| Compile | Model run (fast) | Bit Repro (fast)|
| :-------: | :--------: | :--------: |
| [![Build Status](https://travis-ci.org/mom-ocean/MOM5.svg?branch=master)](https://travis-ci.org/mom-ocean/MOM5) | [![Fast model run](https://accessdev.nci.org.au/jenkins/buildStatus/icon?job=mom-ocean.org/MOM5_run)](https://accessdev.nci.org.au/jenkins/buildStatus/icon?job=mom-ocean.org/MOM5_run) | [![Bit Reproducibility](https://accessdev.nci.org.au/jenkins/buildStatus/icon?job=mom-ocean.org/MOM5_bit_reproducibility)](https://accessdev.nci.org.au/jenkins/buildStatus/icon?job=mom-ocean.org/MOM5_bit_reproducibility) |


# The Modular Ocean Model

MOM is a numerical ocean model based on the hydrostatic primitive equations. Development of the model is managed through this Github site.

Contributions from users and developers are always welcomed. Any questions should be directed to the [mailing list](https://groups.google.com/forum/#!forum/mom-users).

To get started with MOM please consult the [quickstart guide](https://mom-ocean.github.io/docs/quick-start-guide/). More information can be found in the [online documentation](https://mom-ocean.github.io/)

Where to start
~~~~~~~~~~~~~~
A good place to start is the "doc" directory, where you
will find  "user" guides for the MOM.

How to run the MOM tests
~~~~~~~~~~~~~~~~~~~~~~~~~

Read:

https://mom-ocean.github.io/docs/quick-start-guide/


Warning: The Solo and Coupled run scripts have been tested only on 10 and 24, ia64
         processors respectively.
Warning: Some of these tests require a large disk space to save the input data.
         Choose a partition with enough space (1-2 G) to untar the code and data bundels.
Warning: If you want to use the same root directory for all three experiments we suggest to
         compile in the order of increasing complexity: solo -> coupled -> ebm .
         You may have to remove some of the existing .o and .mod files
         if you want to compile ebm experiment after the coupled experiment.
         E.g., you probably have to:   cd ../exec; rm mpp*.o mpp*.mod fms_io*.o fms_io*.mod

Note:    IBM platform users might want to add the following line to the top of the run scripts
             setenv LDR_CNTRL MAXDATA=0xD0000000@DSA


Note:    The compile scripts provide the basic capability to use static memory allocation
         which might be faster on some platforms. In that case you need to adjust the values
         of domain bounds properly according to the number of processors and layout.


Summary of directory contents
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bin/
     -- mkmf script for creating Makefiles
     -- template files for the mkmf script
     -- assorted other scripts

exp/
     -- all MOM experiments (test cases)

src/
     -- source code for all models

src/postprocessing/
    -- source code for postprocessing programs

src/preprocessing/
    -- source code for preprocessing programs

# Flexible Modeling System (FMS)

The Flexible Modeling System (FMS) is a software framework for supporting the 
efficient development, construction, execution, and scientific interpretation
of atmospheric, oceanic, and climate system models.

More information is available on the [GFDL FMS page](http://www.gfdl.noaa.gov/fms).

# Disclaimer

The United States Department of Commerce (DOC) GitHub project code is provided
on an 'as is' basis and the user assumes responsibility for its use. DOC has
relinquished control of the information and no longer has responsibility to
protect the integrity, confidentiality, or availability of the information. Any
claims against the Department of Commerce stemming from the use of its GitHub
project will be governed by all applicable Federal law. Any reference to
specific commercial products, processes, or services by service mark,
trademark, manufacturer, or otherwise, does not constitute or imply their
endorsement, recommendation or favoring by the Department of Commerce. The
Department of Commerce seal and logo, or the seal and logo of a DOC bureau,
shall not be used in any manner to imply endorsement of any commercial product
or activity by DOC or the United States Government.

This project code is made available through GitHub but is managed by NOAA-GFDL
at https://gitlab.gfdl.noaa.gov.

Where to start
~~~~~~~~~~~~~~
A good place to start is the "doc" directory, where you
will find  "user" guides for the MOM.  

Summary of directory contents
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bin/
     -- mkmf script for creating Makefiles
     -- template files for the mkmf script
     -- assorted other scripts

exp/
     -- all MOM experiments (test cases)

src/   
     -- source code for all models

src/postprocessing/
    -- source code for postprocessing programs

src/preprocessing/
    -- source code for preprocessing programs

Drifters
========

$Id$

Alexander.Pletzer@noaa.gov

Overview:
---------

1. What are drifters?

2. The drifters' module

3. What the drifters' module can and cannot do?

4. How to invoke the drifters' module in your code

5. Pre- and post-processing

6. Loose ends

1) What are drifters?
---------------------

Drifters are idealized point particles with positions that evolve in time according 
to a prescribed velocity field, starting from some initial conditions. Drifters have
no mass, no energy, no size, and no friction and therefore have no impact on the 
dynamics of the underlying system. The only feature that distinguishes a drifter
from another is its trajectory. This makes drifters ideal for tracking pollution
clouds and probing fields (e.g. temperature, salinity) along ocean currents. 
Drifters can mimic real experiments such as the Argo floats 
<http://www.metoffice.com/research/ocean/argo/ukfloats.html>.

2) The drifters' module
-----------------------

The drifters' module (drifters_mod) is a fortran module built on top of low level 
kernels. The code was designed to run in parallel within a coupled FMS model.

The general layout is:

Top layer:

drifters.F90: exposes the API

Some low level kernels:

cloud_interpolator.F90: (linear) interpolation of a structured field at random 
positions
drifters_comm.F90: updates positions across processor (PE) domains
drifters_core.F90: handles the mechanics for adding/removing drifters
drifters_input.F90: imports initial positions from a NetCDF file
drifters_io.F90: saves data for postprocessing and restart

3. What the drifters' module can and cannot do?
-----------------------------------------------

The drifters' module will handle all the communication necessary to keep track of 
positions within PE domains. This will involve adding/removing drifters when they 
enter/leave a PE domain. As the number of drifters can vary greatly both between PE 
domains and in the course of a simulation, the drifters' module will also manage 
dynamically the memory for you.

The drifters' code was written to run efficiently by avoiding unnecessary data 
copies. There is no software limit as to the maximum number of drifters and their 
distribution. The drifters' module is ideally suited for long runs where the amount 
of data required to advect particles is large, making it impractical to use a 
postprocessing approach. Such a situation occurs, in particular, when the velocity 
fields must be saved at high sampling rate in order to compute accurately the 
drifters' positions. 

Although a Runge-Kutta method is provided to push drifters, users may want to 
implement their own time-integration scheme in some cases. It is moreover possible to 
combine time integration along some axes while prescribing the evolution in the 
third axis, as would be the case for robotic floats that move up and down in 
predetermined way, for instance. 

There are a number of basic assumptions which could make the drifters' module 
ill-suited for some tasks. First and foremost, it is assumed that the motion of 
drifters is not erratic but follows deterministic trajectories. Furthermore, 
drifters should not cross both compute and data domain boundaries within less 
than a time step. This limitation is imposed by the Runge-Kutta integration 
scheme, which must be able to complete, within a time step, a trajectory 
calculation that starts inside the compute domain. Therefore, the drifters, 
as they are presently modelled, are unlikely to work for very fast objects. 
This constraint also puts a upper limit to the domain decomposition, although
it can often be remedied by increasing the number of ghost nodes.

Another fundamental assumption is that the (e.g. velocity) fields are structured, 
on a per PE domain basis. There is no support for locally nested or unstrucured 
meshes. Meshes need not be smooth and continuous across PE domains, however. 

If the higher level module drifters_mod cannot do what you need, the chances are 
the kernels will be able to. For instance, the upper level assumes, at present, 
two-dimensional (x,y) positions, and a two-dimension domain decomposition. The 
cloud_interpolator kernel on the other hand makes no such assumption; it can be 
used to interpolate structured data in arbitrary number of dimensions and with no 
dependence on FMS code. 


4. How to invoke the drifters' module in your code
--------------------------------------------------

In order to implement drifters in your code, you will need to get access to the 
velocity fields at all times. You will also need to settle on a definition of a 
position, which could be the longitude, latitude, elevation/depth triplet. The 
drifters' code does not care what your choice of position is. Typically, you will 
want, however, to choose positions that are aligned to the velocity axes, and to 
your coordinate system. It is perfectly fine to use a warped coordinate system 
(e.g. tripolar), which avoids the problem of geometric singularity (pole).

Naturally, it is important for the velocity field's units to be consistent with 
both positions and time. Often, some metric coefficients are required for this 
transformation. The drifters' module does not have any support for specific meshes 
per se. Each component of the velocity can sit on different nodes, as in the case
of Arakawa C and D meshes.

You will also need to know what the boundaries of your "compute" and "data" domains are,
when running in parallel. Your compute domain, expressed in terms of xcmin, xcmax,
ycmin and ycmax should densily cover the entire domain; that is 
xcmin[pe_east]  = xcmax[pe]
ycmin[pe_north] = ycmax[pe]
etc.
The data domain should be larger than the compute domain. The larger the velocities 
or the larger the time steps, the more ghost nodes are required. You should also 
pay attention to the fact that *all* components of your velocity need to fall inside
the data domain. If you're using a staggered grid (Arakawa's B, C grids) you should 
reduce the max data domain by dx, resp. dy, in every direction. 

The implementation of drifters involves typically the following steps, which will
be assumed to run on different PEs:

  use drifters_mod
  ...

  ! declare drifters object
  type(drifters_type) :: drfts ! drifters' object

  ! constructor
  call drifters_new(drfts, &
       & input_file ='INPUT/drifters_inp.nc'  , &
       & output_file='drifters_out.nc', &
       & ermesg=ermesg)

  ! set the initial time and dt
  drfts%time = t0
  drfts%dt   = dt
  

  ! set the PE domain boundaries. Xmin_comp/ymin_comp, xmax_comp/ymax_comp
  ! refer to the "compute" domain, which should cover densily the domain:
  ! xcmax[pe] = xcmin[pe_east]
  ! ycmax[pe] = ycmin[pe_north]
  ! Xmin_data/ymin_data, xmax_data/ymax_data refer to the "data" domain, which
  ! should be larger than the compute domain and therefore overlap:
  ! xdmax[pe] > xdmin[pe_east]
  ! ydmax[pe] > ydmin[pe_north]
  ! Particles in the overlap regions are tracked by several PEs. 

  call drifters_set_domain(drfts, &
       & xmin_comp=xcmin, xmax_comp=xcmax, &
       & ymin_comp=ycmin, ymax_comp=ycmax, &
       & xmin_data=xdmin, xmax_data=xdmax, &
       & ymin_data=ydmin, ymax_data=ydmax, &
       & xmin_glob=xmin , xmax_glob=xmax,  & ! this will set periodicity in x 
       & ermesg=ermesg)
  
  ! set neighboring PEs [domain2d is of type(domain2d)]

  call drifters_set_pe_neighbors(drfts, domain=domain2d, ermesg=ermesg)

  ! set the velocities axes. Each velocity can have different axes.

  call drifters_set_v_axes(drfts, component='u', &
       & x=x_u, y=y_u, z=z_u, ermesg=ermesg)

  call drifters_set_v_axes(drfts, component='v', &
       & x=x_v, y=y_v, z=z_v, ermesg=ermesg)
  
  ...

  ! Distribute the drifters across PEs
  call drifters_distribute(drfts, ermesg)

  ! Push the drifters. u_comp, v_comp etc are provided by the host code

  call drifters_push(drfts, u=u_comp, v=v_comp, w=w_comp, ermesg=ermesg)

  do while (Time < Time_end)
  
	! Update the velocities
	....

	! Push the drifters
	call drifters_push(drfts, u=u_comp, v=v_comp, w=w_comp, ermesg=ermesg)

	! check if RK4 integration is complete
	if(drfts%rk4_step==1) then

	     ! interpolate fields

	     call drifters_set_field(drfts, index_field=1, x=x1, y=y1, z=z1, &
	     &    data=temp, ermesg=ermesg)

	     .... ! set other fields here

	     ! save data 

	     call drifters_save(drfts, ermesg=ermesg)
	     
	endif
	
  enddo

  ...
  ! write restart file, optionally with lon/lat data coordinates
  
  call drifters_write_restart(drfts, filename='RESTART/drifters_inp.nc', &
       & x1=x_u, y1=y_v, geolon1=grid%geolonq, &
       & x2=x_u, y2=y_v, geolat2=grid%geolatq, &
       & ermesg=ermesg)  

  
  ! destroy
  
  call drifters_del(drfts, ermesg=ermesg)
  

5. Pre and postprocessing
-------------------------

A typical NetCDF input file contains:

netcdf drifters_inp {
dimensions:
	nd = 2 ; // number of dimensions (2 or 3)
	np = 5 ; // number of particles
variables:
	double positions(np, nd) ;
		positions:names = "i j" ;
		positions:units = "- -" ;
	int ids(np) ;

// global attributes:
		:velocity_names = "u v" ;
		:field_names = "lon lat temp salt" ;
		:field_units = "deg_N deg_E Celsius ppu" ;
		:time_units = "seconds" ;
		:title = "example of input data for drifters" ;
data:

 positions =
  240, 100,
  240, 110,
  240, 120,
  240, 130,
  240, 140 ;

 ids = 1, 2, 3, 4, 5 ; // must range from 1 to np, in any order
}

In this case, the 2-d initial conditions consist of 5 particles at positions 
(240,100), (240, 110), .... Here, the positions are defined as i, j global indices. 
The fields to interpolate are the longitudes, latitudes, temperature and salinity. 

The output files have names <output>.nc.<PE> where PE ranges 0...number of domains-1. 
Each PE writes to an independent NetCDF file. These files contain a history of
positions and field values:

 
netcdf drifters_out.nc {
dimensions:
	it_id = UNLIMITED ; // (10 currently)
	nf = 4 ;
	nd = 2 ;
variables:
	int index_time(it_id) ;
	double time(it_id) ;
	int ids(it_id) ;
	double positions(it_id, nd) ;
		positions:name_1 = "i" ;
		positions:name_2 = "j" ;
		positions:unit_1 = "-" ;
		positions:unit_2 = "-" ;
	double fields(it_id, nf) ;
		fields:name_1 = "lon" ;
		fields:name_2 = "lat" ;
		fields:name_3 = "temp" ;
		fields:name_4 = "salt" ;
		fields:unit_1 = "deg_N" ;
		fields:unit_2 = "deg_E" ;
		fields:unit_3 = "Celsius" ;
		fields:unit_4 = "ppu" ;

// global attributes:
		:time_units = "seconds" ;
data:

 index_time = 0, 0, 1, 1, 2, 2, 3, 3, 4, 4 ;

 time = 17280, 17280, 34560, 34560, 51840, 51840, 69120, 69120, 86400, 86400 ;

 ids = 1, 2, 1, 2, 1, 2, 1, 2, 1, 2 ;

 positions =
  239.992427824695, 99.9982201799336,
  239.992780388996, 110.000731652201,
...
 fields =
  -52.5075721753049, 11.5056520209176, 26.5841099585423, 35.4729937970157,
...
}

A tool, drifters_combine, has been written to combine all the NetCDF files into a 
single file, which contains all the drifters data and is suitable for postprocessing,
including visualization using Ncvtk 1.7 or later. 

6. Loose ends
-------------

* What to do with fields that are outside the valid_range (e.g. on continents in the 
case of floats). Use piecewise linear interpolation or fill with missing values?

* How to make the drifters Mosaic compliant?

* Allow drifters to turn on/off at specific time? A predetermined life cycle?

* Extract initial positions from databases.

* How best to visualize drifters?

--Alex.

Updated to gotm-2012.03.09 on 23Apr2012 by
Martin.Schmidt@io-warnemuende.de
Stephen.Griffies


################## README ################################################

This directory contains files distributed with GOTM (General Ocean
Turbulence Model).  MOM provides interface to this code, yet MOM
developers do not support GOTM.  Hence, MOM users who employ GOTM for
MOM simulations should register with the GOTM user community in order
to keep abreast of GOTM changes that may affect your research.

Note regarding the IBM-compiler xlf:

For compatibility with the definition of variables of type "real" in mom, 
which is transformed to REAL*8 with the compiler flag -qrealsize=8,
the switch __aix is added to cppdefs.h. Please note, that __aix is set
by mkmf. Hence, compiling this code independent from the main mom code is
not recommended. Especially the usage of "double precision" leads
to type mismatch in the FORTRAN90/95 interface between mom and GOTM.

About GOTM

The GOTM package consists of the FORTRAN90 software, a number of idealised and 
realistic test cases, and a scientific documentation, all published under the 
GNU public license. THIS LICENCE REQUIRES THAT ANY CODE USING AN ORIGINAL OR 
MODIFIED VERSION OF GOTM MUST BE MADE PUBLICALLY AVAILABLE WITHOUT ANY 
RESTRICTIONS. The complete package is available from the GOTM homepage at 
www.gotm.net, where also the online-documentation can be found.

If you find a bug in GOTM, please let us know using the bug-list on 
www.gotm.net or by sending an E-mail to gotm-users@gotm.net. If you plan an 
extension to GOTM for your own research project, please contact us via 
gotm-users@gotm.net before you start. It occurred a number of times in the 
past that different groups started working on very similar projects without 
knowing from each other - which would be exactly against the spirit of the 
GOTM project. 

##########################################################################

#
#$Id: README,v 20.0 2013/12/14 00:13:03 fms Exp $
#

Currently, there are three versions of the GOTM documentation with the
names coded as "papertype.filetype". These are:

a4.filetype
letter.filetype
html.filetype

"filetype" can be dvi, ps, or pdf. To produce these files type "make
"papertype_filetype" in this directory. For example, 

"make letter_pdf"

will create the documention in US-letter format, which
can be display with 

"acroread letter.pdf".

Similarly, the files "a4.pdf" and "html.pdf" can be produced, where
"html.pdf" essentially corresponds to the paper version of the 
GOTM web documentation. The web version is produced from the 
latex source code by typing 

"make html_web". 

The html-pages are created by "latex2html" such that your result
depends on the variables you have set in ".latex2html-init" in 
your home directory (or their defaults if you don't have this file). 

To copy the html-pages to the server type "make html_scp". 
This option is available only to those that have the password. 

module ocean_topog_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Matt Harrison 
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S. M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! Set up ocean bottom topography. 
!</OVERVIEW>
!
!<DESCRIPTION>
! Set up ocean bottom topography. Reads information from grid specification file. 
!</DESCRIPTION>
!
!<NAMELIST NAME="ocean_topog_nml">
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging.
!  </DATA> 
!  <DATA NAME="flat_bottom" TYPE="logical">
!  For debugging, it is often useful to over-ride the grid spec file
!  and simply make the domain flat bottom. 
!  </DATA> 
!  <DATA NAME="flat_bottom_kmt" TYPE="integer">
!  Number of depth levels to use for the flat_bottom option.
!  </DATA> 
!  <DATA NAME="flat_bottom_ht" TYPE="real">
!  Depth to make the flat_bottom. 
!  </DATA>
!  <DATA NAME="min_thickness" TYPE="real">
!  min_thickness is only used for Mosaic grid. Since there is no kmt available
!  in mosaic grid, need to set min_thickness to configure kmt based on ht and zw.
!  min_thickness should be set in input namelist (default value -1.0 will cause termination).
!  min_thickness should be much smaller than minimum vertical grid spacing,
!  but for floating point representation reasons min_thickness should be no less than 
!  spacing(max_depth,kind=real32) where max_depth is the maximum depth of the model 
!  and the real32 parameter can be obtained from iso_fortran_env.
!  min_thickness=1.0e-3 metre is usually a good choice.
!  The previous default was 1.0 m; this could be used for consistency when
!  restarting from runs which did not specify a value,
!  but may cause problems: https://github.com/COSIMA/access-om2/issues/161
!  </DATA> 
!  <DATA NAME="kmt_recompute" TYPE="logical">
!  To recompute the kmt array based on min_thickness.  This step is not recommended
!  in general, since it can modify the kmt array which may be in the grid spec file.  
!  But it may be of use for specialized situations, such as when you wish to use 
!  the same topography file with a refined vertical resolution.  
!  </DATA> 
!  <DATA NAME="kmt_recompute_offset" TYPE="integer">
!  To recompute the kmt array based on min_thickness, with an offset
!  determined by kmt_recompute_offset.  Default kmt_recompute_offset=0.
!  </DATA> 
! </NAMELIST>
!
use fms_mod,         only: open_namelist_file, close_file, check_nml_error
use fms_mod,         only: field_exist, read_data, file_exist, write_data
use mpp_domains_mod, only: mpp_update_domains
use mpp_mod,         only: input_nml_file, mpp_error, mpp_min, mpp_pe
use mpp_mod,         only: FATAL, WARNING, NOTE, stdout, stdlog
use axis_utils_mod,  only: nearest_index

use ocean_domains_mod,    only: get_local_indices, get_domain_offsets
use ocean_parameters_mod, only: TERRAIN_FOLLOWING, grav
use ocean_types_mod,      only: ocean_grid_type, ocean_domain_type
use ocean_util_mod,       only: write_chksum_2d, write_chksum_2d_int

implicit none
private

character(len=256) :: version='CVS $Id: ocean_topog.F90,v 20.0 2013/12/14 00:12:35 fms Exp $'
character(len=256) :: tagname='Tag $Name: tikal $'

#include <ocean_memory.h>

! for output
integer :: writeunit=6

logical :: flat_bottom          = .false.
integer :: flat_bottom_kmt      = 50
real    :: flat_bottom_ht       = 5500.0
real    :: min_thickness        = -1.0
integer :: kmt_recompute_offset = 0
logical :: kmt_recompute        = .false.
logical :: write_topog          = .false.
logical :: debug_this_module    = .true.

namelist /ocean_topog_nml/ flat_bottom, flat_bottom_kmt, flat_bottom_ht, write_topog, &
                           min_thickness, kmt_recompute, kmt_recompute_offset,        &
                           debug_this_module

public ocean_topog_init

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_topog_init">
!
! <DESCRIPTION>
! Initialize the ocean bottom topography.
!
! There are two reasons to prefer land be at j=1. 
!
! A/ MOM employs a northest B-grid.  To construct 
! horizontal remapping operators, we need information 
! about grid factors one row outside of the global 
! domain boundaries.  In particular, we need j=0
! grid information. However, when constructing the grid spec
! file, we assume nothing about the region outside 
! the global domain.  So MOM's requirement of j=0
! grid information necessitates extrapolation.  
! This extrapolation is done inside ocean_grids.F90, and
! it can lead to non-symmetric values of grid spacing
! for the region j=0 and j=nj, even if the domain global 
! limits are symmetric across the equator.  
!
! B/ The FMS Sea Ice Simulator (SIS) requires land to be present
! for all points at jsc+joff=1.  If this is not the case, then 
! the ocean model cannot be coupled to SIS.  The SIS requirement 
! of all land at jsc+joff=1 is related to the use of a northeast 
! B-grid convention.  To couple the models, the ocean grid
! must be generated with fill_first_row=.true. 
!
! </DESCRIPTION>
!
subroutine ocean_topog_init (Domain, Grid, grid_file, vert_coordinate_type)

  type(ocean_domain_type), intent(inout)        :: Domain
  type(ocean_grid_type),   intent(inout)        :: Grid
  character(len=*),        intent(in), optional :: grid_file
  integer,                 intent(in)           :: vert_coordinate_type

  character(len=128)  :: ocean_topog = "INPUT/topog.nc"
  character(len=128)  :: grd_file
  logical             :: land_jeq1
  logical             :: error_flag=.false.
  real                :: min_depth, min_depth0, fudge 
  integer             :: imin, jmin, kmin
  integer             :: ioun, io_status, ierr
  integer             :: i, j, ioff, joff
  integer             :: k, kb                        

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  grd_file = "INPUT/grid_spec.nc"
  if(present(grid_file)) grd_file = grid_file

  write( stdlogunit,'(/a/)') trim(version)

  joff=0
  ioff=0
#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk

  allocate (Grid%kmt(isd:ied,jsd:jed))
  allocate (Grid%ht(isd:ied,jsd:jed))
  allocate (Grid%htr(isd:ied,jsd:jed))
  allocate (Grid%kmu(isd:ied,jsd:jed))
  allocate (Grid%hu(isd:ied,jsd:jed))
#else
  call get_domain_offsets(Domain,ioff,joff)
#endif
  

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_topog_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_topog_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_topog_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status, 'ocean_topog_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_topog_nml)  
  write (stdlogunit,ocean_topog_nml)

  Grid%kmt=0;Grid%kmu=0;Grid%ht=0;Grid%hu=0
  if(field_exist(grd_file, 'depth_t') ) then ! new grid file
     call read_data(grd_file, "depth_t", Grid%ht(isc:iec,jsc:jec), Domain%domain2d)
     call read_data(grd_file, "num_levels", Grid%kmt(isc:iec,jsc:jec), Domain%domain2d)
     if(field_exist(grd_file, 'depth_c')) then
        if(.not. field_exist(grd_file, 'num_levels_c')) call mpp_error(FATAL, &
           'ocean_topog_mod: depth_c exist but num_levels_c does not exist in file '//trim(grd_file) )
        call read_data(grd_file, "depth_c", Grid%hu(isc:iec,jsc:jec), Domain%domain2d)
        call read_data(grd_file, "num_levels_c", Grid%kmu(isc:iec,jsc:jec), Domain%domain2d)
     elseif(field_exist(grd_file, 'num_levels_c')) then
        call mpp_error(FATAL, &
           'ocean_topog_mod: num_levels_c exist but depth_c does not exist in file '//trim(grd_file) )
     endif

  elseif(field_exist(grd_file, 'ht') ) then ! old grid file
     call read_data(grd_file, "ht", Grid%ht(isc:iec,jsc:jec), Domain%domain2d)
     call read_data(grd_file, "kmt", Grid%kmt(isc:iec,jsc:jec), Domain%domain2d)

  elseif(file_exist(ocean_topog)) then
    
     if(min_thickness < 0.0) then
        call mpp_error(FATAL, &
           'ocean_topog_mod: min_thickness must be explicitly specified in ocean_topog_nml. '// &
           'min_thickness=1.0e-3 metre is usually a good choice. '// &
           'The previous default was 1.0 m; this could be used for consistency when '// &
           'restarting from runs which did not specify a value, '// &
           'but may cause problems: https://github.com/COSIMA/access-om2/issues/161')
     endif

     call read_data(ocean_topog, 'depth', Grid%ht(isc:iec,jsc:jec), Domain%domain2d)

     !--- calculate kmt based on ht and zw.
     do j=jsc,jec
        do i=isc,iec
           if(Grid%ht(i,j) <= 0.0) then
              Grid%kmt(i,j) = 0
           else
              Grid%kmt(i,j) = nearest_index(Grid%ht(i,j), Grid%zw)
              if( Grid%ht(i,j) >= Grid%zw(Grid%kmt(i,j)) + min_thickness) then 
                 if(Grid%kmt(i,j) < nk) then
                    Grid%kmt(i,j) = Grid%kmt(i,j) + 1
                 endif
              endif
           endif
        enddo
     enddo
  else
     call mpp_error(FATAL, 'ocean_topog_mod: depth_t and ht do not exist in file '//trim(grd_file)// &
                    ', also file '//trim(ocean_topog)//' does not exist')
  endif

  if(kmt_recompute) then 
      call mpp_error(NOTE, 'ocean_topog_mod: recomputing kmt array given ht, zw, and min_thickness.')

      if(min_thickness < 0.0) then
        call mpp_error(FATAL, &
           'ocean_topog_mod: min_thickness must be explicitly specified in ocean_topog_nml. '// &
           'min_thickness=1.0e-3 metre is usually a good choice. '// &
           'The previous default was 1.0 m; this could be used for consistency when '// &
           'restarting from runs which did not specify a value, '// &
           'but may cause problems: https://github.com/COSIMA/access-om2/issues/161')
      endif

      do j=jsc,jec
         do i=isc,iec
            if(Grid%kmt(i,j) > 1) then
                kb = Grid%kmt(i,j)              
                kbloop:          do k=2,kb
                   if( Grid%zw(k) + min_thickness > Grid%ht(i,j) ) then 
                       Grid%kmt(i,j) = k-kmt_recompute_offset
                       if(debug_this_module) then 
                          write(*,'(a,3i6,f12.3,a,3i6,f12.3)') 'kmt_recompute: resetting i,j,kmt_orig,ht= ',&
                          i,j,kb,Grid%ht(i,j),'  to ',  i,j,Grid%kmt(i,j),Grid%ht(i,j)
                       endif 
                       exit kbloop
                   endif
                enddo kbloop
            endif
         enddo
      enddo
  endif

  call mpp_update_domains(Grid%ht, Domain%domain2d)
  call mpp_update_domains(Grid%kmt,Domain%domain2d)

  if(write_topog) then
     call write_data("ocean_grid_check.nc", "ht", Grid%ht(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "kmt", Grid%kmt(isc:iec,jsc:jec), Domain%domain2d)
  end if

  ! ensure there are enough kmt levels for nontrivial vertical processes to be computed 
  error_flag=.false. 
  do j=jsc,jec
     do i=isc,iec
        if(Grid%kmt(i,j)==1) then 
            write(writeunit,'(a,i4,a,i4,a)') &
            '==>ocean_topog_init: WARNING: kmt(',i+Domain%ioff,',',j+Domain%joff, &
            ') = 1 is not permitted. kmt>2 recommended for wet ocean domain.'
            error_flag=.true.
        endif
        if(Grid%kmt(i,j)==2) then 
            write(writeunit,'(a,i4,a,i4,a)') &
            '==>ocean_topog_init: WARNING: kmt(',i+Domain%ioff,',',j+Domain%joff, &
            ') = 2 is generally not permitted. kmt>2 recommended for wet ocean domain.'
            error_flag=.true.
        endif
     enddo
  enddo
  if(error_flag) then 
      call mpp_error(WARNING,&
     '==>ocean_topog_init: Regions with 0 < kmt < 2 have been found. Recommend kmt > 2 for wet ocean regions.')
  endif


  ! for terrain following vertical coordinates, all levels are squeazed into wet regions 
  if(vert_coordinate_type == TERRAIN_FOLLOWING) then
      call mpp_error(NOTE,&
      '==>ocean_topog_init: terrain following coordinate places all nk levels into wet regions.')
      do j=jsd,jed
         do i=isd,ied
            if(Grid%kmt(i,j) > 0) then  
                Grid%kmt(i,j) = nk
            endif
         enddo
      enddo
  endif

  ! ensure that land points have ht = 0.0.
  ! this step may be needed if read ht from land/sea dataset, 
  ! or if ht contains "missing values" from a visualization package. 
  do j=jsd,jed
     do i=isd,ied
        if(Grid%ht(i,j) <= 0.0) Grid%ht(i,j) = 0.0
     enddo
  enddo

  if(flat_bottom) then 
      call mpp_error(NOTE,&
      '==>ocean_topog_init: flat_bottom=.true. so will set all cells that are not land equal to their max depth.')
      do j=jsd,jed
         do i=isd,ied
            if(Grid%kmt(i,j) > 0) then  
               Grid%kmt(i,j) = flat_bottom_kmt
               Grid%ht(i,j)  = flat_bottom_ht
            endif  
         enddo
      enddo
  endif


  ! if num_levels_c exist in the grid file, depths at u-cell points will be get from grid file,
  ! otherwise construct depths at u-cell points as minimum of surrounding t cells
  if(.NOT. field_exist(grd_file, 'num_levels_c')) then
     do j=jsc,jec
        do i=isc,iec
           Grid%kmu(i,j) = min(Grid%kmt(i,j), Grid%kmt(i+1,j), Grid%kmt(i,j+1), Grid%kmt(i+1,j+1))
           Grid%hu(i,j)  = min(Grid%ht(i,j), Grid%ht(i+1,j), Grid%ht(i,j+1), Grid%ht(i+1,j+1))
        enddo
     enddo
  end if
  call mpp_update_domains(Grid%kmu,Domain%domain2d)
  call mpp_update_domains(Grid%hu,Domain%domain2d)

  ! check whether any ocean occupies j=1. 
  if (jsc+joff==1) then
    land_jeq1 = .false. 
    do i=isc,iec
      if(Grid%kmt(i,1) > 0) land_jeq1 = .true. 
    enddo
    if(land_jeq1) then 
      call mpp_error(NOTE,&
      '==>ocean_topog_init: Ocean grid has water at j=1.  Recommend placing land at this latitude row.')
    endif 
  endif 

  ! set inverse depth on t-cells 
  Grid%htr = 0.0 
  do j=jsd,jed
     do i=isd,ied
        if(Grid%kmt(i,j) > 0) then    
            Grid%htr(i,j) = 1.0/Grid%ht(i,j)
        endif
     enddo
  enddo

  ! find shallowest water and provide caveat for overly shallow regions
  imin= 0 ; jmin=0 ; kmin=0 ; min_depth = 1.e10
  do j=jsc,jec
    do i=isc,iec
      if(Grid%kmt(i,j) > 0 .and. Grid%ht(i,j) < min_depth) then 
        imin      = i
        jmin      = j
        kmin      = Grid%kmt(i,j)
        min_depth = Grid%ht(i,j)
      endif 
    enddo
  enddo 
  fudge      = 1 + 1.e-12*mpp_pe() ! to distinguish processors when min_depth is independent of processor
  min_depth  = min_depth*fudge 
  min_depth0 = min_depth
  call mpp_min(min_depth)  

  if(min_depth0 == min_depth) then 
      write(writeunit,'(/a,f12.5)')' The shallowest wet ocean model grid cell has depth (meters) ', min_depth  
      write(writeunit,'(a,i3,a,i3,a,i3,a)')' and this occurs at (i,j,k) = (',&
                      imin+Domain%ioff,',',jmin+Domain%joff ,',',kmin,')'  
      write(writeunit,'(a,f10.4,a,f10.4,a,f12.5,a/)')' which has (long,lat,depth) =  (' &
           ,Grid%xt(imin,jmin),',',Grid%yt(imin,jmin), ',', Grid%ht(imin,jmin),')'
      if(min_depth < 50.0) then 
          write(writeunit,'(a)')' Beware that shallow regions (e.g., those shallower than 50m) may be subject' 
          write(writeunit,'(a)')' to numerical problems if strong surface forcing is not mixed vertically.' 
          write(writeunit,'(a)')' Such problems may occur especially in shallow regions with kmt==2.'
          write(writeunit,'(a)')' Current speeds and/or tracer deviations may become large due to the deposition'
          write(writeunit,'(a)')' of wind and/or buoyancy over just a small upper ocean region. Such problems'
          write(writeunit,'(a)')' can be resolved by adding sufficient vertical mixing in these regions.'
          write(writeunit,'(a)')' Such happens in Nature due to tides and breaking surface waves.'
      endif
  endif

  write(stdoutunit,*) 'Topography checksums' 
  call write_chksum_2d('ht', Grid%ht(COMP))
  call write_chksum_2d('hu', Grid%hu(COMP))
  call write_chksum_2d('htr', Grid%htr(COMP))
  call write_chksum_2d_int('kmu', Grid%kmu(COMP))
  call write_chksum_2d_int('kmt', Grid%kmt(COMP))
  write(stdoutunit,*) ' ' 
  

end subroutine ocean_topog_init
! </SUBROUTINE> NAME="ocean_topog_init"


end module ocean_topog_mod

      module MO_EXP_SOL_MOD

      implicit none

!     save

      private
      public :: exp_slv_init, exp_sol

      integer, parameter ::  inst = 1, avrg = 2

      integer ::  o3s_ndx, o3inert_ndx
      integer ::  oh_ndx, ho2_ndx, c2h4_ndx, c3h6_ndx, isop_ndx, &
                  mvk_ndx, macr_ndx, c10h16_ndx, no2_ndx, n2o5_ndx, &
                  no3_ndx, ox_ndx
      integer ::  jo1d_ndx, ox_l1_ndx, o1d_n2_ndx, o1d_o2_ndx, ox_l2_ndx, &
                  ox_l3_ndx, ox_l4_ndx, ox_l5_ndx, ox_l6_ndx, ox_l7_ndx, &
                  ox_l8_ndx, ox_l9_ndx, usr4_ndx, usr16_ndx, usr17_ndx
      logical ::  o3s_loss
      logical ::  class_hist_prod = .false.
      logical ::  class_hist_loss = .false.

character(len=128), parameter :: version     = '$Id: mo_exp_slv.F90,v 19.0 2012/01/06 20:33:52 fms Exp $'
character(len=128), parameter :: tagname     = '$Name: tikal $'
logical                       :: module_is_initialized = .false.

      CONTAINS

      subroutine exp_slv_init
!-----------------------------------------------------------------------      
!       ... Initialize the explicit solver
!-----------------------------------------------------------------------      

      use CHEM_MODS_MOD,   only : clscnt1, explicit
      use mo_chem_utls_mod, only : get_spc_ndx, get_rxt_ndx

      implicit none

!-----------------------------------------------------------------------      
!       ... Local variables
!-----------------------------------------------------------------------      

      o3s_ndx     = get_spc_ndx( 'O3S' )
      o3inert_ndx = get_spc_ndx( 'O3INERT' )
      ox_ndx = get_spc_ndx( 'OX' )
      oh_ndx = get_spc_ndx( 'OH' )
      ho2_ndx = get_spc_ndx( 'HO2' )
      c2h4_ndx = get_spc_ndx( 'C2H4' )
      c3h6_ndx = get_spc_ndx( 'C3H6' )
      isop_ndx = get_spc_ndx( 'ISOP' )
      mvk_ndx = get_spc_ndx( 'MVK' )
      macr_ndx = get_spc_ndx( 'MACR' )
      c10h16_ndx = get_spc_ndx( 'C10H16' )
      no2_ndx = get_spc_ndx( 'NO2' )
      n2o5_ndx = get_spc_ndx( 'N2O5' )
      no3_ndx = get_spc_ndx( 'NO3' )

      jo1d_ndx = get_rxt_ndx( 'jo1d' )
      ox_l1_ndx = get_rxt_ndx( 'ox_l1' )
      ox_l2_ndx = get_rxt_ndx( 'ox_l2' )
      ox_l3_ndx = get_rxt_ndx( 'ox_l3' )
      ox_l4_ndx = get_rxt_ndx( 'ox_l4' )
      ox_l5_ndx = get_rxt_ndx( 'ox_l5' )
      ox_l6_ndx = get_rxt_ndx( 'ox_l6' )
      ox_l7_ndx = get_rxt_ndx( 'ox_l7' )
      ox_l8_ndx = get_rxt_ndx( 'ox_l8' )
      ox_l9_ndx = get_rxt_ndx( 'ox_l9' )
      o1d_n2_ndx = get_rxt_ndx( 'o1d_n2' )
      o1d_o2_ndx = get_rxt_ndx( 'o1d_o2' )
      usr4_ndx = get_rxt_ndx( 'usr4' )
      usr16_ndx = get_rxt_ndx( 'usr16' )
      usr17_ndx = get_rxt_ndx( 'usr17' )

!-----------------------------------------------------------------------      
!       ... Scan for class production to history file(s)
!-----------------------------------------------------------------------      
!     do file = 1,moz_file_cnt
!        do timetype = inst,avrg
!           if( hfile(file)%histout_cnt(14,timetype) > 0 ) then
!              il = hfile(file)%histout_ind(14,timetype)
!              iu = il + hfile(file)%histout_cnt(14,timetype) - 1
!              if( timetype == inst ) then
!                 if( ANY( hfile(file)%inst_map(il:iu)/1000 == 1 ) ) then
!                    class_hist_prod = .true.
!                    exit
!                 end if
!              else if( timetype == avrg ) then
!                 if( ANY( hfile(file)%timav_map(il:iu)/1000 == 1 ) ) then
!                    class_hist_prod = .true.
!                    exit
!                 end if
!              end if
!           end if
!        end do
!        if( class_hist_prod ) then
!           exit
!        end if
!     end do
!-----------------------------------------------------------------------      
!       ... Scan for class loss to history file(s)
!-----------------------------------------------------------------------      
!     do file = 1,moz_file_cnt
!        do timetype = inst,avrg
!           if( hfile(file)%histout_cnt(15,timetype) > 0 ) then
!              il = hfile(file)%histout_ind(15,timetype)
!              iu = il + hfile(file)%histout_cnt(15,timetype) - 1
!              if( timetype == inst ) then
!                 if( ANY( hfile(file)%inst_map(il:iu)/1000 == 1 ) ) then
!                    class_hist_loss = .true.
!                    exit
!                 end if
!              else if( timetype == avrg ) then
!                 if( ANY( hfile(file)%timav_map(il:iu)/1000 == 1 ) ) then
!                    class_hist_loss = .true.
!                    exit
!                 end if
!              end if
!           end if
!        end do
!        if( class_hist_loss ) then
!           exit
!        end if
!     end do

      end subroutine EXP_SLV_INIT

      subroutine EXP_SOL( base_sol, reaction_rates, &
                          het_rates, extfrc, &
                          nstep, delt, &
                          prod_out, loss_out,&
                          plonl, plnplv )
!-----------------------------------------------------------------------
!       ... Exp_sol advances the volumetric mixing ratio
!           forward one time step via the fully explicit
!           Euler scheme
!           Note : This code has o3inert and o3s as the last
!                  two class members;  neither has production
!                  or loss - some dimensionality below has been
!                  altered to acount for this
!-----------------------------------------------------------------------

      use chem_mods_mod,        only : clscnt1, explicit, extcnt, hetcnt, rxntot
      use MO_INDPRD_MOD,        only : INDPRD
      use MO_EXP_PROD_LOSS_MOD, only : EXP_PROD_LOSS
      use mo_grid_mod,          only : pcnstm1

      implicit none
!-----------------------------------------------------------------------
!       ... Dummy arguments
!-----------------------------------------------------------------------
      integer, intent(in) ::  nstep            ! time step index
      integer, intent(in) ::  plonl            ! lon tile dim
      integer, intent(in) ::  plnplv           ! plonl*plev
      real, intent(in)    ::  delt             ! time step in seconds
      real, intent(in)    ::  reaction_rates(plnplv,max(1,rxntot))
      real, intent(in)    ::  het_rates(plnplv,max(1,hetcnt)), &
                              extfrc(plnplv,max(1,extcnt))
      real, intent(inout) ::  base_sol(plnplv,pcnstm1)
      real, intent(out), optional :: prod_out(plnplv,pcnstm1),loss_out(plnplv,pcnstm1)

!-----------------------------------------------------------------------
!       ... Local variables
!-----------------------------------------------------------------------
      integer  ::  k, l, m
      real, dimension(plnplv,max(1,clscnt1)) :: &
                   prod, &
                   loss, &
                   ind_prd

      if( explicit%indprd_cnt /= 0 ) then
!-----------------------------------------------------------------------      
!        ... Put "independent" production in the forcing
!-----------------------------------------------------------------------      
         call indprd( 1, ind_prd, base_sol, extfrc, reaction_rates )
      else
         do m = 1,max(1,clscnt1)
            ind_prd(:,m) = 0.
         end do
      end if
!-----------------------------------------------------------------------      
!       ... Form F(y)
!-----------------------------------------------------------------------      
      call exp_prod_loss( prod, loss, base_sol, reaction_rates, het_rates )

!-----------------------------------------------------------------------      
!       ... Solve for the mixing ratio at t(n+1)
!-----------------------------------------------------------------------      
      do m = 1,clscnt1
         l             = explicit%clsmap(m)
         if( l /= o3s_ndx .and. l /= o3inert_ndx ) then
         base_sol(:,l) = base_sol(:,l) + delt * (prod(:,m) + ind_prd(:,m) - loss(:,m))
!++van : o3s is assigned in mo_chemdr.F90 so commenting these lines here
!        else if( l == o3s_ndx ) then
!-----------------------------------------------------------------------      
!       ... special code for o3s
! NB: The coefficients for O3S loss from rxn with ISOP, MVK, MACR, and C10H16
!     are unity. For the OX loss rate (in IMP_SOL) they are adjusted (downward)
!     to account for the regeneration of OX by these rxns. But here, we
!     consider this regenerated OX to be "tropospheric."  -- lwh 2/01
!     Also include O3S loss from NO2+OH, N2O5+aerosol, NO3+aerosol
!-----------------------------------------------------------------------      
!           do k = 1,plnplv
!              loss(k,m) = &
!                 reaction_rates(k,jo1d_ndx)*reaction_rates(k,ox_l1_ndx) &
!                 /(reaction_rates(k,o1d_n2_ndx) + reaction_rates(k,o1d_o2_ndx) &
!                   + reaction_rates(k,ox_l1_ndx)) &
!               + reaction_rates(k,ox_l2_ndx)*base_sol(k,oh_ndx) &
!               + reaction_rates(k,ox_l3_ndx)*base_sol(k,ho2_ndx) &
!               + reaction_rates(k,ox_l6_ndx)*base_sol(k,c2h4_ndx) &
!               + reaction_rates(k,ox_l4_ndx)*base_sol(k,c3h6_ndx) &
!               + reaction_rates(k,ox_l5_ndx)*base_sol(k,isop_ndx) &
!               + reaction_rates(k,ox_l7_ndx)*base_sol(k,mvk_ndx) &
!               + reaction_rates(k,ox_l8_ndx)*base_sol(k,macr_ndx) &
!               + reaction_rates(k,ox_l9_ndx)*base_sol(k,c10h16_ndx) &
!               + ((reaction_rates(k,usr4_ndx)*base_sol(k,no2_ndx)*base_sol(k,oh_ndx) &
!                  + 3.*reaction_rates(k,usr16_ndx)*base_sol(k,n2o5_ndx) &
!                  + 2.*reaction_rates(k,usr17_ndx)*base_sol(k,no3_ndx)) &
!                  / max( base_sol(k,ox_ndx), 1.e-20 ))
!              base_sol(k,l) = base_sol(k,l)*exp( -delt*loss(k,m) )
!              loss(k,m) = loss(k,m) * base_sol(k,l)
!           end do
         end if
         if( PRESENT( prod_out ) ) then
            prod_out(:,l) = prod(:,m) + ind_prd(:,m)
         end if
         if( PRESENT( loss_out ) ) then
            loss_out(:,l) = loss(:,m)
         end if
      end do

!-----------------------------------------------------------------------      
!       ... Check for explicit species production and loss output
!           First check instantaneous then time averaged
!-----------------------------------------------------------------------      
!     if( class_hist_prod ) then
!        do file = 1,moz_file_cnt
!           if( hfile(file)%wrhstts .and. hfile(file)%histout_cnt(14,1) > 0 ) then
!              do n = 1,hfile(file)%histout_cnt(14,1)
!                 class = hfile(file)%inst_map(hfile(file)%histout_ind(14,1)+n-1)/1000
!                 if( class == 1 ) then
!                    cls_ndx = mod( hfile(file)%inst_map(hfile(file)%histout_ind(14,1)+n-1),1000 )
!                    fldname = hfile(file)%hist_inst(hfile(file)%histout_ind(14,1)+n-1)
!                    wrk(:)  = (prod(:,cls_ndx) + ind_prd(:,cls_ndx)) * hnm(:)
!                    call outfld( fldname, wrk, plonl, ip, lat, file )
!                 end if
!              end do
!           end if
!           if( hfile(file)%histout_cnt(14,2) > 0 ) then
!              do n = 1,hfile(file)%histout_cnt(14,2)
!                 class = hfile(file)%timav_map(hfile(file)%histout_ind(14,2)+n-1)/1000
!                 if( class == 1 ) then
!                    cls_ndx = mod( hfile(file)%timav_map(hfile(file)%histout_ind(14,2)+n-1),1000 )
!                    fldname = hfile(file)%hist_timav(hfile(file)%histout_ind(14,2)+n-1)
!                    wrk(:) = (prod(:,cls_ndx) + ind_prd(:,cls_ndx)) * hnm(:)
!                    call outfld( fldname, wrk, plonl, ip, lat, file )
!                 end if
!              end do
!           end if
!        end do
!     end if
!     if( class_hist_loss ) then
!        do file = 1,moz_file_cnt
!           if( hfile(file)%wrhstts .and. hfile(file)%histout_cnt(15,1) > 0 ) then
!              do n = 1,hfile(file)%histout_cnt(15,1)
!                 class = hfile(file)%inst_map(hfile(file)%histout_ind(15,1)+n-1)/1000
!                 if( class == 1 ) then
!                    cls_ndx = mod( hfile(file)%inst_map(hfile(file)%histout_ind(15,1)+n-1),1000 )
!                    fldname = hfile(file)%hist_inst(hfile(file)%histout_ind(15,1)+n-1)
!                    l       = explicit%clsmap(cls_ndx)
!                    wrk(:)  = loss(:,cls_ndx) * hnm(:)
!                    call outfld( fldname, wrk, plonl, ip, lat, file )
!                 end if
!              end do
!           end if
!           if( hfile(file)%histout_cnt(15,2) > 0 ) then
!              do n = 1,hfile(file)%histout_cnt(15,2)
!                 class = hfile(file)%timav_map(hfile(file)%histout_ind(15,2)+n-1)/1000
!                 if( class == 1 ) then
!                    cls_ndx = mod( hfile(file)%timav_map(hfile(file)%histout_ind(15,2)+n-1),1000 )
!                    fldname = hfile(file)%hist_timav(hfile(file)%histout_ind(15,2)+n-1)
!                    l       = explicit%clsmap(cls_ndx)
!                    wrk(:)  = loss(:,cls_ndx) * hnm(:)
!                    call outfld( fldname, wrk, plonl, ip, lat, file )
!                 end if
!              end do
!           end if
!        end do
!     end if

      end subroutine EXP_SOL

      end module MO_EXP_SOL_MOD

!FDOC_TAG_GFDL
  MODULE STABLE_BL_TURB_MOD

!=======================================================================
 use           mpp_mod, only: input_nml_file
 use           fms_Mod, ONLY: FILE_EXIST, OPEN_NAMELIST_FILE,          &
                              ERROR_MESG, FATAL, mpp_pe, mpp_root_pe,  &
                              CLOSE_FILE,                              &
                              check_nml_error, write_version_number,   &
                              stdlog
 use  Diag_Manager_Mod, ONLY: register_diag_field, send_data
 use  Time_Manager_Mod, ONLY: time_type
 use     Constants_Mod, ONLY: cp_air, hlv, hls, grav, vonkarm, tfreeze,&
                              rdgas, rvgas, omega
 use Monin_Obukhov_Mod, ONLY: stable_mix

 implicit none
 private
 public :: STABLE_BL_TURB, STABLE_BL_TURB_INIT, STABLE_BL_TURB_END


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  character(len=128) :: version = '$Id: stable_bl_turb.F90,v 19.0 2012/01/06 20:26:08 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'
  logical            :: module_is_initialized = .false.
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!---------------------------------------------------------------------
! --- CONSTANTS
!---------------------------------------------------------------------

  real :: oalsm, oalsh
  real, parameter :: d608 = (rvgas-rdgas)/rdgas
  
!---------------------------------------------------------------------
! --- NAMELIST
!---------------------------------------------------------------------

  real    :: akmax        = 1.e4 ! maximum diffusion coefficient value 
                                 !  (m2/s)
  real    :: alpha        = 0.5
  real    :: alsm         = 150.0
  real    :: alsh         = 150.0
  real    :: fmin         = 5.0e-5
  real    :: hpbl_cap     = 1000.
  real    :: ri_crit      = 0.2
  real    :: diff_min     = 0.001
  real    :: winddifmin   = 0.01
  real    :: small        = 1.e-5
  real    :: b_louis      = 9.4
  real    :: cmstar_louis = 7.4
  real    :: chstar_louis = 5.3
       
  NAMELIST / stable_bl_turb_nml / akmax, alpha, alsm, alsh, fmin, &
                                  hpbl_cap, diff_min, ri_crit

!---------------------------------------------------------------------
! DIAGNOSTICS FIELDS 
!---------------------------------------------------------------------

integer :: id_z_sbl, id_f_sbl

character(len=14) :: mod_name = 'stable_bl_turb'

real :: missing_value = -999.

!---------------------------------------------------------------------
 contains

!#######################################################################

! <SUBROUTINE NAME="STABLE_BL_TURB">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call  STABLE_BL_TURB(is, js, Time, temp, qv,  ql,  qi,  um,  vm,
!                zhalf, zfull, u_star, b_star, lat, 
!                akm, akh, vspblcap, kbot )
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!       Starting integer for longitude window (used for diagnostics)
!  </IN>
!  <IN NAME="js" TYPE="integer">
!       Starting integer for latitude window (used for diagnostics)
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!       Time type variable (for diagnostics)
!  </IN>
!  <IN NAME="temp" TYPE="real">
!       Temperature (K)
!  </IN>
!  <IN NAME="qv" TYPE="real">
!       Water vapor specific humidity (kg/kg)
!  </IN>
!  <IN NAME="ql" TYPE="real">
!       Cloud liquid water specific humidity (kg/kg)
!  </IN>
!  <IN NAME="qi" TYPE="real">
!       Cloud ice water specific humidity (kg/kg)
!  </IN>
!  <IN NAME="um" TYPE="real">
!       Zonal wind velocity (m/s)
!  </IN>
!  <IN NAME="vm" TYPE="real">
!       Meridional wind velocity (m/s)
!  </IN>
!  <IN NAME="zhalf" TYPE="real">
!       Geopotential height of half levels (m)
!  </IN>
!  <IN NAME="zfull" TYPE="real">
!       Geopotential height of full levels (m)
!  </IN>
!  <IN NAME="u_star" TYPE="real">
!       Surface friction velocity (m/s)
!  </IN>
!  <IN NAME="b_star" TYPE="real">
!       Surface buoyancy scale (m/s2)
!  </IN>
!  <IN NAME="lat" TYPE="real">
!       Latitude (radians)
!  </IN>
!  <OUT NAME="akm" TYPE="real">
!       Momentum vertical diffusion coefficient (m2/s)
!  </OUT>
!  <OUT NAME="akh" TYPE="real">
!       Heat/Tracer vertical diffusion coefficient (m2/s)
!  </OUT>
!  <IN NAME="vspblcap" TYPE="real">
!       Cap to height of very stable enhanced PBL mixing, coming
!       from any other module (m)
!
!       In usual application this might be entrain_mod. This is also
!       an optional argument. 
!  </IN>
!  <IN NAME="kbot" TYPE="integer">
!       Integer indicating the lowest level above ground (integer)
!       
!       This optional argument is used only for eta coordinate model.
!  </IN>
! </SUBROUTINE>
!
 subroutine STABLE_BL_TURB( is, js, Time, temp, qv,  ql,  qi,  um,  vm,&
                            zhalf, zfull, u_star, b_star, lat,         &
                            akm, akh, vspblcap, kbot )

!=======================================================================
!---------------------------------------------------------------------
! Arguments (Intent in)
!
!       is, js   -  Starting indices for window
!       Time     -  Time used for diagnostics [time_type]
!       temp     -  temperature (K)
!       qv       -  specific humidity of water vapor (kg/kg)
!       ql       -  specific humidity of cloud liquid (kg/kg)
!       qi       -  specific humidity of cloud ice (kg/kg)
!       um, vm   -  Wind components (m/s)
!       u_star   -  surface friction velocity (m/s)
!       b_star   -  surface buoyancy (m/s2)
!       lat      -  latitude in radians
!       zhalf    -  Height at half levels (m)
!       zfull    -  Height at full levels (m)
!
!      --------------
!      optional input
!      --------------
!
!      vspblcap  cap to height of very stable PBL mixing, coming
!                from any other module (m) (in usual application
!                this might be entrain_mod or edt mod)
!
!      kbot      integer indicating the lowest true layer of atmosphere
!                this is used only for eta coordinate model
!
!---------------------------------------------------------------------
! Arguments (Intent out)
!       akm  -  mixing coefficient for momentum
!       akh  -  mixing coefficient for heat and moisture
!---------------------------------------------------------------------

  type(time_type), intent(in)                    :: Time
  integer,         intent(in)                    :: is, js
  real,            intent(in),  dimension(:,:)   :: u_star, b_star, lat
  real,            intent(in),  dimension(:,:,:) :: temp, qv, ql, qi
  real,            intent(in),  dimension(:,:,:) :: um, vm 
  real,            intent(in),  dimension(:,:,:) :: zhalf,  zfull
  real,            intent(out), dimension(:,:,:) :: akm,    akh

  real,     intent(in),   dimension(:,:), optional :: vspblcap
  integer,  intent(in),   dimension(:,:), optional :: kbot
  
!---------------------------------------------------------------------

  real, dimension(SIZE(um,1),SIZE(um,2),SIZE(um,3)-1) ::             &
        dsdzh, shear, buoync, Ri, Ritmp, fm, fh, lm, lh, xxm1, xxm2, &
        phi, zfunc, cmtmp, chtmp, fmtmp, fhtmp

  real, dimension(SIZE(um,1),SIZE(um,2),SIZE(um,3))  :: mask, hleff
  real, dimension(SIZE(um,1),SIZE(um,2),SIZE(um,3))  :: zfull_ag, slv
  real, dimension(SIZE(um,1),SIZE(um,2),SIZE(um,3)+1):: zhalf_ag

  real, dimension(SIZE(um,1),SIZE(um,2)) ::  zsurf,  &
        fcor, hpbl, z_sbl, f_sbl

  integer :: ix, jx, kx, i, j, k,  kxm
  integer :: shape1(1), shape3(3)
  logical :: used

!=======================================================================
! --- Initalize
!=======================================================================

! --- Check to see if STABLE_BL_TURB has been initialized
  if( .not. module_is_initialized ) CALL ERROR_MESG( ' STABLE_BL_TURB',                          &
       ' STABLE_BL_TURB_INIT has not been called', FATAL)

! --- Zero out output arrays
    akm(:,:,:) = 0.0
    akh(:,:,:) = 0.0
  z_sbl(:,:)   = 0.0
  f_sbl(:,:)   = 0.0
  
! --- Set dimensions etc
  ix  = SIZE( um, 1 )
  jx  = SIZE( um, 2 )
  kx  = SIZE( um, 3 )
  kxm = kx - 1

  shape1 =    ix * jx * kxm
  shape3 = (/ ix,  jx,  kxm /)

!====================================================================
! --- COMPUTE HEIGHT ABOVE SURFACE            
!====================================================================


       mask = 1.0
                   
       if (present(kbot)) then
            do j=1,jx
            do i=1,ix
                 zsurf(i,j) = zhalf(i,j,kbot(i,j)+1)
                 if (kbot(i,j).lt.kx) then
                    do k = kbot(i,j)+1,kx
                       mask(i,j,k) = 0.0
                    enddo
                 end if      
            enddo
            enddo
       else
            zsurf(:,:) = zhalf(:,:,kx+1)
       end if

       do k = 1, kx
            zfull_ag(:,:,k) = zfull(:,:,k) - zsurf(:,:)
            zhalf_ag(:,:,k) = zhalf(:,:,k) - zsurf(:,:)
       end do
       zhalf_ag(:,:,kx+1) = zhalf(:,:,kx+1) - zsurf(:,:)
       
!====================================================================
! --- DYNAMIC HEIGHT - also height relative to the surface     
!====================================================================

  fcor(:,:) = 2.0 * omega * SIN( lat(:,:) )
  fcor(:,:) = ABS( fcor(:,:) )
  fcor(:,:) = MAX( fcor(:,:), fmin )
  hpbl(:,:) = alpha * u_star(:,:) / fcor(:,:)

! --- bound
  hpbl(:,:) = MIN( hpbl(:,:), hpbl_cap )
  
! --- cap from entrainment turbulence
  if (present(vspblcap)) hpbl(:,:) = MIN( hpbl(:,:), vspblcap )
  
! --- height relative to the surface
! --- zfunc = zhalf_ag / hpbl, where stable conditions exist
! ---       = 1.0 for unstable conditions

  zfunc = 1.0
  do k = 1, kxm
      where( b_star(:,:) < 0.0) 
           zfunc(:,:,k) = min(1.,max(0.,zhalf_ag(:,:,k+1)/             &
                                     max(0.1,hpbl(:,:))))
      endwhere
  enddo
    
!====================================================================
! --- COMPUTE LIQUID WATER VIRTUAL STATIC ENERGY             
!====================================================================

   hleff   = (min(1.,max(0.,0.05*(temp   -tfreeze+20.)))*hlv + &
              min(1.,max(0.,0.05*(tfreeze -temp      )))*hls)
     
   slv     = cp_air*temp + grav*zfull_ag - hleff*(ql + qi)
   slv     = slv*(1+d608*(qv+ql+qi))
       
!====================================================================
! --- COMPUTE RICHARDSON NUMBER                 
!====================================================================

! --- D( )/DZ OPERATOR  
  
  dsdzh(:,:,1:kxm) = 1.0 / (zfull_ag(:,:,1:kxm) - zfull_ag(:,:,2:kx))

! --- WIND SHEAR SQUARED

  xxm1(:,:,1:kxm) = dsdzh(:,:,1:kxm)*( um(:,:,1:kxm) - um(:,:,2:kx) )
  xxm2(:,:,1:kxm) = dsdzh(:,:,1:kxm)*( vm(:,:,1:kxm) - vm(:,:,2:kx) )



  shear(:,:,:) = xxm1(:,:,:)*xxm1(:,:,:) + xxm2(:,:,:)*xxm2(:,:,:)

  where (shear .lt. (dsdzh*winddifmin*dsdzh*winddifmin)) 
         shear = dsdzh*winddifmin*dsdzh*winddifmin
  end where         

! --- BUOYANCY 
  xxm1(:,:,1:kxm) =       slv(:,:,1:kxm) - slv(:,:,2:kx) 
  xxm2(:,:,1:kxm) = 0.5*( slv(:,:,1:kxm) + slv(:,:,2:kx) )
 
 
  buoync(:,:,:) = grav * dsdzh(:,:,:) * xxm1(:,:,:) / xxm2(:,:,:)

! --- RICHARDSON NUMBER

  Ri(:,:,:) = buoync(:,:,:) / shear(:,:,:)   

!====================================================================
! --- MASK OUT UNDERGROUND VALUES FOR ETA COORDINATE
!====================================================================

  if( PRESENT( kbot ) ) then
     shear(:,:,1:kxm) =  shear(:,:,1:kxm) * mask(:,:,2:kx) 
    buoync(:,:,1:kxm) = buoync(:,:,1:kxm) * mask(:,:,2:kx) 
        Ri(:,:,1:kxm) =     Ri(:,:,1:kxm) * mask(:,:,2:kx) 
  endif

!====================================================================
! --- MIXING LENGTHS                 
!====================================================================

 do k = 1,kxm
   xxm1(:,:,k) = 1.0 / (vonkarm*zhalf_ag(:,:,k+1))
 end do 

  lm(:,:,:) = 1.0 / ( xxm1(:,:,1:kxm) + oalsm )
  lh(:,:,:) = 1.0 / ( xxm1(:,:,1:kxm) + oalsh )

!====================================================================
! --- STABILITY FUNCTIONS : STABLE SIDE       
!
! Note the very stable form of stability function acquired from 
! monin obukhov is weighted with the traditional stable form
! (phi = 1 + zeta/zeta_crit  or fm = (1 - Ri/Ricrit)**2)
! For Ricrit   = 0.2, phi retains the usual 1 + 5*zeta form.
!
! For heights greater than hpbl, the usual form is used.  For heights
! less than hpbl, the weight of the traditional form is given by
! zfunc which is linear in z/hpbl (see code above).
!====================================================================

  Ritmp = Ri
  where (Ritmp .lt. small) Ritmp = small

  CALL STABLE_MIX( Ritmp, phi)

  phi = (1-zfunc)*phi + zfunc* ((1-min(1.,(Ritmp/ri_crit)))**2.)
  
  fm(:,:,:) = phi(:,:,:)
  fh(:,:,:) =  fm(:,:,:) 
  
!====================================================================
! --- STABILITY FUNCTIONS : UNSTABLE SIDE (Louis 1979)
!
! f = 1.  - b * Ri / (1 + c*sqrt(-Ri))
!
! where b = 9.4 and
!
!              l * l * b * ( (  (1+(dz/z))**(1/3) - 1 )**(3/2))
! c = C_star * --------------------------------------------------
!              sqrt(z) * (dz**3/2)  
!
! where C_star(momentum) = 7.4, and C_star(heat) = 5.3
!     
!====================================================================
 
  Ritmp = Ri
  where (Ri .gt. 0.) Ritmp = 0.  
  
  zfunc(:,:,1:kxm) = 1.+(1./(dsdzh(:,:,1:kxm)*zhalf_ag(:,:,2:(kxm+1))))
  zfunc = zfunc **(1./3.) - 1.
  zfunc = zfunc **1.5
  zfunc = zfunc /  sqrt(zhalf_ag(:,:,2:(kxm+1))) 
  zfunc = zfunc * ( dsdzh(:,:,1:kxm) ** 1.5 )
  
  cmtmp =  cmstar_louis*lm(:,:,:)*lm(:,:,:)*b_louis*zfunc(:,:,:)
  chtmp =  chstar_louis*lh(:,:,:)*lh(:,:,:)*b_louis*zfunc(:,:,:)
  fmtmp(:,:,:) = 1. - (b_louis*Ritmp/(1.+cmtmp*sqrt(-1.*Ritmp)))
  fhtmp(:,:,:) = 1. - (b_louis*Ritmp/(1.+chtmp*sqrt(-1.*Ritmp)))
  
  where (Ri .lt. small)
      fm = fmtmp
      fh = fhtmp
  end where      
 
!====================================================================
! --- MIXING COEFFICENTS                 
!====================================================================

  shear(:,:,:) = SQRT( shear(:,:,:) )

! --- Momentum
  xxm1(:,:,:)    = lm(:,:,:) * lm(:,:,:) * fm(:,:,:)
   akm(:,:,2:kx) = xxm1(:,:,1:kxm) * shear(:,:,1:kxm) 
  where (akm .lt. diff_min) akm = 0.0
  where (akm .gt. akmax) akm = akmax
  
! --- Heat and Moisture
  xxm1(:,:,:)    = lh(:,:,:) * lh(:,:,:) * fh(:,:,:)
   akh(:,:,2:kx) = xxm1(:,:,1:kxm) * shear(:,:,1:kxm)
  where (akh .lt. diff_min) akh = 0.0
  where (akh .gt. akmax) akh = akmax

!====================================================================
! --- Extra diagnostics
!====================================================================

  where( b_star(:,:)  < 0.0 .and. hpbl (:,:) > 0.0 )
          z_sbl(:,:) = hpbl(:,:)
          f_sbl(:,:) = 1.0
  endwhere
  
  if ( id_z_sbl > 0 ) then
     used = send_data ( id_z_sbl, z_sbl, Time, is, js )
  endif
  if ( id_f_sbl > 0 ) then
     used = send_data ( id_f_sbl, f_sbl, Time, is, js )
  endif
  
!=======================================================================
  end subroutine STABLE_BL_TURB

!#######################################################################

! <SUBROUTINE NAME="STABLE_BL_TURB_INIT">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!     Initializes stable_bl_turb_mod: Reads and records namelist, 
!     sets up netcdf output if desired.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call  STABLE_BL_TURB_INIT ( axes, Time )
!
!  </TEMPLATE>
!  <IN NAME=" axes" TYPE="integer">
!   Vector of axes integers
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!   Time variable 
!  </IN>
! </SUBROUTINE>
!
 subroutine STABLE_BL_TURB_INIT ( axes, Time )
!=======================================================================
                   
 integer,         intent(in) :: axes(4)
 type(time_type), intent(in) :: Time

 integer :: unit, io, ierr

!=======================================================================

!---------------------------------------------------------------------
! --- Read namelist
!---------------------------------------------------------------------

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=stable_bl_turb_nml, iostat=io)
  ierr = check_nml_error(io,'stable_bl_turb_nml')
#else   
! -------------------------------------
  if( FILE_EXIST( 'input.nml' ) ) then
   unit = OPEN_NAMELIST_FILE ( file = 'input.nml')
   ierr = 1
   do while( ierr .ne. 0 )
   READ ( unit,  nml = stable_bl_turb_nml, iostat = io, end = 10 ) 
   ierr = check_nml_error (io, 'stable_bl_turb_nml')
   end do
10 continue
   CALL CLOSE_FILE( unit )
! -------------------------------------
  end if
#endif

!---------------------------------------------------------------------
! --- Output version
!---------------------------------------------------------------------

  if ( mpp_pe() == mpp_root_pe() ) then
       call write_version_number(version, tagname)
       unit = stdlog()
       WRITE( unit, nml = stable_bl_turb_nml ) 
  endif

!---------------------------------------------------------------------
! --- CONSTANTS
!---------------------------------------------------------------------

  oalsm = 1.0 / alsm
  oalsh = 1.0 / alsh

!---------------------------------------------------------------------
! --- initialize quantities for diagnostics output
!---------------------------------------------------------------------

   id_z_sbl = register_diag_field ( mod_name, &
     'z_sbl', axes(1:2), Time, &
     'Depth of stable boundary layer',              'm' )

   id_f_sbl = register_diag_field ( mod_name, &
     'f_sbl', axes(1:2), Time, &
     'Frequency of stable boundary layer',          ' ' )

!---------------------------------------------------------------------
 module_is_initialized = .true.
!=======================================================================
 end subroutine STABLE_BL_TURB_INIT

!#######################################################################

! <SUBROUTINE NAME="STABLE_BL_TURB_END">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    Closes down stable_bl_turb.  
!  </DESCRIPTION>
!  <TEMPLATE>
!   call STABLE_BL_TURB_END
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine STABLE_BL_TURB_END

!---------------------------------------------------------------------
 module_is_initialized = .false.
!=======================================================================
 end subroutine STABLE_BL_TURB_END

!#######################################################################
  end MODULE STABLE_BL_TURB_MOD

#include <fms_platform.h>

! -*-F90-*-
! $Id: monin_obukhov_kernel.F90,v 13.0 2006/03/28 21:10:33 fms Exp $

!==============================================================================
! Kernel routine interface
!==============================================================================

module monin_obukhov_inter

! explicit interface to all kernel routines
#include "monin_obukhov_interfaces.h"

end module monin_obukhov_inter

!==============================================================================
! Kernel routines
!==============================================================================

_PURE subroutine monin_obukhov_diff(vonkarm,                &
     & ustar_min,                                     &
     & neutral, stable_option, rich_crit, zeta_trans, &
     & ni, nj, nk, z, u_star, b_star, k_m, k_h, ier)

  implicit none

  real   , intent(in   )                        :: vonkarm
  real   , intent(in   )                        :: ustar_min ! = 1.e-10
  logical, intent(in   )                        :: neutral
  integer, intent(in   )                        :: stable_option
  real   , intent(in   )                        :: rich_crit, zeta_trans
  integer, intent(in   )                        :: ni, nj, nk
  real   , intent(in   ), dimension(ni, nj, nk) :: z
  real   , intent(in   ), dimension(ni, nj)     :: u_star, b_star
  real   , intent(  out), dimension(ni, nj, nk) :: k_m, k_h
  integer, intent(  out)                        :: ier

  real , dimension(ni, nj) :: phi_m, phi_h, zeta, uss
  integer :: j, k

  logical, dimension(ni) :: mask

  interface
     _PURE subroutine monin_obukhov_derivative_t(stable_option, rich_crit, zeta_trans, &
          & n, phi_t, zeta, mask, ier)

       ! the differential similarity function for buoyancy and tracers
       ! Note: seems to be the same as monin_obukhov_derivative_m?

       integer, intent(in   )                :: stable_option
       real   , intent(in   )                :: rich_crit, zeta_trans
       integer, intent(in   )                :: n
       real   , intent(  out), dimension(n)  :: phi_t
       real   , intent(in   ), dimension(n)  :: zeta
       logical, intent(in   ), dimension(n)  :: mask  
       integer, intent(  out)                :: ier
     end subroutine monin_obukhov_derivative_t

     _PURE subroutine monin_obukhov_derivative_m(stable_option, rich_crit, zeta_trans, &
          & n, phi_m, zeta, mask, ier)

       ! the differential similarity function for momentum

       integer, intent(in   )                :: stable_option
       real   , intent(in   )                :: rich_crit, zeta_trans
       integer, intent(in   )                :: n
       real   , intent(  out), dimension(n)  :: phi_m
       real   , intent(in   ), dimension(n)  :: zeta
       logical, intent(in   ), dimension(n)  :: mask
       integer, intent(out  )                :: ier
     end subroutine monin_obukhov_derivative_m
  end interface

  ier = 0

  mask = .true.
  uss = max(u_star, ustar_min)

  if(neutral) then
     do k = 1, size(z,3)
        k_m(:,:,k) = vonkarm *uss*z(:,:,k)
        k_h(:,:,k) = k_m(:,:,k)
     end do
  else
     do k = 1, size(z,3)
        zeta = - vonkarm * b_star*z(:,:,k)/(uss*uss)
        do j = 1, size(z,2)
           call monin_obukhov_derivative_m(stable_option, rich_crit, zeta_trans, &
                & ni, phi_m(:,j), zeta(:,j), mask, ier)
           call monin_obukhov_derivative_t(stable_option, rich_crit, zeta_trans, &
                & ni, phi_h(:,j), zeta(:,j), mask, ier)
        enddo
        k_m(:,:,k) = vonkarm * uss*z(:,:,k)/phi_m
        k_h(:,:,k) = vonkarm * uss*z(:,:,k)/phi_h
     end do
  endif

end subroutine monin_obukhov_diff
!==============================================================================
_PURE subroutine monin_obukhov_drag_1d(grav, vonkarm,               &
     & error, zeta_min, max_iter, small,                         &
     & neutral, stable_option, rich_crit, zeta_trans, drag_min,  &
     & n, pt, pt0, z, z0, zt, zq, speed, drag_m, drag_t,         &
     & drag_q, u_star, b_star, lavail, avail, ier)

  implicit none

  real   , intent(in   )                :: grav     
  real   , intent(in   )                :: vonkarm   
  real   , intent(in   )                :: error    ! = 1.e-04
  real   , intent(in   )                :: zeta_min ! = 1.e-06
  integer, intent(in   )                :: max_iter ! = 20
  real   , intent(in   )                :: small    ! = 1.e-04
  logical, intent(in   )                :: neutral
  integer, intent(in   )                :: stable_option
  real   , intent(in   )                :: rich_crit, zeta_trans, drag_min
  integer, intent(in   )                :: n
  real   , intent(in   ), dimension(n)  :: pt, pt0, z, z0, zt, zq, speed
  real   , intent(inout), dimension(n)  :: drag_m, drag_t, drag_q, u_star, b_star
  logical, intent(in   )                :: lavail ! whether to use provided mask or not
  logical, intent(in   ), dimension(n)  :: avail  ! provided mask 
  integer, intent(out  )                :: ier

  real   , dimension(n) :: rich, fm, ft, fq, zz
  logical, dimension(n) :: mask, mask_1, mask_2
  real   , dimension(n) :: delta_b !!, us, bs, qs
  real                  :: r_crit, sqrt_drag_min
  real                  :: us, bs, qs
  integer               :: i

  interface
     _PURE subroutine monin_obukhov_solve_zeta(error, zeta_min, max_iter, small,  &
          & stable_option, rich_crit, zeta_trans,                           &
          & n, rich, z, z0, zt, zq, f_m, f_t, f_q, mask, ier)

       real   , intent(in   )                :: error    ! = 1.e-04
       real   , intent(in   )                :: zeta_min ! = 1.e-06
       integer, intent(in   )                :: max_iter ! = 20
       real   , intent(in   )                :: small    ! = 1.e-04
       integer, intent(in   )                :: stable_option
       real   , intent(in   )                :: rich_crit, zeta_trans
       integer, intent(in   )                :: n
       real   , intent(in   ), dimension(n)  :: rich, z, z0, zt, zq
       logical, intent(in   ), dimension(n)  :: mask
       real   , intent(  out), dimension(n)  :: f_m, f_t, f_q
       integer, intent(  out)                :: ier
     end subroutine monin_obukhov_solve_zeta
  end interface

  ier = 0
  r_crit = 0.95*rich_crit  ! convergence can get slow if one is 
                           ! close to rich_crit
  sqrt_drag_min = 0.0
  if(drag_min.ne.0.0) sqrt_drag_min = sqrt(drag_min)

  mask = .true.
  if(lavail) mask = avail

  where(mask) 
     delta_b = grav*(pt0 - pt)/pt0
     rich    = - z*delta_b/(speed*speed + small)
     zz      = max(z,z0,zt,zq)
  elsewhere 
     rich = 0.0
  end where

  if(neutral) then

     do i = 1, n
        if(mask(i)) then
           fm(i)   = log(zz(i)/z0(i))
           ft(i)   = log(zz(i)/zt(i))
           fq(i)   = log(zz(i)/zq(i))
           us   = vonkarm/fm(i)
           bs   = vonkarm/ft(i)
           qs   = vonkarm/fq(i)
           drag_m(i)    = us*us
           drag_t(i)    = us*bs
           drag_q(i)    = us*qs
           u_star(i) = us*speed(i)
           b_star(i) = bs*delta_b(i)
        end if
     enddo

  else

     mask_1 = mask .and. rich <  r_crit
     mask_2 = mask .and. rich >= r_crit

     do i = 1, n
        if(mask_2(i)) then
           drag_m(i)   = drag_min
           drag_t(i)   = drag_min
           drag_q(i)   = drag_min
           us       = sqrt_drag_min
           bs       = sqrt_drag_min
           u_star(i)   = us*speed(i)
           b_star(i)   = bs*delta_b(i)
        end if
     enddo

     call monin_obukhov_solve_zeta (error, zeta_min, max_iter, small, &
          & stable_option, rich_crit, zeta_trans,                     &
          & n, rich, zz, z0, zt, zq, fm, ft, fq, mask_1, ier)

     do i = 1, n
        if(mask_1(i)) then
           us   = max(vonkarm/fm(i), sqrt_drag_min)
           bs   = max(vonkarm/ft(i), sqrt_drag_min)
           qs   = max(vonkarm/fq(i), sqrt_drag_min)
           drag_m(i)   = us*us
           drag_t(i)   = us*bs
           drag_q(i)   = us*qs
           u_star(i)   = us*speed(i)
           b_star(i)   = bs*delta_b(i)
        endif
     enddo

  end if

end subroutine monin_obukhov_drag_1d
!==============================================================================
_PURE subroutine monin_obukhov_solve_zeta(error, zeta_min, max_iter, small,  &
     & stable_option, rich_crit, zeta_trans,                           &
     & n, rich, z, z0, zt, zq, f_m, f_t, f_q, mask, ier)

  implicit none

  real   , intent(in   )                :: error    ! = 1.e-04
  real   , intent(in   )                :: zeta_min ! = 1.e-06
  integer, intent(in   )                :: max_iter ! = 20
  real   , intent(in   )                :: small    ! = 1.e-04
  integer, intent(in   )                :: stable_option
  real   , intent(in   )                :: rich_crit, zeta_trans
  integer, intent(in   )                :: n
  real   , intent(in   ), dimension(n)  :: rich, z, z0, zt, zq
  logical, intent(in   ), dimension(n)  :: mask
  real   , intent(  out), dimension(n)  :: f_m, f_t, f_q
  integer, intent(  out)                :: ier


  real    :: max_cor
  integer :: iter

  real, dimension(n) ::   &
       d_rich, rich_1, correction, corr, z_z0, z_zt, z_zq, &
       ln_z_z0, ln_z_zt, ln_z_zq, zeta,                    &
       phi_m, phi_m_0, phi_t, phi_t_0, rzeta,              &
       zeta_0, zeta_t, zeta_q, df_m, df_t

  logical, dimension(n) :: mask_1

  interface
     _PURE subroutine monin_obukhov_derivative_t(stable_option, rich_crit, zeta_trans, &
          & n, phi_t, zeta, mask, ier)

       ! the differential similarity function for buoyancy and tracers
       ! Note: seems to be the same as monin_obukhov_derivative_m?

       integer, intent(in   )                :: stable_option
       real   , intent(in   )                :: rich_crit, zeta_trans
       integer, intent(in   )                :: n
       real   , intent(  out), dimension(n)  :: phi_t
       real   , intent(in   ), dimension(n)  :: zeta
       logical, intent(in   ), dimension(n)  :: mask  
       integer, intent(  out)                :: ier
     end subroutine monin_obukhov_derivative_t
     _PURE subroutine monin_obukhov_derivative_m(stable_option, rich_crit, zeta_trans, &
          & n, phi_m, zeta, mask, ier)

       ! the differential similarity function for momentum

       integer, intent(in   )                :: stable_option
       real   , intent(in   )                :: rich_crit, zeta_trans
       integer, intent(in   )                :: n
       real   , intent(  out), dimension(n)  :: phi_m
       real   , intent(in   ), dimension(n)  :: zeta
       logical, intent(in   ), dimension(n)  :: mask
       integer, intent(out  )                :: ier
     end subroutine monin_obukhov_derivative_m
     _PURE subroutine monin_obukhov_integral_tq(stable_option, rich_crit, zeta_trans, &
          & n, psi_t, psi_q, zeta, zeta_t, zeta_q, &
          & ln_z_zt, ln_z_zq, mask, ier)

       ! the integral similarity function for moisture and tracers

       integer, intent(in   )                :: stable_option
       real,    intent(in   )                :: rich_crit, zeta_trans
       integer, intent(in   )                :: n
       real   , intent(  out), dimension(n)  :: psi_t, psi_q
       real   , intent(in)   , dimension(n)  :: zeta, zeta_t, zeta_q, ln_z_zt, ln_z_zq
       logical, intent(in)   , dimension(n)  :: mask
       integer, intent(  out)                :: ier
     end subroutine monin_obukhov_integral_tq

     _PURE subroutine monin_obukhov_integral_m(stable_option, rich_crit, zeta_trans, &
          & n, psi_m, zeta, zeta_0, ln_z_z0, mask, ier)

       !  the integral similarity function for momentum

       integer, intent(in   )                :: stable_option
       real   , intent(in   )                :: rich_crit, zeta_trans
       integer, intent(in   )                :: n
       real   , intent(  out), dimension(n)  :: psi_m
       real   , intent(in)   , dimension(n)  :: zeta, zeta_0, ln_z_z0
       logical, intent(in)   , dimension(n)  :: mask
       integer, intent(out)                  :: ier
     end subroutine monin_obukhov_integral_m
     
  end interface


  ier = 0

  z_z0 = z/z0
  z_zt = z/zt
  z_zq = z/zq
  ln_z_z0 = log(z_z0)
  ln_z_zt = log(z_zt)
  ln_z_zq = log(z_zq)

  corr = 0.0
  mask_1 = mask

  ! initial guess

  zeta = 0.0
  where(mask_1) 
     zeta = rich*ln_z_z0*ln_z_z0/ln_z_zt
  end where

  where (mask_1 .and. rich >= 0.0)
     zeta = zeta/(1.0 - rich/rich_crit)
  end where

  iter_loop: do iter = 1, max_iter

     where (mask_1 .and. abs(zeta).lt.zeta_min) 
        zeta = 0.0
        f_m = ln_z_z0
        f_t = ln_z_zt
        f_q = ln_z_zq
        mask_1 = .false.  ! don't do any more calculations at these pts
     end where

     
     zeta_0 = 0.0
     zeta_t = 0.0
     zeta_q = 0.0
     where (mask_1)
        rzeta  = 1.0/zeta
        zeta_0 = zeta/z_z0
        zeta_t = zeta/z_zt
        zeta_q = zeta/z_zq
     end where

     call monin_obukhov_derivative_m(stable_option, rich_crit, zeta_trans, &
          & n, phi_m  , zeta  , mask_1, ier)
     call monin_obukhov_derivative_m(stable_option, rich_crit, zeta_trans, &
          & n, phi_m_0, zeta_0,  mask_1, ier)
     call monin_obukhov_derivative_t(stable_option, rich_crit, zeta_trans, &
          & n, phi_t  , zeta  , mask_1, ier)
     call monin_obukhov_derivative_t(stable_option, rich_crit, zeta_trans, &
          & n, phi_t_0, zeta_t, mask_1, ier)

     call monin_obukhov_integral_m(stable_option, rich_crit, zeta_trans, &
          & n, f_m, zeta, zeta_0, ln_z_z0, mask_1, ier)
     call monin_obukhov_integral_tq(stable_option, rich_crit, zeta_trans, &
          & n, f_t, f_q, zeta, zeta_t, zeta_q, ln_z_zt, ln_z_zq, mask_1, ier)

     where (mask_1)
        df_m  = (phi_m - phi_m_0)*rzeta
        df_t  = (phi_t - phi_t_0)*rzeta
        rich_1 = zeta*f_t/(f_m*f_m)
        d_rich = rich_1*( rzeta +  df_t/f_t - 2.0 *df_m/f_m) 
        correction = (rich - rich_1)/d_rich  
        corr = min(abs(correction),abs(correction/zeta)) 
        ! the criterion corr < error seems to work ok, but is a bit arbitrary
        !  when zeta is small the tolerance is reduced
     end where

     max_cor= maxval(corr)

     if(max_cor > error) then
        mask_1 = mask_1 .and. (corr > error)  
        ! change the mask so computation proceeds only on non-converged points
        where(mask_1) 
           zeta = zeta + correction
        end where
        cycle iter_loop
     else
        return
     end if

  end do iter_loop

  ier = 1 ! surface drag iteration did not converge

end subroutine monin_obukhov_solve_zeta
!==============================================================================
_PURE subroutine monin_obukhov_derivative_t(stable_option, rich_crit, zeta_trans, &
     & n, phi_t, zeta, mask, ier)

  ! the differential similarity function for buoyancy and tracers
  ! Note: seems to be the same as monin_obukhov_derivative_m?

  implicit none

  integer, intent(in   )                :: stable_option
  real   , intent(in   )                :: rich_crit, zeta_trans
  integer, intent(in   )                :: n
  real   , intent(  out), dimension(n)  :: phi_t
  real   , intent(in   ), dimension(n)  :: zeta
  logical, intent(in   ), dimension(n)  :: mask  
  integer, intent(  out)                :: ier

  logical, dimension(n) :: stable, unstable
  real                  :: b_stab, lambda

  ier = 0
  b_stab     = 1.0/rich_crit

  stable   = mask .and. zeta >= 0.0
  unstable = mask .and. zeta <  0.0

  where (unstable) 
     phi_t = (1 - 16.0*zeta)**(-0.5)
  end where

  if(stable_option == 1) then 

     where (stable) 
        phi_t = 1.0 + zeta*(5.0 + b_stab*zeta)/(1.0 + zeta)
     end where

  else if(stable_option == 2) then

     lambda = 1.0 + (5.0 - b_stab)*zeta_trans

     where (stable .and. zeta < zeta_trans)
        phi_t = 1 + 5.0*zeta
     end where
     where (stable .and. zeta >= zeta_trans)
        phi_t = lambda + b_stab*zeta
     end where

  endif

end subroutine monin_obukhov_derivative_t
!==============================================================================
_PURE subroutine monin_obukhov_derivative_m(stable_option, rich_crit, zeta_trans, &
     & n, phi_m, zeta, mask, ier)

  ! the differential similarity function for momentum

  implicit none

  integer, intent(in   )                :: stable_option
  real   , intent(in   )                :: rich_crit, zeta_trans
  integer, intent(in   )                :: n
  real   , intent(  out), dimension(n)  :: phi_m
  real   , intent(in   ), dimension(n)  :: zeta
  logical, intent(in   ), dimension(n)  :: mask
  integer, intent(out  )                :: ier

  logical, dimension(n) :: stable, unstable
  real   , dimension(n) :: x
  real                  :: b_stab, lambda


  ier = 0
  b_stab     = 1.0/rich_crit

  stable   = mask .and. zeta >= 0.0
  unstable = mask .and. zeta <  0.0

  where (unstable) 
     x     = (1 - 16.0*zeta  )**(-0.5)
     phi_m = sqrt(x)  ! phi_m = (1 - 16.0*zeta)**(-0.25)
  end where

  if(stable_option == 1) then 

     where (stable) 
        phi_m = 1.0 + zeta  *(5.0 + b_stab*zeta)/(1.0 + zeta)
     end where

  else if(stable_option == 2) then

     lambda = 1.0 + (5.0 - b_stab)*zeta_trans

     where (stable .and. zeta < zeta_trans)
        phi_m = 1 + 5.0*zeta
     end where
     where (stable .and. zeta >= zeta_trans)
        phi_m = lambda + b_stab*zeta
     end where

  endif

end subroutine monin_obukhov_derivative_m
!==============================================================================
_PURE subroutine monin_obukhov_profile_1d(vonkarm, &
     & neutral, stable_option, rich_crit, zeta_trans, &
     & n, zref, zref_t, z, z0, zt, zq, u_star, b_star, q_star, &
     & del_m, del_t, del_q, lavail, avail, ier)

  implicit none

  real   , intent(in   )                :: vonkarm
  logical, intent(in   )                :: neutral
  integer, intent(in   )                :: stable_option
  real   , intent(in   )                :: rich_crit, zeta_trans
  integer, intent(in   )                :: n
  real,    intent(in   )                :: zref, zref_t
  real,    intent(in   ), dimension(n)  :: z, z0, zt, zq, u_star, b_star, q_star
  real,    intent(  out), dimension(n)  :: del_m, del_t, del_q
  logical, intent(in   )                :: lavail ! whether to use provided mask or not
  logical, intent(in   ), dimension(n)  :: avail  ! provided mask
  integer, intent(out  )                :: ier

  real, dimension(n) :: zeta, zeta_0, zeta_t, zeta_q, zeta_ref, zeta_ref_t, &
       ln_z_z0, ln_z_zt, ln_z_zq, ln_z_zref, ln_z_zref_t,  &
       f_m_ref, f_m, f_t_ref, f_t, f_q_ref, f_q,           &
       mo_length_inv

  logical, dimension(n) :: mask

  interface
     _PURE subroutine monin_obukhov_integral_tq(stable_option, rich_crit, zeta_trans, &
          & n, psi_t, psi_q, zeta, zeta_t, zeta_q, &
          & ln_z_zt, ln_z_zq, mask, ier)

       ! the integral similarity function for moisture and tracers

       integer, intent(in   )                :: stable_option
       real,    intent(in   )                :: rich_crit, zeta_trans
       integer, intent(in   )                :: n
       real   , intent(  out), dimension(n)  :: psi_t, psi_q
       real   , intent(in)   , dimension(n)  :: zeta, zeta_t, zeta_q, ln_z_zt, ln_z_zq
       logical, intent(in)   , dimension(n)  :: mask
       integer, intent(  out)                :: ier
     end subroutine monin_obukhov_integral_tq

     _PURE subroutine monin_obukhov_integral_m(stable_option, rich_crit, zeta_trans, &
          & n, psi_m, zeta, zeta_0, ln_z_z0, mask, ier)

       !  the integral similarity function for momentum

       integer, intent(in   )                :: stable_option
       real   , intent(in   )                :: rich_crit, zeta_trans
       integer, intent(in   )                :: n
       real   , intent(  out), dimension(n)  :: psi_m
       real   , intent(in)   , dimension(n)  :: zeta, zeta_0, ln_z_z0
       logical, intent(in)   , dimension(n)  :: mask
       integer, intent(out)                  :: ier
     end subroutine monin_obukhov_integral_m
  end interface

  ier = 0

  mask = .true.
  if(lavail) mask = avail

  del_m = 0.0  ! zero output arrays
  del_t = 0.0
  del_q = 0.0

  where(mask) 
     ln_z_z0     = log(z/z0)
     ln_z_zt     = log(z/zt)
     ln_z_zq     = log(z/zq)
     ln_z_zref   = log(z/zref)
     ln_z_zref_t = log(z/zref_t)
  endwhere

  if(neutral) then

     where(mask)
        del_m = 1.0 - ln_z_zref  /ln_z_z0
        del_t = 1.0 - ln_z_zref_t/ln_z_zt
        del_q = 1.0 - ln_z_zref_t/ln_z_zq
     endwhere

  else

     where(mask .and. u_star > 0.0) 
        mo_length_inv = - vonkarm * b_star/(u_star*u_star)
        zeta       = z     *mo_length_inv
        zeta_0     = z0    *mo_length_inv
        zeta_t     = zt    *mo_length_inv
        zeta_q     = zq    *mo_length_inv
        zeta_ref   = zref  *mo_length_inv
        zeta_ref_t = zref_t*mo_length_inv
     endwhere

     call monin_obukhov_integral_m(stable_option, rich_crit, zeta_trans, &
          & n, f_m,     zeta, zeta_0,   ln_z_z0,   mask, ier)
     call monin_obukhov_integral_m(stable_option, rich_crit, zeta_trans, &
          & n, f_m_ref, zeta, zeta_ref, ln_z_zref, mask, ier)

     call monin_obukhov_integral_tq(stable_option, rich_crit, zeta_trans, &
          & n, f_t, f_q, zeta, zeta_t, zeta_q, ln_z_zt, ln_z_zq, mask, ier)
     call monin_obukhov_integral_tq(stable_option, rich_crit, zeta_trans, &
          & n, f_t_ref, f_q_ref, zeta, zeta_ref_t, zeta_ref_t, ln_z_zref_t, ln_z_zref_t,  mask, ier)

     where(mask)
        del_m = 1.0 - f_m_ref/f_m
        del_t = 1.0 - f_t_ref/f_t
        del_q = 1.0 - f_q_ref/f_q
     endwhere

  end if


end subroutine monin_obukhov_profile_1d
!==============================================================================
_PURE subroutine monin_obukhov_integral_m(stable_option, rich_crit, zeta_trans, &
     & n, psi_m, zeta, zeta_0, ln_z_z0, mask, ier)

  !  the integral similarity function for momentum

  implicit none

  integer, intent(in   )                :: stable_option
  real   , intent(in   )                :: rich_crit, zeta_trans
  integer, intent(in   )                :: n
  real   , intent(  out), dimension(n)  :: psi_m
  real   , intent(in)   , dimension(n)  :: zeta, zeta_0, ln_z_z0
  logical, intent(in)   , dimension(n)  :: mask
  integer, intent(out)                  :: ier

  real                   :: b_stab, lambda

  real, dimension(n) :: x, x_0, x1, x1_0, num, denom, y
  logical, dimension(n) :: stable, unstable, &
       weakly_stable, strongly_stable

  ier = 0

  b_stab     = 1.0/rich_crit

  stable   = mask .and. zeta >= 0.0
  unstable = mask .and. zeta <  0.0

  where(unstable) 

     x     = sqrt(1 - 16.0*zeta)
     x_0   = sqrt(1 - 16.0*zeta_0)

     x      = sqrt(x)
     x_0    = sqrt(x_0)

     x1     = 1.0 + x
     x1_0   = 1.0 + x_0

     num    = x1*x1*(1.0 + x*x)
     denom  = x1_0*x1_0*(1.0 + x_0*x_0)
     y      = atan(x) - atan(x_0)
     psi_m  = ln_z_z0 - log(num/denom) + 2*y

  end where

  if( stable_option == 1) then

     where (stable) 
        psi_m = ln_z_z0 + (5.0 - b_stab)*log((1.0 + zeta)/(1.0 + zeta_0)) &
             + b_stab*(zeta - zeta_0) 
     end where

  else if (stable_option == 2) then

     lambda = 1.0 + (5.0 - b_stab)*zeta_trans

     weakly_stable   = stable .and. zeta <= zeta_trans
     strongly_stable = stable .and. zeta >  zeta_trans

     where (weakly_stable)
        psi_m = ln_z_z0 + 5.0*(zeta - zeta_0) 
     end where

     where(strongly_stable)
        x = (lambda - 1.0)*log(zeta/zeta_trans) + b_stab*(zeta - zeta_trans)
     endwhere

     where (strongly_stable .and. zeta_0 <= zeta_trans)
        psi_m = ln_z_z0 + x + 5.0*(zeta_trans - zeta_0)
     end where
     where (strongly_stable .and. zeta_0 > zeta_trans)
        psi_m = lambda*ln_z_z0 + b_stab*(zeta  - zeta_0)
     endwhere

  end if

end subroutine monin_obukhov_integral_m
!==============================================================================
_PURE subroutine monin_obukhov_integral_tq(stable_option, rich_crit, zeta_trans, &
     & n, psi_t, psi_q, zeta, zeta_t, zeta_q, &
     & ln_z_zt, ln_z_zq, mask, ier)

  ! the integral similarity function for moisture and tracers

  implicit none

  integer, intent(in   )                :: stable_option
  real,    intent(in   )                :: rich_crit, zeta_trans
  integer, intent(in   )                :: n
  real   , intent(  out), dimension(n)  :: psi_t, psi_q
  real   , intent(in)   , dimension(n)  :: zeta, zeta_t, zeta_q, ln_z_zt, ln_z_zq
  logical, intent(in)   , dimension(n)  :: mask
  integer, intent(  out)                :: ier
  
  real, dimension(n)     :: x, x_t, x_q                              
  logical, dimension(n)  :: stable, unstable, &
                                  weakly_stable, strongly_stable
  real                   :: b_stab, lambda

  ier = 0
  
  b_stab     = 1.0/rich_crit

stable   = mask .and. zeta >= 0.0
unstable = mask .and. zeta <  0.0

where(unstable) 

  x     = sqrt(1 - 16.0*zeta)
  x_t   = sqrt(1 - 16.0*zeta_t)
  x_q   = sqrt(1 - 16.0*zeta_q)
  
  psi_t = ln_z_zt - 2.0*log( (1.0 + x)/(1.0 + x_t) )
  psi_q = ln_z_zq - 2.0*log( (1.0 + x)/(1.0 + x_q) )

end where

if( stable_option == 1) then

  where (stable) 
  
    psi_t = ln_z_zt + (5.0 - b_stab)*log((1.0 + zeta)/(1.0 + zeta_t)) &
       + b_stab*(zeta - zeta_t) 
    psi_q = ln_z_zq + (5.0 - b_stab)*log((1.0 + zeta)/(1.0 + zeta_q)) &
       + b_stab*(zeta - zeta_q) 
       
  end where
  
else if (stable_option == 2) then

   lambda = 1.0 + (5.0 - b_stab)*zeta_trans

  weakly_stable   = stable .and. zeta <= zeta_trans
  strongly_stable = stable .and. zeta >  zeta_trans

  where (weakly_stable)
    psi_t = ln_z_zt + 5.0*(zeta - zeta_t) 
    psi_q = ln_z_zq + 5.0*(zeta - zeta_q) 
  end where
  
  where(strongly_stable)
    x = (lambda - 1.0)*log(zeta/zeta_trans) + b_stab*(zeta - zeta_trans)
  endwhere
  
  where (strongly_stable .and. zeta_t <= zeta_trans)
    psi_t = ln_z_zt + x + 5.0*(zeta_trans - zeta_t)
  end where
  where (strongly_stable .and. zeta_t > zeta_trans)
    psi_t = lambda*ln_z_zt + b_stab*(zeta  - zeta_t)
  endwhere
  
  where (strongly_stable .and. zeta_q <= zeta_trans)
    psi_q = ln_z_zq + x + 5.0*(zeta_trans - zeta_q)
  end where
  where (strongly_stable .and. zeta_q > zeta_trans)
    psi_q = lambda*ln_z_zq + b_stab*(zeta  - zeta_q)
  endwhere
  
end if

end subroutine monin_obukhov_integral_tq
!==============================================================================
_PURE subroutine monin_obukhov_stable_mix(stable_option, rich_crit, zeta_trans, &
     &                              n, rich, mix, ier)

  implicit none

  integer, intent(in   )                 :: stable_option
  real   , intent(in   )                 :: rich_crit, zeta_trans
  integer, intent(in   )                 :: n
  real   , intent(in   ), dimension(n)   :: rich
  real   , intent(  out), dimension(n)   :: mix  
  integer, intent(  out)                 :: ier

  real               :: r, a, b, c, zeta, phi
  real               :: b_stab, rich_trans, lambda
  integer            :: i

  ier = 0

mix = 0.0
b_stab     = 1.0/rich_crit
rich_trans = zeta_trans/(1.0 + 5.0*zeta_trans)

if(stable_option == 1) then

     c = - 1.0
     do i = 1, n
        if(rich(i) > 0.0 .and. rich(i) < rich_crit) then
           r = 1.0/rich(i)
           a = r - b_stab
           b = r - (1.0 + 5.0)
           zeta = (-b + sqrt(b*b - 4.0*a*c))/(2.0*a)
           phi = 1.0 + b_stab*zeta + (5.0 - b_stab)*zeta/(1.0 + zeta)
           mix(i) = 1./(phi*phi)
     endif
  end do
  
else if(stable_option == 2) then
 
  lambda = 1.0 + (5.0 - b_stab)*zeta_trans

  where(rich > 0.0 .and. rich <= rich_trans)
    mix = (1.0 - 5.0*rich)**2
  end where
  where(rich > rich_trans .and. rich < rich_crit)
    mix = ((1.0 - b_stab*rich)/lambda)**2
  end where
  
end if

end subroutine monin_obukhov_stable_mix


#ifdef _TEST_MONIN_OBUKHOV
!==============================================================================
! Unit test
!==============================================================================

program test

  use monin_obukhov_inter

  implicit none
  integer, parameter :: i8 = selected_int_kind(18)
  integer(i8)        :: ier_tot, ier

  real    :: grav, vonkarm, error, zeta_min, small, ustar_min
  real    :: zref, zref_t
  integer :: max_iter

  real    :: rich_crit, zeta_trans, drag_min
  logical :: neutral
  integer :: stable_option

  grav          = 9.80
  vonkarm       = 0.4
  error         = 1.0e-4
  zeta_min      = 1.0e-6
  max_iter      = 20
  small         = 1.0e-4
  neutral       = .false.
  stable_option = 1
  rich_crit     =10.0
  zeta_trans    = 0.5
  drag_min      = 1.0e-5
  ustar_min     = 1.e-10
  
  zref   = 10.
  zref_t = 2.
  

  ier_tot = 0
  call test_drag
  print *,'test_drag                    ier = ', ier
  ier_tot = ier_tot + ier

  call test_stable_mix
  print *,'test_stable_mix              ier = ', ier
  ier_tot = ier_tot + ier

  call test_diff
  print *,'test_diff                    ier = ', ier
  ier_tot = ier_tot + ier

  call test_profile
  print *,'test_profile                 ier = ', ier
  ier_tot = ier_tot + ier

  if(ier_tot/=0) then
     print *, ier_tot, '***ERRORS detected***'
  else
     print *,'No error detected.'
  endif

  CONTAINS

    subroutine test_drag

      integer(i8)        :: w

      integer :: i, ier_l
      integer, parameter :: n = 5
      logical :: avail(n), lavail

      real, dimension(n) :: pt, pt0, z, z0, zt, zq, speed, drag_m, drag_t, drag_q, u_star, b_star

      ! potential temperature
      pt     = (/ 268.559120403867, 269.799228886728, 277.443023238556, 295.79192777341, 293.268717243262 /)
      pt0    = (/ 273.42369841804 , 272.551410044203, 278.638168565727, 298.133068766049, 292.898163706587/)
      z      = (/ 29.432779269303, 30.0497139076724, 31.6880000418153, 34.1873479240475, 33.2184943356517/)
      z0     = (/ 5.86144925739178e-05, 0.0001, 0.000641655193293549, 3.23383768877187e-05, 0.07/)
      zt     = (/ 3.69403636275411e-05, 0.0001, 1.01735489109205e-05, 7.63933834969505e-05, 0.00947346982656289/)
      zq     = (/ 5.72575636226887e-05, 0.0001, 5.72575636226887e-05, 5.72575636226887e-05, 5.72575636226887e-05/)
      speed  = (/ 2.9693638452068, 2.43308757772094, 5.69418282305367, 9.5608693754561, 4.35302260074334/)
      lavail = .true.
      avail  = (/.true., .true., .true., .true., .true. /)

      drag_m = 0
      drag_t = 0
      drag_q = 0
      u_star = 0
      b_star = 0

      call monin_obukhov_drag_1d(grav, vonkarm,               &
           & error, zeta_min, max_iter, small,                         &
           & neutral, stable_option, rich_crit, zeta_trans, drag_min,  &
           & n, pt, pt0, z, z0, zt, zq, speed, drag_m, drag_t,         &
           & drag_q, u_star, b_star, lavail, avail, ier_l)

      ! check sum results
      w = 0
      w = w + transfer(sum(drag_m), w)
      w = w + transfer(sum(drag_t), w)
      w = w + transfer(sum(drag_q), w)
      w = w + transfer(sum(u_star), w)
      w = w + transfer(sum(b_star), w)

      ! plug in check sum here>>>
#if defined(__INTEL_COMPILER) || defined(_LF95)
#define CHKSUM_DRAG 4466746452959549648
#endif
#if defined(_PGF95)
#define CHKSUM_DRAG 4466746452959549650
#endif


      print *,'chksum test_drag      : ', w, ' ref ', CHKSUM_DRAG
      ier = CHKSUM_DRAG - w

    end subroutine test_drag

    subroutine test_stable_mix

      integer(i8)        :: w

      integer, parameter      :: n = 5
      real   , dimension(n)   :: rich
      real   , dimension(n)   :: mix
      integer                 :: ier_l


      stable_option = 1
      rich_crit     = 10.0
      zeta_trans    =  0.5

      rich = (/1650.92431853365, 1650.9256285137, 77.7636819036559, 1.92806556391324, 0.414767442012442/)


      call monin_obukhov_stable_mix(stable_option, rich_crit, zeta_trans, &
           &                              n, rich, mix, ier_l)

      w = transfer( sum(mix) , w)

      ! plug in check sum here>>>
#if defined(__INTEL_COMPILER) || defined(_LF95)
#define CHKSUM_STABLE_MIX 4590035772608644256
#endif
#if defined(_PGF95)
#define CHKSUM_STABLE_MIX 4590035772608644258
#endif

      print *,'chksum test_stable_mix: ', w, ' ref ', CHKSUM_STABLE_MIX
      ier = CHKSUM_STABLE_MIX - w

    end subroutine test_stable_mix

    !========================================================================

    subroutine test_diff

      integer(i8)        :: w

      integer, parameter             :: ni=1, nj=1, nk=1
      real   , dimension(ni, nj, nk) :: z
      real   , dimension(ni, nj)     :: u_star, b_star
      real   , dimension(ni, nj, nk) :: k_m, k_h
      integer                        :: ier_l

      z      = 19.9982554527751
      u_star = 0.129638955971075
      b_star = 0.000991799765557209

      call monin_obukhov_diff(vonkarm,                        &
           & ustar_min,                                     &
           & neutral, stable_option, rich_crit, zeta_trans, &
           & ni, nj, nk, z, u_star, b_star, k_m, k_h, ier_l)

      w = 0
      w = w + transfer( sum(k_m) , w)
      w = w + transfer( sum(k_h) , w)

      ! plug check sum in here>>>
#if defined(__INTEL_COMPILER) || defined(_LF95) || defined(_PGF95)
#define CHKSUM_DIFF -9222066590093362639
#endif

      print *,'chksum test_diff      : ', w, ' ref ', CHKSUM_DIFF

      ier = CHKSUM_DIFF - w  

    end subroutine test_diff

    !========================================================================

    subroutine test_profile

      integer(i8)        :: w

      integer, parameter :: n = 5
      integer            :: ier_l

      logical :: avail(n)

      real, dimension(n) :: z, z0, zt, zq, u_star, b_star, q_star
      real, dimension(n) :: del_m, del_t, del_q

      z      = (/ 29.432779269303, 30.0497139076724, 31.6880000418153, 34.1873479240475, 33.2184943356517 /)
      z0     = (/ 5.86144925739178e-05, 0.0001, 0.000641655193293549, 3.23383768877187e-05, 0.07/)
      zt     = (/ 3.69403636275411e-05, 0.0001, 1.01735489109205e-05, 7.63933834969505e-05, 0.00947346982656289/)
      zq     = (/ 5.72575636226887e-05, 0.0001, 5.72575636226887e-05, 5.72575636226887e-05, 5.72575636226887e-05/)
      u_star = (/ 0.109462510724615, 0.0932942802513508, 0.223232887323184, 0.290918439028557, 0.260087579361467/)
      b_star = (/ 0.00690834676781433, 0.00428178089592372, 0.00121229800895103, 0.00262353784027441, -0.000570314880866852/)
      q_star = (/ 0.000110861442197537, 9.44983279664197e-05, 4.17643828631936e-05, 0.000133135421415819, 9.36317815993945e-06/) 

      avail = (/ .true., .true.,.true.,.true.,.true. /)

      call monin_obukhov_profile_1d(vonkarm, &
           & neutral, stable_option, rich_crit, zeta_trans, &
           & n, zref, zref_t, z, z0, zt, zq, u_star, b_star, q_star, &
           & del_m, del_t, del_q, .true., avail, ier_l)

      ! check sum results
      w = 0
      w = w + transfer(sum(del_m), w)
      w = w + transfer(sum(del_t), w)
      w = w + transfer(sum(del_q), w)

      ! plug check sum in here>>>
#if defined(__INTEL_COMPILER) || defined(_LF95) 
#define CHKSUM_PROFILE -4596910845317820786
#endif
#if defined(_PGF95)
#define CHKSUM_PROFILE -4596910845317820785
#endif

      print *,'chksum test_profile   : ', w, ' ref ', CHKSUM_PROFILE

      ier = CHKSUM_PROFILE - w

    end subroutine test_profile


end program test

!==============================================================================

#endif 
! _TEST_MONIN_OBUKHOV

program regrid_3d
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">Bonnie Samuels </CONTACT>
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">Zhi Liang</CONTACT>
  ! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">M.J. Harrison</REVIEWER>
  !
  !<DESCRIPTION>
  ! regrid 3-d lat-lon gridded data to logically rectangular grid
  ! described by grid descriptor file. Applies only to scalar fields
  ! No missing points allowed on input grid.
  !
  !</DESCRIPTION>

  use mpp_mod,          only : mpp_error, mpp_pe,  mpp_npes, mpp_root_pe
  use mpp_mod,          only : FATAL, WARNING, stdout, stdlog, mpp_chksum
  use mpp_io_mod,       only : mpp_open, mpp_close, mpp_read, mpp_write, mpp_write_meta
  use mpp_io_mod,       only : mpp_copy_meta, axistype, fieldtype, atttype
  use mpp_io_mod,       only : mpp_get_atts, mpp_get_info, mpp_get_fields, mpp_get_times
  use mpp_io_mod,       only : mpp_get_axes, mpp_get_axis_data
  use mpp_io_mod,       only : MPP_RDONLY, MPP_NETCDF, MPP_MULTI, MPP_SINGLE, MPP_OVERWR
  use mpp_domains_mod,  only : mpp_update_domains, mpp_define_domains, mpp_global_field
  use mpp_domains_mod,  only : domain2d, mpp_define_layout, mpp_get_compute_domain
  use mpp_domains_mod,  only : mpp_domains_set_stack_size
  use horiz_interp_mod, only : horiz_interp_new, horiz_interp, horiz_interp_end, horiz_interp_type
  use axis_utils_mod,   only : get_axis_cart, interp_1d
  use fms_mod,          only : fms_init, fms_end, open_namelist_file, close_file, file_exist
  use fms_mod,          only : check_nml_error, write_version_number, lowercase
  use constants_mod,    only : constants_init, PI

  implicit none

  integer, parameter :: max_fields       = 10
  integer, parameter :: max_ntimes_saved = 12

  !--- namelist interface
  !<NAMELIST NAME="regrid_3d_nml">
  ! <DATA NAME="src_file" TYPE="character(len=128)" DEFAULT="src_file.nc">
  !  Name of input file containing grid and data to be regridded.
  ! </DATA>
  ! <DATA NAME="numfields"  TYPE="integer" DEFAULT="2">
  !  Number of fields.
  ! </DATA>
  ! <DATA NAME="src_field_name" TYPE="character(len=128), dimension(max_fields)" >
  !  Name of input field(s). default is (/'temp', 'salt'/)
  ! </DATA>
  ! <DATA NAME="dest_field_name" TYPE="character(len=128), dimension(max_fields)" >
  !  Name of output field(s). If it is not specified in the namelist, it will 
  !  get the value from src_field_name
  ! </DATA>
  ! <DATA NAME="dest_grid" TYPE="character(len=128)" DEFAULT="dest_grid.nc">
  !  Name of grid descriptor file containing target grid information.
  ! </DATA>
  ! <DATA NAME="dest_file"  TYPE="character(len=128)" DEFAULT="dest_file.nc">
  !  Name of output file.
  ! </DATA>
  ! <DATA NAME="num_nbrs"  TYPE="integer" DEFAULT="10">
  ! Number of nearest neighbors for regridding  
  ! </DATA>
  ! <DATA NAME="max_dist"  TYPE="integer" DEFAULT="0.17" UNITS="radians">
  !  Maximum radial influence for regridding.
  ! </DATA>
  ! <DATA NAME="scale_factor" TYPE="real ">
  ! scaling factor for data (e.g. -1 to flip sign or 0.01 to convert from centimeters)
  ! </DATA>
  ! <DATA NAME="stop_crit"  TYPE="character(len=1),dimension(2)" DEFAULT="0.001">
  !  The stopping criteria when extrapping data onto missing points.
  ! </DATA>
  ! <DATA NAME="use_source_vertical_grid" TYPE="logical" DEFAULT=".false.">
  !  when use_source_vertical_grid is set to true, the destination data will 
  !  have the same vertical level as the source data. When use_source_vertical_grid 
  !  is false, the vertical grid of destination data will come from dest_grid. 
  !  A linear vertical interpolation will be done when the source vertical is different
  !  from destination vertical grid.
  ! </DATA>
  ! <DATA NAME="apply_mask"  TYPE="logical" DEFAULT="true">
  !  flag to indicate if the land/sea mask of source/destination grid will be applied 
  !  on the output dest_file. When apply_mask is false, the destination data will be 
  !  global data, i.e. no missing value in the destination data file. When apply_mask 
  !  is true, mask will be applied to the destination data. The mask can be either 
  !  source grid or destination grid determined by nml use_source_vertical_grid. 
  !  When use_source_vertical_grid is true, source grid mask will be applied, otherwise
  !  destination grid mask will be applied.
  ! </DATA>
  ! <DATA NAME="interp_method"  TYPE= "character(len=20)" >
  !  specifying the remapping method when remampping data onto current grid.
  !  Its value can be "spherical" or " bilinear". "spherical" interpolation is a 
  !  inverse distance weighted interpolation algorithm. Default value is "bilinear". 
  !  "bilinear" interpolation is recommanded, since bilinear interpolation will provide 
  !  more smooth results than "spherical" interpolation (especially when interpolating 
  !  from coarse grid to fine grid). Plus bilinear interpolation is much more efficiency 
  !  than "spherical interpolation". 
  ! </DATA>
  ! <DATA NAME="ntimes_saved" TYPE= "integer" >
  !  number of time levels to be saved. Its value has to be less than or equal to the number 
  !  of time levels in the source data file.
  ! </DATA>
  ! <DATA NAME="timelevel_saved" TYPE= "integer(max_ntimes_saved)" >
  !  specify the selection of time levels to be saved. The number of elements to be specified 
  !  should be equal to ntimes_saved. 
  ! </DATA>
  ! <DATA NAME="debug" TYPE="logical">
  ! For Debugging. Set true to print out chksum information for debugging reproducing ability 
  ! accross processors. default is false.
  ! </DATA>
  !</NAMELIST>
  character(len=128) :: src_file                          = 'src_file.nc'
  character(len=128) :: dest_grid                         = 'dest_grid.nc'
  character(len=128) :: dest_file                         = 'dest_file.nc'
  integer            :: numfields                         = 2
  character(len=128) :: src_field_name(max_fields)        = ''
  character(len=128) :: dest_field_name(max_fields)       = ''
  real               :: stop_crit(max_fields)             = 0.005 
  integer            :: num_nbrs                          = 5
  real               :: max_dist                          = 0.1
  real               :: scale_factor(max_fields)          = 1.0
  logical            :: use_source_vertical_grid          = .FALSE.
  logical            :: apply_mask                        = .TRUE.
  character(len=32)  :: interp_method                     = "bilinear"
  logical            :: debug                             = .FALSE.
  integer            :: ntimes_saved                      = 0
  integer            :: timelevel_saved(max_ntimes_saved) = 0

  namelist /regrid_3d_nml/ src_file, src_field_name, dest_field_name, numfields, dest_file, &
                           dest_grid, scale_factor, num_nbrs, max_dist, stop_crit,          &
                           interp_method, apply_mask, use_source_vertical_grid, debug,      &
                           ntimes_saved, timelevel_saved

  !---------------------------------------------------------------------
  integer            :: ni_src, nj_src, nk_src, ni_dst, nj_dst, nk_dst, ntime_src
  type(axistype)     :: depth_axis, time_axis, axes_dst(2)
  type(fieldtype)    :: field_lon_dst, field_lat_dst
  type(fieldtype)    :: dest_field(max_fields)
  integer            :: dest_unit, dst_grid_unit         
  logical            :: time_axis_exists = .false.
  real, parameter    :: tol = 1.e-10   ! tolerance for detecting missing values
  real, parameter    :: max_val=1.e20
  real, parameter    :: rel_coef = 0.9
  integer, parameter :: max_iter = 2000
  logical            :: is_cyclic = .true.  ! we suppose the source data is always global data.
  real               :: missing(max_fields)
  real               :: D2R
  type(fieldtype), dimension(:), allocatable :: src_field
  integer                                    :: src_unit
  real, dimension(:),            allocatable :: time_in
  real, dimension(:),            allocatable :: depth_src, depth_dst
  real, dimension(:),            allocatable :: lon_src, lat_src
  real, dimension(:,:),          allocatable :: lon_dst, lat_dst
  real, dimension(:,:,:),        allocatable :: mask_dst
  !--- version information variables
  character(len=128) :: version='CVS $Id: regrid_3d.f90,v 20.0 2013/12/14 00:31:13 fms Exp $'
  character(len=128) :: tagname='Tag $Name: tikal $'

  ! --- Begin of the program

  ! --- call fms_init, which will call mpp_init, mpp_io_init, mpp_domains_init
  call fms_init
  call constants_init

  !--- call regrid_3d initialization routine
  call regrid_3d_init

  !--- read the dest_grid file
  call read_dst_grid

  !--- read src_file
  call read_src_file

  !--- set up metadata of output file
  call setup_meta()

  !--- remap data from src grid to dest grid and write out data to output file
  call process_data()

  call regrid_3d_end

  call fms_end

contains

  !#####################################################################
  ! --- read the namelist and write the version and namelist to logfile. Also
  ! --- write the namelist to standard output
  subroutine regrid_3d_init

    integer :: io_status, unit, ierr, n

    D2R = PI/180.0
    ! --- the default src_field_name is 'temp and 'salt'
    src_field_name(1) = 'temp' 
    src_field_name(2) = 'salt'

    ! --- read namelist ------------------------------------------------
    if(file_exist('input.nml')) then
       unit = open_namelist_file()
       read (unit,regrid_3d_nml,IOSTAT=io_status)
       write (stdout(),'(/)')
       write (stdout(),regrid_3d_nml)  
       ierr = check_nml_error(io_status, 'regrid_3d_nml')
       call close_file(unit)
    else
       call mpp_error(FATAL, 'regrid_3d: file input.nml does not exist' )
    endif

    if(ntimes_saved > 0) then
       if(ntimes_saved > max_ntimes_saved) call mpp_error(FATAL, 'regrid_3d: nml ntimes_saved is greater than ' &
               //'max_ntimes_saved, increase max_ntimes_saved or decrease ntimes_saved')
       do n = 1, ntimes_saved
          if(timelevel_saved(n) .le. 0) call mpp_error(FATAL, 'regrid_3d: nml timelevel_saved is not ' &
              //'specified properly, modify timelevel_saved')
       enddo
    endif

    if(numfields .gt. max_fields) call mpp_error(FATAL, &
             'regrid_3d: numfields should be less than max_fields')
    if (numfields .le. 0) call mpp_error(FATAL,'regrid_3d: No field specified')
    !--- if dest_field_name is not defined in the namelist, get it from src_field_name
    do n = 1, numfields
       if(trim(dest_field_name(n)) == '') dest_field_name(n) = trim(src_field_name(n))
    enddo 
 
    !--- write version information
    call write_version_number(version, tagname)

  end subroutine regrid_3d_init

  !#####################################################################
  !--- open grid file and store grid info
  subroutine read_dst_grid

    integer                                    :: ndim, nvar, natt, ntime, i, j, k
    integer                                    :: len1, siz_in(3)
    logical                                    :: found_xt, found_yt, found_kmt
    character(len=32)                          :: name
    real, allocatable, dimension(:,:)          :: kmt
    type(axistype), allocatable, dimension(:)  :: axes
    type(fieldtype), allocatable, dimension(:) :: fields

    if(.not. file_exist(trim(dest_grid)) ) &
         call mpp_error(FATAL, 'regrid_3d: file '//trim(dest_grid)//' does not exist')

    call mpp_open(dst_grid_unit, trim(dest_grid),&
         action=MPP_RDONLY, form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE)

    call mpp_get_info(dst_grid_unit, ndim, nvar, natt, ntime)

    allocate(fields(nvar), axes(ndim) )
    call mpp_get_axes(dst_grid_unit, axes)
    call mpp_get_fields(dst_grid_unit,fields)

    !--------------------------------------------------------------------
    ! get output grid information
    !--------------------------------------------------------------------
    ni_dst=0; nj_dst=0; nk_dst=0
    do i=1,ndim
       call mpp_get_atts(axes(i),name=name,len=len1)
       select case (trim(name))
       case ('grid_x_T')
          ni_dst = len1
       case ('grid_y_T')
          nj_dst = len1
       case ('zt')
          nk_dst = len1
          allocate(depth_dst(nk_dst))
          call mpp_get_axis_data(axes(i),depth_dst)
          if(.not.use_source_vertical_grid) depth_axis = axes(i)         
       end select
    enddo
    if(ni_dst==0) call mpp_error(FATAL,'regrid_3d: file '//trim(dest_grid)//' does not contain axis grid_x_T')
    if(nj_dst==0) call mpp_error(FATAL,'regrid_3d: file '//trim(dest_grid)//' does not contain axis grid_y_T')
    if(nk_dst==0) call mpp_error(FATAL,'regrid_3d: file '//trim(dest_grid)//' does not contain axis zt')

    allocate(lon_dst(ni_dst,nj_dst), lat_dst(ni_dst,nj_dst), kmt(ni_dst,nj_dst) )
    found_xt = .FALSE.;  found_yt = .FALSE.; found_kmt = .false.
    do i=1,nvar
       call mpp_get_atts(fields(i),name=name,ndim=ndim)
       select case (trim(name))
       case ('x_T')
          found_xt = .true.
          call mpp_read(dst_grid_unit,fields(i),lon_dst)
          field_lon_dst = fields(i)
          call mpp_get_atts(fields(i),axes=axes_dst)
       case ('y_T')
          found_yt = .true.
          call mpp_read(dst_grid_unit,fields(i),lat_dst)
          field_lat_dst = fields(i)           
       case ('num_levels')
          found_kmt = .true.
          call mpp_read(dst_grid_unit,fields(i),kmt )
       end select
    enddo
    if(.not.found_kmt) call mpp_error(FATAL,'regrid_3d: field num_levels is not in the file '//trim(dest_grid) )
    if(.not.found_xt) call mpp_error(FATAL,'regrid_3d: field x_T is not in the file '//trim(dest_grid) )
    if(.not.found_yt) call mpp_error(FATAL,'regrid_3d: field y_T is not in the file '//trim(dest_grid) )

    allocate(mask_dst(ni_dst,nj_dst,nk_dst) )

    do k = 1, nk_dst
       do j = 1, nj_dst
          do i = 1, ni_dst
             if(kmt(i,j) .ge. k) then
                mask_dst(i,j,k) = 1.0
             else
                mask_dst(i,j,k) = 0.0
             endif
          enddo
       enddo
    enddo
    
    deallocate(fields, axes, kmt)    

  end subroutine read_dst_grid

  !#####################################################################
  !--- read source grid informationfrom src_file
  subroutine read_src_file

    integer                                    :: unit, ndim, nvar, natt, n
    integer                                    :: nt, i, j, k, jj, len1
    logical                                    :: found_src_field(numfields)
    character(len=1)                           :: cart
    character(len=32)                          :: name, units
    type(axistype), allocatable, dimension(:)  :: axes
    type(fieldtype), allocatable, dimension(:) :: fields
    real                                       :: scale, add

    if(.not. file_exist(trim(src_file)) ) &
         call mpp_error(FATAL, 'regrid_3d: file '//trim(src_file)//' does not exist')

    call mpp_open(src_unit, trim(src_file),&
         action=MPP_RDONLY, form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE)
    call mpp_get_info(src_unit, ndim, nvar, natt, ntime_src)

    allocate(fields(nvar))
    call mpp_get_fields(src_unit, fields)
    allocate(src_field(numfields))
    found_src_field = .FALSE.
    do n=1,numfields
       do i=1,nvar
          call mpp_get_atts(fields(i),name=name)
          if (lowercase(trim(src_field_name(n))) == lowercase(trim(name))) then
             src_field(n) = fields(i)
             found_src_field(n) = .TRUE.
             write(stdout(),*) 'Interpolating src field : ',trim(name), ' grid ', trim(dest_grid)
          endif
       end do
    enddo
    do n=1,numfields 
       if(.not. found_src_field(n)) call mpp_error(FATAL, 'regrid_3d: field '&
            //trim(src_field_name(n))//' is not in the file '//trim(src_file) )
    enddo
    !--- get the src grid
    call mpp_get_atts(src_field(1),ndim=ndim)
    allocate(axes(ndim))
    call mpp_get_atts(src_field(1),axes=axes)
    ni_src=0; nj_src=0; nk_src=0; ntime_src = 1
    do j=1,ndim
       call mpp_get_atts(axes(j),len=len1,units=units)
       call get_axis_cart(axes(j),cart)
       select case (cart)
       case ('X')
          ni_src = len1
          allocate(lon_src(ni_src))
          call mpp_get_axis_data(axes(j),lon_src)
       case('Y')
          nj_src = len1
          allocate(lat_src(nj_src))
          call mpp_get_axis_data(axes(j),lat_src)
       case('Z')
          nk_src = len1
          allocate(depth_src(nk_src))
          if(use_source_vertical_grid) depth_axis = axes(j)
          call mpp_get_axis_data(axes(j),depth_src)
          if (trim(units) == 'cm') then
             depth_src(:) = depth_src(:)*.01
          endif
       case ('T')
          ntime_src = len1
          time_axis_exists = .true.
          allocate(time_in(ntime_src))
          call mpp_get_times(src_unit, time_in)
          time_axis = axes(j)
       end select
    enddo
    if(ni_src==0) call mpp_error(FATAL,'regrid_3d: file ' &
         //trim(src_file)//' does not contain axis with cartesian attributes = "X" ')
    if(nj_src==0) call mpp_error(FATAL,'regrid_3d: file '&
         //trim(src_file)//' does not contain axis with cartesian attributes = "Y" ')
    if(nk_src==0) call mpp_error(FATAL,'regrid_3d: file '&
         //trim(src_file)//' does not contain axis with cartesian attributes = "Z" ')
    !--- if use selective time level, make sure the time level selection is suitable.
    if(ntimes_saved > ntime_src) call mpp_error(FATAL, 'regrid_3d: nml ntime_src is greater than ' &
             //'number of time levels in the file '// trim(src_file) )
    do n = 1, ntimes_saved
       if(timelevel_saved(n) > ntime_src) call mpp_error(FATAL, 'regrid_3d: some entry in nml timelevel_saved ' &
             // 'is greater than number of time levels in the file '// trim(src_file) )
    enddo

    !--- get the missing value
    do n=1, numfields
       call mpp_get_atts(src_field(n),missing=missing(n),scale=scale, add=add )
       if(scale .NE. 1 .OR. add .NE. 0) missing(n) = missing(n)*scale + add
    enddo

    deallocate(fields, axes)    

  end subroutine read_src_file

  !#####################################################################
  !--- setup metadata of output file
  subroutine setup_meta

    integer            :: i, j, n, nt
    character(len=32)  :: units
    character(len=128) :: longname
    !--------------------------------------------------------------------
    ! write output file metadata
    !--------------------------------------------------------------------

    call mpp_open(dest_unit, trim(dest_file),MPP_OVERWR,MPP_NETCDF,threading=MPP_SINGLE,&
         fileset=MPP_SINGLE)
    !
    ! write axis metadata
    !
    do i=1,size(axes_dst(:))
       call mpp_copy_meta(dest_unit,axes_dst(i))
    end do

    call mpp_copy_meta(dest_unit,depth_axis)

    if (time_axis_exists) then
       call mpp_copy_meta(dest_unit, time_axis)
    endif

    !
    ! write variable metadata
    !
    call mpp_copy_meta(dest_unit,field_lon_dst,axes=axes_dst)
    call mpp_copy_meta(dest_unit,field_lat_dst,axes=axes_dst)

    do n = 1, numfields
       call mpp_get_atts(src_field(n),units=units,longname=longname)
       if (time_axis_exists) then 
          call mpp_write_meta(dest_unit, dest_field(n), (/axes_dst(1),axes_dst(2), depth_axis,time_axis/), &
               trim(dest_field_name(n)), units,longname, missing=missing(n), pack=1)
       else
          call mpp_write_meta(dest_unit, dest_field(n), (/axes_dst(1),axes_dst(2), depth_axis/), &
               trim(dest_field_name(n)), units,longname, missing=missing(n), pack=1)
       endif
    enddo
    ! write axis data

    do i=1,size(axes_dst(:))
       call mpp_write(dest_unit,axes_dst(i))
    end do

    call mpp_write(dest_unit,depth_axis)

    ! write variable data

    call mpp_write(dest_unit, field_lon_dst,lon_dst)
    call mpp_write(dest_unit, field_lat_dst,lat_dst)

  end subroutine setup_meta


  !#####################################################################
  !--- remap data from src grid to destination grid.
  subroutine process_data

    integer                             :: ndivs, i, j, k, n, nt, stat, ntimelevel, l
    integer                             :: isc, iec, jsc, jec, layout(2) = (/1,0/)
    integer                             :: kstart, kend
    real                                :: tmp_x, tmp_y
    type(domain2d)                      :: Domain
    type(horiz_interp_type)             :: Interp
    real, dimension(:,:,:), allocatable :: tmp1, tmp2, tmp, mask_src, data_dst, data_src
    real, dimension(:,:,:), allocatable :: depth_src_3d, depth_dst_3d

    !--- decompose model grid points
    !--- mapping can get expensive so we distribute the task at this level
    ndivs = mpp_npes()
    call mpp_define_layout ((/1,ni_dst,1,nj_dst/), ndivs, layout)
    call mpp_define_domains((/1,ni_dst,1,nj_dst/),layout, Domain,xhalo=0,yhalo=0)  
    call mpp_get_compute_domain (Domain, isc, iec, jsc, jec)

    call horiz_interp_new(Interp, lon_src*D2R, lat_src*D2R, lon_dst(isc:iec,jsc:jec)*D2R, &
         lat_dst(isc:iec,jsc:jec)*D2R, interp_method = trim(interp_method),                &
         num_nbrs = num_nbrs, max_dist=max_dist, grid_at_center = .true. )

    allocate(tmp1(ni_src,nj_src, nk_src))
    allocate(data_src(ni_src,nj_src, nk_src))
    if( use_source_vertical_grid) then 
       allocate(data_dst(ni_dst,nj_dst,nk_src), tmp(isc:iec,jsc:jec, nk_src) )
       call mpp_domains_set_stack_size(2*ni_dst*nj_dst*nk_src)
    else
       call mpp_domains_set_stack_size(2*ni_dst*nj_dst*nk_dst)
       allocate(tmp2(isc:iec,jsc:jec, nk_src) )
       allocate(data_dst(ni_dst,nj_dst,nk_dst), tmp(isc:iec,jsc:jec, nk_dst) )
       allocate(depth_src_3d(isc:iec,jsc:jec, nk_src))
       allocate(depth_dst_3d(isc:iec,jsc:jec,nk_dst))
       do k=1,nk_src
          depth_src_3d(:,:,k) = depth_src(k)
       enddo
       do k=1,nk_dst
          depth_dst_3d(:,:,k) = depth_dst(k)
       enddo
    endif


    if(ntimes_saved > 0) then
       ntimelevel = ntimes_saved       
    else
       ntimelevel = ntime_src
    endif

    write(stdout(),*)' There are ', ntimelevel, ' time steps to be saved to output file.'

    ! for vertical interpolation, Set value of levels shallower than the shallowest source level to 
    ! be the source value at shallowest level. 
    ! Set value of levels deeper than the deepest source level to 
    ! be the source value at deepest level. 

    if( .not. use_source_vertical_grid) then 
       do kstart = 1, nk_dst
          if( depth_dst(kstart) .GE. depth_src(1) ) exit 
       enddo
       do kend = nk_dst, 1, -1
          if( depth_dst(kend) .LE. depth_src(nk_src) ) exit 
       enddo
       if( kstart > 1 ) then
          write(stdout(),*)"NOTE from regrid_3d: the value from level 1 to level ", kstart-1, &
                 " will be set to the value at the shallowest source levle."
       endif
       if( kend < nk_dst ) then
          write(stdout(),*)"NOTE from regrid_3d: the value from level ", kend+1, " to level ", nk_dst, &
                 " will be set to the value at the deepest source levle."
       endif
    endif

    do l = 1, ntimelevel 
       if(ntimes_saved > 0) then
          nt = timelevel_saved(l)
       else
          nt = l
       endif
       write(stdout(),*)'**************At time step ', l       
       do n = 1, numfields
          !--- read source data
          call mpp_read(src_unit,src_field(n),data_src,nt)
          if( n==1 .and. nt == 1) then
             allocate(mask_src(ni_src,nj_src,nk_src))
             mask_src = 1.0
             do k = 1, nk_src
                do j = 1, nj_src
                   do i = 1, ni_src
                      if (abs(data_src(i,j,k) - missing(1)) <= tol) mask_src(i,j,k) = 0.
                      if (abs(data_src(i,j,k)) > max_val) mask_src(i,j,k) = 0.0
                   enddo
                enddo
             enddo
          endif
          !--- if scale_factor is not 1, multiple scale_factor to each data
          if(scale_factor(n) .ne. 1) then
             do k =1, nk_src
                do j =1, nj_src
                   do i =1, ni_src
                      if(mask_src(i,j,k) >0.5) data_src(i,j,k) = data_src(i,j,k)*scale_factor(n)
                   enddo
                enddo
             enddo
          endif

          !--- begin to regrid data
          if( use_source_vertical_grid) then 
             if(apply_mask) then
                do k = 1, nk_src
                   call horiz_interp(Interp, data_src(:,:,k), tmp(:,:,k),  &
                        mask_in = mask_src(:,:,k), missing_value=missing(n) )
                enddo
             else
                if(any(mask_src == 0.0) ) then ! do laplace extrap if needed.
                   call extrap(data_src(:,:,:), tmp1(:,:,:), stop_crit(n), &
                      missing(n)*scale_factor(n), is_cyclic ) 
                   do k = 1, nk_src 
                      call horiz_interp(Interp, tmp1(:,:,k), tmp(:,:,k))
                   enddo
                else
                   do k = 1, nk_src
                      call horiz_interp(Interp, data_src(:,:,k), tmp(:,:,k) )
                   enddo
                endif
             endif
          else
             if(any(mask_src == 0.0) ) then ! do laplace extrap if needed.
                call extrap(data_src(:,:,:), tmp1(:,:,:), stop_crit(n), &
                      missing(n)*scale_factor(n), is_cyclic ) 
                do k = 1, nk_src
                   call horiz_interp(Interp, tmp1(:,:,k), tmp2(:,:,k) )
                enddo
             else
                do k = 1, nk_src
                   call horiz_interp(Interp, data_src(:,:,k), tmp2(:,:,k) )
                enddo
             endif
             
             do k = 1, kstart-1
                tmp(:,:,k) = tmp2(:,:,1)
             enddo
                
             do k = kend+1, nk_dst
                tmp(:,:,k) = tmp2(:,:,nk_dst)
             enddo

             call interp_1d(depth_src_3d,depth_dst_3d(:,:,kstart:kend),tmp2,tmp(:,:,kstart:kend))

             do k = 1, nk_dst
                if(apply_mask) then
                   do j = jsc, jec
                      do i = isc, iec
                         if(mask_dst(i,j,k) < 0.5) tmp(i,j,k) = missing(n)
                      enddo
                   enddo
                endif
             enddo
          endif

          !--- get global data
          call mpp_global_field(Domain,tmp, data_dst(:,:,:) )
          if(mpp_pe()==mpp_root_pe()) then  ! --- write out data from root pe
             if (time_axis_exists) then 
                call mpp_write(dest_unit, dest_field(n), data_dst,time_in(nt))
             else
                call mpp_write(dest_unit, dest_field(n), data_dst)  
             endif

             if(debug) then            !--- the chksum is for debugging purpose

                write(stdout(),*)'NOTE: At time level ',nt,', Chksum for ',trim(src_field_name(n)), &
                     ' after-regrid data ', mpp_chksum(data_dst, (/mpp_root_pe()/) )
             endif
          endif
       enddo
    enddo

    if(allocated(tmp)) deallocate(tmp)
    if(allocated(tmp1)) deallocate(tmp1)
    if(allocated(data_src)) deallocate(data_src)
    if(allocated(data_dst)) deallocate(data_dst)
    if(allocated(mask_src)) deallocate(mask_src)
    if(allocated(tmp2)) deallocate(tmp2)
    if(allocated(depth_src_3d)) deallocate(depth_src_3d)
    if(allocated(depth_dst_3d)) deallocate(depth_dst_3d)

    !--- write out chksum for parallel checking

    call mpp_close(dst_grid_unit)
    call mpp_close(dest_unit)
    call mpp_close(src_unit)
    call horiz_interp_end

  end subroutine process_data

  !#####################################################################
  !--- release the memory
  subroutine regrid_3d_end

  deallocate(depth_src, depth_dst, lon_src, lat_src, lon_dst, lat_dst, mask_dst)
  if(time_axis_exists) deallocate(time_in)

  end subroutine regrid_3d_end


  !#####################################################################
  subroutine extrap(data_in, data_out, crit, missing_value, is_cyclic )
    real, dimension(:,:,:),  intent(in) :: data_in
    real, dimension(:,:,:), intent(out) :: data_out
    real,                    intent(in) :: crit, missing_value 
    logical,                 intent(in) :: is_cyclic 
    real                                :: resmax, initial_guess = 0.0
    integer                             :: ni, nj, nk, i, j, k, n

    real, dimension(0:size(data_in,1)+1, 0:size(data_in,2)+1) :: tmp
    real, dimension(size(data_in,1), size(data_in,2) )        :: sor, res

    real, dimension(size(data_in,1), size(data_in,2) )        :: cfn, cfs, cfe, cfw, cfc
    real                                                      :: latp, latm, cstr, csm, csj
    real, dimension(size(data_in,1))                          :: dxu, dxt
    real, dimension(size(data_in,2))                          :: dyu, dyt

    ni = size(data_in,1)
    nj = size(data_in,2)
    nk = size(data_in,3)

    ! construct grid factors for a sphere
    do j=1,nj-1
      dyu(j) = lat_src(j+1)-lat_src(j)
    enddo
    dyu(nj) = dyu(nj-1)
    do j=2,nj
      dyt(j) = 0.5*(dyu(j)+dyu(j-1))
    enddo
    dyt(1) = dyt(2)
    do i=1,ni-1
      dxu(i) = lon_src(i+1)-lon_src(i)
    enddo
    dxu(ni) = dxu(ni-1)
    do i=2,ni
      dxt(i) = 0.5*(dxu(i)+dxu(i-1))
    enddo
    dxt(1) = dxt(2)
    do j= 1, nj
      if (j == nj) then
        latp = lat_src(j) + 0.5*(lat_src(j) - lat_src(j-1))
      else
        latp = 0.5*(lat_src(j) + lat_src(j+1))
      endif
      if (j == 1) then
        latm = lat_src(j) - 0.5*(lat_src(j+1) - lat_src(j))
      else
        latm = 0.5*(lat_src(j) + lat_src(j-1))
      endif
      csj  = cos(latp*pi/180.0)
      csm  = cos(latm*pi/180.0)
      cstr = 1.0/cos(lat_src(j)*pi/180.)       
      do i= 1,ni
        cfn(i,j) = csj*cstr/(dyt(j)*dyu(j))
        cfs(i,j) = csm*cstr/(dyt(j)*dyu(max(j-1,1)))
        cfe(i,j) = cstr**2/(dxu(i)*dxt(i))
        cfw(i,j) = cstr**2/(dxu(max(i-1,1))*dxt(i))
        cfc(i,j) = 1.0/(cfn(i,j)+cfs(i,j)+cfe(i,j)+cfw(i,j))
        cfn(i,j) = cfn(i,j)*cfc(i,j)
        cfs(i,j) = cfs(i,j)*cfc(i,j)
        cfe(i,j) = cfe(i,j)*cfc(i,j)
        cfw(i,j) = cfw(i,j)*cfc(i,j)         
      enddo
    enddo

    tmp = 0.0
    do j= 1, nj
       do i= 1, ni
          if(abs(data_in(i,j,1) - missing_value) <= tol) then
             tmp(i,j) = initial_guess
          endif
       enddo
    enddo

    do k = 1, nk
       do j= 1, nj
          do i= 1, ni
             if(abs(data_in(i,j,k) - missing_value) <= tol ) then
                sor(i,j) = rel_coef
             else
                tmp(i,j) = data_in(i,j,k)
                sor(i,j) = 0.0
             endif
          enddo
       enddo

       call fill_boundaries(tmp, is_cyclic)

       ! iterate
       n=1
       do            
          resmax=0.0
          do j= 1, nj
             do i= 1, ni
                res(i,j) = cfw(i,j)*tmp(i-1,j) + cfe(i,j)*tmp(i+1,j) + cfs(i,j)*tmp(i,j-1) + cfn(i,j)*tmp(i,j+1) - tmp(i,j)
             enddo
          enddo

          do j= 1, nj
             do i= 1, ni
                res(i,j) = res(i,j)*sor(i,j)
                tmp(i,j)=tmp(i,j)+res(i,j)
                resmax = max(abs(res(i,j)),resmax)
             enddo
          enddo

          if(resmax .le. crit .or. n > max_iter) then
             data_out(:,:,k) = tmp(1:ni,1:nj)
             exit
          endif

          !--- update boundaries

          call fill_boundaries(tmp, is_cyclic)

          n=n+1

       enddo

       if(mpp_pe() == mpp_root_pe() ) write(stdout(),'(a,i6,a)') 'Stopped after ',n,' iterations'
       if(mpp_pe() == mpp_root_pe() ) write(stdout(),'(a,f10.4)') 'maxres= ',resmax
    enddo

  end subroutine extrap

  !#####################################################################


  subroutine fill_boundaries(data, is_cyclic)

    real, dimension(0:,0:), intent(inout) :: data
    logical,                   intent(in) :: is_cyclic
    integer :: i,j, ni, nj

    ni = size(data,1) - 2
    nj = size(data,2) - 2

    if(is_cyclic) then
       data(0,1:nj) = data(ni,1:nj)
       data(ni+1,1:nj) = data(1,1:nj)
    endif

    return

  end subroutine fill_boundaries

  !#####################################################################

end program regrid_3d

module ocean_nphysicsC_mod
#define COMP isc:iec,jsc:jec
#define COMPXL isc-1:iec,jsc:jec
#define COMPYL isc:iec,jsc-1:jec
#define COMPXLYL isc-1:iec,jsc-1:jec
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<REVIEWER EMAIL="tim.leslie@gmail.com"> Tim Leslie
!</REVIEWER>
!  
!<OVERVIEW>
! Thickness weighted and density weighted time tendency for tracer 
! from Laplacian neutral diffusion + Laplacian skew-diffusion.
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes the cell thickness weighted and density 
! weighted tracer tendency from small angle Laplacian neutral diffusion
! plus Laplacian skew-diffusion.  The algorithms for neutral diffusion
! are based on mom4p0d methods.  The algorithm for neutral skewsion 
! are based on a projection onto a few of the lowest baroclinic 
! modes. This module is experimental, and should be used with caution. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies, A. Gnanadesikan, R.C. Pacanowski, V. Larichev, 
! J.K. Dukowicz,  and R.D. Smith
! Isoneutral diffusion in a z-coordinate ocean model
! Journal of Physical Oceanography (1998) vol 28 pages 805-830
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies 
! The Gent-McWilliams Skew-flux 
! Journal of Physical Oceanography (1998) vol 28 pages 831-841
! </REFERENCE>
!
! <REFERENCE>
! R. Ferrari, S.M. Griffies, A.J.G. Nurser, and G.K. Vallis  
! A boundary value problem for the parameterized mesoscale eddy transport
! Ocean Modelling, Volume 32, 2010, Pages 143-156.
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies 
! Fundamentals of Ocean Climate Models (2004)
! Princeton University Press 
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies: Elements of MOM (2012)
! </REFERENCE>
!
! <REFERENCE>
! D.B. Chelton,  R.A. deSzoeke, M.G. Schlax, K.E. Naggar, N. Siwertz
! Geographical Variability of the First Baroclinic Rossby Radius of Deformation
! Journal of Physical Oceanography (1998) vol 28 pages 433-460 
! </REFERENCE>
!
! <REFERENCE>
! G. Danabasoglu and J. C. McWilliams
! Sensitivity of the global ocean circulation to 
! parameterizations of mesoscale tracer transports
! Journal of Climate (1995) vol 8 pages 2967--2987 
! </REFERENCE>
!
! <REFERENCE>
! Gerdes, Koberle, and Willebrand
! The influence of numerical advection schemes on the results of ocean
! general circulation models, Climate Dynamics (1991), vol. 5, 
! pages 211--226. 
! </REFERENCE>
!
! <NOTE>
! Numerical implementation of the flux components follows the triad 
! approach documented in the references and implemented in MOM2 and MOM3.  
! The MOM algorithm accounts for partial bottom cells and generalized
! orthogonal horizontal coordinates and general vertical levels.  
! </NOTE> 
!
! <NOTE> 
! In steep neutral slope regions, neutral diffusive fluxes are tapered
! to zero with the tanh taper of Danabasoglu and McWilliams (1995) or the 
! quadratic scheme of Gerdes, Koberle, and Willebrand.  
!
! Traditional tapering is not required for the skew fluxes computed in 
! this module.  
! </NOTE> 
!
! </INFO>
!
!<NAMELIST NAME="ocean_nphysicsC_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For printing starting and ending checksums for restarts
!  </DATA> 
!
!  <DATA NAME="epsln_bv_freq" UNITS="kg/m4" TYPE="real">
!  Minimum buoyancy frequency accepted for the computation of 
!  baroclinic modes. Default epsln_bv_freq=1e-10.  Note there 
!  is also a minimum drhodz set in ocean_density.F90 via the
!  nml epsln_drhodz in that module.  We provide yet another minimum
!  here in case we need an extra regularization for the amplitude
!  of the baroclinic modes.  
!  </DATA>
!
!  <DATA NAME="do_neutral_diffusion" TYPE="logical">
!  To compute tendency from neutral diffusion.
!  Default do_neutral_diffusion=.true. 
!  </DATA> 
!  <DATA NAME="do_gm_skewsion" TYPE="logical">
!  To compute tendency from GM skewsion. Default do_gm_skewsion=.true. 
!  </DATA> 
!  <DATA NAME="gm_skewsion_modes" TYPE="logical">
!  To compute tendency from GM skewsion using streamfunction established
!  by baroclinic modes. Default gm_skewsion_modes=.false.
!  </DATA> 
!  <DATA NAME="gm_skewsion_bvproblem" TYPE="logical">
!  To compute tendency from GM skewsion using streamfunction established
!  by a boundary value problem. Default gm_skewsion_bvproblem=.true.
!  </DATA> 
!
!  <DATA NAME="number_bc_modes" TYPE="integer">
!  The number of baroclinic modes used to construct the eddy induced 
!  streamfunction. Default number_bc_modes=1.
!  </DATA> 
!  <DATA NAME="bvp_bc_mode" TYPE="integer">
!  The particular baroclinic mode used to construct the BVP streamfunction.
!  If bvp_bc_mode=0, then will set bc_speed=0 when computing the BVP streamfunction.
!  Default bvp_bc_mode=1.  
!  </DATA> 
!  <DATA NAME="bvp_constant_speed" TYPE="logical">
!  For taking a constant speed to be used for the calculation 
!  of the BVP streamfunction. Default bvp_constant_speed=.false.  
!  </DATA> 
!  <DATA NAME="bvp_speed" UNITS="m/s" TYPE="real">
!  For setting the speed weighting the second order derivative operator 
!  in the BVP streamfunction method: 
!  c^2 = max[bvp_min_speed, (bvp_speed-c_mode)^2].
!  If bvp_constant_speed, then  c^2 = bvp_speed^2. 
!  Default bvp_speed=0.0, in which case c^2 = c_mode^2.  
!  </DATA> 
!  <DATA NAME="bvp_min_speed" UNITS="m/s" TYPE="real">
!  For setting a minimum speed for use with the calculation 
!  of the BVP streamfunction. We need  bvp_min_speed>0 to ensure
!  that the second order derivative operator contributes to the 
!  calculation of the streamfunction.  
!  Default bvp_min_speed=0.1.  
!  </DATA> 
! 
!  <DATA NAME="bv_freq_smooth_vert" TYPE="logical">
!  To smooth the buoyancy frequency for use in 
!  computing the baroclinic modes. Generally this field has already 
!  been smooted in ocean_density_mod, but we maintain the possibility of 
!  further smoothing here.  Default bv_freq_smooth_vert=.false.
!  </DATA>
!  <DATA NAME="num_121_passes" TYPE="integer">
!  The number of 121 passes used to smooth buoyancy frequency when 
!  bv_freq_smooth_vert=.true.  Default num_121_passes=1.
!  </DATA>
!  <DATA NAME="min_bc_speed"  UNITS="m/s"  TYPE="real">
!  The minimum speed used for computing the baroclinic modes. 
!  Default min_bc_speed=1e-6
!  </DATA> 
!
!  <DATA NAME="smooth_bc_modes" TYPE="logical">
!  For doing a vertical 1-2-1 smoothing on the baroclinic modes
!  prior to normalization.  This is useful to reduce noise.
!  Default smooth_bc_modes=.false.
!  </DATA> 
!
!  <DATA NAME="smooth_psi" TYPE="logical">
!  For doing a horizontal 1-2-1 smoothing on the psix and psiy fields. 
!  This is useful to reduce noise. Default smooth_psi=.true.
!  </DATA> 
!
!  <DATA NAME="regularize_psi" TYPE="logical">
!  To reduce the magnitude of psi in regions of weak stratification, 
!  using the slope = smax_psi to set the overall scale of the max allowed
!  for psi. Default regularize_psi=.true.
!  </DATA> 
!  <DATA NAME="smax_modes" TYPE="real">
!  Maximum slope used for setting the overall scale of a modal 
!  contribution to the parameterized transport.   
!  Default smax_psi=0.1.  
!  </DATA> 
! 
!  <DATA NAME="diffusion_all_explicit" TYPE="logical">
!  To compute all contributions from neutral diffusion explicitly in time, including
!  the K33 diagonal piece.  This approach is available only when have small time 
!  steps and/or running with just a single tracer.  It is for testing purposes. 
!  </DATA> 
!
!  <DATA NAME="neutral_physics_limit" TYPE="logical">
!  When tracer falls outside a specified range, revert to horizontal 
!  diffusive fluxes at this cell. This is an ad hoc and incomplete attempt
!  to maintain monotonicity with the neutral physics scheme.  
!  Default neutral_physics_limit=.true.
!  </DATA> 
!  <DATA NAME="tmask_neutral_on" TYPE="logical">
!  If .true. then this logical reduces the neutral diffusive fluxes to 
!  horizontal/vertical diffusion next to boundaries.  
!  This approach has been found to reduce spurious 
!  extrema resulting from truncation of triads used to compute 
!  a neutral flux component.   
!  Default tmask_neutral_on=.false.
!  </DATA> 
!
!  <DATA NAME="dm_taper" TYPE="logical">
!  Set to true to use the tanh tapering scheme of Danabasoglu and McWilliams.
!  Default is true. 
!  </DATA> 
!  <DATA NAME="gkw_taper" TYPE="logical">
!  Set to true to use the quadradic tapering scheme of Gerdes, Koberle, and Willebrand.
!  Default is false. 
!  </DATA> 
!
!  <DATA NAME="neutral_eddy_depth" TYPE="logical">
!  Compute eddy_depth according to depth over which eddies feel the ocean surface.
!  Default neutral_eddy_depth=.true. 
!  </DATA> 
!
!  <DATA NAME="turb_blayer_min" TYPE="real">
!  Minimum depth of a surface turbulent boundary layer
!  used in the transition of the neutral diffusion fluxes
!  to the surface.  Note that in mom4p0, 
!  turb_blayer_min was always set to zero. 
!  </DATA> 
!
!  <DATA NAME="use_neutral_slopes_potrho" TYPE="logical">
!  To compute the neutral slopes based on globally referenced potential 
!  density rather than locally referenced potential density. This approach
!  is meant solely for sensitivity studies; it is not meant for realistic 
!  simulations.  
!  Default use_neutral_slopes_potrho=.false. 
!  </DATA> 
!  <DATA NAME="neutral_slopes_potrho_press" UNITS="dbar" TYPE="real">
!  The reference pressure used to compute neutral slopes when setting
!  use_neutral_slopes_potrho=.true. 
!  Default neutral_slopes_potrho_press=2000.0
!  </DATA> 
!
!  <DATA NAME="smooth_advect_transport" TYPE="logical">
!  For doing a horizontal 1-2-1 smoothing on the diagnosed  
!  uhrho_et_gm and vhrho_nt_gm fields.  
!  Default smooth_advect_transport=.true.
!  </DATA> 
!  <DATA NAME="smooth_advect_transport_num" TYPE="integer">
!  Number of iterations for the smooothing of horizontal transport. 
!  Default smooth_advect_transport_num=2.
!  </DATA> 
!
!</NAMELIST>

use constants_mod,           only: epsln, pi
use diag_manager_mod,        only: register_diag_field, register_static_field, need_data, send_data
use fms_mod,                 only: FATAL, WARNING, NOTE
use fms_mod,                 only: open_namelist_file, check_nml_error, close_file, write_version_number
use fms_io_mod,              only: string 
use mpp_domains_mod,         only: mpp_update_domains
use mpp_domains_mod,         only: CGRID_NE, WUPDATE, SUPDATE, EUPDATE, NUPDATE
use mpp_domains_mod,         only: cyclic_global_domain, global_data_domain 
use mpp_mod,                 only: input_nml_file, mpp_error, stdout, stdlog
use mpp_mod,                 only: mpp_clock_id, mpp_clock_begin, mpp_clock_end, CLOCK_ROUTINE
use time_manager_mod,        only: set_time, time_type, increment_time, operator ( + )

use ocean_density_mod,       only: density_derivs 
use ocean_domains_mod,       only: get_local_indices, set_ocean_domain
use ocean_nphysics_util_mod, only: ocean_nphysics_coeff_init, ocean_nphysics_coeff_end
use ocean_nphysics_util_mod, only: neutral_slopes, tracer_derivs 
use ocean_nphysics_util_mod, only: compute_eady_rate, compute_baroclinicity
use ocean_nphysics_util_mod, only: compute_rossby_radius, compute_bczone_radius
use ocean_nphysics_util_mod, only: compute_diffusivity, ocean_nphysics_util_restart
use ocean_nphysics_util_mod, only: transport_on_nrho_gm, transport_on_rho_gm, transport_on_theta_gm
use ocean_nphysics_util_mod, only: cabbeling_thermob_tendency
use ocean_nphysics_util_mod, only: compute_eta_tend_gm90
use ocean_nphysics_util_mod, only: watermass_diag_init, watermass_diag_ndiffuse, watermass_diag_sdiffuse
use ocean_operators_mod,     only: FAX, FAY, FMX, FMY, BDX_ET, BDY_NT
use ocean_parameters_mod,    only: missing_value, onehalf, onefourth, oneeigth, DEPTH_BASED
use ocean_parameters_mod,    only: rho0r, rho0, grav
use ocean_tracer_diag_mod,   only: diagnose_eta_tend_3dflux 
use ocean_types_mod,         only: ocean_grid_type, ocean_domain_type, ocean_density_type
use ocean_types_mod,         only: ocean_prog_tracer_type, ocean_thickness_type
use ocean_types_mod,         only: ocean_time_type, ocean_time_steps_type
use ocean_types_mod,         only: tracer_2d_type, tracer_3d_0_nk_type, tracer_3d_1_nk_type 
use ocean_util_mod,          only: write_note, write_line, write_warning
use ocean_util_mod,          only: diagnose_2d, diagnose_3d
use ocean_tracer_util_mod,   only: diagnose_3d_rho
use ocean_workspace_mod,     only: wrk1_2d, wrk1_v2d, wrk2_v2d
use ocean_workspace_mod,     only: wrk1, wrk2, wrk3, wrk4
use ocean_workspace_mod,     only: wrk1_v, wrk2_v, wrk3_v, wrk4_v

use ocean_pik_diag_mod,      only: ocean_pik_diag_init_ty_trans_gm, do_pik_diag

implicit none

public ocean_nphysicsC_init
public ocean_nphysicsC_end
public nphysicsC
public ocean_nphysicsC_restart

private fx_flux_ndiffuse
private fy_flux_ndiffuse
private fz_flux_ndiffuse
private fx_flux_gm
private fy_flux_gm
private fz_flux_gm
private fz_terms
private neutral_blayer
private compute_ndiffusion
private compute_gmskewsion
private compute_advect_transport 
private baroclinic_modes 
private compute_psi_modes 
private compute_psi_bvp
private invtri_bvp


private 

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_domain_type), save    :: Dom_flux

integer :: num_prog_tracers = 0

! clock ids
integer :: id_clock_ndiffuse
integer :: id_clock_gm
integer :: id_clock_neutral_blayer
integer :: id_clock_fz_terms 
integer :: id_clock_fx_flux_ndiffuse
integer :: id_clock_fy_flux_ndiffuse
integer :: id_clock_fz_flux_ndiffuse
integer :: id_clock_fx_flux_gm
integer :: id_clock_fy_flux_gm
integer :: id_clock_fz_flux_gm
integer :: id_clock_bc_modes 
integer :: id_clock_psi_modes
integer :: id_clock_psi_bvp

! diagnostic manager ids
logical :: used
integer :: id_k33_explicit     =-1
integer :: id_N_squared        =-1
integer :: id_bv_freq          =-1
integer :: id_tx_trans_gm      =-1
integer :: id_ty_trans_gm      =-1
integer :: id_tx_trans_gm_adv  =-1
integer :: id_ty_trans_gm_adv  =-1
integer :: id_tz_trans_gm_adv  =-1
integer :: id_eddy_depth       =-1
integer :: id_psix_gm_modes    =-1
integer :: id_psiy_gm_modes    =-1
integer :: id_psix_gm_bvp      =-1
integer :: id_psiy_gm_bvp      =-1
integer :: id_gradx_rho        =-1
integer :: id_grady_rho        =-1
integer :: id_rescale_psi_x    =-1
integer :: id_rescale_psi_y    =-1
integer :: id_gm_eddy_ke_source=-1
integer :: id_uhrho_et_gm      =-1
integer :: id_vhrho_nt_gm      =-1
integer :: id_wrho_bt_gm       =-1
integer :: id_u_et_gm          =-1
integer :: id_v_nt_gm          =-1
integer :: id_w_bt_gm          =-1

integer :: id_eta_tend_gm_flx         =-1
integer :: id_eta_tend_gm_flx_glob    =-1
integer :: id_eta_tend_ndiff_flx      =-1
integer :: id_eta_tend_ndiff_flx_glob =-1

integer, dimension(:), allocatable  :: id_neutral_physics_ndiffuse ! tendency from neutral diffusion 
integer, dimension(:), allocatable  :: id_neutral_physics_gm       ! tendency from GM 
integer, dimension(:), allocatable  :: id_k33_implicit          ! K33 handled implicitly in time 
integer, dimension(:), allocatable  :: id_neutral_physics_ndiffuse_on_nrho ! tendency from neutral diffusion 
integer, dimension(:), allocatable  :: id_neutral_physics_gm_on_nrho       ! tendency from GM 
integer, dimension(:), allocatable  :: id_flux_x_ndiffuse       ! i-directed tracer flux from neutral diffuse
integer, dimension(:), allocatable  :: id_flux_y_ndiffuse       ! j-directed tracer flux from neutral diffuse 
integer, dimension(:), allocatable  :: id_flux_z_ndiffuse       ! k-directed tracer flux from neutral diffuse 
integer, dimension(:), allocatable  :: id_flux_x_gm             ! i-directed tracer flux from GM
integer, dimension(:), allocatable  :: id_flux_y_gm             ! j-directed tracer flux from GM
integer, dimension(:), allocatable  :: id_flux_z_gm             ! k-directed tracer flux from GM
integer, dimension(:), allocatable  :: id_flux_x_ndiffuse_int_z ! vertically integrated i-directed diffuse flux 
integer, dimension(:), allocatable  :: id_flux_y_ndiffuse_int_z ! vertically integrated j-directed diffuse flux 
integer, dimension(:), allocatable  :: id_flux_x_gm_int_z       ! vertically integrated i-directed GM flux 
integer, dimension(:), allocatable  :: id_flux_y_gm_int_z       ! vertically integrated j-directed GM flux 

integer, dimension(:), allocatable  :: id_bc_mode  ! baroclinic modes
integer, dimension(:), allocatable  :: id_bc_speed ! baroclinic wave speeds 

#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS

real, dimension(isd:ied,jsd:jed,nk,0:1) :: delqc   !density weighted (kg/m^3) quarter cell thickness(m)
real, dimension(isd:ied,jsd:jed,0:nk)   :: dzwtr   !(1/dzwt)(m^-1)
real, dimension(isd:ied,jsd:jed,0:1)    :: dtew    !grid distances from T-point to cell faces (m)
real, dimension(isd:ied,jsd:jed,0:1)    :: dtns    !grid distances from T-point to cell faces (m)
real, dimension(isd:ied,jsd:jed,0:1)    :: dtwedyt !horizontal areas (m^2) of quarter cell
real, dimension(isd:ied,jsd:jed,0:1)    :: dxtdtsn !horizontal areas (m^2) of quarter cell

real, dimension(isd:ied,jsd:jed,nk) :: aredi_array !3D array of redi diffusivities (m^2/sec)     
real, dimension(isd:ied,jsd:jed,nk) :: agm_array   !3D array of gm diffusivities (m^2/sec)        
real, dimension(isd:ied,jsd:jed)    :: ah_array    !2D array of micom horizontal diffusivities (not used)

real, dimension(isd:ied,jsd:jed,nk,0:1) :: psix ! streamfunction x-component (m^2/sec) 
real, dimension(isd:ied,jsd:jed,nk,0:1) :: psiy ! streamfunction y-component (m^2/sec) 

real, dimension(isd:ied,jsd:jed,nk) :: bv_freq ! buoyancy frequency (1/sec) 

real, dimension(isd:ied,jsd:jed)    :: bczone_radius     !for bczone calculation (m) 
real, dimension(isd:ied,jsd:jed)    :: rossby_radius     !first baroclinic Rossby radius (m) 
real, dimension(isd:ied,jsd:jed)    :: rossby_radius_raw !first baroclinic Rossby radius (m) without max/min 
real, dimension(isd:ied,jsd:jed,nk) :: eady_termx        !rho_z*(S_x)^2 for computing Eady growth rate 
real, dimension(isd:ied,jsd:jed,nk) :: eady_termy        !rho_z*(S_y)^2 for computing Eady growth rate 
real, dimension(isd:ied,jsd:jed)    :: baroclinic_termx  !intermediate term for computing vert ave baroclinicity
real, dimension(isd:ied,jsd:jed)    :: baroclinic_termy  !intermediate term for computing vert ave baroclinicity 
real, dimension(isd:ied,jsd:jed)    :: grid_length       !grid length scale (m)

real, dimension(isd:ied,jsd:jed,nk)     :: drhodT       !drho/dtheta     (kg/m^3/C)
real, dimension(isd:ied,jsd:jed,nk)     :: drhodS       !drho/dsalinity  (kg/m^3/psu)
real, dimension(isd:ied,jsd:jed,nk,0:1) :: drhodzb      !vertical neutral density gradient (kg/m^3/m)
real, dimension(isd:ied,jsd:jed,nk,0:1) :: drhodzh      !vertical neutral density gradient (kg/m^3/m)

real, dimension(isd:ied,jsd:jed,nk)     :: K33_implicit !density weighted (kg/m^3) implicit in time 
                                                        !diagonal term in redi tensor (m^2/sec) 
real, dimension(isd:ied,jsd:jed,nk)     :: K33_explicit !density weighted (kg/m^3) explicit in time 
                                                        !diagonal term in redi tensor (m^2/sec) 

real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: tensor_31 !tracer independent portion of mixing tensor
real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: tensor_32 !tracer independent portion of mixing tensor

integer, dimension(isd:ied,jsd:jed) :: ksurf_blayer  ! k-value at base of surface nblayer 
real, dimension(isd:ied,jsd:jed)    :: eddy_depth    !max of depth(m) mesoscale eddies penetrate & kpp bldepth
real, dimension(isd:ied,jsd:jed,nk) :: tx_trans_gm   !diagnosing i-transport due to GM 
real, dimension(isd:ied,jsd:jed,nk) :: ty_trans_gm   !diagnosing j-transport due to GM 

#else

real, dimension(:,:,:,:),   allocatable :: delqc   !density weighted (kg/m^3) quarter cell thickness(m)
real, dimension(:,:,:),     allocatable :: dzwtr   !(1/dzwt)(m^-1)
real, dimension(:,:,:),     allocatable :: dtew    !grid distances from T-point to cell faces (m)
real, dimension(:,:,:),     allocatable :: dtns    !grid distances from T-point to cell faces (m)
real, dimension(:,:,:),     allocatable :: dtwedyt !horizontal areas (m^2) of quarter cell
real, dimension(:,:,:),     allocatable :: dxtdtsn !horizontal areas (m^2) of quarter cell

real, dimension(:,:,:),     allocatable :: aredi_array !3D array of redi diffusivities (m^2/sec) 
real, dimension(:,:,:),     allocatable :: agm_array   !3D array of gm diffusivities (m^2/sec)     
real, dimension(:,:),       allocatable :: ah_array    !2D array of micom horizontal diffusivities (not used)

real, dimension(:,:,:,:), allocatable :: psix ! streamfunction x-component (m^2/sec) 
real, dimension(:,:,:,:), allocatable :: psiy ! streamfunction y-component (m^2/sec) 

real, dimension(:,:,:), allocatable :: bv_freq ! buoyancy frequency (1/sec) 

real, dimension(:,:),       allocatable :: bczone_radius     !for bzcone calculation (m) 
real, dimension(:,:),       allocatable :: rossby_radius     !first baroclinic Rossby radius (m) 
real, dimension(:,:),       allocatable :: rossby_radius_raw !first baroclinic Rossby radius (m) without max/min
real, dimension(:,:,:),     allocatable :: eady_termx        !rho_z*(S_x)^2 for computing Eady growth rate 
real, dimension(:,:,:),     allocatable :: eady_termy        !rho_z*(S_y)^2 for computing Eady growth rate 
real, dimension(:,:),       allocatable :: baroclinic_termx  !intermediate term for computing vert ave baroclinicity 
real, dimension(:,:),       allocatable :: baroclinic_termy  !intermediate term for computing vert ave baroclinicity 
real, dimension(:,:),       allocatable :: grid_length       !grid length scale (m)

real, dimension(:,:,:),     allocatable :: drhodT   !drho/dtheta     (kg/m^3/C)
real, dimension(:,:,:),     allocatable :: drhodS   !drho/dsalinity  (kg/m^3/psu)
real, dimension(:,:,:,:),   allocatable :: drhodzb  !vertical neutral density gradient (kg/m^3/m)
real, dimension(:,:,:,:),   allocatable :: drhodzh  !vertical neutral density gradient (kg/m^3/m)

real, dimension(:,:,:,:,:), allocatable :: tensor_31 !tracer independent portion of mixing tensor
real, dimension(:,:,:,:,:), allocatable :: tensor_32 !tracer independent portion of mixing tensor

real, dimension(:,:,:),     allocatable :: K33_implicit !density weighted (kg/m^3) implicit in time 
                                                        !diagonal term in redi tensor (m^2/sec) 
real, dimension(:,:,:),     allocatable :: K33_explicit !density weighted (kg/m^3) explicit in time 

integer, dimension(:,:), allocatable :: ksurf_blayer    ! k-value at base of surface nblayer 
real, dimension(:,:),    allocatable :: eddy_depth      !max of depth (m) mesoscale eddies penetrate & kpp bldepth

real, dimension(:,:,:),  allocatable :: tx_trans_gm     !for diagnosing i-transport due to GM 
real, dimension(:,:,:),  allocatable :: ty_trans_gm     !for diagnosing j-transport due to GM 

#endif

real, dimension(:,:,:,:), allocatable :: bc_mode   !dimensionless normalized baroclinic mode
real, dimension(:,:,:),   allocatable :: bc_speed  !wave speed (m/s) for baroclinic modes 
real, dimension(:,:),     allocatable :: bc_speed2 !squared wave speed (m/s) for chosen baroclinic mode 

! for diagnostics 
real, dimension(:,:,:), allocatable :: uhrho_et_gm  ! i-component of advective mass transport
real, dimension(:,:,:), allocatable :: vhrho_nt_gm  ! j-component of advective mass transport
real, dimension(:,:,:), allocatable :: wrho_bt_gm   ! k-component of advective mass transport 


! introduce following derived types so that do not need to know num_prog_tracers at compile time 
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: dTdx    ! tracer partial derivative (tracer/m)
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: dTdy    ! tracer partial derivative (tracer/m)
type(tracer_3d_0_nk_type), dimension(:), allocatable  :: dTdz    ! tracer partial derivative (tracer/m)
type(tracer_3d_1_nk_type), save                       :: dSdx    ! Dens%rho_salinity partial derivative (tracer/m)
type(tracer_3d_1_nk_type), save                       :: dSdy    ! Dens%rho_salinity partial derivative (tracer/m)
type(tracer_3d_0_nk_type), save                       :: dSdz    ! Dens%rho_salinity partial derivative (tracer/m)
type(tracer_2d_type),      dimension(:), allocatable  :: fz1     ! z-flux component for tracers at particular k 
type(tracer_2d_type),      dimension(:), allocatable  :: fz2     ! z-flux component for tracers at particular k 
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: flux_x  ! i-flux component for tracers for all k
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: flux_y  ! j-flux component for tracers for all k
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: flux_z  ! k-flux component for tracers for all k (diagnostic only)

integer :: index_temp
integer :: index_salt
integer :: neutralrho_nk

character(len=128) :: version=&
     '$Id: ocean_nphysicsC.F90,v 20.0 2013/12/14 00:14:40 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

character(len=*), parameter :: FILENAME=&
     __FILE__

logical :: module_is_initialized = .FALSE.

! time step settings 
real    :: dtime
real    :: two_dtime_inv

! constants
real :: pi_r
real :: grav_rho0_r
real :: grav_rho0r
real :: sqrt_grav

! vertical coordinate 
integer :: vert_coordinate_class

! lower and upper depth for vertically averaging ocean properties.
! read into ocean_nphysics_util_nml
real :: agm_closure_upper_depth
real :: agm_closure_lower_depth

! for eta_tend diagnostics (internally set)
logical :: diagnose_eta_tend_ndiff_flx=.false. 
logical :: diagnose_eta_tend_gm_flx   =.false. 

! for diagnosing advective GM transport 
logical :: diag_advect_transport       = .false. 
logical :: smooth_advect_transport     = .true. 
integer :: smooth_advect_transport_num = 2


!**************nml settings**************

! for turning on/off the schemes 
logical :: do_neutral_diffusion  = .true.
logical :: do_gm_skewsion        = .true.
logical :: gm_skewsion_modes     = .false.
logical :: gm_skewsion_bvproblem = .true.

! number of modes used to construct GM streamfunction 
! when gm_skewsion_modes=.true.
integer :: number_bc_modes = 1

! the particular baroclinic mode used to construct the BVP 
! streamfunction.  
integer :: bvp_bc_mode=1

! for setting the speed to constant with the BVP calculation.
logical :: bvp_constant_speed=.false. 
real    :: bvp_speed         = 0.0
real    :: bvp_min_speed     = 0.1

! for regularizing the streamfunction psi when computed from modes
logical :: regularize_psi=.true.
real    :: smax_psi=0.1 

! for setting minimum buoyancy frequency for computing modes
real    :: epsln_bv_freq=1.e-10

! min baroclinic wave speed (m/s)
real    :: min_bc_speed = 1.e-6

! for smoothing psix and psiy
logical :: smooth_psi = .true.    

! for smoothing baroclinic modes prior to normalization 
logical :: smooth_bc_modes = .false.    

! for smoothing the buoyancy frequency 
logical :: bv_freq_smooth_vert=.false.
integer :: num_121_passes     =1

! for setting the slope tapering methods 
real    :: smax                        ! set in ocean_neutral_util_nml
real    :: swidth                      ! set in ocean_neutral_util_nml
logical :: dm_taper         = .true.   ! tanh tapering scheme of Danabasoglu and McWilliams
real    :: swidthr                     ! inverse swidth  
real    :: smax_swidthr                ! useful combination of terms 
real    :: dm_taper_const   = 1.0      ! internally set to unity when dm_taper=.true.
logical :: gkw_taper        = .false.  ! quadratic tapering of Gerdes, Koberle, and Willebrand
real    :: gkw_taper_const  = 0.0      ! internally set to unity when gkw_taper=.true.

! for neutral blayer 
real :: turb_blayer_min = 0.0 ! metres (was always set to zero in MOM4.0)

! to compute an eddy depth, where shallower eddies feel the surface
logical :: neutral_eddy_depth=.true.        

! to reduce neutral fluxes to horz/vert diffusion next to model boundaries
logical :: tmask_neutral_on=.false.         

! to compute K33 explicitly in time. 
! diffusion_all_explicit=.false. for realistic simulations.
logical :: diffusion_all_explicit=.false.   

! revert to horizontal diffusion when tracer falls outside specified range 
logical :: neutral_physics_limit=.true.   

! for computing neutral slopes based on globally referenced potential
! density rather than locally referenced potential density. 
logical :: use_neutral_slopes_potrho   = .false.
real    :: neutral_slopes_potrho_press = 2000.0

! for specifying transport units
! can either be Sv or mks
character(len=32) :: transport_dims ='Sv (10^9 kg/s)' 
real              :: transport_convert=1.0e-9 

! for the module as a whole 
logical :: use_this_module   = .false.
logical :: debug_this_module = .false.

!**************end of nml settings**************

namelist /ocean_nphysicsC_nml/ use_this_module, debug_this_module, &
          do_neutral_diffusion, do_gm_skewsion,                    &
          neutral_physics_limit, neutral_eddy_depth,               &
          dm_taper, gkw_taper, tmask_neutral_on,                   &
          diffusion_all_explicit, turb_blayer_min,                 &
          gm_skewsion_modes, number_bc_modes,                      &
          gm_skewsion_bvproblem, bvp_bc_mode,                      &
          bvp_min_speed, bvp_speed, bvp_constant_speed,            &
          bv_freq_smooth_vert, num_121_passes,                     &
          min_bc_speed, smooth_psi, epsln_bv_freq,                 &
          regularize_psi, smax_psi, smooth_bc_modes,               &
          use_neutral_slopes_potrho, neutral_slopes_potrho_press,  &
          smooth_advect_transport, smooth_advect_transport_num

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_nphysicsC_init">
!
! <DESCRIPTION>
! Initialize the neutral physics module by registering fields for 
! diagnostic output and performing some numerical checks to see 
! that namelist settings are appropriate. 
! </DESCRIPTION>
!
subroutine ocean_nphysicsC_init(Grid, Domain, Time, Time_steps, Thickness, Dens, T_prog,&
           ver_coordinate_class, agm_closure_lower_dept, agm_closure_upper_dept,        &
           smx, swidt, cmip_units, debug)

  type(ocean_grid_type),        intent(in), target   :: Grid
  type(ocean_domain_type),      intent(in), target   :: Domain
  type(ocean_time_type),        intent(in)           :: Time
  type(ocean_time_steps_type),  intent(in)           :: Time_steps
  type(ocean_thickness_type),   intent(in)           :: Thickness
  type(ocean_density_type),     intent(in)           :: Dens
  type(ocean_prog_tracer_type), intent(inout)        :: T_prog(:)
  integer,                      intent(in)           :: ver_coordinate_class
  real,                         intent(in)           :: agm_closure_lower_dept
  real,                         intent(in)           :: agm_closure_upper_dept
  real,                         intent(in)           :: smx 
  real,                         intent(in)           :: swidt
  logical,                      intent(in)           :: cmip_units
  logical,                      intent(in), optional :: debug

  logical :: diagnose_gm_redi_input=.false.
  integer :: ioun, io_status, ierr  
  integer :: i, j, n
  
  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_nphysicsC_mod (ocean_nphysicsC_init):already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  num_prog_tracers = size(T_prog(:))
  dtime            = Time_steps%dtime_t
  Dom => Domain
  Grd => Grid

  vert_coordinate_class   = ver_coordinate_class
  agm_closure_lower_depth = agm_closure_lower_dept
  agm_closure_upper_depth = agm_closure_upper_dept
  smax                    = smx 
  swidth                  = swidt
  pi_r                    = 1.0/pi
  grav_rho0_r             = 1.0/(grav*rho0)
  grav_rho0r              = grav*rho0r
  sqrt_grav               = sqrt(grav)
  neutralrho_nk           = size(Dens%neutralrho_ref(:))
 
  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_nphysicsC_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_nphysicsC_nml')
#else
  ioun =  open_namelist_file()
  read (ioun,ocean_nphysicsC_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_nphysicsC_nml')
  call close_file (ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_nphysicsC_nml)  
  write (stdlogunit,ocean_nphysicsC_nml)

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  nk = Grid%nk
#endif

  if(use_this_module) then 
     call write_note(FILENAME,&
     'USING ocean_nphysicsC.')
  else 
     call write_note(FILENAME,&
     'NOT using ocean_nphysicsC_mod.')
     return
  endif 

  if (PRESENT(debug) .and. .not. debug_this_module) then
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
     call write_note(FILENAME,&
     'running ocean_nphysicsC_mod with debug_this_module=.true.')
  endif 

  write(stdoutunit,'(/1x,a,f10.2)') &
  '==> Note from ocean_nphysicsC_mod: using forward time step of (secs)', dtime 

  if(cmip_units) then
      transport_convert=1.0
      transport_dims   = 'kg/s'
  else
      transport_convert=1.0e-9 
      transport_dims   = 'Sv (10^9 kg/s)'
  endif


  ! Useful constants 
  two_dtime_inv = 0.5/dtime            !for explicit piece of K33 
  swidthr       = 1.0/(swidth + epsln) !for slope taper function when dm_taper used 
  smax_swidthr  = smax*swidthr         !for slope taper function when dm_taper used 

  if(do_neutral_diffusion) then 
     call write_note(FILENAME,&
     'computing neutral diffusion acting on each tracer.')
  else
     call write_note(FILENAME,&
     'NOT computing neutral diffusion. Are you sure this is what you wish?')
  endif 
  if(do_gm_skewsion) then 
      if(gm_skewsion_modes) then 
         call write_note(FILENAME,&
         'computing GM skewsion as a projection onto baroclinic modes.' )
         write(stdoutunit,'(1x,a,i4,a)') &
              '    Using ',number_bc_modes,' baroclinic modes to compute the eddy induced streamfunction.'
      elseif(gm_skewsion_bvproblem) then 
         call write_note(FILENAME,&
         'computing GM skewsion w/ streamfunction computed by boundary value problem.')
          if(bvp_bc_mode > number_bc_modes) then 
              number_bc_modes=bvp_bc_mode
          endif 
          if(bvp_bc_mode == 0) then 
             call write_note(FILENAME,&
             'setting baroclinic mode phase speed to zero for BVP streamfunction.')
          endif 
      elseif(gm_skewsion_modes .and. gm_skewsion_bvproblem) then 
          call mpp_error(FATAL, &
          '==>Error from ocean_nphysicsC_mod: gm_skewsion_modes .and. gm_skewsion_bvproblem cannot both be true.')
      elseif(.not. gm_skewsion_modes .and. .not. gm_skewsion_bvproblem) then 
          call mpp_error(FATAL, &
          '==>Error from ocean_nphysicsC_mod: choose one of gm_skewsion_modes or gm_skewsion_bvproblem.')
      endif
   else
      call write_note(FILENAME,&
      'NOT computing GM skewsion. Are you sure this is what you wish?')
  endif

  if(neutral_physics_limit) then
     call write_note(FILENAME,&
     'neutral_physics_limit=.true.')
     call write_line('Will revert to horizontal diffusion for points where tracer is outside specified range.')
  endif

  if(dm_taper .and. .not. gkw_taper) then
     call write_note(FILENAME,&
     'dm_taper=.true. Will use the tanh scheme')
     call write_line('of Danabasoglu and McWilliams to taper neutral diffusion in steep sloped regions')
     dm_taper_const =1.0
     gkw_taper_const=0.0
  endif
  if(gkw_taper .and. .not. dm_taper) then
     call write_note(FILENAME,&
     'gkw_taper=.true. Will use the quadratic scheme')
     call write_line('of Gerdes, Koberle, and Willebrand to taper neutral diffusion in steep sloped regions')
     dm_taper_const =0.0
     gkw_taper_const=1.0
  endif
  if(gkw_taper .and. dm_taper) then
      dm_taper_const =0.0
      gkw_taper_const=0.0
      call mpp_error(FATAL, &
      '==>Error from ocean_nphysicsC_mod: gkw_taper and dm_taper cannot both be set true--choose only one.')
  endif

  if(diffusion_all_explicit) then
     call write_warning(FILENAME,&
     'Running w/ diffusion_all_explicit=.true., which means compute K33 contribution')
     call write_line('to neutral diffusion explicitly in time.  This method is stable ONLY if taking')
     call write_line('very small time steps and/or running with just a single tracer.')
  endif

  if(use_neutral_slopes_potrho) then
     call write_warning(FILENAME,&
     'Running w/ use_neutral_slopes_potrho=.true., so will compute neutral slopes')
     call write_line('based on globally referenced potential density rather than')
     call write_line('locally referenced potential density. This method is only for')
     call write_line('sensitivity studies; it is not meant for realistic cases.')     
  endif

  if(number_bc_modes >= nk) then 
      call mpp_error(FATAL, &
      '==>Error from ocean_nphysicsC_mod: reduce number_bc_modes to less than number of vertical levels.')
  endif 


  do n=1,num_prog_tracers
    T_prog(n)%neutral_physics_limit = neutral_physics_limit
  enddo 

  allocate( dTdx(num_prog_tracers) )
  allocate( dTdy(num_prog_tracers) )
  allocate( dTdz(num_prog_tracers) )
  allocate( fz1(num_prog_tracers) )
  allocate( fz2(num_prog_tracers) )
  allocate( flux_x(num_prog_tracers) )
  allocate( flux_y(num_prog_tracers) )
  allocate( flux_z(num_prog_tracers) )

  call set_ocean_domain(Dom_flux,Grid,xhalo=Dom%xhalo,yhalo=Dom%yhalo,name='flux dom neutral',maskmap=Dom%maskmap)

#ifndef MOM_STATIC_ARRAYS
  allocate (dtew(isd:ied,jsd:jed,0:1))
  allocate (dtns(isd:ied,jsd:jed,0:1))
  allocate (dtwedyt(isd:ied,jsd:jed,0:1))
  allocate (dxtdtsn(isd:ied,jsd:jed,0:1))
  allocate (grid_length(isd:ied,jsd:jed))
  allocate (delqc(isd:ied,jsd:jed,nk,0:1))
  allocate (dzwtr(isd:ied,jsd:jed,0:nk))
  allocate (aredi_array(isd:ied,jsd:jed,nk)) 
  allocate (agm_array(isd:ied,jsd:jed,nk))   
  allocate (ah_array(isd:ied,jsd:jed))
  allocate (bczone_radius(isd:ied,jsd:jed))
  allocate (rossby_radius(isd:ied,jsd:jed))
  allocate (rossby_radius_raw(isd:ied,jsd:jed))
  allocate (eady_termx(isd:ied,jsd:jed,nk))
  allocate (eady_termy(isd:ied,jsd:jed,nk))
  allocate (baroclinic_termx(isd:ied,jsd:jed))
  allocate (baroclinic_termy(isd:ied,jsd:jed))
  allocate (tx_trans_gm(isd:ied,jsd:jed,nk))
  allocate (ty_trans_gm(isd:ied,jsd:jed,nk))

  allocate (psix(isd:ied,jsd:jed,nk,0:1))
  allocate (psiy(isd:ied,jsd:jed,nk,0:1))

  allocate (bv_freq(isd:ied,jsd:jed,nk))

  allocate (drhodT(isd:ied,jsd:jed,nk))
  allocate (drhodS(isd:ied,jsd:jed,nk))
  allocate (drhodzb(isd:ied,jsd:jed,nk,0:1))
  allocate (drhodzh(isd:ied,jsd:jed,nk,0:1))
  allocate (tensor_31(isd:ied,jsd:jed,nk,0:1,0:1))
  allocate (tensor_32(isd:ied,jsd:jed,nk,0:1,0:1))
  allocate (K33_implicit(isd:ied,jsd:jed,nk)) 
  allocate (K33_explicit(isd:ied,jsd:jed,nk)) 

  do n=1,num_prog_tracers
    allocate ( dTdx(n)%field(isd:ied,jsd:jed,nk) )
    allocate ( dTdy(n)%field(isd:ied,jsd:jed,nk) )
    allocate ( dTdz(n)%field(isd:ied,jsd:jed,0:nk) )
    allocate ( fz1(n)%field(isd:ied,jsd:jed) )
    allocate ( fz2(n)%field(isd:ied,jsd:jed) )
    allocate ( flux_x(n)%field(isd:ied,jsd:jed,nk) )
    allocate ( flux_y(n)%field(isd:ied,jsd:jed,nk) )
    allocate ( flux_z(n)%field(isd:ied,jsd:jed,nk) )
  enddo 
  allocate (dSdx%field(isd:ied,jsd:jed,nk))
  allocate (dSdy%field(isd:ied,jsd:jed,nk))
  allocate (dSdz%field(isd:ied,jsd:jed,0:nk))

  allocate(eddy_depth(isd:ied,jsd:jed))
  allocate(ksurf_blayer(isd:ied,jsd:jed))

#endif

  do n=1,num_prog_tracers 
    dTdx(n)%field(:,:,:)   = 0.0
    dTdy(n)%field(:,:,:)   = 0.0
    dTdz(n)%field(:,:,:)   = 0.0
    fz1(n)%field(:,:)      = 0.0
    fz2(n)%field(:,:)      = 0.0
    flux_x(n)%field(:,:,:) = 0.0
    flux_y(n)%field(:,:,:) = 0.0
    flux_z(n)%field(:,:,:) = 0.0
  enddo  
  dSdx%field(:,:,:)  = 0.0
  dSdy%field(:,:,:)  = 0.0
  dSdz%field(:,:,:)  = 0.0

  psix               = 0.0
  psiy               = 0.0
  bv_freq            = 0.0
  tx_trans_gm        = 0.0
  ty_trans_gm        = 0.0
  eddy_depth         = 0.0
  ksurf_blayer       = 1

  dtew(:,:,0) = Grd%dtw(:,:)
  dtew(:,:,1) = Grd%dte(:,:)
  dtns(:,:,0) = Grd%dts(:,:)
  dtns(:,:,1) = Grd%dtn(:,:)

  dtwedyt(:,:,:) = 0.0
  dtwedyt(:,:,0) = Grd%dte(:,:)*Grd%dyt(:,:)
  do i=isc-1,iec
    dtwedyt(i,:,1) = Grd%dtw(i+1,:)*Grd%dyt(i+1,:)
  enddo

  dxtdtsn(:,:,:) = 0.0
  dxtdtsn(:,:,0) = Grd%dxt(:,:)*Grd%dtn(:,:)
  do j=jsc-1,jec
    dxtdtsn(:,j,1) = Grd%dxt(:,j+1)*Grd%dts(:,j+1)
  enddo

  grid_length(:,:) = 2.0*Grd%dxt(:,:)*Grd%dyt(:,:)/(Grd%dxt(:,:)+Grd%dyt(:,:))

  eady_termx(:,:,:)            = 0.0
  eady_termy(:,:,:)            = 0.0
  baroclinic_termx(:,:)        = 0.0
  baroclinic_termy(:,:)        = 0.0

  rossby_radius(:,:)           = 0.0
  rossby_radius_raw(:,:)       = 0.0
  bczone_radius(:,:)           = 0.0
  agm_array(:,:,:)             = 0.0
  aredi_array(:,:,:)           = 0.0
  ah_array(:,:)                = 0.0

  call ocean_nphysics_coeff_init(Time, Thickness, rossby_radius, rossby_radius_raw, &
                         bczone_radius, agm_array, aredi_array, ah_array)

  drhodT(:,:,:)        = 0.0
  drhodS(:,:,:)        = 0.0
  drhodzb(:,:,:,:)     = 0.0
  drhodzh(:,:,:,:)     = 0.0
  tensor_31(:,:,:,:,:) = 0.0
  tensor_32(:,:,:,:,:) = 0.0
  K33_implicit(:,:,:)  = 0.0           
  K33_explicit(:,:,:)  = 0.0           

  allocate (bc_mode(isd:ied,jsd:jed,nk,number_bc_modes))
  allocate (bc_speed(isd:ied,jsd:jed,number_bc_modes))
  allocate (bc_speed2(isd:ied,jsd:jed))
  bc_mode   = 0.0
  bc_speed  = 0.0
  bc_speed2 = 0.0

  index_temp=-1;index_salt=-1
  do n=1,num_prog_tracers
     if (T_prog(n)%name == 'temp') index_temp = n
     if (T_prog(n)%name == 'salt') index_salt = n
  enddo
  if (index_temp == -1 .or. index_salt == -1) then 
     call mpp_error(FATAL, &
     '==>Error: temp and/or salt not identified in call to ocean_nphysicsC_init')
  endif 

  ! initialize clock ids 
  id_clock_ndiffuse         = mpp_clock_id('(Ocean neutral: diffuse)'   ,grain=CLOCK_ROUTINE)
  id_clock_gm               = mpp_clock_id('(Ocean neutral: GM stir)'   ,grain=CLOCK_ROUTINE)
  id_clock_neutral_blayer   = mpp_clock_id('(Ocean neutral: blayer)'    ,grain=CLOCK_ROUTINE)
  id_clock_fz_terms         = mpp_clock_id('(Ocean neutral: fz-terms)'  ,grain=CLOCK_ROUTINE)
  id_clock_fx_flux_ndiffuse = mpp_clock_id('(Ocean ndiffuse: fx-flux)'  ,grain=CLOCK_ROUTINE)
  id_clock_fy_flux_ndiffuse = mpp_clock_id('(Ocean ndiffuse: fy-flux)'  ,grain=CLOCK_ROUTINE)
  id_clock_fz_flux_ndiffuse = mpp_clock_id('(Ocean ndiffuse: fz-flux)'  ,grain=CLOCK_ROUTINE)
  id_clock_fx_flux_gm       = mpp_clock_id('(Ocean gm: fx-flux)'        ,grain=CLOCK_ROUTINE)
  id_clock_fy_flux_gm       = mpp_clock_id('(Ocean gm: fy-flux)'        ,grain=CLOCK_ROUTINE)
  id_clock_fz_flux_gm       = mpp_clock_id('(Ocean gm: fz-flux)'        ,grain=CLOCK_ROUTINE)
  id_clock_bc_modes         = mpp_clock_id('(Ocean gm: bc_modes)'       ,grain=CLOCK_ROUTINE)
  id_clock_psi_modes        = mpp_clock_id('(Ocean gm: psi_modes)'      ,grain=CLOCK_ROUTINE)
  id_clock_psi_bvp          = mpp_clock_id('(Ocean gm: psi_bvp)'        ,grain=CLOCK_ROUTINE)


  ! register fields for diagnostic output 

  id_rescale_psi_x = -1
  id_rescale_psi_x = register_diag_field ('ocean_model', 'rescale_psi_x',       &
                    Grd%tracer_axes(1:2), Time%model_time,                      &
                    'Dimensionless rescaling of mode-1 psix for GM', 'unitless',&
                    missing_value=missing_value, range=(/-1.0,1.e10/))

  id_rescale_psi_y = -1
  id_rescale_psi_y = register_diag_field ('ocean_model', 'rescale_psi_y',       &
                    Grd%tracer_axes(1:2), Time%model_time,                      &
                    'Dimensionless rescaling of mode-1 psiy for GM', 'unitless',&
                    missing_value=missing_value, range=(/-1.0,1.e10/))

  id_k33_explicit = -1
  id_k33_explicit = register_diag_field ('ocean_model', 'k33_explicit', &
                    Grd%tracer_axes_wt(1:3), Time%model_time,           &
                    'K33_explicit tensor element', 'm^2/sec',           &
                    missing_value=missing_value, range=(/-10.0,1.e20/))

  id_N_squared = -1
  id_N_squared = register_diag_field ('ocean_model', 'N_squared', &
            Grd%tracer_axes_wt(1:3), Time%model_time,             &
            'squared buoyancy frequency', '1/s^2',                &
            missing_value=missing_value, range=(/-10.0,1.e10/))

  id_bv_freq = -1
  id_bv_freq = register_diag_field ('ocean_model', 'bv_freq',       &   
            Grd%tracer_axes(1:3), Time%model_time,                  &
            'buoy freq at T-cell centre for use in neutral physics',&
            '1/s',missing_value=missing_value, range=(/-10.0,1.e10/))

  id_psix_gm_modes = register_diag_field ('ocean_model', 'psix_gm_modes', &
         Grd%tracer_axes_flux_y(1:3), Time%model_time,                    &
         'i-comp of modal decomposed GM streamfunction',                  &
         'm^2/sec', missing_value=missing_value, range=(/-1.e10,1e10/))

  id_psiy_gm_modes = register_diag_field ('ocean_model', 'psiy_gm_modes', &
         Grd%tracer_axes_flux_x(1:3), Time%model_time,                    &
         'j-comp of modal decomposed GM streamfunction',                  &
         'm^2/sec', missing_value=missing_value, range=(/-1.e10,1e10/))

  id_psix_gm_bvp = register_diag_field ('ocean_model', 'psix_gm_bvp', &
         Grd%tracer_axes_flux_y(1:3), Time%model_time,                &
         'i-comp of GM streamfunction computed via a BVP',            &
         'm^2/sec', missing_value=missing_value, range=(/-1.e10,1e10/))

  id_psiy_gm_bvp = register_diag_field ('ocean_model', 'psiy_gm_bvp', &
         Grd%tracer_axes_flux_x(1:3), Time%model_time,                &
         'j-comp of GM streamfunction computed via a BVP',            &
         'm^2/sec', missing_value=missing_value, range=(/-1.e10,1e10/))

  id_tx_trans_gm = -1
  id_tx_trans_gm = register_diag_field ('ocean_model', 'tx_trans_gm',      &
                   Grd%tracer_axes_flux_x(1:3), Time%model_time,           &
                   'T-cell mass i-transport from GM',trim(transport_dims), &
                   missing_value=missing_value, range=(/-1e20,1.e20/))

  id_ty_trans_gm = -1
  id_ty_trans_gm = register_diag_field ('ocean_model', 'ty_trans_gm',     &
                   Grd%tracer_axes_flux_y(1:3), Time%model_time,          &
                   'T-cell mass j-transport from GM',trim(transport_dims),&
                   missing_value=missing_value, range=(/-1e20,1.e20/))

  id_eddy_depth = -1
  id_eddy_depth = register_diag_field ('ocean_model','eddy_depth',                  &
                  Grd%tracer_axes(1:2), Time%model_time,                            &
                  'mesoscale eddy penetration depth used in neutral physicsC', 'm', &
                  missing_value=missing_value, range=(/-1.0,1.e8/))

  id_gradx_rho = -1
  id_gradx_rho = register_diag_field ('ocean_model', 'gradx_rho', &
              Grd%tracer_axes_flux_x(1:3), Time%model_time,       &
              'd(rho)/dx for neutral density', 'kg/m^4',          &
              missing_value=missing_value, range=(/-1e6,1e6/))

  id_grady_rho = -1
  id_grady_rho = register_diag_field ('ocean_model', 'grady_rho', &
              Grd%tracer_axes_flux_y(1:3), Time%model_time,       &
              'd(rho)/dy for neutral density', 'kg/m^4',          &
              missing_value=missing_value, range=(/-1e6,1e6/))

  id_gm_eddy_ke_source=-1
  id_gm_eddy_ke_source = register_diag_field ('ocean_model', 'gm_eddy_ke_source',                        &
               Grd%tracer_axes(1:2), Time%model_time,                                                    &
               'vertical sum of rho*dz*[(N*psi)^2 + (c*psi_z)^2]/agm = eddy ke source from BVP', 'W/m^2',&
               missing_value=missing_value, range=(/-1.e1,1.e15/),                                       &
               standard_name='tendency_of_ocean_eddy_kinetic_energy_content_due_to_bolus_transport')

  id_eta_tend_ndiff_flx= -1          
  id_eta_tend_ndiff_flx= register_diag_field ('ocean_model','eta_tend_ndiff_flx',&
    Grd%tracer_axes(1:2), Time%model_time,                                       &
    'non-Bouss steric sea level tendency from neutral diffusion operator', 'm/s',&
    missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_ndiff_flx > 0) diagnose_eta_tend_ndiff_flx=.true.

  id_eta_tend_ndiff_flx_glob= -1          
  id_eta_tend_ndiff_flx_glob= register_diag_field ('ocean_model', 'eta_tend_ndiff_flx_glob',          &
    Time%model_time,'global mean non-bouss steric sea level tendency from neutral diffusion operator',&
   'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_ndiff_flx_glob > 0) diagnose_eta_tend_ndiff_flx=.true.

  id_eta_tend_gm_flx= -1          
  id_eta_tend_gm_flx= register_diag_field ('ocean_model','eta_tend_gm_flx',              &
    Grd%tracer_axes(1:2), Time%model_time,                                               &
    'numerical form of non-Bouss steric sea level tend from GM-based eddy fluxes', 'm/s',&
    missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_gm_flx > 0) diagnose_eta_tend_gm_flx=.true.

  id_eta_tend_gm_flx_glob= -1          
  id_eta_tend_gm_flx_glob= register_diag_field ('ocean_model', 'eta_tend_gm_flx_glob',       &
   Time%model_time,                                                                          &
   'global mean numerical form of non-bouss steric sea level tend from GM-based eddy fluxes',&
   'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_gm_flx_glob > 0) diagnose_eta_tend_gm_flx=.true.

  allocate (id_k33_implicit(num_prog_tracers))
  allocate (id_neutral_physics_ndiffuse(num_prog_tracers))
  allocate (id_neutral_physics_gm(num_prog_tracers))
  allocate (id_neutral_physics_ndiffuse_on_nrho(num_prog_tracers))
  allocate (id_neutral_physics_gm_on_nrho(num_prog_tracers))
  id_k33_implicit             = -1
  id_neutral_physics_ndiffuse = -1
  id_neutral_physics_gm       = -1
  id_neutral_physics_ndiffuse_on_nrho = -1
  id_neutral_physics_gm_on_nrho       = -1
  do n=1,num_prog_tracers
     id_k33_implicit(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_k33_implicit', &
                          Grd%tracer_axes_wt(1:3), Time%model_time,                                  &
                          'K33_implicit tensor element for '//trim(T_prog(n)%name),                  &
                          'm^2/sec', missing_value=missing_value, range=(/-10.0,1.e10/))

     if (T_prog(n)%name == 'temp') then
       id_neutral_physics_ndiffuse(n) = register_diag_field ('ocean_model',               &
                               'neutral_diffusion_'//trim(T_prog(n)%name),                &
                               Grd%tracer_axes(1:3), Time%model_time,                     &
                               'rho*dzt*cp*explicit neutral diffusion tendency (heating)',&
                               trim(T_prog(n)%flux_units), missing_value=missing_value,   &
                               range=(/-1.e10,1.e10/))
       id_neutral_physics_ndiffuse_on_nrho(n) = register_diag_field ('ocean_model',       &
                               'neutral_diffusion_on_nrho_'//trim(T_prog(n)%name),        &
                               Dens%neutralrho_axes(1:3), Time%model_time,                &
                               'rho*dzt*cp*explicit neutral diffusion tendency (heating) binned to neutral density',&
                               trim(T_prog(n)%flux_units), missing_value=missing_value,   &
                               range=(/-1.e20,1.e20/))
       id_neutral_physics_gm(n) = register_diag_field ('ocean_model',                   &
                               'neutral_gm_'//trim(T_prog(n)%name),                     &
                               Grd%tracer_axes(1:3), Time%model_time,                   &
                               'rho*dzt*cp*GM stirring (heating)',                      &
                               trim(T_prog(n)%flux_units), missing_value=missing_value, &
                               range=(/-1.e10,1.e10/))
       id_neutral_physics_gm_on_nrho(n) = register_diag_field ('ocean_model',       &
                               'neutral_gm_on_nrho_'//trim(T_prog(n)%name),        &
                               Dens%neutralrho_axes(1:3), Time%model_time,                &
                               'rho*dzt*cp*GM stirring (heating) binned to neutral density',&
                               trim(T_prog(n)%flux_units), missing_value=missing_value,   &
                               range=(/-1.e20,1.e20/))
     else 
       id_neutral_physics_ndiffuse(n) = register_diag_field ('ocean_model',                             &
                               'neutral_diffusion_'//trim(T_prog(n)%name),                              &
                               Grd%tracer_axes(1:3), Time%model_time,                                   &
                               'rho*dzt*explicit neutral diffusion tendency for '//trim(T_prog(n)%name),&
                               trim(T_prog(n)%flux_units), missing_value=missing_value,                 &
                               range=(/-1.e10,1.e10/))
       id_neutral_physics_ndiffuse_on_nrho(n) = register_diag_field ('ocean_model',       &
                               'neutral_diffusion_on_nrho_'//trim(T_prog(n)%name),        &
                               Dens%neutralrho_axes(1:3), Time%model_time,                &
                               'rho*dzt*explicit neutral diffusion tendency binned to neutral density for '//trim(T_prog(n)%name),&
                               trim(T_prog(n)%flux_units), missing_value=missing_value,   &
                               range=(/-1.e20,1.e20/))
       id_neutral_physics_gm(n) = register_diag_field ('ocean_model',                    &
                               'neutral_gm_'//trim(T_prog(n)%name),                      &
                               Grd%tracer_axes(1:3), Time%model_time,                    &
                               'rho*dzt*GM stirring tendency for '//trim(T_prog(n)%name),&
                               trim(T_prog(n)%flux_units), missing_value=missing_value,  &
                               range=(/-1.e10,1.e10/))
       id_neutral_physics_gm_on_nrho(n) = register_diag_field ('ocean_model',       &
                               'neutral_gm_on_nrho_'//trim(T_prog(n)%name),        &
                               Dens%neutralrho_axes(1:3), Time%model_time,                &
                               'rho*dzt*GM stirring tendency binned to neutral density for '//trim(T_prog(n)%name),&
                               trim(T_prog(n)%flux_units), missing_value=missing_value,   &
                               range=(/-1.e20,1.e20/))
     endif 
  enddo 

  allocate (id_flux_x_ndiffuse(num_prog_tracers))
  allocate (id_flux_y_ndiffuse(num_prog_tracers))
  allocate (id_flux_z_ndiffuse(num_prog_tracers))
  allocate (id_flux_x_gm(num_prog_tracers))
  allocate (id_flux_y_gm(num_prog_tracers))
  allocate (id_flux_z_gm(num_prog_tracers))
  allocate (id_flux_x_ndiffuse_int_z(num_prog_tracers))
  allocate (id_flux_y_ndiffuse_int_z(num_prog_tracers))
  allocate (id_flux_x_gm_int_z(num_prog_tracers))
  allocate (id_flux_y_gm_int_z(num_prog_tracers))
  id_flux_x_ndiffuse       = -1
  id_flux_y_ndiffuse       = -1
  id_flux_z_ndiffuse       = -1
  id_flux_x_gm             = -1
  id_flux_y_gm             = -1
  id_flux_z_gm             = -1
  id_flux_x_ndiffuse_int_z = -1
  id_flux_y_ndiffuse_int_z = -1
  id_flux_x_gm_int_z       = -1
  id_flux_y_gm_int_z       = -1

  do n=1,num_prog_tracers
     if(n == index_temp) then 
         id_flux_x_ndiffuse(n) = register_diag_field ('ocean_model', &
              trim(T_prog(n)%name)//'_xflux_ndiffuse',               &
              Grd%tracer_axes_flux_x(1:3), Time%model_time,          &
              'cp*ndiffuse_xflux*dyt*rho_dzt*temp',                  &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_y_ndiffuse(n) = register_diag_field ('ocean_model', &
              trim(T_prog(n)%name)//'_yflux_ndiffuse',               &
              Grd%tracer_axes_flux_y(1:3), Time%model_time,          &
              'cp*ndiffuse_yflux*dxt*rho_dzt*temp',                  &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_z_ndiffuse(n) = register_diag_field ('ocean_model', &
              trim(T_prog(n)%name)//'_zflux_ndiffuse',               &
              Grd%tracer_axes(1:3), Time%model_time,                 &
              'cp*ndiffuse_zflux*dxt*dyt*rho*temp',                  &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_x_gm(n) = register_diag_field ('ocean_model',       &
              trim(T_prog(n)%name)//'_xflux_gm',                     &
              Grd%tracer_axes_flux_x(1:3), Time%model_time,          &
              'cp*gm_xflux*dyt*rho_dzt*temp',                        &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_y_gm(n) = register_diag_field ('ocean_model', &
              trim(T_prog(n)%name)//'_yflux_gm',               & 
              Grd%tracer_axes_flux_y(1:3), Time%model_time,    &
              'cp*gm_yflux*dxt*rho_dzt*temp',                  &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_z_gm(n) = register_diag_field ('ocean_model', &
              trim(T_prog(n)%name)//'_zflux_gm',               & 
              Grd%tracer_axes(1:3), Time%model_time,           &
              'cp*gm_zflux*dxt*dyt*rho*temp',                  &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))

         id_flux_x_ndiffuse_int_z(n) = register_diag_field ('ocean_model', &
              trim(T_prog(n)%name)//'_xflux_ndiffuse_int_z',               &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                &
              'z-integral cp*ndiffuse_xflux*dyt*rho_dzt*temp',             &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_y_ndiffuse_int_z(n) = register_diag_field ('ocean_model', &
              trim(T_prog(n)%name)//'_yflux_ndiffuse_int_z',               &
              Grd%tracer_axes_flux_y(1:2), Time%model_time,                &
              'z-integral cp*ndiffuse_yflux*dxt*rho_dzt*temp',             &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_x_gm_int_z(n) = register_diag_field ('ocean_model', &
              trim(T_prog(n)%name)//'_xflux_gm_int_z',               &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,          &
              'z-integral cp*gm_xflux*dyt*rho_dzt*temp',             &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_y_gm_int_z(n) = register_diag_field ('ocean_model', &
              trim(T_prog(n)%name)//'_yflux_gm_int_z',               &
              Grd%tracer_axes_flux_y(1:2), Time%model_time,          &
              'z-integral cp*gm_yflux*dyt*rho_dzt*temp',             &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
     else
         id_flux_x_ndiffuse(n) = register_diag_field ('ocean_model',         &
              trim(T_prog(n)%name)//'_xflux_ndiffuse',                       &
              Grd%tracer_axes_flux_x(1:3), Time%model_time,                  &
              'ndiffuse_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name), &
              'kg/sec', missing_value=missing_value,                         &
              range=(/-1.e18,1.e18/))
         id_flux_y_ndiffuse(n) = register_diag_field ('ocean_model',         &
              trim(T_prog(n)%name)//'_yflux_ndiffuse',                       &
              Grd%tracer_axes_flux_y(1:3), Time%model_time,                  &
              'ndiffuse_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name), &
              'kg/sec', missing_value=missing_value,                         & 
              range=(/-1.e18,1.e18/))
         id_flux_z_ndiffuse(n) = register_diag_field ('ocean_model',         &
              trim(T_prog(n)%name)//'_zflux_ndiffuse',                       &
              Grd%tracer_axes(1:3), Time%model_time,                         &
              'ndiffuse_zflux*dxt*dyt*rho*tracer for'//trim(T_prog(n)%name), &
              'kg/sec', missing_value=missing_value,                         & 
              range=(/-1.e18,1.e18/))
         id_flux_x_gm(n) = register_diag_field ('ocean_model',              &
              trim(T_prog(n)%name)//'_xflux_gm',                            &
              Grd%tracer_axes_flux_x(1:3), Time%model_time,                 &
              'gm_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),      &
              'kg/sec', missing_value=missing_value,                        &
              range=(/-1.e18,1.e18/))
         id_flux_y_gm(n) = register_diag_field ('ocean_model',              &
              trim(T_prog(n)%name)//'_yflux_gm',                            &
              Grd%tracer_axes_flux_y(1:3), Time%model_time,                 &
              'gm_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),      &
              'kg/sec', missing_value=missing_value,                        &
              range=(/-1.e18,1.e18/))
         id_flux_z_gm(n) = register_diag_field ('ocean_model',              &
              trim(T_prog(n)%name)//'_zflux_gm',                            &
              Grd%tracer_axes(1:3), Time%model_time,                        &
              'gm_zflux*dxt*dyt*rho*tracer for'//trim(T_prog(n)%name),      &
              'kg/sec', missing_value=missing_value,                        &
              range=(/-1.e18,1.e18/))
 
         id_flux_x_ndiffuse_int_z(n) = register_diag_field ('ocean_model',              &
              trim(T_prog(n)%name)//'_xflux_ndiffuse_int_z',                            &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                             &
              'z-integral ndiffuse_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name), &
              'kg/sec', missing_value=missing_value,                                    &
              range=(/-1.e18,1.e18/))
         id_flux_y_ndiffuse_int_z(n) = register_diag_field ('ocean_model',             &
              trim(T_prog(n)%name)//'_yflux_ndiffuse_int_z',                           &
              Grd%tracer_axes_flux_y(1:2), Time%model_time,                            &
              'z-integral ndiffuse_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),&
              'kg/sec', missing_value=missing_value,                                   &
              range=(/-1.e18,1.e18/))
         id_flux_x_gm_int_z(n) = register_diag_field ('ocean_model',              &
              trim(T_prog(n)%name)//'_xflux_gm_int_z',                            &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                       &
              'z-integral gm_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name), &
              'kg/sec', missing_value=missing_value,                              & 
              range=(/-1.e18,1.e18/))
         id_flux_y_gm_int_z(n) = register_diag_field ('ocean_model',              &
              trim(T_prog(n)%name)//'_yflux_gm_int_z',                            &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                       &
              'z-integral gm_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name), &
              'kg/sec', missing_value=missing_value,                              &
              range=(/-1.e18,1.e18/))

     endif

  enddo

  allocate (id_bc_mode(number_bc_modes))
  allocate (id_bc_speed(number_bc_modes))
  id_bc_mode  = -1
  id_bc_speed = -1
  do n=1,number_bc_modes
         id_bc_mode(n) = register_diag_field ('ocean_model',     &
              'baroclinic_mode_'//string(n),                     &
              Grd%tracer_axes(1:3), Time%model_time,             &
              'Dimensionless baroclinic mode number '//string(n),&
              'Dimensionless', missing_value=missing_value, range=(/-1.e2,1.e2/))
         id_bc_speed(n) = register_diag_field ('ocean_model',  &
              'baroclinic_speed_'//string(n),                  &
              Grd%tracer_axes(1:2), Time%model_time,           &
              'Speed for baroclinic mode number '//string(n),  &
              'm/s', missing_value=missing_value, range=(/-1.e2,1.e2/))
  enddo


  ! for diagnosing advective transport components 
  diag_advect_transport=.false. 

  id_u_et_gm = register_diag_field ('ocean_model', 'u_et_gm', &
        Grd%tracer_axes_flux_x(1:3), Time%model_time,         &
       'i-component of gm transport velocity',                &
       'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_u_et_gm > 0) diag_advect_transport=.true.
 
  id_v_nt_gm = register_diag_field ('ocean_model', 'v_nt_gm', &
        Grd%tracer_axes_flux_y(1:3), Time%model_time,         &
       'j-component of gm transport velocity',                &
       'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_v_nt_gm > 0) diag_advect_transport=.true.

  id_w_bt_gm = register_diag_field ('ocean_model', 'w_bt_gm', &
        Grd%tracer_axes_wt(1:3), Time%model_time,             &
       'vertical component of gm transport velocity',         &
       'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_w_bt_gm > 0) diag_advect_transport=.true.

  id_uhrho_et_gm = register_diag_field ('ocean_model', 'uhrho_et_gm', &
        Grd%tracer_axes_flux_x(1:3), Time%model_time,                 &
       'i-component of gm mass transport',                            &
       '(kg/m^3)*m^2/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_uhrho_et_gm > 0) diag_advect_transport=.true.

  id_vhrho_nt_gm = register_diag_field ('ocean_model', 'vhrho_nt_gm', &
        Grd%tracer_axes_flux_y(1:3), Time%model_time,                 &
       'j-component of gm mass transport',                            &
       '(kg/m^3)*m^2/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_vhrho_nt_gm > 0) diag_advect_transport=.true.

  id_wrho_bt_gm = register_diag_field ('ocean_model', 'wrho_bt_gm', &
        Grd%tracer_axes_wt(1:3), Time%model_time,                   &
       'k-component of gm mass transport',                          &
       '(kg/m^3)*m/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wrho_bt_gm > 0) diag_advect_transport=.true.

  id_tx_trans_gm_adv = -1
  id_tx_trans_gm_adv = register_diag_field ('ocean_model', 'tx_trans_gm_adv',       &
                   Grd%tracer_axes_flux_x(1:3), Time%model_time,                    &
                   'T-cell mass i-transport from GM advection',trim(transport_dims),&
                   missing_value=missing_value, range=(/-1e20,1.e20/))
  if(id_tx_trans_gm_adv > 0) diag_advect_transport=.true.

  id_ty_trans_gm_adv = -1
  id_ty_trans_gm_adv = register_diag_field ('ocean_model', 'ty_trans_gm_adv',       &
                   Grd%tracer_axes_flux_y(1:3), Time%model_time,                    &
                   'T-cell mass j-transport from GM advection',trim(transport_dims),&
                   missing_value=missing_value, range=(/-1e20,1.e20/))
  if(id_ty_trans_gm_adv > 0) diag_advect_transport=.true.

  id_tz_trans_gm_adv = register_diag_field ('ocean_model', 'tz_trans_gm_adv',&
         Grd%tracer_axes_wt(1:3), Time%model_time,                           &
         'T-cell mass k-transport from GM advection',                        &
         trim(transport_dims), missing_value=missing_value, range=(/-1.e20,1e20/))
  if(id_tz_trans_gm_adv > 0) diag_advect_transport=.true.


  if(diag_advect_transport) then 
     allocate (uhrho_et_gm(isd:ied,jsd:jed,nk))
     allocate (vhrho_nt_gm(isd:ied,jsd:jed,nk))
     allocate (wrho_bt_gm(isd:ied,jsd:jed,0:nk))
     uhrho_et_gm(:,:,:) = 0.0
     vhrho_nt_gm(:,:,:) = 0.0
     wrho_bt_gm(:,:,:)  = 0.0
  endif 

  call watermass_diag_init(Time, Dens, diagnose_gm_redi_input)

  if (.not. do_gm_skewsion) &
	call mpp_error(NOTE, &
      '==>Note from ocean_nphysicsC_mod: do_gm_skewsion=.true. is required for ocean_pik_diag')
  call ocean_pik_diag_init_ty_trans_gm(ty_trans_gm)

end subroutine ocean_nphysicsC_init
! </SUBROUTINE>  NAME="ocean_nphysicsC_init"


!#######################################################################
! <SUBROUTINE NAME="nphysicsC">
!
! <DESCRIPTION>
! This function computes the thickness weighted and density weighted
! time tendency for tracer from neutral physics.  Full discussion
! and details are provided by Griffies (2008). 
!
! Here is a brief summary.  
!
!---How the neutral diffusive flux components are computed:
!
! The vertical flux component is split into diagonal (3,3) and 
! off-diagonal (3,1) and (3,2) terms. The off-diagonal (3,1) and (3,2) 
! terms are included explicitly in time. The main contribution from the 
! (3,3) term to the time tendency is included implicitly in time 
! along with the usual contribution from diapycnal processes 
! (vertical mixing schemes).  This is the K33_implicit term.
! This approach is necessary with high vertical resolution, as 
! noted by Cox (1987).  However, splitting the vertical flux into 
! an implicit and explicit piece compromises the 
! integrity of the vertical flux component (see Griffies et al. 1998).
! So to minimize the disparity engendered by this split, the portion of 
! K33 that can be stably included explicitly in time is computed along 
! with the (3,1) and (3,2) terms. 
! 
! All other terms in the mixing tensor are included explicitly in time
! using a forward time step as required for temporal stability of 
! numerical diffusive processes.  
!
! The off-diagonal terms in the horizontal flux components, and all terms
! in the vertical flux component, are tapered in regions of steep neutral
! slope according to the requirements of linear stability.  MOM allows for 
! choice of two tapering schemes:
!
! (a) the tanh taper of Danabasoglu and McWilliams (1995)
! (b) the quadratic scheme of Gerdes, Koberle, and Willebrand (1991)
!
! Linear stability is far less stringent on the diagonal (1,1) and (2,2)
! part of the horizontal flux.  Indeed, these terms in practice need
! not be tapered in steep sloped regions. 
!
!---How the skew diffusive flux components are computed:
!
! The skew flux components are purely off-diagonal.  
! They are computed based on a vector streamfunction which 
! is built from a sum of baroclinic modes. 
! It is this part of the calculation that differs from 
! ocean_nphysicsA and ocean_nphysicsB.
! </DESCRIPTION>
!
subroutine nphysicsC (Time, Thickness, Dens, rho, T_prog, &
                      surf_blthick, gm_diffusivity, baroclinic_rossby_radius)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_density_type),     intent(in)    :: Dens
  real, dimension(isd:,jsd:,:), intent(in)    :: rho
  real, dimension(isd:,jsd:),   intent(in)    :: surf_blthick
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  real, dimension(isd:,jsd:,:), intent(inout) :: gm_diffusivity
  real, dimension(isd:,jsd:),   intent(inout) :: baroclinic_rossby_radius

  integer :: k
  integer :: tau, taum1

  if (.not. use_this_module) return

  if ( .not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_nphysicsC (neutral_physics): needs initialization')
  endif 

  if (size(T_prog(:)) /= num_prog_tracers) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_nphysicsC (neutral_physics): inconsistent size of T_prog')
  endif 

  taum1 = Time%taum1
  tau   = Time%tau

  ! time dependent delqc geometric factor 
  do k=1,nk
    delqc(:,:,k,0) = Grd%fracdz(k,0)*Thickness%rho_dzt(:,:,k,tau)
    delqc(:,:,k,1) = Grd%fracdz(k,1)*Thickness%rho_dzt(:,:,k,tau)
  enddo

  ! time dependent inverse dzwt 
  do k=0,nk
    dzwtr(:,:,k) = 1.0/Thickness%dzwt(:,:,k) 
  enddo

  if(use_neutral_slopes_potrho) then 
     wrk1(:,:,:) = neutral_slopes_potrho_press*Grd%tmask(:,:,:)
     wrk2(:,:,:) = 0.0
     call density_derivs(Dens%rho(:,:,:,tau), Dens%rho_salinity(:,:,:,tau), &
                         T_prog(index_temp)%field(:,:,:,tau), wrk1(:,:,:),  &
                         Time, drhodT(:,:,:), drhodS(:,:,:),  wrk2(:,:,:)) 
  else 
     drhodT(:,:,:) = Dens%drhodT(:,:,:)
     drhodS(:,:,:) = Dens%drhodS(:,:,:)
  endif 



  call tracer_derivs(Time, taum1, dtime, drhodT, drhodS, T_prog, Dens, dzwtr, &
                     dTdx, dTdy, dTdz, dSdx, dSdy, dSdz, drhodzb, drhodzh) 

  call neutral_slopes(Time, dTdx, dTdy, dSdx, dSdy, drhodT, drhodS, drhodzb, tensor_31, tensor_32)

  call cabbeling_thermob_tendency(Time, Thickness, T_prog, Dens,                               &
  dTdx(index_temp)%field(:,:,:), dTdy(index_temp)%field(:,:,:), dTdz(index_temp)%field(:,:,:), &
  dSdx%field(:,:,:), dSdy%field(:,:,:),                                                        &
  drhodzh, dxtdtsn, dtwedyt, dzwtr, delqc, aredi_array)

  call compute_eta_tend_gm90(Time, Thickness, Dens,             &
  dTdx(index_temp)%field(:,:,:), dTdy(index_temp)%field(:,:,:), &
  dSdx%field(:,:,:), dSdy%field(:,:,:),                         &
  drhodzh, dtwedyt, dzwtr, delqc, tensor_31, tensor_32, agm_array)

  call neutral_blayer(Time, Thickness, surf_blthick)
 
  call fz_terms(Time, Thickness, T_prog, rho)

  if(do_neutral_diffusion) then 
     call compute_ndiffusion(Time, Thickness, Dens, T_prog)
  endif 

  ! gm_diffusivity passed to neutral_physics for use in computing form drag
  gm_diffusivity(:,:,:) = agm_array(:,:,:)

  if(do_gm_skewsion) then 
      call baroclinic_modes(Time, Thickness, Dens) 
      if(gm_skewsion_modes) then 
          call compute_psi_modes(Time, Dens, Thickness, T_prog)
      else 
          call compute_psi_bvp(Time, Dens, Thickness, T_prog)
      endif
      call compute_gmskewsion(Time, Thickness, Dens, T_prog)
  endif
  
  ! compute Eady growth rate and baroclinicity for use in next time step 
  call compute_eady_rate(Time, Thickness, T_prog, Dens, eady_termx, eady_termy)
  call compute_baroclinicity(Time, baroclinic_termx, baroclinic_termy)

  ! compute rossby radius for use in next time step 
  call compute_rossby_radius(Thickness, dTdz, dSdz, Time, drhodT, drhodS, &
                             rossby_radius, rossby_radius_raw)
  baroclinic_rossby_radius(:,:) = rossby_radius_raw(:,:)

  ! compute width of baroclinic zone for use in next time step 
  call compute_bczone_radius(Time, bczone_radius)

  ! update closure-based diffusivity for next time step 
  call compute_diffusivity(Time, ksurf_blayer, Dens%drhodz_zt, rossby_radius, &
                           bczone_radius, agm_array, aredi_array)


end subroutine nphysicsC
! </SUBROUTINE> NAME="nphysicsC"


!#######################################################################
! <SUBROUTINE NAME="neutral_blayer">
!
! <DESCRIPTION>
! Subroutine computes the boundary layer as determined by 
! 1. depth within which typical mesoscale eddies are partially outcropped
! 2. depth within which vertical mixing scheme (e.g., kpp) computes a boundary layer
!
! Determine depth over which mesoscale eddies feel the ocean 
! surface.  This depth is a function of the neutral slope 
! and the Rossby radius.  This depth is called "eddy_depth".
! The algorithm for computing this depth is taken from 
! the appendix to Large etal, 1997 JPO vol 27, 2418-2447. 
! 
! In addition to considering mesoscale eddy lengths,
! include the possibility that the diabatic vertical
! mixing (e.g., KPP) produces a mixed layer depth that is 
! deeper than the depth that mesoscale eddies feel the ocean 
! surface.  Include this surf_blthick in the considerations so 
! to determine the depth of this generalized "boundary layer" 
! and the neutral slope at the base of the boundary layer. 
!
! Note: Only consider surface boundary layers here.  
!
! This subroutine is a modification of that in ocean_nphysicsA. 
! Here, we only compute the eddy_depth based on the
! algorithm in Large etal.  We do not compute an eddy
! depth which is also a function of smax. that is, we 
! remove the ocean_nphysicsA portion of the calculation 
! that sits inside the neutral_linear_gm_taper if-test.   
! 
! </DESCRIPTION>
!
subroutine neutral_blayer(Time, Thickness, surf_blthick)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  real, dimension(isd:,jsd:),   intent(in) :: surf_blthick

  logical :: slopeok(isc:iec)
  logical :: within_interior 
  integer :: i, j, k, ip, jq, kb, kr, kk, kkpkr
  real :: depth, slope, absslope 
  real :: thick_31(isd:ied,jsd:jed,0:1,0:1)
  real :: thick_32(isd:ied,jsd:jed,0:1,0:1)
  real :: thick_13(isd:ied,jsd:jed,0:1,0:1)
  real :: thick_23(isd:ied,jsd:jed,0:1,0:1)

  eddy_depth  = 0.0
  if(.not. neutral_eddy_depth) return

  call mpp_clock_begin(id_clock_neutral_blayer)

  thick_31    = Grd%zw(1)
  thick_32    = Grd%zw(1)
  thick_13    = Grd%zw(1)
  thick_23    = Grd%zw(1)

  ! 31-triads 
  do ip=0,1
     do kr=0,1
        do j=jsc,jec
           slopeok(:)=.false.
           kkloop31a:     do kk=1,nk-1
              do i=isc,iec 

                 absslope = abs(tensor_31(i,j,kk,ip,kr))
                 depth    = max(rossby_radius(i,j)*absslope, max(turb_blayer_min,surf_blthick(i,j)))
                 if(depth > Thickness%depth_zwt(i,j,kk) .and. .not. slopeok(i)) then
                     thick_31(i,j,ip,kr) = Thickness%depth_zwt(i,j,kk)
                 else 
                     slopeok(i)=.true.
                 endif
              enddo
              if(all(slopeok(:))) exit kkloop31a

           enddo kkloop31a
        enddo
     enddo
  enddo

  ! 13-triads 
  do kr=0,1
     do ip=0,1 
        do j=jsc,jec
           slopeok(:)=.false.

           kkloop13a:     do kk=1,nk
              kkpkr = min(kk+kr,nk)
              do i=isc,iec

                 slope = -Grd%tmask(i+ip,j,kkpkr)                                 &
                      *(drhodT(i+ip,j,kk)*dTdx(index_temp)%field(i,j,kk)         +&
                        drhodS(i+ip,j,kk)*dSdx%field(i,j,kk))                     &
                      /(drhodT(i+ip,j,kk)*dTdz(index_temp)%field(i+ip,j,kk-1+kr) +&
                        drhodS(i+ip,j,kk)*dSdz%field(i+ip,j,kk-1+kr) - epsln)

                 absslope = abs(slope)  

                 depth = max(rossby_radius(i,j)*absslope, max(turb_blayer_min,surf_blthick(i,j)))
                 if(depth > Thickness%depth_zwt(i,j,kk) .and. .not.slopeok(i)) then 
                     thick_13(i,j,ip,kr) = Thickness%depth_zwt(i,j,kk)
                 else 
                     slopeok(i)=.true.
                 endif

              enddo
              if(all(slopeok(:))) exit kkloop13a
           enddo kkloop13a

        enddo
     enddo
  enddo

  ! 32-triads 
  do jq=0,1
     do kr=0,1
        do j=jsc,jec
           slopeok(:)=.false.
           kkloop32a:      do kk=1,nk-1
              do i=isc,iec 

                 absslope = abs(tensor_32(i,j,kk,jq,kr))
                 depth    = max(rossby_radius(i,j)*absslope, max(turb_blayer_min,surf_blthick(i,j)))
                 if(depth > Thickness%depth_zwt(i,j,kk) .and. .not. slopeok(i) ) then
                     thick_32(i,j,jq,kr) = Thickness%depth_zwt(i,j,kk)
                 else 
                     slopeok(i) = .true.
                 endif
              enddo
              if(all(slopeok(:))) exit kkloop32a
           enddo kkloop32a
        enddo
     enddo
  enddo

  ! 23-triads 
  do kr=0,1
     do jq=0,1  
        do j=jsc,jec
           slopeok(:)=.false.

           kkloop23a:     do kk=1,nk
              do i=isc,iec
                 kkpkr = min(kk+kr,nk)

                 slope = -Grd%tmask(i,j+jq,kkpkr)&
                      *(drhodT(i,j+jq,kk)*dTdy(index_temp)%field(i,j,kk)+ &
                        drhodS(i,j+jq,kk)*dSdy%field(i,j,kk))             & 
                      /(drhodT(i,j+jq,kk)*dTdz(index_temp)%field(i,j+jq,kk-1+kr) +&
                        drhodS(i,j+jq,kk)*dSdz%field(i,j+jq,kk-1+kr) - epsln)  
                 absslope = abs(slope)  

                 depth = max(rossby_radius(i,j)*absslope, max(turb_blayer_min,surf_blthick(i,j)))
                 if(depth > Thickness%depth_zwt(i,j,kk) .and. .not.slopeok(i)) then 
                     thick_23(i,j,jq,kr) = Thickness%depth_zwt(i,j,kk) 
                 else
                     slopeok(i)=.true.
                 endif

              enddo
              if(all(slopeok(:))) exit kkloop23a
           enddo kkloop23a
        enddo
     enddo
  enddo

  ! max of triad depth defines eddy_depth.
  do j=jsc,jec
     do i=isc,iec
        eddy_depth(i,j) = max(Thickness%depth_zwt(i,j,1), &
                    thick_31(i,j,0,0), thick_31(i,j,0,1), &
                    thick_31(i,j,1,0), thick_31(i,j,1,1), &
                    thick_32(i,j,0,0), thick_32(i,j,0,1), &
                    thick_32(i,j,1,0), thick_32(i,j,1,1), &
                    thick_13(i,j,0,0), thick_13(i,j,0,1), &
                    thick_13(i,j,1,0), thick_13(i,j,1,1), &
                    thick_23(i,j,0,0), thick_23(i,j,0,1), &
                    thick_23(i,j,1,0), thick_23(i,j,1,1), &
                    turb_blayer_min)
     enddo
  enddo
  call mpp_update_domains(eddy_depth, Dom%domain2d) 


  ! save the k-level surface transition layer. 
  ! initialize ksurf_blayer to 1 rather than 0, to avoid 
  ! accessing the zeroth element of an array.   
  ksurf_blayer(:,:) = 1
  wrk1_2d(:,:)      = 0.0
  do j=jsd,jed
     do i=isd,ied
        kb=Grd%kmt(i,j)
        within_interior=.false.
        ksurf_blayer_loop: do k=1,kb
           if(Thickness%depth_zwt(i,j,k) > eddy_depth(i,j)) then 
               ksurf_blayer(i,j) = k
               wrk1_2d(i,j)      = float(k)
               exit ksurf_blayer_loop
           endif
        enddo ksurf_blayer_loop
     enddo
  enddo

  call diagnose_2d(Time, Grd, id_eddy_depth, eddy_depth(:,:))

  call mpp_clock_end(id_clock_neutral_blayer)

end subroutine neutral_blayer
! </SUBROUTINE> NAME="neutral_blayer"


!#######################################################################
! <SUBROUTINE NAME="compute_ndiffusion">
!
! <DESCRIPTION>
! Subroutine to compute the tendency from neutral diffusion.
! </DESCRIPTION>
!
subroutine compute_ndiffusion(Time, Thickness, Dens, T_prog)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)

  real, dimension(isd:ied,jsd:jed) :: tmp_flux
  real, dimension(isd:ied,jsd:jed) :: eta_tend
  real    :: eta_tend_glob
  integer :: i,j,k,n,tau

  call mpp_clock_begin(id_clock_ndiffuse)

  tau=Time%tau 

  do n=1,num_prog_tracers  
    fz1(n)%field(:,:)      = 0.0
    fz2(n)%field(:,:)      = 0.0
    flux_x(n)%field(:,:,:) = 0.0
    flux_y(n)%field(:,:,:) = 0.0
    T_prog(n)%wrk1(:,:,:)  = 0.0
  enddo 
  
  do k=1,nk
     call mpp_clock_begin(id_clock_fx_flux_ndiffuse)
     call fx_flux_ndiffuse(Time, Thickness, T_prog, k)
     call mpp_clock_end(id_clock_fx_flux_ndiffuse) 

     call mpp_clock_begin(id_clock_fy_flux_ndiffuse)
     call fy_flux_ndiffuse(Time, Thickness, T_prog, k)
     call mpp_clock_end(id_clock_fy_flux_ndiffuse)
  enddo
  if (Grd%tripolar) then 
      do n=1,num_prog_tracers
         call mpp_update_domains(flux_x(n)%field(:,:,:), flux_y(n)%field(:,:,:), Dom_flux%domain2d, &
              gridtype=CGRID_NE, complete=T_prog(n)%complete) 
      enddo
  endif

  do k=1,nk
     call mpp_clock_begin(id_clock_fz_flux_ndiffuse)
     call fz_flux_ndiffuse(T_prog,k)
     call mpp_clock_end(id_clock_fz_flux_ndiffuse)
     do n=1,num_prog_tracers
        do j=jsc,jec
           do i=isc,iec
              T_prog(n)%wrk1(i,j,k) =                                                 & 
                   Grd%tmask(i,j,k)                                                   &
                   *(fz1(n)%field(i,j)-fz2(n)%field(i,j)                              &
                   +( flux_x(n)%field(i,j,k)-flux_x(n)%field(i-1,j,k)                 &
                     +flux_y(n)%field(i,j,k)-flux_y(n)%field(i,j-1,k) )*Grd%datr(i,j) &
                    )
              T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + T_prog(n)%wrk1(i,j,k)
              fz1(n)%field(i,j) = fz2(n)%field(i,j)
           enddo
        enddo

     enddo
  enddo


  ! diagnostics 
  do n=1,num_prog_tracers

     if(id_neutral_physics_ndiffuse(n) > 0) then 
        call diagnose_3d(Time, Grd, id_neutral_physics_ndiffuse(n), T_prog(n)%wrk1(:,:,:)*T_prog(n)%conversion)
     endif
     if(id_neutral_physics_ndiffuse_on_nrho(n) > 0) then 
        call diagnose_3d_rho(Time, Dens, id_neutral_physics_ndiffuse_on_nrho(n), T_prog(n)%wrk1*T_prog(n)%conversion)
     endif

     ! send fluxes to diag_manager 
     ! minus sign is due to a MOM-convention for physics fluxes  
     if(id_flux_x_ndiffuse(n) > 0) then 
        call diagnose_3d(Time, Grd, id_flux_x_ndiffuse(n), -1.0*T_prog(n)%conversion*flux_x(n)%field(:,:,:))
     endif
     if(id_flux_y_ndiffuse(n) > 0) then 
        call diagnose_3d(Time, Grd, id_flux_y_ndiffuse(n), -1.0*T_prog(n)%conversion*flux_y(n)%field(:,:,:))
     endif
     if(id_flux_z_ndiffuse(n) > 0) then 
         wrk1(:,:,:) = 0.0         
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  wrk1(i,j,k) = Grd%dat(i,j)*flux_z(n)%field(i,j,k)
               enddo
            enddo
         enddo
         call diagnose_3d(Time, Grd, id_flux_z_ndiffuse(n), -1.0*T_prog(n)%conversion*wrk1(:,:,:))
     endif

     if(id_flux_x_ndiffuse_int_z(n) > 0) then 
        tmp_flux = 0.0
        do k=1,nk
            tmp_flux(COMP) = tmp_flux(COMP) + flux_x(n)%field(COMP,k)
        enddo
        call diagnose_2d(Time, Grd, id_flux_x_ndiffuse_int_z(n), -1.0*T_prog(n)%conversion*tmp_flux(:,:))
     endif
     if(id_flux_y_ndiffuse_int_z(n) > 0) then 
        tmp_flux = 0.0
        do k=1,nk
            tmp_flux(COMP) = tmp_flux(COMP) + flux_y(n)%field(COMP,k)
        enddo
        call diagnose_2d(Time, Grd, id_flux_y_ndiffuse_int_z(n), -1.0*T_prog(n)%conversion*tmp_flux(:,:))
     endif
     
  enddo   ! n=1,num_prog_tracers

  call watermass_diag_ndiffuse(Time, Dens, T_prog(index_temp)%wrk1(:,:,:), T_prog(index_salt)%wrk1(:,:,:))

  if (id_k33_explicit > 0) then
      call diagnose_3d(Time, Grd, id_k33_explicit, rho0r*K33_explicit(:,:,:))
  endif

  if(diagnose_eta_tend_ndiff_flx) then 
      call diagnose_eta_tend_3dflux (Time, Thickness, Dens,&
           flux_x(index_temp)%field(:,:,:),                &
           flux_y(index_temp)%field(:,:,:),                &
           flux_z(index_temp)%field(:,:,:),                &
           flux_x(index_salt)%field(:,:,:),                &
           flux_y(index_salt)%field(:,:,:),                &
           flux_z(index_salt)%field(:,:,:),                &    
           eta_tend, eta_tend_glob)   

      call diagnose_2d(Time, Grd, id_eta_tend_ndiff_flx, eta_tend(:,:))
      if(id_eta_tend_ndiff_flx_glob > 0) then  
          used  = send_data (id_eta_tend_ndiff_flx_glob, eta_tend_glob, Time%model_time)
      endif
  endif


  call mpp_clock_end(id_clock_ndiffuse)

end subroutine compute_ndiffusion
! </SUBROUTINE> NAME="compute_ndiffusion"


!#######################################################################
! <SUBROUTINE NAME="compute_gmskewsion">
!
! <DESCRIPTION>
! Subroutine to compute the tracer tendency from GM skewsion.
! </DESCRIPTION>
!
subroutine compute_gmskewsion(Time, Thickness, Dens, T_prog)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)

  real, dimension(isd:ied,jsd:jed) :: tmp_flux

  real, dimension(isd:ied,jsd:jed) :: eta_tend
  real    :: eta_tend_glob
  real    :: upsilonx, upsilony
  real    :: d_upsilonx_dz, d_upsilony_dz
  real    :: term1, term2, term3
  integer :: i,j,k,n,kp1
  integer :: tau

  call mpp_clock_begin(id_clock_gm)

  tau  =Time%tau 

  do n=1,num_prog_tracers  
    fz1(n)%field(:,:)      = 0.0
    fz2(n)%field(:,:)      = 0.0
    flux_x(n)%field(:,:,:) = 0.0
    flux_y(n)%field(:,:,:) = 0.0
    flux_z(n)%field(:,:,:) = 0.0  ! for diagnostics 
    T_prog(n)%wrk1(:,:,:)  = 0.0
  enddo 
  
  call mpp_clock_begin(id_clock_fx_flux_gm)
  call fx_flux_gm
  call mpp_clock_end(id_clock_fx_flux_gm)

  call mpp_clock_begin(id_clock_fy_flux_gm)
  call fy_flux_gm
  call mpp_clock_end(id_clock_fy_flux_gm)

  if (Grd%tripolar) then 
      do n=1,num_prog_tracers
         call mpp_update_domains(flux_x(n)%field(:,:,:), flux_y(n)%field(:,:,:), Dom_flux%domain2d, &
              gridtype=CGRID_NE, complete=T_prog(n)%complete) 
      enddo
  endif

  do k=1,nk
     call mpp_clock_begin(id_clock_fz_flux_gm)
     call fz_flux_gm(T_prog,k)
     call mpp_clock_end(id_clock_fz_flux_gm)
     do n=1,num_prog_tracers
        do j=jsc,jec
           do i=isc,iec
              T_prog(n)%wrk1(i,j,k) =                                                 & 
                   Grd%tmask(i,j,k)                                                   &
                   *(fz1(n)%field(i,j)-fz2(n)%field(i,j)                              &
                   +( flux_x(n)%field(i,j,k)-flux_x(n)%field(i-1,j,k)                 &
                   +  flux_y(n)%field(i,j,k)-flux_y(n)%field(i,j-1,k) )*Grd%datr(i,j) &
                    )
           enddo
        enddo
        T_prog(n)%th_tendency(COMP,k) = T_prog(n)%th_tendency(COMP,k) + T_prog(n)%wrk1(COMP,k)
        fz1(n)%field(COMP) = fz2(n)%field(COMP)
     enddo
  enddo


  ! diagnostics 
  do n=1,num_prog_tracers

     if(id_neutral_physics_gm(n) > 0) then 
        call diagnose_3d(Time, Grd, id_neutral_physics_gm(n), T_prog(n)%wrk1(:,:,:)*T_prog(n)%conversion)
     endif
     if(id_neutral_physics_gm_on_nrho(n) > 0) then 
        call diagnose_3d_rho(Time, Dens, id_neutral_physics_gm_on_nrho(n), T_prog(n)%wrk1*T_prog(n)%conversion)
     endif

     ! send fluxes to diag_manager 
     ! minus sign is due to a MOM-convention for physics fluxes  
     if(id_flux_x_gm(n) > 0) then 
        call diagnose_3d(Time, Grd, id_flux_x_gm(n), -1.0*T_prog(n)%conversion*flux_x(n)%field(:,:,:))
     endif
     if(id_flux_y_gm(n) > 0) then 
        call diagnose_3d(Time, Grd, id_flux_y_gm(n), -1.0*T_prog(n)%conversion*flux_y(n)%field(:,:,:))
     endif
     if(id_flux_z_gm(n) > 0) then 
         wrk1(:,:,:) = 0.0         
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  wrk1(i,j,k) = Grd%dat(i,j)*flux_z(n)%field(i,j,k)
               enddo
            enddo
         enddo
        call diagnose_3d(Time, Grd, id_flux_z_gm(n), -1.0*T_prog(n)%conversion*wrk1(:,:,:))
     endif
     if(id_flux_x_gm_int_z(n) > 0) then 
         tmp_flux = 0.0
         do k=1,nk
            tmp_flux(COMP) = tmp_flux(COMP) + flux_x(n)%field(COMP,k)
         enddo
         call diagnose_2d(Time, Grd, id_flux_x_gm_int_z(n), -1.0*T_prog(n)%conversion*tmp_flux(:,:))
     endif
     if(id_flux_y_gm_int_z(n) > 0) then 
        tmp_flux = 0.0
        do k=1,nk
            tmp_flux(COMP) = tmp_flux(COMP) + flux_y(n)%field(COMP,k)
        enddo  
        call diagnose_2d(Time, Grd, id_flux_y_gm_int_z(n), -1.0*T_prog(n)%conversion*tmp_flux(:,:))  
     endif     

  enddo   ! n=1,num_prog_tracers


  call watermass_diag_sdiffuse(Time, Dens, T_prog(index_temp)%wrk1(:,:,:), T_prog(index_salt)%wrk1(:,:,:))

  if(id_gm_eddy_ke_source > 0) then 
      wrk1_2d(:,:) = 0.0
      do k=1,nk
         kp1 = min(nk,k+1) 
         do j=jsc,jec
            do i=isc,iec
               if(agm_array(i,j,k) > 0.0) then 
                   upsilonx = -onehalf*(psiy(i,j,k,0)+psiy(i,j,k,1))
                   upsilony =  onehalf*(psix(i,j,k,0)+psix(i,j,k,1))
                   d_upsilonx_dz = -onehalf*(psiy(i,j,k,0)+psiy(i,j,k,1)-psiy(i,j,kp1,0)-psiy(i,j,kp1,1)) &
                        /(epsln+Thickness%dzt(i,j,k))
                   d_upsilony_dz =  onehalf*(psix(i,j,k,0)+psix(i,j,k,1)-psix(i,j,kp1,0)-psix(i,j,kp1,1)) &
                        /(epsln+Thickness%dzt(i,j,k))
                   term1 = Grd%tmask(i,j,k)*Grd%tmask(i,j,kp1)*Thickness%rho_dzt(i,j,k,tau)/agm_array(i,j,k)
                   term2 = bv_freq(i,j,k)*bv_freq(i,j,k)*(upsilonx**2 + upsilony**2)
                   term3 = bc_speed2(i,j)*(d_upsilonx_dz**2 + d_upsilony_dz**2)
                   wrk1_2d(i,j) = wrk1_2d(i,j) + term1*(term2 + term3) 
               endif
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_gm_eddy_ke_source, wrk1_2d(:,:))
  endif

  if(diagnose_eta_tend_gm_flx) then 
      call diagnose_eta_tend_3dflux (Time, Thickness, Dens,&
           flux_x(index_temp)%field(:,:,:),                &
           flux_y(index_temp)%field(:,:,:),                &
           flux_z(index_temp)%field(:,:,:),                &
           flux_x(index_salt)%field(:,:,:),                &
           flux_y(index_salt)%field(:,:,:),                &
           flux_z(index_salt)%field(:,:,:),                &    
           eta_tend, eta_tend_glob)   

      call diagnose_2d(Time, Grd, id_eta_tend_gm_flx, eta_tend(:,:))
      if(id_eta_tend_gm_flx_glob > 0) then  
          used = send_data (id_eta_tend_gm_flx_glob, eta_tend_glob, Time%model_time)
      endif
  endif

  call mpp_clock_end(id_clock_gm)

end subroutine compute_gmskewsion
! </SUBROUTINE> NAME="compute_gmskewsion"



!#######################################################################
! <SUBROUTINE NAME="baroclinic_modes">
!
! <DESCRIPTION>
! Subroutine computes the baroclinic wave speeds and the dimensionless
! baroclinic mode eigenfunction for the vertical velocity baroclinic 
! modes.  These modes vanish at the surface and the bottom.  We use
! the Chelton etal WKB analytic formulae for the speeds and modes.
!
! The baroclinic modes are dimensionless, and normalized over the 
! depth of the ocean, from free surface to bottom.  
!
! Units of the speeds are m/sec.
!
! </DESCRIPTION>
!
subroutine baroclinic_modes(Time, Thickness, Dens)

  type(ocean_time_type),      intent(in) :: Time
  type(ocean_thickness_type), intent(in) :: Thickness
  type(ocean_density_type),   intent(in) :: Dens

  integer :: i,j,k,m,n,kbot
  real    :: drhodz_prev, tmpdrhodz
  real    :: norm
  real    :: bc_mode_prev, tmp_bcmode

  call mpp_clock_begin(id_clock_bc_modes)


  ! place buoyancy frequency at T-point into bv_freq.
  ! set minimum value for frequency.  
  bv_freq=0.0
  do k=1,nk
     bv_freq(:,:,k) = max(epsln_bv_freq,sqrt(abs(grav*rho0r*Dens%drhodz_zt(:,:,k))))
  enddo

  ! vertically smooth buoyancy frequency, even beyond that in ocean_density_mod
  if(bv_freq_smooth_vert) then
      do m=1,num_121_passes
         do j=jsd,jed
            do i=isd,ied
               drhodz_prev = onefourth*bv_freq(i,j,1) 
               kbot=Grd%kmt(i,j)
               if(kbot>1) then
                   do k=2,kbot-2
                      tmpdrhodz      = bv_freq(i,j,k)
                      bv_freq(i,j,k) = drhodz_prev + onehalf*bv_freq(i,j,k) + onefourth*bv_freq(i,j,k+1)
                      drhodz_prev    = onefourth*tmpdrhodz
                   enddo
               endif
            enddo
         enddo
      enddo
  endif

  ! compute first baroclinic wave speed 
  bc_speed(:,:,:) = 0.0
  n=1
  do j=jsd,jed
     do i=isd,ied
        kbot = Grd%kmt(i,j)  
        if(kbot > 1) then 
            do k=1,kbot  
               bc_speed(i,j,n) = bc_speed(i,j,n) + Thickness%dzt(i,j,k)*bv_freq(i,j,k) 
            enddo
            bc_speed(i,j,n) = max(min_bc_speed,bc_speed(i,j,n)*pi_r)
        endif
     enddo
  enddo

  ! compute argument of sine used in defining the baroclinic modes 
  wrk2(:,:,:) = 0.0
  do j=jsd,jed
     do i=isd,ied
        kbot = Grd%kmt(i,j)  
        if(kbot > 1) then 
            wrk2(i,j,kbot) = bv_freq(i,j,kbot) &
             *(Thickness%depth_zwt(i,j,kbot)-Thickness%depth_zt(i,j,kbot)) 
            do k=kbot-1,1,-1
               wrk2(i,j,k) = wrk2(i,j,k+1)                                                  &
               + (bv_freq(i,j,k+1)*(Thickness%depth_zt(i,j,k+1)-Thickness%depth_zwt(i,j,k)) &
               +  bv_freq(i,j,k)  *(Thickness%depth_zwt(i,j,k) -Thickness%depth_zt(i,j,k))) 
            enddo
            do k=1,kbot
               wrk2(i,j,k) = wrk2(i,j,k)/(epsln + bc_speed(i,j,1))  
            enddo
        endif
     enddo
  enddo

  ! compute baroclinic modes 
  do n=1,number_bc_modes

     do j=jsd,jed
        do i=isd,ied

           kbot = Grd%kmt(i,j)  
           bc_mode(i,j,:,n) = 0.0

           if(kbot > 1) then 

               ! wave speeds 
               bc_speed(i,j,n) = bc_speed(i,j,1)/n 

               ! dimensionless baroclinic mode
               do k=1,kbot
                  bc_mode(i,j,k,n) = sin(wrk2(i,j,k)*n)  
               enddo

               ! vertically smooth bc_mode prior to normalization 
               if(smooth_bc_modes) then
                   do m=1,num_121_passes
                      bc_mode_prev        = onefourth*bc_mode(i,j,1,n) 
                      do k=2,kbot-2
                         tmp_bcmode       = bc_mode(i,j,k,n) 
                         bc_mode(i,j,k,n) = bc_mode_prev + onehalf*bc_mode(i,j,k,n) + onefourth*bc_mode(i,j,k+1,n)
                         bc_mode_prev     = onefourth*tmp_bcmode
                      enddo
                   enddo
               endif

               ! normalize the baroclinic mode 
               norm = 0.0
               do k=1,kbot
                  norm = norm + Thickness%dzt(i,j,k)*(bv_freq(i,j,k)*bc_mode(i,j,k,n))**2
               enddo
               norm = sqrt_grav/(epsln+sqrt(norm))
               do k=1,kbot
                  bc_mode(i,j,k,n) = bc_mode(i,j,k,n)*norm
               enddo

           endif

        enddo
     enddo
  enddo

  ! for use in BVP approach 
  if(bvp_bc_mode == 0 .or. bvp_constant_speed) then 
      bc_speed2(:,:) = bvp_speed*bvp_speed*Grd%tmask(:,:,1)
  else
     bc_speed2(:,:) = Grd%tmask(:,:,1) &
          *max(bvp_min_speed**2,(bvp_speed-bc_speed(:,:,bvp_bc_mode))**2)
  endif
 
  ! to avoid problems with spurious init values 
  if(Time%itt0 <= 1) bc_mode=0.0


  ! diagnostics 
  call diagnose_3d(Time, Grd, id_bv_freq, bv_freq(:,:,:))

  do n=1,number_bc_modes
     call diagnose_3d(Time, Grd, id_bc_mode(n), bc_mode(:,:,:,n))
     call diagnose_2d(Time, Grd, id_bc_speed(n), bc_speed(:,:,n))
  enddo

  call mpp_clock_end(id_clock_bc_modes)


end subroutine baroclinic_modes
! </SUBROUTINE> NAME="baroclinic_modes"


!#######################################################################
! <SUBROUTINE NAME="compute_psi_modes">
!
! <DESCRIPTION>
! Compute vector streamfunction as projection onto baroclinic modes.
!
! Units of psi are m^2/sec
!
! This method for computing the quasi-Stokes streamfunction 
! is not generally recommended. It remains in MOM only for 
! testing purposes.  
!
! </DESCRIPTION>
!
subroutine compute_psi_modes(Time, Dens, Thickness, T_prog)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_density_type),     intent(in) :: Dens
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)

  real    :: gradx, grady 
  real    :: active_cells
  real    :: project_x(0:1), project_y(0:1)
  real    :: tmpx, tmpy
  integer :: i, j, k, n, kbot 
  integer :: ip, jq
  integer :: tau

  call mpp_clock_begin(id_clock_psi_modes)

  tau = Time%tau

  psix(:,:,:,:)   = 0.0
  psiy(:,:,:,:)   = 0.0

  ! compute horizontal density gradients 
  ! compute max(agm_array)
  wrk1_v(:,:,:,:) = 0.0
  wrk2_v(:,:,:,:) = 0.0
  wrk3_v(:,:,:,:) = 0.0
  wrk4_v(:,:,:,:) = 0.0
  wrk1_2d(:,:)    = 0.0
  do k=1,nk
     do j=jsc-1,jec
        do i=isc-1,iec   
           do ip=0,1 
              jq=ip
              gradx = drhodT(i+ip,j,k)*dTdx(index_temp)%field(i,j,k) &
                     +drhodS(i+ip,j,k)*dSdx%field(i,j,k) 
              grady = drhodT(i,j+jq,k)*dTdy(index_temp)%field(i,j,k) &
                     +drhodS(i,j+jq,k)*dSdy%field(i,j,k)
              wrk1_v(i,j,k,ip+1) = Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)*gradx
              wrk2_v(i,j,k,jq+1) = Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)*grady
              wrk3_v(i,j,k,ip+1) = Thickness%dzt(i,j,k)*wrk1_v(i,j,k,ip+1)*agm_array(i,j,k) 
              wrk4_v(i,j,k,jq+1) = Thickness%dzt(i,j,k)*wrk2_v(i,j,k,jq+1)*agm_array(i,j,k) 
           enddo
           if(agm_array(i,j,k) > wrk1_2d(i,j)) wrk1_2d(i,j) = agm_array(i,j,k)          
        enddo
     enddo
  enddo

  ! for psi regularization 
  wrk1_2d(:,:) = wrk1_2d(:,:)*smax_psi


  do n=1,number_bc_modes

     do j=jsc-1,jec
        do i=isc-1,iec

           kbot = Grd%kmt(i,j)
           if(kbot > 1) then  

               ! projection of agm*grad_rho onto baroclinic modes, 
               ! integrated over the depth of an ocean column. 
               ! project_x and project_y have dimensions kg/(m*sec) 
               project_x(:)=0.0 
               project_y(:)=0.0 
               do k=1,kbot 
                  do ip=0,1 
                     jq=ip
                     project_x(ip) = project_x(ip) + bc_mode(i,j,k,n)*wrk3_v(i,j,k,ip+1)
                     project_y(jq) = project_y(jq) + bc_mode(i,j,k,n)*wrk4_v(i,j,k,jq+1)
                  enddo
               enddo

               ! compute the vector streamfunction (m^2/sec)
               do ip=0,1 
                  jq=ip
                  do k=1,kbot
                     psix(i,j,k,jq) = psix(i,j,k,jq) - rho0r*bc_mode(i,j,k,n)*project_y(jq)
                     psiy(i,j,k,ip) = psiy(i,j,k,ip) + rho0r*bc_mode(i,j,k,n)*project_x(ip)
                  enddo
               enddo  ! do ip=0,1

           endif   !if(kbot > 1)

        enddo   ! do j
     enddo      ! do i

  enddo   !n=1,number_bc_modes


  ! smooth psi to reduce potentials for checkerboard noise 
  if(smooth_psi) then 

      call mpp_update_domains(psix(:,:,:,:), Dom%domain2d) 
      call mpp_update_domains(psiy(:,:,:,:), Dom%domain2d) 

      do ip=0,1
         jq=ip
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec

                  if(Grd%tmask(i,j,k)==1.0) then 

                      active_cells = 4.0       +&
                           Grd%tmask(i-1,j,k)  +&
                           Grd%tmask(i+1,j,k)  +&
                           Grd%tmask(i,j-1,k)  +&
                           Grd%tmask(i,j+1,k)

                      if (active_cells > 4.0) then
                          wrk1(i,j,k) = & 
                               (4.0*psix(i,j,k,jq) +&
                               psix(i-1,j,k,jq)    +&
                               psix(i+1,j,k,jq)    +&
                               psix(i,j-1,k,jq)    +&
                               psix(i,j+1,k,jq)) / active_cells
                          wrk2(i,j,k) =  &
                               (4.0*psiy(i,j,k,ip) +&
                               psiy(i-1,j,k,ip)    +&
                               psiy(i+1,j,k,ip)    +&
                               psiy(i,j-1,k,ip)    +&
                               psiy(i,j+1,k,ip)) / active_cells

                      else
                          wrk1(i,j,k) = psix(i,j,k,jq)
                          wrk2(i,j,k) = psiy(i,j,k,ip)
                      endif

                  endif

               enddo
            enddo

            do j=jsc,jec
               do i=isc,iec
                  psix(i,j,k,jq) = wrk1(i,j,k)*Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)
                  psiy(i,j,k,ip) = wrk2(i,j,k)*Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)
               enddo
            enddo

         enddo
      enddo

      call mpp_update_domains(psix(:,:,:,:), Dom%domain2d) 
      call mpp_update_domains(psiy(:,:,:,:), Dom%domain2d) 

  endif

  ! regularize the vector streamfunction to keep magnitude 
  ! under control in regions of weak vertical stratification.
  wrk1_v2d(:,:,:) = 1.0
  wrk2_v2d(:,:,:) = 1.0 
  if(regularize_psi) then 

      do ip=0,1
         jq=ip
         do j=jsc-1,jec
            do i=isc-1,iec

               kbot=Grd%kmt(i,j)
               if(kbot > 1) then 

                   wrk1_v2d(i,j,ip+1) = wrk1_2d(i,j)
                   wrk2_v2d(i,j,jq+1) = wrk1_2d(i,j)
                   do k=1,kbot
                      tmpx = abs(psix(i,j,k,jq))
                      tmpy = abs(psiy(i,j,k,ip))
                      if(tmpx > wrk1_v2d(i,j,jq+1)) wrk1_v2d(i,j,jq+1) = tmpx
                      if(tmpy > wrk2_v2d(i,j,ip+1)) wrk2_v2d(i,j,ip+1) = tmpy
                   enddo
                   wrk1_v2d(i,j,jq+1) = wrk1_2d(i,j)/wrk1_v2d(i,j,jq+1)
                   wrk2_v2d(i,j,ip+1) = wrk1_2d(i,j)/wrk2_v2d(i,j,ip+1)

                   do k=1,kbot
                     psix(i,j,k,jq) = psix(i,j,k,jq)*wrk1_v2d(i,j,jq+1) 
                     psiy(i,j,k,ip) = psiy(i,j,k,ip)*wrk2_v2d(i,j,ip+1) 
                   enddo

               endif

            enddo
         enddo
      enddo

  endif

  if(id_rescale_psi_x > 0) then 
     call diagnose_2d(Time, Grd, id_rescale_psi_x, onehalf*(wrk1_v2d(:,:,1)+wrk1_v2d(:,:,2)))
  endif

  if(id_rescale_psi_y > 0) then 
     call diagnose_2d(Time, Grd, id_rescale_psi_y, onehalf*(wrk2_v2d(:,:,1)+wrk2_v2d(:,:,2)))
  endif

  if (id_psix_gm_modes > 0) then 
     call diagnose_3d(Time, Grd, id_psix_gm_modes, onehalf*(psix(:,:,:,0)+psix(:,:,:,1)))
  endif 
  if (id_psiy_gm_modes > 0) then 
     call diagnose_3d(Time, Grd, id_psiy_gm_modes, onehalf*(psiy(:,:,:,0)+psiy(:,:,:,1)))
  endif 

  if(id_gradx_rho > 0) then 
     call diagnose_3d(Time, Grd, id_gradx_rho, onehalf*(wrk1_v(:,:,:,1)+wrk1_v(:,:,:,2)))
  endif
  if(id_grady_rho > 0) then 
     call diagnose_3d(Time, Grd, id_grady_rho, onehalf*(wrk2_v(:,:,:,1)+wrk2_v(:,:,:,2)))
  endif


  ! diagnose mass transports for sending to diagnostic
  tx_trans_gm = 0.0
  ty_trans_gm = 0.0
  if(vert_coordinate_class==DEPTH_BASED) then 
      do k=1,nk
         tx_trans_gm(COMP,k) = &
              -transport_convert*onehalf*(psiy(COMP,k,0)+psiy(COMP,k,1))*Grd%dyte(COMP)*rho0
         ty_trans_gm(COMP,k) = &
              transport_convert*onehalf*(psix(COMP,k,0)+psix(COMP,k,1))*Grd%dxtn(COMP)*rho0
      enddo
  else
      do k=1,nk
         tx_trans_gm(COMP,k) = &
              -transport_convert*onehalf*(psiy(COMP,k,0)+psiy(COMP,k,1))*Grd%dyte(COMP)*Dens%rho(COMP,k,tau)
         ty_trans_gm(COMP,k) = &
              transport_convert*onehalf*(psix(COMP,k,0)+psix(COMP,k,1))*Grd%dxtn(COMP)*Dens%rho(COMP,k,tau)
      enddo
  endif

  ! change signs to agree with convention in nphysicsA and nphysicsB
  call transport_on_rho_gm (Time, Dens, &
       -1.0*tx_trans_gm(:,:,:), -1.0*ty_trans_gm(:,:,:))
  call transport_on_nrho_gm(Time, Dens, &
       -1.0*tx_trans_gm(:,:,:), -1.0*ty_trans_gm(:,:,:))
  call transport_on_theta_gm(Time, Dens, T_prog(index_temp), &
       -1.0*tx_trans_gm(:,:,:), -1.0*ty_trans_gm(:,:,:))

  ! change signs to agree with convention in nphysicsA and nphysicsB
  if (id_tx_trans_gm > 0) then 
     call diagnose_3d(Time, Grd, id_tx_trans_gm, -1.0*tx_trans_gm(:,:,:))
  endif
  if (id_ty_trans_gm > 0) then 
     call diagnose_3d(Time, Grd, id_ty_trans_gm, -1.0*ty_trans_gm(:,:,:))
  endif


  call mpp_clock_end(id_clock_psi_modes)


end subroutine compute_psi_modes
! </SUBROUTINE> NAME="compute_psi_modes"



!#######################################################################
! <SUBROUTINE NAME="compute_psi_bvp">
!
! <DESCRIPTION>
! Compute vector streamfunction by solving a boundary value problem. 
!
! psi is centered on bottom of tracer cell; for example, 
! psi(k=1)=psi at bottom of tracer cell k=1.
! psi vanishes at the ocean surface: psi(k=0)=0
! and ocean bottom: psi(k=kmt)=0.
!
! psix is centred on north face of tracer cell
! psiy is centred on east  face of tracer cell
!
! Solve for psi(k=1,kmt-1) using a tridiagonal solver from 
! Section 2.4 of Press etal 1986.
!
! Units of psi are m^2/sec
!
! </DESCRIPTION>
!
subroutine compute_psi_bvp(Time, Dens, Thickness, T_prog)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_density_type),     intent(in) :: Dens
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)

  real    :: gradx, grady 
  real    :: active_cells
  real    :: dzwtr
  integer :: i, j, k
  integer :: ip, jq
  integer :: tau

  call mpp_clock_begin(id_clock_psi_bvp)

  tau = Time%tau

  ! initialize to zero 
  psix(:,:,:,:) = 0.0
  psiy(:,:,:,:) = 0.0


  ! compute horizontal density gradients and RHS source terms 
  wrk1_v(:,:,:,:) = 0.0
  wrk2_v(:,:,:,:) = 0.0
  wrk3_v(:,:,:,:) = 0.0
  wrk4_v(:,:,:,:) = 0.0
  wrk1_2d(:,:)    = 0.0
  do k=1,nk-1
     do j=jsc-1,jec
        do i=isc-1,iec   
           do ip=0,1 
              jq=ip
              gradx = drhodT(i+ip,j,k)*dTdx(index_temp)%field(i,j,k) &
                     +drhodS(i+ip,j,k)*dSdx%field(i,j,k) 
              grady = drhodT(i,j+jq,k)*dTdy(index_temp)%field(i,j,k) &
                     +drhodS(i,j+jq,k)*dSdy%field(i,j,k)
              wrk1_v(i,j,k,ip+1) = Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)*gradx
              wrk2_v(i,j,k,jq+1) = Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)*grady
              wrk3_v(i,j,k,ip+1) = Grd%tmask(i,j,k+1)*grav_rho0r*wrk1_v(i,j,k,ip+1)*agm_array(i,j,k) 
              wrk4_v(i,j,k,jq+1) = Grd%tmask(i,j,k+1)*grav_rho0r*wrk2_v(i,j,k,jq+1)*agm_array(i,j,k) 
           enddo
        enddo
     enddo
  enddo

  ! intermediate diagnostics 
  if(id_gradx_rho > 0) then 
     call diagnose_3d(Time, Grd, id_gradx_rho, onehalf*(wrk1_v(:,:,:,1)+wrk1_v(:,:,:,2)))
  endif
  if(id_grady_rho > 0) then 
     call diagnose_3d(Time, Grd, id_grady_rho, onehalf*(wrk2_v(:,:,:,1)+wrk2_v(:,:,:,2)))
  endif


  ! a,b,c fields (using Press etal nomenclature) to invert tridiagonal matrix 
  wrk1(:,:,:) = 0.0   ! a
  wrk2(:,:,:) = 0.0   ! b
  wrk3(:,:,:) = 0.0   ! c 
  do k=1,nk-1
     do j=jsc-1,jec
        do i=isc-1,iec    
           dzwtr       = Grd%tmask(i,j,k)*Grd%tmask(i,j,k+1)/(epsln+Thickness%dzwt(i,j,k))          
           wrk1(i,j,k) = bc_speed2(i,j)*dzwtr/(epsln+Thickness%dzt(i,j,k))
           wrk3(i,j,k) = bc_speed2(i,j)*dzwtr/(epsln+Thickness%dzt(i,j,k+1))
           wrk2(i,j,k) = -Grd%tmask(i,j,k)*Grd%tmask(i,j,k+1) &
                          *(bv_freq(i,j,k)*bv_freq(i,j,k) + wrk1(i,j,k) + wrk3(i,j,k))
        enddo
     enddo
  enddo


  ! invert to solve for upsilon_x, and set psiy=-upsilon_x
  wrk1_v = 0.0
  call invtri_bvp(Grd%tmask, wrk1, wrk2, wrk3, wrk3_v, wrk1_v)
  psiy(:,:,:,:) = -wrk1_v(:,:,:,:)    

  ! invert to solve for upsilon_y, and set psix=upsilon_y
  wrk2_v = 0.0
  call invtri_bvp(Grd%tmask, wrk1, wrk2, wrk3, wrk4_v, wrk2_v)    
  psix(:,:,:,:) = wrk2_v(:,:,:,:)    

  ! smooth psi to reduce potentials for checkerboard noise 
  if(smooth_psi) then 

      call mpp_update_domains(psix(:,:,:,:), Dom%domain2d) 
      call mpp_update_domains(psiy(:,:,:,:), Dom%domain2d) 

      do ip=0,1
         jq=ip
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec

                  if(Grd%tmask(i,j,k)==1.0) then 

                      active_cells = 4.0       +&
                           Grd%tmask(i-1,j,k)  +&
                           Grd%tmask(i+1,j,k)  +&
                           Grd%tmask(i,j-1,k)  +&
                           Grd%tmask(i,j+1,k)

                      if (active_cells > 4.0) then
                          wrk1(i,j,k) = & 
                               (4.0*psix(i,j,k,jq) +&
                               psix(i-1,j,k,jq)    +&
                               psix(i+1,j,k,jq)    +&
                               psix(i,j-1,k,jq)    +&
                               psix(i,j+1,k,jq)) / active_cells
                          wrk2(i,j,k) =  &
                               (4.0*psiy(i,j,k,ip) +&
                               psiy(i-1,j,k,ip)    +&
                               psiy(i+1,j,k,ip)    +&
                               psiy(i,j-1,k,ip)    +&
                               psiy(i,j+1,k,ip)) / active_cells

                      else
                          wrk1(i,j,k) = psix(i,j,k,jq)
                          wrk2(i,j,k) = psiy(i,j,k,ip)
                      endif

                  endif

               enddo
            enddo

            do j=jsc,jec
               do i=isc,iec
                  psix(i,j,k,jq) = wrk1(i,j,k)*Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)
                  psiy(i,j,k,ip) = wrk2(i,j,k)*Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)
               enddo
            enddo

         enddo
      enddo

      call mpp_update_domains(psix(:,:,:,:), Dom%domain2d) 
      call mpp_update_domains(psiy(:,:,:,:), Dom%domain2d) 

  endif


  ! diagnostics 
  if (id_psix_gm_bvp > 0) then 
     call diagnose_3d(Time, Grd, id_psix_gm_bvp, onehalf*(psix(:,:,:,0)+psix(:,:,:,1)))
  endif 
  if (id_psiy_gm_bvp > 0) then 
     call diagnose_3d(Time, Grd, id_psiy_gm_bvp, onehalf*(psiy(:,:,:,0)+psiy(:,:,:,1)))
  endif 

  ! diagnose mass transports for sending to diagnostic
  tx_trans_gm = 0.0
  ty_trans_gm = 0.0
  if(vert_coordinate_class==DEPTH_BASED) then 
      do k=1,nk
         tx_trans_gm(COMP,k) = &
              -transport_convert*onehalf*(psiy(COMP,k,0)+psiy(COMP,k,1))*Grd%dyte(COMP)*rho0
         ty_trans_gm(COMP,k) = &
              transport_convert*onehalf*(psix(COMP,k,0)+psix(COMP,k,1))*Grd%dxtn(COMP)*rho0
      enddo
  else
      do k=1,nk
         tx_trans_gm(COMP,k) = &
              -transport_convert*onehalf*(psiy(COMP,k,0)+psiy(COMP,k,1))*Grd%dyte(COMP)*Dens%rho(COMP,k,tau)
         ty_trans_gm(COMP,k) = &
              transport_convert*onehalf*(psix(COMP,k,0)+psix(COMP,k,1))*Grd%dxtn(COMP)*Dens%rho(COMP,k,tau)
      enddo
  endif

  ! change signs to agree with convention in nphysicsA and nphysicsB
  call transport_on_rho_gm (Time, Dens, &
       -1.0*tx_trans_gm(:,:,:), -1.0*ty_trans_gm(:,:,:))
  call transport_on_nrho_gm(Time, Dens, &
       -1.0*tx_trans_gm(:,:,:), -1.0*ty_trans_gm(:,:,:))
  call transport_on_theta_gm(Time, Dens, T_prog(index_temp), &
       -1.0*tx_trans_gm(:,:,:), -1.0*ty_trans_gm(:,:,:))


  ! change signs to agree with convention in nphysicsA and nphysicsB
  if (id_tx_trans_gm > 0) then 
     call diagnose_3d(Time, Grd, id_tx_trans_gm, -1.0*tx_trans_gm(:,:,:))
  endif
  if (id_ty_trans_gm > 0) then 
     call diagnose_3d(Time, Grd, id_ty_trans_gm, -1.0*ty_trans_gm(:,:,:))
  endif

  if(diag_advect_transport) then 
     call compute_advect_transport(Time, Dens, Thickness)
  endif 


  call mpp_clock_end(id_clock_psi_bvp)


end subroutine compute_psi_bvp
! </SUBROUTINE> NAME="compute_psi_bvp"


!#######################################################################
! <SUBROUTINE NAME="fz_terms">
!
! <DESCRIPTION>
! Subroutine computes the tracer independent pieces of the vertical 
! flux component. As a result of this routine, 
! Array tensor_31 = x-diffusivity*slope (m^2/sec) for fz
! Array tensor_32 = y-diffusivity*slope (m^2/sec) for fz 
!
! K33 is the (3,3) term in small angle Redi diffusion tensor.
! It is broken into an explicit in time piece and implicit 
! in time piece.  It is weighted by density for non-Boussinesq
! and rho0 for Boussinesq.  
!
! K33 has units (kg/m^3)*m^2/sec.
!
! Also will compute the squared Eady growth rate, with the maximum
! slope contributing to this growth rate set by smax.
!
! This routine is nearly the same as in ocean_nphysicsA, except 
! for the following changes: 
! 1/ the routine here removes all pieces related to GM-skewsion.  
! 2/ the routine here uses Thickness%depth_zwt rather than Grd%zt. 
!
! </DESCRIPTION>
!
subroutine fz_terms(Time, Thickness, T_prog, rho)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  real, dimension(isd:,jsd:,:), intent(in)    :: rho

  integer :: i, j, k, n, ip, jq, kr, tau

  real :: baroclinic_triad, K33, K33_crit
  real :: sumx(0:1), sumy(0:1)

  real :: slope, absslope, depth_ratio
  real :: taperA, taperB
  real :: taper_slope, taper_slope2

  real :: aredi_scalar
  real :: absdrhodzb(0:1)
  real :: mindelqc(0:1,0:1), delqc_ijk_1, delqc_ijkp1_0

  call mpp_clock_begin(id_clock_fz_terms)

  tau = Time%tau

  eady_termx(:,:,:)     = 0.0
  eady_termy(:,:,:)     = 0.0
  baroclinic_termx(:,:) = 0.0
  baroclinic_termy(:,:) = 0.0

  ! Main loop. Short ip,jq,kr loops are explicitly unrolled
  ! in order to expose independence and allow vectorisation

  do k=1,nk-1
     do j=jsc,jec
        do i=isc,iec

           aredi_scalar  = aredi_array(i,j,k)

           absdrhodzb(0) = abs(drhodzb(i,j,k,0))
           absdrhodzb(1) = abs(drhodzb(i,j,k,1))

           delqc_ijk_1      = delqc(i,j,k,1)
           delqc_ijkp1_0    = delqc(i,j,k+1,0)

           !mindelqc(ip,kr) = min(delqc(i-1+ip,j,k+kr,1-kr),delqc(i+ip,j,k+kr,1-kr)) 
           ip=0 ; kr=0
           mindelqc(ip,kr)  = min(delqc(i-1,j,k,1),delqc_ijk_1) 
           ip=0 ; kr=1
           mindelqc(ip,kr)  = min(delqc(i-1,j,k+1,0),delqc_ijkp1_0) 
           ip=1 ; kr=0
           mindelqc(ip,kr)  = min(delqc_ijk_1,delqc(i+1,j,k,1)) 
           ip=1 ; kr=1
           mindelqc(ip,kr)  = min(delqc_ijkp1_0,delqc(i+1,j,k+1,0)) 

           baroclinic_triad = 0.0

           ip=0   
           sumx(ip) = 0.0

           kr=0
           slope    = tensor_31(i,j,k,ip,kr)
           absslope = abs(slope)

           ! taper for steep slope regions 
           if(absslope > smax) then 
               taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
               taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
           else 
               taperA = 1.0
           endif

           ! taper for grid depths shallower than eddy_depth
           if(eddy_depth(i,j) >= Thickness%depth_zwt(i,j,k)) then                                           
               depth_ratio     = Thickness%depth_zwt(i,j,k)/(epsln+eddy_depth(i,j))
               taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
           else 
               taperB          = 1.0
           endif

           ! taper times slope for use with neutral diffusion
           taper_slope  = taperA*taperB*slope
           taper_slope2 = slope*taper_slope

           tensor_31(i,j,k,ip,kr) = aredi_scalar*taper_slope
           sumx(ip)               = sumx(ip)         + mindelqc(ip,kr)*taper_slope2
           eady_termx(i,j,k)      = eady_termx(i,j,k)+ absdrhodzb(kr)*absslope*absslope
           baroclinic_triad       = baroclinic_triad + absdrhodzb(kr)*abs(taper_slope)

           kr=1
           slope    = tensor_31(i,j,k,ip,kr)
           absslope = abs(slope)

           ! taper for steep slope regions 
           if(absslope > smax) then 
               taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
               taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
           else 
               taperA = 1.0
           endif

           ! taper for grid depths shallower than eddy_depth
           if(eddy_depth(i,j) >= Thickness%depth_zwt(i,j,k)) then                                           
               depth_ratio     = Thickness%depth_zwt(i,j,k)/(epsln+eddy_depth(i,j))
               taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
           else 
               taperB          = 1.0
           endif

           ! taper times slope for use with neutral diffusion
           taper_slope  = taperA*taperB*slope
           taper_slope2 = slope*taper_slope

           tensor_31(i,j,k,ip,kr) = aredi_scalar*taper_slope
           sumx(ip)               = sumx(ip)         + mindelqc(ip,kr)*taper_slope2
           eady_termx(i,j,k)      = eady_termx(i,j,k)+ absdrhodzb(kr)*absslope*absslope
           baroclinic_triad       = baroclinic_triad + absdrhodzb(kr)*abs(taper_slope)
           sumx(ip)               = sumx(ip)*dtew(i,j,ip)

           ip=1   
           sumx(ip) = 0.0

           kr=0
           slope        = tensor_31(i,j,k,ip,kr)
           absslope     = abs(slope)

           ! taper for steep slope regions 
           if(absslope > smax) then 
               taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
               taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
           else 
               taperA = 1.0
           endif

           ! taper for grid depths shallower than eddy_depth
           if(eddy_depth(i,j) >= Thickness%depth_zwt(i,j,k)) then                                           
               depth_ratio     = Thickness%depth_zwt(i,j,k)/(epsln+eddy_depth(i,j))
               taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
           else 
               taperB          = 1.0
           endif

           ! taper times slope for use with neutral diffusion
           taper_slope  = taperA*taperB*slope
           taper_slope2 = slope*taper_slope

           tensor_31(i,j,k,ip,kr) = aredi_scalar*taper_slope
           sumx(ip)               = sumx(ip)         + mindelqc(ip,kr)*taper_slope2
           eady_termx(i,j,k)      = eady_termx(i,j,k)+ absdrhodzb(kr)*absslope*absslope
           baroclinic_triad       = baroclinic_triad + absdrhodzb(kr)*abs(taper_slope)

           kr=1
           slope        = tensor_31(i,j,k,ip,kr)
           absslope     = abs(slope)

           ! taper for steep slope regions 
           if(absslope > smax) then 
               taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
               taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
           else 
               taperA = 1.0
           endif

           ! taper for grid depths shallower than eddy_depth
           if(eddy_depth(i,j) >= Thickness%depth_zwt(i,j,k)) then                                           
               depth_ratio     = Thickness%depth_zwt(i,j,k)/(epsln+eddy_depth(i,j))
               taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
           else 
               taperB          = 1.0
           endif

           ! taper times slope for use with neutral diffusion
           taper_slope  = taperA*taperB*slope
           taper_slope2 = slope*taper_slope

           tensor_31(i,j,k,ip,kr) = aredi_scalar*taper_slope
           sumx(ip)               = sumx(ip)         + mindelqc(ip,kr)*taper_slope2
           eady_termx(i,j,k)      = eady_termx(i,j,k)+ absdrhodzb(kr)*absslope*absslope
           baroclinic_triad       = baroclinic_triad + absdrhodzb(kr)*abs(taper_slope)
           sumx(ip)               = sumx(ip)*dtew(i,j,ip)

           if(Thickness%depth_zwt(i,j,k) >= agm_closure_upper_depth .and. &
              Thickness%depth_zwt(i,j,k) <= agm_closure_lower_depth) then 
              baroclinic_termx(i,j) = baroclinic_termx(i,j) + baroclinic_triad*Thickness%dzwt(i,j,k)
           endif
   
           !mindelqc(jq,kr) = min(delqc(i,j-1+jq,k+kr,1-kr),delqc(i,j+jq,k+kr,1-kr)) 
           jq=0 ; kr=0
           mindelqc(jq,kr)  = min(delqc(i,j-1,k,1),delqc_ijk_1) 
           jq=0 ; kr=1
           mindelqc(jq,kr)  = min(delqc(i,j-1,k+1,0),delqc_ijkp1_0) 
           jq=1 ; kr=0
           mindelqc(jq,kr)  = min(delqc_ijk_1,delqc(i,j+1,k,1)) 
           jq=1 ; kr=1
           mindelqc(jq,kr)  = min(delqc_ijkp1_0,delqc(i,j+1,k+1,0)) 

           baroclinic_triad = 0.0 

           jq=0   
           sumy(jq) = 0.0

           kr=0
           slope      = tensor_32(i,j,k,jq,kr)
           absslope   = abs(slope)

           ! taper for steep slope regions 
           if(absslope > smax) then 
               taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
               taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
           else 
               taperA = 1.0
           endif

           ! taper for grid depths shallower than eddy_depth
           if(eddy_depth(i,j) >= Thickness%depth_zwt(i,j,k)) then                                           
               depth_ratio     = Thickness%depth_zwt(i,j,k)/(epsln+eddy_depth(i,j))
               taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
           else 
               taperB          = 1.0
           endif

           ! taper times slope for use with neutral diffusion
           taper_slope  = taperA*taperB*slope
           taper_slope2 = slope*taper_slope

           tensor_32(i,j,k,jq,kr) = aredi_scalar*taper_slope
           sumy(jq)               = sumy(jq)         + mindelqc(jq,kr)*taper_slope2
           eady_termy(i,j,k)      = eady_termy(i,j,k)+ absdrhodzb(kr)*absslope*absslope
           baroclinic_triad       = baroclinic_triad + absdrhodzb(kr)*abs(taper_slope)

           kr=1
           slope        = tensor_32(i,j,k,jq,kr)
           absslope     = abs(slope)

           ! taper for steep slope regions 
           if(absslope > smax) then 
               taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
               taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
           else 
               taperA = 1.0
           endif

           ! taper for grid depths shallower than eddy_depth
           if(eddy_depth(i,j) >= Thickness%depth_zwt(i,j,k)) then                                           
               depth_ratio     = Thickness%depth_zwt(i,j,k)/(epsln+eddy_depth(i,j))
               taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
           else 
               taperB          = 1.0
           endif

           ! taper times slope for use with neutral diffusion
           taper_slope  = taperA*taperB*slope
           taper_slope2 = slope*taper_slope

           tensor_32(i,j,k,jq,kr) = aredi_scalar*taper_slope
           sumy(jq)               = sumy(jq)         + mindelqc(jq,kr)*taper_slope2
           eady_termy(i,j,k)      = eady_termy(i,j,k)+ absdrhodzb(kr)*absslope*absslope
           baroclinic_triad       = baroclinic_triad + absdrhodzb(kr)*abs(taper_slope)
           sumy(jq)               = sumy(jq)*dtns(i,j,jq)

           jq=1   
           sumy(jq) = 0.0

           kr=0
           slope    = tensor_32(i,j,k,jq,kr)
           absslope = abs(slope)

           ! taper for steep slope regions 
           if(absslope > smax) then 
               taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
               taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
           else 
               taperA = 1.0
           endif

           ! taper for grid depths shallower than eddy_depth
           if(eddy_depth(i,j) >= Thickness%depth_zwt(i,j,k)) then                                           
               depth_ratio     = Thickness%depth_zwt(i,j,k)/(epsln+eddy_depth(i,j))
               taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
           else 
               taperB          = 1.0
           endif

           ! taper times slope for use with neutral diffusion
           taper_slope  = taperA*taperB*slope
           taper_slope2 = slope*taper_slope

           tensor_32(i,j,k,jq,kr) = aredi_scalar*taper_slope
           sumy(jq)               = sumy(jq)         + mindelqc(jq,kr)*taper_slope2
           eady_termy(i,j,k)      = eady_termy(i,j,k)+ absdrhodzb(kr)*absslope*absslope
           baroclinic_triad       = baroclinic_triad + absdrhodzb(kr)*abs(taper_slope)

           kr=1
           slope    = tensor_32(i,j,k,jq,kr)
           absslope = abs(slope)

           ! taper for steep slope regions 
           if(absslope > smax) then 
               taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
               taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
           else 
               taperA = 1.0
           endif

           ! taper for grid depths shallower than eddy_depth
           if(eddy_depth(i,j) >= Thickness%depth_zwt(i,j,k)) then                                           
               depth_ratio     = Thickness%depth_zwt(i,j,k)/(epsln+eddy_depth(i,j))
               taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
           else 
               taperB          = 1.0
           endif

           ! taper times slope for use with neutral diffusion
           taper_slope  = taperA*taperB*slope
           taper_slope2 = slope*taper_slope

           tensor_32(i,j,k,jq,kr) = aredi_scalar*taper_slope
           sumy(jq)               = sumy(jq)         + mindelqc(jq,kr)*taper_slope2
           eady_termy(i,j,k)      = eady_termy(i,j,k)+ absdrhodzb(kr)*absslope*absslope
           baroclinic_triad       = baroclinic_triad + absdrhodzb(kr)*abs(taper_slope)

           sumy(jq) = sumy(jq)*dtns(i,j,jq)

           if(Thickness%depth_zwt(i,j,k) >= agm_closure_upper_depth .and. &
              Thickness%depth_zwt(i,j,k) <= agm_closure_lower_depth) then 
               baroclinic_termy(i,j) = baroclinic_termy(i,j) + baroclinic_triad*Thickness%dzwt(i,j,k)
           endif

           K33 = aredi_scalar*Grd%tmask(i,j,k+1)*(Grd%dxtr(i,j)*(sumx(0)+sumx(1)) &
                + Grd%dytr(i,j)*(sumy(0)+sumy(1)))*dzwtr(i,j,k)

           ! determine part of K33 included explicitly in time and that part implicitly. 
           ! explicit calculation is more accurate than implicit, so aim to compute as much 
           ! as stably possible via the explicit method. 
           K33_explicit(i,j,k) = K33
           K33_implicit(i,j,k) = 0.0 
           if(.not. diffusion_all_explicit) then 
               K33_crit = two_dtime_inv*Thickness%rho_dzt(i,j,k,tau)*Thickness%dzt(i,j,k)
               if(K33 >= K33_crit) then 
                   K33_explicit(i,j,k) = K33_crit
                   K33_implicit(i,j,k) = K33-K33_crit
               endif
           endif

        enddo
     enddo
  enddo

  if(tmask_neutral_on) then
      do j=jsc,jec
         do i=isc,iec
            K33_implicit(i,j,1) = 0.0  
            K33_explicit(i,j,1) = 0.0  
            if(Grd%kmt(i,j) > 1) then 
                k = Grd%kmt(i,j)-1
                K33_implicit(i,j,k) = 0.0
                K33_explicit(i,j,k) = 0.0
            endif
         enddo
      enddo
  endif

  do n=1,num_prog_tracers 
     T_prog(n)%K33_implicit(:,:,:) = K33_implicit(:,:,:)
  enddo
  if(neutral_physics_limit) then 
      do n=1,num_prog_tracers 
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  if(T_prog(n)%tmask_limit(i,j,k)==1.0) T_prog(n)%K33_implicit(i,j,k) = 0.0
               enddo
            enddo
         enddo
      enddo
  endif


  do n=1,num_prog_tracers
     if (id_k33_implicit(n) > 0) then
        call diagnose_3d(Time, Grd, id_k33_implicit(n), rho0r*T_prog(n)%K33_implicit(:,:,:))
     endif
  enddo

  if(id_N_squared > 0) then 
      wrk2(:,:,:)=0.0
      do k=1,nk
         wrk2(:,:,k) = 1.0/(epsln + rho(:,:,k)) 
         wrk2(:,:,k) = -onehalf*grav*(drhodzb(:,:,k,0)+drhodzb(:,:,k,1))*wrk2(:,:,k)
      enddo
      call diagnose_3d(Time, Grd, id_N_squared, wrk2(:,:,:))
  endif

  call mpp_clock_end(id_clock_fz_terms)

end subroutine fz_terms
! </SUBROUTINE>  NAME="fz_terms"


!#######################################################################
! <SUBROUTINE NAME="fx_flux_ndiffuse">
!
! <DESCRIPTION>
! Subroutine computes the zonal neutral diffusion tracer flux component.
! Compute this component for all tracers at level k.
!
! fx has physical dimensions (area*diffusivity*density*tracer gradient)
!
! This routine is the same as that in ocean_nphysicsA, except 
! for the following changes: 
! 1/ the routine here removes all pieces related to GM-skewsion.  
! 2/ the routine here uses Thickness%depth_zwt rather than Grd%zt. 
! 3/ ah_array is removed.
!
! </DESCRIPTION>
!
subroutine fx_flux_ndiffuse(Time, Thickness, T_prog, k)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer,                      intent(in) :: k

  integer :: i, j, n, ip, tau
  integer :: kr, kpkr
  real    :: tensor_11(isd:ied,jsd:jed,0:1,0:1)
  real    :: tensor_13(isd:ied,jsd:jed,0:1,0:1)
  real    :: sumz(isd:ied,jsd:jed,0:1)
  real    :: taperA, taperB
  real    :: slope, absslope, taper_slope
  real    :: depth_ratio
  real    :: drhodx, drhodz 

  tau = Time%tau

  ! initialize arrays to zero 
  tensor_11(:,:,:,:) = 0.0
  tensor_13(:,:,:,:) = 0.0

  ! tracer-independent part of the calculation 
  do kr=0,1
     kpkr = min(k+kr,nk)
     do ip=0,1 
        do j=jsc,jec
           do i=isc-1,iec

              drhodz   = drhodzh(i+ip,j,k,kr)
              drhodx   = Grd%tmask(i+ip,j,kpkr)                            &
                        *( drhodT(i+ip,j,k)*dTdx(index_temp)%field(i,j,k)  &
                          +drhodS(i+ip,j,k)*dSdx%field(i,j,k))
              slope    = -drhodx/drhodz
              absslope = abs(slope)

              ! taper for steep slope regions 
              if(absslope > smax) then 
                  taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                  taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
              else 
                  taperA = 1.0
              endif

              ! taper for grid depths shallower than eddy_depth
              if(eddy_depth(i,j) >= Thickness%depth_zwt(i,j,k)) then                                           
                  depth_ratio     = Thickness%depth_zwt(i,j,k)/(epsln+eddy_depth(i,j))
                  taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
              else 
                  taperB          = 1.0
              endif

              ! taper times slope for use with neutral diffusion
              taper_slope  = taperA*taperB*slope

              ! fill tensor components 
              tensor_11(i,j,ip,kr) = aredi_array(i,j,k) 
              tensor_13(i,j,ip,kr) = aredi_array(i,j,k)*taper_slope

           enddo
        enddo
     enddo
  enddo

  ! tracer-dependent part of the calculation
  do n=1,num_prog_tracers
     sumz(:,:,:) = 0.0
     do kr=0,1
        do ip=0,1
           do j=jsc,jec
              do i=isc-1,iec
                sumz(i,j,kr) = sumz(i,j,kr) + dtwedyt(i,j,ip)*Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k) &
                *(tensor_11(i,j,ip,kr)*dTdx(n)%field(i,j,k) + tensor_13(i,j,ip,kr)*dTdz(n)%field(i+ip,j,k-1+kr)) &
                * min(delqc(i,j,k,kr),delqc(i+1,j,k,kr))
              enddo
           enddo
        enddo
     enddo
     flux_x(n)%field(COMPXL,k) = Grd%dxter(COMPXL)*(sumz(COMPXL,0)+sumz(COMPXL,1))
  enddo

  ! apply some masks 
  if(tmask_neutral_on) then
     do n=1,num_prog_tracers
        do j=jsc,jec
           do i=isc-1,iec
              if(k==Grd%kmt(i,j)) then
                flux_x(n)%field(i,j,k) = aredi_array(i,j,k)*dTdx(n)%field(i,j,k)*Grd%dyte(i,j)* &
                                          min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i+1,j,k,tau))
              endif
           enddo
        enddo
     enddo
     if(k==1) then
         do n=1,num_prog_tracers
            flux_x(n)%field(:,:,k) = aredi_array(:,:,k)*dTdx(n)%field(:,:,k)*Grd%dyte(:,:) &
                                      *FMX(Thickness%rho_dzt(:,:,k,tau))
         enddo
     endif
  endif

 if(neutral_physics_limit) then 
     do n=1,num_prog_tracers
        do j=jsc,jec
           do i=isc-1,iec
              if(T_prog(n)%tmask_limit(i,j,k)==1.0) then 
                  flux_x(n)%field(i,j,k) = aredi_array(i,j,k)*dTdx(n)%field(i,j,k)*Grd%dyte(i,j) &
                                            *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i+1,j,k,tau))
              endif
           enddo
        enddo
     enddo
 endif

end subroutine fx_flux_ndiffuse
! </SUBROUTINE> NAME="fx_flux_ndiffuse"



!#######################################################################
! <SUBROUTINE NAME="fy_flux_ndiffuse">
!
! <DESCRIPTION>
! Subroutine computes the meridional neutral diffusion tracer flux component.
! Compute this component for all tracers at level k.
!
! fy has physical dimensions (area*diffusivity*density*tracer gradient)
!
! This routine is the same as that in ocean_nphysicsA, except 
! for the following changes: 
! 1/ the routine here removes all pieces related to GM-skewsion.  
! 2/ the routine here uses Thickness%depth_zwt rather than Grd%zt. 
! 3/ ah_array is removed.
!
! </DESCRIPTION>
!
subroutine fy_flux_ndiffuse(Time, Thickness, T_prog, k)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer,                      intent(in) :: k

  integer :: i, j, n, jq, tau
  integer :: kr, kpkr
  real :: tensor_22(isd:ied,jsd:jed,0:1,0:1)
  real :: tensor_23(isd:ied,jsd:jed,0:1,0:1)
  real :: sumz(isd:ied,jsd:jed,0:1)
  real :: taperA, taperB
  real :: slope, absslope, taper_slope
  real :: depth_ratio
  real :: drhody, drhodz 

  tau = Time%tau 

  ! initialize arrays to zero 
  tensor_22(:,:,:,:) = 0.0
  tensor_23(:,:,:,:) = 0.0

  ! tracer-independent part of the calculation 
  do kr=0,1
     kpkr = min(k+kr,nk)
     do jq=0,1  
       do j=jsc-1,jec
          do i=isc,iec
 
              drhodz   = drhodzh(i,j+jq,k,kr) 
              drhody   = Grd%tmask(i,j+jq,kpkr)                            &
                        *( drhodT(i,j+jq,k)*dTdy(index_temp)%field(i,j,k)  &
                          +drhodS(i,j+jq,k)*dSdy%field(i,j,k)) 
              slope    = -drhody/drhodz
              absslope = abs(slope)  

              ! taper for steep slope regions 
              if(absslope > smax) then 
                  taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                  taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
              else 
                  taperA = 1.0
              endif

              ! taper for grid depths shallower than eddy_depth
              if(eddy_depth(i,j) >= Thickness%depth_zwt(i,j,k)) then                                           
                  depth_ratio     = Thickness%depth_zwt(i,j,k)/(epsln+eddy_depth(i,j))
                  taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
              else 
                  taperB          = 1.0
              endif

              ! taper times slope for use with neutral diffusion
              taper_slope  = taperA*taperB*slope

              ! fill tensor components 
              tensor_22(i,j,jq,kr) = aredi_array(i,j,k)
              tensor_23(i,j,jq,kr) = aredi_array(i,j,k)*taper_slope

           enddo
        enddo
     enddo
  enddo

  ! tracer-dependent part of the calculation
  do n=1,num_prog_tracers
     sumz(:,:,:) = 0.0
     do kr=0,1
        do jq=0,1
           do j=jsc-1,jec
              do i=isc,iec
                 sumz(i,j,kr) = sumz(i,j,kr) + dxtdtsn(i,j,jq)*Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k) &
                 *(tensor_22(i,j,jq,kr)*dTdy(n)%field(i,j,k) + tensor_23(i,j,jq,kr)*dTdz(n)%field(i,j+jq,k-1+kr)) &
                 * min(delqc(i,j,k,kr),delqc(i,j+1,k,kr))
              enddo
           enddo
        enddo
     enddo
     flux_y(n)%field(COMPYL,k) = Grd%dytnr(COMPYL)*(sumz(COMPYL,0)+sumz(COMPYL,1))
  enddo


  ! apply some masks 
  if(tmask_neutral_on) then
     do n=1,num_prog_tracers
        do j=jsc-1,jec
           do i=isc,iec
              if(k==Grd%kmt(i,j)) then
                 flux_y(n)%field(i,j,k) = aredi_array(i,j,k)*dTdy(n)%field(i,j,k)*Grd%dxtn(i,j) &
                               *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i,j+1,k,tau))
              endif
           enddo
        enddo
     enddo
     if(k==1) then
         do n=1,num_prog_tracers
            flux_y(n)%field(:,:,k) = &
            aredi_array(:,:,k)*dTdy(n)%field(:,:,k)*Grd%dxtn(:,:)*FMY(Thickness%rho_dzt(:,:,k,tau))
         enddo
     endif
  endif

  if(neutral_physics_limit) then 
      do n=1,num_prog_tracers
         do j=jsc-1,jec
            do i=isc,iec
               if(T_prog(n)%tmask_limit(i,j,k)==1.0) then 
                   flux_y(n)%field(i,j,k) = aredi_array(i,j,k)*dTdy(n)%field(i,j,k)*Grd%dxtn(i,j) &
                                   *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i,j+1,k,tau))
               endif
            enddo
         enddo
      enddo
  endif

end subroutine fy_flux_ndiffuse
! </SUBROUTINE> NAME="fy_flux_ndiffuse"


!#######################################################################
! <SUBROUTINE NAME="fz_flux_ndiffuse">
!
! <DESCRIPTION>
! Subroutine computes the vertical neutral diffusion tracer flux component.
! Compute this component for all tracers at level k.
! Surface and bottom boundary condition fz(k=0)=fz(k=kmt(i,j))=0
!
! fz has physical dimensions (density*diffusivity*tracer gradient)
!
! This is nearly the same as the subroutine in ocean_nphysicsA. 
!
! </DESCRIPTION>
!
subroutine fz_flux_ndiffuse(T_prog, k)

  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer, intent(in) :: k

  integer :: i, j, n, ip, jq, kr
  real :: sumx_0, sumx_1, sumy_0, sumy_1
  real :: temparray31(isc:iec,jsc:jec,0:1,0:1)
  real :: temparray32(isc:iec,jsc:jec,0:1,0:1)

  if(tmask_neutral_on .and. k==1) then
     do n=1,num_prog_tracers
       fz2(n)%field(:,:)      = 0.0 
       flux_z(n)%field(:,:,k) = 0.0 ! for diagnostics only 
      enddo
      return 
  endif

  if(k==nk) then 
     do n=1,num_prog_tracers
        fz2(n)%field(COMP)     = 0.0
        flux_z(n)%field(:,:,k) = 0.0 ! for diagnostics only 
     enddo
     return  

  elseif(k < nk) then  

      ! tracer-independent part of the calculation 
      do kr=0,1
         do ip=0,1
            do j=jsc,jec
               do i=isc,iec
                  temparray31(i,j,ip,kr) = tensor_31(i,j,k,ip,kr)*dtew(i,j,ip) &
                       *min(delqc(i-1+ip,j,k+kr,1-kr),delqc(i+ip,j,k+kr,1-kr))
               enddo
            enddo
         enddo
         do jq=0,1
            do j=jsc,jec
               do i=isc,iec
                  temparray32(i,j,jq,kr) = tensor_32(i,j,k,jq,kr)*dtns(i,j,jq) &
                       *min(delqc(i,j-1+jq,k+kr,1-kr),delqc(i,j+jq,k+kr,1-kr))  
               enddo
            enddo
         enddo
      enddo

      ! tracer-dependent part of the calculation  
      do n=1,num_prog_tracers
         do j=jsc,jec
            do i=isc,iec
               sumx_0 =  temparray31(i,j,0,0)*dTdx(n)%field(i-1,j,k) &
                      +  temparray31(i,j,0,1)*dTdx(n)%field(i-1,j,k+1)
               sumx_1 =  temparray31(i,j,1,0)*dTdx(n)%field(i,j,k) &
                      +  temparray31(i,j,1,1)*dTdx(n)%field(i,j,k+1)
               sumy_0 =  temparray32(i,j,0,0)*dTdy(n)%field(i,j-1,k) &
                      +  temparray32(i,j,0,1)*dTdy(n)%field(i,j-1,k+1)
               sumy_1 =  temparray32(i,j,1,0)*dTdy(n)%field(i,j,k) &
                      +  temparray32(i,j,1,1)*dTdy(n)%field(i,j,k+1)

               ! compute time explicit portion of the vertical flux
               fz2(n)%field(i,j) =   Grd%tmask(i,j,k+1) &
                    *( Grd%dxtr(i,j)*(sumx_0+sumx_1)    &
                      +Grd%dytr(i,j)*(sumy_0+sumy_1))   &
                    *dzwtr(i,j,k) &
                    + K33_explicit(i,j,k)*dTdz(n)%field(i,j,k)
            enddo
         enddo
      enddo
      
      if(tmask_neutral_on) then
          do n=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(k==(Grd%kmt(i,j)-1))  fz2(n)%field(i,j) = 0.0
                enddo
             enddo
          enddo
      endif

      if(neutral_physics_limit) then 
          do n=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(T_prog(n)%tmask_limit(i,j,k)==1.0) fz2(n)%field(i,j) = 0.0  
                enddo
             enddo
          enddo
      endif

      ! save for diagnostics; include full K33 contribution 
      do n=1,num_prog_tracers
         do j=jsc,jec
            do i=isc,iec
               flux_z(n)%field(i,j,k) = fz2(n)%field(i,j) + K33_implicit(i,j,k)*dTdz(n)%field(i,j,k)
            enddo
         enddo
      enddo

  endif  !if-test for k-level 


end subroutine fz_flux_ndiffuse
! </SUBROUTINE> NAME="fz_flux_ndiffuse"


!#######################################################################
! <SUBROUTINE NAME="fx_flux_gm">
!
! <DESCRIPTION>
! Subroutine computes the zonal GM tracer flux component.
! Compute this component for all tracers at level k.
!
! fx has physical dimensions (area*diffusivity*density*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fx_flux_gm

  integer :: i, j, k, n
  integer :: ip, kr
  real    :: tensor_13(isd:ied,jsd:jed,0:1)
  real    :: sumz(isd:ied,jsd:jed,0:1)

  do k=1,nk

     ! tracer-independent part of the calculation 
     tensor_13(:,:,:) = 0.0
     do ip=0,1 
        tensor_13(COMPXL,ip) = -psiy(COMPXL,k,ip)
     enddo

     ! tracer-dependent part of the calculation
     do n=1,num_prog_tracers 
        sumz(:,:,:) = 0.0
        do kr=0,1
           do ip=0,1
              do j=jsc,jec
                 do i=isc-1,iec
                    sumz(i,j,kr) = sumz(i,j,kr) + dtwedyt(i,j,ip)*Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k) &
                         *tensor_13(i,j,ip)*dTdz(n)%field(i+ip,j,k-1+kr)                              &
                         *min(delqc(i,j,k,kr),delqc(i+1,j,k,kr))
                 enddo
              enddo
           enddo
        enddo
        flux_x(n)%field(COMPXL,k) = Grd%dxter(COMPXL)*(sumz(COMPXL,0)+sumz(COMPXL,1))
     enddo

  enddo
  

end subroutine fx_flux_gm
! </SUBROUTINE> NAME="fx_flux_gm"



!#######################################################################
! <SUBROUTINE NAME="fy_flux_gm">
!
! <DESCRIPTION>
! Subroutine computes the meridional GM tracer flux component.
! Compute this component for all tracers at level k.
!
! fy has physical dimensions (area*diffusivity*density*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fy_flux_gm

  integer :: i, j, k, n
  integer :: jq, kr
  real    :: tensor_23(isd:ied,jsd:jed,0:1)
  real    :: sumz(isd:ied,jsd:jed,0:1)


  do k=1,nk

     ! tracer-independent part of the calculation 
     tensor_23(:,:,:) = 0.0
     do jq=0,1  
        tensor_23(COMPYL,jq) = psix(COMPYL,k,jq)
     enddo

     ! tracer-dependent part of the calculation
     do n=1,num_prog_tracers

        sumz(:,:,:) = 0.0
        do kr=0,1
           do jq=0,1
              do j=jsc-1,jec
                 do i=isc,iec
                    sumz(i,j,kr) = sumz(i,j,kr) + dxtdtsn(i,j,jq)*Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k) &
                         *tensor_23(i,j,jq)*dTdz(n)%field(i,j+jq,k-1+kr)                              &
                         *min(delqc(i,j,k,kr),delqc(i,j+1,k,kr))
                 enddo
              enddo
           enddo
        enddo
        flux_y(n)%field(COMPYL,k) = Grd%dytnr(COMPYL)*(sumz(COMPYL,0)+sumz(COMPYL,1))
     enddo

  enddo


end subroutine fy_flux_gm
! </SUBROUTINE> NAME="fy_flux_gm"


!#######################################################################
! <SUBROUTINE NAME="fz_flux_gm">
!
! <DESCRIPTION>
! Subroutine computes the vertical GM tracer flux component.
! Compute this component for all tracers at level k.
! Surface and bottom boundary condition fz(k=0)=fz(k=kmt(i,j))=0
!
! fz has physical dimensions (density*diffusivity*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fz_flux_gm(T_prog, k)

  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)

  integer :: i, j, k, n, ip, jq, kr
  real :: sumx_0, sumx_1, sumy_0, sumy_1
  real :: temparray31(isc:iec,jsc:jec,0:1,0:1)
  real :: temparray32(isc:iec,jsc:jec,0:1,0:1)
  real :: tensor_31(isd:ied,jsd:jed,0:1)
  real :: tensor_32(isd:ied,jsd:jed,0:1)

  if(k==nk) then 

      do n=1,num_prog_tracers
         fz2(n)%field(COMP)     = 0.0
         flux_z(n)%field(:,:,k) = 0.0 ! for diagnostics only 
      enddo
      return 

  elseif(k < nk) then  

      ! tracer independent portion of calculation 
      tensor_31   = 0.0
      tensor_32   = 0.0
      temparray31 = 0.0
      temparray32 = 0.0
      do ip=0,1
         jq=ip  
         tensor_31(COMPXLYL,ip) =  psiy(COMPXLYL,k,ip)
         tensor_32(COMPXLYL,jq) = -psix(COMPXLYL,k,jq)
      enddo

      do kr=0,1

         do ip=0,1
            do j=jsc,jec
               do i=isc,iec
                  temparray31(i,j,ip,kr) = tensor_31(i,j,ip)*dtew(i,j,ip) &
                       *min(delqc(i-1+ip,j,k+kr,1-kr),delqc(i+ip,j,k+kr,1-kr))
               enddo
            enddo
         enddo
         do jq=0,1
            do j=jsc,jec
               do i=isc,iec
                  temparray32(i,j,jq,kr) = tensor_32(i,j,jq)*dtns(i,j,jq) &
                       *min(delqc(i,j-1+jq,k+kr,1-kr),delqc(i,j+jq,k+kr,1-kr))  
               enddo
            enddo
         enddo

      enddo

      ! tracer dependent portion 
      do n=1,num_prog_tracers 
         do j=jsc,jec
            do i=isc,iec
               sumx_0 =  temparray31(i,j,0,0)*dTdx(n)%field(i-1,j,k) &
                      +  temparray31(i,j,0,1)*dTdx(n)%field(i-1,j,k+1)
               sumx_1 =  temparray31(i,j,1,0)*dTdx(n)%field(i,j,k)   &
                      +  temparray31(i,j,1,1)*dTdx(n)%field(i,j,k+1)
               sumy_0 =  temparray32(i,j,0,0)*dTdy(n)%field(i,j-1,k) &
                      +  temparray32(i,j,0,1)*dTdy(n)%field(i,j-1,k+1)
               sumy_1 =  temparray32(i,j,1,0)*dTdy(n)%field(i,j,k)   &
                      +  temparray32(i,j,1,1)*dTdy(n)%field(i,j,k+1)

               fz2(n)%field(i,j) =  Grd%tmask(i,j,k+1)                                 &
                    *( Grd%dxtr(i,j)*(sumx_0+sumx_1) + Grd%dytr(i,j)*(sumy_0+sumy_1) ) &
                    *dzwtr(i,j,k)
            enddo
         enddo
      enddo

      if(neutral_physics_limit) then 
          do n=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(T_prog(n)%tmask_limit(i,j,k)==1.0) fz2(n)%field(i,j) = 0.0  
                enddo
             enddo
          enddo
      endif

      ! save for diagnostics 
      do n=1,num_prog_tracers
         do j=jsc,jec
            do i=isc,iec
               flux_z(n)%field(i,j,k) = fz2(n)%field(i,j)
            enddo
         enddo
      enddo


  endif


end subroutine fz_flux_gm
! </SUBROUTINE> NAME="fz_flux_gm"


!#######################################################################
! <SUBROUTINE NAME="invtri_bvp">
!
! <DESCRIPTION>
! Solve the vertical diffusion equation implicitly using the
! method of inverting a tridiagonal matrix as described in
! Numerical Recipes in Fortran, The art of Scientific Computing,
! Second Edition, Press, Teukolsky, Vetterling, Flannery, 1992
! pages 42,43.
!
! enforce upsilon(k=kmt) = 0 via use of mask(k+1).  
!
! </DESCRIPTION>
!
subroutine invtri_bvp (mask, a, b, c, r, upsilon)

  real, intent(in), dimension(isd:,jsd:,:)      :: mask
  real, intent(in), dimension(isd:,jsd:,:)      :: a
  real, intent(in), dimension(isd:,jsd:,:)      :: b
  real, intent(in), dimension(isd:,jsd:,:)      :: c
  real, intent(in), dimension(isd:,jsd:,:,:)    :: r
  real, intent(inout), dimension(isd:,jsd:,:,:) :: upsilon

  real, dimension(isd:ied)    :: bet
  real, dimension(isd:ied,nk) :: gam

  integer :: i, j, k
  integer :: ipjq 

  bet = 0.0
  gam = 0.0
  
  do ipjq=1,2
     do j=jsc-1,jec


        ! decomposition and forward substitution
        k=1
        do i=isc-1,iec
           bet(i)              = mask(i,j,k+1)/(b(i,j,k) + epsln)
           upsilon(i,j,k,ipjq) = r(i,j,k,ipjq)*bet(i)
        enddo
        do k=2,nk-1
           do i=isc-1,iec
              gam(i,k)            = c(i,j,k-1)*bet(i)
              bet(i)              = mask(i,j,k+1)/(b(i,j,k) - a(i,j,k)*gam(i,k) + epsln)
              upsilon(i,j,k,ipjq) = (r(i,j,k,ipjq) - a(i,j,k)*upsilon(i,j,k-1,ipjq))*bet(i)
           enddo
        enddo

        ! back substitution
        do k=nk-1,1,-1
           do i=isc-1,iec
              upsilon(i,j,k,ipjq) = upsilon(i,j,k,ipjq) - gam(i,k+1)*upsilon(i,j,k+1,ipjq)
           enddo
        enddo


     enddo  ! enddo for j
  enddo     ! enddo for ipjq


end subroutine invtri_bvp
! </SUBROUTINE> NAME="invtri_bvp">



!#######################################################################
! <SUBROUTINE NAME="compute_advect_transport">
!
! <DESCRIPTION>
! Diagnose advective mass transport from GM. 
!
! This routine is a diagnostic routine since generically we use the 
! skewsion approach for the GM scheme. However, it could form the 
! basis for an advective implementation of GM, which remains to be done.
!
! Comments on the diagnostic scheme:
! 
! 0/ algorithm based on a similar approach used for submeso parameterization.  
!
! 1/ psiy(k) is centred at bottom of tracer cell at zonal face.
!    so -(psiy(i,j,k-1)-psiy(i,j,k)) gives zonal transport through 
!    tracer cell k.  
!
! 2/ psix(k) is centred at bottom of tracer cell at meridional face.
!    so (psix(i,j,k-1)-psix(i,j,k)) gives meridional transport through 
!    tracer cell k.  
!
! 3/ compute vertical component from convergence of horizontal, just
! as for the vertical velocity component for the Eulerian transport.
! 
! 4/ wrho_bt_gm(:,:,k=0) = 0.0 by definition
! it should be diagnosed to have zero at the ocean bottom; we should
! check that this is indeed the case to verify the diagnostic algorithm.
!
! 5/ expand the BDX_ET and BDY_NT operators for efficiency.  
!
! </DESCRIPTION>
!
subroutine compute_advect_transport(Time, Dens, Thickness)

  type(ocean_time_type),      intent(in) :: Time
  type(ocean_density_type),   intent(in) :: Dens
  type(ocean_thickness_type), intent(in) :: Thickness

  real    :: active_cells
  real    :: deriv_x, deriv_y
  real    :: divergence
  integer :: i, j, k, kp1
  integer :: tau
  integer :: num_smooth

  integer :: stdoutunit 
  stdoutunit=stdout() 

  tau = Time%tau

  uhrho_et_gm(:,:,:) = 0.0
  vhrho_nt_gm(:,:,:) = 0.0
  wrho_bt_gm(:,:,:)  = 0.0
  

  wrk1_v(:,:,:,:) = 0.0 ! (rho*psix,rho*psiy) = 0.0
  if(vert_coordinate_class==DEPTH_BASED) then 
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1_v(i,j,k,1) = onehalf*rho0*(psix(i,j,k,1)+psix(i,j,k,0))
               wrk1_v(i,j,k,2) = onehalf*rho0*(psiy(i,j,k,1)+psiy(i,j,k,0))
            enddo
         enddo
      enddo
  else 
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1_v(i,j,k,1) = onehalf*Dens%rho(i,j,k,tau)*(psix(i,j,k,1)+psix(i,j,k,0))
               wrk1_v(i,j,k,2) = onehalf*Dens%rho(i,j,k,tau)*(psiy(i,j,k,1)+psiy(i,j,k,0))
            enddo
         enddo
      enddo
  endif

  ! take vertical derivatives to compute zonal and meridional fluxes. 
  ! note that psi(k=0) = 0.0 
  do k=1,1
     do j=jsc,jec
        do i=isc,iec
           uhrho_et_gm(i,j,k) =  wrk1_v(i,j,k,2)
           vhrho_nt_gm(i,j,k) = -wrk1_v(i,j,k,1)
        enddo
     enddo
  enddo
  do k=2,nk
     do j=jsc,jec
        do i=isc,iec
           uhrho_et_gm(i,j,k) = -(wrk1_v(i,j,k-1,2)-wrk1_v(i,j,k,2))
           vhrho_nt_gm(i,j,k) =  (wrk1_v(i,j,k-1,1)-wrk1_v(i,j,k,1))
        enddo
     enddo
  enddo

  ! update domains as per C-grid fluxes 
  call mpp_update_domains(uhrho_et_gm(:,:,:), vhrho_nt_gm(:,:,:),&
                          Dom_flux%domain2d, gridtype=CGRID_NE)


  ! apply horizontal smoother to the transport
  if(smooth_advect_transport) then 
      do num_smooth = 1,smooth_advect_transport_num

         wrk1_v(:,:,:,:) = 0.0

         do k=1,nk
            do j=jsc,jec
               do i=isc,iec

                  if(Grd%tmask(i,j,k)==1.0) then 

                      active_cells = 4.0       +&
                           Grd%tmask(i-1,j,k)  +&
                           Grd%tmask(i+1,j,k)  +&
                           Grd%tmask(i,j-1,k)  +&
                           Grd%tmask(i,j+1,k)

                      if (active_cells > 4.0) then
                          wrk1_v(i,j,k,1) = & 
                          (4.0*uhrho_et_gm(i,j,k)      +&
                               uhrho_et_gm(i-1,j,k)    +&
                               uhrho_et_gm(i+1,j,k)    +&
                               uhrho_et_gm(i,j-1,k)    +&
                               uhrho_et_gm(i,j+1,k)) / active_cells
                          wrk1_v(i,j,k,2) =  &
                          (4.0*vhrho_nt_gm(i,j,k)      +&
                               vhrho_nt_gm(i-1,j,k)    +&
                               vhrho_nt_gm(i+1,j,k)    +&
                               vhrho_nt_gm(i,j-1,k)    +&
                               vhrho_nt_gm(i,j+1,k)) / active_cells

                      else
                          wrk1_v(i,j,k,1) = uhrho_et_gm(i,j,k)
                          wrk1_v(i,j,k,2) = vhrho_nt_gm(i,j,k)
                      endif

                  endif

               enddo
            enddo

            do j=jsc,jec
               do i=isc,iec
                  uhrho_et_gm(i,j,k) = wrk1_v(i,j,k,1)*Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)
                  vhrho_nt_gm(i,j,k) = wrk1_v(i,j,k,2)*Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)
               enddo
            enddo

         enddo

         call mpp_update_domains(uhrho_et_gm(:,:,:), vhrho_nt_gm(:,:,:),&
                                 Dom_flux%domain2d,gridtype=CGRID_NE)

      enddo  ! enddo for number of smoothing iterations 
  endif      ! endif for smooth_advect_transport


  ! diagnose vertical transport
  wrho_bt_gm(:,:,:) = 0.0
  do k=1,nk
      do j=jsc,jec
         do i=isc,iec
            deriv_x = Grd%dyte(i,j)*uhrho_et_gm(i,j,k) - Grd%dyte(i-1,j)*uhrho_et_gm(i-1,j,k)
            deriv_y = Grd%dxtn(i,j)*vhrho_nt_gm(i,j,k) - Grd%dxtn(i,j-1)*vhrho_nt_gm(i,j-1,k)
            divergence = (deriv_x + deriv_y)*Grd%datr(i,j) 
            wrho_bt_gm(i,j,k) = Grd%tmask(i,j,k)*(wrho_bt_gm(i,j,k-1) + divergence)
         enddo
     enddo
  enddo


  ! send diagnostics 

  if (id_u_et_gm > 0) then
      wrk1 = 0.0 
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               wrk1(i,j,k) = Grd%tmask(i,j,k)*uhrho_et_gm(i,j,k) &
                             /(epsln+Thickness%rho_dzt(i,j,k,tau))
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_u_et_gm, wrk1(:,:,:))
  endif
  if (id_v_nt_gm > 0) then
      wrk1 = 0.0 
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               wrk1(i,j,k) = Grd%tmask(i,j,k)*vhrho_nt_gm(i,j,k) &
                             /(epsln+Thickness%rho_dzt(i,j,k,tau))
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_v_nt_gm, wrk1(:,:,:))
  endif
  if (id_w_bt_gm > 0) then
      wrk1 = 0.0 
      do k=1,nk
         kp1 = min(k+1,nk)
         do j=jsd,jed
            do i=isd,ied
               wrk1(i,j,k) = Grd%tmask(i,j,k)*Grd%tmask(i,j,kp1)*Thickness%dzt(i,j,k)*wrho_bt_gm(i,j,k) &
                             /(epsln+Thickness%rho_dzt(i,j,k,tau))
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_w_bt_gm, wrk1(:,:,:))
  endif
  call diagnose_3d(Time, Grd, id_uhrho_et_gm, uhrho_et_gm(:,:,:))
  call diagnose_3d(Time, Grd, id_vhrho_nt_gm, vhrho_nt_gm(:,:,:))
  call diagnose_3d(Time, Grd, id_wrho_bt_gm, wrho_bt_gm(:,:,1:nk))


  ! diagnose advective mass transports from GM through cell faces.
  ! to compute overturning streamfunction in Ferret using these diagnostics,
  ! do so just like the Eulerian overturning.
  if (id_tx_trans_gm_adv > 0 .or. id_ty_trans_gm_adv > 0 .or. id_tz_trans_gm_adv > 0) then

     wrk1_v = 0.0
     wrk1   = 0.0
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              wrk1_v(i,j,k,1) = uhrho_et_gm(i,j,k)*Grd%dyte(i,j)
              wrk1_v(i,j,k,2) = vhrho_nt_gm(i,j,k)*Grd%dxtn(i,j)
              wrk1(i,j,k)     = wrho_bt_gm(i,j,k)*Grd%dat(i,j)
           enddo
        enddo
     enddo
     call diagnose_3d(Time, Grd, id_tx_trans_gm_adv, wrk1_v(:,:,:,1))
     call diagnose_3d(Time, Grd, id_ty_trans_gm_adv, wrk1_v(:,:,:,2))
     call diagnose_3d(Time, Grd, id_tz_trans_gm_adv, wrk1(:,:,:))

  endif



end subroutine compute_advect_transport
! </SUBROUTINE> NAME="compute_advect_transport"


!#######################################################################
! <SUBROUTINE NAME="ocean_nphysicsC_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocean_nphysicsC_restart(time_stamp)
  character(len=*), intent(in), optional :: time_stamp

  if(.not. use_this_module) return

  call ocean_nphysics_util_restart(time_stamp)

end subroutine ocean_nphysicsC_restart
! </SUBROUTINE> NAME="ocean_nphysicsC_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_nphysicsC_end">
!
! <DESCRIPTION>
! Write to restart.
! </DESCRIPTION>
!
subroutine ocean_nphysicsC_end(Time)

  type(ocean_time_type), intent(in) :: Time
  
  if(.not. use_this_module) return

  call ocean_nphysics_coeff_end(Time, agm_array, aredi_array, rossby_radius, rossby_radius_raw, bczone_radius)

end subroutine ocean_nphysicsC_end
! </SUBROUTINE> NAME="ocean_nphysicsC_end"


end module ocean_nphysicsC_mod

program regrid
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Zhi Liang </CONTACT>
  !
  ! <OVERVIEW>
  !   This program remap data from logically rectangular grid to logically rectangular grid.
  ! </OVERVIEW>

  !<DESCRIPTION>
  ! This program expects to read data from a netcdf file, which is specfied
  ! by the namelist variable "src_data". The number of data to be remapped is 
  ! specified by num_flds. The name of field to be remapped is specified 
  ! by the namelist variable "fld_name". The source data should be on the source
  ! grid which is specified by namelist variable src_grid. The destination grid is
  ! specified by nml dst_grd. The output file is a netcdf file specified
  ! by the namelist variable "dst_data". Each field can be a scalar variable or
  ! a vector field, which is specified by vector_fld. The vector field should
  ! always be paired together. A laplacian extrapolation will be performed when
  ! there is any missing value in the source data to interpolate data onto missing points.
  !</DESCRIPTION>

  use mpp_mod,          only : mpp_npes, mpp_pe, mpp_root_pe, mpp_error
  use mpp_mod,          only : FATAL, WARNING, stdout, mpp_chksum
  use mpp_domains_mod,  only : mpp_define_layout, mpp_define_domains, domain2d
  use mpp_domains_mod,  only : mpp_global_field, mpp_domains_set_stack_size, mpp_get_compute_domain 
  use mpp_domains_mod,  only : mpp_update_domains, CYCLIC_GLOBAL_DOMAIN, FOLD_NORTH_EDGE
  use fms_mod,          only : fms_init, open_namelist_file, close_file, fms_end
  use fms_mod,          only : check_nml_error, write_version_number, lowercase, uppercase
  use fms_io_mod,       only : fms_io_exit
  use constants_mod,    only : constants_init, PI
  use horiz_interp_mod, only : horiz_interp_new, horiz_interp, horiz_interp_type
  use axis_utils_mod,   only : interp_1d

  implicit none

#include "netcdf.inc"

  integer, parameter :: max_flds              = 20
  integer, parameter :: max_iter              = 2000
  integer, parameter :: max_atts              = 20
  real,    parameter :: rel_coef              = 0.6
  real,    parameter :: epsln                 = 1.0e-10

  !--- namelist interface ----------------------------------------------
  !<NAMELIST NAME="regrid_nml">
  ! <DATA NAME="num_flds"  TYPE="integer" DEFAULT="0">
  !  Number of fields. 
  ! </DATA>
  ! <DATA NAME="src_data" TYPE="character(len=128)" >
  !  Name of input file containing to-be-remapped data.
  ! </DATA>
  ! <DATA NAME="dst_data" TYPE="character(len=128)" >
  !  Name of output file containing after-remapped data.
  ! </DATA>
  ! <DATA NAME="dst_grid" TYPE="character(len=128)" >
  !  Name of grid descriptor file containing target grid information.
  ! </DATA>
  ! <DATA NAME="src_grid" TYPE="character(len=128)" >
  !  Name of grid descriptor file containing source grid information.
  ! </DATA>
  ! <DATA NAME="fld_name" TYPE="character(len=128), dimension(max_flds)" >
  !  Name of runoff field in input file.
  ! </DATA>
  ! <DATA NAME="fld_pos"  TYPE="character(len=1),dimension(max_flds)" DEFAULT="T">
  !  Name of grid where the field located.  Valid choices are (T)racer, (C)orner, (E)ast and (N)orth.
  ! </DATA>
  ! <DATA NAME="vector_field"  TYPE="logical,dimension(max_flds)" DEFAULT="False">
  !  True if fields are vector components. All the vector field should be paired together.
  !  That is, if vector_field(n) is .true., then vector_field(n+1) should be true.
  ! </DATA>
  ! <DATA NAME="stop_crit"  TYPE="character(len=1),dimension(max_flds)" DEFAULT="0.001">
  !  The stopping criteria when extrapping data onto missing points.
  ! </DATA>
  ! <DATA NAME="num_nbrs" TYPE="integer">
  !  Number of nearest neighbors for regridding.
  ! </DATA>
  ! <DATA NAME="max_dist" TYPE="real" UNITS="radians">
  !  Maximum region of influence around destination grid points.
  ! </DATA>
  ! <DATA NAME="use_source_vertical_grid" TYPE="logical" DEFAULT=".false.">
  !  when use_source_vertical_grid is set to true, the destination data will 
  !  have the same vertical level as the source data. When use_source_vertical_grid 
  !  is false, the vertical grid of destination data will come from dest_grid. 
  !  a linear vertical interpolation will be done when the source vertical is different
  !  from destination vertical grid.
  ! </DATA>
  ! <DATA NAME="apply_mask"  TYPE="logical" DEFAULT="true">
  !  flag to indicate if the land/sea mask of source/destination grid will be applied 
  !  on the output dest_file. When apply_mask is false, the destination data will be 
  !  global data, i.e. no missing value in the destination data file. When apply_mask 
  !  is true, mask will be applied to the destination data. The mask can be either 
  !  source grid or destination grid determined by nml use_source_vertical_grid. 
  !  When use_source_vertical_grid is true, source grid mask will be applied, otherwise
  !  destination grid mask will be applied.
  ! </DATA>
  !<DATA NAME="interp_method"  TYPE= "character(len=20)" >
  ! specifying the remapping method when remampping data onto current grid.
  ! Its value can be "spherical" or " bilinear". "spherical" interpolation is a 
  ! inverse distance weighted interpolation algorithm. Default value is "bilinear". 
  ! "bilinear" interpolation is recommanded, since bilinear interpolation will provide 
  ! more smooth results than "spherical" interpolation (especially when interpolating 
  ! from coarse grid to fine grid). Plus bilinear interpolation is much more efficiency 
  ! than "spherical interpolation". Since bilinear interpolation suppose the source grid 
  ! is a lat-lon grid, "spherical" need to be used if the source grid is not a lat-lon grid.
  ! </DATA>
  ! <DATA NAME="debug" TYPE="logical">
  ! For Debugging. Set true to print out chksum information for debugging reproducing ability 
  ! accross processors. default is false.
  ! </DATA>
  !</NAMELIST>

  integer            :: num_flds                  = 0
  character(len=128) :: src_data                  = '' 
  character(len=128) :: src_grid                  = ''
  character(len=128) :: dst_data                  = ''
  character(len=128) :: dst_grid                  = ''
  character(len=16)  :: fld_name(max_flds)        = ''
  character(len=1)   :: fld_pos(max_flds)         = ''      ! with value 'T','C','E','N'
  logical            :: vector_fld(max_flds)      = .false. ! True if fields are vector components.
  real               :: stop_crit(max_flds)       = 0.001 
  integer            :: num_nbrs                  = 5
  real               :: max_dist                  = 0.1
  logical            :: use_source_vertical_grid  = .FALSE.
  logical            :: apply_mask                = .TRUE.
  character(len=32)  :: interp_method             = "bilinear"
  logical            :: debug                     = .false.

  namelist /regrid_nml/ num_flds, src_data, src_grid, dst_data, dst_grid, fld_name, &
       fld_pos, vector_fld, num_nbrs, max_dist, stop_crit, interp_method,           &
       apply_mask, use_source_vertical_grid, debug


  !--- data type for easy data management ------------------------------
  type cell_type
     real, dimension(:,:),   pointer :: geolon=>NULL(), geolat=>NULL() ! geographical grid
     real, dimension(:,:,:), pointer :: mask  =>NULL()                 ! mask at each vertical level
     real, dimension(:,:),   pointer :: sinrot=>NULL(), cosrot=>NULL() ! rotation
  end type cell_type

  type regrid_type
     type(cell_type)          :: T,C,E,N            ! T,C,E,N-cell
     integer                  :: ni, nj,nk          ! grid size
     integer                  :: isc, iec, jsc, jec ! compute domain decompsition src grid
     integer                  :: isd, ied, jsd, jed ! data domain decompsition on dst grid
     type(domain2d)           :: domain             ! domain of the grid ( only destination grid will use it).
     logical                  :: is_cyclic          ! indicate if the grid is cyclic
     logical                  :: is_tripolar        ! indicate if the grid is tripolar
     real, pointer            :: zt(:) =>NULL()     ! vertical grid 
     real, pointer            :: grid_xt(:)=>NULL() ! T-cell longitude grid
     real, pointer            :: grid_yt(:)=>NULL() ! T-cell latitude grid
     real, pointer            :: grid_xc(:)=>NULL() ! C-cell longitude grid
     real, pointer            :: grid_yc(:)=>NULL() ! C-cell latitude grid
  end type regrid_type

  !--- version information ---------------------------------------------
  character(len=128) :: version = '$Id: regrid.F90,v 20.0 2013/12/14 00:31:05 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

  !--- other variables
  integer                             :: ntime_src                     ! number of time levels of src data
  logical                             :: do_vertical_interp            ! indicate if vertical interpolation is needed.
  logical                             :: is_root_pe                    ! if current pe is root pe.
  type(regrid_type)                   :: Src                           ! regrid_type data of source
  type(regrid_type)                   :: Dst                           ! regrid_type data of destination
  type(horiz_interp_type),     target :: Interp_T, Interp_C            ! horiz_interp data at T,C-cell
  type(horiz_interp_type),     target :: Interp_E, Interp_N            ! horiz_interp data at E,N-cell
  real, dimension(:),     allocatable :: missing_value                 ! missing value for source field.
  real, dimension(:),     allocatable :: time_value                    ! time axis value
  real, dimension(:),     allocatable :: t1_avg, t2_avg, dt_avg        ! time average data
  real, dimension(:,:),   allocatable :: ht, hc, he, hn                ! topography
  logical, dimension(:),  allocatable :: has_zaxis                     ! indicate if the field has z axis
  logical                             :: has_taxis,tavg_exist          ! indicate if all the field has time axis
  integer                             :: ncid_dst                      ! ncid corresponding to 
  integer                             :: id_t1_dst, id_t2_dst, id_dt_dst
  integer                             :: id_time_dst, id_dst_fld(max_flds)

  !---  begin of the program -------------------------------------------

  call regrid_init()

  call read_grid()

  call setup_meta()

  call process_data ()

  call regrid_end ()

contains

  !#####################################################################
  subroutine regrid_init
    integer          :: unit, io_status, ierr, n
    character(len=1) :: direction

    call fms_init()
    call constants_init()

    !--- reading namelist ------------------------------------------------
    unit = open_namelist_file()
    read  (unit, regrid_nml,iostat=io_status)
    write (stdout(),'(/)')
    write (stdout(), regrid_nml)
    ierr = check_nml_error(io_status,'regrid_nml')
    call close_file (unit)

    !--- write out version information ---------------------------------
    call write_version_number(version, tagname)

    if(num_flds == 0) call error_handler('regrid: nml num_fiels = 0 should be a positive number')
    if(num_flds .gt. max_flds) call error_handler('regrid: nml num_fiels is greater than maximum'// &
         ' allowed fields max_flds. Modify num_flds or increase "max_flds" at top of the program' )

    do n = 1, num_flds
       if(fld_pos(n) .ne. 'T' .and. fld_pos(n) .ne. 'C' .and. fld_pos(n) .ne. 'E' .and. fld_pos(n) .ne. 'N' ) &
            call error_handler('regrid: fld_pos should be "T", "C", "E" or "N" ')
    enddo

    !--- number of vector_fld is true should be even and should be paired adjacent.
    !--- The first one of the pair should be u-component and the second one 
    !--- should be v-component.
    n = 1
    do while ( n .le. num_flds )
       if(vector_fld(n)) then
          n = n + 1
          if( n .gt. num_flds .or. ( .NOT. vector_fld(n) ) ) then
             call error_handler('regrid: vector field should be paired together')
          endif
       endif
       n = n+1
    enddo

    !--- write out field information to be remapped.
    Write(stdout(),*) '*****************************************************************'
    write(stdout(),*) 'number of fields to be remapped are: ', num_flds
    write(stdout(),*) 'The source data file is: ', trim(src_data)
    write(stdout(),*) 'The source grid file is: ', trim(src_grid)
    write(stdout(),*) 'The destination grid file is: ', trim(dst_grid)
    if(use_source_vertical_grid) then
       write(stdout(),*) 'use_source_vertical_grid is set to true. The destination data will have '// &
                         'same vertical level as the source data '
    else
       write(stdout(),*) 'use_source_vertical_grid is set to false. vertical interpolation will ', &
                         'be performed if the source and destination has different vertical grid. '
    endif

    direction = 'x'
    do n = 1, num_flds
       if(vector_fld(n)) then
          write(stdout(),*) '** field ',n,': ',trim(fld_name(n)), ' at '//  &
               trim(fld_pos(n))//'-cell center is the '//direction//'-component of a vector field'         
          if(direction == 'x') then
             direction = 'y'
          else
             direction = 'x'
          endif
       else
          write(stdout(),*) '**field ',n,': ',trim(fld_name(n)), ' at '//  &
               trim(fld_pos(n))//'-cell center is a scalar variable'            
       endif
    enddo

    !--- memory allocation
    allocate(has_zaxis(num_flds), missing_value(num_flds) )
    has_zaxis = .false.
    missing_value = -1e20

    is_root_pe = mpp_pe() == mpp_root_pe()

  end subroutine regrid_init

  !#################################################################
  !--- read the src grid and dst grid and land/sea mask of dst grid.

  subroutine read_grid
    integer  :: isc, iec, jsc, jec
    integer  :: k, npes, layout(2)
    real     :: D2R
    logical  :: use_src_vgrid

    D2R = PI/180.0

    !--- read some general grid informaiton for source grid and destination grid
    call get_grid_info(src_grid, Src, .TRUE.)
    call get_grid_info(dst_grid, Dst, .FALSE.)

    do_vertical_interp = .false.
    if(use_source_vertical_grid) then !--- modify the destination vertical information for the future use.
       !--- In this case the destination vertical grid should be the same as source.
       Dst%nk = Src%nk
       deallocate(Dst%zt)
       allocate(Dst%zt(Dst%nk))
       Dst%zt = Src%zt
    else     !--- when use_source_vertical_grid is false, vertical interpolation will be done if the source vertical
       !--- grid didn't match destination vertical grid.
       if(Src%nk .ne. Dst%nk) then
          do_vertical_interp = .true.
       else
          do k = 1, Src%nk
             if( abs(Src%zt(k) - Dst%zt(k)) .gt. epsln ) then
                do_vertical_interp = .true.
                exit
             endif
          enddo
       endif
       if(do_vertical_interp) then
          write(stdout(),*)'NOTE: Since source vertical grid does not match ' //&
               'destination vertical grid and nml use_source_vertical_grid is set ' //&
               'to false, vertical interpolation will be performed. '
       else
          write(stdout(),*)'NOTE: Even though nml use_source_vertical_grid is set to false, ', &
               'but since source vertical grid match destination vertical grid, ',             &
               'no vertical interpolation will be performed. '
       endif
    endif

    isc= Dst%isc; iec= Dst%iec; jsc= Dst%jsc; jec= Dst%jec;

    !--- when source is tripolar grid, 'spherical' interpolation will be used 
    !--- no matter your choice of "interp_method".
    if(Src%is_tripolar .and. trim(interp_method) == "bilinear") then
       write(stdout(),*) "WARNING: Since src grid is tripolar grid, even though you chose ", &
             "bilinear option, spherical option will be used."
    endif

    !--- call horizinterp_new to calculate the reampping weight in horizontal direction
    if( any(fld_pos == 'T') ) then
       if(Src%is_tripolar) then
          call horiz_interp_new(Interp_T, Src%T%geolon*D2R, Src%T%geolat*D2R,           &
               Dst%T%geolon(isc:iec,jsc:jec)*D2R, Dst%T%geolat(isc:iec,jsc:jec)*D2R,     &
               interp_method='spherical', num_nbrs=num_nbrs, max_dist=max_dist,          &
               src_modulo = Src%is_cyclic)
       else
          call horiz_interp_new(Interp_T, Src%T%geolon(:,1)*D2R, Src%T%geolat(1,:)*D2R, &
               Dst%T%geolon(isc:iec,jsc:jec)*D2R, Dst%T%geolat(isc:iec,jsc:jec)*D2R,     &
               interp_method=trim(interp_method), num_nbrs=num_nbrs, max_dist=max_dist,  &
               src_modulo = Src%is_cyclic, grid_at_center = .true.)
       endif
    endif

    if( any(fld_pos == 'C') ) then
       if(Src%is_tripolar) then
          call horiz_interp_new(Interp_C, Src%C%geolon*D2R, Src%C%geolat*D2R,           &
               Dst%C%geolon(isc:iec,jsc:jec)*D2R, Dst%C%geolat(isc:iec,jsc:jec)*D2R,     &
               interp_method='spherical', num_nbrs=num_nbrs, max_dist=max_dist,          &
               src_modulo = Src%is_cyclic )
       else
          call horiz_interp_new(Interp_C, Src%C%geolon(:,1)*D2R, Src%C%geolat(1,:)*D2R, &
               Dst%C%geolon(isc:iec,jsc:jec)*D2R, Dst%C%geolat(isc:iec,jsc:jec)*D2R,     &
               interp_method=trim(interp_method), num_nbrs=num_nbrs, max_dist=max_dist,  &
               src_modulo = Src%is_cyclic, grid_at_center = .true.)
       endif
    endif

    if( any(fld_pos == 'E') ) then
       if(Src%is_tripolar) then
          call horiz_interp_new(Interp_E, Src%E%geolon*D2R, Src%E%geolat*D2R,           &
               Dst%E%geolon(isc:iec,jsc:jec)*D2R, Dst%E%geolat(isc:iec,jsc:jec)*D2R,     &
               interp_method='spherical', num_nbrs=num_nbrs, max_dist=max_dist,          &
               src_modulo = Src%is_cyclic)
       else
          call horiz_interp_new(Interp_E, Src%E%geolon(:,1)*D2R, Src%E%geolat(1,:)*D2R, &
               Dst%E%geolon(isc:iec,jsc:jec)*D2R, Dst%E%geolat(isc:iec,jsc:jec)*D2R,     &
               interp_method=trim(interp_method), num_nbrs=num_nbrs, max_dist=max_dist,  &
               src_modulo = Src%is_cyclic, grid_at_center = .true.)
       endif
    endif

    if( any(fld_pos == 'N') ) then
       if(Src%is_tripolar) then
          call horiz_interp_new(Interp_N, Src%N%geolon*D2R, Src%N%geolat*D2R,           &
               Dst%N%geolon(isc:iec,jsc:jec)*D2R, Dst%N%geolat(isc:iec,jsc:jec)*D2R,     &
               interp_method='spherical', num_nbrs=num_nbrs, max_dist=max_dist,          &
               src_modulo = Src%is_cyclic)
       else
          call horiz_interp_new(Interp_N, Src%N%geolon(:,1)*D2R, Src%N%geolat(1,:)*D2R, &
               Dst%N%geolon(isc:iec,jsc:jec)*D2R, Dst%N%geolat(isc:iec,jsc:jec)*D2R,     &
               interp_method=trim(interp_method), num_nbrs=num_nbrs, max_dist=max_dist,  &
               src_modulo = Src%is_cyclic, grid_at_center = .true.)
       endif
    endif

  end subroutine read_grid

  !#####################################################################

  subroutine get_grid_info(gridfile, Regrid, is_src_grid)
    character(len=*),  intent(in)      :: gridfile
    type(regrid_type), intent(inout)   :: Regrid
    logical,              intent(in)   :: is_src_grid
    integer                            :: rcode, ncid, natt, id_zt, id_kmt, dims(2)
    integer                            :: id_grid_xt, id_grid_yt, id_grid_xc, id_grid_yc
    integer                            :: npes, i, j, k, layout(2)
    integer                            :: isc, iec, jsc, jec, isd, ied, jsd, jed
    logical                            :: is_new_grid
    character(len=128)                 :: name, catt
    integer,allocatable,dimension(:,:) :: kmt, kmc, kme, kmn
    real,   allocatable,dimension(:,:) :: tmp

    rcode = nf_open(trim(gridfile), NF_NOWRITE, ncid)    
    call error_handler('error in open file '//trim(gridfile), rcode)

    Regrid%ni = 0; Regrid%nj = 0; Regrid%nk = 0    
    !--- get vertical grid information
    rcode = nf_inq_varid(ncid, 'zt', id_zt)
    call error_handler('error in inquring id of field zt from file '//trim(gridfile), rcode)
    rcode = nf_inq_vardimid(ncid, id_zt, dims)
    call error_handler('error in inquring dims of field zt from file '//trim(gridfile), rcode)
    rcode = nf_inq_dimlen(ncid, dims(1), Regrid%nk)
    call error_handler('error in inquring dimlen of field zt from file '//trim(gridfile), rcode)
    allocate(Regrid%zt(Regrid%nk) ) 
    rcode = nf_get_var_double(ncid, id_zt, Regrid%zt) 
    call error_handler('error in getting data of zt from file '//trim(gridfile), rcode)

    !--- get horizontal grid size 
    rcode = nf_inq_varid(ncid, 'num_levels', id_kmt)
    if(rcode == 0) then
       is_new_grid = .true.
    else
       is_new_grid = .false.
       rcode = nf_inq_varid(ncid, 'kmt', id_kmt)
    endif

    call error_handler('Can not find kmt/num_levels in file '//trim(gridfile), rcode)

    rcode = nf_inq_vardimid(ncid, id_kmt, dims)
    call error_handler('error in inquring dims of field num_levels/kmt from file '//trim(gridfile), rcode)
    rcode = nf_inq_dimlen(ncid, dims(1), Regrid%ni )
    call error_handler('error in inquring dimlen ni of field num_levels/kmt from file '//trim(gridfile), rcode)
    rcode = nf_inq_dimlen(ncid, dims(2), Regrid%nj )
    call error_handler('error in inquring dimlen nj of field num_levels/kmt from file '//trim(gridfile), rcode)

    !--- get global attributes ( cyclic or tripolar )
    rcode =  nf_inq_natts(ncid, natt)
    call error_handler('error in inquring natts of file '//trim(gridfile), rcode )
    do i = 1, natt
       rcode = nf_inq_attname(ncid,NF_GLOBAL,i,name )
       call error_handler('error in inquring att name of file '//trim(gridfile), rcode )
       catt = ''
       select case( trim(name) )
       case('x_boundary_type')
          rcode = nf_get_att_text(ncid,NF_GLOBAL,name,catt)
          call error_handler('error in inquring x_boundary_type value of file '//trim(gridfile), rcode )
          if(trim(catt) == 'cyclic') then
             Regrid%is_cyclic = .true.
             Write(stdout(),*)' NOTE: x_boundary_type of grid '//trim(gridfile)//' is cyclic'
          else
             Write(stdout(),*)' NOTE: x_boundary_type of '//trim(gridfile)//' is solid_walls'
          endif
       case ('y_boundary_type')
          rcode = nf_get_att_text(ncid,NF_GLOBAL,name,catt)
          call error_handler('error in inquring y_boundary_type value of file '//trim(gridfile), rcode )
          if (trim(catt) == 'fold_north_edge') then
             Regrid%is_tripolar = .true.
             Write(stdout(),*)' NOTE: y_boundary_type of '//trim(gridfile)//' is tripolar'
          else
             Write(stdout(),*)' NOTE: y_boundary_type of '//trim(gridfile)//' is solid_walls' 
          endif
       end select
    end do

    !--- define domain decompsition for destination grid ---------------
    if(.not. is_src_grid) then
       npes = mpp_npes()
       layout = (/1,0/)
       call mpp_define_layout((/1,Regrid%ni,1,Regrid%nj/),npes,layout)

       if(Regrid%is_tripolar) then
          call mpp_define_domains((/1,Regrid%ni,1,Regrid%nj/),layout, Regrid%domain, xflags = CYCLIC_GLOBAL_DOMAIN, &
               yflags = FOLD_NORTH_EDGE, xhalo=1, yhalo=1)
       else if (Regrid%is_cyclic) then
          call mpp_define_domains((/1,Regrid%ni,1,Regrid%nj/),layout, Regrid%domain, xflags = cyclic_global_domain, &
               xhalo=1, yhalo=1)
       else
          call mpp_define_domains((/1,Regrid%ni,1,Regrid%nj/),layout, Regrid%domain,  xhalo=1, yhalo=1)
       endif
       call mpp_get_compute_domain(Regrid%domain,Regrid%isc,Regrid%iec,Regrid%jsc,Regrid%jec)
    endif

    !--- when the grid is source grid, need to get global grid information.
    !--- when the grid is destination grid, only need to get local grid information.
    if(is_src_grid) then
       isc = 1; iec = Regrid%ni
       jsc = 1; jec = Regrid%nj
    else
       isc = Regrid%isc  ; iec = Regrid%iec
       jsc = Regrid%jsc  ; jec = Regrid%jec
    endif
    isd = isc-1       ; ied = iec+1
    jsd = jsc-1       ; jed = jec+1

    ! get number vertical level
    allocate(kmt(isd:ied,jsd:jed), kmc(isc:iec,jsc:jec), kme(isc:iec,jsc:jec), kmn(isc:iec,jsc:jec)  )
    allocate(tmp(Regrid%ni,Regrid%nj) )    

    rcode = nf_get_var_double(ncid, id_kmt, tmp) 
    call error_handler('error in getting value of kmt from file '//trim(gridfile), rcode) 
    kmt = 0
    kmt(isc:iec,jsc:jec) = tmp(isc:iec,jsc:jec)
    if(is_src_grid) then
       kmt(isd,jsc:jec) = kmt(iec,jsc:jec)
       kmt(ied,jsc:jec) = kmt(isc,jsc:jec)
    else
       call mpp_update_domains(kmt,Dst%domain)    
    endif

    !--- calculate the mask at T,C,E,N-cell if needed
    if( any(fld_pos == 'T') ) then
       allocate(Regrid%T%mask(isc:iec,jsc:jec,Regrid%nk))
       do k=1,Regrid%nk
          do j=jsc,jec
             do i=isc,iec
                if (kmt(i,j) .ge. k) then
                   Regrid%T%mask(i,j,k) = 1.0
                else
                   Regrid%T%mask(i,j,k) = 0.0
                endif
             enddo
          enddo
       enddo
    endif

    if( any(fld_pos == 'C') ) then
       do j = jsc, jec
          do i = isc, iec
             kmc(i,j) = min(kmt(i,j), kmt(i+1,j), kmt(i,j+1), kmt(i+1,j+1))
          enddo
       enddo

       allocate(Regrid%C%mask(isc:iec,jsc:jec,Regrid%nk))
       do k=1,Regrid%nk
          do j=jsc,jec
             do i=isc,iec
                if (kmc(i,j) .ge. k) then
                   Regrid%C%mask(i,j,k) = 1.0
                else
                   Regrid%C%mask(i,j,k) = 0.0
                endif
             enddo
          enddo
       enddo
    endif

    if( any(fld_pos == 'E') ) then
       do j = jsc, jec
          do i = isc, iec
             kme(i,j) = min(kmt(i,j), kmt(i+1,j))
          enddo
       enddo

       allocate(Regrid%E%mask(isc:iec,jsc:jec,Regrid%nk))
       do k=1,Regrid%nk
          do j=jsc,jec
             do i=isc,iec
                if (kme(i,j) .ge. k) then
                   Regrid%E%mask(i,j,k) = 1.0
                else
                   Regrid%E%mask(i,j,k) = 0.0
                endif
             enddo
          enddo
       enddo
    endif

    if( any(fld_pos == 'N') ) then
       do j = jsc, jec
          do i = isc, iec
             kmn(i,j) = min(kmt(i,j), kmt(i,j+1))
          enddo
       enddo

       allocate(Regrid%N%mask(isc:iec,jsc:jec,Regrid%nk))
       do k=1,Regrid%nk
          do j=jsc,jec
             do i=isc,iec
                if (kmn(i,j) .ge. k) then
                   Regrid%N%mask(i,j,k) = 1.0
                else
                   Regrid%N%mask(i,j,k) = 0.0
                endif
             enddo
          enddo
       enddo
    endif

    !--- get the destination axis grid information ---------------------------------
    if(.not. is_src_grid) then
       allocate(Regrid%grid_xt(Regrid%ni),Regrid%grid_yt(Regrid%nj) )
       allocate(Regrid%grid_xc(Regrid%ni),Regrid%grid_yc(Regrid%nj) )  
       if(is_new_grid) then
          rcode = nf_inq_varid(ncid, 'grid_x_T', id_grid_xt)
          call error_handler('error in inquring variable id of field grid_x_T', rcode )
          rcode = nf_inq_varid(ncid, 'grid_y_T', id_grid_yt)
          call error_handler('error in inquring variable id of field grid_y_T', rcode )
          rcode = nf_inq_varid(ncid, 'grid_x_C', id_grid_xc)
          call error_handler('error in inquring variable id of field grid_x_C', rcode )
          rcode = nf_inq_varid(ncid, 'grid_y_C', id_grid_yc)
          call error_handler('error in inquring variable id of field grid_y_C', rcode )
       else
          rcode = nf_inq_varid(ncid, 'gridlon_t', id_grid_xt)
          call error_handler('error in inquring variable id of field gridlon_t', rcode )
          rcode = nf_inq_varid(ncid, 'gridlat_t', id_grid_yt)
          call error_handler('error in inquring variable id of field gridlat_t', rcode )
          rcode = nf_inq_varid(ncid, 'gridlon_c', id_grid_xc)
          call error_handler('error in inquring variable id of field gridlon_c', rcode )
          rcode = nf_inq_varid(ncid, 'gridlat_c', id_grid_yc)
          call error_handler('error in inquring variable id of field gridlat_c', rcode )
       endif
       rcode =  nf_get_var_double(ncid, id_grid_xt, Regrid%grid_xt)
       call error_handler('error in getting data of variable grid_x_T/gridlon_t', rcode )       
       rcode =  nf_get_var_double(ncid, id_grid_yt, Regrid%grid_yt)
       call error_handler('error in getting data of variable grid_y_T/gridlat_t', rcode )    
       rcode =  nf_get_var_double(ncid, id_grid_xc, Regrid%grid_xc)
       call error_handler('error in getting data of variable grid_x_C/gridlon_c', rcode )       
       rcode =  nf_get_var_double(ncid, id_grid_yc, Regrid%grid_yc)
       call error_handler('error in getting data of variable grid_y_C/gridlat_c', rcode ) 
    endif

    if(any(fld_pos == 'T') ) then
       call get_cell_info(Regrid%T,'T',ncid,Regrid%ni,Regrid%nj,isc,iec,jsc,jec,is_new_grid)
    endif

    if(any(fld_pos == 'C') ) then
       call get_cell_info(Regrid%C,'C',ncid,Regrid%ni,Regrid%nj,isc,iec,jsc,jec,is_new_grid)
    endif

    if(any(fld_pos == 'E') ) then
       call get_cell_info(Regrid%E,'E',ncid,Regrid%ni,Regrid%nj,isc,iec,jsc,jec,is_new_grid)
    endif

    if(any(fld_pos == 'N') ) then
       call get_cell_info(Regrid%N,'N',ncid,Regrid%ni,Regrid%nj,isc,iec,jsc,jec,is_new_grid)
    endif


    deallocate(kmt, kmc, kme, kmn,tmp)

    rcode = nf_close(ncid)

  end subroutine get_grid_info

  !#####################################################################
  subroutine get_cell_info(Cell, type, ncid, ni, nj, isc, iec,jsc,jec,is_new_grid )     
    type(cell_type), intent(inout) :: Cell
    character(len=1),   intent(in) :: type
    integer,            intent(in) :: ncid, ni, nj
    integer,            intent(in) :: isc, iec, jsc, jec
    logical,            intent(in) :: is_new_grid
    character(len=1)               :: lc_type, uc_type
    integer                        :: rcode, id_x, id_y, id_angle, id_sinrot, id_cosrot
    real, allocatable              :: tmp(:,:)

    allocate(Cell%geolon(isc:iec, jsc:jec), Cell%geolat(isc:iec, jsc:jec) )
    allocate(Cell%sinrot(isc:iec, jsc:jec), Cell%cosrot(isc:iec, jsc:jec) )
    allocate(tmp(ni,nj) )

    lc_type = lowercase(type)
    uc_type = uppercase(type)

    if(is_new_grid) then
       rcode = nf_inq_varid(ncid, 'x_'//uc_type, id_x)  
       call error_handler('error in inquring variable id of field x_'//uc_type, rcode )
       rcode = nf_inq_varid(ncid, 'y_'//uc_type, id_y)    
       call error_handler('error in inquring variable id of field y_'//uc_type, rcode )
       rcode = nf_inq_varid(ncid, 'angle_'//uc_type, id_angle)
       call error_handler('error in inquring variable id of field angle_'//uc_type, rcode )
    else
       rcode = nf_inq_varid(ncid, 'geolon_'//lc_type, id_x)
       call error_handler('error in inquring variable id of field geolon_'//lc_type, rcode )
       rcode = nf_inq_varid(ncid, 'geolat_'//lc_type, id_y) 
       call error_handler('error in inquring variable id of field geolat_'//lc_type, rcode )
       if(lc_type == 'c') then
          rcode = nf_inq_varid(ncid, 'sin_rot', id_sinrot)
          call error_handler('error in inquring variable id of field sin_rot', rcode )
          rcode = nf_inq_varid(ncid, 'cos_rot', id_cosrot)  
          call error_handler('error in inquring variable id of field cos_rot', rcode )
       else
          write(stdout(),*)'==> NOTE: No rotation information avaible for '// &
               uc_type//'-cell, will set sinrot = 0 and cosrot = 1' 
       endif
    endif

    rcode =  nf_get_var_double(ncid, id_x, tmp)
    call error_handler('error in getting data of variable x_'//uc_type//'/geolon_'//lc_type, rcode )
    Cell%geolon(isc:iec, jsc:jec) = tmp(isc:iec,jsc:jec)
    rcode =  nf_get_var_double(ncid, id_y, tmp)
    call error_handler('error in getting data of variable y_'//uc_type//'/geolat_'//lc_type, rcode )
    Cell%geolat(isc:iec, jsc:jec) = tmp(isc:iec,jsc:jec)

    if(is_new_grid) then
       rcode =  nf_get_var_double(ncid, id_angle, tmp) 
       call error_handler('error in getting data of variable angle_'//uc_type, rcode )
       Cell%sinrot(isc:iec,jsc:jec) = sin(tmp(isc:iec,jsc:jec))
       Cell%cosrot(isc:iec,jsc:jec) = cos(tmp(isc:iec,jsc:jec))
    else
       if(lc_type == 'c') then
          rcode =  nf_get_var_double(ncid, id_sinrot, tmp) 
          call error_handler('error in getting data of variable sin_rot', rcode )
          Cell%sinrot(isc:iec,jsc:jec) = tmp(isc:iec,jsc:jec)
          rcode =  nf_get_var_double(ncid, id_cosrot, tmp) 
          call error_handler('error in getting data of variable cos_rot', rcode )
          Cell%cosrot(isc:iec,jsc:jec) = tmp(isc:iec,jsc:jec)
       else
          Cell%sinrot = 0
          Cell%cosrot = 1
       endif
    endif

    deallocate(tmp)

  end subroutine get_cell_info

  !#####################################################################
  !--- set up axis and field meta data for destination data file

  subroutine setup_meta
    integer            :: ncid_src, rcode, id_fld, id_dim, id_time, dims(4)
    integer            :: type, len, ndims, natt_dim, natt, dimids(4), ndims_dst
    integer            :: n, m, i, j, num_has_taxis, start(4), nwrite(4)
    integer            :: id_t1_src, id_t2_src, id_dt_src, dim_time_dst
    integer, parameter :: max_dim = 10
    integer            :: dims_dst(max_dim), id_axes(max_dim), fld_dims(4), dims_id(max_dim)
    character(len=1)   :: dims_pos(max_dim), dims_cart(max_dim)
    character(len=128) :: name, att_name, cart, dims_name(max_dim)
    character(len=512) :: catt
    logical            :: found_dim = .false.
    logical            :: has_missing(max_flds)
    integer            ::fsize = 65536, inital = 0

    !--- open the dst_data file from root_pe.
    if(is_root_pe) then
#ifdef use_netCDF3
        rcode = NF__CREATE(trim(dst_data), NF_CLOBBER, inital, fsize, ncid_dst)
#else  ! netcdf 4
        rcode = NF__CREATE(trim(dst_data), IOR(NF_NETCDF4,NF_CLASSIC_MODEL), inital, fsize, ncid_dst )
#endif
       call error_handler('error in creating file '//trim(dst_data), rcode) 
    endif

    !--- get src_data information ( ntime, global attributes,  axis and field meta information )
    rcode = nf_open(trim(src_data), NF_NOWRITE, ncid_src) 
    call error_handler('error in opening file '//trim(src_data), rcode) 

    !--- get missing value, tavg_information, has_zaxis or has_taxis
    num_has_taxis = 0
    ndims_dst     = 0
    tavg_exist = .false.
    ntime_src = 1
    do n = 1, num_flds
       rcode = nf_inq_varid(ncid_src,fld_name(n), id_fld)
       call error_handler('error in inquring id of field '//trim(fld_name(n))// ' of file '//trim(src_data), rcode)
       rcode = nf_inq_varndims( ncid_src, id_fld, ndims )
       call error_handler('error in inquring ndims of field '//trim(fld_name(n))// ' of file '//trim(src_data), rcode)
       rcode = nf_inq_vardimid( ncid_src, id_fld, dimids )
       call error_handler('error in inquring dimids of field '//trim(fld_name(n))// ' of file '//trim(src_data), rcode)
       rcode = nf_inq_varnatts(ncid_src, id_fld, natt )
       call error_handler('error in inquring natt of field '//trim(fld_name(n))// ' of file '//trim(src_data), rcode)
       !--- to check if each field has z or time axis

       do m = 1, ndims
          rcode = nf_inq_dimname ( ncid_src, dimids(m), name )
          call error_handler('error in inquring dimension name of dimid', rcode)
          rcode = nf_inq_varid(ncid_src, name, id_dim)                    
          call error_handler('error in inquring variable id of '//trim(name), rcode)
          rcode = nf_inq_varnatts(ncid_src, id_dim, natt_dim)
          call error_handler('error in inquring number of attributes of variable '//trim(name), rcode)
          if(lowercase(trim(name)) == 'time') then
             cart = 'T'
             if(num_has_taxis == 0) then
                rcode = nf_inq_dimlen(ncid_src, dimids(m), ntime_src)
                call error_handler('error in inquring time dimension from file '//trim(src_data), rcode)
                allocate(time_value(ntime_src) )
                rcode = nf_get_var_double(ncid_src, id_dim, time_value) 
                call error_handler('error in inquring time value from file '//trim(src_data), rcode)
             endif
             num_has_taxis = num_has_taxis + 1   
          else             
             do i = 1, natt_dim
                rcode = nf_inq_attname(ncid_src, id_dim,i,att_name )
                call error_handler('error in inquring attribute name ', rcode)
                if(trim(att_name) == 'cartesian_axis' ) then
                   rcode = nf_get_att_text(ncid_src,id_dim,att_name,cart)
                   call error_handler('error in get attribute value of attribute '//trim(att_name), rcode)
                   select case(cart(1:1))
                   case('X','Y')
                      ! do nothing 
                   case('Z') 
                      has_zaxis(n) = .true.
                   case default
                      call error_handler('The cartesian_axis of each axis should be X, Y or Z ' )
                   end select
                   exit
                endif
             enddo
          endif

          found_dim = .false.
          do j = 1, ndims_dst
             if(trim(dims_name(j)) == trim(name)) then
                found_dim = .true.
                exit
             endif
          enddo
          if(.not. found_dim) then
             ndims_dst = ndims_dst + 1
             dims_name(ndims_dst) = trim(name)
             dims_pos(ndims_dst) = fld_pos(n)
             dims_cart(ndims_dst) = cart(1:1)
             dims_id(ndims_dst)   = id_dim
          endif
       enddo

       has_missing(n) = .false.
       do i = 1, natt
          rcode = nf_inq_attname(ncid_src, id_fld,i,name )          
          call error_handler('error in inquring attribute name', rcode)
          if(trim(name) == 'time_avg_info') then
             tavg_exist = .true.
          else if(trim(name) == 'missing_value') then
             has_missing(n) = .true.
             rcode = nf_get_att_double(ncid_src, id_fld, name, missing_value(n) )
          endif
       enddo
    enddo

    if(num_has_taxis == 0) then
       has_taxis = .false.
    else if(num_has_taxis == num_flds) then
       has_taxis = .true.
    else
       call error_handler('Either all or none of the fields has time axis ' )
    endif

    !--- suppose the time_avg_info is specified by average_T1, average_T2, average_DT.
    if(tavg_exist) then
       allocate( t1_avg(ntime_src), t2_avg(ntime_src), dt_avg(ntime_src) )
       rcode = nf_inq_varid(ncid_src, 'average_T1', id_t1_src)
       call error_handler('error in inquring variable id of average_T1', rcode)
       rcode = nf_get_var_double(ncid_src,id_t1_src, t1_avg )
       call error_handler('error in getting average_T1 data', rcode)
       rcode = nf_inq_varid(ncid_src, 'average_T2', id_t2_src)
       call error_handler('error in inquring variable id of average_T2', rcode)
       rcode = nf_get_var_double(ncid_src,id_t2_src, t2_avg )
       call error_handler('error in getting average_T2 data', rcode)
       rcode = nf_inq_varid(ncid_src, 'average_DT', id_dt_src)
       call error_handler('error in inquring variable id of average_Dt', rcode)
       rcode = nf_get_var_double(ncid_src,id_dt_src, dt_avg )
       call error_handler('error in getting average_DT data', rcode)
    endif

    !--- read the global attributes from source data and write it to output file
    rcode =  nf_inq_natts(ncid_src, natt )
    call error_handler('error in inquring natts of file '//trim(src_data), rcode)
    do i = 1, natt
       rcode = nf_inq_attname(ncid_src,NF_GLOBAL,i,name )
       call error_handler('error in inquring attribute name of file '//trim(src_data), rcode)
       rcode = nf_inq_att(ncid_src,NF_GLOBAL,name,type,len)
       call error_handler('error in inquring attribute of file '//trim(src_data), rcode)
       if(type == NF_CHAR ) then      ! only keep character global attributes
          if(len .le. 512) then
             if(trim(name) == 'filename') then
                catt = trim(dst_data)
             else
                rcode = nf_get_att_text(ncid_src,NF_GLOBAL,name,catt)
                call error_handler('error in getting attribute text of file '//trim(src_data), rcode)
             endif
             if(is_root_pe) then
                rcode = nf_put_att_text(ncid_dst, NF_GLOBAL, name, len, catt )
                call error_handler('error in putting  attribute to file '//trim(dst_data), rcode)
             endif
          else
             write(stdout(),*)'GLOBAL ATT '//trim(name)//' too long - not reading this metadata'
          endif
       endif
    enddo

    !--- read dimension information from src_data and write them to dst_data file.
    if( .not. is_root_pe) then
       rcode = nf_close(ncid_src)
       return
    endif

    rcode = nf_inq_ndims(ncid_src, ndims)
    call error_handler('error in inquring ndims of file '//trim(src_data), rcode)
    do j = 1, ndims_dst
       if(lowercase(trim(dims_name(j)))=='time' ) then
          rcode = nf_def_dim(ncid_dst, dims_name(j), NF_UNLIMITED, dims_dst(j))
          call error_handler('error in defining time dimension of file '//trim(dst_data), rcode)
          rcode = nf_def_var(ncid_dst, dims_name(j), NF_DOUBLE, 1, dims_dst(j), id_axes(j))
          call error_handler('error in defining time variable of file '//trim(dst_data), rcode)
          id_time_dst = id_axes(j)
          dim_time_dst = dims_dst(j)
       else
          select case(dims_cart(j))
          case('X')
             len = Dst%ni
          case('Y')
             len = Dst%nj
          case('Z')
             len = Dst%nk             
          end select
          rcode = nf_def_dim(ncid_dst, dims_name(j), len, dims_dst(j))
          call error_handler('error in defining dimension '//trim(dims_name(j))//' of file '//trim(dst_data), rcode)
          rcode = nf_def_var(ncid_dst, dims_name(j), NF_DOUBLE, 1, dims_dst(j), id_axes(j) )
          call error_handler('error in defining axis var '//trim(dims_name(j))//' of file '//trim(dst_data), rcode)
       endif

       !--- write out axis attribute
       rcode = nf_inq_varnatts(ncid_src, dims_id(j), natt_dim)
       call error_handler('error in inquring number of attributes', rcode)
       do i = 1, natt_dim 
          rcode = nf_inq_attname(ncid_src, dims_id(j), i, name)             
          rcode = nf_copy_att(ncid_src,dims_id(j), name, ncid_dst, id_axes(j))
          call error_handler('error in copy attribute '//trim(name), rcode)            
       enddo
    enddo

    !--- read attribue of each field and write them to dst_data file
    do n = 1, num_flds
       rcode = nf_inq_varid(ncid_src,fld_name(n), id_fld)
       call error_handler('error in inquring id of field '//trim(fld_name(n))// ' of file '//trim(src_data), rcode)
       rcode = nf_inq_varndims( ncid_src, id_fld, ndims )
       call error_handler('error in inquring ndims of field '//trim(fld_name(n))// ' of file '//trim(src_data), rcode)
       rcode = nf_inq_vardimid( ncid_src, id_fld, dimids )
       call error_handler('error in inquring dimids of field '//trim(fld_name(n))// ' of file '//trim(src_data), rcode)
       do i = 1, ndims
          rcode = nf_inq_dimname ( ncid_src, dimids(i), name )
          call error_handler('error in inquring dimension name of dimid', rcode)
          do j = 1, ndims_dst
             if(trim(name) == trim(dims_name(j))) then
                fld_dims(i) = dims_dst(j)
                exit
             endif
          enddo
       enddo
       rcode = nf_def_var(ncid_dst, fld_name(n), NF_DOUBLE, ndims, fld_dims(1:ndims), id_dst_fld(n) )
       !--- copy the source field attribute to destination field.
       rcode = nf_inq_varnatts(ncid_src, id_fld, natt )
       call error_handler('error in inquring natt of field '//trim(fld_name(n))// ' of file '//trim(src_data), rcode)
       do i = 1, natt
          rcode = nf_inq_attname(ncid_src, id_fld, i, name)
          call error_handler('error in inquring attribute '//trim(name), rcode)  
          if(trim(name) .ne. '_FillValue') then
             rcode = nf_copy_att(ncid_src,id_fld, trim(name), ncid_dst, id_dst_fld(n))
             call error_handler('error in copy attribute '//trim(name)//' of variable '//trim(fld_name(n)), rcode)  
          endif
       enddo
       if(.not. has_missing(n)) then
          rcode = nf_put_att_double(ncid_dst, id_dst_fld(n), 'missing_value',  NF_DOUBLE, 1, missing_value(n:n) )
          call error_handler('error in put missing_value attribute of var '//trim(fld_name(n))// &
                        ' of file '//trim(dst_data), rcode)   
       endif
       call error_handler('error in defining var '//trim(fld_name(n))//' of file '//trim(dst_data), rcode)       
    enddo

    !--- define time avg info, suppose the time_avg_info is specified by average_T1, average_T2, average_DT.
    if(tavg_exist) then
       rcode = nf_def_var(ncid_dst, 'average_T1', NF_DOUBLE, 1, dim_time_dst, id_t1_dst)
       rcode = nf_inq_varnatts(ncid_src, id_t1_src, natt )
       call error_handler('error in inquring natt of average_T1 of file '//trim(src_data), rcode)       
       do i = 1, natt
          rcode = nf_inq_attname(ncid_src, id_t1_src, i, name)
          call error_handler('error in inquring average_T1 attribute '//trim(name), rcode)  
          rcode = nf_copy_att(ncid_src,id_t1_src, name, ncid_dst, id_t1_dst)
          call error_handler('error in copy average_T1 attribute '//trim(name), rcode) 
       enddo
       rcode = nf_def_var(ncid_dst, 'average_T2', NF_DOUBLE, 1, dim_time_dst, id_t2_dst)
       rcode = nf_inq_varnatts(ncid_src, id_t2_src, natt )
       call error_handler('error in inquring natt of average_T2 of file '//trim(src_data), rcode)       
       do i = 1, natt
          rcode = nf_inq_attname(ncid_src, id_t2_src, i, name)
          call error_handler('error in inquring average_T2 attribute '//trim(name), rcode)  
          rcode = nf_copy_att(ncid_src,id_t2_src, name, ncid_dst, id_t2_dst)
          call error_handler('error in copy average_T2 attribute '//trim(name), rcode) 
       enddo
       rcode = nf_def_var(ncid_dst, 'average_DT', NF_DOUBLE, 1, dim_time_dst, id_dt_dst)
       rcode = nf_inq_varnatts(ncid_src, id_dt_src, natt )
       call error_handler('error in inquring natt of average_DT of file '//trim(src_data), rcode)       
       do i = 1, natt
          rcode = nf_inq_attname(ncid_src, id_dt_src, i, name)
          call error_handler('error in inquring average_DT attribute '//trim(name), rcode)  
          rcode = nf_copy_att(ncid_src,id_dt_src, name, ncid_dst, id_dt_dst)
          call error_handler('error in copy average_DT attribute '//trim(name), rcode) 
       enddo

    endif

    rcode = nf_enddef(ncid_dst)
    rcode = nf_close(ncid_src)

    !--- write axis data to dst_data
    start = 1; nwrite = 1
    do j = 1, ndims_dst
       select case(dims_cart(j))
       case('X')
          nwrite(1) = Dst%ni
          if(dims_pos(j) == 'T' .or. dims_pos(j) == 'N') then
             rcode = nf_put_vara_double(ncid_dst,id_axes(j), start, nwrite, Dst%grid_xt )
          else
             rcode = nf_put_vara_double(ncid_dst,id_axes(j), start, nwrite, Dst%grid_xc )             
          endif
          call error_handler('error in putting data of '//trim(dims_name(j))//' to file '//trim(dst_data), rcode)
       case('Y')
          nwrite(1) = Dst%nj
          if(dims_pos(j) == 'T' .or. dims_pos(j) == 'E') then
             rcode = nf_put_vara_double(ncid_dst,id_axes(j), start, nwrite, Dst%grid_yt )
          else
             rcode = nf_put_vara_double(ncid_dst,id_axes(j), start, nwrite, Dst%grid_yc )             
          endif
          call error_handler('error in putting data of '//trim(dims_name(j))//' to file '//trim(dst_data), rcode)
       case('Z')
          nwrite(1) = Dst%nk
          rcode = nf_put_vara_double(ncid_dst,id_axes(j), start, nwrite, Dst%zt )
          call error_handler('error in putting data of '//trim(dims_name(j))//' to file '//trim(dst_data), rcode)
       end select
    enddo

  end subroutine setup_meta

  !#####################################################################

  subroutine process_data
    integer                               :: ncid_src, rcode, i, j, n, m, k, l, nf, nk_src, nk_dst
    integer                               :: start(4), nread(4), nwrite(4), id_fld(num_flds)
    integer                               :: isc, iec, jsc, jec
    integer                               :: kstart, kend
    real                                  :: temp1, temp2
    real, dimension(:,:,:,:), allocatable :: data_src, data_dst
    real, dimension(:,:,:),   allocatable :: tmp1, tmp2, tmp_src
    real, dimension(:,:,:),   allocatable :: depth_src_3d, depth_dst_3d
    real, dimension(:,:),     allocatable :: mask_in
    type(horiz_interp_type),      pointer :: Interp   => NULL()
    real, dimension(:,:),         pointer :: sinrot   => NULL(), cosrot => NULL()
    real, dimension(:,:,:),       pointer :: mask     => NULL()
    logical                               :: is_first = .true.

    isc = Dst%isc; iec = Dst%iec; jsc = Dst%jsc; jec = Dst%jec;    

    !-------------------------------------------------------------------
    !--- read src data, remap onto current grid and write output -------
    rcode = nf_open(trim(src_data), NF_NOWRITE, ncid_src)
    do n = 1, num_flds
       rcode = nf_inq_varid(ncid_src, fld_name(n), id_fld(n) )
       call error_handler('error in inquring varid of '//trim(fld_name(n))//' of file '//trim(src_data), rcode)
    enddo

    write(stdout(),*)'***************************************'
    write(stdout(),*)' ntime_src is ', ntime_src

    if(do_vertical_interp) then
       allocate(depth_src_3d(isc:iec,jsc:jec,Src%nk), depth_dst_3d(isc:iec,jsc:jec,Dst%nk))
       do k=1, Src%nk
          depth_src_3d(:,:,k) = Src%zt(k)
       enddo
       do k=1, Dst%nk
          depth_dst_3d(:,:,k) = Dst%zt(k)
       enddo
       ! for vertical interpolation, Set value of levels shallower than the shallowest source level to 
       ! be the source value at shallowest level. 
       ! Set value of levels deeper than the deepest source level to 
       ! be the source value at deepest level. 
       
       do kstart = 1, Dst%nk
          if( Dst%zt(kstart) .GE. Src%zt(1) ) exit 
       enddo
       do kend = Dst%nk, 1, -1
          if( Dst%zt(kend) .LE. Src%zt(Src%nk) ) exit 
       enddo
       if( kstart > 1 ) then
          write(stdout(),*)"NOTE from regrid_3d: the value from level 1 to level ", kstart-1, &
               " will be set to the value at the shallowest source levle."
       endif
       if( kend < Dst%nk ) then
          write(stdout(),*)"NOTE from regrid_3d: the value from level ", kend+1, " to level ", Dst%nk, &
               " will be set to the value at the deepest source levle."
       endif

    endif

    allocate(mask_in(Src%ni, Src%nj) )

    do m = 1, ntime_src
       write(stdout(),*)'******************* at time level', m
       n = 1
       !--- write out time information 
       if(is_root_pe) then
          if(has_taxis) then       
             rcode = nf_put_var1_double(ncid_dst, id_time_dst, m, time_value(m))
             call error_handler('error in put time data to file '//trim(src_data), rcode )
             if(tavg_exist) then
                rcode = nf_put_var1_double(ncid_dst, id_t1_dst, m, t1_avg(m))
                call error_handler('error in put average_T1 data to file '//trim(src_data), rcode )
                rcode = nf_put_var1_double(ncid_dst, id_t2_dst, m, t2_avg(m))
                call error_handler('error in put average_T2 data to file '//trim(src_data), rcode )
                rcode = nf_put_var1_double(ncid_dst, id_dt_dst, m, dt_avg(m))
                call error_handler('error in put average_DT data to file '//trim(src_data), rcode )
             endif
          endif
       endif

       do while ( n .le. num_flds )
          nf = 1
          if(vector_fld(n) .and. Src%is_tripolar) nf = 2
          nk_src = 1
          if(has_zaxis(n)) nk_src = Src%nk
          nk_dst = 1
          if(has_zaxis(n)) nk_dst = Dst%nk

          write(stdout(),*)'************************************************************'
          write(stdout(),*)'The following are for the # ',n,' field '//trim(fld_name(n))
          write(stdout(),*)'has_zaxis is ', has_zaxis(n)
          write(stdout(),*)'nk_dst is  ', nk_dst
          allocate(data_src(Src%ni, Src%nj, nk_src,nf), data_dst(Dst%ni, Dst%nj, nk_dst,nf) )
          allocate(tmp_src(Src%ni, Src%nj, nk_src) )
          allocate(tmp1(isc:iec,jsc:jec,nk_src), tmp2(isc:iec,jsc:jec,nk_dst) )

          select case(fld_pos(n))
          case('T')
             Interp => Interp_T
          case('C')
             Interp => Interp_C
          case('E')
             Interp => Interp_E
          case('N')
             Interp => Interp_N
          end select

          start = 1; nread = 1
          nread(1) = Src%ni; nread(2) = Src%nj;
          if(has_zaxis(n)) then
             nread(3) = nk_src; start(4) = m
          else 
             start(3) = m
          endif
          rcode = nf_get_vara_double(ncid_src,id_fld(n), start, nread, data_src(:,:,:,1) ) 
          call error_handler('error in getting '//trim(fld_name(n))//' from file '//trim(src_data), rcode )

          !--- if the field is a vector field and src_grid is tripolar, read the next field and 
          !--- rotate data onto spherical grid.
          if( vector_fld(n) .and. Src%is_tripolar ) then
             select case(fld_pos(n))
             case('T')
                sinrot => Src%T%sinrot; cosrot => Src%T%cosrot
             case('C')
                sinrot => Src%C%sinrot; cosrot => Src%C%cosrot
             case('E')
                sinrot => Src%E%sinrot; cosrot => Src%E%cosrot
             case('N')
                sinrot => Src%N%sinrot; cosrot => Src%N%cosrot
             end select

             rcode = nf_get_vara_double(ncid_src,id_fld(n+1), start, nread, data_src(:,:,:,2) ) 

             do k = 1, nk_src
                do j = 1, Src%nj 
                   do i = 1, Src%ni
                      if(data_src(i,j,k,1) /= missing_value(n)) then
                         temp1             = data_src(i,j,k,1)*cosrot(i,j)-data_src(i,j,k,2)*sinrot(i,j)
                         temp2             = data_src(i,j,k,1)*sinrot(i,j)+data_src(i,j,k,2)*cosrot(i,j)
                         data_src(i,j,k,1) = temp1
                         data_src(i,j,k,2) = temp2
                      endif
                   enddo
                enddo
             enddo
          endif

          !--- extrap data onto land grid 
          do l = 1, nf
             if(use_source_vertical_grid) then !--- the source grid mask will decide the destination data mask.
                if(apply_mask) then
                   do k = 1, size(data_src,3)
                      where(data_src(:,:,k,l) == missing_value(n) )
                         mask_in = 0.0
                      elsewhere
                         mask_in = 1.0
                      end where
                      call horiz_interp(Interp, data_src(:,:,k,l), tmp2(:,:,k), mask_in=mask_in, &
                             missing_value=missing_value(n) )
                   enddo
                else
                   if(any(data_src(:,:,:,l) == missing_value(n)))  then
                      if(Src%is_tripolar .and. is_first) then
                         is_first = .false.
                         write(stdout(),*)'WARNING: when the source is tripolar, ',      &
                             'the laplacian extrapolation will not very accurate at the tripolar region. ', &
                             'Even the source grid is lat-lon grid, the extrapolation will not also not  ', &
                             'very accurate if the lat-lon grid is not uniform. '
                      endif
                      call extrap(data_src(:,:,:,l), tmp_src, stop_crit(n), missing_value(n), fld_pos(n) ) 
                      !--- remap data onto destination horizontal grid
                      do k = 1, size(tmp_src,3)
                         call horiz_interp(Interp, tmp_src(:,:,k), tmp2(:,:,k))
                      enddo
                   else
                      !--- remap data onto destination horizontal grid
                      do k = 1, size(data_src,3)
                         call horiz_interp(Interp, data_src(:,:,k,l), tmp2(:,:,k))
                      enddo
                   endif
                endif
             else
                if(any(data_src(:,:,:,l) == missing_value(n)))  then
                   if(Src%is_tripolar .and. is_first) then
                      is_first = .false.
                      write(stdout(),*)'WARNING: when the source is tripolar, ',      &
                           'the laplacian extrapolation will not very accurate at the tripolar region. ', &
                           'Even the source grid is lat-lon grid, the extrapolation will not also not  ', &
                           'very accurate if the lat-lon grid is not uniform. '
                   endif
                   call extrap(data_src(:,:,:,l), tmp_src, stop_crit(n), missing_value(n), fld_pos(n) ) 
                   !--- remap data onto destination horizontal grid
                   do k = 1, size(tmp_src,3)
                      call horiz_interp(Interp, tmp_src(:,:,k), tmp1(:,:,k))
                   enddo
                else
                   !--- remap data onto destination horizontal grid
                   do k = 1, size(data_src,3)
                      call horiz_interp(Interp, data_src(:,:,k,l), tmp1(:,:,k))
                   enddo
                endif

                if(has_zaxis(n) .and. do_vertical_interp ) then
                   do k = 1, kstart-1
                      tmp2(:,:,k) = tmp1(:,:,1)
                   enddo

                   do k = kend+1, nk_dst
                      tmp2(:,:,k) = tmp1(:,:,nk_dst)
                   enddo
                   call interp_1d(depth_src_3d,depth_dst_3d(:,:,kstart:kend),tmp1,tmp2(:,:,kstart:kend))
                else
                   tmp2 = tmp1
                endif

                !--- apply mask if needed,
                if(apply_mask) then
                   select case(fld_pos(n))
                   case('T')
                      mask => Dst%T%mask
                   case('C')
                      mask => Dst%C%mask
                   case('E')
                      mask => Dst%E%mask
                   case('N')
                      mask => Dst%N%mask
                   end select
                   do k = 1, nk_dst
                      do j = jsc, jec
                         do i = isc, iec
                            if(mask(i,j,k) < 0.5) tmp2(i,j,k) = missing_value(n)
                         enddo
                      enddo
                   enddo
                endif
             endif
             !--- get global data ------------------------------
             call mpp_domains_set_stack_size(2*Dst%ni*Dst%nj*nk_dst)
             call mpp_global_field(Dst%domain,tmp2, data_dst(:,:,:,l) )                
          enddo

      !--- rotate the data if the field is a vector field and dst_grid is tripolar.
          if( vector_fld(n) .and. Dst%is_tripolar ) then
             select case(fld_pos(n))
             case('T')
                sinrot => Dst%T%sinrot; cosrot => Dst%T%cosrot
             case('C')
                sinrot => Dst%C%sinrot; cosrot => Dst%C%cosrot
             case('E')
                sinrot => Dst%E%sinrot; cosrot => Dst%E%cosrot
             case('N')
                sinrot => Dst%C%sinrot; cosrot => Dst%C%cosrot
             end select
             do k = 1, nk_dst
                do j = 1, Dst%nj
                   do i = 1, Dst%ni
                      if(data_dst(i,j,k,1) /= missing_value(n)) then
                         temp1             =  data_dst(i,j,k,1)*cosrot(i,j)+data_dst(i,j,k,2)*sinrot(i,j)
                         temp2             = -data_dst(i,j,k,1)*sinrot(i,j)+data_dst(i,j,k,2)*cosrot(i,j) 
                         data_dst(i,j,k,1) =  temp1
                         data_dst(i,j,k,2) =  temp2
                      endif
                   enddo
                enddo
             enddo

             select case(fld_pos(n))
             case('C')
                do k = 1, nk_dst
                   do i=1,Dst%ni/2                   
                      if(data_dst(Dst%ni-i,Dst%nj,k,1) /= missing_value(n)) then
                         data_dst(i,Dst%nj,k,1) = -1.*data_dst(Dst%ni-i,Dst%nj,k,1)
                         data_dst(i,Dst%nj,k,2) = -1.*data_dst(Dst%ni-i,Dst%nj,k,2)
                      endif
                   enddo
                enddo
             case('N')
                do k = 1, nk_dst
                   do i=1,Dst%ni/2  
                      if(data_dst(Dst%ni-i+1,Dst%nj,k,1) /= missing_value(n)) then
                         data_dst(i,Dst%nj,k,1) = -1.*data_dst(Dst%ni-i+1,Dst%nj,k,1)
                         data_dst(i,Dst%nj,k,2) = -1.*data_dst(Dst%ni-i+1,Dst%nj,k,2)
                      endif
                   enddo
                enddo
             end select
          endif
          !--- write out data from root_pe
          if(is_root_pe) then
             if(debug) write(stdout(),*)'NOTE: after regrid data chksum :', mpp_chksum(data_dst, (/mpp_root_pe()/) )
             do l = 1, nf
                start = 1; nwrite = 1
                nwrite(1) = Dst%ni; nwrite(2) = Dst%nj;
                if(has_zaxis(n)) then
                   nwrite(3) = nk_dst
                   start(4) = m
                rcode = nf_put_vara_double(ncid_dst, id_dst_fld(n+l-1), start, nwrite, data_dst(:,:,:,l) ) 
                call error_handler('error in putting '//trim(fld_name(n+l-1))//' in file '//trim(dst_data), rcode )
                else
                   start(3) = m
                rcode = nf_put_vara_double(ncid_dst, id_dst_fld(n+l-1), start, nwrite, data_dst(:,:,1,l) ) 
                call error_handler('error in putting '//trim(fld_name(n+l-1))//' in file '//trim(dst_data), rcode )
                endif
!                rcode = nf_put_vara_double(ncid_dst, id_dst_fld(n+l-1), start, nwrite, data_dst(:,:,:,l) ) 
!                call error_handler('error in putting '//trim(fld_name(n+l-1))//' in file '//trim(dst_data), rcode )
             enddo
          endif
          n = n+nf
          deallocate(data_src, data_dst, tmp_src, tmp1, tmp2)
       enddo
    enddo

    rcode = nf_close(ncid_src)
    if(is_root_pe) rcode = nf_close(ncid_dst)
    if(do_vertical_interp) deallocate(depth_src_3d, depth_dst_3d)
    deallocate(mask_in)

  end subroutine process_data

  !#####################################################################

  subroutine regrid_end


    call fms_io_exit
    call fms_end()

  end subroutine regrid_end

  !#####################################################################
  subroutine extrap(data_in, data_out, crit, missing, pos)
    real, dimension(:,:,:),  intent(in) :: data_in
    real, dimension(:,:,:), intent(out) :: data_out
    real,                    intent(in) :: crit, missing 
    character(len=1),        intent(in) :: pos     
    real                                :: resmax, initial_guess = 0.0
    integer                             :: ni,nj,nk, i, j, k, n
    real, dimension(0:size(data_in,1)+1, 0:size(data_in,2)+1) :: tmp
    real, dimension(size(data_in,1), size(data_in,2) )        :: sor, res

    ni = size(data_in,1)
    nj = size(data_in,2)
    nk = size(data_in,3)

    tmp = 0.0

    do j= 1, nj
       do i= 1, ni
          if(data_in(i,j,1) == missing) then
             tmp(i,j) = initial_guess
          endif
       enddo
    enddo


    do k=1,nk
       do j= 1, nj
          do i= 1, ni
             if(data_in(i,j,k) == missing) then
                sor(i,j) = rel_coef
             else
                tmp(i,j)=data_in(i,j,k)
                sor(i,j) = 0.0
             endif
          enddo
       enddo

       call fill_boundaries(tmp,pos)

       ! iterate
       n=1
       do            
          resmax=0.0
          do j= 1, nj
             do i= 1, ni
                res(i,j) = 0.25*(tmp(i-1,j)+tmp(i+1,j)+tmp(i,j-1)+tmp(i,j+1)) -tmp(i,j)
             enddo
          enddo

          do j= 1, nj
             do i= 1, ni
                res(i,j) = res(i,j)*sor(i,j)
                tmp(i,j)=tmp(i,j)+res(i,j)
                resmax = max(abs(res(i,j)),resmax)
             enddo
          enddo

          if(resmax .le. crit .or. n > max_iter) then
             data_out(:,:,k) = tmp(1:ni,1:nj)
             exit
          endif

          !--- update boundaries

          call fill_boundaries(tmp,pos)

          n=n+1

       enddo

       write(stdout(),'(a,i4,a,i4)') 'At k-level= ',k
       write(stdout(),'(a,i6,a)') 'Stopped after ',n,' iterations'
       write(stdout(),'(a,f10.4)') 'maxres= ',resmax

    enddo

  end subroutine extrap

  !##########################################################

  subroutine fill_boundaries(data, pos)

    real, dimension(0:,0:), intent(inout) :: data
    character(len=1),          intent(in) :: pos
    integer :: i,j, ni, nj

    ni = size(data,1) - 2
    nj = size(data,2) - 2

    if(Dst%is_cyclic) then
       data(0,1:nj) = data(ni,1:nj)
       data(ni+1,1:nj) = data(1,1:nj)
    endif

    if(Dst%is_tripolar) then
       do i = 1, ni
          select case(pos)
          case('T')
             data(i,nj+1) = data(ni-i+1,nj)
          case('C')
             data(i,nj+1) = data(ni-i,nj-1)
          case('E')
             data(i,nj+1) = data(ni-i+1,nj-1)
          case('N')
             data(i,nj+1) = data(ni-i,nj)
          end select
       enddo
    endif

    return

  end subroutine fill_boundaries

  !#####################################################################

  ! error handling routine.
  subroutine error_handler(mesg, status)
    character(len=*),  intent(in) :: mesg
    integer, optional, intent(in) :: status
    character(len=256) :: msg

    if(present(status)) then
       if(status == 0) return
       msg = nf_strerror(status)
       msg = trim(mesg)//': '// trim(msg)
    else
       msg = trim(mesg)
    endif

    call mpp_error(FATAL,trim(msg) )

  end subroutine error_handler


  !#####################################################################

end program regrid

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: Advection schemes --- grid centers\label{sec:advectionMean}
!
! !INTERFACE:
   subroutine adv_center(N,dt,h,ho,ww,Bcup,Bcdw,Yup,Ydw,method,mode,Y)
!
! !DESCRIPTION:
!
! This subroutine solves a one-dimensional advection equation. There are two
! options, depending whether the advection should be conservative or not.
! Conservative advection has to be applied when settling of sediment or
! rising of phytoplankton is considered. In this case the advection is of
! the form
!  \begin{equation}
!   \label{Yadvection_cons}
!    \partder{Y}{t} = - \partder{F}{z}
!    \comma
!  \end{equation}
! where $F=wY$ is the flux caused by the advective velocity, $w$.
!
! Non-conservative advective transport has to be applied, when the water
! has a non-zero vertical velocity. In three-dimensional applications,
! this transport would be conservative, since vertical divergence would be
! compensated by horizontal convergence and vice versa. However, the
! key assumption of one-dimensional modelling is horizontal homogeneity,
! such that we indeed have to apply a vertically non-conservative method,
! which is of the form
!  \begin{equation}
!   \label{Yadvection_noncons}
!    \partder{Y}{t} = - w\partder{Y}{z}
!                   = - \left(\partder{F}{z} - Y\partder{w}{z} \right).
!  \end{equation}
!
! The discretized form of \eq{Yadvection_cons} is
!  \begin{equation}
!   \label{advDiscretized_cons}
!   Y_i^{n+1} = Y_i^n
!   - \dfrac{\Delta t}{h_i}
!    \left( F^n_{i} - F^n_{i-1} \right)
!   \comma
!  \end{equation}
! where the integers $n$ and $i$ correspond to the present time and space
! level, respectively.
!
! For the non-conservative form \eq{Yadvection_noncons},
! an extra term needs to be included:
!  \begin{equation}
!   \label{advDiscretized_noncons}
!   Y_i^{n+1} = Y_i^n
!   - \dfrac{\Delta t}{h_i}
!    \left( F^n_{i} - F^n_{i-1} -Y_i^n \left(w_k-w_{k-1}  \right)\right).
!  \end{equation}
!
!  Which advection method is applied is decided by the flag {\tt mode},
!  which gives conservative advection \eq{advDiscretized_cons}
!  for {\tt mode=1} and
!  non-conservative advection \eq{advDiscretized_noncons} for {\tt mode=0}.
!
! Fluxes are defined at the grid faces, the variable $Y_i$ is defined at the
!  grid centers. The fluxes are computed in an upstream-biased way,
!  \begin{equation}
!   \label{upstream}
!   F^n_{i} = \dfrac{1}{\Delta t}
!   \int_{z^\text{Face}_{i} - w \Delta t}^{z^\text{Face}_{i}} Y(z') dz'
!   \point
!  \end{equation}
!  For a third-order polynomial approximation of $Y$ (see \cite{Pietrzak98}),
!  these fluxes can be written the in so-called Lax-Wendroff form as
!  \begin{equation}
!   \label{fluxDiscretized}
!    \begin{array}{rcll}
!      F_{i} &=& w_{i} \left(Y_i +  \dfrac{1}{2} \Phi^+_{i}
!      \left(1-\magn{c_{i}} \right) \left( Y_{i+1} - Y_i \right) \right)
!      \quad & \text{for} \quad w_{i} > 0
!      \comma  \\[5mm]
!      F_{i} &=& w_{i} \left(Y_{i+1} +  \dfrac{1}{2} \Phi^-_{i}
!      \left(1-\magn{c_{i}} \right) \left( Y_i - Y_{i+1} \right) \right)
!      \quad & \text{for} \quad w_{i} < 0
!      \comma
!    \end{array}
!  \end{equation}
!  where $c_{i} = 2 w_{i} \Delta t / (h_i+h_{i+1})$ is the Courant number.
!  The factors appearing in \eq{fluxDiscretized} are defined as
!  \begin{equation}
!   \label{phiDiscretized}
!  \Phi^+_{i} =  \alpha_{i} +  \beta_{i}  r^+_{i}
!  \comma
!  \Phi^-_{i} =  \alpha_{i} +  \beta_{i}  r^-_{i}
!  \comma
!  \end{equation}
!  where
!  \begin{equation}
!   \label{alphaDiscretized}
!   \alpha_{i} = \dfrac{1}{2}
!    + \dfrac{1}{6} \left( 1- 2 \magn{c_{i}} \right) \comma
!   \beta_{i} = \dfrac{1}{2}
!    - \dfrac{1}{6} \left( 1- 2 \magn{c_{i}} \right)
!  \point
!  \end{equation}
!  The upstream and downstream slope parameters are
!  \begin{equation}
!   \label{slopeDiscretized}
!   r^+_{i} = \dfrac{Y_i - Y_{i-1}}{Y_{i+1}-Y_{i}}  \comma
!   r^-_{i} = \dfrac{Y_{i+2} - Y_{i+1}}{Y_{i+1}-Y_{i}}
!  \point
!  \end{equation}
!
!  To obtain monotonic and positive schemes also in the presence of strong
!  gradients, so-called slope limiters are aplied for the factors $\Phi^+_{i}$
!  and $\Phi^-_{i}$. The two most obvious cases are
!  the first-order upstream discretisation with $\Phi^+_{i}=\Phi^-_{i}=0$
!  and the Lax-Wendroff scheme with  $\Phi^+_{i}=\Phi^-_{i}=1$.
!  The subroutine {\tt adv\_center.F90} provides six different slope-limiters,
!  all discussed in detail by \cite{Pietrzak98}:
!
! \begin{itemize}
!  \item first-order upstream ({\tt method=UPSTREAM})
!  \item second-order upstream-biased polynomial scheme ({\tt method=P1},
!        not yet implemented)
!  \item third-order upstream-biased polynomial scheme ({\tt method=P2})
!  \item third-order scheme (TVD) with Superbee limiter ({\tt method=Superbee})
!  \item third-order scheme (TVD) with MUSCL limiter ({\tt method=MUSCL})
!  \item third-order scheme (TVD) with ULTIMATE QUICKEST limiter
!        ({\tt method=P2\_PDM})
! \end{itemize}
!
!
! If during a certain time step the maximum Courant number is larger
! than one, a split iteration will be carried out which guarantees that the
! split step Courant numbers are just smaller than 1.
!
! Several kinds of boundary conditions are implemented for the upper
! and lower boundaries. They are set by the integer values {\tt Bcup}
! and {\tt Bcdw}, that have to correspond to the parameters defined
! in the module {\tt util}, see \sect{sec:utils}. The
! following choices exist at the moment:
!
! For the value {\tt flux}, the boundary values {\tt Yup} and {\tt Ydw} are
! interpreted as specified fluxes at the uppermost and lowest interface.
! Fluxes into the boundary cells are counted positive by convention.
! For the value {\tt value}, {\tt Yup} and {\tt Ydw} specify the value
! of $Y$ at the interfaces, and the flux is computed by multiplying with
! the (known) speed  at the interface. For the value {\tt oneSided},
! {\tt Yup} and {\tt Ydw} are ignored and the flux is computed
! from a one-sided first-order upstream discretisation using the speed
! at the interface and the value of $Y$ at the center of the boundary cell.
! For the value {\tt zeroDivergence}, the fluxes into and out of the
! respective boundary cell are set equal.
! This corresponds to a zero-gradient formulation, or to zero
! flux divergence in the boundary cells.
!
! Be careful that your boundary conditions are mathematically well defined.
! For example, specifying an inflow into the boundary cell with the
! speed at the boundary being directed outward does not make sense.
!
!
! !USES:
   use util
   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer,  intent(in)                :: N

!  time step (s)
   REALTYPE, intent(in)                :: dt

!  layer thickness (m)
   REALTYPE, intent(in)                :: h(0:N)

!  old layer thickness (m)
   REALTYPE, intent(in)                :: ho(0:N)

!  vertical advection speed
   REALTYPE, intent(in)                :: ww(0:N)

!  type of upper BC
   integer,  intent(in)                :: Bcup

!  type of lower BC
   integer,  intent(in)                :: Bcdw

!  value of upper BC
   REALTYPE, intent(in)                :: Yup

!  value of lower BC
   REALTYPE, intent(in)                :: Ydw

!  type of advection scheme
   integer,  intent(in)                :: method

!  advection mode (0: non-conservative, 1: conservative)
   integer,  intent(in)                :: mode
!
! !INPUT/OUTPUT PARAMETERS:
   REALTYPE                            :: Y(0:N)
!
! !DEFINED PARAMETERS:
   REALTYPE,     parameter             :: one6th=1.0d0/6.0d0
   integer,      parameter             :: itmax=100
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: adv_center.F90,v $
!  Revision 20.0  2013/12/14 00:13:57  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:01:18  smg
!  initial cvs ci to mom5
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:33:41  smg
!  updated to gotm-2012.03.09 CVS tagged code.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.5  2010-09-17 12:53:52  jorn
!  extensive code clean-up to ensure proper initialization and clean-up of all variables
!
!  Revision 1.4  2006-11-06 13:36:46  hb
!  Option for conservative vertical advection added to adv_center
!
!  Revision 1.3  2006-03-20 09:06:38  kbk
!  removed explicit double precission dependency
!
!  Revision 1.2  2005/11/18 10:59:34  kbk
!  removed unused variables - some left in parameter lists
!
!  Revision 1.1  2005/06/27 10:54:33  kbk
!  new files needed
!
!
!
!EOP
!
! !LOCAL VARIABLES:
   integer                              :: i,k,it
   REALTYPE                             :: x,r,Phi,limit
   REALTYPE                             :: Yu,Yc,Yd
   REALTYPE                             :: c,cmax
   REALTYPE                             :: cu(0:N)
!
!-----------------------------------------------------------------------
!BOC
#ifdef DEBUG
   integer, save :: Ncall = 0
   Ncall = Ncall+1
   write(*,*) 'adv_center # ',Ncall
#endif

!  initialize interface fluxes with zero
   cu   = _ZERO_

!  initialize maximum Courant number
   cmax = _ZERO_

!  compute maximum Courant number
   do k=1,N-1
      c=abs(ww(k))*dt/(0.5*(h(k)+h(k+1)))
      if (c.gt.cmax) cmax=c
   enddo

   it=min(itmax,int(cmax)+1)

!#ifdef DEBUG
   if (it .gt. 1) then
      STDERR 'In adv_center():'
      STDERR 'Maximum Courant number is ',cmax
      STDERR it,' iterations used for vertical advection'
   endif
!#endif

!  splitting loop
   do i=1,it

!     vertical loop
      do k=1,N-1

!        compute the slope ration
         if (ww(k) .gt. _ZERO_) then

!           compute Courant number
            c=ww(k)/float(it)*dt/(0.5*(h(k)+h(k+1)))

            if (k .gt. 1) then
               Yu=Y(k-1)                              ! upstream value
            else
               Yu=Y(k)
            end if
            Yc=Y(k  )                                 ! central value
            Yd=Y(k+1)                                 ! downstream value

!           compute slope ration
            if (abs(Yd-Yc) .gt. 1e-10) then
               r=(Yc-Yu)/(Yd-Yc)
            else
               r=(Yc-Yu)*1.e10
            end if

!        negative speed
         else

!           compute Courant number
            c=-ww(k)/float(it)*dt/(0.5*(h(k)+h(k+1)))

            if (k .lt. N-1) then
               Yu=Y(k+2)                              ! upstream value
            else
               Yu=Y(k+1)
            end if
            Yc=Y(k+1)                                 ! central value
            Yd=Y(k  )                                 ! downstream value


!           compute slope ratio
            if (abs(Yc-Yd) .gt. 1e-10) then
               r=(Yu-Yc)/(Yc-Yd)
            else
               r=(Yu-Yc)*1.e10
            end if

         end if

!        compute the flux-factor phi
         x    =  one6th*(1.-2.0*c)
         Phi  =  (0.5+x)+(0.5-x)*r

!        limit the flux according to different suggestions
         select case (method)
            case (UPSTREAM)
               limit=_ZERO_
            case (P1)
               FATAL "P1 advection method not yet implemented, choose other method"
               stop  "adv_center.F90"
            case ((P2),(P2_PDM))
               if (method.eq.P2) then
                  limit=Phi
               else
                  limit=max(_ZERO_,min(Phi,2./(1.-c),2.*r/(c+1.e-10)))
               end if
            case (Superbee)
               limit=max(_ZERO_, min(_ONE_, 2.0*r), min(r,2.*_ONE_) )
            case (MUSCL)
               limit=max(_ZERO_,min(2.*_ONE_,2.0*r,0.5*(1.0+r)))
            case default
               LEVEL3 method
               FATAL 'unkown advection method in adv_center()'
               stop
          end select

!        compute the limited flux
         cu(k)=ww(k)*(Yc+0.5*limit*(1-c)*(Yd-Yc))

      end do

!     do the upper boundary conditions
      select case (Bcup)
      case (flux)
         cu(N) = - Yup              ! flux into the domain is positive
      case (value)
         cu(N) =  ww(N)*Yup
      case (oneSided)
         if (ww(N).ge._ZERO_) then
            cu(N) =  ww(N)*Y(N)
         else
            cu(N) = _ZERO_
         end if
      case (zeroDivergence)
         cu(N) = cu(N-1)
      case default
         FATAL 'unkown upper boundary condition type in adv_center()'
         stop
      end select


!     do the lower boundary conditions
      select case (Bcdw)
      case (flux)
         cu(0) =   Ydw               ! flux into the domain is positive
      case (value)
         cu(0) =  ww(0)*Ydw
      case (oneSided)
         if(ww(0).le._ZERO_) then
            cu(0) =  ww(0)*Y(1)
         else
            cu(0) = _ZERO_
         end if
      case (zeroDivergence)
         cu(0) = cu(1)
      case default
         FATAL 'unkown lower boundary condition type in adv_center()'
         stop
      end select

!     do the vertical advection step which will be used for prescribed
!     vertical flow velocity and for settling of suspended matter.

      if (mode.eq.0) then ! non-conservative
         do k=1,N
            Y(k)=Y(k)-1./float(it)*dt*((cu(k)-cu(k-1))/        &
                 h(k)-Y(k)*(ww(k)-ww(k-1))/h(k))
         enddo
      else                ! conservative
         do k=1,N
            Y(k)=Y(k)-1./float(it)*dt*((cu(k)-cu(k-1))/h(k))
         enddo
      end if

   end do ! end of the iteration loop


#ifdef DEBUG
   write(*,*) 'Leaving adv_center()'
   write(*,*)
#endif

   return
   end subroutine adv_center
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

     module strat_chem_driver_mod


use mpp_mod, only: input_nml_file 
use              fms_mod, only : file_exist, &
                                 check_nml_error,  &
                                 close_file, open_namelist_file, &
                                 stdlog, write_version_number, &
                                 error_mesg, FATAL
use              mpp_io_mod, only: mpp_open, mpp_close, &
                       MPP_NATIVE, MPP_RDONLY, MPP_DELETE

use   tracer_manager_mod, only : get_tracer_index, NO_TRACER
use    field_manager_mod, only : MODEL_ATMOS

use                mpp_mod, only: mpp_pe, mpp_root_pe, stdout
use constants_mod, only : PI, TFREEZE, GRAV, PSTD_MKS, RDGAS

use STRAT_CHEM_MOD, only : chemistry, zen2, dcly_dt, sediment
     implicit none

private
!----------- ****** VERSION NUMBER ******* ---------------------------

character(len=128)  :: version =  '$Id: strat_chem_driver.F90,v 19.0 2012/01/06 20:32:12 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'
logical             :: module_is_initialized = .FALSE.

!-------  interfaces --------

public   strat_chem_driver_init,   strat_chem, strat_chem_driver_end


!----------- namelist -------------------


integer     :: fixed_chem_year= 0   ! 

real        :: n2o_foto_accel= 1.0     !      

logical     :: do_coupled_stratozone = .false.  ! Do I want to use this routine?

namelist / strat_chem_nml /         &
                   fixed_chem_year, n2o_foto_accel, do_coupled_stratozone 





     logical               :: run_startup = .true.
     real  ::   ozon(11,48),cosp(14),cosphc(48),photo(132,14,11,48),    &
           solardata(1801),chlb(90,15),ozb(144,90,12),tropc(151,9),    &
           dfdage(90,48,8),anoy(90,48)
     integer :: mype

!  When initializing additional tracers, the user needs to make the
!  following changes.
!
!  Add an integer variable below for each additional tracer. 
!  This should be initialized to zero. 
!
!-----------------------------------------------------------------------

integer :: nsphum = 0
integer :: nliq_wat = 0
integer :: nice_wat = 0
integer :: ncld_amt = 0
integer :: nhno3 = 0
integer :: nn2o5 = 0
integer :: nh2o2 = 0
integer :: nhcl = 0
integer :: nhocl = 0
integer :: nclono2 = 0
integer :: nh2co = 0
integer :: noy = 0
integer :: nhobr = 0
integer :: nhno4 = 0
integer :: nhbr = 0
integer :: nbrono2 = 0
integer :: nch3ooh = -1
integer :: nco = 0
integer :: nnoy = 0
integer :: ncly = 0
integer :: nbry = 0
integer :: nch4 = 0
integer :: nstrath2o = 0
integer :: nn2o = 0
integer :: nage = 0
integer :: no3 = 0
integer :: no3ch = 0
integer :: nextinct = 0
integer :: naerosol = 0

     CONTAINS

function strat_chem_driver_init()
 logical :: strat_chem_driver_init

      integer                 :: unit, ierr, io, logunit
!---------------------------------------------------------------------
!    read strat_chem namelist.
!---------------------------------------------------------------------


         if (file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
           read (input_nml_file, nml=strat_chem_nml, iostat=io)
           ierr = check_nml_error(io,'strat_chem_nml')
#else
           unit =  open_namelist_file ( )
           ierr=1; do while (ierr /= 0)
           read (unit, nml=strat_chem_nml, iostat=io, end=10)
           ierr = check_nml_error (io, 'strat_chem_nml')
           enddo
 10        call close_file (unit)
#endif
         endif

     strat_chem_driver_init = do_coupled_stratozone
     
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit=stdlog()
      if (mpp_pe() == mpp_root_pe()) write (logunit, nml=strat_chem_nml)
 
      module_is_initialized = .true.

      if (.not. do_coupled_stratozone) return
!---------------------------------------------------------------------

      call chem_startup
      
end function strat_chem_driver_init

subroutine strat_chem_driver_end

      module_is_initialized = .false.

end subroutine strat_chem_driver_end

     subroutine chem_startup()
!
! Obtains chemical lower boundary condition and arrays for photolysis 
! rate calculation
!



      real age(90,48,12)
      integer lev,ipz,icz,lv,nc,jl,ir
!
!   local variables: 

      integer                 :: unit, outunit

      if(run_startup) then
         run_startup = .false.


      nsphum    = get_tracer_index(MODEL_ATMOS,'sphum')    !Tracer #1
      nliq_wat  = get_tracer_index(MODEL_ATMOS,'liq_wat')   !Tracer #2
      nice_wat  = get_tracer_index(MODEL_ATMOS,'ice_wat')   !Tracer #3
      ncld_amt  = get_tracer_index(MODEL_ATMOS,'cld_amt')   !Tracer #4
      nhno3     = get_tracer_index(MODEL_ATMOS,'HNO3')      !Tracer #5
      nn2o5     = get_tracer_index(MODEL_ATMOS,'N2O5')      !Tracer #6
      nh2o2     = get_tracer_index(MODEL_ATMOS,'H2O2')      !Tracer #7
      nhcl      = get_tracer_index(MODEL_ATMOS,'HCl')       !Tracer #8
      nhocl     = get_tracer_index(MODEL_ATMOS,'HOCl')      !Tracer #9
      nclono2   = get_tracer_index(MODEL_ATMOS,'ClONO2')    !Tracer #10
      nh2co     = get_tracer_index(MODEL_ATMOS,'H2CO')      !Tracer #11
      noy       = get_tracer_index(MODEL_ATMOS,'Oy')        !Tracer #12
      nhobr     = get_tracer_index(MODEL_ATMOS,'HOBr')      !Tracer #13
      nhno4     = get_tracer_index(MODEL_ATMOS,'HNO4')      !Tracer #14
      nhbr      = get_tracer_index(MODEL_ATMOS,'HBr')       !Tracer #15
      nbrono2   = get_tracer_index(MODEL_ATMOS,'BrONO2')    !Tracer #16
      nch3ooh   = get_tracer_index(MODEL_ATMOS,'CH3OOH')    !Tracer #17
      nco       = get_tracer_index(MODEL_ATMOS,'CO')        !Tracer #18
      nnoy      = get_tracer_index(MODEL_ATMOS,'NOy')       !Tracer #19
      ncly      = get_tracer_index(MODEL_ATMOS,'Cly')       !Tracer #20
      nbry      = get_tracer_index(MODEL_ATMOS,'Bry')       !Tracer #21
      nch4      = get_tracer_index(MODEL_ATMOS,'CH4')       !Tracer #22
      nstrath2o = get_tracer_index(MODEL_ATMOS,'StratH2O')  !Tracer #23
      nn2o      = get_tracer_index(MODEL_ATMOS,'N2O')       !Tracer #24
      nage      = get_tracer_index(MODEL_ATMOS,'Age')       !Tracer #25
      no3       = get_tracer_index(MODEL_ATMOS,'O3')        !Tracer #26
      no3ch     = get_tracer_index(MODEL_ATMOS,'O3_chem')   !Tracer #27
      nextinct  = get_tracer_index(MODEL_ATMOS,'Extinction')!Tracer #28
      naerosol  = get_tracer_index(MODEL_ATMOS,'Aerosol')   !Tracer #29

      if ( nliq_wat  == NO_TRACER .or. nice_wat  == NO_TRACER .or. &
           ncld_amt  == NO_TRACER .or. nhno3     == NO_TRACER .or. &
           nn2o5     == NO_TRACER .or. nh2o2     == NO_TRACER .or. &
           nhcl      == NO_TRACER .or. nhocl     == NO_TRACER .or. &
           nclono2   == NO_TRACER .or. nh2co     == NO_TRACER .or. &
           noy       == NO_TRACER .or. nhobr     == NO_TRACER .or. &
           nhno4     == NO_TRACER .or. nhbr      == NO_TRACER .or. &
           nbrono2   == NO_TRACER .or. nch3ooh   == NO_TRACER .or. &
           nco       == NO_TRACER .or. nnoy      == NO_TRACER .or. &
           ncly      == NO_TRACER .or. nbry      == NO_TRACER .or. &
           nch4      == NO_TRACER .or. nstrath2o == NO_TRACER .or. &
           nn2o      == NO_TRACER .or. nage      == NO_TRACER .or. &
           no3       == NO_TRACER .or. no3ch     == NO_TRACER ) &
         call error_mesg ('Strat_chem_driver', &
                          'A necessary tracer is missing from the field_table &
                          &and thus will not allow strat_chem to run correctly.', FATAL)  

!  read in chemical lower boundary 
!  
         outunit = stdout()
         call mpp_open( unit, 'INPUT/chemlbf',action=MPP_RDONLY )
         if (mpp_pe() == mpp_root_pe()) WRITE(outunit,*) 'INPUT/chemlbf'
         DO NC = 1,15                                           
           READ(unit,'(6E13.6)') (CHLB(JL,NC),JL=1,90) 
         ENDDO                                                          
         READ(unit,'(6E13.6)') OZB  
         read(unit,'(6e13.6)') tropc
         call mpp_close(unit)
!
!  read in photolysis files
!         
         call mpp_open( unit, 'INPUT/photolsmax', action=MPP_RDONLY )
         if (mpp_pe() == mpp_root_pe()) WRITE(outunit,*) 'INPUT/photolsmax'
         DO LEV = 1,48                                            
         DO IPZ = 1,11                                               
         DO ICZ = 1,14                                               
         READ(unit,'(I4,E12.4,2F10.4,5(/6E12.4),/3E12.4)') &
           LV,OZON(IPZ,LEV),COSP(ICZ),COSPHC(LEV), &
           (PHOTO(IR,ICZ,IPZ,LEV),IR=1,33)
         READ(unit,'(5(6E12.4/),3E12.4)')   &
           (PHOTO(IR,ICZ,IPZ,LEV),IR=34,66)
         enddo
         enddo
         enddo
         call mpp_close(unit)
         call mpp_open( unit, 'INPUT/photolsmin', action=MPP_RDONLY )
         if (mpp_pe() == mpp_root_pe()) WRITE(outunit,*) 'INPUT/photolsmin'
         DO LEV = 1,48                                            
         DO IPZ = 1,11                                               
         DO ICZ = 1,14                                               
         READ(unit,'(I4,E12.4,2F10.4,5(/6E12.4),/3E12.4)') &
           LV,OZON(IPZ,LEV),COSP(ICZ),COSPHC(LEV), &
           (PHOTO(IR,ICZ,IPZ,LEV),IR=67,99)
         READ(unit,'(5(6E12.4/),3E12.4)')   &
           (PHOTO(IR,ICZ,IPZ,LEV),IR=100,132)
         enddo
         enddo
         enddo
         call mpp_close(unit)
         call mpp_open( unit, 'INPUT/solar_f107.dat', action=MPP_RDONLY )
         if (mpp_pe() == mpp_root_pe()) WRITE(outunit,*) 'INPUT/solar_f107.dat'
         read(unit,'(f6.0,5f7.0)') solardata
         call mpp_close(unit)
         DO LEV = 1,48                                              
         DO IPZ = 1,11                                               
         DO ICZ = 1,14                                               
         DO IR = 1,132                                                
         PHOTO(IR,ICZ,IPZ,LEV) = ALOG(PHOTO(IR,ICZ,IPZ,LEV)+1.E-30)     
         enddo
         enddo
         enddo
         enddo
!
!  read in data for Cly and Bry computation
!         
         call mpp_open( unit, 'INPUT/dfdage.dat', action=MPP_RDONLY )
         if (mpp_pe() == mpp_root_pe()) WRITE(outunit,*) 'INPUT/dfdage.dat'
         read(unit,'(6e13.6)') age
         read(unit,'(6e13.6)') dfdage
         call mpp_close(unit)
!
!  read in data for NOy tropospheric relaxation
!         
         call mpp_open( unit, 'INPUT/noy_annual.dat', action=MPP_RDONLY )
         if (mpp_pe() == mpp_root_pe()) WRITE(outunit,*) 'INPUT/noy_annual.dat'
         read(unit,'(6e13.6)') anoy
         call mpp_close(unit)
     endif



     return
     end   subroutine chem_startup

     subroutine strat_chem(alon,alat,chems,dchems,pfull,temp,itime,    &
       is,ie,js,je,dt,coszen,&
       nsphum,chem_tend,ozone,o3_prod,aerosol,mype)
     real, intent(in), dimension(:,:,:,:)  :: chems
     real, intent(in), dimension(:,:,:,:)  :: dchems
     real, intent(in), dimension(:,:,:)    :: pfull, temp 
     real, intent(in), dimension(:,:)      :: alon,alat,coszen
     real, intent(in)                      :: dt
     real, intent(out), dimension(:,:,:,:) :: chem_tend
     real, intent(out), dimension(:,:,:)   :: ozone, o3_prod, aerosol
     integer, intent(in)                   :: is,ie,js,je,nsphum,mype
     integer, intent(inout), dimension(6)  :: itime
!
     integer :: nc,il,jl,kl,merids,lats,levs
     integer :: ipts           
!
     real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) ::     &
                               ozcol,anat,aice,alats,cly,bry,age
     real, dimension(size(pfull,1)) :: h2o,h2o_tend,dagesq

     real  ::   cozen(ie-is+1,je-js+1),vtemp(size(pfull,1)),           &
                rho(size(pfull,1)),dy(size(pfull,1),21),               &
                ch_tend(size(pfull,1),21),                             &
                drad,darg,delta,cdx,cozi,cozj1,cozj2,const,const2,xc,  &
                vtau10,fact2,cond,extinct
!
     if(.not. do_coupled_stratozone) return ! You do not want to do stratospheric chemistry
     merids = size(pfull,1)
     lats = size(pfull,2)
     levs = size(pfull,3)
     drad = 3.141592653589793/180.        
     const =  287.056*273.16/(1.01325*9.81)                 
     const2 = 2.693e19 *273.16/101325.

     chem_tend(:,:,:,:) = 0.0
!wfc Comment out for now
!     drad = PI/180.        
!     const =  RDGAS*TFREEZE/(PSTD_MKS*1.e-5*GRAV)                 
!     const2 = 2.693e19 *TFREEZE/PSTD_MKS
!

!  change model time to fit in with chemical time
      
    if( fixed_chem_year > 0 )  itime(1) = fixed_chem_year
!    if(mpp_pe()==mpp_root_pe()) print *,' time', itime

!
! Compute cosine of solar zenith angle
!
     call zen2 (itime,dt,drad,darg,delta,cdx)
     do jl = 1,je-js+1     
     do il = 1,ie-is+1
     cozi = cos(darg+alon(il,jl))
     cozj1 = cos(alat(il,jl))*cos(delta)                                 
     cozj2 = sin(alat(il,jl))*sin(delta)             
     cozen(il,jl) = cozj2 + cozj1*cozi
     enddo
     enddo
!
! Calculate overhead ozone columns for photolysis
! Allow for transport problems with a 1 e-15 minimum for ozone.
!
     do jl = 1,je-js+1
     do il = 1,ie-is+1
     xc = chems(il,jl,1,no3) 
     if(xc.lt.1.0e-15) xc = 1.0e-15
     ozcol(il,jl,1) = xc*const*pfull(il,jl,1)
     do kl = 2,levs
     xc =  sqrt(chems(il,jl,kl,no3)*chems(il,jl,kl-1,no3)) 
     if(xc.lt.1.0e-15) xc = 1.0e-15
     ozcol(il,jl,kl) = ozcol(il,jl,kl-1) +                    &
        const*(pfull(il,jl,kl) - pfull(il,jl,kl-1))*xc         
     enddo
     enddo
     enddo
!=========================================================================
! Do main loop over model levels
!
!==========================================================================

     do 1000 kl = 1,levs
     do jl = js,je    
!
!  Set up inverse temperature and density for use in the chemical model
!  CHEMISTRY computes the chemical change for one model timestep, one latitude
!  row at a time and converts this into a rate of change chem_tend
!  chems isn't necessarily positive definite, depending on the transport 
!  scheme, so the values are set to zero within the chemistry scheme
!  and the concentration is relaxed to zero with a 1-day timescale 
!
     do il = is,ie
     vtemp(il) = 1.0/temp(il,jl,kl)
     rho(il) = const2*pfull(il,jl,kl)*vtemp(il)
     dy(il,1 ) = chems(il,jl,kl,nhno3    ) + dchems(il,jl,kl,nhno3    )*dt
     dy(il,2 ) = chems(il,jl,kl,nn2o5    ) + dchems(il,jl,kl,nn2o5    )*dt
     dy(il,3 ) = chems(il,jl,kl,nh2o2    ) + dchems(il,jl,kl,nh2o2    )*dt
     dy(il,4 ) = chems(il,jl,kl,nhcl     ) + dchems(il,jl,kl,nhcl     )*dt
     dy(il,5 ) = chems(il,jl,kl,nhocl    ) + dchems(il,jl,kl,nhocl    )*dt
     dy(il,6 ) = chems(il,jl,kl,nclono2  ) + dchems(il,jl,kl,nclono2  )*dt
     dy(il,7 ) = chems(il,jl,kl,nh2co    ) + dchems(il,jl,kl,nh2co    )*dt
     dy(il,8 ) = chems(il,jl,kl,noy      ) + dchems(il,jl,kl,noy      )*dt
     dy(il,9 ) = chems(il,jl,kl,nhobr    ) + dchems(il,jl,kl,nhobr    )*dt
     dy(il,10) = chems(il,jl,kl,nhno4    ) + dchems(il,jl,kl,nhno4    )*dt
     dy(il,11) = chems(il,jl,kl,nhbr     ) + dchems(il,jl,kl,nhbr     )*dt
     dy(il,12) = chems(il,jl,kl,nbrono2  ) + dchems(il,jl,kl,nbrono2  )*dt
     dy(il,13) = chems(il,jl,kl,nch3ooh  ) + dchems(il,jl,kl,nch3ooh  )*dt
     dy(il,14) = chems(il,jl,kl,nco      ) + dchems(il,jl,kl,nco      )*dt
     dy(il,15) = chems(il,jl,kl,nnoy     ) + dchems(il,jl,kl,nnoy     )*dt
     dy(il,16) = chems(il,jl,kl,ncly     ) + dchems(il,jl,kl,ncly     )*dt
     dy(il,17) = chems(il,jl,kl,nbry     ) + dchems(il,jl,kl,nbry     )*dt
     dy(il,18) = chems(il,jl,kl,nch4     ) + dchems(il,jl,kl,nch4     )*dt
     dy(il,19) = chems(il,jl,kl,nstrath2o) + dchems(il,jl,kl,nstrath2o)*dt
     dy(il,20) = chems(il,jl,kl,nn2o     ) + dchems(il,jl,kl,nn2o     )*dt
     dy(il,21) = chems(il,jl,kl,nage     ) + dchems(il,jl,kl,nage     )*dt
     h2o_tend(il) = 0.0
     do nc = 1,21
     ch_tend(il,nc) = 0.0
     if(dy(il,nc).lt.0.0) then
        ch_tend(il,nc) = -dy(il,nc)/86400.0
        dy(il,nc) = 0.0
     endif
     enddo
     if(dy(il,8).lt.1.0e-15) dy(il,8) = 1.0e-15
     if(dy(il,15).lt.1.0e-15) dy(il,15) = 1.0e-15
!
! Set water vapour values from the main model after converting to vmr or
! use stratospheric h2o: chems(...,23), which includes sedimented terms. 
! 
!  Note: values are separated into gas and solid phases in the heterogeneous 
!  chemistry subroutine
!
     h2o(il) = chems(il,jl,kl,nsphum)*1.61
!     cond = chems(il,jl,kl,2) + chems(il,jl,kl,3)
      cond = chems(il,jl,kl,nliq_wat) + chems(il,jl,kl,nice_wat)
    h2o(il) = h2o(il) + cond*1.61
     if(h2o(il) < 1.0e-7) h2o(il) = 1.0e-7
!     dagesq(il) = (chems(il,jl,levs,25) - chems(il,jl,kl,25))**2
     dagesq(il) = (chems(il,jl,levs,nage) - chems(il,jl,kl,nage))**2
!
!  No more than 5 ppmv water in the extra-tropical lower stratosphere
!
     if(h2o(il) > 5.0e-6.and.dagesq(il) > 0.01.and.pfull(il,jl,kl) > 1.0e4) &
         h2o(il) = 5.0e-6
     ozone(il,jl,kl) = chems(il,jl,kl,no3)!26)
     o3_prod(il,jl,kl) = chems(il,jl,kl,no3ch)!27)
     extinct = 0.0
     if (nextinct > 0 ) extinct = chems(il,jl,kl,nextinct)*1000.0
     if(extinct.eq.0.0) then
       aerosol(il,jl,kl) = 0.0
     elseif(extinct <= 4.0e-3) then
       aerosol(il,jl,kl) = 4.25e-6*extinct**0.68
     elseif(extinct > 4.0e-3.and.extinct <= 2.0e-2) then
       aerosol(il,jl,kl) = 1.223e-5*extinct**0.875
     elseif(extinct > 2.0e-2) then
       aerosol(il,jl,kl) = 2.0e-5*extinct 
     endif
     enddo
     call chemistry (alon(:,jl),alat(:,jl),jl,kl,dy,h2o,dagesq,ozcol(:,jl,kl),  &
       pfull(:,jl,kl),rho,temp(:,jl,kl),vtemp,cozen(:,jl),cdx,chlb,       &
       ozb(:,:,itime(2)),anat(:,jl,kl),aice(:,jl,kl),photo,solardata,     &
       ozon,cosp,cosphc,anoy,aerosol(:,jl,kl),dt,merids,ch_tend,   &
       ozone(:,jl,kl), o3_prod(:,jl,kl),h2o_tend,mype,itime)

     do il = 1,merids

!     do nc = 1,21
!     chem_tend(il,jl,kl,nc+4     ) = ch_tend(il,nc)
     chem_tend(il,jl,kl,nhno3    ) = ch_tend(il,1 )
     chem_tend(il,jl,kl,nn2o5    ) = ch_tend(il,2 )
     chem_tend(il,jl,kl,nh2o2    ) = ch_tend(il,3 )
     chem_tend(il,jl,kl,nhcl     ) = ch_tend(il,4 )
     chem_tend(il,jl,kl,nhocl    ) = ch_tend(il,5 )
     chem_tend(il,jl,kl,nclono2  ) = ch_tend(il,6 )
     chem_tend(il,jl,kl,nh2co    ) = ch_tend(il,7 )
     chem_tend(il,jl,kl,noy      ) = ch_tend(il,8 )
     chem_tend(il,jl,kl,nhobr    ) = ch_tend(il,9 )
     chem_tend(il,jl,kl,nhno4    ) = ch_tend(il,10)
     chem_tend(il,jl,kl,nhbr     ) = ch_tend(il,11)
     chem_tend(il,jl,kl,nbrono2  ) = ch_tend(il,12)
     chem_tend(il,jl,kl,nch3ooh  ) = ch_tend(il,13)
     chem_tend(il,jl,kl,nco      ) = ch_tend(il,14)
     chem_tend(il,jl,kl,nnoy     ) = ch_tend(il,15)
     chem_tend(il,jl,kl,ncly     ) = ch_tend(il,16)
     chem_tend(il,jl,kl,nbry     ) = ch_tend(il,17)
     chem_tend(il,jl,kl,nch4     ) = ch_tend(il,18)
     chem_tend(il,jl,kl,nstrath2o) = ch_tend(il,19)
     chem_tend(il,jl,kl,nn2o     ) = ch_tend(il,20)
     chem_tend(il,jl,kl,nage     ) = ch_tend(il,21)
!     enddo
     chem_tend(il,jl,kl,nsphum) = h2o_tend(il)/1.61
!     chem_tend(il,jl,kl,2:4) = 0.0
     chem_tend(il,jl,kl,nliq_wat) = 0.0
     chem_tend(il,jl,kl,nice_wat) = 0.0
     chem_tend(il,jl,kl,ncld_amt) = 0.0
!
!  Relax tracer 23 to the total vmr of PSC
!  Relax Oy to 2e-6 if it exceeds this value in the upper mesosphere
!
     chem_tend(il,jl,kl,nstrath2o) = (aice(il,jl,kl) + 3.0*anat(il,jl,kl)  -  &
                 chems(il,jl,kl,nstrath2o))/21600.0 !23 <- nstrath2o
 !    if(pfull(il,jl,kl) < 10.0.and.chems(il,jl,kl,noy) > 2.0e-6)    &
 !        chem_tend(il,jl,kl,noy) = (2.0e-6  - chems(il,jl,kl,noy))/21600.0
     enddo
     enddo
1000 continue
! 
! compute rate of change of Cly and Bry
!
     fact2 = 1.00
     do kl = 1,levs
     alats(:,:,kl) = 1.0 + (90.0 - alat(:,:))*89.0/180.0
     enddo
     age(:,:,:) = chems(:,:,:,nage)!25)
     cly(:,:,:) = chems(:,:,:,ncly)!20)
     bry(:,:,:) = chems(:,:,:,nbry)!21)
     CALL DCLY_DT(age,dfdage,tropc,alats,cly,bry,chem_tend(:,:,:,ncly),  &
        chem_tend(:,:,:,nbry),fact2,merids,lats,levs,itime)
!
!  set rates of change of Cly and Bry to zero at night, and double during
!  the daytime
!
     do jl = 1,je-js+1
     do il = 1,merids
     if(cozen(il,jl).gt.0.0) then
         chem_tend(il,jl,:,ncly) = 2.*chem_tend(il,jl,:,ncly)
         chem_tend(il,jl,:,nbry) = 2.*chem_tend(il,jl,:,nbry)
     else
         chem_tend(il,jl,:,ncly) = 0.0
         chem_tend(il,jl,:,nbry) = 0.0
     endif
     enddo
     enddo
!
!  Rainout of HNO3, Cly and Bry in the troposphere; relax age of air to zero 
!  also in troposphere, defined by delta Age < 0.1
!
     vtau10 = 1.0/(10.0*86400.0)
     do kl = 1,levs
     do jl = 1,je-js+1
     do il = 1,merids
     dagesq(il) = (chems(il,jl,levs,nage) - chems(il,jl,kl,nage))**2
     if (dagesq(il).lt.1.0e-2)  then
          chem_tend(il,jl,kl,ncly) = (1.0e-13 - chems(il,jl,kl,ncly))*vtau10
          chem_tend(il,jl,kl,nbry) = (1.0e-15 - chems(il,jl,kl,nbry))*vtau10
          chem_tend(il,jl,kl,nage) = - chems(il,jl,kl,nage)*vtau10
     endif
     enddo
     enddo
     enddo
!
! sediment nat and ice
!
     ipts = merids*lats
     CALL SEDIMENT(anat,aice,chem_tend(:,:,:,nnoy),chem_tend(:,:,:,nstrath2o),   &
         chem_tend(:,:,:,nhno3),ipts,levs,pfull,dt,mype)
     return
     end subroutine strat_chem

     end module strat_chem_driver_mod

module ocean_blob_static_free_mod
!
!<CONTACT EMAIL="m.bates@student.unsw.edu.au"> Michael L. Bates
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! This module controls and runs the free static Lagrangian blob 
! parameterisations.
!</OVERVIEW>
!
!<DESCRIPTION>
! There are three available static blob schemes.  None are sanctioned
! for their physical integrity, but they have been important in the 
! development and testing of the Lagrangian framework.
!
! The first free static scheme emulates the NCON scheme of Cox (1984).
! The second is a scheme that acts in a diffusive manner, while the third
! swaps the properties of adjacent grid cells.  Details of all three schemes
! can be found in Bates et al. (2010).
!</DESCRIPTION>
!
!<INFO>
!
! <REFERENCE>
! S.M. Griffies, Elements of mom4p1 (2009)
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
! <REFERENCE>
! Cox, M.D., 1984, A Primitive Equation, 3-Dimensional Model of the
! Ocean.  NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
!</INFO>
!<NAMELIST NAME="ocean_blob_static_free_nml">
!
!  <DATA NAME="blob_ncon_like" TYPE="logical">
!  If true, will use NCon-like formulation. 
!  Default blob_ncon_like = .true. 
!  </DATA> 
!
!  <DATA NAME="blob_diff_like" TYPE="logical">
!  If true, will use the diffusion-like formulation. 
!  Default is "blob_diff_like=.false.
!  </DATA>
!
!  <DATA NAME="blob_swap_like" TYPE="logical">
!  If true, will use the swap-like formulation.  
!  Default is blob_switch_like=.false.
!  </DATA>
!
!  <DATA NAME="ncon_blob" TYPE="integer">
!  The number of times that the water column is checked and adjusted
!  for instability.
!  </DATA>
!</NAMELIST>
!
use fms_mod, only: open_namelist_file, check_nml_error, stdout, stdlog, FATAL, mpp_error
use fms_mod, only: close_file, mpp_error

use ocean_blob_util_mod, only: blob_delete
use ocean_density_mod,   only: density
use ocean_types_mod,     only: ocean_time_type, ocean_grid_type, ocean_domain_type
use ocean_types_mod,     only: ocean_thickness_type, ocean_density_type
use ocean_types_mod,     only: ocean_prog_tracer_type, ocean_blob_type
use ocean_workspace_mod, only: wrk1

implicit none

private

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()

logical :: module_is_initialized=.false.

real, dimension(:,:,:), allocatable :: ocean_mask
integer :: num_prog_tracers=0
integer :: index_temp=-1
integer :: index_salt=-1
integer :: isd,ied,jsd,jed,isc,iec,jsc,jec,nk

public blob_static_free_init
public blob_static_free
public blob_static_free_end

!namelist defaults
logical :: use_this_module = .false.
logical :: blob_ncon_like  = .false. ! for NCON-like scheme.
logical :: blob_diff_like  = .false. ! for Diffusion-like scheme.
logical :: blob_swap_like  = .false. ! for Swap-like scheme.
integer :: ncon_blob       = 7       ! equivalent to traditional ncon

namelist /ocean_blob_static_free_nml/ use_this_module, blob_ncon_like, blob_diff_like, &
                                      blob_swap_like,ncon_blob

contains

!#######################################################################
! <SUBROUTINE NAME="blob_static_free_init">
!
! <DESCRIPTION>
! Initialises the free static schemes.
! </DESCRIPTION>
!
subroutine blob_static_free_init(Grid, Domain, num_tracers, itemp, isalt)

  type(ocean_grid_type),   intent(in), target :: Grid
  type(ocean_domain_type), intent(in), target :: Domain
  integer, intent(in) :: num_tracers
  integer, intent(in) :: itemp
  integer, intent(in) :: isalt

  integer :: k
  integer :: ioun, ierr, io_status
  integer :: stdoutunit,stdlogunit 

  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL,&
         '==>Error in ocean_blob_static_free_mod (ocean_blob_static_free_init):' &
         //' module already initialized')
  endif 

  ! provide for namelist over-ride of default values
  ioun =  open_namelist_file()
  read (ioun,ocean_blob_static_free_nml,IOSTAT=io_status)
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_blob_static_free_nml)  
  write (stdlogunit,ocean_blob_static_free_nml)
  ierr = check_nml_error(io_status,'ocean_blob_static_free_nml')
  call close_file (ioun)

  module_is_initialized=.true.

  if(.not. use_this_module) return

  if(blob_ncon_like) then 
     write(stdoutunit,'(a,i2)') & 
     ' ==>Note: Using the static Lagrangian blob NCon-like convection scheme '&
     //'equivalent to ncon=',ncon_blob
  endif

  if(blob_diff_like) then
          write(stdoutunit,'(a)') &
     ' ==>Note: Using the static Lagrangian Diffusion like convection scheme '
  endif

  if(blob_swap_like) then
          write(stdoutunit,'(a)') &
     ' ==>Note: Using the static Lagrangian Swap convection scheme '
  endif

  index_temp       = itemp
  index_salt       = isalt
  num_prog_tracers = num_tracers

  Grd => Grid
  Dom => Domain

  isd=Dom%isd; ied=Dom%ied; jsd=Dom%jsd; jed=Dom%jed
  isc=Dom%isc; iec=Dom%iec; jsc=Dom%jsc; jec=Dom%jec
  nk = Grd%nk

  ! Makes an ocean/land mask where land values are k*1e30 and
  ! ocean values are 0.0
  allocate(ocean_mask(isd:ied,jsd:jed,nk))
  do k=1,nk
     ocean_mask(:,:,k) = -real(k)*1.e30*(Grd%tmask(:,:,k) - 1)
  enddo

end subroutine blob_static_free_init
! </SUBROUTINE>  NAME="blob_static_free_init"


!#######################################################################
! <SUBROUTINE NAME="blob_static_free">
!
! <DESCRIPTION>
! A subroutine that is called by the main driver blob module, 
! ocean_blob_mod.  The present module in turn calls the three available
! static schemes.  They are not mutually exclusive and so may be run
! in any combination.
!
! Note that only the NCON-like scheme has been implemented.
! </DESCRIPTION>
!
subroutine blob_static_free(Time, Thickness, T_prog, Dens, head)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_thickness_type),   intent(inout) :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_blob_type),        pointer       :: head

  if (.not. use_this_module) return

  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
         '==>Error in ocean_blob_static_free_mod (Static free blob model): module '&
         //' needs to be initialized')
  endif 

  if(blob_ncon_like) call blob_ncon_like_scheme(Time, Thickness, T_prog(:), Dens, head)

  if(blob_diff_like) then
     call mpp_error(FATAL, &
      '==>Error in ocean_blobs_mod (Lagrangian blob model): '&
      //'blob_diff_like=.true. not yet implemented.') 
  endif

  if(blob_swap_like) then
     call mpp_error(FATAL, &
      '==>Error in ocean_blobs_mod (Lagrangian blob model): '&
      //'blob_swap_like=.true. not yet implemented.') 
  endif

end subroutine blob_static_free
! </SUBROUTINE>  NAME="blob_static_free"


!######################################################################
! <SUBROUTINE NAME="blob_ncon_like_scheme">
!
! <DESCRIPTION>
! Run the Lagrangian blob model for the NCon-like scheme.  This scheme
! is a static scheme and uses Lagrangian blobs to homogenise adjacent 
! vertical grid cells by by transferring mass and tracer between them.
!
! This scheme is activated by setting the namelist variable 
! blob_ncon_like=.true.  The number of times that the domain is checked
! for instability is set by the integer namelist variable ncon_blob, of 
! which the default value is 7.
!
! It is based on the original convective adjustment scheme of 
! Cox (1984).
!
! See section 2.1 of Bates et al. for further details.
! </DESCRIPTION>
!
subroutine blob_ncon_like_scheme(Time, Thickness, T_prog, Dens, head)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_thickness_type),   intent(inout) :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_blob_type),        pointer       :: head

  real    :: rhodztk, rhodztkp1, dat, rho_dzt_dat_r
  real    :: mass_blob
  integer :: i, j, k, n, nn, taup1, l, ks, kp1
  type(ocean_blob_type), pointer :: this => NULL()

  taup1 = Time%taup1

  ! ks=1: compare levels 1 to 2; 3 to 4; etc.
  ! ks=2: compare levels 2 to 3; 4 to 5; etc.
  do nn = 1,ncon_blob
     do ks = 1,2

        ! find density with reference pressure determined by vertical pairs 
        do j=jsc,jec
           do l=1,nk,2
              if (ks .eq. 1) then
                 k = min(l+1,nk)
              else
                 k = l
              endif
              do i=isc,iec
                 wrk1(i,j,l)  =density(T_prog(index_salt)%field(i,j,l,taup1),&
                                       T_prog(index_temp)%field(i,j,l,taup1),&
                                       Dens%pressure_at_depth(i,j,k))
              enddo
           enddo
        enddo
        
        do j=jsc,jec
           do l=2,nk,2
              if (ks .eq. 1) then
                 k = l
              else
                 k = min(l+1,nk)
              endif
              do i=isc,iec
                 wrk1(i,j,l)=density(T_prog(index_salt)%field(i,j,l,taup1),&
                                     T_prog(index_temp)%field(i,j,l,taup1),&
                                     Dens%pressure_at_depth(i,j,k))
              enddo
           enddo
        enddo

        ! set "heavy water" in land to stop convection
        wrk1(:,:,:) = wrk1(:,:,:) + ocean_mask(:,:,:)

        do k=ks,nk-1,2
           kp1 = k+1
           do j=jsc,jec
              do i=isc,iec
                 ! test for instability
                 if(wrk1(i,j,k)>wrk1(i,j,kp1)) then
                    ! some shorthand variables for convenience
                    rhodztk   = Thickness%rho_dzt(i,j,k,  taup1)
                    rhodztkp1 = Thickness%rho_dzt(i,j,kp1,taup1)
                    dat       = Grd%dat(i,j)
                    
                    ! compute the mass per unit area of the two blobs.  Note that 
                    ! dat is the same for both k and kp1;
                    ! mass=(dat*rhodztk * dat*rhodztkp1)/(dat(rhodztk + rhodztkp1))
                    !     =dat*rhodztk*rhodztkp1/(rhodztk + rhodztkp1)
                    mass_blob = dat*(rhodztk*rhodztkp1)/(rhodztk + rhodztkp1)

                    ! form the sinking blob
                    call nconblobform(k,  .true.)
                    
                    ! form the rising blob
                    call nconblobform(kp1,.false.)
                 endif
              enddo
           enddo
        enddo
  

        ! now that the blobs have been formed and their properties
        ! transferred from the Eulerian system to the Lagrangian system:
        ! 1/ move the blobs
        ! 2/ complete the diagnostics
        ! Note: see comments in blob_form for rationale of units and
        ! variables used for transferring properties between Eulerian and
        ! Lagrangian system.
        if(associated(head)) then
           this=>head

           blobmove: do
              ! for convenience and readability
              i = this%i
              j = this%j
              k = this%k
           
              ! now move the blobs
              if (this%sink) then
                 ! it is a sinking blob, so move it down one grid cell
                 k = k + 1
              else
                 ! it is a rising blob, so move it up one grid cell
                 k = k - 1
              endif
              this%k = k
              
              ! some shorthand variables for convenience
              rho_dzt_dat_r = Grd%datr(i,j)*Thickness%rho_dztr(i,j,k)
           
              ! transfer mass from the Lagrangian system to the Eulerian System
              Thickness%rho_dzt(i,j,k,taup1) = Thickness%rho_dzt(i,j,k,taup1)&
                                               + this%mass*Grd%datr(i,j)
              this%mass = 0.0
        
              ! transfer tracer from the Lagrangian system to the Eulerian System
              do n=1,num_prog_tracers
                 T_prog(n)%field(i,j,k,taup1) = T_prog(n)%field(i,j,k,taup1) &
                                                + this%tracer(n)*rho_dzt_dat_r
                 this%tracer(n) = 0.0
              enddo

              ! set pointer to the next blob
              this=>this%next

              !if there is no next blob, then exit the loop
              if(.not.associated(this)) exit blobmove
           enddo blobmove
        
           nullify(this)
        endif
        ! delete all approximately zero mass blobs (which should be all of 
        ! them in the ncon_like_scheme).                                   
        call blob_delete(Time, Thickness, T_prog(:), head)
     enddo !ks=1,2
  enddo !ncon_blob

contains
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that forms the blobs for the             !
! ncon_like_scheme                                                     !
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine nconblobform(this_k,this_sink)

    integer :: this_k
    logical :: this_sink
    
    ! local variables
    type(ocean_blob_type), pointer :: new_blob => NULL()

    ! allocate memory to the sinking blob object
    allocate(new_blob)
    allocate(new_blob%tracer(num_prog_tracers))

    ! allocate properties to the sinking blob
    new_blob%sink = this_sink

    new_blob%i = i
    new_blob%j = j
    new_blob%k = this_k

    ! transfer mass from the Eulerian system to the Lagrangian system
    ! blob%mass is in units (kg) & rho_dzt is in units (kg/m^3)*(m)
    Thickness%rho_dzt(i,j,this_k,taup1) = Thickness%rho_dzt(i,j,this_k,taup1)&
                                           - mass_blob*Grd%datr(i,j)
    new_blob%mass = mass_blob

    ! compute the tracer content of the blob and transfer 
    ! that tracer from the Eulerian system to the Lagrangian system
    rho_dzt_dat_r = Grd%datr(i,j)*Thickness%rho_dztr(i,j,this_k)
    do n=1,num_prog_tracers
       ! new_blob%tracer is blob_mass*[concentration]
       new_blob%tracer(n) = new_blob%mass*T_prog(n)%field(i,j,this_k,taup1)
       ! this calculates the reduction in concentration of a grid cell
       T_prog(n)%field(i,j,this_k,taup1) = T_prog(n)%field(i,j,this_k,taup1) &
                            - new_blob%tracer(n)*rho_dzt_dat_r
    enddo

    ! Add the new blob to the top (head) of the list.  Only one blob can exist in a grid cell
    ! at a time.  So, there is no requirement to order the blobs within the list (see the 
    ! subroutine insert_blob for more details about ordering)
    new_blob%next => head
    new_blob%prev => NULL()
    if(associated(head)) head%prev => new_blob
    head      => new_blob

    !now disassociate the new_blob pointer from the new blob object
    nullify(new_blob)
              
  end subroutine nconblobform


end subroutine blob_ncon_like_scheme
! </SUBROUTINE>  NAME="blob_ncon_like_scheme"


!######################################################################
! <SUBROUTINE NAME="blob_static_free_end">
!
! <DESCRIPTION>
! Ends the free static module.
! </DESCRIPTION>
!
subroutine blob_static_free_end()

  if (.not. use_this_module) return

  nullify(Dom)
  nullify(Grd)

end subroutine blob_static_free_end
! </SUBROUTINE>  NAME="blob_static_free_end"

end module ocean_blob_static_free_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: Calculate steady-state Richardson number from c3\label{sec:Rist}
!
! !INTERFACE:
   REALTYPE function  compute_rist(c1,c2,c3)
!
! !DESCRIPTION:
! Numerically computes the steady-state Richardson-number $Ri_{st}$
! for two-equations models from the given
! $c_{\psi 3}$ and the parameters
! $c_{\psi 1}$ and $c_{\psi 2}$ according to \eq{Ri_st}.
! A (very tricky) double Newton-iteration is used to solve the resulting
! implicit non-linear equation.
!
! !USES:
   use turbulence, only:           as,an,cmue1,cmue2
   use turbulence, only:           cm0
   use turbulence, only:           turb_method,stab_method
   use turbulence, only:           cm0_fix,Prandtl0_fix
   use turbulence, only:           Constant
   use turbulence, only:           MunkAnderson
   use turbulence, only:           SchumGerz
   use turbulence, only:           EiflerSchrimpf
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)           :: c1,c2,c3
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard, Lars Umlauf
!
!EOP
!-----------------------------------------------------------------------
! !LOCAL VARIABLES:
     integer                      :: i,j
     integer,parameter            :: imax=100
     REALTYPE                     :: cc3,fc,fp,step,ann
     REALTYPE                     :: ffc,ffp,Ri,Rii
     REALTYPE                     :: NN(0:2),SS(0:2)
     logical                      :: converged
     REALTYPE,parameter           :: e=1.e-9,ee=1.e-4
!
!-----------------------------------------------------------------------
!BOC
   NN=0.
   SS=0.
   Ri=0.18  ! Initial guess for Rist
   converged = .true.

   do j=0,imax
      Rii=Ri
      ann=0.1
      do i=0,imax
         an(1)=ann
         as(1)=an(1)/Rii
         if (turb_method.eq.2) then
            select case(stab_method)
               case(Constant)
                  cmue1=cm0_fix
                  cmue2=cm0_fix/Prandtl0_fix
               case(MunkAnderson)
                  call cmue_ma(2)
               case(SchumGerz)
                  call cmue_sg(2)
               case(EiflerSchrimpf)
                  call cmue_rf(2)
            end select
         else
            call cmue_d(2)
         end if
         fc=cmue1(1)*an(1)/Rii-cmue2(1)*an(1)-cm0**(-3)
         an(1)=ann+e
         as(1)=an(1)/Rii
         if (turb_method.eq.2) then
            select case(stab_method)
               case(Constant)
                  cmue1=cm0_fix
                  cmue2=cm0_fix/Prandtl0_fix
               case(MunkAnderson)
                  call cmue_ma(2)
               case(SchumGerz)
                  call cmue_sg(2)
               case(EiflerSchrimpf)
                  call cmue_rf(2)
            end select
         else
            call cmue_d(2)
         end if
         fp=cmue1(1)*an(1)/Rii-cmue2(1)*an(1)-cm0**(-3)
         step=-fc/((fp-fc)/e)
         ann=ann+0.5*step

         if (abs(step).gt.100.) then
            STDERR '                                                 '
            STDERR 'Method for calculating the steady-state Richardson'
            STDERR 'number Rist does not converge.'
            STDERR 'Probably, the prescribed value for c3'
            STDERR 'is outside the range of the chosen stability function.'
            STDERR 'Please change gotmturb.nml accordingly.'
            STDERR 'You have chosen the stability function no.',stab_method
            STDERR 'If the problem persists, then use another'
            STDERR 'stability function.'
            STDERR 'I will continue anyway. Good luck!'
            STDERR '                                                 '
            converged=.false.
            goto 333
         endif

         if (abs(step).lt.1.e-10) goto 111
      end do
111   an(1)=ann
      as(1)=an(1)/Rii
      if (turb_method.eq.2) then
         select case(stab_method)
            case(Constant)
               cmue1=cm0_fix
               cmue2=cm0_fix/Prandtl0_fix
            case(MunkAnderson)
               call cmue_ma(2)
            case(SchumGerz)
               call cmue_sg(2)
            case(EiflerSchrimpf)
               call cmue_rf(2)
         end select
      else
         call cmue_d(2)
      end if
      cc3=c2+(c1-c2)/Rii*cmue1(1)/cmue2(1)
      ffc=cc3-c3

      Rii=Ri+ee
      ann=0.1
      do i=0,imax
         an(1)=ann
         as(1)=an(1)/Rii
         if (turb_method.eq.2) then
            select case(stab_method)
               case(Constant)
                  cmue1=cm0_fix
                  cmue2=cm0_fix/Prandtl0_fix
               case(MunkAnderson)
                  call cmue_ma(2)
               case(SchumGerz)
                  call cmue_sg(2)
               case(EiflerSchrimpf)
                  call cmue_rf(2)
            end select
         else
            call cmue_d(2)
         end if
         fc=cmue1(1)*an(1)/Rii-cmue2(1)*an(1)-cm0**(-3)
         an(1)=ann+e
         as(1)=an(1)/Rii
         if (turb_method.eq.2) then
            select case(stab_method)
               case(Constant)
                  cmue1=cm0_fix
                  cmue2=cm0_fix/Prandtl0_fix
               case(MunkAnderson)
                  call cmue_ma(2)
               case(SchumGerz)
                  call cmue_sg(2)
               case(EiflerSchrimpf)
                  call cmue_rf(2)
            end select
         else
            call cmue_d(2)
         end if
         fp=cmue1(1)*an(1)/Rii-cmue2(1)*an(1)-cm0**(-3)
         step=-fc/((fp-fc)/e)
         ann=ann+0.5*step
         if (abs(step).gt.100.) then
            STDERR 'Method for calculating the steady-state Richardson'
            STDERR 'number Rist does not converge.'
            STDERR 'Probably, the prescribed value for c3'
            STDERR 'is outside the range of the chosen stability function.'
            STDERR 'Please change gotmturb.nml accordingly.'
            STDERR 'You have chosen the stability function no.',stab_method
            STDERR 'If the problem persists, then use another'
            STDERR 'stability function.'
            STDERR 'I will continue anyway. Good luck!'
            STDERR '                                                 '
            converged=.false.
            goto 333
         endif
         if (abs(step).lt.1.e-10) goto 222
      end do
222   an(1)=ann
      as(1)=an(1)/Rii
      if (turb_method.eq.2) then
         select case(stab_method)
            case(Constant)
               cmue1=cm0_fix
               cmue2=cm0_fix/Prandtl0_fix
            case(MunkAnderson)
               call cmue_ma(2)
            case(SchumGerz)
               call cmue_sg(2)
            case(EiflerSchrimpf)
               call cmue_rf(2)
         end select
      else
         call cmue_d(2)
      end if
      cc3=c2+(c1-c2)/Rii*cmue1(1)/cmue2(1)
      ffp=cc3-c3

      step=-ffc/((ffp-ffc)/ee)
      Ri=Ri+0.25*step
      if (abs(step).gt.100.) then
         STDERR '                                                 '
         STDERR 'Method for calculating the steady-state Richardson'
         STDERR 'number Rist does not converge.'
         STDERR 'Probably, the prescribed value for c3'
         STDERR 'is outside the range of the chosen stability function.'
         STDERR 'Please change gotmturb.nml accordingly.'
         STDERR 'You have chosen the stability function no.',stab_method
         STDERR 'If the problem persists, then use another'
         STDERR 'stability function.'
         STDERR 'I will continue anyway. Good luck!'
         STDERR '                                                 '
         converged=.false.
         goto 333
    endif
      if (abs(step).lt.1.e-10) goto 333
   end do

333   compute_rist=Ri

   if (.not.converged) compute_rist=-999.

   return
   end function compute_rist
!EOC
!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module bgrid_prog_var_mod

!-----------------------------------------------------------------------
!
!     allocates memory for B-grid core prognostics variables
!    and provides several routines for handling these variables
!
!     the module has routines for:
!       1) setting up the prognostic variables in a data structure
!       2) performing simple arithmetic with this data structure
!       3) applying forward explicit time differencing 
!       4) reading and writing prognostic variable restart files
!
!-----------------------------------------------------------------------

use      bgrid_horiz_mod, only: horiz_grid_type
use       bgrid_vert_mod, only: vert_grid_type
use      bgrid_masks_mod, only: grid_mask_type
use       bgrid_halo_mod, only: update_halo, TEMP, UWND, VWND
use bgrid_cold_start_mod, only: cold_start_resol, cold_start
use              fms_mod, only: file_exist, open_restart_file, mpp_error, &
                                FATAL, close_file, mpp_pe, mpp_root_pe,   &
                                set_domain, read_data, write_data,        &
                                write_version_number, nullify_domain,     &
                                field_size, NOTE, mpp_chksum,             &
                                error_mesg, FATAL, stdout, stdlog,        &
                                uppercase
use    field_manager_mod, only: MODEL_ATMOS
use   tracer_manager_mod, only: get_tracer_names, set_tracer_profile

use         platform_mod, only: I8_KIND

implicit none
private

public :: prog_var_type, prog_var_init, var_init,  &
          prog_var_time_diff, prog_var_times_scalar, &
          prog_var_equals_scalar
public :: open_prog_var_file, read_prog_var, write_prog_var

!-----------------------------------------------------------------------
! type(prog_var_type)
!     data structure that contains all prognostic fields and tracers
!
!     nlon = size of the global x-axis compute grid
!             (i.e., number of longitude points)
!     nlat = size of the global y-axis compute grid
!             (i.e., number of latitude points)
!     nlev = number of vertical levels
!     ntrace = number of tracers (in the current data structure)
!
!     ilb, iub = lower and upper index bounds of x-axis (data domain)
!     jlb, jub = lower and upper index bounds of y-axis (data domain)
!     klb, kub = lower and upper index bounds of k-axis
!
! arrays with dimension(ilb:iub,jlb:jub)
!     ps   = surface pressure
!     pssl = surface pressure adjusted to eta=1. (for eta coordinate)
!
! arrays with dimension(ilb:iub,jlb:jub,klb:kub)
!     u    = zonal wind component
!     v    = meridional wind component
!     t    = temperature
!
! arrays with dimension(ilb:iub,jlb:jub,klb:kub,1:ntrace)
!     r    = arbitrary number of tracers
!
!-----------------------------------------------------------------------

type prog_var_type
     integer       :: nlon, nlat, nlev, ntrace
     integer       :: ilb, iub, jlb, jub, klb, kub
     real, pointer :: ps(:,:) =>NULL(), &
                      pssl(:,:) =>NULL()
     real, pointer :: u(:,:,:) =>NULL(), &
                      v(:,:,:) =>NULL(), &
                      t(:,:,:) =>NULL(), &
                      r(:,:,:,:) =>NULL()
end type prog_var_type

! overloaded interface for initializing real model arrays
interface var_init
    module procedure var_init_type_4d, var_init_bound_4d, &
                     var_init_type_3d, var_init_bound_3d, &
                     var_init_type_2d, var_init_bound_2d
end interface

!-----------------------------------------------------------------------
! private data

logical :: do_log = .true.
character(len=128) :: version='$Id: bgrid_prog_var.F90,v 13.0 2006/03/28 21:05:18 fms Exp $'
character(len=128) :: tagname='$Name: tikal $'

integer :: unit_in
character(len=128) :: directory_in
logical :: read_pssl
logical :: old_restart_format, do_cold_start

character(len=64) :: res_file_name = 'bgrid_prog_var.res'

character(len=80) :: restart_format = &
              'bgrid grid atmospheric dynamical core: restart format 05'

contains

!#######################################################################
! creates a prog_var_type variable

 subroutine prog_var_init (Hgrid, nlev, ntrs, Vars)

  type(horiz_grid_type), intent(in)    :: Hgrid
  integer,               intent(in)    :: nlev, ntrs
  type(prog_var_type)  , intent(inout) :: Vars
!-----------------------------------------------------------------------
! write version info to logfile
  if (do_log) then
    call write_version_number(version, tagname)
    do_log = .false.
  endif

! all arrays have the same horizontal dimensions regardless of
! whether the field is on the temperature or velocity grid

    Vars % ilb = Hgrid % ilb
    Vars % iub = Hgrid % iub
    Vars % jlb = Hgrid % jlb
    Vars % jub = Hgrid % jub
    Vars % klb = 1
    Vars % kub = nlev

    Vars % nlon = Hgrid % nlon
    Vars % nlat = Hgrid % nlat
    Vars % nlev = nlev
    Vars % ntrace = ntrs

    Vars % ps   => var_init_bound_2d (Vars % ilb, Vars % iub, &
                                      Vars % jlb, Vars % jub)

    Vars % pssl => var_init_bound_2d (Vars % ilb, Vars % iub, &
                                      Vars % jlb, Vars % jub)

    Vars % u => var_init_bound_3d (Vars % ilb, Vars % iub, &
                                   Vars % jlb, Vars % jub, &
                                   nlev)
    Vars % v => var_init_bound_3d (Vars % ilb, Vars % iub, &
                                   Vars % jlb, Vars % jub, &
                                   nlev)
    Vars % t => var_init_bound_3d (Vars % ilb, Vars % iub, &
                                   Vars % jlb, Vars % jub, &
                                   nlev)
    Vars % r => var_init_bound_4d (Vars % ilb, Vars % iub, &
                                   Vars % jlb, Vars % jub, &
                                   nlev, ntrs)

 end subroutine prog_var_init

!#######################################################################
!##### overloaded functions that allocate a single real variable #######
!#######################################################################
!
!      variables must be declard as pointers
!      real, pointer :: field(:,:,:)
!      field => var_init (Hgrid,nlev)
!
!#######################################################################

 function var_init_bound_2d (ilb, iub, jlb, jub) result (var)

  integer, intent(in)           :: ilb, iub, jlb, jub
  real, dimension(:,:), pointer :: var

    allocate ( var (ilb:iub, jlb:jub) )
    var = 0.0

 end function var_init_bound_2d

!#######################################################################

 function var_init_type_2d (Hgrid) result (var)

  type(horiz_grid_type), intent(in) :: Hgrid
  real, dimension(:,:), pointer     :: var

    var => var_init_bound_2d (Hgrid % ilb, Hgrid % iub, &
                              Hgrid % jlb, Hgrid % jub)

 end function var_init_type_2d

!#######################################################################

 function var_init_bound_3d (ilb, iub, jlb, jub, kdim) result (var)

  integer, intent(in)             :: ilb, iub, jlb, jub, kdim
  real, dimension(:,:,:), pointer :: var

    allocate ( var (ilb:iub, jlb:jub, 1:kdim) )
    var = 0.0

 end function var_init_bound_3d

!#######################################################################

 function var_init_type_3d (Hgrid, kdim) result (var)

  type(horiz_grid_type), intent(in) :: Hgrid
  integer, intent(in)               :: kdim
  real, dimension(:,:,:), pointer   :: var

    var => var_init_bound_3d (Hgrid % ilb, Hgrid % iub, &
                              Hgrid % jlb, Hgrid % jub, kdim)

 end function var_init_type_3d

!#######################################################################

 function var_init_bound_4d (ilb, iub, jlb, jub, kdim, ntrace) result (var)

  integer, intent(in)               :: ilb, iub, jlb, jub, kdim, ntrace
  real, dimension(:,:,:,:), pointer :: var

    allocate ( var (ilb:iub, jlb:jub, 1:kdim, 1:ntrace) )
    var = 0.0

 end function var_init_bound_4d

!#######################################################################

 function var_init_type_4d (Hgrid, kdim, ntrace) result (var)

  type(horiz_grid_type), intent(in)   :: Hgrid
  integer, intent(in)                 :: kdim, ntrace
  real, dimension(:,:,:,:), pointer   :: var

    var => var_init_bound_4d (Hgrid % ilb, Hgrid % iub, &
                              Hgrid % jlb, Hgrid % jub, kdim, ntrace)

 end function var_init_type_4d

!#######################################################################
!#######################################################################
! sets all prognostic variables to a scalar

 subroutine prog_var_equals_scalar (Var, scalar)

  type(prog_var_type), intent(inout) :: Var
  real               , intent(in)    :: scalar

     Var % u    = scalar
     Var % v    = scalar
     Var % t    = scalar
     Var % r    = scalar
     Var % ps   = scalar
     Var % pssl = scalar

 end subroutine prog_var_equals_scalar

!#######################################################################
! multiplies all prognostic variables by a scalar

 subroutine prog_var_times_scalar (Var, scalar)

  type(prog_var_type), intent(inout) :: Var
  real               , intent(in)    :: scalar

     Var % u    = Var % u    * scalar
     Var % v    = Var % v    * scalar
     Var % t    = Var % t    * scalar
     Var % r    = Var % r    * scalar
     Var % ps   = Var % ps   * scalar
     Var % pssl = Var % pssl * scalar

 end subroutine prog_var_times_scalar

!#######################################################################
! performs time differencing on all prognostic variables
!             Var = Var + dt * Var_dt
! all tracers are used unless argument nt is supplied

 subroutine prog_var_time_diff (dt, Masks, Var_dt, Var, nt)

  real,                 intent(in)    :: dt
  type(grid_mask_type), intent(in)    :: Masks
  type(prog_var_type),  intent(inout) :: Var_dt, Var
  integer, optional,    intent(in)    :: nt

  integer :: ntp, i, j, k

!----- explicit differencing with two time levels -----

   ntp = Var_dt % ntrace
   if (present(nt)) ntp = min(Var_dt%ntrace, nt)

   Var % ps   = Var % ps   + dt * Var_dt % ps
   Var % pssl = Var % pssl + dt * Var_dt % pssl

   Var % u = Var % u + dt * Var_dt % u
   Var % v = Var % v + dt * Var_dt % v
   Var % t = Var % t + dt * Var_dt % t

   Var % r(:,:,:,1:ntp) = Var % r(:,:,:,1:ntp) + &
                                dt * Var_dt % r(:,:,:,1:ntp)

  ! apply mask for step-mountain
   if (.not.Masks%sigma) then
       do k = Var%klb, Var%kub
       do j = Var%jlb, Var%jub
       do i = Var%ilb, Var%iub
          if (Masks%Vel%mask(i,j,k) < .01) then
             Var % u (i,j,k) = 0.
             Var % v (i,j,k) = 0.
          endif
        ! temp & tracers
          if (Masks%Tmp%mask(i,j,k) < .01) then
             Var % t (i,j,k) = 0.
             Var % r (i,j,k,1:ntp) = 0.
          endif
       enddo
       enddo
       enddo
   endif

!----- zero out tendencies -----

   Var_dt % ps   = 0.0
   Var_dt % pssl = 0.0

   Var_dt % u = 0.0
   Var_dt % v = 0.0
   Var_dt % t = 0.0

   Var_dt % r(:,:,:,1:ntp) = 0.0


 end subroutine prog_var_time_diff

!#######################################################################
!########## routines for reading and writing restart files #############
!#######################################################################

subroutine open_prog_var_file ( ix, jx, kx, dir )

!-----------------------------------------------------------------------
! This routine can open for reading either a NATIVE or NETCDF restart
! file.  Only the model resolution is returned. A subsequent call to 
! read_prog_var is needed to read the data.
! The restart file is called "INPUT/bgrid_prog_var.res".
! For NetCDF files a ".nc" suffix is added.
!
!   ix, jx, kx = global resolution read from the restart file
!   dir        = directory where input restart files reside
!                  for the current directory use: "" or "."
!                  default: "INPUT"
!-----------------------------------------------------------------------
 integer,          intent(out)          :: ix, jx, kx
 character(len=*), intent(in), optional :: dir

 integer :: ic, vers, day, sec, ntsd, nt, ntp, siz(4)
 character(len=128) :: filename_in
 character(len=80)  :: control
 character(len=2)   :: avers

! write version info to logfile
  if (do_log) then
    call write_version_number(version, tagname)
    do_log = .false.
  endif

! set-up restart directory and file name
  directory_in = 'INPUT/'
  if (present(dir)) then
      if (len_trim(dir) > 0) then
          directory_in = trim(dir)//"/"
      else
          directory_in = '' ! null string
      endif
  endif

  filename_in = trim(directory_in)//trim(res_file_name)

! when restart file does not exist
! set up simple initial conditions

  if (file_exist(trim(filename_in)//'.nc') ) then
       call field_size (trim(filename_in)//'.nc', 't', siz )
       ix = siz(1); jx = siz(2); kx = siz(3)
       if (min(ix,jx,kx) <= 0) call mpp_error ('bgrid_prog_var_mod', &
                        'problem reading field size; siz <= 0', FATAL)
       old_restart_format = .false.
       do_cold_start      = .false.
       if (mpp_pe() == mpp_root_pe()) call mpp_error ('bgrid_prog_var_mod', &
                              'Reading NetCDF formatted restart file.', NOTE)

! old native format restart files
  else if (file_exist(trim(filename_in)) ) then

      ! open restart file and get restart version number
      ! if control record cannot be read then file uses older format (1 or 2)
        unit_in = open_restart_file ( trim(filename_in), 'read' )
        old_restart_format = .true.
        do_cold_start      = .false.
        if (mpp_pe() == mpp_root_pe()) call mpp_error ('bgrid_prog_var_mod', &
                               'Reading native formatted restart file.', NOTE)
        read  (unit_in,err=2)  control 

      ! extract version number
        ic = index(control,'restart format ')
        if (ic == 0) call mpp_error ('bgrid_prog_var_mod', &
                     'problem extracting restart version number', FATAL)
        avers = control(ic+15:ic+16)
        read (avers,'(i2.2)') vers
        go to 3 

      ! read version number from old format (first rewind file)
      2 rewind (unit_in)
        read   (unit_in) vers
        write  (avers,'(i2.2)') vers

      ! read first (non-control) record of restart file
      ! note: ntsd,day,sec are no longer used and
      !       number of time levels (nvar) is not read or used
      3 continue
        select case (vers)
          case (1:2)
               read  (unit_in) ntsd, day, sec, ix, jx, kx, nt, ntp
               read_pssl = .false.
          case (3)
               read  (unit_in) ntsd, day, sec, ix, jx, kx, nt, ntp
               read_pssl = .true.
          case (4)
               read  (unit_in) ix, jx, kx, nt, ntp
               read_pssl = .true.
          case (5)
               read  (unit_in) ix, jx, kx
               read_pssl = .true.
          case default
             call mpp_error ('bgrid_prog_var_mod', &
                             'cannot not read old restart version '//avers, FATAL)
        end select

! no restart --> self start
  else
       call cold_start_resol ( ix, jx, kx )
       do_cold_start = .true.
       read_pssl = .false.
       return
  endif

end subroutine open_prog_var_file

!#######################################################################

subroutine read_prog_var (Hgrid, Var, eta, peta, fis, res)

!-----------------------------------------------------------------------
! This routine can read either a NATIVE or NETCDF restart file.
!
! Hgrid  = horizontal grid constants
! Var    = prognostic variables
! eta    = sigma/eta/bk values at model layer interfaces (half levels)
! peta   = reference pressures (pk) at model layer interfaces
! fis    = geopotential height of the surface
! res    = reciprocal of eta at the surface
!-----------------------------------------------------------------------
 type(horiz_grid_type), intent(inout) :: Hgrid
 type  (prog_var_type), intent(inout) :: Var
 real, intent(out), dimension(:)      :: eta, peta
 real, intent(out), dimension(Hgrid%ilb:Hgrid%iub, &
                              Hgrid%jlb:Hgrid%jub) :: fis, res
 integer :: n, unit, siz(4)
 integer :: isd,ied,vsd,ved
 character(len=64)  :: tr_name
 character(len=128) :: filename_in
 real :: tr_surf, tr_mult
 logical :: found

! set-up file name
  filename_in = trim(directory_in)//trim(res_file_name)
  if (.not.old_restart_format) filename_in = trim(filename_in)//'.nc'

  if (do_cold_start) then

     ! set up simple initial conditions
     ! when restart file does not exist

       call cold_start ( Hgrid, eta, peta, fis, res, Var%ps, Var%pssl, &
                                           Var%u, Var%v, Var%t )
  else

     ! must pass fields to read_data on data domain
     ! mass fields are on data domain
     ! set up indexing for velocity fields on data domain

       isd = Hgrid%Vel%isd;  ied = Hgrid%Vel%ied
       vsd = Hgrid%Vel%jsd;  ved = Hgrid%Vel%jed

     ! read non-distributed data from root pe (vertical coordinate info)
       if (old_restart_format) then
           read (unit_in) eta, peta
       else
           call nullify_domain ()
           call read_data ( filename_in,  'eta',  eta )
           call read_data ( filename_in, 'peta', peta )
       endif

     !  --- read variables ---

     ! initialize domain for temperature grid 
     ! read surf pres, topog, and more

       if (old_restart_format) then
           call set_domain ( Hgrid%Tmp%Domain )
           call read_data ( unit_in, Var%ps  )
           if (read_pssl) &
           call read_data ( unit_in, Var%pssl)
           call read_data ( unit_in,     res )
           call read_data ( unit_in,     fis )
       else
           call read_data ( filename_in, 'ps'  , Var%ps  , Hgrid%Tmp%Domain )
           if (read_pssl) &
           call read_data ( filename_in, 'pssl', Var%pssl, Hgrid%Tmp%Domain )
           call read_data ( filename_in, 'res' ,     res , Hgrid%Tmp%Domain )
           call read_data ( filename_in, 'fis' ,     fis , Hgrid%Tmp%Domain )
       endif
     
     ! initialize domain for velocity grid 
     ! read u and v wind components

     ! pass velocity fields on data domain
       if (old_restart_format) then
           call set_domain ( Hgrid%Vel%Domain )
           call read_data ( unit_in, Var%u(isd:ied,vsd:ved,:) )
           call read_data ( unit_in, Var%v(isd:ied,vsd:ved,:) )
       else
           call read_data ( filename_in, 'u', Var%u(isd:ied,vsd:ved,:), Hgrid%Vel%Domain )
           call read_data ( filename_in, 'v', Var%v(isd:ied,vsd:ved,:), Hgrid%Vel%Domain )
       endif

     ! re-initialize domain for temperature grid 
     ! read temperature and tracers
       if (old_restart_format) then
           call set_domain ( Hgrid%Tmp%Domain )
           call read_data ( unit_in, Var%t )
           call close_file (unit_in) ! done reading B-grid dynamics restart
       else
           call read_data ( filename_in, 't', Var%t, Hgrid%Tmp%Domain )
       endif

  endif

! read single tracer restart file
  
  filename_in = trim(directory_in)//'atmos_tracers.res.nc'

  if (file_exist(trim(filename_in))) then
      do n = 1, Var%ntrace
         call get_tracer_names ( MODEL_ATMOS, n, tr_name )
         call field_size (trim(filename_in), tr_name, siz, field_found=found)
         if (found) then
             if (siz(1) == Hgrid%nlon .and. siz(2) == Hgrid%nlat .and. siz(3) == size(eta(:))-1) then
                call read_data (trim(filename_in), tr_name, Var%r(:,:,:,n), Hgrid%Tmp%Domain)
             else
                call error_mesg ('bgrid_prog_var_mod','can not read tracers with wrong size', FATAL)
             endif
         else
          ! initialize new tracers (apply surface value only)
            call set_tracer_profile ( MODEL_ATMOS, n, Var%r(:,:,:,n) )
         endif
      enddo
  else

    ! old format
    ! read separate tracer restart files
      do n = 1, Var%ntrace
         call get_tracer_names ( MODEL_ATMOS, n, tr_name )
         filename_in = trim(directory_in)//'tracer_'//trim(tr_name)//'.res'

         if (file_exist(trim(filename_in))) then
             unit = open_restart_file( trim(filename_in), 'read' )
             call set_domain ( Hgrid%Tmp%Domain )
             call read_data ( unit, Var%r(:,:,:,n) )
             call close_file (unit)
         else
           ! initialize new tracers (apply surface value only)
             call set_tracer_profile ( MODEL_ATMOS, n, Var%r(:,:,:,n) )
         endif
      enddo

  endif

! update all boundaries for restart variables

  call update_halo (Hgrid, TEMP, res)
  call update_halo (Hgrid, TEMP, fis)
  call update_halo (Hgrid, TEMP, Var%ps)
  if (read_pssl) &
  call update_halo (Hgrid, TEMP, Var%pssl)
  call update_halo (Hgrid, TEMP, Var%t)
  call update_halo (Hgrid, TEMP, Var%r)
  call update_halo (Hgrid, UWND, Var%u)
  call update_halo (Hgrid, VWND, Var%v)

! for old restart formats, initialize pssl
  if (.not.read_pssl) Var%pssl = Var%ps * res

! check sum input data
  call print_check_sum ('Check sums for B-grid input data:', &
                        Hgrid, Var, eta, peta, fis, res)

end subroutine read_prog_var

!#######################################################################
! writes a B-grid core restart file named "RESTART/bgrid_prog_var.res"
! For NetCDF files a ".nc" suffix is added.

 subroutine write_prog_var (Var, Hgrid, Vgrid, fis, res, dir, format)

!-----------------------------------------------------------------------
! Var    = prognostic variables
! Hgrid  = horizontal grid constants
! Vgrid  = vertical grid constants
! fis    = geopotential height of the surface
! res    = reciprocal of eta at the surface
! dir    = directory where output restart files will be written
!            for the current directory use: "" or "."
!            default: "RESTART"
! format = file format, either: NATIVE or NETCDF
!-----------------------------------------------------------------------
 type  (prog_var_type), intent(in) :: Var
 type(horiz_grid_type), intent(in) :: Hgrid
 type (vert_grid_type), intent(in) :: Vgrid
 real, intent(in), dimension(Hgrid%ilb:Hgrid%iub, &
                             Hgrid%jlb:Hgrid%jub) :: fis, res
 character(len=*), intent(in), optional :: dir, format

 integer :: n, unit
 integer :: isd,ied, vsd,ved
 character(len=8)  :: oform
 character(len=64) :: tr_name
 character(len=128) :: directory, restart_name
 logical :: use_old_format

!-----------------------------------------------------------------------
! output format
  oform = 'NETCDF'; if (present(format)) oform = format
  if (trim(uppercase(oform)) == 'NATIVE') then
      use_old_format = .true.
  else if (trim(uppercase(oform)) == 'NETCDF') then
      use_old_format = .false.
  else
      call error_mesg ('write_prog_var', &
                       'invalid value for optional argument format', FATAL)
  endif

! check sum output data
  call print_check_sum ('Check sums for B-grid output data:', &
                        Hgrid, Var, Vgrid%eta, Vgrid%peta, fis, res)

! set-up restart file name
  directory = 'RESTART/'
  if (present(dir)) then
      if (len_trim(dir) > 0) then
          directory = trim(dir)//'/'  ! append /
      else
          directory = ''              ! cwd
      endif
  endif

  restart_name = trim(directory)//trim(res_file_name)

! open output restart file
  if (use_old_format) then
      unit = open_restart_file ( trim(restart_name), 'write' )
    ! write non-distributed data from root pe
      if ( mpp_pe() == mpp_root_pe() ) then
           write (unit)  restart_format
           write (unit)  Hgrid%nlon, Hgrid%nlat, Vgrid%nlev
           write (unit)  Vgrid%eta, Vgrid%peta ! vertical coordinate info
      endif
  else
! netcdf format
      restart_name = trim(restart_name)//'.nc' ! add netcdf file suffix
      call nullify_domain ()
      call write_data ( restart_name,  'eta', Vgrid%eta  )
      call write_data ( restart_name, 'peta', Vgrid%peta )
  endif

! must pass fields to write_data on data domain
! mass fields are on data domain
! set up indexing for velocity fields on data domain

  isd = Hgrid%Vel%isd;  ied = Hgrid%Vel%ied
  vsd = Hgrid%Vel%jsd;  ved = Hgrid%Vel%jed

! output 2d-fields on mass grid (surf pres, topog)
  if (use_old_format) then
      call set_domain ( Hgrid%Tmp%Domain )
      call write_data ( unit, Var%ps  )
      call write_data ( unit, Var%pssl)
      call write_data ( unit,     res )   
      call write_data ( unit,     fis )   
  else
      call write_data ( restart_name, 'ps',   Var%ps  , Hgrid%Tmp%Domain )
      call write_data ( restart_name, 'pssl', Var%pssl, Hgrid%Tmp%Domain )
      call write_data ( restart_name, 'res',  res     , Hgrid%Tmp%Domain )
      call write_data ( restart_name, 'fis',  fis     , Hgrid%Tmp%Domain )
  endif

! output 3d-fields on velocity grid (u,v)
! pass velocity fields on data domain
  if (use_old_format) then
      call set_domain ( Hgrid%Vel%Domain )
      call write_data ( unit, Var%u(isd:ied,vsd:ved,:) )
      call write_data ( unit, Var%v(isd:ied,vsd:ved,:) )
  else
      call write_data ( restart_name, 'u', Var%u(isd:ied,vsd:ved,:), Hgrid%Vel%Domain )
      call write_data ( restart_name, 'v', Var%v(isd:ied,vsd:ved,:), Hgrid%Vel%Domain )
  endif

! output 3d temperature field
  if (use_old_format) then
    ! re-initialize domain for temperature grid (save temp and tracers)
      call set_domain ( Hgrid%Tmp%Domain )
      call write_data ( unit, Var%t   )
    ! done writing B-grid dynamics restart
      call close_file ( unit )
  else
      call write_data ( restart_name, 't', Var%t, Hgrid%Tmp%Domain )
  endif

! write tracer restart file(s)
  do n = 1, Var%ntrace
     call get_tracer_names ( MODEL_ATMOS, n, tr_name )
     if (use_old_format) then
       ! write separate files when using old format
         restart_name = trim(directory)//'tracer_'//trim(tr_name)//'.res'
         unit = open_restart_file( trim(restart_name), 'write' )
         call write_data ( unit, Var%r(:,:,:,n) )
         call close_file ( unit )
     else
       ! write single netcdf tracer file
         restart_name = trim(directory)//'atmos_tracers.res.nc'
         call write_data ( trim(restart_name), trim(tr_name), &
                           Var%r(:,:,:,n), Hgrid%Tmp%Domain )
     endif
  enddo

 end subroutine write_prog_var

!#######################################################################

subroutine print_check_sum (label, Hgrid, Var, eta, peta, fis, res, unit)

 character(len=*),      intent(in) :: label
 type(horiz_grid_type), intent(in) :: Hgrid
 type  (prog_var_type), intent(in) :: Var
 real, intent(in), dimension(:)    :: eta, peta
 real, intent(in), dimension(Hgrid%ilb:Hgrid%iub, &
                             Hgrid%jlb:Hgrid%jub) :: fis, res
 integer, intent(in), optional :: unit
 integer :: n, chksum_unit
 integer :: is, ie, hs, he, vs, ve
 integer(I8_KIND) :: zsum

  chksum_unit = stdout()
  if (present(unit)) chksum_unit = unit
 
  is = Hgrid%Tmp%is;  ie = Hgrid%Tmp%ie
  hs = Hgrid%Tmp%js;  he = Hgrid%Tmp%je
  vs = Hgrid%Vel%js;  ve = Hgrid%Vel%je

  if (mpp_pe() == mpp_root_pe()) write (chksum_unit,'(/a)') trim(label)
! sum all restart variables (except eta,peta)
  zsum = mpp_chksum(fis (is:ie,hs:he))
  if (mpp_pe() == mpp_root_pe()) write (chksum_unit,10) '(fis)',zsum
  zsum = mpp_chksum(res (is:ie,hs:he))
  if (mpp_pe() == mpp_root_pe()) write (chksum_unit,10) '(res)',zsum
  zsum = mpp_chksum(Var%ps  (is:ie,hs:he))
  if (mpp_pe() == mpp_root_pe()) write (chksum_unit,10) '(ps)',zsum
  zsum = mpp_chksum(Var%pssl(is:ie,hs:he))
  if (mpp_pe() == mpp_root_pe()) write (chksum_unit,10) '(pssl)',zsum
  zsum = mpp_chksum(Var%t(is:ie,hs:he,:))
  if (mpp_pe() == mpp_root_pe()) write (chksum_unit,10) '(t)',zsum
  zsum = mpp_chksum(Var%u(is:ie,vs:ve,:))
  if (mpp_pe() == mpp_root_pe()) write (chksum_unit,10) '(u)',zsum
  zsum = mpp_chksum(Var%v(is:ie,vs:ve,:))
  if (mpp_pe() == mpp_root_pe()) write (chksum_unit,10) '(v)',zsum
  zsum = 0
! sum of all tracers
  do n = 1, Var%ntrace
    zsum = zsum + mpp_chksum(Var%r(is:ie,hs:he,:,n))
  enddo
  if (mpp_pe() == mpp_root_pe()) write (chksum_unit,10) '(r)',zsum
10 format ('chksum',a6,' = ',z16)

end subroutine print_check_sum

!#######################################################################

end module bgrid_prog_var_mod

module ocean_overflow_OFP_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> H.-C. Lee 
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S. M. Griffies 
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Z. Liang 
!</REVIEWER>
!
!<OVERVIEW>
! Modeling the physical processes of deep overflow from regional seas. 
!</OVERVIEW>
!
!<DESCRIPTION>
!(1) Physics of the overflow is based on the paper  
!    of Briegleb, Danabasoglu and Large (2010)
!(2) Geographic input data (I and J points) for each region 
!    is given by user at the Field Table.
!(3) Model can compute the overflow processes for 
!    many places. There is no maximum number of overflows. 
!(4) Maximum production lines (or regions) in this code is ten.
!    To get more, code needs to be written.   
!(5) Main acronyms.  
!    src:source, int:interior, ent:entrainment, prd:production
!
!</DESCRIPTION>
!
! <INFO>
! <REFERENCE>
! Briegleb B. P., G. Danabasoglu and W. G. Large (2010), An Overflow Parameterization
!    for the ocean component of the Community Climate System Model. NCAR Technical Note,
!    NCAR Boulder, CO.
! </REFERENCE>
! <REFERENCE>
! Danabasoglu G., W. G. Large and B. P. Briegleb (2010), Climate impacts of parameterized
!    Nordic Sea Overflow, Journal of Geophysical Research, (submitted)  
! </REFERENCE>
! </INFO>
!
!<NAMELIST NAME="ocean_overflow_OFP_nml">
!  
!  <DATA NAME="use_this_module" TYPE="logical">  
!  For using this module.  Default use_this_module=.false.
!  </DATA> 
!
!  <DATA NAME="debug_this_module" TYPE="logical">
!    For debugging.  Default is false.
!  </DATA> 
!
!  <DATA NAME="crit_Fr_geo_ofp" TYPE="real">
!    Critical geostrophic Froude number.
!    Set the minimum Froude number for mixing process
!    between source and entrainment waters
!    Default is 1.0
!  </DATA> 
!
!  <DATA NAME="crit_Fr_geo_ofp" TYPE="real">
!    Maximum overflow speed at the source region
!    Default is 3.0 m/s
!  </DATA> 
!
!  <DATA NAME="frac_exchange_src" TYPE="real">
!    Areal fraction of the overflow exchange at the source region
!    Default is 1.0
!  </DATA> 
!
!  <DATA NAME="max_vol_trans_ofp" TYPE="real">
!    Maximum volume transport of the overflow [m^3/s] 
!    Default is 10.e6
!  </DATA> 
!
!  <DATA NAME="max_ofp_speed" TYPE="real">
!    Maximum overflow speed [m^/s] 
!    Default is 2.0
!  </DATA> 
!
!  <DATA NAME="do_mass_ofp" TYPE="logical">
!    Considering the mass source in the overflow process 
!    Default is .true.
!  </DATA> 
!
!  <DATA NAME="diag_step" TYPE="integer">
!    Diagnostic time step for OFP. 
!    Default is diag_step = -1
!    The diagnostic output is saved in the ascii directory as the ascii format.
!  </DATA> 
!
!  <DATA NAME="do_entrainment_para_ofp" TYPE="logical">
!    Considering the parameterization of entrainment process 
!    in the overflow process 
!    Default is .true.
!  </DATA> 
!
!</NAMELIST>
!

use constants_mod,       only: epsln, deg_to_rad, omega
use diag_manager_mod,    only: register_diag_field, register_static_field, send_data
use field_manager_mod,   only: MODEL_OCEAN, parse, find_field_index
use field_manager_mod,   only: get_field_methods, method_type, get_field_info
use fms_mod,             only: write_version_number, error_mesg, FATAL, NOTE
use fms_mod,             only: open_namelist_file, check_nml_error, close_file, stdout, stdlog
use mpp_domains_mod,     only: mpp_update_domains, CGRID_NE
use mpp_domains_mod,     only: mpp_global_sum, BITWISE_EXACT_SUM, NON_BITWISE_EXACT_SUM
use mpp_domains_mod,     only: mpp_define_domains
use mpp_domains_mod,     only: cyclic_global_domain, global_data_domain 
use mpp_mod,             only: mpp_error, mpp_max, mpp_sum, mpp_pe, mpp_root_pe, mpp_broadcast
use mpp_mod,             only: input_nml_file
use mpp_mod,             only: mpp_clock_id, mpp_clock_begin, mpp_clock_end
use mpp_mod,             only: CLOCK_COMPONENT, CLOCK_SUBCOMPONENT, CLOCK_MODULE, CLOCK_ROUTINE

use ocean_density_mod,    only: density
use ocean_domains_mod,    only: get_local_indices, set_ocean_domain
use ocean_parameters_mod, only: missing_value, rho0r, grav, omega_earth
use ocean_parameters_mod, only: TERRAIN_FOLLOWING
use ocean_types_mod,      only: ocean_domain_type, ocean_grid_type, ocean_time_type, ocean_options_type
use ocean_types_mod,      only: ocean_prog_tracer_type, ocean_density_type, ocean_thickness_type
use ocean_types_mod,      only: ocean_velocity_type, ocean_external_mode_type
use ocean_util_mod,       only: write_timestamp, diagnose_3d
use ocean_tracer_util_mod,only: diagnose_3d_rho
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3, wrk4, wrk1_v

implicit none

private 

public ocean_overflow_OFP_init
public overflow_OFP
private watermass_diag_init
private watermass_diag

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

logical :: used

integer :: id_OFP_n1_src_temp     =-1
integer :: id_OFP_n1_src_salt     =-1
integer :: id_OFP_n1_src_trans    =-1
integer :: id_OFP_n1_int_temp     =-1
integer :: id_OFP_n1_int_salt     =-1
integer :: id_OFP_n1_ent_temp     =-1
integer :: id_OFP_n1_ent_salt     =-1
integer :: id_OFP_n1_ent_trans    =-1
integer :: id_OFP_n1_prd_temp     =-1
integer :: id_OFP_n1_prd_salt     =-1
integer :: id_OFP_n1_prd_trans    =-1
integer :: id_OFP_n1_prd_depth    =-1

integer :: id_OFP_n2_src_temp     =-1
integer :: id_OFP_n2_src_salt     =-1
integer :: id_OFP_n2_src_trans    =-1
integer :: id_OFP_n2_int_temp     =-1
integer :: id_OFP_n2_int_salt     =-1
integer :: id_OFP_n2_ent_temp     =-1
integer :: id_OFP_n2_ent_salt     =-1
integer :: id_OFP_n2_ent_trans    =-1
integer :: id_OFP_n2_prd_temp     =-1
integer :: id_OFP_n2_prd_salt     =-1
integer :: id_OFP_n2_prd_trans    =-1
integer :: id_OFP_n2_prd_depth    =-1

integer :: id_OFP_init
integer :: id_OFP_main
integer :: id_OFP_update_1
integer :: id_OFP_update_2
integer :: id_OFP_update_3

integer :: id_neut_rho_overofp          =-1
integer :: id_wdian_rho_overofp         =-1
integer :: id_neut_rho_overofp_on_nrho  =-1
integer :: id_wdian_rho_overofp_on_nrho =-1
integer :: id_tform_rho_overofp_on_nrho =-1

integer :: id_neut_temp_overofp          =-1
integer :: id_wdian_temp_overofp         =-1
integer :: id_neut_temp_overofp_on_nrho  =-1
integer :: id_wdian_temp_overofp_on_nrho =-1
integer :: id_tform_temp_overofp_on_nrho =-1

integer :: id_neut_salt_overofp          =-1
integer :: id_wdian_salt_overofp         =-1
integer :: id_neut_salt_overofp_on_nrho  =-1
integer :: id_wdian_salt_overofp_on_nrho =-1
integer :: id_tform_salt_overofp_on_nrho =-1


#include <ocean_memory.h>

!------- for multi-regions, input from field table
 real, dimension(:), allocatable :: phi_ofp             !  latitude of overflow (degree N)
 real, dimension(:), allocatable :: hu_ofp              !  upstream thickness of the source water (m)
 real, dimension(:), allocatable :: hs_ofp              
 real, dimension(:), allocatable :: ws_ofp              !  width of strait (m)
 real, dimension(:), allocatable :: xssb_ofp            !  distance from strait to shelf-slop break (m)
 real, dimension(:), allocatable :: alpha_ofp           !  max. bottom slope near shelf break
 real, dimension(:), allocatable :: cdbot_ofp           !  bottom shelf drag coeff.

 integer                         :: OFP_xhalo           !  halo index in x-direction
 integer                         :: OFP_yhalo           !  halo index in y-direction
 type(ocean_domain_type), save   :: OFP_domain          !  domain for OFP

!----- n_OFP:num_prog_tracers
 real, dimension(:,:), allocatable   :: src_flux_trace    ! total source tracer flux [trace kg/m^3 m^3/s]
 real, dimension(:,:), allocatable   :: ent_flux_trace    ! total entrainment tracer flux [trace kg/m^3 m^3/s]
 real, dimension(:,:), allocatable   :: prd_flux_trace    ! total product tracer flux [trace kg/m^3 m^3/s]

!----- n_OFP:num_prog_tracers
 real, dimension(:,:),   allocatable   :: src_vol_trace   ! all tracers in volume average
 real, dimension(:,:),   allocatable   :: ent_vol_trace   ! all tracers in volume average
 real, dimension(:,:),   allocatable   :: prd_vol_trace   ! all tracers in volume average

!----- n_OFP  *** should allocating and localizing
 real, dimension(:),   allocatable   :: src_volT   
 real, dimension(:),   allocatable   :: src_volS   
 real, dimension(:),   allocatable   :: src_volP   
 real, dimension(:),   allocatable   :: src_vol    
 real, dimension(:),   allocatable   :: src_dat   
 real, dimension(:),   allocatable   :: src_flux_Mass   
 real, dimension(:),   allocatable   :: src_den   

 real, dimension(:),   allocatable   :: int_volT   
 real, dimension(:),   allocatable   :: int_volS   
 real, dimension(:),   allocatable   :: int_volP   
 real, dimension(:),   allocatable   :: int_vol   
 real, dimension(:),   allocatable   :: int_dat   
 real, dimension(:),   allocatable   :: int_den   

 real, dimension(:),   allocatable   :: grav_prim_src_ofp  
 real, dimension(:),   allocatable   :: coriolis_source_ofp  
 real, dimension(:),   allocatable   :: trans_vol_ofp_src_raw  
 real, dimension(:),   allocatable   :: trans_vol_ofp_src  
 real, dimension(:),   allocatable   :: vel_src_ofp  

 real, dimension(:),   allocatable   :: ent_volT   
 real, dimension(:),   allocatable   :: ent_volS   
 real, dimension(:),   allocatable   :: ent_volP   
 real, dimension(:),   allocatable   :: ent_vol    
 real, dimension(:),   allocatable   :: ent_dat   
 real, dimension(:),   allocatable   :: ent_den   

 real, dimension(:),   allocatable   :: src_den_prim  
 real, dimension(:),   allocatable   :: src_den_prim_int  
 real, dimension(:),   allocatable   :: grav_prim_ent_ofp 
 real, dimension(:),   allocatable   :: trans_vol_ofp_ent 
 real, dimension(:),   allocatable   :: trans_vol_ofp_prd 
 real, dimension(:),   allocatable   :: trans_mass_ofp_ent 
 real, dimension(:),   allocatable   :: vel_ssb_ofp 
 real, dimension(:),   allocatable   :: vel_ave_ofp 
 real, dimension(:),   allocatable   :: coef_b_ofp 
 real, dimension(:),   allocatable   :: coef_c_ofp 
 real, dimension(:),   allocatable   :: coef_d_ofp 
 real, dimension(:),   allocatable   :: hssb_ofp
 real, dimension(:),   allocatable   :: Fr_geo_ofp 
 real, dimension(:),   allocatable   :: mix_theta_ofp 
 real, dimension(:),   allocatable   :: volf_per_tvol_src 
 real, dimension(:),   allocatable   :: volf_per_tvol_ent
 real, dimension(:),   allocatable   :: ent_flux_Mass

 integer, dimension(:), allocatable  :: prd_line_num,prd_inject_line_num
 real, dimension(:,:),   allocatable :: prd_amb_P, prd_dat, prd_amb_rho
 real, dimension(:,:),   allocatable :: prd_vol, prd_amb_T, prd_amb_S
 real, dimension(:),   allocatable   :: prd_volT,prd_volS,prd_vol_rho
 real, dimension(:),   allocatable   :: prd_flux_Mass, prd_inj_vol
 real, dimension(:),   allocatable   :: volf_per_tvol_prd
 real, dimension(:),   allocatable   :: depth_prd_OFP


!----- pre-defined informations (I,J points) of src, int and ent
integer, dimension(:), allocatable :: src_ist,src_ied,src_jst,src_jed,src_kst,src_ked
integer, dimension(:), allocatable :: int_ist,int_ied,int_jst,int_jed,int_kst,int_ked
integer, dimension(:), allocatable :: ent_ist,ent_ied,ent_jst,ent_jed,ent_kst,ent_ked

!----- I,J points of prd lines (regions)
integer, dimension(:,:), allocatable :: prd_ist,prd_ied,prd_jst,prd_jed,prd_kst,prd_ked

!----- computational domains for regions
integer, dimension(:),   allocatable :: src_isc,src_iec,src_jsc,src_jec
integer, dimension(:),   allocatable :: ent_isc,ent_iec,ent_jsc,ent_jec
integer, dimension(:),   allocatable :: int_isc,int_iec,int_jsc,int_jec
integer, dimension(:,:), allocatable :: prd_isc,prd_iec,prd_jsc,prd_jec

!----- maximum I,J bounds
integer, dimension(:),   allocatable :: max_i_bound,min_i_bound,max_j_bound,min_j_bound
integer, dimension(:),   allocatable :: max_ist,max_ied,max_jst,max_jed

!----- checking the working computational domain for each regions
logical                              :: working_comp_domains_all
logical, dimension(:), allocatable   :: working_comp_domains
logical, dimension(:), allocatable   :: working_src_comp_domains
logical, dimension(:), allocatable   :: working_int_comp_domains
logical, dimension(:), allocatable   :: working_ent_comp_domains
logical, dimension(:,:), allocatable :: working_prd_comp_domains
logical, dimension(:), allocatable   :: occur_overflow_OFP



!------ variables in new ocean domain with halo region
integer, dimension(:,:)    , allocatable :: kmto      ! Grd%kmt(i,j)
real,    dimension(:,:)    , allocatable :: dato      ! Grd%dat(i,j)
real,    dimension(:,:)    , allocatable :: dxto      ! Grd%dxt(i,j)
real,    dimension(:,:)    , allocatable :: dyto      ! Grd%dyt(i,j)
real,    dimension(:,:)    , allocatable :: hto       ! Grd%dyt(i,j)
real,    dimension(:,:,:)  , allocatable :: tmsko     ! Grd%tmask(i,j,k)
real,    dimension(:,:,:)  , allocatable :: umsko     ! Grd%umask(i,j,k)
real,    dimension(:,:,:)  , allocatable :: dzto      ! Thickness%dzt(i,j,k) 
real,    dimension(:,:,:)  , allocatable :: depth_zto ! Thickness%depth_zt(i,j,k) 
real,    dimension(:,:,:)  , allocatable :: rho_dzto  ! Thickness%rho_dzt(i,j,k,tau)
real,    dimension(:,:,:)  , allocatable :: tempo     ! T_prog(index_temp)%field(i,j,k,tau) 
real,    dimension(:,:,:)  , allocatable :: salto     ! T_prog(index_salt)%field(i,j,k,tau) 
real,    dimension(:,:,:,:), allocatable :: traceo    ! T_prog(n)%field(i,j,k,tau)
real,    dimension(:,:,:)  , allocatable :: presso    ! Dens%pressure_at_depth(i,j,k) 

!------ number of OFP regions
integer :: n_OFP_info=0 
integer :: n_OFP_src=0 
integer :: n_OFP_int=0 
integer :: n_OFP_ent=0 
integer :: n_OFP_prd_line_01=0 
integer :: n_OFP_prd_line_02=0 
integer :: n_OFP_prd_line_03=0 
integer :: n_OFP_prd_line_04=0 
integer :: n_OFP_prd_line_05=0 
integer :: n_OFP_prd_line_06=0 
integer :: n_OFP_prd_line_07=0 
integer :: n_OFP_prd_line_08=0 
integer :: n_OFP_prd_line_09=0 
integer :: n_OFP_prd_line_10=0 
integer :: n_OFP=0 
!-integer :: prd_line_num=10


! internally set for computing watermass diagnostics
logical :: compute_watermass_diag = .false. 

!----------------------------------------------------------------------------------

character(len=128) :: version=&
       '=>Using: ocean_overflow_OFP.f90 ($Id: ocean_overflow_OFP.F90,v 20.0 2013/12/14 00:16:08 fms Exp $)'
character (len=128) :: tagname=&
     '$Name: tikal $'

! number of prognostic tracers
integer :: num_prog_tracers=0

! initialization flag 
logical :: module_is_initialized=.false.

! flag for mpp_global_sum
integer :: global_sum_flag      

! time step 
real :: dtime 
real :: p5dtimer

! set from nml
logical :: use_this_module         = .false.    ! must be set .true. in nml to enable this scheme
logical :: debug_this_module       = .false.    ! for debugging
real    :: crit_Fr_geo_ofp         = 1.0        ! Critical geostrophic Froude number
real    :: frac_exchange_src       = 1.0        ! Areal fraction of the exchange at the source region
real    :: max_vol_trans_ofp       = 10.e6      ! Maximum volume transport of the overflow
real    :: max_ofp_speed           = 2.0        ! Maximum OFP speed of the overflow
logical :: do_mass_ofp             = .true.     ! considering the mass source in the overflow process
integer :: diag_step               = -1         ! diagnostic time step
logical :: do_entrainment_para_ofp = .true.     ! parameterization of entrainment process


namelist /ocean_overflow_OFP_nml/ use_this_module, debug_this_module, crit_Fr_geo_ofp &
                                 ,crit_Fr_geo_ofp, frac_exchange_src,max_vol_trans_ofp &
                                 ,max_ofp_speed, do_mass_ofp, diag_step, do_entrainment_para_ofp

contains



!#######################################################################
! <SUBROUTINE NAME="ocean_overflow_OFP_init">
!
! <DESCRIPTION>
! Initial set up for OFP
! </DESCRIPTION>
!
  subroutine ocean_overflow_OFP_init(Grid, Domain, Time, Dens, T_prog, Ocean_options, &
                                 vert_coordinate_type, dtim, debug)

    type(ocean_grid_type),        intent(in), target   :: Grid
    type(ocean_domain_type),      intent(in), target   :: Domain
    type(ocean_time_type),        intent(in), target   :: Time
    type(ocean_density_type),     intent(in)           :: Dens
    type(ocean_prog_tracer_type), intent(in)           :: T_prog(:)
    type(ocean_options_type),     intent(inout)        :: Ocean_options
    integer,                      intent(in)           :: vert_coordinate_type 
    real,                         intent(in)           :: dtim
    logical,                      intent(in), optional :: debug

    integer :: parse_ok
    integer :: io_status, ioun, ierr
    integer :: i, j, k, m, model, nindx, mindx

!------- index of fields
    integer :: n_info, n_src, n_int, n_ent
    integer :: n_prd_line_01, n_prd_line_02, n_prd_line_03, n_prd_line_04, n_prd_line_05
    integer :: n_prd_line_06, n_prd_line_07, n_prd_line_08, n_prd_line_09, n_prd_line_10

!------- methods of fields
    type(method_type), allocatable, dimension(:) :: OFP_methods_info
    type(method_type), allocatable, dimension(:) :: OFP_methods_src, OFP_methods_int, OFP_methods_ent
    type(method_type), allocatable, dimension(:) :: OFP_methods_prd_line_01
    type(method_type), allocatable, dimension(:) :: OFP_methods_prd_line_02
    type(method_type), allocatable, dimension(:) :: OFP_methods_prd_line_03
    type(method_type), allocatable, dimension(:) :: OFP_methods_prd_line_04
    type(method_type), allocatable, dimension(:) :: OFP_methods_prd_line_05
    type(method_type), allocatable, dimension(:) :: OFP_methods_prd_line_06
    type(method_type), allocatable, dimension(:) :: OFP_methods_prd_line_07
    type(method_type), allocatable, dimension(:) :: OFP_methods_prd_line_08
    type(method_type), allocatable, dimension(:) :: OFP_methods_prd_line_09
    type(method_type), allocatable, dimension(:) :: OFP_methods_prd_line_10

    character(len=32) :: fld_type, fld_name
    integer :: stdoutunit, stdlogunit

!----------- pe number
    integer :: pe
    integer :: root_pe

!------------------------
        id_OFP_init        = mpp_clock_id('(Ocean_OFP_init) '           ,grain=CLOCK_MODULE)
        id_OFP_main        = mpp_clock_id('(Ocean_OFP_main) '           ,grain=CLOCK_MODULE)
        id_OFP_update_1    = mpp_clock_id('(ocean_OFP_update_1) '       ,grain=CLOCK_MODULE)
        id_OFP_update_2    = mpp_clock_id('(ocean_OFP_update_2) '       ,grain=CLOCK_MODULE)
        id_OFP_update_3    = mpp_clock_id('(ocean_OFP_update_3) '       ,grain=CLOCK_MODULE)
!------------------------
!    OFP diagnostics
!------------------------
id_OFP_n1_src_temp     = register_diag_field ('ocean_model', 'OFP_n1_src_temp',          &
                         Time%model_time, 'OFP_1 source region temperature', 'oC degree',&
                         missing_value=missing_value, range=(/-100.,100./))
id_OFP_n1_src_salt     = register_diag_field ('ocean_model', 'OFP_n1_src_salt', &
                         Time%model_time, 'OFP_1 source region salinity', 'psu',&
                         missing_value=missing_value, range=(/0.,100./))
id_OFP_n1_src_trans    = register_diag_field ('ocean_model', 'OFP_n1_src_trans',   &
                         Time%model_time, 'OFP_1 source region transport', 'm^3/s',&
                         missing_value=missing_value, range=(/0.,100./))

id_OFP_n1_int_temp     = register_diag_field ('ocean_model', 'OFP_n1_int_temp',            &
                         Time%model_time, 'OFP_1 interior region temperature', 'oC degree',&
                         missing_value=missing_value, range=(/-100.,100./))
id_OFP_n1_int_salt     = register_diag_field ('ocean_model', 'OFP_n1_int_salt',   &
                         Time%model_time, 'OFP_1 interior region salinity', 'psu',&
                         missing_value=missing_value, range=(/0.,100./))

id_OFP_n1_ent_temp     = register_diag_field ('ocean_model', 'OFP_n1_ent_temp',               &
                         Time%model_time, 'OFP_1 entrainment region temperature', 'oC degree',&
                         missing_value=missing_value, range=(/-100.,100./))
id_OFP_n1_ent_salt     = register_diag_field ('ocean_model', 'OFP_n1_ent_salt',       &
                         Time%model_time, 'OFP_1 entrainment  region salinity', 'psu',&
                         missing_value=missing_value, range=(/0.,100./))
id_OFP_n1_ent_trans    = register_diag_field ('ocean_model', 'OFP_n1_ent_trans',        &
                         Time%model_time, 'OFP_1 entrainment region transport', 'm^3/s',&
                         missing_value=missing_value, range=(/0.,100./))

id_OFP_n1_prd_temp     = register_diag_field ('ocean_model', 'OFP_n1_prd_temp',              &
                         Time%model_time, 'OFP_1 production region temperature', 'oC degree',&
                         missing_value=missing_value, range=(/-100.,100./))
id_OFP_n1_prd_salt     = register_diag_field ('ocean_model', 'OFP_n1_prd_salt',      &
                         Time%model_time, 'OFP_1 production  region salinity', 'psu',&
                         missing_value=missing_value, range=(/0.,100./))
id_OFP_n1_prd_trans    = register_diag_field ('ocean_model', 'OFP_n1_prd_trans',       &
                         Time%model_time, 'OFP_1 production region transport', 'm^3/s',&
                         missing_value=missing_value, range=(/0.,100./))
id_OFP_n1_prd_depth    = register_diag_field ('ocean_model', 'OFP_n1_prd_depth',&
                         Time%model_time, 'OFP_1 production depth', 'meter',    &
                         missing_value=missing_value, range=(/0.,10000./))

id_OFP_n2_src_temp     = register_diag_field ('ocean_model', 'OFP_n2_src_temp',          &
                         Time%model_time, 'OFP_2 source region temperature', 'oC degree',&
                         missing_value=missing_value, range=(/-100.,100./))
id_OFP_n2_src_salt     = register_diag_field ('ocean_model', 'OFP_n2_src_salt', &
                         Time%model_time, 'OFP_2 source region salinity', 'psu',&
                         missing_value=missing_value, range=(/0.,100./))
id_OFP_n2_src_trans    = register_diag_field ('ocean_model', 'OFP_n2_src_trans',   &
                         Time%model_time, 'OFP_2 source region transport', 'm^3/s',&
                         missing_value=missing_value, range=(/0.,100./))

id_OFP_n2_int_temp     = register_diag_field ('ocean_model', 'OFP_n2_int_temp',            &
                         Time%model_time, 'OFP_2 interior region temperature', 'oC degree',&
                         missing_value=missing_value, range=(/-100.,100./))
id_OFP_n2_int_salt     = register_diag_field ('ocean_model', 'OFP_n2_int_salt',   &
                         Time%model_time, 'OFP_2 interior region salinity', 'psu',&
                         missing_value=missing_value, range=(/0.,100./))

id_OFP_n2_ent_temp     = register_diag_field ('ocean_model', 'OFP_n2_ent_temp',               &
                         Time%model_time, 'OFP_2 entrainment region temperature', 'oC degree',&
                         missing_value=missing_value, range=(/-100.,100./))
id_OFP_n2_ent_salt     = register_diag_field ('ocean_model', 'OFP_n2_ent_salt',       &
                         Time%model_time, 'OFP_2 entrainment  region salinity', 'psu',&
                         missing_value=missing_value, range=(/0.,100./))
id_OFP_n2_ent_trans    = register_diag_field ('ocean_model', 'OFP_n2_ent_trans',        &
                         Time%model_time, 'OFP_2 entrainment region transport', 'm^3/s',&
                         missing_value=missing_value, range=(/0.,100./))

id_OFP_n2_prd_temp     = register_diag_field ('ocean_model', 'OFP_n2_prd_temp',              &
                         Time%model_time, 'OFP_2 production region temperature', 'oC degree',&
                         missing_value=missing_value, range=(/-100.,100./))
id_OFP_n2_prd_salt     = register_diag_field ('ocean_model', 'OFP_n2_prd_salt',      &
                         Time%model_time, 'OFP_2 production  region salinity', 'psu',&
                         missing_value=missing_value, range=(/0.,100./))
id_OFP_n2_prd_trans    = register_diag_field ('ocean_model', 'OFP_n2_prd_trans',       &
                         Time%model_time, 'OFP_2 production region transport', 'm^3/s',&
                         missing_value=missing_value, range=(/0.,100./))
id_OFP_n2_prd_depth    = register_diag_field ('ocean_model', 'OFP_n2_prd_depth',&
                         Time%model_time, 'OFP_2 production depth', 'meter',    &
                         missing_value=missing_value, range=(/0.,10000./))

!------------------------

    stdoutunit=stdout();stdlogunit=stdlog() 

    pe=mpp_pe()
    root_pe=mpp_root_pe()

 if ( module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error from ocean_overflow_mod (ocean_overflow_init): module already initialized')
 endif 

    module_is_initialized = .TRUE.

    call write_version_number(version, tagname)
#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
    nk = Grid%nk
#endif
    Dom => Domain
    Grd => Grid

         call mpp_clock_begin(id_OFP_init)

    num_prog_tracers = size(T_prog(:))
    dtime = dtim 
    p5dtimer = 0.5/dtime

 if (debug_this_module) then 
    write (stdoutunit,*) 'isd,ied,jsd,jed,isc,iec,jsc,jec',isd,ied,jsd,jed,isc,iec,jsc,jec
    write (stdoutunit,*) 'Dom%ioff,Dom%joff',Dom%ioff,Dom%joff
 endif

    call watermass_diag_init(Time, Dens)

!--
  n_info = find_field_index(MODEL_OCEAN,'overflow_ofp_info')
  n_src  = find_field_index(MODEL_OCEAN,'overflow_ofp_src')
  n_int  = find_field_index(MODEL_OCEAN,'overflow_ofp_int')
  n_ent  = find_field_index(MODEL_OCEAN,'overflow_ofp_ent')

  n_prd_line_01 = find_field_index(MODEL_OCEAN,'overflow_ofp_prd_line_01')
  n_prd_line_02 = find_field_index(MODEL_OCEAN,'overflow_ofp_prd_line_02')
  n_prd_line_03 = find_field_index(MODEL_OCEAN,'overflow_ofp_prd_line_03')
  n_prd_line_04 = find_field_index(MODEL_OCEAN,'overflow_ofp_prd_line_04')
  n_prd_line_05 = find_field_index(MODEL_OCEAN,'overflow_ofp_prd_line_05')
  n_prd_line_06 = find_field_index(MODEL_OCEAN,'overflow_ofp_prd_line_06')
  n_prd_line_07 = find_field_index(MODEL_OCEAN,'overflow_ofp_prd_line_07')
  n_prd_line_08 = find_field_index(MODEL_OCEAN,'overflow_ofp_prd_line_08')
  n_prd_line_09 = find_field_index(MODEL_OCEAN,'overflow_ofp_prd_line_09')
  n_prd_line_10 = find_field_index(MODEL_OCEAN,'overflow_ofp_prd_line_10')

  if (n_src < 1) then 
    write(stdoutunit,'(a)')' '
    write(stdoutunit,'(a)') &
    '==>Warning: ocean_overflow_OFP_init found n_src < 1 for overflow_OFP table.  Will NOT use ocean_overflow_OFP.'  
    write(stdoutunit,'(a)')' '
    Ocean_options%overflow_OFP = 'Did NOT use overflow_OFP.'
    return
  endif 


!----
  call get_field_info(n_info,fld_type,fld_name,model,n_OFP_info)
  call get_field_info(n_src,fld_type,fld_name,model,n_OFP_src)
  call get_field_info(n_int,fld_type,fld_name,model,n_OFP_int)
    if(n_OFP_int /= n_OFP_src) then 
       call mpp_error(NOTE,'==>From ocean_overflow_OFP_mod: n_OFP_int is not equal to n_OFP_src')
    endif    
  call get_field_info(n_ent,fld_type,fld_name,model,n_OFP_ent)
    if(n_OFP_ent /= n_OFP_src) then 
       call mpp_error(NOTE,'==>From ocean_overflow_OFP_mod: n_OFP_ent is not equal to n_OFP_src')
    endif    

  call get_field_info(n_prd_line_01,fld_type,fld_name,model,n_OFP_prd_line_01)
    if(n_OFP_prd_line_01 /= n_OFP_src) then 
      call mpp_error(NOTE,'==>From ocean_overflow_OFP_mod: n_OFP_prd_line_01 is not equal to n_OFP_src')
    endif    
  call get_field_info(n_prd_line_02,fld_type,fld_name,model,n_OFP_prd_line_02)
    if(n_OFP_prd_line_02 /= n_OFP_src) then 
      call mpp_error(NOTE,'==>From ocean_overflow_OFP_mod: n_OFP_prd_line_02 is not equal to n_OFP_src')
    endif    
  call get_field_info(n_prd_line_03,fld_type,fld_name,model,n_OFP_prd_line_03)
    if(n_OFP_prd_line_03 /= n_OFP_src) then 
      call mpp_error(NOTE,'==>From ocean_overflow_OFP_mod: n_OFP_prd_line_03 is not equal to n_OFP_src')
    endif    
  call get_field_info(n_prd_line_04,fld_type,fld_name,model,n_OFP_prd_line_04)
    if(n_OFP_prd_line_04 /= n_OFP_src) then 
      call mpp_error(NOTE,'==>From ocean_overflow_OFP_mod: n_OFP_prd_line_04 is not equal to n_OFP_src')
    endif    
  call get_field_info(n_prd_line_05,fld_type,fld_name,model,n_OFP_prd_line_05)
    if(n_OFP_prd_line_05 /= n_OFP_src) then 
      call mpp_error(NOTE,'==>From ocean_overflow_OFP_mod: n_OFP_prd_line_05 is not equal to n_OFP_src')
    endif    
  call get_field_info(n_prd_line_06,fld_type,fld_name,model,n_OFP_prd_line_06)
    if(n_OFP_prd_line_06 /= n_OFP_src) then 
      call mpp_error(NOTE,'==>From ocean_overflow_OFP_mod: n_OFP_prd_line_06 is not equal to n_OFP_src')
    endif    
  call get_field_info(n_prd_line_07,fld_type,fld_name,model,n_OFP_prd_line_07)
    if(n_OFP_prd_line_07 /= n_OFP_src) then 
      call mpp_error(NOTE,'==>From ocean_overflow_OFP_mod: n_OFP_prd_line_07 is not equal to n_OFP_src')
    endif    
  call get_field_info(n_prd_line_08,fld_type,fld_name,model,n_OFP_prd_line_08)
    if(n_OFP_prd_line_08 /= n_OFP_src) then 
      call mpp_error(NOTE,'==>From ocean_overflow_OFP_mod: n_OFP_prd_line_08 is not equal to n_OFP_src')
    endif    
  call get_field_info(n_prd_line_09,fld_type,fld_name,model,n_OFP_prd_line_09)
    if(n_OFP_prd_line_09 /= n_OFP_src) then 
      call mpp_error(NOTE,'==>From ocean_overflow_OFP_mod: n_OFP_prd_line_09 is not equal to n_OFP_src')
    endif    
  call get_field_info(n_prd_line_10,fld_type,fld_name,model,n_OFP_prd_line_10)
    if(n_OFP_prd_line_10 /= n_OFP_src) then 
      call mpp_error(NOTE,'==>From ocean_overflow_OFP_mod: n_OFP_prd_line_10 is not equal to n_OFP_src')
    endif    
!
!----- 
     n_OFP=n_OFP_src
!----
!
  allocate(OFP_methods_info(n_OFP))
  allocate(OFP_methods_src(n_OFP))
  allocate(OFP_methods_int(n_OFP))
  allocate(OFP_methods_ent(n_OFP))
  allocate(OFP_methods_prd_line_01(n_OFP))
  allocate(OFP_methods_prd_line_02(n_OFP))
  allocate(OFP_methods_prd_line_03(n_OFP))
  allocate(OFP_methods_prd_line_04(n_OFP))
  allocate(OFP_methods_prd_line_05(n_OFP))
  allocate(OFP_methods_prd_line_06(n_OFP))
  allocate(OFP_methods_prd_line_07(n_OFP))
  allocate(OFP_methods_prd_line_08(n_OFP))
  allocate(OFP_methods_prd_line_09(n_OFP))
  allocate(OFP_methods_prd_line_10(n_OFP))
  
  allocate(phi_ofp(n_OFP))
  allocate(hu_ofp(n_OFP))
  allocate(hs_ofp(n_OFP))
  allocate(ws_ofp(n_OFP))
  allocate(xssb_ofp(n_OFP))
  allocate(alpha_ofp(n_OFP))
  allocate(cdbot_ofp(n_OFP))
 
  phi_ofp            = 0.0
  hu_ofp             = 0.0
  hs_ofp             = 0.0
  ws_ofp             = 0.0
  xssb_ofp           = 0.0
  alpha_ofp          = 0.0
  cdbot_ofp          = 0.0
 
  allocate(src_vol_trace(n_OFP,num_prog_tracers))
  allocate(ent_vol_trace(n_OFP,num_prog_tracers))
  allocate(prd_vol_trace(n_OFP,num_prog_tracers))
 
  src_vol_trace      = 0.0
  ent_vol_trace      = 0.0
  prd_vol_trace      = 0.0
 
  allocate(src_ist(n_OFP))
  allocate(src_ied(n_OFP))
  allocate(src_jst(n_OFP))
  allocate(src_jed(n_OFP))
  allocate(src_kst(n_OFP))
  allocate(src_ked(n_OFP))
  allocate(src_isc(n_OFP))
  allocate(src_iec(n_OFP))
  allocate(src_jsc(n_OFP))
  allocate(src_jec(n_OFP))
 
  src_ist   = 0
  src_ied   = 0
  src_jst   = 0
  src_jed   = 0
  src_kst   = 0
  src_ked   = 0
  src_isc   = 0
  src_iec   = 0
  src_jsc   = 0
  src_jec   = 0
 
  allocate(int_ist(n_OFP))
  allocate(int_ied(n_OFP))
  allocate(int_jst(n_OFP))
  allocate(int_jed(n_OFP))
  allocate(int_kst(n_OFP))
  allocate(int_ked(n_OFP))
  allocate(int_isc(n_OFP))
  allocate(int_iec(n_OFP))
  allocate(int_jsc(n_OFP))
  allocate(int_jec(n_OFP))
 
  int_ist   = 0
  int_ied   = 0
  int_jst   = 0
  int_jed   = 0
  int_kst   = 0
  int_ked   = 0
  int_isc   = 0
  int_iec   = 0
  int_jsc   = 0
  int_jec   = 0
 
  allocate(ent_ist(n_OFP))
  allocate(ent_ied(n_OFP))
  allocate(ent_jst(n_OFP))
  allocate(ent_jed(n_OFP))
  allocate(ent_kst(n_OFP))
  allocate(ent_ked(n_OFP))
  allocate(ent_isc(n_OFP))
  allocate(ent_iec(n_OFP))
  allocate(ent_jsc(n_OFP))
  allocate(ent_jec(n_OFP))
 
  ent_ist   = 0
  ent_ied   = 0
  ent_jst   = 0
  ent_jed   = 0
  ent_kst   = 0
  ent_ked   = 0
  ent_isc   = 0
  ent_iec   = 0
  ent_jsc   = 0
  ent_jec   = 0
 
  allocate(prd_ist(n_OFP,10))
  allocate(prd_ied(n_OFP,10))
  allocate(prd_jst(n_OFP,10))
  allocate(prd_jed(n_OFP,10))
  allocate(prd_kst(n_OFP,10))
  allocate(prd_ked(n_OFP,10))
  allocate(prd_isc(n_OFP,10))
  allocate(prd_iec(n_OFP,10))
  allocate(prd_jsc(n_OFP,10))
  allocate(prd_jec(n_OFP,10))
 
  prd_ist   = 0
  prd_ied   = 0
  prd_jst   = 0
  prd_jed   = 0
  prd_kst   = 0
  prd_ked   = 0
  prd_isc   = 0
  prd_iec   = 0
  prd_jsc   = 0
  prd_jec   = 0
 
 
 
  allocate(working_comp_domains(n_OFP))
  allocate(working_src_comp_domains(n_OFP))
  allocate(working_ent_comp_domains(n_OFP))
  allocate(working_int_comp_domains(n_OFP))
  allocate(working_prd_comp_domains(n_OFP,10))
  allocate(occur_overflow_OFP(n_OFP))
 
  working_comp_domains      = .false.
  working_src_comp_domains  = .false.
  working_ent_comp_domains  = .false.
  working_int_comp_domains  = .false.
  working_prd_comp_domains  = .false.
  occur_overflow_OFP        = .false.
 
  allocate(max_i_bound(n_OFP))
  allocate(min_i_bound(n_OFP))
  allocate(max_j_bound(n_OFP))
  allocate(min_j_bound(n_OFP))
 
  max_i_bound   = 0
  min_i_bound   = 0
  max_j_bound   = 0
  min_j_bound   = 0
 
  allocate(max_ist(n_OFP))
  allocate(max_ied(n_OFP))
  allocate(max_jst(n_OFP))
  allocate(max_jed(n_OFP))
 
  max_ist   = 0
  max_ied   = 0
  max_jst   = 0
  max_jed   = 0

!----- n_OFP

  allocate(src_volT(n_OFP))   
  allocate(src_volS(n_OFP))   
  allocate(src_volP(n_OFP))   
  allocate(src_vol(n_OFP))    
  allocate(src_dat(n_OFP))   
  allocate(src_flux_Mass(n_OFP))  
  allocate(src_den(n_OFP))   

  src_volT        =0.0
  src_volS        =0.0
  src_volP        =0.0
  src_vol         =0.0
  src_dat         =0.0
  src_flux_Mass   =0.0
  src_den         =0.0


  allocate(int_volT(n_OFP))   
  allocate(int_volS(n_OFP))   
  allocate(int_volP(n_OFP))   
  allocate(int_vol(n_OFP))  
  allocate(int_dat(n_OFP))   
  allocate(int_den(n_OFP))   

  int_volT    =0.0
  int_volS    =0.0
  int_volP    =0.0
  int_vol     =0.0
  int_dat     =0.0
  int_den      =0.0

  allocate(grav_prim_src_ofp(n_OFP)) 
  allocate(coriolis_source_ofp(n_OFP))  
  allocate(trans_vol_ofp_src_raw(n_OFP)) 
  allocate(trans_vol_ofp_src(n_OFP))  
  allocate(vel_src_ofp(n_OFP))

  grav_prim_src_ofp     =0.0
  coriolis_source_ofp   =0.0
  trans_vol_ofp_src_raw =0.0
  trans_vol_ofp_src     =0.0
  vel_src_ofp           =0.0


  allocate(ent_volT(n_OFP))   
  allocate(ent_volS(n_OFP))   
  allocate(ent_volP(n_OFP))   
  allocate(ent_vol(n_OFP))    
  allocate(ent_dat(n_OFP))   
  allocate(ent_den(n_OFP))   

  ent_volT  =0.0
  ent_volS  =0.0
  ent_volP  =0.0
  ent_vol   =0.0
  ent_dat   =0.0
  ent_den   =0.0

  allocate(src_den_prim(n_OFP))  
  allocate(src_den_prim_int(n_OFP))  
  allocate(grav_prim_ent_ofp(n_OFP)) 
  allocate(trans_vol_ofp_ent(n_OFP)) 
  allocate(trans_vol_ofp_prd(n_OFP)) 
  allocate(trans_mass_ofp_ent(n_OFP)) 
  allocate(vel_ssb_ofp(n_OFP)) 
  allocate(vel_ave_ofp(n_OFP)) 
  allocate(coef_b_ofp(n_OFP)) 
  allocate(coef_c_ofp(n_OFP)) 
  allocate(coef_d_ofp(n_OFP)) 
  allocate(hssb_ofp(n_OFP))
  allocate(Fr_geo_ofp(n_OFP))
  allocate(mix_theta_ofp(n_OFP))
  allocate(volf_per_tvol_src(n_OFP))
  allocate(volf_per_tvol_ent(n_OFP))
  allocate(ent_flux_Mass(n_OFP))
  allocate(depth_prd_OFP(n_OFP))

  src_den_prim       =0.0
  src_den_prim_int   =0.0
  grav_prim_ent_ofp  =0.0
  trans_vol_ofp_ent  =0.0
  trans_vol_ofp_prd  =0.0
  trans_mass_ofp_ent =0.0     
  vel_ssb_ofp        =0.0     
  vel_ave_ofp        =0.0     
  coef_b_ofp         =0.0     
  coef_c_ofp         =0.0     
  coef_d_ofp         =0.0     
  hssb_ofp           =0.0     
  Fr_geo_ofp         =0.0     
  mix_theta_ofp      =0.0     
  volf_per_tvol_src  =0.0     
  volf_per_tvol_ent  =0.0     
  ent_flux_Mass      =0.0     
  depth_prd_OFP      =0.0     

  allocate(prd_line_num(n_OFP))
  allocate(prd_inject_line_num(n_OFP))
 
  prd_line_num        =0
  prd_inject_line_num =0

  allocate(prd_amb_T(n_OFP,10))
  allocate(prd_amb_S(n_OFP,10))
  allocate(prd_amb_P(n_OFP,10))
  allocate(prd_amb_rho(n_OFP,10))
  allocate(prd_vol(n_OFP,10))
  allocate(prd_dat(n_OFP,10))

  prd_amb_T     = 0.0
  prd_amb_S     = 0.0
  prd_amb_P     = 0.0
  prd_amb_rho   = 0.0
  prd_vol       = 0.0
  prd_dat       = 0.0

  allocate(prd_volT(n_OFP)) 
  allocate(prd_volS(n_OFP)) 
  allocate(prd_vol_rho(n_OFP)) 
  allocate(prd_flux_Mass(n_OFP))
  allocate(prd_inj_vol(n_OFP))
  allocate(volf_per_tvol_prd(n_OFP))

  prd_volT         = 0.0 
  prd_volS         = 0.0 
  prd_vol_rho      = 0.0 
  prd_flux_Mass    = 0.0
  prd_inj_vol      = 0.0
  volf_per_tvol_prd= 0.0

!
   allocate (src_flux_trace(n_OFP,num_prog_tracers))
   allocate (ent_flux_trace(n_OFP,num_prog_tracers))
   allocate (prd_flux_trace(n_OFP,num_prog_tracers))
!
   src_flux_trace = 0.0
   ent_flux_trace = 0.0
   prd_flux_trace = 0.0

!-----------------------------------------------------
    ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_overflow_OFP_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_overflow_OFP_nml')
#else
    ioun =  open_namelist_file()
    read (ioun,ocean_overflow_OFP_nml,IOSTAT=io_status)
    ierr = check_nml_error(io_status,'ocean_overflow_OFP_nml')
    call close_file (ioun)
#endif
    write (stdlogunit,ocean_overflow_OFP_nml)
    write (stdoutunit,'(/)') 
    write (stdoutunit,ocean_overflow_OFP_nml)

    if (PRESENT(debug) .and. .not. debug_this_module) then
       debug_this_module = debug
    endif 
    if(debug_this_module) then 
       write(stdoutunit,'(a)') '==>Note: running ocean_overflow_OFP_mod with debug_this_module=.true.'  
    endif 

    if(.not. use_this_module) then 
      call mpp_error(NOTE,&
      '==>From ocean_overflow_OFP_mod: NOT using overflow_OFP scheme.')
      Ocean_options%overflow_OFP = 'Did NOT use overflow_OFP scheme.'
      return
    else 
      if(vert_coordinate_type == TERRAIN_FOLLOWING) then 
          call mpp_error(FATAL, &
          '==>ocean_overflow_OFP_mod: this module is NOT for use with TERRAIN_FOLLOWING vert coodinates.')
      endif
      Ocean_options%overflow_OFP = 'Used the OFP scheme.'
      call mpp_error(NOTE,&
      '==>From ocean_overflow_OFP_mod: USING OFP scheme.')
    endif
    if(debug_this_module) then 
      call mpp_error(NOTE,'==>From ocean_overflow_OFP_mod: USING debug_this_module')
    endif 

!----- reading the data from field_table
  call get_field_methods(n_info,OFP_methods_info)

  do i=1, n_OFP
    parse_ok = parse(OFP_methods_info(i)%method_control,'plat',phi_ofp(i))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "platitude" error')
    parse_ok = parse(OFP_methods_info(i)%method_control,'hh',hu_ofp(i))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "h_ofp" error')
    parse_ok = parse(OFP_methods_info(i)%method_control,'ww',ws_ofp(i))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "w_ofp" error')
    parse_ok = parse(OFP_methods_info(i)%method_control,'wdth',xssb_ofp(i))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "x_ofp" error')
    parse_ok = parse(OFP_methods_info(i)%method_control,'aa',alpha_ofp(i))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "a_ofp" error')
    parse_ok = parse(OFP_methods_info(i)%method_control,'cd',cdbot_ofp(i))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "cd_ofp" error')

   if (debug_this_module) then 
     write(stdoutunit,*) 'n of n_OFP_info, phi_ofp,hu_ofp,ws_ofp,xssb_ofp,alpha_ofp,cdbot_ofp' &
               ,i,phi_ofp(i),hu_ofp(i),ws_ofp(i),xssb_ofp(i),alpha_ofp(i),cdbot_ofp(i)
   endif

  enddo
!
!-------- src
  call get_field_methods(n_src,OFP_methods_src)
!
  do i=1, n_OFP
     parse_ok = parse(OFP_methods_src(i)%method_control,'s_ist',src_ist(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "s_ist" error')
     parse_ok = parse(OFP_methods_src(i)%method_control,'s_ied',src_ied(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "s_ied" error')
     parse_ok = parse(OFP_methods_src(i)%method_control,'s_jst',src_jst(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "s_jst" error')
     parse_ok = parse(OFP_methods_src(i)%method_control,'s_jed',src_jed(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "s_jed" error')
     parse_ok = parse(OFP_methods_src(i)%method_control,'s_kst',src_kst(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "s_kst" error')
     parse_ok = parse(OFP_methods_src(i)%method_control,'s_ked',src_ked(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "s_ked" error')
!
       if (debug_this_module) then 
           write(*,*) 'n of n_OFP, src_ist,src_ied,src_jst,src_jed,src_kst,src_ked', &
                      i,src_ist(i),src_ied(i),src_jst(i),src_jed(i),src_kst(i),src_ked(i)
       endif
  enddo
!
!-------- int
  call get_field_methods(n_int,OFP_methods_int)
!
  do i=1, n_OFP
     parse_ok = parse(OFP_methods_int(i)%method_control,'i_ist',int_ist(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "i_ist" error')
     parse_ok = parse(OFP_methods_int(i)%method_control,'i_ied',int_ied(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "i_ied" error')
     parse_ok = parse(OFP_methods_int(i)%method_control,'i_jst',int_jst(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "i_jst" error')
     parse_ok = parse(OFP_methods_int(i)%method_control,'i_jed',int_jed(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "i_jed" error')
     parse_ok = parse(OFP_methods_int(i)%method_control,'i_kst',int_kst(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "i_kst" error')
     parse_ok = parse(OFP_methods_int(i)%method_control,'i_ked',int_ked(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "i_ked" error')
!
       if (debug_this_module) then 
           write(stdoutunit,*) 'n of n_OFP, int_ist,int_ied,int_jst,int_jed,int_kst,int_ked', &
                      i,int_ist(i),int_ied(i),int_jst(i),int_jed(i),int_kst(i),int_ked(i)
       endif
  enddo
!
!-------- ent
  call get_field_methods(n_ent,OFP_methods_ent)
!
  do i=1, n_OFP
     parse_ok = parse(OFP_methods_ent(i)%method_control,'e_ist',ent_ist(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "e_ist" error')
     parse_ok = parse(OFP_methods_ent(i)%method_control,'e_ied',ent_ied(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "e_ied" error')
     parse_ok = parse(OFP_methods_ent(i)%method_control,'e_jst',ent_jst(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "e_jst" error')
     parse_ok = parse(OFP_methods_ent(i)%method_control,'e_jed',ent_jed(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "e_jed" error')
     parse_ok = parse(OFP_methods_ent(i)%method_control,'e_kst',ent_kst(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "e_kst" error')
     parse_ok = parse(OFP_methods_ent(i)%method_control,'e_ked',ent_ked(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP table entry "e_ked" error')
!
       if (debug_this_module) then 
           write(stdoutunit,*) 'n of n_OFP, ent_ist,ent_ied,ent_jst,ent_jed,ent_kst,ent_ked', &
                      i,ent_ist(i),ent_ied(i),ent_jst(i),ent_jed(i),ent_kst(i),ent_ked(i)
       endif
  enddo
!
!--------- prd line 01
  call get_field_methods(n_prd_line_01,OFP_methods_prd_line_01)
!
  do i=1, n_OFP
     parse_ok = parse(OFP_methods_prd_line_01(i)%method_control,'p_ist',prd_ist(i,1))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_01 table entry "p_ist" error')
     parse_ok = parse(OFP_methods_prd_line_01(i)%method_control,'p_ied',prd_ied(i,1))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_01 table entry "p_ied" error')
     parse_ok = parse(OFP_methods_prd_line_01(i)%method_control,'p_jst',prd_jst(i,1))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_01 table entry "p_jst" error')
     parse_ok = parse(OFP_methods_prd_line_01(i)%method_control,'p_jed',prd_jed(i,1))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_01 table entry "p_jed" error')
     parse_ok = parse(OFP_methods_prd_line_01(i)%method_control,'p_kst',prd_kst(i,1))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_01 table entry "p_kst" error')
     parse_ok = parse(OFP_methods_prd_line_01(i)%method_control,'p_ked',prd_ked(i,1))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_01 table entry "p_ked" error')
!
       if (debug_this_module) then 
           write(*,*) 'n of n_OFP_prd_line_01, prd_ist,prd_ied,prd_jst,prd_jed,prd_kst,prd_ked', &
                      i,prd_ist(i,1),prd_ied(i,1),prd_jst(i,1),prd_jed(i,1),prd_kst(i,1),prd_ked(i,1)
       endif
  enddo
!
!--------- prd line 02
  call get_field_methods(n_prd_line_02,OFP_methods_prd_line_02)
!
  do i=1, n_OFP
     parse_ok = parse(OFP_methods_prd_line_02(i)%method_control,'p_ist',prd_ist(i,2))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_02 table entry "p_ist" error')
     parse_ok = parse(OFP_methods_prd_line_02(i)%method_control,'p_ied',prd_ied(i,2))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_02 table entry "p_ied" error')
     parse_ok = parse(OFP_methods_prd_line_02(i)%method_control,'p_jst',prd_jst(i,2))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_02 table entry "p_jst" error')
     parse_ok = parse(OFP_methods_prd_line_02(i)%method_control,'p_jed',prd_jed(i,2))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_02 table entry "p_jed" error')
     parse_ok = parse(OFP_methods_prd_line_02(i)%method_control,'p_kst',prd_kst(i,2))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_02 table entry "p_kst" error')
     parse_ok = parse(OFP_methods_prd_line_02(i)%method_control,'p_ked',prd_ked(i,2))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_02 table entry "p_ked" error')
!
       if (debug_this_module) then 
           write(stdoutunit,*) 'n of n_OFP_prd_line_02, prd_ist,prd_ied,prd_jst,prd_jed,prd_kst,prd_ked', &
                      i,prd_ist(i,2),prd_ied(i,2),prd_jst(i,2),prd_jed(i,2),prd_kst(i,2),prd_ked(i,2)
       endif
  enddo
!
!--------- prd line 03
  call get_field_methods(n_prd_line_03,OFP_methods_prd_line_03)
!
  do i=1, n_OFP
     parse_ok = parse(OFP_methods_prd_line_03(i)%method_control,'p_ist',prd_ist(i,3))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_03 table entry "p_ist" error')
     parse_ok = parse(OFP_methods_prd_line_03(i)%method_control,'p_ied',prd_ied(i,3))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_03 table entry "p_ied" error')
     parse_ok = parse(OFP_methods_prd_line_03(i)%method_control,'p_jst',prd_jst(i,3))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_03 table entry "p_jst" error')
     parse_ok = parse(OFP_methods_prd_line_03(i)%method_control,'p_jed',prd_jed(i,3))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_03 table entry "p_jed" error')
     parse_ok = parse(OFP_methods_prd_line_03(i)%method_control,'p_kst',prd_kst(i,3))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_03 table entry "p_kst" error')
     parse_ok = parse(OFP_methods_prd_line_03(i)%method_control,'p_ked',prd_ked(i,3))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_03 table entry "p_ked" error')
!
       if (debug_this_module) then 
           write(stdoutunit,*) 'n of n_OFP_prd_line_03, prd_ist,prd_ied,prd_jst,prd_jed,prd_kst,prd_ked', &
                i,prd_ist(i,3),prd_ied(i,3),prd_jst(i,3),prd_jed(i,3),prd_kst(i,3),prd_ked(i,3)
       endif
  enddo
!
!--------- prd line 04
  call get_field_methods(n_prd_line_04,OFP_methods_prd_line_04)
!
  do i=1, n_OFP
     parse_ok = parse(OFP_methods_prd_line_04(i)%method_control,'p_ist',prd_ist(i,4))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_04 table entry "p_ist" error')
     parse_ok = parse(OFP_methods_prd_line_04(i)%method_control,'p_ied',prd_ied(i,4))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_04 table entry "p_ied" error')
     parse_ok = parse(OFP_methods_prd_line_04(i)%method_control,'p_jst',prd_jst(i,4))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_04 table entry "p_jst" error')
     parse_ok = parse(OFP_methods_prd_line_04(i)%method_control,'p_jed',prd_jed(i,4))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_04 table entry "p_jed" error')
     parse_ok = parse(OFP_methods_prd_line_04(i)%method_control,'p_kst',prd_kst(i,4))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_04 table entry "p_kst" error')
     parse_ok = parse(OFP_methods_prd_line_04(i)%method_control,'p_ked',prd_ked(i,4))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_04 table entry "p_ked" error')
!
       if (debug_this_module) then 
            write(*,*) 'n of n_OFP_prd_line_04, prd_ist,prd_ied,prd_jst,prd_jed,prd_kst,prd_ked', &
                 i,prd_ist(i,4),prd_ied(i,4),prd_jst(i,4),prd_jed(i,4),prd_kst(i,4),prd_ked(i,4)
       endif
  enddo
!
!--------- prd line 05
  call get_field_methods(n_prd_line_05,OFP_methods_prd_line_05)
!
  do i=1, n_OFP
     parse_ok = parse(OFP_methods_prd_line_05(i)%method_control,'p_ist',prd_ist(i,5))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_05 table entry "p_ist" error')
     parse_ok = parse(OFP_methods_prd_line_05(i)%method_control,'p_ied',prd_ied(i,5))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_05 table entry "p_ied" error')
     parse_ok = parse(OFP_methods_prd_line_05(i)%method_control,'p_jst',prd_jst(i,5))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_05 table entry "p_jst" error')
     parse_ok = parse(OFP_methods_prd_line_05(i)%method_control,'p_jed',prd_jed(i,5))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_05 table entry "p_jed" error')
     parse_ok = parse(OFP_methods_prd_line_05(i)%method_control,'p_kst',prd_kst(i,5))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_05 table entry "p_kst" error')
     parse_ok = parse(OFP_methods_prd_line_05(i)%method_control,'p_ked',prd_ked(i,5))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_05 table entry "p_ked" error')
!
       if (debug_this_module) then 
            write(stdoutunit,*) 'n of n_OFP_prd_line_05, prd_ist,prd_ied,prd_jst,prd_jed,prd_kst,prd_ked', &
                 i,prd_ist(i,5),prd_ied(i,5),prd_jst(i,5),prd_jed(i,5),prd_kst(i,5),prd_ked(i,5)
       endif
  enddo
!
!--------- prd line 06
  call get_field_methods(n_prd_line_06,OFP_methods_prd_line_06)
!
  do i=1, n_OFP
     parse_ok = parse(OFP_methods_prd_line_06(i)%method_control,'p_ist',prd_ist(i,6))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_06 table entry "p_ist" error')
     parse_ok = parse(OFP_methods_prd_line_06(i)%method_control,'p_ied',prd_ied(i,6))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_06 table entry "p_ied" error')
     parse_ok = parse(OFP_methods_prd_line_06(i)%method_control,'p_jst',prd_jst(i,6))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_06 table entry "p_jst" error')
     parse_ok = parse(OFP_methods_prd_line_06(i)%method_control,'p_jed',prd_jed(i,6))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_06 table entry "p_jed" error')
     parse_ok = parse(OFP_methods_prd_line_06(i)%method_control,'p_kst',prd_kst(i,6))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_06 table entry "p_kst" error')
     parse_ok = parse(OFP_methods_prd_line_06(i)%method_control,'p_ked',prd_ked(i,6))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_06 table entry "p_ked" error')
!
       if (debug_this_module) then 
            write(stdoutunit,*) 'n of n_OFP_prd_line_06, prd_ist,prd_ied,prd_jst,prd_jed,prd_kst,prd_ked', &
                 i,prd_ist(i,6),prd_ied(i,6),prd_jst(i,6),prd_jed(i,6),prd_kst(i,6),prd_ked(i,6)
       endif
  enddo
!
!--------- prd line 07
  call get_field_methods(n_prd_line_07,OFP_methods_prd_line_07)
!
  do i=1, n_OFP
     parse_ok = parse(OFP_methods_prd_line_07(i)%method_control,'p_ist',prd_ist(i,7))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_07 table entry "p_ist" error')
     parse_ok = parse(OFP_methods_prd_line_07(i)%method_control,'p_ied',prd_ied(i,7))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_07 table entry "p_ied" error')
     parse_ok = parse(OFP_methods_prd_line_07(i)%method_control,'p_jst',prd_jst(i,7))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_07 table entry "p_jst" error')
     parse_ok = parse(OFP_methods_prd_line_07(i)%method_control,'p_jed',prd_jed(i,7))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_07 table entry "p_jed" error')
     parse_ok = parse(OFP_methods_prd_line_07(i)%method_control,'p_kst',prd_kst(i,7))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_07 table entry "p_kst" error')
     parse_ok = parse(OFP_methods_prd_line_07(i)%method_control,'p_ked',prd_ked(i,7))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_07 table entry "p_ked" error')
!
       if (debug_this_module) then 
            write(stdoutunit,*) 'n of n_OFP_prd_line_07, prd_ist,prd_ied,prd_jst,prd_jed,prd_kst,prd_ked', &
                 i,prd_ist(i,7),prd_ied(i,7),prd_jst(i,7),prd_jed(i,7),prd_kst(i,7),prd_ked(i,7)
       endif
  enddo
!
!--------- prd line 08
  call get_field_methods(n_prd_line_08,OFP_methods_prd_line_08)
!
  do i=1, n_OFP
     parse_ok = parse(OFP_methods_prd_line_08(i)%method_control,'p_ist',prd_ist(i,8))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_08 table entry "p_ist" error')
     parse_ok = parse(OFP_methods_prd_line_08(i)%method_control,'p_ied',prd_ied(i,8))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_08 table entry "p_ied" error')
     parse_ok = parse(OFP_methods_prd_line_08(i)%method_control,'p_jst',prd_jst(i,8))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_08 table entry "p_jst" error')
     parse_ok = parse(OFP_methods_prd_line_08(i)%method_control,'p_jed',prd_jed(i,8))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_08 table entry "p_jed" error')
     parse_ok = parse(OFP_methods_prd_line_08(i)%method_control,'p_kst',prd_kst(i,8))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_08 table entry "p_kst" error')
     parse_ok = parse(OFP_methods_prd_line_08(i)%method_control,'p_ked',prd_ked(i,8))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_08 table entry "p_ked" error')
!
       if (debug_this_module) then 
            write(stdoutunit,*) 'n of n_OFP_prd_line_08, prd_ist,prd_ied,prd_jst,prd_jed,prd_kst,prd_ked', &
                 i,prd_ist(i,8),prd_ied(i,8),prd_jst(i,8),prd_jed(i,8),prd_kst(i,8),prd_ked(i,8)
       endif
  enddo
!
!--------- prd line 09
  call get_field_methods(n_prd_line_09,OFP_methods_prd_line_09)
!
  do i=1, n_OFP
     parse_ok = parse(OFP_methods_prd_line_09(i)%method_control,'p_ist',prd_ist(i,9))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_09 table entry "p_ist" error')
     parse_ok = parse(OFP_methods_prd_line_09(i)%method_control,'p_ied',prd_ied(i,9))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_09 table entry "p_ied" error')
     parse_ok = parse(OFP_methods_prd_line_09(i)%method_control,'p_jst',prd_jst(i,9))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_09 table entry "p_jst" error')
     parse_ok = parse(OFP_methods_prd_line_09(i)%method_control,'p_jed',prd_jed(i,9))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_09 table entry "p_jed" error')
     parse_ok = parse(OFP_methods_prd_line_09(i)%method_control,'p_kst',prd_kst(i,9))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_09 table entry "p_kst" error')
     parse_ok = parse(OFP_methods_prd_line_09(i)%method_control,'p_ked',prd_ked(i,9))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_09 table entry "p_ked" error')
!
       if (debug_this_module) then 
            write(stdoutunit,*) 'n of n_OFP_prd_line_09, prd_ist,prd_ied,prd_jst,prd_jed,prd_kst,prd_ked', &
                 i,prd_ist(i,9),prd_ied(i,9),prd_jst(i,9),prd_jed(i,9),prd_kst(i,9),prd_ked(i,9)
       endif
  enddo
!
!--------- prd line 10
  call get_field_methods(n_prd_line_10,OFP_methods_prd_line_10)
!
  do i=1, n_OFP
     parse_ok = parse(OFP_methods_prd_line_10(i)%method_control,'p_ist',prd_ist(i,10))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_10 table entry "p_ist" error')
     parse_ok = parse(OFP_methods_prd_line_10(i)%method_control,'p_ied',prd_ied(i,10))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_10 table entry "p_ied" error')
     parse_ok = parse(OFP_methods_prd_line_10(i)%method_control,'p_jst',prd_jst(i,10))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_10 table entry "p_jst" error')
     parse_ok = parse(OFP_methods_prd_line_10(i)%method_control,'p_jed',prd_jed(i,10))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_10 table entry "p_jed" error')
     parse_ok = parse(OFP_methods_prd_line_10(i)%method_control,'p_kst',prd_kst(i,10))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_10 table entry "p_kst" error')
     parse_ok = parse(OFP_methods_prd_line_10(i)%method_control,'p_ked',prd_ked(i,10))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_overflow_OFP_mod: OFP_10 table entry "p_ked" error')
!
       if (debug_this_module) then 
            write(stdoutunit,*) 'n of n_OFP_prd_line_10, prd_ist,prd_ied,prd_jst,prd_jed,prd_kst,prd_ked', &
                 i,prd_ist(i,10),prd_ied(i,10),prd_jst(i,10),prd_jed(i,10),prd_kst(i,10),prd_ked(i,10)
       endif
  enddo
!
!----------- define whether working domain or not
  do nindx=1,n_OFP
      working_src_comp_domains(nindx) = .false.
      if (src_ist(nindx)*src_ied(nindx)*src_jst(nindx)*src_jed(nindx) /= 0) then
        if (((src_ist(nindx) >= isc .and. src_ist(nindx) <= iec) .or.      &
             (src_ied(nindx) >= isc .and. src_ied(nindx) <= iec))   .and.  &
            ((src_jst(nindx) >= jsc .and. src_jst(nindx) <= jec) .or.      &
             (src_jed(nindx) >= jsc .and. src_jed(nindx) <= jec)))   then
                  working_src_comp_domains(nindx) = .true.
        endif
      endif
      working_ent_comp_domains(nindx) = .false.
      if (ent_ist(nindx)*ent_ied(nindx)*ent_jst(nindx)*ent_jed(nindx) /= 0) then
        if (((ent_ist(nindx) >= isc .and. ent_ist(nindx) <= iec) .or.      &
             (ent_ied(nindx) >= isc .and. ent_ied(nindx) <= iec))   .and.  &
            ((ent_jst(nindx) >= jsc .and. ent_jst(nindx) <= jec) .or.      &
             (ent_jed(nindx) >= jsc .and. ent_jed(nindx) <= jec)))   then
                  working_ent_comp_domains(nindx) = .true.
        endif
      endif
      working_int_comp_domains(nindx) = .false.
      if (int_ist(nindx)*int_ied(nindx)*int_jst(nindx)*int_jed(nindx) /= 0) then
        if (((int_ist(nindx) >= isc .and. int_ist(nindx) <= iec) .or.      &
             (int_ied(nindx) >= isc .and. int_ied(nindx) <= iec))   .and.  &
            ((int_jst(nindx) >= jsc .and. int_jst(nindx) <= jec) .or.      &
             (int_jed(nindx) >= jsc .and. int_jed(nindx) <= jec)))   then
                  working_int_comp_domains(nindx) = .true.
        endif
      endif
    do mindx=1,10
      working_prd_comp_domains(nindx,mindx) = .false.
      if (prd_ist(nindx,mindx)*prd_ied(nindx,mindx)*prd_jst(nindx,mindx)*prd_jed(nindx,mindx) /= 0) then
        if (((prd_ist(nindx,mindx) >= isc .and. prd_ist(nindx,mindx) <= iec) .or.      &
             (prd_ied(nindx,mindx) >= isc .and. prd_ied(nindx,mindx) <= iec))   .and.  &
            ((prd_jst(nindx,mindx) >= jsc .and. prd_jst(nindx,mindx) <= jec) .or.      &
             (prd_jed(nindx,mindx) >= jsc .and. prd_jed(nindx,mindx) <= jec)))   then
                  working_prd_comp_domains(nindx,mindx) = .true.
        endif
      endif
    enddo ! mindx=1,10
  enddo !nindx=1,n_OFP
!
!-----------
   do nindx=1,n_OFP      
       working_comp_domains(nindx)=.false.
       if ( working_src_comp_domains(nindx) ) working_comp_domains(nindx)=.true.
       if ( working_ent_comp_domains(nindx) ) working_comp_domains(nindx)=.true.
       if ( working_int_comp_domains(nindx) ) working_comp_domains(nindx)=.true.
         do mindx=1,10
           if ( working_prd_comp_domains(nindx,mindx) ) working_comp_domains(nindx)=.true.
         enddo ! mindx=1,10
   enddo !nindx=1,n_OFP
!
!-----------
    working_comp_domains_all=.false.
    do nindx=1,n_OFP      
       if (working_comp_domains(nindx)) working_comp_domains_all=.true.
    enddo !nindx=1,n_OFP
!         
!---  define the max and min i,j for xhalo and jhalo
!---  no consideration for the arctic cyclonic boundaries

 if ( working_comp_domains_all) then  
   do nindx=1,n_OFP
      max_i_bound(nindx)=src_ied(nindx)
      min_i_bound(nindx)=src_ist(nindx)
      max_j_bound(nindx)=src_jed(nindx)
      min_j_bound(nindx)=src_jst(nindx)
!------- max_i_bound
      if (src_ied(nindx) /= 0 .and. src_ied(nindx) > max_i_bound(nindx)) max_i_bound(nindx)=src_ied(nindx)
      if (int_ied(nindx) /= 0 .and. int_ied(nindx) > max_i_bound(nindx)) max_i_bound(nindx)=int_ied(nindx)
      if (ent_ied(nindx) /= 0 .and. ent_ied(nindx) > max_i_bound(nindx)) max_i_bound(nindx)=ent_ied(nindx)
         do mindx=1,10
            if (prd_ied(nindx,mindx) /= 0 .and. prd_ied(nindx,mindx) > max_i_bound(nindx)) &
                max_i_bound(nindx)=prd_ied(nindx,mindx)
         enddo ! mindx=1,10
!------- min_i_bound
      if (src_ist(nindx) /= 0 .and. src_ist(nindx) < min_i_bound(nindx)) min_i_bound(nindx)=src_ist(nindx)
      if (int_ist(nindx) /= 0 .and. int_ist(nindx) < min_i_bound(nindx)) min_i_bound(nindx)=int_ist(nindx)
      if (ent_ist(nindx) /= 0 .and. ent_ist(nindx) < min_i_bound(nindx)) min_i_bound(nindx)=ent_ist(nindx)
         do mindx=1,10
            if (prd_ist(nindx,mindx) /= 0 .and. prd_ist(nindx,mindx) < min_i_bound(nindx)) &
                min_i_bound(nindx)=prd_ist(nindx,mindx)
         enddo ! mindx=1,10
!------- max_j_bound
      if (src_jed(nindx) /= 0 .and. src_jed(nindx) > max_j_bound(nindx)) max_j_bound(nindx)=src_jed(nindx)
      if (int_jed(nindx) /= 0 .and. int_jed(nindx) > max_j_bound(nindx)) max_j_bound(nindx)=int_jed(nindx)
      if (ent_jed(nindx) /= 0 .and. ent_jed(nindx) > max_j_bound(nindx)) max_j_bound(nindx)=ent_jed(nindx)
         do mindx=1,10
            if (prd_jed(nindx,mindx) /= 0 .and. prd_jed(nindx,mindx) > max_j_bound(nindx)) &
                max_j_bound(nindx)=prd_jed(nindx,mindx)
         enddo ! mindx=1,10
!------- min_j_bound
      if (src_jst(nindx) /= 0 .and. src_jst(nindx) < min_j_bound(nindx)) min_j_bound(nindx)=src_jst(nindx)
      if (int_jst(nindx) /= 0 .and. int_jst(nindx) < min_j_bound(nindx)) min_j_bound(nindx)=int_jst(nindx)
      if (ent_jst(nindx) /= 0 .and. ent_jst(nindx) < min_j_bound(nindx)) min_j_bound(nindx)=ent_jst(nindx)
         do mindx=1,10
            if (prd_jst(nindx,mindx) /= 0 .and. prd_jst(nindx,mindx) < min_j_bound(nindx)) &
                min_j_bound(nindx)=prd_jst(nindx,mindx)
         enddo ! mindx=1,10
   enddo !nindx=1,n_OFP
!
   if (debug_this_module) then
     do nindx=1,n_OFP
       write(*,*) 'pe,nindx,max_i_bound,min_i_bound,max_j_bound,min_j_bound ' &
                ,pe,nindx,max_i_bound(nindx),min_i_bound(nindx),max_j_bound(nindx),min_j_bound(nindx)
     enddo !nindx=1,n_OFP
    endif
!
 endif ! (working_comp_domains) 


!----- define halo region
!----- find the halo range on the maximum region of OFP at the comp. domain

!--- mpp_sum
!-!
        OFP_xhalo=2
        OFP_yhalo=2

!----- define computation index
 do nindx=1,n_OFP
  
   if ( working_src_comp_domains(nindx) ) then

       src_isc(nindx)  = isc    
       if (src_ist(nindx) >= isc ) src_isc(nindx)=src_ist(nindx)

       src_iec(nindx)  = iec    
       if (src_ied(nindx) <= iec ) src_iec(nindx)=src_ied(nindx)

       src_jsc(nindx)  = jsc    
       if (src_jst(nindx) >= jsc ) src_jsc(nindx)=src_jst(nindx)

       src_jec(nindx)  = jec    
       if (src_jed(nindx) <= jec ) src_jec(nindx)=src_jed(nindx)

      if (debug_this_module) then
         write(*,*) "pe, nindx,src_isc(nindx),src_iec(nindx)",pe, nindx,src_isc(nindx),src_iec(nindx)
      endif
   endif

   if ( working_ent_comp_domains(nindx) ) then

       ent_isc(nindx)  = isc    
       if (ent_ist(nindx) >= isc ) ent_isc(nindx)=ent_ist(nindx)

       ent_iec(nindx)  = iec    
       if (ent_ied(nindx) <= iec ) ent_iec(nindx)=ent_ied(nindx)

       ent_jsc(nindx)  = jsc    
       if (ent_jst(nindx) >= jsc ) ent_jsc(nindx)=ent_jst(nindx)

       ent_jec(nindx)  = jec    
       if (ent_jed(nindx) <= jec ) ent_jec(nindx)=ent_jed(nindx)

      if (debug_this_module) then
         write(*,*) "pe, nindx,ent_isc(nindx),ent_iec(nindx)",pe, nindx,ent_isc(nindx),ent_iec(nindx)
      endif
   endif


   if ( working_int_comp_domains(nindx) ) then

       int_isc(nindx)  = isc    
       if (int_ist(nindx) >= isc ) int_isc(nindx)=int_ist(nindx)

       int_iec(nindx)  = iec    
       if (int_ied(nindx) <= iec ) int_iec(nindx)=int_ied(nindx)

       int_jsc(nindx)  = jsc    
       if (int_jst(nindx) >= jsc ) int_jsc(nindx)=int_jst(nindx)

       int_jec(nindx)  = jec    
       if (int_jed(nindx) <= jec ) int_jec(nindx)=int_jed(nindx)

      if (debug_this_module) then
         write(*,*) "pe, nindx,int_isc(nindx),int_iec(nindx)",pe, nindx,int_isc(nindx),int_iec(nindx)
      endif
   endif

   do mindx=1,10

     if ( working_prd_comp_domains(nindx,mindx) ) then

       prd_isc(nindx,mindx)  = isc    
       if (prd_ist(nindx,mindx) >= isc ) prd_isc(nindx,mindx)=prd_ist(nindx,mindx)

       prd_iec(nindx,mindx)  = iec    
       if (prd_ied(nindx,mindx) <= iec ) prd_iec(nindx,mindx)=prd_ied(nindx,mindx)

       prd_jsc(nindx,mindx)  = jsc    
       if (prd_jst(nindx,mindx) >= jsc ) prd_jsc(nindx,mindx)=prd_jst(nindx,mindx)

       prd_jec(nindx,mindx)  = jec    
       if (prd_jed(nindx,mindx) <= jec ) prd_jec(nindx,mindx)=prd_jed(nindx,mindx)

       if (debug_this_module) then
         write(*,*) "pe, nindx,mindx,prd_isc(nindx,mindx)",pe, nindx,mindx,prd_isc(nindx,mindx)
      endif
    endif
   enddo ! mindx=1,10

 enddo !nindx=1,n_OFP


!-------------------------------------------------------------------------------
  if (debug_this_module) then 
    do nindx=1,n_OFP
      if (working_comp_domains(nindx)) then
        write(stdoutunit,*) ' test for working_comp_domains(nindx)---> .true. pe,nindx*************', pe,nindx
        write(stdoutunit,*) 'pe,max_i_bound,min_i_bound,max_j_bound,min_j_bound ' &
                   ,pe,max_i_bound(nindx),min_i_bound(nindx),max_j_bound(nindx),min_j_bound(nindx)
        write(stdoutunit,*) ' pe,isc,iec,jsc,jec',pe,isc,iec,jsc,jec
        write(stdoutunit,*) ' pe,OFP_xhalo,OFP_yhalo',pe,OFP_xhalo,OFP_yhalo
        if (working_src_comp_domains(nindx)) then
          write(stdoutunit,*) ' working_src_comp_domains(nindx)---> .true. at pe,nindx*************', pe,nindx
          write(stdoutunit,*) ' pe,isc,iec,jsc,jec',pe,isc,iec,jsc,jec
          write(stdoutunit,*) ' pe,src_ist(nindx),src_ied(nindx),src_jst(nindx),src_jed(nindx)' &
                      ,pe,src_ist(nindx),src_ied(nindx),src_jst(nindx),src_jed(nindx)
          write(stdoutunit,*) ' pe,src_isc(nindx),src_iec(nindx),src_jsc(nindx),src_jec(nindx)' &
                      ,pe,src_isc(nindx),src_iec(nindx),src_jsc(nindx),src_jec(nindx)
        endif
        if (working_ent_comp_domains(nindx)) then       
          write(stdoutunit,*) ' working_ent_comp_domains(nindx)---> .true. at pe,,nindx*************', pe,nindx
          write(stdoutunit,*) ' pe,isc,iec,jsc,jec',pe,isc,iec,jsc,jec
          write(stdoutunit,*) ' pe,ent_ist(nindx),ent_ied(nindx),ent_jst(nindx),ent_jed(nindx)' &
                      ,pe,ent_ist(nindx),ent_ied(nindx),ent_jst(nindx),ent_jed(nindx)
          write(stdoutunit,*) ' pe,ent_isc(nindx),ent_iec(nindx),ent_jsc(nindx),ent_jec(nindx)' &
                      ,pe,ent_isc(nindx),ent_iec(nindx),ent_jsc(nindx),ent_jec(nindx)
         endif
         do mindx=1,10
          if (working_prd_comp_domains(nindx,mindx)) then
            write(stdoutunit,*) ' working_prd_comp_domains(nindx,mindx)---> .true. at pe,nindx,mindx**', &
                        pe,nindx,mindx
            write(stdoutunit,*) 'pe,isc,iec,jsc,jec',pe,isc,iec,jsc,jec
            write(stdoutunit,*)   &
                 'pe,prd_ist(nindx,mindx),prd_ied(nindx,mindx),prd_jst(nindx,mindx),prd_jed(nindx,mindx) ' &
                 ,pe,prd_ist(nindx,mindx),prd_ied(nindx,mindx),prd_jst(nindx,mindx),prd_jed(nindx,mindx)
            write(stdoutunit,*)   &
                 'pe,prd_isc(nindx,mindx),prd_iec(nindx,mindx),prd_jsc(nindx,mindx),prd_jec(nindx,mindx) ' &
                 ,pe,prd_isc(nindx,mindx),prd_iec(nindx,mindx),prd_jsc(nindx,mindx),prd_jec(nindx,mindx)
           endif 
          enddo ! mindx=1,10
      endif
    enddo ! nindx=1,n_OFP
  endif


!--- define OFP domain 
  call set_ocean_domain(OFP_domain,Grd,xhalo=OFP_xhalo,yhalo=OFP_yhalo,&
                        name='overflow_OFP',maskmap=Dom%maskmap)

!-------------------------------------------------------------------------------
!
!--------- allocation
!
!--- for mpp_sum

   allocate (kmto(isc-OFP_xhalo:iec+OFP_xhalo,jsc-OFP_yhalo:jec+OFP_yhalo))
   allocate (dato(isc-OFP_xhalo:iec+OFP_xhalo,jsc-OFP_yhalo:jec+OFP_yhalo))
   allocate (dxto(isc-OFP_xhalo:iec+OFP_xhalo,jsc-OFP_yhalo:jec+OFP_yhalo))
   allocate (dyto(isc-OFP_xhalo:iec+OFP_xhalo,jsc-OFP_yhalo:jec+OFP_yhalo))
   allocate (hto(isc-OFP_xhalo:iec+OFP_xhalo,jsc-OFP_yhalo:jec+OFP_yhalo))
   allocate (tmsko(isc-OFP_xhalo:iec+OFP_xhalo,jsc-OFP_yhalo:jec+OFP_yhalo,1:nk))
   allocate (umsko(isc-OFP_xhalo:iec+OFP_xhalo,jsc-OFP_yhalo:jec+OFP_yhalo,1:nk))
   allocate (dzto(isc-OFP_xhalo:iec+OFP_xhalo,jsc-OFP_yhalo:jec+OFP_yhalo,1:nk))
   allocate (rho_dzto(isc-OFP_xhalo:iec+OFP_xhalo,jsc-OFP_yhalo:jec+OFP_yhalo,1:nk))
   allocate (tempo(isc-OFP_xhalo:iec+OFP_xhalo,jsc-OFP_yhalo:jec+OFP_yhalo,1:nk))
   allocate (salto(isc-OFP_xhalo:iec+OFP_xhalo,jsc-OFP_yhalo:jec+OFP_yhalo,1:nk))
   allocate (traceo(isc-OFP_xhalo:iec+OFP_xhalo,jsc-OFP_yhalo:jec+OFP_yhalo,1:nk,1:num_prog_tracers))
   allocate (presso(isc-OFP_xhalo:iec+OFP_xhalo,jsc-OFP_yhalo:jec+OFP_yhalo,1:nk))
   allocate (depth_zto(isc-OFP_xhalo:iec+OFP_xhalo,jsc-OFP_yhalo:jec+OFP_yhalo,1:nk))
!

   kmto      = 0
   dato      = 0.0
   dxto      = 0.0
   dyto      = 0.0
   hto       = 0.0
   dzto      = 0.0
   tmsko     = 0.0
   umsko     = 0.0
   rho_dzto  = 0.0
   tempo     = 0.0
   salto     = 0.0
   traceo    = 0.0
   presso    = 0.0
   depth_zto = 0.0
!
    do j=jsc,jec
      do i=isc,iec
         kmto(i,j)= Grd%kmt(i,j)   
         dato(i,j)= Grd%dat(i,j)
         dxto(i,j)= Grd%dxt(i,j)
         dyto(i,j)= Grd%dyt(i,j)
         hto(i,j) = Grd%ht(i,j)
      enddo
    enddo 

  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
         tmsko(i,j,k)=Grd%tmask(i,j,k)
         umsko(i,j,k)=Grd%umask(i,j,k)
      enddo
    enddo 
  enddo 
!

!-- no update domains

   ! integer variables
   call mpp_update_domains (kmto, OFP_domain%domain2d, complete=.true.)
   ! real variables
   call mpp_update_domains (dato, OFP_domain%domain2d, complete=.false.)
   call mpp_update_domains (dxto, OFP_domain%domain2d, complete=.false.)
   call mpp_update_domains (dyto, OFP_domain%domain2d, complete=.false.)
   call mpp_update_domains (hto,  OFP_domain%domain2d, complete=.true.)
   call mpp_update_domains (tmsko,OFP_domain%domain2d, complete=.false.)
   call mpp_update_domains (umsko,OFP_domain%domain2d, complete=.true.)


!-------------------------------------------------------------------------------
   do nindx=1,n_OFP 
      if (working_comp_domains(nindx)) then

          do j=src_jsc(nindx),src_jec(nindx)
             do i=src_isc(nindx),src_iec(nindx)
                if (src_ked(nindx) > kmto(i,j)) then
                    write (stdoutunit,*) ' ked > kmt, at pe,nindx,i,j', pe,nindx,i,j
                    write (stdoutunit,*) ' src_ked(nindx),kmto(i,j)',src_ked(nindx),kmto(i,j)
                endif
             enddo
          enddo

          do j=int_jsc(nindx),int_jec(nindx)
             do i=int_isc(nindx),int_iec(nindx)
                if (int_ked(nindx) > kmto(i,j)) then
                    write (stdoutunit,*) ' ked > kmt, at pe,nindx,i,j', pe,nindx,i,j
                    write (stdoutunit,*) ' int_ked(nindx),kmto(i,j)',int_ked(nindx),kmto(i,j)
                endif
             enddo
          enddo

          do j=ent_jsc(nindx),ent_jec(nindx)
             do i=ent_isc(nindx),ent_iec(nindx)
                if (ent_ked(nindx) > kmto(i,j)) then
                    write (stdoutunit,*) ' ked > kmt, at pe,nindx,i,j', pe,nindx,i,j
                    write (stdoutunit,*) ' ent_ked(nindx),kmto(i,j)',ent_ked(nindx),kmto(i,j)
                endif
             enddo
          enddo

          do m=1,10
             if (prd_jst(nindx,m) /= 0) then
                 do j=prd_jsc(nindx,m),prd_jec(nindx,m)
                    do i=prd_isc(nindx,m),prd_iec(nindx,m)
                       if (prd_ked(nindx,m) > kmto(i,j)) then
                           write (stdoutunit,*) ' ked > kmt, at pe,m, nindx,i,j',pe, m, nindx,i,j
                           write (stdoutunit,*) ' prd_ked(nindx,m),kmto(i,j)',prd_ked(nindx,m),kmto(i,j)
                       endif
                    enddo
                 enddo
             endif !(prd_jst(nindx,m) /= 0)
          enddo


      endif   !(working_comp_domains(nindx))
   enddo      ! nindx=1,n_OFP

   call mpp_clock_end(id_OFP_init)


  end subroutine ocean_overflow_OFP_init
! </SUBROUTINE> NAME="ocean_overflow_OFP_init"
!
!
!#######################################################################
! <SUBROUTINE NAME="overflow_OFP">
!
! <DESCRIPTION>
! Compute overflow process 
!
!
! </DESCRIPTION>
!
subroutine overflow_OFP (Time, Thickness, T_prog, Dens, index_temp, index_salt)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(inout) :: Thickness
  type(ocean_prog_tracer_type),   intent(inout) :: T_prog(:)
  type(ocean_density_type),       intent(in)    :: Dens
  integer,                        intent(in)    :: index_temp
  integer,                        intent(in)    :: index_salt

  real                    :: prd_P,prd_T,prd_S
  real                    :: sum_tmp

  integer                 :: tau, taum1, taup1
  integer                 :: i, j, k, m, n, nid, ijk_check
  integer                 :: pe, root_pe
  integer                 :: stdoutunit

  character(len=256)      :: errMsg
  
  pe         = mpp_pe()
  root_pe    = mpp_root_pe()
  stdoutunit = stdout()


  if(.not. use_this_module) return 

  call mpp_clock_begin(id_OFP_main)

  if(.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_overflow_mod (overflow): module must be initialized')
  endif 

  tau     = Time%tau
  taum1   = Time%taum1
  taup1   = Time%taup1

  dzto(:,:,:)      =0.0
  rho_dzto(:,:,:)  =0.0
  depth_zto(:,:,:) =0.0
  tempo(:,:,:)     =0.0
  salto(:,:,:)     =0.0
  presso(:,:,:)    =0.0
  traceo(:,:,:,:)  =0.0

  wrk1_v(:,:,:,:) = 0.0
  do k=1,nk
     do j=jsc,jec   
        do i=isc,iec
           dzto(i,j,k)      = Thickness%dzt(i,j,k)
           depth_zto(i,j,k) = Thickness%depth_zt(i,j,k)
           rho_dzto(i,j,k)  = Thickness%rho_dzt(i,j,k,tau)
           tempo(i,j,k)     = T_prog(index_temp)%field(i,j,k,tau)
           salto(i,j,k)     = T_prog(index_salt)%field(i,j,k,tau)
           presso(i,j,k)    = Dens%pressure_at_depth(i,j,k)
           wrk1_v(i,j,k,1)  = T_prog(index_temp)%th_tendency(i,j,k)
           wrk1_v(i,j,k,2)  = T_prog(index_salt)%th_tendency(i,j,k)
        enddo
     enddo
  enddo

  do n=1,num_prog_tracers
     do k=1,nk
        do j=jsc,jec   
           do i=isc,iec
              traceo(i,j,k,n)=T_prog(n)%field(i,j,k,tau)
           enddo
        enddo
     enddo
  enddo

  call mpp_clock_begin(id_OFP_update_1)
    call mpp_update_domains (dzto(:,:,:),       OFP_domain%domain2d, complete=.false.)
    call mpp_update_domains (depth_zto(:,:,:),  OFP_domain%domain2d, complete=.false.)
    call mpp_update_domains (rho_dzto(:,:,:),   OFP_domain%domain2d, complete=.false.)
    call mpp_update_domains (tempo(:,:,:),      OFP_domain%domain2d, complete=.false.)
    call mpp_update_domains (salto(:,:,:),      OFP_domain%domain2d, complete=.false.)
    call mpp_update_domains (presso(:,:,:),     OFP_domain%domain2d, complete=.false.)
    do n=1,num_prog_tracers
      call mpp_update_domains (traceo(:,:,:,n), OFP_domain%domain2d, complete=(n==num_prog_tracers))
    enddo
  call mpp_clock_end(id_OFP_update_1)


!-----------------------------------------------------------------------
!---- initial lizing for every PEs
  src_vol_trace(:,:) = 0.0
  ent_vol_trace(:,:) = 0.0
  prd_vol_trace(:,:) = 0.0

  src_volT(:)     =0.0
  src_volS(:)     =0.0
  src_volP(:)     =0.0
  src_vol(:)      =0.0
  src_dat(:)      =0.0
  src_den(:)      =0.0
  src_flux_Mass(:)=0.0

  int_volT(:)     =0.0
  int_volS(:)     =0.0
  int_vol(:)      =0.0
  int_volP(:)     =0.0
  int_dat(:)      =0.0
  int_den(:)      =0.0

  grav_prim_src_ofp(:)     =0.0
  hs_ofp(:)                =0.0
  coriolis_source_ofp(:)   =0.0
  trans_vol_ofp_src_raw(:) =0.0
  trans_vol_ofp_src(:)     =0.0

  ent_volT(:)=0.0
  ent_volS(:)=0.0
  ent_volP(:)=0.0
  ent_vol (:)=0.0
  ent_dat (:)=0.0
  ent_den (:)=0.0

  src_den_prim(:)      =0.0 
  src_den_prim_int(:)  =0.0 
  grav_prim_ent_ofp(:) =0.0
  trans_vol_ofp_ent(:) =0.0
  trans_mass_ofp_ent(:)=0.0 
  vel_ssb_ofp(:)       =0.0
  vel_ave_ofp(:)       =0.0
  coef_b_ofp(:)        =0.0
  coef_c_ofp(:)        =0.0
  coef_d_ofp(:)        =0.0
  hssb_ofp(:)          =0.0
  Fr_geo_ofp(:)        =0.0
  mix_theta_ofp(:)     =0.0
  volf_per_tvol_src(:) =0.0
  volf_per_tvol_ent(:) =0.0
  ent_flux_Mass(:)     =0.0
  prd_line_num(:)      =0
  prd_vol(:,:)         =0.0
  prd_amb_T(:,:)       =0.0
  prd_amb_S(:,:)       =0.0
  prd_amb_P(:,:)       =0.0
  prd_dat(:,:)         =0.0
  prd_amb_rho(:,:)     =0.0
  prd_volT(:)          =0.0
  prd_volS(:)          =0.0
  prd_vol_rho(:)       =0.0
  prd_flux_Mass(:)     =0.0
  prd_inj_vol(:)       =0.0
  volf_per_tvol_prd(:) =0.0 
  trans_vol_ofp_prd(:) =0.0
  depth_prd_OFP(:)     =0.0


!-------main loop

do  nid=1,n_OFP

   if (working_src_comp_domains(nid)) then

       !-----Thickness%dzt(i,j,k):dzto is defined in tau
       do k=src_kst(nid),src_ked(nid)
          do j=src_jsc(nid),src_jec(nid)
             do i=src_isc(nid),src_iec(nid)
                src_volT(nid)=src_volT(nid)+tempo(i,j,k)*dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)
                src_volS(nid)=src_volS(nid)+salto(i,j,k)*dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)
                src_vol(nid) =src_vol(nid) + dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)
             enddo
          enddo
       enddo

       do n=1,num_prog_tracers
          sum_tmp=0.0
          do k=src_kst(nid),src_ked(nid)
             do j=src_jsc(nid),src_jec(nid)
                do i=src_isc(nid),src_iec(nid)
                   sum_tmp=sum_tmp+traceo(i,j,k,n)*dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)
                enddo
             enddo
          enddo
          src_vol_trace(nid,n)=sum_tmp
       enddo

       !---  for the pressure, regionally averaged P over the whole boxes 
       do k=src_kst(nid),src_ked(nid)
          do j=src_jsc(nid),src_jec(nid)
             do i=src_isc(nid),src_iec(nid)
                src_volP(nid) = src_volP(nid) + presso(i,j,k)*dato(i,j)*tmsko(i,j,k)
                src_dat(nid)  = src_dat(nid) + dato(i,j)*tmsko(i,j,k)
             enddo
          enddo
       enddo

   endif !(working_src_comp_domains(nid))

 
   call mpp_sum (src_volT(nid))
   call mpp_sum (src_volS(nid))
   call mpp_sum (src_volP(nid))
   call mpp_sum (src_vol (nid))
   call mpp_sum (src_dat (nid))
   call mpp_sum (src_vol_trace(nid,1:num_prog_tracers), num_prog_tracers)

   !--- truncates at 4 bytes
   src_volT(nid) = real( src_volT(nid), kind=4 )
   src_volS(nid) = real( src_volS(nid), kind=4 )
   src_volP(nid) = real( src_volP(nid), kind=4 )
   src_vol (nid) = real( src_vol (nid), kind=4 )
   src_dat (nid) = real( src_dat (nid), kind=4 )

    do n=1,num_prog_tracers
      src_vol_trace(nid,n)=real( src_vol_trace(nid,n), kind=4 )
    enddo


    if(src_vol(nid) .le. 0.0 ) then 
      call mpp_error(FATAL, &
      '==>Error from ocean_overflow_OFP_mod (overflow_OFP): source region has no sea cell')
    endif 

    src_volT(nid) = src_volT(nid)/src_vol(nid)
    src_volS(nid) = src_volS(nid)/src_vol(nid)
    src_volP(nid) = src_volP(nid)/src_dat(nid)
     
    do n=1,num_prog_tracers
      src_vol_trace(nid,n)=src_vol_trace(nid,n)/src_vol(nid)
    enddo

    !--- define averaged density at source region
    src_den(nid)=density(src_volS(nid),src_volT(nid),src_volP(nid))  

   if (debug_this_module .and. working_src_comp_domains(nid)) then 
      write(stdoutunit,*) 'nid,src_volT(nid),src_volS(nid),src_volP(nid),src_den(nid)' & 
                          ,nid,src_volT(nid),src_volS(nid),src_volP(nid),src_den(nid)
   endif

!--- define INT density
!--- thickness is still before the update, so dzt is at tau.

!  int_volT=0.0
!  int_volS=0.0
!  int_vol=0.0
!  int_volP=0.0
!  int_dat=0.0
!

   if (working_int_comp_domains(nid)) then

       do k=int_kst(nid),int_ked(nid)
          do j=int_jsc(nid),int_jec(nid)
             do i=int_isc(nid),int_iec(nid)
                int_volT(nid)=int_volT(nid)+tempo(i,j,k)*dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)
                int_volS(nid)=int_volS(nid)+salto(i,j,k)*dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)
                int_vol(nid) =int_vol(nid) + dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)
             enddo
          enddo
       enddo

       do k=int_kst(nid),int_ked(nid)
          do j=int_jsc(nid),int_jec(nid)
             do i=int_isc(nid),int_iec(nid)
                int_volP(nid) = int_volP(nid) + presso(i,j,k)*dato(i,j)*tmsko(i,j,k)
                int_dat(nid)  = int_dat(nid) + dato(i,j)*tmsko(i,j,k)
             enddo
          enddo
       enddo

   endif !(working_int_comp_domains(nid))

   call mpp_sum (int_volT(nid))
   call mpp_sum (int_volS(nid))
   call mpp_sum (int_volP(nid))
   call mpp_sum (int_vol (nid))
   call mpp_sum (int_dat (nid))

   !--- truncates at 4 bytes
   int_volT(nid) = real( int_volT(nid), kind=4 )
   int_volS(nid) = real( int_volS(nid), kind=4 )
   int_volP(nid) = real( int_volP(nid), kind=4 )
   int_vol (nid) = real( int_vol (nid), kind=4 )
   int_dat (nid) = real( int_dat (nid), kind=4 )


   if(int_vol(nid) .le. 0.0 ) then 
       call mpp_error(FATAL, &
            '==>Error from ocean_overflow_OFP_mod (overflow_OFP): interior region has no sea cell')
   endif

   int_volT(nid) = int_volT(nid)/int_vol(nid)
   int_volS(nid) = int_volS(nid)/int_vol(nid)
   int_volP(nid)=int_volP(nid)/int_dat(nid)

   int_den(nid)=density(int_volS(nid),int_volT(nid),int_volP(nid))  
   src_den_prim_int(nid)=density(src_volS(nid),src_volT(nid),int_volP(nid))

   if (debug_this_module .and. working_int_comp_domains(nid)) then 
       write(stdoutunit,*) 'nid,int_volT,int_volS,int_volP,int_den' & 
            ,nid,int_volT,int_volS,int_volP,int_den
   endif

   grav_prim_src_ofp(nid)=((src_den_prim_int(nid)-int_den(nid))/1027.0)*grav

   if (grav_prim_src_ofp(nid) .gt. 0.0) then
       occur_overflow_OFP(nid)=.true.
   else
       occur_overflow_OFP(nid)=.false.
   endif

   !------- all
   if (occur_overflow_OFP(nid)) then

       !--- still all
       hs_ofp(nid) = 2.0*hu_ofp(nid)/3.0
!
!--- Maximum geostrophic transport at the channel from the source [m^3/s]
!
      coriolis_source_ofp(nid) = 2.0*omega*sin(deg_to_rad*phi_ofp(nid) )
!
      trans_vol_ofp_src_raw(nid) = 0.5*grav_prim_src_ofp(nid)* hu_ofp(nid)**2  &
                                  / (coriolis_source_ofp(nid)+epsln)    
! 
!--- Maximum trasport
!      
      trans_vol_ofp_src(nid) = min(trans_vol_ofp_src_raw(nid), max_vol_trans_ofp)
!
!--- Maximum geostrophic velocity at the channel from the source [m/s]
!
      vel_src_ofp(nid) = trans_vol_ofp_src(nid) / (hs_ofp(nid)*ws_ofp(nid))
!
!---- Entrainment process based on Price & Baringer (1994)
!
!---- Define densities in entrainment region
!   ent_volT=0.0
!   ent_volS=0.0
!   ent_volP=0.0
!   ent_vol=0.0
!   ent_dat=0.0
!

      if (working_ent_comp_domains(nid)) then

          do k=ent_kst(nid),ent_ked(nid)
             do j=ent_jsc(nid),ent_jec(nid)
                do i=ent_isc(nid),ent_iec(nid)
                   ent_volT(nid)=ent_volT(nid)+tempo(i,j,k)*dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)
                   ent_volS(nid)=ent_volS(nid)+salto(i,j,k)*dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)
                   ent_vol(nid) =ent_vol(nid) + dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)
                enddo
             enddo
          enddo

          do n=1,num_prog_tracers
             sum_tmp=0.0
             do k=ent_kst(nid),ent_ked(nid)
                do j=ent_jsc(nid),ent_jec(nid)
                   do i=ent_isc(nid),ent_iec(nid)
                      sum_tmp=sum_tmp+traceo(i,j,k,n)*dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)
                   enddo
                enddo
             enddo
             ent_vol_trace(nid,n)=sum_tmp
          enddo

          do k=ent_kst(nid),ent_ked(nid)
             do j=ent_jsc(nid),ent_jec(nid)
                do i=ent_isc(nid),ent_iec(nid)
                   ent_volP(nid) = ent_volP(nid)+ presso(i,j,k)*dato(i,j)*tmsko(i,j,k)
                   ent_dat(nid)  = ent_dat(nid) + dato(i,j)*tmsko(i,j,k)
                enddo
             enddo
          enddo

      endif !(working_ent_comp_domains(nid))


  call mpp_sum(ent_volT(nid))
  call mpp_sum(ent_volS(nid))
  call mpp_sum(ent_volP(nid))
  call mpp_sum(ent_vol (nid))
  call mpp_sum(ent_dat (nid))
  call mpp_sum(ent_vol_trace(nid,1:num_prog_tracers), num_prog_tracers)

   !--- truncates at 4 bytes
   ent_volT(nid) = real( ent_volT(nid), kind=4 )
   ent_volS(nid) = real( ent_volS(nid), kind=4 )
   ent_volP(nid) = real( ent_volP(nid), kind=4 )
   ent_vol (nid) = real( ent_vol (nid), kind=4 )
   ent_dat (nid) = real( ent_dat (nid), kind=4 )

    do n=1,num_prog_tracers
      ent_vol_trace(nid,n)=real( ent_vol_trace(nid,n), kind=4 )
    enddo
!---

   if(ent_vol(nid) .le. 0.0 ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_overflow_OFP_mod (overflow_OFP): entrainment region has no sea cell')
   endif 

    !---  volume averaged T and S
    !---  for the pressure, regionally averaged P over the whole boxes 
    ent_volT(nid) = ent_volT(nid)/ent_vol(nid)
    ent_volS(nid) = ent_volS(nid)/ent_vol(nid)
    ent_volP(nid) = ent_volP(nid)/ent_dat(nid)
  
   do n=1,num_prog_tracers
     ent_vol_trace(nid,n)=ent_vol_trace(nid,n)/ent_vol(nid)
   enddo
!
!
!---
   ent_den(nid) = density(ent_volS(nid),ent_volT(nid),ent_volP(nid))
!
!--- define the averaged source density at the depth entrainment region
!
   src_den_prim(nid)=density(src_volS(nid),src_volT(nid),ent_volP(nid))
!  
!--- define reduce gravity
!
   grav_prim_ent_ofp(nid)=((src_den_prim(nid)-ent_den(nid))/1027.0)*grav
!
   if (debug_this_module .and. working_ent_comp_domains(nid)) then 
        write(stdoutunit,*) 'occur_overflow_OFP(nid) == .true. : nid', nid
        write(stdoutunit,*) 'hs_ofp(nid),coriolis_source_ofp(nid),trans_vol_ofp_src_raw(nid)' &
                            ,hs_ofp(nid),coriolis_source_ofp(nid),trans_vol_ofp_src_raw(nid)
        write(stdoutunit,*) 'vel_src_ofp(nid),trans_vol_ofp_src(nid)' &
                            ,vel_src_ofp(nid),trans_vol_ofp_src(nid)
        write(stdoutunit,*) 'ent_volT(nid),src_volS(nid),ent_volP(nid),ent_den(nid),grav_prim_ent_ofp(nid)' &
                            ,ent_volT(nid),src_volS(nid),ent_volP(nid),ent_den(nid),grav_prim_ent_ofp(nid)
   endif
!---- 
   if ((grav_prim_ent_ofp(nid) .le. 0.0) .or. (.not. do_entrainment_para_ofp)) then
!
       trans_vol_ofp_ent(nid)=0.0
       trans_mass_ofp_ent(nid)=0.0
       mix_theta_ofp(nid)=0.0
!
   else  !(grav_prim_ent_ofp(nid) .le. 0.0) : entranment process start
!
!---- compute flow speed at the shelf-slop break [m/s]
!
       vel_ssb_ofp(nid)=grav_prim_ent_ofp(nid)*alpha_ofp(nid)/(coriolis_source_ofp(nid)+epsln)
!
!--- checked for instability
!
      vel_ssb_ofp(nid) = min(max_ofp_speed, vel_ssb_ofp(nid))
!
!---- compute flow speed during spreading
!
      vel_ave_ofp(nid)=0.5*(vel_src_ofp(nid)+vel_ssb_ofp(nid))
!
!--- compute overflow thickness at the shelf/slope break
!
      coef_c_ofp(nid) = -(vel_src_ofp(nid)/vel_ssb_ofp(nid))*hs_ofp(nid)*hs_ofp(nid)
!
      coef_b_ofp(nid) = (1.0-vel_src_ofp(nid)/vel_ssb_ofp(nid))*hs_ofp(nid)  &
              +4.0*(cdbot_ofp(nid)*vel_ave_ofp(nid)*xssb_ofp(nid))  &
                  /(coriolis_source_ofp(nid)*ws_ofp(nid))
!
      coef_d_ofp(nid) = coef_b_ofp(nid)**2 - 4.0*coef_c_ofp(nid)
!
!----  chech coef_d_ofp>=0
    if(coef_d_ofp(nid) < 0.0 ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_overflow_OFP_mod (overflow_OFP): coef_d_ofp is less than 0.0')
    endif 
!----
!
    hssb_ofp(nid) = 0.5*(-coef_b_ofp(nid)+sqrt(coef_d_ofp(nid)))
!

!--- compute geostrophic Froude number
!--- check grav_prim_ent_ofp*hssb_ofp>=0
    if(hssb_ofp(nid) < 0.0 ) then 
      call mpp_error(FATAL, &
      '==>Error from ocean_overflow_OFP_mod (overflow_OFP): hssb_ofp is less than 0.0')
    endif 
!----
!
      Fr_geo_ofp(nid)=vel_ssb_ofp(nid)/sqrt(grav_prim_ent_ofp(nid)*hssb_ofp(nid))
!     
!---- occurrence of mixing 
!---- compute entrainment mixing paramenter
!
     if (Fr_geo_ofp(nid) .ge. crit_Fr_geo_ofp) then     ! mixing occur
         mix_theta_ofp(nid)=1.0-1.0/Fr_geo_ofp(nid)**(2./3.)
     else ! (Fr_geo_ofp .ge. crit_Fr_geo_ofp)      ! no mixing
         mix_theta_ofp(nid)=0.0
     endif !(Fr_geo_ofp .ge. crit_Fr_geo_ofp)
!
!---- compute entrainment transport  [m^3/s], [kg/m^3 m^3/s]
!
           trans_vol_ofp_ent(nid)=trans_vol_ofp_src(nid)*mix_theta_ofp(nid)/(1.0-mix_theta_ofp(nid))
!
!---
     if (debug_this_module) then 
       write(stdoutunit,*) 'entranment process start'
       write(stdoutunit,*) 'vel_ave_ofp(nid),coef_c_ofp(nid),coef_b_ofp(nid),coef_d_ofp(nid),hssb_ofp(nid)' &
                           ,vel_ave_ofp(nid),coef_c_ofp(nid),coef_b_ofp(nid),coef_d_ofp(nid),hssb_ofp(nid)
       write(stdoutunit,*) 'Fr_geo_ofp(nid),mix_theta_ofp(nid),trans_vol_ofp_ent(nid)' &
                           ,Fr_geo_ofp(nid),mix_theta_ofp(nid),trans_vol_ofp_ent(nid)
     endif
!---
!
   endif !(grav_prim_ent_ofp .le. 0.0) : entrainment process
!
!---- compute product transport [m^3/s]
!
   trans_vol_ofp_prd(nid)  = trans_vol_ofp_src(nid)  + trans_vol_ofp_ent(nid)

!                   
!--- compute product Temperature and Salinity [degree C], [psu]
!--- with constraint of the volume conservation
!
   prd_volT(nid)=src_volT(nid)*(1.0-mix_theta_ofp(nid))+ent_volT(nid)*mix_theta_ofp(nid)
   prd_volS(nid)=src_volS(nid)*(1.0-mix_theta_ofp(nid))+ent_volS(nid)*mix_theta_ofp(nid)
!
   do n=1,num_prog_tracers
       prd_vol_trace(nid,n) = src_vol_trace(nid,n)*(1.0-mix_theta_ofp(nid))  &
                            + ent_vol_trace(nid,n)*mix_theta_ofp(nid)
   enddo

!           
!-- Volume fluxes [m^3/s] of source and entrainment and product region, are known.
!-- From these fluxes, mass and tracer fluxes are calculated, which should be conserved.
    if (debug_this_module) then 
      write(stdoutunit,*) 'trans_vol_ofp_prd(nid),prd_volT(nid),prd_volS(nid)' &
                          ,trans_vol_ofp_prd(nid),prd_volT(nid),prd_volS(nid)
      write(stdoutunit,*) 'trans_vol_ofp_prd(nid),prd_volT(nid),prd_volS(nid)' &
                          ,trans_vol_ofp_prd(nid),prd_volT(nid),prd_volS(nid)
      write(stdoutunit,*) 'src_volT(nid),ent_volT(nid),mix_theta_ofp(nid),src_volS(nid),ent_volS(nid)' &
                          ,src_volT(nid),ent_volT(nid),mix_theta_ofp(nid),src_volS(nid),ent_volS(nid)
    endif
!
!--- at the source region, volume flux [m^3/s] / total volume [m^3]
!
   volf_per_tvol_src(nid)=trans_vol_ofp_src(nid) / src_vol(nid)  ![1/s]
!   
!   src_flux_Mass(nid) = 0.0  
!
     if (working_src_comp_domains(nid)) then   
!--- total mass flux from the source region  
   do k=src_kst(nid),src_ked(nid)
    do j=src_jsc(nid),src_jec(nid)
     do i=src_isc(nid),src_iec(nid)
       src_flux_Mass(nid)=src_flux_Mass(nid)     &
                         +volf_per_tvol_src(nid)*rho_dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)  ![kg/m^3 m^3/s]
     enddo
    enddo
   enddo
!
     endif !(working_src_comp_domains(nid))

!--- mpp_sum

     call mpp_sum ( src_flux_Mass(nid) )  

!--- truncates at 4 bytes

      src_flux_Mass(nid) = real ( src_flux_Mass(nid), kind=4 )

 if ( working_src_comp_domains(nid) ) then
   if (do_mass_ofp) then

!--- uniformly decrease mass over the source region [-volf_per_tvol_src*vol(i,j,k)/dat(i,j)]
     do k=src_kst(nid),src_ked(nid)
      do j=src_jsc(nid),src_jec(nid)
       do i=src_isc(nid),src_iec(nid)
           Thickness%mass_source(i,j,k) = Thickness%mass_source(i,j,k)  &
                                         -volf_per_tvol_src(nid)*rho_dzto(i,j,k)*tmsko(i,j,k)     ! [kg/m^3 m/s]
       enddo
      enddo
     enddo
!---
    if (debug_this_module .and. working_src_comp_domains(nid)) then 
      write(stdoutunit,*) 'volf_per_tvol_src(nid),src_flux_Mass(nid)',volf_per_tvol_src(nid),src_flux_Mass(nid)
    endif
!---
!
!--- total trace flux from the source region  
!--- in two level time step, taum1=tau
    do n=1,num_prog_tracers
     do k=src_kst(nid),src_ked(nid)
      do j=src_jsc(nid),src_jec(nid)
       do i=src_isc(nid),src_iec(nid)
            src_flux_trace(nid,n)= src_flux_trace(nid,n)  &
                               +T_prog(n)%field(i,j,k,taum1)  &
                               *volf_per_tvol_src(nid)*rho_dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)   ![trace kg/m^3 m^3/s]
!
            T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k)  &
                                          -T_prog(n)%field(i,j,k,taum1)  &
                                          *volf_per_tvol_src(nid)*rho_dzto(i,j,k)*tmsko(i,j,k)  ![trace kg/m^3 m/s]
!
        enddo
       enddo
      enddo
     enddo !n=1,num_prog_tracers
!
!
   endif !(do_mass_ofp)
 endif ! ( working_src_comp_domains(nid) )
!----
!--- at the entrainment region, volume flux [m^3/s] / total volume [m^3]
!
   volf_per_tvol_ent(nid)=trans_vol_ofp_ent(nid) / ent_vol(nid)  ![1/s]
!   
!   ent_flux_Mass(nid) = 0.0  
!
   if ( working_ent_comp_domains(nid) ) then
!----- total mass flux from the entrainment region  
  do k=ent_kst(nid),ent_ked(nid)
   do j=ent_jsc(nid),ent_jec(nid)
    do i=ent_isc(nid),ent_iec(nid)
          ent_flux_Mass(nid)=ent_flux_Mass(nid)     &
                            + volf_per_tvol_ent(nid)*rho_dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)  ![kg/m^3 m^3/s]
    enddo
   enddo
  enddo
!
   endif !( working_ent_comp_domains(nid) )

!--- mpp_sum
     
     call mpp_sum (ent_flux_Mass(nid)) 

!--- truncates at 4 bytes

     ent_flux_Mass(nid) = real( ent_flux_Mass(nid), kind=4 )

 if ( working_ent_comp_domains(nid) ) then
   if (do_mass_ofp) then
!
!--- uniformly decrease mass over the entrainment region 
    do k=ent_kst(nid),ent_ked(nid)
     do j=ent_jsc(nid),ent_jec(nid)
      do i=ent_isc(nid),ent_iec(nid)
         Thickness%mass_source(i,j,k) = Thickness%mass_source(i,j,k)  &
                                       -volf_per_tvol_ent(nid)*rho_dzto(i,j,k)*tmsko(i,j,k)     ! [kg/m^3 m/s]
      enddo
     enddo
    enddo
!
   if (debug_this_module) then 
      write(stdoutunit,*) 'volf_per_tvol_ent(nid),src_flux_Mass(nid)',volf_per_tvol_ent(nid),src_flux_Mass(nid)
   endif
!
!--- total trace flux from the entrainment region  
    do n=1,num_prog_tracers
     do k=ent_kst(nid),ent_ked(nid)
      do j=ent_jsc(nid),ent_jec(nid)
       do i=ent_isc(nid),ent_iec(nid)
         ent_flux_trace(nid,n)= ent_flux_trace(nid,n) &
                           +T_prog(n)%field(i,j,k,taum1)*volf_per_tvol_ent(nid) &
                         *rho_dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)                          ![trace kg/m^3 m^3/s]
!
          T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) &
                                        -T_prog(n)%field(i,j,k,taum1) &
                                        *volf_per_tvol_ent(nid)*rho_dzto(i,j,k)*tmsko(i,j,k)   ![trace kg/m^3 m/s]
!
       enddo
      enddo
     enddo
    enddo !n=1,num_prog_tracers
!----
   endif !(do_mass_ofp)
 endif !( working_ent_comp_domains(nid) )
!
!
!--- At the product region,
!--- to check the regionally averaged density between ambient density of product lines
!--- and the product water density,
!--- and to decide the injection depth and the product line. 
!
     do m=1,10
       ijk_check=prd_kst(nid,m)*prd_ked(nid,m)*prd_jst(nid,m)*prd_jed(nid,m) &
                *prd_ist(nid,m)*prd_ied(nid,m)
       if (ijk_check /=0) prd_line_num(nid)=m
     enddo

!
!--- Calculate ambient averaged density at each line
!--- prd_ked can be kmt, that is, partial cell. So prd_kst (prd_ked-1) is considered.
         
   do m=1,prd_line_num(nid)

       if (working_prd_comp_domains(nid,m)) then

    do k=prd_kst(nid,m),prd_ked(nid,m)
     do j=prd_jsc(nid,m),prd_jec(nid,m)
      do i=prd_isc(nid,m),prd_iec(nid,m)
         prd_vol(nid,m)  = prd_vol(nid,m)    &
                          +dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)
         prd_amb_T(nid,m)= prd_amb_T(nid,m)  &
                          +tempo(i,j,k)*dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)
         prd_amb_S(nid,m)= prd_amb_S(nid,m)  &
                          +salto(i,j,k)*dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)

   if (debug_this_module) then 
      write(stdoutunit,*) 'CP-030411 : m,i,j,k,tempo(i,j,k),salto(i,j,k)',m,i,j,k,tempo(i,j,k),salto(i,j,k)
   endif

     enddo
    enddo
   enddo
!
   do k=prd_kst(nid,m),prd_ked(nid,m)
    do j=prd_jsc(nid,m),prd_jec(nid,m)
     do i=prd_isc(nid,m),prd_iec(nid,m)
       prd_amb_P(nid,m) = prd_amb_P(nid,m) + presso(i,j,k)*dato(i,j)*tmsko(i,j,k)
       prd_dat(nid,m)   = prd_dat(nid,m) + dato(i,j)*tmsko(i,j,k)

       if (debug_this_module) then 
        write(stdoutunit,*) 'PT4.2: m,prd_kst(nid,m), Dens%pressure_at_depth(i,j,prd_kst(nid,m)),Grd%dat(i,j)' &
                            ,m,prd_kst(nid,m), Dens%pressure_at_depth(i,j,prd_kst(nid,m)),Grd%dat(i,j)
       endif

     enddo
    enddo
   enddo

      endif !(working_prd_comp_domains(nid,m))

!--- mpp_sum

     call mpp_sum (prd_amb_T(nid,m))
     call mpp_sum (prd_amb_S(nid,m))
     call mpp_sum (prd_amb_P(nid,m))
     call mpp_sum (prd_dat(nid,m))
     call mpp_sum (prd_vol(nid,m))

!--- truncates at 4 bytes
   prd_amb_T(nid,m) = real( prd_amb_T(nid,m), kind=4 )
   prd_amb_S(nid,m) = real( prd_amb_S(nid,m), kind=4 )
   prd_amb_P(nid,m) = real( prd_amb_P(nid,m), kind=4 )
   prd_vol(nid,m) = real( prd_vol(nid,m), kind=4 )
   prd_dat(nid,m) = real( prd_dat(nid,m), kind=4 )

!
  if(prd_vol(nid,m) .le. 0.0 ) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_overflow_OFP_mod (overflow_OFP): interior region has no sea cell')
  endif 
! 
   prd_amb_T(nid,m)= prd_amb_T(nid,m)/(epsln+prd_vol(nid,m))
   prd_amb_S(nid,m)= prd_amb_S(nid,m)/(epsln+prd_vol(nid,m))
   prd_amb_P(nid,m)= prd_amb_P(nid,m)/(epsln+prd_dat(nid,m))
!
   if (debug_this_module) then 
      write(stdoutunit,*) 'CP-072810 : m,prd_amb_T(nid,m),prd_amb_S(nid,m)',m,prd_amb_T(nid,m),prd_amb_S(nid,m)
   endif
! 
!!--- define ambient averaged density at product region
!
    prd_S=prd_amb_S(nid,m)
    prd_T=prd_amb_T(nid,m)
    prd_P=prd_amb_P(nid,m)
    prd_amb_rho(nid,m)=density(prd_S,prd_T,prd_P)  
!
    if (debug_this_module) then 
       write(stdoutunit,*) ' m, prd_amb_T(nid,m), prd_amb_S(nid,m),prd_amb_P(nid,m),prd_amb_rho(nid,m)' &
                           , m, prd_amb_T(nid,m), prd_amb_S(nid,m),prd_amb_P(nid,m),prd_amb_rho(nid,m)
    endif
!
  enddo !m=1,prd_line_num
!
!
!!--- define the injection line from the check of the density
!!--- it is assumed that the depth at m=1 is the shallowest line
!
   prd_inject_line_num(nid)=1
!
   do m=1,prd_line_num(nid)-1
      prd_vol_rho(nid) = density(prd_volS(nid), prd_volT(nid),prd_amb_P(nid,m)) 
      if ( prd_vol_rho(nid) > prd_amb_rho(nid,m) ) then
         prd_inject_line_num(nid) = m+1  
      endif    
   enddo !m=1,prd_line_num
!
   if (debug_this_module) then 
      write(stdoutunit,*) 'CP-072810: prd_inject_line_num(nid)',prd_inject_line_num(nid)
   endif
!
   if (debug_this_module) then 
      write(stdoutunit,*) 'CP-072810: trans_vol_ofp_prd(nid)',trans_vol_ofp_prd(nid)
   endif
!
!--- total mass flux of prd from src and ent
!
   prd_flux_Mass(nid)=src_flux_Mass(nid)+ent_flux_Mass(nid)                             ![kg/m^3 m^3/s]
!
!--- total trace flux of prd from src and ent
!
   do n=1,num_prog_tracers
      prd_flux_trace(nid,n)= src_flux_trace(nid,n)+ent_flux_trace(nid,n)              ![trace kg/m^3 m^3/s]
   enddo !n=1,num_prog_tracers
!
!   prd_inj_vol(nid)=0.0

      if ( working_prd_comp_domains(nid,prd_inject_line_num(nid)) ) then

   do k=prd_kst(nid,prd_inject_line_num(nid)),prd_ked(nid,prd_inject_line_num(nid))
    do j=prd_jsc(nid,prd_inject_line_num(nid)),prd_jec(nid,prd_inject_line_num(nid))
     do i=prd_isc(nid,prd_inject_line_num(nid)),prd_iec(nid,prd_inject_line_num(nid))
        prd_inj_vol(nid) = prd_inj_vol(nid) + dzto(i,j,k)*dato(i,j)*tmsko(i,j,k)                   ! [m^3]
     enddo
    enddo
   enddo
 
      depth_prd_OFP(nid)=Thickness%depth_zt(prd_isc(nid,prd_inject_line_num(nid)) &
                                           ,prd_jsc(nid,prd_inject_line_num(nid)) &
                                           ,prd_kst(nid,prd_inject_line_num(nid)))
      endif !( working_prd_comp_domains(nid,prd_inject_line_num(nid)) )
!--- mpp_sum

     call mpp_sum ( prd_inj_vol(nid) )      
     call mpp_max ( depth_prd_OFP(nid) )      

!--- truncates at 4 bytes

     prd_inj_vol(nid) = real( prd_inj_vol(nid), kind=4 )
     
!---
  if(prd_inj_vol(nid) .le. 0.0 ) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_overflow_OFP_mod (overflow_OFP): prd_inj_vol(nid) .le. 0.0')
  endif 

!
!!--- volume flux [m^3/s] / total volume [m^3]
!
     volf_per_tvol_prd(nid) = trans_vol_ofp_prd(nid) / prd_inj_vol(nid)      ! [1/s]
!
!
!--- uniformly increase mass (volume weighted) over the product injection region
!--- defined as (prd_flux_Mass / prd_inj_vol)*vol(i,j,k)/dat(i,j)
!
  if ( working_prd_comp_domains(nid,prd_inject_line_num(nid)) ) then
    if (do_mass_ofp) then
!
      do k=prd_kst(nid,prd_inject_line_num(nid)),prd_ked(nid,prd_inject_line_num(nid))
       do j=prd_jsc(nid,prd_inject_line_num(nid)),prd_jec(nid,prd_inject_line_num(nid))
        do i=prd_isc(nid,prd_inject_line_num(nid)),prd_iec(nid,prd_inject_line_num(nid))
           Thickness%mass_source(i,j,k) = Thickness%mass_source(i,j,k)  &
                                         +(prd_flux_Mass(nid)/prd_inj_vol(nid)) *dzto(i,j,k)*tmsko(i,j,k) ! [kg/m^3 m/s]
        enddo
       enddo
      enddo
!---------------------------------     
     if (prd_vol_trace(nid,index_temp) /=  prd_volT(nid) ) then 
       write (errMsg, FMT='("==>Error from ocean_overflow_mod (ocean_overflow): prd_vol_trace(nid,index_temp) = ",&
            &F20.10," is not same as prd_volT(nid) = ",F20.10)') prd_vol_trace(nid,index_temp), prd_volT(nid)
       call mpp_error(FATAL, trim(errMsg))
     endif 
     if (prd_vol_trace(nid,index_salt) /=  prd_volS(nid) ) then 
       write (errMsg, FMT='("==>Error from ocean_overflow_mod (ocean_overflow): prd_vol_trace(nid,index_salt) = ",&
            &F20.10," is not same as prd_volS(nid) = ",F20.10)') prd_vol_trace(nid,index_salt), prd_volS(nid)
       call mpp_error(FATAL, trim(errMsg))
     endif 
!----------------------------
     do n=1,num_prog_tracers
      do k=prd_kst(nid,prd_inject_line_num(nid)),prd_ked(nid,prd_inject_line_num(nid))
       do j=prd_jsc(nid,prd_inject_line_num(nid)),prd_jec(nid,prd_inject_line_num(nid))
        do i=prd_isc(nid,prd_inject_line_num(nid)),prd_iec(nid,prd_inject_line_num(nid))
           T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) &
                                         +prd_vol_trace(nid,n)*(prd_flux_Mass(nid)  &
                                         /prd_inj_vol(nid)) * dzto(i,j,k) *tmsko(i,j,k)                ![trace kg/m^3 m/s]
        enddo
       enddo
      enddo
     enddo

!

    else !(do_mass_ofp)
!
     do n=1,num_prog_tracers
      do k=prd_kst(nid,prd_inject_line_num(nid)),prd_ked(nid,prd_inject_line_num(nid))
       do j=prd_jsc(nid,prd_inject_line_num(nid)),prd_jec(nid,prd_inject_line_num(nid))
        do i=prd_isc(nid,prd_inject_line_num(nid)),prd_iec(nid,prd_inject_line_num(nid))
           T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) &
                                         +(prd_vol_trace(nid,n)-T_prog(n)%field(i,j,k,tau))  &
                                         *(prd_flux_Mass(nid)/prd_inj_vol(nid)) *dzto(i,j,k)*tmsko(i,j,k) ![trace kg/m^3 m/s]
        enddo
       enddo
      enddo
     enddo 

    endif !(do_mass_ofp)
  endif !( working_prd_comp_domains(nid,prd_inject_line_num) )

!---
!
      if (debug_this_module) then 
         write(stdoutunit,*) '999: pe, nid, src_volT(nid),src_volS(nid),trans_vol_ofp_src(nid)' &
                         ,pe, nid, src_volT(nid),src_volS(nid),trans_vol_ofp_src(nid)
      if (working_comp_domains_all) then 
        write(stdoutunit,'(2i5,12e15.7)') nid, pe, src_volT(nid),src_volS(nid),trans_vol_ofp_src(nid) &
                     , int_volT(nid),int_volS(nid)                        &
                     , ent_volT(nid),ent_volS(nid),trans_vol_ofp_ent(nid) &
                     , prd_volT(nid),prd_volS(nid),trans_vol_ofp_prd(nid) &
                     , depth_prd_OFP(nid)
      endif
      endif
!------------------------- diagnostics
!--- Averaged temperature, salinity, transport and depth of of each region are save 
!--- as the ascii data. In standard script, the output file(.out) is saved
!--- in the directory of the ascii.
!--- Number in the file name (e.g. *01.out, *02.out ...) means the number of the OFP set
!--- (e.g. 01: Denmark Strait, 02: Faroe Bank Channel ...).
!--- diag_step is defined at the name list
!
     if (diag_step > 0 .and. pe==root_pe) then 
      if(mod(Time%itt,diag_step) == 0) then
        write(stdoutunit,'(24x,a)') "Ocean Overflow Parametrization (OFP) summary:"
        write(stdoutunit,'(2i5,12e15.7)') nid, pe, src_volT(nid),src_volS(nid),trans_vol_ofp_src(nid) &
                   , int_volT(nid),int_volS(nid)                        &
                   , ent_volT(nid),ent_volS(nid),trans_vol_ofp_ent(nid) &
                   , prd_volT(nid),prd_volS(nid),trans_vol_ofp_prd(nid) &
                   , depth_prd_OFP(nid)
      endif  
     endif
!---
!
 endif !(working_comp_domains(nid))  
!-------------------------------------------
       if (debug_this_module) then 
         write(stdoutunit,*) '999: pe, nid, src_volT(nid),src_volS(nid),trans_vol_ofp_src(nid)' &
                             ,pe, nid, src_volT(nid),src_volS(nid),trans_vol_ofp_src(nid)
       endif
!------------------------------------------------
enddo ! nid=1,n_OFP
!------------------------------------------------
        call mpp_clock_begin(id_OFP_update_2)       
    do n = 1, num_prog_tracers
       call mpp_update_domains(T_prog(n)%th_tendency, Dom%domain2d, complete=(n==num_prog_tracers))
    enddo
    
        call mpp_clock_end(id_OFP_update_2)  
     
        call mpp_clock_begin(id_OFP_update_3)
        
        call mpp_update_domains(Thickness%mass_source, Dom%domain2d)
        
        call mpp_clock_end(id_OFP_update_3)

        call watermass_diag(Time, Dens, T_prog, index_temp, index_salt, wrk1_v)                

        call mpp_clock_end(id_OFP_main)
        
!-------------------------------------------------
 if(id_OFP_n1_src_temp > 0)  used = send_data(id_OFP_n1_src_temp,src_volT(1),Time%model_time)        
 if(id_OFP_n1_src_salt > 0)  used = send_data(id_OFP_n1_src_salt,src_volS(1),Time%model_time)         
 if(id_OFP_n1_src_trans > 0) used = send_data(id_OFP_n1_src_trans,trans_vol_ofp_src(1),Time%model_time)         
 if(id_OFP_n1_int_temp > 0)  used = send_data(id_OFP_n1_int_temp,int_volT(1),Time%model_time)         
 if(id_OFP_n1_int_salt > 0)  used = send_data(id_OFP_n1_int_salt,int_volS(1),Time%model_time)         
 if(id_OFP_n1_ent_temp > 0)  used = send_data(id_OFP_n1_ent_temp,ent_volT(1),Time%model_time)         
 if(id_OFP_n1_ent_salt > 0)  used = send_data(id_OFP_n1_ent_salt,ent_volS(1),Time%model_time)         
 if(id_OFP_n1_ent_trans > 0) used = send_data(id_OFP_n1_ent_trans,trans_vol_ofp_ent(1),Time%model_time)         
 if(id_OFP_n1_prd_temp > 0)  used = send_data(id_OFP_n1_prd_temp,prd_volT(1),Time%model_time)         
 if(id_OFP_n1_prd_salt > 0)  used = send_data(id_OFP_n1_prd_salt,prd_volS(1),Time%model_time)         
 if(id_OFP_n1_prd_trans > 0) used = send_data(id_OFP_n1_prd_trans,trans_vol_ofp_prd(1),Time%model_time)         
 if(id_OFP_n1_prd_depth > 0) used = send_data(id_OFP_n1_prd_depth,depth_prd_OFP(1),Time%model_time) 
        
 if(id_OFP_n2_src_temp > 0)  used = send_data(id_OFP_n2_src_temp,src_volT(2),Time%model_time)         
 if(id_OFP_n2_src_salt > 0)  used = send_data(id_OFP_n2_src_salt,src_volS(2),Time%model_time)         
 if(id_OFP_n2_src_trans > 0) used = send_data(id_OFP_n2_src_trans,trans_vol_ofp_src(2),Time%model_time)         
 if(id_OFP_n2_int_temp > 0)  used = send_data(id_OFP_n2_int_temp,int_volT(2),Time%model_time)         
 if(id_OFP_n2_int_salt > 0)  used = send_data(id_OFP_n2_int_salt,int_volS(2),Time%model_time)         
 if(id_OFP_n2_ent_temp > 0)  used = send_data(id_OFP_n2_ent_temp,ent_volT(2),Time%model_time)         
 if(id_OFP_n2_ent_salt > 0)  used = send_data(id_OFP_n2_ent_salt,ent_volS(2),Time%model_time)         
 if(id_OFP_n2_ent_trans > 0) used = send_data(id_OFP_n2_ent_trans,trans_vol_ofp_ent(2),Time%model_time)         
 if(id_OFP_n2_prd_temp > 0)  used = send_data(id_OFP_n2_prd_temp,prd_volT(2),Time%model_time)         
 if(id_OFP_n2_prd_salt > 0)  used = send_data(id_OFP_n2_prd_salt,prd_volS(2),Time%model_time)         
 if(id_OFP_n2_prd_trans > 0) used = send_data(id_OFP_n2_prd_trans,trans_vol_ofp_prd(2),Time%model_time)         
 if(id_OFP_n2_prd_depth > 0) used = send_data(id_OFP_n2_prd_depth,depth_prd_OFP(2),Time%model_time) 
!-------------------------------------------------
           
end subroutine overflow_OFP
! </SUBROUTINE> NAME="overflow_OFP"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag_init">
!
! <DESCRIPTION>
! Initialization of watermass diagnostic output files. 
! </DESCRIPTION>
!
subroutine watermass_diag_init(Time, Dens)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens

  integer :: stdoutunit
  stdoutunit=stdout()
  compute_watermass_diag = .false. 

  
  id_neut_rho_overofp = register_diag_field ('ocean_model', 'neut_rho_overofp',&
       Grd%tracer_axes(1:3), Time%model_time,                                  &
       'update of locally referenced potrho from overflow_ofp scheme',         &
       '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_overofp > 0) compute_watermass_diag = .true. 

  id_neut_rho_overofp_on_nrho = register_diag_field ('ocean_model',                     &
   'neut_rho_overofp_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,               &
       'update of locally ref potrho from overflow_ofp as binned to neutral rho layers',&
       '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_overofp_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_rho_overofp = register_diag_field ('ocean_model',  &
   'wdian_rho_overofp', Grd%tracer_axes(1:3), Time%model_time,&
       'dianeutral mass transport due to overflow_ofp',       &
       'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_overofp > 0) compute_watermass_diag = .true. 

  id_wdian_rho_overofp_on_nrho = register_diag_field ('ocean_model',                   &
   'wdian_rho_overofp_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,            &
       'dianeutral mass transport due to overflow_ofp as binned to neutral rho layers',&
       'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_overofp_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_rho_overofp_on_nrho = register_diag_field ('ocean_model',             &
   'tform_rho_overofp_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,      &
       'watermass transform due to overflow_ofp as binned to neutral rho layers',&
       'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_overofp_on_nrho > 0) compute_watermass_diag = .true. 


  ! temperature effects  
  id_neut_temp_overofp = register_diag_field ('ocean_model', 'neut_temp_overofp',&
   Grd%tracer_axes(1:3), Time%model_time,                                        &
   'temp related update of locally referenced potrho from overflow_ofp scheme',  &
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_overofp > 0) compute_watermass_diag = .true. 

  id_neut_temp_overofp_on_nrho = register_diag_field ('ocean_model',                          &
   'neut_temp_overofp_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,                    &
   'temp related update of locally ref potrho from overflow_ofp binned to neutral rho layers',&
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_overofp_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_temp_overofp = register_diag_field ('ocean_model',   &
   'wdian_temp_overofp', Grd%tracer_axes(1:3), Time%model_time, &
   'temp related dianeutral mass transport due to overflow_ofp',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_overofp > 0) compute_watermass_diag = .true. 

  id_wdian_temp_overofp_on_nrho = register_diag_field ('ocean_model',                        &
   'wdian_temp_overofp_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                 &
   'temp related dianeutral mass transport due to overflow_ofp binned to neutral rho layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_overofp_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_temp_overofp_on_nrho = register_diag_field ('ocean_model',                     &
   'tform_temp_overofp_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,              &
   'temp related watermass transform due to overflow_ofp as binned to neutral rho layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_overofp_on_nrho > 0) compute_watermass_diag = .true. 


  ! salinity effects  
  id_neut_salt_overofp = register_diag_field ('ocean_model', 'neut_salt_overofp',&
   Grd%tracer_axes(1:3), Time%model_time,                                        &
   'salt related update of locally referenced potrho from overflow_ofp scheme',  &
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_overofp > 0) compute_watermass_diag = .true. 

  id_neut_salt_overofp_on_nrho = register_diag_field ('ocean_model',                          &
   'neut_salt_overofp_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,                    &
   'salt related update of locally ref potrho from overflow_ofp binned to neutral rho layers',&
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_overofp_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_salt_overofp = register_diag_field ('ocean_model',   &
   'wdian_salt_overofp', Grd%tracer_axes(1:3), Time%model_time, &
   'salt related dianeutral mass transport due to overflow_ofp',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_overofp > 0) compute_watermass_diag = .true. 

  id_wdian_salt_overofp_on_nrho = register_diag_field ('ocean_model',                        &
   'wdian_salt_overofp_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                 &
   'salt related dianeutral mass transport due to overflow_ofp binned to neutral rho layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_overofp_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_salt_overofp_on_nrho = register_diag_field ('ocean_model',                     &
   'tform_salt_overofp_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,              &
   'salt related watermass transform due to overflow_ofp as binned to neutral rho layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_overofp_on_nrho > 0) compute_watermass_diag = .true. 


  if(compute_watermass_diag) then 
    write(stdoutunit,'(/a/)') &
    '==>Note: running ocean_overflow_OFP_mod w/ compute_watermass_diag=.true.'  
  endif 


end subroutine watermass_diag_init
! </SUBROUTINE> NAME="watermass_diag_init"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag">
!
! <DESCRIPTION>
! Diagnose effects from overflow on the watermass transformation.
! </DESCRIPTION>
!
subroutine watermass_diag(Time, Dens, T_prog, index_temp, index_salt, wrk1v)

  type(ocean_time_type),           intent(in)    :: Time
  type(ocean_density_type),        intent(in)    :: Dens
  type(ocean_prog_tracer_type),    intent(in)    :: T_prog(:)
  integer,                         intent(in)    :: index_temp
  integer,                         intent(in)    :: index_salt
  real, dimension(isd:,jsd:,:,:), intent(in) :: wrk1v

  integer :: i,j,k
  real    :: tmp1, tmp2

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_overflow (watermass_diag): module needs initialization ')
  endif 

  if (.not. compute_watermass_diag) return


  ! full effects on rho 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           tmp1 = T_prog(index_temp)%th_tendency(i,j,k) - wrk1v(i,j,k,1)
           tmp2 = T_prog(index_salt)%th_tendency(i,j,k) - wrk1v(i,j,k,2)
           wrk1(i,j,k) = Grd%tmask(i,j,k)*(Dens%drhodT(i,j,k)*tmp1 + Dens%drhodS(i,j,k)*tmp2)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)  
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_overofp,wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_overofp, wrk3(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_overofp_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_overofp_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_overofp_on_nrho, wrk4)

  ! temperature effects on rho 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec

           tmp1        = T_prog(index_temp)%th_tendency(i,j,k) - wrk1v(i,j,k,1)
           wrk1(i,j,k) = Grd%tmask(i,j,k)*Dens%drhodT(i,j,k)*tmp1
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)  
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_overofp,wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_overofp, wrk3(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_overofp_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_overofp_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_overofp_on_nrho, wrk4)

  ! salinity effects on rho 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           tmp2        = T_prog(index_salt)%th_tendency(i,j,k) - wrk1v(i,j,k,2)
           wrk1(i,j,k) = Grd%tmask(i,j,k)*Dens%drhodT(i,j,k)*tmp2
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)  
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_overofp,wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_overofp, wrk3(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_overofp_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_overofp_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_overofp_on_nrho, wrk4)

end subroutine watermass_diag
! </SUBROUTINE>  NAME="watermass_diag"


end module ocean_overflow_OFP_mod
!!

!FDOC_TAG_GFDL
 
                 module standalone_clouds_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
! fil   
! </CONTACT>
! <REVIEWER EMAIL="">
!   
! </REVIEWER>
! <OVERVIEW>
!   
! </OVERVIEW>
! <DESCRIPTION>
!   
! </DESCRIPTION>
!

use mpp_mod,                    only: input_nml_file
use fms_mod,                    only: fms_init, open_namelist_file, &
                                      write_version_number, mpp_pe, &
                                      mpp_root_pe, stdlog,   &
                                      file_exist, check_nml_error,   &
                                      error_mesg, FATAL, close_file
use rad_utilities_mod,          only: rad_utilities_init, &
                                      Cldrad_control, &
                                      cld_specification_type, &
                                      cldrad_properties_type,  &
                                      microphysics_type,  &
                                      microrad_properties_type, &
                                      Sw_control

!--------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!   standalone cloud radiative properties module
!
!--------------------------------------------------------------------



!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------

  character(len=128)  :: version =  '$Id: standalone_clouds.F90,v 19.0 2012/01/06 20:24:41 fms Exp $'
  character(len=128)  :: tagname =  '$Name: tikal $'



!---------------------------------------------------------------------
!-------  interfaces --------

public          &
          standalone_clouds_init,                           &
          standalone_clouds_end,                           &
          define_column_properties, &
      standalone_clouds_amt, obtain_micro_lw_sa, obtain_micro_sw_sa,  &
       obtain_bulk_lw_sa, obtain_bulk_sw_sa

!---------------------------------------------------------------------
!-------- namelist  ---------

character(len=16) :: cldht_type_form='   '
character(len=16) :: cloud_data_form='   '
character(len=16) :: cloud_overlap_form='   '
character(len=16) :: lhsw_cld_prop_form='   '
character(len=16) :: lw_cld_prop_form='   '
integer           :: cloud_data_points = 0

namelist /standalone_clouds_nml /     &
                          cldht_type_form, cloud_data_form, &
                          cloud_data_points, cloud_overlap_form, &
                          lhsw_cld_prop_form,  &
                          lw_cld_prop_form


!----------------------------------------------------------------------
!----  public data -------


!----------------------------------------------------------------------
!----  private data -------

!logical ::          do_esfsw

!------------------------------------------------------------------
!    test (singlecolumn) values for cloud amount, height index,
!    infrared emissivity and shortwave reflectivity and absorptivity
!------------------------------------------------------------------

integer                               :: ich, icm, ict, icb
real                                  :: ch, cm, cl
real, dimension(:,:), allocatable     :: cloud_amount_in
real, dimension(:,:), allocatable     :: max_cloud_amount_in
real, dimension(:,:), allocatable     :: rnd_cloud_amount_in
integer, dimension(:), allocatable    :: nmax_cloud_in
integer, dimension(:), allocatable    :: nrnd_cloud_in




 real, dimension(:,:), allocatable     :: cvis_rf_in, cir_rf_in,  &
                                          cir_abs_in

 real, dimension(:,:,:), allocatable   :: emlw_band_in
real, dimension(:,:), allocatable     :: emlw_in

!----------------------------------------------------------------------
!   define default values for shortwave cloud absorptivity and
!   reflectivity for use only in the lacis-hansen implementation
!   of shortwave radiative transfer
!      (these are the values previously used in SKYHI)
!----------------------------------------------------------------------
real                 :: lowcloud_refl_visband = 0.66E+00
real                 :: midcloud_refl_visband = 0.54E+00
real                 :: highcloud_refl_visband = 0.21E+00
real                 :: lowcloud_refl_nearirband = 0.50E+00
real                 :: midcloud_refl_nearirband = 0.46E+00
real                 :: highcloud_refl_nearirband = 0.19E+00
real                 :: lowcloud_abs_visband = 0.0E+00
real                 :: midcloud_abs_visband = 0.0E+00
real                 :: highcloud_abs_visband = 0.0E+00
real                 :: lowcloud_abs_nearirband = 0.30E+00
real                 :: midcloud_abs_nearirband = 0.20E+00
real                 :: highcloud_abs_nearirband = 0.04E+00

!----------------------------------------------------------------------
!   define default (grey) values for longwave emissivity for low, mid,
!   high clouds. these are used if no microphysics parameterizations
!   (or assumptions) are used in the longwave radiative transfer
!      (these are the values previously used in SKYHI)
!----------------------------------------------------------------------
real                 :: lowcloud_emiss = 1.00E+00
real                 :: midcloud_emiss = 1.00E+00
real                 :: highcloud_emiss = 1.00E+00

real  ::       pie 

!---------------------------------------------------------------------
!        cldhp             sigma value defining high-middle cloud boun-
!                          dary at the pole [ dimensionless ]
!        cldhe             sigma value defining high-middle cloud boun-
!                          dary at the equator [ dimensionless ]
!        cldmp             sigma value defining middle-low cloud boun-
!                          dary at the pole [ dimensionless ]
!        cldme             sigma value defining middle-low cloud boun-
!                          dary at the equator [ dimensionless ]
!---------------------------------------------------------------------
      real        :: cldhp = 0.7                   
      real        :: cldhe = 0.4            
      real        :: cldmp = 0.85                  
      real        :: cldme = 0.7                 

     logical :: module_is_initialized = .false.
!----------------------------------------------------------------------
!----------------------------------------------------------------------



                        contains 


!####################################################################

! <SUBROUTINE NAME="standalone_clouds_init">
!  <OVERVIEW>
!    subroutine standalone_clouds_init is the constructor for the
!    standalone_clouds_mod.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    subroutine standalone_clouds_init is the constructor for the
!    standalone_clouds_mod.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call standalone_clouds_init (pref, lonb, latb)
!
!  </TEMPLATE>
!  <IN NAME="pref" TYPE="real">
!       pref      array containing two reference pressure profiles
!                 for use in defining transmission functions [ Pa ]
! 
!  </IN>
!  <IN NAME="lonb" TYPE="real">
!       lonb      2d array of model longitudes at cell corners [ radians ]
! 
!  </IN>
!  <IN NAME="latb" TYPE="real">
!       latb      2d array of model latitudes at cell corners [radians]
! 
!  </IN>
! </SUBROUTINE>
!
subroutine standalone_clouds_init (pref, lonb, latb)

!--------------------------------------------------------------------
!    subroutine standalone_clouds_init is the constructor for the
!    standalone_clouds_mod.
!---------------------------------------------------------------------

real, dimension(:,:), intent(in)    ::  pref        
real, dimension(:,:), intent(in)    ::  lonb, latb

!---------------------------------------------------------------------
!   intent(in) variables:
!
!       pref      array containing two reference pressure profiles 
!                 for use in defining transmission functions [ Pa ]
!       lonb      2d array of model longitudes at cell corners [ radians ]
!       latb      2d array of model latitudes at cell corners [radians]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      real               :: max_cld_calc
      integer            :: unit, ierr, io, logunit
      integer            :: ktop, kbot
      integer            :: idf, jdf, kx
      integer            :: i, k, kk

!---------------------------------------------------------------------
!   local variables:
!
!      max_cld_calc maximum cloud amount in any layer within a maximum
!                   random overlap cloud [ dimensionless ]
!      unit         io unit for reading nml file and writing logfile
!      io           error status returned from io operation  
!      ierr         error code
!      ktop         cloud top index
!      kbot         cloud bottom index
!      idf          number of longitudes assigned to the processor
!      jdf          number of latitudes assigned to the processor
!      kx           number of layers in the model
!      i,k,kk       do loop indices
!
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return

!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call rad_utilities_init
 
!---------------------------------------------------------------------
!    read namelist.
!---------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
   read (input_nml_file, nml=standalone_clouds_nml, iostat=io)
   ierr = check_nml_error(io,"standalone_clouds_nml")
#else
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ()
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=standalone_clouds_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'standalone_clouds_nml')
        enddo
10      call close_file (unit)
      endif
#endif

!---------------------------------------------------------------------
!    write namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() )    &
                       write (logunit, nml=standalone_clouds_nml)

!---------------------------------------------------------------------
!    define size of processor's domain.
!---------------------------------------------------------------------
      idf = size(lonb,1) - 1
      jdf = size(latb,2) - 1
      kx  = size(pref,1) - 1
      
!---------------------------------------------------------------------
!    define the value of pi for later use.
!---------------------------------------------------------------------
      pie = 4.0*ATAN(1.0)

!---------------------------------------------------------------------
!    save the number of requested cloud columns in a derived type 
!    variable for later use. ensure that this quantity is  at least one
!    but no more than the number of longitudes assigned to the processor
!    (idf). 
!---------------------------------------------------------------------
      Cldrad_control%cloud_data_points = cloud_data_points
      if (cloud_data_points < 1 .or.   &
          cloud_data_points > idf) then
        call error_mesg( 'standalone_clouds_mod',  &
                 ' cloud_data_points must be greater than zero but '//&
                   'no larger than the number of model longitudes', &
                                                               FATAL)
      endif

!---------------------------------------------------------------------
!    allocate the module variables which will hold the cloud specific-
!    ation information (total amount, max rnd amount, rnd amount, max
!    rnd cloud number, rnd cloud number). initialize the values to zero,
!    corresponding to the absence of clouds.
!---------------------------------------------------------------------
      allocate (cloud_amount_in     (idf, kx))
      allocate (max_cloud_amount_in (idf, kx))
      allocate (rnd_cloud_amount_in (idf, kx))
      allocate (nmax_cloud_in       (idf))
      allocate (nrnd_cloud_in       (idf))
      cloud_amount_in     = 0.0E+00
      max_cloud_amount_in = 0.0E+00
      rnd_cloud_amount_in = 0.0E+00
      nmax_cloud_in       = 0
      nrnd_cloud_in       = 0

!---------------------------------------------------------------------
!    if cloud data is to be supplied via input file, open the input
!    file, read the data for each column into cloud-amount_in, and then
!    close the file.
!---------------------------------------------------------------------
      if (trim(cloud_data_form) == 'input') then
        unit = open_namelist_file ('INPUT/cld_amt_file')
        do i=1,cloud_data_points
          read (unit,FMT = '(5e18.10)') (cloud_amount_in(i,k),k=1,kx)
        end do
        call close_file (unit)
      
!---------------------------------------------------------------------
!    if random overlap is assumed, compute the number of max_random and
!    random overlap clouds. the number of max_random is assumed to
!    be zero, while each layer with cloud present is assumed to be
!    a separate raandom overlap cloud. 
!---------------------------------------------------------------------
        if (trim(cloud_overlap_form) == 'random') then
          nrnd_cloud_in = COUNT(cloud_amount_in > 0.0E+00,DIM=2)
          nmax_cloud_in = 0
          max_cloud_amount_in = 0.0E+00
          rnd_cloud_amount_in = cloud_amount_in

!---------------------------------------------------------------------
!    if max_random overlap is assumed, compute the number of max_random
!    and random overlap clouds. 
!---------------------------------------------------------------------
        else if (trim(cloud_overlap_form) == 'max_random') then
          do i=1,cloud_data_points
            ktop = 1
            kbot = 1
            do k=1,kx-1
!----------------------------------------------------------------------
!    the cloud code below accounts for clouds in the (ktop, kbot) 
!    layers. cycle k to (kbot+1) to continue processing.
!----------------------------------------------------------------------
              if (k  > 1 .AND. k <= kbot) CYCLE

!----------------------------------------------------------------------
!    march downward in the column; find the next lower cloud top layer.
!----------------------------------------------------------------------
              if (cloud_amount_in(i,k) > 0.0E+00) then

!----------------------------------------------------------------------
!   determine the thickness of this cloud.
!----------------------------------------------------------------------
                ktop = k
                kbot = k
                do kk=ktop+1,kx   
!----------------------------------------------------------------------
!   find the base of the current cloud. at that point exit the loop.
!----------------------------------------------------------------------
                  if ( cloud_amount_in(i,kk) == 0.0E+00) EXIT
                  kbot = kk
                end do

!----------------------------------------------------------------------
!    if it is a single-layer cloud, assign it random cloud overlap prop-
!    erties.
!----------------------------------------------------------------------
                if (ktop == kbot) then
                  max_cloud_amount_in(i,k) = 0.0E+00
                  rnd_cloud_amount_in(i,k) = cloud_amount_in(i,k)
                  nrnd_cloud_in(i) = nrnd_cloud_in(i) + 1

!----------------------------------------------------------------------
!    if it is a multi-layer cloud, treat it as a max-random overlap
!    cloud. TEMPORARILY, set max cloud amount = max(cloud amounts from 
!    ktop to kbot) and set rnd cloud amount = zero.
!----------------------------------------------------------------------
                else
                  max_cld_calc = MAXVAL (cloud_amount_in(i,ktop:kbot))
                  max_cloud_amount_in(i,ktop:kbot) = max_cld_calc
                  rnd_cloud_amount_in(i,ktop:kbot) = 0.0E+00
                  nmax_cloud_in(i) = nmax_cloud_in(i) + 1
                endif

!----------------------------------------------------------------------
!    if cloud is not present at this level,  check the next level.
!----------------------------------------------------------------------
              else
                ktop = k
                kbot = k
              endif
            end do

!----------------------------------------------------------------------
!    deal with special case of cloud in lowest layer, no cloud in
!    next lowest layer (should never happen).
!----------------------------------------------------------------------
            if (cloud_amount_in(i,kx) > 0.0E+00 .AND.     &
                cloud_amount_in(i,kx-1) == 0.0E+00   ) then
              rnd_cloud_amount_in(i,kx   ) = cloud_amount_in(i,kx   )
              max_cloud_amount_in(i,kx   ) = 0.0E+00
              nrnd_cloud_in(i) = nrnd_cloud_in(i) + 1
            endif
          end do

!----------------------------------------------------------------------
!    error case: invalid specification of cloud_overlap_form.
!----------------------------------------------------------------------
        else
          call error_mesg( 'standalone_clouds_mod',  &
             ' cloud_overlap_form is not an acceptable value.', FATAL)
        endif
 
!----------------------------------------------------------------------
!    if cloud data is specified, define cloud amounts for high, middle
!    and low clouds. 
!----------------------------------------------------------------------
      else if (trim(cloud_data_form) == 'specified') then
        ch   = 0.159E+00
        cm   = 0.070E+00
        cl   = 0.269E+00

!----------------------------------------------------------------------
!    define the model k indices of the high and middle clouds (single 
!    layer) and the k indices of low cloud tops and bases (multi-layer 
!    clouds)  for levels corresponding to 3 different gcms: L40 SKYHI, 
!    the L18 NMC model, and the R30L14 supersource model. if column_type
!    is not recognized, print an error message and stop.
!----------------------------------------------------------------------
        if (trim(cldht_type_form)         == 'skyl40') then
          ich  = 29 
          icm  = 34
          ict  = 35 
          icb  = 37 
        else if (trim(cldht_type_form)         == 'nmcl18') then
          ich  =  5 
          icm  = 11 
          ict  = 12 
          icb  = 14 
        else if (trim(cldht_type_form)         == 'r30l14') then
          ich  = 6 
          icm  = 9 
          ict  = 10 
          icb  = 12 
        else if (trim(cldht_type_form)         == 'fmsl18') then
          ich  = 6   
          icm  = 9       
          ict  = 10  
          icb  = 12
        else
          call error_mesg ('standalone_clouds_mod', &
            'cloud properties have not been specified for'//&
             ' this column type', FATAL)
        endif

!---------------------------------------------------------------------
!    verify that the specified cloud levels are compatible with the
!    the model grid being used in this experiment.
!---------------------------------------------------------------------
        if (ich > kx  .or. icm > kx .or. ict > kx .or. icb > kx) then
          call error_mesg ('standalone_clouds_mod', &
            'specified cloud level index not within model grid', FATAL)
        endif
        if (ich < 1   .or. icm < 1  .or. ict < 1  .or. icb < 1) then
          call error_mesg ('standalone_clouds_mod', &
            'specified cloud level index not within model grid', FATAL)
        endif

!---------------------------------------------------------------------
!    save the cloud level indices for use elsewhere in defining the 
!    cloud radiative properties.
!---------------------------------------------------------------------
        Cldrad_control%ich = ich
        Cldrad_control%icm = icm
        Cldrad_control%ict = ict
        Cldrad_control%icb = icb

!---------------------------------------------------------------------
!    now specify the characteristics of three cloud columns; more can
!    be specified if desired, limited by the number of longitudes owned
!    by the processor.
!---------------------------------------------------------------------

!----------------------------------------------------------------------
!    the first cloud column contains 3 clouds, including a max-random 
!    overlap cloud.
!----------------------------------------------------------------------
        rnd_cloud_amount_in(1,ich) = ch
        rnd_cloud_amount_in(1,icm) = cm
        do k=ict,icb
          max_cloud_amount_in(1,k) = cl
        end do
        nmax_cloud_in(1) = 1
        nrnd_cloud_in(1) = 2

!---------------------------------------------------------------------
!    the second cloud column is cloudless.
!---------------------------------------------------------------------
        if (cloud_data_points > 1) then
          max_cloud_amount_in(2,:) = 0.0
          rnd_cloud_amount_in(2,:) = 0.0
          nmax_cloud_in(2) = 0
          nrnd_cloud_in(2) = 0
        endif

!---------------------------------------------------------------------
!    the third cloud column contains 5 random overlap clouds.
!---------------------------------------------------------------------
        if (cloud_data_points > 2) then
          rnd_cloud_amount_in(3,ich) = ch
          rnd_cloud_amount_in(3,icm) = cm
          do k=ict,icb
            rnd_cloud_amount_in(3,k) = cl
          enddo
          nmax_cloud_in(3) = 0
          nrnd_cloud_in(3) = 5
        endif

!---------------------------------------------------------------------
!    error case: invalid cloud_data_form
!---------------------------------------------------------------------
      else
        call error_mesg( 'standalone_clouds_mod',  &
             ' cloud_data_form is not an acceptable value.', FATAL)
      endif

!--------------------------------------------------------------------
!    mark the module as initialized.
!--------------------------------------------------------------------
      module_is_initialized = .true.

!---------------------------------------------------------------------


end subroutine standalone_clouds_init



!####################################################################

! <SUBROUTINE NAME="define_column_properties">
!  <OVERVIEW>
!    subroutine define_column_properties defines values for lw emiss-
!    ivity, visible and nir reflectivity and nir absorption to be used
!    with standalone clouds.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    subroutine define_column_properties defines values for lw emiss-
!    ivity, visible and nir reflectivity and nir absorption to be used
!    with standalone clouds.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call define_column_properties (pref, lonb, latb)
!
!  </TEMPLATE>
!  <IN NAME="pref" TYPE="real">
!       pref      array containing two reference pressure profiles
!                 for use in defining transmission functions [ Pa ]
! 
!  </IN>
!  <IN NAME="lonb" TYPE="real">
!       lonb      2d array of model longitudes at cell corners [ radians ]
! 
!  </IN>
!  <IN NAME="latb" TYPE="real">
!       latb      2d array of model latitudes at cell corners [radians]
! 
!  </IN>
! </SUBROUTINE>
!
subroutine define_column_properties (pref, lonb, latb)

!---------------------------------------------------------------------
!    subroutine define_column_properties defines values for lw emiss-
!    ivity, visible and nir reflectivity and nir absorption to be used
!    with standalone clouds.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
real, dimension(:,:), intent(in) :: pref
real, dimension(:,:), intent(in) :: lonb, latb

!---------------------------------------------------------------------
!   intent(in) variables:
!
!       pref      array containing two reference pressure profiles 
!                 for use in defining transmission functions [ Pa ]
!       lonb      2d array of model longitudes at cell corners [ radians ]
!       latb      2d array of model latitudes at cell corners [radians]
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!    local variables:

      integer  ::   unit
      integer  ::   idf, jdf, kx
      integer  ::   ich, icm, ict, icb
      integer  ::   i, k, n

!---------------------------------------------------------------------
!    local variables:
!
!      unit     io unit for reading nml file and writing logfile
!      ierr     error code
!      io       error status returned from io operation  
!      idf      x dimension of physics window
!      jdf      y dimension of physics window
!      kx       number of model layers
!      ich      model level index corresponding to level of high cloud
!      icm      model level index corresponding to level of middle cloud
!      ict      model level index corresponding to low-cloud cloud top
!      icb      model level index corresponding to low-cloud cloud base
!      i,k,n    do-loop indices
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    define the processor's domain dimensions. 
!---------------------------------------------------------------------
        jdf = size(latb,2) - 1
        idf = size(lonb,1) - 1
        kx  = size(pref,1) - 1

!-------------------------------------------------------------------
!    define the model levels corresponding to high cloud location, 
!    middle cloud location, low cloud top and low cloud base. 
!-------------------------------------------------------------------
        ich = Cldrad_control%ich
        icm = Cldrad_control%icm
        ict = Cldrad_control%ict
        icb = Cldrad_control%icb

!-------------------------------------------------------------------
!    allocate lw emissivity array and fill with either input or
!    specified values. default emissivity value is unity.
!-------------------------------------------------------------------
        allocate (emlw_band_in(idf, kx, Cldrad_control%nlwcldb))
        emlw_band_in(:,:,:) = 1.00E+00

!-------------------------------------------------------------------
!    if lw emissivity is to be obtained from an input file, allocate
!    an array into which it may be read, and then read the input data
!    for each desired cloud column. broadcast this data over all bands
!    of the emissivity variable.  close the input file unit. note that 
!    there must be consistency between the cloud fraction / altitude 
!    values and the emissivity values. this will be dealt with later.
!-------------------------------------------------------------------
        if (trim(lw_cld_prop_form) == 'input') then
          allocate (emlw_in (idf, kx))
          unit = open_namelist_file ('INPUT/lw_cld_prop_file')
          do i=1,Cldrad_control%cloud_data_points
            read (unit,FMT = '(5e18.10)')  (emlw_in(i,k),k=1,kx)
          end do
          do n=1,CLdrad_control%nlwcldb
            emlw_band_in(:,:,n) = emlw_in(:,:)
          end do
          call close_file (unit)

!---------------------------------------------------------------------
!    if using specified lw cloud emissivity, assign the values specified
!    in this module to the specified levels containing high, middle and
!    low clouds for each column that is to be integrated.
!---------------------------------------------------------------------
        else if (trim(lw_cld_prop_form) == 'specified') then
          if (trim(cloud_data_form) == 'specified') then
            do n=1,Cldrad_control%nlwcldb

!---------------------------------------------------------------------
!    the first specified column contains 3 clouds (max-random).
!----------------------------------------------------------------------
              emlw_band_in(1,ich,n) = highcloud_emiss
              emlw_band_in(1,icm,n) = midcloud_emiss
              do k=ict,icb
                emlw_band_in(1,k,n) = lowcloud_emiss
              end do
            end do

!---------------------------------------------------------------------
!    the second specified column contains no clouds - use default
!    value to which the array was initialized.
!----------------------------------------------------------------------
!           if (Cldrad_control%cloud_data_points > 1) then
!             emlw_band_in(2,:,:) = 1.00E+00
!           endif

!---------------------------------------------------------------------
!    the third specified column contains 5 random-overlap clouds.
!----------------------------------------------------------------------
            if (Cldrad_control%cloud_data_points > 2) then
              do n=1,CLdrad_control%nlwcldb
                emlw_band_in(3,ich,n) = highcloud_emiss
                emlw_band_in(3,icm,n) = midcloud_emiss
                do k=ict,icb
                  emlw_band_in(3,k,n) = lowcloud_emiss
                end do
              end do
            endif

!----------------------------------------------------------------------
!    if lw_cld_prop_form was specified then cloud_data_form must also be
!    specified. if this is not the case, write error message and stop
!    execution.
!---------------------------------------------------------------------
          else
            call error_mesg( 'standalone_clouds_mod',  &
                 ' if lw_cld_prop_form is specified  cloud_data_form'//&
                 ' must be specified.',                         FATAL)
          endif

!----------------------------------------------------------------------
!    if lw_cld_prop_form was neither specified nor input, write an
!    error message and stop execution.
!----------------------------------------------------------------------
        else
          call error_mesg ('standalone_clouds_mod', &
             'lw cld properties have not been specified correctly', &
                                                                FATAL)
        endif

!-------------------------------------------------------------------
!   if lhsw is active, allocate and initialize the lhsw cloud property 
!   arrays and either read an input file containing values for them or 
!   define them using the values specified in this module. the default
!   values are total reflection and zero absorption.
!-------------------------------------------------------------------
        if (Sw_control%do_lhsw) then
          allocate (cvis_rf_in (idf, kx))
          allocate (cir_rf_in  (idf, kx))
          allocate (cir_abs_in (idf, kx))
          cvis_rf_in(:,:) = 1.00E+00
          cir_rf_in (:,:) = 1.00E+00
          cir_abs_in(:,:) = 0.0

!----------------------------------------------------------------------
!    if values are supplied from an input file, open the file and read 
!    the values into the appropriate module variables.
!----------------------------------------------------------------------
          if (trim(lhsw_cld_prop_form) == 'input') then
            unit = open_namelist_file ('INPUT/lhsw_cld_prop_file')
            do i=1,Cldrad_control%cloud_data_points
              read (unit,FMT = '(5e18.10)') (cvis_rf_in(i,k),k=1,kx)
              read (unit,FMT = '(5e18.10)') (cir_rf_in(i,k),k=1,kx)
              read (unit,FMT = '(5e18.10)') (cir_abs_in(i,k),k=1,kx)
            end do
            call close_file (unit)
      
!----------------------------------------------------------------------
!    if one is to use the values provided by this module, define the
!    cldrad variables with the appropriate high, middle and low cloud
!    values. levels containing cloud are defined by ich, icm, ict and 
!    icb.
!---------------------------------------------------------------------
          else if (trim(lhsw_cld_prop_form) == 'specified') then

!---------------------------------------------------------------------
!    the first point contains 3 max-random overlap clouds. 
!---------------------------------------------------------------------
            cvis_rf_in(1,ich) = highcloud_refl_visband
            cvis_rf_in(1,icm) = midcloud_refl_visband
            cir_rf_in(1,ich)  = highcloud_refl_nearirband
            cir_rf_in(1,icm)  = midcloud_refl_nearirband
            cir_abs_in(1,ich) = highcloud_abs_nearirband
            cir_abs_in(1,icm) = midcloud_abs_nearirband
            do k=ict,icb
              cvis_rf_in(1,k) = lowcloud_refl_visband
              cir_rf_in(1,k)  = lowcloud_refl_nearirband
              cir_abs_in(1,k) = lowcloud_abs_nearirband
            end do

!---------------------------------------------------------------------
!    the second point contains no clouds -- use initialized values. 
!---------------------------------------------------------------------
!           if (Cldrad_control%cloud_data_points > 1) then
!             cvis_rf_in(2,:) = 1.00E+00
!             cir_rf_in(2,:)  = 1.00E+00
!             cir_abs_in(2,:) = 0.0
!           endif

!---------------------------------------------------------------------
!    the third point contains 5 random overlap clouds. 
!---------------------------------------------------------------------
            if (Cldrad_control%cloud_data_points > 2) then
              cvis_rf_in(3,ich) = highcloud_refl_visband
              cvis_rf_in(3,icm) = midcloud_refl_visband
              cir_rf_in(3,ich)  = highcloud_refl_nearirband
              cir_rf_in(3,icm)  = midcloud_refl_nearirband
              cir_abs_in(3,ich) = highcloud_abs_nearirband
              cir_abs_in(3,icm) = midcloud_abs_nearirband
              do k=ict,icb
                cvis_rf_in(3,k) = lowcloud_refl_visband
                cir_rf_in(3,k)  = lowcloud_refl_nearirband
                cir_abs_in(3,k) = lowcloud_abs_nearirband
              end do
            endif

!---------------------------------------------------------------------
!    if lhsw_cld_props was neither specified or input, write an error
!    message and stop execution.
!---------------------------------------------------------------------
          else
            call error_mesg ('standalone_clouds_mod', &
                    'lhsw_cld_prop_form has an improper value',  FATAL)
          endif
        endif !  (do_lhsw)

!---------------------------------------------------------------------




end subroutine define_column_properties




!######################################################################

! <SUBROUTINE NAME="standalone_clouds_end">
!  <OVERVIEW>
!    standalone_clouds_end is the destructor for standalone_clouds_mod.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    standalone_clouds_end is the destructor for standalone_clouds_mod.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call standalone_clouds_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine standalone_clouds_end
        
!----------------------------------------------------------------------
!    standalone_clouds_end is the destructor for standalone_clouds_mod.
!----------------------------------------------------------------------
       
!---------------------------------------------------------------------
!    mark the module as not initialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.
        
!--------------------------------------------------------------------


end subroutine standalone_clouds_end



!#################################################################

! <SUBROUTINE NAME="standalone_clouds_amt">
!  <OVERVIEW>
!    standalone_clouds_amt defines the number, amount (cloud fraction),
!    and type (hi, mid, low) of clouds present on the model grid.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    standalone_clouds_amt defines the number, amount (cloud fraction),
!    and type (hi, mid, low) of clouds present on the model grid.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call standalone_clouds_amt (is, ie, js, je, lat, press_mks,  &
!                Cld_spec)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
! 
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <IN NAME="lat" TYPE="real">
!      lat          latitude of model points  [ radians ]
! 
!  </IN>
!  <IN NAME="press_mks" TYPE="real">
!      press_mks    pressure at model levels (1:nlev), surface
!                   pressure is stored at index value nlev+1
!                   [ (kg /( m s^2) ]
! 
!  </IN>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
!      Cld_spec     cld_specification_type variable containing the
!                   cloud specification input fields needed by the
!                   radiation package
!
!               the following elements of Cld_spec are defined here:
!
!                  %cmxolw  fraction of maximally overlapped clouds
!                           seen by the longwave radiation
!                           [ dimensionless ]
!                  %crndlw  fraction of randomly overlapped clouds
!                           seen by the longwave radiation
!                           [ dimensionless ]
!                  %camtsw  cloud fraction seen by the shortwave
!                           radiation; the sum of the maximally
!                           overlapped and randomly overlapped
!                           longwave cloud fractions  [ dimensionless ]
!                  %nmxolw  number of maximally overlapped longwave
!                           clouds in each grid column.
!                  %nrndlw  number of randomly overlapped longwave
!                           clouds in each grid column.
!                  %ncldsw  number of clouds seen by he shortwave
!                           radiation in each grid column.
!                  %hi_cld  logical flag indicating the presence of
!                           high clouds in a grid box
!                 %mid_cld  logical flag indicating the presence of
!                           middle clouds in a grid box
!                 %low_cld  logical flag indicating the presence of
!                           low clouds in a grid box
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine standalone_clouds_amt (is, ie, js, je, lat, press_mks,  &
                                  Cld_spec)

!---------------------------------------------------------------------
!    standalone_clouds_amt defines the number, amount (cloud fraction), 
!    and type (hi, mid, low) of clouds present on the model grid.
!----------------------------------------------------------------------

integer,                      intent(in)     ::  is, ie, js, je
real,    dimension(:,:),      intent(in)     ::  lat  
real,    dimension(:,:,:),    intent(in)     ::  press_mks
type(cld_specification_type), intent(inout)  ::  Cld_spec

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      lat          latitude of model points  [ radians ]
!      press_mks    pressure at model levels (1:nlev), surface 
!                   pressure is stored at index value nlev+1
!                   [ (kg /( m s^2) ]
!
!   intent(inout) variables:
!
!      Cld_spec     cld_specification_type variable containing the 
!                   cloud specification input fields needed by the 
!                   radiation package
!
!               the following elements of Cld_spec are defined here:
!
!                  %cmxolw  fraction of maximally overlapped clouds
!                           seen by the longwave radiation 
!                           [ dimensionless ]
!                  %crndlw  fraction of randomly overlapped clouds
!                           seen by the longwave radiation 
!                           [ dimensionless ]
!                  %camtsw  cloud fraction seen by the shortwave
!                           radiation; the sum of the maximally
!                           overlapped and randomly overlapped 
!                           longwave cloud fractions  [ dimensionless ]
!                  %nmxolw  number of maximally overlapped longwave 
!                           clouds in each grid column.
!                  %nrndlw  number of randomly overlapped longwave 
!                           clouds in each grid column.
!                  %ncldsw  number of clouds seen by he shortwave
!                           radiation in each grid column.
!                  %hi_cld  logical flag indicating the presence of 
!                           high clouds in a grid box
!                 %mid_cld  logical flag indicating the presence of 
!                           middle clouds in a grid box
!                 %low_cld  logical flag indicating the presence of 
!                           low clouds in a grid box
!                                                                  
!---------------------------------------------------------------------

!----------------------------------------------------------------------
!   local variables

      real, dimension (size(Cld_spec%camtsw,2) ) :: cldhm, cldml

      real, dimension (size(Cld_spec%camtsw,1),                    &
                       size(Cld_spec%camtsw,2) ) ::  press_hm, press_ml

      integer     :: kx
      integer     :: i, j, k

!--------------------------------------------------------------------
!  local variables:
!
!        cldhm             sigma value defining high-middle cloud boun-
!                          daries at window latitudes [ dimensionless ]
!        cldml             sigma value defining middle-low cloud boun-
!                          daries at window latitudes [ dimensionless ]
!        press_hm          pressure corresponding to the high-middle
!                          cloud boundary [ (kg /( m s^2) ]
!        press_ml          pressure corresponding to the middle-low
!                          cloud boundary [ (kg /( m s^2) ]
!        kx                number of model layers
!        i,j,k             do loop indices
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    define the number of model layers.
!---------------------------------------------------------------------
      kx = size(Cld_spec%camtsw,3)

!---------------------------------------------------------------------
!    define the cloud fractions and number of clouds per column (random 
!    and max overlap) from the cloud specification data that was input. 
!    each cloud data point is replicated on each latitude row in the 
!    window.
!---------------------------------------------------------------------
      do j=1,size(Cld_spec%camtsw,2)
        do i=1,cloud_data_points
          Cld_spec%crndlw(i,j,:) = rnd_cloud_amount_in(i,:)
          Cld_spec%cmxolw(i,j,:) = max_cloud_amount_in(i,:)
          Cld_spec%nmxolw(i,j) = nmax_cloud_in(i)
          Cld_spec%nrndlw(i,j) = nrnd_cloud_in(i)
        end do
      end do

!!! NOTE:
!!!!  define Cld_spec%cld_thickness here (if needed)

!--------------------------------------------------------------------
!    sum up the random and max overlap cloud fractions and number of 
!    clouds per column to produce the values seen by the shortwave 
!    radiation. insure that cloud fraction at all grid points is <= 1.
!--------------------------------------------------------------------
      do j=1, size(Cld_spec%camtsw,2)
        do i=1,cloud_data_points
          Cld_spec%camtsw(i,j,:) = Cld_spec%crndlw(i,j,:) +    &
                                   Cld_spec%cmxolw(i,j,:)
          Cld_spec%ncldsw(i,j)   = Cld_spec%nmxolw(i,j) +      &
                                   Cld_spec%nrndlw(i,j)
        end do
      end do
      Cld_spec%camtsw = MIN (Cld_spec%camtsw,1.00)
      Cld_spec%cloud_area = Cld_spec%camtsw

!---------------------------------------------------------------------
!    determine the sigmas defining the hi-middle-lo cloud transitions
!    at each grid point. the sigmas vary with latitude between equator
!    and pole, and are linearly interpolated to the model latitude.
!---------------------------------------------------------------------
      do j=1,size(Cld_spec%camtsw,2)
        cldhm(j) = cldhp + ( (0.5*pie - abs(lat(1,j)))/(0.5*pie))* &
                   (cldhe - cldhp)
        cldml(j) = cldmp + ( (0.5*pie - abs(lat(1,j)))/(0.5*pie))* &
                   (cldme - cldmp)
      end do

!---------------------------------------------------------------------
!    define the pressures at the high-middle-low cloud boundaries.
!---------------------------------------------------------------------
      do j=1,size(Cld_spec%camtsw,2)
        do i=1,size(Cld_spec%camtsw,1)
          press_hm(i,j) = cldhm(j)*press_mks(i,j,kx+1)
          press_ml(i,j) = cldml(j)*press_mks(i,j,kx+1)
        end do
      end do

!--------------------------------------------------------------------
!    define flags indicating grid points at which either high, middle
!    or low clouds exist.
!---------------------------------------------------------------------
      do k=1,kx
        do j=1,size(Cld_spec%camtsw,2)
          do i=1,size(Cld_spec%camtsw,1)
            if (Cld_spec%camtsw(i,j,k) > 0.0) then
              if (press_mks(i,j,k) <= press_hm(i,j)) then
                Cld_spec%hi_cloud(i,j,k) = .true.
              else if (press_mks(i,j,k) > press_hm(i,j) .and.      &
                       press_mks(i,j,k) <= press_ml(i,j)) then
                Cld_spec%mid_cloud(i,j,k) = .true.
              else if (press_mks(i,j,k) > press_ml(i,j) ) then
                Cld_spec%low_cloud(i,j,k) = .true.
              endif
            endif
          end do
        end do
      end do

!---------------------------------------------------------------------




end subroutine standalone_clouds_amt   



!#####################################################################

! <SUBROUTINE NAME="obtain_micro_lw_sa">
!  <OVERVIEW>
!    obtain_micro_lw_sa defines microphysically-based longwave cloud
!    radiative properties when the code is executed in standalone
!    columns mode.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    obtain_micro_lw_sa defines microphysically-based longwave cloud
!    radiative properties when the code is executed in standalone
!    columns mode.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call obtain_micro_lw_sa (is, ie, js, je, Lsc_microphys, &
!                Meso_microphys, Cell_microphys, &
!                Lscrad_props,  Mesorad_props, &
!                Cellrad_props)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <INOUT NAME="Lsc_microphys" TYPE="microphysics_type">
!      Lsc_microphys     microphysical specification for large-scale
!                        clouds, provides input to this subroutine
!                        [ microphysics_type ]
! 
!  </INOUT>
!  <INOUT NAME="Meso_microphys" TYPE="microphysics_type">
!      Meso_microphys    microphysical specification for meso-scale
!                        clouds, provides input to this subroutine
!                        [ microphysics_type ]
! 
!  </INOUT>
!  <INOUT NAME="Cell_microphys" TYPE="microphysics_type">
!      Cell_microphys    microphysical specification for cell-scale
!                        clouds, provides input to this subroutine
!                        [ microphysics_type ]
! 
!  </INOUT>
!  <INOUT NAME="Lscrad_props" TYPE="microrad_properties_type">
!      Lscrad_props      cloud radiative properties on model grid,
!                        [ microrad_properties_type ]
! 
!  </INOUT>
!  <INOUT NAME="Mesorad_props" TYPE="microrad_properties_type">
!      Mesorad_props     meso-scale cloud radiative properties on
!                        model grid, [ microrad_properties_type ]
! 
!  </INOUT>
!  <INOUT NAME="Cellrad_props" TYPE="microrad_properties_type">
!      Cellrad_props     cell-scale cloud radiative properties on
!                        model grid, [ microrad_properties_type ]
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine obtain_micro_lw_sa (is, ie, js, je, Lsc_microphys, &
                               Meso_microphys, Cell_microphys, &
                               Lscrad_props,  Mesorad_props, &
                               Cellrad_props)

!---------------------------------------------------------------------
!    obtain_micro_lw_sa defines microphysically-based longwave cloud 
!    radiative properties when the code is executed in standalone 
!    columns mode.
!---------------------------------------------------------------------

integer,                        intent(in)    :: is, ie, js, je
type(microphysics_type),        intent(inout) :: Lsc_microphys, &
                                                 Meso_microphys, &
                                                 Cell_microphys
type(microrad_properties_type), intent(inout) :: Lscrad_props, &
                                                 Mesorad_props, &
                                                 Cellrad_props
 
!---------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!
!   intent(inout) variables:
!
!      Lsc_microphys     microphysical specification for large-scale 
!                        clouds, provides input to this subroutine
!                        [ microphysics_type ]
!      Meso_microphys    microphysical specification for meso-scale 
!                        clouds, provides input to this subroutine
!                        [ microphysics_type ]
!      Cell_microphys    microphysical specification for cell-scale 
!                        clouds, provides input to this subroutine
!                        [ microphysics_type ]
!      Lscrad_props      cloud radiative properties on model grid,
!                        [ microrad_properties_type ]
!      Mesorad_props     meso-scale cloud radiative properties on 
!                        model grid, [ microrad_properties_type ]
!      Cellrad_props     cell-scale cloud radiative properties on 
!                        model grid, [ microrad_properties_type ]
!
!               the following component of the **_props variables is 
!               output from this routine:
!
!                    %abscoeff  absorption coefficient for  
!                               clouds in each of the longwave 
!                               frequency bands  [ km **(-1) ]
!
!---------------------------------------------------------------------

!-----------------------------------------------------------------
!    call microphys_rad_driver2 to obtain the microphysically-based
!    sw cloud radiative quantities.
!---------------------------------------------------------------------
!     call microphys_rad_driver2 (is, ie, js, je, Lsc_microphys,   &
!     call microphys_lw_driver2 (is, ie, js, je, Lsc_microphys,   &
!                                 abscoeff=Lscrad_props%abscoeff)

!---------------------------------------------------------------------
!    if donner_deep is activated, process the cloud radiative properties
!    associated with the mesoscale and cellscale components of that
!    parameterization.
!---------------------------------------------------------------------
!     if (do_donner_deep_clouds) then
!     if (Cldrad_control%do_donner_deep_clouds) then
!        call obtain_micro_lw_donner_deep (is, ie, js, je,  &
!                                          Cell_microphys, & 
!                                          Meso_microphys,  &
!                                          Cellrad_props, Mesorad_props)
!     endif

!--------------------------------------------------------------------


end subroutine obtain_micro_lw_sa     




!#####################################################################

! <SUBROUTINE NAME="obtain_micro_sw_sa">
!  <OVERVIEW>
!    obtain_micro_sw_sa defines microphysically-based shortwave cloud
!    radiative properties for the standalone cloud scheme when run in
!    columns mode.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    obtain_micro_sw_sa defines microphysically-based shortwave cloud
!    radiative properties for the standalone cloud scheme when run in
!    columns mode.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call obtain_micro_sw_sa (is, ie, js, je, Lsc_microphys,   &
!                Meso_microphys, Cell_microphys,   &
!                Lscrad_props, Mesorad_props,   &
!                Cellrad_props)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <INOUT NAME="Lsc_microphys" TYPE="microphysics_type">
! 
!  </INOUT>
!  <INOUT NAME="Meso_microphys" TYPE="microphysics_type">
! 
!  </INOUT>
!  <INOUT NAME="Cell_microphys" TYPE="microphysics_type">
! 
!  </INOUT>
!  <INOUT NAME="Lscrad_props" TYPE="microrad_properties_type">
! 
!  </INOUT>
!  <INOUT NAME="Mesorad_props" TYPE="microrad_properties_type">
! 
!  </INOUT>
!  <INOUT NAME="Cellrad_props" TYPE="microrad_properties_type">
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine obtain_micro_sw_sa (is, ie, js, je, Lsc_microphys,   &
                               Meso_microphys, Cell_microphys,   &
                               Lscrad_props, Mesorad_props,   &
                               Cellrad_props)

!--------------------------------------------------------------------
!    obtain_micro_sw_sa defines microphysically-based shortwave cloud 
!    radiative properties for the standalone cloud scheme when run in 
!    columns mode.
!---------------------------------------------------------------------

integer,                         intent(in)    ::  is, ie, js, je
type(microphysics_type),         intent(inout) ::  Lsc_microphys, &
                                                   Meso_microphys,   &
                                                   Cell_microphys
type(microrad_properties_type),  intent(inout) ::  Lscrad_props,   &
                                                   Mesorad_props,  &
                                                   Cellrad_props

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!
!   intent(inout) variables:
!
!      Lsc_microphys     microphysical specification for large-scale 
!                        clouds, provides input to this subroutine
!                        [ microphysics_type ]
!      Meso_microphys    microphysical specification for meso-scale 
!                        clouds, provides input to this subroutine
!                        [ microphysics_type ]
!      Cell_microphys    microphysical specification for cell-scale 
!                        clouds, provides input to this subroutine
!                        [ microphysics_type ]
!      Lscrad_props      large-scale cloud radiative properties on 
!                        model grid, [ microrad_properties_type ]
!      Mesorad_props     meso-scale cloud radiative properties on 
!                        model grid, [ microrad_properties_type ]
!      Cellrad_props     cell-scale cloud radiative properties on 
!                        model grid, [ microrad_properties_type ]
!
!               the following components of the microrad_properties
!               variables are output from this routine:
!
!                   %cldext    sw extinction coefficient for  
!                              clouds in each of the shortwave 
!                              frequency bands  [ km **(-1) ]
!                   %cldsct    sw scattering coefficient for
!                              clouds in each of the shortwave
!                              frequency bands  [ km **(-1) ]
!                   %cldasymm  sw asymmetry factor for
!                              clouds in each of the shortwave 
!                              frequency bands  [ dimensionless ]
!
!-----------------------------------------------------------------

!-----------------------------------------------------------------
!    call microphys_rad_driver2 to obtain the microphysically-based
!    sw cloud radiative quantities.
!---------------------------------------------------------------------
!     call microphys_rad_driver2 (is, ie, js, je, Lsc_microphys, &
!     call microphys_sw_driver2 (is, ie, js, je, Lsc_microphys, &
!                                 cldext=Lscrad_props%cldext,   &
!                                 cldsct=Lscrad_props%cldsct,   &
!                                 cldasymm=Lscrad_props%cldasymm )

!---------------------------------------------------------------------
!    if donner_deep is activated, process the cloud radiative properties
!    associated with the mesoscale and cellscale components of that
!    parameterization.
!---------------------------------------------------------------------
!     if (do_donner_deep_clouds) then
!     if (CLdrad_control%do_donner_deep_clouds) then
!       call  obtain_micro_sw_donner_deep (is, ie, js, je,     &
!                                          Cell_microphys,&
!                                          Meso_microphys,     &
!                                          Cellrad_props, Mesorad_props)
!     endif

!--------------------------------------------------------------------



end subroutine obtain_micro_sw_sa     




!#####################################################################

! <SUBROUTINE NAME="obtain_bulk_lw_sa">
!  <OVERVIEW>
!    obtain_bulk_lw_sa defines bulk longwave cloud radiative properties
!    when using specified clouds in the standalone columns mode.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    obtain_bulk_lw_sa defines bulk longwave cloud radiative properties
!    when using specified clouds in the standalone columns mode.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call obtain_bulk_lw_sa (is, ie, js, je, Cldrad_props)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
! 
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output
!               from this routine:
!
!                    %emrndlw   longwave cloud emissivity for
!                               randomly overlapped clouds
!                               in each of the longwave
!                               frequency bands  [ dimensionless ]
!                    %emmxolw   longwave cloud emissivity for
!                               maximally overlapped clouds
!                               in each of the longwave
!                               frequency bands  [ dimensionless ]
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine obtain_bulk_lw_sa (is, ie, js, je, Cldrad_props)

!---------------------------------------------------------------------
!    obtain_bulk_lw_sa defines bulk longwave cloud radiative properties 
!    when using specified clouds in the standalone columns mode.
!---------------------------------------------------------------------
 
integer,                      intent(in)    :: is, ie, js, je
type(cldrad_properties_type), intent(inout) :: Cldrad_props
 
!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!
!   intent(inout) variables:
!
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output 
!               from this routine:
!
!                    %emrndlw   longwave cloud emissivity for 
!                               randomly overlapped clouds
!                               in each of the longwave
!                               frequency bands  [ dimensionless ]
!                    %emmxolw   longwave cloud emissivity for 
!                               maximally overlapped clouds
!                               in each of the longwave 
!                               frequency bands  [ dimensionless ]
!
!---------------------------------------------------------------------

!----------------------------------------------------------------------
!   local variables:

      integer       :: i, j     ! do-loop indices

!--------------------------------------------------------------------
!    define the lw bulk cloud radiative properties from the values
!    previously defined in this module.
!--------------------------------------------------------------------
      do j=1,size(Cldrad_props%emrndlw,2)
        do i=1,cloud_data_points
          Cldrad_props%emmxolw(i,j,:,:,1) = emlw_band_in(i,:,:)
          Cldrad_props%emrndlw(i,j,:,:,1) = emlw_band_in(i,:,:)
        end do
      end do

!--------------------------------------------------------------------


end subroutine obtain_bulk_lw_sa     


!#####################################################################

! <SUBROUTINE NAME="obtain_bulk_sw_sa">
!  <OVERVIEW>
!    obtain_bulk_sw_sa defines bulk shortwave cloud radiative
!    properties for the specified cloud scheme when running in
!    standalone columns mode.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    obtain_bulk_sw_sa defines bulk shortwave cloud radiative
!    properties for the specified cloud scheme when running in
!    standalone columns mode.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call obtain_bulk_sw_sa (is, ie, js, je, Cldrad_props)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine obtain_bulk_sw_sa (is, ie, js, je, Cldrad_props)

!---------------------------------------------------------------------
!    obtain_bulk_sw_sa defines bulk shortwave cloud radiative 
!    properties for the specified cloud scheme when running in 
!    standalone columns mode.
!---------------------------------------------------------------------

integer,                      intent(in)    ::   is, ie, js, je
type(cldrad_properties_type), intent(inout) ::   Cldrad_props

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!
!   intent(inout) variables:
!
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!                    %cirabsw   absorptivity of clouds in the 
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cirrfsw   reflectivity of clouds in the 
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cvisrfsw  reflectivity of clouds in the 
!                               visible frequency band
!                               [ dimensionless ]
!
!---------------------------------------------------------------------

!----------------------------------------------------------------------
!   local variables

      integer       :: i, j    ! do-loop indices

!--------------------------------------------------------------------
!    define the sw bulk cloud radiative properties from the values
!    previously defined in this module.
!--------------------------------------------------------------------
      do j=1,size(Cldrad_props%cirabsw,2)
        do i=1,cloud_data_points
          Cldrad_props%cirabsw(i,j,:) = cir_abs_in(i,:)
          Cldrad_props%cirrfsw(i,j,:) = cir_rf_in(i,:)
          Cldrad_props%cvisrfsw(i,j,:) = cvis_rf_in(i,:)
        end do
      end do

!--------------------------------------------------------------------


end subroutine obtain_bulk_sw_sa     




!###################################################################

!subroutine find_nearest_index (latb, jindx2)

!real, dimension(:), intent(in) :: latb
!integer, dimension(:), intent(out)  :: jindx2
 

!      integer :: jd, j, jj
!     real   :: diff_low, diff_high
!      real, dimension(size(latb,1)-1) :: lat

 
!      jd = size(latb,1) - 1

!      do j = 1,jd
!        lat(j) = 0.5*(latb(j) + latb(j+1))
!      do jj=1, LATOBS
!        if (lat(j)*radians_to_degrees >= cloud_lats(jj)) then
!         diff_low = lat(j)*radians_to_degrees - cloud_lats(jj)
!          diff_high = cloud_lats(jj+1) - lat(j)*radians_to_degrees
!          if (diff_high <= diff_low) then
!            jindx2(j) = jj+1
!          else
!            jindx2(j) = jj
!          endif
!        endif
!      end do
!   end do






!end subroutine find_nearest_index

!#####################################################################




       end module standalone_clouds_mod




 

                      module clouds_mod

!=======================================================================
!
!            determines cloud properties necessary for 
!                    fels-schwartzkopf radiation
!
!=======================================================================

use    cloud_rad_mod, only:  cloud_rad_init, cloud_summary
use  cloud_zonal_mod, only:  cloud_zonal
use    cloud_obs_mod, only:  cloud_obs, cloud_obs_init
use time_manager_mod, only:  time_type
use          mpp_mod, only:  input_nml_file
use          fms_mod, only:  error_mesg, FATAL, file_exist,   &
                             check_nml_error, open_namelist_file,      &
                             mpp_pe, mpp_root_pe, close_file, &
                             write_version_number, stdlog
use    rh_clouds_mod, only:  do_rh_clouds, rh_clouds, rh_clouds_avg
use  strat_cloud_mod, only:  do_strat_cloud, strat_cloud_avg
use   diag_cloud_mod, only:  do_diag_cloud, diag_cloud_driver, &
                             diag_cloud_avg
use diag_manager_mod, only:  register_diag_field, send_data

implicit none
private

!------------------- public interfaces ---------------------------------

public   clouds, clouds_init, clouds_end

!-----------------------------------------------------------------------
!--------------------- version number ----------------------------------
 character(len=128) :: version = '$Id: clouds.F90,v 19.0 2012/01/06 20:02:48 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!   note:  the fels-schwarzkopf radiation code permits bi-spectral
!          cloud reflectivity associated with cloud cdwtr droplets:
!            -->  visible band - (cao3sw and cuvrf);
!            -->  near infra-red band - (cah2sw and cirrf).
!          the f-s code assumes that all gaseous absorption by
!          cdwtr vapor occurs in the near infra-red band.
!          thus, original code contains cbsw and cirab.
!          we shall include cbo3sw and cuvab and let cbsw = cbh2sw.
!          however, these spectral absorptivities will be set to zero.

      real, dimension(3) :: cao3sw = (/ 0.210, 0.450, 0.590 /)
      real, dimension(3) :: cah2sw = (/ 0.210, 0.450, 0.590 /)
      real, dimension(3) :: cbsw   = (/ 0.005, 0.020, 0.035 /)


!-----------------------------------------------------------------------

      logical :: module_is_initialized =.false.

      integer :: id_tot_cld_amt, id_high_cld_amt, id_mid_cld_amt, &
                 id_low_cld_amt, id_cld_amt, id_em_cld,  &
                 id_alb_uv_cld, id_alb_nir_cld,          &
                 id_abs_uv_cld, id_abs_nir_cld

      character(len=6), parameter :: mod_name = 'clouds'

      real :: missing_value = -999.

!-----------------------------------------------------------------------
!------------------------- namelist ------------------------------------

      logical :: do_zonal_clouds = .false.
      logical :: do_obs_clouds   = .false.
      logical :: do_no_clouds    = .false.
      logical :: do_isccp_cloud_diags = .false.
      
      namelist /clouds_nml/ do_zonal_clouds,  &
                            do_obs_clouds,    &
                            do_no_clouds,     &
                            do_isccp_cloud_diags

!-----------------------------------------------------------------------

contains

!#######################################################################

subroutine clouds  (is, js, clear_sky, Time, Time_diag, lat, &
                    land, tsfc, pfull, phalf, t, q, cosz,    &
                    nclds, ktopsw, kbtmsw, ktoplw, kbtmlw,   &
                    cldamt, cuvrf, cirrf, cirab, emcld, mask, kbot)

!-----------------------------------------------------------------------
        integer, intent(in)                    :: is, js
        logical, intent(in)                    :: clear_sky
type(time_type), intent(in)                    :: Time, Time_diag

   real, intent(in), dimension(:,:)    :: lat
   real, intent(in), dimension(:,:)    :: land,tsfc
   real, intent(in), dimension(:,:,:)  :: pfull,phalf,t,q
   real, intent(in), dimension(:,:)    :: cosz
integer, intent(out), dimension(:,:)   :: nclds
integer, intent(out), dimension(:,:,:) :: ktopsw,kbtmsw,ktoplw,kbtmlw
   real, intent(out), dimension(:,:,:) :: cldamt,cuvrf,cirrf,cirab,emcld
   real, intent(in),  dimension(:,:,:),optional :: mask
integer, intent(in),  dimension(:,:),  optional :: kbot
!-----------------------------------------------------------------------
   real,dimension(size(cirab,1),size(cirab,2),size(cirab,3)) :: cuvab
integer,dimension(size(ktoplw,1),size(ktoplw,2),size(ktoplw,3)) ::  &
                       ktop, kbtm
!      TCA_CA   array for total clouds diagnositc
!      HML_CA   array for high, middle and low clouds diagnostics
!               as per 3rd index values of 1,2 and 3 respectively.
   real,dimension(size(pfull,1),size(pfull,2))   :: tca
   real,dimension(size(pfull,1),size(pfull,2),3) :: hml_ca
 
!      pflux    array for the flux pressure levels for isccp cloud
!               diagnostics calculations
   real,dimension(size(phalf,1),size(phalf,2),size(phalf,3))  :: pflux
   

   real,dimension(size(pfull,1),size(pfull,2),size(pfull,3)) ::  &
                                                     ql,qi,cf,rh,cloud
   real,dimension(size(phalf,1),size(phalf,2),size(phalf,3)) :: phaf
   real :: rad2deg
integer :: i,j,k,kb,kx,kp1,n,ierr
logical :: used
!-----------------------------------------------------------------------

! The following local quantitities are used exclusively for diagnostic clouds
!      TEMP     Averaged temperature (Deg K) at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      QMIX     Averaged specific humidity at full model levels 
!                   (dimensioned IDIM x JDIM x kx)
!      OMEGA  Averaged pressure vertical velocity at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      LGSCLDELQ  Averaged rate of change in mix ratio due to lg scale precip 
!               at full model levels  
!               (dimensioned IX x JX x KX)
!      CNVCNTQ  Accumulated count of change in mix ratio due to conv precip 
!               at full model levels  
!               (dimensioned IX x JX x KX)
!      CONVPRC  Accumulated conv precip rate summed over all
!               full model levels (mm/day )
!               (dimensioned IX x JX)
!      Note:    RH is also a predictor but since it is used in the rh cloud
!               scheme as well it has already been declared.
!      PSFC     Surface pressure
!               (dimensioned IX x JX)
real, dimension(size(t,1),size(t,2),size(t,3)) :: temp,qmix,omega
real, dimension(size(t,1),size(t,2),size(t,3)) :: lgscldelq,cnvcntq
real, dimension(size(t,1),size(t,2)) :: convprc,psfc

!-----------------------------------------------------------------------

  ierr = 1

  kx  = size(ktopsw,3)-1
  kp1 = kx+1
    
  if (kx /= size(pfull,3)) call error_mesg ('clouds in clouds_mod', &
                       'input arrays have the incorrect size.',FATAL)

!-----------------------------------------------------------------------
!----------- default clouds values ----------

      call default_clouds (nclds,ktopsw,kbtmsw,ktoplw,kbtmlw,  &
                           cldamt,cuvrf,cirrf,cuvab,cirab,emcld)

!-------------- no clouds ----------------------------------------------

      if (clear_sky .or. do_no_clouds) then
          if (present(kbot)) call step_mtn_clouds (kx,kbot,          &
                                 nclds,ktopsw,kbtmsw,ktoplw,kbtmlw,  &
                                 cldamt,cuvrf,cirrf,cirab,emcld)
          return
      endif

!-----------------------------------------------------------------------
!--------------- determine rh cloud properties -----------------
 if ( do_rh_clouds() ) then
!-----------------------------------------------------------------------
!---- compute rh_clouds -----

     call rh_clouds_avg (is, js, rh, ierr)

     if (ierr == 0) then
         rad2deg = 90./acos(0.0)
         call rh_clouds(rh,pfull,phalf(:,:,kx+1),cosz,lat*rad2deg,&
                        nclds,ktop(:,:,2:kp1),kbtm(:,:,2:kp1),  &
                        cldamt(:,:,2:kp1),cuvrf(:,:,2:kp1),  &
                        cirrf(:,:,2:kp1),cuvab(:,:,2:kp1),  &
                        cirab(:,:,2:kp1),emcld(:,:,2:kp1))
     endif     

!-----------------------------------------------------------------------
 endif
!-----------------------------------------------------------------------


!-----------------------------------------------------------------------
!--------------- determine prognostic cloud properties -----------------
 if ( do_strat_cloud() ) then
!-----------------------------------------------------------------------
      
     call strat_cloud_avg (is, js, ql, qi, cf, ierr)

     if (ierr == 0) then
         call cloud_summary (is,js,land,ql,qi,cf,q,pfull, &
                             phalf,t,cosz,tsfc,&
                             nclds,ktop(:,:,2:kp1),kbtm(:,:,2:kp1),  &
                             cldamt(:,:,2:kp1), &
                             Time=Time_diag, &
                             r_uv=cuvrf(:,:,2:kp1), &
                             r_nir=cirrf(:,:,2:kp1), &
                             ab_uv=cuvab(:,:,2:kp1), &
                             ab_nir=cirab(:,:,2:kp1), &
                             em_lw=emcld(:,:,2:kp1))
     endif     

!-----------------------------------------------------------------------
 endif     
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!--------------- determine diagnostic cloud properties -----------------
 if ( do_diag_cloud() ) then
!-----------------------------------------------------------------------
      
     call diag_cloud_avg (is, js, temp,qmix,rh,omega, &
                          lgscldelq,cnvcntq,convprc,ierr)

     psfc(:,:) = phalf(:,:,kp1)
     if (ierr == 0) then
         call diag_cloud_driver (is,js, &
                    temp,qmix,rh,omega,lgscldelq,cnvcntq,convprc, &
                    pfull,phalf,psfc,cosz,lat,Time, &
                    nclds,ktop(:,:,2:kp1),kbtm(:,:,2:kp1), &
                    cldamt(:,:,2:kp1),cuvrf(:,:,2:kp1),  &
                    cirrf(:,:,2:kp1),cuvab(:,:,2:kp1),  &
                    cirab(:,:,2:kp1),emcld(:,:,2:kp1) )
!                    cirab(:,:,2:kp1),emcld(:,:,2:kp1) ,kbot)
     endif     

!-----------------------------------------------------------------------
 endif     
!-----------------------------------------------------------------------


!-----------------------------------------------------------------------
!  ----------- zonal or observed clouds ??? --------------
!  (also do if avg cloud properties could not be returned)
!-----------------------------------------------------------------------
 if ( (do_zonal_clouds .or. do_obs_clouds) .and. ierr /= 0  ) then
!-----------------------------------------------------------------------

!    ---- constrain phalf to:  0. <= phalf <= 101325. ----
      if (present(kbot)) then
         do k=1,kx+1; do j=1,size(phalf,2); do i=1,size(phalf,1)
            kb=kbot(i,j)
            phaf(i,j,k)=101325.*phalf(i,j,k)/phalf(i,j,kb+1)
         enddo; enddo; enddo
      else
         do k=1,kx+1
            phaf(:,:,k)=101325.*phalf(:,:,k)/phalf(:,:,kx+1)
         enddo
      endif

!   ---- get three cloud levels (store in k=2,4) -----

      call cloud_zonal (Time, lat, phaf, nclds,  &
                        ktopsw(:,:,2:4), kbtmsw(:,:,2:4), &
                        ktoplw(:,:,2:4), kbtmlw(:,:,2:4), &
                        cldamt(:,:,2:4), cuvrf(:,:,2:4),  &
                        cirrf(:,:,2:4), cirab(:,:,2:4),  &
                        emcld(:,:,2:4))

      if (do_obs_clouds) call cloud_obs (is, js, Time, cldamt(:,:,2:4))

!-----------------------------------------------------------------------
 endif
!-----------------------------------------------------------------------


!----- store longwave and shortwave indices -----

   if ( (do_rh_clouds() .or. do_strat_cloud() .or. do_diag_cloud()) &
        .and. ierr == 0 ) then

         do j=1,size(ktoplw,2)
         do i=1,size(ktoplw,1)
            if (nclds(i,j) > 0) then
               n=nclds(i,j)
               ktoplw(i,j,2:n+1)=ktop(i,j,2:n+1)
               kbtmlw(i,j,2:n+1)=kbtm(i,j,2:n+1)
               ktopsw(i,j,2:n+1)=ktop(i,j,2:n+1)
               kbtmsw(i,j,2:n+1)=kbtm(i,j,2:n+1)+1
            endif
         enddo
         enddo
   endif


!-----------------------------------------------------------------------
!------------------------ diagnostics section --------------------------

!---- total cloud diagnostic ----
      if ( id_tot_cld_amt > 0 ) then
         call compute_tca_random ( nclds, cldamt(:,:,2:kp1), tca )
         used = send_data ( id_tot_cld_amt, tca, Time_diag, is, js )
      endif

!---- high,mid,low cloud diagnostics ----
      if ( id_high_cld_amt > 0 .or. id_mid_cld_amt > 0 .or. &
            id_low_cld_amt > 0 ) then

         if (do_isccp_cloud_diags) then
!           Do alternative (isccp) high,mid,low cloud methodology.            
!           Use methodology adopted from cloudrad_package:

!           Construct the pflux array, which is the flux pressure
!           level midway between the pressure levels in the model
!           where radiation is actually computed.  Add surface
!           pressure as the final vertical level of the 3-D array.
!           The first element of the array is set to zero.
!           The array which uses these is based on cgs units, 
!           so also multiply by 10 to convert from Pa to dynes/cm2.

            if (present(kbot)) then
               call error_mesg ('clouds in clouds_mod', &
                  'compute_isccp_clds not set up/tested on case where kbot is present.',FATAL)
            end if
     
            pflux(:,:,1) = 0.
            do k = 2, kx
               pflux(:,:,k) = 0.5 * (pfull(:,:,k-1)+pfull(:,:,k)) * 10.0
            end do
            pflux(:,:,kp1) = phalf(:,:,kp1) * 10.0  
       
            call expand_cloud (nclds, ktoplw(:,:,2:kp1),kbtmlw(:,:,2:kp1), &
                             cldamt(:,:,2:kp1), cloud )
                             
            call compute_isccp_clds ( pflux, cloud, hml_ca)               

         else
!           Use original methodology contained in this module:            
            call compute_hml_ca_random ( nclds, cldamt(:,:,2:kp1), &
                    kbtmlw(:,:,2:kp1), pfull, phalf, hml_ca, kbot )
         end if           
                    
         if ( id_high_cld_amt > 0 ) used = send_data &
                     ( id_high_cld_amt, hml_ca(:,:,1), Time_diag, is, js )
         if ( id_mid_cld_amt > 0 ) used = send_data &
                      ( id_mid_cld_amt, hml_ca(:,:,2), Time_diag, is, js )
         if ( id_low_cld_amt > 0 ) used = send_data &
                      ( id_low_cld_amt, hml_ca(:,:,3), Time_diag, is, js )
      endif

!------- cloud amount -------------------------
      if ( id_cld_amt > 0 ) then
         call expand_cloud (nclds, ktoplw(:,:,2:kp1),kbtmlw(:,:,2:kp1), &
                             cldamt(:,:,2:kp1), cloud )
         used = send_data ( id_cld_amt, cloud, Time_diag, is, js, 1, &
                            rmask=mask )
      endif

!------- cloud emissivity ---------------------------------------
      if ( id_em_cld > 0 ) then
         call expand_cloud (nclds, ktoplw(:,:,2:kp1),kbtmlw(:,:,2:kp1), &
                             emcld(:,:,2:kp1), cloud )
         used = send_data ( id_em_cld, cloud, Time_diag, is, js, 1, &
                            rmask=mask )
      endif

!------- ultra-violet reflected by cloud -----------------------------
      if ( id_alb_uv_cld > 0 ) then
         call expand_cloud (nclds, ktoplw(:,:,2:kp1),kbtmlw(:,:,2:kp1), &
                             cuvrf(:,:,2:kp1), cloud )
         used = send_data ( id_alb_uv_cld, cloud, Time_diag, is, js, 1, &
                            rmask=mask )
      endif

!------- infra-red reflected by cloud -----------------------------
      if ( id_alb_nir_cld > 0 ) then
         call expand_cloud (nclds, ktoplw(:,:,2:kp1),kbtmlw(:,:,2:kp1), &
                             cirrf(:,:,2:kp1), cloud )
         used = send_data ( id_alb_nir_cld, cloud, Time_diag, is, js, 1, &
                            rmask=mask )
      endif

!------- ultra-violet absorbed by cloud (not implemented)------------
!     if ( id_abs_uv_cld > 0 ) then
!        call expand_cloud (nclds, ktoplw(:,:,2:kp1),kbtmlw(:,:,2:kp1), &
!                            cuvab(:,:,2:kp1), cloud )
!        used = send_data ( id_abs_uv_cld, cloud, Time_diag, is, js, 1, &
!                           rmask=mask )
!     endif

!------- infra-red absorbed by cloud -----------------------------
      if ( id_abs_nir_cld > 0 ) then
         call expand_cloud (nclds, ktoplw(:,:,2:kp1),kbtmlw(:,:,2:kp1), &
                             cirab(:,:,2:kp1), cloud )
         used = send_data ( id_abs_nir_cld, cloud, Time_diag, is, js, 1, &
                            rmask=mask )
      endif

!--------------END OF DIAGNOSTICS --------------------------------------
!-----------------------------------------------------------------------
!---- step mountain clouds in underground levels ----

     if (present(kbot)) call step_mtn_clouds (kx,kbot,              &
                                nclds,ktopsw,kbtmsw,ktoplw,kbtmlw,  &
                                cldamt,cuvrf,cirrf,cirab,emcld)

!-----------------------------------------------------------------------

      end subroutine clouds

!#######################################################################

 subroutine compute_tca_random ( nclds, cldamt, tca )

   integer, intent(in)  :: nclds (:,:)
   real,    intent(in)  :: cldamt(:,:,:)
   real,    intent(out) :: tca   (:,:)

   integer :: k, max_cld

!---- find maximum number of clouds -----

    max_cld = maxval(nclds)

!---- compute total cloud amount assuming that -----
!       independent clouds overlap randomly

    tca = 1.0

    do k = 1, max_cld
       tca(:,:) = tca(:,:) * (1. - cldamt(:,:,k))
    enddo

    tca = (1. - tca) * 100.


 end subroutine compute_tca_random

!#######################################################################

 subroutine compute_hml_ca_random ( nclds, cldamt, kbtm, pfull, phalf, &
                                    hml_ca, kbot )

   integer, intent(in)  :: nclds (:,:), kbtm(:,:,:)
   real,    intent(in)  :: cldamt(:,:,:), pfull(:,:,:), phalf(:,:,:)
   real,    intent(out) :: hml_ca   (:,:,:)
   integer, intent(in), optional :: kbot(:,:)

! hml_ca - array for high, middle and low clouds as per 3rd index values
!          of 1,2 and 3 respectively.

! ---------------------------------------------------------------------

   integer,  parameter :: mid_btm = 7.0e4,high_btm = 4.0e4

! local array
real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) :: pfull_norm
! pfull_norm is normalized pressure at full model levels

   integer :: i, j, k, kx, kb

   kx   = size(pfull,3)

!  calculate normalized presure to allow full range of high middle low 
!  clouds independent of orography

   if (present(kbot)) then
         do k=1,kx+1; do j=1,size(phalf,2); do i=1,size(phalf,1)
            kb=kbot(i,j)
            pfull_norm(i,j,k)=101325.*phalf(i,j,k)/phalf(i,j,kb+1)
         enddo; enddo; enddo
   else
         do k=1,kx
            pfull_norm(:,:,k)=101325.*pfull(:,:,k)/phalf(:,:,kx+1)
         enddo
   endif

!---- compute high, middle and low cloud amounts assuming that -----
!       independent clouds overlap randomly

    hml_ca = 1.0

    do j=1,size(nclds,2)
    do i=1,size(nclds,1)
!   if (nclds(i,j) == 0) cycle

      do k = 1, nclds(i,j)
         if (pfull_norm(i,j,kbtm(i,j,k)) .le. high_btm) then
           hml_ca(i,j,1) = hml_ca(i,j,1) * (1. - cldamt(i,j,k))
         else if ( (pfull_norm(i,j,kbtm(i,j,k)) .le. mid_btm) .and.  &
                   (pfull_norm(i,j,kbtm(i,j,k)) .gt. high_btm) ) then
           hml_ca(i,j,2) = hml_ca(i,j,2) * (1. - cldamt(i,j,k))
         else 
           hml_ca(i,j,3) = hml_ca(i,j,3) * (1. - cldamt(i,j,k))
         endif
      enddo

    enddo
    enddo

    hml_ca = (1. - hml_ca) * 100.


 end subroutine compute_hml_ca_random

!#######################################################################

subroutine compute_isccp_clds ( pflux, cloud, hml_ca)

real,  dimension(:,:,:),   intent(in)  :: pflux, cloud
real,  dimension(:,:,:),   intent(out) :: hml_ca

!
!   define arrays giving the fractional cloudiness for clouds with
!   tops within the ISCCP definitions of high (10-440 hPa), middle
!   (440-680 hPa) and low (680-1000 hPa).
 
!    note that at this point pflux is in cgs units. change this later.

!    This routine is copied from cloudrad_package_mod, where
!    it is private and thus non-accessible from here directly.
!    Modified to work within this routine...
 
! ---------------------------------------------------------------------

   real,  parameter :: mid_btm = 6.8e5,high_btm = 4.4e5
  
! local array

integer :: i, j, k

 
!---- compute high, middle and low cloud amounts assuming that -----
!       independent clouds overlap randomly

    hml_ca = 1.0
    
 
   do j=1, size(cloud,2)
    do i=1, size(cloud,1)
      do k = 1, size(cloud,3)
        if (pflux(i,j,k)  <=  high_btm) then
          hml_ca(i,j,1) = hml_ca(i,j,1) * (1. - cloud(i,j,k))
        else if ( (pflux(i,j,k) >  high_btm) .and.  &
           (pflux(i,j,k) <=  mid_btm) ) then
         hml_ca(i,j,2) = hml_ca(i,j,2) * (1. - cloud(i,j,k))
       else  if ( pflux(i,j,k) > mid_btm ) then
         hml_ca(i,j,3) = hml_ca(i,j,3) * (1. - cloud(i,j,k))
       endif
    enddo
  enddo
  enddo

    hml_ca = 1. - hml_ca
    hml_ca = 100. * hml_ca
  
end subroutine compute_isccp_clds
!#######################################################################

      subroutine default_clouds (nclds,ktopsw,kbtmsw,ktop,kbtm,  &
                                 cldamt,cuvrf,cirrf,cuvab,cirab,emcld)

!----------------------------------------------------------------------
   integer, intent(inout), dimension(:,:)   :: nclds
   integer, intent(inout), dimension(:,:,:) :: ktopsw,kbtmsw,ktop,kbtm
      real, intent(inout), dimension(:,:,:) :: cldamt,cuvrf,cirrf,  &
                                               cuvab,cirab,emcld
!----------------------------------------------------------------------
      integer  kp1

      kp1=size(ktopsw,3)

      nclds(:,:)=0

      cldamt=0.0; emcld =1.0
      cuvrf =0.0; cirrf =0.0; cuvab =0.0; cirab =0.0
      ktopsw=kp1; kbtmsw=kp1
!     ktop  =kp1; kbtm  =kp1
      ktop  =kp1-1; kbtm  =kp1-1
!     ---- reset top properties ----
      ktopsw(:,:,1)=1
      kbtmsw(:,:,1)=0
      ktop  (:,:,1)=1
      kbtm  (:,:,1)=0

!----------------------------------------------------------------------

      end subroutine default_clouds

!#######################################################################

      subroutine step_mtn_clouds (kmax,kbot,nclds,  &
                                  ktopsw,kbtmsw,ktop,kbtm,  &
                                  cldamt,cuvrf,cirrf,cirab,emcld)

!-----------------------------------------------------------------------
   integer, intent(in)                      :: kmax
   integer, intent(in),    dimension(:,:)   :: kbot
   integer, intent(inout), dimension(:,:)   :: nclds
   integer, intent(inout), dimension(:,:,:) :: ktopsw,kbtmsw,ktop,kbtm
      real, intent(inout), dimension(:,:,:) :: cldamt,cuvrf,cirrf,  &
                                                      cirab,emcld
!-----------------------------------------------------------------------
   integer  i,j,n,kp1

   kp1=kmax+1

         do j=1,size(kbot,2)
         do i=1,size(kbot,1)
            if (kbot(i,j) < kmax) then
               nclds(i,j)=nclds(i,j)+1
               n=nclds(i,j)+1
               ktopsw(i,j,n)=kbot(i,j)+1
               kbtmsw(i,j,n)=kp1
               ktop  (i,j,n)=kbot(i,j)+1
               kbtm  (i,j,n)=kmax
               cldamt(i,j,n)=1.0
               cuvrf (i,j,n)=0.0
               cirrf (i,j,n)=0.0
               cirab (i,j,n)=0.0
               emcld (i,j,n)=1.0
            endif
         enddo
         enddo

!-----------------------------------------------------------------------

      end subroutine step_mtn_clouds

!#######################################################################

      subroutine remove_cloud_overlap (nclds,ktop,kbtm)

!-----------------------------------------------------------------------
   integer, intent(in),    dimension(:,:)   :: nclds
   integer, intent(inout), dimension(:,:,:) :: ktop,kbtm
!-----------------------------------------------------------------------
!                   removes sw cloud overlap
!
!    nclds = number of clouds
!    ktop  = sw indice for cloud top
!    kbtm  = sw indice for cloud bottom
!
!-----------------------------------------------------------------------
   integer  i,j,kc

         do j=1,size(nclds,2)
         do i=1,size(nclds,1)
            if (nclds(i,j) <= 1) cycle

            do kc=2,nclds(i,j)
               if (ktop(i,j,kc+1) >= kbtm(i,j,kc)) cycle
!    case 1: thin or thick upper cloud, thick lower cloud
                  if (ktop(i,j,kc+1) <  kbtm(i,j,kc+1)) then
                     ktop(i,j,kc+1)=ktop(i,j,kc+1)+1
                  else
!    case 2: thick upper cloud, thin lower cloud
                     kbtm(i,j,kc)=kbtm(i,j,kc)-1
                  endif
            enddo

         enddo
         enddo

!-----------------------------------------------------------------------

      end subroutine remove_cloud_overlap

!#######################################################################

      subroutine expand_cloud ( nclds, ktop, kbtm, cloud_in, cloud_out )

      integer, intent(in)  :: nclds(:,:), ktop(:,:,:), kbtm(:,:,:)
      real,    intent(in)  :: cloud_in (:,:,:)
      real,    intent(out) :: cloud_out(:,:,:)

      integer :: i, j, n

         cloud_out = 0.0
         do j=1,size(nclds,2)
         do i=1,size(nclds,1)
            do n=1,nclds(i,j)
              cloud_out(i,j,ktop(i,j,n):kbtm(i,j,n)) = cloud_in(i,j,n)
            enddo
         enddo
         enddo

      end subroutine expand_cloud

!#######################################################################

      subroutine clouds_init ( lonb, latb, axes, Time )

!-----------------------------------------------------------------------
           real, intent(in), dimension(:,:) :: lonb, latb
        integer, intent(in), dimension(4) :: axes
type(time_type), intent(in)               :: Time
!-----------------------------------------------------------------------
      integer  unit,io,ierr, logunit

!-------------- read namelist --------------

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=clouds_nml, iostat=io)
      ierr = check_nml_error(io,"clouds_nml")
#else
      if ( file_exist('input.nml')) then
         unit = open_namelist_file ()
         ierr=1; do while (ierr /= 0)
            read  (unit, nml=clouds_nml, iostat=io, end=10)
            ierr = check_nml_error(io,'clouds_nml')
         enddo
  10     call close_file (unit)
      endif
#endif

!      ----- write namelist -----

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
           logunit = stdlog()
           write (logunit, nml=clouds_nml)
      endif


      if (do_obs_clouds) call cloud_obs_init (lonb, latb)

!------------ initialize diagnostic fields -----------------------------

      call diag_field_init ( Time, axes )

!-----------------------------------------------------------------------
       if (do_strat_cloud() ) then
         call cloud_rad_init
       endif

      module_is_initialized =.true.

!-----------------------------------------------------------------------

      end subroutine clouds_init

!#######################################################################

      subroutine clouds_end

!-----------------------------------------------------------------------

      module_is_initialized =.false.

!-----------------------------------------------------------------------

      end subroutine clouds_end

!#######################################################################

   subroutine diag_field_init ( Time, axes )

     type(time_type), intent(in) :: Time
     integer        , intent(in) :: axes(4)

!-----------------------------------------------------------------------

    id_tot_cld_amt = &
    register_diag_field ( mod_name, 'tot_cld_amt', axes(1:2), Time, &
                         'total cloud amount', 'percent'            )

    id_high_cld_amt = &
    register_diag_field ( mod_name, 'high_cld_amt', axes(1:2), Time, &
                         'high cloud amount', 'percent'            )

    id_mid_cld_amt = &
    register_diag_field ( mod_name, 'mid_cld_amt', axes(1:2), Time, &
                         'mid cloud amount', 'percent'            )

    id_low_cld_amt = &
    register_diag_field ( mod_name, 'low_cld_amt', axes(1:2), Time, &
                         'low cloud amount', 'percent'            )

    id_cld_amt = &
    register_diag_field ( mod_name, 'cld_amt', axes(1:3), Time, &
                         'cloud amount', 'percent',             &
                         missing_value=missing_value            )

    id_em_cld = &
    register_diag_field ( mod_name, 'em_cld', axes(1:3), Time, &
                         'cloud emissivity', 'none',           &
                          missing_value=missing_value          )

    id_alb_uv_cld = &
    register_diag_field ( mod_name, 'alb_uv_cld', axes(1:3), Time, &
                         'UV reflected by cloud', 'none',          &
                          missing_value=missing_value              )

    id_alb_nir_cld = &
    register_diag_field ( mod_name, 'alb_nir_cld', axes(1:3), Time, &
                         'IR reflected by cloud', 'none',           &
                          missing_value=missing_value               )

!   --- do not output this field ---
!   id_abs_uv_cld = &
!   register_diag_field ( mod_name, 'abs_uv_cld', axes(1:3), Time, &
!                        'UV absorbed by cloud', 'none',           &
!                         missing_value=missing_value              )

    id_abs_nir_cld = &
    register_diag_field ( mod_name, 'abs_nir_cld', axes(1:3), Time, &
                         'IR absorbed by cloud', 'none',            &
                          missing_value=missing_value               )

!-----------------------------------------------------------------------

   end subroutine diag_field_init

!#######################################################################

end module clouds_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: Some algebraic length-scale relations \label{sec:algebraiclength}
!
! !INTERFACE:
   subroutine algebraiclength(method,nlev,z0b,z0s,depth,h,NN)
!
! !DESCRIPTION:
! This subroutine computes the vertical profile of the turbulent
! scale $l$ from different types of analytical expressions. These
! range from simple geometrical forms to more complicated expressions
! taking into account the effects of stratification and shear. The
! users can select their method in the input file {\tt gotmturb.nml}.
! For convenience, we define here $d_b$ and $d_s$ as the distance
! from the bottom and the surface, respectively. The water
! depth is then given by $H=d_b+d_s$, and $z_0^b$ and
! $z_0^s$ are the repective roughness lengths. With these
! abbreviations, the expressions implemented in GOTM are as follows.
! \begin{enumerate}
!  \item The parabolic profile is defined according to
!    \begin{equation}
!      l=\kappa \frac{(d_s+z_0^s) (d_b+z_0^b)}
!                    {d_s+d_b+z_0^b+z_0^s}
!    \comma
!    \end{equation}
!    where it should be noted that only for large water depth
!    this equation converges to $\kappa(z+z_0)$ near the bottom
!   or near the surface.
!  \item The triangular profile is defined according to
!    \begin{equation}
!       l = \kappa \, \min(d_s+z_0^s,d_b+z_0^b)
!    \comma
!    \end{equation}
!    which converges always to $\kappa(z+z_0)$ near the bottom
!   or near the surface.
!  \item A distorted parabola can be constructed by
!     using a slightly modified form of the equation
!     used by \cite{XingDavies95},
!     \begin{equation}
!        l = \kappa \frac{(d_s+z_0^s)(d_b^\text{Xing}+z_0^b)}
!                      {d_s+d_b^\text{Xing}+z_0^s+z_0^b}
!        \comma
!        d_b^\text{Xing} =
!        d_b \exp{\left(-\beta \frac{d_b}{H} \right)}
!    \comma
!    \end{equation}
!    where it should be noted that only for large water depth
!    this equation converges to $\kappa(z+z_0)$ near the bottom
!   or near the surface. The constant $\beta$ is a form parameter
!   determining the distortion of the profile. Currently we use
!   $\beta = 2$ in GOTM.
!  \item A distorted parabola can be constructed by
!     using a slightly modified form of the equation
!     used by \cite{RobertOuellet87},
!    \begin{equation}
!       l = \kappa (d_b+z_0^b)
!           \sqrt{1-\frac{d_b-z_0^s}{H}}
!    \comma
!   \end{equation}
!    where it should be noted that only for large water depth
!    this equation converges to $\kappa(z+z_0)$ near the bottom.
!    Near the surface, the slope of $l$ is always different from
!    the law of the wall, a fact that becomes important when model
!    solutions for the case of breaking waves are computed, see
!    \sect{sec:analyse}.
!  \item Also the famous formula of \cite{Blackadar62} is based on
!     a parabolic shape, extended by an extra length--scale $l_a$.
!    Using the form of \cite{Luytenetal96}, the algebraic relation
!    is expressed by
!     \begin{equation}
!        l = \left( \frac{1}{\kappa (d_s+z_0^s)}
!                  +\frac{1}{\kappa (d_b+z_0^b)}
!                  +\dfrac{1}{l_a} \right)
!    \comma
!     \end{equation}
!    where
!   \begin{equation}
!        l_a = \gamma_0 \frac{\int_{-H}^\eta k^\frac{1}{2} z dz}
!                            {\int_{-H}^\eta k^\frac{1}{2} dz}
! \end{equation}
!    is the natural kinetic energy scale resulting from the
!    first moment of the rms turbulent velocity. The constant
!    $\gamma_0$ usually takes the value $\gamma_0 = 0.2$.
!    It should be noted that this expression for $l$
!    converges to $\kappa(z+z_0)$ at the surface and the bottom
!    only for large water depth, and when $l_a$ plays only a
!    minor role.
!  \item The so--called ISPRAMIX method to compute the length--scale
!   is described in detail in \sect{sec:ispramix}.
! \end{enumerate}
! After the length--scale has been computed, it is optionally
! limited by the method suggested by \cite{Galperinetal88}. This
! option can be activated in {\tt gotmturb.nml} by setting
! {\tt length\_lim = .true.} The rate of dissipation is computed
! according to \eq{epsilon}.
!
! !USES:
   use turbulence, only: L,eps,tke,k_min,eps_min
   use turbulence, only: cde,galp,kappa,length_lim
   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  type of length scale
   integer,  intent(in)                :: method

!  number of vertical layers
   integer,  intent(in)                :: nlev

!  surface and bottom roughness (m)
   REALTYPE, intent(in)                :: z0b,z0s

!  local depth (m)
   REALTYPE, intent(in)                :: depth

!  layer thicknesses (m)
   REALTYPE, intent(in)                :: h(0:nlev)

!  buoyancy frequency (1/s^2)
   REALTYPE, intent(in)                :: NN(0:nlev)
!
! !DEFINED PARAMETERS:
   integer, parameter                  :: Parabola=1
   integer, parameter                  :: Triangle=2
   integer, parameter                  :: Xing=3
   integer, parameter                  :: RobertOuellet=4
   integer, parameter                  :: Blackadar=5
   integer, parameter                  :: ispra_length=7
!
! !REVISION HISTORY:
!  Original author(s):  Manuel Ruiz Villarreal, Hans Burchard
!
!  $Log: algebraiclength.F90,v $
!  Revision 20.0  2013/12/14 00:13:26  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.7  2007-01-06 11:49:15  kbk
!  namelist file extension changed .inp --> .nml
!
!  Revision 1.6  2005/11/15 11:35:02  lars
!  documentation finish for print
!
!  Revision 1.5  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.4  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.3  2003/03/10 09:02:03  gotm
!  Added new Generic Turbulence Model +
!  improved documentation and cleaned up code
!
!  Revision 1.2  2002/02/08 08:59:58  gotm
!
!  Revision 1.1.1.1  2001/02/12 15:55:58  gotm
!  initial import into CVS
!
!EOP
!-----------------------------------------------------------------------
! !LOCAL VARIABLES:
   integer                 :: i
   REALTYPE                :: ds,db,dbxing
   REALTYPE                :: beta,gamma,La,int_qz,int_q
   REALTYPE                :: Lcrit,L_min
!
!-----------------------------------------------------------------------
!BOC
!
! distance from bottom and surface initialised
   db=_ZERO_
   ds=_ZERO_
!
! parabolic shape
   select case (method)

      case(parabola)

         do i=1,nlev-1
            db=db+h(i)
            ds=depth-db
            L(i)=kappa*(ds+z0s)*(db+z0b)/(ds+db+z0b+z0s)
         end do

         L(0)    = kappa*z0b
         L(nlev) = kappa*z0s
!
! triangular shape

      case(triangle)
         do i=1,nlev-1
            db=db+h(i)
            ds=depth-db
            L(i)=kappa*min(ds+z0s,db+z0b)
         end do

         L(0)    = kappa*z0b
         L(nlev) = kappa*z0s
!
! modified Xing and Davies (1995)
! modification of parabolic mixing length
      case(Xing)
         beta = 2. ! a tuning parameter
         do i=1,nlev-1
           db=db+h(i)
           ds=depth-db
           ! lu changed a bug in here
           dbxing=db*exp(-beta*db/depth)
           L(i)=kappa*(ds+z0s)*(dbxing+z0b)/(ds+dbxing+z0s+z0b)
         end do

         L(0)    = kappa*z0b
         L(nlev) = kappa*z0s
!
! modified Robert and Ouellet(1987)
! modification of parabolic mixing length
      case(RobertOuellet)
         do i=1,nlev-1
           db=db+h(i)
           ds=depth-db
           ! lu changed a bug in here
           L(i)= kappa*(db+z0b)*sqrt(1-(db-z0s)/depth)
         end do

         L(0)    = kappa*z0b
         L(nlev) = kappa*(depth+z0b)*sqrt(z0s/depth) ! no log-law (!)
!
! Blackadar (1962).
! In the form suggested by Luyten et al. (1996) for two boundary layers.
      case(Blackadar)
         int_qz   = 0.
         int_q    = 0.

         do i=1,nlev-1
            db=db+h(i)
            ! compute the first moment turbulent velocity
            int_qz = int_qz + sqrt(tke(i))*(db+z0b)*h(i)
            ! compute vertically averaged turbulent velocity
            int_q  = int_q  + sqrt(tke(i))*h(i)
         end do

         gamma=0.2               ! an empirical factor
         La=gamma*int_qz/int_q   ! free turbulence length-scale

         db=0.0
         do i=1,nlev-1
            db=db+h(i)
            ds=depth-db
             L(i)=1/(1/(kappa*(ds+z0s))+1/(kappa*(db+z0b))+1/La)
         end do

         L(0)    = kappa*z0b
         L(nlev) = kappa*z0s
!
!  Ispramix
      case(ispra_length)
         call ispralength(nlev,NN,h,depth)

         L(0)    = kappa*z0b
         L(nlev) = kappa*z0s

      case default
   end select

   do i=0,nlev

!     clip the length-scale at the Galperin et al. (1988) value
!     under stable stratifcitation
      if ((NN(i).gt.0).and.(length_lim)) then
         Lcrit=sqrt(2*galp*galp*tke(i)/NN(i))
         if (L(i).gt.Lcrit) L(i)=Lcrit
      end if

!     compute the dissipation rate
      eps(i)=cde*sqrt(tke(i)*tke(i)*tke(i))/L(i)

     ! substitute minimum value
      if (eps(i).lt.eps_min) then
         eps(i) = eps_min
         L(i) = cde*sqrt(tke(i)*tke(i)*tke(i))/eps_min
      endif

   end do

   return
   end subroutine algebraiclength
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module ocean_util_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Matt Harrison 
!</CONTACT>
!
!<CONTACT EMAIL="Tim.Leslie@gmail.com"> Tim Leslie 
!</CONTACT>
!
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
! </REVIEWER>
!
!<OVERVIEW>
! This module contains many routines of use for MOM. 
!</OVERVIEW>
!
!<DESCRIPTION>
! A utility module for MOM. 
!</DESCRIPTION>
!

#define COMP isc:iec,jsc:jec

use platform_mod,        only: i8_kind
use constants_mod,       only: epsln
use diag_manager_mod,    only: send_data, register_diag_field 
use mpp_domains_mod,     only: mpp_update_domains, mpp_global_sum, NON_BITWISE_EXACT_SUM
use mpp_mod,             only: stdout, stdlog, FATAL
use mpp_mod,             only: mpp_error, mpp_pe, mpp_root_pe, mpp_min, mpp_max, mpp_chksum
use time_manager_mod,    only: time_type, get_date

use ocean_domains_mod,    only: get_local_indices
use ocean_parameters_mod, only: missing_value
use ocean_types_mod,      only: ocean_domain_type, ocean_grid_type, ocean_density_type
use ocean_types_mod,      only: ocean_thickness_type, ocean_time_type

implicit none

private

character(len=256) :: version='CVS $Id'
character(len=256) :: tagname='Tag $Name'

! for output
integer :: unit=6

#include <ocean_memory.h>

type(ocean_domain_type), pointer :: Dom =>NULL()

public iplot
public matrix
public ocean_util_init
public invtri
public invtri_bmf
public write_timestamp
public write_note
public write_warning
public write_line
public write_chksum_header
public write_chksum_2d
public write_chksum_2d_int
public write_chksum_3d
public write_chksum_3d_int
public check_restart
public write_summary

public diagnose_2d
public diagnose_2d_u
public diagnose_2d_en
public diagnose_2d_int
public diagnose_2d_comp
public diagnose_3d
public diagnose_3d_u
public diagnose_3d_en
public diagnose_3d_int
public diagnose_3d_comp
public diagnose_sum
public register_2d_t_field
public register_3d_t_field
public register_3d_xte_field
public register_3d_ytn_field
public register_3d_ztb_field



contains


!#######################################################################
! <SUBROUTINE NAME="ocean_util_init">
!
! <DESCRIPTION>
! Initialize MOM utilities.
! </DESCRIPTION>
!
subroutine ocean_util_init (Domain, Grid)
  type(ocean_domain_type), intent(in), target :: Domain
  type(ocean_grid_type),   intent(in)         :: Grid
  integer :: stdlogunit

  stdlogunit=stdlog()

  write( stdlogunit,'(/a/)') trim(version)

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk=Grid%nk
#endif

  Dom => Domain

end subroutine ocean_util_init
! </SUBROUTINE> NAME="ocean_util_init">


!#######################################################################
! <SUBROUTINE NAME="invtri">
!
! <DESCRIPTION>
! Solve the vertical diffusion equation implicitly using the
! method of inverting a tridiagonal matrix as described in
! Numerical Recipes in Fortran, The art of Scientific Computing,
! Second Edition, Press, Teukolsky, Vetterling, Flannery, 1992
! pages 42,43.
!
! This routine assumes that the variables are defined at grid points,
! and the top and bottom b.c. are flux conditions.
!
! inputs:
!
! z         = right hand side terms
!
! nk        = number of vertical levels
!
! topbc     = top boundary condition
!
! botbc     = bottom boundary condition
!
! dcb       = vertical mixing coeff at base of cell
!
! tdt       = timestep over which do implicit update
!
! kmz       = level indicator
!
! mask      = land/sea mask
!
! outputs:
!
! z         = returned solution
!
! </DESCRIPTION>
!
subroutine invtri (z, topbc, botbc, dcb, tdt, kmz, mask, dh, dhw, aidif, nk)

  integer, intent(in)                             :: nk
  real, intent(inout), dimension(isd:,jsd:,:)     :: z
  real, intent(in), dimension(isd:,jsd:,:)        :: dcb
  real, intent(in), dimension(isd:,jsd:,:)        :: dh
  real, intent(in), dimension(isd:,jsd:,:)        :: mask
  real, intent(in), dimension(isd:,jsd:,0:)       :: dhw
  real, intent(in), dimension(isd:,jsd:)          :: topbc
  real, intent(in), dimension(isd:,jsd:)          :: botbc
  real, intent(in)                                :: tdt
  integer, intent(in), dimension(isd:ied,jsd:jed) :: kmz
  real, intent(in)                                :: aidif

  real, dimension(isd:ied,0:nk) :: a, b, c, e, f
  real, dimension(isd:ied) :: bet

  integer :: i, j, k, km1, kp1
  real :: eps, factu, factl, tdt_aidif

  eps = 1.e-30
  tdt_aidif = tdt*aidif
  do j=jsc,jec
    do k=1,nk
      km1   = max(1,k-1)
      kp1   = min(k+1,nk)
      do i=isc,iec
        factu  = tdt_aidif/(dhw(i,j,k-1)*dh(i,j,k))
        factl  = tdt_aidif/(dhw(i,j,k)*dh(i,j,k))
        a(i,k) = -dcb(i,j,km1)*factu*mask(i,j,k)
        c(i,k) = -dcb(i,j,k)*factl*mask(i,j,kp1)
        f(i,k) = z(i,j,k)*mask(i,j,k) 
        b(i,k) = 1.0 - a(i,k) - c(i,k)
      enddo
    enddo

    do i=isc,iec
      a(i,1)  = 0.0
      c(i,nk) = 0.0
      b(i,1)  = 1.0 - a(i,1) - c(i,1)
      b(i,nk) = 1.0 - a(i,nk) - c(i,nk)

      ! top and bottom b.c.
      f(i,1)  = z(i,j,1) + topbc(i,j)*tdt_aidif*mask(i,j,1)/dh(i,j,1)
      k = max(2,kmz(i,j))
      f(i,k)  = z(i,j,k) - botbc(i,j)*tdt_aidif*mask(i,j,k)/dh(i,j,k)
    enddo

    ! decomposition and forward substitution
    do i=isc,iec
      bet(i)   = mask(i,j,1)/(b(i,1) + eps)
      z(i,j,1) = f(i,1)*bet(i)
    enddo
    do k=2,nk
      do i=isc,iec
        e(i,k)   = c(i,k-1)*bet(i)
        bet(i)   = mask(i,j,k)/(b(i,k) - a(i,k)*e(i,k) + eps)
        z(i,j,k) = (f(i,k) - a(i,k)*z(i,j,k-1))*bet(i)
      enddo
    enddo

    ! back substitution
    do k=nk-1,1,-1
      do i=isc,iec
        z(i,j,k) = z(i,j,k) - e(i,k+1)*z(i,j,k+1)
      enddo
    enddo
  enddo

end subroutine invtri
! </SUBROUTINE> NAME="invtri">


!#######################################################################
! <SUBROUTINE NAME="invtri_bmf">
!
! <DESCRIPTION>
! Solve the vertical friction equation implicitly using the
! method of inverting a tridiagonal matrix as described in
! Numerical Recipes in Fortran, The art of Scientific Computing,
! Second Edition, Press, Teukolsky, Vetterling, Flannery, 1992
! pages 42,43.
!
! This routine assumes that the variables are defined at grid points,
! and the top b.c. is a flux condition.  The bottom b.c. is assumed
! to be a bottom drag which is implemented implicitly, thus allowing
! for large values of the bottom drag coefficient. 
!
! NOTE: This routine is generally only called when doing the bmf 
! implicitly in time.  The original invtri is used for explicit
! bmf.  
!
! inputs:
!
! z         = right hand side terms
!
! nk        = number of vertical levels
!
! topbc     = top boundary condition
!
! botbc     = time explicit bottom boundary condition (zero in this routine, since bmf is implicit) 
!
! gamma     = botttom drag factor scaling the u(taup1) contribution to bottom drag 
! 
! dcb       = vertical mixing coeff at base of cell
!
! tdt       = timestep over which do implicit update
!
! kmz       = level indicator
!
! mask      = land/sea mask
!
! outputs:
!
! z         = returned solution
!
! </DESCRIPTION>
!
subroutine invtri_bmf (z, topbc, gamma, dcb, tdt, kmz, mask, dh, dhw, aidif, nk)

  integer, intent(in)                             :: nk
  real, intent(inout), dimension(isd:,jsd:,:)     :: z
  real, intent(in), dimension(isd:,jsd:)          :: gamma
  real, intent(in), dimension(isd:,jsd:,:)        :: dcb
  real, intent(in), dimension(isd:,jsd:,:)        :: dh
  real, intent(in), dimension(isd:,jsd:,:)        :: mask
  real, intent(in), dimension(isd:,jsd:,0:)       :: dhw
  real, intent(in), dimension(isd:,jsd:)          :: topbc
  real, intent(in)                                :: tdt
  integer, intent(in), dimension(isd:ied,jsd:jed) :: kmz
  real, intent(in)                                :: aidif

  real, dimension(isd:ied,0:nk) :: a, b, c, e, f
  real, dimension(isd:ied) :: bet

  integer :: i, j, k, km1, kp1
  real :: eps, factu, factl, tdt_aidif

  eps = 1.e-30
  tdt_aidif = tdt*aidif
  do j=jsc,jec
    do k=1,nk
      km1   = max(1,k-1)
      kp1   = min(k+1,nk)
      do i=isc,iec
        factu  = tdt_aidif/(dhw(i,j,k-1)*dh(i,j,k))
        factl  = tdt_aidif/(dhw(i,j,k)*dh(i,j,k))
        a(i,k) = -dcb(i,j,km1)*factu*mask(i,j,k)
        c(i,k) = -dcb(i,j,k)*factl*mask(i,j,kp1)
        f(i,k) = z(i,j,k)*mask(i,j,k) 
        b(i,k) = 1.0 - a(i,k) - c(i,k)
      enddo
    enddo

    do i=isc,iec

      a(i,1)  = 0.0
      c(i,nk) = 0.0
      b(i,1)  = 1.0 - a(i,1)  - c(i,1)
      b(i,nk) = 1.0 - a(i,nk) - c(i,nk)

      ! top and bottom b.c.
      f(i,1)  = z(i,j,1)  + topbc(i,j)*tdt_aidif*mask(i,j,1)/dh(i,j,1)
      k = max(2,kmz(i,j))
      f(i,k)  = z(i,j,k)
      c(i,k)  = 0.0
      b(i,k)  = 1.0 - a(i,k) - c(i,k) + gamma(i,j)*tdt_aidif*mask(i,j,k)/dh(i,j,k)
    enddo

    ! decomposition and forward substitution
    do i=isc,iec
      bet(i)   = mask(i,j,1)/(b(i,1) + eps)
      z(i,j,1) = f(i,1)*bet(i)
    enddo
    do k=2,nk
      do i=isc,iec
        e(i,k)   = c(i,k-1)*bet(i)
        bet(i)   = mask(i,j,k)/(b(i,k) - a(i,k)*e(i,k) + eps)
        z(i,j,k) = (f(i,k) - a(i,k)*z(i,j,k-1))*bet(i)
      enddo
    enddo

    ! back substitution
    do k=nk-1,1,-1
      do i=isc,iec
        z(i,j,k) = z(i,j,k) - e(i,k+1)*z(i,j,k+1)
      enddo
    enddo
  enddo

end subroutine invtri_bmf
! </SUBROUTINE> NAME="invtri_bmf">


!#######################################################################
! <SUBROUTINE NAME="iplot">
!
! <DESCRIPTION>
!
!  map integer array "iarray" into characters for printing with
!  format (a1) to provide a contour map of the integer field.
!  note: max number of unique characters = 80
!
! inputs:
!
! iarray = integer array to be plotted
!
! is     = starting index along inner dimension of "iarray"
!
! ie     = ending index along inner dimension of "iarray"
!
! js     = starting index along outer dimension of "iarray"
!
! je     = ending index along outer dimension of "iarray"
!
! output: prints contour map of "iarray"
!
! </DESCRIPTION>
!
subroutine iplot (iarray, is, ie, js, je, ni, nj)
  
  integer, intent(in) :: is, ie, js, je, ni, nj
  integer, intent(in), dimension(ni,nj) ::  iarray
  character*80 levels
  character*80 lev1
  integer :: i, j, il, jl, l, incr, ii, jj, inc, last, jinc, maxint, minint
  save levels
  integer :: stdoutunit 
  stdoutunit=stdout() 

  write (stdoutunit,*) ' '

  ! set character markers
  lev1(1:51) = '.+*ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuv'
  levels = lev1(1:51)//'wxyz0123456789-=!@#$%<>[]{}()'

  ! find range of integers
  maxint = iarray(is,js)
  minint = iarray(is,js)
  do j=js,je
    do i=is,ie
      maxint = max(maxint,iarray(i,j))
      minint = min(minint,iarray(i,j))
    enddo
  enddo

  ! show mapping of integers into characters
  write (stdoutunit,*) ' '
  write (stdoutunit,*) ' "iplot" mapping of integers to characters is as follows:'
  inc  = 3
  last = min(minint+80-1,maxint) 
  do i=minint,last,inc
    ii = i-minint+1
    if (i+inc <= last) then
      jinc = inc
    else
      jinc = last-i+1
    endif
    write (stdoutunit,'(6(1x,i6,a,a,3x))')  (j+minint-1,' is printed as ',levels(j:j),j=ii,ii+jinc-1)
  enddo
  write (stdoutunit,*) ' '

  if (maxint - minint + 1 > 80) then
    write (stdoutunit,*) ' Note: there are ',maxint-minint+1,' integers in the field'
    write (stdoutunit,*) '       "iplot" cannot uniquely assign more than 80 characters for plotting symbols.'
    write (stdoutunit,*) '       therefore integers are represented by cyclicly reusing the list of plotting symbols'
    write (stdoutunit,*) ' '
  endif

  ! print character representation of integers
  inc=124
  il = ie-is+1
  jl = je-js+1
  do l=0,il,inc
    incr = min(inc,il-l)
    write (stdoutunit,8800) (l+i,i=1,incr,4)
    do jj=1,jl
      j = jl+1-jj
      write (stdoutunit,8900) j, (levels(mod(iarray(l+i+is-1,j+js-1)-minint+1-1,80)+1:&
             mod(iarray(l+i+is-1,j+js-1)-minint+1-1,80)+1),i=1,incr) 
    enddo
  enddo
  8800  format (/, 2x, 31i4)
  8900  format (1x,i3,1x, 124a1)

end subroutine iplot
! </SUBROUTINE> NAME="iplot">


!#######################################################################
! <SUBROUTINE NAME="matrix">
!
! <DESCRIPTION>
! matrix is a general two-dimensional array printing routine,
! input:
!
! array = the array to be printed
!
! istrt = the 1st element of the 1st dimension to be printed
!
! im    = the last element of the 1st dimension to be printed
!
! jstrt = the 1st element of the 2nd dimension to be printed
!
! jm    = the last element of the 2nd dimension to be printed
!         the 2nd dimension is printed in reverse order if both
!         jstrt and jm are negative
!
! scale = a scaling factor by which array is divided before
!         printing.  (if this is zero, no scaling is done.)
!         if scale=0, 10 columns are printed across in e format
!         if scale>0, 20 columns are printed across in f format
!
! output: print "array" as a matrix
!
! </DESCRIPTION>
!
subroutine matrix (array, istrt, im, jstrt, jm, scale)

  integer :: i, l, istrt, im, jstrt, jm, is, ie, js, je, jinc, unit
  real, dimension(istrt:im,abs(jstrt):abs(jm)) ::  array
  real :: scale, scaler

  unit = 6
  if (jstrt*jm < 0) then
    write (unit,999)  jstrt, jm
    call mpp_error(FATAL,'==>Error in ocean_util_mod (matrix): jstrt*jm < 0 found in matrix')
  endif

  ! allow for inversion of 2nd dimension
  if (jm < 0) then
    js   = -jm
    je   = -jstrt
    jinc = -1
  else
    js   = jstrt
    je   = jm
    jinc = 1
  endif

  if (scale == 0.0) then

    do is=istrt,im,10
      ie = min(is + 9,im)
      write (unit,9001) (i, i=is,ie)
      do l=js,je,jinc
        write (unit,9002) l, (array(i,l),i=is,ie)
      enddo
      write (unit,'(/)')
    enddo
  else
    scaler = 1.0/scale
    do is=istrt,im,20
      ie = min(is + 19,im)
      write (unit,9003) (i, i=is,ie)
      do l=js,je,jinc
        write (unit,9004) l, (array(i,l)*scaler,i=is,ie)
      enddo
      write (unit,'(/)')
    enddo
  endif
  999   format (1x,'jstrt=',i5,' jm=',i5,' in matrix')
  9001  format(10i13)
  9002  format(i3,10(1pe13.5))
  9003  format(3x,20i6)
  9004  format(1x,i3,1x,20f6.2)

end subroutine matrix
! </SUBROUTINE> NAME="matrix">


!#######################################################################
! <SUBROUTINE NAME="write_timestamp">
!
! <DESCRIPTION>
! Write the time stamp.
! </DESCRIPTION>
!
subroutine write_timestamp(Time)

  type(time_type), intent(in) :: Time
  integer :: yr, mon, day, hr, min, sec
  integer :: stdoutunit 

  stdoutunit=stdout() 

  call get_date(Time, yr, mon, day, hr, min, sec)

  write(stdoutunit,'(a,i6,a,i2,a,i2,1x,i2,a,i2,a,i2)' ) &
       'yyyy/mm/dd hh:mm:ss = ', yr, '/',mon,'/',day, hr, ':',min,':', sec

end subroutine write_timestamp
! </SUBROUTINE> NAME="write_timestamp">

!#######################################################################
! <SUBROUTINE NAME="write_chksum_header">
!
! <DESCRIPTION>
! Write the checksum header.
! </DESCRIPTION>
!
subroutine write_chksum_header(filename, desc, model_time)

  character(len=*), intent(in) :: filename
  character(len=*), intent(in) :: desc
  type(time_type), intent(in) :: model_time
  integer :: stdoutunit 

  stdoutunit=stdout() 
  write(stdoutunit,'(a)') ' ' 
  write(stdoutunit,'(a)') '[CHKSUM BLOCK] '//filename//': '//desc
  call write_timestamp(model_time)

end subroutine
! </SUBROUTINE> NAME="write_chksum_header">


!#######################################################################
! <SUBROUTINE NAME="write_note">
!
! <DESCRIPTION>
! Write a note.
! </DESCRIPTION>
!
subroutine write_note(filename, msg)    

  character(len=*), intent(in) :: filename
  character(len=*), intent(in) :: msg
  integer :: stdoutunit

  stdoutunit=stdout()
  write(stdoutunit, '(/a)') "[Note] "//filename//": "// msg

end subroutine write_note
! </SUBROUTINE> NAME="write_note">


!#######################################################################
! <SUBROUTINE NAME="write_warning">
!
! <DESCRIPTION>
! Write a warning.
! </DESCRIPTION>
!
subroutine write_warning(filename, msg)    

  character(len=*), intent(in) :: filename
  character(len=*), intent(in) :: msg
  integer :: stdoutunit

  stdoutunit=stdout()
  write(stdoutunit, '(/a)') "[Warning] "//filename//": "// msg

end subroutine write_warning
! </SUBROUTINE> NAME="write_warning">


!#######################################################################
! <SUBROUTINE NAME="write_line">
!
! <DESCRIPTION>
! Write a message.
! </DESCRIPTION>
!
subroutine write_line(msg)

  character(len=*), intent(in) :: msg
  integer :: stdoutunit

  stdoutunit=stdout()
  write(stdoutunit, '(a)')  "          "// msg

end subroutine write_line
! </SUBROUTINE> NAME="write_line">


!#######################################################################
! <SUBROUTINE NAME="write_chksum_3d">
!
! <DESCRIPTION>
! Write a 3d checksum.
! </DESCRIPTION>
!
subroutine write_chksum_3d(name, data, chksum)
  character(len=*), intent(in) :: name
  real, dimension(isc:iec,jsc:jec,nk), intent(in) :: data
  integer(i8_kind), optional, intent(inout) :: chksum
  integer(i8_kind)                          :: chk_sum

  integer :: stdoutunit
  character(len=40) :: c
  c = '[chksum] '//name
  stdoutunit=stdout()
  chk_sum = mpp_chksum(data(isc:iec,jsc:jec,:nk))
  write(stdoutunit, '(a40,i30)') c, chk_sum
  if (present(chksum)) chksum = chk_sum

end subroutine write_chksum_3d
! </SUBROUTINE> NAME="write_chksum_3d">

!#######################################################################
! <SUBROUTINE NAME="write_chksum_3d_int">
!
! <DESCRIPTION>
! Write a 3d integer checksum.
! </DESCRIPTION>
!
subroutine write_chksum_3d_int(name, data)
  character(len=*), intent(in) :: name
  integer, dimension(isc:iec,jsc:jec,nk) :: data
  integer :: stdoutunit
  character(len=40) :: c
  c = '[chksum] '//name

  stdoutunit=stdout()
  write(stdoutunit, '(a40,i30)') c, mpp_chksum(data(isc:iec,jsc:jec,:nk))

end subroutine write_chksum_3d_int
! </SUBROUTINE> NAME="write_chksum_3d_int">


!#######################################################################
! <SUBROUTINE NAME="write_chksum_2d">
!
! <DESCRIPTION>
! Write a 2d checksum.
! </DESCRIPTION>
!
subroutine write_chksum_2d(name, data)

  character(len=*), intent(in) :: name
  real, dimension(isc:iec,jsc:jec) :: data
  integer :: stdoutunit
  character(len=40) :: c
  c = '[chksum] '//name

  stdoutunit=stdout()
  write(stdoutunit, '(a40,i30)') c, mpp_chksum(data(isc:iec,jsc:jec))


end subroutine write_chksum_2d
! </SUBROUTINE> NAME="write_chksum_2d">


!#######################################################################
! <SUBROUTINE NAME="write_chksum_2d_int">
!
! <DESCRIPTION>
! Write a 2d integer checksum.
! </DESCRIPTION>
!
subroutine write_chksum_2d_int(name, data)

  character(len=*), intent(in) :: name
  integer, dimension(isc:iec,jsc:jec) :: data
  integer :: stdoutunit
  character(len=40) :: c
  c = '[chksum] '//name

  stdoutunit=stdout()
  write(stdoutunit, '(a40,i30)') c, mpp_chksum(data(isc:iec,jsc:jec))

end subroutine write_chksum_2d_int
! </SUBROUTINE> NAME="write_chksum_2d_int">


!#######################################################################
! <SUBROUTINE NAME="check_restart">
!
! <DESCRIPTION>
! Write a note regarding the restart setup.
! </DESCRIPTION>
!
subroutine check_restart(filename, write_a_restart)
  character(len=*), intent(in) :: filename
  logical, intent(in) :: write_a_restart

  if(.not. write_a_restart) then 
     call write_note(filename, 'running with write_a_restart=.false.')
     call write_line('Will NOT write restart file, and so cannot restart the run.')
  endif

end subroutine check_restart
! </SUBROUTINE> NAME="check_restart">


!#######################################################################
! <SUBROUTINE NAME="write_summary">
!
! <DESCRIPTION>
! Write a summary note.
! </DESCRIPTION>
!
subroutine write_summary(filename, msg, model_time)

  character(len=*), intent(in) :: filename
  character(len=*), intent(in) :: msg
  type(time_type),  intent(in) :: model_time  
  integer :: stdoutunit

  stdoutunit=stdout()
  write(stdoutunit, '(/a)') '[SUMMARY] '//filename//': '//msg
  call write_timestamp(model_time)
  
end subroutine write_summary
! </SUBROUTINE> NAME="write_summary">


!#######################################################################
! <SUBROUTINE NAME="diagnose_3d">
!
! <DESCRIPTION>
! Helper function for diagnosting 3D data using the grid tmask.
! </DESCRIPTION>
!
subroutine diagnose_3d(Time, Grid, id_name, data, nk_lim, use_mask, abs_max, abs_min)
    type(ocean_time_type),        intent(in) :: Time
    type(ocean_grid_type),        intent(in) :: Grid
    integer,                      intent(in) :: id_name
    real, dimension(isd:,jsd:,:), intent(in) :: data
    integer,                      intent(in), optional :: nk_lim
    logical,                      intent(in), optional :: use_mask
    real,                         intent(in), optional :: abs_max
    real,                         intent(in), optional :: abs_min

    call diagnose_3d_mask(Time, Grid%tmask(:,:,:), id_name, data, nk_lim, use_mask, abs_max, abs_min)

end subroutine diagnose_3d
! </SUBROUTINE> NAME="diagnose_3d"

!#######################################################################
! <SUBROUTINE NAME="diagnose_3d_u">
!
! <DESCRIPTION>
! Helper function for diagnosting 3D data using the grid umask.
! </DESCRIPTION>
!
subroutine diagnose_3d_u(Time, Grid, id_name, data, nk_lim, use_mask, abs_max, abs_min)
    type(ocean_time_type),        intent(in) :: Time
    type(ocean_grid_type),        intent(in) :: Grid
    integer,                      intent(in) :: id_name
    real, dimension(isd:,jsd:,:), intent(in) :: data
    integer,                      intent(in), optional :: nk_lim
    logical,                      intent(in), optional :: use_mask
    real,                         intent(in), optional :: abs_max
    real,                         intent(in), optional :: abs_min

    call diagnose_3d_mask(Time, Grid%umask(:,:,:), id_name, data, nk_lim, use_mask, abs_max, abs_min)

end subroutine diagnose_3d_u
! </SUBROUTINE> NAME="diagnose_3d_u"

!#######################################################################
! <SUBROUTINE NAME="diagnose_3d_en">
!
! <DESCRIPTION>
! Helper function for diagnosting 3D data using the grid tmasken.
! </DESCRIPTION>
!
subroutine diagnose_3d_en(Time, Grid, id_name1, id_name2, data, nk_lim, use_mask, abs_max, abs_min)
    type(ocean_time_type),        intent(in) :: Time
    type(ocean_grid_type),        intent(in) :: Grid
    integer,                      intent(in) :: id_name1
    integer,                      intent(in) :: id_name2
    real, dimension(isd:,jsd:,:,:), intent(in) :: data
    integer,                      intent(in), optional :: nk_lim
    logical,                      intent(in), optional :: use_mask
    real,                         intent(in), optional :: abs_max
    real,                         intent(in), optional :: abs_min

    call diagnose_3d_mask(Time, Grid%tmasken(:,:,:,1), id_name1, data(:,:,:,1), nk_lim, use_mask, abs_max, abs_min)
    call diagnose_3d_mask(Time, Grid%tmasken(:,:,:,2), id_name2, data(:,:,:,2), nk_lim, use_mask, abs_max, abs_min)

end subroutine diagnose_3d_en
! </SUBROUTINE> NAME="diagnose_3d_en"

!#######################################################################
! <SUBROUTINE NAME="diagnose_3d_mask">
!
! <DESCRIPTION>
! Helper function for diagnosting 3D data using the given mask.
! </DESCRIPTION>
!
subroutine diagnose_3d_mask(Time, mask, id_name, data, nk_lim, use_mask, abs_max, abs_min)
    type(ocean_time_type),        intent(in) :: Time
    real, dimension(isd:,jsd:,:), intent(in) :: mask
    integer,                      intent(in) :: id_name
    real, dimension(isd:,jsd:,:), intent(in) :: data
    integer,                      intent(in), optional :: nk_lim
    logical,                      intent(in), optional :: use_mask
    real,                         intent(in), optional :: abs_max
    real,                         intent(in), optional :: abs_min

    logical :: use_mask_, used
    integer :: nk_lim_
    real, dimension(isd:ied,jsd:jed,nk) :: threshold_mask

    nk_lim_ = nk
    if (present(nk_lim)) then
       nk_lim_ = nk_lim
    endif

    use_mask_ = .true.
    if (present(use_mask)) then
       use_mask_ = use_mask
    endif

    threshold_mask(:,:,:) = 1.0
    if (present(abs_max)) then
       where (abs(data(COMP,:)) > abs_max) threshold_mask(COMP,:) = 0.0
    endif
    if (present(abs_min)) then
       where (abs(data(COMP,:)) < abs_min) threshold_mask(COMP,:) = 0.0
    endif

    if (id_name > 0) then
       if (use_mask_) then
          if (nk_lim_ /= nk) then
             call mpp_error(FATAL, &
                  '==> Error from ocean_nphysics_util_new (diagnose_3d): nk_lim must equal nk.')
          endif
          threshold_mask(:,:,:) = 1.0
          if (present(abs_max)) then
             where (abs(data(COMP,:)) > abs_max) threshold_mask(COMP,:) = 0.0
          endif
          if (present(abs_min)) then
             where (abs(data(COMP,:)) < abs_min) threshold_mask(COMP,:) = 0.0
          endif
          used = send_data(id_name, data(:,:,:),                              &
               Time%model_time, rmask=mask(:,:,:)*threshold_mask(:,:,:),&
               is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk_lim_)
       else
          used = send_data(id_name, data(:,:,:), &
               Time%model_time,                  &
               is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk_lim_)
       endif
    endif

end subroutine diagnose_3d_mask
! </SUBROUTINE> NAME="diagnose_3d_mask"


!#######################################################################
! <SUBROUTINE NAME="diagnose_2d">
!
! <DESCRIPTION>
! Helper function for diagnosting 2D data using the grid tmask.
! </DESCRIPTION>
!
subroutine diagnose_2d(Time, Grid, id_name, data, abs_max, abs_min)
    type(ocean_time_type),      intent(in) :: Time
    type(ocean_grid_type),      intent(in) :: Grid
    integer,                    intent(in) :: id_name
    real, dimension(isd:,jsd:), intent(in) :: data
    real,                       intent(in), optional :: abs_max
    real,                       intent(in), optional :: abs_min

    call diagnose_2d_mask(Time, Grid%tmask(:,:,1), id_name, data, abs_max, abs_min)

end subroutine diagnose_2d
! </SUBROUTINE> NAME="diagnose_2d"

!#######################################################################
! <SUBROUTINE NAME="diagnose_2d_u">
!
! <DESCRIPTION>
! Helper function for diagnosting 2D data using the grid umask.
! </DESCRIPTION>
!
subroutine diagnose_2d_u(Time, Grid, id_name, data, abs_max, abs_min)
    type(ocean_time_type),      intent(in) :: Time
    type(ocean_grid_type),      intent(in) :: Grid
    integer,                    intent(in) :: id_name
    real, dimension(isd:,jsd:), intent(in) :: data
    real,                       intent(in), optional :: abs_max
    real,                       intent(in), optional :: abs_min

    call diagnose_2d_mask(Time, Grid%umask(:,:,1), id_name, data, abs_max, abs_min)

  end subroutine diagnose_2d_u
! </SUBROUTINE> NAME="diagnose_2d_u"

!#######################################################################
! <SUBROUTINE NAME="diagnose_2d_en">
!
! <DESCRIPTION>
! Helper function for diagnosting 2D data using the grid tmasken.
! </DESCRIPTION>
!
subroutine diagnose_2d_en(Time, Grid, id_name1, id_name2, data, abs_max, abs_min)
    type(ocean_time_type),      intent(in) :: Time
    type(ocean_grid_type),      intent(in) :: Grid
    integer,                    intent(in) :: id_name1
    integer,                    intent(in) :: id_name2
    real, dimension(isd:,jsd:,:), intent(in) :: data
    real,                       intent(in), optional :: abs_max
    real,                       intent(in), optional :: abs_min

    call diagnose_2d_mask(Time, Grid%tmasken(:,:,1,1), id_name1, data(:,:,1), abs_max, abs_min)
    call diagnose_2d_mask(Time, Grid%tmasken(:,:,1,2), id_name2, data(:,:,2), abs_max, abs_min)

  end subroutine diagnose_2d_en
! </SUBROUTINE> NAME="diagnose_2d_en"

!#######################################################################
! <SUBROUTINE NAME="diagnose_2d_mask">
!
! <DESCRIPTION>
! Helper function for diagnosting 2D data using a given mask.
! </DESCRIPTION>
!
subroutine diagnose_2d_mask(Time, mask, id_name, data, abs_max, abs_min)
    type(ocean_time_type),      intent(in) :: Time
    real, dimension(isd:,jsd:), intent(in) :: mask
    integer,                    intent(in) :: id_name
    real, dimension(isd:,jsd:), intent(in) :: data
    real,                       intent(in), optional :: abs_max
    real,                       intent(in), optional :: abs_min

    logical :: used
    real, dimension(isd:ied,jsd:jed) :: threshold_mask

    threshold_mask(:,:) = 1.0
    if (present(abs_max)) then
       where (abs(data(COMP)) > abs_max) threshold_mask(COMP) = 0.0
    endif
    if (present(abs_min)) then
       where (abs(data(COMP)) < abs_min) threshold_mask(COMP) = 0.0
    endif

    if (id_name > 0) used = send_data(id_name, data(:,:),             &
         Time%model_time, rmask=mask(:,:)*threshold_mask(:,:),&
         is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)

end subroutine diagnose_2d_mask
! </SUBROUTINE> NAME="diagnose_2d_mask"

!#######################################################################
! <SUBROUTINE NAME="diagnose_2d_int">
!
! <DESCRIPTION>
! Helper function for diagnosting 2D data using the grid tmask.
! </DESCRIPTION>
!
subroutine diagnose_2d_int(Time, Grid, id_name, data)
    type(ocean_time_type),         intent(in) :: Time
    type(ocean_grid_type),         intent(in) :: Grid
    integer,                       intent(in) :: id_name
    integer, dimension(isd:,jsd:), intent(in) :: data

    real, dimension(isd:ied,jsd:jed) :: data_

    data_ = 1.0*data
    call diagnose_2d(Time, Grid, id_name, data_)

end subroutine diagnose_2d_int
! </SUBROUTINE> NAME="diagnose_2d_int"

!#######################################################################
! <SUBROUTINE NAME="diagnose_2d_comp">
!
! <DESCRIPTION>
! Helper function for diagnosting 2D data using the grid tmask on the 
! computational domain.
! </DESCRIPTION>
!
subroutine diagnose_2d_comp(Time, Grid, id_name, data)
    type(ocean_time_type),      intent(in) :: Time
    type(ocean_grid_type),      intent(in) :: Grid
    integer,                    intent(in) :: id_name
    real, dimension(isc:,jsc:), intent(in) :: data

    logical :: used

    if (id_name > 0) used = send_data(id_name, data, &
         Time%model_time, rmask=Grid%tmask(isc:iec,jsc:jec,1))

end subroutine diagnose_2d_comp
! </SUBROUTINE> NAME="diagnose_2d_comp"

!#######################################################################
! <SUBROUTINE NAME="diagnose_3d_int">
!
! <DESCRIPTION>
! Helper function for diagnosting 3D data using the grid tmask.
! </DESCRIPTION>
!
subroutine diagnose_3d_int(Time, Grid, id_name, data)
    type(ocean_time_type),           intent(in) :: Time
    type(ocean_grid_type),           intent(in) :: Grid
    integer,                         intent(in) :: id_name
    integer, dimension(isd:,jsd:,:), intent(in) :: data

    real, dimension(isd:ied,jsd:jed,nk) :: data_

    data_ = 1.0*data
    call diagnose_3d(Time, Grid, id_name, data_)

end subroutine diagnose_3d_int
! </SUBROUTINE> NAME="diagnose_3d_int"

!#######################################################################
! <SUBROUTINE NAME="diagnose_3d_comp">
!
! <DESCRIPTION>
! Helper function for diagnosting 3D data using the grid tmask on the 
! computational domain.
! </DESCRIPTION>
!
subroutine diagnose_3d_comp(Time, Grid, id_name, data)
    type(ocean_time_type),      intent(in) :: Time
    type(ocean_grid_type),      intent(in) :: Grid
    integer,                    intent(in) :: id_name
    real, dimension(isc:,jsc:,:), intent(in) :: data

    logical :: used

    if (id_name > 0) used = send_data(id_name, data, &
         Time%model_time, rmask=Grid%tmask(isc:iec,jsc:jec,:))

end subroutine diagnose_3d_comp
! </SUBROUTINE> NAME="diagnose_3d_comp"


subroutine diagnose_sum(Time, Grid, Dom, id_name, data, factor)

  type(ocean_time_type), intent(in) :: Time
  type(ocean_grid_type), intent(in) :: Grid
  type(ocean_domain_type), intent(in) :: Dom
  integer, intent(in) :: id_name
  real, dimension(isd:,jsd:), intent(in) :: data
  real, intent(in) :: factor

  real, dimension(isd:ied,jsd:jed) :: work
  real :: total
  logical :: used

  if(id_name > 0) then 
     work(:,:) = Grid%tmask(:,:,1)*Grid%dat(:,:)*data(:,:)
     total = mpp_global_sum(Dom%domain2d, work(:,:), NON_BITWISE_EXACT_SUM)*factor
     used = send_data (id_name, total, Time%model_time)
  endif

end subroutine diagnose_sum

function register_2d_t_field(Grid, Time, name, desc, units, range)

    type(ocean_grid_type), intent(in) :: Grid
    type(ocean_time_type), intent(in) :: Time
    character(len=*),      intent(in) :: name
    character(len=*),      intent(in) :: desc
    character(len=*),      intent(in) :: units
    real, dimension(2),    intent(in) :: range

    integer :: register_2d_t_field

    register_2d_t_field = register_diag_field ('ocean_model', name, &
         Grid%tracer_axes(1:2), Time%model_time, desc, units,       &
         missing_value=missing_value, range=range)

end function register_2d_t_field

function register_3d_t_field(Grid, Time, name, desc, units, range)

    type(ocean_grid_type), intent(in) :: Grid
    type(ocean_time_type), intent(in) :: Time
    character(len=*),      intent(in) :: name
    character(len=*),      intent(in) :: desc
    character(len=*),      intent(in) :: units
    real, dimension(2),    intent(in) :: range

    integer :: register_3d_t_field

    register_3d_t_field = register_diag_field ('ocean_model', name, &
         Grid%tracer_axes(1:3), Time%model_time, desc, units,       &
         missing_value=missing_value, range=range)

end function register_3d_t_field

function register_3d_xte_field(Grid, Time, name, desc, units, range)

    type(ocean_grid_type), intent(in) :: Grid
    type(ocean_time_type), intent(in) :: Time
    character(len=*),      intent(in) :: name
    character(len=*),      intent(in) :: desc
    character(len=*),      intent(in) :: units
    real, dimension(2),    intent(in) :: range

    integer :: register_3d_xte_field

    register_3d_xte_field = register_diag_field ('ocean_model', name, &
         Grid%tracer_axes_flux_x(1:3), Time%model_time, desc, units,  &
         missing_value=missing_value, range=range)

end function register_3d_xte_field

function register_3d_ytn_field(Grid, Time, name, desc, units, range)

    type(ocean_grid_type), intent(in) :: Grid
    type(ocean_time_type), intent(in) :: Time
    character(len=*),      intent(in) :: name
    character(len=*),      intent(in) :: desc
    character(len=*),      intent(in) :: units
    real, dimension(2),    intent(in) :: range

    integer :: register_3d_ytn_field

    register_3d_ytn_field = register_diag_field ('ocean_model', name, &
         Grid%tracer_axes_flux_y(1:3), Time%model_time, desc, units,  &
         missing_value=missing_value, range=range)

end function register_3d_ytn_field

function register_3d_ztb_field(Grid, Time, name, desc, units, range)

    type(ocean_grid_type), intent(in) :: Grid
    type(ocean_time_type), intent(in) :: Time
    character(len=*),      intent(in) :: name
    character(len=*),      intent(in) :: desc
    character(len=*),      intent(in) :: units
    real, dimension(2),    intent(in) :: range

    integer :: register_3d_ztb_field

    register_3d_ztb_field = register_diag_field ('ocean_model', name, &
         Grid%tracer_axes_wt(1:3), Time%model_time, desc, units,      &
         missing_value=missing_value, range=range)

end function register_3d_ztb_field



end module ocean_util_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: Update turbulence production\label{sec:production}
!
! !INTERFACE:
   subroutine production(nlev,NN,SS,xP)
!
! !DESCRIPTION:
!  This subroutine calculates the production terms of turbulent kinetic
!  energy as defined in \eq{PandG} and the production of buoayancy
!  variance as defined in \eq{Pbvertical}.
!  The shear-production is computed according to
!  \begin{equation}
!    \label{computeP}
!     P = \nu_t (M^2 + \alpha_w N^2) + X_P
!    \comma
!  \end{equation}
!  with the turbulent diffusivity of momentum, $\nu_t$, defined in
!  \eq{nu}. The shear-frequency, $M$, is discretised as described
!  in \sect{sec:shear}.
!   The term multiplied by $\alpha_w$ traces back to
!  a parameterisation of breaking internal waves suggested by
!  \cite{Mellor89}. $X_P$ is an extra production term, connected for
!  example with turbulence production caused by sea-grass, see
!  \eq{sgProduction} in  \sect{sec:seagrass}. {\tt xP} is an {\tt optional}
!  argument in the FORTRAN code.
!
!  Similarly, according to \eq{PeVertical}, the buoyancy production
!  is computed from the expression
!  \begin{equation}
!   \label{computeG}
!    G=-\nu^B_t N^2 + \tilde{\Gamma}_B
!    \comma
!  \end{equation}
!  with the turbulent diffusivity, $\nu^B_t$, defined in
!  \eq{nu}. The second term in \eq{computeG} represents the non-local
!  buoyancy flux. The buoyancy-frequency, $N$, is discretised as described
!  in \sect{sec:stratification}.
!
!  The production of buoyancy variance by vertical meanflow gradients follows
!  from \eq{PeVertical} and \eq{computeG}
!  \begin{equation}
!   \label{computePb}
!    P_b = -G N^2
!    \point
!  \end{equation}
!  Thus, according to the definition of the potential energy \eq{defkb},
!  the buoyancy production $G$ describes the conversion between turbulent
!  kinetic and potential energy in \eq{tkeA} and \eq{kbeq}, respectively.
!
! !USES:
   use turbulence, only: P,B,Pb
   use turbulence, only: num,nuh
   use turbulence, only: alpha,iw_model
   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer,  intent(in)                :: nlev

!  boyancy frequency squared (1/s^2)
   REALTYPE, intent(in)                :: NN(0:nlev)

!  shear-frequency squared (1/s^2)
   REALTYPE, intent(in)                :: SS(0:nlev)

!  TKE production due to seagrass
!  friction (m^2/s^3)
   REALTYPE, intent(in), optional      :: xP(0:nlev)

!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding, Hans Burchard
!
!  $Log: production.F90,v $
!  Revision 20.0  2013/12/14 00:13:49  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.5  2010-09-17 12:53:52  jorn
!  extensive code clean-up to ensure proper initialization and clean-up of all variables
!
!  Revision 1.4  2005-08-28 09:40:03  hb
!  Misspelling in documentation corrected.
!
!  Revision 1.3  2005/08/11 13:01:49  lars
!  Added explicit loops for 3-D z-level support. Thanks to Vicente Fernandez.
!
!  Revision 1.2  2005/07/19 16:46:14  hb
!  removed superfluous variables - NNT, NNS, SSU, SSV
!
!  Revision 1.1  2005/06/27 10:54:33  kbk
!  new files needed
!
!  Revision 1.6  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.5  2003/03/28 08:56:56  kbk
!  removed tabs
!
!  Revision 1.4  2003/03/10 08:50:07  gotm
!  Improved documentation and cleaned up code
!
!  Revision 1.3  2002/02/08 08:59:57  gotm
!
!  Revision 1.2  2001/11/18 16:02:16  gotm
!  Allow no_shear calculation
!
!  Revision 1.1.1.1  2001/02/12 15:55:57  gotm
!  initial import into CVS
!
!EOP
!-----------------------------------------------------------------------
! !LOCAL VARIABLES:
   REALTYPE                      :: alpha_eff
   integer                       :: i
!-----------------------------------------------------------------------
!BOC
   alpha_eff=_ZERO_
   if (iw_model.eq.1) then
      alpha_eff=alpha
   end if

   if ( PRESENT(xP) ) then
      do i=0,nlev
         P(i)    =  num(i)*( SS(i)+alpha_eff*NN(i) ) + xP(i)
         B(i)    = -nuh(i)*NN(i)
         Pb(i)   = -  B(i)*NN(i)
      enddo
   else
      do i=0,nlev
         P(i)    =  num(i)*( SS(i)+alpha_eff*NN(i) )
         B(i)    = -nuh(i)*NN(i)
         Pb(i)   = -  B(i)*NN(i)
      enddo
   endif

   return
   end subroutine production
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

                  module radiative_gases_mod

! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  ds
! </REVIEWER>
! <OVERVIEW>
!  Module that defines mixing ratios of radiatively-active 
!    gases to be used in the calculation of longwave and shortwave
!    radiative fluxes and heating rates in the sea_esf_rad radiation
!    package.
! </OVERVIEW>
! <DESCRIPTION>
!  Module that defines mixing ratios of radiatively-active 
!    gases to be used in the calculation of longwave and shortwave
!    radiative fluxes and heating rates in the sea_esf_rad radiation
!    package.
! </DESCRIPTION>

!  shared modules:

use time_manager_mod,    only: time_manager_init, time_type, set_date, &
                               get_calendar_type, GREGORIAN, &
                               operator(>=), operator(-), operator(<=),&
                               operator(>),  operator (<), get_date,  &
                               set_time, operator(+), print_date,  &
                               days_in_year, get_time, length_of_year
use diag_manager_mod,    only: diag_manager_init, get_base_time
use mpp_mod,             only: input_nml_file
use fms_mod,             only: open_namelist_file, fms_init, &
                               mpp_pe, mpp_root_pe, stdlog, &
                               file_exist, write_version_number, &
                               check_nml_error, error_mesg, &
                               FATAL, NOTE, close_file, &
                               open_restart_file, read_data
use fms_io_mod,          only: get_restart_io_mode, &
                               register_restart_field, restart_file_type, &
                               save_restart, restore_state, query_initialized
use time_interp_mod,     only: time_interp_init, time_interp
use tracer_manager_mod,  only: get_tracer_index, NO_TRACER
use field_manager_mod,   only: MODEL_ATMOS

!  shared radiation package modules:

use rad_utilities_mod,   only: rad_utilities_init, Lw_control, &
                               atmos_input_type, &
                               radiative_gases_type, Rad_control

! component modules:

use ozone_mod,           only: ozone_driver, ozone_init,  &
                               ozone_time_vary, ozone_endts, ozone_end

!---------------------------------------------------------------------

implicit none
private

!---------------------------------------------------------------------
!    radiative_gases_mod defines mixing ratios of radiatively-active 
!    gases to be used in the calculation of longwave and shortwave
!    radiative fluxes and heating rates in the sea_esf_rad radiation
!    package.
!---------------------------------------------------------------------
 

!---------------------------------------------------------------------
!----------- version number for this module --------------------------

character(len=128)  :: version =  &
'$Id: radiative_gases.F90,v 20.0 2013/12/13 23:20:28 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'

!---------------------------------------------------------------------
!-------  interfaces --------

public     &
         radiative_gases_init, define_radiative_gases,  &
         radiative_gases_time_vary, radiative_gases_endts,  &
         radiative_gases_end, radiative_gases_dealloc,  &
         radiative_gases_restart

private    &
! called from radiative_gases_init:
         validate_time_varying_inputs, &
         define_ch4, define_n2o, define_f11, &
         define_f12, define_f113, define_f22, &
         define_co2, read_gas_timeseries,  &

! called from define_radiative_gases:
         define_gas_amount,     &

! called from radiative_gases_end:
         write_restart_radiative_gases


!---------------------------------------------------------------------
!-------- namelist  ---------

integer          :: verbose = 0   ! verbosity levels, values run from
                                  ! 0 (least output) to 5 (most output)
integer          :: gas_printout_freq = 32*24
                                  ! frequency of outputting gas concen-
                                  ! trations [ hours ] default: 32 days

!--------------------------------------------------------------------
!    time_varying_xxx  logical flag indicating whether the vol. mixing 
!                      ratio of gas xxx varies in time
!    xxx_data_source   source of input data for initial value of gas xxx
!    xxx_floor         smallest value allowed for gas xxx vol. mixing 
!                      ratio [ no. / no. ]
!    xxx_ceiling       largest value allowed for gas xxx vol. mixing 
!                      ratio [ no. / no. ]
!    xxx_specification_type
!                      indicator as to the form of time variation of
!                      vol. mixing ratio for gas xxx; either 
!                      'base_and_trend' or 'time_series'
!    xxx_variation_type
!                      indicator as to the form of time variation of
!                      the vol. mixing ratio of gas xxx; either 'linear'
!                      or 'logarithmic'. Must be 'linear' for 
!                      'time_series'.
!      
!         The following variables only have relevance when 
!         specification_type = 'base_and_trend':
!
!    xxx_base_value    initial value of gas xxx vol. mixing ratio when
!                      xxx_data_source is 'namelist' [ no. / no. ]
!    xxx_base_time     time at which xxx_base_value is relevant spec-
!                      ified as (year, month, day, 0, 0, 0). (Can only 
!                      be specified as 00Z on the particular day).
!
!    xxx_change_rate   time rate of change of gas xxx vol. mixing ratio.
!                      [  1 +/- % per year ]
!
!--------------------------------------------------------------------

logical              :: time_varying_co2 = .false.
character(len=16)    :: co2_data_source  = '   '
real                 :: co2_base_value    = 0.0
integer,dimension(6) :: co2_base_time     = (/ 0,0,0,0,0,0 /)
real                 :: co2_change_rate   = 0.0
real                 :: co2_floor = 0.0
real                 :: co2_ceiling = 1.0E6
character(len=16)    :: co2_specification_type = '              '
character(len=16)    :: co2_variation_type = '           '

logical              :: time_varying_ch4 = .false.
character(len=16)    :: ch4_data_source  = '   '
real                 :: ch4_base_value    = 0.0
integer,dimension(6) :: ch4_base_time     = (/ 0,0,0,0,0,0 /)
real                 :: ch4_change_rate   = 0.0
real                 :: ch4_floor = 0.0
real                 :: ch4_ceiling = 1.0E6
character(len=16)    :: ch4_specification_type = '              '
character(len=16)    :: ch4_variation_type = '           '

logical              :: time_varying_n2o = .false.
character(len=16)    :: n2o_data_source  = '   '
real                 :: n2o_base_value    = 0.0
integer,dimension(6) :: n2o_base_time     = (/ 0,0,0,0,0,0 /)
real                 :: n2o_change_rate   = 0.0
real                 :: n2o_floor = 0.0
real                 :: n2o_ceiling = 1.0E6
character(len=16)    :: n2o_specification_type = '              '
character(len=16)    :: n2o_variation_type = '           '

logical              :: time_varying_f11 = .false.
character(len=16)    :: f11_data_source  = '   '
real                 :: f11_base_value    = 0.0
integer,dimension(6) :: f11_base_time     = (/ 0,0,0,0,0,0 /)
real                 :: f11_change_rate   = 0.0
real                 :: f11_floor = 0.0
real                 :: f11_ceiling = 1.0E6
character(len=16)    :: f11_specification_type = '              '
character(len=16)    :: f11_variation_type = '           '

logical              :: time_varying_f12 = .false.
character(len=16)    :: f12_data_source  = '   '
real                 :: f12_base_value    = 0.0
integer,dimension(6) :: f12_base_time     = (/ 0,0,0,0,0,0 /)
real                 :: f12_change_rate   = 0.0
real                 :: f12_floor = 0.0
real                 :: f12_ceiling = 1.0E6
character(len=16)    :: f12_specification_type = '              '
character(len=16)    :: f12_variation_type = '           '

logical              :: time_varying_f113 = .false.
character(len=16)    :: f113_data_source  = '   '
real                 :: f113_base_value    = 0.0
integer,dimension(6) :: f113_base_time     = (/ 0,0,0,0,0,0 /)
real                 :: f113_change_rate   = 0.0
real                 :: f113_floor = 0.0
real                 :: f113_ceiling = 1.0E6
character(len=16)    :: f113_specification_type = '              '
character(len=16)    :: f113_variation_type = '           '

logical              :: time_varying_f22 = .false.
character(len=16)    :: f22_data_source  = '   '
real                 :: f22_base_value    = 0.0
integer,dimension(6) :: f22_base_time     = (/ 0,0,0,0,0,0 /)
real                 :: f22_change_rate   = 0.0
real                 :: f22_floor = 0.0
real                 :: f22_ceiling = 1.0E6
character(len=16)    :: f22_specification_type = '              '
character(len=16)    :: f22_variation_type = '           '

integer, dimension(6) ::       &
                         co2_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
                      ! time in co2  data set corresponding to model
                      ! initial time  (yr, mo, dy, hr, mn, sc)
integer, dimension(6) ::       &
                         ch4_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
                      ! time in ch4  data set corresponding to model
                      ! initial time  (yr, mo, dy, hr, mn, sc)
integer, dimension(6) ::       &
                         n2o_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
                      ! time in n2o  data set corresponding to model
                      ! initial time  (yr, mo, dy, hr, mn, sc)
integer, dimension(6) ::       &
                         f11_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
                      ! time in f11  data set corresponding to model
                      ! initial time  (yr, mo, dy, hr, mn, sc)
integer, dimension(6) ::       &
                         f12_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
                      ! time in f12  data set corresponding to model
                      ! initial time  (yr, mo, dy, hr, mn, sc)
integer, dimension(6) ::       &
                         f113_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
                      ! time in f113  data set corresponding to model
                      ! initial time  (yr, mo, dy, hr, mn, sc)
integer, dimension(6) ::       &
                         f22_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
                      ! time in f22  data set corresponding to model
                      ! initial time  (yr, mo, dy, hr, mn, sc)
logical              :: time_varying_restart_bug = .false.
logical              :: use_globally_uniform_co2 = .true.
namelist /radiative_gases_nml/ verbose, &
        use_globally_uniform_co2, &
        gas_printout_freq, time_varying_restart_bug, &
        co2_dataset_entry, ch4_dataset_entry, n2o_dataset_entry,  &
        f11_dataset_entry, f12_dataset_entry, f113_dataset_entry, &
        f22_dataset_entry, &

        time_varying_co2, co2_data_source, co2_base_value,  &
        co2_base_time, co2_change_rate, co2_floor, co2_ceiling,  &
        co2_specification_type, co2_variation_type, &

                                time_varying_ch4, ch4_data_source, &
                                ch4_base_value, ch4_base_time, &
                                ch4_change_rate, ch4_floor,   &
                                ch4_ceiling, ch4_specification_type, &
                                ch4_variation_type, &

                                time_varying_n2o, n2o_data_source, &
                                n2o_base_value, n2o_base_time, &
                                n2o_change_rate, n2o_floor,   &
                                n2o_ceiling, n2o_specification_type, &
                                n2o_variation_type, &

                                time_varying_f11, f11_data_source, &
                                f11_base_value, f11_base_time, &
                                f11_change_rate, f11_floor,   &
                                f11_ceiling, f11_specification_type, &
                                f11_variation_type, &

                                time_varying_f12, f12_data_source, &
                                f12_base_value, f12_base_time, &
                                f12_change_rate, f12_floor,   &
                                f12_ceiling, f12_specification_type, &
                                f12_variation_type, &

                                time_varying_f113, f113_data_source, &
                                f113_base_value, f113_base_time, &
                                f113_change_rate, f113_floor,   &
                                f113_ceiling, f113_specification_type, &
                                f113_variation_type, &

                                time_varying_f22, f22_data_source, &
                                f22_base_value, f22_base_time, &
                                f22_change_rate, f22_floor,   &
                                f22_ceiling, f22_specification_type, &
                                f22_variation_type

!---------------------------------------------------------------------
!------- public data ------


!---------------------------------------------------------------------
!------- private data ------

!--- for netcdf restart
type(restart_file_type), save :: Rad_restart
logical                       :: do_netcdf_restart= .true.
integer                       ::  vers   ! version number of restart file 
!---------------------------------------------------------------------
!    list of restart versions of radiation_driver.res readable by this 
!    module.
!---------------------------------------------------------------------
integer, dimension(3)    ::  restart_versions = (/ 1, 2, 3 /)

!--------------------------------------------------------------------
!    initial mixing ratios of the various radiative gases. if a gas 
!    is not active, its mixing ratio is set to zero.
!--------------------------------------------------------------------
real         ::  rch4, rn2o, rf11, rf12, rf113, rf22, rco2

!--------------------------------------------------------------------
!    this is the mixing ratio of gas used when the transmission 
!    functions were last calculated.
!--------------------------------------------------------------------
real         ::  co2_for_last_tf_calc
real         ::  ch4_for_last_tf_calc
real         ::  n2o_for_last_tf_calc

!RSH
!  Need these as module variables rather than components of derived type
!   since they are needed in region executed by master thread only:
real         ::  co2_for_next_tf_calc
real         ::  ch4_for_next_tf_calc
real         ::  n2o_for_next_tf_calc
real         ::  ch4_tf_offset
real         ::  n2o_tf_offset
real         ::  co2_tf_offset
!--------------------------------------------------------------------
!    these variables are .true. if transmission functions are cal-
!    culated for the referenced gas.
!--------------------------------------------------------------------
logical, parameter   :: co2_uses_tfs  = .true.
logical, parameter   :: ch4_uses_tfs  = .true.
logical, parameter   :: n2o_uses_tfs  = .true.
logical, parameter   :: f11_uses_tfs  = .false.
logical, parameter   :: f12_uses_tfs  = .false.
logical, parameter   :: f113_uses_tfs = .false.
logical, parameter   :: f22_uses_tfs  = .false.

!--------------------------------------------------------------------
!    these variables contain the mixing ratios of the radiative gases
!    at the current time. if the gases are fixed, this is the same as
!    the initial value; otherwise it will be time-varying.
!--------------------------------------------------------------------
real   :: rrvco2, rrvf11, rrvf12, rrvf113, rrvf22, rrvch4, rrvn2o 

!---------------------------------------------------------------------
!    variables to specify data for gas xxx, when xxx_specification_type
!    is 'time_series':
!
!    xxx_time_list          list of times (time_type variable) for 
!                           which values for gas xxx are specified 
!                           for 'time_series', these define the data 
!                           points, for 'base_and_trend', the single
!                           entry is the xxx_base_time  [ time_type ]
!    xxx_value              values (vol. mixing ratio) of gas xxx at
!                           times given by xxx_time_list. data may have
!                           to be converted from other units (eg, ppmv 
!                           or ppbv or pptv). [real]
!---------------------------------------------------------------------
type(time_type), dimension(:), pointer :: Co2_time_list, N2o_time_list,&
                                          Ch4_time_list, F11_time_list,&
                                          F12_time_list, F22_time_list,&
                                          F113_time_list
real,            dimension(:), pointer :: co2_value, ch4_value,  &
                                          n2o_value, f11_value,  &
                                          f12_value, f113_value, &
                                          f22_value

!---------------------------------------------------------------------
!    miscellaneous variables:
!
!    restart_present        restart file present ?
!    module_is_initialized  module is initialized ?
!    pts_processed          number of processor's columns that have 
!                           been processed on the current time step 
!    total_points           number of model columns on the processor
!    define_xxx_for_last_tf_calc
!                           the tf's that were used for gas xxx on the 
!                           last step of the previous job must be 
!                           recalculated ? this can only be true when
!                           a restart file version earlier than version
!                           3 is being read. 

!---------------------------------------------------------------------
logical      ::  restart_present =  .false.   
logical      ::  module_is_initialized =  .false. 
integer      ::  ico2
logical      ::  define_co2_for_last_tf_calc = .false.
logical      ::  define_ch4_for_last_tf_calc = .false.
logical      ::  define_n2o_for_last_tf_calc = .false.
logical      ::  printed_current_floor_msg = .false.
logical      ::  printed_current_ceiling_msg = .false.
logical      ::  printed_next_floor_msg = .false.
logical      ::  printed_next_ceiling_msg = .false.
integer      ::  print_alarm = 0
 
type(time_type) :: Model_init_time  ! initial calendar time for model  
                                    ! [ time_type ]

!-------------------------------------------------------------------
!   xxx_offset  ! difference between model initial time and gas time-
                ! series mapped to model initial time
                ! [ time_type ]
!   xxx_entry   ! time in gas timeseries which is mapped to model 
                ! initial time
                ! [ time_type ]
!   negative_offset_xxx 
                !  the model initial time is later than the gas 
                !  xxx_dataset_entry time  ?
!-------------------------------------------------------------------
type(time_type)    :: Co2_offset,  Co2_entry
type(time_type)    :: Ch4_offset,  Ch4_entry
type(time_type)    :: N2o_offset,  N2o_entry
type(time_type)    :: F11_offset,  F11_entry
type(time_type)    :: F12_offset,  F12_entry
type(time_type)    :: F113_offset,  F113_entry
type(time_type)    :: F22_offset,  F22_entry

logical    :: negative_offset_co2 = .false.
logical    :: negative_offset_ch4 = .false.
logical    :: negative_offset_n2o = .false.
logical    :: negative_offset_f11 = .false.
logical    :: negative_offset_f12 = .false.
logical    :: negative_offset_f113 = .false.
logical    :: negative_offset_f22 = .false.

logical    :: co2_tfs_needed = .true.
logical    :: ch4_tfs_needed = .true.
logical    :: n2o_tfs_needed = .true.

!---------------------------------------------------------------------
!---------------------------------------------------------------------



                          contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                    PUBLIC SUBROUTINES
!                                
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



!####################################################################
! <SUBROUTINE NAME="radiative_gases_init">
!  <OVERVIEW>
!   Subroutine to initialize radiative_gases module
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to initialize radiative_gases module
!  </DESCRIPTION>
!  <TEMPLATE>
!   call radiative_gases_init (pref, latb, lonb)
!  </TEMPLATE>
!  <IN NAME="pref" TYPE="real">
!   reference prssure profiles
!  </IN>
!  <IN NAME="latb" TYPE="real">
!   2d array of model latitudes at cell corners [radians]
!  </IN>
!  <IN NAME="lonb" TYPE="real">
!   2d array of model longitudes at cell corners [radians]
!  </IN>
! </SUBROUTINE>
!
subroutine radiative_gases_init (pref, latb, lonb)

!---------------------------------------------------------------------
!    radiative_gases_init is the constructor for radiative_gases_mod.
!---------------------------------------------------------------------

real, dimension(:,:), intent(in) :: pref
real, dimension(:,:), intent(in) :: latb, lonb

!---------------------------------------------------------------------
!   intent(in) variables:
!
!       pref      array containing two reference pressure profiles 
!                 for use in defining transmission functions [pascals]
!       latb      2d array of model latitudes at cell corners [radians]
!       lonb      2d array of model longitudes at cell corners [radians]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      integer              :: unit     ! unit number for i/o operation
      integer              :: ierr     ! error code 
      integer              :: io       ! io status upon completion 
      integer              :: calendar ! calendar type used in model
      character(len=8)     :: gas_name ! name associated with current
                                       ! gas being processed
      character(len=32)    :: restart_file
      integer              :: id_restart
      integer              :: logunit  ! unit number for writing to logfile.

!---------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return

!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call rad_utilities_init
      call time_manager_init
      call diag_manager_init
      call time_interp_init

!-----------------------------------------------------------------------
!    read namelist.              
!-----------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=radiative_gases_nml, iostat=io)
      ierr = check_nml_error(io,'radiative_gases_nml')
#else   
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=radiative_gases_nml, iostat=io, end=10) 
        ierr = check_nml_error(io,'radiative_gases_nml')
        end do                   
10      call close_file (unit)   
      endif                      
#endif
      call get_restart_io_mode(do_netcdf_restart)

                                  
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                       write (logunit, nml=radiative_gases_nml)

!---------------------------------------------------------------------
!    force xxx_data_source to be 'input' when gas is time-varying and
!    that variation is specified via a time-series file.
!----------------------------------------------------------------------
      if (time_varying_ch4 .and.   &
          trim(ch4_specification_type) == 'time_series' .and. &
          trim (ch4_data_source) /= 'input') then
        call error_mesg ('radiative_gases_mod', &
          ' when ch4 is time-varying and comes from a timeseries,&
          & data source must be specified as "input" ', FATAL)  
      endif

      if (time_varying_n2o .and.   &
          trim(n2o_specification_type) == 'time_series' .and. &
          trim (n2o_data_source) /= 'input') then
        call error_mesg ('radiative_gases_mod', &
          ' when n2o is time-varying and comes from a timeseries,&
          & data source must be specified as "input" ', FATAL)  
      endif

      if (time_varying_co2 .and.   &
          trim(co2_specification_type) == 'time_series' .and. &
          trim (co2_data_source) /= 'input') then
        call error_mesg ('radiative_gases_mod', &
          ' when co2 is time-varying and comes from a timeseries,&
          & data source must be specified as "input" ', FATAL)  
      endif

      if (time_varying_f11 .and.   &
          trim(f11_specification_type) == 'time_series' .and. &
          trim (f11_data_source) /= 'input') then
        call error_mesg ('radiative_gases_mod', &
          ' when f11 is time-varying and comes from a timeseries,&
          & data source must be specified as "input" ', FATAL)  
      endif

      if (time_varying_f12 .and.   &
          trim(f12_specification_type) == 'time_series' .and. &
          trim (f12_data_source) /= 'input') then
        call error_mesg ('radiative_gases_mod', &
          ' when f12 is time-varying and comes from a timeseries,&
          & data source must be specified as "input" ', FATAL)  
      endif

      if (time_varying_f113 .and.   &
          trim(f113_specification_type) == 'time_series' .and. &
          trim (f113_data_source) /= 'input') then
        call error_mesg ('radiative_gases_mod', &
          ' when f113 is time-varying and comes from a timeseries,&
          & data source must be specified as "input" ', FATAL)  
      endif

      if (time_varying_f22 .and.   &
          trim(f22_specification_type) == 'time_series' .and. &
          trim (f22_data_source) /= 'input') then
        call error_mesg ('radiative_gases_mod', &
          ' when f22 is time-varying and comes from a timeseries,&
          & data source must be specified as "input" ', FATAL)  
      endif

!--------------------------------------------------------------------
!    time variation of radiative gases is not currently available if the
!    gregorian calendar is being employed. NOTE : gregorian calendar
!    not available currently in FMS; if it becomes available, then
!    code to properly handle the time variation of gases with that
!    calendar may be developed.
!--------------------------------------------------------------------
      if (time_varying_co2 .or. &
          time_varying_ch4 .or. &
          time_varying_n2o .or. &
          time_varying_f11 .or. &
          time_varying_f12 .or. &
          time_varying_f113 .or. &
          time_varying_f22 )  then
        calendar = get_calendar_type()
        if (calendar == GREGORIAN ) then 
          call error_mesg ('radiative_gases_mod', &
               'code not available to handle time-varying radiative &
                &gases with gregorian calendar', FATAL)
        endif
      endif

!---------------------------------------------------------------------
!    if present, read the radiative gases restart file. set a flag 
!    indicating the presence of the file.
!---------------------------------------------------------------------
     restart_file = 'radiative_gases.res.nc'
      if(do_netcdf_restart) then
         id_restart = register_restart_field(Rad_restart, restart_file, 'vers', vers, no_domain = .true. )
         id_restart = register_restart_field(Rad_restart, restart_file, 'rco2', rco2, no_domain = .true. )          
         id_restart = register_restart_field(Rad_restart, restart_file, 'rf11', rf11, no_domain = .true. )
         id_restart = register_restart_field(Rad_restart, restart_file, 'rf12', rf12, no_domain = .true. ) 
         id_restart = register_restart_field(Rad_restart, restart_file, 'rf113', rf113, no_domain = .true. ) 
         id_restart = register_restart_field(Rad_restart, restart_file, 'rf22', rf22, no_domain = .true. ) 
         id_restart = register_restart_field(Rad_restart, restart_file, 'rch4', rch4, no_domain = .true. ) 
         id_restart = register_restart_field(Rad_restart, restart_file, 'rn2o', rn2o, no_domain = .true. ) 
         id_restart = register_restart_field(Rad_restart, restart_file, 'co2_for_last_tf_calc', &
                                             co2_for_last_tf_calc, mandatory=.false., no_domain = .true. ) 
         id_restart = register_restart_field(Rad_restart, restart_file, 'ch4_for_last_tf_calc', &
                                             ch4_for_last_tf_calc, mandatory=.false., no_domain = .true. ) 
         id_restart = register_restart_field(Rad_restart, restart_file, 'n2o_for_last_tf_calc', &
                                             n2o_for_last_tf_calc, mandatory=.false., no_domain = .true. )     
      endif

      restart_present = .false.
      if (file_exist('INPUT/radiative_gases.res.nc')) then
         if (mpp_pe() == mpp_root_pe()) call error_mesg ('radiative_gases_mod', &
              'Reading NetCDF formatted restart file: INPUT/radiative_gases.res.nc', NOTE)
         if(.not. do_netcdf_restart) call error_mesg ('radiative_gases_mod', &
              'netcdf format restart file INPUT/radiative_gases.res.nc exist, but do_netcdf_restart is false.', FATAL)
         call restore_state(Rad_restart)
         restart_present = .true.
         if(vers >= 3) then
            if(.NOT. query_initialized(Rad_restart, id_restart) ) call error_mesg('radiative_gases_mod', &
                'vers >=3 and INPUT/radiative_gases.res.nc exist, but field n2o_for_last_tf_calc does not in that file', FATAL)
         else
            define_co2_for_last_tf_calc = .true.
            define_ch4_for_last_tf_calc = .true.
            define_n2o_for_last_tf_calc = .true.
         endif       
         vers = restart_versions(size(restart_versions(:)))     
      else
         if (file_exist ('INPUT/radiative_gases.res')) then
           call error_mesg ('radiative_gases_mod', &
                 'Native formatted restart file no longer supported.', FATAL)
         endif
      endif

!---------------------------------------------------------------------
!    call a routine for each gas to initialize its mixing ratio
!    and set a flag indicating whether it is fixed in time or time-
!    varying.  fixed-in-time gases will be defined from the 
!    source specified in the namelist.
!---------------------------------------------------------------------
      call define_ch4 (ch4_data_source)
      call define_n2o (n2o_data_source)
      call define_f11 (f11_data_source)
      call define_f12 (f12_data_source)
      call define_f113(f113_data_source)
      call define_f22 (f22_data_source)
      call define_co2 (co2_data_source)

!---------------------------------------------------------------------
!    define logical variable indicating whether ch4 is active.
!---------------------------------------------------------------------
      if ((.not. time_varying_ch4) .and. rch4 == 0.0) then
        Lw_control%do_ch4 = .false.
      else
        Lw_control%do_ch4 = .true.
      endif

!---------------------------------------------------------------------
!    define logical variable indicating whether n2o is active.
!---------------------------------------------------------------------
      if ((.not. time_varying_n2o) .and. rn2o == 0.0) then
        Lw_control%do_n2o = .false.
      else
        Lw_control%do_n2o = .true.
      endif

!--------------------------------------------------------------------
!    set flag to indicate variable has been initialized.
!--------------------------------------------------------------------
      Lw_control%do_ch4_iz = .true.
      Lw_control%do_n2o_iz = .true.

!---------------------------------------------------------------------
!    if any of the cfcs are activated, set a flag indicating that cfcs
!    are active.
!---------------------------------------------------------------------
      if ((.not. time_varying_f11) .and. rf11 == 0.0 .and. &
          (.not. time_varying_f12) .and. rf12 == 0.0 .and. &
          (.not. time_varying_f113) .and. rf113 == 0.0 .and. &
          (.not. time_varying_f22) .and. rf22 == 0.0 )  then 
        Lw_control%do_cfc = .false.
      else
        Lw_control%do_cfc = .true.
      endif

!---------------------------------------------------------------------
!    set flag to indicate variable has been initialized.
!---------------------------------------------------------------------
      Lw_control%do_cfc_iz = .true.

!---------------------------------------------------------------------
!    define a logical variable indicating whether co2 is to be 
!    activated. currently co2 must be activated. 
!---------------------------------------------------------------------
      if ((.not. time_varying_co2) .and. rco2 == 0.0) then
        Lw_control%do_co2 = .false.
      else
        Lw_control%do_co2 = .true.
      endif

!---------------------------------------------------------------------
!    set flag to indicate variable has been initialized.
!---------------------------------------------------------------------
      Lw_control%do_co2_iz = .true.

!--------------------------------------------------------------------
!    define module variable which will be contain mixing ratio of each 
!    gas as model is integrated in time.
!--------------------------------------------------------------------
      rrvch4  = rch4
      rrvn2o  = rn2o
      rrvf11  = rf11
      rrvf12  = rf12
      rrvf113 = rf113
      rrvf22  = rf22
      rrvco2  = rco2

!--------------------------------------------------------------------
!    verify that the nml variables used when co2 is varying with time
!    have been given acceptable values.
!--------------------------------------------------------------------
      if (time_varying_co2) then
        gas_name = 'co2 '
        call validate_time_varying_inputs   &
                        (gas_name, co2_base_time, co2_base_value,  &
                         co2_specification_type, co2_change_rate, &
                         co2_dataset_entry,  negative_offset_co2, &
                         Co2_offset, Co2_entry, &
                         co2_variation_type, Co2_time_list, co2_value)
      endif

!--------------------------------------------------------------------
!    verify that the nml variables used when ch4 is varying with time
!    have been given acceptable values.
!--------------------------------------------------------------------
      if (time_varying_ch4) then
        gas_name = 'ch4 '
        call validate_time_varying_inputs   &
                        (gas_name, ch4_base_time, ch4_base_value,  &
                         ch4_specification_type, ch4_change_rate, &
                         ch4_dataset_entry,  negative_offset_ch4, &
                         Ch4_offset, Ch4_entry, &
                         ch4_variation_type, Ch4_time_list, ch4_value)
      endif

!--------------------------------------------------------------------
!    verify that the nml variables used when n2o is varying with time
!    have been given acceptable values.
!--------------------------------------------------------------------
      if (time_varying_n2o) then
        gas_name = 'n2o '
        call validate_time_varying_inputs   &
                        (gas_name, n2o_base_time, n2o_base_value,  &
                         n2o_specification_type, n2o_change_rate, &
                         n2o_dataset_entry,  negative_offset_n2o, &
                         N2o_offset, N2o_entry, &
                         n2o_variation_type, N2o_time_list, n2o_value)
      endif

!--------------------------------------------------------------------
!    verify that the nml variables used when f11 is varying with time
!    have been given acceptable values.
!--------------------------------------------------------------------
      if (time_varying_f11) then
        gas_name = 'f11 '
        call validate_time_varying_inputs  &
                        (gas_name, f11_base_time, f11_base_value,  &
                         f11_specification_type, f11_change_rate, &
                         f11_dataset_entry,  negative_offset_f11, &
                         F11_offset, F11_entry, &
                         f11_variation_type, F11_time_list, f11_value)
      endif

!--------------------------------------------------------------------
!    verify that the nml variables used when f12 is varying with time
!    have been given acceptable values.
!--------------------------------------------------------------------
      if (time_varying_f12) then
        gas_name = 'f12 '
        call validate_time_varying_inputs   &
                        (gas_name, f12_base_time, f12_base_value, &
                         f12_specification_type, f12_change_rate, &
                         f12_dataset_entry,  negative_offset_f12, &
                         F12_offset, F12_entry, &
                         f12_variation_type, F12_time_list, f12_value)
      endif

!--------------------------------------------------------------------
!    verify that the nml variables used when f113 is varying with time
!    have been given acceptable values.
!--------------------------------------------------------------------
      if (time_varying_f113) then
        gas_name = 'f113'
        call validate_time_varying_inputs   &
                        (gas_name, f113_base_time, f113_base_value, &
                         f113_specification_type, f113_change_rate, &
                         f113_dataset_entry,  negative_offset_f113, &
                         F113_offset, F113_entry, &
                         f113_variation_type, F113_time_list,   &
                         f113_value)
      endif

!--------------------------------------------------------------------
!    verify that the nml variables used when f22 is varying with time
!    have been given acceptable values.
!--------------------------------------------------------------------
      if (time_varying_f22) then
        gas_name = 'f22 '
        call validate_time_varying_inputs  &
                        (gas_name, f22_base_time, f22_base_value, &
                         f22_specification_type, f22_change_rate, &
                         f22_dataset_entry,  negative_offset_f22, &
                         F22_offset, F22_entry, &
                         f22_variation_type, F22_time_list, f22_value)
      endif

      ico2 = get_tracer_index(MODEL_ATMOS, 'co2')
      if (ico2 == NO_TRACER .and. trim(co2_data_source) == 'predicted') then
        call error_mesg('radiation_driver_mod', &
        'co2 must be a tracer when predicted co2 desired for radiation.', FATAL)
      endif

!--------------------------------------------------------------------- 
!    call ozone_init to initialize the ozone field.
!---------------------------------------------------------------------
      call ozone_init (latb, lonb)

!---------------------------------------------------------------------
!    mark the module as initialized.
!---------------------------------------------------------------------
      module_is_initialized = .true.

!--------------------------------------------------------------------


end subroutine radiative_gases_init



!####################################################################


! <SUBROUTINE NAME="define_radiative_gases">
!  <OVERVIEW>
!   Subroutine that returns the current values of the radiative 
!    gas mixing ratios to radiation_driver in Rad_gases.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine that returns the current values of the radiative 
!    gas mixing ratios to radiation_driver in Rad_gases.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call define_radiative_gases (is, ie, js, je, Rad_time, lat, &
!                                Atmos_input, Time_next, Rad_gases)
!  </TEMPLATE>
!  <IN NAME="is,ie,js,je" TYPE="integer">
!   starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="Rad_time" TYPE="time_type">
!   time at which radiation is to be calculated
!                   [ time_type (days, seconds) ] 
!  </IN>
!  <IN NAME="lat" TYPE="real">
!   latitude of model points [ radians ] 
!  </IN>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
!   Atmospheric input data
!  </IN>
!  <IN NAME="Time_next" TYPE="time_type">
!   time on next timestep, used as stamp for diagnostic 
!                   output  [ time_type  (days, seconds) ]
!  </IN>
!  <INOUT NAME="Rad_gases" TYPE="radiative_gases_type">
!   radiative_gases_type variable containing the radi-
!                   ative gas input fields needed by the radiation 
!                   package
!  </INOUT>
! </SUBROUTINE>
!
subroutine define_radiative_gases (is, ie, js, je, Rad_time, lat, &
                                   Atmos_input, r, Time_next, Rad_gases)

!-------------------------------------------------------------------
!    define_radiative_gases returns the current values of the radiative 
!    gas mixing ratios to radiation_driver in Rad_gases.
!-------------------------------------------------------------------

integer,                    intent(in)    :: is, ie, js, je
type(time_type),            intent(in)    :: Rad_time, Time_next
real, dimension(:,:),       intent(in)    :: lat
type(atmos_input_type),     intent(in)    :: Atmos_input
real, dimension(:,:,:,:),   intent(in)    :: r
type(radiative_gases_type), intent(inout) :: Rad_gases

!---------------------------------------------------------------------
!
!  intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      Rad_Time     time at which radiation is to be calculated
!                   [ time_type (days, seconds) ] 
!      Time_next    time on next timestep, used as stamp for diagnostic 
!                   output  [ time_type  (days, seconds) ]  
!      lat          latitude of model points  [ radians ]
!      Atmos_input  atmos_input_type variable containing the atmospheric
!                   input fields needed by the radiation package
!      r            array of tracers, some of which may represent
!                   evolving, radiatively active gases (e.g. ozone) 
!
!
!  intent(inout) variables:
!
!      Rad_gases    radiative_gases_type variable containing the radi-
!                   ative gas input fields needed by the radiation 
!                   package
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables:
!
      character(len=8)   :: gas_name  ! name associated with the 
                                      ! radiative gas
      integer            :: yr, mo, dy, hr, mn, sc 
                                      ! components of Rad_time
      type(time_type)    :: Gas_time

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ( 'radiative_gases_mod', &
             'module has not been initialized', FATAL )
      endif

!--------------------------------------------------------------------
!    if time-varying co2 is desired, and the time at which variation 
!    was to begin has been exceeded, define the gas_name variable and
!    call define_gas_amount to return the values of co2 needed on this
!    timestep.
!--------------------------------------------------------------------
        if (time_varying_co2) then 
        else
           if (trim(co2_data_source) == 'predicted') then
              if (.not. use_globally_uniform_co2) then    
! if predicted, not globally uniform co2 for radiation is desired, then
! rrvco2 will have become an array and will be filled here:
!               rrvco2(:,:,:) = Atmos_input%tracer_co2(is:ie,js:je,:)  
              endif
           endif
        endif

!--------------------------------------------------------------------
!    fill the contents of the radiative_gases_type variable which
!    will be returned to the calling routine.  values of the gas mixing
!    ratio at the current time and a flag indicating if the gas is time-
!    varying are returned for all gases, and for gases for which tfs are
!    calculated, a variable indicating how long they have been varying,
!    and the value of gas mixing ratio used for the last tf calculation
!    are returned.
!---------------------------------------------------------------------
!   these values must now be filled from the module variables:
!      Rad_gases%ch4_tf_offset = ch4_tf_offset
!      Rad_gases%n2o_tf_offset = n2o_tf_offset
!      Rad_gases%co2_tf_offset = co2_tf_offset
!      Rad_gases%ch4_for_next_tf_calc = ch4_for_next_tf_calc
!      Rad_gases%n2o_for_next_tf_calc = n2o_for_next_tf_calc
!      Rad_gases%co2_for_next_tf_calc = co2_for_next_tf_calc

!      Rad_gases%rrvch4  = rrvch4
!      Rad_gases%rrvn2o  = rrvn2o
!      Rad_gases%rrvf11  = rrvf11
!      Rad_gases%rrvf12  = rrvf12
!      Rad_gases%rrvf113 = rrvf113
!      Rad_gases%rrvf22  = rrvf22
!      Rad_gases%rrvco2  = rrvco2
!      Rad_gases%time_varying_co2  = time_varying_co2
!      Rad_gases%time_varying_ch4  = time_varying_ch4
!      Rad_gases%time_varying_n2o  = time_varying_n2o
!      Rad_gases%time_varying_f11  = time_varying_f11
!      Rad_gases%time_varying_f12  = time_varying_f12
!      Rad_gases%time_varying_f113 = time_varying_f113
!      Rad_gases%time_varying_f22  = time_varying_f22
!      if (time_varying_co2) then
!        Rad_gases%Co2_time = Co2_time_list(1)
!      endif
!      if (time_varying_ch4) then
!        Rad_gases%Ch4_time = Ch4_time_list(1)
!      endif
!      if (time_varying_n2o) then
!        Rad_gases%N2o_time = N2o_time_list(1)
!      endif
!RSH    define value for the new variable 
!RSH                     Rad_gases%use_model_supplied_co2, .true. for
!RSH   co2_data_source = 'predicted', .false. otherwise.
!      if (trim(co2_data_source) == 'predicted') then
!         Rad_gases%use_model_supplied_co2 = .true.
!      else
!         Rad_gases%use_model_supplied_co2 = .false.
!      endif

!      Rad_gases%co2_for_last_tf_calc = co2_for_last_tf_calc
!      Rad_gases%ch4_for_last_tf_calc = ch4_for_last_tf_calc
!      Rad_gases%n2o_for_last_tf_calc = n2o_for_last_tf_calc

!--------------------------------------------------------------------
!    allocate an array in a radiative_gases_type variable to hold the
!    model ozone field at the current time. call ozone_driver to define
!    this field for use in the radiation calculation.
!--------------------------------------------------------------------
      allocate (Rad_gases%qo3(ie-is+1, je-js+1,    &
                              size(Atmos_input%press,3) - 1))
      Rad_gases%qo3 = 0.
      call ozone_driver (is, ie, js, je, lat, Rad_time, Atmos_input, &
                         r, Rad_gases)


!---------------------------------------------------------------------


end subroutine define_radiative_gases


!#####################################################################

subroutine radiative_gases_time_vary (Rad_time, gavg_rrv, Rad_gases_tv)

!---------------------------------------------------------------------
!     subroutine radiative_gases_time_vary calculates time-dependent, space-
!     independent quantities needed by this module
!---------------------------------------------------------------------

type(time_type),    intent(in)   :: Rad_time
real, dimension(:), intent(in)   :: gavg_rrv
type(radiative_gases_type), intent(inout)  :: Rad_gases_tv

!---------------------------------------------------------------------
!  local variables:
!
      character(len=8)   :: gas_name  ! name associated with the 
                                      ! radiative gas
      integer            :: yr, mo, dy, hr, mn, sc 
                                      ! components of Rad_time
      type(time_type)    :: Gas_time

!---------------------------------------------------------------------

!--------------------------------------------------------------------
!    if time-varying ch4 is desired, and the time at which variation 
!    was to begin has been exceeded, define the gas_name variable and
!    call define_gas_amount to return the values of ch4 needed on this
!    timestep.
!--------------------------------------------------------------------
        if (time_varying_ch4) then 
            if (negative_offset_ch4) then
              Gas_time = Rad_time - Ch4_offset
            else
              Gas_time = Rad_time + Ch4_offset
            endif
          if (Gas_time >= Ch4_time_list(1)) then
!         if (Rad_time >= Ch4_time_list(1)) then
            gas_name = 'ch4 '
            call define_gas_amount      &
                (gas_name, Gas_time, ch4_specification_type,  &
!               (gas_name, Rad_time, ch4_specification_type,  &
!                negative_offset_ch4, Ch4_offset, &
                 ch4_variation_type, ch4_floor, ch4_ceiling, rch4,   &
                 ch4_uses_tfs, ch4_change_rate, rrvch4, Ch4_time_list, &
                 ch4_value, &
                 gas_tf_calc_intrvl =        &
                            Rad_control%ch4_tf_calc_intrvl,         &
                 gas_tf_time_displacement =  &
                            Rad_control%ch4_tf_time_displacement,   &
                 calc_gas_tfs_on_first_step =  &
                            Rad_control%calc_ch4_tfs_on_first_step, &
                 calc_gas_tfs_monthly       =  &
                            Rad_control%calc_ch4_tfs_monthly,       &
                 use_current_gas_for_tf = &
                            Rad_control%use_current_ch4_for_tf,  &
                 gas_tf_offset = &
                            ch4_tf_offset,  &
                 gas_for_last_tf_calc =   &
                            ch4_for_last_tf_calc,    &
                 gas_for_next_tf_calc = &
                            ch4_for_next_tf_calc, &
                 gas_tfs_needed = ch4_tfs_needed, &
                 define_gas_for_last_tf_calc = &
                            define_ch4_for_last_tf_calc)
                 if (Rad_control%calc_ch4_tfs_on_first_step) then
                   ch4_tfs_needed = .false.
                 endif

!---------------------------------------------------------------------
!    if time-variation is desired, but it is not yet time to begin
!    variation, define the ch4 mixing ratio that was used for the last
!    transmission function calculation, so that the tfs may be calcul-
!    ated as previously. (this is only done on initial timestep of a 
!    job).
!---------------------------------------------------------------------
          else  ! (Rad_time > Ch4_time)
            ch4_for_last_tf_calc = rrvch4
            ch4_tf_offset = 0.0
          endif   ! (Rad_time > Ch4_time)
        else
          ch4_for_last_tf_calc = rrvch4
        endif  ! (time_varying_ch4)

!--------------------------------------------------------------------
!    if time-varying n2o is desired, and the time at which variation 
!    was to begin has been exceeded, define the gas_name variable and
!    call define_gas_amount to return the values of n2o needed on this
!    timestep.
!--------------------------------------------------------------------
        if (time_varying_n2o) then 
            if (negative_offset_n2o) then
              Gas_time = Rad_time - N2o_offset
            else
              Gas_time = Rad_time + N2o_offset
            endif
          if (Gas_time >= N2o_time_list(1)) then
            gas_name = 'n2o '
            call define_gas_amount      &
                (gas_name, Gas_time, n2o_specification_type,  &
!                negative_offset_n2o, N2o_offset, &
                 n2o_variation_type, n2o_floor, n2o_ceiling, rn2o,  &
                 n2o_uses_tfs, n2o_change_rate, rrvn2o, N2o_time_list, &
                 n2o_value, &
                 gas_tf_calc_intrvl =        &
                               Rad_control%n2o_tf_calc_intrvl,         &
                 gas_tf_time_displacement =  &
                               Rad_control%n2o_tf_time_displacement,   &
                 calc_gas_tfs_on_first_step =  &
                               Rad_control%calc_n2o_tfs_on_first_step, &
                 calc_gas_tfs_monthly       =  &
                            Rad_control%calc_n2o_tfs_monthly,       &
                 use_current_gas_for_tf = &
                               Rad_control%use_current_n2o_for_tf,  &
                 gas_tf_offset = &
                               n2o_tf_offset,  &
                 gas_for_last_tf_calc =   &
                               n2o_for_last_tf_calc,    &
                 gas_for_next_tf_calc = &
                               n2o_for_next_tf_calc, &
                 gas_tfs_needed = n2o_tfs_needed, &
                 define_gas_for_last_tf_calc = &
                               define_n2o_for_last_tf_calc)
                 if (Rad_control%calc_n2o_tfs_on_first_step) then
                   n2o_tfs_needed = .false.
                 endif

!---------------------------------------------------------------------
!    if time-variation is desired, but it is not yet time to begin
!    variation, define the n2o mixing ratio that was used for the last
!    transmission function calculation, so that the tfs may be calcul-
!    ated as previously. (this is only done on initial timestep of a 
!    job).
!---------------------------------------------------------------------
          else  ! (Rad_time > N2o_time)
            n2o_for_last_tf_calc = rrvn2o
            n2o_tf_offset = 0.0
          endif   ! (Rad_time > N2o_time)
        else
          n2o_for_last_tf_calc = rrvn2o
        endif  ! (time_varying_n2o)

!--------------------------------------------------------------------
!    if time-varying f11 is desired, and the time at which variation 
!    was to begin has been exceeded, define the gas_name variable and
!    call define_gas_amount to return the values of f11 needed on this
!    timestep.
!--------------------------------------------------------------------
        if (time_varying_f11) then 
            if (negative_offset_f11) then
              Gas_time = Rad_time - F11_offset
            else
              Gas_time = Rad_time + F11_offset
            endif
          if (Gas_time >= F11_time_list(1)) then
            gas_name = 'f11 '
            call define_gas_amount      &
                (gas_name, Gas_time, f11_specification_type,  &
!                negative_offset_f11, F11_offset, &
                 f11_variation_type, f11_floor, f11_ceiling, rf11,   &
                 f11_uses_tfs, f11_change_rate, rrvf11, F11_time_list, &
                 f11_value)
          endif   ! (Rad_time > F11_time)
        endif  ! (time_varying_f11)

!--------------------------------------------------------------------
!    if time-varying f12 is desired, and the time at which variation 
!    was to begin has been exceeded, define the gas_name variable and
!    call define_gas_amount to return the values of f12 needed on this
!    timestep.
!--------------------------------------------------------------------
        if (time_varying_f12) then 
            if (negative_offset_f12) then
              Gas_time = Rad_time - F12_offset
            else
              Gas_time = Rad_time + F12_offset
            endif
          if (Gas_time >= F12_time_list(1)) then
            gas_name = 'f12 '
            call define_gas_amount      &
                (gas_name, Gas_time, f12_specification_type,   &
!                negative_offset_f12, F12_offset, &
                 f12_variation_type, f12_floor, f12_ceiling, rf12,   &
                 f12_uses_tfs, f12_change_rate, rrvf12, F12_time_list, &
                 f12_value)
          endif   ! (Rad_time > F12_time)
        endif  ! (time_varying_f12)

!--------------------------------------------------------------------
!    if time-varying f113 is desired, and the time at which variation 
!    was to begin has been exceeded, define the gas_name variable and
!    call define_gas_amount to return the values of f113 needed on this
!    timestep.
!--------------------------------------------------------------------
        if (time_varying_f113) then 
            if (negative_offset_f113) then
              Gas_time = Rad_time - F113_offset
            else
              Gas_time = Rad_time + F113_offset
            endif
          if (Gas_time >= F113_time_list(1)) then
            gas_name = 'f113'
            call define_gas_amount      &
                (gas_name, Gas_time, f113_specification_type,  &
!                negative_offset_f113, F113_offset, &
                 f113_variation_type, f113_floor, f113_ceiling, rf113, &
                 f113_uses_tfs, f113_change_rate, rrvf113,  &
                 F113_time_list, f113_value)
          endif   ! (Rad_time > F113_time)
        endif  ! (time_varying_f113)

!--------------------------------------------------------------------
!    if time-varying f22 is desired, and the time at which variation 
!    was to begin has been exceeded, define the gas_name variable and
!    call define_gas_amount to return the values of f22 needed on this
!    timestep.
!--------------------------------------------------------------------
        if (time_varying_f22) then 
            if (negative_offset_f22) then
              Gas_time = Rad_time - F22_offset
            else
              Gas_time = Rad_time + F22_offset
            endif
          if (Gas_time >= F22_time_list(1)) then
            gas_name = 'f22 '
            call define_gas_amount      &
                (gas_name, Gas_time, f22_specification_type,  &
!                negative_offset_f22, F22_offset, &
                 f22_variation_type, f22_floor, f22_ceiling, rf22, &
                 f22_uses_tfs, f22_change_rate, rrvf22, F22_time_list, &
                 f22_value)
          endif   ! (Rad_time > F22_time)
        endif  ! (time_varying_f22)

!--------------------------------------------------------------------
!    if time-varying co2 is desired, and the time at which variation 
!    was to begin has been exceeded, define the gas_name variable and
!    call define_gas_amount to return the values of co2 needed on this
!    timestep.
!--------------------------------------------------------------------
        if (time_varying_co2) then 
            if (negative_offset_co2) then
              Gas_time = Rad_time - Co2_offset
            else
              Gas_time = Rad_time + Co2_offset
            endif
          if (Gas_time >= Co2_time_list(1)) then
            gas_name = 'co2 '
            call define_gas_amount      &
                (gas_name, Gas_time, co2_specification_type,  &
!                negative_offset_co2, Co2_offset, &
                 co2_variation_type, co2_floor, co2_ceiling, rco2, &
                 co2_uses_tfs, co2_change_rate, rrvco2, Co2_time_list, &
                 co2_value,  &
                 gas_tf_calc_intrvl =        &
                               Rad_control%co2_tf_calc_intrvl,         &
                 gas_tf_time_displacement =  &
                               Rad_control%co2_tf_time_displacement,   &
                 calc_gas_tfs_on_first_step =  &
                               Rad_control%calc_co2_tfs_on_first_step, &
                 calc_gas_tfs_monthly       =  &
                            Rad_control%calc_co2_tfs_monthly,       &
                 use_current_gas_for_tf = &
                               Rad_control%use_current_co2_for_tf,  &
                 gas_tf_offset = &
                               co2_tf_offset,  &
                 gas_for_last_tf_calc =   &
                               co2_for_last_tf_calc,    &
                 gas_for_next_tf_calc = &
                               co2_for_next_tf_calc, &
                 gas_tfs_needed = co2_tfs_needed, &
                 define_gas_for_last_tf_calc = &
                               define_co2_for_last_tf_calc)
                 if (Rad_control%calc_co2_tfs_on_first_step) then
                   co2_tfs_needed = .false.
                 endif

!---------------------------------------------------------------------
!    if time-variation is desired, but it is not yet time to begin
!    variation, define the co2 mixing ratio that was used for the last
!    transmission function calculation, so that the tfs may be calcul-
!    ated as previously. (this is only needed on initial timestep of a 
!    job).
!---------------------------------------------------------------------
          else  ! (Rad_time > Co2_time)
            co2_for_last_tf_calc = rrvco2
            co2_tf_offset = 0.0
          endif   ! (Rad_time > Co2_time)
        else
           if (trim(co2_data_source) == 'predicted') then
              if (use_globally_uniform_co2) then    
                 rrvco2 = gavg_rrv(ico2)
              else
!    if 3d co2 distribution desired for radiation, it will be defined in
!    define_radiatiove_gases.
              endif
           else !trim(co2_data_source) == 'predicted')
              co2_for_last_tf_calc = rrvco2
           endif  !(trim(co2_data_source) == 'predicted')
        endif  ! (time_varying_co2)


!---------------------------------------------------------------------
!    print out the current gas mixing ratios, if desired.
!---------------------------------------------------------------------
      if ((mpp_pe() == mpp_root_pe()) .and. verbose >= 3) then
        if (Rad_control%do_lw_rad) then
          print_alarm = print_alarm - Rad_control%lw_rad_time_step
        endif
        if (print_alarm <= 0) then
          call get_date (Rad_time, yr, mo, dy, hr, mn, sc)
          write (*, FMT ='(a, i5, i3, i3, i3, i3, i3,   &
                           & a, f11.6, a, f11.6, a, /,  &
                           & 7x, a, f11.6, a, f11.6,  &
                           & a, f11.6, a , /, 7x, a,  f11.6, &
                           & a, f11.6, a)')  &
                  'Time =',  yr, mo, dy, hr, mn, sc, &
                  '    ch4 = ', rrvch4*1.0e09, 'ppb  n2o = ' ,  &
                  rrvn2o*1.0e9, 'ppb', 'co2  = ', rrvco2*1.0e6,  &
                  'ppm  f11 = ' , rrvf11*1.0e12,  'ppt  f12 = ', &
                  rrvf12*1.0e12, 'ppt', 'f113 = ', rrvf113*1.0e12, &
                  'ppt  f22 = ', rrvf22*1.0e12, 'ppt'
          print_alarm = gas_printout_freq*3600
        endif
      endif

!--------------------------------------------------------------------
!    fill the contents of the radiative_gases_type variable which
!    will be returned to the calling routine.  values of the gas mixing
!    ratio at the current time and a flag indicating if the gas is time-
!    varying are returned for all gases, and for gases for which tfs are
!    calculated, a variable indicating how long they have been varying,
!    and the value of gas mixing ratio used for the last tf calculation
!    are returned.
!---------------------------------------------------------------------
!   these values must now be filled from the module variables:
      Rad_gases_tv%ch4_tf_offset = ch4_tf_offset
      Rad_gases_tv%n2o_tf_offset = n2o_tf_offset
      Rad_gases_tv%co2_tf_offset = co2_tf_offset
      Rad_gases_tv%ch4_for_next_tf_calc = ch4_for_next_tf_calc
      Rad_gases_tv%n2o_for_next_tf_calc = n2o_for_next_tf_calc
      Rad_gases_tv%co2_for_next_tf_calc = co2_for_next_tf_calc

      Rad_gases_tv%rrvch4  = rrvch4
      Rad_gases_tv%rrvn2o  = rrvn2o
      Rad_gases_tv%rrvf11  = rrvf11
      Rad_gases_tv%rrvf12  = rrvf12
      Rad_gases_tv%rrvf113 = rrvf113
      Rad_gases_tv%rrvf22  = rrvf22
      Rad_gases_tv%rrvco2  = rrvco2
      Rad_gases_tv%time_varying_co2  = time_varying_co2
      Rad_gases_tv%time_varying_ch4  = time_varying_ch4
      Rad_gases_tv%time_varying_n2o  = time_varying_n2o
      Rad_gases_tv%time_varying_f11  = time_varying_f11
      Rad_gases_tv%time_varying_f12  = time_varying_f12
      Rad_gases_tv%time_varying_f113 = time_varying_f113
      Rad_gases_tv%time_varying_f22  = time_varying_f22
      if (time_varying_co2) then
        Rad_gases_tv%Co2_time = Co2_time_list(1)
      endif
      if (time_varying_ch4) then
        Rad_gases_tv%Ch4_time = Ch4_time_list(1)
      endif
      if (time_varying_n2o) then
        Rad_gases_tv%N2o_time = N2o_time_list(1)
      endif
!    define value for the new variable 
!    Rad_gases%use_model_supplied_co2, .true. for
!                    co2_data_source = 'predicted', .false. otherwise.
      if (trim(co2_data_source) == 'predicted') then
         Rad_gases_tv%use_model_supplied_co2 = .true.
      else
         Rad_gases_tv%use_model_supplied_co2 = .false.
      endif

      Rad_gases_tv%co2_for_last_tf_calc = co2_for_last_tf_calc
      Rad_gases_tv%ch4_for_last_tf_calc = ch4_for_last_tf_calc
      Rad_gases_tv%n2o_for_last_tf_calc = n2o_for_last_tf_calc


!----------------------------------------------------------------------

            call ozone_time_vary (Rad_time)

!--------------------------------------------------------------------


end subroutine radiative_gases_time_vary



!##################################################################

subroutine radiative_gases_endts

     call ozone_endts


end subroutine radiative_gases_endts




!##################################################################

!####################################################################
! <SUBROUTINE NAME="radiative_gases_end">
!  <OVERVIEW>
!    radiative_gases_end is the destructor for radiative_gases_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    radiative_gases_end is the destructor for radiative_gases_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call radiative_gases_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine radiative_gases_end

!---------------------------------------------------------------------
!    radiative_gases_end is the destructor for radiative_gases_mod.
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ( 'radiative_gases_mod', &
               'module has not been initialized', FATAL )
      endif

      call radiative_gases_restart

!--------------------------------------------------------------------
!    deallocate the timeseries arrays.
!--------------------------------------------------------------------
      if (associated(co2_value)) deallocate(co2_value)
      deallocate (ch4_value, n2o_value, f11_value, &
                  f12_value, f113_value, f22_value)    
      if (associated(Co2_time_list)) deallocate(Co2_time_list)
      deallocate (Ch4_time_list, N2o_time_list, &
                  F11_time_list, F12_time_List, &
                  F113_time_list, F22_time_list)

!---------------------------------------------------------------------
!    call the destructors for the component gas module(s).
!---------------------------------------------------------------------
      call ozone_end

!--------------------------------------------------------------------
      module_is_initialized = .false.


end subroutine radiative_gases_end

!#######################################################################
! <SUBROUTINE NAME="radiative_gases_restart">
!
! <DESCRIPTION>
! write out restart file.
! Arguments: 
!   timestamp (optional, intent(in)) : A character string that represents the model time, 
!                                      used for writing restart. timestamp will append to
!                                      the any restart file name as a prefix. 
! </DESCRIPTION>
!
subroutine radiative_gases_restart(timestamp)
   character(len=*), intent(in), optional :: timestamp

! Make sure that the restart_versions variable is up to date.
   vers = restart_versions(size(restart_versions(:)))     
   if( do_netcdf_restart ) then
      if(mpp_pe() == mpp_root_pe() ) then
         call error_mesg ('radiative_gases_mod', 'Writing NetCDF formatted restart file: RESTART/radiative_gases.res.nc', NOTE)
      endif
      call save_restart(Rad_restart, timestamp)
   else
      call error_mesg ('radiative_gases_mod', &
         'Native intermediate restart files are not supported.', FATAL)
   endif

end subroutine radiative_gases_restart
! </SUBROUTINE>

!####################################################################
! <SUBROUTINE NAME="radiative_gases_dealloc">
!  <OVERVIEW>
!    radiative_gases_end is the destructor for radiative_gases_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    radiative_gases_end is the destructor for radiative_gases_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call radiative_gases_dealloc (Rad_gases)
!  </TEMPLATE>
!  <INOUT NAME="Rad_gases" TYPE="radiative_gases_type">
!   radiative_gases_type variable containing the radi-
!              ative gas input fields needed by the radiation package
!  </INOUT>
! </SUBROUTINE>
!
subroutine radiative_gases_dealloc (Rad_gases)

!---------------------------------------------------------------------
!
!--------------------------------------------------------------------

type(radiative_gases_type), intent(inout)  :: Rad_gases

!---------------------------------------------------------------------
!  intent(inout) variable:
!
!     Rad_gases
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ( 'radiative_gases_mod', &
             'module has not been initialized', FATAL )
      endif

!--------------------------------------------------------------------
!    deallocate the variables in Rad_gases.
!--------------------------------------------------------------------
      deallocate (Rad_gases%qo3)


!--------------------------------------------------------------------
!    save the value of the gas mixing ratio used to calculate the gas
!    transmission functions (it may have been updated on this step)
!    so that it is available to write to the restart file.
!--------------------------------------------------------------------
      co2_for_last_tf_calc = Rad_gases%co2_for_last_tf_calc
      ch4_for_last_tf_calc = Rad_gases%ch4_for_last_tf_calc
      n2o_for_last_tf_calc = Rad_gases%n2o_for_last_tf_calc

!---------------------------------------------------------------------


end subroutine radiative_gases_dealloc 



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                    PRIVATE SUBROUTINES
!                                
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!#####################################################################
! <SUBROUTINE NAME="validate_time_varying_inputs">
!  <OVERVIEW>
!   validate_time_varying_inputs checks for consistency among the 
!   namelist parameters defining the time variation of the input gas.
!   NOTE: THIS IS A PRIVATE SUBROUTINE.
!
!  </OVERVIEW>
!
!  <DESCRIPTION>
!   Subroutine validate_time_varying_inputs performs the following 
!   checks of the namelist variables:
!     1) Verifies that base_time has a non-zero month and day number,
!        indicating a change from the default;
!     2) Verifies that the base value of gas mixing ratio is non-zero;
!     3) Verifies that specification_type is valid, either 
!        'base_and_trend' or 'time_series';
!     4) Verifies that variation_type is valid, either 'linear' or
!        'logarithmic';
!     5) When specification_type is 'base_and_trend', verifies that 
!        change_rate is non-zero;
!  </DESCRIPTION>
!  <TEMPLATE>
!   call validate_time_varying_inputs   &
!                     (gas, base_time, base_value, specification_type, &
!                      change_rate, variation_type, Gas_time_list,  &
!                      gas_value)
!  </TEMPLATE>
!  <IN NAME="gas">
!   name associated with the current gas
!  </IN>
!  <IN NAME="base_time">
!   time at which the base_value is applicable
!   [ year, month, day, hour, minute, second ]
!  </IN>
!  <IN NAME="base_value">
!   base value for vol. mixing ratio of gas 
!   [ number / number ]
!  </IN>
!  <IN NAME="specification_type">
!   specification of form of time variation of gas 
!  </IN>
!  <IN NAME="change_rate">
!   rate of change of gas; 1.00 + [ percent change / year ]
!  </IN>
!  <IN NAME="variation_type">
!   form of the temporal behavior of gas; either 'linear' or 
!   'logarithmic'
!  </IN>
!  <INOUT NAME="Gas_time_list">
!   array of time_type variables defining the data times for the gas;
!   if specification_type is timeseries, then it is the set of times
!   in the daa set, if specification type is base_and_trend, then it
!   is an array of dimension 1 containing the xxx_base_time. 
!   [ time_type ]
!  </INOUT>
!  <IN NAME="gas_value">
!   array of values of gas concentrations corresponding to the times
!   in Gas_time_list [ number / number ]
!  </IN>
!

!<PUBLICROUTINE>
!
!NOTE: THIS IS A PRIVATE SUBROUTINE.
!

subroutine validate_time_varying_inputs   &
                      (gas, base_time, base_value, specification_type, &
                       change_rate,  gas_dataset_entry,  &
                       negative_offset_gas, Gas_offset, Gas_entry, &
                       variation_type, Gas_time_list, gas_value)

!---------------------------------------------------------------------
!    validate_time_varying_inputs checks for consistency among the 
!    namelist parameters defining the time variation of the input gas.
!--------------------------------------------------------------------

character(len=*),      intent(in)  :: gas
integer, dimension(6), intent(in)  :: base_time, gas_dataset_entry
real,                  intent(in)  :: base_value,            &
                                      change_rate
logical,               intent(inout)  :: negative_offset_gas
character(len=*),     intent(in)  :: specification_type, variation_type
type(time_type),dimension(:), intent(inout)  :: Gas_time_list
type(time_type), intent(inout)  :: Gas_offset, Gas_entry
real, dimension(:), intent(in) :: gas_value

!--------------------------------------------------------------------
!   local variables:

      integer :: n

!</PUBLICROUTINE>

!------------------------------------------------------------------
!    perform checks for the base_and_trend specification_type.
!------------------------------------------------------------------
      if (trim(specification_type) == 'base_and_trend') then

!------------------------------------------------------------------
!    verify that base_time has a valid value (month and day /= 0 , 
!    hr, min and sec == 0). 
!------------------------------------------------------------------
        if (base_time(4) /= 0 .or. base_time(5) /= 0  .or. &
            base_time(6) /= 0)  then  
          call error_mesg ('radiative_gases_mod', &
           'base_time for gas' // trim(gas)//'must be specified as 00Z &
            &of desired day', FATAL)
        endif

!------------------------------------------------------------------
!    verify that base_value is non-zero. 
!------------------------------------------------------------------
        if (base_value < 0.0) then
          call error_mesg ('radiative_gases_mod', &
                        trim(gas)//'_base_value must be >= 0.0', FATAL)
        endif

!---------------------------------------------------------------------
!    convert the base_time to a time_type and store in Gas_time_list(1).
!---------------------------------------------------------------------
        if (base_time(2) /= 0 .and. base_time(3) /= 0 ) then  
          Gas_time_list(1) = set_date (base_time(1), base_time(2), &
                                       base_time(3), base_time(4), &
                                       base_time(5), base_time(6))  
        else
          call error_mesg ('radiative_gases_mod', &
           'must supply valid date for '//trim(gas)//'_base_time when&
                              & using time_varying '//trim(gas), FATAL)
        endif

!------------------------------------------------------------------
!    make sure that change_rate has been specified as non-zero; a value
!    of 0.0 corresponds to non-time-varying, and is not allowed.
!------------------------------------------------------------------
        if (change_rate == 0.0) then
          call error_mesg ('radiative_gases_mod', &
            ' have specified base_and_trend '//gas//' variation but ' &
                            //trim(gas)//'_change_rate is zero', FATAL)
        endif
        
!------------------------------------------------------------------
!    set Gas_offset to 0 when timeseries is not being used.
!------------------------------------------------------------------
        Gas_offset = set_time(0,0)

!------------------------------------------------------------------
!    perform checks for the time_series specification_type.
!------------------------------------------------------------------
      else if (trim(specification_type) ==  'time_series') then

!------------------------------------------------------------------
!    make sure that the entries are in chronological order.
!------------------------------------------------------------------
        do n = 2, size(Gas_time_list(:)) 
          if (Gas_time_list(n) < Gas_time_list(n-1)) then
            call error_mesg ('radiative_gases_mod', &
                 'times  for ' // trim(gas) //   &
                 ' in Gas_time_list are not in sequence', FATAL) 
          endif
        end do
      
!------------------------------------------------------------------
!    make sure that all gas concentrations are acceptable in magnitude.
!------------------------------------------------------------------
        do n = 1, size(Gas_time_list(:)) 
          if (gas_value(n) < 0) then
          call error_mesg ('radiative_gases_mod', &
             trim(gas)//'_value must be >= 0.0', FATAL)
          endif
        end do
        
!------------------------------------------------------------------
!    if 'time_series' is specified, variation_type
!    must be 'linear'.
!------------------------------------------------------------------
        if (trim(variation_type) == 'logarithmic') then
          call error_mesg ('radiative_gases_mod', &
            'logarithmic variation not allowed with time_series &
                                   &specification', FATAL)
        endif

!---------------------------------------------------------------------
!    define model initial time (from diag_table).
!---------------------------------------------------------------------
        Model_init_time = get_base_time()
 
!---------------------------------------------------------------------
!    if an entry into the gas timeseries has not been specified, use
!    the model base time as the entry point.
!---------------------------------------------------------------------
        if (gas_dataset_entry(1) == 1 .and. &
            gas_dataset_entry(2) == 1 .and. &
            gas_dataset_entry(3) == 1 .and. &
            gas_dataset_entry(4) == 0 .and. &
            gas_dataset_entry(5) == 0 .and. &
            gas_dataset_entry(6) == 0 ) then
          Gas_entry = Model_init_time

!---------------------------------------------------------------------
!    define time for which gas data is desired.
!---------------------------------------------------------------------
        else
          Gas_entry  = set_date (gas_dataset_entry(1), &
                                 gas_dataset_entry(2), &
                                 gas_dataset_entry(3), &
                                 gas_dataset_entry(4), &
                                 gas_dataset_entry(5), &
                                 gas_dataset_entry(6))
        endif

        call error_mesg ( 'radiative_gases_mod', &
              'PROCESSING TIMESERIES FOR ' // trim(gas), NOTE)
        call print_date (Gas_entry , str='Data from timeseries &
                                           &at time:')
        call print_date(Model_init_time , str='This data is mapped to&
                                                  & model time:')

!----------------------------------------------------------------------
!    define the offset from model base time to gas_dataset_entry
!    as a time_type variable.
!----------------------------------------------------------------------
        Gas_offset = Gas_entry - Model_init_time

        if (Model_init_time > Gas_entry) then
          negative_offset_gas = .true.
        else
          negative_offset_gas = .false.
        endif

!------------------------------------------------------------------
!    if specification_type is invalid, issue an error message.
!------------------------------------------------------------------
      else
        call error_mesg ('radiative_gases_mod', &
               ' invalid '//trim(gas)//'_specification_type', FATAL)
      endif

!------------------------------------------------------------------
!    verify that variation_type is valid.
!------------------------------------------------------------------
      if (trim(variation_type) == 'linear' .or. &
          trim(variation_type) == 'logarithmic' ) then
      else
        call  error_mesg ('radiative_gases_mod', &
          trim(gas)//'_variation_type must be "linear" or &
                                             &"logarithmic" ', FATAL)
      endif

!---------------------------------------------------------------------



end subroutine validate_time_varying_inputs


! </SUBROUTINE>

!###################################################################
! <SUBROUTINE NAME="define_ch4">
!  <OVERVIEW>
!   Subroutine that provides initial values for ch4 mixing ratio.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine that provides initial values for ch4 mixing ratio.if ch4
!    is fixed in time, the value is given by the namelist specification.
!    if ch4 is time-varying, the values are obtained from either a
!    restart or input data file.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call define_ch4 (data_source) 
!  </TEMPLATE>
!  <IN NAME="data_source" TYPE="character">
!   character string defining source to use to define ch4 initial values
!  </IN>
! </SUBROUTINE>
!
subroutine define_ch4 (data_source) 

!---------------------------------------------------------------------
!    define_ch4 provides initial values for ch4 mixing ratio. if ch4
!    is fixed in time, the value is given by the namelist specification.
!    if ch4 is time-varying, the values are obtained from either a
!    restart or input data file.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
character(len=*), intent(in)    ::  data_source
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   intent(in) variables:
!
!       data_source     character string defining source to use to
!                       define ch4 initial values
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:
!
!---------------------------------------------------------------------
!    initial trace gas volume mixing ratios in (no./no.) from various
!    sources.
!---------------------------------------------------------------------
      real       ::  rch4_ipcc_80  = 1.56900E-06
      real       ::  rch4_ipcc_92  = 1.71400E-06
      real       ::  rch4_icrccm   = 1.75000E-06
      real       ::  rch4_ipcc_98  = 1.82120E-06




      integer    :: inrad   ! unit number for i/o

character(len=8)     :: gas_name ! name associated with current
                                 ! gas being processed

!---------------------------------------------------------------------
!    define initial ch4 mixing ratios to be used.
!    'icrccm'     --> rch4_icrccm
!    'ipcc80'     --> rch4_ipcc_80
!    'ipcc92'     --> rch4_ipcc_92
!    'ipcc98'     --> rch4_ipcc_98
!    'input'      --> file INPUT/id1ch4n2o, record 1
!    'restart'    --> values read from restart file
!    'prescribed' --> from restart file; if restart not present, 
!                     from input file
!    'predicted'  --> from restart file; if restart not present, 
!                     from input file
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if specification_type is 'base_and_trend', allocate length (1)
!    arrays to hold the base_time and base_value.
!---------------------------------------------------------------------
      if (trim(ch4_specification_type) /= 'time_series') then
        allocate (Ch4_time_list(1))
        allocate (ch4_value(1))
      endif

      if (trim(data_source)      == 'icrccm') then
        rch4   = rch4_icrccm

      else if (trim(data_source) == 'ipcc_80') then
        rch4   = rch4_ipcc_80

      else if (trim(data_source) == 'ipcc_92') then
        rch4   = rch4_ipcc_92  

      else if (trim(data_source) == 'ipcc_98') then
        rch4   = rch4_ipcc_98

!--------------------------------------------------------------------
!    if data_source is an input file, determine if it is present. if so,
!    open and read.  if not present, write an error message and stop.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'input') then
        if (trim(ch4_specification_type) /= 'time_series') then
          if (file_exist ('INPUT/id1ch4n2o') ) then
            inrad = open_namelist_file ('INPUT/id1ch4n2o')
            read (inrad, FMT = '(5e18.10)')  rch4
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
                   'desired ch4_n2o input file is not present', FATAL)
          endif
        else
          gas_name = 'ch4 '
          call read_gas_timeseries (gas_name, ch4_value, &
                                    Ch4_time_list, time_varying_ch4, &
                                    ch4_dataset_entry, rch4)   
        endif

!--------------------------------------------------------------------
!    if data_source is a restart file and it is present, the value to be
!    used has been previously read. if not present, write an error 
!    message and stop.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'restart') then
        if (.not. restart_present ) then
          call error_mesg ( 'radiative_gases_mod', &
           'cannot use restart ch4 values without a restart file', &
                                  FATAL)
        endif

!--------------------------------------------------------------------
!    if data_source is 'prescribed' and a restart file is present, the 
!    value to be used has been previously read. if a restart file is
!    not present, check for an input file. if it is present, read the
!    file; if not, write an error message and stop. set the time_vary-
!    ing flag to .true.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'prescribed') then
        if (.not. restart_present) then
          if (file_exist ('INPUT/id1ch4n2o') ) then
            inrad = open_namelist_file ('INPUT/id1ch4n2o')
            read (inrad, FMT = '(5e18.10)') rch4
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
              'neither restart nor ch4 input file is present. one '//&
          'of these is required when the data_source is  '//&
          '"prescribed" ', FATAL)
          endif
        endif

!--------------------------------------------------------------------
!    if data_source is 'predicted' and a restart file is present, the 
!    value to be used has been previously read. if a restart file is
!    not present, check for an input file. if it is present, read the
!    file; if not, write an error message and stop. set the time_vary-
!    ing flag to .true.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'predicted') then
        if (.not. restart_present) then
          if (file_exist ('INPUT/id1ch4n2o') ) then
            inrad = open_namelist_file ('INPUT/id1ch4n2o')
            read (inrad, FMT = '(5e18.10)') rch4
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
              'neither restart nor ch4 input file is present. one '//&
          'of these is required when the data_source is  '//&
          '"predicted" ', FATAL)
          endif
        endif

!-------------------------------------------------------------------
!    when the data_source is 'namelist', the value of ch4 is obtained
!    from the namelist variable ch4_base_value.
!-------------------------------------------------------------------
      else if (trim(data_source) == 'namelist') then
        rch4 = ch4_base_value

!--------------------------------------------------------------------
!    write an error message if the data_source is invalid.
!--------------------------------------------------------------------
      else
        call error_mesg ('radiative_gases_mod', &
         'no valid data source was specified for ch4' , FATAL)
      endif

!---------------------------------------------------------------------
!    be sure value is within range of acceptable values. a later check
!    in lw_gases_stdtf_mod will further limit values to be those for
!    which tfs may be determined.
!---------------------------------------------------------------------
      if (rch4 < ch4_floor) then
        call error_mesg ('radiative_gases_mod', &
              'base ch4 mixing ratio LOWER THAN FLOOR value', FATAL)
      endif
      if (rch4 > ch4_ceiling) then
        call error_mesg ('radiative_gases_mod', &
              ' base ch4 mixing ratio HIGHER THAN CEILING value', FATAL)
      endif

!---------------------------------------------------------------------



end subroutine define_ch4



!#####################################################################
! <SUBROUTINE NAME="define_n2o">
!  <OVERVIEW>
!   Subroutine that provides initial values for n2o mixing ratio.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine that provides initial values for n2o mixing ratio.if n2o
!    is fixed in time, the value is given by the namelist specification.
!    if n2o is time-varying, the values are obtained from either a
!    restart or input data file.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call define_n2o (data_source) 
!  </TEMPLATE>
!  <IN NAME="data_source" TYPE="character">
!   character string defining source to use to define n2o initial values
!  </IN>
! </SUBROUTINE>
!
subroutine define_n2o (data_source) 

!---------------------------------------------------------------------
!    define_n2o provides initial values for n2o mixing ratio. if n2o
!    is fixed in time, the value is given by the namelist specification.
!    if n2o is time-varying, the values are obtained from either a
!    restart or input data file.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
character(len=*), intent(in)    ::  data_source
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   intent(in) variables:
!
!       data_source     character string defining source to use to
!                       define n2o initial values
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:
!
!---------------------------------------------------------------------
!    initial trace gas volume mixing ratios in (no./no.) from various
!    sources.
!---------------------------------------------------------------------
      real       ::  rn2o_ipcc_80  = 3.02620E-07
      real       ::  rn2o_ipcc_92  = 3.11000E-07
      real       ::  rn2o_icrccm   = 2.80000E-07
      real       ::  rn2o_ipcc_98  = 3.16000E-07




      integer    :: inrad   ! unit number for i/o

character(len=8)     :: gas_name ! name associated with current
                                 ! gas being processed

!---------------------------------------------------------------------
!    define initial n2o mixing ratios to be used.
!    'icrccm'     --> rn2o_icrccm
!    'ipcc80'     --> rn2o_ipcc_80
!    'ipcc92'     --> rn2o_ipcc_92
!    'ipcc98'     --> rn2o_ipcc_98
!    'input'      --> file INPUT/id1ch4n2o, record 2
!    'restart'    --> values read from restart file
!    'prescribed' --> from restart file; if restart not present, 
!                     from input file
!    'predicted'  --> from restart file; if restart not present, 
!                     from input file
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if specification_type is 'base_and_trend', allocate length (1)
!    arrays to hold the base_time and base_value.
!---------------------------------------------------------------------
      if (trim(n2o_specification_type) /= 'time_series') then
        allocate (N2o_time_list(1))
        allocate (n2o_value(1))
      endif

      if (trim(data_source)      == 'icrccm') then
        rn2o   = rn2o_icrccm

      else if (trim(data_source) == 'ipcc_80') then
        rn2o   = rn2o_ipcc_80

      else if (trim(data_source) == 'ipcc_92') then
        rn2o   = rn2o_ipcc_92  

      else if (trim(data_source) == 'ipcc_98') then
        rn2o   = rn2o_ipcc_98

!--------------------------------------------------------------------
!    if data_source is an input file, determine if it is present. if so,
!    open and read.  if not present, write an error message and stop.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'input') then
        if (trim(n2o_specification_type) /= 'time_series') then
          if (file_exist ('INPUT/id1ch4n2o') ) then
            inrad = open_namelist_file ('INPUT/id1ch4n2o')
            read (inrad, FMT = '(5e18.10)')  
            read (inrad, FMT = '(5e18.10)')  rn2o
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
                   'desired ch4_n2o input file is not present', FATAL)
          endif
        else
          gas_name = 'n2o '
          call read_gas_timeseries (gas_name, n2o_value,   &
                                    N2o_time_list, time_varying_n2o, &
                                    n2o_dataset_entry, rn2o)   
        endif

!--------------------------------------------------------------------
!    if data_source is a restart file and it is present, the value to be
!    used has been previously read. if not present, write an error 
!    message and stop.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'restart') then
        if (.not. restart_present ) then
          call error_mesg ( 'radiative_gases_mod', &
           'cannot use restart n2o values without a restart file', &
                                  FATAL)
        endif

!--------------------------------------------------------------------
!    if data_source is 'prescribed' and a restart file is present, the 
!    value to be used has been previously read. if a restart file is
!    not present, check for an input file. if it is present, read the
!    file; if not, write an error message and stop. set the time_vary-
!    ing flag to .true.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'prescribed') then
        if (.not. restart_present) then
          if (file_exist ('INPUT/id1ch4n2o') ) then
            inrad = open_namelist_file ('INPUT/id1ch4n2o')
            read (inrad, FMT = '(5e18.10)') 
            read (inrad, FMT = '(5e18.10)') rn2o
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
              'neither restart nor n2o input file is present. one '//&
          'of these is required when the data_source is  '//&
          '"prescribed" ', FATAL)
          endif
        endif

!--------------------------------------------------------------------
!    if data_source is 'predicted' and a restart file is present, the 
!    value to be used has been previously read. if a restart file is
!    not present, check for an input file. if it is present, read the
!    file; if not, write an error message and stop. set the time_vary-
!    ing flag to .true.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'predicted') then
        if (.not. restart_present) then
          if (file_exist ('INPUT/id1ch4n2o') ) then
            inrad = open_namelist_file ('INPUT/id1ch4n2o')
            read (inrad, FMT = '(5e18.10)') 
            read (inrad, FMT = '(5e18.10)') rn2o
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
              'neither restart nor n2o input file is present. one '//&
          'of these is required when the data_source is  '//&
          '"predicted" ', FATAL)
          endif
        endif

!-------------------------------------------------------------------
!    when the data_source is 'namelist', the value of n2o is obtained
!    from the namelist variable n2o_base_value.
!-------------------------------------------------------------------
      else if (trim(data_source) == 'namelist') then
        rn2o = n2o_base_value

!--------------------------------------------------------------------
!    write an error message if the data_source is invalid.
!--------------------------------------------------------------------
      else
        call error_mesg ('radiative_gases_mod', &
         'no valid data source was specified for n2o ', FATAL)
      endif

!---------------------------------------------------------------------
!    be sure value is within range of acceptable values. a later check
!    in lw_gases_stdtf_mod will further limit values to be those for
!    which tfs may be determined.
!---------------------------------------------------------------------
      if (rn2o < n2o_floor) then
        print *, 'rn2o, n2o_floor', rn2o, n2o_floor, mpp_pe()
        call error_mesg ('radiative_gases_mod', &
              'base n2o mixing ratio LOWER THAN FLOOR value', FATAL)
      endif
      if (rn2o > n2o_ceiling) then
        call error_mesg ('radiative_gases_mod', &
              ' base n2o mixing ratio HIGHER THAN CEILING value', FATAL)
      endif

!---------------------------------------------------------------------




end subroutine define_n2o



!#####################################################################
! <SUBROUTINE NAME="define_f11">
!  <OVERVIEW>
!   Subroutine that provides initial values for f11 mixing ratio.
!  </OVERVIEW>
!  <DESCRIPTION>
!    define_f11 provides initial values for f11 mixing ratio. if f11
!    is fixed in time, the value is given by the namelist specification.
!    if f11 is time-varying, the values are obtained from either a
!    restart or input data file.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call define_f11 (data_source) 
!  </TEMPLATE>
!  <IN NAME="data_source" TYPE="character">
!   character string defining source to use to define f11 initial values
!  </IN>
! </SUBROUTINE>
!
subroutine define_f11 (data_source) 

!---------------------------------------------------------------------
!    define_f11 provides initial values for f11 mixing ratio. if f11
!    is fixed in time, the value is given by the namelist specification.
!    if f11 is time-varying, the values are obtained from either a
!    restart or input data file.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
character(len=*), intent(in)    ::  data_source
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   intent(in) variables:
!
!       data_source     character string defining source to use to
!                       define f11 initial values
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:
!
!---------------------------------------------------------------------
!    initial trace gas volume mixing ratios in (no./no.) from various
!    sources.
!---------------------------------------------------------------------
      real       ::  rf11_icrccm   = 1.00000E-09
      real       ::  rf11_ipcc_80  = 1.57500E-10
      real       ::  rf11_ipcc_92  = 2.68000E-10
      real       ::  rf11_ipcc_98  = 2.68960E-10




      integer    :: inrad   ! unit number for i/o

character(len=8)     :: gas_name ! name associated with current
                                 ! gas being processed

!---------------------------------------------------------------------
!    define initial f11 mixing ratios to be used.
!    'icrccm'     --> rf11_icrccm
!    'ipcc80'     --> rf11_ipcc_80
!    'ipcc92'     --> rf11_ipcc_92
!    'ipcc98'     --> rf11_ipcc_98
!    'input'      --> file INPUT/id1cfc, record 1
!    'restart'    --> values read from restart file
!    'prescribed' --> from restart file; if restart not present, 
!                     from input file
!    'predicted'  --> from restart file; if restart not present, 
!                     from input file
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if specification_type is 'base_and_trend', allocate length (1)
!    arrays to hold the base_time and base_value.
!---------------------------------------------------------------------
      if (trim(f11_specification_type) /= 'time_series') then
        allocate (F11_time_list(1))
        allocate (f11_value(1))
     endif

      if (trim(data_source)      == 'icrccm') then
        rf11   = rf11_icrccm

      else if (trim(data_source) == 'ipcc_80') then
        rf11   = rf11_ipcc_80

      else if (trim(data_source) == 'ipcc_92') then
        rf11   = rf11_ipcc_92  

      else if (trim(data_source) == 'ipcc_98') then
        rf11   = rf11_ipcc_98

!--------------------------------------------------------------------
!    if data_source is an input file, determine if it is present. if so,
!    open and read.  if not present, write an error message and stop.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'input') then
        if (trim(f11_specification_type) /= 'time_series') then
          if (file_exist ('INPUT/id1cfc') ) then
            inrad = open_namelist_file ('INPUT/id1cfc')
            read (inrad, FMT = '(5e18.10)')  rf11
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
                   'desired cfc input file is not present', FATAL)
          endif
        else
          gas_name = 'f11 '
          call read_gas_timeseries (gas_name, f11_value,   &
                                    F11_time_list, time_varying_f11, &
                                    f11_dataset_entry, rf11)   
        endif

!--------------------------------------------------------------------
!    if data_source is a restart file and it is present, the value to be
!    used has been previously read. if not present, write an error 
!    message and stop.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'restart') then
        if (.not. restart_present ) then
          call error_mesg ( 'radiative_gases_mod', &
           'cannot use restart f11 values without a restart file', &
                                  FATAL)
        endif

!--------------------------------------------------------------------
!    if data_source is 'prescribed' and a restart file is present, the 
!    value to be used has been previously read. if a restart file is
!    not present, check for an input file. if it is present, read the
!    file; if not, write an error message and stop. set the time_vary-
!    ing flag to .true.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'prescribed') then
        if (.not. restart_present) then
          if (file_exist ('INPUT/id1cfc') ) then
            inrad = open_namelist_file ('INPUT/id1cfc')
            read (inrad, FMT = '(5e18.10)') rf11
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
              'neither restart nor f11 input file is present. one '//&
          'of these is required when the data_source is  '//&
          '"prescribed" ', FATAL)
          endif
        endif

!--------------------------------------------------------------------
!    if data_source is 'predicted' and a restart file is present, the 
!    value to be used has been previously read. if a restart file is
!    not present, check for an input file. if it is present, read the
!    file; if not, write an error message and stop. set the time_vary-
!    ing flag to .true.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'predicted') then
        if (.not. restart_present) then
          if (file_exist ('INPUT/id1cfc') ) then
            inrad = open_namelist_file ('INPUT/id1cfc')
            read (inrad, FMT = '(5e18.10)') rf11
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
              'neither restart nor f11 input file is present. one '//&
          'of these is required when the data_source is  '//&
          '"predicted" ', FATAL)
          endif
        endif

!-------------------------------------------------------------------
!    when the data_source is 'namelist', the value of f11 is obtained
!    from the namelist variable f11_base_value.
!-------------------------------------------------------------------
      else if (trim(data_source) == 'namelist') then
        rf11 = f11_base_value

!--------------------------------------------------------------------
!    write an error message if the data_source is invalid.
!--------------------------------------------------------------------
      else
        call error_mesg ('radiative_gases_mod', &
         'no valid data source was specified for f11 ', FATAL)
      endif

!---------------------------------------------------------------------
!    be sure value is within range of acceptable values. a later check
!    in lw_gases_stdtf_mod will further limit values to be those for
!    which tfs may be determined.
!---------------------------------------------------------------------
      if (rf11 < f11_floor) then
        call error_mesg ('radiative_gases_mod', &
              'base f11 mixing ratio LOWER THAN FLOOR value', FATAL)
      endif
      if (rf11 > f11_ceiling) then
        call error_mesg ('radiative_gases_mod', &
              ' base f11 mixing ratio HIGHER THAN CEILING value', FATAL)
      endif

!---------------------------------------------------------------------




end subroutine define_f11




!#####################################################################
! <SUBROUTINE NAME="define_f12">
!  <OVERVIEW>
!   Subroutine that provides initial values for f12 mixing ratio.
!  </OVERVIEW>
!  <DESCRIPTION>
!    define_f12 provides initial values for f12 mixing ratio. if f12
!    is fixed in time, the value is given by the namelist specification.
!    if f12 is time-varying, the values are obtained from either a
!    restart or input data file.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call define_f12 (data_source) 
!  </TEMPLATE>
!  <IN NAME="data_source" TYPE="character">
!   character string defining source to use to define f12 initial values
!  </IN>
! </SUBROUTINE>
!
subroutine define_f12 (data_source) 

!---------------------------------------------------------------------
!    define_f12 provides initial values for f12 mixing ratio. if f12
!    is fixed in time, the value is given by the namelist specification.
!    if f12 is time-varying, the values are obtained from either a
!    restart or input data file.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
character(len=*), intent(in)    ::  data_source
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   intent(in) variables:
!
!       data_source     character string defining source to use to
!                       define f12 initial values
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:
!
!---------------------------------------------------------------------
!    initial trace gas volume mixing ratios in (no./no.) from various
!    sources.
!---------------------------------------------------------------------
      real       ::  rf12_icrccm   = 1.00000E-09
      real       ::  rf12_ipcc_80  = 2.72500E-10
      real       ::  rf12_ipcc_92  = 5.03000E-10
      real       ::  rf12_ipcc_98  = 5.31510E-10




      integer    :: inrad   ! unit number for i/o

character(len=8)     :: gas_name ! name associated with current
                                 ! gas being processed

!---------------------------------------------------------------------
!    define initial f12 mixing ratios to be used.
!    'icrccm'     --> rf12_icrccm
!    'ipcc80'     --> rf12_ipcc_80
!    'ipcc92'     --> rf12_ipcc_92
!    'ipcc98'     --> rf12_ipcc_98
!    'input'      --> file INPUT/id1cfc, record 2
!    'restart'    --> values read from restart file
!    'prescribed' --> from restart file; if restart not present, 
!                     from input file
!    'predicted'  --> from restart file; if restart not present, 
!                     from input file
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if specification_type is 'base_and_trend', allocate length (1)
!    arrays to hold the base_time and base_value.
!---------------------------------------------------------------------
      if (trim(f12_specification_type) /= 'time_series') then
        allocate (F12_time_list(1))
        allocate (f12_value(1))
      endif

      if (trim(data_source)      == 'icrccm') then
        rf12   = rf12_icrccm

      else if (trim(data_source) == 'ipcc_80') then
        rf12   = rf12_ipcc_80

      else if (trim(data_source) == 'ipcc_92') then
        rf12   = rf12_ipcc_92  

      else if (trim(data_source) == 'ipcc_98') then
        rf12   = rf12_ipcc_98

!--------------------------------------------------------------------
!    if data_source is an input file, determine if it is present. if so,
!    open and read.  if not present, write an error message and stop.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'input') then
        if (trim(f12_specification_type) /= 'time_series') then
          if (file_exist ('INPUT/id1cfc') ) then
            inrad = open_namelist_file ('INPUT/id1cfc')
            read (inrad, FMT = '(5e18.10)')  
            read (inrad, FMT = '(5e18.10)')  rf12
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
                   'desired cfc input file is not present', FATAL)
          endif
        else
          gas_name = 'f12 '
          call read_gas_timeseries (gas_name, f12_value,   &
                                    F12_time_list, time_varying_f12, &
                                    f12_dataset_entry, rf12)
        endif

!--------------------------------------------------------------------
!    if data_source is a restart file and it is present, the value to be
!    used has been previously read. if not present, write an error 
!    message and stop.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'restart') then
        if (.not. restart_present ) then
          call error_mesg ( 'radiative_gases_mod', &
           'cannot use restart f12 values without a restart file', &
                                  FATAL)
        endif

!--------------------------------------------------------------------
!    if data_source is 'prescribed' and a restart file is present, the 
!    value to be used has been previously read. if a restart file is
!    not present, check for an input file. if it is present, read the
!    file; if not, write an error message and stop. set the time_vary-
!    ing flag to .true.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'prescribed') then
        if (.not. restart_present) then
          if (file_exist ('INPUT/id1cfc') ) then
            inrad = open_namelist_file ('INPUT/id1cfc')
            read (inrad, FMT = '(5e18.10)') 
            read (inrad, FMT = '(5e18.10)') rf12
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
              'neither restart nor f12 input file is present. one '//&
          'of these is required when the data_source is  '//&
          '"prescribed" ', FATAL)
          endif
        endif

!--------------------------------------------------------------------
!    if data_source is 'predicted' and a restart file is present, the 
!    value to be used has been previously read. if a restart file is
!    not present, check for an input file. if it is present, read the
!    file; if not, write an error message and stop. set the time_vary-
!    ing flag to .true.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'predicted') then
        if (.not. restart_present) then
          if (file_exist ('INPUT/id1cfc') ) then
            inrad = open_namelist_file ('INPUT/id1cfc')
            read (inrad, FMT = '(5e18.10)') 
            read (inrad, FMT = '(5e18.10)') rf12
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
              'neither restart nor f12 input file is present. one '//&
          'of these is required when the data_source is  '//&
          '"predicted" ', FATAL)
          endif
        endif

!-------------------------------------------------------------------
!    when the data_source is 'namelist', the value of f12 is obtained
!    from the namelist variable f12_base_value.
!-------------------------------------------------------------------
      else if (trim(data_source) == 'namelist') then
        rf12 = f12_base_value

!--------------------------------------------------------------------
!    write an error message if the data_source is invalid.
!--------------------------------------------------------------------
      else
        call error_mesg ('radiative_gases_mod', &
         'no valid data source was specified for f12', FATAL)
      endif

!---------------------------------------------------------------------
!    be sure value is within range of acceptable values. a later check
!    in lw_gases_stdtf_mod will further limit values to be those for
!    which tfs may be determined.
!---------------------------------------------------------------------
      if (rf12 < f12_floor) then
        call error_mesg ('radiative_gases_mod', &
              'base f12 mixing ratio LOWER THAN FLOOR value', FATAL)
      endif
      if (rf12 > f12_ceiling) then
        call error_mesg ('radiative_gases_mod', &
              ' base f12 mixing ratio HIGHER THAN CEILING value', FATAL)
      endif

!---------------------------------------------------------------------




end subroutine define_f12




!#####################################################################
! <SUBROUTINE NAME="define_f113">
!  <OVERVIEW>
!   Subroutine that provides initial values for f113 mixing ratio.
!  </OVERVIEW>
!  <DESCRIPTION>
!    define_f113 provides initial values for f113 mixing ratio. if f113
!    is fixed in time, the value is given by the namelist specification.
!    if f113 is time-varying, the values are obtained from either a
!    restart or input data file.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call define_f113 (data_source) 
!  </TEMPLATE>
!  <IN NAME="data_source" TYPE="character">
!   character string defining source to use to define f113 initial values
!  </IN>
! </SUBROUTINE>
!
subroutine define_f113 (data_source) 

!---------------------------------------------------------------------
!    define_f113 provides initial values for f113 mixing ratio. if f113
!    is fixed in time, the value is given by the namelist specification.
!    if f113 is time-varying, the values are obtained from either a
!    restart or input data file.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
character(len=*), intent(in)    ::  data_source
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   intent(in) variables:
!
!       data_source     character string defining source to use to
!                       define f113 initial values
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:
!
!---------------------------------------------------------------------
!    initial trace gas volume mixing ratios in (no./no.) from various
!    sources.
!---------------------------------------------------------------------
      real       ::  rf113_icrccm  = 1.00000E-09
      real       ::  rf113_ipcc_80 = 2.31400E-11
      real       ::  rf113_ipcc_92 = 8.20000E-11
      real       ::  rf113_ipcc_98 = 8.58100E-11




      integer    :: inrad   ! unit number for i/o

character(len=8)     :: gas_name ! name associated with current
                                 ! gas being processed

!---------------------------------------------------------------------
!    define initial f113 mixing ratios to be used.
!    'icrccm'     --> rf113_icrccm
!    'ipcc80'     --> rf113_ipcc_80
!    'ipcc92'     --> rf113_ipcc_92
!    'ipcc98'     --> rf113_ipcc_98
!    'input'      --> file INPUT/id1cfc, record 3
!    'restart'    --> values read from restart file
!    'prescribed' --> from restart file; if restart not present, 
!                     from input file
!    'predicted'  --> from restart file; if restart not present, 
!                     from input file
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if specification_type is 'base_and_trend', allocate length (1)
!    arrays to hold the base_time and base_value.
!---------------------------------------------------------------------
      if (trim(f113_specification_type) /= 'time_series') then
        allocate (F113_time_list(1))
        allocate (f113_value(1))
      endif

      if (trim(data_source)      == 'icrccm') then
        rf113   = rf113_icrccm

      else if (trim(data_source) == 'ipcc_80') then
        rf113   = rf113_ipcc_80

      else if (trim(data_source) == 'ipcc_92') then
        rf113   = rf113_ipcc_92  

      else if (trim(data_source) == 'ipcc_98') then
        rf113   = rf113_ipcc_98

!--------------------------------------------------------------------
!    if data_source is an input file, determine if it is present. if so,
!    open and read.  if not present, write an error message and stop.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'input') then
        if (trim(f113_specification_type) /= 'time_series') then
          if (file_exist ('INPUT/id1cfc') ) then
            inrad = open_namelist_file ('INPUT/id1cfc')
            read (inrad, FMT = '(5e18.10)')  
            read (inrad, FMT = '(5e18.10)')  
            read (inrad, FMT = '(5e18.10)')  rf113
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
                   'desired f113 input file is not present', FATAL)
          endif
        else
          gas_name = 'f113'
          call read_gas_timeseries (gas_name, f113_value,   &
                                  F113_time_list, time_varying_f113, &
                                  f113_dataset_entry, rf113 )
        endif

!--------------------------------------------------------------------
!    if data_source is a restart file and it is present, the value to be
!    used has been previously read. if not present, write an error 
!    message and stop.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'restart') then
        if (.not. restart_present ) then
          call error_mesg ( 'radiative_gases_mod', &
           'cannot use restart f113 values without a restart file', &
                                  FATAL)
        endif

!--------------------------------------------------------------------
!    if data_source is 'prescribed' and a restart file is present, the 
!    value to be used has been previously read. if a restart file is
!    not present, check for an input file. if it is present, read the
!    file; if not, write an error message and stop. set the time_vary-
!    ing flag to .true.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'prescribed') then
        if (.not. restart_present) then
          if (file_exist ('INPUT/id1cfc') ) then
            inrad = open_namelist_file ('INPUT/id1cfc')
            read (inrad, FMT = '(5e18.10)') 
            read (inrad, FMT = '(5e18.10)') 
            read (inrad, FMT = '(5e18.10)') rf113
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
              'neither restart nor f113 input file is present. one '//&
          'of these is required when the data_source is  '//&
          '"prescribed" ', FATAL)
          endif
        endif

!--------------------------------------------------------------------
!    if data_source is 'predicted' and a restart file is present, the 
!    value to be used has been previously read. if a restart file is
!    not present, check for an input file. if it is present, read the
!    file; if not, write an error message and stop. set the time_vary-
!    ing flag to .true.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'predicted') then
        if (.not. restart_present) then
          if (file_exist ('INPUT/id1cfc') ) then
            inrad = open_namelist_file ('INPUT/id1cfc')
            read (inrad, FMT = '(5e18.10)') 
            read (inrad, FMT = '(5e18.10)') 
            read (inrad, FMT = '(5e18.10)') rf113
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
              'neither restart nor f113 input file is present. one '//&
          'of these is required when the data_source is  '//&
          '"predicted" ', FATAL)
          endif
        endif

!-------------------------------------------------------------------
!    when the data_source is 'namelist', the value of f113 is obtained
!    from the namelist variable f113_base_value.
!-------------------------------------------------------------------
      else if (trim(data_source) == 'namelist') then
        rf113 = f113_base_value

!--------------------------------------------------------------------
!    write an error message if the data_source is invalid.
!--------------------------------------------------------------------
      else
        call error_mesg ('radiative_gases_mod', &
         'no valid data source was specified for f113', FATAL)
      endif

!---------------------------------------------------------------------
!    be sure value is within range of acceptable values. a later check
!    in lw_gases_stdtf_mod will further limit values to be those for
!    which tfs may be determined.
!---------------------------------------------------------------------
      if (rf113 < f113_floor) then
        call error_mesg ('radiative_gases_mod', &
              'base f113 mixing ratio LOWER THAN FLOOR value', FATAL)
      endif
      if (rf113 > f113_ceiling) then
        call error_mesg ('radiative_gases_mod', &
              ' base f113 mixing ratio HIGHER THAN CEILING value', FATAL)
      endif

!---------------------------------------------------------------------




end subroutine define_f113



!#####################################################################
! <SUBROUTINE NAME="define_f22">
!  <OVERVIEW>
!   Subroutine that provides initial values for f22 mixing ratio.
!  </OVERVIEW>
!  <DESCRIPTION>
!    define_f22 provides initial values for f22 mixing ratio. if f22
!    is fixed in time, the value is given by the namelist specification.
!    if f22 is time-varying, the values are obtained from either a
!    restart or input data file.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call define_f22 (data_source) 
!  </TEMPLATE>
!  <IN NAME="data_source" TYPE="character">
!   character string defining source to use to define f22 initial values
!  </IN>
! </SUBROUTINE>
!
subroutine define_f22 (data_source) 

!---------------------------------------------------------------------
!    define_f22 provides initial values for f22 mixing ratio. if f22
!    is fixed in time, the value is given by the namelist specification.
!    if f22 is time-varying, the values are obtained from either a
!    restart or input data file.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
character(len=*), intent(in)    ::  data_source
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   intent(in) variables:
!
!       data_source     character string defining source to use to
!                       define f22 initial values
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:
!
!---------------------------------------------------------------------
!    initial trace gas volume mixing ratios in (no./no.) from various
!    sources.
!---------------------------------------------------------------------
      real       ::  rf22_icrccm   = 1.00000E-09
      real       ::  rf22_ipcc_80  = 6.20200E-11
      real       ::  rf22_ipcc_92  = 1.05000E-10
      real       ::  rf22_ipcc_98  = 1.26520E-10




      integer    :: inrad   ! unit number for i/o

character(len=8)     :: gas_name ! name associated with current
                                 ! gas being processed

!---------------------------------------------------------------------
!    define initial f22 mixing ratios to be used.
!    'icrccm'     --> rf22_icrccm
!    'ipcc80'     --> rf22_ipcc_80
!    'ipcc92'     --> rf22_ipcc_92
!    'ipcc98'     --> rf22_ipcc_98
!    'input'      --> file INPUT/id1cfc, record 4
!    'restart'    --> values read from restart file
!    'prescribed' --> from restart file; if restart not present, 
!                     from input file
!    'predicted'  --> from restart file; if restart not present, 
!                     from input file
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if specification_type is 'base_and_trend', allocate length (1)
!    arrays to hold the base_time and base_value.
!---------------------------------------------------------------------
      if (trim(f22_specification_type) /= 'time_series') then
        allocate (F22_time_list(1))
        allocate (f22_value(1))
      endif

      if (trim(data_source)      == 'icrccm') then
        rf22   = rf22_icrccm

      else if (trim(data_source) == 'ipcc_80') then
        rf22   = rf22_ipcc_80

      else if (trim(data_source) == 'ipcc_92') then
        rf22   = rf22_ipcc_92  

      else if (trim(data_source) == 'ipcc_98') then
        rf22   = rf22_ipcc_98

!--------------------------------------------------------------------
!    if data_source is an input file, determine if it is present. if so,
!    open and read.  if not present, write an error message and stop.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'input') then
        if (trim(f22_specification_type) /= 'time_series') then
          if (file_exist ('INPUT/id1cfc') ) then
            inrad = open_namelist_file ('INPUT/id1cfc')
            read (inrad, FMT = '(5e18.10)')  
            read (inrad, FMT = '(5e18.10)')  
            read (inrad, FMT = '(5e18.10)')  
            read (inrad, FMT = '(5e18.10)')  rf22
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
                   'desired cfc input file is not present', FATAL)
          endif
        else
          gas_name = 'f22 '
          call read_gas_timeseries (gas_name, f22_value,  &
                                    F22_time_list, time_varying_f22, &
                                    f22_dataset_entry, rf22)
        endif

!--------------------------------------------------------------------
!    if data_source is a restart file and it is present, the value to be
!    used has been previously read. if not present, write an error 
!    message and stop.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'restart') then
        if (.not. restart_present ) then
          call error_mesg ( 'radiative_gases_mod', &
           'cannot use restart f22 values without a restart file', &
                                  FATAL)
        endif

!--------------------------------------------------------------------
!    if data_source is 'prescribed' and a restart file is present, the 
!    value to be used has been previously read. if a restart file is
!    not present, check for an input file. if it is present, read the
!    file; if not, write an error message and stop. set the time_vary-
!    ing flag to .true.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'prescribed') then
        if (.not. restart_present) then
          if (file_exist ('INPUT/id1cfc') ) then
            inrad = open_namelist_file ('INPUT/id1cfc')
            read (inrad, FMT = '(5e18.10)') 
            read (inrad, FMT = '(5e18.10)') 
            read (inrad, FMT = '(5e18.10)') 
            read (inrad, FMT = '(5e18.10)') rf22
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
              'neither restart nor f22 input file is present. one '//&
          'of these is required when the data_source is  '//&
          '"prescribed" ', FATAL)
          endif
        endif

!--------------------------------------------------------------------
!    if data_source is 'predicted' and a restart file is present, the 
!    value to be used has been previously read. if a restart file is
!    not present, check for an input file. if it is present, read the
!    file; if not, write an error message and stop. set the time_vary-
!    ing flag to .true.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'predicted') then
        if (.not. restart_present) then
          if (file_exist ('INPUT/id1cfc') ) then
            inrad = open_namelist_file ('INPUT/id1cfc')
            read (inrad, FMT = '(5e18.10)') 
            read (inrad, FMT = '(5e18.10)') 
            read (inrad, FMT = '(5e18.10)') 
            read (inrad, FMT = '(5e18.10)') rf22
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
              'neither restart nor f22 input file is present. one '//&
          'of these is required when the data_source is  '//&
          '"predicted" ', FATAL)
          endif
        endif

!-------------------------------------------------------------------
!    when the data_source is 'namelist', the value of f22 is obtained
!    from the namelist variable f22_base_value.
!-------------------------------------------------------------------
      else if (trim(data_source) == 'namelist') then
        rf22 = f22_base_value

!--------------------------------------------------------------------
!    write an error message if the data_source is invalid.
!--------------------------------------------------------------------
      else
        call error_mesg ('radiative_gases_mod', &
         'no valid data source was specified for f22', FATAL)
      endif

!---------------------------------------------------------------------
!    be sure value is within range of acceptable values. a later check
!    in lw_gases_stdtf_mod will further limit values to be those for
!    which tfs may be determined.
!---------------------------------------------------------------------
      if (rf22 < f22_floor) then
        call error_mesg ('radiative_gases_mod', &
              'base f22 mixing ratio LOWER THAN FLOOR value', FATAL)
      endif
      if (rf22 > f22_ceiling) then
        call error_mesg ('radiative_gases_mod', &
              ' base f22 mixing ratio HIGHER THAN CEILING value', FATAL)
      endif

!---------------------------------------------------------------------




end subroutine define_f22



!#####################################################################
! <SUBROUTINE NAME="define_co2">
!  <OVERVIEW>
!   Subroutine that provides initial values for co2 mixing ratio.
!  </OVERVIEW>
!  <DESCRIPTION>
!    define_co2 provides initial values for co2 mixing ratio. if co2
!    is fixed in time, the value is given by the namelist specification.
!    if co2 is time-varying, the values are obtained from either a
!    restart or input data file.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call define_co2 (data_source) 
!  </TEMPLATE>
!  <IN NAME="data_source" TYPE="character">
!   character string defining source to use to define co2 initial values
!  </IN>
! </SUBROUTINE>
!
subroutine define_co2 (data_source) 

!---------------------------------------------------------------------
!    define_co2 provides initial values for co2 mixing ratio. if co2
!    is fixed in time, the value is given by the namelist specification.
!    if co2 is time-varying, the values are obtained from either a
!    restart or input data file.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
character(len=*), intent(in)    ::  data_source
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   intent(in) variables:
!
!       data_source     character string defining source to use to
!                       define co2 initial values
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:
!
!---------------------------------------------------------------------
!    initial trace gas volume mixing ratios in (no./no.) from various
!    sources.
!---------------------------------------------------------------------
      real       ::  rco2_icrccm   = 3.00000E-04
      real       ::  rco2_ipcc_92  = 3.56000E-04
      real       ::  rco2_ipcc_80  = 3.37320E-04
      real       ::  rco2_ipcc_98  = 3.69400E-04
      real       ::  rco2_330ppm   = 3.30000E-04
      real       ::  rco2_660ppm   = 6.60000E-04
      real       ::  rco2_720ppm   = 7.20000E-04




      integer    :: inrad   ! unit number for i/o

character(len=8)     :: gas_name ! name associated with current
                                 ! gas being processed

!---------------------------------------------------------------------
!    define initial co2 mixing ratios to be used.
!    'icrccm'     --> rco2_icrccm
!    'ipcc80'     --> rco2_ipcc_80
!    'ipcc92'     --> rco2_ipcc_92
!    'ipcc98'     --> rco2_ipcc_98
!    '330ppm'     --> rco2_330ppm 
!    '660ppm'     --> rco2_660ppm 
!    'input'      --> file INPUT/id1co2, record 2
!    'restart'    --> values read from restart file
!    'prescribed' --> from restart file; if restart not present, 
!                     from input file
!    'predicted'  --> from restart file; if restart not present, 
!                     from input file
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if specification_type is 'base_and_trend', allocate length (1)
!    arrays to hold the base_time and base_value.
!---------------------------------------------------------------------
      if (trim(co2_specification_type) /= 'time_series') then
        allocate (Co2_time_list(1))
        allocate (co2_value(1))
      endif

      if (trim(data_source)      == 'icrccm') then
        rco2   = rco2_icrccm

      else if (trim(data_source) == 'ipcc_80') then
        rco2   = rco2_ipcc_80

      else if (trim(data_source) == 'ipcc_92') then
        rco2   = rco2_ipcc_92  

      else if (trim(data_source) == 'ipcc_98') then
        rco2   = rco2_ipcc_98

      else if (trim(data_source) == '330ppm') then
        rco2   = rco2_330ppm

      else if (trim(data_source) == '660ppm') then
        rco2   = rco2_660ppm

      else if (trim(data_source) == '720ppm') then
        rco2   = rco2_720ppm

!--------------------------------------------------------------------
!    if data_source is an input file, determine if it is present. if so,
!    open and read.  if not present, write an error message and stop.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'input') then
        if (trim(co2_specification_type) /= 'time_series') then
          if (file_exist ('INPUT/id1co2') ) then
            inrad = open_namelist_file ('INPUT/id1co2')
            read (inrad, FMT = '(5e18.10)')  rco2
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
                   'desired co2 input file is not present', FATAL)
          endif
        else
          gas_name = 'co2 '
          call read_gas_timeseries (gas_name, co2_value, &
                                    Co2_time_list, time_varying_co2, &
                                    co2_dataset_entry, rco2)
        endif

!--------------------------------------------------------------------
!    if data_source is a restart file and it is present, the value to be
!    used has been previously read. if not present, write an error 
!    message and stop.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'restart') then
        if (.not. restart_present ) then
          call error_mesg ( 'radiative_gases_mod', &
           'cannot use restart co2 values without a restart file', &
                                  FATAL)
        endif

!--------------------------------------------------------------------
!    if data_source is 'prescribed' and a restart file is present, the 
!    value to be used has been previously read. if a restart file is
!    not present, check for an input file. if it is present, read the
!    file; if not, write an error message and stop. set the time_vary-
!    ing flag to .true.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'prescribed') then
        if (.not. restart_present) then
          if (file_exist ('INPUT/id1co2') ) then
            inrad = open_namelist_file ('INPUT/id1co2')
            read (inrad, FMT = '(5e18.10)') rco2
            call close_file (inrad)
          else
            call error_mesg ( 'radiative_gases_mod', &
              'neither restart nor co2 input file is present. one '//&
          'of these is required when the data_source is  '//&
          '"prescribed" ', FATAL)
          endif
        endif

!--------------------------------------------------------------------
!    if data_source is 'predicted' and a restart file is present, the 
!    value to be used has been previously read. if a restart file is
!    not present, check for an input file. if it is present, read the
!    file; if not, write an error message and stop. set the time_vary-
!    ing flag to .true.
!--------------------------------------------------------------------
      else if (trim(data_source) == 'predicted') then
        if (.not. restart_present) then
          if (file_exist ('INPUT/id1co2') ) then
            inrad = open_namelist_file ('INPUT/id1co2')
            read (inrad, FMT = '(5e18.10)') rco2
            call close_file (inrad)
            co2_for_last_tf_calc = rco2
          else
            call error_mesg ( 'radiative_gases_mod', &
              'neither restart nor co2 input file is present. one '//&
          'of these is required when the data_source is  '//&
          '"predicted" ', FATAL)
          endif
        endif

!-------------------------------------------------------------------
!    when the data_source is 'namelist', the value of co2 is obtained
!    from the namelist variable co2_base_value.
!-------------------------------------------------------------------
      else if (trim(data_source) == 'namelist') then
        rco2 = co2_base_value

!--------------------------------------------------------------------
!    write an error message if the data_source is invalid.
!--------------------------------------------------------------------
      else
        call error_mesg ('radiative_gases_mod', &
         'no valid data source was specified for co2 input', FATAL)
      endif

!---------------------------------------------------------------------
!    be sure value is within range of acceptable values. a later check
!    in lw_gases_stdtf_mod will further limit values to be those for
!    which tfs may be determined.
!---------------------------------------------------------------------
      if (rco2 < co2_floor) then
        call error_mesg ('radiative_gases_mod', &
              'base co2 mixing ratio LOWER THAN FLOOR value', FATAL)
      endif
      if (rco2 > co2_ceiling) then
        call error_mesg ('radiative_gases_mod', &
              ' base co2 mixing ratio HIGHER THAN CEILING value', FATAL)
      endif

!---------------------------------------------------------------------


end subroutine define_co2


!#####################################################################
! <SUBROUTINE NAME="read_gas_timeseries">
!  <OVERVIEW>
!   Subroutine that reads in data values for well-mixed greenhouse
!   gases at specified times.
!  </OVERVIEW>
!  <DESCRIPTION>
!    read_gas_timeseries obtains global values for well-mixed
!    greenhouse gases from observed data sources for gas xxx.
!     the data are obtained from an input file.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call read_gas_timeseries (gas, gas_value, Gas_time_list, rgas)
!  </TEMPLATE>
!  <IN NAME="gas">
!   name associated with the current gas
!  </IN>
!  <INOUT NAME="gas_value">
!   array of volume mixing ratio of gas 'gas' for each time in 
!   Gas_time_list gas_year. [no. /no. ]
!  </INOUT>
!  <INOUT NAME="Gas_time_list">
!   list of times (time_type) associated with the gas_value data 
!  </INOUT>
!  <OUT NAME="rgas">
!   gas volume mixing ratio at the start of the timeseries
!  </OUT>
! </SUBROUTINE>
!
subroutine read_gas_timeseries (gas, gas_value, Gas_time_list,   &
                                time_varying_gas, gas_dataset_entry, &
                                rgas)
 
!--------------------------------------------------------------------
!    read_gas_timeseries obtains global values for well-mixed
!    greenhouse gases from observed data sources for gas xxx.
!     the data are obtained from an input file.
!--------------------------------------------------------------------

character(len=*),                   intent(in)    :: gas
real, dimension(:),                 pointer       :: gas_value
type(time_type), dimension(:),      pointer       :: Gas_time_list
logical,                            intent(in)    :: time_varying_gas
integer,dimension(:),               intent(in)    :: gas_dataset_entry
real,                               intent(out)   :: rgas

!--------------------------------------------------------------------
!
!  intent(in) variables:
!
!      gas     name associated with the current gas
!
!   pointer variables:
!
!      gas_value
!      Gas_time_list
!
!   intent(out) variables:
!
!      rgas
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!    local variables :

      real,dimension(:), allocatable :: input_time
      type(time_type)                :: Year_t, Extra_time
      character(len=64)              :: file_name

      real       :: extra_seconds
      integer    :: inrad   ! unit number for i/o
      integer    :: i       ! do loop index
      integer    :: year, diy, yr, mo, dy, hr, mn, sc
      integer    :: series_length
      integer    :: index1, index2
      real       :: percent_of_period
      type(time_type) :: Gas_entry
      character(len=256) :: err_msg

!-------------------------------------------------------------------
!    define the gas_name which is currently being processed.
!-------------------------------------------------------------------
      file_name = 'INPUT/' // trim(gas) //'_gblannualdata'

!--------------------------------------------------------------------
!    process the gas timeseries file.
!--------------------------------------------------------------------
      if (file_exist (file_name) ) then
        inrad = open_namelist_file (file_name)

!--------------------------------------------------------------------
!    read the number of data points in the timeseries.
!--------------------------------------------------------------------
        read (inrad, FMT = '(i12)')  series_length

!----------------------------------------------------------------------
!    allocate gas_value, input_time and Gas_time_list arrays.
!----------------------------------------------------------------------
        allocate (gas_value(series_length))
        allocate (input_time(series_length))
        allocate (Gas_time_list(series_length))

!---------------------------------------------------------------------
!    read the timeseries data, time and then gas value.
!---------------------------------------------------------------------
        do i=1,series_length
          read (inrad, FMT = '(2f12.4)') input_time(i), &
                                         gas_value(i)
        end do

!---------------------------------------------------------------------
!    convert from input units  to [ no. / no. ].
!---------------------------------------------------------------------
        if ( trim(gas) == 'co2') then
          gas_value = 1.0e-6*gas_value
        else if (trim(gas) == 'ch4' .or. &
                 trim(gas) == 'n2o' ) then   
          gas_value = 1.0e-9*gas_value
        else if (trim(gas) == 'f11' .or. &
                 trim(gas) == 'f12' .or. &   
                 trim(gas) == 'f113' .or. &   
                 trim(gas) == 'f22' ) then   
          gas_value = 1.0e-12*gas_value
        endif

!---------------------------------------------------------------------
!    close the input file.
!---------------------------------------------------------------------
        call close_file (inrad)

!---------------------------------------------------------------------
!    convert the time stamps of the series to time_type variables.     
!---------------------------------------------------------------------
        if (verbose > 3) then
          if ( mpp_pe() == mpp_root_pe() ) then
            print *, 'time series entries for ' // trim (gas)
          endif
        endif
        do i=1,series_length
          year = INT(input_time(i))
          Year_t = set_date (year,1,1,0,0,0)
          diy = days_in_year (Year_t)
          extra_seconds = (input_time(i) - year)*diy*86400. 
          Extra_time=    set_time(NINT(extra_seconds), 0)
          Gas_time_list(i)    = Year_t + Extra_time
          call get_date (Gas_time_list(i), yr, mo, dy, hr, mn, sc)
          if (verbose > 3) then
            if ( mpp_pe() == mpp_root_pe() ) then
              print *, i, yr, mo, dy, hr, mn, sc, gas_value(i)
            endif
          endif
        end do

!--------------------------------------------------------------------
!    if the gas is not time-varying, its value must be defined here.
!--------------------------------------------------------------------
        if (.not. time_varying_gas) then

!--------------------------------------------------------------------
!    if a dataset entry time has not been specified, send an error
!    message.
!--------------------------------------------------------------------
          if (gas_dataset_entry(1) == 1 .and. &
              gas_dataset_entry(2) == 1 .and. &
              gas_dataset_entry(3) == 1 .and. &
              gas_dataset_entry(4) == 0 .and. &
              gas_dataset_entry(5) == 0 .and. &
              gas_dataset_entry(6) == 0 ) then   
            call error_mesg ('radiative_gases_mod', &
             'timeseries selected but no valid datset_entry time &
                             &provided for ' // trim(gas) , FATAL)

!---------------------------------------------------------------------
!    convert the dataset entry that is provided to a time_type variable,
!    and determine the timeseries value that corresponds.
!---------------------------------------------------------------------
          else
            Gas_entry = set_date (gas_dataset_entry(1), &
                                  gas_dataset_entry(2), &
                                  gas_dataset_entry(3), &
                                  gas_dataset_entry(4), &
                                  gas_dataset_entry(5), &
                                  gas_dataset_entry(6))     
            call time_interp (Gas_entry, Gas_time_list,  &
                              percent_of_period, index1, index2, err_msg=err_msg)
            if(err_msg /= '') then
               call error_mesg('radiative_gases_mod ',trim(err_msg)//' file='//trim(file_name), FATAL)
            endif
            rgas = gas_value(index1) + percent_of_period*  &
                   (gas_value(index2) - gas_value(index1))
            call error_mesg ( 'radiative_gases_mod', &
                   'PROCESSING TIMESERIES FOR ' // trim(gas), NOTE)
            call print_date (Gas_entry , str='Gas value is taken from &
                                     &timeseries at time:')
            if (mpp_pe() == mpp_root_pe() ) then
              print *, trim(gas) // ' value is ', rgas
            endif
          endif

!---------------------------------------------------------------------
!    if gas is time_varying, define the initial gas mixing ratio to be 
!    the first value in the timeseries. this value will be replaced 
!    before it is used.
!---------------------------------------------------------------------
        else
          rgas = gas_value(1)
        endif

!---------------------------------------------------------------------
!    if the requested input file is not present, write an error message.
!---------------------------------------------------------------------
      else
        call error_mesg ( 'radiative_gases_mod', &
             'desired ' // file_name // ' input file is not present', &
                                                                FATAL)
      endif

!--------------------------------------------------------------------
 


end subroutine read_gas_timeseries
 

!#####################################################################
! <SUBROUTINE NAME="define_gas_amount">
!  <OVERVIEW>
!   define_gas_amount defines the values of the gas mixing ratio needed !   at the current time, when the gas is varying with time.
!  </OVERVIEW>
!  <DESCRIPTION>
!   define_gas_amount performs the following actions:
!     1) checks for the presence of needed optional arguments;
!     2) determines how long the gas has been varying with time;
!     3) calculates values for the gas mixing ratio at the current time;
!     4) constrains calculated gas values to lie between the
!        specified floor and ceiling;
!
!   if transmission functions are calculated for the gas, then:
!     1) it is determined if the gas value used when the tfs were last
!        calculated is needed;
!     2) if the gas does not use its current value at the time when tfs
!        are calculated, the offset from the current time to the time
!        used for tfs is obtained;
!     3) if the gas value used when the tfs were last calculated is 
!        needed, it is calculated along with the time offset of that
!        time from the present time;
!     4) if the gas value at the time when the tfs are next to be cal-
!        culated is needed, it is calculated;
!     5) gas values relevant at the time when tfs are next to be 
!        calculated are constrained to lie between the specified floor 
!        and ceiling;
!  </DESCRIPTION>
!  <TEMPLATE>
!   call define_gas_amount      &
!        (gas, Rad_time, gas_specification_type, gas_variation_type, &
!         gas_floor, gas_ceiling, rgas, gas_uses_tfs, gas_change_rate, &
!         rrvgas, Gas_time_list, gas_value, gas_tf_calc_intrvl,  &
!         gas_tf_time_displacement, calc_gas_tfs_on_first_step,  &
!         use_current_gas_for_tf, gas_tf_offset, gas_for_last_tf_calc, &
!         gas_for_next_tf_calc, define_gas_for_last_tf_calc)
!  </TEMPLATE>
!  <IN NAME="gas">
!   character string associated with the gas being processed
!  </IN>
!  <IN NAME="Rad_time">
!   time at which radiation calculation is to apply
!  </IN>
!  <IN NAME="gas_specification_type">
!   indicator as to the form of time variation of vol. mixing ratio;
!   either 'base_and_trend' or 'time_series'.
!  </IN>
!  <IN NAME="gas_variation_type">
!   indicator as to the form of time variation of the vol. mixing ratio
!   of gas; either 'linear' or 'logarithmic'
!  </IN>
!  <IN NAME="gas_floor">
!   smallest value allowed for gas xxx vol. mixing ratio [ no. / no. ]
!  </IN>
!  <IN NAME="gas_ceiling">
!   largest value allowed for gas xxx vol. mixing ratio [ no. / no. ]
!  </IN>
!  <IN NAME="rgas">
!   initially specified gas mixing ratio [ no. / no. ]
!  </IN>
!  <IN NAME="gas_uses_tfs">
!   this gas has transmission functions associated with it ?
!  </IN>
!  <INOUT NAME="gas_change_rate">
!   time rate of change of gas xxx vol. mixing ratio
!   [  1 +/- % per year ]
!  </INOUT>
!  <INOUT NAME="rrvgas">
!   gas mixing ratio at current time [ no. / no. ]
!  </INOUT>
!  <IN NAME="Gas_time_list">
!   list of times in gas timeseries [ time_type ]
!  </IN>
!  <IN NAME="gas_value">
!   gas concentrations [ no. / no. ] associated with the times 
!   in Gas_time_list
!  </IN>
!  <IN NAME="gas_tf_calc_intrvl">
!   time interval between calculating gas tfs  [ hours ]
!   OPTIONAL: present only when the gas has tfs associated with it
!  </IN>
!  <IN NAME="gas_tf_time_displacement">
!   time displacement from present to the time at which gas values are
!   to be used in the calculation of tfs. may be <0, ==0, or > 0.
!   [ hours ]
!   OPTIONAL: present only when the gas has tfs associated with it, only
!   used when calc_gas_tfs_on_first_step is .true.
!  </IN>
!  <IN NAME="calc_gas_tfs_on_first_step">
!   if true, tfs are calculated ONLY on the first time step of a run,
!   using gas mixing ratios valid gas_tf_time_displacement hours from 
!   the start time
!   OPTIONAL: present only when the gas has tfs associated with it
!  </IN>
!  <IN NAME="use_current_gas_for_tf">
!   if true, the gas  mixing ratio at the current time is used to cal-
!   culate the gas tfs
!   OPTIONAL: present only when the gas has tfs associated with it
!  </IN>
!  <OUT NAME = "gas_tf_offset">
!   time between last tf calculation and present [ hours ]
!   OPTIONAL: present only when the gas has tfs associated with it
!  </OUT>
!  <OUT NAME = "gas_for_last_tf_calc">
!   value of gas mixing ratio used in last tf calculation [ no. / no. ]
!   OPTIONAL: present only when the gas has tfs associated with it
!  </OUT>
!  <OUT NAME = "gas_for_next_tf_calc">
!   value of gas mixing ratio to be used in next tf calculation 
!   OPTIONAL: present only when the gas has tfs associated with it
!   [ no. / no. ]
!  </OUT>
!  <INOUT NAME = "define_gas_for_last_tf_calc">
!   logical indicating if the gas value used for the last tf calculation
!   must be obtained
!  </INOUT>
!

!<PUBLICROUTINE>
!
!NOTE: THIS IS A PRIVATE SUBROUTINE>
!
subroutine define_gas_amount      &
         (gas, Rad_time, gas_specification_type,  &
!         negative_offset_gas, Gas_offset, gas_variation_type, &
                                           gas_variation_type, &
          gas_floor, gas_ceiling, rgas, gas_uses_tfs, gas_change_rate, &
          rrvgas, Gas_time_list, gas_value, gas_tf_calc_intrvl,  &
          gas_tf_time_displacement, calc_gas_tfs_on_first_step,  &
          calc_gas_tfs_monthly, &
          use_current_gas_for_tf, gas_tf_offset, gas_for_last_tf_calc, &
          gas_for_next_tf_calc,  gas_tfs_needed,  &
          define_gas_for_last_tf_calc)

!--------------------------------------------------------------------
character(len=*),              intent(in)    :: gas
type(time_type),               intent(in)    :: Rad_time
character(len=*),              intent(in)    :: gas_specification_type,&
                                                gas_variation_type
real,                          intent(in)    :: gas_floor, gas_ceiling,&
                                                rgas
logical,                       intent(in)    :: gas_uses_tfs  
!logical,                       intent(in)    :: negative_offset_gas  
real,                          intent(inout) :: gas_change_rate, rrvgas

type(time_type), dimension(:), intent(in)    :: Gas_time_list
!type(time_type),               intent(inout) :: Gas_offset      
real, dimension(:),            intent(in)    :: gas_value
real,               intent(in),    optional  :: gas_tf_calc_intrvl,    &
                                                gas_tf_time_displacement
logical,            intent(in),    optional  ::   &
                                           gas_tfs_needed, &
                                          calc_gas_tfs_on_first_step, &
                                          calc_gas_tfs_monthly,  &
                                          use_current_gas_for_tf 
real,               intent(out),   optional  :: gas_tf_offset, &
                                                gas_for_last_tf_calc, &
                                                gas_for_next_tf_calc
logical,            intent(inout), optional  :: &  
                                          define_gas_for_last_tf_calc

!---------------------------------------------------------------------
!  local variables:

     type(time_type)    :: Gas_yrs   
     integer            :: days, seconds
     real               :: years_of_gas, years_of_gas_till_next
     integer            :: days2, seconds2
     integer            :: days3, seconds3
     real               :: mean_days, calc_time
     character(len=16)  :: chvers7, chvers8, chvers9
     integer            :: alarm, minutes_from_start

     real               :: percent_of_period
     type(time_type)    :: Tf_offset, Tf_calc_intrvl 
     real               :: rseconds3
     integer            :: index1, index2
     integer            :: yr, mo, dy, hr, mn, sc
     integer            :: days7, seconds7
     type(time_type)    :: Tf_displ, First_of_month, Gas_tf_next, &
                           Time_left
     character(len=256) :: err_msg
!---------------------------------------------------------------------
!  local variables:
!    
!     Gas_yrs                 time interval from start of time variation
!                             until current time [ time_type ]
!     days                    days component of Gas_yrs  [ days ]   
!     seconds                 seconds component of Gas_yrs  [ seconds ]
!     minutes_from_start      time interval from start of time variation
!                             until current time [ minutes ]
!     years_of_gas            time interval from start of time variation
!                             until current time [ years ]
!     years_of_gas_till_next  time interval from start of time variation
!                             until next tf calculation [ years ]
!     days2                   days component of the mean length of year
!                             time_type variable [ days ]
!     seconds2                seconds component of the mean length of 
!                             year time_type variable [ seconds ]
!     mean_days               average number of days in a year [ days ]
!     calc_time               time at which tfs were last calculated
!                             [ years from start of gas time variation ]
!     chvers7                 character variable used to output model
!                             variables through error_mesg interface
!     chvers8                 character variable used to output model
!                             variables through error_mesg interface
!     chvers9                 character variable used to output model
!                             variables through error_mesg interface
!     chvers11                character variable used to output model
!                             variables through error_mesg interface
!     alarm                   time since last tf calculation until
!                             current time [ minutes ]              
!
!--------------------------------------------------------------------

!     type(time_type)  :: Gas_time  ! time for which gas data is desired

!</PUBLICROUTINE>

!--------------------------------------------------------------------
!    define the time for which gas data is desired.
!--------------------------------------------------------------------
!     if (negative_offset_gas) then
!       Gas_time = Rad_time - Gas_offset
!     else
!       Gas_time = Rad_time + Gas_offset
!     endif

!---------------------------------------------------------------------
!    if this gas calculates transmission functions, make sure all 
!    optional arguments needed when tfs are in use are present.
!---------------------------------------------------------------------
      if (gas_uses_tfs) then
        if (present( gas_tf_calc_intrvl) .and. &
            present( gas_tf_time_displacement) .and. &
            present( gas_tf_offset) .and. &
            present( gas_for_last_tf_calc) .and. &
            present( gas_for_next_tf_calc) .and. &
            present( calc_gas_tfs_on_first_step) .and. &
            present( calc_gas_tfs_monthly) .and. &
            present( define_gas_for_last_tf_calc) .and. &
            present( use_current_gas_for_tf) ) then 
        else
          call error_mesg ('radiative_gases_mod', &
          'necessary optional arguments for '//trim(gas)//' call to&
           & subroutine define_gas_amount are not present', FATAL)
        endif
      endif

!--------------------------------------------------------------------
!    define the mean length of the year in units of days. this will
!    be a function of the calendar being used. this will be the unit
!    used to define how long gas variation has been occurring 
!    (years_of_gas), not exactly equivalent to calendar years.
!--------------------------------------------------------------------
      call get_time (length_of_year(), seconds2, days2)
      mean_days = days2 + seconds2/86400.

!---------------------------------------------------------------------
!    define how long the gas variation has been occurring, expressed
!    as a time_type, the components of the time_type and then in units
!    of gas-years.
!---------------------------------------------------------------------
      Gas_yrs = Rad_time - Gas_time_list(1)
!     Gas_yrs = Gas_time - Gas_time_list(1)
      call get_time (Gas_yrs, seconds, days)
      years_of_gas = (days + seconds/86400.)/mean_days

!---------------------------------------------------------------------
!    define the current value of gas. this value will be used in sw
!    calculations. the following expressions are available:
!      base_and_trend, logarithmic: 
!                    g(t) = g(t0)*(gas_change_rate)**(t-t0)
!      base_and_trend, linear:   
!                    g(t) = g(t0)*(1.0 + (t-t0)*(gas_change_rate - 1.0)
!    where t0 is the base time.
!---------------------------------------------------------------------
      if (trim(gas_specification_type) =='base_and_trend') then
        if (trim(gas_variation_type) == 'logarithmic') then
          if (gas_change_rate /=0.0) then
            rrvgas = rgas* exp(alog(gas_change_rate)*years_of_gas)
          else
            rrvgas = rgas
          endif
        else 
          rrvgas = rgas*(1.0 + years_of_gas*(gas_change_rate-1.0))
        endif

      else if (trim(gas_specification_type) == 'time_series') then
        call time_interp (Rad_time, Gas_time_list,   &
!       call time_interp (Gas_time, Gas_time_list,   &
                          percent_of_period, index1, index2, err_msg=err_msg)
        if(err_msg /= '') then
           call error_mesg('radiative_gases_mod 1',trim(err_msg), FATAL)
        endif
        rrvgas   = gas_value(index1) + percent_of_period*  &
                   (gas_value(index2) - gas_value(index1))
      endif

!---------------------------------------------------------------------
!    be sure that newly calculated current gas mixing ratio remains 
!    within the floor / ceiling range. if either is exceeded, reset the
!    gas amount to the floor/ ceiling value.
!---------------------------------------------------------------------
      if (rrvgas < gas_floor) then
        if (verbose >= 1) then
          if (.not. printed_current_floor_msg) then
            write (chvers7, '(3pe15.7)') rrvgas
            write (chvers8, '(3pe15.7)') gas_floor
            write (chvers9, '(f9.5)') years_of_gas
            call error_mesg ('radiative_gases_mod', &
           'calculated '//trim(gas)//' mixing ratio ('//chvers7//  &
           ') LOWER THAN FLOOR ('//chvers8//') after'//chvers9//'years&
           & of '//trim(gas)// ' variation; reset to floor value ',  &
                                                                  NOTE)
            printed_current_floor_msg = .true.
          endif
        endif ! (verbose)
        rrvgas = gas_floor
      endif
      if (rrvgas > gas_ceiling) then
        if (verbose >= 1) then
          if (.not. printed_current_ceiling_msg) then
            write (chvers7, '(3pe15.7)') rrvgas
            write (chvers8, '(3pe15.7)') gas_ceiling
            write (chvers9, '(f 9.5)') years_of_gas
            call error_mesg ('radiative_gases_mod', &
           'calculated '//trim(gas)// ' mixing ratio ('//chvers7// &
           ') HIGHER THAN CEILING ('//chvers8//') after'//chvers9// &
           'years of '//trim(gas)// ' variation; reset to ceiling &
                                                        &value ', NOTE)
            printed_current_ceiling_msg = .true.
          endif
        endif ! (verbose)
        rrvgas = gas_ceiling
      endif

!---------------------------------------------------------------------
!    execute the following code if tfs are to be calculated for this 
!    gas.
!---------------------------------------------------------------------
      if (gas_uses_tfs) then
!     if (gas_uses_tfs .and. gas_tfs_needed) then
        if (gas_tfs_needed) then

!---------------------------------------------------------------------
!    if this gas uses tfs, determine if the gas mixing ratio used the
!    last time tfs were calculated is needed. in general it is  
!    needed if it was not read in from the restart file (a non-
!    current version), and gas time variation has already begun. 
!    however if time variation has not yet begun (the usual case if 
!    using an old restart) or if the tfs are to be calculated on the 
!    first step of the job, it will not be needed, and the flag is 
!    reset to so indicate. 
!---------------------------------------------------------------------
        if (years_of_gas == 0.0 .or. calc_gas_tfs_on_first_step .or. &
             calc_gas_tfs_monthly) then
          define_gas_for_last_tf_calc =.false.
        endif

!--------------------------------------------------------------------
!    define the time to which the gas mixing ratio used in the last
!    calculation corresponded. 
!--------------------------------------------------------------------
        if (define_gas_for_last_tf_calc) then
          calc_time = years_of_gas - MOD (years_of_gas, &
                      gas_tf_calc_intrvl/(24.0*mean_days))
          if (verbose >= 4 .and. mpp_pe() == mpp_root_pe() ) then
            print *, 'last tf:calc_time, years_of_gas', calc_time, &
                     years_of_gas
          endif

!--------------------------------------------------------------------
!    if the value of the gas mixing ratio used for the last tf calcul-
!    ation is needed, define it and the time to which it applies. after
!    calculation, set the flag indicating its need to .false.
!--------------------------------------------------------------------
          if (trim(gas_specification_type) =='base_and_trend') then
            if (trim(gas_variation_type) == 'logarithmic') then
              gas_for_last_tf_calc = rgas*exp(alog(gas_change_rate)* &
                                              calc_time)
              gas_tf_offset = (calc_time - years_of_gas)*24.0*mean_days
            else 
              gas_for_last_tf_calc  = rgas*(1.0 + calc_time*  &
                                      (gas_change_rate-1.0))
              gas_tf_offset = (calc_time - years_of_gas)*24.0*mean_days
            endif
          else if (trim(gas_specification_type) == 'time_series') then
            Tf_calc_intrvl = set_time (NINT(calc_time*24.0*  &
                                            mean_days*3600.), 0)
            call time_interp (Rad_time - Tf_calc_intrvl, Gas_time_list, &
!           call time_interp (Gas_time - Tf_calc_intrvl, Gas_time_list, &
                              percent_of_period, index1, index2, err_msg=err_msg)
            if(err_msg /= '') then
               call error_mesg('radiative_gases_mod 2',trim(err_msg), FATAL)
            endif
            gas_for_last_tf_calc   = gas_value(index1) +    &
                                     percent_of_period*  &
                                     (gas_value(index2) -   &
                                      gas_value(index1))
            if (mpp_pe() == mpp_root_pe() )then
              print *, 'gas_for_last_tf_calc, , *3,  &
                       &index1, index2, days3, seconds3, % ',   &
                         gas_for_last_tf_calc,   &
                         index1, index2, percent_of_period
            endif
            gas_tf_offset = (calc_time - years_of_gas)*24.0* mean_days
          endif
          define_gas_for_last_tf_calc = .false.
        endif !(define_gas_for_last_tf_calc) 

!---------------------------------------------------------------------
!    if tfs are calculated using other than the gas values at the 
!    current time, define the time that has elapsed since the beginning
!    of variation, and determine if this is a time at which tfs are
!    due to be calculated (alarm = 0).
!---------------------------------------------------------------------
        if (.not. use_current_gas_for_tf) then
          minutes_from_start = INT(days*1440.0 + real(seconds)/60.)
          if (gas_tf_calc_intrvl /= 0.0) then
            alarm = MOD(minutes_from_start,   &
                        INT(gas_tf_calc_intrvl*60.0))
          else
            alarm = 0
          endif

!---------------------------------------------------------------------
!    if alarm is 0 (indicating this is a step on which to calculate the
!    tfs), or if the option has been chosen to always and only calculate
!    tfs on the first step of a job, define the time to use to obtain 
!    the gas mixing ratio used to calculate those tfs.
!---------------------------------------------------------------------
          if (alarm == 0 .or. calc_gas_tfs_on_first_step .or. &
             calc_gas_tfs_monthly) then

!--------------------------------------------------------------------
!    if calc_gas_tfs_on_first_step is true, the gas mixing ratio at a
!    time gas_tf_time_displacement hours from now (plus, zero or minus 
!    allowed) will be used.
!--------------------------------------------------------------------
            if (calc_gas_tfs_on_first_step  ) then
              years_of_gas_till_next = years_of_gas +   &
                              gas_tf_time_displacement/(24.0*mean_days)
           else if (calc_gas_tfs_monthly) then
              call get_date (Rad_time, yr, mo, dy, hr, mn, sc)
              Tf_displ =   &
                      set_time(NINT(gas_tf_time_displacement*60*60), 0)
              First_of_month = set_date (yr, mo, 1, 0, 0, 0)
              Gas_tf_next =  First_of_month + Tf_displ
              if (Gas_tf_next > Rad_time) then
                Time_left = Gas_tf_next - Rad_time
                call get_time (Time_left, seconds7, days7)
                years_of_gas_till_next = years_of_gas + (days7 +   &
                                         seconds7/86400.)/mean_days
              else
                Time_left = Rad_time - Gas_tf_next
                call get_time (Time_left, seconds7, days7)
                years_of_gas_till_next = years_of_gas - (days7 +   &
                                         seconds7/86400.)/mean_days
!               years_of_gas_till_next = years_of_gas            
              endif
!--------------------------------------------------------------------
!    if alarm is 0, the gas mixing ratio at the mid point of the time
!    interval between this calculation time and the next is used.
!--------------------------------------------------------------------
            else if (alarm == 0 ) then   
              years_of_gas_till_next = years_of_gas +   &
                              0.5*(gas_tf_calc_intrvl)/(24.0*mean_days)
            endif

!--------------------------------------------------------------------
!    calculate the difference in time (hours) between current time and 
!    time used to define the gas mixing ratio used for the next tf
!    calculation.
!--------------------------------------------------------------------
            gas_tf_offset = (years_of_gas_till_next - years_of_gas)* &
                             24.0*mean_days

!--------------------------------------------------------------------
!    if the value of the gas mixing ratio to be used for the next tf 
!    calculation is needed, define it here. it will be needed if the
!    gas mixing ratio to be used in defining the tfs is not the
!    current value and either it is time to do the calculation or the
!    calculation is desired on the first step of the job.
!--------------------------------------------------------------------
            if (trim(gas_specification_type) =='base_and_trend') then
              if (trim(gas_variation_type) == 'logarithmic') then
                gas_for_next_tf_calc = rgas*exp(alog(gas_change_rate)*&
                                       years_of_gas_till_next)
              else 
                gas_for_next_tf_calc = rgas*(1.0 +   &
                                       years_of_gas_till_next*  &
                                       (gas_change_rate-1.0))
              endif
            else if (trim(gas_specification_type) == 'time_series') then
             if (calc_gas_tfs_monthly) then
               Tf_offset = Time_left
               if (gas_tf_offset > 0) then
                 call time_interp (Rad_time + Tf_offset, Gas_time_list,&
                                percent_of_period, index1, index2, err_msg=err_msg)
               else
                 call time_interp (Rad_time - Tf_offset, Gas_time_list,&
                                percent_of_period, index1, index2, err_msg=err_msg)
               endif
               if(err_msg /= '') then
                  call error_mesg('radiative_gases_mod 3',trim(err_msg), FATAL)
               endif
             else
               days3 = NINT(gas_tf_offset/24.0)
               rseconds3 = (gas_tf_offset - days3*24)*3600.0
               seconds3 = NINT(rseconds3)
               Tf_offset = set_time (seconds3, days3)
               call time_interp (Rad_time + Tf_offset, Gas_time_list,  &
                                percent_of_period, index1, index2,err_msg=err_msg)
               if(err_msg /= '') then
                  call error_mesg('radiative_gases_mod 4',trim(err_msg), FATAL)
               endif
              endif
              gas_for_next_tf_calc   = gas_value(index1) +    &
                                       percent_of_period*  &
                                       (gas_value(index2) -   &
                                        gas_value(index1))
            endif

!---------------------------------------------------------------------
!    if the current value is not being used, be sure that the gas mixing
!    ratio calculated for use when tfs are next calculated is within 
!    the floor / ceiling range. if either is exceeded, reset the gas 
!    amount to the floor/ ceiling value.
!---------------------------------------------------------------------
            if (gas_for_next_tf_calc < gas_floor) then
              if (verbose >= 1) then
                if (.not. printed_next_floor_msg) then
                  write (chvers7, '(3pe15.7)')  gas_for_next_tf_calc
                  write (chvers8, '(3pe15.7)') gas_floor
                  write (chvers9, '(f9.5)') years_of_gas_till_next
                  call error_mesg ('radiative_gases_mod', &    
                  'calculated '//trim(gas)// ' mixing ratio to be used&
                  & for tf calcs ('//chvers7//') LOWER  &
                  &THAN FLOOR ('//chvers8//') after'//chvers9//'years&
                  & of '//trim(gas)// ' variation; reset to floor  &
                                                         &value ', NOTE)
                  printed_next_floor_msg = .true.
                endif
              endif ! (verbose)
              gas_for_next_tf_calc = gas_floor
            endif
            if (gas_for_next_tf_calc > gas_ceiling) then
              if (verbose >= 1) then
                if (.not. printed_next_ceiling_msg) then
                  write (chvers7, '(3pe15.7)')   gas_for_next_tf_calc
                  write (chvers8, '(3pe15.7)') gas_ceiling
                  write (chvers9, '(f 9.5)') years_of_gas_till_next
                  call error_mesg ('radiative_gases_mod', &
                 'calculated '//trim(gas)// ' mixing ratio to be used&
                  & for tf calcs (' //chvers7//') HIGHER  &
                  &THAN CEILING ('//chvers8//') after'//chvers9//'years&
                  & of '//trim(gas)// ' variation; reset to ceiling &
                                                        &value ', NOTE)
                  printed_next_ceiling_msg = .true.
                endif
              endif ! (verbose)
              gas_for_next_tf_calc        = gas_ceiling
            endif
          else

!--------------------------------------------------------------------
!    set the value to be the current value. in this case it will not 
!    be used.
!--------------------------------------------------------------------
            gas_for_next_tf_calc = rrvgas
          endif

!---------------------------------------------------------------------
!    if the current value of the gas mixing ratio is to be used for the
!    next tf calculation, reset the values to the just-adjusted current
!    value rrvgas and set the time offset to 0.0.
!---------------------------------------------------------------------
        else ! (.not. use_current_gas_for_tf)
          gas_for_next_tf_calc = rrvgas
          gas_tf_offset = 0.0
        endif
 else ! (gas_tfs_needed)
          define_gas_for_last_tf_calc =.false.
          gas_for_next_tf_calc = rrvgas
          gas_tf_offset = 0.0
 endif ! (gas_tfs_needed)
      endif ! (gas_uses_tfs) 

!---------------------------------------------------------------------



end subroutine define_gas_amount 


! </SUBROUTINE>

!####################################################################
! <SUBROUTINE NAME="write_restart_radiative_gases">
!  <OVERVIEW>
!   Subroutine to write the radiative restart files
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to write the radiative restart files
!  </DESCRIPTION>
!  <TEMPLATE>
!   call write_restart_radiative_gases
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine write_restart_radiative_gases

!---------------------------------------------------------------------
!    write_restart_radiative_gases writes the radiative_gases.res file.
!---------------------------------------------------------------------

      integer    :: unit    ! unit number for i/o



!---------------------------------------------------------------------
!    open unit and write radiative gas restart file.
!---------------------------------------------------------------------
      if (mpp_pe() == mpp_root_pe() ) then
         call error_mesg ('radiative_gases_mod', 'Writing native formatted restart file: RESTART/radiative_gases.res', NOTE)
        unit = open_restart_file ('RESTART/radiative_gases.res',   &
                                   action= 'write')
        write (unit) restart_versions(size(restart_versions(:)))
        write (unit) rrvco2
        write (unit) rrvf11, rrvf12, rrvf113, rrvf22
        write (unit) rrvch4, rrvn2o
        write (unit) co2_for_last_tf_calc
        write (unit) ch4_for_last_tf_calc
        write (unit) n2o_for_last_tf_calc
        call close_file (unit)
      endif

!----------------------------------------------------------------------
      


end subroutine write_restart_radiative_gases

!####################################################################


                  end module radiative_gases_mod

module grid_fourier_mod

use       fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, &
                         write_version_number

use constants_mod, only: pi

use fft_mod,       only: fft_init, fft_grid_to_fourier, fft_fourier_to_grid


!    provides one-dimensional grid-to-fourier and fourier-to-grid 
!    transforms on the first dimension of two- or three-dimensional fields.
!
!----------------------------------------------------------------------------

implicit none
private

character(len=128), parameter :: version = '$Id: grid_fourier.F90,v 11.0 2004/09/28 19:30:50 fms Exp $'
character(len=128), parameter :: tagname = '$Name: tikal $'

public :: grid_fourier_init, grid_fourier_end, trans_grid_to_fourier, trans_fourier_to_grid
public :: get_lon_max, get_longitude_origin, get_deg_lon

interface trans_grid_to_fourier
   module procedure trans_grid_to_fourier_3d, trans_grid_to_fourier_2d
end interface

interface trans_fourier_to_grid
   module procedure trans_fourier_to_grid_3d, trans_fourier_to_grid_2d
end interface

interface verify_fourier_imag
   module procedure verify_fourier_imag_3d, verify_fourier_imag_2d
end interface

integer :: num_lon
real    :: longitude_origin_local
logical :: check_local
logical :: module_is_initialized = .false.

real, allocatable, dimension(:) :: deg_lon

contains

!------------------------------------------------------------------------------------------------------

subroutine grid_fourier_init(num_lon_in, fourier_inc, check, longitude_origin)

integer, intent(in) :: num_lon_in, fourier_inc
logical, intent(in), optional   :: check
real,    intent(in), optional   :: longitude_origin
integer :: i
character(len=8) :: chtmp
real :: total_degrees

if(module_is_initialized) return

call write_version_number(version, tagname)

if(mod(num_lon_in,2) .ne. 0) then
  write(chtmp,'(i8)') num_lon_in
  call error_mesg('grid_fourier_init','num_lon must be even, but num_lon='//chtmp, FATAL)
end if

if(num_lon_in .eq. 0) then
  call error_mesg('grid_fourier_init','num_lon cannot be zero', FATAL)
end if

num_lon = num_lon_in

if(present(check)) then
  check_local = check
else
  check_local = .false.
end if

if(present(longitude_origin)) then
  longitude_origin_local = longitude_origin
else
  longitude_origin_local = 0.0
end if

total_degrees = 360./float(fourier_inc)

if(allocated(deg_lon)) deallocate(deg_lon)
allocate(deg_lon(num_lon))
do i=1,num_lon
  deg_lon(i) = 180*longitude_origin_local/pi &
     + (i-1)*total_degrees/float(num_lon)
  if(deg_lon(i) .ge. total_degrees) then
    deg_lon(i) = deg_lon(i) - total_degrees
  endif
  if(deg_lon(i) .lt. 0.0) then
    deg_lon(i) = deg_lon(i) + total_degrees
  endif
end do

call fft_init(num_lon)

module_is_initialized = .true.

return
end subroutine grid_fourier_init

!------------------------------------------------------------------------------------------------------

function trans_grid_to_fourier_3d(grid) result(fourier)

real,    intent(in),  dimension(:,:,:) :: grid
complex, dimension(0:size(grid,1)/2, size(grid,2), size(grid,3)) :: fourier
real, dimension(size(grid,1)+1,size(grid,2),size(grid,3)) :: grid1
character(len=8) :: chtmp1, chtmp2

if(.not.module_is_initialized) then
  call error_mesg('trans_grid_to_fourier','module grid_fourier not initialized', FATAL)
end if

if(size(grid,1).ne.num_lon) then
  write(chtmp1,'(i8)') size(grid,1)
  write(chtmp2,'(i8)') num_lon
  call error_mesg('trans_grid_to_fourier', &
    'size(grid,1) must equal num_lon, but size(grid,1)='//chtmp1//' num_lon='//chtmp2, FATAL)
end if

grid1(1:size(grid,1),:,:) = grid
grid1(size(grid,1)+1,:,:) = grid(1,:,:)
fourier = fft_grid_to_fourier(grid1)

return
end function trans_grid_to_fourier_3d
!------------------------------------------------------------------------------------------------------

function trans_fourier_to_grid_3d(fourier) result(grid)

complex, intent(in), dimension(0:,:,:) :: fourier
real, dimension(2*(size(fourier,1)-1), size(fourier,2), size(fourier,3)) :: grid
real, dimension(2*size(fourier,1)-1,   size(fourier,2), size(fourier,3)) :: grid1
character(len=8) :: chtmp1, chtmp2

if(.not.module_is_initialized) then
  call error_mesg('trans_fourier_to_grid','module grid_fourier not initialized', FATAL)
end if

if(2*(size(fourier,1)-1) .ne. num_lon) then
  write(chtmp1,'(i8)') size(fourier,1)
  write(chtmp2,'(i8)') num_lon 
  call error_mesg('trans_fourier_to_grid', &
  '2*(size(fourier,1)-1) must equal num_lon, but size(fourier,1)='//chtmp1//' num_lon='//chtmp2, FATAL)
end if

if(check_local)  call verify_fourier_imag(fourier)

grid1 = fft_fourier_to_grid(fourier)
grid = grid1(1:2*(size(fourier,1)-1),:,:)

return
end function trans_fourier_to_grid_3d
!------------------------------------------------------------------------------------------------------

subroutine verify_fourier_imag_3d(fourier)

complex, intent(in), dimension(0:,:,:) :: fourier
integer :: j, k
character(len=56) :: chtmp='aimag(fourier(   ,   ,   ))=                            '

do k=1,size(fourier,3)
  do j=1,size(fourier,2)
    if(aimag(fourier(0,j,k)) .ne. 0.0) then
      chtmp(15:17) = '  0'
      write(chtmp(19:21),'(i3)') j
      write(chtmp(23:25),'(i3)') k
      write(chtmp(29:52),'(1pe24.16)') aimag(fourier(0,j,k))
      call error_mesg('verify_fourier_imag',chtmp//'  It should be zero.', FATAL)
    end if
  end do
end do

if(mod(num_lon,2).eq.0) then
  do k=1,size(fourier,3)
    do j=1,size(fourier,2)
      if(aimag(fourier(num_lon/2,j,k)) .ne. 0.0) then
        write(chtmp(15:17),'(i3)') num_lon/2
        write(chtmp(19:21),'(i3)') j
        write(chtmp(23:25),'(i3)') k
        write(chtmp(29:52),'(1pe24.16)') aimag(fourier(0,j,k))
        call error_mesg('verify_fourier_imag',chtmp//'  It should be zero.', FATAL)
      end if
    end do
  end do
end if

return
end subroutine verify_fourier_imag_3d
!------------------------------------------------------------------------------------------------------

!  The remaining routines are 2d version of the 3d versions described above)

!------------------------------------------------------------------------------------------------------

function trans_fourier_to_grid_2d (fourier) result(grid)

complex, intent(in), dimension(0:,:) :: fourier
complex, dimension(0:size(fourier,1)-1, size(fourier,2), 1) :: fourier_3d

real, dimension(2*(size(fourier,1)-1), size(fourier,2)) :: grid
real, dimension(2*(size(fourier,1)-1), size(fourier,2), 1) :: grid_3d

fourier_3d(:,:,1) = fourier(:,:)
grid_3d = trans_fourier_to_grid_3d(fourier_3d)
grid(:,:) = grid_3d(:,:,1)

return
end function trans_fourier_to_grid_2d
!------------------------------------------------------------------------------------------------------

function trans_grid_to_fourier_2d (grid) result(fourier)

real,    intent(in),  dimension(:,:) :: grid
complex, dimension(0:size(grid,1)/2, size(grid,2)) :: fourier

real, dimension(size(grid,1), size(grid,2), 1) :: grid_3d
complex, dimension(0:size(grid,1)/2, size(grid,2), 1) :: fourier_3d

grid_3d(:,:,1) = grid(:,:)
fourier_3d = trans_grid_to_fourier_3d(grid_3d)
fourier(:,:) = fourier_3d(:,:,1)

return
end function trans_grid_to_fourier_2d

!------------------------------------------------------------------------------------------------------

subroutine verify_fourier_imag_2d(fourier)

complex, intent(in), dimension(0:,:) :: fourier
complex, dimension(0:size(fourier,1)-1, size(fourier,2), 1) :: fourier_3d

fourier_3d(:,:,1) = fourier(:,:)
call verify_fourier_imag_3d(fourier_3d)

return
end subroutine verify_fourier_imag_2d

!------------------------------------------------------------------------------------------------------

subroutine get_lon_max(lon_max_out)

integer, intent (out) :: lon_max_out

if(.not.module_is_initialized) then
  call error_mesg('get_lon_max','module grid_fourier not initialized', FATAL)
end if

lon_max_out = num_lon

return
end subroutine get_lon_max

!------------------------------------------------------------------------------------------------------

subroutine get_longitude_origin(longitude_origin_out)

real, intent (out) :: longitude_origin_out

if(.not.module_is_initialized) then
  call error_mesg('get_longitude_origin','module grid_fourier not initialized', FATAL)
end if

longitude_origin_out = longitude_origin_local

return
end subroutine get_longitude_origin

!------------------------------------------------------------------------------------------------------

subroutine get_deg_lon(deg_lon_out)

real, intent (out), dimension(:) :: deg_lon_out
character(len=8) :: chtmp1, chtmp2

if(.not.module_is_initialized) then
  call error_mesg('get_deg_lon','module grid_fourier not initialized', FATAL)
end if
if(size(deg_lon_out,1).ne.num_lon) then
  write(chtmp1,'(i8)') size(deg_lon_out,1)
  write(chtmp2,'(i8)') num_lon
  call error_mesg('get_deg_lon', &
    'size of deg_lon does not equal num_lon. size(deg_lon)='//chtmp1//' num_lon='//chtmp2, FATAL)
end if

deg_lon_out(:) = deg_lon(:)

return
end subroutine get_deg_lon

!------------------------------------------------------------------------------------------------------

subroutine grid_fourier_end

if(.not.module_is_initialized) return
deallocate(deg_lon)
!call fft_end
module_is_initialized = .false.

return
end subroutine grid_fourier_end

!------------------------------------------------------------------------------------------------------

end module grid_fourier_mod

module ocean_sigma_transport_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Thickness weighted and density weighted time tendency for 
! tracer from transport within a bottom "sigma" layer.
! The advective portion of this routine is experimental,
! and has many problems.  It is retained in MOM for 
! exploratory use only.  Also note that the advection 
! contributes a lot of instability when running realistic
! simulations with pressure vertical coordinates. The 
! instability mechanism is unknown. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes the thickness weighted and density weighted
! time tendency for tracer arising from 
!
! 1. Laplacian diffusion within a bottom turbulent boundary layer.
!
! 2. Upwind advection within this layer.  Advection velocities 
!    determined by model resolved velocity and parameterized 
!    downslope velocity. We use first order upwind tracer advection
!    to ensure positive definite tracer transport in the sigma 
!    layer.  As the sigma layer is a proxy for a bottom turbulent
!    boundary layer, the added mixing from the first order upwind
!    should be physically acceptable.  
!
! CAUTION: The advective portion of this algorithm has problems
! and it retained in MOM only for research purposes.  It 
! is NOT supported for general use.  
!
! The diffusivity used to determine the strength of the diffusion  
! is generally set to be a function of the local horizontal grid 
! spacing.  Diffusivity is the sum of an a priori background plus
! a velocity dependent diffusivity.  It is large if there is a  
! a heavier parcel living adjacent within the "sigma layer" above
! a lighter parcel. It is small otherwise. 
! 
! The advection is set to zero if the density is not downslope
! favorable.  That is, rho_{,x} * H_{,x} < 0 for downslope
! flow in the x-direction, and likewise in the y-direction.  
!
! The thickness of the bottom layer can span more than a single 
! bottom grid cell.  This feature allows the sigma
! layer thickness to undulate in time according to the convergence
! or divergence of mass within the sigma layer. 
!
! </DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! A. Beckmann and R. Doscher, 1997: A method for improved
! representation of dense water spreading over 
! topography in geopotential--coordinate models
! Journal of Physical Oceanography, vol 27, 
! pages 581--59.
! </REFERENCE>
!
! <REFERENCE>
! R. Doscher and A. Beckmann, 2000:
! Effects of a bottom boundary layer parameterization 
! in a coarse-resolution model of the North Atlantic Ocean
! Journal of Atmospheric and Oceanic Technology, 
! vol 17 pages 698--707
! </REFERENCE>
!
! <REFERENCE>
! Campin and Goosse 1999: Parameterization of density-driven downsloping 
! flow for a coarse-resolution model in z-coordinate", Tellus 51A, 
! pages 412-430.
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies: Elements of MOM (2012)
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_sigma_transport_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging. 
!  </DATA> 
!  <DATA NAME="sigma_diffusion_on" TYPE="logical">
!  For using sigma diffusion. Default is true.
!  </DATA> 
!  <DATA NAME="sigma_advection_on" TYPE="logical">
!  For using sigma advection. Default is false.
!  </DATA> 
!  <DATA NAME="sigma_advection_sgs_only" TYPE="logical">
!  In many cases, adding the resolved transport to the 
!  sigma-advective transport produces a tremendous level of 
!  noise at the bottom.  The problem is that there are 
!  grid-scale features that may cause large jumps in whether
!  the velocity should be added or not, depending on the logic
!  of the scheme.  For this reason, it may be prudent to remove
!  the resolved velocity from that contributing to the sigma
!  transport scheme. Note that its removal from sigma transport
!  does not remove the contributions of the resolved velocity 
!  from the resolved advective transport arising from
!  ocean_tracer_advect_mod. It simply removes it from the 
!  added transport arising in the sigma transport module. 
!  Default is sigma_advection_sgs_only=.true. 
!  </DATA>   
!  <DATA NAME="sigma_advection_check" TYPE="logical">
!  If true, then will only include the resolved advection 
!  velocity in the sigma-layer if the direction of 
!  transport is downslope favorable for enhancing deep density.
!  IF false, then will include the velocity regardless. 
!  This option aims to reduce the large divergences
!  that occur for the case when only include the velocity 
!  if it is favorable for deep water getting more dense. 
!  Default is sigma_advection_check=.true. 
!  </DATA>   
!
!  <DATA NAME="thickness_sigma_layer" UNITS="meter" TYPE="real">
!  Initial thickness of the bottom sigma layer.   
!  </DATA>   
!  <DATA NAME="thickness_sigma_min" UNITS="meter" TYPE="real">
!  Minimum thickness of the bottom sigma layer.   
!  </DATA>   
!  <DATA NAME="thickness_sigma_max" UNITS="meter" TYPE="real">
!  Maximum thickness of the bottom sigma layer.   
!  </DATA>   

!  <DATA NAME="sigma_just_in_bottom_cell" TYPE="logical">
!  For just having sigma layer in the bottom cell, as in mom4p0. 
!  This option must be .false. in order to use sigma_advection_on=.true. 
!  Default sigma_just_in_bottom_cell=.true.
!  </DATA>   
!  <DATA NAME="tmask_sigma_on" TYPE="logical">
!  IF .true. then masks out fluxes passing into the sigma layer, except those 
!  associated with sigma transport. Typically set to .false.  
!  </DATA> 
!
!  <DATA NAME="sigma_diffusivity" UNITS="m^2/sec" TYPE="real">
!  Sigma tracer diffusivity for use if not using micom diffusivity.   
!  </DATA> 
!  <DATA NAME="sigma_diffusivity_ratio" UNITS="dimensionless" TYPE="real">
!  When flow along sigma surface is stable (i.e., heavy parcels are below lighter parcels)
!  then sigma diffusivity is reduced by sigma_diffusivity_ratio from the case where 
!  heavy parcels are above lighter parcels.  
!  </DATA>
!  <DATA NAME="tracer_mix_micom" TYPE="logical">
!  If .true., then the sigma diffusivity is set according to a velocity scale 
!  times the grid spacing. 
!  </DATA> 
!  <DATA NAME="vel_micom" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM diffusivity. 
!  </DATA> 
!
!  <DATA NAME="campingoose_mu" TYPE="real" UNITS="inverse seconds">
!  Dissipation rate for the bottom friction.  Campin and Goosse 
!  suggest campingoose_mu=10^-4
!  </DATA> 
!  <DATA NAME="campingoose_delta" TYPE="real" UNITS="dimensionless">
!  Fraction of a grid cell participating in the overflow process. 
!  Campin and Goosse suggest campingoose_delta=1/3. 
!  </DATA> 
!  <DATA NAME="sigma_umax" TYPE="real" UNITS="m/s">
!  Maximum downslope speed allowed in sigma layer. 
!  In some cases, the model will be unstable if sigma_umax
!  is too large.  
!  </DATA> 
!
!  <DATA NAME="smooth_sigma_velocity" TYPE="logical">
!  To smooth the sigma advective transport velocity. 
!  Default is smooth_sigma_velocity=.true. 
!  </DATA>   
!  <DATA NAME="smooth_sigma_thickness" TYPE="logical">
!  To smooth the sigma thickness. This may be needed especially 
!  for case with sigma advection, in which case the thickness 
!  can become noisy. Default is smooth_sigma_thickness=.true. 
!  </DATA>   
!  <DATA NAME="sigma_velmicom" TYPE="real" UNITS="m/s">
!  For smoothing the sigma_thickness, use this as velocity scale to
!  determine the thickness diffusivity.  
!  Default is smooth_velmicom = 0.2
!  </DATA> 
!
!</NAMELIST>

use constants_mod,    only: grav, c2dbars, epsln
use diag_manager_mod, only: register_static_field, register_diag_field, send_data
use fms_mod,          only: write_version_number, open_namelist_file, close_file, check_nml_error
use fms_mod,          only: file_exist
use fms_mod,          only: FATAL, WARNING, NOTE, stdout, stdlog
use fms_io_mod,       only: register_restart_field, save_restart, restore_state
use fms_io_mod,       only: restart_file_type
use mpp_domains_mod,  only: mpp_update_domains, CGRID_NE
use mpp_mod,          only: input_nml_file, mpp_error

use ocean_domains_mod,     only: get_local_indices, set_ocean_domain
use ocean_density_mod,     only: density
use ocean_operators_mod,   only: FMX, FMY, FDX_T, FDY_T, BDX_ET, BDY_NT, LAP_T
use ocean_parameters_mod,  only: GEOPOTENTIAL, TERRAIN_FOLLOWING
use ocean_parameters_mod,  only: missing_value, rho0, rho0r
use ocean_types_mod,       only: ocean_domain_type, ocean_grid_type, ocean_time_type
use ocean_types_mod,       only: ocean_prog_tracer_type, ocean_adv_vel_type
use ocean_types_mod,       only: ocean_options_type, ocean_thickness_type, ocean_density_type
use ocean_util_mod,        only: write_timestamp, diagnose_2d, diagnose_3d, diagnose_sum, write_chksum_2d
use ocean_tracer_util_mod, only: diagnose_3d_rho
use ocean_workspace_mod,   only: wrk1, wrk2, wrk3, wrk4, wrk5, wrk6

implicit none

public ocean_sigma_transport_init
public sigma_transport
public ocean_sigma_transport_end
public ocean_sigma_transport_restart
private advect_sigma_upwind
private watermass_diag_init
private watermass_diag


private

! internally set for computing watermass diagnstics
logical :: compute_watermass_diag = .false. 

! for diagnostics 
logical :: used
integer, dimension(:), allocatable  :: id_tracer_sigma  ! tracer concentration within sigma layer 
integer, dimension(:), allocatable  :: id_sigma_diff    ! thickness and density weighted time tendency 
                                                        ! for tracer from sigma diffusion
integer, dimension(:), allocatable  :: id_sigma_adv     ! thickness and density weighted time tendency 
                                                        ! for tracer from sigma advection
integer, dimension(:), allocatable  :: id_sigma_diff_2d ! thickness and density weighted time tendency 
                                                        ! for tracer from sigma diffusion within sigma layer 
integer, dimension(:), allocatable  :: id_sigma_adv_2d  ! thickness and density weighted time tendency 
                                                        ! for tracer from sigma advection within sigma layer 
integer, dimension(:), allocatable  :: id_sigma_smooth  ! thickness and density weighted time tendency 
                                                        ! for tracer from smoothing of the sigma thickness
integer, dimension(:), allocatable  :: id_sigma_diff_xflux       ! for i-flux from sigma diffusion
integer, dimension(:), allocatable  :: id_sigma_diff_yflux       ! for j-flux from sigma diffusion
integer, dimension(:), allocatable  :: id_sigma_diff_xflux_int_z ! for i-flux integrated in z
integer, dimension(:), allocatable  :: id_sigma_diff_yflux_int_z ! for j-flux integrated in z

integer, dimension(:), allocatable  :: id_sigma_adv_xflux       ! for i-flux from sigma advection 
integer, dimension(:), allocatable  :: id_sigma_adv_yflux       ! for j-flux from sigma advection
integer, dimension(:), allocatable  :: id_sigma_adv_xflux_int_z ! for i-flux integrated in z
integer, dimension(:), allocatable  :: id_sigma_adv_yflux_int_z ! for j-flux integrated in z

integer :: id_sigma_uhrho     =-1 ! i-directed sigma dzt_rho*advection component 
integer :: id_sigma_vhrho     =-1 ! j-directed sigma dzt_rho*advection component 
integer :: id_sigma_uhrho_sgs =-1 ! i-directed sigma dzt_rho*advection component from Campin and Goose 
integer :: id_sigma_vhrho_sgs =-1 ! j-directed sigma dzt_rho*advection component from Campin and Goose 
integer :: id_sigma_uhrho_res =-1 ! i-directed sigma dzt_rho*advection component from resolved u
integer :: id_sigma_vhrho_res =-1 ! j-directed sigma dzt_rho*advection component from resolved v

integer :: id_dtopog_dx      =-1
integer :: id_dtopog_dy      =-1 
integer :: id_tmask_sigma    =-1
integer :: id_thickness_sigma=-1
integer :: id_weight_sigma   =-1
integer :: id_diff_cet       =-1
integer :: id_diff_cnt       =-1

integer :: id_neut_rho_sigma          =-1
integer :: id_wdian_rho_sigma         =-1
integer :: id_tform_rho_sigma         =-1
integer :: id_neut_rho_sigma_on_nrho  =-1
integer :: id_wdian_rho_sigma_on_nrho =-1
integer :: id_tform_rho_sigma_on_nrho =-1

integer :: id_eta_tend_sigma     =-1
integer :: id_eta_tend_sigma_glob=-1

! for vertical coordinate 
integer :: vert_coordinate

! for restart
type(restart_file_type), save :: Sigma_restart

#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS

real, public, dimension(isd:ied,jsd:jed) :: tmask_sigma ! mask defining active sigma cells 
real, dimension(isd:ied,jsd:jed)   :: thickness_sigma   ! space-time dependent sigma layer thickness (m)
real, dimension(isd:ied,jsd:jed)   :: dtopog_dx         ! i-derivative of the T-cell bottom topography (x-slope)
real, dimension(isd:ied,jsd:jed)   :: dtopog_dy         ! j-derivative of the T-cell bottom topography (y-slope) 
real, dimension(isd:ied,jsd:jed)   :: diff_cet          ! sigma diffusivity for northern face of T cell (m^2/s)
real, dimension(isd:ied,jsd:jed)   :: diff_cnt          ! sigma diffusivity for northern face of T cell (m^2/s)
real, dimension(isd:ied,jsd:jed)   :: diff_max          ! maximum a priori diffusivity (m2/sec)
real, dimension(isd:ied,jsd:jed)   :: smooth_diff       ! diffusivity (m^2/sec) for smoothing thickness_sigma

real, dimension(isd:ied,jsd:jed)   :: sigma_uhrho_res   ! rho_dzt*i-velocity in sigma (m^2/s*kg/m^3)
real, dimension(isd:ied,jsd:jed)   :: sigma_vhrho_res   ! rho_dzt*j-velocity in sigma (m^2/s*kg/m^3)
real, dimension(isd:ied,jsd:jed)   :: sigma_uhrho_sgs   ! rho_dzt*i-velocity in sigma from SGS (m^2/s*kg/m^3)
real, dimension(isd:ied,jsd:jed)   :: sigma_vhrho_sgs   ! rho_dzt*j-velocity in sigma from SGS (m^2/s*kg/m^3)
real, dimension(isd:ied,jsd:jed)   :: sigma_uhrho       ! sum of sigma_uhrho_res + sigma_uhrho_sgs
real, dimension(isd:ied,jsd:jed)   :: sigma_vhrho       ! sum of sigma_uhrho_res + sigma_uhrho_sgs

#else

real, public, dimension(:,:), allocatable :: tmask_sigma     ! mask defining active sigma cells 
real, dimension(:,:),         allocatable :: thickness_sigma ! space-time dependent sigma layer thickness (m)
real, dimension(:,:),         allocatable :: dtopog_dx       ! i-derivative of T-cell bottom topography (x-slope)
real, dimension(:,:),         allocatable :: dtopog_dy       ! j-derivative of T-cell bottom topography (y-slope)
real, dimension(:,:),         allocatable :: diff_cet        ! sigma diffusivity for northern face of T cell (m^2/s)
real, dimension(:,:),         allocatable :: diff_cnt        ! sigma diffusivity for northern face of T cell (m^2/s)
real, dimension(:,:),         allocatable :: diff_max        ! maximum a priori diffusivity (m2/sec)
real, dimension(:,:),         allocatable :: smooth_diff     ! diffusivity (m^2/sec) for smoothing thickness_sigma

real, dimension(:,:),         allocatable :: sigma_uhrho_res ! rho_dzt*i-velocity in sigma (m^2/s*kg/m^3)
real, dimension(:,:),         allocatable :: sigma_vhrho_res ! rho_dzt*j-velocity in sigma (m^2/s*kg/m^3)
real, dimension(:,:),         allocatable :: sigma_uhrho_sgs ! rho_dzt*i-velocity in sigma from SGS (m^2/s*kg/m^3)
real, dimension(:,:),         allocatable :: sigma_vhrho_sgs ! rho_dzt*j-velocity in sigma from SGS (m^2/s*kg/m^3)
real, dimension(:,:),         allocatable :: sigma_uhrho     ! sum of sigma_uhrho_res + sigma_uhrho_sgs
real, dimension(:,:),         allocatable :: sigma_vhrho     ! sum of sigma_vhrho_res + sigma_vhrho_sgs

#endif

real, dimension(:,:,:), allocatable :: tracer_sigma       ! tracer concentration in the sigma layer 
real, dimension(:,:),   allocatable :: rho_salinity_sigma ! density salinity concentration in the sigma layer 
real, dimension(:,:,:), allocatable :: fx_diff            ! rho*dzt weighted sigma diffusive flux in i-direction
real, dimension(:,:,:), allocatable :: fy_diff            ! rho*dzt weighted sigma diffusive flux in j-direction
real, dimension(:,:,:), allocatable :: fx_adv             ! rho*dzt weighted sigma advection flux in i-direction
real, dimension(:,:,:), allocatable :: fy_adv             ! rho*dzt weighted sigma advection flux in j-direction
real, dimension(:,:,:), allocatable :: tchg_adv           ! rho*dzt weighted tendency from sigma advection 
real, dimension(:,:,:), allocatable :: tchg_diff          ! rho*dzt weighted tendency from sigma diffusion 
real, dimension(:,:,:), allocatable :: tchg_smooth        ! rho*dzt weighted tendency from sigma smoothing

real, dimension(:,:,:), allocatable :: uhrho_et     ! local version of Adv_vel%uhrho_et
real, dimension(:,:,:), allocatable :: vhrho_nt     ! local version of Adv_vel%vhrho_nt

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), save    :: Dom_flux

integer :: num_prog_tracers=-1
integer :: index_temp=-1
integer :: index_salt=-1

character(len=128) :: version=&
     '$Id: ocean_sigma_transport.F90,v 20.0 2013/12/14 00:14:30 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

integer :: unit=6  
logical :: module_is_initialized = .FALSE.

real    :: press_constant  ! a useful constant for pressure calculation 
real    :: overflow_speed  ! grav*campingoose_delta/campingoose_mu  (m/sec)
real    :: dtime_sigma     ! time step for updating the sigma layer thickness (sec) 

! for global area normalization
real    :: cellarea_r

! nml settings 
logical, public  :: tmask_sigma_on    = .false. ! mask out non-sigma diffusive fluxes passing into sigma layer
logical  :: use_this_module           = .false. ! must be true to have any sigma diffusion occur 
logical  :: debug_this_module         = .false. ! for debugging 
logical  :: verbose_init              = .true.  ! for verbose initialization printout
logical  :: sigma_diffusion_on        = .true.  ! for using sigma diffusion
logical  :: sigma_advection_on        = .false. ! for using sigma advection
logical  :: sigma_advection_sgs_only  = .true.  ! for NOT adding resolved velocity to sigma velocity
logical  :: sigma_advection_check     = .true.  ! to only include resolved velocity when downslope favorable

real     :: sigma_diffusivity         = 1.0e3   ! sigma tracer diffusivity (m^2/sec)
real     :: sigma_diffusivity_ratio   = 1.0e-6  ! ratio of min to max sigma diffusivities
real     :: thickness_sigma_max       = 100.0   ! maximum thickness (m) of bottom sigma layer
real     :: thickness_sigma_min       = 10.0    ! minimum thickness (m) of bottom sigma layer
real     :: thickness_sigma_layer     = 50.0    ! initial thickness (m) of bottom sigma layer
real     :: vel_micom                 = 0.50    ! constant velocity scale (m/s) for setting micom diffusivity
real     :: campingoose_mu            = 1.e-4   ! (sec^-1) friction for deriving SGS downslope velocity 
real     :: campingoose_delta         = 0.3333  ! fraction of a grid cell participating in dowslope advection
real     :: sigma_umax                = .10     ! (m/sec) max speed in sigma layer for downslope advection
logical  :: tracer_mix_micom          = .false. ! if true, diffusivity made a function of horz grid spacing
logical  :: sigma_just_in_bottom_cell = .true.  ! for sigma just in the bottom cell, as in mom4p0. 
logical  :: write_a_restart           = .true.  ! to reproduce across restarts when undulating thickness_sigma  
logical  :: smooth_sigma_thickness    = .true.  ! to smooth the sigma_thickness
logical  :: smooth_sigma_velocity     = .true.  ! to smooth the advective transport in the sigma layer 
real     :: smooth_velmicom           = 0.2     ! velocity scale (m/s) to smooth sigma_thickness & sigma velocity 

namelist /ocean_sigma_transport_nml/ use_this_module, debug_this_module, tmask_sigma_on, sigma_diffusion_on, &
                                     sigma_advection_on, sigma_advection_sgs_only, sigma_advection_check,    &
                                     thickness_sigma_layer, thickness_sigma_max, thickness_sigma_min,        & 
                                     sigma_diffusivity, sigma_diffusivity_ratio,                             &
                                     tracer_mix_micom, vel_micom,                                            &
                                     verbose_init, sigma_just_in_bottom_cell,                                &
                                     campingoose_mu, campingoose_delta, sigma_umax, write_a_restart,         &
                                     smooth_sigma_thickness, smooth_sigma_velocity, smooth_velmicom

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_sigma_transport_init">
!
! <DESCRIPTION>
! Initialize the sigma transport module by registering fields for 
! diagnostic output and performing some numerical checks to see 
! that namelist settings are appropriate. 
! </DESCRIPTION>
!
subroutine ocean_sigma_transport_init(Grid, Domain, Time, Dens, T_prog, Ocean_options, &
                                      dtime, ver_coordinate, vert_coordinate_type, debug)

  type(ocean_domain_type),      intent(in), target   :: Domain
  type(ocean_grid_type),        intent(in), target   :: Grid
  type(ocean_time_type),        intent(in)           :: Time
  type(ocean_density_type),     intent(in)           :: Dens
  type(ocean_prog_tracer_type), intent(inout)        :: T_prog(:)
  type(ocean_options_type),     intent(inout)        :: Ocean_options
  real,                         intent(in)           :: dtime
  integer,                      intent(in)           :: ver_coordinate
  integer,                      intent(in)           :: vert_coordinate_type
  logical,                      intent(in), optional :: debug

  integer :: ioun, io_status, ierr
  integer :: i, j, n, num
  integer :: id_restart
  real    :: dxdymn, asigma_crit
  
  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_sigma_transport_mod (ocean_sigma_transport_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.
  vert_coordinate       = ver_coordinate 

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_sigma_transport_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_sigma_transport_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_sigma_transport_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_sigma_transport_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_sigma_transport_nml)  
  write (stdlogunit,ocean_sigma_transport_nml)

  if(use_this_module) then 
      call mpp_error(NOTE, &
      '==>Note from ocean_sigma_transport_mod: USING ocean_sigma_transport_mod.')
      Ocean_options%sigma_transport = 'Used ocean sigma transport option.'
      if(vert_coordinate_type == TERRAIN_FOLLOWING) then 
          call mpp_error(WARNING, &
          '==>Warning: ocean_sigma_transport_mod is NOT supported for TERRAIN_FOLLOWING vert coodinates.')
      endif
  else 
      call mpp_error(NOTE, &
      '==>Note from ocean_sigma_transport_mod: NOT using ocean_sigma_transport_mod.')
      Ocean_options%sigma_transport = 'Did NOT use ocean sigma transport option.'
      return
  endif

  if (PRESENT(debug) .and. .not. debug_this_module) then
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') '==>Note: running ocean_sigma_transport_mod with debug_this_module=.true.'  
  endif 

  write(stdoutunit,'(a,f10.2)')   &
   '==>Note: ocean_sigma_transport_mod: using forward time step of (secs)', dtime 

  if(.not. write_a_restart) then 
    write(stdoutunit,'(a)') '==>Note: running ocean_sigma_transport_mod with write_a_restart=.false.'
    write(stdoutunit,'(a)') '   Will NOT write restart file, and so cannot restart the run.'
  endif 

  if(sigma_diffusion_on) then 
      write(stdoutunit,'(a)') '==>Note: ocean_sigma_transport_mod: sigma_diffusion_on=.true.'
  else
      write(stdoutunit,'(a)') '==>Note: ocean_sigma_transport_mod: sigma_diffusion_on=.false.'
  endif
  if(sigma_advection_on) then 
      write(stdoutunit,'(a)') '==>Note: ocean_sigma_transport_mod: sigma_advection_on=.true.'
      if(sigma_advection_check) then 
          write(stdoutunit,'(a)') '==>Note: ocean_sigma_transport_mod: sigma_advection_check=.true.'
      else
          write(stdoutunit,'(a)') '==>Note: ocean_sigma_transport_mod: sigma_advection_check=.false.'
      endif
  else
      write(stdoutunit,'(a)') '==>Note: ocean_sigma_transport_mod: sigma_advection_on=.false.'
  endif
  if(.not. sigma_diffusion_on .and. .not. sigma_advection_on) then 
      write(stdoutunit,'(a)') &
      '==>Note: ocean_sigma_transport_mod: sigma_advection_on=.false. AND sigma_diffusion_on=.false.'
  endif   
  if(sigma_advection_on .and. sigma_just_in_bottom_cell) then 
    call mpp_error(FATAL, &
   '==>Error ocean_sigma_transport_mod: sigma_just_in_bottom=.true. incompatible w/ sigma_advection_on=.true.')
  endif 
  if(sigma_just_in_bottom_cell) then 
     write(stdoutunit,'(a)') &
     '==>Note from ocean_sigma_transport_mod: using sigma_just_in_bottom=.true., as in mom4p0.'
  endif 
 
#ifndef MOM_STATIC_ARRAYS  
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
#endif
  
  Dom => Domain
  Grd => Grid

  dtime_sigma      = dtime   
  num_prog_tracers = size(T_prog(:))
  press_constant   = rho0*grav*c2dbars
  overflow_speed   = grav*campingoose_delta/(epsln+campingoose_mu)
  cellarea_r       = 1.0/(epsln + Grd%tcellsurf)

  call set_ocean_domain(Dom_flux, Grid, xhalo=Dom%xhalo, yhalo=Dom%yhalo, &
                        name='flux dom sigma', maskmap=Dom%maskmap)

  do n=1, num_prog_tracers
     if (T_prog(n)%name == 'temp') index_temp = n
     if (T_prog(n)%name == 'salt') index_salt = n
  enddo

  if (index_temp < 1 .or. index_salt < 1) then 
    call mpp_error(FATAL, &
     '==>Error in ocean_sigma_transport_mod: temp and/or salt not identified in tracer array')
  endif 

  if(thickness_sigma_layer==0.0) then 
    call mpp_error(FATAL, &
     '==>Error in ocean_sigma_transport_mod: can only run this module with thickness_sigma_layer > 0.0')
  endif 
  write (stdoutunit,'(a,f12.4)') &
   '==>Note: ocean_sigma_transport_mod: initial thickness of sigma layer (m)   = ', thickness_sigma_layer 

  if(sigma_advection_on) then 
    write (stdoutunit,'(a)') &
     '==>Note: ocean_sigma_transport_mod: allowing sigma layer thickness to undulate in time as per sigma advection. '
    write (stdoutunit,'(a,f12.4)') &
     '==>Note: ocean_sigma_transport_mod: maximum thickness of sigma layer (m) = ', thickness_sigma_max
    write (stdoutunit,'(a,f12.4)') &
     '==>Note: ocean_sigma_transport_mod: minimum thickness of sigma layer (m) = ', thickness_sigma_min

    if(sigma_advection_sgs_only) then 
       write (stdoutunit,'(a)') &
       '==>Note: ocean_sigma_transport_mod: sigma-advective transport is due JUST to parameterized transport.'
    else
       write (stdoutunit,'(a)') &
       '==>Note: ocean_sigma_transport_mod: sigma-advective transport arises from resolved and SGS transport.'
    endif 

  endif 

#ifndef MOM_STATIC_ARRAYS
  allocate (diff_cet(isd:ied,jsd:jed))
  allocate (diff_cnt(isd:ied,jsd:jed))
  allocate (diff_max(isd:ied,jsd:jed))
  allocate (smooth_diff(isd:ied,jsd:jed))
  allocate (dtopog_dx(isd:ied,jsd:jed))
  allocate (dtopog_dy(isd:ied,jsd:jed))
  allocate (tmask_sigma(isd:ied,jsd:jed))
  allocate (thickness_sigma(isd:ied,jsd:jed))
  allocate (sigma_uhrho_res(isd:ied,jsd:jed))
  allocate (sigma_vhrho_res(isd:ied,jsd:jed))
  allocate (sigma_uhrho_sgs(isd:ied,jsd:jed))
  allocate (sigma_vhrho_sgs(isd:ied,jsd:jed))
  allocate (sigma_uhrho(isd:ied,jsd:jed))
  allocate (sigma_vhrho(isd:ied,jsd:jed))
#endif
  allocate (tracer_sigma(isd:ied,jsd:jed,num_prog_tracers))
  allocate (rho_salinity_sigma(isd:ied,jsd:jed))
  allocate (fx_diff(isd:ied,jsd:jed,num_prog_tracers))
  allocate (fy_diff(isd:ied,jsd:jed,num_prog_tracers))
  allocate (fx_adv(isd:ied,jsd:jed,num_prog_tracers))
  allocate (fy_adv(isd:ied,jsd:jed,num_prog_tracers))
  allocate (tchg_diff(isd:ied,jsd:jed,num_prog_tracers))
  allocate (tchg_adv(isd:ied,jsd:jed,num_prog_tracers))
  allocate (tchg_smooth(isd:ied,jsd:jed,num_prog_tracers))

  allocate (uhrho_et(isd:ied,jsd:jed,nk))
  allocate (vhrho_nt(isd:ied,jsd:jed,nk))
  uhrho_et(:,:,:) = 0.0
  vhrho_nt(:,:,:) = 0.0

  ! if wish to further mask out regions, do so here;
  ! need at least kmt=3 to make sense of the algorithm.
  tmask_sigma(:,:) = Grd%tmask(:,:,1)
  do j=jsd,jed
    do i=isd,ied
      if(Grd%kmt(i,j) < 3) tmask_sigma(i,j) = 0.0
    enddo
  enddo
  
  ! initial sigma layer thickness
  thickness_sigma(:,:) = thickness_sigma_layer*tmask_sigma(:,:) 

  ! tracer concentration in the sigma layer 
  tracer_sigma(:,:,:)     = 0.0
  rho_salinity_sigma(:,:) = 0.0

  ! sigma tracer fluxes 
  fx_diff(:,:,:) = 0.0
  fy_diff(:,:,:) = 0.0
  fx_adv(:,:,:)  = 0.0
  fy_adv(:,:,:)  = 0.0

  ! sigma tendencies 
  tchg_diff(:,:,:)   = 0.0
  tchg_adv(:,:,:)    = 0.0
  tchg_smooth(:,:,:) = 0.0

  ! sigma diffusivities 
  diff_cet(:,:) = 0.0
  diff_cnt(:,:) = 0.0
  diff_max(:,:) = sigma_diffusivity*tmask_sigma(:,:) 

  ! diffusivity for smoothing thickness of sigma layer 
  if(smooth_sigma_thickness) then 
     write (stdoutunit,'(a)') &
     '==>Note: ocean_sigma_transport_mod: smooth_sigma_thickness=.true. => diffuse sigma_thickness.'
     smooth_diff(:,:) =  tmask_sigma(:,:)*smooth_velmicom &
                        *(2.0*Grd%dxt(:,:)*Grd%dyt(:,:)/(Grd%dxt(:,:)+Grd%dyt(:,:)))
  else 
     smooth_diff(:,:) = 0.0
  endif 

 
  ! rho_dzt * advective velocity in sigma layer 
  sigma_uhrho_res(:,:) = 0.0
  sigma_vhrho_res(:,:) = 0.0
  sigma_uhrho_sgs(:,:) = 0.0
  sigma_vhrho_sgs(:,:) = 0.0
  sigma_uhrho(:,:)     = 0.0
  sigma_vhrho(:,:)     = 0.0

  ! Micom diffusivity
  if(tracer_mix_micom) then
    do j=jsd,jed
      do i=isd,ied
        diff_max(i,j) = tmask_sigma(i,j)*vel_micom &
                        *(2.0*Grd%dxt(i,j)*Grd%dyt(i,j)/(Grd%dxt(i,j)+Grd%dyt(i,j)))
      enddo
    enddo
    if(verbose_init) then 
      do j=jsc,jec
        write (stdoutunit,'(a,i4,a,e14.7,a)')  &
         ' Laplacian diffusivity in sigma layer at (isc,',j,') = ',diff_max(isc,j),' m^2/s'
      enddo 
    endif 
  endif

  ! Gradient of bottom topography.
  dtopog_dx=0.0 ;  dtopog_dy=0.0
  do j=jsd,jed-1
     do i=isd,ied-1 
        dtopog_dx(i,j) = Grd%tmask(i+1,j,1)*(Grd%ht(i+1,j)-Grd%ht(i,j))*Grd%dxter(i,j)
        dtopog_dy(i,j) = Grd%tmask(i,j+1,1)*(Grd%ht(i,j+1)-Grd%ht(i,j))*Grd%dytnr(i,j)
     enddo
  enddo

  id_restart = register_restart_field(Sigma_restart, 'ocean_sigma_transport.res.nc', 'thickness_sigma', &
               thickness_sigma(:,:), domain=Dom%domain2d )

  ! read in sigma thickness from restart 
  if(.NOT.file_exist('INPUT/ocean_sigma_transport.res.nc')) then
      if (.NOT. Time%init) call mpp_error(FATAL,'Expecting file INPUT/ocean_sigma_transport.res.nc to exist.&
           &This file was not found and Time%init=.false.')
  else
      call restore_state(Sigma_restart)
      call mpp_update_domains(thickness_sigma(:,:),Dom%domain2d)
      write(stdoutunit,*) ' '
      write(stdoutunit,*) 'From ocean_sigma_transport_mod: initial thickness_sigma chksum'
      call write_timestamp(Time%model_time)
      call write_chksum_2d('thickness_sigma', thickness_sigma(COMP)*Grd%tmask(COMP,1))
  endif

  ! checks
  if (dtime /= 0.0) then
    num = 0
    do j=jsc,jec
      do i=isc,iec
        dxdymn = 2.0/(1.0/(Grd%dxt(i,j))**2 + 1.0/Grd%dyt(i,j)**2)
        asigma_crit = 0.5*dxdymn/dtime
        if (diff_max(i,j)*Grd%tmask(i,j,1)  > asigma_crit .and. num <= 10) then
          num = num + 1
          if (num == 1) write (unit,'(/,(1x,a))')&
          '==> Warning: Diffusive criteria exceeded. use a smaller "dtts", or "asigma".  Show 1st 10 violations:'
          write (stdoutunit,'(a,i4,a,i4,a,f6.2,a,f6.2,a,2(e14.7,a))') &
          ' at (i,j)= (',i,',',j,'), (lon,lat)= (', Grd%xt(i,j),',',Grd%yt(i,j),&
          '),  "ah" = ', diff_max(i,j),' m^2/s. the critical value =',asigma_crit,' m^2/s'
        endif
      enddo
    enddo
  endif

  ! diagnostics 

  id_dtopog_dx   = register_static_field ('ocean_model', 'dtopog_dx', Grd%tracer_axes(1:2), &
                  'X-derivative of bottom depth', 'm/m', missing_value=missing_value, range=(/-1.e3,1.e3/))
  id_dtopog_dy   = register_static_field ('ocean_model', 'dtopog_dy', Grd%tracer_axes(1:2), &
                  'Y-derivative of bottom depth', 'm/m', missing_value=missing_value, range=(/-1.e3,1.e3/))
  id_tmask_sigma = register_static_field ('ocean_model', 'tmask_sigma', Grd%tracer_axes(1:2), &
                   'Mask for bottom sigma layer', 'm', missing_value=missing_value, range=(/-1.e3,1.e5/))

  if (id_dtopog_dx  > 0) then 
    used = send_data (id_dtopog_dx, dtopog_dx(isc:iec,jsc:jec), Time%model_time)
  endif
  if (id_dtopog_dy  > 0) then 
    used = send_data (id_dtopog_dy, dtopog_dy(isc:iec,jsc:jec), Time%model_time)
  endif 
  if (id_tmask_sigma  > 0) then 
    used = send_data (id_tmask_sigma, tmask_sigma(isc:iec,jsc:jec), Time%model_time)
  endif 

  id_thickness_sigma = register_diag_field ('ocean_model', 'thickness_sigma', Grd%tracer_axes(1:2), &
                     Time%model_time, 'Thickness of BBL', 'm', missing_value=missing_value,         &
                     range=(/-1.e3,1.e3/))
  id_weight_sigma    = register_diag_field ('ocean_model', 'weight_sigma', Grd%tracer_axes(1:3), &
                     Time%model_time, 'weight of cell w/i sigma layer', 'dimensionless',         &
                     missing_value=missing_value, range=(/-10.0,10.0/))
  id_diff_cet = register_diag_field ('ocean_model', 'diff_cet_sigma', Grd%tracer_axes(1:2),   &
                Time%model_time, 'i-sigma diffusivity', 'm^2/s', missing_value=missing_value, &
                range=(/-10.0,1.e8/))
  id_diff_cnt = register_diag_field ('ocean_model', 'diff_cnt_sigma', Grd%tracer_axes(1:2),   &
                Time%model_time, 'j-sigma diffusivity', 'm^2/s', missing_value=missing_value, &
                range=(/-10.0,1.e8/))

  id_sigma_uhrho = register_diag_field ('ocean_model', 'sigma_uhrho', Grd%tracer_axes(1:2), &
                   Time%model_time, 'i-sigma uhrho', 'm^2/s * kg/m^3',                      &
                   missing_value=missing_value, range=(/-10.0,1.e8/))
  id_sigma_vhrho = register_diag_field ('ocean_model', 'sigma_vhrho', Grd%tracer_axes(1:2),  &
                   Time%model_time, 'j-sigma vhrho', 'm^2/s * kg/m^3',                       &
                   missing_value=missing_value, range=(/-1.e4,1.e4/))
  id_sigma_uhrho_sgs = register_diag_field ('ocean_model', 'sigma_uhrho_sgs', Grd%tracer_axes(1:2), &
                       Time%model_time, 'i-sigma uhrho from SGS', 'm^2/s * kg/m^3',                 &
                       missing_value=missing_value, range=(/-1.e4,1.e4/))
  id_sigma_vhrho_sgs = register_diag_field ('ocean_model', 'sigma_vhrho_sgs', Grd%tracer_axes(1:2), &
                       Time%model_time, 'j-sigma vhrho from SGS', 'm^2/s * kg/m^3',                 &
                       missing_value=missing_value, range=(/-1.e4,1.e4/))
  id_sigma_uhrho_res = register_diag_field ('ocean_model', 'sigma_uhrho_res', Grd%tracer_axes(1:2), &
                       Time%model_time, 'i-sigma uhrho via resolved flow', 'm^2/s * kg/m^3',        &
                       missing_value=missing_value, range=(/-1.e4,1.e4/))
  id_sigma_vhrho_res = register_diag_field ('ocean_model', 'sigma_vhrho_res', Grd%tracer_axes(1:2), &
                       Time%model_time, 'j-sigma vhrho via resolved flow', 'm^2/s * kg/m^3',        &
                       missing_value=missing_value, range=(/-1.e4,1.e4/))


  allocate (id_tracer_sigma(num_prog_tracers))
  allocate (id_sigma_diff(num_prog_tracers))
  allocate (id_sigma_adv(num_prog_tracers))
  allocate (id_sigma_diff_2d(num_prog_tracers))
  allocate (id_sigma_adv_2d(num_prog_tracers))
  allocate (id_sigma_smooth(num_prog_tracers))
  id_tracer_sigma  = -1
  id_sigma_diff    = -1
  id_sigma_adv     = -1
  id_sigma_diff_2d = -1
  id_sigma_adv_2d  = -1
  id_sigma_smooth  = -1
 
  do n=1,num_prog_tracers

     id_tracer_sigma(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_sigma', &
                          Grd%tracer_axes(1:2), Time%model_time,                              &
                          trim(T_prog(n)%longname)//' in sigma layer', trim(T_prog(n)%units), &
                          missing_value=missing_value, range=(/-10.0,1.e10/))

     if (T_prog(n)%name == 'temp') then
        id_sigma_diff(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_sigma_diff', &
                           Grd%tracer_axes(1:3), Time%model_time,                                   &
                           'thk wghtd sigma-diffusion heating ', 'Watts/m^2',                       &
                           missing_value=missing_value, range=(/-1.e16,1.e16/))
        id_sigma_adv(n)  = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_sigma_adv', &
                           Grd%tracer_axes(1:3), Time%model_time,                                  &
                           'thk wghtd sigma-advection heating ', 'Watts/m^2',                      &
                           missing_value=missing_value, range=(/-1.e16,1.e16/))
        id_sigma_diff_2d(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_sigma_diff_2d', &
                           Grd%tracer_axes(1:2), Time%model_time,                                          &
                           'thk wghtd sigma-diffusion heating in sigma layer', 'Watts/m^2',                &
                           missing_value=missing_value, range=(/-1.e16,1.e16/))
        id_sigma_adv_2d(n)  = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_sigma_adv_2d', &
                           Grd%tracer_axes(1:2), Time%model_time,                                        &
                           'thk wghtd sigma-advection heating in sigma layer', 'Watts/m^2',              &
                           missing_value=missing_value, range=(/-1.e16,1.e16/))
        id_sigma_smooth(n)  = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_sigma_smooth', &
                           Grd%tracer_axes(1:2), Time%model_time,                                        &
                           'thk wghtd sigma-smoothing heating in sigma layer', 'Watts/m^2',              &
                           missing_value=missing_value, range=(/-1.e16,1.e16/))
     else 
        id_sigma_diff(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_sigma_diff',          &
                           Grd%tracer_axes(1:3), Time%model_time,                                            &
                           'thk wghtd sigma-diffusion on '//trim(T_prog(n)%name), trim(T_prog(n)%flux_units),&
                           missing_value=missing_value, range=(/-1.e16,1.e16/))
        id_sigma_adv(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_sigma_adv',            &
                           Grd%tracer_axes(1:3), Time%model_time,                                            &
                           'thk wghtd sigma-advection on '//trim(T_prog(n)%name), trim(T_prog(n)%flux_units),&
                           missing_value=missing_value, range=(/-1.e16,1.e16/))
        id_sigma_diff_2d(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_sigma_diff_2d',    &
                           Grd%tracer_axes(1:2), Time%model_time,                                            &
                           'thk wghtd sigma-diffusion in sigma layer on '//trim(T_prog(n)%name),             &
                           trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e16,1.e16/))
        id_sigma_adv_2d(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_sigma_adv_2d',      &
                           Grd%tracer_axes(1:2), Time%model_time,                                            &
                           'thk wghtd sigma-advection in sigma layer on '//trim(T_prog(n)%name),             &
                           trim(T_prog(n)%flux_units), &
                           missing_value=missing_value, range=(/-1.e16,1.e16/))
        id_sigma_smooth(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_sigma_smooth',&
                           Grd%tracer_axes(1:2), Time%model_time,                                      &
                           'thk wghtd sigma-smoothing in sigma layer on '//trim(T_prog(n)%name),       &
                           trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e16,1.e16/))
     endif 
  enddo


  ! diagnostics for sigma diffusion 

  allocate (id_sigma_diff_xflux(num_prog_tracers))
  allocate (id_sigma_diff_yflux(num_prog_tracers))
  allocate (id_sigma_diff_xflux_int_z(num_prog_tracers))
  allocate (id_sigma_diff_yflux_int_z(num_prog_tracers))
  id_sigma_diff_xflux       = -1
  id_sigma_diff_yflux       = -1
  id_sigma_diff_xflux_int_z = -1
  id_sigma_diff_yflux_int_z = -1

  do n=1,num_prog_tracers
    if(n == index_temp) then 

      id_sigma_diff_xflux(n) = register_diag_field ('ocean_model', &
              trim(T_prog(n)%name)//'_sigma_diff_xflux',           &
              Grd%tracer_axes_flux_x(1:3), Time%model_time,        &
              'cp*sigma_diff_xflux*dyt*rho_dzt*temp',              &
              'Watt', missing_value=missing_value, range=(/-1.e16,1.e16/))
      id_sigma_diff_yflux(n) = register_diag_field ('ocean_model',     &
              trim(T_prog(n)%name)//'_sigma_diff_yflux',               &
              Grd%tracer_axes_flux_y(1:3),  Time%model_time,           &
              'cp*sigma_diff_yflux*dxt*rho_dzt*temp',                  &
              'Watt', missing_value=missing_value, range=(/-1.e16,1.e16/))
      id_sigma_diff_xflux_int_z(n) = register_diag_field ('ocean_model', &
              trim(T_prog(n)%name)//'_sigma_diff_xflux_int_z',           &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,              &
              'vertical sum of cp*sigma_diff_xflux*dyt*rho_dzt*temp',    &
              'Watt', missing_value=missing_value, range=(/-1.e16,1.e16/))
      id_sigma_diff_yflux_int_z(n) = register_diag_field ('ocean_model', &
              trim(T_prog(n)%name)//'_sigma_diff_yflux_int_z',           &
              Grd%tracer_axes_flux_y(1:2),  Time%model_time,             &
              'vertical sum of cp*sigma_diff_yflux*dxt*rho_dzt*temp',    &
              'Watt', missing_value=missing_value, range=(/-1.e16,1.e16/))
  else

      id_sigma_diff_xflux(n) = register_diag_field ('ocean_model',              &
              trim(T_prog(n)%name)//'_sigma_diff_xflux',                        &
              Grd%tracer_axes_flux_x(1:3), Time%model_time,                     &
              'sigma_diff_xflux*dyt*rho_dzt*tracer for '//trim(T_prog(n)%name), &
              'kg/sec', missing_value=missing_value,                            & 
              range=(/-1.e16,1.e16/))
      id_sigma_diff_yflux(n) = register_diag_field ('ocean_model',              &
              trim(T_prog(n)%name)//'_sigma_diff_yflux',                        &
              Grd%tracer_axes_flux_y(1:3), Time%model_time,                     &
              'sigma_diff_yflux*dxt*rho_dzt*tracer for '//trim(T_prog(n)%name), &
              'kg/sec', missing_value=missing_value,                            &
              range=(/-1.e16,1.e16/))
      id_sigma_diff_xflux_int_z(n) = register_diag_field ('ocean_model',                        &
              trim(T_prog(n)%name)//'_sigma_diff_xflux_int_z',                                  &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                                     &
              'vertical sum of sigma_diff_xflux*dyt*rho_dzt*tracer for '//trim(T_prog(n)%name), &
              'kg/sec', missing_value=missing_value,                                            & 
              range=(/-1.e16,1.e16/))
      id_sigma_diff_yflux_int_z(n) = register_diag_field ('ocean_model',                        &
              trim(T_prog(n)%name)//'_sigma_diff_yflux_int_z',                                  &
              Grd%tracer_axes_flux_y(1:2), Time%model_time,                                     &
              'vertical sum of sigma_diff_yflux*dxt*rho_dzt*tracer for '//trim(T_prog(n)%name), &
              'kg/sec', missing_value=missing_value,                                            &
              range=(/-1.e16,1.e16/))
    endif 
  enddo

  ! diagnostics for sigma advection 

  allocate (id_sigma_adv_xflux(num_prog_tracers))
  allocate (id_sigma_adv_yflux(num_prog_tracers))
  allocate (id_sigma_adv_xflux_int_z(num_prog_tracers))
  allocate (id_sigma_adv_yflux_int_z(num_prog_tracers))
  id_sigma_adv_xflux       = -1
  id_sigma_adv_yflux       = -1
  id_sigma_adv_xflux_int_z = -1
  id_sigma_adv_yflux_int_z = -1

  do n=1,num_prog_tracers
    if(n == index_temp) then 

      id_sigma_adv_xflux(n) = register_diag_field ('ocean_model',  &
               trim(T_prog(n)%name)//'_sigma_adv_xflux',           &
               Grd%tracer_axes_flux_x(1:3), Time%model_time,       &
               'cp*sigma_adv_xflux*dyt*rho_dzt*temp',              &
               'Watt', missing_value=missing_value, range=(/-1.e16,1.e16/))
      id_sigma_adv_yflux(n) = register_diag_field ('ocean_model',     &
              trim(T_prog(n)%name)//'_sigma_adv_yflux',               &
              Grd%tracer_axes_flux_y(1:3), Time%model_time,           &
              'cp*sigma_adv_yflux*dxt*rho_dzt*temp', &
              'Watt', missing_value=missing_value, range=(/-1.e16,1.e16/))
      id_sigma_adv_xflux_int_z(n) = register_diag_field ('ocean_model',  &
               trim(T_prog(n)%name)//'_sigma_adv_xflux_int_z',           &
               Grd%tracer_axes_flux_x(1:2), Time%model_time,             &
               'vertical sum of cp*sigma_adv_xflux*dyt*rho_dzt*temp',    &
               'Watt', missing_value=missing_value, range=(/-1.e16,1.e16/))
      id_sigma_adv_yflux_int_z(n) = register_diag_field ('ocean_model',  &
              trim(T_prog(n)%name)//'_sigma_adv_yflux_int_z',            &
              Grd%tracer_axes_flux_y(1:2), Time%model_time,              &
              'vertical sum of cp*sigma_adv_yflux*dxt*rho_dzt*temp',     &
              'Watt', missing_value=missing_value, range=(/-1.e16,1.e16/))

  else

      id_sigma_adv_xflux(n) = register_diag_field ('ocean_model',             &
              trim(T_prog(n)%name)//'_sigma_adv_xflux',                       &
              Grd%tracer_axes_flux_x(1:3), Time%model_time,                   &
              'sigma_adv_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name), &
              'kg/sec', missing_value=missing_value,                          & 
              range=(/-1.e16,1.e16/))
      id_sigma_adv_yflux(n) = register_diag_field ('ocean_model',             &
              trim(T_prog(n)%name)//'_sigma_adv_yflux',                       &
              Grd%tracer_axes_flux_y(1:3), Time%model_time,                   &
              'sigma_adv_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name), &
              'kg/sec', missing_value=missing_value,                          &
              range=(/-1.e16,1.e16/))
      id_sigma_adv_xflux_int_z(n) = register_diag_field ('ocean_model',                       &
              trim(T_prog(n)%name)//'_sigma_adv_xflux_int_z',                                 &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                                   &
              'vertical sum of sigma_adv_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name), &
              'kg/sec', missing_value=missing_value,                                          & 
              range=(/-1.e16,1.e16/))
      id_sigma_adv_yflux_int_z(n) = register_diag_field ('ocean_model',                       &
              trim(T_prog(n)%name)//'_sigma_adv_yflux_int_z',                                 &
              Grd%tracer_axes_flux_y(1:2), Time%model_time,                                   &
              'vertical sum of sigma_adv_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name), &
              'kg/sec', missing_value=missing_value,                                          &
              range=(/-1.e16,1.e16/))
    endif 
  enddo

  call watermass_diag_init(Time, Dens)

end subroutine ocean_sigma_transport_init
! </SUBROUTINE> NAME="ocean_sigma_transport_init"


!#######################################################################
! <SUBROUTINE NAME="sigma_transport">
!
! <DESCRIPTION>
! This subroutine computes the thickness weighted and density 
! weighted time tendency for tracer arising from transport in a 
! bottom turbulent boundary layer. The result is stored in 
! tracer th_tendency. 
!
! NOTE: In this algorithm, we ideally wish to have advection 
! velocity components on full data domain.  Unfortunately, 
! from ocean_advection_velocity_mod, they are only known 
! on the following domains:
!
! Adv_vel%uhrho_et: (isd,ied) x (jsc,jed)  
! Adv_vel%vhrho_nt: (isc,ied) x (jsd,jed).  
!
! So to proceed with the sigma_transport algorithm, we 
! transfer into local arrays and then update.  These 
! updates may be avoided (possibly), but at the price
! of much more logic in the algorithm.  We choose to 
! instead do the updates and have less logic.  This 
! decision may need to be revisited. 
!
! CAUTION: The advective portion of this algorithm 
! has fundamental problems.  It is retained in MOM
! only for process physics research purposes.  It is
! NOT recommended for use in general use. 
! 
! </DESCRIPTION>
subroutine sigma_transport (Time, Thickness, Dens, T_prog, Adv_vel, bott_blthick)
 
  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_adv_vel_type),     intent(in)    :: Adv_vel
  real, dimension(isd:,jsd:),   intent(inout) :: bott_blthick

  real, dimension(isd:ied,jsd:jed) :: thickness_sigma_eff
  real, dimension(isd:ied,jsd:jed) :: thickness_sigma_old
  real, dimension(isd:ied,jsd:jed) :: dzt_sigma_tendency
  real, dimension(isd:ied,jsd:jed) :: tmp
  real, dimension(2)               :: density_test

  real :: depth_sigma
  real :: check, press
  real :: temp0, salt0, tempip1, saltip1, tempjp1, saltjp1
  real :: ratio_depth, rho_dzt_sigma

  integer :: i, j, k, n
  integer :: kip1, kjp1, kmt, ksigma
  integer :: taum1, tau

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if (.not. use_this_module) return

  if (size(T_prog(:)) /= num_prog_tracers) then 
      call mpp_error(FATAL, &
           '==>Error from ocean_sigma_transport_mod (sigma_transport): size mismatch for tracer array')
  endif
  if (.not. module_is_initialized ) then 
      call mpp_error(FATAL, &
           '==>Error from ocean_sigma_transport_mod (sigma_transport): module must be initialized')
  endif

  taum1 = Time%taum1
  tau   = Time%tau

  ! initialize properties within sigma layer 
  thickness_sigma_eff(:,:) = 0.0
  wrk1(:,:,:)              = 0.0
  tracer_sigma(:,:,:)      = 0.0
  rho_salinity_sigma(:,:)  = 0.0
  sigma_uhrho_res(:,:)     = 0.0     
  sigma_vhrho_res(:,:)     = 0.0     
  dzt_sigma_tendency(:,:)  = 0.0
  rho_dzt_sigma            = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           uhrho_et(i,j,k)       = Adv_vel%uhrho_et(i,j,k)
           vhrho_nt(i,j,k)       = Adv_vel%vhrho_nt(i,j,k)
        enddo
     enddo
  enddo
  call mpp_update_domains(uhrho_et(:,:,:),vhrho_nt(:,:,:),Dom_flux%domain2d, gridtype=CGRID_NE) 

  if(sigma_just_in_bottom_cell) then 
  ! as in mom4p0, sigma layer is just within the bottom 
  ! grid cell, no matter how thin the cell may be. 

      thickness_sigma(:,:) = 0.0 
      do j=jsd,jed
         do i=isd,ied
            if(tmask_sigma(i,j)==1.0) then 
                k                        = Grd%kmt(i,j)
                thickness_sigma(i,j)     = min(thickness_sigma_layer,Thickness%dzt(i,j,k))
                thickness_sigma_eff(i,j) = thickness_sigma(i,j) 
                wrk1(i,j,k)              = 1.0
                do n=1,num_prog_tracers 
                   tracer_sigma(i,j,n)   = T_prog(n)%field(i,j,k,taum1)
                enddo
                rho_salinity_sigma(i,j)  = Dens%rho_salinity(i,j,k,taum1)
            endif 
         enddo
      enddo

  else 
  ! allow sigma layer to be within more than just the bottom cell.
  ! doing so requires some extra accounting to see where the sigma
  ! layer lives.   

      do j=jsd,jed
         do i=isd,ied
            if(tmask_sigma(i,j)==1.0) then 

                kmt           = Grd%kmt(i,j)
                depth_sigma   = Thickness%depth_zwt(i,j,kmt) - thickness_sigma(i,j)
                rho_dzt_sigma = 0.0

                ! boundary layer fills the total water column to top of k=1 cell 
                if(depth_sigma <= 0.0) then 
                    ratio_depth = 1.0
                    ksigma      = 1 
                    do k=ksigma,kmt
                       thickness_sigma_eff(i,j) = thickness_sigma_eff(i,j) + Thickness%dzt(i,j,k)
                       rho_dzt_sigma            = rho_dzt_sigma            + Thickness%rho_dzt(i,j,k,tau)
                       sigma_uhrho_res(i,j)     = sigma_uhrho_res(i,j)     + uhrho_et(i,j,k) 
                       sigma_vhrho_res(i,j)     = sigma_vhrho_res(i,j)     + vhrho_nt(i,j,k) 
                       do n=1,num_prog_tracers 
                          tracer_sigma(i,j,n) = tracer_sigma(i,j,n) &
                               +Thickness%rho_dzt(i,j,k,tau)*T_prog(n)%field(i,j,k,taum1)
                       enddo
                       rho_salinity_sigma(i,j) = rho_salinity_sigma(i,j) &
                               +Thickness%rho_dzt(i,j,k,tau)*Dens%rho_salinity(i,j,k,taum1)
                    enddo
                    do k=ksigma,kmt
                       wrk1(i,j,k) = Thickness%rho_dzt(i,j,k,tau)/rho_dzt_sigma
                    enddo

                ! boundary layer is within k=1 cell 
                elseif(depth_sigma > 0.0 .and. &
                     depth_sigma <= Thickness%depth_zwt(i,j,1)) then 
                    ksigma=1 
                    do k=ksigma+1,kmt
                       thickness_sigma_eff(i,j) = thickness_sigma_eff(i,j) + Thickness%dzt(i,j,k)
                       rho_dzt_sigma            = rho_dzt_sigma            + Thickness%rho_dzt(i,j,k,tau)
                       sigma_uhrho_res(i,j)     = sigma_uhrho_res(i,j)     + uhrho_et(i,j,k) 
                       sigma_vhrho_res(i,j)     = sigma_vhrho_res(i,j)     + vhrho_nt(i,j,k) 
                       do n=1,num_prog_tracers 
                          tracer_sigma(i,j,n) = tracer_sigma(i,j,n) &
                               +Thickness%rho_dzt(i,j,k,tau)*T_prog(n)%field(i,j,k,taum1)
                       enddo
                       rho_salinity_sigma(i,j) = rho_salinity_sigma(i,j) &
                               +Thickness%rho_dzt(i,j,k,tau)*Dens%rho_salinity(i,j,k,taum1)
                    enddo
                    k=ksigma
                    ratio_depth = (Thickness%depth_zwt(i,j,k)-depth_sigma) &
                                 /(Thickness%depth_zwt(i,j,k) + epsln)
                    thickness_sigma_eff(i,j) = thickness_sigma_eff(i,j) + ratio_depth*Thickness%dzt(i,j,k)
                    rho_dzt_sigma            = rho_dzt_sigma            + ratio_depth*Thickness%rho_dzt(i,j,k,tau)
                    sigma_uhrho_res(i,j)     = sigma_uhrho_res(i,j)     + ratio_depth*uhrho_et(i,j,k) 
                    sigma_vhrho_res(i,j)     = sigma_vhrho_res(i,j)     + ratio_depth*vhrho_nt(i,j,k) 
                    do n=1,num_prog_tracers 
                       tracer_sigma(i,j,n) = tracer_sigma(i,j,n) &
                            +ratio_depth*Thickness%rho_dzt(i,j,k,tau)*T_prog(n)%field(i,j,k,taum1)
                    enddo
                    rho_salinity_sigma(i,j) = rho_salinity_sigma(i,j) &
                            +ratio_depth*Thickness%rho_dzt(i,j,k,tau)*Dens%rho_salinity(i,j,k,taum1)

                    wrk1(i,j,k)    = ratio_depth*Thickness%rho_dzt(i,j,k,tau)/rho_dzt_sigma
                    do k=ksigma+1,kmt
                       wrk1(i,j,k) = Thickness%rho_dzt(i,j,k,tau)/rho_dzt_sigma
                    enddo

                ! boundary layer is fully contained within bottom cell 
                elseif(depth_sigma >  Thickness%depth_zwt(i,j,kmt-1) .and. &
                       depth_sigma <= Thickness%depth_zwt(i,j,kmt)) then  
                    ksigma=kmt
                    k=ksigma
                    ratio_depth = (Thickness%depth_zwt(i,j,k)-depth_sigma) &
                                 /(Thickness%depth_zwt(i,j,k)-Thickness%depth_zwt(i,j,k-1)) 
                    thickness_sigma_eff(i,j) = ratio_depth*Thickness%dzt(i,j,k)
                    rho_dzt_sigma            = ratio_depth*Thickness%rho_dzt(i,j,k,tau)
                    sigma_uhrho_res(i,j)     = ratio_depth*uhrho_et(i,j,k) 
                    sigma_vhrho_res(i,j)     = ratio_depth*vhrho_nt(i,j,k) 
                    do n=1,num_prog_tracers 
                       tracer_sigma(i,j,n)   = rho_dzt_sigma*T_prog(n)%field(i,j,k,taum1)
                    enddo
                    rho_salinity_sigma(i,j)  = rho_dzt_sigma*Dens%rho_salinity(i,j,k,taum1)
                    wrk1(i,j,k) = 1.0

                ! boundary layer is no shallower than k=2 and is not fully in k=kmt
                else

                    kloop1:    do k=2,kmt-1
                       if(depth_sigma >  Thickness%depth_zwt(i,j,k-1) .and. &
                          depth_sigma <= Thickness%depth_zwt(i,j,k)) then  
                          ksigma = k
                          exit kloop1
                       endif
                    enddo kloop1
                    do k=ksigma+1,kmt
                       thickness_sigma_eff(i,j) = thickness_sigma_eff(i,j) + Thickness%dzt(i,j,k)
                       rho_dzt_sigma            = rho_dzt_sigma            + Thickness%rho_dzt(i,j,k,tau)
                       sigma_uhrho_res(i,j)     = sigma_uhrho_res(i,j)     + uhrho_et(i,j,k) 
                       sigma_vhrho_res(i,j)     = sigma_vhrho_res(i,j)     + vhrho_nt(i,j,k) 
                       do n=1,num_prog_tracers 
                          tracer_sigma(i,j,n) = tracer_sigma(i,j,n) &
                               +Thickness%rho_dzt(i,j,k,tau)*T_prog(n)%field(i,j,k,taum1)
                       enddo
                       rho_salinity_sigma(i,j) = rho_salinity_sigma(i,j) &
                               +Thickness%rho_dzt(i,j,k,tau)*Dens%rho_salinity(i,j,k,taum1)
                    enddo
                    k=ksigma 
                    ratio_depth = (Thickness%depth_zwt(i,j,k)-depth_sigma) &
                                 /(Thickness%depth_zwt(i,j,k)-Thickness%depth_zwt(i,j,k-1)) 
                    rho_dzt_sigma            = rho_dzt_sigma            + ratio_depth*Thickness%rho_dzt(i,j,k,tau)
                    thickness_sigma_eff(i,j) = thickness_sigma_eff(i,j) + ratio_depth*Thickness%dzt(i,j,k)
                    sigma_uhrho_res(i,j)     = sigma_uhrho_res(i,j)     + ratio_depth*uhrho_et(i,j,k) 
                    sigma_vhrho_res(i,j)     = sigma_vhrho_res(i,j)     + ratio_depth*vhrho_nt(i,j,k) 
                    do n=1,num_prog_tracers 
                       tracer_sigma(i,j,n) = tracer_sigma(i,j,n) &
                            +ratio_depth*Thickness%rho_dzt(i,j,k,tau)*T_prog(n)%field(i,j,k,taum1)
                    enddo
                    rho_salinity_sigma(i,j) = rho_salinity_sigma(i,j) &
                               +ratio_depth*Thickness%rho_dzt(i,j,k,tau)*Dens%rho_salinity(i,j,k,taum1)
                    wrk1(i,j,k)    = ratio_depth*Thickness%rho_dzt(i,j,k,tau)/rho_dzt_sigma
                    do k=ksigma+1,kmt
                       wrk1(i,j,k) = Thickness%rho_dzt(i,j,k,tau)/rho_dzt_sigma
                    enddo

                endif  ! endif for depth_sigma 

                ! divide by rho_dzt_sigma to produce a tracer concentration
                do n=1,num_prog_tracers 
                   tracer_sigma(i,j,n) = tracer_sigma(i,j,n)/rho_dzt_sigma
                enddo
                rho_salinity_sigma(i,j) = rho_salinity_sigma(i,j)/rho_dzt_sigma

            endif      ! endif for tmask_sigma 
         enddo         ! i-loop  
      enddo            ! j-loop 

  endif                ! endif for sigma_just_in_bottom_cell


  ! set the resolved transport to zero 
  if(sigma_advection_sgs_only) then 
      sigma_uhrho_res(:,:) = 0.0
      sigma_vhrho_res(:,:) = 0.0
  endif

  ! determine diffusivities and SGS velocity within bottom sigma layer.
  ! allow enhanced diffusion even if topography is flat (check=0).
  ! use deepest depth to approximate hydrostatic pressure for computing density. 

  diff_cet(:,:)        = 0.0
  diff_cnt(:,:)        = 0.0
  sigma_uhrho_sgs(:,:) = 0.0     
  sigma_vhrho_sgs(:,:) = 0.0     
  sigma_uhrho(:,:)     = 0.0     
  sigma_vhrho(:,:)     = 0.0     

  do j=jsd,jed-1
     do i=isd,ied-1

        if(tmask_sigma(i,j)==1.0) then 

            k=Grd%kmt(i,j)

            temp0   = tracer_sigma(i,j,  index_temp)
            salt0   = rho_salinity_sigma(i,j)
            tempip1 = tracer_sigma(i+1,j,index_temp)
            saltip1 = rho_salinity_sigma(i+1,j) 
            tempjp1 = tracer_sigma(i,j+1,index_temp)
            saltjp1 = rho_salinity_sigma(i,j+1)

            kip1  = max(1,Grd%kmt(i+1,j))
            press = press_constant*max(Thickness%depth_zt(i,j,k),Thickness%depth_zt(i+1,j,kip1))
            density_test(1) = density(salt0,temp0,press)
            density_test(2) = density(saltip1,tempip1,press)
            check = (density_test(2)-density_test(1))*dtopog_dx(i,j)        

            ! density favorable for downslope flow 
            if(check <= 0.0) then 
                diff_cet(i,j)        = diff_max(i,j)              
                sigma_uhrho_sgs(i,j) = -overflow_speed*check*thickness_sigma_eff(i,j)*sign(1.0,dtopog_dx(i,j))
            else 
                diff_cet(i,j) = diff_max(i,j)*sigma_diffusivity_ratio              
            endif

            ! density favorable for downslope flow & resolved velocity in downslope direction 
            if(check <= 0.0 .and. sigma_uhrho_res(i,j)*dtopog_dx(i,j) >= 0.0) then 
                diff_cet(i,j) = & 
                min(diff_cet(i,j)+abs(sigma_uhrho_res(i,j))*Grd%dxt(i,j)/Thickness%rho_dzt(i,j,k,tau), &
                2.0*diff_max(i,j))
                sigma_uhrho(i,j) = sigma_uhrho_sgs(i,j) + sigma_uhrho_res(i,j)
            else 
                sigma_uhrho(i,j) = sigma_uhrho_sgs(i,j)
            endif

            ! always include resolved velocity  
            if(.not. sigma_advection_check) then 
                sigma_uhrho(i,j) = sigma_uhrho_sgs(i,j) + sigma_uhrho_res(i,j)
            endif 

            kjp1  = max(1,Grd%kmt(i,j+1))
            press = press_constant*max(Thickness%depth_zt(i,j,k),Thickness%depth_zt(i,j+1,kjp1))
            density_test(1) = density(salt0,temp0,press)     
            density_test(2) = density(saltjp1,tempjp1,press)
            check = (density_test(2)-density_test(1))*dtopog_dy(i,j)        

            ! density favorable for downslope flow 
            if(check <= 0.0) then 
                diff_cnt(i,j)        = diff_max(i,j)              
                sigma_vhrho_sgs(i,j) = -overflow_speed*check*thickness_sigma_eff(i,j)*sign(1.0,dtopog_dy(i,j))
            else 
                diff_cnt(i,j) = diff_max(i,j)*sigma_diffusivity_ratio               
            endif

            ! density favorable for downslope flow & resolved velocity in downslope direction 
            if(check <= 0.0 .and. sigma_vhrho_res(i,j)*dtopog_dy(i,j) >= 0.0) then 
                diff_cnt(i,j) = &
                min(diff_cnt(i,j)+abs(sigma_vhrho_res(i,j))*Grd%dyt(i,j)/Thickness%rho_dzt(i,j,k,tau), &
                2.0*diff_max(i,j))     
                sigma_vhrho(i,j) = sigma_vhrho_sgs(i,j) + sigma_vhrho_res(i,j)
            else 
                sigma_vhrho(i,j) = sigma_vhrho_sgs(i,j)
            endif

            ! always include resolved velocity  
            if(.not. sigma_advection_check) then 
                sigma_vhrho(i,j) = sigma_vhrho_sgs(i,j) + sigma_vhrho_res(i,j)
            endif 

            ! check for huge sigma_uhrho and huge sigma_vhrho
            check = rho0*thickness_sigma_eff(i,j)*sigma_umax
            if(sigma_uhrho(i,j) < -check .or. check < sigma_uhrho(i,j)) then 
                sigma_uhrho(i,j) = check*sign(1.0,sigma_uhrho(i,j))
            endif
            if(sigma_vhrho(i,j) < -check .or. check < sigma_vhrho(i,j)) then 
                sigma_vhrho(i,j) = check*sign(1.0,sigma_vhrho(i,j))
            endif


        endif  ! endif for tmask_sigma 

     enddo     ! i-loop
  enddo        ! j-loop 

  ! update sigma layer thickness and compute uhrho and vhrho
  if(.not. sigma_advection_on) then 

      do j=jsd,jed
         do i=isd,ied
            if(tmask_sigma(i,j)==1.0) then 

                thickness_sigma(i,j) = thickness_sigma_eff(i,j)
                if(thickness_sigma_eff(i,j) > thickness_sigma_max) then 
                    thickness_sigma(i,j) = thickness_sigma_max
                endif
                if(thickness_sigma_eff(i,j) < thickness_sigma_min) then 
                    thickness_sigma(i,j) = thickness_sigma_min
                endif

            endif
         enddo
      enddo

  else 

      if(smooth_sigma_velocity) then 
          call mpp_update_domains(sigma_uhrho(:,:),sigma_vhrho(:,:),Dom_flux%domain2d, gridtype=CGRID_NE) 
          sigma_uhrho(:,:) = sigma_uhrho(:,:) + dtime_sigma*LAP_T(sigma_uhrho(:,:),smooth_diff(:,:))
          sigma_vhrho(:,:) = sigma_vhrho(:,:) + dtime_sigma*LAP_T(sigma_vhrho(:,:),smooth_diff(:,:))
      endif

      call mpp_update_domains(sigma_uhrho(:,:),sigma_vhrho(:,:),Dom_flux%domain2d, gridtype=CGRID_NE) 
      dzt_sigma_tendency(:,:) = -rho0r*tmask_sigma(:,:)*(BDX_ET(sigma_uhrho(:,:))+BDY_NT(sigma_vhrho(:,:))) 

      if(smooth_sigma_thickness) then 
          dzt_sigma_tendency(:,:) = dzt_sigma_tendency(:,:) &
                                  + dtime_sigma*LAP_T(thickness_sigma(:,:),smooth_diff(:,:))

          ! this process changes thickness diffusively, so add
          ! a term to the tracer to maintain compatibility.  
          do n=1,num_prog_tracers
             do j=jsd,jed
                do i=isd,ied
                   tmp(i,j) = thickness_sigma(i,j)*tracer_sigma(i,j,n)
                enddo
             enddo
             tmp(:,:) = LAP_T(tmp(:,:),smooth_diff(:,:), update=.true.)
             do j=jsc,jec
                do i=isc,iec
                   tchg_smooth(i,j,n) = dtime_sigma*tmp(i,j)
                enddo
             enddo
          enddo
      endif

      ! update the thickness_sigma array  
      do j=jsc,jec
         do i=isc,iec
            thickness_sigma_old(i,j) = thickness_sigma(i,j)
            thickness_sigma(i,j)     = thickness_sigma_old(i,j) + dtime_sigma*dzt_sigma_tendency(i,j)
         enddo
      enddo

      ! ensure thickness is within bounds 
      do j=jsc,jec
         do i=isc,iec
            if(thickness_sigma(i,j) < thickness_sigma_min) then 
                thickness_sigma(i,j) = thickness_sigma_min
            endif
            if(thickness_sigma(i,j) > thickness_sigma_max) then 
                thickness_sigma(i,j) = thickness_sigma_max
            endif
         enddo
      enddo
      call mpp_update_domains(thickness_sigma(:,:), Dom%domain2d)


  endif  ! endif for sigma_advection_on

  if(debug_this_module) then 
     write(stdoutunit,*) 'From ocean_sigma_transport_mod: intermediate thickness_sigma chksum'
     call write_timestamp(Time%model_time)
     call write_chksum_2d('thickness_sigma', thickness_sigma(COMP)*Grd%tmask(COMP,1))
  endif 

  ! for use in neutral physics 
  do j=jsd,jed
     do i=isd,ied
        bott_blthick(i,j) = thickness_sigma(i,j)
     enddo
  enddo


  ! compute time tendency from sigma advection 
  if(sigma_advection_on) then 
      call advect_sigma_upwind(T_prog(1:num_prog_tracers))

      tchg_adv(:,:,:) = 0.0
      do n=1,num_prog_tracers
         do j=jsc,jec
            do i=isc,iec
               tchg_adv(i,j,n) = -tmask_sigma(i,j) &
                    *(fx_adv(i,j,n)-fx_adv(i-1,j,n)+fy_adv(i,j,n)-fy_adv(i,j-1,n))*Grd%datr(i,j)
            enddo
         enddo
      enddo
  endif


  ! compute time tendency from sigma diffusion 
  if(sigma_diffusion_on) then 

      fx_diff(:,:,:)   = 0.0
      fy_diff(:,:,:)   = 0.0
      tchg_diff(:,:,:) = 0.0

      call mpp_update_domains(diff_cet(:,:), Dom%domain2d)
      call mpp_update_domains(diff_cnt(:,:), Dom%domain2d)

      do n=1,num_prog_tracers

         ! diffusive flux 
         fx_diff(:,:,n) = rho0*diff_cet(:,:)*FDX_T(tracer_sigma(:,:,n)) &
                          *FMX(thickness_sigma_eff(:,:)*tmask_sigma(:,:))
         fy_diff(:,:,n) = rho0*diff_cnt(:,:)*FDY_T(tracer_sigma(:,:,n)) &
                          *FMY(thickness_sigma_eff(:,:)*tmask_sigma(:,:))

         !for redundancies at Arctic fold 
         if (Grd%tripolar) then 
             call mpp_update_domains(fx_diff(:,:,n),fy_diff(:,:,n), Dom_flux%domain2d, &
                                     gridtype=CGRID_NE, complete=T_prog(n)%complete) 
         endif

      enddo

      ! diffusive tendency  
      do n=1,num_prog_tracers
         tchg_diff(:,:,n) = tmask_sigma(:,:)*(BDX_ET(fx_diff(:,:,n)) + BDY_NT(fy_diff(:,:,n)))
      enddo

  endif


  do n=1,num_prog_tracers

     ! th_tendency has dimensions = (tracer concentration)*(m/s)*(kg/m^3)
     wrk2(:,:,:) = 0.0
     wrk3(:,:,:) = 0.0
     wrk4(:,:,:) = 0.0
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              wrk2(i,j,k)                  = wrk1(i,j,k)*tchg_diff(i,j,n)
              wrk3(i,j,k)                  = wrk1(i,j,k)*tchg_adv(i,j,n)
              wrk4(i,j,k)                  = wrk1(i,j,k)*tchg_smooth(i,j,n)
              T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k)  &
                                             + wrk2(i,j,k) + wrk3(i,j,k) + wrk4(i,j,k)
           enddo
        enddo
     enddo

     ! send tracer concentration to diagnostic manager 
     call diagnose_2d(Time, Grd, id_tracer_sigma(n), tracer_sigma(:,:,n))

     ! send tendency to diagnostic manager 
     if (id_sigma_diff(n) > 0) then 
        call diagnose_3d(Time, Grd, id_sigma_diff(n), T_prog(n)%conversion*wrk2(:,:,:))
     endif
     if (id_sigma_adv(n) > 0) then 
        call diagnose_3d(Time, Grd, id_sigma_adv(n), T_prog(n)%conversion*wrk3(:,:,:))
     endif
     if (id_sigma_diff_2d(n) > 0) then 
        call diagnose_2d(Time, Grd, id_sigma_diff_2d(n), T_prog(n)%conversion*tchg_diff(:,:,n))
     endif
     if (id_sigma_adv_2d(n) > 0) then 
        call diagnose_2d(Time, Grd, id_sigma_adv_2d(n), T_prog(n)%conversion*tchg_adv(:,:,n))
     endif


     ! minus sign accounts for MOM sign convention for diffusive flux.  
     if(id_sigma_diff_xflux(n) > 0) then 
         tmp(:,:) = -T_prog(n)%conversion*Grd%dyte(:,:)*fx_diff(:,:,n)
         do k=1,nk
            wrk2(:,:,k) = wrk1(:,:,k)*tmp(:,:) 
         enddo
         call diagnose_3d(Time, Grd, id_sigma_diff_xflux(n), wrk2(:,:,:))
     endif
     if(id_sigma_diff_yflux(n) > 0) then 
         tmp(:,:) = -T_prog(n)%conversion*Grd%dxtn(:,:)*fy_diff(:,:,n)
         do k=1,nk
            wrk2(:,:,k) = wrk1(:,:,k)*tmp(:,:) 
         enddo
         call diagnose_3d(Time, Grd, id_sigma_diff_yflux(n), wrk2(:,:,:))
     endif

     ! advective fluxes have minus sign built in
     if(id_sigma_adv_xflux(n) > 0) then 
         tmp(:,:) = T_prog(n)%conversion*Grd%dyte(:,:)*fx_adv(:,:,n)
         do k=1,nk
            wrk3(:,:,k) = wrk1(:,:,k)*tmp(:,:) 
         enddo
         call diagnose_3d(Time, Grd, id_sigma_adv_xflux(n), wrk3(:,:,:))
     endif
     if(id_sigma_adv_yflux(n) > 0) then 
         tmp(:,:) = T_prog(n)%conversion*Grd%dxtn(:,:)*fy_adv(:,:,n)
         do k=1,nk
            wrk3(:,:,k) = wrk1(:,:,k)*tmp(:,:) 
         enddo
         call diagnose_3d(Time, Grd, id_sigma_adv_yflux(n), wrk3(:,:,:))
     endif

     ! vertically integrated flux from sigma transport = flux in sigma layer. 
     if(id_sigma_diff_xflux_int_z(n) > 0) then 
         tmp(:,:) = -T_prog(n)%conversion*Grd%dyte(:,:)*fx_diff(:,:,n)
         call diagnose_2d(Time, Grd, id_sigma_diff_xflux_int_z(n), tmp(:,:))
     endif
     if(id_sigma_diff_yflux_int_z(n) > 0) then 
         tmp(:,:) = -T_prog(n)%conversion*Grd%dxtn(:,:)*fy_diff(:,:,n)
         call diagnose_2d(Time, Grd, id_sigma_diff_yflux_int_z(n), tmp(:,:))
     endif

     ! advective fluxes have minus sign built in
     if(id_sigma_adv_xflux_int_z(n) > 0) then 
         tmp(:,:) = T_prog(n)%conversion*Grd%dyte(:,:)*fx_adv(:,:,n)
         call diagnose_2d(Time, Grd, id_sigma_adv_xflux_int_z(n), tmp(:,:))
     endif
     if(id_sigma_adv_yflux_int_z(n) > 0) then 
         tmp(:,:) = T_prog(n)%conversion*Grd%dxtn(:,:)*fy_adv(:,:,n)
         call diagnose_2d(Time, Grd, id_sigma_adv_yflux_int_z(n), tmp(:,:))
     endif


  enddo ! end of num_prog_tracer loop


  ! tracer-independent diagnostics 

  if(id_diff_cet > 0) then 
      used = send_data (id_diff_cet, diff_cet(:,:),     &
             Time%model_time, rmask=tmask_sigma(:,:),   &
             is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
  endif
  if(id_diff_cnt > 0) then 
      used = send_data (id_diff_cnt, diff_cnt(:,:),      &
             Time%model_time, rmask=tmask_sigma(:,:),    &
             is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
  endif
  if (id_thickness_sigma  > 0) then 
      used = send_data (id_thickness_sigma, thickness_sigma_eff(:,:), &
             Time%model_time,  rmask=tmask_sigma(:,:),                &
             is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
  endif
  call diagnose_3d(Time, Grd, id_weight_sigma, wrk1(:,:,:))

  if (id_sigma_uhrho  > 0) then 
      used = send_data (id_sigma_uhrho, sigma_uhrho(:,:), &
             Time%model_time,  rmask=tmask_sigma(:,:),    &
             is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
  endif
  if (id_sigma_vhrho  > 0) then 
      used = send_data (id_sigma_vhrho, sigma_vhrho(:,:), &
             Time%model_time,  rmask=tmask_sigma(:,:),    &
             is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
  endif
  if (id_sigma_uhrho_sgs  > 0) then 
      used = send_data (id_sigma_uhrho_sgs, sigma_uhrho_sgs(:,:), &
             Time%model_time,  rmask=tmask_sigma(:,:),            &
             is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
  endif
  if (id_sigma_vhrho_sgs  > 0) then 
      used = send_data (id_sigma_vhrho_sgs, sigma_vhrho_sgs(:,:), &
             Time%model_time,  rmask=tmask_sigma(:,:),            &
             is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
  endif
  if (id_sigma_uhrho_res  > 0) then 
      used = send_data (id_sigma_uhrho_res, sigma_uhrho_res(:,:), &
             Time%model_time,  rmask=tmask_sigma(:,:),            &
             is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
  endif
  if (id_sigma_vhrho_res  > 0) then 
      used = send_data (id_sigma_vhrho_res, sigma_vhrho_res(:,:), &
             Time%model_time,  rmask=tmask_sigma(:,:),            &
             is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
  endif

  call watermass_diag(Time, Dens)  


end subroutine sigma_transport
! </SUBROUTINE> 


!#######################################################################
! <SUBROUTINE NAME="ocean_sigma_transport_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocean_sigma_transport_restart(time_stamp)
  character(len=*), intent(in), optional :: time_stamp

  if(.not. use_this_module) return

  if (.not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_sigma_transport_end: module needs initialization')
  endif 
  call save_restart(Sigma_restart, time_stamp)

end subroutine ocean_sigma_transport_restart
! </SUBROUTINE> NAME="ocean_sigma_transport_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_sigma_transport_end">
!
! <DESCRIPTION>
! Write to restart.
! </DESCRIPTION>
!
subroutine ocean_sigma_transport_end(Time)

  type(ocean_time_type), intent(in) :: Time

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return

  if (.not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_sigma_transport_end: module needs initialization')
  endif 

  if(.not. write_a_restart) then
    write(stdoutunit,'(/a)') &
    '==>Warning from ocean_sigma_transport_mod (ocean_sigma_transport_end): NO restart written.'
    call mpp_error(WARNING,&
    '==>Warning from ocean_sigma_transport_mod (ocean_sigma_transport_end): NO restart written.')
    return
  endif 

  call ocean_sigma_transport_restart

  write(stdoutunit,*) ' '
  write(stdoutunit,*) 'From ocean_sigma_transport_mod: ending chksums'
  call write_timestamp(Time%model_time)
  call write_chksum_2d('thickness_sigma', thickness_sigma(COMP)*Grd%tmask(COMP,1))


end subroutine ocean_sigma_transport_end
! </SUBROUTINE> NAME="ocean_sigma_transport_end"


!#######################################################################
! <SUBROUTINE NAME="advect_sigma_upwind">
!
! <DESCRIPTION>
! First order upwind to advect tracers in sigma layer. 
! </DESCRIPTION>
!
subroutine advect_sigma_upwind(T_prog)

  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)

  real    :: velocity, upos, uneg
  integer :: i, j, n

  fx_adv(:,:,:)   = 0.0
  fy_adv(:,:,:)   = 0.0
  tchg_adv(:,:,:) = 0.0

  do n=1,num_prog_tracers

     ! i-advective flux
     do j=jsc,jec
        do i=isc-1,iec
           velocity      = 0.5*sigma_uhrho(i,j)
           upos          = velocity + abs(velocity)
           uneg          = velocity - abs(velocity)
           fx_adv(i,j,n) = Grd%dyte(i,j)*(upos*tracer_sigma(i,j,n) + uneg*tracer_sigma(i+1,j,n)) &
                           *tmask_sigma(i,j)*tmask_sigma(i+1,j)  
        enddo
     enddo

     ! j-advective flux
     do j=jsc-1,jec
        do i=isc,iec
           velocity      = 0.5*sigma_vhrho(i,j)
           upos          = velocity + abs(velocity)
           uneg          = velocity - abs(velocity)
           fy_adv(i,j,n) = Grd%dxtn(i,j)*(upos*tracer_sigma(i,j,n) + uneg*tracer_sigma(i,j+1,n)) &
                           *tmask_sigma(i,j)*tmask_sigma(i,j+1)
        enddo
     enddo

     ! to handle redundancies across the bipolar fold 
     if (Grd%tripolar) then 
         call mpp_update_domains(fx_adv(:,:,n),fy_adv(:,:,n), Dom_flux%domain2d, &
              gridtype=CGRID_NE, complete=T_prog(n)%complete) 
     endif


  enddo   ! enddo for num_prog_tracers 

end subroutine advect_sigma_upwind
! </SUBROUTINE> NAME="advect_sigma_upwind"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag_init">
!
! <DESCRIPTION>
! Initialization of watermass diagnostic output files. 
! </DESCRIPTION>
!
subroutine watermass_diag_init(Time, Dens)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens

  integer :: stdoutunit
  stdoutunit=stdout()
  compute_watermass_diag = .false. 

  ! diagnostics for neutral density and dianeutral velocity component 
  id_neut_rho_sigma = register_diag_field ('ocean_model', 'neut_rho_sigma', &
                      Grd%tracer_axes(1:3), Time%model_time,                &
                      'update of neutral density from sigma transport',     &
                      '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_rho_sigma > 0) compute_watermass_diag = .true.

  id_wdian_rho_sigma = register_diag_field ('ocean_model', 'wdian_rho_sigma', &
                         Grd%tracer_axes(1:3), Time%model_time,               &
                         'dianeutral mass transport due to sigma transport',  &
                         'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_rho_sigma > 0) compute_watermass_diag = .true.

  id_tform_rho_sigma = register_diag_field ('ocean_model', 'tform_rho_sigma',                       &
                         Grd%tracer_axes(1:3), Time%model_time,                                     &
                         'watermass transform due to sigma transport on levels (pre-layer binning)',&
                         'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_rho_sigma > 0) compute_watermass_diag = .true.

  id_neut_rho_sigma_on_nrho = register_diag_field ('ocean_model',                         &
     'neut_rho_sigma_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                &
     'update of neutral density from sigma transport as binned to neutral density layers',&
                           '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_rho_sigma_on_nrho > 0) compute_watermass_diag = .true.

  id_wdian_rho_sigma_on_nrho = register_diag_field ('ocean_model',                           &
     'wdian_rho_sigma_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                  &
     'dianeutral mass transport due to sigma transport as binned to neutral density layers', &
     'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_rho_sigma_on_nrho > 0) compute_watermass_diag = .true.

  id_tform_rho_sigma_on_nrho = register_diag_field ('ocean_model',                     &
     'tform_rho_sigma_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,            &
     'watermass transform due to sigma transport as binned to neutral density layers', &
     'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_rho_sigma_on_nrho > 0) compute_watermass_diag = .true.

  id_eta_tend_sigma= -1          
  id_eta_tend_sigma= register_diag_field ('ocean_model','eta_tend_sigma',&
       Grd%tracer_axes(1:2), Time%model_time,                            &
       'non-Bouss steric sea level tendency from sigma tendency', 'm/s', &
       missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_sigma > 0) compute_watermass_diag=.true.

  id_eta_tend_sigma_glob= -1          
  id_eta_tend_sigma_glob= register_diag_field ('ocean_model', 'eta_tend_sigma_glob',&
       Time%model_time,                                                             &
       'global mean non-bouss steric sea level tendency from sigma tendency',       &
       'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_sigma_glob > 0) compute_watermass_diag=.true.



  if(compute_watermass_diag) then 
    write(stdoutunit,'(/a/)') &
    '==>Note: running ocean_sigma_transport_mod w/ compute_watermass_diag=.true. to compute some watermass diagnostics.'  
  endif 


end subroutine watermass_diag_init
! </SUBROUTINE> NAME="watermass_diag_init"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag">
!
! <DESCRIPTION>
! Diagnose effects from sigma transport on the watermass transformation.
! </DESCRIPTION>
!
subroutine watermass_diag(Time, Dens)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens

  integer :: i,j,k,tau
  real, dimension(isd:ied,jsd:jed) :: eta_tend

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_sigma_transport (watermass_diag): module needs initialization ')
  endif 

  if(.not. compute_watermass_diag) return 
 
  tau=Time%tau

  ! send diagnostics for update of neutral density from sigma transport 
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0
  wrk6(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk2(i,j,k) = wrk1(i,j,k)*(                                                            &
                Dens%drhodT(i,j,k)                                                                &
                *(tchg_diff(i,j,index_temp)+tchg_adv(i,j,index_temp)+tchg_smooth(i,j,index_temp)) &
                +Dens%drhodS(i,j,k)                                                               &
                *(tchg_diff(i,j,index_salt)+tchg_adv(i,j,index_salt)+tchg_smooth(i,j,index_salt)) &
                )
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk4(i,j,k) = wrk3(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk5(i,j,k) = wrk2(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
           wrk6(i,j,k) =-wrk2(i,j,k)/(epsln+Dens%rho(i,j,k,tau)**2)  ! for eta_tend 
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_sigma, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_sigma, wrk4(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_sigma, wrk5(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_sigma_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_sigma_on_nrho, wrk4)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_sigma_on_nrho, wrk5)

  if(id_eta_tend_sigma > 0 .or. id_eta_tend_sigma_glob > 0) then
      eta_tend(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               eta_tend(i,j) = eta_tend(i,j) + wrk6(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_eta_tend_sigma, eta_tend(:,:))
      call diagnose_sum(Time, Grd, Dom, id_eta_tend_sigma_glob, eta_tend, cellarea_r)
  endif


end subroutine watermass_diag
! </SUBROUTINE>  NAME="watermass_diag"


end module ocean_sigma_transport_mod

      module MOZ_HOOK_MOD

      use diag_manager_mod, only : register_diag_field, send_data
      use time_manager_mod, only : time_type
      use constants_mod,    only : PI


      implicit none

      private
      public  :: moz_hook_init, moz_hook

!     save

!     real :: csrf

!----------------------------------------------------------------------
!        Set global lightning NOx scaling factor
!----------------------------------------------------------------------
      real :: factor = 1.                  ! user-controlled scaling factor to achieve arbitrary NO prod.
      real :: vdist(16,3)                  ! vertical distribution of lightning
!     real, allocatable :: prod_no(:,:,:,:)
!     real, allocatable :: prod_no_col(:,:,:)
!     real, allocatable :: flash_freq(:,:,:)
      integer :: id_prod_no_col, id_flash_freq
      real :: lat25
      
character(len=128), parameter :: version     = '$Id: mo_hook.F90,v 19.0 2012/01/06 20:33:56 fms Exp $'
character(len=128), parameter :: tagname     = '$Name: tikal $'
logical                       :: module_is_initialized = .false.

      CONTAINS

      subroutine moz_hook_init( lght_no_prd_factor, Time, axes, verbose )
!----------------------------------------------------------------------
!       ... Initialize the chemistry "hook" routine
!----------------------------------------------------------------------

      implicit none

!----------------------------------------------------------------------
!        ... Dummy args
!----------------------------------------------------------------------
      type(time_type), intent(in) :: Time
      integer,         intent(in) :: axes(4)
      real,            intent(in) :: lght_no_prd_factor        ! lightning no production factor
      integer,         intent(in) :: verbose

!----------------------------------------------------------------------
!        ... local variables
!----------------------------------------------------------------------

      if (module_is_initialized) return

      factor = lght_no_prd_factor
      if (verbose >= 2) then
         write(*,*) 'MOZ_HOOK_INIT: Lightning NO production scaling factor = ',factor
      end if

!     csrf = twopi*rearth*rearth/REAL(plong)    ! rearth in m
      lat25 = 25. * PI/180.

!----------------------------------------------------------------------
!       ... vdist(kk,itype) = % of lightning NOx between (kk-1) and (kk)
!           km for profile itype
!----------------------------------------------------------------------
      vdist(:,1) = (/ 20.1, 2.3, 0.8, 1.5, 3.4, 5.3, 3.6, 3.8, &       ! midlat cont
                       5.4, 6.6, 8.3, 9.6,12.8,10.0, 6.2, 0.3 /)
      vdist(:,2) = (/  5.8, 2.9, 2.6, 2.4, 2.2, 2.1, 2.3, 6.1, &       ! trop marine
                      16.5,14.1,13.7,12.8,12.5, 2.8, 0.9, 0.3 /)
      vdist(:,3) = (/  8.2, 1.9, 2.1, 1.6, 1.1, 1.6, 3.0, 5.8, &       ! trop cont
                       7.6, 9.6,10.5,12.3,11.8,12.5, 8.1, 2.3 /)
      id_prod_no_col = register_diag_field('tracers','prod_no_col',axes(1:2),Time, &
                                           'prod_no_col','TgN/y')
      id_flash_freq  = register_diag_field('tracers','flash_freq',axes(1:2),Time, &
                                           'flash_freq','/s')
      module_is_initialized = .true.
      
      end subroutine MOZ_HOOK_INIT


      subroutine moz_hook( cldtop, cldbot, oro, zm, zint, t, &
                           prod_no, area, lat, &
                           Time,is,js )
!----------------------------------------------------------------------
!        ... General purpose chemistry "hook" routine.
!           Update deposition velocity and sulfur input fields,
!           and calculate lightning NOx source & Rn emissions.
!----------------------------------------------------------------------


      implicit none

!----------------------------------------------------------------------
!        ... Dummy args
!----------------------------------------------------------------------
!     integer, intent(in) :: ncdate                  ! date of current step (yyyymmdd)
!     integer, intent(in) :: ncsec                   ! seconds of current step
!     integer, intent(in) :: plonl
!     integer, intent(in) :: platl
!     integer, intent(in) :: pplon
!     real, intent(in) :: caldayh                    ! day of year at midpoint
!     real, intent(in) :: caldayf                    ! day of year at endpoint
      integer, intent(in) :: cldtop(:,:)             ! cloud top level index
      integer, intent(in) :: cldbot(:,:)             ! cloud bottom level index
      real, intent(in) :: oro(:,:)                   ! orography "flag"
      real, intent(in) :: zm(:,:,:)                  ! geopot height above surface at midpoints (m)
      real, intent(in) :: zint(:,:,:)                ! geopot height above surface at interfaces (m)
      real, intent(in) :: t(:,:,:)                   ! temperature
      
      real, intent(out) :: prod_no(:,:,:)            ! production of nox (molec cm^-3 s^-1)
      real, intent(in)  :: area(:,:)                 ! area (m^2)
      real, intent(in) :: lat(:,:)                   ! latitude
      type(time_type), intent(in) :: Time            ! time
      integer, intent(in) :: is, js                  ! lon,lat indices

!----------------------------------------------------------------------
!        ... Local variables
!----------------------------------------------------------------------
      integer, parameter :: land = 1, ocean = 0
      real, parameter    :: dayspy = 365.
      real, parameter    :: secpyr = dayspy * 8.64e4

      integer :: i, j, &
                 cldtind, &         ! level index for cloud top
                 cldbind            ! level index for cloud base > 273K
      integer :: k, kk, zlow_ind, zhigh_ind, itype
!     real    :: glob_flashfreq, &  ! global flash frequency [s-1]
!                glob_noprod        ! global rate of NO production [as TgN/yr]
      real    :: frac_sum
      real       :: zlow, zhigh, zlow_scal, zhigh_scal, fraction
      real, dimension( size(prod_no,1),size(prod_no,2) ) :: &
                 dchgzone, &        ! depth of discharge zone [km]
                 cldhgt, &          ! cloud top height [km]
                 cgic, &            ! Cloud-Ground/Intracloud discharge ratio
                 flash_energy, &    ! Energy of flashes per second
                 glob_prod_no_col   ! Global NO production rate for diagnostics
      real :: prod_no_col(size(prod_no,1),size(prod_no,2))
      real :: flash_freq(size(prod_no,1),size(prod_no,2))  
      logical :: used
      integer :: platl, plonl, plev
!----------------------------------------------------------------------
!         ... Parameters to determine CG/IC ratio [Price and Rind, 1993]
!----------------------------------------------------------------------
      real, parameter  :: ca = .021, cb = -.648, cc = 7.49, cd = -36.54, ce = 64.09


      plonl = size(prod_no,1)
      platl = size(prod_no,2)
      plev  = size(prod_no,3)

!----------------------------------------------------------------------
!        Lightning NO production : Initialize ...
!----------------------------------------------------------------------
      flash_freq(:,:) = 0.
      cldhgt(:,:)     = 0.
      dchgzone(:,:)   = 0.
      cgic(:,:)       = 0.
      flash_energy(:,:) = 0.
      prod_no(:,:,:)    = 0.
      prod_no_col(:,:)  = 0.
      glob_prod_no_col(:,:) = 0.

!----------------------------------------------------------------------
!        Check whether tropchem is active
!----------------------------------------------------------------------
      if (.not. module_is_initialized) return

!--------------------------------------------------------------------------------
!        ... Estimate flash frequency and resulting NO emissions
!           [Price, Penner, Prather, 1997 (JGR)]
!    Lightning only occurs in convective clouds with a discharge zone, i.e.
!    an altitude range where liquid water, ice crystals, and graupel coexist.
!    We test this by examining the temperature at the cloud base.
!    It is assumed that only one thunderstorm occurs per grid box, and its
!    flash frequency is determined by the maximum cloud top height (not the
!    depth of the discharge zone). This is somewhat speculative but yields
!    reasonable results.
!
!       The CG/IC ratio is determined by an empirical formula from Price and
!    Rind [1993]. The average energy of a CG flash is estimated as 6.7e9 J,
!    and the average energy of a IC flash is assumed to be 1/10 of that value.
!       The NO production rate is assumed proportional to the discharge energy
!    with 1e17 N atoms per J. The total number of N atoms is then distributed
!    over the complete column of grid boxes.
!--------------------------------------------------------------------------------
!      do ip = 1,pplon
         do j = 1,platl
            do i = 1,plonl
!--------------------------------------------------------------------------------
!         ... Find cloud top and bottom level above 273K
!--------------------------------------------------------------------------------
               cldtind =  cldtop(i,j) 
               cldbind =  cldbot(i,j) 
               do
                  if( cldbind <= cldtind ) then
                    exit
                  else if ( t(i,j,cldbind) < 273. ) then
                    exit
                  end if
                  cldbind = cldbind - 1
               end do
               if( cldtind < plev .and. cldtind > 0 .and. cldtind < cldbind ) then
!--------------------------------------------------------------------------------
!       ... Compute cloud top height and depth of charging zone
!--------------------------------------------------------------------------------
                  cldhgt(i,j) = 1.e-3*MAX( 0.,zint(i,j,cldtind) )
                  dchgzone(i,j) = cldhgt(i,j)-1.e-3*zm(i,j,cldbind)
!--------------------------------------------------------------------------------
!       ... Compute flash frequency for given cloud top height
!           (flashes storm^-1 min^-1)
!--------------------------------------------------------------------------------
                  if( NINT( oro(i,j) ) == land ) then
                     flash_freq(i,j) = 3.44e-5 * cldhgt(i,j)**4.9 
                  else
                     flash_freq(i,j) = 6.40e-4 * cldhgt(i,j)**1.7
                  end if
!--------------------------------------------------------------------------------
!       ... Compute CG/IC ratio
!           cgic = proportion of CG flashes (=PG from PPP paper)
!--------------------------------------------------------------------------------
                  cgic(i,j) = 1./((((ca*dchgzone(i,j) + cb)*dchgzone(i,j) + cc) &
                                      *dchgzone(i,j) + cd)*dchgzone(i,j) + ce)
                  if( dchgzone(i,j) < 5.5 ) then
                     cgic(i,j) = 0.
                  end if
                  if( dchgzone(i,j) > 14. ) then
                     cgic(i,j) = .02
                  end if
!--------------------------------------------------------------------------------
!       ... Compute flash energy (CG*6.7e9 + IC*6.7e8)
!           and convert to total energy per second
!--------------------------------------------------------------------------------
                  flash_energy(i,j) = cgic(i,j)*6.7e9 + (1. - cgic(i,j))*6.7e8
                  flash_energy(i,j) = flash_energy(i,j)*flash_freq(i,j)/60.

!--------------------------------------------------------------------------------
!         ... Compute number of N atoms produced per second
!           and convert to N atoms per second per cm2 and apply fudge factor
!--------------------------------------------------------------------------------
               prod_no_col(i,j) = 1.e17*flash_energy(i,j) &
                                        / (1.e4*area(i,j)) * factor
!--------------------------------------------------------------------------------
!         ... Compute global NO production rate in TgN/yr:
!           TgN per second: * 14.00674 * 1.65979e-24 * 1.e-12
!             NB: 1.65979e-24 = 1/AVO
!           TgN per year: * secpyr
!--------------------------------------------------------------------------------
               glob_prod_no_col(i,j) = 1.e17*flash_energy(i,j) &
                                        * 14.00674 * 1.65979e-24 * 1.e-12 * secpyr * factor
               end if
            end do
         end do
         if(id_prod_no_col >0) &
            used=send_data(id_prod_no_col,glob_prod_no_col,Time,is_in=is,js_in=js)
         if(id_flash_freq >0) &
            used=send_data(id_flash_freq,flash_freq/60.,Time,is_in=is,js_in=js)
!      end do

!--------------------------------------------------------------------------------
!         ... Accumulate global total, convert to flashes per second
!--------------------------------------------------------------------------------
!     glob_flashfreq = SUM( flash_freq(:,:) )/60.

!--------------------------------------------------------------------------------
!         ... Accumulate global NO production rate
!--------------------------------------------------------------------------------
!     glob_noprod = SUM( glob_prod_no_col(:,:) )
      
!--------------------------------------------------------------------------------
!        ... Gather,scatter global sum
!--------------------------------------------------------------------------------
!#ifdef USE_MPI
!      call MPI_ALLREDUCE( glob_flashfreq, wrk, 1, MPI_DOUBLE_PRECISION, MPI_SUM, mpi_comm_comp, istat )
!      if( istat /= MPI_SUCCESS ) then
!         write(*,*) 'MOZ_HOOK: MPI_ALLREDUCE for flashfreq failed; error = ',istat
!         call ENDRUN
!      end if
!      glob_flashfreq = wrk
!      call MPI_ALLREDUCE( glob_noprod, wrk, 1, MPI_DOUBLE_PRECISION, MPI_SUM, mpi_comm_comp, istat )
!      if( istat /= MPI_SUCCESS ) then
!         write(*,*) 'MOZ_HOOK: MPI_ALLREDUCE for noprod failed; error = ',istat
!         call ENDRUN
!      end if
!      glob_noprod = wrk
!#endif

!      if( masternode ) then
!         write(*,*) ' '
!         write(*,'('' Global flash freq (/s), lightning NOx (TgN/y) = '',2f10.4)') &
!                      glob_flashfreq, glob_noprod
!      end if

!      if( glob_noprod > 0. ) then
!--------------------------------------------------------------------------------
!        ... distribute production up to cloud top [Pickering et al., 1998 (JGR)]
!--------------------------------------------------------------------------------
        ! do ip = 1,pplon
            do j = 1,platl
               do i = 1,plonl
                  cldtind =  cldtop(i,j) 
                   if( prod_no_col(i,j) > 0. ) then
                     if( cldhgt(i,j) > 0. ) then
                        if(  ABS(lat(i,j)) > lat25 ) then
                           itype = 1                              ! midlatitude continental
                        else if ( NINT( oro(i,j) ) == land ) then
                           itype = 3                              ! tropical continental
                        else
                           itype = 2                              ! topical marine
                        end if
                        frac_sum = 0.
                        
                        do k = cldtind,plev
                           zlow       = zint(i,j,k+1) * 1.e-3   ! lower interface height (km)
                           zlow_scal  = zlow * 16./cldhgt(i,j)  ! scale to 16 km convection height
                           zlow_ind   = MAX( 1,INT(zlow_scal)+1 )  ! lowest vdist index to include in layer
                           zhigh      = zint(i,j,k) * 1.e-3     ! upper interface height (km)
                           zhigh_scal = zhigh * 16./cldhgt(i,j) ! height (km) scaled to 16km convection height
                           zhigh_ind  = MAX( 1,MIN( 16,INT(zhigh_scal)+1 ) )  ! highest vdist index to include in layer
                           do kk = zlow_ind,zhigh_ind
                              fraction = MIN( zhigh_scal,REAL(kk) ) &         ! fraction of vdist in this model layer
                                         - MAX( zlow_scal,REAL(kk-1) )
                              fraction = MAX( 0., MIN( 1.,fraction ) )
                              frac_sum = frac_sum + fraction*vdist(kk,itype)
                              prod_no(i,j,k) = prod_no(i,j,k) &         ! sum the fraction of column NOx in layer k
                                             + fraction*vdist(kk,itype)*.01
                           end do
                           prod_no(i,j,k) = prod_no_col(i,j) * prod_no(i,j,k) & ! multiply fraction by column amount
                                               / (1.e5*(zhigh - zlow))                   ! and convert to atom N cm^-3 s^-1
                        end do
                     end if
                  end if
               end do
            end do
       !  end do
      !end if

!--------------------------------------------------------------------------------
!       ... Output lightning no production to history file
!--------------------------------------------------------------------------------
!     do file = 1,match_file_cnt
!        do ip = 1,pplon
!           do j = 1,platl
!              call outfld( 'LNO_PROD', glob_prod_no_col(:,j,ip), plonl, ip, j, file )
!              call outfld( 'FLASHFRQ', flash_freq(:,j,ip), plonl, ip, j, file )
!              call outfld( 'CLDHGT', cldhgt(:,j,ip), plonl, ip, j, file )
!              call outfld( 'DCHGZONE', dchgzone(:,j,ip), plonl, ip, j, file )
!              call outfld( 'CGIC', cgic(:,j,ip), plonl, ip, j, file )
!           end do
!        end do
!     end do

      end subroutine MOZ_HOOK

      end module MOZ_HOOK_MOD

                 module cloudrad_package_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  ds
! </REVIEWER>
! <OVERVIEW>
!  Module that supplies cloud radiative properties
! </OVERVIEW>
! <DESCRIPTION>
! </DESCRIPTION>

! shared modules:

use mpp_mod,                  only: input_nml_file
use fms_mod,                  only: fms_init, open_namelist_file, &
                                    write_version_number, mpp_pe, &
                                    mpp_root_pe, stdlog, file_exist,  &
                                    check_nml_error, error_mesg,   &
                                    FATAL, close_file
use time_manager_mod,         only: time_type, time_manager_init

! shared radiation package modules:

use rad_utilities_mod,        only: rad_utilities_init, Lw_control, &
                                    Sw_control, cldrad_properties_type,&
                                    cld_specification_type, &
                                    microrad_properties_type, &
                                    microphysics_type, astronomy_type, &
                                    atmos_input_type, Cldrad_control
use esfsw_parameters_mod,     only: esfsw_parameters_init, Solar_spect

! radiation package modules:

use cloudrad_diagnostics_mod, only: cloudrad_diagnostics_init, &
                                    cloudrad_netcdf, &
                                    cloudrad_diagnostics_end
use bulkphys_rad_mod,         only: bulkphys_rad_init, &
                                    bulkphys_rad_end, &
                                    bulkphys_lw_driver, &
                                    bulkphys_sw_driver
use microphys_rad_mod,        only: lwemiss_calc, comb_cldprops_calc, &
                                    microphys_rad_init, &
                                    microphys_rad_end, &
                                    microphys_lw_driver, &
                                    microphys_sw_driver

!--------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!    cloudrad_package_mod computes cloud radiative properties consistent
!    with the activated radiation package options and returns them to
!    radiation_driver_mod.
!--------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module --------------------------

character(len=128)  :: version =  '$Id: cloudrad_package.F90,v 20.0 2013/12/13 23:19:07 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!---------------------------------------------------------------------
!-------  interfaces --------

public          &
         cloudrad_package_init, cloud_radiative_properties, &
         cldrad_props_dealloc, cloudrad_package_end


private          &
!  called from cloud_radiative_properties:
         initialize_cldrad_props, combine_cloud_properties,  &
         cloudrad_package_dealloc

!---------------------------------------------------------------------
!-------- namelist  ---------

character(len=16)  :: microphys_form =  '     ' ! level of microphysics
                                                ! being used; either
                                                ! 'none', 'prescribed',
                                                ! or 'predicted'
real               :: min_cld_drop_rad = 4.2    ! smallest allowable 
                                                ! cloud drop radius 
                                                ! (microns) allowed in
                                                ! slingo scheme
real               :: max_cld_drop_rad = 16.6   ! largest allowable 
                                                ! cloud drop radius 
                                                ! (microns) allowed in
                                                ! slingo scheme
real               :: min_cld_ice_size = 18.6   ! smallest allowable 
                                                ! cloud ice size    
                                                ! (microns) allowed in
                                                ! fu-liou scheme
real               :: max_cld_ice_size = 130.2  ! largest allowable 
                                                ! cloud ice size    
                                                ! (microns) allowed in
                                                ! fu-liou scheme

namelist /cloudrad_package_nml /     &
                               min_cld_drop_rad, max_cld_drop_rad, &
                               min_cld_ice_size, max_cld_ice_size, &
                               microphys_form

!----------------------------------------------------------------------
!----  public data -------


!----------------------------------------------------------------------
!----  private data -------

logical      :: module_is_initialized = .false.  ! module initialized?



!----------------------------------------------------------------------
!----------------------------------------------------------------------



                          contains 



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!#####################################################################
! <SUBROUTINE NAME="cloudrad_package_init">
!  <OVERVIEW>
!   Contructor of cloudrad_package module
!  </OVERVIEW>
!  <DESCRIPTION>
!   Contructor of cloudrad_package module
!  </DESCRIPTION>
!  <TEMPLATE>
!   call cloudrad_package_init ( pref, lonb, latb, axes, Time)
!  </TEMPLATE>
!  <IN NAME="pref" TYPE="real">
!   reference pressure levels
!  </IN>
!  <IN NAME="lonb" TYPE="real">
!   the longitude array of the model grid box corners
!  </IN>
!  <IN NAME="latb" TYPE="real">
!   the latitude array of the model grid box corners
!  </IN>
!  <IN NAME="axes" TYPE="real">
!   diagnostic variable axes for netcdf files
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!   current time [ time_type(days, seconds) ]
!  </IN>
! </SUBROUTINE>
!
subroutine cloudrad_package_init (pref, lonb, latb, axes, Time, &
                                  donner_meso_is_largescale)

!---------------------------------------------------------------------
!    cloudrad_package_init is the constructor for cloudrad_package_mod.
!----------------------------------------------------------------------

real,    dimension(:,:), intent(in)    ::   pref
real,    dimension(:,:), intent(in)    ::   lonb, latb
integer, dimension(4),   intent(in)    ::   axes
type(time_type),         intent(in)    ::   Time
logical,                 intent(in)    ::   donner_meso_is_largescale

!---------------------------------------------------------------------
!   intent(in) variables:
!
!       pref      array containing two reference pressure profiles 
!                 for use in defining transmission functions [ Pa ]
!       lonb      2d array of model longitudes on cell corners[ radians ]
!       latb      2d array of model latitudes at cell corners [radians]
!       axes      diagnostic variable axes
!       Time      current time [time_type(days, seconds)]
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      integer         :: unit, io, ierr, logunit

!---------------------------------------------------------------------
!   local variables:
!
!      unit     io unit for reading nml file 
!      io       error status returned from io operation  
!      ierr     error code
!
!--------------------------------------------------------------------

!-------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return

!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call time_manager_init
      call rad_utilities_init

!---------------------------------------------------------------------
!    read namelist.
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=cloudrad_package_nml, iostat=io)
      ierr = check_nml_error(io,"cloudrad_package_nml")
#else
!---------------------------------------------------------------------
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ()
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=cloudrad_package_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'cloudrad_package_nml')
        enddo
10      call close_file (unit)
      endif
#endif

!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() )    &
                       write (logunit, nml=cloudrad_package_nml)
 
!-------------------------------------------------------------------
!    verify that Lw_control%do_lwcldemiss has been defined.
!-------------------------------------------------------------------
      if (Lw_control%do_lwcldemiss_iz) then
      else
        call error_mesg ('cloudrad_package_mod', &
         'Lw_control%do_lwcldemiss has not yet been defined', FATAL)
      endif

!-------------------------------------------------------------------
!    verify that Sw_control%do_esfsw has been defined.
!-------------------------------------------------------------------
      if (Sw_control%do_esfsw_iz) then
      else
        call error_mesg ('cloudrad_package_mod', &
         'Sw_control%do_esfsw has not yet been defined', FATAL)
      endif
!-------------------------------------------------------------------
!    verify that the component cloud scheme elements of Cldrad_control 
!    have been defined.
!-------------------------------------------------------------------
      if (Cldrad_control%do_rh_clouds_iz .and.  &
          Cldrad_control%do_strat_clouds_iz .and.  &
          Cldrad_control%do_zonal_clouds_iz .and.  &
          Cldrad_control%do_mgroup_prescribed_iz .and.  &
          Cldrad_control%do_obs_clouds_iz .and.  &
          Cldrad_control%do_no_clouds_iz .and.  &
          Cldrad_control%do_diag_clouds_iz .and.  &
          Cldrad_control%do_specified_clouds_iz .and.  &
          Cldrad_control%do_uw_clouds_iz .and.  &
          Cldrad_control%do_donner_deep_clouds_iz ) then  
      else
        call error_mesg ('cloudrad_package_mod', &
         'Cldrad_control%do_{some cloud type} not yet been defined', &
                                                                 FATAL)
      endif


!-------------------------------------------------------------------
!    define variables which denote whether microphysically-based cloud
!    radiative properties will be defined for the longwave and shortwave
!    radiation calculations. if esf sw is being used, then do_sw_micro
!    will be .true.; if do_lwcldemiss is .true. or if esf sw is being 
!    used along with strat clouds or diag clouds or specified clouds, 
!    then do_lw_micro will be .true..
!----------------------------------------------------------------------
      if (Lw_control%do_lwcldemiss) then
        Cldrad_control%do_lw_micro = .true.
      endif
      if (Sw_control%do_esfsw) then
        call esfsw_parameters_init
        Cldrad_control%do_sw_micro = .true.
        if (Cldrad_control%do_strat_clouds .or. &
            Cldrad_control%do_specified_clouds .or. &
            Cldrad_control%do_diag_clouds) then
          Cldrad_control%do_lw_micro = .true.
        endif
      endif

!--------------------------------------------------------------------
!    mark the logical controls as initialized.
!--------------------------------------------------------------------
      Cldrad_control%do_lw_micro_iz = .true.
      Cldrad_control%do_sw_micro_iz = .true.

!----------------------------------------------------------------------
!    define the microphysical use desired for this experiment. different
!    levels may be used for the lw and sw parameterizations. 
!----------------------------------------------------------------------
      if (trim(microphys_form) == 'predicted') then 

!---------------------------------------------------------------------
!    if microphys_form asks for predicted microphysics, then either
!    strat or donner deep clouds must be activated, and either one or 
!    both of do_lw_micro and do_sw_micro must be .true..  if these
!    conditions are met, set do_pred_cld_microphys to .true.. if only
!    one of do_sw_micro and do_lw_micro are true, then also set 
!    do_bulk_microphys to .true. so that the bulk scheme initialization
!    may be completed. if  neither do_lw_micro or do_sw_micro are .true.
!    or if a different cloud scheme has been activated, stop execution 
!    with an error message.
!---------------------------------------------------------------------
        if (Cldrad_control%do_strat_clouds .or. &
            Cldrad_control%do_donner_deep_clouds .or. &
            Cldrad_control%do_uw_clouds .or. &
            Cldrad_control%do_zetac_clouds) then
          if (Cldrad_control%do_sw_micro .and.   &
              Cldrad_control%do_lw_micro) then
            Cldrad_control%do_pred_cld_microphys = .true.
          else if (Cldrad_control%do_sw_micro .or.    &
                   Cldrad_control%do_lw_micro) then
            Cldrad_control%do_pred_cld_microphys = .true.
            Cldrad_control%do_bulk_microphys = .true.
          else
            call error_mesg( 'cloudrad_package_mod',  &
             ' not using microphysics -- set microphys_form '//&
                                                    'to none.', FATAL)
          endif
        else
          call error_mesg( 'cloudrad_package_mod',  &
                    ' predicted microphys not available with this '//&
                                                 'cloud scheme.', FATAL)
        endif

!---------------------------------------------------------------------
!    if prescribed microphysics are requested, make sure the cloud 
!    scheme requested has the capability of using the microphysical
!    properties, and that either the sw or lw scheme requested is 
!    microphysically based. if only one of do_sw_micro and do_lw_micro
!    is .true., then set do_bulk_microphys to .true., so that the bulk
!    scheme may be initialized. if neither is .true. or if a cloud
!    scheme has been requested that cannot use prescribed microphysics,
!    stop execution with an error message.
!---------------------------------------------------------------------
      else if (trim(microphys_form) == 'prescribed') then
        if (Cldrad_control%do_rh_clouds .or.  &
            Cldrad_control%do_mgroup_prescribed .or.  &
            Cldrad_control%do_specified_clouds  .or.  &
            Cldrad_control%do_diag_clouds       .or.  &
            Cldrad_control%do_no_clouds)    then
          if (Cldrad_control%do_sw_micro .and.    &
              Cldrad_control%do_lw_micro) then
            Cldrad_control%do_presc_cld_microphys = .true.
          else if (Cldrad_control%do_sw_micro .or.     &
                   Cldrad_control%do_lw_micro) then
            Cldrad_control%do_presc_cld_microphys = .true.
            Cldrad_control%do_bulk_microphys = .true.
          else
            call error_mesg( 'cloudrad_package_mod',  &
                ' not using microphysics -- set microphys_form '//&
                  'to none.', FATAL)
          endif
        else
          call error_mesg( 'cloudrad_package_mod',  &
             ' prescribed microphys not allowed with this cloud '//&
                                     'scheme.',  FATAL) 
        endif

!---------------------------------------------------------------------
!    if no microphysics is requested, make sure that donner_deep clouds
!    has not been requested (must use predicted cloud microphysics
!    for that scheme -- all others can be run without microphysics).  
!    also verify that the lw and sw schemes requested are not micro-
!    physically_based. if all is ok, set do_bulk_microphys to .true.; 
!    if not ok, write an error message and stop.
!---------------------------------------------------------------------
      else if (trim(microphys_form) == 'none') then
        if (Cldrad_control%do_donner_deep_clouds .or.  &
            Cldrad_control%do_uw_clouds) then        
          call error_mesg( 'cloudrad_package_mod',  &
            ' use predicted microphys with donner or uw clouds.', FATAL)
        else     
          if (Cldrad_control%do_sw_micro .or.    &
              Cldrad_control%do_lw_micro) then
            call error_mesg ('cloudrad_package_mod', &
               'must specify microphys_form when using microphysica'//&
                'lly-based cld rad scheme', FATAL)
          else
              Cldrad_control%do_bulk_microphys = .true.
          endif
        endif

!----------------------------------------------------------------------
!    error condition.
!----------------------------------------------------------------------
      else
        call error_mesg( 'cloudrad_package_mod',  &
           ' microphys_form is not an acceptable value.', FATAL)
      endif

!---------------------------------------------------------------------
!    define variables indicating that the desired cloud microphysics
!    type control variables have been defined.
!---------------------------------------------------------------------
      Cldrad_control%do_bulk_microphys_iz = .true.
      Cldrad_control%do_pred_cld_microphys_iz = .true.
      Cldrad_control%do_presc_cld_microphys_iz = .true.

!---------------------------------------------------------------------
!    if a microphysically-based scheme is being used, initialize the 
!    microphys_rad module.
!---------------------------------------------------------------------
      if (Cldrad_control%do_presc_cld_microphys  .or.  &
          Cldrad_control%do_pred_cld_microphys) then
        call microphys_rad_init ( min_cld_drop_rad, max_cld_drop_rad, &
                                  min_cld_ice_size, max_cld_ice_size, &
                                  axes, Time, lonb, latb)
      endif

!---------------------------------------------------------------------
!    if a bulk physics scheme is to be used, call bulkphys_rad_init. 
!---------------------------------------------------------------------
      if (Cldrad_control%do_bulk_microphys) then
        call bulkphys_rad_init (min_cld_drop_rad, max_cld_drop_rad, &
                                min_cld_ice_size, max_cld_ice_size, &
                                pref, lonb, latb)
      endif

!-------------------------------------------------------------------
!    when running the gcm or the standalone model with a cloud scheme,
!    call cloudrad_diagnostics_init to initialize the netcdf diagnostics
!    associated with the cloudrad package.
!-------------------------------------------------------------------
      if (.not. Cldrad_control%do_no_clouds) then
        call cloudrad_diagnostics_init (min_cld_drop_rad,   &
                                        max_cld_drop_rad, &
                                  min_cld_ice_size, max_cld_ice_size, &
                                        axes, Time,    &
                                                donner_meso_is_largescale)
      endif

!--------------------------------------------------------------------
!    mark the module initialized.
!--------------------------------------------------------------------
      module_is_initialized= .true.

!--------------------------------------------------------------------



end subroutine cloudrad_package_init



!####################################################################
! <SUBROUTINE NAME="cloud_radiative_properties">
!  <OVERVIEW>
!   Subroutine to calculate cloud radiative properties
!    appropriate for the radiation options that are active.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to calculate cloud radiative properties
!    appropriate for the radiation options that are active.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call cloud_radiative_properties (is, ie, js, je, Rad_time, Time, &
!                                       Time_next,  &
!                                       Astro, Atmos_input, Cld_spec,  &
!                                       Lsc_microphys, Meso_microphys, &
!                                       Cell_microphys, 
!                                     Shallow_microphys, Cldrad_props, &
!                                       kbot, mask)
!  </TEMPLATE>
!  <IN NAME="is,ie,js,je" TYPE="integer">
!   starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!    Time      The current time.  [time_type]
!  </IN>
!  <IN NAME="Time_next" TYPE="time_type">
!   time on next timestep, used as stamp for 
!                        diagnostic output [ time_type (days, seconds) ]
!  </IN>
!  <IN NAME="Astro" TYPE="astronomy_type">
!   astronomical properties needed by radiation
!                        package
!  </IN>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
!    atmospheric input fields on model grid,
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!   cloud specification properties on model grid,
!  </IN>
!  <IN NAME="Lsc_microphys" TYPE="microphysics_type">
!   microphysical specification for large-scale 
!                        clouds
!  </IN>
!  <IN NAME="Meso_microphys" TYPE="microphysics_type">
!   microphysical specification for meso-scale 
!                        clouds assciated with donner convection
!  </IN>
!  <IN NAME="Cell_microphys" TYPE="microphysics_type">
!   microphysical specification for convective cell
!                        clouds associated with donner convection
!  </IN>
!  <IN NAME="Shallow_microphys" TYPE="microphysics_type">
!   microphysical specification for 
!                        clouds associated with uw shallow convection
!  </IN>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!   cloud radiative properties on model grid
!  </INOUT>
!  <IN NAME="kbot" TYPE="integer">
!   OPTIONAL: present when running eta vertical coordinate,
!                        index of lowest model level above ground 
!  </IN>
!  <IN NAME="mask" TYPE="real">
!   OPTIONAL: present when running eta vertical coordinate,
!                        mask to remove points below ground
!  </IN>
! </SUBROUTINE>
!
subroutine cloud_radiative_properties (is, ie, js, je, Rad_time,   &
                                       Time, Time_next,  &
                                       Astro, Atmos_input, Cld_spec,  &
                                       Lsc_microphys, Meso_microphys, &
                                       Cell_microphys,   &
                                       Shallow_microphys,Cldrad_props, &
                                       Model_microphys, &
                                       kbot, mask)

!----------------------------------------------------------------------
!    cloud_radiative_properties defines the cloud radiative properties 
!    appropriate for the radiation options that are active.
!----------------------------------------------------------------------

!----------------------------------------------------------------------
integer,                      intent(in)             :: is, ie, js, je
type(time_type),              intent(in)             :: Rad_time, Time, &
                                                        Time_next
type(astronomy_type),         intent(in)             :: Astro
type(atmos_input_type),       intent(in)             :: Atmos_input
type(cld_specification_type), intent(inout)          :: Cld_spec    
type(microphysics_type),      intent(in)             :: Lsc_microphys, &
                                                        Meso_microphys,&
                                                        Cell_microphys,&
                                                     Shallow_microphys
type(cldrad_properties_type), intent(inout)          :: Cldrad_props
type(microphysics_type),      intent(inout)          :: Model_microphys
integer, dimension(:,:),      intent(in),   optional :: kbot
real, dimension(:,:,:),       intent(in),   optional :: mask
!-------------------------------------------------------------------
 
!---------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je       starting/ending subdomain i,j indices of data 
!                        in the physics_window being integrated
!      Time_next         time on next timestep, used as stamp for 
!                        diagnostic output [ time_type (days, seconds) ]
!      Time              The current time.  [time_type]
!      Astro             astronomical properties needed by radiation
!                        package
!                        [ astronomy_type ]
!      Atmos_input       atmospheric input fields on model grid,
!                        [ atmos_input_type ] 
!      Cld_spec          cloud specification properties on model grid,
!                        [ cld_specification_type ]
!      Lsc_microphys     microphysical specification for large-scale 
!                        clouds
!                        [ microphysics_type ]
!      Meso_microphys    microphysical specification for meso-scale 
!                        clouds assciated with donner convection
!                        [ microphysics_type ]
!      Cell_microphys    microphysical specification for convective cell
!                        clouds associated with donner convection
!                        [ microphysics_type ]
!      Shallow_microphys   
!                        microphysical specification for 
!                        clouds associated with uw shallow convection
!                        [ microphysics_type ]
!
!   intent(inout) variables:
!
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!   intent(in), optional variables:
!
!      kbot              present when running eta vertical coordinate,
!                        index of lowest model level above ground 
!      mask              present when running eta vertical coordinate,
!                        mask to remove points below ground
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      type(microrad_properties_type) :: Lscrad_props, Cellrad_props, &
                                        Mesorad_props, Shallowrad_props
      integer  ::   ix, jx, kx  
      logical  ::   donner_flag = .true.
      logical  ::   donner_flag_uw = .false.

!---------------------------------------------------------------------
!   local variables:
!
!       Lscrad_props   cloud radiative properties for the large-scale 
!                      clouds   
!                      [ microrad_properties_type ]
!       Mesorad_props  cloud radiative properties for meso-scale 
!                      clouds associated with donner convection   
!                      [ microrad_properties_type ]
!       Cellrad_props  cloud radiative properties for convective cell
!                      clouds associated with donner convection  
!                      [ microrad_properties_type ]
!       Shallowrad_props   
!                      cloud radiative properties for 
!                      clouds associated with uw shallow convection  
!                      [ microrad_properties_type ]
!       ix             x dimension of current physics window
!       jx             y dimension of current physics window
!       kx             z dimension of current physics window
!       donner_flag    optional argument to microphys_rad module
!                      indicating that the meso or cell cloud compon-
!                      ent is currently being processed. needed because
!                      a different fu ice parameterization is used in
!                      these cases than is used for large-scale clouds.
!
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!    define the dimensions of the current physics window.
!---------------------------------------------------------------------
      ix = size(Cld_spec%camtsw,1)
      jx = size(Cld_spec%camtsw,2)
      kx = size(Cld_spec%camtsw,3)

!--------------------------------------------------------------------
!    call initialize_cldrad_props to allocate and initialize the cloud 
!    radiative property arrays.
!---------------------------------------------------------------------
      call initialize_cldrad_props (ix, jx, kx, Lscrad_props,   &
                                    Mesorad_props, Cellrad_props, &
                                    Shallowrad_props, Cldrad_props)

!--------------------------------------------------------------------
!    if bulkphys_rad routines are needed, limit the condensate sizes
!    to that range acceptable for the radiative parameterizations.
!--------------------------------------------------------------------
      if (Cldrad_control%do_lw_micro .and. &
        Cldrad_control%do_sw_micro ) then 
      else
        Cld_spec%reff_liq_lim = MAX(MIN(Cld_spec%reff_liq,  &
                                  max_cld_drop_rad), min_cld_drop_rad)
        Cld_spec%reff_ice_lim = MAX(MIN(Cld_spec%reff_ice,  &
                                  max_cld_ice_size), min_cld_ice_size)
      endif

!----------------------------------------------------------------------
!    if a cloud scheme is activated (in contrast to running without any
!    clouds), call either the microphysically-based or bulkphysics-based
!    modules to define the cloud lw and sw radiative properties. if the
!    model is being run with do_no_clouds = .true., exit from this 
!    routine, leaving the cloud radiative property variables as they 
!    were initialized (to values compatible to the non-existence of 
!    cloudiness).
!---------------------------------------------------------------------
      if (.not. Cldrad_control%do_no_clouds) then
        if (Cldrad_control%do_lw_micro) then
          if (Cldrad_control%do_ica_calcs) then
            call microphys_lw_driver (is, ie, js, je, Lsc_microphys,  &
                                      Cloud_rad_props=Cldrad_props)
          else
            call microphys_lw_driver (is, ie, js, je, Lsc_microphys,  &
                                      Micro_rad_props=Lscrad_props)
          endif
        else
          call bulkphys_lw_driver (is, ie, js, je, Cld_spec,    &
                                   Cldrad_props)
        endif
        if (Cldrad_control%do_sw_micro) then
          if (Cldrad_control%do_ica_calcs) then
            call microphys_sw_driver (is, ie, js, je, Lsc_microphys,  &
                                      Cloud_rad_props=Cldrad_props)
          else
            call microphys_sw_driver (is, ie, js, je, Lsc_microphys,  &
                                      Micro_rad_props=Lscrad_props)
          endif
        else
          call bulkphys_sw_driver (is, ie, js, je, Astro%cosz,   &
                                   Cld_spec, Cldrad_props)
        endif

!--------------------------------------------------------------------
!    if donner_deep_clouds is active, obtain the cloud radiative prop-
!    erties associated with the mesoscale and cell-scale convective
!    components. only microphysically-based properties are available.
!    the optional argument  donner_flag is used to indicate that prop-
!    erties associated with the clouds produced by the donner_deep_mod 
!    are being processed, since a different ice parameterization is
!    used for donner_deep relative to large-scale clouds.
!----------------------------------------------------------------------
        if (Cldrad_control%do_donner_deep_clouds) then
          donner_flag = .true.
          call microphys_lw_driver (is, ie, js, je, Meso_microphys,  &
                                    Micro_rad_props=Mesorad_props,   &
                                    donner_flag=donner_flag)
          call microphys_lw_driver (is, ie, js, je, Cell_microphys,  &
                                    Micro_rad_props=Cellrad_props, &
                                    donner_flag=donner_flag)
          call microphys_sw_driver (is, ie, js, je, Meso_microphys,  &
                                    Micro_rad_props=Mesorad_props, &
                                    donner_flag=donner_flag)
          call microphys_sw_driver (is, ie, js, je, Cell_microphys,  &
                                    Micro_rad_props=Cellrad_props, &
                                    donner_flag=donner_flag)
        endif

!--------------------------------------------------------------------
!    if the uw shallow convection scheme is active, obtain the cloud 
!    radiative properties associated with its clouds. only micro-
!    physically-based properties are available.
!    NOTE FOR NOW:
!   the optional argument  donner_flag is set to .false. when processing
!   shallow clouds. the ice cloud radiative properties are obtained from
!    the parameterization used by strat_cloud (effective size), rather 
!    than that used by donner_deep (generalized effective size).
!----------------------------------------------------------------------
       if (Cldrad_control%do_uw_clouds) then
         donner_flag_uw = .false.
         call microphys_lw_driver (is, ie, js, je, Shallow_microphys, &
                                   Micro_rad_props=Shallowrad_props, &
                                   donner_flag=donner_flag_uw)
         call microphys_sw_driver (is, ie, js, je, Shallow_microphys, &
                                   Micro_rad_props=Shallowrad_props,&
                                   donner_flag=donner_flag_uw)
        endif
      endif ! ( .not. do_no_clouds)

!---------------------------------------------------------------------
!    call combine_cloud_properties to define a set of total-cloud cloud
!    radiative properties. if donner deep and / or uw shallow clouds 
!    are active, this requires the combination of the cloud properties 
!    associated with the different types of cloud present (large-scale, 
!    donner meso and  cell, uw shallow). for other schemes the 
!    total-cloud values are simply the large-scale cloud values. 
!    this procedure is only needed when microphysically-based properties
!    are being used.
!---------------------------------------------------------------------
      if (.not. Cldrad_control%do_ica_calcs) then
        if (Cldrad_control%do_sw_micro  .or. &
            Cldrad_control%do_lw_micro) then  
          call combine_cloud_properties (is, js, Rad_time, Time_next, &
                                         Atmos_input%deltaz, &
                                         Cld_spec, &
                                         Lsc_microphys, Meso_microphys,&
                                         Cell_microphys,   &
                                         Shallow_microphys,  &
                                         Lscrad_props, &
                                         Mesorad_props, Cellrad_props, &
                                         Shallowrad_props, &
                                         Cldrad_props)
        endif  
      endif  

!----------------------------------------------------------------------
!    call lwemiss_calc to compute lw emissivity from the absorption 
!    coefficient when a microphysically-based lw emissivity scheme 
!    is being used.
!----------------------------------------------------------------------
      if (Cldrad_control%do_lw_micro) then
        call lwemiss_calc (Atmos_input%clouddeltaz,   &
                           Cldrad_props%abscoeff, Cldrad_props%cldemiss)
        Cldrad_props%emmxolw = Cldrad_props%cldemiss
        Cldrad_props%emrndlw = Cldrad_props%cldemiss
      endif

!-------------------------------------------------------------------
!    if running the gcm or feedback program with a cloud scheme active,
!    call cloudrad_netcdf to generate netcdf output fields.
!-------------------------------------------------------------------
      if (.not. Cldrad_control%do_no_clouds) then 
          call cloudrad_netcdf (is, js, Time, Time_next, Atmos_input,&
                                Astro%cosz, Lsc_microphys, &
                                Meso_microphys, Cell_microphys,   &
                                Shallow_microphys, &
                                Lscrad_props, Mesorad_props,    &
                                Cellrad_props, Shallowrad_props, &
                                Cldrad_props, Cld_spec, Model_microphys)
      endif   ! (do_no_clouds)

!--------------------------------------------------------------------
!    call cloudrad_package_dealloc to deallocate the local derived type
!    variable arrays.
!--------------------------------------------------------------------
      call cloudrad_package_dealloc (Lscrad_props, Mesorad_props,   &
                                     Cellrad_props, Shallowrad_props)

!---------------------------------------------------------------------


end subroutine cloud_radiative_properties     



!#####################################################################
! <SUBROUTINE NAME="cldrad_properties_dealloc">
!  <OVERVIEW>
!    Subroutine to deallocate the array elements of the
!    cldrad_properties_type variable that is input.
!  </OVERVIEW>
!  <DESCRIPTION>
!    Subroutine to deallocate the array elements of the
!    cldrad_properties_type variable that is input.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call cldrad_props_dealloc (Cldrad_props)
!  </TEMPLATE>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!   cldrad_properties_type variable containing cloud 
!   radiative properties
!  </INOUT>
! </SUBROUTINE>
!
subroutine cldrad_props_dealloc (Cldrad_props)

!------------------------------------------------------------------
!    cldrad_props_dealloc deallocates the array elements of the
!    cldrad_properties_type variable that is input.
!------------------------------------------------------------------

type(cldrad_properties_type), intent(inout) :: Cldrad_props

!-------------------------------------------------------------------
!  intent(inout) variables:
!
!    Cldrad_props    cldrad_properties_type variable containing
!                    cloud radiative properties
!
!--------------------------------------------------------------------

!------------------------------------------------------------------
!    deallocate the array elements of Cldrad_props. different variables
!    exist dependent on the sw parameterization being used.
!-------------------------------------------------------------------
      deallocate (Cldrad_props%emmxolw   )
      deallocate (Cldrad_props%emrndlw   )
      deallocate (Cldrad_props%abscoeff  )
      deallocate (Cldrad_props%cldemiss  )

      if ( Cldrad_control%do_sw_micro ) then
        deallocate (Cldrad_props%cldext    )
        deallocate (Cldrad_props%cldasymm  )
        deallocate (Cldrad_props%cldsct    )
      else
        deallocate (Cldrad_props%cvisrfsw  )
        deallocate (Cldrad_props%cirabsw   )
        deallocate (Cldrad_props%cirrfsw   )
      endif

!-------------------------------------------------------------------


end subroutine cldrad_props_dealloc




!####################################################################
! <SUBROUTINE NAME="cloudrad_package_end">
!  <OVERVIEW>
!   Destructor of the cloudrad_package module
!  </OVERVIEW>
!  <DESCRIPTION>
!   Destructor of the cloudrad_package module
!  </DESCRIPTION>
!  <TEMPLATE>
!   call cloudrad_package_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine cloudrad_package_end

!--------------------------------------------------------------------
!    cloudrad_package_end is the destructor for cloudrad_package_mod.
!--------------------------------------------------------------------

!-------------------------------------------------------------------
!    deactivate the modules which are component modules of
!    cloudrad_package_mod.
!-------------------------------------------------------------------
      if (.not. Cldrad_control%do_no_clouds) then
        call cloudrad_diagnostics_end
      endif
      if (Cldrad_control%do_presc_cld_microphys  .or.  &
          Cldrad_control%do_pred_cld_microphys) then
        call microphys_rad_end
      endif
      if (Cldrad_control%do_bulk_microphys) then
        call bulkphys_rad_end
      endif

!---------------------------------------------------------------------
!    mark the module as not initialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.

!---------------------------------------------------------------------



end subroutine cloudrad_package_end



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                    PRIVATE SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




!####################################################################
! <SUBROUTINE NAME="initialize_cldrad_props">
!  <OVERVIEW>
!   initialize_cldrad_props allocates and initializes those fields
!    which define the cloud radiative properties needed by the
!    radiation package.
!  </OVERVIEW>
!  <DESCRIPTION>
!   initialize_cldrad_props allocates and initializes those fields
!    which define the cloud radiative properties needed by the
!    radiation package.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call initialize_cldrad_props (ix, jx, kx, Lscrad_props,    &
!                                    Mesorad_props, Cellrad_props, &
!                                    Shallowrad_props, Cldrad_props )
!  </TEMPLATE>
!  <IN NAME="ix, jx, kx" TYPE="integer">
!       ix             size of i dimension of physics window
!       jx             size of j dimension of physics window
!       kx             size of k dimension of physics window
!  </IN>
!  <INOUT NAME="Lscrad_props" TYPE="microrad_properties_type">
!   cloud radiative properties for the large-scale 
!                      clouds   
!  </INOUT>
!  <INOUT NAME="Mesorad_props" TYPE="microrad_properties_type">
!   cloud radiative properties for the meso-scale
!                      clouds assciated with donner convection
!  </INOUT>
!  <INOUT NAME="Cellrad_props" TYPE="microrad_properties_type">
!   cloud radiative properties for the convective cell
!                      clouds associated with donner convection 
!  </INOUT>
!  <INOUT NAME="Shallowrad_props" TYPE="microrad_properties_type">
!   cloud radiative properties for the 
!                      clouds associated with uw shallow convection 
!  </INOUT>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!   cloud radiative properties on model grid
!  </INOUT>
! </SUBROUTINE>
!
subroutine initialize_cldrad_props (ix, jx, kx, Lscrad_props,    &
                                    Mesorad_props, Cellrad_props, &
                                    Shallowrad_props, Cldrad_props )

!--------------------------------------------------------------------
!    initialize_cldrad_props allocates and initializes those fields
!    which define the cloud radiative properties needed by the
!    radiation package.
!---------------------------------------------------------------------

integer,                        intent(in)    :: ix, jx, kx
type(microrad_properties_type), intent(inout) :: Lscrad_props, &
                                                 Mesorad_props, &
                                                 Cellrad_props, &
                                                 Shallowrad_props
type(cldrad_properties_type),   intent(inout) :: Cldrad_props

!----------------------------------------------------------------------
!    intent(in) variables:
! 
!       ix             size of i dimension of physics window
!       jx             size of j dimension of physics window
!       kx             size of k dimension of physics window
!
!   intent(inout) variables:
!
!       Lscrad_props   cloud radiative properties for the large-scale 
!                      clouds   
!                      [ microrad_properties_type ]
!       Mesorad_props  cloud radiative properties for meso-scale 
!                      clouds associated with donner convection   
!                      [ microrad_properties_type ]
!       Cellrad_props  cloud radiative properties for convective cell
!                      clouds associated with donner convection  
!                      [ microrad_properties_type ]
!       Shallowrad_props 
!                      cloud radiative properties for
!                      clouds associated with uw shallow convection  
!                      [ microrad_properties_type ]
!          the components of a microrad_structure are:
!            %cldext   parameterization band values of the cloud      
!                      extinction coefficient [ km**(-1) ]   
!            %cldsct   parameterization band values of the cloud      
!                      scattering coefficient [ km**(-1) ]
!            %cldasymm parameterization band values of the asymmetry  
!                      factor [ dimensionless ]
!            %abscoeff combined absorption coefficient for clouds in 
!                      each of the longwave frequency bands [ km**(-1) ]
!
!       Cldrad_props   cloud radiative properties on model grid,
!                      [ cldrad_properties_type ]
!          the components of a cldrad_properties_type strucure are:
!            %emmxolw  longwave cloud emissivity for maximally over-
!                      lapped clouds [ dimensionless ] 
!            %emrndlw  longwave cloud emissivity for randomly overlapped
!                      clouds  [ dimensionless ]
!            %cldext   parameterization band values of the cloud      
!                      extinction coefficient [ km**(-1) ]   
!            %cldsct   parameterization band values of the cloud      
!                      scattering coefficient [ km**(-1) ]
!            %cldasymm parameterization band values of the asymmetry  
!                      factor [ dimensionless ]
!            %abscoeff combined absorption coefficient for clouds in 
!                      each of the longwave frequency bands [ km**(-1) ]
!            %cldemiss longwave emissivity calculated using abscoeff
!                      [ dimensionless ]
!            %cirabsw  absorptivity of clouds in the infrared frequency 
!                      band. may be zenith angle dependent. 
!                      [ dimensionless ]
!            %cirrfsw  reflectivity of clouds in the infrared frequency
!                      band. may be zenith angle dependent.
!                      [ dimensionless ]
!            %cvisrfsw reflectivity of clouds in the visible frequency 
!                      band. may be zenith angle dependent.
!                      [ dimensionless ]
!
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!   local variable:

      integer :: n_esfsw_bands
      integer :: nlwcldb

!-------------------------------------------------------------------
!   local variable:
!
!          n_esfsw_bands   number of spectral bands resolved by the 
!                          sw radiation package; set to zero when
!                          bulk-based sw (lhsw) is active
!          nlwcldb         number of frequency bands for which longwave
!                          emissivities are defined
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!    allocate the arrays used to define the longwave cloud radiative
!    properties. initialize to appropriate non-cloudy values.
!--------------------------------------------------------------------
      nlwcldb = Cldrad_control%nlwcldb
      if (Cldrad_control%do_ica_calcs) then
        allocate (Cldrad_props%emmxolw  (ix, jx, kx, nlwcldb,nlwcldb) )
        allocate (Cldrad_props%emrndlw  (ix, jx, kx, nlwcldb,nlwcldb) )
        allocate (Cldrad_props%abscoeff (ix, jx, kx, nlwcldb,nlwcldb) )
        allocate (Cldrad_props%cldemiss (ix, jx, kx, nlwcldb,nlwcldb) )
      else
        allocate (Cldrad_props%emmxolw  (ix, jx, kx, nlwcldb,1) )
        allocate (Cldrad_props%emrndlw  (ix, jx, kx, nlwcldb,1) )
        allocate (Cldrad_props%abscoeff (ix, jx, kx, nlwcldb,1) )
        allocate (Cldrad_props%cldemiss (ix, jx, kx, nlwcldb,1) )
      endif
      Cldrad_props%emmxolw           = 1.0E+00
      Cldrad_props%emrndlw           = 1.0E+00
      Cldrad_props%abscoeff          = 0.0E+00
      Cldrad_props%cldemiss          = 0.0E+00

!---------------------------------------------------------------------
!    allocate and initialize the microphysically-based shortwave cloud 
!    radiative properties.
!---------------------------------------------------------------------
      if (Cldrad_control%do_sw_micro) then
        n_esfsw_bands = Solar_spect%nbands 
        if (Cldrad_control%do_ica_calcs) then
          allocate (Cldrad_props%cldext  (ix, jx, kx, n_esfsw_bands, &
                    n_esfsw_bands) )
          allocate (Cldrad_props%cldsct  (ix, jx, kx, n_esfsw_bands, &
                    n_esfsw_bands) )
          allocate (Cldrad_props%cldasymm(ix, jx, kx, n_esfsw_bands, &
                    n_esfsw_bands) )
        else
          allocate (Cldrad_props%cldext  (ix, jx, kx, n_esfsw_bands, 1))
          allocate (Cldrad_props%cldsct  (ix, jx, kx, n_esfsw_bands, 1))
          allocate (Cldrad_props%cldasymm(ix, jx, kx, n_esfsw_bands, 1))
        endif
        Cldrad_props%cldsct            = 0.0E+00
        Cldrad_props%cldext            = 0.0E+00
        Cldrad_props%cldasymm          = 1.0E+00

!---------------------------------------------------------------------
!    allocate and initialize the bulk-based shortwave cloud 
!    radiative properties.
!---------------------------------------------------------------------
      else
        allocate (Cldrad_props%cirabsw (ix, jx, kx) )
        allocate (Cldrad_props%cirrfsw (ix, jx, kx) )
        allocate (Cldrad_props%cvisrfsw(ix, jx, kx) )
        Cldrad_props%cirrfsw (:,:,:) = 0.0E+00
        Cldrad_props%cvisrfsw(:,:,:) = 0.0E+00
        Cldrad_props%cirabsw (:,:,:) = 0.0E+00
      endif

!---------------------------------------------------------------------
!    allocate and initialize the cloud radiative properties associated
!    with large-scale clouds for those cases where mesoscale and cell-
!    scale clouds may also be present.
!---------------------------------------------------------------------
      if (Cldrad_control%do_sw_micro) then
        allocate (Lscrad_props%cldext(ix, jx, kx, n_esfsw_bands) )
        allocate (Lscrad_props%cldsct(ix, jx, kx, n_esfsw_bands) )
        allocate (Lscrad_props%cldasymm(ix, jx, kx, n_esfsw_bands) )
        Lscrad_props%cldext   = 0.
        Lscrad_props%cldsct   = 0.
        Lscrad_props%cldasymm = 1.
      endif
      allocate (Lscrad_props%abscoeff (ix, jx, kx, nlwcldb) )
      Lscrad_props%abscoeff = 0.

!---------------------------------------------------------------------
!    allocate and initialize the cloud radiative properties associated
!    with mesoscale and cellscale clouds when they are present.
!---------------------------------------------------------------------
      if (Cldrad_control%do_donner_deep_clouds) then
        allocate (Cellrad_props%cldext(ix, jx, kx, n_esfsw_bands) )
        allocate (Cellrad_props%cldsct(ix, jx, kx, n_esfsw_bands) )
        allocate (Cellrad_props%cldasymm(ix, jx, kx, n_esfsw_bands) )
        allocate (Cellrad_props%abscoeff (ix, jx, kx, nlwcldb))
        allocate (Mesorad_props%cldext(ix, jx, kx, n_esfsw_bands) )
        allocate (Mesorad_props%cldsct(ix, jx, kx, n_esfsw_bands) )
        allocate (Mesorad_props%cldasymm(ix, jx, kx, n_esfsw_bands) )
        allocate (Mesorad_props%abscoeff (ix, jx, kx, nlwcldb) )
        Cellrad_props%cldext   = 0.
        Cellrad_props%cldsct   = 0.
        Cellrad_props%cldasymm = 1.
        Cellrad_props%abscoeff = 0.
        Mesorad_props%cldext   = 0.
        Mesorad_props%cldsct   = 0.
        Mesorad_props%cldasymm = 1.
        Mesorad_props%abscoeff = 0.
      endif

!---------------------------------------------------------------------
!    allocate and initialize the cloud radiative properties associated
!    with the clouds from the  uw shallow convection parameterization
!    when they are present.
!---------------------------------------------------------------------
       if (Cldrad_control%do_uw_clouds) then
         allocate (Shallowrad_props%cldext(ix, jx, kx, n_esfsw_bands) )
        allocate (Shallowrad_props%cldsct(ix, jx, kx, n_esfsw_bands) )
        allocate (Shallowrad_props%cldasymm(ix, jx, kx, n_esfsw_bands) )
        allocate (Shallowrad_props%abscoeff (ix, jx, kx, nlwcldb))
        Shallowrad_props%cldext   = 0.
        Shallowrad_props%cldsct   = 0.
        Shallowrad_props%cldasymm = 1.
        Shallowrad_props%abscoeff = 0.
      endif

!----------------------------------------------------------------------


end subroutine initialize_cldrad_props         



!#####################################################################
! <SUBROUTINE NAME="combine_cloud_properties">
!  <OVERVIEW>
!   combine_cloud_properties produces cloud-radiative properties fields
!    for the total-cloud field in each grid box.
!  </OVERVIEW>
!  <DESCRIPTION>
!   combine_cloud_properties produces cloud-radiative properties fields
!    for the total-cloud field in each grid box, using as input the 
!    properties and characteristics of the various cloud types that may 
!    be present (large-scale, donner mesoscale and cell-scale, uw 
!    shallow).
!  </DESCRIPTION>
!  <TEMPLATE>
!   call combine_cloud_properties (is, js, Rad_time, deltaz,    &
!                                     Lsc_microphys, Meso_microphys,  &
!                                     Cell_microphys,   &
!                                     Shallow_microphys, &
!                                     Lscrad_props,   &
!                                     Mesorad_props,  Cellrad_props,  &
!                                     Shallowrad_props, &
!                                     Cldrad_props)
!  </TEMPLATE>
!  <IN NAME="ix, jx, kx" TYPE="integer">
!       ix             size of i dimension of physics window
!       jx             size of j dimension of physics window
!       kx             size of k dimension of physics window
!  </IN>
!  <IN NAME="Lsc_microphys" TYPE="microphysics_type">
!    microphysical specification for large-scale 
!                      clouds
!  </IN>
!  <IN NAME="Meso_microphys" TYPE="microphysics_type">
!    microphysical specification for meso-scale 
!                      clouds assciated with donner convection
!  </IN>
!  <IN NAME="Cell_microphys" TYPE="microphysics_type">
!    microphysical specification for  convective cell
!                      clouds associated with donner convection
!  </IN>
!  <IN NAME="Shallow_microphys" TYPE="microphysics_type">
!    microphysical specification for 
!                      clouds associated with uw shallow convection
!  </IN>
!  <IN NAME="Lscrad_props" TYPE="microrad_properties_type">
!   cloud radiative properties for the large-scale 
!                      clouds   
!  </IN>
!  <IN NAME="Mesorad_props" TYPE="microrad_properties_type">
!   cloud radiative properties for the meso-scale
!                      clouds   
!  </IN>
!  <IN NAME="Cellrad_props" TYPE="microrad_properties_type">
!   cloud radiative properties for the convective cell
!                      clouds associated with donner convection 
!  </IN>
!  <IN NAME="Shallowrad_props" TYPE="microrad_properties_type">
!   cloud radiative properties for the 
!                      clouds associated with uw shallow convection 
!  </IN>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!   cloud radiative properties on model grid
!  </INOUT>
! </SUBROUTINE>
!
subroutine combine_cloud_properties (is, js, Rad_time, Time_next,  &
                                     deltaz,  Cld_spec,   &
                                     Lsc_microphys, Meso_microphys,  &
                                     Cell_microphys,   &
                                     Shallow_microphys, &
                                     Lscrad_props,   &
                                     Mesorad_props,  Cellrad_props,  &
                                     Shallowrad_props, &
                                     Cldrad_props)

!----------------------------------------------------------------------
!    combine_cloud_properties produces cloud-radiative properties fields
!    for the total-cloud field in each grid box, using as input the 
!    properties and characteristics of the various cloud types that may 
!    be present (large-scale, donner mesoscale and cell-scale, uw 
!    shallow).
!----------------------------------------------------------------------

integer,                        intent(in)    :: is, js
type(time_type),                intent(in)    :: Rad_time, Time_next
real, dimension(:,:,:),         intent(in)    :: deltaz
type(cld_specification_type),   intent(inout) :: Cld_spec
type(microphysics_type),        intent(in)    :: Lsc_microphys, &
                                                 Meso_microphys, &
                                                 Cell_microphys, &
                                                 Shallow_microphys
type(microrad_properties_type), intent(in)    :: Lscrad_props,  &
                                                 Mesorad_props,  &
                                                 Cellrad_props,&
                                                 Shallowrad_props
type(cldrad_properties_type), intent(inout)   :: Cldrad_props

!----------------------------------------------------------------------
!   intent(in) variables:
!
!       Lsc_microphys  microphysical specification for large-scale 
!                      clouds
!                      [ microphysics_type ]
!       Meso_microphys microphysical specification for meso-scale 
!                      clouds assciated with donner convection
!                      [ microphysics_type ]
!       Cell_microphys microphysical specification for convective cell
!                      clouds associated with donner convection
!                      [ microphysics_type ]
!       Shallow_microphys 
!                      microphysical specification for 
!                      clouds associated with uw shallow convection
!                      [ microphysics_type ]
!       Lscrad_props   cloud radiative properties for the large-scale 
!                      clouds   
!                      [ microrad_properties_type ]
!       Mesorad_props  cloud radiative properties for meso-scale 
!                      clouds associated with donner convection   
!                      [ microrad_properties_type ]
!       Cellrad_props  cloud radiative properties for convective cell
!                      clouds associated with donner convection  
!                      [ microrad_properties_type ]
!       Shallowrad_props  
!                      cloud radiative properties for
!                      clouds associated with uw shallow convection  
!                      [ microrad_properties_type ]
!
!    intent(inout) variables:
!
!      Cldrad_props    cloud radiative properties on model grid,
!                      [ cldrad_properties_type ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    call comb_cldprops_calc with the appropriate arguments dependent 
!    upon the cloud / convection scheme which is active.
!---------------------------------------------------------------------
      if (Cldrad_control%do_strat_clouds .and.    &
          Cldrad_control%do_uw_clouds .and. &
          Cldrad_control%do_donner_deep_clouds) then

!----------------------------------------------------------------------
!    if strat_cloud, donner_deep and uw shallow are all active, then 
!    lw and sw cloud radiative properties are microphysically based, 
!    and large-scale, donner mesoscale and cell-scale, and uw shallow
!    cloud properties are available. call comb_cldprops_calc to combine
!    these into a single set of cloud radiative properties to be used 
!    by the radiation package. 
!---------------------------------------------------------------------
        call comb_cldprops_calc (is, js, Rad_time, Time_next, deltaz,  &
                                 Cld_spec%stoch_cloud_type, &
                                 Cldrad_props%cldext,   &
                                 Cldrad_props%cldsct,   &
                                 Cldrad_props%cldasymm,  &
                                 Cldrad_props%abscoeff,   &
                                 Lsc_microphys = Lsc_microphys, &
                                 Meso_microphys = Meso_microphys, &
                                 Cell_microphys = Cell_microphys, &
                                 Shallow_microphys = Shallow_microphys,&
                                 Lscrad_props=Lscrad_props,  &
                                 Mesorad_props = Mesorad_props, &
                                 Cellrad_props = Cellrad_props, &
                                Shallowrad_props = Shallowrad_props)
     else if (Cldrad_control%do_strat_clouds .and.    &
             Cldrad_control%do_donner_deep_clouds) then
 

!----------------------------------------------------------------------
!    if strat_cloud and donner_deep are both active, then both lw and 
!    sw cloud radiative properties are microphysically based, and large-
!    scale, mesoscale and cell-scale properties are available. call
!    comb_cldprops_calc to combine these into a single set of cloud
!    radiative properties to be used by the radiation package. 
!---------------------------------------------------------------------
        call comb_cldprops_calc (is, js, Rad_time, Time_next, deltaz,   &
                                 Cld_spec%stoch_cloud_type, &
                                 Cldrad_props%cldext,   &
                                 Cldrad_props%cldsct,   &
                                 Cldrad_props%cldasymm,  &
                                 Cldrad_props%abscoeff,   &
                                 Lsc_microphys = Lsc_microphys, &
                                 Meso_microphys = Meso_microphys, &
                                 Cell_microphys = Cell_microphys, &
                                 Lscrad_props=Lscrad_props,  &
                                 Mesorad_props = Mesorad_props, &
                                 Cellrad_props = Cellrad_props)

      else if (Cldrad_control%do_strat_clouds .and.    &
               Cldrad_control%do_uw_clouds) then

!----------------------------------------------------------------------
!    if strat_cloud and uw shallow are both active, then both lw and 
!    sw cloud radiative properties are microphysically based, and large-
!    scale and uw shallow cloud properties are available. call
!    comb_cldprops_calc to combine these into a single set of cloud
!    radiative properties to be used by the radiation package. 
!---------------------------------------------------------------------
        call comb_cldprops_calc (is, js, Rad_time, Time_next, deltaz,  &
                                 Cld_spec%stoch_cloud_type, &
                                  Cldrad_props%cldext,   &
                               Cldrad_props%cldsct,   &
                                 Cldrad_props%cldasymm,  &
                                  Cldrad_props%abscoeff,   &
                                  Lsc_microphys = Lsc_microphys, &
                                 Shallow_microphys = Shallow_microphys,&
                                  Lscrad_props=Lscrad_props,  &
                                  Shallowrad_props = Shallowrad_props)

   else if (Cldrad_control%do_uw_clouds .and.    &
            Cldrad_control%do_donner_deep_clouds) then
 
!----------------------------------------------------------------------
!    if uw shallow and donner_deep clouds are both active, then both 
!    lw and sw cloud radiative properties are microphysically based, 
!    and donner mesoscale and cell-scale and uw shallow cloud properties
!    are available. call comb_cldprops_calc to combine these into a 
!    single set of cloud radiative properties to be used by the 
!    radiation package. 
!---------------------------------------------------------------------
      call comb_cldprops_calc (is, js, Rad_time, Time_next, deltaz,  &
                                 Cld_spec%stoch_cloud_type, &
                                Cldrad_props%cldext,   &
                                 Cldrad_props%cldsct,   &
                                Cldrad_props%cldasymm,  &
                                  Cldrad_props%abscoeff,   &
                                Meso_microphys = Meso_microphys, &
                                 Cell_microphys = Cell_microphys, &
                                 Shallow_microphys = Shallow_microphys,&
                                 Mesorad_props = Mesorad_props, &
                                 Cellrad_props = Cellrad_props, &
                                Shallowrad_props=Shallowrad_props)
      

!---------------------------------------------------------------------
!    if donner_deep alone is active, then the mesoscale
!    and cell-scale properties must be combined. 
!----------------------------------------------------------------------
      else if (Cldrad_control%do_donner_deep_clouds) then
        call comb_cldprops_calc (is, js, Rad_time, Time_next, deltaz,  &
                                 Cld_spec%stoch_cloud_type, &
                                 Cldrad_props%cldext,   &
                                 Cldrad_props%cldsct,   &
                                 Cldrad_props%cldasymm, &
                                 Cldrad_props%abscoeff,   &
                                 Meso_microphys = Meso_microphys, &
                                 Cell_microphys = Cell_microphys, &
                                 Mesorad_props = Mesorad_props, &
                                 Cellrad_props = Cellrad_props)

!---------------------------------------------------------------------
!    if uw shallow alone is active, then total cloud values are 
!    defined as the uw shallow values.
!----------------------------------------------------------------------
     else if (Cldrad_control%do_uw_clouds) then
       if (Cldrad_control%do_sw_micro) then
         Cldrad_props%cldsct(:,:,:,:,1) =    &
                                      Shallowrad_props%cldsct(:,:,:,:)
         Cldrad_props%cldext(:,:,:,:,1) =    &
                                      Shallowrad_props%cldext(:,:,:,:)
         Cldrad_props%cldasymm(:,:,:,:,1) =  &
                                     Shallowrad_props%cldasymm(:,:,:,:)
      endif
      if (Cldrad_control%do_lw_micro) then
        Cldrad_props%abscoeff(:,:,:,:,1) =   &
                                  Shallowrad_props%abscoeff(:,:,:,:)
     endif
      
!----------------------------------------------------------------------
!    if microphysically-based properties have been generated without
!    donner_deep being active, total-cloud values are defined as the
!    large-scale cloud values.
!----------------------------------------------------------------------
      else if (Cldrad_control%do_strat_clouds) then
        if (Cldrad_control%do_sw_micro) then
          Cldrad_props%cldsct(:,:,:,:,1) = Lscrad_props%cldsct(:,:,:,:)
          Cldrad_props%cldext(:,:,:,:,1) = Lscrad_props%cldext(:,:,:,:)
          Cldrad_props%cldasymm(:,:,:,:,1) =  &
                                         Lscrad_props%cldasymm(:,:,:,:)
        endif
        if (Cldrad_control%do_lw_micro) then
          Cldrad_props%abscoeff(:,:,:,:,1) =   &
                                      Lscrad_props%abscoeff(:,:,:,:)
        endif
      endif

!--------------------------------------------------------------------



end subroutine  combine_cloud_properties 



!####################################################################
! <SUBROUTINE NAME="cloudrad_package_dealloc">
!  <OVERVIEW>
!   Subroutine to deallocate the space cloud radiative properties use
!   in the model
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to deallocate the space cloud radiative properties use
!   in the model
!  </DESCRIPTION>
!  <TEMPLATE>
!   call  cloudrad_package_dealloc (Lscrad_props, Mesorad_props,  &
!                                   Cellrad_props)
!  </TEMPLATE>
!  <IN NAME="Lscrad_props" TYPE="microrad_properties_type">
!   cloud radiative properties for the large-scale 
!                      clouds   
!  </IN>
!  <IN NAME="Mesorad_props" TYPE="microrad_properties_type">
!   cloud radiative properties for the meso-scale
!                      clouds   
!  </IN>
!  <IN NAME="Cellrad_props" TYPE="cldrad_prperties_type">
!   cldrad_prperties_type variable containing the cloud radiative
!   properties for the donner cell clouds
!  </IN>
!  <IN NAME="Shallowrad_props" TYPE="cldrad_properties_type">
!   cldrad_prperties_type variable containing the cloud radiative
!   properties for the uw shallow clouds
!  </IN>
! </SUBROUTINE>
!
subroutine cloudrad_package_dealloc (Lscrad_props, Mesorad_props,   &
                                     Cellrad_props, Shallowrad_props)

!---------------------------------------------------------------------
!    cloudrad_package_dealloc deallocates the components of the local
!    derived-type variables.
!---------------------------------------------------------------------
        
type(microrad_properties_type), intent(inout) :: Lscrad_props,  &
                                                 Mesorad_props, &
                                                 Cellrad_props, &
                                                 Shallowrad_props
!---------------------------------------------------------------------
!   intent(in) variables:
!
!       Lscrad_props   cloud radiative properties for the large-scale 
!                      clouds   
!                      [ microrad_properties_type ]
!       Mesorad_props  cloud radiative properties for meso-scale 
!                      clouds associated with donner convection   
!                      [ microrad_properties_type ]
!       Cellrad_props  cloud radiative properties for convective cell
!                      clouds associated with donner convection  
!                      [ microrad_properties_type ]
!     Shallowrad_props  cloud radiative properties for 
!                      clouds associated with uw shallow convection  
!                      [ microrad_properties_type ]
!
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!    deallocate the elements of Lscrad_props.
!---------------------------------------------------------------------
      if (Cldrad_control%do_sw_micro) then
        deallocate (Lscrad_props%cldext    )
        deallocate (Lscrad_props%cldsct    )
        deallocate (Lscrad_props%cldasymm  )
      endif
      deallocate (Lscrad_props%abscoeff    )

!--------------------------------------------------------------------
!    deallocate the elements of Cellrad_props and Mesorad_props.
!---------------------------------------------------------------------
      if (Cldrad_control%do_donner_deep_clouds) then
        deallocate (Cellrad_props%cldext   )
        deallocate (Cellrad_props%cldsct   )
        deallocate (Cellrad_props%cldasymm )
        deallocate (Cellrad_props%abscoeff )
        deallocate (Mesorad_props%cldext   )
        deallocate (Mesorad_props%cldsct   )
        deallocate (Mesorad_props%cldasymm )
        deallocate (Mesorad_props%abscoeff )
      endif

!--------------------------------------------------------------------
!    deallocate the elements of Shallowrad_props.
!---------------------------------------------------------------------
      if (Cldrad_control%do_uw_clouds) then
        deallocate (Shallowrad_props%cldext   )
        deallocate (Shallowrad_props%cldsct   )
        deallocate (Shallowrad_props%cldasymm )
        deallocate (Shallowrad_props%abscoeff )
      endif

!---------------------------------------------------------------------



end subroutine cloudrad_package_dealloc



!###################################################################





                   end module cloudrad_package_mod

program regrid_hlfs

  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Zhi Liang </CONTACT>
  !
  ! <OVERVIEW>
  !   This program is to calculate surface upward laten heat flux on the atmosphere grid.
  ! </OVERVIEW>

  !<DESCRIPTION>
  ! to compile, in the command line, type 
  !   "
  !</DESCRIPTION>

  implicit none
#include "netcdf.inc"

  real, parameter   :: epsln = 1.e-20
  integer           :: stdout = 6

  character(len=24) :: grid_file = "input/grid_spec.nc"
  character(len=24) :: fld_in_from_lnd = 'latent'
  character(len=24) :: fld_in_from_ice =  'LH'
  character(len=24) :: src_from_lnd,    src_from_ice
  character(len=24) :: fld_out_from_ice = 'LH_from_ice'
  character(len=24) :: fld_out_from_tot = 'sfc_latent_tot'
  character(len=24) :: output_from_ice, output_from_tot
  character(len=32) :: tunits = " "

  logical           :: time_bounds_exist
  integer           :: ni_ice, nj_ice, ntime
  integer           :: ni_atm, nj_atm
  integer           :: ncid_ice, ncid_tot
  integer           :: id_time_ice, id_timeb_ice
  integer           :: id_time_tot, id_timeb_tot
  integer           :: id_lh_ice, id_lh_tot
  integer           :: id_t1_ice, id_t2_ice, id_dt_ice
  integer           :: id_t1_tot, id_t2_tot, id_dt_tot
  real              :: missing_lnd, missing_ice


  real, dimension(:),    allocatable :: lon, lat, lonb, latb
  integer, dimension(:), allocatable :: i_atm_atmxocn, j_atm_atmxocn 
  integer, dimension(:), allocatable :: i_ocn_atmxocn, j_ocn_atmxocn
  real, dimension(:),    allocatable :: area_atmxocn
  real, dimension(:,:),  allocatable :: area_atm, area_ocn 
  real, dimension(:),    allocatable :: time_value, t1, t2, dt
  real, dimension(:,:),  allocatable :: time_bounds

  call regrid_hfls_init

  !---- read grid information
  call read_grid

  !--- get source data information
  call get_src_info

  !--- setup meta data for the output file
  call setup_meta

  !--- processing data and write out the data sets
  call process_data()


contains

  !#####################################################################
  subroutine regrid_hfls_init
    integer :: unit_begin, unit_end, unit
    logical :: opened, file_exist

    src_from_lnd = 'input/'//trim(fld_in_from_lnd)//'.nc'
    src_from_ice = 'input/'//trim(fld_in_from_ice)//'.nc'
    output_from_ice = trim(fld_out_from_ice)//'.nc'
    output_from_tot = trim(fld_out_from_tot)//'.nc'

  end subroutine regrid_hfls_init

  !#####################################################################
  subroutine read_grid

    integer :: rcode, ncid, ncells

    rcode = nf_open(grid_file, NF_NOWRITE, ncid)
    call error_handler('error in open file '//grid_file, rcode)


    !--- read the ocean grid information ( source grid )
    ni_ice = get_dimlen(ncid, 'gridlon_t')
    nj_ice = get_dimlen(ncid, 'gridlat_t')

    !--- read the atmos grid information ( destination grid )
    ni_atm = get_dimlen(ncid, 'xta')
    nj_atm = get_dimlen(ncid, 'yta')

    allocate(lon(ni_atm), lat(nj_atm), lonb(ni_atm+1), latb(nj_atm+1) )

    call get_var_real_1d(ncid, 'xta', lon)
    call get_var_real_1d(ncid, 'yta', lat)  
    call get_var_real_1d(ncid, 'xba', lonb)
    call get_var_real_1d(ncid, 'yba', latb)  

    !--- get exchange grid information
    ncells = get_dimlen(ncid, 'I_ATM_ATMxOCN')
    allocate(i_atm_atmxocn(ncells), j_atm_atmxocn(ncells)    )
    allocate(i_ocn_atmxocn(ncells), j_ocn_atmxocn(ncells)    )
    allocate(area_atmxocn(ncells),  area_atm(ni_atm, nj_atm) )

    call get_var_int_1d(ncid, 'I_ATM_ATMxOCN', i_atm_atmxocn)
    call get_var_int_1d(ncid, 'J_ATM_ATMxOCN',j_atm_atmxocn )
    call get_var_int_1d(ncid, 'I_OCN_ATMxOCN',i_ocn_atmxocn )
    call get_var_int_1d(ncid, 'J_OCN_ATMxOCN',j_ocn_atmxocn )
    call get_var_real_1d(ncid, 'AREA_ATMxOCN',area_atmxocn )
    call get_var_real_2d(ncid, 'AREA_ATM',area_atm )

    allocate(area_ocn(ni_atm,nj_atm) )

    rcode = nf_close(ncid)


  end subroutine read_grid

  !#####################################################################

  subroutine get_src_info

    integer :: rcode, ncid, varid

    rcode = nf_open(trim(src_from_lnd), NF_NOWRITE, ncid) 
    call error_handler('error in opening file '//trim(src_from_lnd), rcode) 

    ! check if time_bounds exist or not
    rcode = nf_inq_varid(ncid, 'time_bounds', varid)
    if(rcode == 0) then
       time_bounds_exist = .true.;
    else
       time_bounds_exist = .false.;
       write(stdout,*)" time average information does not exist, ", &
                   "There will be not time_bounds, average_T1, average_T2 ", &
                   "and average_DT in the output file"
    endif

    ntime = get_dimlen(ncid, 'time')
    allocate(time_value(ntime), time_bounds(2, ntime) )
    allocate(t1(ntime), t2(ntime), dt(ntime) )
    call get_var_real_1d(ncid, 'time', time_value)
    if(time_bounds_exist) then
       call get_var_real_1d(ncid, 'average_T1', t1)
       call get_var_real_1d(ncid, 'average_T2', t2)
       call get_var_real_1d(ncid, 'average_DT', dt)
       call get_var_real_2d(ncid, 'time_bounds', time_bounds)
    endif

    !--- get the time units
    call get_time_units(ncid)

    !--- get the missing value
    call get_missing_value(ncid, fld_in_from_lnd, missing_lnd )

    rcode = nf_close(ncid) 

    rcode = nf_open(trim(src_from_ice), NF_NOWRITE, ncid) 
    call error_handler('error in opening file '//trim(src_from_ice), rcode) 

    call get_missing_value(ncid, fld_in_from_ice, missing_ice )

  end subroutine get_src_info

  !#####################################################################
  subroutine setup_meta

    integer          :: rcode, dims(6), id_xt, id_yt, id_xb, id_yb, id_nv
    character(len=4) :: units

    if(tunits(1:4) == 'days') then
       units = 'days'
    else
       call error_handler('time units should be days, need to update the source code')
    endif

    !--- setup for the part from ice model
    rcode = nf_create(trim(output_from_ice),NF_WRITE, ncid_ice)
    call error_handler('error in creating file '//trim(output_from_ice), rcode) 

    !--- define dimension
    dims(1) = define_dim(ncid_ice, 'xt',ni_atm)
    dims(2) = define_dim(ncid_ice, 'yt',nj_atm)
    dims(3) = define_dim(ncid_ice, 'time', NF_UNLIMITED)
    dims(4) = define_dim(ncid_ice, 'xb', ni_atm+1)
    dims(5) = define_dim(ncid_ice, 'yb', nj_atm+1)
    dims(6) = define_dim(ncid_ice, 'nv', 2)

    !--- define variable
    id_xt        = define_var_1d(ncid_ice, 'xt', NF_FLOAT, dims(1) )
    call put_att_text(ncid_ice, id_xt, 'long_name', 'longitude')
    call put_att_text(ncid_ice, id_xt, 'units', 'degrees_E')
    call put_att_text(ncid_ice, id_xt, 'cartesian_axis', 'X')
    call put_att_text(ncid_ice, id_xt, 'edges', 'xb')

    id_yt        = define_var_1d(ncid_ice, 'yt', NF_FLOAT, dims(2) )
    call put_att_text(ncid_ice, id_yt, 'long_name', 'latitude')
    call put_att_text(ncid_ice, id_yt, 'units', 'degrees_N')
    call put_att_text(ncid_ice, id_yt, 'cartesian_axis', 'Y')
    call put_att_text(ncid_ice, id_yt, 'edges', 'yb')

    id_xb        = define_var_1d(ncid_ice, 'xb', NF_FLOAT, dims(4) )
    call put_att_text(ncid_ice, id_xb, 'long_name', 'longitude edges')
    call put_att_text(ncid_ice, id_xb, 'units', 'degrees_E')
    call put_att_text(ncid_ice, id_xb, 'cartesian_axis', 'X')

    id_yb        = define_var_1d(ncid_ice, 'yb', NF_FLOAT, dims(5) )
    call put_att_text(ncid_ice, id_yb, 'long_name', 'latitude edges')
    call put_att_text(ncid_ice, id_yb, 'units', 'degrees_N')
    call put_att_text(ncid_ice, id_yb, 'cartesian_axis', 'Y')

    id_time_ice  = define_var_1d(ncid_ice, 'time', NF_DOUBLE, dims(3) )
    call put_att_text(ncid_ice, id_time_ice, 'long_name', 'time')
    call put_att_text(ncid_ice, id_time_ice, 'units', trim(tunits) )
    call put_att_text(ncid_ice, id_time_ice, 'cartesian_axis', 'T')
    call put_att_text(ncid_ice, id_time_ice, 'calendar_type', 'NOLEAP')
    call put_att_text(ncid_ice, id_time_ice, 'calendar', 'NOLEAP')
    if(time_bounds_exist) then
       call put_att_text(ncid_ice, id_time_ice, 'bounds', 'time_bounds')
    endif

    id_nv        = define_var_1d(ncid_ice, 'nv', NF_FLOAT, dims(6) )
    call put_att_text(ncid_ice, id_nv, 'long_name', 'vertex number')
    call put_att_text(ncid_ice, id_nv, 'units', 'none')
    call put_att_text(ncid_ice, id_nv, 'cartesian_axis', 'N')

    if(time_bounds_exist) then
       id_t1_ice    = define_var_1d(ncid_ice, 'average_T1', NF_DOUBLE, dims(3) )
       call put_att_text(ncid_ice, id_t1_ice, 'long_name', 'Start time for average period')
       call put_att_text(ncid_ice, id_t1_ice, 'units', trim(tunits) )

       id_t2_ice    = define_var_1d(ncid_ice, 'average_T2', NF_DOUBLE, dims(3) )
       call put_att_text(ncid_ice, id_t2_ice, 'long_name', 'End time for average period')
       call put_att_text(ncid_ice, id_t2_ice, 'units',  trim(tunits) )

       id_dt_ice    = define_var_1d(ncid_ice, 'average_DT', NF_DOUBLE, dims(3) )
       call put_att_text(ncid_ice, id_dt_ice, 'long_name', 'Length of average period')
       call put_att_text(ncid_ice, id_dt_ice, 'units', trim(units))

       id_timeb_ice = define_var_2d(ncid_ice, 'time_bounds', NF_DOUBLE, (/dims(6), dims(3)/) )
       call put_att_text(ncid_ice, id_timeb_ice, 'long_name', 'time axis boundaries')
       call put_att_text(ncid_ice, id_timeb_ice, 'units', trim(units) )
    endif

    id_lh_ice    = define_var_3d(ncid_ice, trim(fld_out_from_ice), NF_FLOAT, dims(1:3) )
    call put_att_text(ncid_ice, id_lh_ice, 'long_name', 'latent heat flux')
    call put_att_text(ncid_ice, id_lh_ice, 'units', 'W/m^2')
    call put_att_real(ncid_ice, id_lh_ice, 'missing_value', missing_ice)
    call put_att_text(ncid_ice, id_lh_ice, 'cell_methods', 'time: mean')

    if(time_bounds_exist) then
       call put_att_text(ncid_ice, id_lh_ice, 'time_avg_info', 'average_T1,average_T2,average_DT')
    endif

    rcode = nf_enddef(ncid_ice)

    !--- write out axis data
    call put_var_real_1d(ncid_ice, id_xt, lon)
    call put_var_real_1d(ncid_ice, id_yt, lat)
    call put_var_real_1d(ncid_ice, id_xb, lonb)
    call put_var_real_1d(ncid_ice, id_yb, latb)
    call put_var_real_1d(ncid_ice, id_nv, (/1.,2./) )

    !--- setup for the part from addition of ice and land model
    rcode = nf_create(trim(output_from_tot),NF_WRITE, ncid_tot)
    call error_handler('error in creating file '//trim(output_from_tot), rcode) 

    !--- define dimension
    dims(1) = define_dim(ncid_tot, 'lon',ni_atm)
    dims(2) = define_dim(ncid_tot, 'lat',nj_atm)
    dims(3) = define_dim(ncid_tot, 'time', NF_UNLIMITED)
    dims(4) = define_dim(ncid_tot, 'lonb', ni_atm+1)
    dims(5) = define_dim(ncid_tot, 'latb', nj_atm+1)
    dims(6) = define_dim(ncid_tot, 'nv', 2)

    !--- define variable
    id_xt        = define_var_1d(ncid_tot, 'lon', NF_FLOAT, dims(1) )
    call put_att_text(ncid_tot, id_xt, 'long_name', 'longitude')
    call put_att_text(ncid_tot, id_xt, 'units', 'degrees_E')
    call put_att_text(ncid_tot, id_xt, 'cartesian_axis', 'X')
    call put_att_text(ncid_tot, id_xt, 'edges', 'lonb')

    id_yt        = define_var_1d(ncid_tot, 'lat', NF_FLOAT, dims(2) )
    call put_att_text(ncid_tot, id_yt, 'long_name', 'latitude')
    call put_att_text(ncid_tot, id_yt, 'units', 'degrees_N')
    call put_att_text(ncid_tot, id_yt, 'cartesian_axis', 'Y')
    call put_att_text(ncid_tot, id_yt, 'edges', 'latb')

    id_xb        = define_var_1d(ncid_tot, 'lonb', NF_FLOAT, dims(4) )
    call put_att_text(ncid_tot, id_xb, 'long_name', 'longitude edges')
    call put_att_text(ncid_tot, id_xb, 'units', 'degrees_E')
    call put_att_text(ncid_tot, id_xb, 'cartesian_axis', 'X')

    id_yb        = define_var_1d(ncid_tot, 'latb', NF_FLOAT, dims(5) )
    call put_att_text(ncid_tot, id_yb, 'long_name', 'latitude edges')
    call put_att_text(ncid_tot, id_yb, 'units', 'degrees_N')
    call put_att_text(ncid_tot, id_yb, 'cartesian_axis', 'Y')

    id_time_tot  = define_var_1d(ncid_tot, 'time', NF_DOUBLE, dims(3) )
    call put_att_text(ncid_tot, id_time_tot, 'long_name', 'time')
    call put_att_text(ncid_tot, id_time_tot, 'units', trim(tunits) )
    call put_att_text(ncid_tot, id_time_tot, 'cartesian_axis', 'T')
    call put_att_text(ncid_tot, id_time_tot, 'calendar_type', 'NOLEAP')
    call put_att_text(ncid_tot, id_time_tot, 'calendar', 'NOLEAP')
    if(time_bounds_exist) then
       call put_att_text(ncid_tot, id_time_tot, 'bounds', 'time_bounds')
    endif

    id_nv        = define_var_1d(ncid_tot, 'nv', NF_FLOAT, dims(6) )
    call put_att_text(ncid_tot, id_nv, 'long_name', 'vertex number')
    call put_att_text(ncid_tot, id_nv, 'units', 'none')
    call put_att_text(ncid_tot, id_nv, 'cartesian_axis', 'N')

    if(time_bounds_exist) then
       id_t1_tot    = define_var_1d(ncid_tot, 'average_T1', NF_DOUBLE, dims(3) )
       call put_att_text(ncid_tot, id_t1_tot, 'long_name', 'Start time for average period')
       call put_att_text(ncid_tot, id_t1_tot, 'units', trim(tunits) )

       id_t2_tot    = define_var_1d(ncid_tot, 'average_T2', NF_DOUBLE, dims(3) )
       call put_att_text(ncid_tot, id_t2_tot, 'long_name', 'End time for average period')
       call put_att_text(ncid_tot, id_t2_tot, 'units', trim(tunits) )

       id_dt_tot    = define_var_1d(ncid_tot, 'average_DT', NF_DOUBLE, dims(3) )
       call put_att_text(ncid_tot, id_dt_tot, 'long_name', 'Length of average period')
       call put_att_text(ncid_tot, id_dt_tot, 'units', trim(units))

       id_timeb_tot = define_var_2d(ncid_tot, 'time_bounds', NF_DOUBLE, (/dims(6), dims(3)/) )
       call put_att_text(ncid_tot, id_timeb_tot, 'long_name', 'time axis boundaries')
       call put_att_text(ncid_tot, id_timeb_tot, 'units', trim(units))
    endif

    id_lh_tot    = define_var_3d(ncid_tot, trim(fld_out_from_tot), NF_FLOAT, dims(1:3) )    
    call put_att_text(ncid_tot, id_lh_tot, 'long_name', 'latent heat flux')
    call put_att_text(ncid_tot, id_lh_tot, 'units', 'W/m^2')
    call put_att_real(ncid_tot, id_lh_tot, 'missing_value', missing_lnd)
    call put_att_text(ncid_tot, id_lh_tot, 'cell_methods', 'time: mean')
    if(time_bounds_exist) then
       call put_att_text(ncid_tot, id_lh_tot, 'time_avg_info', 'average_T1,average_T2,average_DT')
    endif

    rcode = nf_enddef(ncid_tot)

    !--- write out axis data
    call put_var_real_1d(ncid_tot, id_xt, lon)
    call put_var_real_1d(ncid_tot, id_yt, lat)
    call put_var_real_1d(ncid_tot, id_xb, lonb)
    call put_var_real_1d(ncid_tot, id_yb, latb)
    call put_var_real_1d(ncid_tot, id_nv, (/1.,2./) )

    return

  end subroutine setup_meta

  !#####################################################################

  subroutine process_data

    integer                         :: rcode, m, i, j
    real, dimension(ni_ice, nj_ice) :: data_src_ice
    real, dimension(ni_atm, nj_atm) :: data_src_lnd, data_dst_ice, data_dst_tot

    do m = 1, ntime

       write(stdout,*)'******* processing at time step: ', m

       !--- read input data
       call get_var_level_2d(src_from_ice, fld_in_from_ice, m, data_src_ice )
       call get_var_level_2d(src_from_lnd, fld_in_from_lnd, m, data_src_lnd )    

       !--- data conversion
       data_dst_ice = 0.0
       area_ocn     = 0.0
       do i = 1, size(i_atm_atmxocn)
          if(data_src_ice(i_ocn_atmxocn(i),j_ocn_atmxocn(i)) .ne. missing_ice ) then
             data_dst_ice(i_atm_atmxocn(i),j_atm_atmxocn(i)) = data_dst_ice(i_atm_atmxocn(i),j_atm_atmxocn(i)) &
                  + data_src_ice(i_ocn_atmxocn(i),j_ocn_atmxocn(i)) * area_atmxocn(i)
             area_ocn(i_atm_atmxocn(i),j_atm_atmxocn(i)) = area_ocn(i_atm_atmxocn(i),j_atm_atmxocn(i)) + area_atmxocn(i)
          endif
       enddo

       do j = 1, nj_atm
          do i = 1, ni_atm
             if(area_ocn(i,j) > epsln ) then
                data_dst_ice(i,j) = data_dst_ice(i,j)/area_ocn(i,j)
             else
                data_dst_ice(i,j) = missing_ice
             endif
          enddo
       enddo

       do j = 1, nj_atm
          do i = 1, ni_atm
             if(data_dst_ice(i,j) .ne. missing_ice ) then
                data_dst_tot(i,j) = data_dst_ice(i,j) * area_ocn(i,j)
             else
                data_dst_tot(i,j) = 0.0
             endif

             if(data_src_lnd(i,j) .ne. missing_lnd ) then
                data_dst_tot(i,j) = data_dst_tot(i,j) + data_src_lnd(i,j) * (area_atm(i,j)-area_ocn(i,j))
             endif
             data_dst_tot(i,j) = data_dst_tot(i,j)/area_atm(i,j)
          enddo
       enddo

       !--- write out data from ice model
       call put_var_level_2d(ncid_ice, id_lh_ice, m, data_dst_ice )
       call put_var_level_0d(ncid_ice, id_time_ice, m, time_value(m) ) 
       if(time_bounds_exist) then
          call put_var_level_0d(ncid_ice, id_t1_ice, m, t1(m) ) 
          call put_var_level_0d(ncid_ice, id_t2_ice, m, t2(m) ) 
          call put_var_level_0d(ncid_ice, id_dt_ice, m, dt(m) ) 
          call put_var_level_1d(ncid_ice, id_timeb_ice, m, time_bounds(:,m) )      
       endif

       !--- write out the total hfls
       call put_var_level_2d(ncid_tot, id_lh_tot, m, data_dst_tot )
       call put_var_level_0d(ncid_tot, id_time_tot, m, time_value(m) ) 
       if(time_bounds_exist) then
          call put_var_level_0d(ncid_tot, id_t1_tot, m, t1(m) ) 
          call put_var_level_0d(ncid_tot, id_t2_tot, m, t2(m) ) 
          call put_var_level_0d(ncid_tot, id_dt_tot, m, dt(m) ) 
          call put_var_level_1d(ncid_tot, id_timeb_tot, m, time_bounds(:,m) )   
       endif

    enddo

    rcode = nf_close(ncid_ice)
    rcode = nf_close(ncid_tot)

  end subroutine process_data

  !#####################################################################
  ! get the dimension length of any one dimensional variable
  function get_dimlen(ncid, name)
    integer,          intent(in) :: ncid
    character(len=*), intent(in) :: name
    integer                      :: get_dimlen
    integer                      :: varid, rcode, dims(1)

    rcode = nf_inq_varid(ncid, trim(name), varid)
    call error_handler('error in inquiring variable id of '//trim(name), rcode)

    rcode = nf_inq_vardimid(ncid, varid, dims)
    call error_handler('error in inquiring dimension id of '//trim(name), rcode)

    rcode = nf_inq_dimlen(ncid, dims(1), get_dimlen)
    call error_handler('error in inquiring dimension length of '//trim(name), rcode)

  end function get_dimlen

  !#####################################################################
  ! read the 1d integer data from netcdf file.
  subroutine get_var_int_1d(ncid, name, data)
    integer,                intent(in) :: ncid
    character(len=*),       intent(in) :: name
    integer, dimension(:), intent(out) :: data
    integer                            :: rcode, varid

    rcode = nf_inq_varid(ncid, name, varid)
    call error_handler('error in inquiring variable id of '//trim(name), rcode)
    rcode = nf_get_var_int(ncid, varid, data)
    call error_handler('error in reading data of '//trim(name), rcode)

  end subroutine get_var_int_1d

  !#####################################################################
  ! read the 1d real data from netcdf file.
  subroutine get_var_real_1d(ncid, name, data)
    integer,             intent(in) :: ncid
    character(len=*),    intent(in) :: name
    real, dimension(:), intent(out) :: data
    integer                         :: rcode, varid

    rcode = nf_inq_varid(ncid, name, varid)
    call error_handler('error in inquiring variable id of '//trim(name), rcode)

    rcode = nf_get_var_double(ncid, varid, data)
    call error_handler('error in reading data of '//trim(name), rcode)


  end subroutine get_var_real_1d

  !#####################################################################
  ! read the 2d real data from netcdf file.
  subroutine get_var_real_2d(ncid, name, data)
    integer,               intent(in) :: ncid
    character(len=*),      intent(in) :: name
    real, dimension(:,:), intent(out) :: data
    integer                           :: rcode, varid


    rcode = nf_inq_varid(ncid, name, varid)
    call error_handler('error in inquiring variable id of '//trim(name), rcode)

    rcode = nf_get_var_double(ncid, varid, data)
    call error_handler('error in reading data of '//trim(name), rcode)

  end subroutine get_var_real_2d

  !#####################################################################
  subroutine get_missing_value(ncid, name, missing)

    integer,          intent(in) :: ncid
    character(len=*), intent(in) :: name
    real,             intent(in) :: missing

    integer                      :: rcode, id_fld

    rcode = nf_inq_varid(ncid,trim(name), id_fld)
    call error_handler('error in inquring id of field '//trim(name), rcode)

    rcode = nf_get_att_double(ncid, id_fld, 'missing_value', missing )
    call error_handler('error in get field '//trim(name)//' missing value' , rcode)    
    rcode = nf_close(ncid)

  end subroutine get_missing_value

  !#####################################################################
  subroutine get_time_units(ncid)
     integer,           intent(in) :: ncid

    integer                      :: rcode, id_fld

    rcode = nf_inq_varid(ncid,'time', id_fld)
    call error_handler('error in inquring id of time', rcode)

    rcode = nf_get_att_text(ncid, id_fld, 'units', tunits )
    call error_handler('error in get time units' , rcode)    

  end subroutine get_time_units

  !#####################################################################
  function define_dim(ncid, name, size )
    integer,          intent(in) :: ncid, size
    character(len=*), intent(in) :: name
    integer                      :: define_dim

    integer                      :: rcode

    rcode = nf_def_dim(ncid, trim(name), size, define_dim)
    call error_handler('error in defining dimension '//trim(name) , rcode)   

  end function define_dim

  !#####################################################################
  function define_var_1d(ncid, name, type, dim )
    integer,          intent(in) :: ncid, type, dim
    character(len=*), intent(in) :: name
    integer                      :: define_var_1d

    integer                      :: rcode

     rcode = nf_def_var(ncid, trim(name), type, 1, dim, define_var_1d)
    call error_handler('error in defining variable '//trim(name) , rcode)  


  end function define_var_1d

  !#####################################################################
  function define_var_2d(ncid, name, type, dim )
    integer,               intent(in) :: ncid, type
    character(len=*),      intent(in) :: name
    integer, dimension(:), intent(in) :: dim
    integer                           :: define_var_2d

    integer                           :: rcode

     rcode = nf_def_var(ncid, trim(name), type, 2, dim, define_var_2d)
    call error_handler('error in defining variable '//trim(name) , rcode)  


  end function define_var_2d

  !#####################################################################

  function define_var_3d(ncid, name, type, dim )
    integer,               intent(in) :: ncid, type
    character(len=*),      intent(in) :: name
    integer, dimension(:), intent(in) :: dim
    integer                           :: define_var_3d

    integer                           :: rcode

     rcode = nf_def_var(ncid, trim(name), type, 3, dim, define_var_3d)
    call error_handler('error in defining variable '//trim(name) , rcode)  


  end function define_var_3d

  !#####################################################################

  subroutine get_var_level_2d(file, field, level, data )
     character(len=*), intent(in) :: file, field
     integer,          intent(in) :: level
     real,            intent(out) :: data(:,:)
    
     integer :: start(4), nread(4), ncid, rcode, id_fld, nlon, nlat

    nlon = size(data,1)
    nlat = size(data,2)

    rcode = nf_open(trim(file), NF_NOWRITE, ncid) 
    call error_handler('error in opening file '//trim(file), rcode) 

    rcode = nf_inq_varid(ncid, trim(field), id_fld )
    call error_handler('error in inquiring variable id of '//trim(field), rcode) 

    start = 1; nread = 1
    nread(1) = nlon; nread(2) = nlat
    start(3) = level
    rcode = nf_get_vara_double(ncid, id_fld, start, nread, data)
    call error_handler('Error in reading the data ', rcode)

    rcode = nf_close(ncid)

  end subroutine get_var_level_2d

  !#####################################################################
  subroutine put_att_text(ncid, id_fld, name, cval)
    integer,          intent(in) :: ncid, id_fld
    character(len=*), intent(in) :: name, cval

    integer                      :: rcode 

    rcode = nf_put_att_text(ncid,id_fld, trim(name),len_trim(cval), trim(cval) )
    call error_handler('error in putting attribute '//trim(name) , rcode)  

  end subroutine put_att_text
 
  !#####################################################################

  subroutine put_att_real(ncid, id_fld, name, rval)
    integer,          intent(in) :: ncid, id_fld
    character(len=*), intent(in) :: name
    real,             intent(in) :: rval

    integer                      :: rcode 

    rcode = nf_put_att_double(ncid,id_fld, trim(name), NF_DOUBLE, 1, rval )
    call error_handler('error in putting attribute '//trim(name) , rcode)  

  end subroutine put_att_real
 
  !#####################################################################

  subroutine put_var_real_1d(ncid, varid, data)
     integer,            intent(in) :: ncid, varid
     real, dimension(:), intent(in) :: data
     integer :: rcode, start(4), nwrite(4)

     start = 1; nwrite = 1;
     nwrite(1) = size(data)
     rcode = nf_put_vara_double(ncid, varid, start, nwrite, data)
     call error_handler('Error in put real 1d data', rcode )
     

  end subroutine  put_var_real_1d

  !#####################################################################
  subroutine put_var_level_0d(ncid, id_fld, level, data)
    integer, intent(in) :: ncid, id_fld, level
    real,    intent(in) :: data

    integer :: rcode

    rcode = nf_put_var1_double(ncid, id_fld, level, data)
    call error_handler('error in putting scalar data', rcode)

  end subroutine put_var_level_0d

  !#####################################################################

  subroutine put_var_level_1d(ncid, id_fld, level, data)
    integer, intent(in) :: ncid, id_fld, level
    real,    intent(in) :: data(:)

    integer :: nwrite(4), start(4), rcode

    start  = 1;  nwrite = 1 
    start(2)  = level; nwrite(1) = size(data)

    rcode = nf_put_vara_double(ncid, id_fld, start, nwrite, data)
    call error_handler('error in putting 1d data', rcode)

  end subroutine put_var_level_1d

  !#####################################################################
  subroutine put_var_level_2d(ncid, id_fld, level, data)
    integer, intent(in) :: ncid, id_fld, level
    real,    intent(in) :: data(:,:)

    integer             :: rcode, start(4), nwrite(4)

    start = 1; nwrite = 1;
    start(3) = level
    nwrite(1) = size(data,1); nwrite(2) = size(data,2)

    rcode = nf_put_vara_double(ncid, id_fld, start, nwrite, data)
    call error_handler('error in putting 2d data ', rcode)

  end subroutine put_var_level_2d

  !#####################################################################
  ! error handling routine.
  subroutine error_handler(mesg, status)
    character(len=*),  intent(in) :: mesg
    integer, optional, intent(in) :: status
    character(len=256) :: msg


    if(present(status)) then
       if(status == 0) return
       msg = nf_strerror(status)
       msg = trim(mesg)//': '// trim(msg)
    else
       msg = trim(mesg)
    endif

    write(stdout,*)'Error: '//trim(msg) 
    call abort()

  end subroutine error_handler

  !#####################################################################

end program regrid_hlfs

module ocean_passive_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies 
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Alistair Adcroft 
!</CONTACT>
!
!<OVERVIEW>
! Set up for idealized passive tracers. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module setups various passive tracer configurations.
! Some idealized initial conditions are provided.  
!
! These tracers are used for various idealized purposes, 
! such as tracing water mass transports, testing 
! advection schemes, etc. 
!
! These passive tracers are always initialized within 
! this module with an idealized profile. 
! No preprocessing step is required. To define a common initial condition
! for all passive tracers use the namelist "ocean_passive_nml"
! 
! This setting can be overwritten for each tracer by the namelist feature of the tracer field_table.
! For example
!
!   "namelists","ocean_mod","ocean_passive/patch"
!   restore = f
!   init_condition = temp_sq_init
!
! init_condition is one of :: 'level', 'wall','patch', 'patch_'klevel, with "klevel" an integer
!                                                       for the k-level that will place the patch. 
!                             'exponential', 'shelfbowl', 'rho_surface', 'temp_sq_init', 'salt_sq_init'
! Default is 'patch'
!
! With rho_surface' a density surface can be selected, the density value 
! is defined in the field table namelist, for example 
!
!   init_surface = 1025
!
! However, if an initial file exists for a passive tracer,
! then ocean_tracer_mod will overwrite the passive tracer
! with the tracer concentration in the initial file. In this 
! way, we can, for example, initialize a passive tracer with 
! some profile that is not readily determined via a simple 
! algorithmic procedure. 
! 
! If restoring of a passive tracer to its initial value is enabled by
! setting in the field table
!
!   restore = t
!
! the initial field is used only to find the grid cells where to restore the 
! passive tracer to the initial tracer field. Restoring is done where the tracer 
! concentration exceeds 0.00001. The inital value of passive tracers with restoring
! is always set to '1'. With the field_table namelist 
!
!   init_value = some_real
!
! this can be changed to another but also constant value. 
!
! All passive tracers in this module are dimensionless and are 
! treated the same internally to this module. However, they can 
! generally have different initial conditions and can use 
! different advection schemes. Indeed, one motivation for 
! developing this module is to test advection schemes, with 
! the same initial condition used for each of the tracers,
! but different advection schemes. In this way we can readily 
! determine the difference between advection schemes on various
! profiles within MOM.  
!
! Sample passive tracers are setup here.  The user can modify  
! code in a straightforward manner to change the number of
! passive tracers and/or the initial profiles.  
! 
! </DESCRIPTION>
!
!<NAMELIST NAME="ocean_passive_nml">
!
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging the module.
!  </DATA>
!
!  <DATA NAME="common_init_condition" TYPE="character">
!  Default for the tracer initial conditions.
!
!  Options are the following:
!  common_init_condition='level'
!  common_init_condition='wall'
!  common_init_condition='patch'
!  common_init_condition='patch_'klevel, with "klevel" an integer
!                         for the k-level that will place the patch. 
!  common_init_condition='exponential'
!  common_init_condition='shelfbowl'
!  common_init_condition='rho_surface'
!  common_init_condition='temp_sq_init'
!  common_init_condition='salt_sq_init'
!  Default=common_init_condition='patch'
!  </DATA>
!
!  <DATA NAME="layer_value" TYPE="real">
!  Value of tracer concentration within the layer. 
!  Default=1.0.
!  </DATA>
!  <DATA NAME="layer_ztop" TYPE="real">
!  Depth at the top of the tracer layer. 
!  </DATA>
!  <DATA NAME="layer_zbot" TYPE="real">
!  Depth at the bottom of the tracer layer. 
!  </DATA>
!  <DATA NAME="patch_init_klevel_gaussian" TYPE="logical">
!  To initialize on the klevel with a gaussian region.  
!  Default=patch_init_klevel_gaussian=.false.
!  </DATA>
!
!  <DATA NAME="wall_value" TYPE="real">
!  Value of tracer concentration within the wall. 
!  Default=1.0.
!  </DATA>
!  <DATA NAME="wall_ratio_south" TYPE="real">
!  Ratio of the full j-range, northward of which 
!  we place the wall. 
!  </DATA>
!  <DATA NAME="wall_ratio_north" TYPE="real">
!  Ratio of the full j-range, southward of which 
!  we place the wall. 
!  </DATA>
!
!  <DATA NAME="patch_value" TYPE="real">
!  Value of the tracer concentration within a patch. 
!  Default=1.0.
!  </DATA>
!  <DATA NAME="patch_ztop" TYPE="real">
!  Depth at the top of the tracer patch. 
!  </DATA>
!  <DATA NAME="patch_zbot" TYPE="real">
!  Depth at the bottom of the tracer patch. 
!  </DATA>
!  <DATA NAME="patch_ratio1" TYPE="real">
!  For setting position of tracer patch.
!  </DATA>
!  <DATA NAME="patch_ratio2" TYPE="real">
!  For setting position of tracer patch.
!  </DATA>
!
!  <DATA NAME="efold_depth" TYPE="real" UNITS="metre">
!  The efolding depth used for exponential tracer profile. 
!  Default=1000.0.
!  </DATA>
!  <DATA NAME="exponential_value" TYPE="real" UNITS="dimensionless">
!  The tracer value at zero depth when choosing the exponential profile.
!  Default=1.0.
!  </DATA>
!
!</NAMELIST>

use constants_mod,     only: pi
use field_manager_mod, only: fm_string_len, fm_path_name_len, fm_field_name_len
use field_manager_mod, only: fm_get_length, fm_get_value, fm_new_value
use fm_util_mod,       only: fm_util_start_namelist, fm_util_end_namelist
use fm_util_mod,       only: fm_util_set_value, fm_util_get_real, fm_util_get_logical
use fm_util_mod,       only: fm_util_get_string_array, fm_util_get_string
use fm_util_mod,       only: fm_util_check_for_bad_fields
use fms_mod,           only: write_version_number 
use fms_mod,           only: open_namelist_file, check_nml_error, close_file
use mpp_mod,           only: input_nml_file, mpp_min, mpp_max, mpp_error, FATAL, WARNING, NOTE, stdout, stdlog

use ocean_domains_mod,    only: get_local_indices
use ocean_tpm_util_mod,   only: otpm_set_prog_tracer, otpm_set_tracer_package, otpm_set_diag_tracer
use ocean_types_mod,      only: ocean_domain_type, ocean_grid_type
use ocean_types_mod,      only: ocean_options_type
use ocean_types_mod,      only: ocean_prog_tracer_type, ocean_diag_tracer_type

implicit none

private

#include <ocean_memory.h>

type(ocean_domain_type), pointer :: Dom =>NULL()
type(ocean_grid_type), pointer   :: Grd =>NULL()

character(len=128) :: version=&
       '$Id: ocean_passive.F90,v 20.0 2013/12/14 00:17:02 fms Exp $'
character (len=128) :: tagname = &
       '$Name: tikal $'

public ocean_passive_init
public passive_tracer_init
public ocean_passive_tracer_init
public update_tracer_passive

private layer_init
private wall_init
private patch_init
private patch_init_klevel
private exponential_init
private shelfbowl_init

type passive_type
  real, allocatable , dimension(:,:,:) :: mask
  character(len=fm_field_name_len) :: name
  character(len=128)               :: init_condition
  integer                          :: index, diag_index
  real                             :: init_surface
  real                             :: init_value
  logical                          :: restore
end type passive_type
type(passive_type), dimension(:), allocatable, save :: passive

integer :: index_temp =-1
integer :: index_salt =-1  


! defaults for the passive tracer package 

integer, parameter                          :: num_types = 1
character(len=fm_field_name_len), parameter :: package_name     = 'ocean_passive'
character(len=48), parameter                :: mod_name         = 'ocean_passive_mod'
character(len=fm_string_len), parameter     :: default_restart_file = 'ocean_passive.res.nc'

! logical set according to tracer table 
logical :: use_tracer_sq=.false.
logical :: use_tracer_restore=.false.

! set min/max tracer concentration 
! if solution falls outside this range, model will be 
! gracefully brought down.
real :: t_min=-1e6
real :: t_max= 1e6

! min/max tracer concentration beyond which employ upwind 
! advection if set limit_tracer_range_quick=.true.
! (set in ocean_tracer_advect_nml) and/or 
! horizontal diffusion if limit_tracer_range_neutral=.true. 
! (set in ocean_neutral_physics_nml)
real :: t_min_limit=-.10
real :: t_max_limit=1.0

! number of passive tracers 
integer :: instances

! for setting the passive tracer package 
integer :: package_index

logical :: module_is_initialized=.false.
logical :: use_this_module=.false.

! nml settings 
logical :: debug_this_module = .false.

! options are 'patch', 'patch_'klevel, 'layer', 'wall', 'exponential', and 'shelfbowl'
character(len=32) :: common_init_condition='patch'   

real :: layer_value = 1.0
real :: layer_ztop  = 100.0 ! metres
real :: layer_zbot  = 200.0 ! metres

real :: wall_value       = 1.0
real :: wall_ratio_south = 0.33333 
real :: wall_ratio_north = 0.66666 

real :: patch_value  = 1.0    
real :: patch_ztop   = 0.0    ! metres
real :: patch_zbot   = 200.0  ! metres
real :: patch_ratio1 = 0.33333
real :: patch_ratio2 = 0.66666
logical :: patch_init_klevel_gaussian=.false.

real :: shelfbowl_north = 70.0 ! latitude
real :: shelf_value     = 1.0 

real :: efold_depth       = 1000.0  ! metres 
real :: exponential_value = 1.0

namelist /ocean_passive_nml/ debug_this_module, common_init_condition,                        &
                             layer_value, layer_ztop, layer_zbot,                             &   
                             wall_value, wall_ratio_south, wall_ratio_north,                  &   
                             patch_value, patch_ztop, patch_zbot, patch_ratio1, patch_ratio2, &   
                             patch_init_klevel_gaussian, efold_depth, exponential_value,      &
                             shelfbowl_north, shelf_value
contains


!#######################################################################
! <SUBROUTINE NAME="ocean_passive_init">
!
! <DESCRIPTION>
! Initialize the indices for passive tracer fields. 
! This routine is called by ocean_model.F90.
! </DESCRIPTION>
!
subroutine ocean_passive_init(Domain, Grid, Ocean_options, debug)

  type(ocean_domain_type),  intent(in), target   :: Domain
  type(ocean_grid_type),    intent(in), target   :: Grid
  type(ocean_options_type), intent(inout)        :: Ocean_options
  logical,                  intent(in), optional :: debug
  integer                                        :: ioun, io_status, ierr

! -------------------------------------------------------------------------
! start of tracer package material

  ! local parameters 
  character(len=64), parameter :: sub_name = 'ocean_passive_init'
  character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
  character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

  ! local variables 
  integer                                             :: n
  character(len=fm_field_name_len)                    :: name
  character(len=fm_path_name_len)                     :: path_to_names
  character(len=fm_field_name_len+1)                  :: suffix
  character(len=fm_field_name_len+3)                  :: long_suffix
  character(len=256)                                  :: caller_str
  character(len=fm_string_len), pointer, dimension(:) :: good_list
   
  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then
      call mpp_error(FATAL, '==>Error in ocean_passive_mod (ocean_passive_init): module initialized.')
  endif
  module_is_initialized=.true.

  ! initialize the ocean passive tracer package and set some defaults. 
  ! each of these defaults can be altered via entries to the field_table. 
  package_index = otpm_set_tracer_package(package_name,                             &
     units = 'dimensionless', min_tracer=t_min, max_tracer=t_max,                   &
     min_tracer_limit=t_min_limit, max_tracer_limit=t_max_limit,                    &
     restart_file=default_restart_file,                                             &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')',                       &
     conversion=1.0, offset=0.0, min_range=-10.0, max_range=100.0,                  &
     flux_units = 'dimensionless', min_flux_range=-1.0e+16, max_flux_range=1.0e+16, &
     vert_adv_scheme='mdppm', horiz_adv_scheme='mdppm', psom_limit=.true.)

  ! check for number of entries in the field_table for passive tracers.  
  path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
  instances = fm_get_length(path_to_names)
  if (instances < 0) then  
    call mpp_error( &
    FATAL, trim(error_header) // ' Could not get number of passive tracer instances.')
  endif  

  ! determine whether to use this module. 
  write (stdoutunit,*) ' '
  if(instances==0) then  
    write (stdoutunit,*) trim(note_header), ' No instances of passive tracers in field_table.'
    use_this_module=.false.
    write(stdoutunit,'(a)') ' '
    write(stdoutunit,'(a)') &
    '==>Note: NOT running with idealized passive tracers.'  
    call mpp_error(NOTE, '==>Note: ocean_passive_mod: NOT using idealized passive tracer module.')
    Ocean_options%passive_tracers = 'Did NOT use the idealized passive tracer module.'
    return 
  else  
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instances of passive tracers in field_table.'
    use_this_module=.true.
    Ocean_options%passive_tracers = 'Ran with idealized passive tracer module.'
  endif  

  ! allocate the passive array
  allocate (passive(instances))

  ! loop over the names of the passive tracers, saving them into the passive array
  do n=1,instances  
     if (fm_get_value(path_to_names, name, index = n)) then  
         passive(n)%name = name
     else 
         write (name,*) n
         call mpp_error(FATAL, trim(error_header) //        &
              ' Bad field name for index ' // trim(name))
     endif
  enddo

  ! determine the tracer name for this instance, 
  ! and set the prog tracer through otpm_set_prog_tracer
  do n=1,instances  
     name = passive(n)%name
     if (name(1:1) .eq. '_') then  
         suffix = ' '
         long_suffix = ' '
     else  
         suffix = '_' // name
         long_suffix = ' (' // trim(name) // ')'
     endif
     passive(n)%index = otpm_set_prog_tracer('passive' // trim(suffix), package_name, &
          longname = 'passive' // trim(long_suffix),                                  &
          caller = trim(mod_name)//'('//trim(sub_name)//')')
  enddo

  ! add the package name to the list of good namelists; used later for consistency check
  if (fm_new_value('/ocean_mod/GOOD/good_namelists', package_name, append = .true.) .le. 0) then 
    call mpp_error(FATAL, trim(error_header) //                           &
        ' Could not add ' // trim(package_name) // ' to "good_namelists" list')
  endif 
 
  ! set defaults for the available namelist parameters 
  caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'
  do n=1,instances  
     call fm_util_start_namelist(package_name, passive(n)%name, caller=caller_str, &
                                 no_overwrite=.true., check=.true.)
     call fm_util_set_value('init_condition', 'patch')
     call fm_util_set_value('init_surface', 1030.0)
     call fm_util_set_value('init_value', 1.0)
     call fm_util_set_value('restore', .false.)
     call fm_util_end_namelist(package_name, passive(n)%name, check = .true., caller = caller_str)
  enddo

  ! check for errors in number of fields in the namelists for this package
  good_list => fm_util_get_string_array('/ocean_mod/GOOD/namelists/' // trim(package_name) // '/good_values',   &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')
  if (associated(good_list)) then  
      call fm_util_check_for_bad_fields('/ocean_mod/namelists/' // trim(package_name), good_list,       &
           caller = trim(mod_name) // '(' // trim(sub_name) // ')')
      deallocate(good_list)
  else  
      call mpp_error(FATAL,trim(error_header) // ' Empty "' // trim(package_name) // '" list')
  endif

! end of tracer package material
! -------------------------------------------------------------------------

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
#endif

  Dom => Domain
  Grd => Grid

  call write_version_number(version, tagname)

  ! provide for namelist override of defaults
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_passive_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_passive_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_passive_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status, 'ocean_passive_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_passive_nml)
  write (stdlogunit,ocean_passive_nml)

  if (PRESENT(debug) .and. .not. debug_this_module) then
      debug_this_module = debug
  endif
  if(debug_this_module) then 
      write(stdoutunit,'(a)') '==>Note: running ocean_passive with debug_this_module=.true.'  
  endif

  ! set default initial condition according to setting in ocean_passive_nml
  do n=1,instances
     passive(n)%init_condition = trim(common_init_condition)
  enddo

  ! namelist information for each passive tracer from the field_table. 
  ! in particular, can override the common_init_condition so that each 
  ! tracer can, for example, have a distinct initial condition.  
  caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'
  do n=1,instances
     call fm_util_start_namelist(package_name, passive(n)%name, caller = caller_str)
     passive(n)%init_condition =  fm_util_get_string ('init_condition', scalar = .true.)
     passive(n)%init_surface   =  fm_util_get_real('init_surface', scalar = .true.)
     passive(n)%init_value     =  fm_util_get_real('init_value', scalar = .true.)
     passive(n)%restore        =  fm_util_get_logical('restore', scalar = .true.)
     call fm_util_end_namelist(package_name, passive(n)%name, caller = caller_str)
  enddo
  do n=1,instances
     if (passive(n)%restore ) then
        name = passive(n)%name
        if (name(1:1) .eq. '_') then  
           suffix = ' '
           long_suffix = ' '
        else  
           suffix = '_' // name
           long_suffix = ' (' // trim(name) // ')'
        endif
        passive(n)%diag_index = otpm_set_diag_tracer('passive' // trim(suffix) // 'mask',         &
           longname = 'passive' // trim(long_suffix), restart_file='ocean_passive_masks.res.nc',  &
           min_range=-1.0, max_range=2.0, const_init_tracer=.true.,const_init_value=0.0,          &
           caller = caller_str )
        use_tracer_restore=.true.
     endif
  enddo


end subroutine ocean_passive_init
! </SUBROUTINE> NAME="ocean_passive_init"


!#######################################################################
! <SUBROUTINE NAME="passive_tracer_init">
!
! <DESCRIPTION>
! Initialize profiles for the passive tracers.
! This routine is called by ocean_tracer.F90.
! </DESCRIPTION>
!
subroutine passive_tracer_init(time_init, Tracer, initialize_as_a_passive_tracer)

  logical,                      intent(in)    :: time_init
  type(ocean_prog_tracer_type), intent(inout) :: Tracer
  logical,                      intent(inout) :: initialize_as_a_passive_tracer

  integer :: i,j,k,n

  integer :: stdoutunit 
  stdoutunit=stdout() 

  initialize_as_a_passive_tracer=.false.
  if(.not. use_this_module) return 
  if(.not. time_init) return 

  do n=1,instances 

        if(trim(Tracer%name)=='passive_'//trim(passive(n)%name)) then 
            initialize_as_a_passive_tracer=.true.

            if(trim(passive(n)%init_condition)=='layer') then 
                call layer_init(Tracer%field(:,:,:,1))
                write(stdoutunit,'(a)') '==>From passive_tracer_init: initialized tracer '&
                     //trim(passive(n)%name)//' with "layer" profile.' 
            elseif(trim(passive(n)%init_condition)=='wall') then  
                call wall_init(Tracer%field(:,:,:,1))
                write(stdoutunit,'(a)') '==>From passive_tracer_init: initialized tracer '&
                     //trim(passive(n)%name)//' with "wall" profile.' 
            elseif(trim(passive(n)%init_condition)=='patch') then  
                call patch_init(Tracer%field(:,:,:,1))
                write(stdoutunit,'(a)') '==>From passive_tracer_init: initialized tracer '&
                     //trim(passive(n)%name)//' with "patch" profile.' 
            elseif(trim(passive(n)%init_condition)=='patch_klevel') then  
                call patch_init_klevel(Tracer%field(:,:,:,1),trim(Tracer%name))
                write(stdoutunit,'(a)') '==>From passive_tracer_init: initialized tracer '&
                     //trim(passive(n)%name)//' with "patch_klevel" profile, w/ patch on single k-level.' 
            elseif(trim(passive(n)%init_condition)=='exponential') then  
                call exponential_init(Tracer%field(:,:,:,1))
                write(stdoutunit,'(a)') '==>From passive_tracer_init: initialized tracer '&
                     //trim(passive(n)%name)//' with "exponential" profile.' 
            elseif(trim(passive(n)%init_condition)=='shelfbowl') then  
                call shelfbowl_init(Tracer%field(:,:,:,1))
                write(stdoutunit,'(a)') '==>From passive_tracer_init: initialized tracer '&
                     //trim(passive(n)%name)//' with "shelfbowl" profile.' 
            elseif(     trim(passive(n)%init_condition(1:4))=='temp') then 
                write(stdoutunit,'(a)') &
                  '==>From passive_tracer_init: tracer to be initialized after initialize temp.'
            elseif(     trim(passive(n)%init_condition(1:3))=='rho') then 
                write(stdoutunit,'(a)') &
                  '==>From passive_tracer_init: tracer to be initialized after initialize density.'
            elseif(     trim(passive(n)%init_condition(1:12))=='temp_sq_init') then 
                write(stdoutunit,'(a)') &
                  '==>From passive_tracer_init: tracer to be initialized after initialize temp.'
            elseif(     trim(passive(n)%init_condition(1:12))=='salt_sq_init') then 
                write(stdoutunit,'(a)') &
                  '==>From passive_tracer_init: tracer to be initialized after initialize salinity.'
            else
                write(stdoutunit,'(a)') &
                '==>Error in passive_tracer_init: tracer '//trim(Tracer%name)// ' is not initialized.'
                call mpp_error(FATAL, &
                 '==>Error in passive_tracer_init: passive tracer not initialized.')
            endif 
            do k=1,nk
               do j=jsd,jed
                  do i=isd,ied
                     Tracer%field(i,j,k,2) = Tracer%field(i,j,k,1)
                     Tracer%field(i,j,k,3) = Tracer%field(i,j,k,1)
                  enddo
               enddo
            enddo

        endif

  enddo


end subroutine passive_tracer_init
! </SUBROUTINE> NAME="passive_tracer_init"

!#######################################################################
! <SUBROUTINE NAME="ocean_passive_tracer_init">
!
! <DESCRIPTION>
! Initialize restoring to initial values for the passive tracers.
!
! or
! Initialize profiles for the passive tracers which are tagged with 
! specific values of the temperature field or potential density field.
!
! or
! Initialize profiles for the passive tracers which are defined 
! as the temperature or salinity squared. These tracers are used
! for diagnosing the level of spurious mixing associated with 
! PSOM advection.  
! </DESCRIPTION>
!
subroutine ocean_passive_tracer_init(T_prog, T_diag, rho, &
                                     time_init, tau, num_prog_tracers, i_temp, i_salt)

  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_diag_tracer_type), intent(inout) :: T_diag(:)
  real, dimension(isd:,jsd:,:), intent(in)    :: rho
  logical,                      intent(in)    :: time_init
  integer,                      intent(in)    :: tau, num_prog_tracers, i_temp, i_salt

  integer :: i,j,k,n,nt
  real    :: isotherm, isorho

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return 
  if(.not. time_init) return 
  
  index_temp = i_temp
  index_salt = i_salt
  
  do nt=1,num_prog_tracers 
     do n=1,instances 
        
        if(trim(T_prog(nt)%name)=='passive_'//trim(passive(n)%name)) then 

           if( passive(n)%restore ) then 

              T_diag(passive(n)%diag_index)%field = 0.
              do k=1,nk
                do j=jsd,jed
                  do i=isd,ied
                     if (T_prog(nt)%field(i,j,k,tau) > 0.00001) then 
                        ! set a mask to 1 if restoring is required
                        T_diag(passive(n)%diag_index)%field(i,j,k) = 1.
                        T_prog(nt)%field(i,j,k,1) = passive(n)%init_value
                        T_prog(nt)%field(i,j,k,2) = passive(n)%init_value
                        T_prog(nt)%field(i,j,k,3) = passive(n)%init_value
                     endif
                  enddo
                enddo
              enddo
              write(stdoutunit,'(a)') &
                '==>From passive_tracer_init: restore '//trim(T_prog(nt)%name)// ' to initial conditions.'
           else
              write(stdoutunit,'(a)') &
                '==>From passive_tracer_init: do not restore '//trim(T_prog(nt)%name)// ' to initial conditions.'
           endif 


           ! Initialize profiles for the passive tracers which are tagged with 
           ! specific values of the temperature field or potential density field.
           if(trim(passive(n)%init_condition)=='temp_surface') then 
              isotherm=passive(n)%init_surface
              call surface_init(isotherm, 'temp', T_prog(index_temp)%field(:,:,:,tau), & 
                   T_prog(nt)%field(:,:,:,1))
              write(stdoutunit,'(a,a,a,f12.3)')                                        &
                '==>From passive_tracer_surface_init: passive tracer ',T_prog(nt)%name,&
                ' initialized to isotherm (C) = ',isotherm
              write(stdoutunit,'(a)') ' '
              do k=1,nk
                do j=jsd,jed
                   do i=isd,ied
                      T_prog(nt)%field(i,j,k,2) = T_prog(nt)%field(i,j,k,1)
                      T_prog(nt)%field(i,j,k,3) = T_prog(nt)%field(i,j,k,1)
                   enddo
                enddo
             enddo
          endif
           if(trim(passive(n)%init_condition)=='rho_surface') then 
             isorho=passive(n)%init_surface
             call surface_init(isorho, 'rho', rho, T_prog(nt)%field(:,:,:,1))
             write(stdoutunit,'(a,a,a,f12.3)')                                        &
                '==>From passive_tracer_surface_init: passive tracer ',T_prog(nt)%name,&
                ' initialized to neutral rho (kg/m^3) = ',isorho
             write(stdoutunit,'(a)') ' '
             do k=1,nk
               do j=jsd,jed
                  do i=isd,ied
                     T_prog(nt)%field(i,j,k,2) = T_prog(nt)%field(i,j,k,1)
                     T_prog(nt)%field(i,j,k,3) = T_prog(nt)%field(i,j,k,1)
                  enddo
               enddo
             enddo
           endif

           ! Initialize profiles for the passive tracers which are defined 
           ! as the temperature or salinity squared. These tracers are used
           ! for diagnosing the level of spurious mixing associated with 
           ! PSOM advection.  
           if(trim(passive(n)%init_condition)=='temp_sq_init') then 
               do k=1,nk
                  do j=jsd,jed
                     do i=isd,ied
                        T_prog(nt)%field(i,j,k,1)   = T_prog(index_temp)%field(i,j,k,tau)**2
                        T_prog(nt)%field(i,j,k,2)   = T_prog(nt)%field(i,j,k,1)
                        T_prog(nt)%field(i,j,k,3)   = T_prog(nt)%field(i,j,k,1)
                        T_prog(nt)%units            = '(deg C)^2'
                     enddo
                  enddo
               enddo
               write(stdoutunit,'(a,a,a)')                                    &
                    '==>From ocean_tracer_sq_init: tracer ',T_prog(nt)%name,&
                    ' initialized to squared temp (degC^2)'
               write(stdoutunit,'(a)') ' '
               use_tracer_sq=.true.
           endif

           if(trim(passive(n)%init_condition)=='salt_sq_init') then 
               do k=1,nk
                  do j=jsd,jed
                     do i=isd,ied
                        T_prog(nt)%field(i,j,k,1)   = T_prog(index_salt)%field(i,j,k,tau)**2
                        T_prog(nt)%field(i,j,k,2)   = T_prog(nt)%field(i,j,k,1)
                        T_prog(nt)%field(i,j,k,3)   = T_prog(nt)%field(i,j,k,1)
                        T_prog(nt)%units            = '(psu)^2'
                     enddo
                  enddo
               enddo
               write(stdoutunit,'(a,a,a)')                                    &
                    '==>From ocean_tracer_sq_init: tracer ',T_prog(nt)%name,&
                    ' initialized to squared salinity (psu^2)'
               write(stdoutunit,'(a)') ' '
               use_tracer_sq=.true.
           endif

        endif
     enddo    !!n=1,instances 
  enddo       !!nt=1,num_prog_tracers


end subroutine ocean_passive_tracer_init
! </SUBROUTINE> NAME="ocean_passive_tracer_init"


!#######################################################################
! <SUBROUTINE NAME="surface_init">
!
! <DESCRIPTION>
! Initialize passive tracer according to a particular iso-surface.
! </DESCRIPTION>
!
subroutine surface_init(isovalue, surface_name, surface_field, passive_field)

  real, intent(in)                            :: isovalue
  character(len=*), intent(in)                :: surface_name
  real, intent(in)   , dimension(isd:,jsd:,:) :: surface_field
  real, intent(inout), dimension(isd:,jsd:,:) :: passive_field

  integer :: i, j, k

  passive_field(:,:,:) = 0.0

  if(trim(surface_name)=='rho') then 
      do k=1,nk-1
         do j=jsd,jed
            do i=isd,ied
               if(surface_field(i,j,k) <= isovalue .and. surface_field(i,j,k+1) > isovalue) then 
                   passive_field(i,j,k) = Grd%tmask(i,j,k+1)
               endif
            enddo
         enddo
      enddo
  elseif(trim(surface_name)=='temp') then
      do k=1,nk-1
         do j=jsd,jed
            do i=isd,ied
               if(surface_field(i,j,k) >= isovalue .and. surface_field(i,j,k+1) < isovalue) then 
                   passive_field(i,j,k) = Grd%tmask(i,j,k+1)
               endif
            enddo
         enddo
      enddo
  endif

end subroutine surface_init
! </SUBROUTINE> NAME="surface_init"


!#######################################################################
! <SUBROUTINE NAME="layer_init">
!
! <DESCRIPTION>
!
! Initialize tracer inside a depth layer to have a value, and
! zero outside the layer. 
!
! </DESCRIPTION>
!
subroutine layer_init(field)

  real, intent(inout), dimension(isd:,jsd:,:) :: field 

  integer :: i, j, k

  field(:,:,:) = 0.0

  do k=1,nk
     if(Grd%zt(k) >=layer_ztop .and. Grd%zt(k) <= layer_zbot) then 
         do j=jsd,jed
            do i=isd,ied
               field(i,j,k) = layer_value
            enddo
         enddo
     endif
  enddo

end subroutine layer_init
! </SUBROUTINE> NAME="layer_init"


!#######################################################################
! <SUBROUTINE NAME="wall_init">
!
! <DESCRIPTION>
!
! Initialize tracer inside an (i,k) wall to have a value, and
! zero outside the wall. 
!
! </DESCRIPTION>
!
subroutine wall_init(field)

  real, intent(inout), dimension(isd:,jsd:,:) :: field 

  integer :: i, j, k
  integer :: jsouth, jnorth

  jsouth = int(wall_ratio_south*Grd%nj)
  jnorth = int(wall_ratio_north*Grd%nj)

  field(:,:,:) = 0.0

  do j=jsd,jed
     if(j+Dom%joff >= jsouth .and. j+Dom%joff <= jnorth) then                 
         do k=1,nk
            do i=isd,ied
               field(i,j,k) = wall_value
            enddo
         enddo
     endif
  enddo

end subroutine wall_init
! </SUBROUTINE> NAME="wall_init"


!#######################################################################
! <SUBROUTINE NAME="patch_init">
!
! <DESCRIPTION>
!
! Initialize tracer with simple shapes based on vertical layer:
!  Level k=1, square pill box
!  Level k=2, circular pill box (cylinder)
!  Level k=3, circular cone
!  Level k=4, cosine bell
!  Level k=5, Gaussian bell
!  Levels k>5, square patch based on i,j coordinates (original "patch").
!
! </DESCRIPTION>
!
subroutine patch_init(field)

  real, intent(inout), dimension(isd:,jsd:,:) :: field 

  integer :: i, j, k
  integer :: iwest, ieast
  integer :: jsouth, jnorth
  real    :: x_min,x_max,y_min,y_max
  real    :: x_mid,y_mid,xnd,ynd,scl,rr

  integer :: stdoutunit 
  stdoutunit=stdout() 

  x_min = minval( Grd%xu(:,:) )
  call mpp_min(x_min)
  x_max = maxval( Grd%xu(:,:) )
  call mpp_max(x_max)

  y_min = minval( Grd%yu(:,:) )
  call mpp_min(y_min)
  y_max = maxval( Grd%yu(:,:) )
  call mpp_max(y_max)

  scl = 0.5 * ( patch_ratio2 - patch_ratio1 )
  x_mid = x_min + 0.5 * ( patch_ratio1 + patch_ratio2 ) * ( x_max - x_min )
  y_mid = y_min + 0.5 * ( patch_ratio1 + patch_ratio2 ) * ( y_max - y_min )

  field(:,:,:) = 0.0

  iwest  = int(patch_ratio1*Grd%ni)
  ieast  = int(patch_ratio2*Grd%ni)
  jsouth = int(patch_ratio1*Grd%nj)
  jnorth = int(patch_ratio2*Grd%nj)

  ! Discontinuous square box for all k-levels (levels k=1,5 over-written below)
  do k=1,nk
     if(Grd%zt(k) >=patch_ztop .and. Grd%zt(k) <= patch_zbot) then
         do j=jsd,jed
            do i=isd,ied
               if(i+Dom%ioff  >= iwest  .and. i+Dom%ioff <= ieast   .and. &
                  j+Dom%joff  >= jsouth .and. j+Dom%joff <= jnorth ) then
                   field(i,j,k) = patch_value
               endif
            enddo
         enddo
     endif
  enddo

  write(stdoutunit,*) 'passive_init: ',iwest,ieast,jsouth,jnorth
  write(stdoutunit,*) 'passive_init: ',x_min,x_max
  write(stdoutunit,*) 'passive_init: ',y_min,y_max
  write(stdoutunit,*) 'passive_init: ',x_mid,y_mid
  write(stdoutunit,*) 'passive_init: ',scl

  ! k=1: Discontinuous square box
  k=1
  if (nk.ge.k) then
      do j=jsd,jed
         do i=isd,ied
            xnd = 1.-abs(Grd%xt(i,j)-x_mid)/(x_max-x_min)/scl
            ynd = 1.-abs(Grd%yt(i,j)-y_mid)/(y_max-y_min)/scl
            field(i,j,k) = patch_value * max( 0., sign( 1., xnd ) )  &
                                       * max( 0., sign( 1., ynd ) )
         enddo
      enddo
  endif ! k

  ! k=2: Discontinuous circular box (cylinder)
  k=2
  if (nk.ge.k) then
      do j=jsd,jed
         do i=isd,ied
            xnd = (Grd%xt(i,j)-x_mid)/(x_max-x_min)
            ynd = (Grd%yt(i,j)-y_mid)/(y_max-y_min)
            rr  = 1.-sqrt( xnd**2  + ynd**2 )/scl
            field(i,j,k) = patch_value * max( 0., sign( 1., rr ) )
         enddo
      enddo
  endif ! k

  ! k=3: Circular cone
  k=3
  if (nk.ge.k) then
      do j=jsd,jed
         do i=isd,ied
            xnd = (Grd%xt(i,j)-x_mid)/(x_max-x_min)
            ynd = (Grd%yt(i,j)-y_mid)/(y_max-y_min)
            rr  = sqrt( xnd**2  + ynd**2 )
            field(i,j,k) = patch_value * max( 0., 1.-0.5*rr/scl )
         enddo
      enddo
  endif ! k

  ! k=4: Circular cosine bell
  k=4
  if (nk.ge.k) then
      do j=jsd,jed
         do i=isd,ied
            xnd = (Grd%xt(i,j)-x_mid)/(x_max-x_min)
            ynd = (Grd%yt(i,j)-y_mid)/(y_max-y_min)
            rr  = sqrt( xnd**2  + ynd**2 )
            field(i,j,k) = patch_value * 0.5 * ( 1.0+cos(2.*pi*min(0.5,0.25*rr/scl)) )
         enddo
      enddo
  endif ! k

  ! k=5: Circular Gaussian (with 2.5 sigma inside patch)
  k=5
  if (nk.ge.k) then
      do j=jsd,jed
         do i=isd,ied
            xnd = (Grd%xt(i,j)-x_mid)/(x_max-x_min)
            ynd = (Grd%yt(i,j)-y_mid)/(y_max-y_min)
            rr  = sqrt( xnd**2  + ynd**2 )
            field(i,j,k) = patch_value * ( max(0.001, 1.001*exp(-(1.*rr/scl)**2) ) - 0.001 )
         enddo
      enddo
  endif ! k


end subroutine patch_init
! </SUBROUTINE> NAME="patch_init"


!#######################################################################
! <SUBROUTINE NAME="patch_init_klevel">
!
! <DESCRIPTION>
! Initialize tracer with gaussian patch or constant on a level,
! both on a single k-level 
! </DESCRIPTION>
!
subroutine patch_init_klevel(field, name)

  real, dimension(isd:,jsd:,:), intent(inout) :: field 
  character(len=*),             intent(in)    :: name 

  integer :: i, j, n
  integer :: start, strlen, klevel, digit  
  real    :: x_min,x_max,y_min,y_max
  real    :: x_mid,y_mid,xnd,ynd,scl,rr
  logical :: fatal_flag=.false.

  integer :: stdoutunit 
  stdoutunit=stdout() 

  x_min = minval( Grd%xu(:,:) )
  call mpp_min(x_min)
  x_max = maxval( Grd%xu(:,:) )
  call mpp_max(x_max)

  y_min = minval( Grd%yu(:,:) )
  call mpp_min(y_min)
  y_max = maxval( Grd%yu(:,:) )
  call mpp_max(y_max)

  scl = 0.5 * ( patch_ratio2 - patch_ratio1 )
  x_mid = x_min + 0.5 * ( patch_ratio1 + patch_ratio2 ) * ( x_max - x_min )
  y_mid = y_min + 0.5 * ( patch_ratio1 + patch_ratio2 ) * ( y_max - y_min )

  ! determine the k-level that is to be initialized
  ! Algorithm from Zhi.Liang 
  ! start=15 is specific to "passive_patch_" having 14 characters, 
  ! so the 15th character in the name of the tracer begins the klevel.  
  ! Example: passive_patch_123. 
  ! do n=15,17
  ! when n=1, klevel=1       = 1
  ! when n=2, klevel=1*10+2  = 12
  ! when n=3, klevel=12*10+3 = 123  
  start  = 15
  strlen = len_trim(name)
  klevel = 0
  fatal_flag=.false. 
  
  write(stdoutunit,'(a)') ' Initializing passive_patch_klevel for tracer name = ',name 
  do n=start,strlen
     digit = ichar(name(n:n)) - ichar("0")
     if(digit > 9 .or. digit < 0) then 
         write(*,*)'Error: digit =  ',digit 
         fatal_flag=.true.
     endif
     klevel = klevel*10 + digit
  end do

  if(fatal_flag) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_passive_mod (patch_init_klevel): did not find a digit for klevel.')
  endif 

  ! initialize the patch at k=klevel as a circular Gaussian 
  ! (with 2.5 sigma inside patch)
  if(patch_init_klevel_gaussian) then 
      field(:,:,:) = 0.0
      do j=jsd,jed
         do i=isd,ied
            xnd = (Grd%xt(i,j)-x_mid)/(x_max-x_min)
            ynd = (Grd%yt(i,j)-y_mid)/(y_max-y_min)
            rr  = sqrt( xnd**2  + ynd**2 )
            field(i,j,klevel) = Grd%tmask(i,j,klevel) * patch_value &
                                *( max(0.001, 1.001*exp(-(1.*rr/scl)**2) ) - 0.001 )
         enddo
      enddo
  else
      do j=jsd,jed
         do i=isd,ied
            field(i,j,klevel) = patch_value*Grd%tmask(i,j,klevel)
         enddo
      enddo
  endif


end subroutine patch_init_klevel
! </SUBROUTINE> NAME="patch_init_klevel"


!#######################################################################
! <SUBROUTINE NAME="exponential_init">
!
! <DESCRIPTION>
!
! Initialize tracer with a vertical exponential profile. 
!
! </DESCRIPTION>
!
subroutine exponential_init(field)

  real, intent(inout), dimension(isd:,jsd:,:) :: field 

  integer :: i, j, k

  field(:,:,:) = 0.0

  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           field(i,j,k) = exponential_value*exp(-Grd%zt(k)/efold_depth)
        enddo
     enddo
  enddo

end subroutine exponential_init
! </SUBROUTINE> NAME="exponential_init"


!#######################################################################
! <SUBROUTINE NAME="shelfbowl_init">
!
! <DESCRIPTION>
!
! Initialize tracer as in the shelfbowl topography of use for studying
! idealized overflow problems, as in Winton etal (1998). 
!
! </DESCRIPTION>
!
subroutine shelfbowl_init(field)

  real, intent(inout), dimension(isd:,jsd:,:) :: field 

  integer :: i, j, k
  
  field(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           field(i,j,k) = 0.5*shelf_value*(1.0 + 0.5*(1.0-tanh(0.5*(Grd%yt(i,j)-shelfbowl_north))) )
        enddo
     enddo
  enddo

end subroutine shelfbowl_init
! </SUBROUTINE> NAME="shelfbowl_init"


!#######################################################################
! <SUBROUTINE NAME="update_tracer_passive">
!
! <DESCRIPTION>
! Update the squared tracer.
! Restore passive tracers.
! </DESCRIPTION>
!
subroutine update_tracer_passive(num_prog_tracers, T_prog, T_diag, dtts, taup1)

  integer,                      intent(in)    :: num_prog_tracers
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_diag_tracer_type), intent(inout) :: T_diag(:)
  real                        , intent(in)    :: dtts
  integer                     , intent(in)    :: taup1

  integer :: i,j,k,n,nt
  real    :: mask, temp_t

  if(.not. use_this_module) return 

  if(use_tracer_sq) then

     do nt=1,num_prog_tracers 

        if(trim(T_prog(nt)%name)=='passive_temp_sq') then 
            do k=1,nk
               do j=jsd,jed
                  do i=isd,ied
                     T_prog(nt)%field(i,j,k,1) = T_prog(index_temp)%field(i,j,k,1)**2
                     T_prog(nt)%field(i,j,k,2) = T_prog(index_temp)%field(i,j,k,2)**2
                     T_prog(nt)%field(i,j,k,3) = T_prog(index_temp)%field(i,j,k,3)**2
                  enddo
               enddo
            enddo
        endif
        if(trim(T_prog(nt)%name)=='passive_salt_sq') then 
            do k=1,nk
               do j=jsd,jed
                  do i=isd,ied
                     T_prog(nt)%field(i,j,k,1) = T_prog(index_salt)%field(i,j,k,1)**2
                     T_prog(nt)%field(i,j,k,2) = T_prog(index_salt)%field(i,j,k,2)**2
                     T_prog(nt)%field(i,j,k,3) = T_prog(index_salt)%field(i,j,k,3)**2
                  enddo
               enddo
            enddo
        endif 
     enddo
  endif 

  if(use_tracer_restore) then

     do nt=1,num_prog_tracers 
       
        do n=1,instances 

           if( trim(T_prog(nt)%name)=='passive_'//trim(passive(n)%name) .and. passive(n)%restore ) then 
              do k=1,nk
                do j=jsd,jed
                  do i=isd,ied

                     mask = T_diag(passive(n)%diag_index)%field(i,j,k)
                     temp_t = T_prog(nt)%field(i,j,k,taup1)
                     T_prog(nt)%field(i,j,k,taup1) = mask * passive(n)%init_value &
                          + (1.- mask) * T_prog(nt)%field(i,j,k,taup1)

                     ! store the tendency as source for computing tracer conservation diagnostics
                     T_prog(nt)%source(i,j,k) = T_prog(nt)%source(i,j,k) &
                                              + (T_prog(nt)%field(i,j,k,taup1) - temp_t)/dtts

                  enddo
                enddo
              enddo
           endif

        enddo   ! n
     enddo      ! nt

  endif 

end subroutine update_tracer_passive
! </SUBROUTINE> NAME="update_tracer_passive"


end module ocean_passive_mod

module cana_tile_mod

use land_tile_selectors_mod, only : &
     tile_selector_type
use constants_mod, only : &
     cp_air, tfreeze

implicit none
private

! ==== public interfaces =====================================================
public :: cana_prog_type
public :: cana_tile_type

public :: new_cana_tile, delete_cana_tile
public :: cana_tiles_can_be_merged, merge_cana_tiles
public :: get_cana_tile_tag
public :: cana_is_selected

public :: cana_tile_stock_pe
public :: cana_tile_carbon
public :: cana_tile_heat

! public data:
real, public :: canopy_air_mass = 0.0    ! mass of wet air in the canopy air 
                                         ! space for heat and water vapor, kg/m2
real, public :: canopy_air_mass_for_tracers = 0.0 ! mass of wet air in the canopy air 
                                         ! space for tracers other than water vapor, kg/m2
! Water vapor is bundled with heat and not with other tracers because it is
! tightly coupled with the heat capacity of the canopy air and therefore with
! the equations for heat. We assume that other tracers do not contribute to
! the heat capacity of the canopy air.
real, public :: cpw             = 1952.0 ! specific heat of water vapor at constant pressure, J/(kg K)
! ==== end of public interfaces ==============================================
interface new_cana_tile
   module procedure cana_tile_ctor
   module procedure cana_tile_copy_ctor
end interface

! ==== module constants ======================================================
character(len=*), parameter :: &
     version = '$Id: cana_tile.F90,v 18.0 2010/03/02 23:36:42 fms Exp $', &
     tagname = '$Name: tikal $'

! ==== data types ======================================================
type :: cana_prog_type
  real T
  real q
  real :: co2 ! co2 concentration in canopy air, kg CO2/kg of wet air
end type cana_prog_type

type :: cana_tile_type
   type(cana_prog_type) :: prog
end type cana_tile_type

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

! =============================================================================
function cana_tile_ctor() result(ptr)
  type(cana_tile_type), pointer :: ptr ! return value

  allocate(ptr)
end function cana_tile_ctor

! =============================================================================
function cana_tile_copy_ctor(cana) result(ptr)
  type(cana_tile_type), pointer :: ptr ! return value
  type(cana_tile_type), intent(in) :: cana ! return value

  allocate(ptr)
  ptr = cana
end function cana_tile_copy_ctor

! =============================================================================
subroutine delete_cana_tile(cana)
  type(cana_tile_type), pointer :: cana

  deallocate(cana)
end subroutine delete_cana_tile

! =============================================================================
function cana_tiles_can_be_merged(cana1,cana2) result(response)
  logical :: response
  type(cana_tile_type), intent(in) :: cana1,cana2

  response = .TRUE.
end function

! =============================================================================
subroutine merge_cana_tiles(cana1,w1,cana2,w2)
  type(cana_tile_type), intent(in)    :: cana1
  type(cana_tile_type), intent(inout) :: cana2
  real                , intent(in)    :: w1, w2
  
  ! ---- local vars
  real :: x1,x2 ! normalized weights
  real :: HEAT1, HEAT2 ! heat content of the tiles
  
  ! calculate normalized weights
  x1 = w1/(w1+w2)
  x2 = 1-x1
  HEAT1 = canopy_air_mass*(cp_air+(cpw - cp_air)*cana1%prog%q)*cana1%prog%T
  HEAT2 = canopy_air_mass*(cp_air+(cpw - cp_air)*cana2%prog%q)*cana2%prog%T

  cana2%prog%q = cana1%prog%q*x1+cana2%prog%q*x2
  if (canopy_air_mass > 0) then
     cana2%prog%T = (HEAT1*x1+HEAT2*x2)/&
          (canopy_air_mass*(cp_air+(cpw - cp_air)*cana2%prog%q))
  else
     cana2%prog%T = cana1%prog%T*x1+cana2%prog%T*x2
  endif

  cana2%prog%co2 = cana1%prog%co2*x1+cana2%prog%co2*x2
end subroutine

! =============================================================================
! returns tag of the tile
function get_cana_tile_tag(cana) result(tag)
  integer :: tag
  type(cana_tile_type), intent(in) :: cana
  
  tag = 1
end function

! =============================================================================
! returns true if tile fits the specified selector
function cana_is_selected (cana, sel)
  logical cana_is_selected
  type(tile_selector_type),  intent(in) :: sel
  type(cana_tile_type),      intent(in) :: cana

  cana_is_selected = .TRUE.
end function

! =============================================================================
subroutine cana_tile_stock_pe (cana, twd_liq, twd_sol)
  type(cana_tile_type), intent(in) :: cana
  real, intent(out) :: twd_liq, twd_sol

  twd_liq = canopy_air_mass*cana%prog%q; twd_sol = 0
end subroutine

! =============================================================================
function cana_tile_heat (cana) result(heat) ; real heat
  type(cana_tile_type), intent(in) :: cana
  
  heat = canopy_air_mass*(cp_air+(cpw - cp_air)*cana%prog%q)*(cana%prog%T-tfreeze)
end function

! =============================================================================
function cana_tile_carbon (cana) result(c) ; real c
  type(cana_tile_type), intent(in) :: cana

  c = canopy_air_mass_for_tracers * cana%prog%co2
end function 

end module cana_tile_mod

! driver for old supersource MCA and large-scale condensation routines
! Version $Id: mcm_mca_lsc.F90,v 11.0 2004/09/28 19:28:56 fms Exp $  

! TK mod 5/22/02: use mixing ratio, not spec humidity
! MS mod: use FMS values for constants rgas, grav, hl, d622

! THE FOLLOWING NOTES ARE OBSOLETE 5/22/02
! ----------------------------------------

!  TK modified to run with specific humidity as input. 
!    1) Make local copy of specific humidity input and convert to 
!         mixing ratio. 
!    2) In the precip accumulation step, make sure to
!         vertically integrate dq rather than dr.
!         (i.e., find the change in q at each level and integrate).
!    These were done for the tk1_1A test (8/15/01).

!  TK modified:
!    The mcm_mca_lsc routine outputs relative humidity (based on
!    mixing ratio) to use in cloud prediction scheme.  
!    (This replaces rh_calc functionality in the default FMS, 
!    which is based on specific humidity.)  
! ----------------------------------------


      module mcm_mca_lsc_mod

      use     fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL,   &
                             write_version_number, stdlog, close_file, &
                             open_namelist_file, check_nml_error

      use constants_mod, only: rdgas, rvgas, grav, cp_air, hlf, hlv, tfreeze

      use spectral_dynamics_mod, only: get_pk_bk, get_num_levels

      use spec_mpp_mod, only: get_grid_domain

      implicit none
      private

      public :: mcm_mca_lsc

      character(len=128) :: version = &
      '$Id: mcm_mca_lsc.F90,v 11.0 2004/09/28 19:28:56 fms Exp $'

      character(len=128) :: tagname = &
      '$Name: tikal $'

      real,allocatable,dimension(:) :: qmh,q,dqph,dq,tauran,tausno

      real,allocatable,dimension(:,:) :: psp, convq

      real,allocatable,dimension(:,:,:) :: ta,ra

!     TK mod: (analogous to ta,ra)
      real,allocatable,dimension(:,:,:) :: rh_local

      real,dimension(5102) :: etabl

      real :: rswt1,rswt2,rix

      real, parameter :: joules_per_calorie = 4.186
      real, parameter :: gm_per_kg = 1.e3
      real, parameter :: cm_per_meter = 100.

!     cpp = .24000000000000002  calories/(gram*degree K)
!     ara = .068571428571428575 calories/(gram*degree K)
      real, parameter :: cpp =    cp_air/(joules_per_calorie*gm_per_kg)
      real, parameter :: ara = rdgas/(joules_per_calorie*gm_per_kg)

!     Units of og are seconds**2/cm
      real, parameter :: og  = 1.0/(grav*cm_per_meter)

!     hlvv = 597.2288580984233  calories/gm
!     hlss = 677.01863354037266 calories/gm
      real, parameter :: hlvv =  hlv/(gm_per_kg*joules_per_calorie)
      real, parameter :: hlss = (hlv+hlf)/(gm_per_kg*joules_per_calorie)

!     d622 = .62197183098591557
      real, parameter :: d622 = rdgas/rvgas

      integer :: kx,ix,krs1,krs2,kp,km

!     nhem and ih are legacy variables from supersource.
!     I use them to provide a point of reference for those familiar with supersource.
      integer :: nhem = 1,ih=1
      logical :: do_init = .true.
      logical :: use_mixing_ratio = .false.

      namelist / mcm_mca_lsc_nml / use_mixing_ratio

      contains

!     ---------------------------------------------------------------------------------

      subroutine mcm_mca_lsc(tin,qin,p_half,tdel,qdel,rain,snow, rh_out)
      real,intent(in),dimension(:,:,:) :: tin,qin,p_half
      real,intent(out),dimension(:,:,:) :: tdel,qdel
      real,intent(out),dimension(:,:) :: rain,snow

!     TK mod:
      real,intent(out),dimension(:,:,:) :: rh_out

      integer j
      
      if (do_init) call init_mcm_mca_lsc
      do j = 1,size(p_half,2)
!        convert temperature from deg K to deg C and select slab
         ta(:,:,ih) = tin(:,j,:) - tfreeze
!        convert pressure from pascal to dynes/cm^2 and select jrow
         psp(:,ih) = p_half(:,j,size(p_half,3))*10
         
         if(use_mixing_ratio) then
           ra(:,:,ih) = qin(:,j,:)
         else
           ra(:,:,ih) = qin(:,j,:)/(1.-qin(:,j,:))
         endif
            
         call convad
         
!        calculate temperature difference (convert deg C to deg K)
         tdel(:,j,:) = ta(:,:,ih)+tfreeze-tin(:,j,:)
         if(use_mixing_ratio) then
           qdel(:,j,:) = ra(:,:,ih)-qin(:,j,:)
         else
           qdel(:,j,:) = ra(:,:,ih)/(1.+ra(:,:,ih))-qin(:,j,:)
         endif
         
!        TK mod:  Return rh_local to calling routine           
         rh_out(:,j,:) = rh_local(:,:,ih)        
         
!        use rain and snow amounts (convert cm to kg/m^2): factor of 10
!        factor of 2 comes in because tauran and tausno were multiplied by 0.5 
!        (taupre is calculated over 2dt time intervale in supersource)
         rain(:,j) = tauran(:)*10*2
         snow(:,j) = tausno(:)*10*2
      end do
      end subroutine mcm_mca_lsc
! ---------------------------------------------------------------------------------

      subroutine init_mcm_mca_lsc
      real, allocatable, dimension(:) :: pk
      integer :: is, ie, js, je, unit, io, ierr

      unit = open_namelist_file()
      ierr=1
      do while (ierr /= 0)
        read(unit, nml=mcm_mca_lsc_nml, iostat=io, end=20)
        ierr = check_nml_error (io, 'mcm_mca_lsc_nml')
      enddo
20    call close_file (unit)

      call write_version_number(version, tagname)
      if(mpp_pe() == mpp_root_pe()) write (stdlog(),nml=mcm_mca_lsc_nml)

!  ix and kx stay fixed througout run
      call get_grid_domain(is, ie, js, je)
      ix = ie - is + 1
      call get_num_levels(kx)

      if(.not.use_mixing_ratio) then
        allocate(convq(ix,kx))
      endif
      
      kp = kx + 1
      km = kx - 1
      allocate(pk(0:kx), qmh(0:kx), q(kx), dq(kx), dqph(km))
!     assume sigma levels are being used
      call get_pk_bk(pk,qmh)
      if(sum(pk) /= 0.) then
        call error_mesg('init_mcm_mca_lsc','Must be pure sigma', FATAL)
      endif
      allocate(psp(ix,1),ta(ix,kx,1),ra(ix,kx,1))
      
!     TK Mod:
      allocate(rh_local(ix,kx,1))
      
      allocate(tauran(ix),tausno(ix))
!     parmtr sets the following variables:
!     rswt1,rswt2,krs1,krs2
!     q,qmh,dq,dqph,etabl
      call parmtr
      deallocate(pk)
      do_init = .false.

      return
      end subroutine init_mcm_mca_lsc
! ---------------------------------------------------------------------------------

      subroutine convad
 
! this subroutine controls the computation of convective adjustment.
! the input is pressure, temperature and mixing ratio.
! the output are the new adjusted temps and mixing ratios.
 
      real :: taupre(ix)
      real :: tcc   (ix)
      real ::  hl   (ix)
      real :: r0    (ix,kx)
      real :: t0    (ix,kx)
      real :: temp  (ix,kx)

! to match fms diagnostics, convt and convr no longer have units of "amount"/s
! instead, they have units of "amount"
      real,dimension(ix,kx) :: convt,convr

!     TK mod:  8/15/01
!     real,dimension(ix,kx) :: convq

      integer :: ixxx,i,k
      real :: fact
 
!   <> <> <> <> <> <> <> <> <> <> <> <> <> <> <> <> <> <> <> <> <> <> <>
 
! test temperatures for range between -173.16 and +102 degrees c.
! if any temperature is outside of this range, program stops.
 
      fact = 1.0
!      if (ktau .eq. 0) fact = 0.5
      do 70 k=1,kx
       do 70 i=1,ix
        temp(i,k) = 102.0 - ta(i,k,ih)
        temp(i,k) = temp(i,k) * (ta(i,k,ih)+173.16)
   70 continue
      ixxx = 0
      do 71 k=1,kx
       do 71 i=1,ix
        if (temp(i,k) .lt. 0.0) go to 771
   71 continue
      ixxx = 0
      go to 772
  771 continue
      ixxx = 1
  772 continue
      if (ixxx .ne. 0)  then
!        write(6,9030) jrow, ktau
        do 7770 k=1,kx
!          write(6,9031) k, (ta(i,k,ih),i=1,ix)
          
          write(6,*) "bad temperature: k, ta(:,k,ih)",k, &
                (ta(i,k,ih),i=1,ix)
7770    continue
!        call aquit(20)
        call error_mesg('convad in mcm_mca_lsc','bad temperature',FATAL)
      endif
 
! save initial mixing ratio and temperature.
 
      do 110 k=1,kx
        do 110 i=1,ix
          r0 (i,k) = ra (i,k,ih)
          t0 (i,k) = ta (i,k,ih)
  110 continue
 
! test to determine whether precipitation occurs as rain or snow.
! heat of condensation is adjusted accordingly.
 
! tcc(i)=+1.0 when the boundary layer temperature .gt.0 deg.c
! tcc(i)= 0.0 when the boundary layer temperature .le.0 deg.c
 
! height of freezing level is taken to be 350 meters based on
! empirical analysis by nmc.  krs1, krs2, rswt1, and rswt2 are
! determined in subroutine parmtr.
 
      do 74 i=1,ix
       tcc(i) = -rswt1*ta(i,krs1,ih) - rswt2*ta(i,krs2,ih)
   74 continue
      do 75 i=1,ix
       if (tcc(i) .lt. 0.0) then
         hl (i) = hlvv
         tcc(i) =   1.0
       else
         hl (i) = hlss
         tcc(i) =   0.0
       endif
   75 continue
 
!  call mstcnv which computes the moist adjustment.
 
!  TK Mod:
!      call mstcnv(hl)
      call mstcnv(hl, r0)
 
! compute change of temperature and mixing ratio due to condensation,
! convective and dry adjustment.
 
      do 531 k=1,kx
        do 531 i=1,ix
          convt(i,k) = ta(i,k,ih) - t0(i,k)
          convr(i,k) = ra(i,k,ih) - r0(i,k)
          
!         TK mod: 8/15/01
!           Compute the convective adjustment of water
!           in terms of specific humidity in preparation
!           for vertical integration to compute the precipitation.

          if(.not.use_mixing_ratio) then
            convq(i,k) =  ra(i,k,ih) / (ra(i,k,ih) + 1.) &
                       - (r0(i,k) / (r0(i,k) + 1.))             
          endif
          
  531 continue
 
! compute total precipitation and heating due to all adjustments
! in column.
 
! convert convt and convr to rates of change.
 
      do 532 i=1,ix
!        cmcah (i) =  dq(1) * convt(i,1) * psp(i,ih)
         if(use_mixing_ratio) then
           taupre(i) = -dq(1) * convr(i,1) ! TK mod 5/22/02
         else
           taupre(i) = -dq(1) * convq(i,1) ! TK mod: 8/15/01
         endif
  532 continue
      do 534 k=2,kx
        do 534 i=1,ix
!          cmcah (i) = cmcah (i) + dq(k) * convt(i,k) * psp(i,ih)
! TK mod: 8/15/01.  Vertically integratge the change in q:
           if(use_mixing_ratio) then
             taupre(i) = taupre(i) - dq(k) * convr(i,k) ! TK mod 5/22/02
           else
             taupre(i) = taupre(i) - dq(k) * convq(i,k)
           endif
  534 continue
      do 550 i=1,ix
        taupre(i) = taupre(i) * psp(i,ih) * og
  550 continue
!      rdt = 1.0 / float ( idt )
!      rdt = 1.0 / dt
!      do 535 k=1,kx
!        do 535 i=1,ix
!          convt(i,k) = rdt * convt(i,k)
!          convr(i,k) = rdt * convr(i,k)
!  535 continue

! set total precipitation as either rain or snow depending upon
! criterion tcc determined near beginning of subroutine.

! taupre is computed over a 2dt time interval and, therefore,
! must be divided in half.

      do 600 i=1,ix
        taupre(i) = taupre(i) * 0.5 * fact
        tauran(i) = taupre(i) *        tcc(i)
        tausno(i) = taupre(i) * (1.0 - tcc(i))
  600 continue

      return
      end subroutine convad
! ---------------------------------------------------------------------------------

      subroutine parmtr
!     ========== ======
!  this subroutine is called at the beginning of each run from atmos.
!  it calculates  constants, including those in the es table.
!  entry points:       cpoly, lgndre1, lgndre, lgndxy
!  subroutines called : o3init, gaussg

      real :: table(5102),esnew(2551),esupc(200)

      integer :: k,ii,i
      real :: qrs,esbasw,tbasw,esbasi,tbasi,tem,aa,b,c,d, &
           e,esh20,wice,wh2o

! compute sigma values at model full levels
      do 41 k=1,kx
        q(k) = 0.5*(qmh(k)+qmh(k-1))
   41 continue

!  set fundamental atmospheric constants

!  load common block /param/. for additional information,
!  see june 26,1981 notes.
      rix = 1.0/float(ix)

! Determine the levels and weights to be used for discriminating
! between rain and snow.  The 350m level is used as the critical
! level, and q=0.9575 is used as an approximation to this level
! based on the U. S. standard atmosphere.
      qrs = 0.9575
      do 71 k=1,kx-1
        if (q(k).le.qrs .and. q(k+1).gt.qrs) then
          krs1 = k
          krs2 = k+1
          rswt1 = (q(k+1)-qrs)/(q(k+1)-q(k))
          rswt2 = 1.0 - rswt1
        endif
   71 continue

!  compute level dependent constants
!  load common block /sigwgt/.  for additional information,
!  see october 19,1981 notes.
      do 10 k=1,kx
      dq    (k) = qmh(k)-qmh(k-1)
 10   continue
      do 20 k=1,km
      dqph  (k  ) = q(k+1)-q(k)
 20   continue

!  ================================================================
!  +                                                              +
!  +             construction of the es table                     +
!  +                                                              +
!  + this table is constructed from es equations from the smithsonian
!  + tables. the es input  is computed from values  (in           +
!  + one-tenth of a degree increments) of es over ice from  -153c +
!  + to 0c  and values of es over water from 0c to 102c.   output +
!  + table contains these data interleaved with their derivatives +
!  + with   respect  to  temperature  except  between -20c and 0c +
!  + where  blended  (over water  and over ice)   es  values  and +
!  + derivatives are calculated.                                  +
!  note: all es computation is done in microbars and not millibars.
!  ================================================================

!#ifdef moist
      esbasw = 1013246.0
       tbasw =     373.16
      esbasi =    6107.1
       tbasi =     273.16

!  compute es over ice between -153 c and 0 c.
!  see smithsonian meteorological tables page 350.
      do 120 i=1,1530
      tem = 120.16+0.1*float(i-1)
      aa  = -9.09718 *(tbasi/tem-1.0)
      b   = -3.56654 *alog10(tbasi/tem)
      c   =  0.876793*(1.0-tem/tbasi)
      e   = alog10(esbasi)
      table(i)=10**(aa+b+c+e)
 120  continue

!  compute es over water between -20c and freezing.
!  see smithsonian meteorological tables page 350.
      do 128 i=1,1221
      tem = 253.16+0.1*float(i-1)
      aa  = -7.90298*(tbasw/tem-1)
      b   =  5.02808*alog10(tbasw/tem)
      c   = -1.3816e-07*(10**((1-tem/tbasw)*11.344)-1)
      d   =  8.1328e-03*(10**((tbasw/tem-1)*(-3.49149))-1)
      e   = alog10(esbasw)
      esh20  = 10**(aa+b+c+d+e)
      if (i.le.200) then
        esupc(i) = esh20
      else
        table(i+1330) = esh20
      endif
  128 continue

!  derive blended es over ice and supercooled water between -20c and 0c
      do 130 i=1,200
      tem  = 253.16+0.1*float(i-1)
      wice = 0.05*(273.16-tem)
      wh2o = 0.05*(tem-253.16)
      table(i+1330) = wice*table(i+1330)+wh2o*esupc(i)
  130 continue

!  estimate es derivative in microbars per degree celsius by
!    differencing es values in the table
      do 134 i=2,2550
      esnew(i) = 5.0*(table(i+1)-table(i-1))
  134 continue
      esnew(   1) = esnew(   2)
      esnew(2551) = esnew(2550)

!  interleave es and its derivative into one table of alternating
!    variables (es entries are odd numbered, derivatives are even)
      do 135 i=1,2551
                  ii = (i-1)*2
      table(5101-ii) = table(2552-i)
  135 continue
      do 136 i=1,2551
            ii    = (i-1)*2
      table(ii+2) = esnew(i)
  136 continue
      do 140 i=1,5102
      etabl(i)=table(i)
  140 continue
!#endif

      return

      end subroutine parmtr
! ---------------------------------------------------------------------------------

      subroutine mstcnv(hl, r0)

!     input : ta and ra
!     output: ta and ra

!      TK Mod:  additional input:  r0
!      TK Mod:  additional output: rh_local

! this subroutine computes precipitation due to both large scale
! condensation and small scale moist convection.

      integer,parameter :: iters = 1
      integer :: iter

      real,intent(in),dimension(:) ::     hl
      real,dimension(size(hl,1)) :: tauran,tausno
      real,dimension(ix,kx) ::  wk, alrm
      real,dimension(ix,kx) :: c
      real,dimension(ix,kx) :: rsmin

      real,dimension(ix,kx) :: es,des,psq
      real,dimension(ix,kx) :: rs
      integer,dimension(ix,kx) :: mvf
      real,dimension(ix,kx) :: psqm
      integer,dimension(ix,kx) :: it
      real, dimension(ix,kx) :: temnew,ratnew,temavg
      integer,dimension(ix,kx) :: itest,iwk
      real,dimension(ix,kx) :: term2
      real,dimension(ix,kx) ::  wt1, wt3,delta
      real,dimension(ix,kx) :: sum0,term1,test
      real,dimension(ix,kp) :: sum2, sum1
      real :: delmin,esmin
      integer :: i,k,iflag1,iflag2
      
!  TK mod:
      real,dimension(ix,kx) :: r0
      
      real :: hc=1.00

! initialize dummy arrays to zero for moist adiabatic adjustment
! computation.

      do 72 i=1,ix
       sum0(i,kx) = 0.0
       sum1(i, 1) = 0.0
       sum2(i, 1) = 0.0
   72 continue

! compute pressure at middle of layers for use in moist adiabatic
! lapse rate evaluation.

      do 130 k=1,km
        do 130 i=1,ix
          psqm(i,k) = psp(i,ih) * qmh(k)
  130 continue

! compute pressure at individual levels.

      do 140 k=1,kx
        do 140 i=1,ix
          psq(i,k) = psp(i,ih) * q(k)
  140 continue

! beginning of code for determining precipitation by both large
! and small scale processes.  compute es, c, and rs at the
! individual levels which are
!   es = saturation vapor pressure.
!    c = derivative of saturation mixing ratio with respect to
!        temperature.
!   rs = saturation mixing ratio.
!   rsmin = minimum saturation mixing ratio on es table
!   esmin = minimum saturation vapor pressure on es table
!   delmin = minimum p-es allowed, this is done to keep p-es
!            positive.

! note; repeated iteration through the column is no longer performed
! (i.e. iters=1).

      delmin = 1.0e-10
      esmin  = etabl(1)
      do 519 k=1,kx
       do 519 i=1,ix
!       rsmin(i,k) = .622*esmin / (psq(i,k)-esmin) ! MS mod 5/22/02
        rsmin(i,k) = d622*esmin / (psq(i,k)-esmin) ! MS mod 5/22/02
  519 continue

      do 520 iter=1,iters

! es values are taken from a table(120k-375k) at .1 degree intervals

        do 149 k=1,kx
          do 149 i=1,ix
            it(i,k) = 10.0 * (ta(i,k,ih) + 153.05)
  149   continue
        do 80 k=1,kx
         do 80 i=1,ix
          it(i,k) = 2*it(i,k) + 1
          it(i,k) = max(it(i,k), 1)
          it(i,k) = min(it(i,k), 5102-3)
   80   continue
        do 81 k=1,kx
         do 81 i=1,ix
           es(i,k) = etabl(it(i,k)  )
          des(i,k) = etabl(it(i,k)+1)
   81   continue
        do 150 k=1,kx
          do 150 i=1,ix
!cc         wk(i,k)    = .622 * hc *  es(i,k) ! MS mod 5/22/02
            wk(i,k)    = d622 * hc *  es(i,k) ! MS mod 5/22/02

!cc         des(i,k)   = .622 * hc * des(i,k) ! MS mod 5/22/02
            des(i,k)   = d622 * hc * des(i,k) ! MS mod 5/22/02

            delta(i,k) = psq(i,k) - hc *  es(i,k)
  150   continue

!  make sure delta, (press - es press) does not become negative
        do 82 k=1,kx
         do 82 i=1,ix
          delta(i,k) = max(delta(i,k), delmin)
   82   continue
        do 151 k=1,kx
          do 151 i=1,ix
             c(i,k) = psq(i,k) * des(i,k) / (delta(i,k) * delta(i,k))
            rs(i,k) = wk(i,k) / delta(i,k)
  151   continue
        do 83 k=1,kx
         do 83 i=1,ix
          rs(i,k) = max(rs(i,k), rsmin(i,k) )
          
!         TK Mod:  Determine relative humidity for cloud determination 
!                 (later in rh_clouds).  Note that this is within an interation 
!                 loop where temperature could change, but the number of
!                 iterations is currently set to 1.

          rh_local(i,k,ih) = r0(i,k) / rs(i,k)
          
   83   continue

! compute mean temperature of layer for use in moist adiabatic
! lapse rate evaluation.

        do 160 k=1,km
          do 160 i=1,ix
            temavg(i,k) = (ta(i,k,ih) + ta(i,k+1,ih)) * 0.5
  160   continue

! compute es and des (derivative of saturation vapor pressure)
! at the mid-point of the layer for use in moist adiabatic lapse
! rate evaluation.

        do 169 k=1,km
          do 169 i=1,ix
            it(i,k) = 10.0 * (temavg(i,k) + 153.05)
  169   continue
        do 85 k=1,kx
         do 85 i=1,ix
          it(i,k) = 2*it(i,k) + 1
          it(i,k) = max(it(i,k), 1)
          it(i,k) = min(it(i,k), 5102-3)
   85   continue
        do 86 k=1,kx
         do 86 i=1,ix
           es(i,k) = etabl(it(i,k)  )
          des(i,k) = etabl(it(i,k)+1)
   86   continue
        do 170 k=1,km
          do 170 i=1,ix
!cc         es (i,k) = .622 * hc * es (i,k) ! MS mod 5/22/02
            es (i,k) = d622 * hc * es (i,k) ! MS mod 5/22/02

!cc         des(i,k) = .622 * hc * des(i,k) ! MS mod 5/22/02
            des(i,k) = d622 * hc * des(i,k) ! MS mod 5/22/02

  170   continue

! compute alrm (moist adiabatic lapse rate) for each layer.

        do 171 k=1,km
          do 171 i=1,ix
            alrm(i,k) = (dqph(k) * (ara * psqm(i,k) * &
                        (temavg(i,k) + tfreeze) + hl(i) * es(i,k))) &
                      / (qmh(k) * (psqm(i,k) * cpp &
                                     + hl(i) * des(i,k)))
  171   continue

! tests are now performed to determine occurrence and type of
! precipitation.  for small scale, moist convection, layer must be
! both super-moist adiabatic and supersaturated.  for large scale
! condensation, just the individual layer must be supersaturated.

! here begins the computation of the integer arrays iwk and itest
! which will determine the levels where the moist convective and
! large scale adjustments occur, respectively.  mvf is the same as
! iwk except it applies to the layers rather than the levels
! involved.

        if (iter .le. 1) then

!         test(i,k) = 1.0 - ra(i,k,ih) / rs(i,k)

! set test to negative number for supersaturation.

          do 88 k=1,kx
           do 88 i=1,ix
            test(i,k) = wk(i,k) - ra(i,k,ih)*delta(i,k)
   88     continue
          do 89 k=1,kx
           do 89 i=1,ix
            if (test(i,k) .ge. 0.0) then
              itest(i,k) = 0
            else
              itest(i,k) = 1
            endif
   89     continue

          do 181 i=1,ix
            mvf(i,kx) = 0
  181     continue

          do 90 k=1,km
           do 90 i=1,ix
            mvf(i,k) = itest(i,k) * itest(i,k+1)
   90     continue

          do 91 k=1,km
           do 91 i=1,ix
            test(i,k) = alrm(i,k) + 0.01 + ta(i,k,ih) - ta(i,k+1,ih)
   91     continue

          do 92 k=1,km
           do 92 i=1,ix
            if (test(i,k) .ge. 0.0) then
              itest(i,k) = 0
            else
              itest(i,k) = 1
            endif
   92     continue

          do 93 k=1,km
           do 93 i=1,ix
            mvf(i,k) = mvf(i,k) * itest(i,k)
   93     continue

!     mvf(i,k)=1 where moist adiabatic adjustment is required
!     mvf(i,k)=0 where either condensation or nothing is required

          do 94 i=1,ix
           iwk(i,1) = mvf(i,1)
   94     continue

          do 95 k=2,kx
           do 95 i=1,ix
            iwk(i,k) = max(mvf(i,k),mvf(i,k-1))
   95     continue

          do 96 k=1,kx
           do 96 i=1,ix
            test(i,k) = rs(i,k) - ra(i,k,ih)
   96     continue
          do 97 k=1,kx
           do 97 i=1,ix
            if (test(i,k) .ge. 0.0) then
              itest(i,k) = 0
            else
              itest(i,k) = 1
            endif
   97     continue

          do 98 k=1,kx
           do 98 i=1,ix
            itest(i,k) = itest(i,k) * (1-iwk(i,k))
   98     continue

          do 99 k=1,kx
           do 99 i=1,ix
            wt1(i,k) = mvf(i,k)
            wt3(i,k) = iwk(i,k)
   99     continue

! iwk now contains the convection flagbits and itest the
! condensation flagbits: iwk=1 if and only if convection.
! itest=1 if and only if condensation, otherwise they equal zero.
! the value of zero implies no adjustment.

! solution of simultaneous equations for the new temperatures and
! mixing ratios as a result of both condensation and convective
! adjustments.  here
!       ta = temperature after dry adjustment.
!       ra = old mixing ratio
!   temnew = new temperature
!   ratnew = new mixing ratio

          iflag1 = 0
          iflag2 = 0
          do 188 k=1,kx
           do 188 i=1,ix
            iflag1 = iflag1 + itest(i,k)
            iflag2 = iflag2 +   mvf(i,k)
  188     continue
          if (iflag1 .eq. 0 .and. iflag2 .eq. 0) go to 525
          if (iflag1 .eq. 0) then
            do 3376 k=1,kx
              do 3376 i=1,ix
                temnew(i,k) = ta(i,k,ih)
                ratnew(i,k) = ra(i,k,ih)
 3376       continue
          else

! large scale condensation adjustment.

            do 3333 k=1,kx
              do 3333 i=1,ix
                test(i,k) = itest(i,k)
 3333       continue

! **    itest now has a "1" where condensation is allowed to occur,
!        i.e., where moist adjustment did not occur and where the
!        humidity (ratnew/rs) is greater than 1.0, and "0" otherwise.

            do 3004 k=1,kx
              do 3004 i=1,ix
                temnew(i,k) = ta(i,k,ih) + &
                            test(i,k) * (hl(i) * (ra(i,k,ih) - rs(i,k)) &
                              / (cpp + hl(i) * c(i,k)))
                ratnew(i,k) = test(i,k) * (rs(i,k) + c(i,k) &
                                           * (temnew(i,k) - ta(i,k,ih)) &
                                           - ra(i,k,ih)) + ra(i,k,ih)
 3004       continue
          endif

        endif

        if (iter.gt.1) then
          do 3006 k=1,kx
            do 3006 i=1,ix
              temnew(i,k) = ta(i,k,ih) &
                          + test(i,k) * (hl(i) * (ra(i,k,ih) - rs(i,k)) &
                            / (cpp + hl(i) * c(i,k)))
              ratnew(i,k) = test(i,k) * (rs(i,k) + c(i,k) &
                                         * (temnew(i,k) - ta(i,k,ih)) &
                                         - ra(i,k,ih)) + ra(i,k,ih)
 3006     continue
        endif

! small scale moist convective adjustment.

        if (iflag2 .ne. 0) then
          do 700 k=1,km
            do 700 i=1,ix
              sum0(i,kx-k) = wt1(i,kx-k) * (sum0(i,kx+1-k) + alrm(i,kx-k))
  700     continue
          do 701 k=1,kx
            do 701 i=1,ix
              term2(i,k) = dq(k) * (cpp + hl(i) * c(i,k))
              term1(i,k) = term2(i,k) * (ta(i,k,ih) + sum0(i,k)) &
                        + dq(k) * hl(i) * (ra(i,k,ih) - rs(i,k))
  701     continue
          do 702 k=1,kx
            do 706 i=1,ix
              sum1(i,k+1) = wt3(i,k) * (sum1(i,k) + term1(i,k))
              sum2(i,k+1) = wt3(i,k) * (sum2(i,k) + term2(i,k))
  706       continue
            do 172 i=1,ix
             if (wt1(i,k) .ne. wt3(i,k)) then
               temnew(i,k  ) = sum1(i,k+1) / sum2(i,k+1)
                 sum1(i,k+1) = 0.0
                 sum2(i,k+1) = 0.0
             endif
  172       continue
  702     continue
          do 703 k=1,km
            do 703 i=1,ix
              temnew(i,kx-k) = (1.0 - wt1(i,kx-k)) * temnew(i,kx  -k) &
                             +        wt1(i,kx-k)  * temnew(i,kx+1-k)
  703     continue
          do 704 k=1,km
            do 704 i=1,ix
              temnew(i,k) = temnew(i,k) - sum0(i,k)
  704     continue
          do 705 k=1,kx
            do 705 i=1,ix
              ratnew(i,k) = (rs(i,k) + c(i,k) &
                             * (temnew(i,k) - ta(i,k,ih))) * wt3(i,k) &
                          + (1.0 - wt3(i,k)) * ratnew(i,k)
  705     continue
        endif

! end of condensation and convective adjustment algorithm.  replace
! previous temperatures and mixing ratios with new ones.

        do 510 k=1,kx
          do 510 i=1,ix
            ta(i,k,ih) = temnew(i,k)
            ra(i,k,ih) = ratnew(i,k)
  510   continue
  520 continue
  525 continue

      return
      end subroutine mstcnv
! ---------------------------------------------------------------------------------

      end module mcm_mca_lsc_mod

module ocean_age_tracer_mod  !{
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> John P. Dunne
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies 
!</REVIEWER>
!
!<OVERVIEW>
! Ocean age tracer module
!</OVERVIEW>
!
!<DESCRIPTION>
!       This module will perform the necessary operations to handle
!       a series of ocean age tracers. The following types are allowed:
!
!       normal: the age of the designated surface area is fixed at
!               0, while all other grid points increase in age.
!               Therefore, the resultant age is the length of time
!               since that water has been in contact with the
!               designated area of surface. (This is the default type.)
!
!      Note that the tracer "concentration" known as "age" is 
!      in units of years, hence the multiplier "secs_in_year_r"
!      applied to t_prog(index)%source.  This multiplier IS NOT 
!      needed for any other terms, since they all have units with 
!      meter/sec, and this is multiplied by dtime(secs) when 
!      time stepping.  
!
!</DESCRIPTION>
!
! $Id: ocean_age_tracer.F90,v 20.0 2013/12/14 00:16:58 fms Exp $
!

!
!       modules
!

use field_manager_mod,  only: fm_string_len, fm_path_name_len, fm_field_name_len
use field_manager_mod,  only: fm_get_length, fm_get_value, fm_new_value
use mpp_mod,            only: stdout, stderr, stdlog, mpp_error, FATAL
use time_manager_mod,   only : get_date, time_type

use ocean_tpm_util_mod, only: otpm_set_tracer_package, otpm_set_prog_tracer
use fm_util_mod,        only: fm_util_set_value
use fm_util_mod,        only: fm_util_start_namelist, fm_util_end_namelist
use fm_util_mod,        only: fm_util_get_string, fm_util_get_string_array
use fm_util_mod,        only: fm_util_get_logical, fm_util_get_logical_array
use fm_util_mod,        only: fm_util_get_real_array, fm_util_check_for_bad_fields

use ocean_types_mod,    only: ocean_prog_tracer_type

!
!       force all variables to be "typed"
!

implicit none

!
!       Set all variables to be private by default

private

!
!       Public routines
!

public  :: ocean_age_tracer_end
public  :: ocean_age_tracer_init
public  :: ocean_age_tracer_source
public  :: ocean_age_tracer_start
public  :: ocean_age_tracer_tracer

!
!       Private routines
!

private :: set_array

!
!       Public parameters
!


!
!       Private parameters
!

integer, parameter                              :: num_types = 1
character(len=fm_field_name_len), parameter     :: package_name = 'ocean_age_tracer'
character(len=48), parameter                    :: mod_name = 'ocean_age_tracer_mod'
character(len=fm_string_len), parameter         :: default_restart_file = 'ocean_age.res.nc'
real, parameter                                 :: secs_in_year_r = 1.0 / (86400.0 * 365.25)

!
!       Public variables
!

logical, public :: do_ocean_age_tracer

!
!       Private types
!

type age_type
  character(len=fm_field_name_len)      :: name
  character(len=fm_string_len)          :: age_tracer_type
  real, dimension(:,:,:), pointer       :: bc => NULL()
  integer                               :: index
  real, dimension(:), pointer           :: elon => NULL()
  real, dimension(:), pointer           :: nlat => NULL()
  real, dimension(:), pointer           :: slat => NULL()
  real, dimension(:), pointer           :: wlon => NULL()
  logical                               :: coastal_only
  logical, dimension(:), pointer        :: t_mask => NULL()
end type age_type

!
!       Private variables
!

type(age_type), dimension(:), allocatable               :: age
character(len=fm_string_len), dimension(num_types)      :: age_types
logical, dimension(12)                                  :: t_mask
integer                                                 :: instances
integer                                                 :: package_index

!
!       time variables
!

integer :: day
integer :: hour
integer :: minute
integer :: month
integer :: second
integer :: year

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_age_tracer_end">
!
! <DESCRIPTION>
!       Finish up calculations for the tracer packages,
!       possibly writing out non-field restart information
! </DESCRIPTION>
!

subroutine ocean_age_tracer_end  !{

implicit none

!
!       local parameters
!

!
!       finish up the run
!

return

end subroutine ocean_age_tracer_end  !}
! </SUBROUTINE> NAME="ocean_age_tracer_end"


!#######################################################################
! <SUBROUTINE NAME="ocean_age_tracer_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the tracer packages
!
!       Save pointers to various "types", such as Grid and Domains.
! </DESCRIPTION>
!

subroutine ocean_age_tracer_init  !{

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

!
!       local parameters
!

character(len=64), parameter    :: sub_name = 'ocean_age_tracer_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!-----------------------------------------------------------------------
!       local variables
!-----------------------------------------------------------------------
!

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=fm_field_name_len+3)                      :: long_suffix
character(len=256)                                      :: caller_str
character(len=fm_string_len), pointer, dimension(:)     :: good_list

  integer :: stdoutunit 
  stdoutunit=stdout() 

!
!       Initialize the ocean age tracer package
!

package_index = otpm_set_tracer_package(package_name,          &
     units = 'yr', flux_units = 'm',                           &
     min_tracer_limit = 0.0, max_tracer_limit = 1.0e+20,       &
     min_range=0.0, max_range=1.0e+20,                         &
     restart_file = default_restart_file,                      &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')

!
!       Check whether to use this package
!

path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
instances = fm_get_length(path_to_names)
if (instances .lt. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
endif  !}

!
!       Check some things
!

write (stdoutunit,*)
if (instances .eq. 0) then  !{
  write (stdoutunit,*)                                            &
       trim(note_header), ' No instances'
  do_ocean_age_tracer = .false.
else  !}{
  write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
  do_ocean_age_tracer = .true.
endif  !}

!
!       Return if we don't want to use this package
!

if (.not. do_ocean_age_tracer) then  !{
  return
endif  !}

!
!       allocate the age array
!

allocate ( age(instances) )

!
!       loop over the names, saving them into the age array
!

do n = 1, instances  !{

  if (fm_get_value(path_to_names, name, index = n)) then  !{
    age(n)%name = name
  else  !}{
    write (name,*) n
    call mpp_error(FATAL, trim(error_header) //        &
         ' Bad field name for index ' // trim(name))
  endif  !}

enddo  !} n

do n = 1, instances  !{

!
!       determine the tracer name for this instance
!

  name = age(n)%name
  if (name(1:1) .eq. '_') then  !{
    suffix = ' '
    long_suffix = ' '
  else  !}{
    suffix = '_' // name
    long_suffix = ' (' // trim(name) // ')'
  endif  !}

  age(n)%index = otpm_set_prog_tracer('age' // trim(suffix), package_name,      &
       longname = 'Age' // trim(long_suffix),                                   &
       caller = trim(mod_name)//'('//trim(sub_name)//')')

enddo  !} n

!
!-----------------------------------------------------------------------
!       Set up the instance age namelists
!-----------------------------------------------------------------------
!

!
!       Add the package name to the list of good namelists, to be used
!       later for a consistency check
!

if (fm_new_value('/ocean_mod/GOOD/good_namelists', package_name, append = .true.) .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) //                           &
       ' Could not add ' // trim(package_name) // ' to "good_namelists" list')
endif  !}

caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

t_mask(:) = .true.

do n = 1, instances  !{

!
!       create the instance namelist
!

  call fm_util_start_namelist(package_name, age(n)%name, caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('coastal_only', .false.)
  call fm_util_set_value('t_mask', t_mask, size(t_mask))
  call fm_util_set_value('age_tracer_type', 'not used')
  call fm_util_set_value('wlon', 0.0, index = 0)
  call fm_util_set_value('elon', 0.0, index = 0)
  call fm_util_set_value('slat', 0.0, index = 0)
  call fm_util_set_value('nlat', 0.0, index = 0)

  call fm_util_end_namelist(package_name, age(n)%name, check = .true., caller = caller_str)

enddo  !} n

!
!       Check for any errors in the number of fields in the namelists for this package
!

good_list => fm_util_get_string_array('/ocean_mod/GOOD/namelists/' // trim(package_name) // '/good_values',   &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
if (associated(good_list)) then  !{
  call fm_util_check_for_bad_fields('/ocean_mod/namelists/' // trim(package_name), good_list,       &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')
  deallocate(good_list)
else  !}{
  call mpp_error(FATAL,trim(error_header) // ' Empty "' // trim(package_name) // '" list')
endif  !}


return

end subroutine ocean_age_tracer_init  !}
! </SUBROUTINE> NAME="ocean_age_tracer_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_age_tracer_source">
!
! <DESCRIPTION>
!       Calculate the source arrays for the tracer packages
! </DESCRIPTION>
!

subroutine ocean_age_tracer_source(isd, ied, jsd, jed, nk, model_time, grid_tmask, T_prog)

!
!       modules
!

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

integer, intent(in)                                        :: isd
integer, intent(in)                                        :: ied
integer, intent(in)                                        :: jsd
integer, intent(in)                                        :: jed
integer, intent(in)                                        :: nk
type(time_type), intent(in)                                :: model_time
real, dimension(isd:,jsd:,:), intent(in)                   :: grid_tmask
type(ocean_prog_tracer_type), dimension(:), intent(inout)  :: T_prog

!
!       local parameters
!

!
!       local variables
!

integer :: index
integer :: i,j,k,n

!
!       set the source values for the age tracers.
!
!       these sources will be multiplied by dtts 
!       inside of ocean_tracer_mod and then added
!       to the age tracer field.   
!
!       get the index for the current month for use
!       for setting the surface age and source
!

call get_date(model_time, year, month, day, hour, minute, second)

do n=1,instances  

  index = age(n)%index

  k=1  
  do j=jsd,jed
     do i=isd,ied
        t_prog(index)%source(i,j,k)  = t_prog(index)%source(i,j,k) + &
             age(n)%bc(i,j,month)*secs_in_year_r*grid_tmask(i,j,k)
     enddo
  enddo

  do k=2,nk   
     do j=jsd,jed
        do i=isd,ied
           t_prog(index)%source(i,j,k) = t_prog(index)%source(i,j,k) + secs_in_year_r*grid_tmask(i,j,k)
        enddo
     enddo
  enddo

enddo

return

end subroutine ocean_age_tracer_source 
! </SUBROUTINE> NAME="ocean_age_tracer_source"


!#######################################################################
! <SUBROUTINE NAME="ocean_age_tracer_start">
!
! <DESCRIPTION>
!       Start the ocean age tracer package
!
!       Age tracer surface area specification
!
!  wlon         : western longitude of surface age
!                 region
!  elon         : eastern longitude of surface age
!                 region
!  slat         : southern latitude of surface age
!                 region
!  nlat         : northern latitude of surface age
!                 region
!  coastal_only : if true, then only apply the changes in
!                 coastal boxes
!  t_mask       : logical array controlling whether to apply
!                 the following inhibitions and depletions to
!                 each month (true means set the masks,
!                 false means use the defaults everywhere)
!
!
!       To set the surface areas, a number of namelists are read,
!       each containing the above values. You may specify up to
!       num_region rectangles bounded by (wlon,elon,nlat,slat).
!       Any grid box whose center is in one of these rectangles will
!       be considered to be part of the surface area where the
!       age is reset to zero every time-step.
!
!       These masks may be time-dependent by specifying t_mask.
!       For any month that t_mask is true (1=Jan), the rectangular
!       regions will be set, otherwise they will be skipped.
!
!       nlat may not equal slat, and wlon may not equal elon
!
!       If slat > nlat, then nothing will be done for that rectangle
!
!       The initial surface area is empty, with the default rectangle
!       setting the surface area to be empty
!
!       More than num_regions rectangles may be used to specify
!       the area by using more than one namelist
! </DESCRIPTION>
!
subroutine ocean_age_tracer_start(isd, ied, jsd, jed, T_prog, grid_xt, grid_yt, grid_kmt)  !{

!
!       modules
!

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
real, dimension(isd:,jsd:), intent(in)                  :: grid_xt
real, dimension(isd:,jsd:), intent(in)                  :: grid_yt
integer, dimension(isd:,jsd:), intent(in)               :: grid_kmt

!
!       local parameters
!

character(len=64), parameter    :: sub_name = 'ocean_age_tracer_start'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!       local variables
!

integer                         :: done
integer                         :: l
integer                         :: n
character(len=256)              :: caller_str
integer                         :: len_w
integer                         :: len_e
integer                         :: len_s
integer                         :: len_n

  integer :: stdoutunit 
  stdoutunit=stdout() 

!
!       allocate storage for this instance and
!       set all of the values to the default
!

do n = 1, instances  !{
  allocate( age(n)%bc(isd:ied,jsd:jed,12) )
  age(n)%bc(:,:,:) = 1.0
enddo  !} n

!
!-----------------------------------------------------------------------
!       save the instance namelist values
!-----------------------------------------------------------------------
!

caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances !{

  call fm_util_start_namelist(package_name, age(n)%name, caller = caller_str)

  age(n)%age_tracer_type =  fm_util_get_string        ('age_tracer_type', scalar = .true.)
  age(n)%coastal_only    =  fm_util_get_logical       ('coastal_only', scalar = .true.)
  age(n)%wlon            => fm_util_get_real_array    ('wlon')
  age(n)%elon            => fm_util_get_real_array    ('elon')
  age(n)%slat            => fm_util_get_real_array    ('slat')
  age(n)%nlat            => fm_util_get_real_array    ('nlat')
  age(n)%t_mask          => fm_util_get_logical_array ('t_mask')

  call fm_util_end_namelist(package_name, age(n)%name, caller = caller_str)

!
!       Check some things
!

  if (.not. associated(age(n)%wlon) .or.        &
      .not. associated(age(n)%elon) .or.        &
      .not. associated(age(n)%slat) .or.        &
      .not. associated(age(n)%nlat)) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Must specify a region')
  endif  !}

  len_w = size(age(n)%wlon)
  len_e = size(age(n)%elon)
  len_s = size(age(n)%slat)
  len_n = size(age(n)%nlat)

  if (len_e .ne. len_w .or. len_w .ne. len_s .or. len_s .ne. len_n) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal')
  endif  !}

  if (size(age(n)%t_mask) .ne. 12) then  !{
    call mpp_error(FATAL, trim(error_header) // ' t_mask size is not 12')
  endif  !}

!
!       set values for this time-level
!

  done = 0
  do l = 1, 12  !{
    if (age(n)%t_mask(l)) then  !{
      if (done .eq. 0) then  !{

!
!       set the values via the input values, saving this time index
!       afterwards
!
        write (stdoutunit,*) trim(note_header), ' Assigning month ', l
        call set_array(n, l, isd, ied, jsd, jed,                                &
                grid_xt, grid_yt, grid_kmt,                                     &
                len_e, age(n)%wlon, age(n)%elon, age(n)%slat, age(n)%nlat,      &
                0.0, 1.0,                                                       &
                t_prog(age(n)%index)%name, age(n)%coastal_only)
        done = l
      else  !}{

!
!       Duplicate the values for a previous time-level
!

        write (stdoutunit,*) trim(note_header), ' Duplicating month ', done, ' as ', l
        age(n)%bc(:,:,l) = age(n)%bc(:,:,done)
      endif  !}
    endif  !}
  enddo  !} l

enddo  !} n

return

end subroutine ocean_age_tracer_start  !}
! </SUBROUTINE> NAME="ocean_age_tracer_start"


!#######################################################################
! <SUBROUTINE NAME="ocean_age_tracer_tracer">
!
! <DESCRIPTION>
!       Subroutine to do calculations needed every time-step after
!       the continuity equation has been integrated
! </DESCRIPTION>
!

subroutine ocean_age_tracer_tracer(T_prog, taup1) !{

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
integer, intent(in)                                             :: taup1

!
!       local parameters
!

!
!       local variables
!

integer :: index
integer :: n

!
!       fix the surface values
!
do n = 1, instances  !{

  index = age(n)%index

  t_prog(index)%field(:,:,1,taup1) =                       &
       t_prog(index)%field(:,:,1,taup1) * age(n)%bc(:,:,month)

enddo  !} n

return

end subroutine ocean_age_tracer_tracer  !}
! </SUBROUTINE> NAME="ocean_age_tracer_tracer"


!#######################################################################
! <SUBROUTINE NAME="set_array">
!
! <DESCRIPTION>
!       Set up an array covering the model domain with a user-specified
!       value, in user-specified regions. There are a given number of
!       2-d regions specified by the values slat, nlat, wlon and elon.
!       The longitudes are for a cyclic domain, and if wlon and elon
!       are on opposite sides of the cut, the correct thing will
!       be done. Elon is considered to be east of wlon, so if elon is
!       less than wlon, then the region east of elon to the cut will be
!       filled, and the region from the cut to wlon will be filled.
!
!       After setting up the array in this routine, it may prove useful
!       to allow fine-tuning the settings via an array in a namelist.
!
!       Arguments:
!         Input:
!      num_regions  number of user-specified regions which will be filled
!             wlon  1-d array of western (starting) longitudes for the
!                   rectangular regions
!             elon  1-d array of eastern (ending) longitudes for the
!                   rectangular regions
!             slat  1-d array of southern (starting) latitudes for the
!                   rectangular regions
!             nlat  1-d array of northern (ending) latitudes for the
!                   rectangular regions
!                       Note: if slat >= nlat, then nothing is done
!                             for that region
!        set_value  the value to assign to array in the user-specified
!                   regions
!      unset_value  the value to assign to array outside of the
!                   user-specified regions
!             name  character variable used in informative messages
!     coastal_only  true to limit changes only to coastal points (i.e.,
!                   at least one bordering point is land)
!
!         Output:
!            array  2-d array which will contain the set- and unset-
!                   values. The array is assumed to have a border
!                   one unit wide on all edges, ala MOM. A cyclic
!                   boundary condition will be set if requested.
! </DESCRIPTION>
!
!

subroutine set_array(index, l, isd, ied, jsd, jed,              &
                     grid_xt, grid_yt, grid_kmt,                &
                     num_regions, wlon_in, elon_in, slat, nlat, &
                     set_value, unset_value, name,              &
                     coastal_only)  !{

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

integer, intent(in)                             :: index
integer, intent(in)                             :: l
integer, intent(in)                             :: isd
integer, intent(in)                             :: ied
integer, intent(in)                             :: jsd
integer, intent(in)                             :: jed
real, dimension(isd:,jsd:), intent(in)          :: grid_xt
real, dimension(isd:,jsd:), intent(in)          :: grid_yt
integer, dimension(isd:,jsd:), intent(in)       :: grid_kmt
integer, intent(in)                             :: num_regions
!real, dimension(:,:), intent(out)              :: array
real, dimension(num_regions), intent(in)        :: wlon_in
real, dimension(num_regions), intent(in)        :: elon_in
real, dimension(num_regions), intent(in)        :: slat
real, dimension(num_regions), intent(in)        :: nlat
real, intent(in)                                :: set_value
real, intent(in)                                :: unset_value
character*(*), intent(in)                       :: name
logical, intent(in)                             :: coastal_only

!
!       local parameters
!

character(len=64), parameter    :: sub_name = 'set_array'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!       local variables
!

integer :: i, j, n
real, dimension(:), allocatable :: wlon
real, dimension(:), allocatable :: elon

  integer :: stdoutunit 
  stdoutunit=stdout() 

!
!       save the longitudes in case they need to be modified
!

allocate(wlon(num_regions))
allocate(elon(num_regions))

wlon(:) = wlon_in(:)
elon(:) = elon_in(:)

!
! loop over the regions, applying changes as necessary
!

do n = 1, num_regions  !{

  if (nlat(n) .ge. slat(n)) then  !{
    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header), ' ', trim(name), ' region: ', n

!
!       make sure that all longitudes are in the range [0,360]
!

    do while (wlon(n) .gt. 360.0)  !{
      wlon(n) = wlon(n) - 360.0
    enddo  !}
    do while (wlon(n) .lt. 0.0)  !{
      wlon(n) = wlon(n) + 360.0
    enddo  !}
    do while (elon(n) .gt. 360.0)  !{
      elon(n) = elon(n) - 360.0
    enddo  !}
    do while (elon(n) .lt. 0.0)  !{
      elon(n) = elon(n) + 360.0
    enddo  !}

!
!       if the southern and northern latitudes are the same, then
!       find the grid box which encompasses them ...
!

    if (slat(n) .eq. nlat(n)) then  !{

     call mpp_error(FATAL, trim(error_header) // ' Equal latitudes not supported')

    elseif (wlon(n) .eq. elon(n)) then  !}{

     call mpp_error(FATAL, trim(error_header) // ' Equal longitudes not supported')

    else  !}{

!
!       ... else find all boxes where the center lies in the
!       rectangular region
!

      do j = jsd, jed  !{
        do i = isd, ied  !{
          if (nlat(n) .ge. grid_yt(i,j) .and.                   &
              slat(n) .le. grid_yt(i,j) .and.                   &
              lon_between(grid_xt(i,j), wlon(n), elon(n))) then  !{
            age(index)%bc(i,j,l) = set_value
          endif  !}
        enddo  !} i
      enddo  !} j

    endif  !}

  endif  !}

enddo  !} n

!
!       if desired only apply mask to coastal regions
!

if (coastal_only) then  !{
  do j = jsd, jed  !{
    do i = isd, ied  !{
      if (grid_kmt(i,j) .ne. 0 .and.                            &
          age(index)%bc(i,j,l) .eq. set_value) then  !{

!
!       if all the surrounding points are ocean, then this is not
!       a coastal point, therefore reset the mask
!

        if (grid_kmt(i-1,j) .ne. 0 .and.                        &
            grid_kmt(i+1,j) .ne. 0 .and.                        &
            grid_kmt(i,j-1) .ne. 0 .and.                        &
            grid_kmt(i,j+1) .ne. 0) then  !{
          age(index)%bc(i,j,l) = unset_value
        endif  !}
      endif  !}
    enddo  !} i
  enddo  !} j
endif  !}

!
!       clean up
!

deallocate(wlon)
deallocate(elon)

return

contains

!
!       Return true if w <= x_in <= e, taking into account the
!       periodicity of longitude.
!
!       x_in    value to test
!       w       west longitude of boundary
!       e       east longitude of boundary
!

function lon_between(x_in, w, e)  !{

implicit none

!
!       function definition
!

logical :: lon_between

!
!       arguments
!

real, intent(in)                :: x_in
real, intent(in)                :: w
real, intent(in)                :: e

!
!       local variables
!

real                    :: x

!
!       Save input values so we may modify them safely
!

x = x_in

!
!       make sure that all longitudes are in the range [0,360]
!

do while (x .gt. 360.0)  !{
  x = x - 360.0
enddo  !}
do while (x .lt. 0.0)  !{
  x = x + 360.0
enddo  !}
 
if (w .gt. e) then  !{
  lon_between = w .le. x .or. x .le. e
else  !}{
  lon_between = w .le. x .and. x .le. e
endif  !}

return

end function  lon_between  !}

end subroutine  set_array  !}
! </SUBROUTINE> NAME="set_array"

end module ocean_age_tracer_mod  !}

module ocean_mixdownslope_mod
#define COMP isc:iec,jsc:jec
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! Mixing of tracer between dense shallow parcel and 
! deeper parcels downslope. 
!</OVERVIEW>
!
!<DESCRIPTION>
! Mixing of tracer properties as dense shallow parcel is discharged
! into deeper water to approach the parcel's depth of neutral buoyancy.
! This module can be characterized as a mixture of the approach from
! Campin and Goosse (1999) and slope convection. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! Campin and Goosse (1999): Parameterization of density-driven downsloping flow 
! for a coarse-resolution model in z-coordinate", Tellus 51A, pages 412-430
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies: Elements of MOM (2012)
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_mixdownslope_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  For using this module.  Default use_this_module=.false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging 
!  </DATA> 
!  <DATA NAME="do_bitwise_exact_sum" TYPE="logical">
!  Set true to do bitwise exact global sum. When it is false, the global
!  sum will be non-bitwise_exact, but will significantly increase efficiency. 
!  The default value is false.
!  </DATA> 
!
!  <DATA NAME="mixdownslope_npts" TYPE="integer">
!  Number of horizontally distant points used in search downslope. 
!  Note: it is not possible to have 
!  mixdownslope_npts greater than or equal to the computational domain
!  extents, as this would require updates across multiple processors. 
!  Default mixdownslope_npts=1. 
!  </DATA> 
!  <DATA NAME="mixdownslope_frac_central" TYPE="real">
!  Fraction of the central cell that participates in downslope mixing
!  in any particular direction.  Default mixdownslope_frac_central=0.25
!  </DATA> 
!
!  <DATA NAME="mixdownslope_weight_far" TYPE="logical">
!  To place more weight on points further from central point.  This may 
!  be done to enhance properties getting downslope.  Default is 
!  mixdownslope_weight_far=.false.
!  </DATA> 
!  <DATA NAME="mixdownslope_width" TYPE="integer">
!  Width of the re-weighting function used to emphasize points further 
!  along in the search for exchange points.  Default mixdownslope_width=1.
!  </DATA> 
!
!  <DATA NAME="read_mixdownslope_mask" TYPE="logical">
!  For reading in a mask that selects regions of the domain 
!  where mixdownslope is allowed to function (mask=1) or not 
!  to function (mask=0). Default read_mixdownslope_mask=.false., 
!  whereby mixdownslope_mask is set to tmask(k=1). 
!  </DATA> 
!  <DATA NAME="mixdownslope_mask_gfdl" TYPE="logical">
!  For modifying the mixdownslope mask based on reading in 
!  the GFDL regional mask. Default mixdownslope_mask_gfdl=.false.
!  </DATA> 
!
!</NAMELIST>
!

use constants_mod,       only: epsln
use diag_manager_mod,    only: register_diag_field, register_static_field
use fms_mod,             only: write_version_number, error_mesg, read_data, FATAL, NOTE
use fms_mod,             only: open_namelist_file, check_nml_error, close_file, stdout, stdlog
use mpp_domains_mod,     only: mpp_update_domains, CGRID_NE
use mpp_domains_mod,     only: mpp_global_sum, BITWISE_EXACT_SUM, NON_BITWISE_EXACT_SUM
use mpp_mod,             only: input_nml_file, mpp_error

use ocean_density_mod,     only: density
use ocean_domains_mod,     only: get_local_indices, set_ocean_domain
use ocean_parameters_mod,  only: missing_value, rho0, rho0r
use ocean_parameters_mod,  only: TERRAIN_FOLLOWING
use ocean_types_mod,       only: ocean_domain_type, ocean_grid_type, ocean_time_type, ocean_options_type
use ocean_types_mod,       only: ocean_prog_tracer_type, ocean_density_type, ocean_thickness_type
use ocean_util_mod,        only: write_timestamp, diagnose_2d, diagnose_3d, diagnose_sum
use ocean_util_mod,        only: write_chksum_2d, write_chksum_3d, write_chksum_2d_int
use ocean_tracer_util_mod, only: diagnose_3d_rho
use ocean_workspace_mod,   only: wrk1, wrk2, wrk3, wrk4, wrk5, wrk1_v

implicit none

private 

public ocean_mixdownslope_init
public mixdownslope

private watermass_diag_init
private watermass_diag

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

#include <ocean_memory.h>

integer, dimension(:,:), allocatable :: ip    ! shifting in i-direction
integer, dimension(:,:), allocatable :: jq    ! shifting in j-direction

real, dimension(:,:),     allocatable :: data              ! for reading in mask information 
real, dimension(:,:),     allocatable :: area_k            ! area on k-level, including tmask 
real, dimension(:,:),     allocatable :: slope_x           ! topog slope (dimensionless) in the i-direction
real, dimension(:,:),     allocatable :: slope_y           ! topog slope (dimensionless) in the j-direction 
real, dimension(:,:),     allocatable :: mixdownslope_mask ! mask=1 when apply mixdownslope, 0 otherwise
real, dimension(:,:,:),   allocatable :: topog_step        ! where downslope flow is topgraphically possible 
real, dimension(:,:,:),   allocatable :: tend_mix          ! (rho*dzt*tracer) tendency
real, dimension(:,:,:,:), allocatable :: mixdownslope_frac ! fraction of mixing occurring between two cells 

! fields with extended halos 
integer, dimension(:,:),     allocatable :: kmt_ex
integer, dimension(:,:,:),   allocatable :: kup_ex
integer, dimension(:,:,:,:), allocatable :: kdw_ex
real, dimension(:,:,:),   allocatable :: topog_slope_ex    
real, dimension(:,:,:),   allocatable :: topog_step_ex
real, dimension(:,:,:),   allocatable :: tracer_ex
real, dimension(:,:,:),   allocatable :: temp_ex
real, dimension(:,:,:),   allocatable :: salt_ex
real, dimension(:,:,:),   allocatable :: press_ex
real, dimension(:,:,:),   allocatable :: mass_ex
real, dimension(:,:,:),   allocatable :: rho_ex

! domain for mixdownslope 
type(ocean_domain_type), save :: Mixdownslope_domain 

! work array for eta_tend 
real, dimension(:,:,:),   allocatable :: theta_tend
real, dimension(:,:,:),   allocatable :: salt_tend


! internally set for computing watermass diagnstics
logical :: compute_watermass_diag = .false. 

! for global area normalization
real    :: cellarea_r

! for diagnostic manager 
logical :: used
integer :: id_slope_x=-1
integer :: id_slope_y=-1
integer :: id_topog_step_1       =-1
integer :: id_topog_step_2       =-1
integer :: id_topog_step_3       =-1
integer :: id_topog_step_4       =-1
integer :: id_mixdownslope_mask  =-1

integer :: id_neut_rho_mixdown          =-1
integer :: id_wdian_rho_mixdown         =-1
integer :: id_tform_rho_mixdown         =-1
integer :: id_neut_rho_mixdown_on_nrho  =-1
integer :: id_wdian_rho_mixdown_on_nrho =-1
integer :: id_tform_rho_mixdown_on_nrho =-1

integer :: id_eta_tend_mixdown     =-1
integer :: id_eta_tend_mixdown_glob=-1

integer :: id_neut_temp_mixdown          =-1
integer :: id_wdian_temp_mixdown         =-1
integer :: id_tform_temp_mixdown         =-1
integer :: id_neut_temp_mixdown_on_nrho  =-1
integer :: id_wdian_temp_mixdown_on_nrho =-1
integer :: id_tform_temp_mixdown_on_nrho =-1

integer :: id_neut_salt_mixdown          =-1
integer :: id_wdian_salt_mixdown         =-1
integer :: id_tform_salt_mixdown         =-1
integer :: id_neut_salt_mixdown_on_nrho  =-1
integer :: id_wdian_salt_mixdown_on_nrho =-1
integer :: id_tform_salt_mixdown_on_nrho =-1


integer, dimension(:), allocatable :: id_mixdownslope 
integer, dimension(:), allocatable :: id_mixdownslope_on_nrho 


character(len=128) :: version=&
       '=>Using: ocean_mixdownslope.f90 ($Id: ocean_mixdownslope.F90,v 20.0 2013/12/14 00:14:28 fms Exp $)'
character (len=128) :: tagname=&
     '$Name: tikal $'

! number of prognostic tracers
integer :: num_prog_tracers=0

! processor zero writes to unit 6
integer :: unit=6  

! initialization flag 
logical :: module_is_initialized=.false.

! flag for mpp_global_sum
integer :: global_sum_flag      

! halo 
integer :: ijhalo=1 

! time step 
real :: dtime 
real :: dtimer

! set from nml
logical :: use_this_module        = .false. ! must be set .true. in nml to enable this scheme
logical :: debug_this_module      = .false. ! for debugging
logical :: do_bitwise_exact_sum   = .false. ! set true to get slower sum that is same for all PEs. 
logical :: mixdownslope_weight_far= .false. ! to place more weight on points further from central point
logical :: read_mixdownslope_mask = .false. ! for applying a mask where do not apply mixdownslope
logical :: mixdownslope_mask_gfdl = .false. ! for case when applying GFDL regional mask
integer :: mixdownslope_npts      = 1       ! number horizontal points searched for the downslope mixing
integer :: mixdownslope_width     = 1       ! width for exponential that damps points near to central point
real    :: mixdownslope_frac_central =0.25  ! fraction of central cell participating in downslope mixing


namelist /ocean_mixdownslope_nml/ use_this_module, debug_this_module, mixdownslope_npts, &
                                  mixdownslope_width, mixdownslope_weight_far,           &
                                  mixdownslope_frac_central, do_bitwise_exact_sum,       &
                                  read_mixdownslope_mask, mixdownslope_mask_gfdl
                                 

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_mixdownslope_init">
!
! <DESCRIPTION>
! Initial set up for mixing of tracers into the abyss next to topography.
! </DESCRIPTION>
!
subroutine ocean_mixdownslope_init(Grid, Domain, Time, Dens, T_prog, Ocean_options, &
                                     vert_coordinate_type, dtim, debug)

  type(ocean_grid_type),        intent(in), target   :: Grid
  type(ocean_domain_type),      intent(in), target   :: Domain
  type(ocean_time_type),        intent(in), target   :: Time
  type(ocean_density_type),     intent(in)           :: Dens
  type(ocean_prog_tracer_type), intent(inout)        :: T_prog(:)
  type(ocean_options_type),     intent(inout)        :: Ocean_options
  integer,                      intent(in)           :: vert_coordinate_type 
  real,                         intent(in)           :: dtim
  logical,                      intent(in), optional :: debug

  integer :: io_status, ioun, ierr
  integer :: i,j,m,n,kbot

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
      call mpp_error(FATAL, &
           '==>Error from ocean_mixdownslope_mod (ocean_mixdownslope_init): module already initialized')
  endif

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)
#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  nk = Grid%nk
#endif
  Dom => Domain
  Grd => Grid

  dtime      = dtim 
  dtimer     = 1.0/dtime 
  cellarea_r = 1.0/(epsln + Grd%tcellsurf)

  num_prog_tracers = size(T_prog(:))

! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_mixdownslope_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_mixdownslope_nml')
#else
  ioun =  open_namelist_file()
  read (ioun,ocean_mixdownslope_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_mixdownslope_nml')
  call close_file (ioun)
#endif
  write (stdlogunit,ocean_mixdownslope_nml)
  write (stdoutunit,'(/)') 
  write (stdoutunit,ocean_mixdownslope_nml)

  if(do_bitwise_exact_sum) then
      global_sum_flag = BITWISE_EXACT_SUM
  else
      global_sum_flag = NON_BITWISE_EXACT_SUM
  endif

  if (PRESENT(debug) .and. .not. debug_this_module) then
      debug_this_module = debug
  endif
  if(debug_this_module) then 
      write(stdoutunit,'(a)') '==>Note: running ocean_mixdownslope_mod with debug_this_module=.true.'  
  endif

  if(.not. use_this_module) then 
      call mpp_error(NOTE,&
           '==>From ocean_mixdownslope_mod: NOT using downslope mixing scheme.')
      Ocean_options%mixdownslope = 'Did NOT use downslope mixing scheme.'
      return
  else 
      if(vert_coordinate_type == TERRAIN_FOLLOWING) then 
          call mpp_error(FATAL, &
               '==>ocean_mixdownslope_mod: this module is NOT for use with TERRAIN_FOLLOWING vert coodinates.')
      endif
      Ocean_options%mixdownslope = 'Used the downslope mixing scheme. This scheme is experimental!'
      call mpp_error(NOTE,&
           '==>From ocean_mixdownslope_mod: USING downslope mixing scheme.')
  endif
  if(debug_this_module) then 
      call mpp_error(NOTE,'==>From ocean_mixdownslope_mod: USING debug_this_module')
  endif

  ! allocate for tracer tendency array 
  allocate(tend_mix(isd:ied,jsd:jed,nk))
  tend_mix(:,:,:) = 0.0

  if(mixdownslope_npts<1) then
      call mpp_error(FATAL, &
           '==>ocean_mixdownslope_mod: mixdownslope_npts < 1 not allowed. In nml, set mixdownslope_npts>=1.')
  endif
  write(stdoutunit,'(a,i3)')' In ocean_mixdownslope_mod: mixdownslope_npts = ',mixdownslope_npts  
  write(stdoutunit,'(a)')   ' Be sure this number is smaller than dimensions of computational domain.'


  ! set mixdownslope_mask=0.0 in those regions where mixdownslope is NOT applied
  ! and mixdownslope_mask=1.0 in regions where mixdownslope is applied.  Default is 
  ! mixdownslope everywhere (mixdownslope_mask(:,:) = Grd%tmask(:,:,1)).  
  allocate(mixdownslope_mask(isd:ied,jsd:jed))
  mixdownslope_mask(:,:) = Grd%tmask(:,:,1)
  if(read_mixdownslope_mask) then 
      allocate(data(isd:ied,jsd:jed))
      call read_data('INPUT/mixdownslope_mask','mixdownslope_mask',data,Domain%domain2d)
      do j=jsc,jec
         do i=isc,iec
            mixdownslope_mask(i,j) = data(i,j)
         enddo
      enddo

      ! the following is specific to the mask used at GFDL for
      ! the OM3 ocean model configuration. 
      ! here, remove the Black Sea (labelled with 7.0), as this
      ! region contains some odd water masses which cause instabilities
      ! with the mixdownslope scheme. 
      if(mixdownslope_mask_gfdl) then 
          do j=jsc,jec
             do i=isc,iec
                if(mixdownslope_mask(i,j)==0.0 .or. mixdownslope_mask(i,j)==7.0) then 
                    mixdownslope_mask(i,j)=0.0
                else 
                    mixdownslope_mask(i,j)=1.0
                endif
             enddo
          enddo
      endif
      call mpp_update_domains(mixdownslope_mask(:,:), Dom%domain2d)
  endif


  ! halo size for extended domain and larger arrays 
  ijhalo=mixdownslope_npts

  ! k-level of central point in search 
  allocate(kup_ex(isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,4))
  kup_ex(:,:,:) = 0

  ! k-level of deeper points in horizontally adjacent columns 
  allocate(kdw_ex(isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,ijhalo,4))
  kdw_ex(:,:,:,:) = 0

  ! fraction of a cell participating in mixing 
  allocate(mixdownslope_frac(isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,ijhalo,4))
  mixdownslope_frac(:,:,:,:) = 0.0

  ! define extended domain 
  call set_ocean_domain(Mixdownslope_domain,Grd,xhalo=ijhalo,yhalo=ijhalo,&
                        name='mixdownslope',maskmap=Dom%maskmap)

  ! time independent arrays defined over Mixdownslope_domain 
  allocate(kmt_ex (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo))
  kmt_ex(:,:) = 0
  kmt_ex (isc:iec,jsc:jec) = Grd%kmt (isc:iec,jsc:jec)
  call mpp_update_domains (kmt_ex(:,:), Mixdownslope_domain%domain2d)

  ! time dependent arrays defined over Mixdownslope_domain
  allocate(temp_ex   (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,nk))
  allocate(salt_ex   (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,nk))
  allocate(tracer_ex (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,nk))
  allocate(press_ex  (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,nk))
  allocate(rho_ex    (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,nk))
  allocate(mass_ex   (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,nk))
  temp_ex(:,:,:)   = 0.0
  salt_ex(:,:,:)   = 0.0
  tracer_ex(:,:,:) = 0.0
  press_ex(:,:,:)  = 0.0
  rho_ex(:,:,:)    = 0.0
  mass_ex(:,:,:)   = 0.0

  ! area of cells on k-level, including tmask 
  allocate (area_k(isd:ied,jsd:jed))
  area_k(:,:) = 0.0

  ! compute topographic slope arrays for the i-slope and j-slope
  ! slopes are centered on the i-face and j-face of tracer cells 
  allocate (slope_x(isd:ied,jsd:jed))
  allocate (slope_y(isd:ied,jsd:jed))
  slope_x = 0.0 
  slope_y = 0.0
  do j=jsc,jec
     do i=isc,iec
        slope_x(i,j) = (Grd%ht(i+1,j)-Grd%ht(i,j))*Grd%dxter(i,j)*Grd%tmask(i,j,1)*Grd%tmask(i+1,j,1)
        slope_y(i,j) = (Grd%ht(i,j+1)-Grd%ht(i,j))*Grd%dytnr(i,j)*Grd%tmask(i,j,1)*Grd%tmask(i,j+1,1)
        slope_x(i,j) = abs(slope_x(i,j))
        slope_y(i,j) = abs(slope_y(i,j))
     enddo
  enddo
  call mpp_update_domains(slope_x(:,:),Dom%domain2d)
  call mpp_update_domains(slope_y(:,:),Dom%domain2d)

  ! topographic slope for the four surrounding directions 
  allocate (topog_slope_ex(isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,4))
  topog_slope_ex(:,:,:) = 0.0
  do j=jsc,jec
     do i=isc,iec
        m=1 ; topog_slope_ex(i,j,m) = slope_x(i,j)  
        m=2 ; topog_slope_ex(i,j,m) = slope_y(i,j)  
        m=3 ; topog_slope_ex(i,j,m) = slope_x(i-1,j)
        m=4 ; topog_slope_ex(i,j,m) = slope_y(i,j-1)
     enddo
  enddo
  call mpp_update_domains (topog_slope_ex(:,:,:), Mixdownslope_domain%domain2d)

  ! compute directions from an (i,j) point where topography deepens.
  ! these directions may potentially have downslope mixing. 
  ! insist that downslope mixing occurs only when there are more 
  ! kmt cells in the adjacent column. also insist that downslope 
  ! mixing does not involve k=1 cells. 
  allocate (topog_step(isd:ied,jsd:jed,4))
  topog_step(:,:,:) = 0.0
  do j=jsc,jec
     do i=isc,iec
        kbot = Grd%kmt(i,j)
        if(kbot > 1) then 
            if(Grd%kmt(i+1,j) > kbot) topog_step(i,j,1)=1.0
            if(Grd%kmt(i,j+1) > kbot) topog_step(i,j,2)=1.0
            if(Grd%kmt(i-1,j) > kbot) topog_step(i,j,3)=1.0
            if(Grd%kmt(i,j-1) > kbot) topog_step(i,j,4)=1.0
        endif
     enddo
  enddo
  ! block out the bipolar fold in order to ensure tracer conservation.
  ! The reason we do so is related to how the algorithm reaches between  
  ! adjacent columns of tracer points.  When the column straddles 
  ! the bipolar fold, the code logic is not general and so it actually 
  ! attempts to reach to a non-adjacent column.  Shy of generalizing 
  ! the logic, we simply do not consider mixdownslope for points along fold. 
  if(jec+Dom%joff==Dom%jeg) then 
      topog_step(:,jec,:) = 0.0
  endif

  ! fill the larger array 
  allocate (topog_step_ex(isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,4))
  topog_step_ex(:,:,:) = 0.0
  topog_step_ex(isc:iec,jsc:jec,:) = topog_step(isc:iec,jsc:jec,:)
  call mpp_update_domains (topog_step_ex(:,:,:), Mixdownslope_domain%domain2d)

  ! labels for the four quadranats surrounding a 
  ! central tracer cell (moving counter-clockwise)
  allocate(ip(0:ijhalo,4))
  allocate(jq(0:ijhalo,4))

  do n=0,ijhalo
     m=1 
     ip(n,m)   = 1+(n-1)
     jq(n,m)   = 0  

     m=2 
     ip(n,m)   = 0  
     jq(n,m)   = 1+(n-1)  

     m=3 
     ip(n,m)   = -1-(n-1) 
     jq(n,m)   = 0  

     m=4 
     ip(n,m)   =  0  
     jq(n,m)   = -1-(n-1)
  enddo

  ! register/send diagnostics 
  id_mixdownslope_mask = register_static_field ('ocean_model', 'mixdownslope_mask', &
       Grd%tracer_axes(1:2), &
       'mixdownslope mask', 'dimensionless', missing_value=missing_value, range=(/-1.0,1e4/))
  call diagnose_2d(Time, Grd, id_mixdownslope_mask, mixdownslope_mask(:,:))

  id_slope_x = register_static_field ('ocean_model', 'slope_x', Grd%tracer_axes_flux_x(1:2), &
       '|d(ht)/dx| on T-cell face', 'm/m', missing_value=missing_value, range=(/-1.e9,1.e9/))
  call diagnose_2d(Time, Grd, id_slope_x, slope_x(:,:))

  id_slope_y = register_static_field ('ocean_model', 'slope_y', Grd%tracer_axes_flux_y(1:2), &
       '|d(ht)/dy| on T-cell face', 'm/m', missing_value=missing_value, range=(/-1.e9,1.e9/))
  call diagnose_2d(Time, Grd, id_slope_y, slope_y(:,:))

  id_topog_step_1 = register_static_field ('ocean_model', 'topog_step_1', Grd%tracer_axes(1:2), &
       'topog_step_1', 'dimensionless', missing_value=missing_value, range=(/-1.0,1.0/))
  call diagnose_2d(Time, Grd, id_topog_step_1, topog_step(:,:,1))

  id_topog_step_2 = register_static_field ('ocean_model', 'topog_step_2', Grd%tracer_axes(1:2), &
       'topog_step_2', 'dimensionless', missing_value=missing_value, range=(/-1.0,1.0/))
  call diagnose_2d(Time, Grd, id_topog_step_2, topog_step(:,:,2))

  id_topog_step_3 = register_static_field ('ocean_model', 'topog_step_3', Grd%tracer_axes(1:2), &
       'topog_step_3', 'dimensionless', missing_value=missing_value, range=(/-1.0,1.0/))
  call diagnose_2d(Time, Grd, id_topog_step_3, topog_step(:,:,3))

  id_topog_step_4 = register_static_field ('ocean_model', 'topog_step_4', Grd%tracer_axes(1:2), &
       'topog_step_4', 'dimensionless', missing_value=missing_value, range=(/-1.0,1.0/))
  call diagnose_2d(Time, Grd, id_topog_step_4, topog_step(:,:,4))


  allocate (id_mixdownslope(num_prog_tracers))
  allocate (id_mixdownslope_on_nrho(num_prog_tracers))
  id_mixdownslope_on_nrho = -1
  id_mixdownslope = -1

  do n=1,num_prog_tracers
     if(T_prog(n)%name == 'temp') then 
         id_mixdownslope(n) = register_diag_field ('ocean_model', &
              'mixdownslope_'//trim(T_prog(n)%name),              &
              Grd%tracer_axes(1:3), Time%model_time,              &
              'cp*mixdownslope*rho*dzt*temp',                     &
              'Watt/m^2', missing_value=missing_value, range=(/-1.e9,1.e9/))
         id_mixdownslope_on_nrho(n) = register_diag_field ('ocean_model', &
              'mixdownslope_'//trim(T_prog(n)%name)//'_on_nrho',          &
              Dens%neutralrho_axes(1:3), Time%model_time,              &
              'cp*mixdownslope*rho*dzt*temp binned to neutral density',  &
              'Watt/m^2', missing_value=missing_value, range=(/-1.e20,1.e20/))
     else
         id_mixdownslope(n) = register_diag_field ('ocean_model', 'mixdownslope_'//trim(T_prog(n)%name), &
              Grd%tracer_axes(1:3), Time%model_time,                                                     &
              'mixdownslope*rho*dzt*tracer for '//trim(T_prog(n)%name),                                  &
              trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e9,1.e9/))
         id_mixdownslope_on_nrho(n) = register_diag_field ('ocean_model', &
              'mixdownslope_'//trim(T_prog(n)%name)//'_on_nrho',          &
              Dens%neutralrho_axes(1:3), Time%model_time,                                               &
              'mixdownslope*rho*dzt*tracer for '//trim(T_prog(n)%name)//' binned to neutral density',  &
              trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e20,1.e20/))
     endif
  enddo

  call watermass_diag_init(Time,Dens)

  if (debug_this_module) then
      write(stdoutunit,*) ' '
      write(stdoutunit,*) '==Global sums from initialization of ocean_mixdownslope_mod== '
      call write_timestamp(Time%model_time)
      write(stdoutunit,'(a,es24.17)') &
     'slope_x          = ',mpp_global_sum(Dom%domain2d,slope_x(:,:), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
     'slope_y          = ',mpp_global_sum(Dom%domain2d,slope_y(:,:), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
     'topog_slope_ex(1)= ',mpp_global_sum(Mixdownslope_domain%domain2d,topog_slope_ex(:,:,1), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
     'topog_slope_ex(2)= ',mpp_global_sum(Mixdownslope_domain%domain2d,topog_slope_ex(:,:,2), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
     'topog_slope_ex(3)= ',mpp_global_sum(Mixdownslope_domain%domain2d,topog_slope_ex(:,:,3), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
     'topog_slope_ex(4)= ',mpp_global_sum(Mixdownslope_domain%domain2d,topog_slope_ex(:,:,4), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
     'topog_step(1)    = ',mpp_global_sum(Dom%domain2d,topog_step(:,:,1), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
     'topog_step(2)    = ',mpp_global_sum(Dom%domain2d,topog_step(:,:,2), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
     'topog_step(3)    = ',mpp_global_sum(Dom%domain2d,topog_step(:,:,3), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
     'topog_step(4)    = ',mpp_global_sum(Dom%domain2d,topog_step(:,:,4), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
     'topog_step_ex(1) = ',mpp_global_sum(Mixdownslope_domain%domain2d,topog_step_ex(:,:,1), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
     'topog_step_ex(2) = ',mpp_global_sum(Mixdownslope_domain%domain2d,topog_step_ex(:,:,2), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
     'topog_step_ex(3) = ',mpp_global_sum(Mixdownslope_domain%domain2d,topog_step_ex(:,:,3), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
     'topog_step_ex(4) = ',mpp_global_sum(Mixdownslope_domain%domain2d,topog_step_ex(:,:,4), global_sum_flag)
  endif

end subroutine ocean_mixdownslope_init
! </SUBROUTINE> NAME="ocean_mixdownslope_init"


!#######################################################################
! <SUBROUTINE NAME="mixdownslope">
!
! <DESCRIPTION>
! Compute thickness and density weighted tracer tendency [tracer*rho*m/s]
! due to exchange of tracer properties in regions where density-driven
! downslope transport is favorable. 
!
! Allow for exchanges to occur over horizontally 
! distant points, so long as the dense shallow parcel finds that it 
! will sit on the bottom of the horizontally adjacent columns.  Doing
! so requires a search algorithm, which requires some if-test logic
! as well as extended halos.  Note that the halos cannot be extended
! to larger than the size of the computational domain on a processor.
! This restriction limits the extent that we can search horizontally.
!
! The rates for the exchange are functions of the topographic slope
! and the density differences between parcels.  
!
! This scheme can be characterized as a slope convection based on 
! logic incorporated into the overflow and overexchange schemes. 
!
! </DESCRIPTION>
!
subroutine mixdownslope (Time, Thickness, T_prog, Dens, index_temp, index_salt)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_density_type),     intent(in)    :: Dens
  integer,                      intent(in)    :: index_temp
  integer,                      intent(in)    :: index_salt

  integer :: tau, taum1
  integer :: i, j, k, m, n, nt, npts 
  integer :: kmtij, ku, kd
  integer :: iip0, iip1, jjq0, jjq1
  integer :: iip1r, jjq1r
  integer :: nm1

  real    :: temp_so, salt_so, press, density_check
  real    :: weight, arg
  real    :: delta, delta_rho(ijhalo)
  real    :: mass_sum, tmix
  real    :: mixdownslope_total, mixdownslope_total_r
  real    :: tendency

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return 

  if(.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_mixdownslope_mod (mixdownslope): module must be initialized')
  endif 

  tau     = Time%tau
  taum1   = Time%taum1

  delta_rho(:) = 0.0

  ! extend some fields to extended domain 
  rho_ex   = 0.0
  mass_ex  = 0.0
  press_ex = 0.0
  temp_ex  = 0.0
  salt_ex  = 0.0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           rho_ex(i,j,k)   = Dens%rho(i,j,k,tau) 
           mass_ex(i,j,k)  = Thickness%rho_dzt(i,j,k,tau)*Grd%dat(i,j) 
           press_ex(i,j,k) = Dens%pressure_at_depth(i,j,k)           
           temp_ex(i,j,k)  = T_prog(index_temp)%field(i,j,k,tau)           
           salt_ex(i,j,k)  = T_prog(index_salt)%field(i,j,k,tau)           
        enddo
     enddo
  enddo

  call mpp_update_domains(rho_ex(:,:,:),   Mixdownslope_domain%domain2d, complete=.false.)
  call mpp_update_domains(mass_ex(:,:,:),  Mixdownslope_domain%domain2d, complete=.false.)
  call mpp_update_domains(press_ex(:,:,:), Mixdownslope_domain%domain2d, complete=.false.)
  call mpp_update_domains(temp_ex(:,:,:),  Mixdownslope_domain%domain2d, complete=.false.)
  call mpp_update_domains(salt_ex(:,:,:),  Mixdownslope_domain%domain2d, complete=.true.)

  ! compute details for cells participating in downslope mixing
  ! note:  "so" = "shallow ocean" cell...the central point  
  ! note:  "do" = cells within "deep ocean" columns 
  ! this part of the compuatation is independent of the tracer 

  kup_ex(:,:,:)              = 0
  kdw_ex(:,:,:,:)            = 0
  mixdownslope_frac(:,:,:,:) = 0.0

  do j=jsc,jec
     do i=isc,iec

        kmtij   = max(1,kmt_ex(i,j))
        temp_so = temp_ex(i,j,kmtij)
        salt_so = Dens%rho_salinity(i,j,kmtij,tau)

        ! 4-directions surrounding each cell 
        do m=1,4

           ! search for density favorable mixing 
           npts=0 
           nloop1_npts: do n=1,mixdownslope_npts

              iip0 = i+ip(n-1,m)
              jjq0 = j+jq(n-1,m)
              iip1 = i+ip(n,m)
              jjq1 = j+jq(n,m)

              ! check if downslope mixing is topographically possible
              if(topog_step_ex(iip0,jjq0,m)==1.0) then  

                  ! check if density of shallow ocean cell > density of deep ocean cell  
                  if(rho_ex(i,j,kmtij) > rho_ex(iip1,jjq1,kmtij)) then   

                      ! kdw = k-level in do-column where central cell is neutrally buoyant (or at bottom) 
                      kdw_ex(i,j,n,m) = 0
                      kloop1 : do k=kmtij+1,kmt_ex(iip1,jjq1)
                         press         = press_ex(iip1,jjq1,k)
                         density_check = density(salt_so,temp_so,press)
                         if(density_check > rho_ex(iip1,jjq1,k)) then 
                             kdw_ex(i,j,n,m) = k
                             delta_rho(n)    = density_check-rho_ex(iip1,jjq1,k) 
                         else 
                             exit kloop1
                         endif
                      enddo kloop1

                      ! check that the n-parcel has a k-level greater than the n-1 parcel.
                      ! if not, then do not mix with the n-column.
                      nm1 = max(n-1,1)
                      if(n > 1) then 
                          if(kdw_ex(i,j,n,m) <= kdw_ex(i,j,nm1,m)) then  
                              kdw_ex(i,j,n,m) = 0
                          endif  
                      endif

                      ! set strength of downslope mixing between central cell and n-parcel 
                      if(kdw_ex(i,j,n,m) > 0) then 

                          ! add this cell to the number of cells participating in mixing 
                          npts=npts+1

                          if(n==1) then 
                             kup_ex(i,j,m) = kmtij
                             delta = rho_ex(i,j,kmtij)-rho_ex(iip1,jjq1,kmtij)
                          else 
                             delta = delta_rho(n)
                          endif 

                          ! compute mixing weight as product of slope and density difference 
                          mixdownslope_frac(i,j,n,m) = topog_slope_ex(iip0,jjq0,m)*delta 

                      endif  ! kdw_ex(i,j,n,m) > 0 if-test 

                  endif      ! rho_ex(i,j,k) > rho_ex(iip1,jjq1,k) if-test 
              endif          ! topog_step_ex(iip0,jjq0,m)==1.0 if-test


              ! if kdw is not on the bottom, then exit n-loop since finished with search 
              if(kdw_ex(i,j,n,m) < kmt_ex(iip1,jjq1)) then 
                  exit nloop1_npts
              endif

           enddo nloop1_npts ! n-loop for horizontal search reaching out from central point

           
           ! place more weight on the farther points to 
           ! encourage tracer exchange further downslope.  
           if(mixdownslope_weight_far .and. npts > 0) then 
               weight = mixdownslope_frac(i,j,1,m)
               do n=1,npts
                  arg = float((n-npts)/mixdownslope_width)
                  mixdownslope_frac(i,j,n,m) = weight*exp(arg)
               enddo
           endif 

           ! normalize mixdownslope_frac to set fraction of
           ! a cell that is being mixed with central cell. 
           if(npts > 0) then 
               mixdownslope_total=0.0
               do n=1,npts
                  mixdownslope_total = mixdownslope_total + mixdownslope_frac(i,j,n,m)   
               enddo
               mixdownslope_total_r = 1.0/(mixdownslope_total+epsln)
               do n=1,npts
                  mixdownslope_frac(i,j,n,m) = mixdownslope_frac(i,j,n,m)*mixdownslope_total_r
               enddo
           endif

           ! if no exchange points 
           if(npts==0) then 
               mixdownslope_frac(i,j,:,m) = 0.0
           endif

        enddo  ! m-loop
     enddo     ! i-loop
  enddo        ! j-loop


  ! extend arrays to wide halos 
  call mpp_update_domains(kup_ex(:,:,:),              Mixdownslope_domain%domain2d)
  call mpp_update_domains(kdw_ex(:,:,:,:),            Mixdownslope_domain%domain2d)
  call mpp_update_domains(mixdownslope_frac(:,:,:,:), Mixdownslope_domain%domain2d)


  ! compute tracer tendency for cells participating in downslope mixing 
  do nt=1,num_prog_tracers 

     ! place tracer concentration in the wider array tracer_ex 
     if(nt==index_temp) then 
         do k=1,nk
            do j=jsc-ijhalo,jec+ijhalo
               do i=isc-ijhalo,iec+ijhalo
                  tracer_ex(i,j,k) = temp_ex(i,j,k)
               enddo
            enddo
         enddo
     elseif(nt==index_salt) then 
         do k=1,nk
            do j=jsc-ijhalo,jec+ijhalo
               do i=isc-ijhalo,iec+ijhalo
                  tracer_ex(i,j,k) = salt_ex(i,j,k)
               enddo
            enddo
         enddo
     else
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  tracer_ex(i,j,k) = T_prog(nt)%field(i,j,k,tau)
               enddo
            enddo
         enddo
         call mpp_update_domains (tracer_ex(:,:,:), Mixdownslope_domain%domain2d)
     endif

     ! compute tendency, noting that each (i,j,k) cell can generally be part
     ! of mixing as either a central shallow cell (n=0), or as one of the deep cells (n>0). 
     ! for the tendency, we compute a mixing tracer concentration between two cells, 
     ! and then back-out a tendency which is placed in tend_mix.

     tend_mix(:,:,:) = 0.0
     do j=jsc,jec
        do i=isc,iec
           do m=1,4
              do n=1,mixdownslope_npts

                 ! i,j is central cell at k=ku
                 iip1 = i+ip(n,m)
                 jjq1 = j+jq(n,m)
                 ku   = kup_ex(i,j,m) 
                 kd   = kdw_ex(i,j,n,m) 
                 if(ku > 0 .and. kd > ku) then 
                     mass_sum = mixdownslope_frac_central*mass_ex(i,j,ku) &
                               +mixdownslope_frac(i,j,n,m)*mass_ex(iip1,jjq1,kd)
                     tmix = (mixdownslope_frac_central*mass_ex(i,j,ku)*tracer_ex(i,j,ku)               &
                            +mixdownslope_frac(i,j,n,m)*mass_ex(iip1,jjq1,kd)*tracer_ex(iip1,jjq1,kd)) &
                             /mass_sum
                     tendency = dtimer*mixdownslope_frac_central*mass_ex(i,j,ku)/Grd%dat(i,j) &
                                *(tmix-tracer_ex(i,j,ku))
                     tend_mix(i,j,ku) = tend_mix(i,j,ku) + tendency 
                 endif 

                 ! i,j is deep cell at k=kd
                 iip1r = i-ip(n,m)
                 jjq1r = j-jq(n,m)
                 ku    = kup_ex(iip1r,jjq1r,m) 
                 kd    = kdw_ex(iip1r,jjq1r,n,m) 
                 if(ku > 0 .and. kd > ku) then 
                     mass_sum = mixdownslope_frac_central*mass_ex(iip1r,jjq1r,ku) &
                               +mixdownslope_frac(iip1r,jjq1r,n,m)*mass_ex(i,j,kd)
                     tmix = (mixdownslope_frac_central                          &
                             *mass_ex(iip1r,jjq1r,ku)*tracer_ex(iip1r,jjq1r,ku) &
                            +mixdownslope_frac(iip1r,jjq1r,n,m)                 &
                             *mass_ex(i,j,kd)*tracer_ex(i,j,kd))                & 
                            /mass_sum
                     tendency = dtimer*mixdownslope_frac(iip1r,jjq1r,n,m)*mass_ex(i,j,kd)/Grd%dat(i,j) &
                                *(tmix-tracer_ex(i,j,kd))
                     tend_mix(i,j,kd) = tend_mix(i,j,kd) + tendency 
                 endif 

              enddo ! n-loop 
           enddo    ! m-loop
        enddo       ! i-loop
     enddo          ! j-loop


     ! fill tracer tendency array 
     do k=1,nk
        do j=jsc,jec   
           do i=isc,iec
              T_prog(nt)%th_tendency(i,j,k) = T_prog(nt)%th_tendency(i,j,k) &
                                             +tend_mix(i,j,k)*mixdownslope_mask(i,j)
           enddo
        enddo
     enddo

     if(id_mixdownslope(nt) > 0 .or. id_mixdownslope_on_nrho(nt) > 0) then
         wrk1(:,:,:) = 0.0
         do k=1,nk
            do j=jsc,jec   
               do i=isc,iec
                  wrk1(i,j,k) = tend_mix(i,j,k)*mixdownslope_mask(i,j)*T_prog(nt)%conversion
               enddo
            enddo
         enddo
         if (id_mixdownslope(nt) > 0) then
            call diagnose_3d(Time, Grd, id_mixdownslope(nt), wrk1(:,:,:))
         endif
         if (id_mixdownslope_on_nrho(nt) > 0) then
            call diagnose_3d_rho(Time, Dens, id_mixdownslope_on_nrho(nt), wrk1)
         endif
     endif

     if(nt==index_temp) then 
         theta_tend(:,:,:) = 0.0
         do k=1,nk
            do j=jsc,jec   
               do i=isc,iec
                  theta_tend(i,j,k) = tend_mix(i,j,k)*mixdownslope_mask(i,j)
               enddo
            enddo
         enddo
     endif
     if(nt==index_salt) then 
         salt_tend(:,:,:) = 0.0
         do k=1,nk
            do j=jsc,jec   
               do i=isc,iec
                  salt_tend(i,j,k) = tend_mix(i,j,k)*mixdownslope_mask(i,j)
               enddo
            enddo
         enddo
     endif

     if(debug_this_module) then 
         write(stdoutunit,*) ' '
         write(stdoutunit,*) '==Global sums for tendency from ocean_mixdownslope_mod== '
         call write_timestamp(Time%model_time)
         do k=1,nk
            area_k(:,:) = Grd%dat(:,:)*Grd%tmask(:,:,k)  
            tend_mix(:,:,k) = dtime*tend_mix(:,:,k)*area_k(:,:)*T_prog(nt)%conversion
            write(stdoutunit,'(a,i2,a,i2,a,es24.17)') 'tend_mix(',nt,',',k,') = ',&
                 mpp_global_sum(Dom%domain2d,tend_mix(:,:,k))
         enddo
         write(stdoutunit,'(a,i2,a,es24.17)') &
              'tend_mix(',nt,')  = ',&
              mpp_global_sum(Dom%domain2d,tend_mix(:,:,:), global_sum_flag)
     endif


  enddo  ! nt-end for num_prog_tracers 

  call watermass_diag(Time, Dens)

  if (debug_this_module) then
      write(stdoutunit,*) ' '
      write(stdoutunit,*) '==Global sums from ocean_mixdownslope_mod== '
      call write_timestamp(Time%model_time)

      write(stdoutunit,'(a,es24.17)') &
           'rho_ex            = ',&
           mpp_global_sum(Mixdownslope_domain%domain2d,rho_ex(:,:,:), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
           'mass_ex        = ',&
           mpp_global_sum(Mixdownslope_domain%domain2d,mass_ex(:,:,:), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
           'press_ex          = ',&
           mpp_global_sum(Mixdownslope_domain%domain2d,press_ex(:,:,:), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
           'temp_ex           = ',&
           mpp_global_sum(Mixdownslope_domain%domain2d,temp_ex(:,:,:), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
           'salt_ex           = ',&
           mpp_global_sum(Mixdownslope_domain%domain2d,salt_ex(:,:,:), global_sum_flag)
      write(stdoutunit,'(a,i24)') &
           'kmt_ex            = ',&
           mpp_global_sum(Mixdownslope_domain%domain2d,kmt_ex(:,:), global_sum_flag)

      do m=1,4
         write(stdoutunit,'(a,i24)') &
              'kup_ex            = ',  &
              mpp_global_sum(Mixdownslope_domain%domain2d,kup_ex(:,:,m), global_sum_flag)
         do n=1,mixdownslope_npts
            write(stdoutunit,'(a,es24.17)') &
                 'mixdownslope_frac  = ',  &
                 mpp_global_sum(Mixdownslope_domain%domain2d,mixdownslope_frac(:,:,n,m), global_sum_flag)
            write(stdoutunit,'(a,i24)') &
                 'kdw_ex            = ',  &
                 mpp_global_sum(Mixdownslope_domain%domain2d,kdw_ex(:,:,n,m), global_sum_flag)
         enddo
      enddo

      write(stdoutunit,*) ' '
      write(stdoutunit,*) '==Global check sums from ocean_mixdownslope_mod== '
      call write_timestamp(Time%model_time)
      call write_chksum_3d('rho_ex', rho_ex(COMP,:))
      call write_chksum_3d('mass_ex', mass_ex(COMP,:))
      call write_chksum_3d('press_ex', press_ex(COMP,:))
      call write_chksum_3d('temp_ex', temp_ex(COMP,:))
      call write_chksum_3d('salt_ex', salt_ex(COMP,:))
      call write_chksum_2d_int('kmt_ex', kmt_ex(COMP))
      do m=1,4
         call write_chksum_2d_int('kup_ex', kup_ex(COMP,m))
         do n=1,mixdownslope_npts
            call write_chksum_2d_int('kdw_ex', kdw_ex(COMP,n,m))
            call write_chksum_2d('mixdownslope_frac', mixdownslope_frac(COMP,n,m))
         enddo
      enddo

  endif

end subroutine mixdownslope
! </SUBROUTINE> NAME="mixdownslope"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag_init">
!
! <DESCRIPTION>
! Initialization of watermass diagnostic output files. 
! </DESCRIPTION>
!
subroutine watermass_diag_init(Time, Dens)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens

  integer :: stdoutunit
  stdoutunit=stdout()
  compute_watermass_diag = .false. 

  id_neut_rho_mixdown = register_diag_field ('ocean_model', 'neut_rho_mixdown',&
    Grd%tracer_axes(1:3), Time%model_time,                                     &
    'update of locally referenced potential density from mixdowslope',         &
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_rho_mixdown > 0) compute_watermass_diag = .true.

  id_wdian_rho_mixdown = register_diag_field ('ocean_model', 'wdian_rho_mixdown',&
    Grd%tracer_axes(1:3), Time%model_time,                                       &
    'dianeutral mass transport due to mixdowslope',                              &
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_rho_mixdown > 0) compute_watermass_diag = .true.

  id_tform_rho_mixdown = register_diag_field ('ocean_model', 'tform_rho_mixdown',&
    Grd%tracer_axes(1:3), Time%model_time,                                       &
    'watermass transform due to mixdowslope on levels (pre-layer binning)',      &
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_rho_mixdown > 0) compute_watermass_diag = .true.

  id_neut_rho_mixdown_on_nrho = register_diag_field ('ocean_model',                    &
    'neut_rho_mixdown_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,            &
    'update of local ref potrho from mixdownslope as binned to neutral density layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_rho_mixdown_on_nrho > 0) compute_watermass_diag = .true.

  id_wdian_rho_mixdown_on_nrho = register_diag_field ('ocean_model',                  &
   'wdian_rho_mixdown_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,           &
   'dianeutral mass transport due to mixdowslope as binned to neutral density layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_rho_mixdown_on_nrho > 0) compute_watermass_diag = .true.

  id_tform_rho_mixdown_on_nrho = register_diag_field ('ocean_model',            &
   'tform_rho_mixdown_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,     &
   'watermass transform due to mixdowslope as binned to neutral density layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_rho_mixdown_on_nrho > 0) compute_watermass_diag = .true.

  id_eta_tend_mixdown= -1          
  id_eta_tend_mixdown= register_diag_field ('ocean_model','eta_tend_mixdown',&
       Grd%tracer_axes(1:2), Time%model_time,                                &
       'non-Bouss steric sea level tendency from mixdown tendency', 'm/s',   &
       missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_mixdown > 0) compute_watermass_diag=.true.

  id_eta_tend_mixdown_glob= -1          
  id_eta_tend_mixdown_glob= register_diag_field ('ocean_model', 'eta_tend_mixdown_glob',&
       Time%model_time,                                                                 &
       'global mean non-bouss steric sea level tendency from mixdown tendency',         &
       'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_mixdown_glob > 0) compute_watermass_diag=.true.


  ! temp contributions 
  id_neut_temp_mixdown = register_diag_field ('ocean_model', 'neut_temp_mixdown',  &
    Grd%tracer_axes(1:3), Time%model_time,                                         &
    'temp related update of locally referenced potential density from mixdowslope',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_temp_mixdown > 0) compute_watermass_diag = .true.

  id_wdian_temp_mixdown = register_diag_field ('ocean_model', 'wdian_temp_mixdown',&
    Grd%tracer_axes(1:3), Time%model_time,                                         &
    'temp related dianeutral mass transport due to mixdowslope',                   &
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_temp_mixdown > 0) compute_watermass_diag = .true.

  id_tform_temp_mixdown = register_diag_field ('ocean_model', 'tform_temp_mixdown',     &
    Grd%tracer_axes(1:3), Time%model_time,                                              &
    'temp related watermass transform due to mixdowslope on levels (pre-layer binning)',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_temp_mixdown > 0) compute_watermass_diag = .true.

  id_neut_temp_mixdown_on_nrho = register_diag_field ('ocean_model',                               &
   'neut_temp_mixdown_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                        &
   'temp related update of local ref potrho from mixdownslope as binned to neutral density layers',&
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_temp_mixdown_on_nrho > 0) compute_watermass_diag = .true.

  id_wdian_temp_mixdown_on_nrho = register_diag_field ('ocean_model',                               &
    'wdian_temp_mixdown_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
    'temp related dianeutral mass transport due to mixdowslope as binned to neutral density layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_temp_mixdown_on_nrho > 0) compute_watermass_diag = .true.

  id_tform_temp_mixdown_on_nrho = register_diag_field ('ocean_model',                          &
     'tform_temp_mixdown_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                 &
     'temp related watermass transform due to mixdowslope as binned to neutral density layers',&
     'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_temp_mixdown_on_nrho > 0) compute_watermass_diag = .true.


  ! salt contributions 
  id_neut_salt_mixdown = register_diag_field ('ocean_model', 'neut_salt_mixdown',  &
    Grd%tracer_axes(1:3), Time%model_time,                                         &
    'salt related update of locally referenced potential density from mixdowslope',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_salt_mixdown > 0) compute_watermass_diag = .true.

  id_wdian_salt_mixdown = register_diag_field ('ocean_model', 'wdian_salt_mixdown',&
    Grd%tracer_axes(1:3), Time%model_time,                                         &
    'salt related dianeutral mass transport due to mixdowslope',                   &
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_salt_mixdown > 0) compute_watermass_diag = .true.

  id_tform_salt_mixdown = register_diag_field ('ocean_model', 'tform_salt_mixdown',     &
    Grd%tracer_axes(1:3), Time%model_time,                                              &
    'salt related watermass transform due to mixdowslope on levels (pre-layer binning)',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_salt_mixdown > 0) compute_watermass_diag = .true.

  id_neut_salt_mixdown_on_nrho = register_diag_field ('ocean_model',                               &
   'neut_salt_mixdown_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                        &
   'salt related update of local ref potrho from mixdownslope as binned to neutral density layers',&
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_salt_mixdown_on_nrho > 0) compute_watermass_diag = .true.

  id_wdian_salt_mixdown_on_nrho = register_diag_field ('ocean_model',                               &
    'wdian_salt_mixdown_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
    'salt related dianeutral mass transport due to mixdowslope as binned to neutral density layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_salt_mixdown_on_nrho > 0) compute_watermass_diag = .true.

  id_tform_salt_mixdown_on_nrho = register_diag_field ('ocean_model',                          &
     'tform_salt_mixdown_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                 &
     'salt related watermass transform due to mixdowslope as binned to neutral density layers',&
     'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_salt_mixdown_on_nrho > 0) compute_watermass_diag = .true.


  allocate(theta_tend(isd:ied,jsd:jed,nk))
  allocate(salt_tend(isd:ied,jsd:jed,nk))
  theta_tend(:,:,:) = 0.0
  salt_tend(:,:,:)  = 0.0

  if(compute_watermass_diag) then 
    write(stdoutunit,'(/a/)') &
    '==>Note: running ocean_mixdownslope_mod w/ compute_watermass_diag=.true. to compute some watermass diagnostics.'  
  endif 


end subroutine watermass_diag_init
! </SUBROUTINE> NAME="watermass_diag_init"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag">
!
! <DESCRIPTION>
! Diagnose effects from mixdownslope on the watermass transformation.
! </DESCRIPTION>
!
subroutine watermass_diag(Time, Dens)

  type(ocean_time_type),         intent(in) :: Time
  type(ocean_density_type),      intent(in) :: Dens

  integer :: i,j,k,tau
  real, dimension(isd:ied,jsd:jed) :: eta_tend

  if (.not. module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_mixdownslope (watermass_diag): module needs initialization ')
  endif 

  if(.not. compute_watermass_diag) return 

  tau = Time%tau 

  ! rho diagnostics = sum of temp + salt contributions 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Grd%tmask(i,j,k)* &
             (Dens%drhodT(i,j,k)*theta_tend(i,j,k)+Dens%drhodS(i,j,k)*salt_tend(i,j,k))
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)  
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
           wrk5(i,j,k) =-wrk1(i,j,k)/(epsln+Dens%rho(i,j,k,tau)**2)  ! for eta_tend 
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_mixdown, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_mixdown, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_mixdown, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_mixdown_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_mixdown_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_mixdown_on_nrho, wrk4)

  if(id_eta_tend_mixdown > 0 .or. id_eta_tend_mixdown_glob > 0) then
      eta_tend(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               eta_tend(i,j) = eta_tend(i,j) + wrk5(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_eta_tend_mixdown, eta_tend(:,:))
      call diagnose_sum(Time, Grd, Dom, id_eta_tend_mixdown_glob, eta_tend, cellarea_r)
  endif


  ! temp contributions 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Grd%tmask(i,j,k)*Dens%drhodT(i,j,k)*theta_tend(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)  
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_mixdown, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_mixdown, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_temp_mixdown, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_mixdown_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_mixdown_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_mixdown_on_nrho, wrk4)

  ! salinity contributions 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Grd%tmask(i,j,k)*Dens%drhodS(i,j,k)*salt_tend(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)  
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_mixdown, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_mixdown, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_salt_mixdown, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_mixdown_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_mixdown_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_mixdown_on_nrho, wrk4)


end subroutine watermass_diag
! </SUBROUTINE>  NAME="watermass_diag"


end module ocean_mixdownslope_mod

module ocean_nphysicsB_mod
#define COMP isc:iec,jsc:jec
#define COMPXL isc-1:iec,jsc:jec
#define COMPYL isc:iec,jsc-1:jec
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<CONTACT EMAIL="Russell.Fiedler@csiro.au"> Russell Fiedler 
!</CONTACT>
!
!<REVIEWER EMAIL="tim.leslie@gmail.com"> Tim Leslie
!</REVIEWER>
!  
!<OVERVIEW>
! Thickness weighted and density weighted time tendency for tracer 
! from Laplacian neutral diffusion + Laplacian GM skew-diffusion.
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes the cell thickness weighted and density 
! weighted tracer tendency from small angle Laplacian neutral diffusion
! plus Laplacian GM skew-diffusion.  The methods here differ from 
! ocean_nphysicsA in the treatment of fluxes in the boundary
! regions. This module is experimental, and should be used with caution. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies, A. Gnanadesikan, R.C. Pacanowski, V. Larichev, 
! J.K. Dukowicz,  and R.D. Smith
! Isoneutral diffusion in a z-coordinate ocean model
! Journal of Physical Oceanography (1998) vol 28 pages 805-830
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies 
! The Gent-McWilliams Skew-flux 
! Journal of Physical Oceanography (1998) vol 28 pages 831-841
! </REFERENCE>
!
! <REFERENCE>
! R. Ferrari and J.C. McWilliams and Canuto and Dubovikov  
! Parameterization of eddy fluxes near oceanic boundaries
! Journal of Climate (2008). 
! </REFERENCE>
!
! <REFERENCE>
! Large etal (1997), Journal of Physical Oceanography, 
! pages 2418-2447 
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies 
! Fundamentals of Ocean Climate Models (2004)
! Princeton University Press 
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, Elements of MOM (2012)
! </REFERENCE>
!
! <NOTE>
! Revisions made for MOM4p1 in Sept 2005, Jan/Feb 2006,
! and June 2008 by Stephen.Griffies. The June 2008
! revision greatly simplified the boundary layer formulation
! from Ferrari and McWilliams, whereby the quadratic transition
! layer is eliminated, thus removing the need to match vertical
! derivatives of the streamfunction.  The matching conditions
! implied by the transition zone added a tremendous amount 
! of code that was not seen to be critical for the purpose 
! of producing a reasonably smooth streamfunction.  
! </NOTE> 
!
! <NOTE>
! Numerical implementation of the flux components follows the triad 
! approach documented in the references and implemented in MOM2 and MOM3.  
! The MOM algorithm accounts for partial bottom cells and generalized
! orthogonal horizontal coordinates.
! </NOTE> 
!
! <NOTE>
! Note: the option neutral_physics_simple is not supported in this 
! module.  Use nphysicA for that option. 
! </NOTE> 
!
! </INFO>
!
!<NAMELIST NAME="ocean_nphysicsB_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For printing starting and ending checksums for restarts
!  </DATA> 
!
!  <DATA NAME="use_gm_skew" TYPE="logical">
!  Must be true to use GM skewsion.  Set to false if wish to 
!  incorporate the "GM-effect" through form drag, as in 
!  ocean_form_drag module. Default use_gm_skew=.true. 
!  </DATA> 
!
!  <DATA NAME="diffusion_all_explicit" TYPE="logical">
!  To compute all contributions from neutral diffusion explicitly in time, including
!  the K33 diagonal piece.  This approach is available only when have small time 
!  steps and/or running with just a single tracer.  It is for testing purposes. 
!  </DATA> 
!
!  <DATA NAME="neutral_physics_limit" TYPE="logical">
!  When tracer falls outside a specified range, revert to horizontal 
!  diffusive fluxes at this cell. This is an ad hoc and incomplete attempt
!  to maintain monotonicity with the neutral physics scheme.  
!  Default neutral_physics_limit=.true.
!  </DATA> 
!  <DATA NAME="tmask_neutral_on" TYPE="logical">
!  If .true. then this logical reduces the neutral fluxes to 
!  horizontal/vertical diffusion next to boundaries.  
!  This approach has been found to reduce spurious 
!  extrema resulting from truncation of triads used to compute 
!  a neutral flux component.  Default tmask_neutral_on=.false.    
!  </DATA> 
!
!  <DATA NAME="surf_turb_thick_min_k" TYPE="integer">
!  Minimum number of k-levels in surface turbulent boundary
!  layer used in the transition of the neutral physics fluxes
!  to the surface. Default surf_turb_thick_min_k = 2.
!  </DATA> 
!  <DATA NAME="surf_turb_thick_min" TYPE="real">
!  Minimum thickness of surface turbulent boundary layer
!  used in the transition of the neutral physics fluxes
!  to the surface. Default surf_turb_thick_min=20m.
!  </DATA> 
!
!  <DATA NAME="neutral_damping_time" UNITS="days" TYPE="real">
!  The damping time used for determining the effective surface
!  boundary layer thickness from other portions of
!  the model. Default neutral_damping_time=10days.  
!  </DATA> 
!
!  <DATA NAME="nblayer_smooth" TYPE="logical">
!  For smoothing the neutral blayer fields. This is useful
!  when aiming to produce a smooth quasi-stokes streamfunction 
!  within the boundary layers. Default is nblayer_smooth=.true.
!  </DATA> 
!  <DATA NAME="vel_micom_smooth" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM Laplacian mixing 
!  coefficient used in the Laplacian smoothing of neutral blayer fields. 
!  </DATA> 
!
!</NAMELIST>

use constants_mod,           only: epsln, pi
use diag_manager_mod,        only: register_diag_field, register_static_field, need_data
use fms_mod,                 only: FATAL, WARNING, NOTE
use fms_mod,                 only: file_exist
use fms_mod,                 only: open_namelist_file, check_nml_error, close_file, write_version_number
use fms_io_mod,              only: register_restart_field, save_restart, restore_state
use fms_io_mod,              only: restart_file_type
use mpp_domains_mod,         only: mpp_update_domains
use mpp_domains_mod,         only: CGRID_NE, WUPDATE, SUPDATE, EUPDATE, NUPDATE
use mpp_domains_mod,         only: cyclic_global_domain, global_data_domain 
use mpp_mod,                 only: input_nml_file, mpp_error, stdout, stdlog
use mpp_mod,                 only: mpp_clock_id, mpp_clock_begin, mpp_clock_end, CLOCK_ROUTINE
use time_manager_mod,        only: set_time, time_type, increment_time, operator ( + )

use ocean_domains_mod,           only: get_local_indices, set_ocean_domain
use ocean_nphysics_util_mod,     only: ocean_nphysics_coeff_init, ocean_nphysics_coeff_end
use ocean_nphysics_util_mod,     only: neutral_slopes, tracer_derivs 
use ocean_nphysics_util_mod,     only: compute_eady_rate, compute_baroclinicity
use ocean_nphysics_util_mod,     only: compute_rossby_radius, compute_bczone_radius
use ocean_nphysics_util_mod,     only: compute_diffusivity, ocean_nphysics_util_restart
use ocean_nphysics_util_mod,     only: transport_on_nrho_gm, transport_on_rho_gm, transport_on_theta_gm
use ocean_nphysics_util_mod,     only: compute_eta_tend_gm90
use ocean_nphysics_util_mod,     only: cabbeling_thermob_tendency
use ocean_nphysics_util_mod,     only: watermass_diag_init, watermass_diag 
use ocean_operators_mod,         only: FAX, FAY, FMX, FMY, BDX_ET, BDY_NT, LAP_T
use ocean_parameters_mod,        only: missing_value, onehalf, onefourth, oneeigth, DEPTH_BASED
use ocean_parameters_mod,        only: rho0r, rho0, m3toSv, grav
use ocean_sigma_transport_mod,   only: tmask_sigma_on, tmask_sigma  
use ocean_types_mod,             only: ocean_grid_type, ocean_domain_type, ocean_density_type
use ocean_types_mod,             only: ocean_prog_tracer_type, ocean_thickness_type
use ocean_types_mod,             only: ocean_time_type, ocean_time_steps_type
use ocean_types_mod,             only: tracer_2d_type, tracer_3d_0_nk_type, tracer_3d_1_nk_type 
use ocean_util_mod,              only: write_timestamp, write_chksum_2d, write_note
use ocean_util_mod,              only: write_warning, write_line, write_chksum_header
use ocean_util_mod,              only: diagnose_2d, diagnose_3d
use ocean_workspace_mod,         only: wrk1, wrk3, wrk1_v

use ocean_pik_diag_mod,        only: ocean_pik_diag_init_ty_trans_gm, do_pik_diag

implicit none

public ocean_nphysicsB_init
public ocean_nphysicsB_end
public nphysicsB
public ocean_nphysicsB_restart

private fx_flux
private fy_flux
private fz_flux
private fz_terms
private fx_flux_diag
private fy_flux_diag
private fz_terms_diag 
private fz_flux_diag
private neutral_blayer
private neutral_chksums
private nphysics_diagnostics

private 

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_domain_type), save    :: Dom_flux

integer :: num_prog_tracers = 0

! clock ids
integer :: id_clock_neutral_blayer
integer :: id_clock_fz_terms 
integer :: id_clock_fx_flux
integer :: id_clock_fy_flux
integer :: id_clock_fz_flux
integer :: id_clock_fx_flux_diag
integer :: id_clock_fy_flux_diag
integer :: id_clock_fz_flux_diag
integer :: id_clock_fz_terms_diag

! diagnostic manager ids
logical :: used
integer :: id_k33_explicit          =-1
integer :: id_tx_trans_gm           =-1
integer :: id_ty_trans_gm           =-1
integer :: id_surf_turb_thick       =-1
integer :: id_surf_trans_thick      =-1
integer :: id_depth_blayer_base     =-1
integer :: id_full_turb_column      =-1
integer :: id_slope_blayer_base     =-1
integer :: id_grav_agm_dz_sx_drhodx =-1
integer :: id_grav_agm_dz_sy_drhody =-1
integer :: id_gm_eddy_ke_source     =-1
integer :: id_slopex_drhodx         =-1
integer :: id_slopey_drhody         =-1

integer, dimension(:), allocatable  :: id_k33_implicit
integer, dimension(:), allocatable  :: id_neutral_physics
integer, dimension(:), allocatable  :: id_neutral_physics_ndiffuse
integer, dimension(:), allocatable  :: id_neutral_physics_gm

integer, dimension(:), allocatable  :: id_flux_x       ! for i-directed heat flux from neutral physics 
integer, dimension(:), allocatable  :: id_flux_y       ! for j-directed heat flux from neutral physics 
integer, dimension(:), allocatable  :: id_flux_x_int_z ! for vertically integrated i-directed tracer flux 
integer, dimension(:), allocatable  :: id_flux_y_int_z ! for vertically integrated j-directed tracer flux 

integer, dimension(:), allocatable  :: id_flux_x_gm       ! for i-directed heat flux from GM stirring 
integer, dimension(:), allocatable  :: id_flux_y_gm       ! for j-directed heat flux from GM stirring 
integer, dimension(:), allocatable  :: id_flux_x_gm_int_z ! for vertically integrated i-directed GM tracer flux 
integer, dimension(:), allocatable  :: id_flux_y_gm_int_z ! for vertically integrated j-directed GM tracer flux 

integer, dimension(:), allocatable  :: id_flux_x_ndiffuse       ! for i-directed heat flux from neutral diffusion 
integer, dimension(:), allocatable  :: id_flux_y_ndiffuse       ! for j-directed heat flux from neutral diffusion 
integer, dimension(:), allocatable  :: id_flux_x_ndiffuse_int_z ! for vertically integrated i-directed neutral diffusive flux 
integer, dimension(:), allocatable  :: id_flux_y_ndiffuse_int_z ! for vertically integrated j-directed neutral diffusive flux 

! for restart
type(restart_file_type), save :: NphysicsB_restart

#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS

real, dimension(isd:ied,jsd:jed,nk,0:1) :: delqc   !density weighted (kg/m^3) quarter cell thickness(m)
real, dimension(isd:ied,jsd:jed,0:nk)   :: dzwtr   !(1/dzwt)(m^-1)
real, dimension(isd:ied,jsd:jed,0:1)    :: dtew    !grid distances from T-point to cell faces (m)
real, dimension(isd:ied,jsd:jed,0:1)    :: dtns    !grid distances from T-point to cell faces (m)
real, dimension(isd:ied,jsd:jed,0:1)    :: dtwedyt !horizontal areas (m^2) of quarter cell
real, dimension(isd:ied,jsd:jed,0:1)    :: dxtdtsn !horizontal areas (m^2) of quarter cell

real, dimension(isd:ied,jsd:jed)    :: smooth_lap  !2D array of micom diffusivities (m^2/sec) for smoothing

real, dimension(isd:ied,jsd:jed)    :: surf_bdlthick ! surface turbulent boundary layer thickness (m)

real, dimension(isd:ied,jsd:jed,nk) :: slopex_drhodx         !3D array of slopex * drhodx for diagnostics
real, dimension(isd:ied,jsd:jed,nk) :: slopey_drhody         !3D array of slopey * drhody for diagnostics
real, dimension(isd:ied,jsd:jed,nk) :: grav_agm_dz_sx_drhodx !3D array of grav*agm*dz*slopex*drhodx for diagnostics
real, dimension(isd:ied,jsd:jed,nk) :: grav_agm_dz_sy_drhody !3D array of grav*agm*dz*slopey*drhody for diagnostics

real, dimension(isd:ied,jsd:jed,nk) :: aredi_array       !3D array of redi diffusivities (m^2/sec)     
real, dimension(isd:ied,jsd:jed,nk) :: agm_array         !3D array of gm diffusivities (m^2/sec)        

real, dimension(isd:ied,jsd:jed)    :: bczone_radius     !bczone calculation (m) 
real, dimension(isd:ied,jsd:jed)    :: rossby_radius     !first baroclinic Rossby radius (m) 
real, dimension(isd:ied,jsd:jed)    :: rossby_radius_raw !first baroclinic Rossby radius (m) without max/min  
real, dimension(isd:ied,jsd:jed,nk) :: eady_termx        !rho_z*(S_x)^2 for computing Eady growth rate 
real, dimension(isd:ied,jsd:jed,nk) :: eady_termy        !rho_z*(S_y)^2 for computing Eady growth rate 
real, dimension(isd:ied,jsd:jed)    :: baroclinic_termx  !intermediate term for computing vert ave baroclinicity
real, dimension(isd:ied,jsd:jed)    :: baroclinic_termy  !intermediate term for computing vert ave baroclinicity 
real, dimension(isd:ied,jsd:jed)    :: grid_length       !grid length scale (m)

real, dimension(isd:ied,jsd:jed,nk)     :: drhodT       !drho/dtheta     (kg/m^3/C)
real, dimension(isd:ied,jsd:jed,nk)     :: drhodS       !drho/dsalinity  (kg/m^3/psu)
real, dimension(isd:ied,jsd:jed,nk,0:1) :: drhodzb      !vertical local ref potrho derivative (kg/m^3/m)
real, dimension(isd:ied,jsd:jed,nk,0:1) :: drhodzh      !vertical local ref potrho derivative (kg/m^3/m)

real, dimension(isd:ied,jsd:jed,nk)     :: K33_implicit !density weighted (kg/m^3) implicit in time 
                                                        !diagonal term in redi tensor (m^2/sec) 
real, dimension(isd:ied,jsd:jed,nk)     :: K33_explicit !density weighted (kg/m^3) explicit in time 
                                                        !diagonal term in redi tensor (m^2/sec) 

real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: tensor_31 !portion of mixing tensor
real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: tensor_32 !portion of mixing tensor
real, dimension(isd:ied,jsd:jed,0:1,0:1)    :: tensor_11 !portion of mixing tensor
real, dimension(isd:ied,jsd:jed,0:1,0:1)    :: tensor_13 !portion of mixing tensor
real, dimension(isd:ied,jsd:jed,0:1,0:1)    :: tensor_22 !portion of mixing tensor
real, dimension(isd:ied,jsd:jed,0:1,0:1)    :: tensor_23 !portion of mixing tensor
real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: tensor_31_redi !tracer independent portion of Redi diffusion tensor
real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: tensor_32_redi !tracer independent portion of Redi diffusion tensor

real, dimension(isd:ied,jsd:jed,nk) :: tx_trans_gm       !for diagnosing i-transport due to GM (Sv)
real, dimension(isd:ied,jsd:jed,nk) :: ty_trans_gm       !for diagnosing j-transport due to GM (Sv)

integer, dimension(isd:ied,jsd:jed) :: ksurf_blayer      ! k-value at base of surface nblayer
real, dimension(isd:ied,jsd:jed)    :: surf_turb_thick   ! thickness (m) of surface turbulent boundary layer
real, dimension(isd:ied,jsd:jed)    :: surf_trans_thick  ! thickness (m) of surface transition zone 
real, dimension(isd:ied,jsd:jed)    :: full_turb_column  ! =1 if column fully turbulent, =0 if not. 
real, dimension(isd:ied,jsd:jed)    :: depth_blayer_base ! depth at interface between surf_trans zone and interior 
real, dimension(isd:ied,jsd:jed)    :: slope_blayer_base ! abs(slope) at base of neutral boundary layer 

#else

real, dimension(:,:,:,:),   allocatable :: delqc   !density weighted (kg/m^3) quarter cell thickness(m)
real, dimension(:,:,:),     allocatable :: dzwtr   !(1/dzwt)(m^-1)
real, dimension(:,:,:),     allocatable :: dtew    !grid distances from T-point to cell faces (m)
real, dimension(:,:,:),     allocatable :: dtns    !grid distances from T-point to cell faces (m)
real, dimension(:,:,:),     allocatable :: dtwedyt !horizontal areas (m^2) of quarter cell
real, dimension(:,:,:),     allocatable :: dxtdtsn !horizontal areas (m^2) of quarter cell

real, dimension(:,:),       allocatable :: smooth_lap   !2D array of micom diffusivities (m^2/sec) for smoothing
real, dimension(:,:),       allocatable :: surf_bdlthick !surface turbulent boundary layer thickness (m)

real, dimension(:,:,:),     allocatable :: slopex_drhodx         !3D array of slopex * drhodx for diagnostics
real, dimension(:,:,:),     allocatable :: slopey_drhody         !3D array of slopey * drhody for diagnostics
real, dimension(:,:,:),     allocatable :: grav_agm_dz_sx_drhodx !3D array of grav*agm*dz*slopex*drhodx for diagnostics
real, dimension(:,:,:),     allocatable :: grav_agm_dz_sy_drhody !3D array of grav*agm*dz*slopey*drhody for diagnostics

real, dimension(:,:,:),     allocatable :: aredi_array       !3D array of redi diffusivities (m^2/sec) 
real, dimension(:,:,:),     allocatable :: agm_array         !3D array of gm diffusivities (m^2/sec)     

real, dimension(:,:),       allocatable :: bczone_radius     !bczone calculation (m)
real, dimension(:,:),       allocatable :: rossby_radius     !first baroclinic Rossby radius (m) 
real, dimension(:,:),       allocatable :: rossby_radius_raw !first baroclinic Rossby radius (m) without max/min 
real, dimension(:,:,:),     allocatable :: eady_termx        !rho_z*(S_x)^2 for computing Eady growth rate 
real, dimension(:,:,:),     allocatable :: eady_termy        !rho_z*(S_y)^2 for computing Eady growth rate 
real, dimension(:,:),       allocatable :: baroclinic_termx  !intermediate term for computing vert ave baroclinicity 
real, dimension(:,:),       allocatable :: baroclinic_termy  !intermediate term for computing vert ave baroclinicity 
real, dimension(:,:),       allocatable :: grid_length       !grid length scale (m)

real, dimension(:,:,:),     allocatable :: drhodT           !drho/dtheta     (kg/m^3/C)
real, dimension(:,:,:),     allocatable :: drhodS           !drho/dsalinity  (kg/m^3/psu)
real, dimension(:,:,:,:),   allocatable :: drhodzb          !vertical local ref potrho derivative (kg/m^3/m)
real, dimension(:,:,:,:),   allocatable :: drhodzh          !vertical local ref potrho derivative (kg/m^3/m)

real, dimension(:,:,:,:,:), allocatable :: tensor_31 !portion of mixing tensor
real, dimension(:,:,:,:,:), allocatable :: tensor_32 !portion of mixing tensor
real, dimension(:,:,:,:), allocatable   :: tensor_11 !portion of mixing tensor
real, dimension(:,:,:,:), allocatable   :: tensor_13 !portion of mixing tensor
real, dimension(:,:,:,:), allocatable   :: tensor_22 !portion of mixing tensor
real, dimension(:,:,:,:), allocatable   :: tensor_23 !portion of mixing tensor
real, dimension(:,:,:,:,:), allocatable :: tensor_31_redi !tracer independent portion of Redi diffusion tensor
real, dimension(:,:,:,:,:), allocatable :: tensor_32_redi !tracer independent portion of Redi diffusion tensor

real, dimension(:,:,:),     allocatable :: K33_implicit   !density weighted (kg/m^3) implicit in time 
                                                          !diagonal term in redi tensor (m^2/sec) 
real, dimension(:,:,:),     allocatable :: K33_explicit   !density weighted (kg/m^3) explicit in time 

integer, dimension(:,:), allocatable :: ksurf_blayer      ! k-value at base of surface nblayer 
real, dimension(:,:), allocatable    :: surf_turb_thick   ! thickness (m) of surface turbulent boundary layer
real, dimension(:,:), allocatable    :: surf_trans_thick  ! thickness (m) of surface transition region 
real, dimension(:,:), allocatable    :: full_turb_column  ! =1 if column fully turbulent, =0 if not. 
real, dimension(:,:), allocatable    :: depth_blayer_base ! depth at interface between surf_trans zone and interior 
real, dimension(:,:), allocatable    :: slope_blayer_base ! abs(slope) at base of neutral boundary layer 

real, dimension(:,:,:),  allocatable :: tx_trans_gm       !for diagnosing i-transport due to GM (Sv)
real, dimension(:,:,:),  allocatable :: ty_trans_gm       !for diagnosing j-transport due to GM (Sv)

#endif

! use these derived types so that do not need to know num_prog_tracers at compile time 
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: dTdx    ! tracer partial derivative (tracer/m)
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: dTdy    ! tracer partial derivative (tracer/m)
type(tracer_3d_0_nk_type), dimension(:), allocatable  :: dTdz    ! tracer partial derivative (tracer/m)
type(tracer_3d_1_nk_type), save                       :: dSdx    ! Dens%rho_salinity partial derivative (tracer/m)
type(tracer_3d_1_nk_type), save                       :: dSdy    ! Dens%rho_salinity partial derivative (tracer/m)
type(tracer_3d_0_nk_type), save                       :: dSdz    ! Dens%rho_salinity partial derivative (tracer/m)
type(tracer_2d_type),      dimension(:), allocatable  :: fz1     ! z-flux component for tracers at particular k 
type(tracer_2d_type),      dimension(:), allocatable  :: fz2     ! z-flux component for tracers at particular k 
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: flux_x  ! i-flux component for tracers for all k
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: flux_y  ! j-flux component for tracers for all k

! for diagnosing effects from GM and Redi separately, we add the following fields for neutral diffusion
! and calculation the GM contribution as a difference of the total and the neutral diffusion piece.  
type(tracer_2d_type),      dimension(:), allocatable  :: fz1_redi      ! z-flux redi component for tracers at particular k 
type(tracer_2d_type),      dimension(:), allocatable  :: fz2_redi      ! z-flux redi component for tracers at particular k 
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: flux_x_redi   ! i-flux gm component for tracers for all k
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: flux_y_redi   ! j-flux gm component for tracers for all k
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: tendency_redi ! tendency from Redi (excluding implicit K33 piece)


integer :: index_temp
integer :: index_salt
integer :: neutralrho_nk

character(len=128) :: version=&
     '$Id: ocean_nphysicsB.F90,v 20.0 2013/12/14 00:14:38 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

character(len=*), parameter :: FILENAME=&
     __FILE__

logical :: module_is_initialized = .FALSE.

! some useful constants 
real :: gravrho0r
real :: gravrho0r_buoyr
real :: fivedeg
real :: gamma_damp
   
! time step settings 
real    :: dtime
real    :: two_dtime_inv

! vertical coordinate 
integer :: vert_coordinate_class

! lower and upper depth for vertically averaging ocean properties.
! read into ocean_nphysics_util_nml
real :: agm_closure_upper_depth
real :: agm_closure_lower_depth


!**************nml settings**************

! for using form drag rather than GM-skewsion
! gm_skew=1.0 if use_gm_skew=.true.
! gm_skew=0.0 if use_gm_skew=.false.
logical :: use_gm_skew=.true.
real    :: gm_skew=1.0

! time (days) to damp the evolution of the nonconstant diffusivity,
! as well as for updating the surface turbulent boundary 
! layer thickness that is read into this module. This damping 
! allows for the neutral physics module to use boundary layer thicknesses
! and diffusivities that are evolving on a slow (e.g., many days) time. 
real :: neutral_damping_time=10.0    

! for smoothing the neutral blayer fields
logical :: nblayer_smooth   = .true.
real    :: vel_micom_smooth = 0.2   ! m/sec

! for setting the slope tapering methods 
real    :: smax                ! set in ocean_neutral_util_nml
real    :: swidth              ! set in ocean_neutral_util_nml
logical :: dm_taper=.true.     ! tanh taper scheme of Danabasoglu/McWilliams (only one available here)
real    :: dm_taper_const=1.0  ! internally set to unity when dm_taper=.true.
real    :: swidthr                     ! inverse swidth  
real    :: smax_swidthr                ! useful combination of terms 
logical :: gkw_taper        = .false.  ! quadratic tapering of Gerdes, Koberle, and Willebrand
real    :: gkw_taper_const  = 0.0      ! internally set to unity when gkw_taper=.true.

! for determining the neutral blayer regimes 
integer :: surf_turb_thick_min_k  = 5    ! min klevel in surf_turb_thick_min 
real    :: surf_turb_thick_min    = 50.0 ! metres 

! to compute K33 explicitly in time. 
! diffusion_all_explicit=.false. for realistic simulations.
logical :: diffusion_all_explicit=.false.   

! revert to horizontal diffusion when tracer falls outside specified range 
logical :: neutral_physics_limit=.true.   

! to reduce neutral fluxes to horz/vert diffusion next to model boundaries
logical :: tmask_neutral_on=.false.         

! for specifying transport units
! can either be Sv or mks
character(len=32) :: transport_dims ='Sv (10^9 kg/s)' 
real              :: transport_convert=1.0e-9 

! internally set; for diagnosing the effects from GM and Redi separately 
logical :: diagnose_gm_redi = .false.

! for the module as a whole 
logical :: use_this_module   = .false.
logical :: debug_this_module = .false.

namelist /ocean_nphysicsB_nml/                            &
          use_this_module, debug_this_module,             &
          neutral_physics_limit,  diffusion_all_explicit, &
          tmask_neutral_on, use_gm_skew,                  &
          surf_turb_thick_min, surf_turb_thick_min_k,     &
          nblayer_smooth, vel_micom_smooth,               &
          neutral_damping_time, dm_taper, gkw_taper

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_nphysicsB_init">
!
! <DESCRIPTION>
! Initialize the neutral physics module by registering fields for 
! diagnostic output and performing some numerical checks to see 
! that namelist settings are appropriate. 
! </DESCRIPTION>
!
subroutine ocean_nphysicsB_init(Grid, Domain, Time, Time_steps, Thickness, Dens, T_prog,&
           ver_coordinate_class, agm_closure_lower_dept, agm_closure_upper_dept,        &
           smx, swidt, cmip_units, debug)

  type(ocean_grid_type),        intent(in), target   :: Grid
  type(ocean_domain_type),      intent(in), target   :: Domain
  type(ocean_time_type),        intent(in)           :: Time
  type(ocean_time_steps_type),  intent(in)           :: Time_steps
  type(ocean_thickness_type),   intent(in)           :: Thickness
  type(ocean_density_type),     intent(in)           :: Dens
  type(ocean_prog_tracer_type), intent(inout)        :: T_prog(:)
  integer,                      intent(in)           :: ver_coordinate_class
  real,                         intent(in)           :: agm_closure_lower_dept
  real,                         intent(in)           :: agm_closure_upper_dept
  real,                         intent(in)           :: smx 
  real,                         intent(in)           :: swidt
  logical,                      intent(in)           :: cmip_units
  logical,                      intent(in), optional :: debug

  logical :: diagnose_gm_redi_input=.false.
  integer :: ioun, io_status, ierr  
  integer :: i, j, k, n
  integer :: surf_turb_min_k
  integer :: id_restart
  real    :: ah_array(isd:ied,jsd:jed)
  character(len=64) :: file_name
  
  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_nphysicsB_mod (ocean_nphysicsB_init):already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  num_prog_tracers = size(T_prog(:))
  dtime            = Time_steps%dtime_t
  Dom => Domain
  Grd => Grid

  vert_coordinate_class   = ver_coordinate_class
  agm_closure_lower_depth = agm_closure_lower_dept
  agm_closure_upper_depth = agm_closure_upper_dept
  smax                    = smx 
  swidth                  = swidt
  neutralrho_nk           = size(Dens%neutralrho_ref(:))

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_nphysicsB_nml, iostat=io_status) 
  ierr = check_nml_error(io_status,'ocean_nphysicsB_nml')
#else
  ioun =  open_namelist_file()
  read (ioun,ocean_nphysicsB_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_nphysicsB_nml')
  call close_file (ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_nphysicsB_nml)  
  write (stdlogunit,ocean_nphysicsB_nml)

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  nk = Grid%nk
#endif

  if(use_this_module) then 
     call write_note(FILENAME,&
     'USING ocean_nphysicsB_mod.')
  else 
     call write_note(FILENAME,&
     'NOT using ocean_nphysicsB_mod.')
     return
  endif 

  if (PRESENT(debug) .and. .not. debug_this_module) then
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
     call write_note(FILENAME,&
     'running ocean_nphysicsB_mod with debug_this_module=.true.')
  endif 

  write(stdoutunit,'(/1x,a,f10.2)') &
  '==> Note from ocean_nphysicsB_mod: using forward time step of (secs)', dtime 

  if(cmip_units) then
      transport_convert=1.0
      transport_dims   = 'kg/s'
  else
      transport_convert=1.0e-9 
      transport_dims   = 'Sv (10^9 kg/s)'
  endif

  ! Useful constants 
  two_dtime_inv = 0.5/dtime            !for explicit piece of K33 
  swidthr       = 1.0/(swidth + epsln)                 !for slope taper function with dm_taper
  smax_swidthr  = smax*swidthr                         !for slope taper function with dm_taper
  gamma_damp    = dtime/(86400.0*neutral_damping_time) !for damping blayers and diffusivities 

  if(use_gm_skew) then
    gm_skew=1.0
    call write_note(FILENAME,&
    'use_gm_skew=.true. so will use GM-skewsion.')
  else
    gm_skew=0.0
    call write_note(FILENAME,&
    'use_gm_skew=.false. so will NOT use GM-skewsion.')
  endif

  if(dm_taper .and. .not. gkw_taper) then
     call write_note(FILENAME,&
     'dm_taper=.true. Will use the tanh scheme')
     call write_line('of Danabasoglu and McWilliams to taper neutral physics in steep sloped regions')
     dm_taper_const =1.0
     gkw_taper_const=0.0
  endif
  if(gkw_taper .and. .not. dm_taper) then
     call write_note(FILENAME,&
     'gkw_taper=.true. Will use the quadratic scheme')
     call write_line('of Gerdes, Koberle, and Willebrand to taper neutral physics in steep sloped regions')
     dm_taper_const =0.0
     gkw_taper_const=1.0
  endif
  if(gkw_taper .and. dm_taper) then
      dm_taper_const =0.0
      gkw_taper_const=0.0
      call mpp_error(FATAL, &
      '==>Error from ocean_nphysicsB_mod: gkw_taper and dm_taper cannot both be set true--choose only one.')
  endif


  if(neutral_physics_limit) then
     call write_note(FILENAME,&
     'neutral_physics_limit=.true.')
     call write_line('Will revert to horizontal diffusion for points where tracer is outside specified range.')
  endif

  if(dm_taper) then
     call write_note(FILENAME,&
     'dm_taper=.true. Will use the tanh scheme')
     call write_line('of Danabasoglu and McWilliams to taper neutral physics in steep sloped regions.')
     call write_line('This is the only tapering scheme available with ocean_nphysicsB_mod.')
  endif

  if(diffusion_all_explicit) then
     call write_warning(FILENAME,&
     'Running w/ diffusion_all_explicit=.true., which means compute K33 contribution')
     call write_line('to neutral diffusion explicitly in time.  This method is stable only if taking')
     call write_line('very small time steps and/or running with just a single tracer.')
  endif


  do n=1,num_prog_tracers
    T_prog(n)%neutral_physics_limit = neutral_physics_limit
  enddo 

  allocate( dTdx(num_prog_tracers) )
  allocate( dTdy(num_prog_tracers) )
  allocate( dTdz(num_prog_tracers) )
  allocate( fz1(num_prog_tracers) )
  allocate( fz2(num_prog_tracers) )
  allocate( flux_x(num_prog_tracers) )
  allocate( flux_y(num_prog_tracers) )

  call set_ocean_domain(Dom_flux, Grid, xhalo=Dom%xhalo, yhalo=Dom%yhalo, &
                        name='flux dom neutral',maskmap=Dom%maskmap)

#ifndef MOM_STATIC_ARRAYS
  allocate (dtew(isd:ied,jsd:jed,0:1))
  allocate (dtns(isd:ied,jsd:jed,0:1))
  allocate (dtwedyt(isd:ied,jsd:jed,0:1))
  allocate (dxtdtsn(isd:ied,jsd:jed,0:1))
  allocate (grid_length(isd:ied,jsd:jed))
  allocate (delqc(isd:ied,jsd:jed,nk,0:1))
  allocate (dzwtr(isd:ied,jsd:jed,0:nk))
  allocate (aredi_array(isd:ied,jsd:jed,nk)) 
  allocate (agm_array(isd:ied,jsd:jed,nk))   
  allocate (smooth_lap(isd:ied,jsd:jed))
  allocate (surf_bdlthick(isd:ied,jsd:jed))
  allocate (bczone_radius(isd:ied,jsd:jed))
  allocate (rossby_radius(isd:ied,jsd:jed))
  allocate (rossby_radius_raw(isd:ied,jsd:jed))
  allocate (eady_termx(isd:ied,jsd:jed,nk))
  allocate (eady_termy(isd:ied,jsd:jed,nk))
  allocate (baroclinic_termx(isd:ied,jsd:jed))
  allocate (baroclinic_termy(isd:ied,jsd:jed))
  allocate (tx_trans_gm(isd:ied,jsd:jed,nk))
  allocate (ty_trans_gm(isd:ied,jsd:jed,nk))
  allocate (grav_agm_dz_sx_drhodx(isd:ied,jsd:jed,nk)) 
  allocate (grav_agm_dz_sy_drhody(isd:ied,jsd:jed,nk)) 
  allocate (slopex_drhodx(isd:ied,jsd:jed,nk)) 
  allocate (slopey_drhody(isd:ied,jsd:jed,nk)) 

  allocate (drhodT(isd:ied,jsd:jed,nk))
  allocate (drhodS(isd:ied,jsd:jed,nk))
  allocate (drhodzb(isd:ied,jsd:jed,nk,0:1))
  allocate (drhodzh(isd:ied,jsd:jed,nk,0:1))
  allocate (tensor_31(isd:ied,jsd:jed,nk,0:1,0:1))
  allocate (tensor_32(isd:ied,jsd:jed,nk,0:1,0:1))
  allocate (tensor_11(isd:ied,jsd:jed,0:1,0:1))
  allocate (tensor_13(isd:ied,jsd:jed,0:1,0:1))
  allocate (tensor_22(isd:ied,jsd:jed,0:1,0:1))
  allocate (tensor_23(isd:ied,jsd:jed,0:1,0:1))
  allocate (K33_implicit(isd:ied,jsd:jed,nk)) 
  allocate (K33_explicit(isd:ied,jsd:jed,nk)) 

  do n=1,num_prog_tracers
    allocate ( dTdx(n)%field(isd:ied,jsd:jed,nk) )
    allocate ( dTdy(n)%field(isd:ied,jsd:jed,nk) )
    allocate ( dTdz(n)%field(isd:ied,jsd:jed,0:nk) )
    allocate ( fz1(n)%field(isd:ied,jsd:jed) )
    allocate ( fz2(n)%field(isd:ied,jsd:jed) )
    allocate ( flux_x(n)%field(isd:ied,jsd:jed,nk) )
    allocate ( flux_y(n)%field(isd:ied,jsd:jed,nk) )
  enddo 
  allocate ( dSdx%field(isd:ied,jsd:jed,nk) )
  allocate ( dSdy%field(isd:ied,jsd:jed,nk) )
  allocate ( dSdz%field(isd:ied,jsd:jed,0:nk) )

  allocate(ksurf_blayer(isd:ied,jsd:jed))
  allocate(surf_turb_thick(isd:ied,jsd:jed))
  allocate(surf_trans_thick(isd:ied,jsd:jed))
  allocate(depth_blayer_base(isd:ied,jsd:jed))
  allocate(full_turb_column(isd:ied,jsd:jed))
  allocate(slope_blayer_base(isd:ied,jsd:jed))

#endif

  do n=1,num_prog_tracers 
    dTdx(n)%field(:,:,:)   = 0.0
    dTdy(n)%field(:,:,:)   = 0.0
    dTdz(n)%field(:,:,:)   = 0.0
    fz1(n)%field(:,:)      = 0.0
    fz2(n)%field(:,:)      = 0.0
    flux_x(n)%field(:,:,:) = 0.0
    flux_y(n)%field(:,:,:) = 0.0
  enddo  
  dSdx%field(:,:,:) = 0.0
  dSdy%field(:,:,:) = 0.0
  dSdz%field(:,:,:) = 0.0

  ! fields related to boundary layer regimes 
  ksurf_blayer(:,:)        = 1
  surf_turb_thick(:,:)     = Grd%tmask(:,:,1)*surf_turb_thick_min
  surf_trans_thick(:,:)    = 0.0
  depth_blayer_base(:,:)   = surf_turb_thick(:,:) + surf_trans_thick(:,:)
  full_turb_column(:,:)    = 0.0
  slope_blayer_base(:,:)   = 0.0

  tx_trans_gm(:,:,:)    = 0.0
  ty_trans_gm(:,:,:)    = 0.0

  dtew(:,:,0) = Grd%dtw(:,:)
  dtew(:,:,1) = Grd%dte(:,:)
  dtns(:,:,0) = Grd%dts(:,:)
  dtns(:,:,1) = Grd%dtn(:,:)

  dtwedyt(:,:,:) = 0.0
  dtwedyt(:,:,0) = Grd%dte(:,:)*Grd%dyt(:,:)
  do i=isc-1,iec
    dtwedyt(i,:,1) = Grd%dtw(i+1,:)*Grd%dyt(i+1,:)
  enddo

  dxtdtsn(:,:,:) = 0.0
  dxtdtsn(:,:,0) = Grd%dxt(:,:)*Grd%dtn(:,:)
  do j=jsc-1,jec
    dxtdtsn(:,j,1) = Grd%dxt(:,j+1)*Grd%dts(:,j+1)
  enddo

  grid_length(:,:) = 2.0*Grd%dxt(:,:)*Grd%dyt(:,:)/(Grd%dxt(:,:)+Grd%dyt(:,:))

  surf_bdlthick(:,:)           = 0.0
  smooth_lap(:,:)              = vel_micom_smooth*grid_length(:,:)
  eady_termx(:,:,:)            = 0.0
  eady_termy(:,:,:)            = 0.0
  baroclinic_termx(:,:)        = 0.0
  baroclinic_termy(:,:)        = 0.0
  grav_agm_dz_sx_drhodx(:,:,:) = 0.0
  grav_agm_dz_sy_drhody(:,:,:) = 0.0
  slopex_drhodx(:,:,:)         = 0.0
  slopey_drhody(:,:,:)         = 0.0

  rossby_radius(:,:)           = 0.0
  rossby_radius_raw(:,:)       = 0.0
  bczone_radius(:,:)           = 0.0
  aredi_array(:,:,:)           = 0.0
  agm_array(:,:,:)             = 0.0
  ah_array(:,:)                = 0.0

  call ocean_nphysics_coeff_init(Time, Thickness, rossby_radius, rossby_radius_raw, &
                           bczone_radius, agm_array, aredi_array, ah_array)

  drhodT(:,:,:)        = 0.0
  drhodS(:,:,:)        = 0.0
  drhodzb(:,:,:,:)     = 0.0
  drhodzh(:,:,:,:)     = 0.0
  tensor_31(:,:,:,:,:) = 0.0
  tensor_32(:,:,:,:,:) = 0.0
  tensor_11(:,:,:,:)   = 0.0
  tensor_13(:,:,:,:)   = 0.0
  tensor_22(:,:,:,:)   = 0.0
  tensor_23(:,:,:,:)   = 0.0
  K33_implicit(:,:,:)  = 0.0           
  K33_explicit(:,:,:)  = 0.0    
  file_name = 'ocean_neutralB.res.nc'     

  ! make mandatory=.false. to facilitate backward compatibility with older restart files. 
  id_restart = register_restart_field(NphysicsB_restart, file_name, "surf_turb_thick", surf_turb_thick, &
       domain=Dom%domain2d, mandatory=.false.)
  id_restart = register_restart_field(NphysicsB_restart, file_name, "surf_trans_thick", surf_trans_thick, &
       domain=Dom%domain2d, mandatory=.false.)
  if(.NOT.file_exist('INPUT/ocean_neutralB.res.nc')) then

      if (.NOT. Time%init) then 
          call mpp_error(FATAL, &
          'Expecting file INPUT/ocean_neutralB.res.nc to exist.&
           &This file was not found and Time%init=.false.')
      endif 

  else
      call restore_state(NphysicsB_restart)
      call mpp_update_domains(surf_turb_thick,Dom%domain2d)
      call mpp_update_domains(surf_trans_thick,Dom%domain2d)

      call write_chksum_header(FILENAME,&
      'initial neutral checksums', Time%model_time)
      call neutral_chksums

  endif

  index_temp=-1;index_salt=-1
  do n=1,num_prog_tracers
     if (T_prog(n)%name == 'temp') index_temp = n
     if (T_prog(n)%name == 'salt') index_salt = n
  enddo
  if (index_temp == -1 .or. index_salt == -1) then 
     call mpp_error(FATAL, &
     '==>Error: temp and/or salt not identified in call to ocean_nphysicsB_init')
  endif 

  ! minimum number of grid cells in surface turbulent boundary layer
  write(stdoutunit,'(1x,a,f10.2)') &
  '==>Note: Surface turb boundary layer for nphysicsB assumed to have min thick (m) =', &
  surf_turb_thick_min 
  kturb_loop : do k=1,nk-1
     surf_turb_min_k = k
     if(Grd%zw(k) <= surf_turb_thick_min .and. Grd%zw(k+1) > surf_turb_thick_min) then
         exit 
     endif
  enddo kturb_loop
  surf_turb_thick_min_k = max(surf_turb_thick_min_k,surf_turb_min_k)
  write(stdoutunit,'(1x,a,i3,a)') &
  '==>Note: Surface turb boundary layer assumed to have at least ',surf_turb_thick_min_k,' k-levels.' 


  ! initialize clock ids 
  id_clock_neutral_blayer = mpp_clock_id('(Ocean neutral: neutral blayer)',grain=CLOCK_ROUTINE)
  id_clock_fz_terms       = mpp_clock_id('(Ocean neutral: fz-terms)'      ,grain=CLOCK_ROUTINE)
  id_clock_fx_flux        = mpp_clock_id('(Ocean neutral: fx-flux)'       ,grain=CLOCK_ROUTINE)
  id_clock_fy_flux        = mpp_clock_id('(Ocean neutral: fy-flux)'       ,grain=CLOCK_ROUTINE)
  id_clock_fz_flux        = mpp_clock_id('(Ocean neutral: fz-flux)'       ,grain=CLOCK_ROUTINE)
  id_clock_fx_flux_diag   = mpp_clock_id('(Ocean neutral: fx-flux-diag)' ,grain=CLOCK_ROUTINE)
  id_clock_fy_flux_diag   = mpp_clock_id('(Ocean neutral: fy-flux-diag)' ,grain=CLOCK_ROUTINE)
  id_clock_fz_flux_diag   = mpp_clock_id('(Ocean neutral: fz-flux-diag)' ,grain=CLOCK_ROUTINE)
  id_clock_fz_terms_diag  = mpp_clock_id('(Ocean neutral: fz-terms-diag)',grain=CLOCK_ROUTINE)


  ! register fields for diagnostic output 

  id_k33_explicit = -1
  id_k33_explicit = register_diag_field ('ocean_model', 'k33_explicit', &
                    Grd%tracer_axes_wt(1:3), Time%model_time,           &
                    'K33_explicit tensor element', 'm^2/sec',           &
                    missing_value=missing_value, range=(/-10.0,1.e20/))

  id_tx_trans_gm = -1
  id_tx_trans_gm = register_diag_field ('ocean_model', 'tx_trans_gm',     &
                   Grd%tracer_axes_flux_x(1:3), Time%model_time,          &
                   'T-cell mass i-transport from GM',trim(transport_dims),&
                   missing_value=missing_value, range=(/-1e20,1.e20/))

  id_ty_trans_gm = -1
  id_ty_trans_gm = register_diag_field ('ocean_model', 'ty_trans_gm',     &
                   Grd%tracer_axes_flux_y(1:3), Time%model_time,          &
                   'T-cell mass j-transport from GM',trim(transport_dims),&
                   missing_value=missing_value, range=(/-1e20,1.e20/))

  id_slope_blayer_base = -1
  id_slope_blayer_base = register_diag_field ('ocean_model','slope_blayer_base',          &
                         Grd%tracer_axes(1:2), Time%model_time,                           &
                         'abs(slope) at neutral physics bdy-layer base', 'dimensionless', &
                         missing_value=missing_value, range=(/-1.0,1.e8/))

  id_surf_turb_thick = -1
  id_surf_turb_thick = register_diag_field ('ocean_model','surf_turb_thick', &
                         Grd%tracer_axes(1:2), Time%model_time,              &
                  'surface turbulent thickness for neutral physics', 'm',    &
                         missing_value=missing_value, range=(/-1.0,1.e8/))

  id_surf_trans_thick = -1
  id_surf_trans_thick = register_diag_field ('ocean_model','surf_trans_thick', &
                  Grd%tracer_axes(1:2), Time%model_time,                       &
                         'Surface transition layer thickness', 'm',            &
                  missing_value=missing_value, range=(/-1.0,1.e8/))

  id_depth_blayer_base = -1
  id_depth_blayer_base = register_diag_field ('ocean_model','depth_blayer_base',          &
                   Grd%tracer_axes(1:2), Time%model_time,                                 &
                         'Depth at bottom of neutral physics surface boundary layer', 'm',&
                   missing_value=missing_value, range=(/-1.0,1.e8/))

  id_full_turb_column = -1
  id_full_turb_column = register_diag_field ('ocean_model','full_turb_column',               &
                        Grd%tracer_axes(1:2), Time%model_time,                               &
                        'regions deemed fully turbulent by neutral physics', 'dimensioness', &
                        missing_value=missing_value, range=(/-1.e8,1.e8/))

  id_grav_agm_dz_sx_drhodx = -1
  id_grav_agm_dz_sx_drhodx = register_diag_field ('ocean_model', 'grav_agm_dz_sx_drhodx', &
               Grd%tracer_axes(1:3), Time%model_time,                                     &
               'grav*dz*agm*neutral x-slope times drho_dx', 'W/m^2',                      &
               missing_value=missing_value, range=(/-1.e15,1.e15/))

  id_grav_agm_dz_sy_drhody = -1
  id_grav_agm_dz_sy_drhody = register_diag_field ('ocean_model', 'grav_agm_dz_sy_drhody', &
               Grd%tracer_axes(1:3), Time%model_time,                                     &
               'grav*dz*agm*neutral y-slope times drho_dy', 'W/m^2',                      &
               missing_value=missing_value, range=(/-1.e15,1.e15/))

  id_gm_eddy_ke_source = -1
  id_gm_eddy_ke_source = register_diag_field ('ocean_model', 'gm_eddy_ke_source',&
               Grd%tracer_axes(1:3), Time%model_time,                            &
               'rho0*dz*agm*(slope*N)^2 = eddy ke source from GM', 'W/m^2',      &
               missing_value=missing_value, range=(/-1.e1,1.e15/),               &
               standard_name='tendency_of_ocean_eddy_kinetic_energy_content_due_to_bolus_transport')

  id_slopex_drhodx = -1
  id_slopex_drhodx = register_diag_field ('ocean_model', 'slopex_drhodx', &
               Grd%tracer_axes(1:3), Time%model_time,                     &
               'neutral x-slope times drho_dx', 'kg/m^4',                 &
               missing_value=missing_value, range=(/-1.e10,1.e10/))

  id_slopey_drhody = -1
  id_slopey_drhody = register_diag_field ('ocean_model', 'slopey_drhody', &
               Grd%tracer_axes(1:3), Time%model_time,                     &
               'neutral y-slope times drho_dy', 'kg/m^4',                 &
               missing_value=missing_value, range=(/-1.e10,1.e10/))

  call watermass_diag_init(Time, Dens, diagnose_gm_redi_input)
  if(diagnose_gm_redi_input) then 
     diagnose_gm_redi = .true.
  endif 

  allocate (id_k33_implicit(num_prog_tracers))
  allocate (id_neutral_physics(num_prog_tracers))
  allocate (id_neutral_physics_ndiffuse(num_prog_tracers))
  allocate (id_neutral_physics_gm(num_prog_tracers))
  id_k33_implicit             = -1
  id_neutral_physics          = -1
  id_neutral_physics_ndiffuse = -1
  id_neutral_physics_gm       = -1
  do n=1,num_prog_tracers
     id_k33_implicit(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_k33_implicit', &
                          Grd%tracer_axes_wt(1:3), Time%model_time,                                  &
                          'K33_implicit tensor element for '//trim(T_prog(n)%name),                  &
                          'm^2/sec', missing_value=missing_value, range=(/-10.0,1.e10/))

     if (T_prog(n)%name == 'temp') then
       id_neutral_physics(n) = register_diag_field ('ocean_model', 'neutral_'//trim(T_prog(n)%name), &
                               Grd%tracer_axes(1:3), Time%model_time,                                &
                               'rho*dzt*cp*explicit neutral tendency (heating)',                     &
                               trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))

       id_neutral_physics_ndiffuse(n) = register_diag_field ('ocean_model', 'neutral_diffusion_'//trim(T_prog(n)%name), &
                               Grd%tracer_axes(1:3), Time%model_time,                                                   &
                               'rho*dzt*cp*explicit neutral diffusion tendency (heating)',                              &
                               trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))
       if(id_neutral_physics_ndiffuse(n) > 0) diagnose_gm_redi=.true.

       id_neutral_physics_gm(n) = register_diag_field ('ocean_model', 'neutral_gm_'//trim(T_prog(n)%name), &
                               Grd%tracer_axes(1:3), Time%model_time,                                      &
                               'rho*dzt*cp*GM stirring (heating)',                                         &
                               trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))
       if(id_neutral_physics_gm(n) > 0) diagnose_gm_redi=.true.

     else 

       id_neutral_physics(n) = register_diag_field ('ocean_model', 'neutral_'//trim(T_prog(n)%name), &
                               Grd%tracer_axes(1:3), Time%model_time,                                &
                               'rho*dzt*explicit neutral tendency for '//trim(T_prog(n)%name),       &
                               trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))

       id_neutral_physics_ndiffuse(n) = register_diag_field ('ocean_model', 'neutral_diffusion_'//trim(T_prog(n)%name), &
                               Grd%tracer_axes(1:3), Time%model_time,                                                   &
                               'rho*dzt*explicit neutral diffusion tendency for '//trim(T_prog(n)%name),                &
                               trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))
       if(id_neutral_physics_ndiffuse(n) > 0) diagnose_gm_redi=.true.

       id_neutral_physics_gm(n) = register_diag_field ('ocean_model', 'neutral_gm_'//trim(T_prog(n)%name),&
                               Grd%tracer_axes(1:3), Time%model_time,                                     &
                               'rho*dzt*GM stirring tendency for '//trim(T_prog(n)%name),                 &
                               trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))
       if(id_neutral_physics_gm(n) > 0) diagnose_gm_redi=.true.

     endif 
  enddo 

  allocate (id_flux_x(num_prog_tracers))
  allocate (id_flux_y(num_prog_tracers))
  allocate (id_flux_x_int_z(num_prog_tracers))
  allocate (id_flux_y_int_z(num_prog_tracers))

  allocate (id_flux_x_gm(num_prog_tracers))
  allocate (id_flux_y_gm(num_prog_tracers))
  allocate (id_flux_x_gm_int_z(num_prog_tracers))
  allocate (id_flux_y_gm_int_z(num_prog_tracers))

  allocate (id_flux_x_ndiffuse(num_prog_tracers))
  allocate (id_flux_y_ndiffuse(num_prog_tracers))
  allocate (id_flux_x_ndiffuse_int_z(num_prog_tracers))
  allocate (id_flux_y_ndiffuse_int_z(num_prog_tracers))

  id_flux_x       = -1
  id_flux_y       = -1
  id_flux_x_int_z = -1
  id_flux_y_int_z = -1

  id_flux_x_gm       = -1
  id_flux_y_gm       = -1
  id_flux_x_gm_int_z = -1
  id_flux_y_gm_int_z = -1

  id_flux_x_ndiffuse       = -1
  id_flux_y_ndiffuse       = -1
  id_flux_x_ndiffuse_int_z = -1
  id_flux_y_ndiffuse_int_z = -1

  do n=1,num_prog_tracers
     if(n == index_temp) then 

         id_flux_x(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_neutral', &
              Grd%tracer_axes_flux_x(1:3), Time%model_time, 'cp*neutral_xflux*dyt*rho_dzt*temp',    &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_y(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_neutral', &
              Grd%tracer_axes_flux_y(1:3), Time%model_time, 'cp*neutral_yflux*dxt*rho_dzt*temp',    &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_x_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_neutral_int_z', &
              Grd%tracer_axes_flux_x(1:2), Time%model_time, 'z-integral cp*neutral_xflux*dyt*rho_dzt*temp',     &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_y_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_neutral_int_z', &
              Grd%tracer_axes_flux_y(1:2), Time%model_time, 'z-integral cp*neutral_yflux*dxt*rho_dzt*temp',     &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))

         id_flux_x_gm(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_gm',&
              Grd%tracer_axes_flux_x(1:3), Time%model_time, 'cp*gm_xflux*dyt*rho_dzt*temp',      &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_gm(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_gm(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_gm',&
              Grd%tracer_axes_flux_y(1:3), Time%model_time, 'cp*gm_yflux*dxt*rho_dzt*temp',      &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_gm(n) > 0) diagnose_gm_redi=.true.

         id_flux_x_gm_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_gm_int_z',&
              Grd%tracer_axes_flux_x(1:2), Time%model_time, 'z-integral cp*gm_xflux*dyt*rho_dzt*temp',       &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_gm_int_z(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_gm_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_gm_int_z',&
              Grd%tracer_axes_flux_y(1:2), Time%model_time, 'z-integral cp*gm_yflux*dxt*rho_dzt*temp',       &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_gm_int_z(n) > 0) diagnose_gm_redi=.true.

         id_flux_x_ndiffuse(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_ndiffuse',&
              Grd%tracer_axes_flux_x(1:3), Time%model_time, 'cp*redi_xflux*dyt*rho_dzt*temp',                &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_ndiffuse(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_ndiffuse(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_ndiffuse',&
              Grd%tracer_axes_flux_y(1:3), Time%model_time, 'cp*redi_yflux*dxt*rho_dzt*temp',                &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_ndiffuse(n) > 0) diagnose_gm_redi=.true.

         id_flux_x_ndiffuse_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_ndiffuse_int_z',&
              Grd%tracer_axes_flux_x(1:2), Time%model_time, 'z-integral cp*redi_xflux*dyt*rho_dzt*temp',                 &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_ndiffuse_int_z(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_ndiffuse_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_ndiffuse_int_z',&
              Grd%tracer_axes_flux_y(1:2), Time%model_time, 'z-integral cp*redi_yflux*dxt*rho_dzt*temp',                 &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_ndiffuse_int_z(n) > 0) diagnose_gm_redi=.true.

     else

         id_flux_x(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_neutral', &
              Grd%tracer_axes_flux_x(1:3), Time%model_time,                                         &
              'neutral_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),                         &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_y(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_neutral', &
              Grd%tracer_axes_flux_y(1:3), Time%model_time,                                         &
              'neutral_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),                         &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_x_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_neutral_int_z', &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                                                     &
              'z-integral neutral_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),                          &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_y_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_neutral_int_z', &
              Grd%tracer_axes_flux_y(1:2), Time%model_time,                                                     &
              'z-integral neutral_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),                          &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))

         id_flux_x_gm(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_gm',&
              Grd%tracer_axes_flux_x(1:3), Time%model_time,                                      &
              'gm_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),                           &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_gm(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_gm(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_gm', &
              Grd%tracer_axes_flux_y(1:3), Time%model_time,                                       &
              'gm_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),                            &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_gm(n) > 0) diagnose_gm_redi=.true.

         id_flux_x_gm_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_gm_int_z', &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                                                   &
              'z-integral gm_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),                             &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_gm_int_z(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_gm_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_gm_int_z', &
              Grd%tracer_axes_flux_y(1:2), Time%model_time,                                                   &
              'z-integral gm_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),                             &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_gm_int_z(n) > 0) diagnose_gm_redi=.true.

         id_flux_x_ndiffuse(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_ndiffuse',&
              Grd%tracer_axes_flux_x(1:3), Time%model_time,                                          &
              'gm_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),                               &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_ndiffuse(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_ndiffuse(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_ndiffuse',&
              Grd%tracer_axes_flux_y(1:3), Time%model_time,                                          &
              'gm_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),                               &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_ndiffuse(n) > 0) diagnose_gm_redi=.true.

         id_flux_x_ndiffuse_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_ndiffuse_int_z',&
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                                                              &
              'z-integral gm_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),                                        &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_ndiffuse_int_z(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_ndiffuse_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_ndiffuse_int_z',&
              Grd%tracer_axes_flux_y(1:2), Time%model_time,                                                              &
              'z-integral gm_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),                                        &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_ndiffuse_int_z(n) > 0) diagnose_gm_redi=.true.

     endif

  enddo

  if(diagnose_gm_redi) then 
     call write_note(FILENAME,&
     'ocean_nphysicB has diagnose_gm_redi=.true. to diagnose GM and Redi. It adds memory requirements.')
     allocate( fz1_redi(num_prog_tracers) )
     allocate( fz2_redi(num_prog_tracers) )
     allocate( flux_x_redi(num_prog_tracers) )
     allocate( flux_y_redi(num_prog_tracers) )
     allocate( tendency_redi(num_prog_tracers) )

#ifndef MOM_STATIC_ARRAYS
      allocate (tensor_31_redi(isd:ied,jsd:jed,nk,0:1,0:1))
      allocate (tensor_32_redi(isd:ied,jsd:jed,nk,0:1,0:1))
      do n=1,num_prog_tracers
         allocate ( fz1_redi(n)%field(isd:ied,jsd:jed) )
         allocate ( fz2_redi(n)%field(isd:ied,jsd:jed) )
         allocate ( flux_x_redi(n)%field(isd:ied,jsd:jed,nk) )
         allocate ( flux_y_redi(n)%field(isd:ied,jsd:jed,nk) )
         allocate ( tendency_redi(n)%field(isd:ied,jsd:jed,nk) )
      enddo
#endif 
      tensor_31_redi(:,:,:,:,:) = 0.0
      tensor_32_redi(:,:,:,:,:) = 0.0
      do n=1,num_prog_tracers
         fz1_redi(n)%field(:,:)        = 0.0
         fz2_redi(n)%field(:,:)        = 0.0
         flux_x_redi(n)%field(:,:,:)   = 0.0
         flux_y_redi(n)%field(:,:,:)   = 0.0
         tendency_redi(n)%field(:,:,:) = 0.0
      enddo

  endif


  call ocean_pik_diag_init_ty_trans_gm(ty_trans_gm)

end subroutine ocean_nphysicsB_init
! </SUBROUTINE>  NAME="ocean_nphysicsB_init"


!#######################################################################
! <SUBROUTINE NAME="nphysicsB">
!
! <DESCRIPTION>
! This function computes the thickness weighted and density weighted
! time tendency for tracer from neutral physics.  Full discussion
! and details are provided by Griffies (2004,2005). 
!
! Here is a brief summary of the temporal treatment.  
!
!---How the neutral diffusive flux components are computed:
!
! The vertical flux component is split into diagonal (3,3) and 
! off-diagonal (3,1) and (3,2) terms. The off-diagonal (3,1) and (3,2) 
! terms are included explicitly in time. The main contribution from the 
! (3,3) term to the time tendency is included implicitly in time 
! along with the usual contribution from diapycnal processes 
! (vertical mixing schemes).  This is the K33_implicit term.
! This approach is necessary with high vertical resolution, as 
! noted by Cox (1987).  However, splitting the vertical flux into 
! an implicit and explicit piece compromises the 
! integrity of the vertical flux component (see Griffies et al. 1998).
! So to minimize the disparity engendered by this split, the portion of 
! K33 that can be stably included explicitly in time is computed along 
! with the (3,1) and (3,2) terms. 
! 
! All other terms in the mixing tensor are included explicitly in time
! using a forward time step as required for temporal stability of 
! numerical diffusive processes.  
!
! </DESCRIPTION>
!
subroutine nphysicsB (Time, Thickness, Dens, rho, T_prog, &
                      surf_blthick, gm_diffusivity, baroclinic_rossby_radius)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_density_type),     intent(in)    :: Dens
  real, dimension(isd:,jsd:,:), intent(in)    :: rho
  real, dimension(isd:,jsd:),   intent(in)    :: surf_blthick
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  real, dimension(isd:,jsd:,:), intent(inout) :: gm_diffusivity
  real, dimension(isd:,jsd:),   intent(inout) :: baroclinic_rossby_radius

  integer :: i, j, k, n, nn
  integer :: tau, taum1

  if (.not. use_this_module) return

  if ( .not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_nphysicsB (nphysicsB): needs initialization')
  endif 

  if (size(T_prog(:)) /= num_prog_tracers) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_nphysicsB (nphysicsB): inconsistent size of T_prog')
  endif 

  taum1 = Time%taum1
  tau   = Time%tau

  ! time dependent delqc geometric factor 
  do k=1,nk
    delqc(:,:,k,0) = Grd%fracdz(k,0)*Thickness%rho_dzt(:,:,k,tau)
    delqc(:,:,k,1) = Grd%fracdz(k,1)*Thickness%rho_dzt(:,:,k,tau)
  enddo

  ! time dependent inverse dzwt 
  do k=0,nk
    dzwtr(:,:,k) = 1.0/Thickness%dzwt(:,:,k) 
  enddo

  ! boundary layer thicknesses read from other 
  ! modules are needed here on the data domain
  surf_bdlthick(COMP) = surf_blthick(COMP)
  call mpp_update_domains(surf_bdlthick(:,:), Dom%domain2d) 

  drhodT(:,:,:) = Dens%drhodT(:,:,:)
  drhodS(:,:,:) = Dens%drhodS(:,:,:)

  call tracer_derivs(Time, taum1, dtime, drhodT, drhodS, T_prog, Dens, dzwtr, &
                     dTdx, dTdy, dTdz, dSdx, dSdy, dSdz, drhodzb, drhodzh) 
  call neutral_slopes(Time, dTdx, dTdy, dSdx, dSdy, drhodT, drhodS, drhodzb, tensor_31, tensor_32)

  call cabbeling_thermob_tendency(Time, Thickness, T_prog, Dens,                               &
  dTdx(index_temp)%field(:,:,:), dTdy(index_temp)%field(:,:,:), dTdz(index_temp)%field(:,:,:), &
  dSdx%field(:,:,:), dSdy%field(:,:,:),                                                        &
  drhodzh, dxtdtsn, dtwedyt, dzwtr, delqc, aredi_array)

  call compute_eta_tend_gm90(Time, Thickness, Dens,             &
  dTdx(index_temp)%field(:,:,:), dTdy(index_temp)%field(:,:,:), &
  dSdx%field(:,:,:), dSdy%field(:,:,:),                         &
  drhodzh, dtwedyt, dzwtr, delqc, tensor_31, tensor_32, agm_array)

  call neutral_blayer(Time, Thickness)

  if(diagnose_gm_redi) then 
      do n=1,num_prog_tracers  
         fz1_redi(n)%field(:,:) = 0.0
         fz2_redi(n)%field(:,:) = 0.0
         flux_x_redi(n)%field(:,:,:)   = 0.0
         flux_y_redi(n)%field(:,:,:)   = 0.0
         tendency_redi(n)%field(:,:,:) = 0.0
      enddo
      call fz_terms_diag(Time, Thickness)   ! must be called prior to fz_terms
  endif

  call fz_terms(Time, Thickness, Dens, T_prog, rho)

  do n=1,num_prog_tracers  
    fz1(n)%field(:,:)      = 0.0
    fz2(n)%field(:,:)      = 0.0
    flux_x(n)%field(:,:,:) = 0.0
    flux_y(n)%field(:,:,:) = 0.0
    T_prog(n)%wrk1(:,:,:)  = 0.0
  enddo 

  
  do k=1,nk
     call mpp_clock_begin(id_clock_fx_flux)
     call fx_flux(Time, Thickness, T_prog, k)
     call mpp_clock_end(id_clock_fx_flux) 

     call mpp_clock_begin(id_clock_fy_flux)
     call fy_flux(Time, Thickness, T_prog, k)
     call mpp_clock_end(id_clock_fy_flux)
  enddo
  if (Grd%tripolar) then 
      do nn=1,num_prog_tracers
         call mpp_update_domains(flux_x(nn)%field(:,:,:), flux_y(nn)%field(:,:,:), Dom_flux%domain2d, &
              gridtype=CGRID_NE, complete=T_prog(nn)%complete) 
      enddo
  endif

  do k=1,nk
     call mpp_clock_begin(id_clock_fz_flux)
     call fz_flux(T_prog,k)
     call mpp_clock_end(id_clock_fz_flux)
     do nn=1,num_prog_tracers
        do j=jsc,jec
           do i=isc,iec
              T_prog(nn)%wrk1(i,j,k) = & 
                   Grd%tmask(i,j,k)  &
                   *(fz1(nn)%field(i,j)-fz2(nn)%field(i,j) &
                   +( flux_x(nn)%field(i,j,k)-flux_x(nn)%field(i-1,j,k) &
                   +flux_y(nn)%field(i,j,k)-flux_y(nn)%field(i,j-1,k) )*Grd%datr(i,j) &
                   )
           enddo
        enddo
        T_prog(nn)%th_tendency(COMP,k) = T_prog(nn)%th_tendency(COMP,k) + T_prog(nn)%wrk1(COMP,k)
        fz1(nn)%field(COMP) = fz2(nn)%field(COMP)
     enddo
  enddo

  ! some extra diagnostics to split GM and Redi pieces 
  if(diagnose_gm_redi) then 

      do k=1,nk
         call mpp_clock_begin(id_clock_fx_flux_diag)
         call fx_flux_diag(Time, Thickness, T_prog, k)
         call mpp_clock_end(id_clock_fx_flux_diag) 

         call mpp_clock_begin(id_clock_fy_flux_diag)
         call fy_flux_diag(Time, Thickness, T_prog, k)
         call mpp_clock_end(id_clock_fy_flux_diag)
      enddo
      if (Grd%tripolar) then 
          do nn=1,num_prog_tracers
             call mpp_update_domains(flux_x_redi(nn)%field(:,:,:), flux_y_redi(nn)%field(:,:,:), &
                  Dom_flux%domain2d, gridtype=CGRID_NE, complete=T_prog(nn)%complete) 
          enddo
      endif

      do k=1,nk
         call mpp_clock_begin(id_clock_fz_flux_diag)
         call fz_flux_diag(T_prog,k)
         call mpp_clock_end(id_clock_fz_flux_diag)
         do nn=1,num_prog_tracers
            do j=jsc,jec
               do i=isc,iec
                  tendency_redi(nn)%field(i,j,k) =                                                   & 
                       Grd%tmask(i,j,k)                                                              &
                       *(fz1_redi(nn)%field(i,j)-fz2_redi(nn)%field(i,j)                             &
                       +(flux_x_redi(nn)%field(i,j,k)-flux_x_redi(nn)%field(i-1,j,k)                 &
                       + flux_y_redi(nn)%field(i,j,k)-flux_y_redi(nn)%field(i,j-1,k) )*Grd%datr(i,j) &
                       )
               enddo
            enddo
            fz1_redi(nn)%field(COMP) = fz2_redi(nn)%field(COMP)
         enddo
      enddo  ! enddo for k=1,nk
  endif

  ! compute Eady growth rate for use in next time step 
  call compute_eady_rate(Time, Thickness, T_prog, Dens, eady_termx, eady_termy)

  ! compute baroclinicity for use in next time step 
  call compute_baroclinicity(Time, baroclinic_termx, baroclinic_termy)

  ! compute rossby radius for use in next time step.
  ! rossby radius is needed for diffusivity 
  ! calculation and transition layer calculation.   
  call compute_rossby_radius(Thickness, dTdz, dSdz, Time, drhodT, drhodS, &
                             rossby_radius, rossby_radius_raw)
  baroclinic_rossby_radius(:,:) = rossby_radius_raw(:,:)

  ! compute width of baroclinic zone for use in next time step 
  call compute_bczone_radius(Time, bczone_radius)

  ! update closure-based diffusivity for next time step 
  call compute_diffusivity(Time, ksurf_blayer, Dens%drhodz_zt, rossby_radius, &
                           bczone_radius, agm_array, aredi_array)

  ! gm_diffusivity passed to neutral_physics for computing form drag viscosity 
  gm_diffusivity(:,:,:) = agm_array(:,:,:)

  call nphysics_diagnostics(Time, T_prog, Dens)

end subroutine nphysicsB
! </SUBROUTINE> NAME="nphysicsB"


!#######################################################################
! <SUBROUTINE NAME="neutral_blayer">
!
! <DESCRIPTION>
!
! This subroutine computes the "neutral boundary layers" based on
! the formulation of Ferrari and McWilliams (2006). See full
! details and discussion in Elements of MOM4p1 by Griffies (2009).  
!
! Five vertical regions are identified by Ferrari and McWilliams:
! We simplify these regimes by melding the turbulent and transition 
! regimes into an overall neutral boundary layer regime, within which
! the streamfunction is linearly tapers to zero moving towards the 
! boundary.  We also ignore the bottom regimes, as these are poorly 
! resolved in most models, and the neutral physics fluxes are 
! typically small at the bottom.  
! 
! (1) Surface turbulent region:
!    Depth ("h" in Ferrari and McWilliams notation) dominated by 
!    3d turbulent processes.  This depth is taken from surf_blthick,
!    as set by the KPP scheme or another mixed layer scheme.
!    A minimum is set as surf_turb_thick_min and is specified 
!    as a nml parameter in ocean_nphysicsB_nml. 
!
!    In order to use a low frequency version of the boundary layer
!    thickness, we damp its evolution with a damping time scale
!    neutral_damping_time (days). 
!
!    In the code, "h_surf"= surf_turb_thick  
!
! (2) Surface transition region:
!    Thickness ("D" in Ferrari and McWilliams notation)
!    between the turbulent surface boundary layer and the interior.
!    This transition layer thickness is determined by the product of the 
!    neutral slope and first baroclinic Rossby radius.  This specification 
!    is ad hoc, and more fundamental theories are welcome. 
!
!    In the code, "D_surf"= surf_trans_thick 
!    
!!!!!!
!    Within a "boundary layer" region set by the sum of 
!    surf_turb_thick plus surf_trans_thick, the eddy 
!    induced velocity is assumed to have zero vertical shear, 
!    which means the quasi-Stokes streamfunction is linear with 
!    depth.  The neutral diffusive fluxes are reduced to horizontal 
!    downgradient diffusion, with "horizontal" defined according
!    to surfaces of constant vertical coordinate. 
!!!!!!
!
! (3) Interior region:
!    Where neutral diffusion and GM skew-diffusion are taken 
!    from their unmodified form. 
!
!  Only use the 31 and 32 triads for this computation since the 
!  13 and 23 triads require extra slope calculations, and 
!  so will add lots of computational cost. It is felt that the
!  31 and 32 triads are sufficient for this calculation, in 
!  a similar manner that they are used for the calculation of 
!  the non-constant diffusivities.  
! 
! Scheme coded for MOM4p1 by Stephen.Griffies
! Version: March2006
! Simplified version: June2008
! 
! </DESCRIPTION>
!
subroutine neutral_blayer(Time, Thickness)

  type(ocean_time_type),      intent(in) :: Time
  type(ocean_thickness_type), intent(in) :: Thickness

  real, dimension(isd:ied,jsd:jed) :: tmp_ksurf_blayer

  logical :: below_blayer
  logical :: within_interior

  integer :: i, j, k, tau
  integer :: kkp1, kkp2, kkp3
  integer :: kb, kk

  real :: tmp_thickness(4)
  real :: region_thickness(4)
  real :: tmp_surf_turb_thick
  real :: tmp_thick_surf

  call mpp_clock_begin(id_clock_neutral_blayer)

  tau = Time%tau

  ! save the max of abs(slope) in wrk1. this array is
  ! needed to define the surface turb region and transition
  ! region.  
  wrk1(:,:,:) = 0.0
  do k=1,nk
     wrk1(COMP,:) = max( abs(tensor_31(COMP,:,0,0)),abs(tensor_31(COMP,:,0,1)), &
          abs(tensor_31(COMP,:,1,0)),abs(tensor_31(COMP,:,1,1)), & 
          abs(tensor_32(COMP,:,0,0)),abs(tensor_32(COMP,:,0,1)), &
          abs(tensor_32(COMP,:,1,0)),abs(tensor_32(COMP,:,1,1)) )
  enddo

  ! Update thickness of the surface turbulent region for use 
  ! in the neutral_blayer calculation. This thickness is damped relative
  ! to that available from the mixed layer physics, as we are interested
  ! here in the slowly varying form of this thickness. 
  do j=jsd,jed
     do i=isd,ied
        kb=Grd%kmt(i,j)
        if(kb>1) then 
            tmp_surf_turb_thick =  &
              Grd%tmask(i,j,1)*max(surf_turb_thick_min,surf_bdlthick(i,j))
            surf_turb_thick(i,j) = &
              surf_turb_thick(i,j) - gamma_damp*(surf_turb_thick(i,j)-tmp_surf_turb_thick)
                     endif
         enddo
      enddo

  ! spatially smooth surface boundary layer thickness 
  if(nblayer_smooth) then
     call mpp_update_domains(surf_turb_thick(:,:), Dom%domain2d) 
     surf_turb_thick(:,:) = surf_turb_thick(:,:) + dtime*LAP_T(surf_turb_thick(:,:),smooth_lap(:,:))
  endif 


  ! flag for case when full column is turbulent 
  ! (e.g., shallow shelves or deep convection)
  do j=jsc,jec
     do i=isc,iec
        kb=max(1,Grd%kmt(i,j))    
        full_turb_column(i,j) = 0.0
        if(kb>1 .and. surf_turb_thick(i,j) >= Thickness%depth_zwt(i,j,kb)) then 
            full_turb_column(i,j) = 1.0            
        endif
     enddo
  enddo


  ! Determine surface transition region. 
  ! Thise region is determined by the thickness over 
  ! which mesoscale eddies feel the turbulent surface layer.
  ! This thickness is a function of the neutral slope 
  ! times the Rossby radius. The algorithm for computing
  ! this depth is taken from the appendix to Large etal, 
  ! (1997) JPO, pages 2418-2447. It is also described 
  ! in Ferrari and McWilliams (2006) and Griffies (2004).
  ! The thickness of this region is always set > 0. 
  ! 
  ! NOTE: We examine more than one slope*rossby in the vertical
  ! since generally there can be regions of small slopes intermixed
  ! within the large slopes present in the transition layer.
  ! The non-local examination allows for a smoother transition out
  ! of the boundary layer into the interior.  
  !
  ! Also note we take the max from the 8-surrounding triad slopes,
  ! so to maximize the transition layer thicknesses. 
  
  do j=jsc,jec
     do i=isc,iec

        kb             = Grd%kmt(i,j) 
        below_blayer   = .false.
        tmp_thick_surf = 0.0

        ! only compute transition regions if there are enough
        ! vertical cells, and if the column is not fully turbulent. 
        if(kb>surf_turb_thick_min_k+2 .and. full_turb_column(i,j)==0.0) then 


            ! surface region  
            kkloop_surf: do kk=surf_turb_thick_min_k+1,kb-1
               kkp1=min(kk+1,kb)
               kkp2=min(kk+2,kb)
               kkp3=min(kk+3,kb)

               ! to ensure we have captured the boundary layer, 
               ! we check kk, kkp1, kkp2 and kkp3 for good measure. 
               ! this is a bit arbitrary...but useful.  
               region_thickness(1) = rossby_radius(i,j)*wrk1(i,j,kk)
               region_thickness(2) = rossby_radius(i,j)*wrk1(i,j,kkp1)
               region_thickness(3) = rossby_radius(i,j)*wrk1(i,j,kkp2)
               region_thickness(4) = rossby_radius(i,j)*wrk1(i,j,kkp3)
               tmp_thickness(1)    = region_thickness(1) + surf_turb_thick(i,j) 
               tmp_thickness(2)    = region_thickness(2) + surf_turb_thick(i,j) 
               tmp_thickness(3)    = region_thickness(3) + surf_turb_thick(i,j) 
               tmp_thickness(4)    = region_thickness(4) + surf_turb_thick(i,j) 

               if(tmp_thickness(1) <= Thickness%depth_zwt(i,j,kk) .and. &
                    tmp_thickness(2) <= Thickness%depth_zwt(i,j,kk) .and. &
                    tmp_thickness(3) <= Thickness%depth_zwt(i,j,kk) .and. & 
                    tmp_thickness(4) <= Thickness%depth_zwt(i,j,kk) .and. & 
                    .not. below_blayer) then 
                   below_blayer   = .true.
                   tmp_thick_surf = Thickness%depth_zwt(i,j,kk)-surf_turb_thick(i,j)
                   exit kkloop_surf 
               endif
            enddo kkloop_surf

            ! never got below the surface transition layer.
            ! this typically means the slopes are huge or the 
            ! column is very shallow. so column is "fully turbulent".  
            if(.not. below_blayer) then 
                full_turb_column(i,j) = 1.0            
            endif

        endif

        ! column is too small, or is fully turbulent.
        if(kb>1 .and. (full_turb_column(i,j)==1.0 .or. kb<=surf_turb_thick_min_k+2)) then 
            tmp_thick_surf        = 0.0
            full_turb_column(i,j) = 1.0 
        endif

        ! time damping to smooth the field 
        surf_trans_thick(i,j) = surf_trans_thick(i,j) - gamma_damp*(surf_trans_thick(i,j) -tmp_thick_surf) 

     ! end of j,i loops 
     enddo
  enddo


  ! apply spatial smoothing to the boundary field...smoothing may
  ! be needed in space, even with the temporal smoothing used above. 
  if(nblayer_smooth) then
      call mpp_update_domains(surf_trans_thick(:,:), Dom%domain2d) 
      surf_trans_thick(:,:) = surf_trans_thick(:,:) &
           + dtime*LAP_T(surf_trans_thick(:,:),smooth_lap(:,:))
  endif

  ! compute boundary layer depth
  do j=jsc,jec
     do i=isc,iec
        kb=Grd%kmt(i,j)
        if(kb>1) then 
            depth_blayer_base(i,j) = surf_trans_thick(i,j) + surf_turb_thick(i,j)
        endif
     enddo
  enddo
  call mpp_update_domains(depth_blayer_base, Dom%domain2d) 


  ! save the k-level surface transition layer. 
  ! initialize ksurf_blayer to 1 rather than 0, to avoid 
  ! accessing the zeroth element of an array.   
  ksurf_blayer(:,:)     = 1
  tmp_ksurf_blayer(:,:) = 0.0
  do j=jsd,jed
     do i=isd,ied
        kb=Grd%kmt(i,j)
        within_interior=.false.
        ksurf_blayer_loop: do k=surf_turb_thick_min_k,kb
           if(Thickness%depth_zwt(i,j,k) > depth_blayer_base(i,j)) then 
               ksurf_blayer(i,j)     = k
               tmp_ksurf_blayer(i,j) = float(k)
               exit ksurf_blayer_loop
           endif
        enddo ksurf_blayer_loop
     enddo
  enddo

  ! save abs(slope) at base of the surface boundary layer for use in 
  ! computing the streamfunction at this point and then linear 
  ! tapering to the surface. It is important to place a limit 
  ! on slope_blayer_base, since in some regions the blayer_base
  ! could still have infinite slopes...
  do j=jsc,jec
     do i=isc,iec
        k = ksurf_blayer(i,j)
        if(k > 1) then 
            slope_blayer_base(i,j)           = &
                 (abs(tensor_31(i,j,k,0,0))  + & 
                  abs(tensor_31(i,j,k,1,0))  + &
                  abs(tensor_31(i,j,k,0,1))  + & 
                  abs(tensor_31(i,j,k,1,1))  + &
                  abs(tensor_32(i,j,k,0,0))  + &
                  abs(tensor_32(i,j,k,0,1))  + &
                  abs(tensor_32(i,j,k,1,0))  + &
                  abs(tensor_32(i,j,k,1,1)))*oneeigth
            slope_blayer_base(i,j) = min(smax,slope_blayer_base(i,j))
        endif
     enddo
  enddo
  call mpp_update_domains(slope_blayer_base, Dom%domain2d) 


  ! diagnostics 
  call diagnose_2d(Time, Grd, id_slope_blayer_base, slope_blayer_base(:,:))
  call diagnose_2d(Time, Grd, id_surf_turb_thick, surf_turb_thick(:,:))
  call diagnose_2d(Time, Grd, id_surf_trans_thick, surf_trans_thick(:,:))
  call diagnose_2d(Time, Grd, id_depth_blayer_base, depth_blayer_base(:,:))
  call diagnose_2d(Time, Grd, id_full_turb_column, full_turb_column(:,:))

  call mpp_clock_end(id_clock_neutral_blayer)

end subroutine neutral_blayer
! </SUBROUTINE> NAME="neutral_blayer"


!#######################################################################
! <SUBROUTINE NAME="fz_terms">
!
! <DESCRIPTION>
! Subroutine computes the tracer independent pieces of the vertical 
! flux component. As a result of this routine, 
! Array tensor_31 = x-diffusivity*slope (m^2/sec) for fz
! Array tensor_32 = y-diffusivity*slope (m^2/sec) for fz 
!
! K33 is the (3,3) term in small angle Redi diffusion tensor.
! It is broken into an explicit in time piece and implicit 
! in time piece.  It is weighted by density for non-Boussinesq
! and rho0 for Boussinesq.  
!
! K33 has units (kg/m^3)*m^2/sec.
!
! Also will compute the squared Eady growth rate, with the maximum
! slope contributing to this growth rate set by smax.
! </DESCRIPTION>
!
subroutine fz_terms(Time, Thickness, Dens, T_prog, rho)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  real, dimension(isd:,jsd:,:), intent(in)    :: rho

  integer :: i, j, k, n, ip, jq, kr, tau

  real :: baroclinic_triad, K33, K33_crit
  real :: sumx(0:1), sumy(0:1)

  real :: slope, absslope, depth_ratio
  real :: taperA, taperB
  real :: taper_slope, taper_slope2, gm_taper_slope 

  real :: aredi_scalar, agm_scalar, aredi_plus_agm 
  real :: absdrhodzb(0:1)
  real :: mindelqc(0:1,0:1), delqc_ijk_1, delqc_ijkp1_0

  call mpp_clock_begin(id_clock_fz_terms)

  tau = Time%tau
  
  eady_termx(:,:,:)     = 0.0
  eady_termy(:,:,:)     = 0.0
  baroclinic_termx(:,:) = 0.0
  baroclinic_termy(:,:) = 0.0
  tx_trans_gm(:,:,:)    = 0.0
  ty_trans_gm(:,:,:)    = 0.0


! Main loop. Short ip,jq,kr loops are explicitly unrolled
! in order to expose independence and allow vectorisation

  do k=1,nk-1
     do j=jsc,jec
        do i=isc,iec

           aredi_scalar    = aredi_array(i,j,k)
           agm_scalar      = gm_skew*agm_array(i,j,k)
           aredi_plus_agm  = aredi_scalar + agm_scalar

           absdrhodzb(0) = abs(drhodzb(i,j,k,0))
           absdrhodzb(1) = abs(drhodzb(i,j,k,1))

           delqc_ijk_1      = delqc(i,j,k,1)
           delqc_ijkp1_0    = delqc(i,j,k+1,0)
           
           !mindelqc(ip,kr) = min(delqc(i-1+ip,j,k+kr,1-kr),delqc(i+ip,j,k+kr,1-kr)) 
           ip=0 ; kr=0
           mindelqc(ip,kr)  = min(delqc(i-1,j,k,1),delqc_ijk_1) 
           ip=0 ; kr=1
           mindelqc(ip,kr)  = min(delqc(i-1,j,k+1,0),delqc_ijkp1_0) 
           ip=1 ; kr=0
           mindelqc(ip,kr)  = min(delqc_ijk_1,delqc(i+1,j,k,1)) 
           ip=1 ; kr=1
           mindelqc(ip,kr)  = min(delqc_ijkp1_0,delqc(i+1,j,k+1,0)) 

           tx_trans_gm(i,j,k) = 0.0
           baroclinic_triad   = 0.0

           ip=0   
              sumx(ip) = 0.0

              kr=0
                 slope    = tensor_31(i,j,k,ip,kr)
                 absslope = abs(slope)
                 
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                     depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB      = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB      = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then      
                     gm_taper_slope = (Thickness%depth_zt(i,j,k)/depth_blayer_base(i,j)) &
                                       *slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif


                 tx_trans_gm(i,j,k)     = tx_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope       
                 tensor_31(i,j,k,ip,kr) = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumx(ip)               = sumx(ip)                 + mindelqc(ip,kr)*taper_slope2
                 eady_termx(i,j,k)      = eady_termx(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad       = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)

              kr=1
                 slope    = tensor_31(i,j,k,ip,kr)
                 absslope = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then
                     depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB      = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB      = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then      
                     gm_taper_slope = (Thickness%depth_zt(i,j,k)/depth_blayer_base(i,j)) &
                                      *slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 tx_trans_gm(i,j,k)     = tx_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope      
                 tensor_31(i,j,k,ip,kr) = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumx(ip)               = sumx(ip)                 + mindelqc(ip,kr)*taper_slope2
                 eady_termx(i,j,k)      = eady_termx(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad       = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)
                 sumx(ip)               = sumx(ip)*dtew(i,j,ip)

           ip=1   
              sumx(ip) = 0.0

              kr=0
                 slope        = tensor_31(i,j,k,ip,kr)
                 absslope     = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                     depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB      = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB      = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then      
                     gm_taper_slope = (Thickness%depth_zt(i,j,k)/depth_blayer_base(i,j)) &
                                      *slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 tx_trans_gm(i,j,k)     = tx_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope    
                 tensor_31(i,j,k,ip,kr) = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumx(ip)               = sumx(ip)                 + mindelqc(ip,kr)*taper_slope2
                 eady_termx(i,j,k)      = eady_termx(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad       = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)

              kr=1
                 slope        = tensor_31(i,j,k,ip,kr)
                 absslope     = abs(slope)
                                                     
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                     depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB      = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB      = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then      
                     gm_taper_slope = (Thickness%depth_zt(i,j,k)/depth_blayer_base(i,j)) &
                                      *slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 tx_trans_gm(i,j,k)     = tx_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope   
                 tensor_31(i,j,k,ip,kr) = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumx(ip)               = sumx(ip)                 + mindelqc(ip,kr)*taper_slope2
                 eady_termx(i,j,k)      = eady_termx(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad       = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)
                 sumx(ip)               = sumx(ip)*dtew(i,j,ip)

           if(Thickness%depth_zt(i,j,k) >= agm_closure_upper_depth .and. &
              Thickness%depth_zt(i,j,k) <= agm_closure_lower_depth) then 
             baroclinic_termx(i,j) = baroclinic_termx(i,j) + baroclinic_triad*Thickness%dzwt(i,j,k)
           endif 

           tx_trans_gm(i,j,k)    = 0.25*tx_trans_gm(i,j,k)*Grd%dyu(i,j)

           !mindelqc(jq,kr) = min(delqc(i,j-1+jq,k+kr,1-kr),delqc(i,j+jq,k+kr,1-kr)) 
           jq=0 ; kr=0
           mindelqc(jq,kr)  = min(delqc(i,j-1,k,1),delqc_ijk_1) 
           jq=0 ; kr=1
           mindelqc(jq,kr)  = min(delqc(i,j-1,k+1,0),delqc_ijkp1_0) 
           jq=1 ; kr=0
           mindelqc(jq,kr)  = min(delqc_ijk_1,delqc(i,j+1,k,1)) 
           jq=1 ; kr=1
           mindelqc(jq,kr)  = min(delqc_ijkp1_0,delqc(i,j+1,k+1,0)) 

           ty_trans_gm(i,j,k) = 0.0
           baroclinic_triad   = 0.0 

           jq=0   
              sumy(jq) = 0.0

               kr=0
                 slope        = tensor_32(i,j,k,jq,kr)
                 absslope     = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                     depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB      = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB      = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then      
                     gm_taper_slope = (Thickness%depth_zt(i,j,k)/depth_blayer_base(i,j)) &
                                      *slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 ty_trans_gm(i,j,k)     = ty_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope       
                 tensor_32(i,j,k,jq,kr) = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumy(jq)               = sumy(jq)                 + mindelqc(jq,kr)*taper_slope2
                 eady_termy(i,j,k)      = eady_termy(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad       = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)

              kr=1
                 slope        = tensor_32(i,j,k,jq,kr)
                 absslope     = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                     depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB      = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB      = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then      
                     gm_taper_slope = (Thickness%depth_zt(i,j,k)/depth_blayer_base(i,j)) &
                                      *slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 ty_trans_gm(i,j,k)     = ty_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope      
                 tensor_32(i,j,k,jq,kr) = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumy(jq)               = sumy(jq)                 + mindelqc(jq,kr)*taper_slope2
                 eady_termy(i,j,k)      = eady_termy(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad       = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)
                 sumy(jq)               = sumy(jq)*dtns(i,j,jq)

           jq=1   
              sumy(jq) = 0.0

               kr=0
                 slope    = tensor_32(i,j,k,jq,kr)
                 absslope = abs(slope)

                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                     depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB      = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB      = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then      
                     gm_taper_slope = (Thickness%depth_zt(i,j,k)/depth_blayer_base(i,j)) &
                                      *slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 ty_trans_gm(i,j,k)     = ty_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope     
                 tensor_32(i,j,k,jq,kr) = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumy(jq)               = sumy(jq)                 + mindelqc(jq,kr)*taper_slope2
                 eady_termy(i,j,k)      = eady_termy(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad       = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)

              kr=1
                 slope    = tensor_32(i,j,k,jq,kr)
                 absslope = abs(slope)

                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                     depth_ratio     = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then      
                     gm_taper_slope = (Thickness%depth_zt(i,j,k)/depth_blayer_base(i,j)) &
                                      *slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 ty_trans_gm(i,j,k)     = ty_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope      
                 tensor_32(i,j,k,jq,kr) = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumy(jq)               = sumy(jq)                 + mindelqc(jq,kr)*taper_slope2
                 eady_termy(i,j,k)      = eady_termy(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad       = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)

                 sumy(jq) = sumy(jq)*dtns(i,j,jq)

           if(Thickness%depth_zt(i,j,k) >= agm_closure_upper_depth .and. &
              Thickness%depth_zt(i,j,k) <= agm_closure_lower_depth) then
             baroclinic_termy(i,j) = baroclinic_termy(i,j) + baroclinic_triad*Thickness%dzwt(i,j,k)
           endif 

           ty_trans_gm(i,j,k)    = 0.25*ty_trans_gm(i,j,k)*Grd%dxu(i,j)
           
           K33 = aredi_scalar*Grd%tmask(i,j,k+1)*(Grd%dxtr(i,j)*(sumx(0)+sumx(1)) &
                            + Grd%dytr(i,j)*(sumy(0)+sumy(1)))*dzwtr(i,j,k)

           ! determine part of K33 included explicitly in time and that part implicitly. 
           ! explicit calculation is more accurate than implicit, so aim to compute as much 
           ! as stably possible via the explicit method. 
           K33_explicit(i,j,k) = K33
           K33_implicit(i,j,k) = 0.0 
           if(.not. diffusion_all_explicit) then 
               K33_crit = two_dtime_inv*Thickness%rho_dzt(i,j,k,tau)*Thickness%dzt(i,j,k)
               if(K33 >= K33_crit) then 
                   K33_explicit(i,j,k) = K33_crit
                   K33_implicit(i,j,k) = K33-K33_crit
               endif
           endif

        enddo
     enddo
  enddo

  if(tmask_sigma_on) then
     do j=jsc,jec
        do i=isc,iec
           if(tmask_sigma(i,j) > 0.0) then 
              k = Grd%kmt(i,j)-1
              K33_implicit(i,j,k) = K33_implicit(i,j,k)*(1.0-tmask_sigma(i,j))
              K33_explicit(i,j,k) = K33_explicit(i,j,k)*(1.0-tmask_sigma(i,j))
           endif
        enddo
     enddo
 endif
 
 if(tmask_neutral_on) then
     do j=jsc,jec
        do i=isc,iec
           K33_implicit(i,j,1) = 0.0  
           K33_explicit(i,j,1) = 0.0  
           tx_trans_gm(i,j,1)  = 0.0  
           ty_trans_gm(i,j,1)  = 0.0  
           if(Grd%kmt(i,j) > 1) then 
               k = Grd%kmt(i,j)-1
               K33_implicit(i,j,k) = 0.0
               K33_explicit(i,j,k) = 0.0
               tx_trans_gm(i,j,k)  = 0.0  
               ty_trans_gm(i,j,k)  = 0.0  
           endif
        enddo
     enddo
 endif

 do n=1,num_prog_tracers 
   T_prog(n)%K33_implicit(:,:,:) = K33_implicit(:,:,:)
 enddo
 if(neutral_physics_limit) then 
     do n=1,num_prog_tracers 
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                if(T_prog(n)%tmask_limit(i,j,k)==1.0) T_prog(n)%K33_implicit(i,j,k) = 0.0
              enddo
           enddo
        enddo
     enddo
 endif


  do n=1,num_prog_tracers
     if (id_k33_implicit(n) > 0) then
        call diagnose_3d(Time, Grd, id_k33_implicit(n), rho0r*T_prog(n)%K33_implicit(:,:,:))
     endif 
  enddo 


  ! rho factor to get mass transport.
  if(vert_coordinate_class==DEPTH_BASED) then 
     tx_trans_gm(COMP,:) = tx_trans_gm(COMP,:)*rho0
     ty_trans_gm(COMP,:) = ty_trans_gm(COMP,:)*rho0
  else
     tx_trans_gm(COMP,:) = tx_trans_gm(COMP,:)*rho(COMP,:)
     ty_trans_gm(COMP,:) = ty_trans_gm(COMP,:)*rho(COMP,:)
  endif

  call transport_on_rho_gm (Time, Dens, &
       transport_convert*tx_trans_gm(:,:,:), transport_convert*ty_trans_gm(:,:,:))
  call transport_on_nrho_gm(Time, Dens, &
       transport_convert*tx_trans_gm(:,:,:), transport_convert*ty_trans_gm(:,:,:))
  call transport_on_theta_gm(Time, Dens, T_prog(index_temp), &
       transport_convert*tx_trans_gm(:,:,:), transport_convert*ty_trans_gm(:,:,:))

  ! transport_convert converts kg/s to chosen dimensions (either kg/s or Sv (10^9 kg/s)) 
  if(id_tx_trans_gm > 0) then 
      call mpp_update_domains(tx_trans_gm, Dom%domain2d,flags=EUPDATE)
      do k=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               tx_trans_gm(i,j,k) = transport_convert*Grd%dxuer(i,j)*   &
                                   (tx_trans_gm(i+1,j,k)*Grd%due(i,j) + &
                                    tx_trans_gm(i,j,k)  *Grd%duw(i+1,j))
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_tx_trans_gm, tx_trans_gm(:,:,:))
  endif

  ! transport_convert converts kg/s to chosen dimensions (either kg/s or Sv (10^9 kg/s))  
  if(id_ty_trans_gm > 0 .OR. do_pik_diag) then 
      call mpp_update_domains(ty_trans_gm, Dom%domain2d,flags=NUPDATE)
      do k=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               ty_trans_gm(i,j,k) = transport_convert*Grd%dyunr(i,j)*           &
                                          (ty_trans_gm(i,j+1,k)*Grd%dun(i,j) +  &
                                           ty_trans_gm(i,j,k)  *Grd%dus(i,j+1)) 
                                        
            enddo
         enddo
      enddo
      if(id_ty_trans_gm > 0) &
      call diagnose_3d(Time, Grd, id_ty_trans_gm, ty_trans_gm(:,:,:))
  endif

  call mpp_clock_end(id_clock_fz_terms)

end subroutine fz_terms
! </SUBROUTINE>  NAME="fz_terms"


!#######################################################################
! <SUBROUTINE NAME="fz_terms_diag">
!
! <DESCRIPTION>
! For saving the contributions from GM and Redi separately, it is 
! necessary to compute the tensor_redi component here. 
!
! We do so here, reproducing some lines of code from fz_terms,
! to reduce minimize the need to impinge on the case when NOT
! using this generally expensive (memory and computational)
! diagnostic.  
!
! This routine MUST be called prior to fz_terms, since we use
! tensor_31 and tensor_32 in their raw slope forms here.  
!
! </DESCRIPTION>
!
subroutine fz_terms_diag(Time, Thickness)

  type(ocean_time_type),      intent(in) :: Time
  type(ocean_thickness_type), intent(in) :: Thickness

  integer :: i, j, k, ip, jq, kr, tau

  real :: slope, absslope, depth_ratio
  real :: taperA, taperB
  real :: taper_slope
  real :: aredi_scalar

  call mpp_clock_begin(id_clock_fz_terms_diag)

  tau = Time%tau
  
  ! Main loop. Short ip,jq,kr loops are explicitly unrolled
  ! in order to expose independence and allow vectorisation
  do k=1,nk-1
     do j=jsc,jec
        do i=isc,iec

           aredi_scalar = aredi_array(i,j,k)

           ip=0   

              kr=0
                 slope    = tensor_31(i,j,k,ip,kr)
                 absslope = abs(slope)
                 
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                     depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_31_redi(i,j,k,ip,kr) = aredi_scalar*taper_slope

              kr=1
                 slope    = tensor_31(i,j,k,ip,kr)
                 absslope = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then
                     depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_31_redi(i,j,k,ip,kr) = aredi_scalar*taper_slope 

           ip=1   

              kr=0
                 slope        = tensor_31(i,j,k,ip,kr)
                 absslope     = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                     depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_31_redi(i,j,k,ip,kr) = aredi_scalar*taper_slope 

              kr=1
                 slope        = tensor_31(i,j,k,ip,kr)
                 absslope     = abs(slope)
                                                     
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                     depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_31_redi(i,j,k,ip,kr) = aredi_scalar*taper_slope 

           jq=0   

               kr=0
                 slope        = tensor_32(i,j,k,jq,kr)
                 absslope     = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                     depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_32_redi(i,j,k,jq,kr) = aredi_scalar*taper_slope 

              kr=1
                 slope        = tensor_32(i,j,k,jq,kr)
                 absslope     = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                     depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_32_redi(i,j,k,jq,kr) = aredi_scalar*taper_slope 

           jq=1   

               kr=0
                 slope    = tensor_32(i,j,k,jq,kr)
                 absslope = abs(slope)

                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                     depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_32_redi(i,j,k,jq,kr) = aredi_scalar*taper_slope 

              kr=1
                 slope    = tensor_32(i,j,k,jq,kr)
                 absslope = abs(slope)

                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than depth_blayer_base
                 if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                     depth_ratio     = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_32_redi(i,j,k,jq,kr) = aredi_scalar*taper_slope 

        enddo
     enddo
  enddo


  call mpp_clock_end(id_clock_fz_terms_diag)

end subroutine fz_terms_diag
! </SUBROUTINE>  NAME="fz_terms_diag"


!#######################################################################
! <SUBROUTINE NAME="fx_flux">
!
! <DESCRIPTION>
! Subroutine computes the i-directed neutral physics tracer flux component.
! Compute this component for all tracers at level k.
!
! fx has physical dimensions (area*diffusivity*density*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fx_flux(Time, Thickness, T_prog, k)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer,                      intent(in) :: k

  integer :: nn, i, j, ip, tau
  integer :: kr, kpkr
  real    :: triad_weight(isd:ied,jsd:jed)
  real    :: tensor_11(isd:ied,jsd:jed,0:1,0:1)
  real    :: tensor_13(isd:ied,jsd:jed,0:1,0:1)
  real    :: sumz(isd:ied,jsd:jed,0:1)
  real    :: taperA, taperB
  real    :: slope, absslope, taper_slope, gm_taper_slope
  real    :: depth_ratio
  real    :: drhodx, drhodz 

  tau = Time%tau

  ! initialize arrays to zero 
  tensor_11(:,:,:,:)           = 0.0
  tensor_13(:,:,:,:)           = 0.0
  grav_agm_dz_sx_drhodx(:,:,k) = 0.0
  slopex_drhodx(:,:,k)         = 0.0
  triad_weight(:,:)            = 0.0

  ! tracer-independent part of the calculation 
  do kr=0,1
     kpkr = min(k+kr,nk)
     do ip=0,1 
        do j=jsc,jec
           do i=isc-1,iec

              drhodz   = drhodzh(i+ip,j,k,kr)
              drhodx   = Grd%tmask(i+ip,j,kpkr)                            &
                        *( drhodT(i+ip,j,k)*dTdx(index_temp)%field(i,j,k)  &
                          +drhodS(i+ip,j,k)*dSdx%field(i,j,k))
              slope    = -drhodx/drhodz
              absslope = abs(slope)

              ! taper for steep slope regions 
              if(absslope > smax) then 
                  taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                  taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
              else 
                  taperA = 1.0
              endif

              ! taper for grid depths shallower than depth_blayer_base
              if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                  depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                  taperB      = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
              else 
                  taperB      = 1.0
              endif

              ! taper times slope for use with neutral diffusion
              taper_slope  = taperA*taperB*slope

              ! taper times slope for use with GM skewsion
              if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then      
                  gm_taper_slope = (Thickness%depth_zt(i,j,k)/depth_blayer_base(i,j)) &
                                   *slope_blayer_base(i,j)*sign(1.0,slope) 
              else 
                  gm_taper_slope = taper_slope
              endif

              ! for diagnosing slope dot grad rho
              triad_weight(i,j)    = triad_weight(i,j)    + Grd%tmask(i+ip,j,kpkr)
              slopex_drhodx(i,j,k) = slopex_drhodx(i,j,k) + gm_taper_slope*drhodx

              ! fill tensor components 
              tensor_11(i,j,ip,kr) = aredi_array(i,j,k)
              tensor_13(i,j,ip,kr) = aredi_array(i,j,k)*taper_slope-gm_skew*agm_array(i,j,k)*gm_taper_slope

           enddo
        enddo
     enddo
  enddo

  ! tracer-dependent part of the calculation
  do nn=1,num_prog_tracers
     sumz(:,:,:) = 0.0
     do kr=0,1
        do ip=0,1
           do j=jsc,jec
              do i=isc-1,iec
                sumz(i,j,kr) = sumz(i,j,kr) + dtwedyt(i,j,ip)*Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k) &
                *(tensor_11(i,j,ip,kr)*dTdx(nn)%field(i,j,k) + tensor_13(i,j,ip,kr)*dTdz(nn)%field(i+ip,j,k-1+kr)) &
                * min(delqc(i,j,k,kr),delqc(i+1,j,k,kr))
              enddo
           enddo
        enddo
     enddo
     flux_x(nn)%field(COMPXL,k) = Grd%dxter(COMPXL)*(sumz(COMPXL,0)+sumz(COMPXL,1))
  enddo

  ! apply some masks 
  if(tmask_neutral_on) then
     do nn=1,num_prog_tracers
        do j=jsc,jec
           do i=isc-1,iec
              if(k==Grd%kmt(i,j)) then
                flux_x(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdx(nn)%field(i,j,k)*Grd%dyte(i,j)* &
                                          min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i+1,j,k,tau))
              endif
           enddo
        enddo
     enddo
     if(k==1) then
         do nn=1,num_prog_tracers
            flux_x(nn)%field(:,:,k) = aredi_array(:,:,k)*dTdx(nn)%field(:,:,k)*Grd%dyte(:,:) &
                                      *FMX(Thickness%rho_dzt(:,:,k,tau))
         enddo
     endif
  endif
  if(tmask_sigma_on) then
     do nn=1,num_prog_tracers
        do j=jsc,jec
           do i=isc-1,iec
              if(k==Grd%kmt(i,j)) flux_x(nn)%field(i,j,k) = flux_x(nn)%field(i,j,k)*(1.0-tmask_sigma(i,j))
           enddo
        enddo
     enddo
 endif

 if(neutral_physics_limit) then 
     do nn=1,num_prog_tracers
        do j=jsc,jec
           do i=isc-1,iec
              if(T_prog(nn)%tmask_limit(i,j,k)==1.0) then 
                  flux_x(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdx(nn)%field(i,j,k)*Grd%dyte(i,j) &
                                            *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i+1,j,k,tau))
              endif
           enddo
        enddo
     enddo
 endif


 ! for diagnosing slopex_drhodx and grav_agm_dz_sx_drhodx 
 do j=jsc,jec
    do i=isc,iec
       if(triad_weight(i,j) > 0.0) then 
           triad_weight(i,j)            = 1.0/(epsln + triad_weight(i,j))
           slopex_drhodx(i,j,k)         = triad_weight(i,j)*slopex_drhodx(i,j,k)
           grav_agm_dz_sx_drhodx(i,j,k) = slopex_drhodx(i,j,k) &
                                          *grav*agm_array(i,j,k)*Thickness%dzt(i,j,k)
       else 
           slopex_drhodx(i,j,k)         = 0.0
           grav_agm_dz_sx_drhodx(i,j,k) = 0.0
       endif
    enddo
 enddo

 if(k==nk) then 
    call diagnose_3d(Time, Grd, id_grav_agm_dz_sx_drhodx, grav_agm_dz_sx_drhodx(:,:,:))
    call diagnose_3d(Time, Grd, id_slopex_drhodx, slopex_drhodx(:,:,:))
 endif


end subroutine fx_flux
! </SUBROUTINE> NAME="fx_flux"


!#######################################################################
! <SUBROUTINE NAME="fx_flux_diag">
!
! <DESCRIPTION>
! Subroutine computes the i-directed neutral physics tracer flux component
! for Redi separately from GM, in order to diagnose GM and Redi 
! fluxes independent of one another. 
!
! Compute this component for all tracers at level k.
!
! fx has physical dimensions (area*diffusivity*density*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fx_flux_diag(Time, Thickness, T_prog, k)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer,                      intent(in) :: k

  integer :: nn, i, j, ip, tau
  integer :: kr, kpkr
  real    :: tensor_11(isd:ied,jsd:jed,0:1,0:1)
  real    :: tensor_13_redi(isd:ied,jsd:jed,0:1,0:1)
  real    :: sumz(isd:ied,jsd:jed,0:1)
  real    :: taperA, taperB
  real    :: slope, absslope, taper_slope
  real    :: depth_ratio
  real    :: drhodx, drhodz 


  tau = Time%tau

  ! initialize arrays to zero 
  tensor_13_redi(:,:,:,:) = 0.0


  ! tracer-independent part of the calculation 
  do kr=0,1
     kpkr = min(k+kr,nk)
     do ip=0,1 
        do j=jsc,jec
           do i=isc-1,iec

              drhodz   = drhodzh(i+ip,j,k,kr)
              drhodx   = Grd%tmask(i+ip,j,kpkr)                            &
                        *( drhodT(i+ip,j,k)*dTdx(index_temp)%field(i,j,k)  &
                          +drhodS(i+ip,j,k)*dSdx%field(i,j,k))
              slope    = -drhodx/drhodz
              absslope = abs(slope)

              ! taper for steep slope regions 
              if(absslope > smax) then 
                  taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                  taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
              else 
                  taperA = 1.0
              endif

              ! taper for grid depths shallower than depth_blayer_base
              if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                  depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                  taperB      = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
              else 
                  taperB      = 1.0
              endif

              ! taper times slope for use with neutral diffusion
              taper_slope  = taperA*taperB*slope

              ! fill tensor components 
              tensor_11(i,j,ip,kr)      = aredi_array(i,j,k)
              tensor_13_redi(i,j,ip,kr) = aredi_array(i,j,k)*taper_slope

           enddo
        enddo
     enddo
  enddo

  ! tracer dependent portion of calculation 
  do nn=1,num_prog_tracers
     sumz(:,:,:) = 0.0
     do kr=0,1
        do ip=0,1
           do j=jsc,jec
              do i=isc-1,iec
                 sumz(i,j,kr) = sumz(i,j,kr) + dtwedyt(i,j,ip)*Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k) &
                      *(tensor_11(i,j,ip,kr)*dTdx(nn)%field(i,j,k) + tensor_13_redi(i,j,ip,kr)*dTdz(nn)%field(i+ip,j,k-1+kr)) &
                      * min(delqc(i,j,k,kr),delqc(i+1,j,k,kr))
              enddo
           enddo
        enddo
     enddo
     flux_x_redi(nn)%field(COMPXL,k) = Grd%dxter(COMPXL)*(sumz(COMPXL,0)+sumz(COMPXL,1))
  enddo
 
  ! apply some masks 

  if(tmask_neutral_on) then
      do nn=1,num_prog_tracers
         do j=jsc,jec
            do i=isc-1,iec
               if(k==Grd%kmt(i,j)) then
                   flux_x_redi(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdx(nn)%field(i,j,k)*Grd%dyte(i,j)* &
                        min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i+1,j,k,tau))
               endif
            enddo
         enddo
      enddo
      if(k==1) then
          do nn=1,num_prog_tracers
             flux_x_redi(nn)%field(:,:,k) = aredi_array(:,:,k)*dTdx(nn)%field(:,:,k)*Grd%dyte(:,:) &
                  *FMX(Thickness%rho_dzt(:,:,k,tau))
          enddo
      endif
  endif
  if(tmask_sigma_on) then
      do nn=1,num_prog_tracers
         do j=jsc,jec
            do i=isc-1,iec
               if(k==Grd%kmt(i,j)) then 
                   flux_x_redi(nn)%field(i,j,k) = flux_x_redi(nn)%field(i,j,k)*(1.0-tmask_sigma(i,j))
               endif
            enddo
         enddo
      enddo
  endif
  if(neutral_physics_limit) then 
      do nn=1,num_prog_tracers
         do j=jsc,jec
            do i=isc-1,iec
               if(T_prog(nn)%tmask_limit(i,j,k)==1.0) then 
                   flux_x_redi(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdx(nn)%field(i,j,k)*Grd%dyte(i,j) &
                        *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i+1,j,k,tau))
               endif
            enddo
         enddo
      enddo
  endif


end subroutine fx_flux_diag
! </SUBROUTINE> NAME="fx_flux_diag"



!#######################################################################
! <SUBROUTINE NAME="fy_flux">
!
! <DESCRIPTION>
! Subroutine computes the j-directed neutral physics tracer flux component.
! Compute this component for all tracers at level k.
!
! fy has physical dimensions (area*diffusivity*density*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fy_flux(Time, Thickness, T_prog, k)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer,                      intent(in) :: k

  integer :: nn, i, j, jq, tau
  integer :: kr, kpkr
  real :: triad_weight(isd:ied,jsd:jed)
  real :: tensor_22(isd:ied,jsd:jed,0:1,0:1)
  real :: tensor_23(isd:ied,jsd:jed,0:1,0:1)
  real :: sumz(isd:ied,jsd:jed,0:1)
  real :: taperA, taperB
  real :: slope, absslope, taper_slope, gm_taper_slope
  real :: depth_ratio
  real :: drhody, drhodz 

  tau = Time%tau 

  ! initialize arrays to zero 
  tensor_22(:,:,:,:)           = 0.0
  tensor_23(:,:,:,:)           = 0.0
  grav_agm_dz_sy_drhody(:,:,k) = 0.0
  slopey_drhody(:,:,k)         = 0.0
  triad_weight(:,:)            = 0.0

  ! tracer-independent part of the calculation 
  do kr=0,1
     kpkr = min(k+kr,nk)
     do jq=0,1  
       do j=jsc-1,jec
          do i=isc,iec
 
              drhodz   = drhodzh(i,j+jq,k,kr) 
              drhody   = Grd%tmask(i,j+jq,kpkr)                            &
                        *( drhodT(i,j+jq,k)*dTdy(index_temp)%field(i,j,k)  &
                          +drhodS(i,j+jq,k)*dSdy%field(i,j,k)) 
              slope    = -drhody/drhodz
              absslope = abs(slope)  

              ! taper for steep slope regions 
              if(absslope > smax) then 
                  taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                  taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
              else 
                  taperA = 1.0
              endif

              ! taper for grid depths shallower than depth_blayer_base
              if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                  depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                  taperB      = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
              else 
                  taperB      = 1.0
              endif

              ! taper times slope for use with neutral diffusion
              taper_slope  = taperA*taperB*slope

              ! taper times slope for use with GM skewsion
              if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then      
                  gm_taper_slope = (Thickness%depth_zt(i,j,k)/depth_blayer_base(i,j)) &
                                   *slope_blayer_base(i,j)*sign(1.0,slope) 
              else 
                  gm_taper_slope = taper_slope
              endif

              ! for diagnosing slope dot grad rho
              triad_weight(i,j)    = triad_weight(i,j)    + Grd%tmask(i,j+jq,kpkr) 
              slopey_drhody(i,j,k) = slopey_drhody(i,j,k) + gm_taper_slope*drhody

              ! fill tensor components 
              tensor_22(i,j,jq,kr) = aredi_array(i,j,k)
              tensor_23(i,j,jq,kr) = aredi_array(i,j,k)*taper_slope-gm_skew*agm_array(i,j,k)*gm_taper_slope

           enddo
        enddo
     enddo
  enddo

  ! tracer-dependent part of the calculation
  do nn=1,num_prog_tracers
     sumz(:,:,:) = 0.0
     do kr=0,1
        do jq=0,1
           do j=jsc-1,jec
              do i=isc,iec
                 sumz(i,j,kr) = sumz(i,j,kr) + dxtdtsn(i,j,jq)*Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k) &
                 *(tensor_22(i,j,jq,kr)*dTdy(nn)%field(i,j,k) + tensor_23(i,j,jq,kr)*dTdz(nn)%field(i,j+jq,k-1+kr)) &
                 * min(delqc(i,j,k,kr),delqc(i,j+1,k,kr))
              enddo
           enddo
        enddo
     enddo
     flux_y(nn)%field(COMPYL,k) = Grd%dytnr(COMPYL)*(sumz(COMPYL,0)+sumz(COMPYL,1))
  enddo


  ! apply some masks 
  if(tmask_neutral_on) then
     do nn=1,num_prog_tracers
        do j=jsc-1,jec
           do i=isc,iec
              if(k==Grd%kmt(i,j)) then
                flux_y(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdy(nn)%field(i,j,k)*Grd%dxtn(i,j) &
                                          *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i,j+1,k,tau))
              endif
           enddo
        enddo
     enddo
     if(k==1) then
         do nn=1,num_prog_tracers
            flux_y(nn)%field(:,:,k) = &
            aredi_array(:,:,k)*dTdy(nn)%field(:,:,k)*Grd%dxtn(:,:)*FMY(Thickness%rho_dzt(:,:,k,tau))
         enddo
     endif
  endif
  if(tmask_sigma_on) then
      do nn=1,num_prog_tracers
         do j=jsc-1,jec
            do i=isc,iec
               if(k==Grd%kmt(i,j)) flux_y(nn)%field(i,j,k) = flux_y(nn)%field(i,j,k)*(1.0-tmask_sigma(i,j))
            enddo
         enddo
      enddo
  endif

  if(neutral_physics_limit) then 
      do nn=1,num_prog_tracers
         do j=jsc-1,jec
            do i=isc,iec
               if(T_prog(nn)%tmask_limit(i,j,k)==1.0) then 
                   flux_y(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdy(nn)%field(i,j,k)*Grd%dxtn(i,j) &
                                             *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i,j+1,k,tau))
               endif
            enddo
         enddo
      enddo
  endif

 ! for diagnosing slopey_drhody and grav_agm_dz_sy_drhody
 do j=jsc,jec
    do i=isc,iec
       if(triad_weight(i,j) > 0.0) then 
           triad_weight(i,j)    = 1.0/(epsln + triad_weight(i,j))
           slopey_drhody(i,j,k) = triad_weight(i,j)*slopey_drhody(i,j,k)
           grav_agm_dz_sy_drhody(i,j,k) = slopey_drhody(i,j,k) &
                                          *grav*agm_array(i,j,k)*Thickness%dzt(i,j,k)
       else 
           slopey_drhody(i,j,k)         = 0.0
           grav_agm_dz_sy_drhody(i,j,k) = 0.0
       endif
    enddo
 enddo

 if(k==nk) then 
    call diagnose_3d(Time, Grd, id_grav_agm_dz_sy_drhody, grav_agm_dz_sy_drhody(:,:,:))
    call diagnose_3d(Time, Grd, id_slopey_drhody, slopey_drhody(:,:,:))
    if(id_gm_eddy_ke_source > 0) then 
       call diagnose_3d(Time, Grd, id_gm_eddy_ke_source, grav_agm_dz_sx_drhodx(:,:,:) &
            +grav_agm_dz_sy_drhody(:,:,:))
    endif
 endif


end subroutine fy_flux
! </SUBROUTINE> NAME="fy_flux"



!#######################################################################
! <SUBROUTINE NAME="fy_flux_diag">
!
! <DESCRIPTION>
! Subroutine computes the j-directed neutral physics tracer flux component
! for Redi separately, in order to diagnose GM and Redi contributions
! independent of one another. 
!
! Compute this component for all tracers at level k.
!
! fy has physical dimensions (area*diffusivity*density*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fy_flux_diag(Time, Thickness, T_prog, k)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer,                      intent(in) :: k

  integer :: nn, i, j, jq, tau
  integer :: kr, kpkr
  real :: tensor_22(isd:ied,jsd:jed,0:1,0:1)
  real :: tensor_23_redi(isd:ied,jsd:jed,0:1,0:1)
  real :: sumz(isd:ied,jsd:jed,0:1)
  real :: taperA, taperB
  real :: slope, absslope, taper_slope
  real :: depth_ratio
  real :: drhody, drhodz 

  tau = Time%tau 

  ! initialize arrays to zero 
  tensor_22(:,:,:,:)       = 0.0
  tensor_23_redi(:,:,:,:)  = 0.0

  ! tracer-independent part of the calculation 
  do kr=0,1
     kpkr = min(k+kr,nk)
     do jq=0,1  
       do j=jsc-1,jec
          do i=isc,iec
 
              drhodz   = drhodzh(i,j+jq,k,kr) 
              drhody   = Grd%tmask(i,j+jq,kpkr)                            &
                        *( drhodT(i,j+jq,k)*dTdy(index_temp)%field(i,j,k)  &
                          +drhodS(i,j+jq,k)*dSdy%field(i,j,k)) 
              slope    = -drhody/drhodz
              absslope = abs(slope)  

              ! taper for steep slope regions 
              if(absslope > smax) then 
                  taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                  taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
              else 
                  taperA = 1.0
              endif
              ! taper for grid depths shallower than depth_blayer_base
              if(depth_blayer_base(i,j) >= Thickness%depth_zt(i,j,k)) then                                           
                  depth_ratio = Thickness%depth_zt(i,j,k)/(epsln+depth_blayer_base(i,j))
                  taperB      = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
              else 
                  taperB          = 1.0
              endif

              ! taper times slope for use with neutral diffusion
              taper_slope  = taperA*taperB*slope

              ! fill tensor components 
              tensor_22(i,j,jq,kr)      = aredi_array(i,j,k)
              tensor_23_redi(i,j,jq,kr) = aredi_array(i,j,k)*taper_slope

           enddo
        enddo
     enddo
  enddo


  ! tracer dependent portion of calculation  
  do nn=1,num_prog_tracers
     sumz(:,:,:) = 0.0
     do kr=0,1
        do jq=0,1
           do j=jsc-1,jec
              do i=isc,iec
                 sumz(i,j,kr) = sumz(i,j,kr) + dxtdtsn(i,j,jq)*Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)                            &
                      *(tensor_22(i,j,jq,kr)*dTdy(nn)%field(i,j,k) + tensor_23_redi(i,j,jq,kr)*dTdz(nn)%field(i,j+jq,k-1+kr)) &
                      * min(delqc(i,j,k,kr),delqc(i,j+1,k,kr))
              enddo
           enddo
        enddo
     enddo
     flux_y_redi(nn)%field(COMPYL,k) = Grd%dytnr(COMPYL)*(sumz(COMPYL,0)+sumz(COMPYL,1))
  enddo


  ! apply some masks 
  if(tmask_neutral_on) then
      do nn=1,num_prog_tracers
         do j=jsc-1,jec
            do i=isc,iec
               if(k==Grd%kmt(i,j)) then
                   flux_y_redi(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdy(nn)%field(i,j,k)*Grd%dxtn(i,j) &
                        *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i,j+1,k,tau))
               endif
            enddo
         enddo
      enddo
      if(k==1) then
          do nn=1,num_prog_tracers
             flux_y_redi(nn)%field(:,:,k) = &
                  aredi_array(:,:,k)*dTdy(nn)%field(:,:,k)*Grd%dxtn(:,:)*FMY(Thickness%rho_dzt(:,:,k,tau))
          enddo
      endif
  endif
  if(tmask_sigma_on) then
      do nn=1,num_prog_tracers
         do j=jsc-1,jec
            do i=isc,iec
               if(k==Grd%kmt(i,j)) then 
                   flux_y_redi(nn)%field(i,j,k) = flux_y_redi(nn)%field(i,j,k)*(1.0-tmask_sigma(i,j))
               endif
            enddo
         enddo
      enddo
  endif
  if(neutral_physics_limit) then 
      do nn=1,num_prog_tracers
         do j=jsc-1,jec
            do i=isc,iec
               if(T_prog(nn)%tmask_limit(i,j,k)==1.0) then 
                   flux_y_redi(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdy(nn)%field(i,j,k)*Grd%dxtn(i,j) &
                        *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i,j+1,k,tau))
               endif
            enddo
         enddo
      enddo
  endif

end subroutine fy_flux_diag
! </SUBROUTINE> NAME="fy_flux_diag"


!#######################################################################
! <SUBROUTINE NAME="fz_flux">
!
! <DESCRIPTION>
! Subroutine computes the vertical neutral physics tracer flux component.
! Compute this component for all tracers at level k.
! Surface and bottom boundary condition fz(k=0)=fz(k=kmt(i,j))=0
!
! fz has physical dimensions (density*diffusivity*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fz_flux(T_prog, k)

  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer, intent(in) :: k

  integer :: nn, i, j, ip, jq, kr
  real :: sumx_0, sumx_1, sumy_0, sumy_1
  real :: temparray31(isc:iec,jsc:jec,0:1,0:1)
  real :: temparray32(isc:iec,jsc:jec,0:1,0:1)
 
  if(tmask_neutral_on .and. k==1) then
     do nn = 1, num_prog_tracers
       fz2(nn)%field(:,:)      = 0.0 
      enddo
     return 
  endif

  if(k==nk) then 

     do nn = 1, num_prog_tracers
        fz2(nn)%field(COMP) = 0.0
     enddo
     return  

  elseif(k < nk) then  

      ! tracer-independent part of the calculation 
      do kr=0,1
         do ip=0,1
            do j=jsc,jec
               do i=isc,iec
                  temparray31(i,j,ip,kr) = tensor_31(i,j,k,ip,kr)*dtew(i,j,ip) &
                       *min(delqc(i-1+ip,j,k+kr,1-kr),delqc(i+ip,j,k+kr,1-kr))
               enddo
            enddo
         enddo
         do jq=0,1
            do j=jsc,jec
               do i=isc,iec
                  temparray32(i,j,jq,kr) = tensor_32(i,j,k,jq,kr)*dtns(i,j,jq) &
                       *min(delqc(i,j-1+jq,k+kr,1-kr),delqc(i,j+jq,k+kr,1-kr))  
               enddo
            enddo
         enddo
      enddo

      ! tracer-dependent part of the calculation  
      do nn=1,num_prog_tracers
         do j=jsc,jec
            do i=isc,iec

               ! compute time explicit portion of the vertical flux
               sumx_0 =  temparray31(i,j,0,0)*dTdx(nn)%field(i-1,j,k) &
                      +  temparray31(i,j,0,1)*dTdx(nn)%field(i-1,j,k+1)
               sumx_1 =  temparray31(i,j,1,0)*dTdx(nn)%field(i,j,k) &
                      +  temparray31(i,j,1,1)*dTdx(nn)%field(i,j,k+1)
               sumy_0 =  temparray32(i,j,0,0)*dTdy(nn)%field(i,j-1,k) &
                      +  temparray32(i,j,0,1)*dTdy(nn)%field(i,j-1,k+1)
               sumy_1 =  temparray32(i,j,1,0)*dTdy(nn)%field(i,j,k) &
                      +  temparray32(i,j,1,1)*dTdy(nn)%field(i,j,k+1)
               fz2(nn)%field(i,j) =   Grd%tmask(i,j,k+1) &
                    *( Grd%dxtr(i,j)*(sumx_0+sumx_1) &
                      +Grd%dytr(i,j)*(sumy_0+sumy_1)) &
                    *dzwtr(i,j,k) &
                    + K33_explicit(i,j,k)*dTdz(nn)%field(i,j,k)

            enddo
         enddo
      enddo

      ! apply some masks       
      if(tmask_neutral_on) then
          do nn=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(k==(Grd%kmt(i,j)-1))  then 
                       fz2(nn)%field(i,j) = 0.0
                   endif  
                enddo
             enddo
          enddo
      endif
      if(tmask_sigma_on) then
          do nn=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(tmask_sigma(i,j) > 0.0 .and. k==(Grd%kmt(i,j)-1) ) then
                       fz2(nn)%field(i,j) = fz2(nn)%field(i,j)*(1.0-tmask_sigma(i,j))
                    endif
                enddo
             enddo
          enddo
      endif
      if(neutral_physics_limit) then 
          do nn=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(T_prog(nn)%tmask_limit(i,j,k)==1.0) then 
                        fz2(nn)%field(i,j) = 0.0  
                   endif 
                enddo
             enddo
          enddo
      endif


  endif  !if-test for k-level 

end subroutine fz_flux
! </SUBROUTINE> NAME="fz_flux"


!#######################################################################
! <SUBROUTINE NAME="fz_flux_diag">
!
! <DESCRIPTION>
! For diagnosing the GM and Redi pieces separately. 
! Compute this component for all tracers at level k.
! Surface and bottom boundary condition fz(k=0)=fz(k=kmt(i,j))=0
!
! fz has physical dimensions (density*diffusivity*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fz_flux_diag(T_prog, k)

  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer, intent(in) :: k

  integer :: nn, i, j, ip, jq, kr
  real :: sumx_0, sumx_1, sumy_0, sumy_1
  real :: temparray31_redi(isc:iec,jsc:jec,0:1,0:1)
  real :: temparray32_redi(isc:iec,jsc:jec,0:1,0:1)

 
  if(tmask_neutral_on .and. k==1) then
      do nn=1,num_prog_tracers
         fz2_redi(nn)%field(:,:) = 0.0 
      enddo
      return 
  endif

  if(k==nk) then 

      do nn=1,num_prog_tracers
         fz2_redi(nn)%field(COMP) = 0.0
      enddo
      return  

  elseif(k < nk) then  

      ! tracer-independent part of the calculation 
      do kr=0,1
         do ip=0,1
            do j=jsc,jec
               do i=isc,iec
                  temparray31_redi(i,j,ip,kr) = tensor_31_redi(i,j,k,ip,kr)*dtew(i,j,ip) &
                       *min(delqc(i-1+ip,j,k+kr,1-kr),delqc(i+ip,j,k+kr,1-kr))
               enddo
            enddo
         enddo
         do jq=0,1
            do j=jsc,jec
               do i=isc,iec
                  temparray32_redi(i,j,jq,kr) = tensor_32_redi(i,j,k,jq,kr)*dtns(i,j,jq) &
                       *min(delqc(i,j-1+jq,k+kr,1-kr),delqc(i,j+jq,k+kr,1-kr))  
               enddo
            enddo
         enddo
      enddo

      ! tracer-dependent part of the calculation  
      do nn=1,num_prog_tracers
         do j=jsc,jec
            do i=isc,iec

               ! compute time explicit portion of the vertical flux
               sumx_0 =  temparray31_redi(i,j,0,0)*dTdx(nn)%field(i-1,j,k) &
                      +  temparray31_redi(i,j,0,1)*dTdx(nn)%field(i-1,j,k+1)
               sumx_1 =  temparray31_redi(i,j,1,0)*dTdx(nn)%field(i,j,k) &
                      +  temparray31_redi(i,j,1,1)*dTdx(nn)%field(i,j,k+1)
               sumy_0 =  temparray32_redi(i,j,0,0)*dTdy(nn)%field(i,j-1,k) &
                      +  temparray32_redi(i,j,0,1)*dTdy(nn)%field(i,j-1,k+1)
               sumy_1 =  temparray32_redi(i,j,1,0)*dTdy(nn)%field(i,j,k) &
                      +  temparray32_redi(i,j,1,1)*dTdy(nn)%field(i,j,k+1)
               fz2_redi(nn)%field(i,j) =   Grd%tmask(i,j,k+1) &
                    *( Grd%dxtr(i,j)*(sumx_0+sumx_1)          &
                      +Grd%dytr(i,j)*(sumy_0+sumy_1))         &
                    *dzwtr(i,j,k) &
                    + K33_explicit(i,j,k)*dTdz(nn)%field(i,j,k)

            enddo
         enddo
      enddo


      if(tmask_neutral_on) then
          do nn=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(k==(Grd%kmt(i,j)-1))  then 
                       fz2_redi(nn)%field(i,j) = 0.0
                   endif
                enddo
             enddo
          enddo
      endif
      if(tmask_sigma_on) then
          do nn=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(tmask_sigma(i,j) > 0.0 .and. k==(Grd%kmt(i,j)-1) ) then
                       fz2_redi(nn)%field(i,j) = fz2_redi(nn)%field(i,j)*(1.0-tmask_sigma(i,j))
                   endif
                enddo
             enddo
          enddo
      endif
      if(neutral_physics_limit) then 
          do nn=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(T_prog(nn)%tmask_limit(i,j,k)==1.0) then 
                       fz2_redi(nn)%field(i,j) = 0.0  
                   endif
                enddo
             enddo
          enddo
      endif


  endif  !if-test for k-level 


end subroutine fz_flux_diag
! </SUBROUTINE> NAME="fz_flux_diag"



!#######################################################################
! <SUBROUTINE NAME="nphysics_diagnostics">
! <DESCRIPTION>
!  Send some diagnostics to diagnostics manager. 
! </DESCRIPTION>
subroutine nphysics_diagnostics(Time, T_prog, Dens)

  type(ocean_time_type),        intent(in)  :: Time
  type(ocean_prog_tracer_type), intent(in)  :: T_prog(:)
  type(ocean_density_type),     intent(in)  :: Dens

  integer :: k, nn
  integer :: tau
  real, dimension(isd:ied,jsd:jed) :: tmp_flux

  tau = Time%tau


  do nn=1,num_prog_tracers
     if(id_neutral_physics(nn) > 0) then 
        call diagnose_3d(Time, Grd, id_neutral_physics(nn), T_prog(nn)%wrk1(:,:,:)*T_prog(nn)%conversion)
     endif

     ! send fluxes to diag_manager 
     ! minus sign is due to a MOM-convention for physics fluxes  
     if(id_flux_x(nn) > 0) then 
        call diagnose_3d(Time, Grd, id_flux_x(nn), -1.0*T_prog(nn)%conversion*flux_x(nn)%field(:,:,:))
     endif
     if(id_flux_y(nn) > 0) then 
        call diagnose_3d(Time, Grd, id_flux_y(nn), -1.0*T_prog(nn)%conversion*flux_y(nn)%field(:,:,:))
     endif
     if(id_flux_x_int_z(nn) > 0) then 
        tmp_flux = 0.0
        do k=1,nk
            tmp_flux(COMP) = tmp_flux(COMP) + flux_x(nn)%field(COMP,k)
        enddo        
        call diagnose_2d(Time, Grd, id_flux_x_int_z(nn), -1.0*T_prog(nn)%conversion*tmp_flux(:,:))
     endif
     if(id_flux_y_int_z(nn) > 0) then 
        tmp_flux = 0.0
        do k=1,nk
            tmp_flux(COMP) = tmp_flux(COMP) + flux_y(nn)%field(COMP,k)
        enddo        
        call diagnose_2d(Time, Grd, id_flux_y_int_z(nn), -1.0*T_prog(nn)%conversion*tmp_flux(:,:))
     endif    
  enddo   ! enddo for nn=1,num_prog_tracers

 
  if(diagnose_gm_redi) then 

      do nn=1,num_prog_tracers

         if(id_neutral_physics_ndiffuse(nn) > 0) then 
            call diagnose_3d(Time, Grd, id_neutral_physics_ndiffuse(nn),&
                  tendency_redi(nn)%field(:,:,:)*T_prog(nn)%conversion)
         endif
         if(id_flux_x_ndiffuse(nn) > 0) then 
            call diagnose_3d(Time, Grd, id_flux_x_ndiffuse(nn),&
                  -1.0*T_prog(nn)%conversion*flux_x_redi(nn)%field(:,:,:))
         endif
         if(id_flux_y_ndiffuse(nn) > 0) then 
            call diagnose_3d(Time, Grd, id_flux_y_ndiffuse(nn),&
                  -1.0*T_prog(nn)%conversion*flux_y_redi(nn)%field(:,:,:))
         endif
         if(id_flux_x_ndiffuse_int_z(nn) > 0) then 
             tmp_flux = 0.0
             do k=1,nk
                tmp_flux(COMP) = tmp_flux(COMP) + flux_x_redi(nn)%field(COMP,k)
             enddo
            call diagnose_2d(Time, Grd, id_flux_x_ndiffuse_int_z(nn), -1.0*T_prog(nn)%conversion*tmp_flux(:,:))
         endif
         if(id_flux_y_ndiffuse_int_z(nn) > 0) then 
             tmp_flux = 0.0
             do k=1,nk
                tmp_flux(COMP) = tmp_flux(COMP) + flux_y_redi(nn)%field(COMP,k)
             enddo
            call diagnose_2d(Time, Grd, id_flux_y_ndiffuse_int_z(nn), -1.0*T_prog(nn)%conversion*tmp_flux(:,:))
         endif

         if(id_neutral_physics_gm(nn) > 0) then 
             wrk1(COMP,:) = T_prog(nn)%wrk1(COMP,:) - tendency_redi(nn)%field(COMP,:)
             call diagnose_3d(Time, Grd, id_neutral_physics_gm(nn), &
                  wrk1(:,:,:)*T_prog(nn)%conversion)
         endif

         if(id_flux_x_gm(nn) > 0) then 
             wrk1(COMP,:) = flux_x(nn)%field(COMP,:) - flux_x_redi(nn)%field(COMP,:)
             call diagnose_3d(Time, Grd, id_flux_x_gm(nn),          &
                  -1.0*T_prog(nn)%conversion*wrk1(:,:,:))
         endif

         if(id_flux_y_gm(nn) > 0) then 
             wrk1(COMP,:) = flux_y(nn)%field(COMP,:) - flux_y_redi(nn)%field(COMP,:)
             call diagnose_3d(Time, Grd, id_flux_y_gm(nn),          &
                  -1.0*T_prog(nn)%conversion*wrk1(:,:,:))
         endif

         if(id_flux_x_gm_int_z(nn) > 0) then 
             wrk1(COMP,:) = flux_x(nn)%field(COMP,:) - flux_x_redi(nn)%field(COMP,:)
             tmp_flux = 0.0
             do k=1,nk
                tmp_flux(COMP) = tmp_flux(COMP) + wrk1(COMP,k)
             enddo
             call diagnose_2d(Time, Grd, id_flux_x_gm_int_z(nn), -1.0*T_prog(nn)%conversion*tmp_flux(:,:))
         endif

         if(id_flux_y_gm_int_z(nn) > 0) then 
             wrk1(COMP,:) = flux_y(nn)%field(COMP,:) - flux_y_redi(nn)%field(COMP,:)
             tmp_flux = 0.0
             do k=1,nk
                tmp_flux(COMP) = tmp_flux(COMP) + wrk1(COMP,k)
             enddo
             call diagnose_2d(Time, Grd, id_flux_y_gm_int_z(nn), -1.0*T_prog(nn)%conversion*tmp_flux(:,:))
         endif
      enddo   ! enddo for nn=1,num_prog_tracers


      ! more diagnostic output that does not need tracer loop 

      if (id_k33_explicit > 0) then 
         call diagnose_3d(Time, Grd, id_k33_explicit, rho0r*K33_explicit(:,:,:))
      endif

      call watermass_diag(Time, T_prog, Dens,  &
      tendency_redi(index_temp)%field(:,:,:), tendency_redi(index_salt)%field(:,:,:))


  endif  ! endif for diagnose_gm_redi logical 


end subroutine nphysics_diagnostics
! </SUBROUTINE> NAME="nphysics_diagnostics"



!#######################################################################
! <SUBROUTINE NAME="neutral_chksums">
!
! <DESCRIPTION>
! Write some checksums.
! </DESCRIPTION>
!
subroutine neutral_chksums

  call write_chksum_2d('surf_turb_thick', surf_turb_thick(COMP)*Grd%tmask(COMP,1))
  call write_chksum_2d('surf_trans_thick', surf_trans_thick(COMP)*Grd%tmask(COMP,1))

end subroutine neutral_chksums
! </SUBROUTINE> NAME="neutral_chksums"


!#######################################################################
! <SUBROUTINE NAME="ocean_nphysicsB_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocean_nphysicsB_restart(time_stamp)
  character(len=*), intent(in), optional :: time_stamp

  if(.not. use_this_module) return
  call save_restart(NphysicsB_restart, time_stamp)

  call ocean_nphysics_util_restart(time_stamp) 

end subroutine ocean_nphysicsB_restart
! </SUBROUTINE> NAME="ocean_nphysicsB_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_nphysicsB_end">
!
! <DESCRIPTION>
! Write to restart.
! </DESCRIPTION>
!
subroutine ocean_nphysicsB_end(Time)

  type(ocean_time_type), intent(in) :: Time
   
  if(.not. use_this_module) return

  call ocean_nphysics_coeff_end(Time, agm_array, aredi_array, rossby_radius, rossby_radius_raw, bczone_radius)

  call write_chksum_header(FILENAME,&
    'ending neutral checksums', Time%model_time)
  call neutral_chksums

end subroutine ocean_nphysicsB_end
! </SUBROUTINE> NAME="ocean_nphysicsB_end"


end module ocean_nphysicsB_mod

! This code comes from GOLD/config_src/coupled_driver here to be shared.
! But, the interfaces need a little change to work properly with generic tracers.
! The lower bounds of arrays should be specified in the arguments otherwise it core with "out of bound" message.
! For this reason I names the module FMS_coupler_util to distinguish it from GOLD coupler_util
! 
module FMS_coupler_util

!   This code provides a couple of interfaces to allow more transparent and
! robust extraction of the various fields in the coupler types.
use mpp_mod,           only : mpp_error, FATAL, WARNING
use coupler_types_mod, only : coupler_2d_bc_type, ind_flux, ind_deltap, ind_kw
use coupler_types_mod, only : ind_alpha, ind_csurf, ind_sc_no

implicit none ; private

public :: extract_coupler_values, set_coupler_values

contains

subroutine extract_coupler_values(BC_struc, BC_index, BC_element, array_out, ilb, jlb, &
                                  is, ie, js, je, conversion)
  real, dimension(ilb:,jlb:),intent(out) :: array_out
  integer,                   intent(in)  :: ilb, jlb !nnz: I have to pass these otherwise out os bound array reference for array_out inside extract_coupler_values. Why? How come GOLD is OK? 
  type(coupler_2d_bc_type),  intent(in)  :: BC_struc
  integer,                   intent(in)  :: BC_index, BC_element
  integer,        optional,  intent(in)  :: is, ie, js, je
  real,           optional,  intent(in)  :: conversion
! Arguments: BC_struc - The type from which the data is being extracted.
!  (in)      BC_index - The boundary condition number being extracted.
!  (in)      BC_element - The element of the boundary condition being extracted.
!            This could be ind_csurf, ind_alpha, ind_sc_no, ind_flux, ind_deltap,
!            ind_kw or ind_deposition.
!  (out)     array_out - The array being filled with the input values.
!  (in, opt) is, ie, js, je - The i- and j- limits of array_out to be filled.
!            These must match the size of the corresponding value array or an
!            error message is issued.
!  (in, opt) conversion - A number that every element is multiplied by, to
!                         permit sign convention or unit conversion.

  real, pointer, dimension(:,:) :: Array_in
  real :: conv
  integer :: i, j, is0, ie0, js0, je0, i_offset, j_offset

  if ((BC_element /= ind_flux) .and. (BC_element /= ind_alpha) .and. &
      (BC_element /= ind_csurf) .and. (BC_element /= ind_sc_no) .and. &
      (BC_element /= ind_deltap) .and. (BC_element /= ind_kw)) then
    call mpp_error(FATAL,"extract_coupler_values: Unrecognized BC_element.")
  endif

  ! These error messages should be made more explicit.
!  if (.not.associated(BC_struc%bc(BC_index))) &
  if (.not.associated(BC_struc%bc)) &
    call mpp_error(FATAL,"extract_coupler_values: " // &
       "The requested boundary condition is not associated.")
!  if (.not.associated(BC_struc%bc(BC_index)%field(BC_element))) &
  if (.not.associated(BC_struc%bc(BC_index)%field)) &
    call mpp_error(FATAL,"extract_coupler_values: " // &
       "The requested boundary condition element is not associated.")
  if (.not.associated(BC_struc%bc(BC_index)%field(BC_element)%values)) &
    call mpp_error(FATAL,"extract_coupler_values: " // &
       "The requested boundary condition value array is not associated.")

  Array_in => BC_struc%bc(BC_index)%field(BC_element)%values
  
  if (present(is)) then ; is0 = is ; else ; is0 = LBOUND(array_out,1) ; endif
  if (present(ie)) then ; ie0 = ie ; else ; ie0 = UBOUND(array_out,1) ; endif
  if (present(js)) then ; js0 = js ; else ; js0 = LBOUND(array_out,2) ; endif
  if (present(je)) then ; je0 = je ; else ; je0 = UBOUND(array_out,2) ; endif

  conv = 1.0 ; if (present(conversion)) conv = conversion

  if (size(Array_in,1) /= ie0 - is0 + 1) &
    call mpp_error(FATAL,"extract_coupler_values: Mismatch in i-size " // &
                   "between BC array and output array or computational domain.")
  if (size(Array_in,2) /= je0 - js0 + 1) &
    call mpp_error(FATAL,"extract_coupler_values: Mismatch in i-size " // &
                   "between BC array and output array or computational domain.")
  i_offset = lbound(Array_in,1) - is0
  j_offset = lbound(Array_in,2) - js0
  do j=js0,je0 ; do i=is0,ie0
    array_out(i,j) = conv * Array_in(i+i_offset,j+j_offset)
  enddo ; enddo

end subroutine extract_coupler_values

subroutine set_coupler_values(array_in, BC_struc, BC_index, BC_element, ilb, jlb,&
                              is, ie, js, je, conversion)
  real, dimension(ilb:,jlb:), intent(in)  :: array_in
  integer,                  intent(in)    :: ilb, jlb !nnz: I have to pass these otherwise out of bound array reference for array_in. Why? How come GOLD is OK?   
  type(coupler_2d_bc_type), intent(inout) :: BC_struc
  integer,                  intent(in)    :: BC_index, BC_element
  integer,        optional, intent(in)    :: is, ie, js, je
  real,           optional, intent(in)    :: conversion
! Arguments: array_in - The array containing the values to load into the BC.
!  (out)     BC_struc - The type into which the data is being loaded.
!  (in)      BC_index - The boundary condition number being extracted.
!  (in)      BC_element - The element of the boundary condition being extracted.
!            This could be ind_csurf, ind_alpha, ind_sc_no, ind_flux, ind_deltap,
!            ind_kw or ind_deposition.
!  (in, opt) is, ie, js, je - The i- and j- limits of array_out to be filled.
!            These must match the size of the corresponding value array or an
!            error message is issued.
!  (in, opt) conversion - A number that every element is multiplied by, to
!                         permit sign convention or unit conversion.

  real, pointer, dimension(:,:) :: Array_out
  real :: conv
  integer :: i, j, is0, ie0, js0, je0, i_offset, j_offset

  if ((BC_element /= ind_flux) .and. (BC_element /= ind_alpha) .and. &
      (BC_element /= ind_csurf) .and. (BC_element /= ind_sc_no) .and. &
      (BC_element /= ind_deltap) .and. (BC_element /= ind_kw)) then
    call mpp_error(FATAL,"extract_coupler_values: Unrecognized BC_element.")
  endif

  ! These error messages should be made more explicit.
!  if (.not.associated(BC_struc%bc(BC_index))) &
  if (.not.associated(BC_struc%bc)) &
    call mpp_error(FATAL,"set_coupler_values: " // &
       "The requested boundary condition is not associated.")
!  if (.not.associated(BC_struc%bc(BC_index)%field(BC_element))) &
  if (.not.associated(BC_struc%bc(BC_index)%field)) &
    call mpp_error(FATAL,"set_coupler_values: " // &
       "The requested boundary condition element is not associated.")
  if (.not.associated(BC_struc%bc(BC_index)%field(BC_element)%values)) &
    call mpp_error(FATAL,"set_coupler_values: " // &
       "The requested boundary condition value array is not associated.")

  Array_out => BC_struc%bc(BC_index)%field(BC_element)%values
  
  if (present(is)) then ; is0 = is ; else ; is0 = LBOUND(array_in,1) ; endif
  if (present(ie)) then ; ie0 = ie ; else ; ie0 = UBOUND(array_in,1) ; endif
  if (present(js)) then ; js0 = js ; else ; js0 = LBOUND(array_in,2) ; endif
  if (present(je)) then ; je0 = je ; else ; je0 = UBOUND(array_in,2) ; endif

  conv = 1.0 ; if (present(conversion)) conv = conversion

  if (size(Array_out,1) /= ie0 - is0 + 1) &
    call mpp_error(FATAL,"extract_coupler_values: Mismatch in i-size " // &
                   "between BC array and input array or computational domain.")
  if (size(Array_out,2) /= je0 - js0 + 1) &
    call mpp_error(FATAL,"extract_coupler_values: Mismatch in i-size " // &
                   "between BC array and input array or computational domain.")
  i_offset = lbound(Array_out,1) - is0
  j_offset = lbound(Array_out,2) - js0
  do j=js0,je0 ; do i=is0,ie0
    Array_out(i+i_offset,j+j_offset) = conv * array_in(i,j)
  enddo ; enddo

end subroutine set_coupler_values

end module FMS_coupler_util

module axis_utils_mod
  !
  !<CONTACT EMAIL="Matthew.Harrison@noaa.gov">M.J. Harrison</CONTACT>
  !
  !<REVIEWER EMAIL="Bruce.Wyman@noaa.gov">Bruce Wyman</REVIEWER>
  !

  !<OVERVIEW>
  ! A set of utilities for manipulating axes and extracting axis
  ! attributes
  !</OVERVIEW>

  !<DESCRIPTION>
  !
  ! subroutine get_axis_cart(axis,cart) : Returns X,Y,Z or T cartesian attribute
  ! subroutine get_axis_bounds(axis,axis_bound,axes) : Return axis_bound either from an array of 
  !                                                    available axes, or defined based on axis mid-points
  ! function get_axis_modulo : Returns true if axis has the modulo attribute
  ! function get_axis_fold   : Returns is axis is folded at a boundary (non-standard meta-data)
  ! function lon_in_range    : Returns lon_strt <= longitude <= lon_strt+360
  ! subroutine tranlon       : Returns monotonic array of longitudes s.t., lon_strt <= lon(:) <= lon_strt+360.
  ! subroutine nearest_index : Return index of nearest point along axis
  !
  !</DESCRIPTION>
  !

  use mpp_io_mod, only: axistype, atttype, default_axis, default_att,         &
                        mpp_get_atts, mpp_get_axis_data, mpp_modify_meta,     &
                        mpp_get_att_name, mpp_get_att_type, mpp_get_att_char, &
                        mpp_get_att_length, mpp_get_axis_bounds
  use mpp_mod,    only: mpp_error, FATAL, stdout
  use fms_mod,    only: lowercase, string_array_index, fms_error_handler

  implicit none

# include <netcdf.inc>

  public get_axis_cart, get_axis_bounds, get_axis_modulo, get_axis_fold, lon_in_range, &
         tranlon, frac_index, nearest_index, interp_1d, get_axis_modulo_times

  private

  integer, parameter :: maxatts = 100
  real, parameter    :: epsln= 1.e-10
  real, parameter    :: fp5 = 0.5, f360 = 360.0
  character(len=256) :: version = '$Id$'
  character(len=256) :: tagname = '$Name$'   

  interface interp_1d
     module procedure interp_1d_1d
     module procedure interp_1d_2d
     module procedure interp_1d_3d
  end interface

contains


  subroutine get_axis_cart(axis, cart)      

    type(axistype), intent(in) :: axis
    character(len=1), intent(out) :: cart
    character(len=1) :: axis_cart
    character(len=16), dimension(2) :: lon_names, lat_names
    character(len=16), dimension(3) :: z_names
    character(len=16), dimension(2) :: t_names
    character(len=16), dimension(3) :: lon_units, lat_units
    character(len=8) , dimension(5) :: z_units
    character(len=3) , dimension(6) :: t_units
    character(len=32) :: name
    integer :: i,j

    lon_names = (/'lon','x  '/)
    lat_names = (/'lat','y  '/)
    z_names = (/'depth ','height','z     '/)
    t_names = (/'time','t   '/)
    lon_units = (/'degrees_e   ', 'degrees_east', 'degreese    '/)
    lat_units = (/'degrees_n    ', 'degrees_north', 'degreesn     '/)
    z_units = (/'cm    ','m     ','pa    ','hpa   ','meters'/)
    t_units = (/'sec', 'min','hou','day','mon','yea'/)

    call mpp_get_atts(axis,cartesian=axis_cart)
    cart = 'N'

    if ( lowercase(axis_cart) == 'x' ) cart = 'X'
    if ( lowercase(axis_cart) == 'y' ) cart = 'Y'
    if ( lowercase(axis_cart) == 'z' ) cart = 'Z'
    if ( lowercase(axis_cart) == 't' ) cart = 'T'

    if (cart /= 'X' .and. cart /= 'Y' .and. cart /= 'Z' .and. cart /= 'T') then
       call mpp_get_atts(axis,name=name)
       name = lowercase(name)
       do i=1,size(lon_names(:))
          if (trim(name(1:3)) == trim(lon_names(i))) cart = 'X'
       enddo
       do i=1,size(lat_names(:))
          if (trim(name(1:3)) == trim(lat_names(i))) cart = 'Y'
       enddo
       do i=1,size(z_names(:))
          if (trim(name) == trim(z_names(i))) cart = 'Z'
       enddo
       do i=1,size(t_names(:))
          if (trim(name) == t_names(i)) cart = 'T'
       enddo
    end if

    if (cart /= 'X' .and. cart /= 'Y' .and. cart /= 'Z' .and. cart /= 'T') then
       call mpp_get_atts(axis,units=name)
       name = lowercase(name)
       do i=1,size(lon_units(:))
          if (trim(name) == trim(lon_units(i))) cart = 'X'
       enddo
       do i=1,size(lat_units(:))
          if (trim(name) == trim(lat_units(i))) cart = 'Y'
       enddo
       do i=1,size(z_units(:))
          if (trim(name) == trim(z_units(i))) cart = 'Z'
       enddo
       do i=1,size(t_units(:))
          if (name(1:3) == trim(t_units(i))) cart = 'T'
       enddo
    end if

    return

  end subroutine get_axis_cart


  subroutine get_axis_bounds(axis,axis_bound,axes,bnd_name,err_msg)

    type(axistype), intent(in) :: axis
    type(axistype), intent(inout) :: axis_bound
    type(axistype), intent(in), dimension(:) :: axes
    character(len=*), intent(out), optional :: bnd_name, err_msg

    real, dimension(:), allocatable :: data, tmp

    integer :: i, len
    character(len=128) :: name, units
    character(len=256) :: longname
    character(len=1) :: cartesian
    logical :: bounds_found

    if(present(err_msg)) then
      err_msg = ''
    endif
    axis_bound = default_axis
    call mpp_get_atts(axis,units=units,longname=longname,&
            cartesian=cartesian, len=len)
    if(len .LE. 0) return
    allocate(data(len+1))

    bounds_found = mpp_get_axis_bounds(axis, data, name=name)
    longname = trim(longname)//' bounds'

    if(.not.bounds_found .and. len>1 ) then
       ! The following calculation can not be done for len=1
       call mpp_get_atts(axis,name=name)
       name = trim(name)//'_bounds'
       allocate(tmp(len))
       call mpp_get_axis_data(axis,tmp)
       do i=2,len
          data(i)= tmp(i-1)+fp5*(tmp(i)-tmp(i-1))
       enddo
       data(1)= tmp(1)- fp5*(tmp(2)-tmp(1))
       if (abs(data(1)) < epsln) data(1) = 0.0
       data(len+1)= tmp(len)+ fp5*(tmp(len)-tmp(len-1))         
       if (data(1) == 0.0) then
          if (abs(data(len+1)-360.) > epsln) data(len+1)=360.0
       endif
    endif
    if(bounds_found .OR. len>1) then
       call mpp_modify_meta(axis_bound,name=name,units=units,longname=&
                 longname,cartesian=cartesian,data=data)
    endif
    if(allocated(tmp)) deallocate(tmp)
    deallocate(data)

    return
  end subroutine get_axis_bounds

  function get_axis_modulo(axis)

    type(axistype) :: axis
    logical :: get_axis_modulo
    integer :: natt, i
    type(atttype), dimension(:), allocatable :: atts


    call mpp_get_atts(axis,natts=natt)
    allocate(atts(natt))
    call mpp_get_atts(axis,atts=atts)

    get_axis_modulo=.false.
    do i = 1,natt
       if (lowercase(trim(mpp_get_att_name(atts(i)))) == 'modulo') get_axis_modulo = .true.
    enddo

    deallocate(atts)

    return
  end function get_axis_modulo

  function get_axis_modulo_times(axis, tbeg, tend)

    logical :: get_axis_modulo_times
    type(axistype), intent(in) :: axis
    character(len=*), intent(out) :: tbeg, tend
    integer :: natt, i
    type(atttype), dimension(:), allocatable :: atts
    logical :: found_tbeg, found_tend
    
    call mpp_get_atts(axis,natts=natt)
    allocate(atts(natt))
    call mpp_get_atts(axis,atts=atts)
  
    found_tbeg = .false.
    found_tend = .false.

    do i = 1,natt
      if(lowercase(trim(mpp_get_att_name(atts(i)))) == 'modulo_beg') then
        if(mpp_get_att_length(atts(i)) > len(tbeg)) then
          call mpp_error(FATAL,'error in get: len(tbeg) too small to hold attribute')
        endif
        tbeg = trim(mpp_get_att_char(atts(i)))
        found_tbeg = .true.
      endif
      if(lowercase(trim(mpp_get_att_name(atts(i)))) == 'modulo_end') then
        if(mpp_get_att_length(atts(i)) > len(tend)) then
          call mpp_error(FATAL,'error in get: len(tend) too small to hold attribute')
        endif
        tend = trim(mpp_get_att_char(atts(i)))
        found_tend = .true.
      endif
    enddo

    if(found_tbeg .and. .not.found_tend) then
      call mpp_error(FATAL,'error in get: Found modulo_beg but not modulo_end')
    endif
    if(.not.found_tbeg .and. found_tend) then
      call mpp_error(FATAL,'error in get: Found modulo_end but not modulo_beg')
    endif

    get_axis_modulo_times = found_tbeg 

  end function get_axis_modulo_times

  function get_axis_fold(axis)

    type(axistype) :: axis
    logical :: get_axis_fold
    integer :: natt, i
    type(atttype), dimension(:), allocatable :: atts


    call mpp_get_atts(axis,natts=natt)
    allocate(atts(natt))
    call mpp_get_atts(axis,atts=atts)

    get_axis_fold=.false.
    do i = 1,natt
       if (mpp_get_att_char(atts(i)) == 'fold_top') get_axis_fold = .true.
    enddo

    deallocate(atts)

    return
  end function get_axis_fold

  function lon_in_range(lon, l_strt)
    real :: lon, l_strt, lon_in_range, l_end

    lon_in_range = lon
    l_end = l_strt+360.

    if (abs(lon_in_range - l_strt) < 1.e-4) then
       lon_in_range = l_strt
       return
    endif

    if (abs(lon_in_range - l_end) < 1.e-4) then
       lon_in_range = l_strt
       return
    endif

    do
       if (lon_in_range < l_strt) then          
          lon_in_range = lon_in_range +  f360;
       else if (lon_in_range  >  l_end) then
          lon_in_range  = lon_in_range - f360;
       else
          exit
       end if
    end do

  end function lon_in_range

  subroutine tranlon(lon, lon_start, istrt)

    ! returns array of longitudes s.t.  lon_strt <= lon < lon_strt+360.
    ! also, the first istrt-1 entries are moved to the end of the array
    !
    ! e.g.
    !        lon =      0 1 2 3 4 5  ...  358 359; lon_strt = 3 ==>
    !        tranlon =  3 4 5 6 7 8  ...  359 360 361 362; istrt = 4

    real, intent(inout), dimension(:) :: lon
    real, intent(in) :: lon_start
    integer, intent(out) :: istrt


    integer :: len, i
    real :: lon_strt, tmp(size(lon(:))-1)

    len = size(lon(:))

    do i=1,len
       lon(i) = lon_in_range(lon(i),lon_start)
    enddo

    istrt=0
    do i=1,len-1
       if (lon(i+1) < lon(i)) then
          istrt=i+1 
          exit
       endif
    enddo

    if (istrt>1) then ! grid is not monotonic
       if (abs(lon(len)-lon(1)) < epsln) then 
          tmp = cshift(lon(1:len-1),istrt-1)
          lon(1:len-1) = tmp
          lon(len) = lon(1)
       else
          lon = cshift(lon,istrt-1)
       endif
       lon_strt = lon(1)
       do i=2,len+1
          lon(i) = lon_in_range(lon(i),lon_strt)
          lon_strt = lon(i)
       enddo
    endif

    return
  end subroutine tranlon

  function frac_index (value, array)
    !=======================================================================
    !
    !     nearest_index = index of nearest data point within "array" corresponding to
    !            "value".
    !
    !     inputs:
    !
    !     value  = arbitrary data...same units as elements in "array"
    !     array  = array of data points  (must be monotonically increasing)
    !
    !     output:
    !
    !     nearest_index =  index of nearest data point to "value"
    !             if "value" is outside the domain of "array" then nearest_index = 1
    !             or "ia" depending on whether array(1) or array(ia) is
    !             closest to "value"
    !
    !             note: if "array" is dimensioned array(0:ia) in the calling
    !                   program, then the returned index should be reduced
    !                   by one to account for the zero base.
    !
    !     example:
    !
    !     let model depths be defined by the following:
    !     parameter (km=5)
    !     dimension z(km)
    !     data z /5.0, 10.0, 50.0, 100.0, 250.0/
    !
    !     k1 = nearest_index (12.5, z, km)
    !     k2 = nearest_index (0.0, z, km)
    !
    !     k1 would be set to 2, and k2 would be set to 1 so that
    !     z(k1) would be the nearest data point to 12.5 and z(k2) would
    !     be the nearest data point to 0.0
    !
    !=======================================================================

    integer :: ia, i, ii, unit
    real :: value, frac_index
    real, dimension(:) :: array
    logical keep_going
    
    ia = size(array(:))

    do i=2,ia
       if (array(i) < array(i-1)) then
          unit = stdout() 
          write (unit,*) '=> Error: "frac_index" array must be monotonically increasing when searching for nearest value to ',&
                              value
          write (unit,*) '          array(i) < array(i-1) for i=',i 
          write (unit,*) '          array(i) for i=1..ia follows:'
          do ii=1,ia
             write (unit,*) 'i=',ii, ' array(i)=',array(ii)
          enddo
          call mpp_error(FATAL,' "frac_index" array must be monotonically increasing.')
       endif
    enddo
    if (value < array(1) .or. value > array(ia)) then
!       if (value < array(1))  frac_index = 1.
!       if (value > array(ia)) frac_index = float(ia)
        frac_index = -1.0
    else
       i=1
       keep_going = .true.
       do while (i <= ia .and. keep_going)
          i = i+1
          if (value <= array(i)) then
             frac_index = float(i-1) + (value-array(i-1))/(array(i)-array(i-1)) 
             keep_going = .false.
          endif
       enddo
    endif
  end function frac_index

  function nearest_index (value, array)
    !=======================================================================
    !
    !     nearest_index = index of nearest data point within "array" corresponding to
    !            "value".
    !
    !     inputs:
    !
    !     value  = arbitrary data...same units as elements in "array"
    !     array  = array of data points  (must be monotonically increasing)
    !     ia     = dimension of "array"
    !
    !     output:
    !
    !     nearest_index =  index of nearest data point to "value"
    !             if "value" is outside the domain of "array" then nearest_index = 1
    !             or "ia" depending on whether array(1) or array(ia) is
    !             closest to "value"
    !
    !             note: if "array" is dimensioned array(0:ia) in the calling
    !                   program, then the returned index should be reduced
    !                   by one to account for the zero base.
    !
    !     example:
    !
    !     let model depths be defined by the following:
    !     parameter (km=5)
    !     dimension z(km)
    !     data z /5.0, 10.0, 50.0, 100.0, 250.0/
    !
    !     k1 = nearest_index (12.5, z, km)
    !     k2 = nearest_index (0.0, z, km)
    !
    !     k1 would be set to 2, and k2 would be set to 1 so that
    !     z(k1) would be the nearest data point to 12.5 and z(k2) would
    !     be the nearest data point to 0.0
    !
    !=======================================================================

    integer :: nearest_index, ia, i, ii, unit
    real :: value
    real, dimension(:) :: array
    logical keep_going

    ia = size(array(:))

    do i=2,ia
       if (array(i) < array(i-1)) then
          unit = stdout()
          write (unit,*) '=> Error: "nearest_index" array must be monotonically increasing &
                         &when searching for nearest value to ',value
          write (unit,*) '          array(i) < array(i-1) for i=',i 
          write (unit,*) '          array(i) for i=1..ia follows:'
          do ii=1,ia
             write (unit,*) 'i=',ii, ' array(i)=',array(ii)
          enddo
          call mpp_error(FATAL,' "nearest_index" array must be monotonically increasing.')
       endif
    enddo
    if (value < array(1) .or. value > array(ia)) then
       if (value < array(1))  nearest_index = 1
       if (value > array(ia)) nearest_index = ia
    else
       i=1
       keep_going = .true.
       do while (i <= ia .and. keep_going)
          i = i+1
          if (value <= array(i)) then
             nearest_index = i
             if (array(i)-value > value-array(i-1)) nearest_index = i-1
             keep_going = .false.
          endif
       enddo
    endif
  end function nearest_index

  !#############################################################################

  subroutine interp_1d_linear(grid1,grid2,data1,data2)  

    real, dimension(:),    intent(in) :: grid1, data1, grid2
    real, dimension(:), intent(inout) :: data2

    integer :: n1, n2, i, n, ext
    real :: w

    n1 = size(grid1(:))
    n2 = size(grid2(:))


    do i=2,n1
       if (grid1(i) <= grid1(i-1)) call mpp_error(FATAL, 'grid1 not monotonic')
    enddo

    do i=2,n2
       if (grid2(i) <= grid2(i-1)) call mpp_error(FATAL, 'grid2 not monotonic')
    enddo

    if (grid1(1) > grid2(1) ) call mpp_error(FATAL, 'grid2 lies outside grid1')
    if (grid1(n1) < grid2(n2) ) call mpp_error(FATAL, 'grid2 lies outside grid1')

    do i=1,n2
       n = nearest_index(grid2(i),grid1)

       if (grid1(n) < grid2(i)) then
          w = (grid2(i)-grid1(n))/(grid1(n+1)-grid1(n))
          data2(i) = (1.-w)*data1(n) + w*data1(n+1)
       else
          if(n==1) then
             data2(i) = data1(n)
          else
             w = (grid2(i)-grid1(n-1))/(grid1(n)-grid1(n-1))
             data2(i) = (1.-w)*data1(n-1) + w*data1(n)   
          endif     
       endif
    enddo


    return

  end subroutine interp_1d_linear

  !###################################################################
  subroutine interp_1d_cubic_spline(grid1, grid2, data1, data2, yp1, ypn)  

    real, dimension(:),    intent(in) :: grid1, grid2, data1
    real, dimension(:), intent(inout) :: data2
    real,                  intent(in) :: yp1, ypn

    real, dimension(size(grid1))      :: y2, u
    real                              :: sig, p, qn, un, h, a ,b
    integer                           :: n, m, i, k, klo, khi

    n = size(grid1(:))
    m = size(grid2(:))    

    do i=2,n
       if (grid1(i) <= grid1(i-1)) call mpp_error(FATAL, 'grid1 not monotonic')
    enddo

    do i=2,m
       if (grid2(i) <= grid2(i-1)) call mpp_error(FATAL, 'grid2 not monotonic')
    enddo

    if (grid1(1) > grid2(1) ) call mpp_error(FATAL, 'grid2 lies outside grid1')
    if (grid1(n) < grid2(m) ) call mpp_error(FATAL, 'grid2 lies outside grid1')

    if (yp1 >.99e30) then
       y2(1)=0.
       u(1)=0.
    else
       y2(1)=-0.5
       u(1)=(3./(grid1(2)-grid1(1)))*((data1(2)-data1(1))/(grid1(2)-grid1(1))-yp1)
    endif

    do i=2,n-1
       sig=(grid1(i)-grid1(i-1))/(grid1(i+1)-grid1(i-1))
       p=sig*y2(i-1)+2.
       y2(i)=(sig-1.)/p
       u(i)=(6.*((data1(i+1)-data1(i))/(grid1(i+1)-grid1(i))-(data1(i)-data1(i-1)) &
             /(grid1(i)-grid1(i-1)))/(grid1(i+1)-grid1(i-1))-sig*u(i-1))/p
    enddo

    if (ypn > .99e30) then
       qn=0.
       un=0.
    else
       qn=0.5
       un=(3./(grid1(n)-grid1(n-1)))*(ypn-(data1(n)-data1(n-1))/(grid1(n)-grid1(n-1)))
    endif

    y2(n)=(un-qn*u(n-1))/(qn*y2(n-1)+1.)

    do  k=n-1,1,-1
       y2(k)=y2(k)*y2(k+1)+u(k)
    enddo

    do k = 1, m
       n = nearest_index(grid2(k),grid1)
       if (grid1(n) < grid2(k)) then
          klo = n
       else
          if(n==1) then
            klo = n
          else 
            klo = n -1
          endif
       endif
       khi = klo+1
       h   = grid1(khi)-grid1(klo)
       a   = (grid1(khi) - grid2(k))/h
       b   = (grid2(k) - grid1(klo))/h
       data2(k) = a*data1(klo) + b*data1(khi)+ ((a**3-a)*y2(klo) + (b**3-b)*y2(khi))*(h**2)/6.
    enddo

  end subroutine interp_1d_cubic_spline

  !###################################################################

  subroutine interp_1d_1d(grid1,grid2,data1,data2, method, yp1, yp2)  

    real, dimension(:),      intent(in)    :: grid1, data1, grid2
    real, dimension(:),      intent(inout) :: data2
    character(len=*), optional, intent(in) :: method
    real,             optional, intent(in) :: yp1, yp2

    real              :: y1, y2
    character(len=32) :: interp_method    
    integer           :: k2, ks, ke

    k2 = size(grid2(:))

    interp_method = "linear"
    if(present(method)) interp_method = method
    y1 = 1.0e30
    if(present(yp1)) y1 = yp1
    y2 = 1.0e30
    if(present(yp2)) y2 = yp2
    call find_index(grid1, grid2(1), grid2(k2), ks, ke)
    select case(trim(interp_method))
    case("linear")
       call interp_1d_linear(grid1(ks:ke),grid2,data1(ks:ke),data2)
    case("cubic_spline")
       call interp_1d_cubic_spline(grid1(ks:ke),grid2,data1(ks:ke),data2, y1, y2)
    case default
       call mpp_error(FATAL,"axis_utils: interp_method should be linear or cubic_spline")
    end select

    return

  end subroutine interp_1d_1d

  !###################################################################


  subroutine interp_1d_2d(grid1,grid2,data1,data2)  

    real, dimension(:,:),    intent(in) :: grid1, data1, grid2
    real, dimension(:,:), intent(inout) :: data2

    integer :: n1, n2, i, n, k2, ks, ke
    real :: w

    n1 = size(grid1,1)
    n2 = size(grid2,1)
    k2 = size(grid2,2)

    if (n1 /= n2) call mpp_error(FATAL,'grid size mismatch')

    do n=1,n1
       call find_index(grid1(n,:), grid2(n,1), grid2(n,k2), ks, ke)
       call interp_1d_linear(grid1(n,ks:ke),grid2(n,:),data1(n,ks:ke),data2(n,:))
    enddo

    return

  end subroutine interp_1d_2d

  !###################################################################

  subroutine interp_1d_3d(grid1,grid2,data1,data2, method, yp1, yp2)  

    real, dimension(:,:,:),  intent(in)    :: grid1, data1, grid2
    real, dimension(:,:,:),  intent(inout) :: data2
    character(len=*), optional, intent(in) :: method
    real,             optional, intent(in) :: yp1, yp2

    integer           :: n1, n2, m1, m2, k2, i, n, m
    real              :: w, y1, y2
    character(len=32) :: interp_method
    integer           :: ks, ke
    n1 = size(grid1,1)
    n2 = size(grid2,1)
    m1 = size(grid1,2)
    m2 = size(grid2,2)
    k2 = size(grid2,3)

    interp_method = "linear"
    if(present(method)) interp_method = method
    y1 = 1.0e30
    if(present(yp1)) y1 = yp1
    y2 = 1.0e30
    if(present(yp2)) y2 = yp2

    if (n1 /= n2 .or. m1 /= m2) call mpp_error(FATAL,'grid size mismatch')

    select case(trim(interp_method))
    case("linear")
       do m=1,m1
          do n=1,n1
            call find_index(grid1(n,m,:), grid2(n,m,1), grid2(n,m,k2), ks, ke)
             call interp_1d_linear(grid1(n,m,ks:ke),grid2(n,m,:),data1(n,m,ks:ke),data2(n,m,:))
          enddo
       enddo
    case("cubic_spline")
       do m=1,m1
          do n=1,n1
            call find_index(grid1(n,m,:), grid2(n,m,1), grid2(n,m,k2), ks, ke)
            call interp_1d_cubic_spline(grid1(n,m,ks:ke),grid2(n,m,:), data1(n,m,ks:ke),data2(n,m,:), y1, y2)
          enddo
       enddo
    case default
       call mpp_error(FATAL,"axis_utils: interp_method should be linear or cubic_spline")
    end select

    return

  end subroutine interp_1d_3d


  !#####################################################################
  subroutine find_index(grid1, xs, xe, ks, ke)
    real, dimension(:), intent(in) :: grid1
    real,               intent(in) :: xs, xe
    integer,           intent(out) :: ks, ke

    integer :: k, nk

    nk = size(grid1(:))

    ks = 0; ke = 0
    do k = 1, nk-1
       if(grid1(k) <= xs .and. grid1(k+1) > xs ) then
          ks = k
          exit
       endif
    enddo
    do k = nk, 2, -1
       if(grid1(k) >= xe .and. grid1(k-1) < xe ) then
          ke = k
          exit
       endif
    enddo

    if(ks == 0 ) call mpp_error(FATAL,' xs locate outside of grid1')
    if(ke == 0 ) call mpp_error(FATAL,' xe locate outside of grid1')

  end subroutine find_index

end module axis_utils_mod

#ifdef test_axis_utils

program test

use fms_mod,       only : fms_init, file_exist, open_namelist_file, check_nml_error
use fms_mod,       only : close_file
use mpp_mod,       only : mpp_error, FATAL, stdout
use mpp_mod,       only : input_nml_file
use axis_utils_mod, only: interp_1d

implicit none



integer, parameter :: maxsize = 100

integer :: n_src = 0
integer :: n_dst = 0
real, dimension(MAXSIZE) :: grid_src = 0 
real, dimension(MAXSIZE) :: grid_dst = 0
real, dimension(MAXSIZE) :: data_src = 0

namelist / test_axis_utils_nml / n_src, n_dst, grid_src, grid_dst, data_src

real, allocatable :: data_dst(:)
integer           :: unit, ierr, io

  call fms_init()

  !--- default option of data
  n_src = 31
  n_dst = 40
  grid_src(1:n_src) = (/ -63.6711465476916, -63.6711455476916, 166.564180735096, 401.25299580552, &
                         641.056493022762, 886.219516665347, 1137.35352761133, 1394.4936854079,   &
                         1657.17893448689, 1925.64572676068, 2200.13183483549, 2480.9124139255,   &
                         2768.35396680912, 3062.86513953019, 3675.47369643284, 4325.10564183322,  &
                         5020.19039479527, 5769.85432323481, 6584.25101514851, 7475.94655633703,  &
                         8462.01951335773, 9568.28246037887, 10178.3869413515, 10834.1425668942,  &
                         11543.5265942777, 12317.3907407535, 13170.4562394288, 14125.6466646843,  &
                         15225.8720618086, 16554.7859690842, 19697.1334102613   /)
  grid_dst(1:n_dst) = (/ 1002.9522552602, 1077.51144617887, 1163.37842788755, 1264.19848463606,  &
                         1382.57557953916, 1521.56713587855, 1684.76300370633, 1876.37817787584, &
                         2101.36166220498, 2365.52429149707, 2675.68881278444, 3039.86610206727, &
                         3467.4620678435, 3969.52058529847, 4553.81573511231, 5159.54844211827,  &
                         5765.28114912423, 6371.01385613019, 6976.74656313614, 7582.4792701421,  &
                         8188.21197714806, 8793.94468415402, 9399.67739115997, 10005.4100981659, &
                         10611.1428051719, 11216.8755121778, 11822.6082191838, 12428.3409261898, &
                         13034.0736331957, 13639.8063402017, 14245.5390472076, 14851.2717542136, &
                         15457.0044612196, 16062.7371682255, 16668.4698752315, 17274.2025822374, &
                         17879.9352892434, 18485.6679962493, 19091.4007032553, 19697.1334102613 /)
  data_src(1:n_src) = (/ 309.895999643929, 309.991081541887, 309.971074746584, 310.873654697145, &
                         311.946530606618, 312.862249229647, 314.821236806913, 315.001269608758, &
                         315.092410930288, 315.19010999336,  315.122964496815, 315.057882573487, &
                         314.998796850493, 314.984586411292, 315.782246062002, 318.142544345795, &
                         321.553905292867, 325.247730854554, 329.151282227113, 332.835673638378, &
                         336.810414210932, 341.64530983048,  344.155248759994, 346.650476976385, &
                         349.106430095269, 351.915323032738, 354.709396583792, 359.68904432446,  &
                         371.054289820675, 395.098187506342, 446.150726850039 /)


  !---reading namelist 
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, test_axis_utils_nml, iostat=io)
      ierr = check_nml_error(io,'test_axis_utils_nml')
#else
  if(file_exist('input.nml')) then
    unit =  open_namelist_file()
       ierr=1
    do while (ierr /= 0)
          read  (unit, nml=test_axis_utils_nml, iostat=io, end=10)
          ierr = check_nml_error(io,'test_axis_utils_nml')  ! also initializes nml error codes
    enddo
 10    call close_file(unit)
  endif
#endif

  if(n_src >MAXSIZE) call mpp_error(FATAL, 'test_axis_utils: nml n_src is greater than MAXSIZE')
  if(n_dst >MAXSIZE) call mpp_error(FATAL, 'test_axis_utils: nml n_dst is greater than MAXSIZE')

  allocate(data_dst(n_dst) )



  !--- write out data
  unit = stdout()
  write(unit,*)' the source grid is ', grid_src(1:n_src)
  write(unit,*)' the destination grid is ', grid_dst(1:n_dst)
  write(unit,*)' the source data is ', data_src(1:n_src)
  call interp_1d(grid_src(1:n_src), grid_dst(1:n_dst), data_src(1:n_src), data_dst, "linear")
  write(unit,*)' the destination data using linear interpolation is ', data_dst(1:n_dst)
  call interp_1d(grid_src(1:n_src), grid_dst(1:n_dst), data_src(1:n_src), data_dst, "cubic_spline")
  write(unit,*)' the destination data using cublic spline interpolation is ', data_dst(1:n_dst)

end program test


#endif /* test_axis_utils */

module ice_albedo_mod

!=======================================================================
!
!                     ICE SURFACE ALBEDO MODULE
!
!   Routines for computing the surface albedo over ice 
!
!=======================================================================

#ifdef INTERNAL_FILE_NML
use          mpp_mod, only: input_nml_file
#else
use          fms_mod, only: open_namelist_file
#endif

use            fms_mod, only:  error_mesg, file_exist,  &
                               check_nml_error,  &
                               FATAL, close_file, mpp_pe, mpp_root_pe, &
                               write_version_number, stdlog

implicit none
private

!======= public interface =============================================

public  ice_albedo, ice_albedo_init

!--------------------- version number ----------------------------------

character(len=128) :: version = '$Id: ice_albedo.F90,v 19.0 2012/01/06 20:36:39 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!=======================================================================

!     DEFAULT VALUES OF NAMELIST PARAMETERS:

real :: crit_thickness       = 1.00   
real :: t_range              = 10.0

real :: min_ice_alb          = 0.50
real :: max_ice_alb          = 0.80

real :: const_alb            = 0.65


namelist /ice_albedo_nml/  crit_thickness      , &
                           t_range             , &
                           min_ice_alb         , &
                           max_ice_alb         , &
                           const_alb

!=======================================================================

!  OTHER MODULE VARIABLES

real :: temp_ice_freeze

logical :: do_init = .true.

CONTAINS

!#######################################################################

subroutine ice_albedo_init ( t_freeze )

real, intent(in) :: t_freeze

integer  unit, io, ierr

temp_ice_freeze = t_freeze

!------------------- read namelist input -------------------------------

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=ice_albedo_nml, iostat=io)
      ierr = check_nml_error(io, 'ice_albedo_nml')
#else
      if (file_exist('input.nml')) then
         unit = open_namelist_file ('input.nml')
         ierr=1; do while (ierr /= 0)
            read  (unit, nml=ice_albedo_nml, iostat=io, end=10)
            ierr = check_nml_error(io,'ice_albedo_nml')
         enddo
  10     call close_file (unit)
      endif
#endif

!------- write version number and namelist ---------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
           unit = stdlog()
           write (unit, nml=ice_albedo_nml)
      endif

  do_init = .false.

end subroutine ice_albedo_init

!#######################################################################

subroutine ice_albedo (ice, thickness, temp, albedo, i1, j1)

!-----------------------------------------------------------------------
!----------- CALCULATE SURFACE ALBEDO OVER ICE ------------------------
!-----------------------------------------------------------------------
!
! INPUT
!     (i1,j1)    = postition in global ice grid of first elements in
!                       the input
!     thickness  = thickness of ice (in meters)
!     alb_ocean  - albedo of open ocean (on ice grid)
!     temp       = surface temperature (in degrees kelvin)
!
!  OUTPUT
!     albedo = surface albedo

logical, intent(in),    dimension(:,:,:) :: ice
real,    intent(in),    dimension(:,:,:) :: temp, thickness
real,    intent(inout), dimension(:,:,:) :: albedo
integer, intent(in), optional :: i1, j1

!-----------------------------------------------------------------------

integer :: is, js, ie, je, n
real :: tcrit
real, dimension(size(temp,1),size(temp,2)) :: thick_ice_alb, alb_ocean

if (do_init) call error_mesg ('ice_albedo',  &
                              'initialization not called', FATAL)

is = 1; if (present(i1)) is = i1
js = 1; if (present(j1)) js = j1

ie = is + size(temp,1) - 1
je = js + size(temp,2) - 1

tcrit = temp_ice_freeze - t_range

!--- first partition assumed to be open ocean ----

 alb_ocean = albedo(:,:,1)

 do n = 2, size(temp,3)

  where(ice(:,:,n) .and. temp(:,:,n) <= tcrit) &
             thick_ice_alb = max_ice_alb
  where(ice(:,:,n) .and. temp(:,:,n) >= temp_ice_freeze) &
             thick_ice_alb = min_ice_alb
  where(ice(:,:,n) .and. temp(:,:,n) <  temp_ice_freeze &
                               .and. temp(:,:,n) > tcrit)  &
     thick_ice_alb = max_ice_alb +  &
           (min_ice_alb - max_ice_alb)*(temp(:,:,n) - tcrit)/t_range


  where (ice(:,:,n).and.thickness(:,:,n) >= crit_thickness)  &
        albedo(:,:,n) = thick_ice_alb
  where (ice(:,:,n).and.thickness(:,:,n) < crit_thickness) &
        albedo(:,:,n) =  alb_ocean + &
      (thick_ice_alb - alb_ocean) *sqrt(thickness(:,:,n)/crit_thickness)

end do

end subroutine ice_albedo

!######################################################################

end module ice_albedo_mod

module ocean_xlandinsert_mod
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> K.W. Dixon
!</CONTACT>  
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> M.J. Harrison
!</REVIEWER>   
!
!<OVERVIEW>
! Tracer and mass source from cross-land insertion.
!</OVERVIEW>
!
!<DESCRIPTION>
! Compute thickness and density weighted tendency [rho*tracer*meter/sec]
! of tracer associated with cross-land insertion.  Also compute 
! mass source from cross-land insertion.  
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies, M.J. Harrison, R. C. Pacanowski, and A. Rosati
! A Technical Guide to MOM4 (2003)
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
! <NOTE>
! Algorithm ensures both total tracer and total mass is conserved.
! Algorithm sets up the insertion points as in xlandmix, and 
! transports between the columns as in rivermix. 
! </NOTE>
!
! <NOTE>
! 2D domain decomposition is implemented according to following
! notions.  If the two points in an xlandinsert pair live within halo 
! of each other (i.e., within same local_domain), 
! then no added mpp communication required. However, nore generally 
! the two points live further away.  In this case, xland_domain
! is defined so that its halos incorporate the maximum separation 
! of xlandinsert points.  New tracer, eta, and grid arrays
! are defined over this extended xland_domain.  This added domain
! size will come at some computational cost, so it is advantageous
! to limit the separation between points within an xlandinsert pair. 
! </NOTE>
!
! <NOTE>
! The current implementation of xlandinsert has not been generalized 
! to allow for communication between points separated by the tripolar fold.  
! The problem is in the logic used to compute xland_domain.  
! There is nothing fundamental limiting a generalization of the
! logic used to generate xland_domain.
! </NOTE>
!
! <NOTE>
! Many of the user specified values given in USER INPUT are
! model dependent since unresolved straits can become resolved 
! in finer mesh models. 
! </NOTE>
!
! <NOTE>
! BUG FIX 30 May 2011. 
! Trying to mix across the ends of the global domain results in incorrect indexing.
! Local indices need to be incremented/decremented by the global extent.
! Russell.Fiedler@csiro.au
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_xlandinsert_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  Needs to be true in order to use this scheme. Default is false.
!  </DATA> 
!  <DATA NAME="verbose_init" TYPE="logical">
!  For verbose initialization information.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging.
!  </DATA> 
!</NAMELIST>

use constants_mod,     only: epsln
use diag_manager_mod,  only: register_diag_field
use field_manager_mod, only: MODEL_OCEAN, parse, find_field_index
use field_manager_mod, only: get_field_methods, method_type, get_field_info
use fms_mod,           only: stdout, stdlog, FATAL, NOTE, WARNING
use fms_mod,           only: write_version_number, open_namelist_file, check_nml_error, close_file
use mpp_domains_mod,   only: mpp_update_domains 
use mpp_domains_mod,   only: BITWISE_EXACT_SUM
use mpp_mod,           only: input_nml_file, mpp_error

use ocean_domains_mod,    only: get_local_indices, get_global_indices, set_ocean_domain
use ocean_parameters_mod, only: rho0, rho0r, missing_value
use ocean_types_mod,      only: ocean_domain_type, ocean_grid_type, ocean_time_type
use ocean_types_mod,      only: ocean_thickness_type, ocean_external_mode_type 
use ocean_types_mod,      only: ocean_prog_tracer_type, ocean_options_type, ocean_density_type 
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3, wrk4, wrk5, wrk1_v
use ocean_util_mod,       only: diagnose_2d, diagnose_3d, diagnose_sum
use ocean_tracer_util_mod,only: diagnose_3d_rho

implicit none

private 

public  ocean_xlandinsert_init
public  xlandinsert
private xlandinsert_mass
private watermass_diag_init
private watermass_diag

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()


! Variables set inside subroutine ocean_xlandinsert_init
! See comments in ocean_xlandinsert_init for description
integer, dimension(:,:), allocatable :: ixland     
integer, dimension(:,:), allocatable :: jxland     
integer, dimension(:,:), allocatable :: kxland     
real, dimension(:), allocatable      :: tauxland     
real, dimension(:), allocatable      :: tauxlandr     
real, dimension(:,:), allocatable    :: water_rate ! rate (kg/m^3)*(m/s) of water transferred between columns

! number of xland mixing pairs 
integer :: nxland=0 

integer                              :: xland_halo     ! halo size needed to perform xlandinsert
integer                              :: kxland_min     ! min of the k-levels for the nxland pairs
integer                              :: kxland_max     ! max of the k-levels for the nxland pairs
type(ocean_domain_type), save        :: Xland_domain   ! domain for xlandinsert

! variables defined with halos given by xland_halo
real, dimension(:,:), allocatable    :: xland_rho_dzt  ! mass source on (x,y) space from xlandinsert (kg/m^3)*(m/s)
real, dimension(:,:), allocatable    :: rho_dzt_x      ! surface value for rho_dzt (kg/m^3)*(m)
real, dimension(:,:), allocatable    :: xtx            ! zonal position of tracer points (degrees)
real, dimension(:,:), allocatable    :: ytx            ! meridional position of tracer points (degrees)
real, dimension(:,:), allocatable    :: datx           ! area of tracer cell (m^2)
real                                 :: dtime          ! time step

integer                              :: unit=6         ! processor zero writes to unit 6
  
logical, dimension(:), allocatable   :: error_xland    ! for checking that all xland points are OK.  

! work array for eta_tend 
real, dimension(:,:,:),   allocatable :: theta_tend
real, dimension(:,:,:),   allocatable :: salt_tend

! for global area normalization
real    :: cellarea_r

! internally set for computing watermass diagnostics
logical :: compute_watermass_diag = .false. 

! for diagnostics 
logical :: used
integer, dimension(:), allocatable  :: id_xland
integer :: id_xland_rho_dzt=-1

integer :: id_neut_rho_xinsert          =-1
integer :: id_neut_rho_xinsert_on_nrho  =-1
integer :: id_wdian_rho_xinsert         =-1
integer :: id_wdian_rho_xinsert_on_nrho =-1
integer :: id_tform_rho_xinsert         =-1
integer :: id_tform_rho_xinsert_on_nrho =-1

integer :: id_eta_tend_xinsert     =-1
integer :: id_eta_tend_xinsert_glob=-1

integer :: id_neut_temp_xinsert          =-1
integer :: id_neut_temp_xinsert_on_nrho  =-1
integer :: id_wdian_temp_xinsert         =-1
integer :: id_wdian_temp_xinsert_on_nrho =-1
integer :: id_tform_temp_xinsert         =-1
integer :: id_tform_temp_xinsert_on_nrho =-1

integer :: id_neut_salt_xinsert          =-1
integer :: id_neut_salt_xinsert_on_nrho  =-1
integer :: id_wdian_salt_xinsert         =-1
integer :: id_wdian_salt_xinsert_on_nrho =-1
integer :: id_tform_salt_xinsert         =-1
integer :: id_tform_salt_xinsert_on_nrho =-1

integer :: num_prog_tracers=0
integer :: index_temp=-1
integer :: index_salt=-1

character(len=128) :: version=&
       '$Id: ocean_xlandinsert.F90,v 20.0 2013/12/14 00:16:28 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk
integer :: isg, ieg, jsg, jeg
integer :: ixl, jxl, ixl2, jxl2

logical :: verbose_init          = .true.
logical :: use_this_module       = .false.
logical :: module_is_initialized = .FALSE.
logical :: debug_this_module     = .false.

namelist /ocean_xlandinsert_nml/ verbose_init, use_this_module, debug_this_module

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_xlandinsert_init">
!
! <DESCRIPTION>
!    Initial set up for crossland insertion of tracers and eta 
!
!    Checks are performed to ensure that the crossland mixing
!    grid locations are valid according to model configuration.
!
!    A summary of the locations of crossland points is written out.
!
!    User specified inputs in "USER INPUT" section:
!
!    ixland and jxland = user specified nxland pairs of i,j grid locations
!
!    kxland = user specified uppermost (ktop=kxland(n,1)) and  
!             deepest (kbot=kxland(n,2)) levels over which crossland 
!             will be done for each crossland pair. Note the for 
!             xlandinsert, kxland(nxl,1)=1 is required, since the 
!             aim is to move excess volume from one column to another. 
!
!    tauxland = user specified time constant (seconds) setting the rate 
!               of transport via upwind advection.  
!
!    NOTE: for ixland, jxland, and kxland pairs, values of the
!    (n,1) element should be < the corresponding (n,2) value.
!
! </DESCRIPTION>

subroutine ocean_xlandinsert_init(Grid, Domain, Time, Dens, T_prog, Ocean_options, d_time)

  type(ocean_grid_type),        intent(in), target :: Grid
  type(ocean_domain_type),      intent(in), target :: Domain
  type(ocean_time_type),        intent(in)         :: Time
  type(ocean_density_type),     intent(in)         :: Dens
  type(ocean_prog_tracer_type), intent(in)         :: T_prog(:)
  type(ocean_options_type),     intent(inout)      :: Ocean_options
  real,                         intent(in)         :: d_time

  type(method_type), allocatable, dimension(:) :: xland_methods
  character(len=32) :: fld_type, fld_name
  integer :: n, nt, model, imax, imin
  integer :: nxl, lx, xland_halo_test,i
  integer :: parse_ok
  integer :: io_status, ioun, ierr
  real    :: ztop 

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if (module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_xlandinsert_mod (ocean_xlandinsert_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  call get_global_indices(Domain,isg,ieg,jsg,jeg)
  nk = Grid%nk

  Dom => Domain
  Grd => Grid
  
  dtime = d_time 
  cellarea_r = 1.0/(epsln + Grd%tcellsurf)
  
  num_prog_tracers = size(T_prog(:))
  do nt=1,num_prog_tracers
     if (T_prog(nt)%name == 'temp') index_temp = nt
     if (T_prog(nt)%name == 'salt') index_salt = nt
  enddo

  n = find_field_index(MODEL_OCEAN,'xland_insert')

  if (n < 1) then 
    write(stdoutunit,*)' '
    write(stdoutunit,*) &
    '==>Warning: ocean_xlandinsert_init found n < 1 for xland_insert table.  Will NOT use ocean_xlandinsert.'  
    write(stdoutunit,*)' '
    Ocean_options%xlandinsert = 'Did NOT use xlandinsert.'
    return
  endif 

  call get_field_info(n,fld_type,fld_name,model,nxland)

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_xlandinsert_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_xlandinsert_nml')
#else
  ioun =  open_namelist_file()
  read (ioun,ocean_xlandinsert_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_xlandinsert_nml')
  call close_file (ioun)
#endif
  write (stdlogunit,ocean_xlandinsert_nml)
  write (stdoutunit,'(/)') 
  write (stdoutunit,ocean_xlandinsert_nml)

  if(use_this_module) then 
      if(nxland == 0) then 
          write(stdoutunit, *) &
          '==>Warning: use_this_module=.true. but no mixing points chosen. Is this what you wish?'
          call mpp_error(WARNING,&
          '==>NOTE from ocean_xlandinsert_mod: No cross-land mixing points chosen')
          Ocean_options%xlandinsert = 'Used xlandinsert, but set zero cross-land points, so module does nothing.'
          return
      else
          call mpp_error(NOTE, &
          '==>Note from ocean_xlandinsert_mod (ocean_xlandinsert_init): USING this module')
          write(stdoutunit, *) &
          '==>NOte: Using xlandinsert to connect tracers and mass between non-local ocean cells.'
          Ocean_options%xlandinsert = 'Used xlandinsert to transfer tracer between inland seas and open ocean.'
      endif
  else 
      call mpp_error(NOTE, '==>Note from ocean_xlandinsert_mod: NOT USING this module')
      if(nxland > 0) then 
          call mpp_error(WARNING, &
          '==>Warning: nxland > 0, but use_this_module=.false. NOT using xlandinsert. Is this what you wish?')
      endif
      Ocean_options%xlandinsert = 'Did NOT use xlandinsert.'
      return
  endif

  write(stdoutunit,'(/a,f10.2)')'==> Note from ocean_xlandinsert_mod: using time step of (secs)', dtime 

  allocate(xland_methods(nxland))

  allocate (ixland(nxland,2))
  ixland(:,:) = 0
  allocate (jxland(nxland,2))
  jxland(:,:) = 0
  allocate (kxland(nxland,2))
  kxland(:,:) = 0
  allocate (tauxland(nxland))
  tauxland(:)   = 0.0
  allocate (tauxlandr(nxland))
  tauxlandr(:)   = 0.0
  allocate (error_xland(nxland))
  error_xland(:) = .false.
  allocate (water_rate(nxland,2))
  water_rate(:,:) = 0.0

  call get_field_methods(n,xland_methods)
  do i=1, nxland
     parse_ok = parse(xland_methods(i)%method_control,'ixland_1',ixland(i,1))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_xlandinsert_mod: xland table entry "ixland_1" error')
     parse_ok = parse(xland_methods(i)%method_control,'ixland_2',ixland(i,2))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_xlandinsert_mod: xland table entry "ixland_2" error')
     parse_ok = parse(xland_methods(i)%method_control,'jxland_1',jxland(i,1))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_xlandinsert_mod: xland table entry "jxland_1" error')
     parse_ok = parse(xland_methods(i)%method_control,'jxland_2',jxland(i,2))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_xlandinsert_mod: xland table entry "jxland_2" error')
     parse_ok = parse(xland_methods(i)%method_control,'kxland_1',kxland(i,1))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_xlandinsert_mod: xland table entry "kxland_1" error')
     parse_ok = parse(xland_methods(i)%method_control,'kxland_2',kxland(i,2))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_xlandinsert_mod: xland table entry "kxland_2" error')
     parse_ok   = parse(xland_methods(i)%method_control,'tauxland',tauxland(i))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error ocean_xlandinsert_mod: xland table entry "tauxland" error')
  enddo

  if(Grid%tripolar) then 
     write(stdoutunit,'(a)') &
     '==>Warning: xlandinsert has not been implemented to connect points across the tripolar fold.'
  endif

  write(stdoutunit, *) &
  'Using xlandinsert to connect tracers and surface height between non-local ocean cells.'


  xland_halo = min(isc-isd,ied-iec,jsc-jsd,jed-jec)
  kxland_min = nk
  kxland_max = 1

  do nxl=1,nxland

     ! check for invalid crossland insertion grid locations

     if(kxland(nxl,1) > 1) then 
       call mpp_error(FATAL,&
       '==>Error in ocean_xlandinsert_init: kxland set wrong--must start from top cell w/ kxland(nxl,1)=1.')
     endif 

     if (kxland(nxl,1) > kxland(nxl,2)) then
        write (unit,994) nxl, kxland(nxl,1), nxl, kxland(nxl,2)
        error_xland(nxl) = .true.
     endif
     if (kxland(nxl,1) < kxland_min ) kxland_min = kxland(nxl,1)  
     if (kxland(nxl,2) > kxland_max ) kxland_max = kxland(nxl,2)  

     do lx = 1,2
        if (ixland(nxl,lx) < 1 .or. ixland(nxl,lx) > Grd%ni) then
           write(unit,991) nxl, lx, ixland(nxl,lx)
           error_xland(nxl) = .true.
        endif
        if (jxland(nxl,lx) < 1 .or. jxland(nxl,lx) > Grd%nj ) then
           write(unit,992) nxl, lx, jxland(nxl,lx)
           error_xland(nxl) = .true.
        endif
        if (kxland(nxl,lx) < 1 .or. kxland(nxl,lx) > Grd%nk ) then
           write(unit,993) nxl, lx, kxland(nxl,lx)
           error_xland(nxl) = .true.
        endif
     enddo

     ! determine size for xland_halo
     if(Grd%cyclic_x) then
       imax = max(ixland(nxl,1),ixland(nxl,2))
       imin = min(ixland(nxl,1),ixland(nxl,2))
       xland_halo_test = min( abs(imax-imin), abs(imax-Grd%ni-imin))
     else
       xland_halo_test = abs(ixland(nxl,1)-ixland(nxl,2))
     endif
     if (xland_halo_test > xland_halo ) xland_halo = xland_halo_test

     xland_halo_test = abs(jxland(nxl,1)-jxland(nxl,2))
     if (xland_halo_test > xland_halo ) xland_halo = xland_halo_test

     ! set tauxlandr as inverse of tauxland, except when tauxland=0.
     if(tauxland(nxl) > 0.0) tauxlandr(nxl) = 1.0/tauxland(nxl)

  enddo  ! end of do-loop nxl=1,nxland

  if(xland_halo == 0) then 
     call mpp_error(FATAL,&
     '==>Error in ocean_xlandinsert_init: xland_halo=0 => problems defining xlandinsert points.')
  endif
 
  if(xland_halo > Dom%xhalo .or. xland_halo > Dom%yhalo) then 
    write(stdoutunit,*) &
    'Defining extra tracer arrays for xland_domain over k-levels ',kxland_min,' through ',kxland_max 
  endif 

! define arrays and xland_domain
  
  if(xland_halo > Dom%xhalo .or. xland_halo > Dom%yhalo) then 
      write(stdoutunit,*)'The model local computational domain has a x,y halo = ',Dom%xhalo, Dom%yhalo
      write(stdoutunit,*)'This is smaller than the halo required for xlandinsert.'
      write(stdoutunit,*)'For xlandinsert, define a new domain type with halo = ', xland_halo

      if(xland_halo > (Dom%xhalo+6)) then 
          write(stdoutunit,*)'=>Warning: ocean_xlandinsert_init determined xland_halo = ', xland_halo
          write(stdoutunit,*)'           Are you sure you wish to connect such distant locations?'
          write(stdoutunit,*)'           Are you instead trying to connect points across a tripolar fold?'
          write(stdoutunit,*)'           If so, then presently this has yet to be coded into xlandinsert.'
          write(stdoutunit,*)'           Alternative xlandinsert points must be taken, or new code implemented.'
      endif

  endif

  ! define xlandinsert domain 
  call set_ocean_domain(Xland_domain,Grd,xhalo=xland_halo,yhalo=xland_halo,&
                        name='xlandinsert',maskmap=Dom%maskmap)

  ! time independent arrays defined over the xland_domain
  allocate (datx(isc-xland_halo:iec+xland_halo,jsc-xland_halo:jec+xland_halo))
  allocate (xtx(isc-xland_halo:iec+xland_halo,jsc-xland_halo:jec+xland_halo))
  allocate (ytx(isc-xland_halo:iec+xland_halo,jsc-xland_halo:jec+xland_halo))
  datx(:,:) = 0.0
  xtx(:,:)  = 0.0
  ytx(:,:)  = 0.0

  datx(isc:iec,jsc:jec) = Grd%dat(isc:iec,jsc:jec)
  xtx(isc:iec,jsc:jec)  = Grd%xt(isc:iec,jsc:jec)
  ytx(isc:iec,jsc:jec)  = Grd%yt(isc:iec,jsc:jec)
  call mpp_update_domains (datx(:,:), Xland_domain%domain2d)
  call mpp_update_domains (xtx(:,:), Xland_domain%domain2d)
  call mpp_update_domains (ytx(:,:), Xland_domain%domain2d)

  ! time dependent arrays defined over the xland_domain
  allocate (xland_rho_dzt(isc:iec,jsc:jec))
  allocate (rho_dzt_x(isc-xland_halo:iec+xland_halo,jsc-xland_halo:jec+xland_halo))
  xland_rho_dzt(:,:) = 0.0
  rho_dzt_x(:,:)     = 0.0

! Mixing across Straits of Gibraltar in CSIRO MK3.5 model resulted in 
! exceeding bounds with the Dec2009 verison of MOM4p1. 
! ixl needs to be changed to reflect cyclic BCs.
! Earlier checks were made to see if ixl was negative or too 
! large wrt the global domain. However we want ixl in the current 
! expanded data domain of xtx.
  if(Grd%cyclic_x) then
     do nxl=1,nxland 
        if( at_least_one_in_comp_domain(nxl) ) then
            do lx = 1,2
               if(.not. on_processor(nxl, lx)) then               ! Not in domain. This is WRONG!
                  ixl = ixland(nxl,lx)-Dom%ioff
                  if(ixl < lbound(xtx,1) ) then                   ! Gone outside lower index
                     ixl2 = ixland(nxl,lx) + ieg
                     write(unit,*) 'xlandinsert init: ixland outside local domain i=',lbound(xtx,1),':',ubound(xtx,1),   &
                                   ' Changing index from ', ixland(nxl,lx) ,' to ', ixl2
                     ixland(nxl,lx) = ixl2
                  else if ( ixl > ubound(xtx,1) ) then             ! Gone outside upper index
                     ixl2 = ixland(nxl,lx) - ieg
                     write(unit,*) 'xlandinsert init: ixland outside local domain i=',lbound(xtx,1),':',ubound(xtx,1),   &
                                   ' Changing index from ', ixland(nxl,lx) ,' to ', ixl2
                     ixland(nxl,lx) = ixl2
                  endif
                  if(.not. on_processor(nxl, lx)) then
                    write(unit,*) 'xlandinsert init?: ixl =', ixl, ' Bounds ',isc+Dom%ioff-xland_halo,':',iec+Dom%ioff+xland_halo
                    error_xland(nxl)=.true.
                  endif
               endif
             enddo
         endif
      enddo
  endif

  do nxl=1,nxland

     ! check for attempts to connect land rather than sea
     do lx = 1,2
        if(on_comp_domain(nxl, lx)) then
            ixl = ixland(nxl,lx)-Dom%ioff
            jxl = jxland(nxl,lx)-Dom%joff
            if (kxland(nxl,2) > Grid%kmt(ixl,jxl)) then
                write (unit,192) nxl, kxland(nxl,2), ixland(nxl,lx),jxland(nxl,lx),Grid%kmt(ixl,jxl)
                error_xland(nxl)=.true.
            endif
        endif
     enddo

     ! write out summary information for this pair of crossland points
     if (kxland(nxl,1) == 1) then
        ztop = 0.0
     else
        ztop = Grid%zw(kxland(nxl,1)-1)
     endif

     if(at_least_one_in_comp_domain(nxl)) then
         ixl  = ixland(nxl,1)-Dom%ioff
         jxl  = jxland(nxl,1)-Dom%joff
         ixl2 = ixland(nxl,2)-Dom%ioff
         jxl2 = jxland(nxl,2)-Dom%joff
         if(verbose_init) then 
             write(unit,191) nxl, ixland(nxl,1), jxland(nxl,1) &
              ,xtx(ixl,jxl), ytx(ixl,jxl) &
              ,ixland(nxl,2), jxland(nxl,2) &
              ,xtx(ixl2,jxl2), ytx(ixl2,jxl2) &
              ,kxland(nxl,1), kxland(nxl,2), ztop, Grid%zw(kxland(nxl,2)), &
               tauxland(nxl) 
         endif 
     endif

  enddo

  ! Bring model down here if there are problems with xlandinsert points.  
  do nxl=1,nxland
    if(error_xland(nxl)) then
      call mpp_error(FATAL, &
      '==>Error detected in ocean_xlandinsert_mod: Use "grep -i error" to find ALL errors.')
    endif 
  enddo 

  ! register for diag_manager 
  allocate (id_xland(num_prog_tracers))
  id_xland = -1

  do n=1,num_prog_tracers
     if(T_prog(n)%name == 'temp') then 
         id_xland(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xlandinsert', &
                       Grd%tracer_axes(1:3), Time%model_time, 'xlandinsert*cp*rho*dzt*temp',     &
                      'Watt/m^2', missing_value=missing_value, range=(/-1.e10,1.e10/))
     else
         id_xland(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xlandinsert', &
                       Grd%tracer_axes(1:3), Time%model_time,                                    &
                      'xlandinsert*rho*dzt*tracer for '//trim(T_prog(n)%name),                   &
                      trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))
     endif
  enddo

  call watermass_diag_init(Time, Dens)

191 format(/' ===== from ocean_xlandinsert_init ====='/                            &
       ' for crossland sea connection pair number',i3,/                            &
       ' mix  (i,j) gridpoint (',i4,',',i4,') [long=',f8.3,' lat=',f8.3,']',/      &
       ' with (i,j) gridpoint (',i4,',',i4,') [long=',f8.3,' lat=',f8.3,']',/      & 
       ' from level',i3,' to',i3,' [depths of ',f10.3,' to ',f10.3,'m]', /         &
       ' Time scale for insertion via upwind advection is (sec) ',f12.6 /) 
192 format(/'=>Error: Problem with crossland insertion: improper k-levels requested.'/&
       'kxland(',i2,',2) =',i4, ' exceeds kmt(',i4,',',i4,') = ',i4)
991 format(/'=>Error: problem with crossland tracer insertion:',/,                 &
       ' out of bounds i grid location requested'/  &
       '      ixland(',i4,',',i1,') was set incorrectly set to = ',i8,/)
992 format(/'=>Error: problem with crossland tracer insertion:',/,                 &
       ' out of bounds j-row grid location requested'/ &
       '      jxland(',i4,',',i1,') was set incorrectly set to = ',i8,/)
993 format(/'=>Error: problem with crossland tracer insertion:',/,                 &
       ' out of bounds k-level grid location requested'/ &
       '      kxland(',i4,',',i1,') was set incorrectly set to = ',i8,/)
994 format(/'=>Error: problem with crossland tracer insertion:',/,                 &
       ' improper k-values requested'/' kxland(',i3,',1)=',i5,                     &
       ' and is not less than or equal to kxland(',i3,',2)=',i5,/)

end subroutine ocean_xlandinsert_init
! </SUBROUTINE> NAME="ocean_xlandinsert_init"



!#######################################################################
! <SUBROUTINE NAME="xlandinsert">
!
! <DESCRIPTION>
! Compute thickness and density weighted tracer source 
! [(kg/m^3)*tracer*m/s] and mass source (kg/m^3)*(m/s)
! associated with discharge of tracer from surface of a 
! thick column into a set of boxes within a thin column. 
!
! NOTE:
! Compute rho_dzt_x as if using a geopotential model, since the  
! xlandinsert rates are typically first tuned with geopotential models.
! also, we wish to have the transport proportional to differences in 
! eta_t, which for zstar and pstar are generally must larger than 
! differences in dzt.  
!
! Modified by Keith.Dixon (January 2004) 
!
! Modified by Stephen.Griffies for general 
! vertical coordinates January 2005 and August 2006.
!
! </DESCRIPTION>
!
subroutine xlandinsert (Time, Ext_mode, Dens, Thickness, T_prog)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_external_mode_type), intent(in)    :: Ext_mode
  type(ocean_density_type),       intent(in)    :: Dens
  type(ocean_thickness_type),     intent(inout) :: Thickness
  type(ocean_prog_tracer_type),   intent(inout) :: T_prog(:)

  ! tracer concentration on stack
  real, dimension(isc-xland_halo:iec+xland_halo,jsc-xland_halo:jec+xland_halo,kxland_min:kxland_max,num_prog_tracers) :: tracerx    

  real, dimension(nxland,0:2) :: top_rho_dzt   
  real, dimension(nxland,2)   :: area       
  real, dimension(nxland,2)   :: mass     
  real, dimension(nxland)     :: rho_dzt_new_large
  real, dimension(nxland)     :: rho_dzt_new_small

  real  :: thkocean    ! thickness of column over which we insert seawater 
  real  :: delta(nk)   ! fraction inserted into a cell 

  real  :: tracernew(nk)
  real  :: blanda, tracerextra, zextra, zinsert
  real  :: tottracer_thin, tottracer_thick 
  real  :: totrate_thin, totrate_thick 

  integer :: i, j, k, nxl, nz
  integer :: tau
  integer :: n
  integer :: lx
  integer :: lx_thin(max(1,nxland))
  integer :: lx_thick(max(1,nxland))

  if (.not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error in ocean_xlandinsert_mod (xlandinsert): module must be initialized')
  endif

  if (nxland < 1) return
  if (.not. use_this_module) return

  tau   = Time%tau

! tracer independent computations

  xland_rho_dzt(:,:) = 0.0
  rho_dzt_x(:,:)     = 0.0
  tracerx(:,:,:,:)   = 0.0

  if(xland_halo > Dom%xhalo .or. xland_halo > Dom%yhalo) then 
     rho_dzt_x(isc:iec,jsc:jec) = rho0*(Grd%dzt(1)+ext_mode%eta_t(isc:iec,jsc:jec,tau))
     call mpp_update_domains (rho_dzt_x(:,:), Xland_domain%domain2d)
     do n=1,num_prog_tracers
        do k=1,kxland_max
           do j=jsc,jec
              do i=isc,iec
                 tracerx(i,j,k,n) = T_prog(n)%field(i,j,k,tau)
              enddo
           enddo
        enddo
     enddo
     call mpp_update_domains (tracerx(:,:,:,:), Xland_domain%domain2d)
  else
     rho_dzt_x(:,:) =  rho0*(Grd%dzt(1)+ext_mode%eta_t(:,:,tau))
     do n=1,num_prog_tracers
        do k=1,kxland_max
           tracerx(:,:,k,n) = T_prog(n)%field(:,:,k,tau)
        enddo
     enddo
  endif

  do nxl=1,nxland 

     ! calculate only if at least one point in the pair is on the comp-domain  
     if(at_least_one_in_comp_domain(nxl)) then  

         ! geometric factors      
         do lx=1,2
            ixl                 = ixland(nxl,lx)-Dom%ioff
            jxl                 = jxland(nxl,lx)-Dom%joff
            top_rho_dzt(nxl,lx) = rho_dzt_x(ixl,jxl) 
            area(nxl,lx)        = datx(ixl,jxl) 
            mass(nxl,lx)        = top_rho_dzt(nxl,lx)*area(nxl,lx) 
         enddo
         if(top_rho_dzt(nxl,1) > top_rho_dzt(nxl,2)) then 
             lx_thick(nxl) = 1
             lx_thin(nxl)  = 2
         else 
             lx_thick(nxl) = 2
             lx_thin(nxl)  = 1
         endif

         ! transfer rate
         top_rho_dzt(nxl,0)            = (mass(nxl,1) + mass(nxl,2))/(area(nxl,1) + area(nxl,2))
         water_rate(nxl,lx_thick(nxl)) = (top_rho_dzt(nxl,lx_thick(nxl))-top_rho_dzt(nxl,0))*tauxlandr(nxl)
         water_rate(nxl,lx_thin(nxl))  = (top_rho_dzt(nxl,0)-top_rho_dzt(nxl,lx_thin(nxl))) *tauxlandr(nxl)

         if(debug_this_module) then 
           write(*,*)' ' 
           write(*,*)'For xlandinsert pair                    = ',nxl 
           write(*,*)'top_rho_dzt(',lx_thick(nxl),') (kg/m^2) = ',top_rho_dzt(nxl,lx_thick(nxl)),'   (nxl=',nxl,')'
           write(*,*)'top_rho_dzt(',lx_thin(nxl),') (kg/m^2)  = ',top_rho_dzt(nxl,lx_thin(nxl)),'   (nxl=',nxl,')'
           write(*,*)'top_rho_dzt( 0 ) (kg/m^2)               = ',top_rho_dzt(nxl,0),'   (nxl=',nxl,')'
           write(*,*)'water_rate_thin   (kg/m^3)*(m/s)        = ',water_rate(nxl,lx_thin(nxl)),'   (nxl=',nxl,')'
           write(*,*)'water_rate_thick  (kg/m^3)*(m/s)        = ',water_rate(nxl,lx_thick(nxl)),'   (nxl=',nxl,')'
           write(*,*)'area_thin         (m^2)          = ',area(nxl,lx_thin(nxl)),'   (nxl=',nxl,')'
           write(*,*)'area_thick        (m^2)          = ',area(nxl,lx_thick(nxl)),'   (nxl=',nxl,')'
           write(*,*) &
            '{[area*water_rate](thick) - [area*water_rate](thin)}/(area(thin)+area(thick)) (kg/m^3)*(m/s) = ', &
             ( water_rate(nxl,lx_thin(nxl))*area(nxl,lx_thin(nxl))    &
              -water_rate(nxl,lx_thick(nxl))*area(nxl,lx_thick(nxl))) &
               /(area(nxl,lx_thin(nxl)) + area(nxl,lx_thick(nxl))),'   (nxl=',nxl,')'
             write(*,*) &
             ' >> check mass rates (thin)  ', water_rate(nxl,lx_thin(nxl))*area(nxl,lx_thin(nxl)),' (nxl=',nxl,')'
             write(*,*) &
             ' >> check mass rates (thick) ', water_rate(nxl,lx_thick(nxl))*area(nxl,lx_thick(nxl)),' (nxl=',nxl,')'
             write(*,*)' Insert ',water_rate(nxl,lx_thin(nxl))*dtime*area(nxl,lx_thin(nxl)),'kg', &
                       ' of water over ',dtime,' sec timestep   (nxl=',nxl,')'

             if(on_comp_domain(nxl,lx_thick(nxl))) then
                write(*,*)' the thick point is on the computational domain (nxl=',nxl,')'
             else
                write(*,*)' the thick point is NOT on the computational domain (nxl=',nxl,')'
             endif
             if(on_comp_domain(nxl,lx_thin(nxl))) then
                write(*,*)' the thin  point is on the computational domain (nxl=',nxl,')'
             else
                write(*,*)' the thin  point is NOT on the computational domain (nxl=',nxl,')'
             endif

         endif

! compute tendency to remove water from region of more mass to 
! region with less mass.
!
! xland_rho_dzt is added to Thickness%mass_source
!
! rho_dzt_new_large is the estimated tau+1 value of rho_dzt if
! the xland_insert adjustment was the only process contributing
! to the tendency
!
! note that the more massive side can be associated with more that one xland pair,
! so the tendency is accumulated.  Also, this is only calculated if the massive 
! side is a computational point.
         
         lx=lx_thick(nxl) 
         if(on_comp_domain(nxl,lx)) then
             ixl = ixland(nxl,lx)-Dom%ioff
             jxl = jxland(nxl,lx)-Dom%joff
             xland_rho_dzt(ixl,jxl) = xland_rho_dzt(ixl,jxl) - water_rate(nxl,lx)
             rho_dzt_new_large(nxl) = rho_dzt_x(ixl,jxl) - dtime*water_rate(nxl,lx)

             if(debug_this_module) then
               write(*,*) ' BEFORE: (thick) rho_dzt=',rho_dzt_x(ixl,jxl),' (nxl=',nxl,')'
               write(*,*) ' BEFORE: (thick) sfc mass=',(area(nxl,lx)*top_rho_dzt(nxl,lx)),' (nxl=',nxl,')'
               write(*,*) ' >> check sfc mass above =', mass(nxl,lx),' (nxl=',nxl,')'
               write(*,*) ' PREDICT: (thick) mass shift per timestep=',(-water_rate(nxl,lx)*area(nxl,lx)*dtime), &
                            ' (nxl=',nxl,')'
               write(*,*) ' PREDICT: rho_dzt_new_large=', rho_dzt_new_large(nxl), &
                            ' (nxl=',nxl,')'
               write(*,*) ' PREDICT: (thick) sfc mass(tau+1)=',( area(nxl,lx)* &
                                     (top_rho_dzt(nxl,lx)-(water_rate(nxl,lx)*dtime)) ), ' (nxl=',nxl,')'
             endif

         endif

! compute tendency to add water to region of less mass from region of more mass.
!
! xland_rho_dzt is added to Thickness%mass_source
!
! rho_dzt_new_small is the estimated tau+1 value of rho_dzt if
! the xland_insert adjustment was the only process contributing
! to the tendency
!
! note that the less massive side can be associated with more that one xland pair,
! so the tendency is accumulated.  Also, this is only calculated if the less massive 
! side is a computational point.
         
         lx = lx_thin(nxl)
         if(on_comp_domain(nxl,lx)) then
             ixl = ixland(nxl,lx)-Dom%ioff
             jxl = jxland(nxl,lx)-Dom%joff
             xland_rho_dzt(ixl,jxl) = xland_rho_dzt(ixl,jxl) + water_rate(nxl,lx)
             rho_dzt_new_small(nxl) = rho_dzt_x(ixl,jxl) + dtime*water_rate(nxl,lx_thin(nxl))

             if(debug_this_module) then
               write(*,*) ' BEFORE: (thin)  rho_dzt=',rho_dzt_x(ixl,jxl),' (nxl=',nxl,')'
               write(*,*) ' BEFORE: (thin)  sfc mass=',(area(nxl,lx)*top_rho_dzt(nxl,lx)),' (nxl=',nxl,')'
               write(*,*) ' PREDICT: (thin)  mass shift per timestep= ',(water_rate(nxl,lx)*area(nxl,lx)*dtime), &
                          ' (nxl=',nxl,')'
               write(*,*) ' PREDICT: rho_dzt_new_small =', rho_dzt_new_small(nxl), &
                            ' (nxl=',nxl,')'
               write(*,*) ' PREDICT: (thin)  sfc mass(tau+1)=',(area(nxl,lx)* &
                                     (top_rho_dzt(nxl,lx)+(water_rate(nxl,lx)*dtime))), ' (nxl=',nxl,')'
             endif
         endif

     endif ! end of at_least_one_in_comp_domain(nxl) if-test 

  enddo  ! end of the nxland do-loop 


  ! do the tracers 
  do n=1,num_prog_tracers

     wrk1(:,:,:)    = 0.0

     ! loop over nxland pairs 
     do nxl=1,nxland 

        ! perform calculations only if at least one point in the pair is on comp-domain  
        if(at_least_one_in_comp_domain(nxl)) then  

            ! remove tracer from top of the thick column via upwind advection  
            lx=lx_thick(nxl) 
            k =1                                ! kxland(nxl,1)=1 for xlandinsert  
            blanda = 0.0
            if(on_comp_domain(nxl,lx)) then
                ixl = ixland(nxl,lx)-Dom%ioff
                jxl = jxland(nxl,lx)-Dom%joff
                blanda = -1.0*water_rate(nxl,lx)*tracerx(ixl,jxl,k,n)
                wrk1(ixl,jxl,k) = wrk1(ixl,jxl,k) + blanda

                if(debug_this_module) then
                  ! let totrate_thick keep track of the mass weighted tendency of the tracer content and
                  ! tottracer_thick keep track of the total tracer content
                  tottracer_thick = tracerx(ixl,jxl,k,n)*top_rho_dzt(nxl,lx)*area(nxl,lx)
                  totrate_thick   = blanda*area(nxl,lx)
                  write(*,*)' ' 
                  write(*,*) 'BEFORE: tracer value = ',tracerx(ixl,jxl,k,n), &
                             '(nxl=',nxl,' tracer#=',n,' k=',k,' thick)'
                  write(*,*) 'BEFORE: thick mass  = ',(top_rho_dzt(nxl,lx)*area(nxl,lx)),' = ',&
                              top_rho_dzt(nxl,lx),'*',area(nxl,lx), &
                             '(nxl=',nxl,' tracer#=',n,' k=',k,' thick)'
                  write(*,*) 'BEFORE: tottracer_thick = ',tottracer_thick, &
                             '(nxl=',nxl,' tracer#=',n,' k=',k,')'
                  write(*,*) 'xland_insert totrate_thick = ',totrate_thick, &
                             '(nxl=',nxl,' tracer#=',n,' k=',k,' thick)'
                  write(*,*) 'PREDICT AFTER: thick mass   = ', area(nxl,lx) * &
                              ( top_rho_dzt(nxl,lx) - (water_rate(nxl,lx)*dtime) ),' (nxl=',nxl,' tracer#=',n,')'
                  write(*,*) 'PREDICT AFTER: tottracer_thick = ',( tracerx(ixl,jxl,k,n) * area(nxl,lx) * &
                              ( top_rho_dzt(nxl,lx) - (water_rate(nxl,lx)*dtime) ) ),' (nxl=',nxl,' tracer#=',n,')'
                endif

            endif

            lx = lx_thin(nxl)
            if(on_comp_domain(nxl,lx)) then

                nz   = kxland(nxl,2)             ! kxland(nxl,2) is the deepest insertion level
                ixl  = ixland(nxl,lx)  -Dom%ioff
                jxl  = jxland(nxl,lx)  -Dom%joff
                ixl2 = ixland(nxl,3-lx)-Dom%ioff
                jxl2 = jxland(nxl,3-lx)-Dom%joff

                ! compute fraction inserted into each thin grid cell                
                thkocean = 0.0
                do k=1,nz
                   thkocean = thkocean + Thickness%rho_dzt(ixl,jxl,k,tau)
                enddo
                do k=1,nz
                   delta(k) = Thickness%rho_dzt(ixl,jxl,k,tau)/(epsln+thkocean)
                enddo

                if(debug_this_module) then 
                    tottracer_thin = 0.0
                    do k=1,nz
                       if (k.eq. 1) then
                         write(*,*) k, tracerx(ixl,jxl,k,n), tracerx(ixl2,jxl2,k,n), ' (nxl=',nxl,' tracer#=',n,')' &
                             ,' thin Thickness%rho_dzt =',Thickness%rho_dzt(ixl,jxl,k,tau)
                       else
                         write(*,*) k, tracerx(ixl,jxl,k,n), '       (nxl=',nxl,' tracer#=',n,')' &
                             ,' thin Thickness%rho_dzt =',Thickness%rho_dzt(ixl,jxl,k,tau)
                       endif
                       ! for tottracer_thin, add in tracer content of destination (thin) column k-levels
                       tottracer_thin  =  tottracer_thin + &
                         ( tracerx(ixl,jxl,k,n)*Thickness%rho_dzt(ixl,jxl,k,tau)*area(nxl,lx) )
                    enddo
                    write(*,*)' Does Thickness%rho_dzt(ixl,jxl,1,tau) = ',Thickness%rho_dzt(ixl,jxl,1,tau), &
                              ' = ',top_rho_dzt(nxl,lx),' = top_rho_dzt(xnl,lx) ?', &
                           '(nxl=',nxl,' tracer#=',n,')'
                    write(*,*)' BEFORE xland_insert: tottracer_thin = ',tottracer_thin, &
                              ' (nxl=',nxl,' tracer#=',n,')'
                    write(*,*)' ' 
                    write(*,*)' tracernew(k) = ((tracerextra*zextra) +', &
                              '  (tracerx(ixl,jxl,k,n)*Thickness%rho_dzt(ixl,jxl,k,tau)) +', &
                              '  (tracerx(ixl2,jxl2,1,n)*zinsert) )', &
                              ' / (zextra +  Thickness%rho_dzt(ixl,jxl,k,tau) + zinsert)'
                endif

! Insert tracer into thin column by doing an xland_insert adjustment process.
! and then diagnose the effective tendencies from the tau+1 - tau timelevel values.
! Start at the bottom (k=nz) of the destination (thin) column and compute what the 
! tracer value would be at the end of the timestep if xland_insert was the only 
! process contributing to the tracer tendency. Then move up the thin column, one 
! k-level at a time, and at each k-level from k=nz-1 up to k=1 compute what the updated
! tracer value would be accounting for both the insertion of the water from the top of
! the thick column +and+ the bubbling up of the excess mass of water from the level
! below. When the process is done, compare the updated tracer values with the current
! tracer values and convert back into a tendency.

! zextra is the vertical thickness of the excess water bubbling up from the
!        layer below due to the accumulated effects of xland_insert
! tracerextra is the tracer value at the tau+1 time step of the water bubbling
!        up from the layer below
! zinsert is the surface height change that will occur due to xland_insert
!        at the thin (destination) point over the course of this tracer timestep.
! tracernew would be the tau+1 time level tracer value value if the xland_insert
!        adjustment was the only process contributing to the tendencies

                zextra = 0.0

                do k=nz,1,-1

                  tracernew(k) = 0.0 

                  if (k .EQ. nz) then
                    tracerextra = 0.0
                  else
                    tracerextra = tracernew(k+1)
                  endif
                  zinsert = water_rate(nxl,lx)*dtime*delta(k)
                  tracernew(k) = ((tracerextra*zextra) + &
                                  (tracerx(ixl,jxl,k,n)*Thickness%rho_dzt(ixl,jxl,k,tau)) + &
                                  (tracerx(ixl2,jxl2,1,n)*zinsert) ) &
                               / (zextra +  Thickness%rho_dzt(ixl,jxl,k,tau) + zinsert)

                  if(debug_this_module) then 
                      write(*,*)' k=',k, tracernew(k),'   (nxl=',nxl,' tracer#=',n,')'
                      write(*,*)'[nxl=',nxl,'] ',tracernew(k),' = ((',tracerextra,'*',zextra,') +'
                      write(*,*)'[nxl=',nxl,']  (',tracerx(ixl,jxl,k,n),'*',Thickness%rho_dzt(ixl,jxl,k,tau),') +'
                      write(*,*)'[nxl=',nxl,']  (',tracerx(ixl2,jxl2,1,n),'*',zinsert,') )'
                      write(*,*)'[nxl=',nxl,'] / (',zextra,' + ',Thickness%rho_dzt(ixl,jxl,k,tau),' + ',zinsert,')' 
                  endif

                  zextra = zextra + zinsert                  

                enddo

                if(debug_this_module) then 
                  write(*,*)' ' 
                  write(*,*) ' CHECK:   (thin)  sfc mass(tau+1)=',area(nxl,lx)*rho_dzt_new_small(nxl), &
                             ' (nxl=',nxl,')'
                  write(*,*) ' CHECK:   (thin) Does zextra =',zextra,' = ', &
                             '(rho_dzt_new_small(nxl) - rho_dzt_x(ixl,jxl)) = ',(rho_dzt_new_small(nxl) - rho_dzt_x(ixl,jxl)), &
                             '(dtime*water_rate(nxl,lx_thin(nxl)))=',(dtime*water_rate(nxl,lx_thin(nxl)))
 
                  ! accumulate tottracer_thin at tau+1 
                  tottracer_thin = 0.0
                  tottracer_thin =  tracernew(1)*area(nxl,lx)* &
                                    (Thickness%rho_dzt(ixl,jxl,1,tau)-rho_dzt_x(ixl,jxl)+rho_dzt_new_small(nxl))
                  if(debug_this_module) then 
                    write(*,*) ' >nxl=',nxl,' tracer#=',n,') tottracer_thin = ', tottracer_thin,' = '
                    write(*,*) ' >nxl=',nxl,'  ',tracernew(1),'*',area(nxl,lx),'*'
                    write(*,*) ' >nxl=',nxl,' (',Thickness%rho_dzt(ixl,jxl,1,tau),'-',rho_dzt_x(ixl,jxl),&
                               '+',rho_dzt_new_small(nxl),')'
                    write(*,*) ' >nxl=',nxl,' which is [',(Thickness%rho_dzt(ixl,jxl,1,tau)-rho_dzt_x(ixl,jxl)&
                               +rho_dzt_new_small(nxl)),']'
                  endif
                  do k=1,nz
                     write(*,*) k, tracernew(k), tracerx(ixl2,jxl2,k,n)
                     if (k .NE. 1) then
                       tottracer_thin   = tottracer_thin   + &
                         (tracernew(k)*area(nxl,lx)*Thickness%rho_dzt(ixl,jxl,k,tau))
                       if(debug_this_module) then 
                         write(*,*) ' >nxl=',nxl,' tottracer_thin = ', tottracer_thin,' = tottracer_thin'
                         write(*,*) ' >nxl=',nxl,' (',tracernew(k),'*',area(nxl,lx),'*',Thickness%rho_dzt(ixl,jxl,k,tau),')'
                       endif
                     endif
                  enddo
                  write(*,*)'  AFTER xland_insert: tottracer_thin = ',tottracer_thin, &
                              ' (nxl=',nxl,' tracer#=',n,')'
                endif

                ! convert change in tracer amounts between tau a tau+1 timesteps
                !  into tendencies and store into the wrk1 array
                blanda = 0.0

                do k=1,nz

                  if (k .eq. 1) then
                     blanda = ( ( tracernew(1)*(Thickness%rho_dzt(ixl,jxl,1,tau)-rho_dzt_x(ixl,jxl)+rho_dzt_new_small(nxl)) )  &
                              - ( tracerx(ixl,jxl,1,n)*Thickness%rho_dzt(ixl,jxl,1,tau) ) )/dtime
                   else
                     blanda = Thickness%rho_dzt(ixl,jxl,k,tau)*(tracernew(k) - tracerx(ixl,jxl,k,n))/dtime
                   endif
                     wrk1(ixl,jxl,k) = wrk1(ixl,jxl,k) + blanda

                   if (debug_this_module) then 
                     if (k .eq. 1) then
                       totrate_thin = 0.0
                     endif
                     totrate_thin = totrate_thin + (blanda*area(nxl,lx))
                     write(*,*) 'xland_insert tendency = ',blanda,'(nxl=',nxl,' tracer#=',n,' k=',k,' thin)'
                   endif

                end do

                if (debug_this_module) then 
                  write(*,*) ' '
                  write(*,*) 'xland_insert totrate_thin  = ',totrate_thin , &
                             '(nxl=',nxl,' tracer#=',n,' thin )'
                endif

            endif ! end of on_comp_domain

        endif ! end of at_least_one_in_comp_domain(nxl)

     enddo  ! end of nxland 


     ! fill tendency array 
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + wrk1(i,j,k)
           enddo
        enddo
     enddo

     ! send diagnostics 
     if(id_xland(n) > 0) then 
        call diagnose_3d(Time, Grd, id_xland(n), T_prog(n)%conversion*wrk1(:,:,:))
     endif

     ! for watermass diagnostics 
     if(n==index_temp) then 
         theta_tend(:,:,:) = 0.0
         do k=1,nk
            do j=jsc,jec   
               do i=isc,iec
                  theta_tend(i,j,k) = wrk1(i,j,k)
               enddo
            enddo
         enddo
     endif
     if(n==index_salt) then 
         salt_tend(:,:,:) = 0.0
         do k=1,nk
            do j=jsc,jec   
               do i=isc,iec
                  salt_tend(i,j,k) = wrk1(i,j,k)
               enddo
            enddo
         enddo
     endif


  enddo ! end of num_prog_tracers do-loop 

  ! fill mass source array 
  call xlandinsert_mass(Time, Thickness)

  ! call some diagnostics 
  call watermass_diag(Time, Dens)


end subroutine xlandinsert
! </SUBROUTINE> NAME="xlandinsert"


!#######################################################################
! <SUBROUTINE NAME="xlandinsert_mass">
!
! <DESCRIPTION>
! Compute the mass source (kg/m^3)*meter/sec. 
!
! Note that xlandinsert has already been called, so xland_rho_dzt 
! has been filled.  
! </DESCRIPTION>
!
subroutine xlandinsert_mass (Time, Thickness)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(inout) :: Thickness
  integer                                   :: i,j
 
  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_xlandinsert_mod (xlandinsert_mass): module must be initialized')
  endif 

  do j=jsc,jec
     do i=isc,iec     
        Thickness%mass_source(i,j,1) = Thickness%mass_source(i,j,1) + xland_rho_dzt(i,j)
     enddo
  enddo

  call mpp_update_domains (Thickness%mass_source(:,:,1), Dom%domain2d)

  call diagnose_2d(Time, Grd, id_xland_rho_dzt, xland_rho_dzt(:,:))

end subroutine xlandinsert_mass
! </SUBROUTINE> NAME="xlandinsert_mass"


!#######################################################################
! <FUNCTION NAME="at_least_one_in_comp_domain">
!
! <DESCRIPTION>
! Function to see if at least one of the two points in a crossland pair
! is within the computational domain for the processor. 
! </DESCRIPTION>
!
! <IN NAME="nxl" TYPE="integer">
! Integer labeling the particular xlandinsert pair
! </IN>
!
function at_least_one_in_comp_domain(nxl)

  integer, intent(in) :: nxl
  integer             :: lx
  logical             :: in_domain(2), at_least_one_in_comp_domain

  do lx=1,2
    if(isc+Dom%ioff <= ixland(nxl,lx) .and. ixland(nxl,lx) <= iec+Dom%ioff .and. &
       jsc+Dom%joff <= jxland(nxl,lx) .and. jxland(nxl,lx) <= jec+Dom%joff) then
       in_domain(lx) = .true.
    else 
       in_domain(lx) = .false.  
    endif
  enddo

  at_least_one_in_comp_domain = .false.
  if(in_domain(1) .and. in_domain(2)     ) at_least_one_in_comp_domain = .true.
  if(in_domain(1) .and. .not.in_domain(2)) at_least_one_in_comp_domain = .true.
  if(.not.in_domain(1) .and. in_domain(2)) at_least_one_in_comp_domain = .true.


end function at_least_one_in_comp_domain 
! </FUNCTION> NAME="at_least_one_in_comp_domain"



!#######################################################################
! <FUNCTION NAME="on_comp_domain">
!
! <DESCRIPTION>
! Determine if the point is in comp-domain for the processor
! </DESCRIPTION>
!
! <IN NAME="nxl" TYPE="integer">
! Integer labeling the particular xlandinsert pair
! </IN>
! <IN NAME="lx" TYPE="integer">
! lx=1,2 labels the point within an xlandinsert pair
! </IN>
!
function on_comp_domain(nxl, lx)

  integer, intent(in) :: nxl, lx
  logical             :: on_comp_domain

  if(isc+Dom%ioff <= ixland(nxl,lx) .and. ixland(nxl,lx) <= iec+Dom%ioff .and. &
     jsc+Dom%joff <= jxland(nxl,lx) .and. jxland(nxl,lx) <= jec+Dom%joff) then
     on_comp_domain = .true.
  else 
     on_comp_domain = .false.  
  endif

end function on_comp_domain
! </FUNCTION> NAME="on_comp_domain"

!#######################################################################
! <FUNCTION NAME="on_processor">
!
! <DESCRIPTION>
! Determine if the point is on processor
! </DESCRIPTION>
!
function on_processor(nxl, lx)

  integer, intent(in) :: nxl, lx
  logical             :: on_processor

  if(isc+Dom%ioff-xland_halo <= ixland(nxl,lx) .and. ixland(nxl,lx) <= iec+Dom%ioff+xland_halo .and. &
     jsd+Dom%joff-xland_halo <= jxland(nxl,lx) .and. jxland(nxl,lx) <= jed+Dom%joff+xland_halo) then
     on_processor = .true.
  else
     on_processor = .false.
  endif

end function on_processor
! </FUNCTION> NAME="on_processor"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag_init">
!
! <DESCRIPTION>
! Initialization of watermass diagnostic output files. 
! </DESCRIPTION>
!
subroutine watermass_diag_init(Time, Dens)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens

  integer :: stdoutunit
  stdoutunit=stdout()
  compute_watermass_diag = .false. 

  id_neut_rho_xinsert = register_diag_field ('ocean_model', 'neut_rho_xinsert',&
    Grd%tracer_axes(1:3), Time%model_time,                                     &
   'update of locally ref potrho from xlandinsert',                            &
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_xinsert > 0) compute_watermass_diag = .true. 

  id_neut_rho_xinsert_on_nrho = register_diag_field ('ocean_model',                    &
   'neut_rho_xinsert_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,             &
   'update of locally ref potrho from xlandinsert as binned to neutral density layers',&
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_xinsert_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_rho_xinsert = register_diag_field ('ocean_model', 'wdian_rho_xinsert',&
    Grd%tracer_axes(1:3), Time%model_time,                                       &
    'dianeutral mass transport due to xlandinsert',                              &
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_xinsert > 0) compute_watermass_diag = .true. 

  id_wdian_rho_xinsert_on_nrho = register_diag_field ('ocean_model',                &
   'wdian_rho_xinsert_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,         &
   'dianeutral mass transport from xlandinsert as binned to neutral density layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_xinsert_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_rho_xinsert = register_diag_field ('ocean_model',  &
   'tform_rho_xinsert', Grd%tracer_axes(1:3), Time%model_time,&
   'watermass transform from xlandinsert',                    &
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_xinsert_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_rho_xinsert_on_nrho = register_diag_field ('ocean_model',          &
   'tform_rho_xinsert_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,   &
   'watermass transform from xlandinsert as binned to neutral density layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_xinsert_on_nrho > 0) compute_watermass_diag = .true. 

  id_eta_tend_xinsert= -1          
  id_eta_tend_xinsert= register_diag_field ('ocean_model','eta_tend_xinsert',&
       Grd%tracer_axes(1:2), Time%model_time,                                &
       'non-Bouss steric sea level tendency from xinsert tendency', 'm/s',   &
       missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_xinsert > 0) compute_watermass_diag=.true.

  id_eta_tend_xinsert_glob= -1          
  id_eta_tend_xinsert_glob= register_diag_field ('ocean_model', 'eta_tend_xinsert_glob',&
       Time%model_time,                                                                 &
       'global mean non-bouss steric sea level tendency from xinsert tendency',         &
       'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_xinsert_glob > 0) compute_watermass_diag=.true.

 
  ! temperature effects
  id_neut_temp_xinsert = register_diag_field ('ocean_model', 'neut_temp_xinsert',&
    Grd%tracer_axes(1:3), Time%model_time,                                       &
   'temp related update of locally ref potrho from xlandinsert',                 &
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_xinsert > 0) compute_watermass_diag = .true. 

  id_neut_temp_xinsert_on_nrho = register_diag_field ('ocean_model',                                &
   'neut_temp_xinsert_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                         &
   'temp related update of locally ref potrho from xlandinsert as binned to neutral density layers',&
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_xinsert_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_temp_xinsert = register_diag_field ('ocean_model', 'wdian_temp_xinsert',&
    Grd%tracer_axes(1:3), Time%model_time,                                         &
    'temp related dianeutral mass transport due to xlandinsert',                   &
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_xinsert > 0) compute_watermass_diag = .true. 

  id_wdian_temp_xinsert_on_nrho = register_diag_field ('ocean_model',                            &
   'wdian_temp_xinsert_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                     &
   'temp related dianeutral mass transport from xlandinsert as binned to neutral density layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_xinsert_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_temp_xinsert = register_diag_field ('ocean_model',  &
   'tform_temp_xinsert', Grd%tracer_axes(1:3), Time%model_time,&
   'temp related watermass transform from xlandinsert',        &
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_xinsert_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_temp_xinsert_on_nrho = register_diag_field ('ocean_model',                      &
   'tform_temp_xinsert_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,               &
   'temp related watermass transform from xlandinsert as binned to neutral density layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_xinsert_on_nrho > 0) compute_watermass_diag = .true. 


  ! salinity effects
  id_neut_salt_xinsert = register_diag_field ('ocean_model', 'neut_salt_xinsert',&
    Grd%tracer_axes(1:3), Time%model_time,                                       &
   'salt related update of locally ref potrho from xlandinsert',                 &
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_xinsert > 0) compute_watermass_diag = .true. 

  id_neut_salt_xinsert_on_nrho = register_diag_field ('ocean_model',                                &
   'neut_salt_xinsert_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                         &
   'salt related update of locally ref potrho from xlandinsert as binned to neutral density layers',&
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_xinsert_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_salt_xinsert = register_diag_field ('ocean_model', 'wdian_salt_xinsert',&
    Grd%tracer_axes(1:3), Time%model_time,                                         &
    'salt related dianeutral mass transport due to xlandinsert',                   &
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_xinsert > 0) compute_watermass_diag = .true. 

  id_wdian_salt_xinsert_on_nrho = register_diag_field ('ocean_model',                            &
   'wdian_salt_xinsert_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                     &
   'salt related dianeutral mass transport from xlandinsert as binned to neutral density layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_xinsert_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_salt_xinsert = register_diag_field ('ocean_model',  &
   'tform_salt_xinsert', Grd%tracer_axes(1:3), Time%model_time,&
   'salt related watermass transform from xlandinsert',        &
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_xinsert_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_salt_xinsert_on_nrho = register_diag_field ('ocean_model',                      &
   'tform_salt_xinsert_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,               &
   'salt related watermass transform from xlandinsert as binned to neutral density layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_xinsert_on_nrho > 0) compute_watermass_diag = .true. 

  allocate(theta_tend(isd:ied,jsd:jed,nk))
  allocate(salt_tend(isd:ied,jsd:jed,nk))
  theta_tend(:,:,:) = 0.0
  salt_tend(:,:,:)  = 0.0


  if(compute_watermass_diag) then 
    write(stdoutunit,'(/a/)') &
    '==>Note: running ocean_xlandinsert_mod w/ compute_watermass_diag=.true.'  
  endif 


end subroutine watermass_diag_init
! </SUBROUTINE> NAME="watermass_diag_init"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag">
!
! <DESCRIPTION>
! Diagnose effects from xlandinsert on watermass transformation.  
! </DESCRIPTION>
!
subroutine watermass_diag(Time, Dens)

  type(ocean_time_type),          intent(in) :: Time
  type(ocean_density_type),       intent(in) :: Dens

  integer :: i,j,k,tau
  real, dimension(isd:ied,jsd:jed) :: eta_tend

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_xlandinsert (watermass_diag): module needs initialization ')
  endif 

  if(.not. compute_watermass_diag) return 

  tau = Time%tau

  ! full effects from temperature and salinity 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodT(i,j,k)*theta_tend(i,j,k) &
                        +Dens%drhodS(i,j,k)*salt_tend(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
           wrk5(i,j,k) =-wrk1(i,j,k)/(epsln+Dens%rho(i,j,k,tau)**2)  ! for eta_tend 
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_xinsert, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_xinsert, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_xinsert, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_xinsert_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_xinsert_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_xinsert_on_nrho, wrk4)

  if(id_eta_tend_xinsert > 0 .or. id_eta_tend_xinsert_glob > 0) then
      eta_tend(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               eta_tend(i,j) = eta_tend(i,j) + wrk5(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_eta_tend_xinsert, eta_tend(:,:))
      call diagnose_sum(Time, Grd, Dom, id_eta_tend_xinsert_glob, eta_tend, cellarea_r)
  endif


  ! effects from temperature
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodT(i,j,k)*theta_tend(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_xinsert, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_xinsert, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_temp_xinsert, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_xinsert_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_xinsert_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_xinsert_on_nrho, wrk4)

  ! effects from salinity 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodS(i,j,k)*salt_tend(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_xinsert, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_xinsert, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_salt_xinsert, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_xinsert_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_xinsert_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_xinsert_on_nrho, wrk4)
 
end subroutine watermass_diag
! </SUBROUTINE>  NAME="watermass_diag"


end module ocean_xlandinsert_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: cosp_rttov_simulator.F90,v 20.0 2013/12/13 23:15:49 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

!
! History:
! Aug 2008 - V. John - Initial version
! Feb 2009 - V. John - Trace gases and max number of profiles
!


!#include "cosp_defs.h"
#ifndef COSP_GFDL
#include "cosp_defs.h"
#endif
MODULE MOD_COSP_RTTOV_SIMULATOR
  USE MOD_COSP_CONSTANTS
  USE MOD_COSP_TYPES
#ifdef RTTOV
  USE MOD_COSP_RTTOV
#endif
  IMPLICIT NONE

CONTAINS


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINE COSP_RTTOV_SIMULATOR ---------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_RTTOV_SIMULATOR(gbx,y)
  
  ! Arguments
  type(cosp_gridbox),intent(in)  :: gbx ! Gridbox info
  type(cosp_rttov),intent(inout) :: y   ! RTTOV output
  
  ! some local variables for profile conversions etc.
  real, parameter :: eps    =  0.622
  real, parameter :: Mdry   =  28.966
  real, parameter :: Mo3    =  47.9983
  real, parameter :: Mco2   =  44.0096
  real, parameter :: Mch4   =  16.0426
  real, parameter :: Mn2o   =  44.0129
  real, parameter :: Mco    =  28.0102
  integer, parameter :: MaxLim  =  100
  
  ! Local variables 
  integer :: Npoints
  real :: sh(gbx%Npoints, gbx%Nlevels)
  real :: pp(gbx%Npoints, gbx%Nlevels)
  real :: tt(gbx%Npoints, gbx%Nlevels)
  real :: o3(gbx%Npoints, gbx%Nlevels)

  real :: co2,ch4,n2o,co
  real :: tt_surf(gbx%Npoints) ! 1.5 m T
  real :: sh_surf(gbx%Npoints) ! 1.5 m q 
  integer :: nloop,rmod,il
  integer :: istart,istop
  integer :: nprof,nlevels
    
  Nlevels = gbx%Nlevels
  Npoints = gbx%Npoints
  ! Reverting Levels from TOA to surface
  sh  = gbx%sh(:,Nlevels:1:-1) 
  pp  = gbx%p(:,Nlevels:1:-1) / 100.
  tt  = gbx%t(:,Nlevels:1:-1) 
  o3  = gbx%mr_ozone(:,Nlevels:1:-1)
  
  ! FIXME: 1.5 m T and q should be added to input
  tt_surf  =  tt(:, Nlevels)
  sh_surf  =  sh(:, Nlevels)
  
  !Converting Specific Humidity to PPMV
  sh  =  ( sh / ( sh + eps * ( 1. - sh ) ) ) * 1e6

  !Converting Mass mixing ratio of other trace gases to ppmv
  o3   =  ( Mdry / Mo3  ) *     o3  * 1e6
  co2  =  ( Mdry / Mco2 ) * gbx%co2 * 1e6
  ch4  =  ( Mdry / Mch4 ) * gbx%ch4 * 1e6  
  n2o  =  ( Mdry / Mn2o ) * gbx%n2o * 1e6
  co   =  ( Mdry / Mco  ) * gbx%co  * 1e6
  
  !! RTTOV can handle only about 100 profiles at a time (FIXME: Check this with Roger) 
  !! So we are putting a loop of 100 
  
  nloop  =  Npoints / MaxLim
  rmod   =  MOD( Npoints, MaxLim )
  
  if( rmod .ne. 0 ) then  
     nloop = nloop + 1
  endif
  
  !! looping over MaxLim number of profiles
  do il = 1, nloop
     istart  =  (il - 1) * MaxLim + 1
     istop   =  min(il * MaxLim, Npoints) 
     
     if( ( il .eq. nloop ) .and. ( rmod .ne. 0 ) ) then
        nprof   =  rmod
     else
        nprof   =  MaxLim
     endif
          
#ifdef RTTOV
     call  rttov_multprof(              &
          gbx%Nchan,                    &
          gbx%ichan,                    &
          gbx%surfem,                   &
          nprof,                        &
          Nlevels,                      &
          gbx%Plat,                     &
          gbx%Sat,                      &
          gbx%Inst,                     &
          gbx%ZenAng,                   &
          pp(istart:istop, :),          &
          tt(istart:istop, :),          &
          sh(istart:istop, :),          &
          o3(istart:istop, :),          &
          co2,                          &
          ch4,                          &
          n2o,                          &
          co,                           &
          gbx%sfc_height(istart:istop), &
          gbx%u_wind(istart:istop),     &
          gbx%v_wind(istart:istop),     &
          gbx%skt(istart:istop),        &
          gbx%psfc(istart:istop)/100.,  &
          tt_surf(istart:istop),        &
          sh_surf(istart:istop),        &
          gbx%land(istart:istop),       &
          gbx%latitude(istart:istop),   &
          y%tbs(istart:istop, :) )
#endif
  enddo
  
END SUBROUTINE COSP_RTTOV_SIMULATOR

END MODULE MOD_COSP_RTTOV_SIMULATOR

module bgrid_diagnostics_mod

!-----------------------------------------------------------------------

use       bgrid_horiz_mod, only: horiz_grid_type
use        bgrid_vert_mod, only: vert_grid_type, compute_pres_full,  &
                                 compute_pres_half, compute_pres_depth
use       bgrid_masks_mod, only: grid_mask_type
use    bgrid_prog_var_mod, only: prog_var_type
use bgrid_change_grid_mod, only: change_grid, TEMP_GRID, WIND_GRID

use      diag_manager_mod, only: diag_axis_init, register_diag_field, &
                                 register_static_field, send_data
use      time_manager_mod, only: time_type

use            fms_mod, only: file_exist, open_namelist_file,    &
                              error_mesg, NOTE, check_nml_error, &
                              mpp_pe, mpp_root_pe, stdlog,       &
                              close_file, write_version_number
use      constants_mod, only: GRAV, KAPPA, RDGAS
use  field_manager_mod, only: MODEL_ATMOS
use tracer_manager_mod, only: get_tracer_names, get_number_tracers



implicit none
private

public :: bgrid_diagnostics_init, &
          bgrid_diagnostics,      &
          bgrid_diagnostics_tend

!-----------------------------------------------------------------------
!------------------------- axis names ----------------------------------

character(len=8) :: axiset = 'dynamics'
character(len=8) :: mod_name = 'dynamics'

!-----------------------------------------------------------------------

   integer, parameter :: MXTR = 10
   real,    parameter :: GINV = 1./GRAV

!-----------------------------------------------------------------------
! axis and field identifiers for the diag manager

integer :: id_hlonb, id_hlon , id_hlatb, id_hlat , &
           id_vlonb, id_vlon , id_vlatb, id_vlat , &
           id_phalf, id_pfull, id_hlat_wgt, id_vlat_wgt

integer :: id_bk   , id_pk   , id_zsurf, id_res  , id_wspd,          &
           id_ps   , id_ucomp, id_vcomp, id_temp , id_pres_full,     &
           id_omega, id_div  , id_vor  , id_pgfx , id_pgfy,          &
           id_udt  , id_vdt  , id_tdt  , id_pres_half,               &
           id_alm  , id_aph  , id_theta, id_mfew,  id_mfns,  id_slp
integer, allocatable :: id_tracer(:), id_tracer_tend(:)

integer :: id_ucomp_sq, id_vcomp_sq, id_temp_sq, id_omega_sq, &
           id_ucomp_vcomp, id_omega_temp

!-----------------------------------------------------------------------
! need to save surface geopotential height argument to initialization call
! the surface height will be needed for computing sea level pressure
real, pointer, dimension(:,:) :: zsurfg
!-----------------------------------------------------------------------

 character(len=128) :: version = '$Id: bgrid_diagnostics.F90,v 19.0 2012/01/06 19:54:38 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'

!-----------------------------------------------------------------------

contains

!#######################################################################

subroutine bgrid_diagnostics_init ( Time, Hgrid, Vgrid, Var, &
                                    fis, res,                &
                                    mass_axes, vel_axes      )

!-----------------------------------------------------------------------
!             setup/write netcdf metadata and static fields
!-----------------------------------------------------------------------
! Time      = current/initial time
! Hgrid     = horizontal grid constants
! Vgrid     = vertical grid constants
! fis       = geopotential height of the surface
! res       = reciprocal of eta at the surface
! mass_axes = axis identifiers for the temperature (mass) grid
! vel_axes  = axis identifiers for the velocity grid
!   NOTE:  The axes identifiers are for the lon, lat, pfull, and
!       phalf axes, respectively. They are returned by the diag_manager.
!-----------------------------------------------------------------------

   type(time_type),       intent(in)  :: Time
   type(horiz_grid_type), intent(in)  :: Hgrid
   type (vert_grid_type), intent(in)  :: Vgrid
   type  (prog_var_type), intent(in)  :: Var
   real, intent(in), dimension(Hgrid%ilb:,Hgrid%jlb:), target  :: fis, res
   integer, dimension(4), intent(out) :: mass_axes,  vel_axes

!-----------------------------------------------------------------------
      real, dimension(Hgrid%Tmp%isg:Hgrid%Tmp%ieg+1) :: hlonb
      real, dimension(Hgrid%Vel%isg:Hgrid%Vel%ieg+1) :: vlonb
      real, dimension(Hgrid%Tmp%jsg:Hgrid%Tmp%jeg+1) :: hlatb
      real, dimension(Hgrid%Vel%jsg:Hgrid%Vel%jeg+1) :: vlatb

      real, dimension(Hgrid%Tmp%isg:Hgrid%Tmp%ieg) :: hlon
      real, dimension(Hgrid%Vel%isg:Hgrid%Vel%ieg) :: vlon
      real, dimension(Hgrid%Tmp%jsg:Hgrid%Tmp%jeg) :: hlat
      real, dimension(Hgrid%Vel%jsg:Hgrid%Vel%jeg) :: vlat

      real, dimension(Hgrid%Tmp%js:Hgrid%Tmp%je) :: hlat_wgt
      real, dimension(Hgrid%Vel%js:Hgrid%Vel%je) :: vlat_wgt

      real, dimension(1,1)              :: psurf
      real, dimension(1,1,Vgrid%nlev)   :: pfull
      real, dimension(1,1,Vgrid%nlev+1) :: phalf


      real    :: vrange(2), trange(2), prange(2)
      real    :: rad2deg
      integer :: i, j, n, unit, io, ierr, ntprog
      integer :: isg, ieg, hsg, heg, vsg, veg
      integer :: is, ie, hs, he, vs, ve
      integer :: uflx_axes(4), vflx_axes(4)
      integer :: logunit
      logical :: used
      character(len=128) :: tname
      character(len=256) :: longname, units

!--------------------------- set up axes -------------------------------

      ! compute grid indices
      is = Hgrid % Tmp % is;  ie = Hgrid % Tmp % ie
      hs = Hgrid % Tmp % js;  he = Hgrid % Tmp % je
      vs = Hgrid % Vel % js;  ve = Hgrid % Vel % je

      ! global grid indices
      isg = Hgrid % Tmp % isg;  ieg = Hgrid % Tmp % ieg
      hsg = Hgrid % Tmp % jsg;  heg = Hgrid % Tmp % jeg
      vsg = Hgrid % Vel % jsg;  veg = Hgrid % Vel % jeg

      ! grid box boundaries in degrees
      rad2deg = 90./acos(0.0)
      hlonb(isg:ieg+1) = Hgrid % Tmp % blong(isg:ieg+1) * rad2deg
      hlatb(hsg:heg+1) = Hgrid % Tmp % blatg(hsg:heg+1) * rad2deg
      vlonb(isg:ieg+1) = Hgrid % Vel % blong(isg:ieg+1) * rad2deg
      vlatb(vsg:veg+1) = Hgrid % Vel % blatg(vsg:veg+1) * rad2deg

      logunit = stdlog()
      ! grid box centers in degrees
   do i = isg, ieg
      hlon(i) = 0.5*(hlonb(i)+hlonb(i+1))
      vlon(i) = 0.5*(vlonb(i)+vlonb(i+1))
   enddo

   do j = hsg, heg
      hlat(j) = 0.5*(hlatb(j)+hlatb(j+1))
   enddo

   do j = vsg, veg
      vlat(j) = 0.5*(vlatb(j)+vlatb(j+1))
   enddo

  ! compute a reference profile of pressure based on psurf = 1000 hPa
    psurf = reshape ( (/ 100000. /), (/ 1, 1 /) )
    call compute_pres_full (Vgrid, psurf, pfull)
    call compute_pres_half (Vgrid, psurf, phalf)
  ! in units of hPa
    pfull = pfull*0.01
    phalf = phalf*0.01


!----- initialize mass axes ------

 id_hlonb = diag_axis_init ( 'lonb', hlonb, 'degrees_E', 'x',     &
                             'longitude edges', set_name='atmos', &
                             Domain2=Hgrid%Tmp%Domain_nohalo      )

 id_hlon  = diag_axis_init ( 'lon', hlon, 'degrees_E', 'x',       &
                             'longitude', set_name='atmos',       &
                             edges=id_hlonb,                      &
                             Domain2=Hgrid%Tmp%Domain_nohalo      )

 id_hlatb = diag_axis_init ( 'latb', hlatb, 'degrees_N', 'y',     &
                             'latitude edges', set_name='atmos',  &
                             Domain2=Hgrid%Tmp%Domain_nohalo      )

 id_hlat  = diag_axis_init ( 'lat', hlat, 'degrees_N', 'y',       &
                             'latitude', set_name='atmos',        &
                             edges=id_hlatb,                      &
                             Domain2=Hgrid%Tmp%Domain_nohalo      )

!----- initialize velocity axes ------

 id_vlonb = diag_axis_init ( 'vlonb', vlonb, 'degrees_E', 'x',    &
                             'longitude edges', set_name='atmos', &
                             Domain2=Hgrid%Vel%Domain_nohalo      )

 id_vlon  = diag_axis_init ( 'vlon', vlon, 'degrees_E', 'x',      &
                             'longitude', set_name='atmos',       &
                             edges=id_vlonb,                      &
                             Domain2=Hgrid%Vel%Domain_nohalo      )

 id_vlatb = diag_axis_init ( 'vlatb', vlatb, 'degrees_N', 'y',    &
                             'latitude edges', set_name='atmos',  &
                             Domain2=Hgrid%Vel%Domain_nohalo      )

 id_vlat  = diag_axis_init ( 'vlat', vlat, 'degrees_N', 'y',      &
                             'latitude', set_name='atmos',        &
                             edges=id_vlatb,                      &
                             Domain2=Hgrid%Vel%Domain_nohalo      )

!----- initialize vertical axes -----

 id_phalf = diag_axis_init ( 'phalf', phalf(1,1,:), 'hPa', 'z', &
                             'approx half pressure level',      &
                             direction=-1, set_name='atmos'     )

 id_pfull = diag_axis_init ( 'pfull', pfull(1,1,:), 'hPa', 'z', &
                             'approx full pressure level',      &
                             direction=-1, edges=id_phalf,      &
                             set_name='atmos'                   )

!-----------------------------------------------------------------------
!-------- initialize and output variables with no time axis ------------

    mass_axes = (/ id_hlon, id_hlat, id_pfull, id_phalf /)
     vel_axes = (/ id_vlon, id_vlat, id_pfull, id_phalf /)
    uflx_axes = (/ id_vlon, id_hlat, id_pfull, id_phalf /)
    vflx_axes = (/ id_hlon, id_vlat, id_pfull, id_phalf /)

   ! valid range for some fields
     vrange = (/ -400., +400. /)  ! momentum
     trange = (/  100.,  400. /)  ! temperature
     prange = (/ -1., 107500. /)  ! pressure

!-----------------------------------------------------------------------
!---- register static fields -------

  id_bk    = register_static_field ( mod_name, 'bk', (/id_phalf/), &
                        'vertical coordinate sigma value', 'none' )

  id_pk    = register_static_field ( mod_name, 'pk', (/id_phalf/), &
   'vertical coordinate reference pressure value (ak*pref)', 'pascals' )

  id_zsurf = register_static_field ( mod_name, 'zsurf', mass_axes(1:2),&
                                       'surface height', 'm' )

  id_res   = register_static_field ( mod_name, 'res', mass_axes(1:2), &
                     'reciprocal of sigma/eta at the surface', 'none' )

  id_alm   = register_static_field ( mod_name, 'alm', mass_axes(1:2), &
                'actual longitudes for temperature grid', 'degrees_E' )

  id_aph   = register_static_field ( mod_name, 'aph', mass_axes(1:2), &
                 'actual latitudes for temperature grid', 'degrees_N' )

! these changes cannot be implemented until changes to diag_manager
! initialize fields useful for computing offline global averages
!
! id_hlat_wgt = register_static_field ( mod_name, 'lat_wgt',  &
!                 (/id_hlat/), 'latitude weight for mass grid', 'none' )
!
! id_vlat_wgt = register_static_field ( mod_name, 'vlat_wgt',  &
!             (/id_vlat/), 'latitude weight for momentum grid', 'none' )

      if ( id_bk > 0 ) &
      used = send_data ( id_bk, Vgrid%eta, Time )

      if ( id_pk > 0 ) &
      used = send_data ( id_pk, Vgrid%peta, Time )

      if ( id_zsurf > 0 ) &
      used = send_data ( id_zsurf, fis(is:ie,hs:he)*GINV, Time )

      if ( id_res > 0 ) &
      used = send_data ( id_res, res(is:ie,hs:he), Time )

      if ( id_alm > 0 ) &
      used = send_data ( id_alm, Hgrid%Tmp%alm(is:ie,hs:he)*rad2deg, Time )

      if ( id_aph > 0 ) &
      used = send_data ( id_aph, Hgrid%Tmp%aph(is:ie,hs:he)*rad2deg, Time )

!     if ( id_hlat_wgt > 0 ) then
!        hlat_wgt = sin(Hgrid%Tmp%blatg(hs+1:he+1))-sin(Hgrid%Tmp%blatg(hs:he))
!        used = send_data ( id_hlat_wgt, hlat_wgt, Time )
!     endif
!
!     if ( id_vlat_wgt > 0 ) then
!        vlat_wgt = sin(Hgrid%Vel%blatg(vs+1:ve+1))-sin(Hgrid%Vel%blatg(vs:ve))
!        used = send_data ( id_vlat_wgt, vlat_wgt, Time )
!     endif

!---- register non-static fields -------

   id_ps   = register_diag_field ( mod_name, 'ps', mass_axes(1:2), &
                               Time, 'surface pressure', 'pascals' )

   id_slp  = register_diag_field ( mod_name, 'slp', mass_axes(1:2), &
                               Time, 'sea level pressure', 'pascals' )

   id_ucomp = register_diag_field ( mod_name, 'ucomp', vel_axes(1:3), &
                           Time, 'zonal wind component', 'm/sec',     &
                           missing_value=vrange(1), range=vrange      )

   id_vcomp = register_diag_field ( mod_name, 'vcomp', vel_axes(1:3), &
                        Time, 'meridional wind component', 'm/sec',   &
                        missing_value=vrange(1), range=vrange         )

   id_temp = register_diag_field ( mod_name, 'temp', mass_axes(1:3), &
                             Time, 'temperature', 'deg_k',           &
                             missing_value=trange(1), range=trange   )

   id_pres_full = register_diag_field ( mod_name, 'pres_full', mass_axes(1:3), &
                  Time, 'pressure at full model levels', 'pascals',  &
                              missing_value=prange(1), range=prange  )

   ! pressure at half levels
   id_pres_half = register_diag_field ( mod_name, 'pres_half',       &
                             (/ id_hlon, id_hlat, id_phalf /), Time, &
                        'pressure at half model levels', 'pascals',  &
                              missing_value=prange(1), range=prange  )

   id_omega = register_diag_field ( mod_name, 'omega', mass_axes(1:3),&
                                 Time, 'omega vertical velocity',     &
                                 'pascals/sec',                       &
                                 missing_value=-999.                  )

   id_theta = register_diag_field ( mod_name, 'theta', mass_axes(1:3), &
                             Time, 'potential temperature', 'deg_k',   &
                             missing_value=-999.                       )

   id_mfew  = register_diag_field ( mod_name, 'mfew', uflx_axes(1:3),  &
                             Time, 'Zonal mass flux', 'Pa-m2/s',       &
                             missing_value=-1.e30                      )

   id_mfns  = register_diag_field ( mod_name, 'mfns', vflx_axes(1:3),  &
                             Time, 'Meridional mass flux', 'Pa-m2/s',  &
                             missing_value=-1.e30                      )

 !  write version (to log file) 
    call write_version_number(version, tagname)

 ! register diagnostics for all tracers
   allocate (id_tracer(Var%ntrace))
   if (mpp_pe() == mpp_root_pe()) write(logunit,100) trim(mod_name)
   do n = 1, Var%ntrace
     call get_tracer_names ( MODEL_ATMOS, n, tname, longname, units )
     if (mpp_pe() == mpp_root_pe()) write(logunit,110) trim(tname),trim(longname),trim(units)
     id_tracer(n) = register_diag_field ( mod_name, trim(tname),  &
                            mass_axes(1:3), Time, trim(longname), &
                            trim(units), missing_value=-999.      )
   enddo
100 format ('Diagnostics for the following tracer fields are available for module name = ',a)
110 format (3x,a,' (',a,'; ',a,')')

!-------- register second-moment quantities -------
! (for now we are only saving fields on the same grids)

   id_ucomp_sq = register_diag_field ( mod_name, 'ucomp_sq', vel_axes(1:3), &
                           Time, 'zonal wind component squared', 'm2/s2',   &
                           missing_value=-1., range=(/0.,vrange(2)**2/)   )

   id_vcomp_sq = register_diag_field ( mod_name, 'vcomp_sq', vel_axes(1:3), &
                      Time, 'meridional wind component squared', 'm2/s2',   &
                       missing_value=-1., range=(/0.,vrange(2)**2/)   )

   id_temp_sq = register_diag_field ( mod_name, 'temp_sq', mass_axes(1:3), &
                             Time, 'temperature squared', 'deg_K**2',      &
                             missing_value=-1., range=(/0.,trange(2)**2/)  )

   id_omega_sq = register_diag_field ( mod_name, 'omega_sq', mass_axes(1:3),&
                                 Time, 'omega vertical velocity squared',   &
                                 'Pa**2/s**2', missing_value=-999.          )

   id_ucomp_vcomp = register_diag_field ( mod_name, 'ucomp_vcomp', vel_axes(1:3),&
                       Time, 'zonal times meridional wind components', 'm2/s2',  &
                       missing_value=-1. )

   id_omega_temp = register_diag_field ( mod_name, 'omega_temp', mass_axes(1:3),&
                               Time, 'omega vertical velocity time temperature',&
                                 'Pascals*deg_K/sec', missing_value=-999.       )

!-------- wind speed, divergence, vorticity ----------------------------

   id_wspd = register_diag_field ( mod_name, 'wspd', vel_axes(1:3),   &
                       Time, 'wind speed', 'm/s', missing_value=-999.,&
                       range=(/0.,vrange(2)/) )

   id_div  = register_diag_field ( mod_name, 'div', mass_axes(1:3),   &
                       Time, 'divergence', '1/s', missing_value=-999. )

   id_vor  = register_diag_field ( mod_name, 'vor', mass_axes(1:3),   &
               Time, 'relative vorticity', '1/s', missing_value=-999. )

!--------- pressure gradient components (NOT USED) ---------------------

!  id_pgfx = register_diag_field ( mod_name, 'pgfx', vel_axes(1:3), &
!                            Time, 'zonal pressure gradient force', &
!                            'm/s2', missing_value=-999.            )

!  id_pgfy = register_diag_field ( mod_name, 'pgfy', vel_axes(1:3), &
!                       Time, 'meridional pressure gradient force', &
!                       'm/s2', missing_value=-999.                 )

!-----------------------------------------------------------------------
!         -------- tendencies ---------

   id_udt = register_diag_field ( mod_name, 'udt_dyn', vel_axes(1:3),  &
                            Time, 'zonal wind tendency for dynamics', &
                            'm/s2', missing_value=-999. )

   id_vdt = register_diag_field ( mod_name, 'vdt_dyn', vel_axes(1:3),  &
                        Time, 'meridional wind tendency for dynamics', &
                        'm/s2', missing_value=-999. )

   id_tdt = register_diag_field ( mod_name, 'tdt_dyn', mass_axes(1:3), &
                            Time, 'temperature tendency for dynamics', &
                            'deg_k/sec', missing_value=-999. )

 ! tendencies for prognostic tracers only
   call get_number_tracers ( MODEL_ATMOS, num_prog=ntprog )
   allocate (id_tracer_tend(ntprog))
   do n = 1, ntprog
     call get_tracer_names ( MODEL_ATMOS, n, tname, longname, units )
     tname    = trim(tname)   //'_dt_dyn'
     longname = trim(longname)//' tendency for dynamics'
     units    = trim(units)   //'/s'
     if (units == 'none') units = '1/sec'
     if (mpp_pe() == mpp_root_pe()) write(logunit,110) trim(tname),trim(longname),trim(units)
     id_tracer_tend(n) = register_diag_field ( mod_name, trim(tname),  &
                                 mass_axes(1:3), Time, trim(longname), &
                                 trim(units), missing_value=-999.      )
   enddo

 ! save surface geopotential height for computing sea level pressure
   zsurfg => fis

!-----------------------------------------------------------------------

   end subroutine bgrid_diagnostics_init

!#######################################################################

 subroutine bgrid_diagnostics ( Hgrid, Vgrid, Var, Masks, Time, &
                                omega, div, mfew, mfns )

!-----------------------------------------------------------------------
!           write netcdf fields
!-----------------------------------------------------------------------
!  Hgrid  = horizontal grid constants
!  Vgrid  = vertical grid constants
!  Var    = prognostic variables at diagnostics Time
!  Masks  = grid box masks for step-mountain topography
!  Time   = diagnostics time
!  omega  = omega (vertical velocity) diagnostic
!-----------------------------------------------------------------------
type(horiz_grid_type), intent(in) :: Hgrid
type (vert_grid_type), intent(in) :: Vgrid
type (prog_var_type),  intent(in) :: Var
type(grid_mask_type),  intent(in) :: Masks
type(time_type),       intent(in) :: Time
   real, intent(in), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: &
                            omega, div, mfew, mfns

!  real, intent(in), dimension(Hgrid%ilb:,Hgrid%jlb:,:), optional ::&
!                                               div, pgfx, pgfy
                                                       
   real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub) :: slp
   real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub, &
                   Vgrid%nlev) :: wspd, vor, dp, udp, vdp
   real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub, &
                   Vgrid%nlev+1) :: ph
logical, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub, &
                   Vgrid%nlev+1) :: lmask
!-----------------------------------------------------------------------
   integer :: is, ie, hs, he, vs, ve, n, j, k
   logical :: used
!-----------------------------------------------------------------------

      is = Hgrid % Tmp % is;  ie = Hgrid % Tmp % ie
      hs = Hgrid % Tmp % js;  he = Hgrid % Tmp % je
      vs = Hgrid % Vel % js;  ve = Hgrid % Vel % je

!-----------------------------------------------------------------------
!---------------- surface fields ---------------------------------------

      if ( id_ps > 0 ) &
      used = send_data ( id_ps , Var%ps(is:ie,hs:he), Time )

!---------------- 3d momentum fields (u & v) ---------------------------

      if ( id_ucomp > 0 ) &
      used = send_data ( id_ucomp, Var%u(is:ie,vs:ve,:), Time,    &
                         mask=Masks%Vel%mask(is:ie,vs:ve,:) > 0.5 )

      if ( id_vcomp > 0 ) &
      used = send_data ( id_vcomp, Var%v(is:ie,vs:ve,:), Time,    &
                         mask=Masks%Vel%mask(is:ie,vs:ve,:) > 0.5 )

      if ( id_temp > 0 ) &
      used = send_data ( id_temp, Var%t(is:ie,hs:he,:), Time,     &
                         mask=Masks%Tmp%mask(is:ie,hs:he,:) > 0.5 )

      do n = 1, Var%ntrace
        if ( id_tracer(n) > 0 ) &
        used = send_data ( id_tracer(n), Var%r(is:ie,hs:he,:,n), Time, &
                           mask=Masks%Tmp%mask(is:ie,hs:he,:) > 0.5    )
      enddo

      if ( id_omega > 0 ) &
      used = send_data ( id_omega, omega(is:ie,hs:he,:), Time,    &
                         mask=Masks%Tmp%mask(is:ie,hs:he,:) > 0.5 )

      ! pressure at full levels
      ! Note: not computational efficient to recompute pfull
      if ( id_pres_full > 0 ) then
         call compute_pres_full (Vgrid, Var%pssl, dp)
         used = send_data ( id_pres_full, dp(is:ie,hs:he,:), Time,   &
                            mask=Masks%Tmp%mask(is:ie,hs:he,:) > 0.5 )
      endif

      ! pressure at half (interface) levels
      ! Note: not computational efficient to recompute phalf
      if ( id_pres_half > 0 ) then
         call compute_pres_half (Vgrid, Var%pssl, ph)
         lmask(is:ie,hs:he,1) = .true.
         lmask(is:ie,hs:he,2:Vgrid%nlev+1) = Masks%Tmp%mask(is:ie,hs:he,:) > 0.5
         used = send_data ( id_pres_half, ph(is:ie,hs:he,:), Time,   &
                            mask=lmask(is:ie,hs:he,:) )
      endif

     !--- sea level pressure ---
      if ( id_slp > 0 ) then
         if ( id_pres_full <= 0 ) call compute_pres_full (Vgrid, Var%pssl, dp)
         call sea_level_pressure ( Var%ps, zsurfg, dp, Var%t, slp )
         used = send_data ( id_slp, slp(is:ie,hs:he), Time )
      endif

     ! potential temperature (compute pfull if necessary)
      if ( id_theta > 0 ) then
          if ( id_pres_full <= 0 .and. id_slp <= 0 ) call compute_pres_full (Vgrid, Var%pssl, dp)
          dp = Var%t * (1000.e2/dp)**KAPPA
          used = send_data ( id_theta, dp(is:ie,hs:he,:), Time,       &
                             mask=Masks%Tmp%mask(is:ie,hs:he,:) > 0.5 )
      endif

!--------- second moment quantities ----------

      if ( id_ucomp_sq > 0 ) &
      used = send_data ( id_ucomp_sq, Var%u(is:ie,vs:ve,:)**2, Time, &
                         mask=Masks%Vel%mask(is:ie,vs:ve,:) > 0.5 )

      if ( id_vcomp_sq > 0 ) &
      used = send_data ( id_vcomp_sq, Var%v(is:ie,vs:ve,:)**2, Time, &
                         mask=Masks%Vel%mask(is:ie,vs:ve,:) > 0.5 )

      if ( id_temp_sq > 0 ) &
      used = send_data ( id_temp_sq, Var%t(is:ie,hs:he,:)**2, Time, &
                         mask=Masks%Tmp%mask(is:ie,hs:he,:) > 0.5 )

      if ( id_omega_sq > 0 ) &
      used = send_data ( id_omega_sq, omega(is:ie,hs:he,:)**2, Time, &
                         mask=Masks%Tmp%mask(is:ie,hs:he,:) > 0.5 )

      if ( id_ucomp_vcomp > 0 ) used = send_data ( id_ucomp_vcomp, &
                  Var%u(is:ie,vs:ve,:)*Var%v(is:ie,vs:ve,:), Time, &
                         mask=Masks%Vel%mask(is:ie,vs:ve,:) > 0.5 )

      if ( id_omega_temp > 0 ) used = send_data ( id_omega_temp, &
                omega(is:ie,hs:he,:)*Var%t(is:ie,hs:he,:), Time, &
                        mask=Masks%Tmp%mask(is:ie,hs:he,:) > 0.5 )

!------------ wind speed, divergence, vorticity ------------------------

      if ( id_wspd > 0 ) then
          wspd(is:ie,vs:ve,:) = sqrt &
                      ( Var%u(is:ie,vs:ve,:)*Var%u(is:ie,vs:ve,:) + &
                        Var%v(is:ie,vs:ve,:)*Var%v(is:ie,vs:ve,:) )
          used = send_data ( id_wspd, wspd(is:ie,vs:ve,:), Time,      &
                             mask=Masks%Vel%mask(is:ie,vs:ve,:) > 0.5 )
      endif

      if ( id_div > 0 ) then
          used = send_data ( id_div, div(is:ie,hs:he,:), Time,      &
                           mask=Masks%Tmp%mask(is:ie,hs:he,:) > 0.5 )
      endif

      if ( id_vor > 0 ) then
     !if ( id_vor > 0 .or. id_div > 0 ) then
     !--- precompute quantities common to both vor and div ---
         call compute_pres_depth (Vgrid, Var%pssl, dp)
         call change_grid (Hgrid, TEMP_GRID, WIND_GRID, dp, udp)
         vdp = Var%v * udp  ! note: using udp to store dp at vel pts
         udp = Var%u * udp
        !if ( id_vor > 0 ) then
             call compute_vorticity (Hgrid, dp, udp, vdp, vor )
             used = send_data ( id_vor, vor(is:ie,hs:he,:), Time,      &
                              mask=Masks%Tmp%mask(is:ie,hs:he,:) > 0.5 )
        !endif
        !if ( id_div > 0 ) then
        !    call compute_divergence (Hgrid, dp, udp, vdp, div )
        !    used = send_data ( id_div, div(is:ie,hs:he,:), Time,      &
        !                     mask=Masks%Tmp%mask(is:ie,hs:he,:) > 0.5 )
        !endif
      endif

!------- mass fluxes (without topography masks) -----------
      if ( id_mfew > 0 ) then
          used = send_data ( id_mfew, mfew(is:ie,hs:he,:), Time )
      endif
      if ( id_mfns > 0 ) then
          used = send_data ( id_mfns, mfns(is:ie,vs:ve,:), Time )
      endif

!--------------- pressure gradient components --------------------------
!------------------------ NOT USED -------------------------------------

!     if ( id_pgfx > 0 .and. present(pgfx) )  &
!     used = send_data ( id_pgfx, pgfx(is:ie,vs:ve,:), Time,      &
!                        mask=Masks%Vel%mask(is:ie,vs:ve,:) > 0.5 )

!     if ( id_pgfy > 0 .and. present(pgfy) )  &
!     used = send_data ( id_pgfy, pgfy(is:ie,vs:ve,:), Time,      &
!                        mask=Masks%Vel%mask(is:ie,vs:ve,:) > 0.5 )

!-----------------------------------------------------------------------

 end subroutine bgrid_diagnostics

!#######################################################################

 subroutine bgrid_diagnostics_tend ( Hgrid, Var_dt, Masks, Time )

!-----------------------------------------------------------------------
!  Hgrid  = horizontal grid constants
!  Var_dt = prognostic variables tendencies FROM ONLY THE DYNAMICS
!  Masks  = grid box masks for step-mountain topography
!  Time   = diagnostics time
!-----------------------------------------------------------------------
type(horiz_grid_type), intent(in) :: Hgrid
type (prog_var_type),  intent(in) :: Var_dt
type(grid_mask_type),  intent(in) :: Masks
type(time_type),       intent(in) :: Time
!-----------------------------------------------------------------------
   integer :: is, ie, hs, he, vs, ve, n
   logical :: used
!-----------------------------------------------------------------------

      ! compute domain indices
      is = Hgrid % Tmp % is;  ie = Hgrid % Tmp % ie
      hs = Hgrid % Tmp % js;  he = Hgrid % Tmp % je
      vs = Hgrid % Vel % js;  ve = Hgrid % Vel % je

!-----------------------------------------------------------------------
!---------------- 3d prognostic fields ---------------------------

      if ( id_udt > 0 ) &
      used = send_data ( id_udt, Var_dt%u(is:ie,vs:ve,:), Time,    &
                          mask=Masks%Vel%mask(is:ie,vs:ve,:) > 0.5 )

      if ( id_vdt > 0 ) &
      used = send_data ( id_vdt, Var_dt%v(is:ie,vs:ve,:), Time,   &
                         mask=Masks%Vel%mask(is:ie,vs:ve,:) > 0.5 )

      if ( id_tdt > 0 ) &
      used = send_data ( id_tdt, Var_dt%t(is:ie,hs:he,:), Time,   &
                         mask=Masks%Tmp%mask(is:ie,hs:he,:) > 0.5 )

      do n = 1, Var_dt%ntrace
       if ( id_tracer_tend(n) > 0 ) &
       used = send_data ( id_tracer_tend(n), Var_dt%r(is:ie,hs:he,:,n),  &
                          Time, mask=Masks%Tmp%mask(is:ie,hs:he,:) > 0.5 )
      enddo

!-----------------------------------------------------------------------

 end subroutine bgrid_diagnostics_tend

!#######################################################################

 subroutine compute_vorticity ( Hgrid, dp, udp, vdp, vor )

!-----------------------------------------------------------------------
!  Computes relative vorticity on B-grid
!     Hgrid = horizontal grid constants
!     dp    = pressure thickness of model layers at temperature points
!     udp   = zonal wind, u * dp, at velocity points
!     vdp   = meridional wind, v * dp, at velocity points
!     vor   = relative vorticity (1/s) at temperature points
!-----------------------------------------------------------------------
type(horiz_grid_type), intent(in) :: Hgrid
real, intent(in),  dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: dp, udp, vdp
real, intent(out), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: vor

real,dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub) :: &
                          vdy, udx, few, fns
integer :: i, j, k, is, ie, js, je

   is = Hgrid % Tmp % is;  ie = Hgrid % Tmp % ie
   js = Hgrid % Tmp % js;  je = Hgrid % Tmp % je

   do k = 1, size(dp,3)
      do j = js-1, je
         vdy(:,j) = vdp(:,j,k)*Hgrid%Vel%dy
         udx(:,j) = udp(:,j,k)*Hgrid%Vel%dx(j)
      enddo

      do j = js,   je
      do i = is-1, ie
         fns(i,j) = (vdy(i,j-1)+vdy(i,j))*0.5
      enddo
      enddo
      do j = js-1, je
      do i = is,   ie
         few(i,j) = (udx(i-1,j)+udx(i,j))*0.5
      enddo
      enddo

!  ------ vorticity ------
      do j = js, je
      do i = is, ie
         vor(i,j,k)=((fns(i,j)-fns(i-1,j))-(few(i,j)-few(i,j-1))) &
                    /(dp(i,j,k)*Hgrid%Tmp%area(j))
      enddo
      enddo
   enddo

 end subroutine compute_vorticity

!#######################################################################

 subroutine compute_divergence ( Hgrid, dp, udp, vdp, div )

!-----------------------------------------------------------------------
!  Computes divergence on B-grid
!     Hgrid = horizontal grid constants
!     dp    = pressure thickness of model layers at temperature points
!     udp   = zonal wind, u * dp, at velocity points
!     vdp   = meridional wind, v * dp, at velocity points
!     div   = divergence (1/s) at temperature points
!-----------------------------------------------------------------------
type(horiz_grid_type), intent(in) :: Hgrid
real, intent(in),  dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: dp, udp, vdp
real, intent(out), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: div

real,dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub) ::  &
                          udy, vdx, few, fns
integer :: i, j, k, is, ie, js, je

   is = Hgrid % Tmp % is;  ie = Hgrid % Tmp % ie
   js = Hgrid % Tmp % js;  je = Hgrid % Tmp % je

   do k = 1, size(dp,3)
      do j = js-1, je
         udy(:,j) = udp(:,j,k)*Hgrid%Vel%dy
         vdx(:,j) = vdp(:,j,k)*Hgrid%Vel%dx(j)
      enddo

      do j = js,   je
      do i = is-1, ie
         few(i,j) = (udy(i,j-1)+udy(i,j))*0.5
      enddo
      enddo
      do j = js-1, je
      do i = is,   ie
         fns(i,j) = (vdx(i-1,j)+vdx(i,j))*0.5
      enddo
      enddo

!  ------ divergence ------
      do j = js, je
      do i = is, ie
         div(i,j,k)=((few(i,j)+fns(i,j))-(few(i-1,j)+fns(i,j-1))) &
                    /(dp(i,j,k)*Hgrid%Tmp%area(j))
      enddo
      enddo
   enddo

 end subroutine compute_divergence

!#######################################################################

 subroutine sea_level_pressure ( psurf, zsurf, pfull, tfull, slp )

 real, intent(in),  dimension(:,:)   :: psurf, zsurf
 real, intent(in),  dimension(:,:,:) :: pfull, tfull
 real, intent(out), dimension(:,:)   :: slp

! psurf = surface pressure
! zsurf = surface geopotential height in meters^2/sec^2
! pfull = pressure at full model levels
! tfull = temperature at full model levels
! slp   = sea level pressure in pascals

 integer :: i, j, k, kr
 real    :: sig, tbot

 real, parameter :: TLAPSE = 6.5e-3
 real, parameter :: GORG = GRAV/(RDGAS*TLAPSE)
 real, parameter :: MRGOG = -1./GORG

     do j = 1, size(psurf,2)
     do i = 1, size(psurf,1)

        if ( abs(zsurf(i,j)) > 0.0001 ) then

            !---- get ref level for temp ----
             do k = 1, size(tfull,3)
                sig = pfull(i,j,k)/psurf(i,j)
                if ( sig > 0.8 ) then
                     kr = k
                     exit
                endif
             enddo

             tbot = tfull(i,j,kr) * sig ** MRGOG
             slp(i,j) =  psurf(i,j) * ( 1.0 + TLAPSE * zsurf(i,j) / (tbot*GRAV) ) ** GORG
        else
             slp(i,j) = psurf(i,j)
        endif
     enddo
     enddo

 end subroutine sea_level_pressure

!#######################################################################

end module bgrid_diagnostics_mod

module MO_FASTJX_MOD
!----------------------------------------------------------------------
!       FAST-JX Photolysis rate 
!       Revised by Junfeng Liu
!       
!       Feb 19, 2010
!       Junfeng.Liu
!----------------------------------------------------------------------
!         Below is the original information from FASTJX code
!
!  >>>>>>>>>>>>>>>>current code revised to JX ver 6.4 (8/08)<<<<<<<<<<<<
!                                                                       
! version 6.4                                                           
! >>>> allows for shortened, speeded up troposphere versions<<<<<<      
!     STD:           W_=18                                              
!        identical results to v-6.2 if cloud OD is consistent           
!     TROP-ONLY:     W_=12                                              
!        collapses the wavelength bins from 18 to 12 (5-6-7-8 & 11-18)  
!        drops many 'stratospheric' cross-sections (denoted by 'x' in 2n
!        allows use of single standard spectral data set:  FJX_spec.dat 
!        results close to W_=18, largest difference is J-O2 (<1% in 13-1
!        This is recommended as accurate for troposphere only calculatio
!     TROP-QUICK:    W_=8                                               
!        reverts to original fast-J 7-bins (12-18) plus 1 scaled UV (5) 
!        errors in 12-18 km range for J-O2, high sun are 10%, worse abov
!     ***Photolysis of O2 in the upper tropical troposphere is an import
!        source of O3.  It needs to be included in tropospheric runs.   
!        TROP-ONLY is recommended, W_=8 is a quick fix if speed essentia
!                                                                       
!     Major rewrite of code to minimize calls and allow better vector-ty
!     loop over wavelengths internal to Mie soln.                       
!     Driven by profiling of CTM code, may still need optimization.     
!     Wavelengths can be contracted to W_=12 (trop only) and strat-only 
!        X-sections are dropped.  With parm W_=18, the std fast-JX is re
!     Many call eliminated and summations in BLKSLV and GEN_ID are expli
!     GEN_ID replaces GEN and calculates all matrix coeff's (1:L_) at on
!     RD_XXX changed to collapse wavelengths & x-sections to Trop-only: 
!           WX_ = 18 (parm_CTM.f) should match the JX_spec.dat wavelengt
!           W_ = 12 (Trop-only) or 18 (std) is set in (parm_MIE.f).     
!       if W_=12 then drop strat wavels, and drop x-sects (e.g. N2O, ...
!                                                                       
! version 6.3                                                           
!     revise cloud/aerosol OD & wavelength properties for CTM link:     
!         OPTICL is new sub for cloud optical properties, but it        
!              now starts with cloud OD @ 600 nm and cloud NDX          
!              fast-JX now uses cloud NDX to scale OD to other wavelengt
!         OPTICA & OPTICM are new subs to convert aerosol path (g/m2) to
!              A is std UCI scat data                                   
!              M is U Michigan data tables for aerosols, includes Rel Hu
!     drop sub GAUSSP and put into Parameter statement (parm_MIE.f)     
!                                                                       
! version 6.2                                                           
!     corrects a long-standing problem at SZA > 89 degrees.             
!     In prior versions the ray-tracing of the path (and air-mass functi
!     back to the sun was done at the edges of the CTM layers (it was de
!     for the grid-point J-value code at Harvard/GISS/UCI).  This left t
!     interpolation to the mid-layer (needed for J's) open.  The prior m
!     gave irregular fluctuations in the direct solar beam at mid-layer 
!     large SZA > 88.  This is now corrected with exact ray-tracing from
!     the mid-pt of each CTM layer.  For small SZA, there is no effectiv
!     difference, for large SZA, results could be erratic.              
!                                                                       
!   v-6.2 fix should be easy if you have migrated to v6.1, else some min
!      caution may be needed:                                           
!      replace sub SPHERE with SPHERE2, AMF2 report factors for mid and 
!      replace sub OPMIE with new OPMIE, this uses the new AMF2 correctl
!      replace sub PHOTOJ with new PHOTOJ, this just hands off AMF2 from
!            SPHERE2 to OPMIE.                                          
!                                                                       
! version 6.1 adds                                                      
!      6.1b simplifies calling sequences feeds solar factor, albedo, to 
!         and read LAT, LNG directly.  No substantive changes.          
!      new read-in of scat data for clouds/aerosols to allow for UMich d
!      This has required substantial rewrite of some of the core subrout
!         OPMIE is now called for each wavelength and without aersol/clo
!              all subs below OPMIE are unchanged                       
!         OPTICD & OPTICM are new subs to convert path (g/m2) to OD and 
!              D is std UCI scat data (re-ordered for clouds 1st)       
!              M is U Michigan data tables for aerosols, includes Rel Hu
!         PHOTOJ now assembles the aerosol data (better for CTM implemen
!      This version can reproduce earlier versions exactly, but the test
!         is changed from OD and NDX to PATH (g/m2) and NDX.            
!                                                                       
! version 6.0 adds                                                      
!      new 200-nm scattering data so that stratospheric aerosols can be 
! version 5.7                                                           
!     adds the new flux diagnostics (including heating rates)           
!        accurate fluxes for spherical atmos and SZA > 90 !             
!     recommend geometric delta-tau factor from 1.18 to 1.12 for more ac
!        heating rates (but more layers!)                               
!     tuned and corrected to be almost flux conserving (1.e-5), except  
!        deep clouds, where diffusive flux is created (1.e-4)           
!     still needs to return to the original 1970-code for the block-tri 
!        after extensive profiling with F95 and 'modern' versions       
!        it was found that they are much more expensive!!!              
!     corrects typo in JAC(2000) fast-J paper on I+ (reflected from l.b.
!        I+(lb) = refl/(1+refl) * (4*Integ[j(lb)*mu*dmu] + mu0*Fdirect(l
! version 5.6 adds                                                      
!      clean up problems with thick clouds does correct solar attenuatio
!        into cloud sub-layers and into the mid-point of the CTM level  
!      New calculated upward and downward FLUXES at each wavelength at T
!      Correct deposition of solar flux in each CTM layer (spherical)   
!        awaits new diagnostics of the h's for heating rates.           
!      back to old matrix solver (UCI blocksolver and matinv-4)         
! version 5.5 adds                                                      
!      new code for generating and solving the block tri-diagonal scatte
!           problem.  Uses single call to GEM and general 4x4 block-tri 
! version 5.3c adds                                                     
!      calculates reflected UV-vis solar energy (relative to 1.0)       
!      new solar spectrum (J-O2 increases in strat by 10%, J-NO by 15+%)
!                                                                       
! version 5.3b changes include:                                         
!      new data files for specral Xsection and mie-scattering.          
!      add sub-layers (JXTRA) to thick cloud/aerosol layers,            
!           sets up log-spaced sub-layers of increasing thickness ATAU  
!      correction 'b' does massive clean up of the linking code,        
!           now the only subroutine that has access to CTM arrays is PHO
!           Also, the access to the cmn_JVdat.f is 'read-only' after ini
!           This should enable safe openMP/MPI coding.                  
!                                                                       
! common files and what they mean:                                      
!   parm_CTM.f  dimensions & params for code (CTM and fast-JX)          
!   parm_MIE.f  dimensions for mie code variables.                      
!   cmn_metdat.f  CTM 3-D arrays, time of day, grid,  etc.              
!   cmn_JVdat.f   Xsects, Mie, etc., (initialized and then read-only)   
!                                                                       
!<<<<<<<<<<<<<<<<<<<<<begin CTM-specific subroutines<<<<<<<<<<<<<<<<<<<<
! subroutines:                                                          
!                                                                       
!   SET_ATM(GMTAU)                                                      
!           set ups atmosphere (p,T,O3,airmass, etc) for time GMTAU     
!              COMMON BLOCKS: cmn_metdat.f                              
!                                                                       
!   SET_AER(GMTAU)                                                      
!              set ups aerosols for time GMTAU = DUMMY                  
!                                                                       
!   SET_CLD(GMTAU)                                                      
!           set ups clouds for time GMTAU = DUMMY                       
!                                                                       
!   INPHOT                                                              
!           Init. photolysis rate, called once by CHMSET                
!              COMMON BLOCKS: cmn_metdat.f, cmn_JVdat.f                 
!              Input files: ECT42_grid.dat                              
!                                                                       
!   RD_JS(NJ1,NAMFIL)                                                   
!           Read labels of photo. rates, called once by INPHOT.         
!              COMMON BLOCKS: cmn_metdat.f, cmn_JVdat.f                 
!              Input files: chem_Js.dat                                 
!                                                                       
!   RD_PROF(NJ2,NAMFIL)                                                 
!           Read T & O3 climatology, called once by INPHOT.             
!              COMMON BLOCKS: cmn_metdat.f                              
!              Input files: atmos_std.dat                               
!                                                                       
!   SET_CLD0(TINIT,CLDP,NCLD,ALBEDO)                                    
!              Initialize cloud and surface properties, called by MAIN. 
!              COMMON BLOCKS: cmn_metdat.f                              
!                                                                       
!   SET_AER0 (AER1,AER2, NAA1,NAA2)                                     
!              Iniitalize (climatology) aerosol OD and types (3 arrays) 
!              COMMON BLOCKS: cmn_metdat.f                              
!                                                                       
!   SET_ATM0                                                            
!             Initialize climatologies for T & O3, set up atmospheric pr
!              COMMON BLOCKS: cmn_metdat.f                              
!                                                                       
!<<<<<<<<<<<<<<<<<<<<<begin CTM-fastJX linking subroutines<<<<<<<<<<<<<<
!                                                                       
!   PHOTOJ(UTIME,IDAY,ILNG,JLAT,SOLF,SZA,U0,FREFL,ZPJ)                  
!              Gateway to fast-JX, Update the photolysis rates          
!              COMMON BLOCKS: cmn_metdat.f, cmn_JVdat.f                 
!                                                                       
!<<<<<<<<<<<<<<<<<<<<<begin core fast-J subroutines<<<<<<<<<<<<<<<<<<<<<
!  N.B. all these need access to cmn_JVdat.f, but do NOT write into it. 
!           also have no need to access cmn_metdat.f                    
!                                                                       
!   OPTICL (OPTD,SSALB,SLEG, ODCLD,NDCLD)                               
!        UCI CLOUD data sets, calculate scattering properties,          
!           scales OD at 600 nm to JX wavelength                        
!              COMMON BLOCKS: cmn_JVdat.f                               
!                                                                       
!   OPTICA (OPTD,SSALB,SLEG, PATH,RELH,L)                               
!   OPTICM (OPTD,SSALB,SLEG, PATH,RELH,L)                               
!         UC Irvine & U Michigan aerosol data sets, generates fast-JX da
!              COMMON BLOCKS: cmn_JVdat.f                               
!                                                                       
!   JRATET(PPJ,TTJ,FFF, VALJL)                                          
!           Calculate J-value, called by PTOTOJ.                        
!              COMMON BLOCKS: cmn_JVdat.f                               
!                                                                       
!   JP_ATM(PPJ,TTJ,DDJ,ZZJ,ZHL,ZZHT,DTAUX,POMEGAX,JXTRA)                
!              print out atmosphere used in J-value calc.               
!              >>>will be superseded by CTM routines                    
!              COMMON BLOCKS: cmn_JVdat.f                               
!                                                                       
!   RD_XXX(NJ1,NAMFIL)                                                  
!           Read wavelength bins, solar fluxes, Rayleigh, Temp-dep X-sec
!           >>>v-6.4 now collapse to Trop-only Wl's and Xs's if W_=12   
!              called once by INPHOT.                                   
!              COMMON BLOCKS: cmn_JVdat.f                               
!              Input files: FJX_spec.dat                                
!                                                                       
!   RD_MIE(NJ1,NAMFIL)                                                  
!           Set aerosols/cloud scattering, called once by INPHOT        
!              COMMON BLOCKS: cmn_JVdat.f                               
!              Input files: FJX_scat.dat                                
!                                                                       
!   RD_UM(NJ1,NAMFIL)                                                   
!           UMich aerosol optical data, called once by INPHOT           
!              COMMON BLOCKS: cmn_JVdat.f                               
!              Input files: FJX_UMaer.dat                               
!                                                                       
!   SOLARZ(GMTIME,NDAY,YGRDJ,XGRDI, SZA,COSSZA,SOLFX)                   
!     SOLARZ(GMTIME,NDAY,YGRDJ,XGRDI, SZA,COSSZA,SOLFX)                 
!              calc SZA and Solar Flux factor for given lat/lon/UT      
!                                                                       
!   SPHERE2(GMU,RAD,ZHL,ZZHT,AMF2,L1_)                                  
!              calculate spherical geometry, air-mass factors (v 6.2)   
!                                                                       
!   EXTRAL(DTAUX,L1X,L2X,NX,JTAUMX,ATAU,ATAU0, JXTRA)                   
!              add sub-layers (JXTRA) to thick cloud/aerosol layers     
!                                                                       
!   OPMIE (DTAUX,POMEGAX,U0,RFL,AMF2,JXTRA,FJACT,FJTOP,FJBOT,FSBOT,FJFLX
!              calculate mean intensity (actinic) at each CTM levels    
!              calculate fluxes and deposition (heating rates)          
!              COMMON BLOCKS: cmn_JVdat.f                               
!                                                                       
!<<<<<<<<<<<<<<<<<<<<<<<begin core scattering subroutines<<<<<<<<<<<<<<<
!                                                                       
!   MIESCT(FJ,FJT,FJB, POMEGA,FZ,ZTAU,ZFLUX,RFL,U0,ND)                  
!            include 'parm_MIE.f' = dimension parameters                
!                                                                       
!   LEGND0 (X,PL,N)                                                     
!                                                                       
!   BLKSLV (FJ,POMEGA,FZ,ZTAU,ZFLUX,RFL,PM,PM0,FJTOP,FJBOT,ND)          
!                                                                       
!   GEN_ID(POMEGA,FZ,ZTAU,ZFLUX,RFL,PM,PM0,B,CC,AA,A,H,C,ND)            
!                                                                       
!   MATINW (B,A)                                                        
!                                                                       
!-----------------------------------------------------------------------
      use              fms_mod, only : file_exist,              &
                                       write_version_number,    &
                                       mpp_pe,                  &
                                       mpp_root_pE,             &
                                       close_file,              &
                                       stdlog,                  &
                                       mpp_clock_begin, mpp_clock_end, &
                                       mpp_clock_id, CLOCK_MODULE, &
                                       check_nml_error, error_mesg, &
                                       open_namelist_file, FATAL
      use           mpp_io_mod, only : mpp_open, mpp_close, MPP_RDONLY, &
                                       MPP_ASCII, MPP_SEQUENTIAL,   &
                                       MPP_MULTI, MPP_SINGLE 

      implicit none
      
      private
      public :: fastjx_init, fastjx_end, fastjx_photo, JVN_

!-----------------------------------------------------------------------
!     version number and tagname.
!-----------------------------------------------------------------------
      character(len=128)            :: version     = '$Id: mo_fastjx.F90,v 20.0 2013/12/13 23:24:59 fms Exp $'
      character(len=128)            :: tagname     = '$Name: tikal $'

!    include 'parm_CTM.f'  for fast-JX code v5.3+ (prather 6/05)
!
!     I_ = longitude dim of CTM grid
!     J_ = latitude  dim of CTM grid
!     L_ = altitude(levels) dim of CTM grid
!     LWE_ = altitude(level) dim for trop processes (clouds, rain)
!     JVL_ = vertical(levels) dim for J-values
!     L2_  = 2*L1_ = 2*L_ + 2 = no. levels in the basic Fast-JX grid (mid-level_
!     JVN_ =  no. of J-values
!     W_   = dim = no. of Wavelength bins   (now in parm_MIE.f)
!     WX_  = dim = no. of wavelengths in input file
!     X_   = dim = no. of X-section data sets (input data)
!     A_   = dim = no. of Aerosol/cloud Mie sets (input data)
!     MX   = no. of aerosol/cloud types supplied from CTM
!     NTR_ = no. of CTM tracers
!     SZAMAX    Solar zenith angle cut-off, above which to skip calculation
!
!-----------------------------------------------------------------------
!      integer, parameter               ::      I_      =128            !longitude dim of CTM grid
!      integer, parameter               ::      J_      =64             !latitude  dim of CTM grid
      integer, parameter                ::      L_      =48             !altitude(levels) dim of CTM grid
!      integer, parameter               ::      LWE_    =37             !altitude(level) dim for trop processes (clouds, rain)
      integer, parameter                ::      JVL_    =48             !vertical(levels) dim for J-values
      integer, parameter                ::      L1_     =L_+1           !assuming another layer above the top layer
      integer, parameter                ::      L2_     =2*L_+2         !2*L1_ = 2*L_ + 2 = no. levels in the basic Fast-JX grid (mid-level_ 
!      integer, parameter               ::      MX      =4              !no. of aerosol/cloud types supplied from CTM, no use
!      integer, parameter               ::      NTR_    =1              !no. of CTM tracers, is O3 here
      real*8,  parameter                ::      SZAMAX  =98.0d0         !Solar zenith angle cut-off, above which to skip calculation
      integer, parameter                ::      WX_     =18             !dim = no. of wavelengths in input file
      integer, parameter                ::      X_      =64             !dim = no. of X-section data sets (input data)
      integer, parameter                ::      A_      =40             !dim = no. of Aerosol/cloud Mie sets (input data)
      integer, parameter                ::      A_AM3   =1000           !dim = no. of Aerosol/cloud Mie sets FOR AM3(input data)     
      integer, parameter                ::      JVN_    =62             !no. of J-values
!----------------------------------------------------------------------- 
!    include 'parm_mie.f'  for fast-JX code v5.3+ (prather 6/05)
!
!     N_  = no. of levels in Mie scattering arrays
!         = 2*NC+1 = 4*LPAR + 5 + 2*sum(JADDLV)
!     M_  = no. of Gauss points used, must = 4 in fast_JX (no option)
!     M2_ = 2*M_ = 8, replaces MFIT
!     W_   = dim = no. of Wavelength bins:  =18 std, =12 trop only
!
!-----------------------------------------------------------------------
      integer, parameter                ::      N_      =501            !no. of levels in Mie scattering arrays
                                                                        != 2*NC+1 = 4*LPAR + 5 + 2*sum(JADDLV)
      integer, parameter                ::      M_      =4              !no. of Gauss points used, must = 4 in fast_JX (no option)
      integer, parameter                ::      M2_     =2*M_           !2*M_ = 8, replaces MFIT
      integer, parameter                ::      W_      =18             !dim = no. of Wavelength bins:  =18 std, =12 trop only
!-----------------------------------------------------------------------
!    4 Gauss pts = 8-stream
      real*8, dimension(M_), parameter  ::      EMU = [.06943184420297d0, &
                                                        .33000947820757d0, .66999052179243d0, .93056815579703d0]
      real*8, dimension(M_), parameter  ::      WT  = [.17392742256873d0, &
                                                        .32607257743127d0, .32607257743127d0, .17392742256873d0]
!-----------------------------------------------------------------------
!    include 'cmn_JVdat.f'  for fast-JX code v 6.0+ (prather 4/07)
! 
! NB - ALL of these common variables are set paramters, 
!    They are NOT to be used as variables for a local solution
!    Thus this entire set is 'in' only after it is initialized
!-----------------------------------------------------------------------
!-----INPHOT------------------------------------------------------------ 
      real*8                            ::      RAD                     !Radius of Earth (cm)  
      real*8                            ::      ZZHT                    !Effective scale height above top of atmosphere (cm)
!-----RD_XXX  <- FJX_spec.dat-------------------------------------------
      real*8                            ::      WBIN(WX_+1)             !Boundaries of wavelength bins !!!NO USE
      integer                           ::      NJVAL                   !Number of J values
      integer                           ::      NW1                     ! is 1
      integer                           ::      NW2                     ! is 18 wavelines
      real*8                            ::      WL(WX_)                 !Centres of wavelength bins - 'effective wavelength' (nm)
      real*8                            ::      FL(WX_)                 !Solar flux incident on top of atmosphere (cm-2.s-1)
      real*8                            ::      QRAYL(WX_+1)            !Rayleigh parameters (effective cross-section) (cm2) 
      real*8                            ::      QO2(WX_,3)              !O2 cross-sections 
      real*8                            ::      QO3(WX_,3)              !O3 cross-sections
      real*8                            ::      Q1D(WX_,3)              !O3 => O(1D) quantum yield
      character*7                       ::      TITLEJ(X_)              !Species name in FJX_spec.dat
      character*7                       ::      TITLEJ2                 !Temp var 
      character*7                       ::      TITLEJ3                 !Temp var      
      real*8                            ::      TQQ(3,X_)               !Temperature for supplied cross sections(K)
      real*8                            ::      QQQ(WX_,2,X_)           !Supplied cross sections in each wavelength bin (cm2)
!-----RD_MIE  <- FJX_scat.dat-------------------------------------------
      integer                           ::      NAA                     !Number of categories for scattering phase functions, is 30
      integer                           ::      NAA_AM3                 !Number of categories for scattering phase functions for am3, is 880
      real*8                            ::      MEE_AM3(5,A_AM3)        !Aerosol mass extinction efficiency, MEE*colume mass =od
      real*8                            ::      SAA_AM3(5,A_AM3)        !Single scattering albedo
      real*8                            ::      PAA_AM3(8,5,A_AM3)      !Phase function: first 8 terms of expansion      
      real*8                            ::      WAA_AM3(5,A_AM3)        !Wavelengths for the NK supplied phase functions(nm)
      character*78                      ::      TITLE0                  !Title of the first line in FJX_spec.dat
      character*78                      ::      TITLE0_AM3              !Title of the first line in am3_scat.dat
      integer                           ::      JTAUMX                  !Max # is 250
      real*8                            ::      ATAU                    ! is 1.120
      real*8                            ::      ATAU0                   ! is 0.010
      character*20                      ::      TITLAA(A_)              ! A_ =40
      real*8                            ::      RAA(A_)                 !Effective radius associated with aerosol type
      real*8                            ::      DAA(A_)                 ! rho
      real*8                            ::      WAA(5,A_)               !Wavelengths for the NK supplied phase functions(nm)
      real*8                            ::      QAA(5,A_)               !Aerosol scattering phase functions
      real*8                            ::      SAA(5,A_)               !Single scattering albedo
      real*8                            ::      PAA(8,5,A_)             !Phase function: first 8 terms of expansion      
!-----RD_UM  <-  FJX_UMaer.dat------------------------------------------  
      character*20                      ::      TITLUM(33)              !UM aerosol type names
      real*8                            ::      UMAER(3,5,21,33)        !UM aerosol data
!-----RD_JS  <-  chem_Js.dat--------------------------------------------
      real*8                            ::      JFACTA(JVN_)            !Quantum yield (or multiplication factor) for photolysis
      character*7                       ::      JLABEL(JVN_)            !Reference label identifying appropriate J-value to use
      integer                           ::      JIND(JVN_)              !Set index arrays that map Jvalue(j) onto rates
      integer                           ::      NRATJ                   !number of J species
      logical                           ::      module_is_initialized = .false.      
      real*8,    parameter              ::      MASFAC = 100.d0*6.022d+23/(28.97d0*9.8d0*10.d0)         !used to calc ZH
      real*8,    parameter              ::      pfactor1 = 1.e3/9.8/28.9644*6.02e23/1.e4                !pa => molec/cm2
      real*8, dimension(L1_)            ::      ZH   !
      

      CONTAINS
! <SUBROUTINE NAME="fastjx_init">
!   <OVERVIEW>
!     Initialize data for fastjx calculation
!   </OVERVIEW>
!   <DESCRIPTION>
!     This subroutine initializes the calculation of photolysis rates
!     for FAST-JX calculation
!   </DESCRIPTION>
!   <TEMPLATE>
!     call fastjx_init
!   </TEMPLATE>                                                                        
!-----------------------------------------------------------------------
      subroutine fastjx_init 
!-----------------------------------------------------------------------
!  Routine to initialise photolysis rate data, called directly from the 
!  cinit routine in ASAD. Currently use it to read the JPL spectral data
!  and standard O3 and T profiles and to set the appropriate reaction in
!-----------------------------------------------------------------------
!                                                                       
!     IPH       Channel number for reading all data files               
!     RAD       Radius of Earth (cm)                                    
!     ZZHT      Effective scale height above top of atmosphere (cm)     
!     DATUMX    Maximum opt.depth above which sub layers should be inser
!     SZAMAX    Solar zenith angle cut-off, above which to skip calculat
!                                                                       
!-----------------------------------------------------------------------
!                                                                       
      implicit none 
!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_metdat.f' 
!      include 'cmn_JVdat.f' 
                                                                        
       integer  I, J, K 
!      real*8, parameter::   PI = 3.141592653589793d0 
!      real*8, parameter::  PI180=3.141592653589793d0/180.d0 
                                                                        
      if (module_is_initialized) return
                           
!----------------------------------------------------------------------
!     output version number and tagname to logfile.
!----------------------------------------------------------------------
      call write_version_number(version, tagname)

!                                                                       
! Defaults & constants                                                  
      RAD  = 6375.d5   !cm earth radii
      ZZHT = 5.d5 
!      STT(:,:,:,:) = 1.d6 
!      TCNAME(:)    = 'CO2' 
!                                                                       
! Read in annual mean pressure field                                    
!RSH if this code is ever reactivated, change to use mpp_open
!      open (IPH,file='ECT42_grid.dat',form='formatted',status='old') 
!      read (IPH,*) 
!      read (IPH,'(16F8.2)') (XDGRD(I),I=1,I_) 
!      read (IPH,*) 
!      read (IPH,'(16F8.2)') (YDGRD(J),J=1,J_) 
!      read (IPH,*) 
!      read (IPH,'(16F8.2)') (AREAXY(1,J),J=1,J_) 
!      read (IPH,*) 
!      read (IPH,'(16F8.1)') ((PMEAN(I,J),I=1,I_),J=1,J_) 
!      close(IPH) 
!RSH   call mpp_close (IPH)
                                                                        
!      do J=1,J_ 
!        AREAXY(1,J) = AREAXY(1,J)*1.d9 
!        do I=2,I_ 
!        AREAXY(I,J) = AREAXY(1,J) 
!        enddo 
!      enddo 
                                                                        
!      do I = 1,I_ 
!        XGRD(I) = XDGRD(I)*PI180 
!      enddo 
!      do J = 1,J_ 
!        YGRD(J) = YDGRD(J)*PI180 
!      enddo 
!                                                                       
! Read in fast-J X-sections (spectral data) <<<<<<<<<<<<<< new fast-JX  
      call RD_XXX('INPUT/FJX_spec.dat') 
                                                                        
! Read in aerosol/cloud scattering data <<<<<<<<<<<<<<<<<< new fast-JX  
      call RD_MIE('INPUT/FJX_scat.dat') 

! Read in aerosol/cloud scattering data <<<<<<<<<<<<<<<<<< new fast-JX  
      call RD_MIE_AM3('INPUT/am3_scat.dat') 
      
! Read in UMich aerosol optical data    <<<<<<<<<<<<<<<<<< new fast-JX 6
!      call RD_UM (IPH,'INPUT/FJX_UMaer.dat') 
                                                                        
! Read in labels of photolysis rates required   >>>>> keyed to users che
!   this is a tranfer map from the J's automatically calculated in fast-
!   onto the names and order in the users chemistry code                
      call RD_JS('INPUT/chem_Js.dat') 
!                                                                       
! Read in T & O3 climatology                    >>>> general backup clim
!      call RD_PROF(IPH,'atmos_std.dat')      

!-----------------------------------------------------------------------
!   mark module as initialized.
!-----------------------------------------------------------------------
         module_is_initialized = .true.                                                                     
    end subroutine fastjx_init                                         
 

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!    include 'cmn_metdat.f'  for fast-JX code v5.3+ (prather 6/05)
!
!        needs 'parm_ctm.f' for dimensions
!        delivers p, T, Surf Albedo, and Optical Depth from CTM to fastJX
!        >>>>this is for standalone fast-JX ver 5.3   (6.05)
!-----------------------------------------------------------------------
!
!      real*8  P(I_,J_)         !  Surface pressure
!      real*8  T(I_,J_,L_)      !  Temperature profile
!
!      real*8  XGRD(I_)         !  Longitude (midpoint, radians)
!      real*8  XDGRD(I_)
!      real*8  YGRD(J_)         !  Latitude  (midpoint, radians)
!!      real*8  YDGRD(J_) 
!      real*8  ETAA(L1_)        !  Eta(a) value for level boundaries
!      real*8  ETAB(L1_)        !  Eta(b) value for level boundaries
!      real*8  AREAXY(I_,J_)    !  area (m^2)
!      integer  MONTH
!      integer  NSLAT         ! Latitude(J) index of current column
!      integer  NSLON         ! Longitude(I) index of current column

!   Note that the climatology for O3, T, clouds, etc include a layer above
!        the CTM (L1_=L_+1) for calculating the J's
!      real*8, dimension(L1_)       :: RELH   !  Rel Hum (0.00 to 1.00)
!      real*8, dimension(I_,J_,L1_) :: TJ, DM, DO3, ZH
!      real*8, dimension(I_,J_,L1_) :: CLDLWP,AER1P, AER2P
!      integer,dimension(I_,J_,L1_) :: CLDNDX,AER1N, AER2N
!      real*8, dimension(I_,J_)     :: PMEAN, SA



!     PJ       Pressure at boundaries of model levels (hPa)             
!     MASFAC   Conversion factor for pressure to column density         
!                                                                       
!     TJ       Temperature profile on model grid                        
!     DM       Air column for each model level (molecules.cm-2)         
!     DO3      Ozone column for each model level (molecules.cm-2)       
!     ZH       Altitude of boundaries of model levels (cm)              
!     PSTD     Approximate pressures of levels for supplied climatology 

!
!      real*8   STT(I_,J_,L_,NTR_)
!      real*8   TREF(51,18,12),OREF(51,18,12)
!      character*10  TCNAME(NTR_)
!
!      common/metdat/P,T, STT,  &
!     &  XGRD,YGRD,XDGRD,YDGRD,ETAA,ETAB,AREAXY,  &
!     &  TREF,OREF,PMEAN,SA, MONTH,NSLAT,NSLON, TCNAME
!
!      common /jvdatIJ/TJ,DM,DO3,ZH,RELH, CLDLWP,AER1P,AER2P, &
!     &                  CLDNDX,AER1N,AER2N
!-----------------------------------------------------------------------


      
!-------aerosols/cloud scattering data set for fast-JX (ver 5.3+)       
!  >>>>>>>>>>>>>>>>spectral data rev to J-ref ver8.5 (5/05)<<<<<<<<<<<< 
!-----------------------------------------------------------------------
!     NAMFIL   Name of scattering data file (e.g., FJX_scat.dat)        
!     NJ1      Channel number for reading data file                     
!     NAA      Number of categories for scattering phase functions      
!     QAA      Aerosol scattering phase functions                       
!     NK       Number of wavelengths at which functions supplied (set as
!     WAA      Wavelengths for the NK supplied phase functions          
!     PAA      Phase function: first 8 terms of expansion               
!     RAA      Effective radius associated with aerosol type            
!     SAA      Single scattering albedo                                 
!-----------------------------------------------------------------------
!     NAMFIL   Name of spectral data file (JX_spec.dat) >> j2 for fast-J
!     NJ1      Channel number for reading data file                     
!                                                                       
!     NJVAL    Number of species to calculate J-values for              
!     NWWW     Number of wavelength bins, from 1:NWWW                   
!     WBIN     Boundaries of wavelength bins                            
!     WL       Centres of wavelength bins - 'effective wavelength'      
!     FL       Solar flux incident on top of atmosphere (cm-2.s-1)      
!     QRAYL    Rayleigh parameters (effective cross-section) (cm2)      
!     QO2(18,3)      O2 cross-sections                                        
!     QO3(18,3)      O3 cross-sections                                        
!     Q1D(18,3)      O3 => O(1D) quantum yield                                
!     TQQ(3,64)      Temperature for supplied cross sections                  
!     QQQ      Supplied cross sections in each wavelength bin (cm2)   
!  
!-----------------------------------------------------------------------
!      common /jvchem/JFACTA,JIND,NRATJ,JLABEL
!
!      common /jvdat/WBIN,WL,FL,QO2,QO3,Q1D,QQQ,QRAYL,TQQ,  &
!     &        ZZHT,ATAU,ATAU0, WAA,QAA,PAA,SAA,RAA,DAA,RAD, UMAER,  &
!     &        JTAUMX, NJVAL,NW1,NW2,NAA ,TITLE0,TITLEJ,TITLAA,TITLUM
!-----------------------------------------------------------------------



!     fastjx_photo should be called by fphoto, its function is to provide 
!                  the calculated J-values to fphoto, based on clould and 
!                  aerosol information
!
                  
      subroutine fastjx_photo( U0, SOLF, phalf1, zhalf1, pfull1, tfull, &
                              XO3, pwt, lwc, cloudsf, clouds_ndx ,qfld, &
                              srf_alb, aerop, aeron, o3_column_top, ZPJ)                   

!-----------------------------------------------------------------------
!                                                                       
!          PHOTOJ is the gateway to fast-JX calculations:                       
!        only access to CTM 3-D GLOBAL arrays                           
!        sets up the 1-D column arrays for calculating J's              
! v6.1   calculates the optical properties for each wavelength          
!          and passes single column, single wavelength data to OPMIE    
!        OPMIE no longer needs aerosol data, just the overall properties
!           DTAUX() = opt depth of each layer,                          
!           POMEGAX(8,) = scat phase fn, includes s-s albedo factor.    
!-----------------------------------------------------------------------
      implicit none 
!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_metdat.f' 
!      include 'cmn_JVdat.f' 
      real*8,           intent(in)      ::  U0,      &                  !cos(SZA)
                                            SOLF                        !solar-earth distance factor 
                                                                        !In AM3, the first layer is top of ATM, 
                                                                        !but in FASTJ, the first layer is surface           
      real*8,           intent(in)      ::  phalf1(L1_),&               !Pressure at boundaries (Pa) 49 layer
                                            zhalf1(L1_),&               !height at layer boundaries      
                                            pfull1(L_),&                !Pressure at mid-layer (Pa)  48
                                            tfull(L_)                   !Temperature at mid-Layer (K)           
      real*8,           intent(in)      ::  XO3(L_)                     !O3 mixing ratio (VMR)              
      real*8,           intent(in)      ::  pwt(L_)                     !Column air density (Kg/m2)              
      real*8,           intent(in)      ::  lwc(:,:)                    !(L_,ncloud=2)Liquid water content (Kg/Kg)
      real*8,           intent(in)      ::  cloudsf(:,:)                !Clouds fraction
      integer,          intent(in)      ::  clouds_ndx(:,:)             ! clouds type index =2: 1 water, 2 ice
      real*8,           intent(in)      ::  qfld(L_)                    !Specific humidity (kg/kg)
      real*8,           intent(in)      ::  srf_alb                     !Surface albedo               
      real*8,           intent(in)      ::  aerop(:,:)                  !Aerosol mass path (g/m2) (L_,AERONUM)
      integer,          intent(in)      ::  aeron(:,:)                  !(AERONUM) Aerosol type index, see FJX_scat.dat 
                                                                        !for aerosol type info 
      real*8,           intent(in)      ::  o3_column_top               !O3 column density, a small number
      real*8,           intent(out)     ::  ZPJ(JVL_,JVN_)              !ZPJ(JVL_,JVN_) 2-D array of J-values                                                  
!-----------------------------------------------------------------------
      real*8                            ::  SZA                         !solar zenith angle
      real*8                            ::  FREFL                       !fraction of energy refle                                            
      real*8                            ::  ZH(L1_)                     !height of each layer (cm)
      real*8                            ::  SCALEH                      !scale height (cm)
      real*8                            ::  pz, qs, wrk, es             !parameters to calc RH
      real*8                            ::  phalf(L1_), pfull(L_)       !pressures at boundaries and mid-layer (hPa)
      real*8, dimension(L1_+1)          ::  TTJ,&                       !Temperature used by FAST-J(K)
                                            DDJ,&                       !Air column density (molecs/cm2) for each layer
                                            ZZJ,&                       !O3 column density (molecs/cm2)
                                            ZHL                         !Distance of each layer to surface (cm), same to ZH,
                                                                        !but have another top layer, used to calculate cloud density
      real*8, dimension(L1_+1)          ::  PPJ                         !pressure at boundaries (hPa)
!--------key amtospheric data needed to solve plane-parallel J--------- 
      integer,dimension(L2_+1)          ::  JXTRA
      real*8, dimension(W_)             ::  FJTOP,&
                                            FJBOT,&
                                            FSBOT,&
                                            FLXD0,&
                                            RFL 
      real*8, dimension(L_, W_)         ::  AVGF,&
                                            FJFLX 
      real*8, dimension(L1_,W_)         ::  DTAUX,&
                                            FLXD 
      real*8, dimension(8,L1_,W_)       ::  POMEGAX 
      real*8, dimension(W_,L1_)         ::  FFX 
      real*8, dimension(W_,8)           ::  FFXNET 
!---flux/heating arrays (along with FJFLX,FLXD,FLXD0)                   
      real*8                            ::  FLXJ(L1_),&
                                            FFX0,&
                                            FXBOT,&
                                            FABOT                                                                         
      real*8                            ::  ODABS,&
                                            ODRAY 
      real*8                            ::  RFLECT,&
                                            FREFS,&
                                            FREFI !SOLF
      real*8                            ::  AMF2(2*L1_+1,2*L1_+1) 
!------------key SCATTERING arrays for clouds+aerosols------------------
      real*8                            ::  OPTX(5),&
                                            SSAX(5),&
                                            SLEGX(8,5) 
      real*8                            ::  OD(5,L1_),&
                                            SSA(5,L1_),&
                                            SLEG(8,5,L1_) 
      real*8                            ::  OD600(L1_) 
      real*8                            ::  PATH,PATH1,PATH2,&
                                            DENSWP,&
                                            DENS,&
                                            RH,&
                                            RHO,&
                                            REFF,&
                                            XTINCT,&
                                            ODCLD,ODCLD1,ODCLD2                         !optical depth of cloud
!------------key arrays AFTER solving for J's---------------------------
      real*8                            ::  FFF(W_,JVL_),&
                                            VALJ(X_) 
      real*8                            ::  FLXUP(W_),&
                                            FLXDN(W_),&
                                            DIRUP(W_),&
                                            DIRDN(W_) 
!------------2-D array of J_s returned by JRATET------------------------    
      real*8                            ::  VALJL(JVL_,NJVAL)                                                                         
      integer                           ::  I,J,K,&
                                            L,M,&
                                            KMIE,KW,&
                                            NAER,NDCLD,NDCLD1,NDCLD2, &
                                            RATIO(W_) 
      real*8                            ::  XQO3,XQO2,&
                                            DTAUC,&
                                            WAVE, &
!                                           FLINT, &
                                            TTT 
      logical                           ::  test_J = .false.

!-------------check model initialization -------------------------------
      if (.not. module_is_initialized) &
            call error_mesg ('ATMOS: fastjx_init:','fastjx_init must be called first.', FATAL)
!-----------------------------------------------------------------------
      ZPJ(:,:)  = 0.d0 
      FFF(:,:) = 0.d0 
      FREFI = 0.d0 
      FREFL = 0.d0 
      FREFS = 0.d0       

!-----------------------------------------------------------------------
!     call SOLARZ(UTIME,IDAY,YGRD,XGRD1, SZA,U0,SOLF) 
!-----------------------------------------------------------------------
!-----SOLF = 1.d0   ! this needs to be dropped to include 6.7% annual cy
 
      SZA    = acos(U0)*180./ 3.141592653589793d0
                                                                                                                                                
!-----check for dark conditions SZA > 98.0 deg => tan ht = 63 km          
!                        or         99.                  80 km          
      if (SZA .gt. SZAMAX) goto 99 
                                                                        
!-----load the amtospheric column data     
      phalf=phalf1/100.
      pfull=pfull1/100.  
      
!-----calculate effective altitude of each CTM level edge (cm)
!      ZH(1) = 16d5*log10(1000.d0/phalf(L1_))
!      do L = 1,L_
!         SCALEH  = 1.3806d-19*MASFAC*tfull(L1_-L)
!         ZH(L+1) = ZH(L) -(log(phalf(L1_-L)/phalf(L1_-L+1))*SCALEH)
!      enddo
      do L=1,L1_
         ZH(L)= zhalf1(L1_+1-L)*100.            ! height at boundaries (cm)
      end do
!            if (mpp_pe() == mpp_root_pe() ) then 
!              write(*,*) 'fastjx: zh(cm)=', zh    
!           end if                                                         
!---calculate spherical weighting functions (AMF: Air Mass Factor)      
      do L = 1,L1_ 
         ZHL(L) =   ZH(L) 
      enddo 
      ZHL(L1_+1) = ZHL(L1_) + ZZHT 
                                  
      do L = 1,L1_                !L=1 surface  AM3 L=1 TOA
!        PPJ(L) = ETAA(L) + ETAB(L)*P(ILNG,JLAT) 
!        TTJ(L) = TJ(ILNG,JLAT,L) 
!        DDJ(L) = DM(ILNG,JLAT,L) 
!        ZZJ(L) = DO3(ILNG,JLAT,L) 
         PPJ(L) = phalf(L1_+1-L)   ! pressure at boundaries (hPa)
         if(L <L1_)then
            TTJ(L) = tfull(L1_ -L) !TJ(ILNG,JLAT,L) 
            DDJ(L) =   pwt(L1_ -L)*6.023e22/28.92   !DM(ILNG,JLAT,L)  air den moleculars/cm2 
            ZZJ(L) =   XO3(L1_ -L)*DDJ(L)           !O3 column density (molecs/cm2) per layer
         else
            TTJ(L) = TTJ(L1_-1) + (TTJ(L1_-1)-TTJ(L1_-2))*(ZHL(L1_+1)-ZHL(L1_-1))/(ZHL(L1_)-ZHL(L1_-2))                         !K
            DDJ(L) = phalf(1)/pfactor1*100.     !hPa=>molec/cm2
            ZZJ(L) = o3_column_top                !molec/cm2 
         end if 
      enddo 
      PPJ(L1_+1) = 0.d0        
                                                            
!-----------------------------------------------------------------------
      call SPHERE2 (U0,RAD,ZHL,ZZHT,AMF2,L1_)                           !calculate how much sunlight is blocked by earth
!                                                                       !at a few lowest layers when zenith angle is high
!-----------------------------------------------------------------------   
    
                                                                     
!---calculate the optical properties (opt-depth, single-scat-alb, phase-fn(1:8)
!---  at the 5 std wavelengths 200-300-400-600-999 nm for cloud+aerosols
      do L = 1,L1_ 
         OD600(L) = 0.D0 
         do K=1,5 
            OD(K,L)  = 0.d0 
            SSA(K,L) = 0.d0 
            do I=1,8 
               SLEG(I,K,L) = 0.d0 
            enddo 
         enddo 
      enddo 
      
!-----sst and phase-fn are weighted by optical depth                                                                                   
      do L = 1,L1_   
   !      do M = 1,size(lwc,2)      
                                                                            
!-----cloud in layer:  if valid cloud index (now 4:13)        
            if(L<L1_)then            
               NDCLD1 = clouds_ndx(L1_-L,1)                                     !CLDNDX(ILNG,JLAT,L) 
               NDCLD2 = clouds_ndx(L1_-L,2)                                     !CLDNDX(ILNG,JLAT,L) 
               PATH1  = lwc(L1_-L,1)*pwt(L1_-L)*1.e3                            !(g/m2)  CLDLWP(ILNG,JLAT,L) liquid cloud 
               PATH2  = lwc(L1_-L,2)*pwt(L1_-L)*1.e3                            !(g/m2)  CLDLWP(ILNG,JLAT,L)  ice cloud
            else
               NDCLD1 = 0.                                              !CLDNDX(ILNG,JLAT,L) 
               NDCLD2 = 0.                                              !CLDNDX(ILNG,JLAT,L) 
               PATH1  = 0.                                              !(g/m2)  CLDLWP(ILNG,JLAT,L)    
               PATH2  = 0.                                              !(g/m2)  CLDLWP(ILNG,JLAT,L)    
            endif
!               if (mpp_pe() == mpp_root_pe() ) then 
!                 write(*,*)'fastjx: cloud PATH(g/m2): L(m)=', ZHL(L)/100.,'    PATH1=', PATH1, '       PATH2=',PATH2
!               endif
   
  
!            DENS  = PATH / ZH(L)
!            if (mpp_pe() == mpp_root_pe() ) then 
!              write(*,*) 'fastjx: dens(org)=', dens    
!           end if
!            if (mpp_pe() == mpp_root_pe() ) then 
!              write(*,*) 'fastjx: dens(new)=', dens    
!           end if       
            if (PATH1+PATH2 .gt. 0.d0) then 
               if (NDCLD1 .lt.4 .or. NDCLD1.gt.13) then 
                   NDCLD1 = 9 
               endif 
!---now calculate cloud OD at 600 nm from mixed formulae:               
               REFF = RAA(NDCLD1) 
               RHO  = DAA(NDCLD1) 
      
      
!---extinction K(m2/g) = Q(wvl) / [4/3 * Reff(micron) * aerosol-density(
               if(L<L1_)then
                  ODCLD1 = PATH1*0.75d0*QAA(4,NDCLD1)/(REFF*RHO) * cloudsf(L1_-L,1)**0.5                ! assuming approximate random overlap
               else
                  ODCLD1 = 0.
               end if  
       
       
               REFF = RAA(NDCLD2) 
               RHO  = DAA(NDCLD2)
!               if (NDCLD2 .eq. 12 .or. NDCLD2 .eq. 13) then 
               DENS  = PATH2 /(ZHL(L+1)-ZHL(L)) * 100.                  ! !!!JUL CHANGED DENSITY HERE(g/m2)/cm       
!---Ice Water Content (density at g/m3) varies from 0.0001 to 0.1       
!---correct R-eff for ice clouds, increase Reff (microns) with density  
               REFF = 50.d0 * (1.d0 + 8.333d0*DENS)   ! shoudl check the unit of DENS jul !!!!!!!!!!!!!!
!               endif 
               if(L<L1_)then
                  ODCLD2 = PATH2*0.75d0*QAA(4,NDCLD2)/(REFF*RHO) * cloudsf(L1_-L,2)**0.5                ! assuming approximate random overlap
               else
                  ODCLD2 = 0.
               end if  
               ODCLD = ODCLD1 + ODCLD2   
               if(ODCLD1 .ge. ODCLD2)then
                  NDCLD = NDCLD1
               else
                  NDCLD = NDCLD2
               endif
!               if (mpp_pe() == mpp_root_pe() ) then
!                 write(*,*)'fastjx: L(m)=', ZHL(L)/100., '     NDDLD=',NDCLD,  'ODCLD1=',ODCLD1, '     ODCLD2=',ODCLD2, '      DENS2=',DENS
!              endif
               call OPTICL (OPTX,SSAX,SLEGX,  ODCLD,NDCLD) 
               do K=1,5 
                  OD(K,L)  = OD(K,L)  + OPTX(K) 
                  SSA(K,L) = SSA(K,L) + SSAX(K)*OPTX(K) 
                  do I=1,8 
                     SLEG(I,K,L)=SLEG(I,K,L) + SLEGX(I,K)*SSAX(K)*OPTX(K) 
                  enddo 
               enddo 
            endif !if path >0
  !       end do !M
                                                                       
!---use OD of clouds (not aerosols) at 600 nm to determine added layers 
         OD600(L) = OD(4,L)                                                                         
!---aerosols in layer: check aerosol index                              
!---this uses data from climatology OR from current CTM (STT of aerosols                                                                       
!---FIND useful way to sum over different aerosol types!                
         do M = 1,size(aerop,2)
            if(L<L1_)then
               NAER = aeron(L1_-L,M) 
               PATH = aerop(L1_-L,M) !g/m2
            else
               NAER = 0 
               PATH = 0.D0
            endif                                                                      
!---subroutines OPTICA & OPTICM return the same information:            
!---  optical depth (OPTX), single-scat albedo (SSAX) and phase fn (SLEG
!---subs have slightly different inputs:                                
!---  PATH is the g/m2 in the layer, NAER in the cloud/aerosol index    
!---  UMich aerosols use relative humidity (RH)                         
            if (PATH .gt. 0.d0 .and. NAER .gt. 0) then
                call OPTICAM3 (OPTX,SSAX,SLEGX,  PATH, NAER)
!               if (NAER .gt.0) then 
!                   call OPTICA (OPTX,SSAX,SLEGX,  PATH,RH, NAER) 
!               else 
!                   NAER = -NAER
!                   call OPTICM (OPTX,SSAX,SLEGX,  PATH,RH,NAER) 
!               endif
                do K=1,5 
                   OD(K,L)  = OD(K,L)  + OPTX(K) 
                   SSA(K,L) = SSA(K,L) + SSAX(K)*OPTX(K) 
                   do I=1,8 
                      SLEG(I,K,L)=SLEG(I,K,L) + SLEGX(I,K)*SSAX(K)*OPTX(K) 
                   enddo !I
                enddo !K
            endif
         enddo !M
                                                                        
         do K=1,5 
            if (OD(K,L) .gt. 0.d0) then 
               SSA(K,L) = SSA(K,L)/OD(K,L) 
               do I=1,8 
                  SLEG(I,K,L) = SLEG(I,K,L)/OD(K,L) 
               enddo 
            endif 
         enddo                                                                        
      enddo !L
                                                                        
!---can add aerosol OD at 600 nm to determine added layers, but not done yet
!---    OD600(L) = OD(4,L) + aerosol OD's                               
                                                                                                                                                
!---when combining with Rayleigh and O2-O3 abs, remember the SSA and    
!---  phase fn SLEG are weighted by OD and OD*SSA, respectively.        
                                                                        
!---Given the aerosol+cloud OD/layer in visible (600 nm) calculate how to add
!       additonal levels at top of clouds (now uses log spacing)        
!-----------------------------------------------------------------------
      call EXTRAL(OD600,L1_,L2_,N_,JTAUMX,ATAU,ATAU0, JXTRA) 
!-----------------------------------------------------------------------
                                                                        
!---set surface reflectance                                             
      RFLECT = srf_alb !SA(ILNG,JLAT) 
      RFL(:) = max(0.0,min(1.0,RFLECT))                                                                                                                                                 
!-----------------------------------------------------------------------
!---Loop over all wavelength bins to calc mean actinic flux AVGF(L)     
!-----------------------------------------------------------------------                                                                       
      do K = 1,W_ 
                                                                        
         WAVE = WL(K) 
!---Pick nearest Mie wavelength to get scattering properites------------                                           
                                KMIE=1 ! use 200 nm prop for <255 nm                                        
         if( WAVE .gt. 255.d0 ) KMIE=2 ! use 300 nm prop for 255-355 nm                                        
         if( WAVE .gt. 355.d0 ) KMIE=3 ! use 400 nm prop for 355-500 nm
         if( WAVE .gt. 500.d0 ) KMIE=4 
         if( WAVE .gt. 800.d0 ) KMIE=5                                                                                                                                                 
!---Combine: Rayleigh scatters & O2 & O3 absorbers to get optical properties
!---values at L1_=L_+1 are a pseudo/climatol layer above the top CTM layer (L_)
         do L = 1,L1_ 
            TTT     = TTJ(L) 
            XQO3 = FLINT(TTT,TQQ(1,2),TQQ(2,2),TQQ(3,2)                    &   ! O3 cross-section intepolation
                           ,QO3(K,1),QO3(K,2),QO3(K,3))                
                                                                        
            XQO2 = FLINT(TTT,TQQ(1,1),TQQ(2,1),TQQ(3,1)                    &   ! O2 cross-section intepolation
                           ,QO2(K,1),QO2(K,2),QO2(K,3))                
                                                                        
            ODABS = XQO3*ZZJ(L) + XQO2*DDJ(L)*0.20948d0         !o3+o2
            ODRAY = DDJ(L)*QRAYL(K)                             !air
                                                                        
            DTAUX(L,K) = OD(KMIE,L) + ODABS + ODRAY             !OD: cloud+aerosol
                                                                        
            do I=1,8 
               POMEGAX(I,L,K) = SLEG(I,KMIE,L)*OD(KMIE,L) 
            enddo 
            POMEGAX(1,L,K) = POMEGAX(1,L,K) + 1.0d0*ODRAY 
            POMEGAX(3,L,K) = POMEGAX(3,L,K) + 0.5d0*ODRAY 
            do I=1,8 
               POMEGAX(I,L,K) = POMEGAX(I,L,K)/DTAUX(L,K) 
            enddo 
         enddo !L                                                                       
      enddo !K                                                                       
!-----------------------------------------------------------------------
                                                                        
      call OPMIE (DTAUX,POMEGAX,U0,RFL,AMF2,JXTRA,                      &
             AVGF,FJTOP,FJBOT,FSBOT,FJFLX,FLXD,FLXD0)                  
                                                                        
!-----------------------------------------------------------------------                                                                       
      do K = 1,W_ 
                                                                        
!----direct(DIR) and diffuse(FLX) fluxes at top(UP) (solar = negative by convection)
!----     also at bottom (DN), does not include diffuse reflected flux. 
         FLXUP(K) =  FJTOP(K) 
         DIRUP(K) = -FLXD0(K) 
         FLXDN(K) = -FJBOT(K) 
         DIRDN(K) = -FSBOT(K) 
                                                                        
         do L = 1,JVL_ 
            FFF(K,L) = FFF(K,L) + SOLF*FL(K)*AVGF(L,K) 
         enddo 
         FREFI = FREFI + SOLF*FL(K)*FLXD0(K)/WL(K) 
         FREFL = FREFL + SOLF*FL(K)*FJTOP(K)/WL(K) 
         FREFS = FREFS + SOLF*FL(K)/WL(K) 
                                                                        
!---for each wavelength calculate the flux budget/heating rates:        
!  FLXD(L) = direct flux deposited in layer L  [approx = MU0*(F(L+1) -F(
!            but for spherical atmosphere!                              
!  FJFLX(L) = diffuse flux across top of layer L                        
                                                                        
!---calculate divergence of diffuse flux in each CTM layer (& t-o-a)    
!---     need special fix at top and bottom:                            
!---FABOT = total abs at L.B. &  FXBOT = net diffusive flux at L.B.     
         FABOT = (1.d0-RFL(K))*(FJBOT(K)+FSBOT(K)) 
         FXBOT = -FJBOT(K) + RFL(K)*(FJBOT(K)+FSBOT(K)) 
         FLXJ(1) = FJFLX(1,K) - FXBOT 
         do L=2,L_ 
            FLXJ(L) = FJFLX(L,K) - FJFLX(L-1,K) 
         enddo 
         FLXJ(L_+1) = FJTOP(K) - FJFLX(L_,K) 
!---calculate net flux deposited in each CTM layer (direct & diffuse):  
         FFX0 = 0.d0 
         do L=1,L1_ 
            FFX(K,L) = FLXD(L,K) - FLXJ(L) 
            FFX0 = FFX0 + FFX(K,L) 
         enddo 
                                                                        
!  NB: the radiation level ABOVE the top CTM level is included in these 
!      these are the flux budget/heating terms for the column:          
!  FFXNET(K,1) = FLXD0        direct(solar) flux dep into atmos (spheric
!  FFXNET(K,2) = FSBOT        direct(solar) flux dep onto LB (surface)  
!  FFXNET(K,3) = FLXD0+FSBOT  TOTAL solar into atmopshere+surface       
!  FFXNET(K,4) = FJTOP        diffuse flux leaving top-of-atmos         
!  FFXNET(K,5) = FFX0         diffuse flux absorbed in atmos            
!  FFXNET(K,6) = FABOT        total (dir+dif) absorbed at LB (surface)  
!       these are surface fluxes to compare direct vs. diffuse:         
!  FFXNET(K,7) = FSBOT        direct flux dep onto LB (surface) - for sr
!  FFXNET(K,8) = FJBOT        diffuse flux dep onto LB (surface)        
                                                                        
         FFXNET(K,1) = FLXD0(K) 
         FFXNET(K,2) = FSBOT(K) 
         FFXNET(K,3) = FLXD0(K) + FSBOT(K) 
         FFXNET(K,4) = FJTOP(K) 
         FFXNET(K,5) = FFX0 
         FFXNET(K,6) = FABOT 
         FFXNET(K,7) = FSBOT(K) 
         FFXNET(K,8) = FJBOT(K)                                                                         
!-----------------------------------------------------------------------                                         
      enddo ! end loop over wavelength K 
!-----------------------------------------------------------------------                                                                                                           
      FREFL = FREFL/FREFS !calculate reflected flux (energy wei
      FREFI = FREFI/FREFS 
                                                                        
!---NB UVB = 280-320 = bins 12:15, UVA = 320-400 = bins 16:17, VIS = bin
                                                                         
!-----------------------------------------------------------------------
      call JRATET(pfull,tfull,FFF, VALJL) 
!-----------------------------------------------------------------------                                                                         
!---map the J-values from fast-JX onto ASAD ones (use JIND & JFACTA)    

      test_j =.false.
      do L = 1,JVL_ 
         do J = 1,NRATJ 
            if (JIND(J).gt.0) then 
               ZPJ(JVL_+1-L,J) = VALJL(L,JIND(J))*JFACTA(J) 
               if(ZPJ(JVL_+1-L,J) .lt. 0.0D0) then
                 test_j = .true.
               endif
            else 
               ZPJ(JVL_+1-L,J) = 0.d0 
            endif 
         enddo 
      enddo 
      
!      if(test_j)then
!            if (mpp_pe() == mpp_root_pe() ) then
!              write(*,*) 'fastjx: test_negative: (1) input variables'
!              write(*,*) 'fastjx: solar zenith angly',SZA, '  COSZ', U0   
!              write(*,*) 'fastjx:(1): ZHL', ZHL
!              write(*,*) 'fastjx:(1): PPJ', PPJ  
!              write(*,*) 'fastjx:(1): TTJ', TTJ  
!              write(*,*) 'fastjx:(1): DDJ', DDJ  
!              write(*,*) 'fastjx:(1): ZZJ', ZZJ  
!              write(*,*) 'fastjx:(1): AMF2', AMF2  
!              write(*,*) 'fastjx:(1): FFF', FFF  
!              write(*,*) 'fastjx:(1): AVGF', AVGF  
          
!            end if       
!      endif
      
                                                                        
!---diagnostics that are NOT returned to the CTM code                   
                                                                        
!-----------------------------------------------------------------------
!      write(6,*)'fast-JX-(6.4)----PHOTOJ internal print: Atmosphere----' 
!---used last called values of DTAUX and POMEGAX, should be 600 nm      
                                                                        
!      call JP_ATM(PPJ,TTJ,DDJ,ZZJ,ZHL,ZZHT,                             &
!     &            DTAUX(1,W_),POMEGAX(1,1,W_),JXTRA)                    
                                                                        
!---PRINT SUMMARY of mean intensity, flux, heating rates:               
!      write(6,*) 
!      write(6,*)'fast-JX(6.4)----PHOTOJ internal print: Mean Intens----' 
!      write(6,'(a,5f10.4)')                                             &
!     & ' SUMMARY fast-JX: albedo/SZA/u0/F-incd/F-refl/',                &
!     &  RFLECT,SZA,U0,FREFI,FREFL                                       
                                                                        
!      write(6,'(a5,18i8)')   ' bin:',(K, K=NW2,NW1,-1) 
!      write(6,'(a5,18f8.1)') ' wvl:',(WL(K), K=NW2,NW1,-1) 
!      write(6,'(a)') ' ----  100000=Fsolar   MEAN INTENSITY per wvl bin' 
!      do L = JVL_,1,-1 
!       do K=NW1,NW2 
!        RATIO(K) = (1.d5*FFF(K,L)/FL(K)) 
!       enddo 
!        write(6,'(i3,2x,18i8)') L,(RATIO(K),K=NW2,NW1,-1) 
!      enddo 
                                                                        
!      write(6,*) 
!      write(6,*)'fast-JX(6.4)----PHOTOJ internal print: Net Fluxes----' 
!      write(6,'(a11,18i8)')   ' bin:',(K, K=NW2,NW1,-1) 
!      write(6,'(a11,18f8.1)') ' wvl:',(WL(K), K=NW2,NW1,-1) 
!      write(6,'(a11,18f8.4)') ' sol in atm',(FFXNET(K,1), K=NW2,NW1,-1)
!      write(6,'(a11,18f8.4)') ' sol at srf',(FFXNET(K,2), K=NW2,NW1,-1)
!      write(6,*) ' ---NET FLUXES--- ' 
!      write(6,'(a11,18f8.4)') ' sol TOTAL ',(FFXNET(K,3), K=NW2,NW1,-1) 
!      write(6,'(a11,18f8.4)') ' dif outtop',(FFXNET(K,4), K=NW2,NW1,-1) 
!      write(6,'(a11,18f8.4)') ' abs in atm',(FFXNET(K,5), K=NW2,NW1,-1) 
!      write(6,'(a11,18f8.4)') ' abs at srf',(FFXNET(K,6), K=NW2,NW1,-1) 
!      write(6,*) ' ---SRF FLUXES--- ' 
!      write(6,'(a11,18f8.4)') ' srf direct',(FFXNET(K,7), K=NW2,NW1,-1) 
!      write(6,'(a11,18f8.4)') ' srf diffus',(FFXNET(K,8), K=NW2,NW1,-1) 
!      write(6,'(2a)') '  ---NET ABS per layer:       10000=Fsolar',     &
!     & '  [NB: values <0 = numerical error w/clouds or SZA>90, colm OK]'
!      do L = JVL_,1,-1 
!       do K=NW1,NW2 
!        RATIO(K) = 1.d5*FFX(K,L) 
!       enddo 
!        write(6,'(i9,2x,18i8)') L,(RATIO(K),K=NW2,NW1,-1) 
!      enddo                                                                         
!-----------------------------------------------------------------------
                                                                        
   99 continue 
      return 
      end subroutine fastjx_photo                                          
                                                                        
!<<<<<<<<<<<<<<<<<<<<<<<end CTM-fastJX linking subroutines<<<<<<<<<<<<<<
 

      subroutine fastjx_end
         implicit none
         module_is_initialized = .false.
      end subroutine fastjx_end

                                                                        
!-----------------------------------------------------------------------
!      subroutine SET_ATM(GMTAU) 
!-----------------------------------------------------------------------
!      implicit none 
!      include 'parm_CTM.f' 
!      include 'cmn_metdat.f' 
                                                                        
!      real*8 MASFAC,SCALEH,GMTAU, PJ(L1_+1) 
!      integer I,J,L,N 
!                                                                       
!  Mass factor - delta-Pressure (mbars) to delta-Column (molecules.cm-2)
!      MASFAC = 100.d0*6.022d+23/(28.97d0*9.8d0*10.d0) 
!                                                                        
!      do J = 1,J_ 
!      do I = 1,I_ 
!        P(I,J) = PMEAN(I,J) 
!        do L = 1,L1_ 
!          PJ(L) = ETAA(L) + ETAB(L)*P(I,J) 
!        enddo 
!          PJ(L1_+1) = 0.d0 
!        do L = 1,L1_ 
!          DM(I,J,L)  = (PJ(L)-PJ(L+1))*MASFAC 
!        enddo 
!        do L = 1,L_ 
!          TJ(I,J,L)  = T(I,J,L) 
!        enddo 
!-------calculate effective altitude of each CTM level edge             
!          ZH(I,J,1) = 16d5*log10(1000.d0/P(I,J)) 
!        do L = 1,L_ 
!          SCALEH      = 1.3806d-19*MASFAC*TJ(I,J,L) 
!          ZH(I,J,L+1) = ZH(I,J,L) -(log(PJ(L+1)/PJ(L))*SCALEH) 
!        enddo 
!      enddo 
!      enddo 
                                                                        
!---load O3 from CTM is being calculated:                               
!      do N = 1,NTR_ 
!        if (TCNAME(N) .eq. 'O3') then 
!          do J = 1,J_ 
!          do I = 1,I_ 
!                              ! unit of DO3:  # molecules/cm^2          
!          do L = 1,L_ 
!             DO3(I,J,L) = 6.023d26*STT(I,J,L,N)/48.d0                   &
!     &                    *1.d-4 /AREAXY(I,J)                           
!            enddo 
!          enddo 
!          enddo 
!        endif 
!      enddo 
                                                                        !
!      return 
!      END                                           
                                                                        
!      subroutine SET_AER(GMTAU) 
!      return 
!      END                                           
                                                                        
!      subroutine SET_CLD(GMTAU) 
!      return 
!      END                                           
                                                                        
      subroutine RD_JS(NAMFIL) 
!-----------------------------------------------------------------------
!  Reread the chem_Js.dat file to map photolysis rate to reaction       
!  Read in quantum yield 'jfacta' and fastj2 label 'jlabel'             
!-----------------------------------------------------------------------
!                                                                       
!     jfacta    Quantum yield (or multiplication factor) for photolysis 
!     jlabel    Reference label identifying appropriate J-value to use  
!     ipr       Photolysis reaction counter - should total 'JVN_'       
!                                                                       
!-----------------------------------------------------------------------
      implicit none 
!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_metdat.f' 
!      include 'cmn_JVdat.f' 
!                                                                       
      character(*), intent(in) ::  NAMFIL 
                                                                        
      integer  NJ1 
      integer  IPR, I, J, K 
      character*120 CLINE 
      character*7  T_JX, T_CHEM 
                                                                        
! Reread the chem_Js.dat file to map photolysis rate to reaction        
!                     Read in quantum yield jfacta and fastj2 label jlab
      IPR = 0 
      call mpp_open (NJ1, trim(NAMFIL), MPP_RDONLY, MPP_ASCII,  &
                     MPP_SEQUENTIAL, MPP_MULTI, MPP_SINGLE)
   10 read (NJ1,'(A)',err=20)  CLINE 
      if (IPR .eq. JVN_) goto 20 
                                                                        
      if (CLINE(2:5).eq.'9999') then 
        go to 20 
      elseif (CLINE(1:1).eq.'#') then 
        go to 10 
      elseif (CLINE(5:5).eq.'$') then 
        go to 10 
      else 
        IPR = IPR+1 
        read (CLINE(79:83),'(F5.1)') JFACTA(IPR) 
        read (CLINE(86:92),'(A7)')   JLABEL(IPR) 
        JFACTA(IPR) = JFACTA(IPR)/100.d0 
        go to 10 
      endif 
   20 call mpp_close(NJ1) 
                                                                        
      NRATJ = IPR 
                                                                        
!-----------------------------------------------------------------------
!  compare Xsections titles with J-values listed in chem code (jratd.dat
!  map J-values needed for chemistry (chem_Js.dat) onto the fast-JX rate
!  >>>>>>>>>>>>>>>>current code revised to JPL-02 ver 8.5 (5/05)<<<<<<<<
!          >>>this must now follow the read in of Xsects, etc<<<        
!-----------------------------------------------------------------------
                                                                        
!---Zero / Set index arrays that map Jvalue(j) onto rates               
      do J = 1,JVN_ 
        JIND(J) = 0 
      enddo 
      do J = 1,NJVAL 
        T_JX = TITLEJ(J) 
      do K = 1,NRATJ 
        T_CHEM = JLABEL(K) 
        if (T_CHEM(1:6) .eq. T_JX(1:6)) JIND(K)=J 
      enddo 
      enddo 
                                                                        
!      write(6,'(a,i4,a)') ' Photochemistry Scheme with ',IPR,' J-values' 
      do K=1,NRATJ 
        J = JIND(K) 
        if (J.eq.0) then 
!         write(6,'(i5,a9,f6.2,a,i4,a9)') K,JLABEL(K),JFACTA(K),         &
!     &         ' has no mapping onto onto fast-JX'                      
        else 
!         write(6,'(i5,a9,f6.2,a,i4,a9)') K,JLABEL(K),JFACTA(K),         &
!     &         ' mapped onto fast-JX:',J,TITLEJ(J)                      
        endif 
      enddo 
                                                                        
      return 
      END  subroutine RD_JS                                         
                                                                                                                                                
!-----------------------------------------------------------------------
!      subroutine RD_PROF(NJ2,NAMFIL) 
!-----------------------------------------------------------------------
!  Routine to input T and O3 reference profiles                         
!-----------------------------------------------------------------------
!      implicit none 
!      include 'parm_CTM.f' 
!      include 'cmn_metdat.f' 
                                                                        
!      integer, intent(in) ::  NJ2 
!      character(*), intent(in) ::  NAMFIL 
!                                                                       
!      integer IA, I, M, L, LAT, MON, NTLATS, NTMONS, N216 
!      real*8  OFAC, OFAK 
!      character*72 TITLE0 
!                                                                       
!RSH if this code is ever reactivated, change to use mpp_open:
!      open (NJ2,file=NAMFIL,status='old',form='formatted') 
!!      read (NJ2,'(A)') TITLE0 
!      read (NJ2,'(2I5)') NTLATS,NTMONS 
!      write(6,'(1X,A)') TITLE0                                         
!      write(6,1000) NTLATS,NTMONS 
!      N216  = min(216, NTLATS*NTMONS) 
!      do IA = 1,N216 
!        read (NJ2,'(1X,I3,3X,I2)') LAT, MON 
!        M = min(12, max(1, MON)) 
!        L = min(18, max(1, (LAT+95)/10)) 
!        read (NJ2,'(3X,11F7.1)') (TREF(I,L,M), I=1,41) 
!        read (NJ2,'(3X,11F7.4)') (OREF(I,L,M), I=1,31) 
!      enddo 
!      close (NJ2) 
!RSH   call mpp_close (NJ2)
                                                                        
!  Extend climatology to 100 km                                         
!      OFAC = exp(-2.d5/5.d5) 
!      do I = 32,51 
!        OFAK = OFAC**(I-31) 
!        do M = 1,NTMONS 
!        do L = 1,NTLATS 
!          OREF(I,L,M) = OREF(31,L,M)*OFAK 
!        enddo 
!        enddo 
!      enddo 
!      do L = 1,NTLATS 
!      do M = 1,NTMONS 
!      do I = 42,51 
!        TREF(I,L,M) = TREF(41,L,M) 
!      enddo 
!      enddo 
!      enddo 
                                                                        
!      return 
! 1000 format(1x,'std atmos profiles: ',i3,' lat x ',i2,' mon') 
!      END                                           
                                                                        
!-----------------------------------------------------------------------
!      subroutine SET_CLD0(TINIT,CLDP,NCLD,ALBEDO) 
!-----------------------------------------------------------------------
!  Routine to set cloud and surface properties: now loads the input the 
!     input profiles (FJX_test.dat) INCLUDING Temperatures and Surf Albe
!                                                                       
!  >>>>>> this subroutine will need to be customized                    
!  >>>>>> it is separate from aerosols since it comes from met fields   
!-----------------------------------------------------------------------
!      implicit none 
!!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_metdat.f' 
!      include 'cmn_JVdat.f' 
                                                                        
!      integer, intent(in) :: NCLD(L_) 
!      real*8,  intent(in) :: TINIT(L_),CLDP(L_),ALBEDO 
!      integer  I, J, L 
!                                                                       
!      do J = 1,J_ 
!      do I = 1,I_ 
!        do L = 1,L_ 
!          CLDLWP(I,J,L) = CLDP(L) 
!          CLDNDX(I,J,L) = NCLD(L) 
!          T(I,J,L)      = TINIT(L) 
!        enddo 
!          SA(I,J) = ALBEDO 
!      enddo 
!      enddo 
!                                                                       
!      return 
!      END                                           
                                                                        
                                                                        
!-----------------------------------------------------------------------
!      subroutine SET_AER0 (AER1,AER2, NAA1,NAA2) 
!-----------------------------------------------------------------------
!  Set up aerosols >>>>customize for climatology or CTM as source.      
!     this needs to load in the aerosol mass/column and type in each lay
!  In a CTM, this should be done as a climatology or in real time using 
!     computed STT(kg) of the aerosol and calculating PATH=1000.*STT/ARE
!-----------------------------------------------------------------------
!      implicit none 
!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_metdat.f' 
!      include 'cmn_JVdat.f' 
                                                                        
!      integer, intent(in) :: NAA1(L_),NAA2(L_) 
!      real*8,  intent(in) :: AER1(L_),AER2(L_) 
                                                                        
!      integer I, J, L, K 
                                                                        
!          AER1P(:,:,:) = 0.d0 
!!          AER2P(:,:,:) = 0.d0 
!          AER1N(:,:,:) = 0 
!          AER2N(:,:,:) = 0 
!      do J = 1,J_ 
!      do I = 1,I_ 
!        do L = 1,L_ 
!          AER1P(I,J,L) = AER1(L) 
!          AER2P(I,J,L) = AER2(L) 
!          AER1N(I,J,L) = NAA1(L) 
!          AER2N(I,J,L) = NAA2(L) 
!        enddo 
!      enddo 
!      enddo 
                                                                        
!      END                                           
                                                                        
                                                                        
!-----------------------------------------------------------------------
!      subroutine SET_ATM0 
!-----------------------------------------------------------------------
!  Routine to set up atmospheric profiles required by Fast-J2 using a   
!  doubled version of the level scheme used in the CTM. First pressure  
!  and z* altitude are defined, then O3 and T are taken from the supplie
!  climatology and integrated to the CTM levels (may be overwritten with
!  values directly from the CTM, if desired).                           
!                                       Oliver (04/07/99) & MJP (7/05)  
!-----------------------------------------------------------------------
!                                                                       
!                                                                       
!     PJ       Pressure at boundaries of model levels (hPa)             
!     MASFAC   Conversion factor for pressure to column density         
!                                                                       
!     TJ       Temperature profile on model grid                        
!     DM       Air column for each model level (molecules.cm-2)         
!     DO3      Ozone column for each model level (molecules.cm-2)       
!     ZH       Altitude of boundaries of model levels (cm)              
!     PSTD     Approximate pressures of levels for supplied climatology 
!-----------------------------------------------------------------------
!      implicit none 
!      include 'parm_CTM.f' 
!      include 'cmn_metdat.f' 
                                                                        
!      integer  I, J, K, L, M, N 
!      real*8   PSTD(52),OREF2(51),TREF2(51),PJ(L1_+1) 
!      real*8   DLOGP,F0,T0,PB,PC,XC,MASFAC,SCALEH 
!                                                                       
!  Select appropriate month                                             
!      M = max(1,min(12,MONTH)) 
                                                                        
!  Mass factor - delta-Pressure (mbars) to delta-Column (molecules.cm-2)
!      MASFAC = 100.d0*6.022d+23/(28.97d0*9.8d0*10.d0) 
                                                                        
!-----------------------------------------------------------------------
!      do J = 1,J_ 
                                                                        
!  Select appropriate latitudinal profiles                              
!          N = max(1, min(18, (int(YDGRD(J))+99)/10 )) 
!  Temporary zonal arrays for climatology data                          
!          do K = 1,51 
!            OREF2(K) = OREF(K,N,M) 
!            TREF2(K) = TREF(K,N,M) 
!          enddo 
!                                                                        
!        do I = 1,I_ 
                                                                        
!  Apportion O3 and T on supplied climatology z* levels onto CTM levels 
!  with mass (pressure) weighting, assuming constant mixing ratio and   
!  temperature half a layer on either side of the point supplied.       
!  L1_ = L_+1:                                                          
!       PJ(L=1:L1_) = pressure at CTM layer edge, PJ(L1_+1)=0 (top-of-at
                                                                        
!           PJ(L1_+1) = 0.d0 
!         do K = 1,L1_ 
!           PJ(K) = ETAA(K) + ETAB(K)*PMEAN(I,J) 
!         enddo 
                                                                        
!  Set up pressure levels for O3/T climatology - assume that value      
!  given for each 2 km z* level applies from 1 km below to 1 km above,  
!  so select pressures at these boundaries. Surface level values at     
!  1000 mb are assumed to extend down to the actual P(ILNG,JLAT).       
!                                                                       
!           PSTD(1) = max(PJ(1),1000.d0) 
!           PSTD(2) = 1000.d0 * 10.d0**(-1.d0/16.d0) 
!           DLOGP   = 10.d0**(-2.d0/16.d0) 
!         do K = 3,51 
!           PSTD(K) = PSTD(K-1)*DLOGP 
!         enddo 
!           PSTD(52)  = 0.d0 
                                                                        
!         do L = 1,L1_ 
!           F0 = 0.d0 
!           T0 = 0.d0 
!           do K = 1,51 
!             PC   = min(PJ(L),PSTD(K)) 
!             PB   = max(PJ(L+1),PSTD(K+1)) 
!             if (PC .gt. PB) then 
!               XC = (PC-PB)/(PJ(L)-PJ(L+1)) 
!               F0 = F0 + OREF2(K)*XC 
!               T0 = T0 + TREF2(K)*XC 
!             endif !
!           enddo 
!           TJ(I,J,L)  = T0 
!           DM(I,J,L)  = (PJ(L)-PJ(L+1))*MASFAC 
!           DO3(I,J,L) = F0*1.d-6*DM(I,J,L) 
!         enddo 
                                                                        
!  Calculate effective altitudes using scale height at each level       
!           ZH(I,J,1) = 0.d0 
!         do L = 1,L_ 
!           SCALEH      = 1.3806d-19*MASFAC*TJ(I,J,L) 
!           ZH(I,J,L+1) = ZH(I,J,L) -( LOG(PJ(L+1)/PJ(L)) * SCALEH ) 
!         enddo 
                                                                        
!        enddo 
!      enddo 
                                                                        
!      return 
!      END                                           
                                                                        
!<<<<<<<<<<<<<<<<<<<<<<<<end CTM-specific subroutines<<<<<<<<<<<<<<<<<<<
                                                                        
                                                                        
!<<<<<<<<<<<<<<<<<<<<<begin core fast-J subroutines<<<<<<<<<<<<<<<<<<<<<
                                                                        
!-----------------------------------------------------------------------
      subroutine OPTICL (OPTD,SSALB,SLEG, ODCLD,NDCLD) 
!-----------------------------------------------------------------------
!---set CLOUD fast-JX properties at the std 5 wavelengths:200-300-400-60
!---   this now requires the cloud layer OD rather than water path      
!---   assumed CLOUD Optical Depth given with type for optical propertie
!                                                                       
!  04 W_H01   (H1/Deir)GAMMA:r-m=0.1/alf=2 n=1.335   reff=0.250___G=.094
!  05 W_H04   (H1/Deir)GAMMA:r-m=0.4/alf=2 n=1.335   reff=1.000___G=1.50
!  06 W_H40   (H1/Deir)GAMMA:r-m=4.0/alf=2 n=1.335   reff=10.00___G=146.
!  07 W_C02   (C1/Deir)GAMMA:r-m=2.0/alf=6 n=1.335   reff=3.000___G=19.5
!  08 W_C04   (C1/Deir)GAMMA:r-m=4.0/alf=6 n=1.335   reff=6.000___G=78.1
!  09 W_C08   (C1/Deir)GAMMA:r-m=8.0/alf=2 n=1.335   reff=12.00___G=301.
!  10 W_C13   (C1/Deir)GAMMA:r-m=13./alf=2 n=1.335   reff=20.00___G=472.
!  11 W_L06   (W/Lacis)GAMMA:r-m=5.5/alf=11/3        reff=10.00___G=183.
!  12 Ice-Hexagonal (Mishchencko)                    reff=50.00___G=999.
!  13 Ice-Irregular (Mishchencko)                    reff=50.00___G=999.
                                                                        
      implicit none 
!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_JVdat.f' 
                                                                        
                                          ! optical depth of layer      
      real*8, intent(out)::    OPTD(5) 
                                          ! single-scattering albedo    
      real*8, intent(out)::    SSALB(5) 
                                          ! scatt phase fn (Leg coeffs) 
      real*8, intent(out)::    SLEG(8,5) 
                                          ! optical depth of cloud layer
      real*8, intent(in)::     ODCLD 
                                          ! index of cloud layer:  4:13 
      integer,intent(inout)::  NDCLD 
                                                                        
      integer I,J 
      real*8  XTINCT, REFF,RHO 
                                                                        
!---default cloud type C1, Reff = 12 microns                            
      if (NDCLD .gt. 13 .or. NDCLD .lt.4) then 
         NDCLD = 9 
      endif 
                                                                        
!--rescale OD by Qext at 600 nm (J=4)                                   
      do J=1,5 
         OPTD(J) = ODCLD * QAA(J,NDCLD)/QAA(4,NDCLD) 
         SSALB(J) = SAA(J,NDCLD) 
        do I=1,8 
         SLEG(I,J) =  PAA(I,J,NDCLD) 
        enddo 
      enddo 
                                                                        
      return 
      END  subroutine OPTICL                                         
                                                                        
 
                                                                        
!-----------------------------------------------------------------------
      subroutine OPTICAM3 (OPTD,SSALB,SLEG, PATH,L) 
!-----------------------------------------------------------------------
!---for the AM3 aerosol data sets, calculates optical properties at fast-JX
!              std 5 wavelengths:200-300-400-600-999nm                  :                                    
!                                                                         
!                    
!                                                                        
      implicit none 
!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_JVdat.f' 
                                                                        
                                          ! optical depth of layer      
      real*8, intent(out)::    OPTD(5) 
                                          ! single-scattering albedo    
      real*8, intent(out)::    SSALB(5) 
                                          ! scatt phase fn (Leg coeffs) 
      real*8, intent(out)::    SLEG(8,5) 
                                          ! path (g/m2) of aerosol/cloud
      real*8, intent(in)::     PATH 
                                          ! index of cloud/aerosols     
      integer,intent(inout)::     L 
                                                                        
      integer I,J 
!      real*8  XTINCT, REFF,RHO 
                                                                        
      if (L .gt. NAA_AM3 ) then 
         write(6,*) 'ATMOS:fastjx_photo:OPTICAM3:FATAL: aerosol index out-of-range: L/NAA',L,NAA_AM3
         call error_mesg ('ATMOS: fastjx_init:OPTICAM3','aerosol index out-of-range.', FATAL)
      endif 
                                                                        
!          MEE1 = MEE(L)                                                          
!         REFF = RAA(L) 
!         RHO = DAA(L) 
      do J=1,5 
!---extinction K(m2/g) = Q(wvl) / [4/3 * Reff(micron) * aerosol-density(
!         XTINCT = 0.75d0*QAA(J,L)/(REFF*RHO) 
         OPTD(J) = PATH*MEE_AM3(J,L) 
         SSALB(J) = SAA_AM3(J,L) 
       do I=1,8 
         SLEG(I,J) =  PAA_AM3(I,J,L) 
       enddo 
      enddo 
                                                                        
      return 
      END  subroutine OPTICAM3                                         
 
                                                                        
!-----------------------------------------------------------------------
!      subroutine OPTICA (OPTD,SSALB,SLEG, PATH,RELH,L) 
!-----------------------------------------------------------------------
!---for the UCI aerosol data sets, calculates optical properties at fast
!              std 5 wavelengths:200-300-400-600-999nm                  
!---UCI aersols optical data  v-6.1:                                    
!                                                                       
!   14 S-Bkg LOGN:r=.090 s=.600 reff=.221  n=1.514/1.473/1.459/1.448/1.4
!   15 S-Vol LOGN:r=.080 s=.800 reff=.386  n=1.514/1.473/1.459/1.448/1.4
!   16 UT-sulfate LOGN:r=0.05 s=.693 n=1.44           reff=0.166___rho=1
!   17 UT-sulfate LOGN:r=0.05 s=.693 n=1.46           reff=0.166___rho=1
!   18 UM-SULFate LOGN:r=.050 s=.642 n=1.53           reff=0.140___rho=1
!   19 UM-BC1     LOGN:r=.050 s=.642 n=1.80+0.50i     reff=0.140___rho=1
!   20 UM-BC2     LOGN:r=.080 s=.501 n=1.80+0.50i     reff=0.150___rho=1
!   21 UM-BB08 (%BC)LOGN:r=.080 s=.500 n=1.552+0.04i  reff=0.149___rho=1
!   22 UM-FF04(%BC) LOGN:r=.050 s=.642 n=1.541+0.02i  reff=0.140___rho=1
!   23 UM-FF10 (%BC)LOGN:r=.050 s=.642 n=1.557+0.05i  reff=0.140___rho=1
!   24 Mdust .15 (R.V. Martin generated phase fns)                      
!   25 Mdust .25 (R.V. Martin generated phase fns)                      
!   26 Mdust 0.4 (R.V. Martin generated phase fns)                      
!   27 Mdust 0.8 (R.V. Martin generated phase fns)                      
!   28 Mdust 1.5 (R.V. Martin generated phase fns)                      
!   29 Mdust 2.5 (R.V. Martin generated phase fns)                      
!   30 Mdust 4.0 (R.V. Martin generated phase fns)                      
                                                                        
!      implicit none 
!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_JVdat.f' 
                                                                        
                                          ! optical depth of layer      
!      real*8, intent(out)::    OPTD(5) 
                                          ! single-scattering albedo    
!      real*8, intent(out)::    SSALB(5) 
                                          ! scatt phase fn (Leg coeffs) 
!      real*8, intent(out)::    SLEG(8,5) 
                                          ! path (g/m2) of aerosol/cloud
!      real*8, intent(in)::     PATH 
                                          ! relative humidity (0.00->1.0
!      real*8, intent(in)::     RELH 
                                          ! index of cloud/aerosols     
!      integer,intent(inout)::     L 
                                                                        
!      integer I,J 
!      real*8  XTINCT, REFF,RHO 
                                                                        
!      if (L .gt. NAA .or. L .lt. 4) then 
!         write(6,*) 'ATMOS:fastjx_photo: aerosol index out-of-range: L/NAA',L,NAA 
!         L = 18 
!      endif 
                                                                        
!      if (L .lt. 14) then 
!         write(6,*) 'ATMOS:fastjx_photo: aerosol as cloud: L/NAA',L,NAA 
!      endif 
                                                                        
!         REFF = RAA(L) 
!         RHO = DAA(L) 
!      do J=1,5 
!---extinction K(m2/g) = Q(wvl) / [4/3 * Reff(micron) * aerosol-density(
!         XTINCT = 0.75d0*QAA(J,L)/(REFF*RHO) 
!         OPTD(J) = PATH*XTINCT 
!         SSALB(J) = SAA(J,L) 
!       do I=1,8 
!         SLEG(I,J) =  PAA(I,J,L) 
!       enddo 
!      enddo 
                                                                        
!      return 
!      END  subroutine OPTICA                                         
                                                                        
                                                                        
!-----------------------------------------------------------------------
!      subroutine OPTICM (OPTD,SSALB,SLEG, PATH,RELH,L) 
!-----------------------------------------------------------------------
!---for the U Michigan aerosol data sets, this generate fast-JX data for
!---NB Approximates the Legendre expansion(L) of the scattering phase fn
!---           as (2*L+1)*g**L                                          
!---UMAER(I,J,K,L):                                                     
!   I=1:3 = [SSAbldeo, g, k-ext(m2/g)]                                  
!   J=1:6 = [200, 300, 400, 550, 600 , 1000 nm]                         
!   K=1:21= [0, 5, 10, 15, ..., 90, 95, 99 %RelHum]                     
!   L=1:33= UM aerosol types [SULF, SS-1,-2,-3,-4, DD-1,-2,-3,-4, FF00(0
!                      FF02, ...FF14(14%BC), BB00, BB02, ...BB30(30%BC)]
!      implicit none 
!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_JVdat.f' 
                                                                        
                                          ! optical depth of layer      
!      real*8, intent(out)::    OPTD(5) 
                                          ! single-scattering albedo    
!      real*8, intent(out)::    SSALB(5) 
                                          ! scatt phase fn (Leg coeffs) 
!      real*8, intent(out)::    SLEG(8,5) 
                                          ! path (g/m2) of aerosol/cloud
!      real*8, intent(in)::     PATH 
                                          ! relative humidity (0.00->1.0
!      real*8, intent(in)::     RELH 
                                          ! index of cloud/aerosols     
!      integer,intent(inout)::     L 
                                                                        
!      integer KR,J 
!      real*8  R,FRH, GCOS, XTINCT 
                                                                        
!---calculate fast-JX properties at the std 5 wavelengths:200-300-400-60
!---interpolate in Relative Humidity                                    
!---extrapolate pahse fn from first term (g)                            
!      if (L .gt. 33) then 
!         write(6,*) 'ATMOS:fastjx_init: UM aer index too large: L',L 
!         L = 1 
!      endif 
                                                                        
!      R = 100.d0*min(1.d0, max(.01d0, RELH)) 
!         KR = (R/5.d0) 
!         KR = max(0, min(19, KR)) + 1 
!        if (KR.lt.20) then 
!         FRH = 0.20d0*(R - 5.d0*float(KR-1)) 
!        else 
!         FRH = 0.25d0*(R - 5.d0*float(KR-1)) 
!        endif 
                                                                        
!      do J=1,5 
!       SSALB(J) = UMAER(1,J,KR,L)*(1.d0-FRH) + UMAER(1,J,KR+1,L)*FRH 
                                                                        
!       XTINCT = UMAER(3,J,KR,L)*(1.d0-FRH) + UMAER(3,J,KR+1,L)*FRH 
!       OPTD(J) = PATH*XTINCT 
                                                                        
!       GCOS   = UMAER(2,J,KR,L)*(1.d0-FRH) + UMAER(2,J,KR+1,L)*FRH 
!       SLEG(1,J) =  1.d0 
!       SLEG(2,J) =  3.d0*GCOS 
!       SLEG(3,J) =  5.d0*GCOS**2 
!       SLEG(4,J) =  7.d0*GCOS**3 
!       SLEG(5,J) =  9.d0*GCOS**4 
!       SLEG(6,J) = 11.d0*GCOS**5 
!       SLEG(7,J) = 13.d0*GCOS**6 
!       SLEG(8,J) = 15.d0*GCOS**7 
!      enddo 
!      return 
!      END subroutine OPTICM                                          
                                                                        
!-----------------------------------------------------------------------
      subroutine JRATET(PPJ,TTJ,FFF, VALJL) 
!-----------------------------------------------------------------------
! in:                                                                   
!        PPJ(L1_+1) = pressure profile at edges    (hPa)                     
!        TTJ(L1_) = = temperatures at mid-level                         
!        FFF(K=1:NW, L=1:JVL_) = mean actinic flux                      
! out:                                                                  
!        VALJ(JVL_,NJVAL)  JVL_ = no of levels                          
!-----------------------------------------------------------------------
      implicit none 
!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_JVdat.f' 
                                                                        
!      real*8, intent(in)  ::  PPJ(L1_+1),TTJ(L1_) 
      real*8, intent(in)  ::  PPJ(L_),TTJ(L_)  !set to pfull (hPa) and tfull from AM3
      real*8, intent(in)  ::  FFF(W_,JVL_) 
      real*8, intent(out) ::  VALJL(JVL_,NJVAL) 
                                                                        
                                ! temp for call J's at one L            
      real*8  VALJ(X_) 
      real*8  QO2TOT(W_), QO3TOT(W_), QO31DY(W_), QO31D, QQQT, TFACT 
      real*8  TT,PP,DD,TT200,TFACA,TFAC0,TFAC1,TFAC2,QQQA,QQ2,QQ1A,QQ1B 
      integer J,K,L, IV 
                                                                        
                       ! master loop over layer = L                     
      do L = 1,JVL_ 
                                                                        
!---need temperature, pressure, and density at mid-layer (for some quant
          TT   = TTJ(L1_-L) 
!         if (L .eq. 1) then 
          PP = PPJ(L1_-L)  !PPJ(1) 
!         else 
!          PP  = (PPJ(L)+PPJ(L+1))*0.5d0 
!         endif 
          DD = 7.24e18*PP/TT   !molec/cm3
                                                                        
        do J = 1,NJVAL 
          VALJ(J) = 0.d0 
        enddo !j
                                                                        
        if (TT .le. TQQ(2,1))  then 
          if (TT .le. TQQ(1,1))  then 
            TFACT = 0.d0 
          else 
            TFACT = (TT -TQQ(1,1))/(TQQ(2,1) -TQQ(1,1)) 
          endif 
          do K = 1,W_ 
           QO2TOT(K) = QO2(K,1) + (QO2(K,2) - QO2(K,1))*TFACT 
          enddo 
        else 
          if (TT .ge. TQQ(3,1))  then 
            TFACT = 1.d0 
          else 
            TFACT = (TT -TQQ(2,1))/(TQQ(3,1) -TQQ(2,1)) 
          endif 
          do K = 1,W_ 
           QO2TOT(K) = QO2(K,2) + (QO2(K,3) - QO2(K,2))*TFACT 
          enddo 
        endif 

                                                                        
        if (TT .le. TQQ(2,2))  then 
          if (TT .le. TQQ(1,2))  then 
            TFACT = 0.d0 
          else 
            TFACT = (TT -TQQ(1,2))/(TQQ(2,2) -TQQ(1,2)) 
          endif 
          do K = 1,W_ 
           QO3TOT(K) = QO3(K,1) + (QO3(K,2) - QO3(K,1))*TFACT 
          enddo 
        else 
          if (TT .ge. TQQ(3,2))  then 
            TFACT = 1.d0 
          else 
            TFACT = (TT -TQQ(2,2))/(TQQ(3,2) -TQQ(2,2)) 
          endif 
          do K = 1,W_ 
           QO3TOT(K) = QO3(K,2) + (QO3(K,3) - QO3(K,2))*TFACT 
          enddo 
        endif 

                                                                        
        if (TT .le. TQQ(2,3))  then 
          if (TT .le. TQQ(1,3))  then 
            TFACT = 0.d0 
          else 
            TFACT = (TT -TQQ(1,3))/(TQQ(2,3) -TQQ(1,3)) 
          endif 
          do K = 1,W_ 
           QO31DY(K) = Q1D(K,1) + (Q1D(K,2) - Q1D(K,1))*TFACT 
          enddo 
        else 
          if (TT .ge. TQQ(3,3))  then 
            TFACT = 1.d0 
          else 
            TFACT = (TT -TQQ(2,3))/(TQQ(3,3) -TQQ(2,3)) 
          endif 
          do K = 1,W_ 
           QO31DY(K) = Q1D(K,2) + (Q1D(K,3) - Q1D(K,2))*TFACT 
          enddo 
        endif 

                                                                        
        do K = 1,W_ 
           QO31D  = QO31DY(K)*QO3TOT(K) 
          VALJ(1) = VALJ(1) + QO2TOT(K)*FFF(K,L) 
          VALJ(2) = VALJ(2) + (QO3TOT(K) -QO31D) *FFF(K,L)  !changed by jul
          VALJ(3) = VALJ(3) + QO31D*FFF(K,L) 
        enddo 

                                                                        
        do J = 4,NJVAL 
                                                                        
          if (TQQ(2,J) .gt. TQQ(1,J)) then 
           TFACT = max(0.0,min(1.0,(TT-TQQ(1,J))/(TQQ(2,J)-TQQ(1,J)))) 
          else 
           TFACT = 0.d0 
          endif 
                                                                        
          do K = 1,W_ 
            QQQT    = QQQ(K,1,J) + (QQQ(K,2,J) - QQQ(K,1,J))*TFACT 
            VALJ(J) = VALJ(J) + QQQT*FFF(K,L) 
          enddo 
                                                                        
!>>>>Methylvinyl ketone   'MeVK  '     q(M) = 1/(1 + 1.67e-19*[M])      
          if (TITLEJ(J).eq.'MeVK  ') then 
            VALJ(J) = VALJ(J)/(1.0 + 1.67e-19*DD) 
          endif 
!>>>>Methylethyl ketone   MEKeto     q(M) = 1/(1 + 2.0*[M/2.5e19])      
          if (TITLEJ(J).eq.'MEKeto') then 
            VALJ(J) = VALJ(J)/(1.0 + 0.80E-19*DD) 
          endif 
!>>>>Methyl glyoxal       MGlyxl     q(M) = 1/(1 + 4.15*[M/2.5E19])     
          if (TITLEJ(J).eq.'MGlyxl') then 
            VALJ(J) = VALJ(J)/(1.0 + 1.66e-19*DD) 
          endif 
                                                                        
        enddo 

                                                                        
      if (TITLEJ(NJVAL-1).eq.'Acet-a') then 
!--------------J-ref v8.3 includes Blitz ACETONE q-yields-------------- 
!---Acetone is a special case:   (as per Blitz et al GRL, 2004)         
!---     61 = NJVAL-1 = J1(acetone-a) ==> CH3CO + CH3                   
!---     62 = NJVAL   = J2(acetone-b) ==> CH3 + CO + CH3                
          VALJ(NJVAL-1) = 0.d0 
          VALJ(NJVAL)   = 0.d0 
!---IV=NJVAL-1 = Xsect (total abs) for Acetone - pre-calc Temp interp fa
        IV    = NJVAL-1 
        TFACA = (TT-TQQ(1,IV))/(TQQ(2,IV)-TQQ(1,IV)) 
        TFACA = max(0.0, min(1.0, TFACA)) 
!---IV=NJVAL = Q2 for Acetone=>(2), specifically designed for quadratic 
!---      but force to Q2=0 by 210K                                     
        IV    = NJVAL 
        TFAC0 = ( (TT-TQQ(1,IV))/(TQQ(2,IV)-TQQ(1,IV)) )**2 
        if (TT .lt. TQQ(1,IV)) then 
          TFAC0 = (TT - 210.d0)/(TQQ(1,IV)-210.d0) 
        endif 
        TFAC0 = max(0.0, min(1.0, TFAC0)) 
!---IV=NJVAL+1 = Q1A for Acetone => (1), allow full range of T = 200K-30
        IV    = NJVAL+1 
        TT200 = min(300.0, max(200.0, TT)) 
        TFAC1 = (TT200-TQQ(1,IV))/(TQQ(2,IV)-TQQ(1,IV)) 
!---IV=NJVAL+2 = Q1B for Acetone => (1)                                 
        IV    = NJVAL+2 
        TFAC2 = (TT200-TQQ(1,IV))/(TQQ(2,IV)-TQQ(1,IV)) 
                                                                        
!---now integrate over wavelengths                                      
        do K = 1,W_ 
!---NJVAL-1 = Xsect (total abs) for Acetone                             
          IV   = NJVAL-1 
          QQQA = QQQ(K,1,IV) + (QQQ(K,2,IV)-QQQ(K,1,IV))*TFACA 
!---NJVAL   = Q2 for Acetone=>(2), specifically designed for quadratic i
          IV   = NJVAL 
          QQ2  = QQQ(K,1,IV) + (QQQ(K,2,IV)-QQQ(K,1,IV))*TFAC0 
          if (TT .lt. TQQ(1,IV)) then 
            QQ2 = QQQ(K,1,IV)*TFAC0 
          endif 
!---NJVAL+1 = Q1A for Acetone => (1), allow full range of T = 200K-300K 
          IV   = NJVAL+1 
          QQ1A = QQQ(K,1,IV) + (QQQ(K,2,IV)-QQQ(K,1,IV))*TFAC1 
!---NJVAL+2 = Q1B for Acetone => (1)   ! scaled to [M]=2.5e19           
          IV   = NJVAL+2 
          QQ1B = QQQ(K,1,IV) + (QQQ(K,2,IV)-QQQ(K,1,IV))*TFAC2 
          QQ1B = QQ1B*4.d-20 
!---J(61)                                                               
          VALJ(NJVAL-1) = VALJ(NJVAL-1)                                 &
     &         + FFF(K,L)*QQQA*(1.d0-QQ2)/(QQ1A + QQ1B*DD)              
!---J(62)                                                               
          VALJ(NJVAL) = VALJ(NJVAL) + FFF(K,L)*QQQA*QQ2 
                                                                        
                 !K                                                     
        enddo 
!-----------end v-8.3 includes Blitz ACETONE q-yields--------------     
      endif 
                                                                        
!----Load array of J-values in native order, need to be indexed/scaled  
!    by ASAD-related code later: ZPJ(L,JJ) = VALJL(L,JIND(JJ))*JFACTA(JJ
        do J=1,NJVAL 
          VALJL(L,J) = VALJ(J) 
!         if(VALJ(J) .lt. 0.D0)then
!            write(*,*)'fastjx: !!!! negative J: J=',J, ' TITLE=',TITLEJ(J),'  VALJ(J)=',VALJ(J),' L=',L
!         endif   
        enddo 
                                                                        
                                          
      enddo ! master loop over L=1,JVL_   
      return 
      END subroutine JRATET                                          
                                                                        
                                                                        
!-----------------------------------------------------------------------
!      subroutine JP_ATM(PPJ,TTJ,DDJ,ZZJ,ZHL,ZZHT,DTAUX,POMEGAX,JXTRA) 
!-----------------------------------------------------------------------
!      implicit none 
!      include 'parm_CTM.f' 
!-----------------------------------------------------------------------
!--------key amtospheric data needed to solve plane-parallel J----------
!      real*8, dimension(L1_+1) :: TTJ,DDJ,ZZJ,ZHL 
!      real*8, dimension(L1_+1) :: PPJ 
!      integer,dimension(L2_+1) :: JXTRA 
!      real*8                 :: ZZHT 
!      real*8                 :: DTAUX(L1_),POMEGAX(8,L1_) 
!-----------------------------------------------------------------------
!      integer  I,J,K,L 
!      real*8   COLO2,COLO3,ZKM,DELZ,ZTOP 
                                                                        
!      write(6,'(4a)') '   L z(km)     p      T   ',                     &
!     & '    d(air)   d(O3)','  col(O2)  col(O3)     d-TAU   SS-alb',    &
!     & '  g(cos) CTM lyr=>'                                             
                                                                        
!          COLO2 = 0.d0 
!          COLO3 = 0.d0 
!          ZTOP = ZHL(L1_) + ZZHT 
                                                                        
!        do L = L1_,1,-1 
!          COLO2 = COLO2 + DDJ(L)*0.20948d0 
!          COLO3 = COLO3 + ZZJ(L) 
!          DELZ = ZTOP-ZHL(L) 
!          ZTOP = ZHL(L) 
!          ZKM = ZHL(L)*1.d-5 
                                                                        
!      write(6,'(1x,i3,0p,f6.2,f10.3,f7.2,1p,4e9.2,0p,f10.4,2f8.5,2i3)') &
!     &      L,ZKM,PPJ(L),TTJ(L),DDJ(L)/DELZ,ZZJ(L)/DELZ,                &
!     &      COLO2,COLO3,DTAUX(L),POMEGAX(1,L),POMEGAX(2,L)/3.d0,        &
!     &      JXTRA(L+L),JXTRA(L+L-1)                                     
                                                                        
                                                                        
!        enddo 
                                                                        
!      return 
!      END  subroutine JP_ATM                                         
                                                                        
                                                                        
!-----------------------------------------------------------------------
      subroutine RD_XXX(NAMFIL) 
!-----------------------------------------------------------------------
!  Read in wavelength bins, solar fluxes, Rayleigh, T-dep X-sections.   
!                                                                       
!>>>>NEW v-6.4  changed to collapse wavelengths & x-sections to Trop-onl
!           WX_ = 18 (parm_CTM.f) should match the JX_spec.dat wavelengt
!           W_ = 12 (Trop-only) or 18 (std) is set in (parm_MIE.f).     
!       if W_=12 then drop strat wavels, and drop x-sects (e.g. N2O, ...
!           W_ = 8, reverts to quick fix:  fast-J (12-18) plus bin (5) s
!                                                                       
!-----------------------------------------------------------------------
!     NAMFIL   Name of spectral data file (JX_spec.dat) >> j2 for fast-J
!     NJ1      Channel number for reading data file                     
!                                                                       
!     NJVAL    Number of species to calculate J-values for              
!     NWWW     Number of wavelength bins, from 1:NWWW                   
!     WBIN     Boundaries of wavelength bins                            
!     WL       Centres of wavelength bins - 'effective wavelength'      
!     FL       Solar flux incident on top of atmosphere (cm-2.s-1)      
!     QRAYL    Rayleigh parameters (effective cross-section) (cm2)      
!     QO2(18,3)      O2 cross-sections                                        
!     QO3(18,3)      O3 cross-sections                                        
!     Q1D(18,3)      O3 => O(1D) quantum yield                                
!     TQQ(3,64)      Temperature for supplied cross sections                  
!     QQQ      Supplied cross sections in each wavelength bin (cm2)   
!  
!-----------------------------------------------------------------------
!jul++
! RD_XXX  
! will access WL(18), FL(18), QRAYL(18)
!             QO2(18,3)      O2 cross-sections                                        
!             QO3(18,3)      O3 cross-sections                                        
!             Q1D(18,3)      O3 => O(1D) quantum yield   
!             TITLEJ(64),   SPECIES NAME  O2 O3
!             TQQ(3, 64),   TEMPERATURE 180k, 260k, 300K
!             QQQ(18,2,64)
!jul--
      implicit none 
!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_JVdat.f' 
                                                                        
      character(*), intent(in) ::  NAMFIL 
                                                                        
      integer  NJ1 
      integer  I, J, JJ, K, IW, NQQQ, NWWW, NQRD 
                                                                        
      TQQ(:,:) = 0.d0 
                                                                        
!----------spectral data----set for new format data J-ver8.3------------
!         note that NJVAL = # J-values, but NQQQ (>NJVAL) = # Xsects rea
!         for 2005a data, NJVAL = 62 (including a spare XXXX) and       
!              NQQQ = 64 so that 4 wavelength datasets read in for aceto
!         note NQQQ is not used outside this subroutine!                
                                                                        
! >>>> W_ = 12 <<<< means trop-only, discard WL #1-4 and #9-10, some X-s
                                                                        
      call mpp_open (NJ1, trim(NAMFIL), MPP_RDONLY, MPP_ASCII,  &
                     MPP_SEQUENTIAL, MPP_MULTI, MPP_SINGLE)
      read (NJ1,100) TITLE0 
      read (NJ1,101) NJVAL,NQRD, NWWW 
         NW1 = 1 
         NW2 = NWWW 
      if (NJVAL.gt.X_ .or. NQRD.gt.X_) then 
        write(6,201) 'ATMOS:fastjx_init: RD_XXX stop',NJVAL,X_ 
        stop 
      endif 
!      write(6,'(1X,A)') TITLE0 
!----J-values:  1=O2, 2=O3P,3=O3D 4=readin Xsects                       
      read (NJ1,102) (WL(IW),IW=1,NWWW) 
      read (NJ1,102) (FL(IW),IW=1,NWWW) 
      read (NJ1,102) (QRAYL(IW),IW=1,NWWW) 
                                                                        
!---Read O2 X-sects, O3 X-sects, O3=>O(1D) quant yields (each at 3 temps
      read (NJ1,103) TITLEJ(1),TQQ(1,1), (QO2(IW,1),IW=1,NWWW) 
      read (NJ1,103) TITLEJ2,  TQQ(2,1), (QO2(IW,2),IW=1,NWWW) 
      read (NJ1,103) TITLEJ3,  TQQ(3,1), (QO2(IW,3),IW=1,NWWW) 
                                                                        
      read (NJ1,103) TITLEJ(2),TQQ(1,2), (QO3(IW,1),IW=1,NWWW) 
      read (NJ1,103) TITLEJ2,  TQQ(2,2), (QO3(IW,2),IW=1,NWWW) 
      read (NJ1,103) TITLEJ3,  TQQ(3,2), (QO3(IW,3),IW=1,NWWW) 
                                                                        
      read (NJ1,103) TITLEJ(3),TQQ(1,3), (Q1D(IW,1),IW=1,NWWW) 
      read (NJ1,103) TITLEJ2,  TQQ(2,3), (Q1D(IW,2),IW=1,NWWW) 
      read (NJ1,103) TITLEJ3,  TQQ(3,3), (Q1D(IW,3),IW=1,NWWW) 
                                                                        
      do J = 1,3 
              if (mpp_pe() == mpp_root_pe()) then 
                write(*,*)'ATMOS:fastjx_init: RD_XXX:'
                write(*,200) J,TITLEJ(J),(TQQ(I,J),I=1,3) 
              end if
      enddo 
                                                                        
!---Read remaining species:  X-sections at 2 T_s                        
        JJ = 4 
      do J = 4,NQRD 
        read (NJ1,103) TITLEJ(JJ),TQQ(1,JJ),(QQQ(IW,1,JJ),IW=1,NWWW) 
        read (NJ1,103) TITLEJ2,  TQQ(2,JJ),(QQQ(IW,2,JJ),IW=1,NWWW) 
                                                                        
        if (W_.eq.18 .or. TITLEJ2(7:7).ne.'x') then 
!---include stratospheric J's (this also includes Cl and Br compounds!) 
          if (mpp_pe() == mpp_root_pe()) then 
            write(*,200) JJ,TITLEJ(JJ),(TQQ(I,JJ),I=1,2) 
          end if  
          JJ = JJ+1 
        endif 
                                                                        
      enddo 
       NQQQ = JJ-1 
       NJVAL = NJVAL + (NQQQ - NQRD) 
                                                                        
!---truncate number of wavelengths to do troposphere-only               
      if (W_ .ne. WX_) then 
!---TROP-ONLY                                                           
       if (W_ .eq. 12) then 
!        write(6,'(a)')                                                  &
!        ' >>>TROP-ONLY reduce wavelengths to 12, drop strat X-sects'   
        NW2 = 12 
        do IW = 1,4 
          WL(IW) = WL(IW+4) 
          FL(IW) = FL(IW+4) 
          QRAYL(IW) = QRAYL(IW+4) 
         do K = 1,3 
          QO2(IW,K) = QO2(IW+4,K) 
          QO3(IW,K) = QO3(IW+4,K) 
          Q1D(IW,K) = Q1D(IW+4,K) 
         enddo 
         do J = 4,NQQQ 
          QQQ(IW,1,J) = QQQ(IW+4,1,J) 
          QQQ(IW,2,J) = QQQ(IW+4,2,J) 
         enddo 
        enddo 
        do IW = 5,12 
          WL(IW) = WL(IW+6) 
          FL(IW) = FL(IW+6) 
          QRAYL(IW) = QRAYL(IW+6) 
         do K = 1,3 
          QO2(IW,K) = QO2(IW+6,K) 
          QO3(IW,K) = QO3(IW+6,K) 
          Q1D(IW,K) = Q1D(IW+6,K) 
         enddo 
         do J = 4,NQQQ 
          QQQ(IW,1,J) = QQQ(IW+6,1,J) 
          QQQ(IW,2,J) = QQQ(IW+6,2,J) 
         enddo 
        enddo 
!---TROP-QUICK  (must scale solar flux for W=5)                         
       elseif (W_ .eq. 8) then 
!        write(6,'(a)')                                                  &
!        ' >>>TROP-QUICK reduce wavelengths to 8, drop strat X-sects'   
        NW2 = 8 
        do IW = 1,1 
          WL(IW) = WL(IW+4) 
          FL(IW) = FL(IW+4)  * 2.d0 
          QRAYL(IW) = QRAYL(IW+4) 
         do K = 1,3 
          QO2(IW,K) = QO2(IW+4,K) 
          QO3(IW,K) = QO3(IW+4,K) 
          Q1D(IW,K) = Q1D(IW+4,K) 
         enddo 
         do J = 4,NQQQ 
          QQQ(IW,1,J) = QQQ(IW+4,1,J) 
          QQQ(IW,2,J) = QQQ(IW+4,2,J) 
         enddo 
        enddo 
        do IW = 2,8 
          WL(IW) = WL(IW+10) 
          FL(IW) = FL(IW+10) 
          QRAYL(IW) = QRAYL(IW+10) 
         do K = 1,3 
          QO2(IW,K) = QO2(IW+10,K) 
          QO3(IW,K) = QO3(IW+10,K) 
          Q1D(IW,K) = Q1D(IW+10,K) 
         enddo 
         do J = 4,NQQQ 
          QQQ(IW,1,J) = QQQ(IW+10,1,J) 
          QQQ(IW,2,J) = QQQ(IW+10,2,J) 
         enddo 
        enddo 
                                                                        
       else 
         write(6,*) 'ATMOS:fastjx_init: number of used wavelengths wrong:',W_ 
         stop 
       endif 
      endif 
                                                                        
!  Reset the titles for NJVAL-1 & NJVAL to be the two acetone J_s       
!   61: C3H6O  = Acet-a     (CH3CO + CH3)                               
!   62: Q2-Ac  = Acet-b     (CH3 + CO + CH3)                            
                                                                        
      TITLEJ(NJVAL-1) = 'Acet-a' 
      TITLEJ(NJVAL)   = 'Acet-b' 
                                                                        
      call mpp_close (NJ1)
                                                                        
  100 format(a) 
  101 format(10x,5i5) 
  102 format(10x,    6e10.3/(10x,6e10.3)/(10x,6e10.3)) 
  103 format(a7,f3.0,6e10.3/(10x,6e10.3)/(10x,6e10.3)) 
  200 format(1x,' x-sect:',i3,a10,3(3x,f6.2)) 
  201 format(' Number of x-sections supplied to Fast-J2: ',i3,/,        &
            ' Maximum number allowed (X_) only set to: ',i3,           &
            ' - increase in cmn_jv.f')                                 
                                                                        
      return 
      END subroutine RD_XXX                                          
                                                                        
                                                                        
!-----------------------------------------------------------------------
      subroutine RD_MIE(NAMFIL) 
!-----------------------------------------------------------------------
!-------aerosols/cloud scattering data set for fast-JX (ver 5.3+)       
!  >>>>>>>>>>>>>>>>spectral data rev to J-ref ver8.5 (5/05)<<<<<<<<<<<< 
!-----------------------------------------------------------------------
!     NAMFIL   Name of scattering data file (e.g., FJX_scat.dat)        
!     NJ1      Channel number for reading data file                     
!     NAA      Number of categories for scattering phase functions      
!     QAA      Aerosol scattering phase functions                       
!     NK       Number of wavelengths at which functions supplied (set as
!     WAA      Wavelengths for the NK supplied phase functions          
!     PAA      Phase function: first 8 terms of expansion               
!     RAA      Effective radius associated with aerosol type            
!     SAA      Single scattering albedo                                 
!-----------------------------------------------------------------------
      implicit none 
!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_JVdat.f' 
                                                                        
      character(*), intent(in) ::  NAMFIL 
      integer  I, J, K, NJ1 
!jul++
!   NAA,TITLE0
!   JTAUMX,ATAU,ATAU0 
!   TITLAA(J),RAA(J),DAA(J) 
!   WAA(K,J),QAA(K,J),SAA(K,J),PAA(I,K,J)
!
!jul--                                                                        
      call mpp_open (NJ1, trim(NAMFIL), MPP_RDONLY, MPP_ASCII,  &
                     MPP_SEQUENTIAL, MPP_MULTI, MPP_SINGLE)
                                                                        
      read (NJ1,'(i2,a78)') NAA,TITLE0 
        if (NAA .gt. A_) then 
          write(*,*) 'ATMOS:fastjx_init: too many scat-data sets:', NAA, A_ 
          stop 
        endif 
      read (NJ1,'(5x,i5,2f10.5)') JTAUMX,ATAU,ATAU0 
      if (mpp_pe() == mpp_root_pe()) then 
               write(*,*)'ATMOS:fastjx_init: RD_MIE:'
               write(*,'(a,2f9.5,i5)') ' ATAU/ATAU0/JMX',ATAU,ATAU0,JTAUMX 
      end if
        
      read (NJ1,*) 
      do J = 1,NAA 
          read (NJ1,'(3x,a20,32x,f5.3,15x,f5.3)')                       &
     &           TITLAA(J),RAA(J),DAA(J)                                
                       ! ver 6.0 extend to 5 ref wavelengths for mie-sca
        do K = 1,5 
          read (NJ1,'(f4.0,f7.4,f7.4,7f6.3,1x,f7.3,f8.4)')              &
     &  WAA(K,J),QAA(K,J),SAA(K,J),(PAA(I,K,J),I=2,8)                   
          PAA(1,K,J) = 1.d0 
        enddo 
      enddo 
                                                                        
      call mpp_close (NJ1)
      if (mpp_pe() == mpp_root_pe()) then 
        write(*,'(a,9f8.1)') ' ATMOS:fastjx_init: RD_MIE: Aerosol optical: r-eff/rho/Q(@wavel):'     &
                  ,(WAA(K,1),K=1,5)                                    
        write(*,*) TITLE0 
      end if                                                                        

      do J=1,NAA 
        if (mpp_pe() == mpp_root_pe()) then 
           write(*,*) ' ATMOS:fastjx_init: RD_MIE:'
           write(*,'(i3,1x,a8,7f8.3)')                                 &
                   J,TITLAA(J),RAA(J),DAA(J),(QAA(K,J),K=1,5)   
        end if          
      enddo 
                                                                        
      return 
      END  subroutine RD_MIE                                         
 
 
 
 
                                                                       
!-----------------------------------------------------------------------
      subroutine RD_MIE_AM3(NAMFIL) 
!-----------------------------------------------------------------------
!-------aerosols/cloud scattering data set for fast-JX (ver 5.3+)       
!  >>>>>>>>>>>>>>>>spectral data rev to J-ref ver8.5 (5/05)<<<<<<<<<<<< 
!-----------------------------------------------------------------------
!     NAMFIL   Name of scattering data file (e.g., FJX_scat.dat)        
!     NJ1      Channel number for reading data file                     
!     NAA      Number of categories for scattering phase functions      
!     QAA      Aerosol scattering phase functions                       
!     NK       Number of wavelengths at which functions supplied (set as
!     WAA      Wavelengths for the NK supplied phase functions          
!     PAA      Phase function: first 8 terms of expansion               
!     RAA      Effective radius associated with aerosol type            
!     SAA      Single scattering albedo                                 
!-----------------------------------------------------------------------
      implicit none 
!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_JVdat.f' 
                                                                        
      character(*), intent(in) ::  NAMFIL 
      integer  I, J, K, NJ1 
      character*90 :: str1
!jul++
!   NAA,TITLE0
!   JTAUMX,ATAU,ATAU0 
!   TITLAA(J),RAA(J),DAA(J) 
!   WAA(K,J),QAA(K,J),SAA(K,J),PAA(I,K,J)
!
!jul--                                                                        
      call mpp_open (NJ1, trim(NAMFIL), MPP_RDONLY, MPP_ASCII,  &
                     MPP_SEQUENTIAL, MPP_MULTI, MPP_SINGLE)
                                                                        
      read (NJ1,'(i4,a78)') NAA_AM3, TITLE0_AM3 
      if (NAA_AM3 .gt. A_AM3) then 
          write(*,*) 'ATMOS:fastjx_init: too many scat-data sets for AM3:', NAA_AM3, A_AM3 
          stop 
      endif 
!      read (NJ1,'(5x,i5,2f10.5)') JTAUMX,ATAU,ATAU0 
!      if (mpp_pe() == mpp_root_pe()) then 
!               write(*,*)'ATMOS:fastjx_init: RD_MIE_AM3:'
!               write(*,'(a,2f9.5,i5)') ' ATAU/ATAU0/JMX',ATAU,ATAU0,JTAUMX 
!      end if
        
!      read (NJ1,*) 
      do J = 1,NAA_AM3
          read (NJ1,'(a90)') str1
          if (mpp_pe() == mpp_root_pe()) then 
             write (*,'(a12,a90)')              &
                   'fastjx_init:',str1               
          endif       
!          read (NJ1,'(3x,a20,32x,f5.3,15x,f5.3)')                       &
!     &           TITLAA(J),RAA(J),DAA(J)                                
                       ! ver 6.0 extend to 5 ref wavelengths for mie-sca
        do K = 1,5 
          read (NJ1,'(f4.0,2e14.6,7f6.3,1x,f7.3,f8.4)')              &
                   WAA_AM3(K,J),MEE_AM3(K,J),SAA_AM3(K,J),(PAA_AM3(I,K,J),I=2,8)                   
          PAA_AM3(1,K,J) = 1.d0 
  
          if (mpp_pe() == mpp_root_pe()) then 
!!!              write (*,'(a12,i4,1x,f4.0,2e14.6,8f6.3,1x,f7.3,f8.4)')              &
!!!                  'fastjx_init:',J,WAA_AM3(K,J),MEE_AM3(K,J),SAA_AM3(K,J),(PAA_AM3(I,K,J),I=1,8)                   
          endif
        enddo 
      enddo 
                                                                        
       call mpp_close (NJ1)
!      if (mpp_pe() == mpp_root_pe()) then 
!        write(*,'(a,9f8.1)') ' ATMOS:fastjx_init: RD_MIE: Aerosol optical: r-eff/rho/Q(@wavel):'     &
!                  ,(WAA_AM3(K,1),K=1,5)                                    
!!        write(*,*) TITLE0_AM3 
!      end if                                                                        
!        if (mpp_pe() == mpp_root_pe()) then 

!      do J=1,NAA_AM3 
!          write(*,*) ' ATMOS:fastjx_init: RD_MIE_AM3:'
!           write(*,'(i3,1x,a8,7f8.3)')                                 &
!                   J,TITLAA_AM3(J),(QAA(K,J),K=1,5)   
!        end if          
!      enddo 
                                                                        
      return 
      END  subroutine RD_MIE_AM3                                         
 
 
                                                                        
                                                                        
!-----------------------------------------------------------------------
      subroutine RD_UM(NAMFIL) 
!-----------------------------------------------------------------------
!-------UMich aerosol optical data for fast-JX (ver 6.1+)               
!-----------------------------------------------------------------------
!     NAMFIL   Name of scattering data file (e.g., FJX_scat.dat)        
!     NJ1      Channel number for reading data file                     
!-----------------------------------------------------------------------
      implicit none 
!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_JVdat.f' 

!jul++
!  TITLUM(L)
!  UMAER
!jul--                                                                        
      character(*), intent(in) ::  NAMFIL 
                                                                        
      integer  I, J, K, L, NJ1 
                                                                        
      call mpp_open (NJ1, trim(NAMFIL), MPP_RDONLY, MPP_ASCII,  &
                     MPP_SEQUENTIAL, MPP_MULTI, MPP_SINGLE)
                                                                        
      read (NJ1,'(a78)') TITLE0 
!        write(6,*) 'UMichigan Aerosol optical data' 
!        write(6,*) TITLE0 
                                                                        
!---33 Different UM Aerosol Types:  SULF, SS-1,-2,-3,-4, DD-1,-2,-3,-4, 
!---      FF00(0%BC), FF02, ...FF14(14%BC),  BB00, BB02, ...BB30(30%BC) 
      do L=1,33 
          read(NJ1,'(a4)') TITLUM(L) 
!---21 Rel Hum:    K=1=0%, =2=5%, ... =20=95%, =21=99%                  
        do K=1,21 
!---6 wavelengths: J=1=200nm, 2=300nm, 3=400nm, (4'=550nm) 4=600nm, 5=10
!---3 optic vars:  I=1=SSAlbedo,  =2=g,  =3=k-ext                       
          read(NJ1,'(9f9.5,27x,6f9.5)')  ((UMAER(I,J,K,L),I=1,3),J=1,5) 
        enddo 
      enddo 
                                                                        
      call mpp_close (NJ1)
                                                                        
!        write(6,'(7(i5,1x,a4))') (L,TITLUM(L), L=1,33) 
                                                                        
      return 
      END subroutine RD_UM                                          
                                                                        
                                                                        
!-----------------------------------------------------------------------
      real*8 FUNCTION FLINT (TINT,T1,T2,T3,F1,F2,F3) 
!-----------------------------------------------------------------------
!  Three-point linear interpolation function                            
!-----------------------------------------------------------------------
      real*8  TINT,T1,T2,T3,F1,F2,F3 
      if (TINT .le. T2)  then 
        if (TINT .le. T1)  then 
          FLINT = F1 
        else 
          FLINT = F1 + (F2 - F1)*(TINT -T1)/(T2 -T1) 
        endif 
      else 
        if (TINT .ge. T3)  then 
          FLINT = F3 
        else 
          FLINT = F2 + (F3 - F2)*(TINT -T2)/(T3 -T2) 
        endif 
      endif 
      return 
      END  FUNCTION FLINT                                         
                                                                        
                                                                        
!-----------------------------------------------------------------------
!      subroutine SOLARZ(GMTIME,NDAY,YGRDJ,XGRDI, SZA,COSSZA,SOLFX) 
!-----------------------------------------------------------------------
!     GMTIME = UT for when J-values are wanted                          
!           (for implicit solver this is at the end of the time step)   
!     NDAY   = integer day of the year (used for solar lat and declin)  
!     YGRDJ  = laitude (radians) for grid (I,J)                         
!     XGDRI  = longitude (radians) for grid (I,J)                       
!                                                                       
!     SZA = solar zenith angle in degrees                               
!     COSSZA = U0 = cos(SZA)                                            
!-----------------------------------------------------------------------
!      implicit none 
!      real*8, intent(in) ::   GMTIME,YGRDJ,XGRDI 
!      integer, intent(in) ::  NDAY 
!      real*8, intent(out) ::  SZA,COSSZA,SOLFX 
                                                                        
!      real*8  PI, PI180, LOCT 
!      real*8  SINDEC, SOLDEK, COSDEC, SINLAT, SOLLAT, COSLAT, COSZ 
!                                                                       
!      PI     = 3.141592653589793d0 
!      PI180  = PI/180.d0 
!      SINDEC = 0.3978d0*sin(0.9863d0*(dble(NDAY)-80.d0)*PI180) 
!      SOLDEK = asin(SINDEC) 
!      COSDEC = cos(SOLDEK) 
!      SINLAT = sin(YGRDJ) 
!      SOLLAT = asin(SINLAT) 
!      COSLAT = cos(SOLLAT) 
!                                                                       
!      LOCT   = (((GMTIME)*15.d0)-180.d0)*PI180 + XGRDI 
!      COSSZA = COSDEC*COSLAT*cos(LOCT) + SINDEC*SINLAT 
!      SZA    = acos(COSSZA)/PI180 
!       if (mpp_pe() == mpp_root_pe()) then 
!         write(*,*) 'FASTJ:SOLARZ: XGRDI,YGRDJ',XGRDI,YGRDJ 
!         write(*,*) 'FASTJ:SOLARZ: LOCT (rad)',LOCT 
!         write(*,*) 'FASTJ:SOLARZ: SINDEC,COSDEC', SINDEC,COSDEC 
!         write(*,*) 'FASTJ:SOLARZ: SINLAT,COSLAT', SINLAT,COSLAT 
!         write(*,*) 'FASTJ:SOLARZ: COS, SZA',COSSZA,SZA 
!       end if                                                                        
                                                                        
!      SOLFX  = 1.d0-(0.034d0*cos(dble(NDAY-186)*2.d0*PI/365.d0)) 
                                                                        
!      return 
!      END   subroutine SOLARZ                                         
                                                                        
                                                                        
!-----------------------------------------------------------------------
      subroutine SPHERE2(GMU,RAD,ZHL,ZZHT,AMF2,L1_) 
!-----------------------------------------------------------------------
!----new v6.2: does AirMassFactors for mid-layer, needed for SZA ~ 90   
!  This new AMF2 does each of the half-layers of the CTM separately,    
!     whereas the original, based on the pratmo code did the whole layer
!     and thus calculated the ray-path to the CTM layre edges, NOT the m
!  Since fast-JX is meant to calculate the intensity at the mid-layer, t
!     solar beam at low sun (interpolated between layer edges) was incor
!  This new model does make some approximations of the geometry of the l
!     the CTM layer is split evenly in mass (good) and in height (approx
!                                                                       
!  Calculation of spherical geometry; derive tangent heights, slant path
!  lengths and air mass factor for each layer. Not called when          
!  SZA > 98 degrees.  Beyond 90 degrees, include treatment of emergent  
!  beam (where tangent height is below altitude J-value desired at).    
!-----------------------------------------------------------------------
! in:                                                                   
!     GMU     = MU0 = cos(solar zenith angle)                           
!     RAD     radius of Earth mean sea level (cm)                       
!     ZHL(L)  height (cm) of the bottome edge of CTM level L            
!     ZZHT    scale height (cm) used above top of CTM (ZHL(L_+1)        
!     L1_     dimension of CTM = levels +1 (L+1 = above-CTM level)      
! out:                                                                  
!     AMF2(I,J) = air mass factor for CTM level I for sunlight reaching 
!-----------------------------------------------------------------------
      implicit none 
      integer, intent(in) ::   L1_ 
      real*8, intent(in)  ::   GMU,RAD,ZHL(L1_+1),ZZHT 
      real*8, intent(out) ::   AMF2(2*L1_+1,2*L1_+1) 
                                                                        
!     RZ      Distance from centre of Earth to each point (cm)          
!     RQ      Square of radius ratios                                   
!     SHADHT  Shadow height for the current SZA                         
!     XL      Slant path between points                                 
                                                                        
      integer  I, J, K, II, L2 
      real*8   XMU1,XMU2,XL,DIFF,SHADHT,RZ(L1_+1) 
      real*8   RZ2(2*L1_+1),RQ2(2*L1_+1) 
!                                                                       
!--- must have top-of-atmos (NOT top-of-CTM) defined                    
!      ZHL(L1_+1) = ZHL(L1_) + ZZHT                                     
                                                                        
        RZ(1) = RAD + ZHL(1) 
      do II = 2,L1_+1 
        RZ(II)   = RAD + ZHL(II) 
      enddo 
                                                                        
!---calculate heights for edges of split CTM-layers                     
      L2 = 2*L1_ 
      do II = 2,L2,2 
        I = II/2 
        RZ2(II-1) = RZ(I) 
        RZ2(II) = 0.5d0*(RZ(I)+RZ(I+1)) 
      enddo 
        RZ2(L2+1) = RZ(L1_+1) 
      do II = 1,L2 
        RQ2(II) = (RZ2(II)/RZ2(II+1))**2 
      enddo 
                                                                        
                                                                        
!---shadow height for SZA > 90                                          
      if (GMU .lt. 0.0d0)  then 
        SHADHT = RZ2(1)/dsqrt(1.0d0-GMU**2) 
      else 
        SHADHT = 0.d0 
      endif 
                                                                        
!---up from the surface calculating the slant paths between each level  
!---  and the level above, and deriving the appropriate Air Mass Factor 
         AMF2(:,:) = 0.d0 
                                                                        
      do 16 J = 1,2*L1_+1 
                                                                        
!  Air Mass Factors all zero if below the tangent height                
        if (RZ2(J) .lt. SHADHT) goto 16 
!  Ascend from layer J calculating AMF2s                                
        XMU1 = abs(GMU) 
        do I = J,2*L1_ 
          XMU2     = dsqrt(1.0d0 - RQ2(I)*(1.0d0-XMU1**2)) 
          XL       = RZ2(I+1)*XMU2 - RZ2(I)*XMU1 
          AMF2(I,J) = XL / (RZ2(I+1)-RZ2(I)) 
          XMU1     = XMU2 
        enddo 
!--fix above top-of-atmos (L=L1_+1), must set DTAU(L1_+1)=0             
          AMF2(2*L1_+1,J) = 1.d0 
!                                                                       
!  Twilight case - Emergent Beam, calc air mass factors below layer     
        if (GMU .ge. 0.0d0) goto 16 
                                                                        
!  Descend from layer J                                                 
          XMU1       = abs(GMU) 
         do II = J-1,1,-1 
          DIFF        = RZ2(II+1)*sqrt(1.0d0-XMU1**2)-RZ2(II) 
                                                ! filter                
          if (II.eq.1)  DIFF = max(DIFF,0.0) 
!  Tangent height below current level - beam passes through twice       
          if (DIFF .lt. 0.0d0)  then 
            XMU2      = sqrt(1.0d0 - (1.0d0-XMU1**2)/RQ2(II)) 
            XL        = abs(RZ2(II+1)*XMU1-RZ2(II)*XMU2) 
            AMF2(II,J) = 2.d0*XL/(RZ2(II+1)-RZ2(II)) 
            XMU1      = XMU2 
!  Lowest level intersected by emergent beam                            
          else 
            XL        = RZ2(II+1)*XMU1*2.0d0 
            AMF2(II,J) = XL/(RZ2(II+1)-RZ2(II)) 
            goto 16 
          endif 
         enddo 
                                                                        
   16 continue 
      return 
      END  subroutine SPHERE2                                         
                                                                        
                                                                                                                                                
!-----------------------------------------------------------------------
      subroutine EXTRAL(DTAUX,L1X,L2X,NX,JTAUMX,ATAU,ATAU0, JXTRA) 
!-----------------------------------------------------------------------
!                                                                       
!    new version 6.1, add sub-layers (JXTRA) to thick cloud/aerosol laye
!    this version sets up log-spaced sub-layers of increasing thickness ATAU
!                                                                       
!     DTAUX(L=1:L1X) = Optical Depth in layer L (generally 600 nm OD)   
!        This can be just cloud or cloud+aerosol, it is used only to set
!        the number in levels to insert in each layer L                 
!        Set for log-spacing of tau levels, increasing top-down.        
!                                                                       
!     N.B. the TTAU, etc calculated here are NOT used elsewhere         
                                                                        
!---The log-spacing parameters have been tested for convergence and chosen
!---  to be within 0.5% for ranges OD=1-500, rflect=0-100%, mu0=0.1-1.0 
!---  use of ATAU = 1.18 and min = 0.01, gives at most +135 pts for OD=100
!---  ATAU = 1.12 now recommended for more -accurate heating rates (not J's)
!-----------------------------------------------------------------------
!                                                                       
      implicit none 
                                                
      integer, intent(in) ::  JTAUMX,L1X,L2X  !index of cloud/aerosol                                               
      integer, intent(in) ::  NX              !Mie scattering array size                                              
      real*8,  intent(in) ::  DTAUX(L1X)      !cloud+3aerosol OD in each layer
      real*8,  intent(in) ::  ATAU,ATAU0                                               
      integer, intent(out)::  JXTRA(L2X+1)    !number of sub-layers to be added
!                                                                       
      integer JTOTL,I,L,L2 
      real*8  TTAU(L2X+1),DTAUJ, ATAU1,ATAULN,ATAUM,ATAUN1 
!                                                                       
!---Reinitialize arrays                                                 
      TTAU(:)  = 0.d0 
      JXTRA(:) = 0 
!                                                                       
!---combine these edge- and mid-layer points into grid of size:         
!---              L2X+1 = 2*L1X+1 = 2*L_+3                              
!---calculate column optical depths above each level, TTAU(1:L2X+1)     
!---      note that TTAU(L2X+1)=0 and TTAU(1)=total OD                  
!                                                                       
!---Divide thick layers to achieve better accuracy in the scattering code
!---In the original fast-J, equal sub-layers were chosen, this is wasteful
!---and this new code (ver 5.3) uses log-scale:                         
!---        Each succesive layer (down) increase thickness by ATAU > 1  
!---        e.g., if ATAU = 2, a layer with OD = 15 could be divided into
!---        4 sub-layers with ODs = 1 - 2 - 4 - 8                       
!---The key parameters are:                                             
!---        ATAU = factor increase from one layer to the next           
!---        ATAUMN = the smallest OD layer desired                      
!---        JTAUMX = maximum number of divisions (i.e., may not get to ATAUMN
!---These are hardwired below, can be changed, but have been tested/optimized
                                                                        
      ATAU1  = ATAU - 1.d0 
      ATAULN = log(ATAU) 
        TTAU(L2X+1)  = 0.0d0 
      do L2 = L2X,1,-1 
        L         = (L2+1)/2 
        DTAUJ     = 0.5d0 * DTAUX(L) 
        TTAU(L2)  = TTAU(L2+1) + DTAUJ 
!---Now compute the number of log-spaced sub-layers to be added in      
!---   the interval TTAU(L2) > TTAU(L2+1)                               
!---The objective is to have successive TAU-layers increasing by factor ATAU>1
!---the number of sub-layers + 1                                        
        if (TTAU(L2) .lt. ATAU0) then 
          JXTRA(L2) = 0 
        else 
          ATAUM    = max(ATAU0, TTAU(L2+1)) 
          ATAUN1 = log(TTAU(L2)/ATAUM) / ATAULN 
          JXTRA(L2) = min(JTAUMX, max(0, int(ATAUN1 - 0.5d0))) 
        endif 
      enddo 
                                                                        
!---check on overflow of arrays, cut off JXTRA at lower L if too many levels
      JTOTL    = L2X + 2 
      do L2 = L2X,1,-1 
        JTOTL  = JTOTL + JXTRA(L2) 
        if (JTOTL .gt. NX/2)  then 
          write(6,'(A,2I5,F9.2)') 'ATMOS:fastjx_photo: N_/L2_/L2-cutoff JXTRA:',NX,L2X,L2 
          do L = L2,1,-1 
            JXTRA(L) = 0 
          enddo 
          go to 10 
        endif 
      enddo 
   10 continue 
                                                                        
      return 
      END subroutine EXTRAL                                          
                                                                        
                                                                        
!-----------------------------------------------------------------------
      subroutine OPMIE (DTAUX,POMEGAX,U0,RFL,AMF2,JXTRA,                &
     &                  FJACT,FJTOP,FJBOT,FSBOT,FJFLX,FLXD,FLXD0)       
!-----------------------------------------------------------------------
      implicit none 
!      include 'parm_CTM.f' 
!      include 'parm_MIE.f' 
!      include 'cmn_JVdat.f' 
                                                                        
      real*8, intent(in)        ::      DTAUX(L1_,W_),&         ! optical depth
                                        POMEGAX(8,L1_,W_)       ! scattering phase fn
      real*8, intent(in)        ::      AMF2(2*L1_+1,2*L1_+1) 
      real*8, intent(in)        ::      U0,RFL(W_) 
      integer, intent(in)       ::      JXTRA(L2_+1) 
      real*8, intent(out)       ::      FJACT(L_,W_),FJTOP(W_),FJBOT(W_),FSBOT(W_) 
      real*8, intent(out)       ::      FJFLX(L_,W_),FLXD(L1_,W_),FLXD0(W_) 
!                                                                       
      integer JNDLEV(L_),JNELEV(L1_) 
      integer JADDLV(L2_+1),JADDTO(L2_+1),L2LEV(L2_+1) 
      integer JTOTL,I,II,J,K,L,LL,IX,JK,   L2,L2L,L22,LZ,LZZ,ND 
      integer LZ0,LZ1,LZMID 
      real*8   SUMT,SUMJ 
                                                                        
      real*8  DTAU(L1_+1,W_),POMEGAJ(M2_,L2_+1,W_),TTAU(L2_+1,W_) 
      real*8  FTAU2(L2_+1,W_),POMEGAB(M2_,W_) 
      real*8  ATAUA,ATAUZ,XLTAU,TAUDN,TAUUP,DTAUJ,FJFLX0 
      real*8, dimension(W_) :: TAUBTM,TAUTOP,FBTM,FTOP,ZFLUX 
!--- variables used in mie code-----------------------------------------
      real*8, dimension(W_)         :: FJT,FJB 
      real*8, dimension(N_,W_)      :: FJ,FZ,ZTAU 
      real*8, dimension(M2_,N_,W_) :: POMEGA 
      real*8, dimension(2*L1_,W_)   :: FLXD2 
                                                                        
!  fast-J Mie code for J_s, only uses 8-term expansion, 4-Gauss pts     
!                                                                       
! in:                                                                   
!     DTAUX(1:L1_,1:W_) = optical depth of each layer                   
!     POMEGAX(1:8,1:L1_,1:W_) = scattering phase fn (multiplied by s-s abledo)
!     U0  = cos (SZA)                                                   
!     RFL(1:W_) = Lambertian albedo of surface                          
!     AMF2(1:2*L1_+1,1:2*L1_+1) = air mass factor (I,L)=wt of layer-I to layer-L
!        AMF2 now does both edges and middle of CTM layers              
!     JXTRA(1:L1_) = number 0:J = no. of additional levels to be inserted
! out:                                                                  
!     FJACT(1:L_,1:W_) = mean actinic flux(diff+direct) at std CTM levels(mid-lyr)
!  (new ver 5.7 diagnostics for fluxes, deposition)  fluxes 'down' are <0
!     FJTOP(1:W_) = diffuse flux out top-of-atmosphere (TAU=0 above top model lyr)
!     FJBOT(1:W_) = diffuse flux onto surface (<0 by definition)        
!     FSBOT(1:W_) = direct/solar flux onto surface  (<0 by definition)  
!     FJFLX(1:L_,1:W_) = diffuse flux across top of model layer L       
!        this connects with FJBOT = FJFLX(0) & FJTOP = FJFLX(L_+1) (not dim!!)
!     FLXD(1:L_+1,1:W_) = solar flux deposited in layer L (includes lyr above CTM)
!        this should take into account sphericity, and is not just = mu0
!     FLXD0(1:W_) = sum of solar flux deposited in atmos                
!        does NOT include flux on lower surface, does NOT mean absorbed!
!-----------------------------------------------------------------------
!                                                                       
!     DTAU     Local optical depth of each CTM level                    
!     TTAU     Optical depth of air vertically above each point (to top of atm)
!     FTAU2     Attenuation of solar beam                               
!     POMEGAJ  Scattering phase function                                
!                                                                       
!---new ver 5.3 code adds sub-layers (# = JXTRA(L2)) using ATAU as the  
!   factor increase from sub-layer to sub-layer                         
!                                                                       
!---------------------SET UP FOR MIE CODE-------------------------------
                                                                        
!-----------------wavelength independent--------------------------------
!                                                                       
!  Transpose the ascending TTAU grid to a descending ZTAU grid.         
!  Double the resolution - TTAU points become the odd points on the     
!  ZTAU grid, even points needed for asymm phase fn soln, contain 'h'.  
!  Odd point added at top of grid for unattenuated beam   (Z='inf')     
!                                                                       
!  The following mapping holds for JADDLV=0                             
!        Surface:   TTAU(1)    ==> ZTAU(2*L2_+1)                        
!        Top:       TTAU(L2_)  ==> ZTAU(3)                              
!        Infinity:     0.0     ==> ZTAU(1)                              
!        index: 2*(L2_+1-L2)+1 ==> LZ                                   
!                                                                       
!  Mie scattering code only used from surface to level L2_              
!-----------------------------------------------------------------------
!                                                                       
!-----------------------------------------------------------------------
!  Insert new levels, working downwards from the top of the atmosphere  
!  to the surface (down in 'LZ', up in 'L2'). This allows ztau and pomega
!  to be incremented linearly, and the flux fz to be attenuated top-down
!    (avoiding problems where lower level fluxes are zero).             
!-----------------------------------------------------------------------
!                                                                       
!  Ascend through atmosphere transposing grid and adding extra points   
!  remember L2=1 is surface of CTM, but last layer (LZ) in scattering code.
!  there are twice the number of layers in the LZ arrays (2*L2_ + 2*JADDTO + 1)
!    because we need to insert the intermediate layers (even LZ) for the
!    asymmetric scattering code.                                        
                                                                        
                                                                        
!  Transfer the L2=1:L2_+1 values (TTAU,FTAU2,POMEGAJ) onto the reverse 
!    order, expanded, doubled-level scatter grid.                       
!    Note that we need to deal with the expansion by JADD levels (L2L). 
!      These JADDLV levels are skipped and need to be interpolated later
!    Note that only odd LZ levels are filled,                           
                                                                        
!----------------------re-grid data-------------------------------------
!  Calculate cumulative total and define levels we want J-values at.    
!  Sum upwards for levels, and then downwards for Mie code readjustments
!                                                                       
!     JXTRA(L2)  Number of new levels to add between (L2) and (L2+1)    
!           ***JXTRA(1:L2_+1) is calculated based on the aerosol+cloud OD_s
!     JADDLV(L2)  Number of new levels actually added at each wavelength
!            where JADDLV = 0 when there is effectively no FTAU2        
!     JADDTO(L2)   Total number of new levels to add to and above level (L2)
!     JNDLEV(L) = L2 index that maps on CTM mid-layer L                 
!                                                                       
!---JADDLV(L2=1:L2_) = number of levels to add between TTAU2(L2) and TTAU(L2+1)
!---    JADDLV is taken from JXTRA, which is based on visible OD.       
!---    JADDTO(L2=1:L2_+1) is the cumulative number of levels to be added
!---these should be fixed for all wavelengths to lock-in the array sizes
      do L2 = 1,L2_,1 
        JADDLV(L2) = JXTRA(L2) 
      enddo 
        JADDTO(L2_+1) = 0 
      do L2 = L2_,1,-1 
        JADDTO(L2) = JADDTO(L2+1) + JADDLV(L2) 
      enddo 
                                                                        
!---expanded grid now included CTM edge and mid layers plus expanded    
!---    grid to allow for finer delta-tau at tops of clouds.            
!---    DIM of new grid = L2_ + JADDTO(1) + 1                           
                                                                        
!---L2LEV(L2) = L2-index for old level L2 in expanded J-grid (w/JADDLV) 
!     in absence of JADDLV, L2LEV(L2) = L2                              
        L2LEV(1)  = 1 
      do L2 = 2,L2_+1 
        L2LEV(L2) = L2LEV(L2-1) + 1 + JADDLV(L2-1) 
      enddo 
                                                                        
!---JNDLEV(L=1:L_) = L2-index in expanded grid for CTM mid-layer L      
!---JNELEV(L=1:L_) = L2-index for top of layer L                        
      do L = 1,L_ 
        JNDLEV(L) = L2LEV(2*L) 
        JNELEV(L) = L2LEV(2*L+1) 
      enddo 
                          !need to set this to top-of-atmosphere        
        JNELEV(L_+1) = 0 
                                                                        
      ND = 2*L2_ + 2*JADDTO(1) + 1 
                                                                        
      if(ND .gt. N_) then 
        write(6,'(a,2i9)') 'ATMOS:fastjx_photo: overflow of scatter arrays:',ND,N_ 
        stop 
      endif 
                                                                        
!----------------begin wavelength dependent set up----------------------
                                                                        
!---Reinitialize arrays                                                 
      ZTAU(:,:)     = 0.d0 
      FZ(:,:)       = 0.d0 
      POMEGA(:,:,:) = 0.d0 
                                                                        
      do K=1,W_ 
                                                                        
!---Set up optical depth DTAU(L)                                        
       do L = 1,L1_ 
        DTAU(L,K) = DTAUX(L,K) 
       enddo 
        DTAU(L1_+1,K) = 0.d0 
                                                                        
!---Define the total scattering phase fn for each CTM layer L=1:L_+1    
!---   from a DTAU-wt_d mix of aerosols, cloud & Rayleigh               
!---No. of quadrature pts fixed at 4(M_), expansion of phase fn @ 8     
       do L = 1,L1_ 
        do I = 1,M2_ 
          POMEGAJ(I,L,K) = POMEGAX(I,L,K) 
        enddo 
       enddo 
                                                                        
!---Calculate attenuated incident beam exp(-TTAU/U0 = DTAU * AirMassFactor)
!---      at the middle & edges of the CTM layers L=1:2*L1_+1           
!---  L1_ is top-edge of CTM (ie, L=38 = 2 hPa) which has TAU > 0       
!---  note that DTAU(L1_) is optical depth in the FULL CTM layer just above
        FTAU2(:,:) = 0.d0 
        FTAU2(L2_+1,:) = 1.0d0 
       do LL = 1,2*L1_+1 
         L = (LL+1)/2 
        if (AMF2(LL,LL) .gt. 0.0d0) then 
           XLTAU = 0.0d0 
         do II = 1,2*L1_+1 
           I = (II+1)/2 
           XLTAU = XLTAU + 0.5d0*DTAU(I,K)*AMF2(II,LL) 
         enddo 
                                      ! zero out flux at 1e-33          
         if (XLTAU .lt. 76.d0) then 
          FTAU2(LL,K) = exp(-XLTAU)    !!!!!!!!good place to
         endif 
        endif 
       enddo 
                                                                        
!---calculate direct solar flux deposited in each CTM half-layer: L=1:L2_
!---     use FSBOT for surface flux, cannot do layer above CTM (L_+1)   
          FLXD2(:,:) = 0.d0 
       do LL = 1,2*L1_ 
        if (AMF2(LL,LL) .gt. 0.d0) then 
          FLXD2(LL,K) = (FTAU2(LL+1,K) - FTAU2(LL,K))/AMF2(LL,LL) 
        endif 
       enddo 
        if (AMF2(1,1) .gt. 0.d0) then 
          FSBOT(K) = FTAU2(1,K)/AMF2(1,1) 
        else 
          FSBOT(K) = 0.d0 
        endif 
                                                                        
       do LL = 2,2*L1_,2 
         L=LL/2 
         FLXD(L,K) = FLXD2(LL,K)+FLXD2(LL-1,K) 
       enddo 
                                                                        
!---integrate solar flux depositied in CTM layers L=1:L_, cannot do top layer
!---  note FLXD0 .ne. (1.d0 - FTAU(L_+1))/AMF(L_+1,L_+1) with spherical atmos
        FLXD0(K) = 0.d0 
       if (AMF2(2*L1_,2*L1_) .gt. 0.d0) then 
        do L=1,L1_ 
         FLXD0(K) = FLXD0(K) + FLXD(L,K) 
        enddo 
       endif 
                                                                        
!-----------------------------------------------------------------------
!  Take optical properties on CTM layers and convert to a photolysis    
!  level grid corresponding to layer centres and boundaries. This is    
!  required so that J-values can be calculated for the centre of CTM    
!  layers; the index of these layers is kept in the JNDLEV array.       
!-----------------------------------------------------------------------
!---Now combine the CTM layer edges (1:L_+2) with the CTM mid-layer     
!---    points (1:L_) plus 1 for the mid point of added top layer.      
!---combine these edge- and mid-layer points into grid of size:         
!---              L2_+1 = 2*L1_+1 = 2*L_+3                              
!---calculate column optical depths above each level, TTAU(1:L2_+1)     
!---      note that TTAU(L2_+1)=0 and TTAU(1)=total OD                  
                                                                        
        TTAU(L2_+1,K) = 0.0d0 
       do L2 = L2_,1,-1 
        L          = (L2+1)/2 
        DTAUJ      = 0.5d0 * DTAU(L,K) 
        TTAU(L2,K)   = TTAU(L2+1,K) + DTAUJ 
       enddo 
                                                                        
!----solar flux incident on lower boundary & Lambertian reflect factor: 
       if (FSBOT(K) .gt. 0.d0) then 
        ZFLUX(K) = FSBOT(K)*RFL(K)/(1.d0+RFL(K)) 
       else 
        ZFLUX(K) = 0.d0 
       endif 
                                                                        
!  Calculate scattering properties, level centres then level boundaries 
!>>>>>be careful of order, we are overwriting/shifting the 'POMEGAJ' upw
       do L2 = L2_,2,-2 
        L   = L2/2 
        do I = 1,M2_ 
          POMEGAJ(I,L2,K) = POMEGAJ(I,L,K) 
        enddo 
       enddo 
!---lower boundary value is set (POMEGAJ(I,1), but set upper:           
       do I = 1,M2_ 
         POMEGAJ(I,L2_+1,K) = POMEGAJ(I,L2_,K) 
       enddo 
!---now have POMEGAJ filled at even points from L2=3:L2_-1              
!---use inverse interpolation for correct tau-weighted values at edges  
       do L2 = 3,L2_-1,2 
        TAUDN = TTAU(L2-1,K)-TTAU(L2,K) 
        TAUUP = TTAU(L2,K)-TTAU(L2+1,K) 
        do I = 1,M2_ 
          POMEGAJ(I,L2,K) = (POMEGAJ(I,L2-1,K)*TAUDN +                  &
     &           POMEGAJ(I,L2+1,K)*TAUUP) / (TAUDN+TAUUP)               
        enddo 
       enddo 
                                                                        
!---at this point FTAU2(1:L2_+1) and POMEAGJ(1:8, 1:L2_+1)              
!---    where FTAU2(L2_+1) = 1.0 = top-of-atmos, FTAU2(1) = surface     
! Ftau2 indicate how much of light is still alive at that layer                                                                        
                                
       do L2 = 1,L2_+1          ! L2 = index of CTM edge- and mid-layers                               
        L2L = L2LEV(L2)         ! L2L = index for L2 in expanded scale(JADD)                                     
        LZ  = ND + 2 - 2*L2L    ! LZ = index for L2 in scatt arrays
          ZTAU(LZ,K) = TTAU(L2,K) 
          FZ(LZ,K)   = FTAU2(L2,K) 
        do I=1,M2_ 
          POMEGA(I,LZ,K) = POMEGAJ(I,L2,K) 
        enddo 
       enddo 
                                                                        
!   Now go thru the pairs of L2 levels to see if we need JADD levels    
                                 ! L2 = index of CTM edge- and mid-layer
       do L2 = 1,L2_ 
                                 ! L2L = index for L2 in expanded scale(
          L2L = L2LEV(L2) 
                                ! LZ = index for L2 in scatt arrays     
          LZ  = ND + 2 - 2*L2L 
                                             ! L22 = 0 if no added level
          L22 = L2LEV(L2+1) - L2LEV(L2) - 1 
                                                                        
          if (L22 .gt. 0) then 
             TAUBTM(K) = TTAU(L2,K) 
             TAUTOP(K) = TTAU(L2+1,K) 
             FBTM(K)   = FTAU2(L2,K) 
             FTOP(K)   = FTAU2(L2+1,K) 
             do I = 1,M2_ 
                POMEGAB(I,K) = POMEGAJ(I,L2,K) 
             enddo 
                                                                        
!---to fit L22 new layers between TAUBOT > TAUTOP, calculate new 1/ATAU 
!---  such that TAU(just above TAU-btm) = ATUAZ * TAUBTM < TAUBTM       
             ATAUZ = exp(-log(TAUBTM(K)/max(TAUTOP(K),ATAU0))/float(L22+1)) 
                                ! add odd levels between L2LEV(L2) & L2L
             do L = 1,L22 
                               ! LZZ = index(odd) of added level in scat
                LZZ = LZ - 2*L 
                ZTAU(LZZ,K) = TAUBTM(K) * ATAUZ 
                                                                        
!---fraction from TAUBTM=>TAUTOP                                        
                ATAUA=(TAUBTM(K)-ZTAU(LZZ,K))/(TAUBTM(K)-TAUTOP(K)) 
!---solar flux at interp-levels: use exp(TAU/U0) if U0>0.02 (89 deg),   
!---else scale by TAU                                                   
                if (U0 .gt. 0.02d0) then 
                    FZ(LZZ,K) = FTOP(K) * exp((TAUTOP(K)-ZTAU(LZZ,K))/U0) 
                else 
                    if (FBTM(K) .lt. 1.d-32) then 
                        FZ(LZZ,K) = 0.d0 
                    else 
                        FZ(LZZ,K) = FBTM(K) * (FTOP(K)/FBTM(K))**ATAUA 
                    endif 
                endif 
                do I = 1,M2_ 
                   POMEGA(I,LZZ,K) = POMEGAB(I,K) +                            &
     &               ATAUA*(POMEGAJ(I,L2+1,K)-POMEGAB(I,K))             
                enddo 
                TAUBTM(K)    = ZTAU(LZZ,K) 
                FBTM(K)      = FZ(LZZ,K) 
                do I = 1,M2_ 
                   POMEGAB(I,K) = POMEGA(I,LZZ,K) 
                enddo 
             enddo !Loop L
          endif 
       enddo ! Loop L2
                                                                        
!   Now fill in the even points with simple interpolation in scatter arrays
       do LZ = 2,ND-1,2 
         ZTAU(LZ,K) = 0.5d0*(ZTAU(LZ-1,K)+ZTAU(LZ+1,K)) 
         FZ(LZ,K)   = sqrt(FZ(LZ-1,K)*FZ(LZ+1,K)) 
        do I=1,M2_ 
         POMEGA(I,LZ,K) = 0.5d0*(POMEGA(I,LZ-1,K)+POMEGA(I,LZ+1,K)) 
        enddo 
       enddo 
                                                                        
                                                     
      enddo ! wavelength loop! 
                                                                        
!-----------------------------------------------------------------------
       call MIESCT(FJ,FJT,FJB,POMEGA,FZ,ZTAU,ZFLUX,RFL,U0,ND ) 
!-----------------------------------------------------------------------
                                                                        
!---Move mean intensity from scatter array FJ(LZ=1:ND)                  
!---              to CTM mid-level array FJACT(L=1:L_)                  
                                                                        
      do K=1,W_ 
                                                                        
!---mean intensity:  4*<I> + solar at mid-layer                         
       do L = 1,L_ 
        L2L = JNDLEV(L) 
        LZ  = ND+2 - 2*L2L 
        FJACT(L,K) = 4.d0*FJ(LZ,K) + FZ(LZ,K) 
       enddo 
       
 
                                                                        
!---mean diffuse flux:  4<I*mu> (not solar) at top of layer L           
!---      average (tau-wtd) the h's just above and below the L-edge     
       do L = 1,L_ 
        L2L = JNELEV(L) 
        LZ  = ND+2 - 2*L2L 
        FJFLX0 = (ZTAU(LZ+1,K)-ZTAU(LZ,K))/(ZTAU(LZ+1,K)-ZTAU(LZ-1,K)) 
        FJFLX(L,K)=4.d0*(FJ(LZ-1,K)*FJFLX0 + FJ(LZ+1,K)*(1.d0-FJFLX0)) 
       enddo 
                                                                        
!---NB if one needs the mean intensity throughout layer L (instead of mi
!---   then average (tau-weighted) the odd-points from: NELEV(L-1) to NE
!---NB This is NOT now used.                                            
!      real*8   FJACT2(L_,W_)                                           
!-----LZ are indices to the 1:ND array     LZ1 > LZMID > LZ0            
!       LZ1 = ND                                                        
!      do L = 1,L_                                                      
!       LZMID = ND+2-2*JNDLEV(L)                                        
!       LZ0 = ND+2-2*JNELEV(L)                                          
!         SUMT = 0.d0                                                   
!         SUMJ = 0.d0                                                   
!       do L2 = LZ0,LZ1-2,2                                             
!         SUMT = SUMT + ZTAU(L2+2,K)-ZTAU(L2,K)                         
!         SUMJ = SUMJ + (ZTAU(L2+2,K)-ZTAU(L2,K))*(FJ(L2,K)+FJ(L2+2,K)) 
!       enddo                                                           
!         FJACT2(L,K) = 2.d0*SUMJ/SUMT + FZ(LZMID,K)                    
!         LZ1 = LZ0                                                     
!      enddo                                                            
                                                                        
!---diffuse fluxes reflected at top, incident at bottom                 
         FJTOP(K) = FJT(K) 
         FJBOT(K) = FJB(K) 
                                                                        
             ! wavelength loop!                                         
      enddo 
 
!if( any(FJACT(:,:) < 0.0D0 )) then
!  write(*,*) 'Mie: find negative FJACT'
!  write(*,*) 'Mie: U0=', U0, ' ND=',ND
!  if (mpp_pe() == mpp_root_pe() ) then   
!   write(*,*) 'Mie: FJ diffusive', FJ
!   write(*,*) 'Mie: FZ solar at mid-layer', FZ
!   write(*,*) 'Mie: ZTAU', ZTAU
!   write(*,*) 'Mie: RFL', RFL
!   write(*,*) 'Mie: FJT', FJT
!   write(*,*) 'Mie: FJB', FJB
!   write(*,*) 'Mie: POMEGA', POMEGA
!   write(*,*) 'Mie: ZFLUX', ZFLUX
!   write(*,*) 'Mie: AMF2', AMF2
!   endif
!end if   
 
                                                                        
      return 
      END  subroutine OPMIE                                         
                                                                        
                                                                        
!<<<<<<<<<<<<<<<<<<<<<<<end core fast-J subroutines<<<<<<<<<<<<<<<<<<<<<
                                                                        
                                                                        
!<<<<<<<<<<<<<<<<<<<<<<<begin core scattering subroutines<<<<<<<<<<<<<<<
!-----------------------------------------------------------------------
      subroutine MIESCT(FJ,FJT,FJB, POMEGA,FZ,ZTAU,ZFLUX,RFL,U0,ND) 
!-----------------------------------------------------------------------
      implicit none 
!      include 'parm_MIE.f' 
                                                                        
      integer, intent(in) ::  ND 
      real*8, intent(in)  ::  POMEGA(M2_,N_,W_),FZ(N_,W_),ZTAU(N_,W_)   &
     &                       ,RFL(W_),U0,ZFLUX(W_)                      
      real*8, intent(out) ::  FJ(N_,W_),FJT(W_),FJB(W_) 
                                                                        
      real*8  PM(M_,M2_),PM0(M2_)          
      integer I, IM  ,K 
                                                                        
!-----------------------------------------------------------------------
!   This is an adaption of the Prather radiative transfer code, (mjp, 10/95)
!     Prather, 1974, Astrophys. J. 192, 787-792.                        
!         Sol_n of inhomogeneous Rayleigh scattering atmosphere.        
!         (original Rayleigh w/ polarization)                           
!     Cochran and Trafton, 1978, Ap.J., 219, 756-762.                   
!         Raman scattering in the atmospheres of the major planets.     
!         (first use of anisotropic code)                               
!     Jacob, Gottlieb and Prather, 1989, J.Geophys.Res., 94, 12975-13002
!         Chemistry of a polluted cloudy boundary layer,                
!         (documentation of extension to anisotropic scattering)        
!                                                                       
!    takes atmospheric structure and source terms from std J-code       
!    ALSO limited to 4 Gauss points, only calculates mean field! (M=1)  
!-----------------------------------------------------------------------
      do I = 1,M_                         ! M_ =4 fixed
       call LEGND0 (EMU(I),PM0,M2_)       ! EMU =gauss weighting, M2_=8, return PM0
       do IM = 1,M2_ 
         PM(I,IM) = PM0(IM) 
       enddo 
      enddo 
                                                                        
       call LEGND0 (-U0,PM0,M2_)         ! -cosz , 
       do IM=1,M2_ 
         PM0(IM) = 0.25d0*PM0(IM) 
       enddo 
                                                                        
!---BLKSLV now called with all the wavelength arrays (K=1:W_)           
                                                                        
      call BLKSLV(FJ,POMEGA,FZ,ZTAU,ZFLUX,RFL,PM,PM0,FJT,FJB, ND) 
                                                                        
      return 
      END subroutine MIESCT                                          
                                                                        
                                                                        
!-----------------------------------------------------------------------
      subroutine LEGND0 (X,PL,N) 
!-----------------------------------------------------------------------
!---Calculates ORDINARY Legendre fns of X (real)                        
!---   from P[0] = PL(1) = 1,  P[1] = X, .... P[N-1] = PL(N)            
      implicit none 
      integer, intent(in) :: N 
      real*8, intent(in)  :: X 
      real*8, intent(out) :: PL(N) 
      integer I 
      real*8  DEN 
!---Always does PL(2) = P[1]                                            
        PL(1) = 1.d0 
        PL(2) = X 
        do I = 3,N 
         DEN = (I-1) 
         PL(I) = PL(I-1)*X*(2.d0-1.0/DEN) - PL(I-2)*(1.d0-1.d0/DEN) 
        enddo 
      return 
      END subroutine LEGND0                                          
                                                                        
                                                                        
!-----------------------------------------------------------------------
      subroutine BLKSLV                                                 &
     &     (FJ,POMEGA,FZ,ZTAU,ZFLUX,RFL,PM,PM0,FJTOP,FJBOT,ND)          
!-----------------------------------------------------------------------
!  Sets up and solves the block tri-diagonal system:                    
!               A(I)*X(I-1) + B(I)*X(I) + C(I)*X(I+1) = H(I)            
!  This goes back to the old, dumb, fast version 5.3                    
!-----------------------------------------------------------------------
      implicit none 
!      include 'parm_MIE.f' 
!--- expect parameters M_, N_ in parm_MIE.f-----------------------------
                                                                        
      integer, intent(in) ::  ND                   !total Tau layers < N_
      real*8, intent(in)  ::  POMEGA(M2_,N_,W_),&  !phase fn  
                              FZ(N_,W_),&          !total attenuation of sun light from top layer to layer 
                              ZTAU(N_,W_)   &      !optical depth
     &                       ,PM(M_,M2_),&         !legender coef. at gauss points
                              PM0(M2_)&            !legendar coef at cosz
     &                       ,RFL(W_),&            !surface albedo
                              ZFLUX(W_)            !refected solar flux at surface layer
                        
      real*8, intent(out) ::  FJ(N_,W_),FJTOP(W_),FJBOT(W_) 
                                                                        
      real*8, dimension(M_,N_,W_)    ::  A,C,H,   RR 
                                                                        
      real*8, dimension(M_,M_,N_,W_) ::  B,AA,CC,  DD 
      real*8, dimension(W_,M_,M_) ::  F,E 
      real*8  SUMB,SUMBX,SUMT 
      integer I, J, K, L 
                                                                        
                                                                        
      do K=1,W_ 
       call GEN_ID (POMEGA(1,1,K),FZ(1,K),ZTAU(1,K),ZFLUX(K),RFL(K),    &
     &     PM,PM0, B(1,1,1,K),CC(1,1,1,K),AA(1,1,1,K),                  &
     &             A(1,1,K),H(1,1,K),C(1,1,K), ND)                      
      enddo 
                                                                        
!-----------UPPER BOUNDARY L=1                                          
      do K = 1,W_ 
       do J = 1,M_ 
        do I = 1,M_ 
         F(K,I,J) = B(I,J,1,K) 
        enddo 
       enddo 
      enddo 
                                                                        
      call MATINW (F,E) 
                                                                        
      do K = 1,W_ 
       do J = 1,M_ 
        do I = 1,M_ 
         DD(I,J,1,K) = -E(K,I,1)*CC(1,J,1,K)-E(K,I,2)*CC(2,J,1,K)       &
     &                 -E(K,I,3)*CC(3,J,1,K)-E(K,I,4)*CC(4,J,1,K)       
        enddo 
         RR(J,1,K) = E(K,J,1)*H(1,1,K)+E(K,J,2)*H(2,1,K)                &
     &              +E(K,J,3)*H(3,1,K)+E(K,J,4)*H(4,1,K)                
       enddo 
      enddo 
                                                                        
!----------CONTINUE THROUGH ALL DEPTH POINTS ID=2 TO ID=ND-1            
      do L = 2,ND-1 
                                                                        
       do K = 1,W_ 
        do J = 1,M_ 
         do I = 1,M_ 
          B(I,J,L,K) = B(I,J,L,K) + A(I,L,K)*DD(I,J,L-1,K) 
         enddo 
          H(J,L,K) = H(J,L,K) - A(J,L,K)*RR(J,L-1,K) 
        enddo 
                                                                        
        do J = 1,M_ 
         do I = 1,M_ 
          F(K,I,J) = B(I,J,L,K) 
         enddo 
        enddo 
       enddo 
                                                                        
       call MATINW (F,E) 
                                                                        
       do K = 1,W_ 
        do J = 1,M_ 
         do I = 1,M_ 
          DD(I,J,L,K) = - E(K,I,J)*C(J,L,K) 
         enddo 
          RR(J,L,K) = E(K,J,1)*H(1,L,K)+E(K,J,2)*H(2,L,K)               &
     &              + E(K,J,3)*H(3,L,K)+E(K,J,4)*H(4,L,K)               
        enddo 
       enddo 
                                                                        
      enddo 
                                                                        
!---------FINAL DEPTH POINT: L=ND                                       
      L = ND 
                                                                        
      do K = 1,W_ 
        do J = 1,M_ 
         do I = 1,M_ 
          B(I,J,L,K) = B(I,J,L,K)                                       &
     &     + AA(I,1,L,K)*DD(1,J,L-1,K) + AA(I,2,L,K)*DD(2,J,L-1,K)      &
     &     + AA(I,3,L,K)*DD(3,J,L-1,K) + AA(I,4,L,K)*DD(4,J,L-1,K)      
         enddo 
          H(J,L,K) = H(J,L,K)                                           &
     &     - AA(J,1,L,K)*RR(1,L-1,K) - AA(J,2,L,K)*RR(2,L-1,K)          &
     &     - AA(J,3,L,K)*RR(3,L-1,K) - AA(J,4,L,K)*RR(4,L-1,K)          
        enddo 
        do J = 1,M_ 
         do I = 1,M_ 
          F(K,I,J) = B(I,J,L,K) 
         enddo 
        enddo 
      enddo 
                                                                        
      call MATINW (F,E) 
                                                                        
       do K = 1,W_ 
        do J = 1,M_ 
         RR(J,L,K) = E(K,J,1)*H(1,L,K)+E(K,J,2)*H(2,L,K)                &
     &              +E(K,J,3)*H(3,L,K)+E(K,J,4)*H(4,L,K)                
        enddo 
       enddo 
!-----------BACK SOLUTION                                               
      do L = ND-1,1,-1 
       do K = 1,W_ 
        do J = 1,M_ 
         RR(J,L,K) = RR(J,L,K)                                          &
     &    + DD(J,1,L,K)*RR(1,L+1,K) + DD(J,2,L,K)*RR(2,L+1,K)           &
     &    + DD(J,3,L,K)*RR(3,L+1,K) + DD(J,4,L,K)*RR(4,L+1,K)           
        enddo 
       enddo 
      enddo 
                                                                        
!----------mean J & H                                                   
        FJ(:,:) = 0.d0 
      do L = 1,ND,2 
       do K = 1,W_ 
        FJ(L,K) = RR(1,L,K)*WT(1) + RR(2,L,K)*WT(2)                     &
     &          + RR(3,L,K)*WT(3) + RR(4,L,K)*WT(4)                     
       enddo 
      enddo 
      do L = 2,ND,2 
       do K = 1,W_ 
        FJ(L,K) = RR(1,L,K)*WT(1)*EMU(1) + RR(2,L,K)*WT(2)*EMU(2)       &
     &          + RR(3,L,K)*WT(3)*EMU(3) + RR(4,L,K)*WT(4)*EMU(4)       
       enddo 
      enddo 
                                                                        
!---FJTOP = scaled diffuse flux out top-of-atmosphere (limit = mu0)     
!---FJBOT = scaled diffuse flux onto surface:                           
!---ZFLUX = reflect/(1 + reflect) * mu0 * Fsolar(lower boundary)        
!---SUMBX = flux from Lambert reflected I+                              
      do K = 1,W_ 
                                                                        
       SUMT = RR(1, 1,K)*WT(1)*EMU(1) + RR(2, 1,K)*WT(2)*EMU(2)         &
     &      + RR(3, 1,K)*WT(3)*EMU(3) + RR(4, 1,K)*WT(4)*EMU(4)         
       SUMB = RR(1,ND,K)*WT(1)*EMU(1) + RR(2,ND,K)*WT(2)*EMU(2)         &
     &      + RR(3,ND,K)*WT(3)*EMU(3) + RR(4,ND,K)*WT(4)*EMU(4)         
       SUMBX = 4.d0*SUMB*RFL(K)/(1.0d0 + RFL(K)) + ZFLUX(K) 
                                                                        
       FJTOP(K) = 4.d0*SUMT 
       FJBOT(K) = 4.d0*SUMB - SUMBX 
                                                                        
      enddo 
                                                                        
      return 
      END subroutine BLKSLV                                          
                                                                        
                                                                        
!-----------------------------------------------------------------------
      subroutine GEN_ID(POMEGA,FZ,ZTAU,ZFLUX,RFL,PM,PM0                 &
     &              ,B,CC,AA,A,H,C,  ND)                                
!-----------------------------------------------------------------------
!  Generates coefficient matrices for the block tri-diagonal system:    
!               A(I)*X(I-1) + B(I)*X(I) + C(I)*X(I+1) = H(I)            
!-----------------------------------------------------------------------
      implicit none 
!      include 'parm_MIE.f' 
!--- expect parameters M_, N_ in parm_MIE.f-----------------------------
      integer, intent(in) ::  ND 
      real*8, intent(in)  ::  POMEGA(M2_,N_),PM(M_,M2_),PM0(M2_) 
      real*8, intent(in)  ::  ZFLUX,RFL 
      real*8, intent(in),dimension(N_) :: FZ,ZTAU 
                                                                        
      real*8, intent(out),dimension(M_,M_,N_) ::  B,AA,CC 
      real*8, intent(out),dimension(M_,N_) ::  A,C,H 
                                                                        
      integer I, J, K, L1,L2,LL 
      real*8  SUM0, SUM1, SUM2, SUM3 
      real*8  DELTAU, D1, D2, SURFAC 
!                                                                       
      real*8, dimension(M_,M_) :: S,T,U,V,W 
!---------------------------------------------                          
                                                                        
!---------upper boundary:  2nd-order terms                              
       L1 = 1 
       L2 = 2 
       do I = 1,M_ 
        SUM0 =                                                          &
     &   POMEGA(1,L1)*PM(I,1)*PM0(1) + POMEGA(3,L1)*PM(I,3)*PM0(3)      &
     & + POMEGA(5,L1)*PM(I,5)*PM0(5) + POMEGA(7,L1)*PM(I,7)*PM0(7)      
        SUM2 =                                                          &
     &   POMEGA(1,L2)*PM(I,1)*PM0(1) + POMEGA(3,L2)*PM(I,3)*PM0(3)      &
     & + POMEGA(5,L2)*PM(I,5)*PM0(5) + POMEGA(7,L2)*PM(I,7)*PM0(7)      
        SUM1 =                                                          &
     &   POMEGA(2,L1)*PM(I,2)*PM0(2) + POMEGA(4,L1)*PM(I,4)*PM0(4)      &
     & + POMEGA(6,L1)*PM(I,6)*PM0(6) + POMEGA(8,L1)*PM(I,8)*PM0(8)      
        SUM3 =                                                          &
     &   POMEGA(2,L2)*PM(I,2)*PM0(2) + POMEGA(4,L2)*PM(I,4)*PM0(4)      &
     & + POMEGA(6,L2)*PM(I,6)*PM0(6) + POMEGA(8,L2)*PM(I,8)*PM0(8)      
         H(I,L1) = 0.5d0*(SUM0*FZ(L1) + SUM2*FZ(L2)) 
         A(I,L1) = 0.5d0*(SUM1*FZ(L1) + SUM3*FZ(L2)) 
       enddo 
                                                                        
       do I = 1,M_ 
        do J = 1,I 
         SUM0 =                                                         &
     &   POMEGA(1,L1)*PM(I,1)*PM(J,1) + POMEGA(3,L1)*PM(I,3)*PM(J,3)    &
     & + POMEGA(5,L1)*PM(I,5)*PM(J,5) + POMEGA(7,L1)*PM(I,7)*PM(J,7)    
         SUM2 =                                                         &
     &   POMEGA(1,L2)*PM(I,1)*PM(J,1) + POMEGA(3,L2)*PM(I,3)*PM(J,3)    &
     & + POMEGA(5,L2)*PM(I,5)*PM(J,5) + POMEGA(7,L2)*PM(I,7)*PM(J,7)    
         SUM1 =                                                         &
     &   POMEGA(2,L1)*PM(I,2)*PM(J,2) + POMEGA(4,L1)*PM(I,4)*PM(J,4)    &
     & + POMEGA(6,L1)*PM(I,6)*PM(J,6) + POMEGA(8,L1)*PM(I,8)*PM(J,8)    
         SUM3 =                                                         &
     &   POMEGA(2,L2)*PM(I,2)*PM(J,2) + POMEGA(4,L2)*PM(I,4)*PM(J,4)    &
     & + POMEGA(6,L2)*PM(I,6)*PM(J,6) + POMEGA(8,L2)*PM(I,8)*PM(J,8)    
         S(I,J) = - SUM2*WT(J) 
         S(J,I) = - SUM2*WT(I) 
         T(I,J) = - SUM1*WT(J) 
         T(J,I) = - SUM1*WT(I) 
         V(I,J) = - SUM3*WT(J) 
         V(J,I) = - SUM3*WT(I) 
         B(I,J,L1) = - 0.5d0*(SUM0 + SUM2)*WT(J) 
         B(J,I,L1) = - 0.5d0*(SUM0 + SUM2)*WT(I) 
        enddo 
       enddo 
                                                                        
       do I = 1,M_ 
         S(I,I)   = S(I,I)   + 1.0d0 
         T(I,I)   = T(I,I)   + 1.0d0 
         V(I,I)   = V(I,I)   + 1.0d0 
         B(I,I,L1)= B(I,I,L1) + 1.0d0 
                                                                        
         C(I,L1)= S(I,1)*A(1,L1)/EMU(1) + S(I,2)*A(2,L1)/EMU(2)         &
     &          + S(I,3)*A(3,L1)/EMU(3) + S(I,4)*A(4,L1)/EMU(4)         
       enddo 
                                                                        
       do I = 1,M_ 
        do J = 1,M_ 
         W(J,I) = S(J,1)*T(1,I)/EMU(1) + S(J,2)*T(2,I)/EMU(2)           &
     &          + S(J,3)*T(3,I)/EMU(3) + S(J,4)*T(4,I)/EMU(4)           
         U(J,I) = S(J,1)*V(1,I)/EMU(1) + S(J,2)*V(2,I)/EMU(2)           &
     &          + S(J,3)*V(3,I)/EMU(3) + S(J,4)*V(4,I)/EMU(4)           
        enddo 
       enddo 
!-------------upper boundary, 2nd-order, C-matrix is full (CC)          
         DELTAU = ZTAU(L2) - ZTAU(L1) 
         D2 = 0.25d0*DELTAU 
       do I = 1,M_ 
        do J = 1,M_ 
         B(I,J,L1) = B(I,J,L1) + D2*W(I,J) 
         CC(I,J,L1) = D2*U(I,J) 
        enddo 
         H(I,L1) = H(I,L1) + 2.0d0*D2*C(I,L1) 
         A(I,L1) = 0.0d0 
       enddo 
       do I = 1,M_ 
        D1 = EMU(I)/DELTAU 
        B(I,I,L1)  = B(I,I,L1) + D1 
        CC(I,I,L1) = CC(I,I,L1) - D1 
       enddo 
                                                                        
!------------intermediate points:  can be even or odd, A & C diagonal   
!---mid-layer h-points, Legendre terms 2,4,6,8                          
       do LL=2,ND-1,2 
        DELTAU = ZTAU(LL+1) - ZTAU(LL-1) 
        do I = 1,M_ 
          A(I,LL) = EMU(I)/DELTAU 
          C(I,LL) = -A(I,LL) 
          H(I,LL) = FZ(LL)*(                                            &
     &     POMEGA(2,LL)*PM(I,2)*PM0(2) + POMEGA(4,LL)*PM(I,4)*PM0(4)    &
     &   + POMEGA(6,LL)*PM(I,6)*PM0(6) + POMEGA(8,LL)*PM(I,8)*PM0(8))   
        enddo 
        do I = 1,M_ 
         do J=1,I 
          SUM0 =                                                        &
     &     POMEGA(2,LL)*PM(I,2)*PM(J,2) + POMEGA(4,LL)*PM(I,4)*PM(J,4)  &
     &    +POMEGA(6,LL)*PM(I,6)*PM(J,6) + POMEGA(8,LL)*PM(I,8)*PM(J,8)  
          B(I,J,LL) =  - SUM0*WT(J) 
          B(J,I,LL) =  - SUM0*WT(I) 
         enddo 
        enddo 
        do I = 1,M_ 
          B(I,I,LL) = B(I,I,LL) + 1.0d0 
        enddo 
       enddo 
                                                                        
!---odd-layer j-points, Legendre terms 1,3,5,7                          
       do LL=3,ND-2,2 
        DELTAU = ZTAU(LL+1) - ZTAU(LL-1) 
        do I = 1,M_ 
          A(I,LL) = EMU(I)/DELTAU 
          C(I,LL) = -A(I,LL) 
          H(I,LL) = FZ(LL)*(                                            &
     &     POMEGA(1,LL)*PM(I,1)*PM0(1) + POMEGA(3,LL)*PM(I,3)*PM0(3)    &
     &   + POMEGA(5,LL)*PM(I,5)*PM0(5) + POMEGA(7,LL)*PM(I,7)*PM0(7))   
        enddo 
        do I = 1,M_ 
         do J=1,I 
          SUM0 =                                                        &
     &     POMEGA(1,LL)*PM(I,1)*PM(J,1) + POMEGA(3,LL)*PM(I,3)*PM(J,3)  &
     &    +POMEGA(5,LL)*PM(I,5)*PM(J,5) + POMEGA(7,LL)*PM(I,7)*PM(J,7)  
          B(I,J,LL) =  - SUM0*WT(J) 
          B(J,I,LL) =  - SUM0*WT(I) 
         enddo 
        enddo 
        do I = 1,M_ 
          B(I,I,LL) = B(I,I,LL) + 1.0d0 
        enddo 
       enddo 
                                                                        
!---------lower boundary:  2nd-order terms                              
       L1 = ND 
       L2 = ND-1 
       do I = 1,M_ 
        SUM0 =                                                          &
     &   POMEGA(1,L1)*PM(I,1)*PM0(1) + POMEGA(3,L1)*PM(I,3)*PM0(3)      &
     & + POMEGA(5,L1)*PM(I,5)*PM0(5) + POMEGA(7,L1)*PM(I,7)*PM0(7)      
        SUM2 =                                                          &
     &   POMEGA(1,L2)*PM(I,1)*PM0(1) + POMEGA(3,L2)*PM(I,3)*PM0(3)      &
     & + POMEGA(5,L2)*PM(I,5)*PM0(5) + POMEGA(7,L2)*PM(I,7)*PM0(7)      
        SUM1 =                                                          &
     &   POMEGA(2,L1)*PM(I,2)*PM0(2) + POMEGA(4,L1)*PM(I,4)*PM0(4)      &
     & + POMEGA(6,L1)*PM(I,6)*PM0(6) + POMEGA(8,L1)*PM(I,8)*PM0(8)      
        SUM3 =                                                          &
     &   POMEGA(2,L2)*PM(I,2)*PM0(2) + POMEGA(4,L2)*PM(I,4)*PM0(4)      &
     & + POMEGA(6,L2)*PM(I,6)*PM0(6) + POMEGA(8,L2)*PM(I,8)*PM0(8)      
         H(I,L1) = 0.5d0*(SUM0*FZ(L1) + SUM2*FZ(L2)) 
         A(I,L1) = 0.5d0*(SUM1*FZ(L1) + SUM3*FZ(L2)) 
       enddo 
                                                                        
       do I = 1,M_ 
        do J = 1,I 
         SUM0 =                                                         &
     &    POMEGA(1,L1)*PM(I,1)*PM(J,1) + POMEGA(3,L1)*PM(I,3)*PM(J,3)   &
     &  + POMEGA(5,L1)*PM(I,5)*PM(J,5) + POMEGA(7,L1)*PM(I,7)*PM(J,7)   
         SUM2 =                                                         &
     &    POMEGA(1,L2)*PM(I,1)*PM(J,1) + POMEGA(3,L2)*PM(I,3)*PM(J,3)   &
     &  + POMEGA(5,L2)*PM(I,5)*PM(J,5) + POMEGA(7,L2)*PM(I,7)*PM(J,7)   
         SUM1 =                                                         &
     &    POMEGA(2,L1)*PM(I,2)*PM(J,2) + POMEGA(4,L1)*PM(I,4)*PM(J,4)   &
     &  + POMEGA(6,L1)*PM(I,6)*PM(J,6) + POMEGA(8,L1)*PM(I,8)*PM(J,8)   
         SUM3 =                                                         &
     &    POMEGA(2,L2)*PM(I,2)*PM(J,2) + POMEGA(4,L2)*PM(I,4)*PM(J,4)   &
     &  + POMEGA(6,L2)*PM(I,6)*PM(J,6) + POMEGA(8,L2)*PM(I,8)*PM(J,8)   
         S(I,J) = - SUM2*WT(J) 
         S(J,I) = - SUM2*WT(I) 
         T(I,J) = - SUM1*WT(J) 
         T(J,I) = - SUM1*WT(I) 
         V(I,J) = - SUM3*WT(J) 
         V(J,I) = - SUM3*WT(I) 
         B(I,J,L1) = - 0.5d0*(SUM0 + SUM2)*WT(J) 
         B(J,I,L1) = - 0.5d0*(SUM0 + SUM2)*WT(I) 
        enddo 
       enddo 
                                                                        
       do I = 1,M_ 
         S(I,I)   = S(I,I)   + 1.0d0 
         T(I,I)   = T(I,I)   + 1.0d0 
         V(I,I)   = V(I,I)   + 1.0d0 
         B(I,I,L1)= B(I,I,L1) + 1.0d0 
                                                                        
         C(I,L1)= S(I,1)*A(1,L1)/EMU(1) + S(I,2)*A(2,L1)/EMU(2)         &
     &          + S(I,3)*A(3,L1)/EMU(3) + S(I,4)*A(4,L1)/EMU(4)         
       enddo 
                                                                        
       do I = 1,M_ 
        do J = 1,M_ 
         W(J,I) = S(J,1)*T(1,I)/EMU(1) + S(J,2)*T(2,I)/EMU(2)           &
     &          + S(J,3)*T(3,I)/EMU(3) + S(J,4)*T(4,I)/EMU(4)           
         U(J,I) = S(J,1)*V(1,I)/EMU(1) + S(J,2)*V(2,I)/EMU(2)           &
     &          + S(J,3)*V(3,I)/EMU(3) + S(J,4)*V(4,I)/EMU(4)           
        enddo 
       enddo 
                                                                        
!------------lower boundary, 2nd-order, A-matrix is full (AA)           
         DELTAU = ZTAU(L1) - ZTAU(L2) 
         D2 = 0.25d0*DELTAU 
         SURFAC = 4.0d0*RFL/(1.0d0 + RFL) 
       do I = 1,M_ 
          D1 = EMU(I)/DELTAU 
          SUM0 = D1 + D2*(W(I,1)+W(I,2)+W(I,3)+W(I,4)) 
          SUM1 = SURFAC*SUM0 
        do J = 1,M_ 
         AA(I,J,L1) = - D2*U(I,J) 
         B(I,J,L1) = B(I,J,L1) + D2*W(I,J) - SUM1*EMU(J)*WT(J) 
        enddo 
         H(I,L1) = H(I,L1) - 2.0d0*D2*C(I,L1) + SUM0*ZFLUX 
       enddo 
                                                                        
       do I = 1,M_ 
          D1 = EMU(I)/DELTAU 
        AA(I,I,L1) = AA(I,I,L1) + D1 
        B(I,I,L1)  = B(I,I,L1) + D1 
        C(I,L1) = 0.0d0 
       enddo 
                                                                        
      return 
      END subroutine GEN_ID                                          
                                                                        
                                                                        
!-----------------------------------------------------------------------
      subroutine MATINW (B,A) 
!-----------------------------------------------------------------------
!  invert 4x4 matrix B(4,4) with L-U decomposition, return as A(4,4) (mjp, old)
      implicit none 
!      include 'parm_MIE.f' 
      real*8, intent(in)   ::  B(W_,4,4) 
      real*8, intent(out)  ::  A(W_,4,4) 
                                                                        
      A(:,:,:) = B(:,:,:) 
!---SETUP L AND U                                                       
      A(:,2,1) = A(:,2,1)/A(:,1,1) 
      A(:,2,2) = A(:,2,2)-A(:,2,1)*A(:,1,2) 
      A(:,2,3) = A(:,2,3)-A(:,2,1)*A(:,1,3) 
      A(:,2,4) = A(:,2,4)-A(:,2,1)*A(:,1,4) 
      A(:,3,1) = A(:,3,1)/A(:,1,1) 
      A(:,3,2) = (A(:,3,2)-A(:,3,1)*A(:,1,2))/A(:,2,2) 
      A(:,3,3) = A(:,3,3)-A(:,3,1)*A(:,1,3)-A(:,3,2)*A(:,2,3) 
      A(:,3,4) = A(:,3,4)-A(:,3,1)*A(:,1,4)-A(:,3,2)*A(:,2,4) 
      A(:,4,1) = A(:,4,1)/A(:,1,1) 
      A(:,4,2) = (A(:,4,2)-A(:,4,1)*A(:,1,2))/A(:,2,2) 
      A(:,4,3) = (A(:,4,3)-A(:,4,1)*A(:,1,3)-A(:,4,2)*A(:,2,3))/A(:,3,3) 
      A(:,4,4) =                                                        &
     &    A(:,4,4)-A(:,4,1)*A(:,1,4)-A(:,4,2)*A(:,2,4)-A(:,4,3)*A(:,3,4)
!---INVERT L                                                            
      A(:,4,3) = -A(:,4,3) 
      A(:,4,2) = -A(:,4,2)-A(:,4,3)*A(:,3,2) 
      A(:,4,1) = -A(:,4,1)-A(:,4,2)*A(:,2,1)-A(:,4,3)*A(:,3,1) 
      A(:,3,2) = -A(:,3,2) 
      A(:,3,1) = -A(:,3,1)-A(:,3,2)*A(:,2,1) 
      A(:,2,1) = -A(:,2,1) 
!---INVERT U                                                            
      A(:,4,4) = 1.d0/A(:,4,4) 
      A(:,3,4) = -A(:,3,4)*A(:,4,4)/A(:,3,3) 
      A(:,3,3) = 1.d0/A(:,3,3) 
      A(:,2,4) = -(A(:,2,3)*A(:,3,4)+A(:,2,4)*A(:,4,4))/A(:,2,2) 
      A(:,2,3) = -A(:,2,3)*A(:,3,3)/A(:,2,2) 
      A(:,2,2) = 1.d0/A(:,2,2) 
      A(:,1,4) =                                                        &
     & -(A(:,1,2)*A(:,2,4)+A(:,1,3)*A(:,3,4)+A(:,1,4)*A(:,4,4))/A(:,1,1)
      A(:,1,3) = -(A(:,1,2)*A(:,2,3)+A(:,1,3)*A(:,3,3))/A(:,1,1) 
      A(:,1,2) = -A(:,1,2)*A(:,2,2)/A(:,1,1) 
      A(:,1,1) = 1.d0/A(:,1,1) 
!---MULTIPLY (:,U-INVERSE)*(:,L-INVERSE)                                
      A(:,1,1) =                                                        &
     &   A(:,1,1)+A(:,1,2)*A(:,2,1)+A(:,1,3)*A(:,3,1)+A(:,1,4)*A(:,4,1) 
      A(:,1,2) = A(:,1,2)+A(:,1,3)*A(:,3,2)+A(:,1,4)*A(:,4,2) 
      A(:,1,3) = A(:,1,3)+A(:,1,4)*A(:,4,3) 
      A(:,2,1) = A(:,2,2)*A(:,2,1)+A(:,2,3)*A(:,3,1)+A(:,2,4)*A(:,4,1) 
      A(:,2,2) = A(:,2,2)+A(:,2,3)*A(:,3,2)+A(:,2,4)*A(:,4,2) 
      A(:,2,3) = A(:,2,3)+A(:,2,4)*A(:,4,3) 
      A(:,3,1) = A(:,3,3)*A(:,3,1)+A(:,3,4)*A(:,4,1) 
      A(:,3,2) = A(:,3,3)*A(:,3,2)+A(:,3,4)*A(:,4,2) 
      A(:,3,3) = A(:,3,3)+A(:,3,4)*A(:,4,3) 
      A(:,4,1) = A(:,4,4)*A(:,4,1) 
      A(:,4,2) = A(:,4,4)*A(:,4,2) 
      A(:,4,3) = A(:,4,4)*A(:,4,3) 
                                                                        
      return 
      END  subroutine MATINW                                          
end module MO_FASTJX_MOD

                 module aerosolrad_package_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="">
! </REVIEWER>
! <OVERVIEW>
!    aerosolrad_package_mod provides the radiative properties 
!    associated with the atmospheric aerosols.
! </OVERVIEW>
! <DESCRIPTION>
! </DESCRIPTION>
!    shared modules:

use mpp_mod,               only: input_nml_file
use fms_mod,               only: open_namelist_file, fms_init, &
                                 mpp_pe, mpp_root_pe, stdlog, &
                                 file_exist, write_version_number, &
                                 check_nml_error, error_mesg, &
                                 FATAL, NOTE, close_file
use mpp_io_mod,            only: mpp_open, mpp_close, MPP_RDONLY,   &
                                 MPP_ASCII, MPP_SEQUENTIAL, MPP_MULTI, &
                                 MPP_SINGLE, mpp_io_init
use time_manager_mod,      only: time_type, time_manager_init,  &
                                 get_date, set_date, operator(+), &
                                 print_date, operator(-), operator(>)
use diag_manager_mod,      only: diag_manager_init, get_base_time
use interpolator_mod,      only: interpolate_type, interpolator_init, &
                                 interpolator, interpolator_end, &
                                 obtain_interpolator_time_slices, &
                                 unset_interpolator_time_flag, &
                                 CONSTANT, INTERP_WEIGHTED_P

! shared radiation package modules:
                                
use rad_utilities_mod,     only: Sw_control, &
                                 Lw_control, &
                                 Rad_control,&
                                 aerosol_type, aerosol_properties_type,&
                                 aerosol_diagnostics_type, &
                                 Lw_parameters, rad_utilities_init, &
                                 thickavg
use esfsw_parameters_mod,  only: Solar_spect, esfsw_parameters_init 
use longwave_params_mod,   only: NBLW, longwave_params_init

!-------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!    aerosolrad_package_mod provides the radiative properties 
!    associated with the atmospheric aerosols.
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module -------------------

character(len=128)  :: version =  '$Id: aerosolrad_package.F90,v 20.0 2013/12/13 23:18:56 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!---------------------------------------------------------------------
!-------  interfaces --------

public           &
       aerosolrad_package_init, aerosol_radiative_properties, &
       aerosolrad_package_alloc, aerosolrad_package_time_vary, &
       aerosolrad_package_endts, &
       aerosolrad_package_end,  get_aerosol_optical_info, &
       get_aerosol_optical_index
     
private          &

!  called from aerosolrad_package_init: 
   assign_aerosol_opt_props, read_optical_input_file, &
   sw_aerosol_interaction,  lw_aerosol_interaction
       

!---------------------------------------------------------------------
!-------- namelist  ---------

integer, parameter   ::        &
             MAX_OPTICAL_FIELDS = 1000  ! maximum number of aerosol 
                                       ! optical property types
logical              ::        &
             do_lwaerosol = .false.    ! aerosol efects included in lw
                                       ! radiation ?
logical              ::        &
             do_swaerosol = .false.    ! aerosol effects included in sw
                                       ! radiation ?
logical              ::        &
             force_to_repro_quebec = .false.
                                       ! if true, code sequence is 
                                       ! executed which reproduces
                                       ! quebec+ answers for 
                                       ! AM3p8e in pre_Riga
character(len=48)    ::        &
             aerosol_data_set = ' '    ! source of aerosol data; if 
                                       ! aerosols not desired remains
                                       ! ' ', otherwise is set to either
                                       ! 'shettle_fenn' or 
                                       ! 'Ginoux_Reddy'

!----------------------------------------------------------------------
!    the avaialable aerosol datasets are :
!    1) "shettle_fenn":  
!        Ref: shettle, e.p. and r.w. fenn, models for the aerosols of 
!            the lower atmosphere and the effects of humidity variations
!            on their optical properties,afgl-tr-79-0214,1979,94pp.    
!    2) "Ginoux_Reddy": 3D Aerosol fields are generated online reflecting
!        emissions, transport and deposition:
!        Ref: Reddy et al., 2005, Ginoux et al., 2005
!        
!----------------------------------------------------------------------

character(len=64)    ::        &
             aerosol_optical_names(MAX_OPTICAL_FIELDS) = '  '
                                       ! names associated with the 
                                       ! optical property types that
                                       ! are to be used in this 
                                       ! experiment
character(len=64)    ::        &
             optical_filename = ' '    ! name of file containing the
                                       ! aerosol optical property types
logical              ::        &
             using_volcanic_sw_files = .false.
                                       ! files containing sw aerosol
                                       ! optical properties from vol-
                                       ! canic activity are to be
                                       ! used to supplement those cal-
                                       ! culated by model ?
logical              ::        &
             using_volcanic_lw_files = .false.
                                       ! files containing lw aerosol
                                       ! optical properties from vol-
                                       ! canic activity are to be
                                       ! used to supplement those cal-
                                       ! culated by model ?
character(len=64)    ::        &
              sw_ext_filename = ' '    ! name of file containing the
                                       ! aerosol sw extinction optical
                                       ! depth
character(len=64)    ::        &
              sw_ssa_filename = ' '    ! name of file containing the
                                       ! aerosol sw single scattering 
                                       ! albedo
character(len=64)    ::        &
              sw_asy_filename = ' '    ! name of file containing the
                                       ! aerosol sw asymmetry factor   
character(len=64)    ::        &
              lw_ext_filename = ' '    ! name of file containing the
                                       ! aerosol lw extinction optical
                                       ! depth
character(len=64)    ::        &
              lw_ssa_filename = ' '    ! name of file containing the
                                       ! aerosol lw single scattering 
                                       ! albedo
character(len=64)    ::        &
              lw_asy_filename = ' '    ! name of file containing the
                                       ! aerosol lw asymmetry factor   
                                       ! the supplemental input files
character(len=64)    ::        &
              sw_ext_root                  = '   ' 
                                       ! names given to sw extopdep in
                                       ! input netcdf file
character(len=64)    ::        &
              sw_ssa_root                  = '   ' 
                                       ! name given to sw single scat-
                                       ! tering albedo in input netcdf 
                                       ! file
character(len=64)    ::        &
              sw_asy_root                  = '   ' 
                                       ! name given to sw asymmetry
                                       ! factor in input netcdf file
character(len=64)    ::        &
              lw_ext_root                  = '   ' 
                                       ! name given to lw extopdep in
                                       ! input netcdf file
character(len=64)    ::        &
              lw_ssa_root                  = '   '  
                                       ! name given to lw single scat-
                                       ! tering albedo in input netcdf 
                                       ! file
character(len=64)    ::        &
              lw_asy_root                  = '   '      
                                       ! name given to lw asymmetry
                                       ! factor in input netcdf file
integer, dimension(6) ::       &
              volcanic_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /) 
                                       ! time in volcanic data set
                                       ! corresponding to model
                                       ! initial time 
                                       ! (yr, mo, dy, hr, mn, sc)
logical :: interpolating_volcanic_data = .true.
                                       ! volcanic datasets will be
                                       ! time interpolated rather than
                                       ! held constant for a month ?
logical :: repeat_volcano_year = .false. 
                                      ! the same single year's data from
                                      ! the input data set should be 
                                      ! used for each model year ?
integer :: volcano_year_used = 0      ! year of volcanic data to repeat
                                      ! when repeat_volcano_year is
                                      ! .true.
logical :: using_im_bcsul = .false.   ! bc and sulfate aerosols are 
                                      ! treated as an internal mixture ?
integer, dimension(0:100) ::  omphilic_indices = (/        &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0  /)
integer, dimension(0:100) ::  bcphilic_indices = (/        &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0  /)
integer, dimension(0:100) ::  seasalt1_indices = (/        &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0  /)
integer, dimension(0:100) ::  seasalt2_indices = (/        &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0  /)
integer, dimension(0:100) ::  seasalt3_indices = (/        &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0  /)
integer, dimension(0:100) ::  seasalt4_indices = (/        &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0  /)
integer, dimension(0:100) ::  seasalt5_indices = (/        &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, &
                             0  /)
integer, dimension(0:100) ::  sulfate_indices = (/      &
                           30,30,30,30,30,30,30,30,30,30,30,30,30,30, &
                           30,30,30,30,30,30,30,30,30,30,30,30,30,30, &
                           30,30,30,30,30,35,35,35,35,35,40,40,40,40, &
                           40,45,45,45,45,45,50,50,50,50,50,55,55,55, &
                           55,55,60,60,60,60,60,65,65,65,65,65,70,70, &
                           70,70,70,75,75,75,75,75,80,80,80,80,82,82, &
                           84,84,86,86,88,88,90,91,92,93,94,95,96,97, &
                           98,99,100 /)
!yim
integer, dimension(0:100) ::  sulfate_vol_indices = (/      &
                             100,98,98,96,96,94,94,92,92,90,90,88,88,86,86,84,84,82,82,80, &
                             80,80,80,75,75,75,75,75,70,70,70,70,70,65,65,65, &
                             65,65,60,60,60,60,60,55,55,55,55,55,50,50,50,50,50,45,45,45, &
                             45,45,40,40,40,40,40,35,35,35,35,35,30,30,30,30,30,25,25,25, &
                             25,25,20,20,20,20,20,15,15,15,15,15,10,10,10,10,10,5,5,5, &
                             5,5,0,0,0  /)


namelist / aerosolrad_package_nml /                          &
                                    do_lwaerosol, do_swaerosol, &
                                    force_to_repro_quebec, &
                                    aerosol_data_set, &
                                    aerosol_optical_names, &
                                    sulfate_indices, &
                                    sulfate_vol_indices, &
                                    omphilic_indices, &
                                    bcphilic_indices, &
                                    seasalt1_indices, &
                                    seasalt2_indices, &
                                    seasalt3_indices, &
                                    seasalt4_indices, &
                                    seasalt5_indices, &
                                    optical_filename   , &
                                    using_volcanic_sw_files, &
                                    using_volcanic_lw_files, &
                                    volcanic_dataset_entry, &
                                    interpolating_volcanic_data, &
                                    repeat_volcano_year, &
                                    volcano_year_used, &
                                    using_im_bcsul, &
                                    sw_ext_filename, sw_ssa_filename, &
                                    sw_asy_filename, lw_ext_filename, &
                                    lw_ssa_filename, lw_asy_filename, &
                                    sw_ext_root, sw_ssa_root,   &
                                    sw_asy_root, lw_ext_root,   &
                                    lw_ssa_root, lw_asy_root

!---------------------------------------------------------------------
!------- public data ------


!---------------------------------------------------------------------
!------- private data ------


!---------------------------------------------------------------------
!   the following are interpolate_type variables containing the
!   additional aerosol optical properties that may be included as
!   input to the radiation package.
!---------------------------------------------------------------------
type(interpolate_type), save  :: Sw_aer_extopdep_interp
type(interpolate_type), save  :: Sw_aer_ssalb_interp
type(interpolate_type), save  :: Sw_aer_asymm_interp
type(interpolate_type), save  :: Lw_aer_extopdep_interp
type(interpolate_type), save  :: Lw_aer_ssalb_interp
type(interpolate_type), save  :: Lw_aer_asymm_interp

!---------------------------------------------------------------------
!    the following variables define the number and type of different
!    bands over which the radiation package calculates aerosol 
!    radiative properties.
!---------------------------------------------------------------------
integer, parameter ::    &
         N_AEROSOL_BANDS_FR = 8 ! number of non-continuum ir aerosol
                                ! emissivity bands 
integer, parameter ::     &
         N_AEROSOL_BANDS_CO = 1 ! number of continuum ir aerosol
                                ! emissivity bands  
integer, parameter ::     &
         N_AEROSOL_BANDS_CN = 1 ! number of diagnostic continuum ir 
                                ! aerosol emissivity bands  
integer, parameter ::    &
         N_AEROSOL_BANDS = N_AEROSOL_BANDS_FR + N_AEROSOL_BANDS_CO
                                ! total number of ir aerosol emissivity
                                ! bands 

!--------------------------------------------------------------------
!    num_wavenumbers is the number of wavenumber bands over which the
!    aerosol parameterization provides aerosol radiative property data.
!--------------------------------------------------------------------
integer     ::  num_wavenumbers = 0 ! number of wavenumber bands 
                                    ! present in the aerosol 
                                    ! parameterization

!----------------------------------------------------------------------
!    the following variable defines the number of aerosol property 
!    types that are active.
!----------------------------------------------------------------------
integer     :: naermodels = 0   ! number of aerosol optical properties
                                ! types that are active

!---------------------------------------------------------------------
!    flags indicating an index value characteristic of the optical prop-
!    erties associated with different aerosols
!---------------------------------------------------------------------
integer, PARAMETER ::   SULFATE_FLAG =  0
integer, PARAMETER ::  OMPHILIC_FLAG = -1
integer, PARAMETER ::  BCPHILIC_FLAG = -2
integer, PARAMETER ::  SEASALT1_FLAG = -3
integer, PARAMETER ::  SEASALT2_FLAG = -4
integer, PARAMETER ::  SEASALT3_FLAG = -5
integer, PARAMETER ::  SEASALT4_FLAG = -6
integer, PARAMETER ::  SEASALT5_FLAG = -7
!yim
integer, PARAMETER ::  BC_FLAG = -8
integer, PARAMETER ::  NOT_IN_USE = -2000

!----------------------------------------------------------------------
!    the following index arrays contain the mapping information between 
!    actual model relative humidity and the available enties in the 
!    aerosol optical properties file.
!----------------------------------------------------------------------
integer, dimension(:,:), allocatable :: sulfate_index
integer, dimension(:),   allocatable :: optical_index
integer, dimension(:),   allocatable :: omphilic_index
integer, dimension(:),   allocatable :: bcphilic_index
integer, dimension(:),   allocatable :: seasalt1_index
integer, dimension(:),   allocatable :: seasalt2_index
integer, dimension(:),   allocatable :: seasalt3_index
integer, dimension(:),   allocatable :: seasalt4_index
integer, dimension(:),   allocatable :: seasalt5_index

!---------------------------------------------------------------------
!    the following arrays related to sw aerosol effects are allocated 
!    during initialization and retained throughout the integration.
!    here n refers to the bands of the solar parameterization, ni
!    to the bands of the aerosol parameterization, and na to the optical
!    properties type.
!
!      solivlaero(n,ni)  amount of toa incoming solar from solar
!                        spectral band n that is in aerosol parameter-
!                        ization band ni
!      nivl1aero(n)      the aerosol band index corresponding to the 
!                        lowest wave number of spectral band n
!      nivl2aero(n)      the aerosol band index corresponding to the 
!                        highest wave number of spectral band n
!      endaerwvnsf(ni)   ending wave number of aerosol parameterization
!                        band ni
!      aeroextivl(ni,na) extinction coefficient for aerosol parameter-
!                        ization band ni for aerosol optical property 
!                        type na
!      aerossalbivl(ni,na) 
!                        single-scattering albedo for aerosol band 
!                        ni and aerosol optical property type na
!      aeroasymmivl(ni,na)
!                        asymmetry factor for aerosol band ni  and 
!                        aerosol optical property type na
!
!---------------------------------------------------------------------
real,    dimension(:,:), allocatable   :: solivlaero  
integer, dimension(:),   allocatable   :: nivl1aero, nivl2aero
integer, dimension(:),   allocatable   :: endaerwvnsf
real,    dimension(:,:), allocatable   :: aeroextivl, aerossalbivl, &
                                          aeroasymmivl

!---------------------------------------------------------------------
!    sfl following arrays related to lw aerosol effects are allocated 
!    during initialization and retained throughout the integration.
!
!    sflwwts(n,ni)     the fraction of the planck function in aerosol 
!                      emissivity band n that is in aerosol param-
!                      eterization band ni
!
!----------------------------------------------------------------------
real,    dimension(:,:), allocatable   :: sflwwts, sflwwts_cn

!--------------------------------------------------------------------
!    logical flags 
!--------------------------------------------------------------------
logical :: module_is_initialized      = .false. ! module has been
                                                ! initialized ?
!logical :: doing_predicted_aerosols   = .false. ! predicted aerosol 
                                                ! scheme being used ?
logical :: band_calculation_completed = .false. ! lw properties have
                                                ! been calculated ?

type(time_type) :: Model_init_time  ! initial calendar time for model  
                                    ! [ time_type ]
type(time_type) :: Volcanic_offset  ! difference between model initial
                                    ! time and volcanic timeseries app-
                                    ! lied at model initial time
                                    ! [ time_type ]
type(time_type) :: Volcanic_entry   ! time in volcanic timeseries which
                                    ! is mapped to model initial time
                                    ! [ time_type ]
logical    :: negative_offset = .false.
                                !  the model initial time is later than
                                !  the volcanic_dataset_entry time  ?
integer :: nfields_sw_ext = 0   ! number of fields contained in 
                                ! supplemental sw_ext file
integer :: nfields_sw_ssa = 0   ! number of fields contained in 
                                ! supplemental sw_ssa file
integer :: nfields_sw_asy = 0   ! number of fields contained in 
                                ! supplemental sw_asy file
integer :: nfields_lw_ext = 0   ! number of fields contained in 
                                ! supplemental lw_ext file
integer :: nfields_lw_ssa = 0   ! number of fields contained in 
                                ! supplemental lw_ssa file
integer :: nfields_lw_asy = 0   ! number of fields contained in 
                                ! supplemental lw_asy file

!-------------------------------------------------------------------
!   arrays holding variable names:
character(len=64), dimension(:), allocatable ::   &
                                sw_ext_name, sw_ssa_name, sw_asy_name, &
                                lw_ext_name, lw_ssa_name, lw_asy_name

!-------------------------------------------------------------------
!    arrays to hold data when not interpolating on every step:
real, dimension(:,:,:,:), allocatable :: sw_ext_save
real, dimension(:,:,:,:), allocatable :: sw_ssa_save
real, dimension(:,:,:,:), allocatable :: sw_asy_save
real, dimension(:,:,:,:), allocatable :: lw_ext_save
real, dimension(:,:,:,:), allocatable :: lw_ssa_save
real, dimension(:,:,:,:), allocatable :: lw_asy_save

!---------------------------------------------------------------------
!   module variables to hold values unchanging in time:
!---------------------------------------------------------------------
real, dimension(:,:), allocatable :: aerextband_MOD
real, dimension(:,:), allocatable :: aerssalbband_MOD
real, dimension(:,:), allocatable :: aerasymmband_MOD
real, dimension(:,:), allocatable :: aerextbandlw_MOD
real, dimension(:,:), allocatable :: aerssalbbandlw_MOD
real, dimension(:,:), allocatable :: aerextbandlw_cn_MOD
real, dimension(:,:), allocatable :: aerssalbbandlw_cn_MOD

!---------------------------------------------------------------------
!    logical variables indicating whether interpolation is currently
!    needed:
logical :: need_sw_ext = .true.
logical :: need_sw_ssa = .true.
logical :: need_sw_asy = .true.
logical :: need_lw_ext = .true.
logical :: need_lw_ssa = .true.
logical :: need_lw_asy = .true.

!---------------------------------------------------------------------
!    logical variables indicating whether the particular radiative 
!    property associated with volcanoes is being supplied:
logical :: using_sw_ext = .false. 
logical :: using_sw_ssa = .false. 
logical :: using_sw_asy = .false. 
logical :: using_lw_ext = .false. 
logical :: using_lw_ssa = .false. 
logical :: using_lw_asy = .false. 

!---------------------------------------------------------------------
!    counters associated with determining when interpolation needs to
!    be done:
logical :: mo_save_set = .false.
integer :: mo_save = 0
integer :: mo_new

type(time_type) :: Volcano_time
integer :: nfields_save
integer :: num_sul, num_bc
integer, dimension(:), allocatable :: sul_ind, bc_ind

!---------------------------------------------------------------------
!---------------------------------------------------------------------
 


                         contains
 

 
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!#####################################################################
! <SUBROUTINE NAME="aerosolrad_package_init">
!  <OVERVIEW>
!     aerosolrad_package_init is the constructor for 
!     aerosolrad_package_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!     aerosolrad_package_init is the constructor for 
!     aerosolrad_package_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call aerosolrad_package_init (aerosol_names)
!  </TEMPLATE>
!  <IN NAME="aerosol_names" TYPE="character">
!   names of the activated aerosol species
!  </IN>
! </SUBROUTINE>
!
subroutine aerosolrad_package_init (kmax, aerosol_names, lonb, latb)

!---------------------------------------------------------------------
!     aerosolrad_package_init is the constructor for 
!     aerosolrad_package_mod.
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!character(len=64), dimension(:), intent(in)  :: aerosol_names
integer,                        intent(in)  :: kmax
character(len=*), dimension(:), intent(in)  :: aerosol_names
real, dimension(:,:),           intent(in)  :: lonb,latb



!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  intent(in) variables:
!
!      kmax              number of model levels
!      aerosol_names     the names assigned to each of the activated
!                        aerosol species
!       lonb           2d array of model longitudes at cell corners
!                      [ radians ]
!       latb           2d array of model latitudes at cell corners
!                      [ radians ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables:

      integer        :: unit, ierr, io, logunit
      integer        :: n
      character(len=16) :: chvers
      character(len=4)  :: chyr  

!---------------------------------------------------------------------
!  local variables:
!
!        unit            io unit number used for namelist file
!        ierr            error code
!        io              error status returned from io operation
!
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return
 
!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call mpp_io_init
      call fms_init
      call diag_manager_init
      call time_manager_init
      call rad_utilities_init
      call esfsw_parameters_init
      call longwave_params_init

       nfields_save = size(aerosol_names(:))

!-----------------------------------------------------------------------
!    read namelist.
!-----------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=aerosolrad_package_nml, iostat=io)
      ierr = check_nml_error(io,'aerosolrad_package_nml')
#else   
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=aerosolrad_package_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'aerosolrad_package_nml')
        end do
10      call close_file (unit)
      endif
#endif
 
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                          write (logunit, nml=aerosolrad_package_nml)

!---------------------------------------------------------------------
!   exit if aerosols are desired with the lacis-hansen parameterization.
!---------------------------------------------------------------------
     if (Sw_control%do_lhsw_iz) then
       if (Sw_control%do_lhsw .and. do_swaerosol) then
         call error_mesg ('aerosolrad_package_mod', &
         ' cannot activate sw aerosols with lhsw', FATAL)
        endif
     else
       call error_mesg ('aerosolrad_package_mod', &
        'Sw_control%do_lhsw not yet initialized', FATAL)
     endif

!----------------------------------------------------------------------
!    define control variables which indicate whether the impact of 
!    aerosols on radiation is to be included in the sw and lw rad-
!    iation calculations. define a control variable which will be true 
!    if aerosols are included in either the sw or the lw radiation 
!    (Rad_control%do_aerosol).
!----------------------------------------------------------------------
      Sw_control%do_swaerosol = do_swaerosol
      Lw_control%do_lwaerosol = do_lwaerosol
      if (Rad_control%do_lwaerosol_forcing_iz .and. &
          Rad_control%do_swaerosol_forcing_iz) then

      if (do_lwaerosol .or. do_swaerosol  .or.  &
          using_volcanic_lw_files .or. using_volcanic_sw_files .or. &
         Rad_control%do_lwaerosol_forcing .or.  &
         Rad_control%do_swaerosol_forcing)  then
        Rad_control%do_aerosol = .true.
      else
        Rad_control%do_aerosol = .false.
      endif
      else
        call error_mesg ('aerosolrad_package_mod', &
         ' using Rad_control%do_{l,s}waerosol_forcing  before it &
                                             &is defined', FATAL)
      endif

!--------------------------------------------------------------------
!    mark the just defined logicals as initialized.
!--------------------------------------------------------------------
      Sw_control%do_swaerosol_iz = .true.        
      Lw_control%do_lwaerosol_iz = .true.        
      Rad_control%do_aerosol_iz  = .true.
     
!----------------------------------------------------------------------
!    store the control variable indicating whether aerosol internal
!    mixture is being assumed.
!----------------------------------------------------------------------
      Rad_control%using_im_bcsul = using_im_bcsul
      Rad_control%using_im_bcsul_iz = .true.

!---------------------------------------------------------------------
!    exit if an aerosol_data_set is provided when do_aerosol is 
!    .false..
!---------------------------------------------------------------------
      if ( .not. Rad_control%do_aerosol .and.    &
           trim(aerosol_data_set) /= ' ') then
        call error_mesg ('aerosolrad_package_mod', &
           'if aerosol impacts are not desired, aerosol_data_set '//&
            'must be set to "   "', FATAL)
      endif

!---------------------------------------------------------------------
!    exit if no aerosol_data_set is provided when do_aerosol  
!    is .true..
!---------------------------------------------------------------------
      if ( Rad_control%do_aerosol .and.    &
           trim(aerosol_data_set) == ' ') then
        call error_mesg ('aerosolrad_package_mod', &
           'if aerosol impacts are desired, aerosol_data_set '//&
            'must be non-blank', FATAL)
      endif

!---------------------------------------------------------------------
!    exit if aerosol effects are desired but the aerosol input file
!    provided no aerosol fields.
!---------------------------------------------------------------------
      if (Rad_control%do_aerosol .and. size(aerosol_names(:)) == 0) then
        call error_mesg ('aerosolrad_package_mod', &
          ' aerosols desired  for radiation but no aerosol '//&
            'data_names supplied', FATAL)
      endif


!----------------------------------------------------------------------
!    if aerosol radiative effects are to be included, call 
!    assign_aerosol_opt_props to assign the proper aerosol 
!    properties type to each aerosol type. then call 
!    read_optical_input_file to read the optical input file contain-
!    ing the aerosol parameterization information and data.
!----------------------------------------------------------------------
      if (Rad_control%do_aerosol) then
        call assign_aerosol_opt_props (aerosol_names)
        call read_optical_input_file
      endif
 
!---------------------------------------------------------------------
!    if aerosol effects are to be included in the sw calculation,
!    call sw_aerosol_interaction to define the weights needed to prop-
!    erly map the input data from the aerosol parameterization bands to 
!    the solar parameterization bands that the model is using.
!--------------------------------------------------------------------
      if (do_swaerosol .or. Rad_control%do_swaerosol_forcing) then
        call sw_aerosol_interaction                 
      endif

!---------------------------------------------------------------------
!    if aerosol effects are to be included in the lw calculation,
!    call lw_aerosol_interaction to define the weights needed to prop-
!    erly map the input data from the aerosol parameterization bands to 
!    the solar parameterization bands that the model is using. if
!    they are not, indicate that this part of the code has been 
!    executed.
!---------------------------------------------------------------------
      if (do_lwaerosol .or. Rad_control%do_lwaerosol_forcing) then
        call lw_aerosol_interaction
      else
        Lw_parameters%n_lwaerosol_bands_iz = .true.
      endif

!---------------------------------------------------------------------
!    make sure consistent nml settings are present. Cannot use volcanic
!    aerosols unless model aerosols are also activated.
!---------------------------------------------------------------------
      if (.not. do_swaerosol  .and.   &
          using_volcanic_sw_files) then
        call error_mesg ('aerosolrad_package_mod', &
         'cant use sw volcanic aerosols without activating standard &
                                               & sw aerosols', FATAL)
      endif
      if (.not. do_lwaerosol  .and.   &
          using_volcanic_lw_files) then
        call error_mesg ('aerosolrad_package_mod', &
         'cant use lw volcanic aerosols without activating standard &
                                               & lw aerosols', FATAL)
      endif

!---------------------------------------------------------------------
!    set the volcanic control variables to .false. when the model 
!    aerosols are not active.
!---------------------------------------------------------------------
      Rad_control%volcanic_lw_aerosols = using_volcanic_lw_files
      Rad_control%volcanic_lw_aerosols_iz = .true.
      Rad_control%volcanic_sw_aerosols = using_volcanic_sw_files
      Rad_control%volcanic_sw_aerosols_iz = .true.

!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the volcanic files are
!    to be used; if not present, the dataset entry point is taken as
!    the model base_time, defined in the diag_table.
!---------------------------------------------------------------------
      Model_init_time = get_base_time()
      if (using_volcanic_sw_files .or.  &
          using_volcanic_lw_files) then
        if (volcanic_dataset_entry(1) == 1 .and. &
            volcanic_dataset_entry(2) == 1 .and. &
            volcanic_dataset_entry(3) == 1 .and. &
            volcanic_dataset_entry(4) == 0 .and. &
            volcanic_dataset_entry(5) == 0 .and. &
            volcanic_dataset_entry(6) == 0 ) then      
          Volcanic_entry = Model_init_time

!----------------------------------------------------------------------
!    define the offset from model base time  (defined in diag_table) 
!    to volcanic_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
      else
        Volcanic_entry  = set_date (volcanic_dataset_entry(1), &
                                    volcanic_dataset_entry(2), &
                                    volcanic_dataset_entry(3), &
                                    volcanic_dataset_entry(4), &
                                    volcanic_dataset_entry(5), &
                                    volcanic_dataset_entry(6))
       endif
     else
       Volcanic_entry  = set_date (volcanic_dataset_entry(1), &
                                   volcanic_dataset_entry(2), &
                                   volcanic_dataset_entry(3), &
                                   volcanic_dataset_entry(4), &
                                   volcanic_dataset_entry(5), &
                                   volcanic_dataset_entry(6))

      endif
      if (using_volcanic_sw_files .or.  &
          using_volcanic_lw_files) then
        if (repeat_volcano_year) then
          if (volcano_year_used == 0) then
            call error_mesg ('aerosolrad_package_init', &
              'valid year must be supplied when &
                       &repeat_volcano_year is .true.', FATAL)
          endif
        endif
        call print_date(Volcanic_entry , str='Data from volcano &
                                           &timeseries at time:')
        call print_date(Model_init_time , str='This data is mapped to &
                                                  &model time:')
        if (repeat_volcano_year) then
          write (chyr, '(i4)') volcano_year_used
          call error_mesg ('aerosolrad_package_init', &
           'volcanic data from dataset year '  // chyr // ' will be &
                                    &used for all model years.', NOTE)
        endif
      endif
      Volcanic_offset = Volcanic_entry - Model_init_time

      if (Model_init_time > Volcanic_entry) then
        negative_offset = .true.
      else
        negative_offset = .false.
      endif

!-----------------------------------------------------------------------
!    if desired, process the sw extinction coefficient file. allocate 
!    space for and define the names of each variable. if not interpol-
!    ating the data, allocate an array to store it between timesteps. 
!    call interpolator_init to initialize the interpolation module for
!    the file.
!-----------------------------------------------------------------------
      if (using_volcanic_sw_files) then
        if (trim(sw_ext_root) /= ' '  ) then
          nfields_sw_ext = Solar_spect%nbands
          allocate (sw_ext_name (nfields_sw_ext))
          if (.not. interpolating_volcanic_data) then
            allocate (sw_ext_save(size(lonb,1)-1, size(latb,2)-1, &
                                  kmax, nfields_sw_ext) )
            sw_ext_save = 0.0
          endif
          do n=1, nfields_sw_ext
            if (n<= 9) then
              write (chvers, '(i1)') n
             sw_ext_name(n) = trim(sw_ext_root) // '_b0' // trim(chvers)
            else if (n <= 99) then
              write (chvers, '(i2)') n
              sw_ext_name(n) = trim(sw_ext_root) // '_b' // trim(chvers)
            else 
              call error_mesg ('aerosolrad_package_mod', &
                  ' code only handles up to 100 fields', FATAL)
            endif
          end do
          call interpolator_init (Sw_aer_extopdep_interp,  &
                                  sw_ext_filename, lonb, latb,  &
                                  sw_ext_name(:nfields_sw_ext),   &
                                  data_out_of_bounds=(/CONSTANT/), &
                                  vert_interp=(/INTERP_WEIGHTED_P/) )  
          using_sw_ext = .true.
        endif

!--------------------------------------------------------------------
!    if desired, process the sw single scattering albedo file. allocate 
!    space for and define the names of each variable. if not interpol-
!    ating the data, allocate an array to store it between timesteps. 
!    call interpolator_init to initialize the interpolation module for
!    the file.
!-----------------------------------------------------------------------
        if (trim(sw_ssa_root) /= ' '  ) then
          nfields_sw_ssa = Solar_spect%nbands
          allocate (sw_ssa_name (nfields_sw_ssa))
          if (.not. interpolating_volcanic_data) then
            allocate (sw_ssa_save(size(lonb,1)-1, size(latb,2)-1, &
                                  kmax, nfields_sw_ssa) )
            sw_ssa_save = 0.0
          endif
          do n=1, nfields_sw_ssa
            if (n<= 9) then
              write (chvers, '(i1)') n
             sw_ssa_name(n) = trim(sw_ssa_root) // '_b0' // trim(chvers)
            else if (n <= 99) then
              write (chvers, '(i2)') n
              sw_ssa_name(n) = trim(sw_ssa_root) // '_b' // trim(chvers)
            else 
              call error_mesg ('aerosolrad_package_mod', &
                  ' code only handles up to 100 fields', FATAL)
            endif
          end do
          call interpolator_init (Sw_aer_ssalb_interp,   &
                                  sw_ssa_filename,  lonb, latb,    &
                                  sw_ssa_name(:nfields_sw_ssa),   &
                                  data_out_of_bounds=(/CONSTANT/), &
                                  vert_interp=(/INTERP_WEIGHTED_P/) ) 
          using_sw_ssa = .true.
        endif

!--------------------------------------------------------------------
!    if desired, process the sw asymmetry factor file. allocate 
!    space for and define the names of each variable. if not interpol-
!    ating the data, allocate an array to store it between timesteps. 
!    call interpolator_init to initialize the interpolation module for
!    the file.
!-----------------------------------------------------------------------
        if (trim(sw_asy_root)    /= ' '  ) then
          nfields_sw_asy = Solar_spect%nbands
          allocate (sw_asy_name (nfields_sw_asy))
          if (.not. interpolating_volcanic_data) then
            allocate (sw_asy_save(size(lonb,1)-1, size(latb,2)-1, &
                                  kmax, nfields_sw_asy) )
            sw_asy_save = 0.0
          endif
          do n=1, nfields_sw_asy
            if (n<= 9) then
              write (chvers, '(i1)') n
             sw_asy_name(n) = trim(sw_asy_root) // '_b0' // trim(chvers)
            else if (n <= 99) then
              write (chvers, '(i2)') n
              sw_asy_name(n) = trim(sw_asy_root) // '_b' // trim(chvers)
            else 
              call error_mesg ('aerosolrad_package_mod', &
                  ' code only handles up to 100 fields', FATAL)
            endif
          end do
          call interpolator_init (Sw_aer_asymm_interp,   &
                                  sw_asy_filename, lonb, latb,   &
                                  sw_asy_name(:nfields_sw_asy),   &
                                  data_out_of_bounds=(/CONSTANT/), &
                                  vert_interp=(/INTERP_WEIGHTED_P/) )  
          using_sw_asy = .true.
        endif
      endif

!-----------------------------------------------------------------------
!    if desired, process the lw extinction coefficient file. allocate 
!    space for and define the names of each variable. if not interpol-
!    ating the data, allocate an array to store it between timesteps. 
!    call interpolator_init to initialize the interpolation module for
!    the file.
!-----------------------------------------------------------------------
      if (using_volcanic_lw_files) then
        if (trim(lw_ext_root)    /= ' '  ) then
          nfields_lw_ext = N_AEROSOL_BANDS
          allocate (lw_ext_name (nfields_lw_ext))
          if (.not. interpolating_volcanic_data) then
            allocate (lw_ext_save(size(lonb,1)-1, size(latb,2)-1, &
                                  kmax, nfields_lw_ext) )
            lw_ext_save = 0.0
          endif
          do n=1, nfields_lw_ext
            if (n<= 9) then
              write (chvers, '(i1)') n
             lw_ext_name(n) = trim(lw_ext_root) // '_b0' // trim(chvers)
            else if (n <= 99) then
              write (chvers, '(i2)') n
              lw_ext_name(n) = trim(lw_ext_root) // '_b' // trim(chvers)
            else 
              call error_mesg ('aerosolrad_package_mod', &
                  ' code only handles up to 100 fields', FATAL)
            endif
          end do
          call interpolator_init (Lw_aer_extopdep_interp,   &
                                  lw_ext_filename, lonb,  latb,  &
                                  lw_ext_name(:nfields_lw_ext),   &
                                  data_out_of_bounds=(/CONSTANT/), &
                                  vert_interp=(/INTERP_WEIGHTED_P/) )
          using_lw_ext= .true.
        endif

!--------------------------------------------------------------------
!    if desired, process the lw single scattering albedo file.  it 
!    currently is not needed with the sea lw radiation package. allocate
!    space for and define the names of each variable. call 
!    interpolator_init to initialize the interpolation module for the 
!    file.
!-----------------------------------------------------------------------
        if (trim(lw_ssa_root)    /= ' '  ) then
          nfields_lw_ssa = N_AEROSOL_BANDS
          allocate (lw_ssa_name (nfields_lw_ssa))
          if (.not. interpolating_volcanic_data) then
            allocate (lw_ssa_save(size(lonb,1)-1, size(latb,2)-1, &
                                  kmax, nfields_lw_ssa) )
            lw_ssa_save = 0.0
          endif
          do n=1, nfields_lw_ssa
            if (n<= 9) then
              write (chvers, '(i1)') n
             lw_ssa_name(n) = trim(lw_ssa_root) // '_b0' // trim(chvers)
            else if (n <= 99) then
              write (chvers, '(i2)') n
              lw_ssa_name(n) = trim(lw_ssa_root) // '_b' // trim(chvers)
            else 
              call error_mesg ('aerosolrad_package_mod', &
                  ' code only handles up to 100 fields', FATAL)
            endif
          end do
          call interpolator_init (Lw_aer_ssalb_interp,  &
                                  lw_ssa_filename, lonb, latb,  &
                                  lw_ssa_name(:nfields_lw_ssa),   &
                                  data_out_of_bounds=(/CONSTANT/), &
                                  vert_interp=(/INTERP_WEIGHTED_P/) )  
          using_lw_ssa = .true.
        endif

!--------------------------------------------------------------------
!    if desired, process the lw asymmetry factor file.  it currently is
!    not needed with the sea lw radiation package. allocate space for 
!    and define the names of each variable. call interpolator_init to
!    initialize the interpolation module for the file.
!-----------------------------------------------------------------------
        if (trim(lw_asy_root)    /= ' '  ) then
          nfields_lw_asy = N_AEROSOL_BANDS
          allocate (lw_asy_name (nfields_lw_asy))
          if (.not. interpolating_volcanic_data) then
            allocate (lw_asy_save(size(lonb,1)-1, size(latb,2)-1, &
                                  kmax, nfields_lw_asy) )
            lw_asy_save = 0.0
          endif
          do n=1, nfields_lw_asy
            if (n<= 9) then
              write (chvers, '(i1)') n
             lw_asy_name(n) = trim(lw_asy_root) // '_b0' // trim(chvers)
            else if (n <= 99) then
              write (chvers, '(i2)') n
              lw_asy_name(n) = trim(lw_asy_root) // '_b' // trim(chvers)
            else 
              call error_mesg ('aerosolrad_package_mod', &
                  ' code only handles up to 100 fields', FATAL)
            endif
          end do
          call interpolator_init (Lw_aer_asymm_interp,   &
                                   lw_asy_filename,  lonb, latb,  &
                                   lw_asy_name(:nfields_lw_asy),   &
                                   data_out_of_bounds=(/CONSTANT/), &
                                   vert_interp=(/INTERP_WEIGHTED_P/) )  
          using_lw_asy = .true.
        endif
     endif

!---------------------------------------------------------------------
!    mark the module as initialized.
!---------------------------------------------------------------------
      module_is_initialized = .true.

!----------------------------------------------------------------------


end subroutine aerosolrad_package_init


!##########################################################################

subroutine aerosolrad_package_time_vary (Time)

!-------------------------------------------------------------------------
!    aerosolrad_package_time_vary performs time-dependent, space-independent
!    caluclations for this module
!-------------------------------------------------------------------------

type(time_type),         intent(in)   :: Time


      integer  :: yr, mo, dy, hr, mn, sc
      integer  :: na, ni, nw
      type(aerosol_properties_type) :: Aerosol_props_tem
      
    
!---------------------------------------------------------------------
!    define the time for which the volcanic properties will be obtained.
!---------------------------------------------------------------------
        if (using_volcanic_sw_files .or.   &
            using_volcanic_lw_files) then
          if (negative_offset) then
             Volcano_time = Time - Volcanic_offset
          else 
             Volcano_time = Time + Volcanic_offset
          endif
          if (repeat_volcano_year) then
            call get_date (Volcano_time, yr, mo, dy, hr, mn, sc)
            Volcano_time = set_date (volcano_year_used, mo,dy,hr,mn,sc)
          endif

!--------------------------------------------------------------------
!    decide whether the volcanic data must be interpolated on this step.
!    if interpolating_volcanic_data is true, then all variables will
!    always be interpolated. when this is not .true., determine if the
!    month of the data desired has changed from the previous value. if
!    it has set the Volcano_time to 12Z on the 15th of the month, and
!    indicate that new data is needed. On the initial call of the job,
!    one always obtains the data (mo_save_set = .false.).
!--------------------------------------------------------------------
          if (interpolating_volcanic_data) then
            need_sw_ext = .true.
            need_sw_ssa = .true.
            need_sw_asy = .true.
            need_lw_ext = .true.
            need_lw_ssa = .true.
            need_lw_asy = .true.
          else
            call get_date (Volcano_time, yr,mo,dy,hr,mn,sc)
            Volcano_time =  set_date (yr, mo,15,12,0,0)
            if (mo_save_set) then
              if (mo /= mo_save) then
                mo_new = mo       
                need_sw_ext = .true.
                need_sw_ssa = .true.
                need_sw_asy = .true.
                need_lw_ext = .true.
                need_lw_ssa = .true.
                need_lw_asy = .true.
              endif
            else
              need_sw_ext = .true.
              need_sw_ssa = .true.
              need_sw_asy = .true.
              need_lw_ext = .true.
              need_lw_ssa = .true.
              need_lw_asy = .true.
            endif
          endif
        endif ! (using_volcanic_lw or using_volcanic_sw)

!--------------------------------------------------------------------
!    if the volcanic sw aerosol extinction is being supplied, make sure
!    needed time slices are available.
!--------------------------------------------------------------------
        if (using_sw_ext) then
          if (need_sw_ext) then
            if (nfields_sw_ext >= 1) then
              call obtain_interpolator_time_slices  &
                              (Sw_aer_extopdep_interp, Volcano_Time)
            endif
          endif
        endif

!--------------------------------------------------------------------
!    if the volcanic sw aerosol single scattering albedo is being 
!    supplied, make sure needed time slices are available.
!--------------------------------------------------------------------
        if (using_sw_ssa) then
          if (need_sw_ssa) then
            if (nfields_sw_ssa >= 1) then
              call obtain_interpolator_time_slices  &
                              (Sw_aer_ssalb_interp, Volcano_Time)
            endif
          endif
        endif

!--------------------------------------------------------------------
!    if the volcanic sw aerosol asymmetry factor is being supplied, 
!    make sure needed time slices are available.
!--------------------------------------------------------------------
        if (using_sw_asy) then
          if (need_sw_asy) then
            if (nfields_sw_asy >= 1) then
              call obtain_interpolator_time_slices  &
                              (Sw_aer_asymm_interp, Volcano_Time)
            endif
          endif
        endif

!--------------------------------------------------------------------
!    if the volcanic lw aerosol extinction is being supplied, 
!    make sure needed time slices are available.
!--------------------------------------------------------------------
        if (using_lw_ext) then
          if (need_lw_ext) then
            if (nfields_lw_ext >= 1) then
              call obtain_interpolator_time_slices  &
                              (Lw_aer_extopdep_interp, Volcano_Time)
            endif
          endif
        endif

!--------------------------------------------------------------------
!    if the volcanic lw single scattering albedo is being supplied, 
!    make sure needed time slices are available.
!--------------------------------------------------------------------
        if (using_lw_ssa) then
          if (need_lw_ssa) then
            if (nfields_lw_ssa >= 1) then
              call obtain_interpolator_time_slices  &
                              (Lw_aer_ssalb_interp, Volcano_Time)
            endif
          endif
        endif

!--------------------------------------------------------------------
!    if the volcanic lw aerosol asymmetry factor is being supplied, 
!    obtain the appropriate data.
!--------------------------------------------------------------------
        if (using_lw_asy) then
          if (need_lw_asy) then
            if (nfields_lw_asy >= 1) then
              call obtain_interpolator_time_slices  &
                              (Lw_aer_asymm_interp, Volcano_Time)
            endif
          endif
        endif

          if (force_to_repro_quebec) then
            if (.not. band_calculation_completed) then
              allocate (Aerosol_props_tem%aerextbandlw  &
                                       (N_AEROSOL_BANDS, naermodels))
              allocate (Aerosol_props_tem%aerssalbbandlw  &
                                       (N_AEROSOL_BANDS, naermodels))
              allocate (Aerosol_props_tem%aerextbandlw_cn &
                                       (N_AEROSOL_BANDS_CN, naermodels))
              allocate (Aerosol_props_tem%aerssalbbandlw_cn  &
                                       (N_AEROSOL_BANDS_CN, naermodels))
              aerextbandlw_MOD = 0.0                          
              aerssalbbandlw_MOD = 0.0
              aerextbandlw_cn_MOD = 0.0                              
              aerssalbbandlw_cn_MOD = 0.0
              Aerosol_props_tem%aerextbandlw = 0.0               
              Aerosol_props_tem%aerssalbbandlw = 0.0                 
              Aerosol_props_tem%aerextbandlw_cn = 0.0
              Aerosol_props_tem%aerssalbbandlw_cn = 0.0
              do nw=1,naermodels    
                do na=1,N_AEROSOL_BANDS  
                  do ni=1,num_wavenumbers 
                    Aerosol_props_tem%aerextbandlw(na,nw) =   &
                               Aerosol_props_tem%aerextbandlw(na,nw) + &
                                aeroextivl(ni,nw)*sflwwts(na,ni)*1.0E+03
                    Aerosol_props_tem%aerssalbbandlw(na,nw) =   &
                              Aerosol_props_tem%aerssalbbandlw(na,nw) +   &
                                     aerossalbivl(ni,nw)*sflwwts(na,ni)
                  end do
                end do
              end do
              do nw=1,naermodels    
                do na=1,N_AEROSOL_BANDS_CN
                  do ni=1,num_wavenumbers 
                    Aerosol_props_tem%aerextbandlw_cn(na,nw) = &
                         Aerosol_props_tem%aerextbandlw_cn(na,nw) + &
                            aeroextivl(ni,nw)*sflwwts_cn(na,ni)*1.0E+03
                    Aerosol_props_tem%aerssalbbandlw_cn(na,nw) =    &
                           Aerosol_props_tem%aerssalbbandlw_cn(na,nw) +&
                                  aerossalbivl(ni,nw)*sflwwts_cn(na,ni)
                  end do
                end do
              end do

              aerextbandlw_MOD = Aerosol_props_tem%aerextbandlw
              aerssalbbandlw_MOD = Aerosol_props_tem%aerssalbbandlw
              aerextbandlw_cn_MOD = Aerosol_props_tem%aerextbandlw_cn
              aerssalbbandlw_cn_MOD = Aerosol_props_tem%aerssalbbandlw_cn
              band_calculation_completed = .true.
              deallocate (Aerosol_props_tem%aerextbandlw)
              deallocate (Aerosol_props_tem%aerssalbbandlw)
              deallocate (Aerosol_props_tem%aerextbandlw_cn)
              deallocate (Aerosol_props_tem%aerssalbbandlw_cn)
            endif
          endif

!---------------------------------------------------------------------------


end subroutine aerosolrad_package_time_vary 

!######################################################################

subroutine aerosolrad_package_alloc (ix, jx, kx, Aerosol_props)

integer,                       intent(in) :: ix, jx, kx
type(aerosol_properties_type), intent(inout) :: Aerosol_props


        if (Rad_control%volcanic_sw_aerosols) then
          allocate (Aerosol_props%sw_ext (ix,jx,kx, nfields_sw_ext))
          allocate (Aerosol_props%sw_ssa (ix,jx,kx,nfields_sw_ssa))
          allocate (Aerosol_props%sw_asy (ix,jx,kx,nfields_sw_asy))
        endif
        if (Rad_control%volcanic_lw_aerosols) then
          allocate (Aerosol_props%lw_ext (ix,jx,kx, nfields_lw_ext))
          allocate (Aerosol_props%lw_ssa (ix,jx,kx,nfields_lw_ssa))
          allocate (Aerosol_props%lw_asy (ix,jx,kx,nfields_lw_asy))
        endif
        allocate (Aerosol_props%ivol(ix,jx,kx))
        if (Rad_control%do_swaerosol_forcing .or.  &
                                         Sw_control%do_swaerosol) then
          allocate (Aerosol_props%aerextband   &
                                      (Solar_spect%nbands, naermodels))
          allocate (Aerosol_props%aerssalbband &
                                      (Solar_spect%nbands, naermodels))
          allocate (Aerosol_props%aerasymmband &
                                      (Solar_spect%nbands, naermodels))
        endif
        if (Rad_control%do_lwaerosol_forcing .or.  &
                                         Lw_control%do_lwaerosol) then
          allocate (Aerosol_props%aerextbandlw  &
                                      (N_AEROSOL_BANDS, naermodels))
          allocate (Aerosol_props%aerssalbbandlw  &
                                      (N_AEROSOL_BANDS, naermodels))
          allocate (Aerosol_props%aerextbandlw_cn &
                                      (N_AEROSOL_BANDS_CN, naermodels))
          allocate (Aerosol_props%aerssalbbandlw_cn  &
                                      (N_AEROSOL_BANDS_CN, naermodels))
        endif
        if (Rad_control%using_im_bcsul) then
          allocate (Aerosol_props%sulfate_index (0:100, 0:100))
        else
          allocate (Aerosol_props%sulfate_index (0:100, 0:0))
        endif
        allocate (Aerosol_props%optical_index (nfields_save))
        allocate (Aerosol_props%omphilic_index(0:100))
        allocate (Aerosol_props%bcphilic_index(0:100))
        allocate (Aerosol_props%seasalt1_index(0:100))
        allocate (Aerosol_props%seasalt2_index(0:100))
        allocate (Aerosol_props%seasalt3_index(0:100))
        allocate (Aerosol_props%seasalt4_index(0:100))
        allocate (Aerosol_props%seasalt5_index(0:100))

!--------------------------------------------------------------------


end subroutine aerosolrad_package_alloc


subroutine aerosolrad_package_endts

!---------------------------------------------------------------------
!    when data is not always interpolated, set flags to indicate whether
!    data must be obtained on the next call to this subroutine. if 
!    the current call has obtained data, set the flag indicating that 
!    data is not needed on the next call. also set the flag to indicate 
!    that the initial call has been completed (mo_save_set), and that 
!    the month for which data was obtained has been defined (mo_save). 
!---------------------------------------------------------------------
        if (.not. interpolating_volcanic_data) then
          if (need_sw_ext) then
              need_sw_ext = .false.
              need_sw_ssa = .false.
              need_sw_asy = .false.
              need_lw_ext = .false.
              mo_save_set = .true.
              mo_save = mo_new
          endif
        endif

      if (using_sw_ext) then
        call unset_interpolator_time_flag (Sw_aer_extopdep_interp)
      endif
      if (using_sw_ssa) then
        call unset_interpolator_time_flag (Sw_aer_ssalb_interp)
      endif
      if (using_sw_asy) then
        call unset_interpolator_time_flag (Sw_aer_asymm_interp)
      endif
      if (using_lw_ext) then
        call unset_interpolator_time_flag (Lw_aer_extopdep_interp)
      endif
      if (using_sw_ssa) then
        call unset_interpolator_time_flag (Lw_aer_ssalb_interp)
      endif
      if (using_sw_asy) then
        call unset_interpolator_time_flag (Lw_aer_asymm_interp)
      endif

end subroutine aerosolrad_package_endts


!####################################################################
! <SUBROUTINE NAME="aerosol_radiative_properties">
!  <OVERVIEW>
!    aerosol_radiative_properties defines and returns the radiative
!    properties for each aerosol properties type and for each solar
!    parameterization band in the shortwave and for each aerosol 
!    emissivity band in the longwave.
!  </OVERVIEW>
!  <DESCRIPTION>
!    aerosol_radiative_properties defines and returns the radiative
!    properties for each aerosol properties type and for each solar
!    parameterization band in the shortwave and for each aerosol 
!    emissivity band in the longwave.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call aerosol_radiative_properties (is, ie, js, je, &
!                                         Aerosol, Aerosol_props)
!  </TEMPLATE>
!  <IN NAME="Aerosol" TYPE="aerosol_type">
!   Aerosol climatology input
!  </IN>
!  <INOUT NAME="Aerosol_props" TYPE="aerosol_properties_type">
!   Aerosol radiative properties in radiation package
!  </INOUT>
!  <IN NAME="is, ie" TYPE="integer">
!   The longitude index of model physics window domain
!  </IN>
!  <IN NAME="js, je" TYPE="integer">
!   The latitude index of model physics window domain
!  </IN>
! </SUBROUTINE>
!
subroutine aerosol_radiative_properties (is, ie, js, je, &
                                         Time, p_half, Aerosol_diags, &
                                         Aerosol, Aerosol_props)

!---------------------------------------------------------------------
!    aerosol_radiative_properties defines and returns the radiative
!    properties for each aerosol properties type and for each solar
!    parameterization band in the shortwave and for each aerosol 
!    emissivity band in the longwave.
!---------------------------------------------------------------------

integer,                       intent(in)    :: is, ie, js, je
type(time_type),               intent(in)    :: Time
real, dimension(:,:,:),        intent(in)    :: p_half
type(aerosol_type),            intent(in)    :: Aerosol
type(aerosol_diagnostics_type), intent(inout) :: Aerosol_diags
type(aerosol_properties_type), intent(inout) :: Aerosol_props
 
!----------------------------------------------------------------------
! local variables:                                                     

      integer  :: na, nw, ni       ! do-loop indices
      integer  :: iaer, i, j, k
      real, dimension (size(Aerosol%aerosol,1),  &
                       size(Aerosol%aerosol,2),  &
                       size(Aerosol%aerosol,3))  :: sul, bc
     
!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('aerosolrad_package_mod',   &
             'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!    allocate and initialize arrays to hold aerosol diagnostics.
!---------------------------------------------------------------------
      allocate (Aerosol_diags%extopdep (size(Aerosol%aerosol,1), &
                                        size(Aerosol%aerosol,2), &
                                        size(Aerosol%aerosol,3), &
                                        size(Aerosol%aerosol,4), 10 ))
      Aerosol_diags%extopdep = 0.0
      allocate (Aerosol_diags%absopdep (size(Aerosol%aerosol,1), &
                                        size(Aerosol%aerosol,2), &
                                        size(Aerosol%aerosol,3), &
                                        size(Aerosol%aerosol,4), 10 ))
      Aerosol_diags%absopdep = 0.0
      allocate (Aerosol_diags%asymdep (size(Aerosol%aerosol,1), &
                                       size(Aerosol%aerosol,2), &
                                       size(Aerosol%aerosol,3), &
                                       size(Aerosol%aerosol,4), 10 ))
      Aerosol_diags%asymdep = 0.0
      allocate (Aerosol_diags%extopdep_vlcno    &
                                        (size(Aerosol%aerosol,1), &
                                         size(Aerosol%aerosol,2), &
                                         size(Aerosol%aerosol,3),3))
      Aerosol_diags%extopdep_vlcno = 0.0
      allocate (Aerosol_diags%absopdep_vlcno  &
                                        (size(Aerosol%aerosol,1), &
                                         size(Aerosol%aerosol,2), &
                                         size(Aerosol%aerosol,3),3))
      Aerosol_diags%absopdep_vlcno = 0.0
      allocate (Aerosol_diags%sw_heating_vlcno  &
                                        (size(Aerosol%aerosol,1), &
                                         size(Aerosol%aerosol,2), &
                                         size(Aerosol%aerosol,3), &
                                         Rad_control%nzens))
      Aerosol_diags%sw_heating_vlcno = 0.0
      allocate (Aerosol_diags%lw_extopdep_vlcno    &
                                        (size(Aerosol%aerosol,1), &
                                         size(Aerosol%aerosol,2), &
                                         size(Aerosol%aerosol,3)+1,2))
      Aerosol_diags%lw_extopdep_vlcno = 0.0
      allocate (Aerosol_diags%lw_absopdep_vlcno  &
                                        (size(Aerosol%aerosol,1), &
                                         size(Aerosol%aerosol,2), &
                                         size(Aerosol%aerosol,3)+1,2))
      Aerosol_diags%lw_absopdep_vlcno = 0.0


!--------------------------------------------------------------------
!    if the volcanic sw aerosol extinction is being supplied, obtain
!    the appropriate data.
!--------------------------------------------------------------------
        if (using_sw_ext) then

!---------------------------------------------------------------------
!    if new sw extinction data is needed on this step, call interpolator
!    to obtain it.  if the data is not to be interpolated, save the
!    retrieved values in a module variable.
!---------------------------------------------------------------------
          if (need_sw_ext) then
            if (nfields_sw_ext >= 1) then
              call interpolator (Sw_aer_extopdep_interp, Volcano_Time, &
                                 p_half, Aerosol_props%sw_ext,    &
                                 sw_ext_name(1), is, js)
            endif
            if (.not. interpolating_volcanic_data) then
              sw_ext_save(is:ie,js:je,:,:) = Aerosol_props%sw_ext
            endif

!---------------------------------------------------------------------
!    if new data from the file is not needed on this step, then retrieve
!    the relevant data from the storage variable.
!---------------------------------------------------------------------
          else
            if ( .not. interpolating_volcanic_data) then
              Aerosol_props%sw_ext = sw_ext_save(is:ie,js:je,:,:)
            endif
          endif
        endif

!--------------------------------------------------------------------
!    if the volcanic sw aerosol single scattering albedo is being 
!    supplied, obtain the appropriate data.
!--------------------------------------------------------------------
        if (using_sw_ssa) then

!---------------------------------------------------------------------
!    if new sw single scattering albedo data is needed on this step, 
!    call interpolator to obtain it.  if the data is not to be inter-
!    polated, save the retrieved values in a module variable.
!---------------------------------------------------------------------
          if (need_sw_ssa) then
            if (nfields_sw_ssa >= 1) then
              call interpolator (Sw_aer_ssalb_interp, Volcano_Time, &
                                 p_half, Aerosol_props%sw_ssa,    &
                                 sw_ssa_name(1), is, js)
            endif
            if ( .not. interpolating_volcanic_data) then
              sw_ssa_save(is:ie,js:je,:,:) = Aerosol_props%sw_ssa
            endif

!---------------------------------------------------------------------
!    if new data from the file is not needed on this step, then retrieve
!    the relevant data from the storage variable.
!---------------------------------------------------------------------
          else
            if ( .not. interpolating_volcanic_data) then
              Aerosol_props%sw_ssa = sw_ssa_save(is:ie,js:je,:,:)
            endif
          endif
        endif

!--------------------------------------------------------------------
!    if the volcanic sw aerosol asymmetry factor is being supplied, 
!    obtain the appropriate data.
!--------------------------------------------------------------------
        if (using_sw_asy) then

!---------------------------------------------------------------------
!    if new sw asymmetry factor data is needed on this step, call 
!    interpolator to obtain it.  if the data is not to be interpolated,
!    save the retrieved values in a module variable.
!---------------------------------------------------------------------
          if (need_sw_asy) then
            if (nfields_sw_asy >= 1) then
              call interpolator (Sw_aer_asymm_interp, Volcano_Time, &
                                 p_half, Aerosol_props%sw_asy,    &
                                 sw_asy_name(1), is, js)
            endif
            if ( .not. interpolating_volcanic_data) then
              sw_asy_save(is:ie,js:je,:,:) = Aerosol_props%sw_asy
            endif

!---------------------------------------------------------------------
!    if new data from the file is not needed on this step, then retrieve
!    the relevant data from the storage variable.
!---------------------------------------------------------------------
          else
            if (.not. interpolating_volcanic_data) then
              Aerosol_props%sw_asy = sw_asy_save(is:ie,js:je,:,:)
            endif
          endif
        endif

!--------------------------------------------------------------------
!    if the volcanic lw aerosol extinction is being supplied, obtain
!    the appropriate data.
!--------------------------------------------------------------------
        if (using_lw_ext) then

!---------------------------------------------------------------------
!    if new lw extinction data is needed on this step, call interpolator
!    to obtain it.  if the data is not to be interpolated, save the
!    retrieved values in a module variable.
!---------------------------------------------------------------------
          if (need_lw_ext) then
            if (nfields_lw_ext >= 1) then
              call interpolator (Lw_aer_extopdep_interp, Volcano_Time, &
                                 p_half, Aerosol_props%lw_ext,    &
                                 lw_ext_name(1), is, js)
            endif
            if (.not. interpolating_volcanic_data) then
              lw_ext_save(is:ie,js:je,:,:) = Aerosol_props%lw_ext
            endif

!---------------------------------------------------------------------
!    if new data from the file is not needed on this step, then retrieve
!    the relevant data from the storage variable.
!---------------------------------------------------------------------
          else
            if ( .not. interpolating_volcanic_data) then
              Aerosol_props%lw_ext = lw_ext_save(is:ie,js:je,:,:)
            endif
          endif
        endif

!--------------------------------------------------------------------
!    if the volcanic lw single scattering albedo is being supplied, 
!    obtain the appropriate data.
!--------------------------------------------------------------------
        if (using_lw_ssa) then

!---------------------------------------------------------------------
!    if new lw single scattering albedo data is needed on this step, 
!    call interpolator to obtain it.  if the data is not to be inter-
!    polated, save the retrieved values in a module variable.
!---------------------------------------------------------------------
          if (need_lw_ssa) then
            if (nfields_lw_ssa >= 1) then
              call interpolator (Lw_aer_ssalb_interp, Volcano_Time, &
                                 p_half, Aerosol_props%lw_ssa,    &
                                 lw_ssa_name(1), is, js)
            endif
            if ( .not. interpolating_volcanic_data) then
              lw_ssa_save(is:ie,js:je,:,:) = Aerosol_props%lw_ssa
            endif

!---------------------------------------------------------------------
!    if new data from the file is not needed on this step, then retrieve
!    the relevant data from the storage variable.
!---------------------------------------------------------------------
          else
            if ( .not. interpolating_volcanic_data) then
              Aerosol_props%lw_ssa = lw_ssa_save(is:ie,js:je,:,:)
            endif
          endif
        endif

!--------------------------------------------------------------------
!    if the volcanic lw aerosol asymmetry factor is being supplied, 
!    obtain the appropriate data.
!--------------------------------------------------------------------
        if (using_lw_asy) then

!---------------------------------------------------------------------
!    if new lw asymmetry factor data is needed on this step, call 
!    interpolator to obtain it.  if the data is not to be interpolated, 
!    save the retrieved values in a module variable.
!---------------------------------------------------------------------
          if (need_lw_asy) then
            if (nfields_lw_asy >= 1) then
              call interpolator (Lw_aer_asymm_interp, Volcano_Time, &
                                 p_half, Aerosol_props%lw_asy,    &
                                 lw_asy_name(1), is, js)
            endif
            if (.not. interpolating_volcanic_data) then
              lw_asy_save(is:ie,js:je,:,:) = Aerosol_props%lw_asy
            endif

!---------------------------------------------------------------------
!    if new data from the file is not needed on this step, then retrieve
!    the relevant data from the storage variable.
!---------------------------------------------------------------------
          else
            if (.not. interpolating_volcanic_data) then
              Aerosol_props%lw_asy = lw_asy_save(is:ie,js:je,:,:)
            endif
          endif
        endif

!---------------------------------------------------------------------
!    code for treating sulfate and black carbon as an internal aerosol
!    mixture.
!---------------------------------------------------------------------
        if (Rad_control%using_im_bcsul) then
          if (num_sul > 0) then
            sul(:,:,:) = Aerosol%aerosol(:,:,:,sul_ind(1))
            do iaer=2,num_sul
              sul(:,:,:) = sul(:,:,:) +    &
                                Aerosol%aerosol(:,:,:,sul_ind(iaer))
            end do
          else
            sul = 0.
          endif
          if (num_bc > 0) then
            bc(:,:,:) = Aerosol%aerosol(:,:,:,bc_ind(1))
            do iaer=2,num_bc
              bc(:,:,:) = bc(:,:,:) +    &
                                Aerosol%aerosol(:,:,:,bc_ind(iaer))
            end do
          else
            bc = 0.
          endif
          do k = 1,size(Aerosol%aerosol,3)
            do j = 1,size(Aerosol%aerosol,2)
              do i = 1,size(Aerosol%aerosol,1)
                if (bc(i,j,k) > 0 .and. sul(i,j,k) > 0.0) then
                  Aerosol_props%ivol(i,j,k) = 100-MIN(100, MAX( 0,     &
                   NINT(100.*sul(i,j,k)/(sul(i,j,k) +bc(i,j,k)*1.74))))
                else
                  Aerosol_props%ivol(i,j,k) = 0
                end if
              enddo
            end do
          end do
        else
          Aerosol_props%ivol = 0
        endif ! (using_im_bcsul)

!---------------------------------------------------------------------
!    fill the remaining components of the aerosol_properties_type var-
!    iable and return to the calling routine. this variable contains 
!    the aerosol radiative properties for each aerosol properties type 
!    over each solar and aerosol emissivity band.
!---------------------------------------------------------------------
        if (Rad_control%do_swaerosol_forcing .or.  &
                                         Sw_control%do_swaerosol) then
          Aerosol_props%aerextband = aerextband_MOD
          Aerosol_props%aerssalbband = aerssalbband_MOD
          Aerosol_props%aerasymmband = aerasymmband_MOD
        endif

!---------------------------------------------------------------------
!    if longwave aerosol effects are desired, and the following cal-
!    culation has not already been done, calculate the aerosol 
!    properties for each aerosol properties type nw over each aerosol 
!    emissivity band na using the weighted contributions from each
!    aerosol parameterization band ni. mark the calculation as com-
!    pleted.
!
!    the units of extinction coefficient (aeroextivl) are m**2/gm.
!    to make the lw band extinction coefficient (aerextbandlw) have
!    units (m**2/Kg) consistent with the units in FMS models, one
!    must multiply by 1000. this is done below.
!---------------------------------------------------------------------
        if (Rad_control%do_lwaerosol_forcing .or. &
                Lw_control%do_lwaerosol) then
          Aerosol_props%aerextbandlw = aerextbandlw_MOD
          Aerosol_props%aerssalbbandlw = aerssalbbandlw_MOD
          Aerosol_props%aerextbandlw_cn = aerextbandlw_cn_MOD
          Aerosol_props%aerssalbbandlw_cn = aerssalbbandlw_cn_MOD
        endif
        Aerosol_props%sulfate_index = sulfate_index
        Aerosol_props%optical_index = optical_index
        Aerosol_props%omphilic_index =omphilic_index
        Aerosol_props%bcphilic_index =bcphilic_index
        Aerosol_props%seasalt1_index =seasalt1_index
        Aerosol_props%seasalt2_index =seasalt2_index
        Aerosol_props%seasalt3_index =seasalt3_index
        Aerosol_props%seasalt4_index =seasalt4_index
        Aerosol_props%seasalt5_index =seasalt5_index
        Aerosol_props%sulfate_flag =   SULFATE_FLAG
        Aerosol_props%omphilic_flag =  OMPHILIC_FLAG
        Aerosol_props%bcphilic_flag =  BCPHILIC_FLAG
        Aerosol_props%seasalt1_flag =  SEASALT1_FLAG
        Aerosol_props%seasalt2_flag =  SEASALT2_FLAG
        Aerosol_props%seasalt3_flag =  SEASALT3_FLAG
        Aerosol_props%seasalt4_flag =  SEASALT4_FLAG
        Aerosol_props%seasalt5_flag =  SEASALT5_FLAG
        if (Rad_control%using_im_bcsul) then
          Aerosol_props%bc_flag = BC_FLAG
        else
          Aerosol_props%bc_flag = NOT_IN_USE
        endif

end subroutine aerosol_radiative_properties


!#####################################################################
! <SUBROUTINE NAME="aerosolrad_package_end">
!  <OVERVIEW>
!    aerosolrad_package_end is the destructor for 
!    aerosolrad_package_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    aerosolrad_package_end is the destructor for 
!    aerosolrad_package_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call aerosolrad_package_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine aerosolrad_package_end

!--------------------------------------------------------------------
!    aerosolrad_package_end is the destructor for 
!    aerosolrad_package_mod.
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('aerosolrad_package_mod',   &
             'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!    deallocate module variables.
!---------------------------------------------------------------------
      if (do_swaerosol .or. Rad_control%do_swaerosol_forcing) then      
        deallocate (solivlaero, nivl1aero, nivl2aero, endaerwvnsf, &
                    aeroextivl, aerossalbivl, aeroasymmivl)
      endif
      if (do_lwaerosol .or. Rad_control%do_lwaerosol_forcing) then
        deallocate ( sflwwts)
        deallocate ( sflwwts_cn)
      endif
      
!---------------------------------------------------------------------
!    deallocate elements of the aerosol_properties_type array.
!---------------------------------------------------------------------
      if (allocated(sulfate_index )) deallocate(sulfate_index )
      if (allocated(bcphilic_index)) deallocate(bcphilic_index)
      if (allocated(omphilic_index)) deallocate(omphilic_index)
      if (allocated(seasalt1_index)) deallocate(seasalt1_index)
      if (allocated(seasalt2_index)) deallocate(seasalt2_index)
      if (allocated(seasalt3_index)) deallocate(seasalt3_index)
      if (allocated(seasalt4_index)) deallocate(seasalt4_index)
      if (allocated(seasalt5_index)) deallocate(seasalt5_index)
      if (allocated(optical_index )) deallocate(optical_index )

      
      if (Rad_control%volcanic_lw_aerosols) then
        if (nfields_lw_ext /= 0) then
          call interpolator_end (Lw_aer_extopdep_interp)
        endif
        if (nfields_lw_ssa /= 0) then
        call interpolator_end (Lw_aer_ssalb_interp)
        endif
        if (nfields_lw_asy /= 0) then
        call interpolator_end (Lw_aer_asymm_interp)
        endif
      endif

      if (Rad_control%volcanic_sw_aerosols) then
        if (nfields_sw_ext /= 0) then
        call interpolator_end (Sw_aer_extopdep_interp)
        endif
        if (nfields_sw_ssa /= 0) then
        call interpolator_end (Sw_aer_ssalb_interp)
        endif
        if (nfields_sw_asy /= 0) then
        call interpolator_end (Sw_aer_asymm_interp)
        endif
      endif

      if (.not. interpolating_volcanic_data) then
        deallocate (sw_ext_save, sw_ssa_save, sw_asy_save, &
                    lw_ext_save, lw_ssa_save, lw_asy_save)
      endif

!---------------------------------------------------------------------
!    mark the module as uninitialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.




end subroutine aerosolrad_package_end


!####################################################################
! <SUBROUTINE NAME="get_aerosol_optical_info">
!  <OVERVIEW>
!    get_aerosol_optical_info accesses data stored by this module.
!  </OVERVIEW>
!  <DESCRIPTION>
!    get_aerosol_optical_info accesses data stored by this module.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call get_aerosol_optical_info( num_categories, nwavenumbers, &
!                                     names, wavenumbers, &
!                                     aer_ext, aer_ss_alb, aer_asymm)
!  </TEMPLATE>
!  <OUT NAME="num_categories" TYPE="integer">
!   number of aerosol properties types
!  </OUT>
!  <OUT NAME="nwavenumbers" TYPE="integer">
!   number of wavenumber bands over which
!                           aerosol properties are defined
!  </OUT>
!  <OUT NAME="names" TYPE="character">
!   names assigned to the optical properties types
!  </OUT>
!  <OUT NAME="wavenumbers" TYPE="real">
!   wavenumber limits for each of the bands for
!                           which aerosol properties are defined
!  </OUT>
!  <OUT NAME="aer_ext, aer_ss_alb, aer_asymm" TYPE="real">
!   Aerosol extinction coefficient, single scattering albedo, and
!   asymmetry parameter
!  </OUT>
! </SUBROUTINE>
!
subroutine get_aerosol_optical_info( num_categories, nwavenumbers, &
                                     names, wavenumbers, &
                                     aer_ext, aer_ss_alb, aer_asymm)

!-----------------------------------------------------------------------
!    get_aerosol_optical_info accesses data stored by this module.
!-----------------------------------------------------------------------

integer,                        intent(out), optional ::       &
                                            num_categories, nwavenumbers
character(len=*), dimension(:), intent(out), optional :: names
integer, dimension(:),          intent(out), optional :: wavenumbers
real, dimension(:,:),           intent(out), optional :: aer_ext, &
                                                         aer_ss_alb, &
                                                         aer_asymm

!----------------------------------------------------------------------
!   intent(out), optional variables:
!
!      num_categories       number of aerosol properties types
!      nwavenumbers         number of wavenumber bands over which
!                           aerosol properties are defined
!      names                names assigned to the optical properties 
!                           types
!      wavenumbers          wavenumber limits for each of the bands for
!                           which aerosol properties are defined
!      aer_ext              extinction coefficient for each aerosol
!                           spectral band and each aerosol optical 
!                           property type
!      aer_ss_ab            single-scattering albedo for each aerosol 
!                           band and each aerosol optical property type 
!      aer_asymm            asymmetry factor for each aerosol band and 
!                           each aerosol optical property type
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('aerosolrad_package_mod',   &
             'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!    define the desired output variables.
!---------------------------------------------------------------------
      if( present(num_categories) ) num_categories = naermodels
      if( present(nwavenumbers))    nwavenumbers   = num_wavenumbers
      if( present(names) )          names(:naermodels) =    &
                                     aerosol_optical_names(:naermodels)
      if( present(wavenumbers) )    wavenumbers(:num_wavenumbers) =  &
                                           endaerwvnsf(:num_wavenumbers)
      if( present(aer_ext) )        aer_ext(:,:)    = aeroextivl(:,:)
      if( present(aer_ss_alb) )     aer_ss_alb(:,:) = aerossalbivl(:,:)
      if( present(aer_asymm) )      aer_asymm(:,:)  = aeroasymmivl(:,:)

!---------------------------------------------------------------------

end subroutine get_aerosol_optical_info


!######################################################################
! <SUBROUTINE NAME="get_aerosol_optical_index">
!  <OVERVIEW>
!    get_aerosol_optical_index returns the aerosol optical property
!    index for given aerosol number and relative humidity.
!  </OVERVIEW>
!  <DESCRIPTION>
!    get_aerosol_optical_index returns the aerosol optical property
!    index for given aerosol number and relative humidity.
!  </DESCRIPTION>
!  <TEMPLATE>
!   index = get_aerosol_optical_index( name, naerosol, rh )
!  </TEMPLATE>
!  <IN NAME="name" TYPE="real">
!   aerosol species name for which the optical 
!                      properties index is desired
!  </IN>
!  <IN NAME="naerosol" TYPE="integer">
!   aerosol index of the aerosol for whoch the 
!                      optical properties index is desired
!  </IN>
!  <IN NAME="rh" TYPE="real">
!    relative humidity 
!  </IN>
! </SUBROUTINE>
!
function get_aerosol_optical_index( name, naerosol, rh ) result(index)

!-----------------------------------------------------------------------
!    get_aerosol_optical_index returns the aerosol optical property
!    index for given aerosol number and relative humidity.
!-----------------------------------------------------------------------

character(len=*),         intent(in) :: name
integer,                   intent(in) :: naerosol
real,                      intent(in) :: rh
integer                               :: index  ! function value

!----------------------------------------------------------------------
!   intent(in) variables:
!
!      name            aerosol species name for which the optical 
!                      properties index is desired
!      naerosol        aerosol index of the aerosol for whoch the 
!                      optical properties index is desired
!      rh              relative humidity 
!
!  function value
!
!      index           returned optical properties index for aerosol
!                      name (aerosol index = naerosol) when the 
!                      relative humidity is rh
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      integer   :: irh     ! integer value for relative humidity, 
                           ! used as an index
      integer   :: nfields ! total number of active aerosols

!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module is initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg( 'aerosolrad_package_mod',  &
             'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!    be sure the desired aerosol index is valid.
!---------------------------------------------------------------------
      nfields = size(optical_index(:),1)
      if (naerosol > nfields) then
        call error_mesg( 'aerosolrad_package_mod', &
           'aerosol index exceeds number of aerosol fields', FATAL )
      end if

!---------------------------------------------------------------------
!    Determine if the desired aerosol is a hydrophilic or not. 
!    If the aerosol is hydrophilic, then the optical propeties 
!    index will depend on the relative humidity.
!---------------------------------------------------------------------
      if (optical_index(naerosol) == SULFATE_FLAG ) then
        irh = MIN( 100, MAX( 0, NINT(100.*rh) ) )
!yim no vol info is passed here now. Set 0 for now.
        index = sulfate_index( irh, 0 )
      elseif (optical_index(naerosol) == BC_FLAG ) then
        irh = MIN( 100, MAX( 0, NINT(100.*rh) ) )
!yim no vol info is passed here now. Set 0 for now.
        index = sulfate_index( irh, 0 )
      elseif (optical_index(naerosol) == &
                                               OMPHILIC_FLAG ) then
        irh = MIN( 100, MAX( 0, NINT(100.*rh) ) )
        index = omphilic_index( irh )
      elseif (optical_index(naerosol) ==   &
                  BCPHILIC_FLAG .and. Rad_control%using_im_bcsul ) then
        irh = MIN( 100, MAX( 0, NINT(100.*rh) ) )
!yim
        index = sulfate_index( irh, 0 )
      elseif (optical_index(naerosol) == BCPHILIC_FLAG  &
                        .and. .not. Rad_control%using_im_bcsul ) then
        irh = MIN( 100, MAX( 0, NINT(100.*rh) ) )
!yim
        index = bcphilic_index( irh )
      elseif (optical_index(naerosol) ==    &
                                               SEASALT1_FLAG ) then
        irh = MIN( 100, MAX( 0, NINT(100.*rh) ) )
        index = seasalt1_index( irh )
      elseif (optical_index(naerosol) ==  &            
                                               SEASALT2_FLAG ) then
        irh = MIN( 100, MAX( 0, NINT(100.*rh) ) )
        index = seasalt2_index( irh )
      elseif (optical_index(naerosol) ==  &            
                                               SEASALT3_FLAG ) then
        irh = MIN( 100, MAX( 0, NINT(100.*rh) ) )
        index = seasalt3_index( irh )
      elseif (optical_index(naerosol) ==  &           
                                               SEASALT4_FLAG ) then
        irh = MIN( 100, MAX( 0, NINT(100.*rh) ) )
        index = seasalt4_index( irh )
      elseif (optical_index(naerosol) ==  &           
                                               SEASALT5_FLAG ) then
        irh = MIN( 100, MAX( 0, NINT(100.*rh) ) )
        index = seasalt5_index( irh )
      else
        index = optical_index(naerosol)
      endif

!---------------------------------------------------------------------
!    if no value was obtained for the optical index, stop execution.
!---------------------------------------------------------------------
      if (index == 0 ) then
        call error_mesg ('aerosolrad_package_mod', &
           'Cannot find aerosol optical properties for species = ' // &
                  trim (name), FATAL )
      endif

!----------------------------------------------------------------------


end function get_aerosol_optical_index




!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                    PRIVATE SUBROUTINES
!                                
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                                  
                                  

!#####################################################################
! <SUBROUTINE NAME="assign_aerosol_opt_props">
!  <OVERVIEW>
!    assign_aerosol_opt_props assigns an index for an available optical
!    properties type to each activated aerosol type. for sulfates, a 
!    flag is set, since the aerosol properties type is a function 
!    of model relative humidity, and will vary with time.
!  </OVERVIEW>
!  <DESCRIPTION>
!    assign_aerosol_opt_props assigns an index for an available optical
!    properties type to each activated aerosol type. for sulfates, a 
!    flag is set, since the aerosol properties type is a function 
!    of model relative humidity, and will vary with time.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call assign_aerosol_opt_props (aerosol_names)
!  </TEMPLATE>
!  <IN NAME="aerosol_names" TYPE="character">
!   names associated with each aerosol species
!  </IN>
! </SUBROUTINE>
!
subroutine assign_aerosol_opt_props (aerosol_names)

!----------------------------------------------------------------------
!    assign_aerosol_opt_props assigns an index for an available optical
!    properties type to each activated aerosol type. for sulfates, a 
!    flag is set, since the aerosol properties type is a function 
!    of model relative humidity, and will vary with time.
!---------------------------------------------------------------------

!character(len=64), dimension(:), intent(in) :: aerosol_names
character(len=*), dimension(:), intent(in) :: aerosol_names

!----------------------------------------------------------------------
!  intent(in) variables:
!
!     aerosol_names     names associated with each aerosol species
!
!----------------------------------------------------------------------

!-----------------------------------------------------------------------
!    local variables:

      character(len=64) :: name_in, target_name
!yim
      character(len=4)  :: chind, chind2
      integer           :: nfields
!yim
      integer           :: n, noptical, m
      integer           :: ibc, isul

!---------------------------------------------------------------------
!   local variables:
!
!       name_in          variable to hold current aerosol name 
!                        being processed
!       target_name      aerosol_optical_name associated with a given
!                        aerosol species     
!       nfields          number of activated aerosol species
!       n, noptical      do-loop indices
!
!---------------------------------------------------------------------

!----------------------------------------------------------------------
!    count the number of aerosol optical property categories requested
!    via the namelist input.
!----------------------------------------------------------------------
      do n=1,MAX_OPTICAL_FIELDS
        if (aerosol_optical_names(n) /= ' '  ) then
          naermodels = n
        else
          exit
        endif
      end do

!---------------------------------------------------------------------
!    define the number of activated aerosol species.
!---------------------------------------------------------------------
      nfields = size (aerosol_names(:))

      if (Rad_control%using_im_bcsul) then
        allocate (sul_ind(nfields))
        allocate (bc_ind(nfields))
      endif

!---------------------------------------------------------------------
!    allocate components of the aerosol_properties_type module variable
!    which will contain the indices for the different aerosols.
!---------------------------------------------------------------------
      if (Rad_control%using_im_bcsul) then
        allocate (sulfate_index (0:100,0:100))
      else
        allocate (sulfate_index (0:100,0:0  ))
      endif
      allocate (omphilic_index(0:100 ), &
                bcphilic_index(0:100 ), &
                seasalt1_index(0:100 ), &
                seasalt2_index(0:100 ), &
                seasalt3_index(0:100 ), &
                seasalt4_index(0:100 ), &
                seasalt5_index(0:100 ) )
      allocate (optical_index(nfields) )
      optical_index    = 0
      sulfate_index    = 0
      omphilic_index    = 0
      bcphilic_index    = 0
      seasalt1_index    = 0
      seasalt2_index    = 0
      seasalt3_index    = 0
      seasalt4_index    = 0
      seasalt5_index    = 0

!----------------------------------------------------------------------
!    match aerosol optical property indices with aerosol indices.
!    sulfate aerosols are handled separately (below) with RH dependence.
!----------------------------------------------------------------------
      num_sul = 0
      num_bc = 0
      isul = 1
      ibc = 1
      do n=1,nfields
        name_in = trim(aerosol_names(n))
        if (name_in == 'so4' .or. name_in == 'so4_anthro' .or. name_in == 'so4_natural') then
          optical_index(n) = SULFATE_FLAG
          if (Rad_control%using_im_bcsul) then
            num_sul = num_sul +1
            sul_ind(isul) = n
            isul = isul + 1
          endif
        else if (name_in == "omphilic" .or. name_in == "oc_hydrophilic") then
            optical_index(n) = OMPHILIC_FLAG
        else if (name_in == "bcphilic" .or. name_in == "bc_hydrophilic") then
            optical_index(n) = BCPHILIC_FLAG
            if (Rad_control%using_im_bcsul) then
              num_bc = num_bc +1
              bc_ind(ibc) = n
              ibc = ibc + 1
            endif
        else if (name_in == "seasalt1") then
            optical_index(n) = SEASALT1_FLAG
        else if (name_in == "seasalt2") then
            optical_index(n) = SEASALT2_FLAG
        else if (name_in == "seasalt3") then
            optical_index(n) = SEASALT3_FLAG
        else if (name_in == "seasalt4") then
            optical_index(n) = SEASALT4_FLAG
        else if (name_in == "seasalt5") then
            optical_index(n) = SEASALT5_FLAG
!yim
        else if (name_in == "black_carbon" .and.   &
                              Rad_control%using_im_bcsul) then
            optical_index(n) = BC_FLAG
            num_bc = num_bc +1
            bc_ind(ibc) = n
            ibc = ibc + 1
        else 
          select case( name_in )
            case( "anthro_dust_0.1", "natural_dust_0.1" )
              target_name = "dust_0.1"
            case( "anthro_dust_0.2", "natural_dust_0.2" )
              target_name = "dust_0.2"
            case( "anthro_dust_0.4", "natural_dust_0.4" )
              target_name = "dust_0.4"
            case( "anthro_dust_0.8", "natural_dust_0.8" )
              target_name = "dust_0.8"
            case( "anthro_dust_1.0", "natural_dust_1.0" )
              target_name = "dust_1.0"
            case( "anthro_dust_2.0", "natural_dust_2.0" )
              target_name = "dust_2.0"
            case( "anthro_dust_4.0", "natural_dust_4.0" )
              target_name = "dust_4.0"
            case( "anthro_dust_8.0", "natural_dust_8.0" )
              target_name = "dust_8.0"
            case( "black_carbon" )
               target_name = "soot"
            case( "organic_carbon" )
              target_name = "organic_carbon"
            case( "sea_salt" )
              target_name = "sea_salt"
            case( "dust1" )
              target_name = "dust1"
            case( "dust2" )
              target_name = "dust2"
            case( "dust3" )
              target_name = "dust3"
            case( "dust4" )
              target_name = "dust4"
            case( "dust5" )
              target_name = "dust5"
            case( "bcdry" )
              target_name = "bcdry"
            case( "omphobic", "oc_hydrophobic" )
              target_name = "omphobic"
            case( "bcphobic", "bc_hydrophobic" )
              target_name = "bcphobic"
            case DEFAULT
              target_name = name_in
          end select  

!--------------------------------------------------------------------
!    go through the set of aerosol properties types looking for 
!    the target_name defined above. when found, associate the
!    optical properties type index with the current aerosol species.
!--------------------------------------------------------------------
          do noptical=1,naermodels
            if (aerosol_optical_names(noptical) == target_name) then
              optical_index(n) = noptical
              exit
            end if
          end do

!--------------------------------------------------------------------
!    if the target_name is not found, exit with an error message.
!----------------------------------------------------------------------
          if (optical_index(n) == 0 ) then
            call error_mesg( 'aerosolrad_package_mod', &
                'Cannot find aerosol optical model = ' //    &
                                           TRIM( target_name ), FATAL )
          endif
        endif  ! (name_in ==)
      end do  ! (n=1,nfields)

      select case(trim(aerosol_data_set))
        case ('Ginoux_Reddy') 
     if (Rad_control%using_im_bcsul) then

!----------------------------------------------------------------------
!    set up RH-dependent sulfate aerosol optical property indices.
!    define the optical properties type for all possible values of 
!    relative humidity.
!-------------------------------------------------------------------
          do n=0,100
          do m=0,100
            if (sulfate_indices(n) < 10) then
              write (chind, '(i1)') sulfate_indices(n)
            else if (sulfate_indices(n) == 100) then
              write (chind, '(i3)') sulfate_indices(n)
            else
              write (chind, '(i2)') sulfate_indices(n)
            endif
!yim
            if (sulfate_vol_indices(m) < 10) then
              write (chind2, '(i1)') sulfate_vol_indices(m)
            else if (sulfate_vol_indices(m) == 100) then
              write (chind2, '(i3)') sulfate_vol_indices(m)
            else
              write (chind2, '(i2)') sulfate_vol_indices(m)
            endif
!yim format sulfate_10%_10% (RH + volume fraction)
            target_name = 'sulfate_' // trim(chind)  // '%_' // trim(chind2)// '%'

!---------------------------------------------------------------------
!    associate an index value with each possible relative humidity.
!---------------------------------------------------------------------
        do noptical=1,naermodels
          if (aerosol_optical_names(noptical) == target_name ) then
            sulfate_index(n,m) = noptical
            exit
          end if
        end do

!---------------------------------------------------------------------
!    if the  aerosol_optical name_is not included in the potential
!    set listed above, exit with an error message.
!---------------------------------------------------------------------
        if (sulfate_index(n,m) == 0 ) then
          call error_mesg( 'aerosolrad_package_mod', &
                 'Cannot find aerosol optical model = ' // &
                                          TRIM( target_name), FATAL )
        endif
      end do
      end do
     else
!----------------------------------------------------------------------
!    set up RH-dependent sulfate aerosol optical property indices.
!    define the optical properties type for all possible values of 
!    relative humidity.
!-------------------------------------------------------------------
          do n=0,100
            if (sulfate_indices(n) < 10) then
              write (chind, '(i1)') sulfate_indices(n)
            else if (sulfate_indices(n) == 100) then
              write (chind, '(i3)') sulfate_indices(n)
            else
              write (chind, '(i2)') sulfate_indices(n)
            endif
            target_name = 'sulfate_' // trim(chind)  // '%' 

!---------------------------------------------------------------------
!    associate an index value with each possible relative humidity.
!---------------------------------------------------------------------
        do noptical=1,naermodels
          if (aerosol_optical_names(noptical) == target_name ) then
            sulfate_index(n,0) = noptical
            exit
          end if
        end do

!---------------------------------------------------------------------
!    if the  aerosol_optical name_is not included in the potential
!    set listed above, exit with an error message.
!---------------------------------------------------------------------
        if (sulfate_index(n,0) == 0 ) then
          call error_mesg( 'aerosolrad_package_mod', &
                 'Cannot find aerosol optical model = ' // &
                                          TRIM( target_name), FATAL )
        endif
      end do

     endif

!---------------------------------------------------------------------
!    set up RH-dependent omphilic aerosol optical property indices.
!    define the optical properties type for all possible values of 
!    relative humidity.
!-------------------------------------------------------------------
          do n=0,100
            if (omphilic_indices(n) < 10) then
              write (chind, '(i1)') omphilic_indices(n)
            else if (omphilic_indices(n) == 100) then
              write (chind, '(i3)') omphilic_indices(n)
            else
              write (chind, '(i2)') omphilic_indices(n)
            endif
            target_name = 'omphilic_' // trim(chind)  // '%'

!---------------------------------------------------------------------
!    associate an index value with each possible relative humidity.
!---------------------------------------------------------------------
            do noptical=1,naermodels
              if (aerosol_optical_names(noptical) == target_name ) then
                omphilic_index(n) = noptical
                exit
              endif
            end do

!---------------------------------------------------------------------
!    if the  aerosol_optical name_is not included in the potential
!    set listed above, exit with an error message.
!---------------------------------------------------------------------
            if (omphilic_index(n) == 0 ) then
              call error_mesg( 'aerosolrad_package_mod', &
                 'Cannot find aerosol optical model = ' // &
                                          TRIM( target_name), FATAL )
            endif
          end do

!---------------------------------------------------------------------
!    set up RH-dependent seasalt1 aerosol optical property indices.
!    define the optical properties type for all possible values of 
!    relative humidity.
!-------------------------------------------------------------------
          do n=0,100
            if (seasalt1_indices(n) < 10) then
              write (chind, '(i1)') seasalt1_indices(n)
            else if (seasalt1_indices(n) == 100) then
              write (chind, '(i3)') seasalt1_indices(n)
            else
              write (chind, '(i2)') seasalt1_indices(n)
            endif
            target_name = 'seasalt1_' // trim(chind)  // '%'

!---------------------------------------------------------------------
!    associate an index value with each possible relative humidity.
!---------------------------------------------------------------------
            do noptical=1,naermodels
              if (aerosol_optical_names(noptical) == target_name ) then
                seasalt1_index(n) = noptical
                exit
              endif
            end do

!---------------------------------------------------------------------
!    if the  aerosol_optical name_is not included in the potential
!    set listed above, exit with an error message.
!---------------------------------------------------------------------
            if (seasalt1_index(n) == 0 ) then
              call error_mesg( 'aerosolrad_package_mod', &
                 'Cannot find aerosol optical model = ' // &
                                          TRIM( target_name), FATAL )
            endif
          end do

!---------------------------------------------------------------------
!    set up RH-dependent seasalt2 aerosol optical property indices.
!    define the optical properties type for all possible values of 
!    relative humidity.
!-------------------------------------------------------------------
          do n=0,100
            if (seasalt2_indices(n) < 10) then
              write (chind, '(i1)') seasalt2_indices(n)
            else if (seasalt2_indices(n) == 100) then
              write (chind, '(i3)') seasalt2_indices(n)
            else
              write (chind, '(i2)') seasalt2_indices(n)
            endif
            target_name = 'seasalt2_' // trim(chind)  // '%'

!---------------------------------------------------------------------
!    associate an index value with each possible relative humidity.
!---------------------------------------------------------------------
            do noptical=1,naermodels
              if (aerosol_optical_names(noptical) == target_name ) then
                seasalt2_index(n) = noptical
                exit
              endif
            end do

!---------------------------------------------------------------------
!    if the  aerosol_optical name_is not included in the potential
!    set listed above, exit with an error message.
!---------------------------------------------------------------------
            if (seasalt2_index(n) == 0 ) then
              call error_mesg( 'aerosolrad_package_mod', &
                 'Cannot find aerosol optical model = ' // &
                                          TRIM( target_name), FATAL )
            endif
          end do

!---------------------------------------------------------------------
!    set up RH-dependent seasalt3 aerosol optical property indices.
!    define the optical properties type for all possible values of 
!    relative humidity.
!-------------------------------------------------------------------
          do n=0,100
            if (seasalt3_indices(n) < 10) then
              write (chind, '(i1)') seasalt3_indices(n)
            else if (seasalt3_indices(n) == 100) then
              write (chind, '(i3)') seasalt3_indices(n)
            else
              write (chind, '(i2)') seasalt3_indices(n)
            endif
            target_name = 'seasalt3_' // trim(chind)  // '%'

!---------------------------------------------------------------------
!    associate an index value with each possible relative humidity.
!---------------------------------------------------------------------
            do noptical=1,naermodels
              if (aerosol_optical_names(noptical) == target_name ) then
                seasalt3_index(n) = noptical
                exit
              endif
            end do

!---------------------------------------------------------------------
!    if the  aerosol_optical name_is not included in the potential
!    set listed above, exit with an error message.
!---------------------------------------------------------------------
            if (seasalt3_index(n) == 0 ) then
              call error_mesg( 'aerosolrad_package_mod', &
                 'Cannot find aerosol optical model = ' // &
                                          TRIM( target_name), FATAL )
            endif
          end do
 
!---------------------------------------------------------------------
!    set up RH-dependent seasalt4 aerosol optical property indices.
!    define the optical properties type for all possible values of 
!    relative humidity.
!-------------------------------------------------------------------
          do n=0,100
            if (seasalt4_indices(n) < 10) then
              write (chind, '(i1)') seasalt4_indices(n)
            else if (seasalt4_indices(n) == 100) then
              write (chind, '(i3)') seasalt4_indices(n)
            else
              write (chind, '(i2)') seasalt4_indices(n)
            endif
            target_name = 'seasalt4_' // trim(chind)  // '%'

!---------------------------------------------------------------------
!    associate an index value with each possible relative humidity.
!---------------------------------------------------------------------
            do noptical=1,naermodels
              if (aerosol_optical_names(noptical) == target_name ) then
                seasalt4_index(n) = noptical
                exit
              endif
            end do

!---------------------------------------------------------------------
!    if the  aerosol_optical name_is not included in the potential
!    set listed above, exit with an error message.
!---------------------------------------------------------------------
            if (seasalt4_index(n) == 0 ) then
              call error_mesg( 'aerosolrad_package_mod', &
                 'Cannot find aerosol optical model = ' // &
                                          TRIM( target_name), FATAL )
            endif
          end do

!-------------------------------------------------------------------
!    set up RH-dependent seasalt5 aerosol optical property indices.
!    define the optical properties type for all possible values of 
!    relative humidity.
!-------------------------------------------------------------------
          do n=0,100
            if (seasalt5_indices(n) < 10) then
              write (chind, '(i1)') seasalt5_indices(n)
            else if (seasalt5_indices(n) == 100) then
              write (chind, '(i3)') seasalt5_indices(n)
            else
              write (chind, '(i2)') seasalt5_indices(n)
            endif
            target_name = 'seasalt5_' // trim(chind)  // '%'

!---------------------------------------------------------------------
!    associate an index value with each possible relative humidity.
!---------------------------------------------------------------------
            do noptical=1,naermodels
              if (aerosol_optical_names(noptical) == target_name ) then
                seasalt5_index(n) = noptical
                exit
              endif
            end do

!---------------------------------------------------------------------
!    if the  aerosol_optical name_is not included in the potential
!    set listed above, exit with an error message.
!---------------------------------------------------------------------
            if (seasalt5_index(n) == 0 ) then 
              call error_mesg( 'aerosolrad_package_mod', &
                 'Cannot find aerosol optical model = ' // &
                                          TRIM( target_name), FATAL )
            endif
          end do

          if ( .not. Rad_control%using_im_bcsul) then
!-------------------------------------------------------------------
!    set up RH-dependent bcphilic aerosol optical property indices.
!    define the optical properties type for all possible values of 
!    relative humidity.
!-------------------------------------------------------------------
           do n=0,100
             if (bcphilic_indices(n) < 10) then
               write (chind, '(i1)') bcphilic_indices(n)
             else if (bcphilic_indices(n) == 100) then
               write (chind, '(i3)') bcphilic_indices(n)
             else
               write (chind, '(i2)') bcphilic_indices(n)
             endif
             target_name = 'bcphilic_' // trim(chind)  // '%'

!---------------------------------------------------------------------
!    associate an index value with each possible relative humidity.
!---------------------------------------------------------------------
             do noptical=1,naermodels
               if (aerosol_optical_names(noptical) == target_name ) then
                 bcphilic_index(n) = noptical
                 exit
               endif
             end do

!---------------------------------------------------------------------
!    if the  aerosol_optical name_is not included in the potential
!    set listed above, exit with an error message.
!---------------------------------------------------------------------
             if (bcphilic_index(n) == 0 ) then
               call error_mesg( 'aerosolrad_package_mod', &
                  'Cannot find aerosol optical model = ' // &
                                           TRIM( target_name), FATAL )
             endif
           end do
          endif
        case ('shettle_fenn')

   if (Rad_control%using_im_bcsul) then
!----------------------------------------------------------------------
!    set up RH-dependent sulfate aerosol optical property indices.
!    define the optical properties type for all possible values of 
!    relative humidity.
!-------------------------------------------------------------------
          do n=0,100
          do m=0,100
            if (sulfate_indices(n) < 10) then
              write (chind, '(i1)') sulfate_indices(n)
            else if (sulfate_indices(n) == 100) then
              write (chind, '(i3)') sulfate_indices(n)
            else
              write (chind, '(i2)') sulfate_indices(n)
            endif
!yim
            if (sulfate_vol_indices(m) < 10) then
              write (chind2, '(i1)') sulfate_vol_indices(m)
            else if (sulfate_vol_indices(m) == 100) then
              write (chind2, '(i3)') sulfate_vol_indices(m)
            else
              write (chind2, '(i2)') sulfate_vol_indices(m)
            endif
!yim format sulfate_10%_10% (RH + volume fraction)
            target_name = 'sulfate_' // trim(chind)  // '%_' // trim(chind2)// '%'

!---------------------------------------------------------------------
!    associate an index value with each possible relative humidity.
!---------------------------------------------------------------------
        do noptical=1,naermodels
          if (aerosol_optical_names(noptical) == target_name ) then
            sulfate_index(n,m) = noptical
            exit
          end if
        end do

!---------------------------------------------------------------------
!    if the  aerosol_optical name_is not included in the potential
!    set listed above, exit with an error message.
!---------------------------------------------------------------------
        if (sulfate_index(n,m) == 0 ) then
          call error_mesg( 'aerosolrad_package_mod', &
                 'Cannot find aerosol optical model = ' // &
                                          TRIM( target_name), FATAL )
        endif
      end do
      end do
   else 
!----------------------------------------------------------------------
!    set up RH-dependent sulfate aerosol optical property indices.
!    define the optical properties type for all possible values of 
!    relative humidity.
!-------------------------------------------------------------------
          do n=0,100
            if (sulfate_indices(n) < 10) then
              write (chind, '(i1)') sulfate_indices(n)
            else if (sulfate_indices(n) == 100) then
              write (chind, '(i3)') sulfate_indices(n)
            else
              write (chind, '(i2)') sulfate_indices(n)
            endif
            target_name = 'sulfate_' // trim(chind)  // '%' 

!---------------------------------------------------------------------
!    associate an index value with each possible relative humidity.
!---------------------------------------------------------------------
        do noptical=1,naermodels
          if (aerosol_optical_names(noptical) == target_name ) then
            sulfate_index(n,0) = noptical
            exit
          end if
        end do

!---------------------------------------------------------------------
!    if the  aerosol_optical name_is not included in the potential
!    set listed above, exit with an error message.
!---------------------------------------------------------------------
        if (sulfate_index(n,0) == 0 ) then
          call error_mesg( 'aerosolrad_package_mod', &
                 'Cannot find aerosol optical model = ' // &
                                          TRIM( target_name), FATAL )
        endif
      end do

   endif
      end select  ! (aerosol_data_set)  

!---------------------------------------------------------------------



end subroutine assign_aerosol_opt_props



!######################################################################
! <SUBROUTINE NAME="read_optical_input_file">
!  <OVERVIEW>
!    read_optical_input_file reads the optical properties input file
!    to obtain the specified aerosol radiative properties for each 
!    aerosol in each of the aerosol parameterization spectral bands.
!  </OVERVIEW>
!  <DESCRIPTION>
!    read_optical_input_file reads the optical properties input file
!    to obtain the specified aerosol radiative properties for each 
!    aerosol in each of the aerosol parameterization spectral bands.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call read_optical_input_file
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine read_optical_input_file

!-----------------------------------------------------------------------
!    read_optical_input_file reads the optical properties input file
!    to obtain the specified aerosol radiative properties for each 
!    aerosol in each of the aerosol parameterization spectral bands.
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!    local variables:

      real,    dimension(:), allocatable    :: aeroext_in,   &
                                               aerossalb_in,   &
                                               aeroasymm_in
      logical, dimension(:), allocatable    :: found

      integer           :: unit, num_input_categories
      character(len=64) :: name_in
      integer           :: n, noptical

!---------------------------------------------------------------------
!   local variables:
!
!       aeroext_in       aerosol extinction coefficient read from 
!                        input file
!       aerossalb_in     aerosol single scattering albedo read from 
!                        input file
!       aeroasymm_in     aerosol asymmetry factor read from 
!                        input file
!       found            aerosol radiative property data has been
!                        obtained from input file for the given
!                        optical properties type ?
!       unit             io unit number used for optical properties file
!       num_input_categories
!                        number of optical properties types contained
!                        in optical data input file
!       name_in          name of optical properties type being processed
!       n, noptical      do-loop indices
!
!---------------------------------------------------------------------

!----------------------------------------------------------------------
!    open the ASCII input file containing aerosol optical property
!    information.
!----------------------------------------------------------------------
      call mpp_open (unit, 'INPUT/'//optical_filename, MPP_RDONLY,  &
                     MPP_ASCII, MPP_SEQUENTIAL, MPP_MULTI, MPP_SINGLE)

!----------------------------------------------------------------------
!    read the dimension information contained in the input file.
!----------------------------------------------------------------------
      read ( unit,* ) num_wavenumbers
      read ( unit,* ) num_input_categories

!----------------------------------------------------------------------
!    read wavenumber limits for aerosol parameterization bands from 
!    the input file.
!----------------------------------------------------------------------
       allocate (endaerwvnsf(num_wavenumbers) )
       read (unit,* )
       read (unit,* ) endaerwvnsf
 
!----------------------------------------------------------------------
!    allocate module arrays to hold the specified sw properties for 
!    each parameterization bnad and each aerosol properties type.
!----------------------------------------------------------------------
      allocate (       &
            aeroextivl   (num_wavenumbers, naermodels),&
            aerossalbivl (num_wavenumbers, naermodels), &
            aeroasymmivl (num_wavenumbers, naermodels) )

!----------------------------------------------------------------------
!    allocate local working arrays.
!----------------------------------------------------------------------
      allocate (aeroext_in   (num_wavenumbers ),             &
                aerossalb_in (num_wavenumbers ),           &
                aeroasymm_in (num_wavenumbers ),           &
                found        (naermodels ) )

!----------------------------------------------------------------------
!    match the names of optical property categories from input file with
!    those specified in the namelist, and store the following data
!    appropriately. indicate that the data has been found.
!----------------------------------------------------------------------
      found(:) = .false.
      do n=1,num_input_categories
        read( unit,* ) name_in
        read( unit,* )
        read( unit,* ) aeroext_in
        read( unit,* )
        read( unit,* ) aerossalb_in
        read( unit,* )
        read( unit,* ) aeroasymm_in
        do noptical=1,naermodels
          if (aerosol_optical_names(noptical) == name_in) then
            aeroextivl(:,noptical)   = aeroext_in
            aerossalbivl(:,noptical) = aerossalb_in
            aeroasymmivl(:,noptical) = aeroasymm_in
            found( noptical ) = .true.
            exit
          endif
        end do
      end do

!----------------------------------------------------------------------
!    close the ASCII input file.
!----------------------------------------------------------------------
      call mpp_close( unit )

!----------------------------------------------------------------------
!    check to make sure data for all aerosol optical property
!    categories specified in namelist were contained in ASCII
!    input file. if not, exit with a message.
!----------------------------------------------------------------------
      do noptical = 1,naermodels
        if (.not. found( noptical ) ) then
              call error_mesg( 'aerosolrad_package_mod', &
              'Cannot find aerosol optical properties for ' // &
                TRIM(aerosol_optical_names(noptical)),  FATAL )
        endif
      end do

!----------------------------------------------------------------------
!    deallocate local working arrays.
!----------------------------------------------------------------------
      deallocate (aeroext_in, aerossalb_in, aeroasymm_in, found)



end subroutine read_optical_input_file



!#####################################################################
! <SUBROUTINE NAME="sw_aerosol_interaction">
!  <OVERVIEW>
!    sw_aerosol_interaction defines the weights and interval infor-
!    mation needed to map the aerosol radiative properties from the
!    aerosol parameterization bands to the solar parameterization
!    bands being used by the model.
!  </OVERVIEW>
!  <DESCRIPTION>
!    sw_aerosol_interaction defines the weights and interval infor-
!    mation needed to map the aerosol radiative properties from the
!    aerosol parameterization bands to the solar parameterization
!    bands being used by the model.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call sw_aerosol_interaction
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine sw_aerosol_interaction

!-----------------------------------------------------------------------
!    sw_aerosol_interaction defines the weights and interval infor-
!    mation needed to map the aerosol radiative properties from the
!    aerosol parameterization bands to the solar parameterization
!    bands being used by the model.
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!    local variables:

      integer           :: nbands, nband, nivl3
      real              :: sumsol3
      integer           :: nw
      integer           :: nmodel

!---------------------------------------------------------------------
!   local variables:
!
!       aeroext_in       aerosol extinction coefficient read from 
!                        input file
!       aerossalb_in     aerosol single scattering albedo read from 
!                        input file
!       aeroasymm_in     aerosol asymmetry factor read from 
!                        input file
!       found            aerosol radiative property data has been
!                        obtained from input file for the given
!                        optical properties type ?
!       unit             io unit number used for optical properties file
!       num_input_categories
!                        number of optical properties types contained
!                        in optical data input file
!       name_in          name of optical properties type being processed
!       nbands           number of bands in solar spectral param-
!                        eterization
!       nband            currently active solar spectrum band 
!       nivl3            currently active aerosol parameterization band
!       sumsol3          sum of solar input in current aerosol param-
!                        eterization band
!       n, nw, noptical  do-loop indices
!
!---------------------------------------------------------------------



!---------------------------------------------------------------------
!    define the number of bands in the solar spectrum parameterization.
!    allocate space for variables defining the highest and lowest 
!    aerosol parameterization wavenumber in each solar spectral band
!    and the solar flux common to solar spectral band n and aerosol
!    parameterization band ni.
!---------------------------------------------------------------------
      nbands = Solar_spect%nbands 
      allocate ( nivl1aero  (nbands) )
      allocate ( nivl2aero  (nbands) )
      allocate ( solivlaero (nbands, num_wavenumbers))

!---------------------------------------------------------------------
!    define the solar weights and interval counters that are needed to  
!    map the aerosol parameterization spectral intervals onto the solar
!    spectral intervals and so determine the single-scattering proper-
!    ties on the solar spectral intervals.
!--------------------------------------------------------------------
      nivl3 = 1
      sumsol3 = 0.0
      nband = 1
      solivlaero(:,:) = 0.0
      nivl1aero(1) = 1
      do nw = 1,Solar_spect%endwvnbands(nbands)
        sumsol3 = sumsol3 + Solar_spect%solarfluxtoa(nw)
        if (nw == endaerwvnsf(nivl3) ) then
          solivlaero(nband,nivl3) = sumsol3
          sumsol3 = 0.0
        end if
        if ( nw == Solar_spect%endwvnbands(nband) ) then
          if ( nw /= endaerwvnsf(nivl3) ) then
            solivlaero(nband,nivl3) = sumsol3 
            sumsol3 = 0.0
          end if
          nivl2aero(nband) = nivl3
          nband = nband + 1
          if ( nband <= nbands ) then
            if ( nw == endaerwvnsf(nivl3) ) then
              nivl1aero(nband) = nivl3 + 1
            else
              nivl1aero(nband) = nivl3
            end if
          end if
        end if
        if ( nw == endaerwvnsf(nivl3) ) nivl3 = nivl3 + 1
      end do

!---------------------------------------------------------------------
!    allocate and initialize variables which will hold the aerosol 
!    radiative properties for each solar spectral parameterization band.
!    aerextband     the solar band values of the extinction 
!                   coefficient for aerosols                           
!    aerssalbband   the solar band values of the single-     
!                   scattering albedo for aerosols                      
!    aerasymmband   the solar band values of the asymmetry   
!                   factor for aerosols                                 
!---------------------------------------------------------------------
      allocate     &
        (aerextband_MOD   (Solar_spect%nbands, naermodels), &
         aerssalbband_MOD (Solar_spect%nbands, naermodels), &
         aerasymmband_MOD (Solar_spect%nbands, naermodels) )
      aerextband_MOD   = 0.
      aerssalbband_MOD = 0.
      aerasymmband_MOD = 0.

!--------------------------------------------------------------------
!    if sw aerosol properties are desired and have not yet been calc-
!    ulated, use the thick-averaging technique to define the single-
!    scattering properties for each solar parameterization band n 
!    from the specified properties on the aerosol parameterization 
!    bands ni for each aerosol properties type nmodel. 
! references:                                                          
!    edwards,j.m. and a. slingo, studies with a flexible new radiation  
!    code I: choosing a configuration for a large-scale model.,     
!    q.j.r. meteorological society, 122, 689-719, 1996.              
!                                                                      
! note: a thin-averaging technique (subroutine thinavg in 
!    rad_utilities_mod) is also available.   
!--------------------------------------------------------------------
      do nmodel=1,naermodels
        call thickavg (nivl1aero, nivl2aero, num_wavenumbers,   &
                       Solar_spect%nbands, aeroextivl(:,nmodel), &
                       aerossalbivl(:,nmodel),    &
                       aeroasymmivl(:,nmodel), solivlaero,   &
                       Solar_spect%solflxbandref,  &
                       aerextband_MOD(:,nmodel),    &
                       aerssalbband_MOD(:,nmodel),   &
                       aerasymmband_MOD(:,nmodel))
      end do

!---------------------------------------------------------------------



end subroutine sw_aerosol_interaction   



!#####################################################################
! <SUBROUTINE NAME="lw_aerosol_interaction">
!  <OVERVIEW>
!    lw_aerosol_interaction defines the weights and interval infor-
!    mation needed to map the aerosol radiative properties from the
!    aerosol parameterization bands to the aerosol emissivity bands
!    being used by the model.
!  </OVERVIEW>
!  <DESCRIPTION>
!    lw_aerosol_interaction defines the weights and interval infor-
!    mation needed to map the aerosol radiative properties from the
!    aerosol parameterization bands to the aerosol emissivity bands
!    being used by the model.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call lw_aerosol_interaction
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine lw_aerosol_interaction      

!----------------------------------------------------------------------
!    lw_aerosol_interaction defines the weights and interval infor-
!    mation needed to map the aerosol radiative properties from the
!    aerosol parameterization bands to the aerosol emissivity bands
!    being used by the model.
!----------------------------------------------------------------------

!-----------------------------------------------------------------------
!  local variables:

!---------------------------------------------------------------------
!    the following arrays define the wavenumber ranges for the separate
!    aerosol emissivity bands in the model infrared parameterization. 
!    these may be changed only by the keeper of the radiation code.
!    the order of the frequency bands corresponds to the order used
!    in the lw radiation code.
!
!      aerbandlo_fr      low wavenumber limit for the non-continuum 
!                        aerosol emissivity bands
!      aerbandhi_fr      high wavenumber limit for the non-continuum
!                        aerosol emissivity bands
!      istartaerband_fr  starting wavenumber index for the non-continuum
!                        aerosol emissivity bands
!      iendaerband_fr    ending wavenumber index for the non-continuum
!                        aerosol emissivity bands
!      aerbandlo_co      low wavenumber limit for the continuum 
!                        aerosol emissivity bands
!      aerbandhi_co      high wavenumber limit for the continuum
!                        aerosol emissivity bands
!      istartaerband_co  starting wavenumber index for the continuum
!                        aerosol emissivity bands
!      iendaerband_co    ending wavenumber index for the continuum
!                        aerosol emissivity bands
!      aerbandlo         low wavenumber limit for the entire set of
!                        aerosol emissivity bands
!      aerbandhi         high wavenumber limit for the entire set of
!                        aerosol emissivity bands
!      istartaerband     starting wavenumber index for the entire set of
!                        aerosol emissivity bands
!      iendaerband       ending wavenumber index for the entire set of
!                        aerosol emissivity bands
!
!----------------------------------------------------------------------
      real, dimension (N_AEROSOL_BANDS_FR)     :: aerbandlo_fr =  &
      (/ 560.0, 630.0, 700.0, 800.0, 900.0,  990.0, 1070.0, 1200.0 /)

      real, dimension (N_AEROSOL_BANDS_FR)     :: aerbandhi_fr =  &
      (/ 630.0, 700.0, 800.0, 900.0, 990.0, 1070.0, 1200.0, 1400.0 /)

      integer, dimension (N_AEROSOL_BANDS_FR)  :: istartaerband_fr =  &
      (/ 57,  64,  71,  81,  91, 100, 108, 121 /)

      integer, dimension (N_AEROSOL_BANDS_FR)  :: iendaerband_fr =  &
      (/ 63,  70,  80,  90,  99, 107, 120, 140 /)

      real, dimension (N_AEROSOL_BANDS_CO)     :: aerbandlo_co =  &
      (/ 560.0 /)

      real, dimension (N_AEROSOL_BANDS_CO)     :: aerbandhi_co =  &
      (/ 800.0 /)

      integer, dimension (N_AEROSOL_BANDS_CO)  :: istartaerband_co =  &
      (/ 57  /)

      integer, dimension (N_AEROSOL_BANDS_CO)  :: iendaerband_co =  &
      (/ 80  /)

      integer, dimension (N_AEROSOL_BANDS_CN)  :: istartaerband_cn =  &
      (/ 81  /)

      integer, dimension (N_AEROSOL_BANDS_CN)  :: iendaerband_cn =  &
      (/ 120 /)

      real,    dimension(N_AEROSOL_BANDS)      :: aerbandlo, aerbandhi
      integer, dimension(N_AEROSOL_BANDS)      :: istartaerband,    &
                                                  iendaerband

!---------------------------------------------------------------------
!    the following arrays define how the ir aerosol band structure 
!    relates to the aerosol parameterization bands.
!
!      nivl1aer_fr(n)    aerosol parameterization band index corres-
!                        ponding to the lowest wavenumber of the 
!                        non-continuum ir aerosol emissivity band n
!      nivl2aer_fr(n)    aerosol parameterization band index corres-
!                        ponding to the highest wavenumber of the 
!                        non-continuum ir aerosol emissivity band n
!      nivl1aer_co(n)    aerosol parameterization band index corres-
!                        ponding to the lowest wavenumber of the 
!                        continuum ir aerosol emissivity band n
!      nivl2aer_co(n)    aerosol parameterization band index corres-
!                        ponding to the highest wavenumber of the 
!                        continuum ir aerosol emissivity band n
!      nivl1aer(n)       aerosol parameterization band index corres-
!                        ponding to the lowest wavenumber for the 
!                        ir aerosol emissivity band n
!      nivl2aer(n)       aerosol parameterization band index corres-
!                        ponding to the highest wavenumber for the 
!                        ir aerosol emissivity band n
!      planckaerband(n)  planck function summed over each lw param-
!                        eterization band that is contained in the 
!                        ir aerosol emissivity band n
!
!---------------------------------------------------------------------
      integer, dimension (N_AEROSOL_BANDS_FR)  :: nivl1aer_fr,   &
                                                  nivl2aer_fr
      integer, dimension (N_AEROSOL_BANDS_CO)  :: nivl1aer_co,   &
                                                  nivl2aer_co
      integer, dimension (N_AEROSOL_BANDS_CN)  :: nivl1aer_cn,   &
                                                  nivl2aer_cn
      real,    dimension (N_AEROSOL_BANDS)     :: planckaerband
      real,    dimension (N_AEROSOL_BANDS_CN)  :: planckaerband_cn

!----------------------------------------------------------------------
!    the following arrays relate the ir aerosol emissivity band n to
!    either the aerosol optical properties type na or to the aerosol 
!    parameterization band ni.
!        aerextbandlw_fr(n,na)  band averaged extinction coefficient
!                               for non-continuum aerosol emissivity 
!                               band n and aerosol properties type na
!        aerssalbbandlw_fr(n,na)
!                               band averaged single-scattering
!                               coefficient for non-continuum aerosol
!                               emissivity band n and aerosol properties
!                               type na
!        aerextbandlw_co(n,na)  band averaged extinction coefficient
!                               for the continuum aerosol emissivity
!                               band n and aerosol properties type na
!        aerssalbbandlw_co(n,na)
!                               band averaged single-scattering
!                               coefficient for continuum aerosol
!                               emissivity band n and aerosol properties
!                               type na
!        planckivlaer_fr(n,ni)  planck function over the spectral range
!                               common to aerosol emissivity non-
!                               continuum band n and aerosol parameter-
!                               ization band ni
!        planckivlaer_co(n,ni)  planck function over the spectral range
!                               common to aerosol emissivity continuum 
!                               band n and aerosol parameterization 
!                               band ni
!        sflwwts_fr(n,ni)       band weights for the aerosol emissivity
!                               non-continuum band n and the aerosol 
!                               parameterization band ni 
!        sflwwts_co(n,ni)       band weights for the aerosol emissivity
!                               continuum band n and the aerosol 
!                               parameterization band ni 
!        planckivlaer(n,ni)     planck function over the spectral range
!                               common to aerosol emissivity band n and
!                               aerosol parameterization band ni
!        iendsfbands(ni)        ending wavenumber index for aerosol 
!                               parameterization band ni
!
!----------------------------------------------------------------------
      real,    dimension (N_AEROSOL_BANDS_FR, num_wavenumbers) :: &
                                                  planckivlaer_fr, &
                                                  sflwwts_fr
      real,    dimension (N_AEROSOL_BANDS_CO, num_wavenumbers) :: &
                                                  planckivlaer_co, &
                                                  sflwwts_co
      real,    dimension (N_AEROSOL_BANDS_CN, num_wavenumbers) :: &
                                                  planckivlaer_cn   
      integer, dimension (num_wavenumbers)    ::  iendsfbands

!---------------------------------------------------------------------
!    variables associated with the planck function calculation.
!    the planck function is defined for each of the NBLW longwave 
!    parameterization bands.
!---------------------------------------------------------------------
      real, dimension(NBLW)  :: c1, centnb, sc, src1nb, x, x1
      real                   :: del, xtemv, sumplanck

!---------------------------------------------------------------------
!    miscellaneous variables:

     logical         :: do_band1   !  should we do special calculation 
                                   !  for band 1 ?
     integer         :: ib, nw, nivl, nband, n, ni 
                                   !  do-loop indices and counters
     integer         :: na

!--------------------------------------------------------------------
!    define arrays containing the characteristics of all the ir aerosol
!    emissivity bands, both continuum and non-continuum.
!--------------------------------------------------------------------
      do n=1,N_AEROSOL_BANDS_FR
        aerbandlo(n)     = aerbandlo_fr(n)
        aerbandhi(n)     = aerbandhi_fr(n)
        istartaerband(n) = istartaerband_fr(n)
        iendaerband(n)   = iendaerband_fr(n)
      end do
      do n=N_AEROSOL_BANDS_FR+1,N_AEROSOL_BANDS
        aerbandlo(n)     = aerbandlo_co     (n - N_AEROSOL_BANDS_FR)
        aerbandhi(n)     = aerbandhi_co     (n - N_AEROSOL_BANDS_FR)
        istartaerband(n) = istartaerband_co (n - N_AEROSOL_BANDS_FR)
        iendaerband(n)   = iendaerband_co   (n - N_AEROSOL_BANDS_FR)
      end do

!---------------------------------------------------------------------
!    define the number of aerosol ir bands to be used in other modules.
!    set the initialization flag to .true.
!---------------------------------------------------------------------
      Lw_parameters%n_lwaerosol_bands = N_AEROSOL_BANDS
      Lw_parameters%n_lwaerosol_bands_iz = .true.

!--------------------------------------------------------------------
!    allocate a module variable which will store the weighting function
!    between the aerosol emissivity bands and the aerosol parameter-
!    ization bands.
!--------------------------------------------------------------------
      allocate (sflwwts (N_AEROSOL_BANDS, num_wavenumbers))
      allocate (sflwwts_cn (N_AEROSOL_BANDS_CN, num_wavenumbers))

!--------------------------------------------------------------------
!    define the ending aerosol band index for each of the aerosol
!    parameterization bands.
!--------------------------------------------------------------------
      iendsfbands(:) = INT((endaerwvnsf(:) + 0.01)/10.0)

!--------------------------------------------------------------------
!    compute the planck function at 10C over each of the longwave
!    parameterization bands to be used as the weighting function. 
!--------------------------------------------------------------------
      do n=1,NBLW 
        del  = 10.0E+00
        xtemv = 283.15
        centnb(n) = 5.0 + (n - 1)*del
        c1(n)     = (3.7412E-05)*centnb(n)**3
        x(n)      = 1.4387E+00*centnb(n)/xtemv
        x1(n)     = EXP(x(n))
        sc(n)     = c1(n)/(x1(n) - 1.0E+00)
        src1nb(n) = del*sc(n)
      end do
 
!--------------------------------------------------------------------
!    sum the weighting function calculated over the longwave param-
!    eterization bands that are contained in each of the aerosol 
!    emissivity bands. 
!--------------------------------------------------------------------
      planckaerband(:) = 0.0E+00
      do n = 1,N_AEROSOL_BANDS
        do ib = istartaerband(n),iendaerband(n)
          planckaerband(n) = planckaerband(n) + src1nb(ib)
        end do
      end do
      planckaerband_cn(:) = 0.0E+00
      do n = 1,N_AEROSOL_BANDS_CN
        do ib = istartaerband_cn(n),iendaerband_cn(n)
          planckaerband_cn(n) = planckaerband_cn(n) + src1nb(ib)
        end do
      end do
 
!--------------------------------------------------------------------
!    define the weights and interval counters that are needed to  
!    map the aerosol parameterization spectral intervals onto the non-
!    continuum ir aerosol emissivity bands and so determine the 
!    single-scattering properties on the ir aerosol emissivity bands.
!--------------------------------------------------------------------
      nivl = 1
      sumplanck = 0.0
      nband = 1
      planckivlaer_fr(:,:) = 0.0
      nivl1aer_fr(1) = 1
      do_band1 = .true.
 
      do nw = 1,NBLW
        sumplanck = sumplanck + src1nb(nw)
        if ( nw == iendsfbands(nivl) ) then
          planckivlaer_fr(nband,nivl) = sumplanck
          sumplanck = 0.0
        end if
        if ( nw == iendaerband_fr(nband) ) then
          if ( nw /= iendsfbands(nivl) ) then
            planckivlaer_fr(nband,nivl) = sumplanck 
            sumplanck = 0.0
          end if
          nivl2aer_fr(nband) = nivl
          nband = nband + 1
          if ( nband <= N_AEROSOL_BANDS_FR ) then
            if ( nw == iendsfbands(nivl) ) then
              nivl1aer_fr(nband) = nivl + 1
            else
              nivl1aer_fr(nband) = nivl
            end if
          end if
        end if
        if ( nw == iendsfbands(nivl) ) then
          nivl = nivl + 1
          if (do_band1 .and. nband .eq. 1 .and.   &
              iendsfbands(nivl-1) >= istartaerband_fr(1) .and.  &
              iendsfbands(nivl-1) < iendaerband_fr(1)) then
            nivl1aer_fr(nband) = nivl-1
            do_band1 = .false.
          endif
        endif
        if (nw >= iendaerband_fr(N_AEROSOL_BANDS_FR) ) then
          exit
        endif
      end do

!--------------------------------------------------------------------
!    define the weights and interval counters that are needed to  
!    map the aerosol parameterization spectral intervals onto the 
!    continuum ir aerosol emissivity bands and so determine the 
!    single-scattering properties on the ir aerosol emissivity bands.
!--------------------------------------------------------------------
      nivl = 1
      sumplanck = 0.0
      nband = 1
      planckivlaer_co(:,:) = 0.0
      nivl1aer_co(1) = 1
      do_band1 = .true.
 
      do nw = 1,NBLW
        sumplanck = sumplanck + src1nb(nw)
        if ( nw == iendsfbands(nivl) ) then
          planckivlaer_co(nband,nivl) = sumplanck
          sumplanck = 0.0
        end if
        if ( nw == iendaerband_co(nband) ) then
          if ( nw /= iendsfbands(nivl) ) then
            planckivlaer_co(nband,nivl) = sumplanck 
            sumplanck = 0.0
          end if
          nivl2aer_co(nband) = nivl
          nband = nband + 1
          if ( nband <= N_AEROSOL_BANDS_CO ) then
            if ( nw == iendsfbands(nivl) ) then
              nivl1aer_co(nband) = nivl + 1
            else
              nivl1aer_co(nband) = nivl
            end if
          end if
        end if
        if ( nw == iendsfbands(nivl) ) then
          nivl = nivl + 1
          if (do_band1 .and. nband == 1 .and.  &
              iendsfbands(nivl-1) >= istartaerband_co(1) .and.  &
              iendsfbands(nivl-1) < iendaerband_co(1)) then
            nivl1aer_co(nband) = nivl-1
            do_band1 = .false.
          endif
        endif
        if ( nw >= iendaerband_co(N_AEROSOL_BANDS_CO) ) then
          exit
        endif
      end do

!--------------------------------------------------------------------
!    define the weights and interval counters that are needed to  
!    map the aerosol parameterization spectral intervals onto the 
!    continuum ir aerosol emissivity bands and so determine the 
!    single-scattering properties on the ir aerosol emissivity bands.
!--------------------------------------------------------------------
      nivl = 1
      sumplanck = 0.0
      nband = 1
      planckivlaer_cn(:,:) = 0.0
      nivl1aer_cn(1) = 1
      do_band1 = .true.
 
      do nw = 1,NBLW
        sumplanck = sumplanck + src1nb(nw)
        if ( nw == iendsfbands(nivl) ) then
          planckivlaer_cn(nband,nivl) = sumplanck
          sumplanck = 0.0
        end if
        if ( nw == iendaerband_cn(nband) ) then
          if ( nw /= iendsfbands(nivl) ) then
            planckivlaer_cn(nband,nivl) = sumplanck 
            sumplanck = 0.0
          end if
          nivl2aer_cn(nband) = nivl
          nband = nband + 1
          if ( nband <= N_AEROSOL_BANDS_CN ) then
            if ( nw == iendsfbands(nivl) ) then
              nivl1aer_cn(nband) = nivl + 1
            else
              nivl1aer_cn(nband) = nivl
            end if
          end if
        end if
        if ( nw == iendsfbands(nivl) ) then
          nivl = nivl + 1
          if (do_band1 .and. nband == 1 .and.  &
              iendsfbands(nivl-1) >= istartaerband_cn(1) .and.  &
              iendsfbands(nivl-1) < iendaerband_cn(1)) then
            nivl1aer_cn(nband) = nivl-1
            do_band1 = .false.
          endif
        endif
        if ( nw >= iendaerband_cn(N_AEROSOL_BANDS_CN) ) then
          exit
        endif
      end do

!--------------------------------------------------------------------
!    define the planck-function-weighted band weights for the aerosol
!    parameterization bands onto the non-continuum and continuum ir 
!    aerosol emissivity bands.
!--------------------------------------------------------------------
      sflwwts_fr(:,:) = 0.0E+00
      do n=1,N_AEROSOL_BANDS_FR
        do ni=nivl1aer_fr(n),nivl2aer_fr(n)
          sflwwts_fr(n,ni) = planckivlaer_fr(n,ni)/planckaerband(n)
        end do
      end do
      sflwwts_co(:,:) = 0.0E+00
      do n=1,N_AEROSOL_BANDS_CO
        do ni=nivl1aer_co(n),nivl2aer_co(n)
          sflwwts_co(n,ni) = planckivlaer_co(n,ni)/     &
                             planckaerband(N_AEROSOL_BANDS_FR+n)
        end do
      end do
      sflwwts_cn(:,:) = 0.0E+00
      do n=1,N_AEROSOL_BANDS_CN
        do ni=nivl1aer_cn(n),nivl2aer_cn(n)
          sflwwts_cn(n,ni) = planckivlaer_cn(n,ni)/     &
                             planckaerband_cn(n)
        end do
      end do

!--------------------------------------------------------------------
!    consolidate the continuum and non-continuum weights into an
!    array covering all ir aerosol emissivity bands.
!--------------------------------------------------------------------
      do n=1,N_AEROSOL_BANDS_FR
        do ni = 1,num_wavenumbers
          sflwwts(n,ni) = sflwwts_fr(n,ni)
        end do
      end do
      do n=N_AEROSOL_BANDS_FR+1,N_AEROSOL_BANDS
        do ni = 1,num_wavenumbers
          sflwwts(n,ni) = sflwwts_co(n-N_AEROSOL_BANDS_FR,ni)
        end do
      end do

!-----------------------------------------------------------------
!    allocate and initialize the arrays in the aerosol_properties_type 
!    variable that will contain the ir aerosol properties for each
!    aerosol optical type over each ir aerosol emissivity band.
!----------------------------------------------------------------
      allocate     &
         (aerextbandlw_MOD   (N_AEROSOL_BANDS, naermodels), &
          aerssalbbandlw_MOD (N_AEROSOL_BANDS, naermodels), &
          aerextbandlw_cn_MOD   (N_AEROSOL_BANDS_CN, naermodels), &
          aerssalbbandlw_cn_MOD (N_AEROSOL_BANDS_CN, naermodels) )
      aerextbandlw_MOD   = 0.0E+00
      aerssalbbandlw_MOD = 0.0E+00
      aerextbandlw_cn_MOD   = 0.0E+00
      aerssalbbandlw_cn_MOD = 0.0E+00

      if (.not. force_to_repro_quebec) then
!---------------------------------------------------------------------
!    if longwave aerosol effects are desired, and the following cal-
!    culation has not already been done, calculate the aerosol 
!    properties for each aerosol properties type nw over each aerosol 
!    emissivity band na using the weighted contributions from each
!    aerosol parameterization band ni. mark the calculation as com-
!    pleted.
!
!    the units of extinction coefficient (aeroextivl) are m**2/gm.
!    to make the lw band extinction coefficient (aerextbandlw) have
!    units (m**2/Kg) consistent with the units in FMS models, one
!    must multiply by 1000. this is done below.
!---------------------------------------------------------------------
        do nw=1,naermodels    
          do na=1,N_AEROSOL_BANDS  
            do ni=1,num_wavenumbers 
              aerextbandlw_MOD(na,nw) = aerextbandlw_MOD(na,nw) + &
                                aeroextivl(ni,nw)*sflwwts(na,ni)*1.0E+03
              aerssalbbandlw_MOD(na,nw) = aerssalbbandlw_MOD(na,nw) + &
                                     aerossalbivl(ni,nw)*sflwwts(na,ni)
            end do
          end do
        end do
        do nw=1,naermodels    
          do na=1,N_AEROSOL_BANDS_CN
            do ni=1,num_wavenumbers 
              aerextbandlw_cn_MOD(na,nw) = aerextbandlw_cn_MOD(na,nw) +&
                            aeroextivl(ni,nw)*sflwwts_cn(na,ni)*1.0E+03
              aerssalbbandlw_cn_MOD(na,nw) =    &
                               aerssalbbandlw_cn_MOD(na,nw) +&
                                  aerossalbivl(ni,nw)*sflwwts_cn(na,ni)
            end do
          end do
        end do
      endif

!----------------------------------------------------------------------



end subroutine lw_aerosol_interaction


!######################################################################



               end module aerosolrad_package_mod

module ocean_vert_kpp_test_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> A. Rosati
!</CONTACT>
!
!<CONTACT EMAIL="martin.schmidt@io-warnemuende.de"> Martin Schmidt 
!</CONTACT>
!
!<REVIEWER EMAIL="wily@ucar.edu"> Bill Large 
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen Griffies 
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> M.J. Harrison 
!</REVIEWER>
!
!<OVERVIEW>
! Vertical viscosity and diffusivity according KPP.  
!
! This module has extra code options to handle regions of extremely fresh water.  
!
! It also has options for both the Cgrid and Bgrid. 
!
! It is undergoing further development in collaboration with NCAR scientists.  
! So it will undergo significant change during 2012.  
!
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes vertical viscosity and diffusivity according to 
! the K-profile parameterization scheme of Large, McWilliams, and 
! Doney (1994). It computes both local and non-local mixing.
! The code has been updated to MOM4p1, so that vertical grid increments
! are suitable for generalized vertical coordinate models.  When run
! as geopotential model, there will be some differences, since the
! MOM4.0 code (available in ocean_vert_kpp_mom4p0.F90) incorrectly
! ignored the free surface undulations affecting the top model grid
! cell thickness.  
!
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! W.G. Large and J.C. McWilliams and S.C. Doney
! Oceanic vertical mixing: A review and a model with
! a nonlocal boundary layer parameterization
! Reviews of Geophysics (1994) vol 32 pages 363-403
! </REFERENCE>
! <REFERENCE>
! Danabasoglu etal (2006) 
! Diurnal coupling in the tropical oceans of CCSM3
! Journal of Climate (2006) vol 19 pages 2347--2365
! </REFERENCE>
!
! <NOTE>
! Original numerical algorithm by Bill Large at NCAR June 6, 1994
! </NOTE>
!
! <NOTE>
! Equation numbers in the code refer to the Large etal paper. 
! </NOTE>
!
! <NOTE>
! Surface fresh water contributes to surface buoyancy via conversion to 
! a locally implied salt flux. 
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_vert_kpp_test_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Logical switch to enable kpp diffusion.  Default is false. 
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  Logical switch for debugging. Default debug_this_module=.false. 
!  </DATA> 
!
!  <DATA NAME="shear_instability" TYPE="logical">
!  logical switch for shear instability mixing.
!  Default shear_instability=.true.
!  </DATA> 
!  <DATA NAME="double_diffusion" TYPE="logical">
!  Logical switch for double-diffusive mixing.
!  Default double_diffusion=.true.  
!  </DATA> 
!
!  <DATA NAME="diff_cbt_iw" UNITS="m^2/sec" TYPE="real">
!  Background vertical diffusivity.  Note that if using Bryan-Lewis as a 
!  background diffusivity, then should set diff_cbt_iw=0.0. 
!  </DATA> 
!  <DATA NAME="visc_cbu_iw" UNITS="m^2/sec" TYPE="real">
!  Background vertical viscosity
!  </DATA> 
!  <DATA NAME="visc_cbu_limit" UNITS="m^2/sec" TYPE="real">
!  Enhanced vertical viscosity due to shear instability 
!  </DATA> 
!  <DATA NAME="diff_cbt_limit" UNITS="m^2/sec" TYPE="real">
!  Enhanced vertical diffusivity due to shear instability 
!  </DATA> 
!  <DATA NAME="visc_con_limit" UNITS="m^2/sec" TYPE="real">
!  Enhanced vertical viscosity in regions of convection
!  </DATA> 
!  <DATA NAME="diff_con_limit" UNITS="m^2/sec" TYPE="real">
!  Enhanced vertical diffusivity in regions of convection
!  </DATA> 
!
!  <DATA NAME="concv" UNITS="dimensionless" TYPE="real">
!  constant for pure convection (eqn. 23 of Large etal)
!  </DATA> 
!  <DATA NAME="Ricr" UNITS="dimensionless" TYPE="real">
!  Critical bulk Richardson number.  Default from NCAR is 
!  0.3, though this number has a large uncertainty and some
!  find that 1.0 can be of use. 
!  </DATA> 
!  <DATA NAME="non_local_kpp" TYPE="logical">
!  logical switch for enabling the non-local mixing aspect of kpp. 
!  Default is .true. as this is what the original KPP scheme suggests. 
!  </DATA> 
!  <DATA NAME="smooth_blmc" TYPE="logical">
!  Smooth boundary layer diffusitivies to remove grid scale noise.
!  Such noise is apparent in the diagnosed mixed layer depth as well
!  as the SST, especially when running coupled models where forcing 
!  has high temporal frequency. 
!  Default smooth_blmc=.false.
!
!  Warning: This smoother can cause some problems with ghat in regions
!  of zero surface forcing.  To understand details, one needs 
!  the paper of Large et al. Vertical diffusion has the general form 
!  <wx> = K(x_z - ghats)
!  In the surface layer a vertical scale function ws is estimated.
!  We have K ~ ws and ghats ~1/ws. If wind stress is zero the vertical 
!  scale ws becomes zero too. Hence, ghats is very large 
!  (something finite, since it is divided by ws+epsln). Now it may happen,
!  that the bouyancy flux becomes negative (~ -10-30). This enables
!  the nonlocal scheme. Because the mixing coefficient in the 
!  surface boundary layer scales with ws the corresponding
!  time tendency should be of the order (1/ws * ws = finite). However,
!  if smooth_blmc is enabled, it may happen, that from neighbouring
!  points with different mixing depth a finite value for
!  the mixing coefficient leaks in. In this case
!  the tracer time tendency from the nonlocal scheme becomes huge
!  and the model fails. 
!
!  The smoother destroys the consistency between ghats and diff_cbt.
!  In most cases this should not matter, but the example shows,
!  that sudden model failure is possible under otherwise
!  stable and smooth conditions.
! 
!  </DATA> 
!  <DATA NAME="kl_min" TYPE="integer">
!  Lower loop index for finding new kbl. Needed for use with certain 
!  tests of OBC, where kl_min=1 needed, whereas default in original 
!  implementation has kl_min=2.  Default in MOM is kl_min=2. 
!  </DATA> 
!  <DATA NAME="kbl_standard_method" TYPE="logical">
!  For computing kbl as in the MOM4p0d code, which is taken from 
!  the original NCAR scheme.  If false, then will slightly modify 
!  the logic.  The modified logic has been found necessary when running
!  with as few as two grid cells in the vertical.  
!  Default kbl_standard_method=.true.
!  </DATA> 
!  <DATA NAME="limit_with_hekman" TYPE="logical">
!  Limiting the boundary layer depth with the Ekman depth may result in a 
!  shallow boundary layer. In this case the internal values of the vertical 
!  mixing and viscosity coefficients may be large. This results in 
!  unrealistically large non-local vertical mixing
!  Default limit_with_hekman=.true.
!  </DATA> 
!  <DATA NAME="limit_ghats" TYPE="logical">
!  Limits the non-local vertical tracer flux to the value of the tracer 
!  surface flux.   
!  Default limit_ghats=.false.
!  </DATA> 
!  <DATA NAME="hbl_with_rit" TYPE="logical">
!  The default method for determination of the boundary layer depth may fail
!  if the water column is instable (negative Richardson number) below or above 
!  the layer that contains the diagnosed hbl.  
!  With hbl_with_rit=.true. the search for the boundary layer depth is continued 
!  downward in this case even if the bulk Richardson number exceeds the 
!  critical value. This removes a lot of noise from the boundary layer depth. 
!  Default hbl_with_rit=.false.
!  </DATA> 
!  <DATA NAME="radiation_large" TYPE="logical">
!  Remove the shortwave radiation leaving the boundary layer to the ocean interior 
!  (hence, not absorbed in the boundary layer) from non-local vertical heat flux
!  Default radiation_large=.false.
!  </DATA> 
!  <DATA NAME="radiation_zero" TYPE="logical">
!  Remove the all shortwave radiation from non-local vertical heat flux.
!  Default radiation_zero=.false.
!  </DATA> 
!  <DATA NAME="radiation_iow" TYPE="logical">
!  Keep only the shortwave radiation absorbed between the surface and a certain level
!  in non-local vertical heat flux through this level.
!  Default radiation_iow=.false.
!  </DATA> 
!
!  <DATA NAME="bvf_from_below" TYPE="logical">
!  Use BV-freq. at the cell bottom instead of the cell top
!  as in Danabasoglu et al. (2006).
!  Default bvf_from_below=.false., as this will recover 
!  older behaviour.  
!  </DATA> 
!  <DATA NAME="variable_vtc" TYPE="logical">
!  Make vtc dependent on BV-freq. as in Danabasoglu et al. (2006).
!  Default variable_vtc=.false., as this will recover 
!  older behaviour.  
!  </DATA> 
!  <DATA NAME="use_max_shear" TYPE="logical">
!  Use maximum shear instead of 4-point average 
!  (as in Danabasoglu et al. (2006)).
!  Default use_max_shear=.false., as this will recover 
!  legacy behaviour.  
!  </DATA> 
!
!  <DATA NAME="linear_hbl" TYPE="logical">
!  Use linear interpolation to find the position of hbl.
!  If set to false, then use the quadratic interpolation 
!  as in Danabasoglu et al. (2006). The quadratic approach
!  generally yields a slightly deeper surface boundary layer.
!  Default linear_hbl=.true., as this will recover 
!  older behaviour.  
!  </DATA> 

!  <DATA NAME="wsfc_combine_runoff_calve" TYPE="logical">
!  For computing wsfc as in the MOM4p0d code, where we combine
!  the runoff+calving into a single field called river.  
!  The alternative keeps the fields separate, as would be appropriate
!  for a land model that separately tracks the tracer content in the 
!  calving and runoff. 
!  Default wsfc_combine_runoff_calve=.true., as this will recover
!  the previous behaviour, to the bit. 
!  </DATA> 
!
!  <DATA NAME="smooth_ri_kmax_eq_kmu" TYPE="logical">
!  When smoothing the Richardson number, we do so over a vertical 
!  column with max k-levels set by either kmt or kmu.  The proper 
!  approach is kmu, since we are smoothing riu.  But for backwards
!  compatibility, we default to smooth_ri_kmax_eq_kmu=.false. 
!  </DATA> 
!
!</NAMELIST>

use constants_mod,    only: epsln
use diag_manager_mod, only: register_diag_field, register_static_field
use fms_mod,          only: FATAL, NOTE, WARNING, stdout, stdlog
use fms_mod,          only: write_version_number, open_namelist_file, check_nml_error, close_file
use fms_mod,          only: read_data
use mpp_domains_mod,  only: mpp_update_domains, NUPDATE, EUPDATE
use mpp_mod,          only: input_nml_file, mpp_error

use ocean_density_mod,     only: density, density_delta_z, density_delta_sfc
use ocean_domains_mod,     only: get_local_indices
use ocean_parameters_mod,  only: MOM_BGRID, MOM_CGRID 
use ocean_parameters_mod,  only: grav, cp_ocean, missing_value, von_karman, onefourth
use ocean_parameters_mod,  only: ZSIGMA, PSIGMA, rho0r, rho0, PRESSURE_BASED
use ocean_types_mod,       only: ocean_grid_type, ocean_domain_type
use ocean_types_mod,       only: ocean_prog_tracer_type, ocean_diag_tracer_type
use ocean_types_mod,       only: ocean_velocity_type, ocean_density_type
use ocean_types_mod,       only: ocean_time_type, ocean_time_steps_type, ocean_thickness_type
use ocean_vert_util_mod,   only: ri_for_bgrid, ri_for_cgrid
use ocean_workspace_mod,   only: wrk1, wrk2, wrk3, wrk4, wrk5
use ocean_workspace_mod,   only: wrk1_v
use ocean_util_mod,        only: diagnose_2d, diagnose_3d, diagnose_3d_u, diagnose_sum
use ocean_tracer_util_mod, only: diagnose_3d_rho


implicit none

private

public ocean_vert_kpp_test_init
public vert_mix_kpp_test

private bldepth
private wscale
private ri_iwmix
private ddmix
private blmix_kpp
private enhance
private watermass_diag_init
private watermass_diag 

#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS

real, dimension(isd:ied,jsd:jed)                :: bfsfc      ! surface buoyancy forcing    (m^2/s^3)
real, dimension(isd:ied,jsd:jed)                :: ws         ! scalar velocity scale (m/s)
real, dimension(isd:ied,jsd:jed)                :: wm         ! momentum velocity scale (m/s)
real, dimension(isd:ied,jsd:jed)                :: Ustk2      ! magnitude of surface stokes drift velocity ^2 (m^2 / s^2)
real, dimension(isd:ied,jsd:jed)                :: caseA      ! = 1 in case A; =0 in case B
real, dimension(isd:ied,jsd:jed)                :: stable     ! = 1 in stable forcing; =0 in unstable
real, dimension(isd:ied,jsd:jed,3)              :: dkm1       ! boundary layer diff_cbt at kbl-1 level
real, dimension(isd:ied,jsd:jed,nk,3)           :: blmc       ! boundary layer mixing coefficients
real, dimension(isd:ied,jsd:jed)                :: sigma      ! normalized depth (d / hbl)
real, dimension(isd:ied,jsd:jed)                :: rhosfc     ! potential density of sfc layer(kg/m^3)
real, dimension(isd:ied,jsd:jed,nk)             :: talpha     ! -d(rho)/ d(pot.temperature)  (kg/m^3/C)
real, dimension(isd:ied,jsd:jed,nk)             :: sbeta      ! d(rho)/ d(salinity)       (kg/m^3/PSU)
real, dimension(isd:ied,jsd:jed,nk)             :: alphaDT    ! alpha * DT  across interfaces (kg/m^3)
real, dimension(isd:ied,jsd:jed,nk)             :: betaDS     ! beta  * DS  across interfaces (kg/m^3)
real, dimension(isd:ied,jsd:jed)                :: ustar      ! surface friction velocity       (m/s)
real, dimension(isd:ied,jsd:jed)                :: Bo         ! surface turb buoy. forcing  (m^2/s^3)
real, dimension(isd:ied,jsd:jed)                :: Bosol      ! radiative buoy forcing      (m^2/s^3)
real, dimension(isd:ied,jsd:jed,nk)             :: dbloc      ! local delta buoy at interfaces(m/s^2)
real, dimension(isd:ied,jsd:jed,nk)             :: dbsfc      ! delta buoy w/ respect to sfc  (m/s^2)
real, dimension(isd:ied,jsd:jed,nk)             :: dVsq       ! (velocity shear re sfc)^2   (m/s)^2
real, dimension(isd:ied,jsd:jed,3)              :: Rib        ! Bulk Richardson number
real, dimension(isd:ied,jsd:jed,3)              :: gat1
real, dimension(isd:ied,jsd:jed,3)              :: dat1

type wsfc_type
  real, dimension(isd:ied,jsd:jed)              :: wsfc        ! rho0r*(stf - pme*(t(i,j,k=1)-tpme) - river*(t(i,j,k=1)-triver))
end type wsfc_type
real, dimension(isd:ied,jsd:jed)                :: sw_frac_hbl ! fractional shortwave penetration at base of mixed layer
integer, dimension(isd:ied,jsd:jed)             :: kbl         ! index of first grid level below hbl

real, private, dimension(isd:ied,jsd:jed,nk)    :: riu         ! Richardson number at base of U-cells
real, private, dimension(isd:ied,jsd:jed,nk)    :: rit         ! Richardson number at base of T-cells
real, private, dimension(isd:ied,jsd:jed,nk)    :: ghats       ! nonlocal transport (s/m^2)
real, private, dimension(isd:ied,jsd:jed)       :: hblt        ! boundary layer depth with tmask 
real, private, dimension(isd:ied,jsd:jed)       :: hbl         ! boundary layer depth

#else

real, dimension(:,:), allocatable      :: bfsfc    ! surface buoyancy forcing    (m^2/s^3)
real, dimension(:,:), allocatable      :: ws       ! scalar velocity scale (m/s)
real, dimension(:,:), allocatable      :: wm       ! momentum velocity scale (m/s)
real, dimension(:,:), allocatable      :: Ustk2    ! Magnitude of surface stokes drift velocity ^2 (m^2/s^2)
real, dimension(:,:), allocatable      :: caseA    ! = 1 in case A; =0 in case B
real, dimension(:,:), allocatable      :: stable   ! = 1 in stable forcing; =0 in unstable
real, dimension(:,:,:), allocatable    :: dkm1     ! boundary layer diff_cbt at kbl-1 level
real, dimension(:,:,:,:), allocatable  :: blmc     ! boundary layer mixing coefficients
real, dimension(:,:), allocatable      :: sigma    ! normalized depth (d / hbl)
real, dimension(:,:), allocatable      :: rhosfc   ! potential density of sfc layer(kg/m^3)
real, dimension(:,:,:), allocatable    :: talpha   ! -d(rho)/ d(pot.temperature)  (kg/m^3/C)
real, dimension(:,:,:), allocatable    :: sbeta    ! d(rho)/ d(salinity)       (kg/m^3/PSU)
real, dimension(:,:,:), allocatable    :: alphaDT  ! alpha * DT  across interfaces (kg/m^3)
real, dimension(:,:,:), allocatable    :: betaDS   ! beta  * DS  across interfaces (kg/m^3)
real, dimension(:,:), allocatable      :: ustar    ! surface friction velocity       (m/s)
real, dimension(:,:), allocatable      :: Bo       ! surface turb buoy. forcing  (m^2/s^3)
real, dimension(:,:), allocatable      :: Bosol    ! radiative buoy forcing      (m^2/s^3)
real, dimension(:,:,:), allocatable    :: dbloc    ! local delta buoy at interfaces(m/s^2)
real, dimension(:,:,:), allocatable    :: dbsfc    ! delta buoy w/ respect to sfc  (m/s^2)
real, dimension(:,:,:), allocatable    :: dVsq     ! (velocity shear re sfc)^2   (m/s)^2
real, dimension(:,:,:), allocatable    :: Rib      ! Bulk Richardson number
real, dimension(:,:,:), allocatable    :: gat1
real, dimension(:,:,:), allocatable    :: dat1

type wsfc_type
  real, dimension(:,:), pointer        :: wsfc => NULL()  ! rho0r*(stf - pme*(t(i,j,k=1)-tpme) - river*(t(i,j,k=1)-triver))
end type wsfc_type
real, dimension(:,:), allocatable      :: sw_frac_hbl     ! fractional shortwave penetration at base of mixed layer
integer, dimension(:,:), allocatable   :: kbl             ! index of first grid level below hbl

real, private, dimension(:,:,:), allocatable :: riu         ! Richardson number at base of U-cells
real, private, dimension(:,:,:), allocatable :: rit         ! Richardson number at base of T-cells
real, private, dimension(:,:,:), allocatable :: ghats       ! nonlocal transport (s/m^2)
real, private, dimension(:,:),   allocatable :: hblt        ! boundary layer depth with tmask 
real, private, dimension(:,:),   allocatable :: hbl         ! boundary layer depth

#endif

type(wsfc_type), dimension(:), allocatable :: wsfc
real, parameter :: epsilon = 0.1
real, parameter :: conc1   = 5.0
real, parameter :: zmin    = -4.e-7  ! m3/s3 limit for lookup table of wm and ws
real, parameter :: zmax    = 0.0     ! m3/s3 limit for lookup table of wm and ws
real, parameter :: umin    = 0.0     ! m/s limit for lookup table of wm and ws
real, parameter :: umax    = 0.04    ! m/s limit for lookup table of wm and ws
real, parameter :: Riinfty = 0.8     ! local Richardson number limit for shear instability

real :: Ricr               = 0.3     ! critical bulk Richardson Number
real :: visc_cbu_limit     = 50.0e-4 ! max visc due to shear instability
real :: diff_cbt_limit     = 50.0e-4 ! max diff due to shear instability
real :: visc_con_limit     = 0.1     ! m^2/s. visc due to convective instability
real :: diff_con_limit     = 0.1     ! m^2/s. diff due to convective instability
real :: visc_cbu_iw        = 1.0e-4  ! m^2/s. visc background due to internal waves
real :: diff_cbt_iw        = 0.1e-4  ! m^2/s. diffusivity background due to internal waves
real :: Vtc                          ! non-dimensional coefficient for velocity 
                                     ! scale of turbulant velocity shear        
                                     ! (=function of concv,concs,epsilon,von_karman,Ricr)

real :: cg              ! non-dimensional coefficient for counter-gradient term
real :: deltaz          ! delta zehat in table
real :: deltau          ! delta ustar in table
real :: concv    = 1.8  ! constant for pure convection (eqn. 23)
real :: concv_r         ! inverse concv
real :: vtc_flag = 0.0  ! default to the older approach.   
real :: Lgam = 1.04     ! adjustment to non-gradient flux (McWilliam & Sullivan 2000)
real :: Cw_0 = 0.15     ! eq. (13) in Smyth et al (2002)
real :: l_smyth = 2.0   ! eq. (13) in Smyth et al (2002)
real :: LTmax = 5.0     ! maximum Langmuir turbulence enhancement factor (langmuirfactor) allowed
real :: Wstfac = 0.6    ! stability adjustment coefficient, eq. (13) in Smyth et al (2002)

! for global area normalization
real :: cellarea_r

! for vertical coordinate 
integer :: vert_coordinate
integer :: vert_coordinate_class

real :: rho_cp 
real :: inv_rho_cp

! for Bgrid or Cgrid
integer :: horz_grid
logical :: calc_visc_on_cgrid=.false.  ! internally set: calculate viscosity directly on c-grid

integer :: kbl_max  ! helps to limit vertical loops (defaults to nk)
integer :: kl_min=2 
logical :: kbl_standard_method=.true.

logical :: use_this_module   = .false.   ! logical switch for turning on the kpp scheme 
logical :: shear_instability = .true.    ! logical switch for shear instability mixing
logical :: double_diffusion  = .true.    ! logical switch for double-diffusive mixing
logical :: limit_ghats       = .false.   ! logical switch to limit ghats*diff to 1
logical :: limit_with_hekman = .true.    ! logical switch to limit hbl with hekman
logical :: radiation_large   = .false.   ! logical switch to enable short wave radiation in non-local scheme h_gamma=h
logical :: radiation_zero    = .false.   ! logical switch to enable short wave radiation in non-local scheme h_gamma=0
logical :: radiation_iow     = .false.   ! logical switch to enable short wave radiation in non-local scheme IOW-method
logical :: hbl_with_rit      = .false.   ! logical switch to enable hbl correction for negative rit
logical :: use_sbl_bottom_flux = .false. ! logical switch to add flux through the sbl bottom to the non-local term
logical :: wsfc_combine_runoff_calve = .true.  ! for combining runoff+calving to compute wfsc
logical :: bvf_from_below    = .false.   ! Use BV-freq. at the cell bottom instead of the cell top (Danabasoglu et al.) 
logical :: variable_vtc      = .false.   ! Make vtc dependent on BV-freq.
logical :: use_max_shear     = .false.   ! Use maximum shear instead of 4-point average
logical :: linear_hbl        = .true.    ! To use the linear interpolation as Large etal (1994).
                                         ! Set to .false. for quadratic interpolation as in Danabasoglu et al.
logical :: smooth_ri_kmax_eq_kmu=.false. ! to set details for smoothing the richardson number
real    :: shear_instability_flag=1.0    ! set to 1.0 if shear_instability=.true.

! internally set for computing watermass diagnstics
logical :: compute_watermass_diag = .false. 

! for diagnostics 
integer, dimension(:), allocatable :: id_nonlocal(:)
integer, dimension(:), allocatable :: id_nonlocal_on_nrho(:)
integer, dimension(:), allocatable :: id_ghats(:)
integer, dimension(:), allocatable :: id_wsfc(:)
integer, dimension(:), allocatable :: id_wbot(:)

logical  :: used
integer  :: id_diff_cbt_kpp_t =-1
integer  :: id_diff_cbt_kpp_s =-1
integer  :: id_visc_cbt_kpp   =-1
integer  :: id_visc_cbu_kpp   =-1
integer  :: id_hblt           =-1
integer  :: id_ws             =-1

integer  :: id_neut_rho_kpp_nloc          =-1
integer  :: id_wdian_rho_kpp_nloc         =-1
integer  :: id_tform_rho_kpp_nloc         =-1
integer  :: id_neut_rho_kpp_nloc_on_nrho  =-1
integer  :: id_wdian_rho_kpp_nloc_on_nrho =-1
integer  :: id_tform_rho_kpp_nloc_on_nrho =-1

integer :: id_eta_tend_kpp_nloc     =-1
integer :: id_eta_tend_kpp_nloc_glob=-1

integer  :: id_neut_temp_kpp_nloc          =-1
integer  :: id_wdian_temp_kpp_nloc         =-1
integer  :: id_tform_temp_kpp_nloc         =-1
integer  :: id_neut_temp_kpp_nloc_on_nrho  =-1
integer  :: id_wdian_temp_kpp_nloc_on_nrho =-1
integer  :: id_tform_temp_kpp_nloc_on_nrho =-1

integer  :: id_neut_salt_kpp_nloc          =-1
integer  :: id_wdian_salt_kpp_nloc         =-1
integer  :: id_tform_salt_kpp_nloc         =-1
integer  :: id_neut_salt_kpp_nloc_on_nrho  =-1
integer  :: id_wdian_salt_kpp_nloc_on_nrho =-1
integer  :: id_tform_salt_kpp_nloc_on_nrho =-1


logical :: non_local_kpp = .true.  ! enable/disable non-local term in KPP
logical :: smooth_blmc   = .false. ! smooth boundary layer diffusitivies to remove grid scale noise
logical :: do_langmuir   = .false. ! whether or not calcualate langmuir turbulence enhancement factor

integer, parameter :: nni = 890         ! number of values for zehat in the look up table
integer, parameter :: nnj = 480         ! number of values for ustar in the look up table
real, dimension(0:nni+1,0:nnj+1) :: wmt ! lookup table for wm, the turbulent velocity scale for momentum
real, dimension(0:nni+1,0:nnj+1) :: wst ! lookup table for ws, the turbulent velocity scale scalars

real :: tracer_timestep = 0

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type), pointer   :: Grd => NULL()

integer :: num_prog_tracers=0, index_temp, index_salt
integer :: num_diag_tracers=0, index_frazil

character(len=256) :: version=&
     '$Id: ocean_vert_kpp_test.F90,v 20.0 2013/12/14 00:16:46 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

logical :: module_is_initialized = .FALSE.
logical :: debug_this_module     = .FALSE.

namelist /ocean_vert_kpp_test_nml/ use_this_module, shear_instability, double_diffusion,  &
                                   diff_cbt_iw, visc_cbu_iw,                              &
                                   visc_cbu_limit, diff_cbt_limit,                        &
                                   visc_con_limit, diff_con_limit,                        &
                                   concv, Ricr, non_local_kpp, smooth_blmc,               &
                                   Lgam, Cw_0,l_smyth, LTmax, Wstfac,                     &
                                   kl_min, kbl_standard_method, debug_this_module,        &
                                   limit_with_hekman, limit_ghats, hbl_with_rit,          &
                                   radiation_large, radiation_zero, radiation_iow,        &
                                   use_sbl_bottom_flux, wsfc_combine_runoff_calve,        &
			           bvf_from_below, variable_vtc, use_max_shear,           &  
   			           linear_hbl, smooth_ri_kmax_eq_kmu, do_langmuir
                                 

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_vert_kpp_test_init">
!
! <DESCRIPTION>
! Initialization for the KPP vertical mixing scheme
! </DESCRIPTION>
!
subroutine ocean_vert_kpp_test_init (Grid, Domain, Time, Time_steps, Dens, T_prog, T_diag, &
                                     ver_coordinate, ver_coordinate_class, hor_grid)
  
  type(ocean_grid_type),        intent(in), target  :: Grid
  type(ocean_domain_type),      intent(in), target  :: Domain
  type(ocean_time_type),        intent(in)          :: Time
  type(ocean_time_steps_type),  intent(in)          :: Time_steps
  type(ocean_density_type),     intent(in)          :: Dens
  type(ocean_prog_tracer_type), intent(inout)       :: T_prog(:)
  type(ocean_diag_tracer_type), intent(in)          :: T_diag(:)
  integer,                      intent(in)          :: ver_coordinate
  integer,                      intent(in)          :: ver_coordinate_class
  integer,                      intent(in)          :: hor_grid 
  
  real, parameter :: cstar  = 10.0  ! proportionality coefficient for nonlocal transport
  real, parameter :: conam  = 1.257
  real, parameter :: concm  = 8.380 
  real, parameter :: conc2  = 16.0
  real, parameter :: zetam  = -0.2
  real, parameter :: conas  = -28.86
  real, parameter :: concs  = 98.96
  real, parameter :: conc3  = 16.0
  real, parameter :: zetas  = -1.0

  real :: zehat ! = zeta * ustar**3
  real :: zeta  ! = stability parameter d/L
  real :: usta

  integer :: i, j, n, ioun, io_status, ierr
  integer :: rib_dim = 3

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 


  if ( module_is_initialized ) then 
     call mpp_error(FATAL, &
      '==>Error from ocean_vert_kpp_test_mod (ocean_vert_kpp_test_init): module is already initialized')
  endif 

  module_is_initialized = .TRUE.
  vert_coordinate       = ver_coordinate 
  vert_coordinate_class = ver_coordinate_class
  rho_cp     = rho0*cp_ocean 
  inv_rho_cp = 1.0/rho_cp 
  horz_grid  = hor_grid

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_vert_kpp_test_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_vert_kpp_test_nml')
#else
  ioun =  open_namelist_file ()
  read  (ioun, ocean_vert_kpp_test_nml,iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_vert_kpp_test_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit, ocean_vert_kpp_test_nml)  
  write (stdlogunit, ocean_vert_kpp_test_nml)

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  nk = Grid%nk
#endif 
  kbl_max=nk

  if(use_this_module) then 
    write(stdoutunit,'(/1x,a)') '==> NOTE: USING KPP vertical mixing scheme.'
    write(stdoutunit,'(1x,a)')  '==> NOTE: KPP is typically run with penetrative shortwave heating.'
    write(stdoutunit,'(1x,a/)') '==> NOTE: KPP is typically run with a seasonal and/or diurnal cycle.'
  else 
    write(stdoutunit,'(/1x,a)')'==> NOTE: NOT USING KPP vertical mixing scheme.'
    return
  endif 

  if(debug_this_module) then 
    write(stdoutunit,'(/1x,a)')'==> NOTE: Running KPP with debug_this_module=.true. Set vmixing coeffs to constant.'
  endif 

  if(horz_grid==MOM_CGRID) then 
     calc_visc_on_cgrid=.true.
  else
     calc_visc_on_cgrid=.false.
  endif 

  if(vert_coordinate==ZSIGMA .or. vert_coordinate==PSIGMA) then 
    call mpp_error(WARNING,&
    '==>ocean_vert_kpp_test_mod: ZSIGMA or PSIGMA are not fully working w/ KPP. ')
    call mpp_error(WARNING,&
    'Problems exist /w tracer balances not closing AND instabilities w/ nonlocal transport.')
  endif  

  write(stdoutunit,'(/a,f10.2)') &
  '==>Note from ocean_vert_kpp_test_mod: using forward time step for vert-frict of (secs)', &
                               Time_steps%dtime_u 
  write(stdoutunit,'(/a,f10.2)') &
  '==>Note from ocean_vert_kpp_test_mod: using forward time step for vert-diff  of (secs)', &
                               Time_steps%dtime_t 
  if(kbl_standard_method) then
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: adjust kbl to hbl with the standard method.'
  else
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: adjust kbl to hbl with the non-standard method.'
    if (kl_min > 1) write(stdoutunit,'(1x,a,I4)') '==>WARNING from ocean_vert_kpp_test_mod:'// &
                    ' change kl_min to 1 to avoid negative mixing coefficients with low wind stress.'
  endif
  if(use_sbl_bottom_flux) then
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: '// &
    'Add tracer flux through the SBL-bottom to the nonlocal scheme. This is experimental.'  
  endif                               
  if(bvf_from_below) then
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: '// &
    'Find BVF from a forward derivatives.'  
  else
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: '// &
    'Find BVF from a backward derivatives.'  
  endif                               
  if(variable_vtc) then
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: '// &
    'Diagnose hbl with concv that depends on BVF.'  
  else
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: '// &
    'Diagnose hbl with constant concv.'  
  endif                               
  if(use_max_shear) then          
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: '// &
    'Use maximum shear around a tracer cell for diagnostics of hbl.'  
  else
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: '// &
    'Use average shear around a tracer cell for diagnostics of hbl.'  
  endif                               
  if (linear_hbl) then
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: Use linear interpolation to find hbl'
  else
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: Use quadratic interpolation to find hbl'
  endif
  if(limit_ghats) then
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: Limit ghats*diff_cbt to 1.'
  else
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: Do not limit ghats*diff_cbt to 1.'
  endif
  if(limit_with_hekman) then
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: Limit hbl with hekman for stable case.'
  else
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: Do not limit hbl with hekman for stable case.'
  endif
  if(calc_visc_on_cgrid) then  
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: Calculate viscosity at c-grid.'
  else
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: Interpolate viscosity to c-grid.'
  endif
  if(radiation_large) then
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: sw-radiation in non-local scheme h_gamma=h.'
  elseif (radiation_zero) then
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: sw-radiation in non-local scheme with h_gamma=0.'
  elseif (radiation_iow) then
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: sw-radiation in non-local scheme with IOW-method.'
  else
    write(stdoutunit,'(1x,a)') '==> NOTE from ocean_vert_kpp_test_mod: Leave full sw-radiation in non-local surface flux.'
  endif
  
  if(radiation_large .and. radiation_zero) call mpp_error(FATAL,&
      '==>ocean_vert_kpp_test_mod: Do not enable radiation_large and radiation_zero together. ')   
  if(radiation_large .and. radiation_iow) call mpp_error(FATAL,&
      '==>ocean_vert_kpp_test_mod: Do not enable radiation_large and radiation_iow together. ')   
  if(radiation_zero .and.  radiation_iow) call mpp_error(FATAL,&
      '==>ocean_vert_kpp_test_mod: Do not enable radiation_zero and radiation_iow together. ')   

  Dom => Domain
  Grd => Grid

  tracer_timestep = Time_steps%dtts
  index_temp=-1
  index_salt=-1
  num_prog_tracers = size(T_prog(:))
  do n= 1, num_prog_tracers
     if (T_prog(n)%name == 'temp') index_temp = n
     if (T_prog(n)%name == 'salt') index_salt = n
  enddo

  allocate( wsfc(num_prog_tracers) )

  index_frazil=-1
  num_diag_tracers = size(T_diag(:))
  do n= 1, num_diag_tracers
     if (T_diag(n)%name == 'frazil') index_frazil = n
  enddo

  if (index_temp < 1 .or. index_salt < 1) then 
    call mpp_error(FATAL, &
    '==>Error: ocean_vert_kpp_test_mod: temp and/or salt not present in tracer array')
  endif 


  ! for computing Vtsq 
  if (variable_vtc) then
     vtc_flag=1.0   ! as in Danabasoglu etal (2006) 
  else 
     vtc_flag=0.0   ! as in Large etal (1994)
  endif    

  if (linear_hbl) rib_dim=2 
  cellarea_r = 1.0/(epsln + Grd%tcellsurf)

     
#ifndef MOM_STATIC_ARRAYS

  if(radiation_iow) then
    allocate( T_prog(index_temp)%radiation(isd:ied,jsd:jed,nk)) 
    T_prog(index_temp)%radiation(:,:,:) = 0.0
  endif

  allocate (ghats(isd:ied,jsd:jed,nk))
  allocate (riu(isd:ied,jsd:jed,nk))
  allocate (rit(isd:ied,jsd:jed,nk))
  allocate (hblt(isd:ied,jsd:jed))
  allocate (hbl(isd:ied,jsd:jed))
  do n=1,num_prog_tracers 
    allocate( wsfc(n)%wsfc(isd:ied,jsd:jed) )
  enddo

  allocate (bfsfc(isd:ied,jsd:jed))         ! surface buoyancy forcing    (m^2/s^3)
  allocate (caseA(isd:ied,jsd:jed))         ! = 1 in case A; =0 in case B
  allocate (stable(isd:ied,jsd:jed))        ! = 1 in stable forcing; =0 in unstable
  allocate (dkm1(isd:ied,jsd:jed,3))        ! boundary layer diff_cbt at kbl-1 level
  allocate (blmc(isd:ied,jsd:jed,nk,3))     ! boundary layer mixing coefficients
  allocate (sigma(isd:ied,jsd:jed))         ! normalized depth (d / hbl)
  allocate (rhosfc(isd:ied,jsd:jed))        ! potential density of sfc layer(g/m^3)
  allocate (talpha(isd:ied,jsd:jed,nk))     ! -d(rho)/ d(pot.temperature)  (g/m^3/C)
  allocate (sbeta(isd:ied,jsd:jed,nk))      ! d(rho)/ d(salinity)       (g/m^3/PSU)
  allocate (alphaDT(isd:ied,jsd:jed,nk))    ! alpha * DT  across interfaces (g/m^3)
  allocate (betaDS(isd:ied,jsd:jed,nk))     ! beta  * DS  across interfaces (g/m^3)
  allocate (ustar(isd:ied,jsd:jed))         ! surface friction velocity       (m/s)
  allocate (Bo(isd:ied,jsd:jed))            ! surface turb buoy. forcing  (m^2/s^3)
  allocate (Bosol(isd:ied,jsd:jed))         ! radiative buoy forcing      (m^2/s^3)
  allocate (dbloc(isd:ied,jsd:jed,nk))      ! local delta buoy at interfaces(m/s^2)
  allocate (dbsfc(isd:ied,jsd:jed,nk))      ! delta buoy w/ respect to sfc  (m/s^2)
  allocate (dVsq(isd:ied,jsd:jed,nk))       ! (velocity shear re sfc)^2   (m/s)^2
  allocate (kbl(isd:ied,jsd:jed))           ! index of first grid level below hbl
  allocate (Rib(isd:ied,jsd:jed,rib_dim))   ! Bulk Richardson number
  allocate (wm(isd:ied,jsd:jed))            ! momentum turbulent velocity scales  (m/s)
  allocate (ws(isd:ied,jsd:jed))            ! scalar turbulent velocity scales  (m/s)
  allocate (Ustk2(isd:ied,jsd:jed))         ! Magnitude of surface stokes drift velocity ^2 (m^2/s^2)
  allocate (gat1(isd:ied,jsd:jed,3))
  allocate (dat1(isd:ied,jsd:jed,3))
  allocate(sw_frac_hbl(isd:ied,jsd:jed))

#endif

  kbl(:,:)         = 0
  ghats(:,:,:)     = 0.0
  riu(:,:,:)       = 0.0
  rit(:,:,:)       = 0.0
  hblt(:,:)        = 0.0
  hbl(:,:)         = 0.0
  sw_frac_hbl(:,:) = 0.0
  Ustk2(:,:)       = 0.0

  do n = 1, num_prog_tracers  
    wsfc(n)%wsfc(:,:) = 0.0
  enddo  

!-----------------------------------------------------------------------
!     initialize some constants for kmix subroutines, and initialize
!     for kmix subroutine "wscale" the 2D-lookup table for wm and ws
!     as functions of ustar and zetahat (=von_karman*sigma*hbl*bfsfc).
!-----------------------------------------------------------------------
 

!-----------------------------------------------------------------------
! define some non-dimensional constants  (recall epsilon=0.1)
!-----------------------------------------------------------------------

      concv_r = 1.0/concv

!     Vtc used in eqn. 23 
      Vtc     = concv * sqrt(0.2/concs/epsilon) / von_karman**2 / Ricr

!     cg = cs in eqn. 20
      cg      = cstar * von_karman * (concs * von_karman * epsilon)**(1./3.)

!-----------------------------------------------------------------------
! construct the wm and ws lookup tables (eqn. 13 & B1)
!-----------------------------------------------------------------------

      deltaz = (zmax-zmin)/(nni+1) 
      deltau = (umax-umin)/(nnj+1)
      
      do i=0,nni+1
         zehat = deltaz*(i) + zmin
         do j=0,nnj+1
            usta = deltau*(j) + umin
            zeta = zehat/(usta**3+epsln)

            if(zehat >= 0.) then
               wmt(i,j) = von_karman*usta/(1.+conc1*zeta)
               wst(i,j) = wmt(i,j)
            else
               if(zeta > zetam) then
                  wmt(i,j) = von_karman* usta * (1.-conc2*zeta)**(1./4.)
               else
                  wmt(i,j) = von_karman* (conam*usta**3-concm*zehat)**(1./3.)
               endif
               if(zeta > zetas) then
                  wst(i,j) = von_karman* usta * (1.-conc3*zeta)**(1./2.)
               else
                  wst(i,j) = von_karman* (conas*usta**3-concs*zehat)**(1./3.)
               endif
            endif   
         enddo   
      enddo

      ! set flag for shear instability mixing 
      if (shear_instability) then
          write (stdoutunit,'(a)') 'Computing vertical mixing from shear instability in KPP module.'
          shear_instability_flag=1.0
      else 
          write (stdoutunit,'(a)') 'NOT computing vertical mixing from shear instability in KPP module.'
          shear_instability_flag=0.0
      endif 


!-----------------------------------------------------------------------
! error checks and diagnostics setup 
!-----------------------------------------------------------------------

  if (Time_steps%aidif /= 1.0) then
    call mpp_error(FATAL,&
    '==>Error in ocean_vert_kpp_test_mod (ocean_vert_kpp_test_init): KPP must use aidif=1 for implicit vertical mixing')
  endif

  ! register diagnostics 

  allocate(id_nonlocal(num_prog_tracers))
  allocate(id_nonlocal_on_nrho(num_prog_tracers))
  allocate(id_ghats(2))
  allocate(id_wsfc(num_prog_tracers))
  allocate(id_wbot(num_prog_tracers))
  id_nonlocal=-1
  id_nonlocal_on_nrho=-1
  do n = 1, num_prog_tracers
     if(n==index_temp) then
        id_nonlocal(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_nonlocal_KPP', &
                     Grd%tracer_axes(1:3), Time%model_time,                                         &
                     'cp*rho*dzt*nonlocal tendency from KPP', trim(T_prog(n)%flux_units),           &
                     missing_value=missing_value, range=(/-1.e10,1.e10/))
        id_nonlocal_on_nrho(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_nonlocal_KPP_on_nrho', &
                     Dens%neutralrho_axes(1:3), Time%model_time,                                         &
                     'cp*rho*dzt*nonlocal tendency from KPP binned to neutral density', trim(T_prog(n)%flux_units), &
                     missing_value=missing_value, range=(/-1.e20,1.e20/))
        id_wsfc(n)   = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_wsfc_KPP',       &
                     Grd%tracer_axes(1:2), Time%model_time,                                         &
                     'cp*rho*dzt*surface tendency from KPP', trim(T_prog(n)%flux_units),            &
                     missing_value=missing_value, range=(/-1.e10,1.e10/))
     else
        id_nonlocal(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_nonlocal_KPP', &
                     Grd%tracer_axes(1:3), Time%model_time,                                         &
                     'rho*dzt*nonlocal tendency from KPP', trim(T_prog(n)%flux_units),              &
                     missing_value=missing_value, range=(/-1.e10,1.e10/))
        id_nonlocal_on_nrho(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_nonlocal_KPP_on_nrho', &
                     Dens%neutralrho_axes(1:3), Time%model_time,                                         &
                     'rho*dzt*nonlocal tendency from KPP binned to neutral density', trim(T_prog(n)%flux_units),              &
                     missing_value=missing_value, range=(/-1.e20,1.e20/))
        id_wsfc(n)   =  register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_wsfc_KPP',      &
                     Grd%tracer_axes(1:2), Time%model_time,                                         &
                     'rho*dzt*surface tendency from KPP', trim(T_prog(n)%flux_units),               &
                     missing_value=missing_value, range=(/-1.e10,1.e10/))
     endif
     id_wbot(n)   = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_wbot_KPP', &
          Grd%tracer_axes(1:2), Time%model_time,   &
          'tracer flux through sbl-bottom', trim(T_prog(n)%flux_units),    &
          missing_value=missing_value, range=(/-1.e10,1.e10/))
  enddo
  id_ghats(1) = register_diag_field ('ocean_model', 'temp_ghats_KPP', &
       Grd%tracer_axes(1:3), Time%model_time,      &
       'nonlocal term ghats * diff_cbt from KPP', 'none',     &
       missing_value=missing_value, range=(/-1.e10,1.e10/))
  id_ghats(2) = register_diag_field ('ocean_model', 'salt_ghats_KPP', &
       Grd%tracer_axes(1:3), Time%model_time,              &
       'nonlocal term ghats * diff_cbt from KPP', 'none',     &
       missing_value=missing_value, range=(/-1.e10,1.e10/))

  id_diff_cbt_kpp_t = register_diag_field('ocean_model','diff_cbt_kpp_t',         &
       Grd%tracer_axes(1:3),Time%model_time, 'vert diffusivity from kpp for temp',&
       'm^2/sec', missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_diff_cbt_kpp_s = register_diag_field('ocean_model','diff_cbt_kpp_s',          &
       Grd%tracer_axes(1:3), Time%model_time, 'vert diffusivity from kpp for salt',&
       'm^2/sec', missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_visc_cbt_kpp = register_diag_field('ocean_model','visc_cbt_kpp',            &
       Grd%tracer_axes(1:3),Time%model_time, 'vert viscosity from kpp on T-cell',&
       'm^2/sec', missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_visc_cbu_kpp = register_diag_field('ocean_model','visc_cbu_kpp',            &
       Grd%vel_axes_uv(1:3),Time%model_time, 'vert viscosity from kpp on U-cell',&
       'm^2/sec', missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_hblt = register_diag_field('ocean_model','hblt',Grd%tracer_axes(1:2), &
       Time%model_time, 'T-cell boundary layer depth from KPP', 'm',       &
       missing_value = missing_value, range=(/-1.e5,1.e6/),                &
       standard_name='ocean_mixed_layer_thickness_defined_by_mixing_scheme')

  id_ws = register_diag_field('ocean_model','wscale',Grd%tracer_axes(1:3), &
       Time%model_time, 'wscale from KPP', 'm',                            &
       missing_value = missing_value, range=(/-1.e5,1.e6/))

  call watermass_diag_init(Time,Dens)

end subroutine ocean_vert_kpp_test_init
! </SUBROUTINE> NAME="ocean_vert_kpp_test_init">


!#######################################################################
! <SUBROUTINE NAME="vert_mix_kpp_test">
!
! <DESCRIPTION>
! This subroutine computes the vertical diffusivity and viscosity according
! to the KPP scheme of Large etal.  In brief, the scheme does the 
! following:
!
! --Compute interior mixing everywhere:                               
!   interior mixing gets computed at all cell interfaces due to constant
!   internal wave background activity ("visc_cbu_iw" and "diff_cbt_iw").
!   Mixing is enhanced in places of static instability (local Ri < 0).
!   Additionally, mixing can be enhanced by contribution from shear 
!   instability which is a function of the local Ri.
!
! --Double diffusion:
!   Interior mixing can be enhanced by double diffusion due to salt
!   fingering and diffusive convection ("double_diffusion=.true.").
!
! --Boundary layer:
!
!   (A) Boundary layer depth:
!       at every gridpoint the depth of the oceanic boundary layer 
!       ("hbl") gets computed by evaluating bulk richardson numbers.
!
!   (B) Boundary layer mixing:
!       within the boundary layer, above hbl, vertical mixing is 
!       determined by turbulent surface fluxes, and interior mixing at
!       the lower boundary, i.e. at hbl.
!
! NOTE: Use smf_bgrid since this uses the primary smf array read in from 
! the coupler in ocean_core/ocean_sbc.F90 when using the FMS coupler.
!
! </DESCRIPTION>
!
subroutine vert_mix_kpp_test (aidif, Time, Thickness, Velocity, T_prog, T_diag, Dens, &
           swflx, sw_frac_zt, pme, river, visc_cbu, visc_cbt, diff_cbt, hblt_depth, do_wave)

  real,                            intent(in)    :: aidif
  type(ocean_time_type),           intent(in)    :: Time
  type(ocean_thickness_type),      intent(in)    :: Thickness
  type(ocean_velocity_type),       intent(in)    :: Velocity
  type(ocean_prog_tracer_type),    intent(inout) :: T_prog(:)
  type(ocean_diag_tracer_type),    intent(in)    :: T_diag(:)
  type(ocean_density_type),        intent(in)    :: Dens
  real, dimension(isd:,jsd:),      intent(in)    :: swflx
  real, dimension(isd:,jsd:,:),    intent(in)    :: sw_frac_zt
  real, dimension(isd:,jsd:),      intent(in)    :: pme
  real, dimension(isd:,jsd:),      intent(in)    :: river
  real, dimension(isd:,jsd:),      intent(inout) :: hblt_depth
  real, dimension(isd:,jsd:,:),    intent(inout) :: visc_cbu
  real, dimension(isd:,jsd:,:),    intent(inout) :: visc_cbt
  real, dimension(isd:,jsd:,:,:),  intent(inout) :: diff_cbt
  logical,                         intent(in)    :: do_wave

  real, dimension(isd:ied,jsd:jed,nk) :: dbloc1, dbsfc1
  real, dimension(isd:ied,jsd:jed)    :: frazil
  real                                :: smftu, smftv, active_cells
  real                                :: temporary, temporary1
  integer                             :: i, j, k, n, ki, ni, kp
  integer                             :: tau, taum1

  if ( .not. module_is_initialized ) then 
     call mpp_error(FATAL, '==>Error from ocean_vert_kpp_test: module must be initialized')
  endif 

  if(.not. use_this_module) return 

  tau   = Time%tau
  taum1 = Time%taum1

  visc_cbu(:,:,:) = 0.0
  visc_cbt(:,:,:) = 0.0

  if(index_frazil > 0) then 
    do j = jsd, jed
       do i = isd, ied
          frazil(i,j) = T_diag(index_frazil)%field(i,j,1)
       enddo
    enddo
  else 
    frazil(:,:) = 0.0
  endif 

!---------assign Ustk2
    if (do_wave) then
       do j = jsd, jed
          do i = isd, ied
             Ustk2(i,j) = Velocity%ustoke(i,j)**2 + Velocity%vstoke(i,j)**2
          enddo
       enddo
    endif

!-----------------------------------------------------------------------
!     compute gradient Ri and dVsq  
!-----------------------------------------------------------------------

  if(horz_grid == MOM_BGRID) then 

      call ri_for_bgrid(Time, Thickness%dzwt, Dens%drhodT, Dens%drhodS,          &
           T_prog(index_temp)%field(:,:,:,taum1), Dens%rho_salinity(:,:,:,taum1),&
           Velocity%u(:,:,:,1,tau), Velocity%u(:,:,:,2,tau), rit, riu)

      ! compute squared vertical difference of velocity
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               wrk2(i,j,k) = (Velocity%u(i,j,1,1,tau) - Velocity%u(i,j,k,1,tau))**2 &
                           + (Velocity%u(i,j,1,2,tau) - Velocity%u(i,j,k,2,tau))**2
            enddo
         enddo
      enddo
      if (use_max_shear) then  ! as in Danabasoglu et al (2006) 
          do k=1,nk
             do j=jsc,jec
                do i=isc,iec
                   dVsq(i,j,k) = max(wrk2(i,j,k),wrk2(i-1,j,k),wrk2(i,j-1,k),wrk2(i-1,j-1,k))
                enddo
             enddo
          enddo
      else   ! as in legacy GFDL simulations 
          do k=1,nk
             do j=jsc,jec
                do i=isc,iec
                   active_cells = Grd%umask(i,j,k) + Grd%umask(i-1,j,k) + Grd%umask(i,j-1,k) + Grd%umask(i-1,j-1,k) + epsln
                   dVsq(i,j,k)  = (wrk2(i,j,k) + wrk2(i-1,j,k) + wrk2(i,j-1,k) + wrk2(i-1,j-1,k))/active_cells
                enddo
             enddo
          enddo
      endif

  else  ! cgrid  

      ! average horizontal C-grid velocity onto T-cell center 
      wrk1_v(:,:,:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1_v(i,j,k,1) = Grd%tmask(i,j,k)                                                  &
                    *(Velocity%u(i,j,k,tau,1)*Grd%dtw(i,j)+Velocity%u(i-1,j,k,tau,1)*Grd%dte(i,j)) &
                    /(epsln+Grd%dxt(i,j))
               wrk1_v(i,j,k,2) = Grd%tmask(i,j,k)                                                  &
                    *(Velocity%u(i,j,k,tau,2)*Grd%dts(i,j)+Velocity%u(i,j-1,k,tau,2)*Grd%dtn(i,j)) &
                    /(epsln+Grd%dyt(i,j))
            enddo
         enddo
      enddo
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               dVsq(i,j,k) = (wrk1_v(i,j,1,1) - wrk1_v(i,j,k,1))**2 + (wrk1_v(i,j,1,2) - wrk1_v(i,j,k,2))**2
            enddo
         enddo
      enddo

      call ri_for_cgrid(Time, Thickness%dzwt, Dens%drhodT, Dens%drhodS,          &
           T_prog(index_temp)%field(:,:,:,taum1), Dens%rho_salinity(:,:,:,taum1),&
           wrk1_v(:,:,:,1), wrk1_v(:,:,:,2), rit, riu)


  endif  ! endif for Bgrid/Cgrid 


!-----------------------------------------------------------------------
!     density related quantities
!     --------------------------
!     based on mom equation of state, compute normalized
!     density  drho{k,kr} for layer k with respect to reference layer
!     kr, i.e. drho{T(k),S(k), tr(kr), sr(kr), zt(kr)}, as the
!     difference of drho=rho{k,kr}-rhor(kr):
!
!     density of surface layer                                   (kg/m3)
!           rho   = drho{T(1),S(1),zt(1)} + 1. + rhor(zt(1))
!     local buoyancy gradient at km interfaces:                  (m/s2)
!           dbloc = g/rho{k+1,k+1} * [ drho{k,k+1}-drho{k+1,k+1} ]
!     buoyancy difference with respect to "zref",i.e. the surface(m/s2)
!           dbsfc = g * [ drho{1,k}/rho{1,k} - drho{k,k}/rho{k,k} ]
!     thermal expansion coefficient without 1/rho factor       (kg/m3/C)
!           talpha= -d(rho{k,k})/d(T(k))
!     saline contraction coefficient without 1/rho factor      (kg/m3/PSU)
!           sbeta = d(rho{k,k})/d(S(k))
!-----------------------------------------------------------------------

        ! compute thermal and haline expansion coefficients (with factor of rho included).
        ! result from density_derivs is d(rho)/d(theta), yet need minus this for kpp   
        do k=1,nk
           do j=jsd,jed
              do i=isd,ied
                 talpha(i,j,k) = -Dens%drhodT(i,j,k)
                 sbeta(i,j,k)  =  Dens%drhodS(i,j,k)
              enddo
           enddo
        enddo

        rhosfc(:,:)  = Dens%rho(:,:,1,tau)
        dbsfc(:,:,1) = 0.0

        dbloc1(:,:,:) = density_delta_z(Dens%rho(:,:,:,tau), Dens%rho_salinity(:,:,:,tau),   &
                        T_prog(index_temp)%field(:,:,:,tau), Dens%pressure_at_depth(:,:,:))
        dbsfc1(:,:,:) = density_delta_sfc(Dens%rho(:,:,:,tau), Dens%rho_salinity(:,:,:,tau), &
                        T_prog(index_temp)%field(:,:,:,tau),   Dens%pressure_at_depth(:,:,:))
        do k=2,nk
           do j=jsd,jed
              do i=isd,ied
                 dbloc(i,j,k-1) = -grav * dbloc1(i,j,k-1)/(epsln+Dens%rho(i,j,k,tau))
                 dbsfc(i,j,k)   = -grav * dbsfc1(i,j,k-1)/(epsln+Dens%rho(i,j,k,tau))
              enddo
           enddo
        enddo
        dbloc(:,:,nk) = dbloc(:,:,nk-1)

!-----------------------------------------------------------------------
!     kinematic surface fluxes on the "t-grid" :
!     --------------------------------------------------------
!
!     wusfc = kinematic zonal velocity sfc flux on jp       (m2/s2)
!           = -rho0r*smf_bgrid(i,j,1)
!     wvsfc = kinematic merid velocity                      (m2/s2)
!           = -rho0r*smf_bgrid(i,j,2)
!     wsfc(temp) = kinematic temperature                    (C*m/s)
!                = rho0r*(stf(i,j,temp) - pme *(t(i,j,1,temp)-tpme(temp)) 
!                                       -river*(t(i,j,1,temp)-triver(temp))) 
!     wsfc(salt) = kinematic salinity                       (PSU*m/s)
!                = rho0r*(stf(i,j,salt) - pme  *(t(i,j,1,salt)-tpme(salt)) 
!                                       - river*(t(i,j,1,salt)-triver(salt))) 
!     wtsol = kinematic solar temp                          (C*m/s)
!           = -swflx(i,j)/rho_cp 
!
!     friction velocity, turbulent and radiative sfc buoyancy forcing
!     ---------------------------------------------------------------
!
!     ustar(i) = sqrt(sqrt(wusfc(i)**2 + wvsfc(i)**2))      (m/s)
!     Bo(i)    = grav*(talpha(i,j,1)*wsfc(temp)-sbeta(i,j)*wsfc(salt))/rho(i)
!     Bosol(i) = grav*(talpha(i,j,1)*wtsol(i)                         )/rho(i)
!                Both Bo and Bosol have units               (m2/s3)
!-----------------------------------------------------------------------

      ! stf, pme, and river are mass fluxes and so 
      ! require rho0r to convert to kinematic units.      
      ! algebraically we have 
      ! rho0*wsfc = stf - pme*(T(1)-tpme) - runoff*(T(1)-trunoff) - calving*(T(1)-tcalving)
      !           = stf - pme*(T(1)-tpme) - (runoff + calving)*T(1) + runoff*trunoff + calving*tcalving
      !           = stf - pme*(T(1)-tpme) - river*T(1) + runoff_tracer_flux + calving_tracer_flux
        if(wsfc_combine_runoff_calve) then
            ! older method
            do n=1,num_prog_tracers
               do j=jsd,jed
                  do i=isd,ied
                     wsfc(n)%wsfc(i,j) = (T_prog(n)%stf(i,j) -                          &
                          pme(i,j)  *(T_prog(n)%field(i,j,1,tau)-T_prog(n)%tpme(i,j)) - &
                          river(i,j)*(T_prog(n)%field(i,j,1,tau)-T_prog(n)%triver(i,j)) &
                          )*rho0r*Grd%tmask(i,j,1)
                  enddo
               enddo
            enddo
        else 
            ! newer method
            do n=1,num_prog_tracers
               do j=jsd,jed
                  do i=isd,ied
                     wsfc(n)%wsfc(i,j) = (T_prog(n)%stf(i,j)                                    &
                          -pme(i,j)  *(T_prog(n)%field(i,j,1,tau)-T_prog(n)%tpme(i,j))          &
                          -river(i,j)*T_prog(n)%field(i,j,1,tau)                                &
                          +T_prog(n)%runoff_tracer_flux(i,j)+T_prog(n)%calving_tracer_flux(i,j) &
                          )*rho0r*Grd%tmask(i,j,1)
                  enddo
               enddo
            enddo
        endif

        ! ustar is needed on the "T-grid".  It is assumed that masking of 
        ! smf over land was performed inside of the ocean_sbc module. 
        ! smf has units of N/m^2 and so we need rho0r to get ustar in m/s.   
        ! swflx has units W/m^2 so needs 1/rho_cp to get to C*m/s units.
        ! these are proper units for buoyancy fluxes. 
        !
        ! use smf_bgrid for either MOM_BGRID or MOM_CGRID, since smf_bgrid
        ! is taken straight from the FMS coupler, so is more basic than smf_cgrid. 
        do j=jsc,jec
           do i=isc,iec
               active_cells = Grd%umask(i,j,1)   + Grd%umask(i-1,j,1)   &
                             +Grd%umask(i,j-1,1) + Grd%umask(i-1,j-1,1) + epsln
               smftu = rho0r*(Velocity%smf_bgrid(i,j,1)   + Velocity%smf_bgrid(i-1,j,1)     &
                             +Velocity%smf_bgrid(i,j-1,1) + Velocity%smf_bgrid(i-1,j-1,1))  &
                             /active_cells
               smftv = rho0r*(Velocity%smf_bgrid(i,j,2)   + Velocity%smf_bgrid(i-1,j,2)    &
                             +Velocity%smf_bgrid(i,j-1,2) + Velocity%smf_bgrid(i-1,j-1,2)) &
                             /active_cells
               ustar(i,j) = sqrt( sqrt(smftu**2 + smftv**2) )
             
               Bo(i,j) = grav * (talpha(i,j,1) * &
                      (wsfc(index_temp)%wsfc(i,j)+frazil(i,j)/(rho_cp*tracer_timestep))  &
                      -sbeta (i,j,1) * wsfc(index_salt)%wsfc(i,j)) &     
                       / (epsln + rhosfc(i,j))                     
               Bosol(i,j) = grav * talpha(i,j,1) * swflx(i,j)*inv_rho_cp &
                            / (epsln + rhosfc(i,j))
           enddo
        enddo


      ! compute interior mixing coefficients everywhere, due to constant 
      ! internal wave activity, static instability, and local shear instability.
      call ri_iwmix(visc_cbt, diff_cbt)

      if (double_diffusion) then
        call ddmix (Time, T_prog, Dens, diff_cbt)  
      endif


      ! set seafloor values to zero for blmix 
      do ki = 1,nk-1
         do j = jsc,jec
             do i = isc,iec
                visc_cbt(i,j,ki)   = visc_cbt(i,j,ki)  *Grd%tmask(i,j,min(ki+1,nk))
                diff_cbt(i,j,ki,1) = diff_cbt(i,j,ki,1)*Grd%tmask(i,j,min(ki+1,nk))
                diff_cbt(i,j,ki,2) = diff_cbt(i,j,ki,2)*Grd%tmask(i,j,min(ki+1,nk))
             enddo
         enddo
      enddo


      ! boundary layer mixing coefficients: diagnose new bldepth
      call bldepth(Thickness, sw_frac_zt, do_wave) 
 

      !  boundary layer diffusivities
      call blmix_kpp(Thickness, diff_cbt, visc_cbt, do_wave)
      call diagnose_3d(Time, Grd, id_ws, wrk1(:,:,:))


      ! enhance diffusivity and viscosity at interface kbl-1
      call enhance(Thickness, diff_cbt, visc_cbt) 

!-----------------------------------------------------------------------
!     combine interior and b.l. coefficients and nonlocal term
!-----------------------------------------------------------------------

      ! smooth diffusivities with a 5 point filter
      ! to remove 2 delta x noise
      if (smooth_blmc) then
          
          wrk1(:,:,:) = 0.0
          wrk2(:,:,:) = 0.0
          wrk3(:,:,:) = 0.0

          call mpp_update_domains(blmc,Dom%domain2d)

          do k=1,nk-1
             do j=jsc,jec
                do i=isc,iec
                   active_cells = 4.0*Grd%tmask(i,j,k) + &
                        Grd%tmask(i-1,j,k)  +&
                        Grd%tmask(i+1,j,k)  +&
                        Grd%tmask(i,j-1,k)  +&
                        Grd%tmask(i,j+1,k)
                   if (active_cells == 8.0) then
                       wrk1(i,j,k) = & 
                            (4.0*blmc(i,j,k,1)   +&
                                 blmc(i-1,j,k,1) +&
                                 blmc(i+1,j,k,1) +&
                                 blmc(i,j-1,k,1) +&
                                 blmc(i,j+1,k,1)) / active_cells
                       wrk2(i,j,k) = & 
                            (4.0*blmc(i,j,k,2)   +&
                                 blmc(i-1,j,k,2) +&
                                 blmc(i+1,j,k,2) +&
                                 blmc(i,j-1,k,2) +&
                                 blmc(i,j+1,k,2)) / active_cells
                       wrk3(i,j,k) =  &
                            (4.0*blmc(i,j,k,3) +&
                              blmc(i-1,j,k,3)  +&
                              blmc(i+1,j,k,3)  +&
                              blmc(i,j-1,k,3)  +&
                              blmc(i,j+1,k,3)) / active_cells
                   else
                       wrk1(i,j,k) = blmc(i,j,k,1)
                       wrk2(i,j,k) = blmc(i,j,k,2)
                       wrk3(i,j,k) = blmc(i,j,k,3)
                   endif
                enddo
             enddo
          enddo
   
          do k=1,nk-1
             do j=jsc,jec
                do i=isc,iec
                   blmc(i,j,k,1) = wrk1(i,j,k)
                   blmc(i,j,k,2) = wrk2(i,j,k)
                   blmc(i,j,k,3) = wrk3(i,j,k)
                enddo
             enddo
          enddo

      endif
      
      do ki=1,nk-1
         do j=jsc,jec
            do i=isc,iec               
               if (ki < kbl(i,j)) then
                   visc_cbt(i,j,ki)   = blmc(i,j,ki,1)
                   diff_cbt(i,j,ki,1) = blmc(i,j,ki,2)
                   diff_cbt(i,j,ki,2) = blmc(i,j,ki,3)
               else
                   ghats(i,j,ki)=0.0
               endif

               visc_cbt(i,j,ki)   = visc_cbt(i,j,ki)*Grd%tmask(i,j,min(ki+1,nk))               
               diff_cbt(i,j,ki,1) = diff_cbt(i,j,ki,1)*Grd%tmask(i,j,min(ki+1,nk))
               diff_cbt(i,j,ki,2) = diff_cbt(i,j,ki,2)*Grd%tmask(i,j,min(ki+1,nk))               
            enddo
         enddo
      enddo

      ! update halo regions to compute spatial avg of visc_cbt to get visc_cbu
      call mpp_update_domains (visc_cbt(:,:,:), Dom%domain2d, flags=NUPDATE+EUPDATE)
      
      ! compute viscosity on "U-grid" by averaging visc_cbt from "T-grid". 
      ! note: zero out land values
      do ki=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               visc_cbu(i,j,ki) = onefourth*Grd%umask(i,j,min(ki+1,nk))* &
              (visc_cbt(i,j,ki)+visc_cbt(i+1,j,ki)+visc_cbt(i,j+1,ki)+visc_cbt(i+1,j+1,ki))
            enddo
         enddo             
      enddo

      visc_cbt(:,:,nk)   = 0.0
      visc_cbu(:,:,nk)   = 0.0
      diff_cbt(:,:,nk,1) = 0.0
      diff_cbt(:,:,nk,2) = 0.0

      if(debug_this_module) then 
          do k=1,nk-1
             do j=jsd,jed
                do i=isd,ied
                   visc_cbu(i,j,k)   = Grd%umask(i,j,k+1)*visc_cbu_iw
                   visc_cbt(i,j,k)   = Grd%tmask(i,j,k+1)*visc_cbu_iw
                   diff_cbt(i,j,k,1) = Grd%tmask(i,j,k+1)*diff_cbt_iw
                   diff_cbt(i,j,k,2) = Grd%tmask(i,j,k+1)*diff_cbt_iw
                enddo
             enddo
          enddo
      endif

!-----------------------------------------------------------------------
!      boundary layer depth
!-----------------------------------------------------------------------

       do j=jsc,jec
         do i=isc,iec
              hblt(i,j)       = hbl(i,j) * Grd%tmask(i,j,1)
              hblt_depth(i,j) = hblt(i,j)
         enddo
       enddo

!-----------------------------------------------------------------------
! add non-local contribution to th_tendency term
! note th_tendency has units of (kg/m^3)*(m/s)*tracer 
!-----------------------------------------------------------------------

       if (non_local_kpp) then

           do n=1,num_prog_tracers

              ! initialize work array for diagnostic storage
              T_prog(n)%wrk1(:,:,:) = 0.0
              wrk1(:,:,:) = 0.0
              wrk2(:,:,:) = 0.0

              ni = 1
              if (n==index_salt) ni = 2

              if(use_sbl_bottom_flux) then
                  do j=jsc,jec
                     do i=isc,iec
                        ki = max(kbl(i,j),1)
                        kp = min(kbl(i,j)+1,nk)
                        temporary = Thickness%dzwt(i,j,ki)
                        temporary1 = min(diff_cbt(i,j,ki,ni), temporary*temporary/tracer_timestep)
                        wrk2(i,j,1) =  Grd%tmask(i,j,kp)*temporary1 &
                             * (T_prog(n)%field(i,j,ki,taum1) - T_prog(n)%field(i,j,kp,taum1)) &
                             /(temporary + epsln)
                        wsfc(n)%wsfc(i,j) = wsfc(n)%wsfc(i,j)  + Grd%tmask(i,j,kp)*temporary1  &
                             * (T_prog(n)%field(i,j,ki,taum1) - T_prog(n)%field(i,j,kp,taum1)) &
                             /(temporary + epsln)
                     enddo
                  enddo
                  call diagnose_2d(TIme, Grd, id_wbot(n), wrk2(:,:,1))
              endif


              ! remove solar radiation absorbed from 0 to level k 
              ! requires absorbed radiation in T_prog(n)%radiation
              if (n==index_temp .and. radiation_iow) then    

                  k = 1
                  do j=jsc,jec
                     do i=isc,iec
                        wrk2(i,j,k) = wsfc(n)%wsfc(i,j) + T_prog(n)%radiation(i,j,k) * inv_rho_cp
                     enddo
                  enddo
                  do k=2,kbl_max
                     do j=jsc,jec
                        do i=isc,iec
                           wrk2(i,j,k) = wrk2(i,j,k-1) + T_prog(n)%radiation(i,j,k) * inv_rho_cp
                        enddo
                     enddo
                  enddo

                  if (limit_ghats) then
                      k=1
                      do j=jsc,jec
                         do i=isc,iec
                            T_prog(n)%wrk1(i,j,k) = rho0 * wrk2(i,j,k)*(-min(diff_cbt(i,j,k,ni)*ghats(i,j,k),1.))
                            T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + T_prog(n)%wrk1(i,j,k)
                         enddo
                      enddo
                      do k=2,kbl_max
                         do j=jsc,jec
                            do i=isc,iec
                               T_prog(n)%wrk1(i,j,k) =  rho0 * ( wrk2(i,j,k-1)*min(diff_cbt(i,j,k-1,ni)*ghats(i,j,k-1),1.) &
                                                               - wrk2(i,j,k)  *min(diff_cbt(i,j,k,ni)  *ghats(i,j,k)  ,1.))
                               T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + T_prog(n)%wrk1(i,j,k)
                            enddo
                         enddo
                      enddo
                  else 
                      k=1
                      do j=jsc,jec
                         do i=isc,iec
                            T_prog(n)%wrk1(i,j,k) = rho0 * wrk2(i,j,k)*(-diff_cbt(i,j,k,ni)*ghats(i,j,k))
                            T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + T_prog(n)%wrk1(i,j,k)
                         enddo
                      enddo
                      do k=2,kbl_max
                         do j=jsc,jec
                            do i=isc,iec
                               T_prog(n)%wrk1(i,j,k) =  rho0 * ( wrk2(i,j,k-1) * diff_cbt(i,j,k-1,ni)*ghats(i,j,k-1) &
                                                               - wrk2(i,j,k)   * diff_cbt(i,j,k,ni)  *ghats(i,j,k) )
                               T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + T_prog(n)%wrk1(i,j,k)
                            enddo
                         enddo
                      enddo
                  endif  ! endif for limit_ghats 


              else ! alternative treatments of radiation 


                  ! remove solar radiation penetrating the boundary layer
                  if (n==index_temp .and. radiation_large) then   
                      do j=jsc,jec
                         do i=isc,iec
                            wsfc(n)%wsfc(i,j) = wsfc(n)%wsfc(i,j) - swflx(i,j) * inv_rho_cp * sw_frac_hbl(i,j)
                         enddo
                      enddo
                  endif


                  ! remove all solar radiation 
                  if (n==index_temp .and. radiation_zero) then    
                      do j=jsc,jec
                         do i=isc,iec
                            wsfc(n)%wsfc(i,j) = wsfc(n)%wsfc(i,j) - swflx(i,j) * inv_rho_cp 
                         enddo
                      enddo
                  endif

                  if (limit_ghats) then
                      k=1
                      do j=jsc,jec
                         do i=isc,iec
                            T_prog(n)%wrk1(i,j,k) = rho0*wsfc(n)%wsfc(i,j)*(-min(diff_cbt(i,j,k,ni)*ghats(i,j,k),1.))
                            T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + T_prog(n)%wrk1(i,j,k)
                         enddo
                      enddo
                      do k=2,kbl_max
                         do j=jsc,jec
                            do i=isc,iec
                               T_prog(n)%wrk1(i,j,k) = &
                                    rho0*wsfc(n)%wsfc(i,j)*(min(diff_cbt(i,j,k-1,ni)*ghats(i,j,k-1),1.) - &
                                    min(diff_cbt(i,j,k,ni)  *ghats(i,j,k),1.))
                               T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + T_prog(n)%wrk1(i,j,k)
                            enddo
                         enddo
                      enddo
                  else
                      k=1
                      do j=jsc,jec
                         do i=isc,iec
                            T_prog(n)%wrk1(i,j,k) = rho0*wsfc(n)%wsfc(i,j)*(-diff_cbt(i,j,k,ni)*ghats(i,j,k))
                            T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + T_prog(n)%wrk1(i,j,k)
                         enddo
                      enddo
                      do k=2,kbl_max
                         do j=jsc,jec
                            do i=isc,iec
                               T_prog(n)%wrk1(i,j,k) = &
                                    rho0*wsfc(n)%wsfc(i,j)*(diff_cbt(i,j,k-1,ni)*ghats(i,j,k-1) - &
                                    diff_cbt(i,j,k,ni)  *ghats(i,j,k))
                               T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + T_prog(n)%wrk1(i,j,k)
                            enddo
                         enddo
                      enddo
                  endif ! endif for limit_ghats


              endif   ! endif for treatments of solar radiation 


              ! diagnostics 
              if (n==index_temp .or. n==index_salt) then
                  if(id_ghats(ni) > 0) then 
                      if (limit_ghats) then
                         call diagnose_3d(Time, Grd, id_ghats(ni), min(ghats(:,:,:)*diff_cbt(:,:,:,ni),1.))
                      else
                         call diagnose_3d(Time, Grd, id_ghats(n), ghats(:,:,:)*diff_cbt(:,:,:,ni))
                      endif
                  endif
              endif

              if (id_nonlocal(n) > 0) then 
                 call diagnose_3d(Time, Grd, id_nonlocal(n),T_prog(n)%conversion*T_prog(n)%wrk1(:,:,:))
              endif
              if (id_nonlocal_on_nrho(n) > 0) then
                 call diagnose_3d_rho(Time, Dens, id_nonlocal_on_nrho(n),T_prog(n)%conversion*wrk1)
              endif

           enddo   ! enddo for n-loop 

           call watermass_diag(Time, T_prog, Dens)

       endif   ! endif for non_local_kpp


!-----------------------------------------------------------------------
!     send mixing related fields resulting just from kpp
!-----------------------------------------------------------------------

       call diagnose_3d(Time, Grd, id_diff_cbt_kpp_t, diff_cbt(:,:,:,1))
       call diagnose_3d(Time, Grd, id_diff_cbt_kpp_s, diff_cbt(:,:,:,2))
       call diagnose_3d(Time, Grd, id_visc_cbt_kpp, visc_cbt(:,:,:))
       call diagnose_3d_u(Time, Grd, id_visc_cbu_kpp, visc_cbu(:,:,:))
       call diagnose_2d(Time, Grd, id_hblt, hblt(:,:))


end subroutine vert_mix_kpp_test
! </SUBROUTINE> NAME="vert_mix_kpp_test"


!#######################################################################
! <SUBROUTINE NAME="bldepth">
!
! <DESCRIPTION>
! The oceanic planetray boundary layer depth, hbl, is determined as
! the shallowest depth where the bulk richardson number is
! equal to the critical value, Ricr.
!
! Bulk Richardson numbers are evaluated by computing velocity and
! buoyancy differences between values at zt(kl) and surface
! reference values.
!
! In this configuration, the reference values are equal to the
! values in the surface layer.  
!
! When using a very fine vertical grid, these values should be 
! computed as the vertical average of velocity and buoyancy from 
! the surface down to epsilon*zt(kl).
!
! When the bulk richardson number at k exceeds Ricr, hbl is
! linearly interpolated between grid levels zt(k) and zt(k-1).
!
! The water column and the surface forcing are diagnosed for 
! stable/ustable forcing conditions, and where hbl is relative 
! to grid points (caseA), so that conditional branches can be 
! avoided in later subroutines.
!
!  input
!      real dbloc     = local delta buoyancy         (m/s^2)     
!      real dbsfc     = delta buoyancy w/ respect to sfc(m/s)^2  
!      real ustar     = surface friction velocity     (m/s)      
!      real Bo        = surface turbulent buoyancy forcing(m^2/s^3)
!      real Bosol     = radiative buoyancy forcing (m^2/s^3)       
!      real f         = Coriolis parameter            (1/s)        
!
!  output
!      real hbl        ! boundary layer depth              (m)      
!      real bfsfc      !Bo+radiation absorbed to d=hbf*hbl(m^2/s^3)      
!      real stable     ! =1 in stable forcing; =0 unstable          
!      real caseA      ! =1 in case A, =0 in case B                 
!      integer kbl     ! index of first grid level below hbl        
!
! </DESCRIPTION>
!
subroutine bldepth(Thickness, sw_frac_zt, do_wave)

  type(ocean_thickness_type),   intent(in) :: Thickness
  real, dimension(isd:,jsd:,:), intent(in) :: sw_frac_zt   !3-D array of shortwave fract
  logical,                      intent(in) :: do_wave

  real     :: Ritop         ! numerator of bulk Richardson Number
  real     :: bvfr, Vtsq
  real     :: hekman, hmonob, hlimit 
  real     :: a_co, b_co, c_co, slope_up, sqrt_arg, z_upper, z_up, zkl
  
  integer  :: ka, ku, kl, ksave, iwet, klp1, klm1, klm2
  integer  :: kupper, kup, kdn
  integer  :: i, j
  integer  :: iwscale_use_hbl_eq_zt

  real, parameter :: c2     = 2.0
  real, parameter :: c4     = 4.0
  real, parameter :: c0     = 0.0
  real, parameter :: cekman = 0.7  ! constant for Ekman depth
  real, parameter :: cmonob = 1.0  ! constant for Monin-Obukhov depth
  real, parameter :: vtc_fac = 200.! factor after Danabasoglu et al. (A.3) 

! find bulk Richardson number at every grid level until > Ricr
!
! note: the reference depth is -epsilon/2.*zt(k), but the reference
!       u,v,t,s values are simply the surface layer values,
!       and not the averaged values from 0 to 2*ref.depth,
!       which is necessary for very fine grids(top layer < 2m thickness)
! note: max values when Ricr never satisfied are
!       kbl(i)=kmt(i,j) and hbl(i)=zt(i,kmt(i,j))

!     Count the number of wet points. 
!     This is the amount of cells hbl is to be found. 
      iwet = 0


!      initialize hbl and kbl to bottomed out values
      do j=jsc,jec
        do i=isc,iec
          Rib(i,j,:) = 0.0
          kbl(i,j)   = MAX(Grd%kmt(i,j),2)
          hbl(i,j)   = Thickness%depth_zt(i,j,kbl(i,j))
          iwet       = iwet + min(Grd%kmt(i,j),1)
        enddo
      enddo


      ! Following Large etal (1994), do linear interpolation to find hbl
      if (linear_hbl) then

      ! indices for array Rib(i,j,k), the bulk Richardson number.     
      ka = 1
      ku = 2

      do kl=2,nk
        klp1 = min(kl+1,nk)
          klm1 = kl-1

        ! compute bfsfc = sw fraction at hbf * zt
        do j=jsc,jec
         do i=isc,iec
            bfsfc(i,j)  = Bo(i,j)  + Bosol(i,j) * (0.0 - sw_frac_zt(i,j,kl))  ! default assumes sw included in stf. 
                                                                              ! otherwise use (1.0-sw_frac)         
            stable(i,j) = 0.5 + SIGN( 0.5, bfsfc(i,j) )
            sigma(i,j)  = stable(i,j) * 1. + (1.-stable(i,j)) * epsilon
          enddo
        enddo

        ! compute velocity scales at sigma, for hbl = zt(kl):
        iwscale_use_hbl_eq_zt=1
        call wscale (iwscale_use_hbl_eq_zt, Thickness%depth_zt(:,:,kl), do_wave)

        do j=jsc,jec
          do i=isc,iec

            if((kbl(i,j) == Grd%kmt(i,j))) then

              ! compute the turbulent shear contribution to Rib
              ! eqn. (23)
              if (bvf_from_below) then
                 bvfr = sqrt(abs(0.5*                            &
                      ( dbloc(i,j,kl  ) / Thickness%dzwt(i,j,kl) +  &
                      dbloc(i,j,klp1) / Thickness%dzwt(i,j,klp1) ) ))
              else
                 bvfr = sqrt(abs(0.5*                              &
                      ( dbloc(i,j,klm1) / Thickness%dzwt(i,j,klm1) +  &
                      dbloc(i,j,kl  ) / Thickness%dzwt(i,j,kl) ) ))
              endif
    
              ! to ensure bitwise compatible with earlier code where default was vtc_flag=0.0 
              Vtsq =   Thickness%depth_zt(i,j,kl) * ws(i,j) * bvfr  &
                       * Vtc *(1.0-vtc_flag)                        &
                     + Thickness%depth_zt(i,j,kl) * ws(i,j) * bvfr  &
                       * max(concv, vtc_flag*(concv +.4 - vtc_fac*bvfr)) * (Vtc*concv_r) * vtc_flag 

!-----------------------------------------------------------------------
!           compute bulk Richardson number at new level
!           note: Ritop needs to be zero on land and ocean bottom
!           points so that the following if statement gets triggered
!           correctly. otherwise, hbl might get set to (big) negative
!           values, that might exceed the limit for the "exp" function
!           in "swfrac"
!
!           eqn. (21)
!
!           numerator of bulk richardson number on grid levels
!           --------------------------------------------------
!           note: land and ocean bottom values need to be set to zero
!           so that the subroutine "bldepth" works correctly
!-----------------------------------------------------------------------
              Ritop = (Thickness%depth_zt(i,j,kl)-Thickness%depth_zt(i,j,1)) * dbsfc(i,j,kl) * Grd%tmask(i,j,kl)
              Rib(i,j,ku) = Ritop / ( dVsq(i,j,kl) + Vtsq + epsln )

              if(Rib(i,j,ku) > Ricr) then

                  if(((rit(i,j,kl-1).lt.0).or.(rit(i,j,kl).lt.0)).and.hbl_with_rit) then  

                      ! Rib(i,j,ku) is not relevant, because locally unstable
                      Rib(i,j,ku) =  Ricr*0.1

                  else

                      ! linearly interpolate to find hbl where Rib = Ricr
                      hbl(i,j) = Thickness%depth_zt(i,j,kl-1) + Thickness%dzwt(i,j,kl-1) * (Ricr - Rib(i,j,ka))  & 
                           /(Rib(i,j,ku)-Rib(i,j,ka) + epsln)
                      kbl(i,j) = kl
                      iwet     = iwet - 1

                  endif

            endif

            endif  !kbl(i,j) == Grd%kmt(i,j), nothing to do otherwise, hbl is found
          enddo
        enddo

        if (iwet.eq.0) cycle  !all hbl at wet points are defined now -> ready
        
         ksave = ka
         ka    = ku
         ku    = ksave

      enddo


      ! perform quadratic interpolation instead of linear interpolation 
      else


        ! indices for array Rib(i,j,k), the bulk Richardson number.     
        kupper = 1
        kup    = 2
        kdn    = 3

        do kl=2,nk
          klp1 = min(kl+1,nk)
          klm1 = kl-1
          klm2 = max(kl-2,1)

          ! compute bfsfc = sw fraction at hbf * zt
          do j=jsc,jec
            do i=isc,iec
               bfsfc(i,j)  = Bo(i,j)  + Bosol(i,j) * (0.0 - sw_frac_zt(i,j,kl))  ! default assumes sw included in stf. 
                                                                                 ! otherwise use (1.0-sw_frac)         
               stable(i,j) = 0.5 + SIGN( 0.5, bfsfc(i,j) )
               sigma(i,j)  = stable(i,j) * 1. + (1.-stable(i,j)) * epsilon
            enddo
          enddo

          
          !  compute velocity scales at sigma, for hbl = zt(kl):
          iwscale_use_hbl_eq_zt=1
          call wscale (iwscale_use_hbl_eq_zt, Thickness%depth_zt(:,:,kl), do_wave)

          do j=jsc,jec
            do i=isc,iec

              if((kbl(i,j) == Grd%kmt(i,j))) then

                ! compute the turbulent shear contribution to Rib
                ! eqn. (23).
                if (bvf_from_below) then
                   bvfr = sqrt(abs(0.5*                              &
                        ( dbloc(i,j,kl  ) / Thickness%dzwt(i,j,kl) +    &
                        dbloc(i,j,klp1) / Thickness%dzwt(i,j,klp1) ) ))
                else
                   bvfr = sqrt(abs(0.5*                              &
                        ( dbloc(i,j,klm1) / Thickness%dzwt(i,j,klm1) +  &
                        dbloc(i,j,kl  ) / Thickness%dzwt(i,j,kl) ) ))
                endif
    
                ! to ensure bitwise compatible with earlier code where default was vtc_flag=0.0 
                Vtsq =   Thickness%depth_zt(i,j,kl) * ws(i,j) * bvfr  &
                         * Vtc *(1.0-vtc_flag)                        &
                       + Thickness%depth_zt(i,j,kl) * ws(i,j) * bvfr  &
                       * max(concv, vtc_flag*(concv +.4 - vtc_fac*bvfr)) * (Vtc*concv_r) * vtc_flag 

                !-----------------------------------------------------------------------
                ! compute bulk Richardson number at new level
                ! note: Ritop needs to be zero on land and ocean bottom
                ! points so that the following if statement gets triggered
                ! correctly. otherwise, hbl might get set to (big) negative
                ! values, that might exceed the limit for the "exp" function
                ! in "swfrac"
                !
                ! eqn. (21)
                !
                ! numerator of bulk richardson number on grid levels
                ! --------------------------------------------------
                ! note: land and ocean bottom values need to be set to zero
                ! so that the subroutine "bldepth" works correctly
                !-----------------------------------------------------------------------
                Ritop = (Thickness%depth_zt(i,j,kl)-Thickness%depth_zt(i,j,1)) * dbsfc(i,j,kl) * Grd%tmask(i,j,kl)

                Rib(i,j,kdn) = Ritop / ( dVsq(i,j,kl) + Vtsq + epsln )

                if(Rib(i,j,kdn) > Ricr) then

                  if(((rit(i,j,kl-1).lt.0).or.(rit(i,j,kl).lt.0)).and.hbl_with_rit) then  

                      ! Rib(i,j,ku) is not relevant, because locally unstable
                      Rib(i,j,kdn) =  Ricr*0.1			    

                  else

                      ! quadratically interpolate to find hbl where Rib = Ricr, adapted from MODULE: vmix_kpp (NCAR)
                      zkl      =   Thickness%depth_zt(i,j,kl)
                      z_up     = - Thickness%depth_zt(i,j,klm1)
                      z_upper  = - Thickness%depth_zt(i,j,klm2)
                      slope_up =  (Rib(i,j,kupper) - Rib(i,j,kup))/(z_up - z_upper + epsln)
                      a_co = (Rib(i,j,kdn) - Rib(i,j,kup) -         &
                              slope_up*(zkl + z_up) )/(z_up + zkl)**2
                      b_co = slope_up + c2 * a_co * z_up
                      c_co = Rib(i,j,kup) + z_up*(a_co*z_up + slope_up) - Ricr
                      sqrt_arg = b_co**2 - c4*a_co*c_co
                      if ( ( abs(b_co) > epsln .and. abs(a_co)/abs(b_co) <= epsln ) .or. sqrt_arg <= c0 ) then

                         hbl(i,j) = -z_up + (z_up + zkl) *    &
                                   (Ricr - Rib(i,j,kup))/               &
                                   (Rib(i,j,kdn) - Rib(i,j,kup))
                      else
                         hbl(i,j) = (-b_co + sqrt(sqrt_arg)) / (c2*a_co)
                      endif
		      
		      kbl(i,j) = kl
                      iwet     = iwet - 1

                  endif
 
                endif

              endif  !kbl(i,j) == Grd%kmt(i,j), nothing to do otherwise, hbl is found
            enddo
          enddo

          if (iwet.eq.0) cycle  !all hbl at wet points are defined now -> ready
         
          ksave   = kupper
          kupper = kup
          kup    = kdn
          kdn    = ksave

        enddo

      endif  ! endif for linear_hbl

!-----------------------------------------------------------------------
!     find stability and buoyancy forcing for boundary layer
!-----------------------------------------------------------------------

      do j=jsc,jec
        do i = isc,iec

          ! Linear interpolation of sw_frac_zt to depth of hbl
          ! (this is inaccurate, since swflux decays exponentially)
          sw_frac_hbl(i,j)=(sw_frac_zt(i,j,kbl(i,j)) - sw_frac_zt(i,j,kbl(i,j)-1)) / Thickness%dzt(i,j,kbl(i,j)) &
              * (hbl(i,j)-Thickness%depth_zt(i,j,kbl(i,j)))+sw_frac_zt(i,j,kbl(i,j))
          bfsfc(i,j)  = Bo(i,j) + Bosol(i,j) * (0.0 - sw_frac_hbl(i,j))
          stable(i,j) = 0.5 + SIGN( 0.5, bfsfc(i,j) )
          bfsfc(i,j)  = bfsfc(i,j) + stable(i,j) * epsln  ! ensures bfsfc never=0

        enddo
      enddo


!-----------------------------------------------------------------------
!        check hbl limits for hekman or hmonob
!        eqn. (24)
!-----------------------------------------------------------------------
      if(limit_with_hekman) then
      do j=jsc,jec
        do i = isc,iec
          if (bfsfc(i,j) > 0.0) then
             hekman = cekman * ustar(i,j) / (abs(Grd%f(i,j))+epsln)
             hmonob = cmonob * ustar(i,j)*ustar(i,j)*ustar(i,j)     &
                     /von_karman / (bfsfc(i,j)+epsln) 
             hlimit = stable(i,j)     * AMIN1(hekman,hmonob) +      &
                     (stable(i,j)-1.) * (Thickness%depth_zt(i,j,nk))
             hbl(i,j) = AMIN1(hbl(i,j),hlimit)
             hbl(i,j) = AMAX1(hbl(i,j),Thickness%depth_zt(i,j,1))
          endif
          kbl(i,j) =Grd%kmt(i,j)
        enddo
      enddo
      else
        do j=jsc,jec
          do i = isc,iec
            if (bfsfc(i,j) > 0.0) then
              hmonob = cmonob * ustar(i,j)*ustar(i,j)*ustar(i,j)     &
                      /von_karman / (bfsfc(i,j)+epsln) 
              hlimit = stable(i,j)      * hmonob +      &
                       (stable(i,j)-1.) * (Thickness%depth_zt(i,j,nk))
              hbl(i,j) = AMIN1(hbl(i,j),hlimit)
              hbl(i,j) = AMAX1(hbl(i,j),Thickness%depth_zt(i,j,1))
            endif
            kbl(i,j) =Grd%kmt(i,j)
          enddo
        enddo
      endif

!-----------------------------------------------------------------------
!     find new kbl
!-----------------------------------------------------------------------
      if(kbl_standard_method .and. vert_coordinate_class/=PRESSURE_BASED) then 
          do kl=kl_min,nk
             do j=jsc,jec
                do i = isc,iec
                   if((kbl(i,j) == Grd%kmt(i,j)).and.(Thickness%depth_zt(i,j,kl) > hbl(i,j))) then
                       kbl(i,j) = kl
                   endif
                enddo
             enddo
          enddo
      elseif(kbl_standard_method .and. vert_coordinate_class==PRESSURE_BASED) then 
          do kl=kl_min,nk
             do j=jsc,jec
                do i = isc,iec
                   if((kbl(i,j) == Grd%kmt(i,j)).and.(Thickness%depth_zt(i,j,kl) > hbl(i,j))) then
                       kbl(i,j) = min(kl,Grd%kmt(i,j))
                   endif
                enddo
             enddo
          enddo
      else 
          do kl=kl_min,nk
             do j=jsc,jec
                do i = isc,iec
                   if((kbl(i,j) == Grd%kmt(i,j)).and.(Thickness%depth_zt(i,j,kl) >= hbl(i,j))) then
                       kbl(i,j) = min(kl,Grd%kmt(i,j))
                   endif
                enddo
             enddo
          enddo
      endif

      kbl_max = maxval(kbl)

!-----------------------------------------------------------------------
!     find stability and buoyancy forcing for final hbl values
!-----------------------------------------------------------------------

      do j=jsc,jec
        do i = isc,iec
          if (kbl(i,j)==0 .or. kbl(i,j)==1) cycle

          ! Linear interpolation of sw_frac_zt to depth of hbl
          ! (this is inaccurate, since swflux decays exponentially)
          sw_frac_hbl(i,j)=(sw_frac_zt(i,j,kbl(i,j)) - sw_frac_zt(i,j,kbl(i,j)-1)) / Thickness%dzt(i,j,kbl(i,j)) &
              * (hbl(i,j)-Thickness%dzt(i,j,kbl(i,j)))+sw_frac_zt(i,j,kbl(i,j))
          bfsfc(i,j)  = Bo(i,j) + Bosol(i,j) * (0.0 - sw_frac_hbl(i,j))
          stable(i,j) = 0.5 + SIGN( 0.5, bfsfc(i,j) )
          bfsfc(i,j)  = bfsfc(i,j) + stable(i,j) * epsln 

        enddo
      enddo

!-----------------------------------------------------------------------
!     determine caseA and caseB
!     (if hbl is below (deeper than) the mid point of level kbl
!     then caseA=0  else caseA=1)
!-----------------------------------------------------------------------

      do j=jsc,jec
        do i = isc,iec
          if (kbl(i,j)==0) cycle
          caseA(i,j)  = 0.5 + &
          SIGN( 0.5,Thickness%depth_zt(i,j,kbl(i,j)) - 0.5*Thickness%dzt(i,j,kbl(i,j)) - hbl(i,j) )
        enddo
      enddo

end subroutine bldepth
! </SUBROUTINE> NAME="bldepth"



!#######################################################################
! <SUBROUTINE NAME="wscale">
!
! <DESCRIPTION>
! Compute turbulent velocity scales.
! Use a 2D-lookup table for wm and ws as functions of ustar and
! zetahat (=von_karman*sigma*hbl*bfsfc).
!
! Note: the lookup table is only used for unstable conditions
! (zehat <= 0), in the stable domain wm (=ws) gets computed
! directly.
!
! Note: the loop has been doubled to allow NEC compilers for vectorisation.
! Speed gain was observed at the SX-6.
! Later compiler versions may do better.
!
!
!  input                                                               <BR/>
!      real sigma  = normalized depth (d/hbl)               <BR/>
!      real hbl    = boundary layer depth (m)               <BR/>  
!      real ustar  = surface friction velocity    (m/s)     <BR/>  
!      real bfsfc  = total surface buoyancy flux (m^2/s^3)  <BR/>

!  output                                                               <BR/>  
!      real wm,ws ! turbulent velocity scales at sigma

! local                                                                 <BR/>  
!      real zehat           ! = zeta *  ustar**3
!
! </DESCRIPTION>
!
subroutine wscale(iwscale_use_hbl_eq_zt, zt_kl, do_wave)

  integer,                    intent(in) :: iwscale_use_hbl_eq_zt
  real, dimension(isd:,jsd:), intent(in) :: zt_kl
  logical,                    intent(in) :: do_wave

  real                :: zdiff, udiff, zfrac, ufrac, fzfrac
  real                :: wam, wbm, was, wbs, u3, langmuirfactor, Cw_smyth
  real                :: zehat           ! = zeta *  ustar**3
  integer             :: iz, izp1, ju, jup1
  integer             :: i, j

!-----------------------------------------------------------------------
!     use lookup table for zehat < zmax only; otherwise use
!     stable formulae
!-----------------------------------------------------------------------

      if (iwscale_use_hbl_eq_zt == 1) then

        do j=jsc,jec
          do i=isc,iec
            zehat = von_karman * sigma(i,j) * zt_kl(i,j) * bfsfc(i,j)

            if (zehat <= zmax) then

              zdiff  = zehat-zmin
              iz = int( zdiff/deltaz )
              iz = min( iz , nni )
              iz = max( iz , 0  )
              izp1=iz+1
            
              udiff  = ustar(i,j)-umin

              ju = int( min(udiff/deltau,float(nnj)))
              ju = max( ju , 0  )
              jup1=ju+1

              zfrac = zdiff/deltaz - float(iz)
              ufrac = udiff/deltau - float(ju)

              fzfrac= 1.-zfrac
              wam   = (fzfrac)  * wmt(iz,jup1) + zfrac*wmt(izp1,jup1)
              wbm   = (fzfrac)  * wmt(iz,ju  ) + zfrac*wmt(izp1,ju  )
              wm(i,j) = (1.-ufrac)* wbm          + ufrac*wam

              was   = (fzfrac)  * wst(iz,jup1) + zfrac*wst(izp1,jup1)
              wbs   = (fzfrac)  * wst(iz,ju  ) + zfrac*wst(izp1,ju  )
              ws(i,j) = (1.-ufrac)* wbs          + ufrac*was
            else
              u3    = ustar(i,j)*ustar(i,j)*ustar(i,j)
              wm(i,j) = von_karman * ustar(i,j) * u3 / ( u3 + conc1*zehat + epsln )
              ws(i,j) = wm(i,j)
            endif

          enddo
        enddo

      else

        do j=jsc,jec
          do i=isc,iec
            zehat = von_karman * sigma(i,j) * hbl(i,j)   * bfsfc(i,j)

            if (zehat <= zmax) then

              zdiff  = zehat-zmin
              iz = int( zdiff/deltaz )
              iz = min( iz , nni )
              iz = max( iz , 0  )
              izp1=iz+1
              
              udiff  = ustar(i,j)-umin
              
              ju = int( min(udiff/deltau,float(nnj)))
              ju = max( ju , 0  )
              jup1=ju+1
              
              zfrac = zdiff/deltaz - float(iz)
              ufrac = udiff/deltau - float(ju)
              
              fzfrac= 1.-zfrac
              wam   = (fzfrac)  * wmt(iz,jup1) + zfrac*wmt(izp1,jup1)
              wbm   = (fzfrac)  * wmt(iz,ju  ) + zfrac*wmt(izp1,ju  )
              wm(i,j) = (1.-ufrac)* wbm          + ufrac*wam
              
              was   = (fzfrac)  * wst(iz,jup1) + zfrac*wst(izp1,jup1)
              wbs   = (fzfrac)  * wst(iz,ju  ) + zfrac*wst(izp1,ju  )
              ws(i,j) = (1.-ufrac)* wbs          + ufrac*was

            else

              u3    = ustar(i,j)*ustar(i,j)*ustar(i,j)
              wm(i,j) = von_karman * ustar(i,j) * u3 / ( u3 + conc1*zehat + epsln )
              ws(i,j) = wm(i,j)
            endif

          enddo
        enddo

      endif

!----------- if do_wave, add Langmuir turbulence enhancement factor

      if (do_wave .and. do_langmuir) then
         do j=jsc,jec
            do i=isc,iec
               Cw_smyth=Cw_0*(ustar(i,j)*ustar(i,j)*ustar(i,j)/(ustar(i,j)*ustar(i,j)*ustar(i,j) &
                    + Wstfac*von_karman*bfsfc(i,j)*hbl(i,j) + epsln))**l_smyth
               langmuirfactor=sqrt(1+Cw_smyth*Ustk2(i,j)/(ustar(i,j)*ustar(i,j) + epsln))
               langmuirfactor = max(1.0, langmuirfactor)
               langmuirfactor = min(LTmax, langmuirfactor)
               ws(i,j)=ws(i,j)*langmuirfactor
               wm(i,j)=wm(i,j)*langmuirfactor
            enddo
         enddo
      endif

end subroutine wscale
! </SUBROUTINE> NAME="wscale"



!#######################################################################
! <SUBROUTINE NAME="ri_iwmix">
!
! <DESCRIPTION>
! Compute interior viscosity and diffusivity due 
! to shear instability (dependent on a local richardson number),
! to background internal wave activity, and 
! to static instability (local richardson number < 0).
!
! Diffusion and viscosity coefficients are on bottom
! of T-cells.
!
! </DESCRIPTION>
!
subroutine ri_iwmix(visc_cbt, diff_cbt)

  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbt
  real, dimension(isd:,jsd:,:,:), intent(inout) :: diff_cbt
  
  real    :: Rigg, ratio, frit, fcont
  integer :: i, j, k

  do k=1,nk-1
     do j=jsc,jec
        do i=isc,iec
  
!-----------------------------------------------------------------------
!           evaluate function of Ri for shear instability eqn. (28b&c)
!           only do so here using rit.
!-----------------------------------------------------------------------

           Rigg  = AMAX1( rit(i,j,k) , 0.0)
           ratio = AMIN1( Rigg/Riinfty , 1.0 )
           frit  = (1. - ratio*ratio)
           frit  = frit*frit*frit

!-----------------------------------------------------------------------
!          evaluate function of Ri for convection eqn. (28a)
!-----------------------------------------------------------------------

           fcont = 0.5 * ( abs(rit(i,j,k)) - rit(i,j,k) )
           fcont = fcont / (AMAX1(fcont,epsln))
     
!-----------------------------------------------------------------------
!           mixing due to internal wave activity and static instability 
!           eqn. (29).  Note: visc_cbt on T-point.
!-----------------------------------------------------------------------

           visc_cbt(i,j,k)   = visc_cbu_iw + fcont * visc_con_limit   
           diff_cbt(i,j,k,1) = diff_cbt_iw + fcont * diff_con_limit
           diff_cbt(i,j,k,2) = diff_cbt_iw + fcont * diff_con_limit

!-----------------------------------------------------------------------
!          add contribution due to shear instability
!-----------------------------------------------------------------------

           diff_cbt(i,j,k,1) = diff_cbt(i,j,k,1)              &
                + shear_instability_flag*diff_cbt_limit*frit 
           diff_cbt(i,j,k,2) = diff_cbt(i,j,k,2)              &
                + shear_instability_flag*diff_cbt_limit*frit 
           visc_cbt(i,j,k)   = visc_cbt(i,j,k)                &
                + shear_instability_flag*visc_cbu_limit*frit 

        enddo
     enddo
  enddo
 
end subroutine ri_iwmix
! </SUBROUTINE> NAME="ri_iwmix"


!#######################################################################
! <SUBROUTINE NAME="ddmix">
!
! <DESCRIPTION>
! Rrho dependent interior flux parameterization.
! Add double-diffusion diffusivities to Ri-mix values at blending
! interface and below. salt fingering code modified july 2003
! by stephen.griffies based on NCAR CCSM2.x
!
!      real talpha   ! d(rho)/ d(pot.temperature) (kg/m^3/C)  <BR/> 
!      real sbeta    ! d(rho)/ d(salinity)     (kg/m^3/PSU)  
!
!      diff_cbt = diffusion coefficient at bottom of "t" cells (m**2/s)
!
! local
!      real alphaDT  ! alpha * DT  across interfaces   
!      real betaDS   ! beta  * DS  across interfaces   
!
! </DESCRIPTION>
!
subroutine ddmix (Time, T_prog, Dens, diff_cbt)

type(ocean_time_type),          intent(in)    :: Time
type(ocean_prog_tracer_type),   intent(in)    :: T_prog(:)
type(ocean_density_type),       intent(in)    :: Dens
real, dimension(isd:,jsd:,:,:), intent(inout) :: diff_cbt

real diffdd   ! double diffusion diffusivity scale
real prandtl  ! prandtl number
real Rrho     ! double-diffusive density ratio

real, parameter :: Rrho0               = 1.9    ! limit for double diffusive density ratio
real, parameter :: dsfmax              = 1.e-4  ! (m^2/s) max diffusivity in case of salt fingering
real, parameter :: viscosity_molecular = 1.5e-6 ! (m^2/s)

integer :: i, j, k, ki, tau

tau = Time%tau

!     for double diffusion
!     --------------------
!     temperature and salt contributions of buoyancy gradients
!     on interfaces

    do k=1,nk-1
      do j=jsc,jec
        do i=isc,iec
            alphaDT(i,j,k) = 0.5 * (talpha(i,j,k) + talpha(i,j,k+1) ) &
                             * (T_prog(index_temp)%field(i,j,k,tau) - T_prog(index_temp)%field(i,j,k+1,tau))
            betaDS (i,j,k) = 0.5 * (sbeta (i,j,k) + sbeta(i,j,k+1)  ) &
                             *(Dens%rho_salinity(i,j,k,tau) - Dens%rho_salinity(i,j,k+1,tau))
        enddo
      enddo
    enddo
    do j=jsc,jec
      do i=isc,iec
        alphaDT(i,j,nk) = 0.0
        betaDS (i,j,nk) = 0.0
      enddo
    enddo

    do ki=1,nk
       do j=jsc,jec
          do i=isc,iec

!-----------------------------------------------------------------------
!           salt fingering case
!           eqn. (31)
!-----------------------------------------------------------------------

             if ((alphaDT(i,j,ki) > betaDS(i,j,ki)) .and. &
                 (betaDS (i,j,ki) > 0.         )) then

                 Rrho   = MIN(alphaDT(i,j,ki) / betaDS(i,j,ki), Rrho0)

                 diffdd = 1.0-((Rrho-1.0)/(Rrho0-1.0)) 
                 diffdd = dsfmax*diffdd*diffdd*diffdd

                 diff_cbt(i,j,ki,1) = diff_cbt(i,j,ki,1) + 0.7*diffdd
                 diff_cbt(i,j,ki,2) = diff_cbt(i,j,ki,2) + diffdd

!            diffusive convection eqn. (32)
             else if ( (alphaDT(i,j,ki) < 0.0) .and.  &
                       (betaDS(i,j,ki)  < 0.0) .and.  &
                       (alphaDT(i,j,ki) > betaDS(i,j,ki)) ) then

                 Rrho    = alphaDT(i,j,ki) / betaDS(i,j,ki) 
                 diffdd  = viscosity_molecular*0.909*exp(4.6*exp(-0.54*(1/Rrho-1)))  

!                eqn. (34)
                 prandtl = 0.15*Rrho
                 if (Rrho > 0.5) prandtl = (1.85-0.85/Rrho)*Rrho

                 diff_cbt(i,j,ki,1) = diff_cbt(i,j,ki,1) + diffdd
                 diff_cbt(i,j,ki,2) = diff_cbt(i,j,ki,2) + prandtl*diffdd

             endif

          enddo
       enddo
    enddo

end subroutine ddmix
! </SUBROUTINE> NAME="ddmix"


!#######################################################################
! <SUBROUTINE NAME="blmix_kpp">
!
! <DESCRIPTION>
! Mixing coefficients within boundary layer depend on surface
! forcing and the magnitude and gradient of interior mixing below
! the boundary layer ("matching").
!
! CAUTION: if mixing bottoms out at hbl = zt(nk) then
! fictitious layer at nk+1 is needed with small but finite width 
! dzt(nk+1) (eg. epsln = 1.e-20).  
!
!     inputs:
!
!      real ustar    ! surface friction velocity         (m/s)  
!      real bfsfc    ! surface buoyancy forcing     (m^2/s^3)   
!      real hbl      ! boundary layer depth              (m)    
!      real stable   ! = 1 in stable forcing                    
!      real caseA    ! = 1 in case A                            
!      integer kbl   ! index of first grid level below hbl
!
!     outputs:
!
!      visc_cbt = viscosity coefficient at bottom of "t" cells (m**2/s)   
!      diff_cbt = diffusion coefficient at bottom of "t" cells (m**2/s)   
!
!      real dkm1(,3)    = boundary layer diff_cbt at kbl-1 level  
!      real blmc(,nk,3) = boundary layer mixing coeff.(m**2/s)    
!      real ghats(,nk)  = nonlocal scalar transport               
!
!    local:
!
!      real gat1(,3)                                              
!      real dat1(,3)                                              
!      real sigma()              = normalized depth (d / hbl)     
!      real ws(), wm()  = turbulent velocity scales (m/s) 
!
! </DESCRIPTION>
!
subroutine blmix_kpp(Thickness, diff_cbt, visc_cbt, do_wave)

  type(ocean_thickness_type),     intent(in)    :: Thickness
  real, dimension(isd:,jsd:,:,:), intent(inout) :: diff_cbt
  real, dimension(isd:,jsd:,:) ,  intent(inout) :: visc_cbt
  logical,                        intent(in)    :: do_wave

  real, dimension(isd:ied,jsd:jed) :: zt_kl_dummy

  real     :: delhat, R, dvdzup, dvdzdn
  real     :: viscp, difsp, diftp, visch, difsh, difth, f1
  real     :: sig, a1, a2, a3, Gm, Gs, Gt

  integer  :: iwscale_use_hbl_eq_zt
  integer  :: i, j, ki
  integer  :: kn, knm1, knp1

!-----------------------------------------------------------------------
!       compute velocity scales at hbl. (recall epsilon=0.1)
!-----------------------------------------------------------------------
        do j = jsc,jec
          do i = isc,iec
            sigma(i,j) = stable(i,j) * 1.0 + (1.-stable(i,j)) * epsilon
          enddo
        enddo

        iwscale_use_hbl_eq_zt = 0
        zt_kl_dummy(:,:)      = 0.0

        call wscale (iwscale_use_hbl_eq_zt, zt_kl_dummy, do_wave)

      do j=jsc,jec
        do i = isc,iec 
          if (kbl(i,j) .eq. 0) cycle
          kn    = ifix(caseA(i,j)+epsln) *(kbl(i,j) -1) +   &
                  (1-ifix(caseA(i,j)+epsln)) * kbl(i,j)
          knm1 = max(kn-1,1)
          knp1 = min(kn+1,nk)

!-----------------------------------------------------------------------
!         find the interior viscosities and derivatives at hbl(i) 
!         eqn. (18)
!-----------------------------------------------------------------------

          delhat = 0.5*Thickness%dzt(i,j,kn) + Thickness%depth_zt(i,j,kn) - hbl(i,j)
          R      = 1.0 - delhat / Thickness%dzt(i,j,kn)
          dvdzup = (visc_cbt(i,j,knm1) - visc_cbt(i,j,kn))/Thickness%dzt(i,j,kn)
          dvdzdn = (visc_cbt(i,j,kn) - visc_cbt(i,j,knp1))/Thickness%dzt(i,j,knp1)
          viscp  = 0.5 * ( (1.-R) * (dvdzup + abs(dvdzup))+         &
                               R  * (dvdzdn + abs(dvdzdn)) )

          dvdzup = (diff_cbt(i,j,knm1,2) - diff_cbt(i,j,kn,2))/Thickness%dzt(i,j,kn)
          dvdzdn = (diff_cbt(i,j,kn,2)   - diff_cbt(i,j,knp1,2))/Thickness%dzt(i,j,knp1)
          difsp  = 0.5 * ( (1.-R) * (dvdzup + abs(dvdzup))+         &
                               R  * (dvdzdn + abs(dvdzdn)) )

          dvdzup = (diff_cbt(i,j,knm1,1) - diff_cbt(i,j,kn,1))/Thickness%dzt(i,j,kn)
          dvdzdn = (diff_cbt(i,j,kn,1)   - diff_cbt(i,j,knp1,1))/Thickness%dzt(i,j,knp1)
          diftp  = 0.5 * ( (1.-R) * (dvdzup + abs(dvdzup))+         &
                               R  * (dvdzdn + abs(dvdzdn)) )

          visch  = visc_cbt(i,j,kn)       + viscp * delhat
          difsh  = diff_cbt(i,j,kn,2) + difsp * delhat
          difth  = diff_cbt(i,j,kn,1)     + diftp * delhat

          f1 = stable(i,j) * conc1 * bfsfc(i,j) / (ustar(i,j)**4+epsln) 

          gat1(i,j,1) = visch / (hbl(i,j)+epsln) / (wm(i,j)+epsln)
          dat1(i,j,1) = -viscp / (wm(i,j)+epsln) + f1 * visch
          dat1(i,j,1) = min(dat1(i,j,1),0.) 

          gat1(i,j,2) = difsh  / (hbl(i,j)+epsln) / (ws(i,j)+epsln)
          dat1(i,j,2) = -difsp / (ws(i,j)+epsln) + f1 * difsh 
          dat1(i,j,2) = min(dat1(i,j,2),0.) 
  
          gat1(i,j,3) = difth /  (hbl(i,j)+epsln) / (ws(i,j)+epsln)
          dat1(i,j,3) = -diftp / (ws(i,j)+epsln) + f1 * difth 
          dat1(i,j,3) = min(dat1(i,j,3),0.) 
        enddo
      enddo

      blmc(:,:,:,:) = 0.0

      do ki=1,kbl_max !results are needed only for ki<kbl, hence, limiting this loops saves a lot of wscale calls

!-----------------------------------------------------------------------
!         compute turbulent velocity scales on the interfaces
!-----------------------------------------------------------------------

        do j=jsc,jec
          do i=isc,iec
            sig        = (Thickness%depth_zt(i,j,ki) + 0.5 * Thickness%dzt(i,j,ki)) / (hbl(i,j)+epsln)
            sigma(i,j) = stable(i,j)*sig + (1.-stable(i,j))*AMIN1(sig,epsilon)
          enddo
        enddo

        iwscale_use_hbl_eq_zt = 0
        zt_kl_dummy(:,:)      = 0.0

        call wscale(iwscale_use_hbl_eq_zt, zt_kl_dummy, do_wave)

!-----------------------------------------------------------------------
!         compute the dimensionless shape functions at the interfaces
!         eqn. (11)
!-----------------------------------------------------------------------

        if (id_ws > 0) wrk1(:,:,ki) =  ws(:,:)
          
        do j=jsc,jec
          do i = isc,iec
            if (ki < kbl(i,j)) then
              sig = (Thickness%depth_zt(i,j,ki) + 0.5 * Thickness%dzt(i,j,ki)) / (hbl(i,j)+epsln)
              a1 = sig - 2.
              a2 = 3.-2.*sig
              a3 = sig - 1.

              Gm = a1 + a2 * gat1(i,j,1) + a3 * dat1(i,j,1)
                   
              Gs = a1 + a2 * gat1(i,j,2) + a3 * dat1(i,j,2)
                  
              Gt = a1 + a2 * gat1(i,j,3) + a3 * dat1(i,j,3)
                  

!-----------------------------------------------------------------------
!             compute boundary layer diffusivities at the interfaces
!             eqn. (10)
!-----------------------------------------------------------------------

              
              blmc(i,j,ki,1) = hbl(i,j) * wm(i,j) * sig * (1.+sig*Gm) 
              blmc(i,j,ki,2) = hbl(i,j) * ws(i,j) * sig * (1.+sig*Gt) 
              blmc(i,j,ki,3) = hbl(i,j) * ws(i,j) * sig * (1.+sig*Gs) 

!-----------------------------------------------------------------------
!             nonlocal transport term = ghats * <ws>o (eqn. 20)
!             To include Langmuir turbulence effects, multiply ghats
!             by a factor of Lgam (McWilliam & Sullivan 2001)
!-----------------------------------------------------------------------
              if (do_wave .and. do_langmuir) then
                 ghats(i,j,ki) = Lgam * (1.-stable(i,j)) * cg    &
                        / (ws(i,j) * hbl(i,j) + epsln)
              else
                 ghats(i,j,ki) = (1.-stable(i,j)) * cg    &
                        / (ws(i,j) * hbl(i,j) + epsln)
              endif
            endif
          enddo
        enddo
      enddo

     
!-----------------------------------------------------------------------
!     find diffusivities at kbl-1 grid level 
!-----------------------------------------------------------------------

      do j=jsc,jec
        do i= isc,iec
          if (kbl(i,j)== 0 .or. kbl(i,j)==1) cycle
          sig        =  Thickness%depth_zt(i,j,kbl(i,j)-1)  / (hbl(i,j)+epsln)
          sigma(i,j) = stable(i,j) * sig + (1.-stable(i,j)) * MIN(sig,epsilon)
        enddo
      enddo

      iwscale_use_hbl_eq_zt = 0
      zt_kl_dummy(:,:)      = 0.0

      call wscale(iwscale_use_hbl_eq_zt, zt_kl_dummy, do_wave)

      do j=jsc,jec
        do i = isc,iec
          if (kbl(i,j)==0 .or. kbl(i,j)==1) cycle
          sig = Thickness%depth_zt(i,j,kbl(i,j)-1) / (hbl(i,j)+epsln)
          a1= sig - 2.
          a2 = 3.-2.*sig
          a3 = sig - 1.
          Gm = a1 + a2 * gat1(i,j,1) + a3 * dat1(i,j,1)
          Gs = a1 + a2 * gat1(i,j,2) + a3 * dat1(i,j,2)
          Gt = a1 + a2 * gat1(i,j,3) + a3 * dat1(i,j,3)
          dkm1(i,j,1) = hbl(i,j) * wm(i,j) * sig * (1. + sig * Gm)
          dkm1(i,j,2) = hbl(i,j) * ws(i,j) * sig * (1. + sig * Gs)
          dkm1(i,j,3) = hbl(i,j) * ws(i,j) * sig * (1. + sig * Gt)
        enddo
      enddo

      
end subroutine blmix_kpp
! </SUBROUTINE> NAME="blmix_kpp"



!#######################################################################
! <SUBROUTINE NAME="enhance">
!
! <DESCRIPTION>
! Enhance the diffusivity at the kbl-.5 interface
!
! input
!      integer kbl =  grid above hbl                      
!      real hbl    =  boundary layer depth (m)            
!      real dkm1   =  bl diffusivity at kbl-1 grid level  
!      real caseA  =  1 in caseA, = 0 in case B
!
! input/output
!      real ghats =  nonlocal transport     (s/m**2)    
!      modified ghats at kbl(i)-1 interface        
! output
!      real blmc = enhanced boundary layer mixing coefficient
!
! local
!  real delta =  fraction hbl lies beteen zt neighbors
!
! </DESCRIPTION>
subroutine enhance(Thickness, diff_cbt, visc_cbt)

type(ocean_thickness_type),     intent(in) :: Thickness
real, dimension(isd:,jsd:,:,:), intent(in) :: diff_cbt
real, dimension(isd:,jsd:,:),   intent(in) :: visc_cbt

  real    :: delta, dkmp5, dstar
  integer :: i, j, ki

      do ki=1,nk-1
        do j=jsc,jec
          do i = isc,iec

            if(ki == (kbl(i,j) - 1) ) then

              delta =  (hbl(i,j)-Thickness%depth_zt(i,j,ki)) &
                     / (Thickness%depth_zt(i,j,ki+1)-Thickness%depth_zt(i,j,ki))

              dkmp5 = caseA(i,j) * visc_cbt(i,j,ki)      &
                    + (1.-caseA(i,j)) * blmc(i,j,ki,1)
              dstar = (1.-delta)**2 * dkm1(i,j,1) + delta**2 * dkmp5
              blmc(i,j,ki,1) = (1.-delta) * visc_cbt(i,j,ki)  &
                             + delta * dstar

              ! temperature:
              dkmp5 = caseA(i,j) * diff_cbt(i,j,ki,1)  &
                    + (1.-caseA(i,j)) * blmc(i,j,ki,2)
              dstar = (1.-delta)**2 * dkm1(i,j,3) + delta**2 * dkmp5    
              blmc(i,j,ki,2) = (1.-delta) * diff_cbt(i,j,ki,1)  &
                           + delta * dstar

              ! salinity:   
              dkmp5 = caseA(i,j) * diff_cbt(i,j,ki,2)  &
                    + (1.-caseA(i,j)) * blmc(i,j,ki,3)
              dstar = (1.-delta)**2 * dkm1(i,j,2) + delta**2 * dkmp5
              blmc(i,j,ki,3) = (1.-delta) * diff_cbt(i,j,ki,2)  &
                           + delta * dstar
            
              ghats(i,j,ki) = (1.-caseA(i,j)) * ghats(i,j,ki)

            endif

          enddo
        enddo
      enddo

end subroutine enhance
! </SUBROUTINE> NAME="enhance"



!#######################################################################
! <SUBROUTINE NAME="watermass_diag_init">
!
! <DESCRIPTION>
! Initialization of watermass diagnostic output files. 
! </DESCRIPTION>
!
subroutine watermass_diag_init(Time, Dens)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens

  integer :: stdoutunit
  stdoutunit=stdout()
  compute_watermass_diag = .false. 


  id_neut_rho_kpp_nloc = register_diag_field ('ocean_model',      &
    'neut_rho_kpp_nloc',                                          &
    Grd%tracer_axes(1:3), Time%model_time,                        &
    'locally referenced potrho tendency due to KPP nonlocal term',&
    '(kg/m^3)/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_neut_rho_kpp_nloc > 0) compute_watermass_diag=.true.

  id_wdian_rho_kpp_nloc = register_diag_field ('ocean_model',    &
    'wdian_rho_kpp_nloc', Grd%tracer_axes(1:3), Time%model_time, &
    'dianeutral mass transport due to KPP nonlocal term',        &
    'kg/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_wdian_rho_kpp_nloc > 0) compute_watermass_diag=.true.

  id_tform_rho_kpp_nloc = register_diag_field ('ocean_model',               & 
    'tform_rho_kpp_nloc', Grd%tracer_axes(1:3), Time%model_time,            &
    'watermass transform due to KPP nonlocal on levels (pre-layer binning)',&
    'kg/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_tform_rho_kpp_nloc > 0) compute_watermass_diag=.true.

  id_neut_rho_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                    &
    'neut_rho_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,            &
    'update of locally ref potrho from KPP nolocal as binned to neutral density layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_rho_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_rho_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                   &
    'wdian_rho_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,           &
    'dianeutral mass transport due to KPP nonlocal as binned to neutral density layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_rho_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_rho_kpp_nloc_on_nrho = register_diag_field ('ocean_model',             &
    'tform_rho_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,     &
    'watermass transform due to KPP nonlocal as binned to neutral density layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_rho_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.

  id_eta_tend_kpp_nloc= -1          
  id_eta_tend_kpp_nloc= register_diag_field ('ocean_model','eta_tend_kpp_nloc',&
       Grd%tracer_axes(1:2), Time%model_time,                                  &
       'non-Bouss steric sea level tendency from kpp_nloc tendency', 'm/s',    &
       missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_kpp_nloc > 0) compute_watermass_diag=.true.

  id_eta_tend_kpp_nloc_glob= -1          
  id_eta_tend_kpp_nloc_glob= register_diag_field ('ocean_model', 'eta_tend_kpp_nloc_glob',&
       Time%model_time,                                                                   &
       'global mean non-bouss steric sea level tendency from kpp_nloc tendency',          &
       'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_kpp_nloc_glob > 0) compute_watermass_diag=.true.


  id_neut_temp_kpp_nloc = register_diag_field ('ocean_model',                  &
    'neut_temp_kpp_nloc',                                                      &
    Grd%tracer_axes(1:3), Time%model_time,                                     &
    'temp related locally referenced potrho tendency due to KPP nonlocal term',&
    '(kg/m^3)/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_neut_temp_kpp_nloc > 0) compute_watermass_diag=.true.

  id_wdian_temp_kpp_nloc = register_diag_field ('ocean_model',        &
    'wdian_temp_kpp_nloc', Grd%tracer_axes(1:3), Time%model_time,     &
    'temp related dianeutral mass transport due to KPP nonlocal term',&
    'kg/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_wdian_temp_kpp_nloc > 0) compute_watermass_diag=.true.

  id_tform_temp_kpp_nloc = register_diag_field ('ocean_model',                           &  
    'tform_temp_kpp_nloc', Grd%tracer_axes(1:3), Time%model_time,                        &
    'temp related watermass transform due to KPP nonlocal on levels (pre-layer binning)',&
    'kg/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_tform_temp_kpp_nloc > 0) compute_watermass_diag=.true.

  id_neut_temp_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                                &
    'neut_temp_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                        &
    'temp related update of locally ref potrho from KPP nolocal as binned to neutral density layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_temp_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_temp_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                               &
    'wdian_temp_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
    'temp related dianeutral mass transport due to KPP nonlocal as binned to neutral density layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_temp_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_temp_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                         &
    'tform_temp_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                 &
    'temp related watermass transform due to KPP nonlocal as binned to neutral density layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_temp_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.



  id_neut_salt_kpp_nloc = register_diag_field ('ocean_model',                  &
    'neut_salt_kpp_nloc',                                                      &
    Grd%tracer_axes(1:3), Time%model_time,                                     &
    'salt related locally referenced potrho tendency due to KPP nonlocal term',&
    '(kg/m^3)/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_neut_salt_kpp_nloc > 0) compute_watermass_diag=.true.

  id_wdian_salt_kpp_nloc = register_diag_field ('ocean_model',        &
    'wdian_salt_kpp_nloc', Grd%tracer_axes(1:3), Time%model_time,     &
    'salt related dianeutral mass transport due to KPP nonlocal term',&
    'kg/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_wdian_salt_kpp_nloc > 0) compute_watermass_diag=.true.

  id_tform_salt_kpp_nloc = register_diag_field ('ocean_model',                           &  
    'tform_salt_kpp_nloc', Grd%tracer_axes(1:3), Time%model_time,                        &
    'salt related watermass transform due to KPP nonlocal on levels (pre-layer binning)',&
    'kg/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_tform_salt_kpp_nloc > 0) compute_watermass_diag=.true.

  id_neut_salt_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                                &
    'neut_salt_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                        &
    'salt related update of locally ref potrho from KPP nolocal as binned to neutral density layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_salt_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_salt_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                               &
    'wdian_salt_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
    'salt related dianeutral mass transport due to KPP nonlocal as binned to neutral density layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_salt_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_salt_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                         &
    'tform_salt_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                 &
    'salt related watermass transform due to KPP nonlocal as binned to neutral density layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_salt_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.


  if(compute_watermass_diag) then 
    write(stdoutunit,'(/a/)') &
    '==>Note: running ocean_vert_kpp_mod w/ compute_watermass_diag=.true.'  
  endif 

end subroutine watermass_diag_init
! </SUBROUTINE> NAME="watermass_diag_init"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag">
!
! <DESCRIPTION>
! Diagnose effects from KPP nonlocal on the watermass transformation.
! </DESCRIPTION>
!
subroutine watermass_diag(Time, T_prog, Dens)

  type(ocean_time_type),          intent(in) :: Time
  type(ocean_prog_tracer_type),   intent(in) :: T_prog(:)
  type(ocean_density_type),       intent(in) :: Dens

  integer :: i,j,k,tau
  real, dimension(isd:ied,jsd:jed) :: eta_tend

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_vert_kpp (watermass_diag): module needs initialization ')
  endif 

  if(.not. compute_watermass_diag) return 

  tau = Time%tau

  ! rho diagnostics = sum of temp and salt contributions  
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodT(i,j,k)*T_prog(index_temp)%wrk1(i,j,k) &
                        +Dens%drhodS(i,j,k)*T_prog(index_salt)%wrk1(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
           wrk5(i,j,k) =-wrk1(i,j,k)/(epsln+Dens%rho(i,j,k,tau)**2)  ! for eta_tend 
        enddo
     enddo
  enddo
  call diagnose_3d(Time, Grd, id_neut_rho_kpp_nloc, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_kpp_nloc, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_kpp_nloc, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_kpp_nloc_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_kpp_nloc_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_kpp_nloc_on_nrho, wrk4)

  if(id_eta_tend_kpp_nloc > 0 .or. id_eta_tend_kpp_nloc_glob > 0) then
      eta_tend(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               eta_tend(i,j) = eta_tend(i,j) + wrk5(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_eta_tend_kpp_nloc, eta_tend(:,:))
      call diagnose_sum(Time, Grd, Dom, id_eta_tend_kpp_nloc_glob, eta_tend, cellarea_r)
  endif


  ! temp related contribution  
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodT(i,j,k)*T_prog(index_temp)%wrk1(i,j,k) 
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo
  call diagnose_3d(Time, Grd, id_neut_temp_kpp_nloc, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_kpp_nloc, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_temp_kpp_nloc, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_kpp_nloc_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_kpp_nloc_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_kpp_nloc_on_nrho, wrk4)

  ! salt related contribution  
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodS(i,j,k)*T_prog(index_salt)%wrk1(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo
  call diagnose_3d(Time, Grd, id_neut_salt_kpp_nloc, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_kpp_nloc, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_salt_kpp_nloc, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_kpp_nloc_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_kpp_nloc_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_kpp_nloc_on_nrho, wrk4)

end subroutine watermass_diag
! </SUBROUTINE>  NAME="watermass_diag"


end module ocean_vert_kpp_test_mod

module atmos_convection_tracer_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Richard Hemler
! </CONTACT>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!                    
! </REVIEWER>


! <OVERVIEW>
!     This code allows the incorporation of an arbitrarily-specified   
!     tracer for testing within the donner_deep module.
!
!    This module is to serve as a testbed for assessing convective 
!    transport of tracers. 
! </OVERVIEW>

! <DESCRIPTION>
!   This module presents an implementation of an arbirary tracer, 
!   including its convective transport by the donner_deep module.
! </DESCRIPTION>

!-----------------------------------------------------------------------

use              fms_mod,       only : file_exist, &
                                       write_version_number, &
                                       error_mesg, &
                                       FATAL,WARNING,NOTE, &
                                       mpp_pe, mpp_root_pe, stdlog
use     time_manager_mod,       only : time_type
use     diag_manager_mod,       only : send_data,            &
                                       register_static_field
use   tracer_manager_mod,       only : get_tracer_index
use    field_manager_mod,       only : MODEL_ATMOS
use atmos_tracer_utilities_mod, only : wet_deposition,       &
                                       dry_deposition


implicit none
private
!-----------------------------------------------------------------------
!----- interfaces -------

public  atmos_cnvct_tracer_sourcesink,  &
        atmos_convection_tracer_init,        &
        atmos_convection_tracer_end

!-----------------------------------------------------------------------
!----------- namelist -------------------

integer  :: ncopies_cnvct_trcr = 9

namelist /atmos_convection_tracer_nml/  &
                                        ncopies_cnvct_trcr

!-----------------------------------------------------------------------

!--- Arrays to help calculate tracer sources/sinks ---

character(len=6), parameter :: module_name = 'tracer'


!--- identification numbers for  diagnostic fields and axes ----

integer :: id_emiss

logical :: module_is_initialized=.FALSE.


!---- version number -----
character(len=128) :: version = '$Id: atmos_convection_tracer.F90,v 19.0 2012/01/06 20:30:16 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
!-----------------------------------------------------------------------

contains


!#######################################################################
!<SUBROUTINE NAME="atmos_cnvct_tracer_sourcesink">
!<OVERVIEW>
! The routine that calculate the sources and sinks of the 
! convection tracer.
!</OVERVIEW>
!<DESCRIPTION>
! This is an implementation of an arbitrarily-specified tracer.
! At this time it is assumed to have no source or sink.
!
!</DESCRIPTION>
!<TEMPLATE>
!call atmos_cnvct_tracer_sourcesink (lon, lat, land, pwt, convtr, 
!                                         convtr_dt, Time, is, ie, 
!                                         js, je, kbot)
!</TEMPLATE>
!   <IN NAME="lon" TYPE="real" DIM="(:,:)">
!     Longitude of the centre of the model gridcells
!   </IN>
!   <IN NAME="lat" TYPE="real" DIM="(:,:)">
!     Latitude of the centre of the model gridcells
!   </IN>
!   <IN NAME="land" TYPE="real" DIM="(:,:)">
!     Land/sea mask.
!   </IN>
!   <IN NAME="pwt" TYPE="real" DIM="(:,:,:)">
!     The pressure weighting array. = dP/grav
!   </IN>
!   <IN NAME="convtr" TYPE="real" DIM="(:,:,:)">
!     The array of the convection tracer mixing ratio.
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="is, ie, js, je" TYPE="integer">
!     Local domain boundaries.
!   </IN>
!   <IN NAME="kbot" TYPE="integer, optional" DIM="(:,:)">
!     Integer array describing which model layer intercepts the surface.
!   </IN>

!   <OUT NAME="convtr_dt" TYPE="real" DIM="(:,:,:)">
!     The array of the tendency of the convection tracer mixing ratio.
!   </OUT>
 subroutine atmos_cnvct_tracer_sourcesink (lon, lat, land, pwt,&
                                                convtr, convtr_dt,  &
                                                Time, is, ie, js, je, &
                                                kbot)

!-----------------------------------------------------------------------
   real, intent(in),  dimension(:,:)   :: lon, lat
   real, intent(in),  dimension(:,:)   :: land
   real, intent(in),  dimension(:,:,:) :: pwt, convtr
   real, intent(out), dimension(:,:,:) :: convtr_dt
     type(time_type), intent(in) :: Time     
   integer,           intent(in)       :: is, ie, js, je
integer, intent(in),  dimension(:,:), optional :: kbot
!-----------------------------------------------------------------------
   real, dimension(size(convtr,1),size(convtr,2),size(convtr,3)) ::  &
         source, sink
!-----------------------------------------------------------------------


!------  define source and sink of convection_tracer -------
!
!   it is currently assumed that the convection tracer has no source
!   or sink

      source = 0.
      sink   = 0.

!------- tendency ------------------

      convtr_dt = source + sink
      

!-----------------------------------------------------------------------

 end subroutine atmos_cnvct_tracer_sourcesink
!</SUBROUTINE>

!#######################################################################

!<SUBROUTINE NAME="atmos_convection_tracer_init">
!<OVERVIEW>
! The constructor routine for the convection tracer module.
!</OVERVIEW>
!<DESCRIPTION>
! A routine to initialize the convection tracer module.
!</DESCRIPTION>
!<TEMPLATE>
!call convection_tracer_init (r, phalf, mask, axes, Time)
!</TEMPLATE>
!   <INOUT NAME="r" TYPE="real" DIM="(:,:,:,:)">
!     Tracer fields dimensioned as (nlon,nlat,nlev,ntrace). 
!   </INOUT>
!   <IN NAME="phalf" TYPE="real" DIM="(:,:,:)">
!      pressure at model interface levels
!   </IN>
!   <IN NAME="mask" TYPE="real, optional" DIM="(:,:,:)">
!      optional mask (0. or 1.) that designates which grid points
!           are above (=1.) or below (=0.) the ground dimensioned as
!           (nlon,nlat,nlev).
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="axes" TYPE="integer" DIM="(4)">
!     The axes relating to the tracer array dimensioned as
!      (nlon, nlat, nlev, ntime)
!   </IN>
 subroutine atmos_convection_tracer_init (r, phalf, axes, Time, &
                                          nconvect, mask)

!-----------------------------------------------------------------------
!
!   r    = tracer fields dimensioned as (nlon,nlat,nlev,ntrace)
!   mask = optional mask (0. or 1.) that designates which grid points
!          are above (=1.) or below (=0.) the ground dimensioned as
!          (nlon,nlat,nlev).
!
!-----------------------------------------------------------------------
real,             intent(inout), dimension(:,:,:,:) :: r
real,             intent(in),    dimension(:,:,:)   :: phalf
type(time_type),  intent(in)                        :: Time
integer,          intent(in)                        :: axes(4)
integer, dimension(:), pointer                         :: nconvect
real, intent(in), dimension(:,:,:), optional        :: mask

integer :: n
character(len=64) ::  search_name (10)
character(len=4) ::  chname
integer :: nn
!
!-----------------------------------------------------------------------
!
      real, dimension (size(r,1), size(r,2), size(r,3)) :: xgcm, pfull

      real :: xba = 1.0
      integer :: nlev, k, logunit
      character(len=64) :: filename

      nlev = size(r,3)

!---------------------------------------------------------------------
      if (module_is_initialized) return

!---- write namelist ------------------

      call write_version_number(version, tagname)
      logunit=stdlog()
      if ( mpp_pe() == mpp_root_pe() ) &
        write ( logunit, nml=atmos_convection_tracer_nml )

!----- set initial value of convection tracer ------------

       if (ncopies_cnvct_trcr > 9) then
         call error_mesg ('atmos_convection_tracer_mod', &
         'currently no more than 9 copies of the convection tracer '//&
                                             'are allowed', FATAL)
       endif
       allocate (nconvect(ncopies_cnvct_trcr))
       nconvect = -1
 
       
        do nn=1,ncopies_cnvct_trcr
          write (chname,'(i1)') nn
          if (nn > 1) then
          search_name(nn) = 'cnvct_trcr_'// trim(chname)
          else
          search_name(nn) = 'cnvct_trcr'
          endif

       n = get_tracer_index(MODEL_ATMOS,search_name(nn) )
       if (n>0) then
         nconvect(nn)=n
         if (nconvect(nn) > 0 .and. mpp_pe() == mpp_root_pe()) write (*,30) trim(search_name(nn))  ,nconvect(nn)
         if (nconvect(nn) > 0 .and. mpp_pe() == mpp_root_pe()) write (logunit,30) trim(search_name(nn))  ,nconvect(nn)
       endif

      end do

  30        format (A,' was initialized as tracer number ',i2)
!

! Register a static field for the emissions of your tracer
     id_emiss = register_static_field ( 'tracers',                    &
                     'rnemiss', axes(1:2),       &
                     'rnemiss', 'g/m2/s')

!---------------------------------------------------------------------
!    if a convection_tracer.res file exists, it will have been prev-
!    iously processed. there is no need to do anything here.
!---------------------------------------------------------------------
      do nn = 1, ncopies_cnvct_trcr 
        if (nconvect(nn) > 0) then
          filename = 'INPUT/tracer_' //trim(search_name(nn)) // '.res'
          if (file_exist (filename)) then

!--------------------------------------------------------------------
!    if a .res file does not exist, initialize the convection_tracer.
!--------------------------------------------------------------------
          else   
            do k=1, nlev
              pfull(:,:,k) = 0.5*(phalf(:,:,k) + phalf(:,:,k+1))
            end do
            do k=1,nlev
              xgcm(:,:,k) = xba*  &
                           exp((pfull(:,:,k) - pfull(:,:,1))/       &
                               (pfull(:,:,1) - pfull(:,:,nlev)))
            end do
            do k=1,nlev
              r(:,:,nlev+1-k, nconvect(nn)) = xgcm(:,:,k)
            end do
          endif  ! (file_exist) 
        endif
      end do



      module_is_initialized = .TRUE.


!-----------------------------------------------------------------------

 end subroutine atmos_convection_tracer_init
!</SUBROUTINE>

!#######################################################################

!<SUBROUTINE NAME="atmos_convection_tracer_end">
!<OVERVIEW>
!  The destructor routine for the convection tracer module.
!</OVERVIEW>
! <DESCRIPTION>
! This subroutine marks the module as uninitialized and exits. 
! </DESCRIPTION>
!<TEMPLATE>
! call atmos_convection_tracer_end
!</TEMPLATE>
 subroutine atmos_convection_tracer_end
 
      module_is_initialized = .FALSE.

 end subroutine atmos_convection_tracer_end
!</SUBROUTINE>


end module atmos_convection_tracer_mod

module vert_advection_mod

!-------------------------------------------------------------------------------

use fms_mod, only: error_mesg, FATAL, write_version_number, stdout
use mpp_mod, only: mpp_sum, mpp_max            ,mpp_pe,mpp_sync

implicit none
private

public :: vert_advection, vert_advection_end
! for optional argument: scheme
integer, parameter, public :: SECOND_CENTERED          = 101
integer, parameter, public :: FOURTH_CENTERED          = 102
integer, parameter, public :: FINITE_VOLUME_LINEAR     = 103
integer, parameter, public :: FINITE_VOLUME_PARABOLIC  = 104
integer, parameter, public :: FINITE_VOLUME_PARABOLIC2 = 105
integer, parameter, public :: SECOND_CENTERED_WTS      = 106
integer, parameter, public :: FOURTH_CENTERED_WTS      = 107
integer, parameter, public :: VAN_LEER_LINEAR = FINITE_VOLUME_LINEAR
! for optional argument: form
integer, parameter, public :: FLUX_FORM = 201, ADVECTIVE_FORM = 202
! for optional argument: flags
integer, parameter, public :: WEIGHTED_TENDENCY=1
integer, parameter, public :: OUTFLOW_BOUNDARY=2

character(len=128), parameter :: version = '$Id: vert_advection.F90,v 17.0 2009/07/21 03:00:04 fms Exp $'
character(len=128), parameter :: tagname = '$Name: tikal $'

logical :: module_is_initialized = .false.

interface vert_advection
   module procedure vert_advection_1d, vert_advection_2d, vert_advection_3d
end interface

! buffers for coefficients used by the parabolic scheme
  real, allocatable :: zwts(:,:,:,:), dzs(:,:,:)
  integer :: nlons = 0, nlats = 0, nlevs = 0

! for cfl diagnostics with finite volume schemes
  real    :: cflmaxc = 0.
  real    :: cflmaxx = 0.
  integer :: cflerr  = 0

contains

!-------------------------------------------------------------------------------

 subroutine vert_advection_3d ( dt, w, dz, r, rdt, mask, scheme, form, flags )

 real, intent(in)                    :: dt
 real, intent(in),  dimension(:,:,:) :: w, dz, r
 real, intent(out), dimension(:,:,:) :: rdt
 real,    intent(in), optional :: mask(:,:,:)
 integer, intent(in), optional :: scheme, form, flags

! INPUT
!   dt  = time step in seconds
!   w   = advecting velocity at the vertical boundaries of the grid boxes
!         does not assume velocities at top and bottom are zero
!         units = [units of dz / second]
!   dz  = depth of model layers in arbitrary units (usually pressure)
!   r   = advected quantity in arbitrary units
!
! OUTPUT
!   rdt = advective tendency for quantity "r" (units depend on optional flags argument)
!           the default units = [units of r / second]
!           if flags=WEIGHTED_TENDENCY then units = [units of r * units of dz / second]
!
! OPTIONAL INPUT
!   mask   = mask for below ground layers,
!            where mask > 0 for layers above ground
!   scheme = differencing scheme, use one of these values:
!               SECOND_CENTERED = second-order centered
!               FOURTH_CENTERED = fourth-order centered
!               SECOND_CENTERED_WTS = second-order centered (assuming unequal level spacing)
!               FOURTH_CENTERED_WTS = fourth-order centered (assuming unequal level spacing)
!               FINITE_VOLUME_LINEAR    = piecewise linear, finite volume (van Leer)
!               VAN_LEER_LINEAR         = same as FINITE_VOLUME_LINEAR
!               FINITE_VOLUME_PARABOLIC = piecewise parabolic, finite volume (PPM)
!               FINITE_VOLUME_PARABOLIC2 = piecewise parabolic, finite volume (PPM)
!                                          using relaxed montonicity constraint (Lin,2003)
!   form   = form of equations, use one of these values:
!               FLUX_FORM      = solves for -d(wr)/dt
!               ADVECTIVE_FORM = solves for -w*d(r)/dt
!   flags  = additional optional flags
!               WEIGHTED_TENDENCY = output tendency (rdt) has units = [units of r * units of dz / second]
!               OUTFLOW_BOUNDARY  = advection is computed at the top and bottom for outflow boundaries
!                                   this option is only valid for finite volume schemes
!
! NOTE
!   size(w,3) == size(dz,3)+1 == size(r,3)+1 == size(rdt,3)+1 == size(mask,3)+1

 real, dimension(size(r,1),size(r,2),size(r,3)) :: slp, r_left, r_right
 real, dimension(size(w,1),size(w,2),size(w,3)) :: flux
 real, dimension(0:3,size(r,1),size(r,2),size(r,3)) :: zwt
 real    :: xx, a, b, rm, r6, rst, wt
 real    :: tt, c1, c2
 real    :: small = 1.e-6
 logical :: test_1
 logical :: do_weighted_dt, do_outflow_bnd
 integer :: i, j, k, ks, ke, kstart, kend, iflags
 integer :: diff_scheme, eqn_form

 real :: cn, rsum, dzsum, dtw
 integer :: kk

 if(.not.module_is_initialized) then
   call write_version_number(version, tagname)
   module_is_initialized = .true.
 endif

 ! set default values for optional arguments
   diff_scheme = VAN_LEER_LINEAR
   eqn_form    = FLUX_FORM
   if (present(scheme)) diff_scheme = scheme
   if (present(form))   eqn_form    = form
 ! set optional flags
   iflags = 0; if (present(flags)) iflags = flags
   do_weighted_dt = btest(iflags,0)
   do_outflow_bnd = btest(iflags,1)
   

 ! note: size(r,3)+1 = size(w,3)
   if (size(w,3) /= size(r,3)+1) &
      call error_handler ('vertical dimension of input arrays inconsistent')

 ! vertical indexing
   ks = 1; ke = size(r,3)

 ! start and end indexing for finite volume fluxes
   kstart = ks+1;  kend = ke
   if (do_outflow_bnd) then
       kstart = ks;  kend = ke+1
   endif

 ! set fluxes at boundaries
 ! most likely w = 0 at these points
 ! but for outflow boundaries set flux to zero

   if (do_outflow_bnd) then
       flux(:,:,ks)   = 0.
       flux(:,:,ke+1) = 0.
   else
       flux(:,:,ks)   = w(:,:,ks)  *r(:,:,ks)
       flux(:,:,ke+1) = w(:,:,ke+1)*r(:,:,ke)
   endif

   select case (diff_scheme)

   !------ 2nd-order centered scheme assuming variable grid spacing ------
      case (SECOND_CENTERED_WTS)
         do k = ks+1, ke
         do j = 1, size(r,2)
         do i = 1, size(r,1)
            wt = dz(i,j,k-1)/(dz(i,j,k-1)+dz(i,j,k))
            rst = r(i,j,k-1) + wt*(r(i,j,k)-r(i,j,k-1))
            flux(i,j,k) = w(i,j,k)*rst
         enddo
         enddo
         enddo

   !------ 2nd-order centered scheme assuming uniform grid spacing ------
      case (SECOND_CENTERED)
         do k = ks+1, ke
         do j = 1, size(r,2)
         do i = 1, size(r,1)
            rst = 0.5*(r(i,j,k)+r(i,j,k-1))
            flux(i,j,k) = w(i,j,k)*rst
         enddo
         enddo
         enddo

   !------ 4th-order centered scheme assuming variable grid spacing ------
      case (FOURTH_CENTERED_WTS)
         call compute_weights ( dz, zwt )
         call slope_z ( r, dz, slp, limit=.false., linear=.false. )
         if (present(mask)) then
          ! second order if adjacent to ground
            do k = ks+2, ke-1
            do j = 1, size(r,2)
            do i = 1, size(r,1)
               if (mask(i,j,k+1) > small) then
                  rst = r(i,j,k-1) + zwt(1,i,j,k)*(r(i,j,k)-r(i,j,k-1)) &
                        - zwt(2,i,j,k)*slp(i,j,k) + zwt(3,i,j,k)*slp(i,j,k-1)
               else
                  rst = r(i,j,k-1) + zwt(0,i,j,k)*(r(i,j,k)-r(i,j,k-1))
               endif
            flux(i,j,k) = w(i,j,k)*rst
            enddo
            enddo
            enddo
         else
          ! no mask: always fourth order
            do k = ks+2, ke-1
            do j = 1, size(r,2)
            do i = 1, size(r,1)
               rst = r(i,j,k-1) + zwt(1,i,j,k)*(r(i,j,k)-r(i,j,k-1)) &
                        - zwt(2,i,j,k)*slp(i,j,k) + zwt(3,i,j,k)*slp(i,j,k-1)
               flux(i,j,k) = w(i,j,k)*rst
            enddo
            enddo
            enddo
         endif
         ! second order at top and bottom
         do j = 1, size(r,2)
         do i = 1, size(r,1)
            wt  = dz(i,j,ks)/(dz(i,j,ks)+dz(i,j,ks+1))
            rst = r(i,j,ks) + wt*(r(i,j,ks+1)-r(i,j,ks))
            flux(i,j,ks+1) = w(i,j,ks+1)*rst
            wt  = dz(i,j,ke-1)/(dz(i,j,ke-1)+dz(i,j,ke))
            rst = r(i,j,ke-1) + wt*(r(i,j,ke)-r(i,j,ke-1))
            flux(i,j,ke) = w(i,j,ke)*rst
         enddo
         enddo

   !------ 4th-order centered scheme assuming uniform grid spacing ------
      case (FOURTH_CENTERED)
         c1 = 7./12.;  c2 = 1./12.
         if (present(mask)) then
          ! second order if adjacent to ground
            do k = ks+2, ke-1
            do j = 1, size(r,2)
            do i = 1, size(r,1)
               if (mask(i,j,k+1) > small) then
                  rst = c1*(r(i,j,k)+r(i,j,k-1)) - c2*(r(i,j,k+1)+r(i,j,k-2))
               else
                  rst = 0.5*(r(i,j,k)+r(i,j,k-1))
               endif
               flux(i,j,k) = w(i,j,k)*rst
            enddo
            enddo
            enddo
         else
          ! no mask: always fourth order
            do k = ks+2, ke-1
            do j = 1, size(r,2)
            do i = 1, size(r,1)
               rst = c1*(r(i,j,k)+r(i,j,k-1)) - c2*(r(i,j,k+1)+r(i,j,k-2))
               flux(i,j,k) = w(i,j,k)*rst
            enddo
            enddo
            enddo
         endif
         ! second order at top and bottom
         do j = 1, size(r,2)
         do i = 1, size(r,1)
            rst = 0.5*(r(i,j,ks+1)+r(i,j,ks  ))
            flux(i,j,ks+1) = w(i,j,ks+1)*rst
            rst = 0.5*(r(i,j,ke  )+r(i,j,ke-1))
            flux(i,j,ke) = w(i,j,ke)*rst
         enddo
         enddo

   !------ finite volume scheme using piecewise linear method ------
      case (FINITE_VOLUME_LINEAR)
       ! slope along the z-axis
         call slope_z ( r, dz, slp )
         do k = kstart, kend
         do j = 1, size(r,2)
         do i = 1, size(r,1)
            if (w(i,j,k) >= 0.) then
               if (k == ks) cycle ! inflow
               cn = dt*w(i,j,k)/dz(i,j,k-1)
               rst = r(i,j,k-1) + 0.5*slp(i,j,k-1)*(1.-cn)
            else
               if (k == ke+1) cycle ! inflow
               cn = -dt*w(i,j,k)/dz(i,j,k)
               rst = r(i,j,k  ) - 0.5*slp(i,j,k  )*(1.-cn)
            endif
            flux(i,j,k) = w(i,j,k)*rst
            if (cn > 1.) cflerr = cflerr+1
            cflmaxc = max(cflmaxc,cn)
            cflmaxx = cflmaxc ! same for linear scheme
         enddo
         enddo
         enddo

   !------ finite volume scheme using piecewise parabolic method (PPM) ------
      case (FINITE_VOLUME_PARABOLIC:FINITE_VOLUME_PARABOLIC2)
         call compute_weights ( dz, zwt )
         call slope_z ( r, dz, slp, linear=.false. )
         do k = ks+2, ke-1
         do j = 1, size(r,2)
         do i = 1, size(r,1)
            r_left(i,j,k) = r(i,j,k-1) + zwt(1,i,j,k)*(r(i,j,k)-r(i,j,k-1)) &
                   - zwt(2,i,j,k)*slp(i,j,k) + zwt(3,i,j,k)*slp(i,j,k-1)        
            r_right(i,j,k-1) = r_left(i,j,k)
            ! coming out of this loop, all we need is r_left and r_right
         enddo
         enddo
         enddo

         ! boundary values  ! masks ???????

         do j = 1, size(r,2)
         do i = 1, size(r,1)
           r_left (i,j,ks+1) = r(i,j,ks+1) - 0.5*slp(i,j,ks+1)
           r_right(i,j,ke-1) = r(i,j,ke-1) + 0.5*slp(i,j,ke-1)

         ! pure upstream advection near boundary
         ! r_left (i,j,ks) = r(i,j,ks)
         ! r_right(i,j,ks) = r(i,j,ks)
         ! r_left (i,j,ke) = r(i,j,ke)
         ! r_right(i,j,ke) = r(i,j,ke)

         ! make linear assumption near boundary
         ! NOTE: slope is zero at ks and ks therefore
         !       this reduces to upstream advection near boundary
           r_left (i,j,ks) = r(i,j,ks) - 0.5*slp(i,j,ks)
           r_right(i,j,ks) = r(i,j,ks) + 0.5*slp(i,j,ks)
           r_left (i,j,ke) = r(i,j,ke) - 0.5*slp(i,j,ke)
           r_right(i,j,ke) = r(i,j,ke) + 0.5*slp(i,j,ke)
         enddo
         enddo

     ! monotonicity constraint

       if (diff_scheme == FINITE_VOLUME_PARABOLIC2) then
         ! limiters from Lin (2003), Equation 6 (relaxed constraint)
           do k = ks, ke
           do j = 1, size(r,2)
           do i = 1, size(r,1)
              r_left (i,j,k) = r(i,j,k) - sign( min(abs(slp(i,j,k)),abs(r_left (i,j,k)-r(i,j,k))), slp(i,j,k) )
              r_right(i,j,k) = r(i,j,k) + sign( min(abs(slp(i,j,k)),abs(r_right(i,j,k)-r(i,j,k))), slp(i,j,k) )
           enddo
           enddo
           enddo
       else
         ! limiters from Colella and Woodward (1984), Equation 1.10
           do k = ks, ke
           do j = 1, size(r,2)
           do i = 1, size(r,1)
              test_1 = (r_right(i,j,k)-r(i,j,k))*(r(i,j,k)-r_left(i,j,k)) <= 0.0
              if (test_1) then
                 r_left(i,j,k)  = r(i,j,k)
                 r_right(i,j,k) = r(i,j,k)
              endif
              if (k == ks .or. k == ke) cycle
              rm = r_right(i,j,k) - r_left(i,j,k)
              a = rm*(r(i,j,k) - 0.5*(r_right(i,j,k) + r_left(i,j,k)))
              b = rm*rm/6.
              if (a >  b) r_left (i,j,k) = 3.0*r(i,j,k) - 2.0*r_right(i,j,k)
              if (a < -b) r_right(i,j,k) = 3.0*r(i,j,k) - 2.0*r_left (i,j,k)
           enddo
           enddo
           enddo
       endif

         ! compute fluxes at interfaces

           tt = 2./3.
           do k = kstart, kend
           do j = 1, size(r,2)
           do i = 1, size(r,1)
              if (w(i,j,k) >= 0.) then
                  if (k == ks) cycle ! inflow
                  cn = dt*w(i,j,k)/dz(i,j,k-1)
                  kk = k-1
                  ! extension for Courant numbers > 1
                  if (cn > 1.) then
                      rsum = 0.
                      dzsum = 0.
                      dtw = dt*w(i,j,k)
                      do while (dzsum+dz(i,j,kk) < dtw)
                         if (kk == 1) then
                             exit
                         endif
                         dzsum = dzsum + dz(i,j,kk)
                          rsum =  rsum +  r(i,j,kk)
                         kk = kk-1
                      enddo
                      xx = (dtw-dzsum)/dz(i,j,kk)
                  else
                      xx = cn
                  endif
                  rm = r_right(i,j,kk) - r_left(i,j,kk)
                  r6 = 6.0*(r(i,j,kk) - 0.5*(r_right(i,j,kk) + r_left(i,j,kk)))
                  if (kk == ks) r6 = 0.
                  rst = r_right(i,j,kk) - 0.5*xx*(rm - (1.0 - tt*xx)*r6)
                  ! extension for Courant numbers > 1
                  if (cn > 1.) rst = (xx*rst + rsum)/cn
              else
                  if (k == ke+1) cycle ! inflow
                  cn = - dt*w(i,j,k)/dz(i,j,k)
                  kk = k
                  ! extension for Courant numbers > 1
                  if (cn > 1.) then
                      rsum = 0.
                      dzsum = 0.
                      dtw = -dt*w(i,j,k)
                      do while (dzsum+dz(i,j,kk) < dtw)
                         if (kk == ks) then
                             exit
                         endif
                         dzsum = dzsum + dz(i,j,kk)
                          rsum =  rsum +  r(i,j,kk)
                         kk = kk+1
                      enddo
                      xx = (dtw-dzsum)/dz(i,j,kk)
                  else
                      xx = cn
                  endif
                  rm = r_right(i,j,kk) - r_left(i,j,kk)
                  r6 = 6.0*(r(i,j,kk) - 0.5*(r_right(i,j,kk) + r_left(i,j,kk)))
                  if (kk == ke) r6 = 0.
                  rst = r_left(i,j,kk) + 0.5*xx*(rm + (1.0 - tt*xx)*r6)
                  ! extension for Courant numbers > 1
                  if (cn > 1.) rst = (xx*rst + rsum)/cn
              endif
              flux(i,j,k) = w(i,j,k)*rst
              if (xx > 1.) cflerr = cflerr+1
              cflmaxx = max(cflmaxx,xx)
              cflmaxc = max(cflmaxc,cn)
           enddo
           enddo
           enddo


      case default
        ! ERROR
          call error_handler ('invalid value for optional argument scheme')
   end select


 ! vertical advective tendency

   select case (eqn_form)
      case (FLUX_FORM)
         if (do_weighted_dt) then
            do k = ks, ke
               rdt (:,:,k) = - (flux(:,:,k+1) - flux (:,:,k)) 
            enddo
         else
            do k = ks, ke
               rdt (:,:,k) = - (flux(:,:,k+1) - flux (:,:,k))  / dz(:,:,k)
            enddo
         endif
      case (ADVECTIVE_FORM)
         if (do_weighted_dt) then
            do k = ks, ke
               rdt (:,:,k) = - (flux(:,:,k+1) - flux (:,:,k) - &
                            r(:,:,k)*(w(:,:,k+1)-w(:,:,k)))
            enddo
         else
            do k = ks, ke
               rdt (:,:,k) = - (flux(:,:,k+1) - flux (:,:,k) - &
                            r(:,:,k)*(w(:,:,k+1)-w(:,:,k))) / dz(:,:,k)
            enddo
         endif
      case default
        ! ERROR
          call error_handler ('invalid value for optional argument form')
   end select


 end subroutine vert_advection_3d

!-------------------------------------------------------------------------------

 subroutine vert_advection_end

  integer :: outunit
  ! deallocate storage
    if (allocated(zwts)) deallocate(zwts)
    if (allocated(dzs))  deallocate(dzs)

  ! cfl diagnostics
    call mpp_max (cflmaxc)
    call mpp_max (cflmaxx)
    call mpp_sum (cflerr) ! integer sum
    if (cflmaxc > 0.) then
        outunit = stdout()
        write (outunit,10) cflmaxc, cflmaxx, cflerr
    endif
 10 format (/,' Vertical advection (atmosphere):',    &
            /,'     maximum CFL =',f10.6,'; ',f10.6,  &
            /,'     number of CFL errors =',i5,/)
        
 end subroutine vert_advection_end

!-------------------------------------------------------------------------------

 subroutine slope_z ( r, dz, slope, limit, linear )
 real, intent(in),  dimension(:,:,:) :: r, dz
 real, intent(out), dimension(:,:,:) :: slope
 logical, intent(in), optional :: limit, linear

!real    :: grad(size(r,1),size(r,2),2:size(r,3))
 real    :: grad(2:size(r,3))
 real    :: rmin, rmax
 integer :: i, j, k, n
 logical :: limiters, dolinear

  limiters = .true.
  if (present(limit))  limiters = limit
  dolinear = .true.
  if (present(linear)) dolinear = linear

  n = size(r,3)

! compute slope (weighted for unequal levels)

  do j = 1, size(r,2)
  do i = 1, size(r,1)

     do k = 2, n
       grad(k) = (r(i,j,k)-r(i,j,k-1))/(dz(i,j,k)+dz(i,j,k-1))
     enddo
     if (dolinear) then
         do k = 2, n-1
           slope(i,j,k) = (grad(k+1)+grad(k))*dz(i,j,k)
         enddo
     else
         do k = 2, n-1
           slope(i,j,k) = (grad(k+1)*(2.*dz(i,j,k-1)+dz(i,j,k)) + &
                           grad(k  )*(2.*dz(i,j,k+1)+dz(i,j,k)))  &
                          *dz(i,j,k)/(dz(i,j,k-1)+dz(i,j,k)+dz(i,j,k+1))
         enddo
     endif
     slope(i,j,1) = 2.*grad(2)*dz(i,j,1)
     slope(i,j,n) = 2.*grad(n)*dz(i,j,n)

   ! apply limiters to slope
     if (limiters) then
        do k = 1, n
          if (k >= 2 .and. k <= n-1) then
            rmin = min(r(i,j,k-1), r(i,j,k), r(i,j,k+1))
            rmax = max(r(i,j,k-1), r(i,j,k), r(i,j,k+1))
            slope(i,j,k) = sign(1.,slope(i,j,k)) *  &
                   min( abs(slope(i,j,k)), 2.*(r(i,j,k)-rmin), 2.*(rmax-r(i,j,k)) )
          else
         !else if (k == 1) then               ! always slope=0
         !  rmin = min(r(i,j,k), r(i,j,k+1))
         !  rmax = max(r(i,j,k), r(i,j,k+1))
         !else if (k == n) then
         !  rmin = min(r(i,j,k-1), r(i,j,k))
         !  rmax = max(r(i,j,k-1), r(i,j,k))
            slope(i,j,k) = 0.
          endif
        enddo
     endif

  enddo
  enddo

 end subroutine slope_z

!-------------------------------------------------------------------------------

 subroutine compute_weights ( dz, zwt )
 real, intent(in),  dimension(:,:,:)    :: dz
 real, intent(out), dimension(0:,:,:,:) :: zwt
 real    :: denom1, denom2, denom3, denom4, num3, num4, x, y
 integer :: i, j, k
 logical :: redo

! check the size of stored coefficients
! need to reallocate if size has changed
   if (nlons /= size(dz,1) .or. nlats /= size(dz,2) .or.  nlevs /= size(dz,3)) then
      if (allocated(zwts)) deallocate(zwts)
      if (allocated(dzs))  deallocate(dzs)
      nlons = size(dz,1)
      nlats = size(dz,2)
      nlevs = size(dz,3)
      allocate (zwts(0:3,nlons,nlats,nlevs))
      allocate (dzs (nlons,nlats,nlevs))
      dzs = -1.
   endif
   
! coefficients/weights for computing values at grid box interfaces
! only recompute coefficients for a column when layer depth has changed

   do j = 1, size(dz,2)
   do i = 1, size(dz,1)

    redo = .false.
    do k=1,size(dz,3)
      if (dz(i,j,k) /= dzs(i,j,k)) then
        redo = .true.
        exit
      endif
    enddo

   if (redo) then
     do k = 3, size(dz,3)-1
       denom1 = 1.0/(dz(i,j,k-1) + dz(i,j,k))
       denom2 = 1.0/(dz(i,j,k-2) + dz(i,j,k-1) + dz(i,j,k) + dz(i,j,k+1))
       denom3 = 1.0/(2*dz(i,j,k-1) +   dz(i,j,k))  
       denom4 = 1.0/(  dz(i,j,k-1) + 2*dz(i,j,k))  
       num3   = dz(i,j,k-2) + dz(i,j,k-1)          
       num4   = dz(i,j,k)   + dz(i,j,k+1)        
       x      = num3*denom3 - num4*denom4        
       y      = 2.0*dz(i,j,k-1)*dz(i,j,k) ! everything up to this point is just
                                          ! needed to compute x1,x1,x3                      
       zwt(0,i,j,k) = dz(i,j,k-1)*denom1                ! = 1/2 in equally spaced case
       zwt(1,i,j,k) = zwt(0,i,j,k) + x*y*denom1*denom2  ! = 1/2 in equally spaced case
       zwt(2,i,j,k) = dz(i,j,k-1)*num3*denom3*denom2    ! = 1/6 ''
       zwt(3,i,j,k) = dz(i,j,k)*num4*denom4*denom2      ! = 1/6 ''
     enddo
     dzs(i,j,:) = dz(i,j,:)
     zwts(0:3,i,j,:) = zwt(0:3,i,j,:)
   else

   ! use previously computed coefficients
     zwt(0:3,i,j,:) = zwts(0:3,i,j,:)
   endif

   enddo
   enddo


 end subroutine compute_weights

!-------------------------------------------------------------------------------
!--------------------------- overloaded versions -------------------------------

 subroutine vert_advection_1d ( dt, w, dz, r, rdt, mask, scheme, form, flags )
 
 real, intent(in)                :: dt
 real, intent(in),  dimension(:) :: w, dz, r
 real, intent(out), dimension(:) :: rdt
 real,    intent(in), optional :: mask(:)
 integer, intent(in), optional :: scheme, form, flags

 real, dimension(1,1,size(r,1)) :: dz3, r3, rdt3, mask3
 real, dimension(1,1,size(w,1)) :: w3

  ! input
    w3 (1,1,:) = w
    dz3(1,1,:) = dz
    r3 (1,1,:) = r

    if (present(mask)) then
       mask3(1,1,:) = mask
       call vert_advection_3d ( dt, w3, dz3, r3, rdt3, mask=mask3, scheme=scheme, form=form, flags=flags )
    else
       call vert_advection_3d ( dt, w3, dz3, r3, rdt3, scheme=scheme, form=form, flags=flags )
    endif

  ! output
    rdt = rdt3(1,1,:)

 end subroutine vert_advection_1d

!-------------------------------------------------------------------------------

 subroutine vert_advection_2d ( dt, w, dz, r, rdt, mask, scheme, form, flags )

 real, intent(in)                  :: dt
 real, intent(in),  dimension(:,:) :: w, dz, r
 real, intent(out), dimension(:,:) :: rdt
 real,    intent(in), optional :: mask(:,:)
 integer, intent(in), optional :: scheme, form, flags

 real, dimension(size(r,1),1,size(r,2)) :: dz3, r3, rdt3, mask3
 real, dimension(size(w,1),1,size(w,2)) :: w3

  ! input
    w3 (:,1,:) = w
    dz3(:,1,:) = dz
    r3 (:,1,:) = r

    if (present(mask)) then
       mask3(:,1,:) = mask
       call vert_advection_3d ( dt, w3, dz3, r3, rdt3, mask=mask3, scheme=scheme, form=form, flags=flags )
    else
       call vert_advection_3d ( dt, w3, dz3, r3, rdt3, scheme=scheme, form=form, flags=flags )
    endif

  ! output
    rdt = rdt3(:,1,:)

 end subroutine vert_advection_2d

!-------------------------------------------------------------------------------

 subroutine error_handler ( message )
 character(len=*), intent(in) :: message

   call error_mesg ('vert_advection', trim(message), FATAL)

!  print *, 'FATAL ERROR in vert_advection'
!  print *, trim(message)
!  stop 111

 end subroutine error_handler

!-------------------------------------------------------------------------------

end module vert_advection_mod

module ocean_vert_util_mod
!
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S. M. Griffies 
! </CONTACT>
!
!<OVERVIEW>
! This module contains routines for use in vertical mixing. 
!</OVERVIEW>
!
!<DESCRIPTION>
! Routines for vertical mixing schemes. 
!</DESCRIPTION>
!
!<NAMELIST NAME="ocean_tracer_util_nml">
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging purposes.
!  </DATA> 
!
!  <DATA NAME="smooth_n2" TYPE="logical">
!  For vertical smoothing the N2 calculation for Richardson number.
!  Default smooth_n2 = .true.
!  </DATA> 
!  <DATA NAME="num_n2_smooth" TYPE="integer">
!  For vertical smoothing N2 for Richardson number.
!  Default num_n2_smooth = 1.
!  </DATA> 
!
!  <DATA NAME="smooth_ri_number" TYPE="logical">
!  For vertical smoothing richardson number.
!  Default smooth_ri_number = .true.
!  </DATA> 
!  <DATA NAME="num_ri_smooth" TYPE="integer">
!  For vertical smoothing richardson number.
!  Default num_ri_smooth = 1.
!  </DATA> 
!
!</NAMELIST>
!
use constants_mod,        only: epsln
use diag_manager_mod,     only: register_diag_field
use fms_mod,              only: open_namelist_file, check_nml_error, close_file
use mpp_mod,              only: input_nml_file, stdout, stdlog, FATAL
use mpp_mod,              only: mpp_error, mpp_pe, mpp_min, mpp_max
  
use ocean_density_mod,    only: density_delta_z
use ocean_domains_mod,    only: get_local_indices
use ocean_parameters_mod, only: missing_value, rho0r, rho0, grav, onehalf, onefourth
use ocean_types_mod,      only: ocean_grid_type, ocean_domain_type
use ocean_types_mod,      only: ocean_prog_tracer_type
use ocean_types_mod,      only: ocean_time_type, ocean_thickness_type 
use ocean_types_mod,      only: ocean_density_type, ocean_velocity_type
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3, wrk4, wrk5
use ocean_workspace_mod,  only: wrk1_v, wrk2_v
use ocean_util_mod,       only: diagnose_3d, diagnose_3d_u

implicit none

private

character(len=256) :: version='CVS $Id'
character(len=256) :: tagname='Tag $Name'

! for output
integer :: unit=6

#include <ocean_memory.h>
logical :: module_is_initialized  = .false.

! diagnostics 
logical :: used 
integer :: id_ri_num_dudz  =-1
integer :: id_ri_num_n2    =-1
integer :: id_ri_num_cgrid =-1
integer :: id_rit          =-1
integer :: id_riu          =-1

! nml parameters 

! for cgrid Richardson number calculation 
logical :: smooth_n2        = .true.
logical :: smooth_ri_number = .true.
integer :: num_n2_smooth    = 1 
integer :: num_ri_smooth    = 1 


! for debugging 
logical :: debug_this_module = .false. 


type(ocean_domain_type), pointer :: Dom =>NULL()
type(ocean_grid_type), pointer   :: Grd =>NULL()

public ocean_vert_util_init
public ri_for_cgrid
public ri_for_bgrid 

namelist /ocean_vert_util_nml/ debug_this_module, &
         smooth_n2, smooth_ri_number, num_n2_smooth, num_ri_smooth


contains


!#######################################################################
! <SUBROUTINE NAME="ocean_vert_util_init">
!
! <DESCRIPTION>
! Initialize vertical mixing utilities.
! </DESCRIPTION>
!
subroutine ocean_vert_util_init (Grid, Domain, Time)

  type(ocean_grid_type),   intent(in), target :: Grid
  type(ocean_domain_type), intent(in), target :: Domain
  type(ocean_time_type),   intent(in)         :: Time
  
  integer :: ioun, io_status, ierr
  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 


  if (module_is_initialized) then 
    call mpp_error(FATAL,&
    '==>Error in ocean_vert_util_mod (ocean_vert_util_init): module already initialized')
  endif 

  module_is_initialized = .true.
  stdlogunit=stdlog()
  write( stdlogunit,'(/a/)') trim(version)

  Dom => Domain
  Grd => Grid

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk=Grd%nk
#endif

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_vert_util_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_vert_util_nml')
#else
  ioun = open_namelist_file()
  read(ioun, ocean_vert_util_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_vert_util_nml')
  call close_file(ioun)
#endif
  write (stdlogunit, ocean_vert_util_nml)
  write (stdoutunit,'(/)')
  write (stdoutunit, ocean_vert_util_nml)


  id_ri_num_dudz = register_diag_field ('ocean_model', 'ri_num_dudz',                & 
     Grid%tracer_axes_wt(1:3), Time%model_time,                                      &
     '(du/dz)^2 for Richardson number computed on T-cell bottom using Cgrid routine',&
     '1/s^2', missing_value=missing_value, range=(/-1e1,1e15/))

  id_ri_num_n2 = register_diag_field ('ocean_model', 'ri_num_n2',              & 
     Grid%tracer_axes_wt(1:3), Time%model_time,                                &
     'N^2 for Richardson number computed on T-cell bottom using Cgrid routine',&
     '1/s^2', missing_value=missing_value, range=(/-1e15,1e15/))

  id_rit = register_diag_field ('ocean_model', 'rit',& 
     Grid%tracer_axes_wt(1:3), Time%model_time,      &
     'Richardson number computed on T-cell bottom',  &
     'dimensionless', missing_value=missing_value, range=(/-1e15,1e15/))

  id_riu = register_diag_field ('ocean_model', 'riu',& 
     Grid%tracer_axes_wt(1:3), Time%model_time,      &
     'Richardson number computed on U-cell bottom',  &
     'dimensionless', missing_value=missing_value, range=(/-1e15,1e15/))


end subroutine ocean_vert_util_init
! </SUBROUTINE> NAME="ocean_vert_util_init">


!#######################################################################
! <SUBROUTINE NAME="ri_for_bgrid">
!
! <DESCRIPTION>
!
! Compute Richardson number assuming horizontal B-grid layout.   
!
! Richardson number rit is centered at T-cell.  
! Richardson number riu is centered at U-cell.  
!
! This calculation differs from that in ocean_vert_kpp_mom4p1 
! since here we compute N^2 using locally referenced potential density, 
! as done for tide mixing scheme and as done in ri_for_cgrid.  Other
! features of the calculation, such as the horizontal averaging, 
! agree with ocean_vert_kpp_mom4p1. 
!
! </DESCRIPTION>
!
subroutine ri_for_bgrid (Time, dzwt, drhodT, drhodS, theta, salinity, velu, velv, rit, riu)

  type(ocean_time_type),        intent(in)    :: Time
  real, dimension(isd:,jsd:,:), intent(in)    :: dzwt
  real, dimension(isd:,jsd:,:), intent(in)    :: drhodT
  real, dimension(isd:,jsd:,:), intent(in)    :: drhodS
  real, dimension(isd:,jsd:,:), intent(in)    :: theta
  real, dimension(isd:,jsd:,:), intent(in)    :: salinity 
  real, dimension(isd:,jsd:,:), intent(in)    :: velu
  real, dimension(isd:,jsd:,:), intent(in)    :: velv
  real, dimension(isd:,jsd:,:), intent(inout) :: rit
  real, dimension(isd:,jsd:,:), intent(inout) :: riu
  
  integer :: i, j, k, kbot, kp1, m
  real    :: prev, tmp1, tmp3, active_cells

  rit   = 0.0
  riu   = 0.0
  wrk1  = 0.0 ! dT/dz 
  wrk2  = 0.0 ! dS/dz
  wrk3  = 0.0 ! N2
  wrk4  = 0.0 ! (du/dz)**2
  wrk5  = 0.0 ! 1/dzwt

  ! vertical derivative of theta and salinity 
  do k=1,nk-1
     kp1 = k+1
     do j=jsd,jed
        do i=isd,ied
           wrk5(i,j,k) = 1.0/dzwt(i,j,k)
           wrk1(i,j,k) = (theta(i,j,k)    - theta(i,j,kp1)   )*wrk5(i,j,k)
           wrk2(i,j,k) = (salinity(i,j,k) - salinity(i,j,kp1))*wrk5(i,j,k)
        enddo
     enddo
  enddo

  ! N^2 < 0 is a signature of vertically unstable regions.  
  ! N^2 = 0 at bottom of ocean bottom.
  do k=1,nk-1
     kp1 = k+1
     do j=jsd,jed
        do i=isd,ied
           wrk3(i,j,k) = -Grd%tmask(i,j,kp1)*grav*rho0r*(drhodT(i,j,k)*wrk1(i,j,k) + drhodS(i,j,k)*wrk2(i,j,k))
        enddo
     enddo
  enddo

  ! smooth N2 to reduce vertical noise
  if(smooth_n2) then
      do m=1,num_n2_smooth
         do j=jsd,jed
            do i=isd,ied
               prev = onefourth*wrk3(i,j,1) 
               kbot = Grd%kmt(i,j)
               if(kbot > 3) then
                   do k=2,kbot-2
                      tmp1        = wrk3(i,j,k)
                      wrk3(i,j,k) = prev + onehalf*wrk3(i,j,k) + onefourth*wrk3(i,j,k+1)
                      prev        = onefourth*tmp1
                   enddo
               endif
            enddo
         enddo
      enddo
  endif

  ! compute richardson numbers on bottom of U cells.
  ! compute halos to allow later averaging to rit. 
  do k=1,nk-1
     do j=jsd,jec
        do i=isd,iec
           wrk4(i,j,k) = (velu(i,j,k) - velu(i,j,k+1))**2 + (velv(i,j,k) - velv(i,j,k+1))**2 + epsln 
           tmp3 = wrk3(i,j+1,k) + wrk3(i+1,j+1,k) + wrk3(i,j,k) + wrk3(i+1,j,k)
           riu(i,j,k) = Grd%umask(i,j,k+1)*dzwt(i,j,k)*tmp3/wrk4(i,j,k)
        enddo
     enddo
  enddo

  ! smooth Richardson number in the vertical using a 1-2-1 filter
  if (smooth_ri_number) then 
     do m=1,num_ri_smooth
        do j=jsd,jec
           do i=isd,iec
              prev = onefourth*riu(i,j,1)
              kbot = Grd%kmu(i,j)
              if (kbot  > 3) then
                  do k=2,kbot-2
                     tmp1       = riu(i,j,k)
                     riu(i,j,k) = prev + onehalf*riu(i,j,k) + onefourth*riu(i,j,k+1)
                     prev       = onefourth*tmp1
                  enddo
              endif
           enddo
        enddo
     enddo
  endif

  ! compute richardson numbers on bottom of T cells as average
  ! of four nearest richardson numbers on bottom of U cells.
  ! do not consider land cells in the average.
  do k=1,nk-1
     do j=jsc,jec
        do i=isc,iec
           active_cells = Grd%umask(i,j,k+1)   + Grd%umask(i-1,j,k+1) &
                        + Grd%umask(i,j-1,k+1) + Grd%umask(i-1,j-1,k+1) + epsln
           rit(i,j,k)   = (riu(i,j,k)+riu(i-1,j,k)+riu(i,j-1,k)+riu(i-1,j-1,k))/active_cells

           ! make sure no static instability exists (one that is not seen
           ! by the Richardson number).  This may happen due to
           ! horizontal averaging used in calculating the Richardson
           ! number.

           if (rit(i,j,k) > 0.0 .and. wrk3(i,j,k) > 0.0) then
              rit(i,j,k) = -10.0
           endif
        enddo
     enddo
  enddo


  ! diagnostics 
  call diagnose_3d_u(Time, Grd, id_ri_num_dudz, wrk4(:,:,:))
  call diagnose_3d(Time, Grd, id_ri_num_n2, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_rit, rit(:,:,:))
  call diagnose_3d(Time, Grd, id_riu, riu(:,:,:))

end subroutine ri_for_bgrid
! </SUBROUTINE> NAME="ri_for_bgrid"



!#######################################################################
! <SUBROUTINE NAME="ri_for_cgrid">
!
! <DESCRIPTION>
!
! Compute Richardson number assuming horizontal C-grid layout.   
!
! Richardson number rit is centered at T-cell.  
! Richardson number riu is set equal to rit, as there is no 
! separate "U-cell" when working with a Cgrid. 
!
! This calculation differs from that in ocean_vert_kpp_mom4p1 
! since here we compute N^2 using locally referenced potential density, 
! as done for tide mixing scheme and as done in ri_for_cgrid.  
!
! </DESCRIPTION>
!
subroutine ri_for_cgrid (Time, dzwt, drhodT, drhodS, theta, salinity, ut, vt, rit, riu)

  type(ocean_time_type),        intent(in)    :: Time
  real, dimension(isd:,jsd:,:), intent(in)    :: dzwt
  real, dimension(isd:,jsd:,:), intent(in)    :: drhodT
  real, dimension(isd:,jsd:,:), intent(in)    :: drhodS
  real, dimension(isd:,jsd:,:), intent(in)    :: theta
  real, dimension(isd:,jsd:,:), intent(in)    :: salinity 
  real, dimension(isd:,jsd:,:), intent(in)    :: ut       ! zonal velocity at t-point
  real, dimension(isd:,jsd:,:), intent(in)    :: vt       ! merid velocity at t-point
  real, dimension(isd:,jsd:,:), intent(inout) :: rit
  real, dimension(isd:,jsd:,:), intent(inout) :: riu
  
  integer :: i, j, k, kbot, kp1, m
  real    :: prev, tmp, tmp1, tmp2

  rit   = 0.0
  riu   = 0.0
  wrk1  = 0.0 ! dT/dz 
  wrk2  = 0.0 ! dS/dz
  wrk3  = 0.0 ! N2
  wrk4  = 0.0 ! (du/dz)**2
  wrk5  = 0.0 ! 1/dzwt

  ! vertical derivative of theta and salinity 
  do k=1,nk-1
     kp1 = k+1
     do j=jsd,jed
        do i=isd,ied
           wrk5(i,j,k) = 1.0/dzwt(i,j,k)
           wrk1(i,j,k) = (theta(i,j,k)-theta(i,j,kp1))*wrk5(i,j,k)
           wrk2(i,j,k) = (salinity(i,j,k)-salinity(i,j,kp1))*wrk5(i,j,k)
        enddo
     enddo
  enddo

  ! N^2 < 0 is a signature of vertically unstable regions.  
  ! N^2 = 0 at bottom of ocean bottom.
  do k=1,nk-1
     kp1 = k+1
     do j=jsd,jed
        do i=isd,ied
           wrk3(i,j,k) = -Grd%tmask(i,j,kp1)*grav*rho0r*(drhodT(i,j,k)*wrk1(i,j,k)+drhodS(i,j,k)*wrk2(i,j,k))
        enddo
     enddo
  enddo

  ! smooth N2 to reduce vertical noise
  if(smooth_n2) then
      do m=1,num_n2_smooth
         do j=jsd,jed
            do i=isd,ied
               prev = onefourth*wrk3(i,j,1) 
               kbot = Grd%kmt(i,j)
               if(kbot > 3) then
                   do k=2,kbot-2
                      tmp         = wrk3(i,j,k)
                      wrk3(i,j,k) = prev + onehalf*wrk3(i,j,k) + onefourth*wrk3(i,j,k+1)
                      prev        = onefourth*tmp
                   enddo
               endif
            enddo
         enddo
      enddo
  endif

  ! magnitude of vertical shear on bottom of T-cell 
  wrk4(:,:,:) = 0.0
  do k=1,nk-1
     kp1 = k+1
     do j=jsc,jec
        do i=isc,iec
           tmp1        = (ut(i,j,k)-ut(i,j,kp1))*wrk5(i,j,k)
           tmp2        = (vt(i,j,k)-vt(i,j,kp1))*wrk5(i,j,k)
           wrk4(i,j,k) = tmp1**2 + tmp2**2 + epsln 
        enddo
     enddo
  enddo

  ! compute richardson number on bottom of T-cells
  do k=1,nk-1
     do j=jsc,jec
        do i=isc,iec
           rit(i,j,k) = wrk3(i,j,k)/wrk4(i,j,k)
        enddo
     enddo
  enddo

  ! smooth Richardson number in the vertical using a 1-2-1 filter:
  if (smooth_ri_number) then 
      do m = 1,num_ri_smooth
         do j=jsc,jec
            do i=isc,iec
               prev =  onefourth*rit(i,j,1)
               kbot = Grd%kmt(i,j)
               if (kbot > 3) then
                   do k=2,kbot-2
                      tmp        =  rit(i,j,k)
                      rit(i,j,k) =  prev + onehalf*rit(i,j,k) + onefourth*rit(i,j,k+1)
                      prev       =  onefourth*tmp
                   enddo
               endif
            enddo
         enddo
      enddo
  endif

  ! equate riu to rit
  riu(:,:,:) = rit(:,:,:)


  ! diagnostics 
  call diagnose_3d(Time, Grd, id_ri_num_dudz, wrk4(:,:,:))
  call diagnose_3d(Time, Grd, id_ri_num_n2, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_rit, rit(:,:,:))
  call diagnose_3d_u(Time, Grd, id_riu, riu(:,:,:))

end subroutine ri_for_cgrid
! </SUBROUTINE> NAME="ri_for_cgrid"


end module ocean_vert_util_mod

#ifndef USE_LIMA
  subroutine init_sw_ic( icase, im, jm, km, nq, jfirst, jlast,   &
                         ng_d,  ng_s,  phis, u, v, pt, delp, q,  &
                         grav,  ae,   omega, f0, ig )

!-----------------------------------
! Shallow water equivalent settings:
!-----------------------------------

! del(WZ) = CP * PT * del(PK)  = delp
! CP = kappa = 1; pt = 1 ---> Pk == pe;  del(g*Z) == delp
! Example: del(WZ) = 9.81 * 10 (km) ==> delp ~ 981 (mb)


  use fv_pack,      only: sinp, cosp, cose, sine, sinlon, coslon, master
  use pv_module,    only: vort_d

#ifdef SPMD
  use mod_comm,     only: mp_send4d_ns, mp_recv4d_ns
#endif
  implicit none

     integer, intent(in):: ig
     integer, intent(in):: icase           ! Case-2:
                                           ! Case-5: geostrophic flow over isolated mountain
                                           ! Case-6: Rossby-Haurwitz wave#4
     integer, intent(in):: im, jm, km, nq
     integer, intent(in):: jfirst, jlast
     integer, intent(in):: ng_d, ng_s

     real, intent(in):: grav
     real, intent(in):: ae
     real, intent(in):: omega

     real, intent(inout):: f0(im,jfirst-ng_d:jlast+ng_d)
     real, intent(out):: phis(im,jfirst-ig:jlast+ig)   ! surface geopotential
     real, intent(out):: delp(im,jfirst:jlast,km) ! pressure thickness (pascal)

     real, intent(out):: u(im,jfirst-ng_d:jlast+ng_s,km)  ! u-wind (m/s)
     real, intent(out):: v(im,jfirst-ng_d:jlast+ng_d,km)  ! v-wind (m/s)
     real, intent(out):: pt(im,jfirst-ng_d:jlast+ng_d,km)
     real, intent(out):: q(im,jfirst-ng_d:jlast+ng_d,km,nq)

! local:
     integer i,j
     real  vort(im,jfirst:jlast)
     real  pi, dp, dl
     real  alpha, u0
     real  v0, h0, hs0, br, zc, pc, phi, zam, tmp, sr
     real  omg, k, R, cosz, zamc, a, b, c
     real hsp, deg, ddeg
     real h1(jm), u1(jm)

     pi = 4. * atan(1.)
     dl = 2.*pi / im
     dp = pi / (jm-1)

     select case (icase)

     case(2)

      alpha = 0.5*pi
      u0 = 2.*pi*ae / (12.*24.*3600.)
      h0 = 2.94e4

      do j = max(1,jfirst-ng_d), min(jm,jlast+ng_d)
         do i=1,im
            f0(i,j) = 2.*omega*(sinp(j)*cos(alpha)-coslon(i)*cosp(j)*sin(alpha)) 
         enddo
      enddo

      do j=jfirst, jlast
         do i=1,im
            u(i,j,1) = u0*(cose(j)*cos(alpha)+sine(j)*coslon(i)*sin(alpha))
         enddo
      enddo

      DO j=jfirst,jlast
         DO i=1,im
            zamc = dl*real(i-1)
             v(i,j,1) = -u0*sin(zamc)*sin(alpha)
          delp(i,j,1) = h0 - (ae*omega + 0.5*u0)*u0 *        &
                  (sinp(j)*cos(alpha)-coslon(i)*cosp(j)*sin(alpha))**2
            phis(i,j) = 0.
         enddo
      enddo

     case (5)                 ! Williamson et al's test case #5
!----------------------------
! Flow over isolated mountain
!----------------------------
      if(master) write(6,*) 'Generating IC for Flow over isolated mountain case'
      v0  = 20.
      h0  = 5960.*grav
      hs0 = 2000.*grav

      br  = pi/9.
      zc  = .5*pi - pi
      pc  = pi/6.

      do j=jfirst,jlast
         phi = - pi*0.5 + (j-1)*dp
         do i=1,im
            zam = dl*(real(i)-0.5) - pi
            tmp = (zam-zc)**2 + (phi-pc)**2
            sr = min(br**2, tmp)
            phis(i,j) = hs0*(1.-sqrt(sr)/br)
             u(i,j,1)  =  v0*cose(j)
             v(i,j,1)  =  0.
! Total geopotential
          delp(i,j,1)  =  h0 - (ae*omega+0.5*v0)*v0*sinp(j)**2
         enddo
      enddo

     case(6)                  ! Williamson et al's test case #6
!-----------------------
! Rossby-Haurwitz wave#4
!-----------------------

      if(master) write(6,*) 'Generating IC for Rossby-Haurwitz wave#4 case'

      omg = 7.848E-6
      k = omg
      R = 4.
      h0 = 8.E3 * grav

      do j=jfirst, jlast
         do i=1,im
                zam  = dl*(real(i)-0.5)
            u(i,j,1) = AE*omg*cose(j) +        &
             AE*k*(cose(j)**(R-1))*(R*sine(j)**2-cose(j)**2)*cos(R*zam)
         enddo
      enddo

      do j=jfirst, jlast
         cosz = cosp(j)
         do i=1,im
            zam  = DL*(real(i)-0.5)
            zamc = DL*real(i-1)
            v(i,j,1) = -AE*k*R*sinp(j)*sin(R*zamc)*cosz**(R-1)
            A = 0.5*omg*(2.*OMEGA+omg)*cosz**2 + 0.25*k*k*cosz**(R+R) *  &
                ((R+1)*cosz**2 + (2.*R*R-R-2.))-0.5*(k*R)**2*cosz**(R+R-2)
            B = 2.*(OMEGA+omg)*k / ((R+1)*(R+2)) *(cosz**R) *                  &
                ( (R*R+2.*R+2.) - ((R+1.)*cosz)**2 )
            C = 0.25*k*k* ((R+1)*cosz**2-(R+2)) * cosz**(2.*R)
           delp(i,j,1) = h0 + AE*AE*(A+B*cos(R*zam)+C*cos(2.*R*zam))
           phis(i,j) = 0.
         enddo
      enddo

     case(8)
!-----------------------------------------
! Vortex breaking (Lin and Rood 1997, QJ)
!-----------------------------------------

      if(master) write(6,*) 'Generating IC for Rossby wave breaking case'


      hsp = 6000. * grav
      ddeg = 180./real(jm-1)

      do j=1,jlast
         deg = -90. + (real(j-1)-0.5)*ddeg
         if(deg <= 0.) then
            u1(j) = -10.*(deg+90.)/90.
         elseif(deg <= 60.) then
            u1(j) = -10. +  deg
         else
            u1(j) = 50. - (50./30.)* (deg - 60.)
         endif
      enddo

      h1(1) = hsp
      do j=2,jlast
         h1(j) = h1(j-1) - dp*sine(j)*(AE*2.*omega+u1(j)/cose(j))*u1(j)
      enddo
      
      do j=jfirst, jlast
         do i=1,im
            u(i,j,1) = u1(j)
            v(i,j,1) = 0.
            delp(i,j,1) = h1(j)
            phis(i,j) = 0.
         enddo
      enddo

     end select

! For all cases:

#ifdef SPMD
     call mp_send4d_ns(im, jm, 1, 1, jfirst, jlast, 1, 1, ig, ig, phis)
     call mp_recv4d_ns(im, jm, 1, 1, jfirst, jlast, 1, 1, ig, ig, phis)
#endif

!--------------------------------------
! Initialize the passive tracer with PV
!--------------------------------------
     call vort_d(im, jm, 1, jfirst, jlast, u, v, vort, ng_s, ng_d)

     do j=jfirst, jlast
        do i=1,im
! Substract out surface geopotential to get Layer thickness
           delp(i,j,1)   =  delp(i,j,1) - phis(i,j)
              q(i,j,1,1) = (f0(i,j) + vort(i,j)) / delp(i,j,1)
             pt(i,j,1)   =  1.
        enddo
     enddo

  end subroutine init_sw_ic
#else  
  subroutine init_sw_ic( icase, im, jm, km, nq, jfirst, jlast,   &
                         ng_d,  ng_s,  phis, u, v, pt, delp, q,  &
                         grav,  ae,   omega, f0, ig )

!-----------------------------------
! Shallow water equivalent settings:
!-----------------------------------

! del(WZ) = CP * PT * del(PK)  = delp
! CP = kappa = 1; pt = 1 ---> Pk == pe;  del(g*Z) == delp
! Example: del(WZ) = 9.81 * 10 (km) ==> delp ~ 981 (mb)


  use shr_kind_mod, only: r8 => shr_kind_r8
  use fv_pack,      only: sinp, cosp, cose, sine, master
  use pv_module,    only: vort_d

#ifdef SPMD
  use mod_comm,     only: mp_send4d_ns, mp_recv4d_ns
#endif
  implicit none

     integer, intent(in):: ig
     integer, intent(in):: icase           ! Case-2:
                                           ! Case-5: geostrophic flow over isolated mountain
                                           ! Case-6: Rossby-Haurwitz wave#4
     integer, intent(in):: im, jm, km, nq
     integer, intent(in):: jfirst, jlast
     integer, intent(in):: ng_d, ng_s

     real(r8), intent(in):: grav
     real(r8), intent(in):: ae
     real(r8), intent(in):: omega
     real(r8), intent(in):: f0(jfirst-ng_d:jlast+ng_d)

     real(r8), intent(out):: phis(im,jfirst-ig:jlast+ig)   ! surface geopotential
     real(r8), intent(out):: delp(im,jfirst:jlast,km) ! pressure thickness (pascal)

     real(r8), intent(out):: u(im,jfirst-ng_d:jlast+ng_s,km)  ! u-wind (m/s)
     real(r8), intent(out):: v(im,jfirst-ng_d:jlast+ng_d,km)  ! v-wind (m/s)
     real(r8), intent(out):: pt(im,jfirst-ng_d:jlast+ng_d,km)
     real(r8), intent(out):: q(im,jfirst-ng_d:jlast+ng_d,km,nq)

! local:
     integer i,j
     real(r8)  vort(im,jfirst:jlast)
     real(r8)  pi, dp, dl
     real(r8)  alpha, u0
     real(r8)  v0, h0, hs0, br, zc, pc, phi, zam, tmp, sr
     real(r8)  omg, k, R, cosz, zamc, a, b, c

     pi = 4. * atan(1.)
     dl = 2.*pi / im
     dp = pi / (jm-1)

     select case (icase)

     case(2)
      alpha = 0.
      u0 = 2.*pi*ae / (12.*24.*3600.)
      h0 = 2.94e4

      do j=jfirst, jlast
         do i=1,im
                  zam = dl*(i-1) - PI
            u(i,j,1) = u0*(cose(j)*cos(alpha)+sine(j)*cos(zam)*sin(alpha))
         enddo
      enddo

      DO j=jfirst,jlast
         DO i=1,im
            zam  = DL*(i-1) - PI
            zamc = zam - 0.5*DL
             v(i,j,1) = -u0*sin(zamc)*sin(alpha)
          delp(i,j,1) = h0 - (ae*omega + 0.5*u0)*u0 *        &
                  (sinp(j)*cos(alpha)-cos(zam)*cosp(j)*sin(alpha))**2
            phis(i,j) = 0.
         enddo
      enddo

     case (5)                 ! Williamson et al's test case #5
!----------------------------
! Flow over isolated mountain
!----------------------------
      if(master) write(6,*) 'Generating IC for Flow over isolated mountain case'
      v0  = 20.
      h0  = 5960.*grav
      hs0 = 2000.*grav

      br  = pi/9.
      zc  = .5*pi - pi
      pc  = pi/6.

      do j=jfirst,jlast
         phi = - pi*0.5 + (j-1)*dp
         do i=1,im
            zam = dl*(i-1) - pi
            tmp = (zam-zc)**2 + (phi-pc)**2
            sr = min(br**2, tmp)
            phis(i,j) = hs0*(1.-sqrt(sr)/br)
             u(i,j,1)  =  v0*cose(j)
             v(i,j,1)  =  0.
! Total geopotential
          delp(i,j,1)  =  h0 - (ae*omega+0.5*v0)*v0*sinp(j)**2
         enddo
      enddo

     case(6)                  ! Williamson et al's test case #6
!-----------------------
! Rossby-Haurwitz wave#4
!-----------------------

      if(master) write(6,*) 'Generating IC for Rossby-Haurwitz wave#4 case'

      omg = 7.848E-6
      k = omg
      R = 4.
      h0 = 8.E3 * grav

      do j=jfirst, jlast
         do i=1,im
                zam  = DL*(i-1) - PI
            u(i,j,1) = AE*omg*cose(j) +        &
             AE*k*(cose(j)**(R-1))*(R*sine(j)**2-cose(j)**2)*cos(R*zam)
         enddo
      enddo

      do j=jfirst, jlast
         cosz = cosp(j)
         do i=1,im
            zam  = DL*(i-1) - PI
            zamc = zam - 0.5*DL
            v(i,j,1) = -AE*k*R*sinp(j)*sin(R*zamc)*cosz**(R-1)
            A = 0.5*omg*(2.*OMEGA+omg)*cosz**2 + 0.25*k*k*cosz**(R+R) *  &
                ((R+1)*cosz**2 + (2.*R*R-R-2.))-0.5*(k*R)**2*cosz**(R+R-2)
            B = 2.*(OMEGA+omg)*k / ((R+1)*(R+2)) *(cosz**R) *                  &
                ( (R*R+2.*R+2.) - ((R+1.)*cosz)**2 )
            C = 0.25*k*k* ((R+1)*cosz**2-(R+2)) * cosz**(2.*R)
           delp(i,j,1) = h0 + AE*AE*(A+B*cos(R*zam)+C*cos(2.*R*zam))
           phis(i,j) = 0.
         enddo
      enddo

     end select

! For all cases:

#ifdef SPMD
     call mp_send4d_ns(im, jm, 1, 1, jfirst, jlast, 1, 1, ig, ig, phis)
     call mp_recv4d_ns(im, jm, 1, 1, jfirst, jlast, 1, 1, ig, ig, phis)
#endif

!--------------------------------------
! Initialize the passive tracer with PV
!--------------------------------------
     call vort_d(im, jm, 1, jfirst, jlast, u, v, vort, ng_s, ng_d)

     do j=jfirst, jlast
        do i=1,im
! Substract out surface geopotential to get Layer thickness
           delp(i,j,1)   =  delp(i,j,1) - phis(i,j)
              q(i,j,1,1) = (f0(j) + vort(i,j)) / delp(i,j,1)
             pt(i,j,1)   =  1.
        enddo
     enddo

  end subroutine init_sw_ic
#endif

MODULE STRAT_CHEM_MOD
! automatic conversion to free f90 compatible form 
! free.pl strat_chem_model.f  
! linewidth: 72
! file names: strat_chem_model.f 
!
!23456789-123456789-123456789-123456789-123456789-123456789-123456789-23
!/
!/ THIS MODIFICATION SET FOR THE UNIFIED MODEL IS A 
!/ REAL STRATOSPHERIC CHEMICAL MODEL         
!/ WRITTEN BY J AUSTIN (10/02/94); MODIFIED 26/7/95 FOR 49 LEVEL MODEL  
!/ REVISED FOR CLIMATE LENGTH INTEGRATIONS 24/9/96
!/ REVISED FOR PARALLEL CODE 13/11/97
!/ REVISED CHEMICAL MODEL 14/1/98
!/ REVISED CHEMICAL MODEL WITH MAINZ ANALYTIC SCHEME 1/5/99
!/ REVISED INTEGRATION SCHEME AFTER STEILET AL. 1998 14/6/99
!/ UPDATED TO VN4.5 64 LEVELS J. AUSTIN 27/1/00
!/ UPDATED CH4 OXIDATION, TROPOSPHERIC CHEMISTRY 14/2/02
!/ UPDATED FOR USE IN THE FMS, 15/12/03
!/ REVISED, 13/10/04: SIMPLIFIED PSCs, IMPROVED LONG-LIVED TRACERS,
!/      AGE OF AIR PARAMETERISATION FOR HALOGEN RATES OF CHANGE
!/

implicit none
private

public CHEMISTRY, ZEN2, DCLY_DT, SEDIMENT

contains

      SUBROUTINE CHEMISTRY (ALON, ALAT, JLZ, KL, DY, H2O, DAGESQ, OZCOL, &
        PRESS, RHO, TEMP, VTEMP, COZEN, CDX, CHLB, OZB, BNAT, BICE, PHOTO, &
        SOLARDATA, OZON, COSP, COSPHC, ANOY, AEROSOL, DT, MERIDS, CH_TEND, &
        OZONE, O3_PROD, H2O_TEND, MYPE, ITIME)
! """" ----------------------------------------------------------------*
! VERSION NUMBER   : 1   DATE:  6/10/1989.
!   NOTES          : CODE REWRITTEN TO SOLVE EQUATIONS MORE DIRECTLY
!                  : IN FAMILY MODE TO COMPARE MODEL RESULTS
! VERSION NUMBER   : 2   DATE:  1/06/1990.
!   NOTES          : REACTION SET SIMPLIFIED TO REDUCE CPU TIME
! VERSION NUMBER   : 3   DATE: 02/04/1993.
!   NOTES          : REVISED HETEROGENEOUS REACTION SCHEME
! VERSION NUMBER   : 4   DATE: 09/02/1994ET SEQ.
!   NOTES          : ADAPTED FOR USE IN THE UNIFIED MODEL
! VERSION NUMBER   : 5   DATE: 15/12/2003
!   NOTES          : ADAPTED FOR USE IN THE FMS               
! VERSION NUMBER   : 6   DATE: 23/03/2006
!   NOTES          : CONVERTED TO f90 FOR USE IN THE FMS               
! """" ----------------------------------------------------------------*
! PURPOSE          : TO INTEGRATE A ZERO-DIMENSION(POINT) CHEMICAL      
!                    MODEL ALONG A PREDETERMINED TRAJECTORY FOR A       
!                    TIME PERIOD IDT
! METHOD           : USES THE EULER BACKWARD INTEGRATION SCHEME         
! INPUT/OUTPUT LIST:
!     JLX          = LAT.  NUMBER (NEEDED FORERROR DIAGNOSTICS)        
!     KL           = LEVEL NUMBER (NEEDED FOR PHOTOLYSIS RATES)         
!     DT           = INTEGRATION TIMESTEP
!     DY           = ARRAY OF FAMILY CONCENTRATIONS
!     OZCOL        = OZONE COLUMN ABOVE PARTICLE
!     FACT         = RATIO OF OZONE TO OY (FOR PHOTOLYSIS RATES)        
!     RHO          = AIR DENSITY AT THE PARTICLE
!     TEMP         = TEMPERATURE AT THE PARTICLE
!     CHEMINC      = INCREMENTS TO FAMILY CONCENTRATIONS      
!                    AFTER THIS CALL TO OAERO
!
!  SUBPROGRAM CALLS:
!     REACTION_RATES  - CALCULATES REACTION RATES (CALLED ONCE) 
!     PSC/GAMMA_AER/HETRATES - CALCULATE HETEROGENEOUS REACTION RATES
!     PHOTO   - CALCULATES PHOTODISSOCIATION RATES (CALLED ONCE)        
!----------------------------------------------------------------------*
      IMPLICIT NONE
      

      integer ::  nchem, jimpl, ihet, nhet, irx, irx4
      PARAMETER (NCHEM=21,JIMPL=18,IHET=72,NHET=9)
      PARAMETER (IRX=33,IRX4=IRX*4) 

      integer, intent(in) :: MERIDS, JLZ, KL, MYPE
      integer, intent(in) :: ITIME(6)
      real, intent(in)    :: CDX, DT
      real, intent(in), dimension(MERIDS) :: ALON, ALAT,   &
                           DAGESQ, OZCOL, PRESS, RHO, &
                           TEMP, VTEMP, COZEN, &
                           AEROSOL
      real, intent(in), dimension(MERIDS,NCHEM) :: DY
      real, intent(in), dimension(90,15) :: CHLB
      real, intent(in), dimension(144,90) :: OZB
      real, intent(in) :: PHOTO(132,14,11,48)
      real, intent(in) :: SOLARDATA(1801)
      real, intent(in) :: OZON(11,48)
      real, intent(inout) :: COSP(14)
      real, intent(inout) :: COSPHC(48)
      real, intent(in) :: ANOY(90,48)

      real, intent(inout), dimension(MERIDS)       :: H2O, BNAT, BICE, OZONE, O3_PROD, H2O_TEND
      real, intent(inout), dimension(MERIDS,NCHEM) :: CH_TEND
              
!----------------------------------------------------------------------*
! VARIABLES PASSED TO OR FROM HIGHER SUBROUTINES
!----------------------------------------------------------------------*


      INTEGER :: ISTEP_CHEM, IC, IL, ILX, JLX, IZ, NC, KLX, IR, &
                 ITX, ITNO, ITIME_LEFT, IT, IM, IDX, ICYC, IDAYS, LEAPD,&
                 JMOD, ISC
      REAL :: AGESQ
      INTEGER :: IMON(12)
!----------------------------------------------------------------------*
! VARIABLES FOR THIS SUBROUTINE
!----------------------------------------------------------------------*
#define _ALLOC

#ifdef _ALLOC
     REAL, ALLOCATABLE, DIMENSION(:,:) :: RATES, FOTO
     REAL, ALLOCATABLE, DIMENSION(:,:) :: DYY, DYZ, DQT, DPT, RAT, &
              DYZ1, DYY0, DYY1, COND, GAMMA
#else
     REAL :: RATES(MERIDS,IHET+NHET-1)
     REAL :: FOTO(MERIDS,IRX4)
     REAL :: DYY(MERIDS,NCHEM)
     REAL :: DYZ(MERIDS,JIMPL)
     REAL :: DQT(MERIDS,NCHEM)
     REAL :: DPT(MERIDS,NCHEM)
     REAL :: RAT(MERIDS,3)
     REAL :: DYZ1(MERIDS,JIMPL)
     REAL :: DYY0(MERIDS,NCHEM)
     REAL :: DYY1(MERIDS,NCHEM)
     REAL :: COND(MERIDS,3)
     REAL :: GAMMA(MERIDS,NHET)
#endif
     REAL, DIMENSION(MERIDS) ::  CLOX, BROX, ANOZ, H2O1, H2O0, DP1, DQ1, &
            H2SO4, TICE, WH2SO4, AM, AW, ALIQ, RMEAN, ASAT, RNAT, RICE, RTT

     REAL :: DVDT, CH4, AN2O, CH4TR, AN2OTR, ANAT, AICE, VTAU10, VTAU100, &
            VTAUYR, FACT, DELT, SUM, RATIO1, RATIO2, ANUM, ADEN, ANOX, DAX, &
            DA1, DA2, DD1, DB1, DB2, DD2, DDNUM, DA3, DC2, DC3, DD3, R1, R2, &
            DD13, VDDNUM, DAC2, DA12, DD12, CLX, TAU, RAT1, BX1, AX, BX, CX, &
            XYZ, DQT1, DQT2, DQT3, T0, T1, BRX, DIFF, VRHO, BX2, &
            RATIO, X1, X2, SOL, FRAC, SOLARTIME, SOLAR27, DX1, D11, D27, F11, &
            F27, PI, O2, H2, minusT0
      DATA  PI/3.141592653589793/
      DATA  O2/0.2095/,H2/0.5E-6/                                
      DATA  ISTEP_CHEM/900/ ! Chemical timestep (s)
      DATA  ANAT,AICE/10.0, 10.0/
      DATA  IMON/0,31,59,90,120,151,181,212,243,273,304,334/
!
!  ISC IS THE SRES SCENARIO FOR CH4 AND N2O
!  1 = A1B, 2 = A2, 3 = B1, 4 = timeslice
!
      DATA  ISC/1/
! ---------------------------------------------------------------------*
!                                                                       
!   THE ARRAYS DYY AND DYZ CONTAIN THE SPECIES AMOUNTS.  THE SPECIES    
!   DYY ARE CALCULATEDEXPLICITLY, WHILE THE SPECIES DYZ ARE FOUND      
!   IMPLICITLY USING PHOTOCHEMICALEQUILIBRIUM AND RELATED APPROACHES.  
!   THE VALUES IN DYZ ARE RECALCULATED AFRESH FOREVERY CALL TO OAERO.  
!   THE ORDER OF THE SPECIES CONTAINED IN THE ARRAYS DYY AND DYZ IS:    
!      DYY                                                              
!    1. HNO3     2. N2O5   3. H2O2    4. HCL    5. HOCL  6. CLONO2      
!    7. H2CO     8. OY     9. HOBR   10. HNO4  11. HBR  12. BRONO2      
!   13. CH3OOH  14. CO    15. NAT+NY 16. CLY   17. BRY  18. CH4  
!   19. Strat H2O 20. N2O 21. AGE  
!                                                                       
!      DYZ                                                              
!    1.   O3      2.  O3P    3.  O1D    4.  NO      5.  NO2    6. NO3   
!    7.   OH      8.  HO2    9.  H     10.  CL     11.  CLO   12. BR    
!   13.   BRO    14.  CL2O2 15.  BRCL  16.  CH3O2  17.  HONO  18. N
!----------------------------------------------------------------------*

#ifdef _ALLOC
     allocate(RATES(MERIDS,IHET+NHET-1))
     allocate(FOTO(MERIDS,IRX4))
     allocate(DYY(MERIDS,NCHEM))
     allocate(DYZ(MERIDS,JIMPL))
     allocate(DQT(MERIDS,NCHEM))
     allocate(DPT(MERIDS,NCHEM))
     allocate(RAT(MERIDS,3))
     allocate(DYZ1(MERIDS,JIMPL))
     allocate(DYY0(MERIDS,NCHEM))
     allocate(DYY1(MERIDS,NCHEM))
     allocate(COND(MERIDS,3))
     allocate(GAMMA(MERIDS,NHET))
#endif
!
! Set PSCs initially to zero
!
     DO IL = 1,MERIDS
       BNAT(IL) = 0.0
       BICE(IL) = 0.0
     ENDDO
!
! FIND CONCENTRATIONS AND TRENDS OF CH4 AND N2O, ACCORDING TO THE SRES SCENARIO
!
      CALL GHGS(ITIME,ISC,CH4,AN2O,CH4TR,AN2OTR)
!   
!  RELAX TOWARDS SPECIFIC LOWER BOUNDARY VALUES WITH A TIMESCALE OF 10 DAYS
!  (SPECIES 1-15) SPECIES 16-21 ARE TREATED DIFFERENTLY
!                   
      VTAU10 = 1.0/(10.0*86400.0)
      VTAU100 = 0.1*VTAU10
      VTAUYR = 1.0/(365.25*86400.0)
      IF(KL.EQ.48) THEN                                                  
        DO IC = 1,15                                            
          IF(IC.EQ.8) THEN
            DO IL = 1,MERIDS                                            
              ILX = 1 + ALON(IL)*72/PI
              JLX = 1 + (PI*0.5 + ALAT(IL))*89.0/PI
              IF(ILX.GT.144) ILX = ILX - 144 
              CH_TEND(IL,IC) = (OZB(ILX,JLX) - DY(IL,IC))*VTAU10      
            ENDDO
          ELSE             
            DO IL = 1,MERIDS                                            
              JLX = 1 + (PI*0.5 + ALAT(IL))*89.0/PI
              CH_TEND(IL,IC) = (CHLB(JLX,IC) - DY(IL,IC))*VTAU10     
            ENDDO
          ENDIF
        ENDDO                                             
        DO IL = 1,MERIDS
          CH_TEND(IL,16) = - DY(IL,16)*VTAU10     
          CH_TEND(IL,17) = - DY(IL,17)*VTAU10     
          CH_TEND(IL,18) = (CH4 - DY(IL,18))*VTAU10     
          CH_TEND(IL,19) = (3.0E-6 - DY(IL,19))*VTAU10     
          CH_TEND(IL,20) = (AN2O - DY(IL,20))*VTAU10     
        ENDDO
        RETURN
      ENDIF             
!----------------------------------------------------------------------*
!   NO CHANGE TO CHEMICAL CONCENTRATIONS IN THE TOP LEVELS,EXCEPT 
!   FOR AGE
!
!----------------------------------------------------------------------*
!      IF(PRESS(1).LT.8.0) THEN
!        DO IL = 1,MERIDS                                            
!        CH_TEND(IL,21) = VTAUYR     
!       ENDDO
!        RETURN
!     ENDIF
!----------------------------------------------------------------------*
!   RESTRICT THE ACTUAL CHEMICAL MODEL TO STRATOSPHERIC AND 
!   MESOSPHERIC AIR
!----------------------------------------------------------------------*
      DO IL = 1,MERIDS                                               
        DO IZ = 1,NCHEM                                                
          DYY(IL,IZ) = DY(IL,IZ)*RHO(IL)                                    
        ENDDO                  
        H2O(IL) = H2O(IL)*RHO(IL)
        DYZ(IL,1) = OZONE(IL)*RHO(IL)
        DYZ1(IL,1) = OZONE(IL)*RHO(IL)
!        IF(PRESS(IL).LT.10.0.AND.OZONE(IL).GT.1.0E-5) THEN
!          DYZ(IL,1) = 1.0E-5*RHO(IL)
!          DYZ1(IL,1) = DYZ(IL,1)
!        ENDIF                                            
        DO IZ = 2,JIMPL                                                
          DYZ(IL,IZ) = 0.                                                   
          DYZ1(IL,IZ) = 0.                                                  
        ENDDO
      ENDDO                                                   
!----------------------------------------------------------------------*
!   CALL SUBROUTINES FOR TEMPERATURE DEPENDENT RATES, HETEROGENEOUS RATES 
!   AND  FOR PHOTOLYSIS RATES (ONCE PER CALL TO CHEMISTRY)
!   PASS THE PRESSURE IN PA INTO THE OTHER CHEMISTRY S/RS
!----------------------------------------------------------------------*
      CALL REACTION_RATES (RHO,TEMP,VTEMP,PRESS,RATES,MERIDS,IHET,NHET)
      IF(KL.GT.10.AND.KL.LT.28) THEN
        DO IL = 1,MERIDS
!
!  Set H2SO4 as an analytical function of age, peaking at 0.5 ppbv
!
          X1 = 3.0*(ALOG10(PRESS(IL)) - 3.5)**2
          X2 = 3.0/(10.0*DYY(IL,21) + 1.0)*(DYY(IL,21) - 1.0)**2
          H2SO4(IL) = (0.01 + 0.49*EXP(-X1-X2))*1.0E-9*RHO(IL)
        ENDDO
        CALL PSC(TEMP,PRESS,RHO,DYY,H2O,H2SO4,ANAT,AICE,COND,TICE,      &
           WH2SO4,AM,AW,ALIQ,RMEAN,ASAT,RNAT,RICE,MERIDS,NCHEM,MYPE)
        DO IL = 1,MERIDS
          BNAT(IL) = COND(IL,2)/RHO(IL)
          BICE(IL) = COND(IL,3)/RHO(IL)
        ENDDO
        CALL GAMMA_AER(TEMP,PRESS,RHO,DYY,H2O,WH2SO4,AM,AW,RMEAN,GAMMA, &
           RTT,MERIDS,NCHEM,NHET,MYPE)
        CALL HETRATES(TEMP,PRESS,RHO,DYY,H2O,TICE,ANAT,AICE,AEROSOL,    &
           RMEAN,RNAT,RICE,GAMMA,RTT,RATES,IHET,NHET,MERIDS,NCHEM,MYPE)       
      ENDIF
!
      DO NC=1,NCHEM                                                  
        DO IL = 1,MERIDS                                               
          DYY0(IL,NC) = DYY(IL,NC) ! save amounts after natice subtract 
          H2O0(IL) = H2O(IL) 
        ENDDO
      ENDDO                                                
      KLX = KL
      CALL PHOTO_RATES(VTEMP,OZCOL,COZEN,KLX,PHOTO,OZON,COSP,COSPHC,         &
                        MERIDS,IRX,IRX4,FOTO,MYPE)
! ---------------------------------------------------------------------*
!  INCLUDE VARIATIONS IN 11-YR CYCLE AND 27-DAY SOLAR CYCLE AND MULTIPLY 
!  FOTO BY SUN-EARTH DISTANCE TERM (CDX). 
!     IM....NO. OF MONTHS SINCE DEC 1949: USED TO DETERMINE SOLAR F10.7 FLUX.
!     SOLARTIME....TIME AFTER 1 JAN 1960 FOR (ARBITRARY) MIN OF 27 DAY CYCLE
!     ASSUME 12EQUAL MONTHS PER YEAR OF 365.25 DAYS
!  PHOTOLYSIS RATES ARE TAKEN TO BE LINEARLY RELATED TO THE F10.7 FLUX 
!  SOLAR MAX AND SOLAR MIN PHOTO RATES REFER TO APPROX F10.7 FLUX OF 
!  208.1 AND 72.0, CORRESPONDING TO THE YEARS 1991 AND 1996.
! ------------------------------------------------------------------
!
      IF(ISC.EQ.4) THEN
        FACT = 0.0
        SOL = 140.05
      ELSE
        IDAYS = (ITIME(1) - 1960)*365 + IMON(ITIME(2)) + ITIME(3)
        LEAPD = (ITIME(1) - 1960)/4
        JMOD = 4*LEAPD + 1960
        IF(ITIME(2).LT.3.AND.JMOD.EQ.ITIME(1)) LEAPD = LEAPD - 1
        FRAC = FLOAT(ITIME(4)*60 + ITIME(5))/1440.0
        SOLARTIME = FLOAT(IDAYS + LEAPD) + FRAC 
        ICYC = SOLARTIME/27
        SOLAR27 = (SOLARTIME - 27.0*ICYC)/27.0
        FACT = SIN(SOLAR27*2*PI)
        DX1 =  SOLARTIME*12.0/365.25 + 0.5       
        IDX = DX1
        DX1 = DX1 - IDX
        IM = 120 + IDX
        IF(IM.LT.1) IM = 1
        IF(IM.GT.1800) IM = 1800
        SOL = 0.1*(SOLARDATA(IM+1)*DX1 + (1.0 - DX1)*SOLARDATA(IM))
      ENDIF
      DO IR = 1,IRX
        DO IL = 1,MERIDS
          D11 = FOTO(IL,IR) - FOTO(IL,IR+IRX*2)
          D27 = FOTO(IL,IR+IRX) - FOTO(IL,IR+IRX*3)
          F11 = FOTO(IL,IR+IRX*2) + (SOL - 72.0)*D11/136.1
          F27 = FOTO(IL,IR+IRX*3) + (SOL - 72.0)*D27/136.1
          FOTO(IL,IR) = CDX*(F11 + F27*FACT) 
          IF(FOTO(IL,IR).LT.0.0) FOTO(IL,IR) = 0.0
        ENDDO
      ENDDO
! ---------------------------------------------------------------------*
! --- ITX    : TIMESTEP NUMBER                                          
! ---   IT     : ITERATION LOOP COUNTER                                 
! ---                                                                   
! ---   FIRST COMPUTE N + NO + NO2 + NO3 (ANOZ), CL + CLO (CLOX) AND        
! ---   BR + BRO + BRCL (BROX)                                          
! ---                                                                   
! ---------------------------------------------------------------------*
!
      ITX = 0
      ITNO = 6
      ITIME_LEFT = NINT(DT)
      DO 1100
!
      IF(ITIME_LEFT .LE. ISTEP_CHEM) THEN
        DELT = REAL(ITIME_LEFT)
        ITIME_LEFT = 0
      ELSE
        DELT = REAL(ISTEP_CHEM)
        ITIME_LEFT = ITIME_LEFT - ISTEP_CHEM
      ENDIF
      DVDT = 1.0/DELT
      ITX = ITX + 1
      IF (ITX .GE. 2) ITNO = 2
      DO 1000 IT = 1,ITNO
        DO 200 IL = 1,MERIDS
          SUM = DYY(IL,1) + 2.*DYY(IL,2) + DYY(IL,6) + DYY(IL,12) +          &
                DYY(IL,10)
          ANOZ(IL) = DYY(IL,15) - SUM
          IF(ANOZ(IL).LT.0.)  ANOZ(IL) = 0.
          DYZ(IL,5) = ANOZ(IL)
          IF(DYY(IL,1).GT.DYY(IL,15)) DYY(IL,1) = DYY(IL,15)
          SUM = DYY(IL,4) + DYY(IL,5) + DYY(IL,6)
          CLOX(IL) = DYY(IL,16) - SUM
          IF(CLOX(IL).LT.0.)  CLOX(IL) = 0.
          SUM = DYY(IL,12) + DYY(IL,11) + DYY(IL,9)
          BROX(IL) = DYY(IL,17) - SUM
          IF(BROX(IL).LT.0.)  BROX(IL) = 0.
  200   ENDDO
!----------------------------------------------------------------------*
!---
!---         COMPUTE PHOTOCHEMICAL EQUILIBRIUM FOR THE O1D/O3 AND       
!---         O3P/O3 RATIOS
!----------------------------------------------------------------------*
        DO 900 IL=1,MERIDS
          ANUM = (FOTO(IL,2) + FOTO(IL,28)*DYY(IL,20)/DYY(IL,8))
          ADEN =                                                            &
               (RATES(IL,3) + RATES(IL,9)*H2O(IL) +                         &
               RATES(IL,30)*DYY(IL,18) + RATES(IL,66)*DYY(IL,20) +          &
               RATES(IL,70)*DYY(IL,20))
          RATIO2 = ANUM/ADEN
          ANUM = RATES(IL,3)*RATIO2 + FOTO(IL,3) +                          &
                 (2.*FOTO(IL,1)*O2*RHO(IL) + DYZ(IL,5)*FOTO(IL,4) +         &
                  DYZ(IL,4)*FOTO(IL,31) +                                   &
                  DYZ(IL,6)*FOTO(IL,6) + RATES(IL,51)*DYZ(IL,7)**2)/        &
                  DYZ(IL,1)
          ADEN = RATES(IL, 1)           + RATES(IL, 2)*DYZ(IL, 1) +          &
                 RATES(IL, 5)*DYZ(IL,5) + RATES(IL,11)*DYZ(IL, 8) +          &
                 RATES(IL,12)*DYZ(IL,7) + RATES(IL,21)*DYZ(IL,11) +          &
                 RATES(IL,24)*DYY(IL,6) + RATES(IL,44)*DYY(IL, 9)           
          RATIO1 = ANUM/ADEN
          SUM = 1. + RATIO1 + RATIO2
          RAT(IL,1) = 1./SUM
          DYZ(IL,1) = DYY(IL,8)*RAT(IL,1)
          DYZ(IL,2) = RATIO1*DYZ(IL,1)
          DYZ(IL,3) = RATIO2*DYZ(IL,1)
          RAT(IL,2) = RATIO1*RAT(IL,1)
          RAT(IL,3) = RATIO2*RAT(IL,1)
          IF(DYZ(IL,1).LT.1.0E-15*RHO(IL)) THEN
            XYZ = 1.0E-15*RHO(IL) - DYZ(IL,1)
            DYZ(IL,1) = 1.0E-15*RHO(IL)
            DYZ(IL,2) = DYZ(IL,2) + XYZ
            RAT(IL,1) = DYZ(IL,1)/DYY(IL,8)
            RAT(IL,2) = DYZ(IL,2)/DYY(IL,8)
            RAT(IL,3) = 1.0 - RAT(IL,1) - RAT(IL,2)
            IF(RAT(IL,3).LT.0.0) RAT(IL,3) = 0.0
          ENDIF
  900   ENDDO
!----------------------------------------------------------------------*
!--
!---         APPLY PHOTOCHEMICAL EQUILIBRIUM FOR NO3 SUBJECT TO
!---        ENOUGH NOZ BEING PRESENT
!----------------------------------------------------------------------*
        DO 910 IL = 1,MERIDS
          ADEN = RATES(IL,7)*DYZ(IL,5) + FOTO(IL,6) + FOTO(IL,7) +          &
                 RATES(IL,53)*DYZ(IL,4) + RATES(IL,58)*DYZ(IL,5) +          &
                 2.*RATES(IL,59)*DYZ(IL,6) + RATES(IL,62)*DYY(IL,7)            
          IF(ADEN.LT.DVDT.AND.FOTO(IL,6).NE.0.) ADEN = DVDT                 
          IF(ADEN.NE.0.) THEN
            ANUM = (FOTO(IL,8) + RATES(IL,8))*DYY(IL,2) +                   &
              RATES(IL,19)*DYZ(IL, 7)*DYY(IL,1) +                           &
              RATES(IL, 6)*DYZ(IL, 5)*DYZ(IL,1) +                           &
             (RATES(IL,24)*DYZ(IL, 2) + FOTO(IL,12))*DYY(IL,6) +            &
               FOTO(IL,17)*DYY(IL,12)
            DYZ(IL,6) = ANUM/ADEN
            IF(DYZ(IL,6).GT.(0.5*ANOZ(IL))) DYZ(IL,6) = 0.5*ANOZ(IL)
          ENDIF           
!----------------------------------------------------------------------*
!---        APPLY PHOTOCHEMICAL EQUILIBRIUM FOR N SUBJECT TO         
!---       ENOUGH NOZ BEING PRESENT
!---
!----------------------------------------------------------------------*
          ADEN = RATES(IL,67)*DYZ(IL,4) + RATES(IL,68)*O2*RHO(IL) +         &
                 RATES(IL,71)*DYZ(IL,5)
          ANUM = FOTO(IL,31)*DYZ(IL,4)
          DYZ(IL,18) = ANUM/ADEN
          IF(DYZ(IL,18).GT.(0.5*ANOZ(IL))) DYZ(IL,18) = 0.5*ANOZ(IL)
!----------------------------------------------------------------------*
!---
!---    COMPUTE NO/NO2 RATIO ASSUMING PHOTOCHEMICAL EQUILIBRIUM         
!---
! ---   SOLVE SIMULTANEOUSEQUATIONS
! ---      DA1*NO - DA2*NO2 = DD1
! ---    - DB1*NO + DB2*NO2 = DD2
! ---
! ---       DA1*NO......THE RATE OF LOSS TERM OF NO
! ---       DA2*NO2.....THE RATE OF PRODUCTION OF NO FROM NO2
! ---       DB1*NO......THE RATE OF PRODUCTION OF NO2 FROM NO
! ---       DB2*NO2.....THE RATE OF LOSS TERM OF NO2
! ---       DD1.........THE TOTAL PRODUCTION TERM (P) FOR NO LESS
! ---                   CONTRIBUTIONS FROM NO2
! ---       DD2.........THE TOTAL PRODUCTION TERM (P) FOR NO2 LESS
! ---                   CONTRIBUTIONS FROM NO
! ---------------------------------------------------------------------*
          ANOX = ANOZ(IL) - DYZ(IL,6) - DYZ(IL,18)
          DAX = RATES(IL, 4)*DYZ(IL, 1) + RATES(IL,18)*DYZ(IL, 8) +          &
                RATES(IL,22)*DYZ(IL,11) + RATES(IL,43)*DYZ(IL,13) +         &
                RATES(IL,53)*DYZ(IL,6) + RATES(IL,55)*DYZ(IL,16) +          &
                RATES(IL,64)*DYZ(IL,2)          
          DA1 = DAX + RATES(IL,65)*DYZ(IL,7) + RATES(IL,67)*DYZ(IL,18) +    &
                FOTO(IL,31)
          DA2 = FOTO(IL,4) + RATES(IL,5)*DYZ(IL,2) +                        &
                RATES(IL,58)*DYZ(IL,6)
          DD1 = FOTO(IL,7)*DYZ(IL,6) + FOTO(IL,26)*DYZ(IL,17) +             &
                RATES(IL,68)*DYZ(IL,18)*O2*RHO(IL) +                        &
                2.*RATES(IL,66)*DYY(IL,20)*DYZ(IL,3)
          DB1 = DAX + RATES(IL,53)*DYZ(IL,6)
          DB2 = DA2 + RATES(IL, 6)*DYZ(IL, 1) + RATES(IL, 7)*DYZ(IL, 6) +    &
                      RATES(IL,17)*DYZ(IL, 7) + RATES(IL,23)*DYZ(IL,11) +    &
                      RATES(IL,40)*DYZ(IL,13) + RATES(IL,49)*DYZ(IL, 8) +   &
                      RATES(IL,71)*DYZ(IL,18)
          DD2 = RATES(IL, 8)*DYY(IL,2) + FOTO(IL, 5)*DYY(IL,1) +             &
                 FOTO(IL, 6)*DYZ(IL,6) + FOTO(IL, 8)*DYY(IL,2) +             &
               (RATES(IL,50)*DYZ(IL,7) + FOTO(IL,25) + RATES(IL,63))*       &
              DYY(IL,10) + 2.*RATES(IL,59)*DYZ(IL,6)**2 +                   &
              RATES(IL,60)*DYZ(IL,7)*DYZ(IL,17)
          DDNUM = DD2*DA1 + DB1*DD1
          IF(DDNUM.NE.0.) THEN
            RATIO = (DB2*DD1 + DA2*DD2)/DDNUM
          ELSE
            RATIO = 0.
          ENDIF
          DYZ(IL,5) = ANOX/(1. + RATIO)
          DYZ(IL,4) = RATIO*DYZ(IL,5)
  910   ENDDO
!----------------------------------------------------------------------*
!---
!---    COMPUTE THE BR/BRO AND BR/BRCL RATIO FROM THE EQUATIONS         
!---
! ---   SOLVE THREE WAY SIMULTANEOUSEQUATIONS                          
! ---      DA1*BR - DA2*BRO - DA3*BRCL = DD1                            
! ---    - DB1*BR + DB2*BRO            = DD2                            
! ---             - DC2*BRO + DC3*BRCL = DD3                            
! ---
! ---------------------------------------------------------------------*
        DO 930 IL = 1,MERIDS
          DA1 = RATES(IL,39)*DYZ(IL, 1) + RATES(IL,45)*DYZ(IL,8) +           &
                RATES(IL,46)*DYY(IL, 7)
          DA2 = RATES(IL,41)*DYZ(IL,11) + RATES(IL,43)*DYZ(IL,4) +           &
                 FOTO(IL,19)
          DA3 =  FOTO(IL,24)
          DD1 = RATES(IL,    47)*DYZ(IL, 7)*DYY(IL,11) +                     &
             2.*RATES(IL,IHET+7)*DYY(IL,11)*DYY(IL, 9) +                     &
                 FOTO(IL,    17)*DYY(IL,12)            +                     &
                 FOTO(IL,    18)*DYY(IL, 9)
          DB1 = RATES(IL,    39)*DYZ(IL, 1)
          DB2 = DA2 + RATES(IL,40)*DYZ(IL, 5) + RATES(IL,42)*DYZ(IL,8) +     &
                      RATES(IL,48)*DYZ(IL,11)
          DD2 = RATES(IL,44)*DYZ(IL, 2)*DYY(IL,9)
          DC2 = RATES(IL,48)*DYZ(IL,11)
          DC3 = DA3
          DD3 = RATES(IL,IHET+5)*DYY(IL, 9)*DYY(IL,4) +                      &
                RATES(IL,IHET+6)*DYY(IL,11)*DYY(IL,5)
!
          R1 = 0.0
          R2 = 0.0
          DD13 = DD1*DC3 + DD3*DA3
          DDNUM = DD13*DB1 + DD2*DA1*DC3
          IF(DDNUM.GT.0.0) THEN
            VDDNUM = 1.0/DDNUM
            DAC2 = DA2*DC3 + DC2*DA3
            R1 = (DD13*DB2 + DD2*DAC2)*VDDNUM
            DA12 = DA1*DB2 - DA2*DB1
            IF(DA12.LT.0.0) DA12 = 0.0
            DD12 = DA1*DD2 + DB1*DD1
            R2 = (DD12*DC2 + DD3*DA12)*VDDNUM
          ENDIF
          IF (FOTO(IL,24).GT.0.0) THEN    
            DYZ(IL,13) = BROX(IL)/(1. + R1 + R2)
            DYZ(IL,12) = R1*DYZ(IL,13)
            DYZ(IL,15) = R2*DYZ(IL,13)
          ELSE
            DYZ(IL,13) = 0.0
            DYZ(IL,12) = 0.0
            DYZ(IL,15) = BROX(IL)
          ENDIF
  930   ENDDO
!----------------------------------------------------------------------*
!---
!---    COMPUTE CL/CLO RATIO ASSUMING PHOTOCHEMICAL EQUILIBRIUM         
!---
! ---   SOLVE SIMULTANEOUS EQUATIONS
! ---      DA1*CL - DA2*CLO = DD1
! ---    - DB1*CL + DB2*CLO = DD2
! ---
! ---------------------------------------------------------------------*
        DO 940 IL = 1,MERIDS
          DA1 = RATES(IL,20)*DYZ(IL, 1) + RATES(IL,25)*DYY(IL,18) +         &
                RATES(IL,27)*DYZ(IL, 8) + RATES(IL,33)*DYY(IL, 7)      
          DA2 = RATES(IL,21)*DYZ(IL, 2) + RATES(IL,22)*DYZ(IL, 4) +         &
                RATES(IL,29)*DYZ(IL, 7) + RATES(IL,41)*DYZ(IL,13)      
          DD1 = RATES(IL,26)*DYZ(IL, 7)*DYY(IL,4) + FOTO(IL,15)*DYY(IL,5) +  &
              2.*FOTO(IL,16)*DYZ(IL,14) +  FOTO(IL,12)*DYY(IL,6) +           &
                 FOTO(IL,24)*DYZ(IL,15) +  FOTO(IL,33)*DYY(IL,4)
          DB1 = RATES(IL,20)*DYZ(IL, 1)
          DB2 = RATES(IL,21)*DYZ(IL, 2) + RATES(IL,22)*DYZ(IL, 4)    +       &
                RATES(IL,23)*DYZ(IL, 5) + RATES(IL,28)*DYZ(IL, 8)    +       &
               (RATES(IL,29) + RATES(IL,69))*DYZ(IL, 7) +                   &
                RATES(IL,37)*DYZ(IL,11)*2. +                                &
               (RATES(IL,41) + RATES(IL,48))*DYZ(IL,13)
          DD2 = RATES(IL,24)*DYZ(IL, 2)*DYY(IL,6) +                          &
             2.*RATES(IL,38)*DYZ(IL,14)
          DDNUM = DD2*DA1 + DB1*DD1
          IF(DDNUM.NE.0.) THEN
            RATIO = (DB2*DD1 + DA2*DD2)/DDNUM
          ELSE
            RATIO = 0.
          ENDIF
          CLX = CLOX(IL) - DYZ(IL,15)
          IF(CLX.LT.0.0) CLX = 0.0
          IF(FOTO(IL,15).GT.0.0)  THEN
            TAU = RATES(IL,37)/(FOTO(IL,16) + RATES(IL,38))                
            RAT1 = TAU*DYZ(IL,11)
            DYZ(IL,11) = CLX/(1. + RATIO + 2.*RAT1)
            RAT1 = TAU*DYZ(IL,11)
            DYZ(IL,11) = CLX/(1. + RATIO + 2.*RAT1)
            DYZ(IL,10) = DYZ(IL,11)*RATIO
            DYZ(IL,14) = DYZ(IL,11)*RAT1
          ELSE
            DYZ(IL,10) = 0.
            DYZ(IL,11) = 0.
            DYZ(IL,14) = CLX*0.5
          ENDIF
  940   ENDDO
!----------------------------------------------------------------------*
!---
!---    COMPUTE HO2 AND OH ASSUMING PHOTOCHEMICAL EQUILIBRIUM           
!---
! ---   SOLVE SIMULTANEOUSEQUATIONS
! ---      DA1*OH - DA2*HO2 = DD1
! ---    - DB1*OH + DB2*HO2 = DD2
! ---
! ---------------------------------------------------------------------*
        DO 950 IL = 1,MERIDS
          BX1 = RATES(IL,17)*DYZ(IL, 5) +                                   &
                RATES(IL,19)*DYY(IL, 1) + RATES(IL,26)*DYY(IL, 4) +         &
                RATES(IL,31)*DYY(IL,18) + RATES(IL,50)*DYY(IL,10) +         &
                RATES(IL,57)*DYY(IL,13) + RATES(IL,60)*DYZ(IL,17) +         &
                RATES(IL,65)*DYZ(IL,4) + RATES(IL,69)*DYZ(IL,11)
          BX2 = RATES(IL,27)*DYZ(IL,10) + RATES(IL,28)*DYZ(IL,11) +         &
                RATES(IL,42)*DYZ(IL,13) + RATES(IL,45)*DYZ(IL,12) +         &
                RATES(IL,49)*DYZ(IL, 5) + RATES(IL,56)*DYZ(IL,16)
          DB1 = RATES(IL,10)*DYZ(IL, 1) + RATES(IL,12)*DYZ(IL, 2) +         &
                RATES(IL,29)*DYZ(IL,11) + RATES(IL,32)*DYY(IL, 7) +         &
                RATES(IL,36)*DYY(IL,3) +  RATES(IL,47)*DYY(IL,11) +         &
                RATES(IL,52)*DYY(IL,14) + RATES(IL,54)*H2*RHO(IL)
          DA1 = DB1 + BX1 + RATES(IL,16)*DYZ(IL, 8) +                       &
                 (RATES(IL,35) + RATES(IL,51))*DYZ(IL,7)*2.
          DA2 = RATES(IL,11)*DYZ(IL, 2) + RATES(IL,15)*DYZ(IL,1) +          &
                RATES(IL,18)*DYZ(IL, 4)
          DB2 = RATES(IL,16)*DYZ(IL, 7) + RATES(IL,34)*DYZ(IL,8)*2. +       &
                DA2 + BX2
          DD1 = DYZ(IL,3)*(2.*RATES(IL, 9)*H2O(IL) +                        &
                              RATES(IL,30)*DYY(IL,18)) +                    &
                RATES(IL,44)*DYZ(IL,2)*DYY(IL,9) +                          &
                2.*RATES(IL,61)*DYZ(IL,16)**2 +                             &
                 FOTO(IL, 5)*DYY(IL, 1) +  FOTO(IL,15)*DYY(IL, 5) +         &
              2.*FOTO(IL,11)*DYY(IL, 3) +  FOTO(IL,18)*DYY(IL, 9) +         &
                FOTO(IL,26)*DYZ(IL,17) +                                    &
! FOTO(IL,27) IS TAKEN AS A PROXY FOR CH3O2 + HV --> H2CO + OH      
                FOTO(IL,27)*(DYZ(IL,16)+DYY(IL,13)) +                       &
                FOTO(IL,32)*H2O(IL)
          DD2 = (RATES(IL,33)*DYZ(IL,10) +                                  &
                RATES(IL,46)*DYZ(IL,12) + FOTO(IL,13)*2.0)*DYY(IL,7) +      &
                RATES(IL,55)*DYZ(IL,4)*DYZ(IL,16) +                         &
                RATES(IL,62)*DYZ(IL,6)*DYY(IL,7) +                          &
                RATES(IL,63)*DYY(IL,10) + FOTO(IL,25)*DYY(IL,10) +          &
                FOTO(IL,27)*DYY(IL,13) +                                    &
                FOTO(IL,32)*H2O(IL)  +  FOTO(IL,33)*DYY(IL,4) +             &
                FOTO(IL,32)*DYY(IL,18)*1.53/1.83
          DDNUM = DB2*DD1 + DA2*DD2
          IF(DD1.NE.0.0.AND.DD2.NE.0.0) THEN
            RATIO2 = (DD2*DA1 + DB1*DD1)/DDNUM
            AX = 4.*(RATES(IL,16)*RATIO2 + RATES(IL,34)*RATIO2**2 +        &
                  RATES(IL,35) + RATES(IL,51))
            BX = BX1 + RATIO2*BX2
            CX = DD1 + DD2
            IF(CX.LT.0.) CX = 0.0
            IF(BX.LT.0.) BX = 0.0
            IF(BX.EQ.0.) THEN
              DYZ(IL,7) = SQRT(2.*CX/AX)
            ELSE
              DYZ(IL,7) = (-BX + SQRT(BX**2 + 2.*AX*CX))/AX
            ENDIF
            DYZ(IL,8) = RATIO2*DYZ(IL,7)
          ELSE
            DYZ(IL,7) = 0.0
            DYZ(IL,8) = 0.0
          ENDIF
          RATIO1 = RATES(IL,12)*DYZ(IL,2)/(RATES(IL,14) +                   &
                   RATES(IL,13)*DYZ(IL,1))
          DYZ(IL,9) = RATIO1*DYZ(IL,7)
  950   ENDDO
!----------------------------------------------------------------------*
!---
!---    COMPUTE CH3O2 AND HONO ASSUMING PHOTOCHEMICAL EQUILIBRIUM           
!---
!----------------------------------------------------------------------*
        DO 960 IL = 1,MERIDS
          AX = 4.*RATES(IL,61)
!
! FOTO(IL,27) IS TAKEN AS A PROXY FOR CH3O2 + HV --> H2CO + OH
!
          BX = RATES(IL,55)*DYZ(IL,4) + RATES(IL,56)*DYZ(IL,8) +            &
               FOTO(IL,27)
          CX = (RATES(IL,25)*DYZ(IL,10) + RATES(IL,30)*DYZ(IL,3) +          &
                RATES(IL,31)*DYZ(IL,7) + FOTO(IL,32)*1.53/1.83)*DYY(IL,18) + &
                RATES(IL,57)*DYZ(IL,7)*DYY(IL,13)
          IF(CX.LT.0.) CX = 0.0
          IF(BX.LT.0.) BX = 0.0
          IF(BX.EQ.0.) THEN
            DYZ(IL,16) = SQRT(2.*CX/AX)
          ELSE
            DYZ(IL,16) = (-BX + SQRT(BX**2 + 2.*AX*CX))/AX
          ENDIF
  960   ENDDO!CONTINUE
        DO 970 IL = 1,MERIDS
          DDNUM = RATES(IL,60)*DYZ(IL,7) + FOTO(IL,26)
          IF(DDNUM.NE.0.0)  THEN
            DYZ(IL,17) = RATES(IL,65)*DYZ(IL,7)*DYZ(IL,4)/DDNUM
          ELSE
            DYZ(IL,17) = RATES(IL,65)*DYZ(IL,4)/RATES(IL,60)
          ENDIF
  970   ENDDO!CONTINUE
        IF(IT.EQ.1.AND.ITX.EQ.1) THEN
          DO IC = 1,JIMPL
            DO IL = 1,MERIDS
              DYZ1(IL,IC) = DYZ(IL,IC)
            ENDDO
          ENDDO
        ELSE
          DO IC = 1,JIMPL
            DO IL = 1,MERIDS
              XYZ = (DYZ(IL,IC) + DYZ1(IL,IC))*0.5
              DYZ(IL,IC) = XYZ
              DYZ1(IL,IC) = XYZ
            ENDDO
          ENDDO
        ENDIF
!----------------------------------------------------------------------*
!   INTEGRATE MODEL FOR SINGLE TIMESTEP OF LENGTH DT
! --- THE CHEMISTRY SCHEME CALCULATES DESTRUCTION AND
! --- PRODUCTION TERMS READY FOR AN INTEGRATION OF THE FORM
! ---
! ---                 Y = P/Q + (Y - P/Q)*EXP(-Q.DT)
! ---
! ---EXCEPT WHERE Q.DT IS SMALL, WHERE 
! ---   
! ---                 Y = (Y/DT + P)/(Q + 1/DT)
! ---
! --- (FIRST ORDER EULER BACKWARD SCHEME) IS USED.
! ---
! ---   DQT : TOTAL DESTRUCTION RATE (FOR EACH EXPLICIT SPECIES)        
! ---   DPT : TOTAL PRODUCTION RATE (FOR EACH EXPLICIT SPECIES)         
! ---
! ---------------------------------------------------------------------*
        DO 990 IL = 1,MERIDS
          JLX = 1 + (PI*0.5 + ALAT(IL))*89.0/PI
!
!   HNO3
!
          DPT(IL,1) = RATES(IL,17)*DYZ(IL,5)*DYZ(IL,7) +                    &
                      RATES(IL,62)*DYZ(IL,6)*DYY(IL,7) +                    &
                      RATES(IL,IHET+1)*DYY(IL, 2)*DYY(IL, 4)    +           &
                      RATES(IL,IHET+2)*H2O(IL)*DYY(IL, 2)*2. +              &
                      RATES(IL,IHET+3)*H2O(IL)*DYY(IL, 6)    +              &
                      RATES(IL,IHET+4)*DYY(IL, 6)*DYY(IL, 4)
!
!  The HNO3 production term from heterogeneous reaction BrONO2 + H2O
!  is sometimes rather fast leading to too much HNO3 extrapolated to the 
!  full timestep. Hence this term is neglected since it should be small in 
!  any case.      
!     *            RATES(IL,IHET+8)*DYY(IL,12)*H2O(IL)  
!
          DQT(IL,1) = RATES(IL,19)*DYZ(IL,7) + FOTO(IL,5)            
!       
!   N2O5
!
          DPT(IL,2) = RATES(IL,7)*DYZ(IL,5)*DYZ(IL,6)
          DQT(IL,2) = RATES(IL,8) + FOTO(IL,8) +                            &
                      RATES(IL,IHET+1)*DYY(IL, 4) +                         &
                      RATES(IL,IHET+2)*H2O(IL)
!
!  H2O2
!
          DPT(IL,3) = RATES(IL,34)*DYZ(IL,8)**2 +                           &
                      RATES(IL,35)*DYZ(IL,7)**2
          DQT(IL,3) = FOTO(IL,11) + RATES(IL,36)*DYZ(IL,7)
!
!  HCl
!
          DPT(IL,4) = DYZ(IL,10)*(RATES(IL,27)*DYZ(IL, 8)  +                &
                                  RATES(IL,33)*DYY(IL, 7)  +                &
                                  RATES(IL,25)*DYY(IL,18)) +                &
                      RATES(IL,69)*DYZ(IL,11)*DYZ(IL,7)
          DQT(IL,4) = RATES(IL,    26)*DYZ(IL, 7)    +                      &
                      RATES(IL,  IHET)*DYY(IL, 5)    +                      &
                      RATES(IL,IHET+1)*DYY(IL, 2)    +                      &
                      RATES(IL,IHET+4)*DYY(IL, 6)    +                      &
                      RATES(IL,IHET+5)*DYY(IL, 9)    +  FOTO(IL,33)
!
!  HOCl
!
          DPT(IL,5) = RATES(IL,    28)*DYZ(IL,11)*DYZ(IL, 8) +              &
                      RATES(IL,IHET+3)*DYY(IL, 6)*H2O(IL)
          DQT(IL,5) = FOTO(IL,15)                 +                         &
                      RATES(IL,  IHET)*DYY(IL, 4) +                         &
                      RATES(IL,IHET+6)*DYY(IL,11)
!
!  ClONO2
!
          DPT(IL,6) = RATES(IL,23)*DYZ(IL,11)*DYZ(IL,5)
          DQT(IL,6) = RATES(IL,24)*DYZ(IL, 2) + FOTO(IL,12) +               &
                      RATES(IL,IHET+3)*H2O(IL) +                            &
                      RATES(IL,IHET+4)*DYY(IL, 4)
!
!  H2CO
!
          DPT(IL,7) = DYZ(IL,16)*(RATES(IL,55)*DYZ(IL,4) +                  &
                    2.*RATES(IL,61)*DYZ(IL,16)) + FOTO(IL,27)*DYY(IL,13)
          DQT(IL,7) = FOTO(IL,13) + FOTO(IL,14) +                           &
                      RATES(IL,32)*DYZ(IL, 7) + RATES(IL,33)*DYZ(IL,10) +   &
                      RATES(IL,46)*DYZ(IL,12) + RATES(IL,62)*DYZ(IL,6)          
!
! Oy
!
          DPT(IL,8) = RATES(IL,51)*DYZ(IL,7)**2 +                           &
                   2.*FOTO(IL,1)*O2*RHO(IL) + FOTO(IL, 4)*DYZ(IL, 5) +      &
                      FOTO(IL,19)*DYZ(IL,13) + FOTO(IL,28)*DYY(IL,20)    
          DQT1 = RAT(IL,1)*                                                 &
                (RATES(IL, 4)*DYZ(IL, 4) +                                  &
                RATES(IL,10)*DYZ(IL, 7) + RATES(IL,13)*DYZ(IL, 9) +         &
                RATES(IL,15)*DYZ(IL, 8) + RATES(IL,20)*DYZ(IL,10) +         &
                RATES(IL,39)*DYZ(IL,12))
!     &      RATES(IL,15)*DYZ(IL, 8) + RATES(IL,20)*DYZ(IL,10))
          DQT2 = RAT(IL,2)*                                                 &
            (2.*RATES(IL, 2)*DYZ(IL, 1) + RATES(IL, 5)*DYZ(IL, 5) +         &
                RATES(IL,11)*DYZ(IL, 8) + RATES(IL,12)*DYZ(IL, 7) +         &
                RATES(IL,21)*DYZ(IL,11) + RATES(IL,24)*DYY(IL, 6) +         &
                RATES(IL,44)*DYY(IL,9)  + RATES(IL,64)*DYZ(IL, 4))
          DQT3 = RAT(IL,3)*                                                 &
               (RATES(IL, 9)*H2O(IL) +                                      &
                RATES(IL,30)*DYY(IL,18))
!      DQT4 = RATES(IL,39)*OZONE(IL)*ISTEP_CHEM
!      IF(DQT4.GT.1.0) DQT4 = 1.0 
!      DQT(IL,8) = DQT1 + DQT2 + DQT3 + DQT4*DYZ(IL,12)/(ISTEP_CHEM*OZONE(IL))
          DQT(IL,8) = DQT1 + DQT2 + DQT3 
!
!  HOBr
!
          DPT(IL,9) = RATES(IL,    42)*DYZ(IL,13)*DYZ(IL, 8) +              &
                      RATES(IL,IHET+8)*H2O(IL)*DYY(IL,12)
          DQT(IL,9) = FOTO(IL,18) + RATES(IL,44)*DYZ(IL,2) +                &
                      RATES(IL,IHET+5)*DYY(IL, 4)          +                &
                      RATES(IL,IHET+7)*DYY(IL,11)
!  
!  HNO4
!
          DPT(IL,10) = RATES(IL,49)*DYZ(IL,8)*DYZ(IL,5)
          DQT(IL,10) = FOTO(IL,25) + RATES(IL,50)*DYZ(IL,7) +               &
                       RATES(IL,63)
!
!  HBr
!
          DPT(IL,11) = RATES(IL,45)*DYZ(IL,12)*DYZ(IL,8) +                  &
                       RATES(IL,46)*DYZ(IL,12)*DYY(IL,7)
          DQT(IL,11) = RATES(IL,    47)*DYZ(IL, 7) +                        &
                       RATES(IL,IHET+6)*DYY(IL, 5) +                        &
                       RATES(IL,IHET+7)*DYY(IL, 9)
!
!  BrONO2
!
          DPT(IL,12) = RATES(IL,40)*DYZ(IL,13)*DYZ(IL,5)
          DQT(IL,12) = FOTO(IL,17) + RATES(IL,IHET+8)*H2O(IL)
!
!  CH3OOH
!
          DPT(IL,13) = RATES(IL,56)*DYZ(IL,16)*DYZ(IL,8)
          DQT(IL,13) = FOTO(IL,27) + RATES(IL,57)*DYZ(IL,7)
!
! CO
!
          DPT(IL,14) = DYY(IL,7)*                                           &
                  (RATES(IL,32)*DYZ(IL,7) + RATES(IL,33)*DYZ(IL,10) +       &
                   RATES(IL,46)*DYZ(IL,12) + RATES(IL,62)*DYZ(IL,6) +       &
                   FOTO(IL,13) + FOTO(IL,14))
          DQT(IL,14) = RATES(IL,52)*DYZ(IL,7)
!
!  NOY + NAT: Normal Stratospheric terms, relax towards ANOY in the 
!  troposphere
!
          AGESQ = 1.0E-2
          IF(DAGESQ(IL).LT.AGESQ) THEN
            DPT(IL,15) = ANOY(JLX,KL)*RHO(IL)*VTAU10
            DQT(IL,15) = VTAU10
          ELSE
            DPT(IL,15) = 2.*RATES(IL,66)*DYZ(IL,3)*DYY(IL,20)
            DQT(IL,15) = 2.*DYZ(IL,18)*                                     &
                   (RATES(IL,67)*DYZ(IL,4)+RATES(IL,71)*DYZ(IL,5))/DYY(IL,15)
          ENDIF
!
!  Cly: solved separately after call to chemistry; set to zero here
!
          DPT(IL,16) = 0.0
          DQT(IL,16) = 0.0
!
!  Bry: solved separately after call to chemistry; set to zero here
!
          DPT(IL,17) = 0.0
          DQT(IL,17) = 0.0
!
!  CH4: Production rate assumes relaxation to a uniform tropospheric value 
!  with a 10 day time scale
!  DAGESQ < 0.01 is used to denote the troposphere. 
!
          IF(DAGESQ(IL).LT.AGESQ) THEN
            DPT(IL,18) = CH4*VTAU10*RHO(IL)
            DQT(IL,18) = VTAU10 
          ELSE
            DPT(IL,18) = 0.0
!  
! Mesospheric loss of CH4 by lyman alpha photolysis is taken to be the H2O 
! photolysis rate weighted by the ratio of the cross sections
! 
            DQT(IL,18) = RATES(IL,25)*DYZ(IL,10) + RATES(IL,30)*DYZ(IL,3) +   &
                         RATES(IL,31)*DYZ(IL,7) + FOTO(IL,32)*1.53/1.83
          ENDIF
!
!  h2ostrat: not used
!
          DPT(IL,19) = 0.0
          DQT(IL,19) = 0.0
!
!  N2O: Production rate assumes relaxation to a uniform tropospheric value 
!  with a 10 day time scale
!  DAGESQ < 0.01 is used to denote the troposphere. 
!
          IF(DAGESQ(IL).LT.AGESQ) THEN
            DPT(IL,20) = AN2O*VTAU10*RHO(IL)
            DQT(IL,20) = VTAU10
          ELSE
            DPT(IL,20) = RATES(IL,71)*DYZ(IL,5)*DYZ(IL,18)
            DQT(IL,20) = (RATES(IL,66)+RATES(IL,70))*DYZ(IL,3) +           &
                          FOTO(IL,28)
          ENDIF
!
!  AGE OF AIR: Increase at the rate of 1 per second outside the troposphere.
!  Results expressed in years. Relax towards zero with a 10 
!  day timescale in the troposphere, denoted by DAGESQ less than 0.01 
!
          IF(DAGESQ(IL).LT.AGESQ) THEN
            DPT(IL,21) = 0.0
            DQT(IL,21) = VTAU10
          ELSE
            DPT(IL,21) = VTAUYR*RHO(IL)
            DQT(IL,21) = 0.0
          ENDIF
!
!  H2O + ICE
!
          DP1(IL) = DYZ(IL,7)*( RATES(IL,16)*DYZ(IL,8) +                    &
             RATES(IL,19)*DYY(IL,1) + RATES(IL,26)*DYY(IL,4) +              &
             RATES(IL,31)*DYY(IL,18) + RATES(IL,32)*DYY(IL,7) +             &
             RATES(IL,36)*DYY(IL,3) + RATES(IL,50)*DYY(IL,10) +             &
             RATES(IL,47)*DYY(IL,11) +                                      &
             RATES(IL,51)*DYZ(IL,7) + RATES(IL,54)*H2*RHO(IL) +             &
             RATES(IL,57)*DYY(IL,13) + RATES(IL,60)*DYZ(IL,17) )
          DQ1(IL) = FOTO(IL,32) + RATES(IL,9)*DYZ(IL,3)
  990   ENDDO
! ---------------------------------------------------------------------*
! ---
! ---  INTEGRATE NCHEM SPECIES EXPLICITLY
! ---
! ---------------------------------------------------------------------*
        DO 980 NC = 1,NCHEM
          DO  IL = 1,MERIDS
            T0 = DQT(IL,NC)/DVDT
            IF(T0 .LT. 1.0E-6) THEN 
              DYY1(IL,NC) = (DYY(IL,NC)*DVDT + DPT(IL,NC))/(DQT(IL,NC)+DVDT)
! The following line changes answers but should be equivalent to the above..
!              DYY1(IL,NC) = (DYY(IL,NC) + DPT(IL,NC)/DVDT)/(T0+1.0)
            ELSE
              minusT0 = -1.0*T0
              T1 = DPT(IL,NC)/DQT(IL,NC)
!              DYY1(IL,NC) = T1 + (DYY(IL,NC) - T1)*EXP(-1.0*T0)
              DYY1(IL,NC) = T1 + (DYY(IL,NC) - T1)*EXP(minusT0)
            ENDIF
          ENDDO
  980   ENDDO!CONTINUE 
        DO  IL = 1,MERIDS
          H2O1(IL) = (H2O(IL)*DVDT + DP1(IL))/(DQ1(IL)+DVDT)
!
! SPECIAL CODE TO ENSURE THAT THE BROMINE SPECIES ARE UNDER CONTROL DURING
! THE RAPIDLY VARYING PERIOD AT DAWN AND DUSK
!
          BRX = DYY1(IL,9) + DYY1(IL,11) + DYY1(IL,12) + DYZ(IL,12) +       &
                DYZ(IL,13) + DYZ(IL,15)
          IF(DYY1(IL,17).EQ.0.0) THEN
            RATIO = 0.0
          ELSE
            RATIO = BRX/DYY1(IL,17)
          ENDIF
          IF(RATIO.GT.1.0) THEN
            DYY1(IL,9) = DYY1(IL,9)/RATIO
            DYY1(IL,11) = DYY1(IL,11)/RATIO
            DYY1(IL,12) = DYY1(IL,12)/RATIO
            DYZ(IL,12) = DYZ(IL,12)/RATIO
            DYZ(IL,13) = DYZ(IL,13)/RATIO
            DYZ(IL,15) = DYZ(IL,15)/RATIO
          ENDIF
!
!  SPECIAL CODE TO ENSURE THAT THE HETEROGENEOUS SCHEME DOES NOT PRODUCE
! EXCESSIVE HNO3. IF HNO3 EXCEEDS NOy - 2.*N2O5 SET HNO3 TO  NOy - 2.*N2O5
!
          DIFF = DYY1(IL,15) - 2.0*DYY1(IL,2)
          IF (DYY1(IL,1).GT.DIFF) DYY1(IL,1) = DIFF
        ENDDO
 1000 ENDDO
!
!  COMPUTE INCREMENT TO O3_CHEM DIAGNOSTIC TRACER
!
      DO IL = 1,MERIDS
        O3_PROD(IL) = O3_PROD(IL) +                                     &
             (DPT(IL,8) - DQT(IL,8)*DYY(IL,8))*RAT(IL,1)*DELT/RHO(IL)
      ENDDO
      IF(ITIME_LEFT .GT. 0) THEN
        DO NC = 1,NCHEM
          DO IL = 1,MERIDS
            DYY(IL,NC) = DYY1(IL,NC)
            H2O(IL) = H2O1(IL)
          ENDDO
        ENDDO
        CYCLE
      ELSE
        EXIT
      ENDIF
 1100 ENDDO
! ---------------------------------------------------------------------*
! ---
! --- COMPUTE CHEMICAL INCREMENTS FOR THIS SUPER-TIMESTEP   
! ---
! ---------------------------------------------------------------------*
!
!  GET CHEM TENDENCY AND CONVERT TO MIXING RATIOS
!
      DO IL = 1,MERIDS
        VRHO = 1.0/(RHO(IL)*DT)
        DO NC = 1,NCHEM
          CH_TEND(IL,NC) = CH_TEND(IL,NC) +                             &
                           (DYY1(IL,NC) - DYY0(IL,NC))*VRHO
       ENDDO
          H2O_TEND(IL) = H2O_TEND(IL) + (H2O1(IL) - H2O0(IL))*VRHO
      ENDDO
!
! SET OZONE CONCENTRATION
!
      DO IL = 1,MERIDS
        OZONE(IL) = DYZ(IL,1)/RHO(IL)
      ENDDO
!
#ifdef _ALLOC
      deallocate(RATES)
      deallocate(FOTO)
      deallocate(DYY)
      deallocate(DYZ)
      deallocate(DQT)
      deallocate(DPT)
      deallocate(RAT)
      deallocate(DYZ1)
      deallocate(DYY0)
      deallocate(DYY1)
      deallocate(COND)
      deallocate(GAMMA)
#endif
      RETURN
END SUBROUTINE CHEMISTRY
!         
SUBROUTINE DCLY_DT(age,dfdage,tropc,tracer1,cly,bry,dclydt,dbrydt, &
           agefact2,merids,lats,levels,itime)       
!----------------------------------------------------------------------*
!      age:  Age of air since stratospheric entry in years.                
!
!      The order of dfdage array elements is:
!
!      1. CFC11 as a fraction of its tropospheric concentration.        
!      2.-7.  CFC12, CFC113, CCL4, CH3CL, CH3CCL3, HCFC22 
!      8  Bry as a fraction of its tropospheric concentration
!
!      TROPC contains the tropospheric concentrations for 1950.0-2100.0 
!      at annual intervals. The species are ordered as dfdage elements 1-7 
!      and Total organic Cl and Br.
!----------------------------------------------------------------------*
      IMPLICIT NONE
      
      integer, intent(in) :: MERIDS,LATS,LEVELS,itime(6) 
      REAL, intent(in) :: age(merids,lats,levels),dfdage(90,48,8),TROPC(151,9), &
            cly(merids,lats,levels),bry(merids,lats,levels),         &
            tracer1(merids,lats,levels)
      REAL, intent(inout) :: dclydt(merids,lats,levels), &
            dbrydt(merids,lats,levels)
      REAL, intent(in) :: AGEFACT2
            
      
      INTEGER MDAY(12)
      INTEGER IANN,IMON,IDAY,IMON1,IT1,IT2,IC,KL,JL, &
              IL,IY,IY1,IM,MX
      REAL  CLWEIGHT(7),                    &
            dfdtau(merids,lats,8),          &
            cfc(merids,lats,9),cfct(9,2)

      REAL  YSTART,TFACT,AGEFACT1,DX1,DX2,TIME,DT1,DT2,SUM1,   &
            SUM2,FACTOR,YY,Y1,Y2,clytot,brytot
      DATA MDAY/31,28,31,30,31,30,31,31,30,31,30,31/
      DATA YSTART/1950.0/
      DATA CLWEIGHT/ 3.0, 2.0, 3.0, 4.0, 1.0, 3.0, 1.0 / 
!
!      Interpolate between months for TAB array
!
      iann = itime(1)
      imon = itime(2)
      iday = itime(3)
      tfact = 1.0/(365.25*86400.0)
!
! agefact1 and agefact2 are fudge factors, to correct for low model 
! atmospheric age in the computation of the halogen rates of change.
!
      agefact1 = 1.25
      DX1 = IDAY/MDAY(IMON)
      IF(IMON.EQ.2.AND.4*(IANN/4).EQ.IANN) DX1 = IDAY/29.0
      DX2 = 1.0 - DX1
      IMON1 = IMON + 1
      IF(IMON1.EQ.13) IMON1 = 1
!
!  Compute multiplying factor for missing CFCs, and include factor for 
!  conversion of rates to a per second rate. 
!
      TIME = REAL(IANN) + (REAL(imon)-1.0)/12.0
      IT1 = INT(TIME - YSTART) + 1
      IF(IT1 .LT. 1) IT1 = 1
      IF(IT1 .GT. 150) IT1 = 150
      IT2 = IT1 + 1
      DT1 = TIME - REAL(IT1) - (YSTART - 1.0)
      DT2 = 1.0 - DT1
      sum1 = 0.0
      sum2 = 0.0
      do ic = 1,7
        sum1 = sum1 + clweight(ic)*tropc(it1,ic)
        sum2 = sum2 + clweight(ic)*tropc(it2,ic)
      enddo
      factor = (dt2*tropc(it1,8) + dt1*tropc(it2,8))*tfact/             &
                (sum1*dt2 + sum2*dt1)
      do 500 kl = 1,levels
!----------------------------------------------------------------------*
!  determine age and dfdage at air parcel positions using tracer
!----------------------------------------------------------------------*
        do jl = 1,lats
          do il = 1,merids
            yy = tracer1(il,jl,kl)
            IF(YY.LT.1.)  YY =  1.01
            IF(YY.GT.89.99) YY = 89.99
            IY = YY
            Y1 = YY - IY
            Y2 = 1. - Y1
            IY1 = IY + 1
            do ic = 1,8
            dfdtau(il,jl,ic) = y2*dfdage(iy,kl,ic) + y1*dfdage(iy1,kl,ic)
            enddo
          enddo
        enddo
!----------------------------------------------------------------------*
!  compute CFCs at time t - age
!----------------------------------------------------------------------*
!      DO 100 JL = 1,lats
!      DO 100 IL = 1,merids
        DO JL = 1,lats
          DO IL = 1,merids
            DO IM = 1,2
              MX = IM + IMON - 1
              IF(MX.EQ.13) MX = 1
              TIME = REAL(IANN) + (REAL(MX)-1.0)/12.0 - age(IL,JL,kl)*agefact1  
!
!      Interpolate the tropospheric gas concs in time
!
              IT1 = INT(TIME - YSTART) + 1
              IF(IT1 .LT. 1) IT1 = 1
              IF(IT1 .GT. 150) IT1 = 150
              IT2 = IT1 + 1
              DT1 = TIME - REAL(IT1) - (YSTART - 1.0)
              DT2 = 1.0 - DT1
              DO IC=1,9
                CFCT(IC,IM) = TROPC(IT1,IC)*DT2 + TROPC(IT2,IC)*DT1                
              ENDDO! IC
            ENDDO! IM
            DO IC = 1,9
              CFC(IL,JL,IC) =  CFCT(IC,1)*DX2 +  CFCT(IC,2)*DX1  
            ENDDO !IC
          ENDDO
        ENDDO
! 100  CONTINUE
!----------------------------------------------------------------------*
!  Finally compute dclydt and dbrydt
!----------------------------------------------------------------------*
        do jl = 1,lats
          do il = 1,merids
            dclydt(il,jl,kl) = 0.0
            do ic = 1,7
              dclydt(il,jl,kl) = dclydt(il,jl,kl) +             &
                  1.0e-12*factor*dfdtau(il,jl,ic)*clweight(ic)* &
                  cfc(il,jl,ic)*agefact2
            enddo
            clytot = cfc(il,jl,8)*1.0e-12
            if(cly(il,jl,kl).ge.clytot) dclydt(il,jl,kl) = 0.0
            dbrydt(il,jl,kl) = 1.0e-12*tfact*dfdtau(il,jl,8)*cfc(il,jl,9)
            brytot = 1.0e-12*cfc(il,jl,9)
            if(bry(il,jl,kl).ge.brytot) dbrydt(il,jl,kl) = 0.0
          enddo
        enddo
 500  ENDDO
      RETURN
END SUBROUTINE DCLY_DT
!
SUBROUTINE REACTION_RATES (RHO,TEMP,VTEMP,PRESS,RATES,            &
                           MERIDS,IHET,NHET)
!-------------------------------------------------------------------------
!
!   THIS SUBROUTINE DETERMINES THE HOMOGENEOUS GAS PHASE REACTION RATES
!
!-------------------------------------------------------------------------
IMPLICIT NONE
INTEGER  , intent(in) :: MERIDS,IHET,NHET
REAL, intent(in), dimension(MERIDS) ::  RHO,TEMP,VTEMP,PRESS
REAL, intent(inout) :: RATES(MERIDS,IHET+NHET-1)
!
INTEGER  IL,IC
REAL TEMP3(MERIDS)
!
REAL  O2,R0,R1,RX,RX1,RX2
!
  DATA O2/0.2095/      
!
  DO IL = 1,MERIDS
    TEMP3(IL) = TEMP(IL)/300.0
  ENDDO   
!
!  RATES TAKEN FROM JPL 2006 
!
  DO IL = 1,MERIDS
!   REACTION 1 O+O2+M --> O3+M
      RATES(IL,1) = 6.0E-34*TEMP3(IL)**(-2.40)*O2*RHO(IL)*RHO(IL)       
!   REACTION 2 O+O3 --> O2+O2
      RATES(IL,2) = 8.0E-12*EXP(-2060*VTEMP(IL))
!   REACTION 3 OSD+M --> O+M N2 & O2 3RD BODY RATES ALLOWED FOR       
      RATES(IL,3) = RHO(IL)*(6.93E-12*EXP(70*VTEMP(IL)) +              &
                               1.677E-11*EXP(110*VTEMP(IL)))
!   REACTION 4 NO+O3 --> NO2+O2
      RATES(IL,4) = 3.0E-12*EXP(-1500*VTEMP(IL))
!   REACTION 5 NO2+O --> NO+O2
      RATES(IL,5) = 5.1E-12*EXP(210*VTEMP(IL))
!   REACTION 6 NO2+O3 --> NO3+O2
      RATES(IL,6) = 1.2E-13*EXP(-2450*VTEMP(IL))
!   REACTION 7 NO2+NO3 + M --> N2O5 + M
      R0 = 2.0E-30*RHO(IL)*TEMP3(IL)**(-4.4)
      R1 = 1.4E-12*TEMP3(IL)**(-0.7)
      RX = ALOG10(R0/R1)
      RATES(IL,7) =(R0/(1.0 + R0/R1))*                                &
                          (0.6**(1.0/(1.0 + (RX*RX))))
!   REACTION 8 N2O5+M --> NO3+NO2+M
      RATES(IL,8) = RATES(IL,7)/(2.7E-27*EXP(11000.0*VTEMP(IL)))
!   REACTION 9 OSD+H2O --> OH+OH
      RATES(IL,9) = 1.63E-10*EXP(60.0*VTEMP(IL))
!   REACTION 10 OH+O3 --> HO2+O2
      RATES(IL,10) = 1.7E-12*EXP(-940.0*VTEMP(IL))
!   REACTION 11 O+HO2 --> OH+O2
      RATES(IL,11) = 3.0E-11*EXP(200.0*VTEMP(IL))
!   REACTION 12 O+OH --> H+O2
      RATES(IL,12) = 2.2E-11*EXP(120.0*VTEMP(IL))
!   REACTION 13 H+O3 --> OH+O2
      RATES(IL,13) = 1.4E-10*EXP(-470.0*VTEMP(IL))
!   REACTION 14 H+O2+M --> HO2+M : MULTIPLIED BY O2 NUMBER DENSITY    
      R0 = 4.4E-32*RHO(IL)*TEMP3(IL)**(-1.3)
      R1 = 4.7E-11*TEMP3(IL)**(-0.2)
      RX = ALOG10(R0/R1)
      RATES(IL,14) =(R0/(1.0 + R0/R1))*                               &
                          (0.6**(1.0/(1.0 + (RX*RX)))) 
      RATES(IL,14) = RATES(IL,14)*O2*RHO(IL)
!   REACTION 15 HO2+O3 --> OH+O2+O2
      RATES(IL,15) = 1.0E-14*EXP(-490.0*VTEMP(IL))
!   REACTION 16 OH+HO2 --> H2O+O2
      RATES(IL,16) = 4.8E-11*EXP(250.0*VTEMP(IL))
!   REACTION 17 OH+NO2+M --> HONO2+M
!   INCLUDE ALSO OH+NO2+M --> HOONO + M
      R0 = 1.8E-30*RHO(IL)*TEMP3(IL)**(-3.0)
      R1 = 2.8E-11
      RX = ALOG10(R0/R1)
      RATES(IL,17) =(R0/(1.0 + R0/R1))*                               &
                          (0.6**(1.0/(1.0 + (RX*RX)))) 
      R0 = 9.1E-32*RHO(IL)*TEMP3(IL)**(-3.9)
      R1 = 4.2E-11*TEMP3(IL)**(-0.5)
      RX = ALOG10(R0/R1)
      RATES(IL,17) = RATES(IL,17) + (R0/(1.0 + R0/R1))*           &
                          (0.6**(1.0/(1.0 + (RX*RX)))) 
!   REACTION 18 NO+HO2 --> NO2+OH
      RATES(IL,18) = 3.5E-12*EXP(250.0*VTEMP(IL))
!   REACTION 19 OH+HNO3 --> H2O+NO3 : SPECIAL TREATMENT               
      RX1 = 6.5E-34*RHO(IL)*EXP(1335.0*VTEMP(IL))            
      RX2 = 2.7E-17*EXP(2199.0*VTEMP(IL))            
      RATES(IL,19) =  2.4E-14*EXP(460.0*VTEMP(IL)) +                        &
                      RX1/(1.0 + RX1/RX2)           
!   REACTION 20 CL+O3 --> CLO+O2
      RATES(IL,20) = 2.3E-11*EXP(-200.0*VTEMP(IL))
!   REACTION 21 O+CLO --> CL+O2
      RATES(IL,21) = 2.8E-11*EXP(85.0*VTEMP(IL))
!   REACTION 22 CLO+NO --> NO2+CL
      RATES(IL,22) = 6.4E-12*EXP(290.0*VTEMP(IL))
!   REACTION 23 CLO+NO2+M --> CLONO2+M
      R0 = 1.8E-31*RHO(IL)*TEMP3(IL)**(-3.4)
      R1 = 1.5E-11*TEMP3(IL)**(-1.9)
      RX = ALOG10(R0/R1)
      RATES(IL,23) =(R0/(1.0 + R0/R1))*                               &
                          (0.6**(1.0/(1.0 + (RX*RX)))) 
!   REACTION 24 O+CLONO2--> CLO+NO3
      RATES(IL,24) = 2.9E-12*EXP(-800.0*VTEMP(IL))
!   REACTION 25 CL+CH4 (+O2) --> HCL+CH3O2
      RATES(IL,25) = 7.3E-12*EXP(-1280.0*VTEMP(IL))
!   REACTION 26 OH+HCL --> H2O+CL
      RATES(IL,26) = 2.6E-12*EXP(-350.0*VTEMP(IL))
!   REACTION 27 CL+HO2 --> HCL+O2
      RATES(IL,27) = 1.8E-11*EXP(170.0*VTEMP(IL))
!   REACTION 28 CLO+HO2 --> HOCL+O2
      RATES(IL,28) = 2.7E-12*EXP(220.0*VTEMP(IL))
!   REACTION 29 CLO+OH --> HO2+CL
      RATES(IL,29) = 7.4E-12*EXP(270.0*VTEMP(IL))
!   REACTION 30 OSD+CH4 --> OH + CH3O2
      RATES(IL,30) = 1.5E-10*EXP(0.0*VTEMP(IL))
!   REACTION 31 OH+CH4 --> H2O + CH3O2
      RATES(IL,31) = 2.45E-12*EXP(-1775.0*VTEMP(IL))
!   REACTION 32 H2CO+OH (+O2) --> H2O + HO2 + CO
      RATES(IL,32) = 5.5E-12*EXP(125.0*VTEMP(IL))
!   REACTION 33 H2CO+CL (+O2) --> HCL+ HO2 + CO        
      RATES(IL,33) = 8.1E-11*EXP(-30.0*VTEMP(IL))
!   REACTION 34 HO2+HO2 --> H2O2+O2
      RATES(IL,34) = 3.5E-13*EXP(430.0*VTEMP(IL)) +                        &
                     1.7E-33*EXP(1000.0*VTEMP(IL))*RHO(IL)                
!   REACTION 35 OH+OH+M --> H2O2+M
      R0 = 6.9E-31*RHO(IL)*TEMP3(IL)**(-1.0)
      R1 = 2.6E-11*TEMP3(IL)**0.0
      RX = ALOG10(R0/R1)
      RATES(IL,35) =(R0/(1.0 + R0/R1))*                               &
                          (0.6**(1.0/(1.0 + (RX*RX)))) 
!   REACTION 36 OH+H2O2 --> HO2+H2O
      RATES(IL,36) = 2.9E-12*EXP(-160.0*VTEMP(IL))
!   REACTION 37 CLO+CLO+M --> CL2O2 + M
      R0 = 1.6E-32*RHO(IL)*TEMP3(IL)**(-4.5)
      R1 = 2.0E-12*TEMP3(IL)**(-2.4)
      RX = ALOG10(R0/R1)
      RATES(IL,37) =(R0/(1.0 + R0/R1))*                               &
                          (0.6**(1.0/(1.0 + (RX*RX)))) 
!   REACTION 38 CL2O2+M --> 2CLO + M
      RATES(IL,38) = RATES(IL,37)/(9.3E-28*EXP(8835.0*VTEMP(IL)))  
!   REACTION 39 BR + O3 --> BRO + O2
      RATES(IL,39) = 1.7E-11*EXP(-800.0*VTEMP(IL))
!   REACTION 40 BRO + NO2 + M --> BRONO2 + M
      R0 = 5.2E-31*RHO(IL)*TEMP3(IL)**(-3.2)
      R1 = 6.9E-12*TEMP3(IL)**(-2.9)
      RX = ALOG10(R0/R1)
      RATES(IL,40) =(R0/(1.0 + R0/R1))*                               &
                          (0.6**(1.0/(1.0 + (RX*RX)))) 
!   REACTION 41 BRO + CLO --> BR + CL + 02
      RATES(IL,41) =  2.3E-12*EXP(260.0*VTEMP(IL))   
!   REACTION 42 BRO + HO2 --> HOBR + O2
      RATES(IL,42) = 4.5E-12*EXP(460.0*VTEMP(IL))
!   REACTION 43 BRO + NO --> BR + NO2
      RATES(IL,43) = 8.8E-12*EXP(260.0*VTEMP(IL))
!   REACTION 44 HOBR + O --> BRO + OH
      RATES(IL,44) = 1.2E-10*EXP(-430.0*VTEMP(IL))
!   REACTION 45 BR + HO2 --> HBR + O2
      RATES(IL,45) = 4.8E-12*EXP(-310.0*VTEMP(IL))
!   REACTION 46 BR + H2CO (+O2) --> HBR + HO2 + CO
      RATES(IL,46) = 1.7E-11*EXP(-800.0*VTEMP(IL))
!   REACTION 47 HBR + OH --> BR + H2O
      RATES(IL,47) = 5.5E-12*EXP(200.0*VTEMP(IL))
!   REACTION 48 BRO + CLO --> BRCL + O2
      RATES(IL,48) = 4.1E-13*EXP(290.0*VTEMP(IL))
!   REACTION 49 HO2 + NO2 + M --> HNO4 + M
      R0 = 2.0E-31*RHO(IL)*TEMP3(IL)**(-3.4)
      R1 = 2.9E-12*TEMP3(IL)**(-1.1)
      RX = ALOG10(R0/R1)
      RATES(IL,49) =(R0/(1.0 + R0/R1))*                               &
                          (0.6**(1.0/(1.0 + (RX*RX)))) 
!   REACTION 50 HNO4 + OH --> H2O + NO2 + O2
      RATES(IL,50) = 1.3E-12*EXP(380.0*VTEMP(IL))
!
! REACTIONS ADDED FOR TROPOSPHERIC CHEMISTRY
!
!   REACTION 51 OH + OH --> H2O + O
      RATES(IL,51) = 1.8E-12
!   REACTION 52 CO + OH (+O2) --> HO2 +CO2
      R0 = 5.9E-33*RHO(IL)*TEMP3(IL)**(-1.4)
      R1 = 1.1E-12*TEMP3(IL)**(1.3)
      RX = ALOG10(R0/R1)
      RATES(IL,52) =    (R0/(1.0 + R0/R1))*                           &
                          (0.6**(1.0/(1.0 + (RX*RX)))) 
      R0 = 1.5E-13*TEMP3(IL)**0.6
      R1 = 2.1E9*TEMP3(IL)**(6.1)/RHO(IL)       
      RX = ALOG10(R0/R1)       
      RATES(IL,52) = RATES(IL,52)+ (R0/(1.0 + R0/R1))*                 &
                          (0.6**(1.0/(1.0 + (RX*RX)))) 
!   REACTION 53 NO3 + NO --> 2NO2
      RATES(IL,53) = 1.5E-11*EXP(170.0*VTEMP(IL))
!   REACTION 54 H2 + OH (+O2) --> HO2 + H2O
      RATES(IL,54) = 5.5E-12*EXP(-2000.0*VTEMP(IL))
!   REACTION 55 CH3O2 + NO (+O2) --> H2CO + NO2 + HO2
      RATES(IL,55) = 2.8E-12*EXP(300.0*VTEMP(IL))
!   REACTION 56 CH3O2 + HO2 --> CH3OOH + O2
      RATES(IL,56) = 4.1E-13*EXP(750.0*VTEMP(IL))
!   REACTION 57 CH3OOH + OH --> CH3O2 + H2O 
      RATES(IL,57) = 3.8E-12*EXP(200.0*VTEMP(IL))
!   REACTION 58 NO2 + NO3 --> NO + NO2 + O2
      RATES(IL,58) = 4.5E-14*EXP(-1260.0*VTEMP(IL))
!   REACTION 59 NO3 + NO3 --> 2NO2 + O2 
      RATES(IL,59) = 8.5E-13*EXP(-2450.0*VTEMP(IL))
!   REACTION 60 OH + HONO --> H2O + NO2
      RATES(IL,60) = 1.8E-11*EXP(-390.0*VTEMP(IL))
!   REACTION 61 CH3O2 + CH3O2 --> 2H2CO + 2OH
      RATES(IL,61) = 9.5E-14*EXP(390.0*VTEMP(IL))
!   REACTION 62 NO3 + HCHO (+O2) --> HNO3 + CO + HO2
      RATES(IL,62) = 5.8E-16
!   REACTION 63 HO2NO2 + M --> HO2 + NO2
      RATES(IL,63) = RATES(IL,49)*4.762E26*EXP(-10900*VTEMP(IL))
!   REACTION 64 NO + O + M --> NO2 + M
      R0 = 9.0E-31*RHO(IL)*TEMP3(IL)**(-1.5)
      R1 = 3.0E-11
      RX = ALOG10(R0/R1)
      RATES(IL,64) =(R0/(1.0 + R0/R1))*                               &
                          (0.6**(1.0/(1.0 + (RX*RX)))) 
!   REACTION 65 OH + NO + M --> HONO + M
      R0 = 7.0E-31*RHO(IL)*TEMP3(IL)**(-2.6)
      R1 = 3.6E-11*TEMP3(IL)**(-0.1)
      RX = ALOG10(R0/R1)
      RATES(IL,65) =(R0/(1.0 + R0/R1))*                               &
                          (0.6**(1.0/(1.0 + (RX*RX)))) 
!   REACTION 66 N2O + OSD --> 2NO
      RATES(IL,66) = 6.7E-11*EXP(20.0*VTEMP(IL))
!   REACTION 67 N + NO --> N2 + O
      RATES(IL,67) = 2.1E-11*EXP(100.0*VTEMP(IL))
!   REACTION 68 N + O2 --> NO + O
      RATES(IL,68) = 1.5E-11*EXP(-3600.0*VTEMP(IL))
!   REACTION 69 CLO+OH --> --> HCL+O2
      RATES(IL,69) = 6.0E-13*EXP(-230.0*VTEMP(IL))
!   REACTION 70 N2O + OSD --> N2 + O2
      RATES(IL,70) = 4.7E-11*EXP(20.0*VTEMP(IL))
!   REACTION 71 N + NO2 --> N2O + O
      RATES(IL,71) = 5.8E-12*EXP(220.0*VTEMP(IL))
  ENDDO
  DO IC=IHET,IHET+NHET-1
    DO IL=1,MERIDS
      RATES(IL,IC) = 0.0                                            
    ENDDO
  ENDDO
  RETURN
END SUBROUTINE REACTION_RATES

SUBROUTINE PSC(TEMP,PRESS,RHO,DYY,H2O,H2SO4,ANAT,AICE,COND,TICE,  &
           WH2SO4,AM,AW,ALIQ,RMEAN,ASAT,RNAT,RICE,MERIDS,NCHEM,MYPE)
!---------------------------------------------------------------------------
!  CALCULATES IMPORTANT TERMS FOR BINARY AEROSOL/SAT/NAT/ICE SCHEME.
! THE MAIN OUTPUT IS THE SURFACE AREA OR PARTICLE RADIUS
!----------------------------------------------------------------------------
IMPLICIT NONE
INTEGER, intent(in)                           :: MERIDS,NCHEM,MYPE
REAL, intent(in)                              :: ANAT, AICE
REAL, intent(in),    dimension(MERIDS)        :: PRESS, RHO, TEMP, H2SO4

REAL, intent(inout), dimension(MERIDS)        :: H2O, TICE, WH2SO4, AM, AW, &
                                                 ALIQ, RMEAN, ASAT, RNAT, RICE
REAL, intent(inout), dimension(MERIDS,3)      :: COND
REAL, intent(inout), dimension(MERIDS, NCHEM) :: DYY

INTEGER IL
REAL DENS(MERIDS),VHET(MERIDS,4),WF(MERIDS,2),PH2O(MERIDS)
REAL AVGDR,RR,PI,ADROP,SIGMAL,TSAT,ABT,AMT,BMT,PX,C2,   &
     A1,A2,A3,A4,C3,C4,CLIMIT,P0H2O,Y1,Y2,T1,RMODE,RMODESAT,SANAT
!----------------------------------------------------------------------------
!
! AVGDR IS THE RECIPROCAL OF THE AVOGADRO CONSTANT
! RR IS THE GAS CONSTANT
!
!----------------------------------------------------------------------------
  DATA AVGDR,RR/1.66056547E-24, 8.3144/,PI/3.1415926536/
!----------------------------------------------------------------------------
!
!   ADROP, ANAT AND AICE ARE THE (FIXED) NUMBER OF DROPS OR PARTICLES PER CC
!   IN THE POLAR STRATOSPHERC CLOUDS. A LOG NORMAL SIZE DISTRIBUTION IS ASSUMED
!   WITH SIGMA = 1.8 GIVING LOG(SIGMA)**2 = 0.3455  
!
!----------------------------------------------------------------------------
  DATA ADROP/10.0/,SIGMAL/0.34549316/      
!          
    DO 40 IL=1,MERIDS
!----------------------------------------------------------------------------
!
! COMPUTE SOLID CONDENSED MATTER: COND(IL,1:3) -- SAT, NAT, ICE
!               
!----------------------------------------------------------------------------
      PH2O(IL) = H2O(IL)*PRESS(IL)/(RHO(IL)*101325.0)
      COND(IL,1) = 0.0
      COND(IL,2) = 0.0
      COND(IL,3) = 0.0
      TSAT = 3236.0/(11.502 - ALOG10(PH2O(IL)*760.0))           
      IF(TEMP(IL).LT.TSAT) COND(IL,1) = H2SO4(IL)        
      ABT = 39.1104 - 11397.0/TEMP(IL) + 9.179E-3*TEMP(IL)                
      AMT = -2.7836 - 8.8E-4*TEMP(IL)
      BMT = -2.1249 + ALOG10(PH2O(IL)*101325.0)
      PX = AMT*BMT + ABT
      C2 = DYY(IL,1) - (RHO(IL)*100.0/PRESS(IL))*10.0**(PX)
      IF(C2.GT.0.0) COND(IL,2) = C2
      TICE(IL) = 2668.70/(10.4310 - ALOG10(760.0*PH2O(IL)))               
      A1 = 7.5502 - 2668.7/TEMP(IL)
      C3 = H2O(IL) - (RHO(IL)*101325.0/PRESS(IL))*10.0**(A1)          
      C4 = (RHO(IL)*101325.0/PRESS(IL))*10.0**(A1)          
      IF(C3.GT.0.0) COND(IL,3) = C3
      DYY(IL,1) = DYY(IL,1) - COND(IL,2)
      DYY(IL,15) = DYY(IL,15) - COND(IL,2) 
      CLIMIT = RHO(IL)*1.E-15
      IF(DYY(IL,15).LT.CLIMIT) DYY(IL,15) = CLIMIT
      H2O(IL) = H2O(IL) - COND(IL,3) 
 40 ENDDO!CONTINUE
!-------------------------------------------------------------------------
!
!  COMPUTE WEIGHT % H2SO4. FROM TABAZADEHET AL., GRL, 24, 1931-1934, 1997.
!  TABLE A1 OF SHIAET AL. JGR, 106, 24,529-24,274, 2001
!
!-------------------------------------------------------------------------
    DO 50 IL = 1,MERIDS
      P0H2O =EXP(18.452406985 - 3505.1578807/TEMP(IL) -                &
             330918.55082/(TEMP(IL)**2) + 12725068.262/(TEMP(IL)**3))    
      AW(IL) = H2O(IL)*PRESS(IL)*0.01/(RHO(IL)*P0H2O)
      IF(AW(IL).LE.0.05) THEN
        Y1 = 12.37208932*AW(IL)**(-0.16125516114) - 30.490657554*AW(IL)  &
            -  2.1133114241
        Y2 = 13.455394705*AW(IL)**(-0.1921312255) - 34.285174607*AW(IL)        &
            - 1.7620073078
      ELSEIF(AW(IL).LT.0.85.AND.AW(IL).GT.0.05) THEN
        Y1 = 11.820654354*AW(IL)**(-0.20786404244) - 4.807306373*AW(IL)   &
            -  5.1727540348
        Y2 = 12.891938068*AW(IL)**(-0.23233847708) - 6.4261237757*AW(IL)   &
            - 4.9005471319
      ELSE
        Y1 = -180.06541028*AW(IL)**(-0.38601102592)                     &
            - 93.317846778*AW(IL) + 273.88132245
        Y2 = -176.95814097*AW(IL)**(-0.36257048154)                     &
             - 90.469744201*AW(IL) + 267.45509988
      ENDIF              
      AM(IL) = Y1 + (TEMP(IL) - 190.0)*(Y2 - Y1)/70.0
      WH2SO4(IL) = 9800.0*AM(IL)/(98.0*AM(IL) + 1000.0)
      WF(IL,1) = 0.01*WH2SO4(IL) 
      WF(IL,2) = 0.0
 50 ENDDO!CONTINUE
!---------------------------------------------------------------------------
!
!  COMPUTE DENSITY OF BINARY AEROSOL        
!
!---------------------------------------------------------------------------
    CALL DENSITY(WF,TEMP,DENS,MERIDS)
!---------------------------------------------------------------------------
!
!  COMPUTE VOLUME OF BINARY AEROSOL/SAT/NAT/ICE 
!  1.6, 1.35 and 0.928  are the densities of SAT, NAT and ICE     
!
!---------------------------------------------------------------------------
    DO 100 IL=1,MERIDS
      T1 = H2SO4(IL)*PRESS(IL)/(RHO(IL)*TEMP(IL)*RR)
      VHET(IL,1) = T1*98.076E-6/(WF(IL,1)*DENS(IL))             
      VHET(IL,2) = COND(IL,1)*170.1*AVGDR/1.6
      VHET(IL,3) = COND(IL,2)*117.1*AVGDR/1.35
      VHET(IL,4) = COND(IL,3)*18.02*AVGDR/0.928
100 ENDDO
!---------------------------------------------------------------------------
!
!  COMPUTE PARTICLE PARAMETERS FROM WHICH THE HETEROGENEOUS REACTION RATES
!  ARE DETERMINED; ASSUME SURFACE AREA FROM SAT IS LIMITED BY NAT AMOUNT   
!
!---------------------------------------------------------------------------
    A1 =EXP(-4.5*SIGMAL)
    A2 =EXP(0.5*SIGMAL)
    A3 =EXP(2.0*SIGMAL)
    A4 = 1.33333333*PI*ADROP
    DO 150 IL=1,MERIDS
      RMODE = (VHET(IL,1)*A1/A4)**0.33333333
      RMEAN(IL) = RMODE*A2
      ALIQ(IL) = 3.0*A4*(RMODE**2)*A3
      IF(RMEAN(IL).LT.1.0E-12) RMEAN(IL) = 1.0E-12
      RMODESAT = (VHET(IL,2)*A1/A4)**0.33333333
      ASAT(IL) = 3.0*A4*(RMODESAT**2)*A3
      RNAT(IL) = (VHET(IL,3)/(1.33333333*PI*ANAT))**0.33333333
      RICE(IL) = (VHET(IL,4)/(1.33333333*PI*AICE))**0.33333333
      SANAT = 4.0*PI*ANAT*RNAT(IL)**2
      ASAT(IL) = ASAT(IL) - SANAT
      ALIQ(IL) = ALIQ(IL) - SANAT
      IF(ASAT(IL).LT.0.0) ASAT(IL) = 0.0
      IF(ALIQ(IL).LT.0.0) ALIQ(IL) = 0.0
150 ENDDO
    RETURN
END SUBROUTINE PSC
!
SUBROUTINE GAMMA_AER(TEMP,PRESS,RHO,DYY,H2O,WH2SO4,AM,AW,RMEAN,   &
                     GAMMA,RTT,MERIDS,NCHEM,NHET,MYPE)
!-------------------------------------------------------------------------
!
! SUBROUTINE TO CALCULATE REACTION PROBABILITIES ON SULPHATE AEROSOL
! BASED ON JPL'03 RECOMMENDATION
!  
!-------------------------------------------------------------------------
  IMPLICIT NONE
  INTEGER, intent(in) ::  MERIDS,NCHEM,NHET,MYPE
  REAL, intent(in) :: TEMP(MERIDS),PRESS(MERIDS),RHO(MERIDS),DYY(MERIDS,NCHEM), &
        H2O(MERIDS),WH2SO4(MERIDS),AW(MERIDS),AM(MERIDS),           &
        RMEAN(MERIDS)
  REAL, intent(inout) :: RTT(MERIDS), GAMMA(MERIDS,NHET)
!
  INTEGER  IL
  REAL  AMH2SO4(MERIDS),XH2SO4(MERIDS),VISC(MERIDS),AACID(MERIDS),  &
        TEMP2(MERIDS)
!-------------------------------------------------------------------------
!  
! CALCULATE H2SO4 MOLARITY (AMH2SO4), MOLE FRACTION (XH2SO4), 
!  VISCOSITY (VISC) AND ACID ACTIVITY (AACID)
!  TABLE A2 OF SHIAET AL. JGR, 106, 24,529-24,274, 2001.
! 
!-------------------------------------------------------------------------
  REAL  T2,Z1,Z2,Z3,RHOX,AA,X,T1,T3,AKH,AKH2O,AKHYDR,DIFF,SCLONO2,  &
         CCLONO2,GAMMAB1,HHCL,AKHCL,Q1,RQ,A1,FCLONO2,GAMMARXN,      &
         GAMMABHCL,GAMMAS,FHCL,GAMMASP,GAMMABHCLP,GAMMAB,GCLONO2,   &
         SHOCL,HHOCL,FHOCL,WT,AK0,AK1,AK2,T0,HCLONO2,   &
         AMHCL,AKHOCL,CHOCL
!
!  The parameterisations used here break down below about 185K, so the
!  temperature is here limited to 185K and above (TEMP2).
!
    DO IL = 1,MERIDS
      TEMP2(IL) = TEMP(IL)
      IF(TEMP2(IL).LT.185.0) TEMP2(IL) = 185.0
      RTT(IL) = SQRT(TEMP(IL))
    ENDDO
    DO 20 IL = 1,MERIDS
      T2 = TEMP2(IL)**2
      Z1 = 0.12364 - 5.6E-7*T2
      Z2 = -0.02954 + 1.814E-7*T2
      Z3 = 2.343E-3 - 1.487E-6*TEMP2(IL) - 1.324E-8*T2
      RHOX = 1.0 + Z1*AM(IL) + Z2*AM(IL)**1.5 + Z3*AM(IL)**2
      AMH2SO4(IL) = RHOX*WH2SO4(IL)/9.8
      XH2SO4(IL) = WH2SO4(IL)/                                          &
         (WH2SO4(IL) + (100.0 - WH2SO4(IL))*98.0/18.0)
      AA = 169.5 + 5.18*WH2SO4(IL) - 0.0825*WH2SO4(IL)**2 +             &
           3.27E-3*WH2SO4(IL)**3 
      T0 = 144.11 + 0.166*WH2SO4(IL) - 0.015*WH2SO4(IL)**2 +            &
           2.18E-4*WH2SO4(IL)**3
      X = TEMP2(IL)**(-1.43) 
      VISC(IL) = AA*X*EXP(448.0/(TEMP2(IL) - T0))
      T1 = 60.51 - 0.095*WH2SO4(IL) + 0.0077*WH2SO4(IL)**2              &
           - 1.61E-5*WH2SO4(IL)**3
      T2 =  (-805.89 + 253.05*WH2SO4(IL)**0.076)/RTT(IL)  
      T3 =   (1.76 + 2.52E-4*WH2SO4(IL)**2)*RTT(IL)
      AACID(IL) =EXP(T1 + T2 - T3)
 20 ENDDO!CONTINUE
!-------------------------------------------------------------------------
!
!  CALCULATE REACTION PROBABILITES FOR CLONO2 + H2O AND CLONO2 + HCL AND 
!  HENRY'S LAW COEFFICIENTS.
!  TABLE A3 OF SHIAET AL. JGR, 106, 24,529-24,274, 2001.
!
!  The following formulation for the water activity is from Shi et al.,
!  but the differences between their parameterisation and that calculated
!  using the actua model H2O is not large.
!
!      awx = exp((-69.775*xh2so4(il) - 18253.7*xh2so4(il)**2 + 
!     2     31072.2*xh2so4(il)**3 - 25668.8*xh2so4(il)**4)*
!     3     (1.0/temp(il) - 26.9033/(temp(il)**2)))      
!      AKHYDR = AWx*(AKH2O + AKH*AACID(IL))
!
!-------------------------------------------------------------------------
    DO 30 IL = 1,MERIDS
      AKH = 1.22E12*EXP(-6200.0/TEMP2(IL))
      AKH2O = 1.95E10*EXP(-2800.0/TEMP2(IL))     
      AKHYDR = AW(IL)*(AKH2O + AKH*AACID(IL))
      DIFF = 5.0E-8*TEMP2(IL)/VISC(IL)
      SCLONO2 = 0.306 + 24.0/TEMP2(IL)
      HCLONO2 = 1.6E-6*EXP(4710.0/TEMP2(IL) - SCLONO2*AMH2SO4(IL))
      CCLONO2 = 1474.*TEMP2(IL)**0.5
      GAMMAB1 = (4.0*HCLONO2*0.082*TEMP2(IL)/CCLONO2)*                  &
                (DIFF*AKHYDR)**0.5
!
      HHCL = (0.094 - 0.61*XH2SO4(IL) + 1.2*XH2SO4(IL)**2)*             &
        EXP(-8.68 + (8515. - 10718.*XH2SO4(IL)**0.7)/TEMP2(IL))
      AMHCL = HHCL*DYY(IL,4)*PRESS(IL)/(RHO(IL)*101325.0)
      AKHCL = 7.9E11*AACID(IL)*DIFF*AMHCL
      Q1 = (DIFF/(AKHYDR + AKHCL))**0.5
      RQ = RMEAN(IL)/Q1
      A1 = RQ + 0.312*RQ**2
      FCLONO2 = A1/(3.0 + A1)
      GAMMARXN = FCLONO2*GAMMAB1*(1.0 + AKHCL/AKHYDR)**0.5
      GAMMABHCL = GAMMARXN*AKHCL/(AKHCL + AKHYDR)
      GAMMAS = 66.12*EXP(-1374./TEMP2(IL))*HCLONO2*AMHCL
      IF(DYY(IL,4).NE.0.0) THEN
        FHCL = 1.0/(1.0 + 0.612*(GAMMAS + GAMMABHCL)*DYY(IL,6)/DYY(IL,4))
      ELSE
        FHCL = 0.0
      ENDIF
      GAMMASP = FHCL*GAMMAS
      GAMMABHCLP = FHCL*GAMMABHCL     
      GAMMAB = GAMMABHCLP + GAMMARXN*AKHYDR/(AKHCL + AKHYDR)
      GCLONO2 = 1.0/(1.0 + 1.0/(GAMMASP + GAMMAB))
      GAMMA(IL,5) = GCLONO2*(GAMMASP + GAMMABHCLP)/                     &
            (GAMMASP + GAMMAB)
      GAMMA(IL,4) = GCLONO2 - GAMMA(IL,5)
!-------------------------------------------------------------------------
!
!  CALCULATE REACTION PROBABILITES FOR HOCL + HCL AND HENRY'S LAW COEFFICIENTS.
!  TABLE A4 OF SHIAET AL. JGR, 106, 24,529-24,274, 2001.
!
!-------------------------------------------------------------------------
      SHOCL = 0.0776 + 59.18/TEMP2(IL)
      HHOCL = 1.91E-6*EXP(5862.4/TEMP2(IL) - SHOCL*AMH2SO4(IL))
      DIFF = 6.4E-8 *TEMP2(IL)/VISC(IL) 
      AKHOCL = 1.25E9*AACID(IL)*DIFF*AMHCL
      CHOCL = 2009.*RTT(IL)
      Q1 = (DIFF/AKHOCL)**0.5
      RQ = RMEAN(IL)/Q1
      A1 = RQ + 0.312*RQ**2
      FHOCL = A1/(3.0 + A1)
      GAMMARXN = (FHOCL*4.0*HHOCL*0.082*TEMP2(IL)/CHOCL)*               &
                 (DIFF*AKHOCL)**0.5
      GAMMA(IL,1) = 1.0/(1.0 + 1.0/(GAMMARXN*FHCL))
 30 ENDDO!CONTINUE
!-------------------------------------------------------------------------
!
!  CALCULATE REACTION PROBABILITES FOR N2O5 + H2O 
!  ROBINSONET AL. JGR, 102, 3583-3601, 1997.
!
!-------------------------------------------------------------------------
    DO 40 IL = 1,MERIDS
      WT = WH2SO4(IL)
      IF(WH2SO4(IL).GT.80.0) WT = 80.0
      AK0 = -25.5265 - 0.133188*WT + 0.00930846*WT**2 -                 &
              9.0194E-5*WT**3  
      AK1 = 9283.76 + 115.345*WT - 5.19258*WT**2 +                      &
           0.0483464*WT**3  
      AK2 = -851801. - 22191.2*WT + 766.916*WT**2 -                     &
           6.85427*WT**3
      GAMMA(IL,3) =EXP(AK0 + AK1/TEMP2(IL) + AK2/(TEMP2(IL)**2))  
 40 ENDDO!CONTINUE
!-------------------------------------------------------------------------
!
!  REACTION PROBABILITES FOR 
!       N2O5 + HCL
!       HOBR + HCL
!       HOCL + HBR 
!  NO RECOMMENDATION IN JPL '03, ASSUMED ZERO
!
!-------------------------------------------------------------------------
    DO IL = 1,MERIDS
      GAMMA(IL,2) = 0.0
      GAMMA(IL,6) = 0.0
      GAMMA(IL,7) = 0.0
    ENDDO
!-------------------------------------------------------------------------
!
!  REACTION PROBABILITES FOR HOBR + HBR 
!  ABBATT, JGR, 100, 14009-14017, 1995. 
!
!-------------------------------------------------------------------------
    DO IL = 1,MERIDS
      GAMMA(IL,8) = 0.25
    ENDDO
!-------------------------------------------------------------------------
!
!  REACTION PROBABILITES FOR BRONO2 + H2O 
!  USE JPL '03 RECOMMENDATION (HANSON PERS. COMM.)
!
!-------------------------------------------------------------------------
    DO IL = 1,MERIDS
      GAMMA(IL,9) = 1.0/(1.2422 + 1.0/(0.114 +EXP(29.24 -              &
                    0.396*WH2SO4(IL))))
    ENDDO
    RETURN
END SUBROUTINE GAMMA_AER
!
SUBROUTINE HETRATES(TEMP,PRESS,RHO,DYY,H2O,TICE,ANAT,AICE,ALIQ,        &
        RMEAN,RNAT,RICE,GAMMA,RTT,RATES,IHET,NHET,MERIDS,NCHEM,MYPE)

IMPLICIT NONE
!------------------------------------------------------------------------
!
!  This subroutine computes the equivalent 2nd order reaction rates for 
!  the heterogeneous reactions on aerosol, nat and ice.
!
!------------------------------------------------------------------------
      
  INTEGER, intent(in) :: IHET, NHET, MERIDS, NCHEM, MYPE
  REAL, intent(in) ::  TEMP(MERIDS),PRESS(MERIDS),RHO(MERIDS), &
       DYY(MERIDS,NCHEM), H2O(MERIDS),TICE(MERIDS),            &
       ALIQ(MERIDS),RMEAN(MERIDS),RNAT(MERIDS),RICE(MERIDS),   &
       GAMMA(MERIDS,NHET), RTT(MERIDS)
  REAL, intent(inout) :: RATES(MERIDS,IHET+NHET-1)
!
  INTEGER INN(9),IC,IL
  REAL AMW(9),GNAT(9),GICE(9),                          &
       CHEMC(MERIDS,NHET),CONST(NHET),                              &
       G2NAT(MERIDS,NHET),DELT(MERIDS),SICE(MERIDS)
!
  REAL  ANAT,AICE,PI,ANUM,ADEN
  DATA AMW/52.45, 108.00, 108.00, 97.45, 97.45, 96.91,              &
           52.45, 96.91, 141.91/               
!------------------------------------------------------------------------
!  AMW = MOLECULAR WEIGHT OF GAS PHASE SPECIES
!------------------------------------------------------------------------
  DATA PI/3.141592653589793/    
  DATA GNAT/0.1, 3.0E-3, 4.0E-4, 4.0E-3, 0.2,                    &
            0.0, 0.0, 0.0, 0.0/
  DATA GICE/0.2, 0.03, 0.02, 0.3, 0.3, 0.3,                         &
            0.03, 0.1, 0.3/
  DATA INN/4,4,0,0,4,4,11,11,0/
!------------------------------------------------------------------------
!  INN = INDEX NUMBER OF LIQUID/SOLID PHASE SPECIES (0= H2O)
!-------------------------------------------------------------------------
!     REACTION 70 HOCL + HCL --> H2O + CL2 (HETEROGENEOUS)              
!     REACTION 71 N2O5 + HCL --> HNO3 + CLNO2 (HETEROGENEOUS)           
!     REACTION 72 N2O5+H2O --> 2HNO3 (HETEROGENEOUS)
!     REACTION 73 CLONO2+H2O --> HOCL+HNO3 (HETEROGENEOUS)              
!     REACTION 74 CLONO2+HCL --> CL2+HNO3 (HETEROGENEOUS)               
!     REACTION 75 HOBR + HCL --> BRCL + H2O (HETEROGENEOUS)             
!     REACTION 76 HOCL + HBR --> BRCL + H2O (HETEROGENEOUS)             
!     REACTION 77 HOBR + HBR --> 2BR + H2O (HETEROGENEOUS)              
!     REACTION 78 BRONO2 + H2O --> HOBR + HNO3 (HETEROGENEOUS)
!     (THE FIRST MOLECULE ON THE LEFT HAND SIDE IS IN THE GAS PHASE,
!     THE SECOND MOLECULE IS IN THE LIQUID/SOLID PHASE)         
!
!-------------------------------------------------------------------------
!
!    aliq is the liquid surface area. const is sqrt(8R/(pi*mw)) for the
!    gaseous phase species, with the mean molecular
!    speed equal to const*sqrt(temp)
!
!-------------------------------------------------------------------------
    DO 60 IC = 1,NHET
      CONST(IC) = SQRT(8.0*8.3144E7/(PI*AMW(IC)))
      DO 50 IL = 1,MERIDS
        IF(INN(IC).EQ.0) THEN
          CHEMC(IL,IC) = H2O(IL)
        ELSE
          CHEMC(IL,IC) = DYY(IL,INN(IC))
        ENDIF
        RATES(IL,IHET-1+IC) =  0.0 
 50   ENDDO
 60 ENDDO
!-------------------------------------------------------------------------
!
!    Reactions IHET to IHET+NHET-1 on NAT
!
!-------------------------------------------------------------------------
    DO IC = 1,NHET
      DO IL = 1,MERIDS
        G2NAT(IL,IC) = GNAT(IC)
      ENDDO
    ENDDO
    DO 110 IL=1,MERIDS
      DELT(IL) = TEMP(IL) - TICE(IL)
      SICE(IL) =  10**(2668.70*(1.0/TEMP(IL) - 1.0/TICE(IL)))      
      IF (SICE(IL) .GT. 3.0) SICE(IL) = 3.0
      G2NAT(IL,4) =EXP(-9.03 + 2.81*SICE(IL))
      G2NAT(IL,5) = 1.0/(4.3478 + 1.4241*EXP(0.518*DELT(IL)))             
110 ENDDO
!
    DO IC=1,NHET
      DO IL=1,MERIDS
        ANUM = PI*CONST(IC)*RTT(IL)*G2NAT(IL,IC)*ANAT*RNAT(IL)**2
        ADEN = CHEMC(IL,IC)
        IF(ADEN.GT.0.0.AND.ANUM.GT.0.0)                               &
            RATES(IL,IHET-1+IC) =  ANUM/ADEN
      ENDDO
    ENDDO
!-------------------------------------------------------------------------
!
!    Reactions IHET to IHET+NHET-1 on ICE
!
!------------------------------------------------------------------------ 
    DO IC=1,NHET
      DO IL=1,MERIDS
        ANUM = PI*CONST(IC)*RTT(IL)*GICE(IC)*AICE*RICE(IL)**2  
        ADEN = CHEMC(IL,IC)                
        IF(ADEN.GT.0.0.AND.ANUM.GT.0.0)                               &
           RATES(IL,IHET-1+IC) = ANUM/ADEN 
      ENDDO
    ENDDO
!-------------------------------------------------------------------------
!
!    Reactions IHET to IHET+NHET-1 on AEROSOL
!    aliq is the liquid surface area. const is sqrt(8R/(pi*mw)) for the
!    gaseous phase species, with the mean molecular speed equal to 
!        const*sqrt(temp)
!
!-------------------------------------------------------------------------
    DO IC = 1,NHET
      DO IL = 1,MERIDS
        IF(CHEMC(IL,IC).GT.0.0)                                       &
           RATES(IL,IHET+IC-1) =  RATES(IL,IHET+IC-1) +               &
           0.25*GAMMA(IL,IC)*CONST(IC)*RTT(IL)*ALIQ(IL)/CHEMC(IL,IC)
      ENDDO
    ENDDO
!    
    RETURN
END SUBROUTINE HETRATES
!
SUBROUTINE DENSITY(WF,T,DENS,MERIDS)
IMPLICIT NONE
!
!    Density of ternary solution in g cm-3
!
  INTEGER, intent(in)    :: MERIDS
  REAL,    intent(in )   :: WF(MERIDS,2), T(MERIDS)
  REAL,    intent(inout) :: DENS(MERIDS)

  INTEGER IL
  REAL X(22),AMR(3)
  REAL W,WH,T2,V1,A1,A2,VS,VN,VMCAL
  DATA X/2.393284E-02,-4.359335E-05,7.961181E-08,0.0,-0.198716351,   &
         1.39564574E-03,-2.020633E-06,0.51684706,-3.0539E-03,        &
         4.505475E-06,-0.30119511,1.840408E-03,-2.7221253742E-06,    &
        -0.11331674116,8.47763E-04,-1.22336185E-06,0.3455282,        &
        -2.2111E-03,3.503768245E-06,-0.2315332,1.60074E-03,          &
        -2.5827835E-06/
  DATA AMR/0.05550622,0.01019576,0.01586899/
    DO 100 IL=1,MERIDS
      W = WF(IL,1) + WF(IL,2)
      WH = 1.0 - W
      T2 = T(IL)**2
      V1 = X(1) + X(2)*T(IL) + X(3)*T2 + X(4)*T2*T(IL)
      A1 = X(8) + X(9)*T(IL) + X(10)*T2
      A2 = X(11) + X(12)*T(IL) + X(13)*T2
      VS = X(5) + X(6)*T(IL) + X(7)*T2 + A1*W + A2*W**2
      A1 = X(17) + X(18)*T(IL) + X(19)*T2
      A2 = X(20) + X(21)*T(IL) + X(22)*T2
      VN = X(14) + X(15)*T(IL) + X(16)*T2 + A1*W + A2*W**2
      VMCAL = WH*V1*AMR(1) + VS*WF(IL,1)*AMR(2) + VN*WF(IL,2)*AMR(3)
      DENS(IL) = 1.0E-3/VMCAL
100 ENDDO
!
  RETURN
END SUBROUTINE DENSITY
     
SUBROUTINE PHOTO_RATES (VTEMP,OZONX,COSPHI,KL,PHOTO,OZON,COSP,    &
                        COSPHC,MERIDS,IRX,IRX4,FOTO,MYPE)
!---------------------------------------------------------------------- 
!   THIS SUBROUTINE CALCULATES THE PHOTOLYSIS RATES USING A LOOK-UP     
!   TABLE. THE RATES ARE PUT INTO FOTO AND ARE AS FOLLOWS               
!   1.  O2 + HV --> 2O
!   2.  O3 + HV --> OSD + O2
!   3.  O3 + HV --> O3P + O2
!   4.  NO2 + HV --> NO + O
!   5.  HNO3 + HV --> OH + NO2 (300K) (LATER OVERWRITTEN WITH VALUE     
!   6.  NO3 + HV --> NO2 + O
!   7.  NO3 + HV --> NO + O2
!   8.  N2O5 + HV --> NO2 + NO3  (300K)  (LATER OVERWRITTEN WITH VALUE  
!   9.  N2O5 + HV --> NO2 + NO3  (250K)               AT TEMP)          
!  10.  N2O5 + HV --> NO2 + NO3  (200K)
!  11.  H2O2 + HV --> 2OH
!  12.  CLONO2 + HV --> CL + NO3 (300K) (LATER OVERWRITTEN WITH VALUE   
!  13.  H2CO + HV --> H + HCO --> 2H + CO
!  14.  H2CO + HV --> H2 + CO
!  15.  HOCL + HV --> OH + CL
!  16.  CL2O2 + HV --> CLO2 + CL
!  17.  BRONO2 + HV --> BR + NO3
!  18.  HOBR + HV --> OH + BR
!  19.  BRO + HV --> BR + O
!  20.  HNO3 + HV --> OH + NO2 (250K)
!  21.  HNO3 + HV --> OH + NO2 (200K)
!  22.  CLONO2 + HV --> CL + NO3 (250K)
!  23.  CLONO2 + HV --> CL + NO3 (200K)
!  24.  BRCL + HV --> BR + CL
!  25.  HNO4 + HV --> HO2 + NO2
!  26.  HONO + HV --> OH + NO
!  27.  CH3OOH + HV --> H2CO + HO2 + OH
!  28.  N2O + HV --> N2 + OSD  (300K)  (LATER OVERWRITTEN WITH VALUE  
!  29.  N2O + HV --> N2 + OSD  (250K)               AT TEMP)          
!  30.  N2O + HV --> N2 + OSD  (200K)
!  31.  NO + HV --> N + O
!  32.  H2O + HV --> H + OH
!  33.  HCL + HV --> H + CL
!---------------------------------------------------------------------- 
IMPLICIT NONE
  INTEGER, intent(in) :: MERIDS,IRX,IRX4,MYPE, KL
  REAL, intent(in) :: PHOTO(IRX4,14,11,48), OZON(11,48),      &
       VTEMP(MERIDS),OZONX(MERIDS),COSPHI(MERIDS)
  REAL, intent(inout) ::   COSP(14), FOTO(MERIDS,IRX4), COSPHC(48)


  REAL  X1(MERIDS),X2(MERIDS),Y1(MERIDS),Y2(MERIDS),Z1(MERIDS),       &
        Z2(MERIDS),OZON1(MERIDS),OZON2(MERIDS),           &
        COSP1(MERIDS),COSP2(MERIDS)  
  INTEGER IL,ICOX,IOX,IR,IM
  INTEGER IOZ(MERIDS),ICOZ(MERIDS)    
  LOGICAL LCOZ(MERIDS)
!
!      REAL  ALG,CX1,AX1,BX1,CX2,AX1,BX2,AX3,BX3,XX,ZZ,P1,P2,XX2,AX2,CX3  
  REAL  ALG,CX1,AX1,BX1,CX2,AX2,BX2,CX3,AX3,BX3,XX,ZZ,P1,P2,XX2  
!    
!
     IF(KL.EQ.48) COSPHC(KL) = COSPHC(2)
     COSP(1) = -COSPHC(KL)*0.5
     COSP(2) = -COSPHC(KL)*0.25
     DO 110 IL = 1,MERIDS
       LCOZ(IL) = COSPHI(IL).GT.(-COSPHC(KL))
 110 ENDDO
     DO 120 IL = 1,MERIDS
       ICOZ(IL) = 1
       COSP1(IL) = COSP(1)
       COSP2(IL) = COSP(2)
 120 ENDDO
     DO 140 ICOX =  2,13
       DO 130 IL = 1,MERIDS
         IF(COSPHI(IL).GT.COSP(ICOX))  THEN
           ICOZ(IL) = ICOX
           COSP1(IL) = COSP(ICOX)
           COSP2(IL) = COSP(ICOX+1)
         ENDIF
 130   ENDDO
 140 ENDDO
!
!  INTERPOLATE LINEARLY IN COSPHI AND LINEARLY IN
!  OZONE AMOUNT FOR THE LOG OF THE PHOTODISSOCIATION RATE.              
!
     DO 150 IL = 1,MERIDS
       IOZ(IL) = 1
       OZON1(IL) = OZON(1,KL)
       OZON2(IL) = OZON(2,KL)
 150 ENDDO
     DO 170 IOX = 2,10
       DO 160 IL = 1,MERIDS
         IF(OZONX(IL).GT.OZON(IOX,KL))  THEN
           IOZ(IL) = IOX
           OZON1(IL) = OZON(IOX,KL)
           OZON2(IL) = OZON(IOX+1,KL)
         ENDIF
 160   ENDDO
 170 ENDDO
     DO 190 IL = 1,MERIDS
       X1(IL) = OZONX(IL) - OZON1(IL)
       X2(IL) = OZON2(IL) - OZONX(IL)
       XX = X1(IL) + X2(IL)
       IF(XX.EQ.0.0) THEN
         WRITE(6,*) 'TEST 1 ', MYPE
         WRITE(6,*) IL,KL,X1(IL),X2(IL),OZONX(IL),OZON1(IL),             &
                    OZON2(IL),IOZ(IL)
       ENDIF
       Y1(IL) = 1./(X1(IL) + X2(IL))
       Z1(IL) = COSPHI(IL) - COSP1(IL)
       Z2(IL) = COSP2(IL) - COSPHI(IL)
       ZZ = Z1(IL) + Z2(IL)
       IF(ZZ.EQ.0.0) THEN
         WRITE(6,*) 'TEST 2 ', MYPE
         WRITE(6,*) IL,KL,Z1(IL),Z2(IL),COSPHI(IL),COSP1(IL),            &
                    COSP2(IL),ICOZ(IL)
       ENDIF
       Y2(IL) = 1./ZZ
 190 ENDDO
     DO 200 IL = 1,MERIDS
       X1(IL) = X1(IL)*Y1(IL)
       X2(IL) = X2(IL)*Y1(IL)
       Z1(IL) = Z1(IL)*Y2(IL)
       Z2(IL) = Z2(IL)*Y2(IL)
 200 ENDDO
     DO 220 IR = 1,IRX4
       DO 210 IL = 1,MERIDS
         FOTO(IL,IR) = 0.
 210   ENDDO
 220 ENDDO
     DO 240 IL = 1,MERIDS
       IF(LCOZ(IL))  THEN
         DO 230 IR = 1,IRX4
           P1 = PHOTO(IR,ICOZ(IL)+1,IOZ(IL)+1,KL)*X1(IL) +                 &
                X2(IL)*PHOTO(IR,ICOZ(IL)+1,IOZ(IL),KL)
           P2 = PHOTO(IR,ICOZ(IL),IOZ(IL)+1,KL)*X1(IL) +                   &
             X2(IL)*PHOTO(IR,ICOZ(IL),IOZ(IL),KL)
           ALG =  P1*Z1(IL) + P2*Z2(IL)
           FOTO(IL,IR) = ALG
 230     ENDDO
       ENDIF
 240 ENDDO
!
!  PHOTODISSOCIATION RATES FOR TEMPERATURE DEPENDENT N2O5 CROSS-SECTION 
!  FIT A QUADRATIC TO THE VALUES AT 300K, 250K AND 200K                 
!
     DO 250 IL = 1,MERIDS
       IF(LCOZ(IL))  THEN
         XX = 5.0 - VTEMP(IL)*1000.0
         XX2 = XX*XX
         DO 245 IM = 0,3
           CX1 = FOTO(IL,10+IRX*IM)
           AX1 = (9.*FOTO(IL,8+IRX*IM) - 15.*FOTO(IL,9+IRX*IM) +             &
                  6.*CX1)*0.1
           BX1 = FOTO(IL,9+IRX*IM) - AX1 - CX1
           FOTO(IL,8+IRX*IM) = AX1*XX2 + BX1*XX + CX1
           CX2 = FOTO(IL,21+IRX*IM)      
           AX2 = (9.*FOTO(IL,5+IRX*IM) - 15.*FOTO(IL,20+IRX*IM) +            &
                  6.*CX2)*0.1
           BX2 = FOTO(IL,20+IRX*IM) - AX2 - CX2
           FOTO(IL,5+IRX*IM) = AX2*XX2 + BX2*XX + CX2
           CX3 = FOTO(IL,23+IRX*IM)      
           AX3 = (9.*FOTO(IL,12+IRX*IM) - 15.*FOTO(IL,22+IRX*IM) +           &
                  6.*CX3)*0.1
           BX3 = FOTO(IL,22+IRX*IM) - AX3 - CX3
           FOTO(IL,12+IRX*IM) = AX3*XX2 + BX3*XX + CX3
           CX1 = FOTO(IL,30+IRX*IM)
           AX1 = (9.*FOTO(IL,28+IRX*IM) - 15.*FOTO(IL,29+IRX*IM) +           &
                  6.*CX1)*0.1
           BX1 = FOTO(IL,29+IRX*IM) - AX1 - CX1
           FOTO(IL,28+IRX*IM) = AX1*XX2 + BX1*XX + CX1
 245     ENDDO
       ENDIF
 250 ENDDO
     DO 300 IL = 1,MERIDS
       IF(LCOZ(IL))  THEN  
         DO IM = 0,3
           DO IR = 1,IRX
             IF(FOTO(IL,IR+IM*IRX).GT.10.0) FOTO(IL,IR+IM*IRX) = 10.0
             IF(FOTO(IL,IR+IM*IRX).LT.-100.0) FOTO(IL,IR+IM*IRX) = -100.0
             FOTO(IL,IR+IM*IRX) =EXP(FOTO(IL,IR+IM*IRX))  
           ENDDO
         ENDDO
       ENDIF 
 300 ENDDO
     RETURN
END SUBROUTINE PHOTO_RATES
!/ ----------------------------------------------------------------     
!      
SUBROUTINE ZEN2(ITIME,DT,DRAD,DARG,DELTA,CDX)         
!
!  THIS SUBROUTINE CALCULATES THE COSINE OF THE SOLAR ZENITH ANGLE,     
!  COZEN, ALLOWING FOR LEAP YEARS AND THEELLIPTICITY OF THEEARTH'S    
!  ORBIT.
! ELONG IS THE LONGITUDE IN DEG.E. ,XLAT THE LATITUDE NORTH. GMT IS   
!  THE G.M.T. AND DAY IS THE DAY IN THE MONTH. TIMING INFO. IS GIVEN BY 
!  ITIME.
!
IMPLICIT NONE
INTEGER, intent(in) :: ITIME(6)
REAL, intent(in)    :: DT,DRAD
REAL, intent(inout)   :: DARG,DELTA,CDX

REAL DGMT,DP,D1,D2,DF1,DTY,DR,DET,    &
      DAL1,DAL,CD1,DTD
!
INTEGER  IYEAR,IMON,IDAY
!
    IYEAR = ITIME(1)
    IMON = ITIME(2)
    IDAY = ITIME(3)
    DGMT = ITIME(4) + ITIME(5)/60.0 + (ITIME(6) + 0.5*DT)/3600.0
    IF(DGMT.LT.24.)  GOTO 5
    DGMT = DGMT - 24.
    IDAY = IDAY + 1.
  5 DP = 365.*IYEAR + IDAY + 31.*(IMON-1.)
    IF(IMON - 2)  10,10,20
 10 D1 = (IYEAR - 1.)*0.25
    D2 = (IYEAR - 1.)*1.E-2 + 1.
    DF1 = DP + INT(D1) - INT(0.75*INT(D2))
    GOTO 30
 20 D1 = 4.E-1*IMON + 2.3
    D2 = IYEAR*1.E-2
    DF1 = DP - INT(D1) + INT(25.*D2) - INT(0.75*(INT(D2) + 1.))       
 30 DTY = (DF1 - 693960.)/36525.
    DTD = 100.*DTY
    DR = (2.7969668E02 + 3.6000768925E04*DTY + 3.03E-4*DTY*DTY)*    &
      DRAD
    DET = (-9.32701E01  - 1.42E-1*DTD)*SIN(DR) + (-4.3194497E02 +    &
      3.3E-2*DTD)*COS(DR) + 5.965E02*SIN(2.*DR) - 2.*COS(2.*DR)       &
    + 4.2E00*SIN(3.*DR) + 1.93E01*COS(3.*DR) - 1.28E01*SIN(4.*DR)   
    DAL1 = DET*DRAD/240.0
    DAL = DR - DAL1
!
!  DELTA IS THE SOLAR DECLINATION AND COZEN IS THE COSINE OF THE SOLAR  
!  ZENITH ANGLE
!
    DELTA = ATAN(4.336E-1*SIN(DAL))
    DARG = (DGMT - 12.0)*15.*DRAD + DAL1
    CD1 = DTD*DRAD*360.0
    CDX = 1.00011 + 0.034221*COS(CD1) + 0.001280*SIN(CD1) +            &
          0.000719*COS(2.*CD1) + 0.000077*SIN(2.*CD1)                 
    RETURN
END SUBROUTINE ZEN2
!
SUBROUTINE SEDIMENT(ANAT,AICE,ANOY,AH2O,AHNO3,P_FIELD,LEVELS,     &
                    PRESS,DT,MYPE)      
!
!  CALCULATES SEDIMENTATION RATES OF TYPE I AND TYPE 2 PARTICLES               
!  AND VERTICALLY ADVECTS MODEL NAT AND ICE
!
  INTEGER, intent(in) ::  P_FIELD, LEVELS, MYPE
  REAL, intent(inout) :: ANAT(P_FIELD,LEVELS),AICE(P_FIELD,LEVELS), &
       ANOY(P_FIELD,LEVELS),AH2O(P_FIELD,LEVELS),                   &
       AHNO3(P_FIELD,LEVELS)
  REAL, intent(in) :: PRESS(P_FIELD,LEVELS)
  REAL, intent(in) :: DT   


  REAL  SNATS(P_FIELD,LEVELS),SICES(P_FIELD,LEVELS),                 &
        F1(P_FIELD,LEVELS),F2(P_FIELD,LEVELS), &
        PNAT(P_FIELD),PICE(P_FIELD),PNAT2(P_FIELD),PICE2(P_FIELD),        &
        ANAT2(P_FIELD,LEVELS),AICE2(P_FIELD,LEVELS),                 &
        ANATMAX(P_FIELD),AICEMAX(P_FIELD)
!
!  DATA: V1 IS SEDIMENTATION VELOCITY (M/S)
!  OF ICE PARTICLES V2 IS SEDIMENTATION VELOCITY OF         
!  NAT PARTICLES, ASSUMED RADII R1, R2.
!  AM1, AM2 ARE THE MOLECULAR WEIGHTS AND RHO1, RHO2 ARE THE DENSITIES 
!  OF THE PSCs IN G/CM3
!
!      DATA  V1, V2/1.27E-2, 1.39E-4/
!      DATA  R1, R2/7.0E-6, 0.5E-6/
!      DATA AM1,AM2/18.0,117.0/
!      DATA RHO1,RHO2/0.928, 1.35/
  REAL ::   V1=1.27E-2,  V2=1.39E-4
  REAL ::   R1=7.0E-6,   R2=0.5E-6
  REAL ::  AM1=18.0,    AM2=117.0
  REAL :: RHO1=0.928,  RHO2=1.35
  REAL :: RATIO, TEMP, PFRAC, DZ, CONST, D1, D2, FIXNAT, FIXICE
  INTEGER :: KL, JL

!
!  CALCULATE FRACTION OF NAT PARTICLES USED AS TYPE 2 CORES (F1)               
!  AND FRACTION OF NAT PARTICLES THAT REMAIN AS TYPE 1 CORES (F2)              
!  DETERMINE MAXIMUM NAT AND ICE TO APPLY LIMITERS TO ADVECTED AMOUNTS
!
    ANATMAX(:) = 0.0
    AICEMAX(:) = 0.0
    RATIO = AM1*RHO2/(AM2*RHO1)*(R2/R1)**3
    DO 20 KL = 1,LEVELS 
      DO 10 JL = 1,P_FIELD 
        IF(AICE(JL,KL).LT.1.0E-18) THEN 
          AICE(JL,KL) = 0.       
        ENDIF
        IF(ANAT(JL,KL).LT.1.0E-18)  THEN
          ANAT(JL,KL) = 0.
          F1(JL,KL) = 0.
          F2(JL,KL) = 0.
        ELSE
          F1(JL,KL) = AICE(JL,KL)*RATIO/ANAT(JL,KL)
          IF(F1(JL,KL).GT.1.0)  F1(JL,KL) = 1.0
          F2(JL,KL) = 1.0 - F1(JL,KL)
        ENDIF
        IF(ANAT(JL,KL).GT.ANATMAX(JL)) ANATMAX(JL) = ANAT(JL,KL)
        IF(AICE(JL,KL).GT.AICEMAX(JL)) AICEMAX(JL) = AICE(JL,KL)
 10   ENDDO
 20 ENDDO
!
! VERTICALLY ADVECT NAT AND ICE. NOTE THAT PART OF NAT IS ADVECTED             
! AT TYPE 2 RATE AND THE REMAINDER AT TYPE 1 RATE. CALCULATE DESCENT IN
!  1 TIMESTEP; USE APPROXIMATE VERTICAL DISPLACEMENT BETWEEN LAYERS
!
    TEMP = 195.0
    PNAT(:) = 0.0
    PICE(:) = 0.0
    DO 50 KL = 2,LEVELS
      DO 40 JL = 1,P_FIELD
        PFRAC = PRESS(JL,KL)/PRESS(JL,KL-1)
        DZ = 29.26*TEMP*ALOG(PFRAC)
        CONST = DT/DZ
        D1 = ANAT(JL,KL) - ANAT(JL,KL-1)
        D2 = AICE(JL,KL) - AICE(JL,KL-1)         
        SNATS(JL,KL) = -CONST*D1*(V1*F1(JL,KL) + V2*F2(JL,KL))
        SICES(JL,KL) = -CONST*D2*V1
        PNAT(JL) = PNAT(JL) + PRESS(JL,KL)*ANAT(JL,KL)
        PICE(JL) = PICE(JL) + PRESS(JL,KL)*AICE(JL,KL)
 40   ENDDO!CONTINUE
 50 ENDDO!CONTINUE
!
!  set sedimented nat and ice to zero at top and bottom
!
    SNATS(:,1) = 0.0
    SICES(:,1) = 0.0 
    SNATS(:,LEVELS) = 0.0
    SICES(:,LEVELS) = 0.0
    DO 70 KL = 1,LEVELS
      DO 60 JL = 1,P_FIELD
        ANAT2(JL,KL) = ANAT(JL,KL) + SNATS(JL,KL)
        AICE2(JL,KL) = AICE(JL,KL) + SICES(JL,KL)
!
!  APPLY LIMITERS TO NEW NAT AND ICE
!
        IF(ANAT2(JL,KL).LT.0.0) ANAT2(JL,KL) = 0.0
        IF(AICE2(JL,KL).LT.0.0) AICE2(JL,KL) = 0.0
        IF(ANAT2(JL,KL).GT.ANATMAX(JL)) ANAT2(JL,KL) = ANATMAX(JL)
        IF(AICE2(JL,KL).GT.AICEMAX(JL)) AICE2(JL,KL) = AICEMAX(JL)
 60   ENDDO!CONTINUE
 70 ENDDO!CONTINUE
!
! APPLY MASS FIXER
!
    PNAT2(:) = 0.0
    PICE2(:) = 0.0
    DO 90 KL = 1,LEVELS
      DO 80 JL = 1,P_FIELD
        PNAT2(JL) = PNAT2(JL) + PRESS(JL,KL)*ANAT2(JL,KL)
        PICE2(JL) = PICE2(JL) + PRESS(JL,KL)*AICE2(JL,KL)
 80   ENDDO!CONTINUE
 90 ENDDO!CONTINUE
    DO 110 JL = 1,P_FIELD
      IF(PNAT2(JL).EQ.0.0) THEN 
        FIXNAT = 1.0
      ELSE 
        FIXNAT = PNAT(JL)/PNAT2(JL)
      ENDIF
      IF(PICE2(JL).EQ.0.0) THEN
        FIXICE = 1.0
      ELSE
        FIXICE = PICE(JL)/PICE2(JL)
      ENDIF
      DO 100 KL = 1,LEVELS
        ANAT2(JL,KL) = ANAT2(JL,KL)*FIXNAT 
        AICE2(JL,KL) = AICE2(JL,KL)*FIXICE 
100   ENDDO
110 ENDDO
!
!  ADJUST NOY AND H2O TENDENCY FIELDS
!
    DO KL = 1,LEVELS
      DO JL = 1,P_FIELD
        ANOY(JL,KL) = ANOY(JL,kl) + (ANAT2(JL,KL) - ANAT(JL,KL))/DT 
        AHNO3(JL,KL) = AHNO3(JL,kl) + (ANAT2(JL,KL) - ANAT(JL,KL))/DT 
        AH2O(JL,KL) = AH2O(JL,KL) + (AICE2(JL,KL) - AICE(JL,KL))/DT 
     ENDDO
   ENDDO
   RETURN
END SUBROUTINE SEDIMENT
!
SUBROUTINE GHGS(ITIME,ISC,CH4,AN2O,CH4TR,AN2OTR)
!
!  FINDS THE CONCENTRATIONS OF THE GHGS CH4 AND N2O ACCORDING TO THE TIME 
!  ITIME AND SCENARIO ISC, CHOSEN FROM SRES
!
  INTEGER, intent(in) :: ITIME(6),ISC
  REAL, intent(inout) :: CH4,AN2O,CH4TR,AN2OTR

  REAL TIMEN2O(22),AN2O_A1B(22),AN2O_A2(22),AN2O_B1(22)
  REAL TIMECH4(36),CH4_A1B(36),CH4_A2(36),CH4_B1(36)
  REAL TIME, SECS, X1,X2, Z1, C1, C2
  INTEGER IMON(12), IT
  DATA  IMON/0,31,59,90,120,151,181,212,243,273,304,334/
  DATA TIMEN2O/                                                     &
     1950.5, 1976.5, 1980.5, 1984.5, 1988.5, 1990.5,                &
     1992.5, 1994.5, 1996.5, 1998.5, 2000.5, 2010.5,                &
     2020.5, 2030.5, 2040.5, 2050.5, 2060.5, 2070.5,                &
     2080.5, 2090.5, 2100.5, 2500.5/
  DATA AN2O_A1B/                                                    &
     278.0,  299.0,  301.0,  303.0,  305.0,  309.6,                 &
     311.0,  312.0,  312.4,  314.0,  316.0,  324.0,                 &
     331.0,  338.0,  344.0,  350.0,  356.0,  360.0,                 &
     365.0,  368.0,  372.0,  372.0/
  DATA AN2O_A2/                                                     &
     278.0,  299.0,  301.0,  303.0,  305.0,  309.6,                 &
     311.0,  312.0,  312.4,  314.0,  316.0,  325.0,                 &
     335.0,  347.0,  360.0,  373.0,  387.0,  401.0,                 &
     416.0,  432.0,  447.0,  447.0/
  DATA AN2O_B1/                                                     &
     278.0,  299.0,  301.0,  303.0,  305.0,  309.6,                 &
     311.0,  312.0,  312.4,  314.0,  316.0,  324.0,                 &
     333.0,  341.0,  349.0,  357.0,  363.0,  368.0,                 &
     371.0,  374.0,  375.0,  375.0/
  DATA TIMECH4/                                                     &
     1950.5, 1952.5, 1954.5, 1956.5, 1958.5, 1960.5,                &
     1962.5, 1964.5, 1966.5, 1968.5, 1970.5, 1972.5,                &
     1974.5, 1976.5, 1978.5, 1980.5, 1982.5, 1984.5,                &
     1986.5, 1988.5, 1990.5, 1992.5, 1994.5, 1996.5,                &
     1998.5, 2000.5, 2010.5, 2020.5, 2030.5, 2040.5,                &
     2050.5, 2060.5, 2070.5, 2080.5, 2090.5, 2100.5/
  DATA CH4_A1B/                                                     &
     1147.5, 1163.8, 1182.1, 1202.4, 1224.2, 1247.5,                &
     1272.2, 1298.4, 1326.0, 1355.3, 1386.0, 1417.5,                &
     1449.3, 1481.5, 1514.0, 1547.1, 1580.9, 1614.2,                &
     1644.9, 1671.6, 1694.3, 1714.0, 1721.0, 1728.0,                &
     1745.0, 1760.0, 1871.0, 2026.0, 2202.0, 2337.0,                &
     2400.0, 2386.0, 2301.0, 2191.0, 2078.0, 1974.0/
  DATA CH4_A2/                                                      &
     1147.5, 1163.8, 1182.1, 1202.4, 1224.2, 1247.5,                &
     1272.2, 1298.4, 1326.0, 1355.3, 1386.0, 1417.5,                &
     1449.3, 1481.5, 1514.0, 1547.1, 1580.9, 1614.2,                &
     1644.9, 1671.6, 1694.3, 1714.0, 1721.0, 1728.0,                &
     1745.0, 1760.0, 1861.0, 1997.0, 2163.0, 2357.0,                &
     2562.0, 2779.0, 3011.0, 3252.0, 3493.0, 3731.0/
  DATA CH4_B1/                                                      &
     1147.5, 1163.8, 1182.1, 1202.4, 1224.2, 1247.5,                &
     1272.2, 1298.4, 1326.0, 1355.3, 1386.0, 1417.5,                &
     1449.3, 1481.5, 1514.0, 1547.1, 1580.9, 1614.2,                &
     1644.9, 1671.6, 1694.3, 1714.0, 1721.0, 1728.0,                &
     1745.0, 1760.0, 1827.0, 1891.0, 1927.0, 1919.0,                &
     1881.0, 1836.0, 1797.0, 1741.0, 1663.0, 1574.0/
!
    TIME = ITIME(1) + (IMON(ITIME(2)) + ITIME(3))/365.0
    IF(ISC.EQ.4) TIME = ITIME(1) + 0.5
    IF(TIME.LT.1950.5) TIME = 1950.5
    IF(TIME.GT.2100.5) TIME = 2100.5
    SECS = 365.25*86400.0
    DO IT = 2,22
      IF(TIMEN2O(IT).GT.TIME) THEN
        X1 = TIMEN2O(IT) - TIME
        X2 = TIME - TIMEN2O(IT-1)
        Z1 = X1 + X2
        IF(ISC.EQ.1) THEN
          C1 = AN2O_A1B(IT-1)
          C2 = AN2O_A1B(IT)
        ELSEIF(ISC.EQ.2) THEN
          C1 = AN2O_A2(IT-1)
          C2 = AN2O_A2(IT)
        ELSEIF(ISC.EQ.3) THEN
          C1 = AN2O_B1(IT-1)
          C2 = AN2O_B1(IT)
        ELSEIF(ISC.EQ.4) THEN
          C1 = AN2O_A1B(IT-1)
          C2 = AN2O_A1B(IT)
        ENDIF
        AN2O = (X1*C1 + X2*C2)/Z1
        AN2OTR = (C2 - C1)/(AN2O*SECS*Z1)
        GOTO 10
      ENDIF
    ENDDO
 10 DO IT = 2,36
      IF(TIMECH4(IT).GT.TIME) THEN
        X1 = TIMECH4(IT) - TIME
        X2 = TIME - TIMECH4(IT-1)
        Z1 = X1 + X2
        IF(ISC.EQ.1) THEN
          C1 = CH4_A1B(IT-1)
          C2 = CH4_A1B(IT)
        ELSEIF(ISC.EQ.2) THEN
          C1 = CH4_A2(IT-1)
          C2 = CH4_A2(IT)
        ELSEIF(ISC.EQ.3) THEN
          C1 = CH4_B1(IT-1)
          C2 = CH4_B1(IT)
        ELSEIF(ISC.EQ.4) THEN
          C1 = CH4_A1B(IT-1)
          C2 = CH4_A1B(IT)
        ENDIF
        CH4 = (X1*C1 + X2*C2)/Z1
        CH4TR = (C2 - C1)/(CH4*SECS*Z1)
        GOTO 20
      ENDIF
    ENDDO
 20 AN2O = AN2O*1.0E-9
    CH4 = CH4*1.0E-9
    RETURN
END SUBROUTINE GHGS
!/ ----------------------------------------------------------------            
END MODULE STRAT_CHEM_MOD

module ocean_bbc_mod
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Matthew Harrison
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</CONTACT>
!
!<CONTACT EMAIL="martin.schmidt@io-warnemuende.de"> Martin Schmidt 
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Hyun-Chul Lee
!</CONTACT>
!
!<OVERVIEW>
! Set bottom boundary conditions 
!</OVERVIEW>
!
!<DESCRIPTION>
! Set bottom boundary conditions 
! </DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! R.C. Pacanowski and S.M. Griffies
! The MOM3 Manual (1999)
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, M.J. Harrison, R.C. Pacanowski, and A. Rosati 
! A Technical Guide to MOM4 (2003)
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, 2012: Elements of MOM
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_bbc_nml">
!
!  <DATA NAME="cdbot" UNITS="dimensionless" TYPE="real">
! Dimensionless coefficient for quadratic bottom drag. 
!  </DATA> 
!
!  <DATA NAME="bmf_implicit" TYPE="logical">
!  For incorporating the bottom momentum drag implicitly in time.
!  Default is bmf_implicit=.false. 
!  </DATA> 
!
!  <DATA NAME="cdbot_law_of_wall" TYPE="logical">
!  For determining bottom drag coefficient using a constant roughness length.
!  Will take maximum between cdbot and the computed value using law of
!  wall log-profile.  This option is of use when we have very very 
!  refined vertical resolution (say on order of meters) near the bottom.
!  Terrain following coordinates should use this option since they generally 
!  have very refined vertical grid spacing on topography. 
!  Default is cdbot_law_of_wall=.false. 
!  </DATA> 
!  <DATA NAME="law_of_wall_rough_length" UNITS="metre" TYPE="real">
!  Bottom roughness length.  Default is law_of_wall_rough_length=0.01m, following
!  the default used in the Princeton Ocean Model (POM). This value 
!  corresponds to "Law of Wall" physics.  
!  </DATA> 
!
!  <DATA NAME="cdbot_roughness_length" TYPE="logical">
!  For determining bottom drag coefficient using a map of the roughness length.
!  This approach is more relevant for coarse models
!  than the constant roughness length used in the cdbot_law_of_wall option. 
!  cdbot_lo <= cdbot(i,j) <= cdbot_hi.
!  Default is cdbot_roughness_length=.false. 
!  </DATA> 
!
!  <DATA NAME="cdbot_roughness_uamp" TYPE="logical">
!  For determining bottom drag coefficient using a map of the roughness length
!  and tidal velocity amplitude.
!  This approach is more relevant for coarse models
!  than the constant roughness length used in the cdbot_law_of_wall option.
!  cdbot_lo <= cdbot(i,j) <= cdbot_hi.
!  Default is cdbot_roughness_uamp=.false.
!  </DATA>
!
!  <DATA NAME="cdbot_HH" UNITS="m" TYPE="real">
!  H0 in a parameterization of cdbot_roughness_uamp.
!  Default is cdbot_HH=1100.0.
!  </DATA>
!
!  <DATA NAME="cdbot_UU" UNITS="m/s" TYPE="real">
!  U0 in a parameterization of cdbot_roughness_uamp.
!  Default is cdbot_UU=1.0.
!  </DATA>
!
!  <DATA NAME="cdbot_wave" TYPE="logical">
!  For determining bottom drag coefficient using a map of the roughness length
!  and the surface wind wave field. The modified drag coefficient is calculated
!  following Grant and Mattsen. Likewise this method can be improved using
!  more sophisticated wave models including swell.
!  Default is cdbot_wave=.false. 
!  </DATA> 
!
!  <DATA NAME="uresidual" UNITS="m/s" TYPE="real">
!  Residual bottom velocity due to unresolved fluctuations (e.g., waves and tides)
!  that contribute to bottom dissipation.  Should be set to zero when running 
!  with explicit representation of tidal forcing and when waves are well resolved.
!  Default is uresidual=.05.
!  </DATA> 
!
!  <DATA NAME="uvmag_max" UNITS="m/s" TYPE="real">
!  Maximum magnitude of the bottom velocity used to compute the bottom 
!  momentum drag.  Default is uvmag_max=10.0.
!  </DATA> 
!
!  <DATA NAME="bmf_max" UNITS="N/m2" TYPE="real">
!  Maximum magnitude of the bottom momentum drag.
!  Default is bmf_max=1.0.
!  </DATA> 
!
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging purposes.
!  </DATA> 
!</NAMELIST>
!
use constants_mod,        only: epsln, pi
use diag_manager_mod,     only: register_diag_field, register_static_field, send_data
use fms_mod,              only: open_namelist_file, check_nml_error, write_version_number
use fms_mod,              only: close_file, read_data
use mpp_mod,              only: input_nml_file, mpp_error, NOTE, FATAL, WARNING, stdout, stdlog
use mpp_domains_mod,      only: mpp_update_domains, BGRID_NE

use ocean_domains_mod,    only: get_local_indices
use ocean_parameters_mod, only: missing_value, TERRAIN_FOLLOWING
use ocean_parameters_mod, only: onefourth, rho0, rho0r, cp_ocean, von_karman
use ocean_parameters_mod, only: MOM_BGRID, MOM_CGRID
use ocean_types_mod,      only: ocean_velocity_type, ocean_domain_type
use ocean_types_mod,      only: ocean_grid_type, ocean_prog_tracer_type
use ocean_types_mod,      only: ocean_time_type, ocean_thickness_type
use ocean_types_mod,      only: ocean_density_type, ocean_options_type
use ocean_types_mod,      only: ocean_external_mode_type
use ocean_workspace_mod,  only: wrk1_2d, wrk2_2d
use wave_types_mod,       only: ocean_wave_type
use ocean_wave_mod,       only: wave_model_is_initialised
use ocean_util_mod,       only: diagnose_2d, diagnose_2d_u, diagnose_sum

implicit none

private

#include <ocean_memory.h>

integer :: num_prog_tracers

! for Bgrid or Cgrid
integer :: horz_grid

! diagnostics 
integer :: id_eta_tend_geoheat      =-1
integer :: id_eta_tend_geoheat_glob =-1
integer :: id_geo_heat              =-1
integer :: id_gamma_bmf             =-1
integer :: id_drag_coeff            =-1
integer :: id_cdbot                 =-1
integer :: id_bmf_u                 =-1
integer :: id_bmf_v                 =-1
integer :: id_cur_wav_dr            =-1
integer :: id_wave_s                =-1
integer :: id_wave_u                =-1
integer :: id_iter                  =-1
logical :: used

type(ocean_grid_type), pointer   :: Grd =>NULL()
type(ocean_domain_type), pointer :: Dom =>NULL()

character(len=128) :: version=&
     '$Id: ocean_bbc.F90,v 20.0 2013/12/14 00:10:36 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

public  :: ocean_bbc_init
public  :: get_ocean_bbc
private :: current_wave_drag_diag 
private :: wave_u_diag

logical :: module_is_initialized = .false.
logical :: first_call            = .true.

real    :: vonkarman2          
real    :: law_of_wall_rough_length_r

real    :: cellarea_r
real    :: cp_r
real    :: uresidual2
real    :: small=1.e-20

integer :: index_temp=-1
integer :: index_salt=-1
integer :: index_redist_heat=-1

integer :: bbc_geothermal 
integer :: stdoutunit,stdlogunit 

real,    allocatable, dimension(:,:) :: cdbot_array       ! dimensionless drag coefficient
real,    allocatable, dimension(:,:) :: cdbot_lowall      ! dimensionless drag coefficient from law of wall
real,    allocatable, dimension(:,:) :: drag_coeff        ! rho0 * dimensionless drag coefficient
real,    allocatable, dimension(:,:) :: roughness_length  ! for computing bottom drag coefficient
real,    allocatable, dimension(:,:) :: tidal_uamp        ! for computing bottom drag coefficient
real,    allocatable, dimension(:,:) :: geo_heat          ! geothermal heating
real,    allocatable, dimension(:,:) :: wave_u            ! wave action at the sea floor, wave boundary layer       
real,    allocatable, dimension(:,:) :: wave_s            ! wave action at the sea floor, skin layer       
real,    allocatable, dimension(:,:) :: data       
integer, allocatable, dimension(:,:) :: grd_kbot          ! bottom k-level 

real, allocatable, dimension(:, :) :: uresidual2_2d
real, allocatable, dimension(:, :) :: tide_speed_t

! nml variables 
logical :: bmf_implicit             = .false. 
logical :: debug_this_module        = .false. 
logical :: cdbot_law_of_wall        = .false. 
logical :: cdbot_roughness_length   = .false.  
logical :: cdbot_wave               = .false.
logical :: cdbot_roughness_uamp     = .false.
logical :: use_geothermal_heating   = .false. 
real    :: convert_geothermal       = .001     ! for converting units from mW to W
real    :: law_of_wall_rough_length = 0.01     ! metre
real    :: cdbot                    = 2.5e-3   ! dimensionless
real    :: uresidual                = .05      ! m/sec
real    :: cdbot_hi                 = 3.0e-3   ! hi-end of cdbot for cdbot_roughness_length and cdbot_roughness_uamp
real    :: cdbot_lo                 = 1.0e-3   ! lo-end of cdbot for cdbot_roughness_length and cdbot_roughness_uamp
real    :: cdbot_gamma              = 40.0     ! for setting exp decay for cdbot w/ cdbot_roughness_length 
real    :: uvmag_max                = 10.0     ! max velocity scale (m/s) for computing bmf
real    :: bmf_max                  = 1.0      ! max bmf (N/m^2)
real    :: cdbot_HH                 = 1100.0   ! H0 of cdbot_roughness_uamp (m)
real    :: cdbot_UU                 = 1.0      ! U0 of cdbot_roughness_uamp (m/s)

logical :: read_tide_speed = .false.
real    :: uresidual2_max = 0.05

 namelist /ocean_bbc_nml/ bmf_implicit, cdbot, uresidual, cdbot_law_of_wall, law_of_wall_rough_length, &
                         cdbot_roughness_length, use_geothermal_heating, convert_geothermal,           &
                         cdbot_hi, cdbot_lo, cdbot_gamma, uvmag_max, bmf_max, debug_this_module,       &
                         cdbot_roughness_uamp, cdbot_HH, cdbot_UU, cdbot_wave

 namelist /ocean_bbc_ofam_nml/ read_tide_speed, uresidual2_max

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_bbc_init">
!
! <DESCRIPTION>
! Initialize the bottom boundary condition module
! </DESCRIPTION>
!
subroutine ocean_bbc_init(Grid, Domain, Time, T_prog, Velocity, &
                          Ocean_options, vert_coordinate_type, hor_grid)

type(ocean_grid_type),   target, intent(in)    :: Grid
type(ocean_domain_type), target, intent(in)    :: Domain
type(ocean_time_type),           intent(in)    :: Time
type(ocean_prog_tracer_type),    intent(inout) :: T_prog(:)
type(ocean_velocity_type),       intent(inout) :: Velocity
type(ocean_options_type),        intent(inout) :: Ocean_options
integer,                         intent(in)    :: vert_coordinate_type
integer,                         intent(in)    :: hor_grid

logical :: read_roughness=.false. 
integer :: i,j,n, ioun, io_status, ierr
integer :: grd_axes(3)
real    :: depth, cdbot_term1, cdbot_term2

stdoutunit=stdout()
stdlogunit=stdlog() 

module_is_initialized = .TRUE.

call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_bbc_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_bbc_nml')
read (input_nml_file, nml=ocean_bbc_ofam_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_bbc_ofam_nml')
#else
ioun = open_namelist_file()
read(ioun, ocean_bbc_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_bbc_nml')
rewind(ioun)
read(ioun, ocean_bbc_ofam_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_bbc_ofam_nml')
call close_file(ioun)
#endif
write (stdoutunit,'(/)')
write (stdoutunit, ocean_bbc_nml)
write (stdlogunit, ocean_bbc_nml)
write (stdoutunit,'(/)')
write (stdoutunit, ocean_bbc_ofam_nml)
write (stdlogunit, ocean_bbc_ofam_nml)

#ifndef MOM_STATIC_ARRAYS
call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
nk = Grid%nk
#endif

Dom => Domain
Grd => Grid
horz_grid = hor_grid

num_prog_tracers = size(T_prog(:))
index_temp=-1;index_salt=-1;index_redist_heat=-1
do n=1,num_prog_tracers
   if (T_prog(n)%name == 'temp')        index_temp = n
   if (T_prog(n)%name == 'salt')        index_salt = n
   if (T_prog(n)%name == 'redist_heat') index_redist_heat = n
enddo

do n=1, num_prog_tracers
#ifndef MOM_STATIC_ARRAYS
   allocate(T_prog(n)%btf(isd:ied,jsd:jed))
#endif
   T_prog(n)%btf = 0.0
enddo

allocate (cdbot_array(isd:ied,jsd:jed))
allocate (cdbot_lowall(isd:ied,jsd:jed))
allocate (drag_coeff(isd:ied,jsd:jed))
allocate (roughness_length(isd:ied,jsd:jed))
allocate (tidal_uamp(isd:ied,jsd:jed))
allocate (geo_heat(isd:ied,jsd:jed))
allocate (data(isd:ied,jsd:jed))
allocate (wave_u(isd:ied,jsd:jed))
allocate (wave_s(isd:ied,jsd:jed))
allocate (grd_kbot(isd:ied,jsd:jed))

vonkarman2            = von_karman*von_karman
geo_heat(:,:)         = 0.0
data(:,:)             = 0.0
roughness_length(:,:) = 0.0
tidal_uamp(:,:)       = 0.0
wave_u(:,:)           = 0.0
wave_s(:,:)           = 0.0

if(horz_grid == MOM_BGRID) then 
   grd_kbot(:,:) = Grd%kmu(:,:)
   grd_axes(:)   = Grd%vel_axes_uv(:)
else
   grd_kbot(:,:) = Grd%kmt(:,:)
   grd_axes(:)   = Grd%tracer_axes(:)
endif 

if(cdbot_wave .or. cdbot_roughness_length .or. cdbot_roughness_uamp) then 
  read_roughness = .true.
endif

drag_coeff(:,:)   = rho0*cdbot*Grd%mask(:,:,1) 
cdbot_array(:,:)  = cdbot*Grd%mask(:,:,1) 
cdbot_lowall(:,:) = cdbot*Grd%mask(:,:,1)

cellarea_r                 = 1.0/(epsln + Grd%tcellsurf)
cp_r                       = 1.0/cp_ocean
uresidual2                 = uresidual**2

if (read_tide_speed) then
    allocate(uresidual2_2d(isd:ied, jsd:jed))
    allocate(tide_speed_t(isd:ied, jsd:jed))
    call read_data('INPUT/tideamp.nc', 'tideamp', tide_speed_t, Domain%domain2d)
    write (stdout(),*) '==>ocean_bbc_mod: Completed read of tide_speed.'
    uresidual2_2d(:,:) = min(tide_speed_t(:,:)**2, uresidual2_max)
    call mpp_update_domains(uresidual2_2d(:,:), Dom%domain2d)
    deallocate(tide_speed_t)
else
   write(stdout(),'(a)') &
      '==>Note: NOT reading tide_speed for ocean_vert_tidal_mod.'
   call mpp_error(NOTE, &
      '==>ocean_vert_tidal_mod: Setting tide_speed to default value.')
endif

law_of_wall_rough_length_r = 1.0/law_of_wall_rough_length

if(cdbot_law_of_wall) then 
   write(stdoutunit,'(a)') &
   '==>Note from ocean_bbc_mod: Computing bottom drag coefficient from roughness length.'
   Ocean_options%bottom_roughness = 'Used bottom drag coefficient from Law of Wall roughness length.'
elseif (cdbot_roughness_length) then 
   Ocean_options%bottom_roughness = 'Used bottom drag from map of bottom roughness using law of wall.'
elseif (cdbot_roughness_uamp) then
   Ocean_options%bottom_roughness = 'Used bottom drag from map of bottom roughness w/ tidal amplitude from law of wall.'
elseif (cdbot_wave) then 
   Ocean_options%bottom_roughness = 'Used bottom drag from map of bottom roughness using law of wall.'&
                                    //' Also considered influence of the wind wave field.'
else 
   Ocean_options%bottom_roughness = 'Used bottom drag from specified drag coefficient.'
endif 

if(bmf_implicit) then 
   write(stdoutunit,'(a)') &
   '==>Note from ocean_bbc_mod: Computing bottom drag implicitly in time.'
   Ocean_options%bmf_implicit = 'Used bottom drag computed implicitly in time.'
   Velocity%bmf_implicit = .true.
else
   Ocean_options%bmf_implicit = 'Used bottom drag computed explicitly in time.'
   Velocity%bmf_implicit = .false.
endif 

! compute drag coefficient using law of wall with a roughness length 
! read in from a map.  This approach is more relevant for large-scale 
! coarse models than the constant roughness length used in the 
! cdbot_law_of_wall option. 


! read in topographic roughness_length. 
! assume roughness_length on B-grid velocity point if using MOM_BGRID.
! assume roughness_length on tracer point if using MOM_CGRID.

data = 0.0
if(cdbot_wave) then 
    data = law_of_wall_rough_length
endif 

if(read_roughness) then 
    call read_data('INPUT/roughness_cdbot.nc','roughness_cdbot', data, Domain%domain2d)
    if(horz_grid == MOM_BGRID) then 
       write (stdoutunit,*) '==>ocean_bbc_mod: read in topographic roughness length, assumed to be on B-grid velocity point.'
    else 
       write (stdoutunit,*) '==>ocean_bbc_mod: read in topographic roughness length, assumed to be on tracer point.'
    endif 
    do j=jsc,jec
       do i=isc,iec
          roughness_length(i,j) = Grd%mask(i,j,1)*max(0.0,data(i,j))
       enddo
    enddo
    call mpp_update_domains(roughness_length(:,:), Dom%domain2d) 
endif 

! bottom drag from law of wall using roughness_length
if(cdbot_roughness_length) then

    cdbot_lowall=0.0
    do j=jsd,jed
       do i=isd,ied
          depth = Grd%ht(i,j)                 
          if(depth > 0.0) then 
              cdbot_lowall(i,j)= (von_karman/( alog(depth/(roughness_length(i,j)+small)) + small ) )**2
          endif
       enddo
    enddo

    ! bottom drag coefficient; the range of cdbot is
    ! cdbot_lo <= cdbot(i,j) <= cdbot_hi
    do j=jsd,jed
       do i=isd,ied
          cdbot_array(i,j) = Grd%mask(i,j,1)*cdbot_hi*(1.0-exp(-cdbot_gamma*cdbot_lowall(i,j)))
          cdbot_array(i,j) = max(cdbot_lo,cdbot_array(i,j))
       enddo
    enddo

endif

! scheme coded by H.C. Lee (May 2012) 
if(cdbot_roughness_uamp) then

    ! read in tidal velocity amplitude; assumed on U-grid
    data=0.0
    call read_data('INPUT/tideamp.nc','TIDEAMP', data, Domain%domain2d)
    if(horz_grid == MOM_BGRID) then 
       write (stdoutunit,*) '==>ocean_bbc_mod: completed read of tidal velocity amplitude, assumed to be on B-grid velocity point.'
    else 
       write (stdoutunit,*) '==>ocean_bbc_mod: completed read of tidal velocity amplitude, assumed to be on tracer point.'
    endif 
    do j=jsc,jec
       do i=isc,iec
          tidal_uamp(i,j) = Grd%mask(i,j,1)*max(0.0,data(i,j))
       enddo
    enddo
    call mpp_update_domains(tidal_uamp(:,:), Dom%domain2d)


    ! bottom drag from law of wall using roughness_length and tidal velocity amplitude
    do j=jsd,jed
       do i=isd,ied
          depth = Grd%ht(i,j)
          cdbot_term1= cdbot_HH/(roughness_length(i,j)+small)
          cdbot_term2= cdbot_UU/(tidal_uamp(i,j)+small)
          if(depth > 0.0) then
              cdbot_array(i,j)= (von_karman/( alog(cdbot_term1*cdbot_term2) + small ) )**2
          endif
       enddo
    enddo

    ! bottom drag coefficient; the range of cdbot is
    ! cdbot_lo <= cdbot(i,j) <= cdbot_hi
    do j=jsd,jed
       do i=isd,ied
          cdbot_array(i,j) = min(cdbot_hi,cdbot_array(i,j))
          cdbot_array(i,j) = max(cdbot_lo,cdbot_array(i,j))
       enddo
    enddo

endif

    
! save cdbot into Velocity type 
do j=jsd,jed
   do i=isd,ied
      Velocity%cdbot_array(i,j) = cdbot_array(i,j)
   enddo
enddo


if(use_geothermal_heating) then 
    write(stdoutunit,'(a)') &
         '==>Note from ocean_bbc_mod: Geothermal heating introduced at ocean bottom.'
    Ocean_options%geothermal_heating = 'Used geothermal heating introduced at ocean bottom.'

    ! fill geothermal heating array 
    geo_heat = 0.0
    call read_data('INPUT/geothermal_heating.nc', 'geo_heat', data(:,:), Dom%domain2d, timelevel=1)

    ! make sure there are no spurious negative values.
    ! also convert to units appropriate for temperature btf. 
    do j=jsc,jec
       do i=isc,iec
          geo_heat(i,j) = Grd%tmask(i,j,1)*max(0.0,data(i,j))*cp_r*convert_geothermal
       enddo
    enddo

else
    Ocean_options%geothermal_heating = 'Did NOT introduce geothermal heating.'
endif


if(vert_coordinate_type == TERRAIN_FOLLOWING .and. .not. cdbot_law_of_wall) then 
   call mpp_error(WARNING,&
   '==>Warning from ocean_bbc_init: recommend law_of_wall=.true. for TERRAIN_FOLLOWING coordinates.')
endif 


id_drag_coeff = register_diag_field ('ocean_model', 'drag_coeff',         &
                grd_axes(1:2), Time%model_time,                           &
                'Dimensionless bottom drag coefficient', 'dimensionless', &
                missing_value=missing_value, range=(/-1.0,1.e3/))
id_gamma_bmf  = register_diag_field ('ocean_model', 'gamma_bmf',       &
                grd_axes(1:2), Time%model_time,                        &
                'Bottom drag factor rho0*cdbot*uvmag', 'kg/(m^2 sec)', &
                missing_value=missing_value, range=(/-1.0,1.e12/))
id_bmf_u      = register_diag_field ('ocean_model', 'bmf_u',  &
                grd_axes(1:2), Time%model_time,               &
                'Bottom u-stress via bottom drag', 'N/m^2',   &
                missing_value=missing_value, range=(/-1.0,1.e2/))
id_bmf_v      = register_diag_field ('ocean_model', 'bmf_v',  &
                grd_axes(1:2), Time%model_time,               &
                'Bottom v-stress via bottom drag', 'N/m^2',   &
                missing_value=missing_value, range=(/-1.0,1.e2/))

id_cdbot      = register_static_field ('ocean_model', 'cdbot',            &
                grd_axes(1:2), 'Bottom drag coefficient', 'dimensionless',&     
                missing_value=missing_value, range=(/-1.0,1e6/))
if (id_cdbot > 0) then 
    used = send_data (id_cdbot, cdbot_array(:,:), Time%model_time, &
           rmask=Grd%mask(:,:,1), is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
endif

id_geo_heat = register_static_field ('ocean_model', 'geo_heat',   &
              Grd%tracer_axes(1:2), 'Geothermal heating', 'W/m^2',&     
              missing_value=missing_value, range=(/-10.0,1e6/),   &
              standard_name='upward_geothermal_heat_flux_at_sea_floor')
call diagnose_2d(Time, Grd, id_geo_heat, geo_heat(:,:)*cp_ocean)

id_eta_tend_geoheat = register_diag_field('ocean_model',             &
       'eta_tend_geoheat', Grd%tracer_axes(1:2),Time%model_time   ,  &
       'non-Bouss steric sea level tendency from geothermal heating',&
       'm/s',missing_value=missing_value,range=(/-1.e10,1.e10/))   

id_eta_tend_geoheat_glob = register_diag_field('ocean_model',        &
       'eta_tend_geoheat_glob', Time%model_time,                     &
       'non-Bouss steric sea level tendency from geothermal heating',&
       'm/s',missing_value=missing_value,range=(/-1.e10,1.e10/))   

id_cur_wav_dr = register_diag_field ('ocean_model', 'current_wave_stress',&
                Grd%tracer_axes(1:2), Time%model_time,                    &
                'combined current wave bottom stress', 'N/m^2',           &
                missing_value=missing_value, range=(/-1.0,1.e3/))

id_wave_s = register_diag_field ('ocean_model', 'wave_s', &
            Grd%tracer_axes(1:2), Time%model_time,        &
            'wave skin friction velocity', 'm/s',         &
            missing_value=missing_value, range=(/-1.0,1.e3/))

id_wave_u = register_diag_field ('ocean_model', 'wave_u',&
            Grd%tracer_axes(1:2), Time%model_time,       &
            'wave friction velocity', 'm/s',             &
            missing_value=missing_value, range=(/-1.0,1.e3/))
       
id_iter   = register_diag_field ('ocean_model', 'iter',&
            grd_axes(1:2), Time%model_time,            &
            'number of ustar iterations', 'm/s',       &
            missing_value=missing_value, range=(/0.0,1.e3/))


end subroutine ocean_bbc_init
! </SUBROUTINE> NAME="ocean_bbc_init"


!#######################################################################
! <SUBROUTINE NAME="get_ocean_bbc">
!
! <DESCRIPTION>
! Set bottom boundary conditions for velocity and tracer.
!
! Dimensions of bottom momentum flux are 
! N/m^2 = (kg/m^3)*(m^2/s^2).
!
! Note the use of rho0 for the conversion from m^2/s^2 to 
! (kg/m^3)*(m^2/s^2).  We do not know the precise value 
! of cdbot, so the rho0 approximate value is well within 
! our level of uncertainty.  No reason therefore to 
! use in situ rho for this conversion, even when using 
! non-Boussinesq version of MOM.   
!
!
! Note that bmf needs to be computed on the data domain since the 
! halo values are accessed in ocean_vert_gotm.F90.
!
! </DESCRIPTION>
!
subroutine get_ocean_bbc(Time, Thickness, Dens, Velocity, T_prog, Waves)

type(ocean_time_type),          intent(in)    :: Time
type(ocean_thickness_type),     intent(in)    :: Thickness
type(ocean_density_type),       intent(in)    :: Dens 
type(ocean_velocity_type),      intent(inout) :: Velocity
type(ocean_prog_tracer_type),   intent(inout) :: T_prog(:)
type(ocean_wave_type),          intent(inout) :: Waves

integer :: i, j, kbot, n
integer :: taum1, tau, tstep
real    :: uvmag, argument, distance 
real    :: umag, vmag
real    :: rhobot_inv, alphabot 

if (.not. module_is_initialized) then 
   call mpp_error(FATAL,'==>Error from ocean_bbc_mod (get_ocean_bbc): module must be initialized')
endif 

taum1 = Time%taum1
tau   = Time%tau

if(bmf_implicit) then 
  tstep=tau
else
  tstep=taum1
endif 

! Bottom tracer flux defaulted to zero.
do n=1,num_prog_tracers
   do j=jsd,jed
      do i=isd,ied
         T_prog(n)%btf(i,j) = 0.0
      enddo
   enddo
enddo

! T_prog(index_temp)%btf<0 means heat enters ocean; hence the minus sign. 
if (use_geothermal_heating) then
    do j=jsc,jec
       do i=isc,iec
          T_prog(index_temp)%btf(i,j) = -geo_heat(i,j)
       enddo
    enddo
    if(index_redist_heat > 0) then 
      do j=jsc,jec
         do i=isc,iec
            T_prog(index_redist_heat)%btf(i,j) = -geo_heat(i,j)
         enddo
      enddo
    endif   
endif


! set bottom drag coefficient
drag_coeff(:,:) = 0.0
if(horz_grid == MOM_BGRID) then 

   if(cdbot_law_of_wall) then 
       do j=jsd,jed
          do i=isd,ied
             kbot = grd_kbot(i,j)   
             if(kbot > 0) then 
                 distance        = Thickness%depth_zwu(i,j,kbot) - Thickness%depth_zu(i,j,kbot)
                 argument        = law_of_wall_rough_length_r*(distance + law_of_wall_rough_length)
                 drag_coeff(i,j) = rho0*max(cdbot,vonkarman2/(log(argument))**2)
             endif
          enddo
       enddo
   else 
       do j=jsd,jed
          do i=isd,ied
             drag_coeff(i,j) = rho0*cdbot_array(i,j)*Grd%umask(i,j,1)     
          enddo
       enddo
   endif

else 

   if(cdbot_law_of_wall) then 
       do j=jsd,jed
          do i=isd,ied
             kbot = grd_kbot(i,j)   
             if(kbot > 0) then 
                 distance        = Thickness%depth_zwt(i,j,kbot) - Thickness%depth_zt(i,j,kbot)
                 argument        = law_of_wall_rough_length_r*(distance + law_of_wall_rough_length)
                 drag_coeff(i,j) = rho0*max(cdbot,vonkarman2/(log(argument))**2)
             endif
          enddo
       enddo
   else 
       do j=jsd,jed
          do i=isd,ied
             drag_coeff(i,j) = rho0*cdbot_array(i,j)*Grd%tmask(i,j,1)     
          enddo
       enddo
   endif

endif ! horz_grid iftest


! modified stress if use idealized wave model 
if(cdbot_wave) then
    call current_wave_drag_diag(Thickness, Velocity, drag_coeff, Waves, Time, tstep)
endif


! set quadratic bottom momentum drag
! units of bmf are N/m^2
! introduce ceilings for uvmag and bmf
! to minimize potential for instability. 
Velocity%bmf(:,:,:) = 0.0

! if cgrid, ignore offset in velocity components for uvmag calculation 
do j=jsd,jed
   do i=isd,ied
       kbot = grd_kbot(i,j)
       Velocity%gamma(i,j) = 0.0
       if (kbot > 0) then
           if (read_tide_speed) then
               uvmag = sqrt(uresidual2_2d(i, j) &
                            + Velocity%u(i, j, kbot, 1, taum1)**2 &
                            + Velocity%u(i, j, kbot, 2, taum1)**2)
           else
               uvmag = sqrt(uresidual2 + Velocity%u(i, j, kbot, 1, tstep)**2 &
                            + Velocity%u(i, j, kbot, 2, tstep)**2)
           end if
           uvmag = min(uvmag,uvmag_max)
           Velocity%gamma(i,j)  = drag_coeff(i,j)*uvmag
           umag                 = abs(Velocity%u(i,j,kbot,1,tstep))
           vmag                 = abs(Velocity%u(i,j,kbot,2,tstep))
           Velocity%bmf(i,j,1)  = min(bmf_max, Velocity%gamma(i,j)*umag)*sign(1.0,Velocity%u(i,j,kbot,1,tstep))
           Velocity%bmf(i,j,2)  = min(bmf_max, Velocity%gamma(i,j)*vmag)*sign(1.0,Velocity%u(i,j,kbot,2,tstep))
       endif
   enddo
enddo

if (read_tide_speed) then
    deallocate(uresidual2_2d)
end if

! send diagnostics 

if (id_drag_coeff > 0) then 
  used = send_data(id_drag_coeff, rho0r*drag_coeff(:,:), Time%model_time, &
         rmask=Grd%mask(:,:,1), is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
endif 
if (id_gamma_bmf > 0) then 
  used = send_data(id_gamma_bmf, Velocity%gamma(:,:), Time%model_time, &
         rmask=Grd%mask(:,:,1), is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
endif 
if (id_bmf_u > 0) then 
  used = send_data(id_bmf_u, Velocity%bmf(:,:,1), Time%model_time, &
         rmask=Grd%mask(:,:,1), is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
endif 
if (id_bmf_v > 0) then 
  used = send_data(id_bmf_v, Velocity%bmf(:,:,2), Time%model_time, &
         rmask=Grd%mask(:,:,1), is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
endif 


! some sea level diagnostics from geothermal heating 
if (id_eta_tend_geoheat > 0 .or. id_eta_tend_geoheat_glob > 0) then 

    wrk1_2d = 0.0
    do j=jsc,jec
       do i=isc,iec
          kbot=Grd%kmt(i,j)
          if(kbot > 0) then 
              rhobot_inv   = 1.0/(epsln+Dens%rho(i,j,kbot,tau))
              alphabot     = -rhobot_inv*Dens%drhodT(i,j,kbot)
              wrk1_2d(i,j) = -alphabot*rhobot_inv*T_prog(index_temp)%btf(i,j)
          endif
       enddo
    enddo

    call diagnose_2d(Time, Grd, id_eta_tend_geoheat, wrk1_2d(:,:))
    call diagnose_sum(Time, Grd, Dom, id_eta_tend_geoheat_glob, wrk1_2d, cellarea_r)

endif

end subroutine get_ocean_bbc
! </SUBROUTINE> NAME="get_ocean_bbc"

!#######################################################################
! <SUBROUTINE NAME="current_wave_drag_diag">
!
! <DESCRIPTION>
! calculates wave-current bottom shear stress 
! using model of Grand and Madsen(1979) J. Geophys. Res. 84, C4, 1797
! see Signell et. al (1990)  J. Geophys. Res. 95, C6, 9671
!
! input bot_vel: current velocity at u points
! Note: assumed that this is the velocity just above the bottom boundary layer.
!
! A relation between grain size, ripples steepness and and roughness is 
! assumed. More general relations are possible but not needed, since 
! the output is used only to parameterise resuspension of organic matter 
! in the ecosystem model ocean_shared/generic_tracers/generic_ERGOM.F90.
!
! output: effective drag coefficient drag_coeff. 
! It is valid for momentum flux from currents into the bottom, but
! from combined waves+current action.
! Velocity%current_wave_stress is the stress from waves and currents 
! to the sediment.
! 
! Note:
!
! 1/ drag_coeff in this routine arises from both (waves+current); 
! That is, ustar**2/uref**2 1 meter above the bottom.
!
! 2/ bottom velocity is taken just above the bottom boundary layer, and 
! assumed here to be at lowest u point.
!
! 3/ to understand the calculation of shear stress acting on grains 
! at sediment surface ("wrk1_2d(i,j) = (ustar2/ucomb)*0.3152"), 
! see Kuhrts et al. (2004) Eqs. (4,5,6,7).
! Assume a thin skin friction layer according to Smith, McLean (1977)
! thickness of the skin friction layer zskin scales with roughness length ruff
! grained sediments are characterised by median diameter d50[m]
! ripples at sea bottom have spacing lambda and height eta with steepness eta/lambda=0.1
! common approx. for grain roughness length = d50/12
! Nielsen (1983) form drag roughness length = (8/30)*eta*(eta/lambda) ==> (8/3000)*lambda
! Yalin (1977) lambda = 1000*d50 ==> form drag = (8/3)*d50
! ruff = grain + form drag = (1/12+8/3)*d50 = (33/12)*d50 = 33*grain
! Smith, McLean (1977) zskin = 0.09*grain*(lambda/grain)**0.8 = 165*grain = 5*ruff
! matching at zskin leads to log(zskin/ruff)/log(zskin/grain)) = log(5)/log(165) = 0.3152
! the current induced skin friction velocity is derived from matching skin friction 
! to wave boundary layer.
!
! 4/ Algorithm has yet to be updated for Cgrid. 
!
! April 2012
! martin.schmidt@io-warnemuende.de 
!
! </DESCRIPTION>
!
subroutine current_wave_drag_diag(Thickness, Velocity, drag_coeff, Waves, Time, tstep)
type(ocean_thickness_type),     intent(in)    :: Thickness
type(ocean_velocity_type),      intent(inout) :: Velocity
real,  dimension(isd:,jsd:),    intent(out)   :: drag_coeff    
type(ocean_wave_type),          intent(inout) :: Waves
type(ocean_time_type),          intent(in)    :: Time
integer,                        intent(in)    :: tstep

real,parameter:: twopi=2.*pi

  real    :: omega, cdrag, cold, cnew, ruff, rauh, dist, wave_p_u, wave_u_u
  real    :: bot_vel, u_vel, v_vel   ! Velocity in the bottommost layer. 
  real    :: ustar, ustar2, ucomb, ucskin  ! friction velocities in wave & skin boundary layers
  integer:: i, j, icount, kmu
  integer, parameter::  itmax=10

  if (first_call) then
     if ( .not. wave_model_is_initialised() ) then
       call mpp_error(FATAL,&
       '==>Error from ocean_bbc_mod (get_ocean_bbc): enable a wave model for option cdbot_wave ')
     endif
     first_call = .false.
  endif
  
  ! get the wave induced bottom friction velocities 
  ! wave_u applies inside the wave-boundary layer, wave_s inside the skin friction layer
  if (id_iter > 0) wrk2_2d = 0.0
  wrk1_2d    = 0.0
  drag_coeff = 0.0
  call wave_u_diag(wave_u, wave_s, Waves) 

  do j=jsc,jec 
     do i=isc,iec 

        kmu=Grd%kmu(i,j) 
        if (kmu >= 1) then

            ruff  = roughness_length(i,j) ! bottom roughness length (grain+form drag) [m]
            dist  = Thickness%depth_zwu(i,j,kmu) - Thickness%depth_zu(i,j,kmu)
            cdrag = (von_karman/log(dist/ruff))**2  ! drag coefficient from currents at height=dist above sea bed
            u_vel = Velocity%u(i,j,kmu,1,tstep)
            v_vel = Velocity%u(i,j,kmu,2,tstep)
            bot_vel=sqrt(u_vel*u_vel + v_vel*v_vel)

            ! find the effective bottom roughness rauh seen by bot_vel above the wave-boundary layer
            ! determined by matching log-profiles of outer and wave-boundary layer, see Kuhrts et al. (2004) Eq. (1,2)
            ! Waves%-quantities are defined at the t-grid. 
                
            ! put wave_u onto the u-grid
            wave_u_u = max(wave_u(i,j),   wave_u(i+1,j), &
                           wave_u(i,j+1), wave_u(i+1,j+1))
            
            if (wave_u_u > epsln) then

                ! put wave_p onto the u-grid
                wave_p_u = max(Waves%wave_p(i,j),   Waves%wave_p(i+1,j), &
                               Waves%wave_p(i,j+1), Waves%wave_p(i+1,j+1))
                ! wave orbital frequency derived from peak frequency [1/s]
                omega=twopi*wave_p_u 
 
                ! iterate now the bottom drag above the wave-boundary layer (Grand and Madsen)

                cnew = cdrag ! use cdrag as first guess                                    ! [dimensionless]
                do icount=1,itmax
                   cold  = cnew                                                             ! [dimensionless]

                   ! calculate current friction velocity with effective bottom drag 
                   ustar  = bot_vel*sqrt(cold)                                              ! [m/s]

                   ! add wave friction to current friction velocity assuming same direction
                   ucomb = sqrt(ustar*ustar + wave_u_u*wave_u_u)                            ! [m/s]

                   ! determine effective bottom roughness rauh from physical bottom roughness ruff
                   rauh  = ruff*(2*von_karman*ucomb/(omega*ruff+epsln))**&                   ! [m]
                        (1.0-ustar/(ucomb+epsln))

                   ! calculate bottom drag above the wave-boundary layer
                   cnew = (von_karman/log(dist/rauh))**2                                     ! [dimensionless]
                   if (id_iter > 0) wrk2_2d(i,j) = icount
                   if (abs(cold-cnew) .le. 0.01*abs(cnew)) exit

                     !TS iteration cnew(iter) better than cnew=cdrag
                     !!! in case of bad convergence, but this must never happen
                     !!            if (icount.eq.itmax) cnew = cdrag

                enddo


            else ! no waves 
                cnew=cdrag
            endif

            ! the effective drag coefficient seen by model velocities above the wave  boundary layer 
            drag_coeff(i,j) = cnew * rho0

            ! the combined current-wave induced stress in wave  boundary layer 
            ustar2 = bot_vel*bot_vel*cnew                                                ! [m/s]
            ucomb = sqrt(ustar2 + wave_u_u*wave_u_u)                                     ! [m/s]


            ! calculate shear stress acting on grains at sediment surface   
            wrk1_2d(i,j) = (ustar2/ucomb)*0.3152

            ! the wave induced friction velocity wave_s is derived applying Nielsen (1992) for grain roughness
            ! store the total wave-current bottom stress in skin friction layer for later use in sediment dynamics

        endif ! kmu.ge.1

     enddo
  enddo
  call mpp_update_domains(wrk1_2d(:,:), drag_coeff(:,:), Dom%domain2d) 

  ! place onto the T-grid
  do j=jsc,jec 
     do i=isc,iec 
        ucskin = max(wrk1_2d(i,j  ), wrk1_2d(i-1,j  ),  &
                     wrk1_2d(i,j-1), wrk1_2d(i-1,j-1))
        Velocity%current_wave_stress(i,j) = rho0*(ucskin*ucskin + wave_s(i,j)*wave_s(i,j))
     enddo
  enddo

  ! diagnostics 
  call diagnose_2d(Time, Grd, id_cur_wav_dr, Velocity%current_wave_stress(:,:))
  call diagnose_2d(Time, Grd, id_wave_s, wave_s(:,:))
  call diagnose_2d(Time, Grd, id_wave_u, wave_u(:,:))
  call diagnose_2d_u(Time, Grd, id_iter, wrk2_2d(:,:))

  if(debug_this_module) then 
      write(stdoutunit,*) 'ocean_wave_model: end wave_drag_diag'
  endif 


end subroutine current_wave_drag_diag
! </SUBROUTINE> NAME="current_wave_drag_diag"


!#######################################################################
! <SUBROUTINE NAME="wave_u_diag">
!
! <DESCRIPTION>
! calculates wave bottom shear stress velocity 
! wave friction factor is parametrized by approximation of 
! Nielsen (1992), Coastal bottom boundary layers and sediment transport!
!
! April 2012
! martin.schmidt@io-warnemuende.de 
!
! </DESCRIPTION>
!
subroutine wave_u_diag(wave_u, wave_s, Waves)
  real, dimension(isd:,jsd:), intent(inout) :: wave_u
  real, dimension(isd:,jsd:), intent(inout) :: wave_s
  type(ocean_wave_type),      intent(inout) :: Waves

  real    :: omega, U_m, ampli, f_w, wk_times_depth, ruff, grain
  integer :: i, j
  real,parameter:: twopi=2.*pi

  ! these fields have units m/s
  wave_u=0.0
  wave_s=0.0

  do j=jsd,jed 
     do i=isd,ied 

        ! water_depth*wave number [dimensionless]
        wk_times_depth = Grd%ht(i,j) * Waves%wave_k(i,j) 

        !TS uncleasr why wk_times_depth .gt. 0.3 ??? possibly to exclude land ht=0
        !!      if (wk_times_depth .gt. 0.3 .and. wk_times_depth.le.50.) then

        if (wk_times_depth.le.50.) then
            ruff = roughness_length(i,j)                                 ! bottom roughness length (grain+form drag) [m]
            omega=twopi*Waves%wave_p(i,j)                                ! wave orbital frequency [1/s]
            ampli=0.5*Waves%height(i,j)/(sinh(wk_times_depth)+epsln)     ! wave amplitude at sea bottom [m]
            U_m=ampli*omega                                              ! wave orbital velocity at sea bottom [m/s]

            !Kuhrts et al. (2004) Eq. (3) fw >= 0.3 if ampli >= 43.9315 * ruff 
            if (ampli.ge.(43.9315*ruff)) then
                f_w= exp(5.5*(30.*ruff/(ampli+epsln))**0.2 - 6.3)          ! [dimensionless]
            else
                f_w= 0.3                                                   ! [dimensionless]
            endif
            wave_u(i,j)=sqrt(0.5*f_w)*U_m                          ! [m/s]

            !Kuhrts et al. (2004) Eq. (7) applied for grain roughness
            grain = ruff/33.0  
            if (ampli.ge.(43.9315*grain)) then
                f_w= exp(5.5*(30.*grain/(ampli+epsln))**0.2 - 6.3)         ! [dimensionless]
            else
                f_w= 0.3                                                   ! [dimensionless]
            endif
            wave_s(i,j)=sqrt(0.5*f_w)*U_m                                ! [m/s]
        endif
     enddo
  enddo

  if(debug_this_module) then 
      write(stdoutunit,*) 'ocean_wave_model: end wave_u_diag'
  endif


end subroutine wave_u_diag
! </SUBROUTINE> NAME="wave_u_diag"

end module ocean_bbc_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------
 
! $Id: isccp_cloud_types.F,v 20.0 2013/12/13 23:16:03 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

#ifdef COSP_GFDL
       SUBROUTINE ISCCP_CLOUD_TYPES(
     &     debug,
     &     debugcol,
     &     npoints,
     &     sunlit,
     &     nlev,
     &     ncol,
     &     seed,
     &     pfull,
     &     phalf,
     &     qv,
     &     cc,
     &     conv,
     &     dtau_s,
     &     dtau_c,
     &     top_height,
     &     top_height_direction,
     &     overlap,
     &     frac_out,
     &     skt,
     &     emsfc_lw,
     &     at,
     &     dem_s,
     &     dem_c,
     &     fq_isccp,
     &     totalcldarea,
     &     meanptop,
     &     meantaucld,
     &     meanalbedocld,
     &     meantb,
     &     meantbclr,
     &     boxtau,
     &     boxptop,
     &     dtau_col,
     &     dem_col 
     &)
#else
      SUBROUTINE ISCCP_CLOUD_TYPES(
     &     debug,
     &     debugcol,
     &     npoints,
     &     sunlit,
     &     nlev,
     &     ncol,
     &     seed,
     &     pfull,
     &     phalf,
     &     qv,
     &     cc,
     &     conv,
     &     dtau_s,
     &     dtau_c,
     &     top_height,
     &     top_height_direction,
     &     overlap,
     &     frac_out,
     &     skt,
     &     emsfc_lw,
     &     at,
     &     dem_s,
     &     dem_c,
     &     fq_isccp,
     &     totalcldarea,
     &     meanptop,
     &     meantaucld,
     &     meanalbedocld,
     &     meantb,
     &     meantbclr,
     &     boxtau,
     &     boxptop
     &)
#endif

#ifndef COSP_GFDL
!$Id: isccp_cloud_types.F,v 20.0 2013/12/13 23:16:03 fms Exp $
#endif

! *****************************COPYRIGHT****************************
! (c) British Crown Copyright 2009, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without 
! modification, are permitted provided that the
! following conditions are met:
! 
!     * Redistributions of source code must retain the above 
!       copyright  notice, this list of conditions and the following 
!       disclaimer.
!     * Redistributions in binary form must reproduce the above 
!       copyright notice, this list of conditions and the following 
!       disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its 
!       contributors may be used to endorse or promote products
!       derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
! A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
! OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
! SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
! LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
! THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
! 
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************

      implicit none

!     NOTE:   the maximum number of levels and columns is set by
!             the following parameter statement

      INTEGER ncolprint
      
!     -----
!     Input 
!     -----

      INTEGER npoints       !  number of model points in the horizontal
      INTEGER nlev          !  number of model levels in column
      INTEGER ncol          !  number of subcolumns

      INTEGER sunlit(npoints) !  1 for day points, 0 for night time

      INTEGER seed(npoints)
      !  seed values for marsaglia  random number generator
      !  It is recommended that the seed is set
      !  to a different value for each model
      !  gridbox it is called on, as it is
      !  possible that the choice of the same
      !  seed value every time may introduce some
      !  statistical bias in the results, particularly
      !  for low values of NCOL.

      REAL pfull(npoints,nlev)
                       !  pressure of full model levels (Pascals)
                  !  pfull(npoints,1) is top level of model
                  !  pfull(npoints,nlev) is bot of model

      REAL phalf(npoints,nlev+1)
                  !  pressure of half model levels (Pascals)
                  !  phalf(npoints,1) is top of model
                  !  phalf(npoints,nlev+1) is the surface pressure

      REAL qv(npoints,nlev)
                  !  water vapor specific humidity (kg vapor/ kg air)
                  !         on full model levels

      REAL cc(npoints,nlev)   
                  !  input cloud cover in each model level (fraction) 
                  !  NOTE:  This is the HORIZONTAL area of each
                  !         grid box covered by clouds

      REAL conv(npoints,nlev) 
                  !  input convective cloud cover in each model
                  !   level (fraction) 
                  !  NOTE:  This is the HORIZONTAL area of each
                  !         grid box covered by convective clouds

      REAL dtau_s(npoints,nlev) 
                  !  mean 0.67 micron optical depth of stratiform
                !  clouds in each model level
                  !  NOTE:  this the cloud optical depth of only the
                  !  cloudy part of the grid box, it is not weighted
                  !  with the 0 cloud optical depth of the clear
                  !         part of the grid box

      REAL dtau_c(npoints,nlev) 
                  !  mean 0.67 micron optical depth of convective
                !  clouds in each
                  !  model level.  Same note applies as in dtau_s.

      INTEGER overlap                   !  overlap type
                              !  1=max
                              !  2=rand
                              !  3=max/rand

      INTEGER top_height                !  1 = adjust top height using both a computed
                                        !  infrared brightness temperature and the visible
                              !  optical depth to adjust cloud top pressure. Note
                              !  that this calculation is most appropriate to compare
                              !  to ISCCP data during sunlit hours.
                                        !  2 = do not adjust top height, that is cloud top
                                        !  pressure is the actual cloud top pressure
                                        !  in the model
                              !  3 = adjust top height using only the computed
                              !  infrared brightness temperature. Note that this
                              !  calculation is most appropriate to compare to ISCCP
                              !  IR only algortihm (i.e. you can compare to nighttime
                              !  ISCCP data with this option)

      INTEGER top_height_direction ! direction for finding atmosphere pressure level
                                 ! with interpolated temperature equal to the radiance
				 ! determined cloud-top temperature
				 !
				 ! 1 = find the *lowest* altitude (highest pressure) level
				 ! with interpolated temperature equal to the radiance
				 ! determined cloud-top temperature
				 !
				 ! 2 = find the *highest* altitude (lowest pressure) level
				 ! with interpolated temperature equal to the radiance 
				 ! determined cloud-top temperature
				 ! 
				 ! ONLY APPLICABLE IF top_height EQUALS 1 or 3
				 !
				 ! 1 = old setting: matches all versions of 
				 ! ISCCP simulator with versions numbers 3.5.1 and lower
				 !
				 ! 2 = default setting: for version numbers 4.0 and higher  
!
!     The following input variables are used only if top_height = 1 or top_height = 3
!
      REAL skt(npoints)                 !  skin Temperature (K)
      REAL emsfc_lw                     !  10.5 micron emissivity of surface (fraction)                                            
      REAL at(npoints,nlev)                   !  temperature in each model level (K)
      REAL dem_s(npoints,nlev)                !  10.5 micron longwave emissivity of stratiform
                              !  clouds in each
                                        !  model level.  Same note applies as in dtau_s.
      REAL dem_c(npoints,nlev)                  !  10.5 micron longwave emissivity of convective
                              !  clouds in each
                                        !  model level.  Same note applies as in dtau_s.

      REAL frac_out(npoints,ncol,nlev) ! boxes gridbox divided up into
                              ! Equivalent of BOX in original version, but
                              ! indexed by column then row, rather than
                              ! by row then column
#ifdef COSP_GFDL
      REAL          dtau_col(npoints,ncol,nlev)
                              ! tau values obtained from model
                              ! stochastic columns

      REAL          dem_col(npoints,ncol,nlev)
                              ! lw emissivity values obtained
                              ! from model stochastic columns
 
#endif



!     ------
!     Output
!     ------

      REAL fq_isccp(npoints,7,7)        !  the fraction of the model grid box covered by
                                        !  each of the 49 ISCCP D level cloud types

      REAL totalcldarea(npoints)        !  the fraction of model grid box columns
                                        !  with cloud somewhere in them.  NOTE: This diagnostic
					! does not count model clouds with tau < isccp_taumin
                              ! Thus this diagnostic does not equal the sum over all entries of fq_isccp.
			      ! However, this diagnostic does equal the sum over entries of fq_isccp with
			      ! itau = 2:7 (omitting itau = 1)
      
      
      ! The following three means are averages only over the cloudy areas with tau > isccp_taumin.  
      ! If no clouds with tau > isccp_taumin are in grid box all three quantities should equal zero.      
                              
      REAL meanptop(npoints)            !  mean cloud top pressure (mb) - linear averaging
                                        !  in cloud top pressure.
                              
      REAL meantaucld(npoints)          !  mean optical thickness 
                                        !  linear averaging in albedo performed.
      
      real meanalbedocld(npoints)        ! mean cloud albedo
                                        ! linear averaging in albedo performed
					
      real meantb(npoints)              ! mean all-sky 10.5 micron brightness temperature
      
      real meantbclr(npoints)           ! mean clear-sky 10.5 micron brightness temperature
      
      REAL boxtau(npoints,ncol)         !  optical thickness in each column
      
      REAL boxptop(npoints,ncol)        !  cloud top pressure (mb) in each column
                              
                                                                                          
!
!     ------
!     Working variables added when program updated to mimic Mark Webb's PV-Wave code
!     ------

      REAL dem(npoints,ncol),bb(npoints)     !  working variables for 10.5 micron longwave 
                              !  emissivity in part of
                              !  gridbox under consideration

      REAL ptrop(npoints)
      REAL attrop(npoints)
      REAL attropmin (npoints)
      REAL atmax(npoints)
      REAL atmin(npoints)
      REAL btcmin(npoints)
      REAL transmax(npoints)

      INTEGER i,j,ilev,ibox,itrop(npoints)
      INTEGER ipres(npoints)
      INTEGER itau(npoints),ilev2
      INTEGER acc(nlev,ncol)
      INTEGER match(npoints,nlev-1)
      INTEGER nmatch(npoints)
      INTEGER levmatch(npoints,ncol)
      
      !variables needed for water vapor continuum absorption
      real fluxtop_clrsky(npoints),trans_layers_above_clrsky(npoints)
      real taumin(npoints)
      real dem_wv(npoints,nlev), wtmair, wtmh20, Navo, grav, pstd, t0
      real press(npoints), dpress(npoints), atmden(npoints)
      real rvh20(npoints), wk(npoints), rhoave(npoints)
      real rh20s(npoints), rfrgn(npoints)
      real tmpexp(npoints),tauwv(npoints)
      
      character*1 cchar(6),cchar_realtops(6)
      integer icycle
      REAL tau(npoints,ncol)
      LOGICAL box_cloudy(npoints,ncol)
      REAL tb(npoints,ncol)
      REAL ptop(npoints,ncol)
      REAL emcld(npoints,ncol)
      REAL fluxtop(npoints,ncol)
      REAL trans_layers_above(npoints,ncol)
      real isccp_taumin,fluxtopinit(npoints),tauir(npoints)
      REAL albedocld(npoints,ncol)
      real boxarea
      integer debug       ! set to non-zero value to print out inputs
                    ! with step debug
      integer debugcol    ! set to non-zero value to print out column
                    ! decomposition with step debugcol
      integer rangevec(npoints),rangeerror

      integer index1(npoints),num1,jj,k1,k2
      real rec2p13,tauchk,logp,logp1,logp2,atd

      character*10 ftn09
      
      DATA isccp_taumin / 0.3 /
      DATA cchar / ' ','-','1','+','I','+'/
      DATA cchar_realtops / ' ',' ','1','1','I','I'/

!     ------ End duplicate definitions common to wrapper routine

       ncolprint=0

      CALL SCOPS(
     &     npoints,
     &     nlev,
     &     ncol,
     &     seed,
     &     cc,
     &     conv,
     &     overlap,
     &     frac_out,
     &     ncolprint
     &)

#ifdef COSP_GFDL
      CALL ICARUS(
     &     debug,
     &     debugcol,
     &     npoints,
     &     sunlit,
     &     nlev,
     &     ncol,
     &     pfull,
     &     phalf,
     &     qv,
     &     cc,
     &     conv,
     &     dtau_s,
     &     dtau_c,
     &     top_height,
     &     top_height_direction,
     &     overlap,
     &     frac_out,
     &     skt,
     &     emsfc_lw,
     &     at,
     &     dem_s,
     &     dem_c,
     &     fq_isccp,
     &     totalcldarea,
     &     meanptop,
     &     meantaucld,
     &     meanalbedocld,
     &     meantb,
     &     meantbclr,
     &     boxtau,
     &     boxptop,
     &     dtau_col,
     &     dem_col
     &)
#else
      CALL ICARUS(
     &     debug,
     &     debugcol,
     &     npoints,
     &     sunlit,
     &     nlev,
     &     ncol,
     &     pfull,
     &     phalf,
     &     qv,
     &     cc,
     &     conv,
     &     dtau_s,
     &     dtau_c,
     &     top_height,
     &     top_height_direction,
     &     overlap,
     &     frac_out,
     &     skt,
     &     emsfc_lw,
     &     at,
     &     dem_s,
     &     dem_c,
     &     fq_isccp,
     &     totalcldarea,
     &     meanptop,
     &     meantaucld,
     &     meanalbedocld,
     &     meantb,
     &     meantbclr,
     &     boxtau,
     &     boxptop
     &)
#endif

      return
      end

#include"cppdefs.h"
!-------------------------------------------------------------------------
!BOP
!
! !ROUTINE: Printing GOTM library version
!
! !INTERFACE:
      subroutine gotm_lib_version(unit)
!
! !DESCRIPTION:
!  Simply prints the version number of the GOTM turbulence library to unit.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: unit
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding & Hans Burchard
!
!  $Log: gotm_lib_version.F90,v $
!  Revision 20.0  2013/12/14 00:13:41  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.5  2005-11-15 11:35:02  lars
!  documentation finish for print
!
!  Revision 1.4  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.3  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.2  2003/03/10 09:02:05  gotm
!  Added new Generic Turbulence Model +
!  improved documentation and cleaned up code
!
!  Revision 1.1.1.1  2001/02/12 15:55:58  gotm
!  initial import into CVS
!
!EOP
!-------------------------------------------------------------------------
!BOC
   write(unit,*) 'GOTM library version: ',RELEASE

   return
   end
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

#include <fms_platform.h>

! ----------------------------------------------------------------
!                   GNU General Public License                        
! This file is a part of MOM.                                                                 
!                                                                      
! MOM is free software; you can redistribute it and/or modify it and  
! are expected to follow the terms of the GNU General Public License  
! as published by the Free Software Foundation; either version 2 of   
! the License, or (at your option) any later version.                 
!                                                                      
! MOM is distributed in the hope that it will be useful, but WITHOUT    
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
! License for more details.                                           
!                                                                      
! For the full text of the GNU General Public License,                
! write to: Free Software Foundation, Inc.,                           
!           675 Mass Ave, Cambridge, MA 02139, USA.                   
! or see:   http://www.gnu.org/licenses/gpl.html                      
!-----------------------------------------------------------------------
!
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> John P. Dunne
!</REVIEWER>
!
!<OVERVIEW>
! Ocean Carbon Model Intercomparison Study II: CFC module
!</OVERVIEW>
!
!<DESCRIPTION>
!       Implementation of routines to solve the OCMIP-2 CFC
!       simulations as outlined in the CFC-HOWTO documentation,
!       revision 1.6, 1999/04/29.
!</DESCRIPTION>
!
! <INFO>
! <REFERENCE>
! http://www.ipsl.jussieu.fr/OCMIP/phase2/simulations/CFC/HOWTO-CFC.html
! </REFERENCE>
! </INFO>
!

module ocmip2_cfc_mod

use atmos_ocean_fluxes_mod, only: aof_set_coupler_flux
use time_manager_mod,   only: time_type
use field_manager_mod,  only: fm_field_name_len, fm_path_name_len, fm_string_len
use field_manager_mod,  only: fm_get_length, fm_get_value, fm_new_value
use fms_mod,            only: field_exist
use ocean_tpm_util_mod, only: otpm_set_tracer_package, otpm_set_prog_tracer
use constants_mod,      only: WTMCFC11, WTMCFC12

use fm_util_mod,        only: fm_util_check_for_bad_fields, fm_util_set_value
use fm_util_mod,        only: fm_util_get_string, fm_util_get_logical, fm_util_get_integer, fm_util_get_real
use fm_util_mod,        only: fm_util_get_logical_array, fm_util_get_real_array, fm_util_get_string_array
use fm_util_mod,        only: fm_util_start_namelist, fm_util_end_namelist
use mpp_mod,            only: stdout, stdlog, mpp_error, mpp_sum, FATAL
use coupler_types_mod,  only: ind_alpha, ind_csurf, coupler_2d_bc_type, ind_flux
use ocean_types_mod,    only: ocean_prog_tracer_type, ocean_grid_type, ocean_time_type
use diag_manager_mod,   only: register_diag_field
use field_manager_mod,  only: fm_get_index
use ocean_util_mod,     only: diagnose_2d, diagnose_2d_comp

implicit none

private

public  :: ocmip2_cfc_bbc
public  :: ocmip2_cfc_end
public  :: ocmip2_cfc_init
public  :: ocmip2_cfc_flux_init
public  :: ocmip2_cfc_sbc
public  :: ocmip2_cfc_source
public  :: ocmip2_cfc_start
public  :: ocmip2_cfc_init_sfc
public  :: ocmip2_cfc_avg_sfc
public  :: ocmip2_cfc_sum_sfc
public  :: ocmip2_cfc_zero_sfc
public  :: ocmip2_cfc_sfc_end

private :: allocate_arrays

character(len=fm_field_name_len), parameter     :: package_name = 'ocmip2_cfc'
character(len=48), parameter                    :: mod_name = 'ocmip2_cfc_mod'
character(len=48), parameter                    :: diag_name = 'ocean_ocmip2_cfc'
character(len=fm_string_len), parameter         :: default_restart_file = 'ocmip2_cfc.res.nc'
character(len=fm_string_len), parameter         :: default_ice_restart_file = 'ice_ocmip2_cfc.res.nc'
character(len=fm_string_len), parameter         :: default_ocean_restart_file = 'ocmip2_cfc_airsea_flux.res.nc'

integer, parameter :: max_cfc_rec = 1200

type cfc_type

  real                                  :: sc_11_0
  real                                  :: sc_11_1
  real                                  :: sc_11_2
  real                                  :: sc_11_3
  real                                  :: d1_11
  real                                  :: d2_11
  real                                  :: d3_11
  real                                  :: d4_11
  real                                  :: e1_11
  real                                  :: e2_11
  real                                  :: e3_11
  real                                  :: sc_12_0
  real                                  :: sc_12_1
  real                                  :: sc_12_2
  real                                  :: sc_12_3
  real                                  :: d1_12
  real                                  :: d2_12
  real                                  :: d3_12
  real                                  :: d4_12
  real                                  :: e1_12
  real                                  :: e2_12
  real                                  :: e3_12
  integer                               :: id_sc_11 = -1
  integer                               :: id_alpha_11 = -1
  integer                               :: id_sc_12 = -1
  integer                               :: id_alpha_12 = -1
  integer                               :: ind_cfc_11
  integer                               :: ind_cfc_12
  integer                               :: ind_cfc_11_flux
  integer                               :: ind_cfc_12_flux
  character(len=fm_field_name_len)      :: name
  real, _ALLOCATABLE, dimension(:,:)    :: sc_11  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: sc_12  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: alpha_11  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: alpha_12  _NULL
  integer                               :: id_sfc_flux_cfc_11 = -1
  integer                               :: id_sfc_flux_cfc_12 = -1

end type cfc_type

logical, public :: do_ocmip2_cfc

type(cfc_type), allocatable, dimension(:)       :: cfc
integer                                         :: instances
integer                                         :: package_index
logical                                         :: module_initialized = .false.
real, allocatable, dimension(:,:)               :: sc_no_term
integer                                         :: indsal
integer                                         :: indtemp

character(len=128) :: version = '$Id: ocmip2_cfc.F90,v 20.0 2013/12/14 00:09:42 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

contains

!#######################################################################
! <SUBROUTINE NAME="allocate_arrays">
!
! <DESCRIPTION>
!     Dynamically allocate arrays
! </DESCRIPTION>
!

subroutine allocate_arrays(isc, iec, jsc, jec)

integer, intent(in)     :: isc
integer, intent(in)     :: iec
integer, intent(in)     :: jsc
integer, intent(in)     :: jec

integer :: n

allocate( sc_no_term(isc:iec,jsc:jec) )

!       allocate cfc array elements
do n = 1, instances
  allocate( cfc(n)%sc_11(isc:iec,jsc:jec) )
  allocate( cfc(n)%alpha_11(isc:iec,jsc:jec) )
  allocate( cfc(n)%sc_12(isc:iec,jsc:jec) )
  allocate( cfc(n)%alpha_12(isc:iec,jsc:jec) )
enddo

sc_no_term(:,:) = 0.0

do n = 1, instances
  cfc(n)%sc_11(:,:) = 0.0
  cfc(n)%alpha_11(:,:) = 0.0
  cfc(n)%sc_12(:,:) = 0.0
  cfc(n)%alpha_12(:,:) = 0.0
enddo

return
end subroutine  allocate_arrays
! </SUBROUTINE> NAME="allocate_arrays"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_cfc_bbc">
!
! <DESCRIPTION>
!     calculate the surface boundary conditions
! </DESCRIPTION>
!
subroutine ocmip2_cfc_bbc

end subroutine  ocmip2_cfc_bbc
! </SUBROUTINE> NAME="ocmip2_cfc_bbc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_cfc_end">
!
! <DESCRIPTION>
!     Clean up various CFC quantities for this run.
! </DESCRIPTION>
!
subroutine ocmip2_cfc_end(isc, iec, jsc, jec, nk, isd, jsd,  &
     T_prog, grid_dat, grid_tmask, rho_dzt, taup1)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: jsd
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
integer, intent(in)                                     :: taup1
real, dimension(isd:,jsd:), intent(in)                  :: grid_dat
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho_dzt

character(len=64), parameter    :: sub_name = 'ocmip2_cfc_end'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer :: i, j, k, n
real    :: total_cfc_11
real    :: total_cfc_12

  integer :: stdoutunit 
  stdoutunit=stdout() 

!       integrate the total concentrations of some tracers
!       for the end of the run

!       Use taup1 time index for the start of a run, and taup1 time
!       index for the end of a run so that we are integrating the
!       same time level and should therefore get identical results
write (stdoutunit,*) trim(note_header),                           &
     'Global integrals at end of run'

do n = 1, instances

  total_cfc_11 = 0.0
  total_cfc_12 = 0.0

  do k = 1,nk
    do j = jsc, jec
      do i = isc, iec
        total_cfc_11 = total_cfc_11 +                           &
             t_prog(cfc(n)%ind_cfc_11)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_cfc_12 = total_cfc_12 +                           &
             t_prog(cfc(n)%ind_cfc_12)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo

  call mpp_sum(total_cfc_11)
  call mpp_sum(total_cfc_12)

  write (stdoutunit,*) '  Instance ', trim(cfc(n)%name)
  write (stdoutunit,                                      &
       '(/'' Total CFC-11  = '',es19.12,'' Gmol'')')    &
       total_cfc_11 * 1.0e-09
  write (stdoutunit,                                      &
       '(/'' Total CFC-12  = '',es19.12,'' Gmol'')')    &
       total_cfc_12 * 1.0e-09

enddo

return
end subroutine  ocmip2_cfc_end
! </SUBROUTINE> NAME="ocmip2_cfc_end"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_cfc_sbc">
!
! <DESCRIPTION>
!     Calculate the surface boundary conditions
! </DESCRIPTION>
!
subroutine ocmip2_cfc_sbc(isc, iec, jsc, jec,     &
     isc_bnd, jsc_bnd,                                 &
     T_prog, Grid, Time, ice_ocean_boundary_fluxes)

integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: isc_bnd
integer, intent(in)                                             :: jsc_bnd
type(ocean_prog_tracer_type), intent(inout), dimension(:)       :: T_prog
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time
type(coupler_2d_bc_type), intent(in)                            :: ice_ocean_boundary_fluxes

integer :: i_bnd_off
integer :: j_bnd_off
integer :: i, j, n

!     use the surface fluxes from the coupler
!       stf is in mol/m^2/s, flux from coupler is positive upwards
i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

do n = 1, instances
  do j = jsc, jec
    do i = isc, iec
      t_prog(cfc(n)%ind_cfc_11)%stf(i,j) =                              &
            -ice_ocean_boundary_fluxes%bc(cfc(n)%ind_cfc_11_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
      t_prog(cfc(n)%ind_cfc_12)%stf(i,j) =                              &
            -ice_ocean_boundary_fluxes%bc(cfc(n)%ind_cfc_12_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
    enddo
  enddo
enddo

! Save variables for diagnostics
do n = 1, instances
   call diagnose_2d(Time, Grid, cfc(n)%id_sfc_flux_cfc_11, t_prog(cfc(n)%ind_cfc_11)%stf(:,:))
   call diagnose_2d(Time, Grid, cfc(n)%id_sfc_flux_cfc_12, t_prog(cfc(n)%ind_cfc_12)%stf(:,:))
enddo

return

end subroutine  ocmip2_cfc_sbc
! </SUBROUTINE> NAME="ocmip2_cfc_sbc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_cfc_flux_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the ocean-atmosphere gas fluxes
! </DESCRIPTION>
subroutine ocmip2_cfc_flux_init

character(len=64), parameter    :: sub_name = 'ocmip2_cfc_flux_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=256)                                      :: caller_str

  integer :: stdoutunit 
  stdoutunit=stdout() 

!       First, perform some initialization if this module has not been
!       initialized because the normal initialization routine will
!       not have been called as part of the normal ocean model
!       initialization if this is an Atmosphere pe of a coupled
!       model running in concurrent mode
if (.not. module_initialized) then

   ! Initialize the package
  package_index = otpm_set_tracer_package(package_name,            &
       restart_file = default_restart_file,                        &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')

  ! Check whether to use this package
  path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
  instances = fm_get_length(path_to_names)
  if (instances .lt. 0) then
    call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
  endif

  write (stdoutunit,*)
  if (instances .eq. 0) then
    write (stdoutunit,*) trim(note_header), ' No instances'
    do_ocmip2_cfc = .false.
  else
    if (instances .eq. 1) then
      write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
    else
      write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
    endif
    do_ocmip2_cfc = .true.
  endif

  module_initialized = .true.

endif

!       Return if we don't want to use this package
if (.not. do_ocmip2_cfc) then
  return
endif

if (.not. allocated(cfc)) then

   ! allocate storage for cfc array
  allocate ( cfc(instances) )

  ! loop over the names, saving them into the cfc array
  do n = 1, instances

    if (fm_get_value(path_to_names, name, index = n)) then
      cfc(n)%name = name
    else
      write (name,*) n
      call mpp_error(FATAL, trim(error_header) //        &
           'Bad field name for index ' // trim(name))
    endif

  enddo

endif

! Set up the ocean-atmosphere gas flux fields
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

  name = cfc(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
  else
    suffix = '_' // name
  endif

  ! Coupler fluxes
  cfc(n)%ind_cfc_11_flux = aof_set_coupler_flux('cfc_11_flux' // suffix,                        &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',                               &
       mol_wt = WTMCFC11, param = (/ 9.36e-07, 9.7561e-06 /),                                   &
       ice_restart_file = default_ice_restart_file,                                             &
       ocean_restart_file = default_ocean_restart_file,                                         &
       caller = caller_str)

  cfc(n)%ind_cfc_12_flux = aof_set_coupler_flux('cfc_12_flux' // suffix,                        &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',                               &
       mol_wt = WTMCFC12, param = (/ 9.36e-07, 9.7561e-06 /),                                   &
       ice_restart_file = default_ice_restart_file,                                             &
       ocean_restart_file = default_ocean_restart_file,                                         &
       caller = caller_str)
enddo

return

end subroutine  ocmip2_cfc_flux_init
!</SUBROUTINE> NAME="ocmip2_cfc_flux_init"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_cfc_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the tracer packages
!
!       Save pointers to various "types", such as Grid and Domains.
! </DESCRIPTION>
subroutine ocmip2_cfc_init

character(len=64), parameter    :: sub_name = 'ocmip2_cfc_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!     Schmidt number coefficients 
!      Use coefficients given by Zheng et al (1998), JGR vol 103, C1
!         for CFC11 and CFC12
real, parameter :: sc_11_0_def = 3501.8
real, parameter :: sc_11_1_def = -210.31
real, parameter :: sc_11_2_def =    6.1851
real, parameter :: sc_11_3_def =   -0.07513

real, parameter :: sc_12_0_def = 3845.4
real, parameter :: sc_12_1_def = -228.95
real, parameter :: sc_12_2_def =    6.1908
real, parameter :: sc_12_3_def =   -0.067430

!     Solubility coefficients for alpha in mol/l/atm
!      (1) for CFC11, (2) for CFC12
!     after Warner and Weiss (1985) DSR, vol 32 for CFC11 and CFC12
real, parameter :: d1_11_def = -229.9261
real, parameter :: d2_11_def =  319.6552
real, parameter :: d3_11_def =  119.4471
real, parameter :: d4_11_def =   -1.39165
real, parameter :: e1_11_def =   -0.142382
real, parameter :: e2_11_def =    0.091459
real, parameter :: e3_11_def =   -0.0157274
 
real, parameter :: d1_12_def = -218.0971
real, parameter :: d2_12_def =  298.9702
real, parameter :: d3_12_def =  113.8049
real, parameter :: d4_12_def =   -1.39165
real, parameter :: e1_12_def =   -0.143566
real, parameter :: e2_12_def =    0.091015
real, parameter :: e3_12_def =   -0.0153924

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=fm_field_name_len+3)                      :: long_suffix
character(len=256)                                      :: caller_str
character(len=fm_string_len), pointer, dimension(:)     :: good_list

  integer :: stdoutunit 
  stdoutunit=stdout() 

!       Check which tracer packages have been turned on

!       Initialize the ocmip2 cfc package
package_index = otpm_set_tracer_package(package_name,           &
     caller=trim(mod_name) // '(' // trim(sub_name) // ')',     &
     restart_file=default_restart_file )

!       Check whether to use this package
path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
instances = fm_get_length(path_to_names)
if (instances .lt. 0) then
  call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
endif

if (instances .eq. 0) then
  write (stdoutunit,*) trim(note_header), ' No instances'
  do_ocmip2_cfc = .false.
else
  if (instances .eq. 1) then
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
  else
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
  endif
  do_ocmip2_cfc = .true.
endif

module_initialized = .true.

!       Return if we don't want to use this package,
!       after changing the list back
if (.not. do_ocmip2_cfc) then
  return
endif

! after reading tracer tree
!       allocate storage for cfc array
allocate ( cfc(instances) )

! loop over the names, saving them into the cfc array
do n = 1, instances
  if (fm_get_value(path_to_names, name, index = n)) then
    cfc(n)%name = name
  else
    write (name,*) n
    call mpp_error(FATAL, trim(error_header) //                 &
         ' Bad field name for index ' // trim(name))
  endif

enddo

! Set up the field input
do n = 1, instances

  name = cfc(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // name
    long_suffix = ' (' // trim(name) // ')'
  endif

  ! CFC-11
  cfc(n)%ind_cfc_11 = otpm_set_prog_tracer('cfc_11' // suffix, package_name,    &
       longname = 'CFC-11' // trim(long_suffix),                                &
       units = 'mol/kg', flux_units = 'mol/m^2/s',                              &
       caller=trim(mod_name) // '(' // trim(sub_name) // ')')

  ! CFC-12
  cfc(n)%ind_cfc_12 = otpm_set_prog_tracer('cfc_12' // suffix, package_name,    &
       longname = 'CFC-12' // trim(long_suffix),                                &
       units = 'mol/kg', flux_units = 'mol/m^2/s',                              &
       caller=trim(mod_name) // '(' // trim(sub_name) // ')')

enddo

!       Add the package name to the list of good namelists, to be used
!       later for a consistency check
if (fm_new_value('/ocean_mod/GOOD/good_namelists', package_name, append = .true.) .le. 0) then
  call mpp_error(FATAL, trim(error_header) //                           &
       ' Could not add ' // trim(package_name) // ' to "good_namelists" list')
endif

! Set up the *global* CFC namelist
caller_str=trim(mod_name) // '(' // trim(sub_name) // ')'

! Set up the instance CFC namelists
do n = 1, instances
  call fm_util_start_namelist(package_name, cfc(n)%name, caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('sc_11_0', sc_11_0_def)
  call fm_util_set_value('sc_11_1', sc_11_1_def)
  call fm_util_set_value('sc_11_2', sc_11_2_def)
  call fm_util_set_value('sc_11_3', sc_11_3_def)

  call fm_util_set_value('sc_12_0', sc_12_0_def)
  call fm_util_set_value('sc_12_1', sc_12_1_def)
  call fm_util_set_value('sc_12_2', sc_12_2_def)
  call fm_util_set_value('sc_12_3', sc_12_3_def)

  call fm_util_set_value('d1_11', d1_11_def)
  call fm_util_set_value('d2_11', d2_11_def)
  call fm_util_set_value('d3_11', d3_11_def)
  call fm_util_set_value('d4_11', d4_11_def)

  call fm_util_set_value('d1_12', d1_12_def)
  call fm_util_set_value('d2_12', d2_12_def)
  call fm_util_set_value('d3_12', d3_12_def)
  call fm_util_set_value('d4_12', d4_12_def)

  call fm_util_set_value('e1_11', e1_11_def)
  call fm_util_set_value('e2_11', e2_11_def)
  call fm_util_set_value('e3_11', e3_11_def)

  call fm_util_set_value('e1_12', e1_12_def)
  call fm_util_set_value('e2_12', e2_12_def)
  call fm_util_set_value('e3_12', e3_12_def)

  call fm_util_end_namelist(package_name, cfc(n)%name, check = .true., caller = caller_str)
enddo

!       Check for any errors in the number of fields in the namelists for this package
good_list => fm_util_get_string_array('/ocean_mod/GOOD/namelists/' // trim(package_name) // '/good_values',   &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
if (associated(good_list)) then
  call fm_util_check_for_bad_fields('/ocean_mod/namelists/' // trim(package_name), good_list,       &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')
  deallocate(good_list)
else
  call mpp_error(FATAL,trim(error_header) // ' Empty "' // trim(package_name) // '" list')
endif

return

end subroutine ocmip2_cfc_init
! </SUBROUTINE> NAME="ocmip2_cfc_init"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_cfc_init_sfc">
!
! <DESCRIPTION>
!       Initialize surface fields for flux calculations
!
!       Note: this subroutine should be merged into ocmip2_cfc_start
! </DESCRIPTION>
subroutine ocmip2_cfc_init_sfc(isc, iec, jsc, jec, isd, jsd,      &
     isc_bnd, jsc_bnd, Ocean_fields, T_prog, rho, taum1, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: jsc_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho
integer, intent(in)                                     :: taum1
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer         :: i, j, n
integer :: i_bnd_off
integer :: j_bnd_off
integer         :: ind
real            :: sal
real            :: ta
real            :: epsln=1.0e-30

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

do n = 1, instances
   ! CFC-11 flux
  ind = cfc(n)%ind_cfc_11_flux
  if (.not. field_exist('INPUT/'//trim(Ocean_fields%bc(ind)%ocean_restart_file),    &
                        Ocean_fields%bc(ind)%field(ind_alpha)%name)) then

!     Calculate solubilities
!       Use Warner and Weiss (1985) DSR, vol 32, final result
!       in mol/l/atm (note, atmospheric data may be in 1 part per trillion 1e-12, pptv)
!
!       use Bullister and Wisegavger for CCl4
!
!       the factor 1.0e+03 is for the conversion from mol/(l * atm) 
!       to mol/(m3 * atm) 
  do j = jsc, jec
    do i = isc, iec
      ta = (t_prog(indtemp)%field(i,j,1,taum1) + 273.15) * 0.01
      sal = t_prog(indsal)%field(i,j,1,taum1)

      cfc(n)%alpha_11(i,j) =                                                            &
           exp(cfc(n)%d1_11 + cfc(n)%d2_11 / ta + cfc(n)%d3_11 * log(ta) +              &
               cfc(n)%d4_11* ta * ta +                                                  &
               sal * ((cfc(n)%e3_11 * ta + cfc(n)%e2_11) * ta + cfc(n)%e1_11)) *        &
           1.0e+03 * grid_tmask(i,j,1)
    enddo
  enddo

  !     Calculate Schmidt numbers
  !      use coefficients given by Zheng et al (1998), JGR vol 103, C1
    do j = jsc, jec
      do i = isc, iec
        cfc(n)%sc_11(i,j) = cfc(n)%sc_11_0 + t_prog(indtemp)%field(i,j,1,taum1) *       &
             (cfc(n)%sc_11_1 + t_prog(indtemp)%field(i,j,1,taum1) *                     &
              (cfc(n)%sc_11_2 + t_prog(indtemp)%field(i,j,1,taum1) * cfc(n)%sc_11_3)) * &
             grid_tmask(i,j,1)
        sc_no_term(i,j) = sqrt(660.0 / (cfc(n)%sc_11(i,j) + epsln)) * grid_tmask(i,j,1)
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =         &
             cfc(n)%alpha_11(i,j) * sc_no_term(i,j)
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =         &
             t_prog(cfc(n)%ind_cfc_11)%field(i,j,1,taum1) * rho(i,j,1,taum1) * sc_no_term(i,j) 
      enddo
    enddo

  endif

  ! CFC-12 flux
  ind = cfc(n)%ind_cfc_12_flux
  if (.not. field_exist('INPUT/'//trim(Ocean_fields%bc(ind)%ocean_restart_file),    &
                        Ocean_fields%bc(ind)%field(ind_alpha)%name)) then
!     Calculate solubilities
!       Use Warner and Weiss (1985) DSR, vol 32, final result
!       in mol/l/atm (note, atmospheric data may be in 1 part per trillion 1e-12, pptv)
!
!       use Bullister and Wisegavger for CCl4
!
!       the factor 1.0e+03 is for the conversion from mol/(l * atm) 
!       to mol/(m3 * atm) 
  do j = jsc, jec
    do i = isc, iec
      ta = (t_prog(indtemp)%field(i,j,1,taum1) + 273.15) * 0.01
      sal = t_prog(indsal)%field(i,j,1,taum1)

      cfc(n)%alpha_12(i,j) =                                                            &
           exp(cfc(n)%d1_12 + cfc(n)%d2_12 / ta + cfc(n)%d3_12 * log(ta) +              &
               cfc(n)%d4_12* ta * ta +                                                  &
               sal * ((cfc(n)%e3_12 * ta + cfc(n)%e2_12) * ta + cfc(n)%e1_12)) *        &
           1.0e+03 * grid_tmask(i,j,1)
    enddo
  enddo

  ! Calculate Schmidt numbers
  ! use coefficients given by Zheng et al (1998), JGR vol 103, C1
    do j = jsc, jec
      do i = isc, iec
        cfc(n)%sc_12(i,j) = cfc(n)%sc_12_0 + t_prog(indtemp)%field(i,j,1,taum1) *       &
             (cfc(n)%sc_12_1 + t_prog(indtemp)%field(i,j,1,taum1) *                     &
              (cfc(n)%sc_12_2 + t_prog(indtemp)%field(i,j,1,taum1) * cfc(n)%sc_12_3)) * &
             grid_tmask(i,j,1)
        sc_no_term(i,j) = sqrt(660.0 / (cfc(n)%sc_12(i,j) + epsln)) * grid_tmask(i,j,1)
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =         &
             cfc(n)%alpha_12(i,j) * sc_no_term(i,j)
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =         &
             t_prog(cfc(n)%ind_cfc_12)%field(i,j,1,taum1) * rho(i,j,1,taum1) * sc_no_term(i,j)
      enddo
    enddo

  endif

enddo

return

end subroutine ocmip2_cfc_init_sfc
! </SUBROUTINE> NAME="ocmip2_cfc_init_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_cfc_sum_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>

subroutine ocmip2_cfc_sum_sfc(isc, iec, jsc, jec, isd, jsd,        &
     isc_bnd, jsc_bnd,                                         &
     Ocean_fields, T_prog, rho, taum1, grid_tmask, Grid, Time)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: jsc_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
type(ocean_prog_tracer_type), intent(in), dimension(:)  :: T_prog
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho
integer, intent(in)                                     :: taum1
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask
type(ocean_grid_type), intent(in)                       :: Grid
type(ocean_time_type), intent(in)                       :: Time


integer         :: i, j, n
integer :: i_bnd_off
integer :: j_bnd_off
integer         :: ind
real            :: sal
real            :: ta
real            :: epsln=1.0e-30
logical, save   :: done = .false.
logical, save   :: need = .false.

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

do n = 1, instances

   ! CFC-11 flux
  ind = cfc(n)%ind_cfc_11_flux

!     Calculate solubilities
!       Use Warner and Weiss (1985) DSR, vol 32, final result
!       in mol/l/atm (note, atmospheric data may be in 1 part per trillion 1e-12, pptv)
!
!       use Bullister and Wisegavger for CCl4
!
!       the factor 1.0e+03 is for the conversion from mol/(l * atm) 
!       to mol/(m3 * atm) 
  do j = jsc, jec
    do i = isc, iec
      ta = (t_prog(indtemp)%field(i,j,1,taum1) + 273.15) * 0.01
      sal = t_prog(indsal)%field(i,j,1,taum1)

      cfc(n)%alpha_11(i,j) =                                                            &
           exp(cfc(n)%d1_11 + cfc(n)%d2_11 / ta + cfc(n)%d3_11 * log(ta) +              &
               cfc(n)%d4_11* ta * ta +                                                  &
               sal * ((cfc(n)%e3_11 * ta + cfc(n)%e2_11) * ta + cfc(n)%e1_11)) *        &
           1.0e+03 * grid_tmask(i,j,1)
    enddo
  enddo

  !     Calculate Schmidt numbers
  !      use coefficients given by Zheng et al (1998), JGR vol 103, C1
  do j = jsc, jec
    do i = isc, iec
      cfc(n)%sc_11(i,j) = cfc(n)%sc_11_0 + t_prog(indtemp)%field(i,j,1,taum1) *         &
           (cfc(n)%sc_11_1 + t_prog(indtemp)%field(i,j,1,taum1) *                       &
            (cfc(n)%sc_11_2 + t_prog(indtemp)%field(i,j,1,taum1) * cfc(n)%sc_11_3)) *   &
           grid_tmask(i,j,1)
      sc_no_term(i,j) = sqrt(660.0 / (cfc(n)%sc_11(i,j) + epsln)) * grid_tmask(i,j,1)
      Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
           Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +      &
           cfc(n)%alpha_11(i,j) * sc_no_term(i,j)
      Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
           Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +      &
           t_prog(cfc(n)%ind_cfc_11)%field(i,j,1,taum1) * rho(i,j,1,taum1) * sc_no_term(i,j)
    enddo
  enddo

  ! CFC-12 flux
  ind = cfc(n)%ind_cfc_12_flux

!     Calculate solubilities
!       Use Warner and Weiss (1985) DSR, vol 32, final result
!       in mol/l/atm (note, atmospheric data may be in 1 part per trillion 1e-12, pptv)
!
!       use Bullister and Wisegavger for CCl4
!
!       the factor 1.0e+03 is for the conversion from mol/(l * atm) 
!       to mol/(m3 * atm) 
  do j = jsc, jec
    do i = isc, iec
      ta = (t_prog(indtemp)%field(i,j,1,taum1) + 273.15) * 0.01
      sal = t_prog(indsal)%field(i,j,1,taum1)

      cfc(n)%alpha_12(i,j) =                                                            &
           exp(cfc(n)%d1_12 + cfc(n)%d2_12 / ta + cfc(n)%d3_12 * log(ta) +              &
               cfc(n)%d4_12* ta * ta +                                                  &
               sal * ((cfc(n)%e3_12 * ta + cfc(n)%e2_12) * ta + cfc(n)%e1_12)) *        &
           1.0e+03 * grid_tmask(i,j,1)
    enddo
  enddo

  ! Calculate Schmidt numbers
  ! use coefficients given by Zheng et al (1998), JGR vol 103, C1
  do j = jsc, jec
    do i = isc, iec
      cfc(n)%sc_12(i,j) = cfc(n)%sc_12_0 + t_prog(indtemp)%field(i,j,1,taum1) *         &
           (cfc(n)%sc_12_1 + t_prog(indtemp)%field(i,j,1,taum1) *                       &
            (cfc(n)%sc_12_2 + t_prog(indtemp)%field(i,j,1,taum1) * cfc(n)%sc_12_3)) *   &
           grid_tmask(i,j,1)
      sc_no_term(i,j) = sqrt(660.0 / (cfc(n)%sc_12(i,j) + epsln)) * grid_tmask(i,j,1)
      Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
           Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +      &
           cfc(n)%alpha_12(i,j) * sc_no_term(i,j)
      Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
           Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +      &
           t_prog(cfc(n)%ind_cfc_12)%field(i,j,1,taum1) * rho(i,j,1,taum1) * sc_no_term(i,j)
    enddo
  enddo

enddo

! Save variables for diagnostics

!       set up the grid mask on the computational grid so that we
!       will not need to implicitly copy arrays in the following
!       subroutine calls
if (.not. done) then
  need = .false.
  do n = 1, instances
    need = need .or.                    &
         cfc(n)%id_alpha_11 .gt. 0 .or. &
         cfc(n)%id_sc_11 .gt. 0 .or.    &
         cfc(n)%id_alpha_12 .gt. 0 .or. &
         cfc(n)%id_sc_12 .gt. 0
  enddo
  done = .true.
endif

if (need) then
  do n = 1, instances
     call diagnose_2d_comp(Time, Grid, cfc(n)%id_alpha_11, cfc(n)%alpha_11(:,:))
     call diagnose_2d_comp(Time, Grid, cfc(n)%id_sc_11, cfc(n)%sc_11(:,:))
     call diagnose_2d_comp(Time, Grid, cfc(n)%id_alpha_12, cfc(n)%alpha_12(:,:))
     call diagnose_2d_comp(Time, Grid, cfc(n)%id_sc_12, cfc(n)%sc_12(:,:))
  enddo
endif

return

end subroutine ocmip2_cfc_sum_sfc
! </SUBROUTINE> NAME="ocmip2_cfc_sum_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_cfc_zero_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>

subroutine ocmip2_cfc_zero_sfc(Ocean_fields)

type(coupler_2d_bc_type), intent(inout) :: Ocean_fields

integer         :: n
integer         :: ind

do n = 1, instances
  ind = cfc(n)%ind_cfc_11_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0

  ind = cfc(n)%ind_cfc_12_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0
enddo

return

end subroutine ocmip2_cfc_zero_sfc
! </SUBROUTINE> NAME="ocmip2_cfc_zero_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_cfc_avg_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>

subroutine ocmip2_cfc_avg_sfc(isc, iec, jsc, jec, isd, jsd,        &
     isc_bnd, jsc_bnd, Ocean_fields, Ocean_avg_kount, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: jsc_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
integer                                                 :: Ocean_avg_kount
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer :: i_bnd_off
integer :: j_bnd_off
integer :: i, j
integer         :: n
integer         :: ind
real            :: divid

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

divid = 1./float(Ocean_avg_kount)

do n = 1, instances

  ind = cfc(n)%ind_cfc_11_flux

  do j = jsc, jec
    do i = isc, iec
      if (Grid_tmask(i,j,1) == 1.0) then
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
      endif
    enddo
  enddo

  ind = cfc(n)%ind_cfc_12_flux

  do j = jsc, jec
    do i = isc, iec
      if (Grid_tmask(i,j,1) == 1.0) then
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
      endif
    enddo
  enddo

enddo

return

end subroutine ocmip2_cfc_avg_sfc
! </SUBROUTINE> NAME="ocmip2_cfc_avg_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_cfc_sfc_end">
!
! <DESCRIPTION>
!       Initialize surface fields for flux calculations
! </DESCRIPTION>

subroutine ocmip2_cfc_sfc_end

end subroutine ocmip2_cfc_sfc_end
! </SUBROUTINE> NAME="ocmip2_cfc_sfc_end"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_cfc_source">
!
! <DESCRIPTION>
!     compute the source terms for the CFCs, including boundary
!     conditions (not done in setvbc, to minimize number
!     of hooks required in MOM base code)
! </DESCRIPTION>
!
subroutine ocmip2_cfc_source

end subroutine  ocmip2_cfc_source
! </SUBROUTINE> NAME="ocmip2_cfc_source"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_cfc_start">
!
! <DESCRIPTION>
! Initialize variables, read in namelists, calculate constants
! for a given run and allocate diagnostic arrays
! </DESCRIPTION>
!
subroutine ocmip2_cfc_start(isc, iec, jsc, jec, nk, isd, jsd,         &
     T_prog, taup1, model_time, grid_dat, grid_tmask, grid_tracer_axes, rho_dzt)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: jsd
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
integer, intent(in)                                     :: taup1
type(time_type), intent(in)                             :: model_time
real, dimension(isd:,jsd:), intent(in)                  :: grid_dat
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask
integer, dimension(3), intent(in)                       :: grid_tracer_axes
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho_dzt

character(len=64), parameter    :: sub_name = 'ocmip2_cfc_start'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

character(len=fm_field_name_len+3)      :: long_suffix
integer                                 :: i, j, k, n
character(len=fm_field_name_len+1)      :: suffix
character(len=256)                      :: caller_str
real                                    :: total_cfc_11
real                                    :: total_cfc_12

  integer :: stdoutunit 
  stdoutunit=stdout() 

write(stdoutunit,*) 
write(stdoutunit,*) trim(note_header),                     &
                  ' Starting ', trim(package_name), ' module'

! Determine indices for temperature and salinity
indtemp = fm_get_index('/ocean_mod/prog_tracers/temp')
if (indtemp .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the temperature index')
endif

indsal = fm_get_index('/ocean_mod/prog_tracers/salt')
if (indsal .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the salinity index')
endif

! dynamically allocate the global CFC arrays
call allocate_arrays(isc, iec, jsc, jec)

! save the *global* namelist values
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances
  call fm_util_start_namelist(package_name, cfc(n)%name, caller = caller_str)

  cfc(n)%sc_11_0 =    fm_util_get_real   ('sc_11_0', scalar = .true.)
  cfc(n)%sc_11_1 =    fm_util_get_real   ('sc_11_1', scalar = .true.)
  cfc(n)%sc_11_2 =    fm_util_get_real   ('sc_11_2', scalar = .true.)
  cfc(n)%sc_11_3 =    fm_util_get_real   ('sc_11_3', scalar = .true.)
  cfc(n)%sc_12_0 =    fm_util_get_real   ('sc_12_0', scalar = .true.)
  cfc(n)%sc_12_1 =    fm_util_get_real   ('sc_12_1', scalar = .true.)
  cfc(n)%sc_12_2 =    fm_util_get_real   ('sc_12_2', scalar = .true.)
  cfc(n)%sc_12_3 =    fm_util_get_real   ('sc_12_3', scalar = .true.)

  cfc(n)%d1_11 =    fm_util_get_real   ('d1_11', scalar = .true.)
  cfc(n)%d2_11 =    fm_util_get_real   ('d2_11', scalar = .true.)
  cfc(n)%d3_11 =    fm_util_get_real   ('d3_11', scalar = .true.)
  cfc(n)%d4_11 =    fm_util_get_real   ('d4_11', scalar = .true.)
  cfc(n)%d1_12 =    fm_util_get_real   ('d1_12', scalar = .true.)
  cfc(n)%d2_12 =    fm_util_get_real   ('d2_12', scalar = .true.)
  cfc(n)%d3_12 =    fm_util_get_real   ('d3_12', scalar = .true.)
  cfc(n)%d4_12 =    fm_util_get_real   ('d4_12', scalar = .true.)

  cfc(n)%e1_11 =    fm_util_get_real   ('e1_11', scalar = .true.)
  cfc(n)%e2_11 =    fm_util_get_real   ('e2_11', scalar = .true.)
  cfc(n)%e3_11 =    fm_util_get_real   ('e3_11', scalar = .true.)
  cfc(n)%e1_12 =    fm_util_get_real   ('e1_12', scalar = .true.)
  cfc(n)%e2_12 =    fm_util_get_real   ('e2_12', scalar = .true.)
  cfc(n)%e3_12 =    fm_util_get_real   ('e3_12', scalar = .true.)

  call fm_util_end_namelist(package_name, cfc(n)%name, caller = caller_str)
enddo

! Set up analyses

! register the fields
do n = 1, instances

  if (cfc(n)%name(1:1) .eq. '_') then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // cfc(n)%name
    long_suffix = ' (' // trim(cfc(n)%name) // ')'
  endif

  cfc(n)%id_sfc_flux_cfc_11 = register_diag_field(trim(diag_name),                      &
       'sfc_flux_cfc_11' // trim(suffix), grid_tracer_axes(1:2),                        &
       model_time, 'Surface Flux - CFC-11' // trim(long_suffix), 'mol m^-2 s^-1',       &
       missing_value = -1.0e+10)

  cfc(n)%id_sfc_flux_cfc_12 = register_diag_field(trim(diag_name),                      &
       'sfc_flux_cfc_12' // trim(suffix), grid_tracer_axes(1:2),                        &
       model_time, 'Surface Flux - CFC-12' // trim(long_suffix), 'mol m^-2 s^-1',       &
       missing_value = -1.0e+10)

  cfc(n)%id_sc_11 = register_diag_field(trim(diag_name),                &
       'sc_11'//trim(suffix), grid_tracer_axes(1:2),                    &
       model_time,                                                      &
       'Schmidt number - CFC-11'//trim(long_suffix), ' ',               &
       missing_value = -1.0e+10)

  cfc(n)%id_alpha_11 = register_diag_field(trim(diag_name),             &
       'alpha_11'//trim(suffix), grid_tracer_axes(1:2),                 &
       model_time,                                                      &
       'Solubility CFC-11' // trim(long_suffix), 'mol m^-3 atm^-1',     &
       missing_value = -1.0e+10)

  cfc(n)%id_sc_12 = register_diag_field(trim(diag_name),                &
       'sc_12'//trim(suffix), grid_tracer_axes(1:2),                    &
       model_time,                                                      &
       'Schmidt number - CFC-12'//trim(long_suffix), ' ',               &
       missing_value = -1.0e+10)

  cfc(n)%id_alpha_12 = register_diag_field(trim(diag_name),             &
       'alpha_12'//trim(suffix), grid_tracer_axes(1:2),                 &
       model_time,                                                      &
       'Solubility CFC-12' // trim(long_suffix), 'mol m^-3 atm^-1',     &
       missing_value = -1.0e+10)
enddo

!       integrate the total concentrations of some tracers
!       for the start of the run

!       Use taup1 time index for the start of a run, and taup1 time
!       index for the end of a run so that we are integrating the
!       same time level and should therefore get identical results
!
write (stdoutunit,*) trim(note_header),                           &
     'Global integrals at start of run'

do n = 1, instances

  total_cfc_11 = 0.0
  total_cfc_12 = 0.0

  do k = 1,nk
    do j = jsc, jec
      do i = isc, iec
        total_cfc_11 = total_cfc_11 +                           &
             t_prog(cfc(n)%ind_cfc_11)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_cfc_12 = total_cfc_12 +                           &
             t_prog(cfc(n)%ind_cfc_12)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo

  call mpp_sum(total_cfc_11)
  call mpp_sum(total_cfc_12)

  write (stdoutunit,*) '  Instance ', trim(cfc(n)%name)
  write (stdoutunit,                                      &
       '(/'' Total CFC-11  = '',es19.12,'' Gmol'')')    &
       total_cfc_11 * 1.0e-09
  write (stdoutunit,                                      &
       '(/'' Total CFC-12  = '',es19.12,'' Gmol'')')    &
       total_cfc_12 * 1.0e-09

enddo

write(stdoutunit,*)
write(stdoutunit,*) trim(note_header), ' Tracer runs initialized'
write(stdoutunit,*)

return

end subroutine  ocmip2_cfc_start
! </SUBROUTINE> NAME="ocmip2_cfc_start"


end module  ocmip2_cfc_mod

 
               module rad_utilities_mod
!
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  smf
! </REVIEWER>
! 
! <OVERVIEW>
!  Code to define the derived data types and provide table search routines.
! </OVERVIEW>
! <DESCRIPTION>
!  This code is used in the radiation code package as a helper module.
!  It defines many derived data types used in radiation calculation.
!  This code also provides table search routines and simple arithmatic
!  routines.
! </DESCRIPTION>
!
use mpp_mod,            only : input_nml_file
use fms_mod,            only : open_namelist_file, fms_init, &
                               mpp_pe, mpp_root_pe, stdlog, &
                               file_exist, write_version_number, &
                               check_nml_error, error_mesg, &
                               FATAL, close_file, lowercase
use  field_manager_mod, only : parse

use time_manager_mod,   only : time_type

!--------------------------------------------------------------------

implicit none
private

!---------------------------------------------------------------------
!    rad_utilities_mod contains radiation table search routines,
!    some band averaging routines, and the derived-type variables 
!    used in the radiation package.
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------

character(len=128)  :: version =  '$Id: rad_utilities.F90,v 20.0 2013/12/13 23:20:23 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'

!---------------------------------------------------------------------
!-------  interfaces --------

public      &
          rad_utilities_init, check_derived_types, & 
          locate_in_table,  &
          looktab, table_alloc, &
          thickavg, thinavg,   &
          rad_utilities_end,   &
          get_radiative_param, assignment(=)

interface looktab
    module procedure  looktab_type1, looktab_type2, looktab_type3
end interface

interface table_alloc
   module procedure    table1_alloc, table2_alloc, table3_alloc
end interface

interface thickavg
   module procedure thickavg_3d
   module procedure thickavg_0d
   module procedure thickavg_1band
   module procedure thickavg_isccp
end interface

interface assignment(=)
  module procedure lw_output_type_eq
  module procedure sw_output_type_eq
  module procedure aerosol_props_type_eq
end interface

!------------------------------------------------------------------

public   aerosol_type              
  
!    aerosol
!    aerosol_names
!    family_members

type aerosol_type
     real, dimension(:,:,:,:),        pointer :: aerosol=>NULL()
     logical, dimension(:,:),        pointer :: family_members=>NULL()
     character(len=64), dimension(:), pointer :: aerosol_names=>NULL()
end type aerosol_type              

!------------------------------------------------------------------
 
public   aerosol_diagnostics_type
 
!    extopdep
!    absopdep
!    extopdep_vlcno
!    absopdep_vlcno
!    lw_extopdep_vlcno
!    lw_absopdep_vlcno
!    sw_heating_vlcno
 
type aerosol_diagnostics_type
!    real, dimension(:,:,:),   pointer  :: sw_heating_vlcno=>NULL()
     real, dimension(:,:,:,:),   pointer  :: sw_heating_vlcno=>NULL()
     real, dimension(:,:,:,:,:), pointer  :: extopdep=>NULL(), &
                                             absopdep=>NULL()
     real, dimension(:,:,:,:,:), pointer  :: asymdep=>NULL()

     real, dimension(:,:,:,:), pointer  :: extopdep_vlcno=>NULL(), &
                                           absopdep_vlcno=>NULL(), &
                                           lw_extopdep_vlcno=>NULL(), &
                                           lw_absopdep_vlcno=>NULL()
 
end type aerosol_diagnostics_type
 
!------------------------------------------------------------------

public   aerosol_properties_type

!    aerextband
!    aerssalbband
!    aerasymmband
!    aerextbandlw
!    aerssalbbandlw
!    sulfate_index
!    optical_index

type aerosol_properties_type
     integer, dimension(:,:,:), pointer  :: ivol=>NULL()
     real, dimension(:,:), pointer  :: aerextband=>NULL(),   &
                                       aerssalbband=>NULL(), &
                                       aerasymmband=>NULL(), &
                                       aerextbandlw=>NULL(), &
                                       aerssalbbandlw=>NULL(), &
                                       aerextbandlw_cn=>NULL(), &
                                       aerssalbbandlw_cn=>NULL()
     real, dimension(:,:,:,:), pointer :: sw_ext=>NULL(), &
                                          sw_ssa=>NULL(), &
                                          sw_asy=>NULL(), &
                                          lw_ext=>NULL(), &
                                          lw_ssa=>NULL(), &
                                          lw_asy=>NULL()
!yim
     integer, dimension(:,:), pointer :: sulfate_index=>NULL()
     integer, dimension(:), pointer :: optical_index=>NULL()
     integer, dimension(:), pointer :: omphilic_index=>NULL()
     integer, dimension(:), pointer :: bcphilic_index=>NULL()
     integer, dimension(:), pointer :: seasalt1_index=>NULL()
     integer, dimension(:), pointer :: seasalt2_index=>NULL()
     integer, dimension(:), pointer :: seasalt3_index=>NULL()
     integer, dimension(:), pointer :: seasalt4_index=>NULL()
     integer, dimension(:), pointer :: seasalt5_index=>NULL()
     integer                        :: sulfate_flag
     integer                        :: omphilic_flag
     integer                        :: bcphilic_flag
     integer                        :: seasalt1_flag
     integer                        :: seasalt2_flag
     integer                        :: seasalt3_flag
     integer                        :: seasalt4_flag
     integer                        :: seasalt5_flag
!yim
     integer                        :: bc_flag
end type aerosol_properties_type

!------------------------------------------------------------------

public astronomy_type
    
!    solar
!    cosz
!    fracday
!    rrsun

type astronomy_type
     real, dimension(:,:), pointer  :: solar=>NULL(),   &
                                       cosz=>NULL(),  &
                                       fracday=>NULL()
     real, dimension(:,:,:), pointer  :: solar_p=>NULL(),   &
                                       cosz_p=>NULL(),  &
                                       fracday_p=>NULL()
     real    :: rrsun
end type astronomy_type

!--------------------------------------------------------------------
 
public astronomy_inp_type
 
!    zenith_angle   specified zenith angles [ degrees ]
!    fracday        specified daylight fraction [ fraction ]
!    rrsun          specified earth-sun distance, normalized by mean
!                   distance 

type astronomy_inp_type
     real, dimension(:,:), pointer  :: zenith_angle=>NULL()
     real, dimension(:,:), pointer  :: fracday=>NULL()
     real                           :: rrsun
end type astronomy_inp_type

!--------------------------------------------------------------------

public atmos_input_type

!    press
!    temp
!    rh2o
!    zfull
!    pflux
!    tflux
!    deltaz
!    phalf
!    rel_hum
!    cloudtemp
!    clouddeltaz
!    cloudvapor
!    aerosoltemp
!    aerosolvapor
!    aerosolpress
!    aerosolrelhum
!    tracer_co2
!    g_rrvco2
!    tsfc
!    psfc

type atmos_input_type
     real, dimension(:,:,:), pointer :: press=>NULL(),   &
                                        temp=>NULL(), &
                                        rh2o=>NULL(),  &
                                        zfull=>NULL(),  &
                                        pflux=>NULL(), &
                                        tflux=>NULL(),  &
                                        deltaz=>NULL(),  &
                                        phalf=>NULL(),   &
                                        rel_hum=>NULL(), &
                                        cloudtemp=>NULL(),   &
                                        clouddeltaz=>NULL(), &
                                        cloudvapor=>NULL(), &
                                        aerosoltemp=>NULL(), &
                                        aerosolvapor=>NULL(), &
                                        aerosolpress=>NULL(), &
                                        aerosolrelhum=>NULL(), &
                                        tracer_co2 => NULL()
     real, dimension(:,:),   pointer :: tsfc=>NULL(),   &
                                        psfc=>NULL()              
     real                            :: g_rrvco2
end type atmos_input_type

!-------------------------------------------------------------------

public cldrad_properties_type

!    cldext
!    cldasymm
!    cldsct
!    emmxolw
!    emrndlw
!    abscoeff
!    cldemiss
!    cirabsw
!    cirrfsw
!    cvisrfsw

type cldrad_properties_type
     real, dimension(:,:,:,:,:), pointer :: cldext=>NULL(),   &
                                          cldasymm=>NULL(), &
                                          cldsct=>NULL()
     real, dimension(:,:,:,:,:), pointer ::                   &
                                          emmxolw=>NULL(), &
                                          emrndlw=>NULL(),  &
                                          abscoeff=>NULL(),  &
                                          cldemiss=>NULL()
     real, dimension(:,:,:), pointer ::   cirabsw=>NULL(), &
                                          cirrfsw=>NULL(),   &
                                          cvisrfsw=>NULL()
end type cldrad_properties_type

!------------------------------------------------------------------

public cld_space_properties_type

!    camtswkc
!    cirabswkc
!    cirrfswkc
!    cvisrfswkc
!    ktopswkc
!    kbtmswkc

type cld_space_properties_type
     real, dimension(:,:,:),    pointer :: camtswkc=>NULL()        
     real, dimension(:,:,:),    pointer :: cirabswkc=>NULL(),  &
                                           cirrfswkc=>NULL(), &
                                           cvisrfswkc=>NULL()
     integer, dimension(:,:,:), pointer :: ktopswkc=>NULL(),   &
                                           kbtmswkc=>NULL()
end type cld_space_properties_type

!------------------------------------------------------------------

public cld_specification_type

!    tau
!    lwp
!    iwp
!    reff_liq
!    reff_ice
!    liq_frac
!    cloud_water
!    cloud_ice
!    cloud_area
!    cloud_droplet
!    reff_liq_micro
!    reff_ice_micro
!    camtsw
!    cmxolw
!    crndlw
!    cld_thickness
!    ncldsw
!    nmxolw
!    nrndlw
!    hi_cloud
!    mid_cloud
!    low_cloud
!    ice_cloud

type cld_specification_type
   real, dimension(:,:,:,:),  pointer :: tau=>NULL(),  &
                                         camtsw_band=>NULL(), &
                                         crndlw_band=>NULL(), &
                                         lwp_lw_band=>NULL(), &
                                         iwp_lw_band=>NULL(), &
                                         lwp_sw_band=>NULL(), &
                                         iwp_sw_band=>NULL(), &
                                         reff_liq_lw_band=>NULL(),   &
                                         reff_ice_lw_band=>NULL(), &
                                         reff_liq_sw_band=>NULL(),   &
                                         reff_ice_sw_band=>NULL()
   real, dimension(:,:,:),    pointer :: lwp=>NULL(),   &
                                         iwp=>NULL(),  &
                                         reff_liq=>NULL(),   &
                                         reff_ice=>NULL(), &
                                         reff_liq_lim=>NULL(),   &
                                         reff_ice_lim=>NULL(), &
                                         liq_frac=>NULL(), &
                                         cloud_water=>NULL(), &
                                         cloud_ice=>NULL(),  &
                                         cloud_area=>NULL(), &
                                         cloud_droplet=>NULL(), &
                                         cloud_ice_num=>NULL(), &
  ! snow, rain
                                         rain =>NULL(), &
                                         snow =>NULL(), &
                                         rain_size =>NULL(), &
                                         snow_size =>NULL(), &

                                         reff_liq_micro=>NULL(),   &
                                         reff_ice_micro=>NULL(),&
                                         camtsw=>NULL(),   &
                                         cmxolw=>NULL(),  &
                                         crndlw=>NULL()
   integer, dimension(:,:,:), pointer :: cld_thickness=>NULL()
   integer, dimension(:,:,:,:), pointer :: stoch_cloud_type=>NULL()
   integer, dimension(:,:,:,:), pointer :: cld_thickness_lw_band=>NULL()
   integer, dimension(:,:,:,:), pointer :: cld_thickness_sw_band=>NULL()
   integer, dimension(:,:),   pointer :: ncldsw=>NULL(),   &
                                         nmxolw=>NULL(),&
                                         nrndlw=>NULL()
   integer, dimension(:,:,:), pointer :: ncldsw_band=>NULL(),   &
                                         nrndlw_band=>NULL()
   logical, dimension(:,:,:), pointer :: hi_cloud=>NULL(),   &
                                         mid_cloud=>NULL(),  &
                                         low_cloud=>NULL(),   &
                                         ice_cloud=>NULL()
end type cld_specification_type

!------------------------------------------------------------------

public cloudrad_control_type

type cloudrad_control_type
    logical :: do_pred_cld_microphys
    logical :: do_presc_cld_microphys
    logical :: do_bulk_microphys
    logical :: do_sw_micro
    logical :: do_lw_micro
    logical :: do_rh_clouds        
    logical :: do_strat_clouds        
    logical :: do_zonal_clouds        
    logical :: do_mgroup_prescribed
    logical :: do_obs_clouds        
    logical :: do_no_clouds        
    logical :: do_diag_clouds        
    logical :: do_specified_clouds        
    logical :: do_donner_deep_clouds
    logical :: do_uw_clouds
    logical :: do_zetac_clouds
    logical :: do_random_overlap
    logical :: do_max_random_overlap
    logical :: do_stochastic_clouds
    logical :: use_temp_for_seed
    logical :: do_specified_strat_clouds
    logical :: do_ica_calcs
    logical :: do_liq_num
    logical :: do_ice_num
    logical :: using_fu2007
    integer :: nlwcldb                   !   number of frequency bands 
                                         !   for which lw cloud emissiv-
                                         !   ities are defined.
    integer :: cloud_data_points
    integer :: ich
    integer :: icm
    integer :: ict
    integer :: icb
    logical :: do_pred_cld_microphys_iz
    logical :: do_presc_cld_microphys_iz
    logical :: do_bulk_microphys_iz
    logical :: do_sw_micro_iz
    logical :: do_lw_micro_iz
    logical :: do_rh_clouds_iz
    logical :: do_strat_clouds_iz
    logical :: do_zonal_clouds_iz
    logical :: do_mgroup_prescribed_iz
    logical :: do_obs_clouds_iz
    logical :: do_no_clouds_iz
    logical :: do_diag_clouds_iz
    logical :: do_specified_clouds_iz
    logical :: do_donner_deep_clouds_iz
    logical :: do_uw_clouds_iz
    logical :: do_zetac_clouds_iz
    logical :: do_random_overlap_iz
    logical :: do_max_random_overlap_iz
    logical :: do_stochastic_clouds_iz
    logical :: use_temp_for_seed_iz
    logical :: do_specified_strat_clouds_iz
    logical :: do_ica_calcs_iz
    logical :: do_liq_num_iz
    logical :: do_ice_num_iz
    logical :: using_fu2007_iz
end type cloudrad_control_type

!------------------------------------------------------------------

public fsrad_output_type

!    tdtsw
!    tdtlw
!    tdtsw_clr
!    tdtlw_clr
!    swdns
!    swups
!    lwdns
!    lwups
!    swin
!    swout
!    olr
!    swdns_clr
!    swups_clr
!    lwdns_clr
!    lwups_clr`
!    swin_clr
!    swout_clr
!    olr_clr
!    npass

type fsrad_output_type
     real, dimension(:,:,:), pointer :: tdtsw=>NULL(), &
                                        tdtlw=>NULL(),  &
                                        tdtsw_clr=>NULL(),  &
                                        tdtlw_clr=>NULL()
     real, dimension(:,:),   pointer :: swdns=>NULL(),   &
                                        swups=>NULL(),  &
                                        lwups=>NULL(), &
                                        lwdns=>NULL(), &
                                        swin=>NULL(), &
                                        swout=>NULL(), &
                                        olr=>NULL(), &
                                        swdns_clr=>NULL(),  &
                                        swups_clr=>NULL(),  &
                                        lwups_clr=>NULL(),&
                                        lwdns_clr=>NULL(),   &
                                        swin_clr=>NULL(),  &
                                        swout_clr=>NULL(), &
                                        olr_clr=>NULL()
     integer      :: npass
end type fsrad_output_type

!-------------------------------------------------------------------

public gas_tf_type

!    tdav
!    tlsqu
!    tmpdiff
!    tstdav
!    co2nbl
!    n2o9c
!    tn2o17
!    co2spnb
!    a1
!    a2

type gas_tf_type
     real, dimension(:,:,:),   pointer :: tdav=>NULL(),   &
                                          tlsqu=>NULL(),   &
                                          tmpdiff=>NULL(),   &
                                          tstdav=>NULL(),  &
                                          co2nbl=>NULL(),   &
                                          n2o9c=>NULL(),   &
                                          tn2o17=>NULL()
     real, dimension(:,:,:,:), pointer :: co2spnb=>NULL()
     real, dimension(:,:),     pointer :: a1=>NULL(),    &
                                          a2=>NULL()
end type gas_tf_type

!------------------------------------------------------------------

public longwave_control_type 

type longwave_control_type
    character(len=16) :: lw_form
    character(len=16) :: continuum_form
    character(len=16) :: linecatalog_form
    logical           :: do_cfc
    logical           :: do_lwaerosol
    logical           :: do_ch4
    logical           :: do_n2o
    logical           :: do_ch4lbltmpint
    logical           :: do_n2olbltmpint
    logical           :: do_co2
    logical           :: do_lwcldemiss
    logical           :: do_h2o
    logical           :: do_o3 
    logical           :: do_cfc_iz
    logical           :: do_lwaerosol_iz
    logical           :: do_ch4_iz
    logical           :: do_n2o_iz
    logical           :: do_ch4lbltmpint_iz
    logical           :: do_n2olbltmpint_iz
    logical           :: do_co2_iz
    logical           :: do_lwcldemiss_iz
    logical           :: do_h2o_iz
    logical           :: do_o3_iz 
end type longwave_control_type

!---------------------------------------------------------------------

public longwave_parameter_type

type longwave_parameter_type
     integer   :: offset
     integer   :: NBTRG
     integer   :: NBTRGE
     integer   :: NBLY
     integer   :: n_lwaerosol_bands
     real      :: lw_band_resolution
     logical   :: offset_iz
     logical   :: NBTRG_iz
     logical   :: NBTRGE_iz
     logical   :: NBLY_iz
     logical   :: n_lwaerosol_bands_iz
     logical   :: lw_band_resolution_iz
end type longwave_parameter_type

!--------------------------------------------------------------------

public longwave_tables1_type

!    vae
!    td
!    md
!    cd

type longwave_tables1_type
    real, dimension(:,:), pointer  ::  vae=>NULL(),   &
                                       td=>NULL(), &
                                       md=>NULL(), &
                                       cd=>NULL()
end type longwave_tables1_type

!--------------------------------------------------------------------

public longwave_tables2_type

!    vae
!    td
!    md
!    cd

type longwave_tables2_type
    real, dimension(:,:,:), pointer  ::  vae=>NULL(),  &
                                         td=>NULL(),  &
                                         md=>NULL(),   &
                                         cd=>NULL()
end type longwave_tables2_type

!---------------------------------------------------------------------

public longwave_tables3_type

!    vae
!    td

type longwave_tables3_type
     real,  dimension(:,:), pointer    ::  vae=>NULL(),   &
                                           td=>NULL()          
end type longwave_tables3_type

!---------------------------------------------------------------------

public lw_clouds_type

!    taucld_rndlw
!    taucld_mxolw
!    taunbl_mxolw

type lw_clouds_type
     real, dimension(:,:,:,:),   pointer :: taucld_rndlw=>NULL(), &
                                            taucld_mxolw=>NULL(), &
                                            taunbl_mxolw=>NULL()
end type lw_clouds_type

!------------------------------------------------------------------

public lw_diagnostics_type

!    flx1e1
!    gxcts
!    flx1e1f
!    excts
!    fctsg
!    fluxn
!    fluxncf
!    exctsn
!    cts_out
!    cts_outcf

type lw_diagnostics_type
     real, dimension(:,:),   pointer   :: flx1e1=>NULL(),  &
                                          gxcts=>NULL()
     real, dimension(:,:,:), pointer   :: flx1e1f=>NULL(),  &
                                          excts=>NULL(),&
                                          fctsg=>NULL()
     real, dimension(:,:,:,:), pointer :: fluxn=>NULL(),   &
                                          fluxncf=>NULL(),   &
                                          exctsn=>NULL(),  &
                                          cts_out=>NULL(), &
                                          cts_outcf=>NULL()
end type lw_diagnostics_type

!-------------------------------------------------------------------

public lw_output_type

!    heatra
!    flxnet
!    heatracf
!    flxnetcf
!    netlw_special
!    netlw_special_clr

type lw_output_type
     real, dimension(:,:,:), pointer :: heatra=>NULL(), &
                                        flxnet=>NULL(),  &
                                        heatracf=>NULL(), &
                                        flxnetcf=>NULL()
     real, dimension(:,:,:), pointer   :: netlw_special=>NULL(), &
                                          netlw_special_clr=>NULL(), &
                                          bdy_flx=>NULL(), &
                                          bdy_flx_clr=>NULL()
end type lw_output_type

!------------------------------------------------------------------

public lw_table_type

!    bdlocm
!    bdhicm
!    bandlo
!    bandhi
!    iband

type lw_table_type
     real, dimension(:),    pointer :: bdlocm=>NULL(),   &
                                       bdhicm=>NULL(),  &
                                       bandlo=>NULL(),  &
                                       bandhi=>NULL()
     integer, dimension(:), pointer :: iband=>NULL()
end type lw_table_type

!------------------------------------------------------------------

public microphysics_type
 
!    conc_ice
!    conc_drop
!    size_ice
!    size_drop
!    size_snow
!    conc_snow
!    size_rain
!    conc_rain
!    cldamt
!    stoch_conc_ice
!    stoch_conc_drop
!    stoch_size_ice
!    stoch_size_drop
!    stoch_cldamt
!    stoch_cloud_type
!    lw_stoch_conc_ice
!    lw_stoch_conc_drop
!    lw_stoch_size_ice
!    lw_stoch_size_drop
!    lw_stoch_cldamt
!    sw_stoch_conc_ice
!    sw_stoch_conc_drop
!    sw_stoch_size_ice
!    sw_stoch_size_drop
!    sw_stoch_cldamt

type microphysics_type
   real, dimension(:,:,:), pointer :: conc_ice=>NULL(),   &
                                      conc_drop=>NULL(),      &
                                      size_ice=>NULL(),   &
                                      size_drop=>NULL(),     &
                                      size_snow=>NULL(),   &
                                      conc_snow=>NULL(),     &
                                      size_rain=>NULL(),     &
                                      conc_rain=>NULL(),   &
                                      cldamt=>NULL(),      &
                                      droplet_number=>NULL(), &
                                      ice_number=>NULL()
real, dimension(:,:,:,:), pointer :: stoch_conc_ice=>NULL(),   &
                                     stoch_conc_drop=>NULL(),  &
                                     stoch_size_ice=>NULL(),   &
                                     stoch_size_drop=>NULL(),  &
                                     stoch_cldamt=>NULL(),     &
                                     stoch_droplet_number=>NULL(), &
                                     stoch_ice_number=>NULL()
integer, dimension(:,:,:,:), pointer ::  stoch_cloud_type=>NULL()
!
! In practice, we allocate a single set of columns for the stochastic
!   clouds, then point to sections of the larger array with the 
!   lw_ and sw_type. 
!   I.e. lw_stoch_conc_ice => stoch_conc_ice(:, :, :, 1:numLwBands)
!
real, dimension(:,:,:,:), pointer :: lw_stoch_conc_ice=>NULL(),   &
                                     lw_stoch_conc_drop=>NULL(),  &
                                     lw_stoch_size_ice=>NULL(),   &
                                     lw_stoch_size_drop=>NULL(),  &
                                     lw_stoch_cldamt=>NULL(),     &
                                     lw_stoch_droplet_number=>NULL(), &
                                     lw_stoch_ice_number=>NULL(), &
                                     sw_stoch_conc_ice=>NULL(),   &
                                     sw_stoch_conc_drop=>NULL(),  &
                                     sw_stoch_size_ice=>NULL(),   &
                                     sw_stoch_size_drop=>NULL(),  &
                                     sw_stoch_cldamt=>NULL(),     &
                                     sw_stoch_droplet_number=>NULL(), &
                                     sw_stoch_ice_number=>NULL()
end type microphysics_type

!-------------------------------------------------------------------

public microrad_properties_type
 
!    cldext
!    cldsct
!    cldasymm
!    abscoeff

type microrad_properties_type
   real, dimension(:,:,:,:), pointer :: cldext=>NULL(),  &
                                        cldsct=>NULL(), &
                                        cldasymm=>NULL(),    &
                                        abscoeff=>NULL()
end type microrad_properties_type

!--------------------------------------------------------------------

public optical_path_type

!    empl1f
!    vrpfh2o
!    xch2obd
!    tphfh2o
!    avephif
!    totaerooptdep
!    empl1
!    empl2
!    var1
!    var2
!    emx1f
!    emx2f
!    totvo2
!    avephi
!    totch2obdwd
!    xch2obdwd
!    totphi
!    cntval
!    toto3
!    tphio3
!    var3
!    var4
!    wk
!    rh2os
!    rfrgn
!    tfac
!    totaerooptdep15
!    totf11
!    totf12
!    totf113
!    totf22
!    emx1
!    emx2
!    csfah2o
!    aerooptdep_KE_15

type optical_path_type
     real, dimension (:,:,:,:), pointer :: empl1f=>NULL(),  &
                                           empl2f=>NULL(),  &
                                           vrpfh2o=>NULL(), &
                                           xch2obd=>NULL(),  &
                                           tphfh2o=>NULL(), &
                                           avephif=>NULL(), &
                                           totaerooptdep=>NULL()
     real, dimension (:,:,:),   pointer :: empl1=>NULL(), &
                                           empl2=>NULL(),  &
                                           var1=>NULL(), &
                                           var2=>NULL(), &
                                           emx1f=>NULL(),   &
                                           emx2f=>NULL(),   &
                                           totvo2=>NULL(),  &
                                           avephi=>NULL(),&
                                           totch2obdwd=>NULL(), &
                                           xch2obdwd=>NULL(), &
                                           totphi=>NULL(),   &
                                           cntval=>NULL(), &
                                           toto3=>NULL(),   &
                                           tphio3=>NULL(),  &
                                           var3=>NULL(),  &
                                           var4=>NULL(),        &
                                           wk=>NULL(),         &
                                           rh2os=>NULL(),  &
                                           rfrgn=>NULL(),  &
                                           tfac=>NULL(), &
                                           totaerooptdep_15=>NULL(), &
                                           totf11=>NULL(),   &
                                           totf12=>NULL(),  &
                                           totf113=>NULL(),   &
                                           totf22=>NULL()
      real, dimension (:,:), pointer    :: emx1=>NULL(),  &
                                           emx2=>NULL(),  &
                                           csfah2o=>NULL(), &
                                           aerooptdep_KE_15=>NULL()
end type optical_path_type

!------------------------------------------------------------------

public radiation_control_type

type radiation_control_type
    logical  :: do_totcld_forcing
    logical  :: do_aerosol
    integer  :: rad_time_step
    integer  :: lw_rad_time_step
    integer  :: sw_rad_time_step
    logical  :: do_sw_rad
    logical  :: do_lw_rad
    logical  :: hires_coszen
    integer  :: nzens
    real     :: co2_tf_calc_intrvl
    logical  :: use_current_co2_for_tf
    logical  :: calc_co2_tfs_on_first_step
    logical  :: calc_co2_tfs_monthly
    real     :: co2_tf_time_displacement
    real     :: ch4_tf_calc_intrvl
    logical  :: use_current_ch4_for_tf
    logical  :: calc_ch4_tfs_on_first_step
    logical  :: calc_ch4_tfs_monthly
    real     :: ch4_tf_time_displacement
    real     :: n2o_tf_calc_intrvl
    logical  :: use_current_n2o_for_tf
    logical  :: calc_n2o_tfs_on_first_step
    logical  :: calc_n2o_tfs_monthly
    real     :: n2o_tf_time_displacement
    integer  :: mx_spec_levs
    logical  :: time_varying_solar_constant
    logical  :: volcanic_sw_aerosols
    logical  :: volcanic_lw_aerosols
    logical  :: using_solar_timeseries_data
    logical  :: do_lwaerosol_forcing
    logical  :: do_swaerosol_forcing
    integer  :: indx_swaf
    integer  :: indx_lwaf
    logical  :: using_im_bcsul
    logical  :: do_totcld_forcing_iz
    logical  :: do_aerosol_iz
    logical  :: rad_time_step_iz
    logical  :: lw_rad_time_step_iz
    logical  :: sw_rad_time_step_iz
    logical  :: do_sw_rad_iz
    logical  :: do_lw_rad_iz
    logical  :: hires_coszen_iz
    logical  :: nzens_iz  
    logical  :: co2_tf_calc_intrvl_iz
    logical  :: use_current_co2_for_tf_iz
    logical  :: calc_co2_tfs_on_first_step_iz
    logical  :: calc_co2_tfs_monthly_iz
    logical  :: ch4_tf_calc_intrvl_iz
    logical  :: use_current_ch4_for_tf_iz
    logical  :: calc_ch4_tfs_on_first_step_iz
    logical  :: calc_ch4_tfs_monthly_iz
    logical  :: n2o_tf_calc_intrvl_iz
    logical  :: use_current_n2o_for_tf_iz
    logical  :: calc_n2o_tfs_on_first_step_iz
    logical  :: calc_n2o_tfs_monthly_iz
    logical  :: co2_tf_time_displacement_iz
    logical  :: ch4_tf_time_displacement_iz
    logical  :: n2o_tf_time_displacement_iz
    logical  :: mx_spec_levs_iz
    logical  :: time_varying_solar_constant_iz
    logical  :: volcanic_sw_aerosols_iz
    logical  :: volcanic_lw_aerosols_iz
    logical  :: using_solar_timeseries_data_iz
    logical  :: do_lwaerosol_forcing_iz
    logical  :: do_swaerosol_forcing_iz
    logical  :: indx_swaf_iz
    logical  :: indx_lwaf_iz
    logical  :: using_im_bcsul_iz
end type radiation_control_type

!------------------------------------------------------------------

public   radiative_gases_type
 
!    qo3
!    rrvch4
!    rrvn2o
!    rrvco2
!    rrvf11
!    rrvf12
!    rrvf113
!    rrvf22
!    rf11air
!    rf12air
!    rf113air
!    rf22air
!    time_varying_co2
!    time_varying_f11
!    time_varying_f12
!    time_varying_f113
!    time_varying_f22
!    time_varying_ch4
!    time_varying_n2o

type radiative_gases_type
     real, dimension(:,:,:), pointer :: qo3=>NULL()
     real                            :: rrvch4, rrvn2o, rrvco2,    &
                                        rrvf11, rrvf12, rrvf113,  &
                                        rrvf22, rf11air, rf12air,  &
                                        rf113air, rf22air, &
                                        co2_for_last_tf_calc,  &
                                        co2_tf_offset, &
                                        co2_for_next_tf_calc, &
                                        ch4_for_last_tf_calc,  &
                                        ch4_tf_offset, &
                                        ch4_for_next_tf_calc, &
                                        n2o_for_last_tf_calc,  &
                                        n2o_tf_offset, &
                                        n2o_for_next_tf_calc
     logical                         :: time_varying_co2,  &
                                        time_varying_f11, &
                                        time_varying_f12,  &
                                        time_varying_f113, &
                                        time_varying_f22,  &
                                        time_varying_ch4, &
                                        time_varying_n2o, &
                                        use_model_supplied_co2
     type(time_type)                 :: Co2_time, Ch4_time, N2o_time
end type radiative_gases_type

!------------------------------------------------------------------

public rad_output_type

!    tdt_rad
!    tdt_rad_clr
!    tdtsw
!    tdtsw_clr
!    tdtlw
!    flux_sw_surf
!    flux_lw_surf
!    coszen_angle

type rad_output_type
     real, dimension(:,:,:,:), pointer :: tdt_rad=>NULL(),  &
                                        ufsw=>NULL(),  &
                                        dfsw=>NULL(),  &
                                        tdtsw=>NULL()  
     real, dimension(:,:,:,:), pointer :: tdt_rad_clr=>NULL(), &
                                        ufsw_clr=>NULL(),  &
                                        dfsw_clr=>NULL(),  &
                                        tdtsw_clr=>NULL()
                                        
     real, dimension(:,:,:), pointer :: tdtlw=>NULL()
     real, dimension(:,:,:), pointer :: flxnet=>NULL()
     real, dimension(:,:,:), pointer :: flxnetcf=>NULL()
     real, dimension(:,:,:), pointer :: tdtlw_clr=>NULL()
     real, dimension(:,:,:),   pointer :: flux_sw_surf=>NULL(), &
                                        flux_sw_surf_refl_dir=>NULL(), &
                                        flux_sw_surf_dir=>NULL(), &
                                        flux_sw_surf_dif=>NULL(), &
                                        flux_sw_down_vis_dir=>NULL(), &
                                        flux_sw_down_vis_dif=>NULL(), &
                                       flux_sw_down_total_dir=>NULL(), &
                                       flux_sw_down_total_dif=>NULL(), &
                                        flux_sw_vis=>NULL(), &
                                        flux_sw_vis_dir=>NULL(), &
                                        flux_sw_refl_vis_dir=>NULL(), &
                                        flux_sw_vis_dif=>NULL()
     real, dimension(:,:,:),   pointer :: flux_sw_down_vis_clr=>NULL(), &
                                  flux_sw_down_total_dir_clr=>NULL(), &
                                  flux_sw_down_total_dif_clr=>NULL()
     real, dimension(:,:),   pointer :: flux_lw_surf=>NULL(), &
                                        coszen_angle=>NULL()
end type rad_output_type

!-------------------------------------------------------------------

public shortwave_control_type

type shortwave_control_type
    logical  :: do_lhsw
    logical  :: do_esfsw
    logical  :: do_swaerosol
    logical  :: do_diurnal
    logical  :: do_annual
    logical  :: do_daily_mean
    logical  :: do_cmip_diagnostics
    real     :: solar_constant
    logical  :: do_lhsw_iz
    logical  :: do_esfsw_iz
    logical  :: do_swaerosol_iz
    logical  :: do_diurnal_iz
    logical  :: do_annual_iz
    logical  :: do_daily_mean_iz
    logical  :: do_cmip_diagnostics_iz
end type shortwave_control_type

!---------------------------------------------------------------------

public solar_spectrum_type

!    solarfluxtoa      highly-resolved solar flux at toa in 
!                      Sw_control%tot_wvnums 
!                      bands [         ]
!    solflxband_lean   a time series of toa solar flux in each
!                      parameterization band
!    solflxband_lean_ann_1882   1882 average toa solar flux in each
!                               parameterization band
!    solflxband_lean_ann_2000   2000 average toa solar flux in each
!                               parameterization band
!    solflxband        toa solar flux in each parameterization band
!                      [         ]
!    endwvnbands       highest wave number in each of the solar
!                      spectral parameterization bands [ cm (-1) ]
!    tot_wvnums
!    nbands
!    nfrqpts
!    nstreams
!    nh2obands
!    visible_band_indx
!    one_micron_indx
!    eight70_band_indx
!    visible_band_indx_iz
!    one_micron_indx_iz
!    eight70_band_indx_iz

type solar_spectrum_type
    real, dimension(:),    pointer   :: solarfluxtoa=>null()
    real, dimension(:),    pointer   :: solflxband=>NULL()
    real, dimension(:),    pointer   :: solflxbandref=>NULL()
    real, dimension(:),    pointer   :: solflxband_lean_ann_1882=>NULL()
    real, dimension(:),    pointer   :: solflxband_lean_ann_2000=>NULL()
    real, dimension(:,:,:),pointer   :: solflxband_lean=>NULL()
    integer, dimension(:), pointer   :: endwvnbands=>NULL()
    integer         :: tot_wvnums
    integer         :: nbands
    integer         :: nfrqpts
    integer         :: nstreams
    integer         :: nh2obands
    integer         :: visible_band_indx, one_micron_indx
    integer         :: eight70_band_indx
    logical         :: visible_band_indx_iz, one_micron_indx_iz
    logical         :: eight70_band_indx_iz
    integer         :: w340_band_indx, w380_band_indx,  &
                       w440_band_indx, w670_band_indx
    logical         :: w340_band_iz, w380_band_iz, &
                       w440_band_iz, w670_band_iz
end type solar_spectrum_type

!---------------------------------------------------------------------

public surface_type

!    asfc
!    land

type surface_type
    real, dimension(:,:),   pointer ::  asfc=>NULL(),   &
                                        land=>NULL(),  &
                                        asfc_vis_dir=>NULL(), &
                                        asfc_nir_dir=>NULL(), &
                                        asfc_vis_dif=>NULL(), &
                                        asfc_nir_dif=>NULL()
end type surface_type
 
!-------------------------------------------------------------------

public sw_output_type

!    dfsw
!    ufsw
!    fsw
!    hsw
!    dfswcf
!    ufswcf
!    fswcf
!    hswcf
!    swdn_special
!    swup_special
!    swdn_special_clr
!    swup_special_clr

type sw_output_type
     real, dimension(:,:,:,:), pointer :: dfsw=>NULL(),   &
                                        ufsw=>NULL(),  &
                                        fsw=>NULL(),   &
                                        hsw=>NULL()   
     real, dimension(:,:,:,:), pointer :: dfswcf=>NULL(),   &
                                        ufswcf=>NULL(),&
                                        fswcf=>NULL(),  &
                                        hswcf=>NULL()
      real, dimension(:,:,:), pointer :: dfsw_vis_sfc=>NULL(),   &
                                       ufsw_vis_sfc=>NULL()
      real, dimension(:,:,:), pointer :: dfsw_dir_sfc=>NULL()
      real, dimension(:,:,:), pointer :: ufsw_dir_sfc=>NULL()
      real, dimension(:,:,:), pointer :: dfsw_dir_sfc_clr=>NULL()
      real, dimension(:,:,:), pointer :: dfsw_dif_sfc=>NULL(),   &
                                       ufsw_dif_sfc=>NULL()
      real, dimension(:,:,:), pointer :: dfsw_dif_sfc_clr=>NULL()
      real, dimension(:,:,:), pointer :: dfsw_vis_sfc_dir=>NULL()
      real, dimension(:,:,:), pointer :: ufsw_vis_sfc_dir=>NULL()
      real, dimension(:,:,:), pointer :: dfsw_vis_sfc_clr=>NULL()
      real, dimension(:,:,:), pointer :: dfsw_vis_sfc_dif=>NULL(),   &
                                       ufsw_vis_sfc_dif=>NULL()
      real, dimension(:,:,:,:), pointer   ::  bdy_flx=>NULL()
      real, dimension(:,:,:,:), pointer   ::  bdy_flx_clr=>NULL()
      real, dimension(:,:,:,:), pointer   ::                       &
                                        swup_special=>NULL(), &
                                        swup_special_clr=>NULL()
     real, dimension(:,:,:,:), pointer   :: swdn_special=>NULL(), &
                                          swdn_special_clr=>NULL()
end type sw_output_type

!-------------------------------------------------------------------

public table_axis_type

type table_axis_type
  integer :: first_col
  real    :: min_val
  real    :: max_val
  real    :: tab_inc
end type table_axis_type

!---------------------------------------------------------------------

!private      &


!--------------------------------------------------------------------
!-------- namelist  ---------

integer            ::  dummy = 0


namelist / rad_utilities_nml /   &
                                dummy


!---------------------------------------------------------------------
!------- public data ------


type (longwave_control_type),  public   ::    &
     Lw_control = longwave_control_type( '    ', '    ', '    ', &
                                         .false., .false., .false.,  &
                                         .false., .false., .false.,  &
                                         .false., .false.,  &
                                         .false., .false.,  &
                                         .false., .false., .false.,  &
                                         .false., .false.,  &
                                         .false., .false.,  &
                                         .false., .false., .false.   )

type (shortwave_control_type), public   ::  &
    Sw_control = shortwave_control_type( .false., .false., .false. , &
                                         .false., .false., .false., &
                                         .false., &
                                         0.0, &
                                         .false., .false., .false. , &
                                         .false., &
                                         .false., .false., .false.)

type (radiation_control_type), public   ::  &
   Rad_control = radiation_control_type( .false., .false., 0, 0, 0, &
                                         .false., .false., &
                                         .false., 1, &
                                         0.0,  .true.,  .false.,&
                                         .false.,  0.0, &
                                         0.0, .true., .false.,  &
                                         .false.,  0.0,  &
                                         0.0, .true., .false.,   &
                                         .false., 0.0, &
                                         0, .false., .false.,   &
                                         .false., .false.,&
                                         .false., .false.,      &
                                         0, 0, .false., &
! _iz variables:
                                         .false., .false., .false., &
                                         .false., .false., .true., &
                                         .true.,  &
                                         .false., .false., &
                                         .false., .false., &
                                         .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false., .false., &
                                         .false., .false., &
                                         .false., .false., &
                                         .false.,          &
                                         .false., .false., .false.,  &
                                         .false., .false.,   &
                                         .false., .false., &
                                         .false., .false., .false.)

type (cloudrad_control_type), public    ::   &
 Cldrad_control = cloudrad_control_type( .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false.,                   &
                                         0,0,0,0,0,0 , &
                                         .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false., .false., .false., &
                                         .false.   )


type (longwave_parameter_type), public  ::   &
Lw_parameters = longwave_parameter_type( 0, 0, 0, 0, 0, 10.0, &
                                         .false., .false., .false.,  &
                                         .false., .false., .true.)

type (table_axis_type),        public   ::    &
               temp_1 = table_axis_type( 1, 100.0, 370.0, 10.0), &
               mass_1 = table_axis_type( 1, -16.0,   1.9,  0.1)


!---------------------------------------------------------------------
!------- private data ------


logical :: module_is_initialized=.false.   ! module is initialized ?


!---------------------------------------------------------------------
!---------------------------------------------------------------------



                           contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

! <SUBROUTINE NAME="rad_utilities_init">
!  <OVERVIEW>
!   Subroutine to initialize radiation utility package.
!  </OVERVIEW>
!  <DESCRIPTION>
!   This subroutine reads the input namelist file and initializes 
!   rad_utilities_nml. It then writes out this namelist to the output
!   logfile. It also sets up the radiation calculation environment
!   and the initialization flag variable.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call rad_utilities_init
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine rad_utilities_init

!---------------------------------------------------------------------
!    rad_utilities_init is the constructor for rad_uti;lities_mod.
!---------------------------------------------------------------------

!------------------------------------------------------------------
!  local variables:

      integer    ::  unit, ierr, io, logunit

!---------------------------------------------------------------------
!  local variables:
!
!        unit            io unit number used for namelist file
!        ierr            error code
!        io              error status returned from io operation
!                                
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return
 
!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init

!-----------------------------------------------------------------------
!    read namelist.
!-----------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=rad_utilities_nml, iostat=io)
      ierr = check_nml_error(io,'rad_utilities_nml')
#else   
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=rad_utilities_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'rad_utilities_nml')
        end do
10      call close_file (unit)
      endif
#endif
 
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                        write (logunit, nml=rad_utilities_nml)

!-------------------------------------------------------------------
!    mark the module as initialized.
!-------------------------------------------------------------------
      module_is_initialized = .true.

!------------------------------------------------------------------

end subroutine rad_utilities_init


!#####################################################################
!
! <SUBROUTINE NAME="check_derived_types">
!  <OVERVIEW>
!   Subroutine to verify that all logical elements of derived-type
!   variables were initialized during the initialization phase.
!  </OVERVIEW>
!  <DESCRIPTION>
!   This subroutine checks that all of the variable names ending in 
!   "_iz" in its public derived-type module variables are set to .true..
!   If additional types or variables within current public types are
!   added, it is necessary to also add the corresponding "_iz" variable,
!   initialized in this module to .false., and then set to .true. when 
!   the variable is initialized, and add a check in this routine to 
!   verify that initialization.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call check_derived_types
!  </TEMPLATE>
! </SUBROUTINE>
!

subroutine check_derived_types 

!--------------------------------------------------------------------
!    check_derived_types is called at the end of radiation package
!    initialization to verify that all logical components of public
!    derived-type module variables have been initialized.
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    check the components of Lw_control.
!--------------------------------------------------------------------
      if (Lw_control%do_cfc_iz .and. &
          Lw_control%do_lwaerosol_iz .and. &
          Lw_control%do_ch4_iz .and. &
          Lw_control%do_n2o_iz .and. &
          Lw_control%do_ch4lbltmpint_iz .and. &
          Lw_control%do_n2olbltmpint_iz .and. &
          Lw_control%do_co2_iz .and. &
          Lw_control%do_h2o_iz .and. &
          Lw_control%do_o3_iz .and. &
          Lw_control%do_lwcldemiss_iz ) then  
      else
        call error_mesg ('rad_utilities_mod', &
             ' at least one component of Lw_control has not been '//&
                                     'initialized', FATAL)
      endif

!---------------------------------------------------------------------
!    check the components of Sw_control.
!--------------------------------------------------------------------
      if (Sw_control%do_lhsw_iz .and. &
          Sw_control%do_esfsw_iz .and. &
          Sw_control%do_swaerosol_iz .and. &
          Sw_control%do_diurnal_iz .and. &
          Sw_control%do_annual_iz .and. &
          Sw_control%do_cmip_diagnostics_iz .and. &
          Sw_control%do_daily_mean_iz ) then  
      else
        call error_mesg ('rad_utilities_mod', &
             ' at least one component of Sw_control has not been '//&
                                     'initialized', FATAL)
      endif

!---------------------------------------------------------------------
!    check the components of Rad_control.
!--------------------------------------------------------------------
      if (Rad_control%do_totcld_forcing_iz .and. &
          Rad_control%do_lwaerosol_forcing_iz .and.  &
          Rad_control%do_swaerosol_forcing_iz .and.  &
          Rad_control%indx_lwaf_iz .and.   &
          Rad_control%indx_swaf_iz .and.   &
          Rad_control%using_im_bcsul_iz .and. &
          Rad_control%volcanic_sw_aerosols_iz .and. &
          Rad_control%volcanic_lw_aerosols_iz .and. &
          Rad_control%time_varying_solar_constant_iz .and. &
          Rad_control%using_solar_timeseries_data_iz .and. &
          Rad_control%do_aerosol_iz .and.     &
          Rad_control%mx_spec_levs_iz .and.   &
          Rad_control%use_current_co2_for_tf_iz .and. &
          Rad_control%co2_tf_calc_intrvl_iz .and. &
          Rad_control%calc_co2_tfs_on_first_step_iz .and. &
          Rad_control%calc_co2_tfs_monthly_iz .and. &
          Rad_control%co2_tf_time_displacement_iz .and. &
          Rad_control%use_current_ch4_for_tf_iz .and. &
          Rad_control%ch4_tf_calc_intrvl_iz .and. &
          Rad_control%calc_ch4_tfs_on_first_step_iz .and. &
          Rad_control%calc_ch4_tfs_monthly_iz .and. &
          Rad_control%ch4_tf_time_displacement_iz .and. &
          Rad_control%use_current_n2o_for_tf_iz .and. &
          Rad_control%n2o_tf_calc_intrvl_iz .and. &
          Rad_control%calc_n2o_tfs_on_first_step_iz .and. &
          Rad_control%calc_n2o_tfs_monthly_iz .and. &
          Rad_control%n2o_tf_time_displacement_iz .and. &
          Rad_control%do_lw_rad_iz .and. &
          Rad_control%do_sw_rad_iz .and. &
          Rad_control%nzens_iz .and. &
          Rad_control%hires_coszen_iz .and. &
          Rad_control%lw_rad_time_step_iz .and.  &
          Rad_control%sw_rad_time_step_iz .and.  &
          Rad_control%rad_time_step_iz ) then
      else
        call error_mesg ('rad_utilities_mod', &
          ' at least one component of Rad_control has not been '//&
                                     'initialized', FATAL)
      endif

!---------------------------------------------------------------------
!    check the components of Cldrad_control.
!--------------------------------------------------------------------
      if (Cldrad_control%do_pred_cld_microphys_iz .and. &
          Cldrad_control%do_presc_cld_microphys_iz .and. &
          Cldrad_control%do_bulk_microphys_iz .and. &
          Cldrad_control%do_sw_micro_iz .and. &
          Cldrad_control%do_lw_micro_iz .and. &
          Cldrad_control%do_strat_clouds_iz .and. &
          Cldrad_control%do_rh_clouds_iz .and. &
          Cldrad_control%do_zonal_clouds_iz .and. &
          Cldrad_control%do_mgroup_prescribed_iz .and. &
          Cldrad_control%do_obs_clouds_iz .and. &
          Cldrad_control%do_no_clouds_iz .and. &
          Cldrad_control%do_diag_clouds_iz .and. &
          Cldrad_control%do_specified_clouds_iz .and. &
          Cldrad_control%do_specified_strat_clouds_iz .and. &
          Cldrad_control%do_donner_deep_clouds_iz .and. &
          Cldrad_control%do_uw_clouds_iz .and. &
          Cldrad_control%do_zetac_clouds_iz .and. &
          Cldrad_control%do_stochastic_clouds_iz .and. &
          Cldrad_control%use_temp_for_seed_iz .and. &
          Cldrad_control%do_random_overlap_iz .and. &
          Cldrad_control%do_ica_calcs_iz .and. &
          Cldrad_control%using_fu2007_iz .and.  &
          Cldrad_control%do_liq_num_iz .and.  &
          Cldrad_control%do_ice_num_iz .and.  &
          Cldrad_control%do_max_random_overlap_iz ) then     
      else
        call error_mesg ('rad_utilities_mod', &
          ' at least one component of Cldrad_control has not been '//&
                                     'initialized', FATAL)
      endif

!---------------------------------------------------------------------
!    check the components of Lw_parameters.
!--------------------------------------------------------------------
      if (Lw_parameters%offset_iz .and. &
          Lw_parameters%nbtrg_iz .and. &
          Lw_parameters%nbtrge_iz .and. &
          Lw_parameters%nbly_iz .and. &
          Lw_parameters%n_lwaerosol_bands_iz .and. &
          Lw_parameters%lw_band_resolution_iz) then
      else
        call error_mesg ('rad_utilities_mod', &
          ' at least one component of Lw_parameters has not been '//&
                                     'initialized', FATAL)
      endif

!---------------------------------------------------------------------
!    check for consistency between band structure and cfc and lwaerosol
!    effects.
!---------------------------------------------------------------------
      if (Lw_parameters%nbtrge == 0) then
        if (Lw_control%do_cfc .or. Lw_control%do_lwaerosol) then
          call error_mesg ('rad_utilities_mod', &
             'when do_cfc and / or do_lwaerosol is .true., must set &
              &sealw99_nml variable no_h2o_bands_1200_1400 > 0 ', FATAL)
        endif
      endif
!--------------------------------------------------------------------

!--------------------------------------------------------------------


end subroutine check_derived_types 



!####################################################################
! <SUBROUTINE NAME="locate_in_table">
!  <OVERVIEW>
!   Subroutine to locate index and residual value from an array provided 
!   with array and axis information
!  </OVERVIEW>
!  <DESCRIPTION>
!     given array x and an arithmetic sequence of table column headings
!     tabxmin, tabxmin+tabdeltax, ..., corresponding to column ixlow, 
!     ixlow+1, ..., ixupp, Locate returns the array ix is column 
!     indices and the array dx of residuals.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call locate_in_table(table_axis, x, dx, ix, k_min, k_max)
!  </TEMPLATE>
!  <IN NAME="table_axis" TYPE="table_axis_type">
!   table_axis contains the axis information such as, min, increment,
!   and first column values.
!  </IN>
!  <IN NAME="x" TYPE="real">
!   array from which data is to be searched
!  </IN>
!  <OUT NAME="dx" TYPE="real">
!   residual between x and x(ix+first_column)
!  </OUT>
!  <OUT NAME="ix" TYPE="integer">
!   index values of the searched domain in the array
!  </OUT>
!  <IN NAME="k_min" TYPE="integer">
!   minimum k value of the search domain 
!  </IN>
!  <IN NAME="k_max" TYPE="integer">
!   maximum k value of the search domain
!  </IN>
! </SUBROUTINE>
subroutine locate_in_table (table_axis, x, dx, ix, k_min, k_max) 

!---------------------------------------------------------------------
!    given array x and an arithmetic sequence of table column headings
!    tabxmin, tabxmin+tabdeltax, ..., corresponding to column ixlow, 
!    ixlow+1, ..., ixupp, locate_in_table returns the array ix of
!    column indices and the array dx of residuals.
!    author: c. h. goldberg
!    revised: 1/1/93
!    certified:  radiation version 1.0
!----------------------------------------------------------------------

type(table_axis_type),     intent(in)  :: table_axis
real,    dimension(:,:,:), intent(in)  :: x
integer,                   intent(in)  :: k_min, k_max
real,    dimension(:,:,:), intent(out) :: dx
integer, dimension(:,:,:), intent(out) :: ix

!--------------------------------------------------------------------
!  intent(in) variables:
!
!    table_axis
!    x
!    k_min
!    k_max
!
!  intent(out) variables:
!
!    dx
!    ix
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables:

      real, dimension (size(x,1), size(x,2), size(x,3))  ::  fx
      integer     ::  k

!---------------------------------------------------------------------
!  local variables:
!
!     fx
!     table_min
!     table_inc
!     k
!     table_col
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('rad_utilities_mod',   &
               'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      do k=k_min,k_max
        fx (:,:,k) = AINT((x(:,:,k) - table_axis%min_val )/  &
                     table_axis%tab_inc)
        ix (:,:,k) = INT(fx(:,:,k)) + table_axis%first_col
        dx (:,:,k) = x(:,:,k) - fx(:,:,k)*table_axis%tab_inc - &
                     table_axis%min_val
      end do
      
!---------------------------------------------------------------------


end subroutine locate_in_table



!####################################################################
! <SUBROUTINE NAME="looktab_type1">
!  <OVERVIEW>
!   Subroutine to calculate answer from input differentials.
!  </OVERVIEW>
!  <DESCRIPTION>
!   given arrays ix(:,:,:) and iy(:,:,:) of integral subscripts and
!     arrays dx(:,:,:) and dy(:,:,:) of differences from x(:,:,:) and
!     y(:,:,:), calculate answer(:,:,:) = f(x(:,:,:), y(:,:,:))
!     from four tables of values, f, df/dx, df/dy, and d2f/dxdy.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call looktab_type1 (tab, ix, iy, dx, dy, answer, k_min, k_max)
!  </TEMPLATE>
!  <IN NAME="tab" TYPE="longwave_tables1_type">
!   The data array that contains function values and differentials
!  </IN>
!  <IN NAME="ix" TYPE="integer">
!   x subscript of input data array
!  </IN>
!  <IN NAME="iy" TYPE="integer">
!   y subscript of input data array
!  </IN>
!  <IN NAME="dx" TYPE="real">
!   x step in the x subscript space
!  </IN>
!  <IN NAME="dy" TYPE="real">
!   y step in the y subscript space
!  </IN>
!  <OUT NAME="answer" TYPE="real">
!   the answer to be calculated
!  </OUT>
!  <IN NAME="k_min" TYPE="integer">
!   the minimum k value of the domain
!  </IN>
!  <IN NAME="k_max" TYPE="integer">
!   the maximum k value of the domain
!  </IN>
! </SUBROUTINE>
!
subroutine looktab_type1 (tab, ix, iy, dx, dy, answer, k_min, k_max)   

!----------------------------------------------------------------------
!    given arrays ix(:,:,:) and iy(:,:,:) of integral subscripts and
!    arrays dx(:,:,:) and dy(:,:,:) of differences from x(:,:,:) and
!    y(:,:,:), calculate answer(:,:,:) = f(x(:,:,:), y(:,:,:))
!    from four tables of values, f, df/dx, df/dy, and d2f/dxdy.
!    author: c. h. goldberg
!    revised: 1/1/93
!    certified:  radiation version 1.0
!--------------------------------------------------------------------

type(longwave_tables1_type), intent(in)  :: tab
integer,dimension(:,:,:),    intent(in)  :: ix, iy
real,   dimension(:,:,:),    intent(in)  :: dx, dy   
real,   dimension(:,:,:),    intent(out) :: answer
integer,                     intent(in)  :: k_min, k_max

!---------------------------------------------------------------------
!  intent(in) variables:
!
!    tab
!    ix
!    iy
!    dx
!    dy
!    k_min
!    k_max
!
!  intent(out) variables:
!
!    answer
!
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

      integer    ::  i_min, i_max, j_min, j_max, i, j, k
  
!--------------------------------------------------------------------
!  local variables:
!
!    i_min
!    i_max
!    j_min
!    j_max
!    i,j,k
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('rad_utilities_mod',   &
               'module has not been initialized', FATAL )
      endif

      i_min = lbound(ix,1)
      i_max = ubound(ix,1)
      j_min = lbound(ix,2)
      j_max = ubound(ix,2)

      do k=k_min, k_max
        do j=j_min, j_max
          do i=i_min, i_max
            answer(i,j,k) =                                         &
                                      tab%vae (ix(i,j,k), iy(i,j,k)) + &
                            dx(i,j,k)*tab%td  (ix(i,j,k), iy(i,j,k)) + &
                            dy(i,j,k)*tab%md  (ix(i,j,k), iy(i,j,k)) + &
                  dx(i,j,k)*dy(i,j,k)*tab%cd(ix(i,j,k), iy(i,j,k))
          end do
        end do
      end do

!---------------------------------------------------------------------


end subroutine looktab_type1



!#####################################################################
! <SUBROUTINE NAME="looktab_type2">
!  <OVERVIEW>
!   Subroutine to calculate answer from input differentials.
!  </OVERVIEW>
!  <DESCRIPTION>
!   given arrays ix(:,:,:) and iy(:,:,:) of integral subscripts and
!     arrays dx(:,:,:) and dy(:,:,:) of differences from x(:,:,:) and
!     y(:,:,:), calculate answer(:,:,:) = f(x(:,:,:), y(:,:,:))
!     from four tables of values, f, df/dx, df/dy, and d2f/dxdy.
!     The difference between this version about the version above is
!     that the differential arrays are 3 dimensional.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call looktab_type2 (tab, ix, iy, dx, dy, answer, k_min, k_max, m)
!  </TEMPLATE>
!  <IN NAME="tab" TYPE="longwave_tables2_type">
!   The data array that contains function values and differentials
!  </IN>
!  <IN NAME="ix" TYPE="integer">
!   x subscript of input data array
!  </IN>
!  <IN NAME="iy" TYPE="integer">
!   y subscript of input data array
!  </IN>
!  <IN NAME="dx" TYPE="real">
!   x step in the x subscript space
!  </IN>
!  <IN NAME="dy" TYPE="real">
!   y step in the y subscript space
!  </IN>
!  <OUT NAME="answer" TYPE="real">
!   the answer to be calculated
!  </OUT>
!  <IN NAME="k_min" TYPE="integer">
!   the minimum k value of the domain
!  </IN>
!  <IN NAME="k_max" TYPE="integer">
!   the maximum k value of the domain
!  </IN>
!  <IN NAME="m" TYPE="integer">
!   the z indice of the differential arrays
!  </IN>
! </SUBROUTINE>
!
subroutine looktab_type2 (tab, ix, iy, dx, dy, answer, k_min, k_max, m)

!-------------------------------------------------------------------
!    given arrays ix(:,:,:) and iy(:,:,:) of integral subscripts and
!    arrays dx(:,:,:) and dy(:,:,:) of differences from x(:,:,:) and
!    y(:,:,:), calculate answer(:,:,:) = f(x(:,:,:), y(:,:,:))
!    from four tables of values, f, df/dx, df/dy, and d2f/dxdy.
!    author: c. h. goldberg
!    revised: 1/1/93
!    certified:  radiation version 1.0
!--------------------------------------------------------------------

type(longwave_tables2_type), intent(in)   :: tab
integer, dimension (:,:,:),  intent(in)   :: ix, iy
integer,                     intent(in)   :: m
real, dimension (:,:,:),     intent(in)   :: dx, dy
real, dimension (:,:,:),     intent(out)  :: answer
integer,                     intent(in)   :: k_min, k_max

!---------------------------------------------------------------------
!  intent(in) variables:
!
!    tab
!    ix
!    iy
!    m
!    dx
!    dy
!    k_min
!    k_max
!
!  intent(out) variables:
!
!    answer
!
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

       integer    ::    i_min, i_max, j_min, j_max
       integer    ::    i, j, k
  
!--------------------------------------------------------------------
!  local variables:
!
!    i_min
!    i_max
!    j_min
!    j_max
!    i,j,k
!
!-------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('rad_utilities_mod',   &
               'module has not been initialized', FATAL )
      endif

      i_min = lbound(ix,1)
      i_max = ubound(ix,1)
      j_min = lbound(ix,2)
      j_max = ubound(ix,2)

      do k=k_min, k_max
        do j=j_min, j_max
          do i=i_min, i_max
            answer(i,j,k) =                                           &
                                   tab%vae (ix(i,j,k), iy(i,j,k),m) + &
                         dx(i,j,k)*tab%td (ix(i,j,k), iy(i,j,k),m) + &
                         dy(i,j,k)*tab%md (ix(i,j,k), iy(i,j,k),m) + &
               dx(i,j,k)*dy(i,j,k)*tab%cd   (ix(i,j,k), iy(i,j,k),m)
           end do
        end do
      end do

!--------------------------------------------------------------------

end subroutine looktab_type2



!###################################################################
! <SUBROUTINE NAME="looktab_type3">
!  <OVERVIEW>
!   Subroutine to calculate answer from input differentials.
!  </OVERVIEW>
!  <DESCRIPTION>
!   given arrays ix(:,:,:) and iy(:,:,:) of integral subscripts and
!     arrays dx(:,:,:) and dy(:,:,:) of differences from x(:,:,:) and
!     y(:,:,:), calculate answer(:,:,:) = f(x(:,:,:), y(:,:,:))
!     from four tables of values, f, df/dx, df/dy, and d2f/dxdy.
!   In this version, only f(x,y) and f(x,y)+dx*df/dx is used. Probably
!   the f(x,y) is homogeneous in y space.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call looktab_type3 (tab, ix, dx,  answer, k_min, k_max, n)
!  </TEMPLATE>
!  <IN NAME="tab" TYPE="longwave_tables3_type">
!   The data array that contains function values and differentials
!  </IN>
!  <IN NAME="ix" TYPE="integer">
!   x subscript of input data array
!  </IN>
!  <IN NAME="dx" TYPE="real">
!   x step in the x subscript space
!  </IN>
!  <OUT NAME="answer" TYPE="real">
!   the answer to be calculated
!  </OUT>
!  <IN NAME="k_min" TYPE="integer">
!   the minimum k value of the domain
!  </IN>
!  <IN NAME="k_max" TYPE="integer">
!   the maximum k value of the domain
!  </IN>
!  <IN NAME="n" TYPE="integer">
!   the z indice of the differential arrays
!  </IN>
! </SUBROUTINE>
!
subroutine looktab_type3 (tab, ix, dx,  answer, k_min, k_max, n)

!----------------------------------------------------------------------
!
!    given arrays ix(:,:,:) and dx(:,:,:) of integer subscripts and!
!    differences from x(:,:,:) and constant column subscript iyconst, 
!    calculate answer(:,:,:) = f(x(:,:,:), y(:,:,:)) from four tables
!    of values f, df/dx, df/dy, and d2f/dxdy.
!    author: c. h. goldberg
!    revised: 1/1/93
!    certified:  radiation version 1.0
!-----------------------------------------------------------------------

type(longwave_tables3_type), intent(in)  :: tab
integer, dimension (:,:,:),  intent(in)  :: ix
integer,                     intent(in)  :: n
real,    dimension(:,:,:),   intent(in)  :: dx
real,    dimension(:,:,:),   intent(out) :: answer 
integer,                     intent(in)  :: k_min, k_max

!---------------------------------------------------------------------
!  intent(in) variables:
!
!    tab
!    ix
!    n
!    dx
!    k_min
!    k_max
!
!  intent(out) variables:
!
!    answer
!
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

      integer    :: i_min, i_max, j_min, j_max
      integer    :: i, j, k
   
!--------------------------------------------------------------------
!  local variables:
!
!    i_min
!    i_max
!    j_min
!    j_max
!    i,j,k
!
!-------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('rad_utilities_mod',   &
               'module has not been initialized', FATAL )
      endif

!-----------------------------------------------------------------
      i_min = lbound(ix,1)
      i_max = ubound(ix,1)
      j_min = lbound(ix,2)
      j_max = ubound(ix,2)

      do k=k_min, k_max
        do j=j_min, j_max
          do i=i_min, i_max
                answer(i,j,k) =                                 &
                                      tab%vae (ix(i,j,k),n) +   &
                            dx(i,j,k)*tab%td(ix(i,j,k),n)
          end do
        end do
      end do

!------------------------------------------------------------------

end subroutine  looktab_type3


!#####################################################################
! <SUBROUTINE NAME="table1_alloc">
!  <OVERVIEW>
!   Allocate the longwave tables.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Allocate the longwave tables based on 2 dimension sizes
!  </DESCRIPTION>
!  <TEMPLATE>
!   call table1_alloc(tab, dim1, dim2)
!  </TEMPLATE>
!  <INOUT NAME="tab" TYPE="longwave_tables1_type">
!   The longwave tables
!  </INOUT>
!  <IN NAME="dim1" TYPE="integer">
!   size of the x dimension
!  </IN>
!  <IN NAME="dim2" TYPE="integer">
!   size of the y dimension
!  </IN>
! </SUBROUTINE>
!
subroutine table1_alloc (tab, dim1, dim2)

!------------------------------------------------------------------
!    table1_alloc allocates the arrays contained in a 
!    longwave_tables1_type variable.
!------------------------------------------------------------------

type(longwave_tables1_type), intent (inout) :: tab
integer,                     intent(in)     :: dim1, dim2

!-------------------------------------------------------------------
! intent(in) variables:
!
!     dim1
!     dim2
!
!  intent(inout) variables:
!
!     tab
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('rad_utilities_mod',   &
               'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!    allocate the component arrays of a longwave_tables1_type variable.
!---------------------------------------------------------------------
      allocate (tab%vae(dim1, dim2))
      allocate (tab%td (dim1, dim2))
      allocate (tab%md (dim1, dim2))
      allocate (tab%cd (dim1, dim2))

!---------------------------------------------------------------------

end subroutine table1_alloc


!####################################################################
! <SUBROUTINE NAME="table2_alloc">
!  <OVERVIEW>
!   Allocate the longwave tables.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Allocate the longwave tables based on 3 dimension sizes
!  </DESCRIPTION>
!  <TEMPLATE>
!   call table2_alloc(tab, dim1, dim2)
!  </TEMPLATE>
!  <INOUT NAME="tab" TYPE="longwave_tables2_type">
!   The longwave tables
!  </INOUT>
!  <IN NAME="dim1" TYPE="integer">
!   size of the x dimension
!  </IN>
!  <IN NAME="dim2" TYPE="integer">
!   size of the y dimension
!  </IN>
!  <IN NAME="dim3" TYPE="integer">
!   size of the z dimension
!  </IN>
! </SUBROUTINE>
!
subroutine table2_alloc (tab, dim1, dim2, dim3)

!------------------------------------------------------------------
!    table2_alloc allocates the arrays contained in a 
!    longwave_tables2_type variable.
!------------------------------------------------------------------

type(longwave_tables2_type), intent (inout) :: tab
integer,                     intent(in)     :: dim1, dim2, dim3

!-------------------------------------------------------------------
! intent(in) variables:
!
!     dim1
!     dim2
!     dim3
!
!  intent(inout) variables:
!
!     tab
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('rad_utilities_mod',   &
               'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!    allocate the component arrays of a longwave_tables2_type variable.
!---------------------------------------------------------------------
      allocate (tab%vae(dim1, dim2, dim3))
      allocate (tab%td (dim1, dim2, dim3))
      allocate (tab%md (dim1, dim2, dim3))
      allocate (tab%cd (dim1, dim2, dim3))

!--------------------------------------------------------------------

end subroutine table2_alloc


!#####################################################################
! <SUBROUTINE NAME="table3_alloc">
!  <OVERVIEW>
!   Allocate the longwave tables.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Allocate the longwave tables based on 2 dimension sizes
!  </DESCRIPTION>
!  <TEMPLATE>
!   call table3_alloc(tab, dim1, dim2)
!  </TEMPLATE>
!  <INOUT NAME="tab" TYPE="longwave_tables3_type">
!   The longwave tables
!  </INOUT>
!  <IN NAME="dim1" TYPE="integer">
!   size of the x dimension
!  </IN>
!  <IN NAME="dim2" TYPE="integer">
!   size of the y dimension
!  </IN>
! </SUBROUTINE>
!
subroutine table3_alloc (tab, dim1, dim2)

type(longwave_tables3_type), intent (inout) :: tab
integer,                     intent(in)     :: dim1, dim2

!-------------------------------------------------------------------
! intent(in) variables:
!
!     dim1
!     dim2
!
!  intent(inout) variables:
!
!     tab
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('rad_utilities_mod',   &
               'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!    allocate the component arrays of a longwave_tables3_type variable.
!---------------------------------------------------------------------
      allocate (tab%vae(dim1, dim2))
      allocate (tab%td (dim1, dim2))

end subroutine table3_alloc


!##################################################################

! <SUBROUTINE NAME="thickavg_3d">
!  <OVERVIEW>
!   Subroutine to use thick-averaging technique to define band interval
!   single scattering properties.
!  </OVERVIEW>
!  <DESCRIPTION>
! use the thick-averaging technique to define the single-scattering    
! properties of the parameterization band spectral intervals from the  
! specified spectral intervals of the particular scatterer.            
!                                                                      
! references:                                                          
!                                                                      
! edwards,j.m. and a. slingo, studies with a flexible new radiation    
!      code I: choosing a configuration for a large-scale model.,      
!      q.j.r. meteorological society, 122, 689-719, 1996.              
!                                                                      
! note: the 1.0E-100 factor to calculate asymmband is to prevent        
!       division by zero.                                              
!  </DESCRIPTION>
!  <TEMPLATE>
!   call subroutine thickavg_3d (nivl1    , nivl2     , nivls   ,   &
!                        nbands, $
!                        extivl   , ssalbivl  , asymmivl, solflxivl, &
!                        solflxband, extband  , ssalbband , asymmband)
!  </TEMPLATE>
!  <IN NAME="nivl1" TYPE="integer">
!   interval number for the specified single-scattering                
!              properties corresponding to the first psuedo-           
!              monochromatic frequency in a given parameterization     
!              band  
!  </IN>
!  <IN NAME="nivl2" TYPE="integer">
!   interval number for the specified single-scattering     
!              properties corresponding to the last psuedo-            
!              monochromatic frequency in a given parameterization     
!              band
!  </IN>
!  <IN NAME="nivls" TYPE="integer">
!   number of specified scattering spectral intervals
!  </IN>
!  <IN NAME="nbands" TYPE="integer">
!   number of spectral bands
!  </IN>
!  <IN NAME="extivl" TYPE="real">
!   the specified spectral values of the extinction coefficient 
!  </IN>
!  <INOUT NAME="ssalbivl" TYPE="real">
!   the specified spectral values of the single-scattering albedo
!  </INOUT>
!  <IN NAME="asymmivl" TYPE="real">
!   the specified spectral values of the asymmetry factor
!  </IN>
!  <IN NAME="solflxivl" TYPE="real">
!   the solar flux in each specified scattering spectral interval
!  </IN>
!  <IN NAME="solflxband" TYPE="real">
!   the solar flux in each parameterization band
!  </IN>
!  <OUT NAME="extband" TYPE="real">
!   the parameterization band values of the extinction coefficient
!  </OUT>
!  <OUT NAME="ssalbband" TYPE="real">
!   the parameterization band values of the single-scattering albedo
!  </OUT>
!  <OUT NAME="asymmband" TYPE="real">
!   the parameterization band values of the asymmetry factor
!  </OUT>
! </SUBROUTINE>
!
subroutine thickavg_3d (nivl1, nivl2, nivls, nbands, extivl, ssalbivl,&
                        asymmivl, solflxivl, solflxband, mask, extband,&
                        ssalbband, asymmband)
 
!---------------------------------------------------------------------
!    thickavg_3d uses the thick-averaging technique to define the 
!    single-scattering properties of the parameterization band spectral
!    intervals from the  specified spectral intervals of the particular
!    scatterer, using 3d input arrays.   
!    references:                                                       
!    edwards,j.m. and a. slingo, studies with a flexible new radiation  
!      code I: choosing a configuration for a large-scale model.,   
!      q.j.r. meteorological society, 122, 689-719, 1996.            
!--------------------------------------------------------------------

integer, dimension(:),    intent(in)       :: nivl1, nivl2
integer,                  intent(in)       :: nivls
integer,                  intent(in)       :: nbands
real, dimension(:,:,:,:), intent(in)       :: extivl, asymmivl
real, dimension(:,:,:,:), intent(inout)    :: ssalbivl
real, dimension(:,:),     intent(in)       :: solflxivl             
real, dimension(:),       intent(in)       :: solflxband            
real, dimension(:,:,:,:), intent(out)      :: extband, ssalbband,   &
                                              asymmband
logical, dimension(:,:,:), intent(in)      :: mask

!---------------------------------------------------------------------
!  intent(in) variables:
!
!    nivl1       interval number for the specified single-scattering  
!                properties corresponding to the first psuedo-         
!                monochromatic frequency in a given parameterization    
!                band                                                  
!    nivl2       interval number for the specified single-scattering 
!                properties corresponding to the last psuedo-          
!                monochromatic frequency in a given parameterization    
!                band                                                 
!    nivls       number of specified scattering spectral intervals      
!    nbands
!    extivl      specified spectral values of the extinction coefficient
!    asymmivl    the specified spectral values of the asymmetry     
!                factor                                           
!    solflxivl   the solar flux in each specified scattering spectral
!                interval                                         
!    solflxband  the solar flux in each parameterization band  
!
!  intent(inout) variables:
!
!    ssalbivl    the specified spectral values of the single-       
!                scattering albedo                                   
!
!  intent(out) variables:
!
!    extband     the parameterization band values of the extinction 
!                coefficient                                      
!    ssalbband   the parameterization band values of the single-   
!                scattering albedo                                  
!    asymmband   the parameterization band values of the asymmetry   
!                factor                                               
!    
!--------------------------------------------------------------------
 
!--------------------------------------------------------------------
!  local variables:
 
      real, dimension (size(ssalbivl,1),   &
                       size(ssalbivl,2), &
                       size(ssalbivl,3), nbands)  ::   refband        

      real, dimension (size(ssalbivl,1),   &
                       size(ssalbivl,2), &
                       size(ssalbivl,3))  ::   refthick, sp, sumk,   &
                                               sumomegak, sumomegakg, &
                                               sumrefthick

      integer  :: nband
      integer  :: i, j, k, ni
 
!--------------------------------------------------------------------
!  local variables:
!
!     refband
!     refthick
!     sp
!     sumk
!     sumomegak
!     sumomegakg
!     sumrefthck
!     nband
!     i,j,k,ni
!
!--------------------------------------------------------------------

!-------------------------------------------------------------------
!    be sure module has been initialized.
!--------------------------------------------------------------------
      if (.not. module_is_initialized) then
        call error_mesg ('rad_utilities_mod',  &
         'initialization routine of this module was never called', &
                                                                 FATAL)
      endif

!------------------------------------------------------ --------------
!--------------------------------------------------------------------
      do nband = 1,nbands
        sumk(:,:,:) = 0.0
        sumomegak(:,:,:) = 0.0
        sumomegakg(:,:,:) = 0.0
        sumrefthick(:,:,:) = 0.0
        do ni = nivl1(nband),nivl2(nband)
!
          do k=1, size(ssalbivl,3)
            do j=1,size(ssalbivl,2)
              do i=1,size(ssalbivl,1)
                if (mask(i,j,k)) then
                  ssalbivl(i,j,k,ni) = MIN(ssalbivl(i,j,k,ni), 1.0)
                  sp(i,j,k) = sqrt( ( 1.0 - ssalbivl(i,j,k,ni) ) /    &
                                    ( 1.0 - ssalbivl(i,j,k,ni) *      &
                                      asymmivl(i,j,k,ni) ) )
                  refthick(i,j,k) = (1.0 - sp(i,j,k))/(1.0 + sp(i,j,k))
                  sumrefthick(i,j,k) = sumrefthick(i,j,k) +    &
                                       refthick(i,j,k)*  &
                                       solflxivl(nband,ni)
                  sumk(i,j,k) = sumk(i,j,k) + extivl(i,j,k,ni) *   &
                                solflxivl(nband,ni)
                  sumomegak(i,j,k) = sumomegak(i,j,k) +     &
                                     ssalbivl(i,j,k,ni)*   &
                                     extivl(i,j,k,ni) *   &
                                     solflxivl(nband,ni)
                  sumomegakg(i,j,k) = sumomegakg(i,j,k) +    &
                                      ssalbivl(i,j,k,ni)*&
                                      extivl(i,j,k,ni)*  &
                                      asymmivl(i,j,k,ni) * &
                                      solflxivl(nband,ni)
                endif
              end do
            end do
          end do
        end do

!---------------------------------------------------------------------
!    the 1.0E-100 factor to calculate asymmband is to prevent        
!    division by zero.                                             
!---------------------------------------------------------------------
        do k=1, size(ssalbivl,3)
          do j=1,size(ssalbivl,2)
            do i=1,size(ssalbivl,1)
              extband(i,j,k,nband) = sumk(i,j,k) / solflxband(nband)
              asymmband(i,j,k,nband) = sumomegakg(i,j,k) /         &
                                       ( sumomegak(i,j,k) + 1.0E-100)
              refband(i,j,k,nband) = sumrefthick(i,j,k)/  &
                                     solflxband(nband)
              ssalbband(i,j,k,nband) = 4.0 * refband(i,j,k,nband) / &
                                       ((1.0 +    &
                                       refband(i,j,k,nband)) ** 2 -&
                                       asymmband(i,j,k,nband) *     &
                                       (1.0 - refband(i,j,k,nband))**2 )
            end do
          end do
        end do
      end do

!---------------------------------------------------------------------

  
end subroutine thickavg_3d



!####################################################################
! <SUBROUTINE NAME="thickavg_0d">
!  <OVERVIEW>
!   Subroutine to use thick-averaging technique to define band interval
!   single scattering properties.
!  </OVERVIEW>
!  <DESCRIPTION>
! use the thick-averaging technique to define the single-scattering    
! properties of the parameterization band spectral intervals from the  
! specified spectral intervals of the particular scatterer.            
!                                                                      
! references:                                                          
!                                                                      
! edwards,j.m. and a. slingo, studies with a flexible new radiation    
!      code I: choosing a configuration for a large-scale model.,      
!      q.j.r. meteorological society, 122, 689-719, 1996.              
!                                                                      
! note: the 1.0E-100 factor to calculate asymmband is to prevent        
!       division by zero.                                              
!  </DESCRIPTION>
!  <TEMPLATE>
!   call subroutine thickavg_0d (nivl1    , nivl2     , nivls   ,   &
!                        nbands,  &
!                        extivl   , ssalbivl  , asymmivl, solflxivl, &
!                        solflxband, extband  , ssalbband , asymmband)
!  </TEMPLATE>
!  <IN NAME="nivl1" TYPE="integer">
!   interval number for the specified single-scattering                
!              properties corresponding to the first psuedo-           
!              monochromatic frequency in a given parameterization     
!              band  
!  </IN>
!  <IN NAME="nivl2" TYPE="integer">
!   interval number for the specified single-scattering     
!              properties corresponding to the last psuedo-            
!              monochromatic frequency in a given parameterization     
!              band
!  </IN>
!  <IN NAME="nivls" TYPE="integer">
!   number of specified scattering spectral intervals
!  </IN>
!  <IN NAME="nbands" TYPE="integer">
!   number of spectral bands
!  </IN>
!  <IN NAME="extivl" TYPE="real">
!   the specified spectral values of the extinction coefficient 
!  </IN>
!  <INOUT NAME="ssalbivl" TYPE="real">
!   the specified spectral values of the single-scattering albedo
!  </INOUT>
!  <IN NAME="asymmivl" TYPE="real">
!   the specified spectral values of the asymmetry factor
!  </IN>
!  <IN NAME="solflxivl" TYPE="real">
!   the solar flux in each specified scattering spectral interval
!  </IN>
!  <IN NAME="solflxband" TYPE="real">
!   the solar flux in each parameterization band
!  </IN>
!  <OUT NAME="extband" TYPE="real">
!   the parameterization band values of the extinction coefficient
!  </OUT>
!  <OUT NAME="ssalbband" TYPE="real">
!   the parameterization band values of the single-scattering albedo
!  </OUT>
!  <OUT NAME="asymmband" TYPE="real">
!   the parameterization band values of the asymmetry factor
!  </OUT>
! </SUBROUTINE>
!
subroutine thickavg_0d (nivl1, nivl2, nivls, nbands, extivl, ssalbivl,&
                        asymmivl, solflxivl, solflxband, extband,  &
                        ssalbband , asymmband)
 
!---------------------------------------------------------------------
!    thickavg_0d uses the thick-averaging technique to define the 
!    single-scattering properties of the parameterization band spectral
!    intervals from the  specified spectral intervals of the particular
!    scatterer, using 3d input arrays.   
!    references:                                                       
!    edwards,j.m. and a. slingo, studies with a flexible new radiation  
!      code I: choosing a configuration for a large-scale model.,   
!      q.j.r. meteorological society, 122, 689-719, 1996.            
!--------------------------------------------------------------------

integer, dimension(:),    intent(in)       :: nivl1, nivl2
integer,                  intent(in)       :: nivls
integer,                  intent(in)       :: nbands
real, dimension(:),       intent(in)       :: extivl, asymmivl
real, dimension(:),       intent(inout)    :: ssalbivl
real, dimension(:,:),     intent(in)       :: solflxivl             
real, dimension(:),       intent(in)       :: solflxband            
real, dimension(:),       intent(out)      :: extband, ssalbband, &
                                              asymmband

!---------------------------------------------------------------------
!  intent(in) variables:
!
!    nivl1       interval number for the specified single-scattering  
!                properties corresponding to the first psuedo-         
!                monochromatic frequency in a given parameterization    
!                band                                                  
!    nivl2       interval number for the specified single-scattering 
!                properties corresponding to the last psuedo-          
!                monochromatic frequency in a given parameterization    
!                band                                                 
!    nivls       number of specified scattering spectral intervals      
!    nbands
!    extivl      specified spectral values of the extinction coefficient
!    asymmivl    the specified spectral values of the asymmetry     
!                factor                                           
!    solflxivl   the solar flux in each specified scattering spectral
!                interval                                         
!    solflxband  the solar flux in each parameterization band  
!
!  intent(inout) variables:
!
!    ssalbivl    the specified spectral values of the single-       
!                scattering albedo                                   
!
!  intent(out) variables:
!
!    extband     the parameterization band values of the extinction 
!                coefficient                                      
!    ssalbband   the parameterization band values of the single-   
!                scattering albedo                                  
!    asymmband   the parameterization band values of the asymmetry   
!                factor                                               
!    
!--------------------------------------------------------------------
 
!--------------------------------------------------------------------
!  local variables:

      real, dimension (nbands)        ::   refband
      real                            ::   refthick, sp, sumk,   &
                                           sumomegak, sumomegakg, &
                                           sumrefthick
      integer  :: nband 
      integer  :: ni
 
 
!--------------------------------------------------------------------
!  local variables:
!
!     refband
!     refthick
!     sp
!     sumk
!     sumomegak
!     sumomegakg
!     sumrefthck
!     nband
!     i,j,k,ni
!
!--------------------------------------------------------------------

!-------------------------------------------------------------------
!    be sure module has been initialized.
!--------------------------------------------------------------------
      if (.not. module_is_initialized) then
        call error_mesg ('rad_utilities_mod',  &
         'initialization routine of this module was never called', &
                                                                 FATAL)
      endif
  
!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      do nband = 1,nbands
        sumk        = 0.0
        sumomegak   = 0.0
        sumomegakg  = 0.0
        sumrefthick = 0.0
        do ni = nivl1(nband),nivl2(nband)
          if (extivl(ni) /= 0.0) then
            ssalbivl(ni) = MIN(ssalbivl(ni), 1.0)
            sp = sqrt( ( 1.0 - ssalbivl(ni) ) /    &
                       ( 1.0 - ssalbivl(ni) * asymmivl(ni) ) )
            refthick = (1.0 - sp)/(1.0 + sp)
            sumrefthick = sumrefthick + refthick * solflxivl(nband,ni)
            sumk = sumk + extivl(ni) * solflxivl(nband,ni)
            sumomegak = sumomegak +     &
                        ssalbivl(ni) * extivl(ni) * solflxivl(nband,ni)
            sumomegakg = sumomegakg +    &
                         ssalbivl(ni) * extivl(ni) *  &
                         asymmivl(ni) * solflxivl(nband,ni)
          endif
        end do

!--------------------------------------------------------------------- 
!
!--------------------------------------------------------------------- 
        extband(nband) = sumk / solflxband(nband)
        asymmband(nband) = sumomegakg / ( sumomegak + 1.0E-100)
        refband(nband) = sumrefthick/ solflxband(nband)
        ssalbband(nband) = 4.0 * refband(nband) / &
                           ( (1.0 + refband(nband))**2 - &
                          asymmband(nband) * (1.0 - refband(nband))**2 )
      end do

!---------------------------------------------------------------------
  

end subroutine thickavg_0d


!##################################################################

! <SUBROUTINE NAME="thickavg_isccp">
!  <OVERVIEW>
!   Subroutine to use thick-averaging technique to define band interval
!   single scattering properties for a single specified band.
!  </OVERVIEW>
!  <DESCRIPTION>
! use the thick-averaging technique to define the single-scattering    
! properties of the specified parameterization band spectral interval 
! from the specified spectral intervals of the particular scatterer.    
!                                                                      
! references:                                                          
!                                                                      
! edwards,j.m. and a. slingo, studies with a flexible new radiation    
!      code I: choosing a configuration for a large-scale model.,      
!      q.j.r. meteorological society, 122, 689-719, 1996.              
!                                                                      
! note: the 1.0E-100 factor to calculate asymmband is to prevent        
!       division by zero.                                              
!  </DESCRIPTION>
!  <TEMPLATE>
!   call subroutine thickavg (nband, nivl1, nivl2, extivl, solflxivl, &
!                             solflxband, mask, extband )
!  </TEMPLATE>
!  <IN NAME="nband" TYPE="integer">
!
!  </IN>
!  <IN NAME="nivl1" TYPE="integer">
!   interval number for the specified single-scattering                
!              properties corresponding to the first psuedo-           
!              monochromatic frequency in a given parameterization     
!              band  
!  </IN>
!  <IN NAME="nivl2" TYPE="integer">
!   interval number for the specified single-scattering     
!              properties corresponding to the last psuedo-            
!              monochromatic frequency in a given parameterization     
!              band
!  </IN>
!  <IN NAME="extivl" TYPE="real">
!   the specified spectral values of the extinction coefficient 
!  </IN>
!  <IN NAME="solflxivl" TYPE="real">
!   the solar flux in each specified scattering spectral interval
!  </IN>
!  <IN NAME="solflxband" TYPE="real">
!   the solar flux in each parameterization band
!  </IN>
!  <IN NAME="mask" TYPE="logical">
!   mask is .true. at gridpoints where extband needs to be calculated
!  </IN>
!  <OUT NAME="extband" TYPE="real">
!   the parameterization band values of the extinction coefficient
!  </OUT>
! </SUBROUTINE>
!
subroutine thickavg_isccp (nband, nivl1, nivl2, extivl,          &
                           solflxivl, solflxband, mask, extband)
 
!---------------------------------------------------------------------
!    thickavg_isccp uses the thick-averaging technique to define the 
!    solar extinction for the single specified parameterization band 
!    spectral interval (nband) from the  specified spectral intervals 
!    of the particular scatterer, using 3d input arrays.   
!    references:                                                       
!    edwards,j.m. and a. slingo, studies with a flexible new radiation  
!      code I: choosing a configuration for a large-scale model.,   
!      q.j.r. meteorological society, 122, 689-719, 1996.            
!--------------------------------------------------------------------

integer,                  intent(in)       :: nband
integer,                  intent(in)       :: nivl1, nivl2
real, dimension(:,:,:,:), intent(in)       :: extivl
real, dimension(:,:),     intent(in)       :: solflxivl             
real,                     intent(in)       :: solflxband            
logical, dimension(:,:,:),intent(in)       :: mask
real, dimension(:,:,:),   intent(out)      :: extband

!---------------------------------------------------------------------
!  intent(in) variables:
!
!    nband       the sw parameterization band for which the optical
!                properties are being calculated
!    nivl1       interval number for the specified single-scattering  
!                properties corresponding to the first psuedo-         
!                monochromatic frequency in a given parameterization    
!                band                                                  
!    nivl2       interval number for the specified single-scattering 
!                properties corresponding to the last psuedo-          
!                monochromatic frequency in a given parameterization    
!                band                                                 
!    extivl      specified spectral values of the extinction coefficient
!    solflxband  the solar flux in each parameterization band  
!    mask        logical indicating the points at which the band values 
!                should be calculated       
!
!  intent(out) variables:
!
!    extband     the parameterization band values of the extinction 
!                coefficient                                      
!    
!--------------------------------------------------------------------
 
!--------------------------------------------------------------------
!  local variables:
 
      real     ::  sumk
      integer  ::  i, j, k, ni
 
!--------------------------------------------------------------------
!  local variables:
!
!     sumk
!     i,j,k,ni
!
!--------------------------------------------------------------------

!-------------------------------------------------------------------
!    be sure module has been initialized.
!--------------------------------------------------------------------
      if (.not. module_is_initialized) then
        call error_mesg ('rad_utilities_mod',  &
         'initialization routine of this module was never called', &
                                                                 FATAL)
      endif

!--------------------------------------------------------------------
!
      do k=1, size(extivl,3)
        do j=1,size(extivl,2)
          do i=1,size(extivl,1)
            if (mask(i,j,k)) then
              sumk = 0.0
              do ni = nivl1,nivl2
                sumk = sumk + extivl(i,j,k,ni)*solflxivl(nband,ni)
              end do
              extband(i,j,k) = sumk/solflxband
            endif
          end do
        end do
      end do

!---------------------------------------------------------------------

  
end subroutine thickavg_isccp

!##################################################################

! <SUBROUTINE NAME="thickavg_1band">
!  <OVERVIEW>
!   Subroutine to use thick-averaging technique to define band interval
!   single scattering properties for a single specified band.
!  </OVERVIEW>
!  <DESCRIPTION>
! use the thick-averaging technique to define the single-scattering    
! properties of the specified parameterization band spectral interval 
! from the specified spectral intervals of the particular scatterer.    
!                                                                      
! references:                                                          
!                                                                      
! edwards,j.m. and a. slingo, studies with a flexible new radiation    
!      code I: choosing a configuration for a large-scale model.,      
!      q.j.r. meteorological society, 122, 689-719, 1996.              
!                                                                      
! note: the 1.0E-100 factor to calculate asymmband is to prevent        
!       division by zero.                                              
!  </DESCRIPTION>
!  <TEMPLATE>
!   call subroutine thickavg (nband, nivl1  , nivl2   , nivls   , &
!                        nbands, &
!                        extivl   , ssalbivl  , asymmivl, solflxivl, &
!                        solflxband,  mask, extband  , ssalbband ,  &
!                        asymmband)
!  </TEMPLATE>
!  <IN NAME="nband" TYPE="integer">
!
!  </IN>
!  <IN NAME="nivl1" TYPE="integer">
!   interval number for the specified single-scattering                
!              properties corresponding to the first psuedo-           
!              monochromatic frequency in a given parameterization     
!              band  
!  </IN>
!  <IN NAME="nivl2" TYPE="integer">
!   interval number for the specified single-scattering     
!              properties corresponding to the last psuedo-            
!              monochromatic frequency in a given parameterization     
!              band
!  </IN>
!  <IN NAME="nivls" TYPE="integer">
!   number of specified scattering spectral intervals
!  </IN>
!  <IN NAME="nbands" TYPE="integer">
!   number of spectral bands
!  </IN>
!  <IN NAME="extivl" TYPE="real">
!   the specified spectral values of the extinction coefficient 
!  </IN>
!  <INOUT NAME="ssalbivl" TYPE="real">
!   the specified spectral values of the single-scattering albedo
!  </INOUT>
!  <IN NAME="asymmivl" TYPE="real">
!   the specified spectral values of the asymmetry factor
!  </IN>
!  <IN NAME="solflxivl" TYPE="real">
!   the solar flux in each specified scattering spectral interval
!  </IN>
!  <IN NAME="solflxband" TYPE="real">
!   the solar flux in each parameterization band
!  </IN>
!  <IN NAME="mask" TYPE="logical">
!   mask is .true. at gridpoints where band calculations are needed
!  </IN>
!  <OUT NAME="extband" TYPE="real">
!   the parameterization band values of the extinction coefficient
!  </OUT>
!  <OUT NAME="ssalbband" TYPE="real">
!   the parameterization band values of the single-scattering albedo
!  </OUT>
!  <OUT NAME="asymmband" TYPE="real">
!   the parameterization band values of the asymmetry factor
!  </OUT>
! </SUBROUTINE>
!
subroutine thickavg_1band (nband, nivl1, nivl2, nivls, nbands, extivl, &
                           ssalbivl, asymmivl, solflxivl, solflxband, &
                           mask, extband, ssalbband, asymmband)
 
!---------------------------------------------------------------------
!    thickavg_1band uses the thick-averaging technique to define the 
!    single-scattering properties of the specified parameterization band
!    spectral interval from the  specified spectral intervals of the 
!    particular scatterer, using 3d input arrays.   
!    references:                                                       
!    edwards,j.m. and a. slingo, studies with a flexible new radiation  
!      code I: choosing a configuration for a large-scale model.,   
!      q.j.r. meteorological society, 122, 689-719, 1996.            
!--------------------------------------------------------------------

integer,                  intent(in)       :: nband
integer,                  intent(in)       :: nivl1, nivl2
integer,                  intent(in)       :: nivls
integer,                  intent(in)       :: nbands
real, dimension(:,:,:,:), intent(in)       :: extivl, asymmivl
real, dimension(:,:,:,:), intent(inout)    :: ssalbivl
real, dimension(:,:),     intent(in)       :: solflxivl             
real,                     intent(in)       :: solflxband            
real, dimension(:,:,:  ), intent(inout)      :: extband, ssalbband,   &
                                              asymmband
logical, dimension(:,:,:), intent(in)      :: mask

!---------------------------------------------------------------------
!  intent(in) variables:
!
!    nband       the sw parameterization band for which the optical
!                properties are being calculated
!    nivl1       interval number for the specified single-scattering  
!                properties corresponding to the first psuedo-         
!                monochromatic frequency in a given parameterization    
!                band                                                  
!    nivl2       interval number for the specified single-scattering 
!                properties corresponding to the last psuedo-          
!                monochromatic frequency in a given parameterization    
!                band                                                 
!    nivls       number of specified scattering spectral intervals      
!    nbands
!    extivl      specified spectral values of the extinction coefficient
!    asymmivl    the specified spectral values of the asymmetry     
!                factor                                           
!    solflxivl   the solar flux in each specified scattering spectral
!                interval                                         
!    solflxband  the solar flux in each parameterization band  
!    mask        logical indicating the points at which the band values 
!                should be calculated       
!
!  intent(inout) variables:
!
!    ssalbivl    the specified spectral values of the single-       
!                scattering albedo                                   
!
!  intent(out) variables:
!
!    extband     the parameterization band values of the extinction 
!                coefficient                                      
!    ssalbband   the parameterization band values of the single-   
!                scattering albedo                                  
!    asymmband   the parameterization band values of the asymmetry   
!                factor                                               
!    
!--------------------------------------------------------------------
 
!--------------------------------------------------------------------
!  local variables:
 
      real :: refband, sp, refthick
      real :: sumk, sumomegak, sumomegakg,  sumrefthick

      integer  :: i, j, k, ni
 
!--------------------------------------------------------------------
!  local variables:
!
!     refband
!     refthick
!     sp
!     sumk
!     sumomegak
!     sumomegakg
!     sumrefthck
!     nband
!     i,j,k,ni
!
!--------------------------------------------------------------------

!-------------------------------------------------------------------
!    be sure module has been initialized.
!--------------------------------------------------------------------
      if (.not. module_is_initialized) then
        call error_mesg ('rad_utilities_mod',  &
         'initialization routine of this module was never called', &
                                                                 FATAL)
      endif

!--------------------------------------------------------------------
!
!--------------------------------------------------------------------
      do k=1, size(ssalbivl,3)
        do j=1,size(ssalbivl,2)
          do i=1,size(ssalbivl,1)
            if (mask(i,j,k)) then
              sumk        = 0.0
              sumomegak        = 0.0
              sumomegakg        = 0.0
              sumrefthick        = 0.0
              do ni = nivl1,nivl2
                ssalbivl(i,j,k,ni) = MIN(ssalbivl(i,j,k,ni), 1.0)
                sp = sqrt((1.0 - ssalbivl(i,j,k,ni) ) /    &
                          (1.0 - ssalbivl(i,j,k,ni)*asymmivl(i,j,k,ni)))
                refthick = (1.0 - sp)/(1.0 + sp)
                sumrefthick = sumrefthick + refthick*solflxivl(nband,ni)
                sumk = sumk + extivl(i,j,k,ni)*solflxivl(nband,ni)
                sumomegak = sumomegak + ssalbivl(i,j,k,ni)*   &
                                        extivl(i,j,k,ni)*   &
                                        solflxivl(nband,ni)
                sumomegakg = sumomegakg + ssalbivl(i,j,k,ni)*&
                                          extivl(i,j,k,ni)*  &
                                          asymmivl(i,j,k,ni)* &
                                          solflxivl(nband,ni)
              end do

!---------------------------------------------------------------------
!    the 1.0E-100 factor to calculate asymmband is to prevent        
!    division by zero.                                             
!---------------------------------------------------------------------
              extband(i,j,k) = sumk/solflxband
              asymmband(i,j,k) = sumomegakg/(sumomegak + 1.0E-100)
              refband  = sumrefthick/solflxband        
              ssalbband(i,j,k) = 4.0*refband/((1.0 + refband) ** 2 - &
                                 asymmband(i,j,k)*(1.0 - refband)**2 )
            endif
          end do
        end do
      end do

!---------------------------------------------------------------------

  
end subroutine thickavg_1band

!####################################################################
! <SUBROUTINE NAME="thinavg">
!  <OVERVIEW>
!   Subroutine to use thin-averaging technique to define band interval
!   single scattering properties.
!  </OVERVIEW>
!  <DESCRIPTION>
! use the thin-averaging technique to define the single-scattering    
! properties of the parameterization band spectral intervals from the  
! specified spectral intervals of the particular scatterer.            
!                                                                      
! references:                                                          
!                                                                      
! edwards,j.m. and a. slingo, studies with a flexible new radiation    
!      code I: choosing a configuration for a large-scale model.,      
!      q.j.r. meteorological society, 122, 689-719, 1996.              
!                                                                      
! note: the 1.0E-100 factor to calculate asymmband is to prevent        
!       division by zero.                                              
!  </DESCRIPTION>
!  <TEMPLATE>
!   call subroutine thinavg (nivl1    , nivl2     , nivls   ,   &
!                        nbands, &
!                        extivl   , ssalbivl  , asymmivl, solflxivl, &
!                        solflxband, extband  , ssalbband , asymmband)
!  </TEMPLATE>
!  <IN NAME="nivl1" TYPE="integer">
!   interval number for the specified single-scattering                
!              properties corresponding to the first psuedo-           
!              monochromatic frequency in a given parameterization     
!              band  
!  </IN>
!  <IN NAME="nivl2" TYPE="integer">
!   interval number for the specified single-scattering     
!              properties corresponding to the last psuedo-            
!              monochromatic frequency in a given parameterization     
!              band
!  </IN>
!  <IN NAME="nivls" TYPE="integer">
!   number of specified scattering spectral intervals
!  </IN>
!  <IN NAME="extivl" TYPE="real">
!   the specified spectral values of the extinction coefficient 
!  </IN>
!  <IN NAME="nbands" TYPE="integer">
!   number of spectral bands
!  </IN>
!  <INOUT NAME="ssalbivl" TYPE="real">
!   the specified spectral values of the single-scattering albedo
!  </INOUT>
!  <IN NAME="asymmivl" TYPE="real">
!   the specified spectral values of the asymmetry factor
!  </IN>
!  <IN NAME="solflxivl" TYPE="real">
!   the solar flux in each specified scattering spectral interval
!  </IN>
!  <IN NAME="solflxband" TYPE="real">
!   the solar flux in each parameterization band
!  </IN>
!  <OUT NAME="extband" TYPE="real">
!   the parameterization band values of the extinction coefficient
!  </OUT>
!  <OUT NAME="ssalbband" TYPE="real">
!   the parameterization band values of the single-scattering albedo
!  </OUT>
!  <OUT NAME="asymmband" TYPE="real">
!   the parameterization band values of the asymmetry factor
!  </OUT>
! </SUBROUTINE>
!
subroutine thinavg (nivl1, nivl2, nivls, nbands, extivl, ssalbivl, &
                    asymmivl,  solflxivl, solflxband, extband,   &
                    ssalbband , asymmband)
 
!---------------------------------------------------------------------
!    thinavg uses the thin-averaging technique to define the 
!    single-scattering properties of the parameterization band spectral
!    intervals from the  specified spectral intervals of the particular
!    scatterer, using 3d input arrays.   
!    references:                                                       
!    edwards,j.m. and a. slingo, studies with a flexible new radiation  
!      code I: choosing a configuration for a large-scale model.,   
!      q.j.r. meteorological society, 122, 689-719, 1996.            
!--------------------------------------------------------------------

integer, dimension(:),    intent(in)       :: nivl1, nivl2
integer,                  intent(in)       :: nivls
integer,                  intent(in)       :: nbands
real, dimension(:,:,:,:), intent(in)       :: extivl, asymmivl
real, dimension(:,:,:,:), intent(inout)    :: ssalbivl
real, dimension(:,:),     intent(in)       :: solflxivl             
real, dimension(:),       intent(in)       :: solflxband            
real, dimension(:,:,:,:), intent(out)      :: extband, ssalbband,   &
                                              asymmband

!---------------------------------------------------------------------
!  intent(in) variables:
!
!    nivl1       interval number for the specified single-scattering  
!                properties corresponding to the first psuedo-         
!                monochromatic frequency in a given parameterization    
!                band                                                  
!    nivl2       interval number for the specified single-scattering 
!                properties corresponding to the last psuedo-          
!                monochromatic frequency in a given parameterization    
!                band                                                 
!    nivls       number of specified scattering spectral intervals      
!    nbands
!    extivl      specified spectral values of the extinction coefficient
!    asymmivl    the specified spectral values of the asymmetry     
!                factor                                           
!    solflxivl   the solar flux in each specified scattering spectral
!                interval                                         
!    solflxband  the solar flux in each parameterization band  
!
!  intent(inout) variables:
!
!    ssalbivl    the specified spectral values of the single-       
!                scattering albedo                                   
!
!  intent(out) variables:
!
!    extband     the parameterization band values of the extinction 
!                coefficient                                      
!    ssalbband   the parameterization band values of the single-   
!                scattering albedo                                  
!    asymmband   the parameterization band values of the asymmetry   
!                factor                                               
!    
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

      real, dimension (size(ssalbivl,1),   &
                       size(ssalbivl,2),  &
                       size(ssalbivl,3)) ::   sumk,  sumomegak,   &
                                              sumomegakg
 
      integer   ::   nband
      integer   ::   i, j, k, ni

!--------------------------------------------------------------------
!  local variables:
! 
!    sumk
!    sumomegak
!    sumomegakg
!    nband
!    i,j,k,ni
!
!--------------------------------------------------------------------

!-------------------------------------------------------------------
!    be sure module has been initialized.
!--------------------------------------------------------------------
      if (.not. module_is_initialized) then
        call error_mesg ('rad_utilities_mod',  &
         'initialization routine of this module was never called', &
                                                                 FATAL)
      endif

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      do nband = 1,nbands
        sumk(:,:,:) = 0.0
        sumomegak(:,:,:) = 0.0
        sumomegakg(:,:,:) = 0.0
        do ni = nivl1(nband),nivl2(nband)
          do k=1, size(ssalbivl,3)
            do j=1,size(ssalbivl,2)
              do i=1,size(ssalbivl,1)
                if ((ssalbivl(i,j,k,ni) +    &
                     asymmivl(i,j,k,ni)) /= 0.0) then
                  ssalbivl(i,j,k,ni) = MIN(ssalbivl(i,j,k,ni), 1.0)
                  sumk(i,j,k) = sumk(i,j,k) + extivl(i,j,k,ni) *   &
                                solflxivl(nband,ni)
                  sumomegak(i,j,k) = sumomegak(i,j,k) +    &
                                     ssalbivl(i,j,k,ni) *  &
                                     extivl(i,j,k,ni) *   &
                                     solflxivl(nband,ni)
                  sumomegakg(i,j,k) = sumomegakg(i,j,k) +    &
                                      ssalbivl(i,j,k,ni) * & 
                                      extivl(i,j,k,ni) *   &
                                      asymmivl(i,j,k,ni) *  &
                                      solflxivl(nband,ni)
                endif
              end do
            end do
          end do
        end do

!----------------------------------------------------------------------
!
!---------------------------------------------------------------------
        do k=1, size(ssalbivl,3)
          do j=1,size(ssalbivl,2)
            do i=1,size(ssalbivl,1)
              extband(i,j,k,nband) = sumk(i,j,k) / solflxband(nband)
              asymmband(i,j,k,nband) = sumomegakg(i,j,k) /    &
                                       ( sumomegak(i,j,k) + 1.0E-100 )
              ssalbband(i,j,k,nband) = sumomegak(i,j,k) /   &
                                       ( sumk(i,j,k) + 1.0E-100 )
            end do
          end do
        end do
      end do

!-------------------------------------------------------------------
  

end subroutine thinavg 


!#########################################################################
subroutine get_radiative_param(text_in_scheme,text_in_param, &
                               rad_forc_online, tr_rad_name,  &
                               tr_clim_name, tr_rad_scale_factor)

character(len=*), intent(in)    :: text_in_scheme, text_in_param
logical, intent(out)            :: rad_forc_online
character(len=*), intent(out)   :: tr_rad_name,tr_clim_name
real,             intent(out)   :: tr_rad_scale_factor
integer                         :: flag


if(lowercase(trim(text_in_scheme(1:6))) == 'online') then
       rad_forc_online = .true.
       flag=parse(text_in_param,'name_in_rad_mod', tr_rad_name)
       flag=parse(text_in_param,'name_in_clim_mod', tr_clim_name)
       tr_rad_scale_factor = 1.
       flag=parse(text_in_param,'scale_factor', tr_rad_scale_factor)
else
       rad_forc_online = .false.
       tr_rad_name  = ' '
       tr_clim_name = ' '
       tr_rad_scale_factor = 1.
endif

end subroutine get_radiative_param


!#####################################################################

! <SUBROUTINE NAME="rad_utilities_end">
!  <OVERVIEW>
!   Subroutine to close out the radiation utility package.
!  </OVERVIEW>
!  <DESCRIPTION>
!   This subroutine is the destructor for rad_utilies_mod. it marks
!   the module as uninitialized.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call rad_utilities_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine rad_utilities_end

!--------------------------------------------------------------------
!    rad_utilites_end is the destructor for rad_utilities_mod.
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('rad_utilites_mod',   &
             'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!    mark the module as uninitialized.
!---------------------------------------------------------------------
       module_is_initialized = .false.

!-------------------------------------------------------------------


end subroutine rad_utilities_end


subroutine aerosol_props_type_eq(aerosol_props_out,aerosol_props_in)

   type(aerosol_properties_type), intent(inout) :: aerosol_props_out
   type(aerosol_properties_type), intent(in)    :: aerosol_props_in

!  Need to add error trap to catch unallocated aerosol_props_in
   if (ASSOCIATED(aerosol_props_in%aerextband)) then
     aerosol_props_out%aerextband    = aerosol_props_in%aerextband
     aerosol_props_out%aerssalbband    = aerosol_props_in%aerssalbband
     aerosol_props_out%aerasymmband    = aerosol_props_in%aerasymmband
    else
      call error_mesg ('=', 'extband', FATAL)
   endif
   if (ASSOCIATED(aerosol_props_in%aerextbandlw)) then
     aerosol_props_out%aerextbandlw    = aerosol_props_in%aerextbandlw
     aerosol_props_out%aerssalbbandlw  = aerosol_props_in%aerssalbbandlw
     aerosol_props_out%aerextbandlw_cn =    &
                                       aerosol_props_in%aerextbandlw_cn
     aerosol_props_out%aerssalbbandlw_cn  =    &
                                     aerosol_props_in%aerssalbbandlw_cn
    else
      call error_mesg ('=', 'extbandlw', FATAL)
   endif
  if (Rad_control%volcanic_sw_aerosols) then
   if (ASSOCIATED(aerosol_props_in%sw_ext)) then
     aerosol_props_out%sw_ext        = aerosol_props_in%sw_ext     
     aerosol_props_out%sw_ssa          = aerosol_props_in%sw_ssa       
     aerosol_props_out%sw_asy          = aerosol_props_in%sw_asy
    else
      call error_mesg ('=', 'sw volc', FATAL)
   endif
  endif
  if (Rad_control%volcanic_lw_aerosols) then
   if (ASSOCIATED(aerosol_props_in%lw_ext)) then
     aerosol_props_out%lw_ext        = aerosol_props_in%lw_ext     
     aerosol_props_out%lw_ssa          = aerosol_props_in%lw_ssa       
     aerosol_props_out%lw_asy          = aerosol_props_in%lw_asy
    else
      call error_mesg ('=', 'lw volc', FATAL)
   endif
  endif
   if (ASSOCIATED(aerosol_props_in%sulfate_index)) then
     aerosol_props_out%sulfate_index = aerosol_props_in%sulfate_index
     aerosol_props_out%optical_index = aerosol_props_in%optical_index
     aerosol_props_out%omphilic_index = aerosol_props_in%omphilic_index
     aerosol_props_out%bcphilic_index = aerosol_props_in%bcphilic_index
     aerosol_props_out%seasalt1_index = aerosol_props_in%seasalt1_index
     aerosol_props_out%seasalt2_index = aerosol_props_in%seasalt2_index
     aerosol_props_out%seasalt3_index = aerosol_props_in%seasalt3_index
     aerosol_props_out%seasalt4_index = aerosol_props_in%seasalt4_index
     aerosol_props_out%seasalt5_index = aerosol_props_in%seasalt5_index
    else
      call error_mesg ('=', 'index  ', FATAL)
   endif

   if (ASSOCIATED(aerosol_props_in%ivol)) then
     aerosol_props_out%ivol = aerosol_props_in%ivol
    else
      call error_mesg ('=', 'ivol   ', FATAL)
   endif
   
     aerosol_props_out%sulfate_flag = aerosol_props_in%sulfate_flag
     aerosol_props_out%omphilic_flag = aerosol_props_in%omphilic_flag
     aerosol_props_out%bcphilic_flag = aerosol_props_in%bcphilic_flag
     aerosol_props_out%seasalt1_flag = aerosol_props_in%seasalt1_flag
     aerosol_props_out%seasalt2_flag = aerosol_props_in%seasalt2_flag
     aerosol_props_out%seasalt3_flag = aerosol_props_in%seasalt3_flag
     aerosol_props_out%seasalt4_flag = aerosol_props_in%seasalt4_flag
     aerosol_props_out%seasalt5_flag = aerosol_props_in%seasalt5_flag
     aerosol_props_out%bc_flag = aerosol_props_in%bc_flag



end subroutine aerosol_props_type_eq



subroutine lw_output_type_eq(lw_output_out,lw_output_in)

   type(lw_output_type), intent(inout) :: lw_output_out
   type(lw_output_type), intent(in)    :: lw_output_in

!  Need to add error trap to catch unallocated lw_output_in
   lw_output_out%heatra        = lw_output_in%heatra
   lw_output_out%flxnet        = lw_output_in%flxnet
   lw_output_out%netlw_special = lw_output_in%netlw_special
   lw_output_out%bdy_flx       = lw_output_in%bdy_flx
   if (ASSOCIATED(lw_output_in%heatracf))then
       lw_output_out%heatracf          = lw_output_in%heatracf
       lw_output_out%flxnetcf          = lw_output_in%flxnetcf
       lw_output_out%netlw_special_clr = lw_output_in%netlw_special_clr
       lw_output_out%bdy_flx_clr       = lw_output_in%bdy_flx_clr
   endif
end subroutine lw_output_type_eq


subroutine sw_output_type_eq(sw_output_out,sw_output_in)

   type(sw_output_type), intent(inout) :: sw_output_out
   type(sw_output_type), intent(in)    :: sw_output_in

!  Need to add error trap to catch unallocated sw_output_in
   sw_output_out%fsw              = sw_output_in%fsw
   sw_output_out%dfsw             = sw_output_in%dfsw
   sw_output_out%ufsw             = sw_output_in%ufsw
   sw_output_out%hsw              = sw_output_in%hsw
   sw_output_out%dfsw_dir_sfc     = sw_output_in%dfsw_dir_sfc
   sw_output_out%ufsw_dir_sfc     = sw_output_in%ufsw_dir_sfc
   sw_output_out%dfsw_dif_sfc     = sw_output_in%dfsw_dif_sfc
   sw_output_out%ufsw_dif_sfc     = sw_output_in%ufsw_dif_sfc
   sw_output_out%dfsw_vis_sfc     = sw_output_in%dfsw_vis_sfc
   sw_output_out%ufsw_vis_sfc     = sw_output_in%ufsw_vis_sfc
   sw_output_out%ufsw_vis_sfc_dir = sw_output_in%ufsw_vis_sfc_dir
   sw_output_out%dfsw_vis_sfc_dir = sw_output_in%dfsw_vis_sfc_dir
   sw_output_out%dfsw_vis_sfc_dif = sw_output_in%dfsw_vis_sfc_dif
   sw_output_out%ufsw_vis_sfc_dif = sw_output_in%ufsw_vis_sfc_dif
   sw_output_out%swdn_special     = sw_output_in%swdn_special
   sw_output_out%swup_special     = sw_output_in%swup_special
   sw_output_out%bdy_flx          = sw_output_in%bdy_flx
   if (ASSOCIATED(sw_output_in%fswcf))then
       sw_output_out%fswcf            = sw_output_in%fswcf
       sw_output_out%dfswcf           = sw_output_in%dfswcf
       sw_output_out%ufswcf           = sw_output_in%ufswcf
       sw_output_out%hswcf            = sw_output_in%hswcf
       sw_output_out%dfsw_dir_sfc_clr = sw_output_in%dfsw_dir_sfc_clr
       sw_output_out%dfsw_dif_sfc_clr = sw_output_in%dfsw_dif_sfc_clr
       sw_output_out%dfsw_vis_sfc_clr = sw_output_in%dfsw_vis_sfc_clr
       sw_output_out%swdn_special_clr = sw_output_in%swdn_special_clr
       sw_output_out%swup_special_clr = sw_output_in%swup_special_clr
       sw_output_out%bdy_flx_clr      = sw_output_in%bdy_flx_clr
   endif  
end subroutine sw_output_type_eq


!####################################################################


                     end module rad_utilities_mod

module mpp_efp_mod
#include <fms_platform.h>

use mpp_mod, only : mpp_error, FATAL, WARNING, NOTE
use mpp_mod, only : mpp_pe, mpp_root_pe, mpp_npes
use mpp_mod, only : mpp_sum

implicit none ; private

public :: mpp_reproducing_sum, mpp_efp_list_sum_across_PEs
public :: mpp_efp_plus, mpp_efp_minus, mpp_efp_to_real, mpp_real_to_efp, mpp_efp_real_diff
public :: operator(+), operator(-), assignment(=)
public :: mpp_query_efp_overflow_error, mpp_reset_efp_overlow_error

!   This module provides interfaces to the non-domain-oriented communication
! subroutines.
integer, parameter :: NUMBIT = 46  ! number of bits used in the 64-bit signed integer representation.
integer, parameter :: NUMINT = 6   ! The number of long integers to use to represent
                                   ! a real number.

integer(LONG_KIND), parameter :: prec=2_8**NUMBIT ! The precision of each integer.
real(DOUBLE_KIND), parameter :: r_prec=2.0**NUMBIT  ! A real version of prec.
real(DOUBLE_KIND), parameter :: I_prec=1.0/(2.0**NUMBIT) ! The inverse of prec.
integer, parameter :: max_count_prec=2**(63-NUMBIT)-1
                              ! The number of values that can be added together
                              ! with the current value of prec before there will
                              ! be roundoff problems.

real(DOUBLE_KIND), parameter, dimension(NUMINT) :: &
  pr = (/ r_prec**2, r_prec, 1.0, 1.0/r_prec, 1.0/r_prec**2, 1.0/r_prec**3 /)
real(DOUBLE_KIND), parameter, dimension(NUMINT) :: &
  I_pr = (/ 1.0/r_prec**2, 1.0/r_prec, 1.0, r_prec, r_prec**2, r_prec**3 /)

logical :: overflow_error = .false., NaN_error = .false.
logical :: debug = .false.    ! Making this true enables debugging output.

interface mpp_reproducing_sum
  module procedure mpp_reproducing_sum_r8_2d
  module procedure mpp_reproducing_sum_r8_3d
  module procedure mpp_reproducing_sum_r4_2d
end interface mpp_reproducing_sum

! The Extended Fixed Point (mpp_efp) type provides a public interface for doing
! sums and taking differences with this type.
type, public :: mpp_efp_type ; private
  integer(kind=8), dimension(NUMINT) :: v
end type mpp_efp_type

interface operator (+); module procedure mpp_efp_plus  ; end interface
interface operator (-); module procedure mpp_efp_minus ; end interface
interface assignment(=); module procedure mpp_efp_assign ; end interface

contains

function mpp_reproducing_sum_r8_2d(array, isr, ier, jsr, jer, EFP_sum, reproducing, &
                            overflow_check, err) result(sum)
  real(DOUBLE_KIND), dimension(:,:), intent(in) :: array
  integer,        optional,          intent(in) :: isr, ier, jsr, jer
  type(mpp_efp_type), optional,     intent(out) :: EFP_sum
  logical,        optional,          intent(in) :: reproducing
  logical,        optional,          intent(in) :: overflow_check
  integer,        optional,         intent(out) :: err
  real(DOUBLE_KIND)                             :: sum  ! Result

  !   This subroutine uses a conversion to an integer representation
  ! of real numbers to give order-invariant sums that will reproduce
  ! across PE count.  This idea comes from R. Hallberg and A. Adcroft.

  integer(LONG_KIND), dimension(NUMINT)  :: ints_sum
  integer(LONG_KIND) :: ival, prec_error
  real(DOUBLE_KIND)  :: rsum(1), rs
  real(DOUBLE_KIND)  :: max_mag_term
  logical :: repro, over_check
  character(len=256) :: mesg
  integer :: i, j, n, is, ie, js, je, sgn

  if (mpp_npes() > max_count_prec) call mpp_error(FATAL, &
    "mpp_reproducing_sum: Too many processors are being used for the value of "//&
    "prec.  Reduce prec to (2^63-1)/mpp_npes.")

  prec_error = (2_8**62 + (2_8**62 - 1)) / mpp_npes()

  is = 1 ; ie = size(array,1) ; js = 1 ; je = size(array,2 )
  if (present(isr)) then
    if (isr < is) call mpp_error(FATAL, &
      "Value of isr too small in mpp_reproducing_sum_2d.")
    is = isr
  endif
  if (present(ier)) then
    if (ier > ie) call mpp_error(FATAL, &
      "Value of ier too large in mpp_reproducing_sum_2d.")
    ie = ier
  endif
  if (present(jsr)) then
    if (jsr < js) call mpp_error(FATAL, &
      "Value of jsr too small in mpp_reproducing_sum_2d.")
    js = jsr
  endif
  if (present(jer)) then
    if (jer > je) call mpp_error(FATAL, &
      "Value of jer too large in mpp_reproducing_sum_2d.")
    je = jer
  endif

  repro = .true. ; if (present(reproducing)) repro = reproducing
  over_check = .true. ; if (present(overflow_check)) over_check = overflow_check

  if (repro) then
    overflow_error = .false. ; NaN_error = .false. ; max_mag_term = 0.0
    ints_sum(:) = 0
    if (over_check) then
      if ((je+1-js)*(ie+1-is) < max_count_prec) then
        do j=js,je ; do i=is,ie
          call increment_ints_faster(ints_sum, array(i,j), max_mag_term);
        enddo ; enddo
        call carry_overflow(ints_sum, prec_error)
      elseif ((ie+1-is) < max_count_prec) then
        do j=js,je
          do i=is,ie
            call increment_ints_faster(ints_sum, array(i,j), max_mag_term);
          enddo
          call carry_overflow(ints_sum, prec_error)
        enddo
      else
        do j=js,je ; do i=is,ie
          call increment_ints(ints_sum, real_to_ints(array(i,j), prec_error), &
                              prec_error);
        enddo ; enddo
      endif
    else
      do j=js,je ; do i=is,ie
        sgn = 1 ; if (array(i,j)<0.0) sgn = -1
        rs = abs(array(i,j))
        do n=1,NUMINT
          ival = int(rs*I_pr(n), 8)
          rs = rs - ival*pr(n)
          ints_sum(n) = ints_sum(n) + sgn*ival
        enddo
      enddo ; enddo
      call carry_overflow(ints_sum, prec_error)
    endif

    if (present(err)) then
      err = 0
      if (overflow_error) &
        err = err+2
      if (NaN_error) &
        err = err+4
      if (err > 0) then ; do n=1,NUMINT ; ints_sum(n) = 0 ; enddo ; endif
    else
      if (NaN_error) then
        call mpp_error(FATAL, "NaN in input field of mpp_reproducing_sum(_2d).")
      endif
      if (abs(max_mag_term) >= prec_error*pr(1)) then
        write(mesg, '(ES13.5)') max_mag_term
        call mpp_error(FATAL,"Overflow in mpp_reproducing_sum(_2d) conversion of "//trim(mesg))
      endif
      if (overflow_error) then
        call mpp_error(FATAL, "Overflow in mpp_reproducing_sum(_2d).")
      endif
    endif

    call mpp_sum(ints_sum, NUMINT)

    call regularize_ints(ints_sum)
    sum = ints_to_real(ints_sum)
  else
    rsum(1) = 0.0
    do j=js,je ; do i=is,ie
      rsum(1) = rsum(1) + array(i,j);
    enddo ; enddo
    call mpp_sum(rsum,1)
    sum = rsum(1)

    if (present(err)) then ; err = 0 ; endif

    if (debug .or. present(EFP_sum)) then
      overflow_error = .false.
      ints_sum = real_to_ints(sum, prec_error, overflow_error)
      if (overflow_error) then
        if (present(err)) then
          err = err + 2
        else
          write(mesg, '(ES13.5)') sum
          call mpp_error(FATAL,"Repro_sum_2d: Overflow in real_to_ints conversion of "//trim(mesg))
        endif
      endif
    endif
  endif

  if (present(EFP_sum)) EFP_sum%v(:) = ints_sum(:)

  if (debug) then
    write(mesg,'("2d RS: ", ES24.16, 6 Z17.16)') sum, ints_sum(1:NUMINT)
    if(mpp_pe() == mpp_root_pe()) call mpp_error(NOTE, mesg)
  endif

end function mpp_reproducing_sum_r8_2d

function mpp_reproducing_sum_r4_2d(array, isr, ier, jsr, jer, EFP_sum, reproducing, &
                            overflow_check, err) result(sum)
  real(FLOAT_KIND), dimension(:,:), intent(in) :: array
  integer,        optional,          intent(in) :: isr, ier, jsr, jer
  type(mpp_efp_type), optional,     intent(out) :: EFP_sum
  logical,        optional,          intent(in) :: reproducing
  logical,        optional,          intent(in) :: overflow_check
  integer,        optional,         intent(out) :: err
  real(FLOAT_KIND)                             :: sum  ! Result

  real(DOUBLE_KIND) :: array_r8(size(array,1), size(array,2))

  array_r8 = array
  
  sum = mpp_reproducing_sum_r8_2d(array_r8, isr, ier, jsr, jer, EFP_sum, reproducing, &
                            overflow_check, err)

  return

end function mpp_reproducing_sum_r4_2d


function mpp_reproducing_sum_r8_3d(array, isr, ier, jsr, jer, sums, EFP_sum, err) &
                            result(sum)
  real(DOUBLE_KIND), dimension(:,:,:),        intent(in) :: array
  integer,    optional,                       intent(in) :: isr, ier, jsr, jer
  real(DOUBLE_KIND), dimension(:), optional, intent(out) :: sums
  type(mpp_efp_type),     optional,          intent(out) :: EFP_sum
  integer,            optional,              intent(out) :: err
  real(DOUBLE_KIND)                                      :: sum  ! Result

  !   This subroutine uses a conversion to an integer representation
  ! of real numbers to give order-invariant sums that will reproduce
  ! across PE count.  This idea comes from R. Hallberg and A. Adcroft.

  real(DOUBLE_KIND)    :: max_mag_term
  integer(LONG_KIND), dimension(NUMINT)  :: ints_sum
  integer(LONG_KIND), dimension(NUMINT,size(array,3))  :: ints_sums
  integer(LONG_KIND) :: prec_error
  character(len=256) :: mesg
  integer :: i, j, k, is, ie, js, je, ke, isz, jsz, n

  if (mpp_npes() > max_count_prec) call mpp_error(FATAL, &
    "mpp_reproducing_sum: Too many processors are being used for the value of "//&
    "prec.  Reduce prec to (2^63-1)/mpp_npes.")

  prec_error = (2_8**62 + (2_8**62 - 1)) / mpp_npes()
  max_mag_term = 0.0

  is = 1 ; ie = size(array,1) ; js = 1 ; je = size(array,2) ; ke = size(array,3)
  if (present(isr)) then
    if (isr < is) call mpp_error(FATAL, &
      "Value of isr too small in mpp_reproducing_sum(_3d).")
    is = isr
  endif
  if (present(ier)) then
    if (ier > ie) call mpp_error(FATAL, &
      "Value of ier too large in mpp_reproducing_sum(_3d).")
    ie = ier
  endif
  if (present(jsr)) then
    if (jsr < js) call mpp_error(FATAL, &
      "Value of jsr too small in mpp_reproducing_sum(_3d).")
    js = jsr
  endif
  if (present(jer)) then
    if (jer > je) call mpp_error(FATAL, &
      "Value of jer too large in mpp_reproducing_sum(_3d).")
    je = jer
  endif
  jsz = je+1-js; isz = ie+1-is

  if (present(sums)) then
    if (size(sums) > ke) call mpp_error(FATAL, "Sums is smaller than "//&
      "the vertical extent of array in mpp_reproducing_sum(_3d).")
    ints_sums(:,:) = 0
    overflow_error = .false. ; NaN_error = .false. ; max_mag_term = 0.0
    if (jsz*isz < max_count_prec) then
      do k=1,ke
        do j=js,je ; do i=is,ie
          call increment_ints_faster(ints_sums(:,k), array(i,j,k), max_mag_term);
        enddo ; enddo
        call carry_overflow(ints_sums(:,k), prec_error)
      enddo
    elseif (isz < max_count_prec) then
      do k=1,ke ; do j=js,je
        do i=is,ie
          call increment_ints_faster(ints_sums(:,k), array(i,j,k), max_mag_term);
        enddo
        call carry_overflow(ints_sums(:,k), prec_error)
      enddo ; enddo
    else
      do k=1,ke ; do j=js,je ; do i=is,ie
        call increment_ints(ints_sums(:,k), &
                            real_to_ints(array(i,j,k), prec_error), prec_error);
      enddo ; enddo ; enddo
    endif
    if (present(err)) then
      err = 0
      if (abs(max_mag_term) >= prec_error*pr(1)) err = err+1
      if (overflow_error) err = err+2
      if (NaN_error) err = err+2
      if (err > 0) then ; do k=1,ke ; do n=1,NUMINT ; ints_sums(n,k) = 0 ; enddo ; enddo ; endif
    else
      if (NaN_error) call mpp_error(FATAL, "NaN in input field of mpp_reproducing_sum(_3d).")
      if (abs(max_mag_term) >= prec_error*pr(1)) then
        write(mesg, '(ES13.5)') max_mag_term
        call mpp_error(FATAL,"Overflow in mpp_reproducing_sum(_3d) conversion of "//trim(mesg))
      endif
      if (overflow_error) call mpp_error(FATAL, "Overflow in mpp_reproducing_sum(_3d).")
    endif

    call mpp_sum(ints_sums(:,1:ke), NUMINT*ke)

    sum = 0.0
    do k=1,ke
      call regularize_ints(ints_sums(:,k))
      sums(k) = ints_to_real(ints_sums(:,k))
      sum = sum + sums(k)
    enddo

    if (present(EFP_sum)) then
      EFP_sum%v(:) = 0
      do k=1,ke ; call increment_ints(EFP_sum%v(:), ints_sums(:,k)) ; enddo
    endif

    if (debug) then
      do n=1,NUMINT ; ints_sum(n) = 0 ; enddo
      do k=1,ke ; do n=1,NUMINT ; ints_sum(n) = ints_sum(n) + ints_sums(n,k) ; enddo ; enddo
      write(mesg,'("3D RS: ", ES24.16, 6 Z17.16)') sum, ints_sum(1:NUMINT)
      if(mpp_pe()==mpp_root_pe()) call mpp_error(NOTE, mesg)
    endif
  else
    ints_sum(:) = 0
    overflow_error = .false. ; NaN_error = .false. ; max_mag_term = 0.0
    if (jsz*isz < max_count_prec) then
      do k=1,ke
        do j=js,je ; do i=is,ie
          call increment_ints_faster(ints_sum, array(i,j,k), max_mag_term);
        enddo ; enddo
        call carry_overflow(ints_sum, prec_error)
      enddo
    elseif (isz < max_count_prec) then
      do k=1,ke ; do j=js,je
        do i=is,ie
          call increment_ints_faster(ints_sum, array(i,j,k), max_mag_term);
        enddo
        call carry_overflow(ints_sum, prec_error)
      enddo ; enddo
    else
      do k=1,ke ; do j=js,je ; do i=is,ie
        call increment_ints(ints_sum, real_to_ints(array(i,j,k), prec_error), &
                            prec_error);
      enddo ; enddo ; enddo
    endif
    if (present(err)) then
      err = 0
      if (abs(max_mag_term) >= prec_error*pr(1)) err = err+1
      if (overflow_error) err = err+2
      if (NaN_error) err = err+2
      if (err > 0) then ; do n=1,NUMINT ; ints_sum(n) = 0 ; enddo ; endif
    else
      if (NaN_error) call mpp_error(FATAL, "NaN in input field of mpp_reproducing_sum(_3d).")
      if (abs(max_mag_term) >= prec_error*pr(1)) then
        write(mesg, '(ES13.5)') max_mag_term
        call mpp_error(FATAL,"Overflow in mpp_reproducing_sum(_3d) conversion of "//trim(mesg))
      endif
      if (overflow_error) call mpp_error(FATAL, "Overflow in mpp_reproducing_sum(_3d).")
    endif

    call mpp_sum(ints_sum, NUMINT)

    call regularize_ints(ints_sum)
    sum = ints_to_real(ints_sum)

    if (present(EFP_sum)) EFP_sum%v(:) = ints_sum(:)

    if (debug) then
      write(mesg,'("3d RS: ", ES24.16, 6 Z17.16)') sum, ints_sum(1:NUMINT)
      if(mpp_pe()==mpp_root_pe()) call mpp_error(NOTE, mesg)
    endif
  endif

end function mpp_reproducing_sum_r8_3d

function real_to_ints(r, prec_error, overflow) result(ints)
  real(DOUBLE_KIND),            intent(in) :: r
  integer(LONG_KIND), optional, intent(in) :: prec_error
  logical,   optional,       intent(inout) :: overflow
  integer(LONG_KIND),    dimension(NUMINT) :: ints
  !   This subroutine converts a real number to an equivalent representation
  ! using several long integers.

  real(DOUBLE_KIND) :: rs
  character(len=80) :: mesg
  integer(LONG_KIND) :: ival, prec_err
  integer :: sgn, i

  prec_err = prec ; if (present(prec_error)) prec_err = prec_error
  ints(:) = 0_8
  if ((r >= 1e30) .eqv. (r < 1e30)) then ; NaN_error = .true. ; return ; endif

  sgn = 1 ; if (r<0.0) sgn = -1
  rs = abs(r)

  if (present(overflow)) then
    if (.not.(rs < prec_err*pr(1))) overflow = .true.
    if ((r >= 1e30) .eqv. (r < 1e30)) overflow = .true.
  elseif (.not.(rs < prec_err*pr(1))) then
    write(mesg, '(ES13.5)') r
    call mpp_error(FATAL,"Overflow in real_to_ints conversion of "//trim(mesg))
  endif

  do i=1,NUMINT
    ival = int(rs*I_pr(i), 8)
    rs = rs - ival*pr(i)
    ints(i) = sgn*ival
  enddo

end function real_to_ints

function ints_to_real(ints) result(r)
  integer(LONG_KIND), dimension(NUMINT), intent(in) :: ints
  real(DOUBLE_KIND) :: r
  ! This subroutine reverses the conversion in real_to_ints.

  integer :: i

  r = 0.0
  do i=1,NUMINT ; r = r + pr(i)*ints(i) ; enddo
end function ints_to_real

subroutine increment_ints(int_sum, int2, prec_error)
  integer(LONG_KIND), dimension(NUMINT), intent(inout) :: int_sum
  integer(LONG_KIND), dimension(NUMINT), intent(in)    :: int2
  integer(LONG_KIND), optional,      intent(in)    :: prec_error

  ! This subroutine increments a number with another, both using the integer
  ! representation in real_to_ints.
  integer :: i

  do i=NUMINT,2,-1
    int_sum(i) = int_sum(i) + int2(i)
    ! Carry the local overflow.
    if (int_sum(i) > prec) then
      int_sum(i) = int_sum(i) - prec
      int_sum(i-1) = int_sum(i-1) + 1
    elseif (int_sum(i) < -prec) then
      int_sum(i) = int_sum(i) + prec
      int_sum(i-1) = int_sum(i-1) - 1
    endif
  enddo
  int_sum(1) = int_sum(1) + int2(1)
  if (present(prec_error)) then
    if (abs(int_sum(1)) > prec_error) overflow_error = .true.
  else
    if (abs(int_sum(1)) > prec) overflow_error = .true.
  endif

end subroutine increment_ints

subroutine increment_ints_faster(int_sum, r, max_mag_term)
  integer(LONG_KIND), dimension(NUMINT), intent(inout) :: int_sum
  real(DOUBLE_KIND),                        intent(in) :: r
  real(DOUBLE_KIND),                     intent(inout) :: max_mag_term

  ! This subroutine increments a number with another, both using the integer
  ! representation in real_to_ints, but without doing any carrying of overflow.
  ! The entire operation is embedded in a single call for greater speed.
  real(DOUBLE_KIND) :: rs
  integer(LONG_KIND) :: ival
  integer :: sgn, i

  if ((r >= 1e30) .eqv. (r < 1e30)) then ; NaN_error = .true. ; return ; endif
  sgn = 1 ; if (r<0.0) sgn = -1
  rs = abs(r)
  if (rs > abs(max_mag_term)) max_mag_term = r

  do i=1,NUMINT
    ival = int(rs*I_pr(i), 8)
    rs = rs - ival*pr(i)
    int_sum(i) = int_sum(i) + sgn*ival
  enddo

end subroutine increment_ints_faster

subroutine carry_overflow(int_sum, prec_error)
  integer(LONG_KIND), dimension(NUMINT), intent(inout) :: int_sum
  integer(LONG_KIND),                intent(in)    :: prec_error

  ! This subroutine handles carrying of the overflow.
  integer :: i, num_carry

  do i=NUMINT,2,-1 ; if (abs(int_sum(i)) > prec) then
    num_carry = int(int_sum(i) * I_prec)
    int_sum(i) = int_sum(i) - num_carry*prec
    int_sum(i-1) = int_sum(i-1) + num_carry
  endif ; enddo
  if (abs(int_sum(1)) > prec_error) then
    overflow_error = .true.
  endif

end subroutine carry_overflow

subroutine regularize_ints(int_sum)
  integer(LONG_KIND), dimension(NUMINT), intent(inout) :: int_sum

  ! This subroutine carries the overflow, and then makes sure that
  ! all integers are of the same sign as the overall value.
  logical :: positive
  integer :: i, num_carry

  do i=NUMINT,2,-1 ; if (abs(int_sum(i)) > prec) then
    num_carry = int(int_sum(i) * I_prec)
    int_sum(i) = int_sum(i) - num_carry*prec
    int_sum(i-1) = int_sum(i-1) + num_carry
  endif ; enddo

  ! Determine the sign of the final number.
  positive = .true.
  do i=1,NUMINT
    if (abs(int_sum(i)) > 0) then
      if (int_sum(i) < 0) positive = .false.
      exit
    endif
  enddo

  if (positive) then
    do i=NUMINT,2,-1 ; if (int_sum(i) < 0) then
      int_sum(i) = int_sum(i) + prec
      int_sum(i-1) = int_sum(i-1) - 1
    endif ; enddo
  else
    do i=NUMINT,2,-1 ; if (int_sum(i) > 0) then
      int_sum(i) = int_sum(i) - prec
      int_sum(i-1) = int_sum(i-1) + 1
    endif ; enddo
  endif

end subroutine regularize_ints

function mpp_query_efp_overflow_error()
  logical :: mpp_query_efp_overflow_error
  mpp_query_efp_overflow_error = overflow_error
end function mpp_query_efp_overflow_error

subroutine mpp_reset_efp_overlow_error()
  overflow_error = .false.
end subroutine mpp_reset_efp_overlow_error

function mpp_efp_plus(EFP1, EFP2)
  type(mpp_efp_type)             :: mpp_efp_plus
  type(mpp_efp_type), intent(in) :: EFP1, EFP2

  mpp_efp_plus = EFP1

  call increment_ints(mpp_efp_plus%v(:), EFP2%v(:))
end function mpp_efp_plus

function mpp_efp_minus(EFP1, EFP2)
  type(mpp_efp_type)             :: mpp_efp_minus
  type(mpp_efp_type), intent(in) :: EFP1, EFP2
  integer :: i

  do i=1,NUMINT ; mpp_efp_minus%v(i) = -1*EFP2%v(i) ; enddo

  call increment_ints(mpp_efp_minus%v(:), EFP1%v(:))
end function mpp_efp_minus

subroutine mpp_efp_assign(EFP1, EFP2)
  type(mpp_efp_type), intent(out) :: EFP1
  type(mpp_efp_type), intent(in)  :: EFP2
  integer i
  ! This subroutine assigns all components of the extended fixed point type
  ! variable on the RHS (EFP2) to the components of the variable on the LHS
  ! (EFP1).

  do i=1,NUMINT ; EFP1%v(i) = EFP2%v(i) ; enddo
end subroutine mpp_efp_assign

function mpp_efp_to_real(EFP1)
  type(mpp_efp_type), intent(inout) :: EFP1
  real(DOUBLE_KIND) :: mpp_efp_to_real

  call regularize_ints(EFP1%v)
  mpp_efp_to_real = ints_to_real(EFP1%v)
end function mpp_efp_to_real

function mpp_efp_real_diff(EFP1, EFP2)
  type(mpp_efp_type), intent(in) :: EFP1, EFP2
  real(DOUBLE_KIND) :: mpp_efp_real_diff

  type(mpp_efp_type)             :: EFP_diff

  EFP_diff = EFP1 - EFP2
  mpp_efp_real_diff = mpp_efp_to_real(EFP_diff)

end function mpp_efp_real_diff

function mpp_real_to_efp(val, overflow)
  real(DOUBLE_KIND),    intent(in) :: val
  logical, optional, intent(inout) :: overflow
  type(mpp_efp_type)               :: mpp_real_to_efp

  logical :: over
  character(len=80) :: mesg

  if (present(overflow)) then
    mpp_real_to_efp%v(:) = real_to_ints(val, overflow=overflow)
  else
    over = .false.
    mpp_real_to_efp%v(:) = real_to_ints(val, overflow=over)
    if (over) then
      write(mesg, '(ES13.5)') val
      call mpp_error(FATAL,"Overflow in mpp_real_to_efp conversion of "//trim(mesg))
    endif
  endif

end function mpp_real_to_efp

subroutine mpp_efp_list_sum_across_PEs(EFPs, nval, errors)
  type(mpp_efp_type), dimension(:), intent(inout) :: EFPs
  integer, intent(in) :: nval
  logical, dimension(:), optional, intent(out) :: errors

  !   This subroutine does a sum across PEs of a list of EFP variables,
  ! returning the sums in place, with all overflows carried.

  integer(LONG_KIND), dimension(NUMINT,nval) :: ints
  integer(LONG_KIND) :: prec_error
  logical :: error_found
  character(len=256) :: mesg
  integer :: i, n

  if (mpp_npes() > max_count_prec) call mpp_error(FATAL, &
    "mpp_efp_list_sum_across_PEs: Too many processors are being used for the value of "//&
    "prec.  Reduce prec to (2^63-1)/mpp_npes.")

  prec_error = (2_8**62 + (2_8**62 - 1)) / mpp_npes()
  ! overflow_error is an overflow error flag for the whole module.
  overflow_error = .false. ; error_found = .false.

  do i=1,nval ; do n=1,NUMINT ; ints(n,i) = EFPs(i)%v(n) ; enddo ; enddo

  call mpp_sum(ints(:,:), NUMINT*nval)

  if (present(errors)) errors(:) = .false.
  do i=1,nval
    overflow_error = .false.
    call carry_overflow(ints(:,i), prec_error)
    do n=1,NUMINT ; EFPs(i)%v(n) = ints(n,i) ; enddo
    if (present(errors)) errors(i) = overflow_error
    if (overflow_error) then
      write (mesg,'("mpp_efp_list_sum_across_PEs error at ",i6," val was ",ES12.6, ", prec_error = ",ES12.6)') &
             i, mpp_efp_to_real(EFPs(i)), real(prec_error)
      if(mpp_pe()==mpp_root_pe()) call mpp_error(WARNING, mesg)
    endif
    error_found = error_found .or. overflow_error
  enddo
  if (error_found .and. .not.(present(errors))) then
    call mpp_error(FATAL, "Overflow in mpp_efp_list_sum_across_PEs.")
  endif

end subroutine mpp_efp_list_sum_across_PEs

end module mpp_efp_mod

module ocean_drifters_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Matt Harrison 
!</CONTACT>
!
!<OVERVIEW>
! Advect USER supplied drifters using the shared/drifters package.
!</OVERVIEW>
!
!<DESCRIPTION>
! Advect USER supplied drifters using the shared/drifters package.
!</DESCRIPTION>
!
!<NAMELIST NAME="ocean_drifters_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to run this module. Default use_this_module=.false.
!  </DATA> 
!  <DATA NAME="output_interval" TYPE="integer">
!  Interval in timesteps between drifter writes
!  </DATA> 
!
!</NAMELIST>

  use drifters_mod
  use fms_mod
  use mpp_domains_mod
  use mpp_mod,          only : input_nml_file 
  use time_manager_mod, only : time_type, get_time

  use ocean_domains_mod,    only : get_local_indices
  use ocean_parameters_mod, only : rho0r
  use ocean_types_mod,      only : ocean_grid_type, ocean_domain_type
  use ocean_types_mod,      only : ocean_time_type, ocean_velocity_type
  use ocean_types_mod,      only : ocean_adv_vel_type, ocean_prog_tracer_type

  implicit none

  type(drifters_type),save :: drfts

  character(len=128) :: ermesg
  real :: xcmin, xcmax,ycmin,ycmax,xdmin,xdmax,ydmin,ydmax,xmin,xmax
  integer :: isc,iec,jsc,jec,isd,ied,jsd,jed,nk
  integer :: dt ! ocean time step in seconds
  real, dimension(:), allocatable :: x1d, y1d, z1d, dlon, dlat
  real, dimension(:,:,:), allocatable, save :: u, v, w, lon3d, lat3d, depth3d

  ! nml variables 
  logical :: use_this_module=.false.
  integer :: output_interval=1
  
  namelist /ocean_drifters_nml/ use_this_module, output_interval
  
contains

  subroutine ocean_drifters_init(Domain,Grid, Time, T_prog, Velocity, Adv_vel)

    type(ocean_domain_type) :: Domain
    type(ocean_grid_type)   :: Grid
    type(ocean_time_type)   :: Time
    type(ocean_prog_tracer_type), dimension(:) :: T_prog
    type(ocean_velocity_type) :: Velocity
    type(ocean_adv_vel_type) :: Adv_vel
    
    integer :: i,j,k, days, npes, ioun, ierr, io_status
    integer, dimension(:), allocatable :: pelist

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

    ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_drifters_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_drifters_nml')
#else
    ioun = open_namelist_file()
    read  (ioun, ocean_drifters_nml,iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_drifters_nml')
    call close_file (ioun)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit, ocean_drifters_nml)
    write (stdlogunit, ocean_drifters_nml)

    call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
    nk=Grid%nk

    if(.not. use_this_module) return 


    ! Determine local compute and data domain boundaries
    ! Note: This is only appropriate for spherical grids
    ! will not work for the tripolar grid region, for instance.

    allocate(x1d(isd:ied),y1d(jsd:jed),z1d(nk))
    allocate(u(isd:ied,jsd:jed,nk),v(isd:ied,jsd:jed,nk),w(isd:ied,jsd:jed,nk))
    allocate(lon3d(isd:ied,jsd:jed,nk),lat3d(isd:ied,jsd:jed,nk),depth3d(isd:ied,jsd:jed,nk))    
    allocate(dlon(isd:ied),dlat(jsd:jed))

    u=0.0;v=0.0;w=0.0
    
    do i=isc,iec
       x1d(i)=Grid%grid_x_t(i)
    enddo
    
    if (isc.eq.1) then
        x1d(isd)=Grid%grid_x_t(Grid%ni)-360.0
    else
        x1d(isd)=Grid%grid_x_t(isd)
    endif

    if (iec.eq.Grid%ni) then
        x1d(ied)=Grid%grid_x_t(1)+360.0
    else
        x1d(ied)=Grid%grid_x_t(ied)
    endif

    
    do j=jsc,jec
       y1d(j)=Grid%grid_y_t(j)
    enddo

    if (jsc.eq.1) then
        y1d(jsd) = Grid%grid_y_t(1)-1.e-5
    else
        y1d(jsd) = Grid%grid_y_t(jsd)
    endif

    if (jec.eq.Grid%nj) then
        y1d(jed) = Grid%grid_y_t(Grid%nj)+1.e-5
    else
        y1d(jed) = Grid%grid_y_t(jed)
    endif
    

    do k=1,nk
       z1d(k)=Grid%zt(k)
    enddo
    
    xcmin = x1d(isc)
    xcmax = x1d(iec)
    ycmin = y1d(jsc)
    ycmax = y1d(jec)    

    xdmin = x1d(isd)
    xdmax = x1d(ied)
    ydmin = y1d(jsd)
    ydmax = y1d(jed)    

    xmin = Grid%grid_x_t(Grid%ni)-360.;xmax = Grid%grid_x_t(1)+360.
    
    call get_time(Time%Time_Step,dt,days)
    
    call drifters_new(drfts, &
       & input_file ='INPUT/drifters_inp.nc'  ,  &
       & output_file='DRIFTERS/drifters_out.nc', &
       & ermesg=ermesg)

    npes=mpp_npes()
    allocate(pelist(npes))
    call mpp_get_pelist(Domain%domain2d,pelist)

    drfts%comm%pe_beg=pelist(1)
    drfts%comm%pe_end=pelist(npes)
    
    
  ! set the initial time and dt
    drfts%time = 0.0
    drfts%dt   = float(dt)


  ! set the PE domain boundaries. Xmin_comp/ymin_comp, xmax_comp/ymax_comp
  ! refer to the "compute" domain, which should cover densily the domain:
  ! xcmax[pe] = xcmin[pe_east]
  ! ycmax[pe] = ycmin[pe_north]
  ! Xmin_data/ymin_data, xmax_data/ymax_data refer to the "data" domain, which
  ! should be larger than the compute domain and therefore overlap:
  ! xdmax[pe] > xdmin[pe_east]
  ! ydmax[pe] > ydmin[pe_north]
  ! Particles in the overlap regions are tracked by several PEs. 
  call drifters_set_domain(drfts, &
       & xmin_comp=xcmin, xmax_comp=xcmax, &
       & ymin_comp=ycmin, ymax_comp=ycmax, &
       & xmin_data=xdmin, xmax_data=xdmax, &
       & ymin_data=ydmin, ymax_data=ydmax, &
       & xmin_glob=xmin , xmax_glob=xmax,  & ! this will set periodicity in x 
       & ermesg=ermesg)
  
  ! set neighboring PEs [domain2d is of type(domain2d)]
  call drifters_set_pe_neighbors(drfts, domain=Domain%domain2d, ermesg=ermesg)

  ! set the velocities axes. Each velocity can have different axes.
  call drifters_set_v_axes(drfts, component='u', &
       & x=x1d, y=y1d, z=z1d, ermesg=ermesg)

  call drifters_set_v_axes(drfts, component='v', &
       & x=x1d, y=y1d, z=z1d, ermesg=ermesg)

  call drifters_set_v_axes(drfts, component='w', &
       & x=x1d, y=y1d, z=z1d, ermesg=ermesg)  
  

  ! Distribute the drifters across PEs
  call drifters_distribute(drfts, ermesg)


  ! Push the drifters. u_comp, v_comp etc are provided by the host code

  do j=jsc,jec
     dlat(j) = 0.5*(y1d(j+1)-y1d(j-1))
  enddo
  dlat(jsd)=dlat(jsc)
  dlat(jed)=dlat(jec)

  do i=isc,iec
     dlon(i) = 0.5*(x1d(i+1)-x1d(i-1))
  enddo
  dlon(isd)=dlon(isc)
  dlon(ied)=dlon(iec)
  
  
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           u(i,j,k)=Velocity%u(i,j,k,1,Time%taup1)/Grid%dxt(i,j)*dlon(i)
           v(i,j,k)=Velocity%u(i,j,k,2,Time%taup1)/Grid%dyt(i,j)*dlat(j)
           w(i,j,k)=-1.0*Adv_vel%wrho_bt(i,j,k)*rho0r
           lon3d(i,j,k) = Grid%xt(i,j)
           lat3d(i,j,k) = Grid%yt(i,j)
           depth3d(i,j,k) = Grid%zt(k)                      
        enddo
     enddo
  enddo
  
  call drifters_push(drfts, u=u, v=v, w=w, ermesg=ermesg)


  ! check if RK4 integration is complete
  if(drfts%rk4_completed .and. mod(Time%itt0,output_interval) .eq. 0 ) then

      ! interpolate fields      
      call drifters_set_field(drfts, index_field=1, x=x1d, y=y1d, z=z1d, &
           &    data=lon3d, ermesg=ermesg)
      
      call drifters_set_field(drfts, index_field=2, x=x1d, y=y1d, z=z1d, &
           &    data=lat3d, ermesg=ermesg)             

      call drifters_set_field(drfts, index_field=3, x=x1d, y=y1d, z=z1d, &
           &    data=depth3d, ermesg=ermesg)
      
      call drifters_set_field(drfts, index_field=4, x=x1d, y=y1d, z=z1d, &
           &    data=T_prog(1)%field(:,:,:,Time%taup1), ermesg=ermesg)

      call drifters_set_field(drfts, index_field=5, x=x1d, y=y1d, z=z1d, &
           &    data=T_prog(2)%field(:,:,:,Time%taup1), ermesg=ermesg)      

      
      ! save data 
      call drifters_save(drfts, ermesg=ermesg)
      
  endif
  
  end subroutine ocean_drifters_init


  subroutine update_ocean_drifters(Velocity, Adv_vel, T_prog, Grid, Time)

    type(ocean_velocity_type) :: Velocity
    type(ocean_adv_vel_type) :: Adv_vel
    type(ocean_prog_tracer_type), dimension(:) :: T_prog
    type(ocean_grid_type) :: Grid
    type(ocean_time_type) :: Time
    
    integer :: i,j,k

    if(.not. use_this_module) return 

    do k=1,nk
       do j=jsd,jed
          do i=isd,ied
             u(i,j,k)=Velocity%u(i,j,k,1,Time%taup1)/Grid%dxt(i,j)*dlon(i)
             v(i,j,k)=Velocity%u(i,j,k,2,Time%taup1)/Grid%dyt(i,j)*dlat(j)
             w(i,j,k)=-1.0*Adv_vel%wrho_bt(i,j,k)*rho0r
          enddo
       enddo
    enddo


    ! push the drifters
    call drifters_push(drfts, u=u, v=v, w=w, ermesg=ermesg)

 
    ! check if RK4 integration is complete
    if(drfts%rk4_completed .and. mod(Time%itt0,output_interval) .eq. 0 ) then

        ! interpolate fields
        call drifters_set_field(drfts, index_field=1, x=x1d, y=y1d, z=z1d, &
             &    data=lon3d, ermesg=ermesg)

        call drifters_set_field(drfts, index_field=2, x=x1d, y=y1d, z=z1d, &
             &    data=lat3d, ermesg=ermesg)             

        call drifters_set_field(drfts, index_field=3, x=x1d, y=y1d, z=z1d, &
             &    data=depth3d, ermesg=ermesg)

        call drifters_set_field(drfts, index_field=4, x=x1d, y=y1d, z=z1d, &
	     &    data=T_prog(1)%field(:,:,:,Time%taup1), ermesg=ermesg)

        call drifters_set_field(drfts, index_field=5, x=x1d, y=y1d, z=z1d, &
             &    data=T_prog(2)%field(:,:,:,Time%taup1), ermesg=ermesg)

        call drifters_save(drfts, ermesg=ermesg)

    endif 
    
  end subroutine update_ocean_drifters


  subroutine ocean_drifters_end(Grid)
    type(ocean_grid_type) :: Grid

    if(.not. use_this_module) return 

    ! write restart file, optionally with lon/lat data coordinates (under development)
    call drifters_write_restart(drfts, filename='RESTART/drifters_inp.nc', &
!       & x1=Grid%grid_x_u, y1=Grid%grid_y_u, geolon1=Grid%xt, &
!       & x2=Grid%grid_x_u, y2=Grid%grid_y_u, geolat2=Grid%yt, &
         ermesg=ermesg)  

    ! destroy
    call drifters_del(drfts, ermesg=ermesg)

    deallocate(x1d,y1d,z1d,u,v,w,lon3d,lat3d,depth3d,dlon,dlat)


  end subroutine ocean_drifters_end


end module ocean_drifters_mod

module atmos_model_mod
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Bruce Wyman  
!</CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  Zhi Liang
! </REVIEWER>
!-----------------------------------------------------------------------
!<OVERVIEW>
!  Driver for the atmospheric model, contains routines to advance the
!  atmospheric model state by one time step.
!</OVERVIEW>

!<DESCRIPTION>
!     This version of atmos_model_mod has been designed around the implicit
!     version diffusion scheme of the GCM. It requires two routines to advance
!     the atmospheric model one time step into the future. These two routines
!     correspond to the down and up sweeps of the standard tridiagonal solver.
!     Most atmospheric processes (dynamics,radiation,etc.) are performed
!     in the down routine. The up routine finishes the vertical diffusion
!     and computes moisture related terms (convection,large-scale condensation,
!     and precipitation).

!     The boundary variables needed by other component models for coupling
!     are contained in a derived data type. A variable of this derived type
!     is returned when initializing the atmospheric model. It is used by other
!     routines in this module and by coupling routines. The contents of
!     this derived type should only be modified by the atmospheric model.

!</DESCRIPTION>

use mpp_mod,            only: mpp_pe, mpp_root_pe, mpp_clock_id, mpp_clock_begin
use mpp_mod,            only: mpp_clock_end, CLOCK_COMPONENT, mpp_error, mpp_chksum
use mpp_domains_mod,    only: domain2d
#ifdef INTERNAL_FILE_NML
use mpp_mod,            only: input_nml_file
#else
use fms_mod,            only: open_namelist_file
#endif
use fms_mod,            only: file_exist, error_mesg, field_size, FATAL, NOTE, WARNING
use fms_mod,            only: close_file,  write_version_number, stdlog, stdout
use fms_mod,            only: read_data, write_data, clock_flag_default
use fms_mod,            only: open_restart_file, check_nml_error
use fms_io_mod,         only: get_restart_io_mode
use fms_io_mod,         only: restart_file_type, register_restart_field
use fms_io_mod,         only: save_restart, restore_state, get_mosaic_tile_file
use time_manager_mod,   only: time_type, operator(+), get_time
use field_manager_mod,  only: MODEL_ATMOS
use tracer_manager_mod, only: get_number_tracers, get_tracer_index, NO_TRACER
use diag_integral_mod,  only: diag_integral_init, diag_integral_end
use diag_integral_mod,  only: diag_integral_output
use atmosphere_mod,     only: atmosphere_cell_area
use xgrid_mod,          only: grid_box_type
use atmosphere_mod,     only: atmosphere_up, atmosphere_down, atmosphere_init
use atmosphere_mod,     only: atmosphere_end, get_bottom_mass, get_bottom_wind
use atmosphere_mod,     only: atmosphere_resolution, atmosphere_domain
use atmosphere_mod,     only: atmosphere_boundary, get_atmosphere_axes
use atmosphere_mod,     only: get_stock_pe
use atmosphere_mod,     only: surf_diff_type
use atmosphere_mod,     only: atmosphere_restart
use coupler_types_mod,  only: coupler_2d_bc_type
use diag_manager_mod,   only: register_diag_field, send_data

!-----------------------------------------------------------------------

implicit none
private

public update_atmos_model_down, update_atmos_model_up
public atmos_model_init, atmos_model_end, atmos_data_type
public land_ice_atmos_boundary_type, land_atmos_boundary_type
public atm_stock_pe
public ice_atmos_boundary_type
public atmos_model_restart
public atmos_data_type_chksum
public lnd_ice_atm_bnd_type_chksum, lnd_atm_bnd_type_chksum
public ice_atm_bnd_type_chksum
!-----------------------------------------------------------------------

!<PUBLICTYPE >
 type atmos_data_type
     type (domain2d)               :: domain             ! domain decomposition
     integer                       :: axes(4)            ! axis indices (returned by diag_manager) for the atmospheric grid 
                                                         ! (they correspond to the x, y, pfull, phalf axes)
     real, pointer, dimension(:,:) :: lon_bnd  => null() ! local longitude axis grid box corners in radians.
     real, pointer, dimension(:,:) :: lat_bnd  => null() ! local latitude axis grid box corners in radians.
     real, pointer, dimension(:,:) :: t_bot    => null() ! temperature at lowest model level
     real, pointer, dimension(:,:,:) :: tr_bot   => null() ! tracers at lowest model level
     real, pointer, dimension(:,:) :: z_bot    => null() ! height above the surface for the lowest model level
     real, pointer, dimension(:,:) :: p_bot    => null() ! pressure at lowest model level
     real, pointer, dimension(:,:) :: u_bot    => null() ! zonal wind component at lowest model level
     real, pointer, dimension(:,:) :: v_bot    => null() ! meridional wind component at lowest model level
     real, pointer, dimension(:,:) :: p_surf   => null() ! surface pressure 
     real, pointer, dimension(:,:) :: slp      => null() ! sea level pressure 
     real, pointer, dimension(:,:) :: gust     => null() ! gustiness factor
     real, pointer, dimension(:,:) :: coszen   => null() ! cosine of the zenith angle
     real, pointer, dimension(:,:) :: coszen_radwt => null() ! cosine of the zenith angle, radiation weighted, Climber-2 style
     real, pointer, dimension(:,:) :: flux_sw  => null() ! net shortwave flux (W/m2) at the surface
     real, pointer, dimension(:,:) :: flux_sw_dir            =>null()
     real, pointer, dimension(:,:) :: flux_sw_dif            =>null()
     real, pointer, dimension(:,:) :: flux_sw_down_vis_dir   =>null()
     real, pointer, dimension(:,:) :: flux_sw_down_vis_dif   =>null()
     real, pointer, dimension(:,:) :: flux_sw_down_total_dir =>null()
     real, pointer, dimension(:,:) :: flux_sw_down_total_dif =>null()
     real, pointer, dimension(:,:) :: flux_sw_vis            =>null()
     real, pointer, dimension(:,:) :: flux_sw_vis_dir        =>null()
     real, pointer, dimension(:,:) :: flux_sw_vis_dif        =>null()
     real, pointer, dimension(:,:) :: flux_lw  => null() ! net longwave flux (W/m2) at the surface
     real, pointer, dimension(:,:) :: lprec    => null() ! mass of liquid precipitation since last time step (Kg/m2)
     real, pointer, dimension(:,:) :: fprec    => null() ! ass of frozen precipitation since last time step (Kg/m2)
     logical, pointer, dimension(:,:) :: maskmap =>null()! A pointer to an array indicating which
                                                         ! logical processors are actually used for
                                                         ! the ocean code. The other logical
                                                         ! processors would be all land points and
                                                         ! are not assigned to actual processors.
                                                         ! This need not be assigned if all logical
                                                         ! processors are used. This variable is dummy and need 
                                                         ! not to be set, but it is needed to pass compilation.
     type (surf_diff_type)         :: Surf_diff          ! store data needed by the multi-step version of the diffusion algorithm
     type (time_type)              :: Time               ! current time
     type (time_type)              :: Time_step          ! atmospheric time step.
     type (time_type)              :: Time_init          ! reference time.
     integer, pointer              :: pelist(:) =>null() ! pelist where atmosphere is running.
     logical                       :: pe                 ! current pe.
     type(coupler_2d_bc_type)      :: fields             ! array of fields used for additional tracers
     type(grid_box_type)           :: grid               ! hold grid information needed for 2nd order conservative flux exchange 
                                                         ! to calculate gradient on cubic sphere grid.
 end type atmos_data_type
!</PUBLICTYPE >

!<PUBLICTYPE >
type land_ice_atmos_boundary_type
   ! variables of this type are declared by coupler_main, allocated by flux_exchange_init.
!quantities going from land+ice to atmos
   real, dimension(:,:),   pointer :: t              =>null() ! surface temperature for radiation calculations
   real, dimension(:,:),   pointer :: albedo         =>null() ! surface albedo for radiation calculations
   real, dimension(:,:),   pointer :: albedo_vis_dir =>null()
   real, dimension(:,:),   pointer :: albedo_nir_dir =>null()
   real, dimension(:,:),   pointer :: albedo_vis_dif =>null()
   real, dimension(:,:),   pointer :: albedo_nir_dif =>null()
   real, dimension(:,:),   pointer :: land_frac      =>null() ! fraction amount of land in a grid box 
   real, dimension(:,:),   pointer :: dt_t           =>null() ! temperature tendency at the lowest level
   real, dimension(:,:,:), pointer :: dt_tr          =>null() ! tracer tendency at the lowest level
   real, dimension(:,:),   pointer :: u_flux         =>null() ! zonal wind stress
   real, dimension(:,:),   pointer :: v_flux         =>null() ! meridional wind stress
   real, dimension(:,:),   pointer :: dtaudu         =>null() ! derivative of zonal wind stress w.r.t. the lowest zonal level wind speed
   real, dimension(:,:),   pointer :: dtaudv         =>null() ! derivative of meridional wind stress w.r.t. the lowest meridional level wind speed
   real, dimension(:,:),   pointer :: u_star         =>null() ! friction velocity
   real, dimension(:,:),   pointer :: b_star         =>null() ! bouyancy scale
   real, dimension(:,:),   pointer :: q_star         =>null() ! moisture scale
   real, dimension(:,:),   pointer :: rough_mom      =>null() ! surface roughness (used for momentum)
   real, dimension(:,:),   pointer :: frac_open_sea  =>null() ! non-seaice fraction (%)
   real, dimension(:,:,:), pointer :: data           =>null() !collective field for "named" fields above
   integer                         :: xtype                   !REGRID, REDIST or DIRECT
end type land_ice_atmos_boundary_type
!</PUBLICTYPE >

!<PUBLICTYPE >
type :: land_atmos_boundary_type
   real, dimension(:,:), pointer :: data =>null() ! quantities going from land alone to atmos (none at present)
end type land_atmos_boundary_type
!</PUBLICTYPE >

!<PUBLICTYPE >
!quantities going from ice alone to atmos (none at present)
type :: ice_atmos_boundary_type
   real, dimension(:,:), pointer :: data =>null() ! quantities going from ice alone to atmos (none at present)
end type ice_atmos_boundary_type
!</PUBLICTYPE >

!Balaji
integer :: atmClock

!for restart
integer                 :: ipts, jpts, dto
type(restart_file_type), pointer, save :: Atm_restart => null()
type(restart_file_type), pointer, save :: Til_restart => null()
logical                                :: in_different_file = .false.


! Diagnostics For Debugging Atmosphere Output
integer :: used
!integer :: id_lon, id_lat, id_lonb, id_latb, axes
! to update_atmos_model_down
integer :: id_u_star_down, id_b_star_down, id_q_star_down, id_t, id_dtaudu, id_dtaudv, id_u_flux_in, id_v_flux_in
integer :: id_land_frac_down
integer :: id_albedo, id_albedo_vis_dir, id_albedo_nir_dir, id_albedo_vis_dif, id_albedo_nir_dif
! internal state at time of atmos_model_down
integer :: id_lprec_down, id_fprec_down
integer ::  id_t_bot_down, id_sphum_bot_down, id_co2_bot_down, id_p_bot_down, id_z_bot_down, id_p_surf_down, id_slp_down, id_u_bot_down, id_v_bot_down
! from update_atmos_model_down
integer :: id_u_flux, id_v_flux, id_gust_down
integer :: id_coszen, id_coszen_radwt, id_flux_sw, id_flux_sw_dir, id_flux_sw_dif
integer :: id_flux_sw_down_vis_dir, id_flux_sw_down_vis_dif, id_flux_sw_down_total_dir, id_flux_sw_down_total_dif
integer :: id_flux_sw_vis, id_flux_sw_vis_dir, id_flux_sw_vis_dif, id_flux_lw
integer :: id_dtmass, id_dflux_t, id_dflux_sphum, id_dflux_co2, id_delta_t, id_delta_sphum, id_delta_co2, id_delta_u, id_delta_v
! to update_atmos_model_up
integer :: id_u_star_up, id_b_star_up, id_q_star_up, id_dt_sphum, id_dt_co2, id_dt_t
integer :: id_land_frac_up
! from update_atmos_model_up
integer :: id_lprec, id_fprec, id_gust_up
integer :: id_t_bot, id_sphum_bot, id_co2_bot, id_p_bot, id_z_bot, id_p_surf, id_slp, id_u_bot, id_v_bot

!-----------------------------------------------------------------------

character(len=128) :: version = '$Id: atmos_model.F90,v 20.0 2013/12/13 23:08:05 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

integer :: ivapor = NO_TRACER ! index of water vapor tracer
integer :: ico2   = NO_TRACER ! index of CO2 tracer

!-----------------------------------------------------------------------
character(len=80) :: restart_format = 'atmos_coupled_mod restart format 01'
!-----------------------------------------------------------------------
logical           :: do_netcdf_restart = .true.
logical           :: restart_tbot_qbot = .false.
logical           :: restart_zbot_pbot = .false.
namelist /atmos_model_nml/ do_netcdf_restart, restart_tbot_qbot, restart_zbot_pbot

contains

!#######################################################################
! <SUBROUTINE NAME="update_atmos_model_down">
!
! <OVERVIEW>
!   compute the atmospheric tendencies for dynamics, radiation, 
!   vertical diffusion of momentum, tracers, and heat/moisture.
! </OVERVIEW>
!
!<DESCRIPTION>
!   Called every time step as the atmospheric driver to compute the
!   atmospheric tendencies for dynamics, radiation, vertical diffusion of
!   momentum, tracers, and heat/moisture.  For heat/moisture only the
!   downward sweep of the tridiagonal elimination is performed, hence
!   the name "_down". 
!</DESCRIPTION>

!   <TEMPLATE>
!     call  update_atmos_model_down( Surface_boundary, Atmos )
!   </TEMPLATE>

! <IN NAME = "Surface_boundary" TYPE="type(land_ice_atmos_boundary_type)">
!   Derived-type variable that contains quantities going from land+ice to atmos.  
! </IN>

! <INOUT NAME="Atmos" TYPE="type(atmos_data_type)">
!   Derived-type variable that contains fields needed by the flux exchange module.
!   These fields describe the atmospheric grid and are needed to
!   compute/exchange fluxes with other component models.  All fields in this
!   variable type are allocated for the global grid (without halo regions).
! </INOUT>

subroutine update_atmos_model_down( Surface_boundary, Atmos )
!
!-----------------------------------------------------------------------
  type(land_ice_atmos_boundary_type), intent(inout) :: Surface_boundary
  type (atmos_data_type), intent(inout) :: Atmos
                                      
!-----------------------------------------------------------------------
  call mpp_clock_begin(atmClock)

    if (id_t > 0)           used = send_data(id_t,           Surface_boundary%t,      Atmos%Time)
    if (id_albedo > 0)      used = send_data(id_albedo,      Surface_boundary%albedo, Atmos%Time)
    if (id_albedo_vis_dir > 0) used = send_data(id_albedo_vis_dir, Surface_boundary%albedo_vis_dir, Atmos%Time)
    if (id_albedo_nir_dir > 0) used = send_data(id_albedo_nir_dir, Surface_boundary%albedo_nir_dir, Atmos%Time)
    if (id_albedo_vis_dif > 0) used = send_data(id_albedo_vis_dif, Surface_boundary%albedo_vis_dif, Atmos%Time)
    if (id_albedo_nir_dif > 0) used = send_data(id_albedo_nir_dif, Surface_boundary%albedo_nir_dif, Atmos%Time)
    if (id_u_star_down > 0) used = send_data(id_u_star_down, Surface_boundary%u_star, Atmos%Time)
    if (id_b_star_down > 0) used = send_data(id_b_star_down, Surface_boundary%b_star, Atmos%Time)
    if (id_q_star_down > 0) used = send_data(id_q_star_down, Surface_boundary%q_star, Atmos%Time)
    if (id_dtaudu > 0)      used = send_data(id_dtaudu,      Surface_boundary%dtaudu, Atmos%Time)
    if (id_dtaudv > 0)      used = send_data(id_dtaudv,      Surface_boundary%dtaudv, Atmos%Time)
    if (id_u_flux_in > 0)   used = send_data(id_u_flux_in,   Surface_boundary%u_flux, Atmos%Time)
    if (id_v_flux_in > 0)   used = send_data(id_v_flux_in,   Surface_boundary%v_flux, Atmos%Time)
    if (id_land_frac_down > 0) used = send_data(id_land_frac_down, Surface_boundary%land_frac, Atmos%Time)

    if (id_lprec_down     > 0) used = send_data(id_lprec_down,     Atmos%lprec, Atmos%Time)
    if (id_fprec_down     > 0) used = send_data(id_fprec_down,     Atmos%fprec, Atmos%Time)
    if (id_t_bot_down     > 0) used = send_data(id_t_bot_down,     Atmos%t_bot,              Atmos%Time)
    if (id_sphum_bot_down > 0) used = send_data(id_sphum_bot_down, Atmos%tr_bot(:,:,ivapor), Atmos%Time)
    if (id_co2_bot_down   > 0) used = send_data(id_co2_bot_down,   Atmos%tr_bot(:,:,ico2),   Atmos%Time)
    if (id_p_bot_down     > 0) used = send_data(id_p_bot_down,     Atmos%p_bot,              Atmos%Time)
    if (id_z_bot_down     > 0) used = send_data(id_z_bot_down,     Atmos%z_bot,              Atmos%Time)
    if (id_p_surf_down    > 0) used = send_data(id_p_surf_down,    Atmos%p_surf,             Atmos%Time)
    if (id_slp_down       > 0) used = send_data(id_slp_down,       Atmos%slp,                Atmos%Time)
    if (id_u_bot_down     > 0) used = send_data(id_u_bot_down,     Atmos%u_bot,              Atmos%Time)
    if (id_v_bot_down     > 0) used = send_data(id_v_bot_down,     Atmos%v_bot,              Atmos%Time)


    call atmosphere_down (Atmos%Time, Surface_boundary%land_frac,        &
                          Surface_boundary%t,  Surface_boundary%albedo,  &
                          Surface_boundary%albedo_vis_dir,   &
                          Surface_boundary%albedo_nir_dir,   &
                          Surface_boundary%albedo_vis_dif,   &
                          Surface_boundary%albedo_nir_dif,   &
                          Surface_boundary%rough_mom,   &
                          Surface_boundary%u_star,      &
                          Surface_boundary%b_star,      &
                          Surface_boundary%q_star, &
                          Surface_boundary%dtaudu,      &
                          Surface_boundary%dtaudv,      &
                          Surface_boundary%u_flux,      &
                          Surface_boundary%v_flux,      &
                          Surface_boundary%frac_open_sea, &
                          Atmos%gust,                   &
                          Atmos%coszen,                 &
                          Atmos%coszen_radwt,           &
                          Atmos%flux_sw,                &
                          Atmos%flux_sw_dir,            &
                          Atmos%flux_sw_dif,            &
                          Atmos%flux_sw_down_vis_dir,   &
                          Atmos%flux_sw_down_vis_dif,   &
                          Atmos%flux_sw_down_total_dir, &
                          Atmos%flux_sw_down_total_dif, &
                          Atmos%flux_sw_vis,            &
                          Atmos%flux_sw_vis_dir,        &
                          Atmos%flux_sw_vis_dif,        &
                          Atmos%flux_lw,                &
                          Atmos%Surf_diff               )

!-----------------------------------------------------------------------
    if (id_u_flux > 0)                 used = send_data(id_u_flux,                 Surface_boundary%u_flux, Atmos%Time)
    if (id_v_flux > 0)                 used = send_data(id_v_flux,                 Surface_boundary%v_flux, Atmos%Time)
    if (id_gust_down > 0)              used = send_data(id_gust_down,              Atmos%gust, Atmos%Time)
    if (id_coszen > 0)                 used = send_data(id_coszen,                 Atmos%coszen, Atmos%Time)
    if (id_coszen_radwt > 0)           used = send_data(id_coszen_radwt,           Atmos%coszen_radwt, Atmos%Time)
    if (id_flux_sw > 0)                used = send_data(id_flux_sw,                Atmos%flux_sw, Atmos%Time)
    if (id_flux_sw_dir > 0)            used = send_data(id_flux_sw_dir,            Atmos%flux_sw_dir, Atmos%Time)
    if (id_flux_sw_dif > 0)            used = send_data(id_flux_sw_dif,            Atmos%flux_sw_dif, Atmos%Time)
    if (id_flux_sw_down_vis_dir > 0)   used = send_data(id_flux_sw_down_vis_dir,   Atmos%flux_sw_down_vis_dir, Atmos%Time)
    if (id_flux_sw_down_vis_dif > 0)   used = send_data(id_flux_sw_down_vis_dif,   Atmos%flux_sw_down_vis_dif, Atmos%Time)
    if (id_flux_sw_down_total_dir > 0) used = send_data(id_flux_sw_down_total_dir, Atmos%flux_sw_down_total_dir, Atmos%Time)
    if (id_flux_sw_down_total_dif > 0) used = send_data(id_flux_sw_down_total_dif, Atmos%flux_sw_down_total_dif, Atmos%Time)
    if (id_flux_sw_vis > 0)            used = send_data(id_flux_sw_vis,            Atmos%flux_sw_vis, Atmos%Time)
    if (id_flux_sw_vis_dir > 0)        used = send_data(id_flux_sw_vis_dir,        Atmos%flux_sw_vis_dir, Atmos%Time)
    if (id_flux_sw_vis_dif > 0)        used = send_data(id_flux_sw_vis_dif,        Atmos%flux_sw_vis_dif, Atmos%Time)
    if (id_flux_lw > 0)                used = send_data(id_flux_lw,                Atmos%flux_lw, Atmos%Time)
    if (id_dtmass > 0)      used = send_data(id_dtmass,      Atmos%Surf_diff%dtmass,               Atmos%Time)
    if (id_dflux_t > 0)     used = send_data(id_dflux_t,     Atmos%Surf_diff%dflux_t,              Atmos%Time)
    if (id_dflux_sphum > 0) used = send_data(id_dflux_sphum, Atmos%Surf_diff%dflux_tr(:,:,ivapor), Atmos%Time)
    if (id_dflux_co2 > 0)   used = send_data(id_dflux_co2,   Atmos%Surf_diff%dflux_tr(:,:,ico2),   Atmos%Time)
    if (id_delta_t > 0)     used = send_data(id_delta_t,     Atmos%Surf_diff%delta_t,              Atmos%Time)
    if (id_delta_sphum > 0) used = send_data(id_delta_sphum, Atmos%Surf_diff%delta_tr(:,:,ivapor), Atmos%Time)
    if (id_delta_co2   > 0) used = send_data(id_delta_co2,   Atmos%Surf_diff%delta_tr(:,:,ico2),   Atmos%Time)
    if (id_delta_u > 0)     used = send_data(id_delta_u,     Atmos%Surf_diff%delta_u,              Atmos%Time)
    if (id_delta_v > 0)     used = send_data(id_delta_v,     Atmos%Surf_diff%delta_v,              Atmos%Time)

  call mpp_clock_end(atmClock)
 end subroutine update_atmos_model_down
! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="update_atmos_model_up">
!
!-----------------------------------------------------------------------
! <OVERVIEW>
!   upward vertical diffusion of heat/moisture and moisture processes
! </OVERVIEW>

!<DESCRIPTION>
!   Called every time step as the atmospheric driver to finish the upward
!   sweep of the tridiagonal elimination for heat/moisture and compute the
!   convective and large-scale tendencies.  The atmospheric variables are
!   advanced one time step and tendencies set back to zero. 
!</DESCRIPTION>

! <TEMPLATE>
!     call  update_atmos_model_up( Surface_boundary, Atmos )
! </TEMPLATE>

! <IN NAME = "Surface_boundary" TYPE="type(land_ice_atmos_boundary_type)">
!   Derived-type variable that contains quantities going from land+ice to atmos.  
! </IN>

! <INOUT NAME="Atmos" TYPE="type(atmos_data_type)">
!   Derived-type variable that contains fields needed by the flux exchange module.
!   These fields describe the atmospheric grid and are needed to
!   compute/exchange fluxes with other component models.  All fields in this
!   variable type are allocated for the global grid (without halo regions).
! </INOUT>

 subroutine update_atmos_model_up( Surface_boundary, Atmos )

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

type(land_ice_atmos_boundary_type), intent(in) :: Surface_boundary
type (atmos_data_type), intent(inout) :: Atmos
                                      
!-----------------------------------------------------------------------
  call mpp_clock_begin(atmClock)

    if (id_u_star_up > 0) used = send_data(id_u_star_up, Surface_boundary%u_star, Atmos%Time)
    if (id_b_star_up > 0) used = send_data(id_b_star_up, Surface_boundary%b_star, Atmos%Time)
    if (id_q_star_up > 0) used = send_data(id_q_star_up, Surface_boundary%q_star, Atmos%Time)
    if (id_dt_t      > 0) used = send_data(id_dt_t,      Surface_boundary%dt_t,   Atmos%Time)
    if (id_dt_sphum  > 0) used = send_data(id_dt_sphum,  Surface_boundary%dt_tr(:,:,ivapor), Atmos%Time)
    if (id_dt_co2    > 0) used = send_data(id_dt_co2,    Surface_boundary%dt_tr(:,:,ico2),   Atmos%Time)
    if (id_land_frac_up > 0) used = send_data(id_land_frac_up, Surface_boundary%land_frac, Atmos%Time)

    Atmos%Surf_diff%delta_t = Surface_boundary%dt_t
    Atmos%Surf_diff%delta_tr = Surface_boundary%dt_tr

    call atmosphere_up (Atmos%Time,  Surface_boundary%land_frac, Atmos%Surf_diff, &
                        Atmos%lprec, Atmos%fprec, Atmos%gust, &
                        Surface_boundary%u_star, Surface_boundary%b_star, Surface_boundary%q_star)

!   --- advance time ---

    Atmos % Time = Atmos % Time + Atmos % Time_step


    call get_bottom_mass (Atmos % t_bot,  Atmos % tr_bot, &
                          Atmos % p_bot,  Atmos % z_bot,  &
                          Atmos % p_surf, Atmos % slp     )

    call get_bottom_wind (Atmos % u_bot, Atmos % v_bot)

    if (id_lprec   > 0) used = send_data(id_lprec,   Atmos%lprec, Atmos%Time)
    if (id_fprec   > 0) used = send_data(id_fprec,   Atmos%fprec, Atmos%Time)
    if (id_gust_up > 0) used = send_data(id_gust_up, Atmos%gust,  Atmos%Time)

    if (id_t_bot     > 0) used = send_data(id_t_bot,     Atmos%t_bot,              Atmos%Time)
    if (id_sphum_bot > 0) used = send_data(id_sphum_bot, Atmos%tr_bot(:,:,ivapor), Atmos%Time)
    if (id_co2_bot   > 0) used = send_data(id_co2_bot,   Atmos%tr_bot(:,:,ico2),   Atmos%Time)
    if (id_p_bot     > 0) used = send_data(id_p_bot,     Atmos%p_bot,              Atmos%Time)
    if (id_z_bot     > 0) used = send_data(id_z_bot,     Atmos%z_bot,              Atmos%Time)
    if (id_p_surf    > 0) used = send_data(id_p_surf,    Atmos%p_surf,             Atmos%Time)
    if (id_slp       > 0) used = send_data(id_slp,       Atmos%slp,                Atmos%Time)
    if (id_u_bot     > 0) used = send_data(id_u_bot,     Atmos%u_bot,              Atmos%Time)
    if (id_v_bot     > 0) used = send_data(id_v_bot,     Atmos%v_bot,              Atmos%Time)

!------ global integrals ------

    call diag_integral_output (Atmos % Time)

!-----------------------------------------------------------------------
  call mpp_clock_end(atmClock)

end subroutine update_atmos_model_up
! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="atmos_model_init">
!
! <OVERVIEW>
! Routine to initialize the atmospheric model
! </OVERVIEW>

! <DESCRIPTION>
!     This routine allocates storage and returns a variable of type
!     atmos_boundary_data_type, and also reads a namelist input and restart file. 
! </DESCRIPTION>

! <TEMPLATE>
!     call atmos_model_init (Atmos, Time_init, Time, Time_step)
! </TEMPLATE>

! <IN NAME="Time_init" TYPE="type(time_type)" >
!   The base (or initial) time of the experiment.
! </IN>

! <IN NAME="Time" TYPE="type(time_type)" >
!   The current time.
! </IN>

! <IN NAME="Time_step" TYPE="type(time_type)" >
!   The atmospheric model/physics time step.
! </IN>

! <INOUT NAME="Atmos" TYPE="type(atmos_data_type)">
!   Derived-type variable that contains fields needed by the flux exchange module.
! </INOUT>

subroutine atmos_model_init (Atmos, Time_init, Time, Time_step)


type (atmos_data_type), intent(inout) :: Atmos
type (time_type), intent(in) :: Time_init, Time, Time_step

  integer :: unit, ntrace, ntprog, ntdiag, ntfamily, i, j
  integer :: mlon, mlat, nlon, nlat, sec, day, dt
  character(len=80) :: control
  real, dimension(:,:), allocatable :: area
  integer :: ierr, io, logunit
  character(len=64) :: filename, filename2
  integer           :: id_restart
!-----------------------------------------------------------------------

!---- set the atmospheric model time ------

   Atmos % Time_init = Time_init
   Atmos % Time      = Time
   Atmos % Time_step = Time_step
   logunit = stdlog()

   IF ( file_exist('input.nml')) THEN
#ifdef INTERNAL_FILE_NML
      read(input_nml_file, nml=atmos_model_nml, iostat=io)
      ierr = check_nml_error(io, 'atmos_model_nml')
#else
      unit = open_namelist_file ( )
      ierr=1
      do while (ierr /= 0)
         read  (unit, nml=atmos_model_nml, iostat=io, end=10)
         ierr = check_nml_error(io,'atmos_model_nml')
      enddo
 10     call close_file (unit)
#endif
   endif
   call get_restart_io_mode(do_netcdf_restart)

!-----------------------------------------------------------------------
! how many tracers have been registered?
!  (will print number below)
   call get_number_tracers ( MODEL_ATMOS, ntrace, ntprog, ntdiag, ntfamily )
   if ( ntfamily > 0 ) call error_mesg ('atmos_model', 'ntfamily > 0', FATAL)
   ivapor = get_tracer_index( MODEL_ATMOS, 'sphum' )
   if (ivapor==NO_TRACER) &
        ivapor = get_tracer_index( MODEL_ATMOS, 'mix_rat' )
   if (ivapor==NO_TRACER) &
        call error_mesg('atmos_model_init', 'Cannot find water vapor in ATM tracer table', FATAL)
   ico2 = get_tracer_index( MODEL_ATMOS, 'co2' )
   if (ico2==NO_TRACER) &
        call error_mesg('atmos_model_init', 'Cannot find CO2 in ATM tracer table', NOTE)

!-----------------------------------------------------------------------
!  ----- initialize atmospheric model -----

    call atmosphere_init (Atmos%Time_init, Atmos%Time, Atmos%Time_step,&
                          Atmos%Surf_diff, Atmos%grid )
                           
!-----------------------------------------------------------------------
!---- allocate space ----

    call atmosphere_resolution (mlon, mlat, global=.true.)
    call atmosphere_resolution (nlon, nlat, global=.false.)
    call atmosphere_domain     (Atmos%domain)

    allocate ( Atmos %  lon_bnd (nlon+1,nlat+1), &
               Atmos %  lat_bnd (nlon+1,nlat+1), &
               Atmos % t_bot    (nlon,nlat), &
               Atmos % tr_bot    (nlon,nlat, ntprog), &
               Atmos % z_bot    (nlon,nlat), &
               Atmos % p_bot    (nlon,nlat), &
               Atmos % u_bot    (nlon,nlat), &
               Atmos % v_bot    (nlon,nlat), &
               Atmos % p_surf   (nlon,nlat), &
               Atmos % slp      (nlon,nlat), &
               Atmos % gust     (nlon,nlat), &
               Atmos % flux_sw  (nlon,nlat), &
               Atmos % flux_sw_dir (nlon,nlat), &
               Atmos % flux_sw_dif (nlon,nlat), &
               Atmos % flux_sw_down_vis_dir (nlon,nlat), &
               Atmos % flux_sw_down_vis_dif (nlon,nlat), &
               Atmos % flux_sw_down_total_dir (nlon,nlat), &
               Atmos % flux_sw_down_total_dif (nlon,nlat), &
               Atmos % flux_sw_vis (nlon,nlat), &
               Atmos % flux_sw_vis_dir (nlon,nlat), &
               Atmos % flux_sw_vis_dif(nlon,nlat), &
               Atmos % flux_lw  (nlon,nlat), &
               Atmos % coszen   (nlon,nlat), &
               Atmos % coszen_radwt(nlon,nlat), &
               Atmos % lprec    (nlon,nlat), &
               Atmos % fprec    (nlon,nlat)  )

    do j = 1, nlat
       do i = 1, nlon    
          Atmos % flux_sw(i,j)                 = 0.0
          Atmos % flux_lw(i,j)                 = 0.0    
          Atmos % flux_sw_dir (i,j)            = 0.0
          Atmos % flux_sw_dif (i,j)            = 0.0 
          Atmos % flux_sw_down_vis_dir (i,j)   = 0.0 
          Atmos % flux_sw_down_vis_dif (i,j)   = 0.0 
          Atmos % flux_sw_down_total_dir (i,j) = 0.0 
          Atmos % flux_sw_down_total_dif (i,j) = 0.0 
          Atmos % flux_sw_vis (i,j)            = 0.0 
          Atmos % flux_sw_vis_dir (i,j)        = 0.0 
          Atmos % flux_sw_vis_dif(i,j)         = 0.0 
          Atmos % coszen(i,j)                  = 0.0 
          Atmos % coszen_radwt(i,j)            = 0.0 
       enddo
    enddo
!-----------------------------------------------------------------------
!------ get initial state for dynamics -------

    call get_atmosphere_axes ( Atmos % axes )

    call atmosphere_boundary ( Atmos %  lon_bnd, Atmos %  lat_bnd, &
                               global=.false. )

    call get_bottom_mass (Atmos % t_bot,  Atmos % tr_bot, &
                          Atmos % p_bot,  Atmos % z_bot,  &
                          Atmos % p_surf, Atmos % slp     )

    call get_bottom_wind (Atmos % u_bot, Atmos % v_bot)

!-----------------------------------------------------------------------
!---- print version number to logfile ----

   call write_version_number(version, tagname)
!  write the namelist to a log file
   if (mpp_pe() == mpp_root_pe()) then
      unit = stdlog( )
      write (unit, nml=atmos_model_nml)
      call close_file (unit)
!  number of tracers
      write (unit, '(a,i3)') 'Number of tracers =', ntrace
      write (unit, '(a,i3)') 'Number of prognostic tracers =', ntprog
      write (unit, '(a,i3)') 'Number of diagnostic tracers =', ntdiag
   endif

!------ read initial state for several atmospheric fields ------
   filename = 'atmos_coupled.res.nc'
   call get_mosaic_tile_file(filename, filename2, .false., Atmos%domain ) 
   allocate(Atm_restart)
   if(trim(filename2) == trim(filename)) then
      Til_restart => Atm_restart
      in_different_file = .false.
      id_restart = register_restart_field(Atm_restart, filename, 'glon_bnd', ipts, domain=Atmos%domain)
      id_restart = register_restart_field(Atm_restart, filename, 'glat_bnd', jpts, domain=Atmos%domain)
      id_restart = register_restart_field(Atm_restart, filename, 'dt', dto, domain=Atmos%domain)
   else
      in_different_file = .true.
      allocate(Til_restart)
      id_restart = register_restart_field(Atm_restart, filename, 'glon_bnd', ipts, no_domain=.true.)
      id_restart = register_restart_field(Atm_restart, filename, 'glat_bnd', jpts, no_domain=.true.)
      id_restart = register_restart_field(Atm_restart, filename, 'dt', dto, no_domain=.true.)
   endif

   id_restart = register_restart_field(Til_restart, filename, 'lprec', Atmos % lprec, domain=Atmos%domain)
   id_restart = register_restart_field(Til_restart, filename, 'fprec', Atmos % fprec, domain=Atmos%domain)
   id_restart = register_restart_field(Til_restart, filename, 'gust',  Atmos % gust,  domain=Atmos%domain)
   if (restart_tbot_qbot) then
      id_restart = register_restart_field(Til_restart, filename, 't_bot', Atmos%t_bot, domain=Atmos%domain)
      id_restart = register_restart_field(Til_restart, filename, 'q_bot', Atmos%tr_bot(:,:,ivapor), domain=Atmos%domain)
   end if
   if (restart_zbot_pbot) then
      id_restart = register_restart_field(Til_restart, filename, 'z_bot', Atmos%z_bot, domain=Atmos%domain, mandatory=.false.)
      id_restart = register_restart_field(Til_restart, filename, 'p_bot', Atmos%p_bot, domain=Atmos%domain, mandatory=.false.)
   end if

   call get_time (Atmos % Time_step, sec, day)
   dt = sec + 86400*day  ! integer seconds

   filename = 'INPUT/atmos_coupled.res.nc'
   if ( file_exist(filename, domain=Atmos%domain) ) then
       if(mpp_pe() == mpp_root_pe() ) call mpp_error ('atmos_model_mod', &
                   'Reading netCDF formatted restart file: INPUT/atmos_coupled.res.nc', NOTE)
       call restore_state(Atm_restart)
       if(in_different_file)call restore_state(Til_restart)
       if (ipts /= mlon .or. jpts /= mlat) call error_mesg &
               ('coupled_atmos_init', 'incorrect resolution on restart file', WARNING)

!---- if the time step has changed then convert ----
!        tendency to conserve mass of water
       if (dto /= dt) then
          Atmos % lprec = Atmos % lprec * real(dto)/real(dt)
          Atmos % fprec = Atmos % fprec * real(dto)/real(dt)
          if (mpp_pe() == mpp_root_pe()) write (logunit,50)
       endif
   else if (file_exist('INPUT/atmos_coupled.res')) then
          if(mpp_pe() == mpp_root_pe() ) call mpp_error ('atmos_model_mod', &
                   'Reading native formatted restart file: INPUT/atmos_coupled.res', NOTE)
          unit = open_restart_file ('INPUT/atmos_coupled.res', 'read')
          !--- check version number (format) of restart file ---
          read  (unit) control
          if (trim(control) /= trim(restart_format)) call error_mesg &
               ('coupled_atmos_init', 'invalid restart format', FATAL)
          !--- check resolution and time step ---
          read  (unit) ipts,jpts,dto
          if (ipts /= mlon .or. jpts /= mlat) call error_mesg &
               ('coupled_atmos_init', 'incorrect resolution on restart file', FATAL)

          !--- read data ---
          call read_data ( unit, Atmos % lprec )
          call read_data ( unit, Atmos % fprec )
          call read_data ( unit, Atmos % gust  )
          if (restart_tbot_qbot) then
             call read_data ( unit, Atmos % t_bot  )
             call read_data ( unit, Atmos % tr_bot(:,:,ivapor) )
          endif
          if (restart_zbot_pbot) then
             call read_data ( unit, Atmos % z_bot  )
             call read_data ( unit, Atmos % p_bot  )
          endif
          call close_file (unit)

!---- if the time step has changed then convert ----
!        tendency to conserve mass of water
          if (dto /= dt) then
             Atmos % lprec = Atmos % lprec * real(dto)/real(dt)
             Atmos % fprec = Atmos % fprec * real(dto)/real(dt)
             if (mpp_pe() == mpp_root_pe()) write (logunit,50)
 50         format (/,'The model time step changed .... &
                      &modifying precipitation tendencies')
          endif
   else
        Atmos % lprec = 0.0
        Atmos % fprec = 0.0
        Atmos % gust  = 1.0
   endif

   ! to be written to restart file
   ipts = mlon
   jpts = mlat  
   dto  = dt 

!------ initialize global integral package ------
!**** TEMPORARY FIX FOR GRID CELL CORNER PROBLEM ****

    allocate (area (nlon, nlat))
! call atmosphere_cell_area to obtain array of grid cell areas needed
! by diag_integral_init
    call atmosphere_cell_area (area)
    call diag_integral_init (Atmos % Time_init, Atmos % Time,  &
                             Atmos % lon_bnd(:,:),  &
                             Atmos % lat_bnd(:,:), area)
    deallocate (area)

!-----------------------------------------------------------------------
    ! to update_atmos_model_down
    id_land_frac_down = register_diag_field('atmos_model_down_in', 'land_frac_down', Atmos%axes(1:2), Atmos%Time, 'fraction amount of land in a grid box', '1')
    id_u_star_down = register_diag_field('atmos_model_down_in', 'u_star', Atmos%axes(1:2), Atmos%Time, 'friction velocity (in)', 'unit')
    id_b_star_down = register_diag_field('atmos_model_down_in', 'b_star', Atmos%axes(1:2), Atmos%Time, 'bouyancy scale (in)', 'unit')
    id_q_star_down = register_diag_field('atmos_model_down_in', 'q_star', Atmos%axes(1:2), Atmos%Time, 'moisture scale (in)', 'unit')
    id_t = register_diag_field('atmos_model_down_in', 't', Atmos%axes(1:2), Atmos%Time, 'surface temperature (in)', 'K', 0.0)
    id_albedo = register_diag_field('atmos_model_down_in', 'albedo', Atmos%axes(1:2), Atmos%Time, 'albedo', '1', 0.0)
    id_albedo_vis_dir = register_diag_field('atmos_model_down_in', 'albedo_vis_dir', Atmos%axes(1:2), Atmos%Time, 'albedo_vis_dir', '1', 0.0)
    id_albedo_nir_dir = register_diag_field('atmos_model_down_in', 'albedo_nir_dir', Atmos%axes(1:2), Atmos%Time, 'albedo_nir_dir', '1', 0.0)
    id_albedo_vis_dif = register_diag_field('atmos_model_down_in', 'albedo_vis_dif', Atmos%axes(1:2), Atmos%Time, 'albedo_vis_dif', '1', 0.0)
    id_albedo_nir_dif = register_diag_field('atmos_model_down_in', 'albedo_nir_dif', Atmos%axes(1:2), Atmos%Time, 'albedo_nir_dif', '1', 0.0)
    id_dtaudu = register_diag_field('atmos_model_down_in', 'dtaudu', Atmos%axes(1:2), Atmos%Time, 'derivative of zonal wind stress w.r.t. the lowest zonal level wind speed (in)', 'unit')
    id_dtaudv = register_diag_field('atmos_model_down_in', 'dtaudv', Atmos%axes(1:2), Atmos%Time, 'derivative of meridional wind stress w.r.t. the lowest meridional level wind speed (in)', 'unit')
    id_u_flux_in = register_diag_field('atmos_model_down_in', 'u_flux_in', Atmos%axes(1:2), Atmos%Time, 'zonal wind stress (in)', 'pa')
    id_v_flux_in = register_diag_field('atmos_model_down_in', 'v_flux_in', Atmos%axes(1:2), Atmos%Time, 'meridional wind stress (in)', 'pa')
    ! internal state of atmosphere, was copied to Atmos structure in previous get_bottom_XXX invocations during init or update_atmos_model_up
    ! they are repeated here for easier synopsis with input/output variables
    id_lprec_down = register_diag_field('atmos_model_down', 'lprec', Atmos%axes(1:2), Atmos%Time, 'mass of liquid precipitation since last time step (internal)', 'kg/m2')
    id_fprec_down = register_diag_field('atmos_model_down', 'fprec', Atmos%axes(1:2), Atmos%Time, 'mass of frozen precipitation since last time step (internal)', 'kg/m2')
    id_t_bot_down = register_diag_field('atmos_model_down', 't_bot', Atmos%axes(1:2), Atmos%Time, 'temperature at lowest model level (internal)', 'K', 0.0)
    id_sphum_bot_down = register_diag_field('atmos_model_down', 'tr_sphum_bot', Atmos%axes(1:2), Atmos%Time, 'specific humidity (tracer) at lowest model level (internal)', 'kg/kg(?)')
    if (ico2 /= NO_TRACER) then
       id_co2_bot_down = register_diag_field('atmos_model_down', 'tr_co2_bot', Atmos%axes(1:2), Atmos%Time, 'co2 (tracer) at lowest model level (internal)', 'kg/kg wet air(?)')
    else
       id_co2_bot_down = -1
    endif
    id_p_bot_down = register_diag_field('atmos_model_down', 'p_bot', Atmos%axes(1:2), Atmos%Time, 'pressure at lowest model level (internal)', 'pa')
    id_z_bot_down = register_diag_field('atmos_model_down', 'z_bot', Atmos%axes(1:2), Atmos%Time, 'height above the surface for the lowest model level (out)', 'm')
    id_p_surf_down = register_diag_field('atmos_model_down', 'p_surf', Atmos%axes(1:2), Atmos%Time, 'surface pressure (internal)', 'unit')
    id_slp_down = register_diag_field('atmos_model_down', 'slp', Atmos%axes(1:2), Atmos%Time, 'sea level pressure (internal)', 'pa')
    id_u_bot_down = register_diag_field('atmos_model_down', 'u_bot', Atmos%axes(1:2), Atmos%Time, 'zonal wind component at lowest model level (internal)', 'unit')
    id_v_bot_down = register_diag_field('atmos_model_down', 'v_bot', Atmos%axes(1:2), Atmos%Time, 'meridional wind component at lowest model level (internal)', 'unit')
    ! from update_atmos_model_down
    id_u_flux = register_diag_field('atmos_model_down', 'u_flux', Atmos%axes(1:2), Atmos%Time, 'zonal wind stress (out)', 'pa')
    id_v_flux = register_diag_field('atmos_model_down', 'v_flux', Atmos%axes(1:2), Atmos%Time, 'meridional wind stress (out)', 'pa')
    id_gust_down = register_diag_field('atmos_model_down', 'gust', Atmos%axes(1:2), Atmos%Time, 'gustiness factor (downward) (out)', '')
    id_coszen = register_diag_field('atmos_model_down', 'coszen', Atmos%axes(1:2), Atmos%Time, 'cosine of the zenith angle (out)', '')
    id_coszen_radwt = register_diag_field('atmos_model_down', 'coszen_radwt', Atmos%axes(1:2), Atmos%Time, 'cosine of the zenith angle radiation-weighted (out)', '')
    id_flux_sw = register_diag_field('atmos_model_down', 'flux_sw', Atmos%axes(1:2), Atmos%Time, 'net shortwave flux at the surface (out)', 'W/m2')
    id_flux_sw_dir = register_diag_field('atmos_model_down', 'flux_sw_dir', Atmos%axes(1:2), Atmos%Time, 'flux_sw_dir (out)', 'W/m2')
    id_flux_sw_dif = register_diag_field('atmos_model_down', 'flux_sw_dif', Atmos%axes(1:2), Atmos%Time, 'flux_sw_dif (out)', 'W/m2')
    id_flux_sw_down_vis_dir = register_diag_field('atmos_model_down', 'flux_sw_down_vis_dir', Atmos%axes(1:2), Atmos%Time, 'flux_sw_down_vis_dir (out)', 'W/m2')
    id_flux_sw_down_vis_dif = register_diag_field('atmos_model_down', 'flux_sw_down_vis_dif', Atmos%axes(1:2), Atmos%Time, 'flux_sw_down_vis_dif (out)', 'W/m2')
    id_flux_sw_down_total_dir = register_diag_field('atmos_model_down', 'flux_sw_down_total_dir', Atmos%axes(1:2), Atmos%Time, 'flux_sw_down_total_dir (out)', 'W/m2')
    id_flux_sw_down_total_dif = register_diag_field('atmos_model_down', 'flux_sw_down_total_dif', Atmos%axes(1:2), Atmos%Time, 'flux_sw_down_total_dif (out)', 'W/m2')
    id_flux_sw_vis = register_diag_field('atmos_model_down', 'flux_sw_vis', Atmos%axes(1:2), Atmos%Time, 'flux_sw_vis (out)', 'W/m2')
    id_flux_sw_vis_dir = register_diag_field('atmos_model_down', 'flux_sw_vis_dir', Atmos%axes(1:2), Atmos%Time, 'flux_sw_vis_dir (out)', 'W/m2')
    id_flux_sw_vis_dif = register_diag_field('atmos_model_down', 'flux_sw_vis_dif', Atmos%axes(1:2), Atmos%Time, 'flux_sw_vis_dif (out)', 'W/m2')
    id_flux_lw = register_diag_field('atmos_model_down', 'flux_lw', Atmos%axes(1:2), Atmos%Time, 'downward (FMS says net) longwave flux at the surface (out)', 'W/m2')
    id_dtmass = register_diag_field('atmos_model_down', 'dtmass', Atmos%axes(1:2), Atmos%Time, 'dtmass longname (out)', 'unit')
    id_dflux_t = register_diag_field('atmos_model_down', 'dflux_t', Atmos%axes(1:2), Atmos%Time, 'derivative of implicit part of downward temperature flux  at the top of the lowest atmospheric layer (out)', 'J/(m2 K)')
    id_dflux_sphum = register_diag_field('atmos_model_down', 'dflux_tr_sphum', Atmos%axes(1:2), Atmos%Time, 'derivative of implicit part of downward flux of specific humidity at the top of the lowest atmospheric layer (out)', 'kg/(m2 s)')
    if (ico2 /= NO_TRACER) then
       id_dflux_co2 = register_diag_field('atmos_model_down', 'dflux_tr_co2', Atmos%axes(1:2), Atmos%Time, 'derivative of implicit part of downward flux of co2 at the top of the lowest atmospheric layer (out)', 'kg/(m2 s)?')
    else
       id_dflux_co2 = -1
    end if
    id_delta_t = register_diag_field('atmos_model_down', 'delta_t', Atmos%axes(1:2), Atmos%Time, 'increment in temperature in the lowest atmospheric layer (out)', 'K')
    id_delta_sphum = register_diag_field('atmos_model_down', 'delta_tr_sphum', Atmos%axes(1:2), Atmos%Time, 'increment in specific humidity (tracer) in the lowest atmospheric layer (out)', 'kg/kg')
    if (ico2 /= NO_TRACER) then
       id_delta_co2 = register_diag_field('atmos_model_down', 'delta_tr_co2', Atmos%axes(1:2), Atmos%Time, 'increment in co2 (tracer) in the lowest atmospheric layer (out)', 'kg/kg?')
    else
       id_delta_co2 = -1
    end if
    id_delta_u = register_diag_field('atmos_model_down', 'delta_u', Atmos%axes(1:2), Atmos%Time, 'delta_u (out)', 'unit')
    id_delta_v = register_diag_field('atmos_model_down', 'delta_v', Atmos%axes(1:2), Atmos%Time, 'delta_v (out)', 'unit')
    ! to update_atmos_model_up
    id_land_frac_up = register_diag_field('atmos_model_up_in', 'land_frac_up', Atmos%axes(1:2), Atmos%Time, 'fraction amount of land in a grid box', '1')
    id_u_star_up = register_diag_field('atmos_model_up_in', 'u_star', Atmos%axes(1:2), Atmos%Time, 'friction velocity (in)', 'unit')
    id_b_star_up = register_diag_field('atmos_model_up_in', 'b_star', Atmos%axes(1:2), Atmos%Time, 'bouyancy scale (in)', 'unit')
    id_q_star_up = register_diag_field('atmos_model_up_in', 'q_star', Atmos%axes(1:2), Atmos%Time, 'moisture scale (in)', 'unit')
    id_dt_t = register_diag_field('atmos_model_up_in', 'dt_t', Atmos%axes(1:2), Atmos%Time, 'increment in temperature in the lowest atmospheric layer (in)', 'K')
    id_dt_sphum = register_diag_field('atmos_model_up_in', 'dt_tr_sphum', Atmos%axes(1:2), Atmos%Time, 'increment in specific humidity (tracer) in the lowest atmospheric layer (in)', 'kg/kg')
    if (ico2 /= NO_TRACER) then
       id_dt_co2 = register_diag_field('atmos_model_up_in', 'dt_tr_co2', Atmos%axes(1:2), Atmos%Time, 'increment in co2 (tracer) in the lowest atmospheric layer (in)', 'kg/kg?')
    else
       id_dt_co2 = -1
    end if
    ! from update_atmos_model_up
    id_lprec = register_diag_field('atmos_model_up', 'lprec', Atmos%axes(1:2), Atmos%Time, 'mass of liquid precipitation since last time step (out)', 'kg/m2')
    id_fprec = register_diag_field('atmos_model_up', 'fprec', Atmos%axes(1:2), Atmos%Time, 'mass of frozen precipitation since last time step (out)', 'kg/m2')
    id_gust_up = register_diag_field('atmos_model_up', 'gust_up', Atmos%axes(1:2), Atmos%Time, 'gustiness factor (upward) (out)', 'm/s')
    id_t_bot = register_diag_field('atmos_model_up', 't_bot', Atmos%axes(1:2), Atmos%Time, 'temperature at lowest model level (out)', 'K', 0.0)
    id_sphum_bot = register_diag_field('atmos_model_up', 'tr_sphum_bot', Atmos%axes(1:2), Atmos%Time, 'specific humidity (tracer) at lowest model level (out)', 'kg/kg?')
    if (ico2 /= NO_TRACER) then
       id_co2_bot = register_diag_field('atmos_model_up', 'tr_co2_bot', Atmos%axes(1:2), Atmos%Time, 'co2 (tracer) at lowest model level (out)', 'kg/kg wet air?')
    else
       id_co2_bot = -1
    end if
    id_p_bot = register_diag_field('atmos_model_up', 'p_bot', Atmos%axes(1:2), Atmos%Time, 'pressure at lowest model level (out)', 'pa')
    id_z_bot = register_diag_field('atmos_model_up', 'z_bot', Atmos%axes(1:2), Atmos%Time, 'height above the surface for the lowest model level (out)', 'm')
    id_p_surf = register_diag_field('atmos_model_up', 'p_surf', Atmos%axes(1:2), Atmos%Time, 'surface pressure (out)', 'unit')
    id_slp = register_diag_field('atmos_model_up', 'slp', Atmos%axes(1:2), Atmos%Time, 'sea level pressure (out)', 'pa')
    id_u_bot = register_diag_field('atmos_model_up', 'u_bot', Atmos%axes(1:2), Atmos%Time, 'zonal wind component at lowest model level (out)', 'unit')
    id_v_bot = register_diag_field('atmos_model_up', 'v_bot', Atmos%axes(1:2), Atmos%Time, 'meridional wind component at lowest model level (out)', 'unit')


    call atmos_data_type_chksum('atmos_model_init',0,Atmos)
!-----------------------------------------------------------------------
atmClock = mpp_clock_id( 'Atmosphere', flags=clock_flag_default, grain=CLOCK_COMPONENT )
end subroutine atmos_model_init
! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="atmos_model_end">
!
! <OVERVIEW>
!  termination routine for atmospheric model
! </OVERVIEW>

! <DESCRIPTION>
!  Call once to terminate this module and any other modules used.
!  This routine writes a restart file and deallocates storage
!  used by the derived-type variable atmos_boundary_data_type.
! </DESCRIPTION>

! <TEMPLATE>
!   call atmos_model_end (Atmos)
! </TEMPLATE>

! <INOUT NAME="Atmos" TYPE="type(atmos_data_type)">
!   Derived-type variable that contains fields needed by the flux exchange module.
! </INOUT>

subroutine atmos_model_end (Atmos)

type (atmos_data_type), intent(inout) :: Atmos

!-----------------------------------------------------------------------
!---- termination routine for atmospheric model ----
                                              
  call atmosphere_end (Atmos % Time, Atmos%grid)

!------ global integrals ------

  call diag_integral_end (Atmos % Time)

!------ write several atmospheric fields ------
!        also resolution and time step
  call atmos_model_local_restart(Atmos)

!-------- deallocate space --------

  deallocate ( Atmos %  lon_bnd , &
               Atmos %  lat_bnd , &
               Atmos % t_bot    , &
               Atmos % tr_bot   , &
               Atmos % z_bot    , &
               Atmos % p_bot    , &
               Atmos % u_bot    , &
               Atmos % v_bot    , &
               Atmos % p_surf   , &
               Atmos % slp      , &
               Atmos % gust     , &
               Atmos % flux_sw  , &
               Atmos % flux_sw_dir  , &
               Atmos % flux_sw_dif  , &
               Atmos % flux_sw_down_vis_dir  , &
               Atmos % flux_sw_down_vis_dif  , &
               Atmos % flux_sw_down_total_dir  , &
               Atmos % flux_sw_down_total_dif  , &
               Atmos % flux_sw_vis  , &
               Atmos % flux_sw_vis_dir  , &
               Atmos % flux_sw_vis_dif  , &
               Atmos % flux_lw  , &
               Atmos % coszen   , &
               Atmos % coszen_radwt, &
               Atmos % lprec    , &
               Atmos % fprec      )

!-----------------------------------------------------------------------

end subroutine atmos_model_end
! </SUBROUTINE>
  !#######################################################################
  ! <SUBROUTINE NAME="atmos_model_restart">
  ! <DESCRIPTION>
  !  Write out restart files registered through register_restart_file
  ! </DESCRIPTION>
  subroutine atmos_model_restart(Atmos, timestamp)
    type (atmos_data_type),   intent(inout) :: Atmos
    character(len=*),  intent(in)           :: timestamp

    call atmosphere_restart(timestamp)
    call atmos_model_local_restart(Atmos, timestamp)

  end subroutine atmos_model_restart
  ! </SUBROUTINE>

  !#######################################################################
  ! <SUBROUTINE NAME="atmos_model_local_restart">
  ! <DESCRIPTION>
  !  Write out restart files registered through register_restart_file
  ! </DESCRIPTION>
  subroutine atmos_model_local_restart(Atmos, timestamp)
    type (atmos_data_type),   intent(inout) :: Atmos
    character(len=*),  intent(in), optional :: timestamp
    integer :: unit
    if( do_netcdf_restart) then
       if(mpp_pe() == mpp_root_pe()) then
          call mpp_error ('atmos_model_mod', 'Writing netCDF formatted restart file.', NOTE)
       endif
       call save_restart(Atm_restart, timestamp)
       if(in_different_file) call save_restart(Til_restart, timestamp)
    else
       if(present(timestamp)) call mpp_error ('atmos_model_mod',  &
            'intermediate restart capability is not implemented for non-netcdf file', FATAL)
       unit = open_restart_file ('RESTART/atmos_coupled.res', 'write')
       if (mpp_pe() == mpp_root_pe()) then
          write (unit) restart_format
          write (unit) ipts, jpts, dto
       endif
       call write_data ( unit, Atmos % lprec )
       call write_data ( unit, Atmos % fprec )
       call write_data ( unit, Atmos % gust  )
       if(restart_tbot_qbot) then
          call write_data ( unit, Atmos % t_bot  )
          call write_data ( unit, Atmos % tr_bot(:,:,ivapor)  )
       endif
       if(restart_zbot_pbot) then
          call write_data ( unit, Atmos % z_bot  )
          call write_data ( unit, Atmos % p_bot  )
       endif
       call close_file (unit)
    endif

    call atmos_data_type_chksum('atmos_model_local_restart',0,Atmos)

  end subroutine atmos_model_local_restart
  ! </SUBROUTINE>
!#######################################################################
! <SUBROUTINE NAME="atm_stock_pe">
!
! <OVERVIEW>
!  returns the total stock in atmospheric model
! </OVERVIEW>

! <DESCRIPTION>
!  Called to compute and return the total stock (e.g., water, heat, etc.)
! in the atmospheric on the current PE.
! </DESCRIPTION>

! <TEMPLATE>
!   call atm_stock_pe (Atmos, index, value)
! </TEMPLATE>

! <INOUT NAME="Atm" TYPE="type(atmos_data_type)">
!   Derived-type variable that contains fields needed by the flux exchange module.
! </INOUT>
!
! <IN NAME="index" TYPE="integer">
!   Index of stock to be computed.
! </IN>
!
! <OUT NAME="value" TYPE="real">
!   Value of stock on the current processor.
! </OUT>

subroutine atm_stock_pe (Atm, index, value)

type (atmos_data_type), intent(inout) :: Atm
integer,                intent(in)    :: index
real,                   intent(out)   :: value

   value = 0.0
   if(Atm%pe) call get_stock_pe (index, value)

end subroutine atm_stock_pe

! </SUBROUTINE>

!#######################################################################
!#######################################################################
! <SUBROUTINE NAME="atmos_data_type_chksum">
!
! <OVERVIEW>
!  Print checksums of the various fields in the atmos_data_type.
! </OVERVIEW>

! <DESCRIPTION>
!  Routine to print checksums of the various fields in the atmos_data_type.
! </DESCRIPTION>

! <TEMPLATE>
!   call atmos_data_type_chksum(id, timestep, atm)
! </TEMPLATE>

! <IN NAME="Atm" TYPE="type(atmos_data_type)">
!   Derived-type variable that contains fields in the atmos_data_type.
! </INOUT>
!
! <IN NAME="id" TYPE="character">
!   Label to differentiate where this routine in being called from.
! </IN>
!
! <IN NAME="timestep" TYPE="integer">
!   An integer to indicate which timestep this routine is being called for.
! </IN>
!
subroutine atmos_data_type_chksum(id, timestep, atm)
type(atmos_data_type), intent(in) :: atm 
    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    integer :: n, outunit

100 format("CHECKSUM::",A32," = ",Z20)
101 format("CHECKSUM::",A16,a,'%',a," = ",Z20)

  outunit = stdout()
  write(outunit,*) 'BEGIN CHECKSUM(Atmos_data_type):: ', id, timestep
  write(outunit,100) ' atm%lon_bnd                ', mpp_chksum(atm%lon_bnd               )
  write(outunit,100) ' atm%lat_bnd                ', mpp_chksum(atm%lat_bnd               )
  write(outunit,100) ' atm%t_bot                  ', mpp_chksum(atm%t_bot                 )
  do n = 1, size(atm%tr_bot,3)
  write(outunit,100) ' atm%tr_bot(:,:,n)          ', mpp_chksum(atm%tr_bot(:,:,n)         )
  enddo
  write(outunit,100) ' atm%z_bot                  ', mpp_chksum(atm%z_bot                 )
  write(outunit,100) ' atm%p_bot                  ', mpp_chksum(atm%p_bot                 )
  write(outunit,100) ' atm%u_bot                  ', mpp_chksum(atm%u_bot                 )
  write(outunit,100) ' atm%v_bot                  ', mpp_chksum(atm%v_bot                 )
  write(outunit,100) ' atm%p_surf                 ', mpp_chksum(atm%p_surf                )
  write(outunit,100) ' atm%slp                    ', mpp_chksum(atm%slp                   )
  write(outunit,100) ' atm%gust                   ', mpp_chksum(atm%gust                  )
  write(outunit,100) ' atm%coszen                 ', mpp_chksum(atm%coszen                )
  write(outunit,100) ' atm%coszen_radwt           ', mpp_chksum(atm%coszen_radwt          )
  write(outunit,100) ' atm%flux_sw                ', mpp_chksum(atm%flux_sw               )
  write(outunit,100) ' atm%flux_sw_dir            ', mpp_chksum(atm%flux_sw_dir           )
  write(outunit,100) ' atm%flux_sw_dif            ', mpp_chksum(atm%flux_sw_dif           )
  write(outunit,100) ' atm%flux_sw_down_vis_dir   ', mpp_chksum(atm%flux_sw_down_vis_dir  )
  write(outunit,100) ' atm%flux_sw_down_vis_dif   ', mpp_chksum(atm%flux_sw_down_vis_dif  )
  write(outunit,100) ' atm%flux_sw_down_total_dir ', mpp_chksum(atm%flux_sw_down_total_dir)
  write(outunit,100) ' atm%flux_sw_down_total_dif ', mpp_chksum(atm%flux_sw_down_total_dif)
  write(outunit,100) ' atm%flux_sw_vis            ', mpp_chksum(atm%flux_sw_vis           )
  write(outunit,100) ' atm%flux_sw_vis_dir        ', mpp_chksum(atm%flux_sw_vis_dir       )
  write(outunit,100) ' atm%flux_sw_vis_dif        ', mpp_chksum(atm%flux_sw_vis_dif       )
  write(outunit,100) ' atm%flux_lw                ', mpp_chksum(atm%flux_lw               )
  write(outunit,100) ' atm%lprec                  ', mpp_chksum(atm%lprec                 )
  write(outunit,100) ' atm%fprec                  ', mpp_chksum(atm%fprec                 )
!  call surf_diff_type_chksum(id, timestep, atm%surf_diff)

end subroutine atmos_data_type_chksum

! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="lnd_ice_atm_bnd_type_chksum">
!
! <OVERVIEW>
!  Print checksums of the various fields in the land_ice_atmos_boundary_type.
! </OVERVIEW>

! <DESCRIPTION>
!  Routine to print checksums of the various fields in the land_ice_atmos_boundary_type.
! </DESCRIPTION>

! <TEMPLATE>
!   call atmos_data_type_chksum(id, timestep, bnd_type)
! </TEMPLATE>

! <IN NAME="bnd_type" TYPE="type(land_ice_atmos_boundary_type)">
!   Derived-type variable that contains fields in the land_ice_atmos_boundary_type.
! </INOUT>
!
! <IN NAME="id" TYPE="character">
!   Label to differentiate where this routine in being called from.
! </IN>
!
! <IN NAME="timestep" TYPE="integer">
!   An integer to indicate which timestep this routine is being called for.
! </IN>
!


subroutine lnd_ice_atm_bnd_type_chksum(id, timestep, bnd_type)

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(land_ice_atmos_boundary_type), intent(in) :: bnd_type
 integer ::   n, outunit

    outunit = stdout()
    write(outunit,*) 'BEGIN CHECKSUM(lnd_ice_Atm_bnd_type):: ', id, timestep
100 format("CHECKSUM::",A32," = ",Z20)
    write(outunit,100) 'lnd_ice_atm_bnd_type%t             ',mpp_chksum(bnd_type%t              )
    write(outunit,100) 'lnd_ice_atm_bnd_type%albedo        ',mpp_chksum(bnd_type%albedo         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%albedo_vis_dir',mpp_chksum(bnd_type%albedo_vis_dir )
    write(outunit,100) 'lnd_ice_atm_bnd_type%albedo_nir_dir',mpp_chksum(bnd_type%albedo_nir_dir )
    write(outunit,100) 'lnd_ice_atm_bnd_type%albedo_vis_dif',mpp_chksum(bnd_type%albedo_vis_dif )
    write(outunit,100) 'lnd_ice_atm_bnd_type%albedo_nir_dif',mpp_chksum(bnd_type%albedo_nir_dif )
    write(outunit,100) 'lnd_ice_atm_bnd_type%land_frac     ',mpp_chksum(bnd_type%land_frac      )
    write(outunit,100) 'lnd_ice_atm_bnd_type%dt_t          ',mpp_chksum(bnd_type%dt_t           )
    do n = 1, size(bnd_type%dt_tr,3)
    write(outunit,100) 'lnd_ice_atm_bnd_type%dt_tr(:,:,n)  ',mpp_chksum(bnd_type%dt_tr(:,:,n)   )
    enddo
    write(outunit,100) 'lnd_ice_atm_bnd_type%u_flux        ',mpp_chksum(bnd_type%u_flux         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%v_flux        ',mpp_chksum(bnd_type%v_flux         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%dtaudu        ',mpp_chksum(bnd_type%dtaudu         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%dtaudv        ',mpp_chksum(bnd_type%dtaudv         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%u_star        ',mpp_chksum(bnd_type%u_star         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%b_star        ',mpp_chksum(bnd_type%b_star         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%q_star        ',mpp_chksum(bnd_type%q_star         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%rough_mom     ',mpp_chksum(bnd_type%rough_mom      )
!    write(outunit,100) 'lnd_ice_atm_bnd_type%data          ',mpp_chksum(bnd_type%data           )

end subroutine lnd_ice_atm_bnd_type_chksum
! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="lnd_atm_bnd_type_chksum">
!
! <OVERVIEW>
!  Print checksums of the various fields in the land_atmos_boundary_type.
! </OVERVIEW>

! <DESCRIPTION>
!  Routine to print checksums of the various fields in the land_atmos_boundary_type.
! </DESCRIPTION>

! <TEMPLATE>
!   call lnd_atm_bnd_type_chksum(id, timestep, bnd_type)
! </TEMPLATE>

! <IN NAME="bnd_type" TYPE="type(land_atmos_boundary_type)">
!   Derived-type variable that contains fields in the land_atmos_boundary_type.
! </INOUT>
!
! <IN NAME="id" TYPE="character">
!   Label to differentiate where this routine in being called from.
! </IN>
!
! <IN NAME="timestep" TYPE="integer">
!   An integer to indicate which timestep this routine is being called for.
! </IN>
!


subroutine lnd_atm_bnd_type_chksum(id, timestep, bnd_type)
  use fms_mod,                 only: stdout
  use mpp_mod,                 only: mpp_chksum

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(land_atmos_boundary_type), intent(in) :: bnd_type
 integer ::   n, outunit

    outunit = stdout()
    write(outunit,*) 'BEGIN CHECKSUM(lnd_atmos_boundary_type):: ', id, timestep
!    write(outunit,100) 'lnd_atm_bnd_type%data',mpp_chksum(bnd_type%data)

100 format("CHECKSUM::",A32," = ",Z20)

end subroutine lnd_atm_bnd_type_chksum
! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="ice_atm_bnd_type_chksum">
!
! <OVERVIEW>
!  Print checksums of the various fields in the ice_atmos_boundary_type.
! </OVERVIEW>

! <DESCRIPTION>
!  Routine to print checksums of the various fields in the ice_atmos_boundary_type.
! </DESCRIPTION>

! <TEMPLATE>
!   call ice_atm_bnd_type_chksum(id, timestep, bnd_type)
! </TEMPLATE>

! <IN NAME="bnd_type" TYPE="type(ice_atmos_boundary_type)">
!   Derived-type variable that contains fields in the ice_atmos_boundary_type.
! </INOUT>
!
! <IN NAME="id" TYPE="character">
!   Label to differentiate where this routine in being called from.
! </IN>
!
! <IN NAME="timestep" TYPE="integer">
!   An integer to indicate which timestep this routine is being called for.
! </IN>
!


subroutine ice_atm_bnd_type_chksum(id, timestep, bnd_type)
  use fms_mod,                 only: stdout
  use mpp_mod,                 only: mpp_chksum

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(ice_atmos_boundary_type), intent(in) :: bnd_type
 integer ::   n, outunit

    outunit = stdout()
    write(outunit,*) 'BEGIN CHECKSUM(ice_atmos_boundary_type):: ', id, timestep
!    write(outunit,100) 'ice_atm_bnd_type%data',mpp_chksum(data_type%data)

100 format("CHECKSUM::",A32," = ",Z20)


end subroutine ice_atm_bnd_type_chksum
! </SUBROUTINE>


end module atmos_model_mod

module spectral_damping_mod

use        fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, &
                          write_version_number

use transforms_mod, only: get_eigen_laplacian, get_spec_domain

implicit none

private

interface compute_spectral_damping
   module procedure  compute_spectral_damping_2d, compute_spectral_damping_3d 
end interface

real, allocatable, dimension(:,:) :: damping, damping_vor, damping_div, damping_eddy_sponge
real, allocatable, dimension(:)   :: damping_zmu_sponge, damping_zmv_sponge
logical :: module_is_initialized = .false.
integer :: ms, me, ns, ne, num_levels

character(len=128), parameter :: version = '$Id: spectral_damping.F90,v 17.0 2009/07/21 03:00:53 fms Exp $'
character(len=128), parameter :: tagname = '$Name: tikal $'

public :: spectral_damping_init, spectral_damping_end, compute_spectral_damping
public :: compute_spectral_damping_vor, compute_spectral_damping_div

contains
!----------------------------------------------------------------------------------------------------------------
subroutine spectral_damping_init (damping_coeff, damping_order, damping_option, num_fourier, num_spherical, &
                                  num_levels_in, eddy_sponge_coeff, zmu_sponge_coeff, zmv_sponge_coeff,     &
                                  damping_coeff_vor, damping_order_vor, damping_coeff_div, damping_order_div, &
                                  damping_coeff_r)

real,    intent(in) :: damping_coeff
integer, intent(in) :: damping_order, num_fourier, num_spherical, num_levels_in
real,    intent(in) :: eddy_sponge_coeff, zmu_sponge_coeff, zmv_sponge_coeff
character(len=*), intent(in) :: damping_option
real,    intent(in), optional :: damping_coeff_vor, damping_coeff_div
integer, intent(in), optional :: damping_order_vor, damping_order_div
real,    intent(in), optional :: damping_coeff_r ! linear drag coefficient (units = 1/seconds)

real    :: damping_coeff_vor_local, damping_coeff_div_local
integer :: damping_order_vor_local, damping_order_div_local
real, dimension(0:num_fourier, 0:num_spherical) :: eigen

if(module_is_initialized) return

call write_version_number(version, tagname)
num_levels = num_levels_in

call get_spec_domain(ms, me, ns, ne)

allocate(damping_zmu_sponge(0:num_spherical))
allocate(damping_zmv_sponge(0:num_spherical))
allocate(damping_eddy_sponge(0:num_fourier, 0:num_spherical))
allocate(damping    (0:num_fourier, 0:num_spherical))
allocate(damping_vor(0:num_fourier, 0:num_spherical))
allocate(damping_div(0:num_fourier, 0:num_spherical))

call get_eigen_laplacian(eigen)

if(present(damping_coeff_vor)) then
  damping_coeff_vor_local = damping_coeff_vor
else
  damping_coeff_vor_local = damping_coeff
endif

if(present(damping_coeff_div)) then
  damping_coeff_div_local = damping_coeff_div
else
  damping_coeff_div_local = damping_coeff
endif

if(present(damping_order_vor)) then
  damping_order_vor_local = damping_order_vor
else
  damping_order_vor_local = damping_order
endif

if(present(damping_order_div)) then
  damping_order_div_local = damping_order_div
else
  damping_order_div_local = damping_order
endif

if(trim(damping_option) == 'resolution_dependent') then
  damping    (:,:) = damping_coeff          *((eigen(:,:)/eigen(0,num_spherical-1))**damping_order          )
  damping_vor(:,:) = damping_coeff_vor_local*((eigen(:,:)/eigen(0,num_spherical-1))**damping_order_vor_local)
  damping_div(:,:) = damping_coeff_div_local*((eigen(:,:)/eigen(0,num_spherical-1))**damping_order_div_local)
else if(trim(damping_option) == 'resolution_independent') then
  damping    (:,:) = damping_coeff          *(eigen(:,:)**damping_order          )
  damping_vor(:,:) = damping_coeff_vor_local*(eigen(:,:)**damping_order_vor_local)
  damping_div(:,:) = damping_coeff_div_local*(eigen(:,:)**damping_order_div_local)
else
  call error_mesg('spectral_damping_init','"'//trim(damping_option)//'" is an invalid value for damping_option', FATAL)
end if

if(present(damping_coeff_r)) then
  damping(:,:) = damping(:,:) + damping_coeff_r
endif

damping_zmu_sponge  =  zmu_sponge_coeff*eigen(0,:)
damping_zmv_sponge  =  zmv_sponge_coeff*eigen(0,:)
damping_eddy_sponge = eddy_sponge_coeff*eigen

module_is_initialized = .true.

return
end subroutine spectral_damping_init

!-----------------------------------------------------------------
!compute_spectral_damping_3d is local
subroutine compute_spectral_damping_3d(spec, dt_spec, current_dt)  

complex, intent(in), dimension(:,:,:) :: spec
real,    intent(in) :: current_dt
complex, intent(inout), dimension (:,:,:) :: dt_spec

real, dimension(size(spec,1),size(spec,2)) :: coeff

integer :: k

if(.not.module_is_initialized) then
  call error_mesg('compute_spectral_damping','initialization of spectral_damping not performed', FATAL)
end if

coeff = 1.0/(1.0 + damping(ms:me,ns:ne)*current_dt)

do k = 1, size(spec,3)
  dt_spec(:,:,k) =   coeff(:,:) * (dt_spec(:,:,k) - damping(ms:me,ns:ne)*spec(:,:,k))
end do

return
end subroutine compute_spectral_damping_3d
!-----------------------------------------------------------------
subroutine compute_spectral_damping_vor(vor, dt_vor, current_dt)

complex, intent(in), dimension(ms:me, ns:ne, num_levels) :: vor
real,    intent(in) :: current_dt
complex, intent(inout), dimension(ms:me, ns:ne, num_levels) :: dt_vor

real, dimension(ms:me, ns:ne) :: coeff

integer :: k, m, n

if(.not.module_is_initialized) then
  call error_mesg('compute_spectral_damping_vor','initialization of spectral_damping not performed', FATAL)
end if

coeff = 1.0/(1.0 + damping_vor(ms:me,ns:ne)*current_dt)

do k = 1, size(vor,3)
  dt_vor(:,:,k) = coeff * (dt_vor(:,:,k) - damping_vor(ms:me,ns:ne)*vor(:,:,k))
end do

do n=ns,ne
  do m=ms,me
    if(m /= 0) then
      dt_vor(m,n,1) = (dt_vor(m,n,1) - damping_eddy_sponge(m,n)*vor(m,n,1))/(1. + damping_eddy_sponge(m,n)*current_dt)
    endif
  enddo
enddo

if(ms == 0) then
  do n=ns,ne
    dt_vor(0,n,1) = (dt_vor(0,n,1) - damping_zmu_sponge(n)*vor(0,n,1))/(1. + damping_zmu_sponge(n)*current_dt)
  enddo
endif

return
end subroutine compute_spectral_damping_vor
!-----------------------------------------------------------------

subroutine compute_spectral_damping_div(div, dt_div, current_dt)
complex, intent(in), dimension(ms:me, ns:ne, num_levels) :: div
real,    intent(in) :: current_dt
complex, intent(inout), dimension (ms:me, ns:ne, num_levels) :: dt_div

real, dimension(ms:me, ns:ne) :: coeff

integer :: k, m, n

if(.not.module_is_initialized) then
  call error_mesg('compute_spectral_damping_div','initialization of spectral_damping not performed', FATAL)
end if

coeff = 1.0/(1.0 + damping_div(ms:me,ns:ne)*current_dt)

do k = 1, size(div,3)
  dt_div(:,:,k) = coeff * (dt_div(:,:,k) - damping_div(ms:me,ns:ne)*div(:,:,k))
end do

do n=ns,ne
  do m=ms,me
    if(m /= 0) then
      dt_div(m,n,1) = (dt_div(m,n,1) - damping_eddy_sponge(m,n)*div(m,n,1))/(1. + damping_eddy_sponge(m,n)*current_dt)
    endif
  enddo
enddo

if(ms == 0) then
  do n=ns,ne
    dt_div(0,n,1) = (dt_div(0,n,1) - damping_zmv_sponge(n)*div(0,n,1))/(1. + damping_zmv_sponge(n)*current_dt)
  enddo
endif

return
end subroutine compute_spectral_damping_div
!-----------------------------------------------------------------
subroutine compute_spectral_damping_2d(spec, dt_spec, current_dt)  

complex, intent(in), dimension(:,:) :: spec
real, intent(in) :: current_dt
complex, intent(inout), dimension(:,:) :: dt_spec

real, dimension(size(spec,1),size(spec,2)) :: coeff

if(.not.module_is_initialized) then
  call error_mesg('compute_spectral_damping','initialization of spectral_damping not performed', FATAL)
end if

coeff = 1.0/(1.0 + damping(ms:me,ns:ne)*current_dt)
dt_spec = coeff*(dt_spec - damping(ms:me,ns:ne)*spec)

return
end subroutine compute_spectral_damping_2d

!-----------------------------------------------------------------
subroutine spectral_damping_end

if(.not.module_is_initialized) return
deallocate(damping, damping_vor, damping_div)
deallocate(damping_eddy_sponge, damping_zmu_sponge, damping_zmv_sponge)
module_is_initialized = .false.

return
end subroutine spectral_damping_end
!-----------------------------------------------------------------

end module spectral_damping_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The algebraic epsilonb-equation\label{sec:epsbalgebraic}
!
! !INTERFACE:
   subroutine epsbalgebraic(nlev)
!
! !DESCRIPTION:
! The algebraic equation for $\epsilon_b$, the molecular rate of
! destruction of buoyancy variance, see \eq{kbeq}, simply assumes a
! constant time scale ratio $r=c_b$, see \eq{DefR}. From
! this assumption, it follows immediately that
! \begin{equation}
!   \label{epsbAgebraic}
!     \epsilon_b = \dfrac{1}{c_b} \dfrac{\epsilon}{k} k_b
!   \point
! \end{equation}
!
! !USES:
  use turbulence,  only:     tke,eps,kb,epsb
  use turbulence,  only:     ctt,epsb_min

  IMPLICIT NONE
!
! !INPUT PARAMETERS:

! number of vertical layers
  integer,  intent(in)                 :: nlev

! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: epsbalgebraic.F90,v $
!  Revision 20.0  2013/12/14 00:13:38  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1  2005-06-27 10:54:33  kbk
!  new files needed
!
!
!EOP
!-----------------------------------------------------------------------
! !LOCAL VARIABLES:
  REALTYPE                             :: one_over_ctt
  integer                              :: i
!
!-----------------------------------------------------------------------
!BOC

  one_over_ctt=1.0D0/ctt

  do i=0,nlev
     epsb(i) = one_over_ctt*eps(i)/tke(i)*kb(i)

!     clip at epsb_min
     epsb(i) = max(epsb(i),epsb_min)
  enddo

  return
  end subroutine epsbalgebraic
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module dyn_core

! !USES:
#ifndef USE_LIMA
   use fv_pack,      only: get_eta_level, pi, n_spong, n_diffu,  &
                           a_div, b_div, tra_step
#else
   use shr_kind_mod, only: r8 => shr_kind_r8
   use fv_pack,      only: get_eta_level, sc, se, dc, de, pi, ipft1, ipft2,  &
                           ifax, trigs, n_spong, n_diffu, too_big,           &
                           a_div, b_div
#endif

#ifdef MARS_GCM
   use fv_pack,      only: p_ref, fv_sponge_damp, fv_sponge_lev
#endif MARS_GCM


   use pft_module,   only: pft2d
   use sw_core,      only: c_sw, d_sw, upol5
   use timingModule, only: timing_on, timing_off

#ifdef SPMD
   use mod_comm,     only: mp_send4d_ns, mp_recv4d_ns,      &
                           mp_send3d_2,  mp_recv3d_2,       &
                           mp_send3d,    mp_recv3d,         &
                           mp_send2_ns,  mp_recv2_ns,  gid
#endif
   use fv_arrays_mod, only: fv_array_check, fv_array_sync, fv_array_limits, &
        fv_print_chksum, fv_print_chksums, ksp, kep
   use pmaxmin_mod, only: prt_maxmin_local

   implicit none

   private
   public cd_core


CONTAINS 

  subroutine cd_core(im,  jm,  km,   nq,  nx, jfirst, jlast,      &
       u,    v,  pt, delp,  pe,   pk,               &
       ns,  dt, ptop, umax, ae,  rcap, cp, akap,    &
       iord_mt, iord_tm, jord_mt, jord_tm,          &
       ng_d, ng_s, it, n_split, om, hs, sinp,       &
       cosp, cose, acosp, sinlon, coslon,           &
       cosl5, sinl5, f0, dx, rdx,  rdy, cx3, cy3,   &
       mfx, mfy, delpf, uc, vc, dpt, ptc,           &
#ifdef USE_LIMA
    wz3, pkc, wz, delpc, master, ig )
#else
    wz3, pkc, wz, delpc, master, ig, dyn_step )
#endif


! !INPUT PARAMETERS:

! Input paraterers:
    integer, intent(in):: im, jm, km
    integer, intent(in):: ig
    integer, intent(in):: nq
    integer, intent(in):: ns           ! # of time splits
    integer, intent(in):: nx           ! # of split pieces in longitude direction
    integer, intent(in):: jfirst       ! first latitude of the subdomain
    integer, intent(in):: jlast        ! last latitude of the subdomain
    integer, intent(in):: it
    integer, intent(in):: n_split

    real, intent(in):: ae          ! Radius of the Earth (m)
    real, intent(in):: om          ! rotation rate of the earth
    real, intent(in):: ptop        ! Model top pressure (pa)
    real, intent(in):: umax        ! Estimated upper bound of u-wind (m/s)
    real, intent(in):: dt          ! small time step in seconds
    real, intent(in):: rcap
    real, intent(in):: cp
    real, intent(in):: akap

!Grid Geometry
    real, intent(in):: rdy
    real, intent(in):: dx(jm)
    real, intent(in):: rdx(jm)

    integer, intent(in):: iord_mt, jord_mt
    integer, intent(in):: iord_tm, jord_tm
    integer, intent(in):: ng_d          ! Max NS dependencies
    integer, intent(in):: ng_s
#ifndef USE_LIMA
    integer, intent(in):: dyn_step
#endif
    logical, intent(in):: master   ! if master process (for printing)

! Input time independent arrays:
    real, intent(in):: hs(im,jfirst-ig:jlast+ig) ! surface geopotential
    real, intent(in)::  sinp(jm)
    real, intent(in)::  cosp(jm)
    real, intent(in):: acosp(jm)
    real, intent(in)::  cose(jm)

    real, intent(in):: sinlon(im)
    real, intent(in):: coslon(im)
    real, intent(in)::  sinl5(im)
    real, intent(in)::  cosl5(im)

#ifndef USE_LIMA
    real, intent(in):: f0(im,jfirst-ng_d:jlast+ng_d)
#else
    real, intent(in):: f0(jfirst-ng_d:jlast+ng_d)
#endif

! !INPUT/OUTPUT PARAMETERS:
    real, intent(inout)::  u(im,jfirst-ng_d:jlast+ng_s,km)  ! u-Wind (m/s)
    real, intent(inout)::  v(im,jfirst-ng_d:jlast+ng_d,km)  ! v-wind (m/s)
    real, intent(inout):: pt(im,jfirst-ng_d:jlast+ng_d,km)  ! Scaled-Potential temperature 
    real, intent(inout):: delp(im,jfirst:jlast,km)            ! Delta pressure (pa)
    real, intent(inout):: delpf(im,jfirst-ng_d:jlast+ng_d,km)    ! filtered delp

! Input/output: accumulated winds & mass fluxes on c-grid for large-
!               time-step transport
    real, intent(inout):: cx3(im,jfirst-ng_d:jlast+ng_d,km)!Accumulated Courant number in X
    real, intent(inout):: cy3(im,jfirst:jlast+1,km)        !Accumulated Courant number in Y
    real, intent(inout):: mfx(im,jfirst:jlast,km)          !Mass flux in X  (unghosted)
    real, intent(inout):: mfy(im,jfirst:jlast+1,km)        !Mass flux in Y

! !OUTPUT PARAMETERS:
    real, intent(out):: pe(im,km+1,jfirst:jlast)         ! Edge pressure (pascal)
    real, intent(out):: pk(im,jfirst:jlast,km+1)         ! pe ** kappa

! work arrays (useless output)
    real, intent(out)::    uc(im,jfirst-ng_d:jlast+ng_d,km)
    real, intent(out)::    vc(im,jfirst-2:   jlast+2,   km)
    real, intent(out):: delpc(im,jfirst:jlast,km)

    real, intent(out):: ptc(im,jfirst:jlast,km)
    real, intent(out):: dpt(im,jfirst-1:jlast+1,km)

    real, intent(out):: wz3(im,jfirst-1:jlast  ,km+1)

    real, intent(out):: pkc(im,jfirst-1:jlast+1,km+1) 
    real, intent(out)::  wz(im,jfirst-1:jlast+1,km+1)

! ! !DESCRIPTION:
!    Perform a dynamical update for one small time step; the small
!    time step is limitted by the fastest wave within the Lagrangian control-
!    volume 
!
! !REVISION HISTORY:
!     SJL  99.01.01:   Original SMP version
!     WS   99.04.13:   MPI-1; added jfirst:jlast concept
!     SJL  99.07.15:   Merged c_core and d_core to this routine
!     SJL  99.12.23:   More comments; general optimization; reduction
!                      of redundant computation & communication
!     SJL  03.11.15:   Restructure c_sw to reduce communication (added ig)
!     SJL  04.01.30:   Fix bug(s) at poles; revert to old sw_core codes
!
!EOP
!---------------------------------------------------------------------
!BOC
! Local 2D arrays:
    integer, parameter:: pft_buff = 1  ! increase buffer size for pft2d
    real   wk(im,jfirst:jlast+2+pft_buff)
    real  wk2(im,jfirst:jlast+1+pft_buff)
    real  wk1(im,jfirst-1:jlast+1+pft_buff)
    real  wk3(im,jfirst-1:jlast+1)
    real  p1d(im)
    real   phalf(km+1)

!Local scalars
    real  dt0, dt5
    real  dl, dp
    real  dt_divg

    integer i, j, k
    integer js1g1, js2g0
    integer jn2g0, jn1g1, jsfc, jnfc
    integer iord , jord, sord

    real  dtdy, dydt, dtdy5, tdy5
    real  zt_c   
    real  zt_d  
    real  tau, fac, pk4
    real, parameter:: esl = 1.e-20

! Declare permanent local arrays
    real, allocatable, save :: pfull(:)
#ifndef USE_LIMA
    real, allocatable, save :: fc(:,:)
#else
    real, allocatable, save :: fc(:)
#endif
    real, allocatable, save :: cdx(:,:), cdy(:,:)
    real, allocatable, save :: dtdx(:), dtdxe(:), txe5(:), dtxe5(:)
    real, allocatable, save :: dyce(:), cy(:)
    real, allocatable, save :: dtdx2(:), dtdx4(:),  dxdt(:), dxe(:)
    real, allocatable, save :: cye(:),    dycp(:),  rdxe(:)
    integer ng_c, js2gc, jn1gc
    integer :: kepp !use to do km+1: Balaji

    data dt0 / 0./
    save dtdy, dydt, dtdy5, tdy5
    save zt_c, zt_d

    call fv_print_chksums( 'Entering  cd_core' )
    call fv_array_check( LOC(u) )
    call fv_array_check( LOC(v) )
    call fv_array_check( LOC(pt) )
    call fv_array_check( LOC(delp) )
    call fv_array_check( LOC(delpf) )
    call fv_array_check( LOC(cx3) )
    call fv_array_check( LOC(cy3) )
    call fv_array_check( LOC(mfx) )
    call fv_array_check( LOC(mfy) )
    call fv_array_check( LOC(pe) )
    call fv_array_check( LOC(pk) )
    call fv_array_check( LOC(uc) )
    call fv_array_check( LOC(vc) )
    call fv_array_check( LOC(delpc) )
    call fv_array_check( LOC(ptc) )
    call fv_array_check( LOC(dpt) )
    call fv_array_check( LOC(wz3) )
    call fv_array_check( LOC(pkc) )
    call fv_array_check( LOC(wz) )
#ifdef SPMD
    ng_c = 2
#else
    ng_c = 0
#endif
    js2gc  = max(2,jfirst-ng_c)
    jn1gc  = min(jm,jlast+ng_c)

! Set loop limits
    js1g1 = max(1,jfirst-1)
    js2g0 = max(2,jfirst)
    jsfc  = max(2,jfirst-2) 

    jn2g0 = min(jm-1,jlast)
    jn1g1 = min(jm,  jlast+1)
    jnfc  = min(jm,  jlast+2)
    kepp = kep; if( kep.EQ.km )kepp = kep + 1

    if( abs(dt0-dt) > 0.1 ) then
        if ( .not. allocated( dtdx ) ) then
            allocate( dtdx(jm), dtdx2(jm), dtdx4(jm), dtdxe(jm), dxdt(jm),    &
                 dxe(jm),   cye(jm),  dycp(jm),  rdxe(jm), txe5(jm),    &
                 dtxe5(jm),  dyce(jm),    cy(jm) )

            allocate( cdx(js2g0:jn1g1,km) )
            allocate( cdy(js2g0:jn1g1,km) )
#ifndef USE_LIMA
            allocate( fc(im,jsfc:jnfc) )
#else
            allocate( fc(jsfc:jnfc) )
#endif 


#ifndef USE_LIMA

! Compute coriolis parameter at cell corners.
!         do j=2,jm
            do j=jsfc, jnfc
               do i=1,im
                  p1d(i) = 0.25*(f0(i,j) + f0(i,j-1))
               enddo
               fc(1,j) = p1d(im) + p1d(1)
               do i=2,im
                  fc(i,j) = p1d(i-1) + p1d(i)
               enddo
            enddo
#else               

! Compute coriolis parameter at cell corners.
!         do j=2,jm
            do j=jsfc, jnfc
               fc(j) = 0.5*(f0(j) + f0(j-1))
            enddo

#endif

        endif

        dt0 = dt
        dt5 = 0.5*dt

        dl = (pi+pi)/im
        dp = pi/(jm-1)

        dtdy  = dt *rdy
        dtdy5 = dt5*rdy
        dydt  = (ae*dp) / dt
        tdy5  = 0.5/dtdy

        do j=2,jm-1
           dtdx(j)  = dt / dx(j)
           dxdt(j)  = dx(j) / dt
           dtdx2(j) = 0.5*dtdx(j)
           dtdx4(j) = 0.5*dtdx2(j)
           dycp(j)  = ae*dp/cosp(j)
           cy(j)    =  rdy * acosp(j)
        enddo

        do j=2,jm
           dxe(j)   = ae*dl*cose(j)
           rdxe(j)  = 1. / dxe(j)
           dtdxe(j) = dt / dxe(j)
           dtxe5(j) = 0.5*dtdxe(j)
           txe5(j)  = 0.5/dtdxe(j)
           cye(j)  =  1. / (ae*cose(j)*dp)
           dyce(j)  = ae*dp/cose(j)
        enddo

! Checking if Lagrangian (integer part) flux is needed or not
        zt_c = abs(umax*dt5) / (dl*ae)             ! for C-grid
        zt_d = abs(umax*dt)  / (dl*ae)             ! for D-grid

!--------------------------------------------------------
! Divergence damping coeff: Cd = dx*dy / dt_divg [m**2/s]
!--------------------------------------------------------
        if(master) write(6,*) 'Divergence damping coefficient (m**2/sec x E6):'
        dt_divg = 450.*180./max(im, 2*(jm-1))  ! small-time-step as determined
! by the default setup (n_split=0)
        allocate ( pfull(km) )
#ifdef MARS_GCM
        call get_eta_level(km, p_ref, pfull, phalf, 0.01) 
#else
        call get_eta_level(km, 1.E5, pfull, phalf, 0.01) 
#endif MARS_GCM 


        do k=1,km
           if ( km <= 2 ) then 
! Shallow-water mode
               tau = 1.
           else 
#ifdef OLD_DIVD
               if ( n_spong == 0 ) then
                   tau = 1.0              ! weak damping
               else
                   if(k == 1) then
                       tau = 4.0
                   elseif(k == 2) then
                       tau = 2.8
                   else
                       tau = 1.8 + tanh(0.5*log(50./pfull(k))) 
                   endif
               endif
#elif MARS_GCM
!           Set break-point at fv_sponge_lev  ( 0.5 mb is the default) 
             tau =  1.0 +  0.5*fv_sponge_damp*(1.0 + tanh(0.9*log(fv_sponge_lev/pfull(k)) ) )
#else
               if ( n_spong == 0 ) then
                   if(k == 1) then
                       tau = 2.0
                   else
                       tau = 1.
                   endif
               else
                   if(k == 1) then
                       tau = 3.0
                   elseif( k == 2 .and. pfull(k) < 10. ) then
                       tau = 1.25
                   else
                       tau = 1.
                   endif
               endif
#endif
           endif
           tau = max(tau, 1.) / (128.*dt_divg)
           do j=js2g0,jn1g1
              fac = tau * ae * ( a_div/cose(j) + b_div )
              cdx(j,k) = fac*dp
              cdy(j,k) = fac*dl
           enddo
           if(master) write(6,*) k, pfull(k), cdx(js2g0,k)*ae*dl*cose(js2g0)*1.E-6
        enddo
    endif ! end init

#ifdef SPMD
    if( it /= 1 ) then             ! not the first call
        call mp_recv4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_s, u)
        call mp_recv4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, v)
    endif
    call fv_array_sync()
#endif

!-----------------------------------------------------------------
! Call the vertical independent part of the dynamics on the C-grid
!-----------------------------------------------------------------

!$omp parallel do default(shared) private(k, iord, jord)
    do k=ksp,kep !1,km
       iord = 1
       jord = 1
#ifndef USE_LIMA

       call c_sw(  u(1,jfirst-ng_d,k),   v(1,jfirst-ng_d,k),        &
            pt(1,jfirst-ng_d,k),   delp(1,jfirst,k),          &
            uc(1,jfirst-ng_d,k),   vc(1,jfirst-2,k),          &
            ptc(1,jfirst,k),        delpf(1,jfirst-ng_d,k),    &
            delpc(1,jfirst,k),                                 &
            cosp,   acosp,   cose,   coslon,   sinlon,         &
            dxdt,   dxe,     dtdx2,  dtdx4,    dtxe5,  rdxe,   &
            dycp,   dydt,    dtdy5,  cye,      fc,             &
            zt_c,   esl,     rcap,   im,       jm,             &
            jfirst, jlast,   ng_c,    ng_d,    ng_s,           &
            js2g0,  jn2g0,   js2gc,   jn1gc,                   &
            iord,   jord,    cosl5,   sinl5, 0 )
#else               
       call c_sw(  u(1,jfirst-ng_d,k),   v(1,jfirst-ng_d,k),        &
            pt(1,jfirst-ng_d,k),   delp(1,jfirst,k),          &
            uc(1,jfirst-ng_d,k),   vc(1,jfirst-2,k),          &
            ptc(1,jfirst,k),        delpf(1,jfirst-ng_d,k),    &
            delpc(1,jfirst,k),                                 &
            cosp,   acosp,   cose,   coslon,   sinlon,         &
            dxdt,   dxe,     dtdx2,  dtdx4,    dtxe5,  rdxe,   &
            dycp,   dydt,    dtdy5,  cye,      fc,             &
            ifax,   trigs,   dc(1,js2g0),      sc,             &
            zt_c,   esl,     rcap,   im,       jm,             &
            jfirst, jlast,   ng_c,    ng_d,    ng_s,           &
            js2g0,  jn2g0,   js2gc,   jn1gc,                   &
            iord,   jord,    cosl5,   sinl5 )
#endif
    enddo
    call fv_array_sync

    call geopk(ptop, pe, delpc, pkc, wz, hs(1,jfirst), ptc, im, jm, km,   &
         jfirst, jlast, 0, akap, nx, 0, .false.)

#ifdef SPMD
    call mp_send3d_2(gid+1, gid-1, im, jm, km+1, &
         1, im, jfirst-1, jlast+1, 1, km+1, &
         1, im, jlast, jlast, 1, km+1, pkc, wz)
#endif


!$omp parallel do private(i, j, k, p1d, wk, wk2)
    do k=ksp,kep !1,km
       do j=js2g0,jn2g0
          do i=1,im
             p1d(i) = pkc(i,j,k+1) - pkc(i,j,k)
          enddo

          uc(1,j,k) = uc(1,j,k) + dtdx2(j) * (                      &
               (wz(im,j,k+1)-wz(1,j,k))*(pkc(1,j,k+1)-pkc(im,j,k))   &
               + (wz(im,j,k)-wz(1,j,k+1))*(pkc(im,j,k+1)-pkc(1,j,k)))  &
               / (p1d(1)+p1d(im))
          do i=2,im
             uc(i,j,k) = uc(i,j,k) + dtdx2(j) * (                     &
                  (wz(i-1,j,k+1)-wz(i,j,k))*(pkc(i,j,k+1)-pkc(i-1,j,k))    &
                  + (wz(i-1,j,k)-wz(i,j,k+1))*(pkc(i-1,j,k+1)-pkc(i,j,k)) )  &
                  / (p1d(i)+p1d(i-1))
          enddo
       enddo

#ifndef USE_LIMA
       call pft2d(uc(1,js2g0,k), im, jn2g0-js2g0+1,  wk, wk2, 1)
#else               
       call pft2d(uc(1,js2g0,k), sc(js2g0), dc(1,js2g0), im,        &
            jn2g0-js2g0+1,  ifax,   trigs, wk, wk2)
#endif


       call upol5(uc(1,jfirst,k), vc(1,jfirst,k), im, jm,    &
            coslon,  sinlon,  &
            cosl5, sinl5, jfirst, jlast, ng_d)
    enddo                 ! end k paralle loop
    call fv_array_sync

#ifdef SPMD
    call mp_send4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, uc)

    call mp_recv3d_2(gid-1, im, jm, km+1, &
         1, im, jfirst-1, jlast+1, 1, km+1, &
         1, im, jfirst-1, jfirst-1, 1, km+1, pkc, wz)
#endif
    call fv_array_sync

!$omp parallel do private(i, j, k, wk, wk1)
    do k=ksp,kep !1,km
       do j=js1g1,jlast
          do i=1,im
             wk1(i,j) = pkc(i,j,k+1) - pkc(i,j,k)
          enddo
       enddo

       do j=js2g0,jlast
          do i=1,im
             vc(i,j,k) = vc(i,j,k) + dtdy5/(wk1(i,j)+wk1(i,j-1)) *   &
                  ((wz(i,j-1,k+1)-wz(i,j,k))*(pkc(i,j,k+1)-pkc(i,j-1,k))    &
                  + (wz(i,j-1,k)-wz(i,j,k+1))*(pkc(i,j-1,k+1)-pkc(i,j,k)))
          enddo
       enddo

#ifndef USE_LIMA
       call pft2d(vc(1,js2g0,k), im, jlast-js2g0+1, wk, wk1, 2)
#else               
       call pft2d(vc(1,js2g0,k), se(js2g0), de(1,js2g0), im,      &
            jlast-js2g0+1,  ifax, trigs, wk, wk1 )
#endif

    enddo
    call fv_array_sync

#ifdef SPMD
!------------
! Receive uc
!------------
    call mp_recv4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, uc)
!------------
! Send/recv vc
!------------
    call mp_send3d(gid-1, gid+1, im, jm, km,               &
         1, im, jfirst-2, jlast+2, 1, km,        &
         1, im, jfirst, jfirst, 1, km, vc)
    call mp_recv3d(gid+1, im, jm, km,                       &
         1, im, jfirst-2, jlast+2, 1, km, &
         1, im, jlast+1, jlast+1, 1, km, vc)
#endif
!the vc array shouldn't be used until receive complete?
    call fv_array_sync
#ifdef DEBUG
    call prt_maxmin_local(gid, 'uc', uc, im, jm, km, jfirst-ng_d, jlast+ng_d)
    call prt_maxmin_local(gid, 'vc', vc, im, jm, km, jfirst-2, jlast+2)
#endif

!-----------------------------------------------------------------
! Call the vertical independent part of the dynamics on the D-grid
!-----------------------------------------------------------------

!    call timing_on(' D_SW')
!$omp parallel do default(shared) private(k, iord, jord, sord)
    do k=ksp,kep !1,km
       sord = min(iord_tm, jord_tm)
       if( k <= n_spong ) then
! Apply first order scheme for damping the sponge layer
           iord = 1
           jord = 1
           sord = 1                          ! scheme for pt & delp
       elseif( k == n_spong+1 .and. pfull(k) < 10.0  ) then
           iord = min(2, iord_mt)
           jord = min(2, jord_mt)
           sord = min(2, iord_tm, jord_mt)
       elseif( k >= km-n_diffu+1 .and. pfull(k) > 800.0  ) then
           iord = 2
           jord = 2
           sord = 2
       else
! Apply the chosen high-order scheme
           iord = iord_mt
           jord = jord_mt
       endif

#ifndef USE_LIMA
       call d_sw( u(1,jfirst-ng_d,k),      v(1,jfirst-ng_d,k),     &
            uc(1,jfirst-ng_d,k),    vc(1,jfirst-1,k),        &
            pt(1,jfirst-ng_d,k),   delp(1,jfirst,k),         &
            delpf(1,jfirst-ng_d,k), cx3(1,jfirst-ng_d,k),    &
            cy3(1,jfirst,k),        mfx(1,jfirst,k),         &
            mfy(1,jfirst,k), cdx(js2g0,k),  cdy(js2g0,k),    &
            dtdx,   dtdxe,  dtxe5,  txe5,  dyce,  rdx,  cy,  &
            dx,  f0(1,jfirst-ng_d), js2g0,  jn1g1, im,  jm,    &
            jfirst, jlast,  ng_d,  ng_s,   nq,    iord,      &
            jord,   sord,   zt_d,   rcap,  esl,   dtdy,      &
            dtdy5,  tdy5,   rdy,    cosp,  acosp, cose,      &
            coslon, sinlon, cosl5, sinl5, dyn_step )
#else               
       call d_sw( u(1,jfirst-ng_d,k),      v(1,jfirst-ng_d,k),     &
            uc(1,jfirst-ng_d,k),    vc(1,jfirst-1,k),        &
            pt(1,jfirst-ng_d,k),   delp(1,jfirst,k),         &
            delpf(1,jfirst-ng_d,k), cx3(1,jfirst-ng_d,k),    &
            cy3(1,jfirst,k),        mfx(1,jfirst,k),         &
            mfy(1,jfirst,k), cdx(js2g0,k),  cdy(js2g0,k),    &
            dtdx,   dtdxe,  dtxe5,  txe5,  dyce,  rdx,  cy,  &
            dx,  f0(jfirst-ng_d), js2g0,  jn1g1, im,  jm,    &
            jfirst, jlast,  ng_d,  ng_s,   nq,    iord,      &
            jord,   sord,   zt_d,   rcap,  esl,   dtdy,      &
            dtdy5,  tdy5,   rdy,    cosp,  acosp, cose,      &
            coslon, sinlon, cosl5, sinl5 )
#endif

    enddo
    call fv_array_sync

!    call timing_off(' D_SW')

!      call timing_on(' geop_d')
    call geop_d(ptop, pe, delp, pkc, wz, hs(1,jfirst), pt, im, jm,  &
         km,   jfirst, jlast, ng_d, cp, akap, nx, it==n_split, .true.)
!      call timing_off(' geop_d')

#ifdef DEBUG
    call prt_maxmin_local(gid, 'pt_2', pt, im, jm, km, jfirst-ng_d, jlast+ng_d)
#endif

#ifdef SPMD
!-------------------------------------
!  Send pkc and wz NS boundary regions
!-------------------------------------
    call mp_send2_ns(im, jm, km+1, jfirst, jlast, 1, km+1, 1, pkc, wz)
#endif

    if ( it /= n_split ) then          !  not the last call
!$omp parallel do private(i, j, k, wk, wk2)
        do k=ksp,kep !1,km
           do j=jfirst,jlast
              do i=1,im
                 delpf(i,j,k) = delp(i,j,k)
              enddo
           enddo

#ifndef USE_LIMA
           call pft2d(delpf(1,js2g0,k), im, jn2g0-js2g0+1, wk, wk2, 1)
#else               
           call pft2d(delpf(1,js2g0,k), sc(js2g0), dc(1,js2g0),   &
                im, jn2g0-js2g0+1, ifax, trigs, wk, wk2)
#endif


        enddo
    else
! Last call
!$omp parallel do private(i, j, k)
        do k=ksp,kepp !1,km+1 Balaji
           do j=jfirst,jlast
              do i=1,im
                 pk(i,j,k) = pkc(i,j,k)
              enddo
           enddo
        enddo
    endif
    call fv_array_sync

#ifdef SPMD
    call mp_recv2_ns(im, jm, km+1, jfirst, jlast, 1, km+1, 1, pkc, wz)

    if ( it == n_split ) then          !  last call; send data for tracer transport
#ifndef USE_LIMA
        if ( tra_step /= 1 )       &
             call mp_send4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, cx3)
#else
        call mp_send4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, cx3)
#endif
        call mp_send3d_2(gid-1, gid+1, im, jm, km,                            &
             1, im, jfirst, jlast+1, 1, km,                   &
             1, im, jfirst, jfirst,  1, km, cy3, mfy)
    else 

#if !defined (SW_DYN)
        call mp_send4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, pt)
#endif
        call mp_send4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, delpf)

    endif
    call fv_array_sync
#endif

!$omp parallel do private(i, j, k)
    do k=ksp,kep !1,km
       do j=js1g1,jn1g1                  ! dpt needed NS
          do i=1,im                      ! wz, pkc ghosted NS
             dpt(i,j,k)=(wz(i,j,k+1)+wz(i,j,k))*(pkc(i,j,k+1)-pkc(i,j,k))
          enddo
       enddo
    enddo
    call fv_array_sync

    pk4 = 4.*ptop**akap

!$omp parallel do private(i, j, k, wk1, wk3)

    do 4500 k=ksp,kepp !1,km+1 Balaji
       if ( k == 1 ) then
           do j=js2g0,jlast
              do i=1,im
                 wz3(i,j,1) = 0.
                 wz(i,j,1) = 0.
              enddo
           enddo
           do j=js2g0,jn1g1
              do i=1,im
                 pkc(i,j,1) = pk4
              enddo
           enddo

       else

           do j=max(2,jfirst-1), jn2g0
              wk3(1,j) = (wz(1,j,k)+wz(im,j,k)) *        &
                   (pkc(1,j,k)-pkc(im,j,k))
              do i=2,im
                 wk3(i,j) = (wz(i,j,k)+wz(i-1,j,k)) *       &
                      (pkc(i,j,k)-pkc(i-1,j,k))
              enddo
           enddo

           do j=max(2,jfirst-1), jn2g0
              do i=1,im-1
                 wk1(i ,j) = wk3(i, j) + wk3(i+1,j)
              enddo
              wk1(im,j) = wk3(im,j) + wk3(1,j)
           enddo

           if ( jfirst == 1 ) then
               do i=1,im
                  wk1(i,1) = 0.
               enddo
           endif

           if ( jlast == jm ) then
               do i=1,im
                  wk1(i,jm) = 0.
               enddo
           endif

           do j=js2g0,jlast                          ! wk1 ghosted S
              do i=1,im
                 wz3(i,j,k) = wk1(i,j) + wk1(i,j-1)
              enddo
           enddo

! N-S walls
           do j=js2g0,jn1g1                        ! wk1 needed N
              do i=1,im                            ! wz, pkc ghosted NS
                 wk1(i,j) = (wz(i,j,k)+wz(i,j-1,k))*(pkc(i,j,k)-pkc(i,j-1,k))
              enddo
           enddo

           do j=js2g0,jn1g1                         ! wk3 needed N
              wk3(1,j) = wk1(1,j) + wk1(im,j)    ! wk1 ghosted N
              do i=2,im
                 wk3(i,j) = wk1(i,j) + wk1(i-1,j)   ! wk1 ghosted N
              enddo
           enddo

           do j=js2g0,jn2g0
              do i=1,im
                 wz(i,j,k) = wk3(i,j) + wk3(i,j+1)  ! wk3 ghosted N
              enddo
           enddo

           do j=js1g1,jn1g1
              wk1(1,j) = pkc(1,j,k) + pkc(im,j,k)
              do i=2,im
                 wk1(i,j) = pkc(i,j,k) + pkc(i-1,j,k)
              enddo
           enddo

           do j=js2g0,jn1g1
              do i=1,im
                 pkc(i,j,k) = wk1(i,j) + wk1(i,j-1)
              enddo
           enddo
       endif
4500 end do !continue
    call fv_array_sync
!$omp parallel do private(i, j, k, wk, wk1, wk2, wk3)
    do 6000 k=ksp,kep !1,km

       do j=js1g1,jn1g1
          wk1(1,j) = dpt(1,j,k) + dpt(im,j,k)
          do i=2,im
             wk1(i,j) = dpt(i,j,k) + dpt(i-1,j,k)
          enddo
       enddo

       do j=js2g0,jn1g1
          do i=1,im
             wk2(i,j) = wk1(i,j)     + wk1(i,j-1)
             wk(i,j) = pkc(i,j,k+1) - pkc(i,j,k)
          enddo
       enddo

       do j=js2g0,jlast
          do i=1,im-1
             wk3(i,j) = uc(i,j,k) + dtdxe(j)/(wk(i,j) + wk(i+1,j))  &
                  * (wk2(i,j)-wk2(i+1,j)+wz3(i,j,k+1)-wz3(i,j,k))
          enddo
          wk3(im,j) = uc(im,j,k) + dtdxe(j)/(wk(im,j) + wk(1,j))   &
               * (wk2(im,j)-wk2(1,j)+wz3(im,j,k+1)-wz3(im,j,k))
       enddo

       do j=js2g0,jn2g0
          do i=1,im
             wk1(i,j) = vc(i,j,k) + dtdy/(wk(i,j)+wk(i,j+1)) *     &
                  (wk2(i,j)-wk2(i,j+1)+wz(i,j,k+1)-wz(i,j,k))
          enddo
       enddo

#if (!defined ALT_PFT)

#ifndef USE_LIMA
       call pft2d(wk3(1,js2g0), im, jlast-js2g0+1, wk, wk2, 2)
       call pft2d(wk1(1,js2g0), im, jn2g0-js2g0+1, wk, wk2, 1)
#else               
       call pft2d(wk3(1,js2g0), se(js2g0), de(1,js2g0), im,     &
            jlast-js2g0+1,  ifax, trigs, wk, wk2 )
       call pft2d(wk1(1,js2g0), sc(js2g0), dc(1,js2g0), im,     &
            jn2g0-js2g0+1,  ifax, trigs, wk, wk2 )

#endif

#endif

       do j=js2g0,jn2g0
          do i=1,im
             v(i,j,k) = v(i,j,k) + wk1(i,j)
             u(i,j,k) = u(i,j,k) + wk3(i,j)
          enddo
       enddo

       if ( jlast == jm ) then
           do i=1,im
              u(i,jlast,k) = u(i,jlast,k) + wk3(i,jlast)
           enddo
       endif

#ifdef ALT_PFT

#ifndef USE_LIMA
       call pft2d(u(1,js2g0,k), im, jlast-js2g0+1, wk, wk2, 2)
       call pft2d(v(1,js2g0,k), im, jn2g0-js2g0+1, wk, wk2, 1)
#else               
       call pft2d(u(1,js2g0,k), se(js2g0), de(1,js2g0), im,       &
            jlast-js2g0+1,  ifax, trigs, wk, wk2)
       call pft2d(v(1,js2g0,k), sc(js2g0), dc(1,js2g0), im,       &
            jn2g0-js2g0+1,  ifax, trigs, wk, wk2)
#endif

#endif
6000 end do !continue
    call fv_array_sync
#ifdef SPMD
    if ( it /= n_split ) then            ! not the last call
#if !defined (SW_DYN)
        call mp_recv4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, pt)
#endif
        call mp_recv4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, delpf)
        call mp_send4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_s, u)
        call mp_send4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, v)

    endif
#endif
!EOC
    call fv_array_sync
    call fv_print_chksums( 'Exiting  cd_core' )
  end subroutine cd_core
!

 subroutine geop_d(ptop, pe, delp, pk, wz, hs, pt, im, jm, km,  &
                   jfirst, jlast, nd, cp, akap, nx, last_call, dp_check)

! !INPUT PARAMETERS:

   integer, intent(in):: im, jm, km, jfirst, jlast
   integer, intent(in):: nx                      ! # of pieces in longitude direction
   integer, intent(in):: nd
   real, intent(in):: akap, cp, ptop
   real, intent(in):: hs(im,jfirst:jlast)
   logical, intent(in):: dp_check
   logical, intent(in):: last_call

! !INPUT/OUTPUT PARAMETERS:
! pt and delp could be adjusted if dp_check is true
   real, intent(inout)::  pt(im,jfirst-nd:jlast+nd,km) 
   real, intent(inout):: delp(im,jfirst:jlast,km)     

! !OUTPUT PARAMETERS
   real, intent(out):: wz(im,jfirst-1:jlast+1,km+1)  ! space N*1 S*1
   real, intent(out):: pk(im,jfirst-1:jlast+1,km+1)  ! space N*1 S*1
   real, intent(out):: pe(im,km+1,jfirst:jlast)      ! only if last_call

! !DESCRIPTION:
!     Calculates geopotential and pressure to the kappa.  This is an expensive
!     operation and several out arrays are kept around for future use.
!
! !REVISION HISTORY:
!
!  WS  99.10.22: MPIed SJ's original SMP version
!  SJL 00.01.01: Merged C-core and D-core computation
!                SMP "decmposition" in E-W by combining i and j loops
!
!EOP
!---------------------------------------------------------------------
!BOC

! Local:
      integer i, j, k
      integer ixj, jp, it, i1, i2

      real p1d(im)
      real ptk
      real dpmin
      real dp
#ifndef MARS_GCM
      parameter (dpmin = 0.02)              ! unit: pascal
#endif 
      integer :: ixjs, ixje


#ifdef MARS_GCM
!      this valuation has been adopted in the cubed-sphere code
      dpmin = 0.01*ptop
#endif

      call fv_print_chksums( 'Entering  geop_d' )
      call fv_array_check( LOC(hs) )
      call fv_array_check( LOC(pt) )
      call fv_array_check( LOC(delp) )
      call fv_array_check( LOC(wz) )
      call fv_array_check( LOC(pk) )
      call fv_array_check( LOC(pe) )

      it = im / nx
      jp = nx * ( jlast - jfirst + 1 )
      call fv_array_limits( 1, jp, ixjs, ixje )

!$omp parallel do default(shared) private(i1, i2, ixj, i, j, k, p1d, ptk, dp)
!     do 2000 j=jfirst,jlast
      do 2000 ixj=ixjs, ixje !1, jp
!        
         j  = jfirst + (ixj-1)/nx
         i1 = 1 + it * mod(ixj-1, nx)
         i2 = i1 + it - 1
        
        ptk  = ptop ** akap
        do i=i1,i2
           p1d(i) = ptop
           pk(i,j,1) = ptk
           wz(i,j,km+1) = hs(i,j)
        enddo

        if( last_call ) then
            do i=i1,i2
               pe(i,1,j) = ptop
            enddo
        endif

#if !defined(SW_DYN)
        if( dp_check ) then
            do k=1, km-1
               do i=i1,i2
                  if(delp(i,j,k) < dpmin) then
! Remap from below and mix pt
                      dp = dpmin - delp(i,j,k)
                      pt(i,j,k) = (pt(i,j,k)*delp(i,j,k) + pt(i,j,k+1)*dp) / dpmin
                      delp(i,j,k) = dpmin
                      delp(i,j,k+1) = delp(i,j,k+1) - dp
                  endif
               enddo
            enddo

! Bottom (k=km):
            do i=i1,i2
               if(delp(i,j,km) < dpmin) then
! Remap from above and mix pt
                   dp = dpmin - delp(i,j,km)
                   pt(i,j,km) = (pt(i,j,km)*delp(i,j,km) + pt(i,j,km-1)*dp)/dpmin
                   delp(i,j,km) = dpmin
                   delp(i,j,km-1) = delp(i,j,km-1) - dp
               endif
            enddo
        endif
#endif

! Top down
        do k=2,km+1
           do i=i1,i2
              p1d(i)  = p1d(i) + delp(i,j,k-1)
              pk(i,j,k) = p1d(i) ** akap
           enddo
           if( last_call ) then
               do i=i1,i2
                  pe(i,k,j) = p1d(i)
               enddo
           endif
        enddo

! Bottom up
        do k=km,1,-1
           do i=i1,i2
              wz(i,j,k) = wz(i,j,k+1) + pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))
           enddo
        enddo
2000    continue
        call fv_array_sync()
        call fv_print_chksums( 'Exiting  geop_d' )
 end subroutine geop_d


 subroutine geopk(ptop, pe, delp, pk, wz, hs, pt, im, jm, km,  &
      jfirst, jlast, nd, akap, nx, id, dp_check)

   integer im, jm, km, jfirst, jlast, id
   integer nx                        ! # of pieces in longitude direction
   integer nd
   real    akap, ptop
   logical dp_check
   real hs(im,jfirst:jlast)

! !INPUT/OUTPUT PARAMETERS:
   real  pt(im,jfirst-nd:jlast+nd,km)  ! only altered if dp_check
   real delp(im,jfirst:jlast,km)      ! only altered if dp_check

! !OUTPUT PARAMETERS
   real wz(im,jfirst-1:jlast+1,km+1)  ! space N*1 S*1
   real pk(im,jfirst-1:jlast+1,km+1)  ! space N*1 S*1
   real pe(im,km+1,jfirst:jlast)      ! only if id == 1

! !DESCRIPTION:
!     Calculates geopotential and pressure to the kappa.  This is an expensive
!     operation and several out arrays are kept around for future use.
!
! !REVISION HISTORY:
!
!  WS  99.10.22: MPIed SJ's original SMP version
!  SJL 00.01.01: Merged C-core and D-core computation
!                SMP "decmposition" in E-W by combining i and j loops
!
!EOP
!---------------------------------------------------------------------
!BOC

! Local:
   integer i, j, k
   real    p1d(im)
   integer ixj, jp, it, i1, i2

   integer :: ixjs, ixje

   real ptk
   real dpmin
   real dp
#ifdef MARS_GCM
!      this valuation has been adopted in the cubed-sphere code
     dpmin = 0.01*ptop
#else
!    rjw    Note that dpmin was 0.02 in the memphis code  
   parameter (dpmin = 0.1)              ! unit: pascal
#endif MARS_GCM

   call fv_print_chksums( 'Entering  geopk' )
   call fv_array_check( LOC(hs) )
   call fv_array_check( LOC(pt) )
   call fv_array_check( LOC(delp) )
   call fv_array_check( LOC(wz) )
   call fv_array_check( LOC(pk) )
   call fv_array_check( LOC(pe) )

   it = im / nx
   jp = nx * ( jlast - jfirst + 1 )
   call fv_array_limits( 1, jp, ixjs, ixje )

!$omp parallel do default(shared) private(i1, i2, ixj, i, j, k, p1d, ptk, dp)

!     do 2000 j=jfirst,jlast
   do 2000 ixj=ixjs, ixje !1, jp

      j  = jfirst + (ixj-1)/nx
      i1 = 1 + it * mod(ixj-1, nx)
      i2 = i1 + it - 1

      ptk  = ptop ** akap
      do i=i1,i2
         p1d(i) = ptop
         pk(i,j,1) = ptk
         wz(i,j,km+1) = hs(i,j)
      enddo

      if(id .eq. 1) then
          do i=i1,i2
             pe(i,1,j) = ptop
          enddo
      endif

      if( dp_check ) then

          do k=1, km-1
             do i=i1,i2
                if(delp(i,j,k) < dpmin) then
! Remap from below and mix pt
                    dp = dpmin - delp(i,j,k)
                    pt(i,j,k) = (pt(i,j,k)*delp(i,j,k) + pt(i,j,k+1)*dp) / dpmin
                    delp(i,j,k) = dpmin
                    delp(i,j,k+1) = delp(i,j,k+1) - dp
                endif
             enddo
          enddo

! Bottom (k=km):
          do i=i1,i2
             if(delp(i,j,km) < dpmin) then
! Remap from above and mix pt
                 dp = dpmin - delp(i,j,km)
                 pt(i,j,km) = (pt(i,j,km)*delp(i,j,km) + pt(i,j,km-1)*dp)/dpmin
                 delp(i,j,km) = dpmin
                 delp(i,j,km-1) = delp(i,j,km-1) - dp
             endif
          enddo
      endif

! Top down
      do k=2,km+1
         do i=i1,i2
            p1d(i)  = p1d(i) + delp(i,j,k-1)
            pk(i,j,k) = p1d(i) ** akap
         enddo
         if(id == 1) then
             do i=i1,i2
                pe(i,k,j) = p1d(i)
             enddo
         endif
      enddo

! Bottom up
      do k=km,1,-1
         do i=i1,i2
            wz(i,j,k) = wz(i,j,k+1)+pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))
         enddo
      enddo
2000 end do !continue
   call fv_array_sync()
   call fv_print_chksums( 'Exiting  geopk' )
 end subroutine geopk

end module dyn_core

#include <fms_platform.h>

MODULE diag_util_mod
  ! <CONTACT EMAIL="seth.underwood@noaa.gov">
  !   Seth Underwood
  ! </CONTACT>
  ! <HISTORY SRC="http://cobweb.gfdl.noaa.gov/fms-cgi-bin/viewcvs/FMS/shared/diag_manager/"/>

  ! <OVERVIEW>
  !   Functions and subroutines necessary for the <TT>diag_manager_mod</TT>.
  ! </OVERVIEW>

  ! <DESCRIPTION>
  !   <TT>diag_util_mod</TT> is a set of Fortran functions and subroutines used by the <TT>diag_manager_mod</TT>.
  ! </DESCRIPTION>

  ! <INFO>
  !   <FUTURE>
  !     Make an interface <TT>check_bounds_are_exact</TT> for the subroutines <TT>check_bounds_are_exact_static</TT> and
  !     <TT>check_bounds_are_exact_dynamic</TT>.
  !     <PRE>
  !       INTERFACE check_bounds_are_exact
  !         MODULE PROCEDURE check_bounds_are_exact_static
  !         MODULE PROCEDURE check_bounds_are_exact_dynamic
  !       END INTERFACE check_bounds_are_exact
  !     </PRE>
  !   </FUTURE>
  ! </INFO>
  USE diag_data_mod, ONLY  : output_fields, input_fields, files, do_diag_field_log, diag_log_unit,&
       & VERY_LARGE_AXIS_LENGTH, time_zero, VERY_LARGE_FILE_FREQ, END_OF_RUN, EVERY_TIME,&
       & DIAG_SECONDS, DIAG_MINUTES, DIAG_HOURS, DIAG_DAYS, DIAG_MONTHS, DIAG_YEARS, base_time,&
       & time_unit_list, max_files, base_year, base_month, base_day, base_hour, base_minute,&
       & base_second, num_files, max_files, max_fields_per_file, max_out_per_in_field,&
       & max_input_fields,num_input_fields, max_output_fields, num_output_fields, coord_type,&
       & mix_snapshot_average_fields, global_descriptor, CMOR_MISSING_VALUE, use_cmor, pack_size,&
       & debug_diag_manager, conserve_water, output_field_type, max_field_attributes, max_file_attributes,&
       & file_type, prepend_date, region_out_use_alt_value, GLO_REG_VAL, GLO_REG_VAL_ALT,&
       & DIAG_FIELD_NOT_FOUND, diag_init_time
  USE diag_axis_mod, ONLY  : get_diag_axis_data, get_axis_global_length, get_diag_axis_cart,&
       & get_domain1d, get_domain2d, diag_subaxes_init, diag_axis_init, get_diag_axis, get_axis_aux,&
       & get_axes_shift, get_diag_axis_name, get_diag_axis_domain_name
  USE diag_output_mod, ONLY: diag_flush, diag_field_out, diag_output_init, write_axis_meta_data,&
       & write_field_meta_data, done_meta_data
  USE diag_grid_mod, ONLY: get_local_indexes
  USE fms_mod, ONLY        : error_mesg, FATAL, WARNING, mpp_pe, mpp_root_pe, lowercase, fms_error_handler
  USE fms_io_mod, ONLY     : get_tile_string, return_domain, string
  USE mpp_domains_mod,ONLY : domain1d, domain2d, mpp_get_compute_domain, null_domain1d, null_domain2d,&
       & OPERATOR(.NE.), OPERATOR(.EQ.), mpp_modify_domain, mpp_get_domain_components,&
       & mpp_get_ntile_count, mpp_get_current_ntile, mpp_get_tile_id, mpp_mosaic_defined, mpp_get_tile_npes
  USE time_manager_mod,ONLY: time_type, OPERATOR(==), OPERATOR(>), NO_CALENDAR, increment_date,&
       & increment_time, get_calendar_type, get_date, get_time, leap_year, OPERATOR(-),&
       & OPERATOR(<), OPERATOR(>=), OPERATOR(<=)
  USE mpp_io_mod, ONLY : mpp_close
  USE mpp_mod, ONLY : mpp_npes
  USE fms_io_mod, ONLY : get_instance_filename
  USE constants_mod, ONLY : SECONDS_PER_DAY, SECONDS_PER_HOUR, SECONDS_PER_MINUTE

#ifdef use_netCDF
  USE netcdf, ONLY: NF90_CHAR
#endif

  IMPLICIT NONE
  PRIVATE
  PUBLIC get_subfield_size, log_diag_field_info, update_bounds, check_out_of_bounds,&
       & check_bounds_are_exact_dynamic, check_bounds_are_exact_static, init_file, diag_time_inc,&
       & find_input_field, init_input_field, init_output_field, diag_data_out, write_static,&
       & check_duplicate_output_fields, get_date_dif, get_subfield_vert_size, sync_file_times,&
       & prepend_attribute, attribute_init

  ! <INTERFACE NAME="prepend_attribute">
  !   <OVERVIEW>
  !     prepend a value to a string attribute in the output field or output file
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE prepend_attribute(output_field, att_name, att_value)
  !     SUBROUTINE prepend_attribute(output_file, att_name, att_value)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Prepend a character string to a character attribute for a give field, or to a global attribute
  !     in a give file.
  !   </DESCRIPTION>
  !   <IN NAME="output_field" TYPE="TYPE(output_field_type)" />
  !   <IN NAME="output_file" TYPE="TYPE(file_type)" />
  !   <IN NAME="att_name" TYPE="CHARACTER(len=*)" />
  !   <IN NAME="att_value" TYPE="REAL|INTEGER|CHARACTER(len=*)" />
  INTERFACE prepend_attribute
     MODULE PROCEDURE prepend_attribute_field
     MODULE PROCEDURE prepend_attribute_file
  END INTERFACE prepend_attribute
  ! </INTERFACE>

  ! <INTERFACE NAME="attribute_init">
  !   <OVERVIEW>
  !     Allocates the atttype in out_file
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE attribute_init(out_file, err_msg)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Allocates memory in out_file for the attributes.  Will <TT>FATAL</TT> if err_msg is not included
  !     in the subroutine call.
  !   </DESCRIPTION>
  !   <INOUT NAME="out_field" TYPE="TYPE(output_field_type)">output field to allocate memory for attribute</INOUT>
  !   <INOUT NAME="out_file" TYPE="TYPE(file_type)">output file to allocate memory for attribute</INOUT>
  !   <OUT NAME="err_msg" TYPE="CHARACTER(len=*), OPTIONAL">Error message, passed back to calling function</OUT>
  INTERFACE attribute_init
     MODULE PROCEDURE attribute_init_field
     MODULE PROCEDURE attribute_init_file
  END INTERFACE attribute_init
  ! </INTERFACE>

  CHARACTER(len=128),PRIVATE  :: version =&
       & '$Id$'
  CHARACTER(len=128),PRIVATE  :: tagname =&
       & '$Name$'

CONTAINS

  ! <SUBROUTINE NAME="get_subfield_size">
  !   <OVERVIEW>
  !     Get the size, start, and end indices for output fields.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE get_subfield_size(axes, outnum)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Get the size, start and end indices for <TT>output_fields(outnum)</TT>, then
  !     fill in <TT>output_fields(outnum)%output_grid%(start_indx, end_indx)</TT>
  !   </DESCRIPTION>
  !   <IN NAME="axes" TYPE="INTEGER, DIMENSION(:)">Axes of the <TT>input_field</TT>.</IN>
  !   <IN NAME="outnum" TYPE="INTEGER">Position in array <TT>output_fields</TT>.</IN>
  SUBROUTINE get_subfield_size(axes, outnum)
    INTEGER, INTENT(in) :: axes(:) ! axes of the input_field
    INTEGER, INTENT(in) :: outnum  ! position in array output_fields

    REAL, ALLOCATABLE   :: global_lat(:), global_lon(:), global_depth(:)
    INTEGER :: global_axis_size
    INTEGER :: i,xbegin,xend,ybegin,yend,xbegin_l,xend_l,ybegin_l,yend_l
    CHARACTER(len=1) :: cart
    TYPE(domain2d) :: Domain2, Domain2_new
    TYPE(domain1d) :: Domain1, Domain1x, Domain1y
    REAL :: start(3), end(3) ! start and end coordinates in 3 axes
    INTEGER :: gstart_indx(3), gend_indx(3) ! global start and end indices of output domain in 3 axes
    REAL, ALLOCATABLE :: subaxis_x(:), subaxis_y(:), subaxis_z(:) !containing local coordinates in x,y,z axes
    CHARACTER(len=128) :: msg
    INTEGER :: ishift, jshift
    INTEGER :: grv !< Value used to determine if the region defined in the diag_table is for the whole axis, or a sub-axis
    CHARACTER(len=128), DIMENSION(2) :: axis_domain_name

    !initilization for local output
    ! initially out of (lat/lon/depth) range
    start = -1.e10
    end = -1.e10
    gstart_indx = -1
    gend_indx = -1

    ! get the value to compare to determine if writing full axis data
    IF ( region_out_use_alt_value ) THEN
       grv = GLO_REG_VAL_ALT
    ELSE
       grv = GLO_REG_VAL
    END IF

    ! get axis data (lat, lon, depth) and indices
    start = output_fields(outnum)%output_grid%start
    end = output_fields(outnum)%output_grid%end

    CALL get_diag_axis_domain_name(axes(1), axis_domain_name(1))
    CALL get_diag_axis_domain_name(axes(2), axis_domain_name(2))

    IF (   INDEX(lowercase(axis_domain_name(1)), 'cubed') == 0 .AND. &
         & INDEX(lowercase(axis_domain_name(2)), 'cubed') == 0 ) THEN
       DO i = 1, SIZE(axes(:))
          global_axis_size = get_axis_global_length(axes(i))
          output_fields(outnum)%output_grid%subaxes(i) = -1
          CALL get_diag_axis_cart(axes(i), cart)
          SELECT CASE(cart)
          CASE ('X')
             ! <ERROR STATUS="FATAL">wrong order of axes.  X should come first.</ERROR>
             IF( i.NE.1 ) CALL error_mesg('diag_util_mod::get_subfield_size',&
                  & 'wrong order of axes, X should come first',FATAL)
             ALLOCATE(global_lon(global_axis_size))
             CALL get_diag_axis_data(axes(i),global_lon)
             IF( INT(start(i)) == grv .AND. INT(end(i)) == grv ) THEN
                gstart_indx(i) = 1
                gend_indx(i) = global_axis_size
                output_fields(outnum)%output_grid%subaxes(i) = axes(i)
             ELSE
                gstart_indx(i) = get_index(start(i),global_lon)
                gend_indx(i) = get_index(END(i),global_lon)
             END IF
             ALLOCATE(subaxis_x(gstart_indx(i):gend_indx(i)))
             subaxis_x=global_lon(gstart_indx(i):gend_indx(i))
          CASE ('Y')
             ! <ERROR STATUS="FATAL">wrong order of axes, Y should come second.</ERROR>
             IF( i.NE.2 ) CALL error_mesg('diag_util_mod::get_subfield_size',&
                  & 'wrong order of axes, Y should come second',FATAL)
             ALLOCATE(global_lat(global_axis_size))
             CALL get_diag_axis_data(axes(i),global_lat)
             IF( INT(start(i)) == grv .AND. INT(END(i)) == grv ) THEN
                gstart_indx(i) = 1
                gend_indx(i) = global_axis_size
                output_fields(outnum)%output_grid%subaxes(i) = axes(i)
             ELSE
                gstart_indx(i) = get_index(start(i),global_lat)
                gend_indx(i) = get_index(END(i),global_lat)
             END IF
             ALLOCATE(subaxis_y(gstart_indx(i):gend_indx(i)))
             subaxis_y=global_lat(gstart_indx(i):gend_indx(i))
          CASE ('Z')
             ! <ERROR STATUS="FATAL">wrong values in vertical axis of region</ERROR>
             IF ( start(i)*END(i)<0. ) CALL error_mesg('diag_util_mod::get_subfield_size',&
                  & 'wrong values in vertical axis of region',FATAL)
             IF ( start(i)>=0. .AND. END(i)>0. ) THEN
                ALLOCATE(global_depth(global_axis_size))
                CALL get_diag_axis_data(axes(i),global_depth)
                gstart_indx(i) = get_index(start(i),global_depth)
                gend_indx(i) = get_index(END(i),global_depth)
                ALLOCATE(subaxis_z(gstart_indx(i):gend_indx(i)))
                subaxis_z=global_depth(gstart_indx(i):gend_indx(i))
                output_fields(outnum)%output_grid%subaxes(i) =&
                     & diag_subaxes_init(axes(i),subaxis_z, gstart_indx(i),gend_indx(i))
                DEALLOCATE(subaxis_z,global_depth)
             ELSE ! regional vertical axis is the same as global vertical axis
                gstart_indx(i) = 1
                gend_indx(i) = global_axis_size
                output_fields(outnum)%output_grid%subaxes(i) = axes(i)
                ! <ERROR STATUS="FATAL">i should equal 3 for z axis</ERROR>
                IF( i /= 3 ) CALL error_mesg('diag_util_mod::get_subfield_size',&
                     & 'i should equal 3 for z axis', FATAL)
             END IF
          CASE default
             ! <ERROR STATUS="FATAL">Wrong axis_cart</ERROR>
             CALL error_mesg('diag_util_mod::get_subfield_size', 'Wrong axis_cart', FATAL)
          END SELECT
       END DO

       DO i = 1, SIZE(axes(:))
          IF ( gstart_indx(i) == -1 .OR. gend_indx(i) == -1 ) THEN
             ! <ERROR STATUS="FATAL">
             !   can not find gstart_indx/gend_indx for <output_fields(outnum)%output_name>,
             !   check region bounds for axis <i>.
             ! </ERROR>
             WRITE(msg,'(A,I2)') ' check region bounds for axis ', i
             CALL error_mesg('diag_util_mod::get_subfield_size', 'can not find gstart_indx/gend_indx for '&
                  & //TRIM(output_fields(outnum)%output_name)//','//TRIM(msg), FATAL)
          END IF
       END DO
    ELSE ! cubed sphere
       ! get the i and j start and end indexes
       CALL get_local_indexes(LONSTART=start(1), LONEND=END(1), &
            &                 LATSTART=start(2), LATEND=END(2), &
            &                 ISTART=gstart_indx(1), IEND=gend_indx(1), &
            &                 JSTART=gstart_indx(2), JEND=gend_indx(2))
       global_axis_size =  get_axis_global_length(axes(1))
       ALLOCATE(global_lon(global_axis_size))
       global_axis_size = get_axis_global_length(axes(2))
       ALLOCATE(global_lat(global_axis_size))
       CALL get_diag_axis_data(axes(1),global_lon)
       CALL get_diag_axis_data(axes(2),global_lat)
       IF (   (gstart_indx(1) > 0 .AND. gstart_indx(2) > 0) .AND. &
            & (gend_indx(1) > 0 .AND. gend_indx(2) > 0) ) THEN
          ALLOCATE(subaxis_x(gstart_indx(1):gend_indx(1)))
          ALLOCATE(subaxis_y(gstart_indx(2):gend_indx(2)))
          subaxis_x=global_lon(gstart_indx(1):gend_indx(1))
          subaxis_y=global_lat(gstart_indx(2):gend_indx(2))
       END IF

       ! Now deal with the Z component
       IF ( SIZE(axes(:)) > 2 ) THEN
          global_axis_size = get_axis_global_length(axes(3))
          output_fields(outnum)%output_grid%subaxes(3) = -1
          CALL get_diag_axis_cart(axes(3), cart)
          ! <ERROR STATUS="FATAL">
          !   axis(3) should be Z-axis
          ! </ERROR>
          IF ( lowercase(cart) /= 'z' ) CALL error_mesg('diag_util_mod::get_subfield_size', &
               &'axis(3) should be Z-axis', FATAL)
          ! <ERROR STATUS="FATAL">
          !   wrong values in vertical axis of region
          ! </ERROR>
          IF ( start(3)*END(3)<0. ) CALL error_mesg('diag_util_mod::get_subfield_size',&
               & 'wrong values in vertical axis of region',FATAL)
          IF ( start(3)>=0. .AND. END(3)>0. ) THEN
             ALLOCATE(global_depth(global_axis_size))
             CALL get_diag_axis_data(axes(3),global_depth)
             gstart_indx(3) = get_index(start(3),global_depth)
             IF( start(3) == 0.0 )  gstart_indx(3) = 1
             gend_indx(3) = get_index(END(3),global_depth)
             IF( start(3) >= MAXVAL(global_depth) ) gstart_indx(3)= global_axis_size
             IF( END(3)   >= MAXVAL(global_depth) ) gend_indx(3)  = global_axis_size

             ALLOCATE(subaxis_z(gstart_indx(3):gend_indx(3)))
             subaxis_z=global_depth(gstart_indx(3):gend_indx(3))
             output_fields(outnum)%output_grid%subaxes(3) =&
                  & diag_subaxes_init(axes(3),subaxis_z, gstart_indx(3),gend_indx(3))
             DEALLOCATE(subaxis_z,global_depth)
          ELSE ! regional vertical axis is the same as global vertical axis
             gstart_indx(3) = 1
             gend_indx(3) = global_axis_size
             output_fields(outnum)%output_grid%subaxes(3) = axes(3)
          END IF
       END IF
    END IF

    ! get domain and compute_domain(xbegin,xend,ybegin,yend)
    xbegin = -1
    xend = -1
    ybegin = -1
    yend = -1

    Domain2 = get_domain2d(axes)
    IF ( Domain2 .NE. NULL_DOMAIN2D ) THEN
       CALL mpp_get_compute_domain(Domain2, xbegin, xend, ybegin, yend)
       CALL mpp_get_domain_components(Domain2, Domain1x, Domain1y)
    ELSE
       DO i = 1, MIN(SIZE(axes(:)),2)
          Domain1 = get_domain1d(axes(i))
          IF ( Domain1 .NE. NULL_DOMAIN1D ) THEN
             CALL get_diag_axis_cart(axes(i),cart)
             SELECT CASE(cart)
             CASE ('X')
                Domain1x = get_domain1d(axes(i))
                CALL mpp_get_compute_domain(Domain1x, xbegin, xend)
             CASE ('Y')
                Domain1y = get_domain1d(axes(i))
                CALL mpp_get_compute_domain(Domain1y, ybegin, yend)
             CASE default ! do nothing here
             END SELECT
          ELSE
             ! <ERROR STATUS="FATAL">No domain available</ERROR>
             CALL error_mesg('diag_util_mod::get_subfield_size', 'NO domain available', FATAL)
          END IF
       END DO
    END IF

    CALL get_axes_shift(axes, ishift, jshift)
    xend = xend+ishift
    yend = yend+jshift

    IF ( xbegin == -1 .OR. xend == -1 .OR. ybegin == -1 .OR. yend == -1 ) THEN
       ! <ERROR STATUS="FATAL">wrong compute domain indices</ERROR>
       CALL error_mesg('diag_util_mod::get_subfield_size', 'wrong compute domain indices',FATAL)
    END IF

    ! get the area containing BOTH compute domain AND local output area
    IF( gstart_indx(1) > xend .OR. xbegin > gend_indx(1) ) THEN
       output_fields(outnum)%output_grid%l_start_indx(1) = -1
       output_fields(outnum)%output_grid%l_end_indx(1) = -1
       output_fields(outnum)%need_compute = .FALSE. ! not involved
    ELSEIF ( gstart_indx(2) > yend .OR. ybegin > gend_indx(2) ) THEN
       output_fields(outnum)%output_grid%l_start_indx(2) = -1
       output_fields(outnum)%output_grid%l_end_indx(2) = -1
       output_fields(outnum)%need_compute = .FALSE. ! not involved
    ELSE
       output_fields(outnum)%output_grid%l_start_indx(1) = MAX(xbegin, gstart_indx(1))
       output_fields(outnum)%output_grid%l_start_indx(2) = MAX(ybegin, gstart_indx(2))
       output_fields(outnum)%output_grid%l_end_indx(1) = MIN(xend, gend_indx(1))
       output_fields(outnum)%output_grid%l_end_indx(2) = MIN(yend, gend_indx(2))
       output_fields(outnum)%need_compute = .TRUE.  ! involved in local output
    END IF

    IF ( output_fields(outnum)%need_compute ) THEN
       ! need to modify domain1d and domain2d for subaxes
       xbegin_l = output_fields(outnum)%output_grid%l_start_indx(1)
       xend_l = output_fields(outnum)%output_grid%l_end_indx(1)
       ybegin_l = output_fields(outnum)%output_grid%l_start_indx(2)
       yend_l = output_fields(outnum)%output_grid%l_end_indx(2)
       CALL mpp_modify_domain(Domain2, Domain2_new, xbegin_l,xend_l, ybegin_l,yend_l,&
            & gstart_indx(1),gend_indx(1), gstart_indx(2),gend_indx(2))

       output_fields(outnum)%output_grid%subaxes(1) =&
            & diag_subaxes_init(axes(1),subaxis_x, gstart_indx(1),gend_indx(1),Domain2_new)
       output_fields(outnum)%output_grid%subaxes(2) =&
            & diag_subaxes_init(axes(2),subaxis_y, gstart_indx(2),gend_indx(2),Domain2_new)
       DO i = 1, SIZE(axes(:))
          IF ( output_fields(outnum)%output_grid%subaxes(i) == -1 ) THEN
             ! <ERROR STATUS="FATAL">
             !   <output_fields(outnum)%output_name> error at i = <i>
             ! </ERROR>
             WRITE(msg,'(a,"/",I4)') 'at i = ',i
             CALL error_mesg('diag_util_mod::get_subfield_size '//TRIM(output_fields(outnum)%output_name),&
                  'error '//TRIM(msg), FATAL)
          END IF
       END DO

       ! local start index should start from 1
       output_fields(outnum)%output_grid%l_start_indx(1) = MAX(xbegin, gstart_indx(1)) - xbegin + 1
       output_fields(outnum)%output_grid%l_start_indx(2) = MAX(ybegin, gstart_indx(2)) - ybegin + 1
       output_fields(outnum)%output_grid%l_end_indx(1) = MIN(xend, gend_indx(1)) - xbegin + 1
       output_fields(outnum)%output_grid%l_end_indx(2) = MIN(yend, gend_indx(2)) - ybegin + 1
       IF ( SIZE(axes(:))>2 ) THEN
          output_fields(outnum)%output_grid%l_start_indx(3) = gstart_indx(3)
          output_fields(outnum)%output_grid%l_end_indx(3) = gend_indx(3)
       ELSE
          output_fields(outnum)%output_grid%l_start_indx(3) = 1
          output_fields(outnum)%output_grid%l_end_indx(3) = 1
       END IF
    END IF
    IF ( ALLOCATED(subaxis_x) ) DEALLOCATE(subaxis_x, global_lon)
    IF ( ALLOCATED(subaxis_y) ) DEALLOCATE(subaxis_y, global_lat)
  END SUBROUTINE get_subfield_size
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="get_subfield_vert_size">
  !   <OVERVIEW>
  !     Get size, start and end indices for output fields.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE get_subfield_vert_size(axes, outnum)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Get size, start and end indices for <TT>output_fields(outnum)</TT>, fill in
  !     <TT>output_fields(outnum)%output_grid%(start_indx, end_indx)</TT>.
  !   </DESCRIPTION>
  !   <IN NAME="axes" TYPE="INTEGER, DIMENSION(:)">Axes of the <TT>input_field</TT></IN>
  !   <IN NAME="outnum" TYPE="INTEGER">Position in array <TT>output_fields</TT>.</IN>
  SUBROUTINE get_subfield_vert_size(axes, outnum)
    INTEGER, DIMENSION(:), INTENT(in) :: axes ! axes of the input_field
    INTEGER, INTENT(in) :: outnum  ! position in array output_fields

    REAL, DIMENSION(3) :: start, end ! start and end coordinates in 3 axes
    REAL, ALLOCATABLE, DIMENSION(:) :: global_depth
    REAL, ALLOCATABLE, DIMENSION(:) :: subaxis_z !containing local coordinates in x,y,z axes
    INTEGER :: i, global_axis_size
    INTEGER, DIMENSION(3) :: gstart_indx, gend_indx ! global start and end indices of output domain in 3 axes
    CHARACTER(len=1) :: cart
    CHARACTER(len=128) :: msg

    !initilization for local output
    start = -1.e10
    end = -1.e10 ! initially out of (lat/lon/depth) range
    gstart_indx = -1
    gend_indx=-1

    ! get axis data (lat, lon, depth) and indices
    start= output_fields(outnum)%output_grid%start
    end = output_fields(outnum)%output_grid%end

    DO i = 1, SIZE(axes(:))
       global_axis_size = get_axis_global_length(axes(i))
       output_fields(outnum)%output_grid%subaxes(i) = -1
       CALL get_diag_axis_cart(axes(i), cart)
       SELECT CASE(cart)
       CASE ('X')
          ! <ERROR STATUS="FATAL">wrong order of axes, X should come first</ERROR>
          IF ( i.NE.1 ) CALL error_mesg('diag_util_mod::get_subfield_vert_size',&
               & 'wrong order of axes, X should come first',FATAL)
          gstart_indx(i) = 1
          gend_indx(i) = global_axis_size
          output_fields(outnum)%output_grid%subaxes(i) = axes(i)
       CASE ('Y')
          ! <ERROR STATUS="FATAL">wrong order of axes, Y should come second</ERROR>
          IF( i.NE.2 ) CALL error_mesg('diag_util_mod::get_subfield_vert_size',&
               & 'wrong order of axes, Y should come second',FATAL)
          gstart_indx(i) = 1
          gend_indx(i) = global_axis_size
          output_fields(outnum)%output_grid%subaxes(i) = axes(i)
       CASE ('Z')
          ! <ERROR STATUS="FATAL">wrong values in vertical axis of region</ERROR>
          IF( start(i)*END(i) < 0. ) CALL error_mesg('diag_util_mod::get_subfield_vert_size',&
               & 'wrong values in vertical axis of region',FATAL)
          IF( start(i) >= 0. .AND. END(i) > 0. ) THEN
             ALLOCATE(global_depth(global_axis_size))
             CALL get_diag_axis_data(axes(i),global_depth)
             gstart_indx(i) = get_index(start(i),global_depth)
             IF( start(i) == 0.0 )  gstart_indx(i) = 1

             gend_indx(i) = get_index(END(i),global_depth)
             IF( start(i) >= MAXVAL(global_depth) ) gstart_indx(i)= global_axis_size
             IF( END(i)   >= MAXVAL(global_depth) ) gend_indx(i)  = global_axis_size

             ALLOCATE(subaxis_z(gstart_indx(i):gend_indx(i)))
             subaxis_z=global_depth(gstart_indx(i):gend_indx(i))
             output_fields(outnum)%output_grid%subaxes(i) =&
                  & diag_subaxes_init(axes(i),subaxis_z, gstart_indx(i),gend_indx(i))
             DEALLOCATE(subaxis_z,global_depth)
          ELSE !   vertical axis is the same as global vertical axis
             gstart_indx(i) = 1
             gend_indx(i) = global_axis_size
             output_fields(outnum)%output_grid%subaxes(i) = axes(i)
             ! <ERROR STATUS="FATAL">i should equal 3 for z axis</ERROR>
             IF( i /= 3 ) CALL error_mesg('diag_util_mod::get_subfield_vert_size',&
                  & 'i should equal 3 for z axis', FATAL)
          END IF
       CASE default
          ! <ERROR STATUS="FATAL">Wrong axis_cart</ERROR>
          CALL error_mesg('diag_util_mod::get_subfield_vert_size', 'Wrong axis_cart', FATAL)
       END SELECT
    END DO

    DO i = 1,SIZE(axes(:))
       IF ( gstart_indx(i) == -1 .OR. gend_indx(i) == -1 ) THEN
          ! <ERROR STATUS="FATAL">
          !   can not find gstart_indx/gend_indx for <output_fields(outnum)%output_name>
          !   check region bounds for axis
          ! </ERROR>
          WRITE(msg,'(A,I2)') ' check region bounds for axis ', i
          CALL error_mesg('diag_util_mod::get_subfield_vert_size', 'can not find gstart_indx/gend_indx for '&
               & //TRIM(output_fields(outnum)%output_name)//','//TRIM(msg), FATAL)
       END IF
    END DO

    DO i= 1, 2
       output_fields(outnum)%output_grid%l_start_indx(i) = gstart_indx(i)
       output_fields(outnum)%output_grid%l_end_indx(i)   = gend_indx(i)
    END DO

    IF( SIZE(axes(:)) > 2 ) THEN
       output_fields(outnum)%output_grid%l_start_indx(3) = gstart_indx(3)
       output_fields(outnum)%output_grid%l_end_indx(3)   = gend_indx(3)
    ELSE
       output_fields(outnum)%output_grid%l_start_indx(3) = 1
       output_fields(outnum)%output_grid%l_end_indx(3)   = 1
    END IF
  END SUBROUTINE get_subfield_vert_size
  ! </SUBROUTINE>

  ! <PRIVATE>
  ! <FUNCTION NAME="get_index">
  !   <OVERVIEW>
  !     Find index <TT>i</TT> of array such that <TT>array(i)</TT> is closest to number.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     INTEGER FUNCTION get_index(number, array)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Find index <TT>i</TT> of array such that <TT>array(i)</TT> is closest to number.
  !     Array must be  monotonouslly ordered.
  !   </DESCRIPTION>
  !   <IN NAME="number" TYPE="REAL"></IN>
  !   <IN NAME="array" TYPE="REAL, DIMENSION(:)"></IN>
  INTEGER FUNCTION get_index(number, array)
    REAL, INTENT(in) :: number
    REAL, INTENT(in), DIMENSION(:) :: array

    INTEGER :: i, n
    LOGICAL :: found

    n = SIZE(array(:))
    ! check if array is monotonous
    DO i = 2, n-1
       IF( (array(i-1)<array(i).AND.array(i)>array(i+1)) .OR. (array(i-1)>array(i).AND.array(i)<array(i+1))) THEN
          ! <ERROR STATUS="FATAL">array NOT monotonously ordered</ERROR>
          CALL error_mesg('diag_util_mod::get_index', 'array NOT monotonously ordered',FATAL)
       END IF
    END DO
    get_index = -1
    found = .FALSE.
    ! search in increasing array
    DO i = 1, n-1
       IF ( (array(i)<=number).AND.(array(i+1)>= number) ) THEN
          IF( number - array(i) <= array(i+1) - number ) THEN
             get_index = i
             found=.TRUE.
          ELSE
             get_index = i+1
             found=.TRUE.
          ENDIF
          EXIT
       END IF
    END DO
    ! if not found, search in decreasing array
    IF( .NOT.found ) THEN
       DO i = 1, n-1
          IF ( (array(i)>=number).AND.(array(i+1)<= number) ) THEN
             IF ( array(i)-number <= number-array(i+1) ) THEN
                get_index = i
                found = .TRUE.
             ELSE
                get_index = i+1
                found = .TRUE.
             END IF
             EXIT
          END IF
       END DO
    END IF
    ! if still not found, is it less than the first element
    ! or greater than last element? (Increasing Array)
    ! But it must be within 2x the axis spacing
    ! i.e. array(1)-(array(3)-array(1)).LT.number .AND. or 2*array(1)-array(3).LT.number
    IF ( .NOT. found ) THEN
       IF ( 2*array(1)-array(3).LT.number .AND. number.LT.array(1) ) THEN
          get_index = 1
          found = .TRUE.
       ELSE IF ( array(n).LT.number .AND. number.LT.2*array(n)-array(n-2) ) THEN
          get_index = n
          found = .TRUE.
       ELSE
          found = .FALSE.
       END IF
    END IF

    ! if still not found, is it greater than the first element
    ! or less than the last element? (Decreasing Array)
    ! But it must be within 2x the axis spacing (see above)
    IF ( .NOT. found ) THEN
       IF ( 2*array(1)-array(3).GT.number .AND. number.GT.array(1) ) THEN
          get_index = 1
          found = .TRUE.
       ELSE IF ( array(n).GT.number .AND. number.GT.2*array(n)-array(n-2) ) THEN
          get_index = n
          found = .TRUE.
       ELSE
          found = .FALSE.
       END IF
    END IF
  END FUNCTION get_index
  ! </FUNCTION>
  ! </PRIVATE>

  ! <SUBROUTINE NAME="log_diag_field_info">
  !   <OVERVIEW>
  !     Writes brief diagnostic field info to the log file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE log_diag_field_info(module_name, field_name, axes, long_name, units,
  !     missing_value, range, dynamic)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     If the <TT>do_diag_field_log</TT> namelist parameter is .TRUE.,
  !     then a line briefly describing diagnostic field is added to
  !     the log file.  Normally users should not call this subroutine
  !     directly, since it is called by register_static_field and
  !     register_diag_field if do_not_log is not set to .TRUE..  It is
  !     used, however, in LM3 to avoid excessive logs due to the
  !     number of fields registered for each of the tile types.  LM3
  !     code uses a do_not_log parameter in the registration calls,
  !     and subsequently calls this subroutine to log field information
  !     under a generic name.
  !   </DESCRIPTION>
  !   <IN NAME="module_name" TYPE="CHARACTER(len=*)">Module name.</IN>
  !   <IN NAME="field_name" TYPE="CHARACTER(len=*)">Field name.</IN>
  !   <IN NAME="axes" TYPE="INTEGER, DIMENSION(:)">Axis IDs.</IN>
  !   <IN NAME="long_name" TYPE="CHARACTER(len=*), OPTIONAL">Long name for field.</IN>
  !   <IN NAME="units" TYPE="CHARACTER(len=*), OPTIONAL">Unit of field.</IN>
  !   <IN NAME="missing_value" TYPE="REAL, OPTIONAL">Missing value value.</IN>
  !   <IN NAME="range" TYPE="REAL, DIMENSION(2), OPTIONAL">Valid range of values for field.</IN>
  !   <IN NAME="dynamic" TYPE="LOGICAL, OPTIONAL"><TT>.TRUE.</TT> if field is not static.</IN>
  SUBROUTINE log_diag_field_info(module_name, field_name, axes, long_name, units,&
       & missing_value, range, dynamic)
    CHARACTER(len=*), INTENT(in) :: module_name, field_name
    INTEGER, DIMENSION(:), INTENT(in) :: axes
    CHARACTER(len=*), OPTIONAL, INTENT(in) :: long_name, units
    REAL, OPTIONAL, INTENT(in) :: missing_value
    REAL, DIMENSION(2), OPTIONAL, INTENT(IN) :: range
    LOGICAL, OPTIONAL, INTENT(in) :: dynamic

    ! ---- local vars
    CHARACTER(len=256) :: lmodule, lfield, lname, lunits
    CHARACTER(len=64)  :: lmissval, lmin, lmax
    CHARACTER(len=8)   :: numaxis, timeaxis
    CHARACTER(len=1)   :: sep = '|'
    CHARACTER(len=256) :: axis_name, axes_list
    INTEGER :: i

    IF ( .NOT.do_diag_field_log ) RETURN
    IF ( mpp_pe().NE.mpp_root_pe() ) RETURN

    lmodule = TRIM(module_name)
    lfield = TRIM(field_name)

    IF ( PRESENT(long_name) ) THEN
       lname  = TRIM(long_name)
    ELSE
       lname  = ''
    END IF

    IF ( PRESENT(units) ) THEN
       lunits = TRIM(units)
    ELSE
       lunits = ''
    END IF

    WRITE (numaxis,'(i1)') SIZE(axes)

    IF (PRESENT(missing_value)) THEN
       IF ( use_cmor ) THEN
          WRITE (lmissval,*) CMOR_MISSING_VALUE
       ELSE
          WRITE (lmissval,*) missing_value
       END IF
    ELSE
       lmissval = ''
    ENDIF

    IF ( PRESENT(range) ) THEN
       WRITE (lmin,*) range(1)
       WRITE (lmax,*) range(2)
    ELSE
       lmin = ''
       lmax = ''
    END IF

    IF ( PRESENT(dynamic) ) THEN
       IF (dynamic) THEN
          timeaxis = 'T'
       ELSE
          timeaxis = 'F'
       END IF
    ELSE
       timeaxis = ''
    END IF

    axes_list=''
    DO i = 1, SIZE(axes)
     if (axes(i) > 0) then
       CALL get_diag_axis_name(axes(i),axis_name)
     else
       axis_name = '?'
     endif
       IF ( TRIM(axes_list) /= '' ) axes_list = TRIM(axes_list)//','
       axes_list = TRIM(axes_list)//TRIM(axis_name)
    END DO

    !write (diag_log_unit,'(8(a,a),a)') &
    WRITE (diag_log_unit,'(777a)') &
         & TRIM(lmodule),  sep, TRIM(lfield),  sep, TRIM(lname),    sep,&
         & TRIM(lunits),   sep, TRIM(numaxis), sep, TRIM(timeaxis), sep,&
         & TRIM(lmissval), sep, TRIM(lmin),    sep, TRIM(lmax),     sep,&
         & TRIM(axes_list)
  END SUBROUTINE log_diag_field_info
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="update_bounds">
  !   <OVERVIEW>
  !     Update the <TT>output_fields</TT> min and max boundaries.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE update_bounds(out_num, lower_i, upper_i, lower_j, upper_j, lower_k, upper_k)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Update the <TT>output_fields</TT> x, y, and z min and max boundaries (array indices).
  !   </DESCRIPTION>
  !   <IN NAME="out_num" TYPE="INTEGER"><TT>output_field</TT> ID.</IN>
  !   <IN NAME="lower_i" TYPE="INTEGER">Lower <TT>i</TT> bound.</IN>
  !   <IN NAME="upper_i" TYPE="INTEGER">Upper <TT>i</TT> bound.</IN>
  !   <IN NAME="lower_j" TYPE="INTEGER">Lower <TT>j</TT> bound.</IN>
  !   <IN NAME="upper_j" TYPE="INTEGER">Upper <TT>j</TT> bound.</IN>
  !   <IN NAME="lower_k" TYPE="INTEGER">Lower <TT>k</TT> bound.</IN>
  !   <IN NAME="upper_k" TYPE="INTEGER">Upper <TT>k</TT> bound.</IN>
  SUBROUTINE update_bounds(out_num, lower_i, upper_i, lower_j, upper_j, lower_k, upper_k)
    INTEGER, INTENT(in) :: out_num, lower_i, upper_i, lower_j, upper_j, lower_k, upper_k

    output_fields(out_num)%imin = MIN(output_fields(out_num)%imin, lower_i)
    output_fields(out_num)%imax = MAX(output_fields(out_num)%imax, upper_i)
    output_fields(out_num)%jmin = MIN(output_fields(out_num)%jmin, lower_j)
    output_fields(out_num)%jmax = MAX(output_fields(out_num)%jmax, upper_j)
    output_fields(out_num)%kmin = MIN(output_fields(out_num)%kmin, lower_k)
    output_fields(out_num)%kmax = MAX(output_fields(out_num)%kmax, upper_k)
  END SUBROUTINE update_bounds
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="check_out_of_bounds">
  !   <OVERVIEW>
  !     Checks if the array indices for <TT>output_fields(out_num)</TT> are outside the <TT>output_fields(out_num)%buffer</TT> upper
  !     and lower bounds.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE check_out_of_bounds(out_num, diag_field_id, err_msg)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     <TT>check_out_of_bounds</TT> verifies the array min and max indices in the x, y, and z directions of <TT>
  !     output_fields(out_num)</TT> are not outside the upper and lower array boundaries of
  !     <TT>output_fields(out_num)%buffer</TT>.  If the min and max indices are outside the upper and lower bounds of the buffer
  !     array, then <TT>check_out_of_bounds</TT> returns an error string.
  !   </DESCRIPTION>
  !   <IN NAME="out_num" TYPE="INTEGER">
  !     Output field ID number.
  !   </IN>
  !   <IN NAME="diag_field_id" TYPE="INTEGER">
  !     Input field ID number.
  !   </IN>
  !   <OUT NAME="err_msg" TYPE="CHARACTER(len=*)">
  !     Return status of <TT>check_out_of_bounds</TT>.  An empty error string indicates the x, y, and z indices are not outside the
  !     buffer array boundaries.
  !   </OUT>
  SUBROUTINE check_out_of_bounds(out_num, diag_field_id, err_msg)
    INTEGER, INTENT(in) :: out_num, diag_field_id
    CHARACTER(len=*), INTENT(out) :: err_msg

    CHARACTER(len=128) :: error_string1, error_string2

    IF (   output_fields(out_num)%imin < LBOUND(output_fields(out_num)%buffer,1) .OR.&
         & output_fields(out_num)%imax > UBOUND(output_fields(out_num)%buffer,1) .OR.&
         & output_fields(out_num)%jmin < LBOUND(output_fields(out_num)%buffer,2) .OR.&
         & output_fields(out_num)%jmax > UBOUND(output_fields(out_num)%buffer,2) .OR.&
         & output_fields(out_num)%kmin < LBOUND(output_fields(out_num)%buffer,3) .OR.&
         & output_fields(out_num)%kmax > UBOUND(output_fields(out_num)%buffer,3) ) THEN
       WRITE(error_string1,'(a,"/",a)') TRIM(input_fields(diag_field_id)%module_name),&
            & TRIM(output_fields(out_num)%output_name)
       error_string2 ='Buffer bounds=   :   ,   :   ,   :     Actual bounds=   :   ,   :   ,   :   '
       WRITE(error_string2(15:17),'(i3)') LBOUND(output_fields(out_num)%buffer,1)
       WRITE(error_string2(19:21),'(i3)') UBOUND(output_fields(out_num)%buffer,1)
       WRITE(error_string2(23:25),'(i3)') LBOUND(output_fields(out_num)%buffer,2)
       WRITE(error_string2(27:29),'(i3)') UBOUND(output_fields(out_num)%buffer,2)
       WRITE(error_string2(31:33),'(i3)') LBOUND(output_fields(out_num)%buffer,3)
       WRITE(error_string2(35:37),'(i3)') UBOUND(output_fields(out_num)%buffer,3)
       WRITE(error_string2(54:56),'(i3)') output_fields(out_num)%imin
       WRITE(error_string2(58:60),'(i3)') output_fields(out_num)%imax
       WRITE(error_string2(62:64),'(i3)') output_fields(out_num)%jmin
       WRITE(error_string2(66:68),'(i3)') output_fields(out_num)%jmax
       WRITE(error_string2(70:72),'(i3)') output_fields(out_num)%kmin
       WRITE(error_string2(74:76),'(i3)') output_fields(out_num)%kmax
       err_msg = 'module/output_field='//TRIM(error_string1)//&
            & '  Bounds of buffer exceeded.  '//TRIM(error_string2)
       !   imax, imin, etc need to be reset in case the program is not terminated.
       output_fields(out_num)%imax = 0
       output_fields(out_num)%imin = VERY_LARGE_AXIS_LENGTH
       output_fields(out_num)%jmax = 0
       output_fields(out_num)%jmin = VERY_LARGE_AXIS_LENGTH
       output_fields(out_num)%kmax = 0
       output_fields(out_num)%kmin = VERY_LARGE_AXIS_LENGTH
    ELSE
       err_msg = ''
    END IF

  END SUBROUTINE check_out_of_bounds
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="check_bounds_are_exact_dynamic">
  !   <OVERVIEW>
  !     Check if the array indices for <TT>output_fields(out_num)</TT> are equal to the <TT>output_fields(out_num)%buffer</TT>
  !     upper and lower bounds.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE check_bounds_are_exact_dynamic(out_num, diag_field_id, Time, err_msg)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     <TT>check_bounds_are_exact_dynamic</TT> checks if the min and max array indices for <TT>output_fields(out_num)</TT> are
  !     equal to the upper and lower bounds of <TT>output_fields(out_num)%buffer</TT>.  This check is only performed if
  !     <TT>output_fields(out_num)%Time_of_prev_field_data</TT> doesn't equal <TT>Time</TT> or <TT>Time_zero</TT>.
  !     <TT>check_bounds_are_exact_dynamic</TT> returns an error string if the array indices do not match the buffer bounds.
  !   </DESCRIPTION>
  !   <IN NAME="out_num" TYPE="INTEGER">
  !     Output field ID number.
  !   </IN>
  !   <IN NAME="diag_field_id" TYPE="INTEGER">
  !     Input field ID number.
  !   </IN>
  !   <IN NAME="Time" TYPE="TYPE(time_type)">
  !     Time to use in check.  The check is only performed if <TT>output_fields(out_num)%Time_of_prev_field_data</TT> is not
  !     equal to <TT>Time</TT> or <TT>Time_zero</TT>.
  !   </IN>
  !   <OUT NAME="err_msg" TYPE="CHARACTER(len=*)">
  !     Return status of <TT>check_bounds_are_exact_dynamic</TT>.  An empty error string indicates the x, y, and z indices are
  !     equal to the buffer array boundaries.
  !   </OUT>
  SUBROUTINE check_bounds_are_exact_dynamic(out_num, diag_field_id, Time, err_msg)
    INTEGER, INTENT(in) :: out_num, diag_field_id
    TYPE(time_type), INTENT(in) :: Time
    CHARACTER(len=*), INTENT(out) :: err_msg

    CHARACTER(len=128) :: error_string1, error_string2
    LOGICAL :: do_check

    err_msg = ''

    ! Check bounds only when the value of Time changes. When windows are used,
    ! a change in Time indicates that a new loop through the windows has begun,
    !  so a check of the previous loop can be done.
    IF ( Time == output_fields(out_num)%Time_of_prev_field_data ) THEN
       do_check = .FALSE.
    ELSE
       IF ( output_fields(out_num)%Time_of_prev_field_data == Time_zero ) THEN
          ! It may or may not be OK to check, I don't know how to tell.
          ! Check will be done on subsequent calls anyway.
          do_check = .FALSE.
       ELSE
          do_check = .TRUE.
       END IF
       output_fields(out_num)%Time_of_prev_field_data = Time
    END IF

    IF ( do_check ) THEN
       IF (   output_fields(out_num)%imin /= LBOUND(output_fields(out_num)%buffer,1) .OR.&
            & output_fields(out_num)%imax /= UBOUND(output_fields(out_num)%buffer,1) .OR.&
            & output_fields(out_num)%jmin /= LBOUND(output_fields(out_num)%buffer,2) .OR.&
            & output_fields(out_num)%jmax /= UBOUND(output_fields(out_num)%buffer,2) .OR.&
            & output_fields(out_num)%kmin /= LBOUND(output_fields(out_num)%buffer,3) .OR.&
            & output_fields(out_num)%kmax /= UBOUND(output_fields(out_num)%buffer,3) ) THEN
          WRITE(error_string1,'(a,"/",a)') TRIM(input_fields(diag_field_id)%module_name),&
               & TRIM(output_fields(out_num)%output_name)
          error_string2 ='Buffer bounds=   :   ,   :   ,   :     Actual bounds=   :   ,   :   ,   :   '
          WRITE(error_string2(15:17),'(i3)') LBOUND(output_fields(out_num)%buffer,1)
          WRITE(error_string2(19:21),'(i3)') UBOUND(output_fields(out_num)%buffer,1)
          WRITE(error_string2(23:25),'(i3)') LBOUND(output_fields(out_num)%buffer,2)
          WRITE(error_string2(27:29),'(i3)') UBOUND(output_fields(out_num)%buffer,2)
          WRITE(error_string2(31:33),'(i3)') LBOUND(output_fields(out_num)%buffer,3)
          WRITE(error_string2(35:37),'(i3)') UBOUND(output_fields(out_num)%buffer,3)
          WRITE(error_string2(54:56),'(i3)') output_fields(out_num)%imin
          WRITE(error_string2(58:60),'(i3)') output_fields(out_num)%imax
          WRITE(error_string2(62:64),'(i3)') output_fields(out_num)%jmin
          WRITE(error_string2(66:68),'(i3)') output_fields(out_num)%jmax
          WRITE(error_string2(70:72),'(i3)') output_fields(out_num)%kmin
          WRITE(error_string2(74:76),'(i3)') output_fields(out_num)%kmax
          err_msg = TRIM(error_string1)//' Bounds of data do not match those of buffer. '//TRIM(error_string2)
       END IF
       output_fields(out_num)%imax = 0
       output_fields(out_num)%imin = VERY_LARGE_AXIS_LENGTH
       output_fields(out_num)%jmax = 0
       output_fields(out_num)%jmin = VERY_LARGE_AXIS_LENGTH
       output_fields(out_num)%kmax = 0
       output_fields(out_num)%kmin = VERY_LARGE_AXIS_LENGTH
    END IF
  END SUBROUTINE check_bounds_are_exact_dynamic
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="check_bounds_are_exact_static">
  !   <OVERVIEW>
  !     Check if the array indices for <TT>output_fields(out_num)</TT> are equal to the <TT>output_fields(out_num)%buffer</TT>
  !     upper and lower bounds.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE check_bounds_are_exact_static(out_num, diag_field_id, err_msg)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !   </DESCRIPTION>
  !   <IN NAME="out_num" TYPE="INTEGER">Output field ID</IN>
  !   <IN NAME="diag_field_id" TYPE="INTEGER">Input field ID.</IN>
  !   <OUT NAME="err_msg" TYPE="CHARACTER(len=*)"></OUT>
  SUBROUTINE check_bounds_are_exact_static(out_num, diag_field_id, err_msg)
    INTEGER, INTENT(in) :: out_num, diag_field_id
    CHARACTER(len=*), INTENT(out) :: err_msg

    CHARACTER(len=128)  :: error_string1, error_string2

    err_msg = ''

    IF (   output_fields(out_num)%imin /= LBOUND(output_fields(out_num)%buffer,1) .OR.&
         & output_fields(out_num)%imax /= UBOUND(output_fields(out_num)%buffer,1) .OR.&
         & output_fields(out_num)%jmin /= LBOUND(output_fields(out_num)%buffer,2) .OR.&
         & output_fields(out_num)%jmax /= UBOUND(output_fields(out_num)%buffer,2) .OR.&
         & output_fields(out_num)%kmin /= LBOUND(output_fields(out_num)%buffer,3) .OR.&
         & output_fields(out_num)%kmax /= UBOUND(output_fields(out_num)%buffer,3) ) THEN
       WRITE(error_string1,'(a,"/",a)') TRIM(input_fields(diag_field_id)%module_name),&
            & TRIM(output_fields(out_num)%output_name)
       error_string2 ='Buffer bounds=   :   ,   :   ,   :     Actual bounds=   :   ,   :   ,   :   '
       WRITE(error_string2(15:17),'(i3)') LBOUND(output_fields(out_num)%buffer,1)
       WRITE(error_string2(19:21),'(i3)') UBOUND(output_fields(out_num)%buffer,1)
       WRITE(error_string2(23:25),'(i3)') LBOUND(output_fields(out_num)%buffer,2)
       WRITE(error_string2(27:29),'(i3)') UBOUND(output_fields(out_num)%buffer,2)
       WRITE(error_string2(31:33),'(i3)') LBOUND(output_fields(out_num)%buffer,3)
       WRITE(error_string2(35:37),'(i3)') UBOUND(output_fields(out_num)%buffer,3)
       WRITE(error_string2(54:56),'(i3)') output_fields(out_num)%imin
       WRITE(error_string2(58:60),'(i3)') output_fields(out_num)%imax
       WRITE(error_string2(62:64),'(i3)') output_fields(out_num)%jmin
       WRITE(error_string2(66:68),'(i3)') output_fields(out_num)%jmax
       WRITE(error_string2(70:72),'(i3)') output_fields(out_num)%kmin
       WRITE(error_string2(74:76),'(i3)') output_fields(out_num)%kmax
       err_msg = TRIM(error_string1)//' Bounds of data do not match those of buffer. '//TRIM(error_string2)
    END IF
    output_fields(out_num)%imax = 0
    output_fields(out_num)%imin = VERY_LARGE_AXIS_LENGTH
    output_fields(out_num)%jmax = 0
    output_fields(out_num)%jmin = VERY_LARGE_AXIS_LENGTH
    output_fields(out_num)%kmax = 0
    output_fields(out_num)%kmin = VERY_LARGE_AXIS_LENGTH

  END SUBROUTINE check_bounds_are_exact_static
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="init_file">
  !   <OVERVIEW>
  !     Initialize the output file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE init_file(name, output_freq, output_units, format, time_units
  !     long_name, tile_count, new_file_freq, new_file_freq_units, start_time,
  !     file_duration, file_duration_units)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Initialize the output file.
  !   </DESCRIPTION>
  !   <IN NAME="name" TYPE="CHARACTER(len=*)">File name.</IN>
  !   <IN NAME="output_freq" TYPE="INTEGER">How often data is to be written to the file.</IN>
  !   <IN NAME="output_units" TYPE="INTEGER">The output frequency unit.  (MIN, HOURS, DAYS, etc.)</IN>
  !   <IN NAME="format" TYPE="INTEGER">Number type/kind the data is to be written out to the file.</IN>
  !   <IN NAME="time_units" TYPE="INTEGER">Time axis units.</IN>
  !   <IN NAME="log_name" TYPE="CHARACTER(len=*)">Long name for time axis.</IN>
  !   <IN NAME="tile_count" TYPE="INTEGER">Tile number.</IN>
  !   <IN NAME="new_file_freq" TYPE="INTEGER, OPTIONAL">How often a new file is to be created.</IN>
  !   <IN NAME="new_file_freq_units" TYPE="INTEGER, OPTIONAL">The new file frequency unit.  (MIN, HOURS, DAYS, etc.)</IN>
  !   <IN NAME="start_time" TYPE="TYPE(time_type), OPTIONAL">Time when the file is to start </IN>
  !   <IN NAME="file_duration" TYPE="INTEGER, OPTIONAL">How long file is to be used.</IN>
  !   <IN NAME="file_duration_units" TYPE="INTEGER, OPTIONAL">File duration unit.  (MIN, HOURS, DAYS, etc.)</IN>
  SUBROUTINE init_file(name, output_freq, output_units, FORMAT, time_units, long_name, tile_count,&
       & new_file_freq, new_file_freq_units, start_time, file_duration, file_duration_units)
    CHARACTER(len=*), INTENT(in) :: name, long_name
    INTEGER, INTENT(in) :: output_freq, output_units, FORMAT, time_units
    INTEGER, INTENT(in) :: tile_count
    INTEGER, INTENT(in), OPTIONAL :: new_file_freq, new_file_freq_units
    INTEGER, INTENT(in), OPTIONAL :: file_duration, file_duration_units
    TYPE(time_type), INTENT(in), OPTIONAL :: start_time

    INTEGER :: new_file_freq1, new_file_freq_units1
    INTEGER :: file_duration1, file_duration_units1
    REAL, DIMENSION(1) :: tdata
    CHARACTER(len=128) :: time_units_str

    ! Get a number for this file
    num_files = num_files + 1
    IF ( num_files >= max_files ) THEN
       ! <ERROR STATUS="FATAL">
       !   max_files exceeded, increase max_files via the max_files variable
       !   in the namelist diag_manager_nml.
       ! </ERROR>
       CALL error_mesg('diag_util_mod::init_file',&
            & ' max_files exceeded, increase max_files via the max_files variable&
            & in the namelist diag_manager_nml.', FATAL)
    END IF

    IF ( PRESENT(new_file_freq) ) THEN
       new_file_freq1 = new_file_freq
    ELSE
       new_file_freq1 = VERY_LARGE_FILE_FREQ
    END IF

    IF ( PRESENT(new_file_freq_units) ) THEN
       new_file_freq_units1 = new_file_freq_units
    ELSE IF ( get_calendar_type() == NO_CALENDAR ) THEN
       new_file_freq_units1 = DIAG_DAYS
    ELSE
       new_file_freq_units1 = DIAG_YEARS
    END IF

    IF ( PRESENT(file_duration) ) THEN
       file_duration1 = file_duration
    ELSE
       file_duration1 = new_file_freq1
    END IF

    IF ( PRESENT(file_duration_units) ) THEN
       file_duration_units1 = file_duration_units
    ELSE
       file_duration_units1 = new_file_freq_units1
    END IF

    files(num_files)%tile_count = tile_count
    files(num_files)%name = TRIM(name)
    files(num_files)%output_freq = output_freq
    files(num_files)%output_units = output_units
    files(num_files)%format = FORMAT
    files(num_files)%time_units = time_units
    files(num_files)%long_name = TRIM(long_name)
    files(num_files)%num_fields = 0
    files(num_files)%local = .FALSE.
    files(num_files)%last_flush = base_time
    files(num_files)%file_unit = -1
    files(num_files)%new_file_freq = new_file_freq1
    files(num_files)%new_file_freq_units = new_file_freq_units1
    files(num_files)%duration = file_duration1
    files(num_files)%duration_units = file_duration_units1
    IF ( PRESENT(start_time) ) THEN
       files(num_files)%start_time = start_time
    ELSE
       files(num_files)%start_time = base_time
    END IF
    files(num_files)%next_open=diag_time_inc(files(num_files)%start_time,new_file_freq1,new_file_freq_units1)
    files(num_files)%close_time = diag_time_inc(files(num_files)%start_time,file_duration1, file_duration_units1)
    IF ( files(num_files)%close_time>files(num_files)%next_open ) THEN
       ! <ERROR STATUS="FATAL">
       !   close time GREATER than next_open time, check file duration,
       !   file frequency in <files(num_files)%name>
       ! </ERROR>
       CALL error_mesg('diag_util_mod::init_file', 'close time GREATER than next_open time, check file duration,&
            & file frequency in '//files(num_files)%name, FATAL)
    END IF

    ! add time_axis_id and time_bounds_id here
    WRITE(time_units_str, 11) TRIM(time_unit_list(files(num_files)%time_units)), base_year,&
         & base_month, base_day, base_hour, base_minute, base_second
11  FORMAT(a, ' since ', i4.4, '-', i2.2, '-', i2.2, ' ', i2.2, ':', i2.2, ':', i2.2)
    files(num_files)%time_axis_id = diag_axis_init (TRIM(long_name), tdata, time_units_str, 'T',&
         & TRIM(long_name) , set_name=TRIM(name) )
    !---- register axis for storing time boundaries
    files(num_files)%time_bounds_id = diag_axis_init( 'nv',(/1.,2./),'none','N','vertex number',&
         & set_name=TRIM(name))
  END SUBROUTINE init_file
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="sync_file_times">
  !   <OVERVIEW>
  !     Synchronize the file's start and close times with the model start and end times.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE sync_file_times(init_time)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     <TT>sync_file_times</TT> checks to see if the file start time is less than the
  !     model's init time (passed in as the only argument).  If it is less, then the
  !     both the file start time and end time are synchronized using the passed in initial time
  !     and the duration as calculated by the <TT>diag_time_inc</TT> function.  <TT>sync_file_times</TT>
  !     will also increase the <TT>next_open</TT> until it is greater than the init_time.
  !   </DESCRIPTION>
  !   <IN NAME="file_id" TYPE="INTEGER">The file ID</IN>
  !   <IN NAME="init_time" TYPE="TYPE(time_type)">Initial time use for the synchronization.</IN>
  !   <OUT NAME="err_msg" TYPE="CHARACTER(len=*), OPTIONAL">Return error message</OUT>
  SUBROUTINE sync_file_times(file_id, init_time, err_msg)
    INTEGER, INTENT(in) :: file_id
    TYPE(time_type), INTENT(in) :: init_time
    CHARACTER(len=*), OPTIONAL, INTENT(out) :: err_msg

    CHARACTER(len=128) :: msg

    IF ( PRESENT(err_msg) ) err_msg = ''

    IF ( files(file_id)%start_time < init_time ) THEN
       ! Sync the start_time of the file with the initial time of the model
       files(file_id)%start_time = init_time
       ! Sync the file's close time also
       files(file_id)%close_time = diag_time_inc(files(file_id)%start_time,&
            & files(file_id)%duration, files(file_id)%duration_units)
    END IF

    ! Need to increase next_open until it is greate than init_time
    DO WHILE ( files(file_id)%next_open <= init_time )
       files(file_id)%next_open = diag_time_inc(files(file_id)%next_open,&
            & files(file_id)%new_file_freq, files(file_id)%new_file_freq_units, err_msg=msg)
       IF ( msg /= '' ) THEN
          IF ( fms_error_handler('diag_util_mod::sync_file_times',&
               & ' file='//TRIM(files(file_id)%name)//': '//TRIM(msg), err_msg) ) RETURN
       END IF
    END DO
  END SUBROUTINE sync_file_times
  ! </SUBROUTINE>

  ! <FUNCTION NAME="diag_time_inc">
  !   <OVERVIEW>
  !     Return the next time data/file is to be written based on the frequency and units.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     TYPE(time_type) FUNCTION diag_time_inc(time, output_freq, output_units, err_msg)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Return the next time data/file is to be written.  This value is based on the current time and the frequency and units.
  !     Function completed successful if the optional <TT>err_msg</TT> is empty.
  !   </DESCRIPTION>
  !   <IN NAME="time" TYPE="TYPE(time_type)">Current model time.</IN>
  !   <IN NAME="output_freq" TYPE="INTEGER">Output frequency number value.</IN>
  !   <IN NAME="output_units" TYPE="INTEGER">Output frequency unit.</IN>
  !   <OUT NAME="err_msg" TYPE="CHARACTER, OPTIONAL">
  !     Function error message.  An empty string indicates the next output time was found successfully.
  !   </OUT>
  TYPE(time_type) FUNCTION diag_time_inc(time, output_freq, output_units, err_msg)
    TYPE(time_type), INTENT(in) :: time
    INTEGER, INTENT(in):: output_freq, output_units
    CHARACTER(len=*), INTENT(out), OPTIONAL :: err_msg

    CHARACTER(len=128) :: error_message_local

    IF ( PRESENT(err_msg) ) err_msg = ''
    error_message_local = ''

    ! special values for output frequency are -1 for output at end of run
    ! and 0 for every timestep.  Need to check for these here?
    ! Return zero time increment, hopefully this value is never used
    IF ( output_freq == END_OF_RUN .OR. output_freq == EVERY_TIME ) THEN
       diag_time_inc = time
       RETURN
    END IF

    ! Make sure calendar was not set after initialization
    IF ( output_units == DIAG_SECONDS ) THEN
       IF ( get_calendar_type() == NO_CALENDAR ) THEN
          diag_time_inc = increment_time(time, output_freq, 0, err_msg=error_message_local)
       ELSE
          diag_time_inc = increment_date(time, 0, 0, 0, 0, 0, output_freq, err_msg=error_message_local)
       END IF
    ELSE IF ( output_units == DIAG_MINUTES ) THEN
       IF ( get_calendar_type() == NO_CALENDAR ) THEN
          diag_time_inc = increment_time(time, NINT(output_freq*SECONDS_PER_MINUTE), 0, &
               &err_msg=error_message_local)
       ELSE
          diag_time_inc = increment_date(time, 0, 0, 0, 0, output_freq, 0, err_msg=error_message_local)
       END IF
    ELSE IF ( output_units == DIAG_HOURS ) THEN
       IF ( get_calendar_type() == NO_CALENDAR ) THEN
          diag_time_inc = increment_time(time, NINT(output_freq*SECONDS_PER_HOUR), 0, err_msg=error_message_local)
       ELSE
          diag_time_inc = increment_date(time, 0, 0, 0, output_freq, 0, 0, err_msg=error_message_local)
       END IF
    ELSE IF ( output_units == DIAG_DAYS ) THEN
       IF (get_calendar_type() == NO_CALENDAR) THEN
          diag_time_inc = increment_time(time, 0, output_freq, err_msg=error_message_local)
       ELSE
          diag_time_inc = increment_date(time, 0, 0, output_freq, 0, 0, 0, err_msg=error_message_local)
       END IF
    ELSE IF ( output_units == DIAG_MONTHS ) THEN
       IF (get_calendar_type() == NO_CALENDAR) THEN
          error_message_local = 'output units of months NOT allowed with no calendar'
       ELSE
          diag_time_inc = increment_date(time, 0, output_freq, 0, 0, 0, 0, err_msg=error_message_local)
       END IF
    ELSE IF ( output_units == DIAG_YEARS ) THEN
       IF ( get_calendar_type() == NO_CALENDAR ) THEN
          error_message_local = 'output units of years NOT allowed with no calendar'
       ELSE
          diag_time_inc = increment_date(time, output_freq, 0, 0, 0, 0, 0, err_msg=error_message_local)
       END IF
    ELSE
       error_message_local = 'illegal output units'
    END IF

    IF ( error_message_local /= '' ) THEN
       IF ( fms_error_handler('diag_time_inc',error_message_local,err_msg) ) RETURN
    END IF
  END FUNCTION diag_time_inc
  ! </FUNCTION>

  ! <PRIVATE>
  ! <FUNCTION NAME="find_file">
  !   <OVERVIEW>
  !     Return the file number for file name and tile.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     INTEGER FUNCTION fild_file(name, time_count)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Find the file number for the file name and tile number given.  A return value of <TT>-1</TT> indicates the file was not found.
  !   </DESCRIPTION>
  !   <IN NAME="name=" TYPE="CHARACTER(len=*)">File name.</IN>
  !   <IN NAME="tile_count" TYPE="INTEGER">Tile number.</IN>
  INTEGER FUNCTION find_file(name, tile_count)
    INTEGER, INTENT(in) :: tile_count
    CHARACTER(len=*), INTENT(in) :: name

    INTEGER :: i

    find_file = -1
    DO i = 1, num_files
       IF( TRIM(files(i)%name) == TRIM(name) .AND. tile_count == files(i)%tile_count ) THEN
          find_file = i
          RETURN
       END IF
    END DO
  END FUNCTION find_file
  ! </FUNCTION>
  ! </PRIVATE>

  ! <FUNCTION NAME="find_input_field">
  !   <OVERVIEW>
  !     Return the field number for the given module name, field name, and tile number.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     INTEGER FUNCTION find_input_field(module_name, field_name, tile_count)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Return the field number for the given module name, field name and tile number.  A return value of <TT>-1</TT> indicates
  !     the field was not found.
  !   </DESCRIPTION>
  !   <IN NAME="module_name" TYPE="CHARACTER(len=*)">Module name.</IN>
  !   <IN NAME="field_name" TYPE="CHARACTER(len=*)">field name.</IN>
  !   <IN NAME="tile_count" TYPE="INTEGER">Tile number.</IN>
  INTEGER FUNCTION find_input_field(module_name, field_name, tile_count)
    CHARACTER(len=*), INTENT(in) :: module_name, field_name
    INTEGER, INTENT(in) :: tile_count

    INTEGER :: i

    find_input_field = DIAG_FIELD_NOT_FOUND ! Default return value if not found.
    DO i = 1, num_input_fields
       IF(tile_count == input_fields(i)%tile_count .AND.&
            & TRIM(input_fields(i)%module_name) == TRIM(module_name) .AND.&
            & lowercase(TRIM(input_fields(i)%field_name)) == lowercase(TRIM(field_name))) THEN
          find_input_field = i
          RETURN
       END IF
    END DO
  END FUNCTION find_input_field
  ! </FUNCTION>

  ! <SUBROUTINE NAME="init_input_field">
  !   <OVERVIEW>
  !     Initialize the input field.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE init_input_field(module_name, field_name, tile_count)
  !   </TEMPLATE>
  !     Initialize the input field.
  !   <DESCRIPTION>
  !   </DESCRIPTION>
  !   <IN NAME="module_name" TYPE="CHARACTER(len=*)">Module name.</IN>
  !   <IN NAME="field_name" TYPE="CHARACTER(len=*)">Input field name.</IN>
  !   <IN NAME="tile_count" TYPE="INTEGER">Tile number.</IN>
  SUBROUTINE init_input_field(module_name, field_name, tile_count)
    CHARACTER(len=*),  INTENT(in) :: module_name, field_name
    INTEGER, INTENT(in) :: tile_count

    ! Get a number for this input_field if not already set up
    IF ( find_input_field(module_name, field_name, tile_count) < 0 ) THEN
       num_input_fields = num_input_fields + 1
       IF ( num_input_fields > max_input_fields ) THEN
          ! <ERROR STATUS="FATAL">max_input_fields exceeded, increase it via diag_manager_nml</ERROR>
          CALL error_mesg('diag_util_mod::init_input_field',&
               & 'max_input_fields exceeded, increase it via diag_manager_nml', FATAL)
       END IF
    ELSE
       ! If this is already initialized do not need to do anything
       RETURN
    END IF

    input_fields(num_input_fields)%module_name = TRIM(module_name)
    input_fields(num_input_fields)%field_name = TRIM(field_name)
    input_fields(num_input_fields)%num_output_fields = 0
    ! Set flag that this field has not been registered
    input_fields(num_input_fields)%register = .FALSE.
    input_fields(num_input_fields)%local = .FALSE.
    input_fields(num_input_fields)%standard_name = 'none'
    input_fields(num_input_fields)%tile_count = tile_count
    input_fields(num_input_fields)%numthreads = 1
    input_fields(num_input_fields)%active_omp_level = 0
    input_fields(num_input_fields)%time = time_zero
  END SUBROUTINE init_input_field
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="init_output_field">
  !   <OVERVIEW>
  !     Initialize the output field.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE init_output_field(module_name, field_name, output_name, output_file
  !     time_method, pack, tile_count, local_coord)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Initialize the output field.
  !   </DESCRIPTION>
  !   <IN NAME="module_name" TYPE="CHARACTER(len=*)">Module name.</IN>
  !   <IN NAME="field_name" TYPE="CHARACTER(len=*)">Output field name.</IN>
  !   <IN NAME="output_name" TYPE="CHARACTER(len=*)">Output name written to file.</IN>
  !   <IN NAME="output_file" TYPE="CHARACTER(len=*)">File where field should be written.</IN>
  !   <IN NAME="time_method" TYPE="CHARACTER(len=*)">
  !     Data reduction method.  See <LINK SRC="diag_manager.html">diag_manager_mod</LINK> for valid methods.</IN>
  !   <IN NAME="pack" TYPE="INTEGER">Packing method.</IN>
  !   <IN NAME="tile_count" TYPE="INTEGER">Tile number.</IN>
  !   <IN NAME="local_coord" TYPE="INTEGER, OPTIONAL">Region to be written.  If missing, then all data to be written.</IN>
  SUBROUTINE init_output_field(module_name, field_name, output_name, output_file,&
       & time_method, pack, tile_count, local_coord)
    CHARACTER(len=*), INTENT(in) :: module_name, field_name, output_name, output_file
    CHARACTER(len=*), INTENT(in) :: time_method
    INTEGER, INTENT(in) :: pack
    INTEGER, INTENT(in) :: tile_count
    TYPE(coord_type), INTENT(in), OPTIONAL :: local_coord
    INTEGER :: out_num, in_num, file_num, file_num_tile1
    INTEGER :: num_fields, i, method_selected, l1
    INTEGER :: ioerror
    REAL :: pow_value
    INTEGER :: grv !< Value used to determine if the region defined in the diag_table is for the whole axis, or a sub-axis
    CHARACTER(len=128) :: error_msg
    CHARACTER(len=50) :: t_method

    ! Value to use to determine if a region is to be output on the full axis, or sub-axis
    ! get the value to compare to determine if writing full axis data
    IF ( region_out_use_alt_value ) THEN
       grv = GLO_REG_VAL_ALT
    ELSE
       grv = GLO_REG_VAL
    END IF


    ! Get a number for this output field
    num_output_fields = num_output_fields + 1
    IF ( num_output_fields > max_output_fields ) THEN
       ! <ERROR STATUS="FATAL">max_output_fields = <max_output_fields> exceeded.  Increase via diag_manager_nml</ERROR>
       WRITE (UNIT=error_msg,FMT=*) max_output_fields
       CALL error_mesg('diag_util_mod::init_output_field', 'max_output_fields = '//TRIM(error_msg)//' exceeded.&
            &  Increase via diag_manager_nml', FATAL)
    END IF
    out_num = num_output_fields

    ! First, find the index to the associated input field
    in_num = find_input_field(module_name, field_name, tile_count)
    IF ( in_num < 0 ) THEN
       IF ( tile_count > 1 ) THEN
          WRITE (error_msg,'(A,"/",A,"/",A)') TRIM(module_name),TRIM(field_name),&
               & "tile_count="//TRIM(string(tile_count))
       ELSE
          WRITE (error_msg,'(A,"/",A)') TRIM(module_name),TRIM(field_name)
       END IF
       ! <ERROR STATUS="FATAL">module_name/field_name <module_name>/<field_name>[/tile_count=<tile_count>] NOT registered</ERROR>
       CALL error_mesg('diag_util_mod::init_output_field',&
            & 'module_name/field_name '//TRIM(error_msg)//' NOT registered', FATAL)
    END IF

    ! Add this output field into the list for this input field
    input_fields(in_num)%num_output_fields =&
         & input_fields(in_num)%num_output_fields + 1
    IF ( input_fields(in_num)%num_output_fields > max_out_per_in_field ) THEN
       ! <ERROR STATUS="FATAL">
       !   MAX_OUT_PER_IN_FIELD = <MAX_OUT_PER_IN_FIELD> exceeded for <module_name>/<field_name>, increase MAX_OUT_PER_IN_FIELD
       !   in the diag_manager_nml namelist.
       ! </ERROR>
       WRITE (UNIT=error_msg,FMT=*) MAX_OUT_PER_IN_FIELD
       CALL error_mesg('diag_util_mod::init_output_field',&
        & 'MAX_OUT_PER_IN_FIELD exceeded for '//TRIM(module_name)//"/"//TRIM(field_name)//&
        &', increase MAX_OUT_PER_IN_FIELD in the diag_manager_nml namelist', FATAL)
    END IF
    input_fields(in_num)%output_fields(input_fields(in_num)%num_output_fields) = out_num

    ! Also put pointer to input field in this output field
    output_fields(out_num)%input_field = in_num

    ! Next, find the number for the corresponding file
    IF ( TRIM(output_file).EQ.'null' ) THEN
       file_num = max_files
    ELSE
       file_num = find_file(output_file, 1)
       IF ( file_num < 0 ) THEN
          ! <ERROR STATUS="FATAL">
          !   file <file_name> is NOT found in the diag_table.
          ! </ERROR>
          CALL error_mesg('diag_util_mod::init_output_field', 'file '&
               & //TRIM(output_file)//' is NOT found in the diag_table', FATAL)
       END IF
       IF ( tile_count > 1 ) THEN
          file_num_tile1 = file_num
          file_num = find_file(output_file, tile_count)
          IF(file_num < 0) THEN
             CALL init_file(files(file_num_tile1)%name, files(file_num_tile1)%output_freq,&
                  & files(file_num_tile1)%output_units, files(file_num_tile1)%format,&
                  & files(file_num_tile1)%time_units, files(file_num_tile1)%long_name,&
                  & tile_count, files(file_num_tile1)%new_file_freq,&
                  & files(file_num_tile1)%new_file_freq_units, files(file_num_tile1)%start_time,&
                  & files(file_num_tile1)%duration, files(file_num_tile1)%duration_units  )
             file_num = find_file(output_file, tile_count)
             IF ( file_num < 0 ) THEN
                ! <ERROR STATUS="FATAL">
                !   file <output_file> is not initialized for tile_count = <tile_count>
                ! </ERROR>
                CALL error_mesg('diag_util_mod::init_output_field', 'file '//TRIM(output_file)//&
                     & ' is not initialized for tile_count = '//TRIM(string(tile_count)), FATAL)
             END IF
          END IF
       END IF
    END IF

    ! Insert this field into list for this file
    files(file_num)%num_fields = files(file_num)%num_fields + 1
    IF ( files(file_num)%num_fields > MAX_FIELDS_PER_FILE ) THEN
       WRITE (UNIT=error_msg, FMT=*) MAX_FIELDS_PER_FILE
       ! <ERROR STATUS="FATAL">
       !   MAX_FIELDS_PER_FILE = <MAX_FIELDS_PER_FILE> exceeded.  Increase MAX_FIELDS_PER_FILE in diag_data.F90.
       ! </ERROR>
       CALL error_mesg('diag_util_mod::init_output_field',&
            & 'MAX_FIELDS_PER_FILE = '//TRIM(error_msg)//' exceeded.  Increase MAX_FIELDS_PER_FILE in diag_data.F90.', FATAL)
    END IF
    num_fields = files(file_num)%num_fields
    files(file_num)%fields(num_fields) = out_num

    ! Set the file for this output field
    output_fields(out_num)%output_file = file_num

    ! Enter the other data for this output field
    output_fields(out_num)%output_name = TRIM(output_name)
    output_fields(out_num)%pack = pack
    output_fields(out_num)%pow_value = 1
    output_fields(out_num)%num_axes = 0
    output_fields(out_num)%total_elements = 0
    output_fields(out_num)%region_elements = 0
    output_fields(out_num)%imax = 0
    output_fields(out_num)%jmax = 0
    output_fields(out_num)%kmax = 0
    output_fields(out_num)%imin = VERY_LARGE_AXIS_LENGTH
    output_fields(out_num)%jmin = VERY_LARGE_AXIS_LENGTH
    output_fields(out_num)%kmin = VERY_LARGE_AXIS_LENGTH

    ! initialize the size of the diurnal axis to 1
    output_fields(out_num)%n_diurnal_samples = 1

    ! Initialize all time method to false
    method_selected = 0
    output_fields(out_num)%time_average = .FALSE.
    output_fields(out_num)%time_rms = .FALSE.
    output_fields(out_num)%time_min = .FALSE.
    output_fields(out_num)%time_max = .FALSE.
    output_fields(out_num)%time_ops = .FALSE.
    output_fields(out_num)%written_once = .FALSE.

    t_method = lowercase(time_method)
    ! cannot time average fields output every time
    IF ( files(file_num)%output_freq == EVERY_TIME ) THEN
       output_fields(out_num)%time_average = .FALSE.
       method_selected = method_selected+1
       t_method = 'point'
    ELSEIF ( INDEX(t_method,'diurnal') == 1 ) THEN
       ! get the integer number from the t_method
       READ (UNIT=t_method(8:LEN_TRIM(t_method)), FMT=*, IOSTAT=ioerror) output_fields(out_num)%n_diurnal_samples
       IF ( ioerror /= 0 ) THEN
          ! <ERROR STATUS="FATAL">
          !   could not find integer number of diurnal samples in string "<t_method>"
          ! </ERROR>
          CALL error_mesg('diag_util_mod::init_output_field',&
               & 'could not find integer number of diurnal samples in string "' //TRIM(t_method)//'"', FATAL)
       ELSE IF ( output_fields(out_num)%n_diurnal_samples <= 0 ) THEN
          ! <ERROR STATUS="FATAL">
          !   The integer value of diurnal samples must be greater than zero.
          ! </ERROR>
          CALL error_mesg('diag_util_mod::init_output_field',&
               & 'The integer value of diurnal samples must be greater than zero.', FATAL)
       END IF
       output_fields(out_num)%time_average = .TRUE.
       method_selected = method_selected+1
       t_method='mean'
    ELSEIF ( INDEX(t_method,'pow') == 1 ) THEN
       ! Get the integer number from the t_method
       READ (UNIT=t_method(4:LEN_TRIM(t_method)), FMT=*, IOSTAT=ioerror) pow_value
       IF ( ioerror /= 0 .OR. output_fields(out_num)%pow_value < 1  .OR. FLOOR(pow_value) /= CEILING(pow_value) ) THEN
          ! <ERROR STATUS="FATAL">
          !   Invalid power number in time operation "<t_method>".  Must be a positive integer.
          ! </ERROR>
          CALL error_mesg('diag_util_mod::init_output_field',&
               & 'Invalid power number in time operation "'//TRIM(t_method)//'".  Must be a positive integer', FATAL)
       END IF
       output_fields(out_num)%pow_value = INT(pow_value)
       output_fields(out_num)%time_average = .TRUE.
       method_selected = method_selected+1
       t_method = 'mean_pow('//t_method(4:LEN_TRIM(t_method))//')'
    ELSE
       SELECT CASE(TRIM(t_method))
       CASE ( '.true.', 'mean', 'average', 'avg' )
          output_fields(out_num)%time_average = .TRUE.
          method_selected = method_selected+1
          t_method = 'mean'
       CASE ( 'rms' )
          output_fields(out_num)%time_average = .TRUE.
          output_fields(out_num)%time_rms = .TRUE.
          output_fields(out_num)%pow_value = 2.0
          method_selected = method_selected+1
          t_method = 'root_mean_square'
       CASE ( '.false.', 'none', 'point' )
          output_fields(out_num)%time_average = .FALSE.
          method_selected = method_selected+1
          t_method = 'point'
       CASE ( 'maximum', 'max' )
          output_fields(out_num)%time_max = .TRUE.
          l1 = LEN_TRIM(output_fields(out_num)%output_name)
          IF ( output_fields(out_num)%output_name(l1-2:l1) /= 'max' ) &
               output_fields(out_num)%output_name = TRIM(output_name)//'_max'
          method_selected = method_selected+1
          t_method = 'max'
       CASE ( 'minimum', 'min' )
          output_fields(out_num)%time_min = .TRUE.
          l1 = LEN_TRIM(output_fields(out_num)%output_name)
          IF ( output_fields(out_num)%output_name(l1-2:l1) /= 'min' )&
               & output_fields(out_num)%output_name = TRIM(output_name)//'_min'
          method_selected = method_selected+1
          t_method = 'min'
       END SELECT
    END IF

    ! reconcile logical flags
    output_fields(out_num)%time_ops = output_fields(out_num)%time_min.OR.output_fields(out_num)%time_max&
         & .OR.output_fields(out_num)%time_average

    output_fields(out_num)%phys_window = .FALSE.
    ! need to initialize grid_type = -1(start, end, l_start_indx,l_end_indx etc...)
    IF ( PRESENT(local_coord) ) THEN
       input_fields(in_num)%local = .TRUE.
       input_fields(in_num)%local_coord = local_coord
       IF ( INT(local_coord%xbegin) ==  grv .AND. INT(local_coord%xend) == grv .AND.&
            & INT(local_coord%ybegin) == grv .AND. INT(local_coord%yend) == grv ) THEN
          output_fields(out_num)%local_output = .FALSE.
          output_fields(out_num)%need_compute = .FALSE.
          output_fields(out_num)%reduced_k_range = .TRUE.
       ELSE
          output_fields(out_num)%local_output = .TRUE.
          output_fields(out_num)%need_compute = .FALSE.
          output_fields(out_num)%reduced_k_range = .FALSE.
       END IF

       output_fields(out_num)%output_grid%start(1) = local_coord%xbegin
       output_fields(out_num)%output_grid%start(2) = local_coord%ybegin
       output_fields(out_num)%output_grid%start(3) = local_coord%zbegin
       output_fields(out_num)%output_grid%end(1) = local_coord%xend
       output_fields(out_num)%output_grid%end(2) = local_coord%yend
       output_fields(out_num)%output_grid%end(3) = local_coord%zend
       DO i = 1, 3
          output_fields(out_num)%output_grid%l_start_indx(i) = -1
          output_fields(out_num)%output_grid%l_end_indx(i) = -1
          output_fields(out_num)%output_grid%subaxes(i) = -1
       END DO
    ELSE
       output_fields(out_num)%local_output = .FALSE.
       output_fields(out_num)%need_compute = .FALSE.
       output_fields(out_num)%reduced_k_range = .FALSE.
    END IF

    ! <ERROR STATUS="FATAL">
    !   improper time method in diag_table for output field <output_name>
    ! </ERROR>
    IF ( method_selected /= 1 ) CALL error_mesg('diag_util_mod::init_output_field',&
         &'improper time method in diag_table for output field:'//TRIM(output_name),FATAL)

    output_fields(out_num)%time_method = TRIM(t_method)

    ! allocate counters: NOTE that for simplicity we always allocate them, even
    ! if they are superceeded by 4D "counter" array. This isn't most memory
    ! efficient, approach, but probably tolerable since they are so small anyway
    ALLOCATE(output_fields(out_num)%count_0d(output_fields(out_num)%n_diurnal_samples))
    ALLOCATE(output_fields(out_num)%num_elements(output_fields(out_num)%n_diurnal_samples))
    output_fields(out_num)%count_0d(:) = 0
    output_fields(out_num)%num_elements(:) = 0
    output_fields(out_num)%num_attributes = 0
  END SUBROUTINE init_output_field
  ! </SUBROUTINE>

  ! <PRIVATE>
  ! <SUBROUTINE NAME="opening_file">
  !   <OVERVIEW>
  !     Open file for output.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE opening_file(file, time)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Open file for output, and write the meta data.  <BB>Warning:</BB> Assumes all data structures have been fully initialized.
  !   </DESCRIPTION>
  !   <IN NAME="file" TYPE="INTEGER">File ID.</IN>
  !   <IN NAME="tile" TYPE="TYPE(time_type)">Tile number.</IN>
  SUBROUTINE opening_file(file, time)
    ! WARNING: Assumes that all data structures are fully initialized
    INTEGER, INTENT(in) :: file
    TYPE(time_type), INTENT(in) :: time

    REAL, DIMENSION(2) :: DATA
    INTEGER :: j, field_num, input_field_num, num_axes, k
    INTEGER :: field_num1
    INTEGER :: position
    INTEGER :: dir, edges
    INTEGER :: ntileMe
    INTEGER :: year, month, day, hour, minute, second
    INTEGER, ALLOCATABLE :: tile_id(:)
    INTEGER, DIMENSION(1) :: time_axis_id, time_bounds_id
    ! size of this axes array must be at least max num. of
    ! axes per field + 2; the last two elements are for time
    ! and time bounds dimensions
    INTEGER, DIMENSION(6) :: axes
    LOGICAL :: time_ops, aux_present, match_aux_name
    LOGICAL :: all_scalar_or_1d
    CHARACTER(len=7) :: prefix
    CHARACTER(len=7) :: avg_name = 'average'
    CHARACTER(len=128) :: time_units, timeb_units, avg, error_string, filename, aux_name,fieldname
    CHARACTER(len=128) :: suffix, base_name
    CHARACTER(len=32) :: time_name, timeb_name,time_longname, timeb_longname, cart_name
    CHARACTER(len=256) :: fname
    CHARACTER(len=24) :: start_date
    TYPE(domain1d) :: domain
    TYPE(domain2d) :: domain2

    aux_present = .FALSE.
    match_aux_name = .FALSE.
    ! it's unlikely that a file starts with word "rregion", need to check anyway.
    IF ( LEN(files(file)%name) >=7 .AND. .NOT.files(file)%local ) THEN
       prefix = files(file)%name(1:7)
       IF ( lowercase(prefix) == 'rregion' ) THEN
          ! <ERROR STATUS="WARNING">
          !   file name should not start with word "rregion"
          ! </ERROR>
          IF ( mpp_pe() == mpp_root_pe() ) CALL error_mesg('diag_util_mod::opening_file',&
               & 'file name should not start with word "rregion"', WARNING)
       END IF
    END IF

    ! Here is where time_units string must be set up; time since base date
    WRITE (time_units, 11) TRIM(time_unit_list(files(file)%time_units)), base_year,&
         & base_month, base_day, base_hour, base_minute, base_second
11  FORMAT(A, ' since ', I4.4, '-', I2.2, '-', I2.2, ' ', I2.2, ':', I2.2, ':', I2.2)
    base_name = files(file)%name
    IF ( files(file)%new_file_freq < VERY_LARGE_FILE_FREQ ) THEN
       position = INDEX(files(file)%name, '%')
       IF ( position > 0 )  THEN
          base_name = base_name(1:position-1)
       ELSE
          ! <ERROR STATUS="FATAL">
          !   filename <files(file)%name> does not contain % for time stamp string
          ! </ERROR>
          CALL error_mesg('diag_util_mod::opening_file',&
               & 'file name '//TRIM(files(file)%name)//' does not contain % for time stamp string', FATAL)
       END IF
       suffix = get_time_string(files(file)%name, time)
    ELSE
       suffix = ' '
    END IF

    ! Add ensemble ID to filename
    fname=base_name
    call get_instance_filename(fname, base_name)

    ! Add CVS tag as prefix of filename  (currently not implemented)
    !  i1 = INDEX(tagname,':') + 2
    !  i2 = len_trim(tagname) - 2
    !  if(i2 <=i1)  call error_mesg('diag_util opening_file','error in CVS tagname index',FATAL)
    !  prefix2 = tagname(i1:i2)//'_'
    IF ( files(file)%local ) THEN
       ! prepend "rregion" to all local files for post processing, the prefix will be removed in postprocessing
       filename = 'rregion'//TRIM(base_name)//TRIM(suffix)
    ELSE
       ! filename = trim(prefix2)//trim(base_name)//trim(suffix)
       filename = TRIM(base_name)//TRIM(suffix)
    END IF

    ! prepend the file start date if prepend_date == .TRUE.
    IF ( prepend_date ) THEN
       call get_date(diag_init_time, year, month, day, hour, minute, second)
       write (start_date, '(1I20.4, 2I2.2)') year, month, day

       filename = TRIM(adjustl(start_date))//'.'//TRIM(filename)
    END IF

    ! Loop through all fields with this file to output axes
    ! JWD: This is a klooge; need something more robust
    domain2 = NULL_DOMAIN2D
    all_scalar_or_1d = .TRUE.
    DO j = 1, files(file)%num_fields
       field_num = files(file)%fields(j)
       if (output_fields(field_num)%local_output .AND. .NOT. output_fields(field_num)%need_compute) CYCLE
       num_axes = output_fields(field_num)%num_axes
       IF ( num_axes > 1 ) THEN
          all_scalar_or_1d = .FALSE.
          domain2 = get_domain2d ( output_fields(field_num)%axes(1:num_axes) )
          IF ( domain2 .NE. NULL_DOMAIN2D ) EXIT
       END IF
    END DO
    IF( .NOT.all_scalar_or_1d ) THEN
       IF ( domain2 .EQ. NULL_DOMAIN2D ) CALL return_domain(domain2)
       IF ( domain2 .EQ. NULL_DOMAIN2D ) THEN
          ! <ERROR STATUS="FATAL">
          !   Domain not defined through set_domain interface; cannot retrieve tile info
          ! </ERROR>
          CALL error_mesg('diag_util_mod::opening_file',&
               & 'Domain not defined through set_domain interface; cannot retrieve tile info', FATAL)
       END IF
       IF ( mpp_get_ntile_count(domain2) > 1 ) THEN
          ntileMe = mpp_get_current_ntile(domain2)
          ALLOCATE(tile_id(ntileMe))
          tile_id = mpp_get_tile_id(domain2)
          fname = TRIM(filename)
          CALL get_tile_string(filename, TRIM(fname)//'.tile' , tile_id(files(file)%tile_count))
          DEALLOCATE(tile_id)
       END IF
    END IF

    IF ( _ALLOCATED(files(file)%attributes) ) THEN
       CALL diag_output_init(filename, files(file)%format, global_descriptor,&
            & files(file)%file_unit, all_scalar_or_1d, domain2,&
            & attributes=files(file)%attributes(1:files(file)%num_attributes))
    ELSE
       CALL diag_output_init(filename, files(file)%format, global_descriptor,&
            & files(file)%file_unit, all_scalar_or_1d, domain2)
    END IF
    files(file)%bytes_written = 0
    ! Does this file contain time_average fields?
    time_ops = .FALSE.
    DO j = 1, files(file)%num_fields
       field_num = files(file)%fields(j)
       IF ( output_fields(field_num)%time_ops ) THEN
          time_ops = .TRUE.
          EXIT
       END IF
    END DO
    ! Loop through all fields with this file to output axes
    DO j = 1, files(file)%num_fields
       field_num = files(file)%fields(j)
       input_field_num = output_fields(field_num)%input_field
       IF (.NOT.input_fields(input_field_num)%register) THEN
          WRITE (error_string,'(A,"/",A)') TRIM(input_fields(input_field_num)%module_name),&
               & TRIM(input_fields(input_field_num)%field_name)
          IF(mpp_pe() .EQ. mpp_root_pe()) THEN
             ! <ERROR STATUS="WARNING">
             !   module/field_name (<input_fields(input_field_num)%module_name>/<input_fields(input_field_num)%field_name>)
             !   NOT registered
             ! </ERROR>
             CALL error_mesg('diag_util_mod::opening_file',&
                  & 'module/field_name ('//TRIM(error_string)//') NOT registered', WARNING)
          END IF
          CYCLE
       END IF
       if (output_fields(field_num)%local_output .AND. .NOT. output_fields(field_num)%need_compute) CYCLE

       ! Put the time axis in the axis field
       num_axes = output_fields(field_num)%num_axes
       axes(1:num_axes) = output_fields(field_num)%axes(1:num_axes)
       ! make sure that axis_id are not -1
       DO k = 1, num_axes
          IF ( axes(k) < 0 ) THEN
             WRITE(error_string,'(a)') output_fields(field_num)%output_name
             ! <ERROR STATUS="FATAL">
             !   ouptut_name <output_fields(field_num)%output_name> has axis_id = -1
             ! </ERROR>
             CALL error_mesg('diag_util_mod::opening_file','output_name '//TRIM(error_string)//&
                  & ' has axis_id = -1', FATAL)
          END IF
       END DO
       ! check if aux is present in any axes
       IF ( .NOT.aux_present ) THEN
          DO k = 1, num_axes
             aux_name = get_axis_aux(axes(k))
             IF ( TRIM(aux_name) /= 'none' ) THEN
                aux_present = .TRUE.
                EXIT
             END IF
          END DO
       END IF

       axes(num_axes + 1) = files(file)%time_axis_id
       CALL write_axis_meta_data(files(file)%file_unit, axes(1:num_axes + 1), time_ops)
       IF ( time_ops ) THEN
          axes(num_axes + 2) = files(file)%time_bounds_id
          CALL write_axis_meta_data(files(file)%file_unit, axes(1:num_axes + 2))
       END IF
    END DO

    ! Looking for the first NON-static field in a file
    field_num1 = files(file)%fields(1)
    DO j = 1, files(file)%num_fields
       field_num = files(file)%fields(j)
       IF ( output_fields(field_num)%time_ops ) THEN
          field_num1 = field_num
          EXIT
       END IF
    END DO
    DO j = 1, files(file)%num_fields
       field_num = files(file)%fields(j)
       input_field_num = output_fields(field_num)%input_field
       IF (.NOT.input_fields(input_field_num)%register) CYCLE
       IF (output_fields(field_num)%local_output .AND. .NOT. output_fields(field_num)%need_compute) CYCLE
       ! Make sure that 1 file contains either time_average or instantaneous fields
       ! cannot have both time_average and instantaneous in 1 file
       IF ( .NOT.mix_snapshot_average_fields ) THEN
          IF ( (output_fields(field_num)%time_ops.NEQV.output_fields(field_num1)%time_ops) .AND.&
               & .NOT.output_fields(field_num1)%static .AND. .NOT.output_fields(field_num)%static) THEN
             IF ( mpp_pe() == mpp_root_pe() ) THEN
                ! <ERROR STATUS="FATAL">
                !   <files(file)%name> can NOT have BOTH time average AND instantaneous fields.
                !   Create a new file or set mix_snapshot_average_fields=.TRUE. in the namelist diag_manager_nml.
                ! </ERROR>
                CALL error_mesg('diag_util_mod::opening_file','file '//&
                     & TRIM(files(file)%name)//' can NOT have BOTH time average AND instantaneous fields.'//&
                     & ' Create a new file or set mix_snapshot_average_fields=.TRUE. in the namelist diag_manager_nml.' , FATAL)
             END IF
          END IF
       END IF
       ! check if any field has the same name as aux_name
       IF ( aux_present .AND. .NOT.match_aux_name ) THEN
          fieldname = output_fields(field_num)%output_name
          IF ( INDEX(aux_name, TRIM(fieldname)) > 0 ) match_aux_name = .TRUE.
       END IF

       ! Put the time axis in the axis field
       num_axes = output_fields(field_num)%num_axes
       axes(1:num_axes) = output_fields(field_num)%axes(1:num_axes)
       IF ( .NOT.output_fields(field_num)%static ) THEN
          num_axes=num_axes+1
          axes(num_axes) = files(file)%time_axis_id
       END IF
       IF(output_fields(field_num)%time_average) THEN
          avg = avg_name
       ELSE IF(output_fields(field_num)%time_max) THEN
          avg = avg_name
       ELSE IF(output_fields(field_num)%time_min) THEN
          avg = avg_name
       ELSE
          avg = " "
       END IF
       IF ( input_fields(input_field_num)%missing_value_present ) THEN
          IF ( LEN_TRIM(input_fields(input_field_num)%interp_method) > 0 ) THEN
             output_fields(field_num)%f_type = write_field_meta_data(files(file)%file_unit,&
                  & output_fields(field_num)%output_name, axes(1:num_axes),&
                  & input_fields(input_field_num)%units,&
                  & input_fields(input_field_num)%long_name,&
                  & input_fields(input_field_num)%range, output_fields(field_num)%pack,&
                  & input_fields(input_field_num)%missing_value, avg_name = avg,&
                  & time_method=output_fields(field_num)%time_method,&
                  & standard_name = input_fields(input_field_num)%standard_name,&
                  & interp_method = input_fields(input_field_num)%interp_method,&
                  & attributes=output_fields(field_num)%attributes,&
                  & num_attributes=output_fields(field_num)%num_attributes)
          ELSE
             output_fields(field_num)%f_type = write_field_meta_data(files(file)%file_unit,&
                  & output_fields(field_num)%output_name, axes(1:num_axes),&
                  & input_fields(input_field_num)%units,&
                  & input_fields(input_field_num)%long_name,&
                  & input_fields(input_field_num)%range, output_fields(field_num)%pack,&
                  & input_fields(input_field_num)%missing_value, avg_name = avg,&
                  & time_method=output_fields(field_num)%time_method,&
                  & standard_name = input_fields(input_field_num)%standard_name,&
                  & attributes=output_fields(field_num)%attributes,&
                  & num_attributes=output_fields(field_num)%num_attributes)
          END IF
          ! NEED TO TAKE CARE OF TIME AVERAGING INFO TOO BOTH CASES
       ELSE
          IF ( LEN_TRIM(input_fields(input_field_num)%interp_method) > 0 ) THEN
             output_fields(field_num)%f_type = write_field_meta_data(files(file)%file_unit,&
                  & output_fields(field_num)%output_name, axes(1:num_axes),&
                  & input_fields(input_field_num)%units,&
                  & input_fields(input_field_num)%long_name,&
                  & input_fields(input_field_num)%range, output_fields(field_num)%pack,&
                  & avg_name = avg,&
                  & time_method=output_fields(field_num)%time_method,&
                  & standard_name = input_fields(input_field_num)%standard_name,&
                  & interp_method = input_fields(input_field_num)%interp_method,&
                  & attributes=output_fields(field_num)%attributes,&
                  & num_attributes=output_fields(field_num)%num_attributes)
          ELSE
             output_fields(field_num)%f_type = write_field_meta_data(files(file)%file_unit,&
                  & output_fields(field_num)%output_name, axes(1:num_axes),&
                  & input_fields(input_field_num)%units,&
                  & input_fields(input_field_num)%long_name,&
                  & input_fields(input_field_num)%range, output_fields(field_num)%pack,&
                  & avg_name = avg,&
                  & time_method=output_fields(field_num)%time_method,&
                  & standard_name = input_fields(input_field_num)%standard_name,&
                  & attributes=output_fields(field_num)%attributes,&
                  & num_attributes=output_fields(field_num)%num_attributes)
          END IF
       END IF
    END DO

    ! If any of the fields in the file are time averaged, need to output the axes
    ! Use double precision since time axis is double precision
    IF ( time_ops ) THEN
       time_axis_id(1) = files(file)%time_axis_id
       files(file)%f_avg_start = write_field_meta_data(files(file)%file_unit,&
            & avg_name // '_T1', time_axis_id, time_units,&
            & "Start time for average period", pack=pack_size)
       files(file)%f_avg_end = write_field_meta_data(files(file)%file_unit,&
            & avg_name // '_T2', time_axis_id, time_units,&
            & "End time for average period", pack=pack_size)
       files(file)%f_avg_nitems = write_field_meta_data(files(file)%file_unit,&
            & avg_name // '_DT', time_axis_id,&
            & TRIM(time_unit_list(files(file)%time_units)),&
            & "Length of average period", pack=pack_size)
    END IF

    IF ( time_ops ) THEN
       time_axis_id(1) = files(file)%time_axis_id
       time_bounds_id(1) = files(file)%time_bounds_id
       CALL get_diag_axis( time_axis_id(1), time_name, time_units, time_longname,&
            & cart_name, dir, edges, Domain, DATA)
       CALL get_diag_axis( time_bounds_id(1), timeb_name, timeb_units, timeb_longname,&
            & cart_name, dir, edges, Domain, DATA)
       files(file)%f_bounds =  write_field_meta_data(files(file)%file_unit,&
            & TRIM(time_name)//'_bounds', (/time_bounds_id,time_axis_id/),&
            & TRIM(time_unit_list(files(file)%time_units)),&
            & TRIM(time_name)//' axis boundaries', pack=pack_size)
    END IF
    ! Let lower levels know that all meta data has been sent
    CALL done_meta_data(files(file)%file_unit)
    IF( aux_present .AND. .NOT.match_aux_name ) THEN
       ! <ERROR STATUS="WARNING">
       !   one axis has auxiliary but the corresponding field is NOT
       !   found in file <file_name>
       ! </ERROR>
       IF ( mpp_pe() == mpp_root_pe() ) CALL error_mesg('diag_util_mod::opening_file',&
            &'one axis has auxiliary but the corresponding field is NOT found in file '//TRIM(files(file)%name), WARNING)
    END IF
  END SUBROUTINE opening_file
  ! </SUBROUTINE>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <FUNCTION NAME="get_time_string">
  !   <OVERVIEW>
  !     This function determines a string based on current time.
  !     This string is used as suffix in output file name
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     CHARACTER(len=128) FUNCTION get_time_string(filename, current_time)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     This function determines a string based on current time.
  !     This string is used as suffix in output file name
  !   </DESCRIPTION>
  !   <IN NAME="filename" TYPE="CHARACTER(len=128)">File name.</IN>
  !   <IN NAME="current_time" TYPE="TYPE(time_type)">Current model time.</IN>
  CHARACTER(len=128) FUNCTION get_time_string(filename, current_time)
    CHARACTER(len=128), INTENT(in) :: filename
    TYPE(time_type), INTENT(in) :: current_time

    INTEGER :: yr1, mo1, dy1, hr1, mi1, sc1  ! get from current time
    INTEGER :: yr2, dy2, hr2, mi2            ! for computing next_level time unit
    INTEGER :: yr1_s, mo1_s, dy1_s, hr1_s, mi1_s, sc1_s ! actual values to write string
    INTEGER :: abs_sec, abs_day              ! component of current_time
    INTEGER :: days_per_month(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)
    INTEGER :: julian_day, i, position, len, first_percent
    CHARACTER(len=1) :: width  ! width of the field in format write
    CHARACTER(len=10) :: format
    CHARACTER(len=20) :: yr, mo, dy, hr, mi, sc        ! string of current time (output)
    CHARACTER(len=128) :: filetail

    format = '("_",i*.*)'
    CALL get_date(current_time, yr1, mo1, dy1, hr1, mi1, sc1)
    len = LEN_TRIM(filename)
    first_percent = INDEX(filename, '%')
    filetail = filename(first_percent:len)
    ! compute year string
    position = INDEX(filetail, 'yr')
    IF ( position > 0 ) THEN
       width = filetail(position-1:position-1)
       yr1_s = yr1
       format(7:9) = width//'.'//width
       WRITE(yr, format) yr1_s
       yr2 = 0
    ELSE
       yr = ' '
       yr2 = yr1 - 1
    END IF
    ! compute month string
    position = INDEX(filetail, 'mo')
    IF ( position > 0 ) THEN
       width = filetail(position-1:position-1)
       mo1_s = yr2*12 + mo1
       format(7:9) = width//'.'//width
       WRITE(mo, format) mo1_s
    ELSE
       mo = ' '
    END IF
    ! compute day string
    IF ( LEN_TRIM(mo) > 0 ) THEN ! month present
       dy1_s = dy1
       dy2 = dy1_s - 1
    ELSE IF ( LEN_TRIM(yr) >0 )  THEN ! no month, year present
       ! compute julian day
       IF ( mo1 == 1 ) THEN
          dy1_s = dy1
       ELSE
          julian_day = 0
          DO i = 1, mo1-1
             julian_day = julian_day + days_per_month(i)
          END DO
          IF ( leap_year(current_time) .AND. mo1 > 2 ) julian_day = julian_day + 1
          julian_day = julian_day + dy1
          dy1_s = julian_day
       END IF
       dy2 = dy1_s - 1
    ELSE ! no month, no year
       CALL get_time(current_time, abs_sec, abs_day)
       dy1_s = abs_day
       dy2 = dy1_s
    END IF
    position = INDEX(filetail, 'dy')
    IF ( position > 0 ) THEN
       width = filetail(position-1:position-1)
       FORMAT(7:9) = width//'.'//width
       WRITE(dy, FORMAT) dy1_s
    ELSE
       dy = ' '
    END IF
    ! compute hour string
    IF ( LEN_TRIM(dy) > 0 ) THEN
       hr1_s = hr1
    ELSE
       hr1_s = dy2*24 + hr1
    END IF
    hr2 = hr1_s
    position = INDEX(filetail, 'hr')
    IF ( position > 0 ) THEN
       width = filetail(position-1:position-1)
       format(7:9) = width//'.'//width
       WRITE(hr, format) hr1_s
    ELSE
       hr = ' '
    END IF
    ! compute minute string
    IF ( LEN_TRIM(hr) > 0 ) THEN
       mi1_s = mi1
    ELSE
       mi1_s = hr2*60 + mi1
    END IF
    mi2 = mi1_s
    position = INDEX(filetail, 'mi')
    IF(position>0) THEN
       width = filetail(position-1:position-1)
       format(7:9) = width//'.'//width
       WRITE(mi, format) mi1_s
    ELSE
       mi = ' '
    END IF
    ! compute second string
    IF ( LEN_TRIM(mi) > 0 ) THEN
       sc1_s = sc1
    ELSE
       sc1_s = NINT(mi2*SECONDS_PER_MINUTE) + sc1
    END IF
    position = INDEX(filetail, 'sc')
    IF ( position > 0 ) THEN
       width = filetail(position-1:position-1)
       format(7:9) = width//'.'//width
       WRITE(sc, format) sc1_s
    ELSE
       sc = ' '
    ENDIF
    get_time_string = TRIM(yr)//TRIM(mo)//TRIM(dy)//TRIM(hr)//TRIM(mi)//TRIM(sc)
  END FUNCTION get_time_string
  ! </FUNCTION>
  ! </PRIVATE>

  ! <FUNCTION NAME="get_date_dif">
  !   <OVERVIEW>
  !     Return the difference between two times in units.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     REAL FUNCTION get_date_dif(t2, t1, units)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Calculate and return the difference between the two times given in the unit given using the function <TT>t2 - t1</TT>.
  !   </DESCRIPTION>
  !   <IN NAME="t2" TYPE="TYPE(time_type)">Most recent time.</IN>
  !   <IN NAME="t1" TYPE="TYPE(time_type)">Most distant time.</IN>
  !   <IN NAME="units" TYPE="INTEGER">Unit of return value.</IN>
  REAL FUNCTION get_date_dif(t2, t1, units)
    TYPE(time_type), INTENT(in) :: t2, t1
    INTEGER, INTENT(in) :: units

    INTEGER :: dif_seconds, dif_days
    TYPE(time_type) :: dif_time

    ! Compute time axis label value
    ! <ERROR STATUS="FATAL">
    !   variable t2 is less than in variable t1
    ! </ERROR>
    IF ( t2 < t1 ) CALL error_mesg('diag_util_mod::get_date_dif', &
         & 'in variable t2 is less than in variable t1', FATAL)

    dif_time = t2 - t1

    CALL get_time(dif_time, dif_seconds, dif_days)

    IF ( units == DIAG_SECONDS ) THEN
       get_date_dif = dif_seconds + SECONDS_PER_DAY * dif_days
    ELSE IF ( units == DIAG_MINUTES ) THEN
       get_date_dif = 1440 * dif_days + dif_seconds / SECONDS_PER_MINUTE
    ELSE IF ( units == DIAG_HOURS ) THEN
       get_date_dif = 24 * dif_days + dif_seconds / SECONDS_PER_HOUR
    ELSE IF ( units == DIAG_DAYS ) THEN
       get_date_dif = dif_days + dif_seconds / SECONDS_PER_DAY
    ELSE IF ( units == DIAG_MONTHS ) THEN
       ! <ERROR STATUS="FATAL">
       !   months not supported as output units
       ! </ERROR>
       CALL error_mesg('diag_util_mod::get_date_dif', 'months not supported as output units', FATAL)
    ELSE IF ( units == DIAG_YEARS ) THEN
       ! <ERROR STATUS="FATAL">
       !   years not suppored as output units
       ! </ERROR>
       CALL error_mesg('diag_util_mod::get_date_dif', 'years not supported as output units', FATAL)
    ELSE
       ! <ERROR STATUS="FATAL">
       !   illegal time units
       ! </ERROR>
       CALL error_mesg('diag_util_mod::diag_date_dif', 'illegal time units', FATAL)
    END IF
  END FUNCTION get_date_dif
  ! </FUNCTION>

  ! <SUBROUTINE NAME="diag_data_out">
  !   <OVERVIEW>
  !     Write data out to file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE diag_data_out(file, field, dat, time, fianl_call_in, static_write_in)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Write data out to file, and if necessary flush the buffers.
  !   </DESCRIPTION>
  !   <IN NAME="file" TYPE="INTEGER">File ID.</IN>
  !   <IN NAME="field" TYPE="INTEGER">Field ID.</IN>
  !   <INOUT NAME="dat" TYPE="REAL, DIMENSION(:,:,:,:)">Data to write out.</INOUT>
  !   <IN NAME="time" TYPE="TYPE(time_type)">Current model time.</IN>
  !   <IN NAME="final_call_in" TYPE="LOGICAL, OPTIONAL"><TT>.TRUE.</TT> if this is the last write for file.</IN>
  !   <IN NAME="static_write_in" TYPE="LOGICAL, OPTIONAL"><TT>.TRUE.</TT> if static fields are to be written to file.</IN>
  SUBROUTINE diag_data_out(file, field, dat, time, final_call_in, static_write_in)
    INTEGER, INTENT(in) :: file, field
    REAL, DIMENSION(:,:,:,:), INTENT(inout) :: dat
    TYPE(time_type), INTENT(in) :: time
    LOGICAL, OPTIONAL, INTENT(in):: final_call_in, static_write_in

    LOGICAL :: final_call, do_write, static_write
    INTEGER :: i, num
    REAL :: dif, time_data(2, 1, 1, 1), dt_time(1, 1, 1, 1), start_dif, end_dif

    do_write = .TRUE.
    final_call = .FALSE.
    IF ( PRESENT(final_call_in) ) final_call = final_call_in
    static_write = .FALSE.
    IF ( PRESENT(static_write_in) ) static_write = static_write_in
    dif = get_date_dif(time, base_time, files(file)%time_units)
    ! get file_unit, open new file and close curent file if necessary
    IF ( .NOT.static_write .OR. files(file)%file_unit < 0 ) CALL check_and_open(file, time, do_write)
    IF ( .NOT.do_write ) RETURN  ! no need to write data
    CALL diag_field_out(files(file)%file_unit, output_fields(field)%f_type, dat, dif)
    ! record number of bytes written to this file
    files(file)%bytes_written = files(file)%bytes_written +&
         & (SIZE(dat,1)*SIZE(dat,2)*SIZE(dat,3))*(8/output_fields(field)%pack)
    IF ( .NOT.output_fields(field)%written_once ) output_fields(field)%written_once = .TRUE.
    ! *** inserted this line because start_dif < 0 for static fields ***
    IF ( .NOT.output_fields(field)%static ) THEN
       start_dif = get_date_dif(output_fields(field)%last_output, base_time,files(file)%time_units)
       IF ( .NOT.mix_snapshot_average_fields ) THEN
          end_dif = get_date_dif(output_fields(field)%next_output, base_time, files(file)%time_units)
       ELSE
          end_dif = dif
       END IF
    END IF

    ! Need to write average axes out;
    DO i = 1, files(file)%num_fields
       num = files(file)%fields(i)
       IF ( output_fields(num)%time_ops .AND. &
            input_fields(output_fields(num)%input_field)%register) THEN
          IF ( num == field ) THEN
             ! Output the axes if this is first time-averaged field
             time_data(1, 1, 1, 1) = start_dif
             CALL diag_field_out(files(file)%file_unit, files(file)%f_avg_start, time_data(1:1,:,:,:), dif)
             time_data(2, 1, 1, 1) = end_dif
             CALL diag_field_out(files(file)%file_unit, files(file)%f_avg_end, time_data(2:2,:,:,:), dif)
             ! Compute the length of the average
             dt_time(1, 1, 1, 1) = end_dif - start_dif
             CALL diag_field_out(files(file)%file_unit, files(file)%f_avg_nitems, dt_time(1:1,:,:,:), dif)

             ! Include boundary variable for CF compliance
             CALL diag_field_out(files(file)%file_unit, files(file)%f_bounds, time_data(1:2,:,:,:), dif)
             EXIT
          END IF
       END IF
    END DO

    ! If write time is greater (equal for the last call) than last_flush for this file, flush it
    IF ( final_call ) THEN
       IF ( time >= files(file)%last_flush ) THEN
          CALL diag_flush(files(file)%file_unit)
          files(file)%last_flush = time
       END IF
    ELSE
       IF ( time > files(file)%last_flush .AND. (.NOT.conserve_water.OR.debug_diag_manager) ) THEN
          CALL diag_flush(files(file)%file_unit)
          files(file)%last_flush = time
       END IF
    END IF
  END SUBROUTINE diag_data_out
  ! </SUBROUTINE>

  ! <PRIVATE>
  ! <SUBROUTINE NAME="check_and_open">
  !   <OVERVIEW>
  !     Checks if it is time to open a new file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE check_and_open(file, time, do_write)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Checks if it is time to open a new file. If yes, it first closes the
  !     current file, opens a new file and returns file_unit
  !     previous diag_manager_end is replaced by closing_file and output_setup by opening_file.
  !   </DESCRIPTION>
  !   <IN NAME="file" TYPE="INTEGER">File ID.</IN>
  !   <IN NAME="time" TYPE="TYPE(time_type)">Current model time.</IN>
  !   <OUT NAME="do_write" TYPE="LOGICAL"><TT>.TRUE.</TT> if file is expecting more data to write, <TT>.FALSE.</TT> otherwise.</OUT>
  SUBROUTINE check_and_open(file, time, do_write)
    INTEGER, INTENT(in) :: file
    TYPE(time_type), INTENT(in) :: time
    LOGICAL, INTENT(out) :: do_write

    IF ( time >= files(file)%start_time ) THEN
       IF ( files(file)%file_unit < 0 ) THEN ! need to open a new file
          CALL opening_file(file, time)
          do_write = .TRUE.
       ELSE
          do_write = .TRUE.
          IF ( time > files(file)%close_time .AND. time < files(file)%next_open ) THEN
             do_write = .FALSE. ! file still open but receives NO MORE data
          ELSE IF ( time > files(file)%next_open ) THEN ! need to close current file and open a new one
             CALL write_static(file)  ! write all static fields and close this file
             CALL opening_file(file, time)
             files(file)%start_time = files(file)%next_open
             files(file)%close_time =&
                  & diag_time_inc(files(file)%start_time,files(file)%duration, files(file)%duration_units)
             files(file)%next_open =&
                  & diag_time_inc(files(file)%next_open, files(file)%new_file_freq,&
                  & files(file)%new_file_freq_units)
             IF ( files(file)%close_time > files(file)%next_open ) THEN
                ! <ERROR STATUS="FATAL">
                !   <file_name> has close time GREATER than next_open time,
                !   check file duration and frequency
                ! </ERROR>
                CALL error_mesg('diag_util_mod::check_and_open',&
                     & files(file)%name//' has close time GREATER than next_open time, check file duration and frequency',FATAL)
             END IF
          END IF ! no need to open new file, simply return file_unit
       END IF
    ELSE
       do_write = .FALSE.
    END IF
  END SUBROUTINE check_and_open
  ! </SUBROUTINE>
  ! </PRIVATE>

  ! <SUBROUTINE NAME="write_static">
  !   <OVERVIEW>
  !     Output all static fields in this file
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE write_static(file)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Write the static data to the file.
  !   </DESCRIPTION>
  !   <IN NAME="file" TYPE="INTEGER">File ID.</IN>
  SUBROUTINE write_static(file)
    INTEGER, INTENT(in) :: file

    INTEGER :: j, i, input_num

    DO j = 1, files(file)%num_fields
       i = files(file)%fields(j)
       input_num = output_fields(i)%input_field
       ! skip fields that were not registered
       IF ( .NOT.input_fields(input_num)%register ) CYCLE
       if( output_fields(i)%local_output .AND. .NOT. output_fields(i)%need_compute) CYCLE
       ! only output static fields here
       IF ( .NOT.output_fields(i)%static ) CYCLE
       CALL diag_data_out(file, i, output_fields(i)%buffer, files(file)%last_flush, .TRUE., .TRUE.)
    END DO
    ! Close up this file
    CALL mpp_close(files(file)%file_unit)
    files(file)%file_unit = -1
  END SUBROUTINE write_static
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="check_duplicate_output_fields">
  !   <OVERVIEW>
  !     Checks to see if <TT>output_name</TT> and <TT>output_file</TT> are unique in <TT>output_fields</TT>.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE check_duplicate_output_fields(err_msg)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Check to see if <TT>output_name</TT> and <TT>output_file</TT> are unique in <TT>output_fields</TT>.  An empty
  !     <TT>err_msg</TT> indicates no duplicates found.
  !   </DESCRIPTION>
  !   <OUT NAME="err_msg" TYPE="CHARACTER(len=*), OPTIONAL">Error message.  If empty, then no duplicates found.</OUT>
  SUBROUTINE check_duplicate_output_fields(err_msg)
    CHARACTER(len=*), INTENT(out), OPTIONAL :: err_msg

    INTEGER :: i, j, tmp_file
    CHARACTER(len=128) :: tmp_name
    CHARACTER(len=256) :: err_msg_local

    IF ( PRESENT(err_msg) ) err_msg=''
    ! Do the checking when more than 1 output_fileds present
    IF ( num_output_fields <= 1 ) RETURN
    err_msg_local = ''

    i_loop: DO i = 1, num_output_fields-1
       tmp_name = TRIM(output_fields(i)%output_name)
       tmp_file =  output_fields(i)%output_file
       DO j = i+1, num_output_fields
          IF ( (tmp_name == TRIM(output_fields(j)%output_name)) .AND. &
               &(tmp_file == output_fields(j)%output_file)) THEN
             err_msg_local = ' output_field "'//TRIM(tmp_name)//&
                  &'" duplicated in file "'//TRIM(files(tmp_file)%name)//'"'
             EXIT i_loop
          END IF
       END DO
    END DO i_loop
    IF ( err_msg_local /= '' ) THEN
       IF ( fms_error_handler(' ERROR in diag_table',err_msg_local,err_msg) ) RETURN
    END IF
  END SUBROUTINE check_duplicate_output_fields
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="attribute_init_field" INTERFACE="attribute_init">
  !   <OVERVIEW>
  !     Allocates the atttype in out_field
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE attribute_init(out_field, err_msg)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Allocates memory in out_field for the attributes.  Will <TT>FATAL</TT> if err_msg is not included
  !     in the subroutine call.
  !   </DESCRIPTION>
  !   <INOUT NAME="out_field" TYPE="TYPE(output_field_type)">output field to allocate memory for attribute</INOUT>
  !   <OUT NAME="err_msg" TYPE="CHARACTER(len=*), OPTIONAL">Error message, passed back to calling function</OUT>
  SUBROUTINE attribute_init_field(out_field, err_msg)
    TYPE(output_field_type), INTENT(inout) :: out_field
    CHARACTER(LEN=*), INTENT(out), OPTIONAL :: err_msg

    INTEGER :: istat

    ! Need to initialize err_msg if present
    IF ( PRESENT(err_msg) ) err_msg = ''

    ! Allocate memory for the attributes
    IF ( .NOT._ALLOCATED(out_field%attributes) ) THEN
       ALLOCATE(out_field%attributes(max_field_attributes), STAT=istat)
       IF ( istat.NE.0 ) THEN
          ! <ERROR STATUS="FATAL">
          !   Unable to allocate memory for attribute <name> to module/input_field <module_name>/<field_name>
          ! </ERROR>
          IF ( fms_error_handler('diag_util_mod::attribute_init_field',&
               & 'Unable to allocate memory for attributes', err_msg) ) THEN
             RETURN
          END IF
       ELSE
          ! Set equal to 0.  It will be increased when attributes added
          out_field%num_attributes = 0
       END IF
    END IF
  END SUBROUTINE attribute_init_field
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="prepend_attribute_field" INTERFACE="prepend_attribute">
  !   <OVERVIEW>
  !     Prepends the attribute value to an already existing attribute.  If the
  !     attribute isn't yet defined, then creates a new attribute
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE prepend_attribute(out_field, attribute, prepend_value)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Checks if the attribute already exists in the <TT>out_field</TT>.  If it exists,
  !     then prepend the <TT>prepend_value</TT>, otherwise, create the attribute
  !     with the <TT>prepend_value</TT>. <TT>err_msg</TT> indicates no duplicates found.
  !   </DESCRIPTION>
  !   <INOUT NAME="out_field" TYPE="TYPE(output_field_type)">output field that will get the attribute</INOUT>
  !   <IN NAME="att_name" TYPE="CHARACTER(len=*)">Name of the attribute</IN>
  !   <IN NAME="prepend_value" TYPE="CHARACTER(len=*)">Value to prepend</IN>
  !   <OUT NAME="err_msg" TYPE="CHARACTER(len=*), OPTIONAL">Error message, passed back to calling routine</OUT>
  SUBROUTINE prepend_attribute_field(out_field, att_name, prepend_value, err_msg)
    TYPE(output_field_type), INTENT(inout) :: out_field
    CHARACTER(len=*), INTENT(in) :: att_name, prepend_value
    CHARACTER(len=*), INTENT(out) , OPTIONAL :: err_msg

    INTEGER :: length, i, this_attribute
    CHARACTER(len=512) :: err_msg_local

    ! Initialize string characters
    err_msg_local=''
    IF ( PRESENT(err_msg) ) err_msg = ''

    ! Make sure the attributes for this out field have been initialized
    CALL attribute_init_field(out_field, err_msg_local)
    IF ( TRIM(err_msg_local) .NE. '' ) THEN
       IF ( fms_error_handler('diag_util_mod::prepend_attribute_field', TRIM(err_msg_local), err_msg) ) THEN
          RETURN
       END IF
    END IF

    ! Find if attribute exists
    this_attribute = 0
    DO i=1, out_field%num_attributes
       IF ( TRIM(out_field%attributes(i)%name) .EQ. TRIM(att_name) ) THEN
          this_attribute = i
          EXIT
       END IF
    END DO

    IF ( this_attribute > 0 ) THEN
       IF ( out_field%attributes(this_attribute)%type .NE. NF90_CHAR ) THEN
          ! <ERROR STATUS="FATAL">
          !   Attribute <name> is not a character attribute.
          ! </ERROR>
          IF ( fms_error_handler('diag_util_mod::prepend_attribute_field', &
               & 'Attribute "'//TRIM(att_name)//'" is not a character attribute.',&
               & err_msg) ) THEN
             RETURN
          END IF
       END IF
    ELSE
       ! Defining a new attribute
       ! Increase the number of field attributes
       this_attribute = out_field%num_attributes + 1
       IF ( this_attribute .GT. max_field_attributes ) THEN
          ! <ERROR STATUS="FATAL">
          !   Number of attributes exceeds max_field_attributes for attribute <name>.
          !   Increase diag_manager_nml:max_field_attributes.
          ! </ERROR>
          IF ( fms_error_handler('diag_util_mod::prepend_attribute_field',&
               & 'Number of attributes exceeds max_field_attributes for attribute "'&
               & //TRIM(att_name)//'".  Increase diag_manager_nml:max_field_attributes.',&
               & err_msg) ) THEN
             RETURN
          END IF
       ELSE
          out_field%num_attributes = this_attribute
          ! Set name and type
          out_field%attributes(this_attribute)%name = att_name
          out_field%attributes(this_attribute)%type = NF90_CHAR
          ! Initialize catt to a blank string, as len_trim doesn't always work on an uninitialized string
          out_field%attributes(this_attribute)%catt = ''
       END IF
    END IF

    ! Check if string is already included, and return if found
    IF ( INDEX(TRIM(out_field%attributes(this_attribute)%catt), TRIM(prepend_value)).EQ.0 ) THEN
       ! Check if new string length goes beyond the length of catt
       length = LEN_TRIM(TRIM(prepend_value)//" "//TRIM(out_field%attributes(this_attribute)%catt))
       IF ( length.GT.LEN(out_field%attributes(this_attribute)%catt) ) THEN
          ! <ERROR STATUS="FATAL">
          !   Prepend length for attribute <name> is longer than allowed.
          ! </ERROR>
          IF ( fms_error_handler('diag_util_mod::prepend_attribute_field',&
               & 'Prepend length for attribute "'//TRIM(att_name)//'" is longer than allowed.',&
               & err_msg) ) THEN
             RETURN
          END IF
       END IF
       ! Set fields
       out_field%attributes(this_attribute)%catt =&
            & TRIM(prepend_value)//' '//TRIM(out_field%attributes(this_attribute)%catt)
       out_field%attributes(this_attribute)%len = length
    END IF
  END SUBROUTINE prepend_attribute_field
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="attribute_init_file" INTERFACE="attribute_init">
  !   <OVERVIEW>
  !     Allocates the atttype in out_file
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE attribute_init(out_file, err_msg)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Allocates memory in out_file for the attributes.  Will <TT>FATAL</TT> if err_msg is not included
  !     in the subroutine call.
  !   </DESCRIPTION>
  !   <INOUT NAME="out_file" TYPE="TYPE(file_type)">output file to allocate memory for attribute</INOUT>
  !   <OUT NAME="err_msg" TYPE="CHARACTER(len=*), OPTIONAL">Error message, passed back to calling function</OUT>
  SUBROUTINE attribute_init_file(out_file, err_msg)
    TYPE(file_type), INTENT(inout) :: out_file
    CHARACTER(LEN=*), INTENT(out), OPTIONAL :: err_msg

    INTEGER :: istat

    ! Initialize err_msg
    IF ( PRESENT(err_msg) ) err_msg = ''

    ! Allocate memory for the attributes
    IF ( .NOT._ALLOCATED(out_file%attributes) ) THEN
       ALLOCATE(out_file%attributes(max_field_attributes), STAT=istat)
       IF ( istat.NE.0 ) THEN
          ! <ERROR STATUS="FATAL">
          !   Unable to allocate memory for file attributes
          ! </ERROR>
          IF ( fms_error_handler('diag_util_mod::attribute_init_file', 'Unable to allocate memory for file attributes', err_msg) ) THEN
             RETURN
          END IF
       ELSE
          ! Set equal to 0.  It will be increased when attributes added
          out_file%num_attributes = 0
       END IF
    END IF
  END SUBROUTINE attribute_init_file
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="prepend_attribute_file" INTERFACE="prepend_attribute">
  !   <OVERVIEW>
  !     Prepends the attribute value to an already existing attribute.  If the
  !     attribute isn't yet defined, then creates a new attribute
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE prepend_attribute(out_file, attribute, prepend_value)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Checks if the attribute already exists in the <TT>out_file</TT>.  If it exists,
  !     then prepend the <TT>prepend_value</TT>, otherwise, create the attribute
  !     with the <TT>prepend_value</TT>. <TT>err_msg</TT> indicates no duplicates found.
  !   </DESCRIPTION>
  !   <INOUT NAME="out_file" TYPE="TYPE(file_type)">output file that will get the attribute</INOUT>
  !   <IN NAME="att_name" TYPE="CHARACTER(len=*)">Name of the attribute</IN>
  !   <IN NAME="prepend_value" TYPE="CHARACTER(len=*)">Value to prepend</IN>
  !   <OUT NAME="err_msg" TYPE="CHARACTER(len=*), OPTIONAL">Error message, passed back to calling routine</OUT>
  SUBROUTINE prepend_attribute_file(out_file, att_name, prepend_value, err_msg)
    TYPE(file_type), INTENT(inout) :: out_file
    CHARACTER(len=*), INTENT(in) :: att_name, prepend_value
    CHARACTER(len=*), INTENT(out) , OPTIONAL :: err_msg

    INTEGER :: length, i, this_attribute
    CHARACTER(len=512) :: err_msg_local

    ! Initialize string variables
    err_msg_local = ''
    IF ( PRESENT(err_msg) ) err_msg = ''

    ! Make sure the attributes for this out file have been initialized
    CALL attribute_init_file(out_file, err_msg_local)
    IF ( TRIM(err_msg_local) .NE. '' ) THEN
       IF ( fms_error_handler('diag_util_mod::prepend_attribute_file', TRIM(err_msg_local), err_msg) ) THEN
          RETURN
       END IF
    END IF

    ! Find if attribute exists
    this_attribute = 0
    DO i=1, out_file%num_attributes
       IF ( TRIM(out_file%attributes(i)%name) .EQ. TRIM(att_name) ) THEN
          this_attribute = i
          EXIT
       END IF
    END DO

    IF ( this_attribute > 0 ) THEN
       IF ( out_file%attributes(this_attribute)%type .NE. NF90_CHAR ) THEN
          ! <ERROR STATUS="FATAL">
          !   Attribute <name> is not a character attribute.
          ! </ERROR>
          IF ( fms_error_handler('diag_util_mod::prepend_attribute_file',&
               & 'Attribute "'//TRIM(att_name)//'" is not a character attribute.',&
               & err_msg) ) THEN
             RETURN
          END IF
       END IF
    ELSE
       ! Defining a new attribute
       ! Increase the number of file attributes
       this_attribute = out_file%num_attributes + 1
       IF ( this_attribute .GT. max_file_attributes ) THEN
          ! <ERROR STATUS="FATAL">
          !   Number of attributes exceeds max_file_attributes for attribute <name>.
          !   Increase diag_manager_nml:max_file_attributes.
          ! </ERROR>
          IF ( fms_error_handler('diag_util_mod::prepend_attribute_file',&
               & 'Number of attributes exceeds max_file_attributes for attribute "'&
               &//TRIM(att_name)//'".  Increase diag_manager_nml:max_file_attributes.',&
               & err_msg) ) THEN
             RETURN
          END IF
       ELSE
          out_file%num_attributes = this_attribute
          ! Set name and type
          out_file%attributes(this_attribute)%name = att_name
          out_file%attributes(this_attribute)%type = NF90_CHAR
          ! Initialize catt to a blank string, as len_trim doesn't always work on an uninitialized string
          out_file%attributes(this_attribute)%catt = ''
       END IF
    END IF

    ! Only add string only if not already defined
    IF ( INDEX(TRIM(out_file%attributes(this_attribute)%catt), TRIM(prepend_value)).EQ.0 ) THEN
       ! Check if new string length goes beyond the length of catt
       length = LEN_TRIM(TRIM(prepend_value)//" "//TRIM(out_file%attributes(this_attribute)%catt))
       IF ( length.GT.LEN(out_file%attributes(this_attribute)%catt) ) THEN
          ! <ERROR STATUS="FATAL">
          !   Prepend length for attribute <name> is longer than allowed.
          ! </ERROR>
          IF ( fms_error_handler('diag_util_mod::prepend_attribute_file',&
               & 'Prepend length for attribute "'//TRIM(att_name)//'" is longer than allowed.',&
               & err_msg) ) THEN
             RETURN
          END IF
       END IF
       ! Set files
       out_file%attributes(this_attribute)%catt =&
            & TRIM(prepend_value)//' '//TRIM(out_file%attributes(this_attribute)%catt)
       out_file%attributes(this_attribute)%len = length
    END IF
  END SUBROUTINE prepend_attribute_file
  ! </SUBROUTINE>
END MODULE diag_util_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: scops.F,v 20.0 2013/12/13 23:16:04 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif
      subroutine scops(npoints,nlev,ncol,seed,cc,conv,
     &                 overlap,frac_out,ncolprint)


! *****************************COPYRIGHT****************************
! (c) British Crown Copyright 2009, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without 
! modification, are permitted provided that the
! following conditions are met:
! 
!     * Redistributions of source code must retain the above 
!       copyright  notice, this list of conditions and the following 
!       disclaimer.
!     * Redistributions in binary form must reproduce the above 
!       copyright notice, this list of conditions and the following 
!       disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its 
!       contributors may be used to endorse or promote products
!       derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
! A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
! OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
! SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
! LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
! THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
! 
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************

      implicit none

      INTEGER npoints       !  number of model points in the horizontal
      INTEGER nlev          !  number of model levels in column
      INTEGER ncol          !  number of subcolumns


      INTEGER overlap         !  overlap type
                              !  1=max
                              !  2=rand
                              !  3=max/rand
      REAL cc(npoints,nlev)
                  !  input cloud cover in each model level (fraction)
                  !  NOTE:  This is the HORIZONTAL area of each
                  !         grid box covered by clouds

      REAL conv(npoints,nlev)
                  !  input convective cloud cover in each model
                  !   level (fraction)
                  !  NOTE:  This is the HORIZONTAL area of each
                  !         grid box covered by convective clouds

      INTEGER i,j,ilev,ibox,ncolprint,ilev2

      REAL frac_out(npoints,ncol,nlev) ! boxes gridbox divided up into
                              ! Equivalent of BOX in original version, but
                              ! indexed by column then row, rather than
                              ! by row then column


      INTEGER seed(npoints)
      !  seed values for marsaglia  random number generator
      !  It is recommended that the seed is set
      !  to a different value for each model
      !  gridbox it is called on, as it is
      !  possible that the choice of the same
      !  seed value every time may introduce some
      !  statistical bias in the results, particularly
      !  for low values of NCOL.

      REAL tca(npoints,0:nlev) ! total cloud cover in each model level (fraction)
                                        ! with extra layer of zeroes on top
                                        ! in this version this just contains the values input
                                        ! from cc but with an extra level

      REAL threshold(npoints,ncol)   ! pointer to position in gridbox
      REAL maxocc(npoints,ncol)      ! Flag for max overlapped conv cld
      REAL maxosc(npoints,ncol)      ! Flag for max overlapped strat cld

      REAL boxpos(npoints,ncol)      ! ordered pointer to position in gridbox

      REAL threshold_min(npoints,ncol) ! minimum value to define range in with new threshold
                                        ! is chosen

      REAL ran(npoints)                 ! vector of random numbers

      INTEGER irand,i2_16,huge32,overflow_32  ! variables for RNG
      PARAMETER(huge32=2147483647)
      i2_16=65536

      do ibox=1,ncol
        do j=1,npoints 
        boxpos(j,ibox)=(ibox-.5)/ncol
        enddo
      enddo

!     ---------------------------------------------------!
!     Initialise working variables
!     ---------------------------------------------------!

!     Initialised frac_out to zero

      do ilev=1,nlev
        do ibox=1,ncol
          do j=1,npoints
          frac_out(j,ibox,ilev)=0.0
          enddo
        enddo
      enddo

!     assign 2d tca array using 1d input array cc

      do j=1,npoints
        tca(j,0)=0
      enddo

      do ilev=1,nlev
        do j=1,npoints
          tca(j,ilev)=cc(j,ilev)
        enddo
      enddo

      if (ncolprint.ne.0) then
        write (6,'(a)') 'frac_out_pp_rev:'
          do j=1,npoints,1000
          write(6,'(a10)') 'j='
          write(6,'(8I10)') j
          write (6,'(8f5.2)') 
     &     ((frac_out(j,ibox,ilev),ibox=1,ncolprint),ilev=1,nlev)

          enddo
        write (6,'(a)') 'ncol:'
        write (6,'(I3)') ncol
      endif
      if (ncolprint.ne.0) then
        write (6,'(a)') 'last_frac_pp:'
          do j=1,npoints,1000
          write(6,'(a10)') 'j='
          write(6,'(8I10)') j
          write (6,'(8f5.2)') (tca(j,0))
          enddo
      endif

!     ---------------------------------------------------!
!     ALLOCATE CLOUD INTO BOXES, FOR NCOLUMNS, NLEVELS
!     frac_out is the array that contains the information 
!     where 0 is no cloud, 1 is a stratiform cloud and 2 is a
!     convective cloud
      
      !loop over vertical levels
      DO 200 ilev = 1,nlev
                                  
!     Initialise threshold

        IF (ilev.eq.1) then
          ! If max overlap 
          IF (overlap.eq.1) then
            ! select pixels spread evenly
            ! across the gridbox
              DO ibox=1,ncol
                do j=1,npoints
                  threshold(j,ibox)=boxpos(j,ibox)
                enddo
              enddo
          ELSE
              DO ibox=1,ncol
#ifdef COSP_GFDL
#include "congvec.H"
#else
                include 'congvec.f'
#endif
                ! select random pixels from the non-convective
                ! part the gridbox ( some will be converted into
                ! convective pixels below )
                do j=1,npoints
                  threshold(j,ibox)=
     &            conv(j,ilev)+(1-conv(j,ilev))*ran(j)
                enddo
              enddo
            ENDIF
            IF (ncolprint.ne.0) then
              write (6,'(a)') 'threshold_nsf2:'
                do j=1,npoints,1000
                write(6,'(a10)') 'j='
                write(6,'(8I10)') j
                write (6,'(8f5.2)') (threshold(j,ibox),ibox=1,ncolprint)
                enddo
            ENDIF
        ENDIF

        IF (ncolprint.ne.0) then
            write (6,'(a)') 'ilev:'
            write (6,'(I2)') ilev
        ENDIF

        DO ibox=1,ncol

          ! All versions
          do j=1,npoints
            if (boxpos(j,ibox).le.conv(j,ilev)) then
              maxocc(j,ibox) = 1
            else
              maxocc(j,ibox) = 0
            end if
          enddo

          ! Max overlap
          if (overlap.eq.1) then 
            do j=1,npoints
              threshold_min(j,ibox)=conv(j,ilev)
              maxosc(j,ibox)=1
            enddo
          endif

          ! Random overlap
          if (overlap.eq.2) then 
            do j=1,npoints
              threshold_min(j,ibox)=conv(j,ilev)
              maxosc(j,ibox)=0
            enddo
          endif

          ! Max/Random overlap
          if (overlap.eq.3) then 
            do j=1,npoints
              threshold_min(j,ibox)=max(conv(j,ilev),
     &          min(tca(j,ilev-1),tca(j,ilev)))
              if (threshold(j,ibox)
     &          .lt.min(tca(j,ilev-1),tca(j,ilev))
     &          .and.(threshold(j,ibox).gt.conv(j,ilev))) then
                   maxosc(j,ibox)= 1
              else
                   maxosc(j,ibox)= 0
              end if
            enddo
          endif
    
          ! Reset threshold 

#ifdef COSP_GFDL
#include "congvec.H"
#else
          include 'congvec.f'
#endif

          do j=1,npoints
            threshold(j,ibox)=
              !if max overlapped conv cloud
     &        maxocc(j,ibox) * (                                       
     &            boxpos(j,ibox)                                               
     &        ) +                                                      
              !else
     &        (1-maxocc(j,ibox)) * (                                   
                  !if max overlapped strat cloud
     &            (maxosc(j,ibox)) * (                                 
                      !threshold=boxpos
     &                threshold(j,ibox)                                        
     &            ) +                                                  
                  !else
     &            (1-maxosc(j,ibox)) * (                               
                      !threshold_min=random[thrmin,1]
     &                threshold_min(j,ibox)+
     &                  (1-threshold_min(j,ibox))*ran(j)  
     &           ) 
     &        )
          enddo

        ENDDO ! ibox

!          Fill frac_out with 1's where tca is greater than the threshold

           DO ibox=1,ncol
             do j=1,npoints 
               if (tca(j,ilev).gt.threshold(j,ibox)) then
               frac_out(j,ibox,ilev)=1
               else
               frac_out(j,ibox,ilev)=0
               end if               
             enddo
           ENDDO

!         Code to partition boxes into startiform and convective parts
!         goes here

           DO ibox=1,ncol
             do j=1,npoints 
                if (threshold(j,ibox).le.conv(j,ilev)) then
                    ! = 2 IF threshold le conv(j)
                    frac_out(j,ibox,ilev) = 2 
                else
                    ! = the same IF NOT threshold le conv(j) 
                    frac_out(j,ibox,ilev) = frac_out(j,ibox,ilev)
                end if
             enddo
           ENDDO

!         Set last_frac to tca at this level, so as to be tca 
!         from last level next time round

          if (ncolprint.ne.0) then

            do j=1,npoints ,1000
            write(6,'(a10)') 'j='
            write(6,'(8I10)') j
            write (6,'(a)') 'last_frac:'
            write (6,'(8f5.2)') (tca(j,ilev-1))
    
            write (6,'(a)') 'conv:'
            write (6,'(8f5.2)') (conv(j,ilev),ibox=1,ncolprint)
    
            write (6,'(a)') 'max_overlap_cc:'
            write (6,'(8f5.2)') (maxocc(j,ibox),ibox=1,ncolprint)
    
            write (6,'(a)') 'max_overlap_sc:'
            write (6,'(8f5.2)') (maxosc(j,ibox),ibox=1,ncolprint)
    
            write (6,'(a)') 'threshold_min_nsf2:'
            write (6,'(8f5.2)') (threshold_min(j,ibox),ibox=1,ncolprint)
    
            write (6,'(a)') 'threshold_nsf2:'
            write (6,'(8f5.2)') (threshold(j,ibox),ibox=1,ncolprint)
    
            write (6,'(a)') 'frac_out_pp_rev:'
            write (6,'(8f5.2)') 
     &       ((frac_out(j,ibox,ilev2),ibox=1,ncolprint),ilev2=1,nlev)
          enddo
          endif

200   CONTINUE    !loop over nlev


      end

#ifdef test_mpp
#ifdef SYSTEM_CLOCK
#undef SYSTEM_CLOCK
#endif

program test   !test various aspects of mpp_mod
#include <fms_platform.h>

#ifdef sgi_mipspro
  use shmem_interface
#endif

  use mpp_mod, only : mpp_init, mpp_exit, mpp_pe, mpp_npes, mpp_root_pe, stdout
  use mpp_mod, only : mpp_clock_id, mpp_clock_begin, mpp_clock_end, mpp_sync, mpp_malloc
  use mpp_mod, only : mpp_declare_pelist, mpp_set_current_pelist, mpp_set_stack_size
  use mpp_mod, only : mpp_broadcast, mpp_transmit, mpp_sum, mpp_max, mpp_chksum, ALL_PES
  use mpp_mod, only : mpp_gather, mpp_error, FATAL, mpp_sync_self
  use mpp_io_mod, only: mpp_io_init, mpp_flush
#ifdef use_MPI_GSM
  use mpp_mod, only : mpp_gsm_malloc, mpp_gsm_free
#endif

  implicit none

  integer, parameter              :: n=1048576
  real, allocatable, dimension(:) :: a, b, c
#ifdef use_MPI_GSM
  real                            :: d(n)
  pointer (locd, d)
#else
  real, allocatable, dimension(:) :: d
  integer(LONG_KIND) :: locd
#endif
  integer                         :: tick, tick0, ticks_per_sec, id
  integer                         :: pe, npes, root, i, j, k, l, m, n2, istat
  integer                         :: out_unit
  real                            :: dt

  call mpp_init()
  call mpp_io_init()
  call mpp_set_stack_size(3145746)
  pe = mpp_pe()
  npes = mpp_npes()
  root = mpp_root_pe()

  out_unit = stdout()
  call test_gather(npes,pe,root,out_unit)
  call test_gatherV(npes,pe,root,out_unit)
  call test_gather2DV(npes,pe,root,out_unit)

  if(.false.) then

  ! first test broadcast
  call test_broadcast()

  call SYSTEM_CLOCK( count_rate=ticks_per_sec )

  allocate( a(n), b(n) )
  id = mpp_clock_id( 'Random number' )
  call mpp_clock_begin(id)
  call random_number(a)
  call mpp_clock_end  (id)
  !---------------------------------------------------------------------!
  !   time transmit, compare against shmem_put and get                  !
  !---------------------------------------------------------------------!
  if( pe.EQ.root )then
     print *, 'Time mpp_transmit for various lengths...'
#ifdef SGICRAY
     print *, 'For comparison, times for shmem_get and shmem_put are also provided.'
#endif
     print *
  end if
  id = mpp_clock_id( 'mpp_transmit' )
  call mpp_clock_begin(id)
  !timing is done for cyclical pass (more useful than ping-pong etc)
  l = n
  do while( l.GT.0 )
     !--- mpp_transmit -------------------------------------------------
     call mpp_sync()
     call SYSTEM_CLOCK(tick0)
     do i = 1,npes
        call mpp_transmit( put_data=a(1), plen=l, to_pe=modulo(pe+npes-i,npes), &
                           get_data=b(1), glen=l, from_pe=modulo(pe+i,npes) )
        call mpp_sync_self()
        !          call mpp_sync_self( (/modulo(pe+npes-i,npes)/) )
     end do
     call mpp_sync()
     call SYSTEM_CLOCK(tick)
     dt = real(tick-tick0)/(npes*ticks_per_sec)
     dt = max( dt, epsilon(dt) )
     if( pe.EQ.root )write( out_unit,'(/a,i8,f13.6,f8.2)' )'MPP_TRANSMIT length, time, bw(Mb/s)=', l, dt, l*8e-6/dt
!#ifdef SGICRAY
!     !--- shmem_put ----------------------------------------------------
!     call mpp_sync()
!     call SYSTEM_CLOCK(tick0)
!     do i = 1,npes
!       call shmem_real_put( b, a, l, modulo(pe+1,npes) )
!     end do
!     call mpp_sync()
!     call SYSTEM_CLOCK(tick)
!     dt = real(tick-tick0)/(npes*ticks_per_sec)
!     dt = max( dt, epsilon(dt) )
!     if( pe.EQ.root )write( stdout(),'( a,i8,f13.6,f8.2)' )'SHMEM_PUT    length, time, bw(Mb/s)=', l, dt, l*8e-6/dt
!     !--- shmem_get ----------------------------------------------------
!     call mpp_sync()
!     call SYSTEM_CLOCK(tick0)
!     do i = 1,npes
!        call shmem_real_get( b, a, l, modulo(pe+1,npes) )
!     end do
!     call SYSTEM_CLOCK(tick)
!     dt = real(tick-tick0)/(npes*ticks_per_sec)
!     dt = max( dt, epsilon(dt) )
!     if( pe.EQ.root )write( stdout(),'( a,i8,f13.6,f8.2)' )'SHMEM_GET    length, time, bw(Mb/s)=', l, dt, l*8e-6/dt
!#endif
     l = l/2
  end do
  !---------------------------------------------------------------------!
  !                   test mpp_sum                                      !
  !---------------------------------------------------------------------!
  if( pe.EQ.root )then
     print '(/a)', 'Time mpp_sum...'
  end if
  a = real(pe+1)
  call mpp_sync()
  call SYSTEM_CLOCK(tick0)
  call mpp_sum(a(1:1000),1000)
  call SYSTEM_CLOCK(tick)
  dt = real(tick-tick0)/ticks_per_sec
  dt = max( dt, epsilon(dt) )
  if( pe.EQ.root )write( out_unit,'(a,2i6,f9.1,i8,f13.6,f8.2/)' ) &
       'mpp_sum: pe, npes, sum(pe+1), length, time, bw(Mb/s)=', pe, npes, a(1), n, dt, n*8e-6/dt
  call mpp_clock_end(id)
  !---------------------------------------------------------------------!
  !                   test mpp_max                                      !
  !---------------------------------------------------------------------!
  if( pe.EQ.root )then
     print *
     print *, 'Test mpp_max...'
  end if
  a = real(pe+1)
  print *, 'pe,     pe+1 =', pe, a(1)
  call mpp_max( a(1) )
  print *, 'pe, max(pe+1)=', pe, a(1)
  !pelist check
  call mpp_sync()
  call flush(out_unit,istat)
  if( npes.GE.2 )then
     if( pe.EQ.root )print *, 'Test of pelists: bcast, sum and max using PEs 0...npes-2 (excluding last PE)'
     call mpp_declare_pelist( (/(i,i=0,npes-2)/) )
     a = real(pe+1)
     if( pe.NE.npes-1 )call mpp_broadcast( a, n, npes-2, (/(i,i=0,npes-2)/) )
     print *, 'bcast(npes-1) from 0 to npes-2=', pe, a(1)
     a = real(pe+1)
     if( pe.NE.npes-1 )then
        call mpp_set_current_pelist( (/(i,i=0,npes-2)/) )
        id = mpp_clock_id( 'Partial mpp_sum' )
        call mpp_clock_begin(id)
        call mpp_sum( a(1:1000), 1000, (/(i,i=0,npes-2)/) )
        call mpp_clock_end  (id)
     end if
     if( pe.EQ.root )print *, 'sum(pe+1) from 0 to npes-2=', a(1)
     a = real(pe+1)
     if( pe.NE.npes-1 )call mpp_max( a(1), (/(i,i=0,npes-2)/) )
     if( pe.EQ.root )print *, 'max(pe+1) from 0 to npes-2=', a(1)
  end if
  call mpp_set_current_pelist()
  
#ifdef use_CRI_pointers
  !---------------------------------------------------------------------!
  !                   test mpp_chksum                                   !
  !---------------------------------------------------------------------!
  if( modulo(n,npes).EQ.0 )then  !only set up for even division
     n2 = 1024
     a = 0.d0
     if( pe.EQ.root )call random_number(a(1:n2))
!    if( pe.EQ.root )call random_number(a)
     call mpp_sync()
     call mpp_transmit( put_data=a(1), plen=n2, to_pe=ALL_PES, &
                        get_data=a(1), glen=n2, from_pe=root )
     call mpp_sync_self ()
!    call mpp_transmit( put_data=a(1), plen=n, to_pe=ALL_PES, &
!                       get_data=a(1), glen=n, from_pe=root )
     m= n2/npes
!    m= n/npes
     allocate( c(m) )
     c = a(pe*m+1:pe*m+m)
     
     if( pe.EQ.root )then
        print *
        print *, 'Test mpp_chksum...'
        print *, 'This test shows that a whole array and a distributed array give identical checksums.'
     end if
     print *, 'chksum(a(1:1024))=', mpp_chksum(a(1:n2),(/pe/))
     print *, 'chksum(c(1:1024))=', mpp_chksum(c)
!    print *, 'chksum(a)=', mpp_chksum(a,(/pe/))
!    print *, 'chksum(c)=', mpp_chksum(c)
  end if
!test of pointer sharing
#ifdef use_MPI_GSM
      call mpp_gsm_malloc( locd, sizeof(d) )
#else
  if( pe.EQ.root )then
      allocate( d(n) )
      locd = LOC(d)
  end if
  call mpp_broadcast(locd,root)
#endif
  if( pe.EQ.root )then
      call random_number(d)
  end if
  call mpp_sync()
!  call test_shared_pointers(locd,n)

#ifdef use_MPI_GSM
  call mpp_gsm_free( locd )
#else
  if( pe.EQ.root )then
      deallocate( d )
  end if
#endif
#endif
  endif  ! if(.false.)

  call mpp_exit()

contains

  !***********************************************
  !currently only test the mpp_broadcast_char
  subroutine test_broadcast()
     integer, parameter :: ARRAYSIZE = 3
     integer, parameter :: STRINGSIZE = 256
     character(len=STRINGSIZE), dimension(ARRAYSIZE) :: textA, textB
     integer :: n

     textA(1) = "This is line 1 "
     textA(2) = "Here comes the line 2 "
     textA(3) = "Finally is line 3 "  
     do n = 1, ARRAYSIZE  
        textB(n) = TextA(n)
     enddo

     if(mpp_pe() .NE. mpp_root_pe()) then
        do n =1, ARRAYSIZE
           textA(n) = ""
        enddo
     endif

     !--- comparing textA and textB. textA and textB are supposed to be different on pe other than root_pe
     if(mpp_pe() == mpp_root_pe()) then
        do n = 1, ARRAYSIZE         
           if(textA(n) .NE. textB(n)) call mpp_error(FATAL, "test_broadcast: on root_pe, textA should equal textB")
        enddo
     else
        do n = 1, ARRAYSIZE         
           if(textA(n) == textB(n)) call mpp_error(FATAL, "test_broadcast: on root_pe, textA should not equal textB")
        enddo 
     endif
     call mpp_broadcast(textA, STRINGSIZE, mpp_root_pe())
     !--- after broadcast, textA and textB should be the same
     do n = 1, ARRAYSIZE         
        if(textA(n) .NE. textB(n)) call mpp_error(FATAL, "test_broadcast: after broadcast, textA should equal textB")
     enddo

     write(out_unit,*) "==> NOTE from test_broadcast: The test is succesful"

  end subroutine test_broadcast

  subroutine test_gather(npes,pe,root,out_unit)
     integer, intent(in) :: npes,pe,root,out_unit

     integer :: pelist(npes)
     integer :: i
     real :: rdata(npes)
     real :: val

     if(npes < 3)then
       write(out_unit,*) "Minimum of 3 ranks required. Not testing gather; too few ranks."
       return
     endif
     write(out_unit,*)

     val = pe
     rdata = -1.0
     do i=1,npes
       pelist(i) = i-1
     enddo

     call mpp_gather((/val/),rdata)
     if(pe == root)then 
       do i=1,npes
        if(INT(rdata(i)) /= pelist(i))then
           write(6,*) "Gathered data ",INT(rdata(i)), " NE reference ",pelist(i), "at i=",i
           call mpp_error(FATAL, "Test gather uniform vector with global pelist failed")
        endif
       enddo
     endif

     call mpp_sync()
     write(out_unit,*) "Test gather uniform vector with global pelist successful"

     rdata = -1.0
     if(ANY(pe == pelist(2:npes)))call mpp_gather((/val/),rdata(2:npes),pelist(2:npes))
     if(pe == pelist(2))then
       do i=2,npes
        if(INT(rdata(i)) /= pelist(i))then
           write(6,*) "Gathered data ",INT(rdata(i)), " NE reference ",pelist(i), "at i=",i
           call mpp_error(FATAL, "Test gather uniform vector with reduced pelist failed")
        endif
       enddo
     endif
     call mpp_sync()
     write(out_unit,*) "Test gather uniform vector with reduced pelist successful"

  end subroutine test_gather


  subroutine test_gatherV(npes,pe,root,out_unit)
  implicit none
     integer, intent(in) :: npes,pe,root,out_unit

     integer :: pelist(npes),rsize(npes)
     integer :: i,j,k,dsize,ssize
     real,allocatable :: sdata(:), rdata(:), ref(:)

     if(npes < 3)then
       write(out_unit,*) "Minimum of 3 ranks required. Not testing gatherV; too few ranks."
       return
     elseif(npes > 9999)then
       write(out_unit,*) "Maximum of 9999 ranks supported. Not testing gatherV; too many ranks."
       return
     endif
     write(out_unit,*)

     ssize = pe+1
     allocate(sdata(ssize))
     do i=1,ssize
       sdata(i) = pe + 0.0001*i
     enddo
     do i=1,npes
       pelist(i) = i-1
       rsize(i) = i
     enddo

     dsize = sum(rsize)
     allocate(rdata(dsize),ref(dsize))
     rdata = -1.0
     k=1
     do j=1,npes
       do i=1,rsize(j)
          ref(k) = pelist(j) + 0.0001*i
          k = k+1
     enddo;enddo

     call mpp_gather(sdata,ssize,rdata,rsize)
 
     if(pe == root)then
       k = 1
       do j=1,npes
         do i=1,rsize(j)
           if(rdata(k) /= ref(k))then
              write(6,*) "Gathered data ",rdata(k), " NE reference ",ref(k), "at k=",k
              call mpp_error(FATAL, "Test gatherV global pelist failed")
           endif
           k = k+1
       enddo;enddo
     endif

     call mpp_sync()
     write(out_unit,*) "Test gatherV with global pelist successful"

     rdata = -1.0
     ref(1) = -1.0

     if(ANY(pe == pelist(2:npes)))call mpp_gather(sdata,ssize,rdata(2:),rsize(2:),pelist(2:npes))

     if(pe == pelist(2))then
       k = 1
       do j=1,npes
         do i=1,rsize(j)
           if(rdata(k) /= ref(k))then
              write(6,*) "Gathered data ",rdata(k), " NE reference ",ref(k), "at k=",k
              call mpp_error(FATAL, "Test gatherV with reduced pelist failed")
           endif
           k = k+1
       enddo;enddo
     endif
     call mpp_sync()

     write(out_unit,*) "Test gatherV with reduced pelist successful"
     deallocate(sdata,rdata,ref)
  end subroutine test_gatherV

subroutine test_gather2DV(npes,pe,root,out_unit)
  implicit none
     integer, intent(in) :: npes,pe,root,out_unit

     integer :: pelist(npes),rsize(npes)
     integer :: pelist2(npes),rsize2(npes)
     integer :: i,j,k,l,nz,ssize,nelems
     real,allocatable,dimension(:,:) :: data, cdata, sbuff,rbuff
     real,allocatable :: ref(:,:)
     integer, parameter :: KSIZE=10

     real :: sbuff1D(size(sbuff))
     real :: rbuff1D(size(rbuff))
     pointer(sptr,sbuff1D); pointer(rptr,rbuff1D)


     if(npes < 3)then
       write(out_unit,*) "Minimum of 3 ranks required. Not testing gather2DV; too few ranks."
       return
     elseif(npes > 9999)then
       write(out_unit,*) "Maximum of 9999 ranks supported. Not testing gather2DV; too many ranks."
       return
     endif
     write(out_unit,*)

     ssize = pe+1
     allocate(data(ssize,KSIZE))
     do k=1,KSIZE; do i=1,ssize
       data(i,k) = 10000.0*k + pe + 0.0001*i
     enddo; enddo
     do i=1,npes
       pelist(i) = i-1
       rsize(i) = i
     enddo

     nz = KSIZE
     nelems = sum(rsize(:))

     allocate(rbuff(nz,nelems)); rbuff = -1.0
     allocate(ref(nelems,nz),cdata(nelems,nz))
     ref = 0.0; cdata = 0.0
     if(pe == root)then
       do k=1,KSIZE
       l=1
       do j=1,npes
         do i=1,rsize(j)
            ref(l,k) = 10000.0*k + pelist(j) + 0.0001*i
            l = l+1
       enddo; enddo;enddo
     endif
     allocate(sbuff(nz,ssize))
     ! this matrix inversion makes for easy gather to the IO root
     ! and a clear, concise unpack
     do j=1,ssize
       do i=1,nz
         sbuff(i,j) = data(j,i)
     enddo; enddo

  !  Note that the gatherV implied here is asymmetric; only root needs to know the vector of recv size
     sptr = LOC(sbuff); rptr = LOC(rbuff)
     call mpp_gather(sbuff1D,size(sbuff),rbuff1D,nz*rsize(:))

     if(pe == root)then
        do j=1,nz
           do i=1,nelems
             cdata(i,j) = rbuff(j,i)
        enddo; enddo
        do j=1,nz
           do i=1,nelems
            if(cdata(i,j) /= ref(i,j))then
               write(6,*) "Gathered data ",cdata(i,j), " NE reference ",ref(i,j), "at i,j=",i,j
               call mpp_error(FATAL, "Test gather2DV global pelist failed")
            endif
       enddo;enddo
     endif

     call mpp_sync()
     write(out_unit,*) "Test gather2DV with global pelist successful"

     do i=1,npes
       pelist2(i) = pelist(npes-i+1) 
       rsize2(i) = rsize(npes-i+1)
     enddo

     rbuff = -1.0
     ref = 0.0; cdata = 0.0
     if(pe == pelist2(1))then
       do k=1,KSIZE
       l=1
       do j=1,npes
         do i=1,rsize2(j)
            ref(l,k) = 10000.0*k + pelist2(j) + 0.0001*i
            l = l+1
       enddo; enddo;enddo
     endif

     call mpp_gather(sbuff1D,size(sbuff),rbuff1D,nz*rsize2(:),pelist2)

     if(pe == pelist2(1))then
        do j=1,nz
           do i=1,nelems
             cdata(i,j) = rbuff(j,i)
        enddo; enddo
        do j=1,nz
           do i=1,nelems
            if(cdata(i,j) /= ref(i,j))then
               write(6,*) "Gathered data ",cdata(i,j), " NE reference ",ref(i,j), "at i,j=",i,j
               call mpp_error(FATAL, "Test gather2DV with reversed pelist failed")
            endif
       enddo;enddo
     endif
     call mpp_sync()
     write(out_unit,*) "Test gather2DV with reversed pelist successful"
     deallocate(data,sbuff,rbuff,cdata,ref)
  end subroutine test_gather2DV

  subroutine test_shared_pointers(locd,n)
    integer(LONG_KIND), intent(in) :: locd
    integer :: n
    real :: dd(n)
    pointer( p, dd )

    p = locd
    print *, 'TEST_SHARED_POINTERS: pe, locd=', pe, locd
!    print *, 'TEST_SHARED_POINTERS: pe, chksum(d)=', pe, mpp_chksum(dd,(/pe/))
    print *, 'TEST_SHARED_POINTERS: pe, sum(d)=', pe, sum(dd)
    return
  end subroutine test_shared_pointers
end program test

#else
module null_mpp_test
end module  

#endif /* test_mpp */

                  module physics_driver_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="">
! </REVIEWER>
! <OVERVIEW>
!     Provides high level interfaces for calling the entire
!     FMS atmospheric physics package.
!
!    physics_driver_mod accesses the model's physics modules and
!    obtains tendencies and boundary fluxes due to the physical
!    processes that drive atmospheric time tendencies and supply 
!    boundary forcing to the surface models.
! </OVERVIEW>
! <DESCRIPTION>
!     This version of physics_driver_mod has been designed around the implicit
!     version diffusion scheme of the GCM. It requires two routines to advance
!     the model one time step into the future. These two routines
!     correspond to the down and up sweeps of the standard tridiagonal solver.
!     Radiation, Rayleigh damping, gravity wave drag, vertical diffusion of
!     momentum and tracers, and the downward pass of vertical diffusion for
!     temperature and specific humidity are performed in the down routine.
!     The up routine finishes the vertical diffusion and computes moisture
!     related terms (convection,large-scale condensation, and precipitation).
! </DESCRIPTION>
! <DIAGFIELDS>
! </DIAGFIELDS>
! <DATASET NAME="physics_driver.res">
! native format restart file
! </DATASET>
!
! <DATASET NAME="physics_driver.res.nc">
! netcdf format restart file
! </DATASET>


! <INFO>

!   <REFERENCE>            </REFERENCE>
!   <COMPILER NAME="">     </COMPILER>
!   <PRECOMP FLAG="">      </PRECOMP>
!   <LOADER FLAG="">       </LOADER>
!   <TESTPROGRAM NAME="">  </TESTPROGRAM>
!   <BUG>                  </BUG>
!   <NOTE> 
!   </NOTE>
!   <FUTURE> Deal with conservation of total energy?              </FUTURE>

! </INFO>
!   shared modules:

use time_manager_mod,        only: time_type, get_time, operator (-), &
                                   time_manager_init
use field_manager_mod,       only: field_manager_init, MODEL_ATMOS
use tracer_manager_mod,      only: tracer_manager_init, &
                                   get_number_tracers, &
                                   get_tracer_names

use atmos_tracer_driver_mod, only: atmos_tracer_driver_init,    &
                                   atmos_tracer_driver_time_vary, &
                                   atmos_tracer_driver_endts, &
                                   atmos_tracer_driver,  &
                                   atmos_tracer_driver_end
use mpp_mod,                 only: input_nml_file
use fms_mod,                 only: mpp_clock_id, mpp_clock_begin,   &
                                   mpp_clock_end, CLOCK_MODULE_DRIVER, &
                                   fms_init,  &
                                   open_namelist_file, stdlog, stdout,  &
                                   write_version_number, field_size, &
                                   file_exist, error_mesg, FATAL,   &
                                   WARNING, NOTE, check_nml_error, &
                                   close_file, mpp_pe, mpp_root_pe, &
                                   mpp_error, mpp_chksum
use fms_io_mod,              only: restore_state, &
                                   register_restart_field, restart_file_type, &
                                   save_restart, get_mosaic_tile_file
use constants_mod,           only: RDGAS

use diag_manager_mod,        only: register_diag_field, send_data

!    shared radiation package modules:

use rad_utilities_mod,       only: aerosol_type, radiative_gases_type, &
                                   rad_utilities_init, rad_output_type,&
                                   cld_specification_type,   &
                                   surface_type, &
                                   atmos_input_type, microphysics_type

!    component modules:

use cosp_driver_mod,         only: cosp_driver_init, cosp_driver, &
                                   cosp_driver_end, cosp_driver_time_vary,&
                                   cosp_driver_endts
use  moist_processes_mod,    only: moist_processes,    &
                                   moist_processes_init,  &
                                   set_cosp_precip_sources, &
                                   moist_processes_time_vary, &
                                   moist_processes_endts, &
                                   moist_processes_end,  &
                                   moist_alloc_init, &
                                   moist_alloc_end, &
                                   doing_strat!,          &
!                                   moist_processes_restart
use moistproc_kernels_mod,   only:  moistproc_init, moistproc_end

use vert_turb_driver_mod,    only: vert_turb_driver,  &
                                   vert_turb_driver_init,  &
                                   vert_turb_driver_end, &
                                   vert_turb_driver_restart

use vert_diff_driver_mod,    only: vert_diff_driver_down,  &
                                   vert_diff_driver_up,    &
                                   vert_diff_driver_init,  &
                                   vert_diff_driver_end,   &
                                   surf_diff_type

use radiation_driver_mod,    only: radiation_driver_init,    &
                                   define_rad_times, define_surface,   &
                                   define_atmos_input_fields, &
                                   radiation_driver_time_vary, &
                                   radiation_driver_endts, &
                                   radiation_driver,  &
                                   return_cosp_inputs, &
                                   atmos_input_dealloc,    &
                                   microphys_dealloc, &
                                   surface_dealloc, &
                                   radiation_driver_end, &
                                   radiation_driver_restart
  
use cloud_spec_mod,          only: cloud_spec_init, cloud_spec, &
                                   cloud_spec_dealloc, cloud_spec_end

use aerosol_mod,             only: aerosol_init, aerosol_driver, &
                                   aerosol_time_vary, &
                                   aerosol_endts, &
                                   aerosol_dealloc, aerosol_end
 
use radiative_gases_mod,     only: radiative_gases_init,   &
                                   radiative_gases_time_vary, &
                                   radiative_gases_endts, &
                                   define_radiative_gases, &
                                   radiative_gases_dealloc, &
                                   radiative_gases_end,     &
                                   radiative_gases_restart

use damping_driver_mod,      only: damping_driver,      &
                                   damping_driver_init, &
                                   damping_driver_time_vary,  &
                                   damping_driver_endts, &
                                   damping_driver_end,  &
                                   damping_driver_restart

use grey_radiation_mod,       only: grey_radiation_init, grey_radiation, &
                                    grey_radiation_end

!--> h1g, cjg
use clubb_driver_mod,         only: clubb_init, clubb, clubb_end
!<-- h1g, cjg

#ifdef SCM
! Option to add SCM radiative tendencies from forcing to lw_tendency
! and radturbten

use scm_forc_mod,            only: use_scm_rad, add_scm_tdtlw, add_scm_tdtsw

#endif

!-----------------------------------------------------------------

implicit none
private

!---------------------------------------------------------------------
!    physics_driver_mod accesses the model's physics modules and
!    obtains tendencies and boundary fluxes due to the physical
!    processes that drive atmospheric time tendencies and supply 
!    boundary forcing to the surface models.
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!----------- version number for this module -------------------

character(len=128) :: version = '$Id: physics_driver.F90,v 20.0 2013/12/13 23:18:40 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'


!---------------------------------------------------------------------
!-------  interfaces --------

public  physics_driver_init, physics_driver_down,   &
        physics_driver_down_time_vary, physics_driver_up_time_vary, &
        physics_driver_down_endts, physics_driver_up_endts, &
        physics_driver_moist_init, physics_driver_moist_end, &
        physics_driver_up, physics_driver_end, &
        do_moist_in_phys_up, get_diff_t, &
        get_radturbten, zero_radturbten, physics_driver_restart

private          &

!  called from physics_driver_down:
         check_args, &

!  called from check_args:
         check_dim

interface check_dim
     module procedure check_dim_2d, check_dim_3d, check_dim_4d
end interface


!---------------------------------------------------------------------
!------- namelist ------

logical :: do_moist_processes = .true.
                               ! call moist_processes routines
real    :: tau_diff = 3600.    ! time scale for smoothing diffusion 
                               ! coefficients
integer :: do_clubb = 0        ! activate clubb parameterization ?
logical :: do_cosp = .false.   ! activate COSP simulator ?
logical :: do_modis_yim = .true. ! activate simple modis simulator ?
logical :: do_radiation = .true.
                               ! calculating radiative fluxes and
                               ! heating rates?
logical :: do_grey_radiation = .false. ! do grey radiation scheme?
real    :: R1 = 0.25           ! rif:(09/10/09) In Grey radiation we are computing just the total   
real    :: R2 = 0.25           ! SW radiation. We need to divide it into 4 components
real    :: R3 = 0.25           ! to go through the Coupler and Ice modules.
real    :: R4 = 0.25           ! 	Sum[R(i)*SW] = SW  


real    :: diff_min = 1.e-3    ! minimum value of a diffusion 
                               ! coefficient beneath which the
                               ! coefficient is reset to zero
logical :: diffusion_smooth = .true.
                               ! diffusion coefficients should be 
                               ! smoothed in time?
logical :: use_cloud_tracers_in_radiation = .true.
                               ! if true, use lsc cloud tracer fields
                               ! in radiation (these transported on
                               ! current step, will have non-realizable
                               ! total cloud areas at some points); if
                               ! false, then use balanced (realizable)
                               ! fields saved at end of last step
                               ! only an issue when both lsc and conv
                               ! clouds are active (AM3)
logical :: donner_meso_is_largescale = .true.
                               ! donner meso clouds are treated as 
                               ! largescale (rather than convective)
                               ! as far as the COSP simulator is 
                               ! concerned ?
logical :: allow_cosp_precip_wo_clouds = .true.
                               ! COSP will see {ls, cv} precip in grid-
                               ! boxes w/o {ls, cv} clouds ?
logical :: override_aerosols_radiation = .false.
                               ! use offline aerosols for radiation 
                               ! calculation
                               ! (via data_override in aerosol_driver)?
logical :: override_aerosols_cloud = .false.
                               ! use offline aerosols for cloud calculation
                               ! (via data_override in aerosol_driver)?
character(len=16) :: cosp_precip_sources = '    '
                               ! sources of the precip fields to be sent to
                               ! COSP. Default = '  ' implies precip from
                               ! the radiatively-active clouds defined by
                               ! variable cloud_type_form in cloud_spec_nml
                               ! will be sent. Other available choices:
                               ! 'strat', 'deep', 'uw', 'stratdeep',
                               ! 'stratuw', deepuw', 'stratdeepuw', 
                               ! 'noprecip'. 
                               ! CURRENTLY NOT AVAILABLE: precip from ras,
                               ! lsc and mca. For completeness, these could
                               ! be made available, but since no cloud 
                               ! fields are saved for these schemes to be
                               ! made available to COSP, they are also
                               ! currently not considered as precip
                               ! sources.

! <NAMELIST NAME="physics_driver_nml">
!  <DATA NAME="do_radiation" UNITS="" TYPE="logical" DIM="" DEFAULT=".true.">
!calculating radiative fluxes and
! heating rates?
!  </DATA>
!  <DATA NAME="do_moist_processes" UNITS="" TYPE="logical" DIM="" DEFAULT=".true.">
!call moist_processes routines
!  </DATA>
!  <DATA NAME="tau_diff" UNITS="" TYPE="real" DIM="" DEFAULT="3600.">
!time scale for smoothing diffusion 
! coefficients
!  </DATA>
!  <DATA NAME="diff_min" UNITS="" TYPE="real" DIM="" DEFAULT="1.e-3">
!minimum value of a diffusion 
! coefficient beneath which the
! coefficient is reset to zero
!  </DATA>
!  <DATA NAME="diffusion_smooth" UNITS="" TYPE="logical" DIM="" DEFAULT=".true.">
!diffusion coefficients should be 
! smoothed in time?
!  </DATA>
! <DATA NAME="override_aerosols_radiation" UNITS="" TYPE="logical" DIM=""  DEFAULT=".false.">
!use offline aerosols for radiation calculation
! (via data_override in aerosol_driver)?
!  </DATA>
!  <DATA NAME="override_aerosols_cloud" UNITS="" TYPE="logical" DIM="" DEFAULT=".false.">
!use offline aerosols for cloud calculation
! (via data_override in aerosol_driver)?
!  </DATA>
! </NAMELIST>
!

! ---> h1g, 2012-08-28, add option of applying surface fluxes in host-model
!                       by default .true. (that is, applying surface fluxes in host-model)
logical :: l_host_applies_sfc_fluxes = .true.
! <--- h1g, 2012-08-28

namelist / physics_driver_nml / do_radiation, &
                                do_clubb,  &  ! cjg, h1g
                                do_cosp, &
                                do_modis_yim, &
                                donner_meso_is_largescale, &
                                allow_cosp_precip_wo_clouds, &
                                do_moist_processes, tau_diff,      &
                                diff_min, diffusion_smooth, &
                                use_cloud_tracers_in_radiation, &
                                do_grey_radiation, R1, R2, R3, R4,  &
                                override_aerosols_radiation,  &
                                override_aerosols_cloud,    &
                                cosp_precip_sources,    &
                                l_host_applies_sfc_fluxes

!---------------------------------------------------------------------
!------- public data ------
! <DATA NAME="surf_diff_type" UNITS="" TYPE="surf_diff_type" DIM="" DEFAULT="">
! Defined in vert_diff_driver_mod, republished here. See vert_diff_mod for details.
! </DATA>

public  surf_diff_type   ! defined in  vert_diff_driver_mod, republished
                         ! here
 
!---------------------------------------------------------------------
!------- private data ------

!--------------------------------------------------------------------
! list of restart versions readable by this module:
!
! version 1: initial implementation 1/2003, contains diffusion coef-
!            ficient contribution from cu_mo_trans_mod. This variable
!            is generated in physics_driver_up (moist_processes) and
!            used on the next step in vert_diff_down, necessitating
!            its storage.
!
! version 2: adds pbltop as generated in vert_turb_driver_mod. This 
!            variable is then used on the next timestep by topo_drag
!            (called from damping_driver_mod), necessitating its 
!            storage.
!
! version 3: adds the diffusion coefficients which are passed to 
!            vert_diff_driver.  These diffusion are saved should
!            smoothing of vertical diffusion coefficients be turned
!            on.
!
! version 4: adds a logical variable, convect, which indicates whether
!            or not the grid column is convecting. This diagnostic is
!            needed by the entrain_module in vert_turb_driver.
!
! version 5: adds radturbten when strat_cloud_mod is active, adds 
!            lw_tendency when edt_mod or entrain_mod is active.
!
! version 6: adds donner cell and meso cloud variables when donner_deep
!            is activated.

! version 7: adds shallow convection cloud variables when uw_conv
!            is activated.

! version 8: adds lsc cloud props for radiation. only readable when in
!            netcdf mode.


!---------------------------------------------------------------------
integer, dimension(8) :: restart_versions = (/ 1, 2, 3, 4, 5, 6, 7, 8 /)

!--------------------------------------------------------------------
!    the following allocatable arrays are either used to hold physics 
!    data between timesteps when required, or hold physics data between
!    physics_down and physics_up.
!  
!    diff_cu_mo     contains contribution to difusion coefficient
!                   coming from cu_mo_trans_mod (called from 
!                   moist_processes in physics_driver_up) and then used 
!                   as input on the next time step to vert_diff_down 
!                   called in physics_driver_down.
!    diff_t         vertical diffusion coefficient for temperature
!                   which optionally may be time smoothed, meaning
!                   values must be saved between steps
!    diff_m         vertical diffusion coefficient for momentum
!                   which optionally may be time smoothed, meaning
!                   values must be saved between steps
!    radturbten     the sum of the radiational and turbulent heating,
!                   generated in both physics_driver_down (radiation)
!                   and physics_driver_up (turbulence) and then used
!                   in moist_processes
!    lw_tendency    longwave heating rate, generated in radiation and
!                   needed in vert_turb_driver when either edt_mod
!                   or entrain_mod is active. must be saved because
!                   radiation is not calculated on each step.
!    pbltop         top of boundary layer obtained from vert_turb_driver
!                   and then used on the next timestep in topo_drag_mod
!                   called from damping_driver_down        
!    convect        flag indicating whether convection is occurring in
!                   a grid column. generated in physics_driver_up and
!                   then used in vert_turb_driver called from 
!                   physics_driver_down on the next step.
!----------------------------------------------------------------------
real,    dimension(:,:,:), allocatable :: diff_cu_mo, diff_t, diff_m
real,    dimension(:,:,:), allocatable :: radturbten, lw_tendency
real,    dimension(:,:)  , allocatable :: pbltop, cush, cbmf
logical, dimension(:,:)  , allocatable :: convect
real,    dimension(:,:,:), allocatable ::       &
                           cell_cld_frac, cell_liq_amt, &
                           cell_liq_size, cell_ice_amt, cell_ice_size, &
                           cell_droplet_number, &
                           meso_cld_frac, meso_liq_amt, meso_liq_size, &
                           meso_ice_amt, meso_ice_size, &
                           meso_droplet_number, &
                           lsc_cloud_area, lsc_liquid, &
                           lsc_ice, lsc_droplet_number, &
                           lsc_ice_number, &
             !snow, rain in radiation
                           lsc_rain, lsc_snow,              &
                           lsc_rain_size, lsc_snow_size,              &
                           shallow_cloud_area, shallow_liquid, &
                           shallow_ice, shallow_droplet_number, &
!cms++ not yet activated, but may be needed ...
                           shallow_ice_number, &
!cms--
                           temp_last, q_last
real,    dimension(:,:,:,:), allocatable ::  tau_stoch, lwem_stoch, &
                           stoch_cloud_type, stoch_conc_drop, &
                           stoch_conc_ice, stoch_size_drop, &
                           stoch_size_ice
real,    dimension(:,:,:), allocatable ::  fl_lsrain, fl_lssnow, &
                                           fl_lsgrpl, &
                                           fl_donmca_rain, fl_donmca_snow,&
                                           fl_ccrain, fl_ccsnow, &
                                           mr_ozone
real,       dimension(:,:), allocatable  :: daytime
integer,    dimension(:,:)  , allocatable :: nsum_out
real   ,    dimension(:,:)  , allocatable :: tsurf_save

! --->h1g
real,    dimension(:,:,:), allocatable ::  dcond_ls_liquid, dcond_ls_ice
real,    dimension(:,:,:), allocatable ::  Ndrop_act_CLUBB,  Icedrop_act_CLUBB
real,    dimension(:,:,:), allocatable ::  ndust, rbar_dust
real,    dimension(:,:,:), allocatable ::  diff_t_clubb
! <---h1g
   
!--- for netcdf restart
type(restart_file_type), pointer, save :: Phy_restart => NULL()
type(restart_file_type), pointer, save :: Til_restart => NULL()
logical                                :: in_different_file = .false.
integer                                :: vers
integer                                :: now_doing_strat  
integer                                :: now_doing_entrain
integer                                :: now_doing_edt
real, allocatable                      :: r_convect(:,:)

!---------------------------------------------------------------------
!    internal timing clock variables:
!---------------------------------------------------------------------
integer :: radiation_clock, damping_clock, turb_clock,   &
           tracer_clock, diff_up_clock, diff_down_clock, &
           moist_processes_clock, cosp_clock

!--------------------------------------------------------------------
!    miscellaneous control variables:
!---------------------------------------------------------------------
logical   :: do_check_args = .true.   ! argument dimensions should 
                                      ! be checked ?
logical   :: module_is_initialized = .false.
                                      ! module has been initialized ?
logical   :: doing_edt                ! edt_mod has been activated ?
logical   :: doing_entrain            ! entrain_mod has been activated ?
logical   :: doing_donner             ! donner_deep_mod has been 
                                      ! activated ?
logical   :: doing_uw_conv            ! uw_conv shallow cu mod has been 
                                      ! activated ?
logical   :: doing_liq_num = .false.  ! Prognostic cloud droplet number has 
                                      ! been activated?
integer   :: nt                       ! total no. of tracers
integer   :: ntp                      ! total no. of prognostic tracers
integer   :: ncol                     ! number of stochastic columns
 
type(radiative_gases_type), save   :: Rad_gases_tv
type(time_type)  :: Rad_time
logical          ::    need_aerosols, need_clouds, need_gases,   &
                       need_basic
logical    :: do_strat
integer   :: num_uw_tracers


!---------------------------------------------------------------------
!---------------------------------------------------------------------

character(len=4)     :: mod_name = 'phys'
character(len=32)    :: tracer_units, tracer_name
  character(len=128) :: diaglname
real                 :: missing_value = -999.
logical              :: step_to_call_cosp = .false.
logical              :: include_donmca_in_cosp

!integer                            :: id_tdt_phys, id_qdt_phys, &   ! cjg
integer                            :: id_tdt_phys,         &
                                      id_tdt_phys_vdif_dn, &
                                      id_tdt_phys_vdif_up, &
                                      id_tdt_phys_turb,    &
                                      id_tdt_phys_moist

integer, dimension(:), allocatable :: id_tracer_phys,         &  ! cjg
                                      id_tracer_phys_vdif_dn, &
                                      id_tracer_phys_vdif_up, &
                                      id_tracer_phys_turb,    &
                                      id_tracer_phys_moist


                            contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!#####################################################################
! <SUBROUTINE NAME="physics_driver_init">
!  <OVERVIEW>
!    physics_driver_init is the constructor for physics_driver_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    physics_driver_init is the constructor for physics_driver_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call physics_driver_init (Time, lonb, latb, axes, pref, &
!                             trs, Surf_diff, phalf, mask, kbot  )
!  </TEMPLATE>
!  <IN NAME="Time" TYPE="time_type">
!   current time
!  </IN>
!  <IN NAME="pref" TYPE="real">
!   reference prssure profiles
!  </IN>
!  <IN NAME="latb" TYPE="real">
!   array of model latitudes at cell corners [radians]
!  </IN>
!  <IN NAME="lonb" TYPE="real">
!   array of model longitudes at cell corners [radians]
!  </IN>
!  <IN NAME="axes" TYPE="integer">
!   axis indices, (/x,y,pf,ph/)
!                (returned from diag axis manager)
!  </IN>
!  <INOUT NAME="trs" TYPE="real">
!   atmospheric tracer fields
!  </INOUT>
!  <INOUT NAME="Surf_diff" TYPE="surf_diff_type">
!   surface diffusion derived type
!  </INOUT>
!  <IN NAME="phalf" TYPE="real">
!   pressure at model interface levels
!  </IN>
!  <IN NAME="kbot" TYPE="integer">
!   OPTIONAL: present when running eta vertical coordinate,
!                        index of lowest model level above ground
!  </IN>
!  <IN NAME="mask" TYPE="real">
!   OPTIONAL: present when running eta vertical coordinate,
!                        mask to remove points below ground
!  </IN>
! <ERROR MSG="physics_driver_init must be called first" STATUS="FATAL">
! </ERROR>
! </SUBROUTINE>
!
!-->cjg
!subroutine physics_driver_init (Time, lonb, latb, axes, pref, &
subroutine physics_driver_init (Time, lonb, latb, lon, lat, axes, pref, &
                                trs, Surf_diff, phalf, mask, kbot, &
                                diffm, difft  )
!<--cjg
!---------------------------------------------------------------------
!    physics_driver_init is the constructor for physics_driver_mod.
!---------------------------------------------------------------------

type(time_type),         intent(in)              :: Time
real,dimension(:,:),     intent(in)              :: lonb, latb
real,dimension(:,:),     intent(in)              :: lon, lat    ! cjg
integer,dimension(4),    intent(in)              :: axes
real,dimension(:,:),     intent(in)              :: pref
real,dimension(:,:,:,:), intent(inout)           :: trs
type(surf_diff_type),    intent(inout)           :: Surf_diff
real,dimension(:,:,:),   intent(in)              :: phalf
real,dimension(:,:,:),   intent(in),   optional  :: mask
integer,dimension(:,:),  intent(in),   optional  :: kbot
real, dimension(:,:,:),  intent(out),  optional  :: diffm, difft

!---------------------------------------------------------------------
!  intent(in) variables:
!
!     Time       current time (time_type)
!     lonb       longitude of the grid box corners [ radians ]
!     latb       latitude of the grid box corners [ radians ]
!     axes       axis indices, (/x,y,pf,ph/)
!                (returned from diag axis manager)
!     pref       two reference profiles of pressure at nlev+1 levels
!                pref(nlev+1,1)=101325. and pref(nlev+1,2)=81060.
!     phalf      pressure at model interface levels
!                [ Pa ]
!
!   intent(inout) variables:
!
!     trs        atmosperic tracer fields
!     Surf_diff  surface diffusion derived type variable
!
!   intent(in), optional variables:
!
!        mask    present when running eta vertical coordinate,
!                mask to remove points below ground
!        kbot    present when running eta vertical coordinate,
!                index of lowest model level above ground
!   
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables:

      real, dimension (size(lonb,1)-1, size(latb,2)-1) :: sgsmtn
      character(len=64), dimension(:), pointer :: aerosol_names => NULL()
      character(len=64), dimension(:), pointer :: aerosol_family_names => NULL()
      integer          ::  id, jd, kd, n
      integer          ::  ierr, io, unit, logunit, outunit
      integer          ::  ndum
      character(len=16)::  cloud_type_form_out  ! indicator of radiatively 
                                                ! active clouds
      character(len=16)::  cosp_precip_sources_modified

      integer          ::  moist_processes_init_clock, damping_init_clock, &
                           turb_init_clock, diff_init_clock, &
                           cloud_spec_init_clock, aerosol_init_clock, &
                           grey_radiation_init_clock , radiative_gases_init_clock, &
                           radiation_init_clock, tracer_init_clock, &
                           cosp_init_clock

!---------------------------------------------------------------------
!  local variables:
!
!       sgsmtn        sgs orography obtained from mg_drag_mod;
!                     appears to not be currently used
!       aerosol_names names associated with the activated aerosols
!                     that will be seen by the radiation package
!       aerosol_family_names
!              names associated with the activated aerosol
!              families that will be seen by the radiation package
!       id,jd,kd      model dimensions on the processor  
!       ierr          error code
!       io            io status returned from an io call
!       unit          unit number used for an i/ operation

!---------------------------------------------------------------------
!    if routine has already been executed, return.
!---------------------------------------------------------------------
      if (module_is_initialized) return

!---------------------------------------------------------------------
!    verify that the modules used by this module that are not called 
!    later in this subroutine have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call rad_utilities_init
      call time_manager_init
      call tracer_manager_init
      call field_manager_init (ndum)
 
!--------------------------------------------------------------------
!    read namelist.
!--------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=physics_driver_nml, iostat=io)
      ierr = check_nml_error(io,"physics_driver_nml")
#else
      if ( file_exist('input.nml')) then
        unit = open_namelist_file ()
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=physics_driver_nml, iostat=io, end=10)
        ierr = check_nml_error(io, 'physics_driver_nml')
        enddo
10      call close_file (unit)
      endif
#endif

      if(do_radiation .and. do_grey_radiation) & 
        call error_mesg('physics_driver_init','do_radiation and do_grey_radiation cannot both be .true.',FATAL)

!--------------------------------------------------------------------
!    write version number and namelist to log file.
!--------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
               write(logunit, nml=physics_driver_nml)
 
!---------------------------------------------------------------------
!    define the model dimensions on the local processor.
!---------------------------------------------------------------------
      id = size(lonb,1)-1 
      jd = size(latb,2)-1 
      kd = size(trs,3)
      call get_number_tracers (MODEL_ATMOS, num_tracers=nt, &
                               num_prog=ntp)

!---------------------------------------------------------------------
      radiation_clock       =       &
                mpp_clock_id( '   Physics_down: Radiation',    &
                   grain=CLOCK_MODULE_DRIVER )
      cosp_clock       =       &
                mpp_clock_id( '   Physics_down: COSP',    &
                   grain=CLOCK_MODULE_DRIVER )
      damping_clock         =     &
                mpp_clock_id( '   Physics_down: Damping',    &
                  grain=CLOCK_MODULE_DRIVER )
      turb_clock            =      &
                mpp_clock_id( '   Physics_down: Vert. Turb.', &
                  grain=CLOCK_MODULE_DRIVER )
      tracer_clock          =      &
                mpp_clock_id( '   Physics_down: Tracer',    &
                 grain=CLOCK_MODULE_DRIVER )
      diff_down_clock       =     &
                mpp_clock_id( '   Physics_down: Vert. Diff.',   &
                 grain=CLOCK_MODULE_DRIVER )
      diff_up_clock         =     &
                mpp_clock_id( '   Physics_up: Vert. Diff.',     &
                grain=CLOCK_MODULE_DRIVER )
      moist_processes_clock =      &
                mpp_clock_id( '   Physics_up: Moist Processes', &
                grain=CLOCK_MODULE_DRIVER )

      moist_processes_init_clock =      &
        mpp_clock_id( '   Physics_driver_init: Moist Processes: Initialization', &
                grain=CLOCK_MODULE_DRIVER )
      damping_init_clock         =     &
        mpp_clock_id( '   Physics_driver_init: Damping: Initialization',    &
                  grain=CLOCK_MODULE_DRIVER )
      turb_init_clock            =      &
        mpp_clock_id( '   Physics_driver_init: Vert. Turb.: Initialization', &
                  grain=CLOCK_MODULE_DRIVER )
      diff_init_clock       =     &
        mpp_clock_id( '   Physics_driver_init: Vert. Diff.: Initialization',   &
                 grain=CLOCK_MODULE_DRIVER )
      cloud_spec_init_clock       =       &
        mpp_clock_id( '   Physics_driver_init: Cloud spec: Initialization', &
                       grain=CLOCK_MODULE_DRIVER )
      cosp_init_clock       =       &
        mpp_clock_id( '   Physics_driver_init: COSP: Initialization', &
                       grain=CLOCK_MODULE_DRIVER )
      aerosol_init_clock       =       &
        mpp_clock_id( '   Physics_driver_init: Aerosol: Initialization', &
                       grain=CLOCK_MODULE_DRIVER )
      grey_radiation_init_clock       =       &
        mpp_clock_id( '   Physics_driver_init: Grey Radiation: Initialization', &
                       grain=CLOCK_MODULE_DRIVER )
      radiative_gases_init_clock       =       &
        mpp_clock_id( '   Physics_driver_init: Radiative gases: Initialization', &
                       grain=CLOCK_MODULE_DRIVER )
      radiation_init_clock       =       &
        mpp_clock_id( '   Physics_driver_init: Radiation: Initialization', &
                       grain=CLOCK_MODULE_DRIVER )
      tracer_init_clock          =      &
        mpp_clock_id( '   Physics_driver_init: Tracer: Initialization',    &
                 grain=CLOCK_MODULE_DRIVER )

!-----------------------------------------------------------------------
      call mpp_clock_begin ( moist_processes_init_clock )

!---> h1g
!      call  moist_processes_init (id, jd, kd, lonb, latb, pref(:,1),&
      call  moist_processes_init (id, jd, kd, lonb, latb, lon, lat, phalf, pref(:,1),&
                                  axes, Time, doing_donner,  &
                                  doing_uw_conv,  &
                                  num_uw_tracers, do_strat, &
                                  do_clubb_in=do_clubb,               &! cjg
                                  do_cosp_in=do_cosp, &
                                  donner_meso_is_largescale_in= &
                                          donner_meso_is_largescale, &
                                  include_donmca_in_cosp_out = &
                                          include_donmca_in_cosp)
!<--- h1g

      call mpp_clock_end ( moist_processes_init_clock )
     
!-----------------------------------------------------------------------
!    initialize damping_driver_mod.
!-----------------------------------------------------------------------
      call mpp_clock_begin ( damping_init_clock )
      call damping_driver_init (lonb, latb, pref(:,1), axes, Time, &
                                sgsmtn)
      call mpp_clock_end ( damping_init_clock )

!-----------------------------------------------------------------------
!    initialize vert_turb_driver_mod.
!-----------------------------------------------------------------------
      call mpp_clock_begin ( turb_init_clock )
      call vert_turb_driver_init (lonb, latb, id, jd, kd, axes, Time, &
                                  doing_edt, doing_entrain, do_clubb)
      call mpp_clock_end ( turb_init_clock )

!-----------------------------------------------------------------------
!    initialize vert_diff_driver_mod.
!-----------------------------------------------------------------------
      call mpp_clock_begin ( diff_init_clock )
!-->cjg
!     call vert_diff_driver_init (Surf_diff, id, jd, kd, axes, Time )
      call vert_diff_driver_init (Surf_diff, id, jd, kd, axes, Time, do_clubb )
!<--cjg
      call mpp_clock_end ( diff_init_clock )

      if (do_radiation) then
!-----------------------------------------------------------------------
!    initialize cloud_spec_mod.
!-----------------------------------------------------------------------
        call mpp_clock_begin ( cloud_spec_init_clock )
        call cloud_spec_init (pref, lonb, latb, axes, Time,   &
                              cloud_type_form_out)
        if (trim(cosp_precip_sources) == '  ') then
          cosp_precip_sources_modified = cloud_type_form_out
        else
          cosp_precip_sources_modified = cosp_precip_sources
          if (trim(cloud_type_form_out) /= trim(cosp_precip_sources))   &
               call error_mesg ('physics_driver_init',  &
               'cloud_type_form does not match cosp_precip_sources', NOTE)
        endif
        call mpp_clock_end ( cloud_spec_init_clock )
 
!-----------------------------------------------------------------------
!    initialize aerosol_mod.     
!-----------------------------------------------------------------------
        call mpp_clock_begin ( aerosol_init_clock )
        call aerosol_init (lonb, latb, aerosol_names, aerosol_family_names)
        call mpp_clock_end ( aerosol_init_clock )
!-----------------------------------------------------------------------
!    initialize radiative_gases_mod.
!-----------------------------------------------------------------------
        call mpp_clock_begin ( radiative_gases_init_clock )
        call radiative_gases_init (pref, latb, lonb)
        call mpp_clock_end ( radiative_gases_init_clock )
 
!-----------------------------------------------------------------------
!    initialize radiation_driver_mod.
!-----------------------------------------------------------------------
        call mpp_clock_begin ( radiation_init_clock )
        call radiation_driver_init (lonb, latb, pref, axes, time,  &
                                    donner_meso_is_largescale, &
                                    aerosol_names, &
                                    aerosol_family_names, do_cosp, ncol)
        call mpp_clock_end ( radiation_init_clock )

!---------------------------------------------------------------------
!    deallocate space for local pointers.
!---------------------------------------------------------------------
        deallocate (aerosol_names, aerosol_family_names)

      else if (do_moist_processes) then
!-----------------------------------------------------------------------
!    initialize aerosol_mod.     
!-----------------------------------------------------------------------
        call mpp_clock_begin ( aerosol_init_clock )
        call aerosol_init (lonb, latb, aerosol_names, aerosol_family_names)
        call mpp_clock_end ( aerosol_init_clock )

      endif ! do_radiation

      if(do_grey_radiation) then
         call mpp_clock_begin ( grey_radiation_init_clock )
         call grey_radiation_init(axes, Time) 
         call mpp_clock_end ( grey_radiation_init_clock )
      endif
        
!-----------------------------------------------------------------------
!    initialize atmos_tracer_driver_mod.
!-----------------------------------------------------------------------
      call mpp_clock_begin ( tracer_init_clock )
      call atmos_tracer_driver_init (lonb, latb, trs, axes, time,  &
                                     phalf, mask)
      call mpp_clock_end ( tracer_init_clock )

!---------------------------------------------------------------------
!    allocate space for the module variables.
!---------------------------------------------------------------------
      allocate ( diff_t     (id, jd, kd) ) ; diff_t = 0.0
      allocate ( diff_m     (id, jd, kd) ) ; diff_m = 0.0
      allocate ( diff_cu_mo (id, jd, kd) ) ; diff_cu_mo = 0.0
      allocate ( pbltop     (id, jd) )     ; pbltop     = -999.0
      allocate ( cush       (id, jd) )     ; cush=-1. !miz
      allocate ( cbmf       (id, jd) )     ; cbmf=0.0 !miz
      allocate ( convect    (id, jd) )     ; convect = .false.
      allocate ( radturbten (id, jd, kd))  ; radturbten = 0.0
      allocate ( lw_tendency(id, jd, kd))  ; lw_tendency = 0.0
      allocate ( r_convect  (id, jd) )     ; r_convect   = 0.0
       
! ---> h1g, cjg
      if (do_clubb > 0 ) then
        allocate ( dcond_ls_liquid(id, jd, kd) );   dcond_ls_liquid   = 0.0
        allocate ( dcond_ls_ice(id, jd, kd) );      dcond_ls_ice      = 0.0
        allocate ( Ndrop_act_CLUBB(id, jd, kd) );   Ndrop_act_CLUBB   = 0.0
        allocate ( Icedrop_act_CLUBB(id, jd, kd) ); Icedrop_act_CLUBB = 0.0
        allocate ( ndust(id, jd, kd) );             ndust             = 0.0
        allocate ( rbar_dust(id, jd, kd) );         rbar_dust         = 0.0
        allocate ( diff_t_clubb(id, jd, kd) );      diff_t_clubb      = 0.0
      end if
! <--- h1g, cjg

!--------------------------------------------------------------------
!    these variables needed to preserve rain fluxes, q and T from end 
!    of one step for use in COSP simulator on next step.
!--------------------------------------------------------------------
      allocate (fl_lsrain  (id, jd, kd))
      allocate (fl_lssnow  (id, jd, kd))
      allocate (fl_lsgrpl  (id, jd, kd))
      allocate (fl_ccrain  (id, jd, kd))
      allocate (fl_ccsnow  (id, jd, kd))
      allocate (fl_donmca_snow  (id, jd, kd))
      allocate (fl_donmca_rain  (id, jd, kd))
      allocate (mr_ozone   (id, jd, kd))
      allocate (daytime    (id, jd    ))
      allocate ( temp_last (id, jd, kd))
      allocate ( q_last    (id, jd, kd))
      fl_lsrain = 0.
      fl_lssnow = 0.
      fl_lsgrpl = 0.
      fl_ccrain = 0.
      fl_ccsnow = 0.
      fl_donmca_rain = 0.
      fl_donmca_snow = 0.
      mr_ozone  = 0.
      daytime =   0.
      temp_last = 0.
      q_last    = 0.

!--------------------------------------------------------------------
!    these variables needed to preserve radiative inputs to COSP from 
!    physics_driver_down to physics_driver_up.
!--------------------------------------------------------------------
      if (do_cosp .or. do_modis_yim) then
        allocate ( tau_stoch          (id, jd, kd,ncol))
        allocate ( lwem_stoch         (id, jd, kd,ncol))
        allocate ( stoch_cloud_type   (id, jd, kd,ncol))
        allocate ( stoch_conc_drop    (id, jd, kd,ncol))
        allocate ( stoch_conc_ice     (id, jd, kd,ncol))
        allocate ( stoch_size_drop    (id, jd, kd,ncol))
        allocate ( stoch_size_ice     (id, jd, kd,ncol))
        allocate ( tsurf_save         (id, jd)         )
 
        tau_stoch = 0.
        lwem_stoch = 0.
        stoch_cloud_type = 0.
        stoch_conc_drop = 0.
        stoch_conc_ice  = 0.
        stoch_size_drop = 0.
        stoch_size_ice  = 0.
        tsurf_save = 0.
      endif

      if (doing_donner) then

        allocate (cell_cld_frac (id, jd, kd) )
        allocate (cell_liq_amt  (id, jd, kd) )
        allocate (cell_liq_size (id, jd, kd) )
        allocate (cell_ice_amt  (id, jd, kd) )
        allocate (cell_ice_size (id, jd, kd) )
        allocate (cell_droplet_number (id, jd, kd) )
        allocate (meso_cld_frac (id, jd, kd) )
        allocate (meso_liq_amt  (id, jd, kd) )
        allocate (meso_liq_size (id, jd, kd) )
        allocate (meso_ice_amt  (id, jd, kd) )
        allocate (meso_ice_size (id, jd, kd) )
        allocate (meso_droplet_number (id, jd, kd) )
        allocate (nsum_out (id, jd) )
        cell_cld_frac = 0.
        cell_liq_amt  = 0.
        cell_liq_size = 0.
        cell_ice_amt  = 0.
        cell_ice_size = 0.
        cell_droplet_number = 0.
        meso_cld_frac = 0.
        meso_liq_amt  = 0.
        meso_liq_size = 0.
        meso_ice_amt  = 0.
        meso_ice_size = 0.
        meso_droplet_number = 0.
        nsum_out = 1
      endif

       allocate (lsc_cloud_area     (id, jd, kd) )
       allocate (lsc_liquid         (id, jd, kd) )
       allocate (lsc_ice            (id, jd, kd) )
       allocate (lsc_droplet_number (id, jd, kd) )
       allocate (lsc_ice_number     (id, jd, kd) )
  ! snow, rain
       allocate (lsc_rain           (id, jd, kd) )
       allocate (lsc_snow           (id, jd, kd) )
       allocate (lsc_rain_size      (id, jd, kd) )
       allocate (lsc_snow_size      (id, jd, kd) )
       lsc_cloud_area      = -99.
       lsc_liquid          = -99.
       lsc_ice             = -99.
       lsc_droplet_number  = -99.
       lsc_ice_number      = -99.
   ! snow, rain
       lsc_rain = 0.
       lsc_snow = 0.
       lsc_rain_size = 0.
       lsc_snow_size = 0.

       if (doing_uw_conv) then
 
         allocate (shallow_cloud_area     (id, jd, kd) )
         allocate (shallow_liquid         (id, jd, kd) )
         allocate (shallow_ice            (id, jd, kd) )
         allocate (shallow_droplet_number (id, jd, kd) )
         allocate (shallow_ice_number     (id, jd, kd) )
         shallow_cloud_area      = 0.
         shallow_liquid          = 0.
         shallow_ice             = 0.
         shallow_droplet_number  = 0.
         shallow_ice_number      = 0.
       endif

!--------------------------------------------------------------------
!    call physics_driver_read_restart to obtain initial values for the module
!    variables. Also register restart fields to be ready for intermediate 
!    restart.
!--------------------------------------------------------------------

      call physics_driver_register_restart
      if(file_exist('INPUT/physics_driver.res.nc')) then
         call restore_state(Phy_restart)
         if(in_different_file) call restore_state(Til_restart)
      endif
!---------------------------------------------------------------------
!    a flag indicating columns in which convection is occurring is
!    present beginning with v4. if not present, set it to .false.
!---------------------------------------------------------------------
      convect = .false.
      where(r_convect .GT. 0.) 
         convect = .true.
      end where
         
100 FORMAT("CHECKSUM::",A32," = ",Z20)
      outunit = stdout()
      write(outunit,*) 'BEGIN CHECKSUM(physics_driver_init):: '
      write(outunit,100) 'diff_cu_mo             ', mpp_chksum(diff_cu_mo            )
      write(outunit,100) 'pbltop                 ', mpp_chksum(pbltop                )
      write(outunit,100) 'cush                   ', mpp_chksum(cush                  )
      write(outunit,100) 'cbmf                   ', mpp_chksum(cbmf                  )
      write(outunit,100) 'diff_t                 ', mpp_chksum(diff_t                )
      write(outunit,100) 'diff_m                 ', mpp_chksum(diff_m                )
      write(outunit,100) 'r_convect              ', mpp_chksum(r_convect             )
      write(outunit,100) 'radturbten             ', mpp_chksum(radturbten            )
      write(outunit,100) 'lw_tendency            ', mpp_chksum(lw_tendency           )
      if ( doing_donner ) then
         write(outunit,100) 'cell_cld_frac          ', mpp_chksum(cell_cld_frac         )
         write(outunit,100) 'cell_liq_amt           ', mpp_chksum(cell_liq_amt          )
         write(outunit,100) 'cell_liq_size          ', mpp_chksum(cell_liq_size         )
         write(outunit,100) 'cell_ice_amt           ', mpp_chksum(cell_ice_amt          )
         write(outunit,100) 'cell_ice_size          ', mpp_chksum(cell_ice_size         )
         write(outunit,100) 'meso_cld_frac          ', mpp_chksum(meso_cld_frac         )
         write(outunit,100) 'meso_liq_amt           ', mpp_chksum(meso_liq_amt          )
         write(outunit,100) 'meso_liq_size          ', mpp_chksum(meso_liq_size         )
         write(outunit,100) 'meso_ice_amt           ', mpp_chksum(meso_ice_amt          )
         write(outunit,100) 'meso_ice_size          ', mpp_chksum(meso_ice_size         )
         write(outunit,100) 'meso_droplet_number    ', mpp_chksum(meso_droplet_number   )
         write(outunit,100) 'nsum_out               ', mpp_chksum(nsum_out              )
      endif
      if ( doing_uw_conv ) then
         write(outunit,100) 'shallow_cloud_area     ', mpp_chksum(shallow_cloud_area    )
         write(outunit,100) 'shallow_liquid         ', mpp_chksum(shallow_liquid        )
         write(outunit,100) 'shallow_ice            ', mpp_chksum(shallow_ice           )
         write(outunit,100) 'shallow_droplet_number ', mpp_chksum(shallow_droplet_number)
         write(outunit,100) 'shallow_ice_number     ', mpp_chksum(shallow_ice_number    )
      endif
      write(outunit,100) 'lsc_cloud_area         ', mpp_chksum(lsc_cloud_area        )
      write(outunit,100) 'lsc_liquid             ', mpp_chksum(lsc_liquid            )
      write(outunit,100) 'lsc_ice                ', mpp_chksum(lsc_ice               )
      write(outunit,100) 'lsc_droplet_number     ', mpp_chksum(lsc_droplet_number    )
      write(outunit,100) 'lsc_ice_number         ', mpp_chksum(lsc_ice_number        )
      write(outunit,100) 'lsc_snow               ', mpp_chksum(lsc_snow              )
      write(outunit,100) 'lsc_rain               ', mpp_chksum(lsc_rain              )
      write(outunit,100) 'lsc_snow_size          ', mpp_chksum(lsc_snow_size         )
      write(outunit,100) 'lsc_rain_size          ', mpp_chksum(lsc_rain_size         )
     

      vers = restart_versions(size(restart_versions(:)))

!---------------------------------------------------------------------
!    if desired, define variables to return diff_m and diff_t.
!---------------------------------------------------------------------
      if (present(difft)) then
        difft = diff_t
      endif
      if (present(diffm)) then
        diffm = diff_m
      endif

!---------------------------------------------------------------------
!    initialize module diagnostics
!---------------------------------------------------------------------

      id_tdt_phys_vdif_dn = register_diag_field ( mod_name,    &
         'tdt_phys_vdif_dn', axes(1:3), Time,                  &
         'temperature tendency from physics driver vdif down', &
         'K/s', missing_value=missing_value)

      id_tdt_phys_vdif_up = register_diag_field ( mod_name,    &
         'tdt_phys_vdif_up', axes(1:3), Time,                  &
         'temperature tendency from physics driver vdif up',   &
         'K/s', missing_value=missing_value)

      id_tdt_phys_turb = register_diag_field ( mod_name,       &
         'tdt_phys_turb', axes(1:3), Time,                     &
         'temperature tendency from physics driver vdif turb', &
         'K/s', missing_value=missing_value)

      id_tdt_phys_moist = register_diag_field ( mod_name,            &
         'tdt_phys_moist', axes(1:3), Time,                          &
         'temperature tendency from physics driver moist processes', &
         'K/s', missing_value=missing_value)

      id_tdt_phys = register_diag_field ( mod_name,            &
         'tdt_phys', axes(1:3), Time,                          &
         'temperature tendency from physics ', &
         'K/s', missing_value=missing_value)

!-->cjg
!     id_qdt_phys = register_diag_field ( mod_name,            &
!        'qdt_phys', axes(1:3), Time,                          &
!        'specific humidity tendency from physics ', &
!        'kg/kg/s', missing_value=missing_value)
!<--cjg

      allocate (id_tracer_phys(nt))      ! cjg
      allocate (id_tracer_phys_vdif_dn(nt))
      allocate (id_tracer_phys_vdif_up(nt))
      allocate (id_tracer_phys_turb(nt))
      allocate (id_tracer_phys_moist(nt))

      do n = 1,nt

        call get_tracer_names (MODEL_ATMOS, n, name = tracer_name,  &
                               units = tracer_units)
!-->cjg
        diaglname = trim(tracer_name)//  &
                    ' tendency from physics'
        id_tracer_phys(n) =    &
                         register_diag_field ( mod_name, &
                         TRIM(tracer_name)//'_phys',  &
                         axes(1:3), Time, trim(diaglname), &
                         TRIM(tracer_units)//'/s',  &
                         missing_value=missing_value)
!<--cjg

        diaglname = trim(tracer_name)//  &
                    ' tendency from physics driver vdif down'
        id_tracer_phys_vdif_dn(n) =    &
                         register_diag_field ( mod_name, &
                         TRIM(tracer_name)//'_phys_vdif_dn',  &
                         axes(1:3), Time, trim(diaglname), &
                         TRIM(tracer_units)//'/s',  &
                         missing_value=missing_value)

        diaglname = trim(tracer_name)//  &
                    ' tendency from physics driver vdif up'
        id_tracer_phys_vdif_up(n) =    &
                         register_diag_field ( mod_name, &
                         TRIM(tracer_name)//'_phys_vdif_up',  &
                         axes(1:3), Time, trim(diaglname), &
                         TRIM(tracer_units)//'/s',  &
                         missing_value=missing_value)

        diaglname = trim(tracer_name)//  &
                    ' tendency from physics driver vert turb'
        id_tracer_phys_turb(n) =    &
                         register_diag_field ( mod_name, &
                         TRIM(tracer_name)//'_phys_turb',  &
                         axes(1:3), Time, trim(diaglname), &
                         TRIM(tracer_units)//'/s',  &
                         missing_value=missing_value)

        diaglname = trim(tracer_name)//  &
                    ' tendency from physics driver moist processes'
        id_tracer_phys_moist(n) =    &
                         register_diag_field ( mod_name, &
                         TRIM(tracer_name)//'_phys_moist',  &
                         axes(1:3), Time, trim(diaglname), &
                         TRIM(tracer_units)//'/s',  &
                         missing_value=missing_value)

      end do

!--------------------------------------------------------------------
!    if COSP is activated, call its initialization routine.
!--------------------------------------------------------------------
      if (do_cosp) then
        call mpp_clock_begin ( cosp_init_clock )
        call cosp_driver_init (lonb, latb, Time, axes, kd, ncol)
        call set_cosp_precip_sources (cosp_precip_sources_modified)
        call mpp_clock_end   ( cosp_init_clock )
      endif

!---------------------------------------------------------------------
!    mark the module as initialized.
!---------------------------------------------------------------------
      module_is_initialized = .true.

!-----------------------------------------------------------------------



 end subroutine physics_driver_init


!######################################################################
! <SUBROUTINE NAME="physics_driver_down_time_vary">
!  <OVERVIEW>
!    physics_driver_time_vary makes sure that all time-dependent, spacially-
!    independent calculations are completed before entering window or thread
!    loops. Resultant fields are usually saved as module variables in the
!    module where needed.
!  </OVERVIEW>
!  <DESCRIPTION>
!    physics_driver_time_vary makes sure that all time-dependent, spacially-
!    independent calculations are completed before entering window or thread
!    loops. Resultant fields are usually saved as module variables in the
!    module where needed.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call physics_driver_down_time_vary (Time, Time_next)
!
!  </TEMPLATE>
!  <IN NAME="Time" TYPE="time_type">
!   current time
!  </IN>
!  <IN NAME="Time_next" TYPE="time_type">
!   time of next time step
!  </IN>
! </SUBROUTINE>
!

subroutine physics_driver_down_time_vary (Time, Time_next, gavg_rrv, dt)

!---------------------------------------------------------------------
!    physics_driver_down_time_vary makes sure that all time-dependent, 
!    spacially-independent calculations are completed before entering window 
!    or thread loops. Resultant fields are usually saved as module variables in 
!    the module where needed.
!-----------------------------------------------------------------------

type(time_type),         intent(in)             :: Time, Time_next
real, dimension(:),      intent(in)             :: gavg_rrv
real,                    intent(in)             :: dt

!---------------------------------------------------------------------      
      if (do_radiation) then
!----------------------------------------------------------------------
!    call define_rad_times to obtain the time to be used in the rad-
!    iation calculation (Rad_time) and to determine which, if any, 
!    externally-supplied inputs to radiation_driver must be obtained on 
!    this timestep.  logical flags are returned indicating the need or 
!    lack of need for the aerosol fields, the cloud fields, the rad-
!    iative gas fields, and the basic atmospheric variable fields.
!----------------------------------------------------------------------
        call define_rad_times (Time, Time_next, Rad_time, &
                               need_aerosols, need_clouds, &
                               need_gases, need_basic)
        call aerosol_time_vary (Rad_time)
        call radiative_gases_time_vary (Rad_time, gavg_rrv,  &
                                                           Rad_gases_tv)
        call radiation_driver_time_vary (Rad_time, Rad_gases_tv)
        
!--------------------------------------------------------------------
!    define step_to_call_cosp to indicate that this is a radiation
!    step and therefore one on which COSP should be called in 
!    physics_driver_up.
!--------------------------------------------------------------------
        if (need_basic) then
          step_to_call_cosp = .true.
        else
          step_to_call_cosp = .false.
        endif

      endif
      call damping_driver_time_vary (dt)
      call atmos_tracer_driver_time_vary (Time)


!-------------------------------------------------------------------------      

end subroutine physics_driver_down_time_vary



!######################################################################

subroutine physics_driver_down_endts(is,js)

integer, intent(in)  :: is,js

      call damping_driver_endts
      call atmos_tracer_driver_endts

      IF (do_radiation) THEN
         CALL aerosol_endts
         CALL radiation_driver_endts  (is, js, Rad_gases_tv)
         CALL radiative_gases_endts
      END IF
   

!--------------------------------------------------------------------
!    set a flag to indicate that this check was done and need not be
!    done again.
!--------------------------------------------------------------------
      do_check_args = .false.


end subroutine physics_driver_down_endts




!###################################################################


subroutine physics_driver_up_time_vary (Time, Time_next, dt)

!---------------------------------------------------------------------
!    physics_driver_up_time_vary makes sure that all time-dependent, 
!    spacially-independent calculations are completed before entering 
!    window or thread loops. Resultant fields are usually saved as 
!    module variables in the module where needed.
!-----------------------------------------------------------------------

type(time_type),         intent(in)             :: Time
type(time_type),         intent(in)             :: Time_next
real,                    intent(in)             :: dt


      call aerosol_time_vary (Time)
      call moist_processes_time_vary (dt)
      if (do_cosp) call cosp_driver_time_vary (Time_next)

!----------------------------------------------------------------------      

end subroutine physics_driver_up_time_vary


!######################################################################

subroutine physics_driver_up_endts (is,js)

integer, intent(in)  :: is,js

      if (do_cosp) call cosp_driver_endts
      call moist_processes_endts (is,js)
      call aerosol_endts

end subroutine physics_driver_up_endts


!#####################################################################

!--> cjg: code modification to allow diagnostic tracers in physics_up (20120508)
!         
!subroutine physics_driver_moist_init (ix,jx,kx,lx)
!
!integer, intent(in) :: ix,jx, kx, lx 
!
!      call moist_alloc_init (ix,jx,kx,lx)

subroutine physics_driver_moist_init (ix,jx,kx,lx,mx)


integer, intent(in) :: ix,jx, kx, lx, mx


      call moist_alloc_init (ix,jx,kx,lx,mx)
!<--cjg
      call moistproc_init (ix,jx,kx, num_uw_tracers, do_strat)

end subroutine physics_driver_moist_init 



!######################################################################

subroutine physics_driver_moist_end                  

      call moist_alloc_end
      call moistproc_end (do_strat)


end subroutine physics_driver_moist_end                  




!######################################################################
! <SUBROUTINE NAME="physics_driver_down">
!  <OVERVIEW>
!    physics_driver_down calculates "first pass" physics tendencies,
!    associated with radiation, damping and turbulence, and obtains
!    the vertical diffusion tendencies to be passed to the surface and
!    used in the semi-implicit vertical diffusion calculation.
!  </OVERVIEW>
!  <DESCRIPTION>
!    physics_driver_down calculates "first pass" physics tendencies,
!    associated with radiation, damping and turbulence, and obtains
!    the vertical diffusion tendencies to be passed to the surface and
!    used in the semi-implicit vertical diffusion calculation.    
!  </DESCRIPTION>
!  <TEMPLATE>
!   call physics_driver_down (is, ie, js, je,                       &
!                                Time_prev, Time, Time_next,           &
!                                lat, lon, area,                       &
!                                p_half, p_full, z_half, z_full,       &
!                                u, v, t, q, r, um, vm, tm, qm, rm,    &
!                                frac_land, rough_mom,                 &
!                                albedo,    t_surf_rad,                &
!                                u_star,    b_star, q_star,            &
!                                dtau_du,  dtau_dv,  tau_x,  tau_y,    &
!                                udt, vdt, tdt, qdt, rdt,              &
!                                flux_sw,  flux_lw,  coszen,  gust,    &
!                                Surf_diff, gavg_rrv,                  &
!                                mask, kbot
!  </TEMPLATE>
!  <IN NAME="Time_prev" TYPE="time_type">
!   previous time, for variable um, vm, tm, qm, rm
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!   current time
!  </IN>
!  <IN NAME="Time_next" TYPE="time_type">
!   next time, used for diagnostics
!  </IN>
!  <IN NAME="lat" TYPE="real">
!   array of model latitudes at model points [radians]
!  </IN>
!  <IN NAME="lon" TYPE="real">
!   array of model longitudes at model points [radians]
!  </IN>
!  <IN NAME="area" TYPE="real">
!   grid box area - current not used
!  </IN>
!  <IN NAME="p_half" TYPE="real">
!   pressure at model interface levels (offset from t,q,u,v,r)
!  </IN>
!  <IN NAME="p_full" TPYE="real">
!   pressure at full levels
!  </IN>
!  <IN NAME="z_half" TYPE="real">
!   height at model interface levels
!  </IN>
!  <IN NAME="z_full" TPYE="real">
!   height at full levels
!  </IN>
!  <IN NAME="u" TYPE="real">
!   zonal wind at current time step
!  </IN>
!  <IN NAME="v" TYPE="real">
!   meridional wind at current time step
!  </IN>
!  <IN NAME="t" TYPE="real">
!   temperature at current time step
!  </IN>
!  <IN NAME="q" TYPE="real">
!   specific humidity at current time step
!  </IN>
!  <IN NAME="r" TPYE="real">
!   multiple 3d tracer fields at current time step
!  </IN>
!  <IN NAME="um" TYPE="real">
!   zonal wind at previous time step
!  </IN>
!  <IN NAME="vm" TYPE="real">
!   meridional wind at previous time step
!  </IN>
!  <IN NAME="tm" TYPE="real">
!   temperature at previous time step
!  </IN>
!  <IN NAME="qm" TYPE="real">
!   specific humidity at previous time step
!  </IN>
!  <IN NAME="rm" TPYE="real">
!   multiple 3d tracer fields at previous time step
!  </IN>
!  <INOUT NAME="rd" TYPE="real">
!   multiple 3d diagnostic tracer fields 
!  </INOUT>
!  <IN NAME="frac_land" TYPE="real">
!   fraction of land coverage in a model grid point
!  </IN>
!  <IN NAME="rough_mom" TYPE="real">
!   boundary layer roughness
!  </IN>
!  <IN NAME="albedo" TYPE="real">
!   surface albedo
!  </IN>
!  <IN NAME="t_surf_rad" TYPE="real">
!   surface radiative temperature
!  </IN>
!  <IN NAME="u_star" TYPE="real">
!   boundary layer wind speed (frictional speed)
!  </IN>
!  <IN NAME="b_star" TYPE="real">
!   ???
!  </IN>
!  <IN NAME="q_star" TYPE="real">
!   boundary layer specific humidity
!  </IN>
!  <IN NAME="dtau_du" TYPE="real">
!   derivative of zonal surface stress w.r.t zonal wind speed
!  </IN>
!  <IN NAME="dtau_dv" TYPE="real">
!   derivative of meridional surface stress w.r.t meridional wind speed
!  </IN>
!  <INOUT NAME="tau_x" TYPE="real">
!   boundary layer meridional component of wind shear
!  </INOUT>
!  <INOUT NAME="tau_y" TYPE="real">
!   boundary layer zonal component of wind shear
!  </INOUT>
!  <INOUT NAME="udt" TYPE="real">
!   zonal wind tendency
!  </INOUT>
!  <INOUT NAME="vdt" TYPE="real">
!   meridional wind tendency
!  </INOUT>
!  <INOUT NAME="tdt" TYPE="real">
!   temperature tendency
!  </INOUT>
!  <INOUT NAME="qdt" TYPE="real">
!   moisture tracer tendencies
!  </INOUT>
!  <INOUT NAME="rdt" TYPE="real">
!   multiple tracer tendencies
!  </INOUT>
!  <OUT NAME="flux_sw" TYPE="real">
!   Shortwave flux from radiation package
!  </OUT>
!  <OUT NAME="flux_lw" TYPE="real">
!   Longwave flux from radiation package
!  </OUT>
!  <OUT NAME="coszen" TYPE="real">
!   cosine of zenith angle
!  </OUT>
!  <OUT NAME="gust" TYPE="real">
!  </OUT>
!  <INOUT NAME="Surf_diff" TYPE="surface_diffusion_type">
!   Surface diffusion 
!  </INOUT>
!  <IN NAME="gavg_rrv" TYPE="real">
!   array containing global average of tracer volume mixing ratio
!  </IN>
!!  <IN NAME="kbot" TYPE="integer">
!   OPTIONAL: present when running eta vertical coordinate,
!                        index of lowest model level above ground
!  </IN>
!  <IN NAME="mask" TYPE="real">
!   OPTIONAL: present when running eta vertical coordinate,
!                        mask to remove points below ground
!  </IN>
!
!  <IN NAME="diff_cum_mom" TYPE="real">
!   OPTIONAL: present when do_moist_processes=.false.
!    cu_mo_trans diffusion coefficients, which are passed through to vert_diff_down.
!    Should not be present when do_moist_processes=.true., since these
!    values are passed out from moist_processes.
!  </IN>
!
!  <IN NAME="moist_convect" TYPE="real">
!   OPTIONAL: present when do_moist_processes=.false.
!    Should not be present when do_moist_processes=.true., since these
!    values are passed out from moist_processes.
!  </IN>
! </SUBROUTINE>
!
subroutine physics_driver_down (is, ie, js, je,                       &
                                Time_prev, Time, Time_next,           &
                                lat, lon, area,                       &
                                p_half, p_full, z_half, z_full,       &
                                phalfgrey,                            &
                                u, v, t, q, r, um, vm, tm, qm, rm,    &
                                frac_land, rough_mom,                 &
                                frac_open_sea,                        &
                                albedo, albedo_vis_dir, albedo_nir_dir,&
                                albedo_vis_dif, albedo_nir_dif,       &
                                t_surf_rad,                           &
                                u_star,    b_star, q_star,            &
                                dtau_du, dtau_dv,  tau_x,  tau_y,     &
                                udt, vdt, tdt, qdt, rdt,              &
                                flux_sw,                              &
                                flux_sw_dir,                          &
                                flux_sw_dif,                          &
                                flux_sw_down_vis_dir,                 &
                                flux_sw_down_vis_dif,                 &
                                flux_sw_down_total_dir,               &
                                flux_sw_down_total_dif,               &
                                flux_sw_vis,                          &
                                flux_sw_vis_dir,                      &
                                flux_sw_vis_dif,                      &
                                flux_lw,  coszen,  gust,              &
                                Surf_diff, gavg_rrv,                  &
                                mask, kbot, diff_cum_mom,             &
                                moist_convect, diffm, difft  )

!---------------------------------------------------------------------
!    physics_driver_down calculates "first pass" physics tendencies,
!    associated with radiation, damping and turbulence, and obtains
!    the vertical diffusion tendencies to be passed to the surface and
!    used in the semi-implicit vertical diffusion calculation.
!-----------------------------------------------------------------------

integer,                 intent(in)             :: is, ie, js, je
type(time_type),         intent(in)             :: Time_prev, Time,  &
                                                   Time_next
real,dimension(:,:),     intent(in)             :: lat, lon, area
real,dimension(:,:,:),   intent(in)             :: p_half, p_full,   &
                                                   z_half, z_full,   &
                                                   u , v , t , q ,   &
                                                   um, vm, tm, qm,   &
                                                   phalfgrey
real,dimension(:,:,:,:), intent(inout)          :: r
real,dimension(:,:,:,:), intent(inout)          :: rm
real,dimension(:,:),     intent(in)             :: frac_land,   &
                                                   rough_mom, &
                                                   albedo, t_surf_rad, &
                                                   albedo_vis_dir, albedo_nir_dir, &
                                                   albedo_vis_dif, albedo_nir_dif, &
                                                   u_star, b_star,    &
                                                   q_star, dtau_du,   &
                                                   dtau_dv, frac_open_sea
real,dimension(:,:),     intent(inout)          :: tau_x,  tau_y
real,dimension(:,:,:),   intent(inout)          :: udt,vdt,tdt,qdt
real,dimension(:,:,:,:), intent(inout)          :: rdt
real,dimension(:,:),     intent(out)            :: flux_sw,  &
                                                   flux_sw_dir, &
                                                   flux_sw_dif, flux_lw,  &
                                                   coszen,  gust, &
                                                   flux_sw_down_vis_dir, &
                                                   flux_sw_down_vis_dif, &
                                                   flux_sw_down_total_dir, &
                                                   flux_sw_down_total_dif, &
                                                   flux_sw_vis, &
                                                   flux_sw_vis_dir, & 
                                                   flux_sw_vis_dif 
type(surf_diff_type),    intent(inout)          :: Surf_diff
real,dimension(:),       intent(in)             :: gavg_rrv
real,dimension(:,:,:),   intent(in)   ,optional :: mask
integer, dimension(:,:), intent(in)   ,optional :: kbot
real,  dimension(:,:,:), intent(in)   ,optional :: diff_cum_mom
logical, dimension(:,:), intent(in)   ,optional :: moist_convect
real,  dimension(:,:,:), intent(out)  ,optional :: diffm, difft 

!-----------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je    starting/ending subdomain i,j indices of data in 
!                     the physics_window being integrated
!      Time_prev      previous time, for variables um,vm,tm,qm,rm 
!                     (time_type)
!      Time           current time, for variables u,v,t,q,r  (time_type)
!      Time_next      next time, used for diagnostics   (time_type)
!      lat            latitude of model points [ radians ]
!      lon            longitude of model points [ radians ]
!      area           grid box area - currently not used [ m**2 ]
!      p_half         pressure at half levels (offset from t,q,u,v,r)
!                     [ Pa ]
!      p_full         pressure at full levels [ Pa }
!      z_half         height at half levels [ m ]
!      z_full         height at full levels [ m ]
!      u              zonal wind at current time step [ m / s ]
!      v              meridional wind at current time step [ m / s ]
!      t              temperature at current time step [ deg k ]
!      q              specific humidity at current time step  kg / kg ]
!      r              multiple 3d tracer fields at current time step
!      um,vm          zonal and meridional wind at previous time step
!      tm,qm          temperature and specific humidity at previous 
!                     time step
!      rm             multiple 3d tracer fields at previous time step
!      frac_land
!      rough_mom
!      albedo
!      albedo_vis_dir surface visible direct albedo [ dimensionless ]
!      albedo_nir_dir surface nir direct albedo [ dimensionless ]
!      albedo_vis_dif surface visible diffuse albedo [ dimensionless ]
!      albedo_nir_dif surface nir diffuse albedo [ dimensionless ]
!      t_surf_rad
!      u_star
!      b_star
!      q_star
!      dtau_du
!      dtau_dv
!
!  intent(inout) variables:
!
!      tau_x
!      tau_y
!      udt            zonal wind tendency [ m / s**2 ]
!      vdt            meridional wind tendency [ m / s**2 ]
!      tdt            temperature tendency [ deg k / sec ]
!      qdt            specific humidity tendency 
!                     [  kg vapor / kg air / sec ]
!      rdt            multiple tracer tendencies [ unit / unit / sec ]
!      rd             multiple 3d diagnostic tracer fields 
!                     [ unit / unit / sec ]
!      Surf_diff      surface_diffusion_type variable
!
!   intent(out) variables:
!
!      flux_sw
!      flux_sw_dir            net shortwave surface flux (down-up) [ w / m^2 ]
!      flux_sw_dif            net shortwave surface flux (down-up) [ w / m^2 ]
!      flux_sw_down_vis_dir   downward shortwave surface flux in visible spectrum [ w / m^2 ]
!      flux_sw_down_vis_dif   downward shortwave surface flux in visible spectrum [ w / m^2 ]
!      flux_sw_down_total_dir total downward shortwave surface flux [ w / m^2 ]
!      flux_sw_down_total_dif total downward shortwave surface flux [ w / m^2 ]
!      flux_sw_vis            net downward shortwave surface flux in visible spectrum [ w / m^2 ]
!      flux_sw_vis_dir        net downward shortwave surface flux in visible spectrum [ w / m^2 ]
!      flux_sw_vis_dif        net downward shortwave surface flux in visible spectrum [ w / m^2 ]
!      flux_lw
!      coszen
!      gust
!
!   intent(in), optional variables:
!
!       mask        mask that designates which levels do not have data
!                   present (i.e., below ground); 0.=no data, 1.=data
!       kbot        lowest level which has data
!                   note:  both mask and kbot must be present together.
!
!-----------------------------------------------------------------------

!---------------------------------------------------------------------
!    local variables:

      real, dimension(size(u,1),size(u,2),size(u,3)) :: diff_t_vert, &
                                                        diff_m_vert
      real, dimension(size(u,1),size(u,2))           :: z_pbl 
      type(aerosol_type)                             :: Aerosol
      type(cld_specification_type)                   :: Cld_spec
      type(radiative_gases_type)                     :: Rad_gases
      type(atmos_input_type)                         :: Atmos_input
      type(surface_type)                             :: Surface
      type(rad_output_type)                          :: Radiation
      type(microphysics_type)                        :: Lsc_microphys, &
                                                        Meso_microphys,&
                                                        Cell_microphys,&
                                                    Shallow_microphys, &
                                                        Model_microphys
      integer          ::    sec, day, n
      real             ::    dt, alpha, dt2
      logical          ::    used

!---------------------------------------------------------------------
!   local variables:
!
!      diff_t_vert     vertical diffusion coefficient for temperature
!                      calculated on the current step
!      diff_m_vert     vertical diffusion coefficient for momentum   
!                      calculated on the current step
!      z_pbl           height of planetary boundary layer
!      Aerosol         aerosol_type variable describing the aerosol
!                      fields to be seen by the radiation package
!      Cld_spec        cld_specification_type variable describing the
!                      cloud field to be seen by the radiation package 
!      Rad_gases       radiative_gases_type variable describing the
!                      radiatively-active gas distribution to be seen 
!                      by the radiation package
!      Atmos_input     atmos_input_type variable describing the atmos-
!                      pheric state to be seen by the radiation package
!      Surface         surface_type variable describing the surface
!                      characteristics to be seen by the radiation 
!                      package
!      Radiation       rad_output_type variable containing the variables
!                      output from the radiation package, for passage
!                      to other modules
!      Rad_time        time at which the radiation calculation is to
!                      apply [ time_type ]
!      Lsc_microphys   microphysics_type variable containing the micro-
!                      physical characteristics of the large-scale
!                      clouds to be seen by the radiation package 
!      Meso_microphys  microphysics_type variable containing the micro-
!                      physical characteristics of the mesoscale
!                      clouds to be seen by the radiation package 
!      Cell_microphys  microphysics_type variable containing the micro-
!                      physical characteristics of the cell-scale
!                      clouds to be seen by the radiation package 
!      Shallow_microphys  
!                      microphysics_type variable containing the micro-
!                      physical characteristics of the cell-scale
!                      clouds to be seen by the radiation package
!      sec, day        second and day components of the time_type 
!                      variable
!      dt              model physics time step [ seconds ]
!      alpha           ratio of physics time step to diffusion-smoothing
!                      time scale
!      need_aerosols   need to obtain aerosol data on this time step
!                      to input to the radiation package ?
!      need_clouds     need to obtain cloud data on this time step
!                      to input to the radiation package ?
!      need_gases      need to obtain radiative gas data on this time 
!                      step to input to the radiation package ?
!      need_basic      need to obtain atmospheric state variables on
!                      this time step to input to the radiation package?
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    verify that the module is initialized.
!---------------------------------------------------------------------
      if ( .not. module_is_initialized) then
        call error_mesg ('physics_driver_mod',  &
                         'module has not been initialized', FATAL)
      endif

!---------------------------------------------------------------------
!    if COSP is activated, save the surface (skin) temperature for
!    its use.
!---------------------------------------------------------------------
      if (do_cosp) then
        tsurf_save(is:ie,js:je) = t_surf_rad
      endif

!---------------------------------------------------------------------
!    check the size of the input arguments. this is only done on the
!    first call to physics_driver_down.
!---------------------------------------------------------------------
      if (do_check_args) call check_args  &
                   (lat, lon, area, p_half, p_full, z_half, z_full, &
                    u, v, t, q, r, um, vm, tm, qm, rm,              &
                    udt, vdt, tdt, qdt, rdt)

!---------------------------------------------------------------------
!    compute the physics time step (from tau-1 to tau+1).
!---------------------------------------------------------------------
      call get_time (Time_next - Time_prev, sec, day)
      dt = real(sec + day*86400)

     if (do_radiation) then
!----------------------------------------------------------------------
!    prepare to calculate radiative forcings. obtain the valid time
!    at which the radiation calculation is to apply, the needed atmos-
!    pheric fields, and any needed inputs from other physics modules.
!---------------------------------------------------------------------
      call mpp_clock_begin ( radiation_clock )
 
!---------------------------------------------------------------------
!    call define_surface to define a surface_type variable containing
!    the surface albedoes and land fractions for each grid box. this
!    variable must be provided on all timesteps for use in generating
!    netcdf output.
!---------------------------------------------------------------------
      call define_surface (is, ie, js, je, albedo, albedo_vis_dir,  &
                           albedo_nir_dir, albedo_vis_dif, &
                           albedo_nir_dif, frac_land, Surface)

!---------------------------------------------------------------------
!    if the basic atmospheric input variables to the radiation package
!    are needed, pass the model pressure (p_full, p_half), temperature 
!    (t, t_surf_rad) and specific humidity (q) to subroutine
!    define_atmos_input_fields, which will put these fields and some
!    additional auxiliary fields into the form desired by the radiation
!    package and store them as components of the derived-type variable 
!    Atmos_input.
!---------------------------------------------------------------------
      if (need_basic) then
        call define_atmos_input_fields     &
                              (is, ie, js, je, p_full, p_half, t, q,  &
                               t_surf_rad, r, gavg_rrv, Atmos_input, kbot=kbot)
      endif

!---------------------------------------------------------------------
!    if the aerosol fields are needed as input to the radiation_package,
!    call aerosol_driver to access the aerosol data and place it into 
!    an aerosol_type derived-type variable Aerosol.
!---------------------------------------------------------------------
      if (need_aerosols) then
        call aerosol_driver (is, js, Rad_time, r, &
                             Atmos_input%phalf, Atmos_input%pflux, &
                             Aerosol, override_aerosols_radiation)
      endif
 
!---------------------------------------------------------------------
!    if the cloud fields are needed, call cloud_spec to retrieve bulk
!    cloud data and place it into a cld_specification_type derived-type 
!    variable Cld_spec and retrieve microphysical data which is returned
!    in microphysics_type variables Lsc_microphys, Meso_microphys and 
!    Cell_microphys and Shallow_microphys, when applicable.
!---------------------------------------------------------------------
      if (need_clouds) then
       if (use_cloud_tracers_in_radiation) then
       if (doing_donner .and. doing_uw_conv) then
           call cloud_spec (is, ie, js, je, lat,              &
                            z_half, z_full, Rad_time,   &
                            Atmos_input, Surface, Cld_spec,   &
                            Lsc_microphys, Meso_microphys,    &
                            Cell_microphys, Shallow_microphys, &
!             lsc_area_in = lsc_cloud_area,   &
!             lsc_liquid_in=lsc_liquid, lsc_ice_in=lsc_ice,  &
!             lsc_droplet_number_in=lsc_droplet_number,&
                           r=r(:,:,:,1:ntp), &
             shallow_cloud_area = shallow_cloud_area(is:ie,js:je,:), &
             shallow_liquid = shallow_liquid(is:ie,js:je,:), &
             shallow_ice = shallow_ice(is:ie,js:je,:), &
             shallow_droplet_number = shallow_droplet_number(is:ie,js:je,:), &
             shallow_ice_number = shallow_ice_number(is:ie,js:je,:), &
             cell_cld_frac= cell_cld_frac(is:ie,js:je,:),  &
             cell_liq_amt=cell_liq_amt(is:ie,js:je,:), &
             cell_liq_size=cell_liq_size(is:ie,js:je,:), &
             cell_ice_amt= cell_ice_amt(is:ie,js:je,:),   &
             cell_ice_size= cell_ice_size(is:ie,js:je,:), &
             cell_droplet_number= cell_droplet_number(is:ie,js:je,:), &
             meso_cld_frac= meso_cld_frac(is:ie,js:je,:),   &
             meso_liq_amt=meso_liq_amt(is:ie,js:je,:), &
             meso_liq_size=meso_liq_size(is:ie,js:je,:), &
             meso_ice_amt= meso_ice_amt(is:ie,js:je,:),  &
             meso_ice_size= meso_ice_size(is:ie,js:je,:), &
             meso_droplet_number= meso_droplet_number(is:ie,js:je,:), &
             nsum_out=nsum_out(is:ie,js:je)  )
      else  if (doing_donner) then
          call cloud_spec (is, ie, js, je, lat,              &
                           z_half, z_full, Rad_time,   &
                           Atmos_input, Surface, Cld_spec,   &
                           Lsc_microphys, Meso_microphys,    &
                           Cell_microphys, Shallow_microphys, &
!             lsc_area_in = lsc_cloud_area,   &
!             lsc_liquid_in=lsc_liquid, lsc_ice_in=lsc_ice,  &
!              lsc_droplet_number_in=lsc_droplet_number,&
                           r=r(:,:,:,1:ntp), &
             cell_cld_frac= cell_cld_frac(is:ie,js:je,:), &
             cell_liq_amt=cell_liq_amt(is:ie,js:je,:), &
             cell_liq_size=cell_liq_size(is:ie,js:je,:), &
             cell_ice_amt= cell_ice_amt(is:ie,js:je,:),   &
             cell_ice_size= cell_ice_size(is:ie,js:je,:), &
             cell_droplet_number= cell_droplet_number(is:ie,js:je,:), &
             meso_cld_frac= meso_cld_frac(is:ie,js:je,:),   &
             meso_liq_amt=meso_liq_amt(is:ie,js:je,:), &
             meso_liq_size=meso_liq_size(is:ie,js:je,:), &
             meso_ice_amt= meso_ice_amt(is:ie,js:je,:),  &
             meso_ice_size= meso_ice_size(is:ie,js:je,:), &
             meso_droplet_number= meso_droplet_number(is:ie,js:je,:), &
             nsum_out=nsum_out(is:ie,js:je)  )
      else if (doing_uw_conv) then
          call cloud_spec (is, ie, js, je, lat,              &
                           z_half, z_full, Rad_time,   &
                           Atmos_input, Surface, Cld_spec,   &
                           Lsc_microphys, Meso_microphys,    &
                           Cell_microphys, Shallow_microphys, &
!             lsc_area_in = lsc_cloud_area,   &
!             lsc_liquid_in=lsc_liquid, lsc_ice_in=lsc_ice,  &
!              lsc_droplet_number_in=lsc_droplet_number,&
                           r=r(:,:,:,1:ntp), &
             shallow_cloud_area = shallow_cloud_area(is:ie,js:je,:), &
             shallow_liquid = shallow_liquid(is:ie,js:je,:), &
             shallow_ice = shallow_ice(is:ie,js:je,:), &
             shallow_droplet_number =   &
                                shallow_droplet_number(is:ie,js:je,:), &
             shallow_ice_number = shallow_ice_number(is:ie,js:je,:) )
      else
          call cloud_spec (is, ie, js, je, lat,              &
                           z_half, z_full, Rad_time,   &
                           Atmos_input, Surface, Cld_spec,   &
                           Lsc_microphys, Meso_microphys,    &
                           Cell_microphys, Shallow_microphys, &
!             lsc_area_in = lsc_cloud_area,   &
!             lsc_liquid_in=lsc_liquid, lsc_ice_in=lsc_ice,  &
!              lsc_droplet_number_in=lsc_droplet_number,&
                           r=r(:,:,:,1:ntp))
      endif ! (doing_donner)
     else ! (use_cloud_tracers_in_radiation)
       if (doing_donner .and. doing_uw_conv) then
           call cloud_spec (is, ie, js, je, lat,              &
                            z_half, z_full, Rad_time,   &
                            Atmos_input, Surface, Cld_spec,   &
                            Lsc_microphys, Meso_microphys,    &
                            Cell_microphys, Shallow_microphys, &
              lsc_area_in = lsc_cloud_area(is:ie,js:je,:),   &
              lsc_liquid_in=lsc_liquid(is:ie,js:je,:),  &
              lsc_ice_in=lsc_ice(is:ie,js:je,:),  &
               lsc_droplet_number_in=lsc_droplet_number(is:ie,js:je,:),&
              lsc_ice_number_in=lsc_ice_number(is:ie,js:je,:),&
     !snow, rain
              lsc_snow_in =  lsc_snow(is:ie,js:je,:) , &
              lsc_rain_in = lsc_rain(is:ie,js:je,:), &
              lsc_snow_size_in =  lsc_snow_size(is:ie,js:je,:),  &
              lsc_rain_size_in = lsc_rain_size(is:ie,js:je,:), &
                            r=r(:,:,:,1:ntp), &
             shallow_cloud_area = shallow_cloud_area(is:ie,js:je,:), &
             shallow_liquid = shallow_liquid(is:ie,js:je,:), &
             shallow_ice = shallow_ice(is:ie,js:je,:), &
             shallow_droplet_number = shallow_droplet_number(is:ie,js:je,:), &
             shallow_ice_number= shallow_ice_number(is:ie,js:je,:), &
             cell_cld_frac= cell_cld_frac(is:ie,js:je,:),  &
             cell_liq_amt=cell_liq_amt(is:ie,js:je,:), &
             cell_liq_size=cell_liq_size(is:ie,js:je,:), &
             cell_ice_amt= cell_ice_amt(is:ie,js:je,:),   &
             cell_ice_size= cell_ice_size(is:ie,js:je,:), &
             cell_droplet_number= cell_droplet_number(is:ie,js:je,:), &
             meso_cld_frac= meso_cld_frac(is:ie,js:je,:),   &
             meso_liq_amt=meso_liq_amt(is:ie,js:je,:), &
             meso_liq_size=meso_liq_size(is:ie,js:je,:), &
             meso_ice_amt= meso_ice_amt(is:ie,js:je,:),  &
             meso_ice_size= meso_ice_size(is:ie,js:je,:), &
             meso_droplet_number= meso_droplet_number(is:ie,js:je,:), &
             nsum_out=nsum_out(is:ie,js:je)  )
      else  if (doing_donner) then
          call cloud_spec (is, ie, js, je, lat,              &
                           z_half, z_full, Rad_time,   &
                           Atmos_input, Surface, Cld_spec,   &
                           Lsc_microphys, Meso_microphys,    &
                           Cell_microphys, Shallow_microphys, &
                       lsc_area_in = lsc_cloud_area(is:ie,js:je,:),   &
                lsc_liquid_in=lsc_liquid(is:ie,js:je,:), &
                lsc_ice_in=lsc_ice(is:ie,js:je,:),  &
               lsc_droplet_number_in=lsc_droplet_number(is:ie,js:je,:),&
               lsc_ice_number_in=lsc_ice_number(is:ie,js:je,:),&
      ! snow, rain
               lsc_snow_in =  lsc_snow(is:ie,js:je,:) , &
               lsc_rain_in = lsc_rain(is:ie,js:je,:), &
               lsc_snow_size_in =  lsc_snow_size(is:ie,js:je,:),  &
               lsc_rain_size_in = lsc_rain_size(is:ie,js:je,:), &
                           r=r(:,:,:,1:ntp), &
             cell_cld_frac= cell_cld_frac(is:ie,js:je,:), &
             cell_liq_amt=cell_liq_amt(is:ie,js:je,:), &
             cell_liq_size=cell_liq_size(is:ie,js:je,:), &
             cell_ice_amt= cell_ice_amt(is:ie,js:je,:),   &
             cell_ice_size= cell_ice_size(is:ie,js:je,:), &
             cell_droplet_number= cell_droplet_number(is:ie,js:je,:), &
             meso_cld_frac= meso_cld_frac(is:ie,js:je,:),   &
             meso_liq_amt=meso_liq_amt(is:ie,js:je,:), &
             meso_liq_size=meso_liq_size(is:ie,js:je,:), &
             meso_ice_amt= meso_ice_amt(is:ie,js:je,:),  &
             meso_ice_size= meso_ice_size(is:ie,js:je,:), &
             meso_droplet_number= meso_droplet_number(is:ie,js:je,:), &
             nsum_out=nsum_out(is:ie,js:je)  )
      else if (doing_uw_conv) then
          call cloud_spec (is, ie, js, je, lat,              &
                           z_half, z_full, Rad_time,   &
                           Atmos_input, Surface, Cld_spec,   &
                           Lsc_microphys, Meso_microphys,    &
                           Cell_microphys, Shallow_microphys, &
                lsc_area_in = lsc_cloud_area(is:ie,js:je,:),   &
              lsc_liquid_in=lsc_liquid(is:ie,js:je,:),  &
              lsc_ice_in=lsc_ice(is:ie,js:je,:),  &
              lsc_droplet_number_in=lsc_droplet_number(is:ie,js:je,:),&
              lsc_ice_number_in=lsc_ice_number(is:ie,js:je,:),&
      ! snow, rain
              lsc_snow_in =  lsc_snow(is:ie,js:je,:) , &
              lsc_rain_in = lsc_rain(is:ie,js:je,:), &
              lsc_snow_size_in =  lsc_snow_size(is:ie,js:je,:),  &
             lsc_rain_size_in = lsc_rain_size(is:ie,js:je,:), &
                           r=r(:,:,:,1:ntp), &
             shallow_cloud_area = shallow_cloud_area(is:ie,js:je,:), &
             shallow_liquid = shallow_liquid(is:ie,js:je,:), &
             shallow_ice = shallow_ice(is:ie,js:je,:), &
             shallow_droplet_number =   &
                                   shallow_droplet_number(is:ie,js:je,:), &
             shallow_ice_number= shallow_ice_number(is:ie,js:je,:) )
      else
          call cloud_spec (is, ie, js, je, lat,              &
                           z_half, z_full, Rad_time,   &
                           Atmos_input, Surface, Cld_spec,   &
                           Lsc_microphys, Meso_microphys,    &
                           Cell_microphys, Shallow_microphys, &
                       lsc_area_in = lsc_cloud_area(is:ie,js:je,:),   &
                     lsc_liquid_in=lsc_liquid(is:ie,js:je,:),  &
                     lsc_ice_in=lsc_ice(is:ie,js:je,:),  &
              lsc_droplet_number_in=lsc_droplet_number(is:ie,js:je,:),&
              lsc_ice_number_in=lsc_ice_number(is:ie,js:je,:),&
        ! snow, rain
              lsc_snow_in =  lsc_snow(is:ie,js:je,:) , &
              lsc_rain_in = lsc_rain(is:ie,js:je,:), &
              lsc_snow_size_in =  lsc_snow_size(is:ie,js:je,:),  &
              lsc_rain_size_in = lsc_rain_size(is:ie,js:je,:), &
                           r=r(:,:,:,1:ntp))
      endif ! (doing_donner)
      endif ! (use_cloud_tracers_in_radiation)
      endif ! (need_clouds)

!---------------------------------------------------------------------
!    if the radiative gases are needed, call define_radiative_gases to 
!    obtain the values to be used for the radiatively-active gases and 
!    place them in radiative_gases_type derived-type variable Rad_gases.
!---------------------------------------------------------------------
      if (need_gases) then

!--------------------------------------------------------------------
!    fill the contents of the radiative_gases_type variable which
!    will be passed to the radiation package. 
!---------------------------------------------------------------------
        Rad_gases%ch4_tf_offset = Rad_gases_tv%ch4_tf_offset
        Rad_gases%n2o_tf_offset = Rad_gases_tv%n2o_tf_offset
        Rad_gases%co2_tf_offset = Rad_gases_tv%co2_tf_offset
        Rad_gases%ch4_for_next_tf_calc = Rad_gases_tv%ch4_for_next_tf_calc
        Rad_gases%n2o_for_next_tf_calc = Rad_gases_tv%n2o_for_next_tf_calc
        Rad_gases%co2_for_next_tf_calc = Rad_gases_tv%co2_for_next_tf_calc
        Rad_gases%rrvch4  = Rad_gases_tv%rrvch4
        Rad_gases%rrvn2o  = Rad_gases_tv%rrvn2o
        Rad_gases%rrvf11  = Rad_gases_tv%rrvf11
        Rad_gases%rrvf12  = Rad_gases_tv%rrvf12
        Rad_gases%rrvf113 = Rad_gases_tv%rrvf113
        Rad_gases%rrvf22  = Rad_gases_tv%rrvf22
        Rad_gases%rrvco2  = Rad_gases_tv%rrvco2
        Rad_gases%time_varying_co2  = Rad_gases_tv%time_varying_co2
        Rad_gases%time_varying_ch4  = Rad_gases_tv%time_varying_ch4
        Rad_gases%time_varying_n2o  = Rad_gases_tv%time_varying_n2o
        Rad_gases%time_varying_f11  = Rad_gases_tv%time_varying_f11
        Rad_gases%time_varying_f12  = Rad_gases_tv%time_varying_f12
        Rad_gases%time_varying_f113 = Rad_gases_tv%time_varying_f113
        Rad_gases%time_varying_f22  = Rad_gases_tv%time_varying_f22
        Rad_gases%Co2_time = Rad_gases_tv%Co2_time
        Rad_gases%Ch4_time = Rad_gases_tv%Ch4_time
        Rad_gases%N2o_time = Rad_gases_tv%N2o_time
        Rad_gases%use_model_supplied_co2 = Rad_gases_tv%use_model_supplied_co2
  
        Rad_gases%co2_for_last_tf_calc = Rad_gases_tv%co2_for_last_tf_calc
        Rad_gases%ch4_for_last_tf_calc = Rad_gases_tv%ch4_for_last_tf_calc
        Rad_gases%n2o_for_last_tf_calc = Rad_gases_tv%n2o_for_last_tf_calc

        call define_radiative_gases (is, ie, js, je, Rad_time, lat, &
                                     Atmos_input, r, Time_next, Rad_gases)
      endif

!---------------------------------------------------------------------
!    allocate the components of a rad_output_type variable which will
!    be used to return the output from radiation_driver_mod that is
!    needed by other modules.
!---------------------------------------------------------------------
      allocate (Radiation%tdt_rad               (size(q,1), size(q,2),size(q,3),1))
      allocate (Radiation%ufsw                  (size(q,1), size(q,2),size(q,3)+1,1))
      allocate (Radiation%dfsw                  (size(q,1), size(q,2),size(q,3)+1,1))
      allocate (Radiation%ufsw_clr              (size(q,1), size(q,2),size(q,3)+1,1))
      allocate (Radiation%dfsw_clr              (size(q,1), size(q,2),size(q,3)+1,1))
      allocate (Radiation%flux_sw_surf          (size(q,1), size(q,2),1 ))
      allocate (Radiation%flux_sw_surf_dir      (size(q,1), size(q,2),1          ))
      allocate (Radiation%flux_sw_surf_dif      (size(q,1), size(q,2),1          ))
      allocate (Radiation%flux_sw_down_vis_dir  (size(q,1), size(q,2),1          ))
      allocate (Radiation%flux_sw_down_vis_dif  (size(q,1), size(q,2),1          ))
      allocate (Radiation%flux_sw_down_total_dir(size(q,1), size(q,2),1          ))
      allocate (Radiation%flux_sw_down_total_dif(size(q,1), size(q,2),1          ))
      allocate (Radiation%flux_sw_vis           (size(q,1), size(q,2),1          ))
      allocate (Radiation%flux_sw_vis_dir       (size(q,1), size(q,2),1          ))
      allocate (Radiation%flux_sw_vis_dif       (size(q,1), size(q,2),1          ))
      allocate (Radiation%flux_lw_surf          (size(q,1), size(q,2)          ))
      allocate (Radiation%coszen_angle          (size(q,1), size(q,2)          ))
      allocate (Radiation%tdtlw                 (size(q,1), size(q,2),size(q,3)))
      allocate (Radiation%flxnet                (size(q,1), size(q,2),size(q,3)+1))
      allocate (Radiation%flxnetcf              (size(q,1), size(q,2),size(q,3)+1))

!--------------------------------------------------------------------
!    call  radiation_driver to perform the radiation calculation.
!--------------------------------------------------------------------
      call radiation_driver (is, ie, js, je, Time, Time_next, lat,  &
                             lon, Surface, Atmos_input, Aerosol, r, &
                             Cld_spec, Rad_gases, Lsc_microphys, &
                             Meso_microphys, Cell_microphys,&
                             Shallow_microphys, Model_microphys, &
                             Radiation=Radiation, mask=mask, kbot=kbot)

!---------------------------------------------------------------------
!    if COSP is activated and this is a step upon which the cosp
!    simulator is to be called, verify that stochastic clouds are
!    also activated. if they are not, then exit, since COSP should only
!    be requested when stochastic clouds are active.
!---------------------------------------------------------------------
      if (do_cosp .or. do_modis_yim) then
        if (step_to_call_cosp) then
 
!---------------------------------------------------------------------
!    call return_cosp_inputs to retrieve the radiation inputs needed 
!    by COSP.
!---------------------------------------------------------------------
          call return_cosp_inputs        &
                (is, ie, js, je, donner_meso_is_largescale,  &
                 Time_next, Atmos_input, stoch_cloud_type, &
                 stoch_conc_drop, stoch_conc_ice, stoch_size_drop, &
                 stoch_size_ice, tau_stoch, lwem_stoch, &
                 Model_microphys, &
                 do_cosp, do_modis_yim, Lsc_microphys)
          mr_ozone(is:ie,js:je,:) = Rad_gases%qo3(:,:,:)
          where (Radiation%flux_sw_surf(:,:,1) > 0.0)
             daytime(is:ie,js:je) = 1.0
          elsewhere
             daytime(is:ie,js:je) = 0.0
          endwhere
!         daytime(is:ie,js:je) = 1.0
        endif ! (step_to_call_cosp)
      endif ! (do_cosp)

!-------------------------------------------------------------------
!    process the variables returned from radiation_driver_mod. the 
!    radiative heating rate is added to the accumulated physics heating
!    rate (tdt). net surface lw and sw fluxes and the cosine of the 
!    zenith angle are placed in locations where they can be exported
!    for use in other component models. the lw heating rate is stored
!    in a module variable for potential use in other physics modules.
!    the radiative heating rate is also added to a variable which is
!    accumulating the radiative and turbulent heating rates, and which
!    is needed by strat_cloud_mod.
!-------------------------------------------------------------------
      tdt     = tdt + Radiation%tdt_rad(:,:,:,1)
      flux_sw = Radiation%flux_sw_surf(:,:,1)
      flux_sw_dir            = Radiation%flux_sw_surf_dir(:,:,1)
      flux_sw_dif            = Radiation%flux_sw_surf_dif(:,:,1)
      flux_sw_down_vis_dir   = Radiation%flux_sw_down_vis_dir(:,:,1)
      flux_sw_down_vis_dif   = Radiation%flux_sw_down_vis_dif(:,:,1)
      flux_sw_down_total_dir = Radiation%flux_sw_down_total_dir(:,:,1)
      flux_sw_down_total_dif = Radiation%flux_sw_down_total_dif(:,:,1)
      flux_sw_vis            = Radiation%flux_sw_vis(:,:,1)
      flux_sw_vis_dir        = Radiation%flux_sw_vis_dir(:,:,1)
      flux_sw_vis_dif        = Radiation%flux_sw_vis_dif(:,:,1)
      flux_lw = Radiation%flux_lw_surf
      coszen  = Radiation%coszen_angle
      lw_tendency(is:ie,js:je,:) = Radiation%tdtlw(:,:,:)
      radturbten (is:ie,js:je,:) = radturbten(is:ie,js:je,:) + &
                                   Radiation%tdt_rad(:,:,:,1)

!--------------------------------------------------------------------
!    deallocate the arrays used to return the radiation_driver_mod 
!    output.
!--------------------------------------------------------------------
      deallocate ( Radiation%tdt_rad      )
      deallocate ( Radiation%ufsw         )
      deallocate ( Radiation%dfsw         )
      deallocate ( Radiation%ufsw_clr     )
      deallocate ( Radiation%dfsw_clr     )
      deallocate ( Radiation%flux_sw_surf )
      deallocate ( Radiation%flux_sw_surf_dir )
      deallocate ( Radiation%flux_sw_surf_dif )
      deallocate ( Radiation%flux_sw_down_vis_dir )
      deallocate ( Radiation%flux_sw_down_vis_dif )
      deallocate ( Radiation%flux_sw_down_total_dir )
      deallocate ( Radiation%flux_sw_down_total_dif )
      deallocate ( Radiation%flux_sw_vis )
      deallocate ( Radiation%flux_sw_vis_dir )
      deallocate ( Radiation%flux_sw_vis_dif )
      deallocate ( Radiation%flux_lw_surf )
      deallocate ( Radiation%coszen_angle )
      deallocate ( Radiation%tdtlw        )
      deallocate ( Radiation%flxnet       )
      deallocate ( Radiation%flxnetcf     )
 
!---------------------------------------------------------------------
!    call routines to deallocate the components of the derived type 
!    arrays input to radiation_driver.
!---------------------------------------------------------------------
      if (need_gases) then
        call radiative_gases_dealloc (Rad_gases)
      endif
      if (need_clouds) then
        call cloud_spec_dealloc (Cld_spec, Lsc_microphys,   &
                                 Meso_microphys, Cell_microphys, &
                                 Shallow_microphys)
      endif
      if (need_aerosols) then
        call aerosol_dealloc (Aerosol)
      endif
      if (need_basic) then
        call atmos_input_dealloc (Atmos_input)
        call microphys_dealloc (Model_microphys)
      endif
      call surface_dealloc (Surface)
      call mpp_clock_end ( radiation_clock )
      else
        flux_sw = 0.0
        flux_sw_dir = 0.0
        flux_sw_dif = 0.0
        flux_sw_down_vis_dir = 0.0
        flux_sw_down_vis_dif = 0.0
        flux_sw_down_total_dir = 0.0
        flux_sw_down_total_dif = 0.0
        flux_sw_vis = 0.0
        flux_sw_vis_dir = 0.0
        flux_sw_vis_dif = 0.0
        flux_lw = 0.0
        coszen  = 0.0
        lw_tendency(is:ie,js:je,:) = 0.0
      endif ! do_radiation

      if(do_grey_radiation) then !rif:(09/10/09) 
        call grey_radiation(is, js, Time, Time_next, lat, lon, phalfgrey, albedo, t_surf_rad, t, tdt, flux_sw, flux_lw)
        coszen = 1.0
        flux_sw_dir     = R1*flux_sw
        flux_sw_dif     = R2*flux_sw
        flux_sw_vis_dir = R3*flux_sw
        flux_sw_vis_dif = R4*flux_sw
      endif

#ifdef SCM
! Option to add SCM radiative tendencies from forcing to lw_tendency
! and radturbten

      if (use_scm_rad) then
        call add_scm_tdtlw( lw_tendency(is:ie,js:je,:) )
        call add_scm_tdtlw( radturbten (is:ie,js:je,:) )
        call add_scm_tdtsw( radturbten (is:ie,js:je,:) )
      endif

#endif

!----------------------------------------------------------------------
!    call damping_driver to calculate the various model dampings that
!    are desired. 
!----------------------------------------------------------------------
      z_pbl(:,:) = pbltop(is:ie,js:je) 
      call mpp_clock_begin ( damping_clock )
      call damping_driver (is, js, lat, Time_next, dt,           &
                           p_full, p_half, z_full, z_half,          &
                           um, vm, tm, qm, rm(:,:,:,1:ntp), &
                           udt, vdt, tdt, qdt, rdt,&
                           z_pbl , mask=mask, kbot=kbot)
     call mpp_clock_end ( damping_clock )

!---------------------------------------------------------------------
!    If moist_processes is not called in physics_driver_down then values
!    of convect must be passed in via the optional argument "moist_convect".
!---------------------------------------------------------------------
      if(.not.do_moist_processes) then
        if(present(moist_convect)) then
          convect(is:ie,js:je) = moist_convect
        else
          call error_mesg('physics_driver_down', &
          'moist_convect be present when do_moist_processes=.false.',FATAL) 
        endif
      endif

!---------------------------------------------------------------------
!    call vert_turb_driver to calculate diffusion coefficients. save
!    the planetary boundary layer height on return.
!---------------------------------------------------------------------

      if (id_tdt_phys_turb > 0) then
        used = send_data ( id_tdt_phys_turb, -2.0*tdt(:,:,:), &
                           Time_next, is, js, 1, rmask=mask )
      endif

      do n=1,nt
        if (id_tracer_phys_turb(n) > 0) then
          used = send_data ( id_tracer_phys_turb(n), -2.0*rdt(:,:,:,n), &
                             Time_next, is, js, 1, rmask=mask )
        endif
      end do

      call mpp_clock_begin ( turb_clock )
      call vert_turb_driver (is, js, Time, Time_next, dt,            &
                             lw_tendency(is:ie,js:je,:), frac_land,  &
                             p_half, p_full, z_half, z_full, u_star, &
                             b_star, q_star, rough_mom, lat,         &
                             convect(is:ie,js:je),                   &
                             u, v, t, q, r(:,:,:,1:ntp), um, vm,     &
                             tm, qm, rm(:,:,:,1:ntp),                &
                             udt, vdt, tdt, qdt, rdt,                &
                             diff_t_vert, diff_m_vert, gust, z_pbl,  &
                             mask=mask, kbot=kbot             )
     call mpp_clock_end ( turb_clock )
     pbltop(is:ie,js:je) = z_pbl(:,:)

      if (id_tdt_phys_turb > 0) then
        used = send_data ( id_tdt_phys_turb, +2.0*tdt(:,:,:), &
                           Time_next, is, js, 1, rmask=mask )
      endif

      do n=1,nt
        if (id_tracer_phys_turb(n) > 0) then
          used = send_data ( id_tracer_phys_turb(n), +2.0*rdt(:,:,:,n), &
                             Time_next, is, js, 1, rmask=mask )
        endif
      end do

!-----------------------------------------------------------------------
!    process any tracer fields.
!-----------------------------------------------------------------------
      call mpp_clock_begin ( tracer_clock )
      call atmos_tracer_driver (is, ie, js, je, Time, lon, lat,  &
                                area, z_pbl, rough_mom,         &
                                frac_open_sea,   &
                                frac_land, p_half, p_full,  &
                                u, v, t, q, r, &
                                rm, rdt, dt, &
                                u_star, b_star, q_star, &
                                z_half, z_full, t_surf_rad, albedo, &
                                Time_next, &
                                flux_sw_down_vis_dir, flux_sw_down_vis_dif, &  
                                mask, kbot)
      call mpp_clock_end ( tracer_clock )

!-----------------------------------------------------------------------
!    If moist_processes is not called in physics_driver_down then values
!    of the cu_mo_trans diffusion coefficients must be passed in via
!    the optional argument "diff_cum_mom".
!-----------------------------------------------------------------------
      if(.not.do_moist_processes) then
        if(present(diff_cum_mom)) then
          diff_cu_mo(is:ie,js:je,:) = diff_cum_mom          
        else
          call error_mesg('physics_driver_down', &
          'diff_cum_mom must be present when do_moist_processes=.false.',FATAL)
        endif
      endif

!-----------------------------------------------------------------------
!    optionally use an implicit calculation of the vertical diffusion 
!    coefficients.
!
!    the vertical diffusion coefficients are solved using an implicit
!    solution to the following equation:
!
!    dK/dt   = - ( K - K_cur) / tau_diff
!
!    where K         = diffusion coefficient
!          K_cur     = diffusion coefficient diagnosed from current 
!                      time steps' state
!          tau_diff  = time scale for adjustment
!
!    in the code below alpha = dt / tau_diff
!---------------------------------------------------------------------
      if (diffusion_smooth) then
        call get_time (Time_next - Time, sec, day)
        dt2 = real(sec + day*86400)
        alpha = dt2/tau_diff
        diff_m(is:ie,js:je,:) = (diff_m(is:ie,js:je,:) +       &
                                 alpha*(diff_m_vert(:,:,:) +  &
                                 diff_cu_mo(is:ie,js:je,:)) )/&
                                 (1. + alpha)
        where (diff_m(is:ie,js:je,:) < diff_min)
          diff_m(is:ie,js:je,:) = 0.0
        end where
        diff_t(is:ie,js:je,:) = (diff_t(is:ie,js:je,:) +      &
                                 alpha*diff_t_vert(:,:,:) )/  &
                                 (1. + alpha)
        where (diff_t(is:ie,js:je,:) < diff_min)
          diff_t(is:ie,js:je,:) = 0.0
        end where
      else
        diff_t(is:ie,js:je,:) = diff_t_vert
        diff_m(is:ie,js:je,:) = diff_m_vert + diff_cu_mo(is:ie, js:je,:)
      end if

!-----------------------------------------------------------------------
!    call vert_diff_driver_down to calculate the first pass atmos-
!    pheric vertical diffusion.
!-----------------------------------------------------------------------

      if (id_tdt_phys_vdif_dn > 0) then
        used = send_data ( id_tdt_phys_vdif_dn, -2.0*tdt(:,:,:), &
                           Time_next, is, js, 1, rmask=mask )
      endif

      do n=1,nt
        if (id_tracer_phys_vdif_dn(n) > 0) then
          used = send_data ( id_tracer_phys_vdif_dn(n), -2.0*rdt(:,:,:,n), &
                             Time_next, is, js, 1, rmask=mask )
        endif
      end do

      call mpp_clock_begin ( diff_down_clock )
      radturbten(is:ie,js:je,:) = radturbten(is:ie,js:je,:) - tdt(:,:,:)
      if ( allocated(diff_t_clubb) ) then  !RASF Bug fix. Can only pass bounds of diff_t_clubb when allocated
         call vert_diff_driver_down (is, js, Time_next, dt, p_half,   &
                                  p_full, z_full,   &
                                  diff_m(is:ie,js:je,:),         &
                                  diff_t(is:ie,js:je,:),         &
                                  um ,vm ,tm ,qm ,rm(:,:,:,1:ntp), &
                                  dtau_du, dtau_dv, tau_x, tau_y,  &
                                  udt, vdt, tdt, qdt, rdt,       &
                                  Surf_diff,                     &
                                  diff_t_clubb=diff_t_clubb(is:ie,js:je,:),   &   ! cjg
                                  mask=mask, kbot=kbot           )
     else
        call vert_diff_driver_down (is, js, Time_next, dt, p_half,   &
                                  p_full, z_full,   &
                                  diff_m(is:ie,js:je,:),         &
                                  diff_t(is:ie,js:je,:),         &
                                  um ,vm ,tm ,qm ,rm(:,:,:,1:ntp), &
                                  dtau_du, dtau_dv, tau_x, tau_y,  &
                                  udt, vdt, tdt, qdt, rdt,       &
                                  Surf_diff,                     &
                                  diff_t_clubb=diff_t_clubb,   &   ! RASF
                                  mask=mask, kbot=kbot           )
      endif

      if (id_tdt_phys_vdif_dn > 0) then
        used = send_data ( id_tdt_phys_vdif_dn, +2.0*tdt(:,:,:), &
                           Time_next, is, js, 1, rmask=mask )
      endif

      do n=1,nt
        if (id_tracer_phys_vdif_dn(n) > 0) then
          used = send_data ( id_tracer_phys_vdif_dn(n), +2.0*rdt(:,:,:,n), &
                             Time_next, is, js, 1, rmask=mask )
        endif
      end do

!---------------------------------------------------------------------
!    if desired, return diff_m and diff_t to calling routine.
!-----------------------------------------------------------------------
      if (present(difft)) then
        difft = diff_t(is:ie,js:je,:)
      endif
      if (present(diffm)) then
        diffm = diff_m(is:ie,js:je,:)
      endif

     call mpp_clock_end ( diff_down_clock )

 end subroutine physics_driver_down



!#######################################################################
! <SUBROUTINE NAME="physics_driver_up">
!  <OVERVIEW>
!    physics_driver_up completes the calculation of vertical diffusion 
!    and also handles moist physical processes.
!  </OVERVIEW>
!  <DESCRIPTION>
!    physics_driver_up completes the calculation of vertical diffusion 
!    and also handles moist physical processes.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call physics_driver_up (is, ie, js, je,                    &
!                               Time_prev, Time, Time_next,        &
!                               lat, lon, area,                    &
!                               p_half, p_full, z_half, z_full,    & 
!                               omega,                             &
!                               u, v, t, q, r, um, vm, tm, qm, rm, &
!                               frac_land,                         &
!                               udt, vdt, tdt, qdt, rdt,           &
!                               Surf_diff,                         &
!                               lprec,   fprec, gust,              &
!                               mask, kbot    )
!  </TEMPLATE>
!  <IN NAME="Time_prev" TYPE="time_type">
!   previous time, for variable um, vm, tm, qm, rm
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!   current time
!  </IN>
!  <IN NAME="Time_next" TYPE="time_type">
!   next time, used for diagnostics
!  </IN>
!  <IN NAME="lat" TYPE="real">
!   array of model latitudes at model points [radians]
!  </IN>
!  <IN NAME="lon" TYPE="real">
!   array of model longitudes at model points [radians]
!  </IN>
!  <IN NAME="area" TYPE="real">
!   grid box area - current not used
!  </IN>
!  <IN NAME="p_half" TYPE="real">
!   pressure at model interface levels (offset from t,q,u,v,r)
!  </IN>
!  <IN NAME="p_full" TPYE="real">
!   pressure at full levels
!  </IN>
!  <IN NAME="z_half" TYPE="real">
!   height at model interface levels
!  </IN>
!  <IN NAME="z_full" TPYE="real">
!   height at full levels
!  </IN>
!  <IN NAME="omega" TYPE="real">
!   Veritical pressure tendency
!  </IN>
!  <IN NAME="u" TYPE="real">
!   zonal wind at current time step
!  </IN>
!  <IN NAME="v" TYPE="real">
!   meridional wind at current time step
!  </IN>
!  <IN NAME="t" TYPE="real">
!   temperature at current time step
!  </IN>
!  <IN NAME="q" TYPE="real">
!   specific humidity at current time step
!  </IN>
!  <IN NAME="r" TPYE="real">
!   multiple 3d tracer fields at current time step
!  </IN>
!  <IN NAME="um" TYPE="real">
!   zonal wind at previous time step
!  </IN>
!  <IN NAME="vm" TYPE="real">
!   meridional wind at previous time step
!  </IN>
!  <IN NAME="tm" TYPE="real">
!   temperature at previous time step
!  </IN>
!  <IN NAME="qm" TYPE="real">
!   specific humidity at previous time step
!  </IN>
!  <IN NAME="rm" TPYE="real">
!   multiple 3d tracer fields at previous time step
!  </IN>
!  <IN NAME="frac_land" TYPE="real">
!   fraction of land coverage in a model grid point
!  </IN>
!  <INOUT NAME="udt" TYPE="real">
!   zonal wind tendency
!  </INOUT>
!  <INOUT NAME="vdt" TYPE="real">
!   meridional wind tendency
!  </INOUT>
!  <INOUT NAME="tdt" TYPE="real">
!   temperature tendency
!  </INOUT>
!  <INOUT NAME="qdt" TYPE="real">
!   moisture tracer tendencies
!  </INOUT>
!  <INOUT NAME="rdt" TYPE="real">
!   multiple tracer tendencies
!  </INOUT>
!  <OUT NAME="lprec" TYPE="real">
!  </OUT>
!  <OUT NAME="fprec" TYPE="real">
!  </OUT>
!  <OUT NAME="gust" TYPE="real">
!  </OUT>
!  <INOUT NAME="Surf_diff" TYPE="surface_diffusion_type">
!   Surface diffusion 
!  </INOUT>
!  <IN NAME="kbot" TYPE="integer">
!   OPTIONAL: present when running eta vertical coordinate,
!                        index of lowest model level above ground
!  </IN>
!  <IN NAME="mask" TYPE="real">
!   OPTIONAL: present when running eta vertical coordinate,
!                        mask to remove points below ground
!  </IN>
! </SUBROUTINE>
!
 subroutine physics_driver_up (is, ie, js, je,                    &
                               Time_prev, Time, Time_next,        &
                               lat, lon, area,                    &
                               p_half, p_full, z_half, z_full,    &
                               omega,                             &
                               u, v, t, q, r, um, vm, tm, qm, rm, &
                               frac_land,                         &
                               u_star, b_star, q_star,            &
                               udt, vdt, tdt, qdt, rdt,           &
                               Surf_diff,                         &
                               lprec,   fprec, gust,              &
                               mask, kbot,                        &
                               hydrostatic, phys_hydrostatic      )

!----------------------------------------------------------------------
!    physics_driver_up completes the calculation of vertical diffusion 
!    and also handles moist physical processes.
!---------------------------------------------------------------------

integer,                intent(in)             :: is, ie, js, je
type(time_type),        intent(in)             :: Time_prev, Time,   &
                                                  Time_next
real,dimension(:,:),    intent(in)             :: lat, lon, area
real,dimension(:,:,:),  intent(in)             :: p_half, p_full,   &
                                                  omega,  &
                                                  z_half, z_full,     &
                                                  u , v , t , q ,    &
                                                  um, vm, tm, qm
real,dimension(:,:,:,:),intent(inout)          :: r,rm       ! cjg: inout
real,dimension(:,:),    intent(in)             :: frac_land
real,dimension(:,:),    intent(in)             :: u_star, b_star, q_star
real,dimension(:,:,:),  intent(inout)          :: udt,vdt,tdt,qdt
real,dimension(:,:,:,:),intent(inout)          :: rdt
type(surf_diff_type),   intent(inout)          :: Surf_diff
real,dimension(:,:),    intent(out)            :: lprec, fprec
real,dimension(:,:),    intent(inout)          :: gust
real,dimension(:,:,:),  intent(in),   optional :: mask
integer,dimension(:,:), intent(in),   optional :: kbot
logical,                intent(in),   optional :: hydrostatic, phys_hydrostatic

!-----------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je    starting/ending subdomain i,j indices of data in 
!                     the physics_window being integrated
!      Time_prev      previous time, for variables um,vm,tm,qm,rm 
!                     (time_type)
!      Time           current time, for variables u,v,t,q,r  (time_type)
!      Time_next      next time, used for diagnostics   (time_type)
!      lat            latitude of model points [ radians ]
!      lon            longitude of model points [ radians ]
!      area           grid box area - currently not used [ m**2 ]
!      p_half         pressure at half levels (offset from t,q,u,v,r)
!                     [ Pa ]
!      p_full         pressure at full levels [ Pa }
!      omega
!      z_half         height at half levels [ m ]
!      z_full         height at full levels [ m ]
!      u              zonal wind at current time step [ m / s ]
!      v              meridional wind at current time step [ m / s ]
!      t              temperature at current time step [ deg k ]
!      q              specific humidity at current time step  kg / kg ]
!      r              multiple 3d tracer fields at current time step
!      um,vm          zonal and meridional wind at previous time step
!      tm,qm          temperature and specific humidity at previous 
!                     time step
!      rm             multiple 3d tracer fields at previous time step
!      frac_land
!      rough_mom
!      albedo
!      t_surf_rad
!      u_star
!      b_star
!      q_star
!      dtau_du
!      dtau_dv
!
!  intent(inout) variables:
!
!      tau_x
!      tau_y
!      udt            zonal wind tendency [ m / s**2 ]
!      vdt            meridional wind tendency [ m / s**2 ]
!      tdt            temperature tendency [ deg k / sec ]
!      qdt            specific humidity tendency 
!                     [  kg vapor / kg air / sec ]
!      rdt            multiple tracer tendencies [ unit / unit / sec ]
!      Surf_diff      surface_diffusion_type variable
!      gust
!
!   intent(out) variables:
!
!      lprec     
!      fprec       
!
!   intent(in), optional variables:
!
!       mask        mask that designates which levels do not have data
!                   present (i.e., below ground); 0.=no data, 1.=data
!       kbot        lowest level which has data
!                   note:  both mask and kbot must be present together.
!
!--------------------------------------------------------------------
 
!--------------------------------------------------------------------
!   local variables:

      real, dimension(size(u,1), size(u,2), size(u,3)) :: diff_cu_mo_loc
      real, dimension(size(u,1), size(u,2))            :: gust_cv
      real, dimension(size(u,1), size(u,2))            :: land_mask
      integer :: sec, day
      real    :: dt
      real, dimension(size(t,1), size(t,2)) :: u_sfc, v_sfc
      real, dimension(size(t,1), size(t,2), size(t,3)+1) :: pflux
      real, dimension(size(t,1), size(t,2), size(t,3))   ::  &
                             tca, cca, rhoi, lsliq, lsice, ccliq,  &
                             ccice, reff_lsclliq, reff_lsclice, &
                             reff_ccclliq, reff_ccclice, &
                             reff_lsprliq, reff_lsprice, &
                             reff_ccprliq, reff_ccprice, &
                             fl_lsrain_loc, fl_lssnow_loc,  &
                             fl_lsgrpl_loc, &
                             fl_donmca_rain_loc, fl_donmca_snow_loc, &
                             fl_ccrain_loc, fl_ccsnow_loc, mr_ozone_loc
      real, dimension(size(t,1), size(t,2), size(t,3), ncol) ::  &
                             stoch_mr_liq, stoch_mr_ice, &
                             stoch_size_liq, stoch_size_frz
      integer :: i, j , k, n
      integer :: nls, ncc
      real    :: alphb
      integer :: flag_ls, flag_cc
      integer :: kmax
      logical :: used

! ---> h1g, 2012-08-28,  
! save the temperature and moisture tendencies from sensible and latent heat fluxes
  real, dimension(size(t,1), size(t,2))  ::   tdt_shf,  qdt_lhf
! <--- h1g, 2012-08-28

!---------------------------------------------------------------------
!   local variables:
!
!        diff_cu_mo_loc   diffusion coefficient contribution due to 
!                         cumulus momentum transport
!        gust_cv
!        sec, day         second and day components of the time_type 
!                         variable
!        dt               physics time step [ seconds ]
!
!---------------------------------------------------------------------
      type(aerosol_type)                               :: Aerosol

!---------------------------------------------------------------------
!    verify that the module is initialized.
!---------------------------------------------------------------------
      if ( .not. module_is_initialized) then
        call error_mesg ('physics_driver_mod',  &
             'module has not been initialized', FATAL)
      endif

!----------------------------------------------------------------------
!    define number of model layers.
!----------------------------------------------------------------------
      kmax = size(u,3)

!----------------------------------------------------------------------
!    compute the physics time step (from tau-1 to tau+1).
!---------------------------------------------------------------------
      call get_time (Time_next-Time_prev, sec, day)
      dt = real(sec+day*86400)

!------------------------------------------------------------------
!    call vert_diff_driver_up to complete the vertical diffusion
!    calculation.
!------------------------------------------------------------------

      if (id_tdt_phys_vdif_up > 0) then
        used = send_data ( id_tdt_phys_vdif_up, -2.0*tdt(:,:,:), &
                           Time_next, is, js, 1, rmask=mask )
      endif

      do n=1,nt
        if (id_tracer_phys_vdif_up(n) > 0) then
          used = send_data ( id_tracer_phys_vdif_up(n), -2.0*rdt(:,:,:,n), &
                             Time_next, is, js, 1, rmask=mask )
        endif
      end do

! ---> h1g, 2012-08-28, save temperature and moisture tendencies due to surface fluxes at lowest-level
      if( .not. l_host_applies_sfc_fluxes ) then
          tdt_shf(:,:) = tdt(:, :, kmax)
          qdt_lhf(:,:) = qdt(:, :, kmax)
      endif
! <--- h1g, 2012-08-28

      call mpp_clock_begin ( diff_up_clock )
      call vert_diff_driver_up (is, js, Time_next, dt, p_half,   &
                                Surf_diff, tdt, qdt, rdt, mask=mask,  &
                                kbot=kbot)

! ---> h1g, 2012-08-28, save temperature and moisture tendencies due to surface fluxes at lowest-level
      if( .not. l_host_applies_sfc_fluxes ) then
          tdt_shf(:,:) = tdt(:, :, kmax) - tdt_shf(:,:)
          qdt_lhf(:,:) = qdt(:, :, kmax) - qdt_lhf(:,:)

          tdt(:, :, kmax) = tdt(:, :, kmax) - tdt_shf(:,:)
          qdt(:, :, kmax) = qdt(:, :, kmax) - qdt_lhf(:,:)
      endif
! <--- h1g, 2012-08-28

      radturbten(is:ie,js:je,:) = radturbten(is:ie,js:je,:) + tdt(:,:,:)
      call mpp_clock_end ( diff_up_clock )

      if (id_tdt_phys_vdif_up > 0) then
        used = send_data ( id_tdt_phys_vdif_up, +2.0*tdt(:,:,:), &
                           Time_next, is, js, 1, rmask=mask )
      endif

      do n=1,nt
        if (id_tracer_phys_vdif_up(n) > 0) then
          used = send_data ( id_tracer_phys_vdif_up(n), +2.0*rdt(:,:,:,n), &
                             Time_next, is, js, 1, rmask=mask )
        endif
      end do

!-----------------------------------------------------------------------
!    if the fms integration path is being followed, call moist processes
!    to compute moist physics, including convection and processes 
!    involving condenstion.
!-----------------------------------------------------------------------
      if (do_moist_processes) then

        if (id_tdt_phys_moist > 0) then
          used = send_data ( id_tdt_phys_moist, -2.0*tdt(:,:,:), &
                             Time_next, is, js, 1, rmask=mask )
        endif

        do n=1,nt
          if (id_tracer_phys_moist(n) > 0) then
            used = send_data ( id_tracer_phys_moist(n), -2.0*rdt(:,:,:,n), &
                               Time_next, is, js, 1, rmask=mask )
          endif
        end do

        call mpp_clock_begin ( moist_processes_clock )

!-----------------------------------------------------------------------
        if (.NOT. do_grey_radiation) then !rif:(09/02/09) to avoid a call to Aerosol when using do_grey_radiation
!       Get aerosol mass concentrations
        pflux(:,:,1) = 0.0E+00
        do i=2,size(p_full,3)
          pflux(:,:,i) = 0.5E+00*(p_full(:,:,i-1) + p_full(:,:,i))
        end do
	pflux(:,:,size(p_full,3)+1) = p_full(:,:,size(p_full,3)) 
        call aerosol_driver (is, js, Time, r, &
                             p_half, pflux, &
                             Aerosol, override_aerosols_cloud)
        end if
!--------------------------------------------------------------------
!    on steps on which the cosp simulator is called, move the values
!    of precip flux saved on the previous step so they will not be 
!    overwritten on the upcoming call to moist_processes.
!--------------------------------------------------------------------
        if (do_cosp) then
          if (step_to_call_cosp) then
            fl_lsrain_loc(:,:,:) = fl_lsrain(is:ie,js:je,:)
            fl_lssnow_loc(:,:,:) = fl_lssnow(is:ie,js:je,:)
            fl_lsgrpl_loc(:,:,:) = fl_lsgrpl(is:ie,js:je,:)
            fl_ccrain_loc(:,:,:) = fl_ccrain(is:ie,js:je,:)
            fl_ccsnow_loc(:,:,:) = fl_ccsnow(is:ie,js:je,:)
            fl_donmca_rain_loc(:,:,:) = fl_donmca_rain(is:ie,js:je,:)
            fl_donmca_snow_loc(:,:,:) = fl_donmca_snow(is:ie,js:je,:)
            mr_ozone_loc(:,:,:)  = mr_ozone (is:ie,js:je,:)
          endif
        endif

       if (doing_donner .and. doing_uw_conv) then
         call moist_processes (is, ie, js, je, Time_next, dt, &
           frac_land, p_half, p_full, z_half, z_full, omega,    &
           diff_t(is:ie,js:je,:), radturbten(is:ie,js:je,:),    &
           cush(is:ie,js:je), cbmf(is:ie,js:je),   &!miz
           pbltop(is:ie,js:je), u_star, b_star, q_star,  &!miz
           t, q, r, u, v, tm, qm, rm, um, vm, tdt, qdt, rdt, udt, &
           vdt, diff_cu_mo_loc, convect(is:ie,js:je), lprec, &
           fprec, fl_lsrain(is:ie,js:je,:), fl_lssnow(is:ie,js:je,:),  &
           fl_ccrain(is:ie,js:je,:), fl_ccsnow(is:ie,js:je,:),    &
           fl_donmca_rain(is:ie,js:je,:), fl_donmca_snow(is:ie,js:je,:), &
           gust_cv, area, lon, lat, lsc_cloud_area(is:ie,js:je,:),  &
           lsc_liquid(is:ie,js:je,:), lsc_ice(is:ie,js:je,:), &
           lsc_droplet_number(is:ie,js:je,:),   &
           lsc_ice_number(is:ie,js:je,:), &
      ! snow, rain
           lsc_snow(is:ie,js:je,:) , &
           lsc_rain(is:ie,js:je,:), &
           lsc_snow_size(is:ie,js:je,:),  &
           lsc_rain_size(is:ie,js:je,:), &
#ifdef CLUBB
! ---> h1g
           dcond_ls_liquid=dcond_ls_liquid,  dcond_ls_ice=dcond_ls_ice,  &
           Ndrop_act_CLUBB=Ndrop_act_CLUBB,  Icedrop_act_CLUBB=Icedrop_act_CLUBB,  &
           ndust=ndust, rbar_dust= rbar_dust, &
           diff_t_clubb   =diff_t_clubb,                                           &
           tdt_shf = tdt_shf,                                                      &
           qdt_lhf = qdt_lhf,                                                      &
! <--- h1g
#endif
           Aerosol=Aerosol, mask=mask,  &
           kbot=kbot, shallow_cloud_area=shallow_cloud_area(is:ie,js:je,:), &
           shallow_liquid=shallow_liquid(is:ie,js:je,:), &
           shallow_ice= shallow_ice(is:ie,js:je,:),   &
           shallow_droplet_number= shallow_droplet_number(is:ie,js:je,:), &
           shallow_ice_number= shallow_ice_number(is:ie,js:je,:), &
           cell_cld_frac= cell_cld_frac(is:ie,js:je,:), &
           cell_liq_amt=cell_liq_amt(is:ie,js:je,:), &
           cell_liq_size=cell_liq_size(is:ie,js:je,:), &
           cell_ice_amt= cell_ice_amt(is:ie,js:je,:),     &
           cell_ice_size= cell_ice_size(is:ie,js:je,:),   &
           cell_droplet_number= cell_droplet_number(is:ie,js:je,:), &
           meso_cld_frac= meso_cld_frac(is:ie,js:je,:),   &
           meso_liq_amt=meso_liq_amt(is:ie,js:je,:), &
           meso_liq_size=meso_liq_size(is:ie,js:je,:), &
           meso_ice_amt= meso_ice_amt(is:ie,js:je,:),  &
           meso_ice_size= meso_ice_size(is:ie,js:je,:),  &
           meso_droplet_number= meso_droplet_number(is:ie,js:je,:), &
           nsum_out=nsum_out(is:ie,js:je),    &
           hydrostatic=hydrostatic, phys_hydrostatic=phys_hydrostatic  )
       else if (doing_donner) then
        call moist_processes (is, ie, js, je, Time_next, dt, frac_land, &
                           p_half, p_full, z_half, z_full, omega,    &
                           diff_t(is:ie,js:je,:),                    &
                           radturbten(is:ie,js:je,:),                &
                           cush           (is:ie,js:je),             &
                          cbmf           (is:ie,js:je),             &
                            pbltop(is:ie,js:je),         &!miz
                            u_star, b_star, q_star,          &!miz
                           t, q, r, u, v, tm, qm, rm, um, vm,        &
                           tdt, qdt, rdt, udt, vdt, diff_cu_mo_loc , &
                           convect(is:ie,js:je), lprec, fprec,       &
            fl_lsrain(is:ie,js:je,:), fl_lssnow(is:ie,js:je,:),  &
            fl_ccrain(is:ie,js:je,:), fl_ccsnow(is:ie,js:je,:),    &
            fl_donmca_rain(is:ie,js:je,:), fl_donmca_snow(is:ie,js:je,:), &
                           gust_cv, area, lon, lat,  &
                           lsc_cloud_area(is:ie,js:je,:), &
                           lsc_liquid(is:ie,js:je,:), &
                           lsc_ice(is:ie,js:je,:), &
                           lsc_droplet_number(is:ie,js:je,:), &
                           lsc_ice_number(is:ie,js:je,:), &
                 ! snow, rain
                           lsc_snow(is:ie,js:je,:) , &
                           lsc_rain(is:ie,js:je,:), &
                           lsc_snow_size(is:ie,js:je,:),  &
                           lsc_rain_size(is:ie,js:je,:), &
#ifdef CLUBB
! ---> h1g
                           dcond_ls_liquid=dcond_ls_liquid,  dcond_ls_ice=dcond_ls_ice,  &
                           Ndrop_act_CLUBB=Ndrop_act_CLUBB,  Icedrop_act_CLUBB=Icedrop_act_CLUBB,  &
                           ndust=ndust, rbar_dust= rbar_dust, &
                           diff_t_clubb   =diff_t_clubb,                                           &
                           tdt_shf = tdt_shf,                                                      &
                           qdt_lhf = qdt_lhf,                                                      &
! <--- h1g
#endif
                           Aerosol=Aerosol, mask=mask, kbot=kbot, &
                           cell_cld_frac= cell_cld_frac(is:ie,js:je,:), &
                           cell_liq_amt=cell_liq_amt(is:ie,js:je,:), &
                           cell_liq_size=cell_liq_size(is:ie,js:je,:), &
                           cell_ice_amt= cell_ice_amt(is:ie,js:je,:),   &
                           cell_ice_size= cell_ice_size(is:ie,js:je,:), &
              cell_droplet_number= cell_droplet_number(is:ie,js:je,:), &
                           meso_cld_frac= meso_cld_frac(is:ie,js:je,:), &
                           meso_liq_amt=meso_liq_amt(is:ie,js:je,:), &
                           meso_liq_size=meso_liq_size(is:ie,js:je,:), &
                           meso_ice_amt= meso_ice_amt(is:ie,js:je,:),  &
                           meso_ice_size= meso_ice_size(is:ie,js:je,:), &
              meso_droplet_number= meso_droplet_number(is:ie,js:je,:), &
                           nsum_out=nsum_out(is:ie,js:je),    &
           hydrostatic=hydrostatic, phys_hydrostatic=phys_hydrostatic  )
                          
       else if (doing_uw_conv) then
        call moist_processes (is, ie, js, je, Time_next, dt, frac_land,         &
                            p_half, p_full, z_half, z_full, omega,    &
                            diff_t(is:ie,js:je,:),                    &
                            radturbten(is:ie,js:je,:),                &
                            cush           (is:ie,js:je),             &!
                          cbmf           (is:ie,js:je),             &!
                            pbltop(is:ie,js:je),         &!miz
                            u_star, b_star, q_star,          &!miz
                            t, q, r, u, v, tm, qm, rm, um, vm,        &
                            tdt, qdt, rdt, udt, vdt, diff_cu_mo_loc , &
                            convect(is:ie,js:je), lprec, fprec,       &
               fl_lsrain(is:ie,js:je,:), fl_lssnow(is:ie,js:je,:),  &
               fl_ccrain(is:ie,js:je,:), fl_ccsnow(is:ie,js:je,:),    &
           fl_donmca_rain(is:ie,js:je,:), fl_donmca_snow(is:ie,js:je,:), &
                            gust_cv, area, lon, lat,   &
                           lsc_cloud_area(is:ie,js:je,:),  &
                           lsc_liquid(is:ie,js:je,:),  &
                           lsc_ice(is:ie,js:je,:), &
                           lsc_droplet_number(is:ie,js:je,:), &
                           lsc_ice_number(is:ie,js:je,:), &
                 ! snow, rain
                           lsc_snow(is:ie,js:je,:) , &
                           lsc_rain(is:ie,js:je,:), &
                           lsc_snow_size(is:ie,js:je,:),  &
                           lsc_rain_size(is:ie,js:je,:), &
#ifdef CLUBB
! ---> h1g
                           dcond_ls_liquid=dcond_ls_liquid,  dcond_ls_ice=dcond_ls_ice,  &
                           Ndrop_act_CLUBB=Ndrop_act_CLUBB,  Icedrop_act_CLUBB=Icedrop_act_CLUBB,  &
                           ndust=ndust, rbar_dust= rbar_dust, &
                           diff_t_clubb   =diff_t_clubb,                                           &
                           tdt_shf = tdt_shf,                                                      &
                           qdt_lhf = qdt_lhf,                                                      &
! <--- h1g
#endif
                           Aerosol=Aerosol, mask=mask, kbot=        kbot,  &
                  shallow_cloud_area= shallow_cloud_area(is:ie,js:je,:), &
                  shallow_liquid=shallow_liquid(is:ie,js:je,:),  &
                  shallow_ice= shallow_ice(is:ie,js:je,:),   &
                  shallow_droplet_number=    &
                                shallow_droplet_number(is:ie,js:je,:),    &
                  shallow_ice_number = shallow_ice_number(is:ie,js:je,:), &
                           hydrostatic=hydrostatic, phys_hydrostatic=phys_hydrostatic  )
       else
        call moist_processes (is, ie, js, je, Time_next, dt, frac_land, &
                           p_half, p_full, z_half, z_full, omega,    &
                           diff_t(is:ie,js:je,:),                    &
                           radturbten(is:ie,js:je,:),                &
                           cush           (is:ie,js:je),          &!
                        cbmf           (is:ie,js:je),             &!
                            pbltop(is:ie,js:je),         &!miz
                            u_star, b_star, q_star,          &!miz
                           t, q, r, u, v, tm, qm, rm, um, vm,        &
                           tdt, qdt, rdt, udt, vdt, diff_cu_mo_loc , &
                           convect(is:ie,js:je), lprec, fprec,       &
               fl_lsrain(is:ie,js:je,:), fl_lssnow(is:ie,js:je,:),  &
               fl_ccrain(is:ie,js:je,:), fl_ccsnow(is:ie,js:je,:),    &
           fl_donmca_rain(is:ie,js:je,:), fl_donmca_snow(is:ie,js:je,:), &
                           gust_cv, area, lon, lat,   &
                           lsc_cloud_area(is:ie,js:je,:),  &
                           lsc_liquid(is:ie,js:je,:),  &
                           lsc_ice(is:ie,js:je,:), &
                           lsc_droplet_number(is:ie,js:je,:), &
                           lsc_ice_number(is:ie,js:je,:), &
             ! snow, rain
                           lsc_snow(is:ie,js:je,:) , &
                           lsc_rain(is:ie,js:je,:), &
                           lsc_snow_size(is:ie,js:je,:),  &
                           lsc_rain_size(is:ie,js:je,:), &
#ifdef CLUBB
! ---> h1g
                           dcond_ls_liquid=dcond_ls_liquid,  dcond_ls_ice=dcond_ls_ice,  &
                           Ndrop_act_CLUBB=Ndrop_act_CLUBB,  Icedrop_act_CLUBB=Icedrop_act_CLUBB,  &
                           ndust=ndust, rbar_dust= rbar_dust, &
                           diff_t_clubb   =diff_t_clubb,                                           &
                           tdt_shf = tdt_shf,                                                      &
                           qdt_lhf = qdt_lhf,                                                      &
! <--- h1g
#endif
                           Aerosol=Aerosol, mask=mask, kbot=kbot,    &
                           hydrostatic=hydrostatic, phys_hydrostatic=phys_hydrostatic  )
        endif
        call mpp_clock_end ( moist_processes_clock )
        diff_cu_mo(is:ie, js:je,:) = diff_cu_mo_loc(:,:,:)
        radturbten(is:ie,js:je,:) = 0.0

!---------------------------------------------------------------------
!    add the convective gustiness effect to that previously obtained 
!    from non-convective parameterizations.
!---------------------------------------------------------------------
        gust = sqrt( gust*gust + gust_cv*gust_cv)

        if (id_tdt_phys_moist > 0) then
          used = send_data ( id_tdt_phys_moist, +2.0*tdt(:,:,:), &
                             Time_next, is, js, 1, rmask=mask )
        endif

        do n=1,nt
          if (id_tracer_phys_moist(n) > 0) then
            used = send_data ( id_tracer_phys_moist(n), +2.0*rdt(:,:,:,n), &
                               Time_next, is, js, 1, rmask=mask )
          endif
        end do

        if (id_tdt_phys > 0) then
           used = send_data ( id_tdt_phys, tdt(:,:,:), &
                              Time_next, is, js, 1, rmask=mask )
        endif
!--> cjg
!       if (id_qdt_phys > 0) then
!          used = send_data ( id_qdt_phys, qdt(:,:,:), &
!                             Time_next, is, js, 1, rmask=mask )
!       endif
        do n=1,nt
          if (id_tracer_phys(n) > 0) then
            used = send_data ( id_tracer_phys(n), rdt(:,:,:,n), &
                               Time_next, is, js, 1, rmask=mask )
          endif
        end do
!<--cjg

      endif ! do_moist_processes

      if(ASSOCIATED(Aerosol%aerosol))deallocate(Aerosol%aerosol)
      if(ASSOCIATED(Aerosol%family_members))deallocate(Aerosol%family_members)
      if(ASSOCIATED(Aerosol%aerosol_names))deallocate(Aerosol%aerosol_names)

      
      call mpp_clock_begin ( cosp_clock )
      if (do_cosp) then
        if (step_to_call_cosp) then

!---------------------------------------------------------------------
!    on the first step of a job segment, the values of t,q and precip 
!    flux will not be available at the proper time level. in this case
!    denoted by temp-_last = 0.0, use values from the current step for 
!    t, q and precip flux.
!---------------------------------------------------------------------
          alphb = SUM(temp_last(is:ie,js:je,:))
          if (alphb == 0.) then
            temp_last(is:ie,js:je,:) = t(:,:,:) + dt*tdt(:,:,:)
            q_last(is:ie,js:je,:) = q(:,:,:) + dt*qdt(:,:,:)
            fl_lsrain_loc(:,:,:) = fl_lsrain(is:ie,js:je,:)
            fl_lssnow_loc(:,:,:) = fl_lssnow(is:ie,js:je,:)
            fl_lsgrpl_loc(:,:,:) = fl_lsgrpl(is:ie,js:je,:)
            fl_ccrain_loc(:,:,:) = fl_ccrain(is:ie,js:je,:)
            fl_ccsnow_loc(:,:,:) = fl_ccsnow(is:ie,js:je,:)
            fl_donmca_rain_loc(:,:,:) = fl_donmca_rain(is:ie,js:je,:)
            fl_donmca_snow_loc(:,:,:) = fl_donmca_snow(is:ie,js:je,:)
          endif

!----------------------------------------------------------------------
!    define the total and convective cloud fractions in each grid box as
!    the average over the stochastic columns.
!----------------------------------------------------------------------
          tca = 0.
          cca = 0.
          do n=1,ncol                      
            where (stoch_cloud_type(is:ie,js:je,:,n) > 0) 
              tca(:,:,:)  = tca(:,:,:) +  1.0
            end where
            where (stoch_cloud_type(is:ie,js:je,:,n) == 2) 
              cca(:,:,:)  = cca(:,:,:) +  1.0
            end where
          end do
          tca = tca/ float(ncol)                
          cca = cca/ float(ncol)

!--------------------------------------------------------------------
!    define the atmospheric density to use in converting concentrations
!    to mixing ratios.
!--------------------------------------------------------------------
          do k=1, size(stoch_cloud_type,3)
            do j=1, size(t,2)
              do i=1, size(t,1)
                rhoi(i,j,k) =  RDGAS*temp_last(i+is-1,j+js-1,k)/ &
                                                          p_full(i,j,k) 
              end do
            end do
          end do

!--------------------------------------------------------------------
!   convert the condensate concentrations in each stochastic column to 
!   mixing ratios. 
!--------------------------------------------------------------------
          do n=1,ncol                       
            do k=1, size(stoch_cloud_type,3)
              do j=1, size(t,2)
                do i=1, size(t,1)
                  stoch_mr_liq(i,j,k,n) = 1.0e-03*  &
                         stoch_conc_drop(i+is-1,j+js-1,k,n)*rhoi(i,j,k)
                  stoch_mr_ice(i,j,k,n) = 1.0e-03*  &
                         stoch_conc_ice (i+is-1,j+js-1,k,n)*rhoi(i,j,k)
                  stoch_size_liq(i,j,k,n) = 1.0e-06*  &
                         stoch_size_drop(i+is-1,j+js-1,k,n)
                  stoch_size_frz(i,j,k,n) = 1.0e-06*  &
                         stoch_size_ice (i+is-1,j+js-1,k,n)
                end do
              end do
            end do
          end do
          stoch_mr_liq = stoch_mr_liq/(1.0-stoch_mr_liq)
          stoch_mr_ice = stoch_mr_ice/(1.0-stoch_mr_ice)

!---------------------------------------------------------------------
!    define the grid box mean largescale and convective condensate 
!    mixing ratios and sizes.
!---------------------------------------------------------------------
          lsliq = 0.
          lsice = 0.
          ccliq = 0.
          ccice = 0.
          reff_lsclliq = 0.
          reff_lsclice = 0.
          reff_ccclliq = 0.
          reff_ccclice = 0.
          reff_lsprliq = 0.
          reff_lsprice = 0.
          reff_ccprliq = 0.
          reff_ccprice = 0.
          do k=1, size(stoch_cloud_type,3)
            do j=1, size(t,2)
              do i=1, size(t,1)
                nls = 0
                ncc = 0
                do n=1,ncol                       
                  if (stoch_cloud_type(i+is-1,j+js-1,k,n) == 1) then
                    nls = nls + 1
                    lsliq(i,j,k) = lsliq(i,j,k) +  &
                                     stoch_conc_drop(i+is-1,j+js-1,k,n)
                    lsice(i,j,k) = lsice(i,j,k) +   &
                                     stoch_conc_ice (i+is-1,j+js-1,k,n)
                    reff_lsclliq(i,j,k) = reff_lsclliq(i,j,k) +  &
                                     stoch_size_drop(i+is-1,j+js-1,k,n)
                    reff_lsclice(i,j,k) = reff_lsclice(i,j,k) +  &
                                     stoch_size_ice (i+is-1,j+js-1,k,n)
                  else if (stoch_cloud_type(i+is-1,j+js-1,k,n) == 2)then
                    ncc = ncc + 1
                    ccliq(i,j,k) = ccliq(i,j,k) +  &
                                     stoch_conc_drop(i+is-1,j+js-1,k,n)
                    ccice(i,j,k) = ccice(i,j,k) +  &
                                     stoch_conc_ice (i+is-1,j+js-1,k,n)
                    reff_ccclliq(i,j,k) = reff_ccclliq(i,j,k) +  &
                                     stoch_size_drop(i+is-1,j+js-1,k,n)
                    reff_ccclice(i,j,k) = reff_ccclice(i,j,k) +  &
                                     stoch_size_ice (i+is-1,j+js-1,k,n)
                  endif
                end do
                if (nls > 0) then
                  lsliq(i,j,k) = 1.0e-03*lsliq(i,j,k)/float(nls)
                  lsice(i,j,k) = 1.0e-03*lsice(i,j,k)/float(nls)
                  reff_lsclliq(i,j,k) = 1.0e-06*  &
                                      reff_lsclliq (i,j,k)/float(nls)
                  reff_lsclice(i,j,k) = 1.0e-06*  &
                                      reff_lsclice (i,j,k)/float(nls)
                endif
                if (ncc > 0) then
                  ccliq(i,j,k) = 1.0e-03*ccliq(i,j,k)/float(ncc)
                  ccice(i,j,k) = 1.0e-03*ccice(i,j,k)/float(ncc)
                  reff_ccclliq(i,j,k) = 1.0e-06*  &
                                    reff_ccclliq (i,j,k) /float(ncc)
                  reff_ccclice(i,j,k) = 1.0e-06*  &
                                    reff_ccclice (i,j,k) /float(ncc)
                endif
                ccliq(i,j,k) = ccliq(i,j,k)*rhoi(i,j,k)/ &
                                                  (1.0-ccliq(i,j,k))
                ccice(i,j,k) = ccice(i,j,k)*rhoi(i,j,k)/  &
                                                  (1.0-ccice(i,j,k))
                lsliq(i,j,k) = lsliq(i,j,k)*rhoi(i,j,k)/  &
                                                  (1.0-lsliq(i,j,k))
                lsice(i,j,k) = lsice(i,j,k)*rhoi(i,j,k)/  &
                                                  (1.0-lsice(i,j,k))
              end do
            end do
          end do
     
!---------------------------------------------------------------------
!   define land_mask array. set it to 1 over land, 0 over ocean; define
!   based on frac_land > 0.5 being land.
!---------------------------------------------------------------------
          where (frac_land > 0.50)
            land_mask(:,:) =  1.0
          elsewhere
            land_mask(:,:) =  0.0
          end where

          if (allow_cosp_precip_wo_clouds) then
          else
!--------------------------------------------------------------------
!    allow ls precip only in columns containing ls cloud. allow 
!    convective precip only in columns with convective cloud,
!--------------------------------------------------------------------
            do j=1, size(t,2)
              do i=1, size(t,1)
              flag_ls = 0
              flag_cc = 0
              do k=1, size(stoch_cloud_type,3)
                do n=1,ncol                        
                  if (stoch_cloud_type(i+is-1,j+js-1,k,n) == 1) then
                    flag_ls = 1
                    exit
                  else if(stoch_cloud_type(i+is-1,j+js-1,k,n) == 2) then
                    flag_cc = 1
                    exit
                  endif
                end do
                if (flag_ls == 1 .and. flag_cc == 1) exit
              end do
              if (flag_ls == 0) then
                fl_lsrain_loc(i,j,:) = 0.
                fl_lssnow_loc(i,j,:) = 0.
                fl_lsgrpl_loc(i,j,:) = 0.
              endif 
              if (flag_cc == 0) then
                fl_ccrain_loc(i,j,:) = 0.
                fl_ccsnow_loc(i,j,:) = 0.
              endif 
            end do
          end do
          endif

          if (include_donmca_in_cosp) then
            fl_ccrain_loc = fl_ccrain_loc + fl_donmca_rain_loc
            fl_ccsnow_loc = fl_ccsnow_loc + fl_donmca_snow_loc
          endif

!---------------------------------------------------------------------
!    pass in the large-scale graupel flux, lowest-level u and v wind
!    components.
!---------------------------------------------------------------------
          fl_lsgrpl = 0.
          u_sfc = u(:,:,kmax)
          v_sfc = v(:,:,kmax)

!---------------------------------------------------------------------
!    call the cosp simulator to produce the desired outputs.
!---------------------------------------------------------------------
          call cosp_driver (lat*180./ACOS(-1.0), lon*180./ACOS(-1.0),  &
                            daytime(is:ie,js:je), &
                            p_half, &
                            p_full, z_half,  &
                            z_full, u_sfc, v_sfc, mr_ozone_loc, &
                            temp_last(is:ie,js:je,:),  &
                            q_last(is:ie,js:je,:), tca, cca, lsliq,  &
                            lsice, ccliq, ccice,  &
                           fl_lsrain_loc, fl_lssnow_loc, fl_lsgrpl_loc,&
                            fl_ccrain_loc, fl_ccsnow_loc,&
                            0.5*reff_lsclliq, 0.5*reff_lsclice,  &
                            reff_lsprliq, reff_lsprice,  &
                            0.5*reff_ccclliq, 0.5*reff_ccclice, &
                            reff_ccprliq, reff_ccprice, &
                            tsurf_save(is:ie, js:je), land_mask, &
                            Time_next, is, js, &
                stoch_mr_liq_in =stoch_mr_liq,  &
                stoch_mr_ice_in =stoch_mr_ice,  &
                stoch_size_liq_in =0.5*stoch_size_liq, &
                stoch_size_frz_in = 0.5*stoch_size_frz,  &
                tau_stoch_in = tau_stoch(is:ie,js:je,:,:),&
                lwem_stoch_in = lwem_stoch(is:ie,js:je,:,:), &
                stoch_cloud_type_in = stoch_cloud_type(is:ie,js:je,:,:))
        endif ! (step_to_call_cosp)
      endif ! (do_cosp)
      call mpp_clock_end ( cosp_clock )

!--------------------------------------------------------------------
! save t and q from end of step for use with next call to COSP
!--------------------------------------------------------------------
      temp_last(is:ie,js:je,:) = t(:,:,:) + tdt(:,:,:)*dt
      q_last   (is:ie,js:je,:) = q(:,:,:) + qdt(:,:,:)*dt
       
!-----------------------------------------------------------------------


 end subroutine physics_driver_up


!#######################################################################
! <SUBROUTINE NAME="physics_driver_end">
!  <OVERVIEW>
!   physics_driver_end is the destructor for physics_driver_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    physics_driver_end is the destructor for physics_driver_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call physics_driver_end (Time)
!  </TEMPLATE>
!  <IN NAME="Time" TYPE="time_type">
!   current time
!  </IN>
! </SUBROUTINE>
!
subroutine physics_driver_end (Time)

!---------------------------------------------------------------------
!    physics_driver_end is the destructor for physics_driver_mod.
!---------------------------------------------------------------------

type(time_type), intent(in) :: Time

!--------------------------------------------------------------------
!   intent(in) variables:
! 
!      Time      current time [ time_type(days, seconds) ]
!
!--------------------------------------------------------------------
integer :: moist_processes_term_clock, damping_term_clock, turb_term_clock, &
           diff_term_clock, cloud_spec_term_clock, aerosol_term_clock, &
           grey_radiation_term_clock, radiative_gases_term_clock, &
           radiation_term_clock, tracer_term_clock, cosp_term_clock

! ---> h1g
integer :: clubb_term_clock
!--------------------------------------------------------------------
        clubb_term_clock =      &
        mpp_clock_id( '   Phys_driver_term: clubb: Termination', &
                grain=CLOCK_MODULE_DRIVER )
! <--- h1g

      moist_processes_term_clock =      &
        mpp_clock_id( '   Phys_driver_term: MP: Termination', &
                grain=CLOCK_MODULE_DRIVER )
      damping_term_clock         =     &
        mpp_clock_id( '   Phys_driver_term: Damping: Termination',    &
                  grain=CLOCK_MODULE_DRIVER )
      turb_term_clock            =      &
        mpp_clock_id( '   Phys_driver_term: Vert. Turb.: Termination', &
                  grain=CLOCK_MODULE_DRIVER )
      diff_term_clock       =     &
        mpp_clock_id( '   Phys_driver_term: Vert. Diff.: Termination',   &
                 grain=CLOCK_MODULE_DRIVER )
      cloud_spec_term_clock       =       &
        mpp_clock_id( '   Phys_driver_term: Cloud spec: Termination', &
                       grain=CLOCK_MODULE_DRIVER )
      cosp_term_clock       =       &
        mpp_clock_id( '   Phys_driver_term: COSP: Termination', &
                       grain=CLOCK_MODULE_DRIVER )
      aerosol_term_clock       =       &
        mpp_clock_id( '   Phys_driver_term: Aerosol: Termination', &
                       grain=CLOCK_MODULE_DRIVER )
      grey_radiation_term_clock       =       &
        mpp_clock_id( '   Phys_driver_term: Grey Radiation: Termination', &
                       grain=CLOCK_MODULE_DRIVER )
      radiative_gases_term_clock       =       &
        mpp_clock_id( '   Phys_driver_term: Radiative gases: Termination', &
                       grain=CLOCK_MODULE_DRIVER )
      radiation_term_clock       =       &
        mpp_clock_id( '   Phys_driver_term: Radiation: Termination', &
                       grain=CLOCK_MODULE_DRIVER )
      tracer_term_clock          =      &
        mpp_clock_id( '   Phys_driver_term: Tracer: Termination',    &
                 grain=CLOCK_MODULE_DRIVER )
!---------------------------------------------------------------------
!    verify that the module is initialized.
!---------------------------------------------------------------------
      if ( .not. module_is_initialized) then
        call error_mesg ('physics_driver_mod',  &
              'module has not been initialized', FATAL)
      endif

      call physics_driver_netcdf

!--------------------------------------------------------------------
!    call the destructor routines for those modules who were initial-
!    ized from this module.
!--------------------------------------------------------------------
      call mpp_clock_begin ( turb_term_clock )
      call vert_turb_driver_end
      call mpp_clock_end ( turb_term_clock )
      call mpp_clock_begin ( diff_term_clock )
      call vert_diff_driver_end
      call mpp_clock_end ( diff_term_clock )
      if (do_radiation) then
        call mpp_clock_begin ( radiation_term_clock )
        call radiation_driver_end
        call mpp_clock_end ( radiation_term_clock )
        call mpp_clock_begin ( radiative_gases_term_clock )
        call radiative_gases_end
        call mpp_clock_end ( radiative_gases_term_clock )
        call mpp_clock_begin ( cloud_spec_term_clock )
        call cloud_spec_end
        call mpp_clock_end ( cloud_spec_term_clock )
        call mpp_clock_begin ( aerosol_term_clock )
        call aerosol_end
        call mpp_clock_end ( aerosol_term_clock )
      endif
      call mpp_clock_begin ( grey_radiation_term_clock )

      if(do_grey_radiation) call grey_radiation_end 

      call mpp_clock_end ( grey_radiation_term_clock )
      call mpp_clock_begin ( moist_processes_term_clock )
      call moist_processes_end( clubb_term_clock )
      call mpp_clock_end ( moist_processes_term_clock )
      call mpp_clock_begin ( tracer_term_clock )
      call atmos_tracer_driver_end
      call mpp_clock_end ( tracer_term_clock )
      call mpp_clock_begin ( damping_term_clock )
      call damping_driver_end
      call mpp_clock_end ( damping_term_clock )
      call mpp_clock_begin ( cosp_term_clock )
      if (do_cosp) then
        call cosp_driver_end
      endif
      call mpp_clock_end ( cosp_term_clock )

!---------------------------------------------------------------------
!    deallocate the module variables.
!---------------------------------------------------------------------
      deallocate (diff_cu_mo, diff_t, diff_m, pbltop, cush, cbmf,  &
                  convect, radturbten, lw_tendency, r_convect)
      deallocate (fl_lsrain, fl_lssnow, fl_lsgrpl, fl_ccrain, fl_ccsnow, &
                  fl_donmca_snow, fl_donmca_rain, mr_ozone, daytime, &
                  temp_last, q_last)
      deallocate (lsc_cloud_area, lsc_liquid, lsc_ice, &
                  lsc_droplet_number, lsc_ice_number)
      deallocate (lsc_snow, lsc_rain, lsc_snow_size, lsc_rain_size)
      if (do_clubb > 0) then
         deallocate ( dcond_ls_liquid )
         deallocate ( dcond_ls_ice )
         deallocate ( Ndrop_act_CLUBB )
         deallocate ( Icedrop_act_CLUBB )
         deallocate ( ndust )
         deallocate ( rbar_dust )
         deallocate ( diff_t_clubb )
      end if

      if (doing_donner) then
        deallocate (cell_cld_frac, cell_liq_amt, cell_liq_size, &
                    cell_ice_amt, cell_ice_size, cell_droplet_number, &
                    meso_cld_frac, meso_liq_amt, meso_liq_size, &
                    meso_ice_amt, meso_ice_size, meso_droplet_number, &
                    nsum_out)
      endif
      if (doing_uw_conv) then
        deallocate (shallow_cloud_area, shallow_liquid, shallow_ice, &
                    shallow_droplet_number)
        deallocate ( shallow_ice_number)

      endif
 
      deallocate (id_tracer_phys_vdif_dn)
      deallocate (id_tracer_phys_vdif_up)
      deallocate (id_tracer_phys_turb)
      deallocate (id_tracer_phys_moist)

      if (do_cosp .or. do_modis_yim) then
        deallocate (stoch_cloud_type, tau_stoch, lwem_stoch, &
                    stoch_conc_drop, stoch_conc_ice, stoch_size_drop, &
                    stoch_size_ice, tsurf_save)
      endif
!---------------------------------------------------------------------
!    mark the module as uninitialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.


!-----------------------------------------------------------------------

 end subroutine physics_driver_end

!#######################################################################
! <SUBROUTINE NAME="physics_driver_restart">
!
! <DESCRIPTION>
! write out restart file.
! Arguments: 
!   timestamp (optional, intent(in)) : A character string that represents the model time, 
!                                      used for writing restart. timestamp will append to
!                                      the any restart file name as a prefix. 
! </DESCRIPTION>
!
subroutine physics_driver_restart(timestamp)
  character(len=*), intent(in), optional :: timestamp


  if (mpp_pe() == mpp_root_pe() ) then
     call error_mesg('physics_driver_mod', 'Writing netCDF formatted restart file: RESTART/physics_driver.res.nc', NOTE)
  endif
  call physics_driver_netcdf(timestamp)
  call vert_turb_driver_restart(timestamp)
  if (do_radiation) then
    call radiation_driver_restart(timestamp)
    call radiative_gases_restart(timestamp)
  endif

!    call moist_processes_restart(timestamp)
  call damping_driver_restart(timestamp)

end subroutine physics_driver_restart
! </SUBROUTINE> NAME="physics_driver_restart"

! <SUBROUTINE NAME="physics_driver_netcdf">
!
! <DESCRIPTION>
! Write out restart file for physics driver.
! This routine is needed so that physics_driver_restart and physics_driver_end
! can call a routine which will not result in multiple copies of restart files 
! being written by the destructor routines.
! Arguments: 
!   timestamp (optional, intent(in)) : A character string that represents the model time, 
!                                      used for writing restart. timestamp will append to
!                                      the any restart file name as a prefix. 
! </DESCRIPTION>
!
subroutine physics_driver_netcdf(timestamp)
  character(len=*), intent(in), optional :: timestamp

    r_convect = 0.
    where(convect)
       r_convect = 1.0
    end where
    call save_restart(Phy_restart, timestamp)
    if(in_different_file) call save_restart(Til_restart, timestamp)

end subroutine physics_driver_netcdf
! </SUBROUTINE> NAME="physics_driver_netcdf"

!#######################################################################
! <FUNCTION NAME="do_moist_in_phys_up">
!  <OVERVIEW>
!    do_moist_in_phys_up returns the value of do_moist_processes
!  </OVERVIEW>
!  <DESCRIPTION>
!    do_moist_in_phys_up returns the value of do_moist_processes
!  </DESCRIPTION>
!  <TEMPLATE>
!   logical = do_moist_in_phys_up()
!  </TEMPLATE>
! </FUNCTION>
!
function do_moist_in_phys_up()

!--------------------------------------------------------------------
!    do_moist_in_phys_up returns the value of do_moist_processes
!----------------------------------------------------------------------

logical :: do_moist_in_phys_up

!---------------------------------------------------------------------
!    verify that the module is initialized.
!---------------------------------------------------------------------
      if ( .not. module_is_initialized) then
        call error_mesg ('do_moist_in_phys_up',  &
              'module has not been initialized', FATAL)
      endif
 
!-------------------------------------------------------------------
!    define output variable.
!-------------------------------------------------------------------
      do_moist_in_phys_up = do_moist_processes

 
end function do_moist_in_phys_up

!#####################################################################
! <FUNCTION NAME="get_diff_t">
!  <OVERVIEW>
!    returns the values of array diff_t
!  </OVERVIEW>
!  <DESCRIPTION>
!    returns the values of array diff_t
!  </DESCRIPTION>
!  <TEMPLATE>
!   diff_t(:,:,:) = get_diff_t()
!  </TEMPLATE>
! </FUNCTION>
!
!#####################################################################
function get_diff_t() result(diff_t_out)
real, dimension(size(diff_t,1),size(diff_t,2),size(diff_t,3)) :: diff_t_out

  if ( .not. module_is_initialized) then
    call error_mesg ('get_diff_t','module has not been initialized', FATAL)
  endif

  diff_t_out = diff_t

end function get_diff_t

!#####################################################################
! <FUNCTION NAME="get_radturbten">
!  <OVERVIEW>
!    returns the values of array radturbten
!  </OVERVIEW>
!  <DESCRIPTION>
!    returns the values of array radturbten
!  </DESCRIPTION>
!  <TEMPLATE>
!   radturbten(:,:,:) = get_radturbten()
!  </TEMPLATE>
! </FUNCTION>
!
!#####################################################################
function get_radturbten() result(radturbten_out)
real, dimension(size(radturbten,1),size(radturbten,2),size(radturbten,3)) :: radturbten_out

  if ( .not. module_is_initialized) then
    call error_mesg ('get_radturbten','module has not been initialized', FATAL)
  endif

  radturbten_out = radturbten

end function get_radturbten
!#####################################################################
! <SUBROUTINE NAME="zero_radturbten">
!  <OVERVIEW>
!    sets all values of array radturbten to zero
!  </OVERVIEW>
!  <DESCRIPTION>
!    sets all values of array radturbten to zero
!  </DESCRIPTION>
!  <TEMPLATE>
!   call zero_radturbten()
!  </TEMPLATE>
! </SUBROUTINE>
!
!#####################################################################
subroutine zero_radturbten()

  if ( .not. module_is_initialized) then
    call error_mesg ('zero_radturbten','module has not been initialized', FATAL)
  endif

  radturbten = 0.0

end subroutine zero_radturbten
!#####################################################################



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                    PRIVATE SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
          
               
     
!#####################################################################
! <SUBROUTINE NAME="physics_driver_register_restart">
!  <OVERVIEW>
!    physics_driver_register_restart will register restart field when do_netcdf file 
!    is true. 
!  </OVERVIEW>
subroutine physics_driver_register_restart
  character(len=64) :: fname, fname2
  integer           :: id_restart

  
  if(doing_strat()) then 
     now_doing_strat = 1
  else
     now_doing_strat = 0
  endif

  if(doing_edt) then 
     now_doing_edt = 1
  else
     now_doing_edt = 0
  endif

  if(doing_entrain) then 
     now_doing_entrain = 1
  else
     now_doing_entrain = 0
  endif

  fname = 'physics_driver.res.nc'
  call get_mosaic_tile_file(fname, fname2, .false. ) 
  allocate(Phy_restart)
  if(trim(fname2) == trim(fname)) then
     Til_restart => Phy_restart
     in_different_file = .false.
  else
     in_different_file = .true.
     allocate(Til_restart)
  endif

  id_restart = register_restart_field(Phy_restart, fname, 'vers',          vers,              no_domain=.true.)
  id_restart = register_restart_field(Phy_restart, fname, 'doing_strat',   now_doing_strat,   no_domain=.true.)
  id_restart = register_restart_field(Phy_restart, fname, 'doing_edt',     now_doing_edt,     no_domain=.true.)
  id_restart = register_restart_field(Phy_restart, fname, 'doing_entrain', now_doing_entrain, no_domain=.true.)

  id_restart = register_restart_field(Til_restart, fname, 'diff_cu_mo', diff_cu_mo)
  id_restart = register_restart_field(Til_restart, fname, 'pbltop',     pbltop)
  id_restart = register_restart_field(Til_restart, fname, 'cush',       cush, mandatory = .false.)
  id_restart = register_restart_field(Til_restart, fname, 'cbmf',       cbmf, mandatory = .false.)
  id_restart = register_restart_field(Til_restart, fname, 'diff_t',     diff_t)
  id_restart = register_restart_field(Til_restart, fname, 'diff_m',     diff_m)
!-->cjg
  if (do_clubb > 0) then
     id_restart = register_restart_field(Til_restart, fname, 'diff_t_clubb', diff_t_clubb, mandatory = .false.)
  end if
!<--cjg
  id_restart = register_restart_field(Til_restart, fname, 'convect',    r_convect) 
  if (doing_strat()) then
     id_restart = register_restart_field(Til_restart, fname, 'radturbten',       radturbten)
  endif
  if (doing_edt .or. doing_entrain) then
     id_restart = register_restart_field(Til_restart, fname, 'lw_tendency',      lw_tendency)
  endif
  if (doing_donner) then
     id_restart = register_restart_field(Til_restart, fname, 'cell_cloud_frac',  cell_cld_frac, mandatory = .false.)
     id_restart = register_restart_field(Til_restart, fname, 'cell_liquid_amt',  cell_liq_amt,  mandatory = .false.)
     id_restart = register_restart_field(Til_restart, fname, 'cell_liquid_size', cell_liq_size, mandatory = .false.)
     id_restart = register_restart_field(Til_restart, fname, 'cell_ice_amt',     cell_ice_amt,  mandatory = .false.)
     id_restart = register_restart_field(Til_restart, fname, 'cell_ice_size',    cell_ice_size, mandatory = .false.)
     id_restart = register_restart_field(Til_restart, fname, 'meso_cloud_frac',  meso_cld_frac, mandatory = .false.)
     id_restart = register_restart_field(Til_restart, fname, 'meso_liquid_amt',  meso_liq_amt,  mandatory = .false.)
     id_restart = register_restart_field(Til_restart, fname, 'meso_liquid_size', meso_liq_size, mandatory = .false.)
     id_restart = register_restart_field(Til_restart, fname, 'meso_ice_amt',     meso_ice_amt,  mandatory = .false.)
     id_restart = register_restart_field(Til_restart, fname, 'meso_ice_size',    meso_ice_size, mandatory = .false.)
     id_restart = register_restart_field(Til_restart, fname, 'nsum',             nsum_out,      mandatory = .false.)
  endif
  if (doing_uw_conv) then
     id_restart = register_restart_field(Til_restart, fname, 'shallow_cloud_area',     shallow_cloud_area,     mandatory = .false.)
     id_restart = register_restart_field(Til_restart, fname, 'shallow_liquid',         shallow_liquid,         mandatory = .false.)
     id_restart = register_restart_field(Til_restart, fname, 'shallow_ice',            shallow_ice,            mandatory = .false.)
     id_restart = register_restart_field(Til_restart, fname, 'shallow_droplet_number', shallow_droplet_number, mandatory = .false.)
     id_restart = register_restart_field(Til_restart, fname, 'shallow_ice_number',     shallow_ice_number,     mandatory = .false.)
  endif
  id_restart = register_restart_field(Til_restart, fname, 'lsc_cloud_area',     lsc_cloud_area,     mandatory = .false.)
  id_restart = register_restart_field(Til_restart, fname, 'lsc_liquid',         lsc_liquid ,        mandatory = .false.)
  id_restart = register_restart_field(Til_restart, fname, 'lsc_ice',            lsc_ice,            mandatory = .false.)
  id_restart = register_restart_field(Til_restart, fname, 'lsc_droplet_number', lsc_droplet_number, mandatory = .false.)
  id_restart = register_restart_field(Til_restart, fname, 'lsc_ice_number',     lsc_ice_number,     mandatory = .false.)
  id_restart = register_restart_field(Til_restart, fname, 'lsc_snow',           lsc_snow,           mandatory = .false.)
  id_restart = register_restart_field(Til_restart, fname, 'lsc_rain',           lsc_rain,           mandatory = .false.)
  id_restart = register_restart_field(Til_restart, fname, 'lsc_snow_size',      lsc_snow_size,      mandatory = .false.)
  id_restart = register_restart_field(Til_restart, fname, 'lsc_rain_size',      lsc_rain_size,      mandatory = .false.)

end subroutine physics_driver_register_restart
! </SUBROUTINE>    
!#####################################################################
! <SUBROUTINE NAME="check_args">
!  <OVERVIEW>
!    check_args determines if the input arrays to physics_driver_down
!    are of a consistent size.
!  </OVERVIEW>
!  <DESCRIPTION>
!    check_args determines if the input arrays to physics_driver_down
!    are of a consistent size.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call check_args (lat, lon, area, p_half, p_full, z_half, z_full,&
!                        u, v, t, q, r, um, vm, tm, qm, rm,             &
!                        udt, vdt, tdt, qdt, rdt, mask, kbot)
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   array of model latitudes at model points [radians]
!  </IN>
!  <IN NAME="lon" TYPE="real">
!   array of model longitudes at model points [radians]
!  </IN>
!  <IN NAME="area" TYPE="real">
!   grid box area - current not used
!  </IN>
!  <IN NAME="p_half" TYPE="real">
!   pressure at model interface levels (offset from t,q,u,v,r)
!  </IN>
!  <IN NAME="p_full" TPYE="real">
!   pressure at full levels
!  </IN>
!  <IN NAME="z_half" TYPE="real">
!   height at model interface levels
!  </IN>
!  <IN NAME="z_full" TPYE="real">
!   height at full levels
!  </IN>
!  <IN NAME="u" TYPE="real">
!   zonal wind at current time step
!  </IN>
!  <IN NAME="v" TYPE="real">
!   meridional wind at current time step
!  </IN>
!  <IN NAME="t" TYPE="real">
!   temperature at current time step
!  </IN>
!  <IN NAME="q" TYPE="real">
!   specific humidity at current time step
!  </IN>
!  <IN NAME="r" TPYE="real">
!   multiple 3d tracer fields at current time step
!  </IN>
!  <IN NAME="um" TYPE="real">
!   zonal wind at previous time step
!  </IN>
!  <IN NAME="vm" TYPE="real">
!   meridional wind at previous time step
!  </IN>
!  <IN NAME="tm" TYPE="real">
!   temperature at previous time step
!  </IN>
!  <IN NAME="qm" TYPE="real">
!   specific humidity at previous time step
!  </IN>
!  <IN NAME="rm" TPYE="real">
!   multiple 3d tracer fields at previous time step
!  </IN>
!  <IN NAME="udt" TYPE="real">
!   zonal wind tendency
!  </IN>
!  <IN NAME="vdt" TYPE="real">
!   meridional wind tendency
!  </IN>
!  <IN NAME="tdt" TYPE="real">
!   temperature tendency
!  </IN>
!  <IN NAME="qdt" TYPE="real">
!   moisture tracer tendencies
!  </IN>
!  <IN NAME="rdt" TYPE="real">
!   multiple tracer tendencies
!  </IN>
!  <IN NAME="kbot" TYPE="integer">
!   OPTIONAL: present when running eta vertical coordinate,
!                        index of lowest model level above ground
!  </IN>
!  <IN NAME="mask" TYPE="real">
!   OPTIONAL: present when running eta vertical coordinate,
!                        mask to remove points below ground
!  </IN>
! </SUBROUTINE>
!
subroutine check_args (lat, lon, area, p_half, p_full, z_half, z_full,&
                        u, v, t, q, r, um, vm, tm, qm, rm,             &
                        udt, vdt, tdt, qdt, rdt, mask, kbot)

!----------------------------------------------------------------------
!    check_args determines if the input arrays to physics_driver_down
!    are of a consistent size.
!-----------------------------------------------------------------------

real,    dimension(:,:),    intent(in)          :: lat, lon, area
real,    dimension(:,:,:),  intent(in)          :: p_half, p_full,   &
                                                   z_half, z_full,   &
                                                   u, v, t, q, um, vm, &
                                                   tm, qm
real,    dimension(:,:,:,:),intent(in)          :: r, rm
real,    dimension(:,:,:),  intent(in)          :: udt, vdt, tdt, qdt
real,    dimension(:,:,:,:),intent(in)          :: rdt
real,    dimension(:,:,:),  intent(in),optional :: mask
integer, dimension(:,:),    intent(in),optional :: kbot

!-----------------------------------------------------------------------
!   intent(in) variables:
!
!      lat            latitude of model points [ radians ]
!      lon            longitude of model points [ radians ]
!      area           grid box area - currently not used [ m**2 ]
!      p_half         pressure at half levels (offset from t,q,u,v,r)
!                     [ Pa ]
!      p_full         pressure at full levels [ Pa }
!      z_half         height at half levels [ m ]
!      z_full         height at full levels [ m ]
!      u              zonal wind at current time step [ m / s ]
!      v              meridional wind at current time step [ m / s ]
!      t              temperature at current time step [ deg k ]
!      q              specific humidity at current time step  kg / kg ]
!      r              multiple 3d tracer fields at current time step
!      um,vm          zonal and meridional wind at previous time step
!      tm,qm          temperature and specific humidity at previous 
!                     time step
!      rm             multiple 3d tracer fields at previous time step
!      udt            zonal wind tendency [ m / s**2 ]
!      vdt            meridional wind tendency [ m / s**2 ]
!      tdt            temperature tendency [ deg k / sec ]
!      qdt            specific humidity tendency 
!                     [  kg vapor / kg air / sec ]
!      rdt            multiple tracer tendencies [ unit / unit / sec ]
!
!   intent(in), optional:
!
!       mask        mask that designates which levels do not have data
!                   present (i.e., below ground); 0.=no data, 1.=data
!       kbot        lowest level which has data
!                   note:  both mask and kbot must be present together.
!
!---------------------------------------------------------------------

!----------------------------------------------------------------------
!   local variables:

      integer ::  id, jd, kd  ! model dimensions on the processor  
      integer ::  ierr        ! error flag

!--------------------------------------------------------------------
!    define the sizes that the arrays should be.
!--------------------------------------------------------------------
      id = size(u,1) 
      jd = size(u,2) 
      kd = size(u,3) 

!--------------------------------------------------------------------
!    check the dimensions of each input array. if they are incompat-
!    ible in size with the standard, the error flag is set to so
!    indicate.
!--------------------------------------------------------------------
      ierr = 0
      ierr = ierr + check_dim (lat, 'lat',  id,jd)
      ierr = ierr + check_dim (lon, 'lon',  id,jd)
      ierr = ierr + check_dim (area,'area', id,jd)

      ierr = ierr + check_dim (p_half,'p_half', id,jd,kd+1)
      ierr = ierr + check_dim (p_full,'p_full', id,jd,kd)
      ierr = ierr + check_dim (z_half,'z_half', id,jd,kd+1)
      ierr = ierr + check_dim (z_full,'z_full', id,jd,kd)

      ierr = ierr + check_dim (u, 'u',  id,jd,kd)
      ierr = ierr + check_dim (v, 'v',  id,jd,kd)
      ierr = ierr + check_dim (t, 't',  id,jd,kd)
      ierr = ierr + check_dim (q, 'q',  id,jd,kd)
      ierr = ierr + check_dim (um,'um', id,jd,kd)
      ierr = ierr + check_dim (vm,'vm', id,jd,kd)
      ierr = ierr + check_dim (tm,'tm', id,jd,kd)
      ierr = ierr + check_dim (qm,'qm', id,jd,kd)

      ierr = ierr + check_dim (udt,'udt', id,jd,kd)
      ierr = ierr + check_dim (vdt,'vdt', id,jd,kd)
      ierr = ierr + check_dim (tdt,'tdt', id,jd,kd)
      ierr = ierr + check_dim (qdt,'qdt', id,jd,kd)

      if (nt > 0) then
        ierr = ierr + check_dim (r,  'r',   id,jd,kd,nt)
        ierr = ierr + check_dim (rm, 'rm',  id,jd,kd,nt)
      endif
      if (ntp > 0) then
        ierr = ierr + check_dim (rdt,'rdt', id,jd,kd,ntp)
      endif

!--------------------------------------------------------------------
!    if any problems were detected, exit with an error message.
!--------------------------------------------------------------------
      if (ierr > 0) then
        call error_mesg ('physics_driver_mod', 'bad dimensions', FATAL)
      endif

!-----------------------------------------------------------------------


      end subroutine check_args


!#######################################################################
! <FUNCTION NAME="check_dim_2d">
!  <OVERVIEW>
!    check_dim_2d compares the size of two-dimensional input arrays
!    with supplied expected dimensions and returns an error if any
!    inconsistency is found.
!  </OVERVIEW>
!  <DESCRIPTION>
!    check_dim_2d compares the size of two-dimensional input arrays
!    with supplied expected dimensions and returns an error if any
!    inconsistency is found.
!  </DESCRIPTION>
!  <TEMPLATE>
!    check_dim_2d (data,name,id,jd) result (ierr)
!  </TEMPLATE>
!  <IN NAME="data" TYPE="real">
!   array of data to be checked
!  </IN>
!  <IN NAME="name" TYPE="character">
!   name associated with array to be checked
!  </IN>
!  <IN NAME="id, jd" TYPE="integer">
!   expected i and j dimensions
!  </IN>
! </FUNCTION>
!
function check_dim_2d (data,name,id,jd) result (ierr)

!--------------------------------------------------------------------
!    check_dim_2d compares the size of two-dimensional input arrays
!    with supplied expected dimensions and returns an error if any
!    inconsistency is found.
!--------------------------------------------------------------------

real,    intent(in), dimension(:,:) :: data
character(len=*), intent(in)        :: name
integer, intent(in)                 :: id, jd
integer                             :: ierr

!---------------------------------------------------------------------
!  intent(in) variables:
!
!     data        array to be checked
!     name        name associated with array to be checked
!     id, jd      expected i and j dimensions
!     
!  result variable:
!
!     ierr        set to 0 if ok, otherwise is a count of the number
!                 of incompatible dimensions
!
!--------------------------------------------------------------------

      ierr = 0
      if (size(data,1) /= id) then
        call error_mesg ('physics_driver_mod',  &
             'dimension 1 of argument ' //  &
              name(1:len_trim(name)) // ' has wrong size.', NOTE)
        ierr = ierr + 1
      endif
      if (size(data,2) /= jd) then
           call error_mesg ('physics_driver_mod',  &
                'dimension 2 of argument ' //  &
                name(1:len_trim(name)) // ' has wrong size.', NOTE)
           ierr = ierr + 1
      endif

!----------------------------------------------------------------------

      end function check_dim_2d

!#######################################################################
! <FUNCTION NAME="check_dim_3d">
!  <OVERVIEW>
!    check_dim_3d compares the size of three-dimensional input arrays
!    with supplied expected dimensions and returns an error if any
!    inconsistency is found.
!  </OVERVIEW>
!  <DESCRIPTION>
!    check_dim_3d compares the size of three-dimensional input arrays
!    with supplied expected dimensions and returns an error if any
!    inconsistency is found.
!  </DESCRIPTION>
!  <TEMPLATE>
!    check_dim_3d (data,name,id,jd, kd) result (ierr)
!  </TEMPLATE>
!  <IN NAME="data" TYPE="real">
!   array of data to be checked
!  </IN>
!  <IN NAME="name" TYPE="character">
!   name associated with array to be checked
!  </IN>
!  <IN NAME="id, jd, kd" TYPE="integer">
!   expected i, j and k dimensions
!  </IN>
! </FUNCTION>
!
function check_dim_3d (data,name,id,jd,kd) result (ierr)

!--------------------------------------------------------------------
!    check_dim_3d compares the size of thr1eedimensional input arrays
!    with supplied expected dimensions and returns an error if any
!    inconsistency is found.
!--------------------------------------------------------------------

real,    intent(in), dimension(:,:,:) :: data
character(len=*), intent(in)          :: name
integer, intent(in)                   :: id, jd, kd
integer  ierr

!---------------------------------------------------------------------
!  intent(in) variables:
!
!     data        array to be checked
!     name        name associated with array to be checked
!     id, jd,kd   expected i, j and k dimensions
!     
!  result variable:
!
!     ierr        set to 0 if ok, otherwise is a count of the number
!                 of incompatible dimensions
!
!--------------------------------------------------------------------

      ierr = 0
      if (size(data,1) /= id) then
        call error_mesg ('physics_driver_mod',  &
                'dimension 1 of argument ' //  &
                name(1:len_trim(name)) // ' has wrong size.', NOTE)
        ierr = ierr + 1
      endif
      if (size(data,2) /= jd) then
        call error_mesg ('physics_driver_mod',  &
              'dimension 2 of argument ' //  &
                name(1:len_trim(name)) // ' has wrong size.', NOTE)
        ierr = ierr + 1
      endif
      if (size(data,3) /= kd) then
        call error_mesg ('physics_driver_mod',  &
                'dimension 3 of argument ' //  &
                name(1:len_trim(name)) // ' has wrong size.', NOTE)
        ierr = ierr + 1
      endif

!---------------------------------------------------------------------


      end function check_dim_3d


!#######################################################################
! <FUNCTION NAME="check_dim_4d">
!  <OVERVIEW>
!    check_dim_4d compares the size of four-dimensional input arrays
!    with supplied expected dimensions and returns an error if any
!    inconsistency is found.
!  </OVERVIEW>
!  <DESCRIPTION>
!    check_dim_4d compares the size of four-dimensional input arrays
!    with supplied expected dimensions and returns an error if any
!    inconsistency is found.
!  </DESCRIPTION>
!  <TEMPLATE>
!    check_dim_4d (data,name,id,jd, kd, nt) result (ierr)
!  </TEMPLATE>
!  <IN NAME="data" TYPE="real">
!   array of data to be checked
!  </IN>
!  <IN NAME="name" TYPE="character">
!   name associated with array to be checked
!  </IN>
!  <IN NAME="id, jd, kd, nt" TYPE="integer">
!   expected i, j, k and 4th dimensions
!  </IN>
! </FUNCTION>
!
function check_dim_4d (data,name,id,jd,kd,nt) result (ierr)

!--------------------------------------------------------------------
!    check_dim_4d compares the size of four dimensional input arrays
!    with supplied expected dimensions and returns an error if any
!    inconsistency is found.
!--------------------------------------------------------------------
real,    intent(in), dimension(:,:,:,:) :: data
character(len=*), intent(in)            :: name
integer, intent(in)                     :: id, jd, kd, nt
integer                                 :: ierr

!---------------------------------------------------------------------
!  intent(in) variables:
!
!     data          array to be checked
!     name          name associated with array to be checked
!     id,jd,kd,nt   expected i, j and k dimensions
!     
!  result variable:
!
!     ierr          set to 0 if ok, otherwise is a count of the number
!                   of incompatible dimensions
!
!--------------------------------------------------------------------

      ierr = 0
      if (size(data,1) /= id) then
        call error_mesg ('physics_driver_mod',  &
                'dimension 1 of argument ' //  &
                name(1:len_trim(name)) // ' has wrong size.', NOTE)
        ierr = ierr + 1
      endif
      if (size(data,2) /= jd) then
        call error_mesg ('physics_driver_mod',  &
                'dimension 2 of argument ' //  &
                name(1:len_trim(name)) // ' has wrong size.', NOTE)
        ierr = ierr + 1
      endif
      if (size(data,3) /= kd) then
        call error_mesg ('physics_driver_mod',  &
                'dimension 3 of argument ' //  &
                name(1:len_trim(name)) // ' has wrong size.', NOTE)
        ierr = ierr + 1
      endif
      if (size(data,4) /= nt) then
        call error_mesg ('physics_driver_mod',  &
                'dimension 4 of argument ' //  &
                name(1:len_trim(name)) // ' has wrong size.', NOTE)
        ierr = ierr + 1
      endif

!---------------------------------------------------------------------


      end function check_dim_4d



!#######################################################################
 

 
                end module physics_driver_mod

module atmosphere_mod
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                                   !!
!!                   GNU General Public License                      !!
!!                                                                   !!
!! This file is part of the Flexible Modeling System (FMS).          !!
!!                                                                   !!
!! FMS is free software; you can redistribute it and/or modify       !!
!! it and are expected to follow the terms of the GNU General Public !!
!! License as published by the Free Software Foundation.             !!
!!                                                                   !!
!! FMS is distributed in the hope that it will be useful,            !!
!! but WITHOUT ANY WARRANTY; without even the implied warranty of    !!
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     !!
!! GNU General Public License for more details.                      !!
!!                                                                   !!
!! You should have received a copy of the GNU General Public License !!
!! along with FMS; if not, write to:                                 !!
!!          Free Software Foundation, Inc.                           !!
!!          59 Temple Place, Suite 330                               !!
!!          Boston, MA  02111-1307  USA                              !!
!! or see:                                                           !!
!!          http://www.gnu.org/licenses/gpl.txt                      !!
!!                                                                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!module atmosphere_mod

!-----------------------------------------------------------------------
!
!    interface for FV dynamical core with Held-Suarez forcing
!
!-----------------------------------------------------------------------


use time_manager_mod, only: time_type, get_time, set_time, operator(+)

use fms_mod,          only: file_exist, open_namelist_file,   &
                            error_mesg, FATAL,                &
                            check_nml_error, stdlog,          &
                            write_version_number,             &
                            close_file, set_domain,           &
                            nullify_domain

  use hs_forcing_mod,   only: hs_forcing_init
#if  defined(MARS_GCM)  || defined(VENUS_GCM)  || defined(STRAT_GCM)
  use hs_forcing_mod,   only: hs_forcing_end
#endif 

 use constants_mod, only: omega, cp_air, rdgas, kappa, radius, grav, rvgas
 use    mpp_domains_mod, only: domain2d

!------------------
! FV specific codes:
!------------------
 use fv_pack, only: nlon, mlat, nlev, beglat, endlat, beglon, endlon, &
                    rlonb, rlatb,        &
                    cold_start, ncnst, pnats, consv_te, ptop,         &
                    fv_init, fv_domain, fv_end, change_time, map_dt,  &
                    adiabatic, restart_format

#if  defined(MARS_GCM)  || defined(VENUS_GCM)  || defined(STRAT_GCM)
  use fv_pack, only:   rlon, rlat, ak, bk, p_ref
#endif  

  use fv_diagnostics, only: fv_diag_init, fv_diag, fv_time
  use timingModule,   only: timing_on, timing_off
  use fv_restart_mod, only: fv_restart, write_fv_rst
  use fv_dynamics_mod, only: fv_dynamics
  use fv_phys_mod, only: fv_phys

!-----------------------------------------------------------------------

implicit none
private

public   atmosphere_init, atmosphere,  atmosphere_end, atmosphere_domain

!-----------------------------------------------------------------------

character(len=128) :: version = '$Id: atmosphere.F90,v 19.0 2012/01/06 20:00:14 fms Exp $'
character(len=128) :: tag = '$Name: tikal $'

!-----------------------------------------------------------------------
!---- private data ----

type        (time_type) :: Time_step_atmos
real                    :: dt_atmos
integer :: sec
integer days, seconds

!-----------------------------------------------------------------------

contains

!#######################################################################

 subroutine atmosphere_init ( Time_init, Time, Time_step )

 type (time_type), intent(in) :: Time_step
 type (time_type), intent(in) :: Time_init
 type (time_type), intent(in) :: Time

! local:
 integer axes(4)
 integer ss, ds
 integer ii, jj
 real,  allocatable   ::   rlonb2d(:,:), rlatb2d(:,:)

#if  defined(MARS_GCM)  || defined(VENUS_GCM)  || defined(STRAT_GCM)
  integer  k
  real,  allocatable   ::   p_std(:)
#endif 

!----- write version and namelist to log file -----

    call write_version_number(version, tagname)

!---- compute physics/atmos time step in seconds ----

    Time_step_atmos = Time_step
    call get_time (Time_step_atmos, sec)
    dt_atmos = real(sec)

!----- initialize FV dynamical core -----

    call fv_init( sec )
    call fv_restart( days, seconds )
   
    if ( .not. cold_start ) then 
!
! Check consistency in Time
!
    fv_time = set_time (seconds, days)
    call get_time (Time, ss,  ds)

    if( seconds /= ss .or. days /= ds ) then
!       write(6,*) 'FMS:', ds, ss
!       write(6,*) 'FV:', days, seconds
        call error_mesg('FV_init:', &
     'Time inconsistent between fv_rst and INPUT/atmos_model.res', &
                         FATAL)
    endif
    else
    fv_time = time
    endif

    call fv_diag_init( axes, Time )

    allocate ( rlatb2d(beglon:endlon+1,beglat:endlat+1) )
    allocate ( rlonb2d(beglon:endlon+1,beglat:endlat+1) )

!   Convert bounding lon and lat arrays to 2-D
    DO jj= beglat, endlat+1
       rlatb2d(beglon:endlon+1,jj)= rlatb(jj)
    ENDDO
    DO ii= beglon, endlon+1
       rlonb2d(ii,beglat:endlat+1)= rlonb(ii)
    ENDDO

    call set_domain ( fv_domain )

    if( nlev > 1 ) then 
#if  defined(MARS_GCM)  || defined(VENUS_GCM)  || defined(STRAT_GCM)

         allocate(  p_std(nlev+1) )

         DO k= 1, nlev+1
            p_std(k)= ak(k) + bk(k)*p_ref
         ENDDO

         call hs_forcing_init ( nlon, mlat, nlev,                 &
                      rlonb2d(beglon:endlon+1,beglat:endlat+1),   &
                      rlatb2d(beglon:endlon+1,beglat:endlat+1),   &
                      rlon   (beglon:endlon,  beglat:endlat),     &
                      rlat   (beglon:endlon,  beglat:endlat),     &
                      p_std, axes, Time  )

         deallocate( p_std )

#else
         call hs_forcing_init ( axes, Time, rlonb2d, rlatb2d)
#endif 
    endif

    call nullify_domain( )

!-----------------------------------------------------------------------

 end subroutine atmosphere_init


!#######################################################################

 subroutine atmosphere (Time)
#include <fv_arrays.h>
 type(time_type), intent(in) :: Time

! local:
 real    zvir
 logical p_map                      ! Perform only partial remapping
#include <fv_point.inc>

  fv_time = Time + Time_step_atmos
  call get_time (fv_time, seconds,  days)

!---- call fv dynamics -----
  zvir = 0.         ! no virtual effect if not full physics

  if ( mod(seconds, map_dt) == 0 ) then
       p_map = .false.
  else
       p_map = .true.
  endif
                                call timing_on('fv_dynamics')

#ifndef USE_LIMA
  call fv_dynamics (nlon,    mlat,   nlev,    beglat,   endlat,    &
                    ncnst,   pnats,  p_map,   consv_te,            &
                    u,       v,      delp,    pt,       q,         &
                    ps,      pe,     pk,      pkz,      phis,      &
                    omga,    peln,   ptop,    omega,    sec,       &  
                    zvir,    cp_air, rdgas,   kappa,  radius, ua, va, fv_time )
#else
  call fv_dynamics (nlon,    mlat,   nlev,    beglat,   endlat,    &
                    ncnst,   pnats,  p_map,   consv_te,            &
                    u,       v,      delp,    pt,       q,         &
                    ps,      pe,     pk,      pkz,      phis,      &
                    omga,    peln,   ptop,    omega,    sec,       &  
                    zvir,    cp_air, rdgas,   kappa,  radius, ua, va )
#endif

                                call timing_off('fv_dynamics')

      if( nlev /=1 .and. .not. adiabatic ) then
                                call timing_on('FV_PHYS')
                call fv_phys ( fv_time, sec )
                                call timing_off('FV_PHYS')
      endif

!---- diagnostics for FV dynamics -----

                                call timing_on('FV_DIAG')

!!!!rjw    hsphys= .true.  --->  uses simple calender:  days & seconds 

  call fv_diag(fv_time, nlon, mlat, nlev, beglat, endlat, ncnst, zvir,   &
               dt_atmos, .true.)

                                call timing_off('FV_DIAG')

 end subroutine atmosphere


 subroutine atmosphere_end

!----- initialize domains for writing global physics data -----

    call set_domain ( fv_domain )
    call get_time (fv_time, seconds,  days)

#if  defined(MARS_GCM)  || defined(VENUS_GCM)  || defined(STRAT_GCM)
    call hs_forcing_end(  days )
         call nullify_domain( )
#endif 

    call write_fv_rst( 'RESTART/fv_rst.res', days, seconds, grav, &
         restart_format )


    call fv_end(days, seconds)

 end subroutine atmosphere_end

subroutine atmosphere_domain (Domain)
 type(domain2d), intent(inout) :: Domain

   Domain = fv_domain

 end subroutine atmosphere_domain

end module atmosphere_mod

module lscale_cond_mod

!-----------------------------------------------------------------------
use            mpp_mod, only:  input_nml_file
use            fms_mod, only:  file_exist, error_mesg, open_namelist_file,  &
                               check_nml_error, mpp_pe, mpp_root_pe, FATAL,  &
                               close_file, write_version_number, stdlog
use sat_vapor_pres_mod, only:  compute_qs
use      constants_mod, only:  HLv,HLs,Cp_Air,Grav,rdgas,rvgas

implicit none
private
!-----------------------------------------------------------------------
!  ---- public interfaces ----

   public  lscale_cond, lscale_cond_init, lscale_cond_end

!-----------------------------------------------------------------------
!   ---- version number ----

 character(len=128) :: version = '$Id: lscale_cond.F90,v 19.0 2012/01/06 20:10:05 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'
 logical            :: module_is_initialized=.false.

!-----------------------------------------------------------------------
!   ---- local/private data ----

    real, parameter :: d622 = rdgas/rvgas
    real, parameter :: d378 = 1.-d622


!-----------------------------------------------------------------------
!   --- namelist ----

real    :: hc=1.00
logical :: do_evap=.false.
logical :: do_simple =.false.

namelist /lscale_cond_nml/  hc, do_evap, do_simple


!-----------------------------------------------------------------------
!           description of namelist variables
!
!  hc        =  relative humidity at which large scale condensation
!               occurs, where 0 <= hc <= 1 (default: hc=1.)
!
!  do_evap   =  flag for the re-evaporation of moisture in
!               sub-saturated layers below, if do_evap=.true. then
!               re-evaporation is performed (default: do_evap=.false.)
!
!-----------------------------------------------------------------------

contains

!#######################################################################

   subroutine lscale_cond (tin, qin, pfull, phalf, coldT, &
                           rain, snow, tdel, qdel, mask, conv)

!-----------------------------------------------------------------------
!
!                      large scale condensation
!
!-----------------------------------------------------------------------
!
!   input:  tin      temperature at full model levels
!           qin      specific humidity of water vapor at full
!                      model levels
!           pfull    pressure at full model levels
!           phalf    pressure at half (interface) model levels
!           coldT    should precipitation be snow at this point?
!   optional:
!           mask     optional mask (0 or 1.) 
!           conv     logical flag; if true then no large-scale
!                       adjustment is performed at that grid-point or
!                       model level
!
!  output:  rain     liquid precipitation (kg/m2)
!           snow     frozen precipitation (kg/m2)
!           tdel     temperature tendency at full model levels
!           qdel     specific humidity tendency (of water vapor) at
!                      full model levels
!
!-----------------------------------------------------------------------
!--------------------- interface arguments -----------------------------

   real   , intent(in) , dimension(:,:,:) :: tin, qin, pfull, phalf
   logical   , intent(in) , dimension(:,:):: coldT
   real   , intent(out), dimension(:,:)   :: rain,snow
   real   , intent(out), dimension(:,:,:) :: tdel, qdel
   real   , intent(in) , dimension(:,:,:), optional :: mask
   logical, intent(in) , dimension(:,:,:), optional :: conv
!-----------------------------------------------------------------------
!---------------------- local data -------------------------------------

logical,dimension(size(tin,1),size(tin,2),size(tin,3)) :: do_adjust
   real,dimension(size(tin,1),size(tin,2),size(tin,3)) ::  &
                             qsat, dqsat, pmass
   real,dimension(size(tin,1),size(tin,2))             :: hlcp, precip
integer  k, kx
!-----------------------------------------------------------------------
!     computation of precipitation by condensation processes
!-----------------------------------------------------------------------

      if (.not. module_is_initialized) call error_mesg ('lscale_cond',  &
                         'lscale_cond_init has not been called.', FATAL)

      kx=size(tin,3)

!----- compute proper latent heat --------------------------------------
      if(do_simple) then
             hlcp = HLv/Cp_Air
      else
        WHERE (coldT)
             hlcp = HLs/Cp_Air
        ELSEWHERE
             hlcp = HLv/Cp_Air
        END WHERE
      endif

!--- saturation specific humidity (qsat) and deriv wrt temp (dqsat) ---

     call compute_qs (tin, pfull,qsat, hc = hc, dqsdT=dqsat) 

!--------- do adjustment where greater than saturated value ------------

   if (present(conv)) then
!!!!  do_adjust(:,:,:)=(.not.conv(:,:,:) .and. qin(:,:,:) > qsat(:,:,:))
      do_adjust(:,:,:)=(.not.conv(:,:,:) .and.   &
                         (qin(:,:,:) - qsat(:,:,:))*qsat(:,:,:) > 0.0)
   else
!!!!  do_adjust(:,:,:)=(qin(:,:,:) > qsat(:,:,:))
      do_adjust(:,:,:)=( (qin(:,:,:) - qsat(:,:,:))*qsat(:,:,:) > 0.0)
   endif

   if (present(mask)) then
      do_adjust(:,:,:)=do_adjust(:,:,:) .and. (mask(:,:,:) > 0.5)
   end if

!----------- compute adjustments to temp and spec humidity -------------
   do k = 1,kx
   where (do_adjust(:,:,k))
      qdel(:,:,k)=(qsat(:,:,k)-qin(:,:,k))/(1.0+hlcp(:,:)*dqsat(:,:,k))
      tdel(:,:,k)=-hlcp(:,:)*qdel(:,:,k)
   elsewhere
      qdel(:,:,k)=0.0
      tdel(:,:,k)=0.0
   endwhere
   end do
!------------ pressure mass of each layer ------------------------------

   do k=1,kx
      pmass(:,:,k)=(phalf(:,:,k+1)-phalf(:,:,k))/Grav
   enddo

!------------ re-evaporation of precipitation in dry layer below -------

   if (do_evap) then
      if (present(mask)) then
         call precip_evap (pmass,tin,qin,qsat,dqsat,hlcp,tdel,qdel,mask)
      else
         call precip_evap (pmass,tin,qin,qsat,dqsat,hlcp,tdel,qdel)
      endif
   endif

!------------ integrate precip -----------------------------------------

      precip(:,:)=0.0
   do k=1,kx
      precip(:,:)=precip(:,:)-pmass(:,:,k)*qdel(:,:,k)
   enddo
      precip(:,:)=max(precip(:,:),0.0)

   !assign precip to snow or rain
   if(do_simple) then !no snow!
        rain = precip
        snow = 0.
   else
     WHERE (coldT)
        snow = precip
        rain = 0.
     ELSEWHERE
        rain = precip
        snow = 0.
     END WHERE
   endif

!-----------------------------------------------------------------------

   end subroutine lscale_cond

!#######################################################################

subroutine precip_evap (pmass, tin, qin, qsat, dqsat, hlcp, &
                        tdel, qdel, mask)

!-----------------------------------------------------------------------
!        performs re-evaporation of falling precipitation
!-----------------------------------------------------------------------
   real, intent(in),    dimension(:,:,:) :: pmass, tin, qin, qsat, dqsat
   real, intent(in),    dimension(:,:)   :: hlcp
   real, intent(inout), dimension(:,:,:) :: tdel, qdel
   real, intent(in), dimension(:,:,:), optional :: mask
!-----------------------------------------------------------------------
   real, dimension(size(tin,1),size(tin,2)) :: exq, def

   integer  k
!-----------------------------------------------------------------------
    exq(:,:)=0.0

    do k=1,size(tin,3)

        where (qdel(:,:,k) < 0.0)  exq(:,:) = exq(:,:) -  &
                                               qdel(:,:,k)*pmass(:,:,k)

        if (present(mask)) exq(:,:) = exq(:,:)*mask(:,:,k)

!  ---- evaporate precip where needed ------

        where ( (qdel(:,:,k) >= 0.0) .and. (exq(:,:) > 0.0) )
            exq(:,:) = exq(:,:) / pmass(:,:,k)
            def(:,:) = (qsat(:,:,k)-qin(:,:,k))/(1.+hlcp(:,:)*dqsat(:,:,k))
            def(:,:) = min(max(def(:,:),0.0),exq(:,:))
            qdel(:,:,k) = qdel(:,:,k) + def(:,:)
            tdel(:,:,k) = tdel(:,:,k) - def(:,:)*hlcp(:,:)
            exq(:,:) = (exq(:,:)-def(:,:))*pmass(:,:,k)
        endwhere

    enddo

!-----------------------------------------------------------------------

   end subroutine precip_evap

!#######################################################################

   subroutine lscale_cond_init ()

!-----------------------------------------------------------------------
!
!        initialization for large scale condensation
!
!-----------------------------------------------------------------------

  integer  unit,io,ierr, logunit

!----------- read namelist ---------------------------------------------

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=lscale_cond_nml, iostat=io)
      ierr = check_nml_error(io,"lscale_cond_nml")
#else
      if (file_exist('input.nml')) then
         unit = open_namelist_file ()
         ierr=1; do while (ierr /= 0)
            read  (unit, nml=lscale_cond_nml, iostat=io, end=10)
            ierr = check_nml_error (io,'lscale_cond_nml')
         enddo
  10     call close_file (unit)
      endif
#endif

!---------- output namelist --------------------------------------------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
           logunit = stdlog()
           write (logunit,nml=lscale_cond_nml)
      endif

      module_is_initialized=.true.

   end subroutine lscale_cond_init

!#######################################################################
   subroutine lscale_cond_end

      module_is_initialized=.false.

!---------------------------------------------------------------------

   end subroutine lscale_cond_end

!#######################################################################

end module lscale_cond_mod

module ocean_nphysics_new_mod

!<CONTACT EMAIL="tim.leslie@gmail.com"> Tim Leslie
!</CONTACT>
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Compute the effects of neutral physics processes 
! (neutral diffusion and neutral skew-diffusion).
!</OVERVIEW>
!
!<DESCRIPTION>
! Compute the effects of neutral physics processes 
! (neutral diffusion and neutral skew-diffusion).
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies 
! Fundamentals of Ocean Climate Models (FOCM) (2004)
! Princeton University Press 
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, Elements of MOM (2012)
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_nphysics_new_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be set .true. to use this module.
!  Default use_this_module = .false.
!  </DATA> 
!
!  <DATA NAME="drhodz_smooth_vert" TYPE="logical">
!  For smoothing vertical density gradient before computing 
!  neutral slope.  Exercise caution if using this option.   
!  Default drhodz_smooth_vert=.false.
!  </DATA> 
!
!  <DATA NAME="drhodz_smooth_horz" TYPE="logical">
!  For smoothing vertical density gradient before computing 
!  neutral slope.  Exercise caution if using this option.   
!  Default drhodz_smooth_horz=.false.
!  </DATA> 
!
!  <DATA NAME="smax" TYPE="real">
!  Slope maximum parameter for setting behaviour of neutral 
!  physics. Default smax=0.01.
!  </DATA> 
!
!  <DATA NAME="vel_micom_smooth" TYPE="real" UNITS="m/s">
!  For horizontal smoothing of drhodz before computing neutral
!  slopes. Default vel_micom_smooth=0.2.
!  </DATA> 
!
!</NAMELIST>

#define COMP    isc:iec,jsc:jec
#define COMPXLL isc-1:iec-1,jsc:jec
#define COMPYLL isc:iec,jsc-1:jec-1

  use constants_mod,   only: epsln, pi
  use fms_mod,         only: FATAL, WARNING, open_namelist_file, check_nml_error 
  use fms_mod,         only: close_file, file_exist, write_version_number
  use fms_io_mod,      only: restart_file_type
  use fms_io_mod,      only: register_restart_field, save_restart, restore_state
  use mpp_mod,         only: mpp_error, stdout, stdlog, mpp_clock_id, input_nml_file
  use mpp_mod,         only: CLOCK_ROUTINE, mpp_clock_begin, mpp_clock_end
  use mpp_domains_mod, only: mpp_update_domains

  use ocean_domains_mod,           only: get_local_indices, set_ocean_domain
  use ocean_nphysics_util_new_mod, only: ocean_nphysics_util_new_init, vert_smooth, compute_rossby_radius
  use ocean_nphysics_flux_mod,     only: ocean_nphysics_flux_init, flux_calculations
  use ocean_nphysics_tensor_mod,   only: ocean_nphysics_tensor_init, compute_tensors
  use ocean_nphysics_skew_mod,     only: ocean_nphysics_skew_init
  use ocean_nphysics_diff_mod,     only: ocean_nphysics_diff_init, compute_diffusivity
  use ocean_operators_mod,         only: FDX_T, FDY_T, FDX_ZT, FDY_ZT, FMX, FMY, LAP_T
  use ocean_parameters_mod,        only: rho0, grav, TERRAIN_FOLLOWING
  use ocean_types_mod,             only: ocean_grid_type, ocean_domain_type, ocean_time_type
  use ocean_types_mod,             only: ocean_time_steps_type, ocean_options_type
  use ocean_types_mod,             only: ocean_thickness_type, ocean_prog_tracer_type, ocean_density_type
  use ocean_util_mod,              only: write_note
  use ocean_util_mod,              only: diagnose_2d, diagnose_2d_int, diagnose_3d, diagnose_3d_int
  use ocean_util_mod,              only: register_2d_t_field, register_3d_t_field
  use ocean_util_mod,              only: register_3d_xte_field, register_3d_ytn_field, register_3d_ztb_field

  implicit none

  public ocean_nphysics_new_init
  public neutral_physics_new
  public ocean_nphysics_new_restart
  public ocean_nphysics_new_end

  private tracer_gradients

  private gradrho
  private adjust_drhodz

  private neutral_slopes
  private neutral_blayer

  private

#include <ocean_memory.h>

character(len=128) :: version=&
     '$Id: ocean_nphysics_new.F90,v 20.0 2013/12/14 00:14:46 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

character(len=*), parameter :: FILENAME=&
     __FILE__


  logical :: module_is_initialized = .FALSE.

  integer :: id_clock_tracer_gradients
  integer :: id_clock_density
  integer :: id_clock_diffusivity
  integer :: id_clock_tensors
  integer :: id_clock_flux

  integer :: id_drhodx
  integer :: id_drhody
  integer :: id_drhodz
  integer :: id_drhodz_up
  integer :: id_drhodz_lo

  integer :: id_slopex
  integer :: id_slopey
  integer :: id_absslope
  integer :: id_N2
  integer :: id_gravity_wave_speed
  integer :: id_rossby_radius
  integer :: id_ksurf_blayer

  integer, dimension(:), allocatable :: id_dTdx
  integer, dimension(:), allocatable :: id_dTdy
  integer, dimension(:), allocatable :: id_dTdz

  integer :: id_neut_rho_nphysics
  integer :: id_wdian_rho_nphysics

  type(restart_file_type), save :: nphysics_new_restart

  real, dimension(:,:), allocatable :: grid_length ! grid length array (metre)
  real, dimension(:,:), allocatable :: smooth_diff ! (m^2/sec) for smoothing

  ! Diffusivity arrays (m^2/s)
  real, dimension(:,:), allocatable :: ah_array
  real, dimension(:,:,:), allocatable :: agm_array
  real, dimension(:,:,:), allocatable :: aredi_array

  real :: dtime
  integer :: index_temp, index_salt

  logical :: use_this_module

  ! for Tim%init=.true. and ocean_neutral.res.nc exists, but still wish
  ! to start from initial fields.
  logical :: nphysics_new_zero_init=.false.

  real :: smax = 0.01

  ! adjust_drhodz()
  logical :: drhodz_smooth_vert = .false.
  logical :: drhodz_smooth_horz = .false.
  real    :: vel_micom_smooth   = 0.2 ! m/sec

  namelist /ocean_nphysics_new_nml/ use_this_module, &
       drhodz_smooth_vert, drhodz_smooth_horz, smax, vel_micom_smooth

contains

  !#######################################################################
  ! <SUBROUTINE NAME="ocean_nphysics_new_init">
  !
  ! <DESCRIPTION>
  ! Initialises diagnostics, namelists and constants.
  ! </DESCRIPTION>
  !
  subroutine ocean_nphysics_new_init(Grid, Domain, Time, Time_steps, Thickness, &
                                     T_prog, Ocean_options, vert_coordinate_type)

    type(ocean_grid_type),                      intent(in)    :: Grid
    type(ocean_domain_type),                    intent(inout) :: Domain
    type(ocean_time_type),                      intent(in)    :: Time
    type(ocean_time_steps_type),                intent(in)    :: Time_steps
    type(ocean_thickness_type),                 intent(in)    :: Thickness
    type(ocean_prog_tracer_type), dimension(:), intent(in)    :: T_prog
    type(ocean_options_type),                   intent(inout) :: Ocean_options
    integer,                                    intent(in)    :: vert_coordinate_type

    logical :: agm_z_dep
    integer :: ioun, ierr, io_status
    integer :: num_prog_tracers, n
    integer :: id_restart

    character(len=*), parameter :: restart_filename = 'ocean_neutral_new.res.nc'

    integer :: stdoutunit, stdlogunit
    stdoutunit = stdout()
    stdlogunit = stdlog()

    num_prog_tracers = size(T_prog)

    if ( module_is_initialized ) then 
       call mpp_error(FATAL, &
            '==>Error from ocean_nphysics_mod (ocean_nphysics_init):already initialized')
    endif

    module_is_initialized = .TRUE.

    call write_version_number(version, tagname)

    ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_nphysics_new_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_nphysics_new_nml')
#else
    ioun =  open_namelist_file()
    read (ioun,ocean_nphysics_new_nml,IOSTAT=io_status)
    ierr = check_nml_error(io_status,'ocean_nphysics_new_nml')
    call close_file (ioun)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit,ocean_nphysics_new_nml)  
    write (stdlogunit,ocean_nphysics_new_nml)

  call ocean_nphysics_util_new_init(Domain, Grid)

  if(use_this_module) then 
     call write_note(FILENAME,&
     'USING ocean_nphysics_new.')
     if(vert_coordinate_type==TERRAIN_FOLLOWING) then 
        call mpp_error(WARNING, &
             '==>Warning: ocean_nphysics_new is NOT supported with TERRRAIN_FOLLOWING vertical coordinates.')
     endif
     Ocean_options%neutral_physics_new = 'Used neutral physics new.'
  else 
     call write_note(FILENAME,&
     'NOT using ocean_nphysics_new.')
     Ocean_options%neutral_physics_new = 'Did NOT use neutral physics new option.'
     return
  endif 


#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
    nk = Grid%nk
#endif

    index_temp=-1;index_salt=-1
    do n=1,num_prog_tracers
       if (T_prog(n)%name == 'temp') index_temp = n
       if (T_prog(n)%name == 'salt') index_salt = n
    enddo
    if (index_temp == -1 .or. index_salt == -1) then
       call mpp_error(FATAL, &
            '==>Error: temp and/or salt not identified in call to ocean_nphysics_util_init')
    endif

    id_clock_tracer_gradients = mpp_clock_id('(Ocean neutral: tracer gradients)' ,grain=CLOCK_ROUTINE)
    id_clock_density          = mpp_clock_id('(Ocean neutral: density calcs)'    ,grain=CLOCK_ROUTINE)
    id_clock_diffusivity      = mpp_clock_id('(Ocean neutral: diffusivity)'    ,grain=CLOCK_ROUTINE)
    id_clock_tensors          = mpp_clock_id('(Ocean neutral: tensors)'    ,grain=CLOCK_ROUTINE)
    id_clock_flux             = mpp_clock_id('(Ocean neutral: flux)'    ,grain=CLOCK_ROUTINE)

    ! some useful constants
    dtime = Time_steps%dtime_t

    allocate (grid_length(isd:ied,jsd:jed))
    allocate (smooth_diff(isd:ied,jsd:jed))
    allocate (ah_array(isd:ied,jsd:jed))
    allocate (agm_array(isd:ied,jsd:jed,nk))
    allocate (aredi_array(isd:ied,jsd:jed,nk))

    grid_length(:,:) = 2.0*Grid%dxt(:,:)*Grid%dyt(:,:)/(Grid%dxt(:,:)+Grid%dyt(:,:)) 
    smooth_diff(:,:) = vel_micom_smooth*grid_length(:,:)

    call ocean_nphysics_diff_init(Domain, Grid, Time, Thickness, grid_length, dtime, smax, &
         ah_array, agm_array, aredi_array, agm_z_dep)
    call ocean_nphysics_flux_init(Domain, Grid, Time, T_prog)
    call ocean_nphysics_tensor_init(Domain, Grid, Time)
    call ocean_nphysics_skew_init(Domain, Grid, Time, agm_z_dep)

    id_restart = register_restart_field(nphysics_new_restart, restart_filename, 'agm_array', agm_array, &
         domain=Domain%domain2d, mandatory=.false.)
    id_restart = register_restart_field(nphysics_new_restart, restart_filename, 'aredi_array', aredi_array, &
         domain=Domain%domain2d, mandatory=.false.)

    if (Time%init .and. nphysics_new_zero_init) then
       !write(stdoutunit,'(1x,a)') ' Starting ocean_nphysics_util fields from raw initialization.'
    elseif (.not. file_exist('INPUT/' // restart_filename)) then
       if (.not. Time%init) call mpp_error(FATAL,'Expecting file INPUT/ocean_neutral_new.res.nc to exist.&
            &This file was not found and Time%init=.false.')
    else
       call restore_state(nphysics_new_restart)

       call mpp_update_domains(agm_array, Domain%domain2d)
       call mpp_update_domains(aredi_array, Domain%domain2d)
    endif

    call register_fields(Grid, Time, T_prog)

  end subroutine ocean_nphysics_new_init
  ! </SUBROUTINE> NAME="ocean_nphysics_new_init"

  !#######################################################################
  ! <SUBROUTINE NAME="register fields">
  !
  ! <DESCRIPTION>
  ! Register diagnostic fields.
  ! </DESCRIPTION>
  !
  subroutine register_fields(Grid, Time, T_prog)
    type(ocean_grid_type), intent(in) :: Grid
    type(ocean_time_type), intent(in) :: Time
    type(ocean_prog_tracer_type), dimension(:), intent(in) :: T_prog

    integer n, num_prog_tracers

    num_prog_tracers = size(T_prog(:))

    id_drhodx = register_3d_t_field(Grid, Time, 'drhodx',                           &
         'drho/dx at tracer point calculated as average of left/right components ', &
         'rho/m', (/-1e-4,1.e-4/))
    id_drhody = register_3d_t_field(Grid, Time, 'drhody',                           &
         'drho/dy at tracer point calculated as average of left/right components ', &
         'rho/m', (/-1e-4,1.e-4/))
    id_drhodz = register_3d_t_field(Grid, Time, 'drhodz',                        &
         'drho/dz at tracer point calculated as average of up/down components ', &
         'rho/m', (/-1.e-1, 0.0/))
    id_drhodz_up = register_3d_t_field(Grid, Time, 'drhodz_up', &
         'drho/dz at tracer point up component ', 'rho/m', (/-1.e-1, 0.0/))
    id_drhodz_lo = register_3d_t_field(Grid, Time, 'drhodz_lo', &
         'drho/dz at tracer point lo component ', 'rho/m', (/-1.e-1, 0.0/))

    id_slopex = register_3d_t_field(Grid, Time, 'slopex', &
         'x component of neutral slope averaged over triads', '', (/-1e-1,1.e-1/))
    id_slopey = register_3d_t_field(Grid, Time, 'slopey', &
         'y component of neutral slope averaged over triads', '', (/-1e-1,1.e-1/))
    id_absslope = register_3d_t_field(Grid, Time, 'absslope', &
         'magnitude of the neutral slope vector', '', (/0.0,1.-1/))

    id_N2 = register_3d_t_field(Grid, Time, 'N2', &
         'Squared neutral buoyancy frequency', '1/s^2', (/0.0,1.e8/))
    id_gravity_wave_speed = register_2d_t_field(Grid, Time, 'gravity_wave_speed', &
         'Gravity wave speed.', 'm/s', (/-1e-8,1.e8/))

    id_rossby_radius = register_2d_t_field(Grid, Time, 'rossby_radius', &
         'Rossby radius', 'm', (/-1e-8,1.e8/))

    id_ksurf_blayer = register_2d_t_field(Grid, Time, 'ksurf_blayer', &
         'K-index of surface boundary layer.', 'k', (/0.0,100.0/))

    allocate(id_dTdx(num_prog_tracers))
    allocate(id_dTdy(num_prog_tracers))
    allocate(id_dTdz(num_prog_tracers))

    do n = 1, num_prog_tracers
       id_dTdx(n) = register_3d_xte_field(Grid, Time, 'dTdx_'//trim(T_prog(n)%name), &
            'Gradient of '//trim(T_prog(n)%name)//' in x direction', &
            '['//trim(T_prog(n)%name)//']/m', (/-1.e18,1.e18/))
       id_dTdy(n) = register_3d_ytn_field(Grid, Time, 'dTdy_'//trim(T_prog(n)%name), &
            'Gradient of '//trim(T_prog(n)%name)//' in y direction', &
            '['//trim(T_prog(n)%name)//']/m', (/-1.e18,1.e18/))
       id_dTdz(n) = register_3d_ztb_field(Grid, Time, 'dTdz_'//trim(T_prog(n)%name), &
            'Gradient of '//trim(T_prog(n)%name)//' in z direction', &
            '['//trim(T_prog(n)%name)//']/m', (/-1.e18,1.e18/))
    enddo

    id_neut_rho_nphysics = register_3d_t_field(Grid, Time, 'neut_rho_nphysics',&
         'update of neutral density from explicit in time nphysics',           &
         'rho*rho_dz/sec', (/-1.e10,1.e10/))
    id_wdian_rho_nphysics = register_3d_t_field(Grid, Time, 'wdian_rho_nphysics',&
         'dianeutral velocity component due to explicit in time nphysics',       &
         'm/sec', (/-1.e10,1.e10/))

  end subroutine register_fields
  ! </SUBROUTINE> NAME="register_fields"


  !#######################################################################
  ! <SUBROUTINE NAME="neutral_physics_new">
  !
  ! <DESCRIPTION>
  ! This public interface computes the effects of neutral physics
  ! processes (neutral diffusion and neutral skew-diffusion).
  !
  ! --Returns rossby_radius for use in lapgen_friction module.
  ! --Returns gm_diffusivity for use in visc_form_drag module
  ! --Updates the value of T_prog(n)%th_tendency with the explicit thickness
  !   weighted tendency due to neutral physics and also T_prog(n)%K33_implicit
  !   with the implicit component.
  ! </DESCRIPTION>
  !
  subroutine neutral_physics_new(Time, Domain, Thickness, Dens, Grid, surf_blthick, &
       T_prog, rossby_radius, gm_diffusivity)

    type(ocean_time_type),      intent(in)    :: Time
    type(ocean_domain_type),    intent(inout) :: Domain
    type(ocean_thickness_type), intent(in)    :: Thickness
    type(ocean_density_type),   intent(in)    :: Dens
    type(ocean_grid_type),      intent(in)    :: Grid
    real, dimension(isd:,jsd:), intent(in)    :: surf_blthick

    type(ocean_prog_tracer_type), dimension(:), intent(inout) :: T_prog
    real, dimension(isd:,jsd:),                 intent(out) :: rossby_radius
    real, dimension(isd:,jsd:,:),               intent(out) :: gm_diffusivity

    real, dimension(isd:ied,jsd:jed,nk,size(T_prog)) :: dTdx, dTdy
    real, dimension(isd:ied,jsd:jed,0:nk,size(T_prog)) :: dTdz

    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: slopex_xz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: slopey_yz
    real, dimension(isd:ied,jsd:jed,nk,0:1) :: Ndz_z
    real, dimension(isd:ied,jsd:jed,nk,0:1) :: N2_z
    real, dimension(isd:ied,jsd:jed) :: gravity_wave_speed

    real, dimension(isd:ied,jsd:jed,nk,0:1) :: absslope_z
    real, dimension(isd:ied,jsd:jed,nk) :: absslope
    integer, dimension(isd:ied,jsd:jed) :: ksurf_blayer   ! k-value at base of surface nblayer

    ! Neutral diffusion tensor components [m^2/s]
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: symm_tensor13_xz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: symm_tensor23_yz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: symm_tensor33_xz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: symm_tensor33_yz
    real, dimension(isd:ied,jsd:jed,nk,0:1)     :: symm_tensor1122_z

    ! Skew diffusion tensor components (transport vector) [m^2/s]
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: upsilonx_xz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: upsilony_yz

    real, dimension(isd:ied,jsd:jed,nk,size(T_prog)) :: total_th_tendency

    integer :: n, num_prog_tracers

    if (.not. use_this_module) return

    if ( .not. module_is_initialized ) then 
       call mpp_error(FATAL, &
            '==>Error from ocean_nphysics_new (neutral_physics_new): needs initialization')
    endif

    num_prog_tracers = size(T_prog)

    call mpp_clock_begin(id_clock_tracer_gradients)
    call tracer_gradients(Time, Grid, Time%taum1, T_prog, Thickness, &
         dTdx, dTdy, dTdz)
    call mpp_clock_end(id_clock_tracer_gradients)   

    call mpp_clock_begin(id_clock_density)
    call density_calculations(Grid, Time, Thickness, Dens, dTdx, dTdy, dTdz, smax,    &
         slopex_xz, slopey_yz, absslope_z, absslope, N2_z, Ndz_z, gravity_wave_speed, &
         rossby_radius, ksurf_blayer)
    call mpp_clock_end(id_clock_density)

    call mpp_clock_begin(id_clock_diffusivity)
    call compute_diffusivity(Domain, Grid, Time, Thickness, Dens, T_prog(index_temp), &
         T_prog(index_salt), absslope_z, N2_z, gravity_wave_speed, rossby_radius, &
         ksurf_blayer, grid_length, agm_array, aredi_array)
    call mpp_clock_end(id_clock_diffusivity)

    call mpp_clock_begin(id_clock_tensors)
    call compute_tensors(Time, Domain, Grid, Thickness, slopex_xz, slopey_yz, Ndz_z, &
         N2_z, gravity_wave_speed, rossby_radius, absslope, absslope_z,              &
         aredi_array, ah_array, agm_array, ksurf_blayer, smax, surf_blthick,         &
         symm_tensor13_xz, symm_tensor23_yz, symm_tensor33_xz, symm_tensor33_yz,     &
         symm_tensor1122_z, upsilonx_xz, upsilony_yz)
    call mpp_clock_end(id_clock_tensors)

    call mpp_clock_begin(id_clock_flux)
    call flux_calculations(Domain, Grid, Time, Thickness, dtime,        &
         symm_tensor13_xz, symm_tensor23_yz, symm_tensor33_xz,          &
         symm_tensor33_yz, symm_tensor1122_z, upsilonx_xz, upsilony_yz, &
         dTdx, dTdy, dTdz, aredi_array,                                 &
         total_th_tendency, T_prog)
    call mpp_clock_end(id_clock_flux)

    do n = 1, num_prog_tracers
       T_prog(n)%th_tendency(COMP,:) = T_prog(n)%th_tendency(COMP,:) + total_th_tendency(COMP,:,n)
    enddo

    call diagnose_3d(Time, Grid, id_neut_rho_nphysics,              &
         (Dens%drhodT(COMP,:)*total_th_tendency(COMP,:,index_temp)  &
         +Dens%drhodS(COMP,:)*total_th_tendency(COMP,:,index_salt)))
    call diagnose_3d(Time, Grid, id_wdian_rho_nphysics,             &
         (Dens%drhodT(COMP,:)*total_th_tendency(COMP,:,index_temp)  &
         +Dens%drhodS(COMP,:)*total_th_tendency(COMP,:,index_salt)) &
         /(epsln+Dens%drhodz_zt(COMP,:)*Thickness%rho_dzt(COMP,:,Time%tau)))


    ! gm_diffusivity passed to neutral_physics for computing form drag viscosity
    gm_diffusivity(:,:,:) = agm_array(:,:,:)

  end subroutine neutral_physics_new
  ! </SUBROUTINE> NAME="neutral_physics_new"

  !#######################################################################
  ! <SUBROUTINE NAME="tracer_gradients">
  !
  ! <DESCRIPTION>
  ! Compute the tracer derivatives.
  !
  ! G(2004) 16.58
  ! dTdx(i) = (T(i+1) - T(i))/dxte
  ! dTdT(j) = (T(j+1) - T(j))/dytn
  ! dTdz(k) = (T(k) - T(k+1))/dzwt
  !
  ! Horizontal derivatives are taken along surfaces of 
  ! constant vertical coordinate (constant k-level)
  !
  ! This approach ensures that when neutral physics defaults to "horizontal" physics
  ! next to boundaries, it will do so as horizontal, defined along surfaces of constant 
  ! s-surfaces, and so will not generate spurious extrema.  
  !
  ! Additionally, when using generalized vertical coordinates, the neutral diffusion
  ! slope should be computed relative to the s-surfaces.  The skew diffusion slope 
  ! should ideally be computed with respect to z-surfaces, as z-surfaces define
  ! available potential energy. However, when s and z surfaces are reasonably close, 
  ! as they are in the interior for zstar and pstar vertical coordinates, then we 
  ! choose to to dissipate thickness as defined relative to the zstar or pstar surfaces. 
  ! This should not be such a big deal, and it is certainly easier computationally than
  ! worrying about computing two separate sets of slopes.  More on this detail is 
  ! discussed in "Elements of MOM".
  ! 
  ! NOTE: This approach is not appropriate for sigma-models. Indeed, many assumptions
  ! in the neutral physics modules need to be rethought for terrain following vertical
  ! coordinates.  
  !
  ! </DESCRIPTION>
  !
  subroutine tracer_gradients(Time, Grid, taum1, T_prog, Thickness, &
       dTdx, dTdy, dTdz)

    type(ocean_time_type),                      intent(in) :: Time
    type(ocean_grid_type),                      intent(in) :: Grid
    integer,                                    intent(in) :: taum1
    type(ocean_thickness_type),                 intent(in) :: Thickness
    type(ocean_prog_tracer_type), dimension(:), intent(in) :: T_prog

    real, dimension(isd:,jsd:,:,:),  intent(out) :: dTdx
    real, dimension(isd:,jsd:,:,:),  intent(out) :: dTdy
    real, dimension(isd:,jsd:,0:,:), intent(out) :: dTdz

    integer :: k, n, num_prog_tracers
    real, dimension(isd:ied,jsd:jed,2) :: field

    num_prog_tracers = size(T_prog)

    ! lateral derivatives taken along surfaces of
    ! constant vertical coordinate (constant k-level)
    do n=1,num_prog_tracers
       do k = 1, nk
          field(:,:,1) = T_prog(n)%field(:,:,k,taum1)
          dTdx(:,:,k,n) = FDX_T(field(:,:,1))*FMX(Grid%tmask(:,:,k))
          dTdy(:,:,k,n) = FDY_T(field(:,:,1))*FMY(Grid%tmask(:,:,k))
       enddo
    enddo
 
    ! vertical derivative
    do n=1,num_prog_tracers
       dTdz(:,:,0,n) = 0.0
       do k = 1, nk-1
          dTdz(:,:,k,n) = Grid%tmask(:,:,k+1)*(T_prog(n)%field(:,:,k,taum1) - T_prog(n)%field(:,:,k+1,taum1)) &
                          /(Thickness%dzwt(:,:,k) + epsln)
       enddo
       dTdz(:,:,nk,n) = 0.0
    enddo

    do n=1,num_prog_tracers
       call diagnose_3d(Time, Grid, id_dTdx(n), dTdx(:,:,:,n))
       call diagnose_3d(Time, Grid, id_dTdy(n), dTdy(:,:,:,n))
       call diagnose_3d(Time, Grid, id_dTdz(n), dTdz(:,:,1:nk,n))
    enddo

  end subroutine tracer_gradients
  ! </SUBROUTINE> NAME="tracer_gradients"

  !#######################################################################
  ! <SUBROUTINE NAME="density_calculations">
  !
  ! <DESCRIPTION>
  ! This subroutine computes a number of values based on the density gradient.
  !
  ! These are the neutral slope vector, the neutral buoyancy frequency, 
  ! gravity wave speed, Rossby radius and boundary layer depth.
  ! </DESCRIPTION>
  !
  subroutine density_calculations(Grid, Time, Thickness, Dens, dTdx, dTdy, dTdz, smax, &
       slopex_xz, slopey_yz, absslope_z, absslope, N2_z, Ndz_z, gravity_wave_speed,    &
       rossby_radius, ksurf_blayer)

    type(ocean_density_type),        intent(in) :: Dens
    type(ocean_time_type),           intent(in) :: Time
    type(ocean_grid_type),           intent(in) :: Grid
    type(ocean_thickness_type),      intent(in) :: Thickness
    real, dimension(isd:,jsd:,:,:),  intent(in) :: dTdx
    real, dimension(isd:,jsd:,:,:),  intent(in) :: dTdy
    real, dimension(isd:,jsd:,0:,:), intent(in) :: dTdz
    real,                            intent(in) :: smax

    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: slopex_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: slopey_yz
    real, dimension(isd:,jsd:,:,0:),    intent(out) :: absslope_z
    real, dimension(isd:,jsd:,:),       intent(out) :: absslope
    real, dimension(isd:,jsd:,:,0:),    intent(out) :: N2_z
    real, dimension(isd:,jsd:,:,0:),    intent(out) :: Ndz_z
    real, dimension(isd:,jsd:),         intent(out) :: gravity_wave_speed
    real, dimension(isd:,jsd:),         intent(out) :: rossby_radius

    integer, dimension(isd:,jsd:), intent(out) :: ksurf_blayer

    ! neutral density derivatives 
    real, dimension(isd:ied,jsd:jed,nk,0:1) :: drhodx_x
    real, dimension(isd:ied,jsd:jed,nk,0:1) :: drhody_y
    real, dimension(isd:ied,jsd:jed,nk,0:1) :: drhodz_z 

    call gradrho(Dens, dTdx, dTdy, dTdz, drhodx_x, drhody_y, drhodz_z)
    call adjust_drhodz(Grid, drhodz_z)
    call diagnose_3d(Time, Grid, id_drhodx, 0.5*sum(drhodx_x, dim=4))
    call diagnose_3d(Time, Grid, id_drhody, 0.5*sum(drhody_y, dim=4))
    call diagnose_3d(Time, Grid, id_drhodz, 0.5*sum(drhodz_z, dim=4), abs_min=1.e-30)
    call diagnose_3d(Time, Grid, id_drhodz_up, drhodz_z(:,:,:,0),     abs_min=1.e-30)
    call diagnose_3d(Time, Grid, id_drhodz_lo, drhodz_z(:,:,:,1),     abs_min=1.e-30)

    call neutral_slopes(Time, Grid, drhodx_x, drhody_y, drhodz_z, &
         slopex_xz, slopey_yz, absslope_z, absslope)

    N2_z(:,:,:,:) = -(grav/rho0)*drhodz_z(:,:,:,:) ! EoM: 16.65

    Ndz_z(COMP,:,0) = sqrt(N2_z(COMP,:,0))*Thickness%dztup(COMP,:)
    Ndz_z(COMP,:,1) = sqrt(N2_z(COMP,:,1))*Thickness%dztlo(COMP,:)

    ! EoM: 16.64, FCOM(2004) 14.83
    gravity_wave_speed(COMP) = sum(sum(Ndz_z(COMP,:,:), dim=4), dim=3)/pi 

    call compute_rossby_radius(gravity_wave_speed, rossby_radius)

    call neutral_blayer(smax, absslope, ksurf_blayer)

    call diagnose_2d_int(Time, Grid, id_ksurf_blayer, ksurf_blayer)
    call diagnose_3d(Time, Grid, id_absslope, absslope, abs_max=1.e4)
    call diagnose_3d(Time, Grid, id_N2, 0.5*sum(N2_z, dim=4), abs_min=1.e-30)
    call diagnose_2d(Time, Grid, id_gravity_wave_speed, gravity_wave_speed)
    call diagnose_2d(Time, Grid, id_rossby_radius, rossby_radius)

  end subroutine density_calculations
  ! </SUBROUTINE> NAME="density_calculations"

  !#######################################################################
  ! <SUBROUTINE NAME="gradrho">
  !
  ! <DESCRIPTION>
  ! Calculate the raw density gradients. No smoothing or limiting  
  ! applied here.
  ! </DESCRIPTION>
  !
  subroutine gradrho(Dens, dTdx, dTdy, dTdz, drhodx_x, drhody_y, drhodz_z)
    type(ocean_density_type),        intent(in) :: Dens
    real, dimension(isd:,jsd:,:,:),  intent(in) :: dTdx
    real, dimension(isd:,jsd:,:,:),  intent(in) :: dTdy
    real, dimension(isd:,jsd:,0:,:), intent(in) :: dTdz

    real, dimension(isd:,jsd:,:,0:), intent(out) :: drhodx_x
    real, dimension(isd:,jsd:,:,0:), intent(out) :: drhody_y
    real, dimension(isd:,jsd:,:,0:), intent(out) :: drhodz_z

    real, dimension(isd:ied,jsd:jed,nk) :: drhodT, drhodS
    real, dimension(isd:ied,jsd:jed,nk) :: dSdx, dSdy, dTdx_, dTdy_
    real, dimension(isd:ied,jsd:jed,0:nk) :: dSdz, dTdz_

    drhodT = Dens%drhodT
    drhodS = Dens%drhodS
    dSdx = dTdx(:,:,:,index_salt)
    dSdy = dTdy(:,:,:,index_salt)
    dSdz = dTdz(:,:,:,index_salt)
    dTdx_ = dTdx(:,:,:,index_temp)
    dTdy_ = dTdy(:,:,:,index_temp)
    dTdz_ = dTdz(:,:,:,index_temp)

    drhodz_z(:,:,:,0) = drhodT(:,:,:)*dTdz_(:,:,0:nk-1) + drhodS(:,:,:)*dSdz(:,:,0:nk-1)
    drhodz_z(:,:,:,1) = drhodT(:,:,:)*dTdz_(:,:,1:nk)   + drhodS(:,:,:)*dSdz(:,:,1:nk)

    drhodx_x(COMP,:,0) = drhodT(COMP,:)*dTdx_(COMPXLL,:) + drhodS(COMP,:)*dSdx(COMPXLL,:) ! G(2004) 16.64
    drhodx_x(COMP,:,1) = drhodT(COMP,:)*dTdx_(COMP,:)    + drhodS(COMP,:)*dSdx(COMP,:)

    drhody_y(COMP,:,0) = drhodT(COMP,:)*dTdy_(COMPYLL,:) + drhodS(COMP,:)*dSdy(COMPYLL,:)
    drhody_y(COMP,:,1) = drhodT(COMP,:)*dTdy_(COMP,:)    + drhodS(COMP,:)*dSdy(COMP,:)

  end subroutine gradrho
  ! </SUBROUTINE> NAME="gradrho"


  !#######################################################################
  ! <SUBROUTINE NAME="adjust_drhodz">
  !
  ! <DESCRIPTION>
  ! Comments about smoothing drhodz:
  !
  ! 1/ Tests in coupled 1-degree model showed extreme sensitivity
  ! of MOC to smoothing.  GFDL users generally do NOT smooth, hence
  ! the default drhodz_smooth_vert=drhodz_smooth_horz=.false.
  !
  ! 2/ Smoothing the vertical derivative of drhodz helps
  ! produce a regularized (i.e., well behaved) neutral slope vector.
  !
  ! 3/ An attempt was made to smooth dTdz and dSdz rather
  ! than drhodz.  The resulting slope was smooth, but not as
  ! smooth as when acting on drhodz itself.
  ! </DESCRIPTION>
  !
  subroutine adjust_drhodz(Grid, drhodz_z)
    type(ocean_grid_type),           intent(in) :: Grid
    real, dimension(isd:,jsd:,:,0:), intent(inout) :: drhodz_z

    integer :: k

    ! vertical neutral density derivative for use in fz_terms
    ! and fz_flux, and for use in fx_flux and fy_flux.
    ! note that the derivative at k=nk vanishes by definition
    ! since these derivatives are at the bottom of tracer cell.
    ! also note the use of -epsln_drhodz ensures the vertical
    ! derivative is always < 0.
    drhodz_z(:,:,:,:) = min(drhodz_z(:,:,:,:), -epsln)

    ! vertically smooth the vertical derivative of density to
    ! produce a smooth neutral slope vector for all flux components.
    if (drhodz_smooth_vert) then
       call vert_smooth(Grid%kmt(:,:), drhodz_z(:,:,:,0))
       call vert_smooth(Grid%kmt(:,:), drhodz_z(:,:,:,1))
    endif

    ! horizontally smooth (via a diffusivity) the vertical derivative of 
    ! density to produce a smooth neutral slope vector for all flux components.
    if (drhodz_smooth_horz) then
       do k = 1, nk
          drhodz_z(:,:,k,0) = drhodz_z(:,:,k,0) + dtime*LAP_T(drhodz_z(:,:,k,0), smooth_diff(:,:))
          drhodz_z(:,:,k,1) = drhodz_z(:,:,k,1) + dtime*LAP_T(drhodz_z(:,:,k,1), smooth_diff(:,:))
       enddo
    endif

    drhodz_z(:,:,:,0) = Grid%tmask(:,:,:)*drhodz_z(:,:,:,0)
    do k = 1, nk-1
       drhodz_z(:,:,k,1) = Grid%tmask(:,:,k+1)*drhodz_z(:,:,k,1)
    enddo

  end subroutine adjust_drhodz
  ! </SUBROUTINE> NAME="adjust_drhodz"


  !#######################################################################
  ! <SUBROUTINE NAME="neutral_slopes">
  !
  ! <DESCRIPTION>
  ! Compute the neutral slope vector along with its magnitude.
  ! The neutral slope vector is defined as -grad_h(rho)/(drho/dz).
  ! </DESCRIPTION>
  !
  subroutine neutral_slopes(Time, Grid, drhodx_x, drhody_y, drhodz_z, &
       slopex_xz, slopey_yz, absslope_z, absslope)

    type(ocean_time_type),           intent(in) :: Time
    type(ocean_grid_type),           intent(in) :: Grid
    real, dimension(isd:,jsd:,:,0:), intent(in) :: drhodx_x
    real, dimension(isd:,jsd:,:,0:), intent(in) :: drhody_y
    real, dimension(isd:,jsd:,:,0:), intent(in) :: drhodz_z

    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: slopex_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: slopey_yz
    real, dimension(isd:,jsd:,:,0:),    intent(out) :: absslope_z
    real, dimension(isd:,jsd:,:),       intent(out) :: absslope

    real, dimension(isd:ied,jsd:jed,nk)     :: slopex
    real, dimension(isd:ied,jsd:jed,nk)     :: slopey
    real, dimension(isd:ied,jsd:jed,nk,0:1) :: slopex_z
    real, dimension(isd:ied,jsd:jed,nk,0:1) :: slopey_z
    integer :: k

    slopex_xz(COMP,:,:,:) = 0.0
    slopey_yz(COMP,:,:,:) = 0.0

    ! Upper half cell slopes
    do k = 2, nk       
       where (Grid%tmask(COMP,k) == 1.0)
          slopex_xz(COMP,k,0,0) = -drhodx_x(COMP,k,0)/drhodz_z(COMP,k,0)
          slopex_xz(COMP,k,1,0) = -drhodx_x(COMP,k,1)/drhodz_z(COMP,k,0)
       
          slopey_yz(COMP,k,0,0) = -drhody_y(COMP,k,0)/drhodz_z(COMP,k,0)
          slopey_yz(COMP,k,1,0) = -drhody_y(COMP,k,1)/drhodz_z(COMP,k,0)
       endwhere
    enddo

    ! Lower half cell slopes
    do k = 1, nk-1
       where (Grid%tmask(COMP,k+1) == 1.0)
          slopex_xz(COMP,k,0,1) = -drhodx_x(COMP,k,0)/drhodz_z(COMP,k,1)
          slopex_xz(COMP,k,1,1) = -drhodx_x(COMP,k,1)/drhodz_z(COMP,k,1)

          slopey_yz(COMP,k,0,1) = -drhody_y(COMP,k,0)/drhodz_z(COMP,k,1)
          slopey_yz(COMP,k,1,1) = -drhody_y(COMP,k,1)/drhodz_z(COMP,k,1)
       endwhere
    enddo

    ! Set the very top level slope
    slopex_xz(COMP,1,:,0) = slopex_xz(COMP,1,:,1)
    slopey_yz(COMP,1,:,0) = slopey_yz(COMP,1,:,1)

    ! Set the very bottom level slope
    do k = 1, nk
       where (k == Grid%kmt(COMP))
          slopex_xz(COMP,k,0,1) = slopex_xz(COMP,k,0,0)
          slopex_xz(COMP,k,1,1) = slopex_xz(COMP,k,1,0)
          slopey_yz(COMP,k,0,1) = slopey_yz(COMP,k,0,0)
          slopey_yz(COMP,k,1,1) = slopey_yz(COMP,k,1,0)
       endwhere
    enddo

    slopex_z(COMP,:,:)   = sum(slopex_xz(COMP,:,:,:), dim=4)/2.0
    slopey_z(COMP,:,:)   = sum(slopey_yz(COMP,:,:,:), dim=4)/2.0
    absslope_z(COMP,:,:) = sqrt(slopex_z(COMP,:,:)**2 + slopey_z(COMP,:,:)**2)

    slopex(COMP,:)   = sum(slopex_z(COMP,:,:), dim=4)/2.0
    slopey(COMP,:)   = sum(slopey_z(COMP,:,:), dim=4)/2.0
    absslope(COMP,:) = sqrt(slopex(COMP,:)**2 + slopey(COMP,:)**2)

    call diagnose_3d(Time, Grid, id_slopex, slopex, abs_max=1.e10)
    call diagnose_3d(Time, Grid, id_slopey, slopey, abs_max=1.e10)

  end subroutine neutral_slopes
  ! </SUBROUTINE> NAME="neutral_slopes"

  !#######################################################################
  ! <SUBROUTINE NAME="neutral_blayer">
  !
  ! <DESCRIPTION>
  ! Locate the vertical index of the neutral boundary layer. This layer is
  ! defined as the point where the magnitude of the neutral slope vector
  ! first drops below smax, when searching down from the surface.
  ! </DESCRIPTION>
  !
  subroutine neutral_blayer(smax, absslope, ksurf_blayer)
    real,                          intent(in) :: smax
    real, dimension(isd:,jsd:,:),  intent(in) :: absslope
    integer, dimension(isd:,jsd:), intent(out) :: ksurf_blayer

    logical, dimension(isc:iec,jsc:jec) :: slopeok
    integer :: k

    slopeok(COMP) = .false.
    ksurf_blayer(COMP) = nk
    do k = nk, 1, -1
       where (absslope(COMP,k) < smax .and. .not. slopeok(COMP))
          ksurf_blayer(COMP) = k - 1
       elsewhere
          slopeok(COMP) = .true.
       endwhere
       if (all(slopeok(COMP))) exit
    enddo

  end subroutine neutral_blayer
  ! </SUBROUTINE> NAME="neutral_blayer"

  !#######################################################################
  ! <SUBROUTINE NAME="ocean_nphysics_new_restart">
  !
  ! <DESCRIPTION>
  ! Write out the restart data for this module
  ! </DESCRIPTION>
  !
  subroutine ocean_nphysics_new_restart(time_stamp)
    character(len=*), intent(in), optional :: time_stamp

    if(.not. use_this_module) return

    call save_restart(nphysics_new_restart, time_stamp)

  end subroutine ocean_nphysics_new_restart
  ! </SUBROUTINE> NAME="ocean_nphysics_new_restart"

  !#######################################################################
  ! <SUBROUTINE NAME="ocean_nphysics_new_end">
  !
  ! <DESCRIPTION>
  ! Writes out the restart data.
  ! </DESCRIPTION>
  !
  subroutine ocean_nphysics_new_end()

    if(.not. use_this_module) return

    if (.not. module_is_initialized ) then 
       call mpp_error(FATAL, &
            '==>Error from ocean_nphysics_new (ocean_nphysics_new_end): needs initialization')
    endif

    call ocean_nphysics_new_restart()

  end subroutine ocean_nphysics_new_end
  ! </SUBROUTINE> NAME="ocean_nphysics_new_end"

end module ocean_nphysics_new_mod

module atmosphere_mod

!-----------------------------------------------------------------------
!
!         interface for fv dynamical core and physics
!
!-----------------------------------------------------------------------
!---------------- m o d u l e   i n f o r m a t i o n ------------------


use time_manager_mod, only: time_type, get_time, set_time, operator(+)

use fms_mod, only: file_exist, open_namelist_file, &
                               error_mesg, FATAL,              &
                               check_nml_error, stdlog,        &
                               write_version_number,           &
                               mpp_pe, mpp_root_pe,            &
                               close_file, set_domain,         &
                               mpp_clock_id, mpp_clock_begin,  &
                               mpp_clock_end, CLOCK_SUBCOMPONENT, &
                               clock_flag_default

use     fv_physics_mod, only: fv_physics_down, fv_physics_up,  &
                              fv_physics_init, fv_physics_end, &
                              surf_diff_type

use    mpp_domains_mod, only: domain2d
use  field_manager_mod, only: MODEL_ATMOS
use   diag_manager_mod, only: diag_send_complete
use      constants_mod, only: omega, cp_air, rdgas, grav, rvgas, kappa, radius, pstd_mks

use            fv_pack, only: nlon, mlat, nlev, beglat, endlat, beglon, &
                              endlon, rlonb, rlatb,  cold_start, ncnst, &
                              pnats, consv_te, ptop, fv_init, fv_domain, &
                              fv_end, change_time, restart_format, area, &
                              ak, bk
use     fv_diagnostics, only: fv_diag_init, fv_diag, fv_time
use       timingModule, only: timing_on, timing_off
use fv_restart_mod, only: fv_restart, write_fv_rst
use fv_dynamics_mod, only: fv_dynamics
use fv_arrays_mod, only: fv_print_chksums
use mpp_mod, only: mpp_error, input_nml_file
use tracer_manager_mod, only: get_tracer_index, NO_TRACER
use xgrid_mod, only: grid_box_type

!-----------------------------------------------------------------------

implicit none
private

public  atmosphere_down,       atmosphere_up,       &
        atmosphere_init,       atmosphere_end,      &
        atmosphere_resolution, atmosphere_boundary, &
        atmosphere_cell_area,  atmosphere_restart,  &
        get_atmosphere_axes,   atmosphere_domain

public  get_bottom_mass,  get_bottom_wind,  get_stock_pe

public  surf_diff_type

integer sec
integer seconds, days
integer liq_wat, ice_wat
!-----------------------------------------------------------------------

character(len=128) :: version = '$Id: atmosphere.F90,v 20.0 2013/12/13 23:08:15 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!-----------------------------------------------------------------------
!---- namelist (saved in file input.nml) ----
!
! physics_window  The number of "i" by "j" rows processed each time
!                 the modular physics is called. To process the entire
!                 domain use physics_window = (/0,0/).
!                   [integer, default: physics_window = 0,0]

   integer, dimension(2) :: physics_window = (/0,0/)

! Note: the default size of window(1) is chosen to work for N30, N45, ...

   namelist /atmosphere_nml/ physics_window

!-----------------------------------------------------------------------
!---- private data ----

  type    (time_type) :: Time_step_atmos
  real                :: dt_atmos
  integer, dimension(4)              :: atmos_axes
  integer :: id_dynam, id_phys_down, id_phys_up, id_fv_diag

!-----------------------------------------------------------------------

contains

 subroutine atmosphere_init (Time_init, Time, Time_step, Surf_diff, Grid_box)

 type (time_type),     intent(in)    :: Time_init, Time, Time_step
 type(surf_diff_type), intent(inout) :: Surf_diff
 type(grid_box_type),  intent(inout) :: Grid_box

  integer :: unit, ierr, io
  integer :: ss, ds, log_unit

!----- read namelist -----

#ifdef INTERNAL_FILE_NML
      read (input_nml_file,atmosphere_nml,iostat=io)
      ierr = check_nml_error (io, 'atmosphere_nml')
#else
    if (file_exist('input.nml')) then
        unit = open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
           read (unit, nml=atmosphere_nml, iostat=io, end=10)
           ierr = check_nml_error (io, 'atmosphere_nml')
        enddo
 10     call close_file (unit)
    endif
#endif

!----- write version and namelist to log file -----

    call write_version_number(version, tagname)
    if ( mpp_pe() == mpp_root_pe() ) then
       log_unit = stdlog()
       write (log_unit, nml=atmosphere_nml)
    endif

!---- compute physics/atmos time step in seconds ----

   Time_step_atmos = Time_step
   call get_time (Time_step_atmos, sec)
   dt_atmos = real(sec)

!----- initialize FV dynamical core -----

   call fv_init( sec )
   call fv_restart( days, seconds )

    if ( cold_start .or. change_time ) then
        fv_time = time
    else
        fv_time = set_time (seconds, days)
        call get_time (Time, ss,  ds)

        if( seconds /= ss .or. days /= ds )   call  error_mesg         &
            ('FV_init:','Time inconsistent between fv_rst and INPUT/atmos_model.res', FATAL)
    endif

!----- initialize atmos_axes and fv_dynamics diagnostics

    call fv_diag_init( atmos_axes, Time )
!    call fv_print_chksums( 'after fv_diag_init' )
   

!----- initialize physics interface -----
!----- initialize domains for reading global physics data -----

    call set_domain ( fv_domain )

    call fv_physics_init (atmos_axes, Time, physics_window, Surf_diff)
!    call fv_print_chksums( 'after fv_physics_init' )


!  --- initialize clocks for dynamics, physics_down and physics_up

    id_dynam     = mpp_clock_id ('FV dynamical core',   &
                       flags=clock_flag_default, grain=CLOCK_SUBCOMPONENT )
    id_phys_down = mpp_clock_id ('Physics_down',   &
                       flags=clock_flag_default, grain=CLOCK_SUBCOMPONENT )
    id_phys_up   = mpp_clock_id ('Physics_up',   &
                       flags=clock_flag_default, grain=CLOCK_SUBCOMPONENT )
    id_fv_diag   = mpp_clock_id ('FV Diag',   &
                       flags=clock_flag_default, grain=CLOCK_SUBCOMPONENT )

    call fv_print_chksums( 'Exiting  atmosphere_init' )

    liq_wat = get_tracer_index(MODEL_ATMOS, 'liq_wat')
    ice_wat = get_tracer_index(MODEL_ATMOS, 'ice_wat')
 end subroutine atmosphere_init

 subroutine atmosphere_down (Time,    frac_land,             &
      t_surf,  albedo,                &
      albedo_vis_dir, albedo_nir_dir, &
      albedo_vis_dif, albedo_nir_dif, &
      rough_mom,                      &
      u_star,  b_star, q_star,        &
      dtau_du, dtau_dv, tau_x, tau_y, &
      frac_open_sea,                  &
      gust, coszen, coszen_radwt, flux_sw,          &
      flux_sw_dir, flux_sw_dif,       &
      flux_sw_down_vis_dir,           &
      flux_sw_down_vis_dif,           &
      flux_sw_down_total_dir,         &
      flux_sw_down_total_dif,         &
      flux_sw_vis,                    &
      flux_sw_vis_dir,                &
      flux_sw_vis_dif,                &
      flux_lw,                        &
      Surf_diff                       )
#include "fv_arrays.h"
!
!        Time = time at the current time level
!

   type(time_type),intent(in)    :: Time

   real, intent(in),    dimension(:,:) :: frac_land,                 &
        t_surf, albedo,            &
        albedo_vis_dir, albedo_nir_dir, &
        albedo_vis_dif, albedo_nir_dif, &
        rough_mom, u_star, b_star, &
        q_star, dtau_du, dtau_dv
   real, intent(in),    dimension(:,:) :: frac_open_sea
   real, intent(inout), dimension(:,:) :: tau_x,  tau_y
   real, intent(out),   dimension(:,:) :: gust, coszen, coszen_radwt, flux_sw, &
        flux_sw_dir, flux_sw_dif, &
        flux_sw_down_vis_dir,     &
        flux_sw_down_total_dir,   &
        flux_sw_down_vis_dif,     &
        flux_sw_down_total_dif,   &
        flux_sw_vis,              &
        flux_sw_vis_dir,          &
        flux_sw_vis_dif, flux_lw
   type(surf_diff_type), intent(inout) :: Surf_diff

   type(time_type) :: Time_prev, Time_next
   real zvir
#include "fv_point.inc"

   coszen_radwt = 0.

   zvir = rvgas/rdgas - 1.
   call fv_print_chksums( 'Entering  atmosphere_down' )

   Time_prev = Time                       ! two time-level scheme
   Time_next = Time + Time_step_atmos

!---- dynamics -----

   call timing_on('fv_dynamics')
   call mpp_clock_begin (id_dynam)
#ifndef USE_LIMA
   call fv_dynamics (nlon,    mlat,   nlev,    beglat,   endlat,    &
        ncnst,   pnats,  .false., consv_te,            &
        u,       v,      delp,    pt,       q,         &
        ps,      pe,     pk,      pkz,      phis,      &
        omga,    peln,   ptop,    omega,    sec,       &
        zvir,    cp_air, rdgas,   kappa,  radius, ua, va, Time_next )
#else
   call fv_dynamics (nlon,    mlat,   nlev,    beglat,   endlat,    &
        ncnst,   pnats,  .false., consv_te,            &
        u,       v,      delp,    pt,       q,         &
        ps,      pe,     pk,      pkz,      phis,      &
        omga,    peln,   ptop,    omega,    sec,       &
        zvir,    cp_air, rdgas,   kappa,  radius, ua, va )
#endif
   call mpp_clock_end (id_dynam)
   call timing_off('fv_dynamics')

!---- call physics -----

   call timing_on('fv_physics_down')
   call mpp_clock_begin (id_phys_down)
   call fv_physics_down (dt_atmos, Time_prev, Time, Time_next,     &
        frac_land, albedo,              &
        albedo_vis_dir, albedo_nir_dir, &
        albedo_vis_dif, albedo_nir_dif, &
        rough_mom,  t_surf,             &
        u_star,  b_star, q_star,        &
        dtau_du, dtau_dv, tau_x, tau_y, &
        flux_sw, flux_sw_dir,           &
        flux_sw_dif,                    &
        flux_sw_down_vis_dir,           &
        flux_sw_down_vis_dif,           &
        flux_sw_down_total_dir,         &
        flux_sw_down_total_dif,         &
        flux_sw_vis, flux_sw_vis_dir,   &
        flux_sw_vis_dif, flux_lw,       &
        coszen, gust, Surf_diff, frac_open_sea )
   call mpp_clock_end (id_phys_down)
   call timing_off('fv_physics_down')

   call fv_print_chksums( 'Exiting  atmosphere_down' )
 end subroutine atmosphere_down


 subroutine atmosphere_up (Time,  frac_land, Surf_diff, lprec, fprec, gust, u_star, b_star, q_star )

   type(time_type),intent(in)        :: Time
   real, intent(in),  dimension(:,:) :: frac_land
   type(surf_diff_type), intent(inout) :: Surf_diff
   real, intent(out), dimension(:,:) :: lprec,   fprec
   real, intent(inout), dimension(:,:) :: gust
   real,dimension(:,:),    intent(in) :: u_star, b_star, q_star

   type(time_type) :: Time_prev, Time_next
   real zvir

   zvir = rvgas/rdgas - 1.
   call fv_print_chksums( 'Entering  atmosphere_up' )
   Time_prev = Time                       ! two time-level scheme
   Time_next = Time + Time_step_atmos

   call timing_on('fv_physics_up')
   call mpp_clock_begin (id_phys_up)
   call fv_physics_up( dt_atmos, Time_prev, Time, Time_next,      &
        frac_land,  Surf_diff,           &
        lprec,      fprec,      gust, u_star, b_star, q_star     )
   call mpp_clock_end (id_phys_up)
   call timing_off('fv_physics_up')

!---- diagnostics for FV dynamics -----
   call timing_on('FV_DIAG')
   call mpp_clock_begin(id_fv_diag)
   fv_time = Time + Time_step_atmos
   call get_time (fv_time, seconds,  days)

   call fv_diag(fv_time, nlon, mlat, nlev, beglat, endlat, &       
        ncnst, zvir, dt_atmos, .false.)                          
   call timing_off('FV_DIAG')     
   call mpp_clock_end(id_fv_diag)

   ! Indicate to diag_manager to write diagnostics to file (if needed)
   ! This is needed for a threaded run.
   call diag_send_complete(Time_step_atmos)

   call fv_print_chksums( 'Exiting  atmosphere_up' )
#ifdef PSET_DEBUG
   call mpp_error( FATAL, 'ATMOSPHERE_UP is set to abort if -DPSET_DEBUG!' )
#endif
 end subroutine atmosphere_up


 subroutine atmosphere_end (Time, Grid_box)

 type (time_type), intent(in) :: Time
 type(grid_box_type),  intent(inout) :: Grid_box

!----- initialize domains for writing global physics data -----

    call set_domain ( fv_domain )
    call get_time (Time, seconds,  days)
    call write_fv_rst( 'RESTART/fv_rst.res', days, seconds, grav, &
         restart_format )

    call fv_end(days, seconds)      

    call fv_physics_end(Time) 


 end subroutine atmosphere_end

  !#######################################################################
  ! <SUBROUTINE NAME="atmosphere_restart">
  ! <DESCRIPTION>
  !  dummy routine.
  ! </DESCRIPTION>
  subroutine atmosphere_restart(timestamp)
    character(len=*),  intent(in) :: timestamp

    call error_mesg ('atmosphere_restart in atmosphere_mod', &
                     'intermediate restart capability is not implemented for this model', FATAL)

  end subroutine atmosphere_restart
  ! </SUBROUTINE>

!---------------------------------------------------------------
!    returns the number of longitude and latitude grid points
!    for either the local PEs grid (default) or the global grid
!---------------------------------------------------------------

 subroutine atmosphere_resolution (i_size, j_size, global)

   integer, intent(out)          :: i_size, j_size
   logical, intent(in), optional :: global
   logical :: local

   local = .TRUE.
   if( PRESENT(global) )local = .NOT.global

   if( local )then
       i_size = endlon - beglon + 1
       j_size = endlat - beglat + 1
   else
       i_size = nlon
       j_size = mlat
   end if
 end subroutine atmosphere_resolution


 subroutine atmosphere_cell_area  (area_out)
    real, dimension(:,:),  intent(out) :: area_out

    area_out(1:size(area_out,1), 1:size(area_out,2)) =  &
                                   area (beglon:endlon, beglat:endlat)

 end subroutine atmosphere_cell_area


!---------------------------------------------------------------
!    returns the longitude and latitude grid box edges
!    for either the local PEs grid (default) or the global grid
!---------------------------------------------------------------

 subroutine atmosphere_boundary (blon, blat, global)

    real,    intent(out)          :: blon(:,:), blat(:,:)   ! radian
    logical, intent(in), optional :: global
! Local:
    integer i,j
    logical :: local

    local = .TRUE.
    if( PRESENT(global) )local = .NOT.global

    if( local )then
        do i = beglon,endlon+1
           blon(i-beglon+1,:) = rlonb(i)
        end do
        do j = beglat,endlat+1
           blat(:,j-beglat+1) = rlatb(j)
        end do
    else
        do i=1,nlon+1
           blon(i,:) = rlonb(i)
        end do
        do j=1,mlat+1
           blat(:,j) = rlatb(j)
        end do
    end if

 end subroutine atmosphere_boundary




 subroutine atmosphere_domain (Domain)
 type(domain2d), intent(inout) :: Domain

!  returns the domain2d variable associated with the coupling grid
!  note: coupling is done using the mass/temperature grid with no halos

   Domain = fv_domain

 end subroutine atmosphere_domain


 subroutine get_atmosphere_axes ( axes )
! returns the axis indices associated with the coupling grid

   integer, intent(out) :: axes (:)

!----- returns the axis indices for the atmospheric (mass) grid -----

     if ( size(axes(:)) < 0 .or. size(axes(:)) > 4 ) call error_mesg (    &
                           'get_atmosphere_axes in atmosphere_mod', &
                           'size of argument is incorrect', FATAL   )

     axes (1:size(axes(:))) = atmos_axes (1:size(axes(:)))

 
 end subroutine get_atmosphere_axes



 subroutine get_bottom_mass (t_bot, tr_bot, p_bot, z_bot, p_surf, slp)

#include "fv_arrays.h"
! returns temp, sphum, pres, height at the lowest model level
!         and surface pressure and sea level pressure

   real, intent(out), dimension(beglon:endlon,beglat:endlat)  &
        :: t_bot, p_bot, z_bot, p_surf, slp
   real, intent(out), dimension(beglon:endlon,beglat:endlat,ncnst-pnats):: tr_bot
   integer :: i, j, k, kr
   real zvir, rrg, sigtop, sigbot
   real, dimension(beglon:endlon,beglat:endlat) :: tref
   real, parameter :: tlaps = 6.5e-3
#include "fv_point.inc"

   rrg  = rdgas / grav
   zvir = rvgas/rdgas - 1.


   ! determine 0.8 sigma reference level
   sigtop = ak(1)/pstd_mks+bk(1)
   do k = 1, nlev 
      sigbot = ak(k+1)/pstd_mks+bk(k+1)
      if (sigbot+sigtop > 1.6) then
         kr = k
         exit
      endif   
      sigtop = sigbot
   enddo

!$omp parallel do default(shared)    &
!$omp private (i, j)
     do j = beglat, endlat
        do i = beglon, endlon
           p_surf(i,j) =  ps(i,j)
           t_bot(i,j) =  pt(i,j,nlev)

           p_bot(i,j) = delp(i,j,nlev)/(peln(i,nlev+1,j)-peln(i,nlev,j))
           z_bot(i,j) = rrg*t_bot(i,j)*(1.+zvir*q(i,j,nlev,1))*  &
                  (1. - pe(i,nlev,j)/p_bot(i,j))
           ! sea level pressure
           tref(i,j) = pt(i,j,kr)*(delp(i,j,kr)/((peln(i,kr+1,j)-peln(i,kr,j))*ps(i,j)))**(-rrg*tlaps)
           slp(i,j) = ps(i,j)*(1.+tlaps*phis(i,j)/(tref(i,j)*grav))**(1./(rrg*tlaps))
        enddo
     enddo
! Copy tracers
!$omp parallel do default(shared)    &
!$omp private (i, j, k)
     do k = 1,ncnst-pnats
        do j = beglat,endlat
           do i = beglon,endlon
              tr_bot(i,j,k) = q(i,j,nlev,k)
           enddo
        enddo
     enddo

 end subroutine get_bottom_mass



 subroutine get_bottom_wind (u_bot, v_bot)
#include "fv_arrays.h"
!-----------------------------------------------------------
! returns u and v on the mass grid at the lowest model level
!-----------------------------------------------------------

   real, intent(out), dimension(beglon:,beglat:) :: u_bot, v_bot

   integer i, j
#include "fv_point.inc"
!Balaji: this cannot work unless beglon=1: corrected declaration Lbounds
   do j=beglat,endlat
      do i=beglon,endlon
         u_bot(i,j) = u_srf(i,j)
         v_bot(i,j) = v_srf(i,j)
      enddo
   enddo

 end subroutine get_bottom_wind

 subroutine get_stock_pe(index, value)
#include "fv_arrays.h"
    integer, intent(in) :: index
    real, intent(out)   :: value
#ifdef USE_STOCK
    include 'stock.inc' 
#endif
    real wm(beglon:endlon, beglat:endlat)
    integer i,j,k
#include "fv_point.inc"
   
    select case (index)
#ifdef USE_STOCK
    case (ISTOCK_WATER)
#else
    case (1)
#endif
     
!----------------------
! Perform vertical sum:
!----------------------
     wm = 0.
     do j = beglat, endlat
        do k=1,nlev
           do i = beglon, endlon
! Note: There is a check in fv_pack.F90 that ensures that tracer number one
!       is sphum and that the cloud water and ice tracers exist.
              wm(i,j) = wm(i,j) + delp(i,j,k)*(q(i,j,k,1)+q(i,j,k,liq_wat)+q(i,j,k,ice_wat))
           enddo
        enddo
     enddo

!----------------------
! Horizontal sum:
!----------------------
     value = 0.
     do j = beglat, endlat
        do i = beglon, endlon
           value = value + wm(i,j)*area(i,j)
        enddo
     enddo
     value = value/grav

    case default
     value = 0.0
    end select

 end subroutine get_stock_pe 

end module atmosphere_mod

module ocean_nphysicsA_mod
#define COMP isc:iec,jsc:jec
#define COMPXL isc-1:iec,jsc:jec
#define COMPYL isc:iec,jsc-1:jec
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<CONTACT EMAIL="Russell.Fiedler@csiro.au"> Russell Fiedler 
!</CONTACT>
!
!<REVIEWER EMAIL="tim.leslie@gmail.com"> Tim Leslie
!</REVIEWER>
!  
!<OVERVIEW>
! Thickness weighted and density weighted time tendency for tracer 
! from Laplacian neutral diffusion + Laplacian GM skew-diffusion.
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes the cell thickness weighted and density 
! weighted tracer tendency from small angle Laplacian neutral diffusion
! plus Laplacian GM skew-diffusion.  The algorithms are based on 
! MOM4p0d methods.  The fundamental differences from the ocean_nphysicsB
! methods relate to the handling of fluxes near the domain boundaries.  
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies, A. Gnanadesikan, R.C. Pacanowski, V. Larichev, 
! J.K. Dukowicz,  and R.D. Smith
! Isoneutral diffusion in a z-coordinate ocean model
! Journal of Physical Oceanography (1998) vol 28 pages 805-830
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies 
! The Gent-McWilliams Skew-flux 
! Journal of Physical Oceanography (1998) vol 28 pages 831-841
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies 
! Fundamentals of Ocean Climate Models (2004)
! Princeton University Press 
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, Elements of MOM (2012)
! </REFERENCE>
!
! <REFERENCE>
! G. Danabasoglu and J. C. McWilliams
! Sensitivity of the global ocean circulation to 
! parameterizations of mesoscale tracer transports
! Journal of Climate (1995) vol 8 pages 2967--2987 
! </REFERENCE>
!
! <REFERENCE>
! Gerdes, Koberle, and Willebrand
! The influence of numerical advection schemes on the results of ocean
! general circulation models, Climate Dynamics (1991), vol. 5, 
! pages 211--226. 
! </REFERENCE>
!
! <NOTE>
! Numerical implementation of the flux components follows the triad 
! approach documented in the references and implemented in MOM2 and MOM3.  
! The MOM algorithm accounts for partial bottom cells and generalized
! orthogonal horizontal coordinates.
! </NOTE> 
!
! <NOTE>
! neutral_physics_simple=.true. requires aredi_equal_agm=.true.
! neutral_physics_simple=.true. results in down-gradient  
! horizontal flux components. This setting reduces the overall cost 
! of the neutral physics scheme, but it is not used at GFDL
! anymore, since we favor methods whereby treatment of GM and Redi
! in the boundary layers are distinct.  
! </NOTE> 
!
! <NOTE> 
! In steep slope regions, neutral diffusive fluxes are tapered to
! zero with the tanh taper of Danabasoglu and McWilliams (1995) or the 
! quadratic scheme of Gerdes, Koberle, and Willebrand.  However, if
! neutral_physics_simple=.false., the GM skew-diffusive fluxes 
! can remain nonzero if have neutral_linear_gm_taper=.true.
! </NOTE> 
!
! </INFO>
!
!<NAMELIST NAME="ocean_nphysicsA_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For printing starting and ending checksums for restarts
!  </DATA> 
!
!  <DATA NAME="use_gm_skew" TYPE="logical">
!  Must be true to use GM skewsion.  Set to false if wish to 
!  incorporate the "GM-effect" through form drag, as in 
!  ocean_form_drag module. Default use_gm_skew=.true. 
!  </DATA> 
!
!  <DATA NAME="diffusion_all_explicit" TYPE="logical">
!  To compute all contributions from neutral diffusion explicitly in time, including
!  the K33 diagonal piece.  This approach is available only when have small time 
!  steps and/or running with just a single tracer.  It is for testing purposes. 
!  </DATA> 
!
!  <DATA NAME="neutral_physics_simple" TYPE="logical">
!  If .true. then must have aredi_equal_agm=.true..  The horizontal fluxes are then 
!  computed as horizontal downgradient diffusive fluxes regardless the neutral slope.
!  This approach precluds one from being able to have the GM-skew fluxes remain active
!  in the steep sloped regions, thus shutting off their effects to reduce the slopes 
!  of isopycnals in convective and mixed layer regimes.  It is for this reason that
!  neutral_physics_simple=.false. is the recommended default in MOM.  
!  </DATA> 
!
!  <DATA NAME="neutral_physics_limit" TYPE="logical">
!  When tracer falls outside a specified range, revert to horizontal 
!  diffusive fluxes at this cell. This is an ad hoc and incomplete attempt
!  to maintain monotonicity with the neutral physics scheme.  
!  Default neutral_physics_limit=.true.
!  </DATA> 
!  <DATA NAME="tmask_neutral_on" TYPE="logical">
!  If .true. then this logical reduces the neutral fluxes to 
!  horizontal/vertical diffusion next to boundaries.  
!  This approach has been found to reduce spurious 
!  extrema resulting from truncation of triads used to compute 
!  a neutral flux component. Default tmask_neutral_on=.false.   
!  </DATA> 
!
!  <DATA NAME="dm_taper" TYPE="logical">
!  Set to true to use the tanh tapering scheme of Danabasoglu and McWilliams.
!  Default is true. 
!  </DATA> 
!  <DATA NAME="gkw_taper" TYPE="logical">
!  Set to true to use the quadradic tapering scheme of Gerdes, Koberle, and Willebrand.
!  Default is false. 
!  </DATA> 
!
!  <DATA NAME="neutral_linear_gm_taper" TYPE="logical">
!  If .true. then with neutral_physics_simple=.false., will linearly taper GM
!  skew fluxes towards the surface within regions of steep neutral slopes.  
!  This approach leads to a constant horizontal eddy-induced velocity in 
!  the steeply sloping regions and is recommended for realistic simulations. 
!  </DATA> 
!  <DATA NAME="neutral_sine_taper" TYPE="logical">
!  If .true. then with neutral_physics_simple=.false., will apply a sine-taper 
!  to GM and neutral diffusive fluxes in regions where the penetration depth 
!  of eddies is deeper than the grid point. This method is essential for 
!  fine vertical resolution grids. 
!  </DATA> 
!
!  <DATA NAME="turb_blayer_min" TYPE="real">
!  Minimum depth of a surface turbulent boundary layer
!  used in the transition of the neutral physics fluxes
!  to the surface.  Note that in MOM4.0, 
!  turb_blayer_min was always set to zero. 
!  </DATA> 
!
!  <DATA NAME="neutral_blayer_diagnose" TYPE="logical">
!  Diagnose properties of the neutral physics boundary layer, whether have 
!  neutral_linear_gm_taper or neutral_sine_taper true or not.  
!  </DATA> 
!
!  <DATA NAME="neutral_taper_diagonal" UNITS="dimensionless" TYPE="logical">
!  For cases with neutral_physics_simple=.false., then neutral_taper_diagonal=.true.
!  will taper the diagonal pieces of the horizontal flux components when neutral slopes
!  are steep. With neutral_taper_diagonal=.false., then the horizontal flux components will 
!  remain enabled for all slopes, thus producing horizontal downgradient diffusion in 
!  regions of vertical neutral directions.
!  </DATA> 
!
!</NAMELIST>

use constants_mod,           only: epsln, pi
use diag_manager_mod,        only: register_diag_field, register_static_field, need_data
use fms_mod,                 only: FATAL, WARNING, NOTE
use fms_mod,                 only: open_namelist_file, check_nml_error, close_file, write_version_number
use mpp_domains_mod,         only: mpp_update_domains
use mpp_domains_mod,         only: CGRID_NE, WUPDATE, SUPDATE, EUPDATE, NUPDATE
use mpp_domains_mod,         only: cyclic_global_domain, global_data_domain 
use mpp_mod,                 only: input_nml_file, mpp_error, stdout, stdlog
use mpp_mod,                 only: mpp_clock_id, mpp_clock_begin, mpp_clock_end, CLOCK_ROUTINE
use time_manager_mod,        only: set_time, time_type, increment_time, operator ( + )

use ocean_domains_mod,           only: get_local_indices, set_ocean_domain
use ocean_nphysics_util_mod,     only: ocean_nphysics_coeff_init, ocean_nphysics_coeff_end
use ocean_nphysics_util_mod,     only: neutral_slopes, tracer_derivs 
use ocean_nphysics_util_mod,     only: compute_eady_rate, compute_baroclinicity
use ocean_nphysics_util_mod,     only: compute_rossby_radius, compute_bczone_radius
use ocean_nphysics_util_mod,     only: compute_diffusivity, ocean_nphysics_util_restart
use ocean_nphysics_util_mod,     only: transport_on_nrho_gm, transport_on_rho_gm, transport_on_theta_gm
use ocean_nphysics_util_mod,     only: cabbeling_thermob_tendency
use ocean_nphysics_util_mod,     only: compute_eta_tend_gm90
use ocean_nphysics_util_mod,     only: watermass_diag_init, watermass_diag
use ocean_operators_mod,         only: FAX, FAY, FMX, FMY, BDX_ET, BDY_NT
use ocean_parameters_mod,        only: missing_value, onehalf, onefourth, oneeigth, DEPTH_BASED
use ocean_parameters_mod,        only: rho0r, rho0, grav
use ocean_sigma_transport_mod,   only: tmask_sigma_on, tmask_sigma  
use ocean_types_mod,             only: ocean_grid_type, ocean_domain_type, ocean_density_type
use ocean_types_mod,             only: ocean_prog_tracer_type, ocean_thickness_type
use ocean_types_mod,             only: ocean_time_type, ocean_time_steps_type
use ocean_types_mod,             only: tracer_2d_type, tracer_3d_0_nk_type, tracer_3d_1_nk_type 
use ocean_util_mod,              only: write_note, write_line, write_warning
use ocean_util_mod,              only: diagnose_2d, diagnose_3d
use ocean_workspace_mod,         only: wrk1, wrk3, wrk1_v, wrk1_2d

implicit none

public ocean_nphysicsA_init
public ocean_nphysicsA_end
public nphysicsA
public ocean_nphysicsA_restart

private fx_flux
private fy_flux
private fz_flux
private fz_terms
private fx_flux_diag
private fy_flux_diag
private fz_terms_diag 
private fz_flux_diag
private neutral_blayer
private slope_function_gm
private gm_velocity
private nphysics_diagnostics

private 

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_domain_type), save    :: Dom_flux

integer :: num_prog_tracers = 0

! clock ids
integer :: id_clock_neutral_blayer
integer :: id_clock_neutral_blayer_1
integer :: id_clock_neutral_blayer_2
integer :: id_clock_neutral_blayer_3
integer :: id_clock_fz_terms 
integer :: id_clock_fx_flux
integer :: id_clock_fy_flux
integer :: id_clock_fz_flux
integer :: id_clock_fx_flux_diag
integer :: id_clock_fy_flux_diag
integer :: id_clock_fz_flux_diag
integer :: id_clock_fz_terms_diag

! diagnostic manager ids
logical :: used
integer :: id_k33_explicit          =-1
integer :: id_ah_bdy                =-1
integer :: id_ustar                 =-1
integer :: id_vstar                 =-1
integer :: id_wstar                 =-1
integer :: id_tx_trans_gm           =-1
integer :: id_ty_trans_gm           =-1
integer :: id_depth_blayer_base     =-1
integer :: id_eddy_depth            =-1
integer :: id_steep_depth           =-1
integer :: id_slope_blayer_base     =-1
integer :: id_grav_agm_dz_sx_drhodx =-1
integer :: id_grav_agm_dz_sy_drhody =-1
integer :: id_gm_eddy_ke_source     =-1
integer :: id_slopex_drhodx         =-1
integer :: id_slopey_drhody         =-1

integer, dimension(:), allocatable  :: id_neutral_physics
integer, dimension(:), allocatable  :: id_neutral_physics_ndiffuse
integer, dimension(:), allocatable  :: id_neutral_physics_gm
integer, dimension(:), allocatable  :: id_k33_implicit
integer, dimension(:), allocatable  :: id_flux_x       ! for i-directed heat flux from neutral physics 
integer, dimension(:), allocatable  :: id_flux_y       ! for j-directed heat flux from neutral physics 
integer, dimension(:), allocatable  :: id_flux_x_int_z ! for vertically integrated i-directed tracer flux 
integer, dimension(:), allocatable  :: id_flux_y_int_z ! for vertically integrated j-directed tracer flux 

integer, dimension(:), allocatable  :: id_flux_x_gm       ! for i-directed heat flux from GM stirring 
integer, dimension(:), allocatable  :: id_flux_y_gm       ! for j-directed heat flux from GM stirring 
integer, dimension(:), allocatable  :: id_flux_x_gm_int_z ! for vertically integrated i-directed GM tracer flux 
integer, dimension(:), allocatable  :: id_flux_y_gm_int_z ! for vertically integrated j-directed GM tracer flux 

integer, dimension(:), allocatable  :: id_flux_x_ndiffuse       ! for i-directed heat flux from neutral diffusion 
integer, dimension(:), allocatable  :: id_flux_y_ndiffuse       ! for j-directed heat flux from neutral diffusion 
integer, dimension(:), allocatable  :: id_flux_x_ndiffuse_int_z ! for vertically integrated i-directed neutral diffusive flux 
integer, dimension(:), allocatable  :: id_flux_y_ndiffuse_int_z ! for vertically integrated j-directed neutral diffusive flux 

#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS

real, dimension(isd:ied,jsd:jed,nk,0:1) :: delqc   !density weighted (kg/m^3) quarter cell thickness(m)
real, dimension(isd:ied,jsd:jed,0:nk)   :: dzwtr   !(1/dzwt)(m^-1)
real, dimension(isd:ied,jsd:jed,0:1)    :: dtew    !grid distances from T-point to cell faces (m)
real, dimension(isd:ied,jsd:jed,0:1)    :: dtns    !grid distances from T-point to cell faces (m)
real, dimension(isd:ied,jsd:jed,0:1)    :: dtwedyt !horizontal areas (m^2) of quarter cell
real, dimension(isd:ied,jsd:jed,0:1)    :: dxtdtsn !horizontal areas (m^2) of quarter cell

real, dimension(isd:ied,jsd:jed,nk) :: slopex_drhodx         !3D array of slopex * drhodx for diagnostics
real, dimension(isd:ied,jsd:jed,nk) :: slopey_drhody         !3D array of slopey * drhody for diagnostics
real, dimension(isd:ied,jsd:jed,nk) :: grav_agm_dz_sx_drhodx !3D array of grav*agm*dz*slopex*drhodx for diagnostics
real, dimension(isd:ied,jsd:jed,nk) :: grav_agm_dz_sy_drhody !3D array of grav*agm*dz*slopey*drhody for diagnostics

real, dimension(isd:ied,jsd:jed,nk) :: aredi_array       !3D array of redi diffusivities (m^2/sec)     
real, dimension(isd:ied,jsd:jed,nk) :: agm_array         !3D array of gm diffusivities (m^2/sec)        
real, dimension(isd:ied,jsd:jed)    :: ah_array          !2D array of micom horizontal diffusivities (m^2/sec)

real, dimension(isd:ied,jsd:jed)    :: bczone_radius     !for bczone calculation (m) 
real, dimension(isd:ied,jsd:jed)    :: rossby_radius     !first baroclinic Rossby radius (m) 
real, dimension(isd:ied,jsd:jed)    :: rossby_radius_raw !first baroclinic Rossby radius (m) without min/max settings  
real, dimension(isd:ied,jsd:jed,nk) :: eady_termx        !rho_z*(S_x)^2 for computing Eady growth rate 
real, dimension(isd:ied,jsd:jed,nk) :: eady_termy        !rho_z*(S_y)^2 for computing Eady growth rate 
real, dimension(isd:ied,jsd:jed)    :: baroclinic_termx  !intermediate term for computing vert ave baroclinicity
real, dimension(isd:ied,jsd:jed)    :: baroclinic_termy  !intermediate term for computing vert ave baroclinicity 
real, dimension(isd:ied,jsd:jed)    :: grid_length       !grid length scale (m)

real, dimension(isd:ied,jsd:jed,nk)     :: drhodT       !drho/dtheta     (kg/m^3/C)
real, dimension(isd:ied,jsd:jed,nk)     :: drhodS       !drho/dsalinity  (kg/m^3/psu)
real, dimension(isd:ied,jsd:jed,nk,0:1) :: drhodzb      !vertical local ref potrho derivative (kg/m^3/m)
real, dimension(isd:ied,jsd:jed,nk,0:1) :: drhodzh      !vertical local ref potrho derivative (kg/m^3/m)

real, dimension(isd:ied,jsd:jed,nk)     :: K33_implicit !density weighted (kg/m^3) implicit in time 
                                                        !diagonal term in redi tensor (m^2/sec) 
real, dimension(isd:ied,jsd:jed,nk)     :: K33_explicit !density weighted (kg/m^3) explicit in time 
                                                        !diagonal term in redi tensor (m^2/sec) 

real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: tensor_31      !tracer independent portion of mixing tensor
real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: tensor_32      !tracer independent portion of mixing tensor
real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: tensor_31_redi !tracer independent portion of Redi diffusion tensor
real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: tensor_32_redi !tracer independent portion of Redi diffusion tensor

real, dimension(isd:ied,jsd:jed,nk) :: tx_trans_gm       !for diagnosing i-transport due to GM (Sv)
real, dimension(isd:ied,jsd:jed,nk) :: ty_trans_gm       !for diagnosing j-transport due to GM (Sv)

real, dimension(isd:ied,jsd:jed)    :: depth_blayer_base ! depth (m) of boundary layer base for neutral physics
real, dimension(isd:ied,jsd:jed)    :: slope_blayer_base ! abs(slope) at base of neutral boundary layer 
real, dimension(isd:ied,jsd:jed)    :: eddy_depth        ! max of depth(m) mesoscale eddies penetrate & kpp bldepth
real, dimension(isd:ied,jsd:jed)    :: turb_blayer_depth ! depth (m) of surface turbulent boundary layer
real, dimension(isd:ied,jsd:jed)    :: N2_blayer_base    ! squared buoyancy freq (1/s^2) at base of nblayer
integer, dimension(isd:ied,jsd:jed) :: ksurf_blayer      ! k-value at base of surface nblayer 

#else

real, dimension(:,:,:,:),   allocatable :: delqc   !density weighted (kg/m^3) quarter cell thickness(m)
real, dimension(:,:,:),     allocatable :: dzwtr   !(1/dzwt)(m^-1)
real, dimension(:,:,:),     allocatable :: dtew    !grid distances from T-point to cell faces (m)
real, dimension(:,:,:),     allocatable :: dtns    !grid distances from T-point to cell faces (m)
real, dimension(:,:,:),     allocatable :: dtwedyt !horizontal areas (m^2) of quarter cell
real, dimension(:,:,:),     allocatable :: dxtdtsn !horizontal areas (m^2) of quarter cell

real, dimension(:,:,:),     allocatable :: slopex_drhodx         !3D array of slopex * drhodx for diagnostics
real, dimension(:,:,:),     allocatable :: slopey_drhody         !3D array of slopey * drhody for diagnostics
real, dimension(:,:,:),     allocatable :: grav_agm_dz_sx_drhodx !3D array of grav*agm*dz*slopex*drhodx for diagnostics
real, dimension(:,:,:),     allocatable :: grav_agm_dz_sy_drhody !3D array of grav*agm*dz*slopey*drhody for diagnostics

real, dimension(:,:,:),     allocatable :: aredi_array       !3D array of redi diffusivities (m^2/sec) 
real, dimension(:,:,:),     allocatable :: agm_array         !3D array of gm diffusivities (m^2/sec)     
real, dimension(:,:),       allocatable :: ah_array          !2D array of micom horizontal diffusivities (m^2/sec)

real, dimension(:,:),       allocatable :: bczone_radius     !for bzcone calculation (m) 
real, dimension(:,:),       allocatable :: rossby_radius     !first baroclinic Rossby radius (m) 
real, dimension(:,:),       allocatable :: rossby_radius_raw !first baroclinic Rossby radius (m) without min/max settings
real, dimension(:,:,:),     allocatable :: eady_termx        !rho_z*(S_x)^2 for computing Eady growth rate 
real, dimension(:,:,:),     allocatable :: eady_termy        !rho_z*(S_y)^2 for computing Eady growth rate 
real, dimension(:,:),       allocatable :: baroclinic_termx  !intermediate term for computing vert ave baroclinicity 
real, dimension(:,:),       allocatable :: baroclinic_termy  !intermediate term for computing vert ave baroclinicity 
real, dimension(:,:),       allocatable :: grid_length       !grid length scale (m)

real, dimension(:,:,:),     allocatable :: drhodT           !drho/dtheta     (kg/m^3/C)
real, dimension(:,:,:),     allocatable :: drhodS           !drho/dsalinity  (kg/m^3/psu)
real, dimension(:,:,:,:),   allocatable :: drhodzb          !vertical local ref potrho derivative (kg/m^3/m)
real, dimension(:,:,:,:),   allocatable :: drhodzh          !vertical local ref potrho derivative (kg/m^3/m)

real, dimension(:,:,:),     allocatable :: K33_implicit   !density weighted (kg/m^3) implicit in time 
                                                          !diagonal term in redi tensor (m^2/sec) 
real, dimension(:,:,:),     allocatable :: K33_explicit   !density weighted (kg/m^3) explicit in time 

real, dimension(:,:,:,:,:), allocatable :: tensor_31      !tracer independent portion of mixing tensor
real, dimension(:,:,:,:,:), allocatable :: tensor_32      !tracer independent portion of mixing tensor
real, dimension(:,:,:,:,:), allocatable :: tensor_31_redi !tracer independent portion of Redi diffusion tensor
real, dimension(:,:,:,:,:), allocatable :: tensor_32_redi !tracer independent portion of Redi diffusion tensor

real, dimension(:,:,:),  allocatable :: tx_trans_gm       !for diagnosing i-transport due to GM (Sv)
real, dimension(:,:,:),  allocatable :: ty_trans_gm       !for diagnosing j-transport due to GM (Sv)

real, dimension(:,:),    allocatable :: depth_blayer_base ! depth (m) of boundary layer base for neutral physics
real, dimension(:,:),    allocatable :: slope_blayer_base ! abs(slope) at base of neutral boundary layer 
real, dimension(:,:),    allocatable :: eddy_depth        ! max of depth (m) mesoscale eddies penetrate & kpp bldepth
real, dimension(:,:),    allocatable :: turb_blayer_depth ! depth (m) of surface turbulent boundary layer
real, dimension(:,:),    allocatable :: N2_blayer_base    ! squared buoyancy freq (1/s^2) at base of nblayer
integer, dimension(:,:), allocatable :: ksurf_blayer      ! k-value at base of surface nblayer 

#endif


! introduce following derived types so that do not need to know num_prog_tracers at compile time 
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: dTdx    ! tracer partial derivative (tracer/m)
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: dTdy    ! tracer partial derivative (tracer/m)
type(tracer_3d_0_nk_type), dimension(:), allocatable  :: dTdz    ! tracer partial derivative (tracer/m)
type(tracer_3d_1_nk_type), save                       :: dSdx    ! Dens%rho_salinity partial derivative (tracer/m)
type(tracer_3d_1_nk_type), save                       :: dSdy    ! Dens%rho_salinity partial derivative (tracer/m)
type(tracer_3d_0_nk_type), save                       :: dSdz    ! Dens%rho_salinity partial derivative (tracer/m)
type(tracer_2d_type),      dimension(:), allocatable  :: fz1     ! z-flux component for tracers at particular k 
type(tracer_2d_type),      dimension(:), allocatable  :: fz2     ! z-flux component for tracers at particular k 
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: flux_x  ! i-flux component for tracers for all k
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: flux_y  ! j-flux component for tracers for all k


! for diagnosing effects from GM and Redi separately, we add the following fields for neutral diffusion
! and calculation the GM contribution as a difference of the total and the neutral diffusion piece.  
type(tracer_2d_type),      dimension(:), allocatable  :: fz1_redi      ! z-flux redi component for tracers at particular k 
type(tracer_2d_type),      dimension(:), allocatable  :: fz2_redi      ! z-flux redi component for tracers at particular k 
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: flux_x_redi   ! i-flux gm component for tracers for all k
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: flux_y_redi   ! j-flux gm component for tracers for all k
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: tendency_redi ! tendency from Redi (excluding implicit K33 piece)


integer :: index_temp
integer :: index_salt
integer :: neutralrho_nk

character(len=128) :: version=&
     '$Id: ocean_nphysicsA.F90,v 20.0 2013/12/14 00:14:36 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

character(len=*), parameter :: FILENAME=&
     __FILE__

logical :: module_is_initialized = .FALSE.

! time step settings 
real    :: dtime
real    :: two_dtime_inv

! vertical coordinate 
integer :: vert_coordinate_class

! lower and upper depth for vertically averaging ocean properties.
! read into ocean_nphysics_util_nml
real :: agm_closure_upper_depth
real :: agm_closure_lower_depth


!**************nml settings**************

! for using form drag rather than GM-skewsion
! gm_skew=1.0 if use_gm_skew=.true.
! gm_skew=0.0 if use_gm_skew=.false.
logical :: use_gm_skew=.true.
real    :: gm_skew=1.0

! for setting the slope tapering methods 
real    :: smax                        ! set in ocean_neutral_util_nml
real    :: swidth                      ! set in ocean_neutral_util_nml
logical :: dm_taper         = .true.   ! tanh tapering scheme of Danabasoglu and McWilliams
real    :: swidthr                     ! inverse swidth  
real    :: smax_swidthr                ! useful combination of terms 
real    :: dm_taper_const   = 1.0      ! internally set to unity when dm_taper=.true.
logical :: gkw_taper        = .false.  ! quadratic tapering of Gerdes, Koberle, and Willebrand
real    :: gkw_taper_const  = 0.0      ! internally set to unity when gkw_taper=.true.

! neutral_physics_simple=.false. is commonly used at GFDL with MOM4 and later.
! neutral_physics_simple=.true.  was the setting more common in MOM3.  
logical :: neutral_physics_simple=.false.   

! for neutral blayer 
real :: turb_blayer_min = 0.0 ! metres (was always set to zero in MOM4.0)

! for diagnosing properties at the base of the "neutral physics boundary layer" 
logical :: neutral_blayer_diagnose=.false. 

! for maintaining horizontal GM velocity constant with depth within neutral boundary layer 
logical :: neutral_linear_gm_taper=.true.   

! for tapering neutral physics over penetration depth of 
! eddies as determined by slope and Rossby radius
logical :: neutral_sine_taper=.true.        

! to remove diagonal elements to neutral diffusion within the neutral boundar layer 
logical :: neutral_taper_diagonal=.false.   
real    :: taper_diagonal=0.0  ! taper_diagonal=1 if neutral_taper_diagonal=.true. ; =0 otherwise 

! to reduce neutral fluxes to horz/vert diffusion next to model boundaries
logical :: tmask_neutral_on=.false.         

! to compute K33 explicitly in time. 
! diffusion_all_explicit=.false. for realistic simulations.
logical :: diffusion_all_explicit=.false.   

! revert to horizontal diffusion when tracer falls outside specified range 
logical :: neutral_physics_limit=.true.   

! for specifying transport units
! can either be Sv or mks
character(len=32) :: transport_dims ='Sv (10^9 kg/s)' 
real              :: transport_convert=1.0e-9 

! internally set; for diagnosing the effects from GM and Redi separately 
logical :: diagnose_gm_redi = .false.

! for the module as a whole 
logical :: use_this_module   = .false.
logical :: debug_this_module = .false.

!**************end of nml settings**************

namelist /ocean_nphysicsA_nml/ use_this_module, debug_this_module,          &
          neutral_physics_limit, use_gm_skew,                               &
          dm_taper, gkw_taper, tmask_neutral_on,                            &
          neutral_physics_simple, neutral_taper_diagonal,                   &
          neutral_linear_gm_taper, neutral_sine_taper,                      & 
          diffusion_all_explicit, neutral_blayer_diagnose, turb_blayer_min
    

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_nphysicsA_init">
!
! <DESCRIPTION>
! Initialize the neutral physics module by registering fields for 
! diagnostic output and performing some numerical checks to see 
! that namelist settings are appropriate. 
! </DESCRIPTION>
!
subroutine ocean_nphysicsA_init(Grid, Domain, Time, Time_steps, Thickness, Dens, T_prog, &
           ver_coordinate_class, agm_closure_lower_dept, agm_closure_upper_dept,         &
           smx, swidt, cmip_units, debug)

  type(ocean_grid_type),        intent(in), target   :: Grid
  type(ocean_domain_type),      intent(in), target   :: Domain
  type(ocean_time_type),        intent(in)           :: Time
  type(ocean_time_steps_type),  intent(in)           :: Time_steps
  type(ocean_thickness_type),   intent(in)           :: Thickness
  type(ocean_density_type),     intent(in)           :: Dens
  type(ocean_prog_tracer_type), intent(inout)        :: T_prog(:)
  integer,                      intent(in)           :: ver_coordinate_class
  real,                         intent(in)           :: agm_closure_lower_dept
  real,                         intent(in)           :: agm_closure_upper_dept
  real,                         intent(in)           :: smx 
  real,                         intent(in)           :: swidt
  logical,                      intent(in)           :: cmip_units
  logical,                      intent(in), optional :: debug

  logical :: diagnose_gm_redi_input=.false.
  integer :: ioun, io_status, ierr  
  integer :: i, j, n
  
  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_nphysicsA_mod (ocean_nphysicsA_init):already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  num_prog_tracers = size(T_prog(:))
  dtime            = Time_steps%dtime_t
  Dom => Domain
  Grd => Grid

  vert_coordinate_class   = ver_coordinate_class
  agm_closure_lower_depth = agm_closure_lower_dept
  agm_closure_upper_depth = agm_closure_upper_dept
  smax                    = smx 
  swidth                  = swidt
  neutralrho_nk           = size(Dens%neutralrho_ref(:))

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_nphysicsA_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_nphysicsA_nml')
#else
  ioun =  open_namelist_file()
  read (ioun,ocean_nphysicsA_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_nphysicsA_nml')
  call close_file (ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_nphysicsA_nml)  
  write (stdlogunit,ocean_nphysicsA_nml)

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  nk = Grid%nk
#endif

  if(use_this_module) then 
     call write_note(FILENAME,&
      'USING ocean_nphysicsA_mod.')
  else 
     call write_note(FILENAME,&
     'NOT using ocean_nphysicsA_mod.')
     return
  endif 

  if (PRESENT(debug) .and. .not. debug_this_module) then
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
     call write_note(FILENAME,&
     'running ocean_nphysicsA_mod with debug_this_module=.true.')
  endif 

  write(stdoutunit,'(/1x,a,f10.2)') &
  '==> Note from ocean_nphysicsA_mod: using forward time step of (secs)', dtime 

  if(cmip_units) then
      transport_convert=1.0
      transport_dims   = 'kg/s'
  else
      transport_convert=1.0e-9 
      transport_dims   = 'Sv (10^9 kg/s)'
  endif

  ! Useful constants 
  two_dtime_inv = 0.5/dtime            !for explicit piece of K33 
  swidthr       = 1.0/(swidth + epsln) !for slope taper function when dm_taper used 
  smax_swidthr  = smax*swidthr         !for slope taper function when dm_taper used 

  if(use_gm_skew) then
    gm_skew=1.0
    call write_note(FILENAME,&
    'use_gm_skew=.true. so will use GM-skewsion.')
  else
    gm_skew=0.0
    call write_note(FILENAME,&
    'use_gm_skew=.false. so will NOT use GM-skewsion.' )
    if(neutral_physics_simple) then 
      call mpp_error(FATAL, &
      '==>Error from ocean_nphysicsA_mod: use_gm_skew=.false. incompatible with neutral_physics_simple=.true.')
    endif 
  endif 

  if(neutral_physics_simple) then
     call write_note(FILENAME,&
     'neutral_physics_simple=.true.')
     call write_line('means the horizontal SGS tracer fluxes are downgradient for all neutral slopes.')
     call write_line('Assumes aredi_array = agm_array.')
     call write_line('Analogous to MOM3 approach.')
  endif

  if(neutral_physics_limit) then
     call write_note(FILENAME,&
     'neutral_physics_limit=.true.')
     call write_line('Will revert to horizontal diffusion for points where tracer is outside specified range.')
  endif

  if(dm_taper .and. .not. gkw_taper) then
     call write_note(FILENAME,&
     'dm_taper=.true. Will use the tanh scheme')
     call write_line('of Danabasoglu and McWilliams to taper neutral physics in steep sloped regions')
     dm_taper_const =1.0
     gkw_taper_const=0.0
  endif
  if(gkw_taper .and. .not. dm_taper) then
     call write_note(FILENAME,&
     'gkw_taper=.true. Will use the quadratic scheme')
     call write_line('of Gerdes, Koberle, and Willebrand to taper neutral physics in steep sloped regions')
     dm_taper_const =0.0
     gkw_taper_const=1.0
  endif
  if(gkw_taper .and. dm_taper) then
      dm_taper_const =0.0
      gkw_taper_const=0.0
      call mpp_error(FATAL, &
      '==>Error from ocean_nphysicsA_mod: gkw_taper and dm_taper cannot both be set true--choose only one.')
  endif

  if(.not. neutral_physics_simple) then 
      if(neutral_linear_gm_taper) then
         call write_note(FILENAME,&
         'neutral_linear_gm_taper=.true., so will linearly')
         call write_line('taper GM towards the surface when reaching steep neutral slopes in surface bdy.')
      else
         call write_note(FILENAME,&
         'GM exponentially tapered to zero in neutral bdy layer region.')
      endif
      if(neutral_sine_taper) then
         call write_note(FILENAME,&
         'Running with neutral_sine_taper=.true., and so will use sine-taper')
         call write_line('on fluxes where eddy penetration depth and/or KPP hblt exceeds grid depth.')
      endif
  endif

  if(neutral_blayer_diagnose) then 
     call write_note(FILENAME,&
     'Running with neutral_blayer_diagnose=.true., so will diagnose properties')
     call writE_line('of the neutral physics boundary layer.')
  endif

  if(neutral_linear_gm_taper) then
     call write_note(FILENAME,&
     'Running with a nontrivial GM transport in steep neutral slope regions.')
  endif

  if(diffusion_all_explicit) then
     call write_warning(FILENAME,&
     'Running w/ diffusion_all_explicit=.true., which means compute K33 contribution')
     call write_line('to neutral diffusion explicitly in time.  This method is stable ONLY if taking')
     call write_line('very small time steps and/or running with just a single tracer.')
  endif

  if(neutral_taper_diagonal) then
      taper_diagonal = 1.0 
      call write_note(FILENAME,&
      'Running w/ neutral_taper_diagonal=.true. and so taper_diagonal = 1.0')
      call write_line('Will taper all pieces of horiz neutral flux components in steep neutral slope regions.')
      call write_line('neutral_taper_diagonal=.false. will alternatively keep the diagonal pieces untapered.')
  endif
  if(.not. neutral_taper_diagonal) then
      taper_diagonal = 0.0 
      call write_note(FILENAME,&
      'Running w/ neutral_taper_diagonal=.false. so taper_diagonal = 0.0')
      call write_line('Diagonal pieces of horizontal flux components are untapered regardless the neutral slope.')
  endif


  do n=1,num_prog_tracers
    T_prog(n)%neutral_physics_limit = neutral_physics_limit
  enddo 

  allocate( dTdx(num_prog_tracers) )
  allocate( dTdy(num_prog_tracers) )
  allocate( dTdz(num_prog_tracers) )
  allocate( fz1(num_prog_tracers) )
  allocate( fz2(num_prog_tracers) )
  allocate( flux_x(num_prog_tracers) )
  allocate( flux_y(num_prog_tracers) )


  call set_ocean_domain(Dom_flux,Grid,xhalo=Dom%xhalo,yhalo=Dom%yhalo,name='flux dom neutral',maskmap=Dom%maskmap)

#ifndef MOM_STATIC_ARRAYS
  allocate (dtew(isd:ied,jsd:jed,0:1))
  allocate (dtns(isd:ied,jsd:jed,0:1))
  allocate (dtwedyt(isd:ied,jsd:jed,0:1))
  allocate (dxtdtsn(isd:ied,jsd:jed,0:1))
  allocate (grid_length(isd:ied,jsd:jed))
  allocate (delqc(isd:ied,jsd:jed,nk,0:1))
  allocate (dzwtr(isd:ied,jsd:jed,0:nk))
  allocate (aredi_array(isd:ied,jsd:jed,nk)) 
  allocate (agm_array(isd:ied,jsd:jed,nk))   
  allocate (ah_array(isd:ied,jsd:jed))
  allocate (bczone_radius(isd:ied,jsd:jed))
  allocate (rossby_radius(isd:ied,jsd:jed))
  allocate (rossby_radius_raw(isd:ied,jsd:jed))
  allocate (eady_termx(isd:ied,jsd:jed,nk))
  allocate (eady_termy(isd:ied,jsd:jed,nk))
  allocate (baroclinic_termx(isd:ied,jsd:jed))
  allocate (baroclinic_termy(isd:ied,jsd:jed))
  allocate (tx_trans_gm(isd:ied,jsd:jed,nk))
  allocate (ty_trans_gm(isd:ied,jsd:jed,nk))
  allocate (grav_agm_dz_sx_drhodx(isd:ied,jsd:jed,nk)) 
  allocate (grav_agm_dz_sy_drhody(isd:ied,jsd:jed,nk)) 
  allocate (slopex_drhodx(isd:ied,jsd:jed,nk)) 
  allocate (slopey_drhody(isd:ied,jsd:jed,nk)) 

  allocate (drhodT(isd:ied,jsd:jed,nk))
  allocate (drhodS(isd:ied,jsd:jed,nk))
  allocate (drhodzb(isd:ied,jsd:jed,nk,0:1))
  allocate (drhodzh(isd:ied,jsd:jed,nk,0:1))
  allocate (tensor_31(isd:ied,jsd:jed,nk,0:1,0:1))
  allocate (tensor_32(isd:ied,jsd:jed,nk,0:1,0:1))
  allocate (K33_implicit(isd:ied,jsd:jed,nk)) 
  allocate (K33_explicit(isd:ied,jsd:jed,nk)) 

  do n=1,num_prog_tracers
    allocate ( dTdx(n)%field(isd:ied,jsd:jed,nk) )
    allocate ( dTdy(n)%field(isd:ied,jsd:jed,nk) )
    allocate ( dTdz(n)%field(isd:ied,jsd:jed,0:nk) )
    allocate ( fz1(n)%field(isd:ied,jsd:jed) )
    allocate ( fz2(n)%field(isd:ied,jsd:jed) )
    allocate ( flux_x(n)%field(isd:ied,jsd:jed,nk) )
    allocate ( flux_y(n)%field(isd:ied,jsd:jed,nk) )
  enddo 
  allocate ( dSdx%field(isd:ied,jsd:jed,nk) )
  allocate ( dSdy%field(isd:ied,jsd:jed,nk) )
  allocate ( dSdz%field(isd:ied,jsd:jed,0:nk) )

  allocate(depth_blayer_base(isd:ied,jsd:jed))
  allocate(slope_blayer_base(isd:ied,jsd:jed))
  allocate(eddy_depth(isd:ied,jsd:jed))
  allocate(turb_blayer_depth(isd:ied,jsd:jed))
  allocate(N2_blayer_base(isd:ied,jsd:jed))
  allocate(ksurf_blayer(isd:ied,jsd:jed))

#endif

  do n=1,num_prog_tracers 
    dTdx(n)%field(:,:,:)   = 0.0
    dTdy(n)%field(:,:,:)   = 0.0
    dTdz(n)%field(:,:,:)   = 0.0
    fz1(n)%field(:,:)      = 0.0
    fz2(n)%field(:,:)      = 0.0
    flux_x(n)%field(:,:,:) = 0.0
    flux_y(n)%field(:,:,:) = 0.0

  enddo  
  dSdx%field(:,:,:) = 0.0
  dSdy%field(:,:,:) = 0.0
  dSdz%field(:,:,:) = 0.0

  depth_blayer_base  = 0.0
  slope_blayer_base  = 0.0
  eddy_depth         = 0.0
  turb_blayer_depth  = 0.0
  N2_blayer_base     = 0.0
  ksurf_blayer       = 1
  tx_trans_gm        = 0.0
  ty_trans_gm        = 0.0

  dtew(:,:,0) = Grd%dtw(:,:)
  dtew(:,:,1) = Grd%dte(:,:)
  dtns(:,:,0) = Grd%dts(:,:)
  dtns(:,:,1) = Grd%dtn(:,:)

  dtwedyt(:,:,:) = 0.0
  dtwedyt(:,:,0) = Grd%dte(:,:)*Grd%dyt(:,:)
  do i=isc-1,iec
    dtwedyt(i,:,1) = Grd%dtw(i+1,:)*Grd%dyt(i+1,:)
  enddo

  dxtdtsn(:,:,:) = 0.0
  dxtdtsn(:,:,0) = Grd%dxt(:,:)*Grd%dtn(:,:)
  do j=jsc-1,jec
    dxtdtsn(:,j,1) = Grd%dxt(:,j+1)*Grd%dts(:,j+1)
  enddo

  grid_length(:,:) = 2.0*Grd%dxt(:,:)*Grd%dyt(:,:)/(Grd%dxt(:,:)+Grd%dyt(:,:))

  eady_termx(:,:,:)            = 0.0
  eady_termy(:,:,:)            = 0.0
  baroclinic_termx(:,:)        = 0.0
  baroclinic_termy(:,:)        = 0.0
  grav_agm_dz_sx_drhodx(:,:,:) = 0.0
  grav_agm_dz_sy_drhody(:,:,:) = 0.0
  slopex_drhodx(:,:,:)         = 0.0
  slopey_drhody(:,:,:)         = 0.0

  rossby_radius(:,:)           = 0.0
  rossby_radius_raw(:,:)       = 0.0
  bczone_radius(:,:)           = 0.0
  agm_array(:,:,:)             = 0.0
  aredi_array(:,:,:)           = 0.0
  ah_array(:,:)                = 0.0
  call ocean_nphysics_coeff_init(Time, Thickness, rossby_radius, rossby_radius_raw, &
                         bczone_radius, agm_array, aredi_array, ah_array)

  drhodT(:,:,:)             = 0.0
  drhodS(:,:,:)             = 0.0
  drhodzb(:,:,:,:)          = 0.0
  drhodzh(:,:,:,:)          = 0.0
  tensor_31(:,:,:,:,:)      = 0.0
  tensor_32(:,:,:,:,:)      = 0.0
  K33_implicit(:,:,:)       = 0.0           
  K33_explicit(:,:,:)       = 0.0           

  index_temp=-1;index_salt=-1
  do n=1,num_prog_tracers
     if (T_prog(n)%name == 'temp') index_temp = n
     if (T_prog(n)%name == 'salt') index_salt = n
  enddo
  if (index_temp == -1 .or. index_salt == -1) then 
     call mpp_error(FATAL, &
     '==>Error: temp and/or salt not identified in call to ocean_nphysicsA_init')
  endif 

  ! initialize clock ids 
  id_clock_neutral_blayer   = mpp_clock_id('(Ocean neutral: blayer)'       ,grain=CLOCK_ROUTINE)
  id_clock_neutral_blayer_1 = mpp_clock_id('(Ocean neutral: blayer1)'      ,grain=CLOCK_ROUTINE)
  id_clock_neutral_blayer_2 = mpp_clock_id('(Ocean neutral: blayer2)'      ,grain=CLOCK_ROUTINE)
  id_clock_neutral_blayer_3 = mpp_clock_id('(Ocean neutral: blayer3)'      ,grain=CLOCK_ROUTINE)
  id_clock_fz_terms         = mpp_clock_id('(Ocean neutral: fz-terms)'     ,grain=CLOCK_ROUTINE)
  id_clock_fx_flux          = mpp_clock_id('(Ocean neutral: fx-flux)'      ,grain=CLOCK_ROUTINE)
  id_clock_fy_flux          = mpp_clock_id('(Ocean neutral: fy-flux)'      ,grain=CLOCK_ROUTINE)
  id_clock_fz_flux          = mpp_clock_id('(Ocean neutral: fz-flux)'      ,grain=CLOCK_ROUTINE)
  id_clock_fx_flux_diag     = mpp_clock_id('(Ocean neutral: fx-flux-diag)' ,grain=CLOCK_ROUTINE)
  id_clock_fy_flux_diag     = mpp_clock_id('(Ocean neutral: fy-flux-diag)' ,grain=CLOCK_ROUTINE)
  id_clock_fz_flux_diag     = mpp_clock_id('(Ocean neutral: fz-flux-diag)' ,grain=CLOCK_ROUTINE)
  id_clock_fz_terms_diag    = mpp_clock_id('(Ocean neutral: fz-terms-diag)',grain=CLOCK_ROUTINE)


  ! register fields for diagnostic output 

  id_ah_bdy = -1
  id_ah_bdy = register_static_field ('ocean_model', 'ah_bdy',                  &
              Grd%tracer_axes(1:2), 'Horz diffusivity in surface neutral bdy', &
              'm^2/sec', missing_value=missing_value, range=(/-10.0,1.e10/))
  call diagnose_2d(Time, Grd, id_ah_bdy, ah_array(:,:))

  id_k33_explicit = -1
  id_k33_explicit = register_diag_field ('ocean_model', 'k33_explicit', &
                    Grd%tracer_axes_wt(1:3), Time%model_time,           &
                    'K33_explicit tensor element', 'm^2/sec',           &
                    missing_value=missing_value, range=(/-10.0,1.e20/))

  id_tx_trans_gm = -1
  id_tx_trans_gm = register_diag_field ('ocean_model', 'tx_trans_gm',      &
                   Grd%tracer_axes_flux_x(1:3), Time%model_time,           &
                   'T-cell mass i-transport from GM',trim(transport_dims), &
                   missing_value=missing_value, range=(/-1e20,1.e20/))

  id_ty_trans_gm = -1
  id_ty_trans_gm = register_diag_field ('ocean_model', 'ty_trans_gm',     &
                   Grd%tracer_axes_flux_y(1:3), Time%model_time,          &
                   'T-cell mass j-transport from GM',trim(transport_dims),&
                   missing_value=missing_value, range=(/-1e20,1.e20/))

  id_depth_blayer_base = -1
  id_depth_blayer_base = register_diag_field ('ocean_model','depth_blayer_base', &
                         Grd%tracer_axes(1:2), Time%model_time,                  &
                         'Depth of neutral physics surface bdy-layer', 'm',      &
                         missing_value=missing_value, range=(/-1.0,1.e8/))

  id_slope_blayer_base = -1
  id_slope_blayer_base = register_diag_field ('ocean_model','slope_blayer_base',          &
                         Grd%tracer_axes(1:2), Time%model_time,                           &
                         'abs(slope) at neutral physics bdy-layer base', 'dimensionless', &
                         missing_value=missing_value, range=(/-1.0,1.e8/))

  id_eddy_depth = -1
  id_eddy_depth = register_diag_field ('ocean_model','eddy_depth',                 &
                  Grd%tracer_axes(1:2), Time%model_time,                           &
                  'mesoscale eddy penetration depth used in neutral physicsA', 'm',&
                  missing_value=missing_value, range=(/-1.0,1.e8/))

  id_steep_depth = -1
  id_steep_depth = register_diag_field ('ocean_model','steep_depth',     &
                   Grd%tracer_axes(1:2), Time%model_time,                &
                  'Depth at base of steep slope surface bdy layer', 'm', &
                   missing_value=missing_value, range=(/-1.0,1.e8/))

  id_grav_agm_dz_sx_drhodx = -1
  id_grav_agm_dz_sx_drhodx = register_diag_field ('ocean_model', 'grav_agm_dz_sx_drhodx', &
               Grd%tracer_axes(1:3), Time%model_time,                                     &
               'grav*dz*agm*neutral x-slope times drho_dx', 'W/m^2',                      &
               missing_value=missing_value, range=(/-1.e15,1.e15/))

  id_grav_agm_dz_sy_drhody = -1
  id_grav_agm_dz_sy_drhody = register_diag_field ('ocean_model', 'grav_agm_dz_sy_drhody', &
               Grd%tracer_axes(1:3), Time%model_time,                                     &
               'grav*dz*agm*neutral y-slope times drho_dy', 'W/m^2',                      &
               missing_value=missing_value, range=(/-1.e15,1.e15/))

  id_gm_eddy_ke_source = -1
  id_gm_eddy_ke_source = register_diag_field ('ocean_model', 'gm_eddy_ke_source',&
               Grd%tracer_axes(1:3), Time%model_time,                            &
               'rho0*dz*agm*(slope*N)^2 = eddy ke source from GM', 'W/m^2',      &
               missing_value=missing_value, range=(/-1.e1,1.e15/),               &
               standard_name='tendency_of_ocean_eddy_kinetic_energy_content_due_to_bolus_transport')

  id_slopex_drhodx = -1
  id_slopex_drhodx = register_diag_field ('ocean_model', 'slopex_drhodx', &
               Grd%tracer_axes(1:3), Time%model_time,                     &
               'neutral x-slope times drho_dx', 'kg/m^4',                 &
               missing_value=missing_value, range=(/-1.e10,1.e10/))

  id_slopey_drhody = -1
  id_slopey_drhody = register_diag_field ('ocean_model', 'slopey_drhody', &
               Grd%tracer_axes(1:3), Time%model_time,                     &
               'neutral y-slope times drho_dy', 'kg/m^4',                 &
               missing_value=missing_value, range=(/-1.e10,1.e10/))

  id_ustar = -1
  id_ustar = register_diag_field ('ocean_model', 'ugm', &
             Grd%vel_axes_uv(1:3), Time%model_time,     &
             'GM zonal velocity', 'm/sec',              &
             missing_value=missing_value, range=(/-10.0,10.0/))

  id_vstar = -1    
  id_vstar = register_diag_field ('ocean_model', 'vgm', &
             Grd%vel_axes_uv(1:3), Time%model_time,     &
             'GM merid velocity', 'm/sec',              &
             missing_value=missing_value, range=(/-10.0,10.0/))

  id_wstar = -1
  id_wstar = register_diag_field ('ocean_model', 'wgm',   &
             Grd%vel_axes_wt(1:3), Time%model_time,       &
             'GM vert velocity (T-cell bottom)', 'm/sec', &
             missing_value=missing_value, range=(/-10.0,10.0/))

  call watermass_diag_init(Time, Dens, diagnose_gm_redi_input)
  if(diagnose_gm_redi_input) then 
     diagnose_gm_redi = .true.
  endif 


  allocate (id_k33_implicit(num_prog_tracers))
  allocate (id_neutral_physics(num_prog_tracers))
  allocate (id_neutral_physics_ndiffuse(num_prog_tracers))
  allocate (id_neutral_physics_gm(num_prog_tracers))
  id_k33_implicit             = -1
  id_neutral_physics          = -1
  id_neutral_physics_ndiffuse = -1
  id_neutral_physics_gm       = -1
  do n=1,num_prog_tracers
     id_k33_implicit(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_k33_implicit', &
                          Grd%tracer_axes_wt(1:3), Time%model_time,                                  &
                          'K33_implicit tensor element for '//trim(T_prog(n)%name),                  &
                          'm^2/sec', missing_value=missing_value, range=(/-10.0,1.e10/))

     if (T_prog(n)%name == 'temp') then
       id_neutral_physics(n) = register_diag_field ('ocean_model', 'neutral_'//trim(T_prog(n)%name), &
                               Grd%tracer_axes(1:3), Time%model_time,                                &
                               'rho*dzt*cp*explicit neutral tendency (heating)',                     &
                               trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))

       id_neutral_physics_ndiffuse(n) = register_diag_field ('ocean_model', 'neutral_diffusion_'//trim(T_prog(n)%name), &
                               Grd%tracer_axes(1:3), Time%model_time,                                                   &
                               'rho*dzt*cp*explicit neutral diffusion tendency (heating)',                              &
                               trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))
       if(id_neutral_physics_ndiffuse(n) > 0) diagnose_gm_redi=.true.

       id_neutral_physics_gm(n) = register_diag_field ('ocean_model', 'neutral_gm_'//trim(T_prog(n)%name), &
                               Grd%tracer_axes(1:3), Time%model_time,                                      &
                               'rho*dzt*cp*GM stirring (heating)',                                         &
                               trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))
       if(id_neutral_physics_gm(n) > 0) diagnose_gm_redi=.true.

     else 

       id_neutral_physics(n) = register_diag_field ('ocean_model', 'neutral_'//trim(T_prog(n)%name), &
                               Grd%tracer_axes(1:3), Time%model_time,                                &
                               'rho*dzt*explicit neutral tendency for '//trim(T_prog(n)%name),       &
                               trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))

       id_neutral_physics_ndiffuse(n) = register_diag_field ('ocean_model', 'neutral_diffusion_'//trim(T_prog(n)%name), &
                               Grd%tracer_axes(1:3), Time%model_time,                                                   &
                               'rho*dzt*explicit neutral diffusion tendency for '//trim(T_prog(n)%name),                &
                               trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))
       if(id_neutral_physics_ndiffuse(n) > 0) diagnose_gm_redi=.true.

       id_neutral_physics_gm(n) = register_diag_field ('ocean_model', 'neutral_gm_'//trim(T_prog(n)%name),&
                               Grd%tracer_axes(1:3), Time%model_time,                                     &
                               'rho*dzt*GM stirring tendency for '//trim(T_prog(n)%name),                 &
                               trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))
       if(id_neutral_physics_gm(n) > 0) diagnose_gm_redi=.true.

     endif 
  enddo 

  allocate (id_flux_x(num_prog_tracers))
  allocate (id_flux_y(num_prog_tracers))
  allocate (id_flux_x_int_z(num_prog_tracers))
  allocate (id_flux_y_int_z(num_prog_tracers))

  allocate (id_flux_x_gm(num_prog_tracers))
  allocate (id_flux_y_gm(num_prog_tracers))
  allocate (id_flux_x_gm_int_z(num_prog_tracers))
  allocate (id_flux_y_gm_int_z(num_prog_tracers))

  allocate (id_flux_x_ndiffuse(num_prog_tracers))
  allocate (id_flux_y_ndiffuse(num_prog_tracers))
  allocate (id_flux_x_ndiffuse_int_z(num_prog_tracers))
  allocate (id_flux_y_ndiffuse_int_z(num_prog_tracers))

  id_flux_x       = -1
  id_flux_y       = -1
  id_flux_x_int_z = -1
  id_flux_y_int_z = -1

  id_flux_x_gm       = -1
  id_flux_y_gm       = -1
  id_flux_x_gm_int_z = -1
  id_flux_y_gm_int_z = -1

  id_flux_x_ndiffuse       = -1
  id_flux_y_ndiffuse       = -1
  id_flux_x_ndiffuse_int_z = -1
  id_flux_y_ndiffuse_int_z = -1

  do n=1,num_prog_tracers
     if(n == index_temp) then 

         id_flux_x(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_neutral', &
              Grd%tracer_axes_flux_x(1:3), Time%model_time, 'cp*neutral_xflux*dyt*rho_dzt*temp',    &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_y(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_neutral', &
              Grd%tracer_axes_flux_y(1:3), Time%model_time, 'cp*neutral_yflux*dxt*rho_dzt*temp',    &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_x_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_neutral_int_z', &
              Grd%tracer_axes_flux_x(1:2), Time%model_time, 'z-integral cp*neutral_xflux*dyt*rho_dzt*temp',     &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_y_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_neutral_int_z', &
              Grd%tracer_axes_flux_y(1:2), Time%model_time, 'z-integral cp*neutral_yflux*dxt*rho_dzt*temp',     &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))

         id_flux_x_gm(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_gm',&
              Grd%tracer_axes_flux_x(1:3), Time%model_time, 'cp*gm_xflux*dyt*rho_dzt*temp',      &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_gm(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_gm(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_gm',&
              Grd%tracer_axes_flux_y(1:3), Time%model_time, 'cp*gm_yflux*dxt*rho_dzt*temp',      &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_gm(n) > 0) diagnose_gm_redi=.true.

         id_flux_x_gm_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_gm_int_z',&
              Grd%tracer_axes_flux_x(1:2), Time%model_time, 'z-integral cp*gm_xflux*dyt*rho_dzt*temp',       &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_gm_int_z(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_gm_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_gm_int_z',&
              Grd%tracer_axes_flux_y(1:2), Time%model_time, 'z-integral cp*gm_yflux*dxt*rho_dzt*temp',       &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_gm_int_z(n) > 0) diagnose_gm_redi=.true.

         id_flux_x_ndiffuse(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_ndiffuse',&
              Grd%tracer_axes_flux_x(1:3), Time%model_time, 'cp*redi_xflux*dyt*rho_dzt*temp',                &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_ndiffuse(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_ndiffuse(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_ndiffuse',&
              Grd%tracer_axes_flux_y(1:3), Time%model_time, 'cp*redi_yflux*dxt*rho_dzt*temp',                &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_ndiffuse(n) > 0) diagnose_gm_redi=.true.

         id_flux_x_ndiffuse_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_ndiffuse_int_z',&
              Grd%tracer_axes_flux_x(1:2), Time%model_time, 'z-integral cp*redi_xflux*dyt*rho_dzt*temp',                 &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_ndiffuse_int_z(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_ndiffuse_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_ndiffuse_int_z',&
              Grd%tracer_axes_flux_y(1:2), Time%model_time, 'z-integral cp*redi_yflux*dxt*rho_dzt*temp',                 &
              'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_ndiffuse_int_z(n) > 0) diagnose_gm_redi=.true.

     else

         id_flux_x(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_neutral', &
              Grd%tracer_axes_flux_x(1:3), Time%model_time,                                         &
              'neutral_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),                         &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_y(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_neutral', &
              Grd%tracer_axes_flux_y(1:3), Time%model_time,                                         &
              'neutral_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),                         &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_x_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_neutral_int_z', &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                                                     &
              'z-integral neutral_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),                          &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         id_flux_y_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_neutral_int_z', &
              Grd%tracer_axes_flux_y(1:2), Time%model_time,                                                     &
              'z-integral neutral_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),                          &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))

         id_flux_x_gm(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_gm',&
              Grd%tracer_axes_flux_x(1:3), Time%model_time,                                      &
              'gm_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),                           &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_gm(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_gm(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_gm', &
              Grd%tracer_axes_flux_y(1:3), Time%model_time,                                       &
              'gm_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),                            &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_gm(n) > 0) diagnose_gm_redi=.true.

         id_flux_x_gm_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_gm_int_z', &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                                                   &
              'z-integral gm_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),                             &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_gm_int_z(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_gm_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_gm_int_z', &
              Grd%tracer_axes_flux_y(1:2), Time%model_time,                                                   &
              'z-integral gm_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),                             &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_gm_int_z(n) > 0) diagnose_gm_redi=.true.

         id_flux_x_ndiffuse(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_ndiffuse',&
              Grd%tracer_axes_flux_x(1:3), Time%model_time,                                          &
              'gm_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),                               &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_ndiffuse(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_ndiffuse(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_ndiffuse',&
              Grd%tracer_axes_flux_y(1:3), Time%model_time,                                          &
              'gm_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),                               &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_ndiffuse(n) > 0) diagnose_gm_redi=.true.

         id_flux_x_ndiffuse_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xflux_ndiffuse_int_z',&
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                                                              &
              'z-integral gm_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),                                        &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_x_ndiffuse_int_z(n) > 0) diagnose_gm_redi=.true.

         id_flux_y_ndiffuse_int_z(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_yflux_ndiffuse_int_z',&
              Grd%tracer_axes_flux_y(1:2), Time%model_time,                                                              &
              'z-integral gm_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),                                        &
              'kg/sec', missing_value=missing_value, range=(/-1.e18,1.e18/))
         if(id_flux_y_ndiffuse_int_z(n) > 0) diagnose_gm_redi=.true.

     endif

  enddo

  if(diagnose_gm_redi) then 
     if(neutral_physics_simple) then 
        call write_note(FILENAME,&
        'diagnostics from diagnose_gm_redi=.true. are not available w/ neutral_physics_simple=.true.')
     endif 
     call write_note(FILENAME,&
     'ocean_nphysicA has diagnose_gm_redi=.true. to diagnose GM and Redi. It adds memory requirements.')
     allocate( fz1_redi(num_prog_tracers) )
     allocate( fz2_redi(num_prog_tracers) )
     allocate( flux_x_redi(num_prog_tracers) )
     allocate( flux_y_redi(num_prog_tracers) )
     allocate( tendency_redi(num_prog_tracers) )

#ifndef MOM_STATIC_ARRAYS
      allocate (tensor_31_redi(isd:ied,jsd:jed,nk,0:1,0:1))
      allocate (tensor_32_redi(isd:ied,jsd:jed,nk,0:1,0:1))
      do n=1,num_prog_tracers
         allocate ( fz1_redi(n)%field(isd:ied,jsd:jed) )
         allocate ( fz2_redi(n)%field(isd:ied,jsd:jed) )
         allocate ( flux_x_redi(n)%field(isd:ied,jsd:jed,nk) )
         allocate ( flux_y_redi(n)%field(isd:ied,jsd:jed,nk) )
         allocate ( tendency_redi(n)%field(isd:ied,jsd:jed,nk) )
      enddo
#endif 
      tensor_31_redi(:,:,:,:,:) = 0.0
      tensor_32_redi(:,:,:,:,:) = 0.0
      do n=1,num_prog_tracers
         fz1_redi(n)%field(:,:)        = 0.0
         fz2_redi(n)%field(:,:)        = 0.0
         flux_x_redi(n)%field(:,:,:)   = 0.0
         flux_y_redi(n)%field(:,:,:)   = 0.0
         tendency_redi(n)%field(:,:,:) = 0.0
      enddo

  endif


end subroutine ocean_nphysicsA_init
! </SUBROUTINE>  NAME="ocean_nphysicsA_init"


!#######################################################################
! <SUBROUTINE NAME="nphysicsA">
!
! <DESCRIPTION>
! This function computes the thickness weighted and density weighted
! time tendency for tracer from neutral physics.  Full discussion
! and details are provided by Griffies (2004). 
!
! Here is a brief summary.  
!
!---How the neutral diffusive flux components are computed:
!
! The vertical flux component is split into diagonal (3,3) and 
! off-diagonal (3,1) and (3,2) terms. The off-diagonal (3,1) and (3,2) 
! terms are included explicitly in time. The main contribution from the 
! (3,3) term to the time tendency is included implicitly in time 
! along with the usual contribution from diapycnal processes 
! (vertical mixing schemes).  This is the K33_implicit term.
! This approach is necessary with high vertical resolution, as 
! noted by Cox (1987).  However, splitting the vertical flux into 
! an implicit and explicit piece compromises the 
! integrity of the vertical flux component (see Griffies et al. 1998).
! So to minimize the disparity engendered by this split, the portion of 
! K33 that can be stably included explicitly in time is computed along 
! with the (3,1) and (3,2) terms. 
! 
! All other terms in the mixing tensor are included explicitly in time
! using a forward time step as required for temporal stability of 
! numerical diffusive processes.  
!
! The off-diagonal terms in the horizontal flux components, and all terms
! in the vertical flux component, are tapered in regions of steep neutral
! slope according to the requirements of linear stability.  MOM allows for 
! choice of two tapering schemes:
!
! (a) the tanh taper of Danabasoglu and McWilliams (1995)
! (b) the quadratic scheme of Gerdes, Koberle, and Willebrand (1991)
!
! Linear stability is far less stringent on the diagonal (1,1) and (2,2)
! part of the horizontal flux.  Indeed, these terms in practice need
! not be tapered in steep sloped regions. The namelist 
! neutral_taper_diagonal=.false. keeps the diagnonal terms maintained 
! for all neutral slopes. This approach assists in reducing numerical
! noise in regions where the physical system experiences a lot of
! diapycnal mixing anyhow. 
!
!---How the skew diffusive flux components are computed:
!
! The GM skew flux components are purely off-diagonal.  
! They are generally tapered when neutral slope 
! is large (neutral_physics_simple=.false).
! Doing so maintains a nontrivial GM slumping effect even when the 
! neutral slopes are vertical.  The alternative neutral_physics_simple=.true.
! is the approach used in MOM3, whereby GM effects are removed 
! in steep sloped regions.  neutral_physics_simple=.false. is 
! less efficient, but has been seen to yield superior simulations.
!
! </DESCRIPTION>
!
subroutine nphysicsA (Time, Thickness, Dens, rho, T_prog, &
                      surf_blthick, gm_diffusivity,       &
                      baroclinic_rossby_radius)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_density_type),     intent(in)    :: Dens
  real, dimension(isd:,jsd:,:), intent(in)    :: rho
  real, dimension(isd:,jsd:),   intent(in)    :: surf_blthick
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  real, dimension(isd:,jsd:,:), intent(inout) :: gm_diffusivity
  real, dimension(isd:,jsd:),   intent(inout) :: baroclinic_rossby_radius

  real, dimension(isd:ied,jsd:jed) :: tchg

  integer :: i, j, k, n, nn
  integer :: tau, taum1

  if (.not. use_this_module) return

  if ( .not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_nphysicsA (neutral_physics): needs initialization')
  endif 

  if (size(T_prog(:)) /= num_prog_tracers) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_nphysicsA (neutral_physics): inconsistent size of T_prog')
  endif 

  taum1 = Time%taum1
  tau   = Time%tau

  ! time dependent delqc geometric factor 
  do k=1,nk
    delqc(:,:,k,0) = Grd%fracdz(k,0)*Thickness%rho_dzt(:,:,k,tau)
    delqc(:,:,k,1) = Grd%fracdz(k,1)*Thickness%rho_dzt(:,:,k,tau)
  enddo

  ! time dependent inverse dzwt 
  do k=0,nk
    dzwtr(:,:,k) = 1.0/Thickness%dzwt(:,:,k) 
  enddo

  ! compute density derivatives 
  do k=1,nk
     drhodT(:,:,k) = Dens%drhodT(:,:,k)
     drhodS(:,:,k) = Dens%drhodS(:,:,k)
  enddo

  call tracer_derivs(Time, taum1, dtime, drhodT, drhodS, T_prog, Dens, dzwtr, &
                     dTdx, dTdy, dTdz, dSdx, dSdy, dSdz, drhodzb, drhodzh) 

  call neutral_slopes(Time, dTdx, dTdy, dSdx, dSdy, drhodT, drhodS, drhodzb, tensor_31, tensor_32)

  call cabbeling_thermob_tendency(Time, Thickness, T_prog, Dens,                               &
  dTdx(index_temp)%field(:,:,:), dTdy(index_temp)%field(:,:,:), dTdz(index_temp)%field(:,:,:), &
  dSdx%field(:,:,:), dSdy%field(:,:,:),                                                        &
  drhodzh, dxtdtsn, dtwedyt, dzwtr, delqc, aredi_array)

  call compute_eta_tend_gm90(Time, Thickness, Dens,             &
  dTdx(index_temp)%field(:,:,:), dTdy(index_temp)%field(:,:,:), &
  dSdx%field(:,:,:), dSdy%field(:,:,:),                         &
  drhodzh, dtwedyt, dzwtr, delqc, tensor_31, tensor_32, agm_array)

  call neutral_blayer(Time, surf_blthick)


  if(diagnose_gm_redi) then 
      do n=1,num_prog_tracers  
         fz1_redi(n)%field(:,:) = 0.0
         fz2_redi(n)%field(:,:) = 0.0
         flux_x_redi(n)%field(:,:,:)   = 0.0
         flux_y_redi(n)%field(:,:,:)   = 0.0
         tendency_redi(n)%field(:,:,:) = 0.0
      enddo
      call fz_terms_diag(Time)   ! must be called prior to fz_terms
  endif

  call fz_terms(Time, Thickness, Dens, T_prog, rho)
  do n=1,num_prog_tracers  
    fz1(n)%field(:,:)      = 0.0
    fz2(n)%field(:,:)      = 0.0
    flux_x(n)%field(:,:,:) = 0.0
    flux_y(n)%field(:,:,:) = 0.0
    T_prog(n)%wrk1(:,:,:)  = 0.0
  enddo 

  if(neutral_physics_simple) then 

      ! horizontal flux components are downgradient diffusive 
      do k=1,nk
         do nn=1,num_prog_tracers
            flux_x(nn)%field(:,:,k) = &
                 agm_array(:,:,k)*dTdx(nn)%field(:,:,k)*FMX(Thickness%rho_dzt(:,:,k,tau)*Grd%tmask(:,:,k))
            flux_y(nn)%field(:,:,k) = &
                 agm_array(:,:,k)*dTdy(nn)%field(:,:,k)*FMY(Thickness%rho_dzt(:,:,k,tau)*Grd%tmask(:,:,k))
         enddo
      enddo
      if (Grd%tripolar) then 
          do nn=1,num_prog_tracers
             call mpp_update_domains(flux_x(nn)%field(:,:,:), flux_y(nn)%field(:,:,:), Dom_flux%domain2d, &
                  gridtype=CGRID_NE, complete=T_prog(nn)%complete) 
          enddo
      endif
      do k=1,nk
         call mpp_clock_begin(id_clock_fz_flux)
         call fz_flux(T_prog,k)
         call mpp_clock_end(id_clock_fz_flux)

         do nn=1,num_prog_tracers
            tchg(:,:)  = (BDX_ET(flux_x(nn)%field(:,:,k)) + BDY_NT(flux_y(nn)%field(:,:,k))) 
            T_prog(nn)%wrk1(COMP,k) = Grd%tmask(COMP,k)*(tchg(COMP) + (fz1(nn)%field(COMP)-fz2(nn)%field(COMP)))
            T_prog(nn)%th_tendency(COMP,k) = T_prog(nn)%th_tendency(COMP,k) + T_prog(nn)%wrk1(COMP,k)
            fz1(nn)%field(COMP)       = fz2(nn)%field(COMP)
            flux_x(nn)%field(COMP,k)  = Grd%dyte(COMP)*flux_x(nn)%field(COMP,k)
            flux_y(nn)%field(COMP,k)  = Grd%dxtn(COMP)*flux_y(nn)%field(COMP,k)
         enddo
      enddo

  else  ! neutral_physics_simple=.false.

      do k=1,nk
         call mpp_clock_begin(id_clock_fx_flux)
         call fx_flux(Time, Thickness, T_prog, k)
         call mpp_clock_end(id_clock_fx_flux)

         call mpp_clock_begin(id_clock_fy_flux)
         call fy_flux(Time, Thickness, T_prog, k)
         call mpp_clock_end(id_clock_fy_flux)
      enddo

      if (Grd%tripolar) then 
          do nn=1,num_prog_tracers
             call mpp_update_domains(flux_x(nn)%field(:,:,:), flux_y(nn)%field(:,:,:), &
                  Dom_flux%domain2d, gridtype=CGRID_NE, complete=T_prog(nn)%complete) 
          enddo
      endif

      do k=1,nk
         call mpp_clock_begin(id_clock_fz_flux)
         call fz_flux(T_prog,k)
         call mpp_clock_end(id_clock_fz_flux)

         do nn=1,num_prog_tracers
            do j=jsc,jec
               do i=isc,iec
                  T_prog(nn)%wrk1(i,j,k) =                                                 & 
                       Grd%tmask(i,j,k)                                                    &
                       *(fz1(nn)%field(i,j)-fz2(nn)%field(i,j)                             &
                       +(flux_x(nn)%field(i,j,k)-flux_x(nn)%field(i-1,j,k)                 &
                       + flux_y(nn)%field(i,j,k)-flux_y(nn)%field(i,j-1,k) )*Grd%datr(i,j) &
                       )
                  T_prog(nn)%th_tendency(i,j,k) = T_prog(nn)%th_tendency(i,j,k) + T_prog(nn)%wrk1(i,j,k)
                  fz1(nn)%field(i,j) = fz2(nn)%field(i,j)
               enddo
            enddo
         enddo
      enddo  ! enddo for k=1,nk


      ! some extra diagnostics to split GM and Redi pieces 
      if(diagnose_gm_redi) then 

          do k=1,nk

             call mpp_clock_begin(id_clock_fx_flux_diag)
             call fx_flux_diag(Time, Thickness, T_prog, k)
             call mpp_clock_end(id_clock_fx_flux_diag)

             call mpp_clock_begin(id_clock_fy_flux_diag) 
             call fy_flux_diag(Time, Thickness, T_prog, k)
             call mpp_clock_end(id_clock_fy_flux_diag) 

          enddo
          if (Grd%tripolar) then 
              do nn=1,num_prog_tracers
                 call mpp_update_domains(flux_x_redi(nn)%field(:,:,:), flux_y_redi(nn)%field(:,:,:), &
                      Dom_flux%domain2d, gridtype=CGRID_NE, complete=T_prog(nn)%complete) 
              enddo
          endif

          do k=1,nk
             call mpp_clock_begin(id_clock_fz_flux_diag)
             call fz_flux_diag(T_prog,k)
             call mpp_clock_end(id_clock_fz_flux_diag)
             do nn=1,num_prog_tracers
                do j=jsc,jec
                   do i=isc,iec
                      tendency_redi(nn)%field(i,j,k) =                                                   & 
                           Grd%tmask(i,j,k)                                                              &
                           *(fz1_redi(nn)%field(i,j)-fz2_redi(nn)%field(i,j)                             &
                           +(flux_x_redi(nn)%field(i,j,k)-flux_x_redi(nn)%field(i-1,j,k)                 &
                           + flux_y_redi(nn)%field(i,j,k)-flux_y_redi(nn)%field(i,j-1,k) )*Grd%datr(i,j) &
                           )
                      fz1_redi(nn)%field(i,j) = fz2_redi(nn)%field(i,j)
                   enddo
                enddo
             enddo
          enddo  ! enddo for k=1,nk

      endif  ! endif for diagnose_gm_redi


  endif  ! endif for neutral_physics_simple


  ! compute Eady growth rate and baroclinicity for use in next time step 
  call compute_eady_rate(Time, Thickness, T_prog, Dens, eady_termx, eady_termy)
  call compute_baroclinicity(Time, baroclinic_termx, baroclinic_termy)

  ! compute rossby radius for use in next time step 
  call compute_rossby_radius(Thickness, dTdz, dSdz, Time, drhodT, drhodS, &
                             rossby_radius, rossby_radius_raw)
  baroclinic_rossby_radius(:,:) = rossby_radius_raw(:,:)

  ! compute width of baroclinic zone for use in next time step 
  call compute_bczone_radius(Time, bczone_radius)

  ! update closure-based diffusivity for next time step 
  call compute_diffusivity(Time, ksurf_blayer, Dens%drhodz_zt, rossby_radius, &
                           bczone_radius, agm_array, aredi_array)

  ! gm_diffusivity passed to neutral_physics for use in computing form drag
  gm_diffusivity(:,:,:) = agm_array(:,:,:)

  call nphysics_diagnostics(Time, T_prog, Dens) 

  call gm_velocity(Thickness, Time)


end subroutine nphysicsA
! </SUBROUTINE> NAME="nphysicsA"



!#######################################################################
! <SUBROUTINE NAME="neutral_blayer">
!
! <DESCRIPTION>
! Subroutine computes the boundary layer as determined by 
! 1. steep neutral slopes
! 2. depth within which typical mesoscale eddies are partially outcropped
! 3. depth within which vertical mixing scheme (e.g., kpp) computes a boundary layer
!
! Note: Only consider surface boundary layers here.  
!
! Scheme originally coded for MOM4.0 by Stephen.Griffies
! with help for optimization by Russell.Fiedler@csiro.au.
! 
! </DESCRIPTION>
!
subroutine neutral_blayer(Time, surf_blthick)

  type(ocean_time_type),      intent(in) :: Time
  real, dimension(isd:,jsd:), intent(in) :: surf_blthick

  logical :: within_interior
  logical :: slopeok(isc:iec)
  integer :: i, j, k, ip, jq, kb, kr, kk, kkpkr
  real :: depth, slope, absslope 
  real :: steep_depth(isd:ied,jsd:jed)
  real :: slope_blayer_baseA(isd:ied,jsd:jed)
  real :: slope_blayer_baseB(isd:ied,jsd:jed)
  real :: thick_31(isd:ied,jsd:jed,0:1,0:1)
  real :: thick_32(isd:ied,jsd:jed,0:1,0:1)
  real :: thick_13(isd:ied,jsd:jed,0:1,0:1)
  real :: thick_23(isd:ied,jsd:jed,0:1,0:1)
  real :: slope_31(isd:ied,jsd:jed,0:1,0:1)
  real :: slope_32(isd:ied,jsd:jed,0:1,0:1)
  real :: slope_13(isd:ied,jsd:jed,0:1,0:1)
  real :: slope_23(isd:ied,jsd:jed,0:1,0:1)

  call mpp_clock_begin(id_clock_neutral_blayer)

  thick_31 = Grd%zw(1)
  thick_32 = Grd%zw(1)
  thick_13 = Grd%zw(1)
  thick_23 = Grd%zw(1)
  slope_31 = 0.0
  slope_32 = 0.0
  slope_13 = 0.0
  slope_23 = 0.0

  slope_blayer_baseA = 0.0
  slope_blayer_baseB = 0.0
  steep_depth        = 0.0

  eddy_depth         = 0.0
  slope_blayer_base  = 0.0 
  depth_blayer_base  = 0.0


  if(neutral_sine_taper .or. neutral_blayer_diagnose) then 

  ! Determine depth over which mesoscale eddies feel the ocean 
  ! surface.  This depth is a function of the neutral slope 
  ! and the Rossby radius.  This depth is called "eddy_depth".
  ! The algorithm for computing this depth is taken from 
  ! the appendix to Large etal, 1997 JPO vol 27, 2418-2447. 
  ! 
  ! In addition to considering mesoscale eddy lengths,
  ! include the possibility that the diabatic vertical
  ! mixing (e.g., kpp) produces a mixed layer depth that is 
  ! deeper than the depth that mesoscale eddies feel the ocean 
  ! surface.  Include this surf_blthick in the considerations so 
  ! to determine the depth of this generalized "boundary layer" 
  ! and the neutral slope at the base of the boundary layer. 

  call mpp_clock_begin(id_clock_neutral_blayer_1)

! 31-triads 
      do ip=0,1
         do kr=0,1
            do j=jsc,jec
               slopeok(:)=.false.
kkloop31a:     do kk=1,nk-1
                  do i=isc,iec 

                     absslope = abs(tensor_31(i,j,kk,ip,kr))
                     depth    = max(rossby_radius(i,j)*absslope, max(turb_blayer_min,surf_blthick(i,j)))
                     if(depth > Grd%zw(kk) .and. .not. slopeok(i)) then
                         thick_31(i,j,ip,kr) = Grd%zw(kk)
                         slope_31(i,j,ip,kr) = absslope
                     else 
                         slopeok(i)=.true.
                     endif
                  enddo
                  if(all(slopeok(:))) exit kkloop31a

               enddo kkloop31a
            enddo
         enddo
      enddo

      ! 13-triads 
      do kr=0,1
         do ip=0,1 
            do j=jsc,jec
               slopeok(:)=.false.

kkloop13a:     do kk=1,nk
                  kkpkr = min(kk+kr,nk)
                  do i=isc,iec

                     slope = -Grd%tmask(i+ip,j,kkpkr)                                 &
                          *(drhodT(i+ip,j,kk)*dTdx(index_temp)%field(i,j,kk)         +&
                            drhodS(i+ip,j,kk)*dSdx%field(i,j,kk))                     &
                          /(drhodT(i+ip,j,kk)*dTdz(index_temp)%field(i+ip,j,kk-1+kr) +&
                            drhodS(i+ip,j,kk)*dSdz%field(i+ip,j,kk-1+kr) - epsln)
                           
                     absslope = abs(slope)  

                     depth = max(rossby_radius(i,j)*absslope, max(turb_blayer_min,surf_blthick(i,j)))
                     if(depth > Grd%zw(kk) .and. .not.slopeok(i)) then 
                         thick_13(i,j,ip,kr) = Grd%zw(kk)
                         slope_13(i,j,ip,kr) = absslope
                     else 
                         slopeok(i)=.true.
                     endif

                  enddo
                  if(all(slopeok(:))) exit kkloop13a
               enddo kkloop13a

            enddo
         enddo
      enddo

      ! 32-triads 
      do jq=0,1
         do kr=0,1
            do j=jsc,jec
               slopeok(:)=.false.
kkloop32a:      do kk=1,nk-1
                  do i=isc,iec 

                     absslope = abs(tensor_32(i,j,kk,jq,kr))
                     depth    = max(rossby_radius(i,j)*absslope, max(turb_blayer_min,surf_blthick(i,j)))
                     if(depth > Grd%zw(kk) .and. .not. slopeok(i) ) then
                         thick_32(i,j,jq,kr) = Grd%zw(kk)
                         slope_32(i,j,jq,kr) = absslope
                     else 
                         slopeok(i) = .true.
                     endif
                  enddo
                  if(all(slopeok(:))) exit kkloop32a
               enddo kkloop32a
            enddo
         enddo
      enddo

      ! 23-triads 
      do kr=0,1
         do jq=0,1  
            do j=jsc,jec
               slopeok(:)=.false.

kkloop23a:     do kk=1,nk
                  do i=isc,iec
                     kkpkr = min(kk+kr,nk)

                     slope = -Grd%tmask(i,j+jq,kkpkr)                                 &
                          *(drhodT(i,j+jq,kk)*dTdy(index_temp)%field(i,j,kk)+         &
                            drhodS(i,j+jq,kk)*dSdy%field(i,j,kk))                     & 
                          /(drhodT(i,j+jq,kk)*dTdz(index_temp)%field(i,j+jq,kk-1+kr) +&
                            drhodS(i,j+jq,kk)*dSdz%field(i,j+jq,kk-1+kr) - epsln)  
                     absslope = abs(slope)  

                     depth = max(rossby_radius(i,j)*absslope, max(turb_blayer_min,surf_blthick(i,j)))
                     if(depth > Grd%zw(kk) .and. .not.slopeok(i)) then 
                         thick_23(i,j,jq,kr) = Grd%zw(kk)
                         slope_23(i,j,jq,kr) = absslope
                     else
                         slopeok(i)=.true.
                     endif

                  enddo
                  if(all(slopeok(:))) exit kkloop23a
               enddo kkloop23a
            enddo
         enddo
      enddo

  call mpp_clock_end(id_clock_neutral_blayer_1)


  call mpp_clock_begin(id_clock_neutral_blayer_2)
  ! max of triad depth defines eddy_depth. average slope
  ! defines slope at boundary layer base.  This method 
  ! maximizes eddy_depth, and regulates slope at base.
      do j=jsc,jec
         do i=isc,iec
            eddy_depth(i,j) = max(Grd%zw(1), &
                                  thick_31(i,j,0,0), thick_31(i,j,0,1), &
                                  thick_31(i,j,1,0), thick_31(i,j,1,1), &
                                  thick_32(i,j,0,0), thick_32(i,j,0,1), &
                                  thick_32(i,j,1,0), thick_32(i,j,1,1), &
                                  thick_13(i,j,0,0), thick_13(i,j,0,1), &
                                  thick_13(i,j,1,0), thick_13(i,j,1,1), &
                                  thick_23(i,j,0,0), thick_23(i,j,0,1), &
                                  thick_23(i,j,1,0), thick_23(i,j,1,1))

            ! make sure that none of the slopes are larger than smax 
            do kr=0,1
              do ip=0,1      
                 slope_31(i,j,ip,kr) = min(smax, slope_31(i,j,ip,kr)) 
                 slope_13(i,j,ip,kr) = min(smax, slope_13(i,j,ip,kr)) 
                 slope_32(i,j,ip,kr) = min(smax, slope_32(i,j,ip,kr)) 
                 slope_23(i,j,ip,kr) = min(smax, slope_23(i,j,ip,kr)) 
               enddo
            enddo

            ! average of the 16 slopes defines slope at boundary layer base  
                slope_blayer_baseA(i,j) = &
                                         (slope_31(i,j,0,0) + slope_13(i,j,0,0) + &
                                          slope_31(i,j,1,0) + slope_13(i,j,1,0) + &
                                          slope_31(i,j,0,1) + slope_13(i,j,0,1) + &
                                          slope_31(i,j,1,1) + slope_13(i,j,1,1) + &
                                          slope_32(i,j,0,0) + slope_23(i,j,0,0) + &
                                          slope_32(i,j,0,1) + slope_23(i,j,0,1) + &
                                          slope_32(i,j,1,0) + slope_23(i,j,1,0) + &
                                          slope_32(i,j,1,1) + slope_23(i,j,1,1)) /16.0
         enddo
      enddo

  call mpp_clock_end(id_clock_neutral_blayer_2)

  endif  ! endif for neutral_sine_taper .or. neutral_blayer_diagnose


  
  if(neutral_linear_gm_taper .or. neutral_blayer_diagnose) then 

  ! Determine depth of surface boundary layer as defined 
  ! by depth where neutral slopes are larger than smax.
      
      thick_31 = Grd%zw(1)
      thick_32 = Grd%zw(1)
      thick_13 = Grd%zw(1)
      thick_23 = Grd%zw(1)

      ! 31-triads 
      do ip=0,1
         do kr=0,1
            do j=jsc,jec
               slopeok(:)=.false.
kkloop31b:     do kk=1,nk-1
                  do i=isc,iec 

                     absslope = abs(tensor_31(i,j,kk,ip,kr))
                     if(absslope > smax .and. .not. slopeok(i)) then
                         thick_31(i,j,ip,kr) = Grd%zw(kk)
                         slope_31(i,j,ip,kr) = absslope
                     else 
                         slopeok(i)=.true.
                     endif
                  enddo
                  if(all(slopeok(:))) exit kkloop31b

               enddo kkloop31b
            enddo
         enddo
      enddo

      ! 13-triads 
      do kr=0,1
         do ip=0,1 
            do j=jsc,jec
               slopeok(:)=.false.

kkloop13b:     do kk=1,nk
                  kkpkr = min(kk+kr,nk)
                  do i=isc,iec

                     slope = -Grd%tmask(i+ip,j,kkpkr)&
                          *(drhodT(i+ip,j,kk)*dTdx(index_temp)%field(i,j,kk)         +&
                            drhodS(i+ip,j,kk)*dSdx%field(i,j,kk))                     &
                          /(drhodT(i+ip,j,kk)*dTdz(index_temp)%field(i+ip,j,kk-1+kr) +&
                            drhodS(i+ip,j,kk)*dSdz%field(i+ip,j,kk-1+kr) - epsln)
                           
                     absslope = abs(slope) 
 
                     if(absslope > smax .and. .not.slopeok(i)) then 
                         thick_13(i,j,ip,kr) = Grd%zw(kk)
                         slope_13(i,j,ip,kr) = absslope
                     else 
                         slopeok(i)=.true.
                     endif

                  enddo
                  if(all(slopeok(:))) exit kkloop13b
               enddo kkloop13b

            enddo

         enddo
      enddo

      ! 32-triads 
      do jq=0,1
         do kr=0,1
            do j=jsc,jec
               slopeok(:)=.false.
kkloop32b:     do kk=1,nk-1
                  do i=isc,iec 

                     absslope = abs(tensor_32(i,j,kk,jq,kr))
                     if(absslope > smax .and. .not. slopeok(i)) then
                         thick_32(i,j,jq,kr) = Grd%zw(kk)
                         slope_32(i,j,jq,kr) = absslope
                     else 
                         slopeok(i)=.true.
                     endif
                  enddo
                  if(all(slopeok(:))) exit kkloop32b

               enddo kkloop32b
            enddo
         enddo
      enddo

      ! 23-triads 
      do kr=0,1
         do jq=0,1  
            do j=jsc,jec
               slopeok(:)=.false.

kkloop23b:     do kk=1,nk
                  do i=isc,iec
                     kkpkr = min(kk+kr,nk)

                     slope = -Grd%tmask(i,j+jq,kkpkr)&
                          *(drhodT(i,j+jq,kk)*dTdy(index_temp)%field(i,j,kk)         +&
                            drhodS(i,j+jq,kk)*dSdy%field(i,j,kk))                     & 
                          /(drhodT(i,j+jq,kk)*dTdz(index_temp)%field(i,j+jq,kk-1+kr) +&
                            drhodS(i,j+jq,kk)*dSdz%field(i,j+jq,kk-1+kr) - epsln)  
                     absslope = abs(slope)  

                     if(absslope > smax .and. .not.slopeok(i)) then 
                         thick_23(i,j,jq,kr) = Grd%zw(kk)
                         slope_23(i,j,jq,kr) = absslope
                     else
                         slopeok(i)=.true.
                     endif

                  enddo
                  if(all(slopeok(:))) exit kkloop23b
               enddo kkloop23b

            enddo
         enddo
      enddo

  call mpp_clock_begin(id_clock_neutral_blayer_3)
  ! max of triad depth defines steep_depth. average slope
  ! defines slope at boundary layer base.  This method 
  ! maximizes steep_depth, and regulates slope at base.

      do j=jsc,jec
         do i=isc,iec

            steep_depth(i,j) =  max(Grd%zw(1), &
                                    thick_31(i,j,0,0), thick_31(i,j,0,1), &
                                    thick_31(i,j,1,0), thick_31(i,j,1,1), &
                                    thick_32(i,j,0,0), thick_32(i,j,0,1), &
                                    thick_32(i,j,1,0), thick_32(i,j,1,1), &
                                    thick_13(i,j,0,0), thick_13(i,j,0,1), &
                                    thick_13(i,j,1,0), thick_13(i,j,1,1), &
                                    thick_23(i,j,0,0), thick_23(i,j,0,1), &
                                    thick_23(i,j,1,0), thick_23(i,j,1,1))

            ! make sure that none of the slopes are larger than smax 
            do kr=0,1
              do ip=0,1      
                 slope_31(i,j,ip,kr) = min(smax, slope_31(i,j,ip,kr)) 
                 slope_13(i,j,ip,kr) = min(smax, slope_13(i,j,ip,kr)) 
                 slope_32(i,j,ip,kr) = min(smax, slope_32(i,j,ip,kr)) 
                 slope_23(i,j,ip,kr) = min(smax, slope_23(i,j,ip,kr)) 
               enddo
            enddo

            ! average of the 16 slopes defines slope at boundary layer base  
            slope_blayer_baseB(i,j) = 0.0
            do kr=0,1
              do ip=0,1      
                slope_blayer_baseB(i,j) = slope_blayer_baseB(i,j)                   + &
                                          slope_31(i,j,ip,kr) + slope_13(i,j,ip,kr) + &
                                          slope_32(i,j,ip,kr) + slope_23(i,j,ip,kr)
               enddo
            enddo
            slope_blayer_baseB(i,j) = slope_blayer_baseB(i,j)/16.0

         enddo
      enddo

  call mpp_clock_end(id_clock_neutral_blayer_3)

  ! The maximum of steep_depth and eddy_depth define 
  ! neutral_blayer_depth.  For depths shallower than 
  ! neutral_blayer_depth, horizontal gm velocity is depth  
  ! independent and vertical gm velocity linearly decreases
  ! to zero as the surface is reached.   

      do j=jsc,jec
         do i=isc,iec

            if(steep_depth(i,j) > eddy_depth(i,j)) then 
                slope_blayer_base(i,j) = slope_blayer_baseB(i,j)
                depth_blayer_base(i,j) = steep_depth(i,j)
            else 
                slope_blayer_base(i,j) = slope_blayer_baseA(i,j)
                depth_blayer_base(i,j) = eddy_depth(i,j)
            endif

         enddo
      enddo

      ! save the k-level surface transition layer. 
      ! initialize ksurf_blayer to 1 rather than 0, to avoid 
      ! accessing the zeroth element of an array.   
      ksurf_blayer(:,:) = 1
      wrk1_2d(:,:)      = 0.0
      do j=jsd,jed
         do i=isd,ied
            kb=Grd%kmt(i,j)
            within_interior=.false.
            ksurf_blayer_loop: do k=1,kb
               if(Grd%zw(k) > depth_blayer_base(i,j)) then 
                   ksurf_blayer(i,j) = k
                   wrk1_2d(i,j)      = float(k)
                   exit ksurf_blayer_loop
               endif
            enddo ksurf_blayer_loop
         enddo
      enddo


  endif  ! endif for neutral_linear_gm_taper .or. neutral_blayer_diagnose

  call diagnose_2d(Time, Grd, id_depth_blayer_base, depth_blayer_base(:,:))
  call diagnose_2d(Time, Grd, id_slope_blayer_base, slope_blayer_base(:,:))
  call diagnose_2d(Time, Grd, id_eddy_depth, eddy_depth(:,:))
  call diagnose_2d(Time, Grd, id_steep_depth, steep_depth(:,:))

  ! update domains or zero the depths, depending on the chosen method 
  if(neutral_linear_gm_taper) then 
      call mpp_update_domains(depth_blayer_base, Dom%domain2d) 
      call mpp_update_domains(slope_blayer_base, Dom%domain2d) 
  else 
      depth_blayer_base = 0.0
  endif
  if(neutral_sine_taper) then 
      call mpp_update_domains(eddy_depth, Dom%domain2d) 
  else 
      eddy_depth = 0.0
  endif


  call mpp_clock_end(id_clock_neutral_blayer)

end subroutine neutral_blayer
! </SUBROUTINE> NAME="neutral_blayer"


!#######################################################################
! <SUBROUTINE NAME="fz_terms">
!
! <DESCRIPTION>
! Subroutine computes the tracer independent pieces of the vertical 
! flux component. As a result of this routine, 
! Array tensor_31 = x-diffusivity*slope (m^2/sec) for fz
! Array tensor_32 = y-diffusivity*slope (m^2/sec) for fz 
!
! K33 is the (3,3) term in small angle Redi diffusion tensor.
! It is broken into an explicit in time piece and implicit 
! in time piece.  It is weighted by density for non-Boussinesq
! and rho0 for Boussinesq.  
!
! K33 has units (kg/m^3)*m^2/sec.
!
! Also will compute the squared Eady growth rate, with the maximum
! slope contributing to this growth rate set by smax.
! </DESCRIPTION>
!
subroutine fz_terms(Time, Thickness, Dens, T_prog, rho)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  real, dimension(isd:,jsd:,:), intent(in)    :: rho

  integer :: i, j, k, n, ip, jq, kr, tau

  real :: baroclinic_triad, K33, K33_crit
  real :: sumx(0:1), sumy(0:1)

  real :: slope, absslope, depth_ratio
  real :: taperA, taperB
  real :: taper_slope, taper_slope2, gm_taper_slope 

  real :: aredi_scalar, agm_scalar, aredi_plus_agm 
  real :: absdrhodzb(0:1)
  real :: mindelqc(0:1,0:1), delqc_ijk_1, delqc_ijkp1_0

  call mpp_clock_begin(id_clock_fz_terms)

  tau = Time%tau
  
  eady_termx(:,:,:)     = 0.0
  eady_termy(:,:,:)     = 0.0
  baroclinic_termx(:,:) = 0.0
  baroclinic_termy(:,:) = 0.0
  tx_trans_gm(:,:,:)    = 0.0
  ty_trans_gm(:,:,:)    = 0.0


! Main loop. Short ip,jq,kr loops are explicitly unrolled
! in order to expose independence and allow vectorisation

  do k=1,nk-1
     do j=jsc,jec
        do i=isc,iec

           aredi_scalar    = aredi_array(i,j,k)
           agm_scalar      = gm_skew*agm_array(i,j,k)
           aredi_plus_agm  = aredi_scalar + agm_scalar

           absdrhodzb(0) = abs(drhodzb(i,j,k,0))
           absdrhodzb(1) = abs(drhodzb(i,j,k,1))

           delqc_ijk_1      = delqc(i,j,k,1)
           delqc_ijkp1_0    = delqc(i,j,k+1,0)
           
           !mindelqc(ip,kr) = min(delqc(i-1+ip,j,k+kr,1-kr),delqc(i+ip,j,k+kr,1-kr)) 
           ip=0 ; kr=0
           mindelqc(ip,kr)  = min(delqc(i-1,j,k,1),delqc_ijk_1) 
           ip=0 ; kr=1
           mindelqc(ip,kr)  = min(delqc(i-1,j,k+1,0),delqc_ijkp1_0) 
           ip=1 ; kr=0
           mindelqc(ip,kr)  = min(delqc_ijk_1,delqc(i+1,j,k,1)) 
           ip=1 ; kr=1
           mindelqc(ip,kr)  = min(delqc_ijkp1_0,delqc(i+1,j,k+1,0)) 

           tx_trans_gm(i,j,k) = 0.0
           baroclinic_triad   = 0.0

           ip=0   
              sumx(ip) = 0.0

              kr=0
                 slope    = tensor_31(i,j,k,ip,kr)
                 absslope = abs(slope)
                 
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Grd%zt(k)) then      
                     gm_taper_slope = (Grd%zt(k)/depth_blayer_base(i,j))*slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 tx_trans_gm(i,j,k)          = tx_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope       
                 tensor_31(i,j,k,ip,kr)      = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumx(ip)                    = sumx(ip)                 + mindelqc(ip,kr)*taper_slope2
                 eady_termx(i,j,k)           = eady_termx(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad            = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)

              kr=1
                 slope    = tensor_31(i,j,k,ip,kr)
                 absslope = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Grd%zt(k)) then      
                     gm_taper_slope = (Grd%zt(k)/depth_blayer_base(i,j))*slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 tx_trans_gm(i,j,k)          = tx_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope      
                 tensor_31(i,j,k,ip,kr)      = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumx(ip)                    = sumx(ip)                 + mindelqc(ip,kr)*taper_slope2
                 eady_termx(i,j,k)           = eady_termx(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad            = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)
                 sumx(ip)                    = sumx(ip)*dtew(i,j,ip)

           ip=1   
              sumx(ip) = 0.0

              kr=0
                 slope        = tensor_31(i,j,k,ip,kr)
                 absslope     = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Grd%zt(k)) then      
                     gm_taper_slope = (Grd%zt(k)/depth_blayer_base(i,j))*slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 tx_trans_gm(i,j,k)          = tx_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope    
                 tensor_31(i,j,k,ip,kr)      = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumx(ip)                    = sumx(ip)                 + mindelqc(ip,kr)*taper_slope2
                 eady_termx(i,j,k)           = eady_termx(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad            = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)

              kr=1
                 slope        = tensor_31(i,j,k,ip,kr)
                 absslope     = abs(slope)
                                                     
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Grd%zt(k)) then      
                     gm_taper_slope = (Grd%zt(k)/depth_blayer_base(i,j))*slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 tx_trans_gm(i,j,k)          = tx_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope   
                 tensor_31(i,j,k,ip,kr)      = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumx(ip)                    = sumx(ip)                 + mindelqc(ip,kr)*taper_slope2
                 eady_termx(i,j,k)           = eady_termx(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad            = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)
                 sumx(ip)                    = sumx(ip)*dtew(i,j,ip)

           if(Thickness%depth_zt(i,j,k) >= agm_closure_upper_depth .and. &
              Thickness%depth_zt(i,j,k) <= agm_closure_lower_depth) then 
             baroclinic_termx(i,j) = baroclinic_termx(i,j) + baroclinic_triad*Thickness%dzwt(i,j,k)
           endif 

           tx_trans_gm(i,j,k)    = 0.25*tx_trans_gm(i,j,k)*Grd%dyu(i,j)

           !mindelqc(jq,kr) = min(delqc(i,j-1+jq,k+kr,1-kr),delqc(i,j+jq,k+kr,1-kr)) 
           jq=0 ; kr=0
           mindelqc(jq,kr)  = min(delqc(i,j-1,k,1),delqc_ijk_1) 
           jq=0 ; kr=1
           mindelqc(jq,kr)  = min(delqc(i,j-1,k+1,0),delqc_ijkp1_0) 
           jq=1 ; kr=0
           mindelqc(jq,kr)  = min(delqc_ijk_1,delqc(i,j+1,k,1)) 
           jq=1 ; kr=1
           mindelqc(jq,kr)  = min(delqc_ijkp1_0,delqc(i,j+1,k+1,0)) 

           ty_trans_gm(i,j,k) = 0.0
           baroclinic_triad   = 0.0 

           jq=0   
              sumy(jq) = 0.0

               kr=0
                 slope        = tensor_32(i,j,k,jq,kr)
                 absslope     = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Grd%zt(k)) then      
                     gm_taper_slope = (Grd%zt(k)/depth_blayer_base(i,j))*slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 ty_trans_gm(i,j,k)          = ty_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope       
                 tensor_32(i,j,k,jq,kr)      = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumy(jq)                    = sumy(jq)                 + mindelqc(jq,kr)*taper_slope2
                 eady_termy(i,j,k)           = eady_termy(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad            = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)

              kr=1
                 slope        = tensor_32(i,j,k,jq,kr)
                 absslope     = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Grd%zt(k)) then      
                     gm_taper_slope = (Grd%zt(k)/depth_blayer_base(i,j))*slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 ty_trans_gm(i,j,k)          = ty_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope      
                 tensor_32(i,j,k,jq,kr)      = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumy(jq)                    = sumy(jq)                 + mindelqc(jq,kr)*taper_slope2
                 eady_termy(i,j,k)           = eady_termy(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad            = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)
                 sumy(jq)                    = sumy(jq)*dtns(i,j,jq)

           jq=1   
              sumy(jq) = 0.0

               kr=0
                 slope    = tensor_32(i,j,k,jq,kr)
                 absslope = abs(slope)

                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Grd%zt(k)) then      
                     gm_taper_slope = (Grd%zt(k)/depth_blayer_base(i,j))*slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 ty_trans_gm(i,j,k)          = ty_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope     
                 tensor_32(i,j,k,jq,kr)      = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumy(jq)                    = sumy(jq)                 + mindelqc(jq,kr)*taper_slope2
                 eady_termy(i,j,k)           = eady_termy(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad            = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)

              kr=1
                 slope    = tensor_32(i,j,k,jq,kr)
                 absslope = abs(slope)

                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif

                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif

                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope
                 taper_slope2 = slope*taper_slope

                 ! taper times slope for use with GM skewsion
                 if(depth_blayer_base(i,j) >= Grd%zt(k)) then      
                     gm_taper_slope = (Grd%zt(k)/depth_blayer_base(i,j))*slope_blayer_base(i,j)*sign(1.0,slope) 
                 else 
                     gm_taper_slope = taper_slope
                 endif

                 ty_trans_gm(i,j,k)          = ty_trans_gm(i,j,k)       + agm_scalar*gm_taper_slope      
                 tensor_32(i,j,k,jq,kr)      = aredi_scalar*taper_slope + agm_scalar*gm_taper_slope
                 sumy(jq)                    = sumy(jq)                 + mindelqc(jq,kr)*taper_slope2
                 eady_termy(i,j,k)           = eady_termy(i,j,k)        + absdrhodzb(kr)*absslope*absslope
                 baroclinic_triad            = baroclinic_triad         + absdrhodzb(kr)*abs(taper_slope)

                 sumy(jq) = sumy(jq)*dtns(i,j,jq)

           if(Thickness%depth_zt(i,j,k) >= agm_closure_upper_depth .and. &
              Thickness%depth_zt(i,j,k) <= agm_closure_lower_depth) then
             baroclinic_termy(i,j) = baroclinic_termy(i,j) + baroclinic_triad*Thickness%dzwt(i,j,k)
           endif 

           ty_trans_gm(i,j,k)    = 0.25*ty_trans_gm(i,j,k)*Grd%dxu(i,j)
           
           K33 = aredi_scalar*Grd%tmask(i,j,k+1)*(Grd%dxtr(i,j)*(sumx(0)+sumx(1)) &
                            + Grd%dytr(i,j)*(sumy(0)+sumy(1)))*dzwtr(i,j,k)

           ! determine part of K33 included explicitly in time and that part implicitly. 
           ! explicit calculation is more accurate than implicit, so aim to compute as much 
           ! as stably possible via the explicit method. 
           K33_explicit(i,j,k) = K33
           K33_implicit(i,j,k) = 0.0 
           if(.not. diffusion_all_explicit) then 
               K33_crit = two_dtime_inv*Thickness%rho_dzt(i,j,k,tau)*Thickness%dzt(i,j,k)
               if(K33 >= K33_crit) then 
                   K33_explicit(i,j,k) = K33_crit
                   K33_implicit(i,j,k) = K33-K33_crit
               endif
           endif

        enddo
     enddo
  enddo

  if(tmask_sigma_on) then
     do j=jsc,jec
        do i=isc,iec
           if(tmask_sigma(i,j) > 0.0) then 
              k = Grd%kmt(i,j)-1
              K33_implicit(i,j,k) = K33_implicit(i,j,k)*(1.0-tmask_sigma(i,j))
              K33_explicit(i,j,k) = K33_explicit(i,j,k)*(1.0-tmask_sigma(i,j))
           endif
        enddo
     enddo
 endif
 
 if(tmask_neutral_on) then
     do j=jsc,jec
        do i=isc,iec
           K33_implicit(i,j,1) = 0.0  
           K33_explicit(i,j,1) = 0.0  
           tx_trans_gm(i,j,1)  = 0.0  
           ty_trans_gm(i,j,1)  = 0.0  
           if(Grd%kmt(i,j) > 1) then 
               k = Grd%kmt(i,j)-1
               K33_implicit(i,j,k) = 0.0
               K33_explicit(i,j,k) = 0.0
               tx_trans_gm(i,j,k)  = 0.0  
               ty_trans_gm(i,j,k)  = 0.0  
           endif
        enddo
     enddo
 endif

 do n=1,num_prog_tracers 
   T_prog(n)%K33_implicit(:,:,:) = K33_implicit(:,:,:)
 enddo
 if(neutral_physics_limit) then 
     do n=1,num_prog_tracers 
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                if(T_prog(n)%tmask_limit(i,j,k)==1.0) T_prog(n)%K33_implicit(i,j,k) = 0.0
              enddo
           enddo
        enddo
     enddo
 endif


  do n=1,num_prog_tracers
     if (id_k33_implicit(n) > 0) then
        call diagnose_3d(Time, Grd, id_k33_implicit(n), rho0r*T_prog(n)%K33_implicit(:,:,:))
     endif 
  enddo 


  ! rho factor to get mass transport.
  if(vert_coordinate_class==DEPTH_BASED) then 
      do k=1,nk
         tx_trans_gm(COMP,k) = tx_trans_gm(COMP,k)*rho0
         ty_trans_gm(COMP,k) = ty_trans_gm(COMP,k)*rho0
      enddo
  else
      do k=1,nk
         tx_trans_gm(COMP,k) = tx_trans_gm(COMP,k)*rho(COMP,k)
         ty_trans_gm(COMP,k) = ty_trans_gm(COMP,k)*rho(COMP,k)
      enddo
  endif

  call transport_on_rho_gm (Time, Dens, &
       transport_convert*tx_trans_gm(:,:,:), transport_convert*ty_trans_gm(:,:,:))
  call transport_on_nrho_gm(Time, Dens, &
       transport_convert*tx_trans_gm(:,:,:), transport_convert*ty_trans_gm(:,:,:))
  call transport_on_theta_gm(Time, Dens, T_prog(index_temp), &
       transport_convert*tx_trans_gm(:,:,:), transport_convert*ty_trans_gm(:,:,:))

  ! transport_convert converts kg/s to chosen dimensions (either kg/s or Sv (10^9 kg/s)) 
  if(id_tx_trans_gm > 0) then 
      call mpp_update_domains(tx_trans_gm, Dom%domain2d,flags=EUPDATE)
      do k=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               tx_trans_gm(i,j,k) = transport_convert*Grd%dxuer(i,j)*   &
                                   (tx_trans_gm(i+1,j,k)*Grd%due(i,j) + &
                                    tx_trans_gm(i,j,k)  *Grd%duw(i+1,j))
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_tx_trans_gm, tx_trans_gm(:,:,:))
  endif

  ! transport_convert converts kg/s to chosen dimensions (either kg/s or Sv (10^9 kg/s))  
  if(id_ty_trans_gm > 0) then 
      call mpp_update_domains(ty_trans_gm, Dom%domain2d,flags=NUPDATE)
      do k=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               ty_trans_gm(i,j,k) = transport_convert*Grd%dyunr(i,j)*           &
                                          (ty_trans_gm(i,j+1,k)*Grd%dun(i,j) +  &
                                           ty_trans_gm(i,j,k)  *Grd%dus(i,j+1)) 
                                        
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_ty_trans_gm, ty_trans_gm(:,:,:))
  endif

  call mpp_clock_end(id_clock_fz_terms)

end subroutine fz_terms
! </SUBROUTINE>  NAME="fz_terms"


!#######################################################################
! <SUBROUTINE NAME="fz_terms_diag">
!
! <DESCRIPTION>
! For saving the contributions from GM and Redi separately, it is 
! necessary to compute the tensor_redi component here. 
!
! We do so here, reproducing some lines of code from fz_terms,
! to reduce minimize the need to impinge on the case when NOT
! using this generally expensive (memory and computational)
! diagnostic.  
!
! This routine MUST be called prior to fz_terms, since we use
! tensor_31 and tensor_32 in their raw slope forms here.  
!
! </DESCRIPTION>
!
subroutine fz_terms_diag(Time)

  type(ocean_time_type), intent(in) :: Time

  integer :: i, j, k, ip, jq, kr, tau

  real :: slope, absslope, depth_ratio
  real :: taperA, taperB
  real :: taper_slope
  real :: aredi_scalar

  call mpp_clock_begin(id_clock_fz_terms_diag)

  tau = Time%tau
  
  ! Main loop. Short ip,jq,kr loops are explicitly unrolled
  ! in order to expose independence and allow vectorisation
  do k=1,nk-1
     do j=jsc,jec
        do i=isc,iec

           aredi_scalar = aredi_array(i,j,k)

           ip=0   

              kr=0
                 slope    = tensor_31(i,j,k,ip,kr)
                 absslope = abs(slope)
                 
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_31_redi(i,j,k,ip,kr) = aredi_scalar*taper_slope

              kr=1
                 slope    = tensor_31(i,j,k,ip,kr)
                 absslope = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_31_redi(i,j,k,ip,kr) = aredi_scalar*taper_slope 

           ip=1   

              kr=0
                 slope        = tensor_31(i,j,k,ip,kr)
                 absslope     = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_31_redi(i,j,k,ip,kr) = aredi_scalar*taper_slope 

              kr=1
                 slope        = tensor_31(i,j,k,ip,kr)
                 absslope     = abs(slope)
                                                     
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_31_redi(i,j,k,ip,kr) = aredi_scalar*taper_slope 

           jq=0   

               kr=0
                 slope        = tensor_32(i,j,k,jq,kr)
                 absslope     = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_32_redi(i,j,k,jq,kr) = aredi_scalar*taper_slope 

              kr=1
                 slope        = tensor_32(i,j,k,jq,kr)
                 absslope     = abs(slope)
                           
                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_32_redi(i,j,k,jq,kr) = aredi_scalar*taper_slope 

           jq=1   

               kr=0
                 slope    = tensor_32(i,j,k,jq,kr)
                 absslope = abs(slope)

                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_32_redi(i,j,k,jq,kr) = aredi_scalar*taper_slope 

              kr=1
                 slope    = tensor_32(i,j,k,jq,kr)
                 absslope = abs(slope)

                 ! taper for steep slope regions 
                 if(absslope > smax) then 
                     taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                     taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
                 else 
                     taperA = 1.0
                 endif
                 ! taper for grid depths shallower than eddy_depth
                 if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                     depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                     taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
                 else 
                     taperB          = 1.0
                 endif
                 ! taper times slope for use with neutral diffusion
                 taper_slope  = taperA*taperB*slope

                 tensor_32_redi(i,j,k,jq,kr) = aredi_scalar*taper_slope 

        enddo
     enddo
  enddo


  call mpp_clock_end(id_clock_fz_terms_diag)

end subroutine fz_terms_diag
! </SUBROUTINE>  NAME="fz_terms_diag"


!#######################################################################
! <SUBROUTINE NAME="fx_flux">
!
! <DESCRIPTION>
! Subroutine computes the i-directed neutral physics tracer flux component.
! Compute this component for all tracers at level k.
!
! fx has physical dimensions (area*diffusivity*density*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fx_flux(Time, Thickness, T_prog, k)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer,                      intent(in) :: k

  integer :: nn, i, j, ip, tau
  integer :: kr, kpkr
  real    :: triad_weight(isd:ied,jsd:jed)
  real    :: tensor_11(isd:ied,jsd:jed,0:1,0:1)
  real    :: tensor_13(isd:ied,jsd:jed,0:1,0:1)
  real    :: sumz(isd:ied,jsd:jed,0:1)
  real    :: taperA, taperB
  real    :: slope, absslope, taper_slope, gm_taper_slope
  real    :: depth_ratio
  real    :: drhodx, drhodz 

  tau = Time%tau

  ! initialize arrays to zero 
  tensor_11(:,:,:,:)           = 0.0
  tensor_13(:,:,:,:)           = 0.0
  grav_agm_dz_sx_drhodx(:,:,k) = 0.0
  slopex_drhodx(:,:,k)         = 0.0
  triad_weight(:,:)            = 0.0

  ! tracer-independent part of the calculation 
  do kr=0,1
     kpkr = min(k+kr,nk)
     do ip=0,1 
        do j=jsc,jec
           do i=isc-1,iec

              drhodz   = drhodzh(i+ip,j,k,kr)
              drhodx   = Grd%tmask(i+ip,j,kpkr)                            &
                        *( drhodT(i+ip,j,k)*dTdx(index_temp)%field(i,j,k)  &
                          +drhodS(i+ip,j,k)*dSdx%field(i,j,k))
              slope    = -drhodx/drhodz
              absslope = abs(slope)

              ! taper for steep slope regions 
              if(absslope > smax) then 
                  taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                  taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
              else 
                  taperA = 1.0
              endif

              ! taper for grid depths shallower than eddy_depth
              if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                  depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                  taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
              else 
                  taperB          = 1.0
              endif

              ! taper times slope for use with neutral diffusion
              taper_slope  = taperA*taperB*slope

              ! taper times slope for use with GM skewsion
              if(depth_blayer_base(i,j) >= Grd%zt(k)) then      
                  gm_taper_slope = (Grd%zt(k)/depth_blayer_base(i,j))*slope_blayer_base(i,j)*sign(1.0,slope) 
              else 
                  gm_taper_slope = taper_slope
              endif

              ! for diagnosing slope dot grad rho
              triad_weight(i,j)            = triad_weight(i,j)    + Grd%tmask(i+ip,j,kpkr)
              slopex_drhodx(i,j,k)         = slopex_drhodx(i,j,k) + gm_taper_slope*drhodx

              ! fill tensor components 
              tensor_11(i,j,ip,kr)      = aredi_array(i,j,k)*( (1.0-taper_diagonal) + taperA*taperB*taper_diagonal)  &
                                        + ah_array(i,j)*(1.0-taperB)
              tensor_13(i,j,ip,kr)      = aredi_array(i,j,k)*taper_slope-gm_skew*agm_array(i,j,k)*gm_taper_slope

           enddo
        enddo
     enddo
  enddo

  ! tracer-dependent part of the calculation
  do nn=1,num_prog_tracers
     sumz(:,:,:) = 0.0
     do kr=0,1
        do ip=0,1
           do j=jsc,jec
              do i=isc-1,iec
                sumz(i,j,kr) = sumz(i,j,kr) + dtwedyt(i,j,ip)*Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k) &
                *(tensor_11(i,j,ip,kr)*dTdx(nn)%field(i,j,k) + tensor_13(i,j,ip,kr)*dTdz(nn)%field(i+ip,j,k-1+kr)) &
                * min(delqc(i,j,k,kr),delqc(i+1,j,k,kr))
              enddo
           enddo
        enddo
     enddo
     flux_x(nn)%field(COMPXL,k) = Grd%dxter(COMPXL)*(sumz(COMPXL,0)+sumz(COMPXL,1))
  enddo

  ! apply some masks 
  if(tmask_neutral_on) then
     do nn=1,num_prog_tracers
        do j=jsc,jec
           do i=isc-1,iec
              if(k==Grd%kmt(i,j)) then
                flux_x(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdx(nn)%field(i,j,k)*Grd%dyte(i,j)* &
                                          min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i+1,j,k,tau))
              endif
           enddo
        enddo
     enddo
     if(k==1) then
         do nn=1,num_prog_tracers
            flux_x(nn)%field(:,:,k) = aredi_array(:,:,k)*dTdx(nn)%field(:,:,k)*Grd%dyte(:,:) &
                                      *FMX(Thickness%rho_dzt(:,:,k,tau))
         enddo
     endif
  endif
  if(tmask_sigma_on) then
     do nn=1,num_prog_tracers
        do j=jsc,jec
           do i=isc-1,iec
              if(k==Grd%kmt(i,j)) flux_x(nn)%field(i,j,k) = flux_x(nn)%field(i,j,k)*(1.0-tmask_sigma(i,j))
           enddo
        enddo
     enddo
 endif

 if(neutral_physics_limit) then 
     do nn=1,num_prog_tracers
        do j=jsc,jec
           do i=isc-1,iec
              if(T_prog(nn)%tmask_limit(i,j,k)==1.0) then 
                  flux_x(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdx(nn)%field(i,j,k)*Grd%dyte(i,j) &
                                            *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i+1,j,k,tau))
              endif
           enddo
        enddo
     enddo
 endif


 ! for diagnosing slopex_drhodx and grav_agm_dz_sx_drhodx 
 do j=jsc,jec
    do i=isc,iec
       if(triad_weight(i,j) > 0.0) then 
           triad_weight(i,j)            = 1.0/(epsln + triad_weight(i,j))
           slopex_drhodx(i,j,k)         = triad_weight(i,j)*slopex_drhodx(i,j,k)
           grav_agm_dz_sx_drhodx(i,j,k) = slopex_drhodx(i,j,k) &
                                          *grav*agm_array(i,j,k)*Thickness%dzt(i,j,k)
       else 
           slopex_drhodx(i,j,k)         = 0.0
           grav_agm_dz_sx_drhodx(i,j,k) = 0.0
       endif
    enddo
 enddo

 if(k==nk) then 
    call diagnose_3d(Time, Grd, id_grav_agm_dz_sx_drhodx, grav_agm_dz_sx_drhodx(:,:,:))
    call diagnose_3d(Time, Grd, id_slopex_drhodx, slopex_drhodx(:,:,:))
 endif

end subroutine fx_flux
! </SUBROUTINE> NAME="fx_flux"


!#######################################################################
! <SUBROUTINE NAME="fx_flux_diag">
!
! <DESCRIPTION>
! Subroutine computes the i-directed neutral physics tracer flux component
! for Redi separately from GM, in order to diagnose GM and Redi 
! fluxes independent of one another. 
!
! Compute this component for all tracers at level k.
!
! fx has physical dimensions (area*diffusivity*density*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fx_flux_diag(Time, Thickness, T_prog, k)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer,                      intent(in) :: k

  integer :: nn, i, j, ip, tau
  integer :: kr, kpkr
  real    :: tensor_11(isd:ied,jsd:jed,0:1,0:1)
  real    :: tensor_13_redi(isd:ied,jsd:jed,0:1,0:1)
  real    :: sumz(isd:ied,jsd:jed,0:1)
  real    :: taperA, taperB
  real    :: slope, absslope, taper_slope
  real    :: depth_ratio
  real    :: drhodx, drhodz 

  tau = Time%tau

  ! initialize arrays to zero 
  tensor_13_redi(:,:,:,:) = 0.0


  ! tracer-independent part of the calculation 
  do kr=0,1
     kpkr = min(k+kr,nk)
     do ip=0,1 
        do j=jsc,jec
           do i=isc-1,iec

              drhodz   = drhodzh(i+ip,j,k,kr)
              drhodx   = Grd%tmask(i+ip,j,kpkr)                            &
                        *( drhodT(i+ip,j,k)*dTdx(index_temp)%field(i,j,k)  &
                          +drhodS(i+ip,j,k)*dSdx%field(i,j,k))
              slope    = -drhodx/drhodz
              absslope = abs(slope)

              ! taper for steep slope regions 
              if(absslope > smax) then 
                  taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                  taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
              else 
                  taperA = 1.0
              endif

              ! taper for grid depths shallower than eddy_depth
              if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                  depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                  taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
              else 
                  taperB          = 1.0
              endif

              ! taper times slope for use with neutral diffusion
              taper_slope  = taperA*taperB*slope

              ! fill tensor components 
              tensor_11(i,j,ip,kr)      = aredi_array(i,j,k)*( (1.0-taper_diagonal) + taperA*taperB*taper_diagonal)  &
                                        + ah_array(i,j)*(1.0-taperB)
              tensor_13_redi(i,j,ip,kr) = aredi_array(i,j,k)*taper_slope 

           enddo
        enddo
     enddo
  enddo

  ! tracer dependent portion of calculation 
  do nn=1,num_prog_tracers
     sumz(:,:,:) = 0.0
     do kr=0,1
        do ip=0,1
           do j=jsc,jec
              do i=isc-1,iec
                 sumz(i,j,kr) = sumz(i,j,kr) + dtwedyt(i,j,ip)*Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k) &
                      *(tensor_11(i,j,ip,kr)*dTdx(nn)%field(i,j,k) + tensor_13_redi(i,j,ip,kr)*dTdz(nn)%field(i+ip,j,k-1+kr)) &
                      * min(delqc(i,j,k,kr),delqc(i+1,j,k,kr))
              enddo
           enddo
        enddo
     enddo
     flux_x_redi(nn)%field(COMPXL,k) = Grd%dxter(COMPXL)*(sumz(COMPXL,0)+sumz(COMPXL,1))
  enddo
 
  ! apply some masks 

  if(tmask_neutral_on) then
      do nn=1,num_prog_tracers
         do j=jsc,jec
            do i=isc-1,iec
               if(k==Grd%kmt(i,j)) then
                   flux_x_redi(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdx(nn)%field(i,j,k)*Grd%dyte(i,j)* &
                        min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i+1,j,k,tau))
               endif
            enddo
         enddo
      enddo
      if(k==1) then
          do nn=1,num_prog_tracers
             flux_x_redi(nn)%field(:,:,k) = aredi_array(:,:,k)*dTdx(nn)%field(:,:,k)*Grd%dyte(:,:) &
                  *FMX(Thickness%rho_dzt(:,:,k,tau))
          enddo
      endif
  endif
  if(tmask_sigma_on) then
      do nn=1,num_prog_tracers
         do j=jsc,jec
            do i=isc-1,iec
               if(k==Grd%kmt(i,j)) then 
                   flux_x_redi(nn)%field(i,j,k) = flux_x_redi(nn)%field(i,j,k)*(1.0-tmask_sigma(i,j))
               endif
            enddo
         enddo
      enddo
  endif
  if(neutral_physics_limit) then 
      do nn=1,num_prog_tracers
         do j=jsc,jec
            do i=isc-1,iec
               if(T_prog(nn)%tmask_limit(i,j,k)==1.0) then 
                   flux_x_redi(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdx(nn)%field(i,j,k)*Grd%dyte(i,j) &
                        *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i+1,j,k,tau))
               endif
            enddo
         enddo
      enddo
  endif


end subroutine fx_flux_diag
! </SUBROUTINE> NAME="fx_flux_diag"



!#######################################################################
! <SUBROUTINE NAME="fy_flux">
!
! <DESCRIPTION>
! Subroutine computes the j-directed neutral physics tracer flux component.
! Compute this component for all tracers at level k.
!
! fy has physical dimensions (area*diffusivity*density*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fy_flux(Time, Thickness, T_prog, k)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer,                      intent(in) :: k

  integer :: nn, i, j, jq, tau
  integer :: kr, kpkr
  real :: triad_weight(isd:ied,jsd:jed)
  real :: tensor_22(isd:ied,jsd:jed,0:1,0:1)
  real :: tensor_23(isd:ied,jsd:jed,0:1,0:1)
  real :: sumz(isd:ied,jsd:jed,0:1)
  real :: taperA, taperB
  real :: slope, absslope, taper_slope, gm_taper_slope
  real :: depth_ratio
  real :: drhody, drhodz 

  tau = Time%tau 

  ! initialize arrays to zero 
  tensor_22(:,:,:,:)           = 0.0
  tensor_23(:,:,:,:)           = 0.0
  grav_agm_dz_sy_drhody(:,:,k) = 0.0
  slopey_drhody(:,:,k)         = 0.0
  triad_weight(:,:)            = 0.0

  ! tracer-independent part of the calculation 
  do kr=0,1
     kpkr = min(k+kr,nk)
     do jq=0,1  
       do j=jsc-1,jec
          do i=isc,iec
 
              drhodz   = drhodzh(i,j+jq,k,kr) 
              drhody   = Grd%tmask(i,j+jq,kpkr)                            &
                        *( drhodT(i,j+jq,k)*dTdy(index_temp)%field(i,j,k)  &
                          +drhodS(i,j+jq,k)*dSdy%field(i,j,k)) 
              slope    = -drhody/drhodz
              absslope = abs(slope)  

              ! taper for steep slope regions 
              if(absslope > smax) then 
                  taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                  taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
              else 
                  taperA = 1.0
              endif

              ! taper for grid depths shallower than eddy_depth
              if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                  depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                  taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
              else 
                  taperB          = 1.0
              endif

              ! taper times slope for use with neutral diffusion
              taper_slope  = taperA*taperB*slope

              ! taper times slope for use with GM skewsion
              if(depth_blayer_base(i,j) >= Grd%zt(k)) then      
                  gm_taper_slope = (Grd%zt(k)/depth_blayer_base(i,j))*slope_blayer_base(i,j)*sign(1.0,slope) 
              else 
                  gm_taper_slope = taper_slope
              endif

              ! for diagnosing slope dot grad rho
              triad_weight(i,j)    = triad_weight(i,j)    + Grd%tmask(i,j+jq,kpkr) 
              slopey_drhody(i,j,k) = slopey_drhody(i,j,k) + gm_taper_slope*drhody

              ! fill tensor components 
              tensor_22(i,j,jq,kr)      = aredi_array(i,j,k)*( (1.0-taper_diagonal) + taperA*taperB*taper_diagonal) &
                                        + ah_array(i,j)*(1.0-taperB)
              tensor_23(i,j,jq,kr)      = aredi_array(i,j,k)*taper_slope-gm_skew*agm_array(i,j,k)*gm_taper_slope

           enddo
        enddo
     enddo
  enddo

  ! tracer-dependent part of the calculation
  do nn=1,num_prog_tracers
     sumz(:,:,:) = 0.0
     do kr=0,1
        do jq=0,1
           do j=jsc-1,jec
              do i=isc,iec
                 sumz(i,j,kr) = sumz(i,j,kr) + dxtdtsn(i,j,jq)*Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k) &
                 *(tensor_22(i,j,jq,kr)*dTdy(nn)%field(i,j,k) + tensor_23(i,j,jq,kr)*dTdz(nn)%field(i,j+jq,k-1+kr)) &
                 * min(delqc(i,j,k,kr),delqc(i,j+1,k,kr))
              enddo
           enddo
        enddo
     enddo
     flux_y(nn)%field(COMPYL,k) = Grd%dytnr(COMPYL)*(sumz(COMPYL,0)+sumz(COMPYL,1))
  enddo


  ! apply some masks 
  if(tmask_neutral_on) then
     do nn=1,num_prog_tracers
        do j=jsc-1,jec
           do i=isc,iec
              if(k==Grd%kmt(i,j)) then
                flux_y(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdy(nn)%field(i,j,k)*Grd%dxtn(i,j) &
                                          *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i,j+1,k,tau))
              endif
           enddo
        enddo
     enddo
     if(k==1) then
         do nn=1,num_prog_tracers
            flux_y(nn)%field(:,:,k) = &
            aredi_array(:,:,k)*dTdy(nn)%field(:,:,k)*Grd%dxtn(:,:)*FMY(Thickness%rho_dzt(:,:,k,tau))
         enddo
     endif
  endif
  if(tmask_sigma_on) then
      do nn=1,num_prog_tracers
         do j=jsc-1,jec
            do i=isc,iec
               if(k==Grd%kmt(i,j)) flux_y(nn)%field(i,j,k) = flux_y(nn)%field(i,j,k)*(1.0-tmask_sigma(i,j))
            enddo
         enddo
      enddo
  endif

  if(neutral_physics_limit) then 
      do nn=1,num_prog_tracers
         do j=jsc-1,jec
            do i=isc,iec
               if(T_prog(nn)%tmask_limit(i,j,k)==1.0) then 
                   flux_y(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdy(nn)%field(i,j,k)*Grd%dxtn(i,j) &
                                             *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i,j+1,k,tau))
               endif
            enddo
         enddo
      enddo
  endif

 ! for diagnosing slopey_drhody and grav_agm_dz_sy_drhody
 do j=jsc,jec
    do i=isc,iec
       if(triad_weight(i,j) > 0.0) then 
           triad_weight(i,j)    = 1.0/(epsln + triad_weight(i,j))
           slopey_drhody(i,j,k) = triad_weight(i,j)*slopey_drhody(i,j,k)
           grav_agm_dz_sy_drhody(i,j,k) = slopey_drhody(i,j,k) &
                                          *grav*agm_array(i,j,k)*Thickness%dzt(i,j,k)
       else 
           slopey_drhody(i,j,k)         = 0.0
           grav_agm_dz_sy_drhody(i,j,k) = 0.0
       endif
    enddo
 enddo

 if(k==nk) then 
    call diagnose_3d(Time, Grd, id_grav_agm_dz_sy_drhody, grav_agm_dz_sy_drhody(:,:,:))
    call diagnose_3d(Time, Grd, id_slopey_drhody, slopey_drhody(:,:,:))
     if(id_gm_eddy_ke_source > 0) then 
        call diagnose_3d(Time, Grd, id_gm_eddy_ke_source, grav_agm_dz_sx_drhodx(:,:,:) &
             +grav_agm_dz_sy_drhody(:,:,:))
     endif
 endif

end subroutine fy_flux
! </SUBROUTINE> NAME="fy_flux"



!#######################################################################
! <SUBROUTINE NAME="fy_flux_diag">
!
! <DESCRIPTION>
! Subroutine computes the j-directed neutral physics tracer flux component
! for Redi separately, in order to diagnose GM and Redi contributions
! independent of one another. 
!
! Compute this component for all tracers at level k.
!
! fy has physical dimensions (area*diffusivity*density*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fy_flux_diag(Time, Thickness, T_prog, k)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer,                      intent(in) :: k

  integer :: nn, i, j, jq, tau
  integer :: kr, kpkr
  real :: tensor_22(isd:ied,jsd:jed,0:1,0:1)
  real :: tensor_23_redi(isd:ied,jsd:jed,0:1,0:1)
  real :: sumz(isd:ied,jsd:jed,0:1)
  real :: taperA, taperB
  real :: slope, absslope, taper_slope
  real :: depth_ratio
  real :: drhody, drhodz 

  tau = Time%tau 

  ! initialize arrays to zero 
  tensor_22(:,:,:,:)       = 0.0
  tensor_23_redi(:,:,:,:)  = 0.0

  ! tracer-independent part of the calculation 
  do kr=0,1
     kpkr = min(k+kr,nk)
     do jq=0,1  
       do j=jsc-1,jec
          do i=isc,iec
 
              drhodz   = drhodzh(i,j+jq,k,kr) 
              drhody   = Grd%tmask(i,j+jq,kpkr)                            &
                        *( drhodT(i,j+jq,k)*dTdy(index_temp)%field(i,j,k)  &
                          +drhodS(i,j+jq,k)*dSdy%field(i,j,k)) 
              slope    = -drhody/drhodz
              absslope = abs(slope)  

              ! taper for steep slope regions 
              if(absslope > smax) then 
                  taperA = 0.5*(1.0 + tanh(smax_swidthr-absslope*swidthr))             
                  taperA = dm_taper_const*taperA + gkw_taper_const*(smax/absslope)**2
              else 
                  taperA = 1.0
              endif

              ! taper for grid depths shallower than eddy_depth
              if(eddy_depth(i,j) >= Grd%zt(k)) then                                           
                  depth_ratio     = Grd%zt(k)/(epsln+eddy_depth(i,j))
                  taperB          = 0.5*(1.0 + sin(pi*(depth_ratio-0.5)))
              else 
                  taperB          = 1.0
              endif

              ! taper times slope for use with neutral diffusion
              taper_slope  = taperA*taperB*slope

              ! fill tensor components 
              tensor_22(i,j,jq,kr)      = aredi_array(i,j,k)*( (1.0-taper_diagonal) + taperA*taperB*taper_diagonal) &
                                        + ah_array(i,j)*(1.0-taperB)
              tensor_23_redi(i,j,jq,kr) = aredi_array(i,j,k)*taper_slope 

           enddo
        enddo
     enddo
  enddo


  ! tracer dependent portion of calculation  
  do nn=1,num_prog_tracers
     sumz(:,:,:) = 0.0
     do kr=0,1
        do jq=0,1
           do j=jsc-1,jec
              do i=isc,iec
                 sumz(i,j,kr) = sumz(i,j,kr) + dxtdtsn(i,j,jq)*Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)                            &
                      *(tensor_22(i,j,jq,kr)*dTdy(nn)%field(i,j,k) + tensor_23_redi(i,j,jq,kr)*dTdz(nn)%field(i,j+jq,k-1+kr)) &
                      * min(delqc(i,j,k,kr),delqc(i,j+1,k,kr))
              enddo
           enddo
        enddo
     enddo
     flux_y_redi(nn)%field(COMPYL,k) = Grd%dytnr(COMPYL)*(sumz(COMPYL,0)+sumz(COMPYL,1))
  enddo


  ! apply some masks 
  if(tmask_neutral_on) then
      do nn=1,num_prog_tracers
         do j=jsc-1,jec
            do i=isc,iec
               if(k==Grd%kmt(i,j)) then
                   flux_y_redi(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdy(nn)%field(i,j,k)*Grd%dxtn(i,j) &
                        *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i,j+1,k,tau))
               endif
            enddo
         enddo
      enddo
      if(k==1) then
          do nn=1,num_prog_tracers
             flux_y_redi(nn)%field(:,:,k) = &
                  aredi_array(:,:,k)*dTdy(nn)%field(:,:,k)*Grd%dxtn(:,:)*FMY(Thickness%rho_dzt(:,:,k,tau))
          enddo
      endif
  endif
  if(tmask_sigma_on) then
      do nn=1,num_prog_tracers
         do j=jsc-1,jec
            do i=isc,iec
               if(k==Grd%kmt(i,j)) then 
                   flux_y_redi(nn)%field(i,j,k) = flux_y_redi(nn)%field(i,j,k)*(1.0-tmask_sigma(i,j))
               endif
            enddo
         enddo
      enddo
  endif
  if(neutral_physics_limit) then 
      do nn=1,num_prog_tracers
         do j=jsc-1,jec
            do i=isc,iec
               if(T_prog(nn)%tmask_limit(i,j,k)==1.0) then 
                   flux_y_redi(nn)%field(i,j,k) = aredi_array(i,j,k)*dTdy(nn)%field(i,j,k)*Grd%dxtn(i,j) &
                        *min(Thickness%rho_dzt(i,j,k,tau),Thickness%rho_dzt(i,j+1,k,tau))
               endif
            enddo
         enddo
      enddo
  endif

end subroutine fy_flux_diag
! </SUBROUTINE> NAME="fy_flux_diag"


!#######################################################################
! <SUBROUTINE NAME="fz_flux">
!
! <DESCRIPTION>
! Subroutine computes the vertical neutral physics tracer flux component.
! Compute this component for all tracers at level k.
! Surface and bottom boundary condition fz(k=0)=fz(k=kmt(i,j))=0
!
! fz has physical dimensions (density*diffusivity*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fz_flux(T_prog, k)

  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer, intent(in) :: k

  integer :: nn, i, j, ip, jq, kr
  real :: sumx_0, sumx_1, sumy_0, sumy_1
  real :: temparray31(isc:iec,jsc:jec,0:1,0:1)
  real :: temparray32(isc:iec,jsc:jec,0:1,0:1)

  if(tmask_neutral_on .and. k==1) then
     do nn = 1, num_prog_tracers
       fz2(nn)%field(:,:)      = 0.0 
      enddo
     return 
  endif

  if(k==nk) then 

     do nn = 1, num_prog_tracers
        fz2(nn)%field(COMP) = 0.0
     enddo
     return  

  elseif(k < nk) then  

      ! tracer-independent part of the calculation 
      do kr=0,1
         do ip=0,1
            do j=jsc,jec
               do i=isc,iec
                  temparray31(i,j,ip,kr) = tensor_31(i,j,k,ip,kr)*dtew(i,j,ip) &
                       *min(delqc(i-1+ip,j,k+kr,1-kr),delqc(i+ip,j,k+kr,1-kr))
               enddo
            enddo
         enddo
         do jq=0,1
            do j=jsc,jec
               do i=isc,iec
                  temparray32(i,j,jq,kr) = tensor_32(i,j,k,jq,kr)*dtns(i,j,jq) &
                       *min(delqc(i,j-1+jq,k+kr,1-kr),delqc(i,j+jq,k+kr,1-kr))  
               enddo
            enddo
         enddo
      enddo

      ! tracer-dependent part of the calculation  
      do nn=1,num_prog_tracers
         do j=jsc,jec
            do i=isc,iec

               ! compute time explicit portion of the vertical flux
               sumx_0 =  temparray31(i,j,0,0)*dTdx(nn)%field(i-1,j,k) &
                      +  temparray31(i,j,0,1)*dTdx(nn)%field(i-1,j,k+1)
               sumx_1 =  temparray31(i,j,1,0)*dTdx(nn)%field(i,j,k) &
                      +  temparray31(i,j,1,1)*dTdx(nn)%field(i,j,k+1)
               sumy_0 =  temparray32(i,j,0,0)*dTdy(nn)%field(i,j-1,k) &
                      +  temparray32(i,j,0,1)*dTdy(nn)%field(i,j-1,k+1)
               sumy_1 =  temparray32(i,j,1,0)*dTdy(nn)%field(i,j,k) &
                      +  temparray32(i,j,1,1)*dTdy(nn)%field(i,j,k+1)
               fz2(nn)%field(i,j) =   Grd%tmask(i,j,k+1) &
                    *( Grd%dxtr(i,j)*(sumx_0+sumx_1) &
                      +Grd%dytr(i,j)*(sumy_0+sumy_1)) &
                    *dzwtr(i,j,k) &
                    + K33_explicit(i,j,k)*dTdz(nn)%field(i,j,k)

            enddo
         enddo
      enddo

      ! apply some masks       
      if(tmask_neutral_on) then
          do nn=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(k==(Grd%kmt(i,j)-1))  then 
                       fz2(nn)%field(i,j) = 0.0
                   endif  
                enddo
             enddo
          enddo
      endif
      if(tmask_sigma_on) then
          do nn=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(tmask_sigma(i,j) > 0.0 .and. k==(Grd%kmt(i,j)-1) ) then
                       fz2(nn)%field(i,j) = fz2(nn)%field(i,j)*(1.0-tmask_sigma(i,j))
                    endif
                enddo
             enddo
          enddo
      endif
      if(neutral_physics_limit) then 
          do nn=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(T_prog(nn)%tmask_limit(i,j,k)==1.0) then 
                        fz2(nn)%field(i,j) = 0.0  
                   endif 
                enddo
             enddo
          enddo
      endif


  endif  !if-test for k-level 

end subroutine fz_flux
! </SUBROUTINE> NAME="fz_flux"


!#######################################################################
! <SUBROUTINE NAME="fz_flux_diag">
!
! <DESCRIPTION>
! For diagnosing the GM and Redi pieces separately. 
! Compute this component for all tracers at level k.
! Surface and bottom boundary condition fz(k=0)=fz(k=kmt(i,j))=0
!
! fz has physical dimensions (density*diffusivity*tracer gradient)
!
! </DESCRIPTION>
!
subroutine fz_flux_diag(T_prog, k)

  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer, intent(in) :: k

  integer :: nn, i, j, ip, jq, kr
  real :: sumx_0, sumx_1, sumy_0, sumy_1

  real :: temparray31_redi(isc:iec,jsc:jec,0:1,0:1)
  real :: temparray32_redi(isc:iec,jsc:jec,0:1,0:1)

 
  if(tmask_neutral_on .and. k==1) then
      do nn=1,num_prog_tracers
         fz2_redi(nn)%field(:,:) = 0.0 
      enddo
      return 
  endif

  if(k==nk) then 

      do nn=1,num_prog_tracers
         fz2_redi(nn)%field(COMP) = 0.0
      enddo
      return  

  elseif(k < nk) then  

      ! tracer-independent part of the calculation 
      do kr=0,1
         do ip=0,1
            do j=jsc,jec
               do i=isc,iec
                  temparray31_redi(i,j,ip,kr) = tensor_31_redi(i,j,k,ip,kr)*dtew(i,j,ip) &
                       *min(delqc(i-1+ip,j,k+kr,1-kr),delqc(i+ip,j,k+kr,1-kr))
               enddo
            enddo
         enddo
         do jq=0,1
            do j=jsc,jec
               do i=isc,iec
                  temparray32_redi(i,j,jq,kr) = tensor_32_redi(i,j,k,jq,kr)*dtns(i,j,jq) &
                       *min(delqc(i,j-1+jq,k+kr,1-kr),delqc(i,j+jq,k+kr,1-kr))  
               enddo
            enddo
         enddo
      enddo

      ! tracer-dependent part of the calculation  
      do nn=1,num_prog_tracers
         do j=jsc,jec
            do i=isc,iec

               ! compute time explicit portion of the vertical flux
               sumx_0 =  temparray31_redi(i,j,0,0)*dTdx(nn)%field(i-1,j,k) &
                      +  temparray31_redi(i,j,0,1)*dTdx(nn)%field(i-1,j,k+1)
               sumx_1 =  temparray31_redi(i,j,1,0)*dTdx(nn)%field(i,j,k) &
                      +  temparray31_redi(i,j,1,1)*dTdx(nn)%field(i,j,k+1)
               sumy_0 =  temparray32_redi(i,j,0,0)*dTdy(nn)%field(i,j-1,k) &
                      +  temparray32_redi(i,j,0,1)*dTdy(nn)%field(i,j-1,k+1)
               sumy_1 =  temparray32_redi(i,j,1,0)*dTdy(nn)%field(i,j,k) &
                      +  temparray32_redi(i,j,1,1)*dTdy(nn)%field(i,j,k+1)
               fz2_redi(nn)%field(i,j) =   Grd%tmask(i,j,k+1) &
                    *( Grd%dxtr(i,j)*(sumx_0+sumx_1)          &
                      +Grd%dytr(i,j)*(sumy_0+sumy_1))         &
                    *dzwtr(i,j,k) &
                    + K33_explicit(i,j,k)*dTdz(nn)%field(i,j,k)

            enddo
         enddo
      enddo


      if(tmask_neutral_on) then
          do nn=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(k==(Grd%kmt(i,j)-1))  then 
                       fz2_redi(nn)%field(i,j) = 0.0
                   endif
                enddo
             enddo
          enddo
      endif
      if(tmask_sigma_on) then
          do nn=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(tmask_sigma(i,j) > 0.0 .and. k==(Grd%kmt(i,j)-1) ) then
                       fz2_redi(nn)%field(i,j) = fz2_redi(nn)%field(i,j)*(1.0-tmask_sigma(i,j))
                   endif
                enddo
             enddo
          enddo
      endif
      if(neutral_physics_limit) then 
          do nn=1,num_prog_tracers
             do j=jsc,jec
                do i=isc,iec
                   if(T_prog(nn)%tmask_limit(i,j,k)==1.0) then 
                       fz2_redi(nn)%field(i,j) = 0.0  
                   endif
                enddo
             enddo
          enddo
      endif


  endif  !if-test for k-level 


end subroutine fz_flux_diag
! </SUBROUTINE> NAME="fz_flux_diag"



!#######################################################################
! <SUBROUTINE NAME="gm_velocity">
!
! <DESCRIPTION>
! Subroutine computes GM eddy-induced velocity field for diagnostics.
! Compute ustar and vstar at U-cell point, and wstar at T-cell bottom.   
!
! Do a two-point average rather than more democratic four-point avg
! in order to avoid having to call mpp_update domains on tensor_31 and 
! tensor_32.  The 0.5 factor is due to the two-point average.
!   
! Note that this algorithm is ad hoc.  Researchers interested in this 
! field may wish to test alternatives.  
! </DESCRIPTION>
!
subroutine gm_velocity(Thickness, Time)

  type(ocean_thickness_type), intent(in) :: Thickness
  type(ocean_time_type), intent(in)      :: Time

  real, dimension(isd:ied,jsd:jed) :: ugm, vgm
  real, dimension(0:1)             :: agmSx, agmSy

  real            :: normalize=0.5
  integer         :: i, j, k, km1, kp1
  integer         :: dtint
  type(time_type) :: next_time

  dtint = nint(dtime)
  next_time =  increment_time(Time%model_time, dtint, 0)

  if(need_data(id_ustar, next_time) .or. &
     need_data(id_vstar, next_time) .or. &
     need_data(id_wstar, next_time)) then 

      wrk1_v(:,:,:,:) = 0.0 
      wrk3(:,:,:)     = 0.0
      ugm(:,:)        = 0.0 
      vgm(:,:)        = 0.0

      do k=1,nk         
         km1 = max(1,k-1) 
         kp1 = min(nk,k+1) 

         do j=jsc,jec
            do i=isc,iec

               agmSx(0) =  agm_array(i,j,k)*(                     &   
                    slope_function_gm(tensor_31(i,j,km1,1,0))   + &
                    slope_function_gm(tensor_31(i,j,km1,1,1)) )   
               agmSx(1) =  agm_array(i,j,k)*(                     &   
                    slope_function_gm(tensor_31(i,j,k,1,0))     + &
                    slope_function_gm(tensor_31(i,j,k,1,1)) )     
               ugm(i,j) = normalize*(agmSx(0)-agmSx(1))/Thickness%dzt(i,j,k)*Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k) 

               agmSy(0) =  agm_array(i,j,k)*(                     &   
                    slope_function_gm(tensor_32(i,j,km1,1,0))   + &
                    slope_function_gm(tensor_32(i,j,km1,1,1)) )   
               agmSy(1) =  agm_array(i,j,k)*(                     & 
                    slope_function_gm(tensor_32(i,j,k,1,0))     + &
                    slope_function_gm(tensor_32(i,j,k,1,1)) )     
               vgm(i,j) = normalize*(agmSy(0)-agmSy(1))/Thickness%dzt(i,j,k)*Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k) 

            enddo
         enddo

         call mpp_update_domains (ugm(:,:), Dom%domain2d, flags=EUPDATE) 
         call mpp_update_domains (vgm(:,:), Dom%domain2d, flags=NUPDATE) 
         wrk1_v(:,:,k,1) = FAY(ugm(:,:))
         wrk1_v(:,:,k,2) = FAX(vgm(:,:))
      enddo

      call mpp_update_domains (wrk1_v(:,:,:,1), Dom%domain2d, flags=WUPDATE)
      call mpp_update_domains (wrk1_v(:,:,:,2), Dom%domain2d, flags=SUPDATE)

      k=1
      wrk3(:,:,k) = BDX_ET(wrk1_v(:,:,k,1)*Thickness%dzu(:,:,k)) + &
                    BDY_NT(wrk1_v(:,:,k,2)*Thickness%dzu(:,:,k))
      do k=2,nk
         wrk3(:,:,k) = wrk3(:,:,k-1) + BDX_ET(wrk1_v(:,:,k,1)*Thickness%dzu(:,:,k)) + &
                                       BDY_NT(wrk1_v(:,:,k,2)*Thickness%dzu(:,:,k))
      enddo

      if(need_data(id_ustar, next_time)) then
         call diagnose_3d(Time, Grd, id_ustar, wrk1_v(:,:,:,1))
      endif
      if(need_data(id_vstar, next_time)) then
         call diagnose_3d(Time, Grd, id_vstar, wrk1_v(:,:,:,2))
      endif
      if(need_data(id_wstar, next_time)) then
         call diagnose_3d(Time, Grd, id_wstar, wrk3(:,:,:))
      endif
  else 
      return
  endif


end subroutine gm_velocity
! </SUBROUTINE> NAME="gm_velocity"



!#######################################################################
! <FUNCTION NAME="slope_function_gm">
!
! <DESCRIPTION>
! Function for defining effective slope in diagnostic GM velocity
! calculation. Used only for diagnostic purposes.  
! </DESCRIPTION>
!
function slope_function_gm (slope)

  real, intent(in) :: slope
  real             :: absslope, slope_function_gm

  absslope = abs(slope) 

  if(absslope >= smax) then
      slope_function_gm = smax*sign(1.0,slope)
  else
      slope_function_gm = slope
  endif

end function slope_function_gm
! </FUNCTION> NAME="slope_function_gm"


!#######################################################################
! <SUBROUTINE NAME="nphysics_diagnostics">
! <DESCRIPTION>
!  Send some diagnostics to diagnostics manager. 
! </DESCRIPTION>
subroutine nphysics_diagnostics(Time, T_prog, Dens)

  type(ocean_time_type),        intent(in)  :: Time
  type(ocean_prog_tracer_type), intent(in)  :: T_prog(:)
  type(ocean_density_type),     intent(in)  :: Dens

  integer :: k, nn
  integer :: tau
  real, dimension(isd:ied,jsd:jed) :: tmp_flux

  tau = Time%tau

  if (id_k33_explicit > 0) then 
      call diagnose_3d(Time, Grd, id_k33_explicit, rho0r*K33_explicit(:,:,:))
  endif

  do nn=1,num_prog_tracers
     if(id_neutral_physics(nn) > 0) then 
         call diagnose_3d(Time, Grd, id_neutral_physics(nn), T_prog(nn)%wrk1(:,:,:)*T_prog(nn)%conversion)
     endif

     ! send fluxes to diag_manager 
     ! minus sign is due to a MOM-convention for physics fluxes  
     if(id_flux_x(nn) > 0) then 
        call diagnose_3d(Time, Grd, id_flux_x(nn), -1.0*T_prog(nn)%conversion*flux_x(nn)%field(:,:,:))
     endif
     if(id_flux_y(nn) > 0) then 
        call diagnose_3d(Time, Grd, id_flux_y(nn), -1.0*T_prog(nn)%conversion*flux_y(nn)%field(:,:,:))
     endif
     if(id_flux_x_int_z(nn) > 0) then 
        tmp_flux = 0.0
        do k=1,nk
            tmp_flux(COMP) = tmp_flux(COMP) + flux_x(nn)%field(COMP,k)
        enddo        
        call diagnose_2d(Time, Grd, id_flux_x_int_z(nn), -1.0*T_prog(nn)%conversion*tmp_flux(:,:))
     endif
     if(id_flux_y_int_z(nn) > 0) then 
        tmp_flux = 0.0
        do k=1,nk
            tmp_flux(COMP) = tmp_flux(COMP) + flux_y(nn)%field(COMP,k)
        enddo        
        call diagnose_2d(Time, Grd, id_flux_y_int_z(nn), -1.0*T_prog(nn)%conversion*tmp_flux(:,:))
     endif    
  enddo   ! enddo for nn=1,num_prog_tracers

 
  if(diagnose_gm_redi) then 

      do nn=1,num_prog_tracers

         if(id_neutral_physics_ndiffuse(nn) > 0) then 
            call diagnose_3d(Time, Grd, id_neutral_physics_ndiffuse(nn), &
                 tendency_redi(nn)%field(:,:,:)*T_prog(nn)%conversion)
         endif
         if(id_flux_x_ndiffuse(nn) > 0) then 
            call diagnose_3d(Time, Grd, id_flux_x_ndiffuse(nn), &
                 -1.0*T_prog(nn)%conversion*flux_x_redi(nn)%field(:,:,:))
         endif
         if(id_flux_y_ndiffuse(nn) > 0) then 
            call diagnose_3d(Time, Grd, id_flux_y_ndiffuse(nn), &
                  -1.0*T_prog(nn)%conversion*flux_y_redi(nn)%field(:,:,:))
         endif
         if(id_flux_x_ndiffuse_int_z(nn) > 0) then 
             tmp_flux = 0.0
             do k=1,nk
                tmp_flux(COMP) = tmp_flux(COMP) + flux_x_redi(nn)%field(COMP,k)
             enddo
             call diagnose_2d(Time, Grd, id_flux_x_ndiffuse_int_z(nn), -1.0*T_prog(nn)%conversion*tmp_flux(:,:))
          endif
         if(id_flux_y_ndiffuse_int_z(nn) > 0) then 
             tmp_flux = 0.0
             do k=1,nk
                tmp_flux(COMP) = tmp_flux(COMP) + flux_y_redi(nn)%field(COMP,k)
             enddo
             call diagnose_2d(Time, Grd, id_flux_y_ndiffuse_int_z(nn), -1.0*T_prog(nn)%conversion*tmp_flux(:,:))
         endif


         if(id_neutral_physics_gm(nn) > 0) then 
             wrk1(:,:,:) = 0.0
             do k=1,nk
                wrk1(COMP,k) = T_prog(nn)%wrk1(COMP,k) - tendency_redi(nn)%field(COMP,k)
             enddo
             call diagnose_3d(Time, Grd, id_neutral_physics_gm(nn), &
                  wrk1(:,:,:)*T_prog(nn)%conversion)
         endif

         if(id_flux_x_gm(nn) > 0) then 
             wrk1(:,:,:) = 0.0
             do k=1,nk
                wrk1(COMP,k) = flux_x(nn)%field(COMP,k) - flux_x_redi(nn)%field(COMP,k)
             enddo
             call diagnose_3d(Time, Grd, id_flux_x_gm(nn),          &
                  -1.0*T_prog(nn)%conversion*wrk1(:,:,:))
         endif

         if(id_flux_y_gm(nn) > 0) then 
             wrk1(:,:,:) = 0.0
             do k=1,nk
                wrk1(COMP,k) = flux_y(nn)%field(COMP,k) - flux_y_redi(nn)%field(COMP,k)
             enddo
             call diagnose_2d(Time, Grd, id_flux_y_ndiffuse_int_z(nn), -1.0*T_prog(nn)%conversion*tmp_flux(:,:))
         endif

         if(id_flux_x_gm_int_z(nn) > 0) then 
             wrk1(:,:,:) = 0.0
             do k=1,nk
                wrk1(COMP,k) = flux_x(nn)%field(COMP,k) - flux_x_redi(nn)%field(COMP,k)
             enddo
             tmp_flux = 0.0
             do k=1,nk
                tmp_flux(COMP) = tmp_flux(COMP) + wrk1(COMP,k)
             enddo
             call diagnose_2d(Time, Grd, id_flux_x_gm_int_z(nn), -1.0*T_prog(nn)%conversion*tmp_flux(:,:))
         endif

         if(id_flux_y_gm_int_z(nn) > 0) then 
             wrk1(:,:,:) = 0.0
             do k=1,nk
                wrk1(COMP,k) = flux_y(nn)%field(COMP,k) - flux_y_redi(nn)%field(COMP,k)
             enddo
             tmp_flux = 0.0
             do k=1,nk
                tmp_flux(COMP) = tmp_flux(COMP) + wrk1(COMP,k)
             enddo
             call diagnose_2d(Time, Grd, id_flux_y_gm_int_z(nn), -1.0*T_prog(nn)%conversion*tmp_flux(:,:))
         endif
      enddo   ! enddo for nn=1,num_prog_tracers


      ! more diagnostic output that does not need tracer loop 
      call watermass_diag(Time, T_prog, Dens,  &
      tendency_redi(index_temp)%field(:,:,:), tendency_redi(index_salt)%field(:,:,:))

  endif  ! endif for diagnose_gm_redi logical 



end subroutine nphysics_diagnostics
! </SUBROUTINE> NAME="nphysics_diagnostics"




!#######################################################################
! <SUBROUTINE NAME="ocean_nphysicsA_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocean_nphysicsA_restart(time_stamp)
  character(len=*), intent(in), optional :: time_stamp

  if(.not. use_this_module) return

  call ocean_nphysics_util_restart(time_stamp)

end subroutine ocean_nphysicsA_restart
! </SUBROUTINE> NAME="ocean_nphysicsA_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_nphysicsA_end">
!
! <DESCRIPTION>
! Write to restart.
! </DESCRIPTION>
!
subroutine ocean_nphysicsA_end(Time)

  type(ocean_time_type), intent(in) :: Time
  
  if(.not. use_this_module) return

  call ocean_nphysics_coeff_end(Time, agm_array, aredi_array, rossby_radius, rossby_radius_raw, bczone_radius)

end subroutine ocean_nphysicsA_end
! </SUBROUTINE> NAME="ocean_nphysicsA_end"


end module ocean_nphysicsA_mod

!----------------------------------------------------------------
! <CONTACT EMAIL="Eric.Galbraith@mcgill.ca"> Eric D. Galbraith
! </CONTACT>
!
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> John P. Dunne
! </CONTACT>
!
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Anand Gnanandesikan
! </CONTACT>
!
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Niki Zadeh 
! </CONTACT>
! 
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Rick Slater
! </REVIEWER>
!
! <OVERVIEW>
!   This module contains the generic version of BLING.
!   It is designed so that both GFDL Ocean models, GOLD and MOM, can use it.
!
!   WARNING: although the core components of the model (PO4, Fed, DOP, O2) 
!   have been quite well tested, the other components should be viewed as
!   developmental at this point. There may still be some bugs, particularly
!   in the CaCO3 burial scheme. EDG June 4, 2009
!
! </OVERVIEW>
!<DESCRIPTION>
!   Biogeochemistry with Light, Iron, Nutrient and Gas (BLING) includes an
!   implicit ecological model of growth limitation by light,
!   temperature, phosphate and iron, along with dissolved organic
!   phosphorus and O2 pools.
!   Food web processing in the euphotic zone and remineralization/
!   dissolution through the ocean interior are handled as in Dunne et al. 
!   (2005).  O2 equilibria and gas exchange follow OCMIP2 protocols.
!   Additional functionality comes from an optional carbon cycle that is 
!   non-interactive, i.e. does not change the core BLING behaviour, as
!   well as tracers for radiocarbon (14c), a decomposition of carbon 
!   components by gas exchange and remineralization (carbon_pre), and a 
!   decomposition of phosphate as preformed and remineralized (po4_pre).
!</DESCRIPTION>
!
! <INFO>
! <REFERENCE>
! This model is available for public use. 
! The current version is BLING.0. The version number refers to the core
! model behaviour; additional tracers exist in different iterations of the
! module. In publications it should be referenced as:
! Galbraith, E.D., Gnanadesikan, A., Dunne, J. and Hiscock, M. 2009.
! Regional impacts of iron-light colimitation in a global 
! biogeochemical model. Biogeosciences Discussions, 6, 1-47.
!
! All parameter values are as described in this paper.
! Note that this reference is only for the core model components, and
! does not include any of the additional functionalities, which remain
! undocumented. Please contact Eric Galbraith (eric.galbraith@mcgill.ca)
! for more information.
! </REFERENCE>
!
! <DEVELOPER_NOTES>
! This code was developed based on the template of Perth generic TOPAZ code.
! </DEVELOPER_NOTES>
! </INFO>
!
!<NAMELIST NAME="generic_bling_nml">
!
!  <DATA NAME="do_14c" TYPE="logical">
!  If true, then simulate radiocarbon. Includes 2 prognostic tracers, DI14C
! and DO14C. Requires that do_carbon = .true. Note that 14C is not taken up
! by CaCO3 at the current time, but cycles only through the soft tissue.
! This is a mistake that will be fixed later.
!  </DATA> 
!
!  <DATA NAME="do_carbon" TYPE="logical">
!  If true, then simulate the carbon cycle based on strict stoichiometry
! of C:P. Includes 1 prognostic tracer, DIC.
!  </DATA> 
!
!  <DATA NAME="do_carbon_pre" TYPE="logical">
!  If true, then simulate the carbon cycle based on strict stoichiometry
!  of C:P. Includes 3 prognostic tracers, DIC, ALK and ALK_pre. Requires 
! that do_carbon = .true.
!  </DATA> 
!
!  <DATA NAME="do_po4_pre" TYPE="logical">
!  If true, then simulate preformed PO4, a useful theoretical construct
! equal to PO4 in the surface layer and subject only to passive transport 
! everywhere else. 1 prognostic tracer, PO4_pre.
!  </DATA> 
!
!  <DATA NAME="bury_caco3" TYPE="logical">
!  If true, then allow CaCO3 to be buried in sediments as a function
! of sinking CaCO3 flux and bottom water saturation state, and allow
! a river input of alkalinity to compensate. Caution: this will cause
! the alkalinity to have a long term drift, which will produce a long
! term drift in the carbon cycle. Should be considered highly
! experimental at this point. Requires that do_carbon=.true.
!  </DATA> 
!
!  <DATA NAME="use_bling_chl" TYPE="logical">
!  If true, names the BLING diagnostic chlorophyll field 'chl'. Thus,
! if read_chl=.false. in the shortwave namelist, BLING chlorophyll will
! be used to calculate sw absorption. Set this to false in order to 
! have the chlorophyll field named chl_b, preventing conflict with the 
! TOPAZ chlorophyll field, so that the two modules can run
! simultaneously.
!  </DATA> 
!
!</NAMELIST>
!
!----------------------------------------------------------------

module generic_BLING

  use coupler_types_mod, only: coupler_2d_bc_type
  use field_manager_mod, only: fm_string_len, fm_path_name_len
  use mpp_mod,           only: input_nml_file, mpp_error, stdlog, NOTE, WARNING, FATAL, stdout, mpp_chksum
  use fms_mod,           only: write_version_number, open_namelist_file, check_nml_error, close_file
  use fms_mod,           only: field_exist, file_exist
  use time_manager_mod,  only: time_type
  use fm_util_mod,       only: fm_util_start_namelist, fm_util_end_namelist  
  use diag_manager_mod,  only: register_diag_field, send_data 
  use constants_mod,     only: WTMCO2, WTMO2

  use g_tracer_utils, only : g_tracer_type,g_tracer_start_param_list,g_tracer_end_param_list
  use g_tracer_utils, only : g_tracer_add,g_tracer_add_param, g_tracer_set_files
  use g_tracer_utils, only : g_tracer_set_values,g_tracer_get_pointer
  use g_tracer_utils, only : g_tracer_get_common,g_tracer_set_common 
  use g_tracer_utils, only : g_tracer_coupler_set,g_tracer_coupler_get
  use g_tracer_utils, only : g_tracer_send_diag, g_tracer_get_values  

  use FMS_ocmip2_co2calc_mod, only : FMS_ocmip2_co2calc, CO2_dope_vector

  implicit none ; private

  character(len=128) :: version = '$Id: generic_BLING.F90,v 20.0 2013/12/14 00:18:02 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

  character(len=fm_string_len), parameter :: mod_name       = 'generic_BLING'
  character(len=fm_string_len), parameter :: package_name   = 'generic_bling'

  public do_generic_BLING
  public generic_BLING_register
  public generic_BLING_init
  public generic_BLING_register_diag
  public generic_BLING_update_from_coupler
  public generic_BLING_update_from_source
  public generic_BLING_update_from_bottom
  public generic_BLING_set_boundary_values
  public generic_BLING_end

  !The following logical for using this module is overwritten 
  ! generic_tracer_nml namelist
  logical, save :: do_generic_BLING = .false.

  real, parameter :: sperd = 24.0 * 3600.0
  real, parameter :: spery = 365.25 * sperd
  real, parameter :: epsln=1.0e-30

! Namelist Options

  logical :: do_14c             = .true.  ! Requires do_carbon = .true.
  logical :: do_carbon          = .true.  
  logical :: do_carbon_pre      = .true.  ! Requires do_carbon = .true.
  logical :: do_po4_pre         = .true.
  logical :: bury_caco3         = .false. ! Requires do_carbon = .true.
  logical :: use_bling_chl      = .false. ! Must be false to run with TOPAZ

namelist /generic_bling_nml/ do_14c, do_carbon, do_carbon_pre, &
  do_po4_pre, bury_caco3, use_bling_chl

  !
  !The following two types contain all the parameters and arrays used in this module.

  type generic_BLING_type

     logical  ::       &
          init,             &                  ! If tracers should be initializated
          prevent_neg_o2,   &
          tracer_debug

     real  ::          &
          alpha_max,        &                  ! Quantum yield under low light, Fe-replete
          alpha_min,        &                  ! Quantum yield under low light, Fe-limited
          c_2_p,            &                  ! Carbon to Phosphorus ratio
          ca_2_p,           &                  ! CaCO3 to Phosphorus ratio (of small phytoplankton)
          ca_remin_depth,   &                  ! CaCO3 dissolution length scale (subject to omega)
          chl_min,          &                  ! Minimum chl concentration allowed (for numerical stability)
          def_fe_min,       &                  ! Minimum value for iron deficiency term
          fast_gasex,       &                  ! Gas exchange rate multiplier for DIC_sat
          fe_2_p_max,       &                  ! Iron to Phosphate uptake ratio scaling
          fe_2_p_sed,       &                  ! Iron to Phosphorus ratio in sediments
          felig_bkg,        &                  ! Iron ligand concentration
          gamma_biomass,    &                  ! Biomass adjustment timescale
          gamma_dop,        &                  ! Dissolved organic phosphorus decay
          gamma_irr_mem,    &                  ! Photoadaptation timescale
          gamma_pop,        &                  ! Patriculate Organic Phosphorus decay
          gamma_tag,        &                  ! Restoring time constant for nutrient source tracers
          half_life_14c,    &                  ! Radiocarbon half-life
          k_fe_2_p,         &                  ! Fe:P half-saturation constant
          k_fe_uptake,      &                  ! Iron half-saturation concentration
          k_o2,             &                  ! Oxygen half-saturation concentration
          k_po4,            &                  ! Phosphate half-saturation concentration
          kappa_eppley,     &                  ! Temperature dependence
          kappa_remin,      &                  ! Temperature dependence for particle fractionation
          kfe_inorg,        &                  ! Iron scavenging, 2nd order
          kfe_eq_lig_max,   &                  ! Maximum light-dependent iron ligand stability constant
          kfe_eq_lig_min,   &                  ! Minimum light-dependent iron ligand stability constant
          kfe_eq_lig_irr,   &                  ! Irradiance scaling for iron ligand stability constant
          kfe_eq_lig_femin, &                  ! Low-iron threshold for ligand stability constant
          kfe_org,          &                  ! Iron scavenging, 1st order
          lambda0,          &                  ! Total mortality rate constant
          lambda_14c,       &                  ! Radiocarbon decay rate
          resp_frac,        &                  ! Biomass maintenace requirement as fraction of pc_0
          mass_2_p,         &                  ! Organic matter mass to Phosphorus ratio
          n_2_p,            &                  ! Nitrogen to Phosphorus ratio
          o2_2_p,           &                  ! Oxygen to Phosphorus ratio
          o2_min,           &                  ! Anaerobic respiration threshold
          P_star,           &                  ! Pivotal phytoplankton concentration
          pc_0,             &                  ! Maximum carbon-specific growth rate
          phi_dop,          &                  ! Dissolved organic phosphorus fraction of uptake
          phi_lg,           &                  ! Fraction of small phytoplankton converted to detritus
          phi_sm,           &                  ! Fraction of large phytoplankton converted to detritus
          remin_min,        &                  ! Minimum remineralization under low O2
          rho_dense,        &                  ! Deep boundary density for exposure tracers
          rho_light,        &                  ! Shallow boundary density for exposure tracers
          sed_flux,         &                  ! Seafloor sedimentary flux (globally constant)
          thetamax_hi,      &                  ! Maximum Chl:C ratio when iron-replete
          thetamax_lo,      &                  ! Maximum Chl:C ratio when iron-limited
          wsink_acc,        &                  ! Sinking rate acceleration with depth
          wsink0,           &                  ! Sinking rate at surface
          wsink0_z,         &                  ! Depth to which sinking rate remains constant
          z_sed                                ! Thickness of active sediment layer

     real    :: htotal_scale_lo, htotal_scale_hi, htotal_in
     real    :: Rho_0, a_0, a_1, a_2, a_3, a_4, a_5, b_0, b_1, b_2, b_3, c_0
     real    :: a1_co2, a2_co2, a3_co2, a4_co2, a1_o2, a2_o2, a3_o2, a4_o2

!
! The prefixes "f_" refers to a "field" and "j" to a volumetric rate, and 
! "b_" to a bottom flux. The prefix "p_" refers to a "pointer".
!
     real, dimension(:,:,:), ALLOCATABLE ::  &
          alpha,&
          biomass_p_ts,&
          def_fe,&
          expkT,&
          f_biomass_p,&
          f_cased,&
          f_chl,&
          f_dop,&
          f_fed,&
          f_htotal,&
          f_htotal_sat,&
          f_irr_mem,&
          f_o2,&
          f_po4,&
          f_po4_pre,&
          fe_2_p_uptake,&
          feprime,&
          fpofe,&
          fpop,&
          frac_lg,&
          frac_pop,&
          irr_inst,&
          irr_mix,&
          irrk,&
          jdop,&
          jfe_ads_inorg,&
          jfe_ads_org,&
          jfe_recycle,&
          jfe_reminp,&
          jfe_uptake,&
          jo2,&
          jp_recycle,&
          jp_reminp,&
          jp_uptake,&
          jpo4,&
          jpofe,&
          jpop,&
          kfe_eq_lig,&
          pc_m,&
          mu,&
          pc_tot,&
          theta,&
          thetamax_fe,&
          wsink,&
          zremin,&
          zt

     real, dimension(:,:,:), ALLOCATABLE ::  &
          f_dop_n,&
          f_dop_nx,&
          f_dop_s,&
          f_dop_sx,&
          f_po4_n,&
          f_po4_nx,&
          f_po4_s,&
          f_po4_sx,&
          f_po4_pre_n,&
          f_po4_pre_s,&
          fpop_n,&
          fpop_nx,&
          fpop_s,&
          fpop_sx,&
          jpn_reminp,&
          jpnx_reminp,&
          jps_reminp,&
          jpsx_reminp

     real, dimension(:,:,:), ALLOCATABLE ::  &
          c14_2_p,&
          co3_solubility,&
          f_alk,&
          f_alk_pre,&
          f_co3_ion,&
          f_di14c,&
          f_dic,&
          f_dic_pre,&
          f_dic_sat,&
          f_do14c,&
          fcaco3,&
          fpo14c,&
          j14c_decay_dic,&
          j14c_decay_doc,&
          j14c_reminp,&
          jca_reminp,&
          jca_uptake,&
          jdi14c,&
          jdo14c,&
          zremin_caco3

     real, dimension(:,:), ALLOCATABLE :: &
          fe_burial,&
          ffe_sed,&
          b_fed,&
          b_o2,&
          b_po4

     real, dimension(:,:), ALLOCATABLE :: &
          b_po4_n,&
          b_po4_nx,&
          b_po4_s,&
          b_po4_sx

     real, dimension(:,:), ALLOCATABLE ::  &
          co2_csurf,pco2_surf,co2_alpha,&
          c14o2_csurf,c14o2_alpha,co2_sat_csurf,pco2_sat_surf,&
          htotallo, htotalhi,&
          htotal_satlo, htotal_sathi,&
          b_alk,&
          b_di14c,&
          b_dic,&
          fcaco3_to_sed,&
          fcased_burial,&
          fcased_redis
     
     real, dimension(:,:,:,:), pointer :: &
          p_dop,&
          p_fed,&
          p_o2,&
          p_po4,&
          p_po4_pre

     real, dimension(:,:,:,:), pointer :: &
          p_dop_n,&
          p_dop_nx,&
          p_dop_s,&
          p_dop_sx,&
          p_po4_n,&
          p_po4_nx,&
          p_po4_s,&
          p_po4_sx,&
          p_po4_pre_n,&
          p_po4_pre_s

     real, dimension(:,:,:,:), pointer :: &
          p_alk,&
          p_alk_pre,&
          p_di14c,&
          p_dic,&
          p_dic_pre,&
          p_do14c
     
     integer :: nkml
     character(len=fm_string_len) :: file
     character(len=fm_string_len) :: ice_restart_file
     character(len=fm_string_len) :: ocean_restart_file,IC_file

     integer                   :: &
      id_alpha         = -1,  & ! Iron-limited initial slope of P-I curve 
      id_b_alk         = -1,  & ! Bottom flux of alkalinity
      id_b_dic         = -1,  & ! Bottom flux of DIC
      id_b_di14c       = -1,  & ! Bottom flux of DI14C
      id_b_fed         = -1,  & ! Bottom flux of Fe
      id_b_o2          = -1,  & ! Bottom flux of O2
      id_b_po4         = -1,  & ! Bottom flux of PO4
      id_b_po4_n       = -1,  & ! Bottom flux of PO4_n
      id_b_po4_nx      = -1,  & ! Bottom flux of PO4_nx
      id_b_po4_s       = -1,  & ! Bottom flux of PO4_s
      id_b_po4_sx      = -1,  & ! Bottom flux of PO4_sx
      id_biomass_p_ts  = -1,  & ! Instantaneous P concentration in biomass
      id_c14_2_p       = -1,  & ! DI14C to PO4 uptake ratio
      id_c14o2_csurf   = -1,  & ! Surface water 14CO2*
      id_c14o2_alpha   = -1,  & ! Surface water 14CO2* solubility 
      id_co2_csurf     = -1,  & ! Surface water CO2*
      id_co2_alpha     = -1,  & ! Surface water CO2* solubility
      id_co2_sat_csurf = -1,  & ! Surface water CO2* for DIC_sat
      id_co3_solubility= -1,  & ! Calcite solubility
      id_def_fe        = -1,  & ! Iron deficiency term 
      id_expkT         = -1,  & ! Temperature dependence 
      id_fcaco3        = -1,  & ! CaCO3 sinking flux
      id_fcaco3_to_sed = -1,  & ! CaCO3 sinking flux in bottom layer
      id_fcased_burial = -1,  & ! CaCO3 permanent burial flux
      id_fcased_redis  = -1,  & ! CaCO3 dissolution flux from active sediment layer
      id_fe_2_p_uptake = -1,  & ! Fed:PO4 of instantaneous uptake
      id_feprime       = -1,  & ! Free (unbound) iron concentration
      id_fe_burial     = -1,  & ! Flux of iron to sediment as particulate
      id_ffe_sed       = -1,  & ! Sediment iron efflux
      id_fpofe         = -1,  & ! POFe sinking flux
      id_fpo14c        = -1,  & ! PO14C sinking flux
      id_fpop          = -1,  & ! POP sinking flux
      id_fpop_n        = -1,  & ! POP_N sinking flux
      id_fpop_nx       = -1,  & ! POP_Nx sinking flux
      id_fpop_s        = -1,  & ! POP_S sinking flux
      id_fpop_sx       = -1,  & ! POP_Sx sinking flux
      id_frac_lg       = -1,  & ! Fraction of production by large phytoplankton
      id_frac_pop      = -1,  & ! Fraction of uptake converted to particulate
      id_irr_inst      = -1,  & ! Instantaneous irradiance 
      id_irr_mix       = -1,  & ! Mixed layer irradiance 
      id_irrk          = -1,  & ! Effective susceptibility to light limitation 
      id_j14c_decay_dic= -1,  & ! Radioactive decay of DI14C
      id_j14c_decay_doc= -1,  & ! Radioactive decay of DO14C
      id_j14c_reminp   = -1,  & ! 14C particle remineralization layer integral
      id_jca_reminp    = -1,  & ! CaCO3 dissolution layer integral
      id_jca_uptake    = -1,  & ! CaCO3 formation layer integral
      id_jdi14c        = -1,  & ! DI14C source layer integral
      id_jdo14c        = -1,  & ! Semilabile DO14C source layer integral
      id_jdop          = -1,  & ! Semilabile DOP source layer integral
      id_jfe_ads_inorg = -1,  & ! Iron adsorption (2nd order) layer integral
      id_jfe_ads_org   = -1,  & ! Iron adsorption to fpop layer integral
      id_jfe_recycle   = -1,  & ! Iron fast recycling layer integral
      id_jfe_reminp    = -1,  & ! Iron particle remineralization layer integral
      id_jfe_uptake    = -1,  & ! Iron uptake layer integral
      id_jo2           = -1,  & ! O2 source layer integral
      id_jp_recycle    = -1,  & ! Phosphorus fast recycling layer integral
      id_jp_reminp     = -1,  & ! Phosphorus particle remineralization layer integral
      id_jpn_reminp    = -1,  & ! Northern phosphorus particle remineralization layer integral
      id_jpnx_reminp   = -1,  & ! Northern exposure phosphorus particle remineralization layer integral
      id_jps_reminp    = -1,  & ! Southern phosphorus particle remineralization layer integral
      id_jpsx_reminp   = -1,  & ! Southern exposure phosphorus particle remineralization layer integral
      id_jp_uptake     = -1,  & ! Phosphorus uptake layer integral
      id_jpo4          = -1,  & ! PO4 source layer integral
      id_jpofe         = -1,  & ! Particulate organic iron source layer integral
      id_jpop          = -1,  & ! Particulate organic phosphorus source layer integral
      id_kfe_eq_lig    = -1,  & ! Iron-ligand stability constant
      id_pc_m          = -1,  & ! Light-saturated maximum photosynthesis rate (carbon specific)
      id_mu            = -1,  & ! Growth rate after respiratory loss(carbon specific)
      id_pc_tot        = -1,  & ! Fully-limited photosynthesis rate (carbon specific)
      id_pco2_surf     = -1,  & ! Surface water pCO2
      id_pco2_sat_surf = -1,  & ! Surface water pCO2 for DIC_sat
      id_theta         = -1,  & ! Chl:C ratio
      id_thetamax_fe   = -1,  & ! Iron-limited maximum Chl:C ratio
      id_wsink         = -1,  & ! Sinking rate
      id_zremin        = -1,  & ! Remineralization length scale
      id_zremin_caco3  = -1,  & ! CaCO3 remineralization length scale
      id_alk           = -1,  & ! Alkalinity Prognostic tracer
      id_alk_pre       = -1,  & ! Preformed Alkalinity Prognostic tracer
      id_di14c         = -1,  & ! Dissolved inorganic radiocarbon Prognostic tracer
      id_dic           = -1,  & ! Dissolved inorganic carbon Prognostic tracer
      id_dic_pre       = -1,  & ! Preformed DIC Prognostic tracer
      id_dic_sat       = -1,  & ! Saturation DIC Prognostic tracer
      id_do14c         = -1,  & ! Semi-labile DO radiocarbon Prognostic tracer
      id_dop           = -1,  & ! Semi-labile dissolved organic P Prognostic tracer
      id_dop_n         = -1,  & ! Semi-labile dissolved organic P Prognostic tracer
      id_dop_nx         = -1,  & ! Semi-labile dissolved organic P Prognostic tracer
      id_dop_s         = -1,  & ! Semi-labile dissolved organic P Prognostic tracer
      id_dop_sx         = -1,  & ! Semi-labile dissolved organic P Prognostic tracer
      id_fed           = -1,  & ! Dissolved Iron Prognostic tracer
      id_o2            = -1,  & ! Oxygen Prognostic tracer
      id_po4           = -1,  & ! Phosphate Prognostic tracer
      id_po4_n         = -1,  & ! Phosphate Prognostic tracer
      id_po4_nx        = -1,  & ! Phosphate Prognostic tracer
      id_po4_s         = -1,  & ! Phosphate Prognostic tracer
      id_po4_sx        = -1,  & ! Phosphate Prognostic tracer
      id_po4_pre       = -1,  & ! Preformed Phosphate Prognostic tracer
      id_po4_pre_n     = -1,  & ! Preformed Phosphate Prognostic tracer
      id_po4_pre_s     = -1,  & ! Preformed Phosphate Prognostic tracer
      id_htotal        = -1,  & ! Hydrogen ion Diagnostic tracer
      id_htotal_sat    = -1,  & ! Hydrogen ion for DIC_sat Diagnostic tracer
      id_co3_ion       = -1,  & ! CO3= ion Diagnostic tracer
      id_cased         = -1,  & ! Active sediment CaCO3 concentration Diagnostic tracer
      id_chl           = -1,  & ! Chlorophyll Diagnostic tracer
      id_biomass_p     = -1,  & ! Biomass Diagnostic tracer
      id_irr_mem       = -1     ! Irradiance Memory Diagnostic tracer

  end type generic_BLING_type

  !An auxiliary type for storing varible names
  type, public :: vardesc
     character(len=fm_string_len) :: name     ! The variable name in a NetCDF file.
     character(len=fm_string_len) :: longname ! The long name of that variable.
     character(len=1)  :: hor_grid ! The hor. grid:  u, v, h, q, or 1.
     character(len=1)  :: z_grid   ! The vert. grid:  L, i, or 1.
     character(len=1)  :: t_grid   ! The time description: s, a, m, or 1.
     character(len=fm_string_len) :: units    ! The dimensions of the variable.
     character(len=1)  :: mem_size ! The size in memory: d or f.
  end type vardesc

  type(generic_BLING_type), save :: bling

  type(CO2_dope_vector) :: CO2_dope_vec

  
contains

!#######################################################################
  subroutine generic_BLING_register(tracer_list)
    type(g_tracer_type), pointer :: tracer_list

integer                                                 :: ioun
integer                                                 :: ierr
integer                                                 :: io_status
character(len=fm_string_len)                            :: name
integer                                                 :: stdoutunit,stdlogunit
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!
character(len=fm_string_len), parameter :: sub_name = 'generic_bling_register'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '): '
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '): '
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '): '


! provide for namelist over-ride
! This needs to go before the add_tracers in order to allow the namelist 
! settings to switch tracers on and off.
!
stdoutunit=stdout();stdlogunit=stdlog()

#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=generic_bling_nml, iostat=io_status)
ierr = check_nml_error(io_status,'generic_bling_nml')
#else
ioun = open_namelist_file()
read  (ioun, generic_bling_nml,iostat=io_status)
ierr = check_nml_error(io_status,'generic_bling_nml')
call close_file (ioun)
#endif

write (stdoutunit,'(/)')
write (stdoutunit, generic_bling_nml)
write (stdlogunit, generic_bling_nml)

  if ((do_14c) .and. (do_carbon)) then
    write (stdoutunit,*) trim(note_header), 'Simulating radiocarbon'
  else if ((do_14c) .and. .not. (do_carbon)) then
    call mpp_error(FATAL, trim(error_header) //        &
         'Do_14c requires do_carbon' // trim(name))
  endif

  if ((do_carbon_pre) .and. (do_carbon)) then
    write (stdoutunit,*) trim(note_header), 'Calculating DIC_pre and DIC_sat'
  else if ((do_carbon_pre) .and. .not. (do_carbon)) then
    call mpp_error(FATAL, trim(error_header) //        &
         'Do_carbon_pre requires do_carbon' // trim(name))
  endif

  if ((bury_caco3) .and. (do_carbon)) then
    write (stdoutunit,*) trim(note_header), &
         'CAUTION: burying CaCO3, are you sure you want to do this?'
  else if ((bury_caco3) .and. .not. (do_carbon)) then
    call mpp_error(FATAL, trim(error_header) //        &
         'Bury_caco3 requires do_carbon' // trim(name))
  endif

    !Specify all prognostic and diagnostic tracers of this modules.
    call user_add_tracers(tracer_list)

    
    
  end subroutine generic_BLING_register

!#######################################################################
  ! <SUBROUTINE NAME="generic_BLING_init">
  !  <OVERVIEW>
  !   Initialize the generic BLING module
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   This subroutine: 
  !       Adds all the BLING Tracers to the list of generic Tracers passed 
  !  to it via utility subroutine g_tracer_add(). Adds all the parameters 
  !  used by this module via utility subroutine g_tracer_add_param().
  !       Allocates all work arrays used in the module. 
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_BLING_init(tracer_list)
  !  </TEMPLATE>
  !  <IN NAME="tracer_list" TYPE="type(g_tracer_type), pointer">
  !   Pointer to the head of generic tracer list.
  !  </IN>
  ! </SUBROUTINE>
  subroutine generic_BLING_init(tracer_list)
    type(g_tracer_type), pointer :: tracer_list

    call write_version_number(version, tagname)

    !Specify and initialize all parameters used by this package
    call user_add_params

    !Allocate all the private work arrays used by this module.
    call user_allocate_arrays

  end subroutine generic_BLING_init

!#######################################################################
  !   Register diagnostic fields to be used in this module. 
  !   Note that the tracer fields are automatically registered in user_add_tracers
  !   User adds only diagnostics for fields that are not a member of g_tracer_type
  !
  subroutine generic_BLING_register_diag
    real,parameter :: missing_value1=-1.0e+10
    type(vardesc)  :: vardesc_temp
    integer        :: isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau, axes(3)
    type(time_type):: init_time 

    call g_tracer_get_common(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,axes=axes,init_time=init_time) 


    !   The following vardesc types contain a package of metadata about each tracer,
    ! including, in order, the following elements: name; longname; horizontal
    ! staggering ('h') for collocation with thickness points ; vertical staggering
    ! ('L') for a layer variable ; temporal staggering ('s' for snapshot) ; units ;
    ! and precision in non-restart output files ('f' for 32-bit float or 'd' for
    ! 64-bit doubles). For most tracers, only the name, longname and units should
    ! be changed.  

    !
    ! Register Diagnostics
    !===========================================================
    !
    ! Core diagnostics

    vardesc_temp = vardesc&
    ("alpha","Fe-limitated initial slope of P-I curve",'h','L','s','g C g Chl-1 m2 W-1 s-1','f')
    bling%id_alpha = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("b_fed","Bottom flux of Fe into sediment",'h','1','s','mol m-2 s-1','f')
    bling%id_b_fed = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("b_o2","Bottom flux of O2 into sediment",'h','1','s','mol m-2 s-1','f')
    bling%id_b_o2 = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("b_po4","Bottom flux of PO4 into sediment",'h','1','s','mol m-2 s-1','f')
    bling%id_b_po4 = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("biomass_p_ts","Instantaneous P concentration in biomass",'h','L','s','mol kg-1','f')
    bling%id_biomass_p_ts = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("def_Fe","Iron deficiency term",'h','L','s','unitless','f')
    bling%id_def_fe = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("expkT","Temperature dependence",'h','L','s','unitless','f')
    bling%id_expkT = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("fe_2_p_uptake","Uptake ratio of Fed:PO4",'h','L','s','mol Fe mol P-1','f')
    bling%id_fe_2_p_uptake = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("fe_burial","Sedimenting iron flux",'h','1','s','mol m-2 s-1','f')
    bling%id_fe_burial = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("feprime","Concentration of free, unbound iron",'h','L','s','mol kg-1','f')
    bling%id_feprime = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("ffe_sed","Sediment iron efflux",'h','1','s','mol m-2 s-1','f')
    bling%id_ffe_sed = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("fpofe","POFe sinking flux at layer bottom",'h','L','s','mol m-2 s-1','f')
    bling%id_fpofe = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("fpop","POP sinking flux at layer bottom",'h','L','s','mol m-2 s-1','f')
    bling%id_fpop = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("frac_lg","Fraction of production by large phytoplankton",'h','L','s','unitless','f')
    bling%id_frac_lg = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("frac_pop","Particulate fraction of total uptake",'h','L','s','unitless','f')
    bling%id_frac_pop = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("irr_inst","Instantaneous light",'h','L','s','W m-2','f')
    bling%id_irr_inst = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("irr_mix","Mixed layer light",'h','L','s','W m-2','f')
    bling%id_irr_mix = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("irrk","Tendency to light limitation",'h','L','s','W m-2','f')
    bling%id_irrk = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jdop","DOP source layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jdop = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jfe_ads_inorg","Iron adsorption (2nd order) layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jfe_ads_inorg = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jfe_ads_org","Iron adsorption to FPOP layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jfe_ads_org = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jfe_recycle","Fast recycling of iron layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jfe_recycle = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jfe_reminp","Sinking particulate Fe decay layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jfe_reminp = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jfe_uptake","Iron production layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jfe_uptake = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jp_recycle","Fast recycling of PO4 layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jp_recycle = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jp_reminp","Sinking particulate P decay layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jp_reminp = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jp_uptake","PO4 uptake layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jp_uptake = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jo2","O2 source layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jo2 = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jpo4","PO4 source layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jpo4 = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jpop","Particulate P source layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jpop = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jpofe","Particulate Fe source layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jpofe = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("kfe_eq_lig","Iron ligand stability constant",'h','L','s','mol-1 kg','f')
    bling%id_kfe_eq_lig = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("pc_m","Light-saturated photosynthesis rate (carbon specific)",'h','L','s','s-1','f')
    bling%id_pc_m = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("mu","Net growth rate after respiratory loss",'h','L','s','s-1','f')
    bling%id_mu = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("pc_tot","Photosynthesis rate (carbon specific)",'h','L','s','s-1','f')
    bling%id_pc_tot = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("theta","Chl:C ratio",'h','L','s','g Chl g C-1','f')
    bling%id_theta = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("thetamax_fe","Fe-limited max Chl:C",'h','L','s','g Chl g C-1','f')
    bling%id_thetamax_fe = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("wsink","Sinking rate",'h','L','s','m s-1','f')
    bling%id_wsink = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("zremin","Remineralization lengthscale",'h','L','s','m','f')
    bling%id_zremin = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)

    if (do_carbon) then                                      !<<CARBON CYCLE
    vardesc_temp = vardesc&
    ("b_alk","Bottom flux of Alk into sediment",'h','1','s','mol m-2 s-1','f')
    bling%id_b_alk = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("b_dic","Bottom flux of DIC into sediment",'h','1','s','mol m-2 s-1','f')
    bling%id_b_dic = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("co2_alpha","Saturation surface CO2* per uatm",'h','1','s','mol kg-1 atm-1','f')
    bling%id_co2_alpha = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("co2_csurf","CO2* concentration at surface",'h','1','s','mol kg-1','f')
    bling%id_co2_csurf = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("co3_solubility","Calcite solubility",'h','L','s','mol kg-1','f')
    bling%id_co3_solubility = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("fcaco3","CaCO3 sinking flux at layer bottom",'h','L','s','mol m-2 s-1','f')
    bling%id_fcaco3 = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("fcaco3_to_sed","CaCO3 sinking flux at ocean bottom",'h','1','s','mol m-2 s-1','f')
    bling%id_fcaco3_to_sed = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jca_reminp","Sinking CaCO3 dissolution layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jca_reminp = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jca_uptake","CaCO3 production layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jca_uptake = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("pco2_surf","Seawater pCO2 in surface layer",'h','1','s','uatm','f')
    bling%id_pco2_surf = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("zremin_caco3","CaCO3 Remineralization lengthscale",'h','L','s','m','f')
    bling%id_zremin_caco3 = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)

      if (bury_caco3) then                                     !<<BURY CACO3  
    vardesc_temp = vardesc&
    ("fcased_burial","CaCO3 permanent burial flux",'h','1','s','mol m-2 s-1','f')
    bling%id_fcased_burial = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("fcased_redis","CaCO3 redissolution from sediments",'h','1','s','mol m-2 s-1','f')
    bling%id_fcased_redis = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
      endif                                                    !BURY CACO3>>
         
      if (do_14c) then                                        !<<RADIOCARBON
    vardesc_temp = vardesc&
    ("b_di14c","Bottom flux of DI14C into sediment",'h','1','s','mol m-2 s-1','f')
    bling%id_b_di14c = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("c14_2_p","Ratio of DI14C to PO4",'h','L','s','mol kg-1','f')
    bling%id_c14_2_p = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("c14o2_alpha","Saturation surface 14CO2* per uatm",'h','1','s','mol kg-1 atm-1','f')
    bling%id_c14o2_alpha = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("c14o2_csurf","14CO2* concentration at surface",'h','1','s','mol kg-1','f')
    bling%id_c14o2_csurf = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("fpo14c","PO14C sinking flux at layer bottom",'h','L','s','mol m-2 s-1','f')
    bling%id_fpo14c = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("j14c_decay_dic","DI14C radioactive decay layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_j14c_decay_dic = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("j14c_decay_doc","DO14C radioactive decay layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_j14c_decay_doc = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("j14c_reminp","Sinking PO14C remineralization layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_j14c_reminp = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jdi14c","DI14C source layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jdi14c = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("jdo14c","DO14C source layer integral",'h','L','s','mol m-2 s-1','f')
    bling%id_jdo14c = register_diag_field(package_name, vardesc_temp%name, axes(1:3),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
      endif                                                   !RADIOCARBON>>

      if (do_carbon_pre) then                                     !<<DIC_PRE  
    vardesc_temp = vardesc&
    ("co2_sat_csurf","CO2* concentration for DIC_sat at surface",'h','1','s','mol kg-1','f')
    bling%id_co2_sat_csurf = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
    vardesc_temp = vardesc&
    ("pco2_sat_surf","Seawater pCO2 in surface layer",'h','1','s','uatm','f')
    bling%id_pco2_sat_surf = register_diag_field(package_name, vardesc_temp%name, axes(1:2),&
         init_time, vardesc_temp%longname,vardesc_temp%units, missing_value = missing_value1)
      endif                                                       !DIC_PRE>>

    endif                                                    !CARBON CYCLE>>

  end subroutine generic_BLING_register_diag

!#######################################################################
  !
  !   This is an internal sub, not a public interface.
  !   Add all the parameters to be used in this module. 
  !
  subroutine user_add_params

    !Specify all parameters used in this modules.
    !==============================================================
    !User adds one call for each parameter below!
    !User also adds the definition of each parameter in generic_BLING_params type
    !==============================================================    

    !=============
    !Block Starts: g_tracer_add_param
    !=============
    !Add the known experimental parameters used for calculations
    !in this module.
    !All the g_tracer_add_param calls must happen between 
    !g_tracer_start_param_list and g_tracer_end_param_list  calls.
    !This implementation enables runtime overwrite via field_table.
    !
    call g_tracer_start_param_list(package_name)

    !     g_tracer_add_param(name   , variable   ,  default_value)
    !call g_tracer_add_param('', bling%,  )
    !
    call g_tracer_add_param('init', bling%init, .false. )
    !
    !  Rho_0 is used in the Boussinesq
    !  approximation to calculations of pressure and
    !  pressure gradients, in units of kg m-3.
    call g_tracer_add_param('RHO_0', bling%Rho_0, 1035.0)
    call g_tracer_add_param('NKML' , bling%nkml, 1)
    !
    !-----------------------------------------------------------------------
    ! Gas exchange
    !-----------------------------------------------------------------------
    !       coefficients for O2 saturation
    !-----------------------------------------------------------------------
    call g_tracer_add_param('a_0', bling%a_0, 2.00907)
    call g_tracer_add_param('a_1', bling%a_1, 3.22014)
    call g_tracer_add_param('a_2', bling%a_2, 4.05010)
    call g_tracer_add_param('a_3', bling%a_3, 4.94457)
    call g_tracer_add_param('a_4', bling%a_4, -2.56847e-01)
    call g_tracer_add_param('a_5', bling%a_5, 3.88767)
    call g_tracer_add_param('b_0', bling%b_0, -6.24523e-03)
    call g_tracer_add_param('b_1', bling%b_1, -7.37614e-03)
    call g_tracer_add_param('b_2', bling%b_2, -1.03410e-02 )
    call g_tracer_add_param('b_3', bling%b_3, -8.17083e-03)
    call g_tracer_add_param('c_0', bling%c_0, -4.88682e-07)
    !-----------------------------------------------------------------------
    !     Schmidt number coefficients
    !-----------------------------------------------------------------------
    !  Compute the Schmidt number of CO2 in seawater using the 
    !  formulation presented by Wanninkhof (1992, J. Geophys. Res., 97,
    !  7373-7382).
    !-----------------------------------------------------------------------
    !New Wanninkhof numbers
    call g_tracer_add_param('a1_co2', bling%a1_co2,  2068.9)
    call g_tracer_add_param('a2_co2', bling%a2_co2, -118.63)
    call g_tracer_add_param('a3_co2', bling%a3_co2,  2.9311)
    call g_tracer_add_param('a4_co2', bling%a4_co2, -0.027)
    !---------------------------------------------------------------------
    !  Compute the Schmidt number of O2 in seawater using the 
    !  formulation proposed by Keeling et al. (1998, Global Biogeochem.
    !  Cycles, 12, 141-163).
    !---------------------------------------------------------------------
    !New Wanninkhof numbers
    call g_tracer_add_param('a1_o2', bling%a1_o2, 1929.7)
    call g_tracer_add_param('a2_o2', bling%a2_o2, -117.46)
    call g_tracer_add_param('a3_o2', bling%a3_o2, 3.116)
    call g_tracer_add_param('a4_o2', bling%a4_o2, -0.0306)

    call g_tracer_add_param('htotal_scale_lo', bling%htotal_scale_lo, 0.01)
    call g_tracer_add_param('htotal_scale_hi', bling%htotal_scale_hi, 100.0)

    ! Fast gas exchange multiplier for DIC_sat
    ! Should be >30, but can be reduced during spinup to prevent instability
    call g_tracer_add_param('fast_gasex', bling%fast_gasex, 30.)   ! mol Fed mol PO4-1
    !-----------------------------------------------------------------------
    ! Uptake
    !-----------------------------------------------------------------------
    !
    ! Phytoplankton growth altered from Geider et al (1997)
    ! and Moore et al (2002). 
    ! The factor of 6.022e17 is to convert
    ! from umol to quanta and 2.77e18 to convert from quanta/sec
    ! to Watts given the average energy spectrum for underwater
    ! PAR from the Seabird sensor.  
    ! 
    call g_tracer_add_param('alpha_max', bling%alpha_max, 1.6e-5 *2.77e18/6.022e17) ! g C g Chl-1 m2 W-1 s-1
    call g_tracer_add_param('alpha_min', bling%alpha_min, 0.4e-5 *2.77e18/6.022e17) ! g C g Chl-1 m2 W-1 s-1
    call g_tracer_add_param('kappa_eppley', bling%kappa_eppley, 0.063)              ! deg C-1
    call g_tracer_add_param('resp_frac', bling%resp_frac, 0.0)                      ! dimensionless
    call g_tracer_add_param('pc_0',     bling%pc_0, 1.0e-5)                         ! s-1
    call g_tracer_add_param('thetamax_hi', bling%thetamax_hi, 0.040)                ! g Chl g C-1
    call g_tracer_add_param('thetamax_lo', bling%thetamax_lo, 0.010)                ! g Chl g C-1
    !
    ! Chl:C response rate constant for phytoplankton calibrated to 1 d-1
    ! after Owens et al (1980, Diel Periodicity in cellular Chlorophyll
    ! content of marine diatoms, Mar. Biol, 59, 71-77).
    !
    call g_tracer_add_param('gamma_irr_mem', bling%gamma_irr_mem, 1.0 / sperd)   ! s-1

    ! Introduce a minimum chlorophyll concentration for numerical stability.
    ! Value is an order of magnitude less than the minimum produced in topaz.
    !
    call g_tracer_add_param('chl_min', bling%chl_min, 1.e-5)                     ! ug kg-1
    !
    ! The biomass reponds to changes in growth rate with an arbitrary 2 day lag.
    !
    call g_tracer_add_param('gamma_biomass', bling%gamma_biomass, 0.5 / sperd)   ! s-1

    !-----------------------------------------------------------------------
    ! Monod half saturation coefficient for phosphate. Value of Aumont (JGR, 2002) 
    ! used for large phytoplankton.

    call g_tracer_add_param('k_po4', bling%k_po4,  1.0e-7)                       ! mol PO4 kg-1

    !-----------------------------------------------------------------------
    ! Fe uptake and limitation.
    ! The uptake ratio of Fe:P is determined from a Monod constant and a
    ! scaling factor. 
    ! The k_Fe_uptake is high, to provide luxury uptake of iron as a 
    ! relatively linear function of iron concentrations under open-ocean
    ! conditions, consistent with the results of Sunda and Huntsman (Fig 1, 
    ! Nature, 1997).

    call g_tracer_add_param('k_fe_uptake', bling%k_fe_uptake,  0.8e-9)           ! mol Fe kg-1

    ! This Monod term, which is nearly linear with [Fe], is multiplied by a
    ! scaling term to provide the actual Fe:P uptake ratio such that, at
    ! [Fe] = k_fe_uptake, Fe:P = fe_2_p_max / 2.
    ! This maximum value was set in accordance with the range of 
    ! open-ocean Fe:C ratios summarized by Boyd et al. (Science, 2007) and
    ! converted to a Fe:P ratio.
    ! As a tuning parameter, it affects the amount of Fe that cycles via the 
    ! organic matter pathway, and its ratio to k_fe_2_p determines the
    ! degree of iron limitation (the larger this ratio, the less iron
    ! limitation there will be).

    call g_tracer_add_param('fe_2_p_max', bling%fe_2_p_max, 28.e-6 * 106.)   ! mol Fed mol PO4-1

    ! The k_fe_2_p is the Fe:P at which the iron-limitation term has a 
    ! value of 0.5, chosen according to Sunda and Huntsman (Fig. 2, 
    ! Nature, 1997). Converted from Fe:C ratio.

    call g_tracer_add_param('k_fe_2_p', bling%k_fe_2_p,  7.e-6 * 106.)           ! mol Fe mol P-1

    ! In order to represent enzymatic plasticity and the ability of plankton
    ! to make do with very low Fe supply - including by liberating recalcitrant
    ! iron - the def_fe should not approach zero, but instead some small 
    ! positive number << 1, def_fe_min. This prevents unrealistically-strong
    ! limitation of phytoplankton under very low iron concentrations.

    call g_tracer_add_param('def_fe_min', bling%def_fe_min, 0.)           ! mol Fe mol P-1

    !-----------------------------------------------------------------------
    ! Mortality & Remineralization
    !-----------------------------------------------------------------------
    !
    ! T=0 phytoplankton specific total-mortality rate from the global
    ! synthesis of Dunne et al. (2005)
    !
    call g_tracer_add_param('lambda0', bling%lambda0, 0.19 / sperd)              ! s-1
    !
    ! Pivot phytoplankton concentration for grazing-based
    ! variation in ecosystem structure from the global
    ! synthesis of Dunne et al. (2005). Converted from mol C m-3.
    !
    call g_tracer_add_param('P_star', bling%P_star, 1.9e-3 / 1028. / 106.0)      ! mol P kg-1
    !
    ! Temperature-dependence of fractional detritus production
    ! from the global synthesis of Dunne et al. (2005)
    !
    call g_tracer_add_param('kappa_remin', bling%kappa_remin, -0.032)            ! deg C-1

    ! Phytoplankton fractional detritus production by size class,
    ! from the global synthesis of Dunne et al. (2005)
    call g_tracer_add_param('phi_lg', bling%phi_lg, 1.0)             ! unitless
    call g_tracer_add_param('phi_sm', bling%phi_sm, 0.18)            ! unitless
    !
    !-----------------------------------------------------------------------
    ! Dissolved Organic Material remineralization rate constants
    ! and fractional production ratios, all to be consistent
    ! with the work of Abell et al. (2000, Distributions of TOP, TON and TOC
    ! in the North pacific subtropical gyre: Implications for nutrient supply
    ! in the surface ocean and remineralization in the upper thermocline,
    ! J. Mar. Res., 58, 203-222).  
    ! Phi_dop is the fraction of non-sinking OM converted to DOP, and 
    ! gamma_dop is the first-order decay rate constant for DOP.
    ! 
    call g_tracer_add_param('phi_dop'  ,  bling%phi_dop, 0.1)                    ! dimensionless
    call g_tracer_add_param('gamma_dop',  bling%gamma_dop, 1.0 / (4.0 * spery))  ! s-1
    !
    !
    !-----------------------------------------------------------------------
    ! Remineralization
    !-----------------------------------------------------------------------
    !
    ! Stoichiometric ratios taken from Anderson (1995) as discussed in
    ! Sarmiento and Gruber (2008), and Sarmiento et al. (2002) for Ca:P.
    !
    call g_tracer_add_param('c_2_p', bling%c_2_p, 106.0 )                        ! mol C mol P-1
    call g_tracer_add_param('ca_2_p', bling%ca_2_p, 106.0 * .015 )                        ! mol C mol P-1
    call g_tracer_add_param('n_2_p', bling%n_2_p, 16. )                        ! mol C mol P-1
    call g_tracer_add_param('o2_2_p', bling%o2_2_p, 150.0 )                      ! mol O2 mol P-1
    ! Convert from mol P m-3 to mg C l-1
    call g_tracer_add_param('mass_2_p', bling%mass_2_p, 106. * 12.001 )          ! g C mol P-1

    ! Radiocarbon
    call g_tracer_add_param('half_life_14c', bling%half_life_14c, 5730.0 )       ! a

    !
    !-----------------------------------------------------------------------
    ! Remineralization length scales
    !
    ! Values of parameters to approximate upper e-folding of the globally-tuned
    ! "Martin curve" used in the OCMIP-II Biotic configuration of (z/75)^-0.9
    ! that gives a value of exp(-1) at 228 m from 75 m for an e-folding scale
    ! of 188 m.
    ! Here these are given as a linear function of depth, 
    !   wsink = wsink0 + wsink_acc * (z - wsink0_z)

    call g_tracer_add_param('wsink_acc', bling%wsink_acc, 0.05 / sperd)          ! s-1 
    call g_tracer_add_param('wsink0', bling%wsink0, 16.0 / sperd)                ! m s-1
    call g_tracer_add_param('wsink0_z', bling%wsink0_z, 80. )                    ! m
    call g_tracer_add_param('gamma_pop', bling%gamma_pop, 0.12 / sperd )         ! s-1

    ! Half saturation oxygen concentration for oxic remineralization rate.
    !
    call g_tracer_add_param('k_o2', bling%k_o2, 20.0e-6)                         ! mol O2 kg-1
    !
    ! Remineralization rate under suboxic/anoxic conditions, as a fraction of the rate under
    ! fully oxidized conditions.
    !
    call g_tracer_add_param('remin_min', bling%remin_min, 0.3)                   ! dimensionless
    !
    ! Minimum oxygen concentration for oxic remineralization.
    ! At O2 less than this, anaerobic remineralization occurs at remin_min rate.
    !
    call g_tracer_add_param('o2_min', bling%o2_min, 1.0e-06)                     ! mol O2 kg-1
    !
    ! Prevent oxygen from becoming negative. Setting to false allows negative
    ! oxygen in anoxic zones, which can be thought of as equivalent to 
    ! denitrification plus H2S production.
    !
    call g_tracer_add_param('prevent_neg_o2', bling%prevent_neg_o2, .true. ) 

    ! CaCO3 remineralization length scale. From Station P calibration (Dunne).
    !
    call g_tracer_add_param('ca_remin_depth', bling%ca_remin_depth, 1343. )      ! m

    ! Thickness of active sediment layer for  CaCO3 dissolution calculation
    !
    call g_tracer_add_param('z_sed',  bling%z_sed, 0.1 )                         ! m

    ! Global constant background (non-CaCO3) sedimentation flux, for CaCO3
    ! burial calculation. Given as a flux in g cm-2 ky-1, but then converted 
    ! to a 'mol lith m-2 a-1' flux, by dividing by 10, for consistency with 
    ! the calculations (from TOPAZ).
    !
    call g_tracer_add_param('sed_flux',  bling%sed_flux, 0.14 * .1 )             ! mol m-2 a-1 

    !-----------------------------------------------------------------------
    !       Iron Cycling
    !
    ! Global uniform iron ligand concentration.
    ! Taken from Parekh, P., M. J. Follows and E. A. Boyle (2005) Decoupling of iron
    ! and phosphate in the global ocean. Glob. Biogeochem. Cycles, 19, 
    ! doi: 10.1029/2004GB002280.
    !
    call g_tracer_add_param('felig_bkg', bling%felig_bkg, 1.0e-9)                ! mol ligand kg-1
    !
    ! Ratio of iron efflux from bottom sediment boundaries to the sedimenting phosphorus flux.
    ! From Elrod et al. (2004), 0.68 mmol Fe mol C-1, after Moore et al (2008):
    !
    call g_tracer_add_param('fe_2_p_sed', bling%fe_2_p_sed, 1.e-4 * 106.0 )      ! mol Fe mol P-1
    !
    ! 1.5-order iron scavenging in order to prevent high iron
    ! accumulations in high deposition regions (like the tropical
    ! Atlantic). This also helps prevent Fe accumulating in oligotrophic gyres and in 
    ! the abyssal ocean, where organic fluxes are low.  
    !
    call g_tracer_add_param('kfe_inorg', bling%kfe_inorg, 1.e3/sperd)            ! mol.5 Fe-.5 kg s-1
    !
    ! Equilibrium constant for (free and inorganically bound) iron binding with organic
    ! ligands taken from range similar to Parekh, P., M. J. Follows and E. A. Boyle 
    ! (2005) Decoupling of iron and phosphate in the global ocean. Glob. Biogeochem. 
    ! Cycles, 19, doi: 10.1029/2004GB002280.
    !
    call g_tracer_add_param('kfe_eq_lig_max', bling%kfe_eq_lig_max, 8.e10)       ! mol lig-1 kg
    !
    ! Minimum ligand strength under high light, to represent photodissociation of 
    ! ligand-Fe complexes.
    !
    call g_tracer_add_param('kfe_eq_lig_min', bling%kfe_eq_lig_min, 0.8e10)      ! mol lig-1 kg
    !
    ! Photodecay irradiance scaling.
    !
    call g_tracer_add_param('kfe_eq_lig_irr', bling%kfe_eq_lig_irr, 0.1)         ! W m-2
    !
    ! Iron concentration near which photodecay is compensated by enhanced siderophore
    ! production.
    !
    call g_tracer_add_param('kfe_eq_lig_femin', bling%kfe_eq_lig_femin, 0.05e-9) ! W m-2
    !
    ! Adsorption rate coefficient for detrital organic material.
    !
    call g_tracer_add_param('kfe_org', bling%kfe_org, 0.5/sperd)                 ! g org-1 m3 s-1
    !
    !-----------------------------------------------------------------------
    ! Miscellaneous
    !-----------------------------------------------------------------------
    !
    ! Debug flag to calculate global integrals for tracers
    !
    call g_tracer_add_param('tracer_debug',  bling%tracer_debug, .false.)
    !
    call g_tracer_end_param_list(package_name)
    !===========
    !Block Ends: g_tracer_add_param
    !===========

  end subroutine user_add_params

!#######################################################################
  !
  !   This is an internal sub, not a public interface.
  !   Add all the tracers to be used in this module. 
  !
  subroutine user_add_tracers(tracer_list)
    type(g_tracer_type), pointer :: tracer_list
    character(len=fm_string_len), parameter :: sub_name = 'user_add_tracers'

    !Add here only the parameters that are required at the time of registeration 
    !(to make flux exchanging Ocean tracers known for all PE's) 
    !
    call g_tracer_start_param_list(package_name)

    call g_tracer_add_param('ice_restart_file'   , bling%ice_restart_file  , 'ice_bling.res.nc')
    call g_tracer_add_param('ocean_restart_file' , bling%ocean_restart_file, 'ocean_bling.res.nc')
    call g_tracer_add_param('IC_file'       , bling%IC_file       , '')

    call g_tracer_end_param_list(package_name)

    ! Set Restart files
    call g_tracer_set_files(ice_restart_file    = bling%ice_restart_file,&
         ocean_restart_file  = bling%ocean_restart_file )

    !All tracer fields shall be registered for diag output.

    !=====================================================
    !Specify all prognostic tracers of this modules.
    !=====================================================
    !User adds one call for each prognostic tracer below!
    !User should specify if fluxes must be extracted from boundary 
    !by passing one or more of the following methods as .true.  
    !and provide the corresponding parameters array
    !methods: flux_gas,flux_runoff,flux_wetdep,flux_drydep  
    !
    !Pass an init_value arg if the tracers should be initialized to a nonzero value everywhere
    !otherwise they will be initialized to zero.
    !
    !===========================================================
    !Prognostic Tracers
    !===========================================================
    !

    !       Dissolved Fe 
    !
    call g_tracer_add(tracer_list,package_name, &
         name       = 'fed',                  &
         longname   = 'Dissolved Iron',         & 
         units      = 'mol/kg',                 &
         prog       = .true.,                   &
         flux_runoff    = .false.,              &
         flux_wetdep    = .true.,               &
         flux_drydep    = .true.,               &
         flux_param     = (/ 55.847e-03 /),     &
         flux_bottom    = .true. )


    !       DOP (Dissolved organic phosphorus)
    !
    call g_tracer_add(tracer_list,package_name, &
         name       = 'dop',                  &
         longname   = 'DOP',                    &
         units      = 'mol/kg',                 &
         prog       = .true.)

    !
    !       O2
    !
    !NOTE: flux_gas_type = 'air_sea_gas_flux' is needed since the calculated alpha and csurf 
    !      in this module include the Schmidt number.
    !      If you want to pass Schmidt number separately refer to the calculation in generic_TOPAZ.F90
    !      which uses flux_gas_type = 'air_sea_gas_flux_generic' (which is default).
    !
    call g_tracer_add(tracer_list,package_name,                     &
         name       = 'o2',                                       &
         longname   = 'Oxygen',                                     &
         units      = 'mol/kg',                                     &
         prog       = .true.,                                       &
         flux_gas       = .true.,                                   &
         flux_bottom    = .true.,                                   &
         flux_gas_name  = 'o2_flux',                              &
         flux_gas_type  = 'air_sea_gas_flux',                       &
         flux_gas_molwt = WTMO2,                                    &
         flux_gas_param = (/ 9.36e-07, 9.7561e-06 /),               &
         flux_gas_restart_file  = 'ocean_bling_airsea_flux.res.nc' )

    !
    !       PO4
    !
    call g_tracer_add(tracer_list,package_name,&
         name       = 'po4',                   &
         longname   = 'Phosphate',             &
         units      = 'mol/kg',                &
         prog       = .true.,                  &
         flux_bottom    = .true.     )

    if (do_po4_pre) then                                          !<<PO4_PRE
    !
    !       PO4_pre
    !
    call g_tracer_add(tracer_list,package_name,  &
         name       = 'po4_pre',                 &
         longname   = 'Preformed phosphate',     &
         units      = 'mol/kg',                  &
         prog       = .true.)
    endif                                                         !PO4_PRE>>
    
    !===========================================================
    !Diagnostic Tracers
    !===========================================================
    !
    if (use_bling_chl) then    
    !       Chl (Chlorophyll)
    !
    call g_tracer_add(tracer_list,package_name,&
         name       = 'chl',                   &
         longname   = 'Chlorophyll',           &
         units      = 'ug kg-1',               &
         prog       = .false.,                 &
         init_value = 0.08          )
    else
    call g_tracer_add(tracer_list,package_name,&
         name       = 'chl',                 &
         longname   = 'Chlorophyll',           &
         units      = 'ug kg-1',               &
         prog       = .false.,                 &
         init_value = 0.08          )
    endif    
    !
    !       Biomass
    !
    call g_tracer_add(tracer_list,package_name,&
         name       = 'biomass_p',             &
         longname   = 'Biomass in P units',    &
         units      = 'mol P kg-1',            &
         prog       = .false.)

    !       Irr_mem (Irradiance Memory)
    !
    call g_tracer_add(tracer_list,package_name,&
         name       = 'irr_mem',             &
         longname   = 'Irradiance memory',     &
         units      = 'Watts/m^2',             &
         prog       = .false.)


    if (do_carbon) then                                      !<<CARBON CYCLE
      if (bury_caco3) then                                     !<<BURY CACO3  
      !
      !       ALK (Total carbonate alkalinity)
      ! If CaCO3 is being buried, alkalinity is restored
      ! by riverine input (flux_runoff = true).
      !
      call g_tracer_add(tracer_list,package_name,&
           name       = 'alk',                   &
           longname   = 'Alkalinity',            &
           units      = 'mol/kg',                &
           prog       = .true.,                  &
           flux_runoff    = .true.,              &
           flux_param     = (/ 1.0e-03 /),       &
           flux_bottom    = .true.           )
      !
      !    Cased (CaCO3 concentration in active sediment layer)   
      !
      call g_tracer_add(tracer_list,package_name,&
           name       = 'cased',          &
           longname   = 'Sediment CaCO3 concentration', &
           units      = 'mol m-3',       &
           prog       = .false.          )
      else
      !
      !       ALK (Total carbonate alkalinity)
      !
      call g_tracer_add(tracer_list,package_name,&
           name       = 'alk',                   &
           longname   = 'Alkalinity',            &
           units      = 'mol/kg',                &
           prog       = .true.,                  &
           flux_runoff    = .false.,             &
           flux_param     = (/ 1.0e-03 /),       &
           flux_bottom    = .true.           )
      endif                                                    !BURY CACO3>>
    !
    !       DIC (Dissolved inorganic carbon)
    !
    call g_tracer_add(tracer_list,package_name,      &
         name       = 'dic',                       &
         longname   = 'Dissolved Inorganic Carbon',  &
         units      = 'mol/kg',                      &
         prog       = .true.,                        &
         flux_gas       = .true.,                    &
         flux_gas_name  = 'co2_flux',              &
         flux_gas_type  = 'air_sea_gas_flux',        &
         flux_gas_molwt = WTMCO2,                    &
         flux_gas_param = (/ 9.36e-07, 9.7561e-06 /),&
         flux_gas_restart_file  = 'ocean_bling_airsea_flux.res.nc',  &
         flux_runoff    = .false.,                   &
         flux_param     = (/12.011e-03  /),          &
         flux_bottom    = .true.,                    &
         init_value     = 0.001)
    !     
    !Diagnostic Tracers:
    !
    !       CO3_ion (Carbonate ion)
    !
    call g_tracer_add(tracer_list,package_name,    &
         name       = 'co3_ion',                   &
         longname   = 'Carbonate ion',             &
         units      = 'mol/kg',                    &
         prog       = .false. )
    !
    !       htotal (H+ ion concentration)
    !
    call g_tracer_add(tracer_list,package_name,  &
         name       = 'htotal',                  &
         longname   = 'H+ ion concentration',    &
         units      = 'mol/kg',                  &
         prog       = .false.,                   &
         init_value = bling%htotal_in)

      if (do_carbon_pre) then                                     !<<DIC_PRE  
      !       ALK_pre
      !
      call g_tracer_add(tracer_list,package_name,  &
           name       = 'alk_pre',                 &
           longname   = 'Preformed ALK',           &
           units      = 'mol/kg',                  &
           prog       = .true.)
      !          
      !       DIC_pre
      !
      call g_tracer_add(tracer_list,package_name,  &
           name       = 'dic_pre',                 &
           longname   = 'Preformed DIC',           &
           units      = 'mol/kg',                  &
           prog       = .true.)
      !   
      !       DIC_sat (Saturation Dissolved inorganic carbon)
      !
      call g_tracer_add(tracer_list,package_name,      &
           name       = 'dic_sat',                     &
           longname   = 'Saturation Dissolved Inorganic Carbon', &
           units      = 'mol/kg',                      &
           prog       = .true.,                        &
           flux_gas       = .true.,                    &
           flux_gas_name  = 'co2_sat_flux',            &
           flux_gas_type  = 'air_sea_gas_flux',        &
           flux_gas_molwt = WTMCO2,                    &
           flux_gas_param = (/ 9.36e-07, 9.7561e-06 /),&
           flux_gas_restart_file  = 'ocean_bling_airsea_flux.res.nc',  &
           flux_param     = (/12.011e-03  /),          &
           init_value     = 0.001)
      !
      !Diagnostic tracers
      !
      !       htotal_sat (H+ ion concentration for DIC_sat)
      !
      call g_tracer_add(tracer_list,package_name,       &
           name       = 'htotal_sat',                   &
           longname   = 'H+ ion concentration for DIC_sat',    &
           units      = 'mol/kg',                       &
           prog       = .false.,                        &
           init_value = bling%htotal_in)
      endif                                                       !DIC_PRE>>
 
 
      if (do_14c) then                                        !<<RADIOCARBON
      !       D14IC (Dissolved inorganic radiocarbon)
      !
      call g_tracer_add(tracer_list,package_name,       &
         name       = 'di14c',                          &
         longname   = 'Dissolved Inorganic Radiocarbon',&
         units      = 'mol/kg',                         &
         prog       = .true.,                           &
         flux_gas       = .true.,                       &
         flux_gas_name  = 'c14o2_flux',                 &
         flux_gas_type  = 'air_sea_gas_flux',           &
         flux_gas_molwt = WTMCO2,                       &
         flux_gas_param = (/ 9.36e-07, 9.7561e-06 /),   &
         flux_gas_restart_file  = 'ocean_bling_airsea_flux.res.nc',  &
         flux_param     = (/14.e-03  /),                &
         flux_bottom    = .true.,                       &
         init_value     = 0.001)
      !
      !       DO14C (Dissolved organic radiocarbon)
      !
      call g_tracer_add(tracer_list,package_name, &
         name       = 'do14c',                    &
         longname   = 'DO14C',                    &
         units      = 'mol/kg',                   &
         prog       = .true.)
      endif                                                   !RADIOCARBON>>

    endif                                                    !CARBON CYCLE>>

  end subroutine user_add_tracers

!#######################################################################
! <SUBROUTINE NAME="generic_BLING_update_from_coupler">
  !  <OVERVIEW>
  !   Modify the values obtained from the coupler if necessary.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Some tracer fields could be modified after values are obtained from the 
  !  coupler. This subroutine is the place for specific tracer manipulations.
  !  BLING currently does not use this.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_BLING_update_from_coupler(tracer_list) 
  !  </TEMPLATE>
  !  <IN NAME="tracer_list" TYPE="type(g_tracer_type), pointer">
  !   Pointer to the head of generic tracer list.
  !  </IN>
  ! </SUBROUTINE>
  subroutine generic_BLING_update_from_coupler(tracer_list)
    type(g_tracer_type), pointer :: tracer_list

    character(len=fm_string_len), parameter :: sub_name = 'generic_BLING_update_from_coupler'

  end subroutine generic_BLING_update_from_coupler
!#######################################################################
  ! <SUBROUTINE NAME="generic_BLING_update_from_bottom">
  !  <OVERVIEW>
  !   Set values of bottom fluxes and reservoirs
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Some tracers could have bottom fluxes and reservoirs. 
  !   This subroutine is the place for specific tracer manipulations.
  !   BLING currently does not use this.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_BLING_update_from_bottom(tracer_list,dt, tau) 
  !  </TEMPLATE>
  !  <IN NAME="tracer_list" TYPE="type(g_tracer_type), pointer">
  !   Pointer to the head of generic tracer list.
  !  </IN>
  !  <IN NAME="dt" TYPE="real">
  !   Time step increment 
  !  </IN>
  !  <IN NAME="tau" TYPE="integer">
  !   Time step index to be used for %field
  !  </IN>
  ! </SUBROUTINE>
  subroutine generic_BLING_update_from_bottom(tracer_list, dt, tau)
    type(g_tracer_type), pointer :: tracer_list
    real,               intent(in) :: dt
    integer,            intent(in) :: tau
    integer :: isc,iec, jsc,jec,isd,ied,jsd,jed,nk,ntau
    real, dimension(:,:,:),pointer :: grid_tmask

    call g_tracer_get_common(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,grid_tmask=grid_tmask) 

  end subroutine generic_BLING_update_from_bottom

!#######################################################################
  ! <SUBROUTINE NAME="generic_BLING_update_from_source">
  !  <OVERVIEW>
  !   Update tracer concentration fields due to the source/sink contributions.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   This is the subroutine to contain most of the biogeochemistry for calculating the 
  !   interaction of tracers with each other and with outside forcings.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_BLING_update_from_source(tracer_list,Temp,Salt,dzt,hblt_depth,&
  !                                         ilb,jlb,tau,dt, grid_dat,sw_pen,opacity) 
  !  </TEMPLATE>
  !  <IN NAME="tracer_list" TYPE="type(g_tracer_type), pointer">
  !   Pointer to the head of generic tracer list.
  !  </IN>
  !  <IN NAME="ilb,jlb" TYPE="integer">
  !   Lower bounds of x and y extents of input arrays on data domain
  !  </IN>
  !  <IN NAME="Temp" TYPE="real, dimension(ilb:,jlb:,:)">
  !   Ocean temperature   
  !  </IN>
  !  <IN NAME="Salt" TYPE="real, dimension(ilb:,jlb:,:)">
  !   Ocean salinity
  !  </IN>
  !  <IN NAME="dzt" TYPE="real, dimension(ilb:,jlb:,:)">
  !   Ocean layer thickness (meters)
  !  </IN>
  !  <IN NAME="opacity" TYPE="real, dimension(ilb:,jlb:,:)">
  !   Ocean opacity
  !  </IN>
  !  <IN NAME="sw_pen" TYPE="real, dimension(ilb:,jlb:)">
  !   Shortwave peneteration
  !  </IN>
  !  <IN NAME="hblt_depth" TYPE="real, dimension(ilb:,jlb:)">
  !   
  !  </IN>
  !  <IN NAME="grid_dat" TYPE="real, dimension(ilb:,jlb:)">
  !   Grid area
  !  </IN>
  !  <IN NAME="tau" TYPE="integer">
  !   Time step index of %field
  !  </IN>
  !  <IN NAME="dt" TYPE="real">
  !   Time step increment
  !  </IN>
  ! </SUBROUTINE>
  subroutine generic_BLING_update_from_source(tracer_list,Temp,Salt,&
       rho_dzt,dzt,hblt_depth,ilb,jlb,tau,dt,grid_dat,model_time,nbands,   &
       max_wavelength_band,sw_pen_band,opacity_band)

    type(g_tracer_type),          pointer    :: tracer_list
    real, dimension(ilb:,jlb:,:),   intent(in) :: Temp,Salt,rho_dzt,dzt
    real, dimension(ilb:,jlb:),     intent(in) :: hblt_depth
    integer,                        intent(in) :: ilb,jlb,tau
    real,                           intent(in) :: dt
    real, dimension(ilb:,jlb:),     intent(in) :: grid_dat
    type(time_type),                intent(in) :: model_time

    integer,                        intent(in) :: nbands
    real, dimension(:),             intent(in) :: max_wavelength_band
    real, dimension(:,ilb:,jlb:),   intent(in) :: sw_pen_band
    real, dimension(:,ilb:,jlb:,:), intent(in) :: opacity_band


    character(len=fm_string_len), parameter :: sub_name = 'generic_BLING_update_from_source'
    integer :: isc,iec, jsc,jec,isd,ied,jsd,jed,nk,ntau, i, j, k , kblt,n
    real, dimension(:,:,:) ,pointer :: grid_tmask
    integer, dimension(:,:),pointer :: mask_coast,grid_kmt

    integer :: nb
    logical :: used
    real :: tmp_hblt, tmp_Irrad, tmp_irrad_ML, tmp_opacity
    real, dimension(:), Allocatable :: tmp_irr_band 
    real :: s_over_p, fe_2_p
    real :: TK, PRESS, PKSPC

    call g_tracer_get_common(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,&
         grid_tmask=grid_tmask,grid_mask_coast=mask_coast,grid_kmt=grid_kmt)

  ! SURFACE GAS FLUXES
  ! 
  ! This subroutine coordinates the calculation of gas concentrations and solubilities 
  ! in the surface layer. The concentration of a gas is written as csurf, while the
  ! solubility (in mol kg-1 atm-1 or mol m-3 atm-1) is written as alpha. These two
  ! quantities are passed to the coupler, which multiplies their difference by the
  ! gas exchange piston velocity over the mixed layer depth to provide the gas
  ! exchange flux,
  !    Flux = Kw/dz * (alpha - csurf)
  ! In order to simplify code flow, the Schmidt number parameters, which are part of 
  ! the piston velocity, are calculated here and applied to each of csurf and alpha 
  ! before being sent to the coupler.
  !
  ! For CO2 and 14CO2, the carbon solubility and speciation are calculated by the
  ! subroutine co2calc, following the OCMIP2 protocol. These calculations are both made
  ! using total CO2, following which the surface CO2 concentration (CO2*, also known as
  ! H2CO3*) is scaled by the DI14C/DIC ratio to give the surface 14CO2 concentration.
  ! The speciation calculation uses in situ temperature, salinity, ALK, PO4 and SiO4.
  !
  ! Oxygen solubility is calculated here, using in situ temperature and salinity.  

    !---------------------------------------------------------------------
    ! Get positive tracer concentrations for carbon calculation
    !---------------------------------------------------------------------

    call g_tracer_get_values(tracer_list,'po4' ,'field', bling%f_po4,isd,jsd,ntau=tau,positive=.true.)

    if (do_carbon) then                                      !<<CARBON CYCLE

    call g_tracer_get_values(tracer_list,'htotal','field', bling%f_htotal,isd,jsd,ntau=1)
    call g_tracer_get_values(tracer_list,'alk'   ,'field', bling%f_alk   ,isd,jsd,ntau=tau)
    call g_tracer_get_values(tracer_list,'dic'   ,'field', bling%f_dic   ,isd,jsd,ntau=tau)

    !---------------------------------------------------------------------
    !Calculate co3_ion.
    !Also calculate co2 fluxes csurf and alpha for the next round of exchange
    ! Note a scaled value of the PO4, rather than SiOH3, is used for all 
    ! calculations since there is no prognostic silica cycle 
    !---------------------------------------------------------------------
   
    k=1
    do j = jsc, jec ; do i = isc, iec  !{
       bling%htotallo(i,j) = bling%htotal_scale_lo * bling%f_htotal(i,j,k)
       bling%htotalhi(i,j) = bling%htotal_scale_hi * bling%f_htotal(i,j,k)
    enddo; enddo ; !} i, j
 
    call FMS_ocmip2_co2calc(CO2_dope_vec,grid_tmask(:,:,k),&
         Temp(:,:,k), Salt(:,:,k),                    &
         bling%f_dic(:,:,k),                          &
         bling%f_po4(:,:,k),                          &  
         bling%f_po4(:,:,k),                          &
         bling%f_alk(:,:,k),                          &
         bling%htotallo, bling%htotalhi,&
                                !InOut
         bling%f_htotal(:,:,k),                       & 
                                !OUT
         co2star=bling%co2_csurf(:,:), alpha=bling%co2_alpha(:,:), &
         pCO2surf=bling%pco2_surf(:,:), &
         co3_ion=bling%f_co3_ion(:,:,k))

    do k = 2, nk
       do j = jsc, jec ; do i = isc, iec  !{
          bling%htotallo(i,j) = bling%htotal_scale_lo * bling%f_htotal(i,j,k)
          bling%htotalhi(i,j) = bling%htotal_scale_hi * bling%f_htotal(i,j,k)
       enddo; enddo ; !} i, j
  
       call FMS_ocmip2_co2calc(CO2_dope_vec,grid_tmask(:,:,k),&
            Temp(:,:,k), Salt(:,:,k),                    &
            bling%f_dic(:,:,k),                          &
            bling%f_po4(:,:,k),                          &  
            bling%f_po4(:,:,k),                          &
            bling%f_alk(:,:,k),                          &
            bling%htotallo, bling%htotalhi,&
                                !InOut
            bling%f_htotal(:,:,k),                       & 
                                !OUT
            co3_ion=bling%f_co3_ion(:,:,k))
    enddo

    call g_tracer_set_values(tracer_list,'htotal','field',bling%f_htotal  ,isd,jsd,ntau=1)
    call g_tracer_set_values(tracer_list,'co3_ion','field',bling%f_co3_ion  ,isd,jsd,ntau=1)
    call g_tracer_set_values(tracer_list,'dic','alpha',bling%co2_alpha    ,isd,jsd)
    call g_tracer_set_values(tracer_list,'dic','csurf',bling%co2_csurf    ,isd,jsd)

      if (do_carbon_pre) then                                     !<<DIC_PRE  

    call g_tracer_get_values(tracer_list,'htotal_sat' ,'field',bling%f_htotal_sat,isd,jsd,ntau=1)
    call g_tracer_get_values(tracer_list,'dic_sat'    ,'field',bling%f_dic_sat ,isd,jsd,ntau=tau)
    ! not needed for gas calc, but get them now for later
    call g_tracer_get_values(tracer_list,'alk_pre'    ,'field',bling%f_alk_pre ,isd,jsd,ntau=tau)
    call g_tracer_get_values(tracer_list,'dic_pre'    ,'field',bling%f_dic_pre ,isd,jsd,ntau=tau)

    !---------------------------------------------------------------------
    !Calculate co2 fluxes csurf and alpha for the next round of exchange
    !---------------------------------------------------------------------
   
    k=1
    do j = jsc, jec ; do i = isc, iec  !{
       bling%htotal_satlo(i,j) = bling%htotal_scale_lo * bling%f_htotal_sat(i,j,k)
       bling%htotal_sathi(i,j) = bling%htotal_scale_hi * bling%f_htotal_sat(i,j,k)
    enddo; enddo ; !} i, j
 
    ! The saturation carbon uses the same solubility as the regular DIC, so the
    ! alpha for dic_sat is simply set equal to the alpha for DIC. However, it
    ! has its own concentrations of things (and will use a faster gas exchange).
    ! The Htotal_sat is calculated for the whole ocean, even though it's only
    ! required in the surface layer (since the CO3= concentration related to 
    ! DIC_sat is not used).
 
    call FMS_ocmip2_co2calc(CO2_dope_vec,grid_tmask(:,:,k),&
         Temp(:,:,k), Salt(:,:,k),                    &
         bling%f_dic_sat(:,:,k),                      &
         bling%f_po4(:,:,k),                          &  
         bling%f_po4(:,:,k),                          &  
         bling%f_alk(:,:,k),                          &
         bling%htotal_satlo, bling%htotal_sathi,&
                                !InOut
         bling%f_htotal_sat(:,:,k),                   & 
                                !OUT
         co2star=bling%co2_sat_csurf(:,:),            &
         pCO2surf=bling%pco2_sat_surf(:,:))

    do k = 2, nk
       do j = jsc, jec ; do i = isc, iec  !{
          bling%htotal_satlo(i,j) = bling%htotal_scale_lo * bling%f_htotal_sat(i,j,k)
          bling%htotal_sathi(i,j) = bling%htotal_scale_hi * bling%f_htotal_sat(i,j,k)
       enddo; enddo ; !} i, j
  
       call FMS_ocmip2_co2calc(CO2_dope_vec,grid_tmask(:,:,k),&
            Temp(:,:,k), Salt(:,:,k),                    &
            bling%f_dic_sat(:,:,k),                          &
            bling%f_po4(:,:,k),                          &  
            bling%f_po4(:,:,k),                          &  
            bling%f_alk(:,:,k),                          &
            bling%htotal_satlo, bling%htotal_sathi,&
                                !InOut
            bling%f_htotal_sat(:,:,k))
    enddo

    call g_tracer_set_values(tracer_list,'htotal_sat','field',bling%f_htotal_sat  ,isd,jsd,ntau=1)
    call g_tracer_set_values(tracer_list,'dic_sat','alpha',bling%co2_alpha        ,isd,jsd)
    call g_tracer_set_values(tracer_list,'dic_sat','csurf',bling%co2_sat_csurf    ,isd,jsd)

      endif                                                       !DIC_PRE>>
    
      if (do_14c) then                                        !<<RADIOCARBON
      
      ! Normally, the alpha would be multiplied by the atmospheric 14C/12C ratio. However,
      ! here that is set to 1, so that alpha_14C = alpha_12C. This needs to be changed!

    call g_tracer_get_values(tracer_list,'di14c' ,'field', bling%f_di14c,isd,jsd,ntau=tau)
    ! This is not used until later, but get it now
    call g_tracer_get_values(tracer_list,'do14c' ,'field', bling%f_do14c,isd,jsd,ntau=tau,positive=.true.)
    
       do j = jsc, jec ; do i = isc, iec  !{
       bling%c14o2_csurf(i,j) =  bling%co2_csurf(i,j) *                &
         bling%f_di14c(i,j,1) / (bling%f_dic(i,j,1) + epsln)
       bling%c14o2_alpha(i,j) =  bling%co2_alpha(i,j)
       enddo; enddo ; !} i, j

    call g_tracer_set_values(tracer_list,'di14c','alpha',bling%c14o2_alpha      ,isd,jsd)
    call g_tracer_set_values(tracer_list,'di14c','csurf',bling%c14o2_csurf      ,isd,jsd)

      endif                                                   !RADIOCARBON>>
      
    endif                                                    !CARBON CYCLE>>
    
    !---------------------------------------------------------------------
    ! Get positive concentrations for core tracers
    !---------------------------------------------------------------------
    call g_tracer_get_values(tracer_list,'fed'    ,'field',bling%f_fed       ,isd,jsd,ntau=tau,positive=.true.)
    call g_tracer_get_values(tracer_list,'dop'    ,'field',bling%f_dop       ,isd,jsd,ntau=tau,positive=.true.)
    call g_tracer_get_values(tracer_list,'o2'       ,'field',bling%f_o2        ,isd,jsd,ntau=tau,positive=.true.)
    call g_tracer_get_values(tracer_list,'biomass_p','field',bling%f_biomass_p ,isd,jsd,ntau=1)
    call g_tracer_get_values(tracer_list,'irr_mem','field',bling%f_irr_mem   ,isd,jsd,ntau=1)

    if (do_po4_pre) &
    call g_tracer_get_values(tracer_list,'po4_pre'  ,'field',bling%f_po4_pre   ,isd,jsd,ntau=tau,positive=.true.)
    
    if (do_carbon) then
    call g_tracer_get_values(tracer_list,'co3_ion','field',bling%f_co3_ion   ,isd,jsd,ntau=1,positive=.true.)
      if (bury_caco3) &
      call g_tracer_get_values(tracer_list,'cased'    ,'field',bling%f_cased     ,isd,jsd,ntau=1)
    endif

    bling%zt = 0.0
    s_over_p = 0.0

 !--------------------------------------------------------------------------
 ! NUTRIENT UPTAKE
 !--------------------------------------------------------------------------
   
    ! Available light calculation
    !-----------------------------------------------------------------------
    ! There are multiple types of light.
    !   irr_inst is the instantaneous irradiance field.
    !   irr_mix is the same, but with the irr_inst averaged throughout the  
    ! mixed layer as defined in the KPP routine plus one more vertical box 
    ! to account for mixing directly below the boundary layer. This quantity  
    ! is intended to represent the light to which phytoplankton subject to
    ! turbulent transport in the mixed-layer would be exposed.
    !   irr_mem is a temporally smoothed field carried between timesteps, to 
    ! represent photoadaptation.
    !-----------------------------------------------------------------------

    allocate(tmp_irr_band(nbands))
    do j = jsc, jec ; do i = isc, iec   !{

       do nb=1,nbands !{
          if (max_wavelength_band(nb) .lt. 710) then !{
             tmp_irr_band(nb) = sw_pen_band(nb,i,j)
          else
             tmp_irr_band(nb) = 0.0
          endif !}
       enddo !}

       kblt = 0 ; tmp_irrad_ML = 0.0 ; tmp_hblt = 0.0
       do k = 1, nk !{
          tmp_Irrad = 0.0
          do nb=1,nbands !{
             tmp_opacity = opacity_band(nb,i,j,k)
             tmp_Irrad = tmp_Irrad + tmp_irr_band(nb) * exp(-tmp_opacity * &
               dzt(i,j,k) * 0.5)
             ! Change tmp_irr_band from being the value atop layer k to the 
             ! value at the bottom of layer k.
             tmp_irr_band(nb) = tmp_irr_band(nb) * exp(-tmp_opacity *      &
               dzt(i,j,k))
          enddo !}
          bling%irr_inst(i,j,k) = tmp_Irrad * grid_tmask(i,j,k)
          bling%irr_mix(i,j,k) = tmp_Irrad * grid_tmask(i,j,k)
          if ((k == 1) .or. (tmp_hblt .lt. hblt_depth(i,j))) then !{
             kblt = kblt+1
             tmp_irrad_ML = tmp_irrad_ML + bling%irr_mix(i,j,k) * dzt(i,j,k)
             tmp_hblt = tmp_hblt + dzt(i,j,k)
          endif !}
       enddo !} k-loop
       bling%irr_mix(i,j,1:kblt) = tmp_irrad_ML / max(1.0e-6,tmp_hblt)

    enddo;  enddo !} i,j

    deallocate(tmp_irr_band)

    do k = 1, nk ; do j = jsc, jec ; do i = isc, iec   !{        

       !--------------------------------------------------------------------
       ! Phytoplankton photoadaptation timescale
       
       bling%f_irr_mem(i,j,k) = (bling%f_irr_mem(i,j,k) +                   &
            (bling%irr_mix(i,j,k) - bling%f_irr_mem(i,j,k)) * min( 1.0 ,   &
            bling%gamma_irr_mem * dt)) * grid_tmask(i,j,k)

       !--------------------------------------------------------------------
       ! Temperature functionality of growth and grazing
       ! NB The temperature effect of Eppley (1972) is used instead
       !    of that in Geider et al (1997) for both simplicity and
       !    to incorporate combined effects on uptake, incorporation
       !    into organic matter and photorespiration.  Values of PCmax
       !    are normalized to 0C rather than 20C in Geider et al. (1997)
        
       bling%expkT(i,j,k) = exp(bling%kappa_eppley * Temp(i,j,k))
     
    enddo; enddo ; enddo !} i,j,k

    !-----------------------------------------------------------------------
    ! Phytoplankton are assumed to grow according to the general properties 
    ! described in Geider (1997). This formulation gives a biomass-specific 
    ! growthrate as a function of light, nutrient limitation, and 
    ! temperature. We modify this relationship slightly here, as described 
    ! below, and also use the assumption of steady state growth vs. loss to 
    ! derive a simple relationship between growth rate, biomass and uptake.
    !
    !-----------------------------------------------------------------------
    ! First, we calculate the limitation terms for PO4 and Fe, and the 
    ! Fe-limited Chl:C maximum.
    ! The light-saturated maximal photosynthesis rate term (pc_m) is simply 
    ! the product of a prescribed maximal photosynthesis rate (pc_0), the 
    ! Eppley temperature dependence, and a Liebig limitation (the minimum
    ! of Michaelis-Menton PO4-limitation, or iron-limitation).
    ! The iron limitation term has a lower limit of def_fe_min 
    ! and is scaled by (k_fe_2_p + fe_2_p_max) / fe_2_p_max
    ! so that it approaches 1 as fed approaches infinity. Thus, 
    ! it's of comparable magnitude to the PO4 limitation term.
    !
    ! Fe limitation acts in two additional mechanisms:
    ! 1. By reducing the maximum achievable Chl:C ratio 
    ! (theta) below a prescribed, Fe-replete maximum value (thetamax), to 
    ! approach a prescribed minimum Chl:C (thetamin) under extreme
    ! Fe-limitation.
    ! 2. By reducing alpha (the initial slope of the P-I curve) under Fe-
    ! limitation.
    !-----------------------------------------------------------------------
    
    do k = 1, nk ; do j = jsc, jec ; do i = isc, iec   !{      
         bling%fe_2_p_uptake(i,j,k) = bling%fe_2_p_max *                   &
           bling%f_fed(i,j,k) / (bling%k_fe_uptake + bling%f_fed(i,j,k))
         bling%def_fe(i,j,k) = bling%def_fe_min +                          &
           (1. - bling%def_fe_min) * bling%fe_2_p_uptake(i,j,k) /          & 
           (bling%k_fe_2_p + bling%fe_2_p_uptake(i,j,k)) *                 &
           (bling%k_fe_2_p + bling%fe_2_p_max) / bling%fe_2_p_max 
         bling%pc_m(i,j,k) = bling%pc_0 * bling%expkT(i,j,k) * min(      &
           bling%f_po4(i,j,k) / (bling%k_po4 + bling%f_po4(i,j,k)) ,       &
           bling%def_fe(i,j,k))
         bling%thetamax_fe(i,j,k) = bling%thetamax_lo +                    &
           (bling%thetamax_hi - bling%thetamax_lo) * bling%def_fe(i,j,k)
         bling%alpha(i,j,k) = bling%alpha_min +                            &
           (bling%alpha_max - bling%alpha_min) * bling%def_fe(i,j,k)
            
    !-----------------------------------------------------------------------
    ! Next, the nutrient-limited efficiency of algal photosystems, Irrk, is
    ! calculated. This requires a prescribed quantum yield, alpha.
    ! The iron deficiency term is included here as a multiplier of the 
    ! thetamax_fe to represent the importance of Fe in forming chlorophyll
    ! accessory antennae, which do not affect the Chl:C but still affect the
    ! phytoplankton ability to use light (eg Stzrepek & Harrison Nature 
    ! 2004).

          bling%irrk(i,j,k) = (bling%pc_m(i,j,k) / ( epsln +               &
            bling%alpha(i,j,k) * bling%thetamax_fe(i,j,k) )) +             &
            bling%f_irr_mem(i,j,k) * 0.5

    !-----------------------------------------------------------------------
    ! We also calculate the Chl:C ratio here, although it does not enter  
    ! into the uptake calculation and is only used for the diagnostic
    ! chlorophyll concentration, below.

          bling%theta(i,j,k) = bling%thetamax_fe(i,j,k) / (1. +            &
            bling%thetamax_fe(i,j,k) * bling%alpha(i,j,k) *                &
            bling%f_irr_mem(i,j,k) / (epsln + 2. * bling%pc_m(i,j,k)))
            
    !-----------------------------------------------------------------------
    ! Now we can calculate the carbon-specific photosynthesis rate, pc_tot.
    
          bling%pc_tot(i,j,k) = bling%pc_m(i,j,k) *                        &
            (1. - exp(-bling%irr_mix(i,j,k) / (epsln + bling%irrk(i,j,k))))

    !-----------------------------------------------------------------------
    ! Next, we account for the maintenance effort that phytoplankton must 
    ! exert in order to combat decay. This is prescribed as a fraction of the
    ! light-saturated photosynthesis rate, resp_frac. The result of this is 
    ! to set a level of energy availability below which net growth (and 
    ! therefore nutrient uptake) is zero, given by resp_frac * pc_m.

          bling%mu(i,j,k) = max (0.,                                       &              
            bling%pc_tot(i,j,k) - bling%resp_frac * bling%pc_m(i,j,k))

    !-----------------------------------------------------------------------
    ! We now must convert this net carbon-specific growth rate to nutrient 
    ! uptake rates, the quantities we are interested in. Since we have no 
    ! explicit biomass tracer, we use the result of Dunne et al. (GBC, 2005) 
    ! to calculate an implicit biomass from the uptake rate through the  
    ! application of a simple idealized grazing law. This has the effect of 
    ! reducing uptake in low growth-rate regimes and increasing uptake in 
    ! high growth-rate regimes - essentially a non-linear amplification of 
    ! the growth rate variability. The result is:
    
          bling%biomass_p_ts(i,j,k) =                                      &
            ((bling%mu(i,j,k)/(bling%lambda0 * bling%expkT(i,j,k)))**3     &
            + (bling%mu(i,j,k)/(bling%lambda0 * bling%expkT(i,j,k))))      &
            * bling%p_star

          bling%f_biomass_p(i,j,k) = bling%f_biomass_p(i,j,k) +            &
            (bling%biomass_p_ts(i,j,k) - bling%f_biomass_p(i,j,k)) *       &
            min(1.0, bling%gamma_biomass * dt) * grid_tmask(i,j,k)
          
          bling%jp_uptake(i,j,k) = bling%f_biomass_p(i,j,k) *              &
            bling%mu(i,j,k)

    ! We can now use the diagnostic biomass to calculate the chlorophyll
    ! concentration:
    
          bling%f_chl(i,j,k) = max(bling%chl_min, bling%f_biomass_p(i,j,k) &
            * bling%c_2_p * 12.011e6 * bling%theta(i,j,k)) *               &
            grid_tmask(i,j,k)

    !-----------------------------------------------------------------------
    ! Iron is then taken up as a function of PO4 uptake and iron limitation,
    ! with a maximum Fe:P uptake ratio of fe2p_max:
    
          bling%jfe_uptake(i,j,k) = bling%jp_uptake(i,j,k) *               &
            bling%fe_2_p_uptake(i,j,k)

    enddo; enddo ; enddo !} i,j,k
    
  !-------------------------------------------------------------------------
  ! PARTITIONING BETWEEN ORGANIC POOLS
  !-------------------------------------------------------------------------
   
  ! The uptake of nutrients is assumed to contribute to the growth of
  ! phytoplankton, which subsequently die and are consumed by heterotrophs.
  ! This can involve the transfer of nutrient elements between many
  ! organic pools, both particulate and dissolved, with complex histories.
  ! We take a simple approach here, partitioning the total uptake into two
  ! fractions - sinking and non-sinking - as a function of temperature, 
  ! following Dunne et al. (2005). 
  ! Then, the non-sinking fraction is further subdivided, such that the 
  ! majority is recycled instantaneously to the inorganic nutrient pool,
  ! representing the fast turnover of labile dissolved organic matter via
  ! the microbial loop, and the remainder is converted to semi-labile
  ! dissolved organic matter. Iron and phosphorus are treated identically 
  ! for the first step, but all iron is recycled instantaneously in the
  ! second step (i.e. there is no dissolved organic iron pool).
  !-------------------------------------------------------------------------
    
    do k = 1, nk ; do j = jsc, jec ; do i = isc, iec   !{        

          bling%frac_pop(i,j,k) = (bling%phi_sm + bling%phi_lg *           &
            (bling%mu(i,j,k)/(bling%lambda0*bling%expkT(i,j,k)))**2.)/     &
            (1. +                                                          &
            (bling%mu(i,j,k)/(bling%lambda0*bling%expkT(i,j,k)))**2.)*     &
            exp(bling%kappa_remin * Temp(i,j,k))

          bling%jpop(i,j,k) = bling%frac_pop(i,j,k) * bling%jp_uptake(i,j,k)

          bling%jpofe(i,j,k) = bling%frac_pop(i,j,k)*bling%jfe_uptake(i,j,k)
 
     ! As a helpful diagnostic, the implied fraction of production by large 
     ! phytoplankton is calculated, also following Dunne et al. 2005. This
     ! could be done more simply, but is done here in a complicated way as
     ! a sanity check. Looks fine.
     ! Note the calculation is made in P units, rather than C.
     ! This is also used for the CaCO3 production.

          s_over_p = ( -1. + ( 1. + 4. * bling%jp_uptake(i,j,k) / &
            (bling%expkT(i,j,k) * bling%lambda0 * bling%p_star))**0.5) * .5

          bling%frac_lg(i,j,k) = s_over_p / (1 + s_over_p)
          
    !-----------------------------------------------------------------------
    ! Then the remainder is divided between instantaneously recycled and
    ! long-lived dissolved organic matter,
            
          bling%jdop(i,j,k) = bling%phi_dop * (bling%jp_uptake(i,j,k) - &
            bling%jpop(i,j,k))
            
          bling%jp_recycle(i,j,k) = bling%jp_uptake(i,j,k) - &
            bling%jpop(i,j,k) - bling%jdop(i,j,k)

          bling%jfe_recycle(i,j,k) = bling%jfe_uptake(i,j,k) -  &
            bling%jpofe(i,j,k)

    enddo; enddo ; enddo !} i,j,k
    
    if (do_carbon) then                                     !<<CARBON CYCLE

    !-----------------------------------------------------------------------
    ! Calcium carbonate production
    ! Alkalinity is consumed through the production of CaCO3. Here, this is
    ! simply a linear function of the implied growth rate of small
    ! phytoplankton, which gave a reasonably good fit to the global 
    ! observational synthesis of Dunne (in prep., 2009). This is consistent
    ! with the findings of Jin et al. (GBC,2006).
    !-----------------------------------------------------------------------

         do k = 1, nk ; do j = jsc, jec ; do i = isc, iec   !{
            bling%jca_uptake(i,j,k) = (1. - bling%frac_lg(i,j,k)) *        &
              bling%jp_uptake(i,j,k) * bling%ca_2_p
         enddo; enddo ; enddo !} i,j,k
       
      if (do_14c) then                                        !<<RADIOCARBON
         do k = 1, nk ; do j = jsc, jec ; do i = isc, iec   !{

          bling%c14_2_p(i,j,k) = bling%c_2_p *                             &
            bling%f_di14c(i,j,k) / (epsln + bling%f_dic(i,j,k))

          bling%jdo14c(i,j,k) = bling%phi_dop * (bling%jp_uptake(i,j,k) -  &
            bling%jpop(i,j,k)) * bling%c14_2_p(i,j,k)
            
         enddo; enddo ; enddo !} i,j,k
      endif                                                   !RADIOCARBON>>
       
    endif                                                    !CARBON CYCLE>>

  !-------------------------------------------------------------------------
  ! SINKING AND REMINERALIZATION
  !-------------------------------------------------------------------------
    ! Calculate the depth of each grid cell (needs to be 3d for use with
    ! isopycnal co-ordinate model).

    do j = jsc, jec ;      do i = isc, iec   !{
       bling%zt(i,j,1) = dzt(i,j,1)
    enddo; enddo !} i,j

    do k = 2, nk ; do j = jsc, jec ; do i = isc, iec   !{
       bling%zt(i,j,k) = bling%zt(i,j,k-1) + dzt(i,j,k)
    enddo; enddo ; enddo !} i,j,k

    !-----------------------------------------------------------------------
    ! Calculate the remineralization lengthscale matrix, zremin, a function 
    ! of z. Sinking rate (wsink) is constant over the upper wsink0_z metres,
    ! then  increases linearly with depth.
    ! The remineralization rate is a function of oxygen concentrations,
    ! following a Holling type 2 dependence, decreasing to a minimum value
    ! of remin_min. This is ad hoc, following work by Bianchi, Sarmiento,
    ! Galbraith and Kwon (unpublished).

    do k = 1, nk ; do j = jsc, jec ; do i = isc, iec   !{        
      
        if (bling%zt(i,j,k) .lt. bling%wsink0_z) then !{
          bling%wsink(i,j,k) = bling%wsink0
        else
          bling%wsink(i,j,k) = (bling%wsink_acc * (bling%zt(i,j,k) -       &
            bling%wsink0_z) + bling%wsink0)
        endif  !}

        bling%zremin(i,j,k) = bling%gamma_pop * (bling%f_o2(i,j,k)**2 /    &
          (bling%k_o2**2 + bling%f_o2(i,j,k)**2) * (1. - bling%remin_min)+ &
          bling%remin_min) / (bling%wsink(i,j,k) + epsln)

    enddo; enddo ; enddo !} i,j,k

    if (do_carbon) then                                       !<<CARBON CYCLE
     do k = 1, nk ; do j = jsc, jec ; do i = isc, iec   !{
     
     ! Using Sayles for solubility (will change to Mucci later)
       bling%co3_solubility(i,j,k) = max(4.95e-7 * exp ( 0.05021 / &
            (Temp(i,j,k) + 273.15) * bling%zt(i,j,k)) * 3.42031e-3 *       &
            bling%Rho_0 * bling%Rho_0 / max(epsln, Salt(i,j,k)),epsln)
      
     ! CaCO3 dissolution lengthscale is a function of the saturation state,
     ! CO3 / CO3solubility, such that the lengthscale decreases from
     ! infinity at CO3 > CO3solubility to zero at CO3 = 0.
     
     bling%zremin_caco3(i,j,k) = 1. / bling%ca_remin_depth * (1.0 -        &
       min(1., bling%f_co3_ion(i,j,k) / (bling%co3_solubility(i,j,k) +     &
       epsln)))
         
     enddo; enddo ; enddo !} i,j,k
     
    ! Generate CaCO3 sinking flux, and dissolve it through the water column.
    ! Same as for other elements - see below for more detailed explanation.

    do j = jsc, jec ;      do i = isc, iec   !{

      bling%fcaco3(i,j,1) = bling%jca_uptake(i,j,1) * rho_dzt(i,j,1) /     &
        (1.0 + dzt(i,j,1) * bling%zremin_caco3(i,j,1)) 

      bling%jca_reminp(i,j,1) =                                            &
       (bling%jca_uptake(i,j,1) * rho_dzt(i,j,1) - bling%fcaco3(i,j,1)) /  &
       (epsln + rho_dzt(i,j,1))
       
    enddo; enddo !} i,j

    do k = 2, nk ; do j = jsc, jec ; do i = isc, iec   !{

      bling%fcaco3(i,j,k) = (bling%fcaco3(i,j,k-1) +                       &
        bling%jca_uptake(i,j,k) * rho_dzt(i,j,k)) /                        &
        (1.0 + dzt(i,j,k) * bling%zremin_caco3(i,j,k)) 

      bling%jca_reminp(i,j,k) = (bling%fcaco3(i,j,k-1) +                   &
       bling%jca_uptake(i,j,k) * rho_dzt(i,j,k) - bling%fcaco3(i,j,k)) /   &
       (epsln + rho_dzt(i,j,k))
       
    enddo; enddo ; enddo !} i,j,k

      if (do_14c) then                                        !<<RADIOCARBON

      ! Sinking particulate 14C is generated in the local ratio of 14C/12C
      ! to sinking 12C, which itself is strictly tied to P through a fixed
      ! C:P. Therefore, jpop can be used to calculate fpo14c.

      do j = jsc, jec ;      do i = isc, iec   !{
        bling%fpo14c(i,j,1) = bling%jpop(i,j,1) * bling%c14_2_p(i,j,1) *   &
          rho_dzt(i,j,1) /                                                 &
          (1.0 + dzt(i,j,1) * bling%zremin(i,j,1)) 

        bling%j14c_reminp(i,j,1) = (bling%jpop(i,j,1) *                    &
          bling%c14_2_p(i,j,1) * rho_dzt(i,j,1) - bling%fpo14c(i,j,1)) /   &
         (epsln + rho_dzt(i,j,1))
      enddo; enddo !} i,j

      do k = 2, nk ; do j = jsc, jec ; do i = isc, iec   !{
        bling%fpo14c(i,j,k) = (bling%fpo14c(i,j,k-1) +                     &
          bling%jpop(i,j,k) * bling%c14_2_p(i,j,k) * rho_dzt(i,j,k)) /     &
          (1.0 + dzt(i,j,k) * bling%zremin(i,j,k)) 

        bling%j14c_reminp(i,j,k) = (bling%fpo14c(i,j,k-1) +                &
         bling%jpop(i,j,k) * bling%c14_2_p(i,j,k) * rho_dzt(i,j,k) -       &
         bling%fpo14c(i,j,k)) / (epsln + rho_dzt(i,j,k))
      enddo; enddo ; enddo !} i,j,k

     ! Decay the radiocarbon in both DIC and DOC
     
     bling%lambda_14c = log(2.0) / (bling%half_life_14c * spery)

      do k = 1, nk ; do j = jsc, jec ; do i = isc, iec   !{        

        bling%j14c_decay_dic(i,j,k) = bling%f_di14c(i,j,k) *               &
          bling%lambda_14c 

        bling%j14c_decay_doc(i,j,k) = bling%f_do14c(i,j,k) *               &
          bling%lambda_14c 

      enddo; enddo ; enddo !} i,j,k
      endif                                                   !RADIOCARBON>>

    endif                                                    !CARBON CYCLE>>

    do k = 1, nk ; do j = jsc, jec ; do i = isc, iec   !{        

     !---------------------------------------------------------------------
     ! Calculate free and inorganically associated iron concentration for
     ! scavenging.
     ! We assume that there is a 
     ! spectrum of iron ligands present in seawater, with varying binding
     ! strengths and whose composition varies with light and iron 
     ! concentrations. For example, photodissocation of ligand complexes 
     ! occurs under bright light, weakening the binding strength 
     ! (e.g. Barbeau et al., Nature 2001), while at very low iron 
     ! concentrations (order kfe_eq_lig_femin), siderophores are thought
     ! to be produced as a response to extreme
     ! iron stress.
     ! In anoxic waters, iron should be reduced, and therefore mostly 
     ! immune to scavenging. Easiest way to do this is to skip the feprime
     ! calculation if oxygen is less than 0.
     
     if (bling%f_o2(i,j,k) .gt. bling%o2_min) then  !{
     bling%kfe_eq_lig(i,j,k) = bling%kfe_eq_lig_max -                      &
       (bling%kfe_eq_lig_max - bling%kfe_eq_lig_min) *                     &
       (bling%irr_inst(i,j,k)**2. / (bling%irr_inst(i,j,k)**2. +       &
       bling%kfe_eq_lig_irr **2.)) * max(0., min(1., (bling%f_fed(i,j,k) - &
       bling%kfe_eq_lig_femin) / (epsln + bling%f_fed(i,j,k)) * 1.2))

     bling%feprime(i,j,k) = 1.0 + bling%kfe_eq_lig(i,j,k) *                &
       (bling%felig_bkg - bling%f_fed(i,j,k))
     
     bling%feprime(i,j,k) = (-bling%feprime(i,j,k) +(bling%feprime(i,j,k)* &
       bling%feprime(i,j,k) + 4.0 * bling%kfe_eq_lig(i,j,k) *              &
       bling%f_fed(i,j,k))**(0.5)) /(2.0 * bling%kfe_eq_lig(i,j,k))
     else
     bling%feprime(i,j,k) = 0.
     endif !}

     bling%jfe_ads_inorg(i,j,k) = min(0.5/dt, bling%kfe_inorg * &
       bling%feprime(i,j,k) ** 0.5) * bling%feprime(i,j,k) 
     
    enddo; enddo ; enddo  !} i,j,k

    !---------------------------------------------------------------------
    ! In general, the flux at the bottom of a grid cell should equal
    ! Fb = (Ft + Prod*dz) / (1 + zremin*dz)
    ! where Ft is the flux at the top, and prod*dz is the integrated 
    ! production of new sinking particles within the layer.
    ! Since Ft=0 in the first layer,

    do j = jsc, jec ;      do i = isc, iec   !{

      bling%fpop(i,j,1) = bling%jpop(i,j,1) * rho_dzt(i,j,1) /             &
        (1.0 + dzt(i,j,1) * bling%zremin(i,j,1)) 

    !-----------------------------------------------------------------------
    ! Now, calculate the Fe adsorption using this fpop:
    ! The absolute first order rate constant is calculated from the 
    ! concentration of organic particles, after Parekh et al. (2005). Never
    !  allowed to be greater than 1/2dt for numerical stability.

     bling%jfe_ads_org(i,j,1) = min (0.5/dt,                               &
       bling%kfe_org * (bling%fpop(i,j,1) / (epsln + bling%wsink(i,j,1)) * &
       bling%mass_2_p) ** 0.58) * bling%feprime(i,j,1)
       
      bling%fpofe(i,j,1) = (bling%jpofe(i,j,1) +bling%jfe_ads_inorg(i,j,1) &
        + bling%jfe_ads_org(i,j,1)) * rho_dzt(i,j,1) /                     &
        (1.0 + dzt(i,j,1) * bling%zremin(i,j,1)) 
      
    !-----------------------------------------------------------------------
    ! Calculate remineralization terms

      bling%jp_reminp(i,j,1) =                                             &
       (bling%jpop(i,j,1) * rho_dzt(i,j,1) - bling%fpop(i,j,1)) /          &
       (epsln + rho_dzt(i,j,1))
       
      bling%jfe_reminp(i,j,1) =                                            &
       ((bling%jpofe(i,j,1) + bling%jfe_ads_org(i,j,1) +                   &
       bling%jfe_ads_inorg(i,j,1)) * rho_dzt(i,j,1) -                      &
       bling%fpofe(i,j,1)) / (epsln + rho_dzt(i,j,1))

     enddo; enddo !} i,j

    !-----------------------------------------------------------------------
    ! Then, for the rest of water column, include Ft:

    do k = 2, nk ; do j = jsc, jec ; do i = isc, iec   !{

      bling%fpop(i,j,k) = (bling%fpop(i,j,k-1) +                           &
        bling%jpop(i,j,k) * rho_dzt(i,j,k)) /                              &
        (1.0 + dzt(i,j,k) * bling%zremin(i,j,k)) 

    !-----------------------------------------------------------------------
    ! Again, calculate the Fe adsorption using this fpop:

     bling%jfe_ads_org(i,j,k) = min (0.5/dt,                               &
       bling%kfe_org * (bling%fpop(i,j,k) / (epsln + bling%wsink(i,j,k)) * &
       bling%mass_2_p) ** 0.58) * bling%feprime(i,j,k)
       
      bling%fpofe(i,j,k) = (bling%fpofe(i,j,k-1) +                         &
        (bling%jfe_ads_org(i,j,k) + bling%jfe_ads_inorg(i,j,k) +           &
        bling%jpofe(i,j,k)) *rho_dzt(i,j,k)) /                             &
        (1.0 + dzt(i,j,k) * bling%zremin(i,j,k)) 

    !---------------------------------------------------------------------
    ! Calculate remineralization terms

      bling%jp_reminp(i,j,k) = (bling%fpop(i,j,k-1) +                      &
       bling%jpop(i,j,k) * rho_dzt(i,j,k) - bling%fpop(i,j,k)) /           &
       (epsln + rho_dzt(i,j,k))
       
      bling%jfe_reminp(i,j,k) = (bling%fpofe(i,j,k-1) +                    &
       (bling%jfe_ads_org(i,j,k) + bling%jfe_ads_inorg(i,j,k) +            & 
         bling%jpofe(i,j,k)) * rho_dzt(i,j,k) -                            &
       bling%fpofe(i,j,k)) / (epsln + rho_dzt(i,j,k))

    enddo; enddo ; enddo !} i,j,k

    !---------------------------------------------------------------------
    ! BOTTOM LAYER 
    ! Account for remineralization in bottom box, and bottom fluxes

    do j = jsc, jec ; do i = isc, iec  !{
       k = grid_kmt(i,j)
       if (k .gt. 0) then !{

      !---------------------------------------------------------------------
      ! Calculate iron addition from sediments as a function of organic
      ! matter supply.

        bling%ffe_sed(i,j) = bling%fe_2_p_sed * bling%fpop(i,j,k)

      ! Added the burial flux of sinking particulate iron here as a 
      ! diagnostic, needed to calculate mass balance of iron.

        bling%fe_burial(i,j) = bling%fpofe(i,j,k)

      !---------------------------------------------------------------------
      ! Calculate external bottom fluxes for tracer_vertdiff. Positive fluxes
      ! are from the water column into the seafloor. For P, the bottom flux  
      ! puts the sinking flux reaching the bottom cell into the water column 
      ! through diffusion. For iron, the sinking flux disappears into the 
      ! sediments if bottom waters are oxic (assumed adsorbed as oxides),
      ! while an efflux of dissolved iron occurs dependent on the supply of
      ! reducing organic matter (scaled by the org-P sedimentation rate).
      ! If bottom waters are anoxic, the sinking flux of Fe is returned to
      ! the water column. Note this is not appropriate for very long runs
      ! with an anoxic ocean (iron will keep accumulating forever).
      ! For oxygen, the consumption of oxidant required to respire  
      ! the settling flux of organic matter (in support of the
      ! PO4 bottom flux) diffuses from the bottom water into the sediment.

        bling%b_po4(i,j) = - bling%fpop(i,j,k)

        if (bling%f_o2(i,j,k) .gt. bling%o2_min) then  !{
          bling%b_fed(i,j) = - bling%ffe_sed(i,j) 
        else
          bling%b_fed(i,j) = - bling%ffe_sed(i,j) - bling%fpofe(i,j,k)
        endif !}      

        bling%b_o2(i,j) = bling%o2_2_p * bling%fpop(i,j,k)

      endif !}
    enddo; enddo  !} i, j

    call g_tracer_set_values(tracer_list,'fed', 'btf', bling%b_fed ,isd,jsd)
    call g_tracer_set_values(tracer_list,'po4', 'btf', bling%b_po4 ,isd,jsd)
    call g_tracer_set_values(tracer_list,'o2',    'btf', bling%b_o2 ,isd,jsd)

    if (do_carbon) then                                !<<CARBON CYCLE
    ! Do bottom box calcs for carbon cycle
    
      do j = jsc, jec ; do i = isc, iec  !{
         k = grid_kmt(i,j)
         if (k .gt. 0) then !{
           ! CaCO3 dissolved in the sediment is returned as an alkalinity 
           ! bottom flux. This can allow for some burial of CaCO3, or return
           ! all CaCO3 to the water column to preserve the alkalinity 
           ! inventory at the user's preference.
           ! In addition, the flux of NO3 out of the sediment, inferred from 
           ! the PO4 flux, causes a negative flux of alkalinity.
           ! As a diagnostic,
           bling%fcaco3_to_sed(i,j) = bling%fcaco3(i,j,k)
           
           if (bury_caco3) then 
           !-----------------------------------------------------------------
           ! Determine the flux of CaCO3 retained in sediment using the Dunne
           ! et al (in prep) metamodel calibrated to the Hales (2003) steady 
           ! state 1-d sediment model. In short, this uses the bottom water 
           ! calcite saturation state (omega), as well as additional
           ! dissolution caused by the remineralization of organic matter, to
           ! calculate dissolution within a 10cm-thick active sediment layer. 
           ! The sediment is assumed to accumulate at a rate determined by
           ! the sum of 
           ! so that, assuming a density of 2.7 g cm-3,
           ! a porosity of 0.7, and an average molecular weight of 100 for 
           ! sedimentary components to give: 2.7e6*(1-0.7)=8.1e3 mol m-3.  
           !
           ! The permanent burial flux of CaCO3 is then given by the product
           ! of the concentration of CaCO3 in the active sediment layer and 
           ! the mass accumulation rate, and a new concentration of CaCO3 in 
           ! the active sediment layer is calcuated from the sum of the 
           ! fluxes.
           !
           ! Note that, at steady state, the burial efficiency, 
           !     f = fcased_burial/f_cadet_btf
           ! reduces to (in TOPAZ nomenclature):
           !
           !  f = min(f_cadet_btf,0.0653 * f_ndet_btf * topaz%c_2_n) / 
           !   (7.34e-02 / spery * max(0.0, 1.0 - f_co3_ion / co3_solubility 
           !   + 1.64 * f_ndet_btf * c_2_n * spery)**2.83 * (f_lithdet
           !   * spery + f_cadet_btf * 100.0 * spery)**-1.84 + f_cadet_btf)
           !
           ! which can be used to generate a useful initial condition. 
           !----------------------------------------------------------------
           !
           bling%fcased_redis(i,j) = min(bling%fcaco3(i,j,k),              &
             0.0653 * bling%fpop(i,j,k) * bling%c_2_p) + 7.34e-02 / spery  &
             * max(0.0, 1.0 - bling%f_co3_ion(i,j,k) /                     &
             bling%co3_solubility(i,j,k) + 1.64 * bling%fpop(i,j,k) *      &
             bling%c_2_p * spery)**(2.83) * (bling%sed_flux +              &
             bling%fcaco3(i,j,k) * 100.0 * spery)**(-1.84) *               &
             bling%f_cased(i,j,1)
           bling%fcased_burial(i,j) = max(0.0, bling%fcaco3(i,j,k) *       &
             bling%f_cased(i,j,1) / 8.1e3)
           bling%f_cased(i,j,1) = bling%f_cased(i,j,1) +                   &
             (bling%fcaco3(i,j,k) - bling%fcased_redis(i,j) -              &
             bling%fcased_burial(i,j)) / bling%z_sed * dt *                &
             grid_tmask(i,j,k)
           bling%b_alk(i,j) = - 2. * bling%fcased_redis(i,j) +             &
             bling%fpop(i,j,k) * bling%n_2_p
           ! Do not bury any C-org - all goes back to water column  
           bling%b_dic(i,j) = - bling%fpop(i,j,k) * bling%c_2_p -          &
             bling%fcased_redis(i,j)
           else
           !----------------------------------------------------------------
           !   Conserve alkalinity in the ocean
           !
           bling%b_alk(i,j) = - 2. * bling%fcaco3(i,j,k) +                 &
             bling%fpop(i,j,k) * bling%n_2_p
           ! Do not bury any C - all goes back to water column  
           bling%b_dic(i,j) = - bling%fpop(i,j,k) * bling%c_2_p -          &
             bling%fcaco3(i,j,k)
           endif
         endif  
      enddo; enddo  !} i, j

      call g_tracer_set_values(tracer_list,'alk', 'btf', bling%b_alk ,isd,jsd)
      call g_tracer_set_values(tracer_list,'dic', 'btf', bling%b_dic ,isd,jsd)

      if (do_14c) then                                        !<<RADIOCARBON
      do j = jsc, jec ; do i = isc, iec  !{
         k = grid_kmt(i,j)
         if (k .gt. 0) then !{
           bling%b_di14c(i,j) = - bling%fpo14c(i,j,k)
         endif  
      enddo; enddo  !} i, j

     call g_tracer_set_values(tracer_list,'di14c','btf',bling%b_di14c,isd,jsd)
      endif                                                   !RADIOCARBON>>
      
    endif                                                    !CARBON CYCLE>>


  !-------------------------------------------------------------------------
  !     CALCULATE SOURCE/SINK TERMS FOR EACH TRACER
  !-------------------------------------------------------------------------

    !Update the prognostics tracer fields via their pointers.

    call g_tracer_get_pointer(tracer_list,'fed'    ,'field',bling%p_fed    )
    call g_tracer_get_pointer(tracer_list,'dop'    ,'field',bling%p_dop    )
    call g_tracer_get_pointer(tracer_list,'o2'       ,'field',bling%p_o2     )
    call g_tracer_get_pointer(tracer_list,'po4'    ,'field',bling%p_po4    )

    if (do_po4_pre) &
    call g_tracer_get_pointer(tracer_list,'po4_pre','field',bling%p_po4_pre)
    
    if (do_carbon) then
    call g_tracer_get_pointer(tracer_list,'alk','field',bling%p_alk)
    call g_tracer_get_pointer(tracer_list,'dic','field',bling%p_dic)
    endif 

    if (do_14c) then
    call g_tracer_get_pointer(tracer_list,'di14c','field',bling%p_di14c)
    call g_tracer_get_pointer(tracer_list,'do14c','field',bling%p_do14c)
    endif 

    if (do_carbon_pre) then 
    call g_tracer_get_pointer(tracer_list,'alk_pre','field',bling%p_alk_pre)
    call g_tracer_get_pointer(tracer_list,'dic_pre','field',bling%p_dic_pre)
    endif

    do k = 1, nk ; do j = jsc, jec ; do i = isc, iec  !{
       
       !
       ! PO4
       ! Sum of fast recycling, decay of sinking POP, and decay of DOP,
       ! less uptake.
       !    
       bling%jpo4(i,j,k) = bling%jp_recycle(i,j,k) +                       &
         (1. - bling%phi_dop) * bling%jp_reminp(i,j,k) +                   &
         (bling%gamma_dop * bling%f_dop(i,j,k))  - bling%jp_uptake(i,j,k)
  
       bling%p_po4(i,j,k,tau) = bling%p_po4(i,j,k,tau) +                   &
          bling%jpo4(i,j,k) * dt * grid_tmask(i,j,k)
       !
       ! Fed
       !
       bling%p_fed(i,j,k,tau) = bling%p_fed(i,j,k,tau) +                   &
         (bling%jfe_recycle(i,j,k) + bling%jfe_reminp(i,j,k) -             &
         bling%jfe_uptake(i,j,k) - bling%jfe_ads_org(i,j,k) -              &
         bling%jfe_ads_inorg(i,j,k) ) * dt * grid_tmask(i,j,k)

       !
       ! Dissolved Organic Phosphorus
       ! Add first-order decay and generation from sinking particles
       ! to jprod, initially produced in Uptake above.
       !
       bling%jdop(i,j,k) = bling%jdop(i,j,k) + bling%phi_dop *             &
         bling%jp_reminp(i,j,k) - bling%gamma_dop * bling%f_dop(i,j,k)
         
       bling%p_dop(i,j,k,tau) = bling%p_dop(i,j,k,tau)+bling%jdop(i,j,k) * &
        dt * grid_tmask(i,j,k)

    !-----------------------------------------------------------------------
    !     O2
    ! Assuming constant P:O ratio.
    ! Optional prevention of negative oxygen (does not conserve ocean 
    ! redox potential) or alternatively it can be allowed to go negative, 
    ! keeping track of an implicit nitrate deficit 
    ! plus sulfate reduction.
    !-----------------------------------------------------------------------

       if ( (bling%prevent_neg_o2) .and.                                   &
            (bling%f_o2(i,j,k) .lt. bling%o2_min) ) then !{
         bling%jo2(i,j,k) = 0. * grid_tmask(i,j,k)
       else
         bling%jo2(i,j,k) = - bling%o2_2_p * bling%jpo4(i,j,k)              &
           * grid_tmask(i,j,k)
       endif !}

       bling%p_o2(i,j,k,tau) = bling%p_o2(i,j,k,tau) + bling%jo2(i,j,k) *  &
        dt * grid_tmask(i,j,k)
    enddo; enddo ; enddo  !} i,j,k

    if (do_carbon) then                                      !<<CARBON CYCLE
    do k = 1, nk ; do j = jsc, jec ; do i = isc, iec  !{
    
       bling%p_alk(i,j,k,tau) = bling%p_alk(i,j,k,tau) + (2. *             &
         (bling%jca_reminp(i,j,k) - bling%jca_uptake(i,j,k)) -             &
         bling%jpo4(i,j,k) * bling%n_2_p) * dt * grid_tmask(i,j,k)
         
       bling%p_dic(i,j,k,tau) = bling%p_dic(i,j,k,tau) +                   &
         (bling%jpo4(i,j,k) * bling%c_2_p + bling%jca_reminp(i,j,k) -      &
         bling%jca_uptake(i,j,k)) * dt * grid_tmask(i,j,k)
       
      if (do_14c) then                                        !<<RADIOCARBON
       bling%jdi14c(i,j,k) = (bling%jp_recycle(i,j,k) -                    &
         bling%jp_uptake(i,j,k)) * bling%c14_2_p(i,j,k) +                  &
         (1. - bling%phi_dop) * bling%j14c_reminp(i,j,k) +                 &
         (bling%gamma_dop * bling%f_do14c(i,j,k)) 
  
       bling%p_di14c(i,j,k,tau) = bling%p_di14c(i,j,k,tau) +               &
         (bling%jdi14c(i,j,k) - bling%j14c_decay_dic(i,j,k)) * dt          &
         * grid_tmask(i,j,k)

       bling%jdo14c(i,j,k) = bling%jdo14c(i,j,k) + bling%phi_dop *         &
         bling%j14c_reminp(i,j,k) - bling%gamma_dop * bling%f_do14c(i,j,k)
         
       bling%p_do14c(i,j,k,tau) = bling%p_do14c(i,j,k,tau) +               &
         (bling%jdo14c(i,j,k) - bling%j14c_decay_doc(i,j,k)) * dt          &
         * grid_tmask(i,j,k)
      endif                                                   !RADIOCARBON>>
 
    enddo; enddo ; enddo  !} i,j,k
    endif                                                    !CARBON CYCLE>>
       

    !
    ! PO4_pre
    ! Set equal to PO4 in surface layer only.
    if (do_po4_pre) then
      do j = jsc, jec ; do i = isc, iec  !{
        bling%p_po4_pre(i,j,1,tau) = bling%f_po4(i,j,1) 
      enddo; enddo ;  !} i,j
    endif
    
    !
    ! DIC_pre and ALK_pre
    ! Set equal to DIC and ALK, respectively, in surface layer.
    if (do_carbon_pre) then 
      do j = jsc, jec ; do i = isc, iec  !{
        bling%p_alk_pre(i,j,1,tau) = bling%f_alk(i,j,1) 
        bling%p_dic_pre(i,j,1,tau) = bling%f_dic(i,j,1) 
      enddo; enddo ;  !} i,j
    endif

    !
    !Set the diagnostics tracer fields.
    !
    if (use_bling_chl) then    
    call g_tracer_set_values(tracer_list,'chl',       'field',bling%f_chl       ,isd,jsd,ntau=1)
    else
      call g_tracer_set_values(tracer_list,'chl',       'field',bling%f_chl       ,isd,jsd,ntau=1)
    endif
    call g_tracer_set_values(tracer_list,'biomass_p', 'field',bling%f_biomass_p ,isd,jsd,ntau=1)
    call g_tracer_set_values(tracer_list,'irr_mem' ,  'field',bling%f_irr_mem   ,isd,jsd,ntau=1)
    if (bury_caco3) &
      call g_tracer_set_values(tracer_list,'cased',   'field',bling%f_cased     ,isd,jsd,ntau=1)

    !-----------------------------------------------------------------------
    !       Save variables for diagnostics
    !-----------------------------------------------------------------------
    !

    if (bling%id_alpha .gt. 0)                                                   &
         used = send_data(bling%id_alpha,          bling%alpha,                  &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_b_fed .gt. 0)                                                   &
         used = send_data(bling%id_b_fed,          bling%b_fed,                  &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_b_o2 .gt. 0)                                                    &
         used = send_data(bling%id_b_o2,           bling%b_o2,                   &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_b_po4 .gt. 0)                                                   &
         used = send_data(bling%id_b_po4,          bling%b_po4,                  &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_b_po4_n .gt. 0)                                                 &
         used = send_data(bling%id_b_po4_n,          bling%b_po4_n,              &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_b_po4_nx .gt. 0)                                                &
         used = send_data(bling%id_b_po4_nx,          bling%b_po4_nx,            &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_b_po4_s .gt. 0)                                                 &
         used = send_data(bling%id_b_po4_s,          bling%b_po4_s,              &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_b_po4_sx .gt. 0)                                                &
         used = send_data(bling%id_b_po4_sx,          bling%b_po4_sx,            &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_biomass_p_ts .gt. 0)                                            &
         used = send_data(bling%id_biomass_p_ts,   bling%biomass_p_ts,           &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_def_fe .gt. 0)                                                  &
         used = send_data(bling%id_def_fe,         bling%def_fe,                 &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_expkT .gt. 0)                                                   &
         used = send_data(bling%id_expkT,          bling%expkT,                  &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_fe_2_p_uptake .gt. 0)                                           &
         used = send_data(bling%id_fe_2_p_uptake,  bling%fe_2_p_uptake,          &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_feprime .gt. 0)                                                 &
         used = send_data(bling%id_feprime,        bling%feprime,                &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_fe_burial .gt. 0)                                               &
         used = send_data(bling%id_fe_burial,      bling%fe_burial,              &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_ffe_sed .gt. 0)                                                 &
         used = send_data(bling%id_ffe_sed,        bling%ffe_sed,                &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_fpofe .gt. 0)                                                   &
         used = send_data(bling%id_fpofe,          bling%fpofe,                  &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_fpop .gt. 0)                                                    &
         used = send_data(bling%id_fpop,           bling%fpop,                   &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_fpop_n .gt. 0)                                                  &
         used = send_data(bling%id_fpop_n,           bling%fpop_n,               &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_fpop_nx .gt. 0)                                                 &
         used = send_data(bling%id_fpop_nx,           bling%fpop_nx,             &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_fpop_s .gt. 0)                                                  &
         used = send_data(bling%id_fpop_s,           bling%fpop_s,               &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_fpop_sx .gt. 0)                                                 &
         used = send_data(bling%id_fpop_sx,           bling%fpop_sx,             &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_frac_lg .gt. 0)                                                 &
         used = send_data(bling%id_frac_lg,        bling%frac_lg,                &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_frac_pop .gt. 0)                                                &
         used = send_data(bling%id_frac_pop,       bling%frac_pop,               &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_irr_inst .gt. 0)                                                &
         used = send_data(bling%id_irr_inst,       bling%irr_inst,               &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_irr_mix .gt. 0)                                                 &
         used = send_data(bling%id_irr_mix,        bling%irr_mix,                &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_irrk .gt. 0)                                                    &
         used = send_data(bling%id_irrk,           bling%irrk,                   &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jdop .gt. 0)                                                    &
         used = send_data(bling%id_jdop,           bling%jdop*rho_dzt,           &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jfe_ads_inorg .gt. 0)                                           &
         used = send_data(bling%id_jfe_ads_inorg,  bling%jfe_ads_inorg*rho_dzt,  &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jfe_ads_org .gt. 0)                                             &
         used = send_data(bling%id_jfe_ads_org,    bling%jfe_ads_org*rho_dzt,    &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jfe_recycle .gt. 0)                                             &
         used = send_data(bling%id_jfe_recycle,    bling%jfe_recycle*rho_dzt,    &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jfe_reminp .gt. 0)                                              &
         used = send_data(bling%id_jfe_reminp,     bling%jfe_reminp*rho_dzt,     &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jfe_uptake .gt. 0)                                              &
         used = send_data(bling%id_jfe_uptake,     bling%jfe_uptake*rho_dzt,     &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jo2 .gt. 0)                                                     &
         used = send_data(bling%id_jo2,            bling%jo2*rho_dzt,            &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jp_recycle .gt. 0)                                              &
         used = send_data(bling%id_jp_recycle,     bling%jp_recycle*rho_dzt,     &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jp_reminp .gt. 0)                                               &
         used = send_data(bling%id_jp_reminp,      bling%jp_reminp*rho_dzt,      &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jpn_reminp .gt. 0)                                              &
         used = send_data(bling%id_jpn_reminp,      bling%jpn_reminp*rho_dzt,    &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jpnx_reminp .gt. 0)                                             &
         used = send_data(bling%id_jpnx_reminp,    bling%jpnx_reminp*rho_dzt,    &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jps_reminp .gt. 0)                                              &
         used = send_data(bling%id_jps_reminp,      bling%jps_reminp*rho_dzt,    &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jpsx_reminp .gt. 0)                                             &
         used = send_data(bling%id_jpsx_reminp,    bling%jpsx_reminp*rho_dzt,    &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jp_uptake .gt. 0)                                               &
         used = send_data(bling%id_jp_uptake,      bling%jp_uptake*rho_dzt,      &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jpo4 .gt. 0)                                                    &
         used = send_data(bling%id_jpo4,           bling%jpo4*rho_dzt,           &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jpofe .gt. 0)                                                   &
         used = send_data(bling%id_jpofe,          bling%jpofe*rho_dzt,          &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jpop .gt. 0)                                                    &
         used = send_data(bling%id_jpop,           bling%jpop*rho_dzt,           &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_kfe_eq_lig .gt. 0)                                              &
         used = send_data(bling%id_kfe_eq_lig,     bling%kfe_eq_lig,             &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_pc_m .gt. 0)                                                    &
         used = send_data(bling%id_pc_m,           bling%pc_m,                   &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_mu .gt. 0)                                                      &
         used = send_data(bling%id_mu,         bling%mu,                         &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_pc_tot .gt. 0)                                                  &
         used = send_data(bling%id_pc_tot,         bling%pc_tot,                 &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_theta .gt. 0)                                                   &
         used = send_data(bling%id_theta,          bling%theta,                  &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_thetamax_fe .gt. 0)                                             &
         used = send_data(bling%id_thetamax_fe,    bling%thetamax_fe,            &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_wsink .gt. 0)                                                   &
         used = send_data(bling%id_wsink,          bling%wsink,                  &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_zremin .gt. 0)                                                  &
         used = send_data(bling%id_zremin,         bling%zremin,                 &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_b_alk .gt. 0)                                                   &
         used = send_data(bling%id_b_alk,          bling%b_alk,                  &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_b_dic .gt. 0)                                                   &
         used = send_data(bling%id_b_dic,          bling%b_dic,                  &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_co2_csurf .gt. 0)                                               &
         used = send_data(bling%id_co2_csurf,      bling%co2_csurf,              &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_co2_alpha .gt. 0)                                               &
         used = send_data(bling%id_co2_alpha,      bling%co2_alpha,              &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_co3_solubility .gt. 0)                                          &
         used = send_data(bling%id_co3_solubility, bling%co3_solubility,         &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_fcaco3 .gt. 0)                                                  &
         used = send_data(bling%id_fcaco3,         bling%fcaco3,                 &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_fcaco3_to_sed .gt. 0)                                           &
         used = send_data(bling%id_fcaco3_to_sed,  bling%fcaco3_to_sed,          &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_fcased_burial .gt. 0)                                           &
         used = send_data(bling%id_fcased_burial,  bling%fcased_burial,          &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_fcased_redis .gt. 0)                                            &
         used = send_data(bling%id_fcased_redis,   bling%fcased_redis,           &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_jca_reminp .gt. 0)                                              &
         used = send_data(bling%id_jca_reminp,     bling%jca_reminp*rho_dzt,     &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jca_uptake .gt. 0)                                              &
         used = send_data(bling%id_jca_uptake,     bling%jca_uptake*rho_dzt,     &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_pco2_surf .gt. 0)                                               &
         used = send_data(bling%id_pco2_surf,      bling%pco2_surf,              &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_zremin_caco3 .gt. 0)                                            &
         used = send_data(bling%id_zremin_caco3,   bling%zremin_caco3,           &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_co2_sat_csurf .gt. 0)                                           &
         used = send_data(bling%id_co2_sat_csurf,  bling%co2_sat_csurf,          &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_pco2_sat_surf .gt. 0)                                           &
         used = send_data(bling%id_pco2_sat_surf,  bling%pco2_sat_surf,          &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_b_di14c .gt. 0)                                                 &
         used = send_data(bling%id_b_di14c,        bling%b_di14c,                &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_c14_2_p .gt. 0)                                                 &
         used = send_data(bling%id_c14_2_p,        bling%c14_2_p,                &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_c14o2_csurf .gt. 0)                                             &
         used = send_data(bling%id_c14o2_csurf,    bling%c14o2_csurf,            &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_c14o2_alpha .gt. 0)                                             &
         used = send_data(bling%id_c14o2_alpha,    bling%c14o2_alpha,            &
         model_time, rmask = grid_tmask(:,:,1),                                  & 
         is_in=isc, js_in=jsc,ie_in=iec, je_in=jec)
    if (bling%id_fpo14c .gt. 0)                                                  &
         used = send_data(bling%id_fpo14c,         bling%fpo14c,                 &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_j14c_decay_dic .gt. 0)                                          &
         used = send_data(bling%id_j14c_decay_dic, bling%j14c_decay_dic*rho_dzt, &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_j14c_decay_doc .gt. 0)                                          &
         used = send_data(bling%id_j14c_decay_doc, bling%j14c_decay_doc*rho_dzt, &
         model_time, rmask = grid_tmask,& 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_j14c_reminp .gt. 0)                                             &
         used = send_data(bling%id_j14c_reminp,    bling%j14c_reminp*rho_dzt,    &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jdi14c .gt. 0)                                                  &
         used = send_data(bling%id_jdi14c,         bling%jdi14c*rho_dzt,         &
         model_time, rmask = grid_tmask,& 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)
    if (bling%id_jdo14c .gt. 0)                                                  &
         used = send_data(bling%id_jdo14c,         bling%jdo14c*rho_dzt,         &
         model_time, rmask = grid_tmask,                                         & 
         is_in=isc, js_in=jsc, ks_in=1,ie_in=iec, je_in=jec, ke_in=nk)

  end subroutine generic_BLING_update_from_source

!#######################################################################
  ! <SUBROUTINE NAME="generic_BLING_set_boundary_values">
  !  <OVERVIEW>
  !   Calculate and set coupler values at the surface / bottom
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_BLING_set_boundary_values(tracer_list,SST,SSS,rho,ilb,jlb,tau)
  !  </TEMPLATE>
  !  <IN NAME="tracer_list" TYPE="type(g_tracer_type), pointer">
  !   Pointer to the head of generic tracer list.
  !  </IN>
  !  <IN NAME="ilb,jlb" TYPE="integer">
  !   Lower bounds of x and y extents of input arrays on data domain
  !  </IN>
  !  <IN NAME="SST" TYPE="real, dimension(ilb:,jlb:)">
  !   Sea Surface Temperature   
  !  </IN>
  !  <IN NAME="SSS" TYPE="real, dimension(ilb:,jlb:)">
  !   Sea Surface Salinity
  !  </IN>
  !  <IN NAME="rho" TYPE="real, dimension(ilb:,jlb:,:,:)">
  !   Ocean density
  !  </IN>
  !  <IN NAME="tau" TYPE="integer">
  !   Time step index of %field
  !  </IN>
  ! </SUBROUTINE>

  !User must provide the calculations for these boundary values.
  subroutine generic_BLING_set_boundary_values(tracer_list,SST,SSS,rho,ilb,jlb,tau)
    type(g_tracer_type),          pointer    :: tracer_list
    real, dimension(ilb:,jlb:),   intent(in)   :: SST, SSS 
    real, dimension(ilb:,jlb:,:,:), intent(in) :: rho
    integer,                        intent(in) :: ilb,jlb,tau

    integer :: isc,iec, jsc,jec,isd,ied,jsd,jed,nk,ntau , i, j
    real    :: sal,ST,sc_co2,sc_o2,sc_no_term,o2_saturation
    real    :: tt,tk,ts,ts2,ts3,ts4,ts5
    real, dimension(:,:,:)  ,pointer  :: grid_tmask
    real, dimension(:,:,:,:), pointer :: o2_field
    real, dimension(:,:), ALLOCATABLE :: co2_alpha,co2_csurf,o2_alpha,o2_csurf
    real, dimension(:,:), ALLOCATABLE :: co2_sat_alpha,co2_sat_csurf,c14o2_alpha,c14o2_csurf
    character(len=fm_string_len), parameter :: sub_name = 'generic_BLING_set_boundary_values'

    !Get the necessary properties
    call g_tracer_get_common(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,grid_tmask=grid_tmask) 

    call g_tracer_get_pointer(tracer_list,'o2'   ,'field',  o2_field)

    allocate(    co2_alpha(isd:ied, jsd:jed)); co2_alpha=0.0
    allocate(    co2_csurf(isd:ied, jsd:jed)); co2_csurf=0.0
    allocate(co2_sat_alpha(isd:ied, jsd:jed)); co2_sat_alpha=0.0
    allocate(co2_sat_csurf(isd:ied, jsd:jed)); co2_sat_csurf=0.0
    allocate(  c14o2_alpha(isd:ied, jsd:jed)); c14o2_alpha=0.0
    allocate(  c14o2_csurf(isd:ied, jsd:jed)); c14o2_csurf=0.0
    allocate(     o2_alpha(isd:ied, jsd:jed)); o2_alpha=0.0
    allocate(     o2_csurf(isd:ied, jsd:jed)); o2_csurf=0.0

    do j=jsc,jec ; do i=isc,iec
       !This calculation needs an input of SST and SSS
       sal = SSS(i,j) ; ST = SST(i,j)

       !nnz: 
       !Note: In the following calculations in order to get results for o2 
       !      identical with bling code in MOM bling%Rho_0 must be replaced with rho(i,j,1,tau)
       !      This is achieved by uncommenting the following if desired.
       !! bling%Rho_0 = rho(i,j,1,tau)
       !      But since bling%Rho_0 plays the role of a unit conversion factor in this module
       !      it may be safer to keep it as a constant (1035.0) rather than the actual variable
       !      surface density rho(i,j,1,tau)
       !---------------------------------------------------------------------
       !     O2
       !---------------------------------------------------------------------
       !  Compute the oxygen saturation concentration at 1 atm total
       !  pressure in mol/kg given the temperature (t, in deg C) and
       !  the salinity (s, in permil)
       !
       !  From Garcia and Gordon (1992), Limnology and Oceonography.
       !  The formula used is from page 1310, eq (8).
       !
       !  *** Note: the "a3*ts^2" term (in the paper) is incorrect. ***
       !  *** It shouldn't be there.                                ***
       !
       !  o2_saturation is defined between T(freezing) <= T <= 40 deg C and
       !                                   0 permil <= S <= 42 permil
       !
       ! check value: T = 10 deg C, S = 35 permil,
       !              o2_saturation = 0.282015 mol m-3
       !---------------------------------------------------------------------
       !
       tt = 298.15 - ST
       tk = 273.15 + ST
       ts = log(tt / tk)
       ts2 = ts  * ts
       ts3 = ts2 * ts
       ts4 = ts3 * ts
       ts5 = ts4 * ts

       o2_saturation = (1000.0/22391.6) * grid_tmask(i,j,1) *  & !convert from ml/l to mol m-3
            exp( bling%a_0 + bling%a_1*ts + bling%a_2*ts2 + bling%a_3*ts3 + bling%a_4*ts4 + bling%a_5*ts5 + &
            (bling%b_0 + bling%b_1*ts + bling%b_2*ts2 + bling%b_3*ts3 + bling%c_0*sal)*sal)

       !---------------------------------------------------------------------
       !  Compute the Schmidt number of O2 in seawater using the 
       !  formulation proposed by Keeling et al. (1998, Global Biogeochem.
       !  Cycles, 12, 141-163).
       !---------------------------------------------------------------------

       sc_o2  = bling%a1_o2  + ST * (bling%a2_o2  + ST * (bling%a3_o2  + ST * bling%a4_o2 )) * &
            grid_tmask(i,j,1)
       sc_no_term = sqrt(660.0 / (sc_o2 + epsln)) 
     
       o2_alpha(i,j) = o2_saturation       * sc_no_term
       o2_csurf(i,j) = o2_field(i,j,1,tau) * sc_no_term * bling%Rho_0 !nnz: MOM has rho(i,j,1,tau)

    enddo; enddo
    !
    !Set %csurf and %alpha for these tracers. This will mark them for sending fluxes to coupler
    !
    call g_tracer_set_values(tracer_list,'o2',   'alpha',o2_alpha, isd,jsd)
    call g_tracer_set_values(tracer_list,'o2',   'csurf',o2_csurf, isd,jsd)

    if (do_carbon) then                                !<<CARBON CYCLE
    
    call g_tracer_get_values(tracer_list,'dic','alpha', co2_alpha ,isd,jsd)
    call g_tracer_get_values(tracer_list,'dic','csurf', co2_csurf ,isd,jsd)

    do j=jsc,jec ; do i=isc,iec
       !This calculation needs an input of SST and SSS
       sal = SSS(i,j) ; ST = SST(i,j)
       !nnz: 
       !Note: In the following calculations in order to get results for co2 and o2 
       !      identical with bling code in MOM bling%Rho_0 must be replaced with rho(i,j,1,tau)
       !      This is achieved by uncommenting the following if desired.
       !! bling%Rho_0 = rho(i,j,1,tau)
       !      But since bling%Rho_0 plays the role of a unit conversion factor in this module
       !      it may be safer to keep it as a constant (1035.0) rather than the actual variable
       !      surface density rho(i,j,1,tau)
       !---------------------------------------------------------------------
       !     CO2
       !---------------------------------------------------------------------
       !---------------------------------------------------------------------
       !  Compute the Schmidt number of CO2 in seawater using the 
       !  formulation presented by Wanninkhof (1992, J. Geophys. Res., 97,
       !  7373-7382).
       !---------------------------------------------------------------------
       sc_co2 = bling%a1_co2 + ST * (bling%a2_co2 + ST * (bling%a3_co2 + ST * bling%a4_co2)) * &
            grid_tmask(i,j,1)
       sc_no_term = sqrt(660.0 / (sc_co2 + epsln)) 
       
       co2_alpha(i,j) = co2_alpha(i,j)* sc_no_term * bling%Rho_0 !nnz: MOM has rho(i,j,1,tau)  
       co2_csurf(i,j) = co2_csurf(i,j)* sc_no_term * bling%Rho_0 !nnz: MOM has rho(i,j,1,tau) 

    enddo; enddo

    call g_tracer_set_values(tracer_list,'dic','alpha',co2_alpha,isd,jsd)
    call g_tracer_set_values(tracer_list,'dic','csurf',co2_csurf,isd,jsd)


      if (do_carbon_pre) then
 
        call g_tracer_get_values(tracer_list,'dic_sat','alpha', co2_sat_alpha ,isd,jsd)
        call g_tracer_get_values(tracer_list,'dic_sat','csurf', co2_sat_csurf ,isd,jsd)

        do j=jsc,jec ; do i=isc,iec
         !---------------------------------------------------------------------
         !     CO2_sat - schmidt number is calculated same as before, and then
         ! multiplied by 50 to get the fast gas exchange.
         ! NOTE: if unstable during initial spinup, can decrease multiplier to
         ! 1x for a year, then go back to 50
         !---------------------------------------------------------------------

         sal = SSS(i,j) ; ST = SST(i,j)
         sc_co2 = bling%a1_co2 + ST * (bling%a2_co2 + ST * (bling%a3_co2 +  &
           ST * bling%a4_co2)) * grid_tmask(i,j,1)
         sc_no_term = sqrt(660.0 / (sc_co2 + epsln)) 
       
         co2_sat_alpha(i,j) = co2_sat_alpha(i,j) * sc_no_term * bling%fast_gasex * &
           bling%Rho_0 
         co2_sat_csurf(i,j) = co2_sat_csurf(i,j) * sc_no_term * bling%fast_gasex * &
           bling%Rho_0 

        enddo; enddo

        call g_tracer_set_values(tracer_list,'dic_sat','alpha',co2_sat_alpha,isd,jsd)
        call g_tracer_set_values(tracer_list,'dic_sat','csurf',co2_sat_csurf,isd,jsd)

      endif

      if (do_14c) then
      
        call g_tracer_get_values(tracer_list,'di14c','alpha', c14o2_alpha ,isd,jsd)
        call g_tracer_get_values(tracer_list,'di14c','csurf', c14o2_csurf ,isd,jsd)

        do j=jsc,jec ; do i=isc,iec
         !---------------------------------------------------------------------
         !     14CO2 - schmidt number is calculated same as before, as is alpha.
         !   Need to multiply alpha by frac_14catm to get the real alpha.
         !   NOTE: FOR NOW, D14C fixed at 0 permil!! Need to fix this later.
         !---------------------------------------------------------------------

         sal = SSS(i,j) ; ST = SST(i,j)
         sc_co2 = bling%a1_co2 + ST * (bling%a2_co2 + ST * (bling%a3_co2 +  &
           ST * bling%a4_co2)) * grid_tmask(i,j,1)
         sc_no_term = sqrt(660.0 / (sc_co2 + epsln)) 
       
         c14o2_alpha(i,j) = c14o2_alpha(i,j) * 1. * sc_no_term * bling%Rho_0 
         c14o2_csurf(i,j) = c14o2_csurf(i,j) * sc_no_term * bling%Rho_0 

        enddo; enddo

        call g_tracer_set_values(tracer_list,'di14c','alpha',c14o2_alpha,isd,jsd)
        call g_tracer_set_values(tracer_list,'di14c','csurf',c14o2_csurf,isd,jsd)

      endif
      
    endif                                                    !CARBON CYCLE>>


    deallocate(                    &
      co2_alpha,co2_csurf,         &
      co2_sat_alpha,co2_sat_csurf, &
      c14o2_alpha,c14o2_csurf,     &
      o2_alpha,o2_csurf)

  end subroutine generic_BLING_set_boundary_values

!#######################################################################
  ! <SUBROUTINE NAME="generic_BLING_end">
  !  <OVERVIEW>
  !   End the module.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Deallocate all work arrays
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_BLING_end
  !  </TEMPLATE>
  ! </SUBROUTINE>


  subroutine generic_BLING_end
    character(len=fm_string_len), parameter :: sub_name = 'generic_BLING_end'
    call user_deallocate_arrays
  end subroutine generic_BLING_end

!#######################################################################
  !
  !   This is an internal sub, not a public interface.
  !   Allocate all the work arrays to be used in this module.
  !
  subroutine user_allocate_arrays
    integer :: isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau, n

    call g_tracer_get_common(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau) 

    allocate(bling%alpha(isd:ied, jsd:jed, 1:nk));          bling%alpha=0.0
    allocate(bling%biomass_p_ts(isd:ied, jsd:jed, 1:nk));   bling%biomass_p_ts=0.0
    allocate(bling%def_fe(isd:ied, jsd:jed, 1:nk));         bling%def_fe=0.0
    allocate(bling%expkT(isd:ied, jsd:jed, 1:nk));          bling%expkT=0.0
    allocate(bling%f_biomass_p(isd:ied, jsd:jed, 1:nk));    bling%f_biomass_p=0.0
    allocate(bling%f_chl(isd:ied, jsd:jed, 1:nk));          bling%f_chl=0.0
    allocate(bling%f_dop(isd:ied, jsd:jed, 1:nk));          bling%f_dop=0.0
    allocate(bling%f_fed(isd:ied, jsd:jed, 1:nk));          bling%f_fed=0.0
    allocate(bling%f_irr_mem(isd:ied, jsd:jed, 1:nk));      bling%f_irr_mem=0.0
    allocate(bling%f_o2(isd:ied, jsd:jed, 1:nk));           bling%f_o2=0.0
    allocate(bling%f_po4(isd:ied, jsd:jed, 1:nk));          bling%f_po4=0.0
    allocate(bling%fe_2_p_uptake(isd:ied, jsd:jed, 1:nk));  bling%fe_2_p_uptake=0.0
    allocate(bling%feprime(isd:ied, jsd:jed, 1:nk));        bling%feprime=0.0
    allocate(bling%fpofe(isd:ied, jsd:jed, 1:nk));          bling%fpofe=0.0
    allocate(bling%fpop(isd:ied, jsd:jed, 1:nk));           bling%fpop=0.0
    allocate(bling%frac_lg(isd:ied, jsd:jed, 1:nk));        bling%frac_lg=0.0
    allocate(bling%frac_pop(isd:ied, jsd:jed, 1:nk));       bling%frac_pop=0.0
    allocate(bling%irr_inst(isd:ied, jsd:jed, 1:nk));       bling%irr_inst=0.0
    allocate(bling%irr_mix(isd:ied, jsd:jed, 1:nk));        bling%irr_mix=0.0
    allocate(bling%irrk(isd:ied, jsd:jed, 1:nk));           bling%irrk=0.0
    allocate(bling%jdop(isd:ied, jsd:jed, 1:nk));           bling%jdop=0.0
    allocate(bling%jfe_ads_org(isd:ied, jsd:jed, 1:nk));    bling%jfe_ads_org=0.0
    allocate(bling%jfe_ads_inorg(isd:ied, jsd:jed, 1:nk));  bling%jfe_ads_inorg=0.0
    allocate(bling%jfe_recycle(isd:ied, jsd:jed, 1:nk));    bling%jfe_recycle=0.0
    allocate(bling%jfe_reminp(isd:ied, jsd:jed, 1:nk));     bling%jfe_reminp=0.0
    allocate(bling%jfe_uptake(isd:ied, jsd:jed, 1:nk));     bling%jfe_uptake=0.0
    allocate(bling%jo2(isd:ied, jsd:jed, 1:nk));            bling%jo2=0.0
    allocate(bling%jp_recycle(isd:ied, jsd:jed, 1:nk));     bling%jp_recycle=0.0
    allocate(bling%jp_reminp(isd:ied, jsd:jed, 1:nk));      bling%jp_reminp=0.0
    allocate(bling%jp_uptake(isd:ied, jsd:jed, 1:nk));      bling%jp_uptake=0.0
    allocate(bling%jpo4(isd:ied, jsd:jed, 1:nk));           bling%jpo4=0.0
    allocate(bling%jpofe(isd:ied, jsd:jed, 1:nk));          bling%jpofe=0.0
    allocate(bling%jpop(isd:ied, jsd:jed, 1:nk));           bling%jpop=0.0
    allocate(bling%kfe_eq_lig(isd:ied, jsd:jed, 1:nk));     bling%kfe_eq_lig=0.0
    allocate(bling%pc_m(isd:ied, jsd:jed, 1:nk));           bling%pc_m=0.0
    allocate(bling%mu(isd:ied, jsd:jed, 1:nk));         bling%mu=0.0
    allocate(bling%pc_tot(isd:ied, jsd:jed, 1:nk));         bling%pc_tot=0.0
    allocate(bling%theta(isd:ied, jsd:jed, 1:nk));          bling%theta=0.0
    allocate(bling%thetamax_fe(isd:ied, jsd:jed, 1:nk));    bling%thetamax_fe=0.0
    allocate(bling%wsink(isd:ied, jsd:jed, 1:nk));          bling%wsink=0.0
    allocate(bling%zremin(isd:ied, jsd:jed, 1:nk));         bling%zremin=0.0
    allocate(bling%zt(isd:ied, jsd:jed, 1:nk));             bling%zt=0.0
    allocate(bling%fe_burial    (isd:ied, jsd:jed));        bling%fe_burial=0.0
    allocate(bling%ffe_sed      (isd:ied, jsd:jed));        bling%ffe_sed=0.0
    allocate(bling%b_fed        (isd:ied, jsd:jed));        bling%b_fed=0.0
    allocate(bling%b_o2         (isd:ied, jsd:jed));        bling%b_o2=0.0
    allocate(bling%b_po4        (isd:ied, jsd:jed));        bling%b_po4=0.0

    if (do_po4_pre) then                                          !<<PO4_PRE
    allocate(bling%f_po4_pre(isd:ied, jsd:jed, 1:nk));      bling%f_po4_pre=0.0
    endif                                                         !PO4_PRE>>

    if (do_carbon) then                                      !<<CARBON CYCLE
    !Used in ocmip2_co2calc
    CO2_dope_vec%isc = isc ; CO2_dope_vec%iec = iec 
    CO2_dope_vec%jsc = jsc ; CO2_dope_vec%jec = jec
    CO2_dope_vec%isd = isd ; CO2_dope_vec%ied = ied
    CO2_dope_vec%jsd = jsd ; CO2_dope_vec%jed = jed    
    allocate(bling%htotallo(isd:ied, jsd:jed))
    allocate(bling%htotalhi(isd:ied, jsd:jed))
    allocate(bling%co3_solubility(isd:ied, jsd:jed, 1:nk)); bling%co3_solubility=0.0
    allocate(bling%f_alk(isd:ied, jsd:jed, 1:nk));          bling%f_alk=0.0
    allocate(bling%f_co3_ion(isd:ied, jsd:jed, 1:nk));      bling%f_co3_ion=0.0
    allocate(bling%f_dic(isd:ied, jsd:jed, 1:nk));          bling%f_dic=0.0
    allocate(bling%f_htotal(isd:ied, jsd:jed, 1:nk));       bling%f_htotal=0.0
    allocate(bling%fcaco3(isd:ied, jsd:jed, 1:nk));         bling%fcaco3=0.0
    allocate(bling%jca_reminp(isd:ied, jsd:jed, 1:nk));     bling%jca_reminp=0.0
    allocate(bling%jca_uptake(isd:ied, jsd:jed, 1:nk));     bling%jca_uptake=0.0
    allocate(bling%zremin_caco3(isd:ied, jsd:jed, 1:nk));   bling%zremin_caco3=0.0
    allocate(bling%co2_csurf    (isd:ied, jsd:jed));        bling%co2_csurf=0.0
    allocate(bling%pco2_surf    (isd:ied, jsd:jed));        bling%pco2_surf=0.0
    allocate(bling%co2_alpha    (isd:ied, jsd:jed));        bling%co2_alpha=0.0
    allocate(bling%fcaco3_to_sed(isd:ied, jsd:jed));        bling%fcaco3_to_sed=0.0
    allocate(bling%b_alk        (isd:ied, jsd:jed));        bling%b_alk=0.0
    allocate(bling%b_dic        (isd:ied, jsd:jed));        bling%b_dic=0.0
      if (bury_caco3) then                                     !<<BURY CACO3  
    allocate(bling%f_cased(isd:ied, jsd:jed, 1:nk));        bling%f_cased=0.0
    allocate(bling%fcased_burial(isd:ied, jsd:jed));        bling%fcased_burial=0.0
    allocate(bling%fcased_redis (isd:ied, jsd:jed));        bling%fcased_redis=0.0
      endif                                                    !BURY CACO3>>
      if (do_carbon_pre) then                                     !<<DIC_PRE  
    allocate(bling%htotal_satlo(isd:ied, jsd:jed))
    allocate(bling%htotal_sathi(isd:ied, jsd:jed))
    allocate(bling%f_alk_pre(isd:ied, jsd:jed, 1:nk));      bling%f_alk_pre=0.0
    allocate(bling%f_dic_pre(isd:ied, jsd:jed, 1:nk));      bling%f_dic_pre=0.0
    allocate(bling%f_dic_sat(isd:ied, jsd:jed, 1:nk));      bling%f_dic_sat=0.0
    allocate(bling%f_htotal_sat(isd:ied, jsd:jed, 1:nk));   bling%f_htotal_sat=0.0
    allocate(bling%co2_sat_csurf(isd:ied, jsd:jed));        bling%co2_sat_csurf=0.0
    allocate(bling%pco2_sat_surf(isd:ied, jsd:jed));        bling%pco2_sat_surf=0.0
      endif                                                       !DIC_PRE>>
      if (do_14c) then                                        !<<RADIOCARBON
    allocate(bling%c14_2_p(isd:ied, jsd:jed, 1:nk));        bling%c14_2_p=0.0
    allocate(bling%f_di14c(isd:ied, jsd:jed, 1:nk));        bling%f_di14c=0.0
    allocate(bling%f_do14c(isd:ied, jsd:jed, 1:nk));        bling%f_do14c=0.0
    allocate(bling%fpo14c(isd:ied, jsd:jed, 1:nk));         bling%fpo14c=0.0
    allocate(bling%j14c_decay_dic(isd:ied, jsd:jed, 1:nk)); bling%j14c_decay_dic=0.0
    allocate(bling%j14c_decay_doc(isd:ied, jsd:jed, 1:nk)); bling%j14c_decay_doc=0.0
    allocate(bling%j14c_reminp(isd:ied, jsd:jed, 1:nk));    bling%j14c_reminp=0.0
    allocate(bling%jdi14c(isd:ied, jsd:jed, 1:nk));         bling%jdi14c=0.0
    allocate(bling%jdo14c(isd:ied, jsd:jed, 1:nk));         bling%jdo14c=0.0
    allocate(bling%c14o2_csurf  (isd:ied, jsd:jed));        bling%c14o2_csurf=0.0
    allocate(bling%c14o2_alpha  (isd:ied, jsd:jed));        bling%c14o2_alpha=0.0
    allocate(bling%b_di14c      (isd:ied, jsd:jed));        bling%b_di14c=0.0
      endif                                                   !RADIOCARBON>>
    endif                                                    !CARBON CYCLE>>

  end subroutine user_allocate_arrays

!#######################################################################
  !
  !   This is an internal sub, not a public interface.
  !   Deallocate all the work arrays allocated by user_allocate_arrays.
  !
  subroutine user_deallocate_arrays

    deallocate(&
         bling%alpha,&
         bling%biomass_p_ts,&
         bling%def_fe,&
         bling%expkT,&
         bling%f_biomass_p,&
         bling%f_chl,&
         bling%f_dop,&
         bling%f_fed,&
         bling%f_irr_mem,&
         bling%f_o2,&
         bling%f_po4,&
         bling%fe_2_p_uptake,&
         bling%feprime,&
         bling%fpofe,&
         bling%fpop,&
         bling%frac_lg,&
         bling%frac_pop,&
         bling%irr_inst,&
         bling%irr_mix,&
         bling%irrk,&
         bling%jdop,&
         bling%jfe_ads_inorg,&
         bling%jfe_ads_org,&
         bling%jfe_recycle,&
         bling%jfe_reminp,&
         bling%jfe_uptake,&
         bling%jo2,&
         bling%jp_recycle,&
         bling%jp_reminp,&
         bling%jp_uptake,&
         bling%jpo4,&
         bling%jpofe,&
         bling%jpop,&
         bling%kfe_eq_lig,&
         bling%pc_m,&
         bling%mu,&
         bling%pc_tot,&
         bling%theta,&
         bling%thetamax_fe,&
         bling%wsink,&
         bling%zremin,&
         bling%zt,&
         bling%fe_burial,&
         bling%ffe_sed,&
         bling%b_fed,&
         bling%b_o2,&
         bling%b_po4 )

    if (do_po4_pre) then                                          !<<PO4_PRE
    deallocate(&
         bling%f_po4_pre )
    endif                                                         !PO4_PRE>>

    if (do_carbon) then                                      !<<CARBON CYCLE
    deallocate(&
         bling%f_alk,&
         bling%co3_solubility,&
         bling%f_co3_ion,&
         bling%f_dic,&
         bling%f_htotal,&
         bling%fcaco3,&
         bling%jca_reminp,&
         bling%jca_uptake,&
         bling%zremin_caco3,&
         bling%co2_csurf,&
         bling%pco2_surf,&
         bling%co2_alpha,&
         bling%htotallo,&
         bling%htotalhi,&
         bling%fcaco3_to_sed,&
         bling%b_alk,&
         bling%b_dic )
      if (bury_caco3) then                                     !<<BURY CACO3  
      deallocate(&
           bling%f_cased,&
           bling%fcased_burial,&
           bling%fcased_redis )
      endif                                                    !BURY CACO3>>
      if (do_carbon_pre) then                                     !<<DIC_PRE  
      deallocate(&
           bling%f_alk_pre,&
           bling%f_dic_pre,&
           bling%f_dic_sat,&
           bling%f_htotal_sat,&
           bling%co2_sat_csurf,&
           bling%pco2_sat_surf,&
           bling%htotal_satlo,&
           bling%htotal_sathi )
      endif                                                       !DIC_PRE>>
      if (do_14c) then                                        !<<RADIOCARBON
      deallocate(&
           bling%c14_2_p,&
           bling%f_di14c,&
           bling%f_do14c,&
           bling%fpo14c,&
           bling%j14c_decay_dic,&
           bling%j14c_decay_doc,&
           bling%j14c_reminp,&
           bling%jdi14c,&
           bling%jdo14c,&
           bling%c14o2_alpha,&
           bling%c14o2_csurf,&
           bling%b_di14c )
      endif                                                   !RADIOCARBON>>
    endif                                                    !CARBON CYCLE>>

  end subroutine user_deallocate_arrays


end module generic_BLING

module vert_diff_driver_mod

!-----------------------------------------------------------------------
!   module performs vertical diffusion of atmospheric variables
!-----------------------------------------------------------------------

use    vert_diff_mod, only:  surf_diff_type,     &
                             vert_diff_init, &
                             gcm_vert_diff_down, &
                             gcm_vert_diff_up,   &
                             vert_diff_end


use diag_manager_mod, only:  register_diag_field, send_data

use time_manager_mod, only:  time_type

use          mpp_mod, only:  input_nml_file
use          fms_mod, only:  file_exist, open_namelist_file, error_mesg,  &
                             check_nml_error, FATAL, mpp_pe, mpp_root_pe, &
                             close_file, write_version_number, stdlog

use    constants_mod, only:  CP_AIR, GRAV

use   field_manager_mod, only: MODEL_ATMOS
use  tracer_manager_mod, only: get_number_tracers, get_tracer_names, &
                               NO_TRACER

!-----------------------------------------------------------------------

implicit none
private

public :: vert_diff_driver_down, vert_diff_driver_up,  &
          vert_diff_driver_init, vert_diff_driver_end
public :: surf_diff_type


!-----------------------------------------------------------------------
!---- namelist ----

logical :: do_conserve_energy         = .false.
logical :: do_mcm_no_neg_q            = .false.
logical :: use_virtual_temp_vert_diff = .true.
logical :: do_mcm_plev                = .false.
logical :: do_mcm_vert_diff_tq        = .false.

namelist /vert_diff_driver_nml/ do_conserve_energy,         &
                                do_mcm_no_neg_q,            &
                                use_virtual_temp_vert_diff, &
                                do_mcm_plev, do_mcm_vert_diff_tq

!-----------------------------------------------------------------------
! tracer storage is used 
type :: tracer_storage_type
   integer :: id_tr_dt     = 0 ! diag id of the tracer tendency due 
                               ! to vert diff
   integer :: id_tr_dt_int = 0 ! diag id of the vertically-integrated 
                               ! tracer tendency
   real, pointer :: &
        buffer(:,:,:) => NULL() ! buffer for tendency calculations
end type
type(tracer_storage_type), allocatable :: tr_store(:)

real, allocatable, dimension(:,:,:) :: dt_t_save, dt_q_save

!-------------------- diagnostics fields -------------------------------

integer :: id_tdt_vdif, id_qdt_vdif, id_udt_vdif, id_vdt_vdif,  &
           id_sens_vdif, id_evap_vdif,                          &
           id_tdt_diss_vdif, id_diss_heat_vdif

real :: missing_value = -999.

character(len=9), parameter :: mod_name = 'vert_diff'

!-----------------------------------------------------------------------
!---- version number ----

character(len=128) :: version = '$Id: vert_diff_driver.F90,v 20.0 2013/12/13 23:22:29 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

logical :: module_is_initialized = .false.


contains

!#######################################################################

 subroutine vert_diff_driver_down (is, js, Time, delt, p_half, p_full, &
                                   z_full, diff_mom, diff_heat,        &
                                   u, v, t, q, trs,                    &
                                   dtau_du, dtau_dv, tau_x, tau_y,     &
                                   dt_u, dt_v, dt_t, dt_q, dt_trs,     &
                                   Surf_diff, diff_t_clubb, mask, kbot ) !cjg

integer, intent(in)                     :: is, js
type(time_type),   intent(in)           :: Time
real, intent(in)                        :: delt
real, intent(in)   , dimension(:,:,:)   :: p_half, p_full, z_full,  &
                                           diff_mom, diff_heat
real, intent(in),    dimension(:,:,:)   :: u, v, t, q
real, intent(in),    dimension(:,:,:,:) :: trs
real, intent(in),    dimension(:,:)     :: dtau_du, dtau_dv

real, intent(inout), dimension(:,:)     :: tau_x, tau_y
real, intent(inout), dimension(:,:,:)   :: dt_u, dt_v, dt_t, dt_q
real, intent(inout), dimension(:,:,:,:) :: dt_trs

type(surf_diff_type), intent(inout)     :: Surf_diff

!-->cjg
real, intent(in)   , dimension(:,:,:), optional :: diff_t_clubb
!<--cjg
real   , intent(in), dimension(:,:,:), optional :: mask
integer, intent(in), dimension(:,:),   optional :: kbot

real, dimension(size(t,1),size(t,2),size(t,3)) :: tt, dpg, q_2
real, dimension(size(t,1),size(t,2),size(t,3)) :: dissipative_heat
integer :: k, ntp, tr
logical :: used
real, dimension(size(t,1),size(t,2)) :: diag2
integer :: ie, je

!-----------------------------------------------------------------------

  if (.not. module_is_initialized) call error_mesg       &
                  ('vert_diff_driver_mod',  &
                   'vert_diff_driver_init must be called first', FATAL)

!-----------------------------------------------------------------------

  ntp = size(dt_trs,4) ! number of prognostic tracers
  if (size(trs,4) < ntp) call error_mesg ('vert_diff_driver', &
             'Number of tracers .lt. number of tracer tendencies',FATAL)

  ie = is + size(t,1) -1
  je = js + size(t,2) -1


    if(do_mcm_vert_diff_tq) then
      dt_t_save(is:ie,js:je,:) = dt_t
      dt_q_save(is:ie,js:je,:) = dt_q
      dt_t = 0.0
      dt_q = 0.0
    endif

!-----------------------------------------------------------------------
!---- to do diagnostics on dt_t, dt_q, dt_u, and dt_v at this point add 
!-----in the negative value of the field.  Note that the multiplication
!---- by 2 is necessary to get the correct value because sum_diag_phys
!---- is called twice for this single field
!-----------------------------------------------------------------------




!------- diagnostics for uwnd_diff -------
    if ( id_udt_vdif > 0 ) then
       used = send_data ( id_udt_vdif, -2.*dt_u, Time, is, js, 1, &
                          rmask=mask )
    endif

!------- diagnostics for vwnd_diff -------
    if ( id_vdt_vdif > 0 ) then
       used = send_data ( id_vdt_vdif, -2.*dt_v, Time, is, js, 1, &
                          rmask=mask )
    endif


!------- diagnostics for dt/dt_diff -------
    if ( id_tdt_vdif > 0 ) then
       used = send_data ( id_tdt_vdif, -3.*dt_t, Time, is, js, 1, &
                           rmask=mask )
    endif
    
!------- diagnostics for dq/dt_diff -------
    if ( id_qdt_vdif > 0 ) then
       used = send_data ( id_qdt_vdif, -2.*dt_q, Time, is, js, 1, &
                          rmask=mask )
    endif

    ! store values of tracer tendencies before the vertical diffusion, if 
    ! requested -- availability of storage serves as an indicatior that 
    ! storing is necessary
    do tr = 1,size(tr_store(:))
       if( associated(tr_store(tr)%buffer) ) &
            tr_store(tr)%buffer(is:ie,js:je,:) = dt_trs(:,:,:,tr)
    enddo

!-----------------------------------------------------------------------
!---- local temperature ----
!     (avoids divid by zero when computing virtual temp)

   tt = t
   if (present(mask)) where (mask < 0.5) tt = 200.

!-----------------------------------------------------------------------
!---- momentum diffusion ----
!---- heat/moisture diffusion (down only) ----
!---- tracer diffusion (no surface flux) ----

 q_2 = q
 if (do_mcm_no_neg_q) then
   where (q_2 < 0.0)  q_2 = 0.0
 endif

!--> cjg
 call gcm_vert_diff_down (is, js, delt, u, v, tt, q_2, trs(:,:,:,1:ntp), &
                          diff_mom, diff_heat,                           &
                          p_half, p_full, z_full,                        &
                          tau_x, tau_y, dtau_du, dtau_dv,                &
                          dt_u, dt_v, dt_t, dt_q, dt_trs(:,:,:,1:ntp),   &
                          dissipative_heat, Surf_diff,  diff_t_clubb, kbot ) !cjg
!<--cjg

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!---- to do diagnostics on dt_u, and dt_v at this point add 
!-----in the value of the field.  Note that the multiplication
!---- by 2 is necessary to get the correct value because sum_diag_phys
!---- is called twice for this single field
!-----------------------------------------------------------------------

!------ preliminary calculations for vert integrals -----
    if ( id_sens_vdif > 0 .or. id_evap_vdif > 0 .or. id_diss_heat_vdif > 0 ) then
            do k = 1, size(p_half,3)-1
               dpg(:,:,k) = (p_half(:,:,k+1)-p_half(:,:,k))/GRAV
            enddo
            if (present(mask)) dpg = dpg*mask
    endif
    

!------- diagnostics for sens_diff -------
    if ( id_sens_vdif > 0 ) then
!         --- compute column changes ---
          diag2 = sum( dt_t*dpg, 3 )
          used = send_data ( id_sens_vdif, -2.*CP_AIR*diag2, Time, is, js )
    endif

!------- diagnostics for evap_diff -------
    if ( id_evap_vdif > 0 ) then
!         --- compute column changes ---
          diag2 = sum( dt_q*dpg, 3 )
          used = send_data ( id_evap_vdif, -2.*diag2, Time, is, js )
    endif
    
    

!------- diagnostics for uwnd_diff -------
    if ( id_udt_vdif > 0 ) then
       used = send_data ( id_udt_vdif, 2.*dt_u, Time, is, js, 1, &
                          rmask=mask )
    endif

!------- diagnostics for vwnd_diff -------
    if ( id_vdt_vdif > 0 ) then
       used = send_data ( id_vdt_vdif, 2.*dt_v, Time, is, js, 1, &
                          rmask=mask )
    endif
    
!------- diagnostics for dissipative heating -------
    if ( id_tdt_diss_vdif > 0 ) then
       used = send_data ( id_tdt_diss_vdif, dissipative_heat, Time, &
                          is, js, 1, &
                          rmask=mask)
    endif

!------- diagnostics for dt/dt_diff -------
    if ( id_tdt_vdif > 0 ) then
       used = send_data ( id_tdt_vdif, -3.*dissipative_heat, Time, is, js, 1, &
                           rmask=mask )
    endif

!------- diagnostics for vertically integrated dissipative heating -------
    if ( id_diss_heat_vdif > 0 ) then
          diag2 = sum( CP_AIR*dissipative_heat*dpg, 3 )
          used = send_data ( id_diss_heat_vdif, diag2, Time, is, js )
    endif

!-----------------------------------------------------------------------

 end subroutine vert_diff_driver_down

!#######################################################################

 subroutine vert_diff_driver_up (is, js, Time, delt, p_half, &
                                 Surf_diff, dt_t, dt_q, dt_tr, mask, kbot)

 integer,           intent(in)            :: is, js
 type(time_type),   intent(in)            :: Time
 real,    intent(in)                      :: delt
 real,    intent(in),    dimension(:,:,:) :: p_half
 type(surf_diff_type),   intent(in)       :: Surf_diff
 real,    intent(inout), dimension(:,:,:) :: dt_t, dt_q
 real,    intent(inout), dimension(:,:,:,:) :: dt_tr
 real   , intent(in), dimension(:,:,:), optional :: mask
 integer, intent(in),    dimension(:,:), optional :: kbot

 integer :: k, tr
 logical :: used
 real, dimension(size(p_half,1),size(p_half,2),size(p_half,3)-1) :: dpg
 real, dimension(size(p_half,1),size(p_half,2)) :: diag2
 integer :: ie, je

!-----------------------------------------------------------------------
    ie = is + size(p_half,1) -1
    je = js + size(p_half,2) -1
!-----------------------------------------------------------------------

    call gcm_vert_diff_up (is, js, delt, Surf_diff, dt_t, dt_q, dt_tr, kbot)


!-----------------------------------------------------------------------
!---- to do diagnostics on dt_t and dt_q at this point add in the
!---- the postive value of the field.  Note that the multiplication
!---- by 2 is necessary to get the correct value because sum_diag_phys
!---- is called twice for this single field
!-----------------------------------------------------------------------
!------- diagnostics for dt/dt_diff -------

    if ( id_tdt_vdif > 0 ) then
       used = send_data ( id_tdt_vdif, 3.*dt_t, Time, is, js, 1, &
                          rmask=mask )
    endif

!------- diagnostics for dq/dt_diff -------
    if ( id_qdt_vdif > 0 ) then
       used = send_data ( id_qdt_vdif, 2.*dt_q, Time, is, js, 1, &
                          rmask=mask )
    endif

!------ preliminary calculations for vert integrals -----
    if ( id_sens_vdif > 0 .or. id_evap_vdif > 0 ) then
            do k = 1, size(p_half,3)-1
               dpg(:,:,k) = (p_half(:,:,k+1)-p_half(:,:,k))/GRAV
            enddo
            if (present(mask)) dpg = dpg*mask
    endif

!------- diagnostics for sens_diff -------
    if ( id_sens_vdif > 0 ) then
!         --- compute column changes ---
          diag2 = sum( dt_t*dpg, 3 )
          used = send_data ( id_sens_vdif, 2.*CP_AIR*diag2, Time, is, js )
    endif

!------- diagnostics for evap_diff -------
    if ( id_evap_vdif > 0 ) then
!         --- compute column changes ---
          diag2 = sum( dt_q*dpg, 3 )
          used = send_data ( id_evap_vdif, 2.*diag2, Time, is, js )
    endif

!------- diagnostics of tracer tendencies ------- 
    do tr = 1, size(tr_store(:))
       if(tr_store(tr)%id_tr_dt > 0) then
          used = send_data(tr_store(tr)%id_tr_dt, &
               dt_tr(:,:,:,tr)-tr_store(tr)%buffer(is:ie,js:je,:),Time,is,js)
       endif
       
       if(tr_store(tr)%id_tr_dt_int > 0) then
          diag2 = sum((dt_tr(:,:,:,tr)-tr_store(tr)%buffer(is:ie,js:je,:))*dpg,3)
          used = send_data(tr_store(tr)%id_tr_dt_int, diag2, Time, is, js)
       endif
    enddo

    if(do_mcm_vert_diff_tq) then
      dt_t = dt_t + dt_t_save(is:ie,js:je,:)
      dt_q = dt_q + dt_q_save(is:ie,js:je,:)
    endif

!-----------------------------------------------------------------------

 end subroutine vert_diff_driver_up

!#######################################################################

 subroutine vert_diff_driver_init ( Surf_diff, idim, jdim, kdim,  &
                                    axes, Time, do_clubb )  !cjg

 type(surf_diff_type), intent(inout) :: Surf_diff
 integer             , intent(in)    :: idim, jdim, kdim, axes(4)
 type(time_type)     , intent(in)    :: Time
!-->cjg
 integer, intent(in)                 :: do_clubb
!<--cjg

 integer :: unit, io, ierr, tr, logunit
 integer :: ntprog ! number of prognostic tracers in the atmosphere
 character(len=32)  :: name, units ! name of the tracer
 character(len=128) :: longname    ! long name of the tracer

!-----------------------------------------------------------------------
!------ read namelist ------

#ifdef INTERNAL_FILE_NML
   read (input_nml_file, nml=vert_diff_driver_nml, iostat=io)
   ierr = check_nml_error(io,'vert_diff_driver_nml')
#else   
   if ( file_exist('input.nml')) then
      unit = open_namelist_file ()
      ierr=1; do while (ierr /= 0)
         read  (unit, nml=vert_diff_driver_nml, iostat=io, end=10)
         ierr = check_nml_error(io,'vert_diff_driver_nml')
      enddo
 10   call close_file (unit)
   endif
#endif

!--------- write version number and namelist ------------------

   call write_version_number(version, tagname)
   logunit = stdlog()
   if(mpp_pe() == mpp_root_pe() ) write(logunit,nml=vert_diff_driver_nml)

!-------- initialize gcm vertical diffusion ------

   call vert_diff_init (Surf_diff, idim, jdim, kdim, do_conserve_energy, &
                        use_virtual_temp_vert_diff, do_mcm_plev, do_clubb) !cjg

!-----------------------------------------------------------------------

   if(do_mcm_vert_diff_tq) then
     allocate(dt_t_save(idim,jdim,kdim)) ; dt_t_save = 0.0
     allocate(dt_q_save(idim,jdim,kdim)) ; dt_q_save = 0.0
   endif

!--------------- initialize diagnostic fields --------------------

   id_tdt_vdif = &
   register_diag_field ( mod_name, 'tdt_vdif', axes(1:3), Time, &
                        'Temperature tendency from vert diff',  &
                        'deg_K/s', missing_value=missing_value  )

   id_qdt_vdif = &
   register_diag_field ( mod_name, 'qdt_vdif', axes(1:3), Time, &
                        'Spec humidity tendency from vert diff',&
                        'kg/kg/s', missing_value=missing_value  )

   id_udt_vdif = &
   register_diag_field ( mod_name, 'udt_vdif', axes(1:3), Time, &
                        'Zonal wind tendency from vert diff',   &
                        'm/s2', missing_value=missing_value     )

   id_vdt_vdif = &
   register_diag_field ( mod_name, 'vdt_vdif', axes(1:3), Time,    &
                        'Meridional wind tendency from vert diff', &
                        'm/s2', missing_value=missing_value        )

   id_sens_vdif = &
   register_diag_field ( mod_name, 'sens_vdif', axes(1:2), Time,  &
                        'Integrated heat flux from vert diff',    &
                        'W/m2' )

   id_evap_vdif = &
   register_diag_field ( mod_name, 'evap_vdif', axes(1:2), Time,    &
                        'Integrated moisture flux from vert diff',  &
                        'kg/m2/s' )

   id_tdt_diss_vdif = &
   register_diag_field ( mod_name, 'tdt_diss_vdif', axes(1:3), Time,  &
                        'Dissipative heating from vert_diff', 'deg_K/s', &
                         missing_value=missing_value  ) 

   id_diss_heat_vdif = &
   register_diag_field ( mod_name, 'diss_heat_vdif', axes(1:2), Time,  &
                        'Integrated dissipative heating from vert diff',  &
                        'W/m2' )

   ! initialize diagnostics tracers
   call get_number_tracers(MODEL_ATMOS, num_prog=ntprog)
   allocate(tr_store(ntprog))
   do tr = 1,ntprog
      call get_tracer_names( MODEL_ATMOS, tr, name, longname, units )
      tr_store(tr)%id_tr_dt = &
        register_diag_field ( mod_name, trim(name)//'dt_vdif', axes(1:3), Time, &
           'Tendency of '//trim(longname)//' from vert diff', trim(units)//'/s')
      tr_store(tr)%id_tr_dt_int = &
        register_diag_field ( mod_name, trim(name)//'dt_vint_vdif', axes(1:2), Time, &
           'Integrated tendency of '//trim(longname)//' from vert diff',&
           trim(units)//' kg/(m2 s)')

      if(tr_store(tr)%id_tr_dt>0 .or.tr_store(tr)%id_tr_dt_int>0 ) &
           allocate(tr_store(tr)%buffer(idim,jdim,kdim))
   enddo

!-----------------------------------------------------------------------

   module_is_initialized = .true.

!-----------------------------------------------------------------------

 end subroutine vert_diff_driver_init

!#######################################################################

 subroutine vert_diff_driver_end

   integer :: tr ! tracer index

   call vert_diff_end
   if(do_mcm_vert_diff_tq) deallocate(dt_t_save, dt_q_save)
   ! deallocate tracer diagnostics storage
   do tr = 1,size(tr_store(:))
      if(associated(tr_store(tr)%buffer)) &
           deallocate(tr_store(tr)%buffer)
   enddo
   deallocate(tr_store)

!-----------------------------------------------------------------------

   module_is_initialized = .false.

!-----------------------------------------------------------------------
 end subroutine vert_diff_driver_end

!#######################################################################

end module vert_diff_driver_mod

module atmos_radon_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   William Cooke
! </CONTACT>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Larry Horowitz
! </REVIEWER>


! <OVERVIEW>
!     This code allows the implementation of an extremely simplified 
!     radon tracer in the FMS framework.
!
!    It should be taken as the implementation of a very simple tracer 
!   which bears some characteristics of radon.
! </OVERVIEW>

! <DESCRIPTION>
!   This module presents an implementation of a tracer.
!   It should be taken as representing radon only in a rudimentary manner.
! </DESCRIPTION>

!-----------------------------------------------------------------------

use              fms_mod, only : file_exist, &
                                 write_version_number, &
                                 mpp_pe, &
                                 mpp_root_pe, &
                                 error_mesg, &
                                 FATAL,WARNING, NOTE, &
                                 stdlog
use     time_manager_mod, only : time_type
use     diag_manager_mod, only : send_data,            &
                                 register_static_field
use   tracer_manager_mod, only : get_tracer_index
use    field_manager_mod, only : MODEL_ATMOS
use atmos_tracer_utilities_mod, only : wet_deposition,       &
                                 dry_deposition


implicit none
private
!-----------------------------------------------------------------------
!----- interfaces -------

public  atmos_radon_sourcesink, atmos_radon_init, atmos_radon_end

!-----------------------------------------------------------------------
!----------- namelist -------------------
!-----------------------------------------------------------------------
integer  :: ncopies_radon = 9
 
namelist /atmos_radon_nml/  &
                            ncopies_radon


!--- Arrays to help calculate tracer sources/sinks ---

character(len=6), parameter :: module_name = 'tracer'

!--- identification numbers for  diagnostic fields and axes ----

integer :: id_emiss

logical :: module_is_initialized=.FALSE.


!---- version number -----
character(len=128) :: version = '$Id: atmos_radon.F90,v 19.0 2012/01/06 20:30:50 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
!-----------------------------------------------------------------------

contains


!#######################################################################
!<SUBROUTINE NAME="atmos_radon_sourcesink">
!<OVERVIEW>
! The routine that calculate the sources and sinks of radon.
!</OVERVIEW>
!<DESCRIPTION>
! This is a very rudimentary implementation of radon.
!
! It is assumed that the Rn222 flux is 3.69e-21 kg/m*m/sec over land 
! for latitudes < 60N
!
!   Between 60N and 70N the source  = source * .5
!
!  Rn222 has a half-life time of 3.83 days, which corresponds to an 
!  e-folding time of 5.52 days.
!
!</DESCRIPTION>
!<TEMPLATE>
!call atmos_radon_sourcesink (lon, lat, land, pwt, radon, radon_dt, 
!                              Time, kbot)
!</TEMPLATE>
!   <IN NAME="lon" TYPE="real" DIM="(:,:)">
!     Longitude of the centre of the model gridcells
!   </IN>
!   <IN NAME="lat" TYPE="real" DIM="(:,:)">
!     Latitude of the centre of the model gridcells
!   </IN>
!   <IN NAME="land" TYPE="real" DIM="(:,:)">
!     Land/sea mask.
!   </IN>
!   <IN NAME="pwt" TYPE="real" DIM="(:,:,:)">
!     The pressure weighting array. = dP/grav
!   </IN>
!   <IN NAME="radon" TYPE="real" DIM="(:,:,:)">
!     The array of the radon mixing ratio.
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="kbot" TYPE="integer, optional" DIM="(:,:)">
!     Integer array describing which model layer intercepts the surface.
!   </IN>

!   <OUT NAME="radon_dt" TYPE="real" DIM="(:,:,:)">
!     The array of the tendency of the radon mixing ratio.
!   </OUT>
 subroutine atmos_radon_sourcesink (lon, lat, land, pwt, radon, radon_dt,  &
                              Time, kbot)

!-----------------------------------------------------------------------
   real, intent(in),  dimension(:,:)   :: lon, lat
   real, intent(in),  dimension(:,:)   :: land
   real, intent(in),  dimension(:,:,:) :: pwt, radon
   real, intent(out), dimension(:,:,:) :: radon_dt
     type(time_type), intent(in) :: Time     
integer, intent(in),  dimension(:,:), optional :: kbot
!-----------------------------------------------------------------------
   real, dimension(size(radon,1),size(radon,2),size(radon,3)) ::  &
         source, sink
logical, dimension(size(radon,1),size(radon,2)) ::  maskeq,masknh
   real  radon_flux, dtr, deg60, deg70, deg300, deg336
integer  i,j,kb,id,jd,kd
!-----------------------------------------------------------------------

      id=size(radon,1); jd=size(radon,2); kd=size(radon,3)

      dtr=acos(0.0)/90.
      deg60=60.*dtr; deg70=70.*dtr; deg300=300.*dtr; deg336=336.*dtr

!----------- compute radon source ------------
!
!  rn222 flux is 3.69e-21 kg/m*m/sec over land for latitudes lt 60n
!   between 60n and 70n the source  = source * .5
!
!  molecular wt. of air is 28.9644 gm/mole
!  molecular wt. of radon is 222 gm/mole
!  scaling facter to get reasonable mixing ratio is 1.e+21
!
!  source = 3.69e-21 * g * 28.9644 * 1.e+21/(pwt * 222.) or
!
!  source = g * .4814353 / pwt
!
!  must initialize all rn to .001
!

      radon_flux = 3.69e-21 * 28.9644 * 1.e+21 / 222.
      source = 0.0
      maskeq = (land > 0.5) .and. lat > -deg60 .and. lat < deg60
      masknh = (land > 0.5) .and. lat >= deg60 .and. lat < deg70

      if (present(kbot)) then
          do j=1,jd
          do i=1,id
             kb=kbot(i,j)
             if (maskeq(i,j)) source(i,j,kb)=radon_flux/pwt(i,j,kb)
             if (masknh(i,j)) source(i,j,kb)=0.5*radon_flux/pwt(i,j,kb)
          enddo
          enddo
      else
          where (maskeq) source(:,:,kd)=radon_flux/pwt(:,:,kd)
          where (masknh) source(:,:,kd)=0.5*radon_flux/pwt(:,:,kd)
          where (masknh .and. lon > deg300 .and. lon < deg336)  &
               source(:,:,kd)=0.0
      endif


!------- compute radon sink --------------
!
!  rn222 has a half-life time of 3.83days 
!   (corresponds to an e-folding time of 5.52 days)
!
!  sink = 1./(86400.*5.52) = 2.09675e-6
!

    where (radon(:,:,:) >= 0.0)
       sink(:,:,:) = -2.09675e-6*radon(:,:,:)
    elsewhere
       sink(:,:,:) = 0.0
    endwhere

!------- tendency ------------------

      radon_dt=source+sink
      

!-----------------------------------------------------------------------

 end subroutine atmos_radon_sourcesink
!</SUBROUTINE>

!#######################################################################

!<SUBROUTINE NAME="atmos_radon_init">
!<OVERVIEW>
! The constructor routine for the radon module.
!</OVERVIEW>
!<DESCRIPTION>
! A routine to initialize the radon module.
!</DESCRIPTION>
!<TEMPLATE>
!call radon_init (r, mask, axes, Time)
!</TEMPLATE>
!   <INOUT NAME="r" TYPE="real" DIM="(:,:,:,:)">
!     Tracer fields dimensioned as (nlon,nlat,nlev,ntrace). 
!   </INOUT>
!   <IN NAME="mask" TYPE="real, optional" DIM="(:,:,:)">
!      optional mask (0. or 1.) that designates which grid points
!           are above (=1.) or below (=0.) the ground dimensioned as
!           (nlon,nlat,nlev).
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="axes" TYPE="integer" DIM="(4)">
!     The axes relating to the tracer array dimensioned as
!      (nlon, nlat, nlev, ntime)
!   </IN>
 subroutine atmos_radon_init (r, axes, Time, nradon, mask)

!-----------------------------------------------------------------------
!
!   r    = tracer fields dimensioned as (nlon,nlat,nlev,ntrace)
!   mask = optional mask (0. or 1.) that designates which grid points
!          are above (=1.) or below (=0.) the ground dimensioned as
!          (nlon,nlat,nlev).
!
!-----------------------------------------------------------------------
real,             intent(inout), dimension(:,:,:,:) :: r
type(time_type),  intent(in)                        :: Time
integer,          intent(in)                        :: axes(4)
integer, dimension(:), pointer                         :: nradon
real, intent(in), dimension(:,:,:), optional        :: mask

integer :: n
!
!-----------------------------------------------------------------------
!
      integer  logunit
      character(len=64) ::  search_name
      character(len=4) ::  chname
      integer :: nn

      if (module_is_initialized) return

!---- write namelist ------------------

      call write_version_number(version, tagname)
      logunit=stdlog()
      if ( mpp_pe() == mpp_root_pe() ) &
        write ( logunit, nml=atmos_radon_nml )
 
      if (ncopies_radon > 9) then
        call error_mesg ('atmos_radonm_mod', &
          'currently no more than 9 copies of the radon tracer '//&
                                               'are allowed', FATAL)
      endif
      allocate (nradon(ncopies_radon))
      nradon = -1

      do nn=1,ncopies_radon
        write (chname,'(i1)') nn
        if (nn > 1) then
          search_name = 'radon_'// trim(chname)
        else
          search_name = 'radon'
        endif
!----- set initial value of radon ------------

       n = get_tracer_index(MODEL_ATMOS,search_name)
       if (n>0) then
         nradon(nn)=n
         if (nradon(nn) > 0 .and. mpp_pe() == mpp_root_pe()) write (*,30) trim(search_name), nradon(nn)
         if (nradon(nn) > 0 .and. mpp_pe() == mpp_root_pe()) write (logunit,30) trim(search_name), nradon(nn)
       endif

      end do

  30        format (A,' was initialized as tracer number ',i2)
!

! Register a static field for the emissions of your tracer
     id_emiss = register_static_field ( 'tracers',                    &
                     'rnemiss', axes(1:2),       &
                     'rnemiss', 'g/m2/s')

      module_is_initialized = .TRUE.


!-----------------------------------------------------------------------

 end subroutine atmos_radon_init
!</SUBROUTINE>

!#######################################################################

!<SUBROUTINE NAME="atmos_radon_end">
!<OVERVIEW>
!  The destructor routine for the radon module.
!</OVERVIEW>
! <DESCRIPTION>
! This subroutine writes the version name to logfile and exits. 
! </DESCRIPTION>
!<TEMPLATE>
! call atmos_radon_end
!</TEMPLATE>
 subroutine atmos_radon_end
 
      module_is_initialized = .FALSE.

 end subroutine atmos_radon_end
!</SUBROUTINE>


end module atmos_radon_mod

module ocean_advection_velocity_mod
#define COMP isc:iec,jsc:jec
!  
!<CONTACT EMAIL="Stephen.Griffies@noaa.gov"> S.M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Advection velocity components for tracer and momenta transport, with 
! options for B-grid or C-grid.      
!</OVERVIEW>
!
!<DESCRIPTION>
! The module computes the horizontal and vertical components to the 
! advection velocity on the face of tracer and velocity cells.
! Options are provided for either the B-grid or C-grid.  
!
! The three velocity components are related by continuity. 
!
! All components are density weighted, and the 
! horizontal components are thickness weighted. 
!
! Some diagnostics related to fluid mass transport
! classified according to both depth and density classes 
! are also computed.
!
! </DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! R.C. Pacanowski and S.M. Griffies
! The MOM3 Manual (1999)
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, M.J. Harrison, R.C. Pacanowski, and A. Rosati 
! A Technical Guide to MOM4 (2003)
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies: Elements of MOM (2012)
! </REFERENCE>
!
! <NOTE>
! The expressions for the horizontal components for tracer advection
! allow for a proper conversion between pressure work and buoyancy.
! </NOTE>
!
! <NOTE>
! The B-grid remapping operators are derived from considerations of linear
! interpolation and volume conservation.  A "remapping error" is
! computed to determine consistency between the tracer and velocity
! grid advection velocities.  This error is roundoff only for cases
! where the horizontal tracer and velocity grids are linearly related,
! as is the case for the spherical coordinate version of MOM.  The
! tripolar version of MOM does not have tracer and velocity grids
! related linearly, and so the "remapping error" is nontrivial.  The 
! significance of this error is unclear.  No adverse effects have been 
! identified. 
! </NOTE>
!
! <NOTE>
! The vertical velocity components for both the tracer and velocity cells
! are diagnosed via continuity (either volume or mass conservation depending
! on the use of the Boussinesq or non-Boussinesq versions of MOM).
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_advection_velocity_nml">
!
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging.   
!  </DATA> 
!
!  <DATA NAME="inflow_nboundary" TYPE="logical">
!  For adding an inflow velocity from the northern boundary.
!  Default is inflow_nboundary=.false.
!  </DATA> 
!
!  <DATA NAME="read_advection_velocity" TYPE="logical">
!  For reading in a file with specified zonal, meridional,
!  and vertical components to the advective velocity.
!  The file should have velocity at the east face of T-cell,
!  north face, and bottom, just as on a C-grid.  The units 
!  should be m/s for each component.  MOM then multiplies
!  but the appropriate thickness and density factors to 
!  generate transport for use in the model.  
!  Default read_advection_velocity=.false.
!  </DATA> 
!
!  <DATA NAME="read_advection_transport" TYPE="logical">
!  For reading in a file with specified zonal, meridional,
!  and vertical components to the advection transport.
!  The file should have transport at the east face of T-cell,
!  north face, and bottom, just as on a C-grid.  The units 
!  should be (kg/m^3)*(m^2/sec) for horz components, and
!  (kg/m^3)*(m/sec) for vertical component.  MOM then uses 
!  these fields directly to initialize uhrho_et, vhrho_nt,
!  and wrho_bt.  
!  Default read_advection_transport=.false.
!  </DATA> 
!
!  <DATA NAME="constant_advection_velocity" TYPE="logical">
!  When reading in the advection velocity components, we 
!  may choose to keep them constant in time.  This facilitates
!  idealized tests of tracer advection.
!  Default constant_advection_velocity=.false.
!  </DATA> 
!
!  <DATA NAME="max_advection_velocity" UNITS="meter/sec" TYPE="real">
!  This is a check value used to determine if the time steps will result in 
!  linearly stable advection.  If set to a number < 0, then model will estimate the
!  value as a function of maximum grid size.
!  Note that this time step check is not rigorous, and it depends on the details of
!  the advection scheme.  Nonetheless, it provides some useful warning for setting the 
!  time steps in the model.  
!  </DATA> 
!
!</NAMELIST>

use axis_utils_mod,      only: nearest_index 
use constants_mod,       only: epsln, c2dbars
use diag_manager_mod,    only: send_data, register_diag_field, register_static_field
use fms_mod,             only: write_version_number, open_namelist_file
use fms_mod,             only: close_file, check_nml_error
use fms_mod,             only: read_data, file_exist
use fms_mod,             only: FATAL, WARNING
use fms_io_mod,          only: register_restart_field, save_restart
use fms_io_mod,          only: restore_state, restart_file_type
use mpp_domains_mod,     only: mpp_update_domains
use mpp_mod,             only: input_nml_file, mpp_error, stdout, stdlog
use mpp_mod,             only: mpp_min, mpp_max, mpp_error, mpp_pe

use ocean_domains_mod,   only: get_local_indices
use ocean_operators_mod, only: BAX, BAY, BDX_ET, BDY_NT, BDX_EU, BDY_NU
use ocean_operators_mod, only: REMAP_ET_TO_EU, REMAP_NT_TO_NU, REMAP_BT_TO_BU
use ocean_parameters_mod,only: missing_value, grav, rho0, rho0r
use ocean_parameters_mod,only: MOM_BGRID, MOM_CGRID, DEPTH_BASED 
use ocean_types_mod,     only: ocean_domain_type, ocean_grid_type
use ocean_types_mod,     only: ocean_grid_type, ocean_thickness_type
use ocean_types_mod,     only: ocean_adv_vel_type, ocean_velocity_type
use ocean_types_mod,     only: ocean_time_type, ocean_time_steps_type
use ocean_types_mod,     only: ocean_density_type, ocean_lagrangian_type
use ocean_workspace_mod, only: wrk1, wrk1_2d, wrk2_2d
use ocean_obc_mod,       only: ocean_obc_adjust_advel
use ocean_util_mod,      only: write_timestamp, diagnose_2d, diagnose_3d, diagnose_3d_u, diagnose_sum
use ocean_util_mod,      only: write_chksum_3d, write_chksum_2d

implicit none

private

integer :: unit = 6

! for vertical coordinate class
integer :: vert_coordinate_class

! for Bgrid or Cgrid
integer :: horz_grid

! for diagnostics 
integer :: id_wt               =-1
integer :: id_wrho_bt          =-1
integer :: id_uhrho_et         =-1
integer :: id_vhrho_nt         =-1
integer :: id_wrho_bu          =-1
integer :: id_uhrho_eu         =-1
integer :: id_vhrho_nu         =-1
integer :: id_rhodz_vorticity_z=-1
integer :: id_mass_source      =-1
integer :: id_horz_diverge_t   =-1
integer :: id_horz_diverge_u   =-1
integer :: id_courant_uet      =-1
integer :: id_courant_vnt      =-1
integer :: id_courant_wbt      =-1
integer :: id_courant_ueu      =-1
integer :: id_courant_vnu      =-1
integer :: id_courant_wbu      =-1
integer :: id_ue               =-1
integer :: id_vn               =-1
integer :: id_wb               =-1
integer :: id_ue_rhodzt        =-1
integer :: id_vn_rhodzt        =-1
integer :: id_wb_rho           =-1

integer :: id_eta_tend_press     =-1
integer :: id_eta_tend_press_glob=-1

real    :: dtts
real    :: dtuv
real    :: cellarea_r

logical :: used

!for restart file
type(restart_file_type), save :: adv_vel_restart

integer :: id_adv_vel_restart

#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS
 real, dimension(isd:ied,jsd:jed)    :: tmp 
#else
 real, dimension(:,:),   allocatable :: tmp 
#endif

real, dimension(:,:,:), allocatable :: vt_inflow  ! m/s
real, dimension(:,:,:), allocatable :: mask_inflow 
real, dimension(:,:,:), allocatable :: ue !m/s from file 
real, dimension(:,:,:), allocatable :: vn !m/s from file 
real, dimension(:,:,:), allocatable :: wb !m/s from file
real, dimension(:,:),   allocatable :: cgrav2  


type(ocean_domain_type), pointer :: Dom =>NULL()
type(ocean_grid_type), pointer   :: Grd =>NULL()

public ocean_advection_velocity_init
public ocean_advection_velocity
public ocean_advection_velocity_end

private check_vert_cfl_blobs
private read_advection
private inflow_nboundary_init

character(len=128) :: version=&
     '$Id: ocean_advection_velocity.F90,v 20.0.4.1 2014/01/22 17:19:10 smg Exp $'
character (len=128) :: tagname = &
     '$Name: mom5_tikal_22jan2014_smg $'

logical :: have_obc                     = .false.
logical :: module_is_initialized        = .FALSE.
logical :: prescribe_advection_velocity = .false.

real    :: max_advection_velocity       = -1.0 
logical :: debug_this_module            = .false.
logical :: inflow_nboundary             = .false. 
logical :: read_advection_velocity      = .false.
logical :: read_advection_transport     = .false.
logical :: constant_advection_velocity  = .false. 

namelist /ocean_advection_velocity_nml/ debug_this_module, max_advection_velocity, inflow_nboundary,  &
                                        read_advection_velocity, read_advection_transport,            &
                                        constant_advection_velocity

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_advection_velocity_init">
!
! <DESCRIPTION>
! Initialize the advection velocity module
! </DESCRIPTION>
!
subroutine ocean_advection_velocity_init(Grid, Domain, Time, Time_steps, Thickness, Adv_vel, &
                                         ver_coordinate_class, hor_grid, obc, use_blobs,     &
                                         introduce_blobs, debug)

  type(ocean_grid_type),       intent(in), target   :: Grid
  type(ocean_domain_type),     intent(in), target   :: Domain  
  type(ocean_time_type),       intent(in), target   :: Time
  type(ocean_time_steps_type), intent(in)           :: Time_steps
  type(ocean_thickness_type),  intent(in)           :: Thickness
  type(ocean_adv_vel_type),    intent(inout)        :: Adv_vel
  integer,                     intent(in)           :: ver_coordinate_class
  integer,                     intent(in)           :: hor_grid
  logical,                     intent(in)           :: obc
  logical,                     intent(in)           :: use_blobs
  logical,                     intent(in)           :: introduce_blobs
  logical,                     intent(in), optional :: debug

  character(len=128) :: filename
  
  integer :: ioun, io_status, ierr
  real    :: gridmin, gridmax, dtadv, a, b
  integer :: i, j, icg, jcg
  real    :: vertical_factor = 2.0
  real    :: max_dt_for_advection
  real    :: max_dt_for_advection0

  real, dimension(7) :: res = (/0.0625, 0.125, 0.25, 0.50, 1.00, 2.0, 4.0/) ! max resolution (deg)
  real, dimension(7) :: vel = (/2.0,    1.8,   1.6,  1.45, 1.25, 0.9, 0.4/) ! estimated max advection velocity (m/sec)

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
     call mpp_error(FATAL,&
    '==>Error from ocean_advection_velocity_mod: module already initialized.')
  endif 

  call write_version_number(version, tagname)

  module_is_initialized = .TRUE.

  have_obc = obc
  vert_coordinate_class = ver_coordinate_class

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_advection_velocity_nml, iostat=io_status) 
  ierr = check_nml_error(io_status,'ocean_advection_velocity_nml')
#else
  ioun = open_namelist_file ()
  read  (ioun, ocean_advection_velocity_nml,iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_advection_velocity_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit, ocean_advection_velocity_nml)
  write (stdlogunit, ocean_advection_velocity_nml)

  if (PRESENT(debug) .and. .not. debug_this_module) then
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') &
    '==>Note: running ocean_advection_velocity_mod with debug_this_module=.true.'  
  endif 

  Dom => Domain
  Grd => Grid

  dtts       = Time_steps%dtts
  dtuv       = Time_steps%dtuv
  cellarea_r = 1.0/(epsln + Grd%tcellsurf)
  horz_grid  = hor_grid

  
#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Dom, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grd%nk
 
  ! allocate variables
  allocate ( Adv_vel%uhrho_et(isd:ied,jsd:jed,nk) )
  allocate ( Adv_vel%vhrho_nt(isd:ied,jsd:jed,nk) )
  allocate ( Adv_vel%uhrho_eu(isd:ied,jsd:jed,nk) )
  allocate ( Adv_vel%vhrho_nu(isd:ied,jsd:jed,nk) )
  allocate ( Adv_vel%wrho_bt(isd:ied,jsd:jed,0:nk) )
  allocate ( Adv_vel%wrho_bu(isd:ied,jsd:jed,0:nk) )
  allocate ( Adv_vel%diverge_t(isd:ied,jsd:jed,nk) )
  allocate ( Adv_vel%diverge_u(isd:ied,jsd:jed,nk) )
  allocate ( tmp(isd:ied,jsd:jed) )

#endif

  allocate ( cgrav2(isd:ied,jsd:jed) )

  Adv_vel%uhrho_et(:,:,:)  = 0.0
  Adv_vel%vhrho_nt(:,:,:)  = 0.0
  Adv_vel%wrho_bt(:,:,:)   = 0.0
  Adv_vel%uhrho_eu(:,:,:)  = 0.0
  Adv_vel%vhrho_nu(:,:,:)  = 0.0
  Adv_vel%wrho_bu(:,:,:)   = 0.0
  Adv_vel%diverge_t(:,:,:) = 0.0
  Adv_vel%diverge_u(:,:,:) = 0.0
  tmp(:,:)                 = 0.0
  cgrav2(:,:)              = grav*Grd%ht(:,:)*Grd%tmask(:,:,1)

  if(inflow_nboundary) then 
    call inflow_nboundary_init
  endif 

  if(read_advection_velocity .or. read_advection_transport) then 
    call read_advection(Time, Thickness, Adv_vel)
    prescribe_advection_velocity = .true.
  endif
  
  if(constant_advection_velocity) then 
    write(stdoutunit,'(a)') &
    '==>Note: Using ocean_advection_velocity_mod with constant_advection_velocity=.true.'  
    write(stdoutunit,'(a)') &
    '         Will hold the advection velocity components constant in time. '
    prescribe_advection_velocity = .true.
  endif 

  if(use_blobs .and. horz_grid == MOM_CGRID) then 
    write(stdoutunit,*) &
    '==>Warning from advection velocity module: MOM C-grid with blobs is incomplete. Blobs have only been tested with Bgrid.'
  endif 

  ! initialise the restart if blobs are used
  if (use_blobs) then
     filename = 'ocean_adv_vel.res.nc'
     id_adv_vel_restart = register_restart_field(adv_vel_restart, filename, 'wrho_bt', &
          Adv_vel%wrho_bt(:,:,:), domain=Dom%domain2d)

     if (.not. introduce_blobs) then
        if(file_exist('INPUT/'//trim(filename))) then
           write(stdoutunit, '(/a)') 'Reading in advective velocity data from '//trim(filename)
           call restore_state( adv_vel_restart, id_adv_vel_restart )

        else
           if (.NOT.Time%init) then
              call mpp_error(FATAL,&
                   'Expecting file '//trim(filename)//' to exist.&
                   &This file was not found and Time%init=.false.')
           endif
        endif
     endif
  endif

  ! estimate the max advective speed for the given resolution
  if (max_advection_velocity < 0.0) then
    gridmax = 0.0
    do j=jsc,jec
      do i=isc,iec
        if (Grd%kmt(i,j) /= 0) then
          gridmax = max(gridmax,Grd%dyt(i,j),Grd%dxt(i,j))
        endif
      enddo
    enddo
    call mpp_max (gridmax)
    gridmax = gridmax/111.324e3 ! convert to degrees from metres
    i = nearest_index(gridmax, res)
    if (gridmax <= res(1)) then
      max_advection_velocity =  vel(1)
    elseif (gridmax >= res(7)) then
      max_advection_velocity =  vel(7)
    elseif (gridmax < res(i)) then
      a = res(i)-gridmax
      b = gridmax-res(i-1)
      max_advection_velocity = (a*vel(i-1) + b*vel(i))/(a+b)      
    elseif (gridmax > res(i)) then
      a = gridmax-res(i)
      b = res(i+1)-gridmax
      max_advection_velocity = (a*vel(i+1) + b*vel(i))/(a+b)      
    endif
    write (stdoutunit,'(/a,f5.2,a/a/)') &
    ' Note: The max_advection_velocity is estimated to be ',max_advection_velocity,&
    ' m/s based on grid resolution.','       A more appropriate value can be specified via namelist.'
  endif

  icg = isc; jcg = jsc; gridmin = 1.0e20; max_dt_for_advection = 1.e6; gridmax = 0.0
  do j=jsc,jec
    do i=isc,iec
      if (Grd%kmt(i,j) /= 0) then
        gridmin = min(gridmin,Grd%dyt(i,j),Grd%dxt(i,j))
        gridmax = max(gridmax,Grd%dyt(i,j),Grd%dxt(i,j))
        dtadv = 0.5*gridmin/max_advection_velocity
        if (dtadv < max_dt_for_advection) then
          max_dt_for_advection = dtadv; icg  = i; jcg  = j
        endif
      endif
    enddo
  enddo
  
  max_dt_for_advection = nint(max_dt_for_advection/vertical_factor) ! 
  max_dt_for_advection =  max_dt_for_advection + 1.e-12*mpp_pe()     ! to separate redundancies
  max_dt_for_advection0 = max_dt_for_advection
  call mpp_min (max_dt_for_advection)
  call mpp_max (gridmax)
  
  if (max_dt_for_advection == max_dt_for_advection0) then
    if (max(dtts,dtuv) <= max_dt_for_advection) then
      write (unit,'(/a,i4,a,i4,a,f8.3,a,f8.3,a)') &
       ' Note: Advection stability most nearly violated at T-cell (i,j) = (',&
        icg+Dom%ioff,',',jcg+Dom%joff,'), (lon,lat) = (',Grd%xt(icg,jcg),',',Grd%yt(icg,jcg),').'
    else
      write (unit,'(/a,i4,a,i4,a,f8.3,a,f8.3,a)') &
      '=>Error: Advection stability violated at T-cell (i,j) = (',&
      icg+Dom%ioff,',',jcg+Dom%joff,'), (lon,lat) = (',Grd%xt(icg,jcg),',',Grd%yt(icg,jcg),').'
      call mpp_error(FATAL,&
      '==>Error from ocean_advection_velocity_mod: tracer advection stability is violated.')
    endif
    write (unit,'(a,f7.2,a,/a,f12.2,a,/a,f12.2,a,f12.2,a)')                                  &
     ' Assuming a maximum advection velocity of ',max_advection_velocity,' m/s,',            &
     ' Linear stability requires max(dtuv,dtts) be less than ',max_dt_for_advection,' sec.', &
     ' Model is now using (dtuv,dtts) = (',dtuv,',',dtts,') sec.'
  endif
  max_dt_for_advection = nint(max_dt_for_advection)

  ! register advective velocity components for diagnostic output

  id_horz_diverge_t = register_diag_field ('ocean_model', 'horz_diverge_t',                 &
     Grd%vel_axes_wt(1:3), Time%model_time,                                                 &
    'horizontal (on k=constant) divergence of (uhrho,vhrho) at T-points', '(kg/m^3)*m/sec', &
    missing_value=missing_value, range=(/-10.e4,10.e4/))

  id_wt = register_diag_field ('ocean_model', 'wt', Grd%vel_axes_wt(1:3), Time%model_time, &
    'dia-surface velocity T-points', 'm/sec', missing_value=missing_value, range=(/-10.e4,10.e4/))

  id_wrho_bt = register_diag_field ('ocean_model', 'wrhot', Grd%vel_axes_wt(1:3), Time%model_time, &
    'rho*dia-surface velocity T-points', '(kg/m^3)*m/sec', missing_value=missing_value, range=(/-10.e4,10.e4/))
  id_uhrho_et = register_diag_field ('ocean_model', 'uhrho_et', Grd%tracer_axes(1:3), Time%model_time, &
    'uhrho_et on horz face of T-cells', '(kg/m^3)*m^2/sec', missing_value=missing_value, range=(/-100.e4,100.e4/))
  id_vhrho_nt = register_diag_field ('ocean_model', 'vhrho_nt', Grd%tracer_axes(1:3), Time%model_time, &
    'vhrho_nt on horz face of T-cells', '(kg/m^3)*m^2/sec', missing_value=missing_value, range=(/-100.e4,100.e4/))

  id_horz_diverge_u = register_diag_field ('ocean_model', 'horz_diverge_u',                         &
     Grd%vel_axes_wu(1:3), Time%model_time,                                                         &
    'horizontal (on k=constant) divergence of (uhrho,vhrho) at U-points (only relevant for B-grid)',&
    '(kg/m^3)*m/sec', missing_value=missing_value, range=(/-10.e4,10.e4/))

  id_wrho_bu = register_diag_field ('ocean_model', 'wrhou', Grd%vel_axes_wu(1:3), Time%model_time, &
    'rho*dia-surface velocity U-points (only relevant for B-grid)', '(kg/m^3)*m/sec',              &
    missing_value=missing_value, range=(/-10.e4,10.e4/))
  id_uhrho_eu = register_diag_field ('ocean_model', 'uhrho_eu', Grd%vel_axes_uv(1:3), Time%model_time, &
    'uhrho_eu on horz face of U-cells (only relevant for B-grid)', '(kg/m^3)*m^2/sec',                 &
     missing_value=missing_value, range=(/-100.e4,100.e4/))
  id_vhrho_nu = register_diag_field ('ocean_model', 'vhrho_nu', Grd%vel_axes_uv(1:3), Time%model_time, &
    'vhrho_nu on horz face of U-cells (only relevant for B-grid)', '(kg/m^3)*m^2/sec',                 &
    missing_value=missing_value, range=(/-100.e4,100.e4/))

  ! mass-based vorticity 
  id_rhodz_vorticity_z = register_diag_field ('ocean_model', 'rhodz_vorticity_z', Grd%vel_axes_uv(1:3), &
     Time%model_time, 'vertical rhodz vorticity: (rho*dz*v)_x-(rho*dz*u)_y', &
     '(kg*m^2)/sec', missing_value=missing_value, range=(/-1e8,1e8/))

  ! register Courant numbers for diagnostic output
  id_courant_uet = register_diag_field ('ocean_model', 'courant_uet', Grd%tracer_axes(1:3), Time%model_time, &
    'Courant number [uet*dtts/dxt]', 'none', missing_value=missing_value, range=(/-1e9,1e9/))
  id_courant_vnt = register_diag_field ('ocean_model', 'courant_vnt', Grd%tracer_axes(1:3), Time%model_time, &
    'Courant number [vnt*dtts/dyt]', 'none', missing_value=missing_value, range=(/-1e9,1e9/))
  id_courant_wbt = register_diag_field ('ocean_model', 'courant_wbt', Grd%tracer_axes(1:3), Time%model_time, &
    'Courant number [wbt*dtts/dzt]', 'none', missing_value=missing_value, range=(/-1e9,1e9/))
  id_courant_ueu = register_diag_field ('ocean_model', 'courant_ueu', Grd%vel_axes_uv(1:3), Time%model_time, &
    'Courant number [ueu*dtuv/dxu]', 'none', missing_value=missing_value, range=(/-1e9,1e9/))
  id_courant_vnu = register_diag_field ('ocean_model', 'courant_vnu', Grd%vel_axes_uv(1:3), Time%model_time, &
    'Courant number [vnu*dtuv/dyu]', 'none', missing_value=missing_value, range=(/-1e9,1e9/))
  id_courant_wbu = register_diag_field ('ocean_model', 'courant_wbu', Grd%vel_axes_uv(1:3), Time%model_time, &
    'Courant number [wnu*dtuv/dzu]', 'none', missing_value=missing_value, range=(/-1e9,1e9/))

  ! register mass source 
  id_mass_source = register_diag_field ('ocean_model', 'mass_source', Grd%tracer_axes(1:3), Time%model_time, &
    'Mass source on T-grid', '(kg/m^3)*(m/s)', missing_value=missing_value, range=(/-1e9,1e9/))

  ! eta tendency from motion across pressure surfaces (when vert_coord=press)
  id_eta_tend_press = register_diag_field ('ocean_model', 'eta_tend_press',                   &
  Grd%tracer_axes(1:2),Time%model_time,                                                       &
  'non-Bouss steric tendency from motion across pressure surfaces (when vert coord = press)', &
  'm/s', missing_value=missing_value, range=(/-1e9,1e9/))

  id_eta_tend_press_glob = register_diag_field ('ocean_model', 'eta_tend_press_glob',         &
  Time%model_time,                                                                            &
  'non-Bouss steric tendency from motion across pressure surfaces (when vert coord = press)', &
  'm/s', missing_value=missing_value, range=(/-1e9,1e9/))


  if(debug_this_module .and. use_blobs) then 
      write(stdoutunit,*) ' '
      write(stdoutunit,*) 'From ocean_advection_velocity_mod: beginning chksums'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('Adv_vel%wrho_bt', Adv_vel%wrho_bt(COMP,1:))
      call write_chksum_2d('Adv_vel%wrho_bt(0)', Adv_vel%wrho_bt(COMP,0))
  endif

end subroutine ocean_advection_velocity_init
! </SUBROUTINE> NAME="ocean_advection_velocity_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_advection_velocity">
!
! <DESCRIPTION>
! Compute thickness weighted and density weighted advection velocity 
! components for the B-grid on the T-cells and U-cells. 
!
! U-cell advective components are not used for Cgrid, so we do not 
! update the u-cell components.  Instead, simply keep values at their
! initial setting of 0.0.  
!
! </DESCRIPTION>
!
subroutine ocean_advection_velocity (Velocity, Time, Thickness, Dens, pme, river, Adv_vel, &
                                     L_system, use_blobs)
  
  type(ocean_velocity_type),  intent(in)    :: Velocity
  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(in)    :: Thickness
  type(ocean_density_type),   intent(in)    :: Dens
  real, dimension(isd:,jsd:), intent(in)    :: pme
  real, dimension(isd:,jsd:), intent(in)    :: river
  type(ocean_adv_vel_type),   intent(inout) :: Adv_vel
  type(ocean_lagrangian_type),intent(in)    :: L_system
  logical,                    intent(in)    :: use_blobs

  integer ::  i, j, k, tau
  integer :: stdoutunit 
  stdoutunit=stdout() 

  if ( .not. module_is_initialized ) &
   call mpp_error(FATAL, &
    '==>Error from ocean_advection_velocity_mod (ocean_advection_velocity): module must be initialized')

  tau  = Time%tau
  wrk1 = 0.0
  tmp  = 0.0

  ! compute thickness weighted and density weighted C-grid advection 
  ! velocity components (uhrho_et, vhrho_nt) to advect tracer fields. 
  ! Remap these to get the corresponding advection velocity components 
  ! (uhrho_eu,vhrho_nu) to advect B-grid horizontal momentum.

  if(.not. prescribe_advection_velocity .and. horz_grid == MOM_BGRID) then 

      do k=1,nk
         Adv_vel%uhrho_et(:,:,k) = &
         BAY(Velocity%u(:,:,k,1,tau)*Grd%dyu(:,:)*Thickness%rho_dzu(:,:,k,tau))/Grd%dyte(:,:) 
         Adv_vel%vhrho_nt(:,:,k) = &
         BAX(Velocity%u(:,:,k,2,tau)*Grd%dxu(:,:)*Thickness%rho_dzu(:,:,k,tau))/Grd%dxtn(:,:) 
         Adv_vel%uhrho_eu(:,:,k) = REMAP_ET_TO_EU(Adv_vel%uhrho_et(:,:,k))
         Adv_vel%vhrho_nu(:,:,k) = REMAP_NT_TO_NU(Adv_vel%vhrho_nt(:,:,k))
         Adv_vel%diverge_t(:,:,k)= Grd%tmask(:,:,k) &
           *(BDX_ET(Adv_vel%uhrho_et(:,:,k)) + BDY_NT(Adv_vel%vhrho_nt(:,:,k)))    
         Adv_vel%diverge_u(:,:,k)= Grd%umask(:,:,k) &
           *(BDX_EU(Adv_vel%uhrho_eu(:,:,k)) + BDY_NU(Adv_vel%vhrho_nu(:,:,k)))    
      enddo

      ! dia-surface mass flux through ocean surface arises from water crossing ocean surface. 
      ! minus sign arises from the model sign convention.
      Adv_vel%wrho_bt(:,:,0) = -(pme(:,:) + river(:,:))
      Adv_vel%wrho_bu(:,:,0) = Grd%umask(:,:,1)*REMAP_BT_TO_BU(Adv_vel%wrho_bt(:,:,0))         

      if (use_blobs) then

         do k=1,nk
            tmp(:,:) = Thickness%rho_dzt_tendency(:,:,k) - Thickness%mass_source(:,:,k) - L_system%conv_blob(:,:,k)
            Adv_vel%wrho_bt(:,:,k) = (tmp(:,:) + Adv_vel%diverge_t(:,:,k) + Adv_vel%wrho_bt(:,:,k-1)) &
                                     *Grd%tmask(:,:,k)

            tmp(:,:) = Grd%umask(:,:,k)*REMAP_BT_TO_BU(tmp(:,:))
            Adv_vel%wrho_bu(:,:,k) = tmp(:,:) + Adv_vel%diverge_u(:,:,k) + Adv_vel%wrho_bu(:,:,k-1) 
         enddo

         if (debug_this_module) then 
            call check_vert_cfl_blobs(Time, Adv_vel, Thickness, L_system)
         endif 

      else !use_blobs=.false.

         do k=1,nk
            tmp(:,:) = Thickness%rho_dzt_tendency(:,:,k) - Thickness%mass_source(:,:,k)
            Adv_vel%wrho_bt(:,:,k) = (tmp(:,:) + Adv_vel%diverge_t(:,:,k) + Adv_vel%wrho_bt(:,:,k-1)) &
                                     *Grd%tmask(:,:,k)
            tmp(:,:) = Grd%umask(:,:,k)*REMAP_BT_TO_BU(tmp(:,:))
            Adv_vel%wrho_bu(:,:,k) = tmp(:,:) + Adv_vel%diverge_u(:,:,k) + Adv_vel%wrho_bu(:,:,k-1) 
         enddo

      endif

  endif  ! endif for .not. prescribe_advection_velocity and MOM_BGRID 


  ! smg: June 2012: C-grid yet to be updated for blobs. 
  if(.not. prescribe_advection_velocity .and. horz_grid == MOM_CGRID) then 

      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               Adv_vel%uhrho_et(i,j,k) = Velocity%u(i,j,k,1,tau)*Thickness%rho_dzten(i,j,k,1) &
                                         *Grd%dxt_dxter(i,j)*Grd%dyt_dyter(i,j)
               Adv_vel%vhrho_nt(i,j,k) = Velocity%u(i,j,k,2,tau)*Thickness%rho_dzten(i,j,k,2) &
                                         *Grd%dxt_dxtnr(i,j)*Grd%dyt_dytnr(i,j)
            enddo
         enddo
         Adv_vel%diverge_t(:,:,k) = Grd%tmask(:,:,k)*(BDX_ET(Adv_vel%uhrho_et(:,:,k)) + BDY_NT(Adv_vel%vhrho_nt(:,:,k)))    
      enddo

      ! dia-surface mass flux through ocean surface arises from water crossing ocean surface. 
      ! minus sign arises from the model sign convention.
      Adv_vel%wrho_bt(:,:,0) = -(pme(:,:) + river(:,:))
      do k=1,nk
        tmp(:,:) = Thickness%rho_dzt_tendency(:,:,k) - Thickness%mass_source(:,:,k)
        Adv_vel%wrho_bt(:,:,k) = (tmp(:,:) + Adv_vel%diverge_t(:,:,k) + Adv_vel%wrho_bt(:,:,k-1)) &
                                 *Grd%tmask(:,:,k)
     enddo

  endif  ! endif for .not. prescribe_advection_velocity and MOM_CGRID 


  if (have_obc) then
     call ocean_obc_adjust_advel(Adv_vel) 
  endif


  ! specify a value for the inflow meridional transport 
  if(inflow_nboundary) then 
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               Adv_vel%vhrho_nt(i,j,k) = Adv_vel%vhrho_nt(i,j,k)  &
                + Grd%tmask(i,j,k)*mask_inflow(i,j,k)*rho0*Thickness%dzt(i,j,k)*vt_inflow(i,j,k)
            enddo
         enddo
      enddo
  endif

  
  if(debug_this_module) then 
      write(stdoutunit,*) ' '
      write(stdoutunit,*) 'From ocean_advection_velocity_mod: chksums'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('Velocity%u(1)', Velocity%u(COMP,:,1,tau))
      call write_chksum_3d('Velocity%u(2)', Velocity%u(COMP,:,2,tau))
      ! To make it equivalent to the checksum in the thickness module
      call write_chksum_3d('rho_dzu', Thickness%rho_dzu(COMP,:,tau)*Grd%umask(COMP,:))
      if (use_blobs) then
         call write_chksum_3d('L_system%conv_blob', L_system%conv_blob(COMP,:))
      endif
      call write_chksum_3d('Adv_vel%uhrho_et', Adv_vel%uhrho_et(COMP,:))
      call write_chksum_3d('Adv_vel%vhrho_nt', Adv_vel%vhrho_nt(COMP,:))
      call write_chksum_3d('Adv_vel%uhrho_eu', Adv_vel%uhrho_eu(COMP,:))
      call write_chksum_3d('Adv_vel%vhrho_nu', Adv_vel%vhrho_nu(COMP,:))
      call write_chksum_3d('Adv_vel%wrho_bt', Adv_vel%wrho_bt(COMP,1:))
      call write_chksum_3d('Adv_vel%wrho_bu', Adv_vel%wrho_bu(COMP,1:))
      call write_chksum_2d('Adv_vel%wrho_bt(0)', Adv_vel%wrho_bt(COMP,0))
      call write_chksum_2d('Adv_vel%wrho_bu(0)', Adv_vel%wrho_bu(COMP,0))
      call write_chksum_3d('Adv_vel%diverge_t', Adv_vel%diverge_t(COMP,:))
      call write_chksum_3d('Adv_vel%diverge_u', Adv_vel%diverge_u(COMP,:))
  endif

  ! send advective velocity components to diagnostic manager 

  if (id_wt > 0)  then
      if(vert_coordinate_class==DEPTH_BASED) then 
         call diagnose_3d(Time, Grd, id_wt, rho0r*Adv_vel%wrho_bt(:,:,1:nk))
      else 
          wrk1(:,:,:) = 0.0
          do k=1,nk
             do j=jsd,jed
                do i=isd,ied
                   if(Grd%tmask(i,j,k) > 0.0) then 
                       wrk1(i,j,k) = Adv_vel%wrho_bt(i,j,k)/Dens%rho(i,j,k,tau)
                   endif
                enddo
             enddo
          enddo
          call diagnose_3d(Time, Grd, id_wt, wrk1(:,:,:))
      endif
  endif

  call diagnose_3d(Time, Grd, id_uhrho_et, Adv_vel%uhrho_et(:,:,:))
  call diagnose_3d(Time, Grd, id_vhrho_nt, Adv_vel%vhrho_nt(:,:,:))
  call diagnose_3d(Time, Grd, id_wrho_bt, Adv_vel%wrho_bt(:,:,1:nk))
  call diagnose_3d_u(Time, Grd, id_uhrho_eu, Adv_vel%uhrho_eu(:,:,:))
  call diagnose_3d_u(Time, Grd, id_vhrho_nu, Adv_vel%vhrho_nu(:,:,:))
  call diagnose_3d_u(Time, Grd, id_wrho_bu, Adv_vel%wrho_bu(:,:,1:nk))

  call diagnose_3d(Time, Grd, id_horz_diverge_t, Adv_vel%diverge_t(:,:,:))
  call diagnose_3d_u(Time, Grd, id_horz_diverge_u, Adv_vel%diverge_u(:,:,:))

  ! send mass and thickness weighted vertical vorticity 
  if(id_rhodz_vorticity_z > 0) then 
      wrk1=0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1(i,j,k) = (Adv_vel%vhrho_nt(i+1,j,k)-Adv_vel%vhrho_nt(i,j,k))*Grd%dxur(i,j) &
                            -(Adv_vel%uhrho_et(i,j+1,k)-Adv_vel%uhrho_et(i,j,k))*Grd%dyur(i,j) 
            enddo
         enddo
      enddo
      call diagnose_3d_u(Time, Grd, id_rhodz_vorticity_z, wrk1(:,:,:))
  endif 


  ! send Courant numbers to diagnostic manager 
  if (id_courant_uet > 0) then 
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1(i,j,k) = dtts*Adv_vel%uhrho_et(i,j,k)/(Thickness%rho_dzt(i,j,k,tau)*Grd%dxt(i,j))
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_courant_uet, wrk1(:,:,:))
  endif
  if (id_courant_vnt > 0) then 
      do k=1,nk  
         do j=jsc,jec
            do i=isc,iec
               wrk1(i,j,k) = dtts*Adv_vel%vhrho_nt(i,j,k)/(Thickness%rho_dzt(i,j,k,tau)*Grd%dyt(i,j))
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_courant_vnt, wrk1(:,:,:))
  endif
  if (id_courant_wbt > 0) then 
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1(i,j,k) = dtts*Adv_vel%wrho_bt(i,j,k)/Thickness%rho_dzt(i,j,k,tau)
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_courant_wbt, wrk1(:,:,:))
  endif
  if (id_courant_ueu > 0) then 
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1(i,j,k) = dtuv*Adv_vel%uhrho_eu(i,j,k)/(Thickness%rho_dzu(i,j,k,tau)*Grd%dxu(i,j))
            enddo
         enddo
      enddo
      call diagnose_3d_u(Time, Grd, id_courant_ueu, wrk1(:,:,:))
  endif 
  if (id_courant_vnu > 0) then 
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1(i,j,k) = dtuv*Adv_vel%vhrho_nu(i,j,k)/(Thickness%rho_dzu(i,j,k,tau)*Grd%dyu(i,j))
            enddo
         enddo
      enddo
      call diagnose_3d_u(Time, Grd, id_courant_vnu, wrk1(:,:,:))
  endif
  if (id_courant_wbu > 0) then 
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1(i,j,k) = dtuv*Adv_vel%wrho_bu(i,j,k)/Thickness%rho_dzu(i,j,k,tau)
            enddo
         enddo
      enddo
      call diagnose_3d_u(Time, Grd, id_courant_wbu, wrk1(:,:,:))
  endif

  if(id_eta_tend_press > 0 .or. id_eta_tend_press_glob > 0) then 
      ! do not include k=0, as that is pme+river contribution,
      ! and that is not what is desired for this diagnostic.
      ! note that drhodP is in units of (kg/m^3)/dbars, so 
      ! need to multiply by c2dbars to get squared sound speed
      ! in (m^2/s^2).   
      wrk1_2d(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1_2d(i,j) = wrk1_2d(i,j) + Dens%drhodP(i,j,k)*Adv_vel%wrho_bt(i,j,k) &
                                             *Thickness%dzt(i,j,k)/(Dens%rho(i,j,k,tau)+epsln)
            enddo
         enddo
      enddo
      do j=jsc,jec
         do i=isc,iec
            wrk1_2d(i,j) = c2dbars*grav*wrk1_2d(i,j)
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_eta_tend_press, wrk1_2d(:,:))
      call diagnose_sum(Time, Grd, Dom, id_eta_tend_press_glob, wrk1_2d, cellarea_r)
  endif

end subroutine ocean_advection_velocity
! </SUBROUTINE> NAME="advection_velocity"


!#######################################################################
! <SUBROUTINE NAME="check_vert_cfl_blobs">
!
! <DESCRIPTION>
! This routine is useful to check for strong vertical motions in the 
! presence of Lagrangian blobs.  The CFL check is the same as in the 
! module ocean_adv_vel_diag.F90, but we have more local control here
! so it is useful in the development stages of the blobs.
! </DESCRIPTION>
!
subroutine check_vert_cfl_blobs(Time, Adv_vel, Thickness, L_system)

  type(ocean_time_type),       intent(in)  :: Time
  type(ocean_adv_vel_type),    intent(in)  :: Adv_vel
  type(ocean_thickness_type),  intent(in)  :: Thickness
  type(ocean_lagrangian_type), intent(in)  :: L_system

  integer :: i,j,k,tau
  integer :: stdoutunit 
  stdoutunit=stdout() 

  tau = Time%tau

    do k=1,nk
       do j=jsc,jec
          do i=isc,iec
             if (dtts*Adv_vel%wrho_bt(i,j,k)/Thickness%rho_dztT(i,j,k,tau) > 1.0) then
                write (stdoutunit, '(/,a)') 'Vertical CFL condition violated'
                call write_timestamp(Time%model_time)
                print ('(3(a,i3),a,x,7(/,a20,x,es11.4))'), '(',i,',',j,',',k,')',                      &
                     'CFL number       =',  dtts*Adv_vel%wrho_bt(i,j,k)/Thickness%rho_dztT(i,j,k,tau), &
                     'wrho_bt          =',  Adv_vel%wrho_bt(i,j,k),                                    &
                     'w                =',  rho0r*Adv_vel%wrho_bt(i,j,k),                              &
                     'rho_dzt_tendency =',  Thickness%rho_dzt_tendency(i,j,k),                         &
                     'mass_source      =', -Thickness%mass_source(i,j,k),                              &
                     'conv_blob        =', -L_system%conv_blob(i,j,k),                                 &
                     'diverge_t        =',  Adv_vel%diverge_t(i,j,k)
                call mpp_error(WARNING, &
                '==>Error from ocean_advection_velocity_mod: Vertical CFL condition violated in presence of blobs.')
             endif
          enddo
       enddo
    enddo

end subroutine check_vert_cfl_blobs
! </SUBROUTINE> NAME="check_vert_cfl_blobs"


!#######################################################################
! <SUBROUTINE NAME="read_advection">
!
! <DESCRIPTION>
! To read in advection velocity components or advection transport
! components.
!
! This routine assumes that the read-in components are masked.  
!
! A/ read_advection_velocity=.true. 
! Assume (x,y,z) advection velocity components read in and are in units 
! of meter/sec, and placed on the T-cell faces, as in a C-grid ocean model.  
! An application of this option is for developing idealized test cases
! for tracer advection.
!
! B/ read_advection_transport=.true. 
! Assume (x,y,z) advection transport components read in from a file.
! The file should have transport at the east face of T-cell,
! north face, and bottom, just as on a C-grid. The units should be
! uhrho_et = (kg/m^3)*(m^2/sec)
! vhrho_nt = (kg/m^3)*(m^2/sec)
! wrho_bt  = (kg/m^3)*(m/sec)
! MOM then uses these read fields to initialize uhrho_et, vhrho_nt,
! and wrho_bt. 
! An application of this option is for diagnosing the advection
! operator and advection fluxes when reading in the time mean
! uhrho_et, vhrho_nt, and wrho_bt and initializing tracer concentration
! with a time mean value. Assuming we have also saved the time mean
! advection operator, we may then diagnose the eddy correlation
! contribution to tracer transport. 
!
! </DESCRIPTION>
!
subroutine read_advection(Time, Thickness, Adv_vel)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(in)    :: Thickness
  type(ocean_adv_vel_type),   intent(inout) :: Adv_vel

  integer            :: i,j,k
  character(len=128) :: filename

  allocate (ue(isd:ied,jsd:jed,nk))
  ue(:,:,:) = 0.0
  allocate (vn(isd:ied,jsd:jed,nk))
  vn(:,:,:) = 0.0
  allocate (wb(isd:ied,jsd:jed,nk))
  wb(:,:,:) = 0.0

  filename = 'INPUT/ocean_advect_velocity.nc'
  if (file_exist(trim(filename))) then 
      call read_data(filename,'ue',ue,Dom%domain2d,timelevel=1)
      call read_data(filename,'vn',vn,Dom%domain2d,timelevel=1)
      call read_data(filename,'wb',wb,Dom%domain2d,timelevel=1)
      do k=1,nk
        do j=jsd,jed
           do i=isd,ied
              ue(i,j,k) = ue(i,j,k)*Grd%tmask(i,j,k)
              vn(i,j,k) = vn(i,j,k)*Grd%tmask(i,j,k)
              wb(i,j,k) = wb(i,j,k)*Grd%tmask(i,j,k)
           enddo
        enddo
      enddo
      call mpp_update_domains(ue(:,:,:), Dom%domain2d)
      call mpp_update_domains(vn(:,:,:), Dom%domain2d)
      call mpp_update_domains(wb(:,:,:), Dom%domain2d)
  else 
      call mpp_error(FATAL,&
      '==>Error from ocean_advection_velocity_mod: read_advect_velocity cannot find ocean_advect_velocity.nc.')
  endif


  if(read_advection_velocity) then 
      if(horz_grid == MOM_BGRID) then 

          do k=1,nk
             Adv_vel%uhrho_et(:,:,k) = rho0*ue(:,:,k)*BAY(Thickness%dzu(:,:,k)) 
             Adv_vel%vhrho_nt(:,:,k) = rho0*vn(:,:,k)*BAX(Thickness%dzu(:,:,k)) 
             Adv_vel%wrho_bt(:,:,k)  = rho0*wb(:,:,k)
             Adv_vel%uhrho_eu(:,:,k) = REMAP_ET_TO_EU(Adv_vel%uhrho_et(:,:,k))                                       
             Adv_vel%vhrho_nu(:,:,k) = REMAP_NT_TO_NU(Adv_vel%vhrho_nt(:,:,k))                                       
             Adv_vel%wrho_bu(:,:,k)  = REMAP_BT_TO_BU(Adv_vel%wrho_bt(:,:,k))
          enddo

      else 

          ! U-cell advective components are not used for Cgrid
          do k=1,nk
             Adv_vel%uhrho_et(:,:,k) = rho0*ue(:,:,k)*Thickness%dzten(:,:,k,1) 
             Adv_vel%vhrho_nt(:,:,k) = rho0*vn(:,:,k)*Thickness%dzten(:,:,k,2) 
             Adv_vel%wrho_bt(:,:,k)  = rho0*wb(:,:,k)
          enddo

      endif

      id_ue = register_static_field('ocean_model','ue', Grd%tracer_axes_flux_x(1:3), &
           'zonal C-grid velocity from file','m/s', range=(/-1e3,1e3/))
      id_vn = register_static_field('ocean_model','vn', Grd%tracer_axes_flux_y(1:3), &
           'meridional C-grid velocity from file','m/s', range=(/-1e3,1e3/)) 
      id_wb = register_static_field('ocean_model','wb', Grd%tracer_axes_wt(1:3), &
           'vertical C-grid velocity from file','m/s', range=(/-1e3,1e3/))

      
  endif

  if(read_advection_transport) then 
      if(horz_grid == MOM_BGRID) then 

          do k=1,nk
             Adv_vel%uhrho_et(:,:,k) = ue(:,:,k)
             Adv_vel%vhrho_nt(:,:,k) = vn(:,:,k)
             Adv_vel%wrho_bt(:,:,k)  = wb(:,:,k)
             Adv_vel%uhrho_eu(:,:,k) = REMAP_ET_TO_EU(Adv_vel%uhrho_et(:,:,k))                                       
             Adv_vel%vhrho_nu(:,:,k) = REMAP_NT_TO_NU(Adv_vel%vhrho_nt(:,:,k))                                       
             Adv_vel%wrho_bu(:,:,k)  = REMAP_BT_TO_BU(Adv_vel%wrho_bt(:,:,k))
          enddo

      else 

          ! U-cell advective components are not used for Cgrid
          do k=1,nk
             Adv_vel%uhrho_et(:,:,k) = ue(:,:,k)
             Adv_vel%vhrho_nt(:,:,k) = vn(:,:,k)
             Adv_vel%wrho_bt(:,:,k)  = wb(:,:,k)
          enddo

      endif

      id_ue = register_static_field('ocean_model','ue', Grd%tracer_axes_flux_x(1:3), &
           'zonal C-grid transport from file','(kg/m^3)*(m^2/sec)', range=(/-1e12,1e12/))
      id_vn = register_static_field('ocean_model','vn', Grd%tracer_axes_flux_y(1:3), &
           'meridional C-grid transport from file','(kg/m^3)*(m^2/sec)', range=(/-1e12,1e12/))
      id_wb = register_static_field('ocean_model','wb', Grd%tracer_axes_wt(1:3),     &
           'vertical C-grid transport from file','m/s', range=(/-1e12,1e12/))

      
  endif

  
  if (id_ue > 0) used = send_data(id_ue, ue(isc:iec,jsc:jec,:), Time%model_time)
  if (id_vn > 0) used = send_data(id_vn, vn(isc:iec,jsc:jec,:), Time%model_time)
  if (id_wb > 0) used = send_data(id_wb, wb(isc:iec,jsc:jec,:), Time%model_time)

  id_ue_rhodzt = register_static_field('ocean_model','ue_rhodzt', Grd%tracer_axes_flux_x(1:3), &
                 'zonal C-grid velocity*rhodzt from file','(kg/m3)*m^2/s', range=(/-1e6,1e6/))
  if (id_ue_rhodzt > 0) used = send_data(id_ue_rhodzt, Adv_vel%uhrho_et(isc:iec,jsc:jec,:), Time%model_time)

  id_vn_rhodzt = register_static_field('ocean_model','vn_rhodzt', Grd%tracer_axes_flux_y(1:3), &
                 'merid C-grid velocity*rhodzt from file','(kg/m3)*m^2/s', range=(/-1e6,1e6/))
  if (id_vn_rhodzt > 0) used = send_data(id_vn_rhodzt, Adv_vel%vhrho_nt(isc:iec,jsc:jec,:), Time%model_time)

  id_wb_rho = register_static_field('ocean_model','wb_rho', Grd%tracer_axes_wt(1:3), &
              'vertical C-grid velocity*rho from file','(kg/m3)*m/s', range=(/-1e6,1e6/))
  if (id_wb_rho > 0) used = send_data(id_wb_rho, Adv_vel%wrho_bt(isc:iec,jsc:jec,1:nk), Time%model_time)



end subroutine read_advection
! </SUBROUTINE> NAME="read_advection"


!#######################################################################
! <SUBROUTINE NAME="inflow_nboundary_init">
!
! <DESCRIPTION>
! Initialize the advection velocity used for specifying a nonzero 
! southward inflow introduced to the domain from the northern boundary.  
!
! </DESCRIPTION>
!
subroutine inflow_nboundary_init

  character(len=128) :: filename

  allocate ( vt_inflow(isd:ied,jsd:jed,nk) )
  allocate ( mask_inflow(isd:ied,jsd:jed,nk) )

  vt_inflow(:,:,:)   = 0.0
  mask_inflow(:,:,:) = 0.0


  filename = 'INPUT/mask_inflow.nc'
  if (file_exist(trim(filename))) then 
      call read_data(filename,'mask_inflow',mask_inflow,Dom%domain2d,timelevel=1)
      call mpp_update_domains(mask_inflow(:,:,:), Dom%domain2d)
  else 
     call mpp_error(FATAL,&
    '==>Error from ocean_advection_velocity_mod: inflow_nboundary_init cannot find mask_inflow file.')
  endif 

  filename = 'INPUT/vt_inflow.nc'
  if (file_exist(trim(filename))) then 
      call read_data(filename,'vt_inflow',vt_inflow,Dom%domain2d,timelevel=1)
      call mpp_update_domains(vt_inflow(:,:,:), Dom%domain2d)
  else 
     call mpp_error(FATAL,&
    '==>Error from ocean_advection_velocity_mod: inflow_nboundary_init cannot find vt_inflow.')
  endif 

end subroutine inflow_nboundary_init
! </SUBROUTINE> NAME="inflow_nboundary_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_advection_velocity_end">
!
! <DESCRIPTION>
! Write a restart if necessary
!
! </DESCRIPTION>
!
subroutine ocean_advection_velocity_end(Time, Adv_vel, use_blobs)
  type(ocean_time_type),    intent(in) :: Time
  type(ocean_adv_vel_type), intent(in) :: Adv_vel
  logical,                  intent(in) :: use_blobs

  integer :: stdoutunit
  stdoutunit = stdout()

  if (use_blobs) call save_restart(adv_vel_restart)

  if (debug_this_module) then
      write(stdoutunit,*) ' '
      write(stdoutunit,*) 'From ocean_advection_velocity_mod: ending chksums'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('Adv_vel%uhrho_et', Adv_vel%uhrho_et(COMP,:))
      call write_chksum_3d('Adv_vel%vhrho_nt', Adv_vel%vhrho_nt(COMP,:))
      call write_chksum_3d('Adv_vel%uhrho_eu', Adv_vel%uhrho_eu(COMP,:))
      call write_chksum_3d('Adv_vel%vhrho_nu', Adv_vel%vhrho_nu(COMP,:))
      call write_chksum_3d('Adv_vel%wrho_bt', Adv_vel%wrho_bt(COMP,1:))
      call write_chksum_3d('Adv_vel%wrho_bu', Adv_vel%wrho_bu(COMP,1:))
      call write_chksum_2d('Adv_vel%wrho_bt(0)', Adv_vel%wrho_bt(COMP,0))
      call write_chksum_2d('Adv_vel%wrho_bu(0)', Adv_vel%wrho_bu(COMP,0))
      call write_chksum_3d('Adv_vel%diverge_t', Adv_vel%diverge_t(COMP,:))
      call write_chksum_3d('Adv_vel%diverge_u', Adv_vel%diverge_u(COMP,:))
  endif

end subroutine ocean_advection_velocity_end
! </SUBROUTINE> NAME="ocean_advection_velocity_end"



end module ocean_advection_velocity_mod

module beta_dist_mod
  use fms_mod,only: stdlog, write_version_number, &
                    error_mesg, FATAL
  use mpp_mod,only: get_unit                  
  implicit none
  private 
  
  ! Provide values of the beta distribtion as a function of the CDF (the incomplete beta
  !   function). Returns a value as a function of two beta distribution parameters p, q 
  !   (here they must be integers) and the value x of the CDF between 0 and 1. 
  
  ! In this version we build tables using the NAG library function nag_beta_deviate, then 
  !   look up values from a table. The table can be built at run time or read from 
  !   a file (this version uses netcdf format). 
  
  ! betaDeviateTable is a 3D table with dimensions
  !   x, p, q. The range of P and Q are specified when the tables are built. 
  !   The arrays bounds are from 0 to nSteps + 1, just in case we draw exactly 0 or 1. 
  !
  character(len=128)  :: version =  '$Id: betaDistribution.F90,v 16.0 2008/07/30 22:06:18 fms Exp $'
  character(len=128)  :: tagname =  '$Name: tikal $'
  
  logical         :: module_is_initialized = .false.
  
  real, parameter :: failureValue = -1. 
  real, parameter :: Xmin = 0., Xmax = 1.

  integer         :: Pmax, Qmax, numXSteps
  real, dimension(:, :, :), allocatable &
                  :: betaDeviateTable, incompleteBetaTable
  character(len = 32) &
                  :: fileName = "INPUT/BetaDistributionTable.txt" 
  
  interface interpolateFromTable
    module procedure interpolateFromTable_s,  interpolateFromTable_1D, interpolateFromTable_2D, &
                     interpolateFromTable_3D, interpolateFromTable_4D
  end interface ! interpolateFromTable

  interface beta_deviate
    module procedure betaDeviate_s,  betaDeviate_1D, betaDeviate_2D, &
                     betaDeviate_3D, betaDeviate_4D
  end interface ! betaDeviate

  interface incomplete_beta
    module procedure incompleteBeta_s,  incompleteBeta_1D, incompleteBeta_2D, &
                     incompleteBeta_3D, incompleteBeta_4D
  end interface ! incompleteBeta

  public :: beta_dist_init, beta_deviate, incomplete_beta, beta_dist_end
contains
 ! ---------------------------------------------------------
  subroutine test_beta
  
    integer :: i
    real    :: x, inc_x, inv_inc_x, inv_x, inc_inv_x
    
    print *, "TESTING BETA" 
    print *, "x    inc(x)    inv(inc(x))   inv(x)   inc(inv(x))"
    do i = 0, numXSteps
      x = real(i)/real(numXSteps) 
      inc_x     = incomplete_beta(    x, 5, 5)
      inv_inc_x = beta_deviate(   inc_x, 5, 5)
      inv_x     = beta_deviate(       x, 5, 5)
      inc_inv_x = incomplete_beta(inv_x, 5, 5)
      write(*, "(5(f10.7, 1x))") x, inc_x, inv_inc_x, inv_x, inc_inv_x
    end do
  end subroutine test_beta
  ! ---------------------------------------------------------
  subroutine beta_dist_init
    ! Initialize the tables containing the incomplete beta function
    !   and its inverse (beta deviate). 
    !   If the table parameters are supplied we use the NAG libraries to 
    !   compute a new table and write it to a file; if just
    !   the file name is supplied we read the table from the file. 
    !
    
    !---------------------------------------------------------------------
    !    if routine has already been executed, exit.
    !---------------------------------------------------------------------
      if (module_is_initialized) return
    
    !---------------------------------------------------------------------
    !    mark the module as initialized if we're able to read the tables
    !---------------------------------------------------------------------
    call write_version_number(version, tagname)
    module_is_initialized = readFromFile(fileName)
    
  end subroutine beta_dist_init
!---------------------------------------------------------------------
  subroutine beta_dist_end

    !---------------------------------------------------------------------
    !    be sure module has been initialized.
    !---------------------------------------------------------------------
    if (.not. module_is_initialized ) return
    
    if(allocated(betaDeviateTable))    deallocate(betaDeviateTable)
    if(allocated(incompleteBetaTable)) deallocate(incompleteBetaTable)
    module_is_initialized = .false.
    
  end subroutine beta_dist_end
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     SEMI-PRIVATE PROCEDURES 
!            Not accessed directly but through generic interface
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! ---------------------------------------------------------
!  Functions to look up the beta deviate (inverse incomplete beta distribution) 
!    from a table
!    Overloaded, to allow for input arguments from 0 to 4 dimensions
!    It might be more efficient to loop over dimensions higher than 1 to 
!    avoid using reshape.
! ---------------------------------------------------------
  function betaDeviate_s(x, p, q) result (betaDeviate)
    real,                  intent( in) :: x
    integer,               intent( in) :: p, q
    real                               :: betaDeviate
    
    if (.not. module_is_initialized ) then
      call error_mesg ('beta_dist_mod', 'module has not been initialized', FATAL )
    endif
    
    if(any( (/ p < 1, p > pMax, q < 1, q > qMax, x < Xmin, x > Xmax /) )) then
      betaDeviate = FailureValue
    else
      betaDeviate = interpolateFromTable(x, p, q, betaDeviateTable)
    end if
  end function betaDeviate_s
! ---------------------------------------------------------
  function betaDeviate_1D(x, p, q) result (betaDeviate)
    real,    dimension(:),    intent( in) :: x
    integer,                  intent( in) :: p, q
    real,    dimension(size(x))           :: betaDeviate
    
    if (.not. module_is_initialized ) then
      call error_mesg ('beta_dist_mod', 'module has not been initialized', FATAL )
    endif
    
    if(any( (/ p < 1, p > pMax, q < 1, q > qMax /) )) then
      betaDeviate(:) = FailureValue
    else
      betaDeviate(:) = interpolateFromTable(x, p, q, betaDeviateTable)
    end if
  end function betaDeviate_1D
! ---------------------------------------------------------
  function betaDeviate_2D(x, p, q) result (betaDeviate)
    real,    dimension(:, :), intent( in) :: x
    integer,                  intent( in) :: p, q
    real,    dimension(size(x, 1), &
                       size(x, 2))        :: betaDeviate
    
    if (.not. module_is_initialized ) then
      call error_mesg ('beta_dist_mod', 'module has not been initialized', FATAL )
    endif
    
    if(any( (/ p < 1, p > pMax, q < 1, q > qMax /) )) then
      betaDeviate(:, :) = FailureValue
    else
      betaDeviate(:, :) = interpolateFromTable(x, p, q, betaDeviateTable)
    end if
  end function betaDeviate_2D
! ---------------------------------------------------------
  function betaDeviate_3D(x, p, q) result (betaDeviate)
    real,    dimension(:, :, :), intent( in) :: x
    integer,                     intent( in) :: p, q
    real,    dimension(size(x, 1), &
                       size(x, 2), &
                       size(x, 3))           :: betaDeviate
    
    if (.not. module_is_initialized ) then
      call error_mesg ('beta_dist_mod', 'module has not been initialized', FATAL )
    endif
    
    if(any( (/ p < 1, p > pMax, q < 1, q > qMax /) )) then
      betaDeviate(:, :, :) = FailureValue
    else
      betaDeviate(:, :, :) = interpolateFromTable(x, p, q, betaDeviateTable)
    end if
  end function betaDeviate_3D
! ---------------------------------------------------------
  function betaDeviate_4D(x, p, q) result (betaDeviate)
    real,    dimension(:, :, :, :), intent( in) :: x
    integer,                        intent( in) :: p, q
    real,    dimension(size(x, 1), size(x, 2), &
                       size(x, 3), size(x, 4))  :: betaDeviate
    
    if (.not. module_is_initialized ) then
      call error_mesg ('beta_dist_mod', 'module has not been initialized', FATAL )
    endif
    
    if(any( (/ p < 1, p > pMax, q < 1, q > qMax /) )) then
      betaDeviate(:, :, :, :) = FailureValue
    else
      betaDeviate(:, :, :, :) = interpolateFromTable(x, p, q, betaDeviateTable)
    end if
  end function betaDeviate_4D
! ---------------------------------------------------------
! ---------------------------------------------------------
!  Functions to look up the incomplete beta function from a table. 
!    Overloaded, to allow for input arguments from 0 to 4 dimensions
!    It might be more efficient to loop over dimensions higher than 1 to 
!    avoid using reshape.
! ---------------------------------------------------------
  function incompleteBeta_s(x, p, q) result (incompleteBeta)
    real,                  intent( in) :: x
    integer,               intent( in) :: p, q
    real                               :: incompleteBeta
    
    if (.not. module_is_initialized ) then
      call error_mesg ('beta_dist_mod', 'module has not been initialized', FATAL )
    endif
    
    if(any( (/ p < 1, p > pMax, q < 1, q > qMax, x < Xmin, x > Xmax /) )) then
      incompleteBeta = FailureValue
    else
      incompleteBeta = interpolateFromTable(x, p, q, incompleteBetaTable)
    end if
  end function incompleteBeta_s
! ---------------------------------------------------------
  function incompleteBeta_1D(x, p, q) result (incompleteBeta)
    real,    dimension(:),    intent( in) :: x
    integer,                  intent( in) :: p, q
    real,    dimension(size(x))           :: incompleteBeta
    
    if (.not. module_is_initialized ) then
      call error_mesg ('beta_dist_mod', 'module has not been initialized', FATAL )
    endif
    
    if(any( (/ p < 1, p > pMax, q < 1, q > qMax /) )) then
      incompleteBeta(:) = FailureValue
    else
      incompleteBeta(:) = interpolateFromTable(x, p, q, incompleteBetaTable)
    end if
  end function incompleteBeta_1D
! ---------------------------------------------------------
  function incompleteBeta_2D(x, p, q) result (incompleteBeta)
    real,    dimension(:, :), intent( in) :: x
    integer,                  intent( in) :: p, q
    real,    dimension(size(x, 1), &
                       size(x, 2))        :: incompleteBeta
    
    if (.not. module_is_initialized ) then
      call error_mesg ('beta_dist_mod', 'module has not been initialized', FATAL )
    endif
    
    if(any( (/ p < 1, p > pMax, q < 1, q > qMax /) )) then
      incompleteBeta(:, :) = FailureValue
    else
      incompleteBeta(:, :) = interpolateFromTable(x, p, q, incompleteBetaTable)
    end if
  end function incompleteBeta_2D
! ---------------------------------------------------------
  function incompleteBeta_3D(x, p, q) result (incompleteBeta)
    real,    dimension(:, :, :), intent( in) :: x
    integer,                     intent( in) :: p, q
    real,    dimension(size(x, 1), &
                       size(x, 2), &
                       size(x, 3))           :: incompleteBeta
    
    if (.not. module_is_initialized ) then
      call error_mesg ('beta_dist_mod', 'module has not been initialized', FATAL )
    endif
    
    if(any( (/ p < 1, p > pMax, q < 1, q > qMax /) )) then
      incompleteBeta(:, :, :) = FailureValue
    else
      incompleteBeta(:, :, :) = interpolateFromTable(x, p, q, incompleteBetaTable)
    end if
  end function incompleteBeta_3D
! ---------------------------------------------------------
  function incompleteBeta_4D(x, p, q) result (incompleteBeta)
    real,    dimension(:, :, :, :), intent( in) :: x
    integer,                        intent( in) :: p, q
    real,    dimension(size(x, 1), size(x, 2), &
                       size(x, 3), size(x, 4))  :: incompleteBeta
    
    if (.not. module_is_initialized ) then
      call error_mesg ('beta_dist_mod', 'module has not been initialized', FATAL )
    endif
    
    if(any( (/ p < 1, p > pMax, q < 1, q > qMax /) )) then
      incompleteBeta(:, :, :, :) = FailureValue
    else
      incompleteBeta(:, :, :, :) = interpolateFromTable(x, p, q, incompleteBetaTable)
    end if
  end function incompleteBeta_4D
! ---------------------------------------------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PRIVATE PROCEDURES 
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  ! ---------------------------------------------------------
  function interpolateFromTable_s(x, p, q, table) result (values)
    real,                      intent( in) :: x
    integer,                   intent( in) :: p, q
    real, dimension(0:, :, :), intent( in) :: table
    real                                  :: values
    
    ! Local variables
    integer :: xIndex
    real    :: xWeight
    
    ! Check to see if we're at an endpoint of the distribution 
    if      (abs(x - xMax) < spacing(Xmax)) then
      values = 1.
    else if (abs(x - XMin) < spacing(Xmin))  then
      values = 0.
    else
      !
      ! Linear interpolation in x
      !
      xIndex = int( x * numXSteps)
      xWeight = numXSteps *  x - xIndex
      values = (1. - xWeight) * table(xIndex    , p, q) + & 
               (     xWeight) * table(xIndex + 1, p, q)
    end if
  end function interpolateFromTable_s
  ! ---------------------------------------------------------
  function interpolateFromTable_1D(x, p, q, table) result(values)
    real,    dimension(:),        intent( in) :: x
    integer,                      intent( in) :: p, q
    real,    dimension(0:, :, :), intent( in) :: table
    real,    dimension(size(x))           :: values
    
    ! Local variables
    integer, dimension(size(x)) :: xIndex
    real,    dimension(size(x)) :: xWeight
    
    ! Check for parameters out of bounds, and be sure the table has been initialized. 
    ! 
    where(x(:) < Xmin .or. x(:) > Xmax) 
      values(:) = FailureValue
    else where
      !
      ! Linear interpolation in x
      !
      xIndex(:)  = int( x(:) * numXSteps)
      xWeight(:) = numXSteps *  x(:) - xIndex(:)
      values(:)  = (1. - xWeight(:)) * table(xIndex(:)    , p, q) + & 
                   (     xWeight(:)) * table(xIndex(:) + 1, p, q)
    end where

     ! Check to see if we're at an endpoint of the distribution 
    where (abs(x(:) - xMax) < spacing(Xmax)) values(:) = 1.
    where (abs(x(:) - XMin) < spacing(Xmin)) values(:) = 0.
  end function interpolateFromTable_1D
  ! ---------------------------------------------------------
  function interpolateFromTable_2D(x, p, q, table) result(values)
    real,    dimension(:, :),     intent( in) :: x
    integer,                      intent( in) :: p, q
    real,    dimension(0:, :, :), intent( in) :: table
    real,    dimension(size(x, 1), &
                       size(x, 2))           :: values
    ! Local variables 
    integer :: i
 
    do i = 1, size(x, 2)
      values(:, i) = interpolateFromTable(x(:, i), p, q, table)
    end do 
  end function interpolateFromTable_2D
  ! ---------------------------------------------------------
  function interpolateFromTable_3D(x, p, q, table) result(values)
    real,    dimension(:, :, :),  intent( in) :: x
    integer,                      intent( in) :: p, q
    real,    dimension(0:, :, :), intent( in) :: table
    real,    dimension(size(x, 1), &
                       size(x, 2), &  
                       size(x, 3))           :: values
    ! Local variables 
    integer :: i
 
    do i = 1, size(x, 3)
      values(:, :, i) = interpolateFromTable(x(:, :, i), p, q, table)
    end do 
  end function interpolateFromTable_3D
  ! ---------------------------------------------------------
  function interpolateFromTable_4D(x, p, q, table) result(values)
    real,    dimension(:, :, :, :),  intent( in) :: x
    integer,                         intent( in) :: p, q
    real,    dimension(0:, :, :),    intent( in) :: table
    real,    dimension(size(x, 1), &
                       size(x, 2), &
                       size(x, 3), &
                       size(x, 4))              :: values
    ! Local variables 
    integer :: i

    do i = 1, size(x, 4)
      values(:, :, :, i) = interpolateFromTable(x(:, :, :, i), p, q, table)
    end do 
  end function interpolateFromTable_4D
  ! ---------------------------------------------------------
  ! Reading and writing procedures
  ! ---------------------------------------------------------
  function readFromFile(fileName)
    character(len = *), intent( in) :: fileName
    logical                         :: readFromFile

    ! Local variables
!    integer, parameter :: unit = 909
    integer :: unit
    
    unit = get_unit()
    open(unit = unit, file = trim(fileName), status = 'old')
    read(unit, '(3(i5, 1x))') Pmax, Qmax, numXSteps
    allocate(   betaDeviateTable(0:numXSteps + 1, Pmax, Qmax), &
             incompleteBetaTable(0:numXSteps + 1, Pmax, Qmax))
    read(unit, '(8(f10.8, 1x))') betaDeviateTable
    read(unit, '(8(f10.8, 1x))') incompleteBetaTable
    close(unit)
 
!    print *, "Reading beta distribution tables..."
!    write(*, '(8(f10.8, 1x))') betaDeviateTable(:8, 5, 5)
!    write(*, '(8(f10.8, 1x))') incompleteBetaTable(:8, 5, 5)
   
    readFromFile = .true.
  end function readFromFile 
  
!   function readFromFile(fileName) 
!     use netcdf
!     character(len = *), intent( in) :: fileName
!     logical                         :: readFromFile
!     
!     ! Local variables - all related to netcdf
!     integer, dimension(16) :: status
!     integer                :: fileId, ncDimId, ncVarId
!    
!     status( :) = nf90_NoErr
!     status( 1) = nf90_open(trim(fileName), nf90_NoWrite, fileID)
!     status( 2) = nf90_inq_dimid(fileId, "x", ncDimId)
!     status( 3) = nf90_Inquire_Dimension(fileId, ncDimId, len = numXSteps)
!     
!     if(allocated(betaDeviateTable)) deallocate(betaDeviateTable)
!     allocate(betaDeviateTable(0:numXSteps-1, Pmax, Qmax))
!     status( 4) = nf90_inq_varId(fileId, "betaDeviateTable", ncVarId)
!     status( 5) = nf90_get_var(fileId, ncVarId, betaDeviateTable)
!     
!     if(allocated(incompleteBetaTable)) deallocate(incompleteBetaTable)
!     allocate(incompleteBetaTable(0:numXSteps-1, Pmax, Qmax))
!     status( 7) = nf90_inq_varId(fileId, "incompleteBetaTable", ncVarId)
!     status( 8) = nf90_get_var(fileId, ncVarId, betaDeviateTable)
!  
!     status( 9) = nf90_close(fileId)
!     
!     !
!     ! Make the definitions of numXSteps, consistent with what's in routine 
!     !   initializeIncBetaTables, which has a zero at one end an one extra element in each 
!     !   direction, just in case we hit the last element. 
!     ! 
!     numXSteps = numXSteps - 2
!    
!     readFromFile = all(status(:) == nf90_NoErr)
!   end function readFromFile
end module beta_dist_mod

! ============================================================================
! module numerics: a collection of useful general-purpose routines
! ============================================================================
#define __ERROR__(message) \
call my_error(mod_name,message,FATAL,thisfile,__LINE__)
#define __NOTE__(message) \
call my_error(mod_name,message,NOTE,thisfile,__LINE__)
#define __ASSERT__(x, message) \
if(.NOT.(x))call my_error(mod_name,message,FATAL,thisfile,__LINE__)

module land_numerics_mod

use fms_mod, only: error_mesg, FATAL, NOTE, write_version_number, mpp_pe, &
     stdout
use mpp_mod, only: mpp_npes, mpp_get_current_pelist, mpp_send, mpp_recv, &
     mpp_sync, mpp_sync_self, EVENT_RECV, COMM_TAG_1,  COMM_TAG_2,       &
     COMM_TAG_3,  COMM_TAG_4, COMM_TAG_5,  COMM_TAG_6, COMM_TAG_7,       &
     COMM_TAG_8, COMM_TAG_9,  COMM_TAG_10, COMM_TAG_11,  COMM_TAG_12,    &
     COMM_TAG_13, COMM_TAG_14,  COMM_TAG_15, COMM_TAG_16,  COMM_TAG_17,    &
     COMM_TAG_18, COMM_TAG_19,  COMM_TAG_20


use mpp_domains_mod, only : domain2d, mpp_get_compute_domain, &
     mpp_get_global_domain

implicit none
private

! ==== public interfaces =====================================================
public :: bisect    ! finds a position of point in array of bounds
public :: lin_int   ! linear interpolation
public :: ludcmp, lubksb ! LU decomposition and back substitution
public :: tridiag   ! tri-diagonal system solver
public :: nearest   ! nearest point search

public :: horiz_remap_type
public :: horiz_remap_new, horiz_remap_del
public :: horiz_remap_print
public :: horiz_remap

public :: numerics_init
! ==== end of public interfaces ==============================================


!     Linear interpolation.
interface lin_int
   module procedure lin_int0
   module procedure lin_int1
   module procedure lin_int2
   module procedure lin_int1m
   module procedure lin_int2m
end interface

interface nearest
   module procedure nearest1D, nearest2D
end interface

logical :: module_is_initialized =.FALSE.
! module constants
character(len=*), parameter :: &
     mod_name = 'land_numerics_mod', &
     version  = '$Id: land_numerics.F90,v 20.0 2013/12/13 23:29:53 fms Exp $', &
     tagname  = '$Name: tikal $', &
     thisfile = __FILE__
! ==== public type ===========================================================
! this data structure describes the horizontal remapping: that is, the operation 
! of copying the data from the source points to the destination points. The source
! points are not necessarily on the same PE as destination points.
type :: horiz_remap_type
   integer :: n = 0 ! number of points that need remapping on this PE
   integer, pointer :: &
       dst_i(:)=>NULL(), & ! x-indices of destination points
       dst_j(:)=>NULL()    ! y-indices of destination points
   integer, pointer :: &
       src_i(:)=>NULL(), & ! x-indices of source points
       src_j(:)=>NULL(), & ! y-indices of source points
       src_p(:)=>NULL()    ! processor number of source points
   ! data distribution map: for each processor pair that communicate 
   ! (unidirectionally), an entry in the srcPE and dstPE arrays holds their 
   ! numbers. This map is the same on each of the PEs that participate in
   ! remapping.
   integer :: mapSize = 0
   integer, pointer :: &     ! for each index:
       srcPE(:) => NULL(), & ! PE that provides the data
       dstPE(:) => NULL()    ! PE that requests and then uses the data
end type horiz_remap_type


contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-


! ============================================================================
! Initializes the numerics module.
subroutine numerics_init()

  module_is_initialized =.TRUE. 
  call write_version_number(version, tagname)

end subroutine numerics_init


! ============================================================================
!  Finds a position of point in array of bounds. Returns i, such that x is
!  between xx(i) and xx(i+1).
!  Usage:
!     value=bisect( xx, x1, periodic )
function bisect(xx, x1, periodic)
  real, intent(in)              :: xx(:)     ! array of boundaries
  real, intent(in)              :: x1        ! point to locate
  logical, intent(in), optional :: periodic  ! if present and true, the data
                                             ! domain is assumed to be periodic
  ! ---- result type ---------------------------------------------------
  integer bisect

  ! ---- local vars ----------------------------------------------------
  real    :: x              ! duplicate of input value
  integer :: low, high, mid
  integer :: n              ! size of the input array
  logical :: ascending      ! if true, the coordinates are in ascending order

  n = size(xx)
  x = x1

  ! bring the point inside bounds of the period
  if (present(periodic)) then
     if (periodic) then
	__ASSERT__(xx(n)-xx(1)/=0,"periodic bisect: period equal to zero")
	x = modulo(x-min(xx(1),xx(n)),abs(xx(n)-xx(1)))+min(xx(1),xx(n))
     endif
  endif

  ! find the coordinates
  if (x >= xx(1).and.x<=xx(n)) then
     low = 1; high = n
     ascending = xx(n) > xx(1)
     do while (high-low > 1)
        mid = (low+high)/2
        if (ascending.eqv.xx(mid) <= x) then
           low = mid
        else
           high = mid
        endif
     enddo
     bisect = low
  else
     bisect = -1
  endif

end function bisect


! ==============================================================================
!     Linearly interpolates 1-D data.
subroutine lin_int0(data, xx, x, res)
  real, intent(in) :: data(:)    ! data to interpolate
  real, intent(in) :: xx(:)      ! coordinates of the data points
  real, intent(in) :: x          ! coordinates to interpolate to
  real, intent(inout) :: res     ! result of interpolation

  ! ---- local vars ----------------------------------------------------------
  integer :: i1, i2
  real    :: f1, f2

  ! find where is our time point and calculate weights
  i1 = bisect(xx,x)
  i2 = i1+1
  __ASSERT__(i1>0.AND.i1<size(xx),"Coordinate is out of range")

  f2 = (x-xx(i1))/(xx(i2)-xx(i1))
  f1 = 1.0-f2

  ! update the result
  res = data(i1)*f1+data(i2)*f2

end subroutine lin_int0


! ==============================================================================
!     Linearly interpolates 1-D data.
subroutine lin_int1(data, xx, x, res)

  real, intent(in) :: data(:,:)    ! data to interpolate
  real, intent(in) :: xx(:)        ! coordinates of the data points
  real, intent(in) :: x            ! coordinates to interpolate to
  real, intent(inout) :: res(:)    ! result of interpolation

  ! ---- local vars ----------------------------------------------------------
  integer :: i1, i2
  real    :: f1, f2

  ! find where is our time point and calculate weights
  i1 = bisect(xx,x)
  i2 = i1+1

  __ASSERT__(i1>0.AND.i1<size(xx),"Coordinate is out of range")

  f2 = (x-xx(i1))/(xx(i2)-xx(i1))
  f1 = 1.0-f2

  ! update the result
  res = data(:,i1)*f1+data(:,i2)*f2

end subroutine lin_int1


! ==============================================================================
!     Interpolates prescribed over time.
subroutine lin_int2(data, tt, t, res)

  real, intent(in) :: data(:,:,:)  ! data to interpolate
  real, intent(in) :: tt(:)        ! time moments corresponding to data points
  real, intent(in) :: t            ! time to interpolate to
  real, intent(inout) :: res(:,:)  ! result

  ! ---- local vars ----------------------------------------------------------
  integer :: i1, i2
  real    :: f1, f2

  ! find where is our time point and calculate weights
  i1 = bisect(tt,t); i2 = i1+1
  __ASSERT__(i1>0.AND.i1<size(tt),"Coordinate is out of range")

  f2 = (t-tt(i1))/(tt(i2)-tt(i1))
  f1 = 1-f2

  ! update the result
  res = data(:,:,i1)*f1+data(:,:,i2)*f2

end subroutine lin_int2


!     Linearly interpolates 1-D data.
subroutine lin_int1m(data, xx, x, res, mask)
  real, intent(in) :: data(:,:)    ! data to interpolate
  real, intent(in) :: xx(:)        ! coordinates of the data points
  real, intent(in) :: x            ! coordinates to interpolate to
  real, intent(inout) :: res(:)    ! result of interpolation
  logical, intent(in) :: mask(:)   ! valid data mask

  ! ---- local vars ----------------------------------------------------------
  integer :: i1, i2
  real    :: f1, f2

  ! find where is our time point and calculate weights
  i1 = bisect(xx,x)
  i2 = i1+1
  __ASSERT__(i1>0.AND.i1<size(xx),"Coordinate is out of range")

  f2 = (x-xx(i1))/(xx(i2)-xx(i1))
  f1 = 1.0-f2

  ! finally, update the result
  where (mask) 
     res = data(:,i1)*f1+data(:,i2)*f2
  endwhere

end subroutine lin_int1m


! ==============================================================================
!     Interpolates prescribed over time.
subroutine lin_int2m(data, tt, t, res, mask)
  real, intent(in) :: data(:,:,:)  ! data to interpolate
  real, intent(in) :: tt(:)        ! time moments corresponding to data points
  real, intent(in) :: t            ! time to interpolate to
  real, intent(inout) :: res(:,:)  ! result
  logical, intent(in) :: mask(:,:) ! interpolation mask

  ! ---- local vars ----------------------------------------------------------
  integer :: i1, i2
  real    :: f1, f2

  ! find where is our time point and calculate weights
  i1 = bisect(tt,t); i2 = i1+1
  __ASSERT__(i1>0.AND.i1<size(tt),"Coordinate is out of range")

  f2 = (t-tt(i1))/(tt(i2)-tt(i1))
  f1 = 1-f2

  ! update the result
  where (mask) 
     res = data(:,:,i1)*f1+data(:,:,i2)*f2
  endwhere
end subroutine lin_int2m


! ==============================================================================
! given a matrix a(n,n) replaces it by LU decomposition of a row-wise permutation
! of itself indx(n) is an output that records the permutation. This routine is
! used in combination with lubksb to solve linear equations or invert a matrix
! example:
!    call ludcmp(a,indx)
!    call lubksb(a,indx,b1)
!    call lubksb(a,indx,b2)
subroutine ludcmp(a,indx,status)
  real,    intent(inout) :: a(:,:) ! matrix that gets replaced by its LU decomposition
  integer, intent(out)   :: indx(:) ! index of row permutations affected by partial pivoting
  integer, intent(out), optional :: status

  integer, parameter :: TINY = 1.0e-20
  integer :: n ! size of the matrix 
  integer :: i,j,k,imax
  real    :: aamax,dum,sum
  real    :: vv(size(a,1)) ! implicit scaling for each row

  n = size(a,1)
  if(present(status))status = 0

  ! find largest element in each row and calculate scaling 
  do i = 1,n
     aamax = 0.0
     do j = 1,n
        if(abs(a(i,j)) > aamax)aamax = abs(a(i,j))
     enddo
     if(.not.(aamax /= 0.0)) then 
        if(present(status))then
           status = -1; aamax = TINY
        else
           call error_mesg('ludcmp','Matrix is singular', FATAL)
        endif
     endif
     vv(i) = 1.0/aamax
  enddo

  ! loop over the columns of Crout's method
  do j=1,n
     do i = 1,j-1
        sum = a(i,j)
        do k = 1,i-1
           sum = sum-a(i,k)*a(k,j)
        enddo
        a(i,j) = sum
     enddo
     aamax = 0.0 ! initialize the search for the largest pivot element
     do i = j,n
        sum = a(i,j)
        do k = 1,j-1
           sum = sum-a(i,k)*a(k,j)
        enddo
        a(i,j) = sum
        dum = vv(i)*abs(sum) ! figure of merit for the pivot
        if (dum >= aamax) then ! is it better than the best so far?
           imax = i
           aamax = dum
        endif
     enddo
     if (j /= imax) then ! do we need to interchange rows?
        ! Yes, do so
        do k=1,n
           dum=a(imax,k)
           a(imax,k) = a(j,k)
           a(j,k) = dum
        enddo
        vv(imax) = vv(j)
     endif
     indx(j) = imax
     ! if the pivot element is zero, then the matrix is singular (at least to the
     ! precision of the algorithm). For some applications on singular matrices, it 
     ! is desirable to substitute TINY for zero
     if(a(j,j)==0.0) a(j,j) = TINY

     if (j/=n)then
        ! Finally, divide by the pivot element
        dum = 1.0/a(j,j)
        do i = j+1,n
           a(i,j) = a(i,j)*dum
        enddo
     endif
  enddo ! loop over the columns
end subroutine ludcmp


! ==============================================================================
! given a LU decomposition of matrix a(n,n), permutation vector indx, and right-
! hand side b, solves the set of linear equations A*X = B 
subroutine lubksb(a,indx,b)
  real,    intent(in)    :: a(:,:)  ! LU-decomposed matrix
  integer, intent(in)    :: indx(:) ! permutation vector, as returned by the ludcmp
  real,    intent(inout) :: b(:)    ! right-hand side vector, returns solution

  integer :: i,ii,j,ll,n
  real    :: sum

  n = size(a,1)
  ii = 0
  do i = 1,n
     ll = indx(i)
     sum = b(ll)
     b(ll) = b(i)
     if (ii/=0) then
        do j = ii,i-1
           sum = sum - a(i,j)*b(j)
        enddo
     else if (sum /= 0.0) then
        ii = i
     endif
     b(i) = sum
  enddo
  do i = n, 1, -1
     sum = b(i)
     do j = i+1,n
        sum = sum-a(i,j)*b(j)
     enddo
     b(i) = sum/a(i,i)
  enddo
end subroutine lubksb


! ============================================================================
! given values of the tri-diagonal matrix coefficients, computes a solution
subroutine tridiag(a,b,c,r,u)
  real, intent(in)  :: a(:),b(:),c(:),r(:)
  real, intent(out) :: u(:)

  integer :: j
  real :: bet, gam(size(a))
  
  ! check that the sizes are the same
  if(size(a)/=size(b).or.size(a)/=size(c).or.size(a)/=size(r)) &
       call error_mesg('tridiag','sizes of input arrays are not equal',FATAL)
  if(size(u)<size(a)) &
       call error_mesg('tridiag','size of the result is insufficient',FATAL)
  ! check that a(1)==0 and c(N)==0
  if(a(1)/=0.or.c(size(a))/=0) &
       call error_mesg('tridiag','a(1) and c(N) must be equal to 0',FATAL)
  ! decomposition and forward substitution
  bet = b(1)
  u(1) = r(1)/bet
  do j = 2,size(a)
     gam(j) = c(j-1)/bet
     bet = b(j)-a(j)*gam(j)
     if(bet==0) &
          call error_mesg('tridiag','system is ill-defined',FATAL)
     u(j) = (r(j)-a(j)*u(j-1))/bet
  enddo
  ! backward substitution
  do j = size(a)-1,1,-1
     u(j) = u(j)-gam(j+1)*u(j+1)
  enddo
end subroutine tridiag

! ============================================================================
! finds nearest point that is not masked out in input data
! NOTE: implemented in very naive and inefficient way
subroutine nearest1D(mask, lon, lat, plon, plat, iout, jout, dist)
  logical, intent(in) :: mask(:,:)  ! mask of valid input points (.true. if valid point)
  real,    intent(in) :: lon(:)     ! longitudes of input grid central points, radian
  real,    intent(in) :: lat(:)     ! latitudes of input grid central points, radian
  real,    intent(in) :: plon, plat ! coordinates of destination point, radian
  integer, intent(out):: iout, jout ! indices of nearest valid (unmasked) point
  real, optional, intent(out):: dist ! distance to the point 

  ! ---- local constants
  character(*),parameter :: mod_name='nearest1D'
  ! ---- local vars
  integer :: i,j
  real    :: r,r1

  __ASSERT__(size(mask,1)==size(lon),'sizes of "mask" and "lon" are inconsistent')
  __ASSERT__(size(mask,2)==size(lat),'sizes of "mask" and "lat" are inconsistent')
  
  r = HUGE(r)  ! some value larger than any possible distance

  do j = 1, size(mask,2)
  do i = 1, size(mask,1)
     if (.not.mask(i,j)) cycle
     r1 = distance(plon,plat,lon(i),lat(j))
     if ( r1 < r ) then
        iout = i
        jout = j
        r = r1
     endif
  enddo
  enddo
  if (present(dist)) dist = r
end subroutine nearest1D

! ============================================================================
! finds nearest point that is not masked out in input data
! this version works with 2D lon and lat fields
subroutine nearest2D(mask, lon, lat, plon, plat, iout, jout, dist)
  logical, intent(in) :: mask(:,:)  ! mask of valid input points (.true. if valid point)
  real,    intent(in) :: lon(:,:)   ! longitudes of input grid central points, radian
  real,    intent(in) :: lat(:,:)   ! latitudes of input grid central points, radian
  real,    intent(in) :: plon, plat ! coordinates of destination point, radian
  integer, intent(out):: iout, jout ! indices of nearest valid (unmasked) point
  real, optional, intent(out):: dist! distance to the point 

  ! ---- local constants
  character(*),parameter :: mod_name='nearest2D'
  ! ---- local vars 
  integer :: i,j
  real    :: r,r1

  __ASSERT__(ALL(SHAPE(mask)==SHAPE(lon)),'shapes of "mask" and "lon" are different')
  __ASSERT__(ALL(SHAPE(mask)==SHAPE(lat)),'shapes of "mask" and "lat" are different')

  r = HUGE(r)  ! some value larger than any possible distance

  do j = 1, size(mask,2)
  do i = 1, size(mask,1)
     if (.not.mask(i,j)) cycle
     r1 = distance(plon,plat,lon(i,j),lat(i,j))
     if ( r1 < r ) then
        iout = i
        jout = j
        r = r1
     endif
  enddo
  enddo
  if (present(dist)) dist=r
end subroutine nearest2D

! ============================================================================
! private functions that calculates the distance between two points given their 
! coordinates
function distance(lon1, lat1, lon2, lat2) ; real distance
  ! calculates distance between points on unit square
  real, intent(in) :: lon1,lat1,lon2,lat2
  
  real :: x1,y1,z1, x2,y2,z2
  real :: dlon
  dlon = (lon2-lon1)
  
  z1 = sin(lat1) ;  z2 = sin(lat2)
  y1 = 0.0       ;  y2 = cos(lat2)*sin(dlon)
  x1 = cos(lat1) ;  x2 = cos(lat2)*cos(dlon)
  
  ! distance = acos(x1*x2 + z1*z2)
  distance = (x1-x2)**2+(y1-y2)**2+(z1-z2)**2
end function distance


! ============================================================================
! deallocate memory associated with the horiz_remap_type data structure
subroutine horiz_remap_del(map)
   type(horiz_remap_type), intent(inout) :: map
#define __DEALLOC__(x)\
if (associated(x)) then; deallocate(x); x=>NULL(); endif
   __DEALLOC__(map%dst_i)
   __DEALLOC__(map%dst_j)
   __DEALLOC__(map%src_i)
   __DEALLOC__(map%src_j)
   __DEALLOC__(map%src_p)
   map%n=0
      
   __DEALLOC__(map%srcPE)
   __DEALLOC__(map%dstPE)
   map%mapSize=0   
#undef __DEALLOC__
end subroutine

! ============================================================================
! prints remapping information
subroutine horiz_remap_print(map, prefix)
   type(horiz_remap_type), intent(in) :: map
   character(*), intent(in) :: prefix

   integer :: k

   do k = 1, map%n
      write(*,100) prefix,&
         map%src_i(k),map%src_j(k),map%src_p(k),&
         map%dst_i(k),map%dst_j(k),mpp_pe()
   enddo
100 format(a,'(I:',i4.4,' J:',i4.4,' PE:',i4.4,') -> (I:',i4.4,' J:',i4.4,' PE:',i4.4,')')
end subroutine

! ============================================================================
! given the local mask of the points that need filling, the local mask of 
! the valid points, local arrays of coordinates, and the domain, returns the
! remapping information that can be used later to fill the data
subroutine horiz_remap_new(invalid, valid, lon, lat, domain, pes, map)
  logical, intent(in) :: invalid(:,:) ! mask of points to be filled
  logical, intent(in) :: valid  (:,:) ! mask of valid input points 
  real,    intent(in) :: lon(:,:)   ! longitudes of input grid central points, radian
  real,    intent(in) :: lat(:,:)   ! latitudes of input grid central points, radian
  type(domain2d), intent(in) :: domain ! our domain
  integer, intent(in) :: pes(:)     ! list of PEs
  type(horiz_remap_type), intent(out) :: map ! remapping information


  ! --- local constants  
  character(*), parameter :: mod_name='horiz_remap_new'
  ! --- local vars  
  integer :: ntot ! total number of missing points across all PEs
  integer :: is,ie,js,je ! boundaries of our compute domain
  integer :: npes ! total number of PEs
  integer :: nlon ! longitudinal size of global grid
  integer :: root_pe ! root PE for this operation
  integer, allocatable :: np(:) ! number of missing points per processor
  integer :: p ! processor iterator
  real   , allocatable :: glon(:), glat(:) ! global arrays of missing point coordinates
  integer, allocatable :: from_pe(:) ! number of PE the missing points belong to
  real   , allocatable :: dist(:) ! distance to the missing points
  integer, allocatable :: ii(:),jj(:) ! indices of the nearest points
  integer, allocatable :: ibuf(:),jbuf(:) ! send/receive buffers for indices
  real   , allocatable :: dbuf(:) ! send/receive buffer for distances
  integer :: i,j,k,m,n1
  integer :: k0

  ! get the number of longitudes in global domain (only used to resolve ambiguities
  ! in PE-count independent manner)
  call mpp_get_global_domain(domain, xsize = nlon )  
  ! get the size of our domain
  call mpp_get_compute_domain(domain, is,ie,js,je)
  ! check the input array shapes
  if(size(invalid,1)/=ie-is+1.or.size(invalid,2)/=je-js+1) then
    call my_error(mod_name,'shape of input array "'//'invalid'//'" must be the same as shape of compute domain',FATAL)
  endif
  if(size(valid,1)/=ie-is+1.or.size(valid,2)/=je-js+1) then
    call my_error(mod_name,'shape of input array "'//'valid'//'" must be the same as shape of compute domain',FATAL)
  endif
  if(size(lon,1)/=ie-is+1.or.size(lon,2)/=je-js+1) then
    call my_error(mod_name,'shape of input array "'//'lon'//'" must be the same as shape of compute domain',FATAL)
  endif
  if(size(lat,1)/=ie-is+1.or.size(lat,2)/=je-js+1) then
    call my_error(mod_name,'shape of input array "'//'lat'//'" must be the same as shape of compute domain',FATAL)
  endif
  
  ! get the number of missing points for this PE
  map%n = count(invalid)

  ! get the number of PEs that communicate
  npes = size(pes)
  ! and the number of the root PE
  root_pe = pes(1)

  ! [x] compute the global number of missing points and assemble the 
  ! array of point numbers per PE on root PE
  ! no need to send data to oneself (rab)
  if (mpp_pe()/=root_pe) then
     call mpp_send(map%n,root_pe,tag=COMM_TAG_1)
     call mpp_recv(ntot,root_pe,tag=COMM_TAG_2)
  else
     allocate(np(npes))
     np(1)=map%n
     do p = 2,npes
        call mpp_recv(np(p),pes(p),tag=COMM_TAG_1)
     enddo
     ntot = sum(np)
     do p = 2, npes
        call mpp_send(ntot,pes(p),tag=COMM_TAG_2)
     enddo
  endif
  
  call mpp_sync_self()
  ! we don't need to do anything if there are no missing points anywhere
  if (ntot==0) return
  
  ! [x] allocate global buffers
  allocate(glon(ntot),glat(ntot),from_pe(ntot),dist(ntot),ii(ntot),jj(ntot))

  ! allocate buffers for missing point indices and processors
  allocate(map%dst_i(map%n), map%dst_j(map%n))
  allocate(map%src_i(map%n), map%src_j(map%n), map%src_p(map%n))
  ! and fill the coordinates of missing points for this PE
  k = 1
  do j=1,size(invalid,2)
  do i=1,size(invalid,1)
     if (invalid(i,j)) then
        glon(k)      = lon(i,j); glat(k)      = lat(i,j)
        map%dst_i(k) = i+is-1  ; map%dst_j(k) = j+js-1
        k = k+1
     endif
  enddo
  enddo
  
  ! [x] send the array of point coordinates to root PE and get the global
  ! arrays of point coordinates in return
  if (mpp_pe()/=root_pe) then
     ! non-root PE sends its data to the root
     call mpp_send(map%n,root_pe, tag=COMM_TAG_3)
     if (map%n>0) then
        call mpp_send(glon(1), plen=map%n, to_pe=root_pe, tag=COMM_TAG_4)
        call mpp_send(glat(1), plen=map%n, to_pe=root_pe, tag=COMM_TAG_5)
     endif
     ! and then receives the global data in response
     call mpp_recv(glon(1),glen=ntot,from_pe=root_pe, tag=COMM_TAG_6)
     call mpp_recv(glat(1),glen=ntot,from_pe=root_pe, tag=COMM_TAG_7)
  else
     ! root PE receives data from all PEs and assembles global coordinate arrays 
     ! in the order of PEs in the list, except that it puts its own data first.
     from_pe(1:map%n) = root_pe
     k=map%n+1
     do p = 1,npes 
        if (pes(p)==root_pe) cycle
        call mpp_recv(n1,pes(p), tag=COMM_TAG_3)
        if (n1>0) then
           call mpp_recv(glon(k),glen=n1,from_pe=pes(p), tag=COMM_TAG_4)
           call mpp_recv(glat(k),glen=n1,from_pe=pes(p), tag=COMM_TAG_5)
           from_pe(k:k+n1-1)=pes(p)
        endif
        k = k+n1
     enddo
     ! then it distributes the resulting array among PEs
     do p = 1,npes
        if (pes(p)==root_pe) cycle
        call mpp_send(glon(1),plen=ntot,to_pe=pes(p), tag=COMM_TAG_6)
        call mpp_send(glat(1),plen=ntot,to_pe=pes(p), tag=COMM_TAG_7)
     enddo
  endif
  call mpp_sync_self()

  ! [x] find the nearest points in the domain
  do k = 1, ntot
     call nearest(valid,lon,lat,glon(k),glat(k),ii(k),jj(k),dist=dist(k))     
  enddo
  ! convert local domain indices to global
  ii(:) = ii(:)+is-1; jj(:)=jj(:)+js-1

  ! [5] send the data to root PE and let it calculate the points corresponding to 
  ! the global minimum distance
  if (mpp_pe()/=root_pe) then
     ! non-root PE just sends the data
     call mpp_send(ii(1)  ,plen=ntot,to_pe=root_pe, tag=COMM_TAG_8)
     call mpp_send(jj(1)  ,plen=ntot,to_pe=root_pe, tag=COMM_TAG_9)
     call mpp_send(dist(1),plen=ntot,to_pe=root_pe, tag=COMM_TAG_10)
     ! and receives the updated data in response
     if(map%n>0) then
        ! receive the nearest point locations and PEs
        call mpp_recv(map%src_i(1),glen=map%n,from_pe=root_pe, tag=COMM_TAG_11)
        call mpp_recv(map%src_j(1),glen=map%n,from_pe=root_pe, tag=COMM_TAG_12)
        call mpp_recv(map%src_p(1),glen=map%n,from_pe=root_pe, tag=COMM_TAG_13)
     endif
     ! receive communication map
     call mpp_recv(map%mapSize,glen=1,from_pe=root_pe, tag=COMM_TAG_14)
     if (map%mapSize>0) then
        allocate (map%srcPE(map%mapSize),map%dstPE(map%mapSize))
        call mpp_recv(map%srcPE(1),glen=map%mapSize,from_pe=root_pe, tag=COMM_TAG_15)
        call mpp_recv(map%dstPE(1),glen=map%mapSize,from_pe=root_pe, tag=COMM_TAG_16)
     endif
  else
     ! root PE does the bulk of processing: it assembles all the data
     ! and sends the relevant parts back to the processors that need them
     
     ! receive data about domain-specific nearest points from PEs and select
     ! the globally nearest point among them
     allocate(ibuf(ntot),jbuf(ntot),dbuf(ntot))
     ! note that arrays ii,jj, and dist are initially filled with the
     ! nearest points information for the root PE own domain
     from_pe(:) = root_pe
     do p = 1,npes
        if (pes(p)==root_pe) cycle
        call mpp_recv(ibuf(1),glen=ntot,from_pe=pes(p), tag=COMM_TAG_8)
        call mpp_recv(jbuf(1),glen=ntot,from_pe=pes(p), tag=COMM_TAG_9)
        call mpp_recv(dbuf(1),glen=ntot,from_pe=pes(p), tag=COMM_TAG_10)
        do k = 1,ntot
           ! to avoid dependence on the order of operations, give preference
           ! to the lowest leftmost point among the equidistant points
           if (dbuf(k)<dist(k).or.(&
               dbuf(k)==dist(k).and.jbuf(k)*nlon+ibuf(k)<jj(k)*nlon+ii(k))) then
              ii(k)=ibuf(k); jj(k)=jbuf(k); dist(k)=dbuf(k); from_pe(k)=pes(p)
           endif
        enddo
     enddo
     
     ! release buffers
     deallocate (ibuf,jbuf,dbuf)

     ! create a communication map: arrays srcPE and dstPE listing all pairs that
     ! communicate
     allocate(map%srcPE(ntot),map%dstPE(ntot)) ! allocate max possible number
     k0=1; m=1
     do p = 1, npes
        do k = sum(np(1:p-1))+1, sum(np(1:p))
           if (from_pe(k) == pes(p)) cycle ! skip communications to itself 
           if (ANY(map%srcPE(k0:m-1)==from_pe(k))) cycle ! skip src->dst pair that already exists
           ! add current pair to the communication map
           map%srcPE(m)=from_pe(k); map%dstPE(m)=pes(p); m=m+1
        enddo
        k0=m
     enddo
     
     ! actual number of elements in comm. map is m-1
     map%mapSize=m-1

     ! simply assign the results for the root PE
     if (map%n>0) then
        map%src_i(:) = ii(1:map%n)
        map%src_j(:) = jj(1:map%n)
        map%src_p(:) = from_pe(1:map%n)
     endif
     ! distribute the results among processors
     k = map%n+1
     do p = 1,npes
        if (pes(p)==root_pe) cycle
        if (np(p)>0) then
           ! send nearest point location
           call mpp_send(ii(k),plen=np(p),to_pe=pes(p), tag=COMM_TAG_11)
           call mpp_send(jj(k),plen=np(p),to_pe=pes(p), tag=COMM_TAG_12)
           call mpp_send(from_pe(k),plen=np(p),to_pe=pes(p), tag=COMM_TAG_13)
        endif
        ! broadcast comm. map
        call mpp_send(map%mapSize,plen=1,to_pe=pes(p), tag=COMM_TAG_14)
        if (map%mapSize>0) then
           call mpp_send(map%srcPE(1),plen=map%mapSize,to_pe=pes(p), tag=COMM_TAG_15)
           call mpp_send(map%dstPE(1),plen=map%mapSize,to_pe=pes(p), tag=COMM_TAG_16)
        endif
        call mpp_sync_self()
        k = k+np(p)
     enddo
     
  endif

  call mpp_sync_self()

  deallocate(glon,glat,from_pe,dist,ii,jj)
  
  ! note that many communications in this routine can be sped up if the data 
  ! are combined.
  ! For example instead of sending ii,jj,and from_pe one can encode them
  ! in a single integer array [ a(i*3-2)=ii(i), a(i*3-1)=jj(i), a(i*3)=from_pe(i) ]
  ! and send that array.

end subroutine

! ============================================================================
subroutine horiz_remap(map,domain,d)
  type(horiz_remap_type), intent(in)    :: map
  type(domain2d)        , intent(in)    :: domain
  real                  , intent(inout) :: d(:,:,:) ! field to fill
  
  ! ---- local vars
  integer :: is,ie,js,je ! bounds of out compute domain
  integer :: i,j,k,n
  integer, allocatable :: ii(:),jj(:)
  real   , allocatable :: buf(:,:)
  logical :: ltmp

  ! get the boundaries of the compute domain, for global->local index
  ! conversion
  call mpp_get_compute_domain(domain, is,ie,js,je)

  ltmp = size(d,1)==ie-is+1.or.size(d,2)==je-js+1
  __ASSERT__(ltmp,'shape of data must be the same as shape of compute domain')

  ! handle the local points
  do i = 1, map%n
     if (map%src_p(i)==mpp_pe()) then
       d(map%dst_i(i)-is+1,map%dst_j(i)-js+1,:) = &
       d(map%src_i(i)-is+1,map%src_j(i)-js+1,:)
     endif
  enddo

  ! exchange information with other processors
  do k = 1, map%mapSize
     if (map%srcPE(k)==mpp_pe()) then
        ! get the size of the data from the other PE
        call mpp_recv(n,map%dstPE(k), tag=COMM_TAG_17)
        allocate(ii(n),jj(n),buf(n,size(d,3)))
        ! get the indices
        call mpp_recv(ii(1),glen=n,from_pe=map%dstPE(k), tag=COMM_TAG_18)
        call mpp_recv(jj(1),glen=n,from_pe=map%dstPE(k), tag=COMM_TAG_19)
        ! fill the buffer
        do i = 1,n
           if(ii(i)<is.or.ii(i)>ie) call error_mesg('distr_fill','requested index i outside of domain', FATAL)
           if(jj(i)<js.or.jj(i)>je) call error_mesg('distr_fill','requested index j outside of domain', FATAL)
           buf(i,:) = d(ii(i)-is+1,jj(i)-js+1,:)
        enddo
        ! send the buffer
        call mpp_send(buf(1,1),plen=size(buf),to_pe=map%dstPE(k), tag=COMM_TAG_20)
        call mpp_sync_self()
        deallocate (ii,jj,buf)
     else if (map%dstPE(k)==mpp_pe()) then
        ! send data request
        n = count(map%src_p(:)==map%srcPE(k))
        ! alloacate and fill arrays of requested indices ii and jj
        allocate(ii(n),jj(n),buf(n,size(d,3)))
        j = 1
        do i = 1, map%n
           if (map%src_p(i)==map%srcPE(k)) then
              ii(j) = map%src_i(i); jj(j) = map%src_j(i) ; j = j+1
           endif
        enddo
        ! send the data request
        call mpp_send(n,map%srcPE(k), tag=COMM_TAG_17)
        call mpp_send(ii(1),plen=n,to_pe=map%srcPE(k), tag=COMM_TAG_18)
        call mpp_send(jj(1),plen=n,to_pe=map%srcPE(k), tag=COMM_TAG_19)

        ! get the response
        call mpp_recv(buf(1,1),glen=size(buf),from_pe=map%srcPE(k), tag=COMM_TAG_20)
        ! fill the data 
        j = 1
        do i = 1,map%n
           if (map%src_p(i)==map%srcPE(k)) then
              d(map%dst_i(i)-is+1,map%dst_j(i)-js+1,:) = buf(j,:) ; j = j+1
           endif
        enddo
        call mpp_sync_self()
        deallocate (ii,jj,buf)
     endif
  enddo

end subroutine

! ==============================================================================
! Reports error, including file name and line.
subroutine my_error(mod_name, message, mode, file, line)

  character(len=*), intent(in) :: mod_name
  character(len=*), intent(in) :: message
  integer,          intent(in) :: mode
  character(len=*), intent(in), optional :: file
  integer,          intent(in), optional :: line

  ! ---- local vars ----------------------------------------------------------
  character(len=512) :: mesg
  if(present(file)) then ! assume that file and line are either both present or not
     write(mesg,'("File ",a," Line ",i4.4," :: ",a)')&
       file, line, trim(message)
  else
    mesg = trim(message)
  endif
  call error_mesg(mod_name, mesg, mode)
end subroutine


end module land_numerics_mod

MODULE diag_axis_mod
  ! <CONTACT EMAIL="seth.underwood@noaa.gov">
  !   Seth Underwood
  ! </CONTACT>

  ! <OVERVIEW> <TT>diag_axis_mod</TT> is an integral part
  !   of diag_manager_mod. It helps to create axis IDs
  !   that are used in register_diag_field.
  ! </OVERVIEW>

  ! <DESCRIPTION> Users first create axis ID by calling
  !   diag_axis_init, then use this axis ID in
  !   register_diag_field.
  ! </DESCRIPTION>

  USE mpp_domains_mod, ONLY: domain1d, domain2d, mpp_get_compute_domain,&
       & mpp_get_domain_components, null_domain1d, null_domain2d,&
       & OPERATOR(.NE.), mpp_get_global_domain, mpp_get_domain_name
  USE fms_mod, ONLY: error_mesg, write_version_number, lowercase, uppercase, FATAL
  USE diag_data_mod, ONLY: diag_axis_type, max_subaxes, max_axes,&
       & max_num_axis_sets

  IMPLICIT NONE

  PRIVATE
  PUBLIC  diag_axis_init, get_diag_axis, get_domain1d, get_domain2d,&
       & get_axis_length, get_axis_global_length, diag_subaxes_init,&
       & get_diag_axis_cart, get_diag_axis_data, max_axes, get_axis_aux,&
       & get_tile_count, get_axes_shift, get_diag_axis_name,&
       & get_axis_num, get_diag_axis_domain_name


  ! Module variables
  ! Parameters
  CHARACTER(len=128), PARAMETER :: version =&
       & '$Id$'
  CHARACTER(len=128), PARAMETER :: tagname =&
       & '$Name$'

  ! counter of number of axes defined
  INTEGER, DIMENSION(:), ALLOCATABLE :: num_subaxes
  INTEGER :: num_def_axes = 0

  ! storage for axis set names
  CHARACTER(len=128), DIMENSION(:), ALLOCATABLE, SAVE :: Axis_sets
  INTEGER :: num_axis_sets = 0

  ! ---- global storage for all defined axes ----
  TYPE(diag_axis_type), ALLOCATABLE, SAVE :: Axes(:)
  LOGICAL :: module_is_initialized = .FALSE.

CONTAINS

  ! <FUNCTION NAME="diag_axis_init">
  !   <OVERVIEW>
  !     Initialize the axis, and return the axis ID.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     INTEGER FUNCTION diag_axis_init(name, data, units, cart_name, long_name,
  !           direction, set_name, edges, Domain, Domain2, aux, tile_count)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     <TT>diag_axis_init</TT> initializes an axis and returns the axis ID that
  !     is to be used with <TT>register_diag_field</TT>.  This function also
  !     increments the axis counter and fills in the axes
  !   </DESCRIPTION>
  !   <IN NAME="name" TYPE="CHARACTER(len=*)">Short name for axis</IN>
  !   <IN NAME="data" TYPE="REAL, DIMENSION(:)">Array of coordinate values</IN>
  !   <IN NAME="units" TYPE="CHARACTER(len=*)">Units for the axis</IN>
  !   <IN NAME="cart_name" TYPE="CHARACTER(len=*)">
  !     Cartesian axis ("X", "Y", "Z", "T")
  !   </IN>
  !   <IN NAME="direction" TYPE="INTEGER, OPTIONAL" DEFAULT="0">
  !     Indicates the direction of the axis:
  !     <UL>
  !       <LI>Up if +1</LI>
  !       <LI>Down if -1</LI>
  !       <LI>Neither up or down if 0</LI>
  !     </UL>
  !   </IN>
  !   <IN NAME="long_name" TYPE="CHARACTER(len=*), OPTIONAL" DEFAULT="name">
  !     Long name for the axis.
  !   </IN>
  !   <IN NAME="edges" TYPE="INTEGER, OPTIONAL">
  !     Axis ID for the previously defined "edges axis"
  !   </IN>
  !   <IN NAME="Domain" TYPE="TYPE(domain1d), OPTIONAL" />
  !   <IN NAME="Domain2" TYPE="TYPE(domain2d), OPTIONAL" />
  !   <IN NAME="aux" TYPE="CHARACTER(len=*), OPTIONAL">
  !     Auxiliary name, can only be <TT>geolon_t</TT> or <TT>geolat_t</TT>
  !   </IN>
  !   <IN NAME="tile_count" TYPE="INTEGER, OPTIONAL" />
  INTEGER FUNCTION diag_axis_init(name, DATA, units, cart_name, long_name, direction,&
       & set_name, edges, Domain, Domain2, aux, tile_count)
    CHARACTER(len=*), INTENT(in) :: name
    REAL, DIMENSION(:), INTENT(in) :: DATA
    CHARACTER(len=*), INTENT(in) :: units
    CHARACTER(len=*), INTENT(in) :: cart_name
    CHARACTER(len=*), INTENT(in), OPTIONAL :: long_name, set_name
    INTEGER, INTENT(in), OPTIONAL :: direction, edges
    TYPE(domain1d), INTENT(in), OPTIONAL :: Domain
    TYPE(domain2d), INTENT(in), OPTIONAL :: Domain2
    CHARACTER(len=*), INTENT(in), OPTIONAL :: aux
    INTEGER, INTENT(in), OPTIONAL :: tile_count

    TYPE(domain1d) :: domain_x, domain_y
    INTEGER :: ierr, axlen
    INTEGER :: i, set, tile
    INTEGER :: isc, iec, isg, ieg
    CHARACTER(len=128) :: emsg

    IF ( .NOT.module_is_initialized ) THEN
       CALL write_version_number( version, tagname )
    ENDIF

    IF ( PRESENT(tile_count)) THEN
       tile = tile_count
    ELSE
       tile = 1
    END IF

    ! Allocate the axes
    IF (.NOT. ALLOCATED(Axis_sets)) ALLOCATE(Axis_sets(max_num_axis_sets))
    IF (.NOT. ALLOCATED(Axes)) ALLOCATE(Axes(max_axes))
    IF (.NOT. ALLOCATED(num_subaxes)) THEN
       ALLOCATE(num_subaxes(max_axes))
       num_subaxes = 0
    END IF

    !---- is there an axis set? ----
    IF ( PRESENT(set_name) ) THEN
       set = get_axis_set_num (set_name)
       !---- add new set name ----
       IF (set == 0) THEN
          num_axis_sets = num_axis_sets + 1
          IF ( num_axis_sets > max_num_axis_sets ) THEN
             WRITE (emsg, FMT='("num_axis_sets (",I2,") exceeds max_num_axis_sets (",I2,"). ")')&
                  & num_axis_sets, max_num_axis_sets
             ! <ERROR STATUS="FATAL">
             !   num_axis_sets (<num_axis_sets>) exceeds max_num_axis_sets(<num_axis_sets>).
             !   Increase max_num_axis_sets via diag_manager_nml.
             ! </ERROR>
             CALL error_mesg('diag_axis_mod::diag_axis_init',&
                  & TRIM(emsg)//'  Increase max_num_axis_sets via diag_manager_nml.', FATAL)
          END IF
          set = num_axis_sets
          Axis_sets(set) = set_name
       END IF
    ELSE
       set = 0
    END IF

    !---- see if axis already exists --
    ! if this is time axis, return the ID of a previously defined
    ! if this is spatial axis, FATAL error
    DO i = 1, num_def_axes
       IF ( TRIM(name) == Axes(i)%name ) THEN
          IF ( TRIM(name) == 'Stations' .OR. TRIM(name) == 'Levels') THEN
             diag_axis_init = i
             RETURN
          ELSE IF ( set == Axes(i)%set ) THEN
             IF ( TRIM(lowercase(name)) == 'time' .OR.&
                  & TRIM(lowercase(cart_name)) == 't' .OR.&
                  & TRIM(lowercase(name)) == 'nv' .OR.&
                  & TRIM(lowercase(cart_name)) == 'n' ) THEN
                diag_axis_init = i
                RETURN
             ELSE IF ( (lowercase(cart_name) /= 'x' .AND. lowercase(cart_name) /= 'y')&
                  & .OR. tile /= Axes(i)%tile_count) THEN
                ! <ERROR STATUS="FATAL">axis_name <NAME> and axis_set already exist.</ERROR>
                CALL error_mesg('diag_axis_mod::diag_axis_init',&
                     & 'axis_name '//TRIM(name)//' and axis_set already exist.', FATAL)
             END IF
          END IF
       END IF
    END DO

    !---- register axis ----
    num_def_axes = num_def_axes + 1
    ! <ERROR STATUS="FATAL">max_axes exceeded, increase it via diag_manager_nml</ERROR>
    IF (num_def_axes > max_axes) CALL error_mesg ('diag_axis_mod::diag_axis_init',&
         & 'max_axes exceeded, increase via diag_manager_nml', FATAL)
    diag_axis_init = num_def_axes

    !---- check and then save cart_name name ----
    IF ( TRIM(uppercase(cart_name)) == 'X' .OR.&
         & TRIM(uppercase(cart_name)) == 'Y' .OR.&
         & TRIM(uppercase(cart_name)) == 'Z' .OR.&
         & TRIM(uppercase(cart_name)) == 'T' .OR.&
         & TRIM(uppercase(cart_name)) == 'N' ) THEN
       Axes(diag_axis_init)%cart_name = TRIM(uppercase(cart_name))
    ELSE
       ! <ERROR STATUS="FATAL">Invalid cart_name name.</ERROR>
       CALL error_mesg('diag_axis_mod::diag_axis_init', 'Invalid cart_name name.', FATAL)
    END IF

    !---- allocate storage for coordinate values of axis ----
    IF ( Axes(diag_axis_init)%cart_name == 'T' ) THEN
       axlen = 0
    ELSE
       axlen = SIZE(DATA(:))
    END IF
    ALLOCATE ( Axes(diag_axis_init)%data(1:axlen) )

    ! Initialize Axes(diag_axis_init)
    Axes(diag_axis_init)%name   = TRIM(name)
    Axes(diag_axis_init)%data   = DATA(1:axlen)
    Axes(diag_axis_init)%units  = units
    Axes(diag_axis_init)%length = axlen
    Axes(diag_axis_init)%set    = set
    ! start and end are used in subaxes information only
    Axes(diag_axis_init)%start = -1
    Axes(diag_axis_init)%end = -1
    Axes(diag_axis_init)%subaxis_name = ""
    Axes(diag_axis_init)%shift = 0

    IF ( PRESENT(long_name) ) THEN
       Axes(diag_axis_init)%long_name = long_name
    ELSE
       Axes(diag_axis_init)%long_name = name
    END IF

    IF ( PRESENT(aux) ) THEN
       Axes(diag_axis_init)%aux = TRIM(aux)
    ELSE
       Axes(diag_axis_init)%aux = 'none'
    END IF

    !---- axis direction (-1, 0, or +1) ----
    IF ( PRESENT(direction) )THEN
       IF ( ABS(direction) /= 1 .AND. direction /= 0 )&
            ! <ERROR STATUS="FATAL">direction must be 0, +1, or -1</ERROR>
            & CALL error_mesg('diag_axis_mod::diag_axis_init', 'direction must be 0, +1 or -1', FATAL)
       Axes(diag_axis_init)%direction = direction
    ELSE
       Axes(diag_axis_init)%direction = 0
    END IF

    !---- domain2d type ----
    IF ( PRESENT(Domain2) .AND. PRESENT(Domain)) THEN
       ! <ERROR STATUS="FATAL">Presence of both Domain and Domain2 at the same time is prohibited</ERROR>
       CALL error_mesg('diag_axis_mod::diag_axis_init',&
            & 'Presence of both Domain and Domain2 at the same time is prohibited', FATAL)
    ELSE IF ( PRESENT(Domain2) .OR. PRESENT(Domain)) THEN
       IF ( Axes(diag_axis_init)%cart_name /= 'X' .AND. Axes(diag_axis_init)%cart_name /= 'Y') THEN
          ! <ERROR STATUS="FATAL">Domain must not be present for an axis which is not in the X or Y direction.</ERROR>
          CALL error_mesg('diag_axis_mod::diag_axis_init',&
               & 'Domain must not be present for an axis which is not in the X or Y direction', FATAL)
       END IF
    END IF

    Axes(diag_axis_init)%tile_count = tile

    IF ( PRESENT(Domain2) ) THEN
       Axes(diag_axis_init)%Domain2 = Domain2
       CALL mpp_get_domain_components(Domain2, domain_x, domain_y, tile_count=tile_count)
       IF ( Axes(diag_axis_init)%cart_name == 'X' ) Axes(diag_axis_init)%Domain = domain_x
       IF ( Axes(diag_axis_init)%cart_name == 'Y' ) Axes(diag_axis_init)%Domain = domain_y
    ELSE IF ( PRESENT(Domain)) THEN
       !---- domain1d type ----
       Axes(diag_axis_init)%Domain2 = null_domain2d ! needed since not 2-D domain
       Axes(diag_axis_init)%Domain = Domain
    ELSE
       Axes(diag_axis_init)%Domain2 = null_domain2d
       Axes(diag_axis_init)%Domain = null_domain1d
    END IF


    !--- set up the shift value for x-y axis
    IF ( Axes(diag_axis_init)%Domain .NE. null_domain1d ) THEN
       CALL mpp_get_compute_domain(Axes(diag_axis_init)%Domain, isc, iec)
       CALL mpp_get_global_domain(Axes(diag_axis_init)%Domain, isg, ieg)
       IF ( Axes(diag_axis_init)%length == ieg - isg + 2 ) THEN
          Axes(diag_axis_init)%shift = 1
       END IF
    END IF

    !---- have axis edges been defined ? ----
    Axes(diag_axis_init)%edges = 0
    IF (PRESENT(edges) ) THEN
       IF ( edges > 0 .AND. edges < num_def_axes ) THEN
          ierr=0
          IF ( Axes(edges)%cart_name /= Axes(diag_axis_init)%cart_name) ierr=1
          IF ( Axes(edges)%length    /= Axes(diag_axis_init)%length+1 ) ierr=ierr+2
          IF ( Axes(edges)%set       /= Axes(diag_axis_init)%set      ) ierr=ierr+4
          IF ( ierr > 0 )   THEN
             ! <ERROR STATUS="FATAL">Edges axis does not match axis (code <CODE>).</ERROR>
             WRITE (emsg,'("Edges axis does not match axis (code ",I1,").")') ierr
             CALL error_mesg('diag_axis_mod::diag_axis_init', emsg, FATAL)
          END IF
          Axes(diag_axis_init)%edges = edges
       ELSE
          ! <ERROR STATUS="FATAL">Edges axis is not defined.</ERROR>
          CALL error_mesg('diag_axis_mod::diag_axis_init', 'Edges axis is not defined', FATAL)
       END IF
    END IF

    ! Module is now initialized
    module_is_initialized = .TRUE.

  END FUNCTION diag_axis_init
  ! </FUNCTION>

  ! <FUNCTION NAME="diag_subaxes_init">
  !   <OVERVIEW>
  !     Create a subaxis on a parent axis.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     INTEGER FUNCTION diag_subaxes_init(axis, subdata, start_indx, end_indx,
  !           domain_1d, domain_2d)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Given the ID of a parent axis, create a subaxis and fill it with data,
  !     and return the ID of the corresponding subaxis.
  !
  !     The subaxis is defined on the parent axis from <TT>start_indx</TT>
  !     to <TT>end_indx</TT>.
  !   </DESCRIPTION>
  !   <IN NAME="axis" TYPE="INTEGER">ID of the parent axis</IN>
  !   <IN NAME="subdata" TYPE="REAL, DIMENSION(:)">Data of the subaxis</IN>
  !   <IN NAME="start_indx" TYPE="INTEGER">Start index of the subaxis</IN>
  !   <IN NAME="end_indx" TYPE="INTEGER">End index of the subaxis</IN>
  !   <IN NAME="domain_1d" TYPE="TYPE(domain1d), OPTIONAL" />
  !   <IN NAME="domain_2d" TYPE="TYPE(domain2d), OPTIONAL" />
  INTEGER FUNCTION diag_subaxes_init(axis, subdata, start_indx, end_indx, domain_2d)
    INTEGER, INTENT(in) :: axis
    REAL, DIMENSION(:), INTENT(in) :: subdata
    INTEGER, INTENT(in) :: start_indx
    INTEGER, INTENT(in) :: end_indx
    TYPE(domain2d), INTENT(in), OPTIONAL  :: domain_2d

    INTEGER :: i, nsub_axis, direction
    INTEGER :: xbegin, xend, ybegin, yend
    INTEGER :: ad_xbegin, ad_xend, ad_ybegin, ad_yend
    CHARACTER(len=128) :: name, nsub_name
    CHARACTER(len=128) :: units
    CHARACTER(len=128) :: cart_name
    CHARACTER(len=128) :: long_name
    CHARACTER(len=128) :: emsg
    LOGICAL :: subaxis_set, hasDomain

    ! there may be more than 1 subaxis on a parent axis, check for redundancy
    nsub_axis = 0
    subaxis_set = .FALSE.

    IF ( PRESENT(domain_2d) ) THEN
       hasDomain = .TRUE.
       CALL mpp_get_compute_domain(domain_2d, xbegin, xend, ybegin, yend)
    ELSE
       hasDomain = .FALSE.
    END IF
    sa_search: DO i = 1, num_subaxes(axis)
       IF ( start_indx == Axes(axis)%start(i) .AND. end_indx == Axes(axis)%end(i) ) THEN
          IF ( hasDomain ) THEN
             CALL mpp_get_compute_domain(Axes(axis)%subaxis_domain2(i), ad_xbegin, ad_xend, ad_ybegin, ad_yend)
             IF ( .NOT.((xbegin == ad_xbegin .AND. xend == ad_xend) .AND.&
                  & (ybegin == ad_ybegin .AND. yend == ad_yend)) ) THEN
                CYCLE sa_search
             END IF
          END IF
          nsub_axis = i
          subaxis_set = .TRUE.    !subaxis already exists
          name = TRIM(Axes(axis)%subaxis_name(nsub_axis))
          EXIT sa_search
       END IF
    END DO sa_search

    IF ( nsub_axis == 0 ) THEN  ! create new subaxis
       num_subaxes(axis) = num_subaxes(axis) + 1
       IF (num_subaxes(axis) > max_subaxes) THEN
          ! <ERROR STATUS="FATAL">max_subaxes (value <VALUE>) is too small.  Consider increasing max_subaxes.</ERROR>
          WRITE (emsg,'("max_subaxes (value ",I4,") is too small.  Consider increasing max_subaxes.")') max_subaxes
          CALL error_mesg('diag_axis_mod::diag_subaxes_init', emsg, FATAL)
       END IF
       nsub_axis = num_subaxes(axis)
       Axes(axis)%start(nsub_axis) = start_indx
       Axes(axis)%end(nsub_axis)   = end_indx
       if ( hasDomain ) Axes(axis)%subaxis_domain2(nsub_axis) = domain_2d
    END IF

    ! Create new name for the subaxis from name of parent axis
    ! If subaxis already exists, get the index and return
    IF(subaxis_set) THEN
       IF ( Axes(axis)%set > 0 ) THEN
          diag_subaxes_init = get_axis_num(name, set_name=TRIM(Axis_sets(Axes(axis)%set)))
       ELSE
          diag_subaxes_init = get_axis_num(name)
       END IF
    ELSE
       ! get a new index for subaxis
       !::sdu:: Need a check to allow larger numbers in the index number.
       WRITE (nsub_name,'(I2.2)') nsub_axis
       name = TRIM(Axes(axis)%name)//'_sub'//TRIM(nsub_name)
       Axes(axis)%subaxis_name(nsub_axis) = name
       long_name = TRIM(Axes(axis)%long_name)
       units = TRIM(Axes(axis)%units)
       cart_name = TRIM(Axes(axis)%cart_name)
       direction = Axes(axis)%direction
       IF (Axes(axis)%set > 0) THEN
          diag_subaxes_init =  diag_axis_init (TRIM(name), subdata, TRIM(units), TRIM(cart_name), TRIM(long_name),&
               & set_name=TRIM(Axis_sets(Axes(axis)%set)), direction=direction, Domain2=domain_2d)
       ELSE
          diag_subaxes_init =  diag_axis_init (TRIM(name), subdata, TRIM(units), TRIM(cart_name), TRIM(long_name),&
               & direction=direction, Domain2=domain_2d)
       END IF
    END IF
  END FUNCTION diag_subaxes_init
  ! </FUNCTION>

  ! <SUBROUTINE NAME="get_diag_axis">
  !   <OVERVIEW>
  !     Return information about the axis with index ID
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE get_diag_axis(id, name, units, long_name, cart_name,
  !          direction, edges, Domain, data)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Return information about the axis with index ID
  !   </DESCRIPTION>
  !   <IN NAME="id" TYPE="INTEGER">Axis ID</IN>
  !   <OUT NAME="name" TYPE="CHARACTER(len=*)">Short name for axis</OUT>
  !   <OUT NAME="units" TYPE="CHARACTER(len=*)">Units for axis</OUT>
  !   <OUT NAME="long_name" TYPE="CHARACTER(len=*)">Long name for axis</OUT>
  !   <OUT NAME="cart_name" TYPE="CHARACTER(len=*)">
  !     Cartesian axis ("x", "y", "z", "t").
  !   </OUT>
  !   <OUT NAME="direction" TYPE="INTEGER">
  !     Direction of data. (See <TT>diag_axis_init</TT> for a description of
  !     allowed values)
  !   </OUT>
  !   <OUT NAME="edges" TYPE="INTEGER">
  !     Axis ID for the previously defined "edges axis".
  !   </OUT>
  !   <OUT NAME="Domain" TYPE="TYPE(domain1d)" />
  !   <OUT NAME="data" TYPE="REAL, DIMENSION(:)">
  !     Array of coordinate values for this axis.
  !   </OUT>
  SUBROUTINE get_diag_axis(id, name, units, long_name, cart_name,&
       & direction, edges, Domain, DATA)
    CHARACTER(len=*), INTENT(out) :: name, units, long_name, cart_name
    INTEGER, INTENT(in) :: id
    TYPE(domain1d), INTENT(out) :: Domain
    INTEGER, INTENT(out) :: direction, edges
    REAL, DIMENSION(:), INTENT(out) :: DATA

    CALL valid_id_check(id, 'get_diag_axis')
    name      = Axes(id)%name
    units     = Axes(id)%units
    long_name = Axes(id)%long_name
    cart_name = Axes(id)%cart_name
    direction = Axes(id)%direction
    edges     = Axes(id)%edges
    Domain    = Axes(id)%Domain
    IF ( Axes(id)%length > SIZE(DATA(:)) ) THEN
       ! <ERROR STATUS="FATAL">array data is too small.</ERROR>
       CALL error_mesg('diag_axis_mod::get_diag_axis', 'array data is too small', FATAL)
    ELSE
       DATA(1:Axes(id)%length) = Axes(id)%data(1:Axes(id)%length)
    END IF
  END SUBROUTINE get_diag_axis
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="get_diag_axis_cart">
  !   <OVERVIEW>
  !     Return the axis cartesian.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE get_diag_axis_cart(id, cart_name)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Return the axis cartesian ('X', 'Y', 'Z' or 'T') for the axis ID given.
  !   </DESCRIPTION>
  !   <IN NAME="id" TYPE="INTEGER">Axis ID</IN>
  !   <OUT NAME="cart_name" TYPE="CHARACTER(len=*)">Cartesian axis</OUT>
  SUBROUTINE get_diag_axis_cart(id, cart_name)
    INTEGER, INTENT(in)           :: id
    CHARACTER(len=*), INTENT(out) :: cart_name

    CALL valid_id_check(id, 'get_diag_axis_cart')
    cart_name = Axes(id)%cart_name
  END SUBROUTINE get_diag_axis_cart
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="get_diag_axis_data">
  !   <OVERVIEW>
  !     Return the axis data.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE get_diag_axis_data(id, data)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Return the axis data for the axis ID given.
  !   </DESCRIPTION>
  !   <IN NAME="id" TYPE="INTEGER">Axis ID</IN>
  !   <OUT NAME="data" TYPE="REAL, DIMENSION(:)">Axis data</OUT>
  SUBROUTINE get_diag_axis_data(id, DATA)
    INTEGER, INTENT(in) :: id
    REAL, DIMENSION(:), INTENT(out) :: DATA

    CALL valid_id_check(id, 'get_diag_axis_data')
    IF (Axes(id)%length > SIZE(DATA(:))) THEN
       ! <ERROR STATUS="FATAL">array data is too small</ERROR>
       CALL error_mesg('diag_axis_mod::get_diag_axis_data', 'array data is too small', FATAL)
    ELSE
       DATA(1:Axes(id)%length) = Axes(id)%data
    END IF
  END SUBROUTINE get_diag_axis_data
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="get_diag_axis_name">
  !   <OVERVIEW>
  !     Return the short name of the axis.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE get_diag_axis_name (id, name)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Return the short name for the axis ID given.
  !   </DESCRIPTION>
  !   <IN NAME="id" TYPE="INTEGER">Axis ID</IN>
  !   <OUT NAME="name" TYPE="CHARACTER(len=*)">Axis short name</OUT>
  SUBROUTINE get_diag_axis_name(id, name)
    INTEGER         , INTENT(in)  :: id
    CHARACTER(len=*), INTENT(out) :: name

    CALL valid_id_check(id, 'get_diag_axis_name')
    name = Axes(id)%name
  END SUBROUTINE get_diag_axis_name
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="get_diag_axis_domain_name">
  !   <OVERVIEW>
  !     Return the name of the axis' domain
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE get_diag_axis_domain_name(id, name)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Retruns the name of the axis' domain.
  !   </DESCRIPTION>
  !   <IN NAME="id" TYPE="INTEGER">Axis ID</IN>
  !   <OUT NAME="name" TYPE="CHARACTER(len=*)">Axis' domain name</OUT>
  SUBROUTINE get_diag_axis_domain_name(id, name)
    INTEGER, INTENT(in) :: id
    CHARACTER(len=*), INTENT(out) :: name

    CALL valid_id_check(id, 'get_diag_axis_domain_name')
    name = mpp_get_domain_name(Axes(id)%domain2)
  END SUBROUTINE get_diag_axis_domain_name
  ! </SUBROUTINE>

  ! <FUNCTION NAME="get_axis_length">
  !   <OVERVIEW>
  !     Return the length of the axis.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     INTEGER FUNCTION get_axis_length(id)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Return the length of the axis ID given.
  !   </DESCRIPTION>
  !   <IN NAME="id" TYPE="INTEGER">Axis ID</IN>
  INTEGER FUNCTION get_axis_length(id)
    INTEGER, INTENT(in) :: id

    INTEGER :: length

    CALL valid_id_check(id, 'get_axis_length')
    IF ( Axes(id)%Domain .NE. null_domain1d ) THEN
       CALL mpp_get_compute_domain(Axes(id)%Domain,size=length)
       !---one extra point is needed for some case. ( like symmetry domain )
       get_axis_length = length + Axes(id)%shift
    ELSE
       get_axis_length = Axes(id)%length
    END IF
  END FUNCTION get_axis_length
  ! </FUNCTION>

  ! <FUNCTION NAME="get_axis_aux">
  !   <OVERVIEW>
  !     Return the auxiliary name for the axis.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     CHARACTER(len=128) FUNCTION get_axis_aux(id)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Returns the auxiliary name for the axis.  The only possible values for
  !     the auxiliary names is <TT>geolon_t</TT> or <TT>geolat_t</TT>.
  !   </DESCRIPTION>
  !   <IN NAME="id" TYPE="INTEGER">Axis ID</IN>
  CHARACTER(len=138) FUNCTION get_axis_aux(id)
    INTEGER, INTENT(in) :: id

    CALL valid_id_check(id, 'get_axis_aux')
    get_axis_aux =  Axes(id)%aux
  END FUNCTION get_axis_aux
  ! </FUNCTION>

  ! <FUNCTION NAME="get_axis_global_length">
  !   <OVERVIEW>
  !     Return the global length of the axis.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     INTEGER FUNCTION get_axis_global_length (id)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Returns the global length of the axis ID given.
  !   </DESCRIPTION>
  !   <IN NAME="id" TYPE="INTEGER">Axis ID</IN>
  INTEGER FUNCTION get_axis_global_length(id)
    INTEGER, INTENT(in) :: id

    CALL valid_id_check(id, 'get_axis_global_length')
    get_axis_global_length = Axes(id)%length
  END FUNCTION get_axis_global_length
  ! </FUNCTION>

  ! <FUNCTION NAME="get_tile_count">
  !   <OVERVIEW>
  !     Return the tile count for the axis.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     INTEGER FUNCTION get_tile_count (ids)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Return the tile count for the axis IDs given.
  !   </DESCRIPTION>
  !   <IN NAME="ids" TYPE="INTEGER, DIMENSION(:)">
  !     Axis IDs.  Possible dimensions: 1 <= <TT>size(ids(:))</TT> <= 4.
  !   </IN>
  INTEGER FUNCTION get_tile_count(ids)
    INTEGER, DIMENSION(:), INTENT(in) :: ids

    INTEGER :: i, id, flag

    IF ( SIZE(ids(:)) < 1 ) THEN
       ! <ERROR STATUS="FATAL">input argument has incorrect size.</ERROR>
       CALL error_mesg('diag_axis_mod::get_tile_count', 'input argument has incorrect size', FATAL)
    END IF
    get_tile_count = 1
    flag = 0
    DO i = 1, SIZE(ids(:))
       id = ids(i)
       CALL valid_id_check(id, 'get_tile_count')
       IF ( Axes(id)%cart_name == 'X' .OR.  &
            Axes(id)%cart_name == 'Y' ) flag = flag + 1
       !     --- both x/y axes found ---
       IF ( flag == 2 ) THEN
          get_tile_count = Axes(id)%tile_count
          EXIT
       END IF
    END DO
  END FUNCTION get_tile_count
  ! </FUNCTION>

  ! <FUNCTION NAME="get_domain1d">
  !   <OVERVIEW>
  !     Return the 1D domain.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     TYPE(domain1d) FUNCTION get_domain1d(id)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Retrun the 1D domain for the axis ID given.
  !   </DESCRIPTION>
  !   <IN NAME="id" TYPE="INTEGER">Axis ID</IN>
  TYPE(domain1d) FUNCTION get_domain1d(id)
    INTEGER, INTENT(in) :: id

    CALL valid_id_check(id, 'get_domain1d')
    IF (Axes(id)%Domain .NE. NULL_DOMAIN1D) THEN
       get_domain1d = Axes(id)%Domain
    ELSE
       get_domain1d = NULL_DOMAIN1D
    ENDIF
  END FUNCTION get_domain1d
  ! </FUNCTION>

  ! <FUNCTION NAME="get_domain2d">
  !   <OVERVIEW>
  !     Return the 2D domain.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     TYPE(domain2d) FUNCTION get_domain2d(ids)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Return the 2D domain for the axis IDs given.
  !   </DESCRIPTION>
  !   <IN NAME="ids" TYPE="INTEGER, DIMENSION(:)">
  !     Axis IDs.  Possible dimensions: 1 <= <TT>size(ids(:))</TT> <= 4.
  !   </IN>
  TYPE(domain2d) FUNCTION get_domain2d(ids)
    INTEGER, DIMENSION(:), INTENT(in) :: ids

    INTEGER :: i, id, flag

    IF ( SIZE(ids(:)) < 1 ) THEN
       ! <ERROR STATUS="FATAL">input argument has incorrect size.</ERROR>
       CALL error_mesg('diag_axis_mod::get_domain2d', 'input argument has incorrect size', FATAL)
    END IF
    get_domain2d = null_domain2d
    flag = 0
    DO i = 1, SIZE(ids(:))
       id = ids(i)
       CALL valid_id_check(id, 'get_domain2d')
       IF ( Axes(id)%cart_name == 'X' .OR. Axes(id)%cart_name == 'Y' ) flag = flag + 1
       !     --- both x/y axes found ---
       IF ( flag == 2 ) THEN
          IF (Axes(id)%Domain2 .NE. NULL_DOMAIN2D) get_domain2d = Axes(id)%Domain2
          EXIT
       END IF
    END DO
  END FUNCTION get_domain2d
  ! </FUNCTION>

  ! <SUBROUTINE NAME="get_axes_shift">
  !   <OVERVIEW>
  !     Return the value of the shift.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE get_axes_shift(ids, ishift, jshift)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Return the value of the shift for the axis IDs given.
  !   </DESCRIPTION>
  !   <IN NAME="ids" TYPE="INTEGER, DIMENSION(:)">
  !     Axis IDs.  Possible dimensions: 1 <= <TT>size(ids(:))</TT> <= 4
  !   </IN>
  !   <OUT NAME="ishift" TYPE="INTEGER">X shift value.</OUT>
  !   <OUT NAME="jshift" TYPE="INTEGER">Y shift value.</OUT>
  SUBROUTINE get_axes_shift(ids, ishift, jshift)
    INTEGER, DIMENSION(:), INTENT(in) :: ids
    INTEGER, INTENT(out) :: ishift, jshift

    INTEGER :: i, id

    !-- get the value of the shift.
    ishift = 0
    jshift = 0
    DO i = 1, SIZE(ids(:))
       id = ids(i)
       CALL valid_id_check(id, 'get_axes_shift')
       SELECT CASE (Axes(id)%cart_name)
       CASE ( 'X' )
          ishift = Axes(id)%shift
       CASE ( 'Y' )
          jshift = Axes(id)%shift
       END SELECT
    END DO
  END SUBROUTINE get_axes_shift
  ! </SUBROUTINE>

  ! <PRIVATE>
  ! <FUNCTION NAME="get_axis_num">
  !   <OVERVIEW>
  !     Returns index into axis table corresponding to a given axis name.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     INTEGER FUNCTION get_axis_num(axis_name, set_name)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Returns index into axis table corresponding to a given axis name.
  !   </DESCRIPTION>
  !   <IN NAME="axis_name" TYPE="CHARACTER(len=*)">Axis name.</IN>
  !   <IN NAME="set_name" TYPE="CHARACTER(len=*), OPTIONAL">Set name.</IN>
  INTEGER FUNCTION get_axis_num(axis_name, set_name)
    CHARACTER(len=*), INTENT(in) :: axis_name
    CHARACTER(len=*), INTENT(in), OPTIONAL :: set_name

    INTEGER :: set, n

    IF ( PRESENT(set_name) ) THEN
       set = get_axis_set_num (TRIM(set_name))
    ELSE
       set = 0
    END IF
    get_axis_num = 0
    DO n = 1, num_def_axes
       IF ( TRIM(axis_name) == TRIM(Axes(n)%name) .AND. Axes(n)%set == set ) THEN
          get_axis_num = n
          RETURN
       END IF
    END DO
  END FUNCTION get_axis_num
  ! </FUNCTION>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <FUNCTION NAME="get_axis_set_num">
  !   <OVERVIEW>
  !     Returns index in axis set table corresponding to a given axis set name.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     INTEGER FUNCTION get_axis_set_num(set_name)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Returns index in axis set table corresponding to a given axis set name.
  !   </DESCRIPTION>
  !   <IN NAME="set_name" TYPE="CHARACTER(len=*)">Set name.</IN>
  INTEGER FUNCTION get_axis_set_num (set_name)
    CHARACTER(len=*), INTENT(in) :: set_name

    INTEGER :: iset

    get_axis_set_num = 0
    DO iset = 1, num_axis_sets
       IF ( set_name == Axis_sets(iset) ) THEN
          get_axis_set_num = iset
          RETURN
       END IF
    END DO
  END FUNCTION get_axis_set_num
  ! </FUNCTION>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <SUBROUTINE NAME="valid_id_check">
  !   <OVERVIEW>
  !     Check to see if the axis id is a vaild id.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE valid_id_check(id, routine_name)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Check to see if the given axis id is a valid id.  If the axis id is invalid,
  !     call a FATAL error.  If the ID is valid, just return.
  !   </DESCRIPTION>
  !   <IN NAME="id" TYPE="INTEGER">Axis id to check for validity</IN>
  !   <IN NAME="routine_name" TYPE="CHARACTER(len=*)">Name of the subroutine checking for a valid axis id.</IN>
  SUBROUTINE valid_id_check(id, routine_name)
    INTEGER, INTENT(in) :: id
    CHARACTER(len=*), INTENT(in) :: routine_name

    CHARACTER(len=5) :: emsg

    IF ( id < 1 .OR. id > num_def_axes) THEN
       ! <ERROR STATUS="FATAL">
       !   Illegal value for axis used (value <VALUE>).
       ! </ERROR>
       WRITE (emsg, '(I2)') id
       CALL error_mesg('diag_axis_mod::'//TRIM(routine_name),&
            & 'Illegal value for axis_id used (value '//TRIM(emsg)//').', FATAL)
    END IF
  END SUBROUTINE valid_id_check
  ! </SUBROUTINE>
  ! </PRIVATE>
END MODULE diag_axis_mod

MODULE morrison_gettelman_microp_mod

use sat_vapor_pres_mod,        only : lookup_des, compute_qs,  &
                                      sat_vapor_pres_init
use polysvp_mod,               only : polysvp_l,  polysvp_i,   &
                                      polysvp_init,  polysvp_end
use constants_mod,             only : pi, grav, rvgas, rdgas, tfreeze, &
                                      hlv, hlf, hls, cp_air
use mpp_mod,                   only : input_nml_file
use fms_mod,                   only : mpp_pe, file_exist, error_mesg,  &
                                      open_namelist_file, FATAL, &
                                      stdlog, write_version_number, &
                                      check_nml_error, close_file, &
                                      mpp_root_pe
use strat_cloud_utilities_mod, only : strat_cloud_utilities_init, &
                                      diag_id_type, diag_pt_type, &
                                      strat_nml_type
use  gamma_mg_mod,             only : gamma_mg, gamma_mg_init, gamma_mg_end
use mg_const_mod,              only : mg_const_init, rhow, rhoi,  &
                                      mg_pr, di_mg, ci_mg
use simple_pdf_mod,            only : simple_pdf, simple_pdf_init, &
                                      simple_pdf_end
  
implicit none
private 

!------------------------------------------------------------------------
!--interfaces------------------------------------------------------------

public morrison_gettelman_microp, morrison_gettelman_microp_init,  &
       morrison_gettelman_microp_end

!------------------------------------------------------------------------
!--version number--------------------------------------------------------

Character(len=128) :: Version = '$Id: morrison_gettelman_microp.F90,v 20.0 2013/12/13 23:21:59 fms Exp $'
Character(len=128) :: Tagname = '$Name: tikal $'

!------------------------------------------------------------------------
!--namelist--------------------------------------------------------------

logical           :: do_morrison_gettelman_eros = .true.
integer           :: auto_conv_ice_choice = 1
real              :: auto_conv_time_scale = 180._mg_pr
real              :: auto_conv_m_thresh =  1.e-4_mg_pr 
integer           :: act_choice  = 1     ! M+G super_act
logical           :: super_act = .false. ! super_act is more consistent 
                                         ! with Yi's formula.
real              :: ai = 700._mg_pr     ! a in the fallspeed relationship
                                         ! V=a*D^b for cloud ice 
                                         ! (mg two moment scheme)
real              :: bi = 1._mg_pr       ! b in the fallspeed relationship
                                         ! V=a*D^b for cloud ice  
                                         ! (mg two moment scheme)
real              :: as = 11.72_mg_pr   ! a in the fallspeed relationship
                                         ! V=a*D^b for cloud ice 
                                         ! (mg two moment scheme)
real              :: bs = 0.41_mg_pr     ! b in the fallspeed relationship
                                         ! V=a*D^b for cloud ice 
                                         ! (mg two moment scheme)
real              :: in_cloud_limit = 5.e-3_mg_pr
logical           :: orig_app_test = .false.
logical           :: sub_cld_var = .true.
logical           :: do_berg_snow = .false.
logical           :: do_excess1   = .false.
logical           :: hd_sedi_sens = .false.

real              :: vfact            = 1.0_mg_pr
real              :: vfact_n          = 1.0_mg_pr
real              :: vfact_m          = 1.0_mg_pr
real              :: max_vt_ice       = 1.2_mg_pr
real              :: max_vt_snow       = 1.2_mg_pr
real              :: nucl_thresh = 208.9e3_mg_pr
integer           :: no_rh_adj_opt = 0

real              :: min_diam_ice = 10.e-6_mg_pr
real              :: min_diam_drop = 2.e-6_mg_pr
real              :: max_diam_drop = 50.e-6_mg_pr

real              :: max_diam_ii = 2400.e-6_mg_pr
real              :: min_diam_ii = 1.e-6_mg_pr
logical           :: rain_evap_opt  = .false.
logical           :: subl_snow    = .false.
logical           :: mass_cons = .false.

logical           :: collect_frzreg = .true.
logical           :: do_contact_frz = .false.
integer           :: n_contact_opt = 2
logical           :: do_bigg_frz = .true.
real              :: limit_bigg_t = 0._mg_pr
logical           :: limit_volri = .true.
logical           :: one_ice = .false.
logical           :: scav_by_cloud_ice = .false.
real              :: tmin_fice =  tfreeze - 40._mg_pr ! min temperature for
                                         ! ice deposition/bergeron process
real              :: Dcs  = 200.e-6_mg_pr
real              :: qsmall =  1.e-14_mg_pr ! smallest mixing ratio 
                                            ! considered in microphysics
logical           :: tiedtke_qa_test = .false.
logical           :: qv_on_qi = .false.
integer           :: sat_adj_opt = 1
real              :: autoconv_ice_thr  = 100.e-6_mg_pr
real              :: Eii = 0.1_mg_pr
real              :: size_hom = 25.e-6_mg_pr
logical           :: limit_berg = .false.
logical           :: do_nevap = .true. 
integer           :: limit_droplet_freeze_opt = 1

real              :: berg_lim = 1.e-6_mg_pr 
real              :: rhosn = 100._mg_pr       ! bulk density snow  (from 
                                              ! Reisner et al. (1998))

logical           :: mg_repartition_first = .true.
logical           :: meyers_test = .false.
logical    :: allow_all_cldtop_collection = .false.
logical    :: rho_factor_in_max_vt = .true.
real       :: max_rho_factor_in_vt = 1.0
real       :: lowest_temp_for_sublimation = 180._mg_pr

namelist / morrison_gettelman_microp_nml /   &
                 do_morrison_gettelman_eros, auto_conv_ice_choice,   &
                 auto_conv_time_scale,  auto_conv_m_thresh,              &
                 ai, bi, as , bs, act_choice, super_act, in_cloud_limit, &
                 do_berg_snow, do_excess1, hd_sedi_sens, vfact, vfact_n, &
                 vfact_m, max_vt_ice, max_vt_snow, sub_cld_var,          &
                 nucl_thresh, no_rh_adj_opt, min_diam_ice,     &
                 min_diam_drop, max_diam_drop, rain_evap_opt, mass_cons, &
                 subl_snow, collect_frzreg, one_ice, tmin_fice, Dcs,     &
                 qsmall, tiedtke_qa_test, qv_on_qi, scav_by_cloud_ice,  &
                 max_diam_ii, min_diam_ii, sat_adj_opt, autoconv_ice_thr, &
                 eii, size_hom, limit_berg, do_nevap, berg_lim, rhosn, &
                 do_contact_frz, n_contact_opt, do_bigg_frz, limit_bigg_t,&
                 limit_volri, limit_droplet_freeze_opt,    &
                 mg_repartition_first, meyers_test, &
                 allow_all_cldtop_collection, rho_factor_in_max_vt,&
!                allow_all_cldtop_collection,                      &
                 max_rho_factor_in_vt, &
                 lowest_temp_for_sublimation

!-----------------------------------------------------------------------
!-----internal parameters and constants---------------------------------
 
!-----------------------------------------------------------------------
! radius of contact nuclei aerosol (m) :
REAL(kind=mg_pr), PARAMETER  :: rin = 0.1e-6_mg_pr

!-----------------------------------------------------------------------
! cloud droplet fall speed parameters, V = aD^b;  V is in m/s
REAL(kind=mg_pr), PARAMETER  :: ac = 3.e7_mg_pr
REAL(kind=mg_pr), PARAMETER  :: bc = 2._mg_pr


!-----------------------------------------------------------------------
! rain drop fall speed parameters, V = aD^b;  V is in m/s
REAL(kind=mg_pr), PARAMETER  :: ar = 841.99667_mg_pr
REAL(kind=mg_pr), PARAMETER  :: br = 0.8_mg_pr

!-----------------------------------------------------------------------
! typical air density at 850 mb
REAL(kind=mg_pr), PARAMETER  :: rhosu = 85000._mg_pr/(rdgas*tfreeze)

!-----------------------------------------------------------------------
! immersion freezing parameters, bigg 1953
REAL(kind=mg_pr), PARAMETER  :: bimm = 100._mg_pr
REAL(kind=mg_pr), PARAMETER  :: aimm = 0.66_mg_pr

!------------------------------------------------------------------------
! mass of new crystal due to aerosol freezing and growth (kg)
REAL(kind=mg_pr)             :: mi0

!------------------------------------------------------------------------
! snow mass-diameter relationship
REAL(kind=mg_pr)             :: cs
REAL(kind=mg_pr), PARAMETER  :: ds = 3._mg_pr

!------------------------------------------------------------------------
! collection efficiency, accretion of cloud water by rain
REAL(kind=mg_pr), PARAMETER  :: Ecr = 1.0_mg_pr

!-----------------------------------------------------------------------
! radius for homogeneously frozen droplets
!REAL(kind=mg_pr), PARAMETER  :: homog_frz_radius = 25.e-6

!-----------------------------------------------------------------------
! ventilation constants for rain
REAL(kind=mg_pr), PARAMETER  :: f1r = 0.78_mg_pr
REAL(kind=mg_pr), PARAMETER  :: f2r = 0.32_mg_pr

!-------------------------------------------------------------------------
! ventilation parameters for snow
! hall and prupacher
REAL(kind=mg_pr), PARAMETER  :: f1s = 0.86_mg_pr
REAL(kind=mg_pr), PARAMETER  :: f2s = 0.28_mg_pr

!------------------------------------------------------------------------
! ratio of h2o to dry air molecular weight
REAL(kind=mg_pr), PARAMETER  :: epsqs = 0.62197_mg_pr

!-----------------------------------------------------------------------
!NOTE:
! latent heats should probably be fixed with temperature 
! for energy conservation with the rest of the model
! (this looks like a +/- 3 or 4% effect, but will mess up energy balance)
! xxlv - latent heat of vaporization
! xlf  - latent heat of freezing
! xxls - xxlv + xlf, latent heat of sublimation
REAL(kind=mg_pr), PARAMETER  :: xxlv = hlv       
REAL(kind=mg_pr), PARAMETER  :: xlf = hlf   
REAL(kind=mg_pr), PARAMETER  :: xxls = hls

!------------------------------------------------------------------------
! water vapor gas contstant
REAL(kind=mg_pr), PARAMETER  :: rv= rvgas  

!------------------------------------------------------------------------
! specific heat of dry air at const. press
REAL(kind=mg_pr), PARAMETER  ::  cpp = cp_air         

!------------------------------------------------------------------------
! constants related to subgrid cloud variance
REAL (kind=mg_pr)            :: sfac1, sfac2, sfac3, sfac4, sfac5


!------------------------------------------------------------------------

logical    :: module_is_initialized = .false.

! 1 / relative variance of sub-grid cloud water distribution
! see morrison and gettelman, 2007, J. Climate for details
real              :: qcvar 


CONTAINS



!#########################################################################

SUBROUTINE morrison_gettelman_microp_init (do_pdf_clouds, qcvar_in)

!-----------------------------------------------------------------------
LOGICAL, INTENT(IN ) :: do_pdf_clouds
Real,    INTENT(IN ) :: qcvar_in      

!-----------------------------------------------------------------------
!--local variables------------------------------------------------------

      INTEGER   :: unit, io, ierr, logunit

!-----------------------------------------------------------------------
      if (module_is_initialized) return

      qcvar = qcvar_in

!-----------------------------------------------------------------------
!    process namelist.
!-----------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=morrison_gettelman_microp_nml, iostat=io)
      ierr = check_nml_error(io,'morrison_gettelman_microp_nml')
#else
      if ( file_exist('input.nml')) then
        unit = open_namelist_file ()
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=morrison_gettelman_microp_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'morrison_gettelman_microp_nml')
        enddo
10      call close_file (unit)
      endif
#endif

!-----------------------------------------------------------------------
!    write version and namelist to stdlog.
!-----------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe()) &
                       write (logunit, nml=morrison_gettelman_microp_nml)

!------------------------------------------------------------------------
!    be sure needed modules have been initilized.
!------------------------------------------------------------------------
      CALL sat_vapor_pres_init
      call mg_const_init
      call strat_cloud_utilities_init
      CALL polysvp_init
      IF (do_pdf_clouds) THEN
        CALL  simple_pdf_init
      END IF
      CALL gamma_mg_init

!-----------------------------------------------------------------------
!    calculate some constants.
!-----------------------------------------------------------------------
      mi0 = 4._mg_pr/3._mg_pr*pi*rhoi*min_diam_ice**3
      IF (sub_cld_var) THEN
        sfac1 = gamma_mg(qcvar+2.47_mg_pr)/(gamma_mg(qcvar)*  &
                                                       qcvar**2.47_mg_pr)
        sfac2 = gamma_mg(qcvar+2._mg_pr)/(gamma_mg(qcvar)*qcvar**2)
        sfac3 = gamma_mg(qcvar+1._mg_pr)/(gamma_mg(qcvar)*qcvar)
        sfac4 = gamma_mg(qcvar+1.15_mg_pr)/(gamma_mg(qcvar)*   &
                                                       qcvar**1.15_mg_pr)
        sfac5 = gamma_mg(qcvar+bc/3._mg_pr)/(gamma_mg(qcvar)*  &
                                                      qcvar**(bc/3._mg_pr))
      ELSE
        sfac1 = 1._mg_pr
        sfac2 = 1._mg_pr 
        sfac3 = 1._mg_pr
        sfac4 = 1._mg_pr
        sfac5 = 1._mg_pr
      END IF
      cs = rhosn*pi/6._mg_pr

!-----------------------------------------------------------------------
!    mark the module as initialized.
!-----------------------------------------------------------------------
      module_is_initialized = .true.

!----------------------------------------------------------------------


END SUBROUTINE morrison_gettelman_microp_init



!########################################################################

SUBROUTINE morrison_gettelman_microp  (      &
                  tiedtke_macrophysics, total_activation, dqa_activation, &
                  ncall, j, idim, jdim, kdim, Nml, deltatin, pfull, &
                  pdel, t_in, t0, qv_in, qv0, qc_in, qi_in, nc_in, ni_in, &
                  cldn_in, dqcdt, dqidt, drop2, crystal1, rbar_dust,   &
                  ndust, delta_cf, qa_upd, qa_upd_0, SA_0, D_eros_l4, &
                  nerosc4,  D_eros_i4, nerosi4, gamma, inv_dtcloud, qa0, & 
                  ST, SQ,  ssat_disposal, tlat, qvlat, qctend, qitend,    &
                  nctend, nitend, SA, rain3d, snow3d, prect, preci,   &
                  qrout, qsout, lsc_rain_size, lsc_snow_size,   &
                  f_snow_berg, n_diag_4d, diag_4d, diag_id, diag_pt,  &
                  nrefuse, debugo0, debugo1, otun)
       
!------------------------------------------------------------------------
logical,                 intent(in)    ::  tiedtke_macrophysics,  &
                                           total_activation, &
                                           dqa_activation
INTEGER,                 INTENT(IN )   ::  ncall, j, idim, jdim, kdim
type(strat_nml_type),    intent(in)    ::  Nml
REAL(kind=mg_pr),        INTENT(IN )   ::  deltatin        ! time step (s)
REAL(kind=mg_pr), DIMENSION(idim,kdim),   INTENT(IN)    & 
                                       ::  pfull ! air pressure (pa)
REAL(kind=mg_pr), DIMENSION(idim,kdim),   INTENT(IN)    &
                                       ::  pdel  ! pressure difference 
                                                 ! across level (pa)
REAL(kind=mg_pr), DIMENSION(idim,kdim),   INTENT(IN)    &
                                       ::  t_in  ! input temperature (K)
REAL(kind=mg_pr), DIMENSION(idim,kdim),   INTENT(IN)    &
                                       ::  qv_in ! input h20 vapor mixing 
                                                 ! ratio (kg/kg)
REAL(kind=mg_pr), DIMENSION(idim,kdim),   INTENT(IN)    &
                                       ::  T0, qv0
REAL(kind=mg_pr), DIMENSION(idim,kdim),   INTENT(IN)     &
                                       ::  qc_in ! cloud water mixing 
                                                 ! ratio (kg/kg)  
REAL(kind=mg_pr), DIMENSION(idim,kdim),   INTENT(IN)   &
                                       ::  qi_in ! cloud ice mixing    
                                                 ! ratio (kg/kg)
REAL(kind=mg_pr), DIMENSION(idim,kdim),   INTENT(IN)   &
                                       ::  nc_in ! cloud droplet number 
                                                 ! conc (1/kg) at the 
                                                 ! beginning of the 
                                                 ! timestep prior to 
                                                 ! activation calc.
REAL(kind=mg_pr), DIMENSION(idim,kdim),   INTENT(IN)   &
                                       ::  ni_in ! cloud ice number conc 
                                                 ! (1/kg)
REAL(kind=mg_pr), DIMENSION(idim,kdim),   INTENT(IN)    &
                                       ::  cldn_in 
                                                 ! cloud fraction
REAL(kind=mg_pr), DIMENSION(idim,kdim),  INTENT(IN)    &
                                       :: dqcdt, dqidt
REAL(kind=mg_pr), DIMENSION(idim,kdim),  INTENT(INOUT)   &
                                       ::  drop2, crystal1
REAL(kind=mg_pr), DIMENSION(idim,kdim),  INTENT(IN)     &
                                       ::  rbar_dust, ndust
REAL(kind=mg_pr), DIMENSION(idim,kdim),  INTENT(INOUT)   &
                                       ::  delta_cf
REAL(kind=mg_pr), DIMENSION(idim,kdim),  INTENT(INOUT)   &
                                       ::  qa_upd
REAL(kind=mg_pr), DIMENSION(idim,kdim),  INTENT(INOUT )   &
                                       ::  qa_upd_0, SA_0
REAL(kind=mg_pr), DIMENSION(idim,kdim),  INTENT(IN)    &
                                       ::  D_eros_l4, D_eros_i4
REAL(kind=mg_pr), DIMENSION(idim,kdim),  INTENT(IN)    &
                                       ::  nerosc4, nerosi4
REAL(kind=mg_pr), DIMENSION(idim,kdim),  INTENT(IN)    &
                                       ::  gamma
REAL(kind=mg_pr),                        INTENT(IN )   &
                                       ::  inv_dtcloud       
REAL(kind=mg_pr), DIMENSION(idim,kdim),  INTENT(IN)    &
                                       ::  qa0
REAL(kind=mg_pr), DIMENSION(idim,kdim),  INTENT(IN)    &
                                       ::  ST, SQ
REAL(kind=mg_pr), DIMENSION(idim,kdim),intent(out)     &
                                       :: ssat_disposal
REAL(kind=mg_pr), DIMENSION(idim,kdim),intent(out)    &
                                       :: tlat   ! latent heating rate 
                                                 !    (K/s)
REAL(kind=mg_pr), DIMENSION(idim,kdim),intent(out)     &
                                       :: qvlat  ! microphysical  tendency
                                                 !  qv (1/s)
REAL(kind=mg_pr), DIMENSION(idim,kdim),  INTENT(OUT)    &
                                       :: qctend, qitend, nctend, nitend
REAL(kind=mg_pr), DIMENSION(idim,kdim),  INTENT(INOUT)    &
                                       :: SA
! snow and rain mass mixing ratio (kg/kg) 
real, dimension(idim, jdim, kdim+1), INTENT(INOUT)      &
                                       :: rain3d, snow3d
REAL(kind=mg_pr), DIMENSION(idim), intent(out)       &
                                       :: prect  ! surface precip rate 
                                                 ! (m/s)
REAL(kind=mg_pr), DIMENSION(idim), intent(out)    &
                                       :: preci  ! cloud ice/snow precip 
                                                 ! rate (m/s)
! diagnostic rain/snow for output to history
! values are in-precip (local) !!!!
REAL(kind=mg_pr), DIMENSION(idim,kdim), INTENT(OUT )      &
                                       :: qrout ! rain mixing ratio (kg/kg)
REAL(kind=mg_pr), DIMENSION(idim,kdim), INTENT(OUT )      &
                                       :: qsout ! snow mixing ratio (kg/kg)
! snow and rain diameter (micrometer):
! (snow_size currently not used) 
REAL, dimension(idim, kdim), INTENT(INOUT)     &
                                       :: lsc_snow_size, lsc_rain_size
REAL(kind=mg_pr), DIMENSION(idim,kdim),  INTENT(OUT)     &
                                       ::  f_snow_berg
INTEGER,                                 intent(in)     &
                                       :: n_diag_4d
REAL, dimension( idim, jdim, kdim, 0:n_diag_4d ), INTENT(INOUT )    &
                                       ::  diag_4d
TYPE(diag_id_type),                       intent(in)     &
                                       :: diag_id
TYPE(diag_pt_type),                       intent(inout)    &
                                       :: diag_pt
INTEGER,                                  INTENT(INOUT)     &
                                       :: nrefuse
LOGICAL,                                  INTENT(IN )    &
                                       :: debugo0, debugo1 
INTEGER,                                  INTENT(IN )     &
                                       :: otun

!-------------------------------------------------------------------------

!-------------------------------------------------------------------------
!---local variables-------------------------------------------------------
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: tn !input temperature

      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  D_eros_l, D_eros_i 

      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: dz ! height difference 
                                               !across model vertical level


      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: qv, qtot

      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: qc, qi

      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nc, ni



! sum of source/sink terms for diagnostic prec
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: qnitend ! snow mixing ratio source/sink term
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nstend  ! snow number concentration source/sink term
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: qrtend ! rain mixing ratio source/sink term
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nrtend  ! rain number concentration source/sink term



! new terms for Bergeron process

      REAL(kind=mg_pr) :: dumnnuc ! provisional ice nucleation rate (for calculating bergeron)
      REAL(kind=mg_pr) :: ninew  ! provisional cloud ice number conc (for calculating bergeron)
      REAL(kind=mg_pr) :: qinew ! provisional cloud ice mixing ratio (for calculating bergeron)
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: berg  ! mixing rat tendency due to bergeron process for cloud ice

!cms++
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: qvdep_qi   ! mixing rat tendency due to vapor deposition on ice   
!cms--



      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: esl ! liquid sat vapor pressure (pa)
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: esi ! ice sat vapor pressure (pa)


      REAL(kind=mg_pr), DIMENSION(kdim) ::  nsubi ! evaporation of cloud ice number
      REAL(kind=mg_pr), DIMENSION(kdim) ::  nsubc ! evaporation of droplet number




      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  nerosi! "erosion" of cloud ice number
      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  nerosc! "erosion" of cloud ice number
      REAL(kind=mg_pr), DIMENSION(kdim) ::  nsubs ! evaporation of snow number
      REAL(kind=mg_pr), DIMENSION(kdim) ::  nsubr ! evaporation of rain number


      REAL(kind=mg_pr), DIMENSION(kdim) :: nnuccd   ! ice nucleation rate from various freezing processes
      REAL(kind=mg_pr), DIMENSION(kdim) :: mnuccd   ! ice nucleation rate from various freezing processes
      REAL(kind=mg_pr), DIMENSION(kdim) :: npccn    ! droplet activation rate



      REAL(kind=mg_pr) :: qrtot ! vertically-integrated rain mixing rat source/sink term
      REAL(kind=mg_pr) :: nrtot ! vertically-integrated rain number conc source/sink term
      REAL(kind=mg_pr) :: qstot ! vertically-integrated snow mixing rat source/sink term
      REAL(kind=mg_pr) :: nstot ! vertically-integrated snow number conc source/sink term

      REAL(kind=mg_pr) :: deltat   ! sub-time step (s)  
  

      REAL(kind=mg_pr) :: omsm    ! number near unity for round-off issues
      REAL(kind=mg_pr) :: mincld  ! minimum allowed cloud fraction

      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: q ! water vapor mixing ratio (kg/kg)
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: t ! temperature (K)
      REAL(kind=mg_pr) , DIMENSION(idim,kdim):: rho ! air density (kg m-3)


      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: dv  ! diffusivity of water vapor in air
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: mu  ! viscocity of air
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: sc  ! schmidt number
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: kap ! thermal conductivity of air
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: rhof! air density correction factor for fallspeed
      REAL(kind=mg_pr) :: dap ! effecvtive diffusivity of contact ice nuclei
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: arn ! air density corrected rain fallspeed parameter
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: asn ! air density corrected snow fallspeed parameter
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: acn ! air density corrected cloud droplet fallspeed parameter
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: ain ! air density corrected cloud ice fallspeed parameter


      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: qcic ! in-cloud cloud liquid mixing ratio
      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: qiic ! in-cloud cloud ice mixing ratio
      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: qniic ! in-precip snow mixing ratio
      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: qric ! in-precip rain mixing ratio
      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: ncic ! in-cloud droplet number conc
      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: niic ! in-cloud cloud ice number conc
      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: nsic ! in-precip snow number conc
      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: nric ! in-precip rain number conc

        ! hm, add9/5/07, rain rate for reflectivity calculation
      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: rainrt
      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: rainrt1


      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: atotrt
      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: atotrt1

      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: asnowrt
      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: asnowrt1



      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: cwml   ! cloud water mixing ratio
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: cwmi   ! cloud ice mixing ratio

      REAL(kind=mg_pr), DIMENSION(kdim) :: snow2vapor

      REAL(kind=mg_pr) :: uni ! number-weighted cloud ice fallspeed
      REAL(kind=mg_pr), DIMENSION(kdim) ::  umi ! mass-weighted cloud ice fallspeed
      REAL(kind=mg_pr), DIMENSION(kdim) :: uns  ! number-weighted snow fallspeed
      REAL(kind=mg_pr), DIMENSION(kdim) ::  ums ! mass-weighted snow fallspeed
      REAL(kind=mg_pr), DIMENSION(kdim) ::  unr ! number-weighted rain fallspeed
      REAL(kind=mg_pr), DIMENSION(kdim) ::  umr ! mass-weighted rain fallspeed
      REAL(kind=mg_pr) :: unc ! number-weighted cloud droplet fallspeed
      REAL(kind=mg_pr) :: umc ! mass-weighted cloud droplet fallspeed

      REAL(kind=mg_pr), DIMENSION(kdim) :: pracs ! mixing rat tendency due to collection of rain by snow
      REAL(kind=mg_pr), DIMENSION(kdim) :: npracs ! number conc tendency due to collection of rain by snow ! number conc tendency due to collection of rain by snow
      REAL(kind=mg_pr), DIMENSION(kdim) :: mnuccr ! mixing rat tendency due to freezing of rain
      REAL(kind=mg_pr), DIMENSION(kdim) :: nnuccr ! number conc tendency due to freezing of rain
      REAL(kind=mg_pr), DIMENSION(kdim) :: pra ! mixing rat tendnency due to accretion of droplets by rain
      REAL(kind=mg_pr), DIMENSION(kdim) :: npra ! nc tendnency due to accretion of droplets by rain
      REAL(kind=mg_pr), DIMENSION(kdim) :: nragg ! nr tendency due to self-collection of rain
      REAL(kind=mg_pr), DIMENSION(kdim) :: prci ! mixing rat tendency due to autoconversion of cloud ice to snow
      REAL(kind=mg_pr), DIMENSION(kdim) :: nprci ! number conc tendency due to autoconversion of cloud ice to snow
      REAL(kind=mg_pr), DIMENSION(kdim) :: prai ! mixing rat tendency due to accretion of cloud ice by snow
      REAL(kind=mg_pr), DIMENSION(kdim) :: nprai ! number conc tendency due to accretion of cloud ice by snow
      REAL(kind=mg_pr), DIMENSION(kdim) :: mnuccc ! mixing ratio tendency due to freezing of cloud water
      REAL(kind=mg_pr), DIMENSION(kdim) :: nnuccc ! number conc tendency due to freezing of cloud water
      REAL(kind=mg_pr), DIMENSION(kdim) :: nsagg ! ns tendency due to self-aggregation of snow


      REAL(kind=mg_pr), DIMENSION(kdim) :: pre ! rain mixing rat tendency due to evaporation
      REAL(kind=mg_pr), DIMENSION(kdim) :: prds ! snow mixing rat tendency due to sublimation

      REAL(kind=mg_pr), DIMENSION(kdim) ::psacws ! mixing rat tendency due to collection of droplets by snow
      REAL(kind=mg_pr), DIMENSION(kdim) ::npsacws ! number conc tendency due to collection of droplets by snow

! for the one ice class scheme: 
      REAL(kind=mg_pr), DIMENSION(kdim) ::psacws_o ! mixing rat tendency due to collection of droplets by snow
      REAL(kind=mg_pr), DIMENSION(kdim) ::npsacws_o ! number conc tendency due to collection of droplets by snow

      REAL(kind=mg_pr), DIMENSION(kdim) :: prc    ! qc tendency due to autoconversion of cloud droplets
      REAL(kind=mg_pr), DIMENSION(kdim) :: nprc   ! number conc tendency due to autoconversion of cloud droplets
      REAL(kind=mg_pr), DIMENSION(kdim) :: nprc1  ! qr tendency due to autoconversion of cloud droplets

      REAL(kind=mg_pr), DIMENSION(kdim) ::  bergs ! mixing rat tendency due to bergeron process for snow



      REAL(kind=mg_pr), DIMENSION(kdim) ::  lami       ! slope of cloud ice size distr
      REAL(kind=mg_pr), DIMENSION(kdim) ::  n0i        ! intercept of cloud ice size distr


      REAL(kind=mg_pr), DIMENSION(kdim) :: lamr  ! slope of rain size distr
      REAL(kind=mg_pr), DIMENSION(kdim) :: n0r    ! intercept of rain size distr


      REAL(kind=mg_pr), DIMENSION(kdim) :: lams  ! slope of snow size distr
      REAL(kind=mg_pr), DIMENSION(kdim) :: n0s   ! intercept of snow size distr




      REAL(kind=mg_pr) :: lammax  ! maximum allowed slope of size distr
      REAL(kind=mg_pr) :: lammin  ! minimum allowed slope of size distr

      REAL(kind=mg_pr), DIMENSION(kdim) ::  pgam ! spectral width parameter of droplet size distr

      REAL(kind=mg_pr), DIMENSION(kdim) ::  cdist1 ! size distr parameter to calculate droplet freezing



      REAL(kind=mg_pr), DIMENSION(kdim) ::  lamc ! slope of cloud liquid size distr



      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: cldmax ! precip fraction assuming maximum overlap
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: cldm     ! cloud fraction 


      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  t1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  q1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  qc1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  qi1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  nc1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  ni1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  tlat1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  qvlat1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  qctend1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  qitend1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  nctend1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  nitend1

      REAL(kind=mg_pr), DIMENSION(idim) :: prect1
      REAL(kind=mg_pr), DIMENSION(idim) :: preci1

      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: cmei       ! dep/sublimation rate of cloud ice
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: cmel     ! cond/evap rate of cloud liquid
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: cmel_orig, cmei_orig, &
                                                    berg_orig




      REAL(kind=mg_pr) :: qvi ! ice saturation vapor mixing ratio

      REAL(kind=mg_pr) :: qvqvsi ! ICE SATURAION RATIO

      REAL(kind=mg_pr) :: qvl  ! liquid sat mixing ratio  
      REAL(kind=mg_pr) :: qvs ! liquid saturation vapor mixing ratio

      REAL(kind=mg_pr) :: dqsdt ! change of sat vapor mixing ratio with temperature
      REAL(kind=mg_pr) :: dqsidt ! change of ice sat vapor mixing ratio with temperature

      REAL(kind=mg_pr), DIMENSION(idim,kdim)  ::  abi ! correction factor for snow sublimation to account for latent heat
      REAL(kind=mg_pr) :: qclr ! water vapor mixing ratio in clear air

      REAL(kind=mg_pr) :: ab ! correction factor for rain evap to account for latent heat

      REAL(kind=mg_pr) ::  epsi ! 1/ sat relaxation timecale for cloud ice
      REAL(kind=mg_pr) ::  prd ! provisional deposition rate of cloud ice at water sat   
      REAL(kind=mg_pr)  :: epsr ! 1/ sat relaxation timescale for rain
      REAL(kind=mg_pr)  :: epss ! 1/ sat relaxation timescale for snow
      
      real(kind=mg_pr) :: bergtsf   !bergeron timescale to remove all liquid

      REAL(kind=mg_pr) :: esat0, gamma1, qvmax

! hm add 3/19/07, ice nucleation, droplet activation
      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  dum2i ! number conc of ice nuclei available (1/kg)
      REAL(kind=mg_pr) , DIMENSION(idim,kdim)::  dum2l ! number conc of CCN (1/kg)
      REAL(kind=mg_pr) ::   ncmax
      REAL(kind=mg_pr) ::   nimax




! diagnostic rain/snow for output to history
! values are in-precip (local) !!!!

      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nrout ! rain number concentration (1/m3)
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nsout ! snow number concentration (1/m3)



      REAL(kind=mg_pr) :: dc0  ! mean size droplet size distr
      REAL(kind=mg_pr) :: ds0  ! mean size snow size distr (area weighted)
      REAL(kind=mg_pr) :: eci  ! collection efficiency for riming of snow by droplets


      REAL(kind=mg_pr) :: mtime ! factor to account for droplet activation timescale

! variabels to check for RH after rain evap

      REAL(kind=mg_pr) :: esn
      REAL(kind=mg_pr) :: qsn
      REAL(kind=mg_pr) :: qtmp
      REAL(kind=mg_pr) :: ttmp, tc, rhi

      REAL(kind=mg_pr) :: dum, dum1, dum2, dumd 


      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: dumc ! dummy in-cloud qc
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: dumnc ! dummy in-cloud nc
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: dumi ! dummy in-cloud qi
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: dumni ! dummy in-cloud ni
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: dums ! dummy in-cloud snow mixing rat
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: dumns ! dummy in-cloud snow number conc
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: dumr ! dummy in-cloud rain mixing rat
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: dumnr ! dummy in-cloud rain number conc

      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  cldn ! cloud fraction

      REAL(kind=mg_pr) :: qce ! dummy qc for conservation check
      REAL(kind=mg_pr) :: qie ! dummy qi for conservation check
      REAL(kind=mg_pr) :: nce ! dummy nc for conservation check
      REAL(kind=mg_pr) :: nie ! dummy ni for conservation check

      REAL(kind=mg_pr) :: ratio ! parameter for conservation check



! below are parameters for cloud water and cloud ice sedimentation calculations
      REAL(kind=mg_pr), DIMENSION(kdim) :: fr
      REAL(kind=mg_pr), DIMENSION(kdim) :: fnr
      REAL(kind=mg_pr), DIMENSION(kdim) :: fc
      REAL(kind=mg_pr), DIMENSION(kdim) :: fnc
      REAL(kind=mg_pr), DIMENSION(kdim) :: fi
      REAL(kind=mg_pr), DIMENSION(kdim) :: fni
      REAL(kind=mg_pr), DIMENSION(kdim) :: fs
      REAL(kind=mg_pr), DIMENSION(kdim) :: fns
      REAL(kind=mg_pr), DIMENSION(kdim) :: faloutr
      REAL(kind=mg_pr), DIMENSION(kdim) :: faloutnr
      REAL(kind=mg_pr), DIMENSION(kdim) :: faloutc
      REAL(kind=mg_pr), DIMENSION(kdim) :: faloutnc
      REAL(kind=mg_pr), DIMENSION(kdim) :: falouti
      REAL(kind=mg_pr), DIMENSION(kdim) :: faloutni
      REAL(kind=mg_pr), DIMENSION(kdim) :: falouts
      REAL(kind=mg_pr), DIMENSION(kdim) :: faloutns
      REAL(kind=mg_pr) :: faltndr
      REAL(kind=mg_pr) :: faltndnr
      REAL(kind=mg_pr) :: faltndc
      REAL(kind=mg_pr) :: faltndnc
      REAL(kind=mg_pr) :: faltndi
      REAL(kind=mg_pr) :: faltndni
      REAL(kind=mg_pr) :: faltnds
      REAL(kind=mg_pr) :: faltndns
      REAL(kind=mg_pr) :: faltndqie
      REAL(kind=mg_pr) :: faltndqce

          
      REAL(kind=mg_pr) :: rgvm ! max fallspeed for all species

      REAL(kind=mg_pr) :: dumt1, dumt2

      REAL(kind=mg_pr) :: ql_new, qi_new, qn_new, qni_new, qa_new
   
! hm add 3/19/07, new loop variables for sub-step solution
      integer iter, it, ltrue(idim)

      REAL(kind=mg_pr) :: dum3


      REAL(kind=mg_pr) :: qii_new, nii_new,  nii_min,  nii_max 


      logical           ::  do_berg_ex, do_berg1


! v1.4
! new variables for seifert and beheng warm rain scheme
      REAL(kind=mg_pr), DIMENSION(kdim) :: nu
      integer dumii
      REAL(kind=mg_pr) :: dnu(16)

     

      REAL(kind=mg_pr) :: scalef, m1, m2, m3, m4, m5


      INTEGER :: i, k, n ,nstep, kk






!cms++ 6/6/08 temp?
      real(kind=mg_pr), parameter :: d622 = rdgas / rvgas
      real(kind=mg_pr), parameter :: d378 = 1._mg_pr - d622
!cms--

      REAL (kind=mg_pr) :: tmp1, tmp2, tmp3, tmp7, coffi

      REAL (kind=mg_pr) :: qs_t, qs_d , eslt, esit,  dqsi


      REAL (kind=mg_pr) :: q_e




!------------------------------------

!cloud droplets   

      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: pre1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: prds1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: snow2vapor1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: sedi_ice2vapor1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: sedi_liquid2vapor1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: super_saturation_rm1

      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: cmel1     ! cond/evap rate of cloud liquid
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: D_eros_l1   
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: berg1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: qvdep_qi1

      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: prc1

      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: pra1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: mnuccc1

      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: psacws1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: bergs1


!cloud ice
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: psacws_o1

      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: cmei1   
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: D_eros_i1   

      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: prci1
      REAL(kind=mg_pr), DIMENSION(idim,kdim)  :: prai1

!cloud droplet number
      REAL(kind=mg_pr), DIMENSION(kdim) :: nucclim
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nucclim1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: npccn1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nnuccc1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: npsacws1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: npsacws_o1     
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nsubc1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nerosc1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: npra1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nprc11

!cloud ice number
      REAL(kind=mg_pr), DIMENSION(kdim) :: nucclim1i
      REAL(kind=mg_pr), DIMENSION(kdim) :: nucclim2
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nnuccd1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nsubi1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nerosi1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nprci1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nprai1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nucclim1_1
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: nucclim2_1


      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: pracs1
      real(kind=mg_pr), DIMENSION(idim,kdim) :: mnuccr1
      real(kind=mg_pr), DIMENSION(idim,kdim) :: relhum

     
      REAL(kind=mg_pr), DIMENSION(idim,kdim) :: qs


      REAL :: tmp2s, qa_t

      REAL :: NACNT 
    
      REAL(kind=mg_pr), DIMENSION(idim,kdim) ::  sum_freeze, sum_rime, &
                                                 sum_bergs, sum_ice_adj, &
                                                 sum_berg, sum_cond, &
                                                 sum_freeze2
      real :: qldt_sum
 



!---------------------

!some sanity checking (more needed!!)

         IF ( .NOT. Nml%do_pdf_clouds ) THEN
           IF (auto_conv_ice_choice .EQ. 2 ) THEN
             call error_mesg ( 'morrison_gettelman_microp', &
              'ERROR auto_conv_ice_choice =2 not compatible w. Tiedtke&
                  & param. assumption of in-cloud RH=1 ', FATAL)
           END IF
           IF ( qv_on_qi ) THEN
             call error_mesg ( 'morrison_gettelman_microp', &
               'ERROR qv_on_qi = .true. not compatible w. Tiedtke &
                    &param. assumption of in-cloud RH=1 ', FATAL)
           END IF
         END IF

!---------------------------------------------------------------------
         DO k=1,kdim
           DO i= 1,idim
             qv(i,k) = qv_in(i,k)
             qc(i,k) =   qc_in(i,k)   
             qi(i,k) =   qi_in(i,k)  
             nc(i,k) =   nc_in(i,k)   
             ni(i,k) =   ni_in(i,k)
             tn(i,k) = t_in(i,k)
             cldn(i,k) = cldn_in(i,k) 
           END DO
         END DO

!----------------------------------------------------

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!++ag assign variable deltat for sub-stepping...
         deltat = deltatin

! parameters for scheme

         omsm = 0.99999_mg_pr
         mincld = 0.0001_mg_pr
 
! initialize multi-level fields
         do k=1,kdim
           do i=1,idim
             q(i,k) = qv(i,k)
             t(i,k) = tn(i,k)
           end do
         end do
  

! initialize time-varying parameters

         do k=1,kdim
           do i=1,idim
             rho(i,k) = pfull(i,k)/(rdgas*t(i,k))
             dv(i,k) = 8.794E-5_mg_pr*t(i,k)**1.81_mg_pr/pfull(i,k)
             mu(i,k) = 1.496E-6_mg_pr*t(i,k)**1.5_mg_pr/ &
                                            (t(i,k) + 120._mg_pr)
             sc(i,k) = mu(i,k)/(rho(i,k)*dv(i,k))
             kap(i,k) = 1.414e3_mg_pr*1.496e-6_mg_pr*t(i,k)**1.5_mg_pr/  &
                                                     (t(i,k) + 120._mg_pr) 

! air density adjustment for fallspeed parameters
! hm added 11/18/06, add air density correction factor to the
! power of 0.54 following Heymsfield and Bansemer 2006

!            if (rho_factor_in_max_vt) then
               rhof(i,k)=(rhosu/rho(i,k))**0.54_mg_pr
!            else
!              rhof(i,k) = 1.0
!            endif
             rhof(i,k) = MIN (rhof(i,k), max_rho_factor_in_vt)

!            arn(i,k)=ar*(rhosu/rho(i,k))**0.54_mg_pr
!            asn(i,k)=as*(rhosu/rho(i,k))**0.54_mg_pr
!            acn(i,k)=ac*(rhosu/rho(i,k))**0.54_mg_pr
!            ain(i,k)=ai*(rhosu/rho(i,k))**0.54_mg_pr
             arn(i,k)=ar*rhof(i,k)                        
             asn(i,k)=as*rhof(i,k)                        
             acn(i,k)=ac*rhof(i,k)                        
             ain(i,k)=ai*rhof(i,k)                        
 
! keep dz positive (define as layer k-1 - layer k)

             dz(i,k)= pdel(i,k)/(rho(i,k)*grav)
           end do
         end do

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! calculate condensation based on cloud fraction, t,q tendencies
! 

         do k=1,kdim
           do i=1,idim

! store original variables for sub-stepping

             t1(i,k) = t(i,k)
             q1(i,k) = q(i,k)
             qc1(i,k) = qc(i,k)
             qi1(i,k) = qi(i,k)
             nc1(i,k) = nc(i,k)
             ni1(i,k) = ni(i,k)
!cms++
! initialize tendencies to zero

             tlat1(i,k) = 0._mg_pr
             qvlat1(i,k) = 0._mg_pr
             qctend1(i,k) = 0._mg_pr
             qitend1(i,k) = 0._mg_pr
             nctend1(i,k) = 0._mg_pr
             nitend1(i,k) = 0._mg_pr

             tlat(i,k) = 0._mg_pr
             qvlat(i,k) = 0._mg_pr
             qctend(i,k) = 0._mg_pr
             qitend(i,k) = 0._mg_pr
             qnitend(i,k) = 0._mg_pr
             qrtend(i,k) = 0._mg_pr
             nctend(i,k) = 0._mg_pr
             nitend(i,k) = 0._mg_pr
             nrtend(i,k) = 0._mg_pr
             nstend(i,k) = 0._mg_pr
             prect(i) = 0._mg_pr
             preci(i) = 0._mg_pr
             qniic(i,k) = 0._mg_pr
             qric(i,k) = 0._mg_pr
             nsic(i,k) = 0._mg_pr
             nric(i,k) = 0._mg_pr
 
! hm add 9/5/07
             rainrt(i,k) = 0._mg_pr
!cms for calc. rain3d, snow3d

!cms--
! initialize precip output

             qrout(i,k) = 0._mg_pr
             qsout(i,k) = 0._mg_pr
             nrout(i,k) = 0._mg_pr
             nsout(i,k) = 0._mg_pr
 
!  initialize bergeron fraction arrays
             sum_freeze(i,k) = 0._mg_pr
             sum_freeze2(i,k) = 0._mg_pr
             sum_rime  (i,k) = 0._mg_pr
             sum_berg  (i,k) = 0._mg_pr
             sum_ice_adj(i,k) = 0._mg_pr
             sum_bergs (i,k) = 0._mg_pr
             sum_cond  (i,k) = 0._mg_pr

             rainrt1(i,k) = 0._mg_pr

!diag++
!droplets
             pre1(i,k)                 = 0._mg_pr
             prds1(i,k)                = 0._mg_pr
             snow2vapor1(i,k)          = 0._mg_pr
             snow2vapor(k)             = 0._mg_pr
             sedi_ice2vapor1(i,k)      = 0._mg_pr
             sedi_liquid2vapor1(i,k)   = 0._mg_pr
             super_saturation_rm1(i,k) = 0._mg_pr

             cmel1(i,k) = 0._mg_pr
             D_eros_l1(i,k) = 0._mg_pr 
             berg1(i,k) = 0._mg_pr
             qvdep_qi1(i,k) = 0._mg_pr
             prc1(i,k) = 0._mg_pr
             pra1(i,k) = 0._mg_pr
             mnuccc1(i,k) = 0._mg_pr
             psacws1(i,k) = 0._mg_pr
             bergs1(i,k) = 0._mg_pr
!ice
             psacws_o1(i,k) = 0._mg_pr
             cmei1(i,k) = 0._mg_pr
             D_eros_i1(i,k) = 0._mg_pr   
             prci1(i,k) = 0._mg_pr 
             prai1(i,k) = 0._mg_pr 

!droplet number
             nucclim1(i,k) = 0._mg_pr 
             npccn1(i,k) = 0._mg_pr 
             nnuccc1(i,k) = 0._mg_pr 
             npsacws1(i,k) = 0._mg_pr 
             npsacws_o1(i,k) = 0._mg_pr  
             nsubc1(i,k) = 0._mg_pr 
             nerosc1(i,k) = 0._mg_pr 
             npra1(i,k) = 0._mg_pr 
             nprc11(i,k) = 0._mg_pr 

!ice number
             nnuccd1(i,k) = 0._mg_pr 
             nsubi1(i,k) = 0._mg_pr 
             nerosi1(i,k) = 0._mg_pr 
             nprci1(i,k) = 0._mg_pr 
             nprai1(i,k) = 0._mg_pr 
             nucclim1_1(i,k) = 0._mg_pr 
             nucclim2_1(i,k) = 0._mg_pr 
             pracs1(i,k)    = 0._mg_pr
             mnuccr1(i,k)  = 0._mg_pr
           end do 
         end do

! get cloud fraction, check for minimum
         do k=1,kdim
           do i=1,idim
             cldmax(i,k) = mincld
             cldm(i,k) = max(cldn(i,k), mincld)
           end do
         end do

! initialize avg precip rate
         do i=1,idim
           prect1(i)=0._mg_pr
           preci1(i)=0._mg_pr
         end do

         do k=1,kdim
           do i=1,idim
             esl(i,k) = polysvp_l(t(i,k))
             esi(i,k) = polysvp_i(t(i,k))

! MAKE SURE ICE SATURATION DOESN'T EXCEED WATER SAT. NEAR FREEZING
             IF (esi(i,k) .GT. esl(i,k)) esi(i,k) = esl(i,k)
           end do
         end do

         IF ( meyers_test ) THEN
! over-write crystal1
! this is Steve Klein's version, Hugh's WRF version is different ...
           do k=1,kdim
             do i=1,idim
               crystal1(i,k)  = 1000._mg_pr*exp((12.96_mg_pr*    &
                                    0.0125_mg_pr*(tfreeze - T(i,k))) - &
                                                             0.639_mg_pr)
             end do
           end do   
         END IF

         do k=1,kdim
           do i=1,idim
             prd = 0._mg_pr
             if (t(i,k) .lt. tfreeze - 5._mg_pr) then
               IF (Nml%do_ice_nucl_wpdf) THEN

!use number calculated outside this code
                 IF (total_activation) THEN
                   dum = crystal1(i,k)*cldm(i,k)/rho(i,k)
                 ELSE IF (dqa_activation) THEN
                   dum =  crystal1(i,k)/rho(i,k)
                 END IF
               ELSE 
! cooper
                 dum = min(0.005_mg_pr*exp(0.304_mg_pr*   &
                           (tfreeze - t(i,k)))*1000._mg_pr, 208.9e3_mg_pr)
                 dum = dum/rho(i,k)
               END IF 

               IF (total_activation) THEN
                 if (delta_cf(i,k) .gt. 0._mg_pr ) then
                   dumnnuc = (dum - ni(i,k)/cldm(i,k))/deltat*cldm(i,k)
                 else
                   dumnnuc = 0._mg_pr
                 end if
               ELSE  IF (dqa_activation) THEN
                 dumnnuc = max(delta_cf(i,k), 0.)*dum/deltat
               END IF
               dumnnuc=max(dumnnuc,0._mg_pr)

  ! get provisional ni and qi after nucleation in order to calculate
  ! Bergeron process below
               ninew = ni(i,k) + dumnnuc*deltat
               if (tiedtke_macrophysics .or. dqa_activation) then
                 qinew = qi(i,k)
               else
                 qinew =qi(i,k) + dumnnuc*deltat*mi0
               endif
             else 
               ninew = ni(i,k)
               qinew = qi(i,k)
             end if

! NOTE: this approach has been replaced by NCAR's, so the following 
!       comments are no longer valid
! for condensation
! for T < tmin_fice, assume all new condensate is ice
! for T > tmin_fice, put all new condensate into liquid temporarily,
! then calculate transfer to ice through Bergeron process
! note: this approach assumes that ice/liquid is mixed throughout the 
! cloudy portion of the grid cell
! END NOTE

! make sure to initialize bergeron process to zero
             berg(i,k) = 0._mg_pr

             qvdep_qi(i,k) = 0._mg_pr

! cmel and cmei are liquid and ice condensate as clacuklated in nc_cond.F90
! and input here
             cmel(i,k) = dqcdt(i,k)
             cmei(i,k) = dqidt(i,k)
             dum2 = dqcdt(i,k) + dqidt(i,k)

! get in-cloud qi and ni after nucleation
!RSH: Note loop may be unnecessary since icldm >= mincld, which is > 0.
             if (cldm(i,k) .gt. 0._mg_pr) then
               qiic(i,k)=qinew/cldm(i,k)
               niic(i,k)=ninew/cldm(i,k)
             else
               qiic(i,k)=0._mg_pr
               niic(i,k)=0._mg_pr
             endif

             IF (.NOT. limit_berg) THEN
               if (dum2 .ge. 0._mg_pr .and.     &
                      (qc(i,k) + dqcdt(i,k)*deltat > qsmall) ) then
                 do_berg1 = .true.
               else
                 do_berg1 = .false.
               end if
             ELSE
               if (dum2 .ge. 0._mg_pr .and. qinew .gt. berg_lim )  then
                 do_berg1 = .true.
               else
                 do_berg1 = .false.
               end if
             END If

             if (do_berg1) then
               if (t(i,k) .lt. tfreeze ) then
                 if (qi(i,k) > qsmall) then
! calculate Bergeron process

                   bergtsf = 0._mg_pr ! bergeron time scale 
                                      ! (fraction of timestep)
                   qvi = 0.622_mg_pr*esi(i,k)/(pfull(i,k) - d378*esi(i,k))
                   qvl = 0.622_mg_pr*esl(i,k)/(pfull(i,k) - d378*esl(i,k))
                   dqsidt =  xxls*qvi/(rv*t(i,k)**2)
                   abi(i,k) = 1._mg_pr + dqsidt*xxls/cpp

! get ice size distribution parameters
!adding this 10/1 0421AM
                   if (qiic(i,k).ge.qsmall) then
                     lami(k) = (gamma_mg(1._mg_pr + di_mg)*ci_mg* &
                                niic(i,k)/qiic(i,k))**(1._mg_pr/di_mg)
                     n0i(k) = niic(i,k)*lami(k)

! check for slope
                     lammax = 1._mg_pr/min_diam_ice
                     lammin = 1._mg_pr/(2._mg_pr*dcs)

! adjust vars
                     if (lami(k) .lt. lammin) then
                       lami(k) = lammin
                       n0i(k) = lami(k)**(di_mg + 1._mg_pr)*qiic(i,k)/  &
                                      (ci_mg*gamma_mg(1._mg_pr + di_mg))
                     else if (lami(k) .gt. lammax) then
                       lami(k) = lammax
                       n0i(k) = lami(k)**(di_mg + 1._mg_pr)*qiic(i,k)/  &
                                        (ci_mg*gamma_mg(1._mg_pr + di_mg))
                     end if
 
                     epsi = 2._mg_pr*pi*n0i(k)*rho(i,k)*Dv(i,k)/  &
                                                        (lami(k)*lami(k))
                     if (qc(i,k) + dqcdt(i,k)*deltat .gt. qsmall) then
                       prd = epsi*(qvl - qvi)/abi(i,k)
                     else
                       prd = 0._mg_pr
                     end if

! multiply by cloud fraction
                     prd = prd*cldm(i,k)

                     berg(i,k) = max(0._mg_pr, prd)
                   end if

                   if (berg(i,k) .gt. 0._mg_pr) then
                     bergtsf = max(0._mg_pr,    &
                                 ((dqcdt(i,k) + qc(i,k)/deltat)/berg(i,k)))
                     if(bergtsf .lt. 1._mg_pr) berg(i,k) = &
                          max(0._mg_pr, dqcdt(i,k) + qc(i,k)/deltat)
                   endif
!TEST IF NEEDED: 9/27 0133Z
                   if (t(i,k) < tfreeze  - 40._mg_pr) then
                     berg(i,k) = 0._mg_pr
                   endif
!cms++
! vapor deposition onto cloud ice 
                   if (qv_on_qi) then
                     dqsi = MAX(qv(i,k) - qvi, 0._mg_pr)
                     qvdep_qi(i,k) = max(min(prd - cmei(i,k) - berg(i,k), &
                                             dqsi/deltat*omsm), 0._mg_pr)
                   end if
!cms--
                 endif
               end if  ! t < 273.15
             endif ! (do_berg1)

! limit cmel,cmei due for roundoff error
             cmel(i,k) = cmel(i,k)*omsm
             cmei(i,k) = cmei(i,k)*omsm

! define activated ice nuclei
             if (t(i,k) <  tfreeze - 5.0_mg_pr) then

! use number calculated outside this code
               IF (Nml%do_ice_nucl_wpdf) THEN
                 IF (total_activation) THEN
                   if (delta_cf(i,k) .gt. 0._mg_pr) then 
                     dum2i(i,k) = crystal1(i,k)*cldm(i,k)/rho(i,k)
                   else
                     dum2i(i,k) = 0._mg_pr
                   end if
                 ELSEIF (dqa_activation) THEN
                   dum2i(i,k) = crystal1(i,k)/rho(i,k)
                 END IF
               ELSE
! cooper
                 dum2i(i,k) =  min(0.005_mg_pr*exp(0.304_mg_pr*  &
                            (tfreeze - t(i,k)))*1000._mg_pr, 208.9e3_mg_pr)
               END IF
             else
               dum2i(i,k) = 0.0_mg_pr
             endif
           end do
         end do



!pdf clouds option -- validity ??
!re-calculate cloud fraction
         IF (Nml%do_pdf_clouds .AND.   &
            (Nml%super_ice_opt .EQ. 1 .OR. Nml%super_ice_opt .EQ. 2)) THEN
           IF (Nml%super_ice_opt .EQ. 1) THEN
             DO k=1,kdim
               DO i=1,idim
                 ttmp = t(i,k) 
                 IF (ttmp .LT. tfreeze - 40._mg_pr .OR.    &
                    (ttmp .LE. tfreeze .AND. qc(i,k) +    &
                         (cmel(i,k) - berg(i,k) )/deltat  &
                                          .LT. 3._mg_pr*Nml%qmin)) THEN 
                   eslt = polysvp_i(ttmp)
                 ELSE
                   eslt = polysvp_l(ttmp)
                 END IF
                 qs_d = pfull(i,k) - d378*eslt
                 qs_d = max(qs_d, eslt)
                 qs(i,k) = d622*eslt/qs_d 
               END DO
             END DO
           END IF

           IF (Nml%super_ice_opt .EQ. 2) THEN
             DO k=1,kdim
               DO i=1,idim
                 ttmp = t(i,k) 
                 IF (ttmp .LT. tfreeze - 40._mg_pr .OR.   &
                    (ttmp .LE. tfreeze .AND. qc(i,k) +   &
                         (cmel(i,k) - berg(i,k) )/deltat   &
                                       .LT. 3._mg_pr*Nml%qmin) ) THEN 
                   eslt = polysvp_i(ttmp)
                   tc = ttmp - tfreeze
!!!                rhi=MIN( max_super_ice, 0.000195*tc**2+0.00266*tc+1.005)
                   rhi = 0.000195_mg_pr*tc**2 + 0.00266_mg_pr*tc +   &
                                                               1.005_mg_pr
                 ELSE
                   eslt = polysvp_l(ttmp)
                   rhi = 1._mg_pr
                 END IF
                 qs_d = pfull(i,k) - d378*eslt
                 qs_d = max(qs_d, eslt)
                 qs(i,k)= rhi*d622*eslt/qs_d 
               END DO
             END DO
           END IF

           qtot = qv_in + qc_in + qi_in 

           IF ( Nml%pdf_org )    &
                 call error_mesg ( 'morrison_gettelman_microp', &
                                        'ERROR 1 simple_pdf ', FATAL)

           CALL  simple_pdf (j, idim, jdim, kdim, Nml%qmin, qa0, &
                             qtot, qs,  gamma, Nml%qthalfwidth,  &
                             Nml%betaP, inv_dtcloud,                 &
!inout
                             SA_0,                            &
!diag
                             n_diag_4d, diag_4d, diag_id, diag_pt,  &
                             SA, qa_upd)


           do k=1,kdim
             do i=1,idim
               cldm(i,k) = max(qa_upd(i,k), mincld)
             end do
           end do 
         END IF  

!! initialize sub-step precip flux variables
         do i=1,idim
!! flux is zero at top interface, so these should stay as 0.
           do k=1,kdim
 
! initialize normal and sub-step precip flux variables
             atotrt1(i,k)=0._mg_pr
             asnowrt1(i,k)=0._mg_pr
           end do 
         end do 

!! initialize final precip flux variables.
         do i=1,idim
!! flux is zero at top interface, so these should stay as 0.
           do k=1,kdim
! initialize normal and sub-step precip flux variables
             atotrt(i,k)=0._mg_pr
             asnowrt(i,k)=0._mg_pr
           end do 
         end do 

         do i=1,idim
           ltrue(i) = 0
           do k=1,kdim
! hm add 3/19/07 skip microphysical calculations if no cloud water

             if (qc(i,k).ge.qsmall .or. qi(i,k).ge.qsmall .or.   &
                 cmel(i,k).ge.qsmall .or. cmei(i,k).ge.qsmall .or.   &
                 qvdep_qi(i,k).ge.qsmall) ltrue(i)=1

!cms also skip if total water amount is negative anywhere within the column
             if (qc(i,k) + qi(i,k) + qv(i,k) .lt. -1.e-9_mg_pr .OR.  &
                 qv(i,k)  .lt. -1.e-9_mg_pr) then
               ltrue(i) = 0
               nrefuse = nrefuse + 1
             end if
           end do
         end do


! assign number of sub-steps to iter
! use 2 sub-steps, following tests described in 
! Morrison and Gettelman, 2007, J. Clim.
         iter = 2

! get sub-step time step
         deltat = deltat/real(iter)

!!!! skip calculations if no cloud water

         do i=1,idim

           if (ltrue(i) .eq. 0) then
             do k=1,kdim
               tlat(i,k)=0._mg_pr
               qvlat(i,k)=0._mg_pr
               qctend(i,k)=0._mg_pr
               qitend(i,k)=0._mg_pr
               qnitend(i,k)=0._mg_pr
               qrtend(i,k)=0._mg_pr
               nctend(i,k)=0._mg_pr
               nitend(i,k)=0._mg_pr
               nrtend(i,k)=0._mg_pr
               nstend(i,k)=0._mg_pr
               prect(i)=0._mg_pr
               preci(i)=0._mg_pr
               qniic(i,k)=0._mg_pr
               qric(i,k)=0._mg_pr
               nsic(i,k)=0._mg_pr
               nric(i,k)=0._mg_pr

! hm add 9/5/07
               rainrt(i,k)=0._mg_pr
             end do
             goto 300
           end if

           cmel_orig(i,:) = cmel(i,:)
           cmei_orig(i,:) = cmei(i,:)
           berg_orig(i,:) = berg(i,:)

!!!!!!!!! begin sub-step!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!.........................................................................

           do it=1,iter
             do k=1,kdim

! initialize sub-step microphysical tendencies
               tlat(i,k)=0._mg_pr
               qvlat(i,k)=0._mg_pr
               qctend(i,k)=0._mg_pr
               qitend(i,k)=0._mg_pr
               qnitend(i,k)=0._mg_pr
               qrtend(i,k)=0._mg_pr
               nctend(i,k)=0._mg_pr
               nitend(i,k)=0._mg_pr
               nrtend(i,k)=0._mg_pr
               nstend(i,k)=0._mg_pr

! initialize diagnostic precipitation to zero

               qniic(i,k)=0._mg_pr
               qric(i,k)=0._mg_pr
               nsic(i,k)=0._mg_pr
               nric(i,k)=0._mg_pr

               nerosc(i,k) = nerosc4(i,k)
               nerosi(i,k) = nerosi4(i,k)
               D_eros_l(i,k) = D_eros_l4(i,k)
               D_eros_i(i,k) = D_eros_i4(i,k)

               cmel(i,k) = cmel_orig(i,k)
               cmei(i,k) = cmei_orig(i,k)
               berg(i,k) = berg_orig(i,k)

! hm, add 9/5/07
 
               rainrt(i,k)=0._mg_pr

             end do

! initialize vertically-integrated rain and snow tendencies

             qrtot = 0._mg_pr
             nrtot = 0._mg_pr
             qstot = 0._mg_pr
             nstot = 0._mg_pr

! initialize precip at surface

             prect(i)=0._mg_pr
             preci(i)=0._mg_pr

             do k=1,kdim

! set cwml and cwmi to current qc and qi
               cwml(i,k) = qc(i,k)
               cwmi(i,k) = qi(i,k)

! initialize precip fallspeeds to zero

               ums(k) = 0._mg_pr 
               uns(k) = 0._mg_pr 
               umr(k) = 0._mg_pr 
               unr(k)= 0._mg_pr

! calculate precip fraction based on maximum overlap assumption

               if (k .eq. 1) then
                 cldmax(i,k) = cldm(i,k)
               else

! hm add sep 6, 2006, if rain or snow mix ratio is smaller than
! threshold, then set cldmax to cloud fraction at current level
                 if (qric(i,k-1) .ge. qsmall .or.   &
                        qniic(i,k-1) .ge. qsmall) then
                   cldmax(i,k) = max(cldmax(i,k-1), cldm(i,k))
                 else
                   cldmax(i,k) = cldm(i,k)
                 end if
               end if

! should this be behind the next block (scaling)?
! decrease in number concentration due to sublimation/evap
! divide by cloud fraction to get in-cloud decrease
! don't reduce Nc due to bergeron process ?????
 
               nsubi(k) = 0._mg_pr
               nsubc(k) = 0._mg_pr
 
               if (.not. tiedtke_macrophysics) then
                 if (cmei(i,k) < 0._mg_pr .and.     &
                     qi(i,k) > qsmall .and.    &
                     cldm(i,k) > mincld) then
                   nsubi(k) = cmei(i,k)/qi(i,k)*ni(i,k)/cldm(i,k)
                 else
                   nsubi(k) = 0._mg_pr
                 end if
                 if (cmel(i,k) < 0._mg_pr  .AND.    &
                     qc(i,k) .ge. qsmall  .and.    &
                     cldm(i,k) > mincld)      then
                   nsubc(k) = cmel(i,k)/qc(i,k)*nc(i,k)/cldm(i,k)
                 else
                   nsubc(k) = 0._mg_pr
                 end if
               end if
       
!c.......................................................................
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! obtain in-cloud values of cloud water/ice mixing ratios and number 
! concentrations for microphysical process calculations
! units are kg/kg for mixing ratio, 1/kg for number conc

! limit in-cloud values to 0.005 kg/kg


               qcic(i,k) = min(cwml(i,k)/cldm(i,k), in_cloud_limit)
               qiic(i,k) = min(cwmi(i,k)/cldm(i,k), in_cloud_limit)
               ncic(i,k) = max(nc(i,k)/cldm(i,k), 0._mg_pr)
               niic(i,k) = max(ni(i,k)/cldm(i,k), 0._mg_pr)

               if (qc(i,k) +    &
                      (cmel(i,k) + D_eros_l(i,k) - berg(i,k))*deltat   &
                                                          .lt. qsmall) then
                 qcic(i,k) = 0._mg_pr
                 ncic(i,k) = 0._mg_pr

                 if (qc(i,k) +   &
                      (cmel(i,k) + D_eros_l(i,k) - berg(i,k))*deltat   &
                                                      .lt. 0._mg_pr) then
                   if (cmel(i,k) .lt. 0._mg_pr) then

!++ first only scale cmel, d_eros
                     dum = -cmel(i,k) - D_eros_l(i,k)
                     if (dum .gt. 1.e-30_mg_pr) then
                       dum3 = qc(i,k)/deltat/dum*omsm
                     else
                       dum3 = 0._mg_pr 
                     end if
                     cmel(i,k) = dum3*cmel(i,k)
                     D_eros_l(i,k) = dum3*D_eros_l(i,k)

!--
                     dum = -cmel(i,k) - D_eros_l(i,k) + berg(i,k)
                     if (dum .gt. 1.e-30_mg_pr) then
                       dum3 = qc(i,k)/deltat/dum*omsm
                     else
                       dum3 = 0._mg_pr 
                     end if
                     cmel(i,k) = dum3*cmel(i,k)
                     D_eros_l(i,k) = dum3*D_eros_l(i,k)
                     berg(i,k) = dum3*berg(i,k)
                   else
                     dum = -D_eros_l(i,k) + berg(i,k)
!                    berg(i,k)=qc(i,k)/deltat*omsm
                     if (dum .gt. 1.e-30_mg_pr) then
                       dum3 = (qc(i,k)/deltat + cmel(i,k))/dum*omsm
                     else
                       dum3 = 0._mg_pr 
                     end if 
                     D_eros_l(i,k) = D_eros_l(i,k)*dum3
                     berg(i,k) = berg(i,k)*dum3
                   end if
                 end if
               end if

               if (qi(i,k) + (cmei(i,k) + D_eros_i(i,k) + berg(i,k) +  &
                                  qvdep_qi(i,k))*deltat .lt. qsmall) then
                 qiic(i,k) = 0._mg_pr
                 niic(i,k) = 0._mg_pr
                 if (qi(i,k) + (cmei(i,k) + berg(i,k) + D_eros_i(i,k) +  &
                                 qvdep_qi(i,k))*deltat .lt. 0._mg_pr) then
                   if (cmei(i,k) .lt. 0._mg_pr) then
                     dum = - cmei(i,k) - D_eros_i(i,k) 
                     if (dum .gt. 1.e-30_mg_pr) then
                       dum3 = (qi(i,k)/deltat + berg(i,k) +   &
                                                  qvdep_qi(i,k))/dum*omsm
                     else
                       dum3 = 0._mg_pr 
                     end if
                     cmei(i,k) = dum3*cmei(i,k)
                     D_eros_i(i,k) = dum3*D_eros_i(i,k)
                   else
                     dum = - D_eros_i(i,k)
                     if (dum .gt. 1.e-30_mg_pr) then
                       dum3 = (qi(i,k)/deltat + cmei(i,k) + berg(i,k) + &
                                                   qvdep_qi(i,k))/dum*omsm
                     else
                       dum3 = 0._mg_pr
                     end if
                     D_eros_i(i,k) = dum3*D_eros_i(i,k)
                   end if
                 end if
               end if

! add to cme output

!cms           cmeout1(i,k) = cmeout1(i,k)+cmel(i,k)+cmei(i,k)

            
               if (qiic(i,k) .ge. qsmall .and.    &
                   t(i,k) .lt. tfreeze - 5._mg_pr) then

! if NCAI > 0. then set numice = ncai (as before)
! note: this is gridbox averaged
 
                 if (total_activation) then
                   nnuccd(k) = (dum2i(i,k) - ni(i,k)/cldm(i,k))/deltat*  &
                                                                  cldm(i,k)
                   nnuccd(k) = max(nnuccd(k), 0._mg_pr)
                 else if (dqa_activation ) then
                   nnuccd(k) = max(delta_cf(i,k), 0.)*dum2i(i,k)/deltatin
                 endif
                 nimax = dum2i(i,k)*cldm(i,k)
               else
                 nnuccd(k) = 0._mg_pr
                 nimax = 0._mg_pr
                 mnuccd(k) = 0._mg_pr
               end if

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! droplet activation
! calculate potential for droplet activation if cloud water is present

               if (qcic(i,k) .ge. qsmall) then
                 IF (total_activation) THEN
                   if (delta_cf(i,k) .gt. 0._mg_pr) then
                     dum2l(i,k) = drop2(i,k)*cldm(i,k)
                   else 
                     dum2l(i,k) = 0._mg_pr
                   end if

! assume aerosols already activated are equal to number of existing 
! droplets for simplicity
! multiply by cloud fraction to obtain grid-average tendency
                   npccn(k) = (dum2l(i,k) - nc(i,k)/cldm(i,k))/deltat*  &
                                                                 cldm(i,k)

! make sure number activated > 0
                   npccn(k) = max(0._mg_pr, npccn(k))

                 ELSE IF (dqa_activation) THEN
! delta_cf:  A_dt * (1.-qabar)   where A_dt = A*dt , A source rate
! Eq. 7 of Yi's 2007 paper
! dum2l has already been multiplied by 1.e6/airdens(i,k)
                   dum2l(i,k) = drop2(i,k) 
                   npccn(k) = max(delta_cf(i,k), 0.)*dum2l(i,k) /deltatin
                 END IF
                 ncmax = dum2l(i,k)*cldm(i,k)
               else
                 npccn(k) = 0._mg_pr
                 ncmax = 0._mg_pr
               end if

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! get size distribution parameters based on in-cloud cloud water/ice 
! these calculations also ensure consistency between number and 
! mixing ratio
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!......................................................................
! cloud ice

               if (qiic(i,k).ge.qsmall) then

! add upper limit to in-cloud number concentration to prevent
! numerical error
                 niic(i,k) = min(niic(i,k), qiic(i,k)*1.e20_mg_pr)
                 lami(k) = (gamma_mg(1._mg_pr + di_mg)*ci_mg* &
                                   niic(i,k)/qiic(i,k))**(1._mg_pr/di_mg)
                 n0i(k) = niic(i,k)*lami(k)

! check for slope
                 lammax = 1._mg_pr/min_diam_ice
                 lammin = 1._mg_pr/(2._mg_pr*dcs)

! adjust vars
                 if (lami(k) .lt. lammin) then
                   lami(k) = lammin
                   n0i(k) = lami(k)**(di_mg + 1._mg_pr)*qiic(i,k)/  &
                                        (ci_mg*gamma_mg(1._mg_pr + di_mg))
                   niic(i,k) = n0i(k)/lami(k)
                 else if (lami(k) .gt. lammax) then
                   lami(k) = lammax
                   n0i(k) = lami(k)**(di_mg + 1._mg_pr)*qiic(i,k)/    &
                                        (ci_mg*gamma_mg(1._mg_pr + di_mg))
                   niic(i,k) = n0i(k)/lami(k)
                 end if
               else
                 lami(k) = 0._mg_pr
                 n0i(k) = 0._mg_pr
               end if

               if (qcic(i,k).ge.qsmall) then

! add upper limit to in-cloud number concentration to prevent   
! numerical error
                 ncic(i,k) = min(ncic(i,k), qcic(i,k)*1.e20_mg_pr)

! get pgam from fit to observations of martin et al. 1994

!RSH BUGFIX email of 6/8/10
!                pgam(k) = 0.0005714_mg_pr*(ncic(i,k)/1.e6_mg_pr/   &
!                                                 rho(i,k)) + 0.2714_mg_pr
                 pgam(k) = 0.0005714_mg_pr*(ncic(i,k)/1.e6_mg_pr*  &
                                                  rho(i,k)) + 0.2714_mg_pr
                 pgam(k) = 1._mg_pr/(pgam(k)**2) - 1._mg_pr
                 pgam(k) = max(pgam(k), 2._mg_pr)
                 pgam(k) = min(pgam(k), 15._mg_pr)

! calculate lamc
                 lamc(k) = (pi/6._mg_pr*rhow*ncic(i,k)*  &
                             gamma_mg(pgam(k) + 4._mg_pr)/(qcic(i,k)*    &
                       gamma_mg(pgam(k) + 1._mg_pr)))**(1._mg_pr/3._mg_pr)

! lammin, 40 micron diameter max mean size
                 lammin = (pgam(k) + 1._mg_pr)/max_diam_drop
                 lammax = (pgam(k) + 1._mg_pr)/min_diam_drop

                 if (lamc(k) .lt. lammin) then
                   lamc(k) = lammin
                   ncic(i,k) = 6._mg_pr*lamc(k)**3*qcic(i,k)* &
                                     gamma_mg(pgam(k) + 1._mg_pr)/ &
                                    (pi*rhow*gamma_mg(pgam(k) + 4._mg_pr))
                 else if (lamc(k) .gt. lammax) then
                   lamc(k) = lammax
                   ncic(i,k) = 6._mg_pr*lamc(k)**3*qcic(i,k)* &
                                       gamma_mg(pgam(k) + 1._mg_pr)/ &
                                     (pi*rhow*gamma_mg(pgam(k) + 4._mg_pr))
                 end if

! parameter to calculate droplet freezing
                 cdist1(k) = ncic(i,k)/gamma_mg(pgam(k) + 1._mg_pr) 
               else
                 lamc(k) = 0._mg_pr
                 cdist1(k) = 0._mg_pr
               end if

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! begin micropysical process calculations 
!.................................................................
! autoconversion of cloud liquid water to rain
! formula from Khrouditnov and Kogan (2000)
! minimum qc of 1 x 10^-8 prevents floating point error

               if (qcic(i,k) .ge. 1.e-8_mg_pr) then

! nprc is increase in rain number conc due to autoconversion
! nprc1 is decrease in cloud droplet conc due to autoconversion

! assume exponential sub-grid distribution of qc, resulting in additional
! factor related to qcvar below

!                prc(k) = gamma_mg(qcvar+2.47_mg_pr)/(gamma_mg(qcvar)*qcvar**2.47_mg_pr)*1350._mg_pr*qcic(i,k)**2.47_mg_pr* &
                 prc(k) = sfac1*1350._mg_pr*qcic(i,k)**2.47_mg_pr* &
                            (ncic(i,k)/1.e6_mg_pr*rho(i,k))**(-1.79_mg_pr)
                 nprc(k) = prc(k)/(4._mg_pr/3._mg_pr*pi*rhow*   &
                                                      (25.e-6_mg_pr)**3)
                 nprc1(k) = prc(k)/(qcic(i,k)/ncic(i,k))
               else
                 prc(k)=0._mg_pr
                 nprc(k)=0._mg_pr
                 nprc1(k)=0._mg_pr
               end if

! add autoconversion to precip from above to get provisional rain mixing 
! ratio and number concentration (qric and nric)
! 0.45 m/s is fallspeed of new rain drop (80 micron diameter)

               dum = 0.45_mg_pr
               dum1 = 0.45_mg_pr

! hm modify 6/12
               if (k .eq. 1) then
                 qric(i,k) = prc(k)*cldm(i,k)*dz(i,k)/cldmax(i,k)/dum
                 nric(i,k) = nprc(k)*cldm(i,k)*dz(i,k)/cldmax(i,k)/dum
               else
                 if (qric(i,k-1) .ge. qsmall) then
                   dum = umr(k-1)
                   dum1 = unr(k-1)
                 end if

! hm add 4/17/06, no autoconversion of rain number if rain/snow falling 
! from above
! this assumes that new drizzle drops formed by autoconversion are 
! rapidly collected by the existing rain/snow particles from above
 
!RSH 2011:
! NCAR allows no autoconversion of rain number if rain/snow falling from 
! above. this assumes that new drizzle drops formed by autoconversion are 
! rapidly collected by the existing rain/snow particles falling from above.
! Marc's code allowed autoconversion to change rain number, so  variable 
! allow_all_cldtop_collection was introduced, which when .true. would turn
! off this effect. By default, it is .false. for GFDL (as in MG) in both 
! this subroutine and in the NCAR subroutine(cldwat2m_micro.F90), in 
! contrast to the original NCAR code.

                 if (allow_all_cldtop_collection) then
                   if (qric(i,k-1) .ge. 1.e-9_mg_pr .or.   &
                                 qniic(i,k-1) .ge. 1.e-9_mg_pr) then
                     nprc(k) = 0._mg_pr
                   end if
                 endif  !  allow_all_cldtop_collection

                 qric(i,k) = (rho(i,k-1)*umr(k-1)*qric(i,k-1)*  &
                                                        cldmax(i,k-1) + &
                             (rho(i,k)*dz(i,k)*  &
                              ((pra(k-1) + prc(k))*cldm(i,k) +    &
                                 (pre(k-1) - pracs(k-1) - mnuccr(k-1))*  &
                                                  cldmax(i,k))))/  &
                                                (dum*rho(i,k)*cldmax(i,k))
                 nric(i,k) = (rho(i,k-1)*unr(k-1)*nric(i,k-1)*   &
                                                         cldmax(i,k-1) + &
                             (rho(i,k)*dz(i,k)*(nprc(k)*cldm(i,k) +   &
                               (nsubr(k-1) - npracs(k-1) - nnuccr(k-1) + &
                                        nragg(k-1))*cldmax(i,k))))/   &
                                             (dum1*rho(i,k)*cldmax(i,k))
               end if

!  cloudice to snow autoconversion. if parameter one_ice is .true., then
!  cloudice and snow are retained in the same variable (as in the R-K 
!  microphysics) 
               IF (.NOT. one_ice) THEN

                 if (t(i,k) .le. tfreeze .and. qiic(i,k) .ge. qsmall) then

                   IF (auto_conv_ice_choice .EQ. 1) THEN  
!.......................................................................
! Autoconversion of cloud ice to snow
! similar to Ferrier (1994)
! note: assumes autoconversion timescale of 180 sec
                     nprci(k) = n0i(k)/(lami(k)*auto_conv_time_scale)*  &
                                                         exp(-lami(k)*dcs)
                     prci(k) = pi*rhoi*n0i(k)/(6._mg_pr*  &
                                                  auto_conv_time_scale)* &
                               (dcs**3/lami(k) + 3._mg_pr*dcs**2/ &
                                  lami(k)**2 + 6._mg_pr*dcs/lami(k)**3 +  &
                                     6._mg_pr/lami(k)**4)*exp(-lami(k)*dcs)

                   ELSE IF (auto_conv_ice_choice .EQ. 2) THEN
!.......................................................................
! AUTOCONVERSION OF CLOUD ICE TO SNOW
! FOLLOWING HARRINGTON ET AL. (1995) WITH MODIFICATION
! HERE IT IS ASSUMED THAT AUTOCONVERSION CAN ONLY OCCUR WHEN THE
! ICE IS GROWING, I.E. IN CONDITIONS OF ICE SUPERSATURATION
                     prci(k) = 0._mg_pr
                     nprci(k) = 0._mg_pr
                     esi(i,k) = polysvp_i(t(i,k))
                     qvi = 0.622_mg_pr*esi(i,k)/    &
                                            (pfull(i,k) - d378*esi(i,k))
                     dqsidt = xxls*qvi/(rv*t(i,k)**2)
                     abi(i,k) = 1._mg_pr + dqsidt*xxls/cpp
                     IF (Q(i,k) - QVI .GT. qsmall) THEN
                       NPRCI(K) = 4._mg_pr/(DCS*RHOI)*(Q(i,k) - QVI)*  &
                                    rho(i,k)*n0i(K)*   &
                                         EXP(-lami(K)*dcs)*dv(i,k)/abi(i,k)
                       NPRCI(K) = MIN(NPRCI(K), niic(i,K)/deltat)
                       PRCI(K) = MIN(PI*RHOI*DCS**3/6._mg_pr*NPRCI(K),   &
                                                         qiic(i,k)/deltat)
                     END IF

                   ELSE IF (auto_conv_ice_choice  .EQ. 3) THEN  
!.......................................................................
! Autoconversion of cloud ice to snow
! similar to Ferrier (1994)
! note: assumes autoconversion timescale of 180 sec
                     IF (lami(k) .LT. 1._mg_pr/autoconv_ice_thr) THEN 
                       nprci(k) = n0i(k)/(lami(k)*auto_conv_time_scale)* &
                                                         exp(-lami(k)*dcs)
                       prci(k) = pi*rhoi*n0i(k)/(6._mg_pr*    &
                                                 auto_conv_time_scale)* &
                                     (dcs**3/lami(k) +     &
                                          3._mg_pr*dcs**2/lami(k)**2 + &
                                              6._mg_pr*dcs/lami(k)**3 +   &
                                    6._mg_pr/lami(k)**4)*exp(-lami(k)*dcs) 
                     END IF

                   ELSE IF (auto_conv_ice_choice .EQ. 4) THEN  
! ferrier, 1994, 4.54    
                     dum = 1._mg_pr/autoconv_ice_thr 
                     IF (lami(k) .LT. dum) THEN 
                       nprci(k) = niic(i,K)/deltat*(1._mg_pr -   &
                                                      (lami(k)/dum )**3 )
                       prci(k) = qiic(i,k)/deltat*(1._mg_pr -   &
                                     (lami(k)/dum)**3)/   &
                                           (1._mg_pr + (lami(k)/dum)**3)
                     END IF

                   ELSE IF (auto_conv_ice_choice .EQ. 5) THEN  
!.......................................................................
! Autoconversion of cloud ice to snow
! similar to Ferrier (1994)
! note: assumes autoconversion timescale of 180 sec
                     IF (qiic(i,k) .GE. auto_conv_m_thresh) THEN 
                       nprci(k) = n0i(k)/(lami(k)*auto_conv_time_scale)*&
                                                        exp(-lami(k)*dcs)
                       prci(k) = pi*rhoi*n0i(k)/(6._mg_pr*  &
                                                  auto_conv_time_scale)* &
                                  (dcs**3/lami(k) +    &
                                      3._mg_pr*dcs**2/lami(k)**2 + &
                                          6._mg_pr*dcs/lami(k)**3 +  &
                                     6._mg_pr/lami(k)**4)*exp(-lami(k)*dcs)
                     END IF
                   END IF
                 else ! t(i,k) .le. tfreeze .and. qiic(i,k) .ge. qsmall
                   prci(k) = 0._mg_pr
                   nprci(k) = 0._mg_pr
                 end if ! t(i,k) .le. tfreeze .and. qiic(i,k) .ge. qsmall
               ELSE ! one_ice
                 prci(k) = 0._mg_pr
                 nprci(k) = 0._mg_pr
               END IF ! one_ice

! add autoconversion on current level to flux from level above to get 
! provisional snow mixing ratio and number concentration (qniic and nsic)

               dum = (asn(i,k)*dcs**bs)
               dum1 = (asn(i,k)*dcs**bs)

               if (k .eq. 1) then
                 qniic(i,k) = prci(k)*cldm(i,k)*dz(i,k)/cldmax(i,k)/dum
                 nsic(i,k) = nprci(k)*cldm(i,k)*dz(i,k)/cldmax(i,k)/dum
               else
                 if (qniic(i,k-1) .ge. qsmall) then
                   dum = ums(k-1)
                   dum1 = uns(k-1)
                 end if

!++ag fixed snow bug (from Morrison nov.27.2007)
!                qniic(i,k) = (rho(i,k-1)*ums(k-1)*qniic(i,k-1)*  &
!                                                     cldmax(i,k-1) + &
!                              (rho(i,k)*dz(i,k)*(prci(k)*cldm(i,k) +  &
!                                  (prai(k-1) + psacws(k-1) + prci(k-1) + &
!                                        bergs(k-1))*cldmax(i,k))))/  &
!                                          (dum*rho(i,k)*cldmax(i,k))

                 qniic(i,k) = (rho(i,k-1)*ums(k-1)*qniic(i,k-1)*  &
                                                       cldmax(i,k-1) + &
                              (rho(i,k)*dz(i,k)*((prci(k) + prai(k-1) + &
                                  psacws(k-1) + bergs(k-1))*cldm(i,k) +  &
                                 (prds(k-1) + pracs(k-1) + mnuccr(k-1))*  &
                                                         cldmax(i,k))))/  &
                                               (dum*rho(i,k)*cldmax(i,k))
!--ag

                 nsic(i,k) = (rho(i,k-1)*uns(k-1)*nsic(i,k-1)*  &
                                                       cldmax(i,k-1) + &
                             (rho(i,k)*dz(i,k)*(nprci(k)*cldm(i,k) +  &
                                (nsubs(k-1) + nsagg(k-1) + nnuccr(k-1))*  &
                                                        cldmax(i,k))))/   &
                                              (dum1*rho(i,k)*cldmax(i,k))
               end if

! if precip mix ratio is zero so should number concentration
               if (qniic(i,k) .lt. qsmall) then
                 qniic(i,k) = 0._mg_pr
                 nsic(i,k) = 0._mg_pr
               end if
               if (qric(i,k) .lt. qsmall) then
                 qric(i,k) = 0._mg_pr
                 nric(i,k) = 0._mg_pr
               end if

! make sure number concentration is a positive number to avoid 
! taking root of negative later
               nric(i,k) = max(nric(i,k), 0._mg_pr)
               nsic(i,k) = max(nsic(i,k), 0._mg_pr)

!.......................................................................
! get size distribution parameters for precip
!......................................................................
! rain
               if (qric(i,k) .ge. qsmall) then
                 lamr(k) = (pi*rhow*nric(i,k)/qric(i,k))**  &
                                                        (1._mg_pr/3._mg_pr)
                 n0r(k) = nric(i,k)*lamr(k)

! check for slope
                 lammax = 1._mg_pr/20.e-6_mg_pr
                 lammin = 1._mg_pr/500.e-6_mg_pr

! adjust vars
                 if (lamr(k) .lt. lammin) then
                   lamr(k) = lammin
                   n0r(k) = lamr(k)**4*qric(i,k)/(pi*rhow)
                   nric(i,k) = n0r(k)/lamr(k)
                 else if (lamr(k).gt.lammax) then
                   lamr(k) = lammax
                   n0r(k) = lamr(k)**4*qric(i,k)/(pi*rhow)
                   nric(i,k) = n0r(k)/lamr(k)
                 end if

! provisional rain number and mass weighted mean fallspeed (m/s)
                 unr(k) = min (           &
                            arn(i,k)*gamma_mg(1._mg_pr + br)/lamr(k)**br, &
                                                      9.1_mg_pr*rhof(i,k))
                 umr(k) = min (       &
                            arn(i,k)*gamma_mg(4._mg_pr + br)/   &
                                                 (6._mg_pr*lamr(k)**br), &
                                                       9.1_mg_pr*rhof(i,k))
               else
                 lamr(k) = 0._mg_pr
                 n0r(k) = 0._mg_pr
                 umr(k) = 0._mg_pr
                 unr(k) = 0._mg_pr
               end if

!......................................................................
! snow

               if (qniic(i,k) .ge. qsmall) then
                 lams(k) = (gamma_mg(1._mg_pr + ds)*cs*nsic(i,k)/ &
                                              qniic(i,k))**(1._mg_pr/ds)
                 n0s(k) = nsic(i,k)*lams(k)

! check for slope
                 lammax = 1._mg_pr/min_diam_ice
                 lammin = 1._mg_pr/2000.e-6_mg_pr

! adjust vars
                 if (lams(k) .lt. lammin) then
                   lams(k) = lammin
                   n0s(k) = lams(k)**(ds + 1._mg_pr)*qniic(i,k)/   &
                                              (cs*gamma_mg(1._mg_pr + ds))
                   nsic(i,k) = n0s(k)/lams(k)
                 else if (lams(k) .gt. lammax) then
                   lams(k) = lammax
                   n0s(k) = lams(k)**(ds + 1._mg_pr)*qniic(i,k)/    &
                                               (cs*gamma_mg(1._mg_pr + ds))
                   nsic(i,k) = n0s(k)/lams(k)
                 end if

! provisional snow number and mass weighted mean fallspeed (m/s)
                 ums(k) = min (      &
                           asn(i,k)*gamma_mg(4._mg_pr + bs)/   &
                                            (6._mg_pr*lams(k)**bs),  &
                                                    max_vt_snow*rhof(i,k))
                 uns(k) = min (       &
                           asn(i,k)*gamma_mg(1._mg_pr + bs)/lams(k)**bs,  &
                                                    max_vt_snow*rhof(i,k))
               else
                 lams(k) = 0._mg_pr
                 n0s(k) = 0._mg_pr
                 ums(k) = 0._mg_pr
                 uns(k) = 0._mg_pr
               end if

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

! heterogeneous freezing of cloud water

               if (qcic(i,k) .ge. qsmall ) then 
                 mnuccc(k) = 0._mg_pr
                 nnuccc(k) = 0._mg_pr

!contact freezing
                 IF (do_contact_frz) THEN 
                   tc = ttmp - tfreeze
                   IF (tc .LE. -3._mg_pr .AND. tc .GE. -40._mg_pr) THEN
                     IF (rbar_dust(i,k) .GT. 0._mg_pr) THEN

! mean free path
                       dum = 7.37_mg_pr*t(i,k)/(288._mg_pr*10._mg_pr*  &
                                                    pfull(i,k))/100._mg_pr

! effective diffusivity based on Brownian collection
                       dap = 4._mg_pr*pi*1.38e-23_mg_pr*t(i,k)*  &
                             (1._mg_pr + dum/rbar_dust(i,k))/ &
                                     (6._mg_pr*pi*rbar_dust(i,k)*mu(i,k))

! number of contact nucleii similar Young as in  Liu et al.
                       IF (n_contact_opt .eq. 1 ) THEN
                         NACNT = ndust(i,k)/rho(i,k)*  &
                                       (tfreeze - 3._mg_pr - T(i,k))**1.3
                       ELSE IF (n_contact_opt .eq. 2) THEN

!similar Meyers et al., 1992, Eq. 2.6
                         NACNT = ndust(i,k)/rho(i,k)*    &
                                        EXP(-2.8_mg_pr + 0.262_mg_pr*   &
                                                       (tfreeze - T(i,k)))
                       END IF

                       MNUCCC(K) = sfac3*PI*PI/3._mg_pr*RHOW*DAP*NACNT*  &
                                   EXP(LOG(CDIST1(K)) +   &
                                     LOG(GAMMA_mg(PGAM(K) + 5._mg_pr)) - &
                                                    4._mg_pr*LOG(LAMC(K)))
                       NNUCCC(K) = 2._mg_pr*PI*DAP*NACNT*CDIST1(K)*      &
                                     GAMMA_mg(PGAM(K) + 2._mg_pr)/LAMC(K) 

                     END IF
                   END IF
                 END IF  ! (do_contact_frz)

                 IF (do_bigg_frz) THEN 

! immersion freezing (Bigg, 1953)
                   if (t(i,k) .lt. tfreeze - 4._mg_pr) then
!                    mnuccc(k) = gamma_mg(qcvar+2._mg_pr)/    &
!                                        (gamma_mg(qcvar)*qcvar**2)* &
                     mnuccc(k) = mnuccc(k) + sfac2*pi*pi/36._mg_pr*rhow* &
                                          cdist1(k)*  &
                                             gamma_mg(7._mg_pr + pgam(k))*&
!RSH BUGFIX email 8/9/10
                                             bimm*(exp(aimm*(   &
                                          tfreeze - t(i,k))) - 1._mg_pr)/ &
                                                      lamc(k)**3/lamc(k)**3
!                    nnuccc(k) = gamma_mg(qcvar+1._mg_pr)/   &
!                                             (gamma_mg(qcvar)*qcvar)* &
                     nnuccc(k) =  nnuccc(k) + sfac3*pi/6._mg_pr*cdist1(k)*&
                                       gamma_mg(pgam(k) + 4._mg_pr)* &
!RSH BUGFIX email 8/9/10
                                                  bimm*(exp(aimm*(  &
                                 tfreeze - t(i,k))) - 1._mg_pr)/lamc(k)**3

                   end if
                 END IF

                 IF (limit_droplet_freeze_opt .EQ. 1) THEN

! hm add 11/17/06
! make sure number of droplets frozen does not exceed available ice 
! nuclei concentration
! this prevents 'runaway' droplet freezing
                   if (nnuccc(k) .gt. nnuccd(k)/cldm(i,k)) then
                     dum = (nnuccd(k)/cldm(i,k))/nnuccc(k)

! scale mixing ratio of droplet freezing with limit
                     mnuccc(k) = mnuccc(k)*dum
                     nnuccc(k) = nnuccd(k)/cldm(i,k)
                   end if
                 ELSE IF (limit_droplet_freeze_opt .EQ. 2) THEN
                   dum1 = nnuccc(k)*deltat
                   dum2 = ndust(i,k)/rho(i,k)/cldm(i,k)
                   if (dum1 .gt. dum2) then
                     dum = dum2/dum1
 
! scale mixing ratio of droplet freezing with limit
                     mnuccc(k) = mnuccc(k)*dum
                     nnuccc(k) = nnuccc(k)*dum
!!!                  nnuccc(k) = nnuccd(k)/cldm(i,k)
                   end if
                 END IF
               else ! (qcic(i,k) .ge. qsmall )  
                 mnuccc(k) = 0._mg_pr
                 nnuccc(k) = 0._mg_pr
               end if ! (qcic(i,k) .ge. qsmall )  

!.......................................................................
! snow self-aggregation from passarelli, 1978, used by reisner, 1998
! this is hard-wired for bs = 0.4 for now
! ignore self-collection of cloud ice

               if (qniic(i,k) .ge. qsmall .and. t(i,k) .le. tfreeze) then
                 nsagg(k) = -1108._mg_pr*asn(i,k)*Eii* &
                                pi**((1._mg_pr - bs)/3._mg_pr)*   &
                                 rhosn**((-2._mg_pr - bs)/3._mg_pr)*  &
                                  rho(i,k)**((2._mg_pr + bs)/3._mg_pr)*  &
                                  qniic(i,k)**((2._mg_pr + bs)/3._mg_pr)* &
                                    (nsic(i,k)*rho(i,k))**  &
                                           ((4._mg_pr-bs)/3._mg_pr)/ &
                                             (4._mg_pr*720._mg_pr*rho(i,k))
               else
                 nsagg(k)=0._mg_pr
               end if

               IF (.NOT. one_ice) THEN

!.......................................................................
! accretion of cloud droplets onto snow/graupel
! here use continuous collection equation with
! simple gravitational collection kernel
! ignore collisions between droplets/cloud ice
! since minimum size ice particle for accretion is 50 - 150 micron

! ignore collision of snow with droplets above freezing

                 if (qniic(i,k) .ge. qsmall .and.     &
                             t(i,k) .le. tfreeze .and. &
                                  qcic(i,k) .ge. qsmall) then

! put in size dependent collection efficiency
! mean diameter of snow is area-weighted, since
! accretion is function of crystal geometric area
! collection efficiency is from stoke's law (Thompson et al. 2004)

                   dc0 = (pgam(k) + 1._mg_pr)/lamc(k)
                   ds0 = 1._mg_pr/lams(k)
                   dum = dc0*dc0*uns(k)*rhow/(9._mg_pr*mu(i,k)*ds0)
                   eci = dum*dum/((dum + 0.4_mg_pr)*(dum + 0.4_mg_pr))
                   eci = max(eci, 0._mg_pr)
                   eci = min(eci, 1._mg_pr)

! no impact of sub-grid distribution of qc since psacws
! is linear in qc

                   psacws(k) = pi/4._mg_pr*asn(i,k)*qcic(i,k)*rho(i,k)* &
                                   n0s(k)*Eci*gamma_mg(bs + 3._mg_pr)/ &
                                                  lams(k)**(bs + 3._mg_pr)
                   npsacws(k) = pi/4._mg_pr*asn(i,k)*ncic(i,k)*rho(i,k)* &
                                    n0s(k)*Eci*gamma_mg(bs + 3._mg_pr)/ &
                                                  lams(k)**(bs + 3._mg_pr)
                 else
                   psacws(k) = 0._mg_pr
                   npsacws(k) = 0._mg_pr
                 end if

                 psacws_o(k) = 0._mg_pr
                 npsacws_o(k) = 0._mg_pr
               ELSE !one_ice 
                 psacws_o(k) = 0._mg_pr
                 npsacws_o(k) =0._mg_pr
                 IF (lami(k) .gt. 1._mg_pr/50.e-6_mg_pr) THEN 

! provisional snow number and mass weighted mean fallspeed (m/s)
                   ums(k) = min (       &
                              asn(i,k)*gamma_mg(4._mg_pr + bs)/    &
                                           (6._mg_pr*lami(k)**bs),   &
                                                              max_vt_snow)
                   uns(k) = min (      &
                              asn(i,k)*gamma_mg(1._mg_pr + bs)/     &
                                                 lami(k)**bs, max_vt_snow)

!PROBLEM k-1 indices 11/20/11
                   qiic(i,k) = (rho(i,k-1)*ums(k-1)*qiic(i,k-1)*     &
                                                         cldmax(i,k-1) + &
                               (rho(i,k)*dz(i,k)*((psacws_o(k-1))*   &
                                                           cldm(i,k))))/ &
                                                (dum*rho(i,k)*cldmax(i,k))
                   if (qiic(i,k) .ge. qsmall .and.    &
                                 t(i,k) .le. tfreeze .and. &
                                        qcic(i,k) .ge. qsmall) then

! put in size dependent collection efficiency
! mean diameter of snow is area-weighted, since
! accretion is function of crystal geometric area
! collection efficiency is from stoke's law (Thompson et al. 2004)
                     dc0 = (pgam(k) + 1._mg_pr)/lamc(k)
                     ds0 = 1._mg_pr/lami(k)
                     dum = dc0*dc0*uns(k)*rhow/(9._mg_pr*mu(i,k)*ds0)
                     eci = dum*dum/((dum + 0.4_mg_pr)*(dum + 0.4_mg_pr))
                     eci = max(eci, 0._mg_pr)
                     eci = min(eci, 1._mg_pr)

! no impact of sub-grid distribution of qc since psacws
! is linear in qc

                     psacws_o(k) = pi/4._mg_pr*asn(i,k)*qcic(i,k)*  &
                                   rho(i,k)*n0i(k)*Eci*   &
                                     gamma_mg(bs + 3._mg_pr)/ &
                                                 lami(k)**(bs + 3._mg_pr)
                     npsacws_o(k) = pi/4._mg_pr*asn(i,k)*ncic(i,k)*  &
                                   rho(i,k)*n0i(k)*Eci*   &
                                      gamma_mg(bs + 3._mg_pr)/ &
                                                 lami(k)**(bs + 3._mg_pr)
                   else
                     psacws_o(k) = 0._mg_pr
                     npsacws_o(k) = 0._mg_pr
                   end if
                   psacws(k) = 0._mg_pr
                   npsacws(k) = 0._mg_pr
                 END IF !size
               END IF !one_ice 

               IF (.NOT. one_ice) THEN 
!.......................................................................
! accretion of rain water by snow
! formula from ikawa and saito, 1991, used by reisner et al., 1998

                 if (qric(i,k) .ge. 1.e-8_mg_pr .and.     &
                         qniic(i,k) .ge. 1.e-8_mg_pr .and. & 
                                       t(i,k).le. tfreeze) then
                   pracs(k) = pi*pi*ecr*(((1.2_mg_pr*umr(k) -    &
                                                 0.95_mg_pr*ums(k))**2 + &
                               0.08_mg_pr*ums(k)*umr(k))**0.5_mg_pr*rhow* &
                                   rho(i,k)*n0r(k)*n0s(k)* &
                                     (5._mg_pr/(lamr(k)**6*lams(k)) + &
                                      2._mg_pr/(lamr(k)**5*lams(k)**2) + &
                                     0.5_mg_pr/(lamr(k)**4*lams(k)**3)))

                   npracs(k) = pi/2._mg_pr*rho(i,k)*ecr*(1.7_mg_pr*  &
                                                   (unr(k) - uns(k))**2 + &
                                 0.3_mg_pr*unr(k)*uns(k))**0.5_mg_pr*  &
                                                        n0r(k)*n0s(k)* &
                                  (1._mg_pr/(lamr(k)**3*lams(k)) + &
                                   1._mg_pr/(lamr(k)**2*lams(k)**2) + &
                                   1._mg_pr/(lamr(k)*lams(k)**3))
                 else
                   pracs(k)=0._mg_pr
                   npracs(k)=0._mg_pr
                 end if
               ELSE !(.NOT. one_ice) 
                 pracs(k)=0._mg_pr
                 npracs(k)=0._mg_pr
               END IF ! (.NOT. one_ice) 

               IF (.NOT. one_ice) THEN

!.......................................................................
! heterogeneous freezing of rain drops
! follows from Bigg (1953)
                 if (t(i,k) .lt. tfreeze -4._mg_pr .and.    &
                        qric(i,k) .ge. qsmall) then
                   mnuccr(k) = 20._mg_pr*pi*pi*rhow*nric(i,k)*bimm* &
!RSH BUGFIX email 8/9/10
                               (exp(aimm*(tfreeze - t(i,k))) - 1._mg_pr)/ &
                                                  lamr(k)**3/lamr(k)**3

                   nnuccr(k) = pi*nric(i,k)*bimm* &
!RSH BUGFIX email 8/9/10
                               (exp(aimm*(tfreeze - t(i,k))) - 1._mg_pr)/ &
                                                  lamr(k)**3
                 else
                   mnuccr(k) = 0._mg_pr
                   nnuccr(k) = 0._mg_pr
                 end if
               ELSE ! (.NOT. one_ice) 
                 mnuccr(k) = 0._mg_pr
                 nnuccr(k) = 0._mg_pr
               END IF ! (.NOT. one_ice) 

!.......................................................................
! accretion of cloud liquid water by rain
! formula from Khrouditnov and Kogan (2000)
! gravitational collection kernel, droplet fall speed neglected

               if (qric(i,k) .ge. qsmall .and.    &
                               qcic(i,k) .ge. qsmall) then

! include sub-grid distribution of cloud water
!                 pra(k) = gamma_mg(qcvar+1.15_mg_pr)/   &
!                          (gamma_mg(qcvar)*qcvar**1.15_mg_pr) * &
                  pra(k) = sfac4*67._mg_pr*  &
                                         (qcic(i,k)*qric(i,k))**1.15_mg_pr
                  npra(k) = pra(k)/(qcic(i,k)/ncic(i,k))
               else
                 pra(k) = 0._mg_pr
                 npra(k) = 0._mg_pr
               end if

!.......................................................................
! Self-collection of rain drops
! from Beheng(1994)

               if (qric(i,k) .ge. qsmall) then
                 nragg(k) = -8._mg_pr*nric(i,k)*qric(i,k)*rho(i,k)
               else
                 nragg(k) = 0._mg_pr
               end if

!.......................................................................
! Accretion of cloud ice by snow
! For this calculation, it is assumed that the Vs >> Vi
! and Ds >> Di for continuous collection

               IF (.NOT. one_ice) THEN
                 if (qniic(i,k) .ge. qsmall .and.   &
                                qiic(i,k) .ge. qsmall  .and.  &
                                         t(i,k) .le. tfreeze) then
                   prai(k) = pi/4._mg_pr*asn(i,k)*qiic(i,k)*rho(i,k)* &
                                n0s(k)*Eii*gamma_mg(bs + 3._mg_pr)/ &
                                                  lams(k)**(bs + 3._mg_pr)
                   nprai(k) = pi/4._mg_pr*asn(i,k)*niic(i,k)*rho(i,k)*  &
                                   n0s(k)*Eii*gamma_mg(bs + 3._mg_pr)/ &
                                                  lams(k)**(bs + 3._mg_pr)
                 else
                   prai(k) = 0._mg_pr
                   nprai(k) = 0._mg_pr
                 end if
               ELSE
                 prai(k) = 0._mg_pr
                 nprai(k) = 0._mg_pr
               END IF

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! calculate evaporation/sublimation of rain and snow
! note: evaporation/sublimation occurs only in cloud-free portion of 
! grid cell
! in-cloud condensation/deposition of rain and snow is neglected
! except for transfer of cloud water to snow through bergeron process

! initialize evap/sub tendncies
               pre(k) = 0._mg_pr
               prds(k) = 0._mg_pr

! evaporation of rain
! only calculate if there is some precip fraction > cloud fraction

!RSH 8/7/12: return to using qsmall to avoid model blowups
!              if (qcic(i,k) + qiic(i,k) .lt. 1.e-6_mg_pr .or.   &
!                                       cldmax(i,k) .gt. cldm(i,k)) then
               if (qcic(i,k) + qiic(i,k) .lt. qsmall .or.   &
                                        cldmax(i,k) .gt. cldm(i,k)) then

! set temporary cloud fraction to zero if cloud water + ice is very small
! this will ensure that evaporation/sublimation of precip occurs over
! entire grid cell, since min cloud fraction is specified otherwise

!RSH 8/7/12: return to using qsmall to avoid model blowups
!                if (qcic(i,k) + qiic(i,k) .lt. 1.e-6_mg_pr) then
                 if (qcic(i,k) + qiic(i,k) .lt. qsmall) then
                   dum = 0._mg_pr
                 else
                   dum = cldm(i,k)
                 end if
                 ttmp = t(i,k)

! recalculate saturation vapor pressure for liquid and ice
                 esl(i,k) = polysvp_l(t(i,k))
                 esi(i,k) = polysvp_i(t(i,k))
                 esn = esl(i,k)
                 qsn = min (   &
                         epsqs*esn/(pfull(i,k) - (1._mg_pr - epsqs)*esn), &
                                                                  1._mg_pr)
                 qsn = max (qsn, 0._mg_pr)

! MAKE SURE ICE SATURATION DOESN'T EXCEED WATER SAT. NEAR FREEZING
                 IF (esi(i,k) .GT. esl(i,k)) esi(i,k) = esl(i,k)

! calculate q for out-of-cloud region
                 qclr = (q(i,k) - dum*qsn)/(1._mg_pr - dum)
                 if (qric(i,k) .ge. qsmall) then
                   qvs = 0.622_mg_pr*esl(i,k)/(pfull(i,k) - d378*esl(i,k))
                   dqsdt = xxlv*qvs/(rv*t(i,k)**2)
                   ab = 1._mg_pr + dqsdt*xxlv/cpp
                   epsr = 2._mg_pr*pi*n0r(k)*rho(i,k)*Dv(i,k)* &
                         (f1r/(lamr(k)*lamr(k)) +    &
                             f2r*(arn(i,k)*rho(i,k)/mu(i,k))**0.5_mg_pr* &
                                  sc(i,k)**(1._mg_pr/3._mg_pr)*   &
                            gamma_mg(5._mg_pr/2._mg_pr + br/2._mg_pr)/ &
                              (lamr(k)**(5._mg_pr/2._mg_pr + br/2._mg_pr)))
                   pre(k) = epsr*(qclr - qvs)/ab

! only evaporate in out-of-cloud region
! and distribute across cldmax
                   pre(k) = min(pre(k)*(cldmax(i,k) - dum), 0._mg_pr)
                   pre(k) = pre(k)/cldmax(i,k)
                 end if

                 IF (.NOT. one_ice) THEN

! sublimation of snow
                   if (qniic(i,k) .ge. qsmall) then
                     qvi = 0.622_mg_pr*esi(i,k)/    &
                                               (pfull(i,k) - d378*esi(i,k))
                     dqsidt =  xxls*qvi/(rv*t(i,k)**2)
                     abi(i,k) = 1._mg_pr + dqsidt*xxls/cpp
                     dumt1 = 2._mg_pr*pi*n0s(k)*rho(i,k)*Dv(i,k)
                     dumt2 = sc(i,k)**(1._mg_pr/3._mg_pr)*   &
                              gamma_mg(5._mg_pr/2._mg_pr + bs/2._mg_pr)/ &
                               (lams(k)**(5._mg_pr/2._mg_pr + bs/2._mg_pr))
                     epss = 2._mg_pr*pi*n0s(k)*rho(i,k)*Dv(i,k)* &
                                (f1s/(lams(k)*lams(k)) +     &
                              f2s*(asn(i,k)*rho(i,k)/mu(i,k))**0.5_mg_pr* &
                               sc(i,k)**(1._mg_pr/3._mg_pr)*    &
                               gamma_mg(5._mg_pr/2._mg_pr + bs/2._mg_pr)/ &
                              (lams(k)**(5._mg_pr/2._mg_pr + bs/2._mg_pr)))
                     prds(k) = epss*(qclr - qvi)/abi(i,k)
 
! only sublimate in out-of-cloud region and distribute over cldmax
                     prds(k) = min(prds(k)*(cldmax(i,k) - dum), 0._mg_pr)
                     prds(k) = prds(k)/cldmax(i,k)
                   end if
                 ELSE   ! (.NOT. one_ice) 
                   prds(k) = 0._mg_pr
                 END IF ! (.NOT. one_ice) 

! hm add 2/2/07, make sure RH not pushed above 100%
! get updated RH at end of time step based on 
! cloud water/ice condensation/evap

                 qtmp = q(i,k) - (D_eros_l(i,k) + D_eros_i(i,k) +  &
                        cmel(i,k) + cmei(i,k) + qvdep_qi(i,k) +    &
                                    (pre(k) + prds(k))*cldmax(i,k))*deltat

!bug?  2/12/09
!!$     ttmp=t(i,k)+((D_eros_l(i,k)+cmel(i,k)+pre(k)*cldmax(i,k))*xxlv+ &
!!$                (D_eros_i(i,k)+cmei(i,k)+prds(k))*cldmax(i,k)*xxls)*deltat/cpp

                 ttmp = t(i,k) + ((D_eros_l(i,k) + cmel(i,k) +   &
                                               pre(k)*cldmax(i,k))*xxlv + &
                        (D_eros_i(i,k) + cmei(i,k) + qvdep_qi(i,k) + &
                                     prds(k)*cldmax(i,k))*xxls)*deltat/cpp
                 ttmp = MAX(lowest_temp_for_sublimation,   &
                                                    min(ttmp, 323._mg_pr))
                 eslt = polysvp_l(ttmp)
                 esit = polysvp_i(ttmp)
                 esn = eslt
    
                 qsn = min (epsqs*esn/  &
                           (pfull(i,k) - (1._mg_pr - epsqs)*esn), 1._mg_pr)
                 qsn = max(qsn, 0._mg_pr)
      
! modify precip evaporation rate if q > qsat
                 if (qtmp .gt. qsn ) then
                   if (pre(k) + prds(k) .lt. -1.e-20_mg_pr) then
                     dum1 = pre(k)/(pre(k) + prds(k))

! recalculate q and t after cloud water cond but without precip evap
                     qtmp = q(i,k) - (D_eros_l(i,k) + D_eros_i(i,k) +  &
                             cmel(i,k) + cmei(i,k) + qvdep_qi(i,k))*deltat

!bug 2/12/09
!!$     ttmp=t(i,k)+(D_eros_l(i,k)+cmel(i,k)*xxlv+ &
!!$                D_eros_i(i,k)+cmei(i,k)*xxls)*deltat/cpp

                     ttmp = t(i,k) + ((D_eros_l(i,k) + cmel(i,k))*xxlv +&
                             (D_eros_i(i,k) + cmei(i,k) + qvdep_qi(i,k))*&
                                                           xxls)*deltat/cpp
                     eslt = polysvp_l(ttmp)
                     esit = polysvp_i(ttmp)
                     esn = eslt
            
                     qsn = min( epsqs*esn/   &
                           (pfull(i,k) - (1._mg_pr - epsqs)*esn), 1._mg_pr)
                     qsn=max(qsn, 0._mg_pr)
                     dum = (qtmp - qsn)/   &
                                  (1._mg_pr + xxlv**2*qsn/(cpp*rv*ttmp**2))
                     dum = min(dum, 0._mg_pr)

! modify rates if needed, divide by cldmax to get local (in-precip) value
                     pre(k) = dum*dum1/deltat/cldmax(i,k)
                     qsn = min( epsqs*esit/    &
                                (pfull(i,k) - (1._mg_pr - epsqs)*esit),  &
                                                                  1._mg_pr)
                     dum = (qtmp - qsn)/(1._mg_pr + xxls**2*qsn/   &
                                                         (cpp*rv*ttmp**2)) 
                     dum = min(dum, 0._mg_pr)
                     prds(k) = dum*(1._mg_pr - dum1)/deltat/cldmax(i,k)
                   end if
                 end if
               end if

               IF (.NOT. one_ice) THEN

! bergeron process - evaporation of droplets and deposition onto snow
! bergeron process for snow is neglected for now.............
                 if (do_berg_snow ) then
                   if (qniic(i,k) .ge. qsmall .and.     &
                                qcic(i,k) .ge. qsmall .and.     &
                                        t(i,k) .lt. tfreeze) then
                     qvs = 0.622_mg_pr*esl(i,k)/    &
                                          (pfull(i,k) - d378*esl(i,k))
                     qvi = 0.622_mg_pr*esi(i,k)/   &
                                          (pfull(i,k) - d378*esi(i,k))

!8/1/12: place limits to avoid negative values which may occur at low pfull
!        prevents model blowups
                     qvs = MAX(0._mg_pr, MIN(qvs, 1.0_mg_pr))
                     qvi = MAX(0._mg_pr, MIN(qvi, 1.0_mg_pr))
                     dqsidt = xxls*qvi/(rv*t(i,k)**2)
                     abi(i,k) = 1._mg_pr + dqsidt*xxls/cpp
                     epss = 2._mg_pr*pi*n0s(k)*rho(i,k)*Dv(i,k)* &
                            (f1s/(lams(k)*lams(k)) + &
                              f2s*(asn(i,k)*rho(i,k)/mu(i,k))**0.5_mg_pr* &
                                sc(i,k)**(1._mg_pr/3._mg_pr)*    &
                               gamma_mg(5._mg_pr/2._mg_pr + bs/2._mg_pr)/ &
                             (lams(k)**(5._mg_pr/2._mg_pr + bs/2._mg_pr)))
!cms 2009/3/2        bergs(k) = epss*(qvs - qvi)/abi(i,k)
                     bergs(k) = epss*(qvs - qvi)/abi(i,k)
                   else
                     bergs(k) = 0._mg_pr
                   end if
                 else
                   bergs(k) = 0._mg_pr
                 endif
               ELSE
                 bergs(k) = 0._mg_pr
               END IF

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! conservation to ensure no negative values of cloud water/precipitation
! in case microphysical process rates are large

! make sure and use end-of-time step values for cloud water, ice, due
! condensation/deposition

! note: for check on conservation, processes are multiplied by omsm
! to prevent problems due to round off error

! since activation/nucleation processes are fast, need to take into account
! factor mtime = mixing timescale in cloud / model time step
! mixing time can be interpreted as cloud depth divided by sub-grid 
! vertical velocity
! for now mixing timescale is assumed to be 20 min
! could possibly be estimated better from model variables

               IF (total_activation) THEN 
! since act. is assumed to take place at cloud base:
!cms             mtime = deltat/1200._mg_pr
                 mtime = 1._mg_pr
               ELSE IF (dqa_activation) THEN 
! since Yi's formulation assumes activation at lateral cloud boundaries
                 mtime=1._mg_pr
               ENDIF

               qce = (qc(i,k) + (D_eros_l(i,k) + cmel(i,k) -    &
                                                        berg(i,k))*deltat)
               nce = (nc(i,k) + npccn(k)*deltat*mtime)/cldm(i,k)
               qie = (qi(i,k) + (D_eros_i(i,k) + cmei(i,k) +   &
                                        berg(i,k) + qvdep_qi(i,k))*deltat)
               nie = (ni(i,k) + nnuccd(k)*deltat*mtime)/cldm(i,k)

! conservation of qc
               dum = (prc(k) + pra(k) + mnuccc(k) + &
                       psacws(k) + bergs(k) + psacws_o(k))*cldm(i,k)*deltat
               if (dum .gt. qce) then
                 if (dum .gt. 1.e-30_mg_pr) then
                   ratio = qce/deltat/cldm(i,k)/(prc(k) + pra(k) +    &
                                   mnuccc(k) + psacws(k) + psacws_o(k) +  &
                                                            bergs(k))*omsm
                 else 
                   ratio = 0._mg_pr
                 endif
                 prc(k) = prc(k)*ratio
                 pra(k) = pra(k)*ratio
                 mnuccc(k) = mnuccc(k)*ratio
                 psacws(k) = psacws(k)*ratio
                 psacws_o(k) = psacws_o(k)*ratio
                 bergs(k) = bergs(k)*ratio
               end if

! conservation of nc
               dum = (nprc1(k) + npra(k) + nnuccc(k) + &
                      npsacws(k) + npsacws_o(k) - nsubc(k) -   &
                                                     nerosc(i,k))*deltat
               if (dum .gt. nce) then
                 if (dum .gt. 1.e-30_mg_pr) then
                   ratio = nce/deltat/(nprc1(k) + npra(k) + nnuccc(k) + &
                            npsacws(k) + npsacws_o(k) - nsubc(k) -   &
                                                        nerosc(i,k))*omsm
                 else
                   ratio = 0._mg_pr
                 end if
                 nprc1(k) = nprc1(k)*ratio
                 npra(k) = npra(k)*ratio
                 nnuccc(k) = nnuccc(k)*ratio
                 npsacws(k) = npsacws(k)*ratio
                 npsacws_o(k) = npsacws_o(k)*ratio
                 nsubc(k) = nsubc(k)*ratio
                 nerosc(i,k) =  nerosc(i,k)*ratio
               end if

! conservation of qi
               dum = (-mnuccc(k) + prci(k) + &
                        prai(k) - psacws_o(k))*cldm(i,k)*deltat
               if (dum .gt. qie) then
                 if (dum .gt. 1.e-30_mg_pr) then
                   ratio = (qie/deltat/cldm(i,k) + mnuccc(k) +    &
                                psacws_o(k))/(prci(k) + prai(k))*omsm
                 else
                   ratio = 0._mg_pr
                 end if
                 prci(k) = prci(k)*ratio
                 prai(k) = prai(k)*ratio
                 psacws_o(k) = psacws_o(k)*ratio
               end if

! conservation of ni
               dum = (nprci(k) + &
                        nprai(k) - nsubi(k) - nerosi(i,k))*deltat
               if (dum .gt. nie) then
                 if (dum .gt. 1.e-30_mg_pr) then
                   ratio = (nie/deltat)/(nprci(k) + nprai(k)    &
                                           - nsubi(k) - nerosi(i,k))*omsm
                 else
                   ratio = 0._mg_pr
                 end if
                 nprci(k) = nprci(k)*ratio
                 nprai(k) = nprai(k)*ratio
                 nsubi(k) = nsubi(k)*ratio
                 nerosi(i,k) = nerosi(i,k)*ratio
               end if

! for preciptiation conservation, use logic that vertical integral 
! of tendency from current level to top of model (i.e., qrtot) cannot 
! be negative

! conservation of rain mixing rat

               if (((prc(k) + pra(k))*cldm(i,k) +     &
                      (-mnuccr(k) + pre(k) - pracs(k))*cldmax(i,k))*  &
                             rho(i,k)*dz(i,k) + qrtot .lt. 0._mg_pr) then
                 if (-pre(k) + pracs(k) + mnuccr(k) .ge. qsmall) then
                   ratio = (qrtot/(rho(i,k)*dz(i,k)) + (prc(k) +   &
                                                   pra(k))*cldm(i,k))/&
                                    ((-pre(k) + pracs(k) + mnuccr(k))*   &
                                                        cldmax(i,k))*omsm 
                 else 
                   ratio = 0._mg_pr
                 end if
                 pre(k) = pre(k)*ratio
                 pracs(k) = pracs(k)*ratio
                 mnuccr(k) = mnuccr(k)*ratio
               end if

! conservation of nr
! for now neglect evaporation of nr

               IF (rain_evap_opt) THEN

! calculate evaporation of nr
                 if (pre(k) .lt. 0._mg_pr .and.      &
                                       qric(i,k) .ge. qsmall) then
                   nsubr(k) = pre(k)/qric(i,k)*nric(i,k)
                 else
                   nsubr(k) = 0._mg_pr
                 end if
               ELSE
                 nsubr(k)=0._mg_pr
               END IF

               if ((nprc(k)*cldm(i,k) + (-nnuccr(k) + nsubr(k) -    &
                      npracs(k) + nragg(k))*cldmax(i,k))*rho(i,k)*    &
                                     dz(i,k) + nrtot .lt. 0._mg_pr) then
                 if (-nsubr(k) - nragg(k) + npracs(k) +     &
                                              nnuccr(k) .ge. qsmall) then
                   ratio = (nrtot/(rho(i,k)*dz(i,k)) +     &
                                                nprc(k)*cldm(i,k))/   &
                             ((-nsubr(k) - nragg(k) + npracs(k) +   &
                                              nnuccr(k))*cldmax(i,k))*omsm
                 else 
                   ratio = 0._mg_pr
                 end if
                 nsubr(k) = nsubr(k)*ratio
                 npracs(k) = npracs(k)*ratio
                 nnuccr(k) = nnuccr(k)*ratio
                 nragg(k) = nragg(k)*ratio
               end if

! conservation of snow mix ratio
               if (((bergs(k) + psacws(k) + prai(k) +     &
                                                  prci(k))*cldm(i,k) +    &
                         (pracs(k) + mnuccr(k) + prds(k))*cldmax(i,k))*   &
                             rho(i,k)*dz(i,k) + qstot .lt. 0._mg_pr) then
                 if (-prds(k) .ge. qsmall) then
                   ratio = (qstot/(rho(i,k)*dz(i,k)) + (bergs(k) +   &
                             psacws(k) + prai(k) + prci(k))*cldm(i,k) +  &
                             (pracs(k) + mnuccr(k))*cldmax(i,k))/   &
                                            (-prds(k)*cldmax(i,k))*omsm
                 else
                   ratio =0._mg_pr
                 end if
                 prds(k) = prds(k)*ratio
               end if

! conservation of ns


! calculate loss of number due to sublimation
               IF (subl_snow) THEN
                 if (prds(k) .lt. 0._mg_pr .and.     &
                                             qniic(i,k) .ge. qsmall) then
                   nsubs(k) = prds(k)/qniic(i,k)*nsic(i,k)
                 else
                   nsubs(k) = 0._mg_pr
                 end if

! neglect sublimation of ns
               ELSE
                 nsubs(k) = 0._mg_pr
               END IF 

               if ((nprci(k)*cldm(i,k) + (nnuccr(k) + nsubs(k) +   &
                                                nsagg(k))*cldmax(i,k))*&
                            rho (i,k)*dz(i,k) + nstot .lt. 0._mg_pr) then
                 if (-nsubs(k) - nsagg(k) .ge. qsmall) then
                   ratio = (nstot/(rho(i,k)*dz(i,k)) + nprci(k)*   &
                                                           cldm(i,k) +   &
                                           nnuccr(k)*cldmax(i,k))/    &
                                 ((-nsubs(k) - nsagg(k))*cldmax(i,k))*omsm
                 else 
                   ratio =0._mg_pr
                 end if
                 nsubs(k) = nsubs(k)*ratio
                 nsagg(k) = nsagg(k)*ratio
               end if

! get tendencies due to microphysical conversion processes
! note: tendencies are multiplied by appropaiate cloud/precip 
! fraction to get grid-scale values
! note: cmei,cmel are already grid-average values

               qvlat(i,k) = qvlat(i,k) - &
                             (pre(k) + prds(k))*cldmax(i,k) - cmel(i,k) - &
                              cmei(i,k) - D_eros_l(i,k) - D_eros_i(i,k) - &
                                                             qvdep_qi(i,k)
               tlat(i,k) = tlat(i,k) + ((pre(k)*cldmax(i,k) +    &
                            cmel(i,k) + D_eros_l(i,k))*xxlv +   &
                            (prds(k)*cldmax(i,k) + cmei(i,k) +    &
                             D_eros_i(i,k) + qvdep_qi(i,k))*xxls +    &
                            ((bergs(k) + psacws(k) + psacws_o(k) +   &
                                mnuccc(k))*cldm(i,k) + (mnuccr(k) + &
                                  pracs(k))*cldmax(i,k) + berg(i,k))*xlf)
               qctend(i,k) = qctend(i,k) + &
                              (-pra(k) - prc(k) - mnuccc(k) -    &
                               psacws(k) - psacws_o(k) - bergs(k))*   &
                                                          cldm(i,k) +    &
                              cmel(i,k) - berg(i,k) + D_eros_l(i,k)
               qitend(i,k) = qitend(i,k) +       &
                              (mnuccc(k) - prci(k) - prai(k) +    &
                              psacws_o(k))*cldm(i,k) + cmei(i,k) +   &
                                 berg(i,k) + D_eros_i(i,k) + qvdep_qi(i,k)
               qrtend(i,k) = qrtend(i,k) + &
                              (pra(k) + prc(k))*cldm(i,k) + (pre(k) -   &
                                         pracs(k) - mnuccr(k))*cldmax(i,k)
               qnitend(i,k) = qnitend(i,k) + &
                               (prai(k) + psacws(k) + prci(k) +    &
                                          bergs(k))*cldm(i,k) +    &
                                       (prds(k) + pracs(k) + mnuccr(k))*  &
                                                                cldmax(i,k)

! multiply activation/nucleation by mtime to account for fast timescale

               dumd = nctend(i,k) 
               nctend(i,k) = nctend(i,k) + npccn(k)*mtime +   &
                             (-nnuccc(k) - npsacws(k) - npsacws_o(k) +  &
                                 nsubc(k) + nerosc(i,k) - npra(k) -   &
                                                        nprc1(k))*cldm(i,k)
               nitend(i,k) = nitend(i,k) + nnuccd(k)*mtime +    &
                              (nsubi(k) + nerosi(i,k) - nprci(k) - &
                                                       nprai(k))*cldm(i,k)
               nstend(i,k) = nstend(i,k) + (nsubs(k) +       &
                              nsagg(k) + nnuccr(k))*cldmax(i,k) +  &
                                                        nprci(k)*cldm(i,k)
               nrtend(i,k) = nrtend(i,k) +       &
                              nprc(k)*cldm(i,k) + (nsubr(k) - npracs(k) - &
                                        nnuccr(k) + nragg(k))*cldmax(i,k)

! make sure that nc and ni at advanced time step do not exceed
! maximum (existing N + source terms*dt), which is possible due to
! fast nucleation timescale

! diag++
               IF (diag_id%qndt_nucclim +     &
                                     diag_id%qn_nucclim_col  > 0) THEN
                 nucclim(k) = nctend(i,k)
               END IF
               IF (diag_id%qnidt_nucclim1 +    &
                               diag_id%qni_nucclim1_col > 0 ) THEN
                 nucclim1i(k) = nitend(i,k)
               END IF
! diag--
    
               if (nctend(i,k) .gt. 0._mg_pr .and.    &
                       nc(i,k) + nctend(i,k)*deltat .gt. ncmax) then
                 nctend(i,k) = max(0._mg_pr, (ncmax - nc(i,k))/deltat)
               end if
               if (nitend(i,k) .gt. 0._mg_pr .and.    &
                       ni(i,k) + nitend(i,k)*deltat .gt. nimax) then
                 nitend(i,k) = max(0._mg_pr, (nimax - ni(i,k))/deltat)
               end if

! diag++
               IF (diag_id%qndt_nucclim +     &
                                    diag_id%qn_nucclim_col  > 0) THEN
                 nucclim(k) = nctend(i,k) - nucclim(k)
               END IF
               IF (diag_id%qnidt_nucclim1 +   &
                                diag_id%qni_nucclim1_col > 0) THEN
                 nucclim1i(k) = nitend(i,k) - nucclim1i(k)
               END IF
! diag--

! cms 2009-2-26 also limit volume mean ice radius (optionally)
               IF (limit_volri) THEN 

                 IF (diag_id%qnidt_nucclim2 +    &
                             diag_id%qni_nucclim2_col > 0) THEN
                   nucclim2(k) = nitend(i,k)
                 END IF

                 qii_new = (qi(i,k) + qitend(i,k)*deltat)/cldm(i,k)
                 nii_new = (ni(i,k) + nitend(i,k)*deltat)/cldm(i,k)

!max XXX micron 
                 nii_min = qii_new/rhoi*3._mg_pr/(4._mg_pr*3.14_mg_pr*  &
                                                            max_diam_ii**3)
!min XXX micron
                 nii_max = qii_new/rhoi*3._mg_pr/(4._mg_pr*3.14_mg_pr*  &
                                                            min_diam_ii**3)
                 if ( nii_new .gt. nii_max) then
                   nitend(i,k) = (nii_max - ni(i,k)/cldm(i,k))/deltat*   &
                                                                 cldm(i,k)
                 else if (nii_new .lt. nii_min) then
                   nitend(i,k) = (nii_min - ni(i,k)/cldm(i,k))/deltat*   &
                                                                  cldm(i,k)
                 end if
                 IF (diag_id%qnidt_nucclim2 +     &
                                    diag_id%qni_nucclim2_col > 0) THEN
                   nucclim2(k) = nitend(i,k) - nucclim2(k)
                 END IF
               ELSE
                   nucclim2(k) = 0.
               END IF

! get final values for precipitation q and N, based on
! flux of precip from above, source/sink term, and terminal fallspeed
! see eq. 15-16 in Morrison and Gettelman, 2007, J. Climate

! rain
               if (qric(i,k) .ge. qsmall) then
                 if (k .eq. 1) then
                   qric(i,k) = qrtend(i,k)*dz(i,k)/cldmax(i,k)/umr(k)
                   nric(i,k) = nrtend(i,k)*dz(i,k)/cldmax(i,k)/unr(k)
                 else
                   qric(i,k) = (rho(i,k-1)*umr(k-1)*qric(i,k-1)*   &
                                    cldmax(i,k-1) + (rho(i,k)*dz(i,k)*  &
                                             qrtend(i,k)))/(umr(k)*  &
                                                     rho(i,k)*cldmax(i,k))
                   nric(i,k) = (rho(i,k-1)*unr(k-1)*nric(i,k-1)*    &
                                     cldmax(i,k-1) + (rho(i,k)*dz(i,k)*  &
                                             nrtend(i,k)))/(unr(k)*    &
                                                     rho(i,k)*cldmax(i,k))
                 end if
               else
                 qric(i,k) = 0._mg_pr
                 nric(i,k) = 0._mg_pr
               end if

! snow

               if (qniic(i,k) .ge. qsmall) then
                 if (k .eq. 1) then
                   qniic(i,k) = qnitend(i,k)*dz(i,k)/cldmax(i,k)/ums(k)
                   nsic(i,k) = nstend(i,k)*dz(i,k)/cldmax(i,k)/uns(k)
                 else
                   qniic(i,k) = (rho(i,k-1)*ums(k-1)*qniic(i,k-1)*   &
                                     cldmax(i,k-1) + (rho(i,k)*dz(i,k)*  &
                                          qnitend(i,k)))/(ums(k)*   &
                                                    rho(i,k)*cldmax(i,k))
                   nsic(i,k) = (rho(i,k-1)*uns(k-1)*nsic(i,k-1)*    &
                                      cldmax(i,k-1) + (rho(i,k)*dz(i,k)*  &
                                          nstend(i,k)))/(uns(k)*   &
                                                     rho(i,k)*cldmax(i,k))
                 end if
               else
                 qniic(i,k) = 0._mg_pr
                 nsic(i,k) = 0._mg_pr
               end if

! calculate precipitation flux at surface
! divide by density of water to get units of m/s

               prect(i) = prect(i) + (qrtend(i,k)*rho (i,k)*dz(i,k) +  &
                                 qnitend(i,k)*rho(i,k)*dz(i,k))/rhow
               preci(i) = preci(i) + qnitend(i,k)*rho(i,k)*dz(i,k)/rhow

! hm, add 9/5/07
! convert rain rate from m/s to mm/hr
 
               rainrt(i,k) = qric(i,k)*rho(i,k)*umr(k)/     &
                                              rhow*3600._mg_pr*1000._mg_pr

! vertically-integrated precip source/sink terms (note: grid-averaged)

!              qrtot = max(qrtot + qrtend(i,k)*rho(i,k)*dz(i,k), 0._mg_pr)
!              qstot = max(qstot + qnitend(i,k)*rho(i,k)*dz(i,k),    &
!                                                               0._mg_pr)
!              nrtot = max(nrtot + nrtend(i,k)*rho(i,k)*dz(i,k), 0._mg_pr)
!              nstot = max(nstot + nstend(i,k)*rho(i,k)*dz(i,k), 0._mg_pr)
               qrtot = qrtot + qrtend(i,k)*rho(i,k)*dz(i,k)
               qstot = qstot + qnitend(i,k)*rho(i,k)*dz(i,k)
               nrtot = nrtot + nrtend(i,k)*rho(i,k)*dz(i,k)
               nstot = nstot + nstend(i,k)*rho(i,k)*dz(i,k)

! calculate melting and freezing of precip

! melt snow at +2 C
! NOTE RSH 11/22/11:
! NOTE THAT R-K only starts melting at 0 C -- called a bug to melt at +2 C 
!
               if (t(i,k) + tlat(i,k)/cpp*deltat >     &
                                                 tfreeze + 2._mg_pr) then
                 if (qstot > 0._mg_pr) then

! make sure melting snow doesn't reduce temperature below threshold
                   dum = -xlf/cpp*qstot/(rho(i,k)*dz(i,k))
                   if (t(i,k) + tlat(i,k)/cpp*deltat+dum .lt.    &
                                                 tfreeze + 2._mg_pr) then
                     dum = (t(i,k) + tlat(i,k)/cpp*deltat -   &
                                            (tfreeze + 2._mg_pr))*cpp/xlf
                     dum = dum/(xlf/cpp*qstot/(rho(i,k)*dz(i,k)))
                     dum = max(0._mg_pr, dum)
                     dum = min(1._mg_pr, dum)
                   else
                     dum = 1._mg_pr
                   end if
                   qric(i,k) = qric(i,k) + dum*qniic(i,k)
                   nric(i,k) = nric(i,k) + dum*nsic(i,k)
                   qniic(i,k) = (1._mg_pr - dum)*qniic(i,k)
                   nsic(i,k) = (1._mg_pr - dum)*nsic(i,k)
                   tlat(i,k) = tlat(i,k) - xlf*dum*qstot/    &
                                                       (rho(i,k)*dz(i,k))
                   qrtot = qrtot + dum*qstot
                   qstot = (1._mg_pr - dum)*qstot
                   nrtot = nrtot + dum*nstot
                   nstot = (1._mg_pr - dum)*nstot
                   if (diag_id%snow_melt + diag_id%snow_melt_col > 0) & 
                             diag_4d(i,j,k, diag_pt%snow_melt) =     &
                                    diag_4d(i,j,k, diag_pt%snow_melt) +  &
                                       dum*preci(i)*rhow/(rho(i,k)*dz(i,k))
                   preci(i) = (1._mg_pr - dum)*preci(i)

!cms++
! assume that droplets which would condense due to cooling associated 
! with melting of snow are rapidly collected by (newly formed) rain drops
! (this is optional, controlled by namelist, set to .false. in Marc's final
! parameterization)

                   IF (collect_frzreg) THEN
!only if there is net cooling
                     IF (tlat(i,k) .LT. 0._mg_pr) THEN 
                       ttmp = t(i,k) + tlat(i,k)/cpp*deltat
                       qtmp = q(i,k) + qvlat(i,k)*deltat
                       esn = polysvp_l(ttmp)
                       qvs = 0.622_mg_pr*esn/(pfull(i,k) - d378*esn)
                       dqsdt = xxlv*qvs/(rv*ttmp**2)
                       ab = 1._mg_pr + dqsdt*xxlv/cpp
                       tmp2 = pfull(i,k) - d378*esn
                       tmp2 = max(tmp2,esn)
                       tmp2 = d622*esn/tmp2
                       tmp1 = max(0._mg_pr, (qtmp - tmp2)/ab)
        
! change vapor content and T
                       qvlat(i,k) = qvlat(i,k) -tmp1/deltat 
                       snow2vapor(k) = -tmp1/deltat
                       tlat(i,k)  = tlat(i,k) + hlv*tmp1/deltat

! and rain mixing ratio
                       qric(i,k) = qric(i,k) + tmp1/cldmax(i,k)
                       qrtot = qrtot + tmp1/deltat*pdel(i,k)/grav
                       prect(i) = prect(i) + tmp1/deltat*pdel(i,k)/   &
                                                                grav/rhow 
                     END IF 
                   END IF 
                 end if
               end if

! freeze rain at -5 C
               if (t(i,k) + tlat(i,k)/cpp*deltat <      &
                                                 tfreeze - 5._mg_pr ) then
                 if (qrtot > 0._mg_pr) then

! make sure freezing rain doesn't increase temperature above threshold
                   dum = xlf/cpp*qrtot/(rho(i,k)*dz(i,k))
                   if (t(i,k) + tlat(i,k)/cpp*deltat + dum   &
                                            .gt. tfreeze -5._mg_pr ) then
                     dum = -(t(i,k) + tlat(i,k)/cpp*deltat -    &
                                             (tfreeze - 5._mg_pr) )*cpp/xlf
                     dum = dum/(xlf/cpp*qrtot/(rho(i,k)*dz(i,k)))
                     dum = max(0._mg_pr, dum)
                     dum = min(1._mg_pr, dum)
                   else
                     dum = 1._mg_pr
                   end if
                   qniic(i,k) = qniic(i,k) + dum*qric(i,k)
                   nsic(i,k) = nsic(i,k) + dum*nric(i,k)
                   qric(i,k) = (1._mg_pr - dum)*qric(i,k)
                   nric(i,k) = (1._mg_pr - dum)*nric(i,k)
                   tlat(i,k) = tlat(i,k) + xlf*dum*qrtot/   &
                                                       (rho(i,k)*dz(i,k))
                   qstot = qstot + dum*qrtot
                   qrtot = (1._mg_pr - dum)*qrtot
                   nstot = nstot + dum*nrtot
                   nrtot = (1._mg_pr - dum)*nrtot
                   diag_4d(i,j,k, diag_pt%rain_freeze) =  &
                           diag_4d(i,j,k, diag_pt%rain_freeze) +  &
                                          dum*(prect(i) - preci(i))* &
                                                    rhow/(rho(i,k)*dz(i,k))
                   preci(i) = preci(i) + dum* (prect(i) - preci(i))
                 end if
               end if

! if rain/snow mix ratio is zero so should number concentration
               if (qniic(i,k) .lt. qsmall) then
                 qniic(i,k) = 0._mg_pr
                 nsic(i,k) = 0._mg_pr
               end if
               if (qric(i,k) .lt. qsmall) then
                 qric(i,k) = 0._mg_pr
                 nric(i,k) = 0._mg_pr
               end if

! make sure number concentration is a positive number to avoid 
! taking root of negative
               nric(i,k) = max(nric(i,k), 0._mg_pr)
               nsic(i,k) = max(nsic(i,k), 0._mg_pr)

!.......................................................................
! get size distribution parameters for fallspeed calculations
!......................................................................
! rain
               if (qric(i,k) .ge. qsmall) then
                 lamr(k) = (pi*rhow*nric(i,k)/    &
                                          qric(i,k))**(1._mg_pr/3._mg_pr)
                 n0r(k) = nric(i,k)*lamr(k)

! check for slope
! hm 4/5/07, change lammax and lammin for rain and snow
                 lammax = 1._mg_pr/20.e-6_mg_pr
                 lammin = 1._mg_pr/500.e-6_mg_pr

! adjust vars
                 if (lamr(k) .lt. lammin) then
                   lamr(k) = lammin
                   n0r(k) = lamr(k)**4*qric(i,k)/(pi*rhow)
                   nric(i,k) = n0r(k)/lamr(k)
                 else if (lamr(k) .gt. lammax) then
                   lamr(k) = lammax
                   n0r(k) = lamr(k)**4*qric(i,k)/(pi*rhow)
                   nric(i,k) = n0r(k)/lamr(k)
                 end if

! 'final' values of number and mass weighted mean fallspeed for rain (m/s)
                 unr(k) = min(arn(i,k)*gamma_mg(1._mg_pr + br)/    &
                                          lamr(k)**br, 9.1_mg_pr*rhof(i,k))
                 umr(k) = min(arn(i,k)*gamma_mg(4._mg_pr+br)/    &
                               (6._mg_pr*lamr(k)**br), 9.1_mg_pr*rhof(i,k))
               else
                 lamr(k) = 0._mg_pr
                 n0r(k) = 0._mg_pr
                 umr(k) = 0._mg_pr
                 unr(k) = 0._mg_pr
               end if

!......................................................................
! snow
               if (qniic(i,k) .ge. qsmall) then
                 lams(k) = (gamma_mg(1._mg_pr + ds)*cs*nsic(i,k)/ &
                                            qniic(i,k))**(1._mg_pr/ds)
                 n0s(k) = nsic(i,k)*lams(k)

! check for slope
                 lammax = 1._mg_pr/min_diam_ice
                 lammin = 1._mg_pr/2000.e-6_mg_pr

! adjust vars
                 if (lams(k) .lt. lammin) then
                   lams(k) = lammin
                   n0s(k) = lams(k)**(ds + 1._mg_pr)*qniic(i,k)/   &
                                             (cs*gamma_mg(1._mg_pr + ds))
                   nsic(i,k) = n0s(k)/lams(k)
                 else if (lams(k).gt.lammax) then
                   lams(k) = lammax
                   n0s(k) = lams(k)**(ds + 1._mg_pr)*qniic(i,k)/    &
                                             (cs*gamma_mg(1._mg_pr + ds))
                   nsic(i,k) = n0s(k)/lams(k)
                 end if

! 'final' values of number and mass weighted mean fallspeed for snow (m/s)
                 ums(k) = min(asn(i,k)*gamma_mg(4._mg_pr + bs)/    &
                             (6._mg_pr*lams(k)**bs), max_vt_snow*rhof(i,k))
                 uns(k) = min(asn(i,k)*gamma_mg(1._mg_pr + bs)/     &
                                       lams(k)**bs, max_vt_snow*rhof(i,k))
               else
                 lams(k) = 0._mg_pr
                 n0s(k) = 0._mg_pr
                 ums(k) = 0._mg_pr
                 uns(k) = 0._mg_pr
               end if

! convert rain/snow q and N for output to history, note, 
! output is for gridbox average

               qrout(i,k) = qrout(i,k) + qric(i,k)*cldmax(i,k)
               qsout(i,k) = qsout(i,k) + qniic(i,k)*cldmax(i,k)
               nrout(i,k) = nrout(i,k) + nric(i,k)*rho(i,k)*cldmax(i,k)
               nsout(i,k) = nsout(i,k) + nsic(i,k)*rho(i,k)*cldmax(i,k)

!c........................................................................
! sum over sub-step for average process rates

               tlat1(i,k) = tlat1(i,k) + tlat(i,k)
               qvlat1(i,k) = qvlat1(i,k) + qvlat(i,k)
               qctend1(i,k) = qctend1(i,k) + qctend(i,k)
               qitend1(i,k) = qitend1(i,k) + qitend(i,k)
               nctend1(i,k) = nctend1(i,k) + nctend(i,k)
               nitend1(i,k) = nitend1(i,k) + nitend(i,k)

               t(i,k) = t(i,k) + tlat(i,k)*deltat/cpp
               q(i,k) = q(i,k) + qvlat(i,k)*deltat
               qc(i,k) = qc(i,k) + qctend(i,k)*deltat
               qi(i,k) = qi(i,k) + qitend(i,k)*deltat
               nc(i,k) = nc(i,k) + nctend(i,k)*deltat
               ni(i,k) = ni(i,k) + nitend(i,k)*deltat

! hm add 9/5/07
               rainrt1(i,k) = rainrt1(i,k) + rainrt(i,k)

!CODE MOVED TO HERE:
               if ( k > 1 ) then        
                 IF (.NOT. one_ice) THEN
                   asnowrt(i,k-1) = cldmax(i,k-1)*qniic(i,k-1)*   &
                                                      rho(i,k-1)*ums(k-1)
                   if (k == kdim) then
                     asnowrt(i,kdim) = cldmax(i,kdim)*qniic(i,kdim)*   &
                                                    rho(i,kdim)*ums(kdim)
                   endif
                 ELSE
                   asnowrt(i,k-1)= cldmax(i,k-1)*qiic(i,k-1)*   &
                                                      rho(i,k-1)*ums(k-1)
                   if (k == kdim) then
                     asnowrt(i,kdim) = cldmax(i,kdim)*qiic(i,kdim)*   &
                                                     rho(i,kdim)*ums(kdim)
                   endif
                 END IF
                 atotrt(i,k-1) =  asnowrt(i,k-1) + cldmax(i,k-1)*  &
                                           qric(i,k-1)*rho(i,k-1)*umr(k-1)
                 if (k == kdim) then
                   atotrt(i,kdim) =  asnowrt(i,kdim) + cldmax(i,kdim)*  &
                                         qric(i,kdim)*rho(i,kdim)*umr(kdim)
                 endif
                 atotrt1(i,k-1) = atotrt1(i,k-1) + atotrt(i,k-1)
                 asnowrt1(i,k-1) = asnowrt1(i,k-1) + asnowrt(i,k-1)   
               end if
!END OF MOVED CODE

               if (k == kdim) then
                 atotrt1(i,k) = atotrt1(i,k) + atotrt(i,k)
                 asnowrt1(i,k) = asnowrt1(i,k) + asnowrt(i,k)   
               endif

               pre1(i,k)  = pre1(i,k) - pre(k)*cldmax(i,k)
               prds1(i,k) = prds1(i,k) - prds(k)*cldmax(i,k)
               snow2vapor1(i,k) = snow2vapor1(i,k) + snow2vapor(k)
               cmel1(i,k) = cmel1(i,k) + cmel(i,k)
               D_eros_l1(i,k) = D_eros_l1(i,k) + D_eros_l(i,k)
               berg1(i,k) = berg1(i,k) + berg(i,k)
               qvdep_qi1(i,k) = qvdep_qi1(i,k) + qvdep_qi(i,k)
               prc1(i,k) = prc1(i,k) - prc(k)*cldm(i,k)

               pra1(i,k) = pra1(i,k) - pra(k)*cldm(i,k)
               mnuccc1(i,k) = mnuccc1(i,k) - mnuccc(k)*cldm(i,k)

               psacws1(i,k) = psacws1(i,k) -    &
                                        (psacws(k) + psacws_o(k))*cldm(i,k)
               psacws_o1(i,k) =  psacws_o1(i,k) - psacws_o(k)*cldm(i,k)
               bergs1(i,k) = bergs1(i,k) - bergs(k)*cldm(i,k)
   
               cmei1(i,k) = cmei1(i,k) + cmei(i,k)
               D_eros_i1(i,k) = D_eros_i1(i,k) + D_eros_i(i,k)
               prci1(i,k) = prci1(i,k) - prci(k)*cldm(i,k)
               prai1(i,k) = prai1(i,k) - prai(k)*cldm(i,k)

!droplet number
               npccn1(i,k) = npccn1(i,k) + npccn(k)*mtime
               nnuccc1(i,k) = nnuccc1(i,k) - nnuccc(k)*cldm(i,k)
               npsacws1(i,k) = npsacws1(i,k) - npsacws(k)*cldm(i,k)
               npsacws_o1(i,k) = npsacws_o1(i,k) - npsacws_o(k)*cldm(i,k)
               nsubc1(i,k) = nsubc1(i,k) + nsubc(k)*cldm(i,k)
               nerosc1(i,k) = nerosc1(i,k) + nerosc(i,k)*cldm(i,k)
               npra1(i,k) = npra1(i,k) - npra(k)*cldm(i,k)
               nprc11(i,k) = nprc11(i,k) - nprc1(k)*cldm(i,k)
               nucclim1(i,k) = nucclim1(i,k) + nucclim(k)

!ice number
               nnuccd1(i,k) = nnuccd1(i,k) + nnuccd(k)*mtime
               nsubi1(i,k) = nsubi1(i,k) + nsubi(k)*cldm(i,k)
               nerosi1(i,k) = nerosi1(i,k) + nerosi(i,k)*cldm(i,k)
               nprci1(i,k) = nprci1(i,k) -  nprci(k)*cldm(i,k)
               nprai1(i,k) = nprai1(i,k) - nprai(k)*cldm(i,k)
               nucclim1_1(i,k) = nucclim1_1(i,k) + nucclim1i(k)
               nucclim2_1(i,k) = nucclim2_1(i,k) + nucclim2(k)

               pracs1(i,k) = pracs1(i,k) - pracs(k)*cldmax(i,k)
               mnuccr1(i,k) = mnuccr1(i,k) - mnuccr(k)*cldmax(i,k)
             end do   !  k-loop (do k=1,kdim; starts ~ 1800 lines above)

             prect1(i) = prect1(i) + prect(i)
             preci1(i) = preci1(i) + preci(i)
           end do ! it loop  (do it=1,iter) (sub-step loop)
300        continue  ! skip to end of loop if  no cloud water
         end do  ! i loop (do i=1,idim)

! convert dt from sub-step back to full time step
         deltat=deltat*real(iter)

!c........................................................................

!ADD HERE 6/6/12
         ssat_disposal(:,:) = 0._mg_pr

         do i=1,idim

! skip all calculations if no cloud water
           if (ltrue(i) .eq. 0) then
             if (diag_id%vfall > 0)     &
                               diag_4d(i,j,:,diag_pt%vfall) = 0.0_mg_pr   
             goto 500
           endif
  
! initialize nstep for sedimentation sub-steps
           nstep = 1

! divide precip rate by number of sub-steps to get average over time step
           prect(i) = prect1(i)/real(iter)
           preci(i) = preci1(i)/real(iter)

           diag_4d(i,j,:, diag_pt%snow_melt) =  &
                         diag_4d(i,j,:, diag_pt%snow_melt)/real(iter)
           diag_4d(i,j,:, diag_pt%rain_freeze) =  &
                        diag_4d(i,j,:, diag_pt%rain_freeze)/real(iter)
           do k=1,kdim
             umi(k) = 0._mg_pr 
           end do
 
           do k=1,kdim  

! assign variables back to start-of-timestep values before updating 
! after sub-steps 
             t(i,k) = t1(i,k)
             q(i,k) = q1(i,k)
             qc(i,k) = qc1(i,k)
             qi(i,k) = qi1(i,k)
             nc(i,k) = nc1(i,k)
             ni(i,k) = ni1(i,k)

! divide microphysical tendencies by number of sub-steps to get average 
! over time step
             tlat(i,k) = tlat1(i,k)/real(iter)
             qvlat(i,k) = qvlat1(i,k)/real(iter)
             qctend(i,k) = qctend1(i,k)/real(iter)
             qitend(i,k) = qitend1(i,k)/real(iter)
             nctend(i,k) = nctend1(i,k)/real(iter)
             nitend(i,k) = nitend1(i,k)/real(iter)
   
! hm, add 9/5/07
             rainrt(i,k) = rainrt1(i,k)/real(iter)

             atotrt(i,k) = atotrt1(i,k)/real(iter)
             asnowrt(i,k) = asnowrt1(i,k)/real(iter)

! divide output precip q and N by number of sub-steps to get average 
! over time step
             qrout(i,k) = qrout(i,k)/real(iter)
             qsout(i,k) = qsout(i,k)/real(iter)
             nrout(i,k) = nrout(i,k)/real(iter)
             nsout(i,k) = nsout(i,k)/real(iter)

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! calculate sedimentation for cloud water and ice
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

! update in-cloud cloud mixing ratio and number concentration 
! with microphsical tendencies to calculate sedimentation, assign 
! to dummy vars
! note: these are in-cloud values***, hence we divide by cloud fraction

             dumc(i,k) = (qc(i,k) + qctend(i,k)*deltat)/cldm(i,k)
             dumi(i,k) = (qi(i,k) + qitend(i,k)*deltat)/cldm(i,k)
             dumnc(i,k) = max((nc(i,k) + nctend(i,k)*deltat)/cldm(i,k), &
                                                                 0._mg_pr)
             dumni(i,k) = max((ni(i,k) + nitend(i,k)*deltat)/cldm(i,k),  &
                                                                 0._mg_pr)

! obtain new slope parameter to avoid possible singularity
             if (dumi(i,k) .ge. qsmall) then

! add upper limit to in-cloud number concentration to prevent 
! numerical error
               dumni(i,k) = min(dumni(i,k), dumi(i,k)*1.e20_mg_pr)

               lami(k) = (gamma_mg(1._mg_pr + di_mg)*ci_mg* &
                                 dumni(i,k)/dumi(i,k))**(1._mg_pr/di_mg)
               lammax = 1._mg_pr/min_diam_ice
               lammin = 1._mg_pr/(2._mg_pr*dcs)
               lami(k) = max(lami(k), lammin)
               lami(k) = min(lami(k), lammax)
             else
               lami(k) = 0._mg_pr
             end if

             if (dumc(i,k) .ge. qsmall) then

! add upper limit to in-cloud number concentration to prevent 
! numerical error
               dumnc(i,k) = min(dumnc(i,k), dumc(i,k)*1.e20_mg_pr)

!RSH BUGFIX email of 6/8/10
!              pgam(k)=0.0005714_mg_pr*(dumnc(i,k)/1.e6_mg_pr/rho(i,k))+  &
!                                                              0.2714_mg_pr
               pgam(k) = 0.0005714_mg_pr*(dumnc(i,k)/1.e6_mg_pr*   &
                                                   rho(i,k))+0.2714_mg_pr
               pgam(k) = 1._mg_pr/(pgam(k)**2) - 1._mg_pr
               pgam(k) = max(pgam(k), 2._mg_pr)
               pgam(k) = min(pgam(k), 15._mg_pr)

               lamc(k) = (pi/6._mg_pr*rhow*dumnc(i,k)*    &
                                         gamma_mg(pgam(k) + 4._mg_pr)/ &
                                                          (dumc(i,k)*    &
                        gamma_mg(pgam(k) + 1._mg_pr)))**(1._mg_pr/3._mg_pr)
               lammin = (pgam(k) + 1._mg_pr)/max_diam_drop
               lammax = (pgam(k) + 1._mg_pr)/min_diam_drop
               lamc(k) = max(lamc(k), lammin)
               lamc(k) = min(lamc(k), lammax)
             else
               lamc(k) = 0._mg_pr
             end if

! calculate number and mass weighted fall velocity for droplets
! include effects of sub-grid distribution of cloud water
             if (dumc(i,k) .ge. qsmall) then

!RSH bugfix email 6/8/10
!              unc= sfac5 * &
               unc =         &
                     acn(i,k)*gamma_mg(1._mg_pr + bc+pgam(k))/ &
                               (lamc(k)**bc*gamma_mg(pgam(k) + 1._mg_pr))
!RSH bugfix email 6/8/10
!              umc =   sfac5 * &
               umc =           &
                          acn(i,k)*gamma_mg(4._mg_pr + bc+pgam(k))/ &
                               (lamc(k)**bc*gamma_mg(pgam(k) + 4._mg_pr))
             else
               umc = 0._mg_pr
               unc = 0._mg_pr
             end if

! calculate number and mass weighted fall velocity for cloud ice
             if (dumi(i,k) .ge. qsmall) then
               IF (.NOT. one_ice) THEN
                 uni = ain(i,k)*gamma_mg(1._mg_pr + bi)/lami(k)**bi
                 umi(k) = ain(i,k)*gamma_mg(4._mg_pr + bi)/    &
                                                   (6._mg_pr*lami(k)**bi)
               ELSE
                 umi(k) = min(asn(i,k)*gamma_mg(4._mg_pr + bs)/   &
                                       (6._mg_pr*lami(k)**bs), max_vt_ice)
                 uni = min(asn(i,k)*gamma_mg(1._mg_pr + bs)/   &
                                                   lami(k)**bs, max_vt_ice)
               END IF
               uni = vfact_n*uni
               umi(k) = vfact_m*umi(k)
               uni = min(uni, max_vt_ice*rhof(i,k))
               umi(k) = min(umi(k), max_vt_ice*rhof(i,k))

               IF (hd_sedi_sens) THEN
                 umi(k) = vfact*3.29_mg_pr*    &
                             ((rho(i,k)*qi(i,k)/cldm(i,k))**0.16_mg_pr)
                 uni = umi(k)
               END IF

               IF (scav_by_cloud_ice) THEN
                 if ( k > 1 ) then  
!RSH: if this activated, should deal with difference between rhoi and rhosn
!RSH  in this additional term in asnowrt :
                   asnowrt(i,k) = asnowrt(i,k) + cldmax(i,k-1)*    &
                                          qiic(i,k-1)*rho(i,k-1)*umi(k-1)
                 end if
               END IF
             else
               umi(k) = 0._mg_pr
               uni = 0._mg_pr
             end if

             if (diag_id%vfall > 0) diag_4d(i,j,k,diag_pt%vfall) = umi(k)

             fi(k) = grav*rho(i,k)*umi(k)
             fni(k) = grav*rho(i,k)*uni
             fc(k) = grav*rho(i,k)*umc
             fnc(k) = grav*rho(i,k)*unc

! calculate number of split time steps to ensure courant stability criteria
! for sedimentation calculations

             rgvm = max(fi(k), fc(k), fni(k), fnc(k))
             nstep = max(int(rgvm*deltat/pdel(i,k) + 1._mg_pr), nstep)

! redefine dummy variables - sedimentation is calculated over grid-scale
! quantities to ensure conservation
             dumc(i,k) = (qc(i,k) + qctend(i,k)*deltat)
             dumi(i,k) = (qi(i,k) + qitend (i,k)*deltat)
             dumnc(i,k) = max((nc(i,k) + nctend(i,k)*deltat), 0._mg_pr)
             dumni(i,k) = max((ni(i,k) + nitend(i,k)*deltat), 0._mg_pr)

             if (dumc(i,k) .lt. qsmall) dumnc(i,k) = 0._mg_pr
             if (dumi(i,k) .lt. qsmall) dumni(i,k) = 0._mg_pr
           end do       !!! vertical loop

           do n = 1,nstep  !! loop over sub-time step to ensure stability
             do k = 1,kdim
               falouti(k) = fi(k)*dumi(i,k)
               faloutni(k) = fni(k)*dumni(i,k)
               faloutc(k) = fc(k)*dumc(i,k)
               faloutnc(k) = fnc(k)*dumnc(i,k)
             end do

! top of model
             k = 1
             faltndi = falouti(k)/pdel(i,k)
             faltndni = faloutni(k)/pdel(i,k)
             faltndc = faloutc(k)/pdel(i,k)
             faltndnc = faloutnc(k)/pdel(i,k)

! add fallout terms to microphysical tendencies
             qitend(i,k) = qitend(i,k) - faltndi/nstep
             nitend(i,k) = nitend(i,k) - faltndni/nstep
             qctend(i,k) = qctend(i,k) - faltndc/nstep
             nctend(i,k) = nctend(i,k) - faltndnc/nstep
             IF (diag_id%qldt_sedi + diag_id%ql_sedi_col > 0) &
                    diag_4d(i,j,k,diag_pt%qldt_sedi) =    &
                          diag_4d(i,j,k,diag_pt%qldt_sedi) - faltndc/nstep
             IF (diag_id%sedi_ice > 0) &
                    diag_4d(i,j,1,diag_pt%sedi_ice) =    &
                                 diag_4d(i,j,1,diag_pt%sedi_ice) +       &
                                             falouti(kdim)/grav/nstep/rhoi
             IF (diag_id%qidt_fall + diag_id%qi_fall_col > 0) &
                    diag_4d(i,j,k,diag_pt%qidt_fall) =     &
                        diag_4d(i,j,k,diag_pt%qidt_fall) - faltndi/nstep
             IF (diag_id%qndt_sedi + diag_id%qn_sedi_col > 0) &
                    diag_4d(i,j,k,diag_pt%qndt_sedi) =    &
                        diag_4d(i,j,k,diag_pt%qndt_sedi) - faltndnc/nstep
             IF (diag_id%qnidt_sedi +  diag_id%qni_sedi_col > 0) &
                     diag_4d(i,j,k,diag_pt%qnidt_sedi) =    &
                       diag_4d(i,j,k,diag_pt%qnidt_sedi) - faltndni/nstep

             dumi(i,k) = dumi(i,k) - faltndi*deltat/nstep
             dumni(i,k) = dumni(i,k) - faltndni*deltat/nstep
             dumc(i,k) = dumc(i,k) - faltndc*deltat/nstep
             dumnc(i,k) = dumnc(i,k) - faltndnc*deltat/nstep

             do k = 2,kdim
 
! for cloud liquid and ice, if cloud fraction increases with height
! then add flux from above to both vapor and cloud water of current level
! this means that flux entering clear portion of cell from above evaporates
! instantly

               dum = cldm(i,k)/cldm(i,k-1)
               dum = min(dum, 1._mg_pr)

               faltndqie = (falouti(k) - falouti(k-1))/pdel(i,k)
               faltndi = (falouti(k) - dum*falouti(k-1))/pdel(i,k)
               faltndni = (faloutni(k) - dum*faloutni(k-1))/pdel(i,k)
               faltndqce = (faloutc(k) - faloutc(k-1))/pdel(i,k)
               faltndc = (faloutc(k) - dum*faloutc(k-1))/pdel(i,k)
               faltndnc = (faloutnc(k) - dum*faloutnc(k-1))/pdel(i,k)

! add fallout terms to eulerian tendencies
               qitend(i,k) = qitend(i,k) - faltndi/nstep
               nitend(i,k) = nitend(i,k) - faltndni/nstep
               qctend(i,k) = qctend(i,k)-  faltndc/nstep
               nctend(i,k) = nctend(i,k) - faltndnc/nstep

               IF (diag_id%qldt_sedi + diag_id%ql_sedi_col > 0) &
                       diag_4d(i,j,k,diag_pt%qldt_sedi) =    &
                         diag_4d(i,j,k,diag_pt%qldt_sedi) - faltndc/nstep
               IF (diag_id%qndt_sedi + diag_id%qn_sedi_col > 0) &
                       diag_4d(i,j,k,diag_pt%qndt_sedi) =    &
                         diag_4d(i,j,k,diag_pt%qndt_sedi) - faltndnc/nstep
               IF (diag_id%qnidt_sedi + diag_id%qni_sedi_col > 0) &
                       diag_4d(i,j,k,diag_pt%qnidt_sedi) =    &
                         diag_4d(i,j,k,diag_pt%qnidt_sedi) - faltndni/nstep

! add terms to to evap/sub of cloud water
               qvlat(i,k) = qvlat(i,k) - (faltndqie - faltndi)/nstep
               if (diag_id%qdt_sedi_ice2vapor > 0)  &
                      sedi_ice2vapor1(i,k)  = sedi_ice2vapor1(i,k) -  &
                                               (faltndqie - faltndi)/nstep
               qvlat(i,k) = qvlat(i,k) - (faltndqce - faltndc)/nstep
               if  (diag_id%qdt_sedi_liquid2vapor> 0)  &
                    sedi_liquid2vapor1(i,k)  = sedi_liquid2vapor1(i,k) -  &
                                              (faltndqce - faltndc)/nstep
               tlat(i,k) = tlat(i,k) + (faltndqie - faltndi)*xxls/nstep
               tlat(i,k) = tlat(i,k) + (faltndqce - faltndc)*xxlv/nstep

               dumi(i,k) = dumi(i,k) - faltndi*deltat/nstep
               dumni(i,k) = dumni(i,k) - faltndni*deltat/nstep
               dumc(i,k) = dumc(i,k) - faltndc*deltat/nstep
               dumnc(i,k) = dumnc(i,k) - faltndnc*deltat/nstep

               Fni(K) = MAX(Fni(K)/pdel(i,K), Fni(K-1)/pdel(i,K-1))*   &
                                                                 pdel(i,K)
               FI(K) = MAX(FI(K)/pdel(i,K), FI(K-1)/pdel(i,K-1))*pdel(i,K)
               fnc(k) = max(fnc(k)/pdel(i,k), fnc(k-1)/pdel(i,k-1))*   &
                                                                  pdel(i,k)
               Fc(K) = MAX(Fc(K)/pdel(i,K), Fc(K-1)/pdel(i,K-1))*pdel(i,K)

               IF (diag_id%qidt_fall + diag_id%qi_fall_col > 0) &
                      diag_4d(i,j,k,diag_pt%qidt_fall) =    &
                          diag_4d(i,j,k,diag_pt%qidt_fall) - faltndi/nstep
             end do   !! k loop

! units below are m/s
! cloud water/ice sedimentation flux at surface is added to precip flux 
! at surface to get total precip (cloud + precip water) rate
             prect(i) = prect(i) + (faloutc(kdim) + falouti(kdim)) &
                                                  /grav/nstep/1000._mg_pr
             preci(i) = preci(i) + (falouti(kdim))/grav/nstep/1000._mg_pr

             IF (diag_id%sedi_sfc > 0) &
                    diag_4d(i,j,1,diag_pt%sedi_sfc) =    &
                                  diag_4d(i,j,1,diag_pt%sedi_sfc)  +  & 
                                             faloutc(kdim)/grav/nstep/rhow
           end do   !! nstep loop

! end sedimentation

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! get new update for variables that includes sedimentation tendency
! note : here dum variables are grid-average, NOT in-cloud

           do k=1,kdim
             dumc(i,k) = max(qc(i,k) + qctend(i,k)*deltat, 0._mg_pr)
             dumi(i,k) = max(qi(i,k) + qitend(i,k)*deltat, 0._mg_pr)
             dumnc(i,k) = max(nc(i,k) + nctend(i,k)*deltat, 0._mg_pr)
             dumni(i,k) = max(ni(i,k) + nitend(i,k)*deltat, 0._mg_pr)

             if (dumc(i,k) .lt. qsmall) dumnc(i,k) = 0._mg_pr 
             if (dumi(i,k) .lt. qsmall) dumni(i,k) = 0._mg_pr

! calculate instantaneous processes (melting, homogeneous freezing)

             if (t(i,k) + tlat(i,k)/cpp*deltat > tfreeze) then
               if (dumi(i,k) > 0._mg_pr) then

! limit so that melting does not push temperature below freezing
                 dum = -dumi(i,k)*xlf/cpp
                 if (t(i,k) + tlat(i,k)/cpp*deltat + dum    &
                                                       .lt.  tfreeze) then
                   dum = (t(i,k) + tlat(i,k)/cpp*deltat-tfreeze)*cpp/xlf
                   dum = dum/dumi(i,k)*xlf/cpp 
                   dum = max(0._mg_pr, dum)
                   dum = min(1._mg_pr, dum)
                 else
                   dum = 1._mg_pr
                 end if

                 qctend(i,k) = qctend(i,k) + dum*dumi(i,k)/deltat

! hm add, 9/15/06, assume melting ice produces droplet
! mean volume radius of 8 micron

                 IF (diag_id%qndt_melt + diag_id%qn_melt_col > 0) &
                       diag_4d(i,j,k,diag_pt%qndt_melt) = nctend(i,k)
                 IF (diag_id%qidt_melt2 + diag_id%qi_melt2_col > 0) &
                        diag_4d(i,j,k,diag_pt%qidt_melt2) = qitend(i,k)
                 IF (diag_id%qnidt_melt + diag_id%qni_melt_col > 0) &
                        diag_4d(i,j,k,diag_pt%qnidt_melt) = nitend(i,k)
                 nctend(i,k) = nctend(i,k) + 3._mg_pr*dum*dumi(i,k)/  &
                                  deltat/(4._mg_pr*pi*5.12e-16_mg_pr*rhow)
                 qitend(i,k) = ((1._mg_pr - dum)*dumi(i,k) - qi(i,k))/  &
                                                                   deltat
                 nitend(i,k) = ((1._mg_pr - dum)*dumni(i,k) - ni(i,k))/   &
                                                                    deltat
                 tlat(i,k) = tlat(i,k) - xlf*dum*dumi(i,k)/deltat

                 IF (diag_id%qndt_melt + diag_id%qn_melt_col > 0) &
                         diag_4d(i,j,k,diag_pt%qndt_melt) =     &
                            nctend(i,k) - diag_4d(i,j,k,diag_pt%qndt_melt)
                 IF (diag_id%qidt_melt2  + diag_id%qi_melt2_col > 0) &
                         diag_4d(i,j,k,diag_pt%qidt_melt2) =    &
                            qitend(i,k) - diag_4d(i,j,k,diag_pt%qidt_melt2)
                 IF (diag_id%qnidt_melt + diag_id%qni_melt_col > 0) &
                        diag_4d(i,j,k,diag_pt%qnidt_melt) =     &
                           nitend(i,k) - diag_4d(i,j,k,diag_pt%qnidt_melt)
               end if
             end if

! homogeneously freeze droplets at -40 C
             if (t(i,k) + tlat(i,k)/cpp*deltat < tmin_fice) then
               if (dumc(i,k) .ge. 0._mg_pr) then
! limit so that freezing does not push temperature above threshold
                 dum = dumc(i,k)*xlf/cpp
                 if (t(i,k) + tlat(i,k)/cpp*deltat + dum .gt.   &
                                                           tmin_fice) then
                   dum = -(t(i,k) + tlat(i,k)/cpp*deltat - tmin_fice)*  &
                                                                   cpp/xlf
                   dum = dum/dumc(i,k)*xlf/cpp
                   dum = max(0._mg_pr, dum)
                   dum = min(1._mg_pr, dum)
                 else
                   dum = 1._mg_pr
                 end if
                 qitend(i,k) = qitend(i,k) + dum*dumc(i,k)/deltat
                 IF (diag_id%qldt_freez  + diag_id%ql_freez_col > 0) &
                        diag_4d(i,j,k,diag_pt%qldt_freez) = qctend(i,k)
                        sum_freeze(i,k) = qctend(i,k)
                 IF (diag_id%qndt_ihom + diag_id%qn_ihom_col > 0) &
                        diag_4d(i,j,k,diag_pt%qndt_ihom) =  nctend(i,k)
                 IF (diag_id%qnidt_ihom + diag_id%qni_ihom_col > 0) &
                        diag_4d(i,j,k,diag_pt%qnidt_ihom) =  nitend(i,k)

! hm add 11/18/06
! assume 25 micron mean volume radius of homogeneously frozen droplets
! consistent with size of detrained ice in stratiform.F90
!
! cms nitend .ne. -nctend
!
! 4/24/12: replace the 1.563 with x**3, here and in nCAR routine.

                 nitend(i,k) = nitend(i,k) + dum*3._mg_pr*dumc(i,k)/  &
                         (4._mg_pr*3.14_mg_pr*1.563e-14_mg_pr*rhoi)/deltat
                 qctend(i,k) = ((1._mg_pr - dum)*dumc(i,k) - qc(i,k))/   &
                                                                     deltat
                 nctend(i,k) = ((1._mg_pr - dum)*dumnc(i,k) - nc(i,k))/  &
                                                                     deltat
                 tlat(i,k) = tlat(i,k) + xlf*dum*dumc(i,k)/deltat

                 IF (diag_id%qldt_freez + diag_id%ql_freez_col > 0) &
                        diag_4d(i,j,k,diag_pt%qldt_freez)  =    &
                          qctend(i,k) - diag_4d(i,j,k,diag_pt%qldt_freez) 
                 sum_freeze(i,k) = -(qctend(i,k) - sum_freeze(i,k))
                 IF (diag_id%qndt_ihom + diag_id%qn_ihom_col > 0) &
                         diag_4d(i,j,k,diag_pt%qndt_ihom) =    &
                            nctend(i,k) - diag_4d(i,j,k,diag_pt%qndt_ihom)
                 IF (diag_id%qnidt_ihom + diag_id%qni_ihom_col > 0) &
                        diag_4d(i,j,k,diag_pt%qnidt_ihom) =   &
                            nitend(i,k) - diag_4d(i,j,k,diag_pt%qnidt_ihom)
               end if
             end if

             ssat_disposal(i,k) = 0._mg_pr

             IF (no_rh_adj_opt .EQ. 0) THEN
               IF (Nml%super_ice_opt .EQ. 0) THEN

!RSH: This is the code section which is intended to mimic the RK treatment.
!RSH  (super_ice_opt = 0)
!--++
!cms remove supersat 

                 rho(i,k) = pfull(i,k)/(rdgas*t_in(i,k))
                 ttmp = t(i,k) + tlat(i,k)/cpp*deltat
                 qtmp = q(i,k) + qvlat(i,k)*deltat
                 eslt = polysvp_l(ttmp)
                 esit = polysvp_i(ttmp)
                 esn = min(esit, eslt)
                 tmp2 = pfull(i,k) - d378*esn
                 tmp2 = max(tmp2, esn)
                 call lookup_des(ttmp, tmp7)
                 tmp7 = d622*pfull(i,k)*tmp7/tmp2/tmp2
                 tmp2 = d622*esn/tmp2

! the following is not consistent with the apportioning below ...
                 tmp3 = tmp7*(min(1., max(0._mg_pr,    &
                         0.05_mg_pr*(ttmp - tfreeze + 20._mg_pr)))*hlv + &
                          min(1., max(0._mg_pr,      &
                               0.05_mg_pr*(tfreeze - ttmp)))*hls)/cp_air

! compute excess over saturation
                 tmp1 = max(0._mg_pr, qtmp - tmp2)/(1._mg_pr + tmp3)

! change vapor content
                 qvlat(i,k) = qvlat(i,k) - tmp1/deltat 
                 if  (diag_id%qdt_super_sat_rm > 0)  &
                         super_saturation_rm1(i,k) =      &
                                  super_saturation_rm1(i,k) - tmp1/deltat
                 if  (diag_id%qdt_super_sat_rm > 0)  &
                         diag_4d(i,j,k,diag_pt%qdt_super_sat_rm) =    &
                                           super_saturation_rm1(i,k)
!CHANGE
! add in excess to cloud condensate, change cloud area and 
! increment temperature
                 if (ttmp .le. tfreeze - 40._mg_pr .and.     &
                                          tmp1 .gt. 0._mg_pr) then
                   IF (Nml%super_choice) THEN 
                     qitend(i,k) = qitend(i,k) + tmp1/deltat
                     ssat_disposal(i,k) = 2._mg_pr
                     IF (diag_id%ice_adj + diag_id%ice_adj_col > 0) &
                            diag_4d(i,j,k,diag_pt%ice_adj) = tmp1/deltat
                     sum_ice_adj(i,k) = tmp1/deltat
                   ELSE
                     ssat_disposal(i,k) = 0._mg_pr
                     prect(i) = prect(i) + tmp1/deltat*pdel(i,k)/grav/rhow
                     preci(i) = preci(i) + tmp1/deltat*pdel(i,k)/grav/rhow
                     qsout(i,k) = qsout(i,k) + tmp1
                     asnowrt(i,k) = asnowrt(i,k) + tmp1/deltat*    &
                                                           pdel(i,k)/grav 
                     atotrt(i,k) = atotrt(i,k) + tmp1/deltat *   &
                                                          pdel(i,k)/grav 
                   END IF
                   tlat(i,k) = tlat(i,k) + hls*tmp1/deltat 
                 end if

                 if (ttmp .gt. tfreeze - 40._mg_pr .and.    &
                                               tmp1 .gt. 0._mg_pr) then   
                   IF (Nml%super_choice) THEN 
                     qctend(i,k) = qctend(i,k) + tmp1/deltat 
                     ssat_disposal(i,k) = 1._mg_pr
                     IF (diag_id%liq_adj + diag_id%liq_adj_col > 0 ) &
                           diag_4d(i,j,k,diag_pt%liq_adj) = tmp1/deltat
                   ELSE
                     ssat_disposal(i,k) = 0._mg_pr
                     prect(i) = prect(i) + tmp1/deltat*pdel(i,k)/   &
                                                               grav/rhow
                     qrout(i,k) = qrout(i,k) + tmp1
                     atotrt(i,k) = atotrt(i,k) +  tmp1/deltat*   &
                                                            pdel(i,k)/grav 
                   END IF
                   tlat(i,k) = tlat(i,k) + hlv*tmp1/deltat             
                 end if
               ELSE IF (Nml%super_ice_opt .GE. 1) THEN 
                 ssat_disposal(i,k) = 0._mg_pr

!RSH: THis is the code section  used with M-G (super_ice_opt >= 1).
                 IF (sat_adj_opt .EQ. 1) THEN
                   ttmp = t(i,k) + tlat(i,k)/cpp*deltat
                   qtmp = q(i,k) + qvlat(i,k)*deltat
                   qs_t = polysvp_l(ttmp)
! calculate denominator in qsat formula
                   qs_d = pfull(i,k) - d378*qs_t
! limit denominator to esat, and thus qs to d622
! this is done to avoid blow up in the upper stratosphere
! where pfull ~ esat  
                   qs_d = max(qs_d, qs_t)
! calculate qs
                   qs_t = d622*qs_t/qs_d

! compute super saturation
                   tmp1 = max(0._mg_pr, (qtmp - qs_t))/(1._mg_pr +    &
                                       hlv*qs_t/(rvgas*ttmp**2)*hlv/cp_air)
 
! change vapor content
                   qvlat(i,k) = qvlat(i,k) - tmp1/deltat

! add in excess to cloud condensate, change cloud area and 
! increment temperature
                   if (ttmp .le. tfreeze - 40._mg_pr .and.   &
                                                 tmp1 .gt. 0._mg_pr) then
                     ssat_disposal(i,k) = 2._mg_pr
                     qitend(i,k) = qitend(i,k) + tmp1/deltat
                     IF (diag_id%ice_adj + diag_id%ice_adj_col > 0) &
                               diag_4d(i,j,k,diag_pt%ice_adj) = tmp1/deltat
                     sum_ice_adj(i,k) = tmp1/deltat
                     if  (diag_id%qdt_super_sat_rm > 0)  &
                              super_saturation_rm1(i,k)  =     &
                                   super_saturation_rm1(i,k) - tmp1/deltat
                     if  (diag_id%qdt_super_sat_rm > 0)  &
                              diag_4d(i,j,k,diag_pt%qdt_super_sat_rm) =  &
                                             super_saturation_rm1(i,k)
                     tlat(i,k) = tlat(i,k) + hls*tmp1/deltat
                   end if 

                   if (ttmp .gt. tfreeze - 40._mg_pr .and.    &
                                                  tmp1 .gt. 0._mg_pr) then
                     qctend(i,k) = qctend(i,k) + tmp1/deltat
                     ssat_disposal(i,k) = 1._mg_pr
                     IF (diag_id%liq_adj + diag_id%liq_adj_col > 0 ) &
                            diag_4d(i,j,k,diag_pt%liq_adj) = tmp1/deltat
                     if  (diag_id%qdt_super_sat_rm > 0)  &
                                super_saturation_rm1(i,k)  =   &
                                    super_saturation_rm1(i,k) - tmp1/deltat
                     if  (diag_id%qdt_super_sat_rm > 0)  &
                              diag_4d(i,j,k,diag_pt%qdt_super_sat_rm) =  &
                                          super_saturation_rm1(i,k)
                     tlat(i,k) = tlat(i,k) + hlv*tmp1/deltat
                   end if   
                 END IF 
               END IF ! (super_ice_opt .EQ. 0)
             END IF ! (no_rh_adj_opt .EQ. 0)
!........................................................................
! do not calculate effective radius here,
! but do some limiting
! update cloud variables after instantaneous processes to get effective 
! radius
! variables are in-cloud to calculate size dist parameters

             dumc(i,k) = max(qc(i,k) + qctend(i,k)*deltat, 0._mg_pr)/   &
                                                                 cldm(i,k)
             dumi(i,k) = max(qi(i,k) + qitend(i,k)*deltat, 0._mg_pr)/  &
                                                                 cldm(i,k)
             dumnc(i,k) = max(nc(i,k) + nctend(i,k)*deltat, 0._mg_pr)/  &
                                                                 cldm(i,k)
             dumni(i,k) = max(ni(i,k) + nitend(i,k)*deltat, 0._mg_pr)/  &
                                                                cldm(i,k)

! limit in-cloud mixing ratio to reasonable value of 5 g kg-1
             dumc(i,k) = min(dumc(i,k), in_cloud_limit)
             dumi(i,k) = min(dumi(i,k), in_cloud_limit)

!...................
! cloud ice effective radius

             if (dumi(i,k) .ge. qsmall) then
               IF (diag_id%qnidt_size_adj +   &
                              diag_id%qni_size_adj_col > 0) THEN
                      diag_4d(i,j,k,diag_pt%qnidt_size_adj ) =  nitend(i,k)
               END IF

! add upper limit to in-cloud number concentration to prevent 
! numerical error
               dumni(i,k) = min(dumni(i,k), dumi(i,k)*1.e20_mg_pr)
               lami(k) = (gamma_mg(1._mg_pr + di_mg)*ci_mg* &
                                dumni(i,k)/dumi(i,k))**(1._mg_pr/di_mg)
               lammax = 1._mg_pr/min_diam_ice
               lammin = 1._mg_pr/(2._mg_pr*dcs)
               if (lami(k) .lt. lammin) then
                 lami(k) = lammin
                 n0i(k) = lami(k)**(di_mg + 1._mg_pr)*dumi(i,k)/   &
                                        (ci_mg*gamma_mg(1._mg_pr + di_mg))
                 niic(i,k) = n0i(k)/lami(k)

! adjust number conc if needed to keep mean size in reasonable range
                 nitend(i,k) = (niic(i,k)*cldm(i,k) - ni(i,k))/deltat
               else if (lami(k) .gt. lammax) then
                 lami(k) = lammax
                 n0i(k) = lami(k)**(di_mg + 1._mg_pr)*dumi(i,k)/   &
                                        (ci_mg*gamma_mg(1._mg_pr + di_mg))
                 niic(i,k) = n0i(k)/lami(k)

! adjust number conc if needed to keep mean size in reasonable range
                 nitend(i,k) = (niic(i,k)*cldm(i,k) - ni(i,k))/deltat
               end if
               IF (diag_id%qnidt_size_adj + diag_id%qni_size_adj_col > 0) &
                    diag_4d(i,j,k,diag_pt%qnidt_size_adj) = nitend(i,k) - &
                                     diag_4d(i,j,k,diag_pt%qnidt_size_adj) 
             end if

!...................
! cloud droplet effective radius

             if (dumc(i,k) .ge. qsmall) then
               IF (diag_id%qndt_size_adj + diag_id%qn_size_adj_col > 0) &
                      diag_4d(i,j,k,diag_pt%qndt_size_adj ) =  nctend(i,k)

! add upper limit to in-cloud number concentration to prevent 
! numerical error
               dumnc(i,k) = min(dumnc(i,k), dumc(i,k)*1.e20_mg_pr)
!RSH BUGFIX email of 6/8/10
!              pgam(k)=0.0005714_mg_pr*(dumnc(i,k)/1.e6_mg_pr/rho(i,k))+ &
!                                                              0.2714_mg_pr
               pgam(k) = 0.0005714_mg_pr*(dumnc(i,k)/1.e6_mg_pr*    &
                                                  rho(i,k)) + 0.2714_mg_pr
               pgam(k)=1._mg_pr/(pgam(k)**2) - 1._mg_pr
               pgam(k) = max(pgam(k), 2._mg_pr)
               pgam(k) = min(pgam(k), 15._mg_pr)
               lamc(k) = (pi/6._mg_pr*rhow*dumnc(i,k)*  &
                                    gamma_mg(pgam(k) + 4._mg_pr)/ &
                                              (dumc(i,k)*    &
                        gamma_mg(pgam(k) + 1._mg_pr)))**(1._mg_pr/3._mg_pr)
!              lammin = (pgam(k)+1._mg_pr)/50.e-6_mg_pr
!              lammax = (pgam(k)+1._mg_pr)/2.e-6_mg_pr
               lammin = (pgam(k) + 1._mg_pr)/max_diam_drop
               lammax = (pgam(k) + 1._mg_pr)/min_diam_drop
               if (lamc(k) .lt. lammin) then
                 lamc(k) = lammin
                 ncic(i,k) = 6._mg_pr*lamc(k)**3*dumc(i,k)* &
                                  gamma_mg(pgam(k) + 1._mg_pr)/ &
                                     (pi*rhow*gamma_mg(pgam(k) + 4._mg_pr))

! adjust number conc if needed to keep mean size in reasonable range
                 nctend(i,k) = (ncic(i,k)*cldm(i,k) - nc(i,k))/deltat
               else if (lamc(k).gt.lammax) then
                 lamc(k) = lammax
                 ncic(i,k) = 6._mg_pr*lamc(k)**3*dumc(i,k)* &
                                  gamma_mg(pgam(k) + 1._mg_pr)/ &

                                     (pi*rhow*gamma_mg(pgam(k) + 4._mg_pr))
! adjust number conc if needed to keep mean size in reasonable range
                 nctend(i,k) = (ncic(i,k)*cldm(i,k) - nc(i,k))/deltat
               end if
               IF (diag_id%qndt_size_adj + diag_id%qn_size_adj_col > 0) &
                      diag_4d(i,j,k,diag_pt%qndt_size_adj ) =    &
                       nctend(i,k) - diag_4d(i,j,k,diag_pt%qndt_size_adj) 
             end if

!...................
! rain drop effective size
             if (qrout(i,k) .gt. 1.e-7_mg_pr .and.    &
                                 nrout(i,k) .gt. 0._mg_pr) then
               lsc_rain_size(i,k) = 3.0_mg_pr*(pi*rhow*nrout(i,k)/    &
                              qrout(i,k))**(-1._mg_pr/3._mg_pr)*1.e6_mg_pr
             else
               lsc_rain_size(i,k) = 100._mg_pr
             endif
           end do   ! (k loop) 
500        CONTINUE


           do k=1,kdim
! if updated q (after microphysics) is zero, then ensure updated n is also zero
             IF (diag_id%qndt_fill2 + diag_id%qn_fill2_col > 0) &
                    diag_4d(i,j,k,diag_pt%qndt_fill2 ) = nctend(i,k)
             IF (diag_id%qnidt_fill2 +  diag_id%qni_fill2_col > 0) &
                    diag_4d(i,j,k,diag_pt%qnidt_fill2 ) = nitend(i,k)
             if (qc(i,k) + qctend(i,k)*deltat .lt. qsmall)    &
                                             nctend(i,k) = -nc(i,k)/deltat
             if (qi(i,k) + qitend(i,k)*deltat .lt. qsmall)     &
                                             nitend(i,k) = -ni(i,k)/deltat
             IF (diag_id%qndt_fill2 + diag_id%qn_fill2_col > 0) &
                      diag_4d(i,j,k,diag_pt%qndt_fill2 ) =    &
                          nctend(i,k) - diag_4d(i,j,k,diag_pt%qndt_fill2) 
             IF (diag_id%qnidt_fill2 + diag_id%qni_fill2_col > 0) &
                     diag_4d(i,j,k,diag_pt%qnidt_fill2 ) =   &
                         nitend(i,k) - diag_4d(i,j,k,diag_pt%qnidt_fill2) 
           end do
         end do ! (do i=1,idim)

         rain3d(:,:,1) = 0._mg_pr
         snow3d(:,:,1) = 0._mg_pr
         DO k=1,kdim
           DO i=1,idim

! STILL NEED TO DEAL WITH SSAT GOING to PRECIP RATHER THAN CLOUD -
             rain3d(i,j,k+1) = MAX((atotrt(i,k) - asnowrt(i,k)), 0._mg_pr)
             snow3d(i,j,k+1) = MAX(asnowrt(i,k), 0._mg_pr)
           END DO
         END DO
 
         if (diag_id%rain_evap + diag_id%rain_evap_col > 0)  &
                diag_4d(:,j,:,diag_pt%rain_evap) = pre1(:,:)/real(iter)

         if (diag_id%qdt_rain_evap > 0)  &
                diag_4d(:,j,:,diag_pt%qdt_rain_evap) = pre1(:,:)/real(iter)

         if (diag_id%qdt_cond > 0) &
                diag_4d(:,j,:,diag_pt%qdt_cond) = -cmel1(:,:)/real(iter)

         if (diag_id%qdt_snow_sublim > 0 .or.  &
                         diag_id%q_snow_sublim_col > 0)  &
                diag_4d(:,j,:,diag_pt%qdt_snow_sublim )  =  &
                                                     prds1(:,:)/real(iter)

         if (diag_id%qdt_deposition > 0)  &
                diag_4d(:,j,:,diag_pt%qdt_deposition)  =   &
                                       -cmei1(:,:)/real(iter)

         if  (diag_id%qdt_eros_l > 0)  &
              diag_4d(:,j,:,diag_pt%qdt_eros_l)  =    &
                                    -D_eros_l1(:,:)/real(iter)

         if  (diag_id%qdt_eros_i > 0)  &
                 diag_4d(:,j,:,diag_pt%qdt_eros_i)  =    &
                                     -D_eros_i1(:,:)/real(iter)

         if  (diag_id%qdt_qv_on_qi > 0)  &
                   diag_4d(:,j,:,diag_pt%qdt_qv_on_qi) =  &
                                    - qvdep_qi1(:,:)/real(iter)

         if  (diag_id%qdt_snow2vapor + diag_id%q_snow2vapor_col > 0)  &
                    diag_4d(:,j,:,diag_pt%qdt_snow2vapor) =   &
                                        snow2vapor1(:,:)/real(iter)

         if  (diag_id%qdt_sedi_ice2vapor > 0)  &
               diag_4d(:,j,:,diag_pt%qdt_sedi_ice2vapor) =   &
                                            sedi_ice2vapor1(:,:)

         if  (diag_id%qdt_sedi_liquid2vapor > 0)  &
                  diag_4d(:,j,:,diag_pt%qdt_sedi_liquid2vapor) =  &
                                         sedi_liquid2vapor1(:,:)

         if  (diag_id%qdt_super_sat_rm > 0)  &
              diag_4d(:,j,:,diag_pt%qdt_super_sat_rm) =    &
                                      super_saturation_rm1(:,:)

!       diagnostics for cloud liquid tendencies
!cloud water  
         if (diag_id%qldt_cond  + diag_id%ql_cond_col > 0) &
              diag_4d(:,j,:,diag_pt%qldt_cond)  =     &
                                    max(cmel1(:,:), 0._mg_pr)/real(iter)

         if (diag_id%qldt_evap  + diag_id%ql_evap_col > 0) &
              diag_4d(:,j,:,diag_pt%qldt_evap)  =     &
                          - max(-1._mg_pr*cmel1(:,:),0._mg_pr)/real(iter) 

         if (diag_id%qldt_eros + diag_id%ql_eros_col > 0) &
              diag_4d(:,j,:,diag_pt%qldt_eros) = D_eros_l1(:,:)/real(iter) 

         if (diag_id%qldt_berg + diag_id%ql_berg_col > 0) &
              diag_4d(:,j,:,diag_pt%qldt_berg) = - berg1(:,:)/real(iter)   

         sum_berg(:,:) =  berg1(:,:)/real(iter)
         if (diag_id%qldt_auto + diag_id%ql_auto_col > 0) &
              diag_4d(:,j,:,diag_pt%qldt_auto) = prc1(:,:)/real(iter)   

         if (diag_id%qldt_freez2 + diag_id%ql_freez2_col > 0) &
              diag_4d(:,j,:,diag_pt%qldt_freez2) = mnuccc1(:,:)/real(iter) 
         sum_freeze2(:,:) = -mnuccc1(:,:)/real(iter)

         if (diag_id%qldt_accr  + diag_id%ql_accr_col > 0) &
              diag_4d(:,j,:,diag_pt% qldt_accr) = pra1(:,:) /real(iter)   

         if (diag_id%qldt_accrs  + diag_id%ql_accrs_col > 0) & 
              diag_4d(:,j,:,diag_pt%qldt_accrs) = psacws1(:,:)/real(iter)
         sum_rime(:,:) = -psacws1(:,:)/real(iter)

         if (diag_id%qldt_bergs + diag_id%ql_bergs_col > 0) &
              diag_4d(:,j,:,diag_pt%qldt_bergs) = bergs1(:,:)/real(iter)
         sum_bergs(:,:) = -bergs1(:,:)/real(iter)

!cloud ice 
         if (diag_id%qidt_dep + diag_id%qi_dep_col > 0)    &
             diag_4d(:,j,:,diag_pt%qidt_dep)  =   &
                                 max(cmei1(:,:), 0._mg_pr) /real(iter)
         sum_cond (:,:) = max(cmei1(:,:), 0._mg_pr) /real(iter)

         if (diag_id%qidt_subl + diag_id%qi_subl_col > 0)  &
                 diag_4d(:,j,:,diag_pt%qidt_subl) =     &
                          -max(-1._mg_pr*cmei1(:,:), 0._mg_pr) /real(iter) 

         if (diag_id%qidt_eros + diag_id%qi_eros_col > 0) &
             diag_4d(:,j,:,diag_pt%qidt_eros) = D_eros_i1(:,:)/real(iter) 

         if (diag_id%qidt_auto + diag_id%qi_auto_col > 0) & 
             diag_4d(:,j,:,diag_pt%qidt_auto) = prci1(:,:)/real(iter) 

         if (diag_id%qidt_accr  + diag_id%qi_accr_col > 0) &
             diag_4d(:,j,:,diag_pt%qidt_accr) = prai1(:,:)/real(iter)

         if (diag_id%qidt_accrs  + diag_id%qi_accrs_col > 0) &
             diag_4d(:,j,:,diag_pt%qidt_accrs) = psacws_o1(:,:)/real(iter)

         if (diag_id%qidt_qvdep + diag_id%qi_qvdep_col > 0)    &
             diag_4d(:,j,:,diag_pt%qidt_qvdep) = qvdep_qi1(:,:)/real(iter)

!cloud droplet number
         if ( diag_id%qndt_nucclim + diag_id%qn_nucclim_col > 0) &
            diag_4d(:,j,:,diag_pt%qndt_nucclim) = nucclim1(:,:)/real(iter)

         if (diag_id%qndt_cond + diag_id%qn_cond_col > 0)    &
             diag_4d(:,j,:,diag_pt%qndt_cond) = npccn1(:,:)/real(iter)

         if (diag_id%qndt_freez + diag_id%qn_freez_col > 0)    &
             diag_4d(:,j,:,diag_pt%qndt_freez) = nnuccc1(:,:)/real(iter)

         if (diag_id%qndt_sacws + diag_id%qn_sacws_col > 0)    &
             diag_4d(:,j,:,diag_pt%qndt_sacws) = npsacws1(:,:)/real(iter)

         if (diag_id%qndt_sacws_o + diag_id%qn_sacws_o_col > 0)    &
             diag_4d(:,j,:,diag_pt%qndt_sacws_o) =     &
                                                 npsacws_o1(:,:)/real(iter)

         if (diag_id%qndt_evap + diag_id%qn_evap_col > 0)    &
             diag_4d(:,j,:,diag_pt%qndt_evap) = nsubc1(:,:)/real(iter)

         if (diag_id%qndt_eros + diag_id%qn_eros_col > 0)    &
             diag_4d(:,j,:,diag_pt%qndt_eros) = nerosc1(:,:)/real(iter)

         if (diag_id%qndt_pra + diag_id%qn_pra_col > 0)    &
             diag_4d(:,j,:,diag_pt%qndt_pra) = npra1(:,:)/real(iter)

         if (diag_id%qndt_auto + diag_id%qn_auto_col > 0)    &
             diag_4d(:,j,:,diag_pt%qndt_auto) = nprc11(:,:)/real(iter)

!cloud droplet number
         if (diag_id%qnidt_nnuccd + diag_id%qni_nnuccd_col > 0)    &
             diag_4d(:,j,:,diag_pt%qnidt_nnuccd) = nnuccd1(:,:)/real(iter)

         if (diag_id%qnidt_nsubi  + diag_id%qni_nsubi_col  > 0)    &
             diag_4d(:,j,:,diag_pt%qnidt_nsubi) = nsubi1(:,:)/real(iter)

         if (diag_id%qnidt_nerosi  + diag_id%qni_nerosi_col  > 0)    &
             diag_4d(:,j,:,diag_pt%qnidt_nerosi) = nerosi1(:,:)/real(iter)

         if (diag_id%qnidt_nprci  + diag_id%qni_nprci_col  > 0)    &
             diag_4d(:,j,:,diag_pt%qnidt_nprci) = nprci1(:,:)/real(iter)

         if (diag_id%qnidt_nprai  + diag_id%qni_nprai_col  > 0)    &
             diag_4d(:,j,:,diag_pt%qnidt_nprai) = nprai1(:,:)/real(iter)

         if (diag_id%qnidt_nucclim1  + diag_id%qni_nucclim1_col  > 0)    &
             diag_4d(:,j,:,diag_pt%qnidt_nucclim1) =    &
                                                 nucclim1_1(:,:)/real(iter)

         if (diag_id%qnidt_nucclim2  + diag_id%qni_nucclim2_col  > 0)    &
             diag_4d(:,j,:,diag_pt%qnidt_nucclim2) =     &
                                                 nucclim2_1(:,:)/real(iter)

         if (diag_id%srfrain_accrs + diag_id%srfrain_accrs_col  > 0)    &
             diag_4d(:,j,:,diag_pt%srfrain_accrs) =   &
                                                 pracs1(:,:)/real(iter)
 
         if (diag_id%srfrain_freez + diag_id%srfrain_freez_col > 0)    &
             diag_4d(:,j,:,diag_pt%srfrain_freez) =    &
                                                 mnuccr1(:,:)/real(iter)
!RSH:
!   calculate fraction of total ice/snow creation that requires
!   ice-forming nuclei
         do k=1,kdim
           do i=1,idim
             qldt_sum = sum_berg(i,k) + sum_rime(i,k) + sum_freeze(i,k) +&
                        MAX(sum_bergs(i,k), 0.0_mg_pr) + sum_cond(i,k) + &
                        sum_ice_adj(i,k) + sum_freeze2(i,k)
             if (qldt_sum > 0.0_mg_pr)  then
               f_snow_berg(i,k) = (sum_berg(i,k) + sum_cond(i,k) +   &
                                   sum_ice_adj(i,k) + sum_freeze(i,k) + &
                                   MAX(sum_bergs(i,k), 0.0))/qldt_sum
             else
               f_snow_berg(i,k) = 0._mg_pr
             endif
           end do
         end do

!-----------------------------------------------------------------------

END SUBROUTINE morrison_gettelman_microp


!#########################################################################

SUBROUTINE morrison_gettelman_microp_end (do_pdf_clouds)

LOGICAL, INTENT(IN ) :: do_pdf_clouds

!------------------------------------------------------------------------
!    call destructor routines for modules used here.
!------------------------------------------------------------------------
      call polysvp_end
      if (do_pdf_clouds) then
        CALL  simple_pdf_end
      endif 
      call gamma_mg_end

!------------------------------------------------------------------------
!    mark the module as uninitialized.
!------------------------------------------------------------------------
      module_is_initialized = .false.

!-----------------------------------------------------------------------


END SUBROUTINE morrison_gettelman_microp_end


!#########################################################################



END MODULE morrison_gettelman_microp_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: Lagrangian particle random walk \label{sec:lagrange}
!
! !INTERFACE:
   subroutine lagrange(nlev,dt,zlev,nuh,w,npar,active,zi,zp)
!
! !DESCRIPTION:
!
! Here a Lagrangian particle random walk for spatially
! inhomogeneous turbulence according to \cite{Visser1997} is implemented.
! With the random walk, the particle $i$ is moved from the vertical
! position $z_i^n$ to $z_i^{n+1}$ according to the following algorithm:
! \begin{equation}
! \begin{array}{rcl}
! z_i^{n+1} &=&
! z^n_i + \partial_z \nu_t (z^n_i)\Delta t \\ \\
! &+&
! R \left\{2 r^{-1} \nu_t (z^n_i + \frac12  \partial_z \nu_t (z^n_i)\Delta t)
! \Delta t\right\}^{1/2},
! \end{array}
! \end{equation}
! where $R$ is a random process with $\langle R \rangle =0$ (zero mean) and
! and the variance $\langle R^2 \rangle=r$.
! Set {\tt visc\_corr=.true.} for
! evaluating eddy viscosity in a semi-implicit way. A background viscosity
! ({\tt visc\_back}) may be set. The variance $r$ of the random walk scheme
! ({\tt rnd\_var}) has to be set manually as well here.
!
! !USES:
!
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: nlev
   REALTYPE, intent(in)                :: dt
   REALTYPE, intent(in)                :: zlev(0:nlev)
   REALTYPE, intent(in)                :: nuh(0:nlev)
   REALTYPE, intent(in)                :: w
   integer, intent(in)                 :: npar
   logical, intent(in)                 :: active(npar)
!
! !INPUT/OUTPUT PARAMETERS:
   integer, intent(inout)              :: zi(npar)
   REALTYPE, intent(inout)             :: zp(npar)
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard & Karsten Bolding
!
!  $Log: lagrange.F90,v $
!  Revision 20.0  2013/12/14 00:14:03  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:01:18  smg
!  initial cvs ci to mom5
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:33:41  smg
!  updated to gotm-2012.03.09 CVS tagged code.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.9  2010-09-17 12:53:53  jorn
!  extensive code clean-up to ensure proper initialization and clean-up of all variables
!
!  Revision 1.8  2009-01-07 07:25:37  kb
!  fixed various compilation warnings found by gfortran
!
!  Revision 1.7  2008-11-03 12:56:39  jorn
!  fixed: particles are now reflected multiple times if needed
!
!  Revision 1.6  2008-07-07 09:05:51  lars
!  added LaTeX label
!
!  Revision 1.5  2005-12-02 21:06:09  hb
!  Lagrangian routine included into source code documentation
!
!  Revision 1.4  2004/08/19 09:24:57  hb
!  Variance of random walk and background diffusivity explicitely prescribed --> Hidekatsu Yamazaki
!
!  Revision 1.3  2004/08/18 16:09:39  hb
!  Visser correction for viscosity evaluation included
!
!  Revision 1.2  2004/03/22 10:14:24  kbk
!  cleaned, store old index -> much faster, fixed conc. calc.
!
!  Revision 1.1  2004/03/04 09:28:41  kbk
!  general lagrangian 1D solver
!
! !LOCAL VARIABLES:
   integer            :: i,n
   REALTYPE           :: rnd(npar),rnd_var_inv
   REALTYPE,parameter :: visc_back=0.e-6,rnd_var=0.333333333
   REALTYPE           :: depth,dz(nlev),dzn(nlev),step,zp_old
   REALTYPE           :: visc,rat,dt_inv,zloc
   logical,parameter  :: visc_corr=.false.
!EOP
!-----------------------------------------------------------------------
!BOC

   dt_inv=1./dt
   rnd_var_inv=1./rnd_var

   call random_number(rnd)
   rnd=(2.*rnd-1.)

   do i=1,nlev
      dz(i)=zlev(i)-zlev(i-1)
      dzn(i)=(nuh(i)-nuh(i-1))/dz(i)
   end do

   depth=-zlev(0)
   do n=1,npar
!     local viscosity calculation
      if (visc_corr) then ! correction suggested by Visser [1997]
         zloc=zp(n)+0.5*(dzn(zi(n))+w)*dt
         do while (zloc .lt. -depth .or. zloc .gt. _ZERO_)
            if (zloc .lt. -depth) then
               zloc=-depth+(-depth-zloc)
            else
               zloc=-zloc
            end if
         end do
         step=zloc-zp(n)
         if (step.gt.0) then ! search new index above old index
            do i=zi(n),nlev
               if (zlev(i) .gt. zloc) EXIT
            end do
         else                ! search new index below old index
            do i=zi(n),1,-1
               if (zlev(i-1) .lt. zloc) EXIT
            end do
         end if
      else
         i=zi(n)
         zloc=zp(n)
      end if
      rat=(zloc-zlev(i-1))/dz(i)
      visc=rat*nuh(i)+(1.-rat)*nuh(i-1)
      if (visc.lt.visc_back) visc=visc_back
      zp_old=zp(n)
      step=dt*(sqrt(2.*rnd_var_inv*dt_inv*visc)*rnd(n)+w+dzn(i))
      zp(n)=zp(n)+step
      do while (zp(n) .lt. -depth .or. zp(n) .gt. _ZERO_)
         if (zp(n) .lt. -depth) then
            zp(n)=-depth+(-depth-zp(n))
         else
            zp(n)=-zp(n)
         end if
      end do
      step=zp(n)-zp_old
      if (step.gt.0) then ! search new index above old index
         do i=zi(n),nlev
            if (zlev(i) .gt. zp(n)) EXIT
         end do
      else                ! search new index below old index
         do i=zi(n),1,-1
            if (zlev(i-1) .lt. zp(n)) EXIT
         end do
      end if
      zi(n)=i
   end do

   return
   end subroutine lagrange
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: cosp_lidar.F90,v 20.0 2013/12/13 23:15:45 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

!
! History:
! Jul 2007 - A. Bodas-Salcedo - Initial version
! Oct 2008 - S. Bony          - Instructions "Call for large-scale cloud" removed  -> sgx%frac_out is used instead.
!                               Call lidar_simulator changed (lsca, gbx%cca and depol removed; 
!                               frac_out changed in sgx%frac_out)
!
! 
MODULE MOD_COSP_LIDAR
  USE MOD_COSP_CONSTANTS
  USE MOD_COSP_TYPES
  IMPLICIT NONE

CONTAINS


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------------- SUBROUTINE COSP_LIDAR ------------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_LIDAR(gbx,sgx,sghydro,y)
  
  ! Arguments
  type(cosp_gridbox),intent(in) :: gbx  ! Gridbox info
  type(cosp_subgrid),intent(in) :: sgx  ! Subgrid info
  type(cosp_sghydro),intent(in) :: sghydro  ! Subgrid info for hydrometeors
  type(cosp_sglidar),intent(inout) :: y ! Subgrid output
  
  ! Local variables 
  integer :: i
  real :: presf(sgx%Npoints, sgx%Nlevels + 1)
  real,dimension(sgx%Npoints, sgx%Nlevels) :: lsca,mr_ll,mr_li,mr_cl,mr_ci
  real,dimension(sgx%Npoints, sgx%Nlevels) :: beta_tot,tau_tot
  real,dimension(sgx%Npoints, PARASOL_NREFL)  :: refle
  
  
  presf(:,1:sgx%Nlevels) = gbx%ph
  presf(:,sgx%Nlevels + 1) = 0.0
  lsca = gbx%tca-gbx%cca
  do i=1,sgx%Ncolumns
      ! Temporary arrays for simulator call
      mr_ll(:,:) = sghydro%mr_hydro(:,i,:,I_LSCLIQ)
      mr_li(:,:) = sghydro%mr_hydro(:,i,:,I_LSCICE)
      mr_cl(:,:) = sghydro%mr_hydro(:,i,:,I_CVCLIQ)
      mr_ci(:,:) = sghydro%mr_hydro(:,i,:,I_CVCICE)
#ifdef COSP_GFDL
     if (sgx%cols_input_from_model) then
      call lidar_simulator(sgx%Npoints, sgx%Nlevels, 4 &
                 , PARASOL_NREFL, LIDAR_UNDEF  &
                 , gbx%p, presf, gbx%T &
                 , mr_ll, mr_li, mr_cl, mr_ci &
                 , sghydro%Reff(:,i,:,I_LSCLIQ),  &
                   sghydro%Reff(:,i,:,I_LSCICE), &
                   sghydro%Reff(:,i, :,I_CVCLIQ), &
                   sghydro%Reff(:,i,:,I_CVCICE) &
                 , sgx%frac_out, gbx%lidar_ice_type,  &
                   y%beta_mol, beta_tot, tau_tot  &
                 , refle ) ! reflectance
     else
#endif
      call lidar_simulator(sgx%Npoints, sgx%Nlevels, 4 &
                 , PARASOL_NREFL, LIDAR_UNDEF  &
                 , gbx%p, presf, gbx%T &
                 , mr_ll, mr_li, mr_cl, mr_ci &
                 , gbx%Reff(:,:,I_LSCLIQ), gbx%Reff(:,:,I_LSCICE), gbx%Reff(:,:,I_CVCLIQ), gbx%Reff(:,:,I_CVCICE) &
                 , sgx%frac_out, gbx%lidar_ice_type, y%beta_mol, beta_tot, tau_tot  &
                 , refle ) ! reflectance
#ifdef COSP_GFDL
     endif
#endif
      
      y%beta_tot(:,i,:) = beta_tot(:,:)
      y%tau_tot(:,i,:)  = tau_tot(:,:)
      y%refl(:,i,:)     = refle(:,:)
  enddo

END SUBROUTINE COSP_LIDAR

END MODULE MOD_COSP_LIDAR

      Module CO2_Data_Mod

!-----------------------------------------------------------------------

      use fs_profile_mod, ONLY:  fs_profile
      Use     co2int_mod, ONLY:  co2int, TRNS
      Use        fms_mod, ONLY:  open_namelist_file, mpp_pe,  &
                                 Error_Mesg, FATAL, close_file,  &
                                 write_version_number, mpp_root_pe, open_file

implicit none
private

!-----------------------------------------------------------------------
!
!   Pretabulated co2 transmission functions, evaluated using the
!   methods of Fels and Schwarzkopf (1981) and Schwarzkopf and
!   Fels (1985). 
!
!-----------------------------------------------------------------------
!
!   co2 transmission functions and temperature and pressure
!   derivatives for the 560-800 cm-1 band. also included are the
!   standard temperatures and the weighting function.
!   This data was formally in COMMON /CO2BD3/.
!
!       CO251    =  TRANSMISSION FCTNS FOR T0 (STD. PROFILE)
!                     WITH P(SFC)=1013.25 MB
!       CO258    =  TRANSMISSION FCTNS. FOR T0 (STD. PROFILE) 
!                     WITH P(SFC)= ^810 MB
!       CDT51    =  FIRST TEMPERATURE DERIVATIVE OF CO251 
!       CDT58    =  FIRST TEMPERATURE DERIVATIVE OF CO258 
!       C2D51    =  SECOND TEMPERATURE DERIVATIVE OF CO251
!       C2D58    =  SECOND TEMPERATURE DERIVATIVE OF CO251
!       CO2M51   =  TRANSMISSION FCTNS FOR T0 FOR ADJACENT PRESSURE 
!                      LEVELS, WITH NO PRESSURE QUADRATURE. USED FOR
!                      NEARBY LAYER COMPUTATIONS. P(SFC)=1013.25 MB 
!       CO2M58   =  SAME AS CO2M51,WITH P(SFC)= ^810 MB 
!       CDTM51   =  FIRST TEMPERATURE DERIVATIVE OF CO2M51
!       CDTM58   =  FIRST TEMPERATURE DERIVATIVE OF CO2M58
!       C2DM51   =  SECOND TEMPERATURE DERIVATIVE OF CO2M51 
!       C2DM58   =  SECOND TEMPERATURE DERIVATIVE OF CO2M58 
!       STEMP    =  STANDARD TEMPERATURES FOR MODEL PRESSURE LEVEL
!                      STRUCTURE WITH P(SFC)=1013.25 MB 
!       GTEMP    =  WEIGHTING FUNCTION FOR MODEL PRESSURE LEVEL 
!                      STRUCTURE WITH P(SFC)=1013.25 MB.
!       B0       =  TEMP. COEFFICIENT USED FOR CO2 TRANS. FCTN. 
!                      CORRECTION FOR T(K). (SEE REF. 4 AND BD3)
!       B1       =  TEMP. COEFFICIENT, USED ALONG WITH B0 
!       B2       =  TEMP. COEFFICIENT, USED ALONG WITH B0 
!       B3       =  TEMP. COEFFICIENT, USED ALONG WITH B0 

      Real, Allocatable, Dimension(:,:) :: CO251,CO258,CDT51,CDT58
      Real, Allocatable, Dimension(:,:) :: C2D51,C2D58
      Real, Allocatable, Dimension(:)   :: CO2M51,CO2M58,CDTM51,CDTM58
      Real, Allocatable, Dimension(:)   :: C2DM51,C2DM58
      Real, Allocatable, Dimension(:)   :: STEMP,GTEMP
      Real                              :: B0,B1,B2,B3

!-----------------------------------------------------------------------
!
!   co2 transmission functions and temperature and pressure
!   derivatives for the 560-670 cm-1 part of the 15 um co2 band. 
!   This data was formally in COMMON /CO2BD2/.
!
!       CO231    =  TRANSMISSION FCTNS FOR T0 (STD. PROFILE)
!                     WITH P(SFC)=1013.25 MB
!       CO238    =  TRANSMISSION FCTNS. FOR T0 (STD. PROFILE)
!                     WITH P(SFC)= ^810 MB
!       CDT31    =  FIRST TEMPERATURE DERIVATIVE OF CO231
!       CDT38    =  FIRST TEMPERATURE DERIVATIVE OF CO238
!       C2D31    =  SECOND TEMPERATURE DERIVATIVE OF CO231
!       C2D38    =  SECOND TEMPERATURE DERIVATIVE OF CO231

      Real, Allocatable, Dimension(:) :: CO231,CO238,CDT31,CDT38
      Real, Allocatable, Dimension(:) :: C2D31,C2D38

!-----------------------------------------------------------------------
!
!   co2 transmission functions and temperature and pressure
!   derivatives for the 670-800 part of the 15 um co2 band.
!   This data was formally in COMMON /CO2BD4/.
!
!       CO271    =  TRANSMISSION FCTNS FOR T0 (STD. PROFILE)
!                     WITH P(SFC)=1013.25 MB
!       CO278    =  TRANSMISSION FCTNS. FOR T0 (STD. PROFILE)
!                     WITH P(SFC)= ^810 MB
!       CDT71    =  FIRST TEMPERATURE DERIVATIVE OF CO271
!       CDT78    =  FIRST TEMPERATURE DERIVATIVE OF CO278
!       C2D71    =  SECOND TEMPERATURE DERIVATIVE OF CO271
!       C2D78    =  SECOND TEMPERATURE DERIVATIVE OF CO271

      Real, Allocatable, Dimension(:) :: CO271,CO278,CDT71,CDT78
      Real, Allocatable, Dimension(:) :: C2D71,C2D78

!-----------------------------------------------------------------------
!
!   co2 transmission functions for the 2270-2380 part of the
!   4.3 um co2 band. THis data was formally in COMMON /CO2BD5/.
!
!       CO211    =  TRANSMISSION FCTNS FOR T0 (STD. PROFILE)
!                     WITH P(SFC)=1013.25 MB
!       CO218    =  TRANSMISSION FCTNS. FOR T0 (STD. PROFILE)
!                     WITH P(SFC)= ^810 MB

      Real, Allocatable, Dimension(:) :: CO211,CO218

! 
!-----------------------------------------------------------------------

      Integer, Private :: LP1=0,LMAX=0

!-----------------------------------------------------------------------
!------------ VERSION NUMBER ----------------

 character(len=128) :: version = '$Id: co2_data.F90,v 13.0 2006/03/28 21:09:22 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'
 logical            :: module_is_initialized = .false.

!-----------------------------------------------------------------------

      Public   CO2_Data, Write_CO2_Data, Read_CO2_Data, &
               co2_data_init, co2_data_end

      Public   CO251,  CO258,  CDT51,  CDT58,  C2D51,  C2D58,  &
               CO2M51, CO2M58, CDTM51, CDTM58, C2DM51, C2DM58, &
               STEMP,  GTEMP,  B0,     B1,     B2,     B3,     &
               CO231,  CO238,  CDT31,  CDT38,  C2D31,  C2D38,  &
               CO271,  CO278,  CDT71,  CDT78,  C2D71,  C2D78,  &
               CO211,  CO218

      CONTAINS

!#######################################################################

      Subroutine CO2_Data (co2std, ratio, Pref)

      Implicit None
!-----------------------------------------------------------------------
      Real, Intent(IN) :: co2std, ratio
      Real, Intent(IN) :: Pref(:,:)
!-----------------------------------------------------------------------
!   CO2STD = standard co2 vol. mixing ratio (either 300 or 330 ppmv)
!   RATIO  = co2 vol. mixing ratio in units of the standard vol. 
!            mixing ratio (must lie between 0.5 and 4.0)
!   PREF   = reference pressure levels
!-----------------------------------------------------------------------
      Integer    ir,iq,npurp,nkkk,unit1,unit2,m,n,ntap
      Real       co2mix,ccomp
      Real, Dimension(4) :: cstd = (/ 0.5, 1.0, 2.0, 4.0 /)
!-----------------------------------------------------------------------
      Character(len=14), Dimension(3) :: files =  &
         (/ 'INPUT/cns_300_', 'INPUT/cns_330_', 'INPUT/cns_600_' /)
      Character(len=6), Dimension(4) :: bands =  &
        (/ '490850', '490670', '670850', '43um  ' /)
!-----------------------------------------------------------------------


!----- check input values -----

      If (ratio < 0.5 .or. ratio > 4.0)  Call Error_Mesg  &
       ('CO2_Data', 'ratio > 4.0 or ratio < 0.5', FATAL)

      co2mix=co2std*ratio

!-----------------------------------------------------------------------

      B0 = -.51926410E-4
      B1 = -.18113332E-3
      B2 = -.10680132E-5
      B3 = -.67303519E-7

!-----------------------------------------------------------------------
!---------- has this data been previously allocated ? ------------------

      If (Size(Pref,1) .ne. LP1) Then
         LP1=Size(Pref,1); LMAX=LP1-1

         If (Allocated(CDT51)) Then
            DeAllocate (CDT51, CO251, C2D51, CDT58, CO258, C2D58)
            DeAllocate (CDT31, CO231, C2D31, CDT38, CO238, C2D38)
            DeAllocate (CDT71, CO271, C2D71, CDT78, CO278, C2D78)
            DeAllocate (CO211, CO218, STEMP, GTEMP)
            DeAllocate (CDTM51, CO2M51, C2DM51, CDTM58, CO2M58, C2DM58)
         EndIf

!  ----- For the 560-800 cm-1 bandwidth -----

         Allocate (CDT51(LP1,LP1), CO251(LP1,LP1), C2D51(LP1,LP1),  &
                   CDT58(LP1,LP1), CO258(LP1,LP1), C2D58(LP1,LP1))

!  ----- For the 560-670 cm-1 bandwidth -----

         Allocate (CDT31(LP1), CO231(LP1), C2D31(LP1),  &
                   CDT38(LP1), CO238(LP1), C2D38(LP1))

!  ----- For the 670-800 cm-1 bandwidth -----

         Allocate (CDT71(LP1), CO271(LP1), C2D71(LP1),  &
                   CDT78(LP1), CO278(LP1), C2D78(LP1))

!  ----- For the 2270-2380 cm-1 bandwidth -----

         Allocate (CO211(LP1), CO218(LP1))

! ----- For the 560-800 cm-1 bandwidth -----

         Allocate (CDTM51(LMAX), CO2M51(LMAX), C2DM51(LMAX),  &
                   CDTM58(LMAX), CO2M58(LMAX), C2DM58(LMAX))

!  STEMP IS THE US STANDARD ATMOSPHERES,1976,AT N18 PRESSURES
!  WHERE PSTAR=1013.25 MB
!  THE WEIGHTING FUNCTION GTEMP=P(K)**0.2*(1.+P(K)/30000.)**0.8/
!  1013250.,WHERE P(K)=PRESSURE,N18 DATA LEVELS FOR PSTAR=
!  1013250.

         Allocate (STEMP(LP1), GTEMP(LP1))

      EndIf

!-----------------------------------------------------------------------
!---- compute profiles -----

      Call fs_profile (Pref,STEMP,GTEMP)

!-----------------------------------------------------------------------
!
!   Use one tape (no interpolation) if the mixing ratio is
!   sufficiently close to the standard value, also do not interpolate
!   if the mixing ratio is sufficiently close to multiples
!   (0.5,2.0,4.0) of the standard value
!
!-----------------------------------------------------------------------

      If (co2std <= 310.) Then
          m=1
      Else if (co2std >  310. .and. co2std <= 350.) Then
          m=2
      Else
          m=3
      EndIf

      Do n=1,4
         ccomp=abs(co2mix-cstd(n)*co2std)
         if (ccomp <= 1.0e-4) then
            ntap=1
            EXIT
         else
            ntap=2
         endif
      EndDo

!-----------------------------------------------------------------------
!        ir=1:  lbl transmissions over 490-850 cm-1
!        ir=2:  lbl transmissions over 490-670 cm-1
!        ir=3:  lbl transmissions over 670-850 cm-1
!        ir=4:  lbl transmissions over 2270-2380 cm-1
!-----------------------------------------------------------------------

      Do ir = 1,4

!-----------------------------------------------------------------------
!
!   read in indices npurp and nkkk.
!   for GCM radiation codes, the values to be used for
!   npurp and nkkk vary with ir as follows:
!     ir=1:   npurp=1,nkkk=3
!     ir=2:   npurp=3,nkkk=3
!     ir=3:   npurp=3,nkkk=3
!     ir=4:   npurp=3,nkkk=1
!
!   read in npurp, an index giving the kinds of interps
!   desired, according to the following values:
!     npurp=1: purpose 1 and purpose 2 calcs. for p(sfc)
!              of 1013.25 and 810.6 mb.
!     npurp=2: purpose 1 calcs. only
!     npurp=3: purpose 2 calcs. only
!   purposes 1 and 2 are explained in comments for subroutine co2int
!
!   read in nkkk, an index giving the no. of temp.'
!   profiles to be calculated. use the following values:'
!     nkkk=1: calculate only the (T0) profile'
!     nkkk=3: calculate the (T0,T+ and T-) profiles'
!             (normal case).'
!      note: if ir=4, nkkk must be 1'
!
!-----------------------------------------------------------------------

         Select Case (ir)
            Case (1)
               npurp=1; nkkk=3
            Case (2:3)
               npurp=3; nkkk=3
            Case (4)
               npurp=3; nkkk=1
         End Select

!-----------------------------------------------------------------------
!
!***open lbl co2 transmission functions pior to executing the interpol-
!   ation pgm. this will be user-dependent. additionally, it depends
!   on ir (freq. range) and on ratio (co2 amt). the files below 
!   assume that ratio lies between 1 and 2, and that the file and
!   directory names are as specified below.
!
!-----------------------------------------------------------------------

         If (ntap == 1) Then
            unit1 = open_file (file=files(m)//bands(ir), action='read')
            unit2 = 0
         EndIf

         If (ntap == 2) Then
            unit1 = open_file (file=files(1)//bands(ir), action='read')
            unit2 = open_file (file=files(3)//bands(ir), action='read')
         EndIf

!-----------------------------------------------------------------------
!----- interpolate co2 transmission fctns -----

         Call co2int (LMAX,ir,npurp,nkkk,unit1,unit2,ratio)  

!RSH     call close_file (unit1, status='keep') 
!RSH     If (ntap == 2) call close_file (unit2, status='keep')
         call close_file (unit1               ) 
         If (ntap == 2) call close_file (unit2               )

!-----------------------------------------------------------------------
!     Load transmission functions into data arrays


         If (ir == 1) Then
            iq=ir
            Call co2ins (LMAX,1,3,iq)
            Call co2in1 (LMAX,2,4,iq)
         Else
            iq=ir
            If (ir == 4) iq=5
            Call co2ins(LMAX,1,2,iq)
         EndIf

!-----------------------------------------------------------------------
      EndDo
!-----------------------------------------------------------------------

      End Subroutine CO2_Data

!#######################################################################

      Subroutine co2ins (nlev,itin,itin1,iq)

      Implicit None
!-----------------------------------------------------------------------
      Integer, Intent(IN) :: nlev,itin,itin1,iq

      Real, Dimension(nlev+1,nlev+1) :: DCDT8,DCDT10,CO2PO,CO2800,  &
                                        CO2PO1,CO2801,CO2PO2,CO2802,  &
                                        D2CT8,D2CT10

      Integer   i,j,L,LP1,JMAX
      Real      C1,C2
!-----------------------------------------------------------------------

      L=nlev
      LP1=L+1

      CO2PO (:,:)=TRNS(:,:,itin ,1)
      CO2800(:,:)=TRNS(:,:,itin1,1)
      If (iq >= 1 .and. iq <= 4) Then
         CO2PO1(:,:)=TRNS(:,:,itin ,2)
         CO2801(:,:)=TRNS(:,:,itin1,2)
         CO2PO2(:,:)=TRNS(:,:,itin ,3)
         CO2802(:,:)=TRNS(:,:,itin1,3)
      EndIf

!-----------------------------------------------------------------------
!   THE FOLLOWING CODE IS REWRITTEN SO THAT THE RADIATIVE BANDS ARE: 
!
!        iq=1    560-800     (CONSOL.=490-850)
!        iq=2    560-670     (CONSOL.=490-670)
!        iq=3    670-800     (CONSOL.=670-850)
!        iq=4    560-760 (ORIGINAL CODE)   (CONSOL.=490-850)
!        iq=5   2270-2380     CONSOL=2270-2380
!
!  THE FOLLOWING LOOP OBTAINS TRANSMISSION FUNCTIONS FOR BANDS
!  USED IN RADIATIVE MODEL CALCULATIONS,WITH THE EQUIVALENT
!  WIDTHS KEPT FROM THE ORIGINAL CONSOLIDATED CO2 TF'S.
!      NOTE: ALTHOUGH THE BAND TRANSMISSION FUNCTIONS ARE
!  COMPUTED FOR ALL RADIATIVE BANDS, AS OF 9/28/88, THEY
!  ARE WRITTEN OUT IN FULL ONLY FOR THE FULL 15 UM BAND CASES
!  (iq=1,4).  IN OTHER CASES, THE TRANSMISSIVITIES (1,K) ARE
!  WRITTEN OUT, AS THESE ARE THE ONLY ONES NEEDED FOR CTS
!  CALCULATIONS.  ALSO, FOR THE 4.3 UM BAND (iq=5) THE TEMP.
!  DERIVATIVE TERMS ARE NOT WRITTEN OUT, AS THEY ARE UNUSED.
!-----------------------------------------------------------------------

      If (iq == 1) Then
         C1=1.5
         C2=0.5
         JMAX=LP1
      EndIf
      If (iq == 2) Then
        C1=18./11.
        C2=7./11.
        JMAX=1
      EndIf
      If (iq == 3) Then
        C1=18./13.
        C2=5./13.
        JMAX=1
      EndIf
      If (iq == 4) Then
        C1=1.8
        C2=0.8
        JMAX=LP1
      EndIf
      If (iq == 5) Then
        C1=1.0
        C2=0.0
        JMAX=1
      EndIf

      Do i=1,LP1
      Do j=1,LP1
         CO2PO(j,i)=C1*CO2PO(j,i)-C2
         CO2800(j,i)=C1*CO2800(j,i)-C2
      EndDo
      EndDo

      If (iq >= 1 .and. iq <= 4) Then
        Do i=1,LP1
        Do j=1,LP1
          CO2PO1(j,i)=C1*CO2PO1(j,i)-C2
          CO2801(j,i)=C1*CO2801(j,i)-C2
          CO2PO2(j,i)=C1*CO2PO2(j,i)-C2
          CO2802(j,i)=C1*CO2802(j,i)-C2
        EndDo
        EndDo
        Do j=1,LP1
        Do i=1,LP1
         DCDT8(i,j)=.02*(CO2801(i,j)-CO2802(i,j))*100.
         DCDT10(i,j)=.02*(CO2PO1(i,j)-CO2PO2(i,j))*100.
         D2CT8(i,j)=.0016*(CO2801(i,j)+CO2802(i,j)-2.*CO2800(i,j))*1000.
         D2CT10(i,j)=.0016*(CO2PO1(i,j)+CO2PO2(i,j)-2.*CO2PO(i,j))*1000.
        EndDo
        EndDo
      EndIf

!-----------------------------------------------------------------------
      If (iq == 1) Then
         CDT51=DCDT10
         CO251=CO2PO
         C2D51=D2CT10
         CDT58=DCDT8
         CO258=CO2800
         C2D58=D2CT8
      EndIf
!-----------------------------------------------------------------------
      If (iq == 2) Then
         CDT31=DCDT10(1,:)
         CO231=CO2PO (1,:)
         C2D31=D2CT10(1,:)
         CDT38=DCDT8 (1,:)
         CO238=CO2800(1,:)
         C2D38=D2CT8 (1,:)
      EndIf
!-----------------------------------------------------------------------
      If (iq == 3) Then
         CDT71=DCDT10(1,:)
         CO271=CO2PO (1,:)
         C2D71=D2CT10(1,:)
         CDT78=DCDT8 (1,:)
         CO278=CO2800(1,:)
         C2D78=D2CT8 (1,:)
      EndIf
!-----------------------------------------------------------------------
      If (iq == 4) Then
         Call Error_Mesg ('co2ins', 'iq cannot equal 4', FATAL)
      EndIf
!-----------------------------------------------------------------------
      If (iq == 5) Then
         CO211=CO2PO (1,:)
         CO218=CO2800(1,:)
      EndIf
!-----------------------------------------------------------------------

      End Subroutine co2ins

!#######################################################################

      Subroutine co2in1 (nlev,itin,itin1,iq)

      Implicit None
!-----------------------------------------------------------------------
!
!                       CO2INS FOR METHOD 1
!
!-----------------------------------------------------------------------

      Integer, Intent(IN)    :: nlev,itin,itin1,iq

      Real,   Dimension(nlev+1,nlev+1) :: DCDT8,DCDT10,CO2PO,CO2800,   &
                                          CO2PO1,CO2801,CO2PO2,CO2802, &
                                          D2CT8,D2CT10

      Integer  L,LP1,i,j
      Real     C1,C2
!-----------------------------------------------------------------------

      L=nlev
      LP1=L+1

      CO2PO (:,:)=TRNS(:,:,itin ,1)
      CO2800(:,:)=TRNS(:,:,itin1,1)
      If (IQ >= 1 .and. IQ <= 4) Then
         CO2PO1(:,:)=TRNS(:,:,itin ,2)
         CO2801(:,:)=TRNS(:,:,itin1,2)
         CO2PO2(:,:)=TRNS(:,:,itin ,3)
         CO2802(:,:)=TRNS(:,:,itin1,3)
      EndIf

!-----------------------------------------------------------------------
!   THE FOLLOWING CODE IS REWRITTEN SO THAT THE RADIATIVE BANDS ARE:
!
!        iq=1    560-800     (CONSOL.=490-850)
!        iq=2    560-670     (CONSOL.=490-670)
!        iq=3    670-800     (CONSOL.=670-850)
!        iq=4    560-760 (ORIGINAL CODE)   (CONSOL.=490-850)
!        iq=5   2270-2380     CONSOL=2270-2380
!
!  THE FOLLOWING LOOP OBTAINS TRANSMISSION FUNCTIONS FOR BANDS
!  USED IN RADIATIVE MODEL CALCULATIONS,WITH THE EQUIVALENT
!  WIDTHS KEPT FROM THE ORIGRNAL CONSOLIDATED CO2 TF'S.
!-----------------------------------------------------------------------

      If (iq == 1) Then
         C1=1.5
         C2=0.5
      EndIf
      If (iq == 2) Then
        C1=18./11.
        C2=7./11.
      EndIf
      If (iq == 3) Then
        C1=18./13.
        C2=5./13.
      EndIf
      If (iq == 4) Then
        C1=1.8
        C2=0.8
      EndIf
      If (iq == 5) Then
        C1=1.0
        C2=0.0
      EndIf

      Do i=1,LP1
      Do j=1,LP1
         CO2PO(j,i)=C1*CO2PO(j,i)-C2
         CO2800(j,i)=C1*CO2800(j,i)-C2
      EndDo
      EndDo

      If (iq >= 1 .and. iq <= 4) Then
        Do i=1,LP1
        Do j=1,LP1
         CO2PO1(j,i)=C1*CO2PO1(j,i)-C2
         CO2801(j,i)=C1*CO2801(j,i)-C2
         CO2PO2(j,i)=C1*CO2PO2(j,i)-C2
         CO2802(j,i)=C1*CO2802(j,i)-C2
        EndDo
        EndDo

        Do j=1,LP1
        Do i=1,LP1
         DCDT8(i,j)=.02*(CO2801(i,j)-CO2802(i,j))*100.
         DCDT10(i,j)=.02*(CO2PO1(i,j)-CO2PO2(i,j))*100.
         D2CT8(i,j)=.0016*(CO2801(i,j)+CO2802(i,j)-2.*CO2800(i,j))*1000.
         D2CT10(i,j)=.0016*(CO2PO1(i,j)+CO2PO2(i,j)-2.*CO2PO(i,j))*1000.
        EndDo
        EndDo
      EndIf

!-----------------------------------------------------------------------
      If (iq == 1) Then
         Do i=1,nlev
            CDTM51(i)=DCDT10(i,i+1)
            CO2M51(i)=CO2PO (i,i+1)
            C2DM51(i)=D2CT10(i,i+1)
            CDTM58(i)=DCDT8 (i,i+1)
            CO2M58(i)=CO2800(i,i+1)
            C2DM58(i)=D2CT8 (i,i+1)
         EndDo
      EndIf
!-----------------------------------------------------------------------

      End Subroutine co2in1

!#######################################################################

      Subroutine Write_CO2_Data

      Implicit None
!-----------------------------------------------------------------------
      Integer  i,k,nlev,nlevp1,unit
!-----------------------------------------------------------------------

      nlevp1=Size(CDT51,1); nlev=nlevp1-1

      unit = open_file (file='co2data', action='write')

      Do k=1,nlevp1; Write (unit,101) (CDT51(i,k),i=1,nlevp1); EndDo
      Do k=1,nlevp1; Write (unit,101) (CO251(i,k),i=1,nlevp1); EndDo
      Do k=1,nlevp1; Write (unit,101) (C2D51(i,k),i=1,nlevp1); EndDo
      Do k=1,nlevp1; Write (unit,101) (CDT58(i,k),i=1,nlevp1); EndDo
      Do k=1,nlevp1; Write (unit,101) (CO258(i,k),i=1,nlevp1); EndDo
      Do k=1,nlevp1; Write (unit,101) (C2D58(i,k),i=1,nlevp1); EndDo

                     Write (unit,101) (CDT31(i),i=1,nlevp1)
                     Write (unit,101) (CO231(i),i=1,nlevp1)
                     Write (unit,101) (C2D31(i),i=1,nlevp1)
                     Write (unit,101) (CDT38(i),i=1,nlevp1)
                     Write (unit,101) (CO238(i),i=1,nlevp1)
                     Write (unit,101) (C2D38(i),i=1,nlevp1)

                     Write (unit,101) (CDT71(i),i=1,nlevp1)
                     Write (unit,101) (CO271(i),i=1,nlevp1)
                     Write (unit,101) (C2D71(i),i=1,nlevp1)
                     Write (unit,101) (CDT78(i),i=1,nlevp1)
                     Write (unit,101) (CO278(i),i=1,nlevp1)
                     Write (unit,101) (C2D78(i),i=1,nlevp1)

                     Write (unit,101) (CO211(i),i=1,nlevp1)
                     Write (unit,101) (CO218(i),i=1,nlevp1)

                     Write (unit,101) (CDTM51(i),i=1,nlev)
                     Write (unit,101) (CO2M51(i),i=1,nlev)
                     Write (unit,101) (C2DM51(i),i=1,nlev)
                     Write (unit,101) (CDTM58(i),i=1,nlev)
                     Write (unit,101) (CO2M58(i),i=1,nlev)
                     Write (unit,101) (C2DM58(i),i=1,nlev)

                     Write (unit,102) (STEMP(i),i=1,nlevp1)
                     Write (unit,103) (GTEMP(i),i=1,nlevp1)

                     call close_file (unit)

 101  Format (6F12.8)
 102  Format (5F13.6)
 103  Format (4E16.9)
!-----------------------------------------------------------------------

      End Subroutine Write_CO2_Data

!#######################################################################

      Subroutine Read_CO2_Data (nlev)

      Implicit None
!-----------------------------------------------------------------------
!     Reads co2 transmission functions from file = INPUT/CO2.data
!-----------------------------------------------------------------------
      Integer, Intent(IN) :: nlev
      Integer  unit,nlevp1,i,k
!-----------------------------------------------------------------------

      If (Allocated(CDT51)) Call Error_Mesg ('Read_CO2_Data',  &
                          'CO2 data has already been allocated.', FATAL)

      nlevp1=nlev+1
      unit = open_file (file='INPUT/CO2.data', action='read')

!   B0,B1,B2,B3 ARE COEFFICIENTS USED TO CORRECT FOR THE USE OF 250K IN
!   THE PLANCK FUNCTION USED IN EVALUATING PLANCK-WEIGHTED CO2
!   TRANSMISSION FUNCTIONS. 


      B0 = -.51926410E-4
      B1 = -.18113332E-3
      B2 = -.10680132E-5
      B3 = -.67303519E-7

 101  Format (6f12.8)
 102  Format (5f13.6)
 103  Format (4f16.9)

!  ----- For the 560-800 cm-1 bandwidth -----

      Allocate (CDT51(nlevp1,nlevp1))
      Allocate (CO251(nlevp1,nlevp1))
      Allocate (C2D51(nlevp1,nlevp1))
      Allocate (CDT58(nlevp1,nlevp1))
      Allocate (CO258(nlevp1,nlevp1))
      Allocate (C2D58(nlevp1,nlevp1))

      Do k=1,nlevp1
        Read (unit,101) (CDT51(i,k),i=1,nlevp1)
      EndDo

      Do k=1,nlevp1
        Read (unit,101) (CO251(i,k),i=1,nlevp1)
      EndDo

      Do k=1,nlevp1
        Read (unit,101) (C2D51(i,k),i=1,nlevp1)
      EndDo

      Do k=1,nlevp1
        Read (unit,101) (CDT58(i,k),i=1,nlevp1)
      EndDo

      Do k=1,nlevp1
        Read (unit,101) (CO258(i,k),i=1,nlevp1)
      EndDo

      Do k=1,nlevp1
        Read (unit,101) (C2D58(i,k),i=1,nlevp1)
      EndDo


!  ----- For the 560-670 cm-1 bandwidth -----

      Allocate (CDT31(nlevp1))
      Allocate (CO231(nlevp1))
      Allocate (C2D31(nlevp1))
      Allocate (CDT38(nlevp1))
      Allocate (CO238(nlevp1))
      Allocate (C2D38(nlevp1))

      Read (unit,101) (CDT31(i),i=1,nlevp1)
      Read (unit,101) (CO231(i),i=1,nlevp1)
      Read (unit,101) (C2D31(i),i=1,nlevp1)
      Read (unit,101) (CDT38(i),i=1,nlevp1)
      Read (unit,101) (CO238(i),i=1,nlevp1)
      Read (unit,101) (C2D38(i),i=1,nlevp1)


!  ----- For the 670-800 cm-1 bandwidth -----

      Allocate (CDT71(nlevp1))
      Allocate (CO271(nlevp1))
      Allocate (C2D71(nlevp1))
      Allocate (CDT78(nlevp1))
      Allocate (CO278(nlevp1))
      Allocate (C2D78(nlevp1))

      Read (unit,101) (CDT71(i),i=1,nlevp1)
      Read (unit,101) (CO271(i),i=1,nlevp1)
      Read (unit,101) (C2D71(i),i=1,nlevp1)
      Read (unit,101) (CDT78(i),i=1,nlevp1)
      Read (unit,101) (CO278(i),i=1,nlevp1)
      Read (unit,101) (C2D78(i),i=1,nlevp1)


!  ----- For the 2270-2380 cm-1 bandwidth -----

      Allocate (CO211(nlevp1))
      Allocate (CO218(nlevp1))

      Read (unit,101) (CO211(i),i=1,nlevp1)
      Read (unit,101) (CO218(i),i=1,nlevp1)


! ----- For the 560-800 cm-1 bandwidth -----

      Allocate (CDTM51(nlev))
      Allocate (CO2M51(nlev))
      Allocate (C2DM51(nlev))
      Allocate (CDTM58(nlev))
      Allocate (CO2M58(nlev))
      Allocate (C2DM58(nlev))

      Read (unit,101) (CDTM51(i),i=1,nlev)
      Read (unit,101) (CO2M51(i),i=1,nlev)
      Read (unit,101) (C2DM51(i),i=1,nlev)
      Read (unit,101) (CDTM58(i),i=1,nlev)
      Read (unit,101) (CO2M58(i),i=1,nlev)
      Read (unit,101) (C2DM58(i),i=1,nlev)


!  STEMP IS THE US STANDARD ATMOSPHERES,1976,AT N18 PRESSURES
!  WHERE PSTAR=1013.25 MB

      Allocate (STEMP(nlevp1))

      Read (unit,102) (STEMP(i),i=1,nlevp1)


!  THE WEIGHTING FUNCTION GTEMP=P(K)**0.2*(1.+P(K)/30000.)**0.8/
!  1013250.,WHERE P(K)=PRESSURE,N18 DATA LEVELS FOR PSTAR=
!  1013250.

      Allocate (GTEMP(nlevp1))

      Read (unit,103) (GTEMP(i),i=1,nlevp1)


      call close_file (unit)

!-----------------------------------------------------------------------

      End Subroutine Read_CO2_Data

!#######################################################################

      Subroutine co2_data_init
!------- write version number and namelist ---------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
      endif

      module_is_initialized = .true.

!---------------------------------------------------------------------
      End Subroutine co2_data_init

!#######################################################################

      Subroutine co2_data_end

      module_is_initialized = .false.

!---------------------------------------------------------------------

      End Subroutine co2_data_end

!#######################################################################


      End Module CO2_Data_Mod

program ocean_grid_generator
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">Z. Liang </CONTACT>
  ! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">S. M. Griffies</REVIEWER>

  !<OVERVIEW>
  !  Generate a grid specification data file for ocean.
  !</OVERVIEW>

  !<DESCRIPTION>
  !  This program can generate horizontal grid, vertical grid or grids with topography and land/sea mask. .
  !  The namelist option grid_type control the type of grid created. when grid_type equal
  !  <PRE>
  ! 1. "hgrid": only horizontal grid will be created.
  ! 2. "vgrid": only vertical grid will be created
  ! 4. "hgrid_topog" : horizontal grid, topography and land/sea mask will be created. 
  !    Topography is obtained by remapping onto current grid from some topography source data. 
  !    land/sea mask is determined by the topography. In this case, topography does not depend 
  !    on vertical grid and no vertical grid will be created. You need to set topog_depend_on_vgrid of 
  !    topog_nml to .false. .
  ! 5. "hgrid_vgrid_topog": horizontal grid, vertical grid, topography and land/sea mask 
  !    will be created. The topography is mom4-specific topography (could be idealized or from 
  !    some source file), which depends on vertical grid. The land/sea mask is determined by 
  !    topography. In this case, you need to set topog_depend_on_vgrid of topog_nml to .true. .
  !  </PRE>
  !</DESCRIPTION>
  use fms_mod,        only : check_nml_error, open_namelist_file, close_file, stdout
  use fms_mod,        only : write_version_number, fms_init, fms_end, file_exist
  use mpp_mod,        only : mpp_pe, mpp_root_pe, mpp_error, FATAL
  use mpp_io_mod,     only : mpp_open, MPP_OVERWR, MPP_NETCDF, MPP_SINGLE, axistype
  use grids_type_mod, only : hgrid_data_type, vgrid_data_type, topog_data_type
  use hgrid_mod,      only : generate_hgrid, hgrid_init, hgrid_end, write_hgrid_global_meta 
  use hgrid_mod,      only : write_hgrid_field_meta, write_hgrid_data
  use vgrid_mod,      only : generate_vgrid, vgrid_init, vgrid_end, write_vgrid_meta, write_vgrid_data
  use topog_mod,      only : generate_topog, topog_init, topog_end, write_topog_global_meta
  use topog_mod,      only : write_topog_field_meta, write_topog_data
  use constants_mod,  only : constants_init

  implicit none

  character(len=128) :: version= '$Id: ocean_grid_generator.f90,v 13.0 2006/03/28 21:44:58 fms Exp $'
  character(len=128) :: tagname='$Name: tikal $'

  type(hgrid_data_type) :: Hgrid
  type(vgrid_data_type) :: Vgrid
  type(topog_data_type) :: Topog
  integer               :: unit, ierr, io

  !--- namelist interface
  character(len=128) :: output_file = "ocean_grid.nc"
  character(len=64)  :: grid_type   = "hgrid_vgrid_topog"
  !
  !<NAMELIST NAME="ocean_grid_generator_nml">
  !<DATA NAME="grid_type" TYPE="character(len=64)">
  !  Control the type of grid will be created. Its value can be hgrid, vgrid, hgrid_mask, 
  !  hgrid_topog_mask, hgrid_vgrid_topog_mask. Default value is hgrid_vgrid_topog. 
  !  See module description for details.
  !</DATA>
  !<DATA NAME="output_file" TYPE="character(len=128)">
  !  name of grid file to be created. Default value is "ocean_grid.nc".
  !</DATA>
  !</NAMELIST>
  namelist / ocean_grid_generator_nml / output_file, grid_type
  !---------------------------------------------------------------------------

  call fms_init()
  call constants_init()

  if (file_exist('input.nml')) then
     unit = open_namelist_file()
     ierr=1
     do while (ierr /= 0)
        read(unit, nml=ocean_grid_generator_nml, iostat=io, end=10)
        ierr = check_nml_error(io, 'ocean_grid_generator_nml')
     enddo
10   call close_file(unit)
  else
     call mpp_error(FATAL,'ocean_grid_generator: file input.nml does not exist')
  endif

  call write_version_number(version, tagname)
  if (mpp_pe() == mpp_root_pe()) write(stdout(), nml=ocean_grid_generator_nml)

  !--- generate data ---------------------------------------------------
  select case(trim(grid_type))
  case ('hgrid')
     call hgrid_init
     call generate_hgrid(Hgrid)
  case ('vgrid')
     call vgrid_init
     call generate_vgrid(Vgrid)
  case ('hgrid_topog')
     call hgrid_init
     call generate_hgrid(Hgrid)
     call topog_init(Topog, Hgrid)
     call generate_topog(Topog, Hgrid)
  case ('hgrid_vgrid_topog')
     call hgrid_init
     call generate_hgrid(Hgrid)
     call vgrid_init
     call generate_vgrid(Vgrid)
     call topog_init(Topog, Hgrid)
     call generate_topog(Topog, Hgrid, Vgrid)
  case default
     call mpp_error(FATAL, 'ocean_grid_generator: '//trim(grid_type)//' is not a valid option of nml "grid_type"')
  end select

  !--- write out data-----------------------------------------------------

  !--- write meta
  select case(trim(grid_type))
  case ('hgrid')
     call write_hgrid_global_meta(output_file)
     call write_hgrid_field_meta(output_file)
     call write_hgrid_data(output_file, Hgrid)
  case ('vgrid') 
     call write_vgrid_meta(output_file, Vgrid)
     call write_vgrid_data(output_file)
  case ('hgrid_topog')
     call write_hgrid_global_meta(output_file)
     call write_topog_global_meta(output_file)
     call write_hgrid_field_meta(output_file)
     call write_topog_field_meta(output_file)
     call write_hgrid_data(output_file, Hgrid)
     call write_topog_data(output_file, Topog)
  case ('hgrid_vgrid_topog')
     call write_hgrid_global_meta(output_file)
     call write_topog_global_meta(output_file)
     call write_vgrid_meta(output_file, Vgrid)
     call write_hgrid_field_meta(output_file)
     call write_topog_field_meta(output_file)
     call write_vgrid_data(output_file)
     call write_hgrid_data(output_file, Hgrid)
     call write_topog_data(output_file, Topog)
  end select

  !--- release the memory
  if(trim(grid_type) .ne. 'vgrid') call hgrid_end(Hgrid)
  if(trim(grid_type) .eq. 'vgrid' .or. (trim(grid_type) .eq. 'hgrid_vgrid_topog' )) &
       call vgrid_end(Vgrid)
  if(trim(grid_type) .eq. 'hgrid_topog' .or. trim(grid_type) .eq.'hgrid_vgrid_topog')  &
       call topog_end(Topog)

  call fms_end()

end program ocean_grid_generator

module ocean_lapgen_friction_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S. M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! This module computes the thickness weighted time tendency for  
! horizontal velocity arising from horizontal Laplacian friction. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes the thickness weighted time tendency for
! horizontal velocity arising from horizontal Laplacian friction. 
! The viscosity used to determine the strength of the tendency 
! can be a general function of space and time as specified by 
! the Smagorinsky approach as well as a grid-scale dependent
! background viscosity.  The form of the friction operator 
! can be isotropic or anisotropic in the horizontal plane. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies and R.W. Hallberg, 2000: 
! Biharmonic friction with a Smagorinsky viscosity for use in large-scale
! eddy-permitting ocean models
! Monthly Weather Review, vol. 128, pages 2935-2946
! </REFERENCE>
!
! <REFERENCE>
! R. D. Smith and J. C. McWilliams, 2003:
! Anisotropic horizontal viscosity for ocean models,
! Ocean Modelling, vol. 5, pages 129-156.
! </REFERENCE>
!
! <REFERENCE>
! Maltrud and Holloway, 2008: Implementing biharmonic neptune in a
! global eddying ocean model, Ocean Modelling, vol. 21, pages 22-34.
! </REFERENCE>
!
! <REFERENCE>
! Deremble, Hogg, Berloff, and Dewar, 2011:
! On the application of no-slip lateral boundary conditions to coarsely
! resolved ocean models, Ocean Modelling. 
! </REFERENCE>
!
! <REFERENCE>
! Griffies: Elements of MOM (2012)
! </REFERENCE>
!
! <NOTE>
! The ocean model can generally run with both Laplacian and biharmonic friction
! enabled at the same time.  Such has been found useful for some eddying 
! ocean simulations. 
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_lapgen_friction_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is false.
!  </DATA>
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging by printing checksums.  
!  </DATA> 
!
!  <DATA NAME="viscosity_scale_by_rossby" TYPE="logical">
!  To scale down the laplacian viscosity according to the relative scale of the 
!  horizontal grid and the first baroclinic Rossby radius. This is a useful 
!  scheme for models that resolve the Rossby radius in the lower latitudes, and so
!  presumably do not wish to have much laplacian friction, whereas the higher latitudes
!  need more friction.  Default viscosity_scale_by_rossby=.false.
!  </DATA> 
!
!  <DATA NAME="viscosity_scale_by_rossby_power" TYPE="real">
!  The power used to determine the viscosity scaling function. 
!  Default viscosity_scale_by_rossby_power=2.0.
!  </DATA> 
!
!  <DATA NAME="divergence_damp" TYPE="logical">
!  To damp the divergence field.  
!  </DATA> 
!  <DATA NAME="divergence_damp_vel_micom" TYPE="real" UNITS="m/s">
!  Velocity scale to set the viscosity used with divergence damping. 
!  </DATA> 
!
!  <DATA NAME="k_smag_iso" UNITS="dimensionless" TYPE="real">
!  This is the dimensionless Smagorinsky coefficient used to set the scale 
!  of the Smagorinsky isotropic viscosity. 
!  </DATA> 
!  <DATA NAME="k_smag_aniso" UNITS="dimensionless" TYPE="real">
!  This is the dimensionless Smagorinsky coefficient used to set the scale 
!  of the Smagorinsky anisotropic viscosity. 
!  </DATA> 
!  <DATA NAME="viscosity_ncar" TYPE="logical">
!  Anisotropic background viscosities used by NCAR. 
!  </DATA> 
!  <DATA NAME="viscosity_ncar_2000" TYPE="logical">
!  Anisotropic background viscosities used by NCAR, using the 
!  formulation as of 2000.  Default viscosity_ncar_2000=.true.
!  </DATA> 
!  <DATA NAME="viscosity_ncar_2007" TYPE="logical">
!  Anisotropic background viscosities used by NCAR, using the 
!  formulation as of 2007.  Default viscosity_ncar_2007=.false.
!  </DATA> 
!  <DATA NAME="vel_micom_iso" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM isotropic viscosity. 
!  </DATA> 
!  <DATA NAME="vel_micom_aniso" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM anisotropic viscosity. 
!  </DATA> 
!
!  <DATA NAME="equatorial_zonal" TYPE="logical">
!  Orient the anisotropic friction within a latitudinal band according to zonal direction. 
!  </DATA> 
!  <DATA NAME="equatorial_zonal_lat" TYPE="real">
!  Latitudinal band to use the zonal friction orientation. 
!  </DATA> 
!  <DATA NAME="ncar_isotropic_off_equator" TYPE="logical">
!  Polewards of equatorial_zonal_lat, revert NCAR scheme to isotropic 
!  </DATA> 
!  <DATA NAME="equatorial_no_smag" TYPE="logical">
!  Turn smag off within equatorial_zonal_lat region. 
!  </DATA> 
!  <DATA NAME="eq_vel_micom_iso" TYPE="real">
!  Velocity scale that is used for computing the MICOM isotropic viscosity within
!  a user specified equatorial band. 
!  </DATA> 
!  <DATA NAME="eq_vel_micom_aniso" TYPE="real">
!  Velocity scale that is used for computing the MICOM anisotropic viscosity within
!  a user specified equatorial band. 
!  </DATA> 
!  <DATA NAME="eq_lat_micom" TYPE="real">
!  Equatorial latitude band (degrees) within which the MICOM viscosity is set according 
!  to eq_vel_micom_iso and eq_vel_micom_aniso.
!  </DATA> 
!
!  <DATA NAME="restrict_polar_visc" TYPE="logical">
!  For restricting the background viscosity poleward of a 
!  latitude.  This method may be useful for coupling to an ice model
!  in which case the horizontal viscosity may need to be a bit 
!  smaller to maintain time step constraints.  This is because the 
!  effective friction is larger than that just within the ocean.  
!  </DATA> 
!  <DATA NAME="restrict_polar_visc_lat" TYPE="real">
!  Latitude poleward of which we restrict the viscosity.
!  </DATA> 
!  <DATA NAME="restrict_polar_visc_ratio" TYPE="real">
!  Ratio of the normal critical value that we limit the 
!  viscosity to be no greater than.  If restrict_polar_visc_ratio=1.0
!  then there is no special limitation of the viscosity beyond that 
!  of the one-dimensional stability constraint.  
!  </DATA> 
!
!  <DATA NAME="bottom_5point" TYPE="logical">
!  To alleviate problems with small partial cells, it is often necessary to reduce the 
!  operator to the traditional 5-point Laplacian at the ocean bottom.  This logical 
!  implements this mixing. Default bottom_5point=.false.
!  </DATA> 
!
!  <DATA NAME="neptune" TYPE="logical">
!  Set to true for computing friction relative to Neptune barotropic velocity. 
!  Default neptune=.false. 
!  </DATA> 
!  <DATA NAME="neptune_length_eq" UNITS="m" TYPE="real">
!  Length scale used to compute Neptune velocity at equator.  
!  </DATA> 
!  <DATA NAME="neptune_length_pole" UNITS="m" TYPE="real">
!  Length scale used to compute Neptune velocity at pole. 
!  </DATA> 
!  <DATA NAME="neptune_depth_min" UNITS="m" TYPE="real">
!  Minimum depth scale used for computing Neptune velocity.
!  Default neptune_depth_min=100.0
!  </DATA> 
!  <DATA NAME="neptune_smooth" TYPE="logical">
!  For doing a horizontal 1-2-1 smoothing on the diagnosed  
!  neptune velocity scale. 
!  Default neptune_smooth=.true.
!  </DATA> 
!  <DATA NAME="neptune_smooth_num" TYPE="integer">
!  Number of smoothing passes for neptune velocity.
!  Default neptune_smooth_num=1.
!  </DATA> 
!
!  <DATA NAME="vconst_1" UNITS="cm^2/sec" TYPE="real">
!  Background viscosity for NCAR algorithm.
!  </DATA> 
!  <DATA NAME="vconst_2" TYPE="real">
!  For NCAR viscosity algorithm.
!  </DATA> 
!  <DATA NAME="vconst_3" TYPE="real">
!  For NCAR viscosity algorithm.
!  </DATA> 
!  <DATA NAME="vconst_4" UNITS="1/cm" TYPE="real">
!  For NCAR viscosity algorithm.
!  </DATA> 
!  <DATA NAME="vconst_5" TYPE="integer">
!  For NCAR viscosity algorithm.
!  </DATA> 
!  <DATA NAME="vconst_6" UNITS="cm^2/sec" TYPE="real">
!  For NCAR viscosity algorithm.
!  </DATA> 
!  <DATA NAME="vconst_7" UNITS="cm/sec">
!  For NCAR viscosity algorithm.
!  </DATA> 
!  <DATA NAME="vconst_8" UNITS="degrees">
!  For NCAR viscosity algorithm.
!  </DATA> 
!  <DATA NAME="visc_vel_scale_length" UNITS="cm">
!  For NCAR viscosity algorithm: efolding depth for 
!  depth dependent background viscosity.  
!  Default visc_vel_scale_length=1500.e2 cm
!  </DATA> 
!  <DATA NAME="ncar_isotropic_at_depth" TYPE="logical">
!  Sets the NCAR scheme to be isotropic beneath a chosen depth.
!  </DATA> 
!  <DATA NAME="ncar_isotropic_depth" TYPE="real" UNITS="m">
!  Sets the NCAR scheme to be isotropic beneath this chosen depth.
!  </DATA> 
!  <DATA NAME="ncar_isotropic_at_depth_visc" TYPE="real" UNITS="m2/sec">
!  Sets the NCAR scheme to be isotropic beneath this chosen depth, with 
!  minimum viscosity set according to this value. 
!  </DATA> 
!  <DATA NAME="debug_ncar_A" TYPE="logical">
!  Sets f_perp=f_para for debugging purposes with the NCAR scheme.
!  </DATA> 
!  <DATA NAME="debug_ncar_B" TYPE="logical">
!  Sets f_para=f_perp for debugging purposes with the NCAR scheme.
!  </DATA> 
!
!  <DATA NAME="use_side_drag_friction" TYPE="logical">
!  For converting friction at U-cells next to walls into 
!  a drag law, as per Deremble et al. Use cdbot_array
!  from ocean_core/ocean_bbc.F90 to compute drag force. 
!  Default use_side_drag_friction=.false.
!  </DATA> 
!  <DATA NAME="side_drag_friction_scaling" TYPE="real">
!  Dimensionless scaling used for cdbot_array when setting
!  side drag friction. So the effective side dragy coefficient
!  is side_drag_friction_scaling*cdbot_array.  
!  Default side_drag_friction_scaling=1.0.
!  </DATA> 
!  <DATA NAME="side_drag_friction_uvmag_max" UNITS="m/s" TYPE="real">
!  Maximum magnitude of horizontal velocity used to compute the 
!  side drag friction. This parameter can be useful especially
!  for pressure models where the bottom cells can be quite thin 
!  and subject to sporadic large magnitudes.  We do the same thing with 
!  bottom drag calculations. 
!  Default side_drag_friction_uvmag_max=10.0.
!  </DATA> 
!  <DATA NAME="side_drag_friction_max" UNITS="N/m^2" TYPE="real">
!  Maximum magnitude of the side drag induced friction. 
!  This parameter can be useful especially for pressure models 
!  where the bottom cells can be quite thin and subject to sporadic
!  large magnitudes.  We do the same thing with bottom drag calculations. 
!  Default side_drag_friction_max=1.0.
!  </DATA> 
!
!</NAMELIST>

use constants_mod,    only: pi, radius, epsln, radian
use diag_manager_mod, only: register_diag_field, register_static_field
use fms_mod,          only: open_namelist_file, check_nml_error, write_version_number, close_file
use mpp_domains_mod,  only: mpp_update_domains, BGRID_NE, mpp_global_field, XUPDATE 
use mpp_domains_mod,  only: mpp_start_update_domains, mpp_complete_update_domains
use mpp_mod,          only: input_nml_file, mpp_sum, mpp_pe, mpp_error, mpp_max
use mpp_mod,          only: FATAL, NOTE, stdout, stdlog

use ocean_domains_mod,    only: get_local_indices
use ocean_obc_mod,        only: ocean_obc_enhance_visc_back
use ocean_operators_mod,  only: BAY, BAX, BDX_EU, BDY_NU, FDX_U, FDY_U, FMX, FMY
use ocean_operators_mod,  only: FAY, FAX, FDX_NT, FDY_ET, FDX_T, FDY_T 
use ocean_parameters_mod, only: missing_value, omega_earth, rho0
use ocean_types_mod,      only: ocean_time_type, ocean_grid_type
use ocean_types_mod,      only: ocean_domain_type, ocean_adv_vel_type 
use ocean_types_mod,      only: ocean_thickness_type, ocean_velocity_type
use ocean_types_mod,      only: ocean_options_type
use ocean_util_mod,       only: write_timestamp, diagnose_2d_u, diagnose_3d_u, diagnose_2d, write_chksum_3d
use ocean_workspace_mod,  only: wrk1, wrk2, wrk1_2d, wrk1_v, wrk2_v, wrk3_v, wrk1_v2d  

implicit none

private

public ocean_lapgen_friction_init
public lapgen_friction
public lapgen_viscosity_check
public lapgen_reynolds_check

private BDX_EU_smag
private BDY_NU_smag
private compute_neptune_velocity

! length of forward time step  
real :: dtime

! for diagnostics 
integer :: id_aiso                 =-1
integer :: id_aaniso               =-1
integer :: id_along_back           =-1
integer :: id_across_back          =-1
integer :: id_aiso_diverge         =-1
integer :: id_neptune_lap_u        =-1
integer :: id_neptune_lap_v        =-1
integer :: id_neptune_psi          =-1
integer :: id_neptune_ft           =-1
integer :: id_along                =-1
integer :: id_across               =-1
integer :: id_visc_crit_lap        =-1
integer :: id_lap_fric_u           =-1
integer :: id_lap_fric_v           =-1
integer :: id_horz_lap_diss        =-1
integer :: id_viscosity_scaling    =-1
integer :: id_umask_next_to_land   =-1
integer :: id_lap_plus_side_fric_u =-1
integer :: id_lap_plus_side_fric_v =-1
integer :: id_side_drag_friction_u =-1
integer :: id_side_drag_friction_v =-1

logical :: used

real :: k_smag_iso            = 2.0     ! smag scaling coeff for isotropic viscosity (dimensionless) 
real :: k_smag_aniso          = 0.0     ! smag scaling coeff for anisotripic viscosity (dimensionless) 
real :: vel_micom_iso         = 0.0     ! background scaling velocity for isotropic viscosity (m/sec) 
real :: vel_micom_aniso       = 0.0     ! background scaling velocity for anisotropic viscosity (m/sec) 
real :: eq_vel_micom_iso      = 0.0     ! background scaling velocity (m/sec) within equatorial band for isotropic visc
real :: eq_vel_micom_aniso    = 0.0     ! background scaling velocity (m/sec) within equatorial band for anisotropic visc
real :: eq_lat_micom          = 0.0     ! equatorial latitude band for micom (degrees)
real :: equatorial_zonal_lat  = 0.0     ! latitudinal band for orienting the friction along zonal direction
logical :: equatorial_zonal   = .false. ! zonally orient anisotropic friction w/i equatorial_zonal_lat
logical :: equatorial_no_smag = .false. ! remove smag within equatorial_zonal_lat
logical :: bottom_5point      = .false. ! for bottom Laplacian 5point mixing to avoid problems with thin partial cells. 

! for scaling the viscosity down according to the Rossby radius 
logical :: viscosity_scale_by_rossby=.false. 
real    :: viscosity_scale_by_rossby_power=2.0

! for restricting critical viscosity in high latitudes.
! this has been found of use for coupling to ice models, where 
! the effective friction is larger than just that within the ocean.   
logical :: restrict_polar_visc=.false.  
real    :: restrict_polar_visc_lat=60.0
real    :: restrict_polar_visc_ratio=0.35

! for divergence damping 
logical  :: divergence_damp           = .false.
real     :: divergence_damp_vel_micom = 0.0
                                 
! From NCAR viscosity algorithm.  Defaults are from CCSM2.0 ocean component gx1v3 
integer :: nx, ny                         ! number of global points in generalized x and y directions
real :: vconst_1              = 1.e7      ! (cm^2/s)
real :: vconst_2              = 0.0       ! (dimensionless)
real :: vconst_3              = 0.16      ! (dimensionless)
real :: vconst_4              = 2.e-8     ! (1/cm) 
integer :: vconst_5           = 3         ! (number of grid points)
real :: vconst_6              = 1.e7      ! (cm^2/sec)
real :: vconst_7              = 100.0     ! (cm/sec)
real :: vconst_8              = 45.0      ! (degrees on a circle)
real :: visc_vel_scale_length = 1500.e2   ! cm efolding depth scale 
logical :: viscosity_ncar     = .false.   ! to get the (x,y,z) dependent isotropic 
                                          ! and anisotropic viscosities used by NCAR.  
logical :: viscosity_ncar_2000= .true.    ! to get the (x,y,z) dependent isotropic 
                                          ! and anisotropic viscosities used by NCAR as of 2000.  
logical :: viscosity_ncar_2007= .false.   ! to get the (x,y,z) dependent isotropic 
                                          ! and anisotropic viscosities used by NCAR as of 2007.  
logical :: debug_ncar_A     = .false.
logical :: debug_ncar_B     = .false.
logical :: ncar_isotropic_off_equator = .false.
logical :: ncar_only_equatorial = .false.  ! for use of the ncar scheme only within the tropical band 

logical :: ncar_isotropic_at_depth      = .false. ! to set the NCAR scheme to be isotropic beneath a depth
real    :: ncar_isotropic_depth         = 4000.0  ! depth (m) beneath which set NCAR scheme to isotropic 
real    :: ncar_isotropic_at_depth_visc = 1e4     ! m2/sec minimum viscosity for ncar_isotropic_at_depth

! for neptune scheme  
logical :: neptune              = .false. ! for computing friction relative to barotropic Neptune velocity
logical :: neptune_smooth       = .true.  ! for smoothing diagnosed neptune velocity
integer :: neptune_smooth_num   = 1       ! number of smoothing passes for neptune smoother 
real    :: neptune_length_eq    = 1.2e3   ! (metres)
real    :: neptune_length_pole  = 3.0e3   ! (metres)
real    :: neptune_depth_min    = 100.0   ! (metres)

! for side-boundary drag law
logical :: use_side_drag_friction       = .false.
real    :: side_drag_friction_scaling   = 1.0
real    :: side_drag_friction_max       = 1.0
real    :: side_drag_friction_uvmag_max = 10.0
real, dimension(:,:,:), allocatable :: umask_next_to_land


#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS

real, dimension(isd:ied,jsd:jed)    :: aiso_diverge ! (m^2/s) viscosity for divergence damping
 
real, dimension(isd:ied,jsd:jed)    :: fsmag_iso   ! (m^2) combination of terms for computing isotropic smag visc
real, dimension(isd:ied,jsd:jed)    :: fsmag_aniso ! (m^2) combination of terms for computing anisotropic smag visc
real, dimension(isd:ied,jsd:jed,nk) :: aiso_back   ! minimum allowable isotropic viscosity (m^2/s)
real, dimension(isd:ied,jsd:jed,nk) :: aaniso_back ! minimum allowable anisotropic viscosity (m^2/s)
real, dimension(isd:ied,jsd:jed,nk) :: aiso        ! isotropic viscosity (m^2/s) averaged to U cell for diagnostics
real, dimension(isd:ied,jsd:jed)    :: daur_dxur   ! 1/(dxu*dxu*dyu) (m^-3)
real, dimension(isd:ied,jsd:jed)    :: daur_dyur   ! 1/(dxu*dyu*dyu) (m^-3)
real, dimension(isd:ied,jsd:jed,nk) :: massqc      ! (1/4)*dxu*dyu*rho_dzu (kg) for time-independent quarter-cell mass
real, dimension(isd:ied,jsd:jed)    :: visc_crit   ! critical value of the viscosity (m^2/sec) for linear stability 

real, dimension(isd:ied,jsd:jed,0:1,0:1,2) :: stress   !stress tensor: last index 1=stress_xx, 2=stress_xy
real, dimension(isd:ied,jsd:jed,2)         :: tmpfdelx
real, dimension(isd:ied,jsd:jed,2)         :: tmpfdely
real, dimension(isd:ied,jsd:jed)           :: tmp
real, dimension(isd:ied,jsd:jed)           :: cos2theta
real, dimension(isd:ied,jsd:jed)           :: sin2theta

#else

real, dimension(:,:), allocatable   :: aiso_diverge ! (m^2/s) viscosity for divergence damping
real, dimension(:,:), allocatable   :: fsmag_iso    ! (m^2) combination of terms for computing isotropic smag visc
real, dimension(:,:), allocatable   :: fsmag_aniso  ! (m^2) combination of terms for computing anisotropic smag visc
real, dimension(:,:,:), allocatable :: aiso_back    ! minimum allowable isotropic viscosity (m^2/s)
real, dimension(:,:,:), allocatable :: aaniso_back  ! minimum allowable anisotropic viscosity (m^2/s)
real, dimension(:,:,:), allocatable :: aiso         ! isotropic viscosity (m^2/s) averaged to U cell for diagnostics
real, dimension(:,:), allocatable   :: daur_dxur    ! 1/(dxu*dxu*dyu) (m^-3)
real, dimension(:,:), allocatable   :: daur_dyur    ! 1/(dxu*dyu*dyu) (m^-3)
real, dimension(:,:,:), allocatable :: massqc       ! (1/4)*dxu*dyu*rho_dzu (kg) for time-independent quarter-cell mass 
real, dimension(:,:), allocatable   :: visc_crit    ! critical value of the viscosity (m^2/sec) for linear stability 

real, dimension(:,:,:,:,:), allocatable        :: stress   !stress tensor: last index 1=stress_xx, 2=stress_xy
real, dimension(:,:,:), allocatable            :: tmpfdelx
real, dimension(:,:,:), allocatable            :: tmpfdely
real, dimension(:,:), allocatable              :: tmp
real, dimension(:,:), allocatable              :: cos2theta
real, dimension(:,:), allocatable              :: sin2theta


#endif


real, dimension(:,:,:), allocatable :: neptune_velocity  ! barotropic velocity (m/s) from Neptune 
real, dimension(:,:),   allocatable :: grid_length       ! horizontal grid length (m)
real, dimension(:,:),   allocatable :: viscosity_scaling ! dimensionless function of grid scale and Rossby radius

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()

character(len=256) :: version=&
     '=>Using: ocean_lapgen_friction.F90 ($Id: ocean_lapgen_friction.F90,v 20.0 2013/12/14 00:14:26 fms Exp $)'
character (len=128) :: tagname = &
     '$Name: tikal $'

logical :: use_this_module       = .false.
logical :: debug_this_module     = .false.
logical :: module_is_initialized = .FALSE.
logical :: have_obc              = .FALSE.
logical :: async_domain_update   = .false.
integer :: blocksize             = 10

namelist /ocean_lapgen_friction_nml/ use_this_module, debug_this_module,                &
    bottom_5point, k_smag_iso, k_smag_aniso,                                            &
    vel_micom_iso, vel_micom_aniso, eq_vel_micom_iso, eq_vel_micom_aniso, eq_lat_micom, &
    equatorial_zonal, equatorial_zonal_lat, equatorial_no_smag,                         &
    viscosity_ncar, viscosity_ncar_2000, viscosity_ncar_2007,                           &
    ncar_isotropic_off_equator, ncar_only_equatorial,                                   &
    vconst_1, vconst_2, vconst_3, vconst_4, vconst_5, vconst_6, vconst_7, vconst_8,     &
    debug_ncar_A, debug_ncar_B, visc_vel_scale_length,                                  &
    neptune, neptune_length_eq, neptune_length_pole, neptune_depth_min,                 &
    neptune_smooth, neptune_smooth_num,                                                 &
    restrict_polar_visc, restrict_polar_visc_lat, restrict_polar_visc_ratio,            &
    ncar_isotropic_at_depth, ncar_isotropic_depth, ncar_isotropic_at_depth_visc,        &
    divergence_damp, divergence_damp_vel_micom,                                         &
    viscosity_scale_by_rossby, viscosity_scale_by_rossby_power, async_domain_update,    &
    blocksize, use_side_drag_friction, side_drag_friction_scaling,                      &
    side_drag_friction_uvmag_max, side_drag_friction_max 

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_lapgen_friction_init">

! <DESCRIPTION>
! Initialize the horizontal Laplacian friction module by 
! registering fields for diagnostic output and performing some 
! numerical checks to see that viscosity is set appropriately.
! </DESCRIPTION>
!
subroutine ocean_lapgen_friction_init(Grid, Domain, Time, Ocean_options, d_time, &
                                      obc, use_lapgen_friction, debug)

  type(ocean_grid_type),    target, intent(in)    :: Grid
  type(ocean_domain_type),  target, intent(in)    :: Domain
  type(ocean_time_type),            intent(in)    :: Time
  type(ocean_options_type),         intent(inout) :: Ocean_options
  real,                             intent(in)    :: d_time
  logical,                          intent(in)    :: obc
  logical,                          intent(inout) :: use_lapgen_friction
  logical,                optional, intent(in)    :: debug

  integer :: ioun, io_status, ierr
  integer :: i, j, k
  real :: coeff_iso, coeff_aniso, dxdy

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lapgen_friction_mod (ocean_lapgen_friction_init): already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
#endif 

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_lapgen_friction_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_lapgen_friction_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_lapgen_friction_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_lapgen_friction_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_lapgen_friction_nml)  
  write (stdlogunit,ocean_lapgen_friction_nml)

  if(use_this_module) then 
      call mpp_error(NOTE, '==> NOTE: USING ocean_lapgen_friction_mod.')
      Ocean_options%horz_lap_friction = 'Used general horizontal Laplacian friction.'
      use_lapgen_friction = .true. 
  else 
      call mpp_error(NOTE, '==> NOTE: NOT using ocean_lapgen_friction_mod.')
      Ocean_options%horz_lap_friction = 'Did NOT use horizontal Laplacian friction.'
      use_lapgen_friction = .false. 
      return 
  endif

  if (PRESENT(debug) .and. .not. debug_this_module) then 
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') &
    '==>Note: running with debug_this_module=.true. so will print lots of checksums.'  
  endif 

  if(async_domain_update) then 
    write(stdoutunit,'(a)') &
    '==>Note: using asynchronous domain update in the vertical loop.'  
  else
    write(stdoutunit,'(a)') &
    '==>Note: not using asynchronous domain update in the vertical loop. This may be slow.'  
  endif 

  dtime = d_time
  write(stdoutunit,'(/a,f10.2)') &
  '==> Note from ocean_lapgen_friction_mod: using forward time step of (secs)', dtime 

  have_obc       = obc
  if (have_obc) write(stdoutunit,'(/a,f10.2)') &
   '==> Note from ocean_lapgen_friction_mod: considering obc' 

  if(viscosity_scale_by_rossby) then 
    write(stdoutunit,'(1x,a)') '==> Note: Scaling the laplacian viscosity according to grid scale and Rossby radius.'
  endif 

  if(bottom_5point) then 
    write(stdoutunit,'(1x,a)') '==> Note: Will reduce horizontal friction &
         &to a 5point Laplacian on the bottom'
    write(stdoutunit,'(5x,a)') 'This helps to alleviate numerical problems&
         & with thin bottom partial cells.'
  endif 

  if(neptune) then 
    write(stdoutunit,'(1x,a)') '==> Note: Computing Laplacian friction relative to Neptune'
    write(stdoutunit,'(5x,a,e10.5)') &
    'Equatorial length (m) for computing Neptune velocity is   ',neptune_length_eq 
    write(stdoutunit,'(5x,a,e10.5)') &
    'Polar length (m) for computing Neptune velocity is        ',neptune_length_pole 
    write(stdoutunit,'(5x,a,e10.5)') &
    'Minimum depth scale (m) for computing Neptune velocity is ',neptune_depth_min
  endif 

  if(viscosity_ncar)  then 

    write( stdoutunit,'(1x,a)')'==> NOTE: USING background horz viscosities &
         &according to NCAR CCSM2.0 algorithm.' 
    if(viscosity_ncar_2000) then 
       write( stdoutunit,'(1x,a)')'==> NOTE: USING NCAR viscosity as formulated in 2000.' 
    endif 
    if(viscosity_ncar_2007) then 
       write( stdoutunit,'(1x,a)')'==> NOTE: USING NCAR viscosity as formulated in 2007.' 
    endif 
    if(viscosity_ncar_2000 .and. viscosity_ncar_2007) then 
       call mpp_error(FATAL, &
       '==>Error in ocean_lapgen_friction_mod: cannot choose both viscosity_ncar_2000 and viscosity_ncar_2007')
    endif 
    if(.not. viscosity_ncar_2000 .and. .not. viscosity_ncar_2007) then 
       call mpp_error(FATAL, &
       '==>Error in ocean_lapgen_friction_mod: viscosity_ncar requires one of viscosity_ncar_2000 or viscosity_ncar_2007')
    endif 

    write( stdoutunit,'(a,e15.4)')'  NCAR vconst_1 (cm^2/sec)  = ',vconst_1
    write( stdoutunit,*)' NCAR vconst_2             = ',vconst_2
    write( stdoutunit,*)' NCAR vconst_3             = ',vconst_3
    write( stdoutunit,*)' NCAR vconst_4 (1/cm)      = ',vconst_4
    write( stdoutunit,*)' NCAR vconst_5             = ',vconst_5
    write( stdoutunit,'(a,e15.4)')'  NCAR vconst_6 (cm^2/sec)  = ',vconst_6
    write( stdoutunit,*)' NCAR vconst_7 (cm/sec)    = ',vconst_7
    write( stdoutunit,*)' NCAR vconst_8 (degrees)   = ',vconst_8
    if(debug_ncar_A) then 
      write( stdoutunit,'(1x,a)')'==> NOTE: USING debug_ncar_A=.true., &
           &so will set f_perp=f_para'
    endif 
    if(debug_ncar_B) then 
      write( stdoutunit,'(1x,a)')'==> NOTE: USING debug_ncar_B=.true.,&
           & so will set f_para=f_perp'
    endif 
    if(ncar_isotropic_off_equator) then 
      write( stdoutunit,'(1x,a,f10.4)')&
      '==>ncar_isotropic_off_equator=.true. =>f_para=f_perp poleward of lat',equatorial_zonal_lat
    endif 
    if(ncar_only_equatorial) then 
      write( stdoutunit,'(1x,a,f10.4)')&
      '==>ncar_only_equatorial=.true. =>ncar scheme only in band +/- lat',equatorial_zonal_lat
    endif 

  endif  

  if(k_smag_iso > 0.0) then 
     write( stdoutunit,'(1x,a)')'==> NOTE: USING horz isotropic viscosity &
          &via Smagorinsky.'
  endif 
  if(k_smag_aniso > 0.0) then 
     write( stdoutunit,'(1x,a)')'==> NOTE: USING horz anisotropic viscosity &
          &via Smagorinsky.'
  endif      
  if(k_smag_iso==0.0)    write( stdoutunit,'(1x,a)')'==> NOTE: Setting horz &
       &isotropic Smagorinsky viscosity to zero.'
  if(k_smag_aniso==0.0)  write( stdoutunit,'(1x,a)')'==> NOTE: Setting horz &
       &anisotropic Smagorinsky viscosity to zero.'

  if(.not. viscosity_ncar) then 
    write( stdoutunit,'(1x,a)') &
    '==> NOTE: NOT using NCAR scheme for computing viscosities. '
    if(vel_micom_iso > 0.0) then 
       write( stdoutunit,'(1x,a)') &
       '==> NOTE: USING background horz isotropic viscosity via MICOM.'
    endif
    if(vel_micom_aniso > 0.0) then 
       write( stdoutunit,'(1x,a)') &
       '==> NOTE: USING background horz anisotropic viscosity via MICOM.'
    endif 
    if(vel_micom_iso==0.0)  write( stdoutunit,'(1x,a)')  '==> NOTE: USING zero &
         &background horz isotropic viscosity.'
    if(vel_micom_aniso==0.0)  write( stdoutunit,'(1x,a)')'==> NOTE: USING zero &
         &background horz anisotropic viscosity.' 
  endif  
  if(eq_lat_micom > 0) write( stdoutunit,'(1x,a)')'==> NOTE: USING different &
       &background horz viscosity within equatorial zone.'

  if(k_smag_aniso > 2.0*k_smag_iso) then
    write( stdoutunit,'(1x,a)')'==> ERROR: Smag horz anisotropic visc too large. &
         &Must be less than twice Smagorinsky isotropic visc.'
  endif  
  if(vel_micom_aniso > 2.0*vel_micom_iso) then
    write( stdoutunit,'(1x,a)')'==> ERROR: Background anisotropic visc too large.&
         & Must be less than twice back isotropic visc.'
  endif  

  if(equatorial_zonal) then
    write( stdoutunit,'(/a)') &
    'If using anisotropic friction, zonally orient the friction within a latitudinal band'
    write( stdoutunit,'(a,f12.5,a)') &
    ' of width ',equatorial_zonal_lat,' degrees.'
  endif 

  if(restrict_polar_visc) then
    write( stdoutunit,'(/a,f12.5)')&
    ' Using restrict_polar_visc to lower visc_crit poleward of (deg)',restrict_polar_visc_lat
    write( stdoutunit,'(a,f12.5)')&
    ' by an amount given by the fraction ',restrict_polar_visc_ratio
    write( stdoutunit,'(a/)')&
    ' This approach is useful when coupling to ice, where effective (ocn+ice) visc > ocn visc.'
  endif 

  Grd => Grid
  Dom => Domain
  nx  =  Grd%ni
  ny  =  Grd%nj

#ifndef MOM_STATIC_ARRAYS
  allocate (aiso_diverge(isd:ied,jsd:jed))
  allocate (fsmag_iso(isd:ied,jsd:jed))
  allocate (fsmag_aniso(isd:ied,jsd:jed))
  allocate (aiso_back(isd:ied,jsd:jed,nk))
  allocate (aaniso_back(isd:ied,jsd:jed,nk))
  allocate (aiso(isd:ied,jsd:jed,nk)) 
  allocate (daur_dxur(isd:ied,jsd:jed))
  allocate (daur_dyur(isd:ied,jsd:jed))
  allocate (massqc(isd:ied,jsd:jed,nk))
  allocate (visc_crit(isd:ied,jsd:jed))
  allocate (stress(isd:ied,jsd:jed,0:1,0:1,2))  !stress tensor: last index 1=stress_xx, 2=stress_xy
  allocate (tmpfdelx(isd:ied,jsd:jed,2))    
  allocate (tmpfdely(isd:ied,jsd:jed,2))   
  allocate (tmp(isd:ied,jsd:jed))
  allocate (cos2theta(isd:ied,jsd:jed))
  allocate (sin2theta(isd:ied,jsd:jed))
#endif

  allocate (grid_length(isd:ied,jsd:jed))
  allocate (viscosity_scaling(isd:ied,jsd:jed))
  grid_length(:,:)       = Grd%umask(:,:,1)*2.0*Grd%dxu(:,:)*Grd%dyu(:,:)/(epsln+Grd%dxu(:,:)+Grd%dyu(:,:))
  viscosity_scaling(:,:) = Grd%umask(:,:,1)

  tmp(:,:)          = 0.0
  aiso_diverge(:,:) = 0.0
  
  ! Some commonly used grid arrays 
  daur_dxur(:,:) = 0.0
  daur_dyur(:,:) = 0.0
  daur_dxur(:,:) = Grd%daur(:,:)*Grd%dxur(:,:)
  daur_dyur(:,:) = Grd%daur(:,:)*Grd%dyur(:,:)

  ! critical value of viscosity, above which 2-dim linear stability is not satisfied
  ! visc_crit taken from equation (18.17) of Griffies book.
  visc_crit(:,:) = 0.0
  do j=jsd,jed
    do i=isd,ied
      dxdy = 1.0/( 1.0/(Grd%dxu(i,j)*Grd%dxu(i,j)) + 1.0/(Grd%dyu(i,j)*Grd%dyu(i,j)) )
      visc_crit(i,j) = 0.5*dxdy/(dtime + epsln)
    enddo
  enddo
  
  ! may need a more conservative restriction in high latitudes when coupling to ice models 
  if(restrict_polar_visc) then 
     do j=jsd,jed
       do i=isd,ied
          if (abs(Grd%yu(i,j)) > restrict_polar_visc_lat) then    
            visc_crit(i,j) = restrict_polar_visc_ratio*visc_crit(i,j)
          endif
       enddo
     enddo
  endif

  id_visc_crit_lap = register_static_field ('ocean_model', 'visc_crit_lap', &
                     Grd%vel_axes_uv(1:2), 'critical viscosity',            &
                     'm^2/sec',missing_value=missing_value, range=(/0.0,1.e20/))
  call diagnose_2d_u(Time, Grd, id_visc_crit_lap, visc_crit(:,:))


  ! compute some smag fields and parameters 

  ! f_smag = (delta s * k_smag/pi)^2 where (delta s) is for velocity cell
  fsmag_iso(:,:)   = 0.0
  fsmag_aniso(:,:) = 0.0
  coeff_iso        = (k_smag_iso/pi)**2
  coeff_aniso      = (k_smag_aniso/pi)**2
  fsmag_iso(:,:)   = coeff_iso  *((2.0*Grd%dxu(:,:)*Grd%dyu(:,:))/(epsln + Grd%dxu(:,:) + Grd%dyu(:,:)))**2
  fsmag_aniso(:,:) = coeff_aniso*((2.0*Grd%dxu(:,:)*Grd%dyu(:,:))/(epsln + Grd%dxu(:,:) + Grd%dyu(:,:)))**2

  ! remove smag within equatorial_zonal_lat band 
  if(equatorial_no_smag) then
    do j=jsd,jed
      do i=isd,ied
        if(abs(Grd%yu(i,j)) < equatorial_zonal_lat) then
          fsmag_iso(i,j)   = 0.0
          fsmag_aniso(i,j) = 0.0
        endif 
      enddo
    enddo 
  endif 

  ! compute time independent background viscosities 
  aiso(:,:,:)        = 0.0
  aiso_back(:,:,:)   = 0.0
  aaniso_back(:,:,:) = 0.0

  ! grid scale dependent "MICOM" background viscosities
  if(.not. viscosity_ncar)  then
      do j=jsd,jed
         do i=isd,ied
            aiso_back(i,j,:)     = vel_micom_iso  *(2.0*Grd%dxu(i,j)*Grd%dyu(i,j)) &
                                                   /(epsln + Grd%dxu(i,j) + Grd%dyu(i,j))
            aaniso_back(i,j,:)   = vel_micom_aniso*(2.0*Grd%dxu(i,j)*Grd%dyu(i,j)) &
                                                  /(epsln + Grd%dxu(i,j) + Grd%dyu(i,j))
            if(abs(Grd%yu(i,j)) < eq_lat_micom) then
                aiso_back(i,j,:)   = eq_vel_micom_iso  *(2.0*Grd%dxu(i,j)*Grd%dyu(i,j)) &
                                                       /(epsln + Grd%dxu(i,j) + Grd%dyu(i,j))
                aaniso_back(i,j,:) = eq_vel_micom_aniso*(2.0*Grd%dxu(i,j)*Grd%dyu(i,j)) &
                                                       /(epsln + Grd%dxu(i,j) + Grd%dyu(i,j))
            endif
         enddo
      enddo
  endif

  ! for divergence damping 
  do j=jsd,jed
     do i=isd,ied
        aiso_diverge(i,j) = divergence_damp_vel_micom*(2.0*Grd%dxt(i,j)*Grd%dyt(i,j)) &
                            /(epsln + Grd%dxt(i,j) + Grd%dyt(i,j))
     enddo
  enddo


  ! (x,y,z) viscosities according to NCAR CCSM2.0 algorithm
  ! if use ncar only for equatorial region, revert to micom for off-equatorial 
  if(viscosity_ncar)  then
     call anisotropic_ncar
     if(ncar_only_equatorial) then    
        do j=jsd,jed
           do i=isd,ied  
              if(abs(Grd%yu(i,j)) > equatorial_zonal_lat) then
                 aiso_back(i,j,:) = vel_micom_iso  *(2.0*Grd%dxu(i,j)*Grd%dyu(i,j)) &
                                                   /(epsln + Grd%dxu(i,j) + Grd%dyu(i,j))
                 aaniso_back(i,j,:) = vel_micom_aniso*(2.0*Grd%dxu(i,j)*Grd%dyu(i,j)) &
                                                     /(epsln + Grd%dxu(i,j) + Grd%dyu(i,j))
              endif
           enddo
        enddo
     endif  
  endif 

  ! enhance background viscosity near open boundaries if needed
  if (have_obc) call ocean_obc_enhance_visc_back(aiso_back, aaniso_back)

  ! ensure background viscosities are not too large 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           if(aiso_back(i,j,k)   > visc_crit(i,j))  aiso_back(i,j,k)   = visc_crit(i,j)
           if(aaniso_back(i,j,k) > visc_crit(i,j))  aaniso_back(i,j,k) = visc_crit(i,j)
        enddo
     enddo
  enddo

  ! ensure viscosities maintain proper relative values so friction dissipates 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
            if(aaniso_back(i,j,k) >= 2.0*aiso_back(i,j,k) .and. aaniso_back(i,j,k) > 0.0)  then 
              write(stdoutunit,'(a,i4,a,i4,a,i3,a)') &
              'Violating lap iso/aniso constraint at (',i,',',j,',',k,')'
              aaniso_back(i,j,k) = 1.9*aiso_back(i,j,k)
            endif 
         enddo
      enddo
  enddo

  call compute_neptune_velocity(Time)


  if(use_side_drag_friction) then 
     write(stdoutunit,'(a)') '==> Note from ocean_lapgen_friction: using side drag friction for cells next to land.'
     allocate (umask_next_to_land(isd:ied,jsd:jed,nk))
     umask_next_to_land(:,:,:) = 0.0
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              umask_next_to_land(i,j,k) = (1.0-Grd%umask(i+1,j,k)) + (1.0-Grd%umask(i-1,j,k)) &
                                         +(1.0-Grd%umask(i,j+1,k)) + (1.0-Grd%umask(i,j-1,k)) 
              umask_next_to_land(i,j,k) = Grd%umask(i,j,k)*min(1.0,umask_next_to_land(i,j,k))
           enddo
        enddo
     enddo 
     id_umask_next_to_land = register_static_field('ocean_model', 'umask_next_to_land_lap',&
            Grd%vel_axes_uv(1:3),'U-cell mask for cells next to land for lapgen module',   &
            'dimensionless', missing_value=missing_value, range=(/-10.0,10.0/))
     call diagnose_3d_u(Time, Grd, id_umask_next_to_land, umask_next_to_land(:,:,:))
  endif 


  ! send static fields to diag_manager 
  id_along_back   = register_static_field('ocean_model', 'along_lap_back',      &
                    Grd%vel_axes_uv(1:3),'U-cell background along-stream visc', &
                    'm^2/sec', missing_value=missing_value, range=(/-10.0,1.e10/))
  id_across_back = register_static_field('ocean_model', 'across_lap_back',      &
                   Grd%vel_axes_uv(1:3), 'U-cell background cross-stream visc', &
                   'm^2/sec', missing_value=missing_value, range=(/-10.0,1.e10/))

  if (id_along_back > 0) then 
     call diagnose_3d_u(Time, Grd, id_along_back, aiso_back(:,:,:)+0.5*aaniso_back(:,:,:))
  endif 
  if (id_across_back > 0) then 
     call diagnose_3d_u(Time, Grd, id_across_back, aiso_back(:,:,:)-0.5*aaniso_back(:,:,:))
  endif 

  id_aiso_diverge = register_static_field('ocean_model', 'aiso_lap_diverge', &
              Grd%tracer_axes(1:2), 'U-cell visc for divergence damping',    &
              'm^2/sec', missing_value=missing_value, range=(/-10.0,1.e10/))
  call diagnose_2d(Time, Grd, id_aiso_diverge, aiso_diverge(:,:))

  ! other viscosities for diagnostic output 

  id_aiso   = register_diag_field ('ocean_model', 'aiso_lap', Grd%vel_axes_uv(1:3), &
              Time%model_time, 'U-cell isotropic visc', 'm^2/sec',                  &
              missing_value=missing_value, range=(/-10.0,1.e10/),                   &
              standard_name='ocean_momentum_xy_laplacian_diffusivity')
  id_aaniso = register_diag_field ('ocean_model', 'aaniso_lap', Grd%vel_axes_uv(1:3), &
              Time%model_time, 'U-cell anisotropic visc', 'm^2/sec',                  &
              missing_value=missing_value, range=(/-10.0,1.e10/))
  id_along  = register_diag_field ('ocean_model', 'along', Grd%vel_axes_uv(1:3), &
              Time%model_time, 'U-cell along-stream visc', 'm^2/sec',            &
              missing_value=missing_value, range=(/-10.0,1.e10/))
  id_across = register_diag_field ('ocean_model', 'across', Grd%vel_axes_uv(1:3), &
              Time%model_time, 'U-cell cross-stream visc', 'm^2/sec',             &
              missing_value=missing_value, range=(/-10.0,1.e10/))
  id_lap_fric_u = register_diag_field ('ocean_model', 'lap_fric_u', Grd%vel_axes_uv(1:3),              &
                  Time%model_time, 'Thick & rho wghtd horz lap frict on u-zonal','(kg/m^3)*(m^2/s^2)', &
                  missing_value=missing_value, range=(/-1.e20,1.e20/))
  id_lap_fric_v = register_diag_field ('ocean_model', 'lap_fric_v', Grd%vel_axes_uv(1:3), &
                  Time%model_time, 'Thick & rho wghtd horz lap frict on v-merid', '(kg/m^3)*(m^2/s^2)', &
                  missing_value=missing_value, range=(/-1.e20,1.e20/))
  id_horz_lap_diss = register_diag_field ('ocean_model', 'horz_lap_diss', Grd%vel_axes_uv(1:3),     &
                  Time%model_time, 'Energy dissipation from horizontal Laplacian friction', 'W/m^2',&
                  missing_value=missing_value, range=(/-1.e20,1.e20/))
  id_viscosity_scaling = register_diag_field ('ocean_model', 'viscosity_scaling', Grd%vel_axes_uv(1:2),  &
              Time%model_time, 'Grid/Rossby radius scaling for the laplacian viscosity', 'dimensionless',&
              missing_value=missing_value, range=(/-1.0,10.0/))

  id_side_drag_friction_u = register_diag_field ('ocean_model', 'side_drag_friction_lap_u', Grd%vel_axes_uv(1:3),&
                  Time%model_time, 'u-friction due to side drag from lapgen module', 'N/m^2',                    &
                  missing_value=missing_value, range=(/-1.e20,1.e20/))

  id_side_drag_friction_v = register_diag_field ('ocean_model', 'side_drag_friction_lap_v', Grd%vel_axes_uv(1:3),&
                  Time%model_time, 'v-friction due to side drag from lapgen module', 'N/m^2',                    &
                  missing_value=missing_value, range=(/-1.e20,1.e20/))

  id_lap_plus_side_fric_u = register_diag_field ('ocean_model', 'lap_plus_side_fric_u', Grd%vel_axes_uv(1:3), &
                  Time%model_time, 'Thickness and rho wghtd horz lap frict + side friction on u-zonal',       &
                  '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1.e20,1.e20/))
  id_lap_plus_side_fric_v = register_diag_field ('ocean_model', 'lap_plus_side_fric_v', Grd%vel_axes_uv(1:3), &
                  Time%model_time, 'Thickness and rho wghtd horz lap frict + side friction on v-merid',       &
                  '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1.e20,1.e20/))


end subroutine ocean_lapgen_friction_init
! </SUBROUTINE>  NAME="ocean_lapgen_friction_init"


!#######################################################################
! <SUBROUTINE NAME="lapgen_friction">
!
! <DESCRIPTION>
! This routine computes thickness weighted and density weighted 
! time tendency for horizontal velocity arising from horizontal 
! Laplacian friction.  
!
! The algorithm is derived from a functional approach that ensures
! kinetic energy is consistenty dissipated for all flow configurations. 
! The triad do-loops are expanded in order to enhance the 
! ability of cache-based machines to keep most of the variables 
! on-cache.  
! 
! Fundamental to the scheme are the rates of horizontal deformation  <BR/> 
! horizontal tension = DT = (dy)(u/dy)_x - (dx)(v/dx)_y              <BR/>    
! horizontal strain  = DS = (dx)(u/dx)_y + (dy)(v/dy)_x              <BR/> 
! Units of the tension and strain are sec^-1.
!
! Four tensions and four strains are computed for each velocity point, <BR/>
! corresponding to the four triads surrounding the point.              <BR/>  
! The following notation is used to distinguish the triads:            <BR/>  
! (0,1)=northwest triad  (1,1)=northeast triad,                        <BR/> 
! (0,0)=southwest triad, (1,0)=southeast triad
!
! A triad contributes when at least one of its velocities is            
! not a land point.  In order to obtain the correct tension          
! and strain next to boundaries, tension and strain should not be   
! masked with umask. 
!
! </DESCRIPTION>
!
subroutine lapgen_friction(Time, Thickness, Adv_vel, Velocity, &
                           lap_viscosity, energy_analysis_step)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(in)    :: Thickness
  type(ocean_adv_vel_type),   intent(in)    :: Adv_vel
  type(ocean_velocity_type),  intent(inout) :: Velocity
  logical,                    intent(in)    :: energy_analysis_step
  real, dimension(isd:,jsd:), intent(inout) :: lap_viscosity

  real, dimension(0:1,0:1) :: aiso_smag
  real, dimension(0:1,0:1) :: aaniso_smag
  real, dimension(0:1,0:1) :: dissipate

  integer :: i, j, k, n
  integer :: ip, jq, jjq, iip
  integer :: taum1, tau

  real :: u1_m10, u2_m10
  real :: u1_10,  u2_10
  real :: u1_00,  u2_00
  real :: u1_01,  u2_01
  real :: u1_0m1, u2_0m1 
  real :: dxuer_ip0, dxuer_ip1
  real :: dyunr_jq0, dyunr_jq1
  real :: usqrd, vsqrd, umagr
  real :: uvmag, umag, vmag, velocity_gamma
  real :: tension, strain, deform, delta 
  real :: tension_metric, strain_metric
  real,dimension (isd:ied,jsd:jed,8,nk) :: stress_B

  integer :: stdoutunit, ibl
  integer, dimension(nk) :: id_update, kstart, kend

  stdoutunit=stdout() 

  if(.not. use_this_module) then

      if(energy_analysis_step) then 
          do n=1,2
             do k=1,nk
                do j=jsc,jec
                   do i=isc,iec
                      Velocity%wrkv(i,j,k,n) = 0.0
                   enddo
                enddo
             enddo
          enddo
      endif

    return 
  endif 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lapgen_friction_mod (lapgen_friction): module not initialized')
  endif 

  taum1 = Time%taum1
  tau   = Time%tau

  ! to scale down the viscosity if the Rossby radius is resolved by the grid 
  if(viscosity_scale_by_rossby) then 
     do j=jsc,jec
        do i=isc,iec
           wrk1_2d(i,j) = Velocity%rossby_radius(i,j)
        enddo
     enddo
     call mpp_update_domains (wrk1_2d(:,:), Dom%domain2d)    
     do j=jsd,jed
        do i=isd,ied
           viscosity_scaling(i,j) = grid_length(i,j)**viscosity_scale_by_rossby_power &
           /(grid_length(i,j)**viscosity_scale_by_rossby_power + wrk1_2d(i,j)**viscosity_scale_by_rossby_power + epsln)
        enddo
     enddo
  else 
     viscosity_scaling(:,:) = Grd%umask(:,:,1)
  endif 


  stress(:,:,:,:,:) = 0.0
  wrk1_v(:,:,:,:)   = 0.0
  wrk2_v(:,:,:,:)   = 0.0
  wrk3_v(:,:,:,:)   = 0.0
  wrk1(:,:,:)       = 0.0 
  wrk2(:,:,:)       = 0.0 

  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           massqc(i,j,k) = 0.25*Grd%dau(i,j)*Thickness%rho_dzu(i,j,k,tau)
        enddo
     enddo
  enddo 

  kstart = 1
  kend   = nk
  ibl    = 1
  do k=1,nk

     do j=jsd,jec
        do i=isd,iec

           tension_metric = -(Velocity%u(i,j,k,1,taum1)-neptune_velocity(i,j,1))*Grd%dh2dx(i,j) &
                            +(Velocity%u(i,j,k,2,taum1)-neptune_velocity(i,j,2))*Grd%dh1dy(i,j)  

           strain_metric  = -(Velocity%u(i,j,k,1,taum1)-neptune_velocity(i,j,1))*Grd%dh1dy(i,j) &
                            -(Velocity%u(i,j,k,2,taum1)-neptune_velocity(i,j,2))*Grd%dh2dx(i,j)  

           if(equatorial_zonal .and. abs(Grd%yu(i,j)) <= equatorial_zonal_lat) then  
             sin2theta(i,j) = 0.0
             cos2theta(i,j) = 1.0
           else 
             usqrd = (Velocity%u(i,j,k,1,taum1)-neptune_velocity(i,j,1))**2
             vsqrd = (Velocity%u(i,j,k,2,taum1)-neptune_velocity(i,j,2))**2
             umagr = 1.0/(epsln + usqrd + vsqrd)
             sin2theta(i,j) = 2.0*(Velocity%u(i,j,k,1,taum1)-neptune_velocity(i,j,1)) &
                                 *(Velocity%u(i,j,k,2,taum1)-neptune_velocity(i,j,2))*umagr
             cos2theta(i,j) = (usqrd-vsqrd)*umagr
           endif  

          ! compute stress tensor components for the four triads.  
          ! expanded do-loops are quicker. 

           ip=0 ; iip = max(isd,i+ip-1)
           dxuer_ip0 = Grd%dxuer(iip,j)

           ip=1 
           dxuer_ip1 = Grd%dxuer(i+ip-1,j)

           jq=0 ; jjq = max(jsd,j+jq-1)
           dyunr_jq0 = Grd%dyunr(i,jjq)

           jq=1 
           dyunr_jq1 = Grd%dyunr(i,j+jq-1)

           ip=-1 ; jq=0  ; iip = max(i+ip,isd)
           u1_m10 = Velocity%u(iip,j+jq,k,1,taum1) - neptune_velocity(iip,j+jq,1) 
           u2_m10 = Velocity%u(iip,j+jq,k,2,taum1) - neptune_velocity(iip,j+jq,2) 

           ip=1  ; jq=0  
           u1_10  = Velocity%u(i+ip,j+jq,k,1,taum1) - neptune_velocity(i+ip,j+jq,1) 
           u2_10  = Velocity%u(i+ip,j+jq,k,2,taum1) - neptune_velocity(i+ip,j+jq,2)

           ip=0  ; jq=0  
           u1_00  = Velocity%u(i+ip,j+jq,k,1,taum1) - neptune_velocity(i+ip,j+jq,1) 
           u2_00  = Velocity%u(i+ip,j+jq,k,2,taum1) - neptune_velocity(i+ip,j+jq,2)

           ip=0  ; jq=1  
           u1_01  = Velocity%u(i+ip,j+jq,k,1,taum1) - neptune_velocity(i+ip,j+jq,1)  
           u2_01  = Velocity%u(i+ip,j+jq,k,2,taum1) - neptune_velocity(i+ip,j+jq,2) 

           ip=0  ; jq=-1;  jjq = max(j+jq,jsd)
           u1_0m1 = Velocity%u(i+ip,jjq,k,1,taum1) - neptune_velocity(i+ip,jjq,1) 
           u2_0m1 = Velocity%u(i+ip,jjq,k,2,taum1) - neptune_velocity(i+ip,jjq,2)

           ip=0 ; jq=0 
           tension =  dxuer_ip0*(u1_00-u1_m10)-dyunr_jq0*(u2_00-u2_0m1)+tension_metric
           strain  =  dxuer_ip0*(u2_00-u2_m10)+dyunr_jq0*(u1_00-u1_0m1)+strain_metric
           delta   =  0.5*(strain*cos2theta(i,j) - tension*sin2theta(i,j))
           deform  = sqrt(tension**2 + strain**2)
           aiso_smag(ip,jq)    = viscosity_scaling(i,j)*min(visc_crit(i,j), aiso_back(i,j,k)   + fsmag_iso(i,j)*deform)
           aaniso_smag(ip,jq)  = viscosity_scaling(i,j)*min(visc_crit(i,j), aaniso_back(i,j,k) + fsmag_aniso(i,j)*deform)
           stress(i,j,ip,jq,1) = aiso_smag(ip,jq)*tension + aaniso_smag(ip,jq)*delta*sin2theta(i,j)
           stress(i,j,ip,jq,2) = aiso_smag(ip,jq)*strain  - aaniso_smag(ip,jq)*delta*cos2theta(i,j)
           dissipate(ip,jq)    = -aiso_smag(ip,jq)*deform**2 + 2.0*aaniso_smag(ip,jq)*delta**2

           ip=1 ; jq=0 
           tension =  dxuer_ip1*(u1_10-u1_00)-dyunr_jq0*(u2_00-u2_0m1)+tension_metric
           strain  =  dxuer_ip1*(u2_10-u2_00)+dyunr_jq0*(u1_00-u1_0m1)+strain_metric
           delta   =  0.5*(strain*cos2theta(i,j) - tension*sin2theta(i,j))
           deform  = sqrt(tension**2 + strain**2)
           aiso_smag(ip,jq)    = viscosity_scaling(i,j)*min(visc_crit(i,j), aiso_back(i,j,k)   + fsmag_iso(i,j)*deform)
           aaniso_smag(ip,jq)  = viscosity_scaling(i,j)*min(visc_crit(i,j), aaniso_back(i,j,k) + fsmag_aniso(i,j)*deform)
           stress(i,j,ip,jq,1) = aiso_smag(ip,jq)*tension + aaniso_smag(ip,jq)*delta*sin2theta(i,j)
           stress(i,j,ip,jq,2) = aiso_smag(ip,jq)*strain  - aaniso_smag(ip,jq)*delta*cos2theta(i,j)
           dissipate(ip,jq)    = -aiso_smag(ip,jq)*deform**2 + 2.0*aaniso_smag(ip,jq)*delta**2

           ip=0 ; jq=1
           tension =  dxuer_ip0*(u1_00-u1_m10)-dyunr_jq1*(u2_01-u2_00)+tension_metric
           strain  =  dxuer_ip0*(u2_00-u2_m10)+dyunr_jq1*(u1_01-u1_00)+strain_metric
           delta   =  0.5*(strain*cos2theta(i,j) - tension*sin2theta(i,j))
           deform  = sqrt(tension**2 + strain**2)
           aiso_smag(ip,jq)    = viscosity_scaling(i,j)*min(visc_crit(i,j), aiso_back(i,j,k)   + fsmag_iso(i,j)*deform)
           aaniso_smag(ip,jq)  = viscosity_scaling(i,j)*min(visc_crit(i,j), aaniso_back(i,j,k) + fsmag_aniso(i,j)*deform)
           stress(i,j,ip,jq,1) = aiso_smag(ip,jq)*tension + aaniso_smag(ip,jq)*delta*sin2theta(i,j)
           stress(i,j,ip,jq,2) = aiso_smag(ip,jq)*strain  - aaniso_smag(ip,jq)*delta*cos2theta(i,j)
           dissipate(ip,jq)    = -aiso_smag(ip,jq)*deform**2 + 2.0*aaniso_smag(ip,jq)*delta**2

           jq=1 ; ip=1
           tension =  dxuer_ip1*(u1_10-u1_00)-dyunr_jq1*(u2_01-u2_00)+tension_metric
           strain  =  dxuer_ip1*(u2_10-u2_00)+dyunr_jq1*(u1_01-u1_00)+strain_metric
           delta   =  0.5*(strain*cos2theta(i,j) - tension*sin2theta(i,j))
           deform  = sqrt(tension**2 + strain**2)
           aiso_smag(ip,jq)    = viscosity_scaling(i,j)*min(visc_crit(i,j), aiso_back(i,j,k)   + fsmag_iso(i,j)*deform)
           aaniso_smag(ip,jq)  = viscosity_scaling(i,j)*min(visc_crit(i,j), aaniso_back(i,j,k) + fsmag_aniso(i,j)*deform)
           stress(i,j,ip,jq,1) = aiso_smag(ip,jq)*tension + aaniso_smag(ip,jq)*delta*sin2theta(i,j)
           stress(i,j,ip,jq,2) = aiso_smag(ip,jq)*strain  - aaniso_smag(ip,jq)*delta*cos2theta(i,j)
           dissipate(ip,jq)    = -aiso_smag(ip,jq)*deform**2 + 2.0*aaniso_smag(ip,jq)*delta**2

           ! viscosities and dissipation for diagnostics 
           aiso(i,j,k) = 0.25*(aiso_smag(0,0)   + aiso_smag(1,0)   + aiso_smag(0,1)   + aiso_smag(1,1))
           wrk1(i,j,k) = 0.25*(aaniso_smag(0,0) + aaniso_smag(1,0) + aaniso_smag(0,1) + aaniso_smag(1,1))
           wrk2(i,j,k) = massqc(i,j,k)*(dissipate(0,0) + dissipate(1,0) + dissipate(0,1) + dissipate(1,1))

        enddo
     enddo
     stress_B(:,:,1,k)  = stress(:,:,0,0,1)
     stress_B(:,:,2,k)  = stress(:,:,1,0,1)
     stress_B(:,:,3,k)  = stress(:,:,0,1,1)
     stress_B(:,:,4,k)  = stress(:,:,1,1,1)
     stress_B(:,:,5,k)  = stress(:,:,0,0,2)
     stress_B(:,:,6,k)  = stress(:,:,1,0,2)
     stress_B(:,:,7,k)  = stress(:,:,0,1,2)
     stress_B(:,:,8,k)  = stress(:,:,1,1,2)
     if( async_domain_update ) then
        if(mod(k,blocksize) == 0 .or. k == nk)   then
           kend(ibl) = k
           id_update(ibl) = mpp_start_update_domains (stress_B(:,:,:,kstart(ibl):kend(ibl)), Dom%domain2d)  
           ibl = ibl+1
           if(ibl<nk) kstart(ibl) = k+1
        endif
     endif
  enddo

  if( .not. async_domain_update ) then
     call mpp_update_domains (stress_B(:,:,:,:), Dom%domain2d)    
  endif  

  ibl = 1
  do k=1,nk
     if( async_domain_update ) then
        if(k == kstart(ibl))   then
           call mpp_complete_update_domains (id_update(ibl), stress_B(:,:,:,kstart(ibl):kend(ibl)), Dom%domain2d) 
           ibl = ibl+1
        endif
     endif
     stress(:,:,0,0,1) = stress_B(:,:,1,k)
     stress(:,:,1,0,1) = stress_B(:,:,2,k)
     stress(:,:,0,1,1) = stress_B(:,:,3,k)
     stress(:,:,1,1,1) = stress_B(:,:,4,k)
     stress(:,:,0,0,2) = stress_B(:,:,5,k)
     stress(:,:,1,0,2) = stress_B(:,:,6,k)
     stress(:,:,0,1,2) = stress_B(:,:,7,k)
     stress(:,:,1,1,2) = stress_B(:,:,8,k)
     ! sum the stress tensor components over the triads
     ! loops designed to reduce calls to mpp_update_domains

     tmpfdelx(:,:,:) = 0.0
     do j=jsc,jec
        do i=isd,iec
           tmpfdelx(i,j,1) = (stress(i,j,1,0,1)   + stress(i,j,1,1,1)  )*massqc(i,j,k)    &
                            +(stress(i+1,j,0,0,1) + stress(i+1,j,0,1,1))*massqc(i+1,j,k)
           tmpfdelx(i,j,2) = (stress(i,j,1,0,2)   + stress(i,j,1,1,2)  )*massqc(i,j,k)    &  
                            +(stress(i+1,j,0,0,2) + stress(i+1,j,0,1,2))*massqc(i+1,j,k)              
        enddo
     enddo

     tmpfdely(:,:,:) = 0.0
     do j=jsd,jec
        do i=isc,iec  
           tmpfdely(i,j,1) = (stress(i,j,0,1,2)   + stress(i,j,1,1,2)  )*massqc(i,j,k)    &
                            +(stress(i,j+1,0,0,2) + stress(i,j+1,1,0,2))*massqc(i,j+1,k) 
           tmpfdely(i,j,2) = (stress(i,j,0,1,1)   + stress(i,j,1,1,1)  )*massqc(i,j,k)    &
                            +(stress(i,j+1,0,0,1) + stress(i,j+1,1,0,1))*massqc(i,j+1,k)
        enddo
     enddo


     ! thickness weighted and density weighted frictional acceleration (kg/m^3)*(m/sec^2) 
     do n=1,2

        tmp(:,:) =  BDX_EU_smag(tmpfdelx(:,:,n))+(3-2*n)*BDY_NU_smag(tmpfdely(:,:,n))    
        do j=jsc,jec
           do i=isc,iec
              wrk1_v(i,j,k,n) = tmp(i,j)*Grd%umask(i,j,k)
           enddo
        enddo

        ! reduce to 5-point laplacian at bottom to avoid problems with thin bottom partial cells
        if (bottom_5point) then
            tmp(:,:) = BDX_EU(aiso_back(:,:,k)*FMX(Thickness%rho_dzu(:,:,k,tau)) &
                      *FDX_U(Velocity%u(:,:,k,n,taum1)-neptune_velocity(:,:,n))) &
                      +BDY_NU(aiso_back(:,:,k)*FMY(Thickness%rho_dzu(:,:,k,tau)) &
                      *FDY_U(Velocity%u(:,:,k,n,taum1)-neptune_velocity(:,:,n)))
            do j=jsc,jec
               do i=isc,iec
                  if(k==Grd%kmu(i,j)) wrk1_v(i,j,k,n) = tmp(i,j)*Grd%umask(i,j,k)*viscosity_scaling(i,j)
               enddo
            enddo
        endif

     enddo ! end of n-loop

     ! use side drag for cells next to side boundaries 
     if(use_side_drag_friction) then
        do j=jsc,jec
           do i=isc,iec
              uvmag           = sqrt(Velocity%u(i,j,k,1,taum1)**2 + Velocity%u(i,j,k,2,taum1)**2)
              uvmag           = min(uvmag,side_drag_friction_uvmag_max)
              velocity_gamma  = rho0*side_drag_friction_scaling*Velocity%cdbot_array(i,j) &
                                *uvmag*umask_next_to_land(i,j,k)
              umag            = abs(Velocity%u(i,j,k,1,taum1))
              vmag            = abs(Velocity%u(i,j,k,2,taum1))
              wrk2_v(i,j,k,1) = -min(side_drag_friction_max, velocity_gamma*umag)*sign(1.0,Velocity%u(i,j,k,1,taum1))
              wrk2_v(i,j,k,2) = -min(side_drag_friction_max, velocity_gamma*vmag)*sign(1.0,Velocity%u(i,j,k,2,taum1))
              wrk3_v(i,j,k,1) =  wrk1_v(i,j,k,1)*(1.0-umask_next_to_land(i,j,k))
              wrk3_v(i,j,k,2) =  wrk1_v(i,j,k,2)*(1.0-umask_next_to_land(i,j,k))
              wrk1_v(i,j,k,1) =  wrk2_v(i,j,k,1) + wrk3_v(i,j,k,1)
              wrk1_v(i,j,k,2) =  wrk2_v(i,j,k,2) + wrk3_v(i,j,k,2)              
            enddo
         enddo
     endif 

  enddo  !end of k-loop


  ! damping on the divergence field   
  if(divergence_damp) then 
      do n=1,2 
         do k=1,nk
            wrk1_v2d(:,:,:) = 0.0
            wrk1_v2d(:,:,1) = FAY(FDX_T(aiso_diverge(:,:)*Adv_vel%diverge_t(:,:,k)))
            wrk1_v2d(:,:,2) = FAX(FDY_T(aiso_diverge(:,:)*Adv_vel%diverge_t(:,:,k)))
            do j=jsc,jec
               do i=isc,iec
                  wrk1_v(i,j,k,n) = wrk1_v(i,j,k,n) + wrk1_v2d(i,j,n)*Grd%umask(i,j,k)
               enddo
            enddo
         enddo
      enddo
  endif


  if(energy_analysis_step) then 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%wrkv(i,j,k,n) = wrk1_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo

  else 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%accel(i,j,k,n) = Velocity%accel(i,j,k,n) + wrk1_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo

      ! vertically averaged isotropic portion of the viscosity 
      lap_viscosity(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               lap_viscosity(i,j) = lap_viscosity(i,j) &
                 + Grd%umask(i,j,k)*Thickness%rho_dzu(i,j,k,tau)*aiso(i,j,k)
            enddo
         enddo
      enddo
      do j=jsc,jec
         do i=isc,iec
            lap_viscosity(i,j) = &
            Grd%umask(i,j,1)*lap_viscosity(i,j)/(epsln+Thickness%mass_u(i,j,tau))
         enddo
      enddo
      call mpp_update_domains (lap_viscosity(:,:), Dom%domain2d)    


      call diagnose_3d_u(Time, Grd, id_aiso, aiso(:,:,:))
      call diagnose_3d_u(Time, Grd, id_aaniso, wrk1(:,:,:))
      if (id_along > 0)  call diagnose_3d_u(Time, Grd, id_along,  aiso(:,:,:)+0.5*wrk1(:,:,:))
      if (id_across > 0) call diagnose_3d_u(Time, Grd, id_across, aiso(:,:,:)-0.5*wrk1(:,:,:))

      call diagnose_3d_u(Time, Grd, id_lap_fric_u, wrk1_v(:,:,:,1))
      call diagnose_3d_u(Time, Grd, id_lap_fric_v, wrk1_v(:,:,:,2))

      if (id_horz_lap_diss > 0) then 
          do k=1,nk
             do j=jsd,jed
                do i=isd,ied
                   wrk2(i,j,k) = wrk2(i,j,k)*Grd%daur(i,j)
                enddo
             enddo
          enddo
          call diagnose_3d_u(Time, Grd, id_horz_lap_diss, wrk2(:,:,:))
      endif 

      call diagnose_2d_u(Time, Grd, id_viscosity_scaling, viscosity_scaling(:,:))

      if(use_side_drag_friction) then 
         call diagnose_3d_u(Time, Grd, id_lap_fric_u, wrk3_v(:,:,:,1))
      else 
         call diagnose_3d_u(Time, Grd, id_lap_fric_u, wrk1_v(:,:,:,1))
      endif

      if(use_side_drag_friction) then 
         call diagnose_3d_u(Time, Grd, id_lap_fric_v, wrk3_v(:,:,:,2))
      else 
         call diagnose_3d_u(Time, Grd, id_lap_fric_v, wrk1_v(:,:,:,2))
      endif

      call diagnose_3d_u(Time, Grd, id_lap_plus_side_fric_u, wrk1_v(:,:,:,1))
      call diagnose_3d_u(Time, Grd, id_lap_plus_side_fric_v, wrk1_v(:,:,:,2))
      call diagnose_3d_u(Time, Grd, id_side_drag_friction_u, wrk2_v(:,:,:,1))
      call diagnose_3d_u(Time, Grd, id_side_drag_friction_v, wrk2_v(:,:,:,2))

  endif

  if(debug_this_module) then
      write(stdoutunit,*) ' ' 
      write(stdoutunit,*) 'From ocean_lapgen_friction_mod: friction chksums'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('rho_dzu(tau)', Thickness%rho_dzu(COMP,:,tau)*Grd%umask(COMP,:))
      call write_chksum_3d('lapgen friction(1)', wrk1_v(COMP,:,1)*Grd%umask(COMP,:))
      call write_chksum_3d('lapgen friction(2)', wrk1_v(COMP,:,2)*Grd%umask(COMP,:))
  endif


end subroutine lapgen_friction
! </SUBROUTINE> NAME="lapgen_friction"


!#######################################################################
! <FUNCTION NAME="BDX_EU_smag">
!
! <DESCRIPTION>
! Compute backwards derivative in X of a quantity defined on the east 
! face of a U-cell. Slightly modified version of BDX_EU used in
! ocean_operators.F90. If input is a(i,j) then output is defined 
! at (i-1/2,j).
!
! BDX_EU_smag(a) has dimensions of a*m^-3 
!
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! field defined on the east face of a U-cell
! </IN>
!
function BDX_EU_smag(a)

  real, dimension(isd:,jsd:), intent(in) :: a
  real, dimension(isd:ied,jsd:jed)       :: BDX_EU_smag
  integer :: i, j

  do j=jsd,jed
    do i=isd+1,ied
      BDX_EU_smag(i,j) = &
      (Grd%dyue_dxuer(i,j)*a(i,j) - Grd%dyue_dxuer(i-1,j)*a(i-1,j))*daur_dyur(i,j)
    enddo
    BDX_EU_smag(isd,j) = 0.0
  enddo

end function BDX_EU_smag
! </FUNCTION> NAME="BDX_EU_smag"


!#######################################################################
! <FUNCTION NAME="BDY_NU_smag">
!
! <DESCRIPTION>
! Compute backwards derivative in Y of a quantity defined on the north
! face of a U-cell. Slightly modified version of BDY_EU used in
! ocean_operators.F90. If input is a(i,j) then output is defined 
! at (i,j-1/2)
!
! BDY_NU_smag(a) has dimensions of a*m^-3 
!
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! field defined on the north face of a U-cell
! </IN>
!
function BDY_NU_smag(a)

  real, dimension(isd:,jsd:), intent(in) :: a
  real, dimension(isd:ied,jsd:jed)       :: BDY_NU_smag
  integer :: i, j

  do j=jsd+1,jed
    do i=isd,ied            
      BDY_NU_smag(i,j) = &
      (Grd%dxun_dyunr(i,j)*a(i,j) - Grd%dxun_dyunr(i,j-1)*a(i,j-1))*daur_dxur(i,j)
    enddo
  enddo
  BDY_NU_smag(:,jsd) = 0.0

end function BDY_NU_smag
! </FUNCTION> NAME="BDY_EU_smag"


!#######################################################################
! <SUBROUTINE NAME="anisotropic_ncar">
!
! <DESCRIPTION>
!
!     Spatially-varying anisotropic viscosity initialization
!
!     This routine defines NCOM-like spatial distributions of
!     viscosity coefficients F_PARA and F_PERP.
!     Uses NCAR CCSM2.0 algorithm with cm^2/sec --> m^2/sec.  
!
!     written by:     Stephen Yeager 3/2000                           <BR/> 
!
!     modified by:    Gokhan Danabasoglu (08/2001)                    <BR/>
!
!     port to mom4:   Stephen.Griffies (9/2002)  
!
!     update to mom4p1 based on new tunes from NCAR
!                    Stephen.Griffies (7/2007)  
!
!
!   "A_viscosity" = F_PARA = Along = viscosity parallel to flow 
!                  = max{0.5*visc_vel_scale(z)*A*max[dx,dy],vconst_6}
!
!   where                                                                <BR/>    
!          A = 0.425 * cos(pi*y*radian/30) + 0.575   for |y*radian| < 30 <BR/>
!          A = 0.15                                  otherwise 
!
!   Here, A provides a horizontal variation for visc_vel_scale.
!
!   "B_viscosity" = F_PERP = Across = viscosity perpendicular to flow = max( bu, bv)
!
!   and                                                                  <BR/>    
!        F_PARA = min(F_PARA, AMAX_CFL),                                 <BR/> 
!        F_PERP = min(F_PERP, AMAX_CFL),                                 <BR/>   
!        F_PARA = max(F_PARA, F_PERP)                                    <BR/> 
!   are enforced 
!
!   In the above equations, 
!
!        bu  = vconst_1 * ( 1 + vconst_2  * ( 1 + cos( 2*y + pi ) ) )        <BR/>
!        bv  = vconst_3 * beta_f * dx^3   * exp( - (vconst_4 * distance)^2 ) <BR/>
!
!   with                                                                     <BR/>        
!        beta_f         (x,y)   = 2 * omega_earth* cos(ULAT(i,j)) / radius   <BR/>  
!        distance       (x,y,z) = actual distance to "vconst_5" points       <BR/>  
!                                 west of the nearest western boundary       <BR/>  
!        dx             (x,y)   = DXU(i,j)                                   <BR/>  
!        dy             (x,y)   = DYU(i,j)                                   <BR/> 
!        visc_vel_scale (z)     = vconst_7 * exp(-zt(k)/visc_vel_scale_length)  <BR/> 
!        visc_vel_scale_length  = e-folding scale ( default = 1500.0e2 cm)      <BR/> 
!        y              (x,y)   = ULAT(i,j), latitude of "u/v" grid pts in radians   <BR/> 
!        In MOM, ULAT(radians) = xu*pi/180 with xu(i,j) the longitude of U grid points in degrees
!
!   "vconst_#" are input parameters defined in namelist ocean_lapgen_friction_general_nml. 
!   "vconst_1", "vconst_6", and "vconst_4" have dimensions of cm^2/s,
!   cm^2/s, and 1/cm, respectively. "vconst_5" is an INTEGER.
!
!   NOTE: The nearest western boundary computations are done along the
!         model i-grid lines. Therefore, viscosity based on these are 
!         only approximate in the high Northern Hemisphere when using 
!         generalized coordinates with coordinate pole(s) shifted onto land. 
!
! </DESCRIPTION>
!
subroutine anisotropic_ncar

  integer :: i, j, k
  integer :: n, ncount
  integer :: is, ie, ip1, ii
  integer :: index, indexo
  integer, dimension(nx) :: iwp
  integer, dimension(nx) :: nwbp_global

  real, dimension(nx,jsc:jec)            :: dxtn_global
  real, dimension(nx,jsc:jec)            :: kmu_global
  real, dimension(isd:ied,jsd:jed)  :: kmu_tmp
  real, dimension(nx)               :: dist_g 

  real :: dist_max, vvsl  
  real :: a_para, bu, bv 
  real :: f_para, f_perp
  real :: visc_vel_scale

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lapgen_friction_mod (anisotropic_ncar): module must be initialized')
  endif 

  dist_max = 1.e10                  ! distance for ACC region (cm)
  vvsl     = visc_vel_scale_length  ! exponential decay scale (cm) for decay away from ocean surface

  dxtn_global(:,:) = 0.0
  kmu_global(:,:)  = 0.0
  kmu_tmp(:,:)     = Grd%kmu(:,:)

  call mpp_global_field(Dom%domain2d,kmu_tmp,kmu_global, flags = XUPDATE)  
  call mpp_global_field(Dom%domain2d,Grd%dxtn,dxtn_global, flags = XUPDATE)

  do k=1,nk

     ! 100.0 factor in exponential is to convert MOM zt from (m) to (cm)
     ! visc_vel_scale is in cm/sec.  It is used for along-stream viscosity. 
     visc_vel_scale = vconst_7 * exp(-100.0*Grd%zt(k)/vvsl)   

     do j=jsc,jec


        ! determine nearest western boundary
        ncount         = 0
        nwbp_global(:) = 0
        iwp(:)         = 0
        dist_g(:)      = 0.0

        do i=1,Grd%ni
           ip1 = i+1
           if(i==Grd%ni) then 
               if(Grd%cyclic_x) then 
                   ip1=1
               else
                   ip1=i  
               endif
           endif
           if(kmu_global(i,j)<k .and. kmu_global(ip1,j) >= k) then 
               ncount      = ncount+1
               iwp(ncount) = i
           endif
        enddo

        if (ncount > 0) then
            do n=1,ncount-1
               is = iwp(n)
               ie = iwp(n+1)-1
               do i=is,ie
                  nwbp_global(i)=is
               enddo
            enddo
            do i=1,Grd%ni
               if(nwbp_global(i)==0) nwbp_global(i) = iwp(ncount)
            enddo
        endif


        ! determine distance (cm) to nearest western boundary
        do i=1,Grd%ni

           index  = nwbp_global(i)
           indexo = index + vconst_5
           if ( index .eq. 0) then
               dist_g(i) = dist_max
           elseif ( i .ge. index  .and.  i .le. indexo ) then
               dist_g(i) = 0.0
           elseif ( (i .gt. indexo) ) then
               dist_g(i) = dxtn_global(i,j)+dist_g(i-1)
           elseif ( i .lt. index ) then
               if (indexo .le. Grd%ni) then
                   if (i .eq. 1) then
                       dist_g(i) = 0.0
                       do ii=indexo+1,Grd%ni
                          dist_g(i)=dxtn_global(ii,j) + dist_g(i)
                       enddo
                       dist_g(i) = dxtn_global(i,j)+dist_g(i)
                   else
                       dist_g(i) = dxtn_global(i,j)+dist_g(i-1)
                   endif
               else
                   if (i .le. (indexo - Grd%ni)) then
                       dist_g(i) = 0.0
                   else
                       dist_g(i) = dxtn_global(i,j)+dist_g(i-1)
                   endif
               endif
           endif

        enddo

        ! convert distance in MOM (m) to POP1.4 (cm)
        dist_g(:) = 100.0*dist_g(:)

 
        !calculate viscosity over comp domain 
        do i=isc,iec

           
           if(viscosity_ncar_2000) then 

               ! f_para is viscosity parallel to flow 
               ! 100.0 factor in f_para converts (m) to (cm)
               a_para = 0.15
               if ( abs(Grd%yu(i,j)) < 30.0) then  ! yu is in degrees, not radians 
                   a_para = 0.425*cos(pi*Grd%yu(i,j)/30.0) + 0.575
               endif
               f_para = &
                    max(0.5 * visc_vel_scale * a_para * 100.0*max(Grd%dxu(i,j),Grd%dyu(i,j)), vconst_6 )

               ! f_perp is viscosity perpendicular to flow 
               ! 1e4 factor in bv converts (m) to (cm) for dxu and beta_f 
               bu = vconst_1*(1.0 + vconst_2*(1.0 + cos((2.0*Grd%yu(i,j)/radian)+pi)))
               bv = 1e4*vconst_3*Grd%beta(i,j)*Grd%dxu(i,j)**3
               bv = bv*exp(-(vconst_4*dist_g(i+Dom%ioff))**2)
               f_perp = min(max(bu,bv),0.99*f_para)

           elseif(viscosity_ncar_2007) then 

               ! bv here is a temporary 
               bv = (min(abs(Grd%yu(i,j)),vconst_8)*90.0 / vconst_8) / radian 
               bu = vconst_1 * ( 1.0 + vconst_2*(1.0-cos(2.0*bv)))

               bv = 1e4*vconst_3*Grd%beta(i,j)*Grd%dxu(i,j)**3
               bv = bv*exp(-(vconst_4*dist_g(i+Dom%ioff))**2)
               f_para = max(bv,vconst_6)
               f_perp = min(max(bu,bv),0.99*f_para)

           endif

           if(debug_ncar_A) then 
             f_perp=f_para
           endif 
           if(debug_ncar_B) then 
             f_para=f_perp
           endif 

           ! revert to isotropic background viscosity outside equatorial_zonal_lat
           if(ncar_isotropic_off_equator .and. abs(Grd%yu(i,j)) >= equatorial_zonal_lat) then 
             f_perp=f_para
           endif   

           ! 1.e-4 converts from cm^2/sec to m^2/sec
           aiso_back(i,j,k)   = 1.e-4*0.5*(f_para + f_perp) 
           aaniso_back(i,j,k) = 1.e-4*(f_para - f_perp)

           ! revert to isotropic background viscosity beneath some level
           if(ncar_isotropic_at_depth .and. Grd%zt(k) >= ncar_isotropic_depth) then 
             aaniso_back(i,j,k) = 0.0
             aiso_back(i,j,k)   = max(aiso_back(i,j,k), ncar_isotropic_at_depth_visc)
           endif   


        enddo !i

     enddo ! j
  enddo    ! k

  ! need these viscosities in the halo regions
  call mpp_update_domains (aiso_back(:,:,:),   Dom%domain2d)    
  call mpp_update_domains (aaniso_back(:,:,:), Dom%domain2d)    


end subroutine anisotropic_ncar
! </SUBROUTINE>  NAME="anisotropic_ncar"


!#######################################################################
! <SUBROUTINE NAME="lapgen_viscosity_check">
!
! <DESCRIPTION>
! Subroutine to perform linear stability check for the Laplacian 
! operator given a value for the horizontal biharmonic viscosity.
! </DESCRIPTION>
!
subroutine lapgen_viscosity_check

  integer       :: num, i, j, k
  integer, save :: unit=6, max_num=3
  real :: fudge

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return 

  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL,&
     '==>Error in ocean_lapgen_friction_mod (lapgen_viscosity_check): needs initialization')
  endif 

  fudge=1.001  ! to eliminate roundoffs causing aiso=visc_crit+epsln

  write (stdoutunit,'(/60x,a/)') &
  ' Excessive horizontal Laplacian friction summary:'
  write (stdoutunit,'(1x,a/)') &
  'Locations (if any) where viscosity exceeds conservative linear stability constraint'
  num = 0
  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        if (Grd%umask(i,j,k) > 0.0) then 
          if (aiso(i,j,k) > fudge*visc_crit(i,j) .and. num < max_num) then
            num = num + 1
            write (unit,9600) &
            'aiso(',aiso(i,j,k), visc_crit(i,j), i, j, k, &
            Grd%xu(i,j), Grd%yu(i,j), Grd%zt(k), mpp_pe()
          endif
        endif 
      enddo
    enddo
  enddo
  call mpp_sum(num)
  if (num > max_num) write (stdoutunit,*) ' (a max of ',max_num,' violations per pe are listed)'

9600  format(/' Warning: ',a,es16.8,' m^2/s) exceeds max value (',es16.8,') at (i,j,k) = ', &
            '(',i4,',',i4,',',i4,'),',' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.0,'m, pe=',i3,')')


end subroutine lapgen_viscosity_check
! </SUBROUTINE> NAME="lapgen_viscosity_check"


!#######################################################################
! <SUBROUTINE NAME="lapgen_reynolds_check">
!
! <DESCRIPTION>
! Subroutine to compute the LLaplacian grid Reynolds number.  Large 
! Reynolds numbers indicate regions where solution may experience 
! some grid noise due to lack of enough horizontal friction. 
! </DESCRIPTION>
!
! <IN NAME="u" TYPE="real" DIM="(isd:ied,jsd:jed,nk,2)">
! Horizontal velocity field at time tau
! </IN>
!
subroutine lapgen_reynolds_check(Time, Velocity)

  type(ocean_time_type),     intent(in) :: Time
  type(ocean_velocity_type), intent(in) :: Velocity

  real :: rame, ramn, reyx, reyy
  real :: reynx0, reyny0, reynx,reyny, reynu,reynv, reynmu,reynmv
  integer :: ireynx,jreynx,kreynx, ireyny,jreyny,kreyny
  integer :: i, j, k, tau
  integer, save :: unit=6

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lapgen_friction_mod (lapgen_reynolds_check): needs initialization')
  endif 

  tau = Time%tau

  ! look for max grid reynolds numbers using velocities at "tau".

  ireynx=isc; jreynx=jsc; kreynx=1; reynx=0.0
  ireyny=isc; jreyny=jsc; kreyny=1; reyny=0.0
  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        rame = 1.0/(aiso(i,j,k) + epsln)
        ramn = 1.0/(aiso(i,j,k) + epsln)
        reyx = abs(Velocity%u(i,j,k,1,tau)*Grd%dxu(i,j))*rame
        if (reyx > reynx) then
          ireynx = i
          jreynx = j
          kreynx = k
          reynx  = reyx
          reynu  = Velocity%u(i,j,k,1,tau)
          reynmu = 1.0/rame
        endif
        reyy = abs(Velocity%u(i,j,k,2,tau)*Grd%dyu(i,j))*ramn
        if (reyy > reyny) then
          ireyny = i
          jreyny = j
          kreyny = k
          reyny  = reyy
          reynv  = Velocity%u(i,j,k,2,tau)
          reynmv = 1.0/ramn
        endif
      enddo
    enddo
  enddo
  write (stdoutunit,'(/60x,a/)') ' Horizontal Laplacian Reynolds number summary'

  reynx0 = reynx
  reyny0 = reyny
  call mpp_max(reynx)
  call mpp_max(reyny)
  
  if (reynx == reynx0 .and. reynx > 1.e-6) then
    write (unit,10300) &
    reynx, ireynx, jreynx, kreynx, Grd%xu(ireynx,jreynx), &
    Grd%yu(ireynx,jreynx), Grd%zt(kreynx), reynu, reynmu
  endif
  
  if (reyny == reyny0 .and. reyny > 1.e-6) then
    write (unit,10400) &
    reyny, ireyny, jreyny, kreyny, Grd%xu(ireyny,jreyny), &
    Grd%yu(ireyny,jreyny), Grd%zt(kreyny), reynv, reynmv
  endif

  10300 format (1x,'Maximum zonal Re =',es9.2,' at (i,j,k) = (',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.2,'), U =',es9.2, ', mix =',e9.2)
  10400 format (1x,'Maximum merid Re =',es9.2,' at (i,j,k) = (',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.2,'), V =',es9.2, ', mix =',e9.2)


end subroutine lapgen_reynolds_check
! </SUBROUTINE> NAME="lapgen_reynolds_check"


!#######################################################################
! <SUBROUTINE NAME="compute_neptune_velocity">
!
! <DESCRIPTION>
! Compute Neptune velocity.  
!
! Method follows that used in MOM2 and MOM3 as implemented by 
! Greg Holloway (zounds@ios.bc.ca) and Michael Eby (eby@uvic.ca) 
! Coded in mom4 by Stephen.Griffies 
!
! Neptune is calculated as an equilibrium streamfunction given by 
! pnep = -f*snep*snep*ht and is applied through friction whereby 
! the solution is damped towards the equilibrium streamfunction 
! rather than being damped towards zero kinetic energy. 
!
! ht    = depth of tracer cells 
! snep = spnep + (senep-spnep)*(0.5 + 0.5*cos(2.0*latitude))
!
! Neptune length scale snep has a value of senep at the
! equator and smoothly changes to spnep at the poles
!
! Reference:
! Holloway, G., 1992: Representing topographic stress for large
! scale ocean models, J. Phys. Oceanogr., 22, 1033-1046
!
! Eby and Holloway, 1994: Sensitivity of a large scale ocean model
! to a parameterization of topographic stress.  JPO, vol. 24,
! pages 2577-2588
!
! March 2012
! Stephen.Griffies 
! Algorithm updated to Eby and Holloway (1994)
!
! </DESCRIPTION>
!
subroutine compute_neptune_velocity(Time)

  type(ocean_time_type), intent(in) :: Time
  real, dimension(isd:ied,jsd:jed)  :: neptune_ft
  real, dimension(isd:ied,jsd:jed)  :: neptune_psi
  real                              :: neptune_length
  real                              :: active_cells
  integer                           :: i,j,k
  integer                           :: num_smooth

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lapgen_friction_mod (compute_neptune_velocity): needs initialization')
  endif 

  allocate (neptune_velocity(isd:ied,jsd:jed,2))
  neptune_velocity = 0.0
  if(.not. neptune) return 

  ! neptune_psi is at T-cell point 
  do j=jsd,jed
    do i=isd,ied
      neptune_ft(i,j)  = 2.0*omega_earth*sin(Grd%phit(i,j))
      neptune_length   = neptune_length_pole  &
      + 0.5*(neptune_length_eq-neptune_length_pole)*(1.0 + cos(2.0*Grd%phit(i,j)))
      neptune_psi(i,j) = -neptune_ft(i,j)*neptune_length*neptune_length*Grd%ht(i,j)
    enddo
  enddo

  ! compute velocity 
  neptune_velocity(:,:,1) = -FDY_ET(FAX(neptune_psi(:,:)))
  neptune_velocity(:,:,2) =  FDX_NT(FAY(neptune_psi(:,:)))
  do j=jsc,jec
     do i=isc,iec
        neptune_velocity(i,j,1) = neptune_velocity(i,j,1)*Grd%umask(i,j,1)/(neptune_depth_min+Grd%hu(i,j))
        neptune_velocity(i,j,2) = neptune_velocity(i,j,2)*Grd%umask(i,j,1)/(neptune_depth_min+Grd%hu(i,j)) 
     enddo
  enddo
  call mpp_update_domains(neptune_velocity(:,:,1), neptune_velocity(:,:,2),&
                          Dom%domain2d,gridtype=BGRID_NE)


  ! optional smoothing
  if(neptune_smooth) then 
      do num_smooth=1,neptune_smooth_num

         wrk1_v2d(:,:,:) = 0.0
         k=1
         do j=jsc,jec
            do i=isc,iec

               if(Grd%tmask(i,j,k)==1.0) then 

                   active_cells = 4.0       +&
                        Grd%umask(i-1,j,k)  +&
                        Grd%umask(i+1,j,k)  +&
                        Grd%umask(i,j-1,k)  +&
                        Grd%umask(i,j+1,k)

                   if (active_cells > 4.0) then
                       wrk1_v2d(i,j,1) =                  &  
                         (4.0*neptune_velocity(i,j,1)    +&
                            neptune_velocity(i-1,j,1)    +&
                            neptune_velocity(i+1,j,1)    +&
                            neptune_velocity(i,j-1,1)    +&
                            neptune_velocity(i,j+1,1)) / active_cells
                       wrk1_v2d(i,j,2) =                  &  
                         (4.0*neptune_velocity(i,j,2)    +&
                            neptune_velocity(i-1,j,2)    +&
                            neptune_velocity(i+1,j,2)    +&
                            neptune_velocity(i,j-1,2)    +&
                            neptune_velocity(i,j+1,2)) / active_cells
                   else
                       wrk1_v2d(i,j,1) = neptune_velocity(i,j,1)
                       wrk1_v2d(i,j,2) = neptune_velocity(i,j,2)
                   endif

               endif

            enddo
         enddo

         do j=jsc,jec
            do i=isc,iec
               neptune_velocity(i,j,1) = wrk1_v2d(i,j,1)*Grd%umask(i,j,k)
               neptune_velocity(i,j,2) = wrk1_v2d(i,j,2)*Grd%umask(i,j,k)
            enddo
         enddo

         call mpp_update_domains(neptune_velocity(:,:,1), neptune_velocity(:,:,2),&
                                 Dom%domain2d,gridtype=BGRID_NE)

      enddo  ! enddo for number of smoothing iterations 
  endif      ! endif for smooth



  ! diagnostics 
  id_neptune_lap_u = register_static_field('ocean_model', 'neptune_lap_u',               &
                   Grd%vel_axes_uv(1:2), 'Zonal velocity from neptune Laplacian scheme', &
                   'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  call diagnose_2d_u(Time, Grd, id_neptune_lap_u, neptune_velocity(:,:,1))

  id_neptune_lap_v = register_static_field('ocean_model', 'neptune_lap_v',                    &
                   Grd%vel_axes_uv(1:2), 'Meridional velocity from neptune Laplacian scheme', &
                   'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  call diagnose_2d_u(Time, Grd, id_neptune_lap_v, neptune_velocity(:,:,2))

  id_neptune_psi   = register_static_field('ocean_model', 'neptune_psi',             &
                     Grd%tracer_axes(1:2), 'Transport for neptune parameterization', &
                     'm^3/sec', missing_value=missing_value, range=(/-1.e12,1.e12/))
  call diagnose_2d_u(Time, Grd, id_neptune_psi, neptune_psi(:,:))

  id_neptune_ft   = register_static_field('ocean_model', 'neptune_ft',                                &
                    Grd%tracer_axes(1:2),'Coriolis parameter used for  neptune parameterization Psi', &
                    '1/sec', missing_value=missing_value, range=(/-1.e3,1.e3/))
  call diagnose_2d_u(Time, Grd, id_neptune_ft, neptune_ft(:,:))


end subroutine compute_neptune_velocity
! </SUBROUTINE> NAME="compute_neptune_velocity"

end module ocean_lapgen_friction_mod
      
      

#include <fms_platform.h>

module land_transitions_mod

#include "../shared/debug.inc"

use constants_mod, only : PI

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only : write_version_number, string, error_mesg, FATAL, WARNING, NOTE, &
     mpp_pe, write_version_number, file_exist, close_file, &
     check_nml_error, stdlog, mpp_root_pe, fms_error_handler
use mpp_io_mod, only : mpp_open, mpp_close, MPP_RDONLY, MPP_ASCII
use time_manager_mod, only : time_type, set_date, get_date, set_time, &
     operator(+), operator(-), operator(>), operator(<), operator(<=), operator(/), &
     operator(//), days_in_year, print_date, increment_date, get_time, &
     valid_calendar_types, get_calendar_type
use get_cal_time_mod, only : get_cal_time
use horiz_interp_mod, only : horiz_interp_type, horiz_interp_init, &
     horiz_interp_new, horiz_interp_del, horiz_interp
use time_interp_mod, only : time_interp
use diag_manager_mod, only : register_diag_field, send_data

use nfu_mod, only : nfu_validtype, nfu_inq_var, nfu_get_dim_bounds, nfu_get_rec, &
     nfu_get_dim, nfu_get_valid_range, nfu_is_valid

use vegn_data_mod, only : &
     N_LU_TYPES, LU_NTRL, LU_SCND, landuse_name, landuse_longname

use cana_tile_mod, only : cana_tile_heat
use snow_tile_mod, only : snow_tile_heat
use vegn_tile_mod, only : vegn_tile_heat
use soil_tile_mod, only : soil_tile_heat

use land_tile_mod, only : &
     land_tile_type, land_tile_list_type, land_tile_enum_type, new_land_tile, delete_land_tile, &
     first_elmt, tail_elmt, next_elmt, operator(/=), operator(==), current_tile, &
     land_tile_list_init, land_tile_list_end, &
     empty, erase, remove, insert, land_tiles_can_be_merged, merge_land_tiles, &
     get_tile_water, land_tile_carbon, land_tile_heat
use land_tile_io_mod, only : print_netcdf_error

use land_data_mod, only : &
     land_data_type, lnd
use vegn_tile_mod, only : &
     vegn_tile_type, vegn_tran_priority
use vegn_harvesting_mod, only : &
     vegn_cut_forest

use land_debug_mod, only : set_current_point, is_watch_point, get_current_point
     
implicit none
private

! ==== public interface =====================================================
public :: land_transitions_init
public :: land_transitions_end
public :: save_land_transitions_restart

public :: land_transitions
! ==== end of public interface ==============================================

! ==== module constants =====================================================
character(len=*), parameter   :: &
     version = '$Id: transitions.F90,v 20.0 2013/12/13 23:30:55 fms Exp $', &
     tagname = '$Name: tikal $', &
     module_name = 'land_transitions_mod', &
     diag_mod_name = 'landuse'
! selectors for overshoot handling options, for efficiency
integer, parameter :: &
     OPT_IGNORE = 0, &
     OPT_STOP   = 1, &
     OPT_REPORT = 2

! ==== NetCDF declarations ===================================================
include 'netcdf.inc'
#define __NF_ASRT__(x) call print_netcdf_error((x),module_name,__LINE__)

! ==== data types ===========================================================
type :: tran_type
   integer :: donor    = 0  ! kind of donor tile
   integer :: acceptor = 0  ! kind of acceptor tile
   real    :: frac     = 0  ! area of transition
end type tran_type

! ==== module data ==========================================================
logical :: module_is_initialized = .FALSE.
integer :: ncid ! netcd id of the input file
integer :: input_ids (N_LU_TYPES,N_LU_TYPES) ! id's of input transition rate fields
integer :: diag_ids  (N_LU_TYPES,N_LU_TYPES)
real, allocatable :: buffer_in(:,:) ! buffer for input data
type(horiz_interp_type), save :: interp
type(time_type), allocatable :: time_in(:) ! time axis in input data
type(time_type) :: time0 ! time of previous transition calculations
integer :: overshoot_opt ! selector for overshoot handling options, for efficiency
integer :: conservation_opt ! selector for non-conservation handling options, for efficiency

! ---- namelist variables ---------------------------------------------------
logical :: do_landuse_change = .FALSE. ! if true, then the landuse changes with time
character(len=512) :: input_file = ''
! sets how to handle transition overshoot: that is, the situation when transition 
! is larger than available area of the given land use type.
character(len=16) :: overshoot_handling = 'report' ! or 'stop', or 'ignore'
real :: overshoot_tolerance = 1e-4 ! tolerance interval for overshoots 
! specifies how to handle non-conservation
character(len=16) :: conservation_handling = 'stop' ! or 'report', or 'ignore'

namelist/landuse_nml/input_file, do_landuse_change, &
     overshoot_handling, overshoot_tolerance, &
     conservation_handling
     

contains ! ###################################################################

! ============================================================================
subroutine land_transitions_init(id_lon, id_lat)
  integer, intent(in) :: id_lon, id_lat ! the IDs of land diagnostic axes

  ! ---- local vars
  logical        :: grid_initialized = .false.
  integer        :: len, unit, ierr, io
  integer        :: year,month,day,hour,min,sec
  integer        :: k1,k2,i
  real,allocatable :: lon_in(:,:),lat_in(:,:)
  character(len=12) :: fieldname
  integer :: dimids(NF_MAX_VAR_DIMS), dimlens(NF_MAX_VAR_DIMS)
  integer :: nrec ! number of records in the input file
  real, allocatable :: time(:)  ! real values of time coordinate
  real, allocatable :: mask_in(:,:) ! valid data mask on the input data grid
  type(nfu_validtype) :: v ! valid values range
  integer :: timedim ! id of the record (time) dimension
  integer :: timevar ! id of the time variable
  character(len=NF_MAX_NAME) :: timename  ! name of the time variable
  character(len=256)         :: timeunits ! units ot time in the file
  character(len=24) :: calendar ! model calendar

  if(module_is_initialized) return

  call horiz_interp_init
  call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=landuse_nml, iostat=io)
  ierr = check_nml_error(io, 'landuse_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file ( )
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=landuse_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'landuse_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif
  
  if (mpp_pe() == mpp_root_pe()) then
     unit=stdlog()
     write(unit, nml=landuse_nml)
  endif

  ! read restart file, if any
  if (file_exist('INPUT/landuse.res')) then
     call error_mesg('land_transitions_init',&
          'reading restart "INPUT/landuse.res"',&
          NOTE)
     call mpp_open(unit,'INPUT/landuse.res', action=MPP_RDONLY, form=MPP_ASCII)
     read(unit,*) year,month,day,hour,min,sec
     time0 = set_date(year,month,day,hour,min,sec)
     call mpp_close(unit)
  else
     call error_mesg('land_transitions_init',&
          'cold-starting land transitions',&
          NOTE)
     time0 = set_date(0001,01,01);
  endif
  
  ! parse the overshoot handling option
  if (trim(overshoot_handling)=='stop') then
     overshoot_opt = OPT_STOP
  else if (trim(overshoot_handling)=='ignore') then
     overshoot_opt = OPT_IGNORE
  else if (trim(overshoot_handling)=='report') then
     overshoot_opt = OPT_REPORT
  else
     call error_mesg('land_transitions_init','overshoot_handling value "'//&
          trim(overshoot_handling)//'" is illegal, use "stop", "report", or "ignore"',&
          FATAL)
  endif

  ! parse the non-conservation handling option
  if (trim(conservation_handling)=='stop') then
     conservation_opt = OPT_STOP
  else if (trim(conservation_handling)=='ignore') then
     conservation_opt = OPT_IGNORE
  else if (trim(conservation_handling)=='report') then
     conservation_opt = OPT_REPORT
  else
     call error_mesg('land_transitions_init','conservation_handling value "'//&
          trim(conservation_handling)//'" is illegal, use "stop", "report", or "ignore"',&
          FATAL)
  endif

  if (do_landuse_change) then
     if (trim(input_file)=='') call error_mesg('landuse_init', &
          'do_landuse_change is requested, but landuse transition file is not specified', &
          FATAL)

     ierr=nf_open(input_file,NF_NOWRITE,ncid)

     if(ierr/=NF_NOERR) call error_mesg('landuse_init', &
          'do_landuse_change is requested, but landuse transition file "'// &
          trim(input_file)//'" could not be opened because '//nf_strerror(ierr), FATAL)
  
     ! initialize array of input field ids
     input_ids(:,:) = 0
     do k1 = 1,size(input_ids,1)
     do k2 = 1,size(input_ids,2)
        ! construct a name of input field and register the field
        fieldname = trim(landuse_name(k1))//'2'//trim(landuse_name(k2))
        if(trim(fieldname)=='2') cycle ! skip unspecified tiles
        
        ierr = nfu_inq_var(ncid,fieldname, id=input_ids(k1,k2))
        if (ierr/=NF_NOERR) then
           if (ierr==NF_ENOTVAR) then
              input_ids(k1,k2)=-1 ! to indicate that input field is not present in the input data
           else
              call error_mesg('landuse_init',&
                   'error initializing field "'//trim(fieldname)//&
                   '" from file "'//trim(input_file)//'" : '//&
                   nf_strerror(ierr), &
                   FATAL)
           endif
        endif
        ! initialize the input data grid and horizontal interpolator
        if ((.not.grid_initialized).and.(input_ids(k1,k2)>0)) then
           ! we assume that all transition rate fields are specified on the same grid, 
           ! in both horizontal and time "directions". Therefore there is a single grid
           ! for all fields, initialized only once.
           
           __NF_ASRT__(nfu_inq_var(ncid,fieldname,dimids=dimids,dimlens=dimlens,nrec=nrec))
           ! allocate temporary variables
           allocate(lon_in(dimlens(1)+1,1), &
                    lat_in(1,dimlens(2)+1), &
                    time(nrec), mask_in(dimlens(1),dimlens(2)) )
           ! allocate module data
           allocate(buffer_in(dimlens(1),dimlens(2)),time_in(nrec))

           ! get the boundaries of the horizontal axes and initialize horizontal
           ! interpolator
           __NF_ASRT__(nfu_get_dim_bounds(ncid, dimids(1), lon_in(:,1)))
           __NF_ASRT__(nfu_get_dim_bounds(ncid, dimids(2), lat_in(1,:)))

           ! get the first record from variable and obtain the mask of valid data
           ! assume that valid mask does not change with time
           __NF_ASRT__(nfu_get_rec(ncid,fieldname,1,buffer_in))
           ! get the valid range for the variable
           __NF_ASRT__(nfu_get_valid_range(ncid,fieldname,v))
           ! get the mask
           where (nfu_is_valid(buffer_in,v))
              mask_in = 1
           elsewhere
              mask_in = 0
           end where

           ! add mask_in and mask_out to this call
           call horiz_interp_new(interp, lon_in*PI/180,lat_in*PI/180, &
                lnd%lonb, lnd%latb, &
                interp_method='conservative',&
                mask_in=mask_in, is_latlon_in=.TRUE. )
           
           ! get the time axis 
           __NF_ASRT__(nf_inq_unlimdim(ncid, timedim))
           __NF_ASRT__(nfu_get_dim(ncid, timedim, time))
           ! get units of time
           __NF_ASRT__(nf_inq_dimname(ncid, timedim, timename))
           __NF_ASRT__(nf_inq_varid(ncid,timename, timevar))
           timeunits = ' '
           __NF_ASRT__(nf_get_att_text(ncid,timevar,'units',timeunits))
           ! get model calendar
           calendar=valid_calendar_types(get_calendar_type())

           ! loop through the time axis and get time_type values in time_in
           do i = 1,size(time)
              time_in(i) = get_cal_time(time(i),timeunits,calendar)
           end do
           
           grid_initialized = .true.
           ! get rid of allocated data
           deallocate(lon_in,lat_in,time,mask_in)
        endif
     enddo
     enddo
  endif ! do_landuse_changes

  ! initialize diagnostics
  diag_ids(:,:) = 0

  do k1 = 1,size(diag_ids,1)
  do k2 = 1,size(diag_ids,2)
     ! skip unnamed tiles
     if(landuse_name(k1)=='')cycle
     if(landuse_name(k2)=='')cycle
     ! construct a name of input field and register the field
     fieldname = trim(landuse_name(k1))//'2'//trim(landuse_name(k2))
     diag_ids(k1,k2) = register_diag_field(diag_mod_name,fieldname,(/id_lon,id_lat/), lnd%time, &
          'rate of transition from '//trim(landuse_longname(k1))//' to '//trim(landuse_longname(k2)),& 
          units='1/year', missing_value=-1.0)
  enddo
  enddo

  module_is_initialized=.TRUE.

end subroutine


! ============================================================================
subroutine land_transitions_end()
  
  if (do_landuse_change) &
       call horiz_interp_del(interp)
  if(allocated(time_in)) &
       deallocate(time_in,buffer_in)
  module_is_initialized=.FALSE.

end subroutine


! ============================================================================
subroutine save_land_transitions_restart(timestamp)
  character(*), intent(in) :: timestamp ! timestamp to add to the file name
  
  integer :: unit,year,month,day,hour,min,sec

  call mpp_open( unit, 'RESTART/'//trim(timestamp)//'landuse.res', nohdrs=.TRUE. )
  if (mpp_pe() == mpp_root_pe()) then
     call get_date(time0, year,month,day,hour,min,sec)
     write(unit,'(6i6,8x,a)') year,month,day,hour,min,sec, &
          'Time of previous landuse transition calculation'
  endif
  call mpp_close(unit)

end subroutine save_land_transitions_restart


! ============================================================================
! performs transitions between tiles, e.g. conversion of forests to crop, etc.
subroutine land_transitions (time)
  type(time_type), intent(in) :: time 

  ! ---- local vars.
  integer :: i,j,k1,k2
  type(tran_type), pointer :: transitions(:,:,:) => NULL()
  integer :: second, minute, hour, day0, day1, month0, month1, year0, year1

  if (.not.do_landuse_change) &
       return ! do nothing if landuse change not requested
  ! NB: in this case file/interp/data are not initialized, so it is
  ! not even possible to use the code below

  call get_date(time,             year0,month0,day0,hour,minute,second)
  call get_date(time-lnd%dt_slow, year1,month1,day1,hour,minute,second)
  if(year0 == year1) &
!!$  if(day0 == day1) &
       return ! do nothing during a year 

  ! get transition rates for current time: read map of transitions, and accumulate
  ! as many layers in array of transitions as necessary. Note that "transitions"
  ! array gets reallocated inside get_transitions as necessary, it has only as many
  ! layers as the max number of transitions occuring at a point at the time.
  do k1 = 1,N_LU_TYPES
  do k2 = 1,N_LU_TYPES
     call get_transitions(time0,time,k1,k2,transitions)
  enddo
  enddo

  ! perform the transitions
  do j = lnd%js,lnd%je
  do i = lnd%is,lnd%ie
     if(empty(lnd%tile_map(i,j))) cycle ! skip cells where there is no land
     ! set current point for debugging
     call set_current_point(i,j,1)
     ! transiton land area between different tile types
     call land_transitions_0d(lnd%tile_map(i,j), &
          transitions(i,j,:)%donor, &
          transitions(i,j,:)%acceptor,&
          transitions(i,j,:)%frac )
  enddo
  enddo
  
  ! deallocate array of transitions
  if (associated(transitions)) deallocate(transitions)
  
  ! store current time for future reference
  time0=time

end subroutine land_transitions


! =============================================================================
! performs tile transitions in a given grid cell
subroutine land_transitions_0d(d_list,d_kinds,a_kinds,area)
  type(land_tile_list_type), intent(inout) :: d_list ! list of tiles
  integer, intent(in) :: d_kinds(:) ! array of donor tile kinds
  integer, intent(in) :: a_kinds(:) ! array of acceptor tile kinds
  real   , intent(in) :: area(:)    ! array of areas changing from donor tiles to acceptor tiles
  
  ! ---- local vars
  integer :: i
  type(land_tile_type), pointer :: ptr
  type(land_tile_list_type) :: a_list
  type(land_tile_enum_type) :: ts, te
  real :: atot ! total fraction of tiles that can be involved in transitions
  ! variable used for conservation check:
  real :: lmass0, fmass0, cmass0, heat0, &
       soil_heat0, vegn_heat0, cana_heat0, snow_heat0 ! pre-transition values 
  real :: lmass1, fmass1, cmass1, heat1, &
       soil_heat1, vegn_heat1, cana_heat1, snow_heat1 ! post-transition values
  real :: lm, fm ! buffers for transition calulations

  ! conservation check code, part 1: calculate the pre-transition grid
  ! cell totals
  lmass0 = 0 ; fmass0 = 0 ; cmass0 = 0 ; heat0 = 0
  soil_heat0 = 0 ;  vegn_heat0 = 0 ; cana_heat0 = 0 ; snow_heat0 = 0
  ts = first_elmt(d_list) ; te=tail_elmt(d_list)
  do while (ts /= te)
     ptr=>current_tile(ts); ts=next_elmt(ts)
     call get_tile_water(ptr,lm,fm)
     lmass0 = lmass0 + lm*ptr%frac ; fmass0 = fmass0 + fm*ptr%frac

     heat0  = heat0  + land_tile_heat  (ptr)*ptr%frac
     cmass0 = cmass0 + land_tile_carbon(ptr)*ptr%frac
     
     if(associated(ptr%soil)) soil_heat0 = soil_heat0 + soil_tile_heat(ptr%soil)*ptr%frac
     if(associated(ptr%vegn)) vegn_heat0 = vegn_heat0 + vegn_tile_heat(ptr%vegn)*ptr%frac
     if(associated(ptr%cana)) cana_heat0 = cana_heat0 + cana_tile_heat(ptr%cana)*ptr%frac
     if(associated(ptr%snow)) snow_heat0 = snow_heat0 + snow_tile_heat(ptr%snow)*ptr%frac
  enddo

  ! calculate the area that can participate in land transitions
  atot = 0 ; ts = first_elmt(d_list) ; te=tail_elmt(d_list)
  do while (ts /= te)
     ptr=>current_tile(ts); ts=next_elmt(ts)
     if (.not.associated(ptr%vegn)) cycle
     atot = atot + ptr%frac
  enddo

  if (is_watch_point()) then
     write(*,*)'### land_transitions_0d: input parameters ###'
     do i = 1, size(d_kinds)
        __DEBUG4__(i,d_kinds(i),a_kinds(i),area(i))
        ! write(*,'(a,i2.2,100(2x,a,g))')'i='i,d_kinds(i)d_kinds(i),a_kinds(i),)
     enddo

     write(*,*)'### land_transitions_0d: land fractions before transitions (initial state) ###'
     ts = first_elmt(d_list) ; te=tail_elmt(d_list)
     do while (ts /= te)
        ptr=>current_tile(ts); ts=next_elmt(ts)
        if (.not.associated(ptr%vegn)) cycle
        write(*,*)'landuse=',ptr%vegn%landuse,' area=',ptr%frac
     enddo
     write(*,'(a,g23.16)')'total area=',atot
  endif

  ! split each donor tile and gather the parts that undergo a 
  ! transition into a separate list. Note that the kind of the landuse is
  ! changed during this transition, including forest harvesting if necessary.
  ! This has to occur at some time before the tiles are merged, and it seems
  ! to be the most convenient place as both original and final landuse kind
  ! is known for each part.
  call land_tile_list_init(a_list)
  do i = 1,size(d_kinds)
     call split_changing_tile_parts(d_list,d_kinds(i),a_kinds(i),area(i)*atot,a_list)
     ! the factor atot normalizes the transitions to the total area in the grid cell
     ! available for the land use, that is, the area of land excluding lakes and glaciers
  enddo
  if (is_watch_point()) then
     write(*,*)'### land_transitions_0d: land fractions after splitting changing parts ###'
     atot = 0 ; ts = first_elmt(d_list) ; te=tail_elmt(d_list)
     do while (ts /= te)
        ptr=>current_tile(ts); ts=next_elmt(ts)
        if (.not.associated(ptr%vegn)) cycle
        write(*,'(2(a,g23.16,2x))')'   donor: landuse=',ptr%vegn%landuse,' area=',ptr%frac
        atot = atot + ptr%frac
     enddo
     ts = first_elmt(a_list); te=tail_elmt(a_list)
     do while (ts /= te)
        ptr=>current_tile(ts); ts=next_elmt(ts)
        if (.not.associated(ptr%vegn)) cycle
        write(*,'(2(a,g23.16,2x))')'acceptor: landuse=',ptr%vegn%landuse,' area=',ptr%frac
        atot = atot + ptr%frac
     enddo
     write(*,'(a,g23.16)')'total area=',atot
  endif

  ! move all tiles from the donor list to the acceptor list -- this will ensure
  ! that all the tiles that can be merged at this time will be
  te = tail_elmt(d_list) 
  do 
     ts=first_elmt(d_list)
     if(ts==te) exit ! reached the end of the list
     ptr=>current_tile(ts)
     if(ptr%frac <= 0.0) then
        call erase(ts) ! if area of the tile is zero, free it
     else
        ! othervise, move it to a_list
        call remove(ts)
        call insert(ptr,a_list)
     endif
  enddo
  ! d_list is empty at this point

  ! merge all generated tiles into the source (donor) list
  te = tail_elmt(a_list) 
  do
     ts=first_elmt(a_list)
     if(ts==te) exit ! break out of loop
     ptr=>current_tile(ts)
     call remove(ts)
     call land_tile_merge(ptr,d_list)
  enddo
  ! a_list is empty at this point
  call land_tile_list_end(a_list)

  if (is_watch_point()) then
     write(*,*)'### land_transitions_0d: land fractions final state ###'
     atot = 0
     ts = first_elmt(d_list); te=tail_elmt(d_list)
     do while (ts /= te)
        ptr=>current_tile(ts); ts=next_elmt(ts)
        if (.not.associated(ptr%vegn)) cycle
        write(*,'(2(a,g23.16,2x))')'landuse=',ptr%vegn%landuse,' area=',ptr%frac
        atot = atot + ptr%frac
     enddo
     write(*,'(a,g23.16)')'total area=',atot
  endif

  ! conservation check part 2: calculate grid cell totals in final state, and 
  ! compare them with pre-transition totals
  lmass1 = 0 ; fmass1 = 0 ; cmass1 = 0 ; heat1 = 0
  soil_heat1 = 0 ;  vegn_heat1 = 0 ; cana_heat1 = 0 ; snow_heat1 = 0
  ts = first_elmt(d_list) ; te=tail_elmt(d_list)
  do while (ts /= te)
     ptr=>current_tile(ts); ts=next_elmt(ts)
     call get_tile_water(ptr,lm,fm)
     lmass1 = lmass1 + lm*ptr%frac ; fmass1 = fmass1 + fm*ptr%frac

     heat1  = heat1  + land_tile_heat  (ptr)*ptr%frac
     cmass1 = cmass1 + land_tile_carbon(ptr)*ptr%frac

     if(associated(ptr%soil)) soil_heat1 = soil_heat1 + soil_tile_heat(ptr%soil)*ptr%frac
     if(associated(ptr%vegn)) vegn_heat1 = vegn_heat1 + vegn_tile_heat(ptr%vegn)*ptr%frac
     if(associated(ptr%cana)) cana_heat1 = cana_heat1 + cana_tile_heat(ptr%cana)*ptr%frac
     if(associated(ptr%snow)) snow_heat1 = snow_heat1 + snow_tile_heat(ptr%snow)*ptr%frac
  enddo
  call check_conservation ('liquid water', lmass0, lmass1, 1e-6)
  call check_conservation ('frozen water', fmass0, fmass1, 1e-6)
  call check_conservation ('carbon'      , cmass0, cmass1, 1e-6)
  call check_conservation ('canopy air heat content', cana_heat0 , cana_heat1 , 1e-6)
  call check_conservation ('vegetation heat content', vegn_heat0 , vegn_heat1 , 1e-6)
  call check_conservation ('snow heat content',       snow_heat0 , snow_heat1 , 1e-6)
  call check_conservation ('soil heat content',       soil_heat0 , soil_heat1 , 1e-6)
  call check_conservation ('heat content', heat0 , heat1 , 1e-6)

end subroutine 


! ==============================================================================
! given a pointer to a tile and a tile list, insert the tile into the list so that
! if tile can be merged with any one already present, it is merged; otherwise 
! the tile is inserted into the list
subroutine land_tile_merge(tile, list)
  type(land_tile_type), pointer :: tile
  type(land_tile_list_type), intent(inout) :: list

  ! ---- local vars
  type(land_tile_type), pointer :: ptr
  type(land_tile_enum_type) :: ct,et
  
  ! try to find a tile that we can merge to
  ct = first_elmt(list) ; et = tail_elmt(list)
  do while(ct/=et)
     ptr=>current_tile(ct) ; ct = next_elmt(ct)
     if (land_tiles_can_be_merged(tile,ptr)) then
        call merge_land_tiles(tile,ptr)
        call delete_land_tile(tile)
        return ! break out of the subroutine
     endif
  enddo
  ! we reach here only if no suitable files was found in the list
  ! if no suitable tile was found, just insert given tile into the list
  call insert(tile,list)
end subroutine land_tile_merge


! =============================================================================
! splits changing parts of donor tiles into a separate tile list, performing
! land use changes in the process
subroutine split_changing_tile_parts(d_list,d_kind,a_kind,dfrac,a_list)
  type(land_tile_list_type), intent(in) :: d_list ! list of donor tiles
  integer, intent(in) :: d_kind ! kind of donor tiles
  integer, intent(in) :: a_kind ! kind of acceptor tiles
  real,    intent(in) :: dfrac  ! fraction of land area that changes kind
  type(land_tile_list_type), intent(inout) :: a_list ! list of acceptors
  
  ! ---- local vars
  type(land_tile_enum_type) :: ct, et
  type(land_tile_type), pointer :: temp
  type(land_tile_type), pointer :: tile
  real :: area, darea, area0, area1
  real :: x0,x1,x2 ! values of transition intensity
  real, parameter :: eps = 1e-6 ! area calculation precision
  integer :: iter
  real :: factor = 1.6
  integer :: severity ! severity of overshoot errors
  integer :: i,j,k,face ! coordinates of current point, for overshoot diagnostics

  ! calculate total area of the tiles that should be transitioned to another kind
  area = 0
  ct = first_elmt(d_list); et=tail_elmt(d_list)
  do while (ct /= et)
     tile=>current_tile(ct); ct=next_elmt(ct)
     if (.not.associated(tile%vegn)) cycle
     if (tile%vegn%landuse == d_kind)  &
          area = area + tile%frac
  enddo

  ! check for overshoot situtaion: that is, a case where the transition area is
  ! larger than the available area
  if(overshoot_opt /= OPT_IGNORE.and.dfrac>area+overshoot_tolerance) then
     severity = WARNING
     if (overshoot_opt==OPT_STOP) severity = FATAL
     call get_current_point(i,j,k,face)
     call error_mesg('she_landuse',&
          'transition at ('//trim(string(i))//','//trim(string(j))//&
          ',face='//trim(string(face))//&
          ') from "'//trim(landuse_name(d_kind))// &
          '" to "'  //trim(landuse_name(a_kind))//&
          '" ('//trim(string(dfrac))//') is larger than area of "'&
          //trim(landuse_name(d_kind))//'" ('//trim(string(area))//')', &
          severity)
  endif

  ! if area of the tiles of requested kind is zero we cannot transition
  ! anything, so just return
  if (area==0) return
       
  ! transition cannot be more than current total area of specified kind
  darea = min(dfrac, area)

  ! solve equation to get transition intensity
  ! (1) bracket transition intensity interval so that requested area is within it
  x0=0.0; area0 = total_transition_area(d_list, d_kind, a_kind, x0)
  x1=1.0; area1 = total_transition_area(d_list, d_kind, a_kind, x1)
  iter = 0
  do
     if ((area0<=darea).and.(area1>=darea)) exit
     if (area0>darea) then
        x0 = x0-(x1-x0)*factor
        area0 = total_transition_area(d_list, d_kind, a_kind, x0)
     else
        x1 = x1+(x1-x0)*factor
        area1 = total_transition_area(d_list, d_kind, a_kind, x1)
     endif
     iter = iter+1
     if (iter>50) then
        call error_mesg('veg_tile_transitions',&
             'cannot braket transition intensity interval after 50 iterations',&
             FATAL) 
     endif
  enddo

  ! find solution for transition intensity by binary search
  do iter = 1,50
     x2 = (x0+x1)/2
     area = total_transition_area(d_list, d_kind, a_kind, x2)
     if (abs(x1-x2)<eps) exit
     if (area>darea) then
        x1=x2
     else
        x0=x2
     endif
  enddo

  ! do tile transitions to destination list
  ct = first_elmt(d_list); et=tail_elmt(d_list)
  do while (ct /= et)
     tile=>current_tile(ct) ; ct=next_elmt(ct)
     if(.not.associated(tile%vegn)) cycle
     if(tile%vegn%landuse == d_kind) then
        darea = vegn_tran_priority(tile%vegn, a_kind, x2)
        if(darea > 0) then
           ! make a copy 
           temp => new_land_tile(tile)
           temp%frac = tile%frac*darea
           tile%frac = tile%frac*(1.0-darea)
           ! convert land use type of the tile:
           ! cut the forest, if necessary
           if(temp%vegn%landuse==LU_NTRL.or.temp%vegn%landuse==LU_SCND) &
                call vegn_cut_forest(temp%vegn, a_kind)
           ! change landuse type of the tile
           temp%vegn%landuse = a_kind
           ! add the new tile to the resulting list 
           call insert(temp, a_list) ! insert tile into output list
        endif
     endif
  enddo

end subroutine split_changing_tile_parts


! ============================================================================
! calculates total area (fraction of grid cell area) participating in 
! vegetation transition from src_kind to dst_kind for given transition
! intensity tau
function total_transition_area(list,src_kind,dst_kind,tau) result (total_area)
  real :: total_area
  type(land_tile_list_type), intent(in) :: list ! list of tiles
  integer , intent(in) :: src_kind, dst_kind ! source and destination kinds
  real    , intent(in) :: tau                ! transition intensity

  ! ---- local vars
  type(land_tile_enum_type) :: ct, et
  type(land_tile_type), pointer :: tile

  total_area = 0
  ct = first_elmt(list) ; et = tail_elmt(list) 
  do while (ct/=et)
     tile=>current_tile(ct);  ct = next_elmt(ct)
     if (.not.associated(tile%vegn)) cycle ! skip non-vegetated tiles
     if(tile%vegn%landuse == src_kind) &
          total_area = total_area + tile%frac*vegn_tran_priority(tile%vegn,dst_kind,tau)
  enddo
  
end function


! ============================================================================

subroutine get_transitions(time0,time1,k1,k2,tran)
  type(time_type), intent(in) :: time0       ! time of previous calculation of 
    ! transitions (the integral transitinos will be calculated between time0 
    ! and time)
  type(time_type), intent(in) :: time1       ! current time
  integer, intent(in) :: k1,k2               ! kinds of tiles
  type(tran_type), pointer :: tran(:,:,:)    ! transition info

  ! ---- local vars
  integer :: i,j,k,sec,days
  type(tran_type), pointer :: ptr(:,:,:) => NULL()
  real    :: frac(lnd%is:lnd%ie,lnd%js:lnd%je)
  real    :: part_of_year
  logical :: used

  ! allocate array of transitions, if necessary
  if (.not.associated(tran)) then
     allocate(tran(lnd%is:lnd%ie,lnd%js:lnd%je,1) )
  end if

  ! get transition rate for this specific transition
  frac(:,:) = 0.0
  if(input_ids(k1,k2)>0) then
     call integral_transition(time0,time1,input_ids(k1,k2),frac)
     
     do j = lnd%js,lnd%je
     do i = lnd%is,lnd%ie
        if(frac(i,j) == 0) cycle ! skip points where transition rate is zero
        ! find the first empty transition element for the current indices
        k = 1
        do while ( k <= size(tran,3) )
           if(tran(i,j,k)%donor == 0) exit
           k = k+1
        enddo

        if (k>size(tran,3)) then
           ! if there is no room, make the array of transitions larger
           allocate(ptr(lnd%is:lnd%ie,lnd%js:lnd%je,size(tran,3)*2))
           ptr(:,:,1:size(tran,3)) = tran
           deallocate(tran)
           tran => ptr
           nullify(ptr)
        end if

        ! store the transition element
        tran(i,j,k) = tran_type(k1,k2,frac(i,j))
     enddo
     enddo
  endif

  ! send transition data to diagnostics
  if(diag_ids(k1,k2)>0) then
     call get_time(time1-time0, sec,days)
     part_of_year = (days+sec/86400.0)/days_in_year(time0)
     used = send_data(diag_ids(k1,k2),frac/part_of_year,time1)
  endif

end subroutine get_transitions


! ===========================================================================
! given beginnig and end of the time period, and the id of the external
! tile transition field, calculates total transition during the specified period.
! The transition rate data are assumed to be in fraction of land area per year,
! timestamped at the beginning of the year
subroutine integral_transition(t1, t2, id, frac, err_msg)
  type(time_type), intent(in)  :: t1,t2 ! time boundaries
  integer        , intent(in)  :: id    ! id of the field
  real           , intent(out) :: frac(:,:)
  character(len=*),intent(out), optional :: err_msg

  ! ---- local vars
  integer :: n ! size of time axis
  type(time_type) :: ts,te
  integer         :: i1,i2
  real :: w  ! time interpolation weight
  real :: dt ! current time interval, in years
  real :: sum(size(frac,1),size(frac,2))
  integer :: i,j
  character(len=256) :: msg

  msg = ''
  ! adjust the integration limits, in case they are out of range   
  n = size(time_in)
  ts = t1; 
  if (ts<time_in(1)) ts = time_in(1)
  if (ts>time_in(n)) ts = time_in(n) 
  te = t2
  if (te<time_in(1)) te = time_in(1)
  if (te>time_in(n)) te = time_in(n) 

  call time_interp(ts, time_in, w, i1,i2, err_msg=msg)
  if(msg /= '') then
    if(fms_error_handler('integral_transition','Message from time_interp: '//trim(msg),err_msg)) return
  endif
  __NF_ASRT__(nfu_get_rec(ncid,id,i1,buffer_in))

  frac = 0;
  call horiz_interp(interp,buffer_in,frac)
  dt = (time_in(i2)-time_in(i1))//set_time(0,days_in_year((time_in(i2)+time_in(i1))/2))
  sum = -frac*w*dt
  do while(time_in(i2)<=te)
     __NF_ASRT__(nfu_get_rec(ncid,id,i1,buffer_in))
     call horiz_interp(interp,buffer_in,frac)
     dt = (time_in(i2)-time_in(i1))//set_time(0,days_in_year((time_in(i2)+time_in(i1))/2))
     sum = sum+frac*dt
     i2 = i2+1
     i1 = i2-1
     if(i2>size(time_in)) exit ! from loop
  enddo

  call time_interp(te,time_in,w,i1,i2, err_msg=msg)
  if(msg /= '') then
    if(fms_error_handler('integral_transition','Message from time_interp: '//trim(msg),err_msg)) return
  endif
  __NF_ASRT__(nfu_get_rec(ncid,id,i1,buffer_in))
  call horiz_interp(interp,buffer_in,frac)
  dt = (time_in(i2)-time_in(i1))//set_time(0,days_in_year((time_in(i2)+time_in(i1))/2))
  frac = sum+frac*w*dt
  do i = 1,size(frac,1)
  do j = 1,size(frac,2)
     if(frac(i,j)<0) then
        call error_mesg('get','transition rate is below zero',FATAL)
     endif
  enddo
  enddo
end subroutine


! ==============================================================================
! checks conservation and aborts with fatal error if tolerance is exceeded
subroutine check_conservation(name, d1, d2, tolerance)
  character(*), intent(in) :: name ! name of the component
  real, intent(in) :: d1,d2 ! values to check
  real, intent(in) :: tolerance ! tolerance of the test

  integer :: curr_i, curr_j, face
  integer :: severity ! severity of the generated message
  character(256) :: message

  if (conservation_opt == OPT_IGNORE) return ! do nothing

  severity = WARNING
  if (overshoot_opt==OPT_STOP) severity = FATAL
  
  if (abs(d1-d2)>tolerance) then
     call get_current_point(i=curr_i,j=curr_j,face=face)
     write(message,'(a,3(x,a,i4), 2(x,a,g23.16))')&
          'conservation of '//trim(name)//' is violated', &
          'at i=',curr_i,'j=',curr_j,'face=',face, &
          'value before=', d1, 'after=', d2
     call error_mesg('land_transitions',message,severity)
  endif
end subroutine 

end module

!FDOC_TAG_GFDL

                 module diag_clouds_W_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!    fil
! </CONTACT>
! <REVIEWER EMAIL="">
! </REVIEWER>
! <OVERVIEW>
!           diag cloud radiative properties module
!            currently a wrapper until SKYHI goes away and this
!            module can be consolidated with diag_cloud_mod
!   
! </OVERVIEW>
! <DESCRIPTION>
!   
! </DESCRIPTION>
!

use time_manager_mod,       only: time_type
use diag_cloud_mod,         only: diag_cloud_avg2, diag_cloud_driver2
use diag_cloud_rad_mod,     only: cloud_opt_prop_tg_lw,  &
                                  cloud_opt_prop_tg_sw
use mpp_mod,                only: input_nml_file
use fms_mod,                only: open_namelist_file, file_exist, &
                                  check_nml_error, &
                                  write_version_number, &
                                  mpp_pe, mpp_root_pe, &
                                  close_file, stdlog
use rad_utilities_mod,      only: microphysics_type, &
                                  cld_specification_type, &
                                  cldrad_properties_type, &
                                  Sw_control

!--------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!           diag cloud radiative properties module
!            currently a wrapper until SKYHI goes away and this
!            module can be consolidated with diag_cloud_mod
!
!--------------------------------------------------------------------



!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------

   character(len=128)  :: version =  '$Id: diag_clouds_W.F90,v 19.0 2012/01/06 20:14:45 fms Exp $'
   character(len=128)  :: tagname =  '$Name: tikal $'



!---------------------------------------------------------------------
!-------  interfaces --------

public          &
          diag_clouds_W_init,    &
          diag_clouds_W_end,    &
          diag_clouds_amt,  &
          obtain_bulk_lw_diag, &
          obtain_bulk_sw_diag

!---------------------------------------------------------------------
!-------- namelist  ---------

real       :: taucrit = 1.0     !  critical optical depth at which 
                                !  solar beam is treated as diffuse
                                !  rather than direct
integer    :: num_slingo_bands = 4



namelist /diag_clouds_W_nml /     &
                               num_slingo_bands, &
                               taucrit


!----------------------------------------------------------------------
!----  public data -------


!----------------------------------------------------------------------
!----  private data -------

logical :: module_is_initialized = .false.
!----------------------------------------------------------------------
!----------------------------------------------------------------------




contains 





! <SUBROUTINE NAME="diag_clouds_W_init">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call diag_clouds_W_init  (num_slingo_bands_out)
!
!  </TEMPLATE>
!  <OUT NAME="num_slingo_bands_out" TYPE="integer">
! 
!  </OUT>
! </SUBROUTINE>
!
subroutine diag_clouds_W_init  (num_slingo_bands_out)


integer, intent(out) :: num_slingo_bands_out

      integer            :: unit, ierr, io, logunit


      if (module_is_initialized) return
!---------------------------------------------------------------------
!-----  read namelist  ------
  
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=diag_clouds_W_nml, iostat=io)
      ierr = check_nml_error(io,'diag_clouds_W_nml')
#else   
      if (file_exist('input.nml')) then
        unit =  open_namelist_file ()
        ierr=1; do while (ierr /= 0)
        read (unit, nml=diag_clouds_W_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'diag_clouds_W_nml')
        enddo
10      call close_file (unit)
      endif
#endif

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
           logunit = stdlog()
           write (logunit,nml=diag_clouds_W_nml)
      endif

      num_slingo_bands_out = num_slingo_bands
! (ultimately get from diag_cloud_mod when call diag_cloud_init)
      module_is_initialized = .true.

end subroutine diag_clouds_W_init


!#####################################################################

! <SUBROUTINE NAME="diag_clouds_W_end">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call diag_clouds_W_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine diag_clouds_W_end
 
!----------------------------------------------------------------------
!    diag_clouds_W_end is the destructor for diag_clouds_W_mod.
!----------------------------------------------------------------------
 
!---------------------------------------------------------------------
!    mark the module as not initialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.

!--------------------------------------------------------------------


end subroutine diag_clouds_W_end



!#################################################################

! <SUBROUTINE NAME="diag_clouds_amt">
!  <OVERVIEW>
!    diag_clouds_amt defines the location, amount (cloud fraction),
!    number, optical depth, thickness and liquid percentage of clouds
!    present on the model grid.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    diag_clouds_amt defines the location, amount (cloud fraction),
!    number, optical depth, thickness and liquid percentage of clouds
!    present on the model grid.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call diag_clouds_amt (is, ie, js, je, lat, pflux, press,   &
!                Rad_time, Cld_spec, Lsc_microphys) 
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <IN NAME="lat" TYPE="real">
!      lat          latitude of model points  [ radians ]
! 
!  </IN>
!  <IN NAME="pflux" TYPE="real">
!      pflux        average of pressure at adjacent model levels
!                   [ (kg /( m s^2) ]
! 
!  </IN>
!  <IN NAME="press" TYPE="real">
!      press        pressure at model levels (1:nlev), surface
!                   pressure is stored at index value nlev+1
!                   [ (kg /( m s^2) ]
! 
!  </IN>
!  <IN NAME="Rad_time" TYPE="time_type">
!      Rad_time     time at which the climatologically-determined,
!                   time-varying zonal cloud fields should apply
!                   [ time_type, days and seconds]
! 
!  </IN>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
!      Cld_spec     cld_specification_type variable containing the
!                   cloud specification input fields needed by the
!                   radiation package
!
!               the following elements of Cld_spec are defined here:
!
!                  %cmxolw  fraction of maximally overlapped clouds
!                           seen by the longwave radiation
!                           [ dimensionless ]
!                  %crndlw  fraction of randomly overlapped clouds
!                           seen by the longwave radiation
!                           [ dimensionless ]
!                  %camtsw  cloud fraction seen by the shortwave
!                           radiation; the sum of the maximally
!                           overlapped and randomly overlapped
!                           longwave cloud fractions  [ dimensionless ]
!                  %nmxolw  number of maximally overlapped longwave
!                           clouds in each grid column.
!                  %nrndlw  number of randomly overlapped longwave
!                           clouds in each grid column.
!                  %ncldsw  number of clouds seen by he shortwave
!                           radiation in each grid column.
!                  %liq_frac
!                           percentage of cloud condensate in a grid
!                           box which is liquid  [ dimensionless ]
!                  %tau     cloud optical depth  [ dimensionless ]
!                  %cloud_thickness
!                           number of model layers over which the cloud
!                           in this grid box extends
!                  %ice_cloud
!                           logical variable, which if true, indicates
!                           that the grid box will contain ice cloud;
!                           if false, the box will contain liquid cloud
! 
!  </INOUT>
!  <INOUT NAME="Lsc_microphys" TYPE="microphysics_type">
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine diag_clouds_amt (is, ie, js, je, lat, pflux, press,   &
                            Rad_time, Cld_spec, Lsc_microphys) 

!----------------------------------------------------------------------
!    diag_clouds_amt defines the location, amount (cloud fraction), 
!    number, optical depth, thickness and liquid percentage of clouds 
!    present on the model grid.
!----------------------------------------------------------------------

integer,                      intent(in)     ::  is, ie, js, je
real,    dimension(:,:),      intent(in)     ::  lat
real,    dimension(:,:,:),    intent(in)     ::  pflux, press
type(time_type),              intent(in)     ::  Rad_time     
type(cld_specification_type), intent(inout)  ::  Cld_spec
type(microphysics_type),      intent(inout)  ::  Lsc_microphys

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      lat          latitude of model points  [ radians ]
!      pflux        average of pressure at adjacent model levels
!                   [ (kg /( m s^2) ] 
!      press        pressure at model levels (1:nlev), surface 
!                   pressure is stored at index value nlev+1
!                   [ (kg /( m s^2) ]
!      Rad_time     time at which the climatologically-determined, 
!                   time-varying zonal cloud fields should apply
!                   [ time_type, days and seconds]
!
!   intent(inout) variables:
!
!      Cld_spec     cld_specification_type variable containing the 
!                   cloud specification input fields needed by the 
!                   radiation package
!
!               the following elements of Cld_spec are defined here:
!
!                  %cmxolw  fraction of maximally overlapped clouds
!                           seen by the longwave radiation 
!                           [ dimensionless ]
!                  %crndlw  fraction of randomly overlapped clouds
!                           seen by the longwave radiation 
!                           [ dimensionless ]
!                  %camtsw  cloud fraction seen by the shortwave
!                           radiation; the sum of the maximally
!                           overlapped and randomly overlapped 
!                           longwave cloud fractions  [ dimensionless ]
!                  %nmxolw  number of maximally overlapped longwave 
!                           clouds in each grid column.
!                  %nrndlw  number of randomly overlapped longwave 
!                           clouds in each grid column.
!                  %ncldsw  number of clouds seen by he shortwave
!                           radiation in each grid column.
!                  %liq_frac 
!                           percentage of cloud condensate in a grid 
!                           box which is liquid  [ dimensionless ]
!                  %tau     cloud optical depth  [ dimensionless ]
!                  %cloud_thickness
!                           number of model layers over which the cloud
!                           in this grid box extends
!                  %ice_cloud  
!                           logical variable, which if true, indicates 
!                           that the grid box will contain ice cloud; 
!                           if false, the box will contain liquid cloud
!
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!   local variables

      logical, dimension (size(Cld_spec%camtsw,1),                 &
                          size(Cld_spec%camtsw,2),                 &
                          size(Cld_spec%camtsw,3)) :: ice_cloud_cs

      real, dimension    (size(Cld_spec%camtsw,1),                 &
                          size(Cld_spec%camtsw,2),                 &
                          size(Cld_spec%camtsw,3)) ::  cldamt,     &
                                                       liq_frac

      real, dimension    (size(Cld_spec%camtsw,1),                 &
                          size(Cld_spec%camtsw,2),                 &
                          size(Cld_spec%camtsw,3),                 &
                          size(Cld_spec%tau,4))    ::  tau

      integer, dimension (size(Cld_spec%camtsw,1),                 &
                          size(Cld_spec%camtsw,2),                 &
                          size(Cld_spec%camtsw,3)) ::  ktop, kbtm

      integer     ::   i,j, k, kc           
      integer     ::   kx                     

!----------------------------------------------------------------------
!  local variables:
!
!      ice_cloud_cs  logical flag indicating whether a given cloud (in
!                    cloud-space) is made up of ice (.true.) or liquid
!                    (.false.)
!      cldamt        fractional cloudiness in a grid box 
!                    (in cloud-space)  [ dimensionless ]
!      liq_frac      the fraction of cloud in a grid box which is liquid
!                    (in cloud-space) [ dimensionless ]
!      tau           cloud optical depth, in cloud-space   
!                    [ dimensionless ]
!      ktop          model index of the cloud top
!      kbtm          model index of the cloud base
!      i, j, k, kc   do loop indices
!      kx            number of model layers
!
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!    define number of model layers.
!--------------------------------------------------------------------
      kx = size(Cld_spec%camtsw,3)

!---------------------------------------------------------------------
!    call diag_cloud_driver2 to obtain the cloud specification variables
!    in cloud space.
!---------------------------------------------------------------------
      call diag_cloud_driver2 (is, js, press, pflux, lat, Rad_time,  &
                               Cld_spec%ncldsw, ktop, kbtm, cldamt, &
                               liq_frac, tau, ice_cloud_cs)

!---------------------------------------------------------------------
!    map the various cloud specification arrays from cloud-space to 
!    physical space so that they may be exported for use elsewhere.
!-------------------------------------------------------------------
      do j=1,size(Cld_spec%camtsw,2)
        do i=1,size(Cld_spec%camtsw,1)
          do kc=1,Cld_spec%ncldsw(i,j)  
            do k=ktop(i,j,kc), kbtm(i,j,kc)
              Cld_spec%camtsw(i,j,k) = cldamt(i,j,kc) 
              Cld_spec%liq_frac(i,j,k) = liq_frac(i,j,kc)
              Cld_spec%tau(i,j,k,:) = tau(i,j,kc,:)
              Cld_spec%cld_thickness(i,j,k) =    &
                                      kbtm(i,j,kc) - ktop(i,j,kc) + 1
              Cld_spec%ice_cloud(i,j,k) = ice_cloud_cs(i,j,kc)
      
!---------------------------------------------------------------------
!    determine if max overlap or random overlap assumption is made. if
!    cloud is more than one layer deep and using lhsw, then max overlap
!    assumed; otherwise random overlap is assumed.
!----------------------------------------------------------------------
              if (ktop(i,j,kc) == kbtm(i,j,kc)) then
                Cld_spec%crndlw(i,j,k) = cldamt(i,j,kc)
                Cld_spec%cmxolw(i,j,k) = 0.0             
              else
                if (Sw_control%do_esfsw) then
                  Cld_spec%crndlw(i,j,k) = cldamt(i,j,kc)  
                  Cld_spec%cmxolw(i,j,k) = 0.0             
                else
                  Cld_spec%cmxolw(i,j,k) = cldamt(i,j,kc)
                  Cld_spec%crndlw(i,j,k) = 0.0
                endif       
              endif
            end do
            if (ktop(i,j,kc) == kbtm(i,j,kc)) then
              Cld_spec%nrndlw(i,j) = Cld_spec%nrndlw(i,j) + 1
            else
              if (Sw_control%do_esfsw) then
                Cld_spec%nrndlw(i,j) = Cld_spec%nrndlw(i,j) + 1
              else
                Cld_spec%nmxolw(i,j) = Cld_spec%nmxolw(i,j) + 1
              endif     
            endif
          end do
        end do
      end do
 

!--------------------------------------------------------------------

end subroutine diag_clouds_amt 





!#####################################################################

! <SUBROUTINE NAME="obtain_bulk_lw_diag">
!  <OVERVIEW>
!    obtain_bulk_lw_diag defines bulk longwave cloud radiative
!    properties for the gordon diag cloud scheme.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    obtain_bulk_lw_diag defines bulk longwave cloud radiative
!    properties for the gordon diag cloud scheme.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call obtain_bulk_lw_diag (is, ie, js, je, Cld_spec, Cldrad_props)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!      Cld_spec          cloud specification arrays defining the
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input
!                        to this subroutine
!                        [ cld_specification_type ]
! 
!  </IN>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output
!               from this routine:
!
!                    %emrndlw   longwave cloud emissivity for
!                               randomly overlapped clouds
!                               in each of the longwave
!                               frequency bands  [ dimensionless ]
!                    %emmxolw   longwave cloud emissivity for
!                               maximally overlapped clouds
!                               in each of the longwave
!                               frequency bands  [ dimensionless ]
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine obtain_bulk_lw_diag (is, ie, js, je, Cld_spec, Cldrad_props)

!---------------------------------------------------------------------
!    obtain_bulk_lw_diag defines bulk longwave cloud radiative 
!    properties for the gordon diag cloud scheme.
!---------------------------------------------------------------------
 
integer,                     intent(in)     :: is, ie, js, je
type(cld_specification_type), intent(in   ) :: Cld_spec
type(cldrad_properties_type), intent(inout) :: Cldrad_props

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!
!   intent(inout) variables:
!
!      Cld_spec          cloud specification arrays defining the 
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input 
!                        to this subroutine
!                        [ cld_specification_type ]
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output 
!               from this routine:
!
!                    %emrndlw   longwave cloud emissivity for 
!                               randomly overlapped clouds
!                               in each of the longwave 
!                               frequency bands  [ dimensionless ]
!                    %emmxolw   longwave cloud emissivity for 
!                               maximally overlapped clouds
!                               in each of the longwave 
!                               frequency bands  [ dimensionless ]
!
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!   local variables:

      real, dimension (size(Cldrad_props%emrndlw,1),               &
                       size(Cldrad_props%emrndlw,2),                &
                       size(Cldrad_props%emrndlw,3)) ::  emcld

      integer    :: max_cld
      integer    :: i,j,k

!---------------------------------------------------------------------
!   local variables:
!
!            emcld    longwave cloud emissivity, assuming a single 
!                     band, returned from diag_cloud_rad_mod
!            max_cld  maximum number of clouds in any column in the 
!                     window
!            i,j,k    do-loop indices
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    determine if any clouds are present in the window.
!---------------------------------------------------------------------
      max_cld = maxval(Cld_spec%ncldsw)

!---------------------------------------------------------------------
!    if cloud is nowhere present, return. 
!---------------------------------------------------------------------
      if (max_cld > 0) then

!--------------------------------------------------------------------
!    initialize property array in cloud-space to zero.
!--------------------------------------------------------------------
        emcld = 0.

!---------------------------------------------------------------------
!    call cloud_opt_prop_tg_lw to obtain the cloud longwave enmissivity.
!---------------------------------------------------------------------
        call cloud_opt_prop_tg_lw (Cld_spec%tau, Cld_spec%liq_frac,  &
                                   emcld)

!---------------------------------------------------------------------
!    assign the emissivity value returned to both the random and max-
!    imum overlap case. the value will only be used when there is a
!    non-zero cloud fraction of a particular type.
!-------------------------------------------------------------------
        do k=1,size(Cldrad_props%emrndlw,3)
          do j=1,size(Cldrad_props%emrndlw,2)
            do i=1,size(Cldrad_props%emrndlw,1)
              Cldrad_props%emrndlw(i,j,k,:,1) = emcld(i,j,k) 
              Cldrad_props%emmxolw(i,j,k,:,1) = emcld(i,j,k) 
            end do
          end do
        end do
      endif  
 
!---------------------------------------------------------------------


end subroutine obtain_bulk_lw_diag




!#####################################################################

! <SUBROUTINE NAME="obtain_bulk_sw_diag">
!  <OVERVIEW>
!    obtain_bulk_sw_diag defines bulk shortwave cloud radiative
!    properties for the gordon diag cloud scheme.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    obtain_bulk_sw_diag defines bulk shortwave cloud radiative
!    properties for the gordon diag cloud scheme.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call obtain_bulk_sw_diag (is, ie, js, je, cosz, Cld_spec,  &   
!                Cldrad_props)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <IN NAME="cosz" TYPE="real">
!      cosz         cosine of the zenith angle  [ dimensionless ]
! 
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!      Cld_spec          cloud specification arrays defining the
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input
!                        to this subroutine
!                        [ cld_specification_type ]
! 
!  </IN>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output
!               from this routine:
!
!                    %cirabsw   absorptivity of clouds in the
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cirrfsw   reflectivity of clouds in the
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cvisrfsw  reflectivity of clouds in the
!                               visible frequency band
!                               [ dimensionless ]
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine obtain_bulk_sw_diag (is, ie, js, je, cosz, Cld_spec,  &   
                                Cldrad_props)

!---------------------------------------------------------------------
!    obtain_bulk_sw_diag defines bulk shortwave cloud radiative 
!    properties for the gordon diag cloud scheme.
!---------------------------------------------------------------------

integer,                      intent(in)    ::  is, ie, js, je
real, dimension(:,:),         intent(in)    ::  cosz
type(cld_specification_type), intent(in   ) ::  Cld_spec
type(cldrad_properties_type), intent(inout) ::  Cldrad_props

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      cosz         cosine of the zenith angle  [ dimensionless ]
!
!   intent(inout) variables:
!
!      Cld_spec          cloud specification arrays defining the 
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input 
!                        to this subroutine
!                        [ cld_specification_type ]
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output 
!               from this routine:
!
!                    %cirabsw   absorptivity of clouds in the 
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cirrfsw   reflectivity of clouds in the 
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cvisrfsw  reflectivity of clouds in the 
!                               visible frequency band
!                               [ dimensionless ]
!
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!   local variables:


      real, dimension (size(Cldrad_props%cirabsw,1),                 &
                       size(Cldrad_props%cirabsw,2),                 &
                       size(Cldrad_props%cirabsw,3)) ::  cuvab

      real, dimension (size(Cldrad_props%cirabsw,1),                 &
                       size(Cldrad_props%cirabsw,2)) :: qmix_kx

      logical, dimension (size(Cldrad_props%cirabsw,1),    &
                          size(Cldrad_props%cirabsw,2), &
                          size(Cldrad_props%cirabsw,3)) ::  direct

      real        ::    taucum
      integer     ::    max_cld, ierr, kcld
      integer     ::    i, j, k, kk

!-------------------------------------------------------------------
!   local variables:
!
!        cuvab      absorptivity of clouds in the visible frequency
!                   bands [ nondimensional ]
!        qmix_kx    mixing ratio at the lowest model level
!                   [ nondimensional ]
!        direct     logical variable indicating whether solar beam is
!                   treated as direct or diffuse
!        taucum     sum of cloud extinction coefficients from model
!                   top to the current level; if taucum is > taucrit
!                   then the solar beam is considered to be diffuse 
!                   at lower model levels [ dimensionless ]
!        max_cld    maximum number of clouds in any physics window 
!                   column
!        ierr       error flag
!        kcld       next model layer to check for the presence of cloud
!                   in the calculation of taucum. this will not be the
!                   next lower level when multi-layer clouds are present
!        i,j,k,kk   do-loop indices
!
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!    define the nature of the solar beam at the top of atmosphere.
!---------------------------------------------------------------------
      direct(:,:,:) = .true.

!----------------------------------------------------------------------
!    in each column, integrate downward, defining the nature of the 
!    solar beam at each model level, and summing the cloud optical 
!    depths. once the optical depth exceeds taucrit, the solar beam is 
!    assigned diffuse properties rather than the properties of a direct 
!    solar beam. the logical variable direct is defined to indicate how
!    the beam is to be treated at each level.
!---------------------------------------------------------------------
      do j=1,size(Cld_spec%tau,2)
        do i=1,size(Cld_spec%tau,1)
          kcld = 1
          taucum = 0.
          do k=1,size(Cld_spec%tau,3)
            if (k >= kcld) then

!---------------------------------------------------------------------
!    once taucrit is exceeded, mark all lower levels as being diffuse,
!    and begin the next column.
!----------------------------------------------------------------------
              if (taucum > taucrit) then
                do kk=k,size(Cld_spec%tau,3)
                  direct(i,j,kk) = .false.
                end do
                exit
              endif

!---------------------------------------------------------------------
!    when multi-layer clouds are encountered, the optical depth for the
!    cloud must be added to taucum only once. kcld is defined as the 
!    first level below the current cloud at which to again start check-
!    ing taucum vs taucrit.
!---------------------------------------------------------------------
              if (Cld_spec%cld_thickness(i,j,k) > 0) then
                taucum = taucum + Cld_spec%tau(i,j,k,1)
                kcld = kcld + Cld_spec%cld_thickness(i,j,k)
              else
                kcld = kcld + 1
              endif
            endif
          end do
        end do
      end do

!---------------------------------------------------------------------
!    determine if any clouds are present in the window.
!---------------------------------------------------------------------
      max_cld = maxval(Cld_spec%ncldsw)

!--------------------------------------------------------------------
!    define the absorptivity in the visible spectrum to be 0.0.
!--------------------------------------------------------------------
      cuvab = 0.

!---------------------------------------------------------------------
!    if cloud is present, define cloud radiative properties. otherwise 
!    the default values corresponding to no clouds will be used.
!---------------------------------------------------------------------
      if (max_cld > 0) then

!--------------------------------------------------------------------
!    obtain the properly averaged (or instantaneous) mixing ratio at
!    the lowest model level. it will be passed to cloud_opt_prop_tg_sw
!    and used to calculate anomalous absorption.
!---------------------------------------------------------------------
        call diag_cloud_avg2 (is, js, qmix_kx, ierr)

!---------------------------------------------------------------------
!    call cloud_opt_prop_tg_sw to obtain short-wave cloud radiative 
!    properties. 
!---------------------------------------------------------------------
        call cloud_opt_prop_tg_sw (Cld_spec%liq_frac, Cld_spec%tau, &
                                   direct,  qmix_kx, cosz,   &
                                   Cldrad_props%cvisrfsw, &
                                   Cldrad_props%cirrfsw, &
                                   cuvab, Cldrad_props%cirabsw)
      endif  ! (max_cld > 0)

!--------------------------------------------------------------------




end subroutine obtain_bulk_sw_diag



!####################################################################


       end module diag_clouds_W_mod

! $Id: fv_pack.F90,v 19.0 2012/01/06 20:00:50 fms Exp $

module fv_pack

   use timingModule
#ifdef USE_LIMA
   use shr_kind_mod, only: r8 => shr_kind_r8
#endif



!-----------------------------------------------------------------------
! "SPMD" stands for Single Program Multiple Data. It activates
! domain decomposition with inter-process communication done
! by MPI-1, MPI-2, or SHMEM -- this is the first level of the
! parallelism. The second level parallelism uses the standard
! "OpenMP". To activate OpenMP, add "-mp" to the compiler and the load
! flags on the SGI.
!-----------------------------------------------------------------------

#ifdef SPMD
   use mod_comm,     only: gid, mp_init, mp_exit, y_decomp,  &
                           mp_send3d, mp_recv3d,                             &
                           mp_scatter3d, mp_send4d_ns, mp_recv4d_ns
#endif

! --- FMS ----
   use fms_mod,      only: file_exist,  open_namelist_file,    &
                           error_mesg,  FATAL,                 &
                           close_file,  check_nml_error,       &
                           write_version_number, stdlog, stdout, stderr
   use mpp_mod, only: mpp_pe, mpp_root_pe, mpp_npes, MPP_VERBOSE, &
        mpp_get_current_pelist, mpp_sync, mpp_error, input_nml_file
   use mpp_domains_mod, only: mpp_define_domains, mpp_domains_init, domain2D, &
        mpp_get_compute_domain
   use constants_mod,    only: radius, omega, grav, kappa, rdgas, cp_air, rvgas

! --- tracer manager ---
   use tracer_manager_mod, only : tm_get_number_tracers => get_number_tracers, &
                                  tm_get_tracer_index   => get_tracer_index,   &
                                  tm_get_tracer_indices => get_tracer_indices, &
                                  tm_set_tracer_profile => set_tracer_profile, &
                                  tm_get_tracer_names   => get_tracer_names,   &
                                  tm_check_if_prognostic=> check_if_prognostic,&
                                  tm_register_tracers   => register_tracers
   use field_manager_mod, only  : MODEL_ATMOS

   use fv_arrays_mod, only: fv_arrays_init, fv_arrays_exit, fv_array_check, &
        fv_stack_push, fv_array_sync, isp, iep, jsp, jep, ksp, kep, layout, &
        nlev, ncnst, n_zonal, fv_print_chksums, fv_pset_stack
#ifndef USE_LIMA
   use pft_module, only: pft_init, pft_end
#else
   use pft_module, only: pft_init
#endif


! --- FMS ----

   implicit none
   private

! --- FMS ----



!==================
! fv_core namelist:
!==================

!----------------
! Dimensionality:
!----------------
   integer nlon              ! E-W (total number of longitudes)
   integer mlat              ! N-S (total number of latitudes)
!   integer nlev              ! Vertical dimension
!   integer ncnst             ! Total number of tracers
   integer :: nt_phys = 4    ! Total number of tracers needed by physics
   integer :: nt_prog = 0    ! Number of prognostic tracers
   integer :: pnats = 0      ! Number of non-advected tracers; default to 0
   logical :: do_fms_tracer_manager = .FALSE.  ! get list of tracers from field_table
! name of fms tracers restart file
   character(len=*), parameter :: fms_tracers_file='atmos_tracers.res'

!------------------------------------------
! Parameters that control the FV algorithms:
!------------------------------------------

! Momentum transport options:
   integer :: iord_mt = 4    ! E-W
   integer :: jord_mt = 4    ! N-S
   integer :: kord_mt = 4    ! vertical mapping option

! Heat transport options:
   integer :: iord_tm = 4    ! E-W
   integer :: jord_tm = 4    ! N-S
   integer :: kord_tm = 7    ! vertical mapping option

! Tracer transport options:
   integer :: iord_tr = 4    ! E-W
   integer :: jord_tr = 4    ! N-S
   integer :: kord_tr = 7    ! vertical mapping option for tracers

   integer :: n_split = 0    ! Number of time splits for the lagrangian dynamics
                             ! Default = 0 (automatic computation of best value)
   integer :: n_spong = 1    ! Number of sponge layers from the top
   integer :: n_diffu = 0    ! Number of diffusive layers from the bottom
!   integer :: n_zonal = 0    ! loop decomposition in East-West direction
#ifndef USE_LIMA
   integer :: dyn_step= 0    ! Multi-Dimensional transport algorithms for dynamics
   integer :: tra_step= 1    ! Multi-Dimensional transport algorithms for tracers
                             ! 0: NO directional split
                             ! 1: start with meridional transport
                             ! 2: start with zonal transport
#endif

   logical :: age_tracer= .false.  ! Carry the age tracer as the last tracer
   logical :: adiabatic = .false.  ! Run without physics (full or idealized).
                                   ! this is mainly to turn off the Held-Suarez
                                   ! forcing in the "solo" mode
   logical :: full_phys = .true.   ! Run with full physics with virtual effects
                                   ! for R (gas constant) and Cp
   real:: consv_te  = 0.       ! Total energy fixer. Range[0,1.]. For example 0.75
                                   ! would provide 75% correction
! Divergence damping parameters: D = a_div + b_div * cos(lat)
   real:: a_div     = 0.6      !
   real:: b_div     = 0.6      !

#ifndef USE_LIMA
!!!1   real:: dry_mass = 98290.
#endif

#ifdef MARS_GCM
   real    :: p_ref = 700.
   real    :: fv_sponge_damp=   10.0
   real    :: fv_sponge_lev= 0.5      !   level (mb) for enhanced divergence damping 
   real    :: dry_mass = 7.01E2
#else
   real    :: p_ref = 1.E5
   real    :: dry_mass = 98290.
#endif


   logical :: cold_start      = .false.       ! read in initial condition
   logical :: change_time     = .false.       ! ignore time stamp in fv_rst.res
   logical :: adjust_dry_mass = .false.       ! adjust initial total dry air mass
   logical :: use_set_eta     = .false.       ! use set_eta(), instead of restart, for (ak,bk)
   logical :: pft_phys        = .true.        ! polar filter physical tendencies
   logical :: use_tendency    = .false.       ! use the tendency approach
   logical :: do_ch4_chem     = .false.       ! Relax H2o to Haloe data between 1 and 10 mb
   integer :: print_freq      = 0             ! Print max/min of selected fields
                                              ! 0: off
                                              ! positive n: every n hours
                                              ! negative n: every time step

#ifdef SW_DYN
   logical :: fill = .false.
#else
   logical :: fill = .true.  ! Activate a simple filling algorithm for tracers
#endif

   integer :: map_dt         ! Remapping time step (seconds); default to model
                             ! time step

! Default case for the shallow water test: Rossby wave-4
   integer :: icase = 6      ! Test case number if "SW_DYN" is defined
                             ! see tools/nit_sw_ic.f90 for details

   character(len=24) :: restart_format = 'native'   ! native or netcdf

   character(len=128) :: version = '$Id: fv_pack.F90 1.1.2.15.2.2'
   character(len=128) :: tagname = '$Name: tikal $'


#ifndef USE_LIMA
   namelist /fv_core_nml/nlon,      mlat,     nlev,                           &
                         ncnst,     nt_phys,  pnats,                          &
                         iord_mt,   iord_tm,  iord_tr,                        &
                         jord_mt,   jord_tm,  jord_tr,                        &
                         kord_mt,   kord_tm,  kord_tr,                        &
                         n_split,   n_zonal,  map_dt,                         &
                         consv_te,  restart_format,  adiabatic, full_phys,    &
                         fill,      adjust_dry_mass, n_spong, n_diffu,        &
                         change_time, a_div, b_div,  use_set_eta,             &
                         use_tendency, do_ch4_chem,  pft_phys, age_tracer,    &
                         tra_step, dyn_step, dry_mass, print_freq,  icase,    &
#ifdef MARS_GCM
                        p_ref, fv_sponge_lev, fv_sponge_damp,                      &
#endif MARS_GCM 
                         layout, fv_pset_stack
#else
   namelist /fv_core_nml/nlon,      mlat,     nlev,                           &
                         ncnst,     nt_phys,  pnats,                          &
                         iord_mt,   iord_tm,  iord_tr,                        &
                         jord_mt,   jord_tm,  jord_tr,                        &
                         kord_mt,   kord_tm,  kord_tr,                        &
                         n_split,   n_zonal,  map_dt,                         &
                         consv_te,  restart_format,  adiabatic, full_phys,    &
                         fill,      adjust_dry_mass, n_spong, n_diffu,        &
                         change_time, a_div, b_div,  use_set_eta,             &
                         use_tendency, do_ch4_chem,  pft_phys, age_tracer,    &
#ifdef MARS_GCM
                         p_ref, fv_sponge_lev, fv_sponge_damp,                      &
#endif MARS_GCM 
                         print_freq,  icase, layout

#endif

   logical mountain          ! If terrain is present
   integer nqrst             ! Total number of tracers in fv_rst file

!-----------------------------------------------------------------
! Domain decomposition parameters (not to be changed by the user):
!-----------------------------------------------------------------
   integer beglon             ! beginning lon index
   integer endlon             ! ending    lon index
   integer beglat             ! beginning lat index
   integer endlat             ! ending    lat index
   integer ng_d               ! algorithm dependent ghost zones
   integer ng_s               ! algorithm dependent ghost zones for u-wind
   logical master             ! If "master process"? used mostly for print
                              ! and read/write restart
! FMS specific:
   type(domain2D), save :: fv_domain


!-----------------------------------------------------------------------
! Eulerian vertical coordinate:
! pe(k) = ak(k) + bk(k) * ps
!-----------------------------------------------------------------------
   real, allocatable :: ak(:)
   real, allocatable :: bk(:)
   integer  ks                            ! number of layers in pure p region
   real ptop                          ! pressure at model top (pascal)

! Horizontal grid geometry
#ifndef USE_LIMA
   real, allocatable:: f_d(:,:)       !  Coriolis parm at cell center
#else
   real, allocatable:: f_d(:)       !  Coriolis parm at cell center
#endif
   real, allocatable:: dx(:)          !  grid distance (m) along latitude circles
   real, allocatable:: one_by_dx(:)   !  1 / dx
   real one_by_dy                     !  1 / dy
   real acap                          ! scaled polar area = nlon * cosp(1)
   real rcap                          ! 1 / acap

!-----------------------------------
! Geometric arrays
!-----------------------------------
   real, allocatable :: lon(:), lonb(:), rlonb(:)
   real, allocatable :: lat(:), latb(:), rlatb(:)
   real, allocatable :: rlat(:,:)
   real, allocatable :: rlon(:,:)
   real, allocatable :: area(:,:)         ! grid cell area: m**2
   real, allocatable :: sine(:)
   real, allocatable :: cose(:)
   real, allocatable :: sinp(:)
   real, allocatable :: cosp(:)
   real, allocatable :: acosp(:)
   real, allocatable :: acosu(:)          ! for u-wind averaging
   real, allocatable :: grid_weight(:)

   real, allocatable :: coslon(:)
   real, allocatable :: sinlon(:)
   real, allocatable :: cosl5(:)
   real, allocatable :: sinl5(:)

   real, parameter::cv_wv = 1463.  ! specific heat of water vapor at constant
                                       ! volume [J/(K KG)]
   real, parameter::cp_wv = 1952.  ! specific heat of water vapor at constant
                                       ! pressure [J/(K KG)]
   real cp_vir
   real pi

#ifdef USE_LIMA
! Polar filter related
   integer  ifax(13)                      !ECMWF fft
   real(r8), allocatable :: trigs(:)
   real(r8), allocatable :: dc(:,:), de(:,:), sc(:), se(:)
   integer:: ipft1, ipft2
#endif

!-----------------------------------------------------------------------
! Others:
!-----------------------------------------------------------------------
!   real, allocatable :: pesouth(:,:)  ! "pe at the south" for SPMD
   logical :: u_ghosted = .false.         ! u-wind is ghosted at the first lat to the N
   real, parameter::ptop_min = 1.E-6  ! minimum pressure (pa) at model top to avoid
                                          ! floating point exception; this is not needed
                                          ! if model top is not at zero
   real, parameter :: too_big = 1.E30      ! use this for missing values
   real :: age_time                   ! Time (sec) since init of age_tracer


#ifdef USE_LIMA
   integer:: js2g0, jn1g1
#endif
   integer:: ighost
!PUBLIC VARIABLES
   public :: nlon, mlat, nlev, beglon, endlon, beglat, endlat, &
        age_tracer, age_time, do_ch4_chem, u_ghosted, ng_d, ng_s, &
        use_tendency, pft_phys, ak, bk, get_eta_level, ptop, full_phys, &
        coslon, sinlon, ighost, cosp, sinp, cose, sine, master, &
        nt_phys, nt_prog, rlat, rlon, area, rlonb, rlatb, rcap, &
        one_by_dy, one_by_dx, f_d, acosp, ks, lon, lat, lonb, latb, &
        fv_domain, print_freq, do_fms_tracer_manager, nqrst, mountain, &
        adjust_dry_mass, use_set_eta, fms_tracers_file, restart_format, &
        cold_start, gid, acap, acosu, ptop_min, pi, n_spong, n_diffu, &
        a_div, b_div, cosl5, sinl5, dx, n_split, iord_mt, iord_tm, &
        iord_tr, jord_mt, jord_tm, jord_tr, kord_mt, kord_tm, kord_tr, &
        fill, n_zonal, cp_vir, icase, ncnst, pnats, consv_te, &
        change_time, grid_weight
#ifdef USE_LIMA
   public :: sc, se, dc, de, ipft1, ipft2, ifax, trigs, too_big
#else
   public :: dry_mass, tra_step, dyn_step, p_ref
#endif

#ifdef MARS_GCM
   public ::   fv_sponge_lev,  fv_sponge_damp
#endif

!Balaji: needed by solo driver
   public :: map_dt, adiabatic
!PUBLIC ROUTINES
   public fv_init, fv_end, d2a3d, p_var, polavg, drymadj, tracer_mass


! !REVISION HISTORY:
!
!   03.10.02     SJ Lin        Modifications from fvGCM
!   03.11.12     SJ Lin        Inline documentation
!   03.11.21     SJ Lin        Change pt from potential temperature to temperature
!   04.11.29     SJ Lin        Pre-2D decomposition modifications
!-----------------------------------------------------------------------

contains

 subroutine fv_init(ndt)
   use fms_io_mod, only : get_instance_filename

#ifdef USE_LIMA
   use pft_module, only: pft_init, fftfax
#endif
!#include "fv_arrays.h"

! SJL note:
! This routine initializes various parameters for FV and touch the arrays
! that should promote better memory placement on share memory machines (e.g., SGI)

   integer, intent(in)    :: ndt             ! model time step (seconds)

! LOCAL VARIABLES:
#ifdef USE_LIMA
   real rat, ycrit
#endif

   real:: dim0 = 180.           ! base dimension
   real:: dt0  = 1800.          ! base time step
   real:: ns0  = 4.             ! base nsplit for base dimension
   real dimx

   integer :: i, j, k, m, n
   integer :: unit, ierr, io
   integer :: kfirst, klast  ! useless (but required) input to y_decomp at this point
   integer, allocatable:: ysize(:)

! tracers
   integer :: num_family, index ! output of register_tracers
   integer, allocatable :: tracer_indices(:)
   logical :: is_in_nonadv_tracer_section
   character(len=128) :: msg, tname, restart_file_name
   integer :: log_unit, out_unit

   map_dt = ndt        ! mapping time step default to model time step

   call get_instance_filename('INPUT/fv_rst.res',restart_file_name )
   cold_start = (.not.file_exist('INPUT/fv_rst.res') &
         & .and. .not.file_exist('INPUT/fv_rst.res.nc')) &
         & .and. .not.file_exist(restart_file_name) &
         & .and. .not.file_exist('INPUT/'//fms_tracers_file)

!----- read namelist -----

#ifdef INTERNAL_FILE_NML
      read (input_nml_file,fv_core_nml,iostat=io)
      ierr = check_nml_error (io, 'fv_core_nml')
#else

    if (file_exist('input.nml')) then
          unit = open_namelist_file ( )
          ierr=1; do while (ierr /= 0)

! Every PE reading the same file? Ok on the SGI
             read (unit, nml=fv_core_nml, iostat=io, end=10)
                   ierr = check_nml_error (io, 'fv_core_nml')
          enddo
10    call close_file (unit)
    endif
#endif
!

! override number of tracers by reading field_table
    if (file_exist('field_table')) do_fms_tracer_manager = .TRUE.
    if (do_fms_tracer_manager) then !{


#ifndef MARS_GCM

#ifndef USE_LIMA
       if(full_phys .and. nt_phys /= 4) then !{
          call error_mesg('FV_INIT',  &
               & 'Wrong number of physics tracers nt_phys, should be 4! ', &
               FATAL)
       endif !}
#else
       if(nt_phys /= 4) then !{
          call error_mesg('FV_INIT',  &
               & 'Wrong number of physics tracers nt_phys, should be 4! ', &
               FATAL)
       endif !}
#endif

#endif 

       call tm_register_tracers (MODEL_ATMOS, ncnst, nt_prog, pnats, num_family)
       if(mpp_pe() == mpp_root_pe()) then
          out_unit = stdout()
          write(out_unit, *)'ncnst=', ncnst,' num_prog=',nt_prog,' pnats=',pnats,' num_family=',num_family
       endif


#ifndef MARS_GCM 

#ifndef USE_LIMA
       if(full_phys .and. nt_prog < nt_phys) then !{
          call error_mesg('FV_INIT',  &
               & 'Number of prognostic tracers in field_table should be >= number of physics tracers', &
               FATAL)
       endif !}
#else
       if(nt_prog < nt_phys) then !{
          call error_mesg('FV_INIT',  &
               & 'Number of prognostic tracers in field_table should be >= number of physics tracers', &
               FATAL)
       endif !}
#endif

#endif

       allocate(tracer_indices(ncnst))

       call tm_get_tracer_indices(MODEL_ATMOS, tracer_indices)

#ifndef USE_LIMA
       if(full_phys) then !{
#endif
 


#ifndef MARS_GCM
      ! Check tracer positions in field_table
       !
       ! sphum should the first entry
       ! followed by liq_wat, ice_wat, cld_amt (in any order)
       ! followed by all other advected tracers (if any)
       ! followed by non-advected tracers (if any)

          index = tm_get_tracer_index(MODEL_ATMOS, 'sphum', tracer_indices)
          if(index /= 1) then !{
             call error_mesg('FV_INIT',  &
                  & 'sphum should be the first tracer entry in field table ', &
                  FATAL)
          endif !}
          index = tm_get_tracer_index(MODEL_ATMOS, 'liq_wat', tracer_indices)
          if(index < 2 .or. index > 4) then !{
             call error_mesg('FV_INIT',  &
               & 'liq_wat should be tracer entry no 2 to 4 in field table ', &
               FATAL)
          endif !}
          index = tm_get_tracer_index(MODEL_ATMOS, 'ice_wat', tracer_indices)
          if(index < 2 .or. index > 4) then !{
             call error_mesg('FV_INIT',  &
               & 'ice_wat should be tracer entry no 2 to 4 in field table ', &
               FATAL)
          endif !}
          index = tm_get_tracer_index(MODEL_ATMOS, 'cld_amt', tracer_indices)
          if(index < 2 .or. index > 4) then !{
             call error_mesg('FV_INIT',  &
               & 'cld_amt should be tracer entry no 2 to 4 in field table ', &
               FATAL)
          endif
#endif


#ifndef USE_LIMA
       endif
#endif

       if(age_tracer) then !{
          ! age of air tracer should be present in field_table
          index = tm_get_tracer_index(MODEL_ATMOS, 'aoa', tracer_indices)
          if(index < 1 .or. index > ncnst) then !{
             call error_mesg('FV_INIT',  &
                  & 'age_tracer=.TRUE.: entry "aoa" is required in field table but could not find it', &
                  FATAL)
          endif !}
       endif !}

       ! check that non-advected tracers are defined last in field table

       is_in_nonadv_tracer_section = .FALSE.
       do i = 1, ncnst
          call tm_get_tracer_names(MODEL_ATMOS, tracer_indices(i), tname)
          if( is_in_nonadv_tracer_section .AND. &
               tm_check_if_prognostic(MODEL_ATMOS, tracer_indices(i)) ) then
             call tm_get_tracer_names(MODEL_ATMOS, tracer_indices(i), tname)
             write(msg, '(a,a,a)') 'Advected tracer ', tname,                    &
                   ' entry found after non-advected tracer entry in field table.'
             call error_mesg('FV_INIT', msg, FATAL)
          endif
          if( .NOT. tm_check_if_prognostic(MODEL_ATMOS, tracer_indices(i)) ) then
               is_in_nonadv_tracer_section = .TRUE.
          endif
       enddo

       deallocate(tracer_indices)

     endif !}

    call write_version_number(version, tagname)
    if ( mpp_pe() == mpp_root_pe() ) then
       log_unit = stdlog()
       write (log_unit, nml=fv_core_nml)
    endif

#ifdef SPMD
      ng_d = max( 2, min(3, max(jord_mt, jord_tm, jord_tr)) )
      ng_s   = 3
      ighost = 0
      gid = -999 !the PEs not participating in mod_comm will show this value
      call fv_arrays_init( nlon, mlat, nlev, ncnst, ng_d, ng_s, ighost, &
           fv_domain )
      master = (gid == 0)
!set some variables from SPMD correctly...
      call mpp_get_compute_domain( fv_domain, beglon, endlon, beglat, endlat )
!gid.NE.mpp_pe when npex.NE.1!
      call y_decomp( mlat, nlev, beglat, endlat, kfirst, klast, gid )
#else
      beglat = 1; endlat = mlat
      beglon = 1; endlon = nlon
      ng_d   = 0;   ng_s = 0
      ighost = 0
      master = .true.
      if( n_zonal == 0 ) n_zonal = 1
#endif

      if(master) then
         write(6,*) 'SMP pseudo domain decomposition in E-W =', n_zonal
         write(6,*) 'Cold_start=', cold_start
      endif

      call timing_init()
      call timing_on('Total')
!     call timing_on('FV_init')

!----------------------------------
! Determine nsplit for the dynamics
!----------------------------------

      if ( n_split == 0 ) then
           dimx   = max ( nlon, 2*(mlat-1) )
          n_split = nint ( ns0*abs(ndt)*dimx/(dt0*dim0) + 0.49 )
          n_split = max ( 1, n_split )
          if(master) write(6,*) 'n_split is set to ', n_split, ' for (im,jm,dt)=',nlon,mlat,ndt
      else
          if(master) write(6,*) 'Using n_split from the namelist: ', n_split
      endif

     if(master) write(6,*) 'Total number of sponge layers= ', n_spong

     if ( adiabatic ) full_phys = .false.

! Set up some constants:
     if ( full_phys ) then
          cp_vir = (cv_wv + rvgas) / cp_air - 1.
     else
          cp_vir = 0.
     endif


#ifdef MARS_GCM
          cp_vir = 0.0
#endif 

!--------------------------------------------
! Set up horizontal grid geometrical factors:
!--------------------------------------------

      call set_fv_geom

#ifndef USE_LIMA
      call pft_init(nlon, mlat, beglat, endlat, ighost, cosp, cose, master)
#else
      ipft1 = max(2, beglat-ighost)
      js2g0 = max(2, beglat)

      ipft2 = min(mlat-1, endlat+ighost)
      jn1g1 = min(mlat,   endlat+1)

      allocate( sc(ipft1:ipft2),            se(js2g0:jn1g1)  )
      allocate( dc(nlon,ipft1:ipft2),  de(nlon,js2g0:jn1g1) )
      allocate( trigs(3*nlon/2+1) )

      call fftfax(nlon, ifax, trigs)

!---------------------------------------------
! Determine ycrit such that effective DX >= DY
!---------------------------------------------
      rat = float(nlon)/float(2*(mlat-1))
      ycrit = acos( min(0.81, rat) ) * (180./pi)

      if ( master ) write(6,*) 'Critical latitude for pft=', ycrit
      write (6,*) 'nlon, mlat, js2g0, jn1g1 ', nlon, mlat, js2g0, jn1g1
      write (6,*)  ' size(sc,1), size(dc,1), size(dc,2) ', size(sc,1), size(dc,1), size(dc,2)

      call pft_init(nlon, mlat, js2g0, jn1g1,      &
                    sc,   se,   dc,    de,         &
                    cosp, cose, ycrit, ipft1, ipft2)

#endif

!
! Vertical reference Eulerian coordinate for remapping:
!
      ks   = -1000    ! something large enough to cause trouble if not initialized
      ptop = too_big

      allocate ( ak(nlev+1) )
      allocate ( bk(nlev+1) )

      call initialize_arrays
      call fv_print_chksums( 'Exiting  fv_init' )

 end subroutine fv_init

 subroutine initialize_arrays
#include "fv_arrays.h"

!   real, parameter :: too_big=huge(1.)

   integer :: i, j, k, m
#include "fv_point.inc"
!---------------------------
! Initialize prognostic vars:
!---------------------------
! Note: the use of omp parallel is for better memory placement
!       (the "first touch" principle)

!$omp parallel do private (i, j, k)
   do k=ksp,kep !1,nlev
      do j=beglat-ng_d,endlat+ng_s
         do i=1,nlon
            u(i,j,k) = too_big
         enddo
      enddo

      do j=beglat-ng_d,endlat+ng_d
         do i=1,nlon
            v(i,j,k) = too_big
         enddo
      enddo

      do j=beglat-ng_d,endlat+ng_d
         do i=1,nlon
            pt(i,j,k) = too_big
         enddo
      enddo

      do j=beglat,endlat
         do i=1,nlon
           delp(i,j,k) = too_big
         enddo
      enddo

      do j=beglat,endlat
         do i=1,nlon
            pkz(i,j,k) = too_big
         enddo
      enddo
  enddo

!------------------
! Initialize tracers
!------------------

  if(do_fms_tracer_manager) then !{

     ! use tracer_manager profile spec
     do m = 1, ncnst
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! should use 1D decomp here
!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        call tm_set_tracer_profile (MODEL_ATMOS, m, q(:,:,:,m))
     enddo

  else !}{

     ! default

     do m=1,ncnst
        !$omp parallel do private (i, j, k)
!        do k=1,nlev
        do k=ksp,kep
           do j=beglat-ng_d, endlat+ng_d
              do i=1,nlon
                 q(i,j,k,m) = too_big
              enddo
           enddo
        enddo
     enddo

  endif !}

!$omp parallel do private (i, j, k)
!  do k=1,nlev+1
  do k=ksp,kep+1 !NOTE that kep+1 overlaps between PEs!
     do j=beglat,endlat
        do i=1,nlon
           pk(i,j,k) = too_big
        enddo
     enddo
     do i = 1,nlon
        pesouth(i,k) = too_big
     end do
  enddo
  call fv_array_sync()

! The follwoing var are mostly used by physics
!$omp parallel do private (i, j, k)
!  do j=beglat, endlat
   do j=jsp,jep
      do i=1,nlon
         ps(i,j) = too_big
      enddo

      do k=1,nlev
         do i=1,nlon
            omga(i,j,k) = too_big
         enddo
      enddo

      do k=1, nlev+1
         do i=1,nlon
            pe  (i,k,j) = too_big
            peln(i,k,j) = too_big
         enddo
      enddo
! required to solve a denorm problem for HS (pletzer)
      do i = 1,nlon
         ps_bp(i,j) = too_big
         phis (i,j) = too_big
         u_srf(i,j) = too_big
         v_srf(i,j) = too_big
      end do
   enddo
   call fv_array_sync()

 end subroutine initialize_arrays

!-----------------------------------------------------------------------

 subroutine get_eta_level(km, p_s, pf, ph, pscale)

  integer, intent(in) :: km
  real, intent(in)  :: p_s            ! unit: pascal
  real, intent(out) :: pf(km)
  real, intent(out) :: ph(km+1)
  real, intent(in), optional :: pscale

  integer k
  real    ak1

  if(nlev /= km)  &
  call error_mesg('get_eta_level:','dimensionally inconsistent', FATAL)

     ph(1) = ak (1)
  do k=2,nlev+1
     ph(k) = ak (k) + bk(k)*p_s
  enddo

  if ( present(pscale) ) then
      do k=1,nlev+1
         ph(k) = pscale*ph(k)
      enddo
  endif

  if( ak(1) > ptop_min ) then
     pf(1) = (ph(2) - ph(1)) / log(ph(2)/ph(1))
  else
     ak1 = (kappa + 1.) / kappa
     pf(1) = (ph(2) - ph(1)) / ak1
!    if(master) write(*,*) 'Modified p_full(1)=',pf(1), 0.5*(ph(1)+ph(2))
  endif

  do k=2,nlev
     pf(k) = (ph(k+1) - ph(k)) / log(ph(k+1)/ph(k))
  enddo

 end subroutine get_eta_level

!-----------------------------------------------------------------------

 subroutine set_fv_geom
! Sets the geometric factors used in FV core for the lat-lon grid
! This routine should only be called once per run

   integer i, j, imh
   real dp, dl
   real ph5, zamda, zam5
   real dg2r, asum, gmean

   allocate (  lon(nlon) )
   allocate (  lonb(nlon+1) )
   allocate ( rlonb(nlon+1) )

   allocate (   lat(mlat) )
   allocate (  latb(mlat+1) )
   allocate ( rlatb(mlat+1) )

   allocate ( rlat(nlon,beglat:endlat) )
   allocate ( rlon(nlon,beglat:endlat) )
   allocate ( area(nlon,beglat:endlat) )

   allocate ( cose(mlat) )
   allocate ( sine(mlat) )
   allocate ( cosp(mlat) )
   allocate ( sinp(mlat) )
   allocate (acosp(mlat) )
   allocate (acosu(mlat) )
   allocate ( grid_weight(mlat) )

   allocate ( coslon(nlon) )
   allocate ( sinlon(nlon) )

   allocate ( cosl5(nlon) )
   allocate ( sinl5(nlon) )

   allocate ( dx(mlat) )
   allocate ( one_by_dx(mlat) )
#ifndef USE_LIMA
   allocate ( f_d(nlon,beglat-ng_d:endlat+ng_d) )
#else
   allocate ( f_d(beglat-ng_d:endlat+ng_d) )
#endif


   pi = 4.d0 * atan(1.d0)
   dl = (pi+pi) / nlon
   dp = pi/(mlat-1)

         sine(1) = -1.
      do j=2,mlat
            ph5  = -0.5d0*pi + (dble(j-1)-0.5d0)*(pi/dble(mlat-1))
         sine(j) = sin(ph5)
      enddo

      do j=1,mlat-1
         grid_weight(j) = sine(j+1) - sine(j)
      enddo
         grid_weight(mlat) = 1. - sine(mlat)

! Define area-conservative cosine at "cell center"
      do j=1,mlat
                cosp(j) = grid_weight(j) / dp
               acosp(j) = dp / grid_weight(j)
         grid_weight(j) = grid_weight(j) / (2*nlon)
      enddo

! Define cosine at edges..

         cose(1) = 0.
         cose(2) = 0.5 * cosp(2)
      do j=3,mlat-1
         cose(j) = 0.5 * (cosp(j-1) + cosp(j))
      enddo
         cose(mlat) = cose(2)

      do j=2,mlat-1
         acosu(j) = 2. / (cose(j) + cose(j+1))
      enddo

      do j=1,mlat-1
         sinp(j) = 0.5 * (sine(j) + sine(j+1))
      enddo
         sinp(mlat) = 0.5 * (sine(mlat) + 1.)

      acap = nlon*(1.+sine(2))/dp               ! acap = nlon * cosp(1)
      rcap = 1.d0 / acap

! Coriolis parameter at cell center

#ifndef USE_LIMA
      do j = max(1,beglat-ng_d), min(mlat,endlat+ng_d)
         do i=1,nlon
            f_d(i,j) = (omega+omega) * sinp(j)
         enddo
      enddo
#else
      do j = max(1,beglat-ng_d), min(mlat,endlat+ng_d)
         f_d(j) = (omega+omega) * sinp(j)
      enddo
#endif

!-------------
! Bounding box
!-------------

      do j = 2, mlat
         latb(j) = -90. + (real(j-1)-0.5) * 180. / real(mlat-1)
      enddo

      latb( 1 ) = -90.
      latb( mlat+1 ) =  90.

      do j=1, mlat
         lat(j) = 0.5 * ( latb(j) + latb(j+1) )
      enddo

      one_by_dy = 1. / ( radius*dp )

      do j=2, mlat-1
                dx(j) = dl*radius*cosp(j)
         one_by_dx(j) = 1. / dx(j)
      enddo

            dg2r = pi/180.

      do j=1,mlat+1
         rlatb(j) = dg2r * latb(j)
      enddo

!-------------------------------
! Set longitude dependent param
!-------------------------------

      do i=1,nlon+1
#ifdef OLD_WAY
         lonb(i) = (real(i-1)-0.5) * 360. / real(nlon)
#else
!--------------------------
! FMS B grid way:
!--------------------------
         lonb(i) = real(i-1)*360./real(nlon)
#endif
      enddo

      do i=1,nlon
         lon(i) = 0.5 * ( lonb(i) + lonb(i+1) )
      enddo

      do i=1,nlon+1
         rlonb(i) = dg2r * lonb(i)
      enddo


        imh = nlon/2
      if(nlon /= 4*(imh/2)) then
         call error_mesg('FV_INIT','nlon must be dividable by 4', FATAL)
      endif

      do i=1,imh
#ifdef OLD_WAY
         zam5          = ((i-1)-0.5d0) * dl
         zamda         =  (i-1)*dl
#else
         zam5          = (i-1) * dl
         zamda         = (0.5d0+(i-1))*dl
#endif
         cosl5(i)      =  cos(zam5)
         cosl5(i+imh)  = -cosl5(i)
         sinl5(i)      =  sin(zam5)
         sinl5(i+imh)  = -sinl5(i)
         coslon(i)     =  cos(zamda)
         coslon(i+imh) = -coslon(i)
         sinlon(i)     =  sin(zamda)
         sinlon(i+imh) = -sinlon(i)
      enddo

      do j=beglat, endlat
         do i=1,nlon
            rlat(i,j) = dg2r * lat(j)
            rlon(i,j) = dg2r * lon(i)          ! Cubed sphere ready
            area(i,j) = (radius*dl*cosp(j)) * (dp*radius)
         enddo
      enddo

         asum = gmean(nlon, mlat, beglat, endlat, area)
      if(master) then
         write(6,*) 'Mean cell width (km)=', 1.e-3*sqrt(asum)
      endif

 end subroutine set_fv_geom

 subroutine fv_end(days, seconds)

integer, intent(in):: days
integer, intent(in):: seconds

      deallocate ( lon )
      deallocate ( lat )
      deallocate ( rlat )
      deallocate ( rlon )
      deallocate ( area )

      deallocate ( lonb )
      deallocate ( latb )

      deallocate ( rlonb )
      deallocate ( rlatb )

      deallocate ( cose )
      deallocate ( sine )
      deallocate ( cosp )
      deallocate ( sinp )
      deallocate ( grid_weight )

      deallocate ( acosp )
      deallocate ( acosu )

      deallocate ( coslon )
      deallocate ( sinlon )

      deallocate ( cosl5 )
      deallocate ( sinl5 )

      deallocate ( ak )
      deallocate ( bk )

      deallocate ( dx )
      deallocate ( one_by_dx )

      call fv_arrays_exit
! Clean up polar filter module:

#ifndef USE_LIMA
      call pft_end
#endif


      call timing_off('Total')

#ifdef SPMD
      call timing_prt(gid)
      call mp_exit( .false. )         !Call mp_exit to cleanly exit mod_comm
#else
      call timing_prt(0)
#endif
 end subroutine fv_end

 subroutine d2a3d(u,   v,   ua,   va,   im,   jm,   km,     &
                  jfirst, jlast, ng_d, ng_s,  coslon, sinlon)
! !ROUTINE: d2a3d -- Second order D-to-A grid transformation (3D)

! !INPUT PARAMETERS:
      integer, intent(in):: im, jm, km           ! Dimensions
      integer, intent(in):: jfirst, jlast        ! Latitude strip
      integer, intent(in):: ng_d, ng_s           ! as defined in fvgcm.F

      real, intent(in):: coslon(im),sinlon(im)    ! Sine and cosine in longitude
      real, intent(in):: v(im,jfirst-ng_d:jlast+ng_d,km)

      real, intent(inout):: u(im,jfirst-ng_d:jlast+ng_s,km)

! !OUTPUT PARAMETERS:
      real, intent(out):: ua(im,jfirst:jlast,km)   ! U-Wind on A Grid
      real, intent(out):: va(im,jfirst:jlast,km)   ! V-Wind on A Grid

! local
      integer i, j, k
      integer imh, js2g0
      real un, vn, us, vs

      integer :: ks, ke

      imh = im/2
      js2g0 = max(jfirst, 2)

      call fv_array_check( LOC(u ) )
      call fv_array_check( LOC(v ) )
      call fv_array_check( LOC(ua) )
      call fv_array_check( LOC(va) )

#ifdef SPMD
      if ( .not. u_ghosted ) then
      call mp_send3d(gid-1, gid+1, im, jm, km,              &
                     1, im, jfirst-ng_d, jlast+ng_s, 1, km, &
                     1, im, jfirst, jfirst, 1, km, u)
      endif
#endif
      if( km.EQ.1 )then
!this means processing the last level km=nlev, surface
          ks=1; ke=1
      else if( km.EQ.nlev )then
          ks=ksp; ke=kep !shared arrays
      else
          call mpp_error( FATAL, 'D2A3D: shared pointers requires km.EQ.1 or km.EQ.nlev' )
      end if

!$omp parallel do private(i,j,k,us,vs,un,vn)
      do k=ks,ke !1,km
         do j=js2g0,jlast-1
            do i=1,im
               ua(i,j,k) = 0.5*(u(i,j,k) + u(i,j+1,k))
            enddo
         enddo

         do j=js2g0,min(jlast,jm-1)
            do i=1,im-1
               va(i,j,k) = 0.5*(v(i,j,k) + v(i+1,j,k))
            enddo
            va(im,j,k) = 0.5*(v(im,j,k) + v(1,j,k))
         enddo

         if( jfirst == 1 ) then
! Projection at SP
             us = 0.
             vs = 0.
             do i=1,imh
                us = us + (ua(i+imh,2,k)-ua(i,2,k))*sinlon(i)      &
                     + (va(i,2,k)-va(i+imh,2,k))*coslon(i)
                vs = vs + (ua(i+imh,2,k)-ua(i,2,k))*coslon(i)      &
                     + (va(i+imh,2,k)-va(i,2,k))*sinlon(i)
             enddo
             us = us/im
             vs = vs/im
             do i=1,imh
                ua(i,1,k)   = -us*sinlon(i) - vs*coslon(i)
                va(i,1,k)   =  us*coslon(i) - vs*sinlon(i)
                ua(i+imh,1,k)   = -ua(i,1,k)
                va(i+imh,1,k)   = -va(i,1,k)
             enddo
         endif

         if ( jlast == jm ) then
! Projection at NP
             un = 0.
             vn = 0.
             do i=1,imh
                un = un + (ua(i+imh,jm-1,k)-ua(i,jm-1,k))*sinlon(i)    &
                     + (va(i+imh,jm-1,k)-va(i,jm-1,k))*coslon(i)
                vn = vn + (ua(i,jm-1,k)-ua(i+imh,jm-1,k))*coslon(i)    &
                     + (va(i+imh,jm-1,k)-va(i,jm-1,k))*sinlon(i)
             enddo

             un = un/im
             vn = vn/im
             do i=1,imh
                ua(i,jm,k) = -un*sinlon(i) + vn*coslon(i)
                va(i,jm,k) = -un*coslon(i) - vn*sinlon(i)
                ua(i+imh,jm,k) = -ua(i,jm,k)
                va(i+imh,jm,k) = -va(i,jm,k)
             enddo
         endif
      enddo

#ifdef SPMD
      if ( .not. u_ghosted ) then
      call mp_recv3d(gid+1, im, jm, km, &
                         1, im, jfirst-ng_d, jlast+ng_s, 1, km, &
                         1, im, jlast+1, jlast+1, 1, km, u)
           u_ghosted = .true.
      endif
      call fv_array_sync()

      if ( jlast < jm ) then
!balaji, switched parallelization to i, since km might be 1
!$omp parallel do private(i, k)
        do k=1,km
           do i=isp,iep
              ua(i,jlast,k) = 0.5 * ( u(i,jlast,k) + u(i,jlast+1,k) )
           enddo
        enddo
      endif
#endif
      call fv_array_sync()
    end subroutine d2a3d

 subroutine p_var(im, jm, km, jfirst, jlast, ptop,    &
                  delp,  ps,  pe, peln, pk, pkz,      &
                  cappa, q,   ng, nq, adjust_dry_mass )

! Given (ptop, delp) computes (ps, pk, pe, peln, pkz)
!

! Input:
   integer,  intent(in):: im, jm, km               ! Dimensions
   integer,  intent(in):: jfirst, jlast            ! Latitude strip
   integer,  intent(in):: nq
   integer,  intent(in):: ng
   logical,  intent(in):: adjust_dry_mass

   real, intent(in):: ptop
   real, intent(in):: cappa
   real, intent(inout):: delp(im,jfirst:jlast, km)
   real, intent(inout):: q(im,jfirst-ng:jlast+ng, km, nq)
! Output:
   real, intent(out) ::   ps(im, jfirst:jlast)
   real, intent(out) ::   pk(im, jfirst:jlast, km+1)
   real, intent(out) ::   pe(im, km+1, jfirst:jlast)    ! Edge pressure
   real, intent(out) :: peln(im, km+1, jfirst:jlast)    ! Edge pressure
   real, intent(out) ::  pkz(im, jfirst:jlast, km)

! Local
   real pek
   real lnp
   real ak1
   integer i, j, k

   pek = ptop ** cappa
   ak1 = (cappa + 1.) / cappa

   call fv_array_check( LOC(delp) )
   call fv_array_check( LOC(q) )
   call fv_array_check( LOC(ps) )
   call fv_array_check( LOC(pk) )
   call fv_array_check( LOC(pe) )
   call fv_array_check( LOC(peln) )
   call fv_array_check( LOC(pkz) )

!$omp parallel do private(i,j,k)
   do j=jsp,jep !jfirst,jlast
      do i=1,im
         pe(i,1,j) = ptop
         pk(i,j,1) = pek
      enddo

      do k=2,km+1
         do i=1,im
            pe(i,k,j) = pe(i,k-1,j) + delp(i,j,k-1)
            peln(i,k,j) = log(pe(i,k,j))
            pk(i,j,k) = pe(i,k,j)**cappa
         enddo
      enddo

      do i=1,im
         ps(i,j) = pe(i,km+1,j)
      enddo

!---- GFDL modification
      if( ptop < ptop_min ) then
          do i=1,im
             peln(i,1,j) = peln(i,2,j) - ak1
          enddo
      else
             lnp = log( ptop )
          do i=1,im
             peln(i,1,j) = lnp
          enddo
      endif
!---- GFDL modification

      do k=1,km
        do i=1,im
           pkz(i,j,k) = (pk(i,j,k+1)-pk(i,j,k))/(cappa*(peln(i,k+1,j)-peln(i,k,j)))
        enddo
      enddo
   enddo
   call fv_array_sync()

! Check dry air mass:
   call drymadj( im,  jm,  km,  jfirst,  jlast, ng, mountain, cappa,   &
                 ptop,   ps, delp, pe, pk, peln, pkz, nq, q, adjust_dry_mass )

 end subroutine p_var


 subroutine polavg(p, im, jm, jfirst, jlast)
 integer, intent(in):: im, jm, jfirst, jlast
 real, intent(inout):: p(im,jfirst:jlast)

! local:
   integer i
   real sum1

   if ( jfirst == 1 ) then
           sum1 = 0.
        do i=1,im
           sum1 = sum1 + p(i,1)
        enddo
           sum1 = sum1/im

        do i=1,im
           p(i,1) = sum1
        enddo
   endif

   if ( jlast == jm ) then
           sum1 = 0.
        do i=1,im
           sum1 = sum1 + p(i,jm)
        enddo
           sum1 = sum1/im

        do i=1,im
           p(i,jm) = sum1
        enddo
   endif

 end subroutine polavg


 subroutine drymadj( im,  jm,  km,  jfirst,  jlast,  ng, &
                     moun, cappa,   ptop, ps, delp, pe,  &
                     pk, peln, pkz, nq, q, adjust_dry_mass )

! !INPUT PARAMETERS:
      integer im, jm, km     ! Dimensions
      integer jfirst, jlast  ! Latitude strip
      integer nq             ! Number of tracers
      integer ng
      logical moun
      logical, intent(in):: adjust_dry_mass
      real, intent(in):: ptop
      real, intent(in):: cappa

! !INPUT/OUTPUT PARAMETERS:
      real  delp(im,jfirst:jlast,km)     !
      real  pe(im,km+1,jfirst:jlast)     !
      real   q(im,jfirst-ng:jlast+ng,km,nq)
      real  ps(im,jfirst:jlast)        ! surface pressure

      real, intent(inout)::   pk(im, jfirst:jlast, km+1)
      real, intent(inout):: peln(im, km+1, jfirst:jlast)    ! Edge pressure
      real, intent(inout)::  pkz(im, jfirst:jlast, km)

#ifdef USE_LIMA
      real drym

!     parameter ( drym = 98222. )       ! setting for US NAVY 10 min data
      parameter ( drym = 98288. )       ! setting for USGS
!     parameter ( drym = 98290. )       ! New setting for USGS
#endif

      integer   i, j, k
      real   psmo
      real   psdry, qtot
      real   gmean
      real   dpd
      integer ic, ip
! Local
      real  psq(im,jfirst:jlast)
      real  psd(im,jfirst:jlast)     ! surface pressure  due to dry air mass
#ifdef use_shared_pointers
      pointer( p_psq, psq )
      pointer( p_psd, psd )
      call fv_stack_push( p_psq, im*(jlast-jfirst+1) )
      call fv_stack_push( p_psd, im*(jlast-jfirst+1) )
#endif
      call fv_array_check( LOC(delp) )
      call fv_array_check( LOC(pe) )
      call fv_array_check( LOC(q) )
      call fv_array_check( LOC(ps) )
      call fv_array_check( LOC(pk) )
      call fv_array_check( LOC(peln) )
      call fv_array_check( LOC(pkz) )

      ip = min(3,size(q,4))

!$omp  parallel do          &
!$omp  default(shared)      &
!$omp  private(i,j,k)
      do 1000 j=jsp,jep !jfirst,jlast
         do i=1,im
            psd(i,j) = ptop
            psq(i,j) = 0.
         enddo

#ifdef MARS_GCM
         do k=1,km
            do i=1,im
               psd(i,j) = psd(i,j) +  delp(i,j,k)
            enddo
         enddo
#else

         if( full_phys ) then
             do k=1,km
                do i=1,im
                   psd(i,j) = psd(i,j) + delp(i,j,k)*(1.-q(i,j,k,1))
!             psq(i,j) = psq(i,j) + delp(i,j,k)*(q(i,j,k,1)+q(i,j,k,2)+q(i,j,k,3))
                   psq(i,j) = psq(i,j) + delp(i,j,k)*sum( q(i,j,k,1:ip) )
                enddo
             enddo
         else
             do k=1,km
                do i=1,im
                   psd(i,j) = psd(i,j) +  delp(i,j,k)
                enddo
             enddo
         endif
#endif MARS_GCM

1000  continue
      call fv_array_sync() !probably needed before gmean

! Check global maximum/minimum
      psmo  = gmean(im, jm, jfirst, jlast, ps (1,jfirst))
      psdry = gmean(im, jm, jfirst, jlast, psd(1,jfirst))
       qtot = gmean(im, jm, jfirst, jlast, psq(1,jfirst))

      if(master) then
         write(6,*) 'Total surface pressure (mb) = ', 0.01*psmo
         if ( full_phys ) then
         write(6,*) 'mean dry surface pressure = ', 0.01*psdry
         write(6,*) 'TPW-vapor (kg/m**2) =', (psmo-psdry)/GRAV
         write(6,*) 'TPW-total (kg/m**2) =', qtot/GRAV
         endif
      endif

      if( .not. adjust_dry_mass ) return

#ifndef USE_LIMA
      if(moun) then
         dpd = dry_mass - psdry
      else
         dpd = 1000.*100. - psdry
      endif
#else
      if(moun) then
         dpd = drym - psdry
      else
         dpd = 1000.*100. - psdry
      endif
#endif

      if(master) write(6,*) 'dry mass to be added (pascals) =', dpd

!$omp  parallel do            &
!$omp  default(shared)        &
!$omp  private(i,j, ic)

      do 2000 j=jsp,jep !jfirst,jlast
         do ic=1,nq
            do i=1,im
               q(i,j,km,ic) = q(i,j,km,ic)*delp(i,j,km) / (delp(i,j,km)+dpd)
            enddo
         enddo

! Adjust the lowest Lagrangian layer
         do i=1,im
            delp(i,j,km) = delp(i,j,km) + dpd
            pe(i,km+1,j) = pe(i,km,j) + delp(i,j,km)
            ps(i,j) = pe(i,km+1,j)
! adjust pk, peln, pkz
            pk(i,j,km+1) = pe(i,km+1,j) ** cappa
            peln(i,km+1,j) = log(pe(i,km+1,j))
            pkz(i,j,km) = (pk(i,j,km+1)-pk(i,j,km)) /      &
                 (cappa*(peln(i,km+1,j)-peln(i,km,j)))
         enddo
2000  continue
      call fv_array_sync() !probably needed before gmean

      psmo = gmean(im, jm, jfirst, jlast, ps(1,jfirst) )
      if( master ) write(6,*)                                     &
              'Total (moist) surface pressure after adjustment = ', &
               0.01*psmo

 end subroutine drymadj


 subroutine tracer_mass(im, jm, km, jfirst, jlast, ng, nq, q, delp)


! !INPUT PARAMETERS:
      integer im, jm, km     ! Dimensions
      integer jfirst, jlast  ! Latitude strip
      integer nq             ! Number of tracers
      integer ng

      real  delp(im,jfirst:jlast,km)     !
      real   q(im,jfirst-ng:jlast+ng,km,nq)

! Local
      real   gmean
      real  qz(im,jfirst:jlast,nq)
      real  qmass
      integer   i, j, k
      integer iq
#ifdef use_shared_pointers
      pointer( p_qz, qz )
      call fv_stack_push( p_qz, im*(jlast-jfirst+1)*nq )
#endif

      call fv_array_check( LOC(delp) )
      call fv_array_check( LOC(q) )
      do iq=1,nq

!$omp  parallel do          &
!$omp  default(shared)      &
!$omp  private(i,j,k)
      do 1000 j=jsp,jep
        do i=1,im
           qz(i,j,iq) = 0.
        enddo

        do k=1,km
           do i=1,im
              qz(i,j,iq) = qz(i,j,iq) + delp(i,j,k)*q(i,j,k,iq)
           enddo
        enddo
1000    continue
        call fv_array_sync()

      qmass = gmean(im, jm, jfirst, jlast, qz(1,jfirst,iq))

      if(master) write(6,*) iq, 'tracer mass = ', qmass

      enddo

 end subroutine tracer_mass
end module fv_pack

module atmos_soa_mod
! <DESCRIPTION>
!   This module is an implementation of Secondary organic aerosols (SOA)
!   from anthropogenic activities, and is based on Tie et al. (JGR, 2003).
!   The only souce of SOA is due to the oxydation of C4H10 by OH.
!   The concentrations of these 2 gas species are read as input.
! </DESCRIPTION>
! <WARNING>
!  To save space only the actual month of input files are kept in memory. 
!  This implies that the "atmos_SOA_init" should be executed at the begining 
!  of each month. In other words, the script should not run more than 1 month
!  without a restart.
! </WARNING>
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Paul Ginoux
! </CONTACT>
!-----------------------------------------------------------------------

use mpp_mod, only: input_nml_file 
use                    fms_mod, only : file_exist,              &
                                       write_version_number,    &
                                       mpp_pe,                  &
                                       mpp_root_pE,             &
                                       close_file,              &
                                       stdlog,                  &
                                       check_nml_error, error_mesg, &
                                       open_namelist_file, FATAL
use           time_manager_mod, only : time_type
use           diag_manager_mod, only : send_data,               &
                                       register_diag_field,     &
                                       register_static_field
use         tracer_manager_mod, only : get_tracer_index,        &
                                       set_tracer_atts
use          field_manager_mod, only : MODEL_ATMOS
use              constants_mod, only : PI, GRAV, RDGAS, WTMAIR
use           interpolator_mod, only:  interpolate_type,  &
                                       interpolator_init, &
                                       obtain_interpolator_time_slices,&
                                       unset_interpolator_time_flag, &
                                       interpolator, interpolator_end, &
                                       CONSTANT, INTERP_WEIGHTED_P

implicit none

private
!-----------------------------------------------------------------------
!----- interfaces -------
!
public  atmos_SOA_init, atmos_SOA_end, atmos_SOA_chem, &
        atmos_SOA_time_vary, atmos_soa_endts

!-----------------------------------------------------------------------
!----------- namelist -------------------
!-----------------------------------------------------------------------

!--- Arrays to help calculate tracer sources/sinks ---

character(len=6), parameter :: module_name = 'tracer'

integer :: nSOA = 0  ! tracer number for Secondary Organic Aerosol 

!--- identification numbers for  diagnostic fields and axes ----
integer ::   id_OH_conc            = 0
integer ::   id_C4H10_conc         = 0
integer ::   id_SOA_chem           = 0
integer ::   id_SOA_chem_col       = 0

type(interpolate_type),save         ::  gas_conc_interp
character(len=32)  :: gas_conc_filename = 'gas_conc_3D.nc'
character(len=32), dimension(2) :: gas_conc_name
data gas_conc_name/'OH','C4H10'/

namelist /secondary_organics_nml/ gas_conc_filename, gas_conc_name

logical :: module_is_initialized=.FALSE.
logical :: used

!---- version number -----
character(len=128) :: version = '$Id: atmos_soa.F90,v 20.0 2013/12/13 23:24:02 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
!-----------------------------------------------------------------------

contains


!#######################################################################

!<SUBROUTINE NAME="atmos_SOA_init">
!<OVERVIEW>
! The constructor routine for the soa module.
!</OVERVIEW>
 subroutine atmos_SOA_init ( lonb, latb, nlev, axes, Time, mask)
!-----------------------------------------------------------------------
real,             intent(in), dimension(:,:)        :: lonb, latb
integer,          intent(in)                        :: nlev
type(time_type),  intent(in)                        :: Time
integer,          intent(in)                        :: axes(4)
real, intent(in), dimension(:,:,:), optional        :: mask
character(len=7), parameter :: mod_name = 'tracers'
!
!-----------------------------------------------------------------------
!
      integer  unit,io,ierr, logunit
      character(len=3) :: SOA_tracer
!
      data SOA_tracer/'SOA'/

!
      if (module_is_initialized) return
!    read namelist.
!-----------------------------------------------------------------------
      if ( file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
        read (input_nml_file, nml=secondary_organics_nml, iostat=io)
        ierr = check_nml_error(io,'secondary_organics_nml')
#else
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=secondary_organics_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'secondary_organics_nml')
        end do
10      call close_file (unit)
#endif
      endif

!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit=stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                          write (logunit, nml=secondary_organics_nml)

!----- set initial value of soa ------------

      nSOA = get_tracer_index(MODEL_ATMOS,'SOA')
      if (nSOA > 0) then
         call set_tracer_atts(MODEL_ATMOS,'SOA','SOA','mmr')
         if (nSOA > 0 .and. mpp_pe() == mpp_root_pe()) &
                 write (*,30) SOA_tracer,nsoa
         if (nSOA > 0 .and. mpp_pe() == mpp_root_pe()) &
                 write (logunit,30) SOA_tracer,nsoa
      endif


  30   format (A,' was initialized as tracer number ',i2)

     call interpolator_init (gas_conc_interp, trim(gas_conc_filename),  &
                             lonb, latb,&        
                             data_out_of_bounds=  (/CONSTANT/), &
                             data_names = gas_conc_name, & 
                             vert_interp=(/INTERP_WEIGHTED_P/) )
      if (id_OH_conc .eq. 0 ) &
        id_OH_conc    = register_diag_field ( mod_name,           &
                      'OH_SOA_conc',axes(1:3),Time,                        &
                      'Hydroxyl radical concentration',           &
                      'molec.cm-3')

      id_C4H10_conc    = register_diag_field ( mod_name,           &
                      'C4H10_mmr',axes(1:3),Time,                        &
                      'nButane concentration',           &
                      'mmr')

      id_SOA_chem    = register_diag_field ( mod_name,       &
                      'SOA_chem',axes(1:3),Time,            &
                      'SOA production by C4H10 + OH',        &
                      'kg/m2/s')

      id_SOA_chem_col= register_diag_field ( mod_name,       &
                      'SOA_chem_col',axes(1:2),Time,            &
                      'column SOA production by C4H10 + OH',        &
                      'kg/m2/s')

      call write_version_number(version, tagname)

      module_is_initialized = .TRUE.

!-----------------------------------------------------------------------
 end subroutine atmos_SOA_init




!#####################################################################

subroutine atmos_SOA_time_vary (Time)

type(time_type), intent(in) :: Time


      call obtain_interpolator_time_slices (gas_conc_interp, Time)

end subroutine atmos_SOA_time_vary


!#####################################################################

subroutine atmos_SOA_endts             


      call unset_interpolator_time_flag (gas_conc_interp)


end subroutine atmos_SOA_endts



!#####################################################################

!</SUBROUTINE>

!#######################################################################
!<SUBROUTINE NAME="atmos_SOA_end">
!<OVERVIEW>
!  The destructor routine for the soa module.
!</OVERVIEW>
! <DESCRIPTION>
! This subroutine writes the version name to logfile and exits. 
! </DESCRIPTION>
!<TEMPLATE>
! call atmos_SOA_end
!</TEMPLATE>
 subroutine atmos_SOA_end

      call interpolator_end (gas_conc_interp)
      module_is_initialized = .FALSE.

 end subroutine atmos_SOA_end
!</SUBROUTINE>
!-----------------------------------------------------------------------
      SUBROUTINE atmos_SOA_chem(pwt,temp,pfull, phalf, dt, &
                          jday,hour,minute,second,lat,lon, &
                          SOA, SOA_dt, Time,Time_next,is,ie,js,je,kbot)

! ****************************************************************************
      real, intent(in),    dimension(:,:,:)          :: pwt
      real, intent(in),    dimension(:,:,:)          :: temp,pfull,phalf
      real, intent(in)                               :: dt
      integer, intent(in)                            :: jday, hour,minute,second
      real, intent(in),  dimension(:,:)              :: lat, lon  ! [radian]
      real, intent(in),    dimension(:,:,:)          :: SOA
      real, intent(out),   dimension(:,:,:)          :: SOA_dt
      type(time_type), intent(in)                    :: Time, Time_next
      integer, intent(in),  dimension(:,:), optional :: kbot
      integer, intent(in)                            :: is,ie,js,je
! Working vectors
      real, dimension(size(SOA,1),size(SOA,2),size(SOA,3)) :: &
               SOA_chem, OH_conc, C4H10_conc
      real, dimension(size(SOA,1),size(SOA,2)) :: &
               SOA_prod, &
               xu, dayl, h, hl, hc, hred, fac_OH, fact_OH
      real, parameter                            :: wtm_C = 12.
      real, parameter                            :: wtm_C4H10 = 58.
      real, parameter                            :: yield = 0.1
      real, parameter                            :: small_value=1.e-21
      real, parameter                            :: A0 = 0.006918
      real, parameter                            :: A1 = 0.399912
      real, parameter                            :: A2 = 0.006758
      real, parameter                            :: A3 = 0.002697
      real, parameter                            :: B1 = 0.070257
      real, parameter                            :: B2 = 0.000907
      real, parameter                            :: B3 = 0.000148
      real                                       :: decl, hd, x
      integer :: i,j,k,id,jd,kd
      integer                                    :: istep, nstep
! Local grid sizes
      id=size(SOA,1); jd=size(SOA,2); kd=size(SOA,3)

      OH_conc(:,:,:)=0.  ! molec/cm3
      call interpolator(gas_conc_interp, Time, phalf, OH_conc, &
                       trim(gas_conc_name(1)), is, js)

      C4H10_conc(:,:,:)=0.0
      call interpolator(gas_conc_interp, Time, phalf, C4H10_conc, &
                       trim(gas_conc_name(2)), is, js)
      C4H10_conc(:,:,:)=C4H10_conc(:,:,:)*WTM_C4H10/WTMAIR

      x = 2. *pi *float(jday-1)/365.
      decl = A0 - A1*cos(  X) + B1*sin(  X) - A2*cos(2.*X) + B2*sin(2.*X) &
           - A3*cos(3.*X) + B3*sin(3.*X)
      xu(:,:) = -tan(lat(:,:))*tan(decl)
      where ( xu > -1 .and. xu < 1 ) dayl=acos(xu)/pi
      where ( xu <= -1 ) dayl = 1.
      where ( xu >= 1 ) dayl = 0.
!   Calculate normalization factors for OH and NO3 such that
!   the diurnal average respect the monthly input values.
      hd=0.
      fact_OH(:,:)  = 0.
      nstep = int(24.*3600./dt)
      do istep=1,nstep
        hd=hd+dt/3600./24.
        hl(:,:) = pi*(1.-dayl(:,:))
        hc(:,:) = pi*(1.+dayl(:,:))
        h(:,:)=2.*pi*mod(hd+lon(:,:)/2./pi,1.)
        where ( h.ge.hl .and. h.lt.hc )
! Daytime
          hred=(h-hl)/(hc-hl)
          fact_OH  = fact_OH + amax1(0.,sin(pi*hred)/2.)/nstep
        endwhere
      enddo


      hd=amax1(0.,amin1(1.,(hour+minute/60.+second/3600.)/24.))
      hl(:,:) = pi*(1.-dayl(:,:))
      hc(:,:) = pi*(1.+dayl(:,:))
      h(:,:)=2.*pi*mod(hd+lon(:,:)/2./pi,1.)
      fac_OH(:,:)  = 0.
      where ( h.ge.hl .and. h.lt.hc )
! Daytime
          hred=(h-hl)/(hc-hl)
          fac_OH  = amax1(0.,sin(pi*hred)/2.)/fact_OH
      elsewhere
! Nightime
          fac_OH  = 0.
      endwhere

      do i=1,id
        do j=1,jd
          do k=1,kd 
            SOA_dt(i,j,k) = 1.55E-11 * exp( -540./temp(i,j,k) ) *yield &
                * C4H10_conc(i,j,k)*OH_conc(i,j,k)*fac_oh(i,j)
          enddo
        enddo
      enddo

      SOA_chem(:,:,:)=SOA_dt(:,:,:)*pwt(:,:,:)

      if (id_SOA_chem > 0) then
        used = send_data ( id_SOA_chem, &
              SOA_chem, Time_next,is_in=is,js_in=js,ks_in=1)
      endif

! column production of SOA 


      SOA_prod = 0.
      do k=1,kd
        SOA_prod = SOA_prod +  SOA_chem(:,:,k)
      end do

      if (id_SOA_chem_col > 0) then
        used = send_data ( id_SOA_chem_col, &
                           SOA_prod, Time_next,is_in=is,js_in=js)
      endif


end subroutine atmos_SOA_chem


end module atmos_SOA_mod

! $Id$

!!#include <fms_platform.h>

module drifters_io_mod
  implicit none  
  private

  public :: drifters_io_type, drifters_io_new, drifters_io_del, drifters_io_set_time_units
  public :: drifters_io_set_position_names, drifters_io_set_position_units, drifters_io_set_field_names
  public :: drifters_io_set_field_units, drifters_io_write

  ! Globals
  integer, parameter, private   :: MAX_STR_LEN = 128
  character(MAX_STR_LEN), parameter, private :: &
       & version = '$Id$'

  real :: drfts_eps_t = 10.*epsilon(1.)
  

  type drifters_io_type
     real                 :: time
     integer              :: it ! time index
     integer              :: it_id  ! infinite axis index
     integer              :: ncid
     integer              :: nc_positions, nc_fields, nc_ids, nc_time, nc_index_time    
     logical              :: enddef
  end type drifters_io_type

contains

!###############################################################################
  subroutine drifters_io_new(self, filename, nd, nf, ermesg)
    type(drifters_io_type)        :: self
    character(len=*), intent(in)  :: filename
    integer, intent(in)           :: nd  ! number of dims
    integer, intent(in)           :: nf  ! number of fields
    character(len=*), intent(out) :: ermesg

    integer ier, nc_it_id, nc_nd, nc_nf
    integer :: size1(1), size2(2)
    include 'netcdf.inc'

    ermesg=''
    self%enddef = .FALSE.

    ier = nf_create(filename, NF_CLOBBER, self%ncid)
    if(ier/=NF_NOERR) ermesg = 'drifters_io_new::nf_create ('//filename//') '//nf_strerror(ier)

    ! global attributes
    ier = nf_put_att_text(self%ncid, NF_GLOBAL, 'version', len_trim(version), trim(version))
    

    ! dimensions
    ier = nf_def_dim(self%ncid, 'it_id', NF_UNLIMITED, nc_it_id)
    if(ier/=NF_NOERR) ermesg = 'drifters_io_new::nf_def_dim (it_id) '//nf_strerror(ier)

    ier = nf_def_dim(self%ncid, 'nf', nf, nc_nf)
    if(ier/=NF_NOERR) ermesg = 'drifters_io_new::nf_def_dim (nf) '//nf_strerror(ier)

    ier = nf_def_dim(self%ncid, 'nd', nd, nc_nd)
    if(ier/=NF_NOERR) ermesg = 'drifters_io_new::nf_def_dim (nd) '//nf_strerror(ier)

    ! variables
    size1 = (/nc_it_id/)
    ier = nf_def_var(self%ncid, 'index_time', NF_INT, 1, size1, self%nc_index_time)
    if(ier/=NF_NOERR) ermesg = 'drifters_io_new::nf_def_var (index_time)'//nf_strerror(ier)

    ier = nf_def_var(self%ncid, 'time', NF_DOUBLE, 1, size1, self%nc_time)
    if(ier/=NF_NOERR) ermesg = 'drifters_io_new::nf_def_var (time)'//nf_strerror(ier)

    ier = nf_def_var(self%ncid, 'ids', NF_INT, 1, size1, self%nc_ids)
    if(ier/=NF_NOERR) ermesg = 'drifters_io_new::nf_def_var (ids)'//nf_strerror(ier)

    size2 = (/nc_nd, nc_it_id/)
    ier = nf_def_var(self%ncid, 'positions', NF_DOUBLE, 2, size2, self%nc_positions)
    if(ier/=NF_NOERR) ermesg = 'drifters_io_new::nf_def_var (positions)'//nf_strerror(ier)

    size2 = (/nc_nf, nc_it_id/)
    ier = nf_def_var(self%ncid, 'fields', NF_DOUBLE, 2, size2, self%nc_fields)
    if(ier/=NF_NOERR) ermesg = 'drifters_io_new::nf_def_var (fields)'//nf_strerror(ier)
    
    self%time  = -huge(1.)
    self%it    = -1
    self%it_id = 1

  end subroutine drifters_io_new

!###############################################################################
  subroutine drifters_io_del(self, ermesg)
    type(drifters_io_type)        :: self
    character(len=*), intent(out) :: ermesg

    integer ier
    include 'netcdf.inc'

    ermesg = ''
    
    ier = nf_close(self%ncid)
    if(ier/=NF_NOERR) ermesg = 'drifters_io_del::nf_close '//nf_strerror(ier)
    
  end subroutine drifters_io_del

!###############################################################################
  subroutine drifters_io_set_time_units(self, name, ermesg)
    type(drifters_io_type)        :: self
    character(len=*), intent(in)  :: name
    character(len=*), intent(out) :: ermesg

    integer ier
    include 'netcdf.inc'

    ermesg = ''
    ier = nf_put_att_text(self%ncid, NF_GLOBAL, &
         & 'time_units', len_trim(name), trim(name))
    if(ier/=NF_NOERR) &
         & ermesg = 'drifters_io_set_time_units::failed to add time_units attribute ' &
         & //nf_strerror(ier)

  end subroutine drifters_io_set_time_units

!###############################################################################
  subroutine drifters_io_set_position_names(self, names, ermesg)
    type(drifters_io_type)        :: self
    character(len=*), intent(in)  :: names(:)
    character(len=*), intent(out) :: ermesg

    integer n, ier, i
    character(len=128) :: attname
    include 'netcdf.inc'

    n = size(names)
    ermesg = ''

    do i = 1, n
       write(attname, '(i6)' ) i
       attname = 'name_'//adjustl(attname)
       ier = nf_put_att_text(self%ncid, self%nc_positions, &
            & trim(attname), len_trim(names(i)), trim(names(i)))
       if(ier/=NF_NOERR) &
            & ermesg = 'drifters_io_set_position_names::failed to add name attribute to positions '//nf_strerror(ier)
    enddo

  end subroutine drifters_io_set_position_names

!###############################################################################
  subroutine drifters_io_set_position_units(self, names, ermesg)
    type(drifters_io_type)        :: self
    character(len=*), intent(in)  :: names(:)
    character(len=*), intent(out) :: ermesg

    integer n, ier, i
    character(len=128) :: attname
    include 'netcdf.inc'

    n = size(names)
    ermesg = ''

    do i = 1, n
       write(attname, '(i6)' ) i
       attname = 'unit_'//adjustl(attname)
       ier = nf_put_att_text(self%ncid, self%nc_positions, &
            & trim(attname), len_trim(names(i)), trim(names(i)))
       if(ier/=NF_NOERR) &
            & ermesg = 'drifters_io_set_position_names::failed to add unit attribute to positions '//nf_strerror(ier)
    enddo
        
  end subroutine drifters_io_set_position_units

!###############################################################################
  subroutine drifters_io_set_field_names(self, names, ermesg)
    type(drifters_io_type)        :: self
    character(len=*), intent(in)  :: names(:)
    character(len=*), intent(out) :: ermesg

    integer n, ier, i
    character(len=128) :: attname
    include 'netcdf.inc'

    n = size(names)
    ermesg = ''

    do i = 1, n
       write(attname, '(i6)' ) i
       attname = 'name_'//adjustl(attname)
       ier = nf_put_att_text(self%ncid, self%nc_fields, &
            & trim(attname), len_trim(names(i)), trim(names(i)))
       if(ier/=NF_NOERR) &
            & ermesg = 'drifters_io_set_field_names::failed to add name attribute to fields '//nf_strerror(ier)
    enddo

  end subroutine drifters_io_set_field_names

!###############################################################################
  subroutine drifters_io_set_field_units(self, names, ermesg)
    type(drifters_io_type)        :: self
    character(len=*), intent(in)  :: names(:)
    character(len=*), intent(out) :: ermesg

    integer n, ier, i
    character(len=128) :: attname
    include 'netcdf.inc'

    n = size(names)
    ermesg = ''

    do i = 1, n
       write(attname, '(i6)' ) i
       attname = 'unit_'//adjustl(attname)
       ier = nf_put_att_text(self%ncid, self%nc_fields, &
            & trim(attname), len_trim(names(i)), trim(names(i)))
       if(ier/=NF_NOERR) &
            & ermesg = 'drifters_io_set_field_units::failed to add unit attribute to fields '//nf_strerror(ier)
    enddo
    
  end subroutine drifters_io_set_field_units
!###############################################################################

  subroutine drifters_io_write(self, time, np, nd, nf, ids, positions, fields, ermesg)
    type(drifters_io_type)        :: self
    real, intent(in)              :: time
    integer, intent(in)           :: np    ! number of dirfters
    integer, intent(in)           :: nd    ! number of dimensions
    integer, intent(in)           :: nf    ! number of fields
    integer, intent(in)           :: ids(np)          ! of size np
    real, intent(in)              :: positions(nd,np) ! nd times np
    real, intent(in)              :: fields(nf,np)    ! nf times np
    character(len=*), intent(out) :: ermesg

    integer ier, i
    integer :: start1(1), len1(1), start2(2), len2(2)
    integer :: it_indices(np)
    real    :: time_array(np)
    include 'netcdf.inc'

    ermesg = ''
    
    if(.not. self%enddef) then
       ier = nf_enddef(self%ncid)
       if(ier/=NF_NOERR) then 
            ermesg = 'drifters_io_write::nf_enddef failure. No data will be written. '//nf_strerror(ier)
            return
       endif
       self%enddef = .TRUE.
    endif

    if(abs(time - self%time) > drfts_eps_t) then
       self%it = self%it + 1
       self%time = time
    endif

    start1(1) = self%it_id
    len1(1)   = np

    it_indices = (/(self%it,i=1,np)/)
    ier = nf_put_vara_int( self%ncid, self%nc_index_time, start1, len1, it_indices )
    if(ier/=NF_NOERR) &
         & ermesg = 'drifters_io_write::failed to write index_time: ' //nf_strerror(ier)

    time_array = (/(time,i=1,np)/)
    ier = nf_put_vara_double( self%ncid, self%nc_time, start1, len1, time_array )
    if(ier/=NF_NOERR) &
         & ermesg = 'drifters_io_write::failed to write time: ' //nf_strerror(ier)

    ier = nf_put_vara_int(self%ncid, self%nc_ids, start1, len1, ids)
    if(ier/=NF_NOERR) &
         & ermesg = 'drifters_io_write::failed to write ids: '//nf_strerror(ier)

    start2(1) = 1
    start2(2) = self%it_id

    len2(1)   = nd
    len2(2)   = np

    ier = nf_put_vara_double(self%ncid, self%nc_positions, start2, len2, positions)
    if(ier/=NF_NOERR) &
         & ermesg = 'drifters_io_write::failed to write positions: '//nf_strerror(ier)

    len2(1)   = nf
    len2(2)   = np    
    
    ier = nf_put_vara_double(self%ncid, self%nc_fields, start2, len2, fields)
    if(ier/=NF_NOERR) &
         & ermesg = 'drifters_io_write::failed to write fields: '//nf_strerror(ier)

    self%it_id = self%it_id + np
    
  end subroutine drifters_io_write

end module drifters_io_mod
 !###############################################################################
 !###############################################################################
#ifdef _TEST_DRIFTERS_IO
! set FC=pgf95
! set FOPTS='-r8 -g -Mdclchk -Minform=warn'
! set INCS='-I/usr/local/include'
! set LIBS='-L/usr/local/lib -lnetcdf'
! $FC $INCS $FOPTS -D_TEST_DRIFTERS_IO drifters_io.F90 $LIBS
program test
  use drifters_io_mod
  implicit none
  type(drifters_io_type) :: drfts_io
  character(len=128) :: ermesg
  character(len=31) :: filename
  integer :: np, nd, nf, nt, i, j, k, npmax
  real :: dt, time, xmin, xmax, ymin, ymax, u, v, dr, x, y
  integer, allocatable :: ids(:)
  real, allocatable :: positions(:,:), fields(:,:)

  ! number of dimensions
  nd = 3
  ! number of fields 
  nf = 2
  ! max number of dirfters 
  npmax = 20
  ! number of time steps
  nt = 50
  ! starting time
  time = 0.

  ! domain boundary. (drifters outside domain will not be written to file.)
  xmin = 0.
  ymin = 0.
  xmax = 1.
  ymax = 1.

  ! constant velocity
  u = (xmax-xmin)*sqrt(2.)
  v = (ymax-ymin)*sqrt(2.)
  dt = 1/real(nt)

  ! open file
  
  filename = 'test.nc'
  call drifters_io_new(drfts_io, filename, nd, nf, ermesg)
  if(ermesg/='') print *,'ERROR after drifters_io_new: ', ermesg

  ! set attributes

  call drifters_io_set_position_names(drfts_io, (/'x','y','z'/), ermesg)
  if(ermesg/='') print *,'ERROR after drifters_io_position_names: ', ermesg

  ! note the trailing blanks in the first field, which are added here to 
  ! ensure that "salinity" will not be truncated (all names must have the 
  ! same length)
  call drifters_io_set_field_names(drfts_io, (/'temp    ','salinity'/), ermesg)
  if(ermesg/='') print *,'ERROR after drifters_io_field_names: ', ermesg

  call drifters_io_set_position_units(drfts_io, (/'deg east ','deg north','meters'/), ermesg)
  if(ermesg/='') print *,'ERROR after drifters_io_position_units: ', ermesg
  
  call drifters_io_set_field_units(drfts_io, (/'deg K ','ppm'/), ermesg)
  if(ermesg/='') print *,'ERROR after drifters_io_field_units: ', ermesg

  allocate(positions(nd, npmax), ids(npmax), fields(nf, npmax))
  dr = sqrt( (xmax-xmin)**2 + (ymax-ymin)**2 )/real(npmax)


  ! x
  positions(1, :) = +(/ (i*dr,i=0,npmax-1) /)/sqrt(2.)
  ! y
  positions(2, :) = -(/ (i*dr,i=0,npmax-1) /)/sqrt(2.)
  ! z
  positions(3, :) = 0.

  ! drifters' identity array (can be any integer number)
  ids = (/ (i, i=1, npmax) /)
  
  ! set fields as a function of space time
  fields(1, :) = sqrt( (positions(1,:)-xmin)**2 + (positions(2,:)-ymin)**2 )
  fields(2, :) = positions(1,:)-u*time + positions(2,:)-v*time ! invariant

  ! write to disk only drifters inside domain
  do i = 1, npmax
     x = positions(1,i)
     y = positions(2,i)
     if(x>=xmin .and. x<=xmax .and. y>=ymin .and. y<=ymax) then
        call drifters_io_write(drfts_io, time, np=1, nd=nd, nf=nf, &
             & ids=ids(i), positions=positions(:,i), fields=fields(:,i), ermesg=ermesg)
        if(ermesg/='') print *,'ERROR after drifters_io_write: ', ermesg
     endif
  enddo

  ! advect
  
  do j = 1, nt
     time = time + dt
     positions(1, :) = positions(1, :) + u*dt
     positions(2, :) = positions(2, :) + v*dt
     fields(1, :) = sqrt( (positions(1,:)-xmin)**2 + (positions(2,:)-ymin)**2 )
     fields(2, :) = positions(1,:)-u*time + positions(2,:)-v*time ! invariant

     do i = 1, npmax
        x = positions(1,i)
        y = positions(2,i)
        if(x>=xmin .and. x<=xmax .and. y>=ymin .and. y<=ymax) then
           call drifters_io_write(drfts_io, time, np=1, nd=nd, nf=nf, &
                & ids=ids(i), positions=positions(:,i), fields=fields(:,i), ermesg=ermesg)
           if(ermesg/='') print *,'ERROR after drifters_io_write: ', ermesg
        endif
     enddo
     
  enddo

  deallocate(positions, ids, fields)

  call drifters_io_del(drfts_io, ermesg)
  if(ermesg/='') print *,'ERROR after drifters_io_del: ', ermesg

end program test
#endif 
! _TEST_DRIFTERS_IO

#include <fms_platform.h>
#include "fms_switches.h"

! $Id$

module drifters_comm_mod

#ifdef _SERIAL

#define _TYPE_DOMAIN2D integer
#define _NULL_PE 0

#else

  use mpp_mod,         only        : NULL_PE, FATAL, NOTE, mpp_error, mpp_pe, mpp_npes
  use mpp_mod,         only        : mpp_root_pe
  use mpp_mod,         only        : mpp_send, mpp_recv, mpp_sync_self
  use mpp_mod,         only        : COMM_TAG_1, COMM_TAG_2, COMM_TAG_3, COMM_TAG_4
  use mpp_domains_mod, only        : domain2D
  use mpp_domains_mod, only        : mpp_get_neighbor_pe, mpp_define_domains, mpp_get_layout
  use mpp_domains_mod, only        : mpp_get_compute_domain, mpp_get_data_domain
  use mpp_domains_mod, only        : NORTH, SOUTH, EAST, WEST, CYCLIC_GLOBAL_DOMAIN
  use mpp_domains_mod, only        : NORTH_EAST, SOUTH_EAST, SOUTH_WEST, NORTH_WEST

#define _TYPE_DOMAIN2D type(domain2d)
#define _NULL_PE NULL_PE

#endif

  use drifters_core_mod, only: drifters_core_type, drifters_core_remove_and_add,  drifters_core_set_positions

  implicit none
  private

  public :: drifters_comm_type, drifters_comm_new, drifters_comm_del, drifters_comm_set_pe_neighbors
  public :: drifters_comm_set_domain, drifters_comm_update, drifters_comm_gather

  type drifters_comm_type
     ! compute domain
     real           :: xcmin, xcmax
     real           :: ycmin, ycmax
     ! data domain
     real           :: xdmin, xdmax
     real           :: ydmin, ydmax
     ! global valid min/max
     real           :: xgmin, xgmax
     real           :: ygmin, ygmax
     ! x/y period (can be be nearly infinite)
     logical        :: xperiodic, yperiodic
     ! neighbor domains
     integer        :: pe_N, pe_S, pe_E, pe_W, pe_NE, pe_SE, pe_SW, pe_NW
     ! starting/ending pe, set this to a value /= 0 if running concurrently
     integer        :: pe_beg, pe_end
  end type drifters_comm_type

contains

!===============================================================================
  subroutine drifters_comm_new(self)
    type(drifters_comm_type)   :: self
    
    self%xcmin = -huge(1.); self%xcmax = +huge(1.)
    self%ycmin = -huge(1.); self%ycmax = +huge(1.)

    self%xdmin = -huge(1.); self%xdmax = +huge(1.)
    self%ydmin = -huge(1.); self%ydmax = +huge(1.)

    self%xgmin = -huge(1.); self%xgmax = +huge(1.)
    self%ygmin = -huge(1.); self%ygmax = +huge(1.)

    self%xperiodic = .FALSE.; self%yperiodic = .FALSE.

    self%pe_N  = _NULL_PE
    self%pe_S  = _NULL_PE
    self%pe_E  = _NULL_PE
    self%pe_W  = _NULL_PE
    self%pe_NE = _NULL_PE
    self%pe_SE = _NULL_PE
    self%pe_SW = _NULL_PE
    self%pe_NW = _NULL_PE

    self%pe_beg =  0
    self%pe_end = -1
    
    
  end subroutine drifters_comm_new

!===============================================================================
  subroutine drifters_comm_del(self)
    type(drifters_comm_type)   :: self
    
    ! nothing to deallocate
    call drifters_comm_new(self)

  end subroutine drifters_comm_del

!===============================================================================
  subroutine drifters_comm_set_data_bounds(self, xmin, ymin, xmax, ymax)
    ! Set data domain bounds.
    type(drifters_comm_type)   :: self
    real, intent(in)           :: xmin, ymin, xmax, ymax
    
    self%xdmin = max(xmin, self%xdmin)
    self%xdmax = min(xmax, self%xdmax)
    self%ydmin = max(ymin, self%ydmin)
    self%ydmax = min(ymax, self%ydmax)

  end subroutine drifters_comm_set_data_bounds

!===============================================================================
  subroutine drifters_comm_set_comp_bounds(self, xmin, ymin, xmax, ymax)
    ! Set compute domain bounds.
    type(drifters_comm_type)   :: self
    real, intent(in)           :: xmin, ymin, xmax, ymax
    
    self%xcmin = max(xmin, self%xcmin)
    self%xcmax = min(xmax, self%xcmax)
    self%ycmin = max(ymin, self%ycmin)
    self%ycmax = min(ymax, self%ycmax)

  end subroutine drifters_comm_set_comp_bounds

!===============================================================================
  subroutine drifters_comm_set_pe_neighbors(self, domain)
    ! Set neighboring pe numbers.
    type(drifters_comm_type)   :: self
    _TYPE_DOMAIN2D, intent(inout) :: domain

#ifndef _SERIAL
! parallel code

    integer        :: pe_N, pe_S, pe_E, pe_W, pe_NE, pe_SE, pe_SW, pe_NW

    call mpp_get_neighbor_pe(domain, NORTH     , pe_N )
    call mpp_get_neighbor_pe(domain, NORTH_EAST, pe_NE)
    call mpp_get_neighbor_pe(domain, EAST      , pe_E )
    call mpp_get_neighbor_pe(domain, SOUTH_EAST, pe_SE)
    call mpp_get_neighbor_pe(domain, SOUTH     , pe_S )
    call mpp_get_neighbor_pe(domain, SOUTH_WEST, pe_SW)
    call mpp_get_neighbor_pe(domain, WEST      , pe_W )
    call mpp_get_neighbor_pe(domain, NORTH_WEST, pe_NW)

    if(pe_N  /= self%pe_N  .and. self%pe_N  == _NULL_PE) then
       self%pe_N  = pe_N 
    else if(pe_N  /= self%pe_N ) then
       call mpp_error( FATAL, 'drifters_comm_set_pe_neighbors: NORTH PE changed!.')
    endif 
    if(pe_NE /= self%pe_NE .and. self%pe_NE == _NULL_PE) then
       self%pe_NE = pe_NE
    else if(pe_NE /= self%pe_NE) then
       call mpp_error( FATAL, 'drifters_comm_set_pe_neighbors: NORTH-EAST PE changed!.')
    endif 
    if(pe_E  /= self%pe_E  .and. self%pe_E  == _NULL_PE) then
       self%pe_E  = pe_E 
    else if(pe_E  /= self%pe_E ) then
       call mpp_error( FATAL, 'drifters_comm_set_pe_neighbors: EAST PE changed!.')
    endif 
    if(pe_SE /= self%pe_SE .and. self%pe_SE == _NULL_PE) then
       self%pe_SE = pe_SE
    else if(pe_SE /= self%pe_SE) then
       call mpp_error( FATAL, 'drifters_comm_set_pe_neighbors: SOUTH-EAST PE changed!.')
    endif 
    if(pe_S  /= self%pe_S  .and. self%pe_S  == _NULL_PE) then
       self%pe_S  = pe_S 
    else if(pe_S  /= self%pe_S ) then
       call mpp_error( FATAL, 'drifters_comm_set_pe_neighbors: SOUTH PE changed!.')
    endif 
    if(pe_SW /= self%pe_SW .and. self%pe_SW == _NULL_PE) then
       self%pe_SW = pe_SW
    else if(pe_SW /= self%pe_SW) then
       call mpp_error( FATAL, 'drifters_comm_set_pe_neighbors: SOUTH-WEST PE changed!.')
    endif 
    if(pe_W  /= self%pe_W  .and. self%pe_W  == _NULL_PE) then
       self%pe_W  = pe_W 
    else if(pe_W  /= self%pe_W ) then
       call mpp_error( FATAL, 'drifters_comm_set_pe_neighbors: WEST PE changed!.')
    endif 
    if(pe_NW /= self%pe_NW .and. self%pe_NW == _NULL_PE) then
       self%pe_NW = pe_NW
    else if(pe_NW /= self%pe_NW) then
       call mpp_error( FATAL, 'drifters_comm_set_pe_neighbors: NORTH-WEST PE changed!.')
    endif 

#endif
! end of parallel code

  end subroutine drifters_comm_set_pe_neighbors

!===============================================================================
  subroutine drifters_comm_set_domain(self, domain, x, y, backoff_x, backoff_y)
    ! Set boundaries of domain and compute neighbors. This method can be called
    ! multiple times; the data domain will just be the intersection (overlap) of
    ! all domains (e.g domain_u, domain_v, etc). 
    type(drifters_comm_type)   :: self
    _TYPE_DOMAIN2D, intent(inout) :: domain
    real, intent(in)           :: x(:), y(:)           ! global axes
    integer, intent(in)        :: backoff_x, backoff_y ! >=0, data domain is reduced by "backoff_x,y" indices in x, resp. y
    
    ! compute/data domain start/end indices
    integer isc, iec, jsc, jec
    integer isd, ied, jsd, jed
    integer nx, ny, hx, hy, bckf_x, bckf_y, halox, haloy
    real dx, dy, xdmin, xdmax, ydmin, ydmax

#ifdef _SERIAL
    integer :: ibnds(1)

    ibnds = lbound(x); isc = ibnds(1)
    ibnds = ubound(x); iec = ibnds(1) - 1
    ibnds = lbound(y); jsc = ibnds(1)
    ibnds = ubound(y); jec = ibnds(1) - 1
#else
    call mpp_get_compute_domain( domain, isc, iec, jsc, jec )
#endif

    self%xcmin = max(x(isc), self%xcmin)
    self%xcmax = min(x(iec), self%xcmax)
    self%ycmin = max(y(jsc), self%ycmin)
    self%ycmax = min(y(jec), self%ycmax)

    nx = iec - isc + 1
    ny = jec - jsc + 1

#ifdef _SERIAL
    isd = 1; ied = size(x); jsd = 1; jed = size(y)
#else
    call mpp_get_data_domain   ( domain, isd, ied, jsd, jed )
#endif

    hx = max(ied-iec, isc-isd)
    hy = max(jed-jec, jsc-jsd)
    bckf_x = min(backoff_x, hx)
    bckf_y = min(backoff_y, hy)

    halox = max(0, hx - bckf_x)
    haloy = max(0, hy - bckf_y)

    if(isd < 1) then
       dx = x(2) - x(1)
       xdmin = self%xcmin - dx*halox
    else
       xdmin = x(isd+bckf_x)
    endif

    if(ied > nx) then
       dx = x(nx) - x(nx-1)
       xdmax = self%xcmax + dx*halox
    else
       xdmax = x(ied-bckf_x)
    endif

    if(jsd < 1) then
       dy = y(2) - y(1)
       ydmin = self%ycmin - dy*haloy
    else
       ydmin = y(jsd+bckf_y)
    endif

    if(jed > ny) then
       dy = y(ny) - y(ny-1)
       ydmax = self%ycmax + dy*haloy
    else
       ydmax = y(jed-bckf_y)
    endif
    
    self%xdmin = max(xdmin, self%xdmin)
    self%ydmin = max(ydmin, self%ydmin)
    self%xdmax = min(xdmax, self%xdmax)
    self%ydmax = min(ydmax, self%ydmax)

    call drifters_comm_set_pe_neighbors(self, domain)

  end subroutine drifters_comm_set_domain

!===============================================================================
  subroutine drifters_comm_update(self, drfts, new_positions, &
       & comm, remove, max_add_remove)

    type(drifters_comm_type)   :: self
    type(drifters_core_type)   :: drfts
    real, intent(inout)           :: new_positions(:,:)
    integer, intent(in), optional :: comm ! MPI communicator
    logical, intent(in), optional :: remove(:) ! Set to True for particles that should be removed
    integer, intent(in), optional :: max_add_remove ! max no of particles to add/remove

#ifdef _SERIAL
! serial code
    
    drfts%positions(:, 1:drfts%np) = new_positions(:, 1:drfts%np)
    return

#else
! parallel code

    include 'mpif.h'


    integer nd, np, nar_est, ip, neigh_pe, irem, pe, npes, ntuples
    integer ntuples_tot, ndata, mycomm
#ifdef _USE_MPI
    integer ier 
#endif
    integer, allocatable :: iadd(:)
    integer, allocatable :: table_recv(:), table_send(:)
    real   , allocatable :: data_recv(:,:), data_send(:,:)
    integer, allocatable :: indices_to_remove(:)
    integer, allocatable :: ids_to_add(:)
    real   , allocatable :: positions_to_add(:,:)
    real                 :: x, y, xold, yold
    character(len=128) :: ermsg, notemsg
    logical            :: is_present
    integer            :: id, j, k, m, n, el
    logical            :: crossed_W, crossed_E, crossed_S, crossed_N
    logical            :: was_in_compute_domain, left_domain

    mycomm = MPI_COMM_WORLD
    if( present(comm) ) mycomm = comm

    nd = drfts%nd
    np = size(new_positions,2)
    if(np > 0 .and. nd < 2) call mpp_error( FATAL, &
         & 'drifters_comm_update: number of dimensions must be 2 or higher.' )

    nar_est = 100 
    if(present(max_add_remove)) nar_est = max(1, max_add_remove)

    pe   = mpp_pe()
    npes = mpp_npes()

    ! assume pe list is contiguous, self%pe_beg...self%pe_end
    allocate(iadd(self%pe_beg:self%pe_end))
    allocate(table_recv(self%pe_beg:self%pe_end))
    allocate(table_send(self%pe_beg:self%pe_end))
    allocate(data_recv(nar_est*(1+nd), self%pe_beg:self%pe_end))
    allocate(data_send(nar_est*(1+nd), self%pe_beg:self%pe_end))
    allocate(indices_to_remove(nar_est))

    table_send = 0
    table_recv = 0
    data_send  = 0
    data_recv  = 0

    iadd = 0
    irem = 0
    do ip = 1, np
       x = new_positions(1, ip)
       y = new_positions(2, ip)
       xold = drfts%positions(1, ip)
       yold = drfts%positions(2, ip)

       if(    xold<self%xcmin .or. xold>self%xcmax .or. &
            & yold<self%ycmin .or. yold>self%ycmax      ) then
          was_in_compute_domain = .FALSE.
       else
          was_in_compute_domain = .TRUE.
       endif

       ! check if drifters crossed compute domain boundary 
       
       crossed_W = .FALSE.
       crossed_E = .FALSE.
       crossed_S = .FALSE.
       crossed_N = .FALSE.
       if( was_in_compute_domain .and. &
            & (x<self%xcmin) .and. (xold>self%xcmin) ) crossed_W = .TRUE.
       if( was_in_compute_domain .and. &
            & (x>self%xcmax) .and. (xold<self%xcmax) ) crossed_E = .TRUE.
       if( was_in_compute_domain .and. &
            & (y<self%ycmin) .and. (yold>self%ycmin) ) crossed_S = .TRUE.
       if( was_in_compute_domain .and. &
            & (y>self%ycmax) .and. (yold<self%ycmax) ) crossed_N = .TRUE.

       neigh_pe = _NULL_PE
       if(crossed_N .and. .not. crossed_E .and. .not. crossed_W) neigh_pe = self%pe_N
       if(crossed_N .and.       crossed_E                      ) neigh_pe = self%pe_NE
       if(crossed_E .and. .not. crossed_N .and. .not. crossed_S) neigh_pe = self%pe_E
       if(crossed_S .and.       crossed_E                      ) neigh_pe = self%pe_SE
       if(crossed_S .and. .not. crossed_E .and. .not. crossed_W) neigh_pe = self%pe_S
       if(crossed_S .and.       crossed_W                      ) neigh_pe = self%pe_SW
       if(crossed_W .and. .not. crossed_S .and. .not. crossed_N) neigh_pe = self%pe_W
       if(crossed_N .and.       crossed_W                      ) neigh_pe = self%pe_NW

       if(neigh_pe /= _NULL_PE) then
          iadd(neigh_pe) = iadd(neigh_pe) + 1
          if(iadd(neigh_pe) > nar_est) then
             write(notemsg, '(a,i4,a,i4,a)') 'drifters_comm_update: exceeded nar_est (', &
                  & iadd(neigh_pe),'>',nar_est,').'
             call mpp_error( FATAL, notemsg)
          endif
          table_send(neigh_pe)  = table_send(neigh_pe) + 1
          k = ( iadd(neigh_pe)-1 )*(1+nd) + 1
          data_send(k       , neigh_pe) = drfts%ids(ip)
          data_send(k+1:k+nd, neigh_pe) = new_positions(:,ip)
       endif

       ! check if drifters left data domain

       left_domain = .FALSE.
       if(       (x<self%xdmin .and. (self%pe_W/=pe)) .or. &
            &    (x>self%xdmax .and. (self%pe_E/=pe)) .or. &
            &    (y<self%ydmin .and. (self%pe_S/=pe)) .or. &
            &    (y>self%ydmax .and. (self%pe_N/=pe)) ) then
          left_domain = .TRUE.
       endif

       ! remove if particle was tagged as such

       if(present(remove)) then
          if(remove(ip)) left_domain = .TRUE.
       endif

       if(left_domain) then
          irem = irem + 1
          if(irem > nar_est) then
             write(notemsg, '(a,i4,a,i4,a)') 'drifters_comm_update: exceeded nar_est (',&
                  & irem,'>',nar_est,').'
             call mpp_error( FATAL, notemsg)
          endif
          indices_to_remove(irem) = ip
       endif

    enddo


    ! update drifters' positions (remove whatever needs to be removed later)
    call drifters_core_set_positions(drfts, new_positions, ermsg)
    if(ermsg/='') call mpp_error( FATAL, ermsg)

    ! fill in table_recv from table_send. table_send contains the
    ! number of tuples that will be sent to another pe. table_recv
    ! will contain the number of tuples to be received. The indices 
    ! of table_send refer to the pe where the tuples should be sent to;
    ! the indices of table_recv refer to the pe number 
    ! (self%pe_beg..self%pe_end) from
    ! which the tuple should be received from.
    !
    ! table_send(to_pe) = ntuples; table_recv(from_pe) = ntuples

    ! the following is a transpose operation
    ! table_send(m)[pe] -> table_recv(pe)[m]
    do m = self%pe_beg, self%pe_end
#ifdef _USE_MPI
       call MPI_Scatter (table_send   , 1, MPI_INTEGER,  &
            &            table_recv(m), 1, MPI_INTEGER,  &
            &            m, mycomm, ier )
#else
       if(pe==m) then
          do k = self%pe_beg, self%pe_end
             call mpp_send(table_send(k), plen=1, to_pe=k, tag=COMM_TAG_1)
          enddo
       endif
       call mpp_recv(table_recv(m), glen=1, from_pe=m, tag=COMM_TAG_1)    
#endif
    enddo

    ! communicate new positions. data_send is an array of size n*(nd+1) times npes.
    ! Each column j of data_send contains the tuple (id, x, y, ..) to be sent to pe=j.
    ! Inversely, data_recv's column j contains tuples (id, x, y,..) received from pe=j.
    do m = self%pe_beg, self%pe_end
       ntuples = table_send(m)
       ndata   = ntuples*(nd+1)
       ! should be able to send ndata?
#ifdef _USE_MPI
       call MPI_Scatter (data_send     , nar_est*(1+nd), MPI_REAL8, &
            &            data_recv(1,m), nar_est*(1+nd), MPI_REAL8, &
            &            m, mycomm, ier )
#else
       if(pe==m) then
          do k = self%pe_beg, self%pe_end
             call mpp_send(data_send(1,k), plen=nar_est*(1+nd), to_pe=k, tag=COMM_TAG_2)
          enddo
       endif
       call mpp_recv(data_recv(1,m), glen=nar_est*(1+nd), from_pe=m, tag=COMM_TAG_2)           
#endif
    enddo

    ! total number of tuples will determine size of ids_to_add/positions_to_add
    ntuples_tot = 0
    do m = self%pe_beg, self%pe_end
       ntuples_tot = ntuples_tot + table_recv(m)
    enddo

    allocate(positions_to_add(nd, ntuples_tot))
    allocate(      ids_to_add(    ntuples_tot))

    ! fill positions_to_add and ids_to_add.
    k = 0
    do m = self%pe_beg, self%pe_end
       ! get ids/positions coming from all pes
       do n = 1, table_recv(m)
          ! iterate over all ids/positions coming from pe=m
          el = (n-1)*(nd+1) + 1
          id = int(data_recv(el, m))
          ! only add if id not already present in drfts
          ! this can happen if a drifter meanders about 
          ! the compute domain boundary
          is_present = .false.
          do j = 1, drfts%np
             if(id == drfts%ids(j)) then
                is_present = .true.
                write(notemsg, '(a,i4,a)') 'Drifter ', id, ' already advected (will not be added).'
                call mpp_error(NOTE, notemsg)
                exit
             endif
          enddo
          if(.not. is_present) then
             k = k + 1
             ids_to_add(k)         = id

             positions_to_add(1:nd, k) = data_recv(el+1:el+nd, m)

          endif
       enddo
    enddo
    
    ! remove and add
    if(irem > 0 .or. k > 0) then
       write(notemsg, '(i4,a,i4,a)') irem, ' drifter(s) will be removed, ', k,' will be added'
       call mpp_error(NOTE, notemsg)
!!$       if(k>0) print *,'positions to add ', positions_to_add(:,1:k)
!!$       if(irem>0) print *,'ids to remove: ', indices_to_remove(1:irem)
    endif
    call drifters_core_remove_and_add(drfts, indices_to_remove(1:irem), &
         & ids_to_add(1:k), positions_to_add(:,1:k), ermsg)
    if(ermsg/='') call mpp_error( FATAL, ermsg)

#ifndef _USE_MPI
    ! make sure unbuffered mpp_isend call returned before deallocating
    call mpp_sync_self()
#endif

    deallocate(ids_to_add)
    deallocate(positions_to_add)

    deallocate(iadd)
    deallocate(table_recv)
    deallocate(table_send)
    deallocate(data_recv)
    deallocate(data_send)
    deallocate(indices_to_remove)

#endif
! end of parallel code

  end subroutine drifters_comm_update

!===============================================================================
  subroutine drifters_comm_gather(self, drfts, dinp, &
       & lons, lats, do_save_lonlat, &
       & filename, &
       & root, mycomm)

    use drifters_input_mod, only : drifters_input_type, drifters_input_save

    type(drifters_comm_type)   :: self
    type(drifters_core_type)   :: drfts
    type(drifters_input_type)  :: dinp
    real, intent(in)           :: lons(:), lats(:)
    logical, intent(in)        :: do_save_lonlat
    character(len=*), intent(in)  :: filename
    integer, intent(in), optional :: root    ! root pe
    integer, intent(in), optional :: mycomm  ! MPI communicator

    character(len=128) :: ermesg

#ifdef _SERIAL
! serial code

       dinp%ids(1:drfts%np)          = drfts%ids(1:drfts%np)
       dinp%positions(:, 1:drfts%np) = drfts%positions(:, 1:drfts%np)

       if(do_save_lonlat) then

          call drifters_input_save(dinp, filename=filename, &
               & geolon=lons, geolat=lats, ermesg=ermesg)

       else

          call drifters_input_save(dinp, filename=filename, ermesg=ermesg)

       endif

#else
! parallel code


    integer :: npf, ip, comm, root_pe, pe, npes, nd, np, npdim, npmax, ier, nptot
    integer :: i, j, k, kk
    integer, allocatable ::  nps(:)
    real    :: x, y
    real, allocatable :: lons0(:), lats0(:), recvbuf(:,:)
    real    :: data(drfts%nd+3, drfts%np)
    include 'mpif.h'

    comm    = MPI_COMM_WORLD
    if(present(mycomm)) comm = mycomm

    root_pe = mpp_root_pe()
    if(present(root)) root_pe = root

    pe   = mpp_pe()
    npes = mpp_npes()

    nd = drfts%nd
    np = drfts%np
    npdim = drfts%npdim
    
    allocate(nps(self%pe_beg:self%pe_end))
    nps = 0
    
    ! npf= number of drifters in compute domain

    npf = 0
    do ip = 1, np
       x = drfts%positions(1, ip)
       y = drfts%positions(2, ip)
       if( x <= self%xcmax .and. x >= self%xcmin .and. &
        &  y <= self%ycmax .and. y >= self%ycmin) then
          npf = npf + 1
          data(1       , npf)   = real(drfts%ids(ip))
          data(1+1:1+nd, npf)   =      drfts%positions(:, ip)
          data(    2+nd, npf)   = lons(ip)
          data(    3+nd, npf)   = lats(ip)
       endif
    enddo

    ! gather number of drifters
#ifdef _USE_MPI
    call mpi_gather(npf, 1, MPI_INT, &
         &          nps, 1, MPI_INT, &
         &          root_pe, comm, ier)
    !!if(ier/=0) ermesg = 'drifters_write_restart: ERROR while gathering "npf"'
#else
    call mpp_send(npf, plen=1, to_pe=root_pe, tag=COMM_TAG_3)
    if(pe==root_pe) then
       do i = self%pe_beg, self%pe_end
          call mpp_recv(nps(i), glen=1, from_pe=i, tag=COMM_TAG_3)
       enddo
    endif
#endif
    
    ! Now we know the max number of drifters to expect from each PE, so allocate 
    ! recvbuf (first dim will be zero on all PEs except root).

    ! allocate recvbuf to receive all the data on root PE, strided by npmax*(nd+3)
    npmax = maxval(nps)
    allocate(recvbuf(npmax*(nd+3), self%pe_beg:self%pe_end))
    recvbuf = -1

    ! Each PE sends data to recvbuf on root_pe.
#ifdef _USE_MPI
    call mpi_gather(         data  ,     npf*(nd+3), MPI_REAL8, &
         &                  recvbuf,   npmax*(nd+3), MPI_REAL8, &
         &          root_pe, comm, ier)
    !!if(ier/=0) ermesg = 'drifters_write_restart: ERROR while gathering "data"'
#else
    if(npf > 0) call mpp_send(data(1,1), plen=npf*(nd+3), to_pe=root_pe, tag=COMM_TAG_4)
    if(pe==root_pe) then
       do i = self%pe_beg, self%pe_end
          if(nps(i) > 0) call mpp_recv(recvbuf(1, i), glen=nps(i)*(nd+3), from_pe=i, tag=COMM_TAG_4)
       enddo
    endif
#endif
    
    ! Set positions and ids
    if(pe == root_pe) then
       ! check dims 
       nptot = sum(nps) ! total number of drifters, across al PEs
       if(nptot /= size(dinp%ids)) then
          deallocate(dinp%ids      , stat=ier)
          deallocate(dinp%positions, stat=ier)
          allocate(dinp%ids(nptot))
          allocate(dinp%positions(nd, nptot))
          dinp%ids       = -1
          dinp%positions = -huge(1.)
       endif

       allocate(lons0(nptot), lats0(nptot))

       ! Set the new positions/ids in dinp, on PE=root. Also set 
       ! lons/lats, these arrays will hold garbage if x1, y1, etc. were 
       ! not passed as subroutine arguments, that's ok 'cause we won't
       ! save them.
       j = 1
       do i = self%pe_beg, self%pe_end
          do k = 1, nps(i)
             kk = (nd+3)*(k-1)
             dinp%ids(j)             = int(recvbuf(kk+1          , i))
             dinp%positions(1:nd, j) =     recvbuf(kk+1+1:kk+1+nd, i)
             lons0(j)                =     recvbuf(kk+2+nd, i)
             lats0(j)                =     recvbuf(kk+3+nd, i)
             j = j + 1
          enddo
       enddo

       if(do_save_lonlat) then

          call drifters_input_save(dinp, filename=filename, &
               & geolon=lons0, geolat=lats0, ermesg=ermesg)

       else

          call drifters_input_save(dinp, filename=filename, ermesg=ermesg)

       endif

       deallocate(lons0, lats0)

    endif

#ifndef _USE_MPI
    call mpp_sync_self()
#endif
    deallocate(nps    , stat=ier)
    deallocate(recvbuf, stat=ier)

#endif
! _end of parallel code

  end subroutine drifters_comm_gather


end module drifters_comm_mod

!===============================================================================
!===============================================================================
#ifdef _TEST_DRIFTERS_COMM
! set FMS=/home/ap/ia64/mpp/mpp_test/exec/
! set OPTS="-r8 -g"
! set OBJS="$FMS/mpp*.o $FMS/threadloc.o"
! set INCS="-I/usr/include -I/usr/local/include -I${FMS}"
! set LIBS="-L/usr/local/lib -lnetcdf -L/usr/lib -lmpi -lcprts"
! ifort $OPTS $INCS -D_TEST_DRIFTERS_COMM drifters_comm.F90 quicksort.F90 drifters_core.F90 $OBJS $LIBS
program main

  use drifters_core_mod
  use drifters_comm_mod
  use mpp_mod
  use mpp_domains_mod

  implicit none

  integer, parameter :: nd=2, npmax = 4
  integer :: nx, ny, halox, haloy, layout(2), i, j, npes, pe, it, nt
  _TYPE_DOMAIN2D      :: domain
  type(drifters_core_type)      :: drfts
  type(drifters_comm_type) :: drfts_com
  real, parameter                     :: xmin=0., xmax=1., ymin=0., ymax=1.
  real                                :: dx, dy, u0, v0, dt, Lx, Ly
  real, allocatable                   :: x(:), y(:)
  character(len=128)  :: ermsg = ''
  integer :: ids(npmax)
  real    :: positions(nd, npmax), velocity(nd, npmax)
  integer :: io_status
!!$  integer :: stackmax=4000000

  namelist /drifters_comm_nml/ nx, ny, halox, haloy, u0, v0, dt, nt 
  

  call mpp_init !(MPP_DEBUG)
  !call mpp_set_stack_size(3145746)

  ! default input values
  nx = 11
  ny = 21
  halox = 2
  haloy = 2
  u0    = 1.0
  v0    = 0.0
  dt    = 0.1
  nt    = 10

  ! read input
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, drifters_comm_nml, iostat=io_status)
#else
  open(unit=1, file='input.nml', form='formatted')
  read(1, drifters_comm_nml)
  close(unit=1)
  if(mpp_pe()==0) write(*,drifters_comm_nml)
#endif

  ! create global domain
  Lx = xmax - xmin
  Ly = ymax - ymin
  dx = Lx/real(nx-1)
  dy = Ly/real(ny-1)
  allocate(x(nx), y(ny))
  x = xmin + (/ ( i*dx, i=0, nx-1) /)
  y = ymin + (/ ( j*dy, j=0, ny-1) /)

  ! decompose domain
  call mpp_domains_init ! (MPP_DEBUG)
!!$  call mpp_domains_set_stack_size(stackmax)

  npes = mpp_npes()
  call mpp_define_layout( (/1,nx, 1,ny/), npes, layout )
  if(mpp_pe()==0) print *,'LAYOUT: ', layout
  call mpp_define_domains((/1,nx, 1,ny/), layout, domain, xhalo=halox, yhalo=haloy,&
       & xflags=CYCLIC_GLOBAL_DOMAIN, yflags=CYCLIC_GLOBAL_DOMAIN)

  ! set up drifters' communicator
  call drifters_comm_new(drfts_com)
  call drifters_comm_set_domain(drfts_com, domain, x, y, 0,0)
  ! repeated calls just for the fun of it
  call drifters_comm_set_domain(drfts_com, domain, x, y, 0,0)
  call drifters_comm_set_domain(drfts_com, domain, x, y, 0,0)
  
  ! create drifters
  call drifters_core_new(drfts, nd, npmax, ermsg)
  if(ermsg /= '') print *,ermsg

  pe = mpp_pe()
  ids = (/ (i+100*pe, i=1,npmax) /)
  call drifters_core_set_ids(drfts, ids, ermsg)
  if(ermsg /= '') print *,ermsg

  ! position particles
  if(pe == 0) then
     positions(:, 1) = (/ (drfts_com%xcmin + drfts_com%xcmax)/2., &
          &               (drfts_com%ycmin + drfts_com%ycmax)/2. /)
     !positions(:, 2) = (/0.,0.01/)
     call drifters_core_set_positions(drfts, positions(:, 1:1), ermsg)
     if(ermsg /= '') print *,ermsg
  endif

  ! push drifters
  velocity(:,1) = (/u0, v0/)
  do it = 1, nt
     positions(:,1:drfts%np) = xmin + &
          & modulo(drfts%positions(:,1:drfts%np) + dt*velocity(:,1:drfts%np)-xmin, xmax-xmin)
     ! this will redistribute the drifters and update the positions
     call drifters_comm_update(drfts_com, drfts, positions(:,1:drfts%np))
     
     if(drfts%np > 0) then 
        do i=1,drfts%np
           print '(a,i6,a,i3,a,i3,a, i3, a,2f10.6)', 'PE: ',pe, ' it=', it, ' np=', drfts%np, ' ip=', i, &
                & ' x,y=', drfts%positions(1,i), drfts%positions(2,i)
        enddo
     endif
!!$     call drifters_print(drfts, ermsg)
!!$     if(ermsg /= '') print *,ermsg
  enddo

  ! clean up
  call drifters_core_del(drfts, ermsg)
  if(ermsg /= '') print *,ermsg
  call drifters_comm_del(drfts_com)
  call mpp_domains_exit
  call mpp_exit

end program main
#endif
! _TEST_DRIFTERS_COMM

module ocean_pressure_mod
#define COMP isc:iec,jsc:jec
!  
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
! S.M. Griffies 
! </CONTACT>
!
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
! A. Rosati 
! </REVIEWER>
!
!<OVERVIEW>
! Compute the hydrostatic pressure and forces from pressure. 
! Includes methods for either Bgrid or Cgrid. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes hydrostatic pressure and the pressure force
! acting at a velocity point (traditional finite difference approach).
! This force is used for the linear momentum equation.  
!
! This module takes account of the vertical coordinate,
! which determines details of the calculation.  
!
! This module allows for either Bgrid or Cgrid calculation. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
!  S.M. Griffies, 2012: Elements of MOM 
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_pressure_nml">
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging. 
!  </DATA> 
!
!  <DATA NAME="zero_correction_term_grad" TYPE="logical">
!  For debugging it is often useful to zero the contribution to the 
!  pressure gradient that arises from the "correction" term. 
!  Implemented only for depth based vertical coordinate models.
!  </DATA> 
!  <DATA NAME="zero_diagonal_press_grad" TYPE="logical">
!  For debugging it is often useful to zero the contribution to the 
!  pressure gradient that arises from the along k-level gradient.
!  Implemented only for depth based vertical coordinate models.
!  </DATA> 
!  <DATA NAME="zero_pressure_force" TYPE="logical">
!  For debugging it is often useful to zero the pressure force
!  to zero.  
!  </DATA> 
!  <DATA NAME="zero_eta_over_h_zstar_pressure" TYPE="logical">
!  For debugging zstar, we drop any eta/H contribution to 
!  the hydrostatic pressure.  This is wrong physically, but 
!  useful for certain tests.   
!  </DATA> 
!
!</NAMELIST>

use constants_mod,    only: c2dbars, epsln 
use diag_manager_mod, only: register_diag_field, send_data
use fms_mod,          only: open_namelist_file, check_nml_error, close_file, write_version_number
use mpp_io_mod,       only: mpp_open, mpp_close, MPP_RDONLY, MPP_ASCII
use mpp_mod,          only: input_nml_file, mpp_error, FATAL, stdout, stdlog
use mpp_domains_mod,  only: mpp_update_domains

use ocean_domains_mod,    only: get_local_indices
use ocean_operators_mod,  only: FAY, FAX, FDX_NT, FDY_ET 
use ocean_parameters_mod, only: MOM_BGRID, MOM_CGRID 
use ocean_parameters_mod, only: GEOPOTENTIAL, ZSTAR, ZSIGMA
use ocean_parameters_mod, only: PRESSURE, PSTAR, PSIGMA
use ocean_parameters_mod, only: DEPTH_BASED, PRESSURE_BASED
use ocean_parameters_mod, only: ENERGETIC, FINITEVOLUME
use ocean_parameters_mod, only: missing_value, onehalf, rho0, rho0r, grav
use ocean_types_mod,      only: ocean_domain_type, ocean_grid_type
use ocean_types_mod,      only: ocean_time_type, ocean_velocity_type
use ocean_types_mod,      only: ocean_thickness_type, ocean_density_type
use ocean_types_mod,      only: ocean_lagrangian_type
use ocean_util_mod,       only: write_timestamp, diagnose_3d, diagnose_3d_u, write_chksum_3d
use ocean_workspace_mod,  only: wrk1, wrk2, wrk1_zw, wrk2_zw, wrk1_v, wrk2_v, wrk1_2d
use ocean_workspace_mod,  only: wrk3, wrk4
use ocean_obc_mod,        only: store_ocean_obc_pressure_grad

implicit none

private

public ocean_pressure_init
public pressure_in_dbars
public pressure_in_dbars_blob
public pressure_force
public hydrostatic_pressure
public hydrostatic_pressure_blob
public geopotential_anomaly 
public geopotential_anomaly_blob

private press_grad_force_depth_bgrid
private press_grad_force_depth_cgrid
private press_grad_force_depth_blob

private press_grad_force_press_bgrid
private press_grad_force_press_cgrid
private press_grad_force_press_blob

#include <ocean_memory.h>

type(ocean_domain_type), pointer :: Dom =>NULL()
type(ocean_grid_type), pointer   :: Grd =>NULL()

character(len=128) :: version = &
     '$Id: ocean_pressure.F90,v 20.0 2013/12/14 00:10:57 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

! for vertical coordinate
integer :: vert_coordinate 
integer :: vert_coordinate_class

! for Bgrid or Cgrid
integer :: horz_grid

! useful constants
real :: grav_rho0r
real :: grav_rho0
real :: p5grav
real :: p5gravr
real :: p5grav_rho0r
real :: dbars2pa

real, allocatable, dimension(:,:,:) :: gridmask

logical :: use_blobs

! for computing geopotential at T-cell bottom from depth_zwt
real :: geopotential_switch=0.0

! for diagnostics
integer :: id_geopotential   =-1
integer :: id_anomgeopot     =-1
integer :: id_anomgeopot_zwt =-1
integer :: id_anompress      =-1
integer :: id_anompress_zwt  =-1

integer :: id_press_force(2)           =-1
integer :: id_pgrad_klev(2)            =-1
integer :: id_rhoprime_geograd_klev(2) =-1
integer :: id_rhoprime_pgrad_klev(2)   =-1
integer :: id_rho_geogradprime_klev(2) =-1

logical :: used

logical :: debug_this_module         =.false. 
logical :: zero_pressure_force       =.false.
logical :: zero_correction_term_grad =.false.
logical :: zero_diagonal_press_grad  =.false.
logical :: module_is_initialized     =.false.
logical :: have_obc                  =.false. 
logical :: zero_eta_over_h_zstar_pressure = .false. 

namelist /ocean_pressure_nml/ debug_this_module, zero_pressure_force, &
         zero_correction_term_grad, zero_diagonal_press_grad,         &
         zero_eta_over_h_zstar_pressure

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_pressure_init">
!
! <DESCRIPTION>
! Initialize the pressure module
! </DESCRIPTION>
!
subroutine ocean_pressure_init(Grid, Domain, Time, ver_coordinate, &
                               ver_coordinate_class, hor_grid, obc, blobs, debug)

  type(ocean_grid_type),   target, intent(in) :: Grid
  type(ocean_domain_type), target, intent(in) :: Domain
  type(ocean_time_type),           intent(in) :: Time
  integer,                         intent(in) :: ver_coordinate
  integer,                         intent(in) :: ver_coordinate_class
  integer,                         intent(in) :: hor_grid
  logical,                         intent(in) :: obc
  logical,                         intent(in) :: blobs
  logical,               optional, intent(in) :: debug

  integer :: ioun, io_status, ierr

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error( FATAL, &
    '==>Error: ocean_pressure_mod (ocean_pressure_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  vert_coordinate       = ver_coordinate
  vert_coordinate_class = ver_coordinate_class
  horz_grid             = hor_grid 
  have_obc              = obc
  use_blobs             = blobs

  grav_rho0    = grav*rho0
  grav_rho0r   = grav*rho0r
  p5grav       = 0.5*grav
  p5gravr      = 0.5/grav
  p5grav_rho0r = 0.5*grav*rho0r 
  dbars2pa     = 1.0/c2dbars

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_pressure_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_pressure_nml')
#else
  ioun = open_namelist_file()
  read  (ioun, ocean_pressure_nml,iostat=io_status)
  ierr = check_nml_error(io_status, 'ocean_pressure_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit, ocean_pressure_nml)
  write (stdlogunit, ocean_pressure_nml)

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain,isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
#endif

  Dom => Domain
  Grd => Grid

  if (PRESENT(debug) .and. .not. debug_this_module) then
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') '==>Note: running ocean_pressure_mod with debug_this_module=.true.'  
  endif 

  if(zero_pressure_force) then 
    write(stdoutunit,*) &
    '==>Warning: Running MOM with zero horizontal pressure force; meant for debugging.'
  endif 

  if(use_blobs .and. horz_grid == MOM_CGRID) then 
    write(stdoutunit,*) &
    '==>Warning from pressure mod: MOM C-grid with blobs is incomplete; blobs have only been tested with Bgrid.'
  endif 

  if(vert_coordinate==GEOPOTENTIAL) then 
     geopotential_switch=0.0
  else
     geopotential_switch=1.0
  endif


  allocate (gridmask(isd:ied,jsd:jed,nk))
  if(horz_grid == MOM_BGRID) then 
     gridmask(:,:,:) = Grd%umask(:,:,:)
  else
     gridmask(:,:,:) = Grd%tmask(:,:,:)
  endif 


  write(stdoutunit,*) &
       '==>NOTE: Running MOM with finite difference formulation of pressure force.'

  if(zero_correction_term_grad) then 
      write(stdoutunit,*) &
           '==>Warning: Running MOM with zero_correction_term_grad=.true. Unrealistic simulation.'
  endif

  if(zero_diagonal_press_grad) then 
      write(stdoutunit,*) &
           '==>Warning: Running MOM with zero_diagonal_press_grad=.true. Unrealistic simulation.'
  endif


  ! register fields

  id_geopotential = register_diag_field ('ocean_model', 'geopotential', Grd%tracer_axes(1:3),&
   Time%model_time, 'geopotential at T-point', 'm^2/s^2',                                    &
   missing_value=missing_value, range=(/-1e8,1e8/))

  id_anompress = register_diag_field ('ocean_model', 'anompress', Grd%tracer_axes(1:3),&
   Time%model_time, 'anomalous hydrostatic pressure at T-point', 'Pa',                 &
   missing_value=missing_value, range=(/-1e8,1e8/))

  id_anompress_zwt = register_diag_field ('ocean_model', 'anompress_zwt', Grd%tracer_axes(1:3),&
   Time%model_time, 'anomalous hydrostatic pressure at T-cell bottom', 'Pa',                   &
   missing_value=missing_value, range=(/-1e8,1e8/))

  id_anomgeopot = register_diag_field ('ocean_model', 'anomgeopot', Grd%tracer_axes(1:3),&
   Time%model_time, 'anomalous geopotential at T-point', 'm^2/s^2',                      &
   missing_value=missing_value, range=(/-1e8,1e8/))

  id_anomgeopot_zwt = register_diag_field ('ocean_model', 'anomgeopot_zwt', Grd%tracer_axes(1:3),&
   Time%model_time, 'anomalous geopotential at T-cell bottom', 'm^2/s^2',                        &
   missing_value=missing_value, range=(/-1e8,1e8/))

  id_pgrad_klev(1) = register_diag_field ('ocean_model', 'dzupgrad_x_klev', Grd%vel_axes_u(1:3), &
     Time%model_time, 'dz*dp_dx on k-level', 'Pa', missing_value=missing_value, range=(/-1e9,1e9/))
  id_pgrad_klev(2) = register_diag_field ('ocean_model', 'dzupgrad_y_klev', Grd%vel_axes_v(1:3), &
     Time%model_time, 'dz*dp_dy on k-level', 'Pa', missing_value=missing_value, range=(/-1e9,1e9/))

  id_rhoprime_geograd_klev(1) = register_diag_field ('ocean_model', 'dzurhoprime_geograd_x_klev',&
     Grd%vel_axes_u(1:3), Time%model_time, 'dz*rhoprime*d(geopot)/dx on k-level', 'Pa',          &
     missing_value=missing_value, range=(/-1e9,1e9/))
  id_rhoprime_geograd_klev(2) = register_diag_field ('ocean_model', 'dzurhoprime_geograd_y_klev',&
    Grd%vel_axes_v(1:3), Time%model_time, 'dz*rhoprime*d(geopot)/dx on k-level', 'Pa',           &
    missing_value=missing_value, range=(/-1e9,1e9/))

  id_rhoprime_pgrad_klev(1) = register_diag_field ('ocean_model', 'dzurhoprime_pgrad_x_klev',&
     Grd%vel_axes_u(1:3), Time%model_time, 'dz*(rhoprime/rho0)*dp/dx on k-level', 'Pa',      &
     missing_value=missing_value, range=(/-1e9,1e9/))
  id_rhoprime_pgrad_klev(2) = register_diag_field ('ocean_model', 'dzurhoprime_pgrad_y_klev',&
     Grd%vel_axes_v(1:3), Time%model_time, 'dz*(rhoprime/rho0)*dp/dy on k-level', 'Pa',      &
     missing_value=missing_value, range=(/-1e9,1e9/))

  id_rho_geogradprime_klev(1) = register_diag_field ('ocean_model', 'dzurho_geogradprime_x_klev',&
    Grd%vel_axes_u(1:3), Time%model_time, 'dzu*rho*d(geopot_prime)/dx on k-level', 'Pa',         &
    missing_value=missing_value, range=(/-1e9,1e9/))
  id_rho_geogradprime_klev(2) = register_diag_field ('ocean_model', 'dzurho_geogradprime_y_klev',&
    Grd%vel_axes_v(1:3), Time%model_time, 'dzu*rho*d(geopot_prime)/dy on k-level', 'Pa/m',       &
    missing_value=missing_value, range=(/-1e9,1e9/))

  id_press_force(1) = register_diag_field ('ocean_model', 'press_force_u',&
     Grd%vel_axes_u(1:3), Time%model_time, 'i-directed pressure force',   &
     'Pa', missing_value=missing_value, range=(/-1e9,1e9/))
  id_press_force(2) = register_diag_field ('ocean_model', 'press_force_v',&
     Grd%vel_axes_v(1:3), Time%model_time, 'j-directed pressure force',   &
     'Pa', missing_value=missing_value, range=(/-1e9,1e9/))
 

end subroutine ocean_pressure_init
! </SUBROUTINE> NAME="ocean_pressure_init"


!#######################################################################
! <SUBROUTINE NAME="pressure_force">
!
! <DESCRIPTION>
! Compute the horizontal force [Pa=N/m^2] from pressure. 
!
! Use the traditional approach whereby the pressure force
! is computed as a finite difference gradient centred 
! at the U-cell point. 
!
! </DESCRIPTION>
!
subroutine pressure_force(Time, Thickness, Dens, Velocity, L_system, rho)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_density_type),       intent(in)    :: Dens
  type(ocean_velocity_type),      intent(inout) :: Velocity
  type(ocean_lagrangian_type),    intent(inout) :: L_system
  real, dimension(isd:,jsd:,:),   intent(in)    :: rho

  integer :: tau, taup1
 
  integer :: stdoutunit 
  stdoutunit=stdout() 

  tau   = Time%tau 
  taup1 = Time%taup1

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_pressure_mod (pressure_force): module must be initialized')
  endif 

  if(horz_grid == MOM_BGRID) then 

     if(use_blobs) then
        if(vert_coordinate_class==DEPTH_BASED) then 
           call press_grad_force_depth_blob(Time, Thickness, Velocity, L_system, rho)
        else 
           call press_grad_force_press_blob(Time, Thickness, Dens, Velocity, L_system, rho)
        endif
     else
        if(vert_coordinate_class==DEPTH_BASED) then 
           call press_grad_force_depth_bgrid(Time, Thickness, Velocity, rho)
        else 
           call press_grad_force_press_bgrid(Time, Thickness, Dens, Velocity, rho)
        endif
     endif

  else ! MOM_CGRID (smg: blobs not yet coded for Cgrid)

     if(vert_coordinate_class==DEPTH_BASED) then 
        call press_grad_force_depth_cgrid(Time, Thickness, Velocity, rho)
     else
        call press_grad_force_press_cgrid(Time, Thickness, Dens, Velocity, rho)
     endif

  endif 

  ! for debugging 
  if(zero_pressure_force) then 
      Velocity%press_force = 0.0
  endif

  ! for open boundaries 
  if (have_obc) call store_ocean_obc_pressure_grad(Thickness, Velocity%press_force) 

  ! send some diagnostics 

  if(id_geopotential > 0) call diagnose_3d(Time, Grd, id_geopotential, -grav*Thickness%geodepth_zt(:,:,:))

  if (id_press_force(1) > 0) then 
       used = send_data( id_press_force(1), Velocity%press_force(:,:,:,1), &
       Time%model_time, rmask=gridmask(:,:,:),                             &
       is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
  endif 
  if (id_press_force(2) > 0) then 
       used = send_data( id_press_force(2), Velocity%press_force(:,:,:,2), &
       Time%model_time, rmask=gridmask(:,:,:),                             &
       is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
  endif 


  ! more debugging 
  if(debug_this_module) then 
      write(stdoutunit,*)' '
      write(stdoutunit,*) 'From ocean_pressure_mod: pressure chksums'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('rho_dzu(tau)', Thickness%rho_dzu(COMP,:,tau)*Grd%umask(COMP,:))
      call write_chksum_3d('press_force(1)', Velocity%press_force(COMP,:,1)*Grd%umask(COMP,:))
      call write_chksum_3d('press_force(2)', Velocity%press_force(COMP,:,2)*Grd%umask(COMP,:))
  endif 


end subroutine pressure_force
! </SUBROUTINE> NAME="pressure_force"



!#######################################################################
! <SUBROUTINE NAME="press_grad_force_depth_bgrid">
!
! <DESCRIPTION>
! Compute the force from pressure using a finite difference method
! to compute the thickness weighted pressure gradient at the 
! velocity cell point. 
!
! Assume B-grid arrangement here.
!
! For depth-like vertical coordinates, we exclude surface and applied 
! pressures (i.e., we are computing here the gradient of the baroclinic 
! pressure).  The surface and applied pressures are accounted for in 
! the barotropic module. 
!
! Account is taken of variable partial cell thickness.
!
! 1 = dp/dx; 2 = dp/dy
!
! Thickness weight since this is what we wish to use in update of 
! the velocity. Resulting thickness weighted pressure gradient has 
! dimensions of Pa = N/m^2 = kg/(m*s^2).
!
! Thickness%dzu should be at tau.
!
! </DESCRIPTION>
!
subroutine press_grad_force_depth_bgrid(Time, Thickness, Velocity, rho)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_velocity_type),      intent(inout) :: Velocity
  real, dimension(isd:,jsd:,:),   intent(in)    :: rho

  real, dimension(isd:ied,jsd:jed) :: diff_geo_x
  real, dimension(isd:ied,jsd:jed) :: diff_geo_y
  real, dimension(isd:ied,jsd:jed) :: tmp1
  real, dimension(isd:ied,jsd:jed) :: tmp2
  integer :: i, j, k
  integer :: tau

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_pressure_mod (press_grad_force_depth_bgrid): module must be initialized')
  endif 

  tau    = Time%tau
  tmp1   = 0.0
  tmp2   = 0.0
  wrk1_v = 0.0
  wrk2_v = 0.0


  ! use density anomaly to improve accuracy 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           wrk2(i,j,k) = Grd%tmask(i,j,k)*(rho(i,j,k)-rho0)
        enddo
     enddo
  enddo
  
  ! compute hydrostatic pressure anomaly at T-point 
  ! ( Pa=N/m^2=kg/(m*s^2) )
  wrk1(:,:,:) = hydrostatic_pressure(Thickness, wrk2(:,:,:))  

  diff_geo_x(:,:) = 0.0
  diff_geo_y(:,:) = 0.0

  do k=1,nk

     ! geopotential = -grav*geodepth, hence the minus sign below 
     do j=jsd,jed
        do i=isd,iec
           diff_geo_x(i,j) = -grav*(Thickness%geodepth_zt(i+1,j,k)-Thickness%geodepth_zt(i,j,k))
        enddo
     enddo
     do j=jsd,jec
        do i=isd,ied
           diff_geo_y(i,j) = -grav*(Thickness%geodepth_zt(i,j+1,k)-Thickness%geodepth_zt(i,j,k))
        enddo
     enddo

     ! density anomaly times geopotential gradient on k-levels 
     ! (dzurhoprime_geograd_x_klev,dzurhoprime_geograd_y_klev)
     tmp1(:,:) = FAY(FAX(wrk2(:,:,k))*diff_geo_x(:,:))
     tmp2(:,:) = FAX(FAY(wrk2(:,:,k))*diff_geo_y(:,:))
     do j=jsc,jec
        do i=isc,iec
           wrk1_v(i,j,k,1) = tmp1(i,j)*Grd%dxur(i,j)*Thickness%dzu(i,j,k)
           wrk1_v(i,j,k,2) = tmp2(i,j)*Grd%dyur(i,j)*Thickness%dzu(i,j,k)
        enddo
     enddo
     if(zero_correction_term_grad) then 
         wrk1_v(:,:,:,:) = 0.0
     endif

     ! gradient of anomalous baroclinic pressure on k-levels 
     ! (dzupgrad_x_klev,dzupgrad_y_klev)
     tmp1(:,:) = FDX_NT(FAY(wrk1(:,:,k)))
     tmp2(:,:) = FDY_ET(FAX(wrk1(:,:,k)))
     do j=jsc,jec
        do i=isc,iec
           wrk2_v(i,j,k,1) = tmp1(i,j)*Thickness%dzu(i,j,k)
           wrk2_v(i,j,k,2) = tmp2(i,j)*Thickness%dzu(i,j,k)
        enddo
     enddo

     if(zero_diagonal_press_grad) then 
         wrk2_v(:,:,:,:) = 0.0
     endif

     ! thickness weighted baroclinic pressure gradient on z-levels
     ! (dzu_pgrad_u,dzu_pgrad_v)
     do j=jsc,jec
        do i=isc,iec    
           Velocity%press_force(i,j,k,1) = -Grd%umask(i,j,k)*( wrk1_v(i,j,k,1) + wrk2_v(i,j,k,1) )
           Velocity%press_force(i,j,k,2) = -Grd%umask(i,j,k)*( wrk1_v(i,j,k,2) + wrk2_v(i,j,k,2) )
        enddo
     enddo

  enddo   ! k do-loop finish 


  ! diagnostics 

  call diagnose_3d(Time, Grd, id_anompress, wrk1(:,:,:))

  ! (dzurhoprime_geograd_x_klev,dzurhoprime_geograd_y_klev)
  call diagnose_3d_u(Time, Grd, id_rhoprime_geograd_klev(1),wrk1_v(:,:,:,1))
  call diagnose_3d_u(Time, Grd, id_rhoprime_geograd_klev(2),wrk1_v(:,:,:,2))

  ! (dzupgrad_x_klev,dzupgrad_y_klev)
  call diagnose_3d_u(Time, Grd, id_pgrad_klev(1), wrk2_v(:,:,:,1))
  call diagnose_3d_u(TIme, Grd, id_pgrad_klev(2), wrk2_v(:,:,:,2))

end subroutine press_grad_force_depth_bgrid
! </SUBROUTINE> NAME="press_grad_force_depth_bgrid"



!#######################################################################
! <SUBROUTINE NAME="press_grad_force_press_bgrid">
!
! <DESCRIPTION>
! Compute the force from pressure using a finite difference method
! to compute the thickness weighted pressure gradient at the 
! velocity cell corner point. 
!
! Assume B-grid arrangement here.
!
! For pressure-like vertical coordinates, we omit the bottom pressure
! and bottom geopotential. These pressures are accounted for in the 
! barotropic module.   
!
! Account is taken of variable partial cell thickness. 
!
! 1 = dp/dx; 2 = dp/dy
!
! Thickness weight since this is what we wish to use in update of 
! the velocity. Resulting thickness weighted pressure gradient has 
! dimensions of Pa = N/m^2 = kg/(m*s^2).
!
! Thickness%dzu should be at tau.
!
! </DESCRIPTION>
!
subroutine press_grad_force_press_bgrid(Time, Thickness, Dens, Velocity, rho)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_density_type),       intent(in)    :: Dens
  type(ocean_velocity_type),      intent(inout) :: Velocity
  real, dimension(isd:,jsd:,:),   intent(in)    :: rho

  real, dimension(isd:ied,jsd:jed) :: diff_press_x
  real, dimension(isd:ied,jsd:jed) :: diff_press_y
  real, dimension(isd:ied,jsd:jed) :: tmp1
  real, dimension(isd:ied,jsd:jed) :: tmp2
  integer :: i, j, k
  integer :: tau

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_pressure_mod (press_grad_force_press_bgrid): module must be initialized')
  endif 

  tau    = Time%tau
  tmp1   = 0.0
  tmp2   = 0.0
  wrk1_v = 0.0
  wrk2_v = 0.0

  ! use density anomaly to improve accuracy 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           wrk2(i,j,k) = Grd%tmask(i,j,k)*(rho(i,j,k)-rho0)
        enddo
     enddo
  enddo

  ! compute geopotential anomaly (m^2/s^2) at T-cell point 
  wrk1(:,:,:) = geopotential_anomaly(Thickness, wrk2(:,:,:)) 

  diff_press_x(:,:) = 0.0
  diff_press_y(:,:) = 0.0

  do k=1,nk

     do j=jsd,jed
        do i=isd,iec
           diff_press_x(i,j) = -dbars2pa*(Dens%pressure_at_depth(i+1,j,k)-Dens%pressure_at_depth(i,j,k))
        enddo
     enddo
     do j=jsd,jec
        do i=isd,ied
           diff_press_y(i,j) = -dbars2pa*(Dens%pressure_at_depth(i,j+1,k)-Dens%pressure_at_depth(i,j,k))
        enddo
     enddo

     ! anomalous density times gradient of pressure on k-level               
     ! (dzurhoprime_pgrad_x_klev,dzurhoprime_pgrad_y_klev)
     tmp1(:,:) = rho0r*FAY(FAX(wrk2(:,:,k))*diff_press_x(:,:))
     tmp2(:,:) = rho0r*FAX(FAY(wrk2(:,:,k))*diff_press_y(:,:))
     do j=jsc,jec
        do i=isc,iec
           wrk1_v(i,j,k,1) = tmp1(i,j)*Grd%dxur(i,j)*Thickness%dzu(i,j,k)
           wrk1_v(i,j,k,2) = tmp2(i,j)*Grd%dyur(i,j)*Thickness%dzu(i,j,k)
        enddo
     enddo

     ! density times gradient of anomalous geopotential on k-level
     ! (dzurho_geogradprime_x_klev,dzurho_geogradprime_y_klev) 
     tmp1(:,:) = FDX_NT(FAY(wrk1(:,:,k)))
     tmp2(:,:) = FDY_ET(FAX(wrk1(:,:,k)))
     do j=jsc,jec
        do i=isc,iec
           wrk2_v(i,j,k,1) = tmp1(i,j)*Thickness%rho_dzu(i,j,k,tau)
           wrk2_v(i,j,k,2) = tmp2(i,j)*Thickness%rho_dzu(i,j,k,tau)
        enddo
     enddo

     ! thickness weighted baroclinic pressure gradient on z-levels
     ! (dzu_pgrad_u,dzu_pgrad_v)
     do j=jsc,jec
        do i=isc,iec    
           Velocity%press_force(i,j,k,1) = -Grd%umask(i,j,k)*( wrk1_v(i,j,k,1) + wrk2_v(i,j,k,1) )
           Velocity%press_force(i,j,k,2) = -Grd%umask(i,j,k)*( wrk1_v(i,j,k,2) + wrk2_v(i,j,k,2) )
        enddo
     enddo

  enddo  ! k do-loop finish 


  ! diagnostics 

  call diagnose_3d(Time, Grd, id_anomgeopot, wrk1(:,:,:))

  ! (dzurhoprime_pgrad_x_klev,dzurhoprime_pgrad_y_klev)
  call diagnose_3d_u(Time, Grd, id_rhoprime_pgrad_klev(1),wrk1_v(:,:,:,1))
  call diagnose_3d_u(Time, Grd, id_rhoprime_pgrad_klev(2),wrk1_v(:,:,:,2))

  ! (dzurho_geogradprime_x_klev,dzurho_geogradprime_y_klev)
  call diagnose_3d_u(Time, Grd, id_rho_geogradprime_klev(1),wrk2_v(:,:,:,1))
  call diagnose_3d_u(Time, Grd, id_rho_geogradprime_klev(2),wrk2_v(:,:,:,2))

end subroutine press_grad_force_press_bgrid
! </SUBROUTINE> NAME="press_grad_force_press_bgrid"


!#######################################################################
! <SUBROUTINE NAME="press_grad_force_depth_cgrid">
!
! <DESCRIPTION>
! Compute the force from pressure using a finite difference method
! to compute the thickness weighted pressure gradient at the 
! T-cell face, thus acting on the C-grid velocity components.  
!
! Assume C-grid arrangement here.
!
! For depth-like vertical coordinates, we exclude surface and applied 
! pressures (i.e., we are computing here the gradient of the baroclinic 
! pressure).  The surface and applied pressures are included in 
! ocean_barotropic.
!
! Account is taken of variable partial cell thickness.
!
! 1 = dp/dx; 2 = dp/dy
!
! Thickness weight since this is what we wish to use in update of 
! the velocity. Resulting thickness weighted pressure gradient has 
! dimensions of Pa = N/m^2 = kg/(m*s^2).
!
! Thickness%dzten should be at time tau.
!
! </DESCRIPTION>
!
subroutine press_grad_force_depth_cgrid(Time, Thickness, Velocity, rho)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_velocity_type),    intent(inout) :: Velocity
  real, dimension(isd:,jsd:,:), intent(in)    :: rho

  real    :: rhoave 
  integer :: i, j, k
  integer :: tau

  tau    = Time%tau
  wrk1   = 0.0
  wrk2   = 0.0
  wrk1_v = 0.0
  wrk2_v = 0.0

  ! density anomaly to improve accuracy 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           wrk2(i,j,k) = Grd%tmask(i,j,k)*(rho(i,j,k)-rho0)
        enddo
     enddo
  enddo
  
  ! hydrostatic pressure anomaly at T-point ( Pa = N/m^2 = kg/(m*s^2) )
  wrk1(:,:,:) = hydrostatic_pressure(Thickness, wrk2(:,:,:))  

  ! wrk1_v = horizontal gradient of geopotential on T-cell faces (geopotential = -grav*geodepth);
  ! wrk2_v = horizontal gradient of anomalous baroclinic pressure on T-cell faces;
  ! press_force = thickness weighted baroclinic pressure gradient on z-levels at T-cell faces. 
  do k=1,nk
     do j=jsd,jec
        do i=isd,iec
           rhoave          = onehalf*(wrk2(i+1,j,k)+wrk2(i,j,k))
           wrk1_v(i,j,k,1) = -grav*rhoave*(Thickness%geodepth_zt(i+1,j,k)-Thickness%geodepth_zt(i,j,k))
           rhoave          = onehalf*(wrk2(i,j+1,k)+wrk2(i,j,k))
           wrk1_v(i,j,k,2) = -grav*rhoave*(Thickness%geodepth_zt(i,j+1,k)-Thickness%geodepth_zt(i,j,k))
           wrk2_v(i,j,k,1) = wrk1(i+1,j,k)-wrk1(i,j,k)
           wrk2_v(i,j,k,2) = wrk1(i,j+1,k)-wrk1(i,j,k)
        enddo
     enddo
  enddo
  if(zero_correction_term_grad) then 
     wrk1_v(:,:,:,:) = 0.0
  endif
  if(zero_diagonal_press_grad) then 
      wrk2_v(:,:,:,:) = 0.0
  endif
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           Velocity%press_force(i,j,k,1) = -Grd%tmasken(i,j,k,1)*Thickness%dzten(i,j,k,1)*Grd%dxter(i,j) * ( wrk1_v(i,j,k,1) + wrk2_v(i,j,k,1) )
           Velocity%press_force(i,j,k,2) = -Grd%tmasken(i,j,k,2)*Thickness%dzten(i,j,k,2)*Grd%dytnr(i,j) * ( wrk1_v(i,j,k,2) + wrk2_v(i,j,k,2) )
        enddo
     enddo
  enddo

  ! diagnostics 
  call diagnose_3d(Time, Grd, id_anompress, wrk1(:,:,:))

  if (id_rhoprime_geograd_klev(1) > 0) then 
     do k=1,nk
        do j=jsd,jec
           do i=isd,iec
              wrk1_v(i,j,k,1) = wrk1_v(i,j,k,1)*Thickness%dzten(i,j,k,1)*Grd%dxter(i,j)
           enddo
        enddo
     enddo
     call diagnose_3d(Time, Grd, id_rhoprime_geograd_klev(1), wrk1_v(:,:,:,1))
  endif
  if (id_rhoprime_geograd_klev(2) > 0) then 
     do k=1,nk
        do j=jsd,jec
           do i=isd,iec
              wrk1_v(i,j,k,2) = wrk1_v(i,j,k,2)*Thickness%dzten(i,j,k,2)*Grd%dytnr(i,j)
           enddo
        enddo
     enddo
     call diagnose_3d(Time, Grd, id_rhoprime_geograd_klev(2), wrk1_v(:,:,:,2))
  endif
  if (id_pgrad_klev(1) > 0) then 
     do k=1,nk
        do j=jsd,jec
           do i=isd,iec
              wrk2_v(i,j,k,1) = wrk2_v(i,j,k,1)*Thickness%dzten(i,j,k,1)*Grd%dxter(i,j)
           enddo
        enddo
     enddo
     call diagnose_3d(Time, Grd, id_pgrad_klev(1), wrk2_v(:,:,:,1))
  endif
  if (id_pgrad_klev(2) > 0) then 
     do k=1,nk
        do j=jsd,jec
           do i=isd,iec
              wrk2_v(i,j,k,2) = wrk2_v(i,j,k,2)*Thickness%dzten(i,j,k,2)*Grd%dytnr(i,j)
           enddo
        enddo
     enddo
     call diagnose_3d(Time, Grd, id_pgrad_klev(2), wrk2_v(:,:,:,2))
  endif


end subroutine press_grad_force_depth_cgrid
! </SUBROUTINE> NAME="press_grad_force_depth_cgrid"


!#######################################################################
! <SUBROUTINE NAME="press_grad_force_press_cgrid">
!
! <DESCRIPTION>
! Compute the force from pressure using a finite difference method
! to compute the thickness weighted pressure gradient at the
! T-cell face, thus acting on the C-grid velocity components.
!
! Assume C-grid arrangement here.
!
! For pressure-like vertical coordinates, we omit the bottom pressure
! and bottom geopotential; these are handled in ocean_barotropic.  
!
! Account is taken of variable partial cell thickness.  
!
! 1 = dp/dx; 2 = dp/dy
!
! Thickness weight since this is what we wish to use in update of 
! the velocity. Resulting thickness weighted pressure gradient has 
! dimensions of Pa = N/m^2 = kg/(m*s^2).
!
! Thickness%dzu should be at tau.
!
! </DESCRIPTION>
!
subroutine press_grad_force_press_cgrid(Time, Thickness, Dens, Velocity, rho)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_velocity_type),    intent(inout) :: Velocity
  real, dimension(isd:,jsd:,:), intent(in)    :: rho

  integer :: i, j, k
  integer :: tau
  real    :: rhoave 

  tau    = Time%tau
  wrk1   = 0.0
  wrk2   = 0.0
  wrk1_v = 0.0
  wrk2_v = 0.0

  ! use density anomaly to improve accuracy 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           wrk2(i,j,k) = Grd%tmask(i,j,k)*(rho(i,j,k)-rho0)
        enddo
     enddo
  enddo

  ! geopotential anomaly (m^2/s^2) at T-cell point 
  wrk1(:,:,:) = geopotential_anomaly(Thickness, wrk2(:,:,:)) 

  ! wrk1_v = rho0r*rhoave * dz * horizontal gradient of pressure on T-cell faces;
  ! wrk2_v = rho_dz * horizontal gradient of anomalous geopotential on T-cell faces;
  ! press_force = thickness weighted baroclinic pressure gradient on z-levels at T-cell faces. 
  do k=1,nk
     do j=jsd,jec
        do i=isd,iec
           rhoave          = onehalf*(wrk2(i+1,j,k)+wrk2(i,j,k))
           wrk1_v(i,j,k,1) = -rhoave*rho0r*Thickness%dzten(i,j,k,1)*dbars2pa &
                             *(Dens%pressure_at_depth(i+1,j,k)-Dens%pressure_at_depth(i,j,k))
           rhoave          = onehalf*(wrk2(i,j+1,k)+wrk2(i,j,k))
           wrk1_v(i,j,k,2) = -rhoave*rho0r*Thickness%dzten(i,j,k,2)*dbars2pa &
                             *(Dens%pressure_at_depth(i,j+1,k)-Dens%pressure_at_depth(i,j,k))
           wrk2_v(i,j,k,1) = Thickness%rho_dzten(i,j,k,1)*(wrk1(i+1,j,k)-wrk1(i,j,k))
           wrk2_v(i,j,k,2) = Thickness%rho_dzten(i,j,k,2)*(wrk1(i,j+1,k)-wrk1(i,j,k))
           Velocity%press_force(i,j,k,1) = -Grd%dxter(i,j) * ( wrk1_v(i,j,k,1) + wrk2_v(i,j,k,1) )
           Velocity%press_force(i,j,k,2) = -Grd%dytnr(i,j) * ( wrk1_v(i,j,k,2) + wrk2_v(i,j,k,2) )
        enddo
     enddo
  enddo

  ! diagnostics 
  call diagnose_3d(Time, Grd, id_anomgeopot, wrk1(:,:,:))

  call diagnose_3d(Time, Grd, id_rhoprime_pgrad_klev(1), wrk1_v(:,:,:,1))
  call diagnose_3d(Time, Grd, id_rhoprime_pgrad_klev(2), wrk1_v(:,:,:,2))

  call diagnose_3d(Time, Grd, id_rho_geogradprime_klev(1), wrk2_v(:,:,:,1))
  call diagnose_3d(Time, Grd, id_rho_geogradprime_klev(2), wrk2_v(:,:,:,2))


end subroutine press_grad_force_press_cgrid
! </SUBROUTINE> NAME="press_grad_force_press_cgrid"


!#######################################################################
! <FUNCTION NAME="pressure_in_dbars">
!
! <DESCRIPTION>
! Compute pressure (dbars) exerted at T cell grid point by weight of
! water column above the grid point. 
!
! rho = density in kg/m^3
!
! psurf = surface pressure in Pa= kg/(m*s^2) = hydrostatic pressure 
! at z=0 associated with fluid between z=0 and z=eta_t.
! Also include pressure from atmosphere and ice, both of which 
! are part of the patm array. 
!
! This routine is used by ocean_density to compute the pressure 
! used in the equation of state.  It is only called when the 
! vertical coordinate is DEPTH_BASED.
!
! </DESCRIPTION>
function pressure_in_dbars (Thickness, rho, psurf)

  type(ocean_thickness_type),   intent(in) :: Thickness
  real, dimension(isd:,jsd:,:), intent(in) :: rho   
  real, dimension(isd:,jsd:),   intent(in) :: psurf 
  real, dimension(isd:ied,jsd:jed,nk)      :: pressure_in_dbars
  integer :: k

  if ( .not. module_is_initialized ) then   
    call mpp_error(FATAL, &
    '==>Error in ocean_pressure_mod (pressure_in_dbars): module must be initialized')
  endif 

  pressure_in_dbars(:,:,:) = hydrostatic_pressure (Thickness, rho(:,:,:))*c2dbars

  ! add pressure from free surface height and loading from atmosphere and/or sea ice
  do k=1,nk
     pressure_in_dbars(:,:,k) = pressure_in_dbars(:,:,k) + psurf(:,:)*c2dbars 
  enddo


end function pressure_in_dbars
! </FUNCTION> NAME="pressure_in_dbars"


!#######################################################################
! <FUNCTION NAME="hydrostatic_pressure">
!
! <DESCRIPTION>
! Hydrostatic pressure [Pa=N/m^2=kg/(m*s^2)] at T cell grid points.
!
! For GEOPOTENTIAL vertical coordinate, integration is 
! from z=0 to depth of grid point.  This integration results in  
! the so-called "baroclinic" pressure. 
!
! For ZSTAR or ZSIGMA, vertical coordinate, integration is from z=eta to 
! depth of grid point.  This is allowed because ZSTAR and ZSIGMA 
! absorb the undulations of the surface height into their definition.
!
! If the input density "rho" is an anomoly, the resulting presure 
! will be a hydrostatic pressure anomoly. If "rho" is full density, 
! the presure will be a full hydrostatic pressure.
!
! </DESCRIPTION>
!
function hydrostatic_pressure (Thickness, rho)

  type(ocean_thickness_type),   intent(in) :: Thickness
  real, dimension(isd:,jsd:,:), intent(in) :: rho

  integer :: i, j, k
  real, dimension(isd:ied,jsd:jed,nk) :: hydrostatic_pressure

  if(vert_coordinate==GEOPOTENTIAL) then 
      do j=jsd,jed
         do i=isd,ied
            hydrostatic_pressure(i,j,1) = rho(i,j,1)*grav*Grd%dzw(0)
         enddo
      enddo
  elseif(vert_coordinate==ZSTAR .or. vert_coordinate==ZSIGMA) then 
      do j=jsd,jed
         do i=isd,ied
            hydrostatic_pressure(i,j,1) = rho(i,j,1)*grav*Thickness%dzwt(i,j,0)
         enddo
      enddo
  endif

  if(Thickness%method==ENERGETIC) then 

      do k=2,nk
         do j=jsd,jed
            do i=isd,ied
               hydrostatic_pressure(i,j,k) = hydrostatic_pressure(i,j,k-1) &
               + Grd%tmask(i,j,k)*p5grav                                   &
                *(rho(i,j,k-1)+rho(i,j,k))*Thickness%dzwt(i,j,k-1) 
            enddo
         enddo
      enddo

  elseif(Thickness%method==FINITEVOLUME) then 

      do k=2,nk
         do j=jsd,jed
            do i=isd,ied
               hydrostatic_pressure(i,j,k) = hydrostatic_pressure(i,j,k-1) &
               + Grd%tmask(i,j,k)*grav                                     &
                *(Thickness%dztlo(i,j,k-1)*rho(i,j,k-1)+Thickness%dztup(i,j,k)*rho(i,j,k)) 
            enddo
         enddo
      enddo

  endif

  ! For some debugging...we here drop the contribution from a 
  ! nonzero eta in the calculation of hydrostatic_pressure. 
  ! This is wrong physically, but it is useful for certain tests
  ! of the zstar vertical coordinate.  
  if(vert_coordinate==ZSTAR .and. zero_eta_over_h_zstar_pressure) then 
      do j=jsd,jed
         do i=isd,ied
            hydrostatic_pressure(i,j,1) = rho(i,j,1)*grav*Thickness%dswt(i,j,0)
         enddo
      enddo
      do k=2,nk
         do j=jsd,jed
            do i=isd,ied
               hydrostatic_pressure(i,j,k) = hydrostatic_pressure(i,j,k-1) &
               + Grd%tmask(i,j,k)*p5grav                                   &
                *(rho(i,j,k-1)+rho(i,j,k))*Thickness%dswt(i,j,k-1) 
            enddo
         enddo
      enddo
  endif 


end function hydrostatic_pressure
! </FUNCTION> NAME="hydrostatic_pressure"



!#######################################################################
! <FUNCTION NAME="geopotential_anomaly">
!
! <DESCRIPTION>
! Geopotential anomaly [m^2/s^2] at T cell grid points.
! Integration here is from z=-H to depth of grid point.  
!
! Input should be density anomaly rhoprime = rho-rho0.
!
! This function is needed when computing pressure gradient
! for PRESSURE_BASED vertical coordinates. 
!
! WARNING: Thickness%method==FINITEVOLUME has been found to be 
! problematic.  It remains under development.  It is NOT 
! supported for general use. 
! 
! </DESCRIPTION>
!
function geopotential_anomaly (Thickness, rhoprime)

  type(ocean_thickness_type),   intent(in) :: Thickness
  real, dimension(isd:,jsd:,:), intent(in) :: rhoprime

  integer :: i, j, k, kbot
  real, dimension(isd:ied,jsd:jed,nk) :: geopotential_anomaly 
  
  geopotential_anomaly(:,:,:) = 0.0

  if(Thickness%method==ENERGETIC) then 
      do j=jsd,jed
         do i=isd,ied
            kbot=Grd%kmt(i,j)
            if(kbot > 1) then  
                k=kbot
                geopotential_anomaly(i,j,k) = -grav_rho0r*rhoprime(i,j,k)*Thickness%dzwt(i,j,k) 
                do k=kbot-1,1,-1
                   geopotential_anomaly(i,j,k) = geopotential_anomaly(i,j,k+1) &
                   -p5grav_rho0r*(rhoprime(i,j,k+1)+rhoprime(i,j,k))*Thickness%dzwt(i,j,k)
                enddo
            endif
         enddo
      enddo
  elseif(Thickness%method==FINITEVOLUME) then 
      do j=jsd,jed
         do i=isd,ied
            kbot=Grd%kmt(i,j)
            if(kbot > 1) then
                k=kbot
                geopotential_anomaly(i,j,k) = -grav_rho0r*rhoprime(i,j,k)*Thickness%dztlo(i,j,k)   
                do k=kbot-1,1,-1
                   geopotential_anomaly(i,j,k) = geopotential_anomaly(i,j,k+1) &
                   -grav_rho0r*(Thickness%dztlo(i,j,k)*rhoprime(i,j,k)+Thickness%dztup(i,j,k+1)*rhoprime(i,j,k+1)) 
                enddo
            endif
         enddo
      enddo
  endif

end function geopotential_anomaly
! </FUNCTION> NAME="geopotential_anomaly"


!#######################################################################
! <SUBROUTINE NAME="press_grad_force_depth_blob">
!
! <DESCRIPTION>
! This routine respects the partition between Eulerian system mass
! and the Lagrangian system mass associated with the Lagrangian blobs
! model.  The pressure gradient from the total (combined Eulerian and 
! Lagrangian systems) is calculated.  Aside from that, the routine is 
! the same as for press_grad_force_depth.
!
! Compute the force from pressure using a finite difference method
! to compute the thickness weighted pressure gradient at the 
! velocity cell point. 
!
! For depth-like vertical coordinates, we exclude surface and applied 
! pressures (i.e., we are computing here the gradient of the baroclinic 
! pressure).  Account is taken of variable partial cell thickness.
! 1 = dp/dx; 2 = dp/dy
!
! Thickness weight since this is what we wish to use in update of 
! the velocity. Resulting thickness weighted pressure gradient has 
! dimensions of Pa = N/m^2 = kg/(m*s^2).
!
! Thickness%dzu should be at tau.
! </DESCRIPTION>
!
subroutine press_grad_force_depth_blob(Time, Thickness, Velocity, L_system, rho)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_velocity_type),      intent(inout) :: Velocity
  type(ocean_lagrangian_type),    intent(inout) :: L_system
  real, dimension(isd:,jsd:,:),   intent(in)    :: rho

  real, dimension(isd:ied,jsd:jed,nk) :: rho_anomup
  real, dimension(isd:ied,jsd:jed,nk) :: rho_anomlo
  real, dimension(isd:ied,jsd:jed) :: diff_geo_x
  real, dimension(isd:ied,jsd:jed) :: diff_geo_y
  real, dimension(isd:ied,jsd:jed) :: tmp1
  real, dimension(isd:ied,jsd:jed) :: tmp2
  real    :: rhoT
  integer :: i, j, k
  integer :: tau, taup1

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_pressure_mod (press_grad_force_depth): module must be initialized')
  endif 

  tau    = Time%tau
  taup1  = Time%taup1
  tmp1   = 0.0
  tmp2   = 0.0
  wrk1_v = 0.0
  wrk2_v = 0.0
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  rho_anomup(:,:,:) = 0.0
  rho_anomlo(:,:,:) = 0.0

  ! use density anomaly to improve accuracy 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           ! Thickness weighted density of upper and lower part of grid box
           wrk2(i,j,k) = Thickness%dztup(i,j,k)*rho(i,j,k) + L_system%rho_dztup(i,j,k)
           wrk3(i,j,k) = Thickness%dztlo(i,j,k)*rho(i,j,k) + L_system%rho_dztlo(i,j,k)
           
           ! Density anomaly of full grid box
           rhoT        = ( wrk2(i,j,k)+wrk3(i,j,k) )/(Thickness%dztT(i,j,k,taup1)+epsln)
           wrk4(i,j,k) = Grd%tmask(i,j,k)*(rhoT - rho0)

           ! Density anomaly of upper and lower part of grid box
           rho_anomup(i,j,k) = Grd%tmask(i,j,k)*( -rho0 + (wrk2(i,j,k)/(Thickness%dztupT(i,j,k)+epsln)) )
           rho_anomlo(i,j,k) = Grd%tmask(i,j,k)*( -rho0 + (wrk3(i,j,k)/(Thickness%dztloT(i,j,k)+epsln)) )
        enddo
     enddo
  enddo
  
  ! compute hydrostatic pressure anomaly at T-point 
  ! ( Pa=N/m^2=kg/(m*s^2) )
  wrk1(:,:,:) = hydrostatic_pressure_blob(Thickness, rho_anomup(:,:,:), rho_anomlo(:,:,:))  

  call diagnose_3d(Time, Grd, id_anompress, wrk1(:,:,:))

  diff_geo_x(:,:) = 0.0
  diff_geo_y(:,:) = 0.0

  do k=1,nk

     do j=jsd,jed
        do i=isd,iec
           diff_geo_x(i,j) = -grav*(Thickness%geodepth_zt(i+1,j,k)-Thickness%geodepth_zt(i,j,k))
        enddo
     enddo
     do j=jsd,jec
        do i=isd,ied
           diff_geo_y(i,j) = -grav*(Thickness%geodepth_zt(i,j+1,k)-Thickness%geodepth_zt(i,j,k))
        enddo
     enddo

     ! density anomaly times geopotential gradient on k-levels 
     ! (dzurhoprime_geograd_x_klev,dzurhoprime_geograd_y_klev)
     tmp1(:,:) = FAY(FAX(wrk4(:,:,k))*diff_geo_x(:,:))
     tmp2(:,:) = FAX(FAY(wrk4(:,:,k))*diff_geo_y(:,:))
     do j=jsc,jec
        do i=isc,iec
           wrk1_v(i,j,k,1) = tmp1(i,j)*Grd%dxur(i,j)*Thickness%dzu(i,j,k)
           wrk1_v(i,j,k,2) = tmp2(i,j)*Grd%dyur(i,j)*Thickness%dzu(i,j,k)
        enddo
     enddo
     if(zero_correction_term_grad) then 
         wrk1_v(:,:,:,:) = 0.0
     endif

     ! gradient of anomalous baroclinic pressure on k-levels 
     ! (dzupgrad_x_klev,dzupgrad_y_klev)
     tmp1(:,:) = FDX_NT(FAY(wrk1(:,:,k)))
     tmp2(:,:) = FDY_ET(FAX(wrk1(:,:,k)))
     do j=jsc,jec
        do i=isc,iec
           wrk2_v(i,j,k,1) = tmp1(i,j)*Thickness%dzu(i,j,k)
           wrk2_v(i,j,k,2) = tmp2(i,j)*Thickness%dzu(i,j,k)
        enddo
     enddo

     if(zero_diagonal_press_grad) then 
         wrk2_v(:,:,:,:) = 0.0
     endif

     ! thickness weighted baroclinic pressure gradient on z-levels
     ! (dzu_pgrad_u,dzu_pgrad_v)
     do j=jsc,jec
        do i=isc,iec    
           Velocity%press_force(i,j,k,1) = -Grd%umask(i,j,k)*( wrk1_v(i,j,k,1) + wrk2_v(i,j,k,1) )
           Velocity%press_force(i,j,k,2) = -Grd%umask(i,j,k)*( wrk1_v(i,j,k,2) + wrk2_v(i,j,k,2) )
        enddo
     enddo

  enddo   ! k do-loop finish 

  ! (dzurhoprime_geograd_x_klev,dzurhoprime_geograd_y_klev)
  call diagnose_3d_u(Time, Grd, id_rhoprime_geograd_klev(1),wrk1_v(:,:,:,1))
  call diagnose_3d_u(Time, Grd, id_rhoprime_geograd_klev(2),wrk1_v(:,:,:,2))

  ! (dzupgrad_x_klev,dzupgrad_y_klev)
  call diagnose_3d_u(Time, Grd, id_pgrad_klev(1), wrk2_v(:,:,:,1))
  call diagnose_3d_u(Time, Grd, id_pgrad_klev(2), wrk2_v(:,:,:,2))

end subroutine press_grad_force_depth_blob
! </SUBROUTINE> NAME="press_grad_force_depth_blob"


!#######################################################################
! <SUBROUTINE NAME="press_grad_force_press_blob">
!
! <DESCRIPTION>
! This routine respects the partition between Eulerian system mass
! and the Lagrangian system mass associated with the Lagrangian blobs
! model.  The pressure gradient from the total (combined Eulerian and 
! Lagrangian systems) system is calculated. Aside from that, the routine 
! is the same as for press_grad_force_press.
!
! Compute the force from pressure using a finite difference method
! to compute the thickness weighted pressure gradient at the 
! velocity cell point. 
!
! For pressure-like vertical coordinates, we omit the bottom pressure
! and bottom geopotential.  Account is taken of variable partial cell
! thickness.  1 = dp/dx; 2 = dp/dy
!
! Thickness weight since this is what we wish to use in update of 
! the velocity. Resulting thickness weighted pressure gradient has 
! dimensions of Pa = N/m^2 = kg/(m*s^2).
!
! Thickness%dzu should be at tau.
!
! </DESCRIPTION>
!
subroutine press_grad_force_press_blob(Time, Thickness, Dens, Velocity, L_system, rho)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_density_type),       intent(in)    :: Dens
  type(ocean_velocity_type),      intent(inout) :: Velocity
  type(ocean_lagrangian_type),    intent(inout) :: L_system
  real, dimension(isd:,jsd:,:),   intent(in)    :: rho

  real, dimension(isd:ied,jsd:jed,nk) :: rho_anomup
  real, dimension(isd:ied,jsd:jed,nk) :: rho_anomlo
  real, dimension(isd:ied,jsd:jed) :: diff_press_x
  real, dimension(isd:ied,jsd:jed) :: diff_press_y
  real, dimension(isd:ied,jsd:jed) :: tmp1
  real, dimension(isd:ied,jsd:jed) :: tmp2
  real    :: rhoT
  integer :: i, j, k
  integer :: tau, taup1

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_pressure_mod (press_grad_force_press): module must be initialized')
  endif 

  tau    = Time%tau
  taup1  = Time%taup1
  tmp1   = 0.0
  tmp2   = 0.0
  wrk1_v = 0.0
  wrk2_v = 0.0
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  rho_anomup(:,:,:) = 0.0
  rho_anomlo(:,:,:) = 0.0

  ! use density anomaly to improve accuracy 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           ! Thickness weighted density of upper and lower part of grid box
           wrk2(i,j,k) = Thickness%dztup(i,j,k)*rho(i,j,k) + L_system%rho_dztup(i,j,k)
           wrk3(i,j,k) = Thickness%dztlo(i,j,k)*rho(i,j,k) + L_system%rho_dztlo(i,j,k)
           
           ! Density anomaly of full grid box
           rhoT        = ( wrk2(i,j,k)+wrk3(i,j,k) )/(Thickness%dztT(i,j,k,taup1)+epsln)
           wrk4(i,j,k) = Grd%tmask(i,j,k)*(rhoT - rho0)

           ! Density anomaly of upper and lower part of grid box
           rho_anomup(i,j,k) = Grd%tmask(i,j,k)*( -rho0 + wrk2(i,j,k)/(Thickness%dztupT(i,j,k)+epsln) )
           rho_anomlo(i,j,k) = Grd%tmask(i,j,k)*( -rho0 + wrk3(i,j,k)/(Thickness%dztloT(i,j,k)+epsln) )
        enddo
     enddo
  enddo

  ! compute geopotential anomaly (m^2/s^2) at T-cell point 
  wrk1(:,:,:) = geopotential_anomaly_blob(Thickness, rho_anomup(:,:,:), rho_anomlo(:,:,:)) 

  call diagnose_3d(Time, Grd, id_anomgeopot, wrk1(:,:,:))

  diff_press_x(:,:) = 0.0
  diff_press_y(:,:) = 0.0

  do k=1,nk

     do j=jsd,jed
        do i=isd,iec
           diff_press_x(i,j) = -dbars2pa*(Dens%pressure_at_depth(i+1,j,k)-Dens%pressure_at_depth(i,j,k))
        enddo
     enddo
     do j=jsd,jec
        do i=isd,ied
           diff_press_y(i,j) = -dbars2pa*(Dens%pressure_at_depth(i,j+1,k)-Dens%pressure_at_depth(i,j,k))
        enddo
     enddo

     ! anomalous density times gradient of pressure on k-level               
     ! (dzurhoprime_pgrad_x_klev,dzurhoprime_pgrad_y_klev)
     tmp1(:,:) = rho0r*FAY(FAX(wrk4(:,:,k))*diff_press_x(:,:))
     tmp2(:,:) = rho0r*FAX(FAY(wrk4(:,:,k))*diff_press_y(:,:))
     do j=jsc,jec
        do i=isc,iec
           wrk1_v(i,j,k,1) = tmp1(i,j)*Grd%dxur(i,j)*Thickness%dzu(i,j,k)
           wrk1_v(i,j,k,2) = tmp2(i,j)*Grd%dyur(i,j)*Thickness%dzu(i,j,k)
        enddo
     enddo

     ! density times gradient of anomalous geopotential on k-level
     ! (dzurho_geogradprime_x_klev,dzurho_geogradprime_y_klev) 
     tmp1(:,:) = FDX_NT(FAY(wrk1(:,:,k)))
     tmp2(:,:) = FDY_ET(FAX(wrk1(:,:,k)))
     do j=jsc,jec
        do i=isc,iec
           wrk2_v(i,j,k,1) = tmp1(i,j)*Thickness%rho_dzu(i,j,k,tau)
           wrk2_v(i,j,k,2) = tmp2(i,j)*Thickness%rho_dzu(i,j,k,tau)
        enddo
     enddo

     ! thickness weighted baroclinic pressure gradient on z-levels
     ! (dzu_pgrad_u,dzu_pgrad_v)
     do j=jsc,jec
        do i=isc,iec    
           Velocity%press_force(i,j,k,1) = -Grd%umask(i,j,k)*( wrk1_v(i,j,k,1) + wrk2_v(i,j,k,1) )
           Velocity%press_force(i,j,k,2) = -Grd%umask(i,j,k)*( wrk1_v(i,j,k,2) + wrk2_v(i,j,k,2) )
        enddo
     enddo

  enddo  ! k do-loop finish 


  ! (dzurhoprime_pgrad_x_klev,dzurhoprime_pgrad_y_klev)
  call diagnose_3d_u(Time, Grd, id_rhoprime_pgrad_klev(1),wrk1_v(:,:,:,1))
  call diagnose_3d_u(Time, Grd, id_rhoprime_pgrad_klev(2),wrk1_v(:,:,:,2))

  ! (dzurho_geogradprime_x_klev,dzurho_geogradprime_y_klev)
  call diagnose_3d_u(Time, Grd, id_rho_geogradprime_klev(1),wrk2_v(:,:,:,1))
  call diagnose_3d_u(Time, Grd, id_rho_geogradprime_klev(2),wrk2_v(:,:,:,2))

end subroutine press_grad_force_press_blob
! </SUBROUTINE> NAME="press_grad_force_press_blob"


!#######################################################################
! <FUNCTION NAME="pressure_in_dbars_blob">
!
! <DESCRIPTION>
! This routine respects the partition between Eulerian system mass
! and the Lagrangian system mass associated with the Lagrangian blobs
! model.  The pressure from the combined system is calculated.
! Aside from that, the routine is the same as for pressure_in_dbars.
!
! Compute pressure (dbars) exerted at T cell grid point by weight of
! water column above the grid point. 
!
! rho = density in kg/m^3
!
! psurf = surface pressure in Pa= kg/(m*s^2) = hydrostatic pressure 
! at z=0 associated with fluid between z=0 and z=eta_t.
! Also include pressure from atmosphere and ice, both of which 
! are part of the patm array. 
!
! This routine is used by ocean_density to compute the pressure 
! used in the equation of state.  It is only called when the 
! vertical coordinate is DEPTH_BASED.
!
! </DESCRIPTION>
function pressure_in_dbars_blob (Thickness, rho, Ldzrhoup, Ldzrholo, psurf)

  type(ocean_thickness_type),   intent(in) :: Thickness
  real, dimension(isd:,jsd:,:), intent(in) :: rho   
  real, dimension(isd:,jsd:,:), intent(in) :: Ldzrhoup
  real, dimension(isd:,jsd:,:), intent(in) :: Ldzrholo
  real, dimension(isd:,jsd:),   intent(in) :: psurf 
  real, dimension(isd:ied,jsd:jed,nk)      :: pressure_in_dbars_blob
  integer :: k

  if ( .not. module_is_initialized ) then   
    call mpp_error(FATAL, &
    '==>Error in ocean_pressure_mod (pressure_in_dbars): module must be initialized')
  endif 

  wrk1(:,:,:) = ( Thickness%dztup(:,:,:)*rho(:,:,:) + Ldzrhoup(:,:,:) )/(Thickness%dztupT(:,:,:) + epsln)
  wrk2(:,:,:) = ( Thickness%dztlo(:,:,:)*rho(:,:,:) + Ldzrholo(:,:,:) )/(Thickness%dztloT(:,:,:) + epsln)

  pressure_in_dbars_blob(:,:,:) = hydrostatic_pressure_blob (Thickness, wrk1(:,:,:), wrk2(:,:,:))*c2dbars

  ! add pressure from free surface height and loading from atmosphere and/or sea ice
  do k=1,nk
     pressure_in_dbars_blob(:,:,k) = pressure_in_dbars_blob(:,:,k) + psurf(:,:)*c2dbars 
  enddo


end function pressure_in_dbars_blob
! </FUNCTION> NAME="pressure_in_dbars_blob"


!#######################################################################
! <FUNCTION NAME="hydrostatic_pressure_blob">
!
! <DESCRIPTION>
! This routine respects the partition between Eulerian system mass
! and the Lagrangian system mass associated with the Lagrangian blobs
! model.  The hydrostatic pressure from the combined system is 
! calculated. Aside from that, the routine is the same as for 
! Hydrostatic_pressure.
!
! Hydrostatic pressure [Pa=N/m^2=kg/(m*s^2)] at T cell grid points.
!
! For GEOPOTENTIAL vertical coordinate, integration is 
! from z=0 to depth of grid point.  This integration results in  
! the so-called "baroclinic" pressure. 
!
! For ZSTAR, vertical coordinate, integration is from z=eta to 
! depth of grid point.  This is allowed because ZSTAR
! absorbs the undulations of the surface height into their definition.
!
! If the input density "rho" is an anomoly, the resulting presure 
! will be a hydrostatic pressure anomoly. If "rho" is full density, 
! the presure will be a full hydrostatic pressure.
!
! </DESCRIPTION>
!
function hydrostatic_pressure_blob (Thickness, rhoup, rholo)

  type(ocean_thickness_type),   intent(in) :: Thickness
  real, dimension(isd:,jsd:,:), intent(in) :: rhoup
  real, dimension(isd:,jsd:,:), intent(in) :: rholo

  integer :: i, j, k
  real, dimension(isd:ied,jsd:jed,nk) :: hydrostatic_pressure_blob

  if(vert_coordinate==GEOPOTENTIAL) then 
      do j=jsd,jed
         do i=isd,ied
            hydrostatic_pressure_blob(i,j,1) = rhoup(i,j,1)*grav*Grd%dzw(0)
         enddo
      enddo
  else !ZSTAR
      do j=jsd,jed
         do i=isd,ied
            hydrostatic_pressure_blob(i,j,1) = rhoup(i,j,1)*grav*Thickness%dzwtT(i,j,0)
         enddo
      enddo
  endif

  if(Thickness%method==ENERGETIC) then 

      do k=2,nk
         do j=jsd,jed
            do i=isd,ied
               hydrostatic_pressure_blob(i,j,k) = hydrostatic_pressure_blob(i,j,k-1) &
               + Grd%tmask(i,j,k)*p5grav                                   &
                *(rholo(i,j,k-1)+rhoup(i,j,k))*Thickness%dzwtT(i,j,k-1) 
            enddo
         enddo
      enddo

  elseif(Thickness%method==FINITEVOLUME) then 

      do k=2,nk
         do j=jsd,jed
            do i=isd,ied
               hydrostatic_pressure_blob(i,j,k) = hydrostatic_pressure_blob(i,j,k-1) &
               + Grd%tmask(i,j,k)*grav                                     &
                *(Thickness%dztloT(i,j,k-1)*rholo(i,j,k-1)+Thickness%dztupT(i,j,k)*rhoup(i,j,k)) 
            enddo
         enddo
      enddo

  endif

  ! For some debugging...we here drop the contribution from a 
  ! nonzero eta in the calculation of hydrostatic_pressure. 
  ! This is wrong physically, but it is useful for certain tests
  ! of the zstar vertical coordinate.  
  if(vert_coordinate==ZSTAR .and. zero_eta_over_h_zstar_pressure) then 
      do j=jsd,jed
         do i=isd,ied
            hydrostatic_pressure_blob(i,j,1) = rhoup(i,j,1)*grav*Thickness%dswt(i,j,0)
         enddo
      enddo
      do k=2,nk
         do j=jsd,jed
            do i=isd,ied
               hydrostatic_pressure_blob(i,j,k) = hydrostatic_pressure_blob(i,j,k-1) &
               + Grd%tmask(i,j,k)*p5grav                                   &
                *(rholo(i,j,k-1)+rhoup(i,j,k))*Thickness%dswt(i,j,k-1) 
            enddo
         enddo
      enddo
  endif 


end function hydrostatic_pressure_blob
! </FUNCTION> NAME="hydrostatic_pressure_blob"



!#######################################################################
! <FUNCTION NAME="geopotential_anomaly_blob">
!
! <DESCRIPTION>
! This routine respects the partition between Eulerian system mass
! and the Lagrangian system mass associated with the Lagrangian blobs
! model.  The geopotential from the combined system is calculated.
! Aside from that, the routine is the same as for geopotential_anomaly.
!
! Geopotential anomaly [m^2/s^2] at T cell grid points.
! Integration here is from z=-H to depth of grid point.  
!
! Input should be density anomaly rhoprime = rho-rho0.
!
! This function is needed when computing pressure gradient
! for PRESSURE_BASED vertical coordinates. 
!
! WARNING: Thickness%method==FINITEVOLUME has been found to be 
! problematic.  It remains under development.  It is NOT 
! supported for general use. 
! 
! </DESCRIPTION>
!
function geopotential_anomaly_blob (Thickness, rhoprimeup, rhoprimelo)

  type(ocean_thickness_type),   intent(in) :: Thickness
  real, dimension(isd:,jsd:,:), intent(in) :: rhoprimeup
  real, dimension(isd:,jsd:,:), intent(in) :: rhoprimelo

  integer :: i, j, k, kbot, kp1
  real, dimension(isd:ied,jsd:jed,nk) :: geopotential_anomaly_blob
  
  geopotential_anomaly_blob(:,:,:) = 0.0

  if(Thickness%method==ENERGETIC) then 
      do j=jsd,jed
         do i=isd,ied
            kbot=Grd%kmt(i,j)
            if(kbot > 1) then  
                k=kbot
                geopotential_anomaly_blob(i,j,k) = -grav_rho0r*rhoprimelo(i,j,k)*Thickness%dztloT(i,j,k)
                do k=kbot-1,1,-1
                   kp1 = k+1
                   geopotential_anomaly_blob(i,j,k) = geopotential_anomaly_blob(i,j,kp1) &
                   -p5grav_rho0r*(rhoprimeup(i,j,kp1)+rhoprimelo(i,j,k))*Thickness%dzwtT(i,j,k)
                enddo
            endif
         enddo
      enddo
  elseif(Thickness%method==FINITEVOLUME) then 
      do j=jsd,jed
         do i=isd,ied
            kbot=Grd%kmt(i,j)
            if(kbot > 1) then
                k=kbot
                geopotential_anomaly_blob(i,j,k) = -grav_rho0r*rhoprimelo(i,j,k)*Thickness%dztloT(i,j,k)
                do k=kbot-1,1,-1
                   kp1 = k+1
                   geopotential_anomaly_blob(i,j,k) = geopotential_anomaly_blob(i,j,kp1) &
                   -grav_rho0r*(Thickness%dztloT(i,j,k)*rhoprimelo(i,j,k)      &
                              + Thickness%dztupT(i,j,kp1)*rhoprimeup(i,j,kp1)) 
                enddo
            endif
         enddo
      enddo
  endif

end function geopotential_anomaly_blob
! </FUNCTION> NAME="geopotential_anomaly_blob"

end module ocean_pressure_mod

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                                   !!
!!                   GNU General Public License                      !!
!!                                                                   !!
!! This file is part of the Flexible Modeling System (FMS).          !!
!!                                                                   !!
!! FMS is free software; you can redistribute it and/or modify       !!
!! it and are expected to follow the terms of the GNU General Public !!
!! License as published by the Free Software Foundation.             !!
!!                                                                   !!
!! FMS is distributed in the hope that it will be useful,            !!
!! but WITHOUT ANY WARRANTY; without even the implied warranty of    !!
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     !!
!! GNU General Public License for more details.                      !!
!!                                                                   !!
!! You should have received a copy of the GNU General Public License !!
!! along with FMS; if not, write to:                                 !!
!!          Free Software Foundation, Inc.                           !!
!!          59 Temple Place, Suite 330                               !!
!!          Boston, MA  02111-1307  USA                              !!
!! or see:                                                           !!
!!          http://www.gnu.org/licenses/gpl.txt                      !!
!!                                                                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
program main
!  
!<CONTACT EMAIL="Matthew.Harrison@noaa.gov"> Matt Harrison
!</CONTACT>
!
!<CONTACT EMAIL="Dave.Bi@csiro.au"> Dave Bi (for OASIS3 hooks)
!</CONTACT>
!
!<REVIEWER EMAIL="Niki.Zadeh@noaa.gov"> Niki Zadeh (for OASIS3 hooks)
!</REVIEWER>
!
!<REVIEWER EMAIL="V.Balaji@noaa.gov"> V. Balaji
!</REVIEWER>
!
!<REVIEWER EMAIL="Stephen.Griffies@noaa.gov"> Stephen Griffies 
!</REVIEWER>
!
!<OVERVIEW>
! Driver for ocean-only simulations and prototype setup for OASIS3 driver.  
!</OVERVIEW>
!
!<DESCRIPTION>
! Driver for the ocean-only simulations. Similar to the FMS coupler, but 
! allows one to run the ocean model without compiling  other models. 
! Much simpler than the full FMS coupler. 
!
! This driver also provides the prototype hooks for using MOM4p1 with OASIS3,
! with this code surrounded by the cpp-preprocessor option "ifdef OASIS3".  
! The couping of MOM4p1 to OASIS3 has not been tested at GFDL. Rather, 
! CSIRO in Australia uses MOM4p1 with OASIS3, with Dave.Bi@csiro.au the primary 
! contact for questions regarding MOM4p1 and OASIS3. 
! </DESCRIPTION>
!
! <NAMELIST NAME="ocean_solo_nml">
!
!  <DATA NAME="n_mask" TYPE="integer">
!    number of region to be masked out. Its value should be less than MAX_PES.
!  </DATA>
!  <DATA NAME="mask_list(2,MAXPES)" TYPE="integer, dimension(MAX_MASK_REGION,2)">
!    The position of the region to be masked out. mask_list(1,:) is the x-layout position
!    and mask_list(2,:) is y-layout position.  
!  </DATA>
!  <DATA NAME="layout_mask" TYPE="integer, dimension(2)">
!   Processor domain layout for all the component model. layout_mask need to be set when and only 
!   when n_mask is greater than 0 ( some domain region is masked out ). When this namelist is set,
!   it will overload the layout in each component model. The default value is (0,0).
!   Currently we require all the component model has the same layout and same grid size.
!  </DATA>
!  <DATA NAME="restart_interval" TYPE="integer, dimension(6)"  DEFAULT="0">
!     The time interval that write out intermediate restart file. The format is (yr,mo,day,hr,min,sec).
!     When restart_interval is all zero, no intermediate restart file will be written out.
!   </DATA>
!
! </NAMELIST>
!

  use constants_mod,            only: constants_init, SECONDS_PER_HOUR
  use data_override_mod,        only: data_override_init, data_override
  use diag_manager_mod,         only: diag_manager_init, diag_manager_end
  use field_manager_mod,        only: field_manager_init
  use fms_mod,                  only: fms_init, fms_end, open_namelist_file, check_nml_error
  use fms_mod,                  only: close_file, file_exist, uppercase
  use fms_io_mod,               only: fms_io_exit
  use mpp_domains_mod,          only: domain2d, mpp_get_compute_domain
  use mpp_io_mod,               only: mpp_open, MPP_RDONLY, MPP_ASCII, MPP_OVERWR, MPP_APPEND, mpp_close, MPP_SINGLE
  use mpp_mod,                  only: mpp_init
  use mpp_mod,                  only: mpp_error, FATAL, NOTE, mpp_pe, mpp_npes, mpp_set_current_pelist, mpp_sync
  use mpp_mod,                  only: stdlog, stdout, mpp_root_pe, mpp_clock_id
  use mpp_mod,                  only: mpp_clock_begin, mpp_clock_end, MPP_CLOCK_SYNC
  use mpp_mod,                  only: MPP_CLOCK_DETAILED, CLOCK_COMPONENT, MAXPES
  use mpp_mod,                  only: mpp_broadcast
  use time_interp_external_mod, only: time_interp_external_init
  use time_manager_mod,         only: set_calendar_type, time_type, increment_date
  use time_manager_mod,         only: set_time, set_date, get_time, get_date, month_name, print_time
  use time_manager_mod,         only: GREGORIAN, JULIAN, NOLEAP, THIRTY_DAY_MONTHS, NO_CALENDAR
  use time_manager_mod,         only: operator( <= ), operator( < ), operator( >= )
  use time_manager_mod,         only: operator( + ),  operator( - ), operator( / )
  use time_manager_mod,         only: operator( * ), operator( /= ), operator( > )
  use time_manager_mod,         only: date_to_string

  use ocean_model_mod,          only: ocean_model_init , update_ocean_model, ocean_model_end
  use ocean_model_mod,          only: ocean_model_restart, ocean_public_type, ocean_state_type
  use ocean_types_mod,          only: ice_ocean_boundary_type
  use ocean_util_mod,           only: write_chksum_2d

  use auscom_ice_parameters_mod, only: redsea_gulfbay_sfix, do_sfix_now, sfix_hours, int_sec
  use accessom2_mod, only : accessom2_type => accessom2
  use coupler_mod, only : coupler_type => coupler

  implicit none

  type (ocean_public_type)               :: Ocean_sfc
  type (ocean_state_type),       pointer :: Ocean_state
  type(ice_ocean_boundary_type), target  :: Ice_ocean_boundary
  type(accessom2_type) :: accessom2
  type(coupler_type) :: coupler

  ! define some time types
  type(time_type) :: Time_init    ! initial time for experiment
  type(time_type) :: Time_start   ! start time for experiment
  type(time_type) :: Time_end     ! end time for experiment (as determined by dtts)
  type(time_type) :: Run_len      ! length of experiment
  type(time_type) :: Time
  type(time_type) :: Time_step_coupled
  type(time_type) :: Time_restart_init
  type(time_type) :: Time_restart
  type(time_type) :: Time_restart_current
  type(time_type) :: Time_last_sfix 
  type(time_type) :: Time_sfix 
  integer :: sfix_seconds

  character(len=17) :: calendar = 'julian'

  integer :: num_cpld_calls  = 0
  integer :: nc
  integer :: calendar_type=-1

  integer :: date_init(6)=0, date(6)
  integer :: date_restart(6)
  integer :: years=0, months=0, days=0, hours=0, minutes=0, seconds=0
  integer :: dt_cpld  = 86400
  integer :: yy, mm, dd, hh, mimi, ss

  integer :: isc,iec,jsc,jec
  integer :: unit, io_status, ierr

  integer :: flags=0
  integer :: init_clock, main_clock, term_clock
  integer :: override_clock, coupler_init_clock
  integer :: nfields 
  
  character(len=256) :: version = ''
  character(len=256) :: tag = ''

  character(len=9) :: month
  character(len=64):: timestamp

  integer :: n, m 
  integer :: layout_mask(2) = (/0 , 0/)
  integer :: n_mask = 0
  integer :: mask_list(2,MAXPES)
  integer, parameter :: mp = 2*MAXPES
  data ((mask_list(n,m),n=1, 2),m=1,MAXPES) /mp*0/
  integer :: restart_interval(6) = (/0,0,0,0,0,0/)
  integer :: mpi_comm_mom
  integer ::  stdoutunit, stdlogunit, tmp_unit
  logical :: debug_this_module
  character(len=1024) :: accessom2_config_dir = '../'
  integer, dimension(6) :: date_array

  namelist /ocean_solo_nml/ n_mask, layout_mask, mask_list, restart_interval, &
                            debug_this_module, accessom2_config_dir

    ! Initialise floating point exception error handler.
    !call fpe_err_handler_init()
  debug_this_module = .false.

  open(newunit=tmp_unit, file='input.nml')
  read(tmp_unit, nml=ocean_solo_nml)
  close(tmp_unit)

  call coupler%init_begin('mom5xx', config_dir=trim(accessom2_config_dir))

  call mpp_init(localcomm=coupler%localcomm)
  init_clock = mpp_clock_id('Initialization')
  main_clock = mpp_clock_id('Main Loop')
  term_clock = mpp_clock_id('Termination')
  call mpp_clock_begin(init_clock)

  call fms_init(coupler%localcomm)

  call constants_init()
  flags = MPP_CLOCK_SYNC

  stdoutunit=stdout();stdlogunit=stdlog()

  ! provide for namelist over-ride
  unit = open_namelist_file('input.nml')
  read  (unit, ocean_solo_nml,iostat=io_status)
  write (stdoutunit,'(/)')
  write (stdoutunit,'(/47x,a/)') '======== MODEL BEING DRIVEN BY OCEAN_SOLO_MOD ========'
  write (stdoutunit, ocean_solo_nml)  
  write (stdlogunit, ocean_solo_nml)
  ierr = check_nml_error(io_status,'ocean_solo_nml')
  call close_file (unit)

  ! set the calendar 
  select case( uppercase(trim(calendar)) )
  case( 'GREGORIAN' )
     calendar_type = GREGORIAN
  case( 'JULIAN' )
     calendar_type = JULIAN
  case( 'NOLEAP' )
     calendar_type = NOLEAP
  case( 'THIRTY_DAY' )
     calendar_type = THIRTY_DAY_MONTHS
  case( 'NO_CALENDAR' )
     calendar_type = NO_CALENDAR
  case default
     call mpp_error(FATAL, &
     'ocean_solo: ocean_solo_nml entry calendar must be one of GREGORIAN|JULIAN|NOLEAP|THIRTY_DAY|NO_CALENDAR.' )
  end select

  ! Initialise libaccessom2
  call accessom2%init('mom5xx', config_dir=trim(accessom2_config_dir))

  if (mpp_pe() == mpp_root_pe()) then
    call accessom2%print_version_info()
  endif

  ! Tell libaccessom2 about any global configs/state

  ! Synchronise accessom2 'state' (i.e. configuration) between all models.
  call accessom2%sync_config(coupler)

  ! Use accessom2 configuration to set calendar
  if (index(accessom2%get_calendar_type(), 'noleap') > 0) then
      calendar_type = NOLEAP
  elseif (index(accessom2%get_calendar_type(), 'gregorian') > 0) then
      calendar_type = GREGORIAN
  else
    call mpp_error(FATAL, 'ocean_solo: unsupported calendar type')
  endif

  ! Use accessom2 configuration to initial date and runtime
  date_init(:) = accessom2%get_cur_exp_date_array()
  dt_cpld = accessom2%get_ice_ocean_timestep()
  years = 0
  months = 0
  days = 0
  hours = 0
  minutes = 0
  seconds = accessom2%get_total_runtime_in_seconds()

  ! get ocean_solo restart : this can override settings from namelist
  if (file_exist('INPUT/ocean_solo.res')) then
      call mpp_open(unit,'INPUT/ocean_solo.res',form=MPP_ASCII,action=MPP_RDONLY)
      read(unit,*) calendar_type
      read(unit,*) date_init
      read(unit,*) date
      call mpp_close(unit)
  endif

  if (file_exist('INPUT/ocean_solo.intermediate.res')) then
      call mpp_open(unit,'INPUT/ocean_solo.intermediate.res',form=MPP_ASCII,action=MPP_RDONLY)
      read(unit,*) date_restart
      call mpp_close(unit)
  else
      date_restart = date_init
  endif

  call set_calendar_type (calendar_type)

  call field_manager_init(nfields)

  call diag_manager_init()

  call time_interp_external_init()

  if (sum(date_init) <= 0) then
      call mpp_error(FATAL,&
      '==>Error from ocean_solo_mod: date_init must be set either in ocean_solo.res or in ocean_solo_nml')
  else
      Time_init  = set_date(date_init(1),date_init(2), date_init(3), &
           date_init(4),date_init(5),date_init(6))
  endif

  if (file_exist('INPUT/ocean_solo.res')) then
      Time_start =  set_date(date(1),date(2),date(3),date(4),date(5),date(6))
  else
      Time_start = Time_init
      date = date_init
  endif

  Time_end          = increment_date(Time_start, years, months, days, hours, minutes, seconds)
  Run_len           = Time_end - Time_start

  Time_step_coupled = set_time(dt_cpld, 0)
  num_cpld_calls    = Run_len / Time_step_coupled
  Time = Time_start

  Time_restart_init = set_date(date_restart(1), date_restart(2), date_restart(3),  &
                               date_restart(4), date_restart(5), date_restart(6) )
  Time_restart_current = Time_start
  if(ALL(restart_interval == 0)) then
     Time_restart = increment_date(Time_end, 1, 0, 0, 0, 0, 0)   ! no intermediate restart
  else
     Time_restart = increment_date(Time_restart_init, restart_interval(1), restart_interval(2), &
        restart_interval(3), restart_interval(4), restart_interval(5), restart_interval(6) )
     if(Time_restart <= Time_start) call mpp_error(FATAL, &
       '==>Error from program ocean_solo: The first intermediate restart time is no larger than the start time')
  end if

  !-----------------------------------------------------------------------
  !------------------- some error checks ---------------------------------
  if ( num_cpld_calls * Time_step_coupled /= Run_len ) call mpp_error(FATAL, &
     '==>Error from program ocean_solo: run length must be multiple of cpld time step', FATAL)

  call mpp_open (unit, 'time_stamp.out', form=MPP_ASCII, action=MPP_APPEND,threading=MPP_SINGLE)

  month = month_name(date(2))
  if ( mpp_pe() == mpp_root_pe() ) write (unit,'(6i4,2x,a3)') date, month(1:3)

  call get_date (Time_end, date(1), date(2), date(3), date(4), date(5), date(6))
  month = month_name(date(2))
  if ( mpp_pe() == mpp_root_pe() ) write (unit,'(6i4,2x,a3)') date, month(1:3)

  call mpp_close (unit)  

  !----- check the value of layout and setup the maskmap for domain layout.
  if( n_mask > 0 ) then
      if( layout_mask(1)*layout_mask(2) - n_mask .NE. mpp_npes() ) call mpp_error(FATAL, &
      '==>Error from program ocean_solo: layout(1)*layout(2) - n_mask should equal to npes when n_mask>0')
      call mpp_error(NOTE, &
      '==>Error from program ocean_solo: layout_mask and mask_list is set in ocean_solo_nml, ' // &
      'the value of layout_mask will override the layout specified in ocean_model_mod')

      allocate(Ocean_sfc%maskmap(layout_mask(1), layout_mask(2)) )
      Ocean_sfc%maskmap = .TRUE.
      do n=1, n_mask
         if (mask_list(1,n) .gt. layout_mask(1) ) &
              call mpp_error( FATAL, &
              'program ocean_solo: mask_list elements outside layout defines.' )
         if (mask_list(2,n) .gt. layout_mask(2) ) &
              call mpp_error( FATAL, &
              'program ocean_solo: mask_list elements outside layout defines.' )
         Ocean_sfc%maskmap(mask_list(1,n),mask_list(2,n)) = .false.
      enddo
  else
      if( layout_mask(1)*layout_mask(2) .NE. 0 ) call mpp_error(NOTE, &
           'program ocean_solo: when no region is masked out, layout_mask need not be set' )
  end if

  call ocean_model_init(Ocean_sfc, Ocean_state, Time_init, Time, &
                        accessom2%get_ice_ocean_timestep())

  if (redsea_gulfbay_sfix) then
    ! This must be called after ocean_model_init so sfix_hours is read in from namelist
    sfix_seconds = sfix_hours * SECONDS_PER_HOUR
    ! Get current model time from Time_init in seconds (must be done like this otherwise
    ! can get an overflow in seconds)
    call get_time(Time-Time_init,seconds=seconds,days=days)
    ! The last sfix time has to be determined from absolute model time, to ensure reproducibility 
    ! across restarts

    ! Current time to nearest hour
    hours = days*24 + int(seconds/SECONDS_PER_HOUR)

    ! Time of last sfix 
    hours = int(hours / sfix_hours) * sfix_hours

    ! Convert to days + hours
    days = int(hours / 24)
    hours = hours - days*24

    Time_last_sfix = set_time(days=int(days),seconds=int(hours*SECONDS_PER_HOUR)) + Time_init
    Time_sfix = set_time(seconds=int(sfix_seconds))

    call print_time(Time_last_sfix,'Time_last_sfix: ')
  end if

  call data_override_init(Ocean_domain_in = Ocean_sfc%domain)

  override_clock = mpp_clock_id('Override', flags=flags,grain=CLOCK_COMPONENT)
  
  call mpp_get_compute_domain(Ocean_sfc%domain, isc, iec, jsc, jec)
  
  allocate ( Ice_ocean_boundary% u_flux (isc:iec,jsc:jec),          &
             Ice_ocean_boundary% v_flux (isc:iec,jsc:jec),          &
             Ice_ocean_boundary% t_flux (isc:iec,jsc:jec),          &
             Ice_ocean_boundary% q_flux (isc:iec,jsc:jec),          &
             Ice_ocean_boundary% salt_flux (isc:iec,jsc:jec),       &
             Ice_ocean_boundary% lw_flux (isc:iec,jsc:jec),         &
             Ice_ocean_boundary% sw_flux_vis_dir (isc:iec,jsc:jec), &
             Ice_ocean_boundary% sw_flux_vis_dif (isc:iec,jsc:jec), &
             Ice_ocean_boundary% sw_flux_nir_dir (isc:iec,jsc:jec), &
             Ice_ocean_boundary% sw_flux_nir_dif (isc:iec,jsc:jec), &
             Ice_ocean_boundary% lprec (isc:iec,jsc:jec),           &
             Ice_ocean_boundary% fprec (isc:iec,jsc:jec),           &
             Ice_ocean_boundary% runoff (isc:iec,jsc:jec),          &
             Ice_ocean_boundary% calving (isc:iec,jsc:jec),         &
             Ice_ocean_boundary% p (isc:iec,jsc:jec),               &
             Ice_ocean_boundary% aice(isc:iec,jsc:jec),             &
             Ice_ocean_boundary% mh_flux(isc:iec,jsc:jec),          &
             Ice_ocean_boundary% wfimelt(isc:iec,jsc:jec),          &
             Ice_ocean_boundary% wfiform(isc:iec,jsc:jec),          &
             Ice_ocean_boundary% licefw(isc:iec,jsc:jec),           &
             Ice_ocean_boundary% liceht(isc:iec,jsc:jec),           &
             Ice_ocean_boundary%wnd(isc:iec,jsc:jec))

  Ice_ocean_boundary%u_flux          = 0.0
  Ice_ocean_boundary%v_flux          = 0.0
  Ice_ocean_boundary%t_flux          = 0.0
  Ice_ocean_boundary%q_flux          = 0.0
  Ice_ocean_boundary%salt_flux       = 0.0
  Ice_ocean_boundary%lw_flux         = 0.0
  Ice_ocean_boundary%sw_flux_vis_dir = 0.0
  Ice_ocean_boundary%sw_flux_vis_dif = 0.0
  Ice_ocean_boundary%sw_flux_nir_dir = 0.0
  Ice_ocean_boundary%sw_flux_nir_dif = 0.0
  Ice_ocean_boundary%lprec           = 0.0
  Ice_ocean_boundary%fprec           = 0.0
  Ice_ocean_boundary%runoff          = 0.0
  Ice_ocean_boundary%calving         = 0.0
  Ice_ocean_boundary%p               = 0.0
  Ice_ocean_boundary%aice            = 0.0
  Ice_ocean_boundary%mh_flux         = 0.0
  Ice_ocean_boundary% wfimelt        = 0.0
  Ice_ocean_boundary% wfiform        = 0.0
  Ice_ocean_boundary%licefw          = 0.0
  Ice_ocean_boundary%liceht          = 0.0
  Ice_ocean_boundary%wnd             = 0.0

  coupler_init_clock = mpp_clock_id('OASIS init', grain=CLOCK_COMPONENT)
  call mpp_clock_begin(coupler_init_clock)
  call external_coupler_sbc_init(Ocean_sfc%domain, dt_cpld, Run_len, &
                                 accessom2%get_coupling_field_timesteps())
  call mpp_clock_end(coupler_init_clock)
  call mpp_clock_end(init_clock)

  ! loop over the coupled calls
  call mpp_clock_begin(main_clock)
  do nc=1, num_cpld_calls

     call external_coupler_sbc_before(Ice_ocean_boundary, Ocean_sfc, nc, dt_cpld)

     call mpp_clock_begin(override_clock)
     call ice_ocn_bnd_from_data(Ice_ocean_boundary)
     call mpp_clock_end(override_clock)

     if (debug_this_module) then
        call write_boundary_chksums(Ice_ocean_boundary)
     endif

    if (redsea_gulfbay_sfix) then
        if ((Time - Time_last_sfix) >= Time_sfix) then
            do_sfix_now = .true.
            Time_last_sfix = Time
        else
            do_sfix_now = .false.
        end if
    end if

     call update_ocean_model(Ice_ocean_boundary, Ocean_state, Ocean_sfc, Time, Time_step_coupled)

     Time = Time + Time_step_coupled
     if ( mpp_pe() == mpp_root_pe() ) then
        call accessom2%progress_date(int(dt_cpld))
     endif

     if( Time >= Time_restart ) then
       Time_restart_current = Time
       Time_restart = increment_date(Time, restart_interval(1), restart_interval(2), &
             restart_interval(3), restart_interval(4), restart_interval(5), restart_interval(6) )
       timestamp = date_to_string(time_restart_current)
        write(stdoutunit,*) '=> NOTE from program ocean_solo: intermediate restart file is written and ', &
             trim(timestamp),' is appended as prefix to each restart file name'
        call ocean_model_restart(Ocean_state, timestamp)
        call ocean_solo_restart(Time, Time_restart_current, timestamp)
     end if

     call external_coupler_sbc_after(Ice_ocean_boundary, Ocean_sfc, nc, dt_cpld )

  enddo
  call mpp_clock_end(main_clock)

  call mpp_clock_begin(term_clock)

  call external_coupler_restart( dt_cpld, num_cpld_calls, Ocean_sfc)

  ! close some of the main components 
  call ocean_model_end(Ocean_sfc, Ocean_state, Time)

  call diag_manager_end(Time)

  ! need to reset pelist before calling mpp_clock_end
  ! call mpp_set_current_pelist()

  ! write restart file
  call ocean_solo_restart(Time_end, Time_restart_current)

  call fms_io_exit

  call coupler%deinit()
  ! Allow libaccessom2 to check that all models are synchronised at the end of
  ! the run.
  call get_date(Time, date_array(1), date_array(2), date_array(3), &
                date_array(4), date_array(5), date_array(6))
  call accessom2%deinit(cur_date_array=date_array)

  call mpp_clock_end(term_clock)

  call fms_end

  call external_coupler_mpi_exit(coupler%localcomm, .true.)

  print *, 'MOM5: --- completed ---'

  contains

  !--- writing restart file that contains running time and restart file writing time.
  subroutine ocean_solo_restart(Time_run, Time_res, time_stamp)
    type(time_type),   intent(in)           :: Time_run, Time_res
    character(len=*),  intent(in), optional :: time_stamp
    character(len=128)                      :: file_run, file_res
    integer :: yr, mon, day, hr, min, sec

    ! write restart file
    if(present(time_stamp)) then
       file_run = 'RESTART/'//trim(time_stamp)//'.ocean_solo.res'
       file_res = 'RESTART/'//trim(time_stamp)//'.ocean_solo.intermediate.res'
    else
       file_run = 'RESTART/ocean_solo.res'
       file_res = 'RESTART/ocean_solo.intermediate.res'
    endif

    call mpp_open( unit, file_run, nohdrs=.TRUE. )
    if ( mpp_pe().EQ.mpp_root_pe() )then
       write( unit, '(i6,8x,a)' )calendar_type, &
            '(Calendar: no_calendar=0, thirty_day_months=1, julian=2, gregorian=3, noleap=4)'

       call get_date(Time_init,yr,mon,day,hr,min,sec)
       write( unit, '(6i6,8x,a)' )yr,mon,day,hr,min,sec, &
            'Model start time:   year, month, day, hour, minute, second'
       call get_date(Time_run ,yr,mon,day,hr,min,sec)
       write( unit, '(6i6,8x,a)' )yr,mon,day,hr,min,sec, &
            'Current model time: year, month, day, hour, minute, second'
    end if
    call mpp_close(unit)

 if(Time_res > Time_start) then
    call mpp_open( unit, file_res, nohdrs=.TRUE. )
    if ( mpp_pe().EQ.mpp_root_pe() )then
       call get_date(Time_res ,yr,mon,day,hr,min,sec)
       write( unit, '(6i6,8x,a)' )yr,mon,day,hr,min,sec, &
            'Current intermediate restart time: year, month, day, hour, minute, second'
    end if
    call mpp_close(unit)     
 end if

end subroutine ocean_solo_restart

!====================================================================
! get forcing data from data_overide 
subroutine ice_ocn_bnd_from_data(x)

      type (ice_ocean_boundary_type) :: x
      type(time_type)                :: Time_next

      Time_next = Time + Time_step_coupled
      call data_override('OCN', 't_flux',          x%t_flux         , Time_next)
      call data_override('OCN', 'u_flux',          x%u_flux         , Time_next)
      call data_override('OCN', 'v_flux',          x%v_flux         , Time_next)
      call data_override('OCN', 'q_flux',          x%q_flux         , Time_next)
      call data_override('OCN', 'salt_flux',       x%salt_flux      , Time_next)
      call data_override('OCN', 'lw_flux',         x%lw_flux        , Time_next)
      call data_override('OCN', 'sw_flux_vis_dir', x%sw_flux_vis_dir, Time_next)
      call data_override('OCN', 'sw_flux_vis_dif', x%sw_flux_vis_dif, Time_next)
      call data_override('OCN', 'sw_flux_nir_dir', x%sw_flux_nir_dir, Time_next)
      call data_override('OCN', 'sw_flux_nir_dif', x%sw_flux_nir_dif, Time_next)
      call data_override('OCN', 'lprec',           x%lprec          , Time_next)
      call data_override('OCN', 'fprec',           x%fprec          , Time_next)
      call data_override('OCN', 'runoff',          x%runoff         , Time_next)
      call data_override('OCN', 'calving',         x%calving        , Time_next)
      call data_override('OCN', 'p',               x%p              , Time_next)
      call data_override('OCN', 'aice',            x%aice           , Time_next)
      call data_override('OCN', 'mh_flux',         x%mh_flux        , Time_next)
    call mpp_sync()
            
end subroutine ice_ocn_bnd_from_data



! Here we provide some hooks for calling an interface between the OASIS3 coupler and MOM.
! The mom_oasis3_interface module is NOT general and it is expected that the user will 
! heavily modify it depending on the coupling strategy.
! For clarity all variables should be passed as arguments rather than as globals.
! This may require changes to the argument lists.

! NOTE: libaccessom2 makes most of these functions redundant.

subroutine external_coupler_sbc_init(Dom, dt_cpld, Run_len, &
                                     coupling_field_timesteps)
    ! Call to routine initializing arrays etc for transferring via coupler
    ! Perform sanity checks and make sure all inputs are compatible
    use mom_oasis3_interface_mod, only : coupler_init
    implicit none
    type(domain2d) :: Dom
    integer :: dt_cpld
    type(time_type) :: Run_len
    integer, dimension(:), intent(in) :: coupling_field_timesteps

    call coupler_init(Dom, dt_cpld=dt_cpld, Run_len=Run_len, &
                      coupling_field_timesteps=coupling_field_timesteps)
end  subroutine external_coupler_sbc_init

subroutine external_coupler_sbc_before(Ice_ocean_boundary, Ocean_sfc, nsteps, dt_cpld )
    ! Perform transfers before ocean time stepping
    ! May need special tratment on first call.

    use mom_oasis3_interface_mod, only : from_coupler, into_coupler 

    implicit none
    type (ice_ocean_boundary_type), intent(INOUT) :: Ice_ocean_boundary
    type (ocean_public_type) , intent(INOUT)        :: Ocean_sfc
    integer , intent(IN)                       :: nsteps, dt_cpld

    integer                        :: rtimestep ! Receive timestep
    integer                        :: stimestep ! Send timestep

    rtimestep = (nsteps-1) * dt_cpld   ! runtime in this run segment!
    stimestep = rtimestep
    call from_coupler( rtimestep, Ocean_sfc, Ice_ocean_boundary )
    call into_coupler( stimestep, Ocean_sfc, before_ocean_update = .true.)
end subroutine external_coupler_sbc_before

subroutine external_coupler_sbc_after(Ice_ocean_boundary, Ocean_sfc, nsteps, dt_cpld )
    !Perform transfers after ocean time stepping

    use mom_oasis3_interface_mod, only : into_coupler

    implicit none
    type (ice_ocean_boundary_type) :: Ice_ocean_boundary
    type (ocean_public_type)         :: Ocean_sfc
    integer                        :: nsteps, dt_cpld

    integer                        :: stimestep ! Send timestep

    stimestep = nsteps * dt_cpld   ! runtime in this run segment!
    if (stimestep < num_cpld_calls*dt_cpld) call into_coupler(stimestep, Ocean_sfc, before_ocean_update = .false.)
end subroutine external_coupler_sbc_after

subroutine external_coupler_restart( dt_cpld, num_cpld_calls, Ocean_sfc)
    !Clean up as appropriate and write a restart
    use mom_oasis3_interface_mod, only : write_coupler_restart
    implicit none
    integer, intent(in)               :: dt_cpld, num_cpld_calls
    integer                           :: timestep
    type (ocean_public_type)         :: Ocean_sfc

    timestep = num_cpld_calls * dt_cpld
    call write_coupler_restart(timestep, Ocean_sfc, write_restart=.true.)
end subroutine external_coupler_restart

subroutine external_coupler_mpi_exit(mom_local_communicator, external_initialization)
    ! mpp_exit wont call MPI_FINALIZE if mom_local_communicator /= MPI_COMM_WORLD
    implicit none
    integer, intent(in) :: mom_local_communicator
    logical, intent(in) :: external_initialization
    integer :: ierr
    call MPI_FINALIZE(ierr)
    return
end subroutine external_coupler_mpi_exit


subroutine write_boundary_chksums(Ice_ocean_boundary)
    type(ice_ocean_boundary_type), intent(in) :: Ice_ocean_boundary

    call write_chksum_2d('Ice_ocean_boundary%u_flux', Ice_ocean_boundary%u_flux)
    call write_chksum_2d('Ice_ocean_boundary%v_flux', Ice_ocean_boundary%v_flux)
    call write_chksum_2d('Ice_ocean_boundary%t_flux', Ice_ocean_boundary%t_flux)
    call write_chksum_2d('Ice_ocean_boundary%q_flux', Ice_ocean_boundary%q_flux)
    call write_chksum_2d('Ice_ocean_boundary%salt_flux', Ice_ocean_boundary%salt_flux)
    call write_chksum_2d('Ice_ocean_boundary%lw_flux', Ice_ocean_boundary%lw_flux)
    call write_chksum_2d('Ice_ocean_boundary%sw_flux_vis_dir', Ice_ocean_boundary%sw_flux_vis_dir)
    call write_chksum_2d('Ice_ocean_boundary%sw_flux_vis_dif', Ice_ocean_boundary%sw_flux_vis_dif)
    call write_chksum_2d('Ice_ocean_boundary%sw_flux_nir_dir', Ice_ocean_boundary%sw_flux_nir_dir)
    call write_chksum_2d('Ice_ocean_boundary%sw_flux_nir_dif', Ice_ocean_boundary%sw_flux_nir_dif)
    call write_chksum_2d('Ice_ocean_boundary%lprec', Ice_ocean_boundary%lprec)
    call write_chksum_2d('Ice_ocean_boundary%fprec', Ice_ocean_boundary%fprec)
    call write_chksum_2d('Ice_ocean_boundary%runoff', Ice_ocean_boundary%runoff)
    call write_chksum_2d('Ice_ocean_boundary%calving', Ice_ocean_boundary%calving)
    call write_chksum_2d('Ice_ocean_boundary%p', Ice_ocean_boundary%p)
    call write_chksum_2d('Ice_ocean_boundary%aice', Ice_ocean_boundary%aice)
    call write_chksum_2d('Ice_ocean_boundary%mh_flux', Ice_ocean_boundary%mh_flux)
    call write_chksum_2d('Ice_ocean_boundary%wfimelt', Ice_ocean_boundary%wfimelt)
    call write_chksum_2d('Ice_ocean_boundary%wfiform', Ice_ocean_boundary%wfiform)
    call write_chksum_2d('Ice_ocean_boundary%wnd', Ice_ocean_boundary%wnd)

end subroutine write_boundary_chksums

end program main

module ocean_vert_tidal_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S. M. Griffies 
!</CONTACT>
!
!<REVIEWER EMAIL="hsimmons@iarc.uaf.edu"> Harper Simmons 
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Hyun-Chul Lee 
!</REVIEWER>
!
!<OVERVIEW>
! This module computes a vertical diffusivity and vertical 
! viscosity deduced from barotropic and baroclinic tidal 
! dissipation.  Assume Prandtl number unity. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes a vertical diffusivity and vertical 
! viscosity deduced from barotropic and baroclinic tidal 
! dissipation. For the baroclinic dissipation, we follow
! Simmons etal, and for the barotropic dissipation we follow 
! Lee etal. Assume Prandtl number unity. 
!
! This code is more general than that in the ocean_vert_kpp_mom4p0_mod.
! The KPP_mom4p0 code remains part of MOM for legacy purposes. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! Simmons, Jayne, St. Laurent, and Weaver, 2004:
! Tidally driven mixing in a numerical model of the ocean 
! general circulation.  Ocean Modelling, vol. 6,
! pages 245-263.
! </REFERENCE>
!
! <REFERENCE>
! Jayne and St. Laurent, 2001:
! Parameterizing tidal dissipation over rough topography.
! Geophysical Research Letters, vol. 28, pages 811-814.
! </REFERENCE>
!
! <REFERENCE>
! Hyun-Chul Lee, A. Rosati, and M.J. Spelman, 2006: 
! Barotropic tidal mixing effects in a coupled climate model:
! ocean conditions in the northern Atlantic
! Ocean Modelling, vol 11, pages 464--477
! </REFERENCE>
!
! <REFERENCE>
! Osborn, T.R., 1980: Estimates of the local rate of vertical diffusion 
! from dissipation measurements.  JPO, vol. 10, pages 83-89.
! </REFERENCE>
!
! <REFERENCE>
! Munk and Anderson, 1948: Notes on a theory of the thermocline. 
! Journal of Marine Research, vol 3. pages 276-295.
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, Elements of MOM (2012)
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_vert_tidal_nml">
!  <DATA NAME="use_this_module=" TYPE="logical">
!  Must be .true. to use this module. Default is false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging purposes.
!  </DATA> 
!
!  <DATA NAME="use_wave_dissipation=" TYPE="logical">
!  Set to .true. for using the Simmons etal scheme for 
!  obtaining a diffusivity and viscosity based on internal 
!  wave breaking.  This is a general form of the KPP 
!  scheme "int_tidal_mix". 
!  Default use_wave_dissipation=.false.
!  </DATA> 
!  <DATA NAME="use_drag_dissipation=" TYPE="logical">
!  Set to .true. for using the Lee etal scheme for 
!  obtaining a diffusivity and viscosity based on drag
!  of barotropic tides on bottom.  This is a general 
!  form of the KPP scheme "coastal_tidal_mix".
!  Default use_drag_dissipation=.false.
!  </DATA> 
!  <DATA NAME="use_leewave_dissipation=" TYPE="logical">
!  Set to .true. for using a prototype Nikurashin scheme for 
!  obtaining a diffusivity and viscosity based on breaking 
!  leewaves. This scheme is not related to tides, but it 
!  is incorporated to the baroclinic tide parameterization scheme
!  as a prototype.  It will be placed into ts own module when 
!  the parameterization matures. 
!  Default use_leewave_dissipation=.false.
!  </DATA> 
!
!  <DATA NAME="read_leewave_dissipation" TYPE="logical">
!  If .true. then read in leewave dissipation from a file. 
!  Default read_leewave_dissipation=.false.
!  </DATA> 
!
!  <DATA NAME="read_wave_dissipation" TYPE="logical">
!  If .true. then read in wave dissipation computed from 
!  Jayne and St.Laurent (2001) tide model (or another model). 
!  Default read_wave_dissipation=.false.
!  </DATA> 
!  <DATA NAME="fixed_wave_dissipation" TYPE="logical">
!  If .true. then fix the wave dissipation from that 
!  read in by the tide model, such as Jayne and St.Laurent (2001).
!  This power dissipation will be employed
!  for computing wave induced mixing.  
!  Default fixed_wave_dissipation=.false.
!  </DATA> 
!
!  <DATA NAME="read_roughness" TYPE="logical">
!  If .true. then read in bottom roughness amplitude h, 
!  where roughness_length = kappa*h^2, with kappa a 
!  representative roughness wavelength and h a  
!  representative topographic amplitude.  This information is 
!  used for the Simmons etal wave dissipation parameterization.  
!  </DATA> 
!  <DATA NAME="reading_roughness_length" TYPE="logical">
!  If .true., then the field in the roughness file is 
!  roughness_length = kappa*h^2, with kappa a 
!  representative roughness wavelength and h a  
!  representative topographic amplitude.  This information is 
!  used for the Simmons etal wave dissipation parameterization.  
!  Default reading_roughness_length=.false.
!  </DATA> 
!  <DATA NAME="reading_roughness_amp" TYPE="logical">
!  If .true., then the field in the roughness file is 
!  roughness_amp=h, where roughness_length=kappa*h^2.
!  This information is used for the Simmons etal wave
!  dissipation parameterization.  
!  Default reading_roughness_amp=.false.
!  </DATA> 
!  <DATA NAME="default_roughness_length" UNITS="m"  TYPE="real">
!  Default value for kappa*h^2 = roughness length for use 
!  in the absence of a roughness length dataset. MOM default
!  is default_roughness_length=25.0m.
!  </DATA> 
!
!  <DATA NAME="read_tide_speed" TYPE="logical">
!  If .true. then read in tidal speed (m/s) from a tidal model.   
!  This information is used for the computing the energy dissipation 
!  from tides.
!  scheme.  
!  </DATA> 
!  <DATA NAME="tide_speed_data_on_t_grid" TYPE="logical">
!  To set the input tide speed data on T-grid, set to true.
!  Otherwise, set to false.
!  Default tide_speed_data_on_t_grid=.true.
!  </DATA> 
!
!  <DATA NAME="roughness_scale" UNITS="m"  TYPE="real">
!  Scale for the roughness that characterizes the roughness
!  affecting the tidal dissipation process. Used for setting 
!  roughness_length via roughness_length = kappa*h^2, with 
!  kappa = 2pi/(roughness_scale) and h=topography amplitude. 
!  Default roughness_scale=1e4 as in Jayne and St. Laurent (2001)
!  </DATA> 
!  <DATA NAME="default_tide_speed" UNITS="m/s"  TYPE="real">
!  Default value for tidal speed for use in the absence of a 
!  value from a tidal model. 
!  </DATA> 
!  <DATA NAME="speed_min" UNITS="m/s"  TYPE="real">
!  For the drag scheme, we set the diffusivity as well as the 
!  Richardson number to zero if the tide speed is less than 
!  speed_min.  This serves two purposes: 1/ to reduce overflows
!  in some of the diagnostics; 2/ to set the drag induced diffusivity
!  to zero in regions where the tide speed is small. Default
!  speed_min=5e-3m/s. 
!  </DATA> 
!
!  <DATA NAME="shelf_depth_cutoff" UNITS="m" TYPE="real">
!  For use in defining a mask for the Simmons scheme, with depths
!  shallower than shelf_depth_cutoff removed from the scheme. 
!  shelf_depth_cutoff=1000m in Simmons etal.  
!  Default shelf_depth_cutoff=-1000m so there is no cutoff. 
!  </DATA> 
!
!  <DATA NAME="decay_scale" UNITS="m"  TYPE="real">
!  In the Simmons etal vertical profile function, the exponential decay 
!  scale is determined by this parameter.  Default = 500m as in Simmons 
!  etal (2004).  This vertical profile determines how to deposit the 
!  internal wave energy within a vertical column. 
!  </DATA> 
!
!  <DATA NAME="tidal_diss_efficiency" UNITS="dimensionless"  TYPE="real">
!  Fraction of barotropic tidal energy that is dissipated locally, as 
!  opposed to that which propagates away.  Default=1/3 as in 
!  Simmons etal (2004).
!  </DATA> 
!
!  <DATA NAME="mixing_efficiency" UNITS="dimensionless"  TYPE="real">
!  Fraction of energy that is dissipated which is converted into dianeutral 
!  diffusion of tracer.  Default=0.2 based on Osborn (1980).
!  </DATA> 
!  <DATA NAME="mixing_efficiency_n2depend" TYPE="logical">
!  Allow for mixing efficiency to be a function of 
!  N^2/(N^2+Omega^2), which is close to unity except in 
!  regions where N is very small. 
!  Default mixing_efficiency_n2depend=.false.
!  </DATA> 
!
!  <DATA NAME="wave_energy_flux_max" UNITS="W/m2"  TYPE="real">
!  The maximum mechanical energy from internal tides that is 
!  provided for mixing.  Default wave_energy_flux_max=0.1Watt/m^2. 
!  </DATA> 
!
!  <DATA NAME="wave_diffusivity_monotonic" TYPE="logical">
!  Enforce a monotonic decay of the wave dissipation diffusivity,
!  with largest values near bottom and smaller as move to shallower
!  water.  This behaviour is not guaranteed in general, since the 
!  division by the buoyancy frequency can give non-monotone diffusivities.  
!  Default wave_diffusivity_monotonic=.true. 
!  </DATA> 
!
!  <DATA NAME="munk_anderson_p" UNITS="dimensionless" TYPE="real">
!  The p constant in the Munk-Anderson scheme employed by Lee etal. 
!  This parameter is minus the "p_tide" parameter in the KPP schemes. 
!  Default munk_anderson_p=0.25
! </DATA> 
!  <DATA NAME="munk_anderson_sigma" UNITS="dimensionless" TYPE="real">
!  The sigma constant in the Munk-Anderson scheme employed by Lee etal. 
!  This parameter is called "sigma_tide" in the KPP schemes. 
!  Default munk_anderson_sigma=3.0
! </DATA> 
!  <DATA NAME="drag_dissipation_use_cdbot" TYPE="logical">
!  For using the cdbot_array computed from ocean_bbc.F90 module.  
!  Default drag_dissipation_use_cdbot=.false., as this is consistent 
!  with earlier simulations.  
! </DATA> 
!  <DATA NAME="bottom_drag_cd" UNITS="dimensionless" TYPE="real">
!  Bottom drag coefficient from Lee etal. Default bottom_drag_cd=2.4e-3 
! </DATA> 
!
!  <DATA NAME="background_diffusivity" UNITS="m^2/s"  TYPE="real">
!  Background vertical diffusivity not accounted for by the tidal schemes
!  nor any other scheme such as KPP.  Default=0.1e-4. 
!  </DATA> 
!  <DATA NAME="background_viscosity" UNITS="m^2/s"  TYPE="real">
!  Background vertical viscosity not accounted for by the tidal schemes
!  nor any other scheme such as KPP.  Default=0.1e-4. 
!  </DATA> 
!  <DATA NAME="max_wave_diffusivity" UNITS="m^2/s"  TYPE="real">
!  Maximum tracer diffusivity deduced from the wave dissipation
!  scheme from Simmons etal. Default = 5.e-3 m^2/sec.
!  </DATA> 
!
!  <DATA NAME="max_drag_diffusivity" UNITS="m^2/s"  TYPE="real">
!  Maximum tracer diffusivity deduced from the drag dissipation scheme
!  from Lee etal. Default = 5.e-3 m^2/sec.
!  </DATA> 
!  <DATA NAME="drag_dissipation_efold" TYPE="logical">
!  For setting an efolding whereby the drag dissipation diffusivity 
!  exponentially decreases as move upward in the water column.    
!  There are good reasons to set this logical to true, as the scheme 
!  can produce unreasonably large diffusivities far from the bottom, if 
!  there are tides in the deep ocean. 
!  Default drag_dissipation_efold=.true. 
!  </DATA> 
!  <DATA NAME="drag_dissipation_tide_period" UNITS="s"  TYPE="real">
!  Characteristic tide period for use in computing efolding depth for
!  the tide drag scheme.  Default = 12*60*60 = 12hours for semi-diurnal tide.
!  </DATA> 
!  <DATA NAME="drag_mask_deep" TYPE="logical">
!  For masking out the deep ocean regions for the drag dissipation
!  scheme.  This scheme is meant to apply only in shallow shelves,
!  so it is physically relevant to mask it out.  We apply a mask as
!  determined by the ratio of the frictional tide depth scale and the 
!  total ocean depth.    
!  Default drag_mask_deep=.true. 
!  </DATA> 
!  <DATA NAME="drag_mask_deep_ratio" TYPE="real">
!  For determining the drag dissipation mask.
!  The mask = 0 in regions where 
!  tide_depth/total_depth < drag_mask_deep_ratio
!  Default drag_mask_deep_ratio=0.1 
!  </DATA> 
!  <DATA NAME="smooth_ri_drag_cgrid" TYPE="logical">
!  For smoothing the raw C-grid Richardson number computed for
!  the drag scheme on the Cgrid. Default smooth_ri_drag_cgrid=.true.
!  </DATA> 
!
!  <DATA NAME="use_legacy_methods" TYPE="logical">
!  To compute all mixing coefficients using legacy methods. 
!  There are good reasons to prefer the newer approaches, which motivates 
!  setting the default use_legacy_methods=.false.
!  </DATA> 
!  <DATA NAME="drhodz_min" UNITS="kg/m^3"  TYPE="real">
!  Minimum absolute value for the drhodz used to compute N^2 and rhoN2.
!  This value is needed in order to regularize the diffusivity computed
!  from the tide mixing schemes. Default is drhodz_min=1e-10, which 
!  is much smaller than the (N^2)min = 10^-8 sec^-2 used by Simmons 
!  etal. There is some sensitivity to the choice of drhodz_min, with 
!  larger values leading to reduced deep diffusivities, due to the 
!  N^-2 dependence in the diffusivity calculation. 
!  </DATA> 
!  <DATA NAME="smooth_bvfreq_bottom" TYPE="logical">
!  For smoothing the buoyancy frequency at the bottom.
!  Default smooth_bvfreq_bottom=.true.
!  </DATA> 
!  <DATA NAME="vel_micom_smooth" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM Laplacian mixing 
!  coefficient used in the Laplacian smoothing of diffusivities. 
!  Default vel_micom_smooth=0.2.
!  </DATA>
!
!  <DATA NAME="smooth_rho_N2" TYPE="logical">
!  For smoothing the rho_N2 field via a 1-2-1 filter in 
!  vertical.  This is useful to produce smoother diffusivities. 
!  Default is smooth_rho_N2=.true.
!  </DATA> 
!  <DATA NAME="num_121_passes" TYPE="integer">
!  Number of passes of 1-2-1 filter in vertical for 
!  smoothing the rho_N2 field. Default num_121_passes=1.
!  </DATA> 
!
!</NAMELIST>

use constants_mod,     only: pi, epsln
use diag_manager_mod,  only: register_diag_field, register_static_field
use fms_mod,           only: write_version_number, open_namelist_file, close_file, check_nml_error
use fms_mod,           only: stdout, stdlog, read_data, NOTE, FATAL, WARNING
use mpp_domains_mod,   only: mpp_update_domains, NUPDATE, EUPDATE
use mpp_mod,           only: input_nml_file, mpp_error

use ocean_domains_mod,    only: get_local_indices
use ocean_operators_mod,  only: LAP_T
use ocean_parameters_mod, only: MOM_BGRID, MOM_CGRID 
use ocean_parameters_mod, only: missing_value, onehalf, onefourth
use ocean_parameters_mod, only: von_karman, rho0, rho0r, omega_earth, grav
use ocean_types_mod,      only: ocean_time_type, ocean_domain_type, ocean_grid_type, ocean_options_type
use ocean_types_mod,      only: ocean_prog_tracer_type, ocean_thickness_type, ocean_density_type, ocean_velocity_type 
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3, wrk1_2d
use ocean_util_mod,       only: diagnose_2d, diagnose_3d, diagnose_2d_u, diagnose_3d_u

implicit none

private

! for diagnostics 
integer :: id_tide_speed_wave    =-1
integer :: id_tide_speed_drag    =-1
integer :: id_tide_speed_mask    =-1
integer :: id_roughness_length   =-1
integer :: id_roughness_amp      =-1
integer :: id_roughness_klevel   =-1
integer :: id_energy_flux        =-1
integer :: id_power_waves        =-1
integer :: id_leewave_dissipation=-1
integer :: id_power_diss_wave    =-1
integer :: id_power_diss_drag    =-1
integer :: id_power_diss_tides   =-1
integer :: id_power_diss_leewave =-1
integer :: id_rinumber_drag      =-1
integer :: id_drag_dissipation   =-1
integer :: id_bvfreq_bottom      =-1
integer :: id_mix_efficiency     =-1
integer :: id_bvfreq             =-1
integer :: id_diff_cbt_wave      =-1
integer :: id_diff_cbt_drag      =-1
integer :: id_diff_cbt_leewave   =-1
integer :: id_diff_cbt_tides     =-1
integer :: id_visc_cbt_wave      =-1
integer :: id_visc_cbt_drag      =-1
integer :: id_visc_cbt_leewave   =-1
integer :: id_visc_cbt_tides     =-1
integer :: id_visc_cbu_wave      =-1
integer :: id_visc_cbu_leewave   =-1
integer :: id_visc_cbu_drag      =-1
integer :: id_visc_cbu_tides     =-1
integer :: id_drag_diss_efold    =-1
integer :: id_tide_diff_cbt_back =-1
integer :: id_tide_visc_cbu_back =-1
logical :: used

#include <ocean_memory.h>

real, private, dimension(:,:),   allocatable :: smooth_lap          !2D array of micom diffusivities (m^2/sec) for smoothing
real, private, dimension(:,:),   allocatable :: roughness_amp       ! roughness amplitude (m) from topography
real, private, dimension(:,:),   allocatable :: roughness_length    ! roughness length (m) from topography
real, private, dimension(:,:),   allocatable :: wave_dissipation    ! wave dissipation (W/m2) from tide model 
real, private, dimension(:,:),   allocatable :: leewave_dissipation ! leewave dissipation (W/m2) 
real, private, dimension(:,:),   allocatable :: tide_speed_t        ! T-cell speed (m/s) from barotropic tide model 
real, private, dimension(:,:),   allocatable :: tide_speed_u        ! U-cell speed (m/s) from barotropic tide model 
real, private, dimension(:,:),   allocatable :: tide_speed_mask     ! U-cell mask for when tide speed=0
real, private, dimension(:,:),   allocatable :: rescaled_speed_u    ! U-cell speed (m/s) for Lee etal calculation of Ri
real, private, dimension(:,:),   allocatable :: rescaled_speed_t    ! T-cell speed (m/s) for Lee etal calculation of Ri
real, private, dimension(:,:),   allocatable :: efold_depth_r       ! T-cell inverse efold depth (1/m) for Lee etal
real, private, dimension(:,:),   allocatable :: energy_flux         ! energy flux (W/m^2) out of ext-tide to int-tide
real, private, dimension(:,:),   allocatable :: wave_term           ! static term in wave energy flux calculation
real, private, dimension(:,:),   allocatable :: bvfreq_bottom       ! buoyancy frequency (sec^-1) at ocean bottom  

real, private, dimension(:,:,:), allocatable :: mix_efficiency      ! dimensionless mixing efficiency 
real, private, dimension(:,:,:), allocatable :: bvfreq              ! buoyancy frequency (sec^-1) 
real, private, dimension(:,:,:), allocatable :: rho_N2              ! rho*squared buoyancy frequency (kg/m^3)*(sec^-2) 
real, private, dimension(:,:,:), allocatable :: drhodT              ! partial rho / partial temperature 
real, private, dimension(:,:,:), allocatable :: drhodS              ! partial rho / partial salinity 
real, private, dimension(:,:,:), allocatable :: diff_drag           ! diffusivity (m^2/sec) from drag mixing scheme 
real, private, dimension(:,:,:), allocatable :: diff_wave           ! diffusivity (m^2/sec) from wave mixing scheme 
real, private, dimension(:,:,:), allocatable :: diff_leewave        ! diffusivity (m^2/sec) from leewave mixing scheme 
real, private, dimension(:,:),   allocatable :: tmask_deep          ! nonzero for points deeper than shelf_depth_cutoff

logical, private, dimension(:),  allocatable :: skip_row            ! false if any point in i-direction needs computing for Lee et al scheme

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

character(len=128)  :: version='$$'
character (len=128) :: tagname = '$Name: tikal $'

public vert_mix_tidal 
public ocean_vert_tidal_init

private vert_mix_wave
private vert_mix_drag_bgrid 
private vert_mix_drag_cgrid 
private vert_mix_drag_legacy 
private compute_bvfreq

integer :: index_temp=-1
integer :: index_salt=-1 

! for Bgrid or Cgrid
integer :: horz_grid

real :: p5rho0
real :: decay_scale_inv
real :: sqrt_cd
real :: von_karman_inv
real :: dtime 
real :: roughness_kappa
real :: omega_earth2 

logical :: module_is_initialized  = .false.

! nml parameters 

logical :: use_this_module             = .false.
logical :: use_legacy_methods          = .false.  
logical :: debug_this_module           = .false. 
logical :: use_wave_dissipation        = .false.
logical :: use_drag_dissipation        = .false.
logical :: use_leewave_dissipation     = .false.
logical :: read_roughness              = .false.
logical :: read_wave_dissipation       = .false. 
logical :: read_leewave_dissipation    = .false. 
logical :: reading_roughness_amp       = .false.
logical :: reading_roughness_length    = .false.
logical :: read_tide_speed             = .false.
logical :: wave_diffusivity_monotonic  = .true.
logical :: tide_speed_data_on_t_grid   = .true.
logical :: fixed_wave_dissipation      = .false.
logical :: mixing_efficiency_n2depend  = .false. 
logical :: drag_dissipation_efold      = .true.
logical :: smooth_bvfreq_bottom        = .true.  
logical :: drag_mask_deep              = .true.
logical :: smooth_ri_drag_cgrid        = .true. 

logical :: smooth_rho_N2            = .true.   ! for smoothing the rho_N2 field in vertical with 1-2-1
integer :: num_121_passes           = 1        ! number of 1-2-1 passes 

real    :: drag_mask_deep_ratio         = 0.1 
real    :: roughness_scale              = 85e3     ! (metre)
real    :: default_roughness_length     = 25.0     ! (metre)
real    :: default_tide_speed           = .01      ! (m/s)
real    :: shelf_depth_cutoff           = -1000.0  ! (metre)
real    :: decay_scale                  = 500.0    ! (metre)
real    :: tidal_diss_efficiency        = 0.33333  ! (dimensionless) from Simmons etal 
real    :: mixing_efficiency            = 0.2      ! (dimensionless) from Osborne
real    :: munk_anderson_p              = 0.25     ! (dimensionless) from Munk and Anderson 
real    :: munk_anderson_sigma          = 3.0      ! (dimensionless) from Munk and Anderson 
real    :: bottom_drag_cd               = 2.4e-3   ! (dimensionless) bottom drag from Lee etal
real    :: background_diffusivity       = 0.1e-4   ! (m^2/sec)
real    :: background_viscosity         = 0.1e-4   ! (m^2/sec)
real    :: max_wave_diffusivity         = 5.0e-3   ! (m^2/sec)
real    :: max_drag_diffusivity         = 5.0e-3   ! (m^2/sec)
real    :: drhodz_min                   = 1.e-10   ! (kg/m^4) minimum abs(drhodz) used to compute N^2 
real    :: speed_min                    = 5.e-3    ! (m/s) below which set a mask=0 for drag mixing diffusivity 
real    :: wave_energy_flux_max         = 0.1      ! (W/m^2) 
real    :: drag_dissipation_tide_period = 43200.   ! seconds   
real    :: vel_micom_smooth             = 0.2      ! m/sec for smoothing 
logical :: drag_dissipation_use_cdbot   = .false.  ! for using cdbot_array from ocean_bbc 


namelist /ocean_vert_tidal_nml/ use_this_module, use_legacy_methods, debug_this_module,         &
                                use_wave_dissipation, use_drag_dissipation,                     & 
                                read_roughness, read_tide_speed,                                &
                                default_roughness_length, default_tide_speed,                   &
                                shelf_depth_cutoff, decay_scale, roughness_scale,               &
                                tidal_diss_efficiency, mixing_efficiency,                       &
                                mixing_efficiency_n2depend,                                     &
                                munk_anderson_p, munk_anderson_sigma,                           &
                                drag_dissipation_efold, drag_dissipation_tide_period,           &
                                drag_mask_deep, drag_mask_deep_ratio,                           &    
                                bottom_drag_cd, drhodz_min, speed_min,                          &
                                background_diffusivity, background_viscosity,                   &
                                max_wave_diffusivity, max_drag_diffusivity,                     &
                                smooth_bvfreq_bottom, vel_micom_smooth,                         & 
                                smooth_rho_N2, num_121_passes, wave_diffusivity_monotonic,      &
                                tide_speed_data_on_t_grid,                                      &
                                reading_roughness_amp, reading_roughness_length,                &
                                read_wave_dissipation, fixed_wave_dissipation,                  &
                                wave_energy_flux_max,                                           &
                                use_leewave_dissipation, read_leewave_dissipation,              &
                                drag_dissipation_use_cdbot               

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_vert_tidal_init">
!
! <DESCRIPTION>
! Initialization for the ocean_vert_tidal module.
! </DESCRIPTION>
  subroutine ocean_vert_tidal_init(Grid, Domain, Time, T_prog, Velocity, Ocean_options, dtime_t, vert_mix_scheme, hor_grid)
  
    type(ocean_grid_type),        intent(in), target :: Grid
    type(ocean_domain_type),      intent(in), target :: Domain
    type(ocean_time_type),        intent(in)         :: Time
    type(ocean_prog_tracer_type), intent(in)         :: T_prog(:)
    type(ocean_velocity_type),    intent(in)         :: Velocity
    type(ocean_options_type),     intent(inout)      :: Ocean_options 
    real,                         intent(in)         :: dtime_t 
    character(len=10),            intent(in)         :: vert_mix_scheme
    integer,                      intent(in)         :: hor_grid

    real    :: active_cells, temporary 
    integer :: unit, io_status, ierr
    integer :: i,j,n
    integer :: roughness_has_been_read=0

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

    if ( module_is_initialized ) then 
      call mpp_error(FATAL,&
      '==>Error from ocean_vert_tidal_mod (ocean_vert_tidal_init) module already initialized')
    endif 

    module_is_initialized = .TRUE.

    call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_vert_tidal_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_vert_tidal_nml')
#else
    unit = open_namelist_file()
    read(unit, ocean_vert_tidal_nml,iostat=io_status)
    ierr = check_nml_error(io_status, 'ocean_vert_tidal_nml')
    call close_file(unit)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit,ocean_vert_tidal_nml)    
    write (stdlogunit,ocean_vert_tidal_nml)

    Dom => Domain
    Grd => Grid
    dtime = dtime_t 

#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
    nk = Grid%nk
#endif

    if(use_this_module) then 
      call mpp_error(NOTE, '==>Note: USING ocean_vert_tidal_mod')
    else 
      call mpp_error(NOTE, '==>Note: NOT using ocean_vert_tidal_mod')
      Ocean_options%tidal_wave_mix = 'Did NOT use tidal wave mixing option for vertical mixing.'
      Ocean_options%tidal_drag_mix = 'Did NOT use tidal drag mixing option for vertical mixing.'
      return 
    endif 

    decay_scale_inv = 1.0/decay_scale
    p5rho0          = 0.5*rho0
    sqrt_cd         = sqrt(bottom_drag_cd)
    von_karman_inv  = 1.0/von_karman
    roughness_kappa = 2.0*pi/roughness_scale   
    omega_earth2    = omega_earth**2
    horz_grid       = hor_grid

    do n=1, size(T_prog(:))
       if (T_prog(n)%name == 'temp') index_temp = n
       if (T_prog(n)%name == 'salt') index_salt = n
    enddo

    ! allocate arrays needed for buoyancy frequency 
    allocate (mix_efficiency(isd:ied,jsd:jed,nk))
    allocate (bvfreq_bottom(isd:ied,jsd:jed))
    allocate (bvfreq(isd:ied,jsd:jed,nk))
    allocate (rho_N2(isd:ied,jsd:jed,nk))
    allocate (drhodT(isd:ied,jsd:jed,nk))
    allocate (drhodS(isd:ied,jsd:jed,nk))
    allocate (diff_drag(isd:ied,jsd:jed,nk))
    allocate (diff_wave(isd:ied,jsd:jed,nk))
    allocate (diff_leewave(isd:ied,jsd:jed,nk))
    allocate (tmask_deep(isd:ied,jsd:jed))
    mix_efficiency  = 0.0
    bvfreq_bottom   = 0.0
    bvfreq          = 0.0
    rho_N2          = 0.0
    drhodT          = 0.0
    drhodS          = 0.0
    diff_drag       = 0.0
    diff_wave       = 0.0
    diff_leewave    = 0.0
    tmask_deep(:,:) = Grd%tmask(:,:,1)

    allocate (smooth_lap(isd:ied,jsd:jed))
    allocate (wave_term(isd:ied,jsd:jed))
    allocate (energy_flux(isd:ied,jsd:jed))
    allocate (wave_dissipation(isd:ied,jsd:jed))
    allocate (leewave_dissipation(isd:ied,jsd:jed))
    allocate (roughness_length(isd:ied,jsd:jed))
    allocate (roughness_amp(isd:ied,jsd:jed))
    allocate (tide_speed_t(isd:ied,jsd:jed))
    allocate (tide_speed_u(isd:ied,jsd:jed))
    allocate (tide_speed_mask(isd:ied,jsd:jed))
    allocate (rescaled_speed_u(isd:ied,jsd:jed))
    allocate (rescaled_speed_t(isd:ied,jsd:jed))
    allocate (efold_depth_r(isd:ied,jsd:jed))
    allocate (skip_row(jsd:jed))
    smooth_lap(:,:)          = Grd%tmask(:,:,1)*vel_micom_smooth*2.0*Grd%dxt(:,:)*Grd%dyt(:,:)/(Grd%dxt(:,:)+Grd%dyt(:,:))
    roughness_length(:,:)    = Grd%tmask(:,:,1)*default_roughness_length
    roughness_amp(:,:)       = sqrt(Grd%tmask(:,:,1)/roughness_kappa)
    tide_speed_t(:,:)        = Grd%tmask(:,:,1)*default_tide_speed
    tide_speed_u(:,:)        = Grd%umask(:,:,1)*default_tide_speed
    tide_speed_mask(:,:)     = 0.0
    rescaled_speed_u(:,:)    = 0.0
    rescaled_speed_t(:,:)    = 0.0
    efold_depth_r(:,:)       = 0.0
    wave_term(:,:)           = 0.0
    energy_flux(:,:)         = 0.0
    wave_dissipation(:,:)    = 0.0
    leewave_dissipation(:,:) = 0.0
    skip_row             = .false.

    if(use_wave_dissipation) then 
        write (stdoutunit,'(a)') &
             'Using Simmons etal scheme to compute dia-surface diffusivity and viscosity based on internal wave breaking.'
        Ocean_options%tidal_wave_mix = 'Used tidal wave mixing option for vertical mixing.'
    else
        write(stdoutunit,'(a)') 'NOT using Simmons etal scheme for dia-surface diffusivity and viscosity.'
        Ocean_options%tidal_wave_mix = 'Did NOT use tidal wave mixing option for vertical mixing.'
    endif

    if(use_drag_dissipation) then 
        write (stdoutunit,'(a)') &
        'Using Lee etal scheme to compute dia-surface diffusivity and viscosity based on barotropic tide drag on bottom.'
        Ocean_options%tidal_drag_mix = 'Used tidal drag mixing option for vertical mixing.'
        if(vert_mix_scheme == 'kpp_mom4p0') then 
            write (stdoutunit,'(a)') &
            '===>WARNING: Using kpp_mom4p0, where Lee etal scheme can be enabled. Be sure not to double count!!!'
        endif
    else
        write(stdoutunit,'(a)') 'NOT using Lee etal scheme from ocean_vert_tidal_mod for dia-surface mixing.'
        Ocean_options%tidal_drag_mix = 'Did NOT use tidal drag mixing option for vertical mixing.'
    endif

    if(use_leewave_dissipation) then 
        write (stdoutunit,'(a)') &
             'Using prototype for Nikurashin scheme to compute dia-surface diff and visc from breaking leewaves.'
        Ocean_options%leewave_mix = 'Using prototype for leewave mixing option for vertical mixing.'
    else
        write(stdoutunit,'(a)') 'NOT using Nikurashin scheme for dia-surface diffusivity and viscosity.'
        Ocean_options%leewave_mix = 'Did NOT use prototype breaking leewave paramaterization of vertical mixing.'
    endif

    if(.not. use_drag_dissipation .and. .not. use_wave_dissipation) then
        call mpp_error(WARNING, &
        '==>ocean_vert_tidal: No dissipation mechanism is set to determine dia-surface mixing.')
    endif

    if(.not. use_wave_dissipation .and. use_leewave_dissipation) then
        call mpp_error(WARNING, &
        '==>ocean_vert_tidal: The prototype leewave mixing scheme must run with use_wave_dissipation=.true.')
    endif

    ! read in topographic amplitude ("h" in "kappa*h^2" from Simmons etal 2004) on T-grid 
    if(read_roughness) then 
        if(reading_roughness_length) then 
           roughness_has_been_read=roughness_has_been_read+1
           call read_data('INPUT/roughness_length.nc','roughness_length', roughness_length, Domain%domain2d)
           write (stdoutunit,*) '==>ocean_vert_tidal_mod: Completed read of topographic roughness length on T-grid.'
           call mpp_update_domains(roughness_length(:,:), Dom%domain2d) 
           roughness_amp(:,:) = sqrt(roughness_length(:,:)/roughness_kappa)
        endif 
        if(reading_roughness_amp) then 
           roughness_has_been_read=roughness_has_been_read+1
           call read_data('INPUT/roughness_amp.nc','roughness_amp', roughness_amp, Domain%domain2d)
           write (stdoutunit,*) '==>ocean_vert_tidal_mod: Completed read of topographic roughness amplitude on T-grid.'
           call mpp_update_domains(roughness_amp(:,:), Dom%domain2d) 
           roughness_length(:,:) = roughness_kappa*roughness_amp(:,:)*roughness_amp(:,:)
        endif 
        if(roughness_has_been_read > 1) then 
           call mpp_error(FATAL, &
             '==>ocean_vert_tidal_mod: Read in both roughness_amp & roughness_length. Check to be sure what you wish.')
        endif 
        if(roughness_has_been_read==0) then 
           call mpp_error(FATAL, &
             '==>ocean_vert_tidal_mod: To read roughness, reading_roughness_amp or reading_roughness_length must be true.')
        endif 
    else
        write(stdoutunit,'(a)') &
             '==>Note: NOT reading topographic roughness_length for ocean_vert_tidal_mod.'
    endif

    if(read_wave_dissipation) then 
           call read_data('INPUT/wave_dissipation.nc','wave_dissipation', wave_dissipation, Domain%domain2d)
           write (stdoutunit,*) '==>ocean_vert_tidal_mod: Completed read of wave dissipation (W/m^2) on T-grid.'
           call mpp_update_domains(wave_dissipation(:,:), Dom%domain2d) 
    else 
        write(stdoutunit,'(a)') &
             '==>Note: NOT reading wave dissipation for ocean_vert_tidal_mod.'
    endif 

    if(read_leewave_dissipation) then 
        call read_data('INPUT/leewave_dissipation.nc','leewave_dissipation', leewave_dissipation, Domain%domain2d)
        write (stdoutunit,*) '==>ocean_vert_tidal_mod: Completed read of leewave dissipation (W/m^2) on T-grid.'
        call mpp_update_domains(leewave_dissipation(:,:), Dom%domain2d) 
    else 
        write(stdoutunit,'(a)') &
             '==>Note: NOT reading leewave dissipation for ocean_vert_tidal_mod.'
    endif

    ! read tidal speed (m/s) from a tide model, such as the
    ! Global Inverse Solution TPX06.0 created by OSU.
    if(read_tide_speed) then 
        if(tide_speed_data_on_t_grid) then 
           call read_data('INPUT/tideamp.nc','tideamp', tide_speed_t, Domain%domain2d)
           write (stdoutunit,*) '==>ocean_vert_tidal_mod: Completed read of tide_speed on T-grid.'
           call mpp_update_domains(tide_speed_t(:,:), Dom%domain2d) 
        else 
           call read_data('INPUT/tideamp.nc','tideamp', tide_speed_u, Domain%domain2d)
           write (stdoutunit,*) '==>ocean_vert_tidal_mod: Completed read of tide_speed on U-grid.'
           call mpp_update_domains(tide_speed_u(:,:), Dom%domain2d) 
        endif 
    else
        write(stdoutunit,'(a)') &
             '==>Note: NOT reading tide_speed for ocean_vert_tidal_mod.'
        call mpp_error(NOTE, &
             '==>ocean_vert_tidal_mod: Setting tide_speed to default value.')
    endif

    ! map tide speed onto U-cell by 4-point average 
    if(tide_speed_data_on_t_grid) then 
        do j=jsc,jec
           do i=isc,iec
              tide_speed_u(i,j) = onefourth*Grd%umask(i,j,1)     &
                   *(tide_speed_t(i,j)   + tide_speed_t(i+1,j)   &
                    +tide_speed_t(i,j+1) + tide_speed_t(i+1,j+1)) 
           enddo
        enddo
        call mpp_update_domains(tide_speed_u(:,:), Dom%domain2d) 
    endif

    ! speed scale for tides rubbing against bottom 
    ! (defined following eq. (3) in Lee etal)
    if(drag_dissipation_use_cdbot) then 
        write(stdoutunit,'(a)') &
        '==>Note from ocean_vert_tidal: using cdbot_array(i,j) for tide drag_dissipation scheme.'
       do j=jsd,jed
          do i=isd,ied
             rescaled_speed_u(i,j) = sqrt(Velocity%cdbot_array(i,j))*von_karman_inv*tide_speed_u(i,j)
             rescaled_speed_t(i,j) = sqrt(Velocity%cdbot_array(i,j))*von_karman_inv*tide_speed_t(i,j)
             tide_speed_mask(i,j)  = 0.0 
             if(rescaled_speed_u(i,j) > speed_min) then 
                tide_speed_mask(i,j) = 1.0 
             endif 
          enddo
       enddo
    else 
        write(stdoutunit,'(a)') &
        '==>Note from ocean_vert_tidal: using constant bottom drag coefficient for tide drag_dissipation scheme.'
       do j=jsd,jed
          do i=isd,ied
             rescaled_speed_u(i,j) = sqrt_cd*von_karman_inv*tide_speed_u(i,j)
             rescaled_speed_t(i,j) = sqrt_cd*von_karman_inv*tide_speed_t(i,j)
             tide_speed_mask(i,j)  = 0.0 
             if(rescaled_speed_u(i,j) > speed_min) then 
                tide_speed_mask(i,j) = 1.0 
             endif 
          enddo
       enddo
    endif



    ! compute efolding depth scale for use in Lee etal scheme. 
    ! efold depth set as rescaled_speed/(radial tide frequency). 
    ! Choose default radial tide frequency as 2pi/12hrs for semi-diurnal tide.  
    ! let this efolding hold whether using Bgrid or Cgrid.  
    wrk1_2d(:,:) = 0.0
    do j=jsc,jec
       do i=isc,iec
          active_cells =   Grd%umask(i,j,1)   + Grd%umask(i-1,j,1) &
                         + Grd%umask(i,j-1,1) + Grd%umask(i-1,j-1,1) + epsln
          temporary    = (rescaled_speed_u(i,j)   + rescaled_speed_u(i-1,j) + &
                          rescaled_speed_u(i,j-1) + rescaled_speed_u(i-1,j-1))/active_cells
          wrk1_2d(i,j)       = Grd%tmask(i,j,1)*temporary*drag_dissipation_tide_period/(2.0*pi)
          efold_depth_r(i,j) = Grd%tmask(i,j,1)/(wrk1_2d(i,j) + epsln) 
       enddo
    enddo

    ! mask out the deep ocean regions for the drag scheme.  
    if(drag_mask_deep .and. .not. use_legacy_methods) then
        do j=jsc,jec
           do i=isc,iec
              if(Grd%tmask(i,j,1) == 1.0) then 
                  temporary = wrk1_2d(i,j)/(epsln+Grd%ht(i,j))
                  if(temporary > drag_mask_deep_ratio) then 
                      tide_speed_mask(i,j) = 1.0 
                  else 
                      tide_speed_mask(i,j) = 0.0
                  endif
              endif
           enddo
        enddo
        call mpp_update_domains(tide_speed_mask(:,:), Dom%domain2d) 
    endif

    skip_row = all(tide_speed_mask==0.0,dim=1)

    ! compute static piece of the energy flux on T-grid for wave diffusivity 
    do j=jsd,jed
       do i=isd,ied
          wave_term(i,j) = Grd%tmask(i,j,1)*p5rho0*roughness_length(i,j)*tide_speed_t(i,j)**2
       enddo
    enddo

    ! diagnostics 

    id_tide_diff_cbt_back = -1
    id_tide_diff_cbt_back = register_static_field ('ocean_model', 'tide_diff_cbt_back',     &
                     Grid%tracer_axes(1:3), 'static background diff_cbt set in tide module',&
                     'm^2/s',missing_value=missing_value, range=(/-10.0,1e6/))
    if (id_tide_diff_cbt_back > 0) then 
        wrk1(:,:,:) = background_diffusivity*Grid%tmask(:,:,:)
        call diagnose_3d(Time, Grd, id_tide_diff_cbt_back, wrk1(:,:,:))
    endif

    id_tide_visc_cbu_back = -1
    id_tide_visc_cbu_back = register_static_field ('ocean_model', 'tide_visc_cbu_back',     &
                     Grid%vel_axes_wu(1:3), 'static background visc_cbu set in tide module',&
                     'm^2/s',missing_value=missing_value, range=(/-10.0,1e6/))
    if (id_tide_visc_cbu_back > 0) then 
        wrk1(:,:,:) = background_viscosity*Grid%umask(:,:,:)
        call diagnose_3d_u(Time, Grd, id_tide_visc_cbu_back, wrk1(:,:,:))
    endif

    ! e-folding depth for drag dissipation scheme 
    id_drag_diss_efold = register_static_field ('ocean_model', 'drag_diss_efold',&
         Grid%tracer_axes(1:2), 'e-folding depth for drag dissipation scheme',   &
         'm', missing_value=missing_value, range=(/-1.0,1e10/))
    call diagnose_2d(Time, Grd, id_drag_diss_efold, wrk1_2d(:,:))

    ! static input of leewave breaking from Nikurashin
    id_leewave_dissipation = register_static_field ('ocean_model', 'leewave_dissipation',&
         Grid%tracer_axes(1:2), 'specified energy flux input from breaking leewaves',    &
         'W/m^2', missing_value=missing_value, range=(/-1e1,1e15/))
    call diagnose_2d(Time, Grd, id_leewave_dissipation, leewave_dissipation(:,:))

    ! tide speed for breaking internal wave dissipation scheme
    id_tide_speed_wave = register_static_field ('ocean_model', 'tide_speed_wave',                     &
         Grid%tracer_axes(1:2), 'tide speed from tide model for breaking internal wave mixing scheme',&
         'm/s', missing_value=missing_value, range=(/-1e1,1e9/))
    call diagnose_2d(Time, Grd, id_tide_speed_wave, tide_speed_t(:,:))

    ! tide speed scale for barotropic bottom drag dissipation scheme 
    id_tide_speed_drag = register_static_field ('ocean_model', 'tide_speed_drag',              &
         Grid%vel_axes_uv(1:2), 'tide speed from tide model for barotropic drag mixing scheme',&  
         'm/s', missing_value=missing_value, range=(/-1e1,1e9/))
    call diagnose_2d_u(Time, Grd, id_tide_speed_drag, rescaled_speed_u(:,:))

    ! static tide speed mask
    id_tide_speed_mask = register_static_field ('ocean_model', 'tide_speed_mask',           &
         Grid%vel_axes_uv(1:2), 'mask based on tide_speed_drag for barotropic drag mixing', &
         'dimensionless', missing_value=missing_value, range=(/-1e1,1e1/))
    call diagnose_2d_u(Time, Grd, id_tide_speed_mask, tide_speed_mask(:,:))

    ! static roughness amplitude 
    id_roughness_amp = register_static_field ('ocean_model', 'roughness_amp',                  &
         Grid%tracer_axes(1:2), 'roughness amplitude for breaking internal wave mixing scheme',&
         'metre', missing_value=missing_value, range=(/-1e1,1e9/))
    call diagnose_2d(Time, Grd, id_roughness_amp, roughness_amp(:,:))

    ! static roughness length 
    id_roughness_length = register_static_field ('ocean_model', 'roughness_length',         &
         Grid%tracer_axes(1:2), 'roughness length for breaking internal wave mixing scheme',&
         'metre', missing_value=missing_value, range=(/-1e1,1e9/))
    call diagnose_2d(TIme, Grd, id_roughness_length, roughness_length(:,:))


    id_roughness_klevel = register_diag_field ('ocean_model', 'roughness_klevel',                    &
         Grid%tracer_axes(1:2), Time%model_time,                                                     &
         'klevel at top of the bottom layer defined by roughness amplitude for internal tide mixing',&
         'dimensionless', missing_value=missing_value, range=(/-1.0,1.e10/))
    id_energy_flux = register_diag_field ('ocean_model', 'energy_flux',        &
         Grid%tracer_axes(1:2), Time%model_time,                               &
         'energy flux out of barotropic tides for use w/ internal tide mixing',&
         'W/m^2', missing_value=missing_value, range=(/-1e9,1e9/))
    id_power_waves = register_diag_field ('ocean_model', 'power_waves',                           &
         Grid%tracer_axes(1:2), Time%model_time, 'power from barotropic tides to internal tides', &
         'Watt', missing_value=missing_value, range=(/-1e15,1e15/))

    id_power_diss_leewave = register_diag_field ('ocean_model', 'power_diss_leewave',                     &
         Grid%tracer_axes(1:3), Time%model_time, 'power dissipation from mixing due to breaking leewaves',&
         'W/m^2', missing_value=missing_value, range=(/-1e15,1e15/))
    id_power_diss_wave = register_diag_field ('ocean_model', 'power_diss_wave',                         &
         Grid%tracer_axes(1:3), Time%model_time, 'power dissipation from internal wave induced mixing', &
         'W/m^2', missing_value=missing_value, range=(/-1e15,1e15/))
    id_power_diss_drag = register_diag_field ('ocean_model', 'power_diss_drag',                 &
         Grid%tracer_axes(1:3), Time%model_time, 'power dissipation from barotropic tide drag', &
         'W/m^2', missing_value=missing_value, range=(/-1e15,1e15/))
    id_power_diss_tides = register_diag_field ('ocean_model', 'power_diss_tides',& 
         Grid%tracer_axes(1:3), Time%model_time,                                 &
         'power dissipation from barotropic tide drag and baroclinic wave drag', &
         'W/m^2', missing_value=missing_value, range=(/-1e15,1e15/),             &
          standard_name='tendency_of_ocean_potential_energy_content_due_to_tides')

    id_mix_efficiency = register_diag_field ('ocean_model', 'mix_efficiency',                                  &
         Grid%tracer_axes(1:3), Time%model_time, 'efficiency of internal wave dissipation going to mix tracer',&
         'dimensionless', missing_value=missing_value, range=(/-1e5,1e5/))
    id_bvfreq_bottom = register_diag_field ('ocean_model', 'bvfreq_bottom',                     &
         Grid%tracer_axes(1:2), Time%model_time, 'absolute Brunt-Vaisala freq at ocean bottom', &
         's^-1', missing_value=missing_value, range=(/-1e1,1e9/))
    id_bvfreq = register_diag_field ('ocean_model', 'bvfreq',                                         &
         Grid%tracer_axes(1:3), Time%model_time, 'absolute Brunt-Vaisala freq at tracer cell bottom', &
         's^-1', missing_value=missing_value, range=(/-1e1,1e9/))
    id_rinumber_drag = register_diag_field ('ocean_model', 'rinumber_drag',         &
         Grid%tracer_axes(1:3), Time%model_time, 'Richardson number from Lee etal', &
         'dimensionless', missing_value=missing_value, range=(/-1e1,1e18/))
    id_diff_cbt_wave = register_diag_field ('ocean_model', 'diff_cbt_wave',                             &
         Grid%tracer_axes(1:3), Time%model_time, 'diffusivity from breaking internal wave dissipation', &
         'm^2/sec', missing_value=missing_value, range=(/-1.0,1e6/))
    id_diff_cbt_leewave = register_diag_field ('ocean_model', 'diff_cbt_leewave',      &
         Grid%tracer_axes(1:3), Time%model_time, 'diffusivity from breaking leewaves', &
         'm^2/sec', missing_value=missing_value, range=(/-1.0,1e6/))
    id_diff_cbt_drag = register_diag_field ('ocean_model', 'diff_cbt_drag',                             &
         Grid%tracer_axes(1:3), Time%model_time, 'diffusivity from drag of barotropic tides on bottom', &
         'm^2/sec', missing_value=missing_value, range=(/-1.0,1e6/))

    id_visc_cbt_wave = register_diag_field ('ocean_model', 'visc_cbt_wave',                           &
         Grid%tracer_axes(1:3), Time%model_time, 'viscosity from breaking internal wave dissipation', &
         'm^2/sec', missing_value=missing_value, range=(/-1.0,1e6/))
    id_visc_cbt_leewave = register_diag_field ('ocean_model', 'visc_cbt_leewave',    &
         Grid%tracer_axes(1:3), Time%model_time, 'viscosity from breaking leewaves', &
         'm^2/sec', missing_value=missing_value, range=(/-1.0,1e6/))
    id_visc_cbt_drag = register_diag_field ('ocean_model', 'visc_cbt_drag',                           &
         Grid%tracer_axes(1:3), Time%model_time, 'viscosity from drag of barotropic tides on bottom', &
         'm^2/sec', missing_value=missing_value, range=(/-1.0,1e6/))

    id_visc_cbu_wave = register_diag_field ('ocean_model', 'visc_cbu_wave',                           &
         Grid%vel_axes_uv(1:3), Time%model_time, 'viscosity from breaking internal wave dissipation', &
         'm^2/sec', missing_value=missing_value, range=(/-1.0,1e6/))
    id_visc_cbu_leewave = register_diag_field ('ocean_model', 'visc_cbu_leewave',     &
         Grid%vel_axes_uv(1:3), Time%model_time, 'viscosity from breaking leewaves ', &
         'm^2/sec', missing_value=missing_value, range=(/-1.0,1e6/))
    id_visc_cbu_drag = register_diag_field ('ocean_model', 'visc_cbu_drag',                           &
         Grid%vel_axes_uv(1:3), Time%model_time, 'viscosity from drag of barotropic tides on bottom', &
         'm^2/sec', missing_value=missing_value, range=(/-1.0,1e6/))
    id_diff_cbt_tides = register_diag_field ('ocean_model', 'diff_cbt_tides',                                      &
         Grid%tracer_axes(1:3), Time%model_time, 'diffusivity from drag of barotropic tides on bottom + wave drag',&
         'm^2/sec', missing_value=missing_value, range=(/-1.0,1e6/),                                               &
         standard_name='ocean_vertical_tracer_diffusivity_due_to_tides')
    id_visc_cbt_tides = register_diag_field ('ocean_model', 'visc_cbt_tides',                                    &
         Grid%tracer_axes(1:3), Time%model_time, 'viscosity from drag of barotropic tides on bottom + wave drag',&
         'm^2/sec', missing_value=missing_value, range=(/-1.0,1e6/),                                             &
         standard_name='ocean_vertical_tracer_diffusivity_due_to_tides')
    id_visc_cbu_tides = register_diag_field ('ocean_model', 'visc_cbu_tides',                                    &
         Grid%vel_axes_uv(1:3), Time%model_time, 'viscosity from drag of barotropic tides on bottom + wave drag',&
         'm^2/sec', missing_value=missing_value, range=(/-1.0,1e6/),                                             &
         standard_name='ocean_vertical_momentum_diffusivity_due_to_tides')


end subroutine ocean_vert_tidal_init
! </SUBROUTINE> NAME="ocean_vert_tidal_init"


!#######################################################################
! <SUBROUTINE NAME="vert_mix_tidal">
!
! <DESCRIPTION>
! This subroutine computes vertical tracer diffusivity and viscosity
! based on one or both of the following dissipation mechanisms:
!
! 1. internal wave breaking as parameterized by Simmons etal.
!
! 2. barotropic tides feeling the bottom drag, as parameterized by 
!    Lee etal.  
!
! </DESCRIPTION>
!
  subroutine vert_mix_tidal(Time, Thickness, T_prog, Dens, diff_cbt, visc_cbu, visc_cbt, &
                      diff_cbt_wave, diff_cbt_leewave, diff_cbt_drag)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_prog_tracer_type),   intent(in)    :: T_prog(:)
  type(ocean_density_type),       intent(in)    :: Dens
  real, dimension(isd:,jsd:,:,:), intent(inout) :: diff_cbt
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbu
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbt
  real, dimension(isd:,jsd:,:),   intent(inout) :: diff_cbt_wave
  real, dimension(isd:,jsd:,:),   intent(inout) :: diff_cbt_leewave
  real, dimension(isd:,jsd:,:),   intent(inout) :: diff_cbt_drag

  integer :: i, j, k, kp1
  real    :: tmp 

  if(.not. use_this_module) return 

  if(use_legacy_methods) then

      call compute_bvfreq_legacy(Time, Thickness, T_prog, Dens)
      if(use_wave_dissipation)  then 
          call vert_mix_wave_legacy(Time, Thickness, diff_cbt, visc_cbu, visc_cbt, diff_cbt_wave)
      endif
      if(use_drag_dissipation)  then
          call vert_mix_drag_legacy(Time, Thickness, diff_cbt, visc_cbu, visc_cbt, diff_cbt_drag)
      endif
      diff_cbt_leewave(:,:,:) = 0.0
      diff_leewave(:,:,:)     = 0.0
      
  else 

      call compute_bvfreq(Time, Thickness, Dens)
      if(use_wave_dissipation)  then 
          call vert_mix_wave(Time, Thickness, Dens, diff_cbt, visc_cbu, visc_cbt, diff_cbt_wave, diff_cbt_leewave)
      endif
      if(use_drag_dissipation .and. horz_grid == MOM_BGRID)  then
          call vert_mix_drag_bgrid(Time, Thickness, diff_cbt, visc_cbu, visc_cbt, diff_cbt_drag)
      endif
      if(use_drag_dissipation .and. horz_grid == MOM_CGRID)  then
          call vert_mix_drag_cgrid(Time, Thickness, diff_cbt, visc_cbu, visc_cbt, diff_cbt_drag)
      endif

  endif

  ! add the background diffusivity and viscosity 
  do k=1,nk
     kp1 = min(k+1,nk)
     do j=jsc,jec
        do i=isc,iec
          diff_cbt(i,j,k,1) = Grd%tmask(i,j,kp1)*(diff_cbt(i,j,k,1) + background_diffusivity)
          diff_cbt(i,j,k,2) = Grd%tmask(i,j,kp1)*(diff_cbt(i,j,k,2) + background_diffusivity)
          visc_cbt(i,j,k)   = Grd%tmask(i,j,kp1)*(visc_cbt(i,j,k)   + background_viscosity)
          visc_cbu(i,j,k)   = Grd%umask(i,j,kp1)*(visc_cbu(i,j,k)   + background_viscosity)
        enddo
     enddo
  enddo

  ! compute power dissipated by mixing against stratification 
  if(id_power_diss_wave  > 0 .or. id_power_diss_drag    > 0 .or. &
     id_power_diss_tides > 0 .or. id_power_diss_leewave > 0 ) then 
      wrk1(:,:,:) = 0.0
      wrk2(:,:,:) = 0.0
      wrk3(:,:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               tmp = Thickness%dzt(i,j,k)*rho_N2(i,j,k)*Grd%tmask(i,j,k)
               wrk1(i,j,k) = tmp*diff_wave(i,j,k) 
               wrk2(i,j,k) = tmp*diff_drag(i,j,k) 
               wrk3(i,j,k) = tmp*diff_leewave(i,j,k) 
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_power_diss_wave, wrk1(:,:,:))
      call diagnose_3d(Time, Grd, id_power_diss_drag, wrk2(:,:,:))
      call diagnose_3d(Time, Grd, id_power_diss_leewave, wrk3(:,:,:))
      if (id_power_diss_tides > 0) then 
         call diagnose_3d(Time, Grd, id_power_diss_tides, wrk1(:,:,:)+wrk2(:,:,:))
      endif
  endif

  if (id_diff_cbt_tides > 0) then 
     call diagnose_3d(Time, Grd, id_diff_cbt_tides, diff_cbt_wave(:,:,:)+diff_cbt_drag(:,:,:))
  endif 

  ! recall unit Prandtl number 
  if (id_visc_cbt_tides > 0) then  
     call diagnose_3d(Time, Grd, id_visc_cbt_tides, diff_cbt_wave(:,:,:)+diff_cbt_drag(:,:,:))
  endif 

  if (id_visc_cbu_tides > 0) then
      wrk1=0.0
      do k=1,nk-1
         kp1=k+1
         do j=jsc,jec
            do i=isc,iec
               wrk1(i,j,k)          = Grd%umask(i,j,kp1)*onefourth  &
                   *(diff_cbt_wave(i,j,k)  +diff_cbt_wave(i+1,j,k)  &
                    +diff_cbt_wave(i,j+1,k)+diff_cbt_wave(i+1,j+1,k)&
                    +diff_cbt_drag(i,j,k)  +diff_cbt_drag(i+1,j,k)  &
                    +diff_cbt_drag(i,j+1,k)+diff_cbt_drag(i+1,j+1,k))
            enddo
         enddo
      enddo
      call diagnose_3d_u(Time, Grd, id_visc_cbu_tides, wrk1(:,:,:))
  endif


end subroutine vert_mix_tidal
! </SUBROUTINE> NAME="vert_mix_tidal"



!#######################################################################
! <SUBROUTINE NAME="compute_bvfreq">
!
! <DESCRIPTION>
! This subroutine computes the absolute value of rho*N^2 and abs of 
! N^2, with N^2 the squared Brunt-Vaisala (or buoyancy) frequency. 
!
! </DESCRIPTION>
!
  subroutine compute_bvfreq(Time, Thickness, Dens)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_density_type),     intent(in) :: Dens

  real    :: bottom
  real    :: tmp, rho_N2_prev
  integer :: i, j, k, m, kbot
  integer :: tau

  tau                = Time%tau
  wrk1(:,:,:)        = 0.0
  wrk2(:,:,:)        = 0.0
  bvfreq_bottom(:,:) = 0.0
  

  ! absolute(rho*N^2) computed from ocean_density module calculation. 
  ! use the value at T-cell centre as this produces a smoother and
  ! better behaved bvfreq near the bottom, than does drhodz_wt. 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           rho_N2(i,j,k) = max(0.0,-grav*Dens%drhodz_zt(i,j,k)*Grd%tmask(i,j,k)) 
        enddo
     enddo
  enddo

  ! smooth rho_N2 in the vertical using a 1-2-1 filter
  if (smooth_rho_N2) then
      do m=1,num_121_passes
         do j=jsd,jed
            do i=isd,ied
               rho_N2_prev = onefourth*rho_N2(i,j,1)
               kbot=Grd%kmt(i,j)
               if (kbot>3) then
                   do k=2,kbot-2
                      tmp           = rho_N2(i,j,k)
                      rho_N2(i,j,k) = rho_N2_prev + onehalf*rho_N2(i,j,k) + onefourth*rho_N2(i,j,k+1)
                      rho_N2_prev   = onefourth*tmp
                   enddo
               endif
            enddo
         enddo
      enddo
  endif

  ! compute absolute value of buoyancy frequency, 
  ! using rho0r as an approximation to 1/rho.  
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           bvfreq(i,j,k) = sqrt(rho0r*rho_N2(i,j,k))
        enddo
     enddo
  enddo

  ! determine k-level at top of the bottom roughness boundary layer  
  wrk1_2d(:,:) = 0.0
  do j=jsd,jed
     do i=isd,ied
        kbot                  = Grd%kmt(i,j)
        if(kbot > 1) then 
            bottom = Thickness%depth_zwt(i,j,kbot)
            kloop: do k=kbot,1,-1
               tmp = Thickness%depth_zwt(i,j,k) + roughness_amp(i,j)
               if(tmp <= bottom) then 
                   wrk1_2d(i,j)          = k
                   exit kloop
               endif
            enddo  kloop
        endif
     enddo
  enddo

  
  ! set bvfreq in bottom equal to value at kmt-1  
  do j=jsd,jed
     do i=isd,ied
        bvfreq_bottom(i,j) = 0.0
        if(Grd%kmt(i,j) > 1) then 
            kbot=Grd%kmt(i,j)-1
            bvfreq_bottom(i,j) = bvfreq(i,j,kbot)
        endif
     enddo
  enddo

  ! horizontal laplacian smoothing on the bottom bvfreq
  if(smooth_bvfreq_bottom) then 
     bvfreq_bottom(:,:) = bvfreq_bottom(:,:) + dtime*LAP_T(bvfreq_bottom(:,:),smooth_lap(:,:))
     call mpp_update_domains(bvfreq_bottom(:,:), Dom%domain2d,flags=NUPDATE+EUPDATE)  !RASF Only ever need NE values
  endif 


  ! diagnostics 
  call diagnose_2d(TIme, Grd, id_roughness_klevel, wrk1_2d(:,:))
  call diagnose_2d(Time, Grd, id_bvfreq_bottom, bvfreq_bottom(:,:))
  call diagnose_3d(Time, Grd, id_bvfreq, bvfreq(:,:,:))


end subroutine compute_bvfreq
! </SUBROUTINE> NAME="compute_bvfreq"



!#######################################################################
! <SUBROUTINE NAME="vert_mix_wave">
!
! <DESCRIPTION>
! This subroutine computes dia-surface tracer diffusivity based on the 
! methods of Simmons et al., which consider dissipation from breaking
! internal gravity waves and their conversion into local dia-surface
! mixing, which is parameterized as diffusion.  
!
! Also compute a prototype parameterization of mixing due to 
! breaking leewaves from Nikurashin. 
!
! We assume a unit Prandtl number.
!
! Note that if umask(i,j,k) is 1.0, then so is 
! tmask(i,j,k), tmask(i+1,j,k), tmask(i,j+1,k), and tmask(i+1,j+1,k).
! So there is no need to compute the "active_cells" when doing the 
! space average to go from t-cell to u-cell to compute visc_cbu.
!
! </DESCRIPTION>
!
  subroutine vert_mix_wave(Time, Thickness, Dens, diff_cbt, visc_cbu, visc_cbt, diff_cbt_wave, diff_cbt_leewave)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_density_type),       intent(in)    :: Dens
  real, dimension(isd:,jsd:,:,:), intent(inout) :: diff_cbt
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbu
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbt
  real, dimension(isd:,jsd:,:),   intent(inout) :: diff_cbt_wave
  real, dimension(isd:,jsd:,:),   intent(inout) :: diff_cbt_leewave

  integer :: i, j, k, kbot, kp1, tau
  real    :: deposition, factor, tmp, rho_tmp 

  tau = Time%tau
  diff_wave(:,:,:)    = 0.0 ! diffusivity from wave scheme 
  diff_leewave(:,:,:) = 0.0 ! diffusivity from leewave scheme 
  wrk1(:,:,:)         = 0.0 ! viscosity   from wave scheme 
  wrk2(:,:,:)         = 0.0 ! mix_efficiency / rho_N2 
  wrk1_2d(:,:)      = 0.0 ! work array for factor 

  ! compute mask for regions that are deemed too shallow for this scheme 
  do j=jsd,jed
     do i=isd,ied
        kbot=Grd%kmt(i,j)
        tmask_deep(i,j) = 0.0
        if(kbot > 1) then 
            if(Thickness%depth_zwt(i,j,kbot) > shelf_depth_cutoff) tmask_deep(i,j) = 1.0
        endif
     enddo
  enddo

  ! energy flux array (W/m2) (Simmons etal equation (1))
  if(fixed_wave_dissipation) then 
      do j=jsd,jed
         do i=isd,ied
            energy_flux(i,j) = min(wave_energy_flux_max, wave_dissipation(i,j)*tmask_deep(i,j)) 
         enddo
      enddo
  else 
      do j=jsd,jed
         do i=isd,ied
            energy_flux(i,j) = min(wave_energy_flux_max, wave_term(i,j)*bvfreq_bottom(i,j)*tmask_deep(i,j)) 
         enddo
      enddo
  endif

  ! compute mixing efficiency function 
  if(mixing_efficiency_n2depend) then
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               rho_tmp               = Dens%rho(i,j,k,tau) + epsln
               mix_efficiency(i,j,k) = mixing_efficiency*Grd%tmask(i,j,k) &
                                       *rho_N2(i,j,k)/(rho_N2(i,j,k) + rho_tmp*omega_earth2)
               wrk2(i,j,k)           = mixing_efficiency*Grd%tmask(i,j,k) &
                                       /(rho_N2(i,j,k) + rho_tmp*omega_earth2)
            enddo
         enddo
      enddo
  else 
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               mix_efficiency(i,j,k) = mixing_efficiency*Grd%tmask(i,j,k)
               wrk2(i,j,k)           = mixing_efficiency*Grd%tmask(i,j,k) &
                                       /(rho_N2(i,j,k) + epsln)
            enddo
         enddo
      enddo
  endif


  ! diffusivity calculation (Simmons etal equation (3))
            ! normalization of vertical structure function.
            ! Ensure it integrates to unity on the discrete grid.    
            ! "factor" approx decay_scale_inv/(exp[(H+eta)*decay_scale_inv]-1.0)  
  do k = 1,maxval(Grd%kmt)-1
     do j=jsd,jed
        do i=isd,ied
           wrk1_2d(i,j) = wrk1_2d(i,j) + Thickness%dzt(i,j,k)*exp(decay_scale_inv*Thickness%depth_zwt(i,j,k))*Grd%tmask(i,j,k+1)
        enddo
     enddo
  enddo
  where(wrk1_2d > 0.0) wrk1_2d=1/wrk1_2d
  do k = 1,maxval(Grd%kmt)-1
     do j=jsd,jed
        do i=isd,ied
           deposition          = wrk1_2d(i,j)*exp(decay_scale_inv*Thickness%depth_zwt(i,j,k))
           tmp                 = Grd%tmask(i,j,k+1)*wrk2(i,j,k)*tidal_diss_efficiency*deposition
           diff_wave(i,j,k)    = tmp*energy_flux(i,j)
           diff_leewave(i,j,k) = tmp*leewave_dissipation(i,j)
           diff_wave(i,j,k)    = min(diff_wave(i,j,k),max_wave_diffusivity) 
           diff_leewave(i,j,k) = min(diff_leewave(i,j,k),max_wave_diffusivity) 
        enddo
     enddo
  enddo
    

  ! ensure diffusivity monotonically decreases as move upward in column.
  ! recall that diff_wave(i,j,k) is the diffusivity at the bottom of cell-k, 
  ! where diff_wave(i,j,kbot)=0.0 by definition. This prompts the kbot-2,1,-1
  ! loop limits.   
  if(wave_diffusivity_monotonic) then 
      do k=maxval(Grd%kmt)-2,1,-1
         do j=jsd,jed
            do i=isd,ied
               if(k<=Grd%kmt(i,j)-2) then
                  diff_wave(i,j,k)    = min(diff_wave(i,j,k),diff_wave(i,j,k+1))
                  diff_leewave(i,j,k) = min(diff_leewave(i,j,k),diff_leewave(i,j,k+1))
               endif
            enddo
         enddo
      enddo
  endif

  ! add wave induced diffusivity and viscosity to diff_cbt and visc_cbu 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  do k=1,nk-1
     kp1=k+1
     do j=jsc,jec
        do i=isc,iec
           diff_cbt_wave(i,j,k)    = diff_wave(i,j,k) 
           diff_cbt_leewave(i,j,k) = diff_leewave(i,j,k) 
           diff_cbt(i,j,k,1)    = diff_cbt(i,j,k,1) + diff_wave(i,j,k) + diff_leewave(i,j,k)
           diff_cbt(i,j,k,2)    = diff_cbt(i,j,k,2) + diff_wave(i,j,k) + diff_leewave(i,j,k)
           visc_cbt(i,j,k)      = visc_cbt(i,j,k)   + diff_wave(i,j,k) + diff_leewave(i,j,k)
           wrk1(i,j,k)          = Grd%umask(i,j,kp1)*onefourth                   &
                                 *(diff_wave(i,j,k)     +diff_wave(i+1,j,k)      &
                                  +diff_wave(i,j+1,k)   +diff_wave(i+1,j+1,k))
           wrk2(i,j,k)          = Grd%umask(i,j,kp1)*onefourth                   &
                                 *(diff_leewave(i,j,k)  +diff_leewave(i+1,j,k)   &
                                  +diff_leewave(i,j+1,k)+diff_leewave(i+1,j+1,k))
           visc_cbu(i,j,k)      = visc_cbu(i,j,k) + wrk1(i,j,k) + wrk2(i,j,k)
        enddo
     enddo
  enddo


  ! send some diagnostics 

  call diagnose_3d(Time, Grd, id_mix_efficiency, mix_efficiency(:,:,:))
  call diagnose_2d(Time, Grd, id_energy_flux, energy_flux(:,:))
  call diagnose_2d(Time, Grd, id_power_waves, Grd%dat(:,:)*energy_flux(:,:))
  call diagnose_3d(Time, Grd, id_diff_cbt_wave, diff_wave(:,:,:))
  call diagnose_3d(Time, Grd, id_diff_cbt_leewave, diff_leewave(:,:,:))
  call diagnose_3d(Time, Grd, id_visc_cbt_wave, diff_wave(:,:,:))
  call diagnose_3d(Time, Grd, id_visc_cbt_leewave, diff_leewave(:,:,:))
  call diagnose_3d_u(Time, Grd, id_visc_cbu_wave, wrk1(:,:,:))
  call diagnose_3d_u(Time, Grd, id_visc_cbu_leewave, wrk2(:,:,:))


end subroutine vert_mix_wave
! </SUBROUTINE> NAME="vert_mix_wave"


!#######################################################################
! <SUBROUTINE NAME="vert_mix_drag_bgrid">
!
! <DESCRIPTION>
! This subroutine computes dia-surface tracer diffusivity based on the 
! methods of Lee etal., which consider the dissipation from barotropic tides
! rubbing against the ocean bottom. 
!
! We assume B-grid layout for the velocity 
!
! We assume a unit Prandtl number, so compute the viscosity as a four-point
! average of the diffusivity. 
!
! We perform various averages here in order to smooth Richardson number.
!
! 1. compute Richardson number on U-cell by averaging bvfreq from T-cell
! 2. average U-cell Richardson number to then get T-cell diffusivity 
! 3. average T-cell diffusivity to get U-cell viscosity. 
!
! Note that if umask(i,j,k)==1.0, then so is tmask(i,j,k), tmask(i+1,j,k), 
! tmask(i,j+1,k), and tmask(i+1,j+1,k). So there is no need to compute 
! active_cells when averaging from T-cell to U-cell.
!
! </DESCRIPTION>
!
  subroutine vert_mix_drag_bgrid(Time, Thickness, diff_cbt, visc_cbu, visc_cbt, diff_cbt_drag)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  real, dimension(isd:,jsd:,:,:), intent(inout) :: diff_cbt
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbu
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbt
  real, dimension(isd:,jsd:,:),   intent(inout) :: diff_cbt_drag

  integer :: i, j, k, kbot, kp1
  real    :: height, bottom
  real    :: bvfreq_u, speedr, active_cells

  wrk1(:,:,:)      =0.0  ! Richardson number on U-cell
  wrk2(:,:,:)      =0.0  ! Richardson number on T-cell
  wrk3(:,:,:)      =0.0  ! viscosity from drag scheme 
  diff_drag(:,:,:) =0.0  ! diffusivity from drag scheme 

  if(.not. all(skip_row)) then !Check if nothing to do...
  ! Richardson number on U-cell. 
  ! perform a 4-point average of T-cell bvfreq 
  ! and then divide by the U-cell tidal speed term. 
  ! tide_speed_mask is useful to reduce overflows
  ! in later calculation of the diffusivity.
  do k=1,maxval(Grd%kmt)-1
     kp1=k+1 
     do j=jsd,jed-1
        if(skip_row(j)) cycle
        do i=isd,ied-1
           kbot=max(Grd%kmu(i,j),1)
           bottom = Thickness%depth_zwu(i,j,kbot)
           speedr = tide_speed_mask(i,j)/(epsln+rescaled_speed_u(i,j))
           height      = bottom-Thickness%depth_zwu(i,j,k)
           bvfreq_u    = onefourth*(bvfreq(i,j,k)+bvfreq(i+1,j,k)+bvfreq(i,j+1,k)+bvfreq(i+1,j+1,k))            
           wrk1(i,j,k) = 2.0*Grd%umask(i,j,kp1)*(bvfreq_u*height*speedr)**2
        enddo
     enddo

  ! Richardson number on bottom of T-cells.
  ! need active_cells for averaging operation.
     do j=jsc,jec
        if(skip_row(j)) cycle
        do i=isc,iec
           active_cells =   Grd%umask(i,j,k)   + Grd%umask(i-1,j,k) &
                          + Grd%umask(i,j-1,k) + Grd%umask(i-1,j-1,k) + epsln
           wrk2(i,j,k)  =  (wrk1(i,j,k) + wrk1(i-1,j,k) + wrk1(i,j-1,k) + wrk1(i-1,j-1,k))/active_cells


  ! compute drag induced diffusivity 
  ! (Lee etal equations (1), (2), and (3))
  ! Multiply by tide_speed_mask so to zero out 
  ! regions with tiny tide speeds, which are regions 
  ! where we do not wish to have any enhanced mixing
  ! arising from the barotropic tide mixing parameterization
  ! anyhow.  
           diff_drag(i,j,k) = Grd%tmask(i,j,kp1)*tide_speed_mask(i,j)*max_drag_diffusivity &
                              *(1.0 + munk_anderson_sigma*wrk2(i,j,k))**(-munk_anderson_p)
        enddo
     enddo
  enddo

  if(drag_dissipation_efold) then 
      do k=1,maxval(Grd%kmt(isc:iec,jsc:jec))-1
         do j=jsc,jec
            if(skip_row(j)) cycle
            do i=isc,iec
               kbot=Grd%kmt(i,j)
               if(k<kbot) then 
                   bottom = Thickness%depth_zwt(i,j,kbot)
                   height           = bottom-Thickness%depth_zwt(i,j,k)
                   diff_drag(i,j,k) = diff_drag(i,j,k)*exp(-height*efold_depth_r(i,j))
               endif
            enddo
         enddo
      enddo
  endif

  endif ! Still need to update neighbours even if we did no work
  call mpp_update_domains(diff_drag(:,:,:), Dom%domain2d,flags=NUPDATE+EUPDATE) 


  if(.not. all(skip_row)) then ! No need to update
  ! add drag induced diffusivity and viscosity to diff_cbt and visc_cbu. 
  ! average t-cell diffusivities to get u-cell viscosity.
  do k=1,nk-1
     kp1=k+1
     do j=jsc,jec
        do i=isc,iec
           diff_cbt_drag(i,j,k) = diff_drag(i,j,k)
           diff_cbt(i,j,k,1)    = diff_cbt(i,j,k,1) + diff_drag(i,j,k)
           diff_cbt(i,j,k,2)    = diff_cbt(i,j,k,2) + diff_drag(i,j,k)
           visc_cbt(i,j,k)      = visc_cbt(i,j,k)   + diff_drag(i,j,k)
           wrk3(i,j,k)          = Grd%umask(i,j,kp1)*onefourth              &
                                 *(diff_drag(i,j,k)  +diff_drag(i+1,j,k)    &
                                  +diff_drag(i,j+1,k)+diff_drag(i+1,j+1,k))
           visc_cbu(i,j,k)      = visc_cbu(i,j,k) + wrk3(i,j,k)
        enddo
     enddo
  enddo
  endif


  call diagnose_3d(Time, Grd, id_rinumber_drag, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_diff_cbt_drag, diff_drag(:,:,:))
  call diagnose_3d_u(Time, Grd, id_visc_cbu_drag, wrk3(:,:,:))

end subroutine vert_mix_drag_bgrid
! </SUBROUTINE> NAME="vert_mix_drag_bgrid"


!#######################################################################
! <SUBROUTINE NAME="vert_mix_drag_cgrid">
!
! <DESCRIPTION>
! This subroutine computes dia-surface tracer diffusivity based on the 
! methods of Lee etal., which consider the dissipation from barotropic tides
! rubbing against the ocean bottom. 
!
! We assume a unit Prandtl number, so compute the viscosity as a four-point
! average of the diffusivity. 
!
! We assume C-grid layout for the velocity, which renders slight
! distinctions for the calculation of Richardson number. Otherwise, the 
! calculations are the same as the Bgrid. We introduce this separate
! routine, however, to enable easier bitwise agreement with older 
! model results.  Also, further development of this scheme may lead
! to more distinctions from the Bgrid.  
!
! </DESCRIPTION>
!
  subroutine vert_mix_drag_cgrid(Time, Thickness, diff_cbt, visc_cbu, visc_cbt, diff_cbt_drag)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  real, dimension(isd:,jsd:,:,:), intent(inout) :: diff_cbt
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbu
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbt
  real, dimension(isd:,jsd:,:),   intent(inout) :: diff_cbt_drag

  integer :: i, j, k, kbot, kp1
  real    :: height, bottom
  real    :: speedr, active_cells

  wrk1(:,:,:)      = 0.0  ! raw Richardson number on T-cell
  wrk2(:,:,:)      = 0.0  ! smoothed Richardson number on T-cell
  wrk3(:,:,:)      = 0.0  ! visc_cbu from drag scheme 
  diff_drag(:,:,:) = 0.0  ! diffusivity from drag scheme 

  ! Richardson number on T-cell. 
  do j=jsd,jed
     do i=isd,ied
        kbot=Grd%kmt(i,j)
        if(kbot>1) then 
            bottom = Thickness%depth_zwt(i,j,kbot)
            speedr = tide_speed_mask(i,j)/(epsln+rescaled_speed_t(i,j))
            do k=1,kbot-1
               kp1=k+1 
               height      = bottom-Thickness%depth_zwt(i,j,k)
               wrk1(i,j,k) = 2.0*Grd%tmask(i,j,kp1)*(bvfreq(i,j,k)*height*speedr)**2
               wrk2(i,j,k) = wrk1(i,j,k)
            enddo
        endif
     enddo
  enddo

  ! perform 9point average to smooth, and to be more consistent 
  ! with the Bgrid approach.
  ! need active_cells for averaging operation.
  if(smooth_ri_drag_cgrid) then 
     do k=1,nk-1
        do j=jsc,jec
           do i=isc,iec
              active_cells =   Grd%tmask(i-1,j-1,k) + Grd%tmask(i,j-1,k) + Grd%tmask(i+1,j-1,k) &
                             + Grd%tmask(i,j-1,k)   + Grd%tmask(i,j,k)   + Grd%tmask(i+1,j,k)   &
                             + Grd%tmask(i-1,j+1,k) + Grd%tmask(i,j+1,k) + Grd%tmask(i+1,j+1,k) &
                             + epsln
              wrk2(i,j,k)  =  (  wrk1(i-1,j-1,k) + wrk1(i,j-1,k) + wrk1(i+1,j-1,k)   &
                               + wrk1(i,j-1,k)   + wrk1(i,j,k)   + wrk1(i+1,j,k)     &
                               + wrk1(i-1,j+1,k) + wrk1(i,j+1,k) + wrk1(i+1,j+1,k)) / active_cells
           enddo
        enddo
     enddo
  endif 

  ! compute drag induced diffusivity 
  ! (Lee etal equations (1), (2), and (3))
  ! Multiply by tide_speed_mask so to zero out 
  ! regions with tiny tide speeds, which are regions 
  ! where we do not wish to have any enhanced mixing
  ! arising from the barotropic tide mixing parameterization
  ! anyhow.  
  do k=1,nk-1
     kp1=k+1
     do j=jsc,jec
        do i=isc,iec
           diff_drag(i,j,k) = Grd%tmask(i,j,kp1)*tide_speed_mask(i,j)*max_drag_diffusivity &
                              *(1.0 + munk_anderson_sigma*wrk2(i,j,k))**(-munk_anderson_p)
        enddo
     enddo
  enddo

  if(drag_dissipation_efold) then 
      do j=jsc,jec
         do i=isc,iec
            kbot=Grd%kmt(i,j)
            if(kbot>1) then 
                bottom = Thickness%depth_zwt(i,j,kbot)
                do k=1,kbot-1
                   kp1=k+1 
                   height           = bottom-Thickness%depth_zwt(i,j,k)
                   diff_drag(i,j,k) = diff_drag(i,j,k)*exp(-height*efold_depth_r(i,j))
                enddo
            endif
         enddo
      enddo
  endif

  call mpp_update_domains(diff_drag(:,:,:), Dom%domain2d,flags=NUPDATE+EUPDATE) 


  ! add drag induced diffusivity and viscosity to diff_cbt and visc_cbu. 
  ! average t-cell diffusivities to get u-cell viscosity.
  do k=1,nk-1
     kp1=k+1
     do j=jsc,jec
        do i=isc,iec
           diff_cbt_drag(i,j,k) = diff_drag(i,j,k)
           diff_cbt(i,j,k,1)    = diff_cbt(i,j,k,1) + diff_drag(i,j,k)
           diff_cbt(i,j,k,2)    = diff_cbt(i,j,k,2) + diff_drag(i,j,k)
           visc_cbt(i,j,k)      = visc_cbt(i,j,k)   + diff_drag(i,j,k)
           wrk3(i,j,k)          = Grd%umask(i,j,kp1)*onefourth              &
                                 *(diff_drag(i,j,k)  +diff_drag(i+1,j,k)    &
                                  +diff_drag(i,j+1,k)+diff_drag(i+1,j+1,k))
           visc_cbu(i,j,k)      = visc_cbu(i,j,k) + wrk3(i,j,k)
        enddo
     enddo
  enddo


  call diagnose_3d(Time, Grd, id_rinumber_drag, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_diff_cbt_drag, diff_drag(:,:,:))
  call diagnose_3d_u(Time, Grd, id_visc_cbu_drag, wrk3(:,:,:))

end subroutine vert_mix_drag_cgrid
! </SUBROUTINE> NAME="vert_mix_drag_cgrid"



!#######################################################################
! <SUBROUTINE NAME="compute_bvfreq_legacy">
!
! <DESCRIPTION>
! This subroutine computes the absolute value of rho*N^2 and abs of 
! N^2, with N^2 the squared Brunt-Vaisala (or buoyancy) frequency. 
!
! This routine employs a legacy approach, which is not recommended.
! It remains solely to allow exact reproduction of older results.
!
! </DESCRIPTION>
!
  subroutine compute_bvfreq_legacy(Time, Thickness, T_prog, Dens)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  type(ocean_density_type),     intent(in) :: Dens

  real    :: rho_inv, drhodz
  real    :: tmp, rho_N2_prev, rho_tmp
  integer :: i, j, k, m, kp1, kbot
  integer :: tau

  tau = Time%tau
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0

  ! partial derivatives of density wrt to temperature and salinity 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           drhodT(i,j,k) = Dens%drhodT(i,j,k)
           drhodS(i,j,k) = Dens%drhodS(i,j,k)
        enddo
     enddo
  enddo


  ! vertical derivative of temperature and salinity at bottom of tracer cells 
  do k=1,nk
     kp1=min(k+1,nk)
     do j=jsd,jed
        do i=isd,ied
           tmp         = Grd%tmask(i,j,kp1)/Thickness%dzwt(i,j,k)
           wrk1(i,j,k) = tmp*(T_prog(index_temp)%field(i,j,k,tau)-T_prog(index_temp)%field(i,j,kp1,tau)) 
           wrk2(i,j,k) = tmp*(Dens%rho_salinity(i,j,k,tau)-Dens%rho_salinity(i,j,kp1,tau)) 
        enddo
     enddo
  enddo

  ! absolute(rho*N^2) computed from vertical derivative of "neutral density" 
  do k=1,nk
     kp1 = min(k+1,nk)
     do j=jsd,jed
        do i=isd,ied
           drhodz        = onehalf*( (drhodT(i,j,k)+drhodT(i,j,kp1))*wrk1(i,j,k) &
                                    +(drhodS(i,j,k)+drhodS(i,j,kp1))*wrk2(i,j,k) )
           drhodz        = min(drhodz,-drhodz_min)*Grd%tmask(i,j,kp1) 
           rho_N2(i,j,k) = -grav*drhodz
        enddo
     enddo
  enddo

  ! smooth rho_N2 in the vertical using a 1-2-1 filter
  if (smooth_rho_N2) then
      do m=1,num_121_passes
         do j=jsd,jed
            do i=isd,ied
               rho_N2_prev = onefourth*rho_N2(i,j,1)
               kbot=Grd%kmt(i,j)
               if (kbot>3) then
                   do k=2,kbot-2
                      tmp           = rho_N2(i,j,k)
                      rho_N2(i,j,k) = rho_N2_prev + onehalf*rho_N2(i,j,k) + onefourth*rho_N2(i,j,k+1)
                      rho_N2_prev   = onefourth*tmp
                   enddo
               endif
            enddo
         enddo
      enddo
  endif

  ! compute buoyancy frequency 
  do k=1,nk
     kp1 = min(k+1,nk)
     do j=jsd,jed
        do i=isd,ied
           rho_inv       = 2.0/(epsln + Dens%rho(i,j,k,tau) + Dens%rho(i,j,kp1,tau)) 
           bvfreq(i,j,k) = sqrt(rho_inv*rho_N2(i,j,k))
        enddo
     enddo
  enddo

  ! bvfreq at the bottom.
  ! set kbot=kmt-1 rather than kbot=kmt, since N^2=0 
  ! at bottom of bottom-most tracer cell, by definition.
  do j=jsd,jed
     do i=isd,ied
        bvfreq_bottom(i,j) = 0.0
        if(Grd%kmt(i,j) > 1) then 
            kbot=Grd%kmt(i,j)-1
            bvfreq_bottom(i,j) = bvfreq(i,j,kbot)
        endif
     enddo
  enddo

  ! horizontal laplacian smoothing on the bottom bvfreq to reduce noise 
  if(smooth_bvfreq_bottom) then 
     bvfreq_bottom(:,:) = bvfreq_bottom(:,:) + dtime*LAP_T(bvfreq_bottom(:,:),smooth_lap(:,:))
     call mpp_update_domains(bvfreq_bottom(:,:), Dom%domain2d) 
  endif 

  ! compute mixing efficiency 
  mix_efficiency(:,:,:) = mixing_efficiency
  if(mixing_efficiency_n2depend) then
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               rho_tmp = Dens%rho(i,j,k,tau) + epsln
               mix_efficiency(i,j,k) = mixing_efficiency*rho_N2(i,j,k)/(rho_N2(i,j,k) + rho_tmp*omega_earth2)
            enddo
         enddo
      enddo
  endif

  call diagnose_2d(Time, Grd, id_bvfreq_bottom, bvfreq_bottom(:,:))
  call diagnose_3d(Time, Grd, id_bvfreq, bvfreq(:,:,:))
  call diagnose_3d(Time, Grd, id_mix_efficiency, mix_efficiency(:,:,:))

end subroutine compute_bvfreq_legacy
! </SUBROUTINE> NAME="compute_bvfreq_legacy"


!#######################################################################
! <SUBROUTINE NAME="vert_mix_wave_legacy">
!
! <DESCRIPTION>
!
! Legacy routine maintained only to exactly reproduce older results.
! It is not recommended for new experiments, as it uses some obsolete
! methods. 
!
! This subroutine computes dia-surface tracer diffusivity based on the 
! methods of Simmons etal., which consider the dissipation from breaking
! internal gravity waves and their conversion into local dia-surface
! diffusion.  
!
! We assume a unit Prandtl number, so compute the viscosity as a four-point
! average of the diffusivity. 
!
! Note that if umask(i,j,k) is 1.0, then so is 
! tmask(i,j,k), tmask(i+1,j,k), tmask(i,j+1,k), and tmask(i+1,j+1,k).
! So there is no need to compute the "active_cells" when doing the 
! space average to go from t-cell to u-cell to compute viscosity.
!
! </DESCRIPTION>
!
  subroutine vert_mix_wave_legacy(Time, Thickness, diff_cbt, visc_cbu, visc_cbt, diff_cbt_wave)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  real, dimension(isd:,jsd:,:,:), intent(inout) :: diff_cbt
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbu
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbt
  real, dimension(isd:,jsd:,:),   intent(inout) :: diff_cbt_wave

  integer :: i, j, k, kbot, kp1
  real    :: deposition, factor 

  diff_wave(:,:,:) = 0.0 ! diffusivity from wave scheme 
  wrk1(:,:,:)      = 0.0 ! viscosity   from wave scheme 

  ! compute mask for regions that are too shallow for this scheme 
  do j=jsd,jed
     do i=isd,ied
        kbot=Grd%kmt(i,j)
        tmask_deep(i,j) = 0.0
        if(kbot > 1) then 
            if(Thickness%depth_zwt(i,j,kbot) > shelf_depth_cutoff) tmask_deep(i,j) = 1.0
        endif
     enddo
  enddo

  ! compute the wave energy flux array (W/m2) and save for diagnostics
  ! (Simmons etal equation (1))
  if(fixed_wave_dissipation) then 
      do j=jsd,jed
         do i=isd,ied
            energy_flux(i,j) = min(wave_energy_flux_max, wave_dissipation(i,j)*tmask_deep(i,j)) 
         enddo
      enddo
  else 
      do j=jsd,jed
         do i=isd,ied
            energy_flux(i,j) = min(wave_energy_flux_max, wave_term(i,j)*bvfreq_bottom(i,j)*tmask_deep(i,j)) 
         enddo
      enddo
  endif

  ! compute wave induced diffusivity 
  ! (Simmons etal equation (3))
  do j=jsd,jed
     do i=isd,ied
        kbot=Grd%kmt(i,j)
        if(kbot > 1) then

            ! normalization of vertical structure function...ensure it 
            ! integrates to unity on the discrete grid.   
            factor = 0.0
            do k=1,kbot-1
               factor = factor + Thickness%dzt(i,j,k)*exp(decay_scale_inv*Thickness%depth_zwt(i,j,k))
            enddo
            factor = 1.0/factor 

            ! calculate diffusivity 
            do k=1,kbot-1
               deposition       = factor*exp(decay_scale_inv*Thickness%depth_zwt(i,j,k))
               diff_wave(i,j,k) = Grd%tmask(i,j,k+1)*mix_efficiency(i,j,k)*tidal_diss_efficiency &
                                  *energy_flux(i,j)*deposition/(epsln+rho_N2(i,j,k))
               diff_wave(i,j,k) = min(diff_wave(i,j,k),max_wave_diffusivity) 
            enddo

        endif
     enddo
  enddo

  ! ensure diffusivity monotonically decreases as move upward in column.
  ! recall that diff_wave(i,j,k) is the diffusivity at the bottom of cell-k, 
  ! where diff_wave(i,j,kbot)=0.0 by definition. This prompts the kbot-2,1,-1
  ! loop limits.   
  if(wave_diffusivity_monotonic) then 
      do j=jsd,jed
         do i=isd,ied
            kbot=Grd%kmt(i,j)
            if(kbot > 1) then 
                do k=kbot-2,1,-1
                   diff_wave(i,j,k) = min(diff_wave(i,j,k),diff_wave(i,j,k+1))
                enddo
            endif
         enddo
      enddo
  endif

  ! add wave induced diffusivity and viscosity to diff_cbt and visc_cbu 
  do k=1,nk-1
     kp1=k+1
     do j=jsc,jec
        do i=isc,iec
           diff_cbt_wave(i,j,k) = diff_wave(i,j,k) 
           diff_cbt(i,j,k,1)    = diff_cbt(i,j,k,1) + diff_wave(i,j,k)
           diff_cbt(i,j,k,2)    = diff_cbt(i,j,k,2) + diff_wave(i,j,k)
           visc_cbt(i,j,k)      = visc_cbt(i,j,k)   + diff_wave(i,j,k)
           wrk1(i,j,k)          = Grd%umask(i,j,kp1)*onefourth             &
                                 *(diff_wave(i,j,k)  +diff_wave(i+1,j,k)   &
                                  +diff_wave(i,j+1,k)+diff_wave(i+1,j+1,k))
           visc_cbu(i,j,k)      = visc_cbu(i,j,k) + wrk1(i,j,k)
        enddo
     enddo
  enddo


  call diagnose_2d(Time, Grd, id_energy_flux, energy_flux(:,:))
  call diagnose_2d(Time, Grd, id_power_waves, Grd%dat(:,:)*energy_flux(:,:))
  call diagnose_3d(Time, Grd, id_diff_cbt_wave, diff_wave(:,:,:))
  call diagnose_3d(Time, Grd, id_visc_cbt_wave, diff_wave(:,:,:))
  call diagnose_3d_u(Time, Grd, id_visc_cbu_wave, wrk1(:,:,:))

end subroutine vert_mix_wave_legacy
! </SUBROUTINE> NAME="vert_mix_wave_legacy"


!#######################################################################
! <SUBROUTINE NAME="vert_mix_drag_legacy">
!
! <DESCRIPTION>
!
! Legacy routine maintained only to exactly reproduce older results.
! It is not recommended for new experiments, as it uses some obsolete
! methods. 
!
! This subroutine computes dia-surface tracer diffusivity based on the 
! methods of Lee etal., which consider the dissipation from barotropic tides
! rubbing against the ocean bottom. 
!
! We assume a unit Prandtl number, so compute the viscosity as a four-point
! average of the diffusivity. 
!
! We perform various averages here in order to smooth Richardson number.
!
! 1. compute Richardson number on U-cell by averaging bvfreq from T-cell
! 2. average U-cell Richardson number to then get T-cell diffusivity 
! 3. average T-cell diffusivity to get U-cell viscosity. 
!
! Note that if umask(i,j,k)==1.0, then so is tmask(i,j,k), tmask(i+1,j,k), 
! tmask(i,j+1,k), and tmask(i+1,j+1,k). So there is no need to compute 
! active_cells when averaging from T-cell to U-cell.
!
! </DESCRIPTION>
!
  subroutine vert_mix_drag_legacy(Time, Thickness, diff_cbt, visc_cbu, visc_cbt, diff_cbt_drag)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  real, dimension(isd:,jsd:,:,:), intent(inout) :: diff_cbt
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbu
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbt
  real, dimension(isd:,jsd:,:),   intent(inout) :: diff_cbt_drag

  integer :: i, j, k, kbot, kp1
  real    :: height, bottom, bvfreq_u, speedr, active_cells

  wrk1(:,:,:)      =0.0  ! Richardson number on U-cell
  wrk2(:,:,:)      =0.0  ! Richardson number on T-cell
  wrk3(:,:,:)      =0.0  ! viscosity from drag scheme 
  diff_drag(:,:,:) =0.0  ! diffusivity from drag scheme 

  ! Richardson number on U-cell. 
  ! perform a 4-point average of T-cell bvfreq 
  ! and then divide by the U-cell tidal speed term. 
  ! tide_speed_mask is useful to reduce overflows
  ! in later calculation of the diffusivity.
  do j=jsd,jed-1
     do i=isd,ied-1
        kbot=Grd%kmu(i,j)
        if(kbot>1) then 
            bottom = Thickness%depth_zwu(i,j,kbot)
            speedr = tide_speed_mask(i,j)/(epsln+rescaled_speed_u(i,j))
            do k=1,kbot-1
               kp1=k+1 
               height      = bottom-Thickness%depth_zwu(i,j,k)
               bvfreq_u    = onefourth*(bvfreq(i,j,k)+bvfreq(i+1,j,k)+bvfreq(i,j+1,k)+bvfreq(i+1,j+1,k))            
               wrk1(i,j,k) = 2.0*Grd%umask(i,j,kp1)*(bvfreq_u*height*speedr)**2
            enddo
        endif
     enddo
  enddo

  ! Richardson number on bottom of T-cells.
  ! need active_cells for averaging operation.
  do k=1,nk-1
     do j=jsc,jec
        do i=isc,iec
           active_cells =   Grd%umask(i,j,k)   + Grd%umask(i-1,j,k) &
                          + Grd%umask(i,j-1,k) + Grd%umask(i-1,j-1,k) + epsln
           wrk2(i,j,k)  =  (wrk1(i,j,k) + wrk1(i-1,j,k) + wrk1(i,j-1,k) + wrk1(i-1,j-1,k))/active_cells
        enddo
     enddo
  enddo

  ! compute drag induced diffusivity 
  ! (Lee etal equations (1), (2), and (3))
  ! Multiply by tide_speed_mask so to zero out 
  ! regions with tiny tide speeds, which are regions 
  ! where we do not wish to have any enhanced mixing
  ! arising from the barotropic tide mixing parameterization
  ! anyhow.  
  do k=1,nk-1
     kp1=k+1
     do j=jsc,jec
        do i=isc,iec
           diff_drag(i,j,k) = Grd%tmask(i,j,kp1)*tide_speed_mask(i,j)*max_drag_diffusivity &
                              *(1.0 + munk_anderson_sigma*wrk2(i,j,k))**(-munk_anderson_p)
        enddo
     enddo
  enddo
  call mpp_update_domains(diff_drag(:,:,:), Dom%domain2d) 


  ! add drag induced diffusivity and viscosity to diff_cbt and visc_cbu. 
  ! average t-cell diffusivities to get u-cell viscosity.
  do k=1,nk-1
     kp1=k+1
     do j=jsc,jec
        do i=isc,iec
           diff_cbt_drag(i,j,k) = diff_drag(i,j,k)
           diff_cbt(i,j,k,1)    = diff_cbt(i,j,k,1) + diff_drag(i,j,k)
           diff_cbt(i,j,k,2)    = diff_cbt(i,j,k,2) + diff_drag(i,j,k)
           visc_cbt(i,j,k)      = visc_cbt(i,j,k)   + diff_drag(i,j,k)
           wrk3(i,j,k)          = Grd%umask(i,j,kp1)*onefourth              &
                                 *(diff_drag(i,j,k)  +diff_drag(i+1,j,k)    &
                                  +diff_drag(i,j+1,k)+diff_drag(i+1,j+1,k))
           visc_cbu(i,j,k)      = visc_cbu(i,j,k) + wrk3(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_rinumber_drag, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_diff_cbt_drag, diff_drag(:,:,:))
  call diagnose_3d(Time, Grd, id_visc_cbt_drag, diff_drag(:,:,:))
  call diagnose_3d_u(Time, Grd, id_visc_cbu_drag, wrk3(:,:,:))


end subroutine vert_mix_drag_legacy
! </SUBROUTINE> NAME="vert_mix_drag_legacy"



end module ocean_vert_tidal_mod

module ocean_residency_ml_mod  !{
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies 
!</REVIEWER>
!
!<OVERVIEW>
! Ocean age tracer module
!</OVERVIEW>
!
!<DESCRIPTION>
!       This module handles the case where the specified region is determined
!       by a 2-d array of depths, typically mixed layer depths.
!
!       To use this module, in the field table namelist, you must do the following:
!
!       1) set "module_name" to "ocean_residency_ml"
!       2) "strings" should have one value: one of "kpp_bl", "mld_buoyancy", or
!          "mld_potrho"
!       3) no "params" should be set
!       4) no "flags" should be set
!
!       Currently, the following mixed layers are supported:
!
!          kpp_bl:  KPP mixed layer
!    mld_buoyancy:  mixed layer defined by a change in buoyancy
!                   (mld in diagnostic output)
!      mld_potrho:  mixed layer defined by a change in potential density
!                   (depth_of_potrho in diagnostic output)
!
!       There should be no "params" or "flags" set, and only one element of
!       "strings".
!
!       For an overview of the ocean residency modules, see ocean_residency.F90.
!
!</DESCRIPTION>
!
! $Id: ocean_residency_ml.F90,v 20.0 2013/12/14 00:17:10 fms Exp $
!

!
!       modules
!

use field_manager_mod,        only: fm_field_name_len, fm_get_index
use mpp_mod,                  only: stdout, mpp_error, FATAL

use ocean_residency_meta_mod, only: ocean_residency_get_instances
use ocean_residency_meta_mod, only: ocean_residency_instance_type
use ocean_residency_meta_mod, only: ocean_residency_set_region_2d
use ocean_types_mod,          only: ocean_thickness_type, ocean_prog_tracer_type
use ocean_types_mod,          only: ocean_time_type, ocean_density_type
use ocean_tracer_diag_mod,    only: calc_mixed_layer_depth, calc_potrho_mixed_layer

!
!       force all variables to be "typed"
!

implicit none

!
!       Set all variables to be private by default

private

!
!       Public routines
!

public  :: ocean_residency_ml_source
public  :: ocean_residency_ml_start

!
!       Private routines
!

!
!       Public parameters
!


!
!       Private parameters
!

character(len=fm_field_name_len), parameter     :: package_name = 'ocean_residency_ml'
character(len=48), parameter                    :: mod_name = 'ocean_residency_ml_mod'

!
!       Public variables
!

logical, public :: do_ocean_residency_ml

!
!       Private types
!


!
!       Private variables
!

type(ocean_residency_instance_type), dimension(:), pointer      :: instance
integer                                                         :: num_instances = 0
integer                                                         :: indtemp, indsal

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_residency_ml_source">
!
! <DESCRIPTION>
!       Calculate the mask for the mixed layer.
!
!       Arguments:
!
!         Input:
!
!              isd:  low dimension of first index
!              ied:  high dimension of first index
!              jsd:  low dimension of second index
!              jed:  high dimension of second index
!               nk:  dimension of third index
!           T_prog:  array of ocean prognostic types
!           T_diag:  array of ocean diagnostic types
!             Time:  ocean time type
!        Thickness:  ocean thickness type
!             Dens:  ocean density type
!        depth_zwt:  depth of bottom of grid cell
!       hblt_depth:  array of depths of KPP boundary layer
! </DESCRIPTION>
!

subroutine ocean_residency_ml_source(isd, ied, jsd, jed, nk,    &
     T_prog, Time, Thickness, Dens, depth_zwt, hblt_depth)  !{

!
!       modules
!

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
integer, intent(in)                                             :: nk
type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
type(ocean_time_type), intent(in)                               :: Time
type(ocean_thickness_type), intent(in)                          :: Thickness
type(ocean_density_type), intent(in)                            :: Dens
real, dimension(isd:,jsd:,:), intent(in)                        :: depth_zwt
real, dimension(isd:,jsd:), intent(in)                          :: hblt_depth

!
!       local parameters
!

!
!       local variables
!

integer                                 :: n
integer                                 :: nn
real, dimension(isd:ied,jsd:jed)        :: mld

!
!       set the source values for the age tracers
!

do n = 1, num_instances  !{

  do nn = 1, instance(n)%num_regions  !{

    if (associated(instance(n)%region(nn)%strings)) then  !{

      if (instance(n)%region(nn)%strings(1) .eq. 'kpp_bl') then  !{
      
        mld(:,:) = hblt_depth(:,:)

      elseif (instance(n)%region(nn)%strings(1) .eq. 'mld_buoyancy') then  !}{

        call calc_mixed_layer_depth(Thickness,                                  &
             t_prog(indsal)%field(isd:ied,jsd:jed,:,time%tau),                  &
             t_prog(indtemp)%field(isd:ied,jsd:jed,:,time%tau),                 &
             dens%rho(isd:ied,jsd:jed,:,Time%tau),                              &
             dens%pressure_at_depth(isd:ied,jsd:jed,:),         &
             mld)

      elseif (instance(n)%region(nn)%strings(1) .eq. 'mld_potrho') then  !}{

        call calc_potrho_mixed_layer(thickness, dens,                     &
             potrho_mix_depth = mld)

      endif  !}

      call ocean_residency_set_region_2d(isd, ied, jsd, jed, nk, mld,           &
           instance(n)%region(nn)%mask, depth_zwt,                              &
           restore_region_value = 1.0, integrate_region_value = 0.0,            &
           swap = instance(n)%region(nn)%swap_module)

    endif  !}

  enddo  !} nn

enddo  !} n

return

end subroutine ocean_residency_ml_source   !}
! </SUBROUTINE> NAME="ocean_residency_ml_source"


!#######################################################################
! <SUBROUTINE NAME="ocean_residency_ml_start">
!
! <DESCRIPTION>
!       Start the ocean residency mixed layer package
!
! </DESCRIPTION>
!
subroutine ocean_residency_ml_start  !{

!
!       modules
!

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

!
!       local parameters
!

character(len=64), parameter    :: sub_name = 'ocean_residency_ml_start'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!       local variables
!

integer :: n
integer :: nn

  integer :: stdoutunit 
  stdoutunit=stdout() 

instance => ocean_residency_get_instances(package_name)

write (stdoutunit,*)
if (.not. associated(instance)) then  !{
  write (stdoutunit,*) trim(note_header), ' No instances'
  num_instances = 0
  do_ocean_residency_ml = .false.
else  !}{
  num_instances = size(instance)
  if (num_instances .eq. 1) then  !{
    write (stdoutunit,*) trim(note_header), ' ', num_instances, ' instance'
  else  !}{
    write (stdoutunit,*) trim(note_header), ' ', num_instances, ' instances'
  endif  !}
  do_ocean_residency_ml = .true.
endif  !}

!
!       return if no tracers
!

if (.not. do_ocean_residency_ml) then
  return
endif

do n = 1, num_instances  !{

  do nn = 1, instance(n)%num_regions  !{

!
!       Only process items for this module
!

    if (instance(n)%region(nn)%module_name .eq. package_name) then  !{

!
!       Check that a type was given
!

      if (.not. associated(instance(n)%region(nn)%strings)) then  !{
        call mpp_error(FATAL, trim(error_header) // ' No strings set for ' // trim(instance(n)%name))
      endif  !}

!
!       Check the types
!
!       Whole grid boxes which contain at least part
!       of the mixed layer are used.
!       If swap_module is true, then the region is inverted
!

      if (instance(n)%region(nn)%strings(1) .eq. 'kpp_bl') then  !{

!
!       kpp_bl: KPP boundary layer
!

        if (size(instance(n)%region(nn)%strings) .ne. 1) then  !{
          call mpp_error(FATAL, trim(error_header) // ' Wrong number of strings set for ' //            &
               trim(instance(n)%name) // ' (' // trim(instance(n)%region(nn)%strings(1)) // ')')
        endif  !}

        if (associated(instance(n)%region(nn)%params)) then  !{
          call mpp_error(FATAL, trim(error_header) // ' Params set for ' //                             &
               trim(instance(n)%name) // ' (' // trim(instance(n)%region(nn)%strings(1)) // ')')
        endif  !}

        if (associated(instance(n)%region(nn)%flags)) then  !{
          call mpp_error(FATAL, trim(error_header) // ' Flags set for ' //                              &
               trim(instance(n)%name) // ' (' // trim(instance(n)%region(nn)%strings(1)) // ')')
        endif  !}

      elseif (instance(n)%region(nn)%strings(1) .eq. 'mld_buoyancy') then  !}{

!
!       mld_buoyancy: mixed layer depth defined by a change in buoyancy
!               from the surface value.
!

        if (size(instance(n)%region(nn)%strings) .ne. 1) then  !{
          call mpp_error(FATAL, trim(error_header) // ' Wrong number of region(nn)%strings set for ' // &
               trim(instance(n)%name) // ' (' // trim(instance(n)%region(nn)%strings(1)) // ')')
        endif  !}

        if (associated(instance(n)%region(nn)%params)) then  !{
          call mpp_error(FATAL, trim(error_header) // ' Params set for ' //                             &
               trim(instance(n)%name) // ' (' // trim(instance(n)%region(nn)%strings(1)) // ')')
        endif  !}

        if (associated(instance(n)%region(nn)%flags)) then  !{
          call mpp_error(FATAL, trim(error_header) // ' Flags set for ' //                              &
               trim(instance(n)%name) // ' (' // trim(instance(n)%region(nn)%strings(1)) // ')')
        endif  !}


      elseif (instance(n)%region(nn)%strings(1) .eq. 'mld_potrho') then  !}{

!
!       mld_potrho: mixed layer depth defined by a change in potential
!               density from the surface value.
!

        if (size(instance(n)%region(nn)%strings) .ne. 1) then  !{
          call mpp_error(FATAL, trim(error_header) // ' Wrong number of region(nn)%strings set for ' // &
               trim(instance(n)%name) // ' (' // trim(instance(n)%region(nn)%strings(1)) // ')')
        endif  !}

        if (associated(instance(n)%region(nn)%params)) then  !{
          call mpp_error(FATAL, trim(error_header) // ' Params set for ' //                             &
               trim(instance(n)%name) // ' (' // trim(instance(n)%region(nn)%strings(1)) // ')')
        endif  !}

        if (associated(instance(n)%region(nn)%flags)) then  !{
          call mpp_error(FATAL, trim(error_header) // ' Flags set for ' //                              &
               trim(instance(n)%name) // ' (' // trim(instance(n)%region(nn)%strings(1)) // ')')
        endif  !}

      else  !}{

!
!       Unknown type
!

        call mpp_error(FATAL, trim(error_header) // ' Unrecognized type (' //                           &
             trim(instance(n)%region(nn)%strings(1)) // ') for ' // trim(instance(n)%name))

      endif  !}

    endif  !}

  enddo  !} nn

enddo  !} n

indtemp = fm_get_index('/ocean_mod/prog_tracers/temp')
if (indtemp .le. 0) then  !{
  call mpp_error(FATAL,trim(error_header) // ' Could not get the temperature index')
endif  !}
                                                                                                                          
indsal = fm_get_index('/ocean_mod/prog_tracers/salt')
if (indsal .le. 0) then  !{
  call mpp_error(FATAL,trim(error_header) // ' Could not get the salinity index')
endif  !}

return

end subroutine ocean_residency_ml_start  !}
! </SUBROUTINE> NAME="ocean_residency_ml_start"

end module ocean_residency_ml_mod  !}

module tracer_manager_mod
! <CONTACT EMAIL="William.Cooke@noaa.gov">
!   William Cooke
! </CONTACT>

! <REVIEWER EMAIL="Matthew.Harrison@noaa.gov">
!   Matt Harrison
! </REVIEWER>

! <REVIEWER EMAIL="Bruce.Wyman@noaa.gov">
!   Bruce Wyman
! </REVIEWER>

! <REVIEWER EMAIL="Peter.Phillipps@noaa.gov">
!   Peter Phillipps
! </REVIEWER>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!   Code to manage the simple addition of tracers to the FMS code.
!     This code keeps track of the numbers and names of tracers included
!     in a tracer table.
! </OVERVIEW>

! <DESCRIPTION>
!     This code is a grouping of calls which will allow the simple
!     introduction of tracers into the FMS framework. It is designed to
!     allow users of a variety of component models interact easily with
!     the dynamical core of the model. 
!     
!     In calling the tracer manager routines the user must provide a
!     parameter identifying the model that the user is working with. This
!     parameter is defined within field_manager as MODEL_X 
!     where X is one of [ATMOS, OCEAN, LAND, ICE].
!
!     In many of these calls the argument list includes model and tracer_index. These 
!     are the parameter corresponding to the component model and the tracer_index N is 
!     the Nth tracer within the component model. Therefore a call with MODEL_ATMOS and 5 
!     is different from a call with MODEL_OCEAN and 5.
!
! </DESCRIPTION>


!----------------------------------------------------------------------

use           mpp_mod, only : mpp_error,          &
                              mpp_pe,             &
                              mpp_root_pe,        &
                              FATAL,              &
                              WARNING,            &
                              NOTE,               &
                              stdlog
use        mpp_io_mod, only : mpp_open,           &
                              mpp_close,          &
                              MPP_ASCII,          &
                              MPP_APPEND,         &
                              MPP_RDONLY
use           fms_mod, only : lowercase,          &
                              write_version_number

use field_manager_mod, only : field_manager_init, &
                              get_field_info,     &
                              get_field_methods,  &
                              MODEL_ATMOS,        &
                              MODEL_LAND,         &
                              MODEL_OCEAN,        &
                              MODEL_ICE,          &
                              MODEL_COUPLER,      &
                              NUM_MODELS,         &
                              method_type,        &
                              default_method,     &
                              parse,              &
                              fm_copy_list,       &
                              fm_change_list,     &
                              fm_modify_name,     &
                              fm_query_method,    &
                              fm_new_value,       &
                              fm_exists,          &
                              MODEL_NAMES

implicit none
private

!-----------------------------------------------------------------------

public  tracer_manager_init, &
        tracer_manager_end,  &
        check_if_prognostic, &
        get_tracer_indices,  &
        get_tracer_index,    &
        get_tracer_names,    &
        get_tracer_name,     &
        query_method,        &
        set_tracer_atts,     &
        set_tracer_profile,  &
        register_tracers,    &
        get_number_tracers,  &
        adjust_mass,         &
        adjust_positive_def, &
        NO_TRACER,           &
        MAX_TRACER_FIELDS

!-----------------------------------------------------------------------
interface get_tracer_index
  module procedure get_tracer_index_integer, get_tracer_index_logical
end interface
!-----------------------------------------------------------------------

integer            :: num_tracer_fields = 0
integer, parameter :: MAX_TRACER_FIELDS = 150
integer, parameter :: MAX_TRACER_METHOD = 20
integer, parameter :: NO_TRACER         = 1-HUGE(1)
integer, parameter :: NOTRACER          = -HUGE(1)

integer :: total_tracers(NUM_MODELS), prog_tracers(NUM_MODELS), diag_tracers(NUM_MODELS)
logical :: model_registered(NUM_MODELS) = .FALSE.

type, private ::  tracer_type
   character(len=32)        :: tracer_name, tracer_units
   character(len=128)       :: tracer_longname
   integer                  :: num_methods, model, instances
   logical                  :: is_prognostic, instances_set
   logical                  :: needs_init
!    Does tracer need mass or positive definite adjustment?
!    (true by default for both)
   logical                  :: needs_mass_adjust
   logical                  :: needs_positive_adjust
end type tracer_type

type, private ::  tracer_name_type
   character(len=32)  :: model_name, tracer_name, tracer_units
   character(len=128) :: tracer_longname
end type tracer_name_type


type, private :: inst_type
   character(len=128) :: name
   integer            :: instances
end type inst_type

type(tracer_type), save  :: tracers(MAX_TRACER_FIELDS)
type(inst_type)  , save  :: instantiations(MAX_TRACER_FIELDS)

character(len=128) :: version = '$Id$'
character(len=128) :: tagname = '$Name$'
logical            :: module_is_initialized = .false.

logical            :: verbose_local
integer            :: TRACER_ARRAY(NUM_MODELS,MAX_TRACER_FIELDS)

contains

!
!#######################################################################
!
! <SUBROUTINE NAME="tracer_manager_init">
!   <OVERVIEW>
!      It is not necessary to call this routine.
!      It is included only for backward compatability.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This routine writes the version and tagname to the logfile and 
!     sets the module initialization flag.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call tracer_manager_init
!   </TEMPLATE>
subroutine tracer_manager_init
integer :: model, num_tracers, num_prog, num_diag

  if(module_is_initialized) return
  module_is_initialized = .TRUE.

  call write_version_number (version, tagname)
  call field_manager_init()
  TRACER_ARRAY = NOTRACER
  do model=1,NUM_MODELS 
    call get_tracer_meta_data(model, num_tracers, num_prog, num_diag)
  enddo

end subroutine tracer_manager_init
! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="get_tracer_meta_data">
!   <OVERVIEW>
! read tracer table and store tracer information associated with "model"
! in "tracers" array. 
!   </OVERVIEW>
subroutine get_tracer_meta_data(model, num_tracers,num_prog,num_diag)

integer,  intent(in) :: model ! model being used
integer, intent(out) :: num_tracers, num_prog, num_diag
character(len=256)    :: warnmesg

character(len=32)  :: name_type, type, name
integer :: n, m, mod, num_tracer_methods, nfields, swop
integer :: j, log_unit, num_methods
logical :: flag_type
type(method_type), dimension(MAX_TRACER_METHOD) :: methods
integer :: instances, siz_inst,i
character(len = 32) :: digit,suffnam

character(len=128) :: list_name , control
integer            :: index_list_name
logical :: fm_success

!   <ERROR MSG="invalid model type" STATUS="FATAL">
!     The index for the model type is invalid.
!   </ERROR>
if (model .ne. MODEL_ATMOS .and. model .ne. MODEL_LAND .and. &
    model .ne. MODEL_OCEAN .and. model .ne. MODEL_ICE  .and. &
    model .ne. MODEL_COUPLER) call mpp_error(FATAL,'tracer_manager_init : invalid model type')

! One should only call get_tracer_meta_data once for each model type
! Therefore need to set up an array to stop the subroutine being 
! unnecssarily called multiple times.

if ( model_registered(model) ) then
! This routine has already been called for the component model.
! Fill in the values from the previous registration and return.
  num_tracers = total_tracers(model)
  num_prog    = prog_tracers(model)
  num_diag    = diag_tracers(model) 
  return
endif

! Initialize the number of tracers to zero.
num_tracers = 0; num_prog = 0; num_diag = 0

call field_manager_init(nfields=nfields)

!   <ERROR MSG="No tracers are available to be registered." STATUS="NOTE">
!      No tracers are available to be registered. This means that the field
!      table does not exist or is empty.
!   </ERROR>
if (nfields == 0 ) then
if (mpp_pe() == mpp_root_pe()) &
  call mpp_error(NOTE,'tracer_manager_init : No tracers are available to be registered.')
  return
endif

! search through field entries for model tracers
total_tracers(model) = 0

do n=1,nfields
   call get_field_info(n,type,name,mod,num_methods)

   if (mod == model .and. type == 'tracer') then
         num_tracer_fields = num_tracer_fields + 1
         total_tracers(model) = total_tracers(model) + 1
!   <ERROR MSG="MAX_TRACER_FIELDS exceeded" STATUS="FATAL">
!     The maximum number of tracer fields has been exceeded.
!   </ERROR>
         if(num_tracer_fields > MAX_TRACER_FIELDS) call mpp_error(FATAL,'tracer_manager_init: MAX_TRACER_FIELDS exceeded')
         TRACER_ARRAY(model,total_tracers(model))  = num_tracer_fields
         tracers(num_tracer_fields)%model          = model
         tracers(num_tracer_fields)%tracer_name    = name
         tracers(num_tracer_fields)%tracer_units   = 'none'
         tracers(num_tracer_fields)%tracer_longname = tracers(num_tracer_fields)%tracer_name
         tracers(num_tracer_fields)%instances_set   = .FALSE.
!        By default, tracers need mass and positive definite adjustments.
!        We hardwire exceptions for compatibility with existing field_tables
!        This should ideally be cleaned up.
         tracers(num_tracer_fields)%needs_mass_adjust = .true.
         tracers(num_tracer_fields)%needs_positive_adjust = .true.
         if (name == 'cld_amt') then
            tracers(num_tracer_fields)%needs_mass_adjust = .false.
         endif
         if (name == 'cld_amt' .or. name == 'liq_wat' .or. name == 'ice_wat') then
            tracers(num_tracer_fields)%needs_positive_adjust = .false.
         endif

         num_tracer_methods     = 0
         methods = default_method ! initialize methods array
         call get_field_methods(n,methods)
         do j=1,num_methods
            select case (methods(j)%method_type) 
            case ('units')
               tracers(num_tracer_fields)%tracer_units   = methods(j)%method_name
            case ('longname')
               tracers(num_tracer_fields)%tracer_longname = methods(j)%method_name
            case ('instances')
!               tracers(num_tracer_fields)%instances = methods(j)%method_name
               siz_inst = parse(methods(j)%method_name,"",instances)
               tracers(num_tracer_fields)%instances = instances
               tracers(num_tracer_fields)%instances_set   = .TRUE.
            case ('adjust_mass')
               if (methods(j)%method_name == "false") then
                 tracers(num_tracer_fields)%needs_mass_adjust = .false.
               endif
            case ('adjust_positive_def')
               if (methods(j)%method_name == "false") then
                 tracers(num_tracer_fields)%needs_positive_adjust = .false.
               endif
            case default
               num_tracer_methods = num_tracer_methods+1
!               tracers(num_tracer_fields)%methods(num_tracer_methods) = methods(j)
            end select
         enddo
         tracers(num_tracer_fields)%num_methods = num_tracer_methods
         tracers(num_tracer_fields)%needs_init = .false.
         flag_type = query_method ('tracer_type',model,total_tracers(model),name_type)
         if (flag_type .and. name_type == 'diagnostic') then
            tracers(num_tracer_fields)%is_prognostic = .false.
         else   
            tracers(num_tracer_fields)%is_prognostic = .true.
         endif   
         if (tracers(num_tracer_fields)%is_prognostic) then
            num_prog = num_prog+1
         else
            num_diag = num_diag+1
         endif
   endif
enddo

! Now cycle through the tracers and add additional instances of the tracers.

do n = 1, num_tracer_fields !{
!   call get_field_info(n,type,name,mod,num_methods)

  if ( model == tracers(n)%model .and. tracers(n)%instances_set ) then !{ We have multiple instances of this tracer

    if ( num_tracer_fields + tracers(n)%instances > MAX_TRACER_FIELDS ) then
      write(warnmesg, '("tracer_manager_init: Number of tracers will exceed MAX_TRACER_FIELDS with &
                       &multiple (",I3," instances) setup of tracer ",A)') tracers(n)%instances,tracers(n)%tracer_name
      call mpp_error(FATAL, warnmesg)
    endif                        

    do i = 2, tracers(n)%instances !{
      num_tracer_fields = num_tracer_fields + 1
      total_tracers(model) = total_tracers(model) + 1
      TRACER_ARRAY(model,total_tracers(model))  = num_tracer_fields
      ! Copy the original tracer type to the multiple instances.
      tracers(num_tracer_fields) = tracers(n)
      if ( query_method ('instances', model,model_tracer_number(model,n),name, control)) then !{
          
        if (i .lt. 10) then  !{
           write (suffnam,'(''suffix'',i1)') i
           siz_inst = parse(control, suffnam,digit)
           if (siz_inst == 0 ) then
             write (digit,'(''_'',i1)') i
           else
             digit = "_"//trim(digit)
           endif  
        elseif (i .lt. 100) then  !}{
           write (suffnam,'(''suffix'',i2)') i
           siz_inst = parse(control, suffnam,digit)
           if (siz_inst == 0 ) then
             write (digit,'(''_'',i2)') i
           else
             digit = "_"//trim(digit)
           endif
        else  !}{
          call mpp_error(FATAL, 'tracer_manager_init: MULTIPLE_TRACER_SET_UP exceeds 100 for '//tracers(n)%tracer_name )
        endif  !}

        select case(model)
          case (MODEL_COUPLER)
            list_name = "/coupler_mod/tracer/"//trim(tracers(num_tracer_fields)%tracer_name)
          case (MODEL_ATMOS)
            list_name = "/atmos_mod/tracer/"//trim(tracers(num_tracer_fields)%tracer_name)
          case (MODEL_OCEAN)
            list_name = "/ocean_mod/tracer/"//trim(tracers(num_tracer_fields)%tracer_name)
          case (MODEL_ICE  )
            list_name = "/ice_mod/tracer/"//trim(tracers(num_tracer_fields)%tracer_name)
          case (MODEL_LAND )
            list_name = "/land_mod/tracer/"//trim(tracers(num_tracer_fields)%tracer_name)
          case default
            list_name = "/default/tracer/"//trim(tracers(num_tracer_fields)%tracer_name)
        end select

        if (mpp_pe() == mpp_root_pe() ) write (*,*) "Creating list name = ",trim(list_name)//trim(digit)

        index_list_name = fm_copy_list(trim(list_name),digit, create = .true.)
        tracers(num_tracer_fields)%tracer_name = trim(tracers(num_tracer_fields)%tracer_name)//trim(digit)
      endif !}
         
      if (tracers(num_tracer_fields)%is_prognostic) then !{
         num_prog = num_prog+1
      else !}{
         num_diag = num_diag+1
      endif !}
    enddo !}
    ! Multiple instances of tracers were found so need to rename the original tracer.
    digit = "_1" 
    siz_inst = parse(control, "suffix1",digit)
    if (siz_inst > 0 ) then !{
      digit = "_"//trim(digit)
    endif !}
    fm_success = fm_modify_name(trim(list_name), trim(tracers(n)%tracer_name)//trim(digit))
    tracers(n)%tracer_name = trim(tracers(n)%tracer_name)//trim(digit)
  endif !}
enddo !}

! Find any field entries with the instances keyword.
do n=1,nfields
   call get_field_info(n,type,name,mod,num_methods)

   if ( mod == model .and. type == 'instances' ) then
      call get_field_methods(n,methods)
      do j=1,num_methods

         if (.not.get_tracer_index(mod,methods(j)%method_type,m)) then 
           call mpp_error(FATAL,'tracer_manager_init: The instances keyword was found for undefined tracer '&
           //trim(methods(j)%method_type))
         else
           if ( tracers(m)%instances_set ) &
              call mpp_error(FATAL,'tracer_manager_init: The instances keyword was found for '&
              //trim(methods(j)%method_type)//' but has previously been defined in the tracer entry')
           siz_inst = parse(methods(j)%method_name,"",instances)
           tracers(m)%instances = instances
           call mpp_error(NOTE,'tracer_manager_init: '//trim(instantiations(j)%name)// &
                               ' will have '//trim(methods(j)%method_name)//' instances')
         endif
         if ( num_tracer_fields + instances > MAX_TRACER_FIELDS ) then
           write(warnmesg, '("tracer_manager_init: Number of tracers will exceed MAX_TRACER_FIELDS with &
                       &multiple (",I3," instances) setup of tracer ",A)') tracers(m)%instances,tracers(m)%tracer_name
           call mpp_error(FATAL, warnmesg)
         endif                        
! We have found a valid tracer that has more than one instantiation.
! We need to modify that tracer name to tracer_1 and add extra tracers for the extra instantiations.
         if (instances .eq. 1) then
           siz_inst = parse(methods(j)%method_control, 'suffix1',digit)
           if (siz_inst == 0 ) then
             digit = '_1'
           else
             digit = "_"//trim(digit)
           endif  
         endif
         do i = 2, instances
           num_tracer_fields = num_tracer_fields + 1
           total_tracers(model) = total_tracers(model) + 1
           TRACER_ARRAY(model,total_tracers(model))  = num_tracer_fields
           tracers(num_tracer_fields)                =  tracers(m)
           
           if (i .lt. 10) then  !{
             write (suffnam,'(''suffix'',i1)') i
             siz_inst = parse(methods(j)%method_control, suffnam,digit)
             if (siz_inst == 0 ) then
               write (digit,'(''_'',i1)') i
             else
               digit = "_"//trim(digit)
             endif  
          elseif (i .lt. 100) then  !}{
             write (suffnam,'(''suffix'',i2)') i
             siz_inst = parse(methods(j)%method_control, suffnam,digit)
             if (siz_inst == 0 ) then
               write (digit,'(''_'',i2)') i
             else
               digit = "_"//trim(digit)
             endif
          else  !}{
            call mpp_error(FATAL, 'tracer_manager_init: MULTIPLE_TRACER_SET_UP exceeds 100 for '&
                                  //tracers(num_tracer_fields)%tracer_name )
          endif  !}

          select case(model)
            case (MODEL_COUPLER)
              list_name = "/coupler_mod/tracer/"//trim(tracers(num_tracer_fields)%tracer_name)
            case (MODEL_ATMOS)
              list_name = "/atmos_mod/tracer/"//trim(tracers(num_tracer_fields)%tracer_name)
            case (MODEL_OCEAN)
              list_name = "/ocean_mod/tracer/"//trim(tracers(num_tracer_fields)%tracer_name)
            case (MODEL_ICE  )
              list_name = "/ice_mod/tracer/"//trim(tracers(num_tracer_fields)%tracer_name)
            case (MODEL_LAND )
              list_name = "/land_mod/tracer/"//trim(tracers(num_tracer_fields)%tracer_name)
            case default
              list_name = "/default/tracer/"//trim(tracers(num_tracer_fields)%tracer_name)
          end select

          if (mpp_pe() == mpp_root_pe() ) write (*,*) "Creating list name = ",trim(list_name)

          index_list_name = fm_copy_list(trim(list_name),digit, create = .true.)

          tracers(num_tracer_fields)%tracer_name    =  trim(tracers(num_tracer_fields)%tracer_name)//digit
          if (tracers(num_tracer_fields)%is_prognostic) then
            num_prog = num_prog+1
          else
            num_diag = num_diag+1
          endif
        enddo
!Now rename the original tracer to tracer_1 (or if suffix1 present to tracer_'value_of_suffix1')
        siz_inst = parse(methods(j)%method_control, 'suffix1',digit)
        if (siz_inst == 0 ) then
          digit = '_1'
        else
          digit = "_"//trim(digit)
        endif  
        fm_success = fm_modify_name(trim(list_name), trim(tracers(m)%tracer_name)//trim(digit))
        tracers(m)%tracer_name    =  trim(tracers(m)%tracer_name)//trim(digit)
      enddo
   endif
enddo

num_tracers = num_prog + num_diag
! Make the number of tracers available publicly.
total_tracers(model)    = num_tracers
prog_tracers(model)     = num_prog
diag_tracers(model)     = num_diag
model_registered(model) = .TRUE.

! Now sort through the tracer fields and sort them so that the 
! prognostic tracers are first.

do n=1, num_tracers
  if (.not.check_if_prognostic(model,n) .and. n.le.num_prog) then 
  ! This is a diagnostic tracer so find a prognostic tracer to swop with
    do m = n, num_tracers
       if (check_if_prognostic(model,m) .and. .not.check_if_prognostic(model,n)) then
           swop = TRACER_ARRAY(model,n)
           TRACER_ARRAY(model,n) = TRACER_ARRAY(model,m)
           TRACER_ARRAY(model,m) = swop
           cycle
       endif
    enddo
  endif
enddo

do n=1, num_tracer_fields
  call print_tracer_info(model,n)
enddo

log_unit = stdlog()
if ( mpp_pe() == mpp_root_pe() ) then
   write (log_unit,15) trim(MODEL_NAMES(model)),total_tracers(model)
endif

15 format ('Number of tracers in field table for ',A,' model = ',i4)

end subroutine get_tracer_meta_data
!</SUBROUTINE>


function model_tracer_number(model,n)
integer, intent(in) :: model, n
integer model_tracer_number

integer :: i

model_tracer_number = NO_TRACER

do i = 1, MAX_TRACER_FIELDS
  if ( TRACER_ARRAY(model,i) == n ) then
    model_tracer_number = i
    return
  endif
enddo

end function model_tracer_number

!#######################################################################
!
! <SUBROUTINE NAME="register_tracers">

!   <OVERVIEW>
!      It is not necessary to call this routine.
!      It is included only for backward compatability.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This routine returns the total number of valid tracers,
!     the number of prognostic and diagnostic tracers.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call register_tracers(model, num_tracers,num_prog,num_diag)
!   </TEMPLATE>

!   <IN NAME="model" TYPE="integer">
!     A parameter to identify which model is being used.
!   </IN>
!   <OUT NAME="num_tracers" TYPE="integer">
!    The total number of valid tracers within the component model.
!   </OUT>
!   <OUT NAME="num_prog" TYPE="integer">
!     The number of prognostic tracers within the component model.
!   </OUT>
!   <OUT NAME="num_diag" TYPE="integer">
!     The number of diagnostic tracers within the component model.
!   </OUT>
subroutine register_tracers(model, num_tracers, num_prog, num_diag, num_family)
integer, intent(in) :: model
integer, intent(out) :: num_tracers, num_prog, num_diag
integer, intent(out), optional :: num_family

if(.not.module_is_initialized) call tracer_manager_init

call get_number_tracers(model, num_tracers, num_prog, num_diag, num_family)

end subroutine register_tracers
!</SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="get_number_tracers">
!   <OVERVIEW>
!      A routine to return the number of tracers included in a component model.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This routine returns the total number of valid tracers,
!     the number of prognostic and diagnostic tracers
!   </DESCRIPTION>
!   <TEMPLATE>
!     call get_number_tracers(model, num_tracers,num_prog,num_diag)
!   </TEMPLATE>

!   <IN NAME="model" TYPE="integer">
!     A parameter to identify which model is being used.
!   </IN>
!   <OUT NAME="num_tracers" TYPE="integer, optional">
!    The total number of valid tracers within the component model.
!   </OUT>
!   <OUT NAME="num_prog" TYPE="integer, optional">
!     The number of prognostic tracers within the component model.
!   </OUT>
!   <OUT NAME="num_diag" TYPE="integer, optional">
!     The number of diagnostic tracers within the component model.
!   </OUT>
subroutine get_number_tracers(model, num_tracers, num_prog, num_diag, num_family)

integer,  intent(in) :: model
integer, intent(out), optional :: num_tracers, num_prog, num_diag, num_family

if(.not.module_is_initialized) call tracer_manager_init

!   <ERROR MSG="Model number is invalid." STATUS="FATAL">
!     The index of the component model is invalid.
!   </ERROR>
if (model .ne. MODEL_ATMOS .and. model .ne. MODEL_LAND .and. &
    model .ne. MODEL_OCEAN .and. model .ne. MODEL_ICE  .and. &
    model .ne. MODEL_COUPLER)  &
    call mpp_error(FATAL,"get_number_tracers : Model number is invalid.")

if (present(num_tracers)) num_tracers = total_tracers(model)
if (present(num_prog))    num_prog    = prog_tracers(model)
if (present(num_diag))    num_diag    = diag_tracers(model)
if (present(num_family))  num_family  = 0 ! Needed only for backward compatability with lima

end subroutine get_number_tracers
!</SUBROUTINE>


! <SUBROUTINE NAME="get_tracer_indices">

!   <OVERVIEW>
!     Routine to return the component model tracer indices as defined within
!     the tracer manager.
!   </OVERVIEW>
!   <DESCRIPTION>
!     If several models are being used or redundant tracers have been written to
! the tracer_table, then the indices in the component model and the tracer
! manager may not have a one to one correspondence. Therefore the component
! model needs to know what index to pass to calls to tracer_manager routines in
! order that the correct tracer information be accessed.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call get_tracer_indices(model, ind, prog_ind, diag_ind)
!   </TEMPLATE>

!   <IN NAME="model" TYPE="integer">
!     A parameter to identify which model is being used.
!   </IN>
!   <OUT NAME="ind" TYPE="integer, optional" DIM="(:)" >
! An array containing the tracer manager defined indices for
!             all the tracers within the component model.
!   </OUT>
!   <OUT NAME="prog_ind" TYPE="integer, optional" DIM="(:)" >
! An array containing the tracer manager defined indices for
!             the prognostic tracers within the component model.
!   </OUT>
!   <OUT NAME="diag_ind" TYPE="integer, optional" DIM="(:)" >
! An array containing the tracer manager defined indices for
!             the diagnostic tracers within the component model.
!   </OUT>
subroutine get_tracer_indices(model, ind, prog_ind, diag_ind, fam_ind)

integer, intent(in) :: model
integer, intent(out), dimension(:), optional :: ind, prog_ind, diag_ind, fam_ind

integer :: i, j, np, nd, n

if(.not.module_is_initialized) call tracer_manager_init

nd=0;np=0;n=0

! Initialize arrays with dummy values
if (PRESENT(ind))      ind      = NO_TRACER
if (PRESENT(prog_ind)) prog_ind = NO_TRACER
if (PRESENT(diag_ind)) diag_ind = NO_TRACER
if (PRESENT(fam_ind))  fam_ind  = NO_TRACER

do i = 1, MAX_TRACER_FIELDS
j = TRACER_ARRAY(model,i)
 if ( j /= NOTRACER) then
   if ( model == tracers(j)%model) then
      if (PRESENT(ind)) then
         n=n+1
!   <ERROR MSG="index array size too small in get_tracer_indices" STATUS="FATAL">
!     The global index array is too small and cannot contain all the tracer numbers.
!   </ERROR>
         if (n > size(ind(:))) call mpp_error(FATAL,'get_tracer_indices : index array size too small in get_tracer_indices')
         ind(n) = i
      endif

      if (tracers(j)%is_prognostic.and.PRESENT(prog_ind)) then
         np=np+1
!   <ERROR MSG="prognostic array size too small in get_tracer_indices" STATUS="FATAL">
!     The prognostic index array is too small and cannot contain all the tracer numbers.
!   </ERROR>
         if ( np > size( prog_ind(:)))call mpp_error(FATAL,&
                                          'get_tracer_indices : prognostic array size too small in get_tracer_indices')
         prog_ind(np) = i
      else if (.not.tracers(j)%is_prognostic .and. PRESENT(diag_ind)) then
         nd = nd+1
!   <ERROR MSG="diagnostic array size too small in get_tracer_indices" STATUS="FATAL">
!     The diagnostic index array is too small and cannot contain all the tracer numbers.
!   </ERROR>
         if (nd > size(diag_ind(:))) call mpp_error(FATAL,&
                                         'get_tracer_indices : diagnostic array size too small in get_tracer_indices')
         diag_ind(nd) = i
      endif
   endif
 endif
enddo

return
end subroutine get_tracer_indices
!</SUBROUTINE>

!<FUNCTION NAME= "get_tracer_index">
!   <OVERVIEW>
!     Function which returns the number assigned to the tracer name.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This is a function which returns the index, as implied within the component model.
!     There are two overloaded interfaces: one of type integer, one logical.
!   </DESCRIPTION>
!   <TEMPLATE>
!     integer: index = get_tracer_index(model, name,        indices, verbose)
!     logical:    if ( get_tracer_index(model, name, index, indices, verbose) ) then
!   </TEMPLATE>
!   <IN NAME="model" TYPE="integer">
!     A parameter to identify which model is being used.
!   </IN>
!   <IN NAME="name" TYPE="character">
!     The name of the tracer (as assigned in the field table).
!   </IN>
!   <IN NAME="indices" TYPE="integer, optional" DIM="(:)">
!     An array indices.
!     When present, the returned index will limit the search for the tracer
!     to those tracers whos indices are amoung those in array "indices".
!     This would be useful when it is desired to limit the search to a subset
!     of the tracers. Such a subset might be the diagnostic or prognostic tracers.
!     (Note that subroutine get_tracer_indices returns these subsets)
!   </IN>
!   <IN NAME="verbose" TYPE="logical, optional">
!     A flag to allow the message saying that a tracer with this name has not 
!     been found. This should only be used for debugging purposes.
!   </IN>
!   <OUT NAME="get_tracer_index" TYPE="integer">
!     integer function:
!       The index of the tracer named "name". 
!       If no tracer by that name exists then the returned value is NO_TRACER.
!     logical function:
!       If no tracer by that name exists then the returned value is .false.,
!       otherwise the returned value is .true.
!   </OUT>
function get_tracer_index_integer(model, name, indices, verbose)

integer, intent(in)                         :: model
character(len=*), intent(in)                :: name
integer, intent(in), dimension(:), optional :: indices
logical, intent(in), optional               :: verbose
integer :: get_tracer_index_integer

integer :: i

if(.not.module_is_initialized) call tracer_manager_init

get_tracer_index_integer = NO_TRACER

if (PRESENT(indices)) then
    do i = 1, size(indices(:))
       if (model == tracers(indices(i))%model .and. lowercase(trim(name)) == trim(tracers(indices(i))%tracer_name)) then
           get_tracer_index_integer = i
           exit
       endif
    enddo
else
    do i=1, num_tracer_fields
       if(TRACER_ARRAY(model,i) == NOTRACER) cycle
       if (lowercase(trim(name)) == trim(tracers(TRACER_ARRAY(model,i))%tracer_name)) then
           get_tracer_index_integer = i!TRACER_ARRAY(model,i)
           exit
       endif
    enddo
end if

verbose_local=.FALSE.
if (present(verbose)) verbose_local=verbose

if (verbose_local) then
! <ERROR MSG="tracer with this name not found: X" STATUS="NOTE">
  if (get_tracer_index_integer == NO_TRACER ) then
    call mpp_error(NOTE,'get_tracer_index : tracer with this name not found: '//trim(name))
  endif
! </ERROR>
endif
   
return

end function get_tracer_index_integer

!#######################################################################
function get_tracer_index_logical(model, name, index, indices, verbose)

integer, intent(in)                         :: model
character(len=*), intent(in)                :: name
integer, intent(out)                        :: index
integer, intent(in), dimension(:), optional :: indices
logical, intent(in), optional               :: verbose
logical :: get_tracer_index_logical

index = get_tracer_index_integer(model, name, indices, verbose)
if(index == NO_TRACER) then
  get_tracer_index_logical = .false.
else
  get_tracer_index_logical = .true.
endif

end function get_tracer_index_logical
!</FUNCTION>

!#######################################################################
! <SUBROUTINE NAME="tracer_manager_end" >
!   <OVERVIEW>
!     Routine to write to the log file that the tracer manager is ending.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Routine to write to the log file that the tracer manager is ending.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call tracer_manager_end
!   </TEMPLATE>
subroutine tracer_manager_end

integer :: log_unit

log_unit = stdlog()
if ( mpp_pe() == mpp_root_pe() ) then
   write (log_unit,'(/,(a))') 'Exiting tracer_manager, have a nice day ...'
endif

module_is_initialized = .FALSE.

end subroutine tracer_manager_end
!</SUBROUTINE>

!#######################################################################
!
subroutine print_tracer_info(model,n)
!
! Routine to print out the components of the tracer.
! This is useful for informational purposes.
! Used in get_tracer_meta_data.
!
! Arguments:
! INTENT IN
!  i            : index of the tracer that is being printed.
!
integer, intent(in) :: model,n
integer :: i,log_unit

if(.not.module_is_initialized) call tracer_manager_init

if(mpp_pe()==mpp_root_pe() .and. TRACER_ARRAY(model,n)> 0 ) then
  i = TRACER_ARRAY(model,n)
  log_unit = stdlog()
  write(log_unit, *)'----------------------------------------------------'
  write(log_unit, *) 'Contents of tracer entry ', i
  write(log_unit, *) 'Model type and field name'
  write(log_unit, *) 'Model                : ', tracers(i)%model
  write(log_unit, *) 'Field name           : ', trim(tracers(i)%tracer_name)
  write(log_unit, *) 'Tracer units         : ', trim(tracers(i)%tracer_units)
  write(log_unit, *) 'Tracer longname      : ', trim(tracers(i)%tracer_longname)
  write(log_unit, *) 'Tracer is_prognostic : ', tracers(i)%is_prognostic
  write(log_unit, *)'----------------------------------------------------'
endif

900 FORMAT(A,2(1x,E12.6))
901 FORMAT(E12.6,1x,E12.6)


end subroutine print_tracer_info

!#######################################################################
!
! <SUBROUTINE NAME="get_tracer_names" >
!   <OVERVIEW>
!     Routine to find the names associated with a tracer number.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This routine can return the name, long name and units associated
!     with a tracer.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call get_tracer_names(model,n,name,longname, units)
!   </TEMPLATE>

!   <IN NAME="model" TYPE="integer">
!     A parameter representing the component model in use.
!   </IN>
!   <IN NAME="n" TYPE="integer">
!     Tracer number.
!   </IN>
!   <OUT NAME="name" TYPE="character" >
!     Field name associated with tracer number.
!   </OUT>
!   <OUT NAME="longname" TYPE="character, optional" >
!     The long name associated with tracer number.
!   </OUT>
!   <OUT NAME="units" TYPE="character, optional" >
!     The units associated with tracer number.
!   </OUT>

subroutine get_tracer_names(model,n,name,longname, units, err_msg)

integer,          intent(in)  :: model, n
character (len=*),intent(out) :: name
character (len=*), intent(out), optional :: longname, units, err_msg
character (len=128) :: err_msg_local
integer :: n1
character(len=11) :: chn

if(.not.module_is_initialized) call tracer_manager_init

 if (n < 1 .or. n > total_tracers(model)) then
   write(chn, '(i11)') n
   err_msg_local = ' Invalid tracer index.  Model name = '//trim(MODEL_NAMES(model))//',  Index='//trim(chn)
   if(error_handler('get_tracer_names', err_msg_local, err_msg)) return
 endif
 n1 = TRACER_ARRAY(model,n)

name = trim(tracers(n1)%tracer_name)
if (PRESENT(longname)) longname = trim(tracers(n1)%tracer_longname)
if (PRESENT(units))    units    = trim(tracers(n1)%tracer_units)

end subroutine get_tracer_names
!</SUBROUTINE>
!
!#######################################################################
!
! <FUNCTION NAME="get_tracer_name" >
!   <OVERVIEW>
!     Routine to find the names associated with a tracer number.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This routine can return the name, long name and units associated with a tracer.
!     The return value of get_tracer_name is .false. when a FATAL error condition is
!     detected, otherwise the return value is .true.
!   </DESCRIPTION>
!   <TEMPLATE>
!     if(.not.get_tracer_name(model,n,name,longname, units, err_msg)) call mpp_error(.....
!   </TEMPLATE>

!   <IN NAME="model" TYPE="integer">
!     A parameter representing the component model in use.
!   </IN>
!   <IN NAME="n" TYPE="integer">
!     Tracer number.
!   </IN>
!   <OUT NAME="name" TYPE="character" >
!     Field name associated with tracer number.
!   </OUT>
!   <OUT NAME="longname" TYPE="character, optional" >
!     The long name associated with tracer number.
!   </OUT>
!   <OUT NAME="units" TYPE="character, optional" >
!     The units associated with tracer number.
!   </OUT>
!   <OUT NAME="err_msg" TYPE="character, optional" >
!     When present:
!       If a FATAL error condition is detected then err_msg will contain an error message
!       and the return value of get_tracer_name will be .false.
!       If no FATAL error is detected err_msg will be filled with space characters and
!       and the return value of get_tracer_name will be .true.
!     When not present:
!       A FATAL error will result in termination inside get_tracer_name without returning.
!       If no FATAL error is detected the return value of get_tracer_name will be .true.
!   </OUT>

function get_tracer_name(model,n,name,longname, units, err_msg)

logical :: get_tracer_name
integer,          intent(in)  :: model, n
character (len=*),intent(out) :: name
character (len=*), intent(out), optional :: longname, units, err_msg
character (len=128) :: err_msg_local
integer :: n1
character(len=11) :: chn

if(.not.module_is_initialized) call tracer_manager_init

 if (n < 1 .or. n > total_tracers(model)) then
   write(chn, '(i11)') n
   err_msg_local = ' Invalid tracer index.  Model name = '//trim(MODEL_NAMES(model))//',  Index='//trim(chn)
   if(error_handler('get_tracer_name', err_msg_local, err_msg)) then
     get_tracer_name = .false.
     return
   endif
 else
   get_tracer_name = .true.
 endif
 n1 = TRACER_ARRAY(model,n)

name = trim(tracers(n1)%tracer_name)
if (PRESENT(longname)) longname = trim(tracers(n1)%tracer_longname)
if (PRESENT(units))    units    = trim(tracers(n1)%tracer_units)

end function get_tracer_name
!</FUNCTION>
!
!#######################################################################
!
!<FUNCTION NAME= "check_if_prognostic">
!   <OVERVIEW>
!    Function to see if a tracer is prognostic or diagnostic.
!   </OVERVIEW>
!   <DESCRIPTION>
!    All tracers are assumed to be prognostic when read in from the field_table
!    However a tracer can be changed to a diagnostic tracer by adding the line
!    "tracer_type","diagnostic"
!    to the tracer description in field_table.
!   </DESCRIPTION>
!   <TEMPLATE>
!     logical =check_if_prognostic(model, n)
!   </TEMPLATE>

!   <IN NAME="model" TYPE="integer">
!     A parameter representing the component model in use.
!   </IN>
!   <IN NAME="n" TYPE="integer">
!     Tracer number
!   </IN>
!   <OUT NAME="check_if_prognostic" TYPE="logical">
!     A logical flag set TRUE if the tracer is 
!                        prognostic.
!   </OUT>
function check_if_prognostic(model, n, err_msg)

integer, intent(in) :: model, n
logical             :: check_if_prognostic
character(len=*), intent(out), optional :: err_msg
character(len=128) :: err_msg_local
character(len=11) :: chn

if(.not.module_is_initialized) call tracer_manager_init

if (n < 1 .or. n > total_tracers(model)) then
  write(chn, '(i11)') n
  err_msg_local = ' Invalid tracer index.  Model name = '//trim(MODEL_NAMES(model))//',  Index='//trim(chn)
  check_if_prognostic = .true.
  if(error_handler('check_if_prognostic', err_msg_local, err_msg)) return
endif

!Convert local model index to tracer_manager index

check_if_prognostic = tracers(TRACER_ARRAY(model,n))%is_prognostic

end function check_if_prognostic
!</FUNCTION>

! Does tracer need mass or positive definite adjustments?
!#######################################################################
! Function to check whether tracer should have its mass adjusted
function adjust_mass(model, n, err_msg)

integer, intent(in) :: model, n
logical             :: adjust_mass
character(len=*), intent(out), optional :: err_msg
character(len=128) :: err_msg_local
character(len=11) :: chn

if(.not.module_is_initialized) call tracer_manager_init

if (n < 1 .or. n > total_tracers(model)) then
  write(chn, '(i11)') n
  err_msg_local = ' Invalid tracer index.  Model name = '//trim(MODEL_NAMES(model))//',  Index='//trim(chn)
  adjust_mass = .true.
  if(error_handler('adjust_mass', err_msg_local, err_msg)) return
endif

!Convert local model index to tracer_manager index

adjust_mass = tracers(TRACER_ARRAY(model,n))%needs_mass_adjust

end function adjust_mass

! Function to check whether tracer should be adjusted to remain positive definite
function adjust_positive_def(model, n, err_msg)

integer, intent(in) :: model, n
logical             :: adjust_positive_def
character(len=*), intent(out), optional :: err_msg
character(len=128) :: err_msg_local
character(len=11) :: chn

if(.not.module_is_initialized) call tracer_manager_init

if (n < 1 .or. n > total_tracers(model)) then
  write(chn, '(i11)') n
  err_msg_local = ' Invalid tracer index.  Model name = '//trim(MODEL_NAMES(model))//',  Index='//trim(chn)
  adjust_positive_def = .true.
  if(error_handler('adjust_positive_def', err_msg_local, err_msg)) return
endif

!Convert local model index to tracer_manager index

adjust_positive_def = tracers(TRACER_ARRAY(model,n))%needs_positive_adjust

end function adjust_positive_def

!
!#######################################################################
!
! <SUBROUTINE NAME="set_tracer_profile" >
!   <OVERVIEW>
!     Subroutine to set the tracer field to the wanted profile.
!   </OVERVIEW>
!   <DESCRIPTION>
!     If the profile type is 'fixed' then the tracer field values are set 
! equal to the surface value.
! If the profile type is 'profile' then the top/bottom of model and
! surface values are read and an exponential profile is calculated,
! with the profile being dependent on the number of levels in the
! component model. This should be called from the part of the dynamical
! core where tracer restarts are called in the event that a tracer
! restart file does not exist.
!
!  This can be activated by adding a method to the field_table
! e.g.
!  "profile_type","fixed","surface_value = 1e-12"
!  would return values of surf_value = 1e-12 and a multiplier of 1.0
!  One can use these to initialize the entire field with a value of 1e-12.
!
!  "profile_type","profile","surface_value = 1e-12, top_value = 1e-15"
!   In a 15 layer model this would return values of surf_value = 1e-12 and 
!   multiplier = 0.6309573 i.e 1e-15 = 1e-12*(0.6309573^15)
!   In this case the model should be MODEL_ATMOS as you have a "top" value.
!
!   If you wish to initialize the ocean model, one can use bottom_value instead
!   of top_value.

!   </DESCRIPTION>
!   <TEMPLATE>
!     call set_tracer_profile(model, n, tracer)
!   </TEMPLATE>

!   <IN NAME="model" TYPE="integer">
!     A parameter representing the component model in use.
!   </IN>
!   <IN NAME="n" TYPE="integer">
!     Tracer number.
!   </IN>
!   <INOUT NAME="tracer_array" TYPE="real">
!     The initialized tracer array.
!   </INOUT>

subroutine set_tracer_profile(model, n, tracer, err_msg)

integer,  intent(in)  :: model, n
   real, intent(inout), dimension(:,:,:) :: tracer
character(len=*), intent(out), optional :: err_msg

real    :: surf_value, multiplier
integer :: numlevels, k, n1, flag
real    :: top_value, bottom_value
character(len=80) :: scheme, control,profile_type
character(len=128) :: err_msg_local
character(len=11) :: chn

if(.not.module_is_initialized) call tracer_manager_init

if (n < 1 .or. n > total_tracers(model)) then
  write(chn, '(i11)') n
  err_msg_local = ' Invalid tracer index.  Model name = '//trim(MODEL_NAMES(model))//',  Index='//trim(chn)
  if(error_handler('set_tracer_profile', err_msg_local, err_msg)) return
endif
n1 = TRACER_ARRAY(model,n)

!default values
profile_type  = 'Fixed'
surf_value = 0.0E+00
top_value  = surf_value
bottom_value = surf_value
multiplier = 1.0

tracer = surf_value

if ( query_method ( 'profile_type',model,n,scheme,control)) then
!Change the tracer_number to the tracer_manager version

  if(lowercase(trim(scheme(1:5))).eq.'fixed') then
    profile_type                   = 'Fixed'
    flag =parse(control,'surface_value',surf_value)
    multiplier = 1.0
    tracer = surf_value
  endif

  if(lowercase(trim(scheme(1:7))).eq.'profile') then
    profile_type                   = 'Profile'
    flag=parse(control,'surface_value',surf_value)
    if (surf_value .eq. 0.0) &
      call mpp_error(FATAL,'set_tracer_profile : Cannot have a zero surface value for an exponential profile. Tracer '&
                           //tracers(n1)%tracer_name//" "//control//" "//scheme)
    select case (tracers(n1)%model)
      case (MODEL_ATMOS)
        flag=parse(control,'top_value',top_value)
        if(mpp_pe()==mpp_root_pe() .and. flag == 0) &
           call mpp_error(NOTE,'set_tracer_profile : Parameter top_value needs to be defined for the tracer profile.')
      case (MODEL_OCEAN)
        flag =parse(control,'bottom_value',bottom_value)
        if(mpp_pe() == mpp_root_pe() .and. flag == 0) &
           call mpp_error(NOTE,'set_tracer_profile : Parameter bottom_value needs to be defined for the tracer profile.')
      case default
!   Should there be a NOTE or WARNING message here?
    end select

! If profile type is profile then set the surface value to the input
! value and calculate the vertical multiplier.
! 
! Assume an exponential decay/increase from the surface to the top level
!  C = C0 exp ( -multiplier* level_number)
!  => multiplier = exp [ ln(Ctop/Csurf)/number_of_levels]
!
numlevels = size(tracer,3) -1
    select case (tracers(n1)%model)
      case (MODEL_ATMOS)
        multiplier = exp( log (top_value/surf_value) /numlevels)
        tracer(:,:,1) = surf_value
        do k = 2, size(tracer,3)
          tracer(:,:,k) = tracer(:,:,k-1) * multiplier
        enddo
      case (MODEL_OCEAN)
        multiplier = exp( log (bottom_value/surf_value) /numlevels)
        tracer(:,:,size(tracer,3)) = surf_value
        do k = size(tracer,3) - 1, 1, -1
          tracer(:,:,k) = tracer(:,:,k+1) * multiplier
        enddo
      case default
    end select
  endif !scheme.eq.profile

  if (mpp_pe() == mpp_root_pe() ) write(*,700) 'Tracer ',trim(tracers(n1)%tracer_name),    &
                            ' initialized with surface value of ',surf_value, &
                            ' and vertical multiplier of ',multiplier
  700 FORMAT (3A,E12.6,A,F10.6)

endif ! end of query scheme

end subroutine set_tracer_profile
!</SUBROUTINE>

!
!#######################################################################
!
! <FUNCTION NAME="query_method" >
!   <OVERVIEW>
!     A function to query the "methods" associated with each tracer.
!   </OVERVIEW>
!   <DESCRIPTION>
!     A function to query the "methods" associated with each tracer. The
!  "methods" are the parameters of the component model that can be
!  adjusted by user by placing formatted strings, associated with a
!  particular tracer, within the field table.
!  These methods can control the advection, wet deposition, dry
!  deposition or initial profile of the tracer in question. Any
!  parametrization can use this function as long as a routine for parsing
!  the name and control strings are provided by that routine.
!   </DESCRIPTION>
!   <TEMPLATE>
!     logical =query_method  (method_type, model, n, name, control)
!   </TEMPLATE>

!   <IN NAME="method_type" TYPE="character">
!     The method that is being requested.
!   </IN>
!   <IN NAME="model" TYPE="integer">
!     A parameter representing the component model in use.
!   </IN>
!   <IN NAME="n" TYPE="integer">
!     Tracer number
!   </IN>
!   <OUT NAME="name" TYPE="character">
!     A string containing the modified name to be used with
!     method_type. i.e. "2nd_order" might be the default for 
!     advection. One could use "4th_order" here to modify 
!     that behaviour.
!   </OUT>
!   <OUT NAME="control" TYPE="character, optional">
!     A string containing the modified parameters that are 
!     associated with the method_type and name.
!   </OUT>
!   <OUT NAME="query_method" TYPE="logical">
!      A flag to show whether method_type exists with regard to
!      tracer n. If method_type is not present then one must
!      have default values.
!   </OUT>

!<NOTE>
!  At present the tracer manager module allows the initialization of a tracer
!  profile if a restart does not exist for that tracer. 
!  Options for this routine are as follows
!
!  Tracer profile setup
!  ==================================================================
!  |method_type  |method_name  |method_control                      |
!  ==================================================================
!  |profile_type |fixed        |surface_value = X                   |
!  |profile_type |profile      |surface_value = X, top_value = Y    |(atmosphere)
!  |profile_type |profile      |surface_value = X, bottom_value = Y |(ocean)
!  ==================================================================
!
!</NOTE>
 function query_method  (method_type, model, n, name, control, err_msg)
!
!  A function to query the schemes associated with each tracer. 
!  
!  INTENT IN
!   method_type  : The method that is being requested.
!   model        : The model that you are calling this function from.
!   n            : The tracer number.
!  INTENT OUT
!   name         : A string containing the modified name to be used with
!                  method_type. i.e. "2nd_order" might be the default for 
!                  advection. One could use "4th_order" here to modify 
!                  that behaviour.
!   control      : A string containing the modified parameters that are 
!                  associated with the method_type and name.
!   query_method : A flag to show whether method_type exists with regard 
!                  to tracer n. If method_type is not present then one
!                  must have default values.

 character(len=*), intent(in)            :: method_type
 integer         , intent(in)            :: model, n
 character(len=*), intent(out)           :: name
 character(len=*), intent(out), optional :: control, err_msg
 logical                                 :: query_method

 integer :: n1
 character(len=256) :: list_name, control_tr
 character(len=11)  :: chn
 character(len=128) :: err_msg_local

 if(.not.module_is_initialized) call tracer_manager_init

!Convert the local model tracer number to the tracer_manager version.

 if (n < 1 .or. n > total_tracers(model)) then
   write(chn, '(i11)') n
   err_msg_local = ' Invalid tracer index.  Model name = '//trim(MODEL_NAMES(model))//',  Index='//trim(chn)
   if(error_handler('query_method', err_msg_local, err_msg)) return
 endif

 n1 = TRACER_ARRAY(model,n)

 select case(model)
  case (MODEL_COUPLER)
   list_name = "/coupler_mod/tracer/"//trim(tracers(n1)%tracer_name)//"/"//trim(method_type)
  case (MODEL_ATMOS)
   list_name = "/atmos_mod/tracer/"//trim(tracers(n1)%tracer_name)//"/"//trim(method_type)
  case (MODEL_OCEAN)
   list_name = "/ocean_mod/tracer/"//trim(tracers(n1)%tracer_name)//"/"//trim(method_type)
  case (MODEL_ICE  )
   list_name = "/ice_mod/tracer/"//trim(tracers(n1)%tracer_name)//"/"//trim(method_type)
  case (MODEL_LAND )
   list_name = "/land_mod/tracer/"//trim(tracers(n1)%tracer_name)//"/"//trim(method_type)
  case default
   list_name = "/default/tracer/"//trim(tracers(n1)%tracer_name)//"/"//trim(method_type)
 end select

 name = ''
 control_tr = ''
 query_method = fm_query_method(list_name, name, control_tr)

 if ( present(control)) control = trim(control_tr)

 end function query_method
!</FUNCTION>

!<SUBROUTINE NAME="set_tracer_atts">
!   <OVERVIEW>
!     A subroutine to allow the user set the tracer longname and units from the 
!     tracer initialization routine.
!   </OVERVIEW>
!   <DESCRIPTION>
!     A function to allow the user set the tracer longname and units from the 
!     tracer initialization routine. It seems sensible that the user who is 
!     coding the tracer code will know what units they are working in and it 
!     is probably safer to set the value in the tracer code rather than in 
!     the field table.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call set_tracer_atts(model, name, longname, units)
!   </TEMPLATE>

!   <IN NAME="model" TYPE="integer">
!     A parameter representing the component model in use.
!   </IN>
!   <IN NAME="name" TYPE="character">
!     Tracer name.
!   </IN>
!   <OUT NAME="longname" TYPE="character, optional">
!     A string describing the longname of the tracer for output to NetCDF files
!   </OUT>
!   <OUT NAME="units" TYPE="character, optional">
!     A string describing the units of the tracer for output to NetCDF files
!   </OUT>
subroutine set_tracer_atts(model, name, longname, units)

integer, intent(in)                    :: model
character(len=*), intent(in)           :: name
character(len=*), intent(in), optional :: longname, units

integer :: n, index
logical :: success
character(len=128) :: list_name

if ( get_tracer_index(model,name,n) ) then
    tracers(TRACER_ARRAY(model,n))%tracer_units   = units
    tracers(TRACER_ARRAY(model,n))%tracer_longname = longname
  select case(model)
    case(MODEL_COUPLER) 
      list_name = "/coupler_mod/tracer/"//trim(name)
    case(MODEL_ATMOS) 
      list_name = "/atmos_mod/tracer/"//trim(name)
    case(MODEL_OCEAN) 
      list_name = "/ocean_mod/tracer/"//trim(name)
    case(MODEL_LAND) 
      list_name = "/land_mod/tracer/"//trim(name)
    case(MODEL_ICE) 
      list_name = "/ice_mod/tracer/"//trim(name)
    case DEFAULT 
      list_name = "/"//trim(name)
  end select      

! Method_type is a list, method_name is a name of a parameter and method_control has the value.
!    list_name = trim(list_name)//"/longname"
  if ( fm_exists(list_name)) then
    success = fm_change_list(list_name)
    if ( present(longname) ) then
      if ( longname .ne. "" ) index = fm_new_value('longname',longname)
    endif
    if ( present(units) ) then
      if (units .ne. "" ) index = fm_new_value('units',units)
    endif
  endif  
    
else
    call mpp_error(NOTE,'set_tracer_atts : Trying to set longname and/or units for non-existent tracer : '//trim(name))
endif

end subroutine set_tracer_atts
!</SUBROUTINE>

!<SUBROUTINE NAME="set_tracer_method">
!   <OVERVIEW> 
!      A subroutine to allow the user to set some tracer specific methods.
!   </OVERVIEW>
!   <DESCRIPTION>
!      A subroutine to allow the user to set methods for a specific tracer. 
!   </DESCRIPTION>
!   <TEMPLATE>
!     call set_tracer_method(model, name, method_type, method_name, method_control)
!   </TEMPLATE>

!   <IN NAME="model" TYPE="integer">
!     A parameter representing the component model in use.
!   </IN>
!   <IN NAME="name" TYPE="character">
!     Tracer name.
!   </IN>
!   <IN NAME="method_type" TYPE="character">
!     The type of the method to be set.
!   </IN>
!   <IN NAME="method_name" TYPE="character">
!     The name of the method to be set.
!   </IN>
!   <IN NAME="method_control" TYPE="character">
!     The control parameters of the method to be set.
!   </IN>
     
subroutine set_tracer_method(model, name, method_type, method_name, method_control)

integer, intent(in)                    :: model
character(len=*), intent(in)           :: name
character(len=*), intent(in)           :: method_type
character(len=*), intent(in)           :: method_name
character(len=*), intent(in)           :: method_control

integer :: n, num_method, index
logical :: success
character(len=128) :: list_name

if ( get_tracer_index(model,name,n) ) then
  tracers(n)%num_methods = tracers(n)%num_methods + 1
  num_method = tracers(n)%num_methods

  select case(model)
    case(MODEL_COUPLER)
      list_name = "/coupler_mod/tracer/"//trim(name)
    case(MODEL_ATMOS)
      list_name = "/atmos_mod/tracer/"//trim(name)
    case(MODEL_OCEAN)
      list_name = "/ocean_mod/tracer/"//trim(name)
    case(MODEL_LAND)
      list_name = "/land_mod/tracer/"//trim(name)
    case(MODEL_ICE)
      list_name = "/ice_mod/tracer/"//trim(name)
    case DEFAULT
      list_name = "/"//trim(name)
  end select      

  if ( method_control .ne. "" ) then
! Method_type is a list, method_name is a name of a parameter and method_control has the value.
    list_name = trim(list_name)//"/"//trim(method_type)
    if ( fm_exists(list_name)) then
      success = fm_change_list(list_name)
      index = fm_new_value(method_type,method_control)
    endif
  else
    call mpp_error(NOTE,'set_tracer_method : Trying to set a method for non-existent tracer : '//trim(name))
  endif
endif

end subroutine set_tracer_method
!</SUBROUTINE>

function error_handler(routine, err_msg_local, err_msg)
logical :: error_handler
character(len=*), intent(in) :: routine, err_msg_local
character(len=*), intent(out), optional :: err_msg

if(present(err_msg)) then
  err_msg = err_msg_local
  error_handler = .true.    
else
  call mpp_error(FATAL,trim(routine)//': '//trim(err_msg_local))
endif

end function error_handler

end module tracer_manager_mod

                    module cloud_obs_mod

!-----------------------------------------------------------------------
!
!           sets up observed (climatological) clouds
!
!-----------------------------------------------------------------------

use horiz_interp_mod, only: horiz_interp_type, horiz_interp_init, &
                            horiz_interp_new, horiz_interp, horiz_interp_del
use          mpp_mod, only: input_nml_file
use          fms_mod, only: file_exist, error_mesg, FATAL, NOTE,     &
                            open_namelist_file, close_file,          &
                            check_nml_error, mpp_pe, mpp_root_pe,    &
                            write_version_number, stdlog, open_ieee32_file
use fms_io_mod,       only: read_data
use time_manager_mod, only: time_type, get_date
use  time_interp_mod, only: time_interp

implicit none
private

!---------- public interfaces ----------

public  cloud_obs, cloud_obs_init, cloud_obs_end

!-----------------------------------------------------------------------
!   ---------- private data ------------

   character(len=128) :: version = '$Id: cloud_obs.F90,v 19.0 2012/01/06 20:02:13 fms Exp $'
   character(len=128) :: tagname = '$Name: tikal $'

      real, allocatable, dimension(:,:,:) :: clda,cldb
      real, allocatable, dimension(:)     :: londat,latdat
   integer :: yrclda=-99,moclda=-99, yrcldb=-99,mocldb=-99
   logical :: module_is_initialized = .false.

!   ---------- namelist ---------------

   logical :: use_climo = .true.
   integer :: verbose = 0

   namelist /cloud_obs_nml/ use_climo, verbose


!------------ input grid parameters ----------
     integer, parameter :: mobs=144, nobs=72
        real :: sb, wb, dx, dy

     type (horiz_interp_type), save :: Interp   ! kerr
!-----------------------------------------------------------------------

contains

!#######################################################################

subroutine cloud_obs ( is, js, Time, cldamt )

!-----------------------------------------------------------------------
!    routine that reads monthly records of climatological
!    isccp cloud amount and then linearly interpolates between them
!-----------------------------------------------------------------------
!     input
!     -----
!     is, js   starting i,j indices (dimension(2))
!     Time     current time (time_type)
!
!     output
!     ------
!     cldamt    cloud amount data on horizontal grid,
!               dimensioned ix x jx x 3, for high,med, & low clouds.
!-----------------------------------------------------------------------
        integer, intent(in)                    :: is, js
type(time_type), intent(in)                    :: Time
           real, intent(out), dimension(:,:,:) :: cldamt
!-----------------------------------------------------------------------
      real, dimension(mobs,nobs,3) :: obs

   integer  day,month,year, second,minute,hour
   integer  month1,month2,mo,year1,year2,yr,unit,irec,n
   integer  ie,je,ix,jx,pe
      real  dmonth,dif
   logical,save :: useclimo1,useclimo2
   logical      :: unit_opened
   integer :: nrecords, tlvl
!-----------------------------------------------------------------------

   if ( .not. module_is_initialized)  &
                call error_mesg ('cloud_obs',  &
                         'cloud_obs_init has not been called.',FATAL)

   if (size(cldamt,3) < 3) call error_mesg ('cloud_obs',  &
                                'dimension 3 of cldamt is < 3', FATAL)

   pe = mpp_pe()

!------------ size & position of this window ---------------------------
      ix=size(cldamt,1); jx=size(cldamt,2)
      ie=is+ix-1;        je=js+jx-1

!  --- check existence of cloud data set --------

      if (.not.file_exist('INPUT/cloud_obs.data')) then
        call error_mesg ('observed_cloud',  &
                    'file INPUT/cloud_obs.data does not exist.', FATAL)
      endif

!-----------------------------------------------------------------------
! ---- time interpolation for months -----

      call time_interp (Time, dmonth, year1, year2, month1, month2)
      
! ---- force climatology ----

      if (use_climo) then
          year1 = 0; year2 = 0
      endif

!-----------------------------------------------------------------------
      ! This code works with the current 1 year (12 records) cloud_obs.data.nc
      ! converted from a one year 12 records native format input file.
      ! In the future, a multi-year, multi-month data series maybe introduced,
      ! we can easily modify the code to accommodate the change. As of now,
      ! since the native format data file does not contain any year information,
      ! we don't process year and just use month to get data.
      if(file_exist('INPUT/cloud_obs.data.nc')) then
         call get_date (Time, year, month, day, hour, minute, second)
         if(mpp_pe() == mpp_root_pe()) call error_mesg ('cloud_obs_mod',  &
              'Reading NetCDF formatted input file: INPUT/cloud_obs.data.nc', NOTE)
         call read_data('INPUT/cloud_obs.data.nc', 'nrecords', nrecords, no_domain=.true.)
         tlvl = month
         call read_data('INPUT/cloud_obs.data.nc', 'obs', obs, timelevel=tlvl, no_domain=.true.)
         do n=1,3
            call horiz_interp (Interp, obs(:,:,n), cldb(:,:,n), verbose=verbose)
         enddo
         goto 381
      end if
      
      unit_opened=.false.

!    assumption is being made that the record for (year1,month1)
!    precedes the record for (year2,month2)

      if (year1 .ne. yrclda .or. month1 .ne. moclda) then
         
          unit_opened=.true.
          unit = open_ieee32_file ( 'INPUT/cloud_obs.data', action='read' )
          irec=0
          do
!!!!               read (unit,end=380)  yr,mo,obs
             yr=0; read (unit,end=380)     mo,obs
             irec=irec+1
             dif=12*(year1-yr)+month1-mo
             if (dif == 0) then
                yrclda=yr
                moclda=mo
                useclimo1=.false.
                if (yr == 0) useclimo1=.true.
                exit
             endif
!           --- otherwise use climo ---
             if (yr == 0 .and. month1 == mo) then
                yrclda=yr
                moclda=mo
                useclimo1=.true.
                exit
             endif
          enddo
          do n=1,3
            call horiz_interp (Interp, obs(:,:,n), clda(:,:,n), verbose=verbose)
          enddo
      endif

      if (year2 .ne. yrcldb .or. month2 .ne. mocldb) then
          if (.not.unit_opened) then
             unit_opened=.true.
             unit = open_ieee32_file ( 'INPUT/cloud_obs.data', action='read' )
          endif
          if (useclimo1 .and. month2 <= month1 ) then
             if (verbose > 1 .and. pe == mpp_root_pe())  &
                       print *, ' rewinding INPUT/cloud_obs.data'
             rewind unit
          endif
          irec=0
          do
!!!!               read (unit,end=380)  yr,mo,obs
             yr=0; read (unit,end=380)     mo,obs
             irec=irec+1
             dif=12*(year2-yr)+month2-mo
             if (dif == 0) then
                yrcldb=yr
                mocldb=mo
                useclimo2=.false.
                if (yr == 0) useclimo2=.true.
                exit
             endif
!           --- climo ---
             if (yr == 0 .and. month2 == mo) then
                yrcldb=yr
                mocldb=mo
                useclimo2=.true.
                exit
             endif
          enddo
          do n=1,3
            call horiz_interp (Interp, obs(:,:,n), cldb(:,:,n), verbose=verbose)
          enddo
      endif
          goto 381

 380  if (pe == 0) print *, ' month1,month2=',month1,month2
      if (pe == 0) print *, ' useclimo1,useclimo2=',useclimo1,useclimo2
      call error_mesg ('observed_cloud',  &
                       'eof reading file=INPUT/cloud_obs.data', FATAL)

 381  continue

   if (unit_opened .or. file_exist('INPUT/cloud_obs.data.nc')) then
      if(unit_opened) call close_file (unit)
      if (verbose > 0 .and. pe == 0) then
         call get_date (Time, year, month, day, hour, minute, second)
         write (*,600) year,month,day, hour,minute,second
600      format (/,'from cloud_obs:',   &
              /,' date(y/m/d h:m:s) = ', &
              i4,2('/',i2.2),1x,2(i2.2,':'),i2.2)
         print *, ' dmonth=',dmonth
         print *, ' year1,month1, yrclda,moclda, useclimo1=',  &
              year1,month1, yrclda,moclda, useclimo1
         print *, ' year2,month2, yrcldb,mocldb, useclimo2=',  &
              year2,month2, yrcldb,mocldb, useclimo2
         print *, ' '
      endif
   endif

!------------ time interpolation ---------------------------------------

      do n=1,3
         cldamt(:,:,n)=clda(is:ie,js:je,n)+  &
                       dmonth*(cldb(is:ie,js:je,n)-clda(is:ie,js:je,n))
      enddo

!-----------------------------------------------------------------------

 end subroutine cloud_obs

!#######################################################################

 subroutine cloud_obs_init (lonb,latb)

!-----------------------------------------------------------------------
!  lonb  =   longitude in radians at the grid box corners
!  latb  =   longitude in radians at the grid box corners
!-----------------------------------------------------------------------
   real, intent(in), dimension(:,:) :: lonb,latb
!-----------------------------------------------------------------------
   real    :: hpie
   integer :: i, j, in, jn, unit, ierr, io, logunit
   real :: lonb_obs(mobs+1), latb_obs(nobs+1)

   if (module_is_initialized) return

!------- read namelist --------

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=cloud_obs_nml, iostat=io)
      ierr = check_nml_error(io,"cloud_obs_nml")
#else
      if (file_exist('input.nml')) then
          unit = open_namelist_file ()
          ierr=1; do while (ierr /= 0)
             read  (unit, nml=cloud_obs_nml, iostat=io, end=10)
             ierr = check_nml_error(io,'cloud_obs_nml')
          enddo
  10      call close_file (unit)
      endif
#endif

!------- write version number and namelist ---------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
           logunit = stdlog()
           write (logunit, nml=cloud_obs_nml)
      endif

!------- setup for observed grid -------

      hpie=acos(0.0)
      sb=-hpie; wb=0.0; dx=4.0*hpie/float(mobs); dy=2.0*hpie/float(nobs)

      do i = 1, mobs
         lonb_obs(i) = wb + float(i-1)*dx
      enddo
         lonb_obs(mobs+1) = lonb_obs(1) + 4.0*hpie
      do j = 2, nobs
         latb_obs(i) = wb + float(i-1)*dx
      enddo
         latb_obs(1) = -hpie
         latb_obs(nobs+1) = hpie

      call horiz_interp_init
      call horiz_interp_new ( Interp, lonb_obs, latb_obs, lonb, latb )


!------- setup for data grid -------

      in=size(lonb,1); jn=size(latb,2)
      allocate (clda(in-1,jn-1,3), cldb(in-1,jn-1,3))

      module_is_initialized = .true.

!-----------------------------------------------------------------------

 end subroutine cloud_obs_init

!#######################################################################

 subroutine cloud_obs_end
 
      module_is_initialized = .false.

!-----------------------------------------------------------------------

 end subroutine cloud_obs_end

!#######################################################################

end module cloud_obs_mod

program regrid
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Zhi Liang </CONTACT>
  !
  ! <OVERVIEW>
  !   Since most analyses are placed on a spherical latitude-longitude grid and
  !   most global ocean models configured from mom4 are run with tripolar grids.
  !   A regridding tool is needed to regrid data from tripolar grid onto latitude-longitude 
  !   grid. This program map data from any logical rectangular grid 
  !   (tripolar or latitude-longitude) to a spherical latitude-longitude grid.
  !   When the data is on Tracer cell (T-cell), the interpolation will be a conservative 
  !   scheme. When the data is on other position (C-cell, E-cell or N-cell), regridding 
  !   is accomplished non-conservatively using a nearest neighbor distance weighting algorithm.
  ! </OVERVIEW>

  !<DESCRIPTION>
  ! Before using this regridding tool, you need to use preprocessing tool 
  ! make_xgrids to generate the grid file which contains source grid, destination 
  ! grid and exchange grid information between source grid and destination grid. 
  ! These exchange grid information is needed when doing conservative remapping.
  ! Suppose the file name of your source grid is src_grid.nc and the file name of
  ! your destination grid is dst_grid.nc (dst grid should be spherical 
  ! latitude-lontitude grid), the command will be 
  ! "make_xgrids -o src_grid.nc -a dst_grid.nc".
  ! Before using make_xgrids, you need to make sure src_grid.nc does not contain
  ! any exchange grid information. Otherwise you are not going to get the 
  ! desired exchange grid information. If your src_grid.nc do contains exchange
  ! grid information, you can remove all those fields by using ncks. Those fields are 
  ! AREA_ATMxOCN, DI_ATMxOCN, DJ_ATMxOCN, I_ATM_ATMxOCN, J_ATM_ATMxOCN, I_OCN_ATMxOCN, 
  ! J_OCN_ATMxOCN, AREA_ATMxLND, DI_ATMxLND, DJ_ATMxLND, I_ATM_ATMxLND, J_ATM_ATMxLND,
  ! I_LND_ATMxLND, J_LND_ATMxLND, AREA_LNDxOCN, DI_LNDxOCN, DJ_LNDxOCN, 
  ! I_LND_LNDxOCN, J_LND_LNDxOCN, I_OCN_LNDxOCN, J_OCN_LNDxOCN, xba, yba, xta, yta, 
  ! AREA_ATM, xbl, ybl, xtl, ytl, AREA_LND, AREA_LND_CELL, xto, yto and AREA_OCN. 
  ! After the grid file is generated, the grid file should be passed into the program 
  ! through nml option "grid_spec_file". 
  !
  ! This program expects to read data from a netcdf file, which is specfied
  ! by the namelist variable "src_data". The number of data to be remapped is 
  ! specified by num_flds. The name of field to be remapped is specified 
  ! by the namelist variable "fld_name". The output file is a netcdf file specified
  ! by the namelist variable "dst_data". Each field can be a scalar variable or
  ! a vector field, which is specified by vector_fld. The vector field should
  ! always be paired together. The data will be always on the source vertical grid.
  ! Previous experiences show that linear vertical interpolation will create lots of noises.
  ! If we find better vertical interpolation algorithm, we may implement it in the
  ! future. 
  !</DESCRIPTION>

  use mpp_mod,          only : mpp_npes, mpp_pe, mpp_root_pe, mpp_error, FATAL, NOTE, WARNING
  use mpp_mod,          only : stdout, stdlog, mpp_chksum
  use mpp_domains_mod,  only : mpp_define_layout, mpp_define_domains, domain2d
  use mpp_domains_mod,  only : mpp_global_field, mpp_get_compute_domain 
  use mpp_domains_mod,  only : mpp_domains_set_stack_size
  use fms_mod,          only : fms_init, open_namelist_file, close_file, fms_end
  use fms_mod,          only : check_nml_error, write_version_number, lowercase, uppercase
  use fms_io_mod,       only : fms_io_exit
  use constants_mod,    only : constants_init, PI, epsln
  use horiz_interp_mod, only : horiz_interp_new, horiz_interp, horiz_interp_type

  implicit none

#include "netcdf.inc"

  integer, parameter :: max_flds     = 20
  integer, parameter :: max_dims      = 20
  integer, parameter :: max_atts     = 20
  real,    parameter :: small        = 1.0e-6

  !--- namelist interface ----------------------------------------------
  !<NAMELIST NAME="regrid_nml">
  ! <DATA NAME="num_flds"  TYPE="integer" DEFAULT="0">
  !  Number of fields. 
  ! </DATA>
  ! <DATA NAME="src_data" TYPE="character(len=128)" >
  !  Name of input file containing to-be-remapped data.
  ! </DATA>
  ! <DATA NAME="dst_data" TYPE="character(len=128)" >
  !  Name of output file containing after-remapped data.
  ! </DATA>
  ! <DATA NAME="grid_spec_file" TYPE="character(len=128)" >
  !  Name of grid descriptor file containing source and target grid information, 
  !  exchange grid information between source and target grid. This grid file can 
  !  be created using preprocessing tool make_xgrids.
  ! </DATA>
  ! <DATA NAME="fld_name" TYPE="character(len=128), dimension(max_flds)" >
  !  Name of field to be regridded in input file.
  ! </DATA>
  ! <DATA NAME="fld_pos"  TYPE="character(len=1),dimension(max_flds)" DEFAULT="T">
  !  Name of grid where the field located.  Valid choices are (T)racer, (C)orner, (E)ast and (N)orth.
  ! </DATA>
  ! <DATA NAME="vector_field"  TYPE="logical,dimension(max_flds)" DEFAULT="False">
  !  True if fields are vector components. All the vector field should be paired together.
  !  That is, if vector_field(n) is .true., then vector_field(n+1) should be true.
  ! </DATA>
  ! <DATA NAME="num_nbrs" TYPE="integer">
  !  Number of nearest neighbors for regridding.
  ! </DATA>
  ! <DATA NAME="max_dist" TYPE="real" UNITS="radians">
  !  Maximum region of influence around destination grid points.
  ! </DATA>
  ! <DATA NAME="debug" TYPE="logical">
  ! For Debugging. Set true to print out chksum information for debugging reproducing ability 
  ! accross processors. default is false.
  ! </DATA>
  !</NAMELIST>

  integer            :: num_flds                  = 0
  character(len=128) :: src_data                  = 'INPUT/src_data.nc' 
  character(len=128) :: grid_spec_file            = 'INPUT/grid_spec.nc'
  character(len=128) :: dst_data                  = 'OUTPUT/dst_data.nc'
  character(len=16)  :: fld_name(max_flds)        = ''
  character(len=1)   :: fld_pos(max_flds)         = ''     ! with value 'T','C','E','N'
  logical            :: vector_fld(max_flds)      = .false. ! True if fields are vector components.
  integer            :: num_nbrs                  = 5
  real               :: max_dist                  = 0.05
  logical            :: debug                     = .false.

  namelist /regrid_nml/ num_flds, src_data, dst_data, grid_spec_file, fld_name, &
       fld_pos, vector_fld, num_nbrs, max_dist, debug

  !--- version information ---------------------------------------------
  character(len=128) :: version = '$Id: regrid.F90,v 14.0 2007/03/15 22:45:28 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

  !--- variables about source data or on source grid
  integer                             :: ncid_src                     ! ncid corresponding to source file.
  integer                             :: ni_src, nj_src, nk_src       ! source grid size
  integer                             :: ntime_src                    ! number of time levels of src data
  logical                             :: src_is_cyclic                ! indicate if the source is cyclic
  logical                             :: src_is_tripolar              ! indicate if the source grid is tripolar
  real, dimension(max_flds)           :: missing_value =  -1e20       ! missing value for source field.
  logical                             :: has_taxis,tavg_exist         ! indicate if all the field has time axis
  logical, dimension(max_flds)        :: has_zaxis     = .false.      ! indicate if the field has z axis
  real, dimension(:),     allocatable :: time_value                   ! time axis value
  real, dimension(:),     allocatable :: t1_avg, t2_avg, dt_avg       ! time average data
  real, dimension(:,:),   allocatable :: area_ocn                     ! ocean area
  real, dimension(:),     allocatable :: zt_src                       ! source vertical grid
  real, dimension(:,:),   allocatable :: geolon_t, geolat_t           ! geographic grid location on T-cell
  real, dimension(:,:),   allocatable :: geolon_e, geolat_e           ! geographic grid location on E-cell
  real, dimension(:,:),   allocatable :: geolon_c, geolat_c           ! geographic grid location on C-cell
  real, dimension(:,:),   allocatable :: geolon_n, geolat_n           ! geographic grid location on N-cell
  real, dimension(:,:),   allocatable :: sinrot, cosrot               ! rotation

  !--- variables about destination data
  integer                             :: ni_dst, nj_dst                   ! destination grid size
  integer                             :: ncid_dst                         ! ncid corresponding to destination file.
  integer                             :: id_t1_dst, id_t2_dst, id_dt_dst
  integer                             :: id_time_dst, id_dst_fld(max_flds)
  character(len=128)                  :: dims_name(max_dims)              ! output file dimension name
  integer                             :: dims_id(max_dims)  
  character(len=1)                    :: dims_cart(max_dims)              ! 'X', 'Y', 'Z' or 'T'
  character(len=1)                    :: dims_pos(max_dims)               ! 'T', 'C', 'E' or 'N'   
  real, dimension(:), allocatable     :: xt_dst, yt_dst, xb_dst, yb_dst   !lat-lon destination grid
  type(domain2D), save                :: Domain                           ! destination grid domain.
  integer                             :: isc, iec, jsc, jec               ! compute domain decompsition of dst grid.
  integer                             :: ndims_dst                        ! number of dimensions in the output file

  !--- exchange grid information
  integer, dimension(:),    allocatable :: i_atm_atmxocn
  integer, dimension(:),    allocatable :: j_atm_atmxocn
  integer, dimension(:),    allocatable :: i_ocn_atmxocn
  integer, dimension(:),    allocatable :: j_ocn_atmxocn
  real, dimension(:),       allocatable :: area_atmxocn

  !--- other variables
  logical                             :: is_root_pe                    ! if current pe is root pe.
  type(horiz_interp_type),     target :: Interp_c, Interp_e, Interp_n  ! horiz_interp data at C,E,N-cell
  integer                             :: jstart                        ! starting index to do interpolation



  !---  begin of the program -------------------------------------------

  call regrid_init()

  call read_src_grid()

  call read_dst_grid()

  call setup_interp()

  call read_xgrid()

  call get_src_info()

  call setup_meta()

  call process_data ()

  call regrid_end ()

contains

  !#####################################################################
  subroutine regrid_init
    integer          :: unit, io_status, ierr, n
    character(len=1) :: direction

    call fms_init()
    call constants_init()

    !--- reading namelist ------------------------------------------------
    unit = open_namelist_file()
    read  (unit, regrid_nml,iostat=io_status)
    write (stdout(),'(/)')
    write (stdout(), regrid_nml)
    ierr = check_nml_error(io_status,'regrid_nml')
    call close_file (unit)

    !--- write out version information ---------------------------------
    call write_version_number(version, tagname)

    if(num_flds == 0) call error_handler('regrid: nml num_fiels = 0 should be a positive number')
    if(num_flds .gt. max_flds) call error_handler('regrid: nml num_fiels is greater than maximum'// &
         ' allowed fields max_flds. Modify num_flds or increase "max_flds" at top of the program' )

    do n = 1, num_flds
       if(fld_pos(n) .ne. 'T' .and. fld_pos(n) .ne. 'C' .and. fld_pos(n) .ne. 'E' .and. fld_pos(n) .ne. 'N' ) &
            call error_handler('regrid: fld_pos should be "T", "C", "E" or "N" ')
    enddo

    !--- when all the data are on T-cell, should always use 1 processor. Since no parallization is 
    !--- implemeneted.
    if(all(fld_pos(1:num_flds) == 'T') .and. mpp_npes() > 1) then
       write(stdout(),*)'WARNING: All the fields are on T-cell but npes is greater than 1, '//&
                        'should change processor count to 1'
    endif

    !--- number of vector_fld is true should be even and should be paired adjacent.
    !--- The first one of the pair should be u-component and the second one 
    !--- should be v-component.
    n = 1
    do while ( n .le. num_flds )
       if(vector_fld(n)) then
          if(fld_pos(n) .ne. 'C') call error_handler('regrid:When the field is a vector field, we assume '// &
             'this field is located at C-cell center. ')
          n = n + 1
          if( n .gt. num_flds .or. ( .NOT. vector_fld(n) ) ) then
             call error_handler('regrid: vector field should be paired together')
          endif
       endif
       n = n+1
    enddo

    !--- write out field information to be remapped.
    Write(stdout(),*) '*****************************************************************'
    write(stdout(),*) 'number of fields to be remapped are: ', num_flds
    write(stdout(),*) 'The source data file is: ', trim(src_data)
    write(stdout(),*) 'The grid spec file that contains exchange grid is: ', trim(grid_spec_file)
    Write(stdout(),*) 'The output data will be located on source vertical grid, '

    direction = 'x'
    do n = 1, num_flds
       if(vector_fld(n)) then
          write(stdout(),*) '** field ',n,': ',trim(fld_name(n)), ' at '//  &
               trim(fld_pos(n))//'-cell center is the '//direction//'-component of a vector field'         
          if(direction == 'x') then
             direction = 'y'
          else
             direction = 'x'
          endif
       else
          write(stdout(),*) '**field ',n,': ',trim(fld_name(n)), ' at '//  &
               trim(fld_pos(n))//'-cell center is a scalar variable'            
       endif
    enddo

    is_root_pe = mpp_pe() == mpp_root_pe()

  end subroutine regrid_init

  !#################################################################
  !--- read the src grid information from file grid_spec_file. The grid information
  !--- will include boundary condition, horizontal and vertical grid information. 
  !--- No need to read source grid land/sea mask, since we can always obtain source grid land/sea
  !--- mask from source data (the value of the point is equal to missing value will be 
  !--- land point). 

  subroutine read_src_grid
    integer              :: i
    integer              :: rcode, ncid, natt
    character(len=64)    :: name, catt
    real,    allocatable :: tmp(:,:)
    logical              :: is_new_grid
    real                 :: D2R

    D2R = PI/180.

    rcode = nf_open(trim(grid_spec_file), NF_NOWRITE, ncid)    
    call error_handler('error in open file '//trim(grid_spec_file), rcode)

    !--- get boundary condition ( cyclic or tripolar )
    !--- the boundary condition are specified by global attribute 
    !--- 'x_boundary_type' and 'y_boundary_type'
    rcode =  nf_inq_natts(ncid, natt)
    call error_handler('error in inquring ngatts of file '//trim(grid_spec_file), rcode )
    do i = 1, natt
       rcode = nf_inq_attname(ncid,NF_GLOBAL,i,name )
       call error_handler('error in inquring att name of file '//trim(grid_spec_file), rcode )
       catt = ''
       select case( trim(name) )
       case('x_boundary_type')
          rcode = nf_get_att_text(ncid,NF_GLOBAL,name,catt)
          call error_handler('error in inquring x_boundary_type value of file ' &
                              //trim(grid_spec_file), rcode )
          if(trim(catt) == 'cyclic') then
             src_is_cyclic = .true.
             Write(stdout(),*)' NOTE: x_boundary_type of grid '//trim(grid_spec_file)//' is cyclic'
             src_is_cyclic = .false.
          else
             Write(stdout(),*)' NOTE: x_boundary_type of '//trim(grid_spec_file)//' is solid_walls'
          endif
       case ('y_boundary_type')
          rcode = nf_get_att_text(ncid,NF_GLOBAL,name,catt)
          call error_handler('error in inquring y_boundary_type value of file ' &
                   //trim(grid_spec_file), rcode )
          if (trim(catt) == 'fold_north_edge') then
             src_is_tripolar = .true.
             Write(stdout(),*)' NOTE: y_boundary_type of '//trim(grid_spec_file)//' is tripolar'
          else
             src_is_tripolar = .false.
             Write(stdout(),*)' NOTE: y_boundary_type of '//trim(grid_spec_file)//' is solid_walls' 
          endif
       end select
    end do

    !--- To determine the grid is in new grid format or old grid format
    is_new_grid = check_is_new_grid(ncid)

    !--- get the vertical grid information
    nk_src = get_dimlen(ncid, 'zt')
    allocate(zt_src(nk_src) ) 
    call get_var_real_1d(ncid, 'zt', zt_src )

    if(is_new_grid) then
       ni_src = get_dimlen(ncid, 'grid_x_T')
       nj_src = get_dimlen(ncid, 'grid_y_T')
    else
       ni_src = get_dimlen(ncid, 'gridlon_t')
       nj_src = get_dimlen(ncid, 'gridlat_t')
    endif

    allocate(geolon_t(ni_src,nj_src), geolat_t(ni_src,nj_src) )
    allocate(geolon_c(ni_src,nj_src), geolat_c(ni_src,nj_src) )
    allocate(geolon_e(ni_src,nj_src), geolat_e(ni_src,nj_src) )
    allocate(geolon_n(ni_src,nj_src), geolat_n(ni_src,nj_src) )
    allocate(sinrot  (ni_src,nj_src), cosrot  (ni_src,nj_src) )  
    allocate(tmp     (ni_src,nj_src) )

    if(is_new_grid) then
       call get_var_real_2d(ncid, 'x_T', geolon_t)
       call get_var_real_2d(ncid, 'y_T', geolat_t)
       call get_var_real_2d(ncid, 'x_C', geolon_c)
       call get_var_real_2d(ncid, 'y_C', geolat_c)
       call get_var_real_2d(ncid, 'x_T', geolon_e)
       call get_var_real_2d(ncid, 'y_T', geolat_e)
       call get_var_real_2d(ncid, 'x_C', geolon_n)
       call get_var_real_2d(ncid, 'y_C', geolat_n)
       call get_var_real_2d(ncid, 'angle_C', tmp)
       sinrot = sin(tmp*D2R)
       cosrot = cos(tmp*D2R)
    else
       call get_var_real_2d(ncid, 'geolon_t', geolon_t)
       call get_var_real_2d(ncid, 'geolat_t', geolat_t)
       call get_var_real_2d(ncid, 'geolon_c', geolon_c)
       call get_var_real_2d(ncid, 'geolat_c', geolat_c)
       call get_var_real_2d(ncid, 'geolon_e', geolon_e)
       call get_var_real_2d(ncid, 'geolat_e', geolat_e)
       call get_var_real_2d(ncid, 'geolon_n', geolon_n)
       call get_var_real_2d(ncid, 'geolat_n', geolat_n)       
       call get_var_real_2d(ncid, 'sin_rot',  sinrot  )
       call get_var_real_2d(ncid, 'cos_rot',  cosrot  )
    endif       

    rcode = nf_close(ncid)

    return

  end subroutine read_src_grid


  !#################################################################
  !--- read the destination horizontal grid information from file "grid_spec_file".

  subroutine read_dst_grid
    integer              :: ncid, rcode

    !--- first reading grid information from file "grid_spec_file"
    rcode = nf_open(trim(grid_spec_file), NF_NOWRITE, ncid)    
    call error_handler('error in open file '//trim(grid_spec_file), rcode)

    !--- get the destination grid size
    ni_dst = get_dimlen(ncid, 'xta')
    nj_dst = get_dimlen(ncid, 'yta')   

    allocate(xt_dst(ni_dst), yt_dst(nj_dst), xb_dst(ni_dst+1), yb_dst(nj_dst+1) )
    call get_var_real_1d(ncid, 'xta', xt_dst)
    call get_var_real_1d(ncid, 'yta', yt_dst)  
    call get_var_real_1d(ncid, 'xba', xb_dst)
    call get_var_real_1d(ncid, 'yba', yb_dst)

    rcode = nf_close(ncid)

    !--- For the conservative interpolation, it is very complicated to implmeent parallization
    !--- also the conservative interpolation is efficiency enough for postprocessing purpose.
    !--- That's the reason we didn't implement parallization for the conservative scheme.


    return

  end subroutine read_dst_grid

  !#####################################################################
  !--- In many situation, the source grid match the destination grid in the
  !--- region southern of some latitude, indexed with jstart. 
  !--- Interpolation is necessary  only for the region northen of jstart.
  !--- this will save lots of interpolation time. When some field is located
  !--- on C, E, or N-cell, call horiz_interp_new to set up the interpolation.
  !--- in this case, parallization is implemented.
  subroutine setup_interp

    integer :: i, j, layout(2)
    real    :: D2R

    D2R = PI/180.

    !--- find the starting point to do interpolatioon jstart
    if(ni_src == ni_dst) then
       J_LOOP: do j = 1, nj_dst
          do i = 1, ni_dst
             if( abs( geolon_t(i,j) - xt_dst(i) )   .gt. small ) exit J_LOOP
             if( abs( geolat_t(i,j) - yt_dst(j) )   .gt. small ) exit J_LOOP
             if( abs( geolon_c(i,j) - xb_dst(i+1) ) .gt. small ) exit J_LOOP
             if( abs( geolat_c(i,j) - yb_dst(j+1) ) .gt. small ) exit J_LOOP
          enddo
       enddo J_LOOP
       jstart = j
    else
       jstart = 1
    endif

    if(jstart .ne. 1) write(stdout(),*)'NOTE: horizontal interpolation will be done ', &
                                       'starting at lat(',jstart,')= ',yt_dst(jstart)

    !--- set up domain for parallization if needed
    layout = (/1,0/)
    call mpp_define_layout((/1,ni_dst,jstart,nj_dst/), mpp_npes(), layout)
    call mpp_define_domains((/1,ni_dst,jstart,nj_dst/),layout, Domain )
    call mpp_get_compute_domain(Domain,isc,iec,jsc,jec) 

    !--- call horiz_interp_new to calculate the reampping weight in horizontal direction

    if( any(fld_pos == 'C') ) then
       call horiz_interp_new(Interp_c, geolon_c*D2R, geolat_c*D2R, xb_dst(isc+1:iec+1)*D2R, &
            yb_dst(jsc+1:jec+1)*D2R, interp_method="spherical",   &
            num_nbrs=num_nbrs, max_dist=max_dist, src_modulo = src_is_cyclic)
    endif

    if( any(fld_pos == 'E') ) then
       call horiz_interp_new(Interp_e, geolon_e*D2R, geolat_e*D2R, xb_dst(isc+1:iec+1)*D2R, &
            yt_dst(jsc:jec)*D2R, interp_method="spherical",   &
            num_nbrs=num_nbrs, max_dist=max_dist, src_modulo = src_is_cyclic)
    endif

    if( any(fld_pos == 'N') ) then
       call horiz_interp_new(Interp_n, geolon_n*D2R, geolat_n*D2R, xt_dst(isc:iec)*D2R, &
            yb_dst(jsc+1:jec+1)*D2R, interp_method="spherical",   &
            num_nbrs=num_nbrs, max_dist=max_dist, src_modulo = src_is_cyclic)
    endif

    return

  end subroutine setup_interp

  !#################################################################
  ! read needed exchange grid information from file grid_spec_file
  ! for the purpose of first-order conservative interpolation for tracer data
  ! If needed, we may adding the option to do second-order conservative
  ! interpolation in the future. The algorithm will be very similiar to
  ! the algorithm used in coupler flux exchange, which is implemented in
  ! shared code xgrid.f90.

  subroutine read_xgrid()
    integer              :: rcode, ncid, ni_lon, nj_lat, ncells, i, j

    !--- It is needed only when doing conservative interpolation, which means
    !--- there is a field located on T-cell.
    if(.not. any(fld_pos == 'T')) return


    !--- read xgrid from the grid_spec.nc file --------------------------
    rcode = nf_open(grid_spec_file, NF_NOWRITE, ncid)
    call error_handler('error in open file '//grid_spec_file, rcode)

    !--- get exchange grid information
    ncells = get_dimlen(ncid, 'I_ATM_ATMxOCN')
    allocate(i_atm_atmxocn(ncells), j_atm_atmxocn(ncells), &
             i_ocn_atmxocn(ncells), j_ocn_atmxocn(ncells), &
             area_atmxocn(ncells) )

    call get_var_int_1d (ncid, 'I_ATM_ATMxOCN', i_atm_atmxocn)
    call get_var_int_1d (ncid, 'J_ATM_ATMxOCN', j_atm_atmxocn )
    call get_var_int_1d (ncid, 'I_OCN_ATMxOCN', i_ocn_atmxocn )
    call get_var_int_1d (ncid, 'J_OCN_ATMxOCN', j_ocn_atmxocn )
    call get_var_real_1d(ncid, 'AREA_ATMxOCN',  area_atmxocn )

    rcode = nf_close(ncid)
    !--- this variable will be used for the conservative interpolation.
    allocate(area_ocn(ni_dst, jstart:nj_dst))

  end subroutine read_xgrid

  !#####################################################################
  !--- This routine will read source data information from file src_data.
  !--- This information includes missing_value for each field, if any field
  !--- contains attribute "time_avg_info". Get the time information. 
  !--- Since the metadata of destination data will be determined by the
  !--- source data, get the metadata information for the dst_data. 
  subroutine get_src_info
    integer            :: rcode, ndims, natt, natt_dim, id_fld, dimids(4), id_dim
    integer            :: num_has_taxis, i, j, m, n
    character(len=128) :: name, cart, att_name
    logical            :: found_dim    

    rcode = nf_open(trim(src_data), NF_NOWRITE, ncid_src) 
    call error_handler('error in opening file '//trim(src_data), rcode) 

    num_has_taxis  = 0
    ndims_dst      = 0
    tavg_exist     = .false.
    ntime_src      = 1

    do n = 1, num_flds
       rcode = nf_inq_varid(ncid_src, fld_name(n), id_fld)
       call error_handler('error in inquring id of field '//trim(fld_name(n))// &
                 ' of file '//trim(src_data), rcode)
       rcode = nf_inq_varndims( ncid_src, id_fld, ndims )
       call error_handler('error in inquring ndims of field '//trim(fld_name(n))// &
                 ' of file '//trim(src_data), rcode)
       rcode = nf_inq_vardimid( ncid_src, id_fld, dimids )
       call error_handler('error in inquring dimids of field '//trim(fld_name(n))// &
                 ' of file '//trim(src_data), rcode)
       rcode = nf_inq_varnatts(ncid_src, id_fld, natt )
       call error_handler('error in inquring natt of field '//trim(fld_name(n))// &
                 ' of file '//trim(src_data), rcode)

       !--- get the missing value and check if the field has tag_exist attribute.

       do i = 1, natt
          rcode = nf_inq_attname(ncid_src, id_fld,i,name )          
          call error_handler('error in inquring attribute name', rcode)
          if(trim(name) == 'time_avg_info') then
             tavg_exist = .true.
          else if(trim(name) == 'missing_value') then
             rcode = nf_get_att_double(ncid_src, id_fld, name, missing_value(n) )
          endif
       enddo

       !--- to check if each field has z or time axis
       do m = 1, ndims
          rcode = nf_inq_dimname ( ncid_src, dimids(m), name )
          call error_handler('error in inquring dimension name of dimid', rcode)
          rcode = nf_inq_varid(ncid_src, name, id_dim)                    
          call error_handler('error in inquring variable id of '//trim(name), rcode)
          if(lowercase(trim(name)) == 'time') then
             cart = 'T'
             if(num_has_taxis == 0) then
                ntime_src = get_dimlen(ncid_src, trim(name) )
                allocate(time_value(ntime_src) )
                call get_var_real_1d(ncid_src, trim(name), time_value)
             endif
             num_has_taxis = num_has_taxis + 1   
          else
             rcode = nf_inq_varnatts(ncid_src, id_dim, natt_dim)
             call error_handler('error in inquring number of attributes of variable '//trim(name), rcode)
             do i = 1, natt_dim
                rcode = nf_inq_attname(ncid_src, id_dim,i,att_name )
                call error_handler('error in inquring attribute name ', rcode)
                if(trim(att_name) == 'cartesian_axis' ) then
                   rcode = nf_get_att_text(ncid_src,id_dim,att_name,cart)
                   call error_handler('error in get attribute value of attribute '//trim(att_name), rcode)
                   select case(cart(1:1))
                   case('X','Y')
                      ! do nothing 
                   case('Z') 
                      has_zaxis(n) = .true.
                   case default
                      call error_handler('The cartesian_axis of each axis should be X, Y or Z ' )
                   end select
                   exit
                endif
             enddo
          endif

          found_dim = .false.
          do j = 1, ndims_dst
             if(trim(dims_name(j)) == trim(name)) then
                found_dim = .true.
                exit
             endif
          enddo
          if(.not. found_dim) then
             ndims_dst = ndims_dst + 1
             dims_name(ndims_dst) = trim(name)
             dims_pos(ndims_dst) = fld_pos(n)
             dims_cart(ndims_dst) = cart(1:1)
             dims_id(ndims_dst)   = id_dim
          endif
       enddo
    enddo

    if(num_has_taxis == 0) then
       has_taxis = .false.
    else if(num_has_taxis == num_flds) then
       has_taxis = .true.
    else
       call error_handler('Either all or none of the fields has time axis ' )
    endif

    !--- suppose the time_avg_info is specified by average_T1, average_T2, average_DT.
    if(tavg_exist) then
       !--- some files don't have 'average_T1', 'average_T2' and 'average_DT' even though 
       !--- some variable do have time_avg_info attribute.  We suppose 'average_T1', 
       !--- 'average_T2' and 'average_DT' always co-exist.
       rcode = nf_inq_varid(ncid_src, 'average_T1', id_fld)
       if(rcode == 0) then
          allocate( t1_avg(ntime_src), t2_avg(ntime_src), dt_avg(ntime_src) )
          call get_var_real_1d(ncid_src, 'average_T1', t1_avg )
          call get_var_real_1d(ncid_src, 'average_T2', t2_avg )
          call get_var_real_1d(ncid_src, 'average_DT', dt_avg )
       else
          tavg_exist = .false.
       endif
    endif

  end subroutine get_src_info

  !#####################################################################
  !--- This routine will read source information.
  !--- set up axis and field meta data for destination data file
  !--- This routine is kind of long. We may change the design in the future
  !--- to have shorter subroutine for easy reading.

  subroutine setup_meta
       integer            :: rcode, natt, type, ndims, natt_dim, id_fld, dimids(4)
       integer            :: dim_time_dst, dims_dst(max_dims), id_axes(max_dims)
       integer            :: i, j, n, len, fld_dims(4), start(4), nwrite(4)
       character(len=128) :: name
       character(len=512) :: catt

    !--- simply return if current pe is not root pe.
    if(.not. is_root_pe) return

    rcode = nf_create(trim(dst_data),NF_WRITE, ncid_dst)
    call error_handler('error in creating file '//trim(dst_data), rcode) 

    !--- read the global attributes from source data and write it to output file
    rcode =  nf_inq_natts(ncid_src, natt )
    call error_handler('error in inquring natts of file '//trim(src_data), rcode)
    do i = 1, natt
       rcode = nf_inq_attname(ncid_src,NF_GLOBAL,i,name )
       call error_handler('error in inquring attribute name of file '//trim(src_data), rcode)
       rcode = nf_inq_att(ncid_src,NF_GLOBAL,name,type,len)
       call error_handler('error in inquring attribute of file '//trim(src_data), rcode)
       if(type == NF_CHAR ) then      ! only keep character global attributes
          if(len .le. 512) then
             if(trim(name) == 'filename') then
                catt = trim(dst_data)
             else
                rcode = nf_get_att_text(ncid_src,NF_GLOBAL,name,catt)
                call error_handler('error in getting attribute text of file '//trim(src_data), rcode)
             endif
             if(is_root_pe) then
                rcode = nf_put_att_text(ncid_dst, NF_GLOBAL, name, len, catt )
                call error_handler('error in putting  attribute to file '//trim(dst_data), rcode)
             endif
          else
             write(stdout(),*)'GLOBAL ATT '//trim(name)//' too long - not reading this metadata'
          endif
       endif
    enddo

    rcode = nf_inq_ndims(ncid_src, ndims)
    call error_handler('error in inquring ndims of file '//trim(src_data), rcode)
    do j = 1, ndims_dst
       if(lowercase(trim(dims_name(j)))=='time' ) then
          rcode = nf_def_dim(ncid_dst, dims_name(j), NF_UNLIMITED, dims_dst(j))
          call error_handler('error in defining time dimension of file '//trim(dst_data), rcode)
          rcode = nf_def_var(ncid_dst, dims_name(j), NF_DOUBLE, 1, dims_dst(j), id_axes(j))
          call error_handler('error in defining time variable of file '//trim(dst_data), rcode)
          id_time_dst = id_axes(j)
          dim_time_dst = dims_dst(j)
       else
          select case(dims_cart(j))
          case('X')
             len = ni_dst
          case('Y')
             len = nj_dst
          case('Z')
             len = nk_src             
          end select
          rcode = nf_def_dim(ncid_dst, dims_name(j), len, dims_dst(j))
          call error_handler('error in defining dimension '//trim(dims_name(j))//' of file '//trim(dst_data), rcode)
          rcode = nf_def_var(ncid_dst, dims_name(j), NF_DOUBLE, 1, dims_dst(j), id_axes(j) )
          call error_handler('error in defining axis var '//trim(dims_name(j))//' of file '//trim(dst_data), rcode)
       endif

       !--- write out axis attribute
       rcode = nf_inq_varnatts(ncid_src, dims_id(j), natt_dim)
       call error_handler('error in inquring number of attributes', rcode)
       do i = 1, natt_dim 
          rcode = nf_inq_attname(ncid_src, dims_id(j), i, name)             
          rcode = nf_copy_att(ncid_src,dims_id(j), name, ncid_dst, id_axes(j))
          call error_handler('error in copy attribute '//trim(name), rcode)            
       enddo
    enddo

    !--- read attribue of each field and write them to dst_data file
    do n = 1, num_flds
       rcode = nf_inq_varid(ncid_src,fld_name(n), id_fld)
       call error_handler('error in inquring id of field '//trim(fld_name(n))// ' of file '//trim(src_data), rcode)
       rcode = nf_inq_varndims( ncid_src, id_fld, ndims )
       call error_handler('error in inquring ndims of field '//trim(fld_name(n))// ' of file '//trim(src_data), rcode)
       rcode = nf_inq_vardimid( ncid_src, id_fld, dimids )
       call error_handler('error in inquring dimids of field '//trim(fld_name(n))// ' of file '//trim(src_data), rcode)
       do i = 1, ndims
          rcode = nf_inq_dimname ( ncid_src, dimids(i), name )
          call error_handler('error in inquring dimension name of dimid', rcode)
          do j = 1, ndims_dst
             if(trim(name) == trim(dims_name(j))) then
                fld_dims(i) = dims_dst(j)
                exit
             endif
          enddo
       enddo
       call define_field_metadata(ncid_src, ncid_dst, fld_name(n), ndims, fld_dims, id_dst_fld(n))       
    enddo

    !--- define time avg info, suppose the time_avg_info is specified by average_T1, average_T2, average_DT.
    if(tavg_exist) then
       fld_dims(1) = dim_time_dst
       call define_field_metadata(ncid_src, ncid_dst, 'average_T1', 1, fld_dims, id_t1_dst)
       call define_field_metadata(ncid_src, ncid_dst, 'average_T2', 1, fld_dims, id_t2_dst)
       call define_field_metadata(ncid_src, ncid_dst, 'average_DT', 1, fld_dims, id_dt_dst)
    endif

    rcode = nf_enddef(ncid_dst)

    !--- write axis data to dst_data
    start = 1; nwrite = 1
    do j = 1, ndims_dst
       select case(dims_cart(j))
       case('X')
          nwrite(1) = ni_dst
          if(dims_pos(j) == 'T' .or. dims_pos(j) == 'N') then
             rcode = nf_put_vara_double(ncid_dst,id_axes(j), start, nwrite, xt_dst )
          else
             rcode = nf_put_vara_double(ncid_dst,id_axes(j), start, nwrite, xb_dst(2:) )             
          endif
          call error_handler('error in putting data of '//trim(dims_name(j))//' to file '//trim(dst_data), rcode)
       case('Y')
          nwrite(1) = nj_dst
          if(dims_pos(j) == 'T' .or. dims_pos(j) == 'E') then
             rcode = nf_put_vara_double(ncid_dst,id_axes(j), start, nwrite, yt_dst )
          else
             rcode = nf_put_vara_double(ncid_dst,id_axes(j), start, nwrite, yb_dst(2:) )             
          endif
          call error_handler('error in putting data of '//trim(dims_name(j))//' to file '//trim(dst_data), rcode)
       case('Z')
          nwrite(1) = nk_src
          rcode = nf_put_vara_double(ncid_dst,id_axes(j), start, nwrite, zt_src )
          call error_handler('error in putting data of '//trim(dims_name(j))//' to file '//trim(dst_data), rcode)
       end select
    enddo

  end subroutine setup_meta

  !#####################################################################
    !-------------------------------------------------------------------
    !--- read src data, remap onto current grid and write output -------
  subroutine process_data
    integer :: n, m, l, rcode, nk, nf 
    integer :: start(4), nread(4), nwrite(4), id_fld(max_flds)
    real, dimension(:,:,:,:), allocatable :: data_src, data_dst
    real, dimension(:,:,:),   allocatable :: wrk1, wrk2

    do n = 1, num_flds
       rcode = nf_inq_varid(ncid_src, fld_name(n), id_fld(n) )
       call error_handler('error in inquring varid of '//trim(fld_name(n))// &
                          ' of file '//trim(src_data), rcode)
    enddo

    write(stdout(),*)'***************************************'
    write(stdout(),*)' ntime_src is ', ntime_src

    do m = 1, ntime_src
       write(stdout(),*)'************************************************'
       write(stdout(),*)'*** At time level ', m
       n = 1
       !--- write out time information 
       if(is_root_pe) then
          if(has_taxis) then       
             rcode = nf_put_var1_double(ncid_dst, id_time_dst, m, time_value(m))
             call error_handler('error in put time data to file '//trim(src_data), rcode )
             if(tavg_exist) then
                rcode = nf_put_var1_double(ncid_dst, id_t1_dst, m, t1_avg(m))
                call error_handler('error in put average_T1 data to file '//trim(src_data), rcode )
                rcode = nf_put_var1_double(ncid_dst, id_t2_dst, m, t2_avg(m))
                call error_handler('error in put average_T2 data to file '//trim(src_data), rcode )
                rcode = nf_put_var1_double(ncid_dst, id_dt_dst, m, dt_avg(m))
                call error_handler('error in put average_DT data to file '//trim(src_data), rcode )
             endif
          endif
       endif

       do while ( n .le. num_flds )
          nf = 1
          if(vector_fld(n) .and. src_is_tripolar) nf = 2
          nk = 1
          if(has_zaxis(n)) nk = nk_src

          allocate(data_src(ni_src, nj_src, nk,nf), data_dst(ni_dst, nj_dst, nk,nf) )
          allocate(wrk1(isc:iec,jsc:jec,nk), wrk2(1:ni_dst,jstart:nj_dst,nk) )

          start = 1; nread = 1
          nread(1) = ni_src; nread(2) = nj_src
          if(has_zaxis(n)) then
             nread(3) = nk; start(4) = m
          else
             start(3) = m
          endif
          rcode = nf_get_vara_double(ncid_src,id_fld(n), start, nread, data_src(:,:,:,1) ) 
          call error_handler('error in get data 1 from file '//trim(src_data), rcode )

          !--- if the field is a vector field and src_grid is tripolar, read the next field and 
          !--- rotate data onto spherical grid.
          if( vector_fld(n) .and. src_is_tripolar ) then
             rcode = nf_get_vara_double(ncid_src,id_fld(n+1), start, nread, data_src(:,:,:,2) ) 
             call error_handler('error in get data 2 from file '//trim(src_data), rcode )

             call rotate_data(data_src(:,jstart:,:,:), cosrot(:,jstart:), sinrot(:,jstart:), missing_value(n) )
          endif

          do l = 1, nf
             !---- doing horizontal interpolaiton
             if(fld_pos(n) == 'T' ) then !--- this case data is already global data
                call conserve_interp(data_src(:,:,:,1), wrk2(:,:,:), missing_value(1))
             else
                call mpp_domains_set_stack_size(2*ni_dst*nj_dst*nk)

                call nonconserve_interp(data_src(:,:,:,l), wrk1(:,:,:), fld_pos(n), missing_value(1) )
                !---- get the global data
                call mpp_global_field(Domain, wrk1, wrk2 )
             endif

             !--- assign data to global region
             if(jstart == 1) then
                data_dst(:,:,:,l) = wrk2
             else
                data_dst(:,1:jstart-1,:,l) = data_src(:,1:jstart-1,:,l)
                data_dst(:,jstart:,:,l)    = wrk2(:,:,:)
             endif
          enddo

          !--- write out data from root_pe
          if(is_root_pe) then
             do l = 1, nf
                start = 1; nwrite = 1
                nwrite(1) = ni_dst; nwrite(2) = nj_dst
                if(has_zaxis(n)) then
                   nwrite(3) = nk; start(4) = m
                   rcode = nf_put_vara_double(ncid_dst, id_dst_fld(n+l-1), start, nwrite, data_dst(:,:,:,l) ) 
                   call error_handler('error in putting '//trim(fld_name(n+l-1))//' in file '//trim(dst_data), rcode )
                else
                   start(3) = m
                   rcode = nf_put_vara_double(ncid_dst, id_dst_fld(n+l-1), start, nwrite, data_dst(:,:,1,l) ) 
                   call error_handler('error in putting '//trim(fld_name(n+l-1))//' in file '//trim(dst_data), rcode )
                endif
                !--- for debugging reproducing ability accross processor count.
                if(debug) write(stdout(),*)'NOTE:after regrid, chksum for '//trim(fld_name(n+l-1))// &
                              ' at time level ',m,' ====> ',mpp_chksum(data_dst(:,:,:,l), (/mpp_root_pe()/) )
             enddo
          endif
          n = n+nf
          deallocate(data_src, data_dst, wrk1, wrk2)
       enddo
    enddo

    rcode = nf_close(ncid_src)
    if(is_root_pe) rcode = nf_close(ncid_dst)

  end subroutine process_data

  !#####################################################################

  subroutine regrid_end


    call fms_io_exit
    call fms_end()

  end subroutine regrid_end

  !#####################################################################
  ! error handling routine.
  subroutine error_handler(mesg, status)
    character(len=*),  intent(in) :: mesg
    integer, optional, intent(in) :: status
    character(len=256) :: msg

    if(present(status)) then
       if(status == 0) return
       msg = nf_strerror(status)
       msg = trim(mesg)//': '// trim(msg)
    else
       msg = trim(mesg)
    endif

    call mpp_error(FATAL,trim(msg) )

  end subroutine error_handler


  !#####################################################################

  ! get the dimension length of any one dimensional variable
  function get_dimlen(ncid, name)
    integer,          intent(in) :: ncid
    character(len=*), intent(in) :: name
    integer                      :: get_dimlen
    integer                      :: varid, rcode, dims(1)

    get_dimlen = 0

    rcode = nf_inq_varid(ncid, trim(name), varid)
    call error_handler('error in inquiring variable id of '//trim(name), rcode)

    rcode = nf_inq_vardimid(ncid, varid, dims)
    call error_handler('error in inquiring dimension id of '//trim(name), rcode)

    rcode = nf_inq_dimlen(ncid, dims(1), get_dimlen)
    call error_handler('error in inquiring dimension length of '//trim(name), rcode)

  end function get_dimlen

  !#####################################################################
  ! read the 1d integer data from netcdf file.
  subroutine get_var_int_1d(ncid, name, data)
    integer,                intent(in) :: ncid
    character(len=*),       intent(in) :: name
    integer, dimension(:), intent(out) :: data
    integer                            :: rcode, varid

    rcode = nf_inq_varid(ncid, name, varid)
    call error_handler('error in inquiring variable id of '//trim(name), rcode)
    rcode = nf_get_var_int(ncid, varid, data)
    call error_handler('error in reading data of '//trim(name), rcode)

  end subroutine get_var_int_1d

  !#####################################################################
  ! read the 1d real data from netcdf file.
  subroutine get_var_real_1d(ncid, name, data)
    integer,             intent(in) :: ncid
    character(len=*),    intent(in) :: name
    real, dimension(:), intent(out) :: data
    integer                         :: rcode, varid

    rcode = nf_inq_varid(ncid, name, varid)
    call error_handler('error in inquiring variable id of '//trim(name), rcode)

    rcode = nf_get_var_double(ncid, varid, data)
    call error_handler('error in reading data of '//trim(name), rcode)


  end subroutine get_var_real_1d

  !#####################################################################
  ! read the 2d real data from netcdf file.
  subroutine get_var_real_2d(ncid, name, data)
    integer,               intent(in) :: ncid
    character(len=*),      intent(in) :: name
    real, dimension(:,:), intent(out) :: data
    integer                           :: rcode, varid


    rcode = nf_inq_varid(ncid, name, varid)
    call error_handler('error in inquiring variable id of '//trim(name), rcode)

    rcode = nf_get_var_double(ncid, varid, data)
    call error_handler('error in reading data of '//trim(name), rcode)

  end subroutine get_var_real_2d


  !#####################################################################

  !--- rotate the data when the field is a vector field.
  subroutine rotate_data(data, rotcos, rotsin, missing)
    real, dimension(:,:,:,:), intent(inout) :: data
    real, dimension(:,:),     intent(in)    :: rotsin, rotcos
    real,                        intent(in) :: missing

    integer                       :: i, j, k
    real                          :: temp1, temp2

    if(size(data,4).ne. 2 ) call error_handler('number of data should be paired when do rotation. ')

    do k = 1, size(data,3)
       do j = 1, size(data,2)
          do i = 1, size(data,1)
             if(data(i,j,k,1) /= missing ) then ! assume data(:,:,:,1) is not missing, then
                ! data(:,:,:,2) is not missing
                temp1           = data(i,j,k,1)*rotcos(i,j)-data(i,j,k,2)*rotsin(i,j)
                temp2           = data(i,j,k,1)*rotsin(i,j)+data(i,j,k,2)*rotcos(i,j)
                data(i,j,k,1)   = temp1
                data(i,j,k,2)   = temp2
             endif
          enddo
       enddo
    enddo

  end subroutine rotate_data

  !#####################################################################
  subroutine conserve_interp(input, output, missing)
    real, dimension(:,:,:),        intent(in) :: input
    real, dimension(:,jstart:,:), intent(out) :: output
    real,                          intent(in) :: missing

    integer                                   :: i, j, k

    !--- put data on exchange grid
    output = 0.0
    area_ocn  = 0.0

    do k = 1, size(input,3)
       area_ocn = 0.0
       do i = 1, size(i_atm_atmxocn)
          if(j_atm_atmxocn(i) >= jstart ) then
             if(input(i_ocn_atmxocn(i),j_ocn_atmxocn(i),k) /= missing) then
                output(i_atm_atmxocn(i),j_atm_atmxocn(i),k) = output(i_atm_atmxocn(i),j_atm_atmxocn(i),k) &
                     + area_atmxocn(i)*input(i_ocn_atmxocn(i),j_ocn_atmxocn(i),k)
                area_ocn(i_atm_atmxocn(i),j_atm_atmxocn(i)) = area_ocn(i_atm_atmxocn(i),j_atm_atmxocn(i)) &
                     + area_atmxocn(i)
             endif
          endif
       enddo

       do j = jstart, nj_dst
          do i = 1, ni_dst
             if(area_ocn(i,j) > epsln ) then
                output(i,j,k) = output(i,j,k)/area_ocn(i,j)
             else
                output(i,j,k) = missing
             endif
          enddo
       enddo
    enddo

  end subroutine conserve_interp

  !#####################################################################
    subroutine nonconserve_interp(input, output, position, missing)
    real, dimension(:,:,:),  intent(in) :: input
    real, dimension(:,:,:), intent(out) :: output
    character(len=1),        intent(in) :: position
    real,                    intent(in) :: missing

    integer                                       :: i, j, k
    real, dimension(size(input,1), size(input,2)) :: mask
    type(horiz_interp_type), pointer              :: Interp=>NULL()

    select case(position)
    case('C')
       Interp => Interp_c
    case('E')
       Interp => Interp_e
    case('N')
       Interp => Interp_n
    end select

    do k = 1, size(input,3)
       !--- define land/sea mask
       do j = 1, size(input,2)
          do i = 1, size(input,1)
             if(input(i,j,k) == missing) then
                mask(i,j) = 0.0
             else
                mask(i,j) = 1.0
             endif
          enddo
       enddo
       !--- remap data onto destination horizontal grid through horiz_interp
       call horiz_interp(Interp, input(:,:,k), output(:,:,k), &
            mask_in=mask, missing_value=missing )
    enddo

    return

  end subroutine nonconserve_interp

  !#####################################################################
  !--- To determine the grid is in new grid format or old grid format
  function check_is_new_grid(ncid)
    integer, intent(in) :: ncid
    logical             :: check_is_new_grid
    integer             :: rcode, id_fld

    rcode = nf_inq_varid(ncid, 'x_T', id_fld)
    if(rcode == 0) then
       check_is_new_grid = .true.
    else
       rcode = nf_inq_varid(ncid, 'geolon_t', id_fld)
       call error_handler('check_is_new_grid: error in inquring id of geolon_t ', rcode)       
       check_is_new_grid = .false.
    endif

  end function check_is_new_grid

  !#####################################################################
  !--- define a field metadata and copy the attribute from source data to destination data
  subroutine define_field_metadata(ncid_in, ncid_out, name, ndim, dims, id_fld_out)
    integer, intent(in)          :: ncid_in, ncid_out, ndim, dims(:)
    character(len=*), intent(in) :: name
    integer, intent(out)         :: id_fld_out

    integer            :: rcode, id_fld_in, natt, i
    character(len=128) :: attname

    rcode = nf_def_var(ncid_out, trim(name), NF_DOUBLE, ndim, dims(1:ndim), id_fld_out)
    call error_handler('define_field_metadata: error in defining field '//trim(name), rcode )
    rcode = nf_inq_varid(ncid_in, trim(name), id_fld_in)
    call error_handler('define_field_metadata: error in inquring field of '//trim(name), rcode) 
    rcode = nf_inq_varnatts(ncid_in, id_fld_in, natt)
    call error_handler('define_field_metadata: error in inquring natt of '//trim(name), rcode)       

    do i = 1, natt
       rcode = nf_inq_attname(ncid_in, id_fld_in, i, attname)
       call error_handler('error in inquring '//trim(name)//' attribute '//trim(attname), rcode) 
       if(trim(attname) /= '_FillValue') then 
          rcode = nf_copy_att(ncid_in,id_fld_in, attname, ncid_out, id_fld_out)
          call error_handler('error in copy '//trim(name)//' attribute '//trim(attname), rcode) 
       endif
    enddo

  end subroutine define_field_metadata

  !#####################################################################
  
end program regrid

!FDOC_TAG_GFDL

                 module mgrp_prscr_clds_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil   
! </CONTACT>
! <REVIEWER EMAIL="">
!   
! </REVIEWER>
! <OVERVIEW>
!       mgroup prescribed cloud properties module
!               (this module runnable in SKYHI and FMS;
!                zonal_clouds_mod is FMS native equivalent)
!   
! </OVERVIEW>
! <DESCRIPTION>
!   
! </DESCRIPTION>
!

use mpp_mod,           only: input_nml_file
use fms_mod,           only: fms_init, file_exist, &
                             open_namelist_file,  &
                             check_nml_error, close_file,   &
                             write_version_number, &
                             mpp_pe, mpp_root_pe, stdlog, &
                             error_mesg, FATAL

use constants_mod,     only: radian
use rad_utilities_mod, only: rad_utilities_init, &
                             cldrad_properties_type, &
                             cld_specification_type


!--------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!       mgroup prescribed cloud properties module
!               (this module runnable in SKYHI and FMS; 
!                zonal_clouds_mod is FMS native equivalent)
!
!!--------------------------------------------------------------------



!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------

  character(len=128)  :: version =  '$Id: mgrp_prscr_clds.F90,v 19.0 2012/01/06 20:19:41 fms Exp $'
  character(len=128)  :: tagname =  '$Name: tikal $'



!---------------------------------------------------------------------
!-------  interfaces --------

public     mgrp_prscr_clds_init,  &
           mgrp_prscr_clds_end,  &
          prscr_clds_amt, &      
          obtain_bulk_lw_prscr, obtain_bulk_sw_prscr 


private    cldht, cldint  


!---------------------------------------------------------------------
!-------- namelist  ---------



integer    ::     dummy=0



namelist /mgrp_prscr_clds_nml /     &
                                           dummy


!----------------------------------------------------------------------
!----  public data -------

!----------------------------------------------------------------------
!----  private data -------


!--------------------------------------------------------------------
!     these variables define cloud amounts and radiative properties  
!     on a global (j,k) model grid.
!--------------------------------------------------------------------
  
logical, dimension(:,:),   allocatable :: zhi_cloud_gl, zmid_cloud_gl, &
                                         zlow_cloud_gl
real, dimension(:,:),   allocatable :: zcamtmxo, zcamtrnd

 
!--------------------------------------------------------------------
!     these variables define cloud tops and bottoms, amounts and rad-
!     iative properties on an input (LATOBS,NOFCLDS_SP) grid. the input 
!     values are the original Skyhi values. 
!--------------------------------------------------------------------
 
integer, parameter                    :: NOFCLDS_SP=3  
integer, parameter                    :: NOFMXOLW=1  
integer, parameter                    :: NOFRNDLW=2  
integer, parameter                    :: LATOBS=19

!-------------------------------------------------------------------
!   default low, middle, high cloud properties 
!   cldem    : infrared emissivity
!   crfvis   : visible band reflectivity
!   crfir    : near-ir band reflectivity
!   cabir    : near-ir band absorptivity
!-------------------------------------------------------------------
real  :: cldem_hi = 1.0     
real ::  cldem_mid= 1.0
real ::  cldem_low = 1.0          
real :: crfvis_hi = 0.21 
real :: crfvis_mid =0.48          
real :: crfvis_low =0.69          
real :: crfir_hi = 0.21
real :: crfir_mid =0.48     
real :: crfir_low = 0.69          
real :: cabir_hi =  0.005         
real :: cabir_mid =0.02           
real :: cabir_low =0.035

!-------------------------------------------------------------------
!   prescribed high, mid, low cloud amounts on 19 latitudes
!-------------------------------------------------------------------

integer                                 ::  jj, kkc
real, dimension(LATOBS)                 ::  ccd_low, ccd_mid, ccd_hi  
real, dimension(LATOBS)                 ::  cloud_lats

data cloud_lats / -90., -80., -70., -60., -50., -40., -30., -20., &
                  -10., 0.0, 10., 20., 30., 40., 50., 60., 70., 80., &
                   90. /

data ccd_low  /    &
     &  0.360E+00, 0.401E+00, 0.439E+00, 0.447E+00, 0.417E+00, &
     &  0.343E+00, 0.269E+00, 0.249E+00, 0.290E+00, 0.330E+00, &
     &  0.290E+00, 0.249E+00, 0.269E+00, 0.343E+00, 0.417E+00, &
     &  0.447E+00, 0.439E+00, 0.401E+00, 0.360E+00/               

data ccd_mid  /    &
     &  0.090E+00, 0.102E+00, 0.117E+00, 0.128E+00, 0.122E+00, &
     &  0.095E+00, 0.070E+00, 0.060E+00, 0.068E+00, 0.080E+00, &
     &  0.068E+00, 0.060E+00, 0.070E+00, 0.095E+00, 0.122E+00, &
     &  0.128E+00, 0.117E+00, 0.102E+00, 0.090E+00/              

data ccd_hi   /    &
     &  0.198E+00, 0.231E+00, 0.254E+00, 0.250E+00, 0.227E+00, &
     &  0.192E+00, 0.159E+00, 0.168E+00, 0.205E+00, 0.241E+00, &
     &  0.205E+00, 0.168E+00, 0.159E+00, 0.192E+00, 0.227E+00, &
     &  0.250E+00, 0.254E+00, 0.231E+00, 0.198E+00/ 
!----------------------------------------------------------------------


!----------------------------------------------------------------------
!    NLWCLDB is the number of frequency bands for which lw
!    emissitivies are defined.
!----------------------------------------------------------------------

logical :: module_is_initialized = .false.

!----------------------------------------------------------------------
!----------------------------------------------------------------------




 contains 


! <SUBROUTINE NAME="mgrp_prscr_clds_init">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call mgrp_prscr_clds_init (    pref, latb      )
!
!  </TEMPLATE>
!  <IN NAME="pref" TYPE="">
! 
!  </IN>
!  <IN NAME="latb" TYPE="real">
! 
!  </IN>
! </SUBROUTINE>
!
subroutine mgrp_prscr_clds_init (    pref, latb      )

!------------------------------------------------------------------
real, dimension(:), intent(in)             ::  latb      
real, dimension(:,:), intent(in)             :: pref          
!--------------------------------------------------------------------

      integer            :: unit, ierr, io, logunit
      integer            :: j, k,                 li
      integer            :: jdf
      integer, dimension ( LATOBS, NOFCLDS_SP)  :: kkbh, kkth
         
 integer :: kerad

      integer, dimension(:), allocatable :: jindx2

      if (module_is_initialized) return

      call fms_init
      call rad_utilities_init

!---------------------------------------------------------------------
!-----  read namelist  ------
  
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=mgrp_prscr_clds_nml, iostat=io)
      ierr = check_nml_error(io,"mgrp_prscr_clds_nml")
#else
      if (file_exist('input.nml')) then
        unit =  open_namelist_file ()
        ierr=1; do while (ierr /= 0)
        read (unit, nml=mgrp_prscr_clds_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'mgrp_prscr_clds_nml')
        enddo
10      call close_file (unit)
      endif
#endif

      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() )   &
         write (logunit, nml = mgrp_prscr_clds_nml)

!--------------------------------------------------------------------
!  retrieve module variables that come from other modules
!--------------------------------------------------------------------

       kerad = size(pref,1) - 1
      jdf = size(latb,1) - 1

         allocate (jindx2  (size(latb,1)-1)) ; jindx2 = 0.0
         call find_nearest_index (latb, jindx2)

!---------------------------------------------------------------------
!    define the number of cloud emissivity bands for use in this module.
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!   allocate space to hold the cloud radiative properties on the model
!   grid (j,k)
!---------------------------------------------------------------------
      allocate( zcamtmxo    (jdf , KERAD)) ; zcamtmxo = 0.0
      allocate( zcamtrnd    (jdf , KERAD)) ; zcamtrnd = 0.0

      allocate( zhi_cloud_gl(jdf ,     kerad  ))
      allocate( zmid_cloud_gl(jdf ,    kerad   ))
      allocate( zlow_cloud_gl(jdf ,    kerad   ))
      zhi_cloud_gl  = .false.
      zmid_cloud_gl = .false.
      zlow_cloud_gl = .false.

!---------------------------------------------------------------------
!     define index arrays for cloud tops and cloud bottoms(kkth, kkbh). 
!     a program courtesy of Ron Stouffer is used. cldht specifies cloud 
!     height data in mb for each cloud type, at 10 deg intervals from 
!     90S to 90N.(ie, 19 lats).
!---------------------------------------------------------------------
 
      call cldht  (pref(:,1), kkbh, kkth)


!---------------------------------------------------------------------
!    perform latitude "interpolation" to the (JD) model latitudes
!    in default case, no interpolation is actually done; the nearest
!    latitude available (using NINT function) is used.
!---------------------------------------------------------------------

       zcamtmxo = 0.
       zcamtrnd = 0.

      do j=1,jdf
        li = jindx2(j)
do k=kkth(li,1), kkbh(li,1)
           zlow_cloud_gl(j,k) = .true.
  zcamtmxo(j,k) = ccd_low(li)        
        end do
        do k=kkth(li,2), kkbh(li,2)
           zmid_cloud_gl(j,k) = .true.
   zcamtrnd(j,k) = ccd_mid(li)
         end do
         do k=kkth(li,3), kkbh(li,3)
            zhi_cloud_gl(j,k) = .true.
    zcamtrnd(j,k) = ccd_hi(li)
        end do
      end do

!---------------------------------------------------------------------
!    if a cloud microphysics scheme is to be employed with the cloud
!    scheme, initialize the microphysics_rad module.
!--------------------------------------------------------------------

      module_is_initialized = .true.

end subroutine mgrp_prscr_clds_init

!######################################################################

! <SUBROUTINE NAME="mgrp_prscr_clds_end">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call mgrp_prscr_clds_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine mgrp_prscr_clds_end
        
!----------------------------------------------------------------------
!    mgrp_prscr_clds_end is the destructor for mgrp_prscr_clds_mod.
!----------------------------------------------------------------------
       
!---------------------------------------------------------------------
!    mark the module as not initialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.
        
!--------------------------------------------------------------------
 
 
end subroutine mgrp_prscr_clds_end




!#####################################################################

! <SUBROUTINE NAME="find_nearest_index">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call find_nearest_index (latb, jindx2)
!
!  </TEMPLATE>
!  <IN NAME="latb" TYPE="real">
! 
!  </IN>
!  <OUT NAME="jindx2" TYPE="integer">
! 
!  </OUT>
! </SUBROUTINE>
!
subroutine find_nearest_index (latb, jindx2)

real, dimension(:), intent(in) :: latb
integer, dimension(:), intent(out)  :: jindx2


      integer :: jd, j, jj
      real   :: diff_low, diff_high
      real, dimension(size(latb,1)-1) :: lat


      jd = size(latb,1) - 1

      do j = 1,jd
        lat(j) = 0.5*(latb(j) + latb(j+1))
      do jj=1, LATOBS         
         if (lat(j)*radian >= cloud_lats(jj)) then
           diff_low = lat(j)*radian - cloud_lats(jj)
           diff_high = cloud_lats(jj+1) - lat(j)*radian
          if (diff_high <= diff_low) then
            jindx2(j) = jj+1
          else
            jindx2(j) = jj
          endif
        endif
      end do
      end do






end subroutine find_nearest_index 





!######################################################################

! <SUBROUTINE NAME="prscr_clds_amt">
!  <OVERVIEW>
!    prscr_clds_amt defines the location, amount (cloud fraction),
!    number and type (hi, mid, low) of clouds present on the model grid.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    prscr_clds_amt defines the location, amount (cloud fraction),
!    number and type (hi, mid, low) of clouds present on the model grid.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call prscr_clds_amt (is, ie, js, je, Cld_spec)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine prscr_clds_amt (is, ie, js, je, Cld_spec)

!---------------------------------------------------------------------
!    prscr_clds_amt defines the location, amount (cloud fraction), 
!    number and type (hi, mid, low) of clouds present on the model grid.
!----------------------------------------------------------------------

integer, intent(in)                          :: is, ie, js, je
type(cld_specification_type), intent(inout)  :: Cld_spec       

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!
!   intent(inout) variables:
!
!      Cld_spec     cld_specification_type variable containing the 
!                   cloud specification input fields needed by the 
!                   radiation package
!
!               the following elements of Cld_spec are defined here:
!
!                  %cmxolw  fraction of maximally overlapped clouds
!                           seen by the longwave radiation 
!                           [ dimensionless ]
!                  %crndlw  fraction of randomly overlapped clouds
!                           seen by the longwave radiation 
!                           [ dimensionless ]
!                  %camtsw  cloud fraction seen by the shortwave
!                           radiation; the sum of the maximally
!                           overlapped and randomly overlapped 
!                           longwave cloud fractions  [ dimensionless ]
!                  %nmxolw  number of maximally overlapped longwave 
!                           clouds in each grid column.
!                  %nrndlw  number of randomly overlapped longwave 
!                           clouds in each grid column.
!                  %ncldsw  number of clouds seen by he shortwave
!                           radiation in each grid column.
!                  %hi_cld  logical flag indicating the presence of 
!                           high clouds in a grid box
!                 %mid_cld  logical flag indicating the presence of 
!                           middle clouds in a grid box
!                 %low_cld  logical flag indicating the presence of 
!                           low clouds in a grid box
!                                                                  
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!   local variables:
 
      integer  ::  i,j,k    ! do loop indices


!---------------------------------------------------------------------
!    define the number of clouds in each column. the assumption is made
!    that all grid columns have NOFCLDS_SP clouds, with NOFMXOLW of 
!    these being maximally overlapped and the remainder (NOFRNDLW) 
!    randomly overlapped. The default case, corresponding to all 
!    previous model simulations, is 3 clouds (1 maximally overlapped, 
!    2 randomly overlapped).
!----------------------------------------------------------------------
      Cld_spec%nmxolw(:,:) = NOFMXOLW
      Cld_spec%nrndlw(:,:) = NOFRNDLW
      Cld_spec%ncldsw(:,:) = NOFCLDS_SP 

!----------------------------------------------------------------------
!    define the fractions of random and maximally overlapped clouds and
!    the total cloud fraction seen by the shortwave radiation. define
!    the hi-mid-low cloud flag arrays based on the pre-defined latitude
!    and height dependent specifications that were defined during init-
!    ialization.
!----------------------------------------------------------------------
      do k=1,size (Cld_spec%hi_cloud,3)
        do j=1,size (Cld_spec%hi_cloud,2)
          do i=1,size (Cld_spec%hi_cloud,1)
            Cld_spec%cmxolw(i,j,k) = zcamtmxo(j+js-1  ,k)
            Cld_spec%crndlw(i,j,k) = zcamtrnd(j+js-1  ,k)
            Cld_spec%camtsw(i,j,k) = Cld_spec%cmxolw(i,j,k) +  &
                                     Cld_spec%crndlw(i,j,k)
            if (Cld_spec%camtsw(i,j,k) > 0.0) then
              if (zhi_cloud_gl(js+j-1,k)) then
                Cld_spec%hi_cloud(i,j,k) = .true.
              else if (zmid_cloud_gl(js+j-1,k)) then
                Cld_spec%mid_cloud(i,j,k) = .true.
              else if (zlow_cloud_gl(js+j-1,k) ) then
                Cld_spec%low_cloud(i,j,k) = .true.
              else
                call error_mesg ('mgrp_prscr_clds_mod',  &
                    'model level is not mapped to a cloud type', FATAL)
              endif
            endif
          end do
        end do
      end do

!---------------------------------------------------------------------



end subroutine prscr_clds_amt


!######################################################################

! <SUBROUTINE NAME="obtain_bulk_lw_prscr">
!  <OVERVIEW>
!    obtain_bulk_lw_prscr defines bulk longwave cloud radiative
!    properties for the mgrp_prscr_clds cloud scheme.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    obtain_bulk_lw_prscr defines bulk longwave cloud radiative
!    properties for the mgrp_prscr_clds cloud scheme.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call obtain_bulk_lw_prscr (is, ie, js, je, Cld_spec, Cldrad_props)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
!      Cld_spec          cloud specification arrays defining the
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input
!                        to this subroutine
!                        [ cld_specification_type ]
! 
!  </INOUT>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output
!               from this routine:
!
!                    %emrndlw   longwave cloud emissivity for
!                               randomly overlapped clouds
!                               in each of the longwave
!                               frequency bands  [ dimensionless ]
!                    %emmxolw   longwave cloud emissivity for
!                               maximally overlapped clouds
!                               in each of the longwave
!                               frequency bands  [ dimensionless ]
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine obtain_bulk_lw_prscr (is, ie, js, je, Cld_spec, Cldrad_props)

!---------------------------------------------------------------------
!    obtain_bulk_lw_prscr defines bulk longwave cloud radiative 
!    properties for the mgrp_prscr_clds cloud scheme.
!---------------------------------------------------------------------

integer,                     intent(in)     :: is, ie, js, je
type(cld_specification_type), intent(inout) :: Cld_spec
type(cldrad_properties_type), intent(inout) :: Cldrad_props

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!
!   intent(inout) variables:
!
!      Cld_spec          cloud specification arrays defining the 
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input 
!                        to this subroutine
!                        [ cld_specification_type ]
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output 
!               from this routine:
!
!                    %emrndlw   longwave cloud emissivity for 
!                               randomly overlapped clouds
!                               in each of the longwave 
!                               frequency bands  [ dimensionless ]
!                    %emmxolw   longwave cloud emissivity for 
!                               maximally overlapped clouds
!                               in each of the longwave 
!                               frequency bands  [ dimensionless ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:
 
      integer   ::    i,j,k   ! do-loop indices

!---------------------------------------------------------------------
!    assign the proper values for cloud emissivity to each grid box
!    with cloudiness, dependent on whether the cloud in that box is 
!    defined as being high, middle or low cloud. high and middle clouds
!    are assumed to be random overlap, low clouds are assume to be
!    maximum overlap.
!----------------------------------------------------------------------
      do k=1, size(Cld_spec%hi_cloud,3)
        do j=1,size(Cld_spec%hi_cloud,2)
          do i=1,size(Cld_spec%hi_cloud,1)
            if (Cld_spec%hi_cloud(i,j,k)) then
              Cldrad_props%emrndlw(i,j,k,:,1)  = cldem_hi
            else if (Cld_spec%mid_cloud(i,j,k)) then
              Cldrad_props%emrndlw(i,j,k,:,1)  = cldem_mid
            else if (Cld_spec%low_cloud(i,j,k)) then
              Cldrad_props%emmxolw(i,j,k,:,1)  = cldem_low
            endif
          end do
        end do
      end do

!---------------------------------------------------------------------



end subroutine obtain_bulk_lw_prscr 



!#####################################################################

! <SUBROUTINE NAME="obtain_bulk_sw_prscr">
!  <OVERVIEW>
!    obtain_bulk_sw_zonal defines bulk shortwave cloud radiative
!    properties for the zonal cloud scheme.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    obtain_bulk_sw_zonal defines bulk shortwave cloud radiative
!    properties for the zonal cloud scheme.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call obtain_bulk_sw_prscr (is, ie, js, je, Cld_spec, Cldrad_props)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
!      Cld_spec          cloud specification arrays defining the
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input
!                        to this subroutine
!                        [ cld_specification_type ]
! 
!  </INOUT>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output
!               from this routine:
!
!                    %cirabsw   absorptivity of clouds in the
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cirrfsw   reflectivity of clouds in the
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cvisrfsw  reflectivity of clouds in the
!                               visible frequency band
!                               [ dimensionless ]
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine obtain_bulk_sw_prscr (is, ie, js, je, Cld_spec, Cldrad_props)

!---------------------------------------------------------------------
!    obtain_bulk_sw_zonal defines bulk shortwave cloud radiative 
!    properties for the zonal cloud scheme.
!---------------------------------------------------------------------

integer,                      intent(in)    :: is, ie, js, je
type(cld_specification_type), intent(inout) :: Cld_spec
type(cldrad_properties_type), intent(inout) :: Cldrad_props
!-------------------------------------------------------------------

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!
!   intent(inout) variables:
!
!      Cld_spec          cloud specification arrays defining the 
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input 
!                        to this subroutine
!                        [ cld_specification_type ]
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output 
!               from this routine:
!
!                    %cirabsw   absorptivity of clouds in the 
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cirrfsw   reflectivity of clouds in the 
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cvisrfsw  reflectivity of clouds in the 
!                               visible frequency band
!                               [ dimensionless ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      integer     ::  i,j,k    ! do loop indices
 
!---------------------------------------------------------------------
!    assign the proper values for cloud absorptivity and reflectivity
!    to each grid box with cloudiness, dependent on whether the cloud 
!    in that box is defined as being high, middle or low cloud. 
!----------------------------------------------------------------------
      do k=1, size(Cld_spec%hi_cloud,3)
        do j=1,size(Cld_spec%hi_cloud,2)
          do i=1,size(Cld_spec%hi_cloud,1)
            if (Cld_spec%hi_cloud(i,j,k)) then
              Cldrad_props%cirabsw(i,j,k)  = cabir_hi
              Cldrad_props%cirrfsw(i,j,k)  = crfir_hi
              Cldrad_props%cvisrfsw(i,j,k) = crfvis_hi
            else if (Cld_spec%mid_cloud(i,j,k)) then
              Cldrad_props%cirabsw(i,j,k)  = cabir_mid
              Cldrad_props%cirrfsw(i,j,k)  = crfir_mid
              Cldrad_props%cvisrfsw(i,j,k) = crfvis_mid
            else if (Cld_spec%low_cloud(i,j,k)) then
              Cldrad_props%cirabsw(i,j,k)  = cabir_low
              Cldrad_props%cirrfsw(i,j,k)  = crfir_low
              Cldrad_props%cvisrfsw(i,j,k) = crfvis_low
            endif
          end do
        end do
      end do

!----------------------------------------------------------------------



end subroutine obtain_bulk_sw_prscr 




!######################################################################




!##################################################################


! <SUBROUTINE NAME="cldht">
!  <OVERVIEW>
!  This subroutine computes the heights of the cloud tops
!  and bottoms for the fixed cloud model.  The observed data
!  are from London (1954, 1957).  This data is a function of 10 deg.
!  latitude bands (0-10, 10-20 and etc.), season and height
!  in the orginal paper and only for
!  the Northern Hemisphere for various cloud types.
!  Dick and Suki averaged the four seasons together to get annual
!  mean cloud heights for three type of clouds (hi, middle and low).
!  Somebody also interpolated the data from the 10 deg latitude
!  bands to 5 deg bands.  At the equator, this interpolation
!  was more like an extrapolation.
!  These heights were then put in pressure coordinates using
!  a Skew-T diagram which assumes a "standard atmosphere".
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!  This subroutine computes the heights of the cloud tops
!  and bottoms for the fixed cloud model.  The observed data
!  are from London (1954, 1957).  This data is a function of 10 deg.
!  latitude bands (0-10, 10-20 and etc.), season and height
!  in the orginal paper and only for
!  the Northern Hemisphere for various cloud types.
!  Dick and Suki averaged the four seasons together to get annual
!  mean cloud heights for three type of clouds (hi, middle and low).
!  Somebody also interpolated the data from the 10 deg latitude
!  bands to 5 deg bands.  At the equator, this interpolation
!  was more like an extrapolation.
!  These heights were then put in pressure coordinates using
!  a Skew-T diagram which assumes a "standard atmosphere".
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call cldht (plevel, kkbh, kkth)
!
!  </TEMPLATE>
!  <IN NAME="plevel" TYPE="real">
! 
!  </IN>
!  <OUT NAME="kkbh" TYPE="integer">
! 
!  </OUT>
!  <OUT NAME="kkth" TYPE="integer">
! 
!  </OUT>
! </SUBROUTINE>
!
subroutine cldht (plevel, kkbh, kkth)

real, dimension(:), intent(in) :: plevel
integer, dimension(:,:), intent(out) :: kkbh, kkth
 
!------------------------------------------------------------------
!  This subroutine computes the heights of the cloud tops
!  and bottoms for the fixed cloud model.  The observed data
!  are from London (1954, 1957).  This data is a function of 10 deg.
!  latitude bands (0-10, 10-20 and etc.), season and height 
!  in the orginal paper and only for
!  the Northern Hemisphere for various cloud types.
!  Dick and Suki averaged the four seasons together to get annual 
!  mean cloud heights for three type of clouds (hi, middle and low).
!  Somebody also interpolated the data from the 10 deg latitude
!  bands to 5 deg bands.  At the equator, this interpolation
!  was more like an extrapolation.
!  These heights were then put in pressure coordinates using
!  a Skew-T diagram which assumes a "standard atmosphere".
!
!  The Dick and Suki (Ron's pressures) data follow:
!
! TYPE:      hi      |   middle    |            low
!     |              |             |     ctop    |   cbase
! Lat |   ht   press |  ht   press |  ht   press |  ht   press
! 0   |  9.80  272   | 4.35  590   | 3.00  700   | 1.40  855
! 5   |  9.82  271   | 4.40  586   | 3.04  698   | 1.47  848
! 10  | 10.13  259   | 4.45  581   | 3.08  693   | 1.61  836
! 15  | 10.35  250   | 4.50  578   | 3.08  693   | 1.70  828 
! 20  | 10.50  244   | 4.50  578   | 3.01  699   | 1.72  825
! 25  | 10.50  244   | 4.41  584   | 2.91  710   | 1.71  826
! 30  | 10.38  248   | 4.26  595   | 2.80  719   | 1.70  828
! 35  | 10.03  263   | 4.10  614   | 2.70  729   | 1.65  830
! 40  |  9.44  285   | 3.92  621   | 2.60  735   | 1.58  839
! 45  |  8.65  322   | 3.79  633   | 2.47  750   | 1.50  846
! 50  |  7.97  357   | 3.67  647   | 2.35  760   | 1.40  859
! 55  |  7.55  379   | 3.56  651   | 2.24  770   | 1.31  867
! 60  |  7.29  392   | 3.51  657   | 2.17  780   | 1.25  871
! 65  |  7.13  401   | 3.50  658   | 2.10  783   | 1.20  875
! 70  |  7.03  406   | 3.48  659   | 2.03  788   | 1.12  881
! 75  |  7.01  409   | 3.44  660   | 1.98  795   | 1.05  890
! 80  |  6.99  410   | 3.43  661   | 1.91  800   | 1.02  891
! 85  |  6.98  411   | 3.43  661   | 1.88  803   | 1.00  896
! 90  |  6.98  411   | 3.43  661   | 1.87  804   | 1.00  896
!
!  Note that the heights are in kilometers and the pressures
!  in millibars.
!--------------------------------------------------------------------

      real, dimension(10)   :: ciht, asht, cltop, clbase
      integer               :: n, nl, j
 
!------------------------------------------------------------------
!  The data in the following arrays run pole to equator,
!  starting at 90, 80, 70....10, 0.
!------------------------------------------------------------------
 
!  Observed high cloud heights running pole to equator (mb)
      data ciht / 411, 410, 406, 392, 357, 285, 248, 244, 259, 272 /
 
!  Observed middle cloud heights running pole to equator (mb)
      data asht / 661, 661, 659, 657, 647, 621, 595, 578, 581, 590 /
 
!  Observed low cloud top heights running pole to equator (mb)
!     data cltop / 804, 800, 788, 780, 760, 735, 719, 699, 693, 700 /
      data cltop / 804, 800, 788, 780, 766, 735, 719, 699, 693, 700 /
!  The above data statement was changed so that this code would
!  reproduce exactly the indexes used in the 9 level model.  The 6 mb
!  error should not affect the results very much....if at all.
 
!  Observed low cloud bottom heights running pole to equator (mb)
      data clbase / 896, 891, 881, 871, 859, 839, 828, 825, 836, 855 /
 
 
!--------------------------------------------------------------------
!   for (at present) unexplained reasons, the middle cloud 
!   specification does not agree with the current gcm specification.
!   a glance at the telegadas and london paper suggests differences
!   caused by 1) use of cldmid rather than clotop and cldbase heights
!   2) seeming errors in polar cloud height locations. for now,
!   the foregoing kluge gives cloud positions in agreement with
!   SKYHI, PROVIDED:
!    it is realized that these indexes are the true values, which
!   differ by 1 from the skyhiindices. in the gcm, a subtraction
!   is done to get the indices to be correct (see radmn.F).
!--------------------------------------------------------------------

      do n=8,10
asht(n) = asht(n) - 25.
      enddo
 
      clbase = clbase *1.0E02
      cltop  = cltop  *1.0E02
     asht  = asht*100.
     ciht = ciht*100.

 
!-------------------------------------------------------------------
!  First compute the cloud top indexes for the high clouds
!  nl is the index for cloud type nl=3 => high
!--------------------------------------------------------------------  

      nl = 3
      call Cldint(plevel, ciht ,kkth, nl)
 
!---------------------------------------------------------------------
!  Set cloud bottom height equal to cloud top height.
!  This assumes cirrus clouds are one level thick.
!---------------------------------------------------------------------

      do j=1,latobs
       kkbh(j,nl) = kkth(j,nl)
      end do
 
!-------------------------------------------------------------------
!  Second compute the cloud top indexes for the middle clouds
!  nl is the index for cloud type nl=2 => middle
!-------------------------------------------------------------------
  
      nl = 2
      call Cldint(plevel, asht,kkth,  nl)
 
!-------------------------------------------------------------------
!  Set cloud bottom height equal to cloud top height.
!  This assumes middle clouds are one level thick.
!-------------------------------------------------------------------

      do j=1,latobs
       kkbh(j,nl) = kkth(j,nl)
      end do
 
!-------------------------------------------------------------------
!  Third compute the cloud top indexes for the low clouds
!  nl is the index for cloud type nl=1 => low
!-------------------------------------------------------------------
  
      nl = 1
      call Cldint(plevel, cltop,kkth,  nl)
 
!-------------------------------------------------------------------
!  Lastly compute the cloud bottom indexes for the low clouds
!  This assumes that low clouds can be thicker than one level.
!  nl is the index for cloud type nl=1 => low
!-------------------------------------------------------------------
  
      nl = 1
      call Cldint(plevel, clbase, kkbh, nl)
 
end subroutine cldht


!##################################################################

! <SUBROUTINE NAME="cldint">
!  <OVERVIEW>
!  This subroutine computes the indexes for the heights of the cloud
!  tops and bottoms for the fixed cloud model.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!  This subroutine computes the indexes for the heights of the cloud
!  tops and bottoms for the fixed cloud model.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call cldint(plevel, cldobs, kindex, nl)
!
!  </TEMPLATE>
!  <IN NAME="plevel" TYPE="real">
! 
!  </IN>
!  <IN NAME="cldobs" TYPE="real">
! 
!  </IN>
!  <OUT NAME="kindex" TYPE="integer">
! 
!  </OUT>
!  <IN NAME="nl" TYPE="integer">
! 
!  </IN>
! </SUBROUTINE>
!
subroutine cldint(plevel, cldobs, kindex, nl)
 
!-------------------------------------------------------------------
!  This subroutine computes the indexes for the heights of the cloud 
!  tops and bottoms for the fixed cloud model. 
!-------------------------------------------------------------------
 
real, dimension(10), intent(in)                    :: cldobs
integer, dimension(LATOBS,NOFCLDS_SP), intent(out) :: kindex
integer,                               intent(in)  :: nl
real, dimension(:), intent(in) :: plevel
!------------------------------------------------------------------
 
      real, dimension(LATOBS)     :: cldlat
      real                        :: prsmid
      integer                     :: j, k
      integer                     :: kerad
 
      kerad = size(plevel(:)) - 1
!---------------------------------------------------------------------
!  Fill in Southern hemisphere cloud heights
!---------------------------------------------------------------------

      do j=1,10
       cldlat(j) = cldobs(j)
      end do  
      do j=1,9
       cldlat(j+10) = cldobs(10-j)
      end do  
  
!-------------------------------------------------------------------
!  Start latitude loop to compute index at each latitude.
!-------------------------------------------------------------------
      do j=1,LATOBS
 
!-------------------------------------------------------------------
!  Find first place where the pressure on the model level
!  is greater than the pressure of the cloud height.  Starting
!  from the top of the atm and going down the column.
!-------------------------------------------------------------------
        if (plevel(KERAD)       .lt. cldlat(j)) then       
        call error_mesg ('mgrp_prscr_clds_mod',  &
         'no level found with pressure greater than cloud pressure', & 
FATAL)
endif
        if (plevel(1)       .gt. cldlat(j)) then       
        call error_mesg ('mgrp_prscr_clds_mod',  &
                ' cloud is above highest model level', FATAL)
        endif
do k=1,KERAD
          if (plevel(k) .gt. cldlat(j)) then       
!-------------------------------------------------------------------
!  k is the index of the first model level below the cloud height.
!  compute the pressure half way between the model levels
!-------------------------------------------------------------------
            prsmid = (plevel(k)+plevel(k-1))      *0.5   
 
!-------------------------------------------------------------------
!  If prsmid is greater than cldlat (cloud height) then the
!  level above is closer to cloud height, otherwise it is the
!  level below.
!-------------------------------------------------------------------
            if (prsmid .gt. cldlat(j)) then
              kindex(j,nl) = k-1
            else
              kindex(j,nl) = k
            endif
            exit
  endif
        end do
      end do
!--------------------------------------------------------------------

 

end subroutine cldint




!####################################################################

       end module mgrp_prscr_clds_mod

module ocean_nphysics_skew_mod
  !
  !<CONTACT EMAIL="t.leslie@unsw.edu.au"> Tim Leslie
  !</CONTACT>
  !
  !<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
  !</CONTACT>
  ! 
  !<OVERVIEW>
  ! Thickness weighted and density weighted time tendency for tracer
  ! from Laplacian neutral diffusion + Laplacian skew-diffusion.
  !</OVERVIEW>
  !
  !<DESCRIPTION>
  ! This module computes the cell thickness weighted and density
  ! weighted tracer tendency from small angle Laplacian neutral diffusion
  ! plus Laplacian skew-diffusion.  The algorithms for neutral diffusion
  ! are based on mom4p0d methods.  The algorithm for neutral skewsion
  ! are based on a projection onto a few of the lowest baroclinic
  ! modes. This module is experimental, and should be used with caution.
  !</DESCRIPTION>
  !
  ! <INFO>
  !
  ! <REFERENCE>
  ! S.M. Griffies
  ! The Gent-McWilliams Skew-flux
  ! Journal of Physical Oceanography (1998) vol 28 pages 831-841
  ! </REFERENCE>
  !
  ! <REFERENCE>
  ! R. Ferrari, S.M. Griffies, A.J.G. Nurser, and G.K. Vallis
  ! A boundary value problem for the parameterized mesoscale eddy transport
  ! Ocean Modelling, 2009.
  ! </REFERENCE>
  !
  ! <REFERENCE>
  ! S.M. Griffies
  ! Fundamentals of Ocean Climate Models (2004)
  ! Princeton University Press
  ! </REFERENCE>
  !
  ! <REFERENCE>
  ! S.M. Griffies: Elements of MOM (2012)
  ! </REFERENCE>
  !
  ! </INFO>
  !
  !<NAMELIST NAME="ocean_nphysics_skew_nml">
  !  <DATA NAME="gm_transport" TYPE="logical">
  !  To compute tendency from GM skewsion. Default gm_transport=.false.
  !  </DATA>
  !  <DATA NAME="bc_modes_transport" TYPE="logical">
  !  To compute tendency from GM skewsion using streamfunction established
  !  by baroclinic modes. Default bc_modes_transport=.false.
  !  </DATA>
  !  <DATA NAME="bvp_transport" TYPE="logical">
  !  To compute tendency from GM skewsion using streamfunction established
  !  by a boundary value problem. Default bvp_transport=.false.
  !  </DATA>
  !
  !  <DATA NAME="number_bc_modes" TYPE="integer">
  !  The number of baroclinic modes used to construct the eddy induced
  !  streamfunction when bc_modes_transport. Default number_bc_modes=1.
  !  </DATA>
  !  <DATA NAME="min_bc_speed"  UNITS="m/s"  TYPE="real">
  !  The minimum speed used for computing the baroclinic modes.
  !  Default min_bc_speed=1e-6
  !  </DATA>
  !  <DATA NAME="regularize_transport" TYPE="logical">
  !  To reduce the magnitude of psi in regions of weak stratification,
  !  using the slope = smax_psi to set the overall scale of the max allowed
  !  for psi. Default regularize_transport=.true.
  !  </DATA>
  !  <DATA NAME="smax_psi" TYPE="real">
  !  Maximum slope used for setting the overall scale of a modal
  !  contribution to the parameterized transport.
  !  Default smax_psi=0.1.
  !  </DATA>
  !
  !  <DATA NAME="bvp_constant_speed" TYPE="logical">
  !  For taking a constant speed to be used for the calculation
  !  of the BVP streamfunction. Default bvp_constant_speed=.false.
  !  </DATA>
  !  <DATA NAME="bvp_speed" UNITS="m/s" TYPE="real">
  !  For setting the speed weighting the second order derivative operator
  !  in the BVP streamfunction method:
  !  c^2 = max[bvp_min_speed, (bvp_speed-c_mode)^2].
  !  If bvp_constant_speed, then  c^2 = bvp_speed^2.
  !  Default bvp_speed=0.0, in which case c^2 = c_mode^2.
  !  </DATA>
  !
  !  <DATA NAME="bvp_bc_mode" TYPE="integer">
  !  The particular baroclinic mode used to construct the BVP streamfunction.
  !  If bvp_bc_mode=0, then will set bc_speed=0 when computing the BVP streamfunction.
  !  Default bvp_bc_mode=1.
  !  </DATA>
  !  <DATA NAME="bvp_min_speed" UNITS="m/s" TYPE="real">
  !  For setting a minimum speed for use with the calculation
  !  of the BVP streamfunction. We need  bvp_min_speed>0 to ensure
  !  that the second order derivative operator contributes to the
  !  calculation of the streamfunction.
  !  Default bvp_min_speed=0.1.
  !  </DATA>
  !
  !  <DATA NAME="bv_freq_smooth_vert" TYPE="logical">
  !  To smooth the buoyancy frequency for use in
  !  computing the baroclinic modes. Generally this field has already
  !  been smooted in ocean_density_mod, but we maintain the possibility of
  !  further smoothing here.  Default bv_freq_smooth_vert=.false.
  !  </DATA>
  !
  !  <DATA NAME="smooth_transport" TYPE="logical">
  !  For doing a horizontal 1-2-1 smoothing on the psix and psiy fields.
  !  This is useful to reduce noise. Default smooth_psi=.true.
  !  </DATA>
  !
  !</NAMELIST>

#define COMP isc:iec,jsc:jec
#define COMPXRR isc+1:iec+1,jsc:jec
#define COMPYRR isc:iec,jsc+1:jec+1

  use constants_mod, only: epsln, pi
  use fms_mod,       only: open_namelist_file, check_nml_error, close_file, FATAL
  use mpp_mod,       only: mpp_error, stdout, stdlog
  use mpp_mod,       only: input_nml_file

  use ocean_domains_mod,           only: get_local_indices
  use ocean_nphysics_util_new_mod, only: horz_smooth
  use ocean_parameters_mod,        only: grav
  use ocean_types_mod,             only: ocean_grid_type, ocean_domain_type
  use ocean_types_mod,             only: ocean_thickness_type, ocean_time_type
  use ocean_util_mod,              only: diagnose_2d, diagnose_3d
  use ocean_util_mod,              only: register_2d_t_field, register_3d_t_field

  implicit none

  public ocean_nphysics_skew_init
  public skew_transport

  private

#include <ocean_memory.h>

character(len=128) :: version=&
     '$Id: ocean_nphysics_skew.F90,v 20.0 2013/12/14 00:14:48 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

character(len=*), parameter :: FILENAME=&
     __FILE__


  integer :: id_bc_speed
  integer :: id_sine_arg_up
  integer :: id_sine_arg_lo
  integer :: id_sine_arg_pre_up
  integer :: id_sine_arg_pre_lo
  integer :: id_bc_mode_1
  integer :: id_norm_1
  integer :: id_depth_blayer_base
  integer :: id_agm_slopex_max
  integer :: id_agm_slopey_max
  integer :: id_N2_Sx_agm_dz
  integer :: id_N2_Sy_agm_dz

  !------Namelist parameters 

  logical :: gm_transport = .false.

  ! for computing skewsion via baroclinic mode decomposition  
  logical :: bc_modes_transport = .false.
  ! number of modes used to construct GM transport when bc_modes_transport=.true.
  integer :: number_bc_modes = 1

  ! for regularizing the transport when computed from modes
  logical :: regularize_transport = .true.
  real    :: smax_psi = 0.01

  ! for computing skewsion via boundary value problem (BVP)
  logical :: bvp_transport = .false.

  ! for setting the speed to constant with the BVP calculation.
  logical :: bvp_constant_speed = .false.
  real    :: bvp_speed          = 0.0

  ! the particular baroclinic mode speed used to construct the BVP transport.
  integer :: bvp_bc_mode = 1
  real    :: bvp_min_speed = 1.0

  ! for smoothing upsilonx and upsilony
  logical :: smooth_transport = .true.

  namelist /ocean_nphysics_skew_nml/                                      & 
       gm_transport, bc_modes_transport, number_bc_modes,                 &
       regularize_transport, smax_psi, bvp_transport, bvp_constant_speed, &
       bvp_speed, bvp_bc_mode, bvp_min_speed, smooth_transport

  contains

  !#######################################################################
  ! <SUBROUTINE NAME="ocean_nphysics_skew_init">
  !
  ! <DESCRIPTION>
  ! Initialization routine. 
  ! </DESCRIPTION>
  !
  subroutine ocean_nphysics_skew_init(Domain, Grid, Time, agm_z_dep)

    type(ocean_domain_type), intent(in) :: Domain
    type(ocean_grid_type),   intent(in) :: Grid
    type(ocean_time_type),   intent(in) :: Time
    logical,                 intent(in) :: agm_z_dep

    integer :: stdoutunit, stdlogunit, ierr, ioun, io_status
    stdoutunit=stdout();stdlogunit=stdlog() 

#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
    nk = Grid%nk
#endif

    ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_nphysics_skew_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_nphysics_skew_nml')
#else
    ioun =  open_namelist_file()
    read (ioun,ocean_nphysics_skew_nml,IOSTAT=io_status)
    ierr = check_nml_error(io_status,'ocean_nphysics_skew_nml')
    call close_file (ioun)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit,ocean_nphysics_skew_nml)  
    write (stdlogunit,ocean_nphysics_skew_nml)

    if (count((/gm_transport, bc_modes_transport, bvp_transport /)) /= 1) then
       call mpp_error(FATAL, &
            '==>Error from ocean_nphysics_skew: must choose exactly one neutral skew transport method.')
    endif

    if (agm_z_dep .and. (bc_modes_transport .or. bvp_transport)) then
       call mpp_error(FATAL, &
            '==>Error from ocean_nphysics_skew (ocean_nphysics_skew_init): Cannot use a z-dependent ' // &
            'skew diffusivity with bc_modes_transport or bvp_transport.')
    endif

    call register_fields(Grid, Time)

  end subroutine ocean_nphysics_skew_init
  ! </SUBROUTINE> NAME="ocean_nphysics_skew_init"

  !#######################################################################
  ! <SUBROUTINE NAME="register fields">
  !
  ! <DESCRIPTION>
  ! Register diagnostic fields.
  ! </DESCRIPTION>
  !
  subroutine register_fields(Grid, Time)
    type(ocean_grid_type), intent(in) :: Grid
    type(ocean_time_type), intent(in) :: Time

    id_norm_1 = register_2d_t_field(Grid, Time, 'norm_1', &
         'Normalisation factor for 1st baroclinic mode.', 'm/s', (/-1e20,1.e20/))
    id_sine_arg_up = register_3d_t_field(Grid, Time, 'sine_arg_up', &
         'Argument to sine used in computing baroclinic modes', 'rad', (/-2*pi, 2*pi/))
    id_sine_arg_lo = register_3d_t_field(Grid, Time, 'sine_arg_lo', &
         'Argument to sine used in computing baroclinic modes', 'rad', (/-2*pi, 2*pi/))
    id_sine_arg_pre_up = register_3d_t_field(Grid, Time, 'sine_arg_pre_up', &
         'Argument to sine used in computing baroclinic modes', 'rad', (/-2*pi, 2*pi/))
    id_sine_arg_pre_lo = register_3d_t_field(Grid, Time, 'sine_arg_pre_lo', &
         'Argument to sine used in computing baroclinic modes', 'rad', (/-2*pi, 2*pi/))
    id_bc_mode_1 = register_3d_t_field(Grid, Time, 'bc_mode_1', &
         '1st baroclinic mode', '', (/-1e8,1.e8/)) ! Dimensionless

    id_depth_blayer_base = register_2d_t_field(Grid, Time, 'depth_blayer_base', &
         'Depth of the boundary layer base used to taper GM transport', 'm', (/0.0, 1.e5/))
    id_agm_slopex_max = register_2d_t_field(Grid, Time, 'agm_slopex_max', &
         'x component of (kS)_max at boundary layer', 'm^2/s', (/-1e8,1.e8/))
    id_agm_slopey_max = register_2d_t_field(Grid, Time, 'agm_slopey_max', &
         'y component of (kS)_max at boundary layer', 'm^2/s', (/-1e8,1.e8/))

    id_N2_Sx_agm_dz = register_3d_t_field(Grid, Time, 'N2_Sx_agm_dz', &
         'x component of \kappa \grad\rho dz', 'rad', (/-1e20, 1e20/))
    id_N2_Sy_agm_dz = register_3d_t_field(Grid, Time, 'N2_Sy_agm_dz', &
         'x component of \kappa \grad\rho dz', 'rad', (/-1e20, 1e20/))

  end subroutine register_fields
  ! </SUBROUTINE> NAME="register_fields"

  subroutine skew_transport(Domain, Time, Grid, Thickness,               &
       agm_array, slopex_xz, slopey_yz, Ndz_z, N2_z, gravity_wave_speed, &
       depth_taper, ksurf_blayer,                                        &
       upsilonx_xz, upsilony_yz)

    type(ocean_domain_type),    intent(inout) :: Domain
    type(ocean_time_type),      intent(in)    :: Time
    type(ocean_grid_type),      intent(in)    :: Grid
    type(ocean_thickness_type), intent(in)    :: Thickness

    real, dimension(isd:,jsd:,:),       intent(in) :: agm_array
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: slopex_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: slopey_yz
    real, dimension(isd:,jsd:,:,0:),    intent(in) :: Ndz_z
    real, dimension(isd:,jsd:,:,0:),    intent(in) :: N2_z
    real, dimension(isd:,jsd:),         intent(in) :: gravity_wave_speed

    real, dimension(isd:,jsd:,:),  intent(in) :: depth_taper
    integer, dimension(isd:,jsd:), intent(in) :: ksurf_blayer

    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: upsilonx_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: upsilony_yz

    integer :: ip, kr

    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: agm_slopex_xz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: agm_slopey_yz
    real, dimension(isd:ied,jsd:jed,nk,0:1)     :: N2dz_z
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: N2_Sx_agm_dz_xz, N2_Sy_agm_dz_yz

    upsilonx_xz(:,:,:,:,:) = 0.0
    upsilony_yz(:,:,:,:,:) = 0.0

    do ip=0,1
       do kr=0,1
          agm_slopex_xz(COMP,:,ip,kr) = agm_array(COMP,:)*slopex_xz(COMP,:,ip,kr)
          agm_slopey_yz(COMP,:,ip,kr) = agm_array(COMP,:)*slopey_yz(COMP,:,ip,kr)
       enddo
    enddo
    if(gm_transport) then
       call gm_tensor(Time, Grid, Thickness, agm_slopex_xz, agm_slopey_yz, &
            depth_taper, ksurf_blayer, &
            upsilonx_xz, upsilony_yz)
    else
       ! We need the following quantities for the vertical integrals which follow
       N2dz_z(COMP,:,0) = N2_z(COMP,:,0)*Thickness%dztup(COMP,:)
       N2dz_z(COMP,:,1) = N2_z(COMP,:,1)*Thickness%dztlo(COMP,:)
       do ip=0,1
          N2_Sx_agm_dz_xz(COMP,:,ip,:) = N2dz_z(COMP,:,:)*agm_slopex_xz(COMP,:,ip,:)
          N2_Sy_agm_dz_yz(COMP,:,ip,:) = N2dz_z(COMP,:,:)*agm_slopey_yz(COMP,:,ip,:)
       enddo
       call diagnose_3d(Time, Grid, id_N2_Sx_agm_dz, 0.25*sum(sum(N2_Sx_agm_dz_xz, dim=5), dim=4))
       call diagnose_3d(Time, Grid, id_N2_Sy_agm_dz, 0.25*sum(sum(N2_Sy_agm_dz_yz, dim=5), dim=4))
       
       if (bc_modes_transport) then
          call compute_transport_modes(Time, Grid, agm_array, Ndz_z, N2dz_z, &
               gravity_wave_speed, N2_Sx_agm_dz_xz, N2_Sy_agm_dz_yz,         &
               upsilonx_xz, upsilony_yz)
       elseif (bvp_transport) then
          call compute_transport_bvp(Grid%tmask, Thickness, gravity_wave_speed, &
               N2dz_z, N2_Sx_agm_dz_xz, N2_Sy_agm_dz_yz, upsilonx_xz, upsilony_yz)
       endif
    endif

    if (smooth_transport) then
       call do_smooth_transport(Domain, Grid%tmask, upsilonx_xz, upsilony_yz)
    endif

  end subroutine skew_transport

  !#######################################################################
  ! <SUBROUTINE NAME="gm_tensor">
  !
  ! <DESCRIPTION>
  ! Compute the skew tensor terms using the GM method.
  ! </DESCRIPTION>
  !
  subroutine gm_tensor(Time, Grid, Thickness, agm_slopex_xz, agm_slopey_yz, &
       depth_taper, ksurf_blayer, upsilonx_xz, upsilony_yz)

    type(ocean_time_type),              intent(in) :: Time
    type(ocean_grid_type),              intent(in) :: Grid
    type(ocean_thickness_type),         intent(in) :: Thickness
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: agm_slopex_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: agm_slopey_yz

    real, dimension(isd:,jsd:,:),  intent(in) :: depth_taper
    integer, dimension(isd:,jsd:), intent(in) :: ksurf_blayer

    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: upsilonx_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: upsilony_yz

    real, dimension(isd:ied,jsd:jed,nk) :: agm_slope_taper_x
    real, dimension(isd:ied,jsd:jed,nk) :: agm_slope_taper_y
    real, dimension(isd:ied,jsd:jed)    :: agm_slopex_max
    real, dimension(isd:ied,jsd:jed)    :: agm_slopey_max
    real, dimension(isd:ied,jsd:jed)    :: depth_blayer_base
    real, dimension(isd:ied,jsd:jed)    :: agm_slopex_blayer
    real, dimension(isd:ied,jsd:jed)    :: agm_slopey_blayer
    real, dimension(isd:ied,jsd:jed)    :: depth_taper_blayer

    integer :: i, j, k, k_blayer

    ! Calculate boundary layer values
    do j=jsc,jec
       do i=isc,iec
          k_blayer = ksurf_blayer(i,j)
          if (k_blayer > 0) then
             depth_blayer_base(i,j)  = Thickness%depth_zt(i,j,k_blayer)
             agm_slopex_blayer(i,j)  = sum(agm_slopex_xz(i,j,k_blayer,:,:))/4.0
             agm_slopey_blayer(i,j)  = sum(agm_slopey_yz(i,j,k_blayer,:,:))/4.0
             depth_taper_blayer(i,j) = depth_taper(i,j,k_blayer)
          else
             depth_blayer_base(i,j)  = 0.0
             agm_slopex_blayer(i,j)  = 0.0
             agm_slopey_blayer(i,j)  = 0.0
             depth_taper_blayer(i,j) = 0.0
          endif
       enddo
    enddo

    agm_slopex_max(COMP) = 0.0
    agm_slopey_max(COMP) = 0.0
    where (ksurf_blayer(COMP) > 0)
       agm_slopex_max(COMP) = depth_taper_blayer(COMP)*agm_slopex_blayer(COMP)
       agm_slopey_max(COMP) = depth_taper_blayer(COMP)*agm_slopey_blayer(COMP)
    endwhere
    
    call diagnose_2d(Time, Grid, id_depth_blayer_base, depth_blayer_base)
    call diagnose_2d(Time, Grid, id_agm_slopex_max, agm_slopex_max, abs_max=1.e5)
    call diagnose_2d(Time, Grid, id_agm_slopey_max, agm_slopey_max, abs_max=1.e5)

    do k = 1, nk
       ! taper times slope for use with GM skewsion
       where (k <= ksurf_blayer(COMP))
          ! Linear taper of (kS)_max in the steep slope region
          agm_slope_taper_x(COMP,k) = agm_slopex_max(COMP)*Thickness%depth_zt(COMP,k)/depth_blayer_base(COMP)
          agm_slope_taper_y(COMP,k) = agm_slopey_max(COMP)*Thickness%depth_zt(COMP,k)/depth_blayer_base(COMP)
          upsilonx_xz(COMP,k,0,0)   = -agm_slope_taper_x(COMP,k)
          upsilonx_xz(COMP,k,0,1)   = -agm_slope_taper_x(COMP,k)
          upsilonx_xz(COMP,k,1,0)   = -agm_slope_taper_x(COMP,k)
          upsilonx_xz(COMP,k,1,1)   = -agm_slope_taper_x(COMP,k)

          upsilony_yz(COMP,k,0,0) = -agm_slope_taper_y(COMP,k)
          upsilony_yz(COMP,k,0,1) = -agm_slope_taper_y(COMP,k)
          upsilony_yz(COMP,k,1,0) = -agm_slope_taper_y(COMP,k)
          upsilony_yz(COMP,k,1,1) = -agm_slope_taper_y(COMP,k)
       elsewhere
          ! Sine taper of (kS) elsewhere
          upsilonx_xz(COMP,k,0,0) = -depth_taper(COMP,k)*agm_slopex_xz(COMP,k,0,0)
          upsilonx_xz(COMP,k,0,1) = -depth_taper(COMP,k)*agm_slopex_xz(COMP,k,0,1)
          upsilonx_xz(COMP,k,1,0) = -depth_taper(COMP,k)*agm_slopex_xz(COMP,k,1,0)
          upsilonx_xz(COMP,k,1,1) = -depth_taper(COMP,k)*agm_slopex_xz(COMP,k,1,1)

          upsilony_yz(COMP,k,0,0) = -depth_taper(COMP,k)*agm_slopey_yz(COMP,k,0,0)
          upsilony_yz(COMP,k,0,1) = -depth_taper(COMP,k)*agm_slopey_yz(COMP,k,0,1)
          upsilony_yz(COMP,k,1,0) = -depth_taper(COMP,k)*agm_slopey_yz(COMP,k,1,0)
          upsilony_yz(COMP,k,1,1) = -depth_taper(COMP,k)*agm_slopey_yz(COMP,k,1,1)
       endwhere
    enddo

  end subroutine gm_tensor
  ! </SUBROUTINE> NAME="gm_tensor"

  !#######################################################################
  ! <SUBROUTINE NAME="compute_transport_modes">
  !
  ! <DESCRIPTION>
  ! Compute transport as projection onto baroclinic modes.
  !
  ! Units of upsilon are m^2/sec
  !
  ! Subroutine computes the baroclinic wave speeds and the dimensionless
  ! baroclinic mode eigenfunction for the vertical velocity baroclinic
  ! modes.  These modes vanish at the surface and the bottom.  We use
  ! the Chelton etal WKB analytic formulae for the speeds and modes.
  !
  ! The baroclinic modes are dimensionless, and normalized over the
  ! depth of the ocean, from free surface to bottom.
  !
  ! The speeds are m/sec.
  !
  ! </DESCRIPTION>
  !
  subroutine compute_transport_modes(Time, Grid, agm_array, Ndz_z, N2dz_z, &
       gravity_wave_speed, N2_Sx_agm_dz_xz, N2_Sy_agm_dz_yz, upsilonx_xz, upsilony_yz)
    type(ocean_time_type),              intent(in) :: Time
    type(ocean_grid_type),              intent(in) :: Grid
    real, dimension(isd:,jsd:,:),       intent(in) :: agm_array
    real, dimension(isd:,jsd:,:,0:),    intent(in) :: Ndz_z
    real, dimension(isd:,jsd:,:,0:),    intent(in) :: N2dz_z
    real, dimension(isd:,jsd:),         intent(in) :: gravity_wave_speed
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: N2_Sx_agm_dz_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: N2_Sy_agm_dz_yz

    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: upsilonx_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: upsilony_yz

    integer :: k, n, ip, jq, kr
    real, dimension(isd:ied,jsd:jed,nk,0:1)                 :: sine_arg_z
    real, dimension(isd:ied,jsd:jed,nk,0:1,number_bc_modes) :: bc_modes_zn
    real, dimension(isd:ied,jsd:jed,number_bc_modes)        :: norm_n
    real, dimension(isd:ied,jsd:jed,0:1,number_bc_modes)    :: upsilon_xn, upsilon_yn

    ! compute argument of sine used in defining the baroclinic modes
    sine_arg_z(COMP,:,:)  = 0.0
    sine_arg_z(COMP,nk,1) = 0.5*Ndz_z(COMP,nk,1)
    sine_arg_z(COMP,nk,0) = sine_arg_z(COMP,nk,1) + 0.5*(Ndz_z(COMP,nk,1) + Ndz_z(COMP,nk,0))
    do k = nk-1, 1, -1
       sine_arg_z(COMP,k,1) = sine_arg_z(COMP,k+1,0) + 0.5*(Ndz_z(COMP,k+1,0) + Ndz_z(COMP,k,1))
       sine_arg_z(COMP,k,0) = sine_arg_z(COMP,k,1) + 0.5*(Ndz_z(COMP,k,1) + Ndz_z(COMP,k,0))
    enddo

    call diagnose_3d(Time, Grid, id_sine_arg_pre_up, sine_arg_z(:,:,:,0))
    call diagnose_3d(Time, Grid, id_sine_arg_pre_lo, sine_arg_z(:,:,:,1))

    do k = 1, nk
       do kr = 0, 1
          sine_arg_z(COMP,k,kr) = sine_arg_z(COMP,k,kr)/(epsln + gravity_wave_speed(COMP))
       enddo
    enddo

    ! compute baroclinic modes
    bc_modes_zn(COMP,:,:,:) = 0.0
    do n = 1, number_bc_modes
       ! dimensionless baroclinic mod
       bc_modes_zn(COMP,:,:,n) = sin(sine_arg_z(COMP,:,:)*n)
       ! normalize the baroclinic mode
       norm_n(COMP,n) = sum(sum(N2dz_z(COMP,:,:)*bc_modes_zn(COMP,:,:,n)**2, dim=4), dim=3)
    enddo
    norm_n(COMP,:) = sqrt(grav/(epsln+norm_n(COMP,:)))

    call diagnose_2d(Time, Grid, id_norm_1, norm_n(:,:,1))
    call diagnose_3d(Time, Grid, id_sine_arg_up, sine_arg_z(:,:,:,0))
    call diagnose_3d(Time, Grid, id_sine_arg_lo, sine_arg_z(:,:,:,1))
    call diagnose_3d(Time, Grid, id_bc_mode_1, 0.5*sum(bc_modes_zn(:,:,:,:,1), dim=4))

    do k = 1, nk
       do kr = 0,1
          bc_modes_zn(COMP,k,kr,:) = bc_modes_zn(COMP,k,kr,:)*norm_n(COMP,:)
       enddo
    enddo

    do n = 1, number_bc_modes
       ! projection of agm*grad_rho onto baroclinic modes,
       ! integrated over the depth of an ocean column.
       ! upsilon_xn and upsilon_yn have dimensions kg/(m*sec)
       do ip = 0, 1
          jq = ip
          upsilon_xn(COMP,ip,n) = -sum(sum(bc_modes_zn(COMP,:,:,n)*N2_Sx_agm_dz_xz(COMP,:,ip,:), dim=4), dim=3)/grav
          upsilon_yn(COMP,jq,n) = -sum(sum(bc_modes_zn(COMP,:,:,n)*N2_Sy_agm_dz_yz(COMP,:,jq,:), dim=4), dim=3)/grav
       enddo
    enddo

    do k = 1, nk
       do ip = 0, 1
          jq = ip
          do kr = 0, 1
             upsilonx_xz(COMP,k,ip,kr) = sum(bc_modes_zn(COMP,k,kr,:)*upsilon_xn(COMP,ip,:), dim=3)
             upsilony_yz(COMP,k,jq,kr) = sum(bc_modes_zn(COMP,k,kr,:)*upsilon_yn(COMP,jq,:), dim=3)
          enddo
       enddo
    enddo

    if (regularize_transport) then
       call do_regularize_transport(agm_array, upsilonx_xz, upsilony_yz)
    endif

  end subroutine compute_transport_modes
  ! </SUBROUTINE> NAME="compute_transport_modes"

  !#######################################################################
  ! <SUBROUTINE NAME="do_regularize_transport">
  !
  ! <DESCRIPTION>
  ! regularize the transport to keep magnitude
  ! under control in regions of weak vertical stratification.
  ! </DESCRIPTION>
  !
  subroutine do_regularize_transport(agm_array, upsilonx_xz, upsilony_yz)
    real, dimension(isd:,jsd:,:),       intent(in) :: agm_array
    real, dimension(isd:,jsd:,:,0:,0:), intent(inout) :: upsilonx_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(inout) :: upsilony_yz

    integer :: k, ip, jq, kr
    real, dimension(isd:ied,jsd:jed) :: max_agm
    real, dimension(isd:ied,jsd:jed,0:1) :: col_max_x, col_max_y
    real, dimension(isd:ied,jsd:jed,0:1) :: reg_psix_y, reg_psiy_x

    ! agm_array is ot z-dependent, so the maximum value over the column
    ! is equal to its value at the surface
    max_agm(COMP) = agm_array(COMP,1)*smax_psi
    col_max_x(COMP,:) = maxval(maxval(abs(upsilonx_xz(COMP,:,:,:)), dim=5), dim=3)
    col_max_y(COMP,:) = maxval(maxval(abs(upsilony_yz(COMP,:,:,:)), dim=5), dim=3)

    reg_psix_y(:,:,:) = 1.0
    reg_psiy_x(:,:,:) = 1.0
    do ip=0,1
       jq=ip
       where (col_max_y(COMP,jq) > max_agm(COMP))
          reg_psix_y(COMP,jq) = max_agm(COMP)/col_max_y(COMP,jq)
       endwhere
       where (col_max_x(COMP,ip) > max_agm(COMP))
          reg_psiy_x(COMP,ip) = max_agm(COMP)/col_max_x(COMP,ip)
       endwhere
    enddo
    do k = 1, nk
       do kr = 0, 1
          upsilonx_xz(COMP,k,:,kr) = upsilonx_xz(COMP,k,:,kr)*reg_psiy_x(COMP,:)
          upsilony_yz(COMP,k,:,kr) = upsilony_yz(COMP,k,:,kr)*reg_psix_y(COMP,:)
       enddo
    enddo

  end subroutine do_regularize_transport
  ! </SUBROUTINE> NAME="do_regularize_transport"


  !#######################################################################
  ! <SUBROUTINE NAME="compute_transport_bvp">
  !
  ! <DESCRIPTION>
  ! Compute transport by solving a boundary value problem.
  !
  ! psi is centered on bottom of tracer cell; for example,
  ! psi(k=1)=psi at bottom of tracer cell k=1.
  ! psi vanishes at the ocean surface: psi(k=0)=0
  ! and ocean bottom: psi(k=kmt)=0.
  !
  ! We solve for psi(k=1,kmt-1) using a tridiagonal solver from
  ! Section 2.4 of Press etal 1986.
  !
  ! Units of psi are m^2/sec
  !
  ! </DESCRIPTION>
  !
  subroutine compute_transport_bvp(tmask, Thickness, gravity_wave_speed, &
       N2dz_z, N2_Sx_agm_dz_xz, N2_Sy_agm_dz_yz, upsilonx_xz, upsilony_yz)

    real, dimension(isd:,jsd:,:),       intent(in) :: tmask
    type(ocean_thickness_type),         intent(in) :: Thickness
    real, dimension(isd:,jsd:),         intent(in) :: gravity_wave_speed
    real, dimension(isd:,jsd:,:,0:),    intent(in) :: N2dz_z
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: N2_Sx_agm_dz_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: N2_Sy_agm_dz_yz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: upsilonx_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: upsilony_yz

    integer :: k
    real, dimension(isd:ied,jsd:jed,nk,0:1) :: rhs_dz_ztb_x, rhs_dz_ztb_y
    real, dimension(isd:ied,jsd:jed,nk) :: c2_dzr_a, n2_dz_b, c2_dzr_c, N2dz_ztb
    real, dimension(isd:ied,jsd:jed,0:nk,0:1) :: upsilonx_ztb_x, upsilony_ztb_y

    ! squared wave speed (m/s) for chosen baroclinic mode
    real, dimension(isd:ied,jsd:jed) :: bc_speed2 

    ! compute RHS source terms
    do k = 1, nk-1
       rhs_dz_ztb_x(COMP,k,:) = N2_Sx_agm_dz_xz(COMP,k,:,1) + N2_Sx_agm_dz_xz(COMP,k+1,:,0)
       rhs_dz_ztb_y(COMP,k,:) = N2_Sy_agm_dz_yz(COMP,k,:,1) + N2_Sy_agm_dz_yz(COMP,k+1,:,0)
    enddo

    ! compute c^2
    if (bvp_constant_speed) then
       bc_speed2(COMP) = bvp_speed**2
    else
       bc_speed2(COMP) = max(bvp_min_speed, gravity_wave_speed(COMP)/bvp_bc_mode)**2
    endif

    ! a,b,c fields (using Press etal nomenclature) to invert tridiagonal matrix
    c2_dzr_a(COMP,:) = 0.0 ! a
    n2_dz_b(COMP,:)  = 0.0 ! b
    c2_dzr_c(COMP,:) = 0.0 ! c
    do k = 1, nk-1
       c2_dzr_a(COMP,k) = bc_speed2(COMP)/(epsln+Thickness%dzt(COMP,k))
       c2_dzr_c(COMP,k) = bc_speed2(COMP)/(epsln+Thickness%dzt(COMP,k+1))

       N2dz_ztb(COMP,k) = (N2dz_z(COMP,k,1) + N2dz_z(COMP,k+1,0))
       n2_dz_b(COMP,k)  = -(N2dz_ztb(COMP,k) + c2_dzr_a(COMP,k) + c2_dzr_c(COMP,k))
    enddo

    ! Mask things out
    do k = 1, nk-1
       c2_dzr_a(COMP,k)       = tmask(COMP,k+1)*c2_dzr_a(COMP,k)
       n2_dz_b(COMP,k)        = tmask(COMP,k+1)*n2_dz_b(COMP,k)
       c2_dzr_c(COMP,k)       = tmask(COMP,k+1)*c2_dzr_c(COMP,k)
       rhs_dz_ztb_x(COMP,k,0) = tmask(COMP,k+1)*rhs_dz_ztb_x(COMP,k,0)
       rhs_dz_ztb_x(COMP,k,1) = tmask(COMP,k+1)*rhs_dz_ztb_x(COMP,k,1)
       rhs_dz_ztb_y(COMP,k,0) = tmask(COMP,k+1)*rhs_dz_ztb_y(COMP,k,0)
       rhs_dz_ztb_y(COMP,k,1) = tmask(COMP,k+1)*rhs_dz_ztb_y(COMP,k,1)
    enddo

    ! invert to solve for upsilonx, upsilony...
    call invtri_bvp(c2_dzr_a, n2_dz_b, c2_dzr_c, rhs_dz_ztb_x, &
                    rhs_dz_ztb_y, upsilonx_ztb_x, upsilony_ztb_y)

    do k = 1, nk
       upsilonx_xz(COMP,k,:,0) = upsilonx_ztb_x(COMP,k-1,:)
       upsilonx_xz(COMP,k,:,1) = upsilonx_ztb_x(COMP,k,:)
       upsilony_yz(COMP,k,:,0) = upsilony_ztb_y(COMP,k-1,:)
       upsilony_yz(COMP,k,:,1) = upsilony_ztb_y(COMP,k,:)
    enddo

  end subroutine compute_transport_bvp
  ! </SUBROUTINE> NAME="compute_transport_bvp"


  !#######################################################################
  ! <SUBROUTINE NAME="invtri_bvp">
  !
  ! <DESCRIPTION>
  ! Solve the vertical diffusion equation implicitly using the
  ! method of inverting a tridiagonal matrix as described in
  ! Numerical Recipes in Fortran, The art of Scientific Computing,
  ! Second Edition, Press, Teukolsky, Vetterling, Flannery, 1992
  ! pages 42,43.
  !
  ! enforce upsilon(k=kmt) = 0 via use of mask(k+1).
  !
  ! </DESCRIPTION>
  !
  subroutine invtri_bvp (a, b, c, r_x, r_y, upsilon_x, upsilon_y)

    real, dimension(isd:,jsd:,:),     intent(in) :: a
    real, dimension(isd:,jsd:,:),     intent(in) :: b
    real, dimension(isd:,jsd:,:),     intent(in) :: c
    real, dimension(isd:,jsd:,:,0:),  intent(in) :: r_x
    real, dimension(isd:,jsd:,:,0:),  intent(in) :: r_y
    real, dimension(isd:,jsd:,0:,0:), intent(out) :: upsilon_x
    real, dimension(isd:,jsd:,0:,0:), intent(out) :: upsilon_y

    real, dimension(isd:ied,jsd:jed,nk) :: bet
    real, dimension(isd:ied,jsd:jed,nk) :: gam

    integer :: k, ip, jq

    bet = 0.0
    gam = 0.0

    ! decomposition and forward substitution
    bet(COMP,1) = 1.0/(b(COMP,1) + epsln)
    do k = 2, nk-1
       gam(COMP,k) = c(COMP,k-1)*bet(COMP,k-1)
       bet(COMP,k) = 1.0/(b(COMP,k) - a(COMP,k)*gam(COMP,k) + epsln)
    enddo

    upsilon_x(COMP,0,:) = 0.0
    upsilon_y(COMP,0,:) = 0.0
    do ip=0,1
       jq=ip
       upsilon_x(COMP,1,ip) = r_x(COMP,1,ip)*bet(COMP,1)
       upsilon_y(COMP,1,jq) = r_y(COMP,1,jq)*bet(COMP,1)
       do k = 2, nk-1
          upsilon_x(COMP,k,ip) = (r_x(COMP,k,ip) - a(COMP,k)*upsilon_x(COMP,k-1,ip))*bet(COMP,k)
          upsilon_y(COMP,k,jq) = (r_y(COMP,k,jq) - a(COMP,k)*upsilon_y(COMP,k-1,jq))*bet(COMP,k)
       enddo
       ! back substitution
       do k = nk-2, 1, -1
          upsilon_x(COMP,k,ip) = upsilon_x(COMP,k,ip) - gam(COMP,k+1)*upsilon_x(COMP,k+1,ip)
          upsilon_y(COMP,k,jq) = upsilon_y(COMP,k,jq) - gam(COMP,k+1)*upsilon_y(COMP,k+1,jq)
       enddo
    enddo
    upsilon_x(COMP,nk,:) = 0.0
    upsilon_y(COMP,nk,:) = 0.0

  end subroutine invtri_bvp
  ! </SUBROUTINE> NAME="invtri_bvp">

  !#######################################################################
  ! <SUBROUTINE NAME="do_smooth_transport">
  !
  ! <DESCRIPTION>
  ! </DESCRIPTION>
  !
  subroutine do_smooth_transport(Domain, tmask, upsilonx_xz, upsilony_yz)

    type(ocean_domain_type),            intent(inout) :: Domain
    real, dimension(isd:,jsd:,:),       intent(in)    :: tmask
    real, dimension(isd:,jsd:,:,0:,0:), intent(inout) :: upsilonx_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(inout) :: upsilony_yz

    integer :: kr, ip, jq

    ! smooth transport to reduce potentials for checkerboard noise
    do ip=0,1
       jq = ip
       do kr = 0, 1
          call horz_smooth(Domain, tmask, upsilonx_xz(:,:,:,ip,kr))
          call horz_smooth(Domain, tmask, upsilony_yz(:,:,:,jq,kr))
          upsilonx_xz(COMP,:,ip,kr) = upsilonx_xz(COMP,:,ip,kr)*tmask(COMP,:)*tmask(COMPXRR,:)
          upsilony_yz(COMP,:,jq,kr) = upsilony_yz(COMP,:,jq,kr)*tmask(COMP,:)*tmask(COMPYRR,:)
       enddo
    enddo

  end subroutine do_smooth_transport
  ! </SUBROUTINE> NAME="do_smooth_transport"


end module ocean_nphysics_skew_mod

program edit_grid
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">Z. Liang </CONTACT>
  ! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">S. M. Griffies</REVIEWER>

  !<OVERVIEW>
  ! edit grid topography.
  !</OVERVIEW>

  !<DESCRIPTION>
  ! This program can edit the topography of input grid_spec file "orig_grid" 
  ! according to the ascii input file "grid_edits". Then it will output the 
  ! new grid_spec file "mod_grid". The program read file "grid_edits" line
  ! by line. Each line contains grid points position and new topography value 
  ! of those grid points. The grid points position is specified by the grid 
  ! index. You can specify a point or a region at each line. For example,
  ! <PRE>
  ! 100, 60, 0 
  ! will set the depth at point (100,60) to 0. 
  ! 40:45, 30:34, 1000
  ! will set the depth at region ( index i from 54 to 50 and j from 30 to 34 ) to 1000.
  ! </PRE>
  ! 
  !</DESCRIPTION>

  use mpp_mod,       only : mpp_error, FATAL, NOTE, mpp_pe, mpp_npes
  use mpp_io_mod,    only : mpp_open, mpp_close, mpp_read, mpp_write, mpp_write_meta
  use mpp_io_mod,    only : MPP_RDONLY, MPP_NETCDF, MPP_SINGLE, MPP_ASCII, MPP_OVERWR
  use mpp_io_mod,    only : axistype, fieldtype, atttype, mpp_get_atts, mpp_get_info
  use mpp_io_mod,    only : mpp_get_axes, mpp_get_fields, mpp_get_axis_data, mpp_copy_meta
  use mpp_io_mod,    only : mpp_get_att_char, mpp_get_att_name, mpp_get_att_real_scalar
  use mpp_io_mod,    only : mpp_get_att_type, mpp_get_att_real
  use fms_mod,       only : fms_init, fms_end, file_exist, close_file, stdout
  use fms_mod,       only : open_namelist_file, check_nml_error, write_version_number
  use constants_mod, only : constants_init
  use topog_mod,     only : process_topo, show_deepest, set_topog_nml

  implicit none
#include <netcdf.inc>

  !--- namelist interface
 !
  !<NAMELIST NAME="edit_grid_nml">
  !<DATA NAME= "mod_grid" TYPE="character(len=128)" >
  ! original grid file
  !</DATA>
  !<DATA NAME= "orig_grid" TYPE="character(len=128)" >
  ! output grid file after modification.
  !</DATA>
  !<DATA NAME="grid_edits" TYPE="character(len=128)">
  !  input text file. Each line is in the format as 
  !  "is:ie, js:je, depth", which means set the depth at region
  !  (is:ie, js:je) to value "depth". is and ie can be equal or 
  !  different. js and je can be same or different.
  !</DATA>
  !<DATA NAME="debug" TYPE="logical" >
  ! Control standard output. Default value is false.
  !</DATA>
  !</NAMELIST>

  character(len=128) :: orig_grid       = 'orig_grid'       ! original grid file
  character(len=128) :: mod_grid        = 'mod_grid     '   ! modified grid file
  character(len=128) :: grid_edits      = 'grid_edits.txt'  ! test file used to edit grid
  logical            :: debug           = .FALSE.           ! will fail at compilation if included 
                                                            ! in the namelist

  namelist /edit_grid_nml/ orig_grid, mod_grid, grid_edits, debug

  !--- version information variables -----------------------------------
  character(len=128) :: version = '$Id: edit_grid.F90,v 19.0 2012/01/06 22:07:48 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'
  !---------------------------------------------------------------------
  logical :: tripolar_grid        =.false. ! indicate the grid is tripolar grid or not.
  logical :: cyclic_x             =.false. ! true indicate cyclic in x-direction
  logical :: cyclic_y             =.false. ! true indicate cyclic in y-direction
  logical :: full_cell            =.false. ! do not generate partial bottom cells 
  logical :: fill_isolated_cells  =.false. ! Do not allow non-advective tracer cells
  logical :: dont_change_landmask =.false. ! Do not change land/sea mask when filling isolated cells
  logical :: fill_shallow         =.false. ! Make cells less than minimum depth land
  logical :: deepen_shallow       =.false. ! Make cells less than minimum depth equal to minimum depth
  logical :: round_shallow        =.false. ! Make cells land if depth is less than 1/2 mimumim depth, 
                                           ! otherwise make ocean
  logical :: adjust_topo          =.false. ! adjust topography 
  logical :: fill_first_row       =.false. ! make first row of ocean model all land points for ice model
  integer :: kmt_min              = 2      ! minimum number of vertical levels

  real, dimension(:),      allocatable :: zw         ! vertical grid at T-cell bound
  real, dimension(:,:),    allocatable :: ht         ! depth at T-cell center
  real, dimension(:,:),    allocatable :: hu         ! depth at UV-cell center  
  real, dimension(:,:),    allocatable :: geolon_t   ! geographical longitude of T-cell center
  real, dimension(:,:),    allocatable :: geolat_t   ! geographical latitude of T-cell center
  real, dimension(:,:),    allocatable :: dxte, dytn 
  real, dimension(:,:),    allocatable :: wet        ! land/sea mask
  real, dimension(:,:),    allocatable :: wet_c        ! land/sea mask  
  integer, dimension(:,:), allocatable :: kmt        ! number of vertical levels
  integer, dimension(:,:), allocatable :: kmu        ! number of vertical levels  
  character(len=64)                    :: topography ! type of topography

  type(axistype), dimension(:), allocatable  :: axes_in, axes_out
  type(fieldtype), dimension(:), allocatable :: fields_in, fields_out
  type(atttype), dimension(:), allocatable   :: global_atts

  integer :: ni, nj, nk  ! grid size
  integer :: i,j
  integer :: unit_input  ! corresponding to the file orig_grid.    
  logical :: hu_exist


  !--- begin of the program 
  call fms_init
  call constants_init

  call edit_grid_init

  !--- first read from orig_grid
  call read_orig_grid

  if(topography == 'idealized')  then
      call mpp_error(FATAL,'edit_grid: can not edit grid when topography == idealized') 
  endif

  !--- read the grid edit file and edit ht
  call reset_depth

  !--- set topog_mod namelist option
  call set_topog_nml(full_cell, fill_isolated_cells, dont_change_landmask, fill_shallow, &
       deepen_shallow, round_shallow, adjust_topo, fill_first_row, kmt_min, debug )

  ! Compare "ht" to bottom of deepest model level. 
  if(debug) call show_deepest(zw, ht)

  call process_topo(ht, kmt, zw, dxte, dytn, geolon_t, geolat_t, tripolar_grid, cyclic_x, cyclic_y)

  if( hu_exist ) then
! MJH
     do j=1,nj-1
        do i=1,ni-1
           hu(i,j) = min(ht(i,j),ht(i+1,j), ht(i,j+1),ht(i+1,j+1))
           kmu(i,j) = min(kmt(i,j), kmt(i+1,j), kmt(i,j+1), kmt(i+1,j+1))        
        enddo
        hu(ni,j) = hu(ni-1,j)
        kmu(ni,j) = kmu(ni-1,j)
     enddo
     hu(:,nj) = hu(:,nj-1)
     kmu(:,nj) = kmu(:,nj-1)

     wet_c=0.0
     where (hu .gt. 0.0) wet_c = 1.0
  endif

  !--- define land/sea mask according to depth
  wet = 0.0
  where(ht(1:ni,1:nj) .gt. 0.0 ) wet = 1.0

  call write_mod_grid ()

  call fms_end

contains

  !#####################################################################
  ! --- read the namelist and write the version information to logfile. Also
  ! --- write the namelist to standard output
  subroutine edit_grid_init

    integer :: io_status, unit, ierr

    !--- This program do not support parallel, so always run on 1 pe
    if(mpp_npes() .gt. 1) call mpp_error(FATAL,'program edit_grid:  set npes = 1 in the runscripts')

    ! provide for namelist over-ride of defaults 
    if(file_exist('input.nml')) then
       unit = open_namelist_file()
       read (unit,edit_grid_nml,IOSTAT=io_status)
       write (stdout(),'(/)')
       write (stdout(),edit_grid_nml)  
       ierr = check_nml_error(io_status, 'edit_grid_nml')
       call close_file(unit)
    else
       call mpp_error(NOTE, 'edit_grid: file input.nml does not exist' )
    endif

    !--- write out version information ---------------------------------
    call write_version_number(version, tagname)

  end subroutine edit_grid_init

  !#####################################################################
  !--- read the grid information from the file orig_grid 
  subroutine read_orig_grid
    integer            :: ndim, nvar, natt, ntime, i, len
    character(len=128) :: name
    logical            :: zw_found, gridlon_found, gridlat_found
    logical            :: ht_found, hu_found, dxte_found, kmu_found
    logical            :: dytn_found, xt_found, yt_found
    real, dimension(:,:), allocatable :: tmp2d
    
    if(.not. file_exist(trim(orig_grid))) &
         call mpp_error(FATAL, 'file '//trim(orig_grid)//' does not exist')

    call mpp_open(unit_input,trim(orig_grid),MPP_RDONLY,MPP_NETCDF,threading=MPP_SINGLE,&
         fileset=MPP_SINGLE)
    call mpp_get_info(unit_input,ndim,nvar,natt,ntime)
    allocate (global_atts(natt))
    call mpp_get_atts(unit_input,global_atts)
    allocate(axes_in(ndim), axes_out(ndim) )
    call mpp_get_axes(unit_input,axes_in)
    axes_out = axes_in
    allocate(fields_in(nvar), fields_out(nvar))
    call mpp_get_fields(unit_input,fields_in)
    fields_out = fields_in

    do i=1,natt
       select case (trim(mpp_get_att_name(global_atts(i))))
       case ('x_boundary_type')
          if (trim(mpp_get_att_char(global_atts(i))) == 'cyclic') then
             cyclic_x = .true.
          else
             cyclic_x = .false.
          endif
       case ('y_boundary_type')
          if (trim(mpp_get_att_char(global_atts(i))) == 'fold_north_edge') then
             tripolar_grid = .true.
          else if(trim(mpp_get_att_char(global_atts(i))) == 'cyclic') then
             cyclic_y = .true.
          endif
       case ('topography')
          topography = mpp_get_att_char(global_atts(i))
       case ('full_cell')
          full_cell = .true.
       case ('fill_isolated_cells')
          fill_isolated_cells = .true.
       case ('dont_change_landmask')
          dont_change_landmask = .true.
       case ('fill_shallow')
          fill_shallow = .true.
       case ('deepen_shallow')
          deepen_shallow = .true.
       case ('round_shallow')
          round_shallow = .true.
       case ('kmt_min')
          kmt_min = mpp_get_att_real_scalar(global_atts(i))
       case ('adjust_topo')
          adjust_topo = .true.
       case ('fill_first_row')
          fill_first_row = .true.
       end select
    enddo

    do i=1,ndim
       call mpp_get_atts(axes_in(i),name=name,len=len)
       select case (trim(name))
       case ('zb') 
          allocate(zw(len))
          nk = len
          call mpp_get_axis_data(axes_in(i),zw)
          zw_found = .true.
       case ('grid_x_T')
          ni = len
          gridlon_found = .true.
       case ('grid_y_T')
          nj = len
          gridlat_found=.true.
       end select
    enddo

    if (.not.zw_found )      call mpp_error(FATAL,'edit_grid: axis zb not found in the file '//trim(orig_grid) )
    if (.not.gridlon_found ) call mpp_error(FATAL,'edit_grid: axis grid_x_T not found in the file '//trim(orig_grid) )
    if (.not.gridlat_found ) call mpp_error(FATAL,'edit_grid: axis grid_y_T not found in the file '//trim(orig_grid) )

    allocate( ht(0:ni+1,0:nj+1), hu(ni,nj),kmt(0:ni+1,0:nj+1), kmu(ni,nj), wet(ni,nj), wet_c(ni,nj)  )
    allocate( geolon_t(ni,nj), geolat_t(ni,nj), dxte(ni,nj), dytn(ni,nj) ) 
    ht = 0.0
    hu = 0.0
    kmt = 0
    kmu = 0

    ht_found = .false.
    hu_found = .false.
    dxte_found = .false.
    dytn_found = .false.
    xt_found = .false.
    yt_found = .false.
    kmu_found = .false.
    do i=1,nvar
       call mpp_get_atts(fields_in(i),name=name)
       select case (trim(name))
       case('depth_t')
          call mpp_read(unit_input,fields_in(i),ht(1:ni,1:nj) )
          ht_found = .true.
       case ('ds_01_21_E')
          call mpp_read(unit_input,fields_in(i),dxte)
          dxte_found = .true.
       case ('ds_10_12_N')
          call mpp_read(unit_input,fields_in(i),dytn)
          dytn_found = .true.
       case ('x_T')
          call mpp_read(unit_input,fields_in(i),geolon_t(1:ni,1:nj))
          xt_found = .true.
       case ('y_T')
          call mpp_read(unit_input,fields_in(i),geolat_t(1:ni,1:nj))
          yt_found = .true.
      case ('depth_c')
          call mpp_read(unit_input,fields_in(i),hu(1:ni,1:nj))          
          hu_found = .true.
      case ('num_levels_c')
          allocate(tmp2d(ni,nj))
          call mpp_read(unit_input,fields_in(i),tmp2d(1:ni,1:nj))          
          kmu(1:ni,1:nj) = tmp2d(1:ni,1:nj)
          deallocate(tmp2d)
          kmu_found = .true.
       end select
    enddo

    if (.not.ht_found)   call mpp_error(FATAL,'edit_grid: depth_t not found in the file '//trim(orig_grid) )
    if (.not.dxte_found) call mpp_error(FATAL,'edit_grid: ds_01_21_E not found in the file '//trim(orig_grid) )
    if (.not.dytn_found) call mpp_error(FATAL,'edit_grid: ds_10_12_N not found in the file '//trim(orig_grid) )
    if (.not.xt_found)   call mpp_error(FATAL,'edit_grid: x_T not found in the file '//trim(orig_grid) )
    if (.not.yt_found)   call mpp_error(FATAL,'edit_grid: y_T not found in the file '//trim(orig_grid) )
    if ( hu_found .neqv. kmu_found ) &
       call mpp_error(FATAL,'edit_grid: depth_c and num_levels_c should co-exist in the file '//trim(orig_grid) )

    hu_exist = hu_found
    if( hu_exist ) then
       write(stdout(),*)"NOTE from edit_grid: field depth_c and num_levels exist in the file "//trim(orig_grid)//".", &
            "Please be aware that the output topography should only be used in radiating open boundary condition model"
    endif

  end subroutine read_orig_grid

  !#####################################################################
  !--- write out the grid information after modification according to 
  !    grid_edits to file mod_grid.
  subroutine write_mod_grid
    integer                              :: unit, i, n
    real, dimension(:,:) ,   allocatable :: tmp2d
    real, dimension(:,:,:) , allocatable :: tmp3d
    integer, dimension(4)                :: siz_in = 1
    character(len=128)                   :: name

    call mpp_open(unit,trim(mod_grid),MPP_OVERWR,MPP_NETCDF,threading=MPP_SINGLE,&
         fileset=MPP_SINGLE)

    ! ----------------------------------------------------------------------
    ! write global atts
    ! ----------------------------------------------------------------------
    do i=1,size(global_atts(:))
       if (mpp_get_att_type(global_atts(i)) == NF_FLOAT) &
            call mpp_write_meta(unit,mpp_get_att_name(global_atts(i)), &
                 rval=mpp_get_att_real(global_atts(i)))
       if (mpp_get_att_type(global_atts(i)) == NF_CHAR) then
          if (trim(mpp_get_att_name(global_atts(i))) == 'filename') then
             call mpp_write_meta(unit,mpp_get_att_name(global_atts(i)),cval=trim(mod_grid))
          else
             call mpp_write_meta(unit,mpp_get_att_name(global_atts(i)), cval=trim(mpp_get_att_char(global_atts(i))))
          end if

       endif
    enddo

    !-----------------------------------------------------------------------
    ! write axis metadata
    ! ----------------------------------------------------------------------
    do i=1,size(axes_out(:))
       call mpp_copy_meta(unit,axes_out(i))
    enddo

    ! ----------------------------------------------------------------------
    ! write variable metadata
    ! ----------------------------------------------------------------------
    do i=1,size(fields_out(:))
       call mpp_copy_meta(unit,fields_out(i))
    enddo

    ! ----------------------------------------------------------------------
    ! write axis data
    ! ----------------------------------------------------------------------
    do i=1,size(axes_out(:))
       call mpp_write(unit,axes_out(i))
    enddo

    do i=1,size(fields_out(:))
       call mpp_get_atts(fields_out(i),name=name,siz=siz_in)
       select case (trim(name))
       case ('depth_t')
           call mpp_write(unit,fields_out(i),ht(1:ni,1:nj))
       case ('depth_c')
          call mpp_write(unit,fields_out(i),hu(1:ni,1:nj))           
       case ('num_levels')
          allocate(tmp2d(ni,nj))
          tmp2d = kmt(1:ni,1:nj)
          call mpp_write(unit,fields_out(i),tmp2d )
          deallocate(tmp2d)
       case ('num_levels_c')
           allocate(tmp2d(ni,nj))
          tmp2d = kmu(1:ni,1:nj)
          call mpp_write(unit,fields_out(i),tmp2d )
          deallocate(tmp2d)
       case ('wet')
           call mpp_write(unit,fields_out(i),wet)
       case ('wet_c')
           call mpp_write(unit,fields_out(i),wet_c)
       case default
          if(siz_in(3) > 1 ) then
             allocate(tmp3d(siz_in(1),siz_in(2), siz_in(3)) )
             call mpp_read(unit_input,fields_in(i),tmp3d)
             call mpp_write(unit,fields_out(i),tmp3d)
             deallocate(tmp3d)
          else 
             allocate(tmp2d(siz_in(1),siz_in(2)) )    
             call mpp_read(unit_input,fields_in(i),tmp2d)
             call mpp_write(unit,fields_out(i),tmp2d)
             deallocate(tmp2d)
          endif
       end select
    enddo

    call mpp_close(unit)
    call mpp_close(unit_input)

  end subroutine write_mod_grid

  !#####################################################################
  !--- reset depth according to file grid_edits
  subroutine reset_depth

    integer            :: unit, i, j, is, ie, js, je
    character(len=128) :: txt
    logical            :: flag
    real               :: ht_new

    if(.not. file_exist(trim(grid_edits))) &
         call mpp_error(FATAL, 'file '//trim(grid_edits)//' does not exist')

    call mpp_open(unit,trim(grid_edits),MPP_RDONLY,MPP_ASCII,threading=MPP_SINGLE,fileset=MPP_SINGLE)

    do 
       read(unit,'(a)',end=99,err=99) txt
       call parse_edits(txt,is,ie,js,je,ht_new,flag)
       if (flag) then
          do j=js,je
             do i=is,ie
                if (i < 0 .or. i > ni .or. j < 0 .or. j > nj) call mpp_error(FATAL,'indices exceed grid bounds')
                if (ht_new < 0.0 .or. ht_new > zw(nk)) call mpp_error(FATAL,'depth exceeds allowable depth')
                write(stdout(),*) 'Resetting depth at location (i,j) : ',i,j,' = ',ht_new
                ht(i,j) = ht_new
             enddo
          enddo
       endif
    enddo

99  call mpp_close(unit)

  end subroutine reset_depth

  !#####################################################################
  !--- read each line of the file grid_edits
  subroutine parse_edits(txt,is,ie,js,je,depth,flag)

    character(len=*), intent(in) :: txt
    integer, intent(inout)       :: is,ie,js,je
    real, intent(inout)          :: depth
    logical, intent(inout)       :: flag

    integer :: i1,i2, i3
    character(len=128) :: txt2

    flag = .true.
    i1 = scan(txt,',')
    txt2 = txt(1:i1-1)

    if (i1 <= 0) goto 90

    i2 = scan(txt2,':')
    if (i2 <= 0) then
       read(txt2,*,err=90) is
       ie = is
    else
       read(txt2(1:i2-1),*,err=90) is
       read(txt2(i2+1:),*,err=90) ie
    endif

    i2 = scan(txt(i1+1:),',')
    txt2 = txt(i1+1:i1+i2-1)
   if (i2 <= 0) goto 90

    i3 = scan(txt2,':')
     if (i3 <= 0) then
       read(txt2,*,err=90) js
       je = js
    else
       read(txt2(1:i3-1),*,err=90) js
       read(txt2(i3+1:),*,err=90) je
    endif

    read(txt(i1+i2+1:),*,err=90) depth

    return

90  continue

    flag = .false.

    return
  end subroutine parse_edits

  !#####################################################################

end program edit_grid

module ocean_overexchange_mod
#define COMP isc:iec,jsc:jec
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! Exchange of tracer properties as dense shallow parcel discharged
! into deeper water to approach the depth of neutral buoyancy.  
!</OVERVIEW>
!
!<DESCRIPTION>
! Exchange of tracer properties as dense shallow parcel is discharged
! into deeper water to approach the parcel's depth of neutral buoyancy.
! This module can be characterized as a mixture of the approach from
! Campin and Goosse (1999) and and dynamically determined xlandmix. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! Campin and Goosse (1999): Parameterization of density-driven downsloping flow 
! for a coarse-resolution model in z-coordinate", Tellus 51A, pages 412-430
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, M.J. Harrison, R. C. Pacanowski, and A. Rosati
! A Technical Guide to MOM4 (2003)
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, Elements of MOM (2012)
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_overexchange_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  For using this module.  Default use_this_module=.false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging 
!  </DATA> 
!  <DATA NAME="do_bitwise_exact_sum" TYPE="logical">
!  Set true to do bitwise exact global sum. When it is false, the global
!  sum will be non-bitwise_exact, but will significantly increase efficiency. 
!  The default value is false.
!  </DATA> 
!
!  <DATA NAME="overexch_npts" TYPE="integer">
!  Number of points used in search for the exchange method. 
!  Default overexch_npts=1.  Note: it is not possible to have 
!  overexch_npts greater than or equal to the computational domain
!  extents, as this would require updates across multiple processors. 
!  Default overexch_npts=1. 
!  </DATA> 
!  <DATA NAME="overexch_weight_far" TYPE="logical">
!  To place more weight on points further from central point.  This may 
!  be done to enhance properties getting downslope.  Default is 
!  overexch_weight_far=.false.
!  </DATA> 
!  <DATA NAME="overexch_width" TYPE="integer">
!  Width of the re-weighting function used to emphasize the points further 
!  along in the search for exchange points.  Default overexch_width=1.
!  </DATA> 
!  <DATA NAME="overexch_stability" TYPE="real">
!  Stability factor for determining the maximum overexch_flux.
!  Default overexch_stability=0.25
!  </DATA> 
!  <DATA NAME="overexch_min_thickness" TYPE="real" UNITS="metre">
!  Minimum bottom cell thickness allowed for use of this scheme.
!  Have found that with very thin cells, the model can become very 
!  unstable.  Default overexch_min_thickness=4.0
!  </DATA> 
!  <DATA NAME="overexch_check_extrema" TYPE="logical">
!  Check to be sure there are no global tracer extrema formed due
!  to the overexch process. Note that this approach DOES NOT 
!  conserve tracer, so it is not generally recommended. 
!  Default overexch_check_extrema=.false.
!  </DATA> 
!
!  <DATA NAME="overflow_mu" TYPE="real" UNITS="sec^-1">
!  Dissipation rate for the bottom friction.  Campin and Goosse 
!  suggest overflow_mu=10^-4
!  </DATA> 
!  <DATA NAME="overflow_delta" TYPE="real" UNITS="dimensionless">
!  Fraction of a grid cell participating in the overflow process. 
!  Campin and Goosse suggest overflow_delta=1/3. 
!  </DATA> 
!  <DATA NAME="overflow_umax" TYPE="real" UNITS="m/s">
!  Maximum downslope speed used for determining the exchange rate. 
!  Default overflow_umax=1.0.
!  </DATA> 
!
!</NAMELIST>
!

use constants_mod,       only: epsln
use diag_manager_mod,    only: register_diag_field, register_static_field
use fms_mod,             only: write_version_number, error_mesg, FATAL, NOTE
use fms_mod,             only: open_namelist_file, check_nml_error, close_file, stdout, stdlog
use mpp_domains_mod,     only: mpp_update_domains, CGRID_NE
use mpp_domains_mod,     only: mpp_global_sum, BITWISE_EXACT_SUM, NON_BITWISE_EXACT_SUM
use mpp_mod,             only: input_nml_file, mpp_error

use ocean_density_mod,     only: density
use ocean_domains_mod,     only: get_local_indices, set_ocean_domain
use ocean_parameters_mod,  only: missing_value, rho0r, rho0, grav
use ocean_parameters_mod,  only: TERRAIN_FOLLOWING, PRESSURE_BASED
use ocean_types_mod,       only: ocean_domain_type, ocean_grid_type, ocean_time_type, ocean_options_type
use ocean_types_mod,       only: ocean_prog_tracer_type, ocean_density_type, ocean_thickness_type
use ocean_util_mod,        only: write_timestamp, diagnose_2d, diagnose_3d
use ocean_util_mod,        only: write_chksum_3d, write_chksum_2d, write_chksum_2d_int
use ocean_tracer_util_mod, only: diagnose_3d_rho
use ocean_workspace_mod,   only: wrk1, wrk2, wrk3, wrk4, wrk1_v

implicit none

private 

public ocean_overexchange_init
public overexchange
private watermass_diag_init
private watermass_diag

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

#include <ocean_memory.h>

integer, dimension(:,:), allocatable :: ip    ! shifting in i-direction
integer, dimension(:,:), allocatable :: jq    ! shifting in j-direction

real, dimension(:,:),     allocatable   :: slope_x          ! topog slope (dimensionless) in the i-direction
real, dimension(:,:),     allocatable   :: slope_y          ! topog slope (dimensionless) in the j-direction 
real, dimension(:,:,:),   allocatable   :: topog_step       ! where downslope flow is topgraphically possible 
real, dimension(:,:,:),   allocatable   :: source_overexch  ! (rho*dzt*tracer) tendency
real, dimension(:,:,:,:), allocatable   :: overexch_flux    ! mass flux associated with overexch 

! fields with larger halos 
integer, dimension(:,:),     allocatable :: kmt_ex
integer, dimension(:,:,:),   allocatable :: kup_ex
integer, dimension(:,:,:,:), allocatable :: kdw_ex
real, dimension(:,:,:),   allocatable :: topog_slope_ex    
real, dimension(:,:,:),   allocatable :: topog_step_ex
real, dimension(:,:,:),   allocatable :: tracer_ex
real, dimension(:,:,:),   allocatable :: temp_ex
real, dimension(:,:,:),   allocatable :: salt_ex
real, dimension(:,:,:),   allocatable :: press_ex
real, dimension(:,:,:),   allocatable :: rho_dzt_ex
real, dimension(:,:,:),   allocatable :: rho_ex
real, dimension(:,:,:),   allocatable :: rho_salinity_ex
real, dimension(:,:),     allocatable :: dxt_ex
real, dimension(:,:),     allocatable :: dyt_ex
real, dimension(:,:),     allocatable :: datr_ex

! internally set for computing watermass diagnostics
logical :: compute_watermass_diag = .false. 


! domain for overexch_exchange 
type(ocean_domain_type), save :: Overexchange_domain 


! for diagnostic manager 
logical :: used
integer :: id_slope_x      =-1
integer :: id_slope_y      =-1
integer :: id_topog_step_1 =-1
integer :: id_topog_step_2 =-1
integer :: id_topog_step_3 =-1
integer :: id_topog_step_4 =-1

integer :: id_neut_rho_overex          =-1
integer :: id_wdian_rho_overex         =-1
integer :: id_neut_rho_overex_on_nrho  =-1
integer :: id_wdian_rho_overex_on_nrho =-1
integer :: id_tform_rho_overex_on_nrho =-1

integer :: id_neut_temp_overex          =-1
integer :: id_wdian_temp_overex         =-1
integer :: id_neut_temp_overex_on_nrho  =-1
integer :: id_wdian_temp_overex_on_nrho =-1
integer :: id_tform_temp_overex_on_nrho =-1

integer :: id_neut_salt_overex          =-1
integer :: id_wdian_salt_overex         =-1
integer :: id_neut_salt_overex_on_nrho  =-1
integer :: id_wdian_salt_overex_on_nrho =-1
integer :: id_tform_salt_overex_on_nrho =-1

integer, dimension(:), allocatable :: id_overexch


character(len=128) :: version=&
       '=>Using: ocean_overexchange.f90 ($Id: ocean_overexchange.F90,v 20.0 2013/12/14 00:16:04 fms Exp $)'
character (len=128) :: tagname=&
     '$Name: tikal $'

! number of prognostic tracers
integer :: num_prog_tracers=0

! processor zero writes to unit 6
integer :: unit=6  

! initialization flag 
logical :: module_is_initialized=.false.

! flag for mpp_global_sum
integer :: global_sum_flag      

! halo 
integer :: ijhalo=1 

! grav*overflow_delta/(rho0*overflow_mu)  (m^4/kg/sec)
real :: overexch_factor 

! time step 
real :: dtime 

! for setting max overexch_flux 
real :: overexch_stability_rate

! set from nml
logical :: use_this_module        = .false. ! must be set .true. in nml to enable this scheme
logical :: debug_this_module      = .false. ! for debugging
logical :: do_bitwise_exact_sum   = .false. ! set true to get slower sum that is same for all PEs. 
logical :: overexch_weight_far    = .false. ! to place more weight on points further from central point
logical :: overexch_check_extrema = .false. ! to be sure there are no global extrema formed from overexch
integer :: overexch_npts          = 1       ! number points searched for the exchange 
integer :: overexch_width         = 1       ! width for exponential that damps points near to central point
real    :: overflow_mu            = 1.e-4   ! frictional dissipation rate (sec^-1) at bottom  
real    :: overflow_delta         = 0.3333  ! fraction of a grid cell participating in overflow 
real    :: overflow_umax          = 1.0     ! maximum downslope speed (m/s) for setting exchange rate 
real    :: overexch_stability     = 0.25    ! stability factor for setting the max overexch_flux 
real    :: overexch_min_thickness = 4.0     ! metres dzt needed in order for a cell to participate in exchange

namelist /ocean_overexchange_nml/ use_this_module, debug_this_module, overexch_npts, overexch_width, &
                                  overexch_weight_far, overflow_mu, overflow_delta, overflow_umax,   &
                                  do_bitwise_exact_sum, overexch_stability, overexch_min_thickness,  &
                                  overexch_check_extrema

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_overexchange_init">
!
! <DESCRIPTION>
! Initial set up for mixing of tracers into the abyss next to topography.
! </DESCRIPTION>
!
  subroutine ocean_overexchange_init(Grid, Domain, Time, Dens, T_prog, Ocean_options, &
                                     vert_coordinate_type, dtim, debug)

    type(ocean_grid_type),        intent(in), target   :: Grid
    type(ocean_domain_type),      intent(in), target   :: Domain
    type(ocean_time_type),        intent(in), target   :: Time
    type(ocean_density_type),     intent(in)           :: Dens   
    type(ocean_prog_tracer_type), intent(inout)        :: T_prog(:)
    type(ocean_options_type),     intent(inout)        :: Ocean_options
    integer,                      intent(in)           :: vert_coordinate_type 
    real,                         intent(in)           :: dtim
    logical,                      intent(in), optional :: debug

    integer :: io_status, ioun, ierr
    integer :: i,j,m,n,kbot

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

    if ( module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error from ocean_overexchange_mod (ocean_overexchange_init): module already initialized')
    endif 

    module_is_initialized = .TRUE.

    call write_version_number(version, tagname)
#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
    nk = Grid%nk
#endif
    Dom => Domain
    Grd => Grid

    dtime = dtim 
    num_prog_tracers = size(T_prog(:))

    ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_overexchange_nml, iostat=io_status) 
    ierr = check_nml_error(io_status,'ocean_overexchange_nml')
#else
    ioun =  open_namelist_file()
    read (ioun,ocean_overexchange_nml,IOSTAT=io_status)
    ierr = check_nml_error(io_status,'ocean_overexchange_nml')
    call close_file (ioun)
#endif
    write (stdlogunit,ocean_overexchange_nml)
    write (stdoutunit,'(/)') 
    write (stdoutunit,ocean_overexchange_nml)

    if(do_bitwise_exact_sum) then
       global_sum_flag = BITWISE_EXACT_SUM
    else
       global_sum_flag = NON_BITWISE_EXACT_SUM
    endif

    if (PRESENT(debug) .and. .not. debug_this_module) then
       debug_this_module = debug
    endif 
    if(debug_this_module) then 
       write(stdoutunit,'(a)') '==>Note: running ocean_overexchange_mod with debug_this_module=.true.'  
    endif 

    if(.not. use_this_module) then 
      call mpp_error(NOTE,&
      '==>From ocean_overexchange_mod: NOT using overflow exchange scheme.')
      Ocean_options%overexchange = 'Did NOT use overflow exchange scheme.'
      return
    else 
      if(vert_coordinate_type == TERRAIN_FOLLOWING) then 
          call mpp_error(FATAL, &
          '==>ocean_overexchange_mod: this module is NOT for use with TERRAIN_FOLLOWING vert coodinates.')
      endif
      Ocean_options%overexchange = 'Used the overflow exchange scheme. This scheme is experimental. User beware!'
      call mpp_error(NOTE,&
      '==>From ocean_overexchange_mod: USING overflow exchange scheme.')
    endif
    if(debug_this_module) then 
      call mpp_error(NOTE,'==>From ocean_overexchange_mod: USING debug_this_module')
    endif 

    ! for setting the maximum overexch_flux 
    overexch_stability_rate = overexch_stability/dtime

    ! allocate for tracer source arrays 
    allocate(source_overexch(isd:ied,jsd:jed,nk))
    source_overexch(:,:,:) = 0.0

    if(overexch_npts<1) then
      call mpp_error(FATAL, &
      '==>ocean_overexchange_mod: overexch_npts < 1 not allowed. In nml, set overexch_npts>=1.')
    endif  
    write(stdoutunit,'(a,i3)')' In ocean_overexchange_mod: overexch_npts = ',overexch_npts  
    write(stdoutunit,'(a)')   ' Be sure this number is smaller than dimensions of computational domain.'

    ! halo size for extended domain and larger arrays 
    ijhalo=overexch_npts

    ! k-level of central point in search 
    allocate(kup_ex(isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,4))
    kup_ex(:,:,:) = 0

    ! k-level of deeper points in horizontally adjacent columns 
    allocate(kdw_ex(isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,ijhalo,4))
    kdw_ex(:,:,:,:) = 0

    ! mass flux setting strength of tracer exchange 
    allocate(overexch_flux(isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,ijhalo,4))
    overexch_flux(:,:,:,:) = 0.0

    ! define extended domain 
    call set_ocean_domain(Overexchange_domain,Grd,xhalo=ijhalo,yhalo=ijhalo,name='overexch',maskmap=Dom%maskmap)

    ! time independent arrays defined over the Overexch_domain region 
    allocate(kmt_ex (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo))
    allocate(dxt_ex (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo))
    allocate(dyt_ex (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo))
    allocate(datr_ex(isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo))
    kmt_ex(:,:)     = 0
    datr_ex(:,:)    = 0.0
    dxt_ex(:,:)     = 0.0
    dyt_ex(:,:)     = 0.0
    kmt_ex (isc:iec,jsc:jec) = Grd%kmt (isc:iec,jsc:jec)
    datr_ex(isc:iec,jsc:jec) = Grd%datr(isc:iec,jsc:jec)
    dxt_ex (isc:iec,jsc:jec) = Grd%dxt (isc:iec,jsc:jec)
    dyt_ex (isc:iec,jsc:jec) = Grd%dyt (isc:iec,jsc:jec)
    call mpp_update_domains (kmt_ex(:,:), Overexchange_domain%domain2d)
    call mpp_update_domains (datr_ex(:,:),Overexchange_domain%domain2d)
    call mpp_update_domains (dxt_ex(:,:), Overexchange_domain%domain2d)
    call mpp_update_domains (dyt_ex(:,:), Overexchange_domain%domain2d)

    ! time dependent arrays defined over the Overexch_domain region 
    allocate(temp_ex         (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,nk))
    allocate(salt_ex         (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,nk))
    allocate(tracer_ex       (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,nk))
    allocate(press_ex        (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,nk))
    allocate(rho_salinity_ex (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,nk))
    allocate(rho_ex          (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,nk))
    allocate(rho_dzt_ex      (isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,nk))
    temp_ex(:,:,:)         = 0.0
    salt_ex(:,:,:)         = 0.0
    tracer_ex(:,:,:)       = 0.0
    press_ex(:,:,:)        = 0.0
    rho_salinity_ex(:,:,:) = 0.0
    rho_ex(:,:,:)          = 0.0
    rho_dzt_ex(:,:,:)      = 0.0

    ! compute a common factor that is time independent 
    overexch_factor = grav*overflow_delta*rho0r/(epsln+overflow_mu)

    ! compute topographic slope arrays for the i-slope and j-slope
    ! slopes are centered on the i-face and j-face of tracer cells 
    allocate (slope_x(isd:ied,jsd:jed))
    allocate (slope_y(isd:ied,jsd:jed))
    slope_x = 0.0 
    slope_y = 0.0
    do j=jsc,jec
      do i=isc,iec
        slope_x(i,j) = (Grd%ht(i+1,j)-Grd%ht(i,j))*Grd%dxter(i,j)*Grd%tmask(i,j,1)*Grd%tmask(i+1,j,1)
        slope_y(i,j) = (Grd%ht(i,j+1)-Grd%ht(i,j))*Grd%dytnr(i,j)*Grd%tmask(i,j,1)*Grd%tmask(i,j+1,1)
        slope_x(i,j) = abs(slope_x(i,j))
        slope_y(i,j) = abs(slope_y(i,j))
      enddo
    enddo 
    call mpp_update_domains(slope_x(:,:),Dom%domain2d)
    call mpp_update_domains(slope_y(:,:),Dom%domain2d)

    ! topographic slope for the four surrounding directions 
    allocate (topog_slope_ex(isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,4))
    topog_slope_ex(:,:,:) = 0.0
    do j=jsc,jec
       do i=isc,iec
          m=1 ; topog_slope_ex(i,j,m) = slope_x(i,j)  
          m=2 ; topog_slope_ex(i,j,m) = slope_y(i,j)  
          m=3 ; topog_slope_ex(i,j,m) = slope_x(i-1,j)
          m=4 ; topog_slope_ex(i,j,m) = slope_y(i,j-1)
       enddo
    enddo
    call mpp_update_domains (topog_slope_ex(:,:,:), Overexchange_domain%domain2d)

    ! compute directions from an (i,j) point where topography deepens.
    ! these directions may potentially have downslope exchange. 
    ! insist that downslope exchange occurs only when there are more 
    ! kmt cells in the adjacent column. also insist that downslope 
    ! exchange does not involve k=1 cells. 
    allocate (topog_step(isd:ied,jsd:jed,4))
    topog_step(:,:,:) = 0.0
    do j=jsc,jec
      do i=isc,iec
         kbot = Grd%kmt(i,j)
         if(kbot > 1) then 
           if(Grd%kmt(i+1,j) > kbot) topog_step(i,j,1)=1.0
           if(Grd%kmt(i,j+1) > kbot) topog_step(i,j,2)=1.0
           if(Grd%kmt(i-1,j) > kbot) topog_step(i,j,3)=1.0
           if(Grd%kmt(i,j-1) > kbot) topog_step(i,j,4)=1.0
         endif 
      enddo
    enddo   
    ! Block out the bipolar fold in order to ensure tracer conservation.
    ! The reason we do so is related to how the algorithm reaches between  
    ! adjacent columns of tracer points.  When the column straddles 
    ! the bipolar fold, the code logic is not general and so it actually 
    ! attempts to reach to a non-adjacent column.  Shy of generalizing 
    ! the logic, we simply do not consider overexch for points along fold. 
    if(jec+Dom%joff==Dom%jeg) then 
       topog_step(:,jec,:) = 0.0
    endif 

    ! fill the larger array 
    allocate (topog_step_ex(isc-ijhalo:iec+ijhalo,jsc-ijhalo:jec+ijhalo,4))
    topog_step_ex(:,:,:) = 0.0
    topog_step_ex(isc:iec,jsc:jec,:) = topog_step(isc:iec,jsc:jec,:)
    call mpp_update_domains (topog_step_ex(:,:,:), Overexchange_domain%domain2d)

    ! labels for the four quadranats surrounding a 
    ! central tracer cell (moving counter-clockwise)
    allocate(ip(0:ijhalo,4))
    allocate(jq(0:ijhalo,4))

    do n=0,ijhalo
        m=1 
        ip(n,m)   = 1+(n-1)
        jq(n,m)   = 0  

        m=2 
        ip(n,m)   = 0  
        jq(n,m)   = 1+(n-1)  

        m=3 
        ip(n,m)   = -1-(n-1) 
        jq(n,m)   = 0  

        m=4 
        ip(n,m)   =  0  
        jq(n,m)   = -1-(n-1)
    enddo

    ! register/send diagnostics 
    id_slope_x = register_static_field ('ocean_model', 'slope_x', Grd%tracer_axes_flux_x(1:2), &
                 '|d(ht)/dx| on T-cell face', 'm/m', missing_value=missing_value, range=(/-1.e9,1.e9/))
    call diagnose_2d(Time, Grd, id_slope_x, slope_x(:,:))

    id_slope_y = register_static_field ('ocean_model', 'slope_y', Grd%tracer_axes_flux_y(1:2), &
                 '|d(ht)/dy| on T-cell face', 'm/m', missing_value=missing_value, range=(/-1.e9,1.e9/))
    call diagnose_2d(Time, Grd, id_slope_y, slope_y(:,:))

    id_topog_step_1 = register_static_field ('ocean_model', 'topog_step_1', Grd%tracer_axes(1:2), &
                 'topog_step_1', 'dimensionless', missing_value=missing_value, range=(/-1.0,1.0/))
    call diagnose_2d(Time, Grd, id_topog_step_1, topog_step(1,:,:))

    id_topog_step_2 = register_static_field ('ocean_model', 'topog_step_2', Grd%tracer_axes(1:2), &
                 'topog_step_2', 'dimensionless', missing_value=missing_value, range=(/-1.0,1.0/))
    call diagnose_2d(Time, Grd, id_topog_step_2, topog_step(2,:,:))

    id_topog_step_3 = register_static_field ('ocean_model', 'topog_step_3', Grd%tracer_axes(1:2), &
                 'topog_step_3', 'dimensionless', missing_value=missing_value, range=(/-1.0,1.0/))
    call diagnose_2d(Time, Grd, id_topog_step_3, topog_step(3,:,:))

    id_topog_step_4 = register_static_field ('ocean_model', 'topog_step_4', Grd%tracer_axes(1:2), &
                 'topog_step_4', 'dimensionless', missing_value=missing_value, range=(/-1.0,1.0/))
    call diagnose_2d(Time, Grd, id_topog_step_4, topog_step(4,:,:))

    call watermass_diag_init(Time,Dens)
   
    allocate (id_overexch(num_prog_tracers))
    id_overexch = -1

    do n=1,num_prog_tracers
       if(T_prog(n)%name == 'temp') then 
           id_overexch(n) = register_diag_field ('ocean_model', &
                'overexch_'//trim(T_prog(n)%name),              &
                Grd%tracer_axes(1:3), Time%model_time,          &
                'cp*overexch*rho*dzt*temp',                     &
                'Watt/m^2', missing_value=missing_value, range=(/-1.e9,1.e9/))
       else
           id_overexch(n) = register_diag_field ('ocean_model', 'overexch_'//trim(T_prog(n)%name), &
                Grd%tracer_axes(1:3), Time%model_time,               &
                'overexch*rho*dzt*tracer for '//trim(T_prog(n)%name),&
                trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e9,1.e9/))
       endif
    enddo

    if (debug_this_module) then
       write(stdoutunit,*) ' '
       write(stdoutunit,*) '==Global sums from initialization of ocean_overexchange_mod== '
       call write_timestamp(Time%model_time)
       write(stdoutunit,'(a,es24.17)') &
       'slope_x          = ',mpp_global_sum(Dom%domain2d,slope_x(:,:), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'slope_y          = ',mpp_global_sum(Dom%domain2d,slope_y(:,:), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_slope_ex(1)= ',mpp_global_sum(Overexchange_domain%domain2d,topog_slope_ex(:,:,1), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_slope_ex(2)= ',mpp_global_sum(Overexchange_domain%domain2d,topog_slope_ex(:,:,2), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_slope_ex(3)= ',mpp_global_sum(Overexchange_domain%domain2d,topog_slope_ex(:,:,3), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_slope_ex(4)= ',mpp_global_sum(Overexchange_domain%domain2d,topog_slope_ex(:,:,4), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_step(1)    = ',mpp_global_sum(Dom%domain2d,topog_step(:,:,1), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_step(2)    = ',mpp_global_sum(Dom%domain2d,topog_step(:,:,2), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_step(3)    = ',mpp_global_sum(Dom%domain2d,topog_step(:,:,3), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_step(4)    = ',mpp_global_sum(Dom%domain2d,topog_step(:,:,4), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_step_ex(1) = ',&
        mpp_global_sum(Overexchange_domain%domain2d,topog_step_ex(:,:,1), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_step_ex(2) = ',&
        mpp_global_sum(Overexchange_domain%domain2d,topog_step_ex(:,:,2), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_step_ex(3) = ',&
        mpp_global_sum(Overexchange_domain%domain2d,topog_step_ex(:,:,3), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_step_ex(4) = ',&
        mpp_global_sum(Overexchange_domain%domain2d,topog_step_ex(:,:,4), global_sum_flag)
    endif

  end subroutine ocean_overexchange_init
! </SUBROUTINE> NAME="ocean_overexchange_init"


!#######################################################################
! <SUBROUTINE NAME="overexchange">
!
! <DESCRIPTION>
! Compute thickness and density weighted tracer source [tracer*rho*m/s]
! due to exchange of tracer properties in regions where density-driven
! overflows are favorable. Allow for exchanges to occur over horizontally 
! distant points, so long as the dense shallow parcel finds that it 
! will sit on the bottom of the horizontally adjacent columns.  Doing
! so requires a search algorithm, which requires some if-test logic
! as well as extended halos.  Note that the halos cannot be extended
! to larger than the size of the computational domain on a processor.
! This restriction limits the extent that we can search horizontally.
!
! This scheme can be characterized as a dynamical xlandmix based on 
! the scheme of Campin and Goosse.  The rates for the exchange are 
! functions of the topographic slope and the density differences
! between parcels.  
!
! </DESCRIPTION>
!
subroutine overexchange (Time, Thickness, T_prog, Dens, index_temp, index_salt)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_density_type),     intent(in)    :: Dens
  integer,                      intent(in)    :: index_temp
  integer,                      intent(in)    :: index_salt

  integer :: tau, taum1
  integer :: i, j, k, m, n, nt, npts 
  integer :: kp1, km1
  integer :: kmtij, ku, kd
  integer :: iip0, iip1, jjq0, jjq1
  integer :: iip1r, jjq1r
  integer :: nm1

  real    :: temp_so, salt_so, press, density_check
  real    :: overexch_thickness, overexch_speed
  real    :: weight, arg
  real    :: delta, delta_rho(ijhalo)
  real    :: max_overexch_flux
  real    :: tnew

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return 

  if(.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_overexchange_mod (overexchange): module must be initialized')
  endif 

  tau     = Time%tau
  taum1   = Time%taum1

  delta_rho(:) = 0.0

  ! extend some fields to larger domain 
  rho_salinity_ex = 0.0
  rho_ex          = 0.0
  rho_dzt_ex      = 0.0
  press_ex        = 0.0
  temp_ex         = 0.0
  salt_ex         = 0.0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           rho_ex(i,j,k)          = Dens%rho(i,j,k,taum1) 
           rho_salinity_ex(i,j,k) = Dens%rho_salinity(i,j,k,taum1) 
           rho_dzt_ex(i,j,k)      = Thickness%rho_dzt(i,j,k,taum1) 
           press_ex(i,j,k)        = Dens%pressure_at_depth(i,j,k)           
           temp_ex(i,j,k)         = T_prog(index_temp)%field(i,j,k,taum1)           
           salt_ex(i,j,k)         = T_prog(index_salt)%field(i,j,k,taum1)           
        enddo
     enddo
  enddo

  call mpp_update_domains(rho_ex(:,:,:),          Overexchange_domain%domain2d, complete=.false.)
  call mpp_update_domains(rho_salinity_ex(:,:,:), Overexchange_domain%domain2d, complete=.false.)
  call mpp_update_domains(rho_dzt_ex(:,:,:),      Overexchange_domain%domain2d, complete=.false.)
  call mpp_update_domains(press_ex(:,:,:),        Overexchange_domain%domain2d, complete=.false.)
  call mpp_update_domains(temp_ex(:,:,:),         Overexchange_domain%domain2d, complete=.false.)
  call mpp_update_domains(salt_ex(:,:,:),         Overexchange_domain%domain2d, complete=.true.)

  ! compute grid details for cells participating in downslope exch 
  ! note:  "so" = "shallow ocean" cell...the central point  
  ! note:  "do" = cells within "deep ocean" columns 
  ! this part of the computation is independent of the tracer 

  kup_ex(:,:,:)          = 0
  kdw_ex(:,:,:,:)        = 0
  overexch_flux(:,:,:,:) = 0.0

  do j=jsc,jec
     do i=isc,iec

        kmtij = kmt_ex(i,j)
        if(kmtij > 1) then   

            temp_so           = temp_ex(i,j,kmtij)
            salt_so           = rho_salinity_ex(i,j,kmtij)
            max_overexch_flux = Grd%dat(i,j)*overexch_stability_rate

            ! 4-directions surrounding each cell 
            do m=1,4

               ! search for density favorable exchanges
               npts=0 
               nloop1_npts: do n=1,overexch_npts

                  iip0 = i+ip(n-1,m)
                  jjq0 = j+jq(n-1,m)
                  iip1 = i+ip(n,m)
                  jjq1 = j+jq(n,m)

                  ! check if downslope exchange is topographically possible
                  if(topog_step_ex(iip0,jjq0,m)==1.0) then  

                      ! check if density of shallow central cell > density of do-cell  
                      if(rho_ex(i,j,kmtij) > rho_ex(iip1,jjq1,kmtij)) then   

                          ! kdw = k-level in do-column where central cell is neutrally buoyant or at the bottom 
                          kdw_ex(i,j,n,m) = 0
                          kloop1 : do k=kmtij+1,kmt_ex(iip1,jjq1)
                             press         = press_ex(iip1,jjq1,k)
                             density_check = density(salt_so,temp_so,press)
                             if(density_check > rho_ex(iip1,jjq1,k)) then 
                                 kdw_ex(i,j,n,m) = k
                                 delta_rho(n)    = density_check-rho_ex(iip1,jjq1,k) 
                             else 
                                 exit kloop1
                             endif
                          enddo kloop1

                          ! check that n-parcel has a k-level greater than the n-1 parcel.
                          ! if not, then do not perform an exchange with the n-column.
                          nm1 = max(n-1,1)
                          if(n > 1) then 
                              if(kdw_ex(i,j,n,m) <= kdw_ex(i,j,nm1,m)) then  
                                  kdw_ex(i,j,n,m) = 0
                              endif
                          endif

                          ! set strength of downslope exchange  
                          if(kdw_ex(i,j,n,m) > 0) then 

                              ! add this cell to the number of cells for exchange 
                              npts=npts+1

                              if(n==1) then 
                                  kup_ex(i,j,m) = kmtij
                                  delta = rho_ex(i,j,kmtij)-rho_ex(iip1,jjq1,kmtij)
                              else 
                                  delta = delta_rho(n)
                              endif

                              ku = kup_ex(i,j,m) 
                              kd = kdw_ex(i,j,n,m) 

                              ! convert overexch_speed (m/s) to overexch_flux (kg/sec) 
                              ! speed (m/sec) setting strength of downslope exchange  
                              overexch_speed = overexch_factor*topog_slope_ex(iip0,jjq0,m)*delta 
                              overexch_speed = min(overexch_speed,overflow_umax)

                              if(m==1 .or. m==3) then 
                                  overexch_flux(i,j,n,m)=overexch_speed*Grd%dyt(i,j)
                              elseif(m==2 .or. m==4) then 
                                  overexch_flux(i,j,n,m)=overexch_speed*Grd%dxt(i,j)
                              endif

                              ! check for too large flux. based on 1D diffusive stability criteria, 
                              ! no more than one-half the mass of a grid cell can be mixed per time 
                              ! step, which means
                              ! overexch_flux(m^2/sec)*rho_dzt*dtime < 0.5*rho_dzt*dat, 
                              ! or equivalently overexch_flux(m^2/sec) < 0.5*dat/dtime
                              overexch_flux(i,j,n,m) = min(overexch_flux(i,j,n,m),max_overexch_flux) 

                              ! convert from m^2/sec to kg/sec using minimum rho_dzt 
                              overexch_thickness     = min(rho_dzt_ex(i,j,ku),rho_dzt_ex(iip0,jjq0,kd)) 
                              overexch_flux(i,j,n,m) = overexch_flux(i,j,n,m)*overexch_thickness

                              ! mask out regions with too small bottom cells
                              if(rho0r*overexch_thickness < overexch_min_thickness) then 
                                  overexch_flux(i,j,n,m) = 0.0
                              endif


                          endif  ! kdw_ex(i,j,n,m) > 0 if-test 

                      endif      ! rho_ex(i,j,k) > rho_ex(iip1,jjq1,k) if-test 
                  endif          ! topog_step_ex(iip0,jjq0,m)==1.0 if-test


                  ! if kdw is not on the bottom, then exit n-loop since finished with search 
                  if(kdw_ex(i,j,n,m) < kmt_ex(iip1,jjq1)) then 
                      exit nloop1_npts
                  endif

               enddo nloop1_npts ! n-loop for search reaching out from central point

               ! place more weight on the farther points to 
               ! encourage tracer exchange further downslope.  
               if(overexch_weight_far .and. npts > 0) then 
                   weight = overexch_flux(i,j,1,m)
                   do n=1,npts
                      arg = float((n-npts)/overexch_width)
                      overexch_flux(i,j,n,m) = weight*exp(arg)
                   enddo
               endif

               ! if no exchange points 
               if(npts==0) then 
                   overexch_flux(i,j,:,m) = 0.0
               endif

            enddo  ! m-loop

        endif ! kmtij > 1

     enddo     ! i-loop
  enddo        ! j-loop


  ! extend arrays to wide halos 
  call mpp_update_domains(kup_ex(:,:,:),          Overexchange_domain%domain2d)
  call mpp_update_domains(kdw_ex(:,:,:,:),        Overexchange_domain%domain2d)
  call mpp_update_domains(overexch_flux(:,:,:,:), Overexchange_domain%domain2d)


  ! compute tracer tendency for cells participating in downslope exchange 
  do nt=1,num_prog_tracers 

     ! place tracer concentration in the wider array tracer_ex 
     if(nt==index_temp) then 
         do k=1,nk
            do j=jsc-ijhalo,jec+ijhalo
               do i=isc-ijhalo,iec+ijhalo
                  tracer_ex(i,j,k) = temp_ex(i,j,k)
               enddo
            enddo
         enddo
     elseif(nt==index_salt) then 
         do k=1,nk
            do j=jsc-ijhalo,jec+ijhalo
               do i=isc-ijhalo,iec+ijhalo
                  tracer_ex(i,j,k) = salt_ex(i,j,k)
               enddo
            enddo
         enddo
     else
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  tracer_ex(i,j,k) = T_prog(nt)%field(i,j,k,taum1)
               enddo
            enddo
         enddo
         call mpp_update_domains (tracer_ex(:,:,:), Overexchange_domain%domain2d)
     endif

     ! initialize array holding tendency for (rho*dzt*tracer) 
     source_overexch(:,:,:) = 0.0

     ! compute tendency, noting that each (i,j,k) cell can generally be part of 
     ! an exchange as either a central shallow cell, or as one of the deep cells. 
     do j=jsc,jec
        do i=isc,iec
           do m=1,4
              do n=1,overexch_npts

                 ! source for shallow cell 
                 iip1 = i+ip(n,m)
                 jjq1 = j+jq(n,m)
                 ku   = kup_ex(i,j,m) 
                 kd   = kdw_ex(i,j,n,m) 
                 if(ku > 0 .and. kd > ku) then 
                     source_overexch(i,j,ku) = source_overexch(i,j,ku) &
                          + overexch_flux(i,j,n,m)*datr_ex(i,j)*(tracer_ex(iip1,jjq1,kd)-tracer_ex(i,j,ku))
                 endif

                 ! source for deep cell  
                 iip1r = i-ip(n,m)
                 jjq1r = j-jq(n,m)
                 ku    = kup_ex(iip1r,jjq1r,m)  
                 kd    = kdw_ex(iip1r,jjq1r,n,m)  
                 if(ku > 0 .and. kd > ku) then 
                     source_overexch(i,j,kd) = source_overexch(i,j,kd) &
                          + overexch_flux(iip1r,jjq1r,n,m)*datr_ex(i,j)*(tracer_ex(iip1r,jjq1r,ku)-tracer_ex(i,j,kd))
                 endif

              enddo ! n-loop 
           enddo    ! m-loop
        enddo       ! i-loop
     enddo          ! j-loop


     ! ensure that this scheme does not create any global extrema
     if(overexch_check_extrema) then 
         do k=1,nk
            kp1=min(nk,k+1)
            km1=max(1,k-1)
            do j=jsc,jec   
               do i=isc,iec
                  if(Grd%tmask(i,j,k) > 0.0) then  
                      tnew = tracer_ex(i,j,k) + source_overexch(i,j,k)*dtime/rho_dzt_ex(i,j,k)
                      if(tnew > T_prog(nt)%max_tracer_limit .or. tnew < T_prog(nt)%min_tracer_limit) then 
                         source_overexch(i,j,k) = 0.0
                      endif 
                  endif
               enddo
            enddo
         enddo
     endif

     ! fill tracer tendency array 
     do k=1,nk
        do j=jsc,jec   
           do i=isc,iec
              T_prog(nt)%th_tendency(i,j,k) = T_prog(nt)%th_tendency(i,j,k) + source_overexch(i,j,k)
           enddo
        enddo
     enddo


     if(id_overexch(nt) > 0) then 
        call diagnose_3d(Time, Grd, id_overexch(nt), T_prog(nt)%conversion*source_overexch(:,:,:))
     endif

     if(nt==index_temp) then 
         wrk1_v(:,:,:,1) = 0.0
         do k=1,nk
            do j=jsc,jec   
               do i=isc,iec
                  wrk1_v(i,j,k,1) = source_overexch(i,j,k)
               enddo
            enddo
         enddo
     endif
     if(nt==index_salt) then 
         wrk1_v(:,:,:,2) = 0.0
         do k=1,nk
            do j=jsc,jec   
               do i=isc,iec
                  wrk1_v(i,j,k,2) = source_overexch(i,j,k)
               enddo
            enddo
         enddo
     endif

  enddo  ! nt-end for num_prog_tracers 

  call watermass_diag(Time, Dens, wrk1_v)

  if (debug_this_module) then
      write(stdoutunit,*) ' '
      write(stdoutunit,*) '==Global sums from ocean_overexchange_mod== '
      call write_timestamp(Time%model_time)

      write(stdoutunit,'(a,es24.17)') &
           'rho_ex     = ',&
           mpp_global_sum(Overexchange_domain%domain2d,rho_ex(:,:,:), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
           'rho_dzt_ex = ',&
           mpp_global_sum(Overexchange_domain%domain2d,rho_dzt_ex(:,:,:), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
           'press_ex   = ',&
           mpp_global_sum(Overexchange_domain%domain2d,press_ex(:,:,:), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
           'temp_ex     = ',&
           mpp_global_sum(Overexchange_domain%domain2d,temp_ex(:,:,:), global_sum_flag)
      write(stdoutunit,'(a,es24.17)') &
           'salt_ex     = ',&
           mpp_global_sum(Overexchange_domain%domain2d,salt_ex(:,:,:), global_sum_flag)
      write(stdoutunit,'(a,i24)') &
           'kmt_ex     = ',&
           mpp_global_sum(Overexchange_domain%domain2d,kmt_ex(:,:), global_sum_flag)

      do m=1,4
         write(stdoutunit,'(a,i24)') &
              'kup_ex            = ',  &
              mpp_global_sum(Overexchange_domain%domain2d,kup_ex(:,:,m), global_sum_flag)
         do n=1,overexch_npts
            write(stdoutunit,'(a,es24.17)') &
                 'overexch_flux     = ',  &
                 mpp_global_sum(Overexchange_domain%domain2d,overexch_flux(:,:,n,m), global_sum_flag)
            write(stdoutunit,'(a,i24)') &
                 'kdw_ex            = ',  &
                 mpp_global_sum(Overexchange_domain%domain2d,kdw_ex(:,:,n,m), global_sum_flag)
         enddo
      enddo

      write(stdoutunit,*) ' '
      write(stdoutunit,*) '==Global check sums from ocean_overexchange_mod== '
      call write_timestamp(Time%model_time)
      call write_chksum_3d('rho_ex', rho_ex(COMP,:))
      call write_chksum_3d('rho_dzt_ex', rho_dzt_ex(COMP,:))
      call write_chksum_3d('press_ex', press_ex(COMP,:))
      call write_chksum_3d('temp_ex', temp_ex(COMP,:))
      call write_chksum_3d('salt_ex', salt_ex(COMP,:))
      call write_chksum_2d_int('kmt_ex;', kmt_ex(COMP))
      do m=1,4
         call write_chksum_2d_int('kup_ex', kup_ex(COMP,m))
         do n=1,overexch_npts
            call write_chksum_2d_int('kdw_ex', kdw_ex(COMP,n,m))
            call write_chksum_2d('overexch_flux', overexch_flux(COMP,n,m))
         enddo
      enddo

  endif

end subroutine overexchange
! </SUBROUTINE> NAME="overexchange"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag_init">
!
! <DESCRIPTION>
! Initialization of watermass diagnostic output files. 
! </DESCRIPTION>
!
subroutine watermass_diag_init(Time, Dens)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens

  integer :: stdoutunit
  stdoutunit=stdout()
  compute_watermass_diag = .false. 
  
  id_neut_rho_overex = register_diag_field ('ocean_model', 'neut_rho_overex',&
    Grd%tracer_axes(1:3), Time%model_time,                                   &
    'update of locally referenced potrho from overexchange scheme',          &
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_overex > 0) compute_watermass_diag = .true.

  id_neut_rho_overex_on_nrho = register_diag_field ('ocean_model',                   &
    'neut_rho_overex_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,            &
    'update of locally ref potrho from overexchange as binned to neutral rho layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_overex_on_nrho > 0) compute_watermass_diag = .true.

  id_wdian_rho_overex = register_diag_field ('ocean_model',   &
    'wdian_rho_overex', Grd%tracer_axes(1:3), Time%model_time,&
    'dianeutral mass transport due to overexchange',          &
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_overex > 0) compute_watermass_diag = .true.

  id_wdian_rho_overex_on_nrho = register_diag_field ('ocean_model',                 &
    'wdian_rho_overex_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,         &
    'dianeutral mass transport due to overexchange as binned to neutral rho layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_overex_on_nrho > 0) compute_watermass_diag = .true.

  id_tform_rho_overex_on_nrho = register_diag_field ('ocean_model',           &
    'tform_rho_overex_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,   &
    'watermass transform due to overexchange as binned to neutral rho layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_overex_on_nrho > 0) compute_watermass_diag = .true.


  ! temperature contributions 
  id_neut_temp_overex = register_diag_field ('ocean_model', 'neut_temp_overex', &
    Grd%tracer_axes(1:3), Time%model_time,                                      &
    'temp related update of locally referenced potrho from overexchange scheme',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_overex > 0) compute_watermass_diag = .true.

  id_neut_temp_overex_on_nrho = register_diag_field ('ocean_model',                            &
    'neut_temp_overex_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,                     &
    'temp related update of locally ref potrho from overexchange binned to neutral rho layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_overex_on_nrho > 0) compute_watermass_diag = .true.

  id_wdian_temp_overex = register_diag_field ('ocean_model',     &
    'wdian_temp_overex', Grd%tracer_axes(1:3), Time%model_time,  &
    'temp related dianeutral mass transport due to overexchange',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_overex > 0) compute_watermass_diag = .true.

  id_wdian_temp_overex_on_nrho = register_diag_field ('ocean_model',                          &
    'wdian_temp_overex_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                  &
    'temp related dianeutral mass transport due to overexchange binned to neutral rho layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_overex_on_nrho > 0) compute_watermass_diag = .true.

  id_tform_temp_overex_on_nrho = register_diag_field ('ocean_model',                       &
    'tform_temp_overex_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,               &
    'temp related watermass transform due to overexchange as binned to neutral rho layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_overex_on_nrho > 0) compute_watermass_diag = .true.


  ! salinity contributions 
  id_neut_salt_overex = register_diag_field ('ocean_model', 'neut_salt_overex', &
    Grd%tracer_axes(1:3), Time%model_time,                                      &
    'salt related update of locally referenced potrho from overexchange scheme',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_overex > 0) compute_watermass_diag = .true.

  id_neut_salt_overex_on_nrho = register_diag_field ('ocean_model',                            &
    'neut_salt_overex_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,                     &
    'salt related update of locally ref potrho from overexchange binned to neutral rho layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_overex_on_nrho > 0) compute_watermass_diag = .true.

  id_wdian_salt_overex = register_diag_field ('ocean_model',     &
    'wdian_salt_overex', Grd%tracer_axes(1:3), Time%model_time,  &
    'salt related dianeutral mass transport due to overexchange',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_overex > 0) compute_watermass_diag = .true.

  id_wdian_salt_overex_on_nrho = register_diag_field ('ocean_model',                          &
    'wdian_salt_overex_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                  &
    'salt related dianeutral mass transport due to overexchange binned to neutral rho layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_overex_on_nrho > 0) compute_watermass_diag = .true.

  id_tform_salt_overex_on_nrho = register_diag_field ('ocean_model',                    &
    'tform_salt_overex_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,            &
    'salt related watermass transform due to overexchange binned to neutral rho layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_overex_on_nrho > 0) compute_watermass_diag = .true.


  if(compute_watermass_diag) then 
      write(stdoutunit,'(/a/)') &
      '==>Note: running ocean_overexchange_mod w/ compute_watermass_diag=.true.'  
  endif

end subroutine watermass_diag_init
! </SUBROUTINE> NAME="watermass_diag_init"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag">
!
! <DESCRIPTION>
! Diagnose effects from overexchange on the watermass transformation.
! </DESCRIPTION>
!
subroutine watermass_diag(Time, Dens, wrk1_v)

  type(ocean_time_type),           intent(in)    :: Time
  type(ocean_density_type),        intent(in)    :: Dens
  real, dimension(isd:,jsd:,:,:),  intent(inout) :: wrk1_v

  integer :: i,j,k

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_overexchange (watermass_diag): module needs initialization ')
  endif 

  if(.not. compute_watermass_diag) return

  ! full rho contributions 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Grd%tmask(i,j,k)*(Dens%drhodT(i,j,k)*wrk1_v(i,j,k,1)+Dens%drhodS(i,j,k)*wrk1_v(i,j,k,2))
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)  
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_overex, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_overex, wrk3(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_overex_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_overex_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_overex_on_nrho, wrk4)

  ! temp contributions 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Grd%tmask(i,j,k)*Dens%drhodT(i,j,k)*wrk1_v(i,j,k,1)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)  
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_overex, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_overex, wrk3(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_overex_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_overex_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_overex_on_nrho, wrk4)

  ! salinity contributions 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Grd%tmask(i,j,k)*Dens%drhodS(i,j,k)*wrk1_v(i,j,k,2)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)  
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_overex, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_overex, wrk3(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_overex_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_overex_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_overex_on_nrho, wrk4)

end subroutine watermass_diag
! </SUBROUTINE>  NAME="watermass_diag"


end module ocean_overexchange_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: cosp_types.F90,v 20.0 2013/12/13 23:15:53 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

!
! History:
! Jul 2007 - A. Bodas-Salcedo - Initial version
! Feb 2008 - R. Marchand      - Added Quickbeam types and initialisation
! Oct 2008 - H. Chepfer       - Added PARASOL reflectance diagnostic
! Nov 2008 - R. Marchand      - Added MISR diagnostics
! Nov 2008 - V. John          - Added RTTOV diagnostics
!
! 
MODULE MOD_COSP_TYPES
    USE MOD_COSP_CONSTANTS
    USE MOD_COSP_UTILS

    use radar_simulator_types, only: class_param, mie, nd, mt_nd, dmax, dmin, mt_ttl, mt_tti, cnt_liq, cnt_ice  ! added by roj Feb 2008

    IMPLICIT NONE
    
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------------- DERIVED TYPES ----------------------------    
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  ! Configuration choices (simulators, variables)
  TYPE COSP_CONFIG
     logical :: Lradar_sim,Llidar_sim,Lisccp_sim,Lmodis_sim,Lmisr_sim,Lrttov_sim,Lstats,Lwrite_output, &
                Lalbisccp,Latb532,Lboxptopisccp,Lboxtauisccp,LcfadDbze94, &
                LcfadLidarsr532,Lclcalipso2,Lclcalipso,Lclhcalipso,Lclisccp,Lcllcalipso, &
                Lclmcalipso,Lcltcalipso,Lcltlidarradar,Lpctisccp,Ldbze94,Ltauisccp,Lcltisccp, &
                Ltoffset,LparasolRefl,LclMISR,Lmeantbisccp,Lmeantbclrisccp, &
                Lfracout,LlidarBetaMol532,Ltbrttov, &
                Lcltmodis,Lclwmodis,Lclimodis,Lclhmodis,Lclmmodis,Lcllmodis,Ltautmodis,Ltauwmodis,Ltauimodis,Ltautlogmodis, &
                Ltauwlogmodis,Ltauilogmodis,Lreffclwmodis,Lreffclimodis,Lpctmodis,Llwpmodis, &
                Liwpmodis,Lclmodis

     character(len=32) :: out_list(N_OUT_LIST)
  END TYPE COSP_CONFIG
  
  ! Outputs from RTTOV
  TYPE COSP_RTTOV
     ! Dimensions
     integer :: Npoints   ! Number of gridpoints
     integer :: Nchan     ! Number of channels
     
     ! Brightness temperatures (Npoints,Nchan)
     real,pointer :: tbs(:,:)
     
  END TYPE COSP_RTTOV
  
  ! Outputs from MISR simulator
  TYPE COSP_MISR
     ! Dimensions
     integer :: Npoints   ! Number of gridpoints
     integer :: Ntau      ! Number of tau intervals
     integer :: Nlevels   ! Number of cth levels

     ! --- (npoints,ntau,nlevels)
     !  the fraction of the model grid box covered by each of the MISR cloud types
     real,pointer :: fq_MISR(:,:,:)  
     
     ! --- (npoints)
     real,pointer :: MISR_meanztop(:), MISR_cldarea(:)
     ! --- (npoints,nlevels)
     real,pointer :: MISR_dist_model_layertops(:,:)
  END TYPE COSP_MISR

  ! Outputs from ISCCP simulator
  TYPE COSP_ISCCP
     ! Dimensions
     integer :: Npoints   ! Number of gridpoints
     integer :: Ncolumns  ! Number of columns
     integer :: Nlevels   ! Number of levels

    
     ! --- (npoints,tau=7,pressure=7)
     !  the fraction of the model grid box covered by each of the 49 ISCCP D level cloud types
     real,pointer :: fq_isccp(:,:,:)
     
     ! --- (npoints) ---
     ! The fraction of model grid box columns with cloud somewhere in them.
     ! This should equal the sum over all entries of fq_isccp
     real,pointer :: totalcldarea(:)
     ! mean all-sky 10.5 micron brightness temperature
     real,pointer ::  meantb(:)
     ! mean clear-sky 10.5 micron brightness temperature
     real,pointer ::  meantbclr(:)
     
     ! The following three means are averages over the cloudy areas only.  If no
     ! clouds are in grid box all three quantities should equal zero.
     
     !  mean cloud top pressure (mb) - linear averaging in cloud top pressure.
     real,pointer :: meanptop(:)
     !  mean optical thickness linear averaging in albedo performed.
     real,pointer :: meantaucld(:)
     ! mean cloud albedo. linear averaging in albedo performed 
     real,pointer :: meanalbedocld(:)  
     
     !--- (npoints,ncol) ---
     !  optical thickness in each column     
     real,pointer :: boxtau(:,:)
     !  cloud top pressure (mb) in each column
     real,pointer :: boxptop(:,:)        
  END TYPE COSP_ISCCP
  
  ! Summary statistics from radar
  TYPE COSP_VGRID
    logical :: use_vgrid ! Logical flag that indicates change of grid
    logical :: csat_vgrid ! Flag for Cloudsat grid
    integer :: Npoints   ! Number of sampled points
    integer :: Ncolumns  ! Number of subgrid columns
    integer :: Nlevels   ! Number of model levels
    integer :: Nlvgrid   ! Number of levels of new grid
    ! Array with dimensions (Nlvgrid)
    real, dimension(:), pointer :: z,zl,zu ! Height and lower and upper boundaries of new levels
    ! Array with dimensions (Nlevels)
    real, dimension(:), pointer :: mz,mzl,mzu ! Height and lower and upper boundaries of model levels
  END TYPE COSP_VGRID
  
  ! Output data from lidar code
  TYPE COSP_SGLIDAR
    ! Dimensions
    integer :: Npoints   ! Number of gridpoints
    integer :: Ncolumns  ! Number of columns
    integer :: Nlevels   ! Number of levels
    integer :: Nhydro    ! Number of hydrometeors    
    integer :: Nrefl     ! Number of parasol reflectances
    ! Arrays with dimensions (Npoints,Nlevels)
    real,dimension(:,:),pointer :: beta_mol   ! Molecular backscatter
    ! Arrays with dimensions (Npoints,Ncolumns,Nlevels)
    real,dimension(:,:,:),pointer :: beta_tot   ! Total backscattered signal
    real,dimension(:,:,:),pointer :: tau_tot    ! Optical thickness integrated from top to level z
    ! Arrays with dimensions (Npoints,Ncolumns,Nrefl)
    real,dimension(:,:,:),pointer :: refl       ! parasol reflectances
  END TYPE COSP_SGLIDAR
  
  ! Output data from radar code
  TYPE COSP_SGRADAR
    ! Dimensions
    integer :: Npoints   ! Number of gridpoints
    integer :: Ncolumns  ! Number of columns
    integer :: Nlevels   ! Number of levels
    integer :: Nhydro    ! Number of hydrometeors
    ! output vertical levels: spaceborne radar -> from TOA to SURFACE
    ! Arrays with dimensions (Npoints,Nlevels)
    real,dimension(:,:),pointer :: att_gas ! 2-way attenuation by gases [dBZ]
    ! Arrays with dimensions (Npoints,Ncolumns,Nlevels)
    real,dimension(:,:,:),pointer :: Ze_tot ! Effective reflectivity factor [dBZ]
 
  END TYPE COSP_SGRADAR

  
  ! Summary statistics from radar
  TYPE COSP_RADARSTATS
    integer :: Npoints  ! Number of sampled points
    integer :: Ncolumns ! Number of subgrid columns
    integer :: Nlevels  ! Number of model levels
    integer :: Nhydro   ! Number of hydrometeors
    ! Array with dimensions (Npoints,dBZe_bins,Nlevels)
    real, dimension(:,:,:), pointer :: cfad_ze ! Ze CFAD
    ! Array with dimensions (Npoints)
    real,dimension(:),pointer :: radar_lidar_tcc ! Radar&lidar total cloud amount, grid-box scale
    ! Arrays with dimensions (Npoints,Nlevels)
    real, dimension(:,:),pointer :: lidar_only_freq_cloud
  END TYPE COSP_RADARSTATS

  ! Summary statistics from lidar
  TYPE COSP_LIDARSTATS
    integer :: Npoints  ! Number of sampled points
    integer :: Ncolumns ! Number of subgrid columns
    integer :: Nlevels  ! Number of model levels
    integer :: Nhydro   ! Number of hydrometeors
    integer :: Nrefl    ! Number of parasol reflectances
    
    ! Arrays with dimensions (SR_BINS)
    real, dimension(:),pointer :: srbval ! SR bins in cfad_sr
    ! Arrays with dimensions (Npoints,SR_BINS,Nlevels)
    real, dimension(:,:,:),pointer :: cfad_sr   ! CFAD of scattering ratio
    ! Arrays with dimensions (Npoints,Nlevels)
    real, dimension(:,:),pointer :: lidarcld    ! 3D "lidar" cloud fraction 
    ! Arrays with dimensions (Npoints,LIDAR_NCAT)
    real, dimension(:,:),pointer :: cldlayer      ! low, mid, high-level, total lidar cloud cover
    ! Arrays with dimensions (Npoints,PARASOL_NREFL)
    real, dimension(:,:),pointer :: parasolrefl   ! mean parasol reflectance

  END TYPE COSP_LIDARSTATS

    
  ! Input data for simulator. Subgrid scale.
  ! Input data from SURFACE to TOA
  TYPE COSP_SUBGRID
    ! Dimensions
    integer :: Npoints   ! Number of gridpoints
    integer :: Ncolumns  ! Number of columns
    integer :: Nlevels   ! Number of levels
    integer :: Nhydro    ! Number of hydrometeors
#ifdef COSP_GFDL
    logical :: cols_input_from_model ! is column data input from model ?
#endif
    
    real,dimension(:,:,:),pointer :: prec_frac  ! Subgrid precip array. Dimensions (Npoints,Ncolumns,Nlevels)
    real,dimension(:,:,:),pointer :: frac_out  ! Subgrid cloud array. Dimensions (Npoints,Ncolumns,Nlevels)
#ifdef COSP_GFDL
    real,dimension(:,:,:),pointer :: dtau_col  ! Subgrid tau   array. Dimensions (Npoints,Ncolumns,Nlevels)
    real,dimension(:,:,:),pointer :: dem_col   ! Subgrid emiss array. Dimensions (Npoints,Ncolumns,Nlevels)
#endif
  END TYPE COSP_SUBGRID

  ! Input data for simulator at Subgrid scale.
  ! Used on a reduced number of points
  TYPE COSP_SGHYDRO
    ! Dimensions
    integer :: Npoints   ! Number of gridpoints
    integer :: Ncolumns  ! Number of columns
    integer :: Nlevels   ! Number of levels
    integer :: Nhydro    ! Number of hydrometeors
    real,dimension(:,:,:,:),pointer :: mr_hydro ! Mixing ratio of each hydrometeor 
                                                ! (Npoints,Ncolumns,Nlevels,Nhydro) [kg/kg]
    real,dimension(:,:,:,:),pointer :: Reff     ! Effective Radius of each hydrometeor
                                                ! (Reff==0 means use default size)   
                                                ! (Npoints,Ncolumns,Nlevels,Nhydro) [m]
  END TYPE COSP_SGHYDRO
  
  ! Input data for simulator. Gridbox scale.
  TYPE COSP_GRIDBOX
    ! Scalars and dimensions
    integer :: Npoints   ! Number of gridpoints
    integer :: Nlevels   ! Number of levels
    integer :: Ncolumns  ! Number of columns
    integer :: Nhydro    ! Number of hydrometeors
    integer :: Nprmts_max_hydro    ! Max number of parameters for hydrometeor size distributions
    integer :: Naero    ! Number of aerosol species
    integer :: Nprmts_max_aero    ! Max number of parameters for aerosol size distributions
    integer :: Npoints_it   ! Max number of gridpoints to be processed in one iteration
    
    ! Time [days]
    double precision :: time
    double precision :: time_bnds(2)
    
    ! Radar ancillary info
    real :: radar_freq, & ! Radar frequency [GHz]
            k2 ! |K|^2, -1=use frequency dependent default
    integer :: surface_radar, & ! surface=1, spaceborne=0
           use_mie_tables, & ! use a precomputed loopup table? yes=1,no=0
           use_gas_abs, & ! include gaseous absorption? yes=1,no=0
           do_ray, & ! calculate/output Rayleigh refl=1, not=0
           melt_lay ! melting layer model off=0, on=1
 
    ! structures used by radar simulator that need to be set only ONCE per radar configuration (e.g. freq, pointing direction) ... added by roj Feb 2008
    type(class_param) ::  hp    ! structure used by radar simulator to store Ze and N scaling constants and other information
    type(mie)::  mt     ! structure used by radar simulator to store mie LUT information
    integer :: nsizes       ! number of discrete drop sizes (um) used to represent the distribution
    real*8, dimension(:), pointer :: D ! array of discrete drop sizes (um) used to represent the distribution
    real*8, dimension(:), pointer :: mt_ttl, mt_tti ! array of temperatures used with Ze_scaling (also build into mie LUT)
    
    ! Lidar
    integer :: lidar_ice_type !ice particle shape hypothesis in lidar calculations 
                              !(ice_type=0 for spheres, ice_type=1 for non spherical particles)
    
    ! Radar
    logical ::  use_precipitation_fluxes  ! True if precipitation fluxes are input to the algorithm 
    logical ::  use_reff  ! True if Reff is to be used by radar 
    
    ! Geolocation (Npoints)
    real,dimension(:),pointer :: toffset   ! Time offset of esch point from the value in time
    real,dimension(:),pointer :: longitude ! longitude [degrees East]
    real,dimension(:),pointer :: latitude  ! latitude [deg North]
    ! Gridbox information (Npoints,Nlevels)
    real,dimension(:,:),pointer :: zlev ! Height of model levels [m]
    real,dimension(:,:),pointer :: zlev_half ! Height at half model levels [m] (Bottom of model layer)
    real,dimension(:,:),pointer :: dlev ! Depth of model levels  [m]
    real,dimension(:,:),pointer :: p  ! Pressure at full model levels [Pa]
    real,dimension(:,:),pointer :: ph ! Pressure at half model levels [Pa]
    real,dimension(:,:),pointer :: T ! Temperature at model levels [K]
    real,dimension(:,:),pointer :: q  ! Relative humidity to water (%)
    real,dimension(:,:),pointer :: sh ! Specific humidity to water [kg/kg]
    real,dimension(:,:),pointer :: dtau_s ! mean 0.67 micron optical depth of stratiform
                                          !  clouds in each model level
                                          !  NOTE:  this the cloud optical depth of only the
                                          !  cloudy part of the grid box, it is not weighted
                                          !  with the 0 cloud optical depth of the clear
                                          !         part of the grid box
    real,dimension(:,:),pointer :: dtau_c !  mean 0.67 micron optical depth of convective
                                          !  clouds in each model level.  Same note applies as in dtau_s.
    real,dimension(:,:),pointer :: dem_s  !  10.5 micron longwave emissivity of stratiform
                                          !  clouds in each model level.  Same note applies as in dtau_s.
    real,dimension(:,:),pointer :: dem_c  !  10.5 micron longwave emissivity of convective
                                          !  clouds in each model level.  Same note applies as in dtau_s.
    real,dimension(:,:),pointer :: mr_ozone !  Ozone mass mixing ratio [kg/kg]

    ! Point information (Npoints)
    real,dimension(:),pointer :: land !Landmask [0 - Ocean, 1 - Land]
    real,dimension(:),pointer :: psfc !Surface pressure [Pa]
    real,dimension(:),pointer :: sunlit ! (npoints) 1 for day points, 0 for nightime
    real,dimension(:),pointer :: skt  ! Skin temperature (K)
    real,dimension(:),pointer :: sfc_height  ! Surface height [m]
    real,dimension(:),pointer :: u_wind  ! eastward wind [m s-1]
    real,dimension(:),pointer :: v_wind  ! northward wind [m s-1]

    ! TOTAL and CONV cloud fraction for SCOPS
    real,dimension(:,:),pointer :: tca ! Total cloud fraction
    real,dimension(:,:),pointer :: cca ! Convective cloud fraction
    ! Precipitation fluxes on model levels
    real,dimension(:,:),pointer :: rain_ls ! large-scale precipitation flux of rain [kg/m2.s]
    real,dimension(:,:),pointer :: rain_cv ! convective precipitation flux of rain [kg/m2.s]
    real,dimension(:,:),pointer :: snow_ls ! large-scale precipitation flux of snow [kg/m2.s]
    real,dimension(:,:),pointer :: snow_cv ! convective precipitation flux of snow [kg/m2.s]
    real,dimension(:,:),pointer :: grpl_ls ! large-scale precipitation flux of graupel [kg/m2.s]
    ! Hydrometeors concentration and distribution parameters
!     real,dimension(:,:,:),pointer :: fr_hydro ! Fraction of the gridbox occupied by each hydrometeor (Npoints,Nlevels,Nhydro)
    real,dimension(:,:,:),pointer :: mr_hydro ! Mixing ratio of each hydrometeor (Npoints,Nlevels,Nhydro) [kg/kg]
    real,dimension(:,:),pointer   :: dist_prmts_hydro !Distributional parameters for hydrometeors (Nprmts_max_hydro,Nhydro)
    ! Effective radius [m]. (Npoints,Nlevels,Nhydro)
    real,dimension(:,:,:),pointer :: Reff
    ! Aerosols concentration and distribution parameters
    real,dimension(:,:,:),pointer :: conc_aero ! Aerosol concentration for each species (Npoints,Nlevels,Naero)
    integer,dimension(:),pointer :: dist_type_aero ! Particle size distribution type for each aerosol species (Naero)
    real,dimension(:,:,:,:),pointer :: dist_prmts_aero ! Distributional parameters for aerosols 
                                                       ! (Npoints,Nlevels,Nprmts_max_aero,Naero)
    ! ISCCP simulator inputs
    integer :: isccp_top_height !  1 = adjust top height using both a computed
                                !  infrared brightness temperature and the visible
                                !  optical depth to adjust cloud top pressure. Note
                                !  that this calculation is most appropriate to compare
                                !  to ISCCP data during sunlit hours.
                                !  2 = do not adjust top height, that is cloud top
                                !  pressure is the actual cloud top pressure
                                !  in the model
                                !  3 = adjust top height using only the computed
                                !  infrared brightness temperature. Note that this
                                !  calculation is most appropriate to compare to ISCCP
                                !  IR only algortihm (i.e. you can compare to nighttime
                                !  ISCCP data with this option)
    integer :: isccp_top_height_direction ! direction for finding atmosphere pressure level
                                 ! with interpolated temperature equal to the radiance
                                 ! determined cloud-top temperature
                                 ! 1 = find the *lowest* altitude (highest pressure) level
                                 ! with interpolated temperature equal to the radiance
                                 ! determined cloud-top temperature
                                 ! 2 = find the *highest* altitude (lowest pressure) level
                                 ! with interpolated temperature equal to the radiance 
                                 ! determined cloud-top temperature
                                 ! ONLY APPLICABLE IF top_height EQUALS 1 or 3
                                 ! 1 = default setting, and matches all versions of 
                                 ! ISCCP simulator with versions numbers 3.5.1 and lower
                                 ! 2 = experimental setting  
    integer :: isccp_overlap !  overlap type (1=max, 2=rand, 3=max/rand)
    real :: isccp_emsfc_lw      ! 10.5 micron emissivity of surface (fraction)
  
    ! RTTOV inputs/options
    integer :: plat      ! satellite platform
    integer :: sat       ! satellite
    integer :: inst      ! instrument
    integer :: Nchan     ! Number of channels to be computed
    integer, dimension(:), pointer :: Ichan   ! Channel numbers
    real,    dimension(:), pointer :: Surfem  ! Surface emissivity
    real    :: ZenAng ! Satellite Zenith Angles
    real :: co2,ch4,n2o,co ! Mixing ratios of trace gases

  END TYPE COSP_GRIDBOX
 
CONTAINS

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE CONSTRUCT_COSP_RTTOV -------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_COSP_RTTOV(Npoints,Nchan,x)
    integer,intent(in) :: Npoints  ! Number of sampled points
    integer,intent(in) :: Nchan ! Number of channels
    type(cosp_rttov),intent(out) :: x
    
    ! Dimensions
    x%Npoints  = Npoints
    x%Nchan    = Nchan
      
    ! --- Allocate arrays ---
    allocate(x%tbs(Npoints, Nchan))
    ! --- Initialise to zero ---
    x%tbs     = 0.0
  END SUBROUTINE CONSTRUCT_COSP_RTTOV

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE FREE_COSP_RTTOV ------------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE FREE_COSP_RTTOV(x)
    type(cosp_rttov),intent(inout) :: x
    
    ! --- Deallocate arrays ---
    deallocate(x%tbs)
  END SUBROUTINE FREE_COSP_RTTOV
  
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE CONSTRUCT_COSP_MISR ------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_COSP_MISR(cfg,Npoints,x)
    type(cosp_config),intent(in) :: cfg ! Configuration options
    integer,intent(in) :: Npoints   ! Number of gridpoints
    type(cosp_misr),intent(out) :: x
    ! Local variables
    integer :: i,j,k
    
   
    ! Allocate minumum storage if simulator not used
    if (cfg%Lmisr_sim) then
      i = Npoints
      j = 7
      k = MISR_N_CTH
    else
      i = 1
      j = 1
      k = 1
    endif
    
    ! Dimensions
    x%Npoints = i
    x%Ntau    = j
    x%Nlevels = k
    
    ! allocate space for MISR simulator outputs ...
    allocate(x%fq_MISR(i,j,k), x%MISR_meanztop(i),x%MISR_cldarea(i), x%MISR_dist_model_layertops(i,k))
    x%fq_MISR = 0.0
    x%MISR_meanztop = 0.0
    x%MISR_cldarea = 0.0
    x%MISR_dist_model_layertops = 0.0
    
  END SUBROUTINE CONSTRUCT_COSP_MISR
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE FREE_COSP_MISR ------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE FREE_COSP_MISR(x)
    type(cosp_misr),intent(inout) :: x
    deallocate(x%fq_MISR, x%MISR_meanztop,x%MISR_cldarea, x%MISR_dist_model_layertops)
    
  END SUBROUTINE FREE_COSP_MISR

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE CONSTRUCT_COSP_ISCCP ------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_COSP_ISCCP(cfg,Npoints,Ncolumns,Nlevels,x)
    type(cosp_config),intent(in) :: cfg ! Configuration options
    integer,intent(in) :: Npoints  ! Number of sampled points
    integer,intent(in) :: Ncolumns ! Number of subgrid columns
    integer,intent(in) :: Nlevels  ! Number of model levels
    type(cosp_isccp),intent(out) :: x
    ! Local variables
    integer :: i,j,k
    
    ! Allocate minumum storage if simulator not used
    if (cfg%Lisccp_sim) then
      i = Npoints
      j = Ncolumns
      k = Nlevels
    else
      i = 1
      j = 1
      k = 1
    endif
    
    ! Dimensions
    x%Npoints  = i
    x%Ncolumns = j
    x%Nlevels  = k
    
    ! --- Allocate arrays ---
    allocate(x%fq_isccp(i,7,7), x%totalcldarea(i), &
         x%meanptop(i), x%meantaucld(i), &
         x%meantb(i), x%meantbclr(i), &
         x%boxtau(i,j), x%boxptop(i,j), &
         x%meanalbedocld(i))
    ! --- Initialise to zero ---
    x%fq_isccp     = 0.0
    x%totalcldarea = 0.0
    x%meanptop     = 0.0
    x%meantaucld   = 0.0
    x%meantb       = 0.0
    x%meantbclr    = 0.0
    x%boxtau       = 0.0
    x%boxptop      = 0.0
    x%meanalbedocld= 0.0
  END SUBROUTINE CONSTRUCT_COSP_ISCCP

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE FREE_COSP_ISCCP -----------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE FREE_COSP_ISCCP(x)
    type(cosp_isccp),intent(inout) :: x
    
    deallocate(x%fq_isccp, x%totalcldarea, &
         x%meanptop, x%meantaucld, x%meantb, x%meantbclr, &
         x%boxtau, x%boxptop, x%meanalbedocld)
  END SUBROUTINE FREE_COSP_ISCCP
  
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE CONSTRUCT_COSP_VGRID ------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_COSP_VGRID(gbx,Nlvgrid,use_vgrid,cloudsat,x)
    type(cosp_gridbox),intent(in) :: gbx ! Gridbox information
    integer,intent(in) :: Nlvgrid  ! Number of new levels    
    logical,intent(in) :: use_vgrid! Logical flag that controls the output on a different grid
    logical,intent(in) :: cloudsat ! TRUE if a CloudSat like grid (480m) is requested
    type(cosp_vgrid),intent(out) :: x
    
    ! Local variables
    integer :: i
    real :: zstep
    
    x%use_vgrid  = use_vgrid
    x%csat_vgrid = cloudsat
    
    ! Dimensions
    x%Npoints  = gbx%Npoints
    x%Ncolumns = gbx%Ncolumns
    x%Nlevels  = gbx%Nlevels
    
    ! --- Allocate arrays ---
    if (use_vgrid) then
      x%Nlvgrid = Nlvgrid
    else 
      x%Nlvgrid = gbx%Nlevels
    endif
    allocate(x%z(x%Nlvgrid),x%zl(x%Nlvgrid),x%zu(x%Nlvgrid))
    allocate(x%mz(x%Nlevels),x%mzl(x%Nlevels),x%mzu(x%Nlevels))
    
    ! --- Model vertical levels ---
    ! Use height levels of first model gridbox
    x%mz  =gbx%zlev(1,:)
    x%mzl = gbx%zlev_half(1,:)
    x%mzu(1:x%Nlevels-1) = gbx%zlev_half(1,2:x%Nlevels)
    x%mzu(x%Nlevels) = gbx%zlev(1,x%Nlevels) + (gbx%zlev(1,x%Nlevels) - x%mzl(x%Nlevels))
    
    if (use_vgrid) then
      ! --- Initialise to zero ---
      x%z  = 0.0
      x%zl = 0.0
      x%zu = 0.0
      if (cloudsat) then ! --- CloudSat grid requested ---
         zstep = 480.0
      else
         ! Other grid requested. Constant vertical spacing with top at 20 km
         zstep = 20000.0/x%Nlvgrid
      endif
      do i=1,x%Nlvgrid
         x%zl(i) = (i-1)*zstep
         x%zu(i) = i*zstep
      enddo
      x%z = (x%zl + x%zu)/2.0
    else
      x%z  = x%mz
      x%zl = x%mzl
      x%zu = x%mzu
    endif
    
  END SUBROUTINE CONSTRUCT_COSP_VGRID

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------------ SUBROUTINE FREE_COSP_VGRID ------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE FREE_COSP_VGRID(x)
    type(cosp_vgrid),intent(inout) :: x

    deallocate(x%z, x%zl, x%zu, x%mz, x%mzl, x%mzu)
  END SUBROUTINE FREE_COSP_VGRID

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE CONSTRUCT_COSP_SGLIDAR ------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_COSP_SGLIDAR(cfg,Npoints,Ncolumns,Nlevels,Nhydro,Nrefl,x)
    type(cosp_config),intent(in) :: cfg ! Configuration options
    integer,intent(in) :: Npoints  ! Number of sampled points
    integer,intent(in) :: Ncolumns ! Number of subgrid columns
    integer,intent(in) :: Nlevels  ! Number of model levels
    integer,intent(in) :: Nhydro   ! Number of hydrometeors
    integer,intent(in) :: Nrefl    ! Number of parasol reflectances ! parasol
    type(cosp_sglidar),intent(out) :: x
    ! Local variables
    integer :: i,j,k,l,m
    
    ! Allocate minumum storage if simulator not used
    if (cfg%Llidar_sim) then
      i = Npoints
      j = Ncolumns
      k = Nlevels
      l = Nhydro
      m = Nrefl
    else
      i = 1
      j = 1
      k = 1
      l = 1
      m = 1
    endif
    
    ! Dimensions
    x%Npoints  = i
    x%Ncolumns = j
    x%Nlevels  = k
    x%Nhydro   = l
    x%Nrefl    = m
    
    ! --- Allocate arrays ---
    allocate(x%beta_mol(i,k), x%beta_tot(i,j,k), &
             x%tau_tot(i,j,k),x%refl(i,j,m))
    ! --- Initialise to zero ---
    x%beta_mol   = 0.0
    x%beta_tot   = 0.0
    x%tau_tot    = 0.0
    x%refl       = 0.0 ! parasol
  END SUBROUTINE CONSTRUCT_COSP_SGLIDAR

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------------ SUBROUTINE FREE_COSP_SGLIDAR ------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE FREE_COSP_SGLIDAR(x)
    type(cosp_sglidar),intent(inout) :: x

    deallocate(x%beta_mol, x%beta_tot, x%tau_tot, x%refl)
  END SUBROUTINE FREE_COSP_SGLIDAR

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE CONSTRUCT_COSP_SGRADAR ------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_COSP_SGRADAR(cfg,Npoints,Ncolumns,Nlevels,Nhydro,x)
    type(cosp_config),intent(in) :: cfg ! Configuration options
    integer,intent(in) :: Npoints  ! Number of sampled points
    integer,intent(in) :: Ncolumns ! Number of subgrid columns
    integer,intent(in) :: Nlevels  ! Number of model levels
    integer,intent(in) :: Nhydro   ! Number of hydrometeors
    type(cosp_sgradar),intent(out) :: x
    ! Local variables
    integer :: i,j,k,l
    
    if (cfg%Lradar_sim) then
      i = Npoints
      j = Ncolumns
      k = Nlevels
      l = Nhydro
    else ! Allocate minumum storage if simulator not used
      i = 1
      j = 1
      k = 1
      l = 1
    endif
    
    ! Dimensions
    x%Npoints  = i
    x%Ncolumns = j
    x%Nlevels  = k
    x%Nhydro   = l
    
    ! --- Allocate arrays ---
    allocate(x%att_gas(i,k), x%Ze_tot(i,j,k))
    ! --- Initialise to zero ---
    x%att_gas   = 0.0
    x%Ze_tot    = 0.0
    ! The following line give a compilation error on the Met Office NEC
!     call zero_real(x%Z_hydro, x%att_hydro)
!     f90: error(666): cosp_types.f90, line nnn:
!                                        Actual argument corresponding to dummy
!                                        argument of ELEMENTAL subroutine
!                                        "zero_real" with INTENET(OUT) attribute
!                                        is not array.
  END SUBROUTINE CONSTRUCT_COSP_SGRADAR

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------------ SUBROUTINE FREE_COSP_SGRADAR ----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE FREE_COSP_SGRADAR(x)
    type(cosp_sgradar),intent(inout) :: x

    deallocate(x%att_gas, x%Ze_tot)
  END SUBROUTINE FREE_COSP_SGRADAR

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------- SUBROUTINE CONSTRUCT_COSP_RADARSTATS ---------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_COSP_RADARSTATS(cfg,Npoints,Ncolumns,Nlevels,Nhydro,x)
    type(cosp_config),intent(in) :: cfg ! Configuration options
    integer,intent(in) :: Npoints  ! Number of sampled points
    integer,intent(in) :: Ncolumns ! Number of subgrid columns
    integer,intent(in) :: Nlevels  ! Number of model levels
    integer,intent(in) :: Nhydro   ! Number of hydrometeors
    type(cosp_radarstats),intent(out) :: x    
    ! Local variables
    integer :: i,j,k,l
    
    ! Allocate minumum storage if simulator not used
    if (cfg%Lradar_sim) then
      i = Npoints
      j = Ncolumns
      k = Nlevels
      l = Nhydro
    else
      i = 1
      j = 1
      k = 1
      l = 1
    endif
    
    ! Dimensions
    x%Npoints  = i
    x%Ncolumns = j
    x%Nlevels  = k
    x%Nhydro   = l
    
    ! --- Allocate arrays ---
    allocate(x%cfad_ze(i,DBZE_BINS,k),x%lidar_only_freq_cloud(i,k))
    allocate(x%radar_lidar_tcc(i))
    ! --- Initialise to zero ---
    x%cfad_ze = 0.0
    x%lidar_only_freq_cloud = 0.0
    x%radar_lidar_tcc = 0.0
  END SUBROUTINE CONSTRUCT_COSP_RADARSTATS

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------------ SUBROUTINE FREE_COSP_RADARSTATS -------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE FREE_COSP_RADARSTATS(x)
    type(cosp_radarstats),intent(inout) :: x

    deallocate(x%cfad_ze,x%lidar_only_freq_cloud,x%radar_lidar_tcc)
  END SUBROUTINE FREE_COSP_RADARSTATS

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------- SUBROUTINE CONSTRUCT_COSP_LIDARSTATS ---------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_COSP_LIDARSTATS(cfg,Npoints,Ncolumns,Nlevels,Nhydro,Nrefl,x)
    type(cosp_config),intent(in) :: cfg ! Configuration options
    integer,intent(in) :: Npoints  ! Number of sampled points
    integer,intent(in) :: Ncolumns ! Number of subgrid columns
    integer,intent(in) :: Nlevels  ! Number of model levels
    integer,intent(in) :: Nhydro   ! Number of hydrometeors
    integer,intent(in) :: Nrefl    ! Number of parasol reflectance
    type(cosp_lidarstats),intent(out) :: x
    ! Local variables
    integer :: i,j,k,l,m
    
    ! Allocate minumum storage if simulator not used
    if (cfg%Llidar_sim) then
      i = Npoints
      j = Ncolumns
      k = Nlevels
      l = Nhydro
      m = Nrefl
    else
      i = 1
      j = 1
      k = 1
      l = 1
      m = 1
    endif
    
    ! Dimensions
    x%Npoints  = i
    x%Ncolumns = j
    x%Nlevels  = k
    x%Nhydro   = l
    x%Nrefl    = m
    
    ! --- Allocate arrays ---
    allocate(x%srbval(SR_BINS),x%cfad_sr(i,SR_BINS,k), & 
             x%lidarcld(i,k), x%cldlayer(i,LIDAR_NCAT), x%parasolrefl(i,m))
    ! --- Initialise to zero ---
    x%srbval    = 0.0
    x%cfad_sr   = 0.0
    x%lidarcld  = 0.0
    x%cldlayer  = 0.0
    x%parasolrefl  = 0.0
  END SUBROUTINE CONSTRUCT_COSP_LIDARSTATS

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------------ SUBROUTINE FREE_COSP_LIDARSTATS -------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE FREE_COSP_LIDARSTATS(x)
    type(cosp_lidarstats),intent(inout) :: x

    deallocate(x%srbval, x%cfad_sr, x%lidarcld, x%cldlayer, x%parasolrefl)
  END SUBROUTINE FREE_COSP_LIDARSTATS
 

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE CONSTRUCT_COSP_SUBGRID ------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_COSP_SUBGRID(Npoints,Ncolumns,Nlevels,y)
    integer,intent(in) :: Npoints, & ! Number of gridpoints
                                        Ncolumns, & ! Number of columns
                                        Nlevels   ! Number of levels
    type(cosp_subgrid),intent(out) :: y
    
    ! Dimensions
    y%Npoints  = Npoints
    y%Ncolumns = Ncolumns
    y%Nlevels  = Nlevels

    ! --- Allocate arrays ---
    allocate(y%frac_out(Npoints,Ncolumns,Nlevels))
#ifdef COSP_GFDL
    allocate (y%dtau_col(Npoints,Ncolumns,Nlevels), &
              y%dem_col(Npoints,Ncolumns,Nlevels) )
#endif
    if (Ncolumns > 1) then
      allocate(y%prec_frac(Npoints,Ncolumns,Nlevels))
    else ! CRM mode, not needed
      allocate(y%prec_frac(1,1,1))
    endif
    ! --- Initialise to zero ---
    y%prec_frac = 0.0
    y%frac_out  = 0.0
#ifdef COSP_GFDL
    y%dtau_col    = 0.0
    y%dem_col    = 0.0
#endif
    ! The following line gives a compilation error on the Met Office NEC
!     call zero_real(y%mr_hydro)
!     f90: error(666): cosp_types.f90, line nnn:
!                                        Actual argument corresponding to dummy
!                                        argument of ELEMENTAL subroutine
!                                        "zero_real" with INTENET(OUT) attribute
!                                        is not array.

  END SUBROUTINE CONSTRUCT_COSP_SUBGRID

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE FREE_COSP_SUBGRID -----------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE FREE_COSP_SUBGRID(y)
    type(cosp_subgrid),intent(inout) :: y
    
    ! --- Deallocate arrays ---
#ifdef COSP_GFDL
    deallocate(y%prec_frac, y%frac_out, y%dtau_col, y%dem_col)
#else
    deallocate(y%prec_frac, y%frac_out)
#endif
        
  END SUBROUTINE FREE_COSP_SUBGRID

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE CONSTRUCT_COSP_SGHYDRO -----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_COSP_SGHYDRO(Npoints,Ncolumns,Nlevels,Nhydro,y)
    integer,intent(in) :: Npoints, & ! Number of gridpoints
                                        Ncolumns, & ! Number of columns
                                        Nhydro, & ! Number of hydrometeors
                                        Nlevels   ! Number of levels
    type(cosp_sghydro),intent(out) :: y
    
    ! Dimensions
    y%Npoints  = Npoints
    y%Ncolumns = Ncolumns
    y%Nlevels  = Nlevels
    y%Nhydro   = Nhydro

    ! --- Allocate arrays ---
    allocate(y%mr_hydro(Npoints,Ncolumns,Nlevels,Nhydro), &
             y%Reff(Npoints,Ncolumns,Nlevels,Nhydro))
    ! --- Initialise to zero ---
    y%mr_hydro = 0.0
    y%Reff     = 0.0

  END SUBROUTINE CONSTRUCT_COSP_SGHYDRO

 !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE FREE_COSP_SGHYDRO -----------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE FREE_COSP_SGHYDRO(y)
    type(cosp_sghydro),intent(inout) :: y
    
    ! --- Deallocate arrays ---
    deallocate(y%mr_hydro, y%Reff)
        
  END SUBROUTINE FREE_COSP_SGHYDRO
 
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE CONSTRUCT_COSP_GRIDBOX ------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_COSP_GRIDBOX(time,time_bnds,radar_freq,surface_radar,use_mie_tables,use_gas_abs,do_ray,melt_lay,k2, &
                                   Npoints,Nlevels,Ncolumns,Nhydro,Nprmts_max_hydro,Naero,Nprmts_max_aero,Npoints_it, & 
                                   lidar_ice_type,isccp_top_height,isccp_top_height_direction,isccp_overlap,isccp_emsfc_lw, &
                                   use_precipitation_fluxes,use_reff, &
                                   ! RTTOV inputs
                                   Plat,Sat,Inst,Nchan,ZenAng,Ichan,SurfEm,co2,ch4,n2o,co,&
                                   y)
    double precision,intent(in) :: time ! Time since start of run [days] 
    double precision,intent(in) :: time_bnds(2) ! Time boundaries
    real,intent(in)    :: radar_freq, & ! Radar frequency [GHz]
                          k2            ! |K|^2, -1=use frequency dependent default
    integer,intent(in) :: &
        surface_radar, &  ! surface=1,spaceborne=0
        use_mie_tables, & ! use a precomputed lookup table? yes=1,no=0,2=use first column everywhere
        use_gas_abs, &    ! include gaseous absorption? yes=1,no=0
        do_ray, &         ! calculate/output Rayleigh refl=1, not=0
        melt_lay          ! melting layer model off=0, on=1
    integer,intent(in) :: Npoints   ! Number of gridpoints
    integer,intent(in) :: Nlevels   ! Number of levels
    integer,intent(in) :: Ncolumns  ! Number of columns
    integer,intent(in) :: Nhydro    ! Number of hydrometeors
    integer,intent(in) :: Nprmts_max_hydro    ! Max number of parameters for hydrometeor size distributions
    integer,intent(in) :: Naero    ! Number of aerosol species
    integer,intent(in) :: Nprmts_max_aero    ! Max number of parameters for aerosol size distributions
    integer,intent(in) :: Npoints_it   ! Number of gridpoints processed in one iteration
    integer,intent(in) :: lidar_ice_type ! Ice particle shape in lidar calculations (0=ice-spheres ; 1=ice-non-spherical)
    integer,intent(in) :: isccp_top_height
    integer,intent(in) :: isccp_top_height_direction
    integer,intent(in) :: isccp_overlap
    real,intent(in)    :: isccp_emsfc_lw
    logical,intent(in) :: use_precipitation_fluxes,use_reff
    integer,intent(in) :: Plat
    integer,intent(in) :: Sat
    integer,intent(in) :: Inst
    integer,intent(in) :: Nchan
    integer,intent(in) :: Ichan(Nchan)
    real,intent(in)    :: SurfEm(Nchan)
    real,intent(in)    :: ZenAng
    real,intent(in)    :: co2,ch4,n2o,co
    type(cosp_gridbox),intent(out) :: y

        
    ! local variables
    integer i, cnt_ice, cnt_liq
    real*8  :: delt, deltp
 
    ! Dimensions and scalars
    y%radar_freq       = radar_freq
    y%surface_radar    = surface_radar
    y%use_mie_tables   = use_mie_tables
    y%use_gas_abs      = use_gas_abs
    y%do_ray           = do_ray
    y%melt_lay         = melt_lay
    y%k2               = k2
    y%Npoints          = Npoints
    y%Nlevels          = Nlevels
    y%Ncolumns         = Ncolumns
    y%Nhydro           = Nhydro
    y%Nprmts_max_hydro = Nprmts_max_hydro
    y%Naero            = Naero
    y%Nprmts_max_aero  = Nprmts_max_aero
    y%Npoints_it       = Npoints_it
    y%lidar_ice_type   = lidar_ice_type
    y%isccp_top_height = isccp_top_height
    y%isccp_top_height_direction = isccp_top_height_direction
    y%isccp_overlap    = isccp_overlap
    y%isccp_emsfc_lw   = isccp_emsfc_lw
    y%use_precipitation_fluxes = use_precipitation_fluxes
    y%use_reff = use_reff
    
    y%time      = time
    y%time_bnds = time_bnds
    
    ! RTTOV parameters
    y%Plat   = Plat
    y%Sat    = Sat
    y%Inst   = Inst
    y%Nchan  = Nchan
    y%ZenAng = ZenAng
    y%co2    = co2
    y%ch4    = ch4
    y%n2o    = n2o
    y%co     = co

    ! --- Allocate arrays ---
    ! Gridbox information (Npoints,Nlevels)
    allocate(y%zlev(Npoints,Nlevels), y%zlev_half(Npoints,Nlevels), y%dlev(Npoints,Nlevels), &
             y%p(Npoints,Nlevels), y%ph(Npoints,Nlevels), y%T(Npoints,Nlevels), &
             y%q(Npoints,Nlevels), y%sh(Npoints,Nlevels), &
             y%dtau_s(Npoints,Nlevels), y%dtau_c(Npoints,Nlevels), &
             y%dem_s(Npoints,Nlevels), y%dem_c(Npoints,Nlevels), &
             y%tca(Npoints,Nlevels), y%cca(Npoints,Nlevels), &
             y%rain_ls(Npoints,Nlevels), y%rain_cv(Npoints,Nlevels), y%grpl_ls(Npoints,Nlevels), &
             y%snow_ls(Npoints,Nlevels), y%snow_cv(Npoints,Nlevels),y%mr_ozone(Npoints,Nlevels))
             
             
    ! Surface information and geolocation (Npoints)
    allocate(y%toffset(Npoints), y%longitude(Npoints),y%latitude(Npoints),y%psfc(Npoints), y%land(Npoints), &
             y%sunlit(Npoints),y%skt(Npoints),y%sfc_height(Npoints),y%u_wind(Npoints),y%v_wind(Npoints))
    ! Hydrometeors concentration and distribution parameters
    allocate(y%mr_hydro(Npoints,Nlevels,Nhydro), &
             y%dist_prmts_hydro(Nprmts_max_hydro,Nhydro), &
             y%Reff(Npoints,Nlevels,Nhydro))
    ! Aerosols concentration and distribution parameters
    allocate(y%conc_aero(Npoints,Nlevels,Naero), y%dist_type_aero(Naero), &
             y%dist_prmts_aero(Npoints,Nlevels,Nprmts_max_aero,Naero))
    
    ! RTTOV channels and sfc. emissivity
    allocate(y%ichan(Nchan),y%surfem(Nchan))
    
    ! RTTOV parameters
    y%ichan   =  ichan
    y%surfem  =  surfem
    
    ! --- Initialise to zero ---
    y%zlev      = 0.0
    y%zlev_half = 0.0
    y%dlev      = 0.0
    y%p         = 0.0
    y%ph        = 0.0
    y%T         = 0.0
    y%q         = 0.0
    y%sh        = 0.0
    y%dtau_s    = 0.0
    y%dtau_c    = 0.0
    y%dem_s     = 0.0
    y%dem_c     = 0.0
    y%tca       = 0.0
    y%cca       = 0.0
    y%rain_ls   = 0.0
    y%rain_cv   = 0.0
    y%grpl_ls   = 0.0
    y%snow_ls   = 0.0
    y%snow_cv   = 0.0
    y%Reff      = 0.0
    y%mr_ozone  = 0.0
    y%u_wind    = 0.0
    y%v_wind    = 0.0

    
    ! (Npoints)
!     call zero_real(y%psfc, y%land)
    y%toffset = 0.0
    y%longitude = 0.0
    y%latitude = 0.0
    y%psfc = 0.0
    y%land = 0.0
    y%sunlit = 0.0
    y%skt = 0.0
    y%sfc_height = 0.0
    ! (Npoints,Nlevels,Nhydro)
!     y%fr_hydro = 0.0
    y%mr_hydro = 0.0
    ! Others
    y%dist_prmts_hydro = 0.0 ! (Nprmts_max_hydro,Nhydro)
    y%conc_aero        = 0.0 ! (Npoints,Nlevels,Naero)
    y%dist_type_aero   = 0   ! (Naero)
    y%dist_prmts_aero  = 0.0 ! (Npoints,Nlevels,Nprmts_max_aero,Naero)

    y%hp%p1 = 0.0
    y%hp%p2 = 0.0
    y%hp%p3 = 0.0
    y%hp%dmin = 0.0
    y%hp%dmax = 0.0
    y%hp%apm = 0.0
    y%hp%bpm = 0.0
    y%hp%rho = 0.0
    y%hp%dtype = 0
    y%hp%col = 0
    y%hp%cp = 0
    y%hp%phase = 0
    y%hp%scaled = .false.
    y%hp%z_flag = .false.
    y%hp%Ze_scaled = 0.0
    y%hp%Zr_scaled = 0.0
    y%hp%kr_scaled = 0.0
    y%hp%fc = 0.0
    y%hp%rho_eff = 0.0
    y%hp%ifc = 0
    y%hp%idd = 0
    y%mt%freq = 0.0
    y%mt%tt = 0.0
    y%mt%f = 0.0
    y%mt%D = 0.0
    y%mt%qext = 0.0
    y%mt%qbsca = 0.0
    y%mt%phase = 0
    
    
    ! --- Initialize the distributional parameters for hydrometeors
    y%dist_prmts_hydro( 1,:) = HCLASS_TYPE(:)
    y%dist_prmts_hydro( 2,:) = HCLASS_COL(:)
    y%dist_prmts_hydro( 3,:) = HCLASS_PHASE(:)
    y%dist_prmts_hydro( 4,:) = HCLASS_CP(:)
    y%dist_prmts_hydro( 5,:) = HCLASS_DMIN(:)
    y%dist_prmts_hydro( 6,:) = HCLASS_DMAX(:)
    y%dist_prmts_hydro( 7,:) = HCLASS_APM(:)
    y%dist_prmts_hydro( 8,:) = HCLASS_BPM(:)
    y%dist_prmts_hydro( 9,:) = HCLASS_RHO(:)
    y%dist_prmts_hydro(10,:) = HCLASS_P1(:)
    y%dist_prmts_hydro(11,:) = HCLASS_P2(:)
    y%dist_prmts_hydro(12,:) = HCLASS_P3(:)

    ! the following code added by roj to initialize structures used by radar simulator, Feb 2008
    call load_hydrometeor_classes(y%Nprmts_max_hydro,y%dist_prmts_hydro(:,:),y%hp,y%Nhydro)

    ! load mie tables ?
    if (y%use_mie_tables == 1) then
      print *, '%%% COSP: Mie tables option for Quickbem not supported'
      stop
!         ! ----- Mie tables ----
!           mie_table_name='mie_table.dat'
!         call load_mie_table(mie_table_name,y%mt)
!   
!       !   :: D specified by table ... not must match that used when mie LUT generated!
!       y%nsizes = mt_nd
!       allocate(y%D(y%nsizes))
!       y%D = y%mt%D

    else
       ! otherwise we still need to initialize temperature arrays for Ze scaling (which is only done when not using mie table)
       
       cnt_ice=19
       cnt_liq=20
!        if (.not.(allocated(mt_ttl).and.allocated(mt_tti))) then
!           allocate(mt_ttl(cnt_liq),mt_tti(cnt_ice))  ! note needed as this is global array ... 
!                                                      ! which should be changed in the future
!        endif
          
       do i=1,cnt_ice
          mt_tti(i)=(i-1)*5-90
       enddo
    
       do i=1,cnt_liq
          mt_ttl(i)=(i-1)*5 - 60
       enddo 
    
       allocate(y%mt_ttl(cnt_liq),y%mt_tti(cnt_ice))

       y%mt_ttl = mt_ttl
       y%mt_tti = mt_tti

! !------ OLD code in v0.1 ---------------------------
!        allocate(mt_ttl(2),mt_tti(2))
!        allocate(y%mt_ttl(2),y%mt_tti(2))
!        mt_ttl = 0.0
!        mt_tti = 0.0
!        y%mt_ttl = mt_ttl
!        y%mt_tti = mt_tti
! !---------------------------------------------------
       
       ! :: D created on a log-linear scale
       y%nsizes = nd
       delt = (log(dmax)-log(dmin))/(y%nsizes-1)
       deltp = exp(delt)
       allocate(y%D(y%nsizes))
       y%D(1) = dmin
       do i=2,y%nsizes
          y%D(i) = y%D(i-1)*deltp
       enddo   
   
    endif


END SUBROUTINE CONSTRUCT_COSP_GRIDBOX

  
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE FREE_COSP_GRIDBOX -----------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE FREE_COSP_GRIDBOX(y,dglobal)
    type(cosp_gridbox),intent(inout) :: y
    logical,intent(in),optional :: dglobal

    ! --- Free arrays ---
    deallocate(y%D,y%mt_ttl,y%mt_tti)   ! added by roj Feb 2008
!     if (.not.present(dglobal)) deallocate(mt_ttl,mt_tti)
    
!     deallocate(y%hp%p1,y%hp%p2,y%hp%p3,y%hp%dmin,y%hp%dmax,y%hp%apm,y%hp%bpm,y%hp%rho, &
!               y%hp%dtype,y%hp%col,y%hp%cp,y%hp%phase,y%hp%scaled, &
!               y%hp%z_flag,y%hp%Ze_scaled,y%hp%Zr_scaled,y%hp%kr_scaled, &
!               y%hp%fc, y%hp%rho_eff, y%hp%ifc, y%hp%idd)
!     deallocate(y%mt%freq, y%mt%tt, y%mt%f, y%mt%D, y%mt%qext, y%mt%qbsca, y%mt%phase)
    
    deallocate(y%zlev, y%zlev_half, y%dlev, y%p, y%ph, y%T, y%q, &
               y%sh, y%dtau_s, y%dtau_c, y%dem_s, y%dem_c, &
               y%toffset, y%longitude,y%latitude,y%psfc, y%land, y%tca, y%cca, &
               y%mr_hydro, y%dist_prmts_hydro, &
               y%conc_aero, y%dist_type_aero, y%dist_prmts_aero, &
               y%rain_ls, y%rain_cv, y%snow_ls, y%snow_cv, y%grpl_ls, &
               y%sunlit, y%skt, y%sfc_height, y%Reff,y%ichan,y%surfem, &
               y%mr_ozone,y%u_wind,y%v_wind)
 
  END SUBROUTINE FREE_COSP_GRIDBOX
  

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE COSP_GRIDBOX_CPHP ----------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_GRIDBOX_CPHP(x,y)
    type(cosp_gridbox),intent(in) :: x
    type(cosp_gridbox),intent(inout) :: y
    
    integer :: i,j,k,sz(3)
    double precision :: tny
    
    tny = tiny(tny)
    y%hp%p1      = x%hp%p1
    y%hp%p2      = x%hp%p2
    y%hp%p3      = x%hp%p3
    y%hp%dmin    = x%hp%dmin
    y%hp%dmax    = x%hp%dmax
    y%hp%apm     = x%hp%apm
    y%hp%bpm     = x%hp%bpm
    y%hp%rho     = x%hp%rho
    y%hp%dtype   = x%hp%dtype
    y%hp%col     = x%hp%col
    y%hp%cp      = x%hp%cp
    y%hp%phase   = x%hp%phase

    y%hp%fc      = x%hp%fc
    y%hp%rho_eff = x%hp%rho_eff
    y%hp%ifc     = x%hp%ifc
    y%hp%idd     = x%hp%idd
    sz = shape(x%hp%z_flag)
    do k=1,sz(3)
      do j=1,sz(2)
        do i=1,sz(1)
           if (x%hp%scaled(i,k))   y%hp%scaled(i,k)      = .true.
           if (x%hp%z_flag(i,j,k)) y%hp%z_flag(i,j,k)    = .true.
           if (abs(x%hp%Ze_scaled(i,j,k)) > tny) y%hp%Ze_scaled(i,j,k) = x%hp%Ze_scaled(i,j,k)
           if (abs(x%hp%Zr_scaled(i,j,k)) > tny) y%hp%Zr_scaled(i,j,k) = x%hp%Zr_scaled(i,j,k)
           if (abs(x%hp%kr_scaled(i,j,k)) > tny) y%hp%kr_scaled(i,j,k) = x%hp%kr_scaled(i,j,k)
        enddo
      enddo
    enddo
    
END SUBROUTINE COSP_GRIDBOX_CPHP

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE COSP_GRIDBOX_CPSECTION -----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_GRIDBOX_CPSECTION(ix,iy,x,y)
    integer,intent(in),dimension(2) :: ix,iy
    type(cosp_gridbox),intent(in) :: x
    type(cosp_gridbox),intent(inout) :: y
    
    ! --- Copy arrays without Npoints as dimension ---
    y%dist_prmts_hydro = x%dist_prmts_hydro
    y%dist_type_aero   = x%dist_type_aero
    y%D                = x%D
    y%mt_ttl           = x%mt_ttl
    y%mt_tti           = x%mt_tti
    
    
!     call cosp_gridbox_cphp(x,y)    
    
    ! 1D
    y%longitude(iy(1):iy(2))  = x%longitude(ix(1):ix(2))
    y%latitude(iy(1):iy(2))   = x%latitude(ix(1):ix(2))
    y%psfc(iy(1):iy(2))       = x%psfc(ix(1):ix(2))
    y%land(iy(1):iy(2))       = x%land(ix(1):ix(2))
    y%sunlit(iy(1):iy(2))     = x%sunlit(ix(1):ix(2))
    y%skt(iy(1):iy(2))        = x%skt(ix(1):ix(2))
    y%sfc_height(iy(1):iy(2)) = x%sfc_height(ix(1):ix(2))
    y%u_wind(iy(1):iy(2))     = x%u_wind(ix(1):ix(2))
    y%v_wind(iy(1):iy(2))     = x%v_wind(ix(1):ix(2))
    ! 2D
    y%zlev(iy(1):iy(2),:)      = x%zlev(ix(1):ix(2),:)
    y%zlev_half(iy(1):iy(2),:) = x%zlev_half(ix(1):ix(2),:)
    y%dlev(iy(1):iy(2),:)      = x%dlev(ix(1):ix(2),:)
    y%p(iy(1):iy(2),:)         = x%p(ix(1):ix(2),:)
    y%ph(iy(1):iy(2),:)        = x%ph(ix(1):ix(2),:)
    y%T(iy(1):iy(2),:)         = x%T(ix(1):ix(2),:)
    y%q(iy(1):iy(2),:)         = x%q(ix(1):ix(2),:)
    y%sh(iy(1):iy(2),:)        = x%sh(ix(1):ix(2),:)
    y%dtau_s(iy(1):iy(2),:)    = x%dtau_s(ix(1):ix(2),:)
    y%dtau_c(iy(1):iy(2),:)    = x%dtau_c(ix(1):ix(2),:)
    y%dem_s(iy(1):iy(2),:)     = x%dem_s(ix(1):ix(2),:)
    y%dem_c(iy(1):iy(2),:)     = x%dem_c(ix(1):ix(2),:)
    y%tca(iy(1):iy(2),:)       = x%tca(ix(1):ix(2),:)
    y%cca(iy(1):iy(2),:)       = x%cca(ix(1):ix(2),:)
    y%rain_ls(iy(1):iy(2),:)   = x%rain_ls(ix(1):ix(2),:)
    y%rain_cv(iy(1):iy(2),:)   = x%rain_cv(ix(1):ix(2),:)
    y%grpl_ls(iy(1):iy(2),:)   = x%grpl_ls(ix(1):ix(2),:)
    y%snow_ls(iy(1):iy(2),:)   = x%snow_ls(ix(1):ix(2),:)
    y%snow_cv(iy(1):iy(2),:)   = x%snow_cv(ix(1):ix(2),:)
    y%mr_ozone(iy(1):iy(2),:)  = x%mr_ozone(ix(1):ix(2),:)
    ! 3D
    y%Reff(iy(1):iy(2),:,:)      = x%Reff(ix(1):ix(2),:,:)
    y%conc_aero(iy(1):iy(2),:,:) = x%conc_aero(ix(1):ix(2),:,:)
    y%mr_hydro(iy(1):iy(2),:,:)  = x%mr_hydro(ix(1):ix(2),:,:)
    ! 4D
    y%dist_prmts_aero(iy(1):iy(2),:,:,:) = x%dist_prmts_aero(ix(1):ix(2),:,:,:)

END SUBROUTINE COSP_GRIDBOX_CPSECTION
 
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE COSP_SUBGRID_CPSECTION -----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_SUBGRID_CPSECTION(ix,iy,x,y)
    integer,intent(in),dimension(2) :: ix,iy
    type(cosp_subgrid),intent(in) :: x
    type(cosp_subgrid),intent(inout) :: y
    
    y%prec_frac(iy(1):iy(2),:,:)  = x%prec_frac(ix(1):ix(2),:,:)
    y%frac_out(iy(1):iy(2),:,:)   = x%frac_out(ix(1):ix(2),:,:)
END SUBROUTINE COSP_SUBGRID_CPSECTION

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE COSP_SGRADAR_CPSECTION -----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_SGRADAR_CPSECTION(ix,iy,x,y)
    integer,intent(in),dimension(2) :: ix,iy
    type(cosp_sgradar),intent(in) :: x
    type(cosp_sgradar),intent(inout) :: y
    
    y%att_gas(iy(1):iy(2),:)  = x%att_gas(ix(1):ix(2),:)
    y%Ze_tot(iy(1):iy(2),:,:) = x%Ze_tot(ix(1):ix(2),:,:)
END SUBROUTINE COSP_SGRADAR_CPSECTION

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE COSP_SGLIDAR_CPSECTION -----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_SGLIDAR_CPSECTION(ix,iy,x,y)
    integer,intent(in),dimension(2) :: ix,iy
    type(cosp_sglidar),intent(in) :: x
    type(cosp_sglidar),intent(inout) :: y
    
    y%beta_mol(iy(1):iy(2),:)       = x%beta_mol(ix(1):ix(2),:)
    y%beta_tot(iy(1):iy(2),:,:)     = x%beta_tot(ix(1):ix(2),:,:)
    y%tau_tot(iy(1):iy(2),:,:)      = x%tau_tot(ix(1):ix(2),:,:)
    y%refl(iy(1):iy(2),:,:)         = x%refl(ix(1):ix(2),:,:)
END SUBROUTINE COSP_SGLIDAR_CPSECTION

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE COSP_ISCCP_CPSECTION -----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_ISCCP_CPSECTION(ix,iy,x,y)
    integer,intent(in),dimension(2) :: ix,iy
    type(cosp_isccp),intent(in) :: x
    type(cosp_isccp),intent(inout) :: y
            
    y%fq_isccp(iy(1):iy(2),:,:)  = x%fq_isccp(ix(1):ix(2),:,:)
    y%totalcldarea(iy(1):iy(2))  = x%totalcldarea(ix(1):ix(2))
    y%meantb(iy(1):iy(2))        = x%meantb(ix(1):ix(2))
    y%meantbclr(iy(1):iy(2))     = x%meantbclr(ix(1):ix(2))
    y%meanptop(iy(1):iy(2))      = x%meanptop(ix(1):ix(2))
    y%meantaucld(iy(1):iy(2))    = x%meantaucld(ix(1):ix(2))
    y%meanalbedocld(iy(1):iy(2)) = x%meanalbedocld(ix(1):ix(2))
    y%boxtau(iy(1):iy(2),:)      = x%boxtau(ix(1):ix(2),:)
    y%boxptop(iy(1):iy(2),:)     = x%boxptop(ix(1):ix(2),:)
END SUBROUTINE COSP_ISCCP_CPSECTION


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE COSP_MISR_CPSECTION -----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_MISR_CPSECTION(ix,iy,x,y)
    integer,intent(in),dimension(2) :: ix,iy
    type(cosp_misr),intent(in) :: x
    type(cosp_misr),intent(inout) :: y
            
    y%fq_MISR(iy(1):iy(2),:,:)                 = x%fq_MISR(ix(1):ix(2),:,:)
    y%MISR_meanztop(iy(1):iy(2))               = x%MISR_meanztop(ix(1):ix(2))
    y%MISR_cldarea(iy(1):iy(2))                = x%MISR_cldarea(ix(1):ix(2))
    y%MISR_dist_model_layertops(iy(1):iy(2),:) = x%MISR_dist_model_layertops(ix(1):ix(2),:)
END SUBROUTINE COSP_MISR_CPSECTION

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE COSP_RTTOV_CPSECTION -------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_RTTOV_CPSECTION(ix,iy,x,y)
    integer,intent(in),dimension(2) :: ix,iy
    type(cosp_rttov),intent(in) :: x
    type(cosp_rttov),intent(inout) :: y
            
    y%tbs(iy(1):iy(2),:) = x%tbs(ix(1):ix(2),:)
END SUBROUTINE COSP_RTTOV_CPSECTION

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE COSP_RADARSTATS_CPSECTION --------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_RADARSTATS_CPSECTION(ix,iy,x,y)
    integer,intent(in),dimension(2) :: ix,iy
    type(cosp_radarstats),intent(in) :: x
    type(cosp_radarstats),intent(inout) :: y
            
    y%cfad_ze(iy(1):iy(2),:,:)             = x%cfad_ze(ix(1):ix(2),:,:)
    y%radar_lidar_tcc(iy(1):iy(2))         = x%radar_lidar_tcc(ix(1):ix(2))
    y%lidar_only_freq_cloud(iy(1):iy(2),:) = x%lidar_only_freq_cloud(ix(1):ix(2),:)
END SUBROUTINE COSP_RADARSTATS_CPSECTION

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE COSP_LIDARSTATS_CPSECTION --------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_LIDARSTATS_CPSECTION(ix,iy,x,y)
    integer,intent(in),dimension(2) :: ix,iy
    type(cosp_lidarstats),intent(in) :: x
    type(cosp_lidarstats),intent(inout) :: y
            
    y%srbval                     = x%srbval
    y%cfad_sr(iy(1):iy(2),:,:)   = x%cfad_sr(ix(1):ix(2),:,:)
    y%lidarcld(iy(1):iy(2),:)    = x%lidarcld(ix(1):ix(2),:)
    y%cldlayer(iy(1):iy(2),:)    = x%cldlayer(ix(1):ix(2),:)
    y%parasolrefl(iy(1):iy(2),:) = x%parasolrefl(ix(1):ix(2),:)
END SUBROUTINE COSP_LIDARSTATS_CPSECTION
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- PRINT SUBROUTINES --------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_GRIDBOX_PRINT(x)
    type(cosp_gridbox),intent(in) :: x

    print *, '%%%%----- Information on COSP_GRIDBOX ------'
    ! Scalars and dimensions
    print *,  x%Npoints
    print *,  x%Nlevels
    print *,  x%Ncolumns
    print *,  x%Nhydro
    print *,  x%Nprmts_max_hydro
    print *,  x%Naero
    print *,  x%Nprmts_max_aero
    print *,  x%Npoints_it
    
    ! Time [days]
    print *,  x%time
    
    ! Radar ancillary info
    print *,  x%radar_freq, &
            x%k2
    print *,  x%surface_radar, &
           x%use_mie_tables, &
           x%use_gas_abs, &
           x%do_ray, &
           x%melt_lay

!               print *,  'shape(x%): ',shape(x%)
 
!     type(class_param) ::  hp  ! structure used by radar simulator to store Ze and N scaling constants and other information
!     type(mie)::  mt       ! structure used by radar simulator to store mie LUT information
    print *,  x%nsizes
    print *,  'shape(x%D): ',shape(x%D)
    print *,  'shape(x%mt_ttl): ',shape(x%mt_ttl)
    print *,  'shape(x%mt_tti): ',shape(x%mt_tti)
    
    ! Lidar
    print *,  x%lidar_ice_type
    
    ! Radar
    print *,  x%use_precipitation_fluxes
    print *,  x%use_reff
    
    ! Geolocation (Npoints)
    print *,  'shape(x%longitude): ',shape(x%longitude)
    print *,  'shape(x%latitude): ',shape(x%latitude)
    ! Gridbox information (Npoints,Nlevels)
    print *,  'shape(x%zlev): ',shape(x%zlev)
    print *,  'shape(x%zlev_half): ',shape(x%zlev_half)
    print *,  'shape(x%dlev): ',shape(x%dlev)
    print *,  'shape(x%p): ',shape(x%p)
    print *,  'shape(x%ph): ',shape(x%ph)
    print *,  'shape(x%T): ',shape(x%T)
    print *,  'shape(x%q): ',shape(x%q)
    print *,  'shape(x%sh): ',shape(x%sh)
    print *,  'shape(x%dtau_s): ',shape(x%dtau_s)
    print *,  'shape(x%dtau_c): ',shape(x%dtau_c)
    print *,  'shape(x%dem_s): ',shape(x%dem_s)
    print *,  'shape(x%dem_c): ',shape(x%dem_c)
    print *,  'shape(x%mr_ozone): ',shape(x%mr_ozone)

    ! Point information (Npoints)
    print *,  'shape(x%land): ',shape(x%land)
    print *,  'shape(x%psfc): ',shape(x%psfc)
    print *,  'shape(x%sunlit): ',shape(x%sunlit)
    print *,  'shape(x%skt): ',shape(x%skt)
    print *,  'shape(x%sfc_height): ',shape(x%sfc_height)
    print *,  'shape(x%u_wind): ',shape(x%u_wind)
    print *,  'shape(x%v_wind): ',shape(x%v_wind)

    ! TOTAL and CONV cloud fraction for SCOPS
    print *,  'shape(x%tca): ',shape(x%tca)
    print *,  'shape(x%cca): ',shape(x%cca)
    ! Precipitation fluxes on model levels
    print *,  'shape(x%rain_ls): ',shape(x%rain_ls)
    print *,  'shape(x%rain_cv): ',shape(x%rain_cv)
    print *,  'shape(x%snow_ls): ',shape(x%snow_ls)
    print *,  'shape(x%snow_cv): ',shape(x%snow_cv)
    print *,  'shape(x%grpl_ls): ',shape(x%grpl_ls)
    ! Hydrometeors concentration and distribution parameters
    print *,  'shape(x%mr_hydro): ',shape(x%mr_hydro)
    print *,  'shape(x%dist_prmts_hydro): ',shape(x%dist_prmts_hydro)
    ! Effective radius [m]. (Npoints,Nlevels,Nhydro)
    print *,  'shape(x%Reff): ',shape(x%Reff)
    ! Aerosols concentration and distribution parameters
    print *,  'shape(x%conc_aero): ',shape(x%conc_aero)
    print *,  'shape(x%dist_type_aero): ',shape(x%dist_type_aero)
    print *,  'shape(x%dist_prmts_aero): ',shape(x%dist_prmts_aero)
    ! ISCCP simulator inputs
    print *, x%isccp_top_height
    print *, x%isccp_top_height_direction
    print *, x%isccp_overlap
    print *, x%isccp_emsfc_lw
  
    ! RTTOV inputs/options
    print *, x%plat
    print *, x%sat
    print *, x%inst
    print *, x%Nchan
    print *,  'shape(x%Ichan): ',x%Ichan
    print *,  'shape(x%Surfem): ',x%Surfem
    print *, x%ZenAng
    print *, x%co2,x%ch4,x%n2o,x%co
                
END SUBROUTINE COSP_GRIDBOX_PRINT

SUBROUTINE COSP_MISR_PRINT(x)
    type(cosp_misr),intent(in) :: x

    print *, '%%%%----- Information on COSP_MISR ------'
                
     ! Dimensions
    print *, x%Npoints
    print *, x%Ntau
    print *, x%Nlevels

     ! --- (npoints,ntau,nlevels)
     !  the fraction of the model grid box covered by each of the MISR cloud types
     print *,  'shape(x%fq_MISR): ',shape(x%fq_MISR)
     
     ! --- (npoints)
     print *,  'shape(x%MISR_meanztop): ',shape(x%MISR_meanztop)
     print *,  'shape(x%MISR_cldarea): ',shape(x%MISR_cldarea)
     ! --- (npoints,nlevels)
     print *,  'shape(x%MISR_dist_model_layertops): ',shape(x%MISR_dist_model_layertops)
    
END SUBROUTINE COSP_MISR_PRINT

SUBROUTINE COSP_ISCCP_PRINT(x)
    type(cosp_isccp),intent(in) :: x
            
    print *, x%Npoints
    print *, x%Ncolumns
    print *, x%Nlevels

    print *, '%%%%----- Information on COSP_ISCCP ------'
    
     print *, 'shape(x%fq_isccp): ',shape(x%fq_isccp)
     print *, 'shape(x%totalcldarea): ',shape(x%totalcldarea)
     print *, 'shape(x%meantb): ',shape(x%meantb)
     print *, 'shape(x%meantbclr): ',shape(x%meantbclr)
     
     print *, 'shape(x%meanptop): ',shape(x%meanptop)
     print *, 'shape(x%meantaucld): ',shape(x%meantaucld)
     print *, 'shape(x%meanalbedocld): ',shape(x%meanalbedocld)
     print *, 'shape(x%boxtau): ',shape(x%boxtau)
     print *, 'shape(x%boxptop): ',shape(x%boxptop)
END SUBROUTINE COSP_ISCCP_PRINT

SUBROUTINE COSP_VGRID_PRINT(x)
    type(cosp_vgrid),intent(in) :: x
            
    print *, '%%%%----- Information on COSP_VGRID ------'
    print *, x%use_vgrid
    print *, x%csat_vgrid
    print *, x%Npoints
    print *, x%Ncolumns
    print *, x%Nlevels
    print *, x%Nlvgrid
    ! Array with dimensions (Nlvgrid)
    print *, 'shape(x%z): ',shape(x%z)
    print *, 'shape(x%zl): ',shape(x%zl)
    print *, 'shape(x%zu): ',shape(x%zu)
    ! Array with dimensions (Nlevels)
    print *, 'shape(x%mz): ',shape(x%mz)
    print *, 'shape(x%mzl): ',shape(x%mzl)
    print *, 'shape(x%mzu): ',shape(x%mzu)
END SUBROUTINE COSP_VGRID_PRINT

SUBROUTINE COSP_SGLIDAR_PRINT(x)
    type(cosp_sglidar),intent(in) :: x
            
    print *, '%%%%----- Information on COSP_SGLIDAR ------'
    ! Dimensions
    print *, x%Npoints
    print *, x%Ncolumns
    print *, x%Nlevels
    print *, x%Nhydro
    print *, x%Nrefl
    ! Arrays with dimensions (Npoints,Nlevels)
    print *, 'shape(x%beta_mol): ',shape(x%beta_mol)
    ! Arrays with dimensions (Npoints,Ncolumns,Nlevels)
    print *, 'shape(x%beta_tot): ',shape(x%beta_tot)
    print *, 'shape(x%tau_tot): ',shape(x%tau_tot)
    ! Arrays with dimensions (Npoints,Ncolumns,Nrefl)
    print *, 'shape(x%refl): ',shape(x%refl)
END SUBROUTINE COSP_SGLIDAR_PRINT

SUBROUTINE COSP_SGRADAR_PRINT(x)
    type(cosp_sgradar),intent(in) :: x
            
    print *, '%%%%----- Information on COSP_SGRADAR ------'
    print *, x%Npoints
    print *, x%Ncolumns
    print *, x%Nlevels
    print *, x%Nhydro
    ! output vertical levels: spaceborne radar -> from TOA to SURFACE
    ! Arrays with dimensions (Npoints,Nlevels)
    print *, 'shape(x%att_gas): ', shape(x%att_gas)
    ! Arrays with dimensions (Npoints,Ncolumns,Nlevels)
    print *, 'shape(x%Ze_tot): ', shape(x%Ze_tot)
END SUBROUTINE COSP_SGRADAR_PRINT

SUBROUTINE COSP_RADARSTATS_PRINT(x)
    type(cosp_radarstats),intent(in) :: x
            
    print *, '%%%%----- Information on COSP_SGRADAR ------'
    print *, x%Npoints
    print *, x%Ncolumns
    print *, x%Nlevels
    print *, x%Nhydro
    print *, 'shape(x%cfad_ze): ',shape(x%cfad_ze)
    print *, 'shape(x%radar_lidar_tcc): ',shape(x%radar_lidar_tcc)
    print *, 'shape(x%lidar_only_freq_cloud): ',shape(x%lidar_only_freq_cloud)
END SUBROUTINE COSP_RADARSTATS_PRINT

SUBROUTINE COSP_LIDARSTATS_PRINT(x)
    type(cosp_lidarstats),intent(in) :: x
            
    print *, '%%%%----- Information on COSP_SGLIDAR ------'
    print *, x%Npoints
    print *, x%Ncolumns
    print *, x%Nlevels
    print *, x%Nhydro
    print *, x%Nrefl
    
    ! Arrays with dimensions (SR_BINS)
    print *, 'shape(x%srbval): ',shape(x%srbval)
    ! Arrays with dimensions (Npoints,SR_BINS,Nlevels)
    print *, 'shape(x%cfad_sr): ',shape(x%cfad_sr)
    ! Arrays with dimensions (Npoints,Nlevels)
    print *, 'shape(x%lidarcld): ',shape(x%lidarcld)
    ! Arrays with dimensions (Npoints,LIDAR_NCAT)
    print *, 'shape(x%cldlayer): ',shape(x%cldlayer)
    ! Arrays with dimensions (Npoints,PARASOL_NREFL)
    print *, 'shape(x%parasolrefl): ',shape(x%parasolrefl)
END SUBROUTINE COSP_LIDARSTATS_PRINT

SUBROUTINE COSP_SUBGRID_PRINT(x)
    type(cosp_subgrid),intent(in) :: x
            
    print *, '%%%%----- Information on COSP_SUBGRID ------'
    print *, x%Npoints
    print *, x%Ncolumns
    print *, x%Nlevels
    print *, x%Nhydro
    
    print *, 'shape(x%prec_frac): ',shape(x%prec_frac)
    print *, 'shape(x%frac_out): ',shape(x%frac_out)
END SUBROUTINE COSP_SUBGRID_PRINT

SUBROUTINE COSP_SGHYDRO_PRINT(x)
    type(cosp_sghydro),intent(in) :: x
            
    print *, '%%%%----- Information on COSP_SGHYDRO ------'
    print *, x%Npoints
    print *, x%Ncolumns
    print *, x%Nlevels
    print *, x%Nhydro
    
    print *, 'shape(x%mr_hydro): ',shape(x%mr_hydro)
    print *, 'shape(x%Reff): ',shape(x%Reff)
END SUBROUTINE COSP_SGHYDRO_PRINT

END MODULE MOD_COSP_TYPES

MODULE CONV_UTILITIES_MOD
  
use      Constants_Mod, ONLY:   tfreeze, HLv, HLf, HLs, CP_AIR, GRAV, &
                                Kappa,rdgas,rvgas
use fms_mod,            only:   mpp_pe, mpp_root_pe
use conv_utilities_k_mod, only: uw_params_init_k, uw_params
! use conv_utilities_k_mod, only: sd_init_k, sd_copy_k, sd_end_k, &
!                                 ac_init_k, ac_clear_k, ac_end_k, &
!                                 uw_params_init_k, uw_params, &
!                                 pack_sd_k, extend_sd_k, adi_cloud_k,&
!                                 qsat_k, qses_k, exn_k, conden_k, &
!                                 findt_k,                      &
!                                 pack_sd_lsm_k, sounding, adicloud

!---------------------------------------------------------------------
  implicit none
  private

!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------

  character(len=128) :: version = '$Id: conv_utilities.F90,v 17.0 2009/07/21 02:58:03 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

!---------------------------------------------------------------------
!-------  interfaces --------

! public  :: sd_init, sd_copy, sd_end, ac_init, ac_clear, ac_end, qsat, qses, exn, &
  public  ::   &
       uw_params_init
!      uw_params_init, &
!      conden, findt, pack_sd, pack_sd_lsm, extend_sd, adi_cloud

  real, parameter :: p00   = 1.E5
  real, parameter :: epsilo= rdgas/rvgas      !ratio of h2o to dry air molecular weights 
  real, parameter :: zvir  = rvgas/rdgas - 1. !rh2o/rair - 1
  real, parameter :: tkmin = -160 + tfreeze   ! tcmin from sat_vapor_pres.f90
  real, parameter :: tkmax =  100 + tfreeze   ! tcmax from sat_vapor_pres.f90

  character(len=7) :: mod_name = 'conv_utilities'

contains

!#####################################################################
!#####################################################################

  subroutine uw_params_init (Uw_p)

  type(uw_params), intent(inout) :: Uw_p
  
    integer :: me, root_pe
    
    me = mpp_pe()
    root_pe = mpp_root_pe()
    call uw_params_init_k (hlv, hls, hlf, cp_air, grav, kappa, rdgas, &
                           p00, epsilo, zvir, tkmin, tkmax, me,  &
                                                           root_pe,Uw_p)
    
  end subroutine uw_params_init

!#####################################################################
!#####################################################################



end MODULE CONV_UTILITIES_MOD

module static_vegn_mod

#include "../shared/concat.inc"

use constants_mod,      only : pi
use mpp_mod,            only : mpp_max, mpp_sum
use time_manager_mod,   only : time_type, set_date, time_type_to_real, &
     get_calendar_type, valid_calendar_types, operator(-), get_date
use get_cal_time_mod,   only : get_cal_time

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod,            only : write_version_number, error_mesg, FATAL, NOTE, &
     mpp_pe, file_exist, close_file, check_nml_error, stdlog, &
     mpp_root_pe, get_mosaic_tile_file, fms_error_handler
use time_interp_mod,    only : time_interp
use diag_manager_mod,   only : get_base_date

use nf_utils_mod,       only : nfu_inq_dim, nfu_get_dim, nfu_def_dim, &
     nfu_inq_compressed_var, nfu_get_compressed_rec, nfu_validtype, &
     nfu_get_valid_range, nfu_is_valid, nfu_put_rec, nfu_put_att
use land_data_mod,      only : lnd
use land_io_mod,        only : print_netcdf_error
use land_numerics_mod,  only : nearest
use land_tile_io_mod,   only : create_tile_out_file,sync_nc_files
use land_tile_mod,      only : land_tile_type, land_tile_enum_type, first_elmt, &
     tail_elmt, next_elmt, current_tile, operator(/=), nitems
use vegn_cohort_mod,    only : vegn_cohort_type
use cohort_io_mod,      only : create_cohort_dimension, &
     write_cohort_data_i0d_fptr, write_cohort_data_r0d_fptr


implicit none
private

! ==== public interface =====================================================
public :: read_static_vegn_namelist
public :: static_vegn_init
public :: static_vegn_end

public :: read_static_vegn
public :: write_static_vegn
! ==== end of public interface ==============================================

! ==== module constants =====================================================
character(len=*), parameter :: &
     module_name = 'static_vegn_mod', &
     version     = '$Id: vegn_static_override.F90,v 20.0 2013/12/13 23:31:17 fms Exp $', &
     tagname     = '$Name: tikal $'

! ==== module data ==========================================================
logical :: module_is_initialized = .FALSE.
integer :: ncid  ! netcdf id of the input file
integer :: ncid2 ! netcdf id of the output file
type(time_type),allocatable :: time_line(:) ! time line of input data
type(time_type)             :: ts,te        ! beginning and end of time interval
integer, allocatable :: map_i(:,:), map_j(:,:)! remapping arrays: for each of the
     ! land grid cells in current domain they hold indices of corresponding points 
     ! in the input grid.
type(time_type) :: base_time ! model base time for static vegetation output

! ---- namelist variables ---------------------------------------------------
logical :: use_static_veg = .FALSE.
character(len=512) :: input_file = & ! name of input file for static vegetation
     "INPUT/static_veg_data.nc"
character(len=10)  :: timeline   = 'normal' ! type of timeline ('normal' or 'loop')
integer, dimension(6) :: &
     start_loop = (/1,1,1,0,0,0/), & ! beginning of the time loop
     end_loop   = (/1,1,1,0,0,0/)    ! end of the time loop
logical :: fill_land_mask = .FALSE. ! if true, all the vegetation points on the
     ! map are filled with the information from static vegetation data, using
     ! nearest point remap; otherwise only the points that overlap with valid
     ! static vegetation data are overridden.
logical :: write_static_veg = .FALSE. ! if true, the state of vegetation is saved 
     ! periodically for future use as static vegetation input
character(16) :: static_veg_freq = 'daily' ! or 'monthly', or 'annual'
     ! specifies the frequency for writing the static vegetation data file
namelist/static_veg_nml/use_static_veg,input_file,timeline,start_loop,end_loop,&
     fill_land_mask, write_static_veg, static_veg_freq

! ==== NetCDF declarations ==================================================
include 'netcdf.inc'
#define __NF_ASRT__(x) call print_netcdf_error((x),__FILE__,__LINE__)

contains

! ===========================================================================
subroutine read_static_vegn_namelist(static_veg_used)
  logical, intent(out) :: static_veg_used

  ! ---- local vars
  integer :: unit, ierr, io

  call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=static_veg_nml, iostat=io)
  ierr = check_nml_error(io, 'static_veg_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file ( )
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=static_veg_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'static_veg_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif
  
  if (mpp_pe() == mpp_root_pe()) then
     unit=stdlog()
     write(unit, nml=static_veg_nml)
  endif

  if (    (trim(static_veg_freq)=='daily') &
      .or.(trim(static_veg_freq)=='monthly') &
      .or.(trim(static_veg_freq)=='annual') ) then
     ! static_veg_freq is OK -- do nothing
  else
     call error_mesg('static_vegn_init','option static_veg_freq="'&
          //trim(static_veg_freq)&
          //'" is invalid, use "daily", "monthly", or "annual"', FATAL)
  endif

  static_veg_used = use_static_veg
end subroutine read_static_vegn_namelist


! ===========================================================================
subroutine static_vegn_init()

  ! ---- local vars
  integer :: unlimdim, timelen, timeid
  integer :: i,j,k,iret
  character(len=NF_MAX_NAME) :: dimname  ! name of the dimension variable : time, lon, and lat
  integer                    :: ndims    ! rank of input vars
  integer                    :: dimids (NF_MAX_VAR_DIMS) ! netcdf IDs of input var dimensions
  integer                    :: dimlens(NF_MAX_VAR_DIMS) ! sizes of respective dimensions
  real, allocatable          :: t(:)     ! temporary real timeline
  character(len=256)         :: units    ! units of time in the file
  character(len=256)         :: calendar ! calendar of the data
  real, allocatable          :: in_lon(:)! longitude coordinates in input file
  real, allocatable          :: in_lat(:)! latitude coordinates in input file
  logical, allocatable       :: mask(:,:)! mask of valid points in input data 
  integer, allocatable       :: data(:,:,:,:) ! temporary array used to calculate the mask of
                                         ! valid input data
  logical                    :: has_records ! true if input variable has records
  integer :: tile_dim_length ! length of tile dimension in output files 
                             ! global max of number of tiles per gridcell
  integer :: year, month, day, hour, minute, sec ! components of base date
  character(len=1024) :: actual_input_file
  logical :: input_is_multiface ! TRUE if the input files are face-specific

  if(module_is_initialized) return


  if(use_static_veg) then

     ! SET UP LOOP BOUNDARIES
     ts = set_date(start_loop(1),start_loop(2),start_loop(3), start_loop(4),start_loop(5),start_loop(6))
     te = set_date(end_loop(1)  ,end_loop(2)  ,end_loop(3)  , end_loop(4)  ,end_loop(5)  ,end_loop(6)  )
     
     ! OPEN INPUT FILE
     if (nf_open(input_file,NF_NOWRITE,ncid)/=NF_NOERR) then
        if(lnd%nfaces==1) then
           ! for 1-face grid we can't use multi-face input, even if it exists
           call error_mesg('static_vegn_init','input file "'//trim(input_file)&
                   //'" does not exist', FATAL)
        else
           ! if there's more then one face, try opening face-specific input
           call get_mosaic_tile_file(trim(input_file),actual_input_file,.FALSE.,lnd%domain)
           if (nf_open(actual_input_file,NF_NOWRITE,ncid)/=NF_NOERR) then
              call error_mesg('static_vegn_init','Neither "'//trim(input_file)&
                   //'" nor "'//trim(actual_input_file)//'" files exist', FATAL)
           else
              call error_mesg('static_vegn_init','Reading face-specific vegetation file "'&
                   //trim(actual_input_file)//'"', NOTE)
              input_is_multiface = .TRUE.
           endif
        endif
     else
        call error_mesg('static_vegn_init','Reading global static vegetation file "'&
             //trim(input_file)//'"', NOTE)
        input_is_multiface = .FALSE.
        actual_input_file = input_file
     endif
     
     ! READ TIME AXIS DATA
     if(nf_inq_unlimdim( ncid, unlimdim )/=NF_NOERR) then
        call error_mesg('static_vegn_init',&
            'Input file "'//trim(actual_input_file)//'" lacks record dimension.', FATAL)
     endif 
     __NF_ASRT__(nf_inq_dimname ( ncid, unlimdim, dimname ))
     __NF_ASRT__(nf_inq_varid   ( ncid, dimname, timeid ))
     __NF_ASRT__(nf_inq_dimlen( ncid, unlimdim, timelen ))
     allocate (time_line(timelen), t(timelen))
     __NF_ASRT__(nf_get_var_double (ncid, timeid, t ))
     
     ! GET UNITS OF THE TIME
     units = ' '
     if (nf_get_att_text(ncid, timeid,'units',units)/=NF_NOERR) then
        call error_mesg('static_vegn_init',&
            'Cannot read time  units from file "'//trim(actual_input_file)//'"', FATAL)
     endif
     
     ! GET CALENDAR OF THE DATA
     calendar = ' '
     iret = nf_get_att_text(ncid, timeid, 'calendar',calendar)
     if(iret/=NF_NOERR) &
          iret = nf_get_att_text(ncid, timeid,'calendar_type',calendar)
     if(iret/=NF_NOERR) &
          calendar='JULIAN' ! use model calendar? how to get the name of the model calendar?
       
     ! CONVERT TIME TO THE FMS TIME_TYPE AND STORE IT IN THE TIMELINE FOR THE
     ! DATA SET
     do i = 1, size(t)
        ! set the respective value in the timeline
        time_line(i) = get_cal_time(t(i),units,calendar)
     enddo

     ! READ HORIZONTAL COORDINATES
     iret = nfu_inq_compressed_var(ncid,'species',ndims=ndims,dimids=dimids,dimlens=dimlens,&
          has_records=has_records)
     if (iret/=NF_NOERR) then
        call error_mesg('static_vegn_init',&
            'Cannot read compression information from file "'//trim(actual_input_file)//&
            '": check that all dimensions listed in "compress" attributes are present in the file.', FATAL)
     endif
     __NF_ASRT__(iret)
     allocate(in_lon(dimlens(1)),in_lat(dimlens(2)))
     __NF_ASRT__(nfu_get_dim(ncid,dimids(1),in_lon)) ! get longitude
     __NF_ASRT__(nfu_get_dim(ncid,dimids(2),in_lat)) ! get latitude
     in_lon = in_lon*PI/180.0 ; in_lat = in_lat*PI/180.0

     ! COMPUTE INDEX REMAPPING ARRAY
     allocate(map_i(lnd%is:lnd%ie,lnd%js:lnd%je))
     allocate(map_j(lnd%is:lnd%ie,lnd%js:lnd%je))
     allocate(mask(size(in_lon),size(in_lat)))

     map_i = -1
     map_j = -1
     mask = .false.

     if(fill_land_mask) then
        ! CALCULATE THE DIMENSIONS OF THE BUFFER FOR THE INPUT DATA
        if (has_records) ndims=ndims-1
        do i = ndims+1,4
           dimlens(i) = 1
        enddo
        ! READ THE FIRST RECORD AND CALCULATE THE MASK OF THE VALID INPUT DATA
        allocate(data(dimlens(1),dimlens(2),dimlens(3),dimlens(4)))
        !             lon        lat        tile       cohort
        data(:,:,:,:) = -1
        __NF_ASRT__(nfu_get_compressed_rec(ncid,'species',1,data))
        do j = 1,size(data,2)
        do i = 1,size(data,1)
           mask(i,j) = any(data(i,j,:,:)>=0)
        enddo
        enddo
        deallocate(data)
     else
        mask(:,:) = .TRUE.
     endif

     if(input_is_multiface) then
        ! check that the sizes of input data and the model data are the same
        if(dimlens(1)/=lnd%nlon.or.dimlens(2)/=lnd%nlat) then
           call error_mesg('static_vegn_init','size of face-specific static vegetation '&
                //'data isn''t the same as the size of the mosaic face', FATAL)
        endif
        ! in case of multi-face input, we don't do any remapping
        do j = lnd%js,lnd%je
        do i = lnd%is,lnd%ie
           map_i(i,j) = i; map_j(i,j) = j
        enddo
        enddo
     else
        ! do the nearest-point remapping
        do j = lnd%js,lnd%je
        do i = lnd%is,lnd%ie
           call nearest(mask,in_lon,in_lat,lnd%lon(i,j),lnd%lat(i,j),map_i(i,j),map_j(i,j))
        enddo
        enddo
     endif

     deallocate (in_lon,in_lat,mask)
     deallocate(t)
  endif

  if(write_static_veg) then
     ! create output file for static vegetation

     ! count all land tiles and determine the length of tile dimension
     ! sufficient for the current domain
     tile_dim_length = 0
     do j = lnd%js, lnd%je
     do i = lnd%is, lnd%ie
        k = nitems(lnd%tile_map(i,j))
        tile_dim_length = max(tile_dim_length,k)
     enddo
     enddo
   
     ! [1.1] calculate the tile dimension length by taking the max across all domains
     call mpp_max(tile_dim_length)

     call create_tile_out_file(ncid2,'static_veg_out.nc', &
          lnd%coord_glon, lnd%coord_glat, vegn_tile_exists, tile_dim_length)
     ! create compressed dimension for vegetation cohorts
     call create_cohort_dimension(ncid2)
     ! get the base date of the simulation
     call get_base_date(year,month,day,hour,minute,sec)
     base_time = set_date(year, month, day, hour, minute, sec)
     if(mpp_pe()==lnd%io_pelist(1)) then
        ! create time axis, on root IO processors only
        units = ' '
        write(units, 11) year, month, day, hour, minute, sec
11      format('days since ', i4.4, '-', i2.2, '-', i2.2, ' ', i2.2, ':', i2.2, ':', i2.2)
        __NF_ASRT__(nfu_def_dim(ncid2,'time',NF_UNLIMITED,NF_DOUBLE,units=trim(units)))
        ! add calendar attribute to the time axis
        iret=nfu_put_att(ncid2,'time','calendar',&
             trim(valid_calendar_types(get_calendar_type())))
        __NF_ASRT__(iret)
     endif
     call sync_nc_files(ncid2)
  endif
  module_is_initialized = .true.

end subroutine static_vegn_init

! ===========================================================================
subroutine static_vegn_end()
  if(use_static_veg) then
     __NF_ASRT__(nf_close(ncid))
     deallocate(time_line,map_i,map_j)
  endif
  if(write_static_veg) then
     __NF_ASRT__(nf_close(ncid2))
  endif
  module_is_initialized = .false.
end subroutine static_vegn_end

! ===========================================================================
subroutine read_static_vegn (time, err_msg)
  type(time_type), intent(in)    :: time
  character(len=*), intent(out), optional :: err_msg

  ! ---- local vars 
  integer :: index1, index2 ! result of time interpolation (only index1 is used)
  real    :: weight         ! another result of time interp, not used
  character(len=256) :: msg

  if(.not.use_static_veg)return;

  msg = ''
  !   time_interp to find out the index of the current time interval
  if (timeline == 'loop') then
     call time_interp(time, ts, te, time_line, weight, index1, index2, &
                      correct_leap_year_inconsistency=.true., err_msg=msg)
  else if (timeline == 'normal') then
     call time_interp(time, time_line, weight, index1, index2, err_msg=msg)
  else
     call error_mesg(module_name,'timeline option "'//trim(timeline)// &
          '" is incorrect, use "normal" or "loop"', FATAL)
  endif
  if(msg /= '') then
    if(fms_error_handler('read_static_vegn','Message from time_interp: '//trim(msg),err_msg)) return
  endif

  ! read the data into cohort variables
  call read_remap_cohort_data_i0d_fptr(ncid, 'species' , cohort_species_ptr , map_i, map_j, index1)
  call read_remap_cohort_data_r0d_fptr(ncid, 'bl'      , cohort_bl_ptr      , map_i, map_j, index1)
  call read_remap_cohort_data_r0d_fptr(ncid, 'blv'     , cohort_blv_ptr     , map_i, map_j, index1)
  call read_remap_cohort_data_r0d_fptr(ncid, 'br'      , cohort_br_ptr      , map_i, map_j, index1)
  call read_remap_cohort_data_r0d_fptr(ncid, 'bsw'     , cohort_bsw_ptr     , map_i, map_j, index1)
  call read_remap_cohort_data_r0d_fptr(ncid, 'bwood'   , cohort_bwood_ptr   , map_i, map_j, index1)
  call read_remap_cohort_data_r0d_fptr(ncid, 'bliving' , cohort_bliving_ptr , map_i, map_j, index1)
  call read_remap_cohort_data_i0d_fptr(ncid, 'status'  , cohort_status_ptr  , map_i, map_j, index1)

  ! derived variables will be updated in update_land_bc_fast
end subroutine read_static_vegn


! ===========================================================================
subroutine write_static_vegn()

  real :: t ! time in output units
  integer :: rec ! number of record to write
  ! components of the date
  integer :: second, minute, hour, day0, day1, month0, month1, year0, year1

  if(.not.write_static_veg) return;

  ! get components of calendar dates for this and previous time step
  call get_date(lnd%time,             year0,month0,day0,hour,minute,second)
  call get_date(lnd%time-lnd%dt_fast, year1,month1,day1,hour,minute,second)

  if (     (trim(static_veg_freq)=='daily'  .and.  day1/=day0)   &
       .or.(trim(static_veg_freq)=='monthly'.and.month1/=month0) &
       .or.(trim(static_veg_freq)=='annual' .and. year1/=year0) )&
       then
     ! sync output files with the disk so that every processor sees the same 
     ! information, number of records being critical here
     call sync_nc_files(ncid2)
     ! get the current number of records in the output file
     __NF_ASRT__(nfu_inq_dim(ncid2,'time',rec))
     rec = rec+1
     ! create new record in the output file and store current value of time
     if(mpp_pe()==lnd%io_pelist(1)) then
        t = (time_type_to_real(lnd%time)-time_type_to_real(base_time))/86400
        __NF_ASRT__(nfu_put_rec(ncid2,'time',rec,t))
     endif
     ! write static vegetation data
     call write_cohort_data_i0d_fptr(ncid2,'species', cohort_species_ptr, &
          'vegetation species',record=rec)
     call write_cohort_data_r0d_fptr(ncid2,'bl',      cohort_bl_ptr, &
          'biomass of leaves per individual','kg C/m2', record=rec)
     call write_cohort_data_r0d_fptr(ncid2,'blv',     cohort_blv_ptr, &
          'biomass of virtual leaves (labile store) per individual','kg C/m2',record=rec)
     call write_cohort_data_r0d_fptr(ncid2,'br',      cohort_br_ptr, &
          'biomass of fine roots per individual','kg C/m2', record=rec)
     call write_cohort_data_r0d_fptr(ncid2,'bsw',     cohort_bsw_ptr, &
          'biomass of sapwood per individual','kg C/m2', record=rec)
     call write_cohort_data_r0d_fptr(ncid2,'bwood',   cohort_bwood_ptr, &
          'biomass of heartwood per individual','kg C/m2', record=rec)
     call write_cohort_data_r0d_fptr(ncid2,'bliving', cohort_bliving_ptr, &
          'total living biomass per individual','kg C/m2', record=rec)
     call write_cohort_data_i0d_fptr(ncid2,'status',  cohort_status_ptr, &
          'leaf status', record=rec)
  endif
end subroutine write_static_vegn


! ============================================================================
#define F90_TYPE       integer
#define READ_REMAP_SUB read_remap_cohort_data_i0d_fptr
#include "read_remap_cohort_data.inc"

#define F90_TYPE       real
#define READ_REMAP_SUB read_remap_cohort_data_r0d_fptr
#include "read_remap_cohort_data.inc"

! ============================================================================
! tile existence detector: returns a logical value indicating wether component
! model tile exists or not
logical function vegn_tile_exists(tile)
   type(land_tile_type), pointer :: tile
   vegn_tile_exists = associated(tile%vegn)
end function vegn_tile_exists

! ============================================================================
! cohort accessor functions: given a pointer to cohort, return a pointer to a
! specific member of the cohort structure
#define DEFINE_COHORT_ACCESSOR(xtype,x) subroutine CONCAT3(cohort_,x,_ptr(c,p));\
type(vegn_cohort_type),pointer::c;xtype,pointer::p;p=>NULL();if(associated(c))p=>c%x;\
end subroutine

DEFINE_COHORT_ACCESSOR(integer,species)
DEFINE_COHORT_ACCESSOR(real,bl)
DEFINE_COHORT_ACCESSOR(real,br)
DEFINE_COHORT_ACCESSOR(real,blv)
DEFINE_COHORT_ACCESSOR(real,bsw)
DEFINE_COHORT_ACCESSOR(real,bwood)
DEFINE_COHORT_ACCESSOR(real,bliving)
DEFINE_COHORT_ACCESSOR(integer,status)

end module static_vegn_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: Flux Richardson number stability function\label{sec:rf}
!
! !INTERFACE:
   subroutine cmue_rf(nlev)
!
! !DESCRIPTION:
! In the ISPRAMIX ocean model (see \cite{EiflerSchrimpf92}),
! another approach is used
! for considering stability effects on vertical mixing.
! The stability functions in this model are of the form:
! \begin{equation}
! c_{\mu}=\mbox{const}=0.5,
! \end{equation}
! \begin{equation}\label{ISPRAcmues}
! c'_{\mu}=c_{\mu} f(R_f)=c_{\mu} \frac{1}{P_r^0}(1-R_f)^{1/2}.
! \end{equation}
!
! The neutral Prandtl number used there is $P_r^0=0.7143$.
! The function $f(R_f)$ is assumed to
! lay between the values 0.18 (corresponding to a supercritically
! stratified situation) and 2.0 (preventing it from growing too much under
! unstable conditions).
!
! A formulation for $(1-R_f)$ can be derived from the definition of the flux
! Richardson number
!
! \begin{equation}
! R_f=\frac{c'_{\mu}}{c_{\mu}}R_i
! \end{equation}
!
! and \eq{ISPRAcmues}, see \cite{Beckers95}:
!
! \begin{equation}
! (1-R_f)=[(\tilde R_i^2+1)^{1/2}-\tilde R_i]^2
! \end{equation}
!
! with
! \begin{equation}
! \tilde R_i=\frac{0.5}{P_r^0} R_i
! \end{equation}
!
! where $R_i$ is the gradient Richardson number.
!
! !USES:
   use turbulence, only: cm0_fix,Prandtl0_fix,xRF
   use turbulence, only: cmue1,cmue2,an,as
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: nlev
!
! !REVISION HISTORY:
!  Original author(s):  Manuel Ruiz Villarreal, Hans Burchard
!
!  $Log: cmue_rf.F90,v $
!  Revision 20.0  2013/12/14 00:13:33  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.8  2005-11-15 11:35:02  lars
!  documentation finish for print
!
!  Revision 1.7  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.6  2004/08/18 12:53:07  lars
!  updated documentation
!
!  Revision 1.5  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.4  2003/03/28 08:37:27  kbk
!  removed tabs
!
!  Revision 1.3  2003/03/10 09:02:04  gotm
!  Added new Generic Turbulence Model +
!  improved documentation and cleaned up code
!
!  Revision 1.2  2002/02/08 08:59:58  gotm

!  Revision 1.1.1.1  2001/02/12 15:55:58  gotm
!  initial import into CVS
!
!EOP
!
! !LOCAL VARIABLES:
   integer                   :: i
   REALTYPE                  :: Ri,Prandtl_inv
!
!-----------------------------------------------------------------------
!BOC
!  Calculation of xRf=(1-Rf), where Rf is the flux Richardson number
   do i=1,nlev-1
      Ri=0.5/Prandtl0_fix*an(i)/(as(i)+1e-8)
      xRf(i)=(sqrt(Ri*Ri+1)-Ri)**2
      if (xRf(i) .gt. 2.) xRf(i)=2.
      Prandtl_inv=1/Prandtl0_fix*sqrt(xRf(i))

      if (Prandtl_inv.lt.0.18) Prandtl_inv=0.18
      if (Prandtl_inv.gt.2.0)  Prandtl_inv=2.0

      cmue1(i)=cm0_fix
      cmue2(i)=cm0_fix*Prandtl_inv
   end do
   return
   end subroutine cmue_rf
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module oda_types_mod
#ifndef MAX_LEVS_FILE_
#define MAX_LEVS_FILE_ 50
#endif

#ifndef MAX_LINKS_
#define MAX_LINKS_ 100
#endif

!============================================================
! This module contains type declarations and default values
! for oda modules.  
!============================================================
  
! Contact: Matthew.Harrison@gfdl.noaa.gov

  use time_manager_mod, only : time_type, set_time
  use mpp_mod, only : stdout
  use mpp_domains_mod, only : domain2d
  
  implicit none

  private

  integer, parameter, public :: MAX_LEVELS_FILE = MAX_LEVS_FILE_ !< Controls record length for optimal storage  
  integer, parameter, public :: MAX_NEIGHBORS = 100 !< Maximum number of neighbors for QC or analysis for profiles
  integer, parameter, public :: MAX_LINKS = MAX_LINKS_ !< Maximum number of records per profile for storage for profiles  

  ! Additional Pramaeters needed for snz's ECDA
  integer, parameter, public :: DROP_PROFILER = 10
  integer, parameter, public :: MOORING = 20
  integer, parameter, public :: SATELLITE = 30
  integer, parameter, public :: DRIFTER = 40
  integer, parameter, public :: SHIP = 50
  integer, parameter, public :: UNKNOWN = 0
  integer, parameter, public :: TAO = 1 !< moorings
  integer, parameter, public :: PIRATA = 2 !< moorings
  integer, parameter, public :: XBT = 1 !< station measurements
  integer, parameter, public :: CTD = 2 !< station measurements
  integer, parameter, public :: MBT = 3 !< station measurements
  integer, parameter, public :: ARGO = 1

  ! Codes for modeling error disttributions
  integer, parameter, public :: COSSQ_LAT = 10

  integer, save, public :: TEMP_ID = 1
  integer, save, public :: SALT_ID = 2

  ! List of variables for ODA   
#ifndef ENABLE_ECDA
  real, parameter, public :: MISSING_VALUE = -1.e20
#else
  !::sdu:: ECDA oda files need this value to different
  real, parameter, public :: MISSING_VALUE = -1.e10
#endif

  type, public :: forward_model_type
     real, dimension(:,:,:,:), pointer :: wgt ! interpolation weights
  end type forward_model_type
  
  type, public :: ocean_profile_type
     integer :: variable !< variable ids are defined by the ocean_types module (e.g. TEMP_ID, SALT_ID)
     integer :: inst_type !< instrument types are defined by platform class (e.g. MOORING, DROP, etc.) and instrument type (XBT, CDT, etc.)
     integer :: nvar
     real    :: project ! e.g. FGGE, COARE, ACCE, ...
     real    :: probe ! MBT, XBT, drifting buoy
     real    :: ref_inst ! instrument (thermograph, hull sensor, ...)
     integer :: wod_cast_num
     real    :: fix_depth
     real    :: ocn_vehicle
     real    :: database_id
     integer :: levels
     integer :: profile_flag ! an overall flag for the profile
     integer :: profile_flag_s ! an overall flag for the profile salinity     
     real :: lat, lon
     logical :: accepted
     integer :: nlinks
     type(ocean_profile_type), pointer, dimension(:) :: next ! Large profiles are stored as linked list.
     integer, dimension(MAX_NEIGHBORS) :: nbr_index
     real, dimension(MAX_NEIGHBORS) :: nbr_dist ! distance in radians 
     real, dimension(:), pointer :: depth, data_t, data_s
     real, dimension(:), pointer :: data
     integer, dimension(:), pointer :: flag_t
     integer, dimension(:), pointer :: flag_s ! level-by-level flags for salinity
     logical, dimension(:), pointer :: flag
     real    :: temp_err, salt_err ! measurement error
     real, dimension(:), pointer :: ms_t ! ms temperature by level
     real, dimension(:), pointer :: ms_s ! ms salinity by level  
     real, dimension(:), pointer :: ms_inv
     real, dimension(:), pointer :: ms
     type(time_type) :: time 
     integer         :: yyyy
     integer         :: mmdd
     type(time_type), pointer :: Model_time ! each profile can be associated with a first-guess field with an associated time and grid
     type(grid_type), pointer :: Model_grid
     real :: i_index, j_index ! model longitude and latitude indices respectively
     real, dimension(:), pointer :: k_index ! model depth indices
     type(forward_model_type) :: Forward_model  ! linear operation from model to observation
     type(time_type) :: tdiff      ! positive difference between model time and observation time
  end type ocean_profile_type

  type, public :: ocean_surface_type
     integer :: variable  ! variable ids are defined by the ocean_types module (e.g. TEMP_ID, SALT_ID, ...)
     integer :: inst_type  ! instrument types are defined by platform class (e.g. MOORING, DROP) and instrument type (XBT, CTD, ...)
     integer :: qc_flag, nobs
     logical :: is_gridded
     integer :: nlon, nlat
     real, pointer, dimension(:) :: lat=>NULL(), lon=>NULL()
     logical :: accepted
     real, pointer, dimension(:) :: data => NULL()
     real, dimension(:), pointer :: ms_inv => NULL()
     real, dimension(:), pointer :: ms => NULL()
     real, dimension(:), pointer :: i_index=>NULL(), j_index=>NULL() ! model indices
     real, pointer, dimension(:,:) :: data2 => NULL()
     real, dimension(:,:), pointer :: ms2 => NULL()
     real, dimension(:,:), pointer :: i_index2=>NULL(), j_index2=>NULL() ! model indices
     real :: k_index          
     type(forward_model_type) :: Forward_model
     type(time_type) :: time
     integer :: yyyy
     integer :: mmdd
     character(len=8) :: wmo_id
     type(time_type), pointer :: Model_time => NULL()
     type(grid_type), pointer :: Model_grid => NULL()
     ! positive difference between current model time 
     ! and observation time
     type(time_type) :: tdiff
  end type ocean_surface_type

  type, public :: da_flux_type
     real, pointer, dimension(:,:) :: u_flux => NULL()
     real, pointer, dimension(:,:) :: v_flux => NULL()
     real, pointer, dimension(:,:) :: t_flux => NULL()
     real, pointer, dimension(:,:) :: q_flux => NULL()
     real, pointer, dimension(:,:) :: salt_flux => NULL()
     real, pointer, dimension(:,:) :: lw_flux => NULL()
     real, pointer, dimension(:,:) :: sw_flux_vis_dir => NULL()
     real, pointer, dimension(:,:) :: sw_flux_vis_dif => NULL()
     real, pointer, dimension(:,:) :: sw_flux_nir_dir => NULL() 
     real, pointer, dimension(:,:) :: sw_flux_nir_dif => NULL()
  end type da_flux_type

  type, public :: ocn_obs_flag_type
     logical :: use_prf_as_obs
     logical :: use_ssh_as_obs
     logical :: use_sst_as_obs
     logical :: use_suv_as_obs
     logical :: use_woa05_t
     logical :: use_woa05_s
  end type ocn_obs_flag_type

  type, public :: grid_type
     real, pointer, dimension(:,:) :: x=>NULL(), y=>NULL()
     real, pointer, dimension(:,:) :: x_bound=>NULL(), y_bound=>NULL()
     real, pointer, dimension(:,:) :: dx=>NULL(), dy=>NULL()
     real, pointer, dimension(:) :: z=>NULL(), z_bound=>NULL()
     real, pointer, dimension(:) :: dz => NULL()
     real, pointer, dimension(:,:,:) :: mask
     type(domain2d), pointer :: Dom ! FMS domain type
     logical :: cyclic
     integer :: ni, nj, nk
  end type grid_type

  type, public :: field_type
     type(grid_type) :: grid
     real, pointer, dimension(:,:,:) :: data => NULL()
  end type field_type


  type, public :: field_dist_type_3d
     integer :: error_model
     character(len=32) :: name
     type(grid_type), pointer :: grid => NULL()
     real, pointer, dimension(:,:,:) :: ex=>NULL(), vr=>NULL()
     real, pointer, dimension(:,:,:) :: obs_d => NULL()  ! obs minus expected value
  end type field_dist_type_3d

  type, public :: field_dist_type_2d
     integer :: error_model
     character(len=32) :: name
     type(grid_type), pointer :: grid => NULL()
     real, pointer, dimension(:,:) :: ex=>NULL(), vr=>NULL()
  end type field_dist_type_2d
     
  type, public :: ocean_dist_type
     type(field_dist_type_3d) :: temp,salt,u,v
     type(field_dist_type_2d) :: eta
  end type ocean_dist_type

  type, public :: obs_clim_type
    real, pointer, dimension(:,:) :: sst_obs
  end type obs_clim_type

  public init_obs
  
  interface init_obs
     module procedure init_obs_profile
  end interface
  
  contains

    subroutine init_obs_profile(profile)
      type(ocean_profile_type), intent(inout) :: profile

      profile%nvar = 0
      profile%project = -1.0
      profile%probe   = -1.0
      profile%wod_cast_num = -1
      profile%ref_inst = -1.0
      profile%fix_depth = -1.0
      profile%ocn_vehicle = -1.0
      profile%database_id = -1.0
      profile%levels = 0
      profile%profile_flag = 0
      profile%profile_flag_s = 0
      profile%lat = -1.e10
      profile%lon = -1.e10
      profile%accepted = .true.
      if (associated(profile%next)) deallocate(profile%next)
      profile%nlinks = 0
      profile%nbr_index(:) = -1
      profile%nbr_dist(:) = -1.0
      if (associated(profile%depth)) deallocate(profile%depth)
      if (associated(profile%data_t)) deallocate(profile%data_t)
      if (associated(profile%data_s)) deallocate(profile%data_s)
      if (associated(profile%flag_t)) deallocate(profile%flag_t)
      if (associated(profile%flag_s)) deallocate(profile%flag_s)
      if (associated(profile%ms_t)) deallocate(profile%ms_t)
      if (associated(profile%ms_s)) deallocate(profile%ms_s)
      profile%temp_err = -1.0
      profile%salt_err = -1.0
      profile%time = set_time(0,0)
      profile%yyyy = 0
      profile%mmdd = 0      
      if (associated(profile%model_time)) deallocate(profile%model_time)
      if (associated(profile%model_grid)) deallocate(profile%model_grid)
      profile%i_index = -1
      profile%j_index = -1
      if (associated(profile%k_index)) deallocate(profile%k_index)
      profile%tdiff = set_time(0,0)

      return
      
    end subroutine init_obs_profile
    
end module oda_types_mod

module topo_rough_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Sergey Malyshev
! </CONTACT>

  use time_manager_mod,   only : time_type
  use mpp_domains_mod,    only : domain2d

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

  use fms_mod,            only : write_version_number, error_mesg, FATAL, NOTE, &
       open_restart_file, set_domain, read_data, &
       write_data, close_file, file_exist, check_nml_error, mpp_pe, &
       mpp_root_pe, stdlog
  use diag_manager_mod,   only : register_static_field, send_data
  use topography_mod,     only : get_topog_stdev

implicit none
private
! ==== public interface ======================================================
public :: topo_rough_init
public :: topo_rough_end
public :: update_topo_rough
! ==== end of public interface ===============================================


! <NAMELIST NAME = "topo_rough_nml">
!   <DATA NAME="use_topo_rough" TYPE="logical" DEFAULT="false">
!     If true, the topographic momentum drag scaling scheme is used
!   </DATA>
!   <DATA NAME="max_topo_rough" TYPE="real" DEFAULT="100" UNITS="m">
!     Maximum of topographic "roughness length" used for momentum drag scaling
!   </DATA>
!   <DATA NAME="topo_rough_factor" TYPE="real" DEFAULT="1.0">
!     Scaling factor to convert topography variance to topographic 
!     "roughness length"
!   </DATA>
!   <DATA NAME="topo_rough_source" TYPE="caharacter(len=16)" DEFAULT="'computed'">
!     Source of the sub-grid topography variance data for topographic momentum drag scaling. 
!     'computed' means that the variance is calculated based on high-resolution 
!     topography data. 'input' means that the data will be provided in specified file
!     (NetCDF of IEEE binary)
!   </DATA>
!   <DATA NAME="topo_rough_file" TYPE="character(len=256)" DEFAULT="INPUT/mg_drag.data.nc">
!     Name of the file to be used as an input for sub-grid topography variance data. 
!     The file can be either NetCDF (in this case variable name can also be specified), or
!     IEEE.
!   </DATA>
!   <DATA NAME="topo_rough_var" TYPE="character(len=128)" DEFAULT="ghprime">
!     Name of the NetCDF variable to be used as a topography variance field. Ignored if
!     the file specified in topo_rough_file is not NetCDF file.
!   </DATA>
! </NAMELIST>

logical     :: use_topo_rough    = .false.
real        :: max_topo_rough    = 100 ! m
real        :: topo_rough_factor = 1.0
character(len=16) :: topo_rough_source = 'computed'
character(len=256):: topo_rough_file   = 'INPUT/mg_drag.data.nc'
character(len=128):: topo_rough_var    = 'ghprime'

namelist/topo_rough_nml/ use_topo_rough, topo_rough_factor, max_topo_rough, &
     topo_rough_source, topo_rough_file, topo_rough_var

! ==== module constants ======================================================
character(len=*), parameter :: &
     module_name   = 'she_topo_rough', &
     diag_mod_name = 'topo_rough', &
     version       = '$Id: topo_rough.F90,v 19.0 2012/01/06 20:43:20 fms Exp $', &
     tagname       = '$Name: tikal $'

! ==== module private data ===================================================
real, allocatable, save ::topo_stdev(:,:)
logical :: module_is_initialized = .FALSE.

! ==== NetCDF declarations ===================================================
include 'netcdf.inc'

contains ! ###################################################################

subroutine topo_rough_init(time, lonb, latb, domain, id_lon,id_lat)
  type(time_type), intent(in) :: time            ! current time
  type(domain2d) , intent(in) :: domain          ! our domain
  real           , intent(in) :: latb(:,:),lonb(:,:) ! boundaries of the grid cells
  integer        , intent(in) :: id_lon,id_lat   ! IDs of diagnostic axes
!   <ERROR MSG="could not read topography data" STATUS="FATAL">
!     get_topog_stdev failed to provide topography variance data.
!   </ERROR>  
!   <ERROR MSG="input file for for topography standard deviation ... does not exist" STATUS="FATAL">
!     topo_rough_source is set to 'input', but input file name either
!     not specified or specified incorrectly, so the program cannot 
!     find it.
!   </ERROR>
!   <ERROR MSG="... is not a valid value for topo_rough_source" STATUS="FATAL">
!     specified value of namelist parameter topo_rough_source is invalid; 
!     valid values are 'computed' or 'input'.
!   </ERROR>
  ! --- local vars
  integer :: ierr,io,unit
  integer :: id
  logical :: used, got_stdev

  ! write the version and tagname to the logfile
  call write_version_number(version, tagname)

  ! read and write (to logfile) namelist variables
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=topo_rough_nml, iostat=io)
  ierr = check_nml_error(io, 'topo_rough_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file ( )
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=topo_rough_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'topo_rough_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif

  if (mpp_pe() == mpp_root_pe()) then
     unit=stdlog()
     write(unit, nml=topo_rough_nml)
  endif

  ! allocate topo_stdev according to specified domain
  allocate(topo_stdev(size(lonb,1)-1, size(lonb,2)-1))

  if (use_topo_rough) then

     if(trim(topo_rough_source) == 'computed') then
        call error_mesg('topo_rough_init','computing topography standard deviation',NOTE)
        got_stdev = get_topog_stdev(lonb,latb,topo_stdev)
        if (.not.got_stdev) &
             call error_mesg ('topo_rough_init', &
             'could not read topography data', FATAL)
     else if (trim(topo_rough_source)=='input') then
        call error_mesg('topo_rough_init','reading topography standard deviation from "'&
             //trim(topo_rough_file)//'"',NOTE)
        if(.not.file_exist(topo_rough_file,domain))&
             call error_mesg('topo_rough_init',            &
             'input file for topography standard deviation "'// &
             trim(topo_rough_file)//'" does not exist', FATAL)
        
        call set_domain(domain)
        call read_data(topo_rough_file,topo_rough_var,topo_stdev)
     else
        call error_mesg('topo_rough_init','"'//trim(topo_rough_source)//&
             '" is not a valid value for topo_rough_source', FATAL)
     endif
     topo_stdev = min(topo_stdev*topo_rough_factor,max_topo_rough)
  else
     topo_stdev = 0.0
  endif

  ! diag output : send topo_stdev to diagnostics
  id = register_static_field(diag_mod_name,'topo_rough',(/id_lon,id_lat/), &
       'momentum drag coefficient scaling lenght','m',missing_value=-1.0 )
  if(id > 0) &
       used = send_data(id,topo_stdev,time)
  module_is_initialized = .TRUE.
end subroutine topo_rough_init

! ============================================================================
subroutine topo_rough_end()
  deallocate(topo_stdev)
  module_is_initialized = .FALSE.
end subroutine

! ============================================================================
subroutine update_topo_rough(topo_rough)
  real, intent(out) :: topo_rough(:,:,:)

  ! ---- local vars
  integer :: k

  ! just assign standard deviation (scaled and trimmed according to namelist 
  ! parameters) to the output field 
  do k = 1, size(topo_rough,3)
     topo_rough(:,:,k) = topo_stdev(:,:)
  enddo
end subroutine

end module topo_rough_mod

module atmos_model_mod

!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Zhi Liang
!</CONTACT>
!
!<OVERVIEW>
! Null atmosphere model. 
!</OVERVIEW>
!<DESCRIPTION>
! Null atmosphere model. 
!</DESCRIPTION>
!
!<NAMELIST NAME="atmos_model_nml">
!  <DATA NAME="layout" TYPE="integer">
!  Processor domain layout for atmos model. 
!  </DATA> 
!  <DATA NAME="mask_table" TYPE="character">
!   A text file to specify n_mask, layout and mask_list to reduce number of processor
!   usage by masking out some domain regions which contain all land points. 
!   The default file name of mask_table is "INPUT/atmos_mask_table". Please note that 
!   the file name must begin with "INPUT/". The first 
!   line of mask_table will be number of region to be masked out. The second line 
!   of the mask_table will be the layout of the model. User need to set atmos_model_nml
!   variable layout to be the same as the second line of the mask table.
!   The following n_mask line will be the position of the processor to be masked out.
!   The mask_table could be created by tools check_mask. 
!   For example the mask_table will be as following if n_mask=2, layout=4,6 and 
!   the processor (1,2) and (3,6) will be masked out. 
!     2
!     4,6
!     1,2
!     3,6
!  </DATA>
!

!</NAMELIST>




use mpp_mod,           only : mpp_npes, mpp_pe, mpp_error, FATAL, mpp_chksum
use mpp_mod,           only : input_nml_file

use mpp_domains_mod,   only : domain2d
use mpp_domains_mod,   only : mpp_define_layout, mpp_define_domains
use mpp_domains_mod,   only : CYCLIC_GLOBAL_DOMAIN, mpp_get_data_domain
use mpp_domains_mod,   only : mpp_get_compute_domain, mpp_get_tile_id
use mpp_domains_mod,   only : mpp_get_current_ntile
use fms_mod,           only : field_exist, read_data, field_size, stdout
use fms_mod,           only : open_namelist_file, check_nml_error, file_exist, close_file
use fms_io_mod,        only : parse_mask_table
use time_manager_mod,  only : time_type
use coupler_types_mod, only : coupler_2d_bc_type
use diag_manager_mod,  only : diag_axis_init
use constants_mod,     only : cp_air, hlv
use mosaic_mod,        only : get_mosaic_ntiles
use xgrid_mod,         only : grid_box_type
use grid_mod,          only : get_grid_ntiles, define_cube_mosaic
use grid_mod,          only : get_grid_size, get_grid_cell_vertices
use grid_mod,          only : get_grid_cell_centers
use diag_integral_mod, only : diag_integral_init
use tracer_manager_mod,only : register_tracers
use field_manager_mod, only : MODEL_LAND

implicit none
private

public atmos_data_type
public atmos_model_end
public atmos_model_init
public ice_atmos_boundary_type
public land_ice_atmos_boundary_type
public land_atmos_boundary_type
public surf_diff_type
public update_atmos_model_down
public update_atmos_model_up
public atm_stock_pe
public atmos_model_restart
public atmos_data_type_chksum
public lnd_ice_atm_bnd_type_chksum, lnd_atm_bnd_type_chksum
public ice_atm_bnd_type_chksum

!<PUBLICTYPE >
! This type should be defined in one spot and "used" from there
type surf_diff_type
  real, pointer, dimension(:,:)   :: dtmass  => NULL()
  real, pointer, dimension(:,:)   :: dflux_t => NULL()
  real, pointer, dimension(:,:)   :: delta_t => NULL()
  real, pointer, dimension(:,:)   :: delta_u => NULL()
  real, pointer, dimension(:,:)   :: delta_v => NULL()
  real, pointer, dimension(:,:,:) :: dflux_tr => NULL()   ! tracer flux tendency
  real, pointer, dimension(:,:,:) :: delta_tr => NULL()   ! tracer tendency
  real, pointer, dimension(:,:)     :: sst_miz => NULL()
end type surf_diff_type
!</PUBLICTYPE >

!<PUBLICTYPE >
 type atmos_data_type
     type (domain2d)               :: domain             ! domain decomposition
     integer                       :: axes(4)            ! axis indices (returned by diag_manager) for the atmospheric grid 
                                                         ! (they correspond to the x, y, pfull, phalf axes)
     real, pointer, dimension(:,:) :: lon_bnd  => NULL() ! local longitude axis grid box boundaries in radians.
     real, pointer, dimension(:,:) :: lat_bnd  => NULL() ! local latitude axis grid box boundaries in radians.
     real, pointer, dimension(:,:) :: t_bot    => NULL() ! temperature at lowest model level
     real, pointer, dimension(:,:,:) :: tr_bot => NULL() ! tracers at lowest model level, including specific humidity
     real, pointer, dimension(:,:) :: z_bot    => NULL() ! height above the surface for the lowest model level
     real, pointer, dimension(:,:) :: p_bot    => NULL() ! pressure at lowest model level
     real, pointer, dimension(:,:) :: u_bot    => NULL() ! zonal wind component at lowest model level
     real, pointer, dimension(:,:) :: v_bot    => NULL() ! meridional wind component at lowest model level
     real, pointer, dimension(:,:) :: p_surf   => NULL() ! surface pressure 
     real, pointer, dimension(:,:) :: slp      => NULL() ! sea level pressure 
     real, pointer, dimension(:,:) :: gust     => NULL() ! gustiness factor
     real, pointer, dimension(:,:) :: coszen   => NULL() ! cosine of the zenith angle
     real, pointer, dimension(:,:) :: coszen_radwt   => NULL() ! cosine of the zenith angle, radiation weighted
     real, pointer, dimension(:,:) :: flux_sw  => NULL() ! net shortwave flux (W/m2) at the surface
     real, pointer, dimension(:,:) :: flux_sw_dir            =>NULL()
     real, pointer, dimension(:,:) :: flux_sw_dif            =>NULL()
     real, pointer, dimension(:,:) :: flux_sw_down_vis_dir   =>NULL()
     real, pointer, dimension(:,:) :: flux_sw_down_vis_dif   =>NULL()
     real, pointer, dimension(:,:) :: flux_sw_down_total_dir =>NULL()
     real, pointer, dimension(:,:) :: flux_sw_down_total_dif =>NULL()
     real, pointer, dimension(:,:) :: flux_sw_vis            =>NULL()
     real, pointer, dimension(:,:) :: flux_sw_vis_dir        =>NULL()
     real, pointer, dimension(:,:) :: flux_sw_vis_dif        =>NULL()
     real, pointer, dimension(:,:) :: flux_lw  => NULL() ! net longwave flux (W/m2) at the surface
     real, pointer, dimension(:,:) :: lprec    => NULL() ! mass of liquid precipitation since last time step (Kg/m2)
     real, pointer, dimension(:,:) :: fprec    => NULL() ! ass of frozen precipitation since last time step (Kg/m2)
     logical,pointer,dimension(:,:):: maskmap  => NULL() ! A pointer to an array indicating which
                                                         ! logical processors are actually used for
                                                         ! the ocean code. The other logical
                                                         ! processors would be all land points and
                                                         ! are not assigned to actual processors.
                                                         ! This need not be assigned if all logical
                                                         ! processors are used.indicate if a domain region will be loaded.
     type (surf_diff_type)         :: Surf_diff          ! store data needed by the multi-step version of the diffusion algorithm
     type (time_type)              :: Time               ! current time
     type (time_type)              :: Time_step          ! atmospheric time step.
     type (time_type)              :: Time_init          ! reference time.
     integer, pointer              :: pelist(:) =>NULL() ! pelist where atmosphere is running.
     logical                       :: pe                 ! current pe.
     type(coupler_2d_bc_type)      :: fields   ! array of fields used for additional tracers
     type(grid_box_type)           :: grid
 end type
!</PUBLICTYPE >

!<PUBLICTYPE >
type land_ice_atmos_boundary_type
   ! variables of this type are declared by coupler_main, allocated by flux_exchange_init.
!quantities going from land+ice to atmos
   real, dimension(:,:),   pointer :: t              =>NULL() ! surface temperature for radiation calculations
   real, dimension(:,:),   pointer :: albedo         =>NULL() ! surface albedo for radiation calculations
   real, dimension(:,:),   pointer :: albedo_vis_dir =>NULL()
   real, dimension(:,:),   pointer :: albedo_nir_dir =>NULL()
   real, dimension(:,:),   pointer :: albedo_vis_dif =>NULL()
   real, dimension(:,:),   pointer :: albedo_nir_dif =>NULL()
   real, dimension(:,:),   pointer :: land_frac      =>NULL() ! fraction amount of land in a grid box 
   real, dimension(:,:),   pointer :: dt_t           =>NULL() ! temperature tendency at the lowest level
   real, dimension(:,:,:), pointer :: dt_tr          =>NULL() ! tracer tendency at the lowest level, including specific humidity
   real, dimension(:,:),   pointer :: u_flux         =>NULL() ! zonal wind stress
   real, dimension(:,:),   pointer :: v_flux         =>NULL() ! meridional wind stress
   real, dimension(:,:),   pointer :: dtaudu         =>NULL() ! derivative of wind stress w.r.t. the lowest level wind speed
   real, dimension(:,:),   pointer :: dtaudv         =>NULL() ! derivative of wind stress w.r.t. the lowest level wind speed
   real, dimension(:,:),   pointer :: u_star         =>NULL() ! friction velocity
   real, dimension(:,:),   pointer :: b_star         =>NULL() ! bouyancy scale
   real, dimension(:,:),   pointer :: q_star         =>NULL() ! moisture scale
   real, dimension(:,:),   pointer :: rough_mom      =>NULL() ! surface roughness (used for momentum)
   real, dimension(:,:,:), pointer :: data =>NULL() !collective field for "named" fields above
   real, dimension(:,:),   pointer :: frac_open_sea  =>null() ! non-seaice fraction (%)
   integer :: xtype             !REGRID, REDIST or DIRECT
end type land_ice_atmos_boundary_type
!</PUBLICTYPE >

!<PUBLICTYPE >
type :: land_atmos_boundary_type
   real, dimension(:,:), pointer :: data =>NULL() ! quantities going from land alone to atmos (none at present)
end type land_atmos_boundary_type
!</PUBLICTYPE >

!<PUBLICTYPE >
!quantities going from ice alone to atmos (none at present)
type :: ice_atmos_boundary_type
   real, dimension(:,:), pointer :: data =>NULL() ! quantities going from ice alone to atmos (none at present)
end type ice_atmos_boundary_type
!</PUBLICTYPE >
  
!-----------------------------------------------------------------------

character(len=128) :: version = '$Id: atmos_model.F90,v 20.0 2013/12/13 23:08:53 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!---- atmos_model_nml
integer :: layout(2)
! mask_table contains information for masking domain ( n_mask, layout and mask_list).
character(len=128) :: mask_table = "INPUT/atmos_mask_table"

namelist /atmos_model_nml/ layout, mask_table


contains

!#######################################################################
! <SUBROUTINE NAME="update_atmos_model_down">
!
! <OVERVIEW>
!   compute the atmospheric tendencies for dynamics, radiation, 
!   vertical diffusion of momentum, tracers, and heat/moisture.
! </OVERVIEW>
!
!<DESCRIPTION>
!   Called every time step as the atmospheric driver to compute the
!   atmospheric tendencies for dynamics, radiation, vertical diffusion of
!   momentum, tracers, and heat/moisture.  For heat/moisture only the
!   downward sweep of the tridiagonal elimination is performed, hence
!   the name "_down". 
!</DESCRIPTION>

!   <TEMPLATE>
!     call  update_atmos_model_down( Surface_boundary, Atmos )
!   </TEMPLATE>

! <IN NAME = "Surface_boundary" TYPE="type(land_ice_atmos_boundary_type)">
!   Derived-type variable that contains quantities going from land+ice to atmos.  
! </IN>

! <IN NAME="Atmos" TYPE="type(atmos_data_type)">
!   Derived-type variable that contains fields needed by the flux exchange module.
!   These fields describe the atmospheric grid and are needed to
!   compute/exchange fluxes with other component models.  All fields in this
!   variable type are allocated for the global grid (without halo regions).
! </IN>

subroutine update_atmos_model_down( Surface_boundary, Atmos )
!-----------------------------------------------------------------------
!                       atmospheric driver
!    performs radiation, damping, and vertical diffusion of momentum,
!    tracers, and downward heat/moisture
!
!-----------------------------------------------------------------------

  type(land_ice_atmos_boundary_type), intent(in) :: Surface_boundary
  type (atmos_data_type), intent(in) :: Atmos

  return

end subroutine update_atmos_model_down
! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="update_atmos_model_up">
!
!-----------------------------------------------------------------------
! <OVERVIEW>
!   upward vertical diffusion of heat/moisture and moisture processes
! </OVERVIEW>

!<DESCRIPTION>
!   Called every time step as the atmospheric driver to finish the upward
!   sweep of the tridiagonal elimination for heat/moisture and compute the
!   convective and large-scale tendencies.  The atmospheric variables are
!   advanced one time step and tendencies set back to zero. 
!</DESCRIPTION>

! <TEMPLATE>
!     call  update_atmos_model_up( Surface_boundary, Atmos )
! </TEMPLATE>

! <IN NAME = "Surface_boundary" TYPE="type(land_ice_atmos_boundary_type)">
!   Derived-type variable that contains quantities going from land+ice to atmos.  
! </IN>

! <IN NAME="Atmos" TYPE="type(atmos_data_type)">
!   Derived-type variable that contains fields needed by the flux exchange module.
!   These fields describe the atmospheric grid and are needed to
!   compute/exchange fluxes with other component models.  All fields in this
!   variable type are allocated for the global grid (without halo regions).
! </IN>
subroutine update_atmos_model_up( Surface_boundary, Atmos )
!-----------------------------------------------------------------------
!                       atmospheric driver
!    performs upward vertical diffusion of heat/moisture and
!    moisture processes
!
!-----------------------------------------------------------------------

   type(land_ice_atmos_boundary_type), intent(in) :: Surface_boundary
   type (atmos_data_type), intent(in) :: Atmos
   
   return

end subroutine update_atmos_model_up
! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="atmos_model_init">
!
! <OVERVIEW>
! Routine to initialize the atmospheric model
! </OVERVIEW>

! <DESCRIPTION>
!     This routine allocates storage and returns a variable of type
!     atmos_boundary_data_type, and also reads a namelist input and restart file. 
! </DESCRIPTION>

! <TEMPLATE>
!     call atmos_model_init (Atmos, Time_init, Time, Time_step)
! </TEMPLATE>

! <IN NAME="Time_init" TYPE="type(time_type)" >
!   The base (or initial) time of the experiment.
! </IN>

! <IN NAME="Time" TYPE="type(time_type)" >
!   The current time.
! </IN>

! <IN NAME="Time_step" TYPE="type(time_type)" >
!   The atmospheric model/physics time step.
! </IN>

! <INOUT NAME="Atmos" TYPE="type(atmos_data_type)">
!   Derived-type variable that contains fields needed by the flux exchange module.
! </INOUT>

subroutine atmos_model_init (Atmos, Time_init, Time, Time_step)

type (atmos_data_type), intent(inout) :: Atmos
type (time_type), intent(in)          :: Time_init, Time, Time_step

real, dimension(:,:), allocatable     :: glon, glat, glon_bnd, glat_bnd
integer, dimension(:), allocatable    :: tile_ids
real, dimension(:,:),  allocatable    :: area
integer                               :: is, ie, js, je, i
integer                               :: nlon, nlat, ntile, tile
integer                               :: ntracers, ntprog, ndiag
integer                               :: namelist_unit, io, ierr, stdoutunit

!--- read namelist
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, atmos_model_nml, iostat=io)
#else
   namelist_unit = open_namelist_file()
   ierr=1
   do while (ierr /= 0)
     read(namelist_unit, nml=atmos_model_nml, iostat=io, end=20)
     ierr = check_nml_error (io, 'atmos_model_nml')
   enddo
   20 call close_file (namelist_unit)
#endif

stdoutunit = stdout()
!---- set the atmospheric model time ------

Atmos % Time_init = Time_init
Atmos % Time      = Time
Atmos % Time_step = Time_step
 
call get_grid_ntiles('ATM',ntile)
call get_grid_size('ATM',1,nlon,nlat)


if(file_exist(mask_table)) then
   if(ntile > 1) then
      call mpp_error(FATAL, &
        'atmos_model_init: file '//trim(mask_table)//' should not exist when ntile is not 1')
   endif
   if(layout(1) == 0 .OR. layout(2) == 0 ) call mpp_error(FATAL, &
        'atmos_model_init: atmos_model_nml layout should be set when file '//trim(mask_table)//' exists')

   write(stdoutunit, '(a)') '==> NOTE from atmos_model_init:  reading maskmap information from '//trim(mask_table)
   allocate(Atmos%maskmap(layout(1), layout(2)))
   call parse_mask_table(mask_table, Atmos%maskmap, "Atmos model")
else
   if(layout(1)*layout(2) .NE. mpp_npes()/ntile) call mpp_define_layout((/1,nlon,1,nlat/), mpp_npes()/ntile, layout)
endif


if(ntile ==1) then
   if( ASSOCIATED(Atmos%maskmap) ) then
      call mpp_define_domains((/1,nlon,1,nlat/), layout, Atmos%domain, &
           xflags = CYCLIC_GLOBAL_DOMAIN, xhalo=1, yhalo=1, maskmap = Atmos%maskmap , name='atmos model')
   else
      call mpp_define_domains((/1,nlon,1,nlat/), layout, Atmos%domain, &
           xflags = CYCLIC_GLOBAL_DOMAIN, xhalo=1, yhalo=1, name='atmos model')
   end if
else
   call define_cube_mosaic('ATM', Atmos%domain, layout, halo=1)
endif

call mpp_get_compute_domain(Atmos%domain,is,ie,js,je)

allocate ( glon_bnd(nlon+1,nlat+1))
allocate ( glat_bnd(nlon+1,nlat+1))
allocate ( glon(nlon, nlat))
allocate ( glat(nlon, nlat))
allocate ( Atmos%lon_bnd(ie-is+2,je-js+2) )
allocate ( Atmos%lat_bnd(ie-is+2,je-js+2) )
allocate ( area(ie-is+1,je-js+1) )

allocate(tile_ids(mpp_get_current_ntile(Atmos%domain)))
tile_ids = mpp_get_tile_id(Atmos%domain)
tile = tile_ids(1)
deallocate(tile_ids)

call get_grid_cell_vertices('ATM',tile,glon_bnd,glat_bnd)
call get_grid_cell_centers ('ATM',tile,glon, glat)

Atmos % lon_bnd(:,:) = glon_bnd(is:ie+1, js:je+1)*atan(1.0)/45.0
Atmos % lat_bnd(:,:) = glat_bnd(is:ie+1, js:je+1)*atan(1.0)/45.0

if(ntile==1) then
   Atmos%axes(1) = diag_axis_init('lon',glon(:,1),'degrees_E','X','longitude',&
        set_name='atmos',domain2 = Atmos%domain)

   Atmos%axes(2) = diag_axis_init('lat',glat(1,:),'degrees_N','Y','latitude',&
        set_name='atmos',domain2 = Atmos%domain)  
else
   Atmos%axes(1) = diag_axis_init('lon',(/(real(i),i=1,nlon)/),'degrees_E','X','longitude',&
        set_name='atmos',domain2 = Atmos%domain)

   Atmos%axes(2) = diag_axis_init('lat',(/(real(i),i=1,nlat)/),'degrees_N','Y','latitude',&
        set_name='atmos',domain2 = Atmos%domain)  
endif

call register_tracers(MODEL_LAND, ntracers, ntprog, ndiag)
allocate ( Atmos % t_bot(is:ie,js:je) )
allocate ( Atmos % tr_bot(is:ie,js:je,ntprog) )
allocate ( Atmos % z_bot(is:ie,js:je) )
allocate ( Atmos % p_bot(is:ie,js:je) )
allocate ( Atmos % u_bot(is:ie,js:je) )
allocate ( Atmos % v_bot(is:ie,js:je) )
allocate ( Atmos % p_surf(is:ie,js:je) )
allocate ( Atmos % slp(is:ie,js:je) )
allocate ( Atmos % gust(is:ie,js:je) )
allocate ( Atmos % coszen(is:ie,js:je) )
allocate ( Atmos % coszen_radwt(is:ie,js:je) )
allocate ( Atmos % flux_sw(is:ie,js:je) )
allocate ( Atmos % flux_sw_dir (is:ie,js:je) )
allocate ( Atmos % flux_sw_dif (is:ie,js:je) )
allocate ( Atmos % flux_sw_down_vis_dir (is:ie,js:je) )
allocate ( Atmos % flux_sw_down_vis_dif (is:ie,js:je) )
allocate ( Atmos % flux_sw_down_total_dir (is:ie,js:je) )
allocate ( Atmos % flux_sw_down_total_dif (is:ie,js:je) )
allocate ( Atmos % flux_sw_vis (is:ie,js:je) )
allocate ( Atmos % flux_sw_vis_dir (is:ie,js:je) )
allocate ( Atmos % flux_sw_vis_dif(is:ie,js:je) )
allocate ( Atmos % flux_lw(is:ie,js:je) )
allocate ( Atmos % lprec(is:ie,js:je) )
allocate ( Atmos % fprec(is:ie,js:je) )

Atmos % t_bot=273.0
Atmos % tr_bot = 0.0
Atmos % z_bot = 10.0
Atmos % p_bot = .99e5
Atmos % u_bot = 0.0
Atmos % v_bot = 0.0
Atmos % p_surf = 1.e5
Atmos % slp = 1.e5
Atmos % gust = 0.0
Atmos % coszen = 0.0
Atmos % coszen_radwt = 0.0
Atmos % flux_sw = 0.0
Atmos % flux_lw = 0.0
Atmos % flux_sw_dir = 0.0
Atmos % flux_sw_dif = 0.0 
Atmos % flux_sw_down_vis_dir = 0.0 
Atmos % flux_sw_down_vis_dif = 0.0 
Atmos % flux_sw_down_total_dir = 0.0
Atmos % flux_sw_down_total_dif = 0.0
Atmos % flux_sw_vis = 0.0 
Atmos % flux_sw_vis_dir = 0.0 
Atmos % flux_sw_vis_dif = 0.0
Atmos % lprec = 0.0
Atmos % fprec = 0.0

allocate ( Atmos % Surf_diff % dtmass(is:ie, js:je) )
allocate ( Atmos % Surf_diff % dflux_t(is:ie, js:je) )
allocate ( Atmos % Surf_diff % delta_t(is:ie, js:je) )
allocate ( Atmos % Surf_diff % delta_u(is:ie, js:je) )
allocate ( Atmos % Surf_diff % delta_v(is:ie, js:je) )
allocate ( Atmos % Surf_diff % dflux_tr(is:ie, js:je, ntprog) )
allocate ( Atmos % Surf_diff % delta_tr(is:ie, js:je, ntprog) )

Atmos % Surf_diff % dtmass   = 0.0
Atmos % Surf_diff % dflux_t  = 0.0
Atmos % Surf_diff % delta_t  = 0.0
Atmos % Surf_diff % delta_u  = 0.0
Atmos % Surf_diff % delta_v  = 0.0
Atmos % Surf_diff % dflux_tr = 0.0
Atmos % Surf_diff % delta_tr = 0.0

area = 0.0

allocate ( Atmos % grid % dx    (   is:ie  , js:je+1))
allocate ( Atmos % grid % dy    (   is:ie+1, js:je  ))
allocate ( Atmos % grid % area  (   is:ie  , js:je  ))
allocate ( Atmos % grid % edge_w(            js:je+1))
allocate ( Atmos % grid % edge_e(            js:je+1))
allocate ( Atmos % grid % edge_s(   is:ie+1         ))
allocate ( Atmos % grid % edge_n(   is:ie+1         ))
allocate ( Atmos % grid % en1   (3, is:ie  , js:je+1))
allocate ( Atmos % grid % en2   (3, is:ie+1, js:je  ))
allocate ( Atmos % grid % vlon  (3, is:ie  , js:je  ))
allocate ( Atmos % grid % vlat  (3, is:ie  , js:je  ))
     
Atmos % grid % dx    = 1.0
Atmos % grid % dy    = 1.0
Atmos % grid % area  = 1.0
Atmos % grid % edge_w= 0.0
Atmos % grid % edge_e= 1.0
Atmos % grid % edge_s= 0.0
Atmos % grid % edge_n= 1.0
Atmos % grid % en1   = 0.0
Atmos % grid % en2   = 0.0
Atmos % grid % vlon  = 0.0
Atmos % grid % vlat  = 0.0

call diag_integral_init (Atmos % Time_init, Atmos % Time,  &
                         Atmos % lon_bnd(:,:),  &
                         Atmos % lat_bnd(:,:), area)

end subroutine atmos_model_init
! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="atmos_model_end">
!
! <OVERVIEW>
!  termination routine for atmospheric model
! </OVERVIEW>

! <DESCRIPTION>
!  Call once to terminate this module and any other modules used.
!  This routine writes a restart file and deallocates storage
!  used by the derived-type variable atmos_boundary_data_type.
! </DESCRIPTION>

! <TEMPLATE>
!   call atmos_model_end (Atmos)
! </TEMPLATE>

! <IN NAME="Atmos" TYPE="type(atmos_data_type)">
!   Derived-type variable that contains fields needed by the flux exchange module.
! </IN>

subroutine atmos_model_end (Atmos)

type (atmos_data_type), intent(in) :: Atmos

return

end subroutine atmos_model_end
! </SUBROUTINE>

  !#######################################################################
  ! <SUBROUTINE NAME="atmos_model_restart">
  ! <DESCRIPTION>
  ! dummy routines.
  ! </DESCRIPTION>
  subroutine atmos_model_restart(Atmos, timestamp)
    type (atmos_data_type),   intent(inout) :: Atmos
    character(len=*),  intent(in)           :: timestamp


  end subroutine atmos_model_restart
  ! </SUBROUTINE>

subroutine atm_stock_pe (Atm, index, value)

type (atmos_data_type), intent(inout) :: Atm
integer,                intent(in)    :: index
real,                   intent(out)   :: value

value = 0.0

end subroutine atm_stock_pe

!#######################################################################
! <SUBROUTINE NAME="atmos_data_type_chksum">
!
! <OVERVIEW>
!  Print checksums of the various fields in the atmos_data_type.
! </OVERVIEW>

! <DESCRIPTION>
!  Routine to print checksums of the various fields in the atmos_data_type.
! </DESCRIPTION>

! <TEMPLATE>
!   call atmos_data_type_chksum(id, timestep, atm)
! </TEMPLATE>

! <IN NAME="Atm" TYPE="type(atmos_data_type)">
!   Derived-type variable that contains fields in the atmos_data_type.
! </INOUT>
!
! <IN NAME="id" TYPE="character">
!   Label to differentiate where this routine in being called from.
! </IN>
!
! <IN NAME="timestep" TYPE="integer">
!   An integer to indicate which timestep this routine is being called for.
! </IN>
!
subroutine atmos_data_type_chksum(id, timestep, atm)
type(atmos_data_type), intent(in) :: atm 
    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    integer :: n, outunit

100 FORMAT("CHECKSUM::",A32," = ",Z20)
101 FORMAT("CHECKSUM::",A16,a,'%',a," = ",Z20)

  outunit = stdout()
  write(outunit,*) 'BEGIN CHECKSUM(Atmos_data_type):: ', id, timestep
  write(outunit,100) ' atm%lon_bnd                ', mpp_chksum(atm%lon_bnd               )
  write(outunit,100) ' atm%lat_bnd                ', mpp_chksum(atm%lat_bnd               )
  write(outunit,100) ' atm%t_bot                  ', mpp_chksum(atm%t_bot                 )
  do n = 1, size(atm%tr_bot,3)
  write(outunit,100) ' atm%tr_bot(:,:,n)          ', mpp_chksum(atm%tr_bot(:,:,n)         )
  enddo
  write(outunit,100) ' atm%z_bot                  ', mpp_chksum(atm%z_bot                 )
  write(outunit,100) ' atm%p_bot                  ', mpp_chksum(atm%p_bot                 )
  write(outunit,100) ' atm%u_bot                  ', mpp_chksum(atm%u_bot                 )
  write(outunit,100) ' atm%v_bot                  ', mpp_chksum(atm%v_bot                 )
  write(outunit,100) ' atm%p_surf                 ', mpp_chksum(atm%p_surf                )
  write(outunit,100) ' atm%slp                    ', mpp_chksum(atm%slp                   )
  write(outunit,100) ' atm%gust                   ', mpp_chksum(atm%gust                  )
  write(outunit,100) ' atm%coszen                 ', mpp_chksum(atm%coszen                )
  write(outunit,100) ' atm%coszen_radwt           ', mpp_chksum(atm%coszen_radwt          )
  write(outunit,100) ' atm%flux_sw                ', mpp_chksum(atm%flux_sw               )
  write(outunit,100) ' atm%flux_sw_dir            ', mpp_chksum(atm%flux_sw_dir           )
  write(outunit,100) ' atm%flux_sw_dif            ', mpp_chksum(atm%flux_sw_dif           )
  write(outunit,100) ' atm%flux_sw_down_vis_dir   ', mpp_chksum(atm%flux_sw_down_vis_dir  )
  write(outunit,100) ' atm%flux_sw_down_vis_dif   ', mpp_chksum(atm%flux_sw_down_vis_dif  )
  write(outunit,100) ' atm%flux_sw_down_total_dir ', mpp_chksum(atm%flux_sw_down_total_dir)
  write(outunit,100) ' atm%flux_sw_down_total_dif ', mpp_chksum(atm%flux_sw_down_total_dif)
  write(outunit,100) ' atm%flux_sw_vis            ', mpp_chksum(atm%flux_sw_vis           )
  write(outunit,100) ' atm%flux_sw_vis_dir        ', mpp_chksum(atm%flux_sw_vis_dir       )
  write(outunit,100) ' atm%flux_sw_vis_dif        ', mpp_chksum(atm%flux_sw_vis_dif       )
  write(outunit,100) ' atm%flux_lw                ', mpp_chksum(atm%flux_lw               )
  write(outunit,100) ' atm%lprec                  ', mpp_chksum(atm%lprec                 )
  write(outunit,100) ' atm%fprec                  ', mpp_chksum(atm%fprec                 )
!  call surf_diff_type_chksum(id, timestep, atm%surf_diff)

end subroutine atmos_data_type_chksum

! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="lnd_ice_atm_bnd_type_chksum">
!
! <OVERVIEW>
!  Print checksums of the various fields in the land_ice_atmos_boundary_type.
! </OVERVIEW>

! <DESCRIPTION>
!  Routine to print checksums of the various fields in the land_ice_atmos_boundary_type.
! </DESCRIPTION>

! <TEMPLATE>
!   call atmos_data_type_chksum(id, timestep, bnd_type)
! </TEMPLATE>

! <IN NAME="bnd_type" TYPE="type(land_ice_atmos_boundary_type)">
!   Derived-type variable that contains fields in the land_ice_atmos_boundary_type.
! </INOUT>
!
! <IN NAME="id" TYPE="character">
!   Label to differentiate where this routine in being called from.
! </IN>
!
! <IN NAME="timestep" TYPE="integer">
!   An integer to indicate which timestep this routine is being called for.
! </IN>
!


subroutine lnd_ice_atm_bnd_type_chksum(id, timestep, bnd_type)

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(land_ice_atmos_boundary_type), intent(in) :: bnd_type
 integer ::   n, outunit

    outunit = stdout()
    write(outunit,*) 'BEGIN CHECKSUM(lnd_ice_Atm_bnd_type):: ', id, timestep
100 FORMAT("CHECKSUM::",A32," = ",Z20)
    write(outunit,100) 'lnd_ice_atm_bnd_type%t             ',mpp_chksum(bnd_type%t              )
    write(outunit,100) 'lnd_ice_atm_bnd_type%albedo        ',mpp_chksum(bnd_type%albedo         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%albedo_vis_dir',mpp_chksum(bnd_type%albedo_vis_dir )
    write(outunit,100) 'lnd_ice_atm_bnd_type%albedo_nir_dir',mpp_chksum(bnd_type%albedo_nir_dir )
    write(outunit,100) 'lnd_ice_atm_bnd_type%albedo_vis_dif',mpp_chksum(bnd_type%albedo_vis_dif )
    write(outunit,100) 'lnd_ice_atm_bnd_type%albedo_nir_dif',mpp_chksum(bnd_type%albedo_nir_dif )
    write(outunit,100) 'lnd_ice_atm_bnd_type%land_frac     ',mpp_chksum(bnd_type%land_frac      )
    write(outunit,100) 'lnd_ice_atm_bnd_type%dt_t          ',mpp_chksum(bnd_type%dt_t           )
    do n = 1, size(bnd_type%dt_tr,3)
    write(outunit,100) 'lnd_ice_atm_bnd_type%dt_tr(:,:,n)  ',mpp_chksum(bnd_type%dt_tr(:,:,n)   )
    enddo
    write(outunit,100) 'lnd_ice_atm_bnd_type%u_flux        ',mpp_chksum(bnd_type%u_flux         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%v_flux        ',mpp_chksum(bnd_type%v_flux         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%dtaudu        ',mpp_chksum(bnd_type%dtaudu         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%dtaudv        ',mpp_chksum(bnd_type%dtaudv         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%u_star        ',mpp_chksum(bnd_type%u_star         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%b_star        ',mpp_chksum(bnd_type%b_star         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%q_star        ',mpp_chksum(bnd_type%q_star         )
    write(outunit,100) 'lnd_ice_atm_bnd_type%rough_mom     ',mpp_chksum(bnd_type%rough_mom      )
!    write(outunit,100) 'lnd_ice_atm_bnd_type%data          ',mpp_chksum(bnd_type%data           )

end subroutine lnd_ice_atm_bnd_type_chksum
! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="lnd_atm_bnd_type_chksum">
!
! <OVERVIEW>
!  Print checksums of the various fields in the land_atmos_boundary_type.
! </OVERVIEW>

! <DESCRIPTION>
!  Routine to print checksums of the various fields in the land_atmos_boundary_type.
! </DESCRIPTION>

! <TEMPLATE>
!   call lnd_atm_bnd_type_chksum(id, timestep, bnd_type)
! </TEMPLATE>

! <IN NAME="bnd_type" TYPE="type(land_atmos_boundary_type)">
!   Derived-type variable that contains fields in the land_atmos_boundary_type.
! </INOUT>
!
! <IN NAME="id" TYPE="character">
!   Label to differentiate where this routine in being called from.
! </IN>
!
! <IN NAME="timestep" TYPE="integer">
!   An integer to indicate which timestep this routine is being called for.
! </IN>
!


subroutine lnd_atm_bnd_type_chksum(id, timestep, bnd_type)
  use fms_mod,                 only: stdout
  use mpp_mod,                 only: mpp_chksum

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(land_atmos_boundary_type), intent(in) :: bnd_type
 integer ::   n, outunit

    outunit = stdout()
    write(outunit,*) 'BEGIN CHECKSUM(lnd_atmos_boundary_type):: ', id, timestep
!    write(outunit,100) 'lnd_atm_bnd_type%data',mpp_chksum(bnd_type%data)

100 FORMAT("CHECKSUM::",A32," = ",Z20)

end subroutine lnd_atm_bnd_type_chksum
! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="ice_atm_bnd_type_chksum">
!
! <OVERVIEW>
!  Print checksums of the various fields in the ice_atmos_boundary_type.
! </OVERVIEW>

! <DESCRIPTION>
!  Routine to print checksums of the various fields in the ice_atmos_boundary_type.
! </DESCRIPTION>

! <TEMPLATE>
!   call ice_atm_bnd_type_chksum(id, timestep, bnd_type)
! </TEMPLATE>

! <IN NAME="bnd_type" TYPE="type(ice_atmos_boundary_type)">
!   Derived-type variable that contains fields in the ice_atmos_boundary_type.
! </INOUT>
!
! <IN NAME="id" TYPE="character">
!   Label to differentiate where this routine in being called from.
! </IN>
!
! <IN NAME="timestep" TYPE="integer">
!   An integer to indicate which timestep this routine is being called for.
! </IN>
!


subroutine ice_atm_bnd_type_chksum(id, timestep, bnd_type)
  use fms_mod,                 only: stdout
  use mpp_mod,                 only: mpp_chksum

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(ice_atmos_boundary_type), intent(in) :: bnd_type
 integer ::   n, outunit

    outunit = stdout()
    write(outunit,*) 'BEGIN CHECKSUM(ice_atmos_boundary_type):: ', id, timestep
!    write(outunit,100) 'ice_atm_bnd_type%data',mpp_chksum(data_type%data)

100 FORMAT("CHECKSUM::",A32," = ",Z20)


end subroutine ice_atm_bnd_type_chksum
! </SUBROUTINE>

end module atmos_model_mod

module bgrid_core_driver_mod

!-----------------------------------------------------------------------
!
!      Driver module for running the FMS B-grid dynamical core.
!
!        * reads namelist
!        * sets up the B-grid core
!        * packages the B-grid core with diagnostic routines
!
!-----------------------------------------------------------------------

use mpp_mod, only: input_nml_file 
use bgrid_core_mod           , only: bgrid_dynam_type,  &
                                     bgrid_core_init, update_bgrid_core,  &
                                     bgrid_core_end
use bgrid_horiz_mod          , only: horiz_grid_type, horiz_grid_init
use bgrid_vert_mod           , only: vert_grid_type, vert_grid_init
use bgrid_prog_var_mod       , only: prog_var_type, prog_var_init, &
                                     prog_var_time_diff, var_init, &
                                     open_prog_var_file,           &
                                     read_prog_var, write_prog_var
use bgrid_diagnostics_mod    , only: bgrid_diagnostics,      &
                                     bgrid_diagnostics_tend, &
                                     bgrid_diagnostics_init
use bgrid_integrals_mod      , only: bgrid_integrals, bgrid_integrals_init, &
                                     bgrid_integrals_end
use bgrid_conserve_energy_mod, only: bgrid_conserve_energy_init, &
                                     bgrid_conserve_energy,      &
                                     bgrid_conserve_energy_end

use  field_manager_mod, only: MODEL_ATMOS
use tracer_manager_mod, only: get_number_tracers
use   time_manager_mod, only: time_type, get_time
use            fms_mod, only: error_mesg, FATAL, file_exist, open_namelist_file,  &
                              check_nml_error, write_version_number,     &
                              mpp_pe, mpp_root_pe, close_file, stdlog

use    mpp_domains_mod, only: domain2d
!-----------------------------------------------------------------------

implicit none
private

public  bgrid_dynam_type, bgrid_core_driver_init, &
        bgrid_core_driver, bgrid_core_driver_end, &
        bgrid_core_time_diff, get_bottom_data, put_bottom_data, &
        atmosphere_domain

!-----------------------------------------------------------------------
character(len=128) :: version =  '$Id: bgrid_core_driver.F90,v 19.0 2012/01/06 19:53:59 fms Exp $'
character(len=128) :: tagname =  '$Name: tikal $'
!-----------------------------------------------------------------------
!
!             NAMELIST INPUT: bgrid_core_driver_nml
!
!           This namelist is read from file input.nml.
!           See the on-line documentation for more details.
!
!-----------------------------------------------------------------------
!
!  num_adjust_dt       The number of adjustment time steps for each advection
!                      time step, where num_adjust_dt >= 1.
!
!  num_advec_dt        The number of advection time steps for each
!                      atmospheric/physics time step, where num_advec_dt >= 1.

   integer :: num_adjust_dt = 3
   integer :: num_advec_dt  = 3

!  layout              The domain decomposition, where layout(1) = x-axis
!                      decomposition, layout(2) = y-axis decomposition.
!                      * If layout(1)*layout(2) does not equal the number
!                        of processors the model will fail.
!                      * If layout(1)=layout(2)=0 then the decomposition is
!                        determined by MPP_DEFINE_LAYOUT.

   integer, dimension(2) :: layout = (/0,0/)

!  filter_option       Determines how polar filtering is performed.
!                      Possible values are :
!                        filter_option = 0, no polar filtering (decrease time step)
!                        filter_option = 1, obsolete scheme (NO NOT USE)
!                        filter_option = 2, default scheme (refer to technical doc)
! 
!  filter_weight       Weight applied to the polar filter that will
!                      increase (or decrease) the strength of the standard
!                      polar filter response function.
!
!  ref_lat_filter      The reference latitude at which polar filtering
!                      (in each hemisphere) will begin to be applied.

   integer   ::     filter_option = 2
   integer   ::     filter_weight = 1
   real      ::     ref_lat_filter = 60.

!  do_conserve_energy  If TRUE the temperature tendency will be updated to
!                      guarantee that the dynamical core conserves total energy.
!                      The correction is applied as a global uniform value.

   logical   :: do_conserve_energy = .false.

!  pgf_scheme          The scheme used to compute the pressure gradient.
!                      Specify one of the following: 'default', 'finite_volume'.
!                      The default scheme is that of Simmons and Burridge.

   character(len=24) :: pgf_scheme = 'default'   ! default, finite_volume

!  restart_output_format   Format used for the output restart file.
!                          The only possible values are: 'native' or 'netcdf'.

   character(len=24) :: restart_output_format = 'netcdf'   ! native, netcdf

!  do_average_omega    If TRUE the omega diagostic returned by the dynamical core
!                      is averaged over all adjustment time steps. If FALSE then
!                      omega for the last adjustment step is returned.

   logical   :: do_average_omega = .false.

!  ddamp_coeff         Damping coefficient for divergence damping.

   real :: ddamp_coeff = 0.0

!  verbose             Flag that control additional printed output.
!                      Currently, this option is not being used.

   integer :: verbose = 0


   namelist /bgrid_core_driver_nml/  num_adjust_dt, num_advec_dt,   &
                                     layout, filter_option,         & 
                                     filter_weight, ref_lat_filter, &
                                     do_conserve_energy,            &
                                     pgf_scheme,                    &
                                     restart_output_format,         &
                                     do_average_omega,              &
                                     ddamp_coeff, verbose

!-----------------------------------------------------------------------
!------ private data ------

real, dimension(:,:),   pointer :: fis, res        ! topography data
real, dimension(:,:,:), pointer :: div, mfew, mfns ! diagnostic fields
real, dimension(:), allocatable :: eta, peta       ! vertical grid


! derived type data containing horizonal and vertical grid constants
! other pointer data may "point at" these data at any time
type  (horiz_grid_type), target, save :: Hgrid
type   (vert_grid_type), target, save :: Vgrid

! axis indices returned by diagnostics manager
integer, dimension(4) :: mass_axes, vel_axes

real :: dt_atmos ! atmospheric time step

!-----------------------------------------------------------------------

contains

!#######################################################################

 subroutine bgrid_core_driver_init ( Time_init, Time, Time_step, &
                                     Var, Var_dt, Dynam, phys_axes )

!-----------------------------------------------------------------------
! Time_init = initial time
! Time      = current time
! Time_step = atmospheric model time step
! Var       = prognostic variables
! Var_dt    = prognostic variable tendencies
! Dynam     = data type for dynamical core constants and data
! phys_axes = axis indices for the grid used by the atmospheric physics
!-----------------------------------------------------------------------

 type       (time_type), intent(in)    :: Time_init, Time, Time_step
 type   (prog_var_type), intent(inout) :: Var, Var_dt
 type(bgrid_dynam_type), intent(inout) :: Dynam
 integer,                intent(out)   :: phys_axes(4)

 integer :: unit, io, ierr, logunit
 integer :: ix, jx, kx
 integer :: sec, ntrace, ntprog, ntdiag
!-----------------------------------------------------------------------
!  ----- read namelist -----

    if (file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
        read (input_nml_file, nml=bgrid_core_driver_nml, iostat=io)
        ierr = check_nml_error(io,'bgrid_core_driver_nml')
#else
        unit = open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
           read (unit, nml=bgrid_core_driver_nml, iostat=io, end=10)
           ierr = check_nml_error (io, 'bgrid_core_driver_nml')
        enddo
 10     call close_file (unit)
#endif
    endif
    logunit = stdlog()

!-----------------------------------------------------------------------
!  ----- read restart header records and set up grid resolution -----

   call open_prog_var_file (ix, jx, kx)

!  ---- horizontal grid initialization ----

   call horiz_grid_init ( Hgrid, ix, jx, layout=layout )

! how many tracers have been registered?
   call get_number_tracers ( MODEL_ATMOS, num_tracers=ntrace, num_prog=ntprog, num_diag=ntdiag )

!  ----- write version, namelist and tracer info to log file -----

    call write_version_number(version, tagname)
    if (mpp_pe() == mpp_root_pe()) then
        write (logunit, nml=bgrid_core_driver_nml)
        write (logunit, '(a,i3)') 'Number of tracers =', ntrace
        write (logunit, '(a,i3)') 'Number of prognostic tracers =', ntprog
        write (logunit, '(a,i3)') 'Number of diagnostic tracers =', ntdiag
    endif

!  ---- prognostic variable initialization -----

   call prog_var_init (Hgrid, kx, ntrace, Var)     ! prognostic+diagnostic tracers
   call prog_var_init (Hgrid, kx, ntprog, Var_dt)

!----- read data -----

   fis   => var_init (Hgrid)
   res   => var_init (Hgrid)

   allocate (eta(kx+1), peta(kx+1))

   call read_prog_var ( Hgrid, Var, eta, peta, fis, res )


!---- vertical grid initialization ----

   call vert_grid_init ( Vgrid, eta, peta )

   deallocate (eta, peta)

!---- diagnostic fields ----

   div  => var_init (Hgrid,kx)
   mfew => var_init (Hgrid,kx)
   mfns => var_init (Hgrid,kx)

!---- compute time step in seconds ----

   call get_time (Time_step, sec)
   dt_atmos = real(sec)

!-----------------------------------------------------------------------
!  ----- initialize dynamical core -----

   call bgrid_core_init ( Dynam, Hgrid, Vgrid, fis, res, dt_atmos,     &
                          num_adjust_dt, num_advec_dt, pgf_scheme,     &
                          filter_option, filter_weight, ref_lat_filter,&
                          ddamp_coeff, do_average_omega, verbose )

!-----------------------------------------------------------------------
!---- initialize history (netcdf) file and integrals -------

   call bgrid_diagnostics_init ( Time, Hgrid, Vgrid, Var,      &
                                 fis, res, mass_axes, vel_axes )
   phys_axes = mass_axes

   call bgrid_integrals_init (Time_init, Time)

!---- initialize integrals ----

   call bgrid_integrals (Time, Hgrid, Vgrid, Var, Dynam%Masks)

!---- initialize energy conservation module ----

   if (do_conserve_energy) call bgrid_conserve_energy_init (Time, mass_axes)

!-----------------------------------------------------------------------

 end subroutine bgrid_core_driver_init

!#######################################################################

 subroutine bgrid_core_driver (Time_diag, Var, Var_dt, Dynam, omega)

!-----------------------------------------------------------------------
! Time_diag = time used for diagnostic output
!              (typically time at end of time step)
! Var       = prognostic variables
! Var_dt    = prognostic variable tendencies
! Dynam     = data type for dynamical core constants and data
! omega     = omega (vertical velocity) diagnostic (Pa/s)
!-----------------------------------------------------------------------
   type       (time_type), intent(in)    :: Time_diag
   type   (prog_var_type), intent(in)    :: Var
   type   (prog_var_type), intent(inout) :: Var_dt
   type(bgrid_dynam_type), intent(inout) :: Dynam
   real,                   intent(out)   :: omega(:,:,:)
!-----------------------------------------------------------------------
!  dynamics

   call update_bgrid_core (Var, Var_dt, Dynam, omega, div, mfew, mfns )

!  energy conservation

   if (do_conserve_energy) then
       call bgrid_conserve_energy ( dt_atmos, Time_diag, Hgrid, Vgrid, &
                                    Dynam%Masks, Var, Var_dt )
   endif

!  diagnostics for dynamics tendencies

   call bgrid_diagnostics_tend ( Hgrid, Var_dt, Dynam%Masks, Time_diag )

!-----------------------------------------------------------------------

 end subroutine bgrid_core_driver

!#######################################################################

 subroutine bgrid_core_time_diff ( omega, Time_diag, Dynam, Var, Var_dt )

!-----------------------------------------------------------------------
! omega     = omega (vertical velocity) diagnostic (Pa/s)
! Time_diag = time used for diagnostic output
!              (typically time at end of time step)
! Dynam     = data type for dynamical core constants and data
! Var       = prognostic variables
! Var_dt    = prognostic variable tendencies
!-----------------------------------------------------------------------
   real,                   intent(in)    :: omega(:,:,:)
   type       (time_type), intent(in)    :: Time_diag
   type(bgrid_dynam_type), intent(in)    :: Dynam
   type   (prog_var_type), intent(inout) :: Var
   type   (prog_var_type), intent(inout) :: Var_dt
!-----------------------------------------------------------------------

!  time differencing

   call prog_var_time_diff ( dt_atmos, Dynam%Masks, Var_dt, Var )

!  global integrals and diagnostics

   call bgrid_integrals ( Time_diag, Hgrid, Vgrid, Var, Dynam%Masks )

   call bgrid_diagnostics ( Hgrid, Vgrid, Var, Dynam%Masks,   &
                            Time_diag, omega, div, mfew, mfns ) 

!-----------------------------------------------------------------------

 end subroutine bgrid_core_time_diff

!#######################################################################

 subroutine bgrid_core_driver_end ( Var, Dynam )

!-----------------------------------------------------------------------
! Var       = prognostic variables
! Dynam     = data type for dynamical core constants and data
!-----------------------------------------------------------------------
   type   (prog_var_type), intent(in)    :: Var
   type(bgrid_dynam_type), intent(inout) :: Dynam
!-----------------------------------------------------------------------
!  terminate dynamics

   call bgrid_core_end ( Dynam )

!  write restart for prognostic variables

   call write_prog_var ( Var, Hgrid, Vgrid, fis, res, &
                         format=restart_output_format )

!  terminate integrals
   call bgrid_integrals_end

!  only prints diagnostics
   call bgrid_conserve_energy_end

!-----------------------------------------------------------------------

 end subroutine bgrid_core_driver_end

!#######################################################################
! The following routines do not really belong in this module but since
! they are not used within the core itself they will reside here.
!#######################################################################

 subroutine get_bottom_data ( a, b, a_bot, b_bot, k_bot ) 

!-------- Extract data from the lowest model level ---------
! a, b     = 3-D data fields
! a_bot,
!    b_bot = 2-D data fields containing data at lowest level
! k_bot    = index of lowest model level (optional)
!-----------------------------------------------------------

  real   , intent(in) , dimension(:,:,:) :: a    , b
  real   , intent(out), dimension(:,:)   :: a_bot, b_bot
  integer, intent(in) , dimension(:,:), optional :: k_bot

! returns the lowest level data (a_bot,b_bot) from 3d fields (a,b)

  integer :: i, j, kb, kb_min
    
                      kb_min = size(a,3)
  if (present(k_bot)) kb_min = minval (k_bot) 

  if ( kb_min == size(a,3) ) then
          a_bot = a(:,:,kb_min)
          b_bot = b(:,:,kb_min)
  else
       do j = 1, size(a,2)
       do i = 1, size(a,1)
          kb = k_bot(i,j)
          a_bot(i,j) = a(i,j,kb)
          b_bot(i,j) = b(i,j,kb)
       enddo   
       enddo   
  endif

 end subroutine get_bottom_data

!#######################################################################

 subroutine put_bottom_data ( a_bot, b_bot, a, b, k_bot ) 

!-------- Insert data into the lowest model level ---------
! a_bot,
!    b_bot = 2-D data fields containing data for the lowest level
! a, b     = 3-D data fields with data inserted into lowest level
! k_bot    = index of lowest model level (optional)
!-----------------------------------------------------------

  real   , intent(in)   , dimension(:,:)   :: a_bot, b_bot
  real   , intent(inout), dimension(:,:,:) :: a    , b
  integer, intent(in)   , dimension(:,:), optional :: k_bot

! inserts the lowest level data (a_bot,b_bot) into 3d fields (a,b)

  integer :: i, j, kb, kb_min

                      kb_min = size(a,3)
  if (present(k_bot)) kb_min = minval (k_bot)

  if ( kb_min == size(a,3) ) then
          a(:,:,kb_min) = a_bot
          b(:,:,kb_min) = b_bot
  else
       do j = 1, size(a,2)
       do i = 1, size(a,1)
          kb = k_bot(i,j)
          a(i,j,kb) = a_bot(i,j)
          b(i,j,kb) = b_bot(i,j)
       enddo
       enddo
  endif

 end subroutine put_bottom_data

!#######################################################################

 subroutine atmosphere_domain(Domain)
 type(domain2d), intent(inout) :: Domain

 Domain = Hgrid%Tmp%Domain

 end subroutine atmosphere_domain
!#######################################################################

end module bgrid_core_driver_mod

module ocean_domains_mod
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Matthew Harrison 
!</CONTACT>
!
!<OVERVIEW>
! Set the ocean domain parameters. 
!</OVERVIEW>
!
!<DESCRIPTION>
! The module computes the horizontal domain parameters needed to 
! run MOM in a parallel computational environment. 
! </DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies, M.J. Harrison,  R.C. Pacanowski, and A. Rosati
! A Technical Guide to MOM4 (2003)
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_domains_nml">
!  <DATA NAME="halo" UNITS="dimensionless" TYPE="integer">
!  For specifying the halo size by hand.
!  </DATA> 
!  <DATA NAME="max_tracers" UNITS="dimensionless" TYPE="integer">
!  temporary - need to call domains_init before tracer_init 
!  Used for computing mpp_stack_size.
!  </DATA> 
!  <DATA NAME="x_cyclic_offset" UNITS="dimensionless" TYPE="integer">
!  offset to be applied on x-direction boundary condition. Its value could
!  be positive or negative and the default value is 0. When the y-direction 
!  boundary condition is folded-north(tripolar grid), x_cyclic_offset must
!  be 0. For torus (cyclic in x and y-direction), at least one of 
!  x_cyclic_offset and y_cyclic_offset must be 0.   
!  </DATA> 
!  <DATA NAME="y_cyclic_offset" UNITS="dimensionless" TYPE="integer">
!  offset to be applied on y-direction boundary condition. Its value could
!  be positive or negative and the default value is 0. For torus (cyclic 
!  in x and y-direction), at least one of x_cyclic_offset and 
!  y_cyclic_offset must be 0.   
!  </DATA> 
!</NAMELIST>

use fms_mod,         only: open_namelist_file, write_version_number, check_nml_error, close_file
use mpp_domains_mod, only: mpp_define_layout, mpp_define_domains, mpp_domains_set_stack_size
use mpp_domains_mod, only: mpp_get_compute_domain, mpp_get_data_domain, mpp_get_global_domain
use mpp_domains_mod, only: FOLD_NORTH_EDGE, CYCLIC_GLOBAL_DOMAIN, mpp_define_io_domain
use mpp_mod,         only: input_nml_file, mpp_max, mpp_min, mpp_npes, mpp_error, FATAL, stdout, stdlog

use ocean_types_mod, only: ocean_domain_type, ocean_grid_type
use ocean_types_mod, only: ocean_prog_tracer_type, ocean_velocity_type

implicit none

private

integer, dimension(2) :: domain_layout=(/1,1/)
integer, dimension(2) :: io_domain_layout=(/0,0/)

character(len=128) :: version='$Id: ocean_domains.F90,v 20.0 2013/12/14 00:10:42 fms Exp $'
character(len=128) :: tagname='$Name: tikal $'

character(len=32) :: name_default = 'mom_domain'

public ocean_domain_init
public set_ocean_domain
public get_local_indices
public get_halo_sizes
public get_global_indices
public get_active_indices
public reduce_active_domain
public get_domain_offsets

integer     :: halo=1            ! size (cells) of halo region
integer     :: max_tracers = 10  ! temporary - need to call domains_init before tracer_init 
integer     :: x_cyclic_offset=0 ! offset applied to x-direction cyclic boundary condition
integer     :: y_cyclic_offset=0 ! offset applied to y-direction cyclic boundary condition
namelist /ocean_domains_nml/ halo, max_tracers, x_cyclic_offset, y_cyclic_offset

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_domain_init">
!
! <DESCRIPTION>
! Initialise the domain module.
! </DESCRIPTION>
!
subroutine ocean_domain_init()

  integer :: ierr,ioun,io_status,stdoutunit,stdlogunit
  stdoutunit=stdout();stdlogunit=stdlog() 

  call write_version_number(version, tagname)

  ! provide for namelist over-ride
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_domains_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_domains_nml')
#else
  ioun = open_namelist_file()
  read  (ioun, ocean_domains_nml,iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_domains_nml')
  call close_file(ioun)
#endif
  write (stdlogunit,ocean_domains_nml)
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_domains_nml)

end subroutine ocean_domain_init
! </SUBROUTINE> NAME="set_ocean_domain"

!#######################################################################
! <SUBROUTINE NAME="set_ocean_domain">
!
! <DESCRIPTION>
! For setting the ocean domain layout and associated parameters. 
! </DESCRIPTION>
!
subroutine set_ocean_domain (Domain, Grid, xhalo, yhalo, name, layout, io_layout, maskmap)

  type(ocean_grid_type),   intent(in)           :: Grid
  type(ocean_domain_type), intent(inout)        :: Domain
  integer,                 intent(in), optional :: xhalo, yhalo, layout(2), io_layout(2)
  logical,                 intent(in), optional :: maskmap(:,:)
  character(len=*),        intent(in), optional :: name

  real              :: ph, pc
  integer           :: n, nhp, ncp, ncp_max, ncp_min, ncpx, ncpy, lay_out(2), xsiz, ysiz
  integer           :: mpp_stack_size=-1 
  character(len=32) :: name_
  character(len=4)  :: char_lay1, char_lay2, char_npes, char_xsiz, char_ysiz


  if (PRESENT(layout)) domain_layout = layout
  if (PRESENT(io_layout)) io_domain_layout = io_layout
  if (domain_layout(1) == 1 .and. domain_layout(2) == 1) then
     call mpp_define_layout ((/1,Grid%ni,1,Grid%nj/), mpp_npes(), lay_out)
  else
     lay_out = domain_layout
  endif

  Domain%layout = lay_out
  Domain%io_layout = io_domain_layout

  allocate(Domain%maskmap(lay_out(1), lay_out(2)) )

  if(PRESENT(maskmap)) then
     Domain%maskmap = maskmap
  else
     Domain%maskmap = .TRUE.
  end if

  if (PRESENT(name)) then
     name_ = trim(name)
  else
     name_ = trim(name_default)
  endif

  if (PRESENT(xhalo)) then
     Domain%xhalo=xhalo
  else
     Domain%xhalo=halo
  endif

  if (PRESENT(yhalo)) then
     Domain%yhalo=yhalo
  else
     Domain%yhalo=halo
  endif


! setup 2D domains for local x-y regions (including halos) on each processor.

  if (Grid%cyclic_x) then

      ! spherical with tripolar Arctic
      if (Grid%tripolar) then
          if(x_cyclic_offset .NE. 0) call  mpp_error(FATAL, &
             '==>Error in ocean_domains_mod: x_cyclic_offset must be 0 for tripolar grid')
          call mpp_define_domains( (/1,Grid%ni,1,Grid%nj/), lay_out, Domain%domain2d, maskmap = Domain%maskmap&
               , xflags = cyclic_global_domain, yflags = FOLD_NORTH_EDGE, xhalo=Domain%xhalo, yhalo=Domain%yhalo,name=name_)
          Domain%xflags = cyclic_global_domain
          Domain%yflags = FOLD_NORTH_EDGE

      ! torus 
      elseif(Grid%cyclic_y) then 
          if(x_cyclic_offset*y_cyclic_offset .NE. 0) call  mpp_error(FATAL, &
             '==>Error in ocean_domains_mod: at least one of x_cyclic_offset and y_cyclic_offset must be 0 for torus')
          call mpp_define_domains( (/1,Grid%ni,1,Grid%nj/), lay_out, Domain%domain2d, maskmap = Domain%maskmap&
               , xflags = cyclic_global_domain, yflags = cyclic_global_domain, xhalo=Domain%xhalo, yhalo=Domain%yhalo, name=name_&
               , x_cyclic_offset=x_cyclic_offset, y_cyclic_offset=y_cyclic_offset)
          Domain%xflags = cyclic_global_domain
          Domain%yflags = cyclic_global_domain
 
      ! cyclic in x and solid wall in y
      else 
          call mpp_define_domains( (/1,Grid%ni,1,Grid%nj/), lay_out, Domain%domain2d, maskmap = Domain%maskmap&
               , xflags = cyclic_global_domain, xhalo=Domain%xhalo, yhalo=Domain%yhalo,name=name_, x_cyclic_offset=x_cyclic_offset)
          Domain%xflags = cyclic_global_domain
          Domain%yflags = 0
      endif

  else

      ! cyclic in y and solid wall in x (only physically relevant on beta or f plane)
      if(Grid%cyclic_y) then 
          call mpp_define_domains( (/1,Grid%ni,1,Grid%nj/), lay_out, Domain%domain2d, maskmap = Domain%maskmap&
               , yflags = cyclic_global_domain, xhalo=Domain%xhalo, yhalo=Domain%yhalo,name=name_, y_cyclic_offset=y_cyclic_offset)
          Domain%xflags = 0
          Domain%yflags = cyclic_global_domain
      
      ! four solid walls
      else 
          call mpp_define_domains( (/1,Grid%ni,1,Grid%nj/), lay_out, Domain%domain2d, maskmap = Domain%maskmap&
               , xhalo=Domain%xhalo, yhalo=Domain%yhalo,name=name_)
          Domain%xflags = 0
          Domain%yflags = 0

      endif

  endif
  call mpp_define_io_domain(Domain%domain2d, io_domain_layout)

  Domain%x_cyclic_offset = x_cyclic_offset
  Domain%y_cyclic_offset = y_cyclic_offset

  ! define data and compute indices for local domain on this processor

  call mpp_get_compute_domain (Domain%domain2d, Domain%isc, Domain%iec, &
       Domain%jsc, Domain%jec)

  call mpp_get_data_domain (Domain%domain2d, Domain%isd, Domain%ied, &
       Domain%jsd, Domain%jed)

  call mpp_get_global_domain (Domain%domain2d, Domain%isg, Domain%ieg, &
       Domain%jsg, Domain%jeg)

  Domain%isa = Domain%isc
  Domain%iea = Domain%iec
  Domain%jsa = Domain%jsc
  Domain%jea = Domain%jec

  Domain%ioff = 0
  Domain%joff = 0
  
#ifdef MOM_STATIC_ARRAYS

  if (Domain%xhalo == 1 .AND. Domain%yhalo == 1) then
     xsiz = Domain%iec - Domain%isc + 1
     ysiz = Domain%jec - Domain%jsc + 1
     Domain%ioff = Domain%isc - 1     
     Domain%isc = 1
     Domain%isd = 0
     Domain%iec = xsiz
     Domain%ied = xsiz+1
     Domain%joff = Domain%jsc - 1          
     Domain%jsc = 1
     Domain%jsd = 0
     Domain%jec = ysiz
     Domain%jed = ysiz+1
     
     if (xsiz /= NI_LOCAL_ .OR. ysiz /= NJ_LOCAL_) then
        write( char_xsiz,'(i4)' ) xsiz
        write( char_ysiz,'(i4)' ) ysiz
        call mpp_error(FATAL,'==>Error in ocean_domains_mod: domain size (xsiz,ysiz) = ('&
        //trim(char_xsiz)//','//trim(char_ysiz)// ') does not match size set by preprocessor macro.&
          & Disable MOM_STATIC_ARRAYS cpp-preprocessor option to use dynamic allocation. ')
     endif
 endif

#endif


  ncp_max = (Domain%iec-Domain%isc+1)*(Domain%jec-Domain%jsc+1)
  ncp_min = ncp_max
  call mpp_max(ncp_max)
  call mpp_min(ncp_min)

  ncp = (Domain%iec-Domain%isc+1)*(Domain%jec-Domain%jsc+1)
  nhp = 4*halo**2 + 2*(Domain%iec-Domain%isc+1 + Domain%jec-Domain%jsc+1)*halo
  ph = 100.0*nhp/(nhp+ncp)
  pc = 100.0 - ph

  ! estimate stack size
  if (mpp_stack_size <= 0) then 
    ncpx = Domain%iec-Domain%isc+1
    ncpy = Domain%jec-Domain%jsc+1
    call mpp_max (ncpx)
    call mpp_max (ncpy)
    mpp_stack_size = 2*(ncpx + 2*max(Domain%xhalo,Domain%yhalo))*&
                    (ncpy + 2*max(Domain%xhalo,Domain%yhalo))*Grid%nk*(max_tracers) 
  endif

  call mpp_domains_set_stack_size(mpp_stack_size)

end subroutine set_ocean_domain
! </SUBROUTINE> NAME="set_ocean_domain"


!#######################################################################
! <SUBROUTINE NAME="get_local_indices">
!
! <DESCRIPTION>
! For getting local indices from domain derived type. 
! </DESCRIPTION>
!
subroutine get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)

  type(ocean_domain_type), intent(in) :: Domain
  integer, intent(out)                :: isd, ied, jsd, jed, isc, iec, jsc, jec
  
  isd=Domain%isd;ied=Domain%ied;jsd=Domain%jsd;jed=Domain%jed
  isc=Domain%isc;iec=Domain%iec;jsc=Domain%jsc;jec=Domain%jec

  
end subroutine get_local_indices
! </SUBROUTINE> NAME="get_local_indices"


!#######################################################################
! <SUBROUTINE NAME="get_domain_offsets">
!
! <DESCRIPTION>
! For getting domain offsets from domain derived type. 
! </DESCRIPTION>
!
subroutine get_domain_offsets(Domain, ioff, joff)

  type(ocean_domain_type), intent(in)  :: Domain
  integer,                 intent(out) :: ioff, joff
  
  ioff = Domain%ioff
  joff = Domain%joff
  
end subroutine get_domain_offsets
! </SUBROUTINE> NAME="get_domain_offsets"


!#######################################################################
! <SUBROUTINE NAME="get_active_indices">
!
! <DESCRIPTION>
! For getting active domain indices from domain derived type. 
! </DESCRIPTION>
!
subroutine get_active_indices(Domain, isa, iea, jsa, jea)

  type(ocean_domain_type), intent(in) :: Domain
  integer, intent(out)                :: isa, iea, jsa, jea

  isa=Domain%isa;iea=Domain%iea;jsa=Domain%jsa;jea=Domain%jea

end subroutine get_active_indices
! </SUBROUTINE> NAME="get_active_indices"


!#######################################################################
! <SUBROUTINE NAME="get_global_indices">
!
! <DESCRIPTION>
! For getting global indices from domain derived type. 
! </DESCRIPTION>
!
subroutine get_global_indices(Domain, isg, ieg, jsg, jeg)

  type(ocean_domain_type), intent(in)  :: Domain
  integer,                 intent(out) :: isg, ieg, jsg, jeg

  isg=Domain%isg;ieg=Domain%ieg;jsg=Domain%jsg;jeg=Domain%jeg
  
end subroutine get_global_indices
! </SUBROUTINE> NAME="get_global_indices"



!#######################################################################
! <SUBROUTINE NAME="reduce_active_domain">
!
! <DESCRIPTION>
! For getting reducing the active domain 
! </DESCRIPTION>
!
subroutine reduce_active_domain(Domain,inc_x,inc_y)

  type(ocean_domain_type), intent(inout)        :: Domain
  integer,                 intent(in), optional :: inc_x, inc_y
  integer                                       :: inc

  if (PRESENT(inc_x)) then
     if (inc_x < 1) call mpp_error(FATAL,'==>Error: active domain decrement must be positive')
     inc = inc_x
  else
     inc = 1
  endif

  Domain%isa = Domain%isa + inc
  Domain%iea = Domain%iea - inc

  if (PRESENT(inc_y)) then
     if (inc_y < 1) call mpp_error(FATAL,'==>Error: active domain decrement must be positive')
     inc = inc_y
  else
     inc = 1
  endif

  Domain%jsa = Domain%jsa + inc
  Domain%jea = Domain%jea - inc

end subroutine reduce_active_domain
! </SUBROUTINE> NAME="reduce_active_domain"



!#######################################################################
! <SUBROUTINE NAME="get_halo_sizes">
!
! <DESCRIPTION>
! For getting halo sizes from domain derived type. 
! </DESCRIPTION>
!
subroutine get_halo_sizes(Domain, xhalo, yhalo)

  type(ocean_domain_type), intent(in)            :: Domain
  integer,                 intent(out), optional :: xhalo, yhalo

  if (PRESENT(xhalo)) xhalo = Domain%xhalo
  if (PRESENT(yhalo)) yhalo = Domain%yhalo

end subroutine get_halo_sizes
! </SUBROUTINE> NAME="get_halo_sizes"

  
end module ocean_domains_mod

#include <fms_platform.h>

MODULE diag_grid_mod
  ! <CONTACT EMAIL="seth.underwood@noaa.gov">
  !   Seth Underwood
  ! </CONTACT>
  ! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/" />
  ! <OVERVIEW>
  !   <TT>diag_grid_mod</TT> is a set of procedures to work with the
  !   model's global grid to allow regional output.
  ! </OVERVIEW>
  ! <DESCRIPTION>
  !   <TT>diag_grid_mod</TT> contains useful utilities for dealing
  !   with, mostly, regional output for grids other than the standard
  !   lat/lon grid.  This module contains three public procedures <TT>
  !   diag_grid_init</TT>, which is shared globably in the <TT>
  !   diag_manager_mod</TT>, <TT>diag_grid_end</TT> which will free
  !   up memory used during the register field calls, and
  !   <TT>get_local_indexes</TT>.  The <TT>send_global_grid</TT>
  !   procedure is called by the model that creates the global grid.
  !   <TT>send_global_grid</TT> needs to be called before any fields
  !   are registered that will output only regions.  <TT>get_local_indexes</TT>
  !   is to be called by the <TT>diag_manager_mod</TT> to discover the
  !   global indexes defining a subregion on the tile.
  !
  !   <B>Change Log</B>
  !   <DL>
  !     <DT>September 2009</DT>
  !     <DD>
  !       <UL>
  !         <LI>Single point region in Cubed Sphere</LI>
  !         <LI>Single tile regions in the cubed sphere</LI>
  !       </UL>
  !     </DD>
  !   </DL>
  ! </DESCRIPTION>

  ! <INFO>
  !   <FUTURE>
  !     Multi-tile regional output in the cubed sphere.
  !   </FUTURE>
  !   <FUTURE>
  !     Single grid in the tri-polar grid.
  !   </FUTURE>
  !   <FUTURE>
  !     Multi-tile regional output in the tri-polar grid.
  !   </FUTURE>
  !   <FUTURE>
  !     Regional output using array masking.  This should allow
  !     regional output to work on any current or future grid.
  !   </FUTURE>
  ! </INFO>
  USE constants_mod, ONLY: DEG_TO_RAD, RAD_TO_DEG, RADIUS
  USE fms_mod, ONLY: write_version_number, error_mesg, WARNING, FATAL,&
       & mpp_pe
  USE mpp_mod, ONLY: mpp_root_pe, mpp_npes, mpp_max, mpp_min
  USE mpp_domains_mod, ONLY: domain2d, mpp_get_tile_id,&
       & mpp_get_ntile_count, mpp_get_compute_domains

  IMPLICIT NONE

  ! Parameters
  CHARACTER(len=128), PARAMETER :: version =&
       & '$Id$'
  CHARACTER(len=128), PARAMETER :: tagname =&
       & '$Name$'

  ! Derived data types
  ! <PRIVATE>
  ! <TYPE NAME="diag_global_grid_type">
  !   <DESCRIPTION>
  !     Contains the model's global grid data, and other grid information.
  !   </DESCRIPTION>
  !   <DATA NAME="glo_lat" TYPE="REAL, _ALLOCATABLE, DIMENSION(:,:)">
  !     The latitude values on the global grid.
  !   </DATA>
  !   <DATA NAME="glo_lon" TYPE="REAL, _ALLOCATABLE, DIMENSION(:,:)">
  !     The longitude values on the global grid.
  !   </DATA>
  !   <DATA NAME="aglo_lat" TYPE="REAL, _ALLOCATABLE, DIMENSION(:,:)">
  !     The latitude values on the global a-grid.  Here we expect isc-1:iec+1 and
  !     jsc=1:jec+1 to be passed in.
  !   </DATA>
  !   <DATA NAME="aglo_lon" TYPE="REAL, _ALLOCATABLE, DIMENSION(:,:)">
  !     The longitude values on the global a-grid.  Here we expec isc-1:iec+j and
  !     jsc-1:jec+1 to be passed in.
  !   </DATA>
  !   <DATA NAME="myXbegin" TYPE="INTEGER">
  !     The starting index of the compute domain on the current PE.
  !   </DATA>
  !   <DATA NAME="myYbegin" TYPE="INTEGER">
  !     The starting index of the compute domain on the cureent PE.
  !   </DATA>
  !   <DATA NAME="dimI" TYPE="INTEGER">
  !     The dimension of the global grid in the 'i' / longitudal direction.
  !   </DATA>
  !   <DATA NAME="dimJ" TYPE="INTEGER">
  !     The dimension of the global grid in the 'j' / latitudal direction.
  !   </DATA>
  !   <DATA NAME="adimI" TYPE="INTEGER">
  !     The dimension of the global a-grid in the 'i' / longitudal direction.  Again,
  !     the expected dimension for diag_grid_mod is isc-1:iec+1.
  !   </DATA>
  !   <DATA NAME="adimJ" TYPE="INTEGER">
  !     The dimension of the global a-grid in the 'j' / latitudal direction.  Again,
  !     the expected dimension for diag_grid_mod is jsc-1:jec+1.
  !   </DATA>
  !   <DATA NAME="tile_number" TYPE="INTEGER">
  !     The tile the <TT>glo_lat</TT> and <TT>glo_lon</TT> define.
  !   </DATA>
  !   <DATA NAME="ntimes" TYPE="INTEGER">
  !     The number of tiles.
  !   </DATA>
  !   <DATA NAME="peStart" TYPE="INTEGER">
  !     The starting PE number for the current tile.
  !   </DATA>
  !   <DATA NAME="peEnd" TYPE="INTEGER">
  !     The ending PE number for the current tile.
  !   </DATA>
  !   <DATA NAME="grid_type" TYPE="CHARACTER(len=128)">
  !     The global grid type.
  !   </DATA>
  TYPE :: diag_global_grid_type
     REAL, _ALLOCATABLE, DIMENSION(:,:) :: glo_lat, glo_lon
     REAL, _ALLOCATABLE, DIMENSION(:,:) :: aglo_lat, aglo_lon
     INTEGER :: myXbegin, myYbegin
     INTEGER :: dimI, dimJ
     INTEGER :: adimI, adimJ
     INTEGER :: tile_number
     INTEGER :: ntiles
     INTEGER :: peStart, peEnd
     CHARACTER(len=128) :: grid_type
  END TYPE diag_global_grid_type
  ! </TYPE>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <TYPE NAME="point">
  !   <DESCRIPTION>
  !      Private point type to hold the (x,y,z) location for a (lat,lon)
  !      location.
  !   </DESCRIPTION>
  !   <DATA NAME="x" TYPE="REAL">
  !     The x value of the (x,y,z) coordinates.
  !   </DATA>
  !   <DATA NAME="y" TYPE="REAL">
  !     The y value of the (x,y,z) coordinates.
  !   </DATA>
  !   <DATA NAME="z" TYPE="REAL">
  !     The z value of the (x,y,z) coordinates.
  !   </DATA>
  TYPE :: point
     REAL :: x,y,z
  END TYPE point
  ! </TYPE>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <DATA NAME="diag_global_grid" TYPE="TYPE(diag_global_grid_type)">
  !   Variable to hold the global grid data
  ! </DATA>
  ! </PRIVATE>
  TYPE(diag_global_grid_type) :: diag_global_grid

  ! <PRIVATE>
  ! <DATA NAME="diag_grid_initialized" TYPE="LOGICAL" DEFAULT=".FALSE.">
  !   Indicates if the diag_grid_mod has been initialized.
  ! </DATA>
  ! </PRIVATE>
  LOGICAL :: diag_grid_initialized = .FALSE.

  PRIVATE
  PUBLIC :: diag_grid_init, diag_grid_end, get_local_indexes,  &
            get_local_indexes2

CONTAINS

  ! <SUBROUTINE NAME="diag_grid_init">
  !   <OVERVIEW>
  !     Send the global grid to the <TT>diag_manager_mod</TT> for
  !     regional output.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE diag_grid_init(domain, glo_lat, glo_lon, aglo_lat, aglo_lon)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     In order for the diag_manager to do regional output for grids
  !     other than the standard lat/lon grid, the <TT>
  !     diag_manager_mod</TT> needs to know the the latitude and
  !     longitude values for the entire global grid.  This procedure
  !     is the mechanism the models will use to share their grid with
  !     the diagnostic manager.
  !
  !     This procedure needs to be called after the grid is created,
  !     and before the first call to register the fields.
  !   </DESCRIPTION>
  !   <IN NAME="domain" TYPE="INTEGER">
  !     The domain to which the grid data corresponds.
  !   </IN>
  !   <IN NAME="glo_lat" TYPE="REAL, DIMENSION(:,:)">
  !     The latitude information for the grid tile.
  !   </IN>
  !   <IN NAME="glo_lon" TYPE="REAL, DIMENSION(:,:)">
  !     The longitude information for the grid tile.
  !   </IN>
  !   <IN NAME="aglo_lat" TYPE="REAL, DIMENSION(:,:)">
  !     The latitude information for the a-grid tile.
  !   </IN>
  !   <IN NAME="aglo_lon" TYPE="REAL, DIMENSION(:,:)">
  !     The longitude information for the a-grid tile.
  !   </IN>
  SUBROUTINE diag_grid_init(domain, glo_lat, glo_lon, aglo_lat, aglo_lon)
    TYPE(domain2d), INTENT(in) :: domain
    REAL, INTENT(in), DIMENSION(:,:) :: glo_lat, glo_lon
    REAL, INTENT(in), DIMENSION(:,:) :: aglo_lat, aglo_lon

    INTEGER, DIMENSION(1) :: tile
    INTEGER :: ntiles
    INTEGER :: stat
    INTEGER :: i_dim, j_dim
    INTEGER :: ai_dim, aj_dim
    INTEGER, DIMENSION(2) :: latDim, lonDim
    INTEGER, DIMENSION(2) :: alatDim, alonDim
    INTEGER :: myPe, npes, npesPerTile
    INTEGER, ALLOCATABLE, DIMENSION(:) :: xbegin, xend, ybegin, yend

    ! Write the version and tagname to the logfile
    CALL write_version_number(version, tagname)

    ! Verify all allocatable / pointers for diag_global_grid hare not
    ! allocated / associated.
    IF ( ALLOCATED(xbegin) ) DEALLOCATE(xbegin)
    IF ( ALLOCATED(ybegin) ) DEALLOCATE(ybegin)
    IF ( ALLOCATED(xend) ) DEALLOCATE(xend)
    IF ( ALLOCATED(yend) ) DEALLOCATE(yend)

    ! What is my PE
    myPe = mpp_pe() -mpp_root_pe() + 1

    ! Get the domain/pe layout, and allocate the [xy]begin|end arrays/pointers
    npes = mpp_npes()
    ALLOCATE(xbegin(npes), &
         &   ybegin(npes), &
         &   xend(npes), &
         &   yend(npes), STAT=stat)
    IF ( stat .NE. 0 ) THEN
       CALL error_mesg('diag_grid_mod::diag_grid_init',&
            &'Could not allocate memory for the compute grid indices&
            &.', FATAL)
    END IF

    ! Get tile information
    ntiles = mpp_get_ntile_count(domain)
    tile = mpp_get_tile_id(domain)

    ! Number of PEs per tile
    npesPerTile = npes / ntiles
    diag_global_grid%peEnd = npesPerTile * tile(1)
    diag_global_grid%peStart = diag_global_grid%peEnd - npesPerTile + 1

    ! Get the compute domains
    CALL mpp_get_compute_domains(domain,&
         & XBEGIN=xbegin, XEND=xend,&
         & YBEGIN=ybegin, YEND=yend)

    ! Module initialized
    diag_grid_initialized = .TRUE.

    ! Get the size of the grids
    latDim = SHAPE(glo_lat)
    lonDim = SHAPE(glo_lon)
    IF (  (latDim(1) == lonDim(1)) .AND.&
         &(latDim(2) == lonDim(2)) ) THEN
       i_dim = latDim(1)
       j_dim = latDim(2)
    ELSE
       CALL error_mesg('diag_grid_mod::diag_grid_init',&
            &'glo_lat and glo_lon must be the same shape.', FATAL)
    END IF

    ! Same thing for the a-grid
    alatDim = SHAPE(aglo_lat)
    alonDim = SHAPE(aglo_lon)
    IF (  (alatDim(1) == alonDim(1)) .AND. &
         &(alatDim(2) == alonDim(2)) ) THEN
       IF ( tile(1) == 4 .OR. tile(1) == 5 ) THEN
          ! These tiles need to be transposed.
          ai_dim = alatDim(2)
          aj_dim = alatDim(1)
       ELSE
          ai_dim = alatDim(1)
          aj_dim = alatDim(2)
       END IF
    ELSE
       CALL error_mesg('diag_grid_mod::diag_grid_init',&
            & "a-grid's glo_lat and glo_lon must be the same shape.", FATAL)
    END IF

    ! Allocate the grid arrays
    IF (   _ALLOCATED(diag_global_grid%glo_lat) .OR.&
         & _ALLOCATED(diag_global_grid%glo_lon) ) THEN
       IF ( mpp_pe() == mpp_root_pe() ) &
            & CALL error_mesg('diag_grid_mod::diag_grid_init',&
            &'The global grid has already been initialized', WARNING)
    ELSE
       ALLOCATE(diag_global_grid%glo_lat(i_dim,j_dim),&
            &   diag_global_grid%glo_lon(i_dim,j_dim), STAT=stat)
       IF ( stat .NE. 0 ) THEN
          CALL error_mesg('diag_grid_mod::diag_grid_init',&
               &'Could not allocate memory for the global grid.', FATAL)
       END IF
    END IF

    ! Same thing for the a-grid
    IF (   _ALLOCATED(diag_global_grid%aglo_lat) .OR.&
         & _ALLOCATED(diag_global_grid%aglo_lon) ) THEN
       IF ( mpp_pe() == mpp_root_pe() ) &
            & CALL error_mesg('diag_grid_mod::diag_grid_init',&
            &'The global a-grid has already been initialized', WARNING)
    ELSE
       ALLOCATE(diag_global_grid%aglo_lat(0:ai_dim-1,0:aj_dim-1),&
            &   diag_global_grid%aglo_lon(0:ai_dim-1,0:aj_dim-1), STAT=stat)
       IF ( stat .NE. 0 ) THEN
          CALL error_mesg('diag_global_mod::diag_grid_init',&
               &'Could not allocate memory for the global a-grid', FATAL)
       END IF
    END IF

    ! Set the values for diag_global_grid

    ! If we are on tile 4 or 5, we need to transpose the grid to get
    ! this to work.
    IF ( tile(1) == 4 .OR. tile(1) == 5 ) THEN
       diag_global_grid%aglo_lat = TRANSPOSE(aglo_lat)
       diag_global_grid%aglo_lon = TRANSPOSE(aglo_lon)
    ELSE
       diag_global_grid%aglo_lat = aglo_lat
       diag_global_grid%aglo_lon = aglo_lon
    END IF
    diag_global_grid%glo_lat = glo_lat
    diag_global_grid%glo_lon = glo_lon
    diag_global_grid%dimI = i_dim
    diag_global_grid%dimJ = j_dim
    diag_global_grid%adimI = ai_dim
    diag_global_grid%adimJ = aj_dim
    !--- For the nested model, the nested region only has 1 tile ( ntiles = 1) but 
    !--- the tile_id is 7 for the nested region. In the routine get_local_indexes,
    !--- local variables ijMin and ijMax have dimesnion (ntiles) and will access
    !--- ijMin(diag_global_grid%tile_number,:). For the nested region, ntiles = 1 and 
    !--- diag_global_grid%tile_number = 7 will cause out of bounds. So need to
    !--- set diag_global_grid%tile_number = 1 when ntiles = 1 for the nested model.
    if(ntiles == 1) then
       diag_global_grid%tile_number = 1
    else
       diag_global_grid%tile_number = tile(1)
    endif
    diag_global_grid%ntiles = ntiles
    diag_global_grid%myXbegin = xbegin(myPe)
    diag_global_grid%myYbegin = ybegin(myPe)

    ! Unallocate arrays used here
    DEALLOCATE(xbegin)
    DEALLOCATE(ybegin)
    DEALLOCATE(xend)
    DEALLOCATE(yend)
  END SUBROUTINE diag_grid_init
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="diag_grid_end">
  !   <OVERVIEW>
  !     Unallocate the diag_global_grid variable.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE diag_grid_end()
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     The <TT>diag_global_grid</TT> variable is only needed during
  !     the register field calls, and then only if there are fields
  !     requestion regional output.  Once all the register fields
  !     calls are complete (before the first <TT>send_data</TT> call
  !     this procedure can be called to free up memory.
  !   </DESCRIPTION>
  SUBROUTINE diag_grid_end()

    IF ( diag_grid_initialized ) THEN
       ! De-allocate grid
       IF ( _ALLOCATED(diag_global_grid%glo_lat) ) THEN
          DEALLOCATE(diag_global_grid%glo_lat)
       ELSE IF ( mpp_pe() == mpp_root_pe() ) THEN
          CALL error_mesg('diag_grid_mod::diag_grid_end',&
               &'diag_global_grid%glo_lat was not allocated.', WARNING)
       END IF

       IF ( _ALLOCATED(diag_global_grid%glo_lon) ) THEN
          DEALLOCATE(diag_global_grid%glo_lon)
       ELSE IF ( mpp_pe() == mpp_root_pe() ) THEN
          CALL error_mesg('diag_grid_mod::diag_grid_end',&
               &'diag_global_grid%glo_lon was not allocated.', WARNING)
       END IF
       ! De-allocate a-grid
       IF ( _ALLOCATED(diag_global_grid%aglo_lat) ) THEN
          DEALLOCATE(diag_global_grid%aglo_lat)
       ELSE IF ( mpp_pe() == mpp_root_pe() ) THEN
          CALL error_mesg('diag_grid_mod::diag_grid_end',&
               &'diag_global_grid%aglo_lat was not allocated.', WARNING)
       END IF

       IF ( _ALLOCATED(diag_global_grid%aglo_lon) ) THEN
          DEALLOCATE(diag_global_grid%aglo_lon)
       ELSE IF ( mpp_pe() == mpp_root_pe() ) THEN
          CALL error_mesg('diag_grid_mod::diag_grid_end',&
               &'diag_global_grid%aglo_lon was not allocated.', WARNING)
       END IF

       diag_grid_initialized = .FALSE.
    END IF
  END SUBROUTINE diag_grid_end
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="get_local_indexes">
  !   <OVERVIEW>
  !     Find the local start and local end indexes on the local PE
  !     for regional output.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE get_local_indexes(latStart, latEnd, lonStart,
  !     lonEnd, istart, iend, jstart, jend)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Given a defined region, find the local indexes on the local
  !     PE surrounding the region.
  !   </DESCRIPTION>
  !   <IN NAME="latStart" TYPE="REAL">
  !     The minimum latitude value defining the region.  This value
  !     must be less than latEnd, and be in the range [-90,90]
  !   </IN>
  !   <IN NAME="latEnd" TYPE="REAL">
  !     The maximum latitude value defining the region.  This value
  !     must be greater than latStart, and be in the range [-90,90]
  !   </IN>
  !   <IN NAME="lonStart" TYPE="REAL">
  !     The western most longitude value defining the region.
  !     Possible ranges are either [-180,180] or [0,360].
  !   </IN>
  !   <IN NAME="lonEnd" TYPE="REAL">
  !     The eastern most longitude value defining the region.
  !     Possible ranges are either [-180,180] or [0,360].
  !   </IN>
  !   <OUT NAME="istart" TYPE="INTEGER">
  !     The local start index on the local PE in the 'i' direction.
  !   </OUT>
  !   <OUT NAME="iend" TYPE="INTEGER">
  !     The local end index on the local PE in the 'i' direction.
  !   </OUT>
  !   <OUT NAME="jstart" TYPE="INTEGER">
  !     The local start index on the local PE in the 'j' direction.
  !   </OUT>
  !   <OUT NAME="jend" TYPE="INTEGER">
  !     The local end index on the local PE in the 'j' direction.
  !   </OUT>
  SUBROUTINE get_local_indexes(latStart, latEnd, lonStart, lonEnd,&
       & istart, iend, jstart, jend)
    REAL, INTENT(in) :: latStart, lonStart !< lat/lon start angles
    REAL, INTENT(in) :: latEnd, lonEnd !< lat/lon end angles
    INTEGER, INTENT(out) :: istart, jstart !< i/j start indexes
    INTEGER, INTENT(out) :: iend, jend !< i/j end indexes

    REAL, ALLOCATABLE, DIMENSION(:,:) :: delta_lat, delta_lon, grid_lon

    REAL, DIMENSION(4) :: dists_lon, dists_lat
    REAL :: lonEndAdj, my_lonStart, my_lonEnd

    INTEGER, ALLOCATABLE, DIMENSION(:,:) :: ijMin, ijMax
    INTEGER :: myTile, ntiles, i, j, k, dimI, dimJ, istat
    INTEGER :: count

    LOGICAL :: onMyPe

    IF ( .NOT. diag_grid_initialized )&
         & CALL error_mesg('diag_grid_mod::get_local_indexes',&
         &'Module not initialized, first initialze module with a call &
         &to diag_grid_init', FATAL)

    myTile = diag_global_grid%tile_number
    ntiles = diag_global_grid%ntiles

    ! Arrays to home min/max for each tile
    ALLOCATE(ijMin(ntiles,2), STAT=istat)
    IF ( istat .NE. 0 )&
         & CALL error_mesg('diag_grid_mod::get_local_indexes',&
         &'Cannot allocate ijMin index array', FATAL)
    ALLOCATE(ijMax(ntiles,2), STAT=istat)
    IF ( istat .NE. 0 )&
         & CALL error_mesg('diag_grid_mod::get_local_indexes',&
         &'Cannot allocate ijMax index array', FATAL)
    ijMin = 0
    ijMax = 0

    ! Make adjustment for negative longitude values
    if ( lonStart < 0. ) then
       my_lonStart = lonStart + 360.
    else
       my_lonStart = lonStart
    end if
    if ( lonEnd < 0. ) then
       my_lonEnd = lonEnd + 360.
    else
       my_lonEnd = lonEnd
    end if

    ! There will be four points to define a region, find all four.
    ! Need to call the correct function depending on if the tile is a
    ! pole tile or not.
    !
    ! Also, if looking for a single point, then use the a-grid
    IF ( latStart == latEnd .AND. my_lonStart == my_lonEnd ) THEN
       ! single point
       IF ( MOD(diag_global_grid%tile_number,3) == 0 ) THEN
          ijMax(myTile,:) = find_pole_index_agrid(latStart,my_lonStart)
       ELSE
          ijMax(myTile,:) = find_equator_index_agrid(latStart,my_lonStart)
       END IF

       WHERE ( ijMax(:,1) .NE. 0 )
          ijMax(:,1) = ijMax(:,1) + diag_global_grid%myXbegin - 1
       END WHERE
       WHERE ( ijMax(:,2) .NE. 0 )
          ijMax(:,2) = ijMax(:,2) + diag_global_grid%myYbegin - 1
       END WHERE

       DO j = 1, 6 ! Each tile.
          CALL mpp_max(ijMax(j,1))
          CALL mpp_max(ijMax(j,2))
       END DO

       ijMin = ijMax
    ELSE
       ! multi-point
       dimI = diag_global_grid%dimI
       dimJ = diag_global_grid%dimJ
       ! Build the delta array
       ALLOCATE(delta_lat(dimI,dimJ), STAT=istat)
       IF ( istat .NE. 0 )&
            & CALL error_mesg('diag_grid_mod::get_local_indexes',&
            &'Cannot allocate latitude delta array', FATAL)
       ALLOCATE(delta_lon(dimI,dimJ), STAT=istat)
       IF ( istat .NE. 0 )&
            & CALL error_mesg('diag_grid_mod::get_local_indexes',&
            &'Cannot allocate longitude delta array', FATAL)
       DO j=1, dimJ
          DO i=1, dimI
             count = 0
             dists_lon = 0.
             dists_lat = 0.
             IF ( i < dimI ) THEN
                dists_lon(1) = ABS(diag_global_grid%glo_lon(i+1,j) - diag_global_grid%glo_lon(i,j))
                dists_lat(1) = ABS(diag_global_grid%glo_lat(i+1,j) - diag_global_grid%glo_lat(i,j))
                count = count+1
             END IF
             IF ( j < dimJ ) THEN
                dists_lon(2) = ABS(diag_global_grid%glo_lon(i,j+1) - diag_global_grid%glo_lon(i,j))
                dists_lat(2) = ABS(diag_global_grid%glo_lat(i,j+1) - diag_global_grid%glo_lat(i,j))
                count = count+1
             END IF
             IF ( i > 1 ) THEN
                dists_lon(3) = ABS(diag_global_grid%glo_lon(i,j) - diag_global_grid%glo_lon(i-1,j))
                dists_lat(3) = ABS(diag_global_grid%glo_lat(i,j) - diag_global_grid%glo_lat(i-1,j))
                count = count+1
             END IF
             IF ( j > 1 ) THEN
                dists_lon(4) = ABS(diag_global_grid%glo_lon(i,j) - diag_global_grid%glo_lon(i,j-1))
                dists_lat(4) = ABS(diag_global_grid%glo_lat(i,j) - diag_global_grid%glo_lat(i,j-1))
                count = count+1
             END IF

             ! Fix wrap around problem
             DO k=1, 4
                IF ( dists_lon(k) > 180.0 ) THEN
                   dists_lon(k) = 360.0 - dists_lon(k)
                END IF
             END DO
             delta_lon(i,j) = SUM(dists_lon)/real(count)
             delta_lat(i,j) = SUM(dists_lat)/real(count)
          END DO
       END DO

       ijMin = HUGE(1)
       ijMax = -HUGE(1)

       ! Adjusted longitude array
       ALLOCATE(grid_lon(dimI,dimJ), STAT=istat)
       IF ( istat .NE. 0 )&
            & CALL error_mesg('diag_grid_mod::get_local_indexes',&
            &'Cannot allocate temporary longitude array', FATAL)
       grid_lon = diag_global_grid%glo_lon

       ! Make adjustments where required
       IF ( my_lonStart > my_lonEnd ) THEN
          WHERE ( grid_lon < my_lonStart )
             grid_lon = grid_lon + 360.0
          END WHERE
          lonEndAdj = my_lonEnd + 360.0
       ELSE
          lonEndAdj = my_lonEnd
       END IF

       DO j=1, dimJ-1
          DO i=1, dimI-1
             onMyPe = .false.
             IF ( latStart-delta_lat(i,j) <= diag_global_grid%glo_lat(i,j) .AND.&
                  & diag_global_grid%glo_lat(i,j) < latEnd+delta_lat(i,j) ) THEN
                ! Short-cut for the poles
                IF ( (ABS(latStart)-delta_lat(i,j) <= 90.0 .AND.&
                     & 90.0 <= ABS(latEnd)+delta_lat(i,j)) .AND.&
                     & ABS(diag_global_grid%glo_lat(i,j)) == 90.0 ) THEN
                   onMyPe = .TRUE.
                ELSE IF ( (my_lonStart-delta_lon(i,j) <= grid_lon(i,j) .AND.&
                     & grid_lon(i,j) < lonEndAdj+delta_lon(i,j)) ) THEN
                   onMyPe = .TRUE.
                ELSE
                   onMyPe = .FALSE.
                END IF
                IF ( onMyPe ) THEN
                   ijMin(myTile,1) = MIN(ijMin(myTile,1),i + diag_global_grid%myXbegin - 1)
                   ijMax(myTile,1) = MAX(ijMax(myTile,1),i + diag_global_grid%myXbegin - 1)
                   ijMin(myTile,2) = MIN(ijMin(myTile,2),j + diag_global_grid%myYbegin - 1)
                   ijMax(myTile,2) = MAX(ijMax(myTile,2),j + diag_global_grid%myYbegin - 1)
                END IF
             END IF
          END DO
       END DO
       DEALLOCATE(delta_lon)
       DEALLOCATE(delta_lat)
       DEALLOCATE(grid_lon)

       ! Global min/max reduce
       DO i=1, ntiles
          CALL mpp_min(ijMin(i,1))
          CALL mpp_max(ijMax(i,1))
          CALL mpp_min(ijMin(i,2))
          CALL mpp_max(ijMax(i,2))
       END DO

       IF ( ijMin(myTile,1) == HUGE(1) .OR. ijMax(myTile,1) == -HUGE(1) ) THEN
          ijMin(myTile,1) = 0
          ijMax(myTile,1) = 0
       END IF
       IF ( ijMin(myTile,2) == HUGE(1) .OR. ijMax(myTile,2) == -HUGE(1) ) THEN
          ijMin(myTile,2) = 0
          ijMax(myTile,2) = 0
       END IF
    END IF

    istart = ijMin(myTile,1)
    jstart = ijMin(myTile,2)
    iend = ijMax(myTile,1)
    jend = ijMax(myTile,2)

    DEALLOCATE(ijMin)
    DEALLOCATE(ijMax)
  END SUBROUTINE get_local_indexes
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="get_local_indexes2">
  !   <OVERVIEW>
  !     Find the indices of the nearest grid point of the a-grid to the
  !     specified (lon,lat) location on the local PE. if desired point not
  !     within domain of local PE, return (0,0) as the indices.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE get_local_indexes2 (lat, lon, iindex, jindex)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Given a specified location, find the nearest a-grid indices on
  !     the local PE.
  !   </DESCRIPTION>
  !   <IN NAME="lat" TYPE="REAL">
  !     The requested latitude.  This value must be in the range [-90,90]
  !   </IN>
  !   <IN NAME="lon" TYPE="REAL">
  !     The requested longitude.
  !     Possible ranges are either [-180,180] or [0,360].
  !   </IN>
  !   <OUT NAME="iindex" TYPE="INTEGER">
  !     The local index on the local PE in the 'i' direction.
  !   </OUT>
  !   <OUT NAME="jindex" TYPE="INTEGER">
  !     The local index on the local PE in the 'j' direction.
  !   </OUT>
  SUBROUTINE get_local_indexes2(lat, lon, iindex, jindex)
    REAL, INTENT(in) :: lat, lon !< lat/lon location
    INTEGER, INTENT(out) :: iindex, jindex !< i/j indexes

    INTEGER  :: indexes(2)

    IF ( .NOT. diag_grid_initialized )&
         & CALL error_mesg('diag_grid_mod::get_local_indexes2',&
         &'Module not initialized, first initialze module with a call &
         &to diag_grid_init', FATAL)

    indexes = 0

    IF ( MOD(diag_global_grid%tile_number,3) == 0 ) THEN
       IF ( lat > 30.0 .AND. diag_global_grid%tile_number == 3 ) THEN
          indexes(:) = find_pole_index_agrid(lat,lon)
       ELSE IF ( lat < -30.0 .AND. diag_global_grid%tile_number == 6 ) THEN
          indexes(:) = find_pole_index_agrid(lat,lon)
       ENDIF
    ELSE
       indexes(:) = find_equator_index_agrid(lat,lon)
    END IF

    iindex = indexes(1)
    jindex = indexes(2)
    IF (iindex ==  diag_global_grid%adimI -1 .OR.&
        jindex ==  diag_global_grid%adimJ -1 ) THEN
      iindex = 0
      jindex = 0
    ENDIF

  END SUBROUTINE get_local_indexes2
  ! </SUBROUTINE>

  ! <PRIVATE>
  ! <FUNCTION NAME="rad2deg">
  !   <OVERVIEW>
  !     Convert and angle in radian to degrees.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     PURE ELEMENTAL REAL FUNCTION rad2deg(angle)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Given a scalar, or an array of angles in radians this
  !     function will return a scalar or array (of the same
  !     dimension) of angles in degrees.
  !   </DESCRIPTION>
  !   <IN NAME="angle" TYPE="REAL">
  !     Scalar or array of angles in radians.
  !   </IN>
  !   <OUT NAME="rad2deg" TYPE="REAL">
  !     Scalar or array (depending on the size of angle) of angles in
  !     degrees.
  !   </OUT>
  PURE ELEMENTAL REAL FUNCTION rad2deg(angle)
    REAL, INTENT(in) :: angle

    rad2deg = RAD_TO_DEG * angle
  END FUNCTION rad2deg
  ! </FUNCTION>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <FUNCTION NAME="deg2rad">
  !   <OVERVIEW>
  !     Convert an angle in degrees to radians.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     PURE ELEMENTAL REAL FUNCTION deg2rad(angle)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Given a scalar, or an array of angles in degrees this
  !     function will return a scalar or array (of the same
  !     dimension) of angles in radians.
  !   </DESCRIPTION>
  !   <IN NAME="angle" TYPE="REAL">
  !     Scalar or array of angles in degrees.
  !   </IN>
  PURE ELEMENTAL REAL FUNCTION deg2rad(angle)
    REAL, INTENT(in) :: angle

    deg2rad = DEG_TO_RAD * angle
  END FUNCTION deg2rad
  ! </FUNCTION>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <FUNCTION NAME="find_pole_index_agrid">
  !   <OVERVIEW>
  !     Return the closest index (i,j) to the given (lat,lon) point.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     PURE FUNCTION find_pole_index_agrid(lat, lon)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     This function searches a pole a-grid tile looking for the grid point
  !     closest to the give (lat, lon) location, and returns the i
  !     and j indexes of the point.
  !   </DESCRIPTION>
  !   <IN NAME="lat" TYPE="REAL">
  !     Latitude location
  !   </IN>
  !   <IN NAME="lon" TYPE="REAL">
  !     Longitude location
  !   </IN>
  !   <OUT NAME="find_pole_index" TYPE="INTEGER, DIMENSION(2)">
  !     The (i, j) location of the closest grid to the given (lat,
  !     lon) location.
  !   </OUT>
  PURE FUNCTION find_pole_index_agrid(lat, lon)
    INTEGER, DIMENSION(2) :: find_pole_index_agrid
    REAL, INTENT(in) :: lat, lon

    INTEGER :: indxI, indxJ !< Indexes to be returned.
    INTEGER :: dimI, dimJ !< Size of the grid dimensions
    INTEGER :: i,j !< Count indexes
    INTEGER :: nearestCorner !< index of the nearest corner.
    INTEGER, DIMENSION(4,2) :: ijArray !< indexes of the cornerPts and pntDistances arrays
    REAL :: llat, llon
    REAL :: maxCtrDist !< maximum distance to center of grid
    REAL, DIMENSION(4) :: pntDistances !< distance from origPt to corner
    TYPE(point) :: origPt !< Original point
    REAL, DIMENSION(4,2) :: cornerPts !< Corner points using (lat,lon)
    TYPE(point), DIMENSION(9) :: points !< xyz of 8 nearest neighbors
    REAL, DIMENSION(9) :: distSqrd !< distance between origPt and points(:)

    ! Set the inital fail values for indxI and indxJ
    indxI = 0
    indxJ = 0

    dimI = diag_global_grid%adimI
    dimJ = diag_global_grid%adimJ

    ! Since the poles have an non-unique longitude value, make a small correction if looking for one of the poles.
    IF ( lat == 90.0 ) THEN
       llat = lat - .1
    ELSE IF ( lat == -90.0 ) THEN
       llat = lat + .1
    ELSE
       llat = lat
    END IF
    llon = lon

    origPt = latlon2xyz(llat,llon)

    iLoop: DO i=0, dimI-2
       jLoop: DO j = 0, dimJ-2
          cornerPts = RESHAPE( (/ diag_global_grid%aglo_lat(i,  j),  diag_global_grid%aglo_lon(i,  j),&
               &                  diag_global_grid%aglo_lat(i+1,j+1),diag_global_grid%aglo_lon(i+1,j+1),&
               &                  diag_global_grid%aglo_lat(i+1,j),  diag_global_grid%aglo_lon(i+1,j),&
               &                  diag_global_grid%aglo_lat(i,  j+1),diag_global_grid%aglo_lon(i,  j+1) /),&
               &               (/ 4, 2 /), ORDER=(/2,1/) )
          ! Find the maximum half distance of the corner points
          maxCtrDist = MAX(gCirDistance(cornerPts(1,1),cornerPts(1,2), cornerPts(2,1),cornerPts(2,2)),&
               &           gCirDistance(cornerPts(3,1),cornerPts(3,2), cornerPts(4,1),cornerPts(4,2)))

          ! Find the distance of the four corner points to the point of interest.
          pntDistances = gCirDistance(cornerPts(:,1),cornerPts(:,2), llat,llon)

          IF ( (MINVAL(pntDistances) <= maxCtrDist) .AND. (i*j.NE.0) ) THEN
             ! Set up the i,j index array
             ijArray = RESHAPE( (/ i, j, i+1, j+1, i+1, j, i, j+1 /), (/ 4, 2 /), ORDER=(/2,1/) )

             ! the nearest point index
             nearestCorner = MINLOC(pntDistances,1)

             indxI = ijArray(nearestCorner,1)
             indxJ = ijArray(nearestCorner,2)

             EXIT iLoop
          END IF
       END DO jLoop
    END DO iLoop


    ! Make sure we have indexes in the correct range
    valid: IF (  (indxI <= 0 .OR. dimI-1 <= indxI) .OR. &
         &       (indxJ <= 0 .OR. dimJ-1 <= indxJ) ) THEN
       indxI = 0
       indxJ = 0
    ELSE ! indxI and indxJ are valid.
       ! Since we are looking for the closest grid point to the
       ! (lat,lon) point, we need to check the surrounding
       ! points.  The indexes for the variable points are as follows
       !
       ! 1---4---7
       ! |   |   |
       ! 2---5---8
       ! |   |   |
       ! 3---6---9

       ! Set the 'default' values for points(:) x,y,z to some large
       ! value.
       DO i=1, 9
          points(i)%x = 1.0e20
          points(i)%y = 1.0e20
          points(i)%z = 1.0e20
       END DO

       ! All the points around the i,j indexes
       points(1) = latlon2xyz(diag_global_grid%aglo_lat(indxI-1,indxJ+1),&
            &                 diag_global_grid%aglo_lon(indxI-1,indxJ+1))
       points(2) = latlon2xyz(diag_global_grid%aglo_lat(indxI-1,indxJ),&
            &                 diag_global_grid%aglo_lon(indxI-1,indxJ))
       points(3) = latlon2xyz(diag_global_grid%aglo_lat(indxI-1,indxJ-1),&
            &                 diag_global_grid%aglo_lon(indxI-1,indxJ-1))
       points(4) = latlon2xyz(diag_global_grid%aglo_lat(indxI,  indxJ+1),&
            &                 diag_global_grid%aglo_lon(indxI,  indxJ+1))
       points(5) = latlon2xyz(diag_global_grid%aglo_lat(indxI,  indxJ),&
            &                 diag_global_grid%aglo_lon(indxI,  indxJ))
       points(6) = latlon2xyz(diag_global_grid%aglo_lat(indxI,  indxJ-1),&
            &                 diag_global_grid%aglo_lon(indxI,  indxJ-1))
       points(7) = latlon2xyz(diag_global_grid%aglo_lat(indxI+1,indxJ+1),&
            &                 diag_global_grid%aglo_lon(indxI+1,indxJ+1))
       points(8) = latlon2xyz(diag_global_grid%aglo_lat(indxI+1,indxJ),&
            &                 diag_global_grid%aglo_lon(indxI+1,indxJ))
       points(9) = latlon2xyz(diag_global_grid%aglo_lat(indxI+1,indxJ-1),&
            &                 diag_global_grid%aglo_lon(indxI+1,indxJ-1))


       ! Calculate the distance squared between the points(:) and the origPt
       distSqrd = distanceSqrd(origPt, points)

       SELECT CASE (MINLOC(distSqrd,1))
       CASE ( 1 )
          indxI = indxI-1
          indxJ = indxJ+1
       CASE ( 2 )
          indxI = indxI-1
          indxJ = indxJ
       CASE ( 3 )
          indxI = indxI-1
          indxJ = indxJ-1
       CASE ( 4 )
          indxI = indxI
          indxJ = indxJ+1
       CASE ( 5 )
          indxI = indxI
          indxJ = indxJ
       CASE ( 6 )
          indxI = indxI
          indxJ = indxJ-1
       CASE ( 7 )
          indxI = indxI+1
          indxJ = indxJ+1
       CASE ( 8 )
          indxI = indxI+1
          indxJ = indxJ
       CASE ( 9 )
          indxI = indxI+1
          indxJ = indxJ-1
       CASE DEFAULT
          indxI = 0
          indxJ = 0
       END SELECT
    END IF valid

    ! Set the return value for the funtion
    find_pole_index_agrid = (/indxI, indxJ/)
  END FUNCTION find_pole_index_agrid
  ! </FUNCTION>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <FUNCTION NAME="find_equator_index_agrid">
  !   <OVERVIEW>
  !     Return the closest index (i,j) to the given (lat,lon) point.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     PURE FUNCTION find_equator_index_agrid(lat, lon)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     This function searches a equator grid tile looking for the grid point
  !     closest to the give (lat, lon) location, and returns the i
  !     and j indexes of the point.
  !   </DESCRIPTION>
  !   <IN NAME="lat" TYPE="REAL">
  !     Latitude location
  !   </IN>
  !   <IN NAME="lon" TYPE="REAL">
  !     Longitude location
  !   </IN>
  !   <OUT NAME="find_equator_index" TYPE="INTEGER, DIMENSION(2)">
  !     The (i, j) location of the closest grid to the given (lat,
  !     lon) location.
  !   </OUT>
  PURE FUNCTION find_equator_index_agrid(lat, lon)
    INTEGER, DIMENSION(2) :: find_equator_index_agrid
    REAL, INTENT(in) :: lat, lon

    INTEGER :: indxI, indxJ !< Indexes to be returned.
    INTEGER :: indxI_tmp !< Hold the indxI value if on tile 3 or 4
    INTEGER :: dimI, dimJ !< Size of the grid dimensions
    INTEGER :: i,j !< Count indexes
    INTEGER :: jstart, jend, nextj !< j counting variables
    TYPE(point) :: origPt !< Original point
    TYPE(point), DIMENSION(4) :: points !< xyz of 8 nearest neighbors
    REAL, DIMENSION(4) :: distSqrd !< distance between origPt and points(:)

    ! Set the inital fail values for indxI and indxJ
    indxI = 0
    indxJ = 0

    dimI = diag_global_grid%adimI
    dimJ = diag_global_grid%adimJ

    ! check to see if the 'fix' for the latitude index is needed
    IF ( diag_global_grid%aglo_lat(1,1) > &
         &diag_global_grid%aglo_lat(1,2) ) THEN
       ! reverse the j search
       jstart = dimJ-1
       jend = 1
       nextj = -1
    ELSE
       jstart = 0
       jend = dimJ-2
       nextJ = 1
    END IF

    ! find the I index
    iLoop: DO i=0, dimI-2
       IF (   diag_global_grid%aglo_lon(i,0) >&
            & diag_global_grid%aglo_lon(i+1,0) ) THEN
          ! We are at the 0 longitudal line
          IF (   (diag_global_grid%aglo_lon(i,0) <= lon .AND. lon <= 360.) .OR.&
               & (0. <= lon .AND. lon < diag_global_grid%aglo_lon(i+1, 0)) ) THEN
             indxI = i
             EXIT iLoop
          END IF
       ELSEIF ( diag_global_grid%aglo_lon(i,0) <= lon .AND.&
            &   lon <= diag_global_grid%aglo_lon(i+1,0) ) THEN
          indxI = i
          EXIT iLoop
       END IF
    END DO iLoop

    ! Find the J index
    IF ( indxI > 0 ) THEN
       jLoop: DO j=jstart, jend, nextj
          IF (   diag_global_grid%aglo_lat(indxI,j) <= lat .AND.&
               & lat <= diag_global_grid%aglo_lat(indxI,j+nextj) ) THEN
             indxJ = j
             EXIT jLoop
          END IF
       END DO jLoop
    END IF

    ! Make sure we have indexes in the correct range
    valid: IF ( (indxI <= 0 .OR. dimI-1 < indxI) .OR. &
         &      (indxJ <= 0 .OR. dimJ-1 < indxJ) ) THEN
       indxI = 0
       indxJ = 0
    ELSE ! indxI and indxJ are valid.
       ! Since we are looking for the closest grid point to the
       ! (lat,lon) point, we need to check the surrounding
       ! points.  The indexes for the variable points are as follows
       !
       ! 1---3
       ! |   |
       ! 2---4

       ! The original point
       origPt = latlon2xyz(lat,lon)

       ! Set the 'default' values for points(:) x,y,z to some large
       ! value.
       DO i=1, 4
          points(i)%x = 1.0e20
          points(i)%y = 1.0e20
          points(i)%z = 1.0e20
       END DO

       ! The original point
       origPt = latlon2xyz(lat,lon)

       points(1) = latlon2xyz(diag_global_grid%aglo_lat(indxI,indxJ),&
            &                 diag_global_grid%aglo_lon(indxI,indxJ))
       points(2) = latlon2xyz(diag_global_grid%aglo_lat(indxI,indxJ+nextj),&
            &                 diag_global_grid%aglo_lon(indxI,indxJ+nextj))
       points(3) = latlon2xyz(diag_global_grid%aglo_lat(indxI+1,indxJ+nextj),&
            &                 diag_global_grid%aglo_lon(indxI+1,indxJ+nextj))
       points(4) = latlon2xyz(diag_global_grid%aglo_lat(indxI+1,indxJ),&
            &                 diag_global_grid%aglo_lon(indxI+1,indxJ))

       ! Find the distance between the original point and the four
       ! grid points
       distSqrd = distanceSqrd(origPt, points)

       SELECT CASE (MINLOC(distSqrd,1))
       CASE ( 1 )
          indxI = indxI;
          indxJ = indxJ;
       CASE ( 2 )
          indxI = indxI;
          indxJ = indxJ+nextj;
       CASE ( 3 )
          indxI = indxI+1;
          indxJ = indxJ+nextj;
       CASE ( 4 )
          indxI = indxI+1;
          indxJ = indxJ;
       CASE DEFAULT
          indxI = 0;
          indxJ = 0;
       END SELECT

       ! If we are on tile 3 or 4, then the indxI and indxJ are
       ! reversed due to the transposed grids.
       IF (   diag_global_grid%tile_number == 4 .OR.&
            & diag_global_grid%tile_number == 5 ) THEN
          indxI_tmp = indxI
          indxI = indxJ
          indxJ = indxI_tmp
       END IF
    END IF valid

    ! Set the return value for the function
    find_equator_index_agrid = (/indxI, indxJ/)
  END FUNCTION find_equator_index_agrid
  ! </FUNCTION>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <FUNCTION NAME="latlon2xyz">
  !   <OVERVIEW>
  !     Return the (x,y,z) position of a given (lat,lon) point.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     PURE ELEMENTAL TYPE(point) FUNCTION latlon2xyz(lat, lon)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Given a specific (lat, lon) point on the Earth, return the
  !     corresponding (x,y,z) location.  The return of latlon2xyz
  !     will be either a scalar or an array of the same size as lat
  !     and lon.
  !   </DESCRIPTION>
  !   <IN NAME="lat" TYPE="REAL">
  !     The latitude of the (x,y,z) location to find.  <TT>lat</TT>
  !     can be either a scalar or array.  <TT>lat</TT> must be of the
  !     same rank / size as <TT>lon</TT>.  This function assumes
  !     <TT>lat</TT> is in the range [-90,90].
  !   </IN>
  !   <IN NAME="lon" TYPE="REAL">
  !     The longitude of the (x,y,z) location to find.  <TT>lon</TT>
  !     can be either a scalar or array.  <TT>lon</TT> must be of the
  !     same rank / size as <TT>lat</TT>.  This function assumes
  !     <TT>lon</TT> is in the range [0,360].
  !   </IN>
  PURE ELEMENTAL TYPE(point) FUNCTION latlon2xyz(lat, lon)
    REAL, INTENT(in) :: lat, lon

    ! lat/lon angles in radians
    REAL :: theta, phi

    ! Convert the lat lon values to radians The lat values passed in
    ! are in the range [-90,90], but we need to have a radian range
    ! [0,pi], where 0 is at the north pole.  This is the reason for
    ! the subtraction from 90
    theta = deg2rad(90.-lat)
    phi = deg2rad(lon)

    ! Calculate the x,y,z point
    latlon2xyz%x = RADIUS * SIN(theta) * COS(phi)
    latlon2xyz%y = RADIUS * SIN(theta) * SIN(phi)
    latlon2xyz%z = RADIUS * COS(theta)
  END FUNCTION latlon2xyz
  ! </FUNCTION>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <FUNCTION NAME="distanceSqrd">
  !   <OVERVIEW>
  !     Find the distance between two points in the Cartesian
  !     coordinate space.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     PURE ELEMENTAL REAL FUNCTION distanceSqrd(pt1, pt2)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     <TT>distanceSqrd</TT> will find the distance squared between
  !     two points in the xyz coordinate space.  <TT>pt1</TT> and <TT>
  !     pt2</TT> can either be both scalars, both arrays of the same
  !     size, or one a scalar and one an array.  The return value
  !     will be a scalar or array of the same size as the input array.
  !   </DESCRIPTION>
  !   <IN NAME="pt1" TYPE="TYPE(POINT)" />
  !   <IN NAME="pt2" TYPE="TYPE(POINT)" />
  PURE ELEMENTAL REAL FUNCTION distanceSqrd(pt1, pt2)
    TYPE(point), INTENT(in) :: pt1, pt2

    distanceSqrd = (pt1%x-pt2%x)**2 +&
         &         (pt1%y-pt2%y)**2 +&
         &         (pt1%z-pt2%z)**2
  END FUNCTION distanceSqrd
  ! </FUNCTION>
  ! </PRIVATE>

  ! <FUNCTION NAME="gCirDistance">
  !   <OVERVIEW>
  !     Find the distance, along the geodesic, between two points.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     PURE ELEMENTAL REAL FUNCTION gCirDistance(lat1, lon1, lat2, lon2)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     <TT>aCirDistance</TT> will find the distance, along the geodesic, between two points defined by the (lat,lon) position of
  !     each point.
  !   </DESCRIPTION>
  !   <IN NAME="lat1" TYPE="REAL">Latitude of the first point</IN>
  !   <IN NAME="lon1" TYPE="REAL">Longitude of the first point</IN>
  !   <IN NAME="lat2" TYPE="REAL">Latitude of the second point</IN>
  !   <IN NAME="lon2" TYPE="REAL">Longitude of the second point</IN>
  PURE ELEMENTAL REAL FUNCTION gCirDistance(lat1, lon1, lat2, lon2)
    REAL, INTENT(in) :: lat1, lat2, lon1, lon2

    REAL :: theta1, theta2
    REAL :: deltaLambda !< Difference in longitude angles, in radians.
    REAL :: deltaTheta !< Difference in latitude angels, in radians.

    theta1 = deg2rad(lat1)
    theta2 = deg2rad(lat2)
    deltaLambda = deg2rad(lon2-lon1)
    deltaTheta = deg2rad(lat2-lat1)

    gCirDistance = RADIUS * 2. * ASIN(SQRT((SIN(deltaTheta/2.))**2 + COS(theta1)*COS(theta2)*(SIN(deltaLambda/2.))**2))
  END FUNCTION gCirDistance
  ! </FUNCTION>
END MODULE diag_grid_mod

module ocean_sponges_velocity_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov.au"> Paul Sandery
!</CONTACT>
!
!<OVERVIEW>
! Thickness weighted velocity tendency [meter*meter/sec*sec] from sponges.
!</OVERVIEW>
!
!<DESCRIPTION>
!
! This module applies sponges to currents. The sponges
! can occur at any location and with any distribution in the domain, and
! with any time step and damping rate.  Sponges occur where positive
! inverse restore times occur in the field passed to sponge_init.  An
! array of tracer tendencies due to the sponges is augmented through a
! call to sponge_tracer_source.  The array of tracer tendencies must be
! reset to zero between calls.
!
! Different damping rates can be specified for each field by making
! calls to register_sponge_rate - no sponges are applied to fields for
! which uniformly zero inverse damping rates are set with a call to
! register_sponge_rate.  The value towards which a field is damped is
! set with calls to register_sponge_field; successive calls are used to
! set up linear interpolation of this restore rate.
!
! Sponge data and damping coefficients are generally 3 dimensional. 
!
! The user is responsible for providing (and registering) the data on
! the model grid of values towards which the currents are being driven.
!
!</DESCRIPTION>
!
!<NAMELIST NAME="ocean_sponges_velocity_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  For using this module.  Default use_this_module=.false.
!  </DATA> 
!
!  <DATA NAME="damp_coeff_3d" TYPE="logical">
!  For case when damping coefficients are full 3d field of values.
!  Default damp_coeff_3d=.false., which means damping coeffs are 
!  2d horizontal array.   
!  </DATA> 
!
!</NAMELIST>
!
use diag_manager_mod,         only: register_diag_field
use fms_mod,                  only: write_version_number, open_namelist_file, close_file
use fms_mod,                  only: file_exist
use fms_mod,                  only: open_namelist_file, check_nml_error, close_file
use fms_mod,                  only: read_data, lowercase, FATAL, WARNING, stdout, stdlog
use mpp_mod,                  only: input_nml_file, mpp_sum, mpp_error, mpp_max
use time_interp_external_mod, only: init_external_field, time_interp_external
use time_manager_mod,         only: time_type, set_date, get_time
use time_manager_mod,         only: operator( + ), operator( - ), operator( // )
use time_manager_mod,         only: operator( > ), operator( == ), operator( <= )

use ocean_domains_mod,        only: get_local_indices
use ocean_parameters_mod,     only: missing_value, rho0 
use ocean_types_mod,          only: ocean_domain_type, ocean_grid_type, ocean_thickness_type
use ocean_types_mod,          only: ocean_time_type, ocean_velocity_type, ocean_options_type
use ocean_workspace_mod,      only: wrk1, wrk2 
use ocean_util_mod,           only: diagnose_3d_u

implicit none

private

#include <ocean_memory.h>

type ocean_sponge_type
   integer :: id                                                 ! time_interp_external index
   character(len=32) :: name                                     ! tracer name corresponding to sponge
   real, dimension(:,:),   pointer :: damp_coeff_u2d   => NULL() ! 3d inverse damping rate (tracer units/ sec)
   real, dimension(:,:),   pointer :: damp_coeff_v2d   => NULL() ! 2d inverse damping rate (tracer units/ sec)
   real, dimension(:,:,:), pointer :: damp_coeff_u     => NULL() ! 3d inverse damping rate for u current (m/ sec^2)
   real, dimension(:,:,:), pointer :: damp_coeff_v     => NULL() ! 3d inverse damping rate for v current (m/ sec^2)
end type ocean_sponge_type

type(ocean_sponge_type), allocatable, dimension(:) :: Sponge_u
type(ocean_sponge_type), allocatable, dimension(:) :: Sponge_v

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()


public ocean_sponges_velocity_init
public sponge_velocity_source

character(len=126)  :: version = '$Id: ocean_sponges_velocity.F90,v 20.0 2013/12/14 00:16:26 fms Exp $'
character (len=128) :: tagname = '$Name: tikal $'

! for diagnostics 
logical :: used
integer, dimension(:), allocatable :: id_sponge_tend
logical :: module_is_initialized = .false.
logical :: damp_coeff_3d         = .false. 
logical :: use_this_module       = .false. 

! Adaptive restoring
real    :: athresh               = 0.5
real    :: npower                = 1.0
real    :: sdiffo_u              = 0.5
real    :: sdiffo_v              = 0.5
real    :: lambda                = 0.0083
real    :: taumin                = 720
logical :: use_adaptive_restore  = .false.
logical :: use_sponge_after_init = .false.
logical :: use_normalising       = .false.
logical :: use_hard_thump        = .false.
integer :: secs_to_restore       = 0
integer :: days_to_restore       = 1

integer :: secs_restore
integer :: days_end_restore
integer :: secs_end_restore
integer :: initial_day, initial_secs

namelist /ocean_sponges_velocity_nml/ use_this_module, damp_coeff_3d
namelist /ocean_sponges_velocity_ofam_nml/ &
    use_adaptive_restore, use_sponge_after_init, use_normalising, &
    use_hard_thump, athresh, taumin, lambda, npower, days_to_restore, &
    secs_to_restore

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_sponges_velocity_init">
!
! <DESCRIPTION>
! This subroutine is intended to be used to initialize the sponges.
! Everything in this subroutine is a user prototype, and should be replacable.
! </DESCRIPTION>
!
subroutine ocean_sponges_velocity_init(Grid, Domain, Time, dtime, Ocean_options)

  type(ocean_grid_type),          intent(in), target :: Grid
  type(ocean_domain_type),        intent(in), target :: Domain
  type(ocean_time_type),          intent(in)         :: Time
  real,                           intent(in)         :: dtime
  type(ocean_options_type),       intent(inout)      :: Ocean_options

  integer :: i, j, k
  integer :: ioun, io_status, ierr
  integer :: secs, days
  real    :: dtimer

  character(len=128) :: name

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_sponges_velocity_mod (ocean_sponges_velocity_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.

  allocate( Sponge_u(1) )
  allocate( Sponge_v(1) )

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
  read(input_nml_file, nml=ocean_sponges_velocity_nml, iostat=io_status)
  ierr = check_nml_error(io_status, 'ocean_sponges_velocity_nml')
  read(input_nml_file, nml=ocean_sponges_velocity_ofam_nml, iostat=io_status)
  ierr = check_nml_error(io_status, 'ocean_sponges_velocity_ofam_nml')
#else
  ioun = open_namelist_file()
  read(ioun, ocean_sponges_velocity_nml, IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_sponges_velocity_nml')
  rewind(ioun)
  read(ioun, ocean_sponges_velocity_ofam_nml, IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_sponges_velocity_ofam_nml')
  call close_file(ioun)
#endif
  write(stdlogunit, ocean_sponges_velocity_nml)
  write(stdoutunit, '(/)')
  write(stdoutunit, ocean_sponges_velocity_nml)

  write(stdlogunit, ocean_sponges_velocity_ofam_nml)
  write(stdoutunit, '(/)')
  write(stdoutunit, ocean_sponges_velocity_ofam_nml)

  Dom => Domain
  Grd => Grid

#ifndef MOM_STATIC_ARRAYS    
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
#endif

  Sponge_u(1)%id = -1
  Sponge_v(1)%id = -1
  dtimer = 1.0/dtime

  if(use_this_module) then
      write(stdoutunit,*)'==>Note from ocean_sponges_velocity_mod: Using this module.'
      Ocean_options%ocean_sponges_velocity= 'Used ocean velocity sponges.'
  else
      write(stdoutunit,*)'==>Note from ocean_sponges_velocity_mod: NOT using this module: no velocity sponges.'
      Ocean_options%ocean_sponges_velocity= 'Did NOT use ocean velocity sponges.'
      return
  endif

  if (use_adaptive_restore) then
    ! Set up some initial times
    call get_time(Time%model_time, secs, days)
    days_end_restore = days + days_to_restore
    secs_end_restore = secs + secs_to_restore
    initial_day = days
    initial_secs = secs

    allocate(Sponge_u(1)%damp_coeff_u(isd:ied, jsd:jed, nk))
    Sponge_u(1)%damp_coeff_u(:,:,:) = 0.0

    allocate(Sponge_v(1)%damp_coeff_v(isd:ied,jsd:jed,nk))
    Sponge_v(1)%damp_coeff_v(:,:,:) = 0.0
  else
    ! Read damping rates for u
    name = 'INPUT/u_sponge_coeff.nc'
    if (file_exist(name)) then
        write(stdoutunit,*) '==> Using sponge damping times specified from file ',name
        allocate(Sponge_u(1)%damp_coeff_u(isd:ied,jsd:jed,nk))
        allocate(Sponge_u(1)%damp_coeff_u2d(isd:ied,jsd:jed))
        Sponge_u(1)%damp_coeff_u(:,:,:) = 0.0
        Sponge_u(1)%damp_coeff_u2d(:,:) = 0.0

        if(damp_coeff_3d) then
            call read_data(name,'coeff',Sponge_u(1)%damp_coeff_u,domain=Domain%domain2d,timelevel=1)
        else
            call read_data(name,'coeff',Sponge_u(1)%damp_coeff_u2d,domain=Domain%domain2d,timelevel=1)
            do k=1,nk
               do j=jsc,jec
                  do i=isc,iec
                     Sponge_u(1)%damp_coeff_u(i,j,k) = Sponge_u(1)%damp_coeff_u2d(i,j)
                  enddo
               enddo
            enddo
        endif

        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 if(Grd%umask(i,j,k) == 0.0) then
                     Sponge_u(1)%damp_coeff_u(i,j,k) = 0.0
                 endif
              enddo
           enddo
        enddo


       ! modify damping rates to allow restoring to be solved implicitly
       ! note: test values between zero and 4.0e-8 revert to damping rates defined above
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 if (dtime*Sponge_u(1)%damp_coeff_u(i,j,k) > 4.0e-8) then
                     if (dtime*Sponge_u(1)%damp_coeff_u(i,j,k) > 37.0) then
                         Sponge_u(1)%damp_coeff_u(i,j,k) = dtimer
                     else
                         Sponge_u(1)%damp_coeff_u(i,j,k) = (1.0 - exp(-dtime*Sponge_u(1)%damp_coeff_u(i,j,k))) * dtimer
                     endif
                 else if (dtime*Sponge_u(1)%damp_coeff_u(i,j,k) <= 0.0) then
                     Sponge_u(1)%damp_coeff_u(i,j,k) = 0.0
                 endif
              enddo
           enddo
        enddo
    endif  ! endif for if fileexist INPUT/u_sponge_coeff.nc

    ! Read damping rates for v-sponge
    name = 'INPUT/v_sponge_coeff.nc'
    if (file_exist(name)) then
        write(stdoutunit,*) '==> Using sponge damping times specified from file ',name
        allocate(Sponge_v(1)%damp_coeff_v(isd:ied,jsd:jed,nk))
        allocate(Sponge_v(1)%damp_coeff_v2d(isd:ied,jsd:jed))
        Sponge_v(1)%damp_coeff_v(:,:,:) = 0.0
        Sponge_v(1)%damp_coeff_v2d(:,:) = 0.0

        if(damp_coeff_3d) then
            call read_data(name,'coeff',Sponge_v(1)%damp_coeff_v,domain=Domain%domain2d,timelevel=1)
        else
            call read_data(name,'coeff',Sponge_v(1)%damp_coeff_v2d,domain=Domain%domain2d,timelevel=1)
            do k=1,nk
               do j=jsc,jec
                  do i=isc,iec
                     Sponge_v(1)%damp_coeff_v(i,j,k) = Sponge_v(1)%damp_coeff_v2d(i,j)
                  enddo
               enddo
            enddo
        endif

        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 if(Grd%umask(i,j,k) == 0.0) then
                     Sponge_v(1)%damp_coeff_v(i,j,k) = 0.0
                 endif
              enddo
           enddo
        enddo

        ! modify damping rates to allow restoring to be solved implicitly
        ! note: test values between zero and 4.0e-8 revert to damping rates defined above
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 if (dtime*Sponge_v(1)%damp_coeff_v(i,j,k) > 4.0e-8) then
                     if (dtime*Sponge_v(1)%damp_coeff_v(i,j,k) > 37.0) then
                         Sponge_v(1)%damp_coeff_v(i,j,k) = dtimer
                     else
                         Sponge_v(1)%damp_coeff_v(i,j,k) = (1.0 - exp(-dtime*Sponge_v(1)%damp_coeff_v(i,j,k))) * dtimer
                     endif
                 else if (dtime*Sponge_v(1)%damp_coeff_v(i,j,k) <= 0.0) then
                     Sponge_v(1)%damp_coeff_v(i,j,k) = 0.0
                 endif
              enddo
           enddo
        enddo

    endif   ! endif for if fileexist INPUT/v_sponge_coeff.nc
  end if

  ! read forcing data for u-sponge
  name = 'INPUT/u_sponge.nc'
  if (file_exist(trim(name)) ) then
      Sponge_u(1)%id = init_external_field(name,'u',domain=Domain%domain2d)
      if (Sponge_u(1)%id < 1) then
         if ( use_adaptive_restore ) then
            call mpp_error(FATAL,&
               '==>Error: in ocean_sponges_velocity_mod: adaptive forcing is specified but restoring values are not')
         else
            call mpp_error(FATAL,&
               '==>Error: in ocean_sponges_velocity_mod: forcing rates are specified but restoring values are not')
         endif
      endif
      write(stdoutunit,*) '==> Using restoring data specified from file '//trim(name)
  else
      write(stdoutunit,*) '==> '//trim(name)//' not found.  Increment not being applied '
  endif


  ! read forcing data for v-sponge
  name = 'INPUT/v_sponge.nc'
  if (file_exist(trim(name)) ) then
      Sponge_v(1)%id = init_external_field(name,'v',domain=Domain%domain2d)
      if (Sponge_v(1)%id < 1) then
         if ( use_adaptive_restore ) then
            call mpp_error(FATAL,&
               '==>Error: in ocean_sponges_velocity_mod: adaptive forcing is specified but restoring values are not')
         else
            call mpp_error(FATAL,&
               '==>Error: in ocean_sponges_velocity_mod: forcing rates are specified but restoring values are not')
         endif
      endif
      write(stdoutunit,*) '==> Using restoring data specified from file '//trim(name)
  else
      write(stdoutunit,*) '==> '//trim(name)//' not found.  Increment not being applied '
  endif


  ! register diagnostic output
  allocate (id_sponge_tend(2))
  id_sponge_tend = -1

  id_sponge_tend(1) = register_diag_field ('ocean_model', 'u_sponge_tend',       &
       Grd%vel_axes_uv(1:3), Time%model_time, 'rho*dzt*u_tendency due to sponge',&
       '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1.e10,1.e10/))
  id_sponge_tend(2) = register_diag_field ('ocean_model', 'v_sponge_tend',       &
       Grd%vel_axes_uv(1:3), Time%model_time, 'rho*dzt*v_tendency due to sponge',&
       '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1.e10,1.e10/))


end subroutine ocean_sponges_velocity_init
! </SUBROUTINE> NAME="ocean_sponges_velocity_init"



!#######################################################################
! <SUBROUTINE NAME="sponge_velocity_source">
!
! <DESCRIPTION>
! This subroutine calculates thickness weighted and density weighted
! time tendencies due to damping by sponges.
! </DESCRIPTION>
!
subroutine sponge_velocity_source(Time, Thickness, Velocity)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_velocity_type),    intent(inout) :: Velocity

  integer :: secs, days
  integer :: taum1, tau
  integer :: i, j, k

  real    :: sdiff, sum_val, adaptive_coeff
  integer :: numsecs

  logical :: do_adaptive_restore = .false.  ! Only restore in specified time period.
  logical :: do_normal_restore = .false.    !
  logical, save :: first_pass = .true.

  if (.not. use_this_module) return

  taum1 = Time%taum1
  tau   = Time%tau

  if (use_adaptive_restore) then
    secs_restore = days_to_restore * 86400 + secs_to_restore
    sdiff = 0.0
    call get_time(Time%model_time, secs, days)
    numsecs = (days - initial_day) * 86400 + secs - initial_secs

    do_adaptive_restore = (numsecs < secs_restore)
    do_normal_restore = (.not. do_adaptive_restore) .and. use_sponge_after_init

    write(stdout(),*) 'dar,dnr', do_adaptive_restore, do_normal_restore
  else
     do_normal_restore = .true.
  endif

  wrk1 = 0.0
  wrk2 = 0.0
  if (Sponge_u(1)%id > 0) then

      call time_interp_external(Sponge_u(1)%id, Time%model_time, wrk1)

      if ( do_adaptive_restore ) then
         if ( first_pass ) then
            if ( use_hard_thump ) then
               do k = 1,nk
                  do j=jsd,jed
                     do i=isd,ied
                        Velocity%u(i,j,k,1,taum1)=wrk1(i,j,k)
                        Velocity%u(i,j,k,1,tau)=wrk1(i,j,k)
                     enddo
                  enddo
               enddo
            endif
            wrk2=abs(Velocity%u(:,:,:,1,taum1)-wrk1(:,:,:))*Grd%umask(:,:,:)
            sum_val=sum(wrk2(isc:iec,jsc:jec,:))

            call mpp_sum(sum_val)
            sdiffo_u = sum_val/Grd%wet_u_points
            !if ( mpp_pe() == mpp_root_pe() ) write (stdout(),*)'mean U_diff', sdiffo
            write (stdout(),*)'mean U_diff', sdiffo_u
            if ( .not. use_normalising ) then
               sdiffo_u=1.0
            else
                ! Work out max difference + threshhold
                sdiffo_u  = maxval(wrk2)
                call mpp_max(sdiffo_u)
                sdiffo_u  = 1.01*sdiffo_u
             endif
          endif

         ! Calculate idealised forcing tendency timescale for each timestep and array element
         do k=1,nk
            do j=jsd,jed
               do i=isd,ied
                  sdiff=abs(Velocity%u(i,j,k,1,taum1)-wrk1(i,j,k))
                  sdiff = max(sdiff,1e-9) !minimum tolerance
                  adaptive_coeff=1.0/(taumin - (lambda*real(secs_restore))/(((sdiff/sdiffo_v)**npower)*log(1-athresh)))
                  wrk2(i,j,k) = adaptive_coeff*(wrk1(i,j,k) - Velocity%u(i,j,k,1,taum1))
                  Velocity%accel(i,j,k,1) = Velocity%accel(i,j,k,1) + Thickness%rho_dzu(i,j,k,tau)*wrk2(i,j,k)
               enddo
            enddo
         enddo

      elseif ( do_normal_restore ) then
         do k=1,nk
            do j=jsd,jed
               do i=isd,ied
                  wrk2(i,j,k) = Sponge_u(1)%damp_coeff_u(i,j,k)*(wrk1(i,j,k) - &
                                Velocity%u(i,j,k,1,taum1))
                  Velocity%accel(i,j,k,1) = Velocity%accel(i,j,k,1) + &
                                            Thickness%rho_dzu(i,j,k,tau)*wrk2(i,j,k)
               enddo
            enddo
         enddo
      endif

  endif

  call diagnose_3d_u(Time, Grd, id_sponge_tend(1), wrk2(:,:,:))

  wrk1 = 0.0
  wrk2 = 0.0
  if (Sponge_v(1)%id > 0) then

      call time_interp_external(Sponge_v(1)%id, Time%model_time, wrk1)

      if ( do_adaptive_restore ) then
         if ( first_pass ) then
            if ( use_hard_thump ) then
               do k = 1,nk
                  do j=jsd,jed
                     do i=isd,ied
                        Velocity%u(i,j,k,2,taum1)=wrk1(i,j,k)
                        Velocity%u(i,j,k,2,tau)=wrk1(i,j,k)
                     enddo
                  enddo
               enddo
            endif
            wrk2=abs(Velocity%u(:,:,:,2,taum1)-wrk1(:,:,:))*Grd%umask(:,:,:)
            sum_val=sum(wrk2(isc:iec,jsc:jec,:))

            call mpp_sum(sum_val)
            sdiffo_v = sum_val/Grd%wet_u_points

            if ( .not. use_normalising ) then
               sdiffo_v=1.0
            else
                sdiffo_v  = maxval(wrk2)
                call mpp_max(sdiffo_v)
                sdiffo_v  = 1.01*sdiffo_v
             endif
          endif


         do k=1,nk
            do j=jsd,jed
               do i=isd,ied
                  sdiff=abs(Velocity%u(i,j,k,2,taum1)-wrk1(i,j,k))
                  sdiff = max(sdiff,1e-9) !minimum tolerance
                  adaptive_coeff=1.0/(taumin - (lambda*real(secs_restore))/(((sdiff/sdiffo_v)**npower)*log(1-athresh)))
                  wrk2(i,j,k) = adaptive_coeff*(wrk1(i,j,k) - Velocity%u(i,j,k,2,taum1))
                  Velocity%accel(i,j,k,2) = Velocity%accel(i,j,k,2) + Thickness%rho_dzu(i,j,k,tau)*wrk2(i,j,k)
               enddo
            enddo
         enddo
      endif

      if ( do_normal_restore ) then
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  wrk2(i,j,k) = Sponge_v(1)%damp_coeff_v(i,j,k)*(wrk1(i,j,k) - &
                                Velocity%u(i,j,k,2,taum1))
                  Velocity%accel(i,j,k,2) = Velocity%accel(i,j,k,2) + &
                                            Thickness%rho_dzu(i,j,k,tau)*wrk2(i,j,k)
               enddo
            enddo
         enddo
      endif
  endif

  call diagnose_3d_u(Time, Grd, id_sponge_tend(2), wrk2(:,:,:))

  first_pass = .false.

  return

end subroutine sponge_velocity_source
! </SUBROUTINE> NAME="sponge_velocity_source"

end module ocean_sponges_velocity_mod

! ============================================================================
! soil model module
! ============================================================================
module soil_mod

#include "../shared/debug.inc"
#include "../shared/concat.inc"

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only: error_mesg, file_exist, check_nml_error, &
     stdlog, write_version_number, close_file, mpp_pe, mpp_root_pe, FATAL, NOTE
use time_manager_mod,   only: time_type, increment_time, time_type_to_real
use diag_manager_mod,   only: diag_axis_init
use constants_mod,      only: tfreeze, hlv, hlf, dens_h2o

use land_constants_mod, only : NBANDS, BAND_VIS, BAND_NIR
use soil_tile_mod, only : GW_LM2, GW_LINEAR, GW_HILL_AR5, GW_HILL, GW_TILED, &
     soil_tile_type, soil_pars_type, soil_prog_type, read_soil_data_namelist, &
     soil_data_radiation, soil_data_diffusion, soil_data_thermodynamics, &
     soil_data_hydraulic_properties, soil_data_psi_for_rh, &
     soil_data_gw_hydraulics, soil_data_gw_hydraulics_ar5, &
     soil_data_vwc_for_init_only, &
     soil_data_init_derive_subsurf_pars, &
     soil_data_init_derive_subsurf_pars_ar5,&
     max_lev, psi_wilt, cpw, clw, csw, g_iso, g_vol, g_geo, g_RT, aspect,&
     num_storage_pts, gw_zeta_s, gw_flux_table, gw_area_table, &
     gw_scale_length, gw_scale_relief, gw_scale_soil_depth, &
     slope_exp, &
     num_zeta_pts, num_tau_pts, &
     log_rho_table, log_zeta_s, log_tau, gw_scale_perm, &
     z_ref, k_macro_constant, use_tau_fix

use land_tile_mod, only : land_tile_type, land_tile_enum_type, &
     first_elmt, tail_elmt, next_elmt, current_tile, get_elmt_indices, &
     operator(/=)
use land_utils_mod, only : put_to_tiles_r0d_fptr, put_to_tiles_r1d_fptr
use land_tile_diag_mod, only : diag_buff_type, &
     register_tiled_static_field, register_tiled_diag_field, &
     send_tile_data, send_tile_data_r0d_fptr, send_tile_data_r1d_fptr, &
     send_tile_data_i0d_fptr, &
     add_tiled_diag_field_alias, add_tiled_static_field_alias
use land_data_mod, only : land_state_type, lnd
use land_io_mod, only : read_field
use land_tile_io_mod, only : create_tile_out_file, write_tile_data_r0d_fptr,& 
     write_tile_data_r1d_fptr, read_tile_data_r0d_fptr, read_tile_data_r1d_fptr,&
     print_netcdf_error, get_input_restart_name, sync_nc_files
use nf_utils_mod, only : nfu_def_dim, nfu_put_att, nfu_inq_var
use vegn_tile_mod, only : vegn_tile_type, vegn_uptake_profile, vegn_root_properties
use land_debug_mod, only : is_watch_point, get_current_point, check_var_range
use uptake_mod, only : UPTAKE_LINEAR, UPTAKE_DARCY2D, UPTAKE_DARCY2D_LIN, &
     uptake_init, &
     darcy2d_uptake, darcy2d_uptake_solver, &
     darcy2d_uptake_lin, darcy2d_uptake_solver_lin
implicit none
private

! ==== public interfaces =====================================================
public :: read_soil_namelist
public :: soil_init
public :: soil_end
public :: save_soil_restart

public :: soil_get_sfc_temp
public :: soil_radiation
public :: soil_diffusion
public :: soil_step_1
public :: soil_step_2
public :: soil_step_3
! =====end of public interfaces ==============================================



! ==== module constants ======================================================
character(len=*), parameter, private   :: &
    module_name = 'soil',&
    version     = '$Id: soil.F90,v 20.0 2013/12/13 23:30:48 fms Exp $',&
    tagname     = '$Name: tikal $'

! ==== module variables ======================================================

!---- namelist ---------------------------------------------------------------
logical :: lm2                  = .false.
logical :: use_E_min            = .false.     ! prohibit condensation
logical :: use_E_max            = .true.      ! theoretical effiltration capacity flag
real    :: init_temp            = 288.        ! cold-start soil T
real    :: init_w               = 150.        ! cold-start w(l)/dz(l)
real    :: init_wtdep           = -1.         ! positive value activates hydrostatic IC,
                                              ! overriding init_w
real    :: init_groundwater     =   0.        ! cold-start gw storage
real    :: lrunf_ie_min         = -1.0e-4     ! trigger for clip and runoff
real    :: lrunf_ie_tol         =  1.e-12
character(len=16) :: albedo_to_use = ''       ! or 'albedo-map' or 'brdf-maps'
character(len=24) :: uptake_to_use = 'linear' ! or 'darcy2d', or 'darcy2d-linearized'
logical :: uptake_oneway        = .false.     ! if true, roots can't loose water to soil
logical :: uptake_from_sat      = .true.      ! if false, the uptake from saturated soil is prohibited
logical :: allow_negative_rie   = .false.
logical :: baseflow_where_frozen = .false.
logical :: write_when_flagged   = .false.
logical :: bypass_richards_when_stiff = .true.
logical :: corrected_lm2_gw     = .true.
logical :: use_stiff_bug        = .false.
logical :: fix_z_bot            = .false.
logical :: update_psi           = .false.
logical :: consistent_d_trans   = .false.
logical :: fix_interp           = .false.
logical :: use_new_dq           = .false.
logical :: use_fringe           = .false.
logical :: push_down_sfc_excess = .true.
logical :: lrunf_from_div       = .true.
real    :: active_layer_drainage_acceleration = 0.
real    :: hlf_factor           = 1.
real    :: gw_flux_max          = 1.e10
real    :: log_rho_max          = 100.
real    :: aquifer_heat_cap     = 0.         ! in equivalent liquid water amount, kg/m2
logical :: write_soil_carbon_restart = .FALSE. ! indicates whether to write
                        ! information for soil carbon acceleration

namelist /soil_nml/ lm2, use_E_min, use_E_max,           &
                    init_temp,      &
                    init_w,   init_wtdep,    &
                    init_groundwater, lrunf_ie_min, lrunf_ie_tol, &
                    cpw, clw, csw, &
                    albedo_to_use, &
                    uptake_to_use, uptake_oneway, uptake_from_sat, &
                    allow_negative_rie, &
                    baseflow_where_frozen, &
                    write_when_flagged, &
                    bypass_richards_when_stiff, corrected_lm2_gw, &
                    use_stiff_bug, fix_z_bot, update_psi, &
                    consistent_d_trans, fix_interp, use_new_dq, use_fringe, &
                    push_down_sfc_excess, lrunf_from_div, &
                    active_layer_drainage_acceleration, hlf_factor, &
                    gw_flux_max, log_rho_max, aquifer_heat_cap, &
                    write_soil_carbon_restart
!---- end of namelist --------------------------------------------------------

logical         :: module_is_initialized =.FALSE.
logical         :: use_brdf = .false.
type(time_type) :: time
real            :: delta_time
logical         :: use_single_geo
integer         :: num_l              ! # of water layers
real            :: dz    (max_lev)    ! thicknesses of layers
real            :: zfull (max_lev)
real            :: zhalf (max_lev+1)
real            :: Eg_min

integer         :: uptake_option = -1 
integer         :: gw_option = -1 

! ---- diagnostic field IDs
integer :: id_fast_soil_C, id_slow_soil_C, id_fsc, id_ssc, &
    id_lwc, id_swc, id_psi, id_temp, &
    id_ie, id_sn, id_bf, id_if, id_al, id_nu, id_sc, &
    id_hie, id_hsn, id_hbf, id_hif, id_hal, id_hnu, id_hsc, &
    id_heat_cap, id_thermal_cond, id_type, id_tau_gw, id_slope_l, &
    id_slope_Z, id_zeta_bar, id_e_depth, id_vwc_sat, id_vwc_fc, &
    id_vwc_wilt, id_K_sat, id_K_gw, id_w_fc, &
    id_refl_dry_dif, id_refl_dry_dir, id_refl_sat_dif, id_refl_sat_dir, &
    id_f_iso_dry, id_f_vol_dry, id_f_geo_dry, &
    id_f_iso_sat, id_f_vol_sat, id_f_geo_sat, &
    id_evap, id_uptk_n_iter, id_uptk, id_psi_x0, id_uptk_residual, &
    id_excess, id_deficit, id_deficit_2, id_deficit_3, id_zeta, id_tau, &
    id_psi_bot, id_sat_frac, id_stor_frac, id_sat_depth, id_sat_dept2, &
    id_cf_1, id_cf_3, id_wt_1, id_wt_2, id_wt_2a, id_wt_3, id_wt2_3, &
    id_div_bf, id_div_if, id_div_al, &
    id_z_cap, id_active_layer

! ==== end of module variables ===============================================

! ==== NetCDF declarations ===================================================
include 'netcdf.inc'
#define __NF_ASRT__(x) call print_netcdf_error((x),module_name,__LINE__)

contains

! ============================================================================
subroutine read_soil_namelist()
  ! ---- local vars
  integer :: unit         ! unit for namelist i/o
  integer :: io           ! i/o status for the namelist
  integer :: ierr         ! error code, returned by i/o routines
  integer :: l

  call read_soil_data_namelist(num_l,dz,use_single_geo,gw_option)

  call write_version_number(version, tagname)
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=soil_nml, iostat=io)
  ierr = check_nml_error(io, 'soil_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file()
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=soil_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'soil_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif
  if (mpp_pe() == mpp_root_pe()) then
     unit=stdlog()
     write(unit, nml=soil_nml)
  endif

  ! ---- set up vertical discretization
  zhalf(1) = 0
  do l = 1, num_l;   
     zhalf(l+1) = zhalf(l) + dz(l)
     zfull(l) = 0.5*(zhalf(l+1) + zhalf(l))
  enddo

  ! ---- convert symbolic names of options into numeric IDs to speed up
  ! the selection during run-time
  if (trim(uptake_to_use)=='linear') then
     uptake_option = UPTAKE_LINEAR
  else if (trim(uptake_to_use)=='darcy2d') then
     uptake_option = UPTAKE_DARCY2D
  else if (trim(uptake_to_use)=='darcy2d-linearized') then
     uptake_option = UPTAKE_DARCY2D_LIN
  else 
     call error_mesg('soil_init',&
          'soil uptake option uptake_to_use="'//&
          trim(uptake_to_use)//'" is invalid, use "linear", "darcy2d" or "darcy2d-linearized"',&
          FATAL)
  endif

  if (use_E_min) then
      Eg_min = 0.
    else
      Eg_min = -HUGE(Eg_min)
    endif

end subroutine read_soil_namelist


! ============================================================================
! initialize soil model
subroutine soil_init ( id_lon, id_lat, id_band )
  integer, intent(in)  :: id_lon  ! ID of land longitude (X) axis  
  integer, intent(in)  :: id_lat  ! ID of land latitude (Y) axis
  integer, intent(in)  :: id_band ! ID of spectral band axis

  ! ---- local vars
  integer :: unit, unit1  ! unit numbers for various i/o
  type(land_tile_enum_type)     :: te,ce  ! tail and current tile list elements
  type(land_tile_type), pointer :: tile   ! pointer to current tile
  real, allocatable :: gw_param(:,:), gw_param2(:,:), albedo(:,:,:) ! input data buffers for respective variables
  real, allocatable :: f_iso(:,:,:), f_vol(:,:,:), f_geo(:,:,:), refl_dif(:,:,:)

  integer :: i
  real :: psi(num_l), mwc(num_l)
  character(len=256) :: restart_file_name
  logical :: restart_exists

  module_is_initialized = .TRUE.
  time       = lnd%time
  delta_time = time_type_to_real(lnd%dt_fast)

  call uptake_init(num_l,dz,zfull)

  ! -------- initialize soil model diagnostic fields
  call soil_diag_init ( id_lon, id_lat, id_band )
  
  ! -------- read spatially distributed fields for groundwater parameters, if requested
  if (.not.use_single_geo) then
     select case (gw_option)
     case (GW_LINEAR,GW_LM2)
        allocate(gw_param(lnd%is:lnd%ie,lnd%js:lnd%je))
        call read_field( 'INPUT/groundwater_residence.nc','tau', lnd%lon, lnd%lat, &
             gw_param, interp='bilinear' )
        call put_to_tiles_r0d_fptr( gw_param, lnd%tile_map, soil_tau_groundwater_ptr )
        deallocate(gw_param)
     case (GW_HILL, GW_HILL_AR5)
        allocate(gw_param (lnd%is:lnd%ie,lnd%js:lnd%je))
        allocate(gw_param2(lnd%is:lnd%ie,lnd%js:lnd%je))
        call read_field( 'INPUT/geohydrology.nc','hillslope_length',  lnd%lon, lnd%lat, &
          gw_param, interp='bilinear' )
        call put_to_tiles_r0d_fptr( gw_param*gw_scale_length, lnd%tile_map, soil_hillslope_length_ptr )
        call read_field( 'INPUT/geohydrology.nc','slope', lnd%lon, lnd%lat, &
          gw_param2, interp='bilinear' )
        gw_param = gw_param*gw_param2
        call put_to_tiles_r0d_fptr( gw_param*gw_scale_relief, lnd%tile_map, soil_hillslope_relief_ptr )
        call read_field( 'INPUT/geohydrology.nc','hillslope_zeta_bar', &
          lnd%lon, lnd%lat, gw_param, interp='bilinear' )
        call put_to_tiles_r0d_fptr( gw_param, lnd%tile_map, soil_hillslope_zeta_bar_ptr )
        call read_field( 'INPUT/geohydrology.nc','soil_e_depth', &
          lnd%lon, lnd%lat, gw_param, interp='bilinear' )
        if (slope_exp.gt.0.01) then
            call put_to_tiles_r0d_fptr( gw_param*gw_scale_soil_depth*(0.08/gw_param2)**slope_exp, &
                                                  lnd%tile_map, soil_soil_e_depth_ptr )
        else
            call put_to_tiles_r0d_fptr( gw_param*gw_scale_soil_depth, lnd%tile_map, soil_soil_e_depth_ptr )
        endif
        if (gw_option /= GW_HILL_AR5) then
            call read_field( 'INPUT/geohydrology.nc','perm', lnd%lon, lnd%lat, &
                 gw_param, interp='bilinear' )
            call put_to_tiles_r0d_fptr(9.8e9*gw_scale_perm*gw_param, lnd%tile_map, &
                                            soil_k_sat_gw_ptr )
        endif
        deallocate(gw_param, gw_param2)
        te = tail_elmt (lnd%tile_map)
        ce = first_elmt(lnd%tile_map)
        do while(ce /= te)
            tile=>current_tile(ce)  ! get pointer to current tile
            ce=next_elmt(ce)        ! advance position to the next tile
            if (.not.associated(tile%soil)) cycle
            select case (gw_option)
            case (GW_HILL)
                call soil_data_init_derive_subsurf_pars(tile%soil)
            case (GW_HILL_AR5)
                call soil_data_init_derive_subsurf_pars_ar5(tile%soil)
            end select
        enddo
     end select ! gw_option
  endif ! single geo

  ! -------- set dry soil albedo values, if requested
  if (trim(albedo_to_use)=='albedo-map') then
     allocate(albedo(lnd%is:lnd%ie,lnd%js:lnd%je,NBANDS))
     call read_field( 'INPUT/soil_albedo.nc','SOIL_ALBEDO_VIS',&
          lnd%lon, lnd%lat, albedo(:,:,BAND_VIS),'bilinear')
     call read_field( 'INPUT/soil_albedo.nc','SOIL_ALBEDO_NIR',&
          lnd%lon, lnd%lat, albedo(:,:,BAND_NIR),'bilinear')
     call put_to_tiles_r1d_fptr( albedo, lnd%tile_map, soil_refl_dry_dir_ptr )
     call put_to_tiles_r1d_fptr( albedo, lnd%tile_map, soil_refl_dry_dif_ptr )
     ! for now, put the same value into the saturated soil albedo, so that
     ! the albedo doesn't depend on soil wetness
     call put_to_tiles_r1d_fptr( albedo, lnd%tile_map, soil_refl_sat_dir_ptr )
     call put_to_tiles_r1d_fptr( albedo, lnd%tile_map, soil_refl_sat_dif_ptr )
     deallocate(albedo)
  else if (trim(albedo_to_use)=='brdf-maps') then
     use_brdf = .true.
     allocate(   f_iso(lnd%is:lnd%ie,lnd%js:lnd%je,NBANDS))
     allocate(   f_vol(lnd%is:lnd%ie,lnd%js:lnd%je,NBANDS))
     allocate(   f_geo(lnd%is:lnd%ie,lnd%js:lnd%je,NBANDS))
     allocate(refl_dif(lnd%is:lnd%ie,lnd%js:lnd%je,NBANDS))
     call read_field( 'INPUT/soil_brdf.nc','f_iso_vis',&
          lnd%lon, lnd%lat, f_iso(:,:,BAND_VIS),'bilinear')
     call read_field( 'INPUT/soil_brdf.nc','f_vol_vis',&
          lnd%lon, lnd%lat, f_vol(:,:,BAND_VIS),'bilinear')
     call read_field( 'INPUT/soil_brdf.nc','f_geo_vis',&
          lnd%lon, lnd%lat, f_geo(:,:,BAND_VIS),'bilinear')
     call read_field( 'INPUT/soil_brdf.nc','f_iso_nir',&
          lnd%lon, lnd%lat, f_iso(:,:,BAND_NIR),'bilinear')
     call read_field( 'INPUT/soil_brdf.nc','f_vol_nir',&
          lnd%lon, lnd%lat, f_vol(:,:,BAND_NIR),'bilinear')
     call read_field( 'INPUT/soil_brdf.nc','f_geo_nir',&
          lnd%lon, lnd%lat, f_geo(:,:,BAND_NIR),'bilinear')
     refl_dif = g_iso*f_iso + g_vol*f_vol + g_geo*f_geo
     call put_to_tiles_r1d_fptr( f_iso,    lnd%tile_map, soil_f_iso_dry_ptr )
     call put_to_tiles_r1d_fptr( f_vol,    lnd%tile_map, soil_f_vol_dry_ptr )
     call put_to_tiles_r1d_fptr( f_geo,    lnd%tile_map, soil_f_geo_dry_ptr )
     call put_to_tiles_r1d_fptr( refl_dif, lnd%tile_map, soil_refl_dry_dif_ptr )
     ! for now, put the same value into the saturated soil albedo, so that
     ! the albedo doesn't depend on soil wetness
     call put_to_tiles_r1d_fptr( f_iso,    lnd%tile_map, soil_f_iso_sat_ptr )
     call put_to_tiles_r1d_fptr( f_vol,    lnd%tile_map, soil_f_vol_sat_ptr )
     call put_to_tiles_r1d_fptr( f_geo,    lnd%tile_map, soil_f_geo_sat_ptr )
     call put_to_tiles_r1d_fptr( refl_dif, lnd%tile_map, soil_refl_sat_dif_ptr )
     deallocate(f_iso, f_vol, f_geo, refl_dif)
  else if (trim(albedo_to_use)=='') then
     ! do nothing, that is leave soil albedo parameters as defined based on the data table
  else
     call error_mesg('soil_init',&
          'option albedo_to_use="'// trim(albedo_to_use)//&
          '" is invalid, use "albedo-map", "brdf-maps", or empty line ("")',&
          FATAL)
  endif
  
  ! -------- initialize soil state --------
  te = tail_elmt (lnd%tile_map)
  ce = first_elmt(lnd%tile_map)
  do while(ce /= te)
     tile=>current_tile(ce)  ! get pointer to current tile
     ce=next_elmt(ce)        ! advance position to the next tile
     if (.not.associated(tile%soil)) cycle
     if (init_wtdep .gt. 0.) then
         psi = zfull - init_wtdep
	 call soil_data_vwc_for_init_only(tile%soil, psi, mwc)
	 mwc = mwc * dens_h2o
       else if (init_w .ge. 0.) then
         mwc = init_w
       else ! negative init_w is to be intrepreted as prescribed saturation
         mwc = -init_w*tile%soil%pars%vwc_sat*dens_h2o
       endif
     if (init_temp.ge.tile%soil%pars%tfreeze) then
         tile%soil%prog%wl = mwc*dz(1:num_l)
         tile%soil%prog%ws = 0
       else
         tile%soil%prog%wl = 0
         tile%soil%prog%ws = mwc*dz(1:num_l)
       endif
     tile%soil%prog%T             = init_temp
     tile%soil%prog%groundwater   = init_groundwater
     tile%soil%prog%groundwater_T = init_temp
     tile%soil%uptake_T           = init_temp
     enddo

  call get_input_restart_name('INPUT/soil.res.nc',restart_exists,restart_file_name)
  if (restart_exists) then
     call error_mesg('soil_init',&
          'reading NetCDF restart "'//trim(restart_file_name)//'"',&
          NOTE)
     __NF_ASRT__(nf_open(restart_file_name,NF_NOWRITE,unit))
     call read_tile_data_r1d_fptr(unit, 'temp'         , soil_T_ptr  )
     call read_tile_data_r1d_fptr(unit, 'wl'           , soil_wl_ptr )
     call read_tile_data_r1d_fptr(unit, 'ws'           , soil_ws_ptr )
     call read_tile_data_r1d_fptr(unit, 'groundwater'  , soil_groundwater_ptr )
     call read_tile_data_r1d_fptr(unit, 'groundwater_T', soil_groundwater_T_ptr)
     if(nfu_inq_var(unit, 'uptake_T')==NF_NOERR) &
          call read_tile_data_r0d_fptr(unit, 'uptake_T', soil_uptake_T_ptr)
     if(nfu_inq_var(unit, 'fsc')==NF_NOERR) then 
        call read_tile_data_r1d_fptr(unit,'fsc',soil_fast_soil_C_ptr)
        call read_tile_data_r1d_fptr(unit,'ssc',soil_slow_soil_C_ptr)
     else
        ! try to read fsc and ssc from vegetation restart
        call get_input_restart_name('INPUT/vegn2.res.nc',restart_exists,restart_file_name)
        if (restart_exists) then
           __NF_ASRT__(nf_open(restart_file_name,NF_NOWRITE,unit1))
           ! read old (scalar) fsc and ssc into the first element of the fast_soil_C
           ! and slow_soil_C arrays
           call read_tile_data_r1d_fptr(unit1,'fsc',soil_fast_soil_C_ptr,1)
           call read_tile_data_r1d_fptr(unit1,'ssc',soil_slow_soil_C_ptr,1)
        endif
     endif
          
     __NF_ASRT__(nf_close(unit))     
  else
     call error_mesg('soil_init', 'cold-starting soil', NOTE)
  endif

  ! read soil carbon restart, if present
  call get_input_restart_name('INPUT/soil_carbon.res.nc',restart_exists,restart_file_name)
  if (restart_exists) then
     __NF_ASRT__(nf_open(restart_file_name,NF_NOWRITE,unit))
     call error_mesg('veg_data_init','reading soil_carbon restart',NOTE)
     call read_tile_data_r1d_fptr(unit,'asoil_in',soil_asoil_in_ptr)
     call read_tile_data_r1d_fptr(unit,'fsc_in',soil_fsc_in_ptr)
     call read_tile_data_r1d_fptr(unit,'ssc_in',soil_ssc_in_ptr)
     __NF_ASRT__(nf_close(unit))     
  endif
  
  ! ---- static diagnostic section
  call send_tile_data_r0d_fptr(id_tau_gw,       lnd%tile_map, soil_tau_groundwater_ptr)
  call send_tile_data_r0d_fptr(id_slope_l,      lnd%tile_map, soil_hillslope_length_ptr)
  call send_tile_data_r0d_fptr(id_slope_Z,      lnd%tile_map, soil_hillslope_relief_ptr)
  call send_tile_data_r0d_fptr(id_zeta_bar,     lnd%tile_map, soil_hillslope_zeta_bar_ptr)
  call send_tile_data_r0d_fptr(id_e_depth,      lnd%tile_map, soil_soil_e_depth_ptr)
  call send_tile_data_r0d_fptr(id_zeta,         lnd%tile_map, soil_zeta_ptr)
  call send_tile_data_r0d_fptr(id_tau,          lnd%tile_map, soil_tau_ptr)
  call send_tile_data_r0d_fptr(id_vwc_wilt,     lnd%tile_map, soil_vwc_wilt_ptr)
  call send_tile_data_r0d_fptr(id_vwc_fc,       lnd%tile_map, soil_vwc_fc_ptr)
  call send_tile_data_r0d_fptr(id_vwc_sat,      lnd%tile_map, soil_vwc_sat_ptr)
  call send_tile_data_r0d_fptr(id_K_sat,        lnd%tile_map, soil_k_sat_ref_ptr)
  call send_tile_data_r0d_fptr(id_K_gw,         lnd%tile_map, soil_k_sat_gw_ptr)
  call send_tile_data_r1d_fptr(id_w_fc,         lnd%tile_map, soil_w_fc_ptr)
  call send_tile_data_r1d_fptr(id_refl_dry_dir, lnd%tile_map, soil_refl_dry_dir_ptr)
  call send_tile_data_r1d_fptr(id_refl_dry_dif, lnd%tile_map, soil_refl_dry_dif_ptr)
  call send_tile_data_r1d_fptr(id_refl_sat_dir, lnd%tile_map, soil_refl_sat_dir_ptr)
  call send_tile_data_r1d_fptr(id_refl_sat_dif, lnd%tile_map, soil_refl_sat_dif_ptr)
  call send_tile_data_r1d_fptr(id_f_iso_dry, lnd%tile_map, soil_f_iso_dry_ptr)
  call send_tile_data_r1d_fptr(id_f_vol_dry, lnd%tile_map, soil_f_vol_dry_ptr)
  call send_tile_data_r1d_fptr(id_f_geo_dry, lnd%tile_map, soil_f_geo_dry_ptr)
  call send_tile_data_r1d_fptr(id_f_iso_sat, lnd%tile_map, soil_f_iso_sat_ptr)
  call send_tile_data_r1d_fptr(id_f_vol_sat, lnd%tile_map, soil_f_vol_sat_ptr)
  call send_tile_data_r1d_fptr(id_f_geo_sat, lnd%tile_map, soil_f_geo_sat_ptr)
  call send_tile_data_i0d_fptr(id_type,         lnd%tile_map, soil_tag_ptr)
end subroutine soil_init


! ============================================================================
subroutine soil_diag_init ( id_lon, id_lat, id_band )
  integer, intent(in) :: id_lon  ! ID of land longitude (X) axis  
  integer, intent(in) :: id_lat  ! ID of land latitude (Y) axis
  integer, intent(in) :: id_band ! ID of spectral band axis  

  ! ---- local vars
  integer :: axes(3)
  integer :: id_zhalf, id_zfull

  ! define vertical axis and its' edges
  id_zhalf = diag_axis_init ( &
       'zhalf_soil', zhalf(1:num_l+1), 'meters', 'z', 'half level',  -1, set_name='soil' )
  id_zfull = diag_axis_init ( &
       'zfull_soil', zfull(1:num_l),   'meters', 'z', 'full level',  -1, set_name='soil', &
       edges=id_zhalf )

  ! define array of axis indices
  axes = (/ id_lon, id_lat, id_zfull /)

  ! define diagnostic fields
  id_fast_soil_C = register_tiled_diag_field ( module_name, 'fast_soil_C', axes,  &
       Time, 'fast soil carbon', 'kg C/m3', missing_value=-100.0 )
  id_slow_soil_C = register_tiled_diag_field ( module_name, 'slow_soil_C', axes,  &
       Time, 'slow soil carbon', 'kg C/m3', missing_value=-100.0 )
  id_fsc = register_tiled_diag_field ( module_name, 'fsc', axes(1:2),  &
       Time, 'total fast soil carbon', 'kg C/m2', missing_value=-100.0 )
  id_ssc = register_tiled_diag_field ( module_name, 'ssc', axes(1:2),  &
       Time, 'total slow soil carbon', 'kg C/m2', missing_value=-100.0 )
  id_lwc = register_tiled_diag_field ( module_name, 'soil_liq', axes,  &
       Time, 'bulk density of liquid water', 'kg/m3', missing_value=-100.0 )
  id_swc  = register_tiled_diag_field ( module_name, 'soil_ice',  axes,  &
       Time, 'bulk density of solid water', 'kg/m3',  missing_value=-100.0 )
  id_psi = register_tiled_diag_field ( module_name, 'soil_psi', axes,  &
       Time, 'soil-water matric head', 'm', missing_value=-100.0 )
  id_temp  = register_tiled_diag_field ( module_name, 'soil_T',  axes,       &
       Time, 'temperature',            'degK',  missing_value=-100.0 )
  id_ie  = register_tiled_diag_field ( module_name, 'soil_rie',  axes(1:2),  &
       Time, 'inf exc runf',            'kg/(m2 s)',  missing_value=-100.0 )
  id_sn  = register_tiled_diag_field ( module_name, 'soil_rsn',  axes(1:2),  &
       Time, 'satn runf',            'kg/(m2 s)',  missing_value=-100.0 )
  id_bf  = register_tiled_diag_field ( module_name, 'soil_rbf',  axes(1:2),  &
       Time, 'baseflow',            'kg/(m2 s)',  missing_value=-100.0 )
  id_if  = register_tiled_diag_field ( module_name, 'soil_rif',  axes(1:2),  &
       Time, 'interflow',            'kg/(m2 s)',  missing_value=-100.0 )
  id_al  = register_tiled_diag_field ( module_name, 'soil_ral',  axes(1:2),  &
       Time, 'active layer flow',    'kg/(m2 s)',  missing_value=-100.0 )
  id_nu  = register_tiled_diag_field ( module_name, 'soil_rnu',  axes(1:2),  &
       Time, 'numerical runoff',    'kg/(m2 s)',  missing_value=-100.0 )
  id_sc  = register_tiled_diag_field ( module_name, 'soil_rsc',  axes(1:2),  &
       Time, 'lm2 groundwater runoff',    'kg/(m2 s)',  missing_value=-100.0 )
  id_hie  = register_tiled_diag_field ( module_name, 'soil_hie',  axes(1:2), &
       Time, 'heat ie runf',            'W/m2',  missing_value=-100.0 )
  id_hsn  = register_tiled_diag_field ( module_name, 'soil_hsn',  axes(1:2), &
       Time, 'heat sn runf',            'W/m2',  missing_value=-100.0 )
  id_hbf  = register_tiled_diag_field ( module_name, 'soil_hbf',  axes(1:2), &
       Time, 'heat bf runf',            'W/m2',  missing_value=-100.0 )
  id_hif  = register_tiled_diag_field ( module_name, 'soil_hif',  axes(1:2), &
       Time, 'heat if runf',            'W/m2',  missing_value=-100.0 )
  id_hal  = register_tiled_diag_field ( module_name, 'soil_hal',  axes(1:2), &
       Time, 'heat al runf',            'W/m2',  missing_value=-100.0 )
  id_hnu  = register_tiled_diag_field ( module_name, 'soil_hnu',  axes(1:2), &
       Time, 'heat nu runoff',          'W/m2',  missing_value=-100.0 )
  id_hsc  = register_tiled_diag_field ( module_name, 'soil_hsc',  axes(1:2), &
       Time, 'heat sc runoff',          'W/m2',  missing_value=-100.0 )
  id_evap  = register_tiled_diag_field ( module_name, 'soil_evap',  axes(1:2), &
       Time, 'soil evap',            'kg/(m2 s)',  missing_value=-100.0 )
  id_excess  = register_tiled_diag_field ( module_name, 'sfc_excess',  axes(1:2),  &
       Time, 'sfc excess pushed down',    'kg/(m2 s)',  missing_value=-100.0 )

  id_uptk_n_iter  = register_tiled_diag_field ( module_name, 'uptake_n_iter',  axes(1:2), &
       Time, 'number of iterations for soil uptake',  missing_value=-100.0 )
  id_uptk = register_tiled_diag_field ( module_name, 'soil_uptk', axes, &
       Time, 'uptake of water by roots', 'kg/(m2 s)',  missing_value=-100.0 )
  id_psi_x0 = register_tiled_diag_field ( module_name, 'soil_psix0', axes(1:2), &
       Time, 'xylem potential at z=0', 'm',  missing_value=-100.0 )
  id_deficit = register_tiled_diag_field ( module_name, 'soil_def', axes(1:2), &
       Time, 'groundwater storage deficit', '-',  missing_value=-100.0 )
  id_deficit_2 = register_tiled_diag_field ( module_name, 'soil_def2', axes(1:2), &
       Time, 'groundwater storage deficit2', '-',  missing_value=-100.0 )
  id_deficit_3 = register_tiled_diag_field ( module_name, 'soil_def3', axes(1:2), &
       Time, 'groundwater storage deficit3', '-',  missing_value=-100.0 )
  id_psi_bot = register_tiled_diag_field ( module_name, 'soil_psi_n', axes(1:2), &
       Time, 'psi at bottom of soil column', 'm',  missing_value=-100.0 )
  id_sat_frac = register_tiled_diag_field ( module_name, 'soil_fsat', axes(1:2), &
       Time, 'fraction of soil area saturated at surface', '-',  missing_value=-100.0 )
  id_stor_frac = register_tiled_diag_field ( module_name, 'soil_fgw', axes(1:2), &
       Time, 'groundwater storage frac above base elev', '-',  missing_value=-100.0 )
  id_sat_depth = register_tiled_diag_field ( module_name, 'soil_wtdep', axes(1:2), &
       Time, 'depth below sfc to saturated soil', 'm',  missing_value=-100.0 )
  id_sat_dept2 = register_tiled_diag_field ( module_name, 'soil_wtdp2', axes(1:2), &
       Time, 'alt depth below sfc to saturated soil', 'm',  missing_value=-100.0 )
  id_z_cap = register_tiled_diag_field ( module_name, 'soil_zcap', axes(1:2), &
       Time, 'depth below sfc to capillary fringe', 'm',  missing_value=-100.0 )

  id_div_bf = register_tiled_diag_field ( module_name, 'soil_dvbf', axes, &
       Time, 'baseflow by layer', 'kg/(m2 s)',  missing_value=-100.0 )
  id_div_if = register_tiled_diag_field ( module_name, 'soil_dvif', axes, &
       Time, 'interflow by layer', 'kg/(m2 s)',  missing_value=-100.0 )
  id_div_al = register_tiled_diag_field ( module_name, 'soil_dval', axes, &
       Time, 'active-layer flow by layer', 'kg/(m2 s)',  missing_value=-100.0 )

  id_cf_1 = register_tiled_diag_field ( module_name, 'soil_cf_1', axes(1:2), &
       Time, 'soil_cf_1', 'm',  missing_value=-100.0 )
  id_cf_3 = register_tiled_diag_field ( module_name, 'soil_cf_3', axes(1:2), &
       Time, 'soil_cf_1', 'm',  missing_value=-100.0 )
  id_wt_1 = register_tiled_diag_field ( module_name, 'soil_wt_1', axes(1:2), &
       Time, 'soil_wt_1', 'm',  missing_value=-100.0 )
  id_wt_2 = register_tiled_diag_field ( module_name, 'soil_wt_2', axes(1:2), &
       Time, 'soil_wt_2', 'm',  missing_value=-100.0 )
  id_wt_2a = register_tiled_diag_field ( module_name, 'soil_wt_2a', axes(1:2), &
       Time, 'soil_wt_2a', 'm',  missing_value=-100.0 )
  id_wt_3 = register_tiled_diag_field ( module_name, 'soil_wt_3', axes(1:2), &
       Time, 'soil_wt_3', 'm',  missing_value=-100.0 )
  id_wt2_3 = register_tiled_diag_field ( module_name, 'soil_wt2_3', axes(1:2), &
       Time, 'soil_wt2_3', 'm',  missing_value=-100.0 )

  id_active_layer = register_tiled_diag_field ( module_name, 'soil_alt', axes(1:2), &
       Time, 'active-layer thickness', 'm',  missing_value=-100.0 )
  id_heat_cap = register_tiled_diag_field ( module_name, 'soil_heat_cap',  &
       axes, Time, 'heat capacity of dry soil','J/(m3 K)', missing_value=-100.0 )
  id_thermal_cond =  register_tiled_diag_field ( module_name, 'soil_tcon', &
       axes, Time, 'soil thermal conductivity', 'W/(m K)',  missing_value=-100.0 )
  
  id_type = register_tiled_static_field ( module_name, 'soil_type',  &
       axes(1:2), 'soil type', missing_value=-1.0 )
  id_tau_gw = register_tiled_static_field ( module_name, 'tau_gw',  &
       axes(1:2), 'groundwater residence time', 's', missing_value=-100.0 )
  id_slope_l = register_tiled_static_field ( module_name, 'slope_l',  &
       axes(1:2), 'hillslope length', 'm', missing_value=-100.0 )
  id_slope_Z = register_tiled_static_field ( module_name, 'soil_rlief',  &
       axes(1:2), 'hillslope relief', 'm', missing_value=-100.0 )
  id_zeta_bar = register_tiled_static_field ( module_name, 'zeta_bar',  &
       axes(1:2), 'hillslope zeta bar', '-', missing_value=-100.0 )
  id_e_depth = register_tiled_static_field ( module_name, 'soil_depth',  &
       axes(1:2), 'soil e-folding depth', 'm', missing_value=-100.0 )
  id_zeta = register_tiled_static_field ( module_name, 'soil_zeta',      &
       axes(1:2), 'soil depth/topo relief', '-',  missing_value=-100.0 )
  id_tau = register_tiled_static_field ( module_name, 'soil_tau',        &
       axes(1:2), 'gw transmissivity/soil transmissivity', '-',  missing_value=-100.0 )
  id_vwc_wilt = register_tiled_static_field ( module_name, 'soil_wilt',  &
       axes(1:2), 'wilting water content', '-', missing_value=-100.0 )
  id_vwc_fc = register_tiled_static_field ( module_name, 'soil_fc',  &
       axes(1:2), 'field capacity', '-', missing_value=-100.0 )
  id_vwc_sat = register_tiled_static_field ( module_name, 'soil_sat',  &
       axes(1:2), 'soil porosity', '-', missing_value=-100.0 )
  id_K_sat = register_tiled_static_field ( module_name, 'soil_Ksat',  &
       axes(1:2), 'soil sat. hydraulic conductivity', 'kg /(m2 s)', missing_value=-100.0 )
  id_K_gw  = register_tiled_static_field ( module_name, 'soil_K_gw',  &
       axes(1:2), 'deep hydraulic conductivity', 'kg /(m2 s)', missing_value=-100.0 )
  id_w_fc = register_tiled_static_field ( module_name, 'w_fc',  &
       axes, 'soil field capacity', missing_value=-1.0 )
  id_refl_dry_dir = register_tiled_static_field ( module_name, 'refl_dry_dir',  &
       (/id_lon, id_lat, id_band/), 'reflectance of dry soil for direct light', &
       missing_value=-1.0 )
  id_refl_dry_dif = register_tiled_static_field ( module_name, 'refl_dry_dif',  &
       (/id_lon, id_lat, id_band/), 'reflectance of dry soil for diffuse light', &
       missing_value=-1.0 )
  id_refl_sat_dir = register_tiled_static_field ( module_name, 'refl_sat_dir',  &
       (/id_lon, id_lat, id_band/), 'reflectance of saturated soil for direct light', &
       missing_value=-1.0 )
  id_refl_sat_dif = register_tiled_static_field ( module_name, 'refl_sat_dif',  &
       (/id_lon, id_lat, id_band/), 'reflectance of saturated soil for diffuse light', &
       missing_value=-1.0 )
  id_f_iso_dry = register_tiled_static_field ( module_name, 'f_iso_dry',  &
       (/id_lon, id_lat, id_band/), 'isotropic brdf weight, dry soil', &
       missing_value=-1.0 )
  id_f_vol_dry = register_tiled_static_field ( module_name, 'f_vol_dry',  &
       (/id_lon, id_lat, id_band/), 'volumetric brdf weight, dry soil', &
       missing_value=-1.0 )
  id_f_geo_dry = register_tiled_static_field ( module_name, 'f_geo_dry',  &
       (/id_lon, id_lat, id_band/), 'geometric brdf weight, dry soil', &
       missing_value=-1.0 )
  id_f_iso_sat = register_tiled_static_field ( module_name, 'f_iso_sat',  &
       (/id_lon, id_lat, id_band/), 'isotropic brdf weight, saturated soil', &
       missing_value=-1.0 )
  id_f_vol_sat = register_tiled_static_field ( module_name, 'f_vol_sat',  &
       (/id_lon, id_lat, id_band/), 'volumetric brdf weight, saturated soil', &
       missing_value=-1.0 )
  id_f_geo_sat = register_tiled_static_field ( module_name, 'f_geo_sat',  &
       (/id_lon, id_lat, id_band/), 'geometric brdf weight, saturated soil', &
       missing_value=-1.0 )

  ! the following fields are for compatibility with older diag tables only
  call add_tiled_static_field_alias ( id_slope_Z, module_name, 'slope_Z',  &
       axes(1:2), 'hillslope relief (obsolete, use "soil_rlief" instead)',&
       'm', missing_value=-100.0 )
  call add_tiled_static_field_alias ( id_e_depth, module_name, 'e_depth',  &
       axes(1:2), 'soil e-folding depth (obsolete, use "soil_depth" instead)', &
       'm', missing_value=-100.0 )
  call add_tiled_static_field_alias ( id_vwc_wilt, module_name, 'vwc_wilt',  &
       axes(1:2), 'wilting water content (obsolete, use "soil_wilt" instead)', &
       '-', missing_value=-100.0 )
  call add_tiled_static_field_alias ( id_vwc_fc, module_name, 'vwc_fc',  &
       axes(1:2), 'field capacity (obsolete, use "soil_fc" instead)', &
       '-', missing_value=-100.0 )
  call add_tiled_static_field_alias ( id_vwc_sat, module_name, 'vwc_sat',  &
       axes(1:2), 'soil porosity (obsolete, use "soil_sat")', &
       '-', missing_value=-100.0 )
  call add_tiled_static_field_alias ( id_K_sat, module_name, 'K_sat',  &
       axes(1:2), 'soil sat. hydraulic conductivity (obsolte, use "soil_Ksat" instead)', &
       'kg /(m2 s)', missing_value=-100.0 )

end subroutine soil_diag_init


! ============================================================================
subroutine soil_end ()

  module_is_initialized =.FALSE.

end subroutine soil_end


! ============================================================================
subroutine save_soil_restart (tile_dim_length, timestamp)
  integer, intent(in) :: tile_dim_length ! length of tile dim. in the output file
  character(*), intent(in) :: timestamp ! timestamp to add to the file name

  ! ---- local vars ----------------------------------------------------------
  integer :: unit            ! restart file i/o unit

  call error_mesg('soil_end','writing NetCDF restart',NOTE)
  ! create output file, including internal structure necessary for output
  call create_tile_out_file(unit,'RESTART/'//trim(timestamp)//'soil.res.nc', &
          lnd%coord_glon, lnd%coord_glat, soil_tile_exists, tile_dim_length )
  ! in addition, define vertical coordinate
  if (mpp_pe()==lnd%io_pelist(1)) then
     __NF_ASRT__(nfu_def_dim(unit,'zfull',zfull(1:num_l),'full level','m'))
     __NF_ASRT__(nfu_put_att(unit,'zfull','positive','down'))
  endif
  call sync_nc_files(unit)
        
  ! write out fields
  call write_tile_data_r1d_fptr(unit,'temp'         ,soil_T_ptr   ,'zfull','soil temperature','degrees_K')
  call write_tile_data_r1d_fptr(unit,'wl'           ,soil_wl_ptr  ,'zfull','liquid water content','kg/m2')
  call write_tile_data_r1d_fptr(unit,'ws'           ,soil_ws_ptr  ,'zfull','solid water content','kg/m2')
  call write_tile_data_r1d_fptr(unit,'groundwater'  ,soil_groundwater_ptr  ,'zfull')
  call write_tile_data_r1d_fptr(unit,'groundwater_T',soil_groundwater_T_ptr ,'zfull')
  call write_tile_data_r0d_fptr(unit,'uptake_T',     soil_uptake_T_ptr, 'temperature of transpiring water', 'degrees_K')
  call write_tile_data_r1d_fptr(unit,'fsc',          soil_fast_soil_C_ptr,'zfull','fast soil carbon', 'kg C/m2')
  call write_tile_data_r1d_fptr(unit,'ssc',          soil_slow_soil_C_ptr,'zfull','slow soil carbon', 'kg C/m2')
  
  ! close file
  __NF_ASRT__(nf_close(unit))

  if (write_soil_carbon_restart) then
     call create_tile_out_file(unit,'RESTART/'//trim(timestamp)//'soil_carbon.res.nc', &
          lnd%coord_glon, lnd%coord_glat, soil_tile_exists, tile_dim_length )
     ! in addition, define vertical coordinate
     if (mpp_pe()==lnd%io_pelist(1)) then
        __NF_ASRT__(nfu_def_dim(unit,'zfull',zfull(1:num_l),'full level','m'))
        __NF_ASRT__(nfu_put_att(unit,'zfull','positive','down'))
     endif
     call sync_nc_files(unit)

     call write_tile_data_r1d_fptr(unit,'asoil_in',soil_asoil_in_ptr,'zfull','aerobic activity modifier', 'unitless')
     call write_tile_data_r1d_fptr(unit,'fsc_in',soil_fsc_in_ptr,'zfull','fast soil carbon input', 'kg C/m2')
     call write_tile_data_r1d_fptr(unit,'ssc_in',soil_ssc_in_ptr,'zfull','slow soil carbon input', 'kg C/m2')
     __NF_ASRT__(nf_close(unit))
  endif


end subroutine save_soil_restart


! ============================================================================
subroutine soil_get_sfc_temp ( soil, soil_T )
  type(soil_tile_type), intent(in) :: soil
  real, intent(out) :: soil_T

  soil_T= soil%prog(1)%T
end subroutine soil_get_sfc_temp


! ============================================================================
! compute soil radiative properties
subroutine soil_radiation ( soil, cosz, &
     soil_refl_dir, soil_refl_dif, soil_refl_lw, soil_emis )
  type(soil_tile_type), intent(in) :: soil
  real, intent(in)  :: cosz
  real, intent(out) :: soil_refl_dir(NBANDS), soil_refl_dif(NBANDS), soil_refl_lw, soil_emis

  call soil_data_radiation ( soil, cosz, use_brdf, soil_refl_dir, soil_refl_dif, soil_emis )
  soil_refl_lw = 1 - soil_emis
  call check_var_range(soil_refl_dir(BAND_VIS), 0.0, 1.0, 'soil_radiation', 'soil_refl_dir(VIS)', lnd%time, FATAL)
  call check_var_range(soil_refl_dir(BAND_NIR), 0.0, 1.0, 'soil_radiation', 'soil_refl_dir(NIR)', lnd%time, FATAL)
  call check_var_range(soil_refl_dif(BAND_VIS), 0.0, 1.0, 'soil_radiation', 'soil_refl_dif(VIS)', lnd%time, FATAL)
  call check_var_range(soil_refl_dif(BAND_NIR), 0.0, 1.0, 'soil_radiation', 'soil_refl_dif(NIR)', lnd%time, FATAL)
end subroutine soil_radiation


! ============================================================================
! compute soil roughness
subroutine soil_diffusion ( soil, soil_z0s, soil_z0m )
  type(soil_tile_type), intent(in) :: soil
  real, intent(out) :: soil_z0s, soil_z0m

  call soil_data_diffusion ( soil, soil_z0s, soil_z0m )
end subroutine soil_diffusion


! ============================================================================
! compute beta function
! after Manabe (1969), but distributed vertically.
subroutine soil_data_beta ( soil, vegn, soil_beta, soil_water_supply, &
                            soil_uptake_T, soil_rh, soil_rh_psi )
  type(soil_tile_type), intent(inout)  :: soil
  type(vegn_tile_type), intent(in)     :: vegn
  real, intent(out) :: soil_beta
  real, intent(out) :: soil_water_supply ! max rate of water supply to roots, kg/(m2 s)
  real, intent(out) :: soil_uptake_T ! an estimate of temperature of the water 
             ! taken up by transpiration. In case of 'linear' uptake it is an exact
             ! value; in case of 'darcy*' treatments the actual uptake profile
             ! is calculated only in step 2, so the value returned is an estimate  
  real, intent(out) :: soil_rh
  real, intent(out) :: soil_rh_psi

  ! ---- local vars
  integer :: l
  real, dimension(num_l) :: &
       uptake_frac_max, & ! root distribution
       vegn_uptake_term, &
       vlc, vsc, & ! volumetric fractions of water and ice in the layer
       VRL, & ! vertical distribution of volumetric root length, m/m3
       u, du ! uptake and its derivative (the latter is not used)
  real :: psi_for_rh
  real :: K_r, r_r ! root properties
  real :: z  !  soil depth

  call vegn_uptake_profile (vegn, dz(1:num_l), uptake_frac_max, vegn_uptake_term )

  vlc=0;vsc=0
  do l = 1, num_l
    vlc(l) = max(0., soil%prog(l)%wl / (dens_h2o*dz(l)))
    vsc(l) = max(0., soil%prog(l)%ws / (dens_h2o*dz(l)))
    enddo
  
  soil%uptake_frac = 0
  do l = 1, num_l
     soil%uptake_frac(l) = uptake_frac_max(l) &
          * max(0.0, min(1.0,(vlc(l)-soil%w_wilt(l))/&
               (0.75*(soil%w_fc(l)-soil%w_wilt(l)))))
  enddo
  soil_beta = sum(soil%uptake_frac)
  do l = 1, num_l
     if (soil_beta /= 0) then
          soil%uptake_frac(l) = soil%uptake_frac(l) / soil_beta
     else
          soil%uptake_frac(l) = uptake_frac_max(l)
     endif
  enddo
  if (lm2) soil%uptake_frac = uptake_frac_max

  ! calculate relative humidity at soil surface
  call soil_data_psi_for_rh ( soil, vlc, vsc, soil%psi, psi_for_rh )
  soil_rh = exp(psi_for_rh*g_RT)
  soil_rh_psi = g_RT*soil_rh

  ! calculate total water supply
  select case (uptake_option)
  case(UPTAKE_LINEAR)
     soil_water_supply = 0
     z = 0
     do l = 1, num_l
        soil_water_supply = soil_water_supply + &
          vegn_uptake_term(l)*max(0.0,soil%prog(l)%wl/dz(l)-soil%w_wilt(l)*dens_h2o)
        z = z + dz(l)
     enddo
     soil_water_supply = z * soil_water_supply
     soil_water_supply = soil_water_supply/delta_time
     soil_uptake_T = sum(soil%uptake_frac*soil%prog%T)
  case(UPTAKE_DARCY2D)
     call vegn_root_properties (vegn, dz(1:num_l), VRL, K_r, r_r)
     call darcy2d_uptake ( soil, psi_wilt, VRL, K_r, r_r, uptake_oneway,&
          uptake_from_sat, u, du )
     soil_water_supply = max(0.0,sum(u))
     soil_uptake_T = soil%uptake_T
  case(UPTAKE_DARCY2D_LIN)
     call vegn_root_properties (vegn, dz(1:num_l), VRL, K_r, r_r)
     call darcy2d_uptake_lin ( soil, psi_wilt, VRL, K_r, r_r, uptake_oneway, &
          uptake_from_sat, u, du)
     soil_water_supply = max(0.0,sum(u))
     soil_uptake_T = soil%uptake_T
  end select
end subroutine soil_data_beta


! ============================================================================
! update soil properties explicitly for time step.
! MAY WISH TO INTRODUCE 'UNIVERSAL' SENSITIVITIES FOR SIMPLICITY.
! T-DEPENDENCE OF HYDRAULIC PROPERTIES COULD BE DONE LESS FREQUENTLY.
! integrate soil-heat conduction equation upward from bottom of soil
! to surface, delivering linearization of surface ground heat flux.
subroutine soil_step_1 ( soil, vegn, diag, &
                         soil_T, soil_uptake_T, soil_beta, soil_water_supply, &
                         soil_E_min, soil_E_max, &
                         soil_rh, soil_rh_psi, soil_liq, soil_ice, soil_subl, soil_tf, &
                         soil_G0, soil_DGDT )
  type(soil_tile_type), intent(inout) :: soil
  type(vegn_tile_type), intent(in)    :: vegn
  type(diag_buff_type), intent(inout) :: diag
  real, intent(out) :: &
       soil_T, &    ! temperature of the upper layer of the soil, degK
       soil_uptake_T, & ! estimate of the temperature of the water taken up by transpiration
       soil_beta, &
       soil_water_supply, & ! supply of water to vegetation per unit total active root biomass, kg/m2 
       soil_E_min, &
       soil_E_max, &
       soil_rh,   & ! soil surface relative humidity
       soil_rh_psi,& ! derivative of soil_rh w.r.t. soil surface matric head
       soil_liq,  & ! amount of liquid water available for implicit freeze (=0)
       soil_ice,  & ! amount of ice available for implicit melt (=0)
       soil_subl, & ! part of sublimation in water vapor flux, dimensionless [0,1]
       soil_tf,   & ! soil freezing temperature, degK
       soil_G0, soil_DGDT ! linearization of ground heat flux
  ! ---- local vars
  real :: bbb, denom, dt_e
  real, dimension(num_l) :: aaa, ccc, thermal_cond, heat_capacity, vlc, vsc
  integer :: l

  if(is_watch_point()) then
     write(*,*) 'soil%tag', soil%tag
     write(*,*) 'soil%pars%k_sat_ref', soil%pars%k_sat_ref 
     write(*,*) 'soil%pars%psi_sat_ref', soil%pars%psi_sat_ref
     write(*,*) 'soil%pars%chb', soil%pars%chb
     write(*,*) 'soil%pars%w_sa', soil%pars%vwc_sat
  endif
! ----------------------------------------------------------------------------
! in preparation for implicit energy balance, determine various measures
! of water availability, so that vapor fluxes will not exceed mass limits
! ----------------------------------------------------------------------------

  soil_T = soil%prog(1)%T
  call soil_data_beta ( soil, vegn, soil_beta, soil_water_supply, soil_uptake_T, &
                        soil_rh, soil_rh_psi )

  do l = 1, num_l
    vlc(l) = max(0.0, soil%prog(l)%wl / (dens_h2o * dz(l)))
    vsc(l) = max(0.0, soil%prog(l)%ws / (dens_h2o * dz(l)))
    enddo
  call soil_data_thermodynamics ( soil, vlc, vsc,  &  
                                  soil_E_max, thermal_cond )
  if (.not.use_E_max) soil_E_max =  HUGE(soil_E_max)
  soil_E_min = Eg_min

  do l = 1, num_l
     heat_capacity(l) = soil%heat_capacity_dry(l) *dz(l) &
          + clw*soil%prog(l)%wl + csw*soil%prog(l)%ws
  enddo

  soil_liq  = max(soil%prog(1)%wl, 0.)
  soil_ice  = max(soil%prog(1)%ws, 0.)
  if (soil_liq + soil_ice > 0) then
     soil_subl = soil_ice / (soil_liq + soil_ice)
  else
     soil_subl = 0
  endif
  soil_liq = 0
  soil_ice = 0

  if(num_l > 1) then
     do l = 1, num_l-1
        dt_e = 2 / ( dz(l+1)/thermal_cond(l+1) &
                     + dz(l)/thermal_cond(l)   )
        aaa(l+1) = - dt_e * delta_time / heat_capacity(l+1)
        ccc(l)   = - dt_e * delta_time / heat_capacity(l)
     enddo

     bbb = 1.0 - aaa(num_l)
     denom = bbb
     dt_e = aaa(num_l)*(soil%prog(num_l)%T - soil%prog(num_l-1)%T) &
               + soil%geothermal_heat_flux * delta_time / heat_capacity(num_l)
     soil%e(num_l-1) = -aaa(num_l)/denom
     soil%f(num_l-1) = dt_e/denom
     do l = num_l-1, 2, -1
        bbb = 1.0 - aaa(l) - ccc(l)
        denom = bbb + ccc(l)*soil%e(l)
        dt_e = - ( ccc(l)*(soil%prog(l+1)%T - soil%prog(l)%T  ) &
                  -aaa(l)*(soil%prog(l)%T   - soil%prog(l-1)%T) )
        soil%e(l-1) = -aaa(l)/denom
        soil%f(l-1) = (dt_e - ccc(l)*soil%f(l))/denom
     end do
     denom = delta_time/(heat_capacity(1) )
     soil_G0   = ccc(1)*(soil%prog(2)%T- soil%prog(1)%T + soil%f(1)) / denom
     soil_DGDT = (1 - ccc(1)*(1-soil%e(1))) / denom   
  else  ! one-level case
     denom = delta_time/heat_capacity(1)
     soil_G0    = 0.
     soil_DGDT  = 1. / denom
  end if
  
  ! set soil freezing temperature
  soil_tf = soil%pars%tfreeze

  if(is_watch_point()) then
     write(*,*) '#### soil_step_1 checkpoint 1 ####'
     write(*,*) 'mask    ', .true.
     write(*,*) 'T       ', soil_T
     write(*,*) 'uptake_T', soil_uptake_T
     write(*,*) 'beta    ', soil_beta
     write(*,*) 'E_max   ', soil_E_max
     write(*,*) 'rh      ', soil_rh
     write(*,*) 'liq     ', soil_liq
     write(*,*) 'ice     ', soil_ice
     write(*,*) 'subl    ', soil_subl
     write(*,*) 'G0      ', soil_G0
     write(*,*) 'DGDT    ', soil_DGDT
     __DEBUG1__(soil_water_supply)
  endif

  call send_tile_data(id_thermal_cond, thermal_cond, diag)

end subroutine soil_step_1


! ============================================================================
! apply boundary flows to soil water and move soil water vertically.
  subroutine soil_step_2 ( soil, vegn, diag, soil_subl, snow_lprec, snow_hlprec,  &
                           vegn_uptk, &
                           subs_DT, subs_M_imp, subs_evap, &
                           use_tfreeze_in_grnd_latent, &
                           soil_levap, soil_fevap, soil_melt, &
                           soil_lrunf, soil_hlrunf, soil_Ttop, soil_Ctop )
  type(soil_tile_type), intent(inout) :: soil
  type(vegn_tile_type), intent(in)    :: vegn
  type(diag_buff_type), intent(inout) :: diag
  real, intent(in) :: &
     soil_subl     !
  real, intent(in) :: &
     snow_lprec, &
     snow_hlprec, &
     vegn_uptk, &
     subs_DT,       &!
     subs_M_imp,       &! rate of phase change of non-evaporated soil water
     subs_evap
  logical, intent(in) :: use_tfreeze_in_grnd_latent
  real, intent(out) :: &
     soil_levap, soil_fevap, soil_melt, &
     soil_lrunf, soil_hlrunf, soil_Ttop, soil_Ctop

  ! ---- local vars ----------------------------------------------------------
  real, dimension(num_l)   :: del_t, psi, DThDP, hyd_cond, DKDP, &
                                 vlc, vsc, dW_l, DPsi
  real, dimension(num_l+1) :: flow, infilt
  real, dimension(num_l  ) :: div, div_bf, div_if, div_al, dq, div_active
    real      :: &
     lprec_eff, hlprec_eff, tflow, hcap,cap_flow, dheat, &
     melt_per_deg, melt, &
     lrunf_sn,lrunf_ie,lrunf_bf,lrunf_if,lrunf_al,lrunf_nu,lrunf_sc, d_GW, &
     hlrunf_sn,hlrunf_ie,hlrunf_bf,hlrunf_if,hlrunf_al,hlrunf_nu,hlrunf_sc, &
     c0, c1, c2, Dpsi_min, Dpsi_max, &
     sat_area_frac, sat_thick, sum_trans, &
     gw_flux, depth_to_wt, depth_to_wt2_3, depth_to_wt_apparent, &
     depth_to_gw_flow_3, deficit, z_bot, &
     active_layer_thickness, depth_to_cf, d_psi, d_psi_s, psi_star, &
     depth_to_cf_1, depth_to_cf_3, &
     depth_to_wt_1, depth_to_wt_2, depth_to_wt_2a, depth_to_wt_3, &
     storage_2, deficit_2, deficit_3
  logical :: stiff
  real :: zimh, ziph, dTr_g(num_l), dTr_s(num_l)
  integer :: n_iter, l, l_max_active_layer
  real :: &
       VRL(num_l), & ! volumetric root length, m/m3
       K_r, & ! root membrame permeability, kg/(m3 s)
       r_r, & ! root radius, m
       uptake(num_l),   & ! uptake by roots per layer, kg/(m2 s)
       uptake_tot,      & ! total uptake, kg/(m2 s)
       uptake_pos,      & ! sum of the positive uptake, kg/(m2 s) 
       uptake_T_new, & ! updated average temperature of uptaken water, deg K
       uptake_T_corr,& ! correction for uptake temperature, deg K
       Tu,           & ! temperature of water taken up from (or added to) a layer, deg K
       psi_x0          ! water potential inside roots (in xylem) at zero depth, m

  ! --------------------------------------------------------------------------

  
  !.........................................................................
  if(is_watch_point()) then
     write(*,*) ' ##### soil_step_2 checkpoint 1 #####'
     write(*,*) 'mask    ', .true.
     write(*,*) 'subs_evap    ', subs_evap
     write(*,*) 'snow_lprec   ', snow_lprec
     write(*,*) 'uptake  ', vegn_uptk
     write(*,*) 'subs_M_imp   ', subs_M_imp
     write(*,*) 'theta_s ', soil%pars%vwc_sat
     do l = 1, num_l
        write(*,'(a,i2.2,100(2x,a,g23.16))') 'level=', l,&
             ' T =', soil%prog(l)%T,&
             ' Th=', (soil%prog(l)%ws+soil%prog(l)%wl)/(dens_h2o*dz(l)),&
             ' wl=', soil%prog(l)%wl,&
             ' ws=', soil%prog(l)%ws,&
             ' gw=', soil%prog(l)%groundwater
     enddo
    endif
  !.........................................................................

  ! ---- record fluxes -----------------------------------------------------
  soil_levap  = subs_evap*(1-soil_subl)
  soil_fevap  = subs_evap*   soil_subl
  soil_melt   = subs_M_imp / delta_time

  ! ---- load surface temp change and perform back substitution ------------
  del_t(1) = subs_DT
  soil%prog(1)%T = soil%prog(1)%T + del_t(1)
  if ( num_l > 1) then
    do l = 1, num_l-1
      del_t(l+1) = soil%e(l) * del_t(l) + soil%f(l)
      soil%prog(l+1)%T = soil%prog(l+1)%T + del_t(l+1)
      enddo
    endif

  !.........................................................................
  if(is_watch_point()) then
     write(*,*) ' ##### soil_step_2 checkpoint 2 #####'
     do l = 1, num_l
        write(*,'(a,i2.2,100(2x,a,g23.16))') 'level=',l, 'T=', soil%prog(l)%T, &
             'del_t=', del_t(l), 'e=', soil%e(l), 'f=', soil%f(l)
       enddo
    endif
  !.........................................................................

  ! ---- extract evap from soil, adjusting T, and do implicit melt ---------
  IF (LM2) THEN  ! (extract surface E--is there any?--uniformly from bucket)
      do l = 1, num_l
        soil%prog(l)%wl = soil%prog(l)%wl &
                      - soil%uptake_frac(l)*soil_levap*delta_time
        enddo
    ELSE
      soil%prog(1)%wl = soil%prog(1)%wl - soil_levap*delta_time
      soil%prog(1)%ws = soil%prog(1)%ws - soil_fevap*delta_time
    ENDIF
  hcap = soil%heat_capacity_dry(1)*dz(1) &
                       + clw*soil%prog(1)%wl + csw*soil%prog(1)%ws
  ! T adjustment for nonlinear terms (del_T)*(del_W)
  dheat = delta_time*(clw*soil_levap+csw*soil_fevap)*del_T(1)
  ! take out extra heat not claimed in advance for evaporation
  if (use_tfreeze_in_grnd_latent) dheat = dheat &
          - delta_time*((cpw-clw)*soil_levap+(cpw-csw)*soil_fevap) &
                                 *(soil%prog(1)%T-del_T(1)-tfreeze)
  soil%prog(1)%T  = soil%prog(1)%T  + dheat/hcap
  soil%prog(1)%wl = soil%prog(1)%wl + subs_M_imp
  soil%prog(1)%ws = soil%prog(1)%ws - subs_M_imp
  soil%prog(1)%T  = tfreeze + (hcap*(soil%prog(1)%T-tfreeze) ) &
                              / ( hcap + (clw-csw)*subs_M_imp )

  ! ---- calculate actual uptake and update its T --------------------------
  select case(uptake_option)
  case ( UPTAKE_LINEAR )
     uptake_T_corr = 0
     n_iter = 0
     uptake = soil%uptake_frac*vegn_uptk
     soil%psi_x0 = 0.
  case ( UPTAKE_DARCY2D, UPTAKE_DARCY2D_LIN )     
     ! for Darcy-flow uptake, find the root water potential to satify actual
     ! transpiration by the vegetation
     call vegn_root_properties (vegn, dz(1:num_l), VRL, K_r, r_r)
     
     if ( uptake_option==UPTAKE_DARCY2D ) then
        call darcy2d_uptake_solver ( soil, vegn_uptk, VRL, K_r, r_r, &
             uptake_oneway, uptake_from_sat, uptake, psi_x0, n_iter)
     else
        call darcy2d_uptake_solver_lin ( soil, vegn_uptk, VRL, K_r, r_r, &
             uptake_oneway, uptake_from_sat, uptake, psi_x0, n_iter )
     endif
     soil%psi_x0 = psi_x0

     uptake_pos = sum(uptake(:),mask=uptake(:)>0)
     if (uptake_pos > 0) then
        ! calculate actual temperature of uptake
        uptake_T_new  = sum(uptake*soil%prog%T,mask=uptake>0)/uptake_pos
        ! and temperature correction
        uptake_T_corr = soil%uptake_T - uptake_T_new
        if(is_watch_point()) then
           __DEBUG3__(soil%uptake_T, uptake_T_new, uptake_T_corr)
        endif
        ! save new uptake for the next time step to serve as an estimate of uptake 
        ! temperature
        soil%uptake_T    = uptake_T_new
     else
        uptake_T_corr = 0.0
        ! and don't change the soil%uptake_T
     endif
  case default
     call error_mesg('soil_step_2', 'invalid soil uptake option', FATAL)
  end select

  !.........................................................................
  if (is_watch_point())then
      write(*,*) ' ##### soil_step_2 checkpoint 2.1 #####'
      __DEBUG2__(vegn_uptk,sum(uptake))
      do l = 1,num_l
        write(*,'(a,i2.2,100(2x,a,g23.16))')'level=',l, &
             'uptake=',uptake(l),'dwl=',-uptake(l)*delta_time,&
             'wl=',soil%prog(l)%wl,'new wl=',soil%prog(l)%wl - uptake(l)*delta_time
        enddo
    endif
  !.........................................................................

  call send_tile_data(id_uptk_n_iter, real(n_iter), diag)
  call send_tile_data(id_uptk, uptake, diag)
  call send_tile_data(id_psi_x0, psi_x0, diag)

  ! ---- perform the uptake ------------------------------------------------
  do l = 1, num_l
    ! calculate the temperature of water that is taken from the layer (or added 
    ! to the layer), including energy balance correction 
    if (uptake(l) > 0) then
        Tu = soil%prog(l)%T + uptake_T_corr
      else
        Tu = soil%uptake_T + uptake_T_corr
      endif
    hcap = soil%heat_capacity_dry(l)*dz(l) &
          + clw*soil%prog(l)%wl + csw*soil%prog(l)%ws
    soil%prog(l)%T = soil%prog(l)%T - &
          uptake(l)*delta_time*clw*( Tu-soil%prog(l)%T ) / &
          ( hcap - uptake(l)*delta_time*clw )
    soil%prog(l)%wl = soil%prog(l)%wl - uptake(l)*delta_time
    enddo

  !.........................................................................
  if(is_watch_point()) then
      write(*,*) ' ##### soil_step_2 checkpoint 3 #####'
      do l = 1, num_l
        write(*,'(a,i2.2,100(2x,a,g23.16))') ' level=', l,&
             ' T =', soil%prog(l)%T,&
             ' Th=', (soil%prog(l)%ws+soil%prog(l)%wl)/(dens_h2o*dz(l)),&
             ' wl=', soil%prog(l)%wl,&
             ' ws=', soil%prog(l)%ws
        enddo
    endif
  !.........................................................................

  ! ---- push down any excess surface water, with heat ---------------------
  IF (PUSH_DOWN_SFC_EXCESS) THEN
      CALL SOIL_PUSH_DOWN_EXCESS ( soil, diag, lrunf_nu, hlrunf_nu )
    ELSE
      lrunf_nu=0; hlrunf_nu=0
    ENDIF

  ! ---- fetch soil hydraulic properties -----------------------------------
  do l = 1, num_l
    vlc(l) = max(0., soil%prog(l)%wl / (dens_h2o*dz(l)))
    vsc(l) = max(0., soil%prog(l)%ws / (dens_h2o*dz(l)))
  enddo
  call soil_data_hydraulic_properties (soil, vlc, vsc, &
                   psi, DThDP, hyd_cond, DKDP, Dpsi_min, Dpsi_max )

  ! ---- compute various measures of water table depth ---------------------
    sat_thick = 0.
    do l=num_l,1,-1
       if(vsc(l)+vlc(l).le.soil%pars%vwc_sat) exit
       sat_thick = sat_thick + dz(l)
    enddo
    depth_to_cf_1 = zhalf(num_l+1) - sat_thick
    depth_to_wt_1 = depth_to_cf_1 - soil%pars%psi_sat_ref/soil%alpha(max(l,1))

    depth_to_wt_2 = zfull(num_l)-psi(num_l)

    depth_to_wt_2a = 0.
    do l=1,num_l
      if (soil%prog(l)%wl+soil%prog(l)%ws .lt. &
                       soil%pars%vwc_sat*dens_h2o*dz(l)) then
          depth_to_wt_2a = depth_to_wt_2a + dz(l)
          if (l.eq.num_l) depth_to_wt_2a = -1.
      else
          exit
      endif
    enddo
    storage_2 = 1 - depth_to_wt_2  &
             /(soil%pars%hillslope_zeta_bar*soil%pars%hillslope_relief)
    storage_2 = min( max( 0., storage_2 ) , 1.)
    deficit_2 = 1 - storage_2

        if (vsc(num_l).gt.0.) then   ! permafrost
	    depth_to_wt2_3 = 0.
	    depth_to_cf_3 = 0.
            depth_to_wt_3 = 0.
	  else                       ! liquid water at depth
	    depth_to_cf_3 = 0.
            if (use_fringe) then
	        do l = num_l, 1, -1
		  if ( l.eq.num_l .and. psi(l).le.soil%pars%psi_sat_ref/soil%alpha(l) ) then
		      depth_to_cf_3 = zfull(l) + soil%pars%psi_sat_ref/soil%alpha(l) - psi(l)
		      exit
		    else if (psi(l).le.soil%pars%psi_sat_ref/soil%alpha(l) ) then
		      d_psi = psi(l+1) - psi(l)
		      d_psi_s = (soil%pars%psi_sat_ref/soil%alpha(l+1)) &
		               -(soil%pars%psi_sat_ref/soil%alpha(l))
	              psi_star = (psi(l)*d_psi_s - &
		                  d_psi*(soil%pars%psi_sat_ref/soil%alpha(l)))&
				  / (d_psi_s - d_psi)
		      depth_to_cf_3 = zfull(l) + (zfull(l+1)-zfull(l)) &
		                            * (psi_star-psi(l)) / d_psi
		      exit
		    else if (l.eq.1) then
		      d_psi = psi(l+1) - psi(l)
		      d_psi_s = (soil%pars%psi_sat_ref/soil%alpha(l+1)) &
		               -(soil%pars%psi_sat_ref/soil%alpha(l))
	              psi_star = (psi(l)*d_psi_s - &
		                  d_psi*(soil%pars%psi_sat_ref/soil%alpha(l)))&
				  / (d_psi_s - d_psi)
		      depth_to_cf_3 = zfull(l) + (zfull(l+1)-zfull(l)) &
		                            * (psi_star-psi(l)) / d_psi
		      depth_to_cf_3 = max(0.,depth_to_cf_3)
		    endif
		  enddo
	      endif
            depth_to_wt_3 = max(0., zhalf(num_l+1)-(psi(num_l)+dz(num_l)/2.))
	    depth_to_wt2_3 = depth_to_wt_3
	  endif

	    if (use_fringe) then
	        depth_to_gw_flow_3 = depth_to_cf_3
              else
	        depth_to_gw_flow_3 = depth_to_wt_3
	      endif
        deficit_3 = depth_to_gw_flow_3  &
             /(soil%pars%hillslope_zeta_bar*soil%pars%hillslope_relief)

  ! ---- get saturated area and column flow divergences --------------------
    SELECT CASE(gw_option)
    
    CASE(GW_LM2)

        div_bf=0; div_if=0; div_al=0; sat_area_frac = 0

    CASE(GW_LINEAR)

        IF (CORRECTED_LM2_GW) THEN
            do l = 1, num_l
              if (vlc(l) .ge. soil%pars%vwc_sat .and. vsc(l).le.0.) &
                  div_bf(l) = 0.15*dens_h2o*dz(l)/soil%pars%tau_groundwater
              enddo
          ELSE
            do l = 1, num_l
              if ((vsc(l)+vlc(l)) .ge. soil%pars%vwc_sat) &
                  div_bf(l) = 0.15*dens_h2o*dz(l)*(vlc(l)/(vsc(l)+vlc(l)))  &
		                      /soil%pars%tau_groundwater
              enddo
          ENDIF
        div_if = 0
	div_al = 0
	sat_thick = zhalf(num_l+1) - depth_to_cf_1
        sat_area_frac = min((sat_thick/zhalf(num_l+1))**soil%pars%rsa_exp,1.)

    CASE(GW_HILL_AR5)

	call soil_data_gw_hydraulics_ar5(soil, storage_2, &
                                                 gw_flux, sat_area_frac)
        dq = 0.
        sat_thick = 0.
        do l=num_l,1,-1
          if(psi(l).le.0.) exit
          if (vsc(l).le.0.) dq(l) = dz(l)
          sat_thick = sat_thick + dz(l)
          enddo
        div_bf = 0.
        if (sat_thick.gt.0.) div_bf = (dq/sat_thick)*gw_flux

        div_active = 0.
        l_max_active_layer = 0
        do l=1,num_l
          if(vsc(l).gt.0.) exit
          l_max_active_layer = l
          enddo
        if (l_max_active_layer.lt.num_l .and. l_max_active_layer.gt.0) then
            do l = 1, l_max_active_layer
              if(vlc(l).gt.0) &
               div_active(l) = hyd_cond(l) * soil%pars%hillslope_relief*dz(l) &
                / (soil%pars%hillslope_length*soil%pars%hillslope_length)
               enddo
          endif

        div_al = 0
        where (div_bf.eq.0.) div_al = div_active*active_layer_drainage_acceleration
        div_if = 0

    CASE(GW_HILL)
      
        if (vsc(num_l).gt.0.) then   ! permafrost
	    sat_area_frac = 0.
            div_bf = 0.
            div_if = 0.
	  else                       ! liquid water at depth
            call soil_data_gw_hydraulics(soil, deficit_3, &
                                               gw_flux, sat_area_frac)
            gw_flux = min(gw_flux, gw_flux_max)
             dTr_g = 0.
             dTr_s = 0.
             dTr_g(num_l) = 1.
             l = num_l
             ziph = sum(dz)
             zimh = ziph - dz(num_l)
             if (depth_to_gw_flow_3 .lt. zimh) then
                 dTR_g(l) = dz(l)
                 dTr_s(l) = (exp(-zimh/soil%pars%soil_e_depth))
                 do l = num_l-1, 1, -1
                   if (vsc(l).gt.0.) exit
                       ziph = zimh
                       zimh = ziph - dz(l)
                       if (depth_to_gw_flow_3 .lt. zimh) then
                           dTR_g(l) = dz(l)
                           dTr_s(l) = exp(-zimh/soil%pars%soil_e_depth)-exp(-ziph/soil%pars%soil_e_depth)
                         else if (depth_to_gw_flow_3 .lt. ziph) then
                           dTR_g(l) =(ziph-depth_to_gw_flow_3)
                           dTr_s(l) = exp(-depth_to_gw_flow_3/soil%pars%soil_e_depth)-exp(-ziph/soil%pars%soil_e_depth)
                         else
                           exit
                         endif
                   enddo
               endif
             sum_trans = sum(dTr_g)
             if (sum_trans.ne.0.) then
                 dTR_g = dTR_g / sum_trans
                 dTR_g = dTR_g * soil%pars%k_sat_gw*aspect*soil%pars%hillslope_length
               endif
             dTR_s = dTR_s * (soil%pars%k_sat_sfc+k_macro_constant)*soil%pars%soil_e_depth
             sum_trans = sum(dTR_g) + sum(dTr_s)
             if (sum_trans.ne.0.) then
                 div_bf = gw_flux * dTR_g /sum_trans
                 div_if = gw_flux * dTR_s /sum_trans
               else
                 div_bf = 0.
                 div_if = 0.
               endif
	  endif

	div_al = 0
        l_max_active_layer = 0   ! "active layer" either over permafrost or perched
        do l=1,num_l
          if(vsc(l).gt.0.) exit
          l_max_active_layer = l
          enddo
        if (l_max_active_layer.lt.num_l .and. l_max_active_layer.gt.0) then
            do l = 1, l_max_active_layer
              div_al(l) = hyd_cond(l) * soil%pars%hillslope_relief*dz(l) &
                   / (soil%pars%hillslope_length*soil%pars%hillslope_length)
              enddo
          endif

    END SELECT

    div = div_bf + div_if + div_al
    lrunf_bf = sum(div_bf)
    lrunf_if = sum(div_if)
    lrunf_al = sum(div_al)

    if (snow_lprec.ne.0.) then
      lrunf_sn = sat_area_frac * snow_lprec
      hlrunf_sn = lrunf_sn*snow_hlprec/snow_lprec
    else
      lrunf_sn = 0.
      hlrunf_sn = 0.
    endif
    hlrunf_ie=0
    lprec_eff = snow_lprec - lrunf_sn
    hlprec_eff = snow_hlprec - hlrunf_sn

    if(is_watch_point()) then
       do l = 1, num_l
          write(*,'(a,1x,i2.2,100(2x,g23.16))')'div_ac,div_bf,div_if,div_al,div', &
	                 l,div_active(l),div_bf(l),div_if(l),div_al(l),div(l)
       enddo
       do l = 1, num_l
          write(*,'(a,1x,i2.2,100(2x,g23.16))')'vsc,psi,dz',l,vsc(l),psi(l),dz(l)
       enddo
       write(*,*)'lrunf_bf',lrunf_bf
       write(*,*)'tau_gw',soil%pars%tau_groundwater
       write(*,*)'dens_h2o',dens_h2o
    endif

  ! ---- soil-water flow ----------------------------------------------------
  IF (LM2) THEN
      flow(1) = 0
      do l = 1, num_l
        infilt(l) = soil%uptake_frac(l)*lprec_eff *delta_time
        flow(l+1) = max(0., soil%prog(l)%wl + flow(l) &
              + infilt(l) - soil%w_fc(l)*dz(l)*dens_h2o)
        dW_l(l) = flow(l) - flow(l+1) + infilt(l)
        soil%prog(l)%wl = soil%prog(l)%wl + dW_l(l)
        enddo
      do l = 1, num_l
        flow(l) = flow(l) + infilt(l)
        enddo
      dW_l=0
      dpsi=0
      c0 = delta_time/soil%pars%tau_groundwater
      c1 = exp(-c0)
      c2 = (1-c1)/c0
      l = 1
      d_GW = c1 * soil%prog(l)%groundwater + c2 * flow(num_l+1) &
	                    - soil%prog(l)%groundwater
      soil%prog(l)%groundwater = soil%prog(l)%groundwater + d_GW
      lrunf_sc  = (1-c1)*soil%prog(l)%groundwater/delta_time &
                          + (1-c2)*flow(num_l+1)/delta_time
      lrunf_ie=0
    ELSE
      lrunf_sc = 0
      d_GW = 0
      stiff = all(DThDP.eq.0)
      IF(stiff .AND. BYPASS_RICHARDS_WHEN_STIFF) THEN
          flow = 0.
          dW_l = 0.
          div  = 0; div_bf=0; div_if=0; div_al=0
          lrunf_bf = 0; lrunf_if = 0; lrunf_al = 0
          lrunf_ie = lprec_eff
          hlrunf_ie = hlprec_eff
          if (use_stiff_bug) then
              psi=-zfull
            else
              psi=zfull
            endif
          dpsi=0.
        ELSE
          CALL RICHARDS(soil, psi, DThDP, hyd_cond, DKDP, div, &
                lprec_eff, Dpsi_min, Dpsi_max, stiff, &
                 dPsi, dW_l, flow, lrunf_ie)
        ENDIF
    ENDIF

  ! ---- heat advection by water flow ---------------------------------------
  if  (snow_lprec.ne.0.) then
    tflow = tfreeze + snow_hlprec/(clw*snow_lprec)
  else
    tflow = tfreeze
  endif

  if(is_watch_point()) then
     write(*,*) ' ***** soil_step_2 checkpoint 3.4 ***** '
     write(*,*) ' tfreeze', tfreeze
     write(*,*) '  tflow ', tflow
     write(*,*) ' snow_hlprec', snow_hlprec
  endif

  call advection(soil, flow, dW_l, tflow, d_GW, snow_lprec, snow_hlprec)

  if (lprec_eff.ne.0. .and. flow(1).ge.0. ) then
      hlrunf_ie = lrunf_ie*hlprec_eff/lprec_eff
    else if (flow(1).lt.0. ) then
      hlrunf_ie = hlprec_eff - (flow(1)/delta_time)*clw &
                         *(soil%prog(1)%T-tfreeze)
    else
      hlrunf_ie = 0.
    endif

  hlrunf_bf = clw*sum(div_bf*(soil%prog%T-tfreeze))
  hlrunf_if = clw*sum(div_if*(soil%prog%T-tfreeze))
  hlrunf_al = clw*sum(div_al*(soil%prog%T-tfreeze))
  hlrunf_sc = clw*lrunf_sc  *(soil%prog(1)%groundwater_T-tfreeze)
  if (lrunf_from_div) then
      soil_lrunf  =  lrunf_sn +  lrunf_ie +  sum(div) +  lrunf_nu +  lrunf_sc
      soil_hlrunf = hlrunf_sn + hlrunf_ie +  clw*sum(div*(soil%prog%T-tfreeze)) &
                                                      + hlrunf_nu + hlrunf_sc
    else
      soil_lrunf  =  lrunf_sn +  lrunf_ie +  lrunf_bf +  lrunf_if &
                              +  lrunf_al +  lrunf_nu +  lrunf_sc
      soil_hlrunf = hlrunf_sn + hlrunf_ie + hlrunf_bf + hlrunf_if &
                              + hlrunf_al + hlrunf_nu + hlrunf_sc
    endif

  do l = 1, num_l
    ! ---- compute explicit melt/freeze --------------------------------------
    hcap = soil%heat_capacity_dry(l)*dz(l) &
             + clw*soil%prog(l)%wl + csw*soil%prog(l)%ws
    melt_per_deg = hcap/(hlf_factor*hlf)
    if       (soil%prog(l)%ws>0 .and. soil%prog(l)%T>soil%pars%tfreeze) then
      melt =  min(soil%prog(l)%ws, (soil%prog(l)%T-soil%pars%tfreeze)*melt_per_deg)
    else if (soil%prog(l)%wl>0 .and. soil%prog(l)%T<soil%pars%tfreeze) then
      melt = -min(soil%prog(l)%wl, (soil%pars%tfreeze-soil%prog(l)%T)*melt_per_deg)
    else
      melt = 0
    endif
    soil%prog(l)%wl = soil%prog(l)%wl + melt
    soil%prog(l)%ws = soil%prog(l)%ws - melt
    soil%prog(l)%T = tfreeze &
       + (hcap*(soil%prog(l)%T-tfreeze) - hlf_factor*hlf*melt) &
                            / ( hcap + (clw-csw)*melt )
    soil_melt = soil_melt + melt / delta_time
  enddo

  if(is_watch_point()) then
     write(*,*) ' ##### soil_step_2 checkpoint 5 #####'
     do l = 1, num_l
        write(*,'(a,i2.2,100(2x,a,g23.16))') ' level=', l,&
             ' T =', soil%prog(l)%T,&
             ' Th=', (soil%prog(l)%ws +soil%prog(l)%wl)/(dens_h2o*dz(l)),&
             ' wl=', soil%prog(l)%wl,&
             ' ws=', soil%prog(l)%ws,&
             ' gw=', soil%prog(l)%groundwater
     enddo
  endif

  active_layer_thickness = 0.
  do l = 1, num_l
    if (soil%prog(l)%ws.gt.0.) then
        active_layer_thickness = active_layer_thickness &
	  + dz(l)*soil%prog(l)%wl/(soil%prog(l)%wl+soil%prog(l)%ws)
        exit
      endif
    active_layer_thickness = active_layer_thickness + dz(l)
    enddo

  soil_Ttop = soil%prog(1)%T
  soil_Ctop = soil%heat_capacity_dry(1)*dz(1) &
    + clw*soil%prog(1)%wl + csw*soil%prog(1)%ws

if (update_psi) soil%psi=psi+dPsi

! ----------------------------------------------------------------------------
! given solution for surface energy balance, write diagnostic output.
!  

  ! ---- increment time and do diagnostics -----------------------------------
  time = increment_time(time, int(delta_time), 0)
  
  ! ---- diagnostic section
   call send_tile_data(id_temp, soil%prog%T, diag)
   if (id_lwc > 0) call send_tile_data(id_lwc,  soil%prog%wl/dz(1:num_l), diag)
   if (id_swc > 0) call send_tile_data(id_swc,  soil%prog%ws/dz(1:num_l), diag)
   if (id_psi > 0) call send_tile_data(id_psi,  psi+dPsi, diag)
!    call send_tile_data(id_deficit, deficit, diag)
!    call send_tile_data(id_sat_depth, depth_to_wt_3, diag)
!    call send_tile_data(id_sat_dept2, depth_to_wt2_3, diag)
!    call send_tile_data(id_z_cap, depth_to_cf_3, diag)
!    if (depth_to_wt_2a .ge. -0.5) &
!	                call send_tile_data(id_sat_depth, depth_to_wt_2a, diag)
    call send_tile_data(id_cf_1, depth_to_cf_1, diag)
    call send_tile_data(id_cf_3, depth_to_cf_3, diag)
    call send_tile_data(id_wt_1, depth_to_wt_1, diag)
    call send_tile_data(id_wt_2, depth_to_wt_2, diag)
    call send_tile_data(id_wt_2a, depth_to_wt_2a, diag)
    call send_tile_data(id_wt_3, depth_to_wt_3, diag)
    call send_tile_data(id_wt2_3, depth_to_wt2_3, diag)
    call send_tile_data(id_deficit_2, deficit_2, diag)
    call send_tile_data(id_deficit_3, deficit_3, diag)
    call send_tile_data(id_sat_frac, sat_area_frac, diag)
    call send_tile_data(id_div_bf, div_bf, diag)
    call send_tile_data(id_div_if, div_if, diag)
    call send_tile_data(id_div_al, div_al, diag)

   call send_tile_data(id_ie,   lrunf_ie, diag)
   call send_tile_data(id_sn,   lrunf_sn, diag)
   call send_tile_data(id_bf,   lrunf_bf, diag)
   call send_tile_data(id_if,   lrunf_if, diag)
   call send_tile_data(id_al,   lrunf_al, diag)
   call send_tile_data(id_nu,   lrunf_nu, diag)
   call send_tile_data(id_sc,   lrunf_sc, diag)
   call send_tile_data(id_hie,  hlrunf_ie, diag)
   call send_tile_data(id_hsn,  hlrunf_sn, diag)
   call send_tile_data(id_hbf,  hlrunf_bf, diag)
   call send_tile_data(id_hif,  hlrunf_if, diag)
   call send_tile_data(id_hal,  hlrunf_al, diag)
   call send_tile_data(id_hnu,  hlrunf_nu, diag)
   call send_tile_data(id_hsc,  hlrunf_sc, diag)
   if (id_evap > 0) call send_tile_data(id_evap,  soil_levap+soil_fevap, diag)

   call send_tile_data(id_heat_cap, soil%heat_capacity_dry, diag)
   call send_tile_data(id_active_layer, active_layer_thickness, diag)

end subroutine soil_step_2

! ============================================================================

subroutine soil_step_3(soil, diag)
  type(soil_tile_type), intent(in) :: soil
  type(diag_buff_type), intent(inout) :: diag

  if(id_fast_soil_C>0) call send_tile_data(id_fast_soil_C, soil%fast_soil_C(:)/dz(:), diag)
  if(id_slow_soil_C>0) call send_tile_data(id_slow_soil_C, soil%slow_soil_C(:)/dz(:), diag)
  if (id_fsc > 0)      call send_tile_data(id_fsc, sum(soil%fast_soil_C(:)), diag)
  if (id_ssc > 0)      call send_tile_data(id_ssc, sum(soil%slow_soil_C(:)), diag)
end subroutine soil_step_3

! ============================================================================
  
  subroutine soil_push_down_excess ( soil, diag, lrunf_nu, hlrunf_nu )
  type(soil_tile_type), intent(inout) :: soil
  type(diag_buff_type), intent(inout) :: diag
  real, intent(out) :: lrunf_nu, hlrunf_nu

  ! ---- local vars ----------------------------------------------------------
  real      :: &
     liq_frac, excess_wat, excess_liq, excess_ice, excess_t, &
     h1, h2, summax, space_avail, liq_placed, ice_placed
  integer :: l

  liq_frac=0;excess_wat=0;excess_liq=0;excess_ice=0;h1=0;h2=0
  l = 1
  summax = max(0.,soil%prog(l)%wl)+max(0.,soil%prog(l)%ws)
  if (summax > 0) then
     liq_frac = max(0.,soil%prog(l)%wl) / summax
  else
     liq_frac = 1
  endif
  excess_wat = max(0., soil%prog(l)%wl + soil%prog(l)%ws &
       - dens_h2o*dz(l)*soil%pars%vwc_sat )
  excess_liq = excess_wat*liq_frac
  excess_ice = excess_wat-excess_liq
  excess_t   = soil%prog(l)%T
  soil%prog(l)%wl = soil%prog(l)%wl - excess_liq
  soil%prog(l)%ws = soil%prog(l)%ws - excess_ice
  call send_tile_data(id_excess, excess_wat/delta_time, diag)

  if(is_watch_point()) then
      write(*,*) ' ##### soil_step_2 checkpoint 3.001 #####'
      write(*,*) ' level=', l,&
          ' summax =', summax,&
          ' liq_frac =', liq_frac,&
          ' soil%pars%vwc_sat =', soil%pars%vwc_sat,&
          ' excess_liq =', excess_liq,&
          ' excess_ice =', excess_ice, &
          ' dens_h2o=', dens_h2o, &
          ' dz(l)=',dz(l)
    endif

  do l = 2, num_l
     if (excess_liq+excess_ice>0) then
        space_avail = dens_h2o*dz(l)*soil%pars%vwc_sat &
             - (soil%prog(l)%wl + soil%prog(l)%ws)
        liq_placed = max(min(space_avail, excess_liq), 0.)
        ice_placed = max(min(space_avail-liq_placed, excess_ice), 0.)
        h1 = (soil%heat_capacity_dry(l)*dz(l) &
             + csw*soil%prog(l)%ws + clw*soil%prog(l)%wl)
        h2 = liq_placed*clw+ice_placed*csw
        soil%prog(l)%T = (h1 * soil%prog(l)%T &
             + h2 * excess_T )  / (h1+h2)
        soil%prog(l)%wl = soil%prog(l)%wl + liq_placed
        soil%prog(l)%ws = soil%prog(l)%ws + ice_placed
        excess_liq = excess_liq - liq_placed
        excess_ice = excess_ice - ice_placed
     endif
  enddo

! to avoid adding frozen runoff to soil interface, melt all remaining
! excess ice, even if it results in supercooled liquid runoff
   lrunf_nu = (excess_liq+excess_ice) / delta_time
  hlrunf_nu = (  excess_liq*clw*(excess_T-tfreeze)  &
               + excess_ice*csw*(excess_T-tfreeze)  &
               - hlf_factor*hlf*excess_ice                   ) / delta_time

  if(is_watch_point()) then
     write(*,*) ' ##### soil_step_2 checkpoint 3.01 #####'
     write(*,*) ' lrunf_nu',lrunf_nu
     write(*,*) 'hlrunf_nu',hlrunf_nu
     do l = 1, num_l
        write(*,'(x,a,x,i2.2,100(x,a,g23.16))') ' level=', l,&
             ' T =', soil%prog(l)%T,&
             ' Th=', (soil%prog(l)%ws +soil%prog(l)%wl)/(dens_h2o*dz(l)),&
             ' wl=', soil%prog(l)%wl,&
             ' ws=', soil%prog(l)%ws
     enddo
  endif
end subroutine soil_push_down_excess

! ============================================================================

  subroutine RICHARDS(soil, psi, DThDP, hyd_cond, DKDP, div, &
                lprec_eff, Dpsi_min, Dpsi_max, stiff, &
                 dPsi, dW_l, flow, lrunf_ie)
  type(soil_tile_type), intent(inout)   :: soil
  real, intent(in),  dimension(num_l)   :: psi, DThDP, hyd_cond, DKDP, div
  real, intent(in)                      :: lprec_eff, Dpsi_min, Dpsi_max
  logical, intent(in)                   :: stiff
  real, intent(out), dimension(num_l)   :: dPsi, dW_l
  real, intent(out), dimension(num_l+1) :: flow
  real, intent(out)                     :: lrunf_ie
  ! ---- local vars ----------------------------------------------------------
  integer l, ipt, jpt, kpt, fpt, l_internal
  real, dimension(num_l-1) :: del_z, K, DKDPm, DKDPp, grad, eee, fff
  real aaa, bbb, ccc, ddd, xxx, dpsi_alt, dW_l_internal, w_to_move_up, adj
  logical flag

    flag = .false.
    flow(1) = delta_time*lprec_eff
    do l = 1, num_l-1
      del_z(l) = zfull(l+1)-zfull(l)
      K(l) = 0.5*(hyd_cond(l)+hyd_cond(l+1))
      DKDPm(l) = 0. !0.5*DKDP(l)
      DKDPp(l) = 0. ! 0.5*DKDP(l+1)
!        K(l) = hyd_cond(l)
!        DKDPm(l) = DKDP(l)
!        DKDPp(l) = 0
      grad(l)  = (psi(l+1)-psi(l))/del_z(l) - 1
    enddo

    if(is_watch_point()) then
       write(*,*) '##### soil_step_2 checkpoint 3.1 #####'
       do l = 1, num_l
          write(*,'(x,a,x,i2.2,x,a,100(x,g23.16))') 'level=', l, 'DThDP,hyd_cond,psi,DKDP', &
               DThDP(l),&
               hyd_cond(l),&
               psi(l),&
               DKDP(l)
       enddo
       do l = 1, num_l-1
          write(*,'(a,i2.2,1x,a,100(2x,g23.16))') 'interface=', l, 'K,DKDPm,DKDPp,grad,del_z', &
               K(l),&
               DKDPm(l),&
               DKDPp(l),&
               grad(l)
       enddo
    endif


    l = num_l
    xxx = dens_h2o*dz(l)*DThDP(l)/delta_time
    aaa =     - ( K(l-1)/del_z(l-1) - DKDPm(l-1)*grad(l-1))
!      where (stiff)
    bbb = xxx - (-K(l-1)/del_z(l-1) - DKDPp(l-1)*grad(l-1) )
    ddd = - K(l-1) *grad(l-1) - div(l)
!        elsewhere
!          Qout = hyd_cond(l) ! gravity drainage
!          DQoutDP = DKDP(l)  ! gravity drainage
!          Qout = 0.                ! no drainage
!          DQoutDP = 0.             ! no drainage
!          where (psi(l).gt.0.) ! linear baseflow from gw
!              Qout = 0.15*psi(l)/soil%pars%tau_groundwater
!              DQoutDP = 0.15/soil%pars%tau_groundwater
!            elsewhere
!              Qout = 0.
!              DQoutDP = 0.
!            endwhere
!          bbb = xxx - (-K(l-1)/del_z(l-1) - DKDPp(l-1)*grad(l-1)&
!                      -DQoutDP )
!          ddd = -Qout - K(l-1) *grad(l-1)
!        endwhere
    eee(l-1) = -aaa/bbb
    fff(l-1) =  ddd/bbb
  
    if(is_watch_point()) then
       write(*,'(a,i2.2,100(2x,g23.16))') 'l,a,b, ,d', l,aaa, bbb,ddd
    endif

    do l = num_l-1, 2, -1
      xxx = dens_h2o*dz(l)*DThDP(l)/delta_time
      aaa = - ( K(l-1)/del_z(l-1) - DKDPm(l-1)*grad(l-1))
      bbb = xxx-( -K(l-1)/del_z(l-1) - DKDPp(l-1)*grad(l-1)&
                  -K(l  )/del_z(l  ) + DKDPm(l  )*grad(l  ))
      ccc =   - (  K(l  )/del_z(l  ) + DKDPp(l  )*grad(l  ))
      ddd =       K(l)*grad(l) - K(l-1)*grad(l-1) &
                            - div(l)
      eee(l-1) =                    -aaa/(bbb+ccc*eee(l))
      fff(l-1) =  (ddd-ccc*fff(l))/(bbb+ccc*eee(l))
      if(is_watch_point()) then
         write(*,'(a,i2.2,100(2x,g23.16))') 'l,a,b,c,d', l,aaa, bbb,ccc,ddd
      endif
    enddo
  
    l = 1
    xxx = dens_h2o*dz(l)*DThDP(l)/delta_time
    bbb = xxx - ( -K(l  )/del_z(l  ) + DKDPm(l  )*grad(l  ))
    ccc =     - (  K(l  )/del_z(l  ) + DKDPp(l  )*grad(l  ))
    ddd =          flow(1)/delta_time +    K(l)     *grad(l) &
                            - div(l)

IF (bbb+ccc*eee(l) .NE. 0.) THEN
    dPsi(l) = (ddd-ccc*fff(l))/(bbb+ccc*eee(l))
    if(is_watch_point()) then
       write(*,*) 'bbb+ccc*eee(l) .NE. 0.'
       write(*,*) 'bbb', bbb
       write(*,*) 'ccc', ccc
       write(*,*) 'ddd', ddd
       write(*,*) 'eee(l)', eee(l)
       write(*,*) 'fff(l)', fff(l)
       write(*,*) 'dPsi(l)', dPsi(l)
       write(*,*) 'stiff', stiff
       write(*,*) 'dPsi(l)', dPsi(l)
       write(*,*) 'Dpsi_min', Dpsi_min
       write(*,*) 'Dpsi_max', Dpsi_max
       endif
    if (.not.stiff .and. dPsi(l).gt.Dpsi_min .and. dPsi(l).lt.Dpsi_max) then
        lrunf_ie = 0.
      else
      	if (stiff) then
            dPsi(l) = - psi(l)
          else
	    if (dPsi(l).lt.Dpsi_min) then
                flag = .true.
                call get_current_point(ipt,jpt,kpt,fpt)
                write(*,*) 'note 1: at point ',ipt,jpt,kpt,fpt,'computed dPsi(1) too negative'
                write(*,*) 'note 1: at point ',ipt,jpt,kpt,fpt,'dPsi(1)=',dPsi(l)
                write(*,*) 'note 1: at point ',ipt,jpt,kpt,fpt,'dPsi_min =',dPsi_min
              endif
            dPsi(l) = min (dPsi(l), Dpsi_max)
            dPsi(l) = max (dPsi(l), Dpsi_min)
          endif
        flow(l) = (dPsi(l)*(bbb+ccc*eee(l))+ccc*fff(l) &
                      - K(l)*grad(l))*delta_time
        lrunf_ie = lprec_eff - flow(l)/delta_time
        if (.not.allow_negative_rie.and.lrunf_ie.lt.-lrunf_ie_tol) then
            flag = .true.
            call get_current_point(ipt,jpt,kpt,fpt)
            dpsi_alt = (ddd-ccc*fff(l))/(bbb+ccc*eee(l))
            write(*,*) 'note 1: at point ',ipt,jpt,kpt,fpt,'rie= ',lrunf_ie,' reset to 0'
            write(*,*) 'note 1: at point ',ipt,jpt,kpt,fpt,'dPsi=',dPsi(l), ' reset to ',dpsi_alt
            write(*,*) 'note 1: at point ',ipt,jpt,kpt,fpt,'dPsi_min/max=',dPsi_min,dPsi_max
            dPsi(l) = dpsi_alt
            lrunf_ie = 0.
            flow(l) = lprec_eff*delta_time
          endif
      endif
  ELSE
    if(is_watch_point()) then
       write(*,*) 'bbb+ccc*eee(l) .EQ. 0.'
       write(*,*) 'bbb', bbb
       write(*,*) 'ccc', ccc
       write(*,*) 'ddd', ddd
       write(*,*) 'eee(l)', eee(l)
       write(*,*) 'fff(l)', fff(l)
       write(*,*) 'dPsi(l)', dPsi(l)
       write(*,*) 'stiff', stiff
       write(*,*) 'dPsi(l)', dPsi(l)
       write(*,*) 'Dpsi_min', Dpsi_min
       write(*,*) 'Dpsi_max', Dpsi_max
       endif
      	if (stiff) then
            dPsi(l) = - psi(l)
          else
            dPsi(l) = Dpsi_max
          endif
        flow(l) = (dPsi(l)*(bbb+ccc*eee(l))+ccc*fff(l) &
                      - K(l)*grad(l))*delta_time
        lrunf_ie = lprec_eff - flow(l)/delta_time
        if (.not.allow_negative_rie.and.lrunf_ie.lt.-lrunf_ie_tol) then
            flag = .true.
            call get_current_point(ipt,jpt,kpt,fpt)
       ! next change will not change answers in previous runs, since old version would crash
       ! the only time this point was reached was when DThDP was zero everywhere.
       !     dpsi_alt = (ddd-ccc*fff(l))/(bbb+ccc*eee(l))
            dpsi_alt = 0.
            write(*,*) 'note 2: at point ',ipt,jpt,kpt,fpt,'rie=',lrunf_ie,' reset to 0'
            write(*,*) 'note 2: at point ',ipt,jpt,kpt,fpt,'dPsi=',dPsi(l),' reset to',dpsi_alt
            write(*,*) 'note 2: at point ',ipt,jpt,kpt,fpt,'dPsi_min/max=',dPsi_min,dPsi_max
            dPsi(l) = dpsi_alt
            lrunf_ie = 0.
            flow(l) = lprec_eff*delta_time
          endif
  ENDIF
      
    if(is_watch_point().or.(flag.and.write_when_flagged)) then
       write(*,'(a,i2.2,100(2x,g23.16))') 'l,  b,c,d', l, bbb,ccc,ddd
       write(*,*) ' ##### soil_step_2 checkpoint 3.2 #####'
       write(*,*) 'ie:', lrunf_ie
       do l = 1, num_l-1
          write(*,'(a,i2.2,100(2x,g23.16))') 'l,eee(l),fff(l)',l,eee(l),fff(l)
       enddo
       write(*,*) 'DThDP(1)', DThDP(1)
       write(*,*) 'K(1)', K(1)
       write(*,*) 'grad(1)', grad(1)
       write(*,*) 'ddd(1)', ddd
       write(*,*) 'ccc(1)', ccc
       write(*,*) 'bbb(1)', bbb
       write(*,*) 'dPsi(1)', dPsi(1)
       write(*,*) 'Psi(1)', Psi(1)
       write(*,*) 'div(1)', div(1)
    endif

    do l = 2, num_l
      dPsi(l) = eee(l-1)*dPsi(l-1) + fff(l-1)
    enddo
  
    l_internal = 1
    dW_l_internal = -1.e20
    do l = 1, num_l-1
      flow(l+1) = delta_time*( &
           -K(l)*(grad(l)&
           +(DPsi(l+1)-DPsi(l))/ del_z(l)) &
           -grad(l)*(DKDPp(l)*Dpsi(l+1)+ &
                           DKDPm(l)*Dpsi(l) )  )
      dW_l(l) = flow(l) - flow(l+1) - div(l)*delta_time
      if (flag .and. l.gt.1. .and. dW_l(l).gt.dW_l_internal) then
          l_internal = l
          dW_l_internal = dW_l(l)
        endif
      enddo
    flow(num_l+1) = 0.
    dW_l(num_l) = flow(num_l) - flow(num_l+1) &
                            - div(num_l)*delta_time
    if (flag .and. dW_l(num_l).gt.dW_l_internal) then
        l_internal = num_l
        dW_l_internal = dW_l(num_l)
      endif

    if(is_watch_point().or.(flag.and.write_when_flagged)) then
       write(*,*) ' ##### soil_step_2 checkpoint 3.21 #####'
       do l = 1, num_l
          write(*,'(i2.2,100(2x,a,g23.16))') l,&
               ' dW_l=', dW_l(l),&
               ' flow=', flow(l),&
               ' div=', div(l)
       enddo
    endif

    if (flag) then
        w_to_move_up = min(dW_l_internal, -(soil%prog(1)%wl+dW_l(1)))
        w_to_move_up = max(w_to_move_up, 0.)
        write(*,*) 'l_internal=',l_internal
        write(*,*) 'dW_l(l_internal)=',dW_l(l_internal)
        write(*,*) 'soil%prog(1)%wl+dW_l(1)',soil%prog(1)%wl+dW_l(1)
        write(*,*) 'w_to_move_up=',w_to_move_up
        if (l_internal.gt.1) then
            dW_l(1) = dW_l(1) + w_to_move_up
            dW_l(l_internal) = dW_l(l_internal) - w_to_move_up
            do l = 2, l_internal
              flow(l) = flow(l) - w_to_move_up
              enddo
          endif
      endif

    if(is_watch_point().or.(flag.and.write_when_flagged)) then
       write(*,*) ' ##### soil_step_2 checkpoint 3.22 #####'
       do l = 1, num_l
          write(*,'(i2.2,100(2x,a,g23.16))') l,&
               ' dW_l=', dW_l(l),&
               ' flow=', flow(l),&
               ' div=', div(l)
       enddo
    endif

! In rare situations where lrunf_ie is large and negative, clip any liquid supersaturation
! layer by layer and recompute lrunf_ie (this is not good, since it ignores 'comp'):
  IF (lrunf_ie < lrunf_ie_min) THEN
       call get_current_point(ipt,jpt,kpt,fpt)
       write(*,*) 'note: at point ',ipt,jpt,kpt,fpt,' clip triggered by lrunf_ie=',lrunf_ie
       do l = num_l, 1, -1
          adj = max(dW_l(l)+soil%prog(l)%ws+soil%prog(l)%wl &
               - soil%pars%vwc_sat*dz(l)*dens_h2o, 0. )

          if(is_watch_point()) then
             write(*,*) '3.22 l=', l,&
                  ' soil_prog%wl=',soil%prog(l)%wl,  &
                  ' soil_prog%ws=',soil%prog(l)%ws , &
                  ' soil%pars%vwc_sat=', soil%pars%vwc_sat, &
                  ' dz=', dz(l), &
                  ' adj=', adj
          endif

          adj = min(adj, max(0.,soil%prog(l)%wl))

          if(is_watch_point()) then
             write(*,*) '3.23 l=', l, ' adj=', adj
          endif

          dW_l(l) = dW_l(l) - adj
          flow(l) = flow(l+1) + dW_l(l) + div(l)*delta_time
       enddo
       lrunf_ie = lprec_eff - flow(1)/delta_time

  ENDIF
       
       do l = 1, num_l
         soil%prog(l)%wl = soil%prog(l)%wl + dW_l(l)
         enddo

  if(is_watch_point().or.(flag.and.write_when_flagged)) then
     write(*,*) ' ***** soil_step_2 checkpoint 3.3 ***** '
     write(*,*) 'psi_sat',soil%pars%psi_sat_ref
     write(*,*) 'Dpsi_max',Dpsi_max
     do l = 1, num_l
        write(*,'(i2.2,100(2x,a,g23.16))') l, &
             'Th=', (soil%prog(l)%ws +soil%prog(l)%wl)/(dens_h2o*dz(l)), &
             'wl=', soil%prog(l)%wl, &
             'ws=', soil%prog(l)%ws, &
             'dW_l=', dW_l(l), &
             'dPsi=', dPsi(l), &
             'flow=', flow(l)
     enddo
  endif

end subroutine richards

! ============================================================================
  subroutine advection(soil, flow, dW_l, tflow, d_GW, snow_lprec, snow_hlprec)
  type(soil_tile_type), intent(inout) :: soil
  real, intent(in), dimension(:) :: flow
  real, intent(in), dimension(:) :: dW_l
  real, intent(in) :: &
     tflow, &
     d_GW, &
     snow_lprec, &
     snow_hlprec
  ! ---- local vars ----------------------------------------------------------
  real, dimension(num_l)   :: u_minus, u_plus, del_t
  real, dimension(num_l-1) :: eee, fff
  real hcap, aaa, bbb, ccc
  integer l
  
! Upstream weighting of advection. Preserving u_plus here for now.
  u_minus = 1.
  where (flow.lt.0.) u_minus = 0.
  do l = 1, num_l-1
    u_plus(l) = 1. - u_minus(l+1)
    enddo
  hcap = (soil%heat_capacity_dry(num_l)*dz(num_l) &
                              + csw*soil%prog(num_l)%ws)/clw
  aaa = -flow(num_l) * u_minus(num_l)
  bbb =  hcap + soil%prog(num_l)%wl - dW_l(num_l) - aaa
  eee(num_l-1) = -aaa/bbb
  fff(num_l-1) = aaa*(soil%prog(num_l)%T-soil%prog(num_l-1)%T) / bbb

  do l = num_l-1, 2, -1
    hcap = (soil%heat_capacity_dry(l)*dz(l) &
                              + csw*soil%prog(l)%ws)/clw
    aaa = -flow(l)   * u_minus(l)
    ccc =  flow(l+1) * u_plus (l)
    bbb =  hcap + soil%prog(l)%wl - dW_l(l) - aaa - ccc
    eee(l-1) = -aaa / ( bbb +ccc*eee(l) )
    fff(l-1) = (   aaa*(soil%prog(l)%T-soil%prog(l-1)%T)    &
                       + ccc*(soil%prog(l)%T-soil%prog(l+1)%T)    &
                       - ccc*fff(l) ) / ( bbb +ccc*eee(l) )
  enddo
    
  hcap = (soil%heat_capacity_dry(1)*dz(1) + csw*soil%prog(1)%ws)/clw
  aaa = -flow(1) * u_minus(1)
  ccc =  flow(2) * u_plus (1)
  bbb =  hcap + soil%prog(1)%wl - dW_l(1) - aaa - ccc

  del_t(1) =  (  aaa*(soil%prog(1)%T-tflow          ) &
                     + ccc*(soil%prog(1)%T-soil%prog(2)%T) &
                     - ccc*fff(1) ) / (bbb+ccc*eee(1))
  soil%prog(1)%T = soil%prog(1)%T + del_t(1)

  if(is_watch_point()) then
     write(*,*) ' ***** soil_step_2 checkpoint 3.4.1 ***** '
     write(*,*) 'hcap', hcap
     write(*,*) 'aaa', aaa
     write(*,*) 'bbb', bbb
     write(*,*) 'ccc', ccc
     write(*,*) 'del_t(1)', del_t(1)
     write(*,*) ' T(1)', soil%prog(1)%T
  endif

  do l = 1, num_l-1
    del_t(l+1) = eee(l)*del_t(l) + fff(l)
    soil%prog(l+1)%T = soil%prog(l+1)%T + del_t(l+1)
    enddo

  ! (lumped=lm2 groundwater stored in l=1 prog variable, liquid only)
  if (soil%prog(1)%groundwater.ne. 0.) soil%prog(1)%groundwater_T =    &
       + ((aquifer_heat_cap+soil%prog(1)%groundwater-d_GW)  &
	                         *soil%prog(1)%groundwater_T &
        + flow(num_l+1)*soil%prog(num_l)%T) &
         /((aquifer_heat_cap+soil%prog(1)%groundwater-d_GW) + flow(num_l+1))

end subroutine advection

! ============================================================================
! tile existence detector: returns a logical value indicating wether component
! model tile exists or not
logical function soil_tile_exists(tile)
   type(land_tile_type), pointer :: tile
   soil_tile_exists = associated(tile%soil)
end function soil_tile_exists


! ============================================================================
! cohort accessor functions: given a pointer to cohort, return a pointer to a
! specific member of the cohort structure
#define DEFINE_SOIL_ACCESSOR_0D(xtype,x) subroutine CONCAT3(soil_,x,_ptr(t,p));\
type(land_tile_type),pointer::t;xtype,pointer::p;p=>NULL();if(associated(t))then;if(associated(t%soil))p=>t%soil%x;endif;end subroutine
#define DEFINE_SOIL_ACCESSOR_1D(xtype,x) subroutine CONCAT3(soil_,x,_ptr(t,p));\
type(land_tile_type),pointer::t;xtype,pointer::p(:);p=>NULL();if(associated(t))then;if(associated(t%soil))p=>t%soil%x;endif;end subroutine
#define DEFINE_SOIL_COMPONENT_ACCESSOR_0D(xtype,component,x) subroutine CONCAT3(soil_,x,_ptr(t,p));\
type(land_tile_type),pointer::t;xtype,pointer::p;p=>NULL();if(associated(t))then;if(associated(t%soil))p=>t%soil%component%x;endif;end subroutine
#define DEFINE_SOIL_COMPONENT_ACCESSOR_1D(xtype,component,x) subroutine CONCAT3(soil_,x,_ptr(t,p));\
type(land_tile_type),pointer::t;xtype,pointer::p(:);p=>NULL();if(associated(t))then;if(associated(t%soil))p=>t%soil%component%x;endif;end subroutine


DEFINE_SOIL_ACCESSOR_1D(real,w_fc)
DEFINE_SOIL_ACCESSOR_0D(real,uptake_T)
DEFINE_SOIL_ACCESSOR_0D(integer,tag)
DEFINE_SOIL_ACCESSOR_1D(real,fast_soil_C)
DEFINE_SOIL_ACCESSOR_1D(real,slow_soil_C)
DEFINE_SOIL_ACCESSOR_1D(real,asoil_in)
DEFINE_SOIL_ACCESSOR_1D(real,fsc_in)
DEFINE_SOIL_ACCESSOR_1D(real,ssc_in)

DEFINE_SOIL_COMPONENT_ACCESSOR_0D(real,pars,tau_groundwater)
DEFINE_SOIL_COMPONENT_ACCESSOR_0D(real,pars,hillslope_length)
DEFINE_SOIL_COMPONENT_ACCESSOR_0D(real,pars,hillslope_relief)
DEFINE_SOIL_COMPONENT_ACCESSOR_0D(real,pars,hillslope_zeta_bar)
DEFINE_SOIL_COMPONENT_ACCESSOR_0D(real,pars,soil_e_depth)
DEFINE_SOIL_COMPONENT_ACCESSOR_0D(real,pars,zeta)
DEFINE_SOIL_COMPONENT_ACCESSOR_0D(real,pars,tau)
DEFINE_SOIL_COMPONENT_ACCESSOR_0D(real,pars,k_sat_gw)
DEFINE_SOIL_COMPONENT_ACCESSOR_0D(real,pars,vwc_wilt)
DEFINE_SOIL_COMPONENT_ACCESSOR_0D(real,pars,vwc_fc)
DEFINE_SOIL_COMPONENT_ACCESSOR_0D(real,pars,vwc_sat)
DEFINE_SOIL_COMPONENT_ACCESSOR_0D(real,pars,k_sat_ref)

DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,pars,refl_dry_dir)
DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,pars,refl_dry_dif)
DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,pars,refl_sat_dir)
DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,pars,refl_sat_dif)
DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,pars,f_iso_dry)
DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,pars,f_vol_dry)
DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,pars,f_geo_dry)
DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,pars,f_iso_sat)
DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,pars,f_vol_sat)
DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,pars,f_geo_sat)

!DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,prog,T)
!DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,prog,wl)
!DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,prog,ws)
!DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,prog,groundwater)
!DEFINE_SOIL_COMPONENT_ACCESSOR_1D(real,prog,groundwater_T)

! ============================================================================
  subroutine soil_T_ptr(t,p)
  type(land_tile_type),pointer::t
  real,pointer::p(:)
  integer :: n

  p=>NULL()
  if(associated(t))then
    if(associated(t%soil))then
      n=size(t%soil%prog(:))
      p(1:n)=>t%soil%prog(1:n)%T
    endif
  endif
  end subroutine
 
! ============================================================================
  subroutine soil_wl_ptr(t,p)
  type(land_tile_type),pointer::t
  real,pointer::p(:)
  integer :: n

  p=>NULL()
  if(associated(t))then
  if(associated(t%soil))then
  n=size(t%soil%prog(:))
  p(1:n)=>t%soil%prog(1:n)%wl
  endif
  endif
  end subroutine
 
! ============================================================================
  subroutine soil_ws_ptr(t,p)
  type(land_tile_type),pointer::t
  real,pointer::p(:)
  integer :: n

  p=>NULL()
  if(associated(t))then
  if(associated(t%soil))then
  n=size(t%soil%prog(:))
  p(1:n)=>t%soil%prog(1:n)%ws
  endif
  endif
  end subroutine

! ============================================================================
  subroutine soil_groundwater_ptr(t,p)
  type(land_tile_type),pointer::t
  real,pointer::p(:)
  integer :: n

  p=>NULL()
  if(associated(t))then
  if(associated(t%soil))then
  n=size(t%soil%prog(:))
  p(1:n)=>t%soil%prog(1:n)%groundwater
  endif
  endif
  end subroutine

! ============================================================================
  subroutine soil_groundwater_T_ptr(t,p)
  type(land_tile_type),pointer::t
  real,pointer::p(:)
  integer :: n

  p=>NULL()
  if(associated(t))then
  if(associated(t%soil))then
  n=size(t%soil%prog(:))
  p(1:n)=>t%soil%prog(1:n)%groundwater_T
  endif
  endif
  end subroutine

end module soil_mod

module land_properties_mod

! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Christopher Milly
! </CONTACT> 

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Elena Shevliakova
! </REVIEWER>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Sergey Malyshev
! </REVIEWER>

! <OVERVIEW>
!   Contains land properties namelist variables and procedures relating
!   to the properties of the land.
! </OVERVIEW>

! <DESCRIPTION>
!     Initialization and calculation of the land property data. The input
!     cover field and implied glacier field are obtained and the glacier mask
!     and cover type are redefined, if necessary. The properties that depend
!     on cover and ground types are assigned. The land properties diagnostics
!     are initialized and the static fields are sent to the diagnostic manager
!     for output.
!
!     Updates the rapidly changing parameters. Computes the albedo of
!     the hypothetical no-snow and deep-snow surfaces and uses snow mass to
!     blend snow-free and deep-snow albedo values. Regrids integer index data
!     to any output grid from a uniformly spaced grid using a maximum-area
!     voting scheme. Includes calculation of total area of each land cover
!     type within the territory and the determination of the type occupying
!     the biggest area within the territory.
! </DESCRIPTION>

use mpp_domains_mod,    only: domain2d, mpp_get_compute_domain, mpp_get_global_domain
use time_manager_mod,   only: time_type, set_date, print_date, get_date,     &
                              operator(-), operator(>)
use mpp_io_mod,         only: mpp_open, mpp_RDONLY
use fms_mod,            only: error_mesg, file_exist, open_namelist_file,    &
                              check_nml_error, stdlog, write_version_number, &
                              mpp_pe, mpp_root_pe, close_file, read_data,    &
                              FATAL, NOTE, open_restart_file, set_domain,    &
                              field_size, stdout
use constants_mod,      only: tfreeze, pi
use horiz_interp_mod,   only: horiz_interp_type, horiz_interp_new, horiz_interp, &
                              horiz_interp_del
use numerics_mod,       only: is_latlon, expand_cell
use climap_albedo_mod,  only: get_climap_albedo,     get_climap_glacier,     &
                              get_climap_albedo_mcm, get_climap_glacier_mcm
use diag_manager_mod,  only : register_static_field, send_data, get_base_time
use topography_mod,     only: get_topog_stdev
implicit none
private

! ==== public interface =====================================================
public :: land_properties_init,land_properties_end
public :: update_land_properties_slow
public :: update_land_properties_fast

public :: regrid_discrete_field
! ==== end public interface =================================================

! <NAMELIST NAME="land_properties_nml">
! n_dim_ground_types        size of ground (soil) parameter lookup tables
! n_dim_cover_types         size of cover (vegetation) parameter lookup tables
! n_map_ground_types        number of ground types in input map file
! n_map_cover_types         number of cover types in input map file

!   <DATA NAME="n_dim_ground_types" TYPE="integer, parameter" DEFAULT="11">
!     Size of ground (soil) parameter lookup tables
!   </DATA>

!   <DATA NAME="n_dim_cover_types" TYPE="integer, parameter" DEFAULT="14">
!     Size of cover (vegetation) parameter lookup tables
!   </DATA>

!   <DATA NAME="n_map_ground_types" TYPE="integer, parameter" DEFAULT="10">
!     Number of ground types in input map file
!   </DATA>

!   <DATA NAME="n_map_cover_types" TYPE="integer, parameter" DEFAULT="11">
!     Number of cover types in input map file
!   </DATA>

integer, parameter   :: n_dim_ground_types = 11  ! = 10+ssl
integer, parameter   :: n_dim_cover_types  = 14  ! = 11+tun+ssl_veg+ssl_ice
integer, parameter   :: n_map_ground_types = 10
integer, parameter   :: n_map_cover_types  = 11

!---- namelist - with default values ----------------------------------
!
! do_all_mcm       run Manabe Climate Model land surface       [logical]
!          Setting this global control option to TRUE causes
!          specification all the following (regardless of default or input
!          settings, which are then ignored):
!              veg_to_use      = 'cons_ssl', 
!              soil_to_use     = 'cons_ssl', 
!              use_climap      = .true.  (this forced by veg_to_use='cons_ssl'), 
!              use_climap_mcm  = .true., 
!              do_mcm_masking  = .true., 
!              use_single_geo  = .true., 
!              geo_res_time    = res_time_ssl, 
!              factor_root     = 1., 
!              factor_rough    = 1., 
!              z_root_min      = 0., 
!              max_snow        = max_snow_ssl
! veg_to_use          choice of method for defining vegetation   [character]
!          'variable' - use input map to index vegetation parameter vectors
!          'constant' - use veg_index_constant to index veg parameter vectors
!          'cons_tun' - use tuned global constant vegetation
!          'cons_ssl' - use Manabe Climate Model-like vegetation (forces use_climap to be true)
! soil_to_use         choice of method for defining soil         [character]
!          'variable' - use input map to index soil parameter vectors
!          'constant' - use soil_index_constant to index soil parameter vectors
!          'cons_ssl' - use Manabe Climate Model-like soil
! use_glaciers        false to remove glaciers from land          [logical]
! use_climap          true to override default albedo by CLIMAP   [logical]
!                     and to invoke use of CLIMAP to define glacier
!                     locations (if use_glaciers)
! use_desert_albedo_map   true to override default snow-free albedo of desert only by
!                         albedo map (SRB)
! do_mcm_masking      true to use Manabe Climate Model snow-albedo fn. [logical]
! use_single_basin    true to avoid using basin maps              [logical]
! use_single_geo      true for global constant gw residence time  [logical]
! i_dest0             if use_single_geo is set to .true., all the river
!                     discharge is put in a single grid cell. i_dest0 is the
!                     longitude index of this grid cell.  
! j_dest0             if use_single_geo is set to .true., all the river
!                     discharge is put in a single grid cell. j_dest0 is the
!                     latitude index of this grid cell.            
! veg_index_constant  veg index used when veg_to_use='constant'          -
! soil_index_constant soil index used when soil_to_use='constant'        -
! soil_index_ice_substitute   ground type to be substituted for
!                     ice ground type when such type is over-ruled due to
!                     absence of glacier cover type. if this is set to 
!                     zero, then the ground type is temporarily marked as
!                     ocean, and, if land is present, ground type will then
!                     be assigned based on neighbor cells through regrid_discrete_field.
! geo_res_time        time constant when use_single_geo is true          s
! t_range             T range over which snow/glacier albedo varies      K
! factor_root         global factor for critical_root_density            -
! factor_stomata      global factor for veg_rs_min_vec                   -
! factor_rough        global factor for rough_momentum_vec               -
! z_root_min          lower bound for root-zone depth                    m
! max_snow            value of snow above which 'snow runoff' occurs  kg/m**3
! sfc_heat_factor     "fudge" factor for heat capacity and thermal
!                     conductivity in surface soil layers                -
! num_sfc_layers      number of surface layers for sfc_heat_factor       -
! dynamic_cover_type    set to true if cover type forcing data varies with
!                       time                               [logical]
! read_old_ascii_cover  read the original ASCII file of cover type
!                                                          [logical]
! cover_dataset_init_year  initial year in the cover_type dataset [integer]
! cover_dataset_entry      beginning time for reading the cover_type
!                          dataset (yr, mo, dy, hr, mn, sc)       [integer]


!   <DATA NAME="do_all_mcm" TYPE="logical" DEFAULT=".false.">
!     Run Manabe Climate Model land surface. Setting this global control
!     option to TRUE causes specification all the following (regardless of
!     default or input settings, which are then ignored):
!              veg_to_use      = 'cons_ssl'
!              soil_to_use     = 'cons_ssl'
!              use_climap      = .true.  (this forced by veg_to_use='cons_ssl')
!              use_climap_mcm  = .true.
!              do_mcm_masking  = .true.
!              use_single_geo  = .true.
!              geo_res_time    = res_time_ssl
!              factor_root     = 1.
!              factor_rough    = 1.
!              z_root_min      = 0.
!              max_snow        = max_snow_ssl
!   </DATA>

!   <DATA NAME="veg_to_use" TYPE="character*8" DEFAULT="'variable'">
!     Choice of method for defining vegetation.
!          'variable' - use input map to index vegetation parameter vectors
!          'constant' - use veg_index_constant to index veg parameter vectors
!          'cons_tun' - use tuned global constant vegetation
!          'cons_ssl' - use Manabe Climate Model-like vegetation (forces use_climap to be true)
!   </DATA>

!   <DATA NAME="soil_to_use" TYPE="character*8" DEFAULT="'variable'">
!     Choice of method for defining soil.
!          'variable' - use input map to index soil parameter vectors
!          'constant' - use soil_index_constant to index soil parameter vectors
!          'cons_ssl' - use Manabe Climate Model-like soil
!   </DATA>

!   <DATA NAME="use_glaciers" TYPE="logical" DEFAULT=".true.">
!     False to remove glaciers from land
!   </DATA>

!   <DATA NAME="use_climap" TYPE="logical" DEFAULT=".false.">
!     True to override default albedo by CLIMAP and to invoke use of CLIMAP
!     to define glacier locations (if use_glaciers)
!   </DATA>

!   <DATA NAME="use_desert_albedo_map" TYPE="logical" DEFAULT=".false.">
!     true to override default snow-free albedo of desert only by
!     albedo map (SRB)
!   </DATA>

!   <DATA NAME="use_climap_mcm" TYPE="logical" DEFAULT=".false.">
!     Run Manabe Climate Model land surface
!   </DATA>

!   <DATA NAME="do_mcm_masking" TYPE="logical" DEFAULT=".false.">
!     True to use Manabe Climate Model snow-albedo function
!   </DATA>

!   <DATA NAME="use_single_basin" TYPE="logical" DEFAULT=".false.">
!     True to avoid using basin maps
!   </DATA>

!   <DATA NAME="use_single_geo" TYPE="logical" DEFAULT=".false.">
!     True for global constant groundwater residence time
!   </DATA>

!   <DATA NAME="i_dest0" TYPE="integer" DEFAULT="1">
!     If use_single_geo is set to .true., all the river discharge is put in a
!     single grid cell. i_dest0 is the longitude index of this grid cell. 
!   </DATA>

!   <DATA NAME="j_dest0" TYPE="integer" DEFAULT="1">
!     If use_single_geo is set to .true., all the river discharge is put in a
!     single grid cell. j_dest0 is the latitude index of this grid cell. 
!   </DATA>

!   <DATA NAME="veg_index_constant" TYPE="integer" DEFAULT="3">
!     Veg index used when veg_to_use='constant'
!   </DATA>

!   <DATA NAME="soil_index_constant" TYPE="integer" DEFAULT="2">
!     Soil index used when soil_to_use='constant'
!   </DATA>

!   <DATA NAME="soil_index_ice_substitute" TYPE="integer" DEFAULT="1">
!     Ground type to be substituted for ice ground type when such type is
!     over-ruled due to absence of glacier cover type. if this is set to zero,
!     then the ground type is temporarily marked as ocean, and, if land is
!     present, ground type will then be assigned based on neighbor cells
!     through regrid_discrete_field.
!   </DATA>

!   <DATA NAME="geo_res_time" UNITS="s" TYPE="real" DEFAULT="60.*86400.">
!     Time constant when use_single_geo is true
!   </DATA>

!   <DATA NAME="t_range" UNITS="K" TYPE="real" DEFAULT="10.0">
!     Temperature range over which snow/glacier albedo varies
!   </DATA>

!   <DATA NAME="factor_root" TYPE="real" DEFAULT="1.0">
!     Global factor for critical_root_density
!   </DATA>

!   <DATA NAME="factor_stomata" TYPE="real" DEFAULT="1.0">
!     Global factor for veg_rs_min_vec
!   </DATA>

!   <DATA NAME="factor_rough" TYPE="real" DEFAULT="1.0">
!     Global factor for rough_momentum_vec
!   </DATA>

!   <DATA NAME="z_root_min" UNITS="m" TYPE="real" DEFAULT="0.01">
!     lower bound for root-zone depth
!   </DATA>

!   <DATA NAME="max_snow" UNITS="kg/m3" TYPE="real" DEFAULT="1000.">
!     Value of snow above which 'snow runoff' occurs
!   </DATA>

!   <DATA NAME="sfc_heat_factor" TYPE="real" DEFAULT="1.">
!     "fudge" factor for heat capacity and thermal
!      conductivity in surface soil layers
!   </DATA>

!   <DATA NAME="num_sfc_layers" TYPE="integer" DEFAULT="0">
!     number of surface layers for sfc_heat_factor
!   </DATA>

!   <DATA NAME="dynamic_cover_type" TYPE="logical" DEFAULT="true">
!     Set to true if cover type forcing data varies with time.
!   </DATA>

!   <DATA NAME="read_old_ascii_cover" TYPE="logical" DEFAULT="false">
!     Set to true if reading the original ASCII static cover type forcing data
!   </DATA>

!   <DATA NAME="cover_dataset_init_year" TYPE="integer" DEFAULT="1860">
!     The initial year in the cover_type dataset.
!   </DATA>

!   <DATA NAME="cover_dataset_entry" TYPE="integer" DEFAULT="(/1,1,1,0,0,0/)">
!     Beginning time for reading the cover_type dataset (yr,mo,dy,hr,mn,sc).
!   </DATA>

logical                       :: do_all_mcm            = .false.
character*8                   :: veg_to_use            = 'variable'
character*8                   :: soil_to_use           = 'variable'
logical                       :: use_glaciers          = .true.
logical                       :: use_climap            = .false.
logical                       :: use_desert_albedo_map = .false.
logical                       :: use_climap_mcm        = .false.
logical                       :: do_mcm_masking        = .false.
logical                       :: use_single_basin      = .false.
logical                       :: use_single_geo        = .false.
integer                       :: i_dest0               = 1
integer                       :: j_dest0               = 1
integer                       :: veg_index_constant    = 3    ! mixed broadleaf/needleleaf
integer                       :: soil_index_constant   = 2    ! medium texture mineral soil
integer                   :: soil_index_ice_substitute = 1
logical :: reconcile_lakes   = .false. ! if true, lake distribution 
           ! in cover and ground type fields is reconciled based on the cover type
integer :: soil_index_lake_substitute = 1 ! substitute for the ground lake type,
           ! used only if reconcile_lakes is true
real                          :: geo_res_time          = 60.*86400.   ! two months
real                          :: t_range               = 10.0
real                          :: factor_root           =  1.0
real                          :: factor_stomata        =  1.0
real                          :: factor_rough          =  1.0
real                          :: z_root_min            =  0.01
real                          :: max_snow              = 1000.  ! (1 m water equiv)
real                          :: sfc_heat_factor       = 1.
integer                       :: num_sfc_layers        = 0
logical :: dynamic_cover_type = .true.  ! true if cover type forcing data
                                        ! varies with time. Must also set
                                        ! cover_dataset_entry.
logical :: read_old_ascii_cover = .false.       ! true if reading original
                                               ! static ACII cover type forcing.
integer, dimension(6) ::     &
       cover_dataset_entry  = (/ 1860, 1, 1, 0, 0, 0 /) 
          ! beginning time for reading the cover_type data. Must be set when
          ! using read_old_ascii_cover = false.

integer :: cover_dataset_init_year = 1860     ! initial year for the cover_type
                                              ! dataset.

!   <DATA NAME="veg_rs_min_vec" UNITS="s/m" TYPE="real" DIM="n_dim_cover_types">
!     Minimum bulk stomatal resistance. For default values, refer to the table
!     in the Public Code section below.
!   </DATA>
!   <DATA NAME="veg_zeta_vec" UNITS="m" TYPE="real" DIM="n_dim_cover_types">
!     Depth scale of root distribution. For default values, refer to the table
!     in the Public Code section below.
!   </DATA>
!   <DATA NAME="veg_root_mass_vec" UNITS="kg/m2" TYPE="real" DIM="n_dim_cover_types">
!     Root biomass areal density. For default values, refer to the table
!     in the Public Code section below.
!   </DATA>
!   <DATA NAME="rough_momentum_vec" UNITS="m" TYPE="real" DIM="n_dim_cover_types">
!     Roughness length for momentum. For default values, refer to the table
!     in the Public Code section below.
!   </DATA>
!   <DATA NAME="k_over_B_vec" TYPE="real" DIM="n_dim_cover_types">
!     ln (z_0_momentum / z_0_scalar). For default values, refer to the table
!     in the Public Code section below.
!   </DATA>
!   <DATA NAME="crit_snowmass_vec" UNITS="kg/m3" TYPE="real" DIM="n_dim_cover_types">
!     Snow amount that half hides surface. For default values, refer to the
!     table in the Public Code section below.
!   </DATA>
!   <DATA NAME="min_nosnow_alb_vec" TYPE="real" DIM="n_dim_cover_types">
!     Snow-free albedo at freezing point. For default values, refer to
!     the table in the Public Code section below. 
!   </DATA>
!   <DATA NAME="max_nosnow_alb_vec" TYPE="real" DIM="n_dim_cover_types">
!     Snow-free albedo at t_range below freezing. For default values, refer to
!     the table in the Public Code section below. 
!   </DATA>
!   <DATA NAME="min_snow_alb_vec" TYPE="real" DIM="n_dim_cover_types">
!     Snow albedo at freezing point.  For default values, refer to
!     the table in the Public Code section below. 
!   </DATA>
!   <DATA NAME="max_snow_alb_vec" TYPE="real" DIM="n_dim_cover_types">
!     Snow albedo at t_range below freezing.  For default values, refer to
!     the table in the Public Code section below. 
!   </DATA>
!   <DATA NAME="soil_awc_vec" UNITS="kg/m3" TYPE="real" DIM="n_dim_ground_types">
!     Available water capacity. For default values, refer to the table in
!     the Public Code section below.
!   </DATA>
!   <DATA NAME="soil_therm_cap_vec" UNITS="J/(K m3)" TYPE="real" DIM="n_dim_ground_types">
!     Volumetric heat capacity. For default values, refer to the table in the
!     Public Code section below.
!   </DATA>
!   <DATA NAME="soil_therm_dif_vec" UNITS="m2/s" TYPE="real" DIM="n_dim_ground_types">
!     Thermal diffusivity. For default values, refer to the table in the
!     Public Code section below.
!   </DATA>
!   <DATA NAME="use_topo_rough" TYPE="logical" DEFAULT="false">
!     If true, the topographic momentum drag scaling scheme is used
!   </DATA>
!   <DATA NAME="max_topo_rough" TYPE="real" DEFAULT="100" UNITS="m">
!     Maximum of topographic "roughness length" used for momentum drag scaling
!   </DATA>
!   <DATA NAME="topo_rough_factor" TYPE="real" DEFAULT="1.0">
!     Scaling factor to convert topography variance to topographic 
!     "roughness length"
!   </DATA>
!   <DATA NAME="topo_rough_source" TYPE="caharacter(len=16)" DEFAULT="'computed'">
!     Source of the sub-grid topography variance data for topographic momentum drag scaling. 
!     'computed' means that the variance is calculated based on high-resolution 
!     topography data. 'input' means that the data will be provided in specified file
!     (NetCDF of IEEE binary)
!   </DATA>
!   <DATA NAME="topo_rough_file" TYPE="character(len=256)" DEFAULT="INPUT/mg_drag.data.nc">
!     Name of the file to be used as an input for sub-grid topography variance data. 
!     The file can be either NetCDF (in this case variable name can also be specified), or
!     IEEE.
!   </DATA>
!   <DATA NAME="topo_rough_var" TYPE="character(len=128)" DEFAULT="ghprime">
!     Name of the NetCDF variable to be used as a topography variance field. Ignored if
!     the file specified in topo_rough_file is not NetCDF file.
!   </DATA>
! </NAMELIST>


!   <PUBLICCOMMENT>
! the following namelist vectors contain properties indexed by cover (veg) type:
!  0      ocean
!  1 (BE) broadleaf evergreen trees
!  2 (BD) broadleaf deciduous trees
!  3 (BN) broadleaf/needleleaf trees
!  4 (NE) needleleaf evergreen trees
!  5 (ND) needleleaf deciduous trees
!  6 (G)  grassland
!  7 (D)  desert
!  8 (T)  tundra
!  9 (A)  agriculture
! 10 (I)  ice
! 11 (L)  lake
! 12 (TV) tuned global vegetation
! 13 (SV) Manabe Climate Model-like vegetation
! 14 (SI) Manabe Climate Model-like ice/glacier

! veg_rs_min_vec       minimum bulk stomatal resistance           s/m
! veg_zeta_vec         depth scale of root distribution            m
! veg_root_mass_vec    root biomass areal density               kg/m**2
! rough_momentum_vec   roughness length for momentum               m
! k_over_B_vec         ln (z_0_momentum / z_0_scalar)              -
! crit_snowmass_vec    snow amount that half hides surface      kg/m**3
! min_nosnow_alb_vec   snow-free albedo at freezing point          -
! max_nosnow_alb_vec   snow-free albedo at t_range below freezing       -
! min_snow_alb_vec     snow albedo at freezing point               -
! max_snow_alb_vec     snow albedo at t_range below freezing       -

real, dimension(n_dim_cover_types) :: &
!                      BE     BD     BN     NE     ND      G      D      T      A      I      L     TV     SV     SI
veg_rs_min_vec    =(/  43.6,  131., 87.1,  69.7,  218.,  56.6,  .01,   170.,  56.6, .01,   .01,     67.,  .01,   .01/),& 
veg_zeta_vec      =(/  .26,   .29,  .35,   .17,   .17,   .26,   .35,   .11,   .25,   0.0,   1.0,   .35,   .35,   0.0/),&
veg_root_mass_vec =(/  4.9,   4.2,  4.3,   2.9,   2.9,   1.4,  .762,   1.2,   .15,   0.0,   1.0,  .362,  .762,   0.0/),&
rough_momentum_vec=(/ 2.65,  .90,   1.2,   .90,   .80,   .07,   .01,   .07,   .40,   .01, 1.4e-4,  1.0,  .045,  .045/),&
k_over_B_vec      =(/   2.,    2.,    2.,    2.,    2.,   2.,    2.,    2.,    2.,    2.,  0.25,    2.,    0.,    0. /),&
crit_snowmass_vec =(/  60.,   10.,   25.,   40.,   40.,   5.,    5.,    5.,    5.,    5.,    5.,  100.,    5.,    5. /),&
min_nosnow_alb_vec=(/0.149, 0.130, 0.132, 0.126, 0.143, 0.182, 0.333, 0.139, 0.160, 0.650, 0.06,  0.12,   999.,  0.55/),&
max_nosnow_alb_vec=(/0.149, 0.130, 0.132, 0.126, 0.143, 0.182, 0.333, 0.139, 0.160, 0.800, 0.06,  0.12,   999.,  0.65/),&
min_snow_alb_vec  =(/0.650, 0.650, 0.650, 0.650, 0.650, 0.650, 0.650, 0.650, 0.650, 0.650, 0.06,  0.450, 0.450, 0.650/),&
max_snow_alb_vec  =(/0.800, 0.800, 0.800, 0.800, 0.800, 0.800, 0.800, 0.800, 0.800, 0.800, 0.06,  0.600, 0.600, 0.800/)
!                      BE     BD     BN     NE     ND      G      D      T      A      I      L     TV     SV     SI


! the following vectors contain properties indexed by ground (soil) type:
!  0       ocean
!  1 (C)   coarse soil
!  2 (M)   medium soil
!  3 (F)   fine soil
!  4 (CM)  coarse/medium mix
!  5 (CF)  coarse/fine mix
!  6 (MF)  medium/fine mix
!  7 (CMF) coarse/medium/fine mix
!  8 (P)   organic soil (peat)
!  9 (I)   ice
! 10 (L)   lake
! 11 (MCM)  Manabe Climate Model

! soil_awc_vec         available water capacity                 kg/m**3
! soil_therm_cap_vec   volumetric heat capacity                J/(K m**3)
! soil_therm_dif_vec   thermal diffusivity                       m**2/s

real, dimension(n_dim_ground_types) :: &
!   C      M      F      CM     CF     MF    CMF     P      I      L      MCM
soil_awc_vec      = &
(/   63.,  132.,  109.,   98.,   86.,  120.,  101.,  445., 1000., 1000.,  150./),&
soil_therm_cap_vec= &
(/ 1.8e6, 2.0e6, 2.6e6, 1.9e6, 2.2e6, 2.3e6, 2.1e6, 3.0e6, 1.6e6, 8.4e7, 1.0/),&
soil_therm_dif_vec=&
(/8.3e-7,4.0e-7,5.2e-7,6.2e-7,6.8e-7,4.6e-7,5.8e-7,1.3e-7,1.1e-6, 1.0,  2.0e-7/)
!   C      M      F      CM     CF     MF    CMF     P      I      L      MCM
! </PUBLICCOMMENT>


logical     :: use_topo_rough    = .false.
real        :: max_topo_rough    = 100 ! m
real        :: topo_rough_factor = 1.0
character(len=16) :: topo_rough_source = 'computed'
character(len=256):: topo_rough_file   = 'INPUT/mg_drag.data.nc'
character(len=128):: topo_rough_var    = 'ghprime'

namelist /land_properties_nml/ do_all_mcm,         veg_to_use,         &
                               soil_to_use,        use_glaciers,       &
                               use_climap,         use_desert_albedo_map,  &
                               do_mcm_masking,     &
                               use_single_basin,   use_single_geo,     &
                               i_dest0,            j_dest0,            &
                               veg_index_constant, soil_index_constant,&
                               soil_index_ice_substitute,              &
                               geo_res_time,       t_range,            &
                               factor_root,        factor_stomata,     &
                               factor_rough,       z_root_min,         &
                               max_snow,                               &
                               veg_rs_min_vec,     veg_zeta_vec,       &
                               veg_root_mass_vec,                      &
                               rough_momentum_vec, k_over_B_vec,       &
                               crit_snowmass_vec,                      &
                               min_nosnow_alb_vec, max_nosnow_alb_vec, &
                               min_snow_alb_vec,   max_snow_alb_vec,   &
                               soil_awc_vec,                           &
                               soil_therm_cap_vec, soil_therm_dif_vec, &
                               use_topo_rough, max_topo_rough, topo_rough_factor, &
                               sfc_heat_factor, num_sfc_layers,        &
                               dynamic_cover_type, read_old_ascii_cover, &
                               cover_dataset_init_year, cover_dataset_entry, &
                               reconcile_lakes, soil_index_lake_substitute

! ---- private data ----------------------------------------------------------
logical :: module_is_initialized =.FALSE.

character(len=128) :: version = '$Id: land_properties.F90,v 19.0 2012/01/06 20:39:32 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!---- other module variables and named constants

! nlon, nlat             numbers of longitudes, latitudes in land grid
! npart                  number of partitions of each land grid cell
! ground_type            lon/lat/tile array of ground type index
! albedo_min_no_snow     lon/lat/tile array of min snow-free land albedo
! albedo_max_no_snow     lon/lat/tile array of max snow-free land albedo
! critical_root_density  root density at the bottom of the root zone (kg/m**3)
! max_snow_ssl           Manabe Climate Model value of max_snow              (kg/m**3)
! res_time_ssl           Manabe Climate Model value of groundwater res. time    (s)
! veg_index_desert       location of desert parameters in veg vecs
! veg_index_tundra       location of tundra parameters in veg vecs
! veg_index_ice          location of standard ice parameters in veg vecs
! veg_index_tuned        location of tuned parameters in veg vecs
! veg_index_ssl_veg      location of ssl veg parameters in veg vecs
! veg_index_ssl_ice      location of ssl ice parameters in veg vecs
! soil_index_coarse      location of coarse soil parameters in soil vecs
! soil_index_ice         location of ice parameters in soil vecs
! soil_index_ssl         location of ssl soil parameters in soil vecs
! topo_stdev             standard deviation of topography
! model_init_time        model base time - used to calculate cover type offset
! cover_entry            cover type dataset entry time 

integer                                :: nlon, nlat, npart
integer, pointer, dimension(:,:,:)     :: ground_type =>NULL()
real, pointer, dimension(:,:,:)        :: albedo_min_no_snow =>NULL()
real, pointer, dimension(:,:,:)        :: albedo_max_no_snow =>NULL()
real                          :: critical_root_density   =  0.125
real                          :: critical_glacier_albedo =  0.79
real                          :: max_snow_ssl            =  200.
real                          :: res_time_ssl            = 60.*86400.
integer                       :: veg_index_desert      =  7
integer                       :: veg_index_tundra      =  8
integer                       :: veg_index_ice         = 10
integer                       :: veg_index_lake        = 11
integer                       :: veg_index_tuned       = 12
integer                       :: veg_index_ssl_veg     = 13
integer                       :: veg_index_ssl_ice     = 14
integer                       :: soil_index_coarse     =  1
integer                       :: soil_index_ice        =  9
integer                       :: soil_index_lake       = 10
integer                       :: soil_index_ssl        = 11
real, allocatable :: topo_stdev(:,:)

type(time_type) :: model_init_time, cover_entry
type(horiz_interp_type), save :: Interp_gw

! ---- name of the diagnostic "module" ---------------------------------------
character(len=*), parameter :: diag_mod_name = "soil"
! ---- diagnostic fields ids -------------------------------------------------
integer :: id_alb_max, id_alb_min
integer :: id_ground_type
integer :: id_topo_stdev

include 'netcdf.inc'
contains

!#######################################################################

! <SUBROUTINE NAME="land_properties_init">

!   <OVERVIEW>
!     Initialize land property data.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Reads and re-grids each land input data field and allocates arrays.
!     The input cover field and implied glacier field are obtained, if either
!     will be needed. Then, the ice cover type is reset to tundra. It
!     may be changed back to ice according to actual glacier specification
!     later. The glacier mask and cover type are redefined, if necessary.
!
!     The appropriate cover type to glacier cells is assigned, if any. The
!     ground (soil) type is defined and the groundwater residence time is
!     calculated. The properties that depend on cover and ground types are
!     assigned. If requested, the snow-free albedo is changed to the CLIMAP
!     array.
!
!     The land properties diagnostics are initialized and the static fields 
!     are sent to the diagnostic manager for output.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call land_properties_init (lonb,   latb,  land,  time,  domain, &
!     glacier, lake, rough_momentum, rough_heat, soil_therm_con,  &
!     soil_therm_cap, veg_rs_min, max_water, tau_groundwater, max_snow_out, &
!     id_lon, id_lat   )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine land_properties_init ( &
     lonb,   latb,  land,  time,  domain, &
     glacier,         &
     lake,            &
     rough_momentum,  &
     rough_heat,      &
     rough_scale,     &  ! topographic roughness for drag scaling
     soil_therm_con,  &
     soil_therm_cap,  &
     veg_rs_min,      &
     max_water,       &
     tau_groundwater, &
     max_snow_out,    &
     cover_type,      &
     id_lon, id_lat )

  real,            intent(in) :: lonb(:,:), latb(:,:) ! corners of the cells,
                                                  ! radian
  logical,         intent(in) :: land(:,:,:)      ! land mask
  type(time_type), intent(in) :: time             ! current time
  type(domain2d),  intent(in) :: domain           ! our domain 

  logical, intent(out), dimension(:,:,:) :: glacier, lake ! glacier, lake masks
  real   , intent(out), dimension(:,:,:) :: &
       rough_momentum, &                  ! roughness length for momentum
       rough_heat,     &                
       rough_scale,    &
       veg_rs_min,     & 
       max_water,      &
       tau_groundwater                    ! groundwater residence time
  real   , intent(out), dimension(:,:,:,:) :: &
       soil_therm_con, &
       soil_therm_cap
  real   , intent(out)  :: max_snow_out
  integer, intent(out), dimension(:,:,:) :: cover_type
  integer, intent(in) :: id_lon, id_lat   ! ids of diagnostic axes
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer, allocatable :: integer_input_1(:,:)
  real,    allocatable :: real_input     (:,:)
  real,    allocatable :: tmp(:,:,:)  ! temp array for read data for cover_type
  integer, allocatable :: cover_type_input (:,:,:)  ! cover_type input data
  integer, allocatable :: nlon_input (:)     ! input data lon
  integer, allocatable :: nlat_input (:)     ! input data lat
  real,    allocatable :: nblon_input (:)    ! input data western boundary

  real, dimension(size(land,1),size(land,2)):: stdev ! standard deviation of
                                                     ! orography 
  logical got_stdev

  character*80            input_format
  integer :: unit, io, ierr, i_cover_type, i_ground_type
  integer :: ii, jj, num_lon_input, num_lat_input, k
  real    :: wb_degrees ! western boundary of the input grid cells
  real    :: sb, wb, dx, dy, z_root
  integer :: is,ie, js,je ! boundaries of our domain
  integer :: gnlon, gnlat
  integer :: siz(4)       ! size of field in field_size call
  integer :: model_yr, model_mo, model_dy, model_hr, model_mn, model_sc
  integer :: init_yr, init_mo, init_dy, init_hr, init_mn, init_sc
  integer :: kk           ! time loop integer for cover type data
  integer :: outunit

  module_is_initialized = .TRUE.
  outunit = stdout()
  
  ! get the size of our domain
  call mpp_get_compute_domain ( domain, is,ie,js,je )

  call mpp_get_global_domain ( domain, xsize=gnlon, ysize=gnlat)

!---- read and write namelist and version -----------------
  if (file_exist('input.nml')) then
     unit = open_namelist_file ( )
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=land_properties_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'land_properties_nml')
     enddo
10   continue
     call close_file (unit)
  endif
  
  call write_version_number(version, tagname)
  if (mpp_pe() == mpp_root_pe()) then
     unit = stdlog()
     write (unit, nml=land_properties_nml)
     call close_file (unit)
  endif

  if (do_all_mcm) then
     veg_to_use        = 'cons_ssl'
     soil_to_use       = 'cons_ssl'
     do_mcm_masking    = .true.
     use_single_geo    = .true.
     geo_res_time      = res_time_ssl
     factor_root       = 1.
     factor_rough      = 1.
     z_root_min        = 0.
     max_snow          = max_snow_ssl
     use_climap_mcm    = .true.
  endif
  if (veg_to_use .eq. 'cons_ssl') then
     use_climap = .true.
  endif

   ! allocate private arrays
   nlon = size(lonb,1) - 1
   nlat = size(latb,2) - 1
   npart = size(land,3)
   allocate (ground_type   (nlon, nlat, npart))
   allocate (albedo_min_no_snow(nlon, nlat, npart))
   allocate (albedo_max_no_snow(nlon, nlat, npart))
   allocate (topo_stdev(nlon,nlat))

   ! Read and re-grid each land input data field

sb = -pi/2.

!  <NOTE>
!---- Cover (vegetation) type. There are 12 possible cases: veg_to_use can
! take 4 values, and glaciers can be (1) absent, (2) based on input cover
! field, or (3) based on climap albedo field. (use of climap albedo forces
! use of climap to locate glaciers, if glaciers are used.) the code
! ensures consistency between cover_type field and glacier mask, with
! the latter taking precedence: where glacier based on input cover field
! must be removed in deference to climap or if no glaciers are used,
! such points are assigned tundra (or global constant) type.
!  </NOTE>

!--- first get input cover field and implied glacier field, if either of
! these will be needed. then re-set ice cover type to tundra; it may be
! changed back to ice according to actual glacier specification later.
if ( veg_to_use.eq.'variable' &
     .or. (use_glaciers.and..not.use_climap) ) then

! check that dynamic_cover_type and read_old_ascii_cover both are not true
   if (dynamic_cover_type .and. read_old_ascii_cover) &
      call error_mesg('land_properties_init',                  &
       'The namelist variables dynamic_cover_type and read_old_ascii_cover cannot both have .true. values',FATAL)

! If dynamic_cover_type_netcdf is chosen, then the cover_type will be obtained
! from a netCDF file of annual data. The initial year of the data is 
! specified in the namelist option cover_dataset_init_year.
   if (dynamic_cover_type) then
     if(.not.file_exist('INPUT/cover_type_field.nc')) &
       call error_mesg('land_properties_init','Cannot find file INPUT/cover_type_field.nc',FATAL)
! <ERROR MSG="Cannot find file INPUT/cover_type_field.nc" STATUS="FATAL">
!   The cover type field file cannot be found. Provide this file or set up
!   namelist parameters so it is not necessary. To do the latter, set
!   veg_to_use to something other than 'variable' in the namelist
!   land_properties_nml.
! </ERROR>

     call error_mesg('land_properties_init', 'Using dynamic cover type forcing data',NOTE)

! obtain the size on lon in the input data
     call field_size('INPUT/cover_type_field.nc', 'lon', siz)
     allocate (nlon_input(siz(1)))
     num_lon_input = size(nlon_input)

! obtain the size of lat in the input data
     call field_size('INPUT/cover_type_field.nc', 'lat', siz)
     allocate (nlat_input(siz(1)))
     num_lat_input = size(nlat_input)

! allocate arrays, read data as real and convert back to integer
     allocate (tmp(num_lon_input, num_lat_input, npart)) ! real temp array
     allocate (cover_type_input (num_lon_input, num_lat_input, npart))  ! input data

! check to make sure cover_dataset_entry has been entered
     if (cover_dataset_entry(1) == 1 .and. &
         cover_dataset_entry(2) == 1 .and. &
         cover_dataset_entry(3) == 1 .and. &
         cover_dataset_entry(4) == 0 .and. &
         cover_dataset_entry(5) == 0 .and. &
         cover_dataset_entry(6) == 0 )     &
       call error_mesg ('land_properties_mod', &
             'must set cover_dataset_entry when using dynamic cover type inputs', FATAL)
! <ERROR MSG="must set cover_dataset_entry when using dynamic cover type inputs" STATUS="FATAL">
! When specifying dynamic cover type forcing data inputs, the
! cover_dataset_entry time must be set.
! </ERROR>

! get the model initial time, current model time and cover type dataset time
     model_init_time = get_base_time()
     call get_date(model_init_time, init_yr, init_mo, init_dy, init_hr, init_mn, init_sc)
     call get_date(time, model_yr, model_mo, model_dy, model_hr, model_mn, model_sc)
     cover_entry  = set_date (cover_dataset_entry(1), &
                              cover_dataset_entry(2), &
                              cover_dataset_entry(3), &
                              cover_dataset_entry(4), &
                              cover_dataset_entry(5), &
                              cover_dataset_entry(6))


! calculate the initial timelevel to be read from the netcdf file
     kk = ( model_yr - init_yr ) +     &
          ( cover_dataset_entry(1) - cover_dataset_init_year )
     if (mpp_pe() == mpp_root_pe()) then
       write (outunit,'(a45,i4)')    &
          'The cover type dataset begins with year:', cover_dataset_init_year
       write (outunit,'(a40,i4)')    &
          'The cover type data year being read is:', cover_dataset_entry(1)
       write (outunit,'(a60,i4)')    &
          'This cover type data is mapped to current model year:', model_yr
       write (outunit,'(a42,i4)')    &
          'The model init year:', init_yr    
     endif

! read the initial cover type data from the netcdf file
     call read_data('INPUT/cover_type_field.nc','cover',tmp(:,:,1),  &
        timelevel=kk+1, no_domain=.true.)
     cover_type_input(:,:,1) = int(tmp(:,:,1))
   
! obtain the western boundary in the input data
     call field_size('INPUT/cover_type_field.nc', 'blon', siz)
     allocate (nblon_input(siz(1)))
     call read_data('INPUT/cover_type_field.nc','blon',nblon_input(:),timelevel=1,no_domain=.true.)

! regrid the data to the land model grid
     wb_degrees = (nblon_input(1))
     wb = pi*wb_degrees/180.
     dx = 2.*pi/float(num_lon_input)
     dy = pi/float(num_lat_input)     
     call regrid_discrete_field(cover_type_input(:,:,1), wb, sb, dx, dy, lonb,&
        latb, n_map_cover_types, land(:,:,1), cover_type(:,:,1) )
     deallocate (cover_type_input)


! if using the read_old_ascii_cover option, read the ASCII data file for cover
! type
   elseif (read_old_ascii_cover) then
     call error_mesg('land_properties_init', 'Using static ASCII cover type dataset',NOTE)
! <ERROR MSG="Using the static ASCII cover type dataset." STATUS="NOTE">
!   Using the read_old_ascii_cover option. Reading the ASCII cover type dataset.
! </ERROR>

     call mpp_open (unit, 'INPUT/cover_type_field', action = MPP_RDONLY)
     read (unit,*) num_lon_input, num_lat_input, wb_degrees
     read (unit,*) input_format
     allocate ( integer_input_1 (num_lon_input, num_lat_input) )
     do jj = 1, num_lat_input
        read(unit,input_format) (integer_input_1(ii,jj),ii=1,num_lon_input)
     end do
     close(unit)

     wb = pi*wb_degrees/180.
     dx = 2.*pi/float(num_lon_input)
     dy = pi/float(num_lat_input)
     call regrid_discrete_field(integer_input_1, wb, sb, dx, dy, lonb, latb, &
        n_map_cover_types, land(:,:,1), cover_type(:,:,1) )
     deallocate (integer_input_1)
     call close_file(unit)
  
! if not using dynamic_cover_type nor the read_old_ascii_cover option, use the
! static netcdf cover_type dataset if it exists
   elseif(file_exist('INPUT/cover_type_field.nc')) then

     call error_mesg('land_properties_init', 'Using the static netcdf cover type dataset',NOTE)
! <ERROR MSG="Using the static NetCDF cover type dataset." STATUS="NOTE">
!   Using the static NetCDF cover type dataset.
! </ERROR>

! obtain the size on lon in the input data
     call field_size('INPUT/cover_type_field.nc', 'lon', siz)
     allocate (nlon_input(siz(1)))
     num_lon_input = size(nlon_input)

! obtain the size of lat in the input data
     call field_size('INPUT/cover_type_field.nc', 'lat', siz)
     allocate (nlat_input(siz(1)))
     num_lat_input = size(nlat_input)

! allocate arrays, read data as real and convert back to integer
     allocate (tmp(num_lon_input, num_lat_input, npart)) ! real temp array
     allocate (cover_type_input (num_lon_input, num_lat_input, npart))  ! input data

     if (cover_dataset_entry(1) == 1 .and. &
         cover_dataset_entry(2) == 1 .and. &
         cover_dataset_entry(3) == 1 .and. &
         cover_dataset_entry(4) == 0 .and. &
         cover_dataset_entry(5) == 0 .and. &
         cover_dataset_entry(6) == 0 )     &
      call error_mesg ('land_properties_mod', &
     'must set cover_dataset_entry when using static_cover_type_netcdf', FATAL)
! <ERROR MSG="must set cover_dataset_entry when using time-varying cover type inputs" STATUS="FATAL">
! When specifying static_cover_type_netcdf forcing data inputs, the
! cover_dataset_entry time must be set.
! </ERROR>

! get the model initial time and cover type dataset time
     model_init_time = get_base_time()
     cover_entry  = set_date (cover_dataset_entry(1), &
                              cover_dataset_entry(2), &
                              cover_dataset_entry(3), &
                              cover_dataset_entry(4), &
                              cover_dataset_entry(5), &
                              cover_dataset_entry(6))

     if (mpp_pe() == mpp_root_pe()) then
       write (outunit,'(a45,i4)')      &
              'The cover type dataset begins with year:', cover_dataset_init_year
       write (outunit,'(a40,i4)')      &
              'The cover type data year being read is:', cover_dataset_entry(1)
     endif

! calculate the static timelevel to read from the NetCDF file 
     kk = cover_dataset_entry(1) - cover_dataset_init_year
     call read_data('INPUT/cover_type_field.nc','cover',tmp(:,:,1),timelevel=kk+1, no_domain=.true.)
     cover_type_input(:,:,1) = int(tmp(:,:,1))
   
! obtain the western boundary in the input data
     call field_size('INPUT/cover_type_field.nc', 'blon', siz)
     allocate (nblon_input(siz(1)))
     call read_data('INPUT/cover_type_field.nc','blon',nblon_input(:),timelevel=1, no_domain=.true.)

! regrid the data onto the land grid
     wb_degrees = (nblon_input(1))
     wb = pi*wb_degrees/180.
     dx = 2.*pi/float(num_lon_input)
     dy = pi/float(num_lat_input)     
     call regrid_discrete_field(cover_type_input(:,:,1), wb, sb, dx, dy, lonb,&
        latb, n_map_cover_types, land(:,:,1), cover_type(:,:,1) )
     deallocate (cover_type_input)

! if the static cover type forcing data option is chosen and the NetCDF file
! does not exist, read the GSWP2 cover type field in ASCII format
   else 
     call error_mesg('land_properties_init','Cannot find the netcdf file INPUT/cover_type_field. Using the ASCII file.',NOTE)
! <ERROR MSG="Cannot find the netCDF file INPUT/cover_type_field. Using the ASCII file." STATUS="NOTE">
!   The netCDF cover type field file cannot be found. Using the ASCII file.
! </ERROR>

     call mpp_open (unit, 'INPUT/cover_type_field', action = MPP_RDONLY)
     read (unit,*) num_lon_input, num_lat_input, wb_degrees
     read (unit,*) input_format
     allocate ( integer_input_1 (num_lon_input, num_lat_input) )
     do jj = 1, num_lat_input
        read(unit,input_format) (integer_input_1(ii,jj),ii=1,num_lon_input)
     end do
     close(unit)

     wb = pi*wb_degrees/180.
     dx = 2.*pi/float(num_lon_input)
     dy = pi/float(num_lat_input)
     call regrid_discrete_field(integer_input_1, wb, sb, dx, dy, lonb, latb, &
        n_map_cover_types, land(:,:,1), cover_type(:,:,1) )
     deallocate (integer_input_1)
     call close_file(unit)
  endif
endif

!--- update cover type
where (.not.land(:,:,1)) cover_type(:,:,1) = 0
  glacier(:,:,1) = .false.
where (cover_type(:,:,1).eq.veg_index_ice)
  glacier(:,:,1) = .true.
  cover_type(:,:,1) = veg_index_tundra
endwhere

!--- now re-define glacier mask, if necessary
if (.not.use_glaciers) then
   glacier(:,:,1) = .false.
else if (use_climap) then
  if(use_climap_mcm) then
     call get_climap_glacier_mcm(lonb, latb, gnlon, gnlat, is, is+size(land,1)-1, &
                js, js+size(land,2)-1, critical_glacier_albedo, glacier(:,:,1))
  else
     call get_climap_glacier(lonb, latb, critical_glacier_albedo, glacier(:,:,1))
  endif
  where (.not.land(:,:,1)) glacier(:,:,1) = .false.
endif

!--- next re-define cover type, if necessary, not yet worrying
!--- about glacier type
if (veg_to_use.eq.'constant') then
   cover_type(:,:,1) = 0
   where (land(:,:,1)) cover_type(:,:,1) = veg_index_constant
else if (veg_to_use.eq.'cons_tun') then
   cover_type(:,:,1) = 0
   where (land(:,:,1)) cover_type(:,:,1) = veg_index_tuned
else if (veg_to_use.eq.'cons_ssl') then
   cover_type(:,:,1) = 0
   where (land(:,:,1)) cover_type(:,:,1) = veg_index_ssl_veg
endif
!--- finally, assign appropriate cover type to glacier cells (if any)
if (veg_to_use.ne.'cons_ssl') then
   where (glacier(:,:,1)) cover_type(:,:,1) = veg_index_ice
else
   where (glacier(:,:,1)) cover_type(:,:,1) = veg_index_ssl_ice
endif

! call error_mesg ('land_properties_init', 'cover type defined', NOTE)
!  <NOTE>
!---- Ground (soil) type. To force consistency with glacier, already
! defined, any ice soil types are first re-set to coarse soil.
! ice types are then located on the basis of glacier. note that a distinct
! ice type is used only if soil_to_use='variable'; this is in contrast
! to the analogous treatment of vegetation types.
!  </NOTE>
if (soil_to_use .eq. 'variable') then
   if (.not.file_exist('INPUT/ground_type_field')) &
       call error_mesg('land_properties_init','Cannot find file INPUT/ground_type_field',FATAL)
! <ERROR MSG="Cannot find file INPUT/ground_type_field" STATUS="FATAL">
!   The ground (soil) type field file cannot be found. Provide this file or
!   set up namelist parameters so it is not necessary. To do the latter, set
!   soil_to_use to something other than 'variable' in the namelist
!   land_properties_nml.
! </ERROR>
   call mpp_open (unit, 'INPUT/ground_type_field', action = MPP_RDONLY)
   read (unit,*) num_lon_input, num_lat_input, wb_degrees
   read (unit,*) input_format
   allocate ( integer_input_1 (num_lon_input, num_lat_input) )
   do jj = 1, num_lat_input
      read(unit,input_format) (integer_input_1(ii,jj),ii=1,num_lon_input)
   end do
   close(unit)
   wb = pi*wb_degrees/180.
   dx = 2.*pi/float(num_lon_input)
   dy = pi/float(num_lat_input)
   if (soil_index_ice_substitute.eq.0) then
      where (integer_input_1.eq.soil_index_ice) integer_input_1 = 0
   endif
   call regrid_discrete_field(integer_input_1, wb, sb, dx, dy, lonb, latb, &
        n_map_ground_types, land(:,:,1), ground_type(:,:,1) )
   deallocate (integer_input_1)
   where (.not.land(:,:,1)) ground_type(:,:,1) = 0
   if (soil_index_ice_substitute.ne.0) then
      where (ground_type(:,:,1).eq.soil_index_ice) &
           ground_type(:,:,1) = soil_index_ice_substitute
   endif
   where (glacier(:,:,1)) ground_type(:,:,1) = soil_index_ice

   ! reconcile lake distribution in cover type and ground type fields
   if (reconcile_lakes) then
      where (ground_type(:,:,1).eq.soil_index_lake) &
           ground_type(:,:,1) = soil_index_lake_substitute
      where (cover_type(:,:,1).eq.veg_index_lake) &
           ground_type(:,:,1) = soil_index_lake
   endif
   
   call close_file(unit)
else if (soil_to_use .eq. 'constant') then
   ground_type(:,:,1) = 0
   where (land(:,:,1)) ground_type(:,:,1) = soil_index_constant
else if (soil_to_use .eq. 'cons_ssl') then
   ground_type(:,:,1) = 0
   where (land(:,:,1)) ground_type(:,:,1) = soil_index_ssl
endif

! call error_mesg ('land_properties_init', 'ground type defined', NOTE)

!---- groundwater residence time

if (use_single_geo) then
   where (land(:,:,1)) tau_groundwater(:,:,1) = geo_res_time
else
   if(.not.file_exist('INPUT/groundwater_residence_time_field')) &
      call error_mesg('land_properties_init','Cannot find file INPUT/groundwater_residence_time_field',FATAL)
! <ERROR MSG="Cannot find file INPUT/groundwater_residence_time_field" STATUS="FATAL">
! The groundwater residence time field file cannot be found. Provide this file
! or set up namelist parameters so it is not necessary. To do the latter, set
! use_single_geo to .true. in the namelist land_properties_nml.
! </ERROR>
   call mpp_open (unit,'INPUT/groundwater_residence_time_field', action = MPP_RDONLY)
   read (unit,*) num_lon_input, num_lat_input, wb_degrees
   read (unit,*) input_format
   allocate ( real_input (num_lon_input, num_lat_input) )
   do jj = 1, num_lat_input
      read(unit,input_format) (real_input(ii,jj),ii=1,num_lon_input)
   end do
   call close_file(unit)
   wb = pi*wb_degrees/180.
   dx = 2.*pi/float(num_lon_input)
   dy = pi/float(num_lat_input)
   call create_horiz_interp_new (Interp_gw, num_lon_input, num_lat_input, &
                                 wb, sb, dx, dy, lonb, latb)
   call horiz_interp ( Interp_gw, real_input, tau_groundwater(:,:,1) )
   deallocate (real_input)
endif

! call error_mesg ('land_properties_init', 'groundwater residence time defined', NOTE)

!---- river destination pointers


lake(:,:,1) = .false.
where (ground_type(:,:,1).eq.soil_index_lake) lake(:,:,1) = .true.

do ii = 2, npart
   glacier        (:,:,ii)  = glacier        (:,:,1)
   lake           (:,:,ii)  = lake           (:,:,1)
   cover_type     (:,:,ii)  = cover_type     (:,:,1)
   ground_type    (:,:,ii)  = ground_type    (:,:,1)
   tau_groundwater(:,:,ii)  = tau_groundwater(:,:,1)
end do
   
!---- assign properties that depend only on cover type -----------
veg_rs_min = 0
rough_momentum = 0
do i_cover_type = 1, n_dim_cover_types
   where (cover_type.eq.i_cover_type)
      albedo_min_no_snow  = min_nosnow_alb_vec(i_cover_type)
      albedo_max_no_snow  = max_nosnow_alb_vec(i_cover_type)
      veg_rs_min          = factor_stomata * veg_rs_min_vec    (i_cover_type)
      rough_momentum      = factor_rough   * rough_momentum_vec(i_cover_type)
      rough_heat          = factor_rough   * rough_momentum_vec(i_cover_type) &
           * exp(-k_over_B_vec(i_cover_type))
   endwhere
enddo

!---- compute or read the topographic roughness ----
if (use_topo_rough) then
   call set_topo_rough (domain, lonb, latb, topo_stdev)
   stdev = min(topo_stdev*topo_rough_factor,max_topo_rough)
   do k = 1,size(rough_momentum,3)
      rough_scale(:,:,k) = max(stdev,rough_momentum(:,:,k))
   end do
else
   rough_scale = rough_momentum
endif

!---- assign properties that depend only on ground type ----------
do i_ground_type = 1, n_dim_ground_types
   where (ground_type.eq.i_ground_type)
      soil_therm_con(:,:,:,1)  = soil_therm_dif_vec(i_ground_type) &
                       *soil_therm_cap_vec(i_ground_type)
      soil_therm_cap(:,:,:,1)  = soil_therm_cap_vec(i_ground_type)
   endwhere
enddo

do ii=2,size(soil_therm_con,4)
  where (land(:,:,:))
     soil_therm_con(:,:,:,ii) = soil_therm_con(:,:,:,1)
     soil_therm_cap(:,:,:,ii) = soil_therm_cap(:,:,:,1)
  endwhere
enddo

do ii=1,num_sfc_layers
  where (land(:,:,:))
     soil_therm_con(:,:,:,ii) = sfc_heat_factor * soil_therm_con(:,:,:,ii)
     soil_therm_cap(:,:,:,ii) = sfc_heat_factor * soil_therm_cap(:,:,:,ii)
  endwhere
enddo

!---- assign properties that depend on cover and ground types ----
max_water = 0
do i_cover_type = 1, n_dim_cover_types
   if ((i_cover_type .ne. veg_index_ice) .and. &
        (i_cover_type .ne. veg_index_ssl_ice)) then
      z_root = veg_zeta_vec(i_cover_type) &
           *log( veg_root_mass_vec(i_cover_type)/ &
           (veg_zeta_vec(i_cover_type)*factor_root*critical_root_density) )
      z_root = max(z_root_min, z_root)
      do i_ground_type = 1, n_dim_ground_types
         where (cover_type.eq.i_cover_type.and.ground_type.eq.i_ground_type)
            max_water = z_root * soil_awc_vec(i_ground_type)
         endwhere
      enddo
   endif
enddo
   
!---- change snow-free albedo to CLIMAP array if requested -------
!
if (use_climap) then
   allocate (real_input(nlon, nlat))
   if(use_climap_mcm) then
     call get_climap_albedo_mcm(lonb, latb, gnlon, gnlat, is, is+size(land,1)-1, &
                                js, js+size(land,2)-1, 1, real_input)
   else
     call get_climap_albedo(lonb, latb, 1, real_input)
   endif
   do ii = 1, npart
      albedo_min_no_snow(:,:,ii) = real_input
      albedo_max_no_snow(:,:,ii) = real_input
      if(use_climap_mcm) then
        where(glacier(:,:,ii))
          albedo_min_no_snow(:,:,ii) = min_nosnow_alb_vec(veg_index_ssl_ice)
          albedo_max_no_snow(:,:,ii) = max_nosnow_alb_vec(veg_index_ssl_ice)
        endwhere
      endif
   enddo
   deallocate (real_input)
elseif (use_desert_albedo_map) then
   allocate (real_input(nlon, nlat))
   call get_climap_albedo(lonb, latb, 5, real_input)
   do ii = 1, npart
      where (cover_type(:,:,ii).eq.veg_index_desert)
          albedo_min_no_snow(:,:,ii) = real_input
          albedo_max_no_snow(:,:,ii) = real_input
        endwhere
   enddo
   deallocate (real_input)

endif

max_snow_out = max_snow

! initialize land properties diagnostics
call init_land_properties_diag(id_lon, id_lat, time)

! send static fields for diagnostic manager for output
call diag_static(time, land)


end subroutine land_properties_init
! </SUBROUTINE>


!#######################################################################

! <SUBROUTINE NAME="update_land_properties_slow">

!   <OVERVIEW>
!     Updates slowly changing parameters, such as cover type.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Updates slowly changing parameters, such as cover type.
!   </DESCRIPTION>

!   <PUBLICROUTINE>
subroutine update_land_properties_slow ( &
     lonb,   latb,  land,  time,  domain, &
     glacier,         &
     lake,            &
     rough_momentum,  &
     rough_heat,      &
     rough_scale,     &  ! topographic roughness for drag scaling
     soil_therm_con,  &
     soil_therm_cap,  &
     veg_rs_min,      &
     max_water,       &
     tau_groundwater, &
     max_snow_out,    &
     cover_type )

  real,            intent(in) :: lonb(:,:), latb(:,:) ! corners of the cells,
                                                  ! radian
  logical,         intent(in) :: land(:,:,:)      ! land mask
  type(time_type), intent(in) :: time             ! current time
  type(domain2d),  intent(in) :: domain           ! our domain 

  logical, intent(out), dimension(:,:,:) :: glacier  ! glacier mask
  logical, intent(out), dimension(:,:,:) :: lake     ! lake mask
  real   , intent(out), dimension(:,:,:) :: &
       rough_momentum, &                  ! roughness length for momentum
       rough_heat,     &                
       rough_scale,    &
       veg_rs_min,     & 
       max_water,      &
       tau_groundwater                    ! groundwater residence time
  real   , intent(out), dimension(:,:,:,:) :: &
       soil_therm_con, &
       soil_therm_cap
  real   , intent(out)  :: max_snow_out
  integer, intent(inout), dimension(:,:,:)  :: cover_type
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer, allocatable :: integer_input_1(:,:)
  real,    allocatable :: real_input     (:,:)
  real,    allocatable :: tmp(:,:,:)  ! temp array for read data for cover_type
  integer, allocatable :: cover_type_input (:,:,:)  ! cover_type input data
  integer, allocatable :: nlon_input (:)     ! input data lon
  integer, allocatable :: nlat_input (:)     ! input data lat
  real,    allocatable :: nblon_input (:)    ! input data western boundary

  real, dimension(size(land,1),size(land,2)):: stdev ! standard deviation of
                                                     ! orography 
  logical got_stdev

  character*80            input_format
  integer :: unit, ierr, i_cover_type, i_ground_type, outunit
  integer :: ii, jj, num_lon_input, num_lat_input, k
  real    :: wb_degrees ! western boundary of the input grid cells
  real    :: sb, wb, dx, dy, z_root
  integer :: is, js     ! boundaries of our domain
  integer :: gnlon, gnlat
  integer :: siz(4)       ! size of field in field_size call
  integer :: model_yr, model_mo, model_dy, model_hr, model_mn, model_sc
  integer :: init_yr, init_mo, init_dy, init_hr, init_mn, init_sc
  integer :: kk           ! time loop integer for cover type data

! call only if using time-varying cover type
if (dynamic_cover_type) then

! Read and re-grid each land input data field

sb = -pi/2.

!  <NOTE>
!---- Cover (vegetation) type. There are 12 possible cases: veg_to_use can
! take 4 values, and glaciers can be (1) absent, (2) based on input cover
! field, or (3) based on climap albedo field. (use of climap albedo forces
! use of climap to locate glaciers, if glaciers are used.) the code
! ensures consistency between cover_type field and glacier mask, with
! the latter taking precedence: where glacier based on input cover field
! must be removed in deference to climap or if no glaciers are used,
! such points are assigned tundra (or global constant) type.
!  </NOTE>

!--- first get input cover field and implied glacier field, if either of
! these will be needed. then re-set ice cover type to tundra; it may be
! changed back to ice according to actual glacier specification later.
! If dynamic_cover_type_netcdf is chosen, then the cover_type will be obtained
! from a netCDF file of annual data. The initial year of the dataset is
! specified by the namelist option cover_dataset_init_year.
if ( veg_to_use.eq.'variable' &
     .or. (use_glaciers.and..not.use_climap) ) then
     if(.not.file_exist('INPUT/cover_type_field.nc')) &
       call error_mesg('land_properties_slow','Cannot find file INPUT/cover_type_field.nc',FATAL)

! <ERROR MSG="Cannot find file INPUT/cover_type_field.nc" STATUS="FATAL">
!   The cover type field file cannot be found. Provide this file or set up
!   namelist parameters so it is not necessary. To do the latter, set
!   veg_to_use to something other than 'variable' in the namelist
!   land_properties_nml.
! </ERROR>

! obtain the size on lon in the input data
     call field_size('INPUT/cover_type_field.nc', 'lon', siz)
     allocate (nlon_input(siz(1)))
     num_lon_input = size(nlon_input)

! obtain the size of lat in the input data
     call field_size('INPUT/cover_type_field.nc', 'lat', siz)
     allocate (nlat_input(siz(1)))
     num_lat_input = size(nlat_input)

! allocate arrays, read data as real and convert back to integer
     allocate (tmp(num_lon_input, num_lat_input, npart)) ! real temp array
     allocate (cover_type_input (num_lon_input, num_lat_input, npart))  ! input data
  
! get the current year of the model
     call get_date(model_init_time, init_yr, init_mo, init_dy, init_hr, init_mn, init_sc)
     call get_date(time, model_yr, model_mo, model_dy, model_hr, model_mn, model_sc)

! calculate the timelevel read from the netcdf file
     kk = ( model_yr - init_yr ) +     &
          ( cover_dataset_entry(1) - cover_dataset_init_year )
     if (mpp_pe() == mpp_root_pe()) then
       outunit = stdout()
       write (outunit,'(a45,i4)')      &
          'The cover type dataset begins with year:', cover_dataset_init_year
       write (outunit,'(a40,i4)')      &
          'The cover type data year being read is:', cover_dataset_entry(1)
       write (outunit,'(a60,i4)')      &
          'This cover type data is mapped to current model year:', model_yr
       write (outunit,'(a42,i4)')      &
          'The model init year:', init_yr     
     endif

! read the cover_type data from the netcdf file and covert it back to integer
     call read_data('INPUT/cover_type_field.nc','cover',tmp(:,:,1),timelevel=kk+1,no_domain=.true.)
     cover_type_input(:,:,1) = int(tmp(:,:,1))

! obtain the western boundary in the input data
     call field_size('INPUT/cover_type_field.nc', 'blon', siz)
     allocate (nblon_input(siz(1)))
     call read_data('INPUT/cover_type_field.nc','blon',nblon_input(:),timelevel=1,no_domain=.true.)

! regrid the data to the land grid and update the cover type
     wb_degrees = (nblon_input(1))
     wb = pi*wb_degrees/180.
     dx = 2.*pi/float(num_lon_input)
     dy = pi/float(num_lat_input)     
     call regrid_discrete_field(cover_type_input(:,:,1), wb, sb, dx, dy, lonb,&
        latb, n_map_cover_types, land(:,:,1), cover_type(:,:,1) )
     deallocate (cover_type_input)
     where (.not.land(:,:,1)) cover_type(:,:,1) = 0
     glacier(:,:,1) = .false.
     where (cover_type(:,:,1).eq.veg_index_ice)
       glacier(:,:,1) = .true.
       cover_type(:,:,1) = veg_index_tundra
     endwhere
endif

!--- next re-define cover type, if necessary, not yet worrying
!--- about glacier type
if (veg_to_use.eq.'constant') then
  cover_type(:,:,1) = 0
  where (land(:,:,1)) cover_type(:,:,1) = veg_index_constant
  else if (veg_to_use.eq.'cons_tun') then
   cover_type(:,:,1) = 0
   where (land(:,:,1)) cover_type(:,:,1) = veg_index_tuned
  else if (veg_to_use.eq.'cons_ssl') then
   cover_type(:,:,1) = 0
   where (land(:,:,1)) cover_type(:,:,1) = veg_index_ssl_veg
endif

!--- finally, assign appropriate cover type to glacier cells (if any)
if (veg_to_use.ne.'cons_ssl') then
  where (glacier(:,:,1)) cover_type(:,:,1) = veg_index_ice
else
  where (glacier(:,:,1)) cover_type(:,:,1) = veg_index_ssl_ice
endif

! call error_mesg ('land_properties_slow', 'cover type defined', NOTE)
!  <NOTE>
!---- Ground (soil) type. Any ice soil types are first re-set to coarse soil.
! ice types are then located on the basis of glacier. note that a distinct
! ice type is used only if soil_to_use='variable'; this is in contrast
! to the analogous treatment of vegetation types.
!  </NOTE>
if (soil_to_use .eq. 'variable') then
  if (.not.file_exist('INPUT/ground_type_field')) &
    call error_mesg('land_properties_slow','Cannot find file INPUT/ground_type_field',FATAL)
! <ERROR MSG="Cannot find file INPUT/ground_type_field" STATUS="FATAL">
!   The ground (soil) type field file cannot be found. Provide this file or
!   set up namelist parameters so it is not necessary. To do the latter, set
!   soil_to_use to something other than 'variable' in the namelist
!   land_properties_nml.
! </ERROR>
  call mpp_open (unit, 'INPUT/ground_type_field', action = MPP_RDONLY)
  read (unit,*) num_lon_input, num_lat_input, wb_degrees
  read (unit,*) input_format
  allocate ( integer_input_1 (num_lon_input, num_lat_input) )
  do jj = 1, num_lat_input
    read(unit,input_format) (integer_input_1(ii,jj),ii=1,num_lon_input)
  end do
  close(unit)

  wb = pi*wb_degrees/180.
  dx = 2.*pi/float(num_lon_input)
  dy = pi/float(num_lat_input)

  if (soil_index_ice_substitute.eq.0) then
    where (integer_input_1.eq.soil_index_ice) integer_input_1 = 0
  endif

  call regrid_discrete_field(integer_input_1, wb, sb, dx, dy, lonb, latb,&
     n_map_ground_types, land(:,:,1), ground_type(:,:,1) )
  deallocate (integer_input_1)
  where (.not.land(:,:,1)) ground_type(:,:,1) = 0
  if (soil_index_ice_substitute.ne.0) then
    where (ground_type(:,:,1).eq.soil_index_ice) &
       ground_type(:,:,1) = soil_index_ice_substitute
  endif
  where (glacier(:,:,1)) ground_type(:,:,1) = soil_index_ice
  call close_file(unit)
  else if (soil_to_use .eq. 'constant') then
    ground_type(:,:,1) = 0
    where (land(:,:,1)) ground_type(:,:,1) = soil_index_constant 
  else if (soil_to_use .eq. 'cons_ssl') then
    ground_type(:,:,1) = 0
    where (land(:,:,1)) ground_type(:,:,1) = soil_index_ssl
  endif

  ! reconcile lake distribution in cover type and ground type fields
  if (reconcile_lakes) then
     where (ground_type(:,:,1).eq.soil_index_lake) &
          ground_type(:,:,1) = soil_index_lake_substitute
     where (cover_type(:,:,1).eq.veg_index_lake) &
          ground_type(:,:,1) = soil_index_lake
  endif

  lake(:,:,1) = .false.
  where (ground_type(:,:,1).eq.soil_index_lake) lake(:,:,1) = .true.

! call error_mesg ('land_properties_slow', 'ground type defined', NOTE)

!---- groundwater residence time

  if (use_single_geo) then
    where (land(:,:,1)) tau_groundwater(:,:,1) = geo_res_time
  else
    if(.not.file_exist('INPUT/groundwater_residence_time_field')) &
     call error_mesg('land_properties_slow','Cannot find file INPUT/groundwater_residence_time_field',FATAL)
! <ERROR MSG="Cannot find file INPUT/groundwater_residence_time_field"
! STATUS="FATAL">
!   The groundwater residence time field file cannot be found. Provide this
!   file or set up namelist parameters so it is not necessary. To do the
!   latter, set use_single_geo to .true. in the namelist land_properties_nml.
! </ERROR>
     call mpp_open (unit,'INPUT/groundwater_residence_time_field', action = MPP_RDONLY)
     read (unit,*) num_lon_input, num_lat_input, wb_degrees
     read (unit,*) input_format
     allocate ( real_input (num_lon_input, num_lat_input) )
     do jj = 1, num_lat_input
       read(unit,input_format) (real_input(ii,jj),ii=1,num_lon_input)
     end do
     call close_file(unit)
     wb = pi*wb_degrees/180.
     dx = 2.*pi/float(num_lon_input)
     dy = pi/float(num_lat_input)
     ! initialized already
     !call create_horiz_interp_new (Interp_gw, num_lon_input, num_lat_input, &
     !                              wb, sb, dx, dy, lonb, latb )
     call horiz_interp ( Interp_gw, real_input, tau_groundwater(:,:,1) )
     deallocate (real_input)
endif

! call error_mesg ('land_properties_slow', 'groundwater residence time defined', NOTE)

!---- river destination pointers

   do ii = 2, npart
    lake           (:,:,ii)  = lake           (:,:,1)
    cover_type     (:,:,ii)  = cover_type     (:,:,1)
    ground_type    (:,:,ii)  = ground_type    (:,:,1)
    tau_groundwater(:,:,ii)  = tau_groundwater(:,:,1)
   end do
   
!---- assign properties that depend only on cover type -----------
   veg_rs_min = 0
   rough_momentum = 0
   do i_cover_type = 1, n_dim_cover_types
   where (cover_type.eq.i_cover_type)
      albedo_min_no_snow  = min_nosnow_alb_vec(i_cover_type)
      albedo_max_no_snow  = max_nosnow_alb_vec(i_cover_type)
      veg_rs_min          = factor_stomata * veg_rs_min_vec    (i_cover_type)
      rough_momentum      = factor_rough   * rough_momentum_vec(i_cover_type)
      rough_heat          = factor_rough   * rough_momentum_vec(i_cover_type) &
           * exp(-k_over_B_vec(i_cover_type))
   endwhere
   enddo

!---- compute or read the topographic roughness ----
if (use_topo_rough) then
   call set_topo_rough (domain, lonb, latb, topo_stdev)
   stdev = min(topo_stdev*topo_rough_factor,max_topo_rough)
   do k = 1,size(rough_momentum,3)
      rough_scale(:,:,k) = max(stdev,rough_momentum(:,:,k))
   end do
else
   rough_scale = rough_momentum
endif

!---- assign properties that depend only on ground type ----------
do i_ground_type = 1, n_dim_ground_types
   where (ground_type.eq.i_ground_type)
      soil_therm_con(:,:,:,1)  = soil_therm_dif_vec(i_ground_type) &
                       *soil_therm_cap_vec(i_ground_type)
      soil_therm_cap(:,:,:,1)  = soil_therm_cap_vec(i_ground_type)
   endwhere
enddo

do ii=2,size(soil_therm_con,4)
  where (land(:,:,:))
     soil_therm_con(:,:,:,ii) = soil_therm_con(:,:,:,1)
     soil_therm_cap(:,:,:,ii) = soil_therm_cap(:,:,:,1)
  endwhere
enddo

do ii=1,num_sfc_layers
  where (land(:,:,:))
     soil_therm_con(:,:,:,ii) = sfc_heat_factor * soil_therm_con(:,:,:,ii)
     soil_therm_cap(:,:,:,ii) = sfc_heat_factor * soil_therm_cap(:,:,:,ii)
  endwhere
enddo

!---- assign properties that depend on cover and ground types ----
max_water = 0
do i_cover_type = 1, n_dim_cover_types
   if ((i_cover_type .ne. veg_index_ice) .and. &
        (i_cover_type .ne. veg_index_ssl_ice)) then
      z_root = veg_zeta_vec(i_cover_type) &
           *log( veg_root_mass_vec(i_cover_type)/ &
           (veg_zeta_vec(i_cover_type)*factor_root*critical_root_density) )
      z_root = max(z_root_min, z_root)
      do i_ground_type = 1, n_dim_ground_types
         where (cover_type.eq.i_cover_type.and.ground_type.eq.i_ground_type)
            max_water = z_root * soil_awc_vec(i_ground_type)
         endwhere
      enddo
   endif
enddo
   
!---- change snow-free albedo to CLIMAP array if requested -------
!
if (use_climap) then
   allocate (real_input(nlon, nlat))
   if(use_climap_mcm) then
     call get_climap_albedo_mcm(lonb, latb, gnlon, gnlat, is, is+size(land,1)-1, &
                                js, js+size(land,2)-1, 1, real_input)
   else
     call get_climap_albedo(lonb, latb, 1, real_input)
   endif
   do ii = 1, npart
      albedo_min_no_snow(:,:,ii) = real_input
      albedo_max_no_snow(:,:,ii) = real_input
      if(use_climap_mcm) then
        where(glacier(:,:,ii))
          albedo_min_no_snow(:,:,ii) = min_nosnow_alb_vec(veg_index_ssl_ice)
          albedo_max_no_snow(:,:,ii) = max_nosnow_alb_vec(veg_index_ssl_ice)
        endwhere
      endif
   enddo
   deallocate (real_input)
elseif (use_desert_albedo_map) then
   allocate (real_input(nlon, nlat))
   call get_climap_albedo(lonb, latb, 5, real_input)
   do ii = 1, npart
      where (cover_type(:,:,ii).eq.veg_index_desert)
          albedo_min_no_snow(:,:,ii) = real_input
          albedo_max_no_snow(:,:,ii) = real_input
        endwhere
   enddo
   deallocate (real_input)

endif

max_snow_out = max_snow
endif

end subroutine update_land_properties_slow
! </SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="update_land_properties_fast">

!   <OVERVIEW>
!     Updates the rapidly changing parameters, such as albedo.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Updates the rapidly changing parameters. Computes the albedo of
!     hypothetical no-snow and deep-snow surfaces and uses snow mass to blend
!     snow-free and deep-snow albedo values.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call update_land_properties_fast (snowmass, t_sfc, land, albedo)
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine update_land_properties_fast (snowmass, t_sfc, land, albedo, cover_type)

!-----------------------------------------------------------------------
!
! INPUT
!    snowmass     = mass of snow on the ground (in kg/(m**2))
!    t_sfc        = surface temperature (in degrees kelvin)
!    land         = logical land mask
! 
!  OUTPUT
!    albedo       = surface albedo

real,    intent(in),  dimension(:,:,:) :: snowmass, t_sfc
logical, intent(in) , dimension(:,:,:) :: land
real,    intent(out), dimension(:,:,:) :: albedo
integer, intent(in),  dimension(:,:,:) :: cover_type
!-----------------------------------------------------------------------
!   </PUBLICROUTINE>

integer :: i_cover_type
real    :: t_crit
real   , dimension(size(t_sfc,1),size(t_sfc,2),size(t_sfc,3)) ::  &
                   albedo_no_snow, albedo_hi_snow, blend

!---- albedo update ----------------------------------------------------

!--- compute albedo of hypothetical no-snow and deep-snow surfaces

t_crit = tfreeze - t_range
blend = (t_sfc - t_crit) / t_range
where (blend .lt. 0.) blend = 0.
where (blend .gt. 1.) blend = 1.

where (land(:,:,:))
   albedo_no_snow = albedo_max_no_snow                            &
    + blend * (albedo_min_no_snow - albedo_max_no_snow)
endwhere

do i_cover_type = 1, n_dim_cover_types
  where (cover_type.eq.i_cover_type)
    albedo_hi_snow = max_snow_alb_vec(i_cover_type) + blend    &
      * (min_snow_alb_vec(i_cover_type)                        &
         - max_snow_alb_vec(i_cover_type) )
  endwhere
enddo

!--- use snow mass to blend snow-free and deep-snow albedo values

if (do_mcm_masking) then
    blend = 0.
    do i_cover_type = 1, n_dim_cover_types
      where (cover_type.eq.i_cover_type) &
           blend = 0.5 * sqrt(snowmass/crit_snowmass_vec(i_cover_type))
      enddo
    where (blend .gt. 1.) blend = 1.
  else
    blend = 0.
    do i_cover_type = 1, n_dim_cover_types
      where (cover_type.eq.i_cover_type) &
           blend = snowmass/(snowmass+crit_snowmass_vec(i_cover_type))
      enddo
  endif

where (cover_type.gt. 0) albedo = albedo_no_snow  &
             + (albedo_hi_snow - albedo_no_snow) * blend

end subroutine update_land_properties_fast
! </SUBROUTINE>

! <SUBROUTINE NAME="regrid_discrete_field">

!   <OVERVIEW>
!     Regrids integer index data to any output grid from a uniformly spaced
!     grid using a maximum-area voting scheme.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Regrids integer index data to any output grid from a uniformly spaced
!     grid using a maximum-area voting scheme.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call regrid_discrete_field (data_in, wb_in, sb_in, dlon_in, dlat_in, &
!     lon_out, lat_out, ntype, mask_out, data_out, mask_in)
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine regrid_discrete_field (data_in, wb_in, sb_in, dlon_in, dlat_in, &
     lon_out, lat_out, ntype, &   
     mask_out, data_out, mask_in)

!-----------------------------------------------------------------------
!  input:
!  -----
!     data_in     input data; dimensioned by mdim x ndim
!                      stored from south to north
!     wb_in      longitude corresponding to western boundary of box i=1
!     sb_in      latitude corresponding to southern boundary of box j=1
!     dlon_in    x axis grid spacing in degrees of longitude
!     dlat_in    y axis grid spacing in degrees of latitude
!
!     lon_out   longitudes of output data at grid box corners
!                  dimensioned by size(data_out,1)+1 by size(data_out,2)+1
!     lat_out   latitudes of output data at grid box corners
!                  dimensioned by size(data_out,1)+1 by size(data_out,2)+1
!     ntype     number of land cover types specified
!     mask_out  output mask that specifies where the data are defined
!
!  output:
!  ------
!     data_out     output number of land cover type
!
!  optional
!  --------
!     mask_in   input mask;  =0.0 for data points that should not
!               be used or have no data; has the same size as data_in
!
!-----------------------------------------------------------------------
  integer, intent(in)           :: ntype
  integer, intent(in)           :: data_in(:,:)
  real,    intent(in)           :: sb_in,wb_in, dlat_in, dlon_in
  real,    intent(in)           :: lon_out(:,:), lat_out(:,:)
  logical, intent(in)           :: mask_out(:,:)
  integer, intent(out)          :: data_out(:,:)
  real,    intent(in), optional :: mask_in(:,:)
!   </PUBLICROUTINE>

  if (is_latlon(lon_out,lat_out)) then
     call regrid_discrete_field_latlon (data_in, wb_in, sb_in, dlon_in, dlat_in, &
                   lon_out(:,1), lat_out(1,:), ntype, mask_out, data_out, mask_in)
  else
     call regrid_discrete_field_cube   (data_in, wb_in, sb_in, dlon_in, dlat_in, &
                   lon_out(:,:), lat_out(:,:), ntype, mask_out, data_out, mask_in)
  endif

end subroutine regrid_discrete_field
! </SUBROUTINE>


! <SUBROUTINE NAME="regrid_discrete_field_latlon">
subroutine regrid_discrete_field_latlon (data_in, wb_in, sb_in, dlon_in, dlat_in, &
                                         lon_out, lat_out, ntype, &   
                                         mask_out, data_out, mask_in)
  integer, intent(in)           :: ntype
  integer, intent(in)           :: data_in(:,:)
  real,    intent(in)           :: sb_in,wb_in, dlat_in, dlon_in
  real,    intent(in)           :: lon_out(:), lat_out(:)
  logical, intent(in)           :: mask_out(:,:)
  integer, intent(out)          :: data_out(:,:)
  real,    intent(in), optional :: mask_in(:,:)

  ! --- local vars -----------------------------------------------------
  real,    dimension(size(data_in,2)) :: area_in
  real,    dimension(size(lat_out(:))) :: ph
!  real,    dimension(ntype) :: sumtype
!  real,    dimension(size(data_out,1),size(data_out,2)) :: totarea
  integer, dimension(size(data_out,1)) :: is,ie
  integer, dimension(size(data_out,2)) :: js,je,jsave
  real,    dimension(size(data_out,1)) :: fis,fie,facis,facie
  real,    dimension(size(data_out,2)) :: fjs,fje,facjs,facje,fsave

  integer  i,j,mdim,ndim,m360,nlon,nlat
  integer  ismin,iemax, iis,iie,jjs,jje, kk
  real     ratlat,ratlon,hpie,phs,phn, dsph
  real     ffacis,ffacie,ffacjs,ffacje
  logical  flip, enlarge

  integer, allocatable :: data(:,:)
  real,    allocatable :: area(:,:)

  hpie= pi/2.0
  mdim=size(data_in,1); ndim=size(data_in,2)
  m360=int(4.*hpie/dlon_in + 0.001)
  if (mdim < m360) call error_mesg ('regrid_discrete_field',  &
       'inner dimension for input data is too small.', FATAL)
  
!   <ERROR MSG="inner dimension for input data is too small." STATUS="FATAL">
!   </ERROR>  

  !   --- input (hires) grid resolution ---
  ratlat=1.0/dlat_in
  ratlon=1.0/dlon_in

  !   --- area of input (hires) grid boxes ---
  do j=1,ndim
     phs=sb_in + float(j-1)*dlat_in
     phn=sb_in + float(j)  *dlat_in
     phs=min(phs, hpie); phs=max(phs,-hpie)
     phn=min(phn, hpie); phn=max(phn,-hpie)
     dsph=sin(phn)-sin(phs)
     area_in(j) = dsph * dlon_in
  enddo

  !-----------------------------------------------------------------------

  nlon=size(data_out,1); nlat=size(data_out,2)

  !***********************************************************************

  !------ set up latitudinal indexing ------
  !------ make sure output grid goes south to north ------
  
  if (lat_out(1) < lat_out(nlat+1)) then
     ph(1:nlat+1) = lat_out(1:nlat+1)
     flip = .false.
  else
     ph(1:nlat+1) = lat_out(nlat+1:1:-1)
     flip = .true.
  endif

  fjs(1:nlat)=(ph(1:nlat  )-sb_in)*ratlat+1.0
  fje(1:nlat)=(ph(2:nlat+1)-sb_in)*ratlat+1.0

  js=fjs
  where (fjs < 0.) js=js-1
  where (js  < 1 ) js=1

  je=fje
  where (fje < 0.  ) je=je-1
  where (je  > ndim) je=ndim

  facjs=float(js+1)-fjs
  facje=fje-float(je)

  if (flip) then
     jsave=js; js(1:nlat)=jsave(nlat:1:-1)
     jsave=je; je(1:nlat)=jsave(nlat:1:-1)
     fsave=facjs; facjs(1:nlat)=fsave(nlat:1:-1)
     fsave=facje; facje(1:nlat)=fsave(nlat:1:-1)
  endif

  !------ set up longitudinal indexing ------

  fis(1:nlon)=(lon_out(1:nlon  )-wb_in)*ratlon+1.0
  fie(1:nlon)=(lon_out(2:nlon+1)-wb_in)*ratlon+1.0

  is=fis
  where (fis < 0.) is=is-1
  ie=fie
  where (fie < 0.) ie=ie-1

  facis=float(is+1)-fis
  facie=fie-float(ie)
  
  !----- allocate expanded data arrays ------
  
  ismin=min(minval(is),1)
  iemax=max(maxval(ie),mdim)

  allocate (data(ismin:iemax,1:ndim), area(ismin:iemax,1:ndim))

  data(1:mdim,1:ndim) = data_in(1:mdim,1:ndim)

  if (ismin < 1) then
     data(ismin:0, 1:ndim) = data_in(ismin+mdim:mdim, 1:ndim)
  endif
  if (iemax > mdim) then
     data(mdim+1:iemax, 1:ndim) =  data_in(1:iemax-mdim, 1:ndim)
  endif
  
  do j = 1,ndim
     area(:,j) = area_in(j)
  enddo
  
  if (present(mask_in)) then
     area(1:mdim,1:ndim) = area(1:mdim,1:ndim)*mask_in(1:mdim,1:ndim)
     if (ismin < 1)  &
          area(ismin:0, 1:ndim) = area(ismin+mdim:mdim, 1:ndim)
     if (iemax > mdim)  &
          area(mdim+1:iemax, 1:ndim) = area(1:iemax-mdim, 1:ndim)
  endif
  !-----------------------------------------------------------------------

  !     totarea=0.
  do j=1,nlat
     do i=1,nlon
        iis = is(i)
        iie = ie(i)
        jjs = js(j)
        jje = je(j)
        ffacis = facis(i)
        ffacie = facie(i)
        ffacjs = facjs(j)
        ffacje = facje(j)
        kk = 1
522     enlarge = .false.
        if (mask_out(i,j)) call typemax (data(iis:iie,jjs:jje), &
             area(iis:iie,jjs:jje), &
             ffacis,ffacie,ffacjs,ffacje,&
             ntype,data_out(i,j),enlarge)
        !         totarea(i,j)=sum(area(iis:iie,jjs:jje))
        
        if(is(i)-kk.le.1.and.ie(i)+kk.ge.mdim.and. &
             js(j)-kk.le.1.and.je(j)+kk.ge.ndim) goto 523
        
        if(enlarge) then
           if(is(i)-kk.ge.1) iis = is(i)-kk        
           if(ie(i)+kk.le.mdim) iie = ie(i)+kk
           if(js(j)-kk.ge.1) jjs = js(j)-kk
           if(je(j)+kk.le.ndim) jje = je(j)+kk
           ffacis = 1.
           ffacie = 1.
           ffacjs = 1.
           ffacje = 1.          
           kk=kk+1
           go to 522
        end if
523     continue
     enddo
  enddo

!      sumtype = 0.
!      do j=1,nlat
!      do i=1,nlon
!        do kk = 1, ntype
!          if(data_out(i,j).eq.kk) sumtype(kk)=sumtype(kk)+totarea(i,j)
!        end do  
!      enddo
!      enddo
!write(*,*)'ntype=',ntype
!do i = 1, ntype
!  write(*,*)'type,areatype=',i,sumtype(i)
!end do


  deallocate(data, area)

end subroutine regrid_discrete_field_latlon
! </SUBROUTINE>

! <SUBROUTINE NAME="create_horiz_interp_new">

  subroutine create_horiz_interp_new (Interp, nx, ny, wb, sb, dx, dy, lonb_out, latb_out, is_latlon_out)
  type(horiz_interp_type), intent(inout) :: Interp
  integer, intent(in) :: nx, ny
  real,    intent(in) :: wb, sb, dx, dy, lonb_out(:,:), latb_out(:,:)
  logical, intent(in), optional :: is_latlon_out
  real    :: lonb_in(nx+1), latb_in(ny+1), tpi
  integer :: i, j

     tpi = 2.*PI

     ! longitude boundaries
     do i = 1, nx+1
       lonb_in(i) = wb + float(i-1)*dx
     enddo
       if (abs(lonb_in(nx+1)-lonb_in(1)-tpi) < epsilon(lonb_in)) &
               lonb_in(nx+1)=lonb_in(1)+tpi

     ! latitude boundaries
     do j = 2, ny
       latb_in(j) = sb + float(j-1)*dy
     enddo
       latb_in(1)    = -0.5*PI
       latb_in(ny+1) =  0.5*PI

     call horiz_interp_new (Interp, lonb_in, latb_in, &
                                    lonb_out, latb_out, is_latlon_out=is_latlon_out)

  end subroutine create_horiz_interp_new

! </SUBROUTINE>


! <SUBROUTINE NAME="typemax">

!   <OVERVIEW>
!     Calculation of total area of each land cover type within the territory
!     and the determination of the type occupying the biggest area within the
!     territory.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Calculation of total area of each land cover type within the territory
!     and the determination of the type occupying the biggest area within the
!     territory.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call typemax(data,area,facis,facie,facjs,facje,ntype,ntypemax,enlarge)
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine typemax(data,area,facis,facie,facjs,facje,ntype,ntypemax,enlarge)

  integer, intent(in)    :: data(:,:)
  real,    intent(in)    :: facis,facie,facjs,facje
  real,    intent(in)    :: area(:,:)
  integer, intent(in)    :: ntype   
  integer, intent(out)   :: ntypemax ! number of land cover type to be assigned
                                     ! to the entire grid cell; 
  logical, intent(inout) :: enlarge  ! says if it's necessary to repeat the
                                     ! process for a larger area
!   </PUBLICROUTINE>

  ! --- local vars -----------------------------------------------------
  integer itype,id,jd,i,j  
  real, dimension(size(area,1),size(area,2)) :: wt
  real, dimension(ntype) :: sumarea     


  id=size(area,1); jd=size(area,2)
  
  wt = area
  wt( 1,:)=wt( 1,:)*facis
  wt(id,:)=wt(id,:)*facie
  wt(:, 1)=wt(:, 1)*facjs
  wt(:,jd)=wt(:,jd)*facje

! Calculation of total area of each land cover type within the territory:
  sumarea = 0.
  do i = 1, id
  do j = 1, jd
    do itype = 1, ntype
      if(int(data(i,j)).eq.itype) sumarea(itype)=sumarea(itype)+wt(i,j)
    end do
  end do
  end do

! Determination of the type occupying the biggest area within the territory:
  ntypemax = 0
    do itype = 1, ntype
      if(maxval(sumarea).eq.sumarea(itype).and.sumarea(itype).gt.0.) &
                ntypemax = itype
    end do

! Check if the land cover type is defined or not (ntypemax = 0  means  
! ocean or undefined type)
  if(ntypemax.eq.0) enlarge = .true.

end subroutine typemax
! </SUBROUTINE>

! <SUBROUTINE NAME="regrid_discrete_field_cube">

!   <OVERVIEW>
!     Regrids integer index data to any output grid from a uniformly spaced
!     grid using a maximum-area voting scheme.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Regrids integer index data to any output grid from a uniformly spaced
!     grid using a maximum-area voting scheme.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call regrid_discrete_field_cube (data_in, wb_in, sb_in, dlon_in, dlat_in, &
!     lon_out, lat_out, ntype, mask_out, data_out, mask_in)
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine regrid_discrete_field_cube (data_in, wb_in, sb_in, dlon_in, dlat_in, &
     lon_out, lat_out, ntype, mask_out, data_out, mask_in)

!-----------------------------------------------------------------------
!  input:
!  -----
!     data_in     input data; dimensioned by mdim x ndim
!                      stored from south to north
!     wb_in      longitude corresponding to western boundary of box i=1
!     sb_in      latitude corresponding to southern boundary of box j=1
!     dlon_in    x axis grid spacing in degrees of longitude
!     dlat_in    y axis grid spacing in degrees of latitude
!
!     lon_out   longitudes of output data at grid box boundaries
!                  dimensioned by size(data_out,1)+1
!     lat_out   latitudes of output data at grid box boundaries
!                  dimensioned by size(data_out,2)+1
!     ntype     number of land cover types specified
!     mask_out  output mask that specifies where the data are defined
!
!  output:
!  ------
!     data_out     output number of land cover type
!
!  optional
!  --------
!     mask_in   input mask;  =0.0 for data points that should not
!               be used or have no data; has the same size as data_in
!
!-----------------------------------------------------------------------
  integer, intent(in)           :: ntype
  integer, intent(in)           :: data_in(:,:)
  real,    intent(in)           :: sb_in, wb_in, dlat_in, dlon_in
  real,    intent(in)           :: lon_out(:,:), lat_out(:,:)
  logical, intent(in)           :: mask_out(:,:)
  integer, intent(out)          :: data_out(:,:)
  real,    intent(in), optional :: mask_in(:,:)
!   </PUBLICROUTINE>

  ! --- local vars -----------------------------------------------------
  real :: lonb(2,2), latb(2,2)
  integer :: data1(1,1)
  logical :: mask1(1,1)
  integer :: i, j, np

  integer :: n, mdim, ndim, m360
  real    :: hpie

  type(horiz_interp_type) :: Interp


  ! setup interpolation
  mdim = size(data_in,1)
  ndim = size(data_in,2)

  hpie = pi/2.0
  m360 = int(4.*hpie/dlon_in + 0.001)
  if (mdim < m360) call error_mesg ('regrid_discrete_field_cube',  &
       'inner dimension for input data is too small.', FATAL)
!   <ERROR MSG="inner dimension for input data is too small." STATUS="FATAL">
!   </ERROR>  

  call create_horiz_interp_new (Interp, mdim, ndim, wb_in, sb_in, dlon_in, dlat_in, lon_out, lat_out)

  !-----------------------------------------------------------------------
  ! loop thru number of types
  ! at each grid box find the type with the largest weight (i.e., area)

  call regrid_discrete_field_base (Interp, data_in, ntype, mask_out, data_out, mask_in)
  call horiz_interp_del (Interp)

  !-----------------------------------------------------------------------
  !if (count(mask_out.and.data_out==0) > 0) then
  !   print *, 'Bad discrete points, pe, nbad = ',mpp_pe(),count(mask_out.and.data_out==0)
  !endif
  ! search for missing/bad points
  do j = 1, size(data_out,2)
  do i = 1, size(data_out,1)
     if (mask_out(i,j) .and. data_out(i,j) == 0) then
        ! Initial grid box
        lonb = lon_out(i:i+1,j:j+1)
        latb = lat_out(i:i+1,j:j+1)
        mask1 = mask_out(i,j)
        np = 0
        do
           ! grow the grid box
           call expand_cell (lonb,latb,1.5)
           ! create a new interp type
           call create_horiz_interp_new (Interp, mdim, ndim, wb_in, sb_in, dlon_in, dlat_in, lonb, latb, is_latlon_out=.false.)
           call regrid_discrete_field_base (Interp, data_in, ntype, mask1, data1, mask_in)
           call horiz_interp_del (Interp)
           np = np+1
           if (data1(1,1) /= 0) then
              data_out(i,j)=data1(1,1)
             !print *, 'Fixed discrete point: pe, np = ',mpp_pe(),np
              exit
           endif
           if (np > 10) then
              print *, 'orig lon = ', lon_out(i:i+1,j:j+1)
              print *, 'orig lat = ', lat_out(i:i+1,j:j+1)
              print *, 'curr lon = ', lonb
              print *, 'curr lat = ', latb
              call error_mesg ('regrid_discrete_field_cube', 'failed to fix discrete point', FATAL)
           endif
        enddo
     endif
  enddo
  enddo

  !-----------------------------------------------------------------------

end subroutine regrid_discrete_field_cube
! </SUBROUTINE>

! <SUBROUTINE NAME="regrid_discrete_field_base">

subroutine regrid_discrete_field_base (Intrp, data_in, ntype, mask_out, data_out, mask_in)
  type(horiz_interp_type), intent(inout) :: Intrp
  integer, intent(in)           :: ntype
  integer, intent(in)           :: data_in(:,:)
  logical, intent(in)           :: mask_out(:,:)
  integer, intent(out)          :: data_out(:,:)
  real,    intent(in), optional :: mask_in(:,:)

  ! --- local vars ---
  real,    dimension(size(data_in,1), size(data_in,2))  :: wt_in
  real,    dimension(size(data_out,1),size(data_out,2)) :: wt_max, wt_out
  integer :: n

  ! loop thru number of types
  ! at each grid box find the type with the largest weight (i.e., area)

  data_out = 0
  wt_max = 0.
  do n = 1, ntype
     where (data_in == n)
        wt_in = 1.
     elsewhere
        wt_in = 0.
     endwhere
     if (present(mask_in)) then
        wt_in = wt_in * mask_in
     endif

     call horiz_interp (Intrp, wt_in, wt_out)

     where (mask_out .and. wt_out > wt_max)
        wt_max = wt_out
        data_out = n
     endwhere
  enddo

end subroutine regrid_discrete_field_base

! </SUBROUTINE>

! <SUBROUTINE NAME="set_topo_rough">

 subroutine set_topo_rough (domain, lonb, latb, topo_stdev)
 type(domain2d), intent(in) :: domain
 real,           intent(in),  dimension(:,:) :: lonb, latb
 real,           intent(out), dimension(:,:) :: topo_stdev
 logical :: got_stdev
 integer :: unit, nc
 character(len=128) :: topo_file_base

!   <ERROR MSG="could not read topography data" STATUS="FATAL">
!     get_topog_stdev failed to provide topography variance data.
!   </ERROR>  
!   <ERROR MSG="input file for topography standard deviation ... does not exist" STATUS="FATAL">
!     topo_rough_source is set to 'input', but input file name either
!     not specified or specified incorrectly, so the program cannot 
!     find it.
!   </ERROR>
!   <ERROR MSG="... is not a valid value for topo_rough_source" STATUS="FATAL">
!     specified value of namelist parameter topo_rough_source is invalid; 
!     valid values are 'computed', 'input' or 'input/computed'.
!   </ERROR>

   if (trim(topo_rough_source) == 'computed') then
      got_stdev = get_topog_stdev(lonb,latb,topo_stdev)
      if (.not.got_stdev) &
           call error_mesg ('land_properties_mod', &
           'could not read topography data', FATAL)
   else if (trim(topo_rough_source)=='input' .or. trim(topo_rough_source)=='input/computed') then
      nc = len_trim(topo_rough_file)
      topo_file_base = topo_rough_file(1:nc-3)
      if (file_exist(topo_rough_file) .or. file_exist(trim(topo_file_base)//'.tile1.nc')) then
         call set_domain(domain)
         call read_data (topo_rough_file,topo_rough_var,topo_stdev)
      else if (file_exist(topo_file_base)) then
         unit = open_restart_file(topo_file_base,'read')
         call read_data(unit,topo_stdev)
         call close_file(unit)
      else
         if (trim(topo_rough_source)=='input') then
             call error_mesg('land_properties_mod',                    &
                     'input file for topography standard deviation "'// &
                      trim(topo_rough_file)//'" does not exist', FATAL)
         else
             got_stdev = get_topog_stdev(lonb,latb,topo_stdev)
             if (.not.got_stdev) &
                       call error_mesg ('land_properties_mod', &
                       'could not read topography data', FATAL)
         endif
      endif
   else
      call error_mesg('land_properties_mod','"'//trim(topo_rough_source)//&
           '" is not a valid value for topo_rough_source', FATAL)
   endif

 end subroutine set_topo_rough

! </SUBROUTINE>

! <SUBROUTINE NAME="init_land_properties_diag">

!   <OVERVIEW>
!      Initializes land properties diagnostics.
!   </OVERVIEW>

!   <DESCRIPTION>
!      Initializes land properties diagnostics.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call init_land_properties_diag (id_lon, id_lat, Time)
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine init_land_properties_diag (id_lon, id_lat, Time)

  integer,         intent(in) :: id_lon  ! ID of land longitude (X) axis  
  integer,         intent(in) :: id_lat  ! ID of land longitude (X) axis
  type(time_type), intent(in) :: Time    ! current time
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer :: axes(2)

  axes = (/id_lon, id_lat/)
  id_alb_max = register_static_field(diag_mod_name, "albedo_max_no_snow", axes, &
       "max. snow-free land albedo","dimensionless", missing_value=-1.0)
  id_alb_min = register_static_field(diag_mod_name, "albedo_min_no_snow", axes, &
       "min. snow-free land albedo","dimensionless", missing_value=-1.0)
  id_ground_type = register_static_field(diag_mod_name,"ground_type", axes, &
       "land surface ground type", "dimensionless", missing_value = -1.0)

end subroutine init_land_properties_diag
! </SUBROUTINE>

! <DIAGFIELDS>
!   <NETCDF NAME="albedo_max_no_snow" UNITS="dimensionless">
!     Maximum snow-free land albedo
!   </NETCDF>
!   <NETCDF NAME="albedo_min_no_snow" UNITS="dimensionless">
!     Minimum snow-free land albedo
!   </NETCDF>
!   <NETCDF NAME="cover_type" UNITS="dimensionless">
!     Land surface cover type
!   </NETCDF>
!   <NETCDF NAME="ground_type" UNITS="dimensionless">
!     Land surface ground type
!   </NETCDF>
! </DIAGFIELDS>


! <SUBROUTINE NAME="diag_static">

!   <OVERVIEW>
!     Sends static fields to diagnostic output.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Sends static fields to diagnostic output.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call diag_static ( Time,mask )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine diag_static ( Time,mask )

  type(time_type), intent(in) :: Time
  logical,         intent(in) :: mask(:,:,:)
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  logical :: used
  real    :: dummy (size(mask,1), size(mask,2))

  if (id_alb_max > 0) &
       used = send_data ( id_alb_max, albedo_max_no_snow(:,:,1), Time, mask=mask(:,:,1) )
  if (id_alb_min > 0) &
       used = send_data ( id_alb_min, albedo_min_no_snow(:,:,1), Time, mask=mask(:,:,1) )
  if (id_ground_type > 0) then
     dummy = ground_type(:,:,1)
     used = send_data (id_ground_type, dummy, Time, mask=mask(:,:,1))
  endif

end subroutine diag_static
! </SUBROUTINE>


!=============================================================================

! <SUBROUTINE NAME="land_properties_end">

!   <OVERVIEW>
!     Deallocates the land property data.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Deallocates the land property data.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call land_properties_end()
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine land_properties_end()
!   </PUBLICROUTINE>

  module_is_initialized =.FALSE.

  deallocate(ground_type, albedo_min_no_snow, albedo_max_no_snow)

end subroutine land_properties_end
! </SUBROUTINE>

end module land_properties_mod

module polvani_2007_mod

! Lorenzo Polvani, and J. Esler:
! Transport and mixing of chemical airmasses in idealized baroclinic life cycles
! J. Geophys. Res., 112, D23102, 10.1029/2007JD008555, 2007.

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use               mpp_mod, only: mpp_error, FATAL

use               fms_mod, only: mpp_pe, mpp_root_pe, stdlog, stdout, lowercase, &
                                 write_version_number, close_file, check_nml_error

use         constants_mod, only: PI,    &
                                 GRAV,  & ! GRAV=9.800, not 9.806 as specified by Polvani
                                 RDGAS, & ! RDGAS=287.04, not 287.00 as specified by Polvani
                                 OMEGA, & ! same as specified by Polvani
                                 RADIUS,& ! same as specified by Polvani
                                 KAPPA    ! same as specified by Polvani

use   vert_coordinate_mod, only: compute_vert_coord

use        transforms_mod, only: get_grid_boundaries, get_sin_lat, get_cos_lat, trans_grid_to_spherical, &
                                 trans_spherical_to_grid, get_wts_lat, get_lon_max, get_lat_max, get_deg_lon, &
                                 get_deg_lat, vor_div_from_uv_grid, uv_grid_from_vor_div, get_grid_domain, grid_domain

use  press_and_geopot_mod, only: press_and_geopot_init, pressure_variables, compute_pressures_and_heights

use      diag_manager_mod, only: diag_axis_init, register_static_field, send_data

use       tracer_type_mod, only: tracer_type

use     field_manager_mod, only: MODEL_ATMOS

use    tracer_manager_mod, only: get_number_tracers, get_tracer_names

implicit none
private

character(len=128), parameter :: version='$Id: polvani_2007.F90,v 19.0 2012/01/06 20:35:37 fms Exp $'
character(len=128), parameter :: tagname='$Name: tikal $'

public :: polvani_2007, polvani_2007_tracer_init, get_polvani_2007_tracers

character(len=12), parameter :: mod_name='polvani_2007'

real,    parameter :: P00=1.e5        ! Used to compute potential temperature.
integer, parameter :: num_iter=10     ! Number of iterations in computation of surface pressure. (Overkill -- only 3 or 4 would do)
integer, parameter :: num_p2007_tr=11 ! Number of tracers associated with polvani_2007 initialization.
                                      ! Additional tracers may be defined elsewhere in the model. There is no conflict. 

integer :: id_LC2_Pstar, id_LC2_Tstar, id_LC2_U1star, id_LC2_U2star, id_LC2_Ustar, id_LC2_lapse00
logical :: used
integer :: i, j, k, lon_max, lat_max, is, ie, js, je, num_levels
integer :: id_LC1_u, id_LC1_pot_t, id_LC1_t, id_perturb, id_Tss, id_Uss, id_LC2_u, id_LC2_pot_t, id_LC2_t
real    :: du_dz, ln_slp, ztmp

real, allocatable, dimension(:,:) :: LC1_u, LC1_t, LC1_pot_t, LC2_u, LC2_t, LC2_pot_t
real, allocatable, dimension(:,:) :: dTdy, Uss, Tss, perturbation
real, allocatable, dimension(:)   :: sin_lat, tan_lat, coriolis, latb, rad_lat, fy1, fy2
real, allocatable, dimension(:)   :: LC2_Tstar, LC2_U1star, LC2_U2star, LC2_Ustar, LC2_Zstar
real, allocatable, dimension(:)   :: deg_lon, lonb, deg_lat, rad_lon, wts_lat, cos_lat
real, allocatable, dimension(:)   :: fz, dfz_dz, lon_factor, lat_factor, z
real, allocatable, dimension(:)   :: LC1_psurf, LC2_psurf
real, allocatable, dimension(:)   :: LC1_p_full, LC1_ln_p_full, LC1_p_half, LC1_ln_p_half
real, allocatable, dimension(:,:) :: LC2_p_full, LC2_ln_p_full, LC2_p_half, LC2_ln_p_half
real, allocatable, dimension(:)   :: trop_strat_boundary

real, allocatable, dimension(:,:,:) :: p2007_tr ! The tracers associated with polvani_2007 initialization.

character(len=15), parameter, dimension(num_p2007_tr) :: p2007_tr_name =   &
(/'polvani_2007_ov','polvani_2007_s1','polvani_2007_s2','polvani_2007_s3', &
  'polvani_2007_t1','polvani_2007_t2','polvani_2007_t3','polvani_2007_un', &
  'polvani_2007_bp','polvani_2007_b0','polvani_2007_bm'/)

character(len=31), parameter, dimension(num_p2007_tr) :: p2007_tr_longname =   &
(/'overworld tracer               ','high middleworld strat tracer  ','center middleworld strat tracer', &
  'low middleworld strat tracer   ','high middleworld trop tracer   ','center middleworld trop tracer ', &
  'low middleworld trop tracer    ','underworld tracer              ', 'high boundary layer tracer     ',&
  'canonical boundary layer tracer','low boundary layer tracer      '/)

! press_diag is the pressure levels used for diagnostic meta data.
! In the LC2 case they are not the actual model pressure levels.
real, allocatable, dimension(:) :: press_diag

character(len=8) :: type_of_init = 'LC1     ' ! 'LC1' or 'LC2'
real :: T_hat = 1.0      ! deg K ------------- Amplitude of temperature perturbation
integer :: m = 6         ! dimensionless ----- Zonal wavenumber of temperature perturbation
real :: theta_hat = 45.  ! degrees latitude -- Latitude center of temperature perturbation
real :: H  = 7.5e3       ! meters
real :: U0 = 45.         ! m/sec
real :: sigma_top = .02  ! dimensionless
real :: zt = 13.e3       ! meters
real :: lapse = -6.5e-3  ! deg K/meter
real :: T0 = 300.        ! deg K
real :: alpha = 10.      ! dimensionless
real :: Us = 45.         ! m/sec
real :: zs = 1.e4        ! meters
real :: theta_s = 35.    ! degrees latitude -- Center of the second term of the zonal wind profile for LC2 ("us" in equation (8) of the paper)
real :: delta_s = 20.    ! degrees latitude -- Width of same

namelist / polvani_2007_nml / type_of_init, T_hat, m, theta_hat, H, U0, &
                              sigma_top, zt, lapse, T0, alpha, Us, zs, theta_s, delta_s

contains

!=================================================================================================================================

subroutine polvani_2007(triang_trunc, vert_difference_option, pk, bk, &
                   vors, divs, ts, ln_ps, ug, vg, tg, psg, vorg, divg, surf_geopotential)

logical, intent(in) :: triang_trunc 
character(len=*), intent(in) :: vert_difference_option
real,    intent(out), dimension(:) :: pk, bk
complex, intent(out), dimension(:,:,:) :: vors, divs, ts
complex, intent(out), dimension(:,:  ) :: ln_ps
real,    intent(out), dimension(:,:,:) :: ug, vg, tg
real,    intent(out), dimension(:,:  ) :: psg
real,    intent(out), dimension(:,:,:) :: vorg, divg
real,    intent(out), dimension(:,:  ) :: surf_geopotential

real, dimension(size(ug,1), size(ug,2)) :: ln_psg
integer :: id_lon, id_lat, id_press, ntmp, id_iter, unit, ierr, io
real :: ln_sigma_top, riter(num_iter)

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=polvani_2007_nml, iostat=io)
    ierr = check_nml_error(io, 'polvani_2007_nml')
#else
    unit = open_namelist_file()
    ierr=1
    do while (ierr /= 0)
      read(unit, nml=polvani_2007_nml, iostat=io, end=20)
      ierr = check_nml_error (io, 'polvani_2007_nml')
    enddo
20  call close_file (unit)
#endif
call write_version_number(version, tagname)
if(mpp_pe() == mpp_root_pe()) write (stdlog(), nml=polvani_2007_nml)

call get_lon_max(lon_max)
call get_lat_max(lat_max)
num_levels = size(ug,3)
ntmp = nint(.46875*lat_max)
if(num_levels /= ntmp) then
  call mpp_error(FATAL,'Number of vertical levels must be ',ntmp, &
                ' when using polvani_2007 initialization with ',lat_max,' latitude rows')
endif
pk = 0.0
bk(1) = sigma_top
ln_sigma_top = alog(bk(1))
do k=2,num_levels
  bk(k) = exp((1.0 - (k-1)/float(num_levels))*ln_sigma_top)
enddo
bk(num_levels+1) = 1.0

surf_geopotential = 0.0

allocate(rad_lon(lon_max), deg_lon(lon_max), lon_factor(lon_max))
allocate(rad_lat(lat_max), deg_lat(lat_max), lat_factor(lat_max), trop_strat_boundary(lat_max))
allocate(wts_lat(lat_max), sin_lat(lat_max), cos_lat(lat_max), tan_lat(lat_max))
allocate(coriolis(lat_max), latb(lat_max+1), lonb(lon_max+1), z(num_levels+1))
allocate(LC1_u(lat_max,num_levels+1), dTdy(lat_max,num_levels+1), Uss(lat_max,num_levels+1))
allocate(LC1_pot_t(lat_max,num_levels+1), LC1_t(lat_max,num_levels+1), Tss(lat_max,num_levels+1))
allocate(LC2_u(lat_max,num_levels+1), LC2_pot_t(lat_max,num_levels+1), LC2_t(lat_max,num_levels+1))
allocate(perturbation(lon_max,lat_max), press_diag(num_levels+1))
allocate(fz(num_levels+1), dfz_dz(num_levels+1), fy1(lat_max), fy2(lat_max))
allocate(LC2_Tstar(lat_max), LC2_U1star(lat_max), LC2_U2star(lat_max), LC2_Ustar(lat_max), LC2_Zstar(lat_max))
allocate(LC1_psurf(lat_max), LC2_psurf(lat_max))
allocate(LC1_p_full(num_levels),   LC1_ln_p_full(num_levels))
allocate(LC1_p_half(num_levels+1), LC1_ln_p_half(num_levels+1))
allocate(LC2_p_full(lat_max,num_levels),   LC2_ln_p_full(lat_max,num_levels))
allocate(LC2_p_half(lat_max,num_levels+1), LC2_ln_p_half(lat_max,num_levels+1))
allocate(p2007_tr(lat_max,num_levels,num_p2007_tr))

call press_and_geopot_init(pk, bk, .false., vert_difference_option)
call pressure_variables(LC1_p_half, LC1_ln_p_half, LC1_p_full, LC1_ln_p_full, P00)
call get_deg_lon(deg_lon)
rad_lon = PI*deg_lon/180.
call get_deg_lat(deg_lat)
rad_lat = PI*deg_lat/180.
trop_strat_boundary = 1500*(55-deg_lat) ! units=meters (only used in the narrow latitude range of about 45 to 52 degrees north)
call get_wts_lat(wts_lat)
call get_sin_lat(sin_lat)
call get_cos_lat(cos_lat)
tan_lat = sin_lat/cos_lat
call get_grid_boundaries(lonb, latb, global=.true.) ! units = radians
coriolis = 2*OMEGA*sin_lat
ln_slp = log(P00)

riter = (/(i,i=1,num_iter)/)
press_diag(1:num_levels) = .01*LC1_p_full
press_diag(num_levels+1) = .01*LC1_p_half(num_levels+1)
id_press = diag_axis_init('p_full',press_diag,'hPa','z','pressure level',direction=-1)
id_lon   = diag_axis_init('lon',deg_lon,'degrees E','x','longitude')
id_lat   = diag_axis_init('lat',deg_lat,'degrees N','y','latitude')
id_iter  = diag_axis_init('iter',riter,'hPa','z','iteration')
id_LC1_u     = register_static_field(mod_name,'LC1_zonal_wind', (/id_lat,id_press/),'initial LC1 zonal wind', 'm/sec')
id_LC1_t     = register_static_field(mod_name,'LC1_temperature',(/id_lat,id_press/),'initial LC1 temperature', 'K')
id_LC1_pot_t = register_static_field(mod_name,'LC1_pot_temp',   (/id_lat,id_press/),'initial LC1 potential temperature','K')
id_Tss       = register_static_field(mod_name,'Tss',            (/id_lat,id_press/),'Tss temperature', 'K')
id_Uss       = register_static_field(mod_name,'Uss',            (/id_lat,id_press/),'Uss zonal wind', 'm/sec')
id_LC2_u     = register_static_field(mod_name,'LC2_zonal_wind', (/id_lat,id_press/),'initial LC2 zonal wind', 'm/sec')
id_LC2_t     = register_static_field(mod_name,'LC2_temperature',(/id_lat,id_press/),'initial LC2 temperature', 'K')
id_LC2_pot_t = register_static_field(mod_name,'LC2_pot_temp',   (/id_lat,id_press/),'initial LC2 potential temperature','K')
id_perturb   = register_static_field(mod_name,'perturbation',   (/id_lon,id_lat/),  'initial temperature perturbation','K')
id_LC2_Pstar = register_static_field(mod_name,'LC2_Pstar',      (/id_lat/),         'initial surface pressure','hPa')
id_LC2_Tstar = register_static_field(mod_name,'LC2_Tstar',      (/id_lat/),         'initial surface temperature','K')
id_LC2_U1star= register_static_field(mod_name,'LC2_U1star',     (/id_lat/),         'initial surface LC1 wind', 'm/sec')
id_LC2_U2star= register_static_field(mod_name,'LC2_U2star',     (/id_lat/),         'initial surface LC2 wind', 'm/sec')
id_LC2_Ustar = register_static_field(mod_name,'LC2_Ustar',      (/id_lat/),         'initial surface wind',     'm/sec')
id_LC2_lapse00=register_static_field(mod_name,'LC2_lapse00',    (/id_lat/),         'initial surface lapse rate','K/m')

call compute_LC1
call compute_LC2
call compute_perturbation

do j=1,lat_max
  do k=1,num_levels+1
    if(k == num_levels+1) then
      LC1_pot_t(j,k) = LC1_t(j,k)
    else
      LC1_pot_t(j,k) = LC1_t(j,k)*(P00/LC1_p_full(k))**KAPPA
    endif
  enddo
enddo
if(id_LC1_u     > 0) used = send_data(id_LC1_u, LC1_u)
if(id_LC1_t     > 0) used = send_data(id_LC1_t, LC1_t)
if(id_LC1_pot_t > 0) used = send_data(id_LC1_pot_t, LC1_pot_t)
if(id_perturb   > 0) used = send_data(id_perturb,  perturbation)

call get_grid_domain(is, ie, js, je)

if(trim(type_of_init) == 'LC1') then
  do k=1,num_levels
    do i=1,size(ug,1)
      ug(i,:,k) = LC1_u(js:je,k)
      tg(i,:,k) = LC1_t(js:je,k)
    enddo
  enddo
  do j=1,size(ug,2)
    psg(:,j) = LC1_psurf(js+j-1)
  enddo
  call compute_p2007_tr(LC1_t,LC1_psurf)
else if(trim(type_of_init) == 'LC2') then
  do k=1,num_levels
    do i=1,size(ug,1)
      ug(i,:,k) = LC2_u(js:je,k)
      tg(i,:,k) = LC2_t(js:je,k)
    enddo
  enddo
  do j=1,size(ug,2)
    psg(:,j) = LC2_psurf(js+j-1)
  enddo
  call compute_p2007_tr(LC2_t,LC2_psurf)
else
  call mpp_error(FATAL,trim(type_of_init)//' is not a valid type_of_init for polvani_2007')
endif

do j=1,size(ug,2)
  do i=1,size(ug,1)
    tg(i,j,:) = tg(i,j,:) + perturbation(is+i-1,js+j-1)
  enddo
enddo

vg = 0.0

! Transform grid fields to spherical waves then transform
! back to ensure that spectral and grid representations match.

call trans_grid_to_spherical(tg, ts)
call trans_spherical_to_grid(ts, tg)
call vor_div_from_uv_grid(ug, vg, vors, divs, triang=triang_trunc)
call uv_grid_from_vor_div(vors, divs, ug, vg)
call trans_spherical_to_grid(vors, vorg)
call trans_spherical_to_grid(divs, divg)
ln_psg = alog(psg)
call trans_grid_to_spherical(ln_psg, ln_ps)
call trans_spherical_to_grid(ln_ps,  ln_psg)
psg = exp(ln_psg)

return
end subroutine polvani_2007
!=================================================================================================================================
subroutine compute_LC1

real :: Tr

do k=1,num_levels+1
  if(k == num_levels+1) then
    z(k) = 0.0
  else
    z(k) = H*(ln_slp - LC1_ln_p_full(k))
  endif
  ztmp = z(k)/zt
  fz(k) = ztmp*exp(-0.5*(ztmp**2 - 1))
  dfz_dz(k) = ((1 - ztmp**2)/zt)*exp(-0.5*(ztmp**2 - 1))
enddo

do j=1,lat_max
  if(sin_lat(j) > 0.0) then
    fy1(j) = (sin(PI*sin_lat(j)**2))**3
  else
    fy1(j) = 0.0
  endif
enddo

do k=1,num_levels+1
  do j=1,lat_max
    LC1_u(j,k) = U0*fy1(j)*fz(k)
    du_dz   = U0*fy1(j)*dfz_dz(k)
    dTdy(j,k) = -(H/RDGAS) * (RADIUS*coriolis(j) + 2*LC1_u(j,k)*tan_lat(j)) * du_dz
  enddo
enddo

! The k loop below computes the integral of equation A4 in the paper.
! The inner loop over latitude does the actual integration.
do k=1,num_levels+1
  do j=1,lat_max
    if(j == 1) then
      LC1_t(j,k) = dTdy(j,k)*(rad_lat(j)-latb(j))
    else
      LC1_t(j,k) = LC1_t(j-1,k) + dTdy(j-1,k)*(latb(j)-rad_lat(j-1)) + dTdy(j,k)*(rad_lat(j)-latb(j))
    endif
  enddo
enddo
do k=1,num_levels+1
  if(k == num_levels+1) then
    Tr = T0
  else
    Tr = T0 + lapse/(zt**-alpha + z(k)**-alpha)**(1./alpha)
  endif
  LC1_t(:,k) = Tr + LC1_t(:,k)
enddo

LC1_psurf = P00

end subroutine compute_LC1
!=================================================================================================================================
subroutine compute_perturbation
    
do i=1,lon_max
  lon_factor(i) = cos(m*rad_lon(i))
enddo
ztmp = PI*theta_hat/180
do j=1,lat_max
  lat_factor(j) = 1.0/cosh(m*(rad_lat(j)-ztmp))**2
enddo
do j=1,lat_max 
  do i=1,lon_max
    perturbation(i,j) = T_hat*lon_factor(i)*lat_factor(j)
  enddo
enddo

end subroutine compute_perturbation
!=================================================================================================================================
subroutine compute_LC2

do k=1,num_levels+1
  fz(k) = exp(-z(k)/zs)
  dfz_dz(k) = -fz(k)/zs
enddo

do j=1,lat_max
  fy2(j) = (sin(2*rad_lat(j))**2)*((deg_lat(j)-theta_s)/delta_s)*exp(-((deg_lat(j)-theta_s)/delta_s)**2)
enddo

do k=1,num_levels+1
  do j=1,lat_max
    Uss(j,k) = -Us*fy2(j)*fz(k)
    du_dz    = -Us*fy2(j)*dfz_dz(k)
    dTdy(j,k) = -(H/RDGAS) * (RADIUS*coriolis(j) + 2*Uss(j,k)*tan_lat(j)) * du_dz
  enddo
enddo

! The k loop below computes the integral of equation A4 in the paper.
! The inner loop over latitude does the actual integration.
do k=1,num_levels+1
  do j=1,lat_max
    if(j == 1) then
      Tss(j,k) = dTdy(j,k)*(rad_lat(j)-latb(j))
    else
      Tss(j,k) = Tss(j-1,k) + dTdy(j-1,k)*(latb(j)-rad_lat(j-1)) + dTdy(j,k)*(rad_lat(j)-latb(j))
    endif
  enddo
enddo

if(id_Uss > 0) used = send_data(id_Uss, Uss)
if(id_Tss > 0) used = send_data(id_Tss, Tss)

LC2_u = LC1_u + Uss
LC2_t = LC1_t + Tss

! Surface pressure for LC2 is not constant.
! The paper does not desribe the details of how it is computed, so I concocted my own scheme to do it.
! I have isolated this calculation by putting it in a separate subroutine.
call compute_surf_press

call pressure_variables(LC2_p_half, LC2_ln_p_half, LC2_p_full, LC2_ln_p_full, LC2_psurf)

do j=1,lat_max
  do k=1,num_levels+1
    if(k == num_levels+1) then
      LC2_pot_t(j,k) = LC2_t(j,k)
    else
      LC2_pot_t(j,k) = LC2_t(j,k)*(P00/LC2_p_full(j,k))**KAPPA
    endif
  enddo
enddo
if(id_LC2_u     > 0) used = send_data(id_LC2_u, LC2_u)
if(id_LC2_t     > 0) used = send_data(id_LC2_t, LC2_t)
if(id_LC2_pot_t > 0) used = send_data(id_LC2_pot_t, LC2_pot_t)

return
end subroutine compute_LC2
!=================================================================================================================================
subroutine compute_surf_press

real, allocatable, dimension(:,:) :: Zstar     ! Zstar = H*alog(P00/psurf)
real, allocatable, dimension(:) :: af          ! af = RADIUS*coriolis
real, allocatable, dimension(:) :: dzstar_dy   ! derivative of Zstar with respect to latitude
real, allocatable, dimension(:) :: LC2_lapse00 ! lapse rate at pressure level P00
real, allocatable, dimension(:) :: dlapse00_dy ! derivative of LC2_lapse00 with respect to latitude
real :: rms, c1, c2, e, sqrt_e
integer :: j, itr

allocate(Zstar(lat_max,0:num_iter), af(lat_max), dzstar_dy(lat_max), dlapse00_dy(lat_max), LC2_lapse00(lat_max))
af = RADIUS*coriolis
e = exp(1.0)
sqrt_e = sqrt(e)
c1 = 2*e*(U0/zt)**2
c2 = Us/zs**2

do j=1,lat_max
  if(sin_lat(j) > 0.0) then
    dlapse00_dy(j) = c1*tan_lat(j)*fy1(j)**2 - (af(j) - 2*Us*fy2(j)*tan_lat(j))*c2*fy2(j)
  else
    dlapse00_dy(j) = 0.0
  endif
enddo
dlapse00_dy = -(H/RDGAS)*dlapse00_dy
do j=1,lat_max
  if(j == 1) then
    LC2_lapse00(j) = dlapse00_dy(j)*(rad_lat(j)-latb(j))
  else
    LC2_lapse00(j) = LC2_lapse00(j-1) + dlapse00_dy(j-1)*(latb(j)-rad_lat(j-1)) + dlapse00_dy(j)*(rad_lat(j)-latb(j))
  endif
enddo
LC2_lapse00 = LC2_lapse00 + lapse

! Zstar is computed by an iterative method. The zonal momentum equation for the
! surface winds is integrated from pole to pole each interation. Temperature and
! zonal wind are expressed as a Taylor series expansion about z=0, i.e., Pressure = P00.
Zstar(:,0) = 0.0
do itr=1,num_iter
  do j=1,lat_max
    LC2_Tstar(j)  = LC2_t(j,num_levels+1) + LC2_lapse00(j)*Zstar(j,itr-1)
    LC2_U1star(j) = U0*sqrt_e*fy1(j)*Zstar(j,itr-1)/zt
    LC2_U2star(j) = (Zstar(j,itr-1)/zs - 1)*Us*fy2(j)
    LC2_Ustar(j)  = LC2_U1star(j) + LC2_U2star(j)
    if(sin_lat(j) > 0.0) then
      dzstar_dy(j) = H*LC2_Ustar(j)*(af(j) + LC2_Ustar(j)*tan_lat(j)) / (RDGAS*LC2_Tstar(j))
    else
      dzstar_dy(j) = 0.0
    endif
  enddo
  do j=1,lat_max
    if(j == 1) then
      Zstar(j,itr) = dzstar_dy(j)*(rad_lat(j)-latb(j))
    else
      Zstar(j,itr) = Zstar(j-1,itr) + dzstar_dy(j-1)*(latb(j)-rad_lat(j-1)) + dzstar_dy(j)*(rad_lat(j)-latb(j))
    endif
  enddo
  rms = 0.0
  do j=1,lat_max
    rms = rms + (Zstar(j,itr) - Zstar(j,itr-1))**2
  enddo
  rms = sqrt(rms/lat_max)
  write(stdout(),'("Convergence of surface pressure for polvani_2007 LC2: iteration=",i2,"  rms=",1pe16.8)') itr,rms
enddo

LC2_Zstar = Zstar(:,num_iter)

do j=1,lat_max
  LC2_psurf(j) = P00*exp(-Zstar(j,num_iter)/H)
enddo

if(id_LC2_Pstar  > 0) used = send_data(id_LC2_Pstar,  LC2_psurf)
if(id_LC2_Tstar  > 0) used = send_data(id_LC2_Tstar,  LC2_Tstar )
if(id_LC2_U1star > 0) used = send_data(id_LC2_U1star, LC2_U1star)
if(id_LC2_U2star > 0) used = send_data(id_LC2_U2star, LC2_U2star)
if(id_LC2_Ustar  > 0) used = send_data(id_LC2_Ustar,  LC2_Ustar )
if(id_LC2_lapse00> 0) used = send_data(id_LC2_lapse00,LC2_lapse00)
deallocate(Zstar, af, dzstar_dy, dlapse00_dy, LC2_lapse00)

end subroutine compute_surf_press
!=================================================================================================================================
subroutine polvani_2007_tracer_init(tg, psg, surface_geopotential, tracers)

real, dimension(:,:,:),     intent(in)  :: tg
real, dimension(:,:),       intent(in)  :: psg, surface_geopotential
real, dimension(:,:,:,:,:), intent(out) :: tracers

real,    dimension(is:ie,js:je,num_levels)   :: z_full, p_full, pot_t
real,    dimension(is:ie,js:je,num_levels+1) :: z_half, p_half
integer, dimension(is:ie,js:je,num_levels)   :: world ! overworld=0, high middleworld=1, center middleworld=2, low middleworld=3, underworld=4
logical, dimension(is:ie,js:je,num_levels)   :: strat ! .true. if above tropopause, .false. if below. 

integer :: ntr, num_tracers, ntr_o, ntr_s1, ntr_s2, ntr_s3, ntr_t1, ntr_t2, ntr_t3, ntr_u
character(len=128) :: tname, longname, units

call compute_pressures_and_heights(tg, psg, surface_geopotential, z_full, z_half, p_full, p_half)
do k=1,num_levels
  do j=js,je
    do i=is,je
      pot_t(i,j,k) = tg(i,j,k)*(P00/p_full(i,j,k))**KAPPA
      if(pot_t(i,j,k) >= 380.) then
        world(i,j,k) = 0
      else if(pot_t(i,j,k) >= 350. .and. pot_t(i,j,k) < 380.) then
        world(i,j,k) = 1
      else if(pot_t(i,j,k) > 320. .and. pot_t(i,j,k) < 350.) then
        world(i,j,k) = 2
      else if(pot_t(i,j,k) > 290. .and. pot_t(i,j,k) <= 320.) then
        world(i,j,k) = 3
      else
        world(i,j,k) = 4
      endif
      if(z_full(i,j,k) > trop_strat_boundary(j)) then
        strat(i,j,k) = .true.
      else
        strat(i,j,k) = .false.
      endif
    enddo
  enddo
enddo

ntr_o=0; ntr_s1=0; ntr_s2=0; ntr_s3=0; ntr_t1=0; ntr_t2=0; ntr_t3=0; ntr_u=0
call get_number_tracers(MODEL_ATMOS, num_prog=num_tracers)
do ntr=1,num_tracers
  call get_tracer_names(MODEL_ATMOS, ntr, tname, longname, units)
  if(trim(lowercase(tname)) == 'polvani_2007_o') then
    ntr_o = ntr
    tracers(:,:,:,:,ntr) = 0.0
  else if(trim(lowercase(tname)) == 'polvani_2007_s1') then
    ntr_s1 = ntr
    tracers(:,:,:,:,ntr) = 0.0
  else if(trim(lowercase(tname)) == 'polvani_2007_s2') then
    ntr_s2 = ntr
    tracers(:,:,:,:,ntr) = 0.0
  else if(trim(lowercase(tname)) == 'polvani_2007_s3') then
    ntr_s3 = ntr
    tracers(:,:,:,:,ntr) = 0.0
  else if(trim(lowercase(tname)) == 'polvani_2007_t1') then
    ntr_t1 = ntr
    tracers(:,:,:,:,ntr) = 0.0
  else if(trim(lowercase(tname)) == 'polvani_2007_t2') then
    ntr_t2 = ntr
    tracers(:,:,:,:,ntr) = 0.0
  else if(trim(lowercase(tname)) == 'polvani_2007_t3') then
    ntr_t3 = ntr
    tracers(:,:,:,:,ntr) = 0.0
  else if(trim(lowercase(tname)) == 'polvani_2007_u') then
    ntr_u = ntr
    tracers(:,:,:,:,ntr) = 0.0
  endif
enddo

do k=1,num_levels
  do j=js,je
    do i=is,je
      if(world(i,j,k) == 0 .and. ntr_o > 0) then
        tracers(i,j,k,:,ntr_o) = 1.0
      else if(world(i,j,k) == 1) then
        if(strat(i,j,k)) then
          if(ntr_s1 > 0) tracers(i,j,k,:,ntr_s1) = 1.0
        else
          if(ntr_t1 > 0) tracers(i,j,k,:,ntr_t1) = 1.0
        endif
      else if(world(i,j,k) == 2) then
        if(strat(i,j,k)) then
          if(ntr_s2 > 0) tracers(i,j,k,:,ntr_s2) = 1.0
        else
          if(ntr_t2 > 0) tracers(i,j,k,:,ntr_t2) = 1.0
        endif
      else if(world(i,j,k) == 3) then
        if(strat(i,j,k)) then
          if(ntr_s3 > 0) tracers(i,j,k,:,ntr_s3) = 1.0
        else
          if(ntr_t3 > 0) tracers(i,j,k,:,ntr_t3) = 1.0
        endif
      else if(world(i,j,k) == 4 .and. ntr_u > 0) then
        tracers(i,j,k,:,ntr_u) = 1.0
      endif
    enddo
  enddo
enddo

end subroutine polvani_2007_tracer_init
!=================================================================================================================================

subroutine compute_p2007_tr(temp, surfp)
real, dimension(lat_max,num_levels), intent(in) :: temp
real, dimension(lat_max),            intent(in) :: surfp

real, dimension(lat_max)              :: surf_geopotential
real, dimension(lat_max,num_levels  ) :: pot_t, z_full, p_full
real, dimension(lat_max,num_levels+1) :: z_half, p_half
integer :: world(lat_max,num_levels) ! overworld=0, high middleworld=1, center middleworld=2, low middleworld=3, underworld=4
logical :: strat(lat_max,num_levels) ! .true. if above tropopause, .false. if below
character(len=15) :: tname
integer :: ntr, id_tr, id_latitude, id_pfull, axes(2)

surf_geopotential = 0.0
call compute_pressures_and_heights(temp, surfp, surf_geopotential, z_full, z_half, p_full, p_half)
do k=1,num_levels
  do j=1,lat_max
    pot_t(j,k) = temp(j,k)*(P00/p_full(j,k))**KAPPA
    if(pot_t(j,k) >= 380.) then
      world(j,k) = 0
    else if(pot_t(j,k) >= 350. .and. pot_t(j,k) < 380.) then
      world(j,k) = 1
    else if(pot_t(j,k) > 320. .and. pot_t(j,k) < 350.) then
      world(j,k) = 2
    else if(pot_t(j,k) > 290. .and. pot_t(j,k) <= 320.) then
      world(j,k) = 3
    else
      world(j,k) = 4
    endif
    if(z_full(j,k) > trop_strat_boundary(j)) then
      strat(j,k) = .true.
    else
      strat(j,k) = .false.
    endif
  enddo
enddo

p2007_tr = 0.0
do ntr=1,num_p2007_tr
  tname = p2007_tr_name(ntr)
  do k=1,num_levels
    do j=1,lat_max

      if(world(j,k) == 0 .and. tname == 'polvani_2007_ov') then
        p2007_tr(j,k,ntr) = 1.0
      else if(world(j,k) == 1) then
        if(strat(j,k)) then
          if(tname == 'polvani_2007_s1') p2007_tr(j,k,ntr) = 1.0
        else
          if(tname == 'polvani_2007_t1') p2007_tr(j,k,ntr) = 1.0
        endif
      else if(world(j,k) == 2) then
        if(strat(j,k)) then
          if(tname == 'polvani_2007_s2') p2007_tr(j,k,ntr) = 1.0
        else
          if(tname == 'polvani_2007_t2') p2007_tr(j,k,ntr) = 1.0
        endif
      else if(world(j,k) == 3) then
        if(strat(j,k)) then
          if(tname == 'polvani_2007_s3') p2007_tr(j,k,ntr) = 1.0
        else
          if(tname == 'polvani_2007_t3') p2007_tr(j,k,ntr) = 1.0
        endif
      else if(world(j,k) == 4 .and. tname == 'polvani_2007_un') then
        p2007_tr(j,k,ntr) = 1.0
      endif

      if(z_full(j,k) < 2500. .and. tname == 'polvani_2007_bp') then
        p2007_tr(j,k,ntr) = 1.0
      endif
      if(z_full(j,k) < 1500. .and. tname == 'polvani_2007_b0') then
        p2007_tr(j,k,ntr) = 1.0
      endif
      if(z_full(j,k) < 500.  .and. tname == 'polvani_2007_bm') then
        p2007_tr(j,k,ntr) = 1.0
      endif

    enddo
  enddo
enddo

id_latitude  = diag_axis_init('latitude' , deg_lat, 'degrees_N', 'y', 'latitude' , set_name=mod_name)
id_pfull     = diag_axis_init('pfull', .01*LC1_p_full, 'hPa'    , 'z', 'pressure' , set_name=mod_name)
axes = (/id_latitude,id_pfull/)
do ntr=1,num_p2007_tr
  id_tr = register_static_field(mod_name, 'initial_'//p2007_tr_name(ntr), axes, p2007_tr_longname(ntr), 'none')
  used = send_data(id_tr, p2007_tr(:,:,ntr))
enddo

end subroutine compute_p2007_tr
!=================================================================================================================================
subroutine get_polvani_2007_tracers(tracers)
real, dimension(:,:,:,:), intent(out) :: tracers
integer :: num_tracers, ntr1, ntr2
character(len=128) :: tname, longname, units

call get_number_tracers(MODEL_ATMOS, num_prog=num_tracers)
do ntr1=1,num_tracers
  call get_tracer_names(MODEL_ATMOS, ntr1, tname, longname, units)
  do ntr2=1,num_p2007_tr
    if(trim(lowercase(tname)) == p2007_tr_name(ntr2)) then
      do k=1,num_levels
        do i=1,size(tracers,1)
          tracers(i,:,k,ntr1) = p2007_tr(js:je,k,ntr2)
        enddo
      enddo
    endif
  enddo
enddo

end subroutine get_polvani_2007_tracers
!=================================================================================================================================
end module polvani_2007_mod

module land_io_mod

use constants_mod,     only : PI
use fms_mod,           only : file_exist, error_mesg, FATAL, stdlog, mpp_pe, &
     mpp_root_pe, write_version_number, string, check_nml_error, close_file

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif


use horiz_interp_mod,  only : horiz_interp_type, &
     horiz_interp_new, horiz_interp_del, &
     horiz_interp

use land_numerics_mod, only : nearest, bisect
use nf_utils_mod,      only : nfu_validtype, nfu_get_dim, nfu_get_dim_bounds, &
     nfu_get_valid_range, nfu_is_valid, nfu_inq_var, nfu_get_var

implicit none
private

! ==== public interface ======================================================
public :: init_cover_field
public :: read_field
public :: read_land_io_namelist

public :: print_netcdf_error

public :: input_buf_size
! ==== end of public interface ===============================================

interface read_field
   module procedure read_field_N_2D, read_field_N_3D
   module procedure read_field_I_2D, read_field_I_3D
end interface

! ==== NetCDF declarations ===================================================
include 'netcdf.inc'
#define __NF_ASRT__(x) call print_netcdf_error((x),__FILE__,__LINE__)

! ==== module constants ======================================================
character(len=*), parameter :: &
     module_name = 'land_io_mod', &
     version     = '$Id: land_io.F90,v 20.0 2013/12/13 23:29:51 fms Exp $', &
     tagname     = '$Name: tikal $'

logical :: module_is_initialized = .false.

character(len=64)  :: interp_method = "conservative"
integer :: input_buf_size = 65536 ! input buffer size for tile and cohort reading
namelist /land_io_nml/ interp_method, input_buf_size

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

subroutine read_land_io_namelist()
  integer :: io, ierr, unit


  module_is_initialized = .TRUE.

  ! [1] print out version number
  call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
     read (input_nml_file, nml=land_io_nml, iostat=io)
     ierr = check_nml_error(io, 'land_io_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file ( )
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=land_io_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'land_io_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif   
  if (mpp_pe() == mpp_root_pe()) then
     unit = stdlog()
     write (unit, nml=land_io_nml)
     call close_file (unit)
  endif

  if(trim(interp_method) .NE. "conservative" .AND. trim(interp_method) .NE. "conserve_great_circle") then
     call error_mesg ( module_name,'interp_method should be "conservative" or "conserve_great_circle"', FATAL)
  endif
  
  if (input_buf_size <= 0) then
     call error_mesg ( module_name,'input_buf_size must be larger than zero', FATAL)
  endif

end subroutine read_land_io_namelist


! ============================================================================
! This procedure creates and initializes a field of fractional coverage.
subroutine init_cover_field( &
     cover_to_use, filename, cover_field_name, frac_field_name, &
     lonb, latb, uniform_cover, input_cover_types, frac)
  character(len=*), intent(in) :: cover_to_use
  character(len=*), intent(in) :: filename
  character(len=*), intent(in) :: cover_field_name, frac_field_name
  real            , intent(in) :: lonb(:,:), latb(:,:) ! boundaries of the grid cells
  integer         , intent(in) :: uniform_cover
  integer         , intent(in) :: input_cover_types(:)
  real            , intent(out):: frac(:,:,:) ! output-global map of soil fractional coverage

  ! ---- local vars ---------------------------------------------------------
  integer :: i,j,k     ! iterators
  integer :: cover_id
  real    :: maxfrac, total

  if( .not. module_is_initialized ) &
       call error_mesg(module_name,'land_io_init is not called', FATAL)
 
  frac = 0
  
  if (cover_to_use == 'multi-tile') then
     call read_cover_field(filename,cover_field_name,frac_field_name,lonb,latb,input_cover_types,frac)
  else if (cover_to_use=='single-tile') then
     call read_cover_field(filename,cover_field_name,frac_field_name,lonb,latb,input_cover_types,frac)
     do j = 1,size(frac,2)
     do i = 1,size(frac,1)
        total = sum(frac(i,j,:))
        if (total <= 0) cycle ! operate on valid input data points only
        maxfrac=0 ; cover_id=1
        do k = 1,size(frac,3)
           if(frac(i,j,k).gt.maxfrac) then
              maxfrac=frac(i,j,k)
              cover_id=k
           endif
        enddo
        ! set all fractions except dominant fraction to zero
        frac(i,j,:) = 0.0
        frac(i,j,cover_id) = total
     enddo
     enddo
  else if (cover_to_use == 'uniform') then
     call read_cover_field(filename,cover_field_name,frac_field_name,lonb,latb,input_cover_types,frac)
     do j = 1,size(frac,2)
     do i = 1,size(frac,1)
        total = sum(frac(i,j,:))
        if (total <= 0) cycle ! operate on valid input data points only
        ! set all fractions except dominant fraction to zero
        frac(i,j,:) = 0.0
        frac(i,j,uniform_cover) = total
     enddo
     enddo
  else
     call error_mesg ( module_name,'illegal value of cover_to_use '//cover_to_use, FATAL )
  endif

end subroutine init_cover_field


! ============================================================================
subroutine read_cover_field(file, cover_field_name, frac_field_name,&
     lonb, latb, input_cover_types, frac)
  character(len=*)  , intent(in)  :: file            ! file to read from
  character(len=*)  , intent(in)  :: cover_field_name, frac_field_name
  real              , intent(in)  :: lonb(:,:),latb(:,:) ! boundaries of the model grid
  real              , intent(out) :: frac(:,:,:)     ! resulting fractions
  integer, optional , intent(in)  :: input_cover_types(:)

  ! --- local vars
  integer :: ncid, varid

  if (.not.file_exist(file)) &
       call error_mesg(module_name,'input file "'//trim(file)//'" does not exist',FATAL)

  __NF_ASRT__( nf_open(file, NF_NOWRITE, ncid) )
  if(nf_inq_varid(ncid,cover_field_name,varid)==NF_NOERR) then
     call do_read_cover_field(ncid,varid,lonb,latb,input_cover_types,frac)
  else if ( nf_inq_varid(ncid,frac_field_name,varid)==NF_NOERR) then
     call do_read_fraction_field(ncid,varid,lonb,latb,input_cover_types,frac)
  else
     call error_mesg(module_name,&
          'neither "'//trim(cover_field_name)//'" nor "'//&
          frac_field_name//'" is present in input file "'//trim(file)//'"' ,&
          FATAL)
  endif
  __NF_ASRT__( nf_close(ncid) )

end subroutine read_cover_field

! ============================================================================
subroutine do_read_cover_field(ncid,varid,lonb,latb,input_cover_types,frac)
  integer, intent(in)  :: ncid, varid
  real   , intent(in)  :: lonb(:,:),latb(:,:)
  integer, intent(in)  :: input_cover_types(:)
  real   , intent(out) :: frac(:,:,:)

  ! ---- local vars
  integer :: nlon, nlat ! size of input map
  integer :: k
  integer, allocatable :: in_cover(:,:)
  real, allocatable    :: in_lonb(:), in_latb(:), x(:,:)
  type(horiz_interp_type) :: interp
  integer :: vardims(NF_MAX_VAR_DIMS)
  type(nfu_validtype) :: v
  integer :: in_j_start, in_j_count ! limits of the latitude belt we read
  integer :: iret ! result of netcdf calls

  ! find out dimensions, etc
  __NF_ASRT__( nf_inq_vardimid(ncid,varid,vardims) )
  ! get size of the longitude and latitude axes
  __NF_ASRT__( nf_inq_dimlen(ncid, vardims(1), nlon) )
  __NF_ASRT__( nf_inq_dimlen(ncid, vardims(2), nlat) )
  allocate ( in_lonb (nlon+1), in_latb (nlat+1) )
  __NF_ASRT__( nfu_get_dim_bounds(ncid, vardims(1), in_lonb) )
  __NF_ASRT__( nfu_get_dim_bounds(ncid, vardims(2), in_latb) )
  in_lonb = in_lonb*PI/180.0; in_latb = in_latb*PI/180.0

  ! to minimize the i/o and work done by horiz_interp, find the boundaries
  ! of latitude belt in input data that covers the entire latb array
  in_j_start=bisect(in_latb, minval(latb))
  in_j_count=bisect(in_latb, maxval(latb))-in_j_start+1

  ! check for unreasonable values
  if (in_j_start<1) &
     call error_mesg('do_read_cover_field','input latitude start index ('&
                     //string(in_j_start)//') is out of bounds', FATAL)
  if (in_j_start+in_j_count-1>nlat) &
     call error_mesg('do_read_cover_field','input latitude count ('&
                     //string(in_j_count)//') is too large (start index='&
                     //string(in_j_start)//')', FATAL)

  ! allocate input data buffers
  allocate ( x(nlon,in_j_count), in_cover(nlon,in_j_count) )

  ! read input data
  iret = nf_get_vara_int(ncid,varid, &
                    (/1,in_j_start/), (/nlon,in_j_count/), in_cover)
  __NF_ASRT__( iret )
  __NF_ASRT__( nfu_get_valid_range(ncid,varid,v) )

  call horiz_interp_new(interp, in_lonb,in_latb(in_j_start:in_j_start+in_j_count), &
       lonb,latb, interp_method=trim(interp_method))
  frac=0
  do k = 1,size(input_cover_types(:))
     x=0
     where(nfu_is_valid(in_cover,v).and.in_cover==input_cover_types(k)) x = 1

     call horiz_interp(interp,x,frac(:,:,k))
  enddo

  call horiz_interp_del(interp)

  ! clean up memory
  deallocate(in_lonb, in_latb, in_cover, x)

end subroutine do_read_cover_field


! ============================================================================
subroutine do_read_fraction_field(ncid,varid,lonb,latb,input_cover_types,frac)
  integer, intent(in)  :: ncid, varid
  real   , intent(in)  :: lonb(:,:),latb(:,:)
  integer, intent(in)  :: input_cover_types(:)
  real   , intent(out) :: frac(:,:,:)

  ! ---- local vars
  integer :: nlon, nlat, ntypes, k, cover
  real, allocatable :: in_frac(:,:,:)
  real, allocatable :: in_lonb(:), in_latb(:)
  real, allocatable :: in_mask(:,:)
  type(horiz_interp_type) :: interp
  type(nfu_validtype) :: v
  integer :: vardims(NF_MAX_VAR_DIMS)
  integer :: in_j_start, in_j_count ! limits of the latitude belt we read
  integer :: iret ! result of netcdf calls

  ! find out dimensions, etc
  __NF_ASRT__( nf_inq_vardimid(ncid,varid,vardims) )
  ! get size of the longitude and latitude axes
  __NF_ASRT__( nf_inq_dimlen(ncid, vardims(1), nlon) )
  __NF_ASRT__( nf_inq_dimlen(ncid, vardims(2), nlat) )
  __NF_ASRT__( nf_inq_dimlen(ncid, vardims(3), ntypes))
  allocate ( in_lonb(nlon+1), in_latb(nlat+1) )
  __NF_ASRT__(nfu_get_dim_bounds(ncid, vardims(1), in_lonb))
  __NF_ASRT__(nfu_get_dim_bounds(ncid, vardims(2), in_latb))
  in_lonb = in_lonb*PI/180.0; in_latb = in_latb*PI/180.0

  ! find the boundaries of latitude belt in input data that covers the 
  ! entire latb array
  in_j_start=bisect(in_latb, minval(latb))
  in_j_count=bisect(in_latb, maxval(latb))-in_j_start+1

  ! check for unreasonable values
  if (in_j_start<1) &
     call error_mesg('do_read_fraction_field','input latitude start index ('&
                     //string(in_j_start)//') is out of bounds', FATAL)
  if (in_j_start+in_j_count-1>nlat) &
     call error_mesg('do_read_fraction_field','input latitude count ('&
                     //string(in_j_count)//') is too large (start index='&
                     //string(in_j_start)//')', FATAL)

  allocate( in_mask(nlon,in_j_count), in_frac(nlon,in_j_count,ntypes) )

  ! read input data
  iret = nf_get_vara_double(ncid, varid, &
          (/1,in_j_start,1/), (/nlon,in_j_count,ntypes/), in_frac)
  __NF_ASRT__( iret ) 
  __NF_ASRT__( nfu_get_valid_range(ncid,varid,v) )

  frac = 0
  do k = 1,size(input_cover_types)
     cover = input_cover_types(k)
     if (cover<1.or.cover>ntypes) then
        cycle ! skip all invalid indices in the array of input cover types
     endif
     in_mask = 0.0
     where(nfu_is_valid(in_frac(:,:,cover),v)) in_mask = 1.0
     call horiz_interp_new(interp, &
          in_lonb,in_latb(in_j_start:in_j_start+in_j_count), lonb,latb,&
          interp_method=trim(interp_method), mask_in=in_mask)
     call horiz_interp(interp,in_frac(:,:,cover),frac(:,:,k))
     call horiz_interp_del(interp)
  enddo

  ! clean up memory
  deallocate(in_lonb, in_latb, in_frac, in_mask)

end subroutine do_read_fraction_field


! ============================================================================
subroutine read_field_N_2D(filename, varname, lon, lat, data, interp)
  character(len=*), intent(in) :: filename
  character(len=*), intent(in) :: varname
  real, intent(in)  :: lon(:,:),lat(:,:)
  real, intent(out) :: data(:,:)
  character(len=*), intent(in), optional :: interp

  ! ---- local vars ----------------------------------------------------------
  real    :: data3(size(data,1),size(data,2),1)

  call read_field_N_3D(filename, varname, lon, lat, data3, interp)
  data = data3(:,:,1)

end subroutine read_field_N_2D

! ============================================================================
subroutine read_field_N_3D(filename, varname, lon, lat, data, interp)
  character(len=*), intent(in) :: filename
  character(len=*), intent(in) :: varname
  real, intent(in)  :: lon(:,:),lat(:,:)
  real, intent(out) :: data(:,:,:)
  character(len=*), intent(in), optional :: interp

  ! ---- local vars ----------------------------------------------------------
  integer :: ncid
  integer :: iret

  iret = nf_open(filename,NF_NOWRITE,ncid)
  if(iret/=NF_NOERR) then
     call error_mesg('read_field','Can''t open netcdf file "'//trim(filename)//'"',FATAL)
  endif
  call read_field_I_3D(ncid, varname, lon, lat, data, interp)
  __NF_ASRT__( nf_close(ncid) )

end subroutine read_field_N_3D

! ============================================================================
subroutine read_field_I_2D(ncid, varname, lon, lat, data, interp)
  integer, intent(in) :: ncid
  character(len=*), intent(in) :: varname
  real, intent(in) :: lon(:,:),lat(:,:)
  real, intent(out) :: data(:,:)
  character(len=*), intent(in), optional  :: interp
  ! ---- local vars
  real    :: data3(size(data,1),size(data,2),1)

  call read_field_I_3D(ncid, varname, lon, lat, data3, interp)
  data = data3(:,:,1)

end subroutine read_field_I_2D

! ============================================================================
subroutine read_field_I_3D(ncid, varname, lon, lat, data, interp)
  integer, intent(in) :: ncid
  character(len=*), intent(in) :: varname
  real, intent(in) :: lon(:,:),lat(:,:)
  real, intent(out) :: data(:,:,:)
  character(len=*), intent(in), optional  :: interp

  ! ---- local vars ----------------------------------------------------------
  integer :: nlon, nlat, nlev ! size of input grid
  integer :: varndims ! number of variable dimension
  integer :: vardims(NF_MAX_VAR_DIMS) ! IDs of variable dimension
  integer :: dimlens(NF_MAX_VAR_DIMS) ! sizes of respective dimensions
  real,    allocatable :: in_lonb(:), in_latb(:), in_lon(:), in_lat(:)
  real,    allocatable :: x(:,:,:) ! input buffer
  logical, allocatable :: mask(:,:,:) ! mask of valid values
  real,    allocatable :: rmask(:,:,:) ! real mask for interpolator
  character(len=20) :: interpolation 
  integer :: i,j,k,imap,jmap !
  type(nfu_validtype) :: v

  interpolation = "bilinear"
  if(present(interp)) interpolation = interp
  
  ! get the dimensions of our variable
  __NF_ASRT__( nfu_inq_var(ncid,varname,ndims=varndims,dimids=vardims,dimlens=dimlens) )
  if(varndims<2.or.varndims>3) then
     call error_mesg('read_field','variable "'//trim(varname)//'" is '//string(varndims)//&
          'D, but only reading 2D or 3D variables is supported', FATAL)
  endif
  nlon = dimlens(1) ; nlat = dimlens(2)
  nlev = 1; 
  if (varndims==3) nlev=dimlens(3)
  if(nlev/=size(data,3)) then
     call error_mesg('read_field','3rd dimension length of the variable "'&
          //trim(varname)//'" ('//trim(string(nlev))//') is different from the expected size of data ('// &
          trim(string(size(data,3)))//')', FATAL)
  endif

  allocate (                 &
       in_lon  (nlon),   in_lat  (nlat),   &
       in_lonb (nlon+1), in_latb (nlat+1), &
       x       (nlon, nlat, nlev) ,&
       mask    (nlon, nlat, nlev) , rmask(nlon, nlat, nlev) )

  ! read boundaries of the grid cells in longitudinal direction
  __NF_ASRT__(nfu_get_dim(ncid, vardims(1), in_lon))
  __NF_ASRT__(nfu_get_dim(ncid, vardims(2), in_lat))
  in_lon = in_lon*PI/180.0; in_lat = in_lat*PI/180.0
  __NF_ASRT__(nfu_get_dim_bounds(ncid, vardims(1), in_lonb))
  __NF_ASRT__(nfu_get_dim_bounds(ncid, vardims(2), in_latb))
  in_lonb = in_lonb*PI/180.0; in_latb = in_latb*PI/180.0
  __NF_ASRT__(nfu_get_valid_range(ncid,varname,v))
  ! read input data
  __NF_ASRT__( nfu_get_var(ncid,varname,x) ) ! assuming real is real*8
  mask = nfu_is_valid(x,v)
  rmask = 1.0
  where(.not.mask) rmask = 0.0

  select case(trim(interpolation))
  case ("bilinear")
     do k = 1,size(data,3)
        call horiz_interp(x(:,:,k), in_lonb, in_latb, lon,lat, data(:,:,k), mask_in=rmask(:,:,k), &
             interp_method='bilinear')
     enddo
  case ("nearest")
     do k = 1,size(data,3)
     do j = 1,size(data,2)
     do i = 1,size(data,1)
        call nearest (mask(:,:,k), in_lon, in_lat, lon(i,j), lat(i,j), imap, jmap)
        data(i,j,k) = x(imap,jmap,k)
     enddo
     enddo
     enddo
  case default
     call error_mesg(module_name, interpolation//" is not a valid interpolation method",FATAL)
  end select

  deallocate(in_lonb, in_latb, in_lon, in_lat, x, mask, rmask)

end subroutine read_field_I_3D

! ============================================================================
subroutine print_netcdf_error(ierr, file, line)
  ! prints out NetCDF library error message, including file name and line number
  integer,          intent(in) :: ierr ! error code
  character(len=*), intent(in) :: file ! name of the file
  integer,          intent(in) :: line ! number of line in the file

  ! ---- local vars
  character(len=1024) :: mesg

  if (ierr.ne.NF_NOERR) then
     write(mesg, "('File ',a,' Line ',i4.4,' :: ',a)") &
          trim(file),line,trim(NF_STRERROR(ierr))
     call error_mesg('NetCDF', mesg, FATAL)
  endif
end subroutine print_netcdf_error

end module

#include <fms_platform.h>
module fv_arrays_mod
!! module for declaring main arrays of FV model. these arrays were
!! declared in fv_pack, now they will be declared here. If pointer
!! sharing is turned on, only the pointers will be published, or by
!! default the arrays.
  use mpp_mod, only: mpp_error, mpp_pe, mpp_npes, mpp_sync, &
       stderr, mpp_root_pe, FATAL, WARNING, &
       mpp_chksum, mpp_send, mpp_recv, &
       mpp_get_current_pelist, mpp_set_current_pelist, mpp_declare_pelist
  use mpp_domains_mod, only: domain2D, mpp_define_layout, mpp_define_domains, &
       mpp_get_compute_domain, mpp_get_data_domain, mpp_get_global_domain
  use mpp_pset_mod, only: mpp_pset_type, mpp_pset_create, mpp_pset_delete, &
       mpp_pset_sync, mpp_pset_broadcast, mpp_pset_broadcast_ptr, &
       mpp_pset_check_ptr, mpp_pset_segment_array, mpp_pset_stack_push, &
       mpp_pset_stack_reset, mpp_pset_print_chksum, mpp_pset_root, &
       mpp_pset_get_root_pelist, mpp_pset_print_stack_chksum

  use mod_comm, only: mp_init

  use ensemble_manager_mod, only: get_ensemble_size, get_ensemble_pelist, &
                                  get_ensemble_filter_pelist

  implicit none
  private

  logical :: debug=.TRUE.
!! declarations from fv_pack.F90

!-----------------------------------------------------------------------
! Five prognostic state variables for the f-v dynamics
!-----------------------------------------------------------------------
! dyn_state:
! D-grid prognostatic variables: u, v, and delp (and other scalars)
!
!     o--------u(i,j+1)----------o
!     |           |              |
!     |           |              |
!  v(i,j)------scalar(i,j)----v(i+1,j)
!     |           |              |
!     |           |              |
!     o--------u(i,j)------------o
!
! The C grid component is "diagnostic" in that it is predicted every time step
! from the D grid variables.

   real, allocatable :: u(:,:,:)    ! D grid zonal wind (m/s)
   real, allocatable :: v(:,:,:)    ! D grid meridional wind (m/s)
   real, allocatable :: pt(:,:,:)   ! temperature (K)
   real, allocatable :: delp(:,:,:) ! pressure thickness (pascal)
   real, allocatable :: q(:,:,:,:)  ! specific humidity and constituents

! phys_state: use these for physics packages that require tendencies as input
! The following 4 arrays are allocated only when use_tendency = .true.
   real, allocatable :: u_phys(:,:,:)     ! u-wind on the physics grid (m/s)
   real, allocatable :: v_phys(:,:,:)     ! v-wind on the physics grid (m/s)
   real, allocatable :: t_phys(:,:,:)     ! temperature (K)
   real, allocatable :: q_phys(:,:,:,:)   ! tracer (moist) mixing ratios

!-----------------------------------------------------------------------
! Auxilliary pressure arrays:
! The 5 vars below can be re-computed from delp and ptop.
!-----------------------------------------------------------------------
! dyn_aux:
   real, allocatable :: ps (:,:)      ! Surface pressure (pascal)
   real, allocatable :: pe (:,:,: )   ! edge pressure (pascal)
   real, allocatable :: pk  (:,:,:)   ! pe**cappa
   real, allocatable :: peln(:,:,:)   ! ln(pe)
   real, allocatable :: pkz (:,:,:)   ! finite-volume mean pk

   real, allocatable :: ps_bp (:,:)   ! ps BEFORE physics update
                                          ! for computing omega
   real, allocatable :: phis(:,:)     ! Surface geopotential (g*Z_surf)
   real, allocatable :: omga(:,:,:)   ! Vertical pressure velocity (pa/s)
   real, allocatable :: pesouth(:,:)  ! "pe at the south" for SPMD

   real, allocatable:: ua(:,:,:)      ! (ua, va) are mostly used as the A grid winds
   real, allocatable:: va(:,:,:)

! Surface winds for coupler
   real, allocatable:: u_srf(:,:)     ! A grid u-wind at surface
   real, allocatable:: v_srf(:,:)     ! A grid v-wind at surface

   real, allocatable, dimension(:,:,:) :: u_dt, v_dt, t_dt
   real, allocatable :: q_dt(:,:,:,:)

#ifdef MARS_GCM
   real, allocatable :: delp_dt(:,:,:)
   real, allocatable :: mars_sfc_budg(:,:,:)
#endif MARS_GCM

!! declarations from fv_pack.F90.1D2D
#ifdef MARS_GCM
  integer, parameter :: NUMPTRS=28
#else
  integer, parameter :: NUMPTRS=26
#endif MARS_GCM

  integer(POINTER_KIND) :: ptrArray(NUMPTRS) !this array contains addresses to all the variables to be shared
                              !between physics and dynamics.
  integer(POINTER_KIND) :: ptr_u, &
                           ptr_v, &
                           ptr_delp, &
                           ptr_pt, &
                           ptr_q, &
                           ptr_u_phys, &
                           ptr_v_phys, &
                           ptr_t_phys, &
                           ptr_q_phys, &
                           ptr_phis, &
                           ptr_ps, &
                           ptr_omga, &
                           ptr_pkz, &
                           ptr_pk, &
                           ptr_pe, &
                           ptr_peln, &
                           ptr_pesouth, &
                           ptr_ua, &
                           ptr_va, &
                           ptr_ps_bp, &
                           ptr_u_srf, &
                           ptr_v_srf, &
                           ptr_u_dt, &
                           ptr_v_dt, &
                           ptr_t_dt, &
#ifdef MARS_GCM
                           ptr_q_dt,  ptr_delp_dt, ptr_mars_sfc_budg  
#else
                           ptr_q_dt
#endif

!note that npes/layout vars are module global: implies that the same pelist
!must call the init and other methods... should be ok since all atmos PEs
!call it
  integer :: npe, npes, npex, npey
  integer :: npel, nper !thread on the left and right
  integer :: pos !pos = modulo(npe,npex) !0.LE.pos.LE.npex-1

  integer, allocatable, dimension(:) :: pelist, ypelist
  logical :: pset_root !TRUE for PEs that allocate shared arrays (ypelist)
!compute/data/global domain limits
  integer, public :: is,ie,js,je, isd,ied,jsd,jed, isg,ieg,jsg,jeg
!the ..p integers are the loop indices corresponding to a parallel loop
  integer, public :: isp, iep, jsp, jep, ksp, kep
!number of levels and tracers; loop decomposition in East-West direction
  integer, public :: nlev, ncnst, n_zonal=0
  integer, public :: layout(2)=(/0,0/) !layout, public to fv_core_nml
  integer, public :: fv_pset_stack=1000000 !internal workspace for PSETs

!MPI communicator for ypelist
  integer :: commID
!PSET
  type(mpp_pset_type), public, save :: pset

  public :: fv_arrays_init, fv_arrays_exit, fv_stack_push, &
       fv_print_chksum, fv_print_chksums, fv_thread_bcast, &
       fv_array_check, fv_array_limits, fv_stack_reset, fv_array_sync
#ifdef use_shared_pointers
!arrays pointers are public
  public :: ptr_u, ptr_v, ptr_delp, ptr_pt, ptr_q, ptr_u_phys, ptr_v_phys, &
            ptr_t_phys, ptr_q_phys, ptr_phis, ptr_ps, ptr_omga, ptr_pkz, &
            ptr_pk, ptr_pe, ptr_peln, ptr_pesouth, ptr_ua, ptr_va, ptr_ps_bp, &
            ptr_u_srf, ptr_v_srf, ptr_u_dt, ptr_v_dt, ptr_t_dt, ptr_q_dt
#   ifdef MARS_GCM
  public ::  ptr_delp_dt, ptr_mars_sfc_budg
#   endif MARS_GCM

#else
!arrays themselves are public
  public :: u, v, delp, pt, q, u_phys, v_phys, &
            t_phys, q_phys, phis, ps, omga, pkz, &
            pk, pe, peln, pesouth, ua, va, ps_bp, &
            u_srf, v_srf, u_dt, v_dt, t_dt, q_dt
#   ifdef MARS_GCM
  public ::  delp_dt, mars_sfc_budg
#   endif MARS_GCM

#endif use_shared_pointers

contains

  subroutine fv_arrays_init( nx, ny, nz, nt, shalo, nhalo, ighost, domain )
    integer, intent(in) ::   nx, ny, nz, nt, shalo, nhalo, ighost 
    type(domain2D), intent(out) :: domain

    integer               :: ensemble_siz(6), num_ensemble, atmos_npes_pm, n
    integer, allocatable :: ensemble_pelist(:,:), all_pelist(:)

!convert to domain2D specification
!this requires ng_s=ng-d for now
    if( shalo.NE.nhalo )call mpp_error( FATAL, &
         'FV_ARRAYS_INIT: now requires even halos (ng_s==ng_d)' )
    npe = mpp_pe()
    npes = mpp_npes()
    if( layout(1).EQ.0 .AND. layout(2).EQ.0 )then
        call mpp_define_layout( (/1,nx,1,ny/), npes, layout )
    else if( layout(1).EQ.0 )then
        layout(1) = npes/layout(2)
    else if( layout(2).EQ.0 )then
        layout(2) = npes/layout(1)
    end if
    npex = layout(1); npey = layout(2)
    if( npex*npey.NE.npes )call mpp_error( FATAL, &
         'FV_ARRAYS_INIT: npex*npey.NE.npes: check if layout in fv_core_nml matches atmos_npes.' )
!latitudes must be evenly divided and more than 3 rows per PE
    if( modulo(ny,npey).NE.0 )call mpp_error( FATAL, &
         'FV_ARRAYS_INIT: mlat must be evenly decomposed.' )
    if( ny/npey.LT.3 )call mpp_error( FATAL, &
         'FV_ARRAYS_INIT: FV core requires at least 3 rows per PE.' )
    if( ighost.NE.0 )call mpp_error( FATAL, &
         'FV_ARRAYS_INIT: currently assumes phis has no halo (ighost==0)' )
    call mpp_define_domains( (/1,nx,1,ny/), layout, domain, &
         xhalo=0, yhalo=shalo, name='FV Core Arrays.' )
    call mpp_get_compute_domain( domain, is, ie, js, je  )
    call mpp_get_data_domain   ( domain, isd,ied,jsd,jed )
    call mpp_get_global_domain ( domain, isg,ieg,jsg,jeg )
    nlev = nz; ncnst = nt
!#ifndef use_shared_pointers
!    if ( n_zonal == 0 ) then
!        if ( (ny/npey) / npex >= 6 ) then
!            n_zonal = 1
!        else
!            if ( 4*(nx/4) == nx ) Then
!                n_zonal = 4
!            else
!                n_zonal = 2
!            endif
!        endif
!    endif
!#else
!in our case n_zonal MUST EQUAL npex!
!fv_arrays_init is called after reading fv_core_nml so it overrides namelist
!value... but better to remove it from namelist later
    if( n_zonal.NE.0 )then
        call mpp_error( WARNING, &
             'FV_ARRAYS_INIT: n_zonal was set in fv_core_nml '// &
             'but overridden here.' )
    end if
    n_zonal = npex
!#endif

    allocate( pelist(0:npes-1) )
    call mpp_get_current_pelist(pelist)
!set up PSETs
!z1l: mpp_pset_create need to be called for each ensemble because of mpp_declare_pelist
    ensemble_siz = get_ensemble_size()
    num_ensemble = ensemble_siz(1)
    if(num_ensemble == 1) then
       call mpp_pset_create( npex, pset, fv_pset_stack)
    else
       atmos_npes_pm = ensemble_siz(4)
       allocate(ensemble_pelist(num_ensemble, atmos_npes_pm) )
       allocate(all_pelist(num_ensemble*atmos_npes_pm) )
       call get_ensemble_pelist(ensemble_pelist, 'atmos')
       call get_ensemble_filter_pelist(all_pelist, 'atmos')
       call mpp_set_current_pelist(all_pelist)
       call mpp_get_current_pelist(all_pelist, commID = commID)
       do n = 1, num_ensemble
             call mpp_pset_create( npex, pset, fv_pset_stack, ensemble_pelist(n,:), commID ) !initialized npey PSETs of npex each
       enddo
       call mpp_set_current_pelist(pelist)
    endif

!the y pelist consists of 1 PE from each row(y) of the decomposition
    allocate( ypelist(0:npey-1) )
    call mpp_pset_get_root_pelist( pset, ypelist, commID=commID )

!all PEs allocate by default; but only root PEs allocate when use_shared_pointers
    pset_root = .TRUE.
#ifdef use_shared_pointers
    pset_root = mpp_pset_root(pset)
#endif
!only the root PEs should do these allocate()s!
    if( pset_root )then
! State variables:
        allocate (   u(isg:ieg, jsd:jed, nz))
        allocate (   v(isg:ieg, jsd:jed, nz))
        allocate (delp(isg:ieg, js:je,   nz))
        allocate (  pt(isg:ieg, jsd:jed, nz))
        allocate (   q(isg:ieg, jsd:jed, nz, nt))

!      if( use_tendency ) then
        allocate ( u_phys(isg:ieg, js:je, nz) )
        allocate ( v_phys(isg:ieg, js:je, nz) )
        allocate ( t_phys(isg:ieg, js:je, nz) )
        allocate ( q_phys(isg:ieg, js:je, nz, nt) )
!      endif

        allocate (phis(isg:ieg, js:je))
        allocate (ps  (isg:ieg, js:je))
        allocate (omga(isg:ieg, js:je,nz))    

        allocate (pkz (isg:ieg, js:je, nz))
        allocate (pk  (isg:ieg, js:je, nz+1))
        allocate (pe  (isg:ieg, nz+1, js:je)) 
        allocate (peln(isg:ieg, nz+1, js:je)) 

        allocate (pesouth(isg:ieg, nz+1))

        allocate ( ua(isg:ieg, js:je, nz) )
        allocate ( va(isg:ieg, js:je, nz) )

! For GFDL physics:
        allocate (ps_bp (isg:ieg, js:je))
        allocate ( u_srf(isg:ieg, js:je) )
        allocate ( v_srf(isg:ieg, js:je) )
        allocate( u_dt(isg:ieg, js:je, nz) )
        allocate( v_dt(isg:ieg, js:je, nz) )
        allocate( t_dt(isg:ieg, js:je, nz) )
        allocate( q_dt(isg:ieg, js:je, nz, nt) )
#ifdef MARS_GCM
        allocate( delp_dt(isg:ieg, js:je, nz) )
        allocate( mars_sfc_budg(isg:ieg, js:je, 5) )
#endif MARS_GCM
    end if
    isp = isg; iep = ieg
    jsp = js; jep = je
    ksp = 1; kep = nz
#ifdef use_shared_pointers
    if( pset_root )then
    ptr_u = LOC(u)
    ptr_v = LOC(v)
    ptr_delp = LOC(delp)
    ptr_pt = LOC(pt)
    ptr_q = LOC(q)
    ptr_u_phys = LOC(u_phys)
    ptr_v_phys = LOC(v_phys)
    ptr_t_phys = LOC(t_phys)
    ptr_q_phys = LOC(q_phys)
    ptr_phis = LOC(phis)
    ptr_ps = LOC(ps)
    ptr_omga = LOC(omga)
    ptr_pkz = LOC(pkz)
    ptr_pk = LOC(pk)
    ptr_pe = LOC(pe)
    ptr_peln = LOC(peln)
    ptr_pesouth = LOC(pesouth)
    ptr_ua = LOC(ua)
    ptr_va = LOC(va)
    ptr_ps_bp = LOC(ps_bp)
    ptr_u_srf = LOC(u_srf)
    ptr_v_srf = LOC(v_srf)
    ptr_u_dt = LOC(u_dt)
    ptr_v_dt = LOC(v_dt)
    ptr_t_dt = LOC(t_dt)
    ptr_q_dt = LOC(q_dt)
#ifdef MARS_GCM
    ptr_delp_dt = LOC(delp_dt)
    ptr_mars_sfc_budg = LOC(mars_sfc_budg)
#endif MARS_GCM
!the array ptrArray is now filled by equivalence()
    ptrArray( 1) = ptr_u
    ptrArray( 2) = ptr_v
    ptrArray( 3) = ptr_delp
    ptrArray( 4) = ptr_pt
    ptrArray( 5) = ptr_q
    ptrArray( 6) = ptr_u_phys
    ptrArray( 7) = ptr_v_phys
    ptrArray( 8) = ptr_t_phys
    ptrArray( 9) = ptr_q_phys
    ptrArray(10) = ptr_phis
    ptrArray(11) = ptr_ps
    ptrArray(12) = ptr_omga
    ptrArray(13) = ptr_pkz
    ptrArray(14) = ptr_pk
    ptrArray(15) = ptr_pe
    ptrArray(16) = ptr_peln
    ptrArray(17) = ptr_pesouth
    ptrArray(18) = ptr_ua
    ptrArray(19) = ptr_va
    ptrArray(20) = ptr_ps_bp
    ptrArray(21) = ptr_u_srf
    ptrArray(22) = ptr_v_srf
    ptrArray(23) = ptr_u_dt
    ptrArray(24) = ptr_v_dt
    ptrArray(25) = ptr_t_dt
    ptrArray(26) = ptr_q_dt
#ifdef MARS_GCM
    ptrArray(27) = ptr_delp_dt
    ptrArray(28) = ptr_mars_sfc_budg
#endif MARS_GCM
    endif
    call mpp_pset_broadcast_ptr( pset, ptrArray )
    ptr_u = ptrArray( 1)
    ptr_v = ptrArray( 2)
    ptr_delp = ptrArray( 3)
    ptr_pt = ptrArray( 4)
    ptr_q = ptrArray( 5)
    ptr_u_phys = ptrArray( 6)
    ptr_v_phys = ptrArray( 7)
    ptr_t_phys = ptrArray( 8)
    ptr_q_phys = ptrArray( 9)
    ptr_phis = ptrArray(10)
    ptr_ps = ptrArray(11)
    ptr_omga = ptrArray(12)
    ptr_pkz = ptrArray(13)
    ptr_pk = ptrArray(14)
    ptr_pe = ptrArray(15)
    ptr_peln = ptrArray(16)
    ptr_pesouth = ptrArray(17)
    ptr_ua = ptrArray(18)
    ptr_va = ptrArray(19)
    ptr_ps_bp = ptrArray(20)
    ptr_u_srf = ptrArray(21)
    ptr_v_srf = ptrArray(22)
    ptr_u_dt = ptrArray(23)
    ptr_v_dt = ptrArray(24)
    ptr_t_dt = ptrArray(25)
    ptr_q_dt = ptrArray(26)
#ifdef MARS_GCM
    ptr_delp_dt = ptrArray(27)
    ptr_mars_sfc_budg = ptrArray(28)
#endif MARS_GCM
!isp,... index limits when you divide the computational domain by npex
    isp = is
    iep = ie
    call fv_array_limits( js, je, jsp, jep )
    call fv_array_limits(  1, nz, ksp, kep )
#endif
!initialize mod_comm on the ypelist
    if( pset_root )then
        call mpp_set_current_pelist(ypelist)
        call mpp_get_current_pelist(ypelist, commID=commID)
        call mp_init( nx, ny, nz, commID )
    end if
    call mpp_set_current_pelist(pelist)
    return
  end subroutine fv_arrays_init

  subroutine fv_thread_bcast(a)
!broadcast value on the pset_root to its sub-threads
!wrapper, eliminate
    real, intent(inout) :: a

    call mpp_pset_broadcast( pset, a )
  end subroutine fv_thread_bcast

  subroutine fv_array_sync
!this is a replacement for mpp_sync, doing syncs across
!shared arrays without calling mpp_sync
!wrapper, eliminate
    call mpp_pset_sync(pset)
  end subroutine fv_array_sync

  subroutine fv_array_check(ptr)
!check if shared array
!wrapper, eliminate
#ifdef use_CRI_pointers
    real :: a
    pointer( ptr, a )
#else
    integer(POINTER_KIND), intent(in) :: ptr
#endif
    call mpp_pset_check_ptr( pset, ptr )
  end subroutine fv_array_check

  subroutine fv_array_limits( ls, le, lsp, lep )
!get parallel limits
!wrapper: eliminate
    integer, intent(in) :: ls, le
    integer, intent(out) :: lsp, lep

    call mpp_pset_segment_array( pset, ls, le, lsp, lep )
  end subroutine fv_array_limits

  subroutine fv_stack_push( ptr, len )
!mpp_malloc specialized for FV shared arrays
!len is the length of the required array
!lstack is the stack already in play
!user should zero lstack (call fv_stack_reset) when the stack is to be cleared
!wrapper: eliminate
    integer, intent(in) :: len
#ifdef use_CRI_pointers
    real :: a
    pointer( ptr, a )
#else
    integer(POINTER_KIND), intent(out) :: ptr
#endif
    call mpp_pset_stack_push( pset, ptr, len )
  end subroutine fv_stack_push

  subroutine fv_stack_reset
!reset stack... will reuse any temporary arrays! USE WITH CARE
    call mpp_pset_stack_reset(pset)
  end subroutine fv_stack_reset

  subroutine fv_print_chksum(caller, array)
!wrapper: eliminate
    character(len=*), intent(in) :: caller
    real, intent(in) :: array(:,:,:)

    call mpp_pset_print_chksum( pset, caller, array )
    return
  end subroutine fv_print_chksum

  subroutine fv_print_chksums(caller)
    character(len=*), intent(in) :: caller
#ifdef PSET_DEBUG
#include "fv_point.inc"
!checksums may not match across changes in Y decomposition!

    call mpp_pset_print_chksum( pset, trim(caller)//' u=', &
         u(isg:ieg,jsd:jed,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' v=', &
         v(isg:ieg,jsd:jed,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' delp=', &
         delp(isg:ieg,js:je,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' pt=', &
         pt(isg:ieg,jsd:jed,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' q=', &
         q(isg:ieg,jsd:jed,:,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' u_phys=', &
         u_phys(isg:ieg,js:je,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' v_phys=', &
         v_phys(isg:ieg,js:je,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' t_phys=', &
         t_phys(isg:ieg,js:je,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' q_phys=', &
         q_phys(isg:ieg,js:je,:,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' phis=', &
         phis(isg:ieg,js:je) )
    call mpp_pset_print_chksum( pset, trim(caller)//' ps=', &
         ps  (isg:ieg,js:je) )
    call mpp_pset_print_chksum( pset, trim(caller)//' omga=', &
         omga(isg:ieg,js:je,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' pkz=', &
         pkz (isg:ieg,js:je,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' pk=', &
         pk  (isg:ieg,js:je,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' pe=', &
         pe  (isg:ieg,:,js:je) )
    call mpp_pset_print_chksum( pset, trim(caller)//' peln=', &
         peln(isg:ieg,:,js:je) )
    call mpp_pset_print_chksum( pset, trim(caller)//' pesouth=', &
         pesouth(isg:ieg,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' ua=', &
         ua(isg:ieg,js:je,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' va=', &
         va(isg:ieg,js:je,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' ps_bp=', &
         ps_bp (isg:ieg,js:je) )
    call mpp_pset_print_chksum( pset, trim(caller)//' u_srf=', &
         u_srf(isg:ieg,js:je) )
    call mpp_pset_print_chksum( pset, trim(caller)//' v_srf=', &
         v_srf(isg:ieg,js:je) )
    call mpp_pset_print_chksum( pset, trim(caller)//' u_dt=', &
         u_dt(isg:ieg,js:je,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' v_dt=', &
         v_dt(isg:ieg,js:je,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' t_dt=', &
         t_dt(isg:ieg,js:je,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' q_dt=', &
         q_dt(isg:ieg,js:je,:,:) )
#ifdef MARS_GCM
    call mpp_pset_print_chksum( pset, trim(caller)//' delp_dt=', &
         delp_dt(isg:ieg,js:je,:) )
    call mpp_pset_print_chksum( pset, trim(caller)//' mars_sfc_budg=', &
         mars_sfc_budg(isg:ieg,js:je,:) )
#endif MARS_GCM
    call mpp_pset_print_stack_chksum(pset, caller)
#endif
    return
  end subroutine fv_print_chksums

  subroutine fv_arrays_exit
    if( pset_root )then
        deallocate ( u )
        deallocate ( v )
        deallocate ( delp )
        deallocate ( pt )
        deallocate ( q )

        deallocate ( phis )
        deallocate ( ps )
        deallocate ( omga )

        deallocate ( pkz )
        deallocate ( pk )
        deallocate ( pe )
        deallocate ( peln )

        deallocate ( pesouth )

        deallocate ( ua )
        deallocate ( va )


        deallocate( ps_bp )
        deallocate( u_srf )
        deallocate( v_srf )

!      if( use_tendency ) then
        deallocate ( u_phys )
        deallocate ( v_phys )
        deallocate ( t_phys )
        deallocate ( q_phys )
!      endif

#ifdef MARS_GCM
        deallocate ( delp_dt )
        deallocate ( mars_sfc_budg )
#endif MARS_GCM


    end if
    call mpp_pset_delete(pset)
  end subroutine fv_arrays_exit
end module fv_arrays_mod

#ifdef test_fv_arrays
  program test
    use fv_arrays_mod, only: fv_arrays_init, fv_array_limits
    use mpp_mod, only: mpp_init, mpp_exit, mpp_pe

    integer :: nx=360, ny=200, halo=2, nzonal=0
    integer :: isp, iep

    call mpp_init()

    call fv_arrays_init( nx, ny, halo, halo, nzonal )
!test fv_array_limits
!run tests at PE counts that divide le exactly, as well as counts that do not
    ls = 1; le = 1000
    call fv_array_limits( ls, le, lsp, lep )
    write( 6,'(a,4i4)' )'ls,le,lsp,lep=', ls,le,lsp,lep
    call mpp_exit()
  end program test
#endif

module fv_restart_mod

  use fms_mod,    only: file_exist, error_mesg,  lowercase, FATAL, &
       NOTE, read_data, uppercase, stdout, mpp_pe, mpp_root_pe, mpp_chksum
  use fms_io_mod,   only: open_restart_file, close_file, write_data, get_instance_filename
  use mpp_io_mod, only: mpp_open, mpp_close, axistype, fieldtype,  &
       mpp_read_meta, mpp_get_info, mpp_get_fields, mpp_read, &
       MPP_NETCDF, MPP_SINGLE, MPP_MULTI, MPP_SEQUENTIAL, MPP_RDONLY, &
       MPP_WRONLY, MPP_NATIVE, MPP_OVERWR, mpp_write_meta, mpp_write, &
       atttype, mpp_get_atts, mpp_get_att_name, mpp_get_att_real_scalar, &
       mpp_get_field_name
  use fv_pack,    only: ak, bk, ks, ptop, beglat, endlat,       &
       master, nlon, mlat, nt_phys, nqrst, ng_d, ng_s, &
       ighost, mountain, coslon, sinlon, lon, lat, lonb, latb,     &
       adjust_dry_mass, use_set_eta, p_var, d2a3d,          &
       age_tracer, age_time, get_eta_level, &
       do_fms_tracer_manager, fms_tracers_file, fv_domain, &
       restart_format, use_tendency, cold_start, gid
#ifdef MARS_GCM
  use fv_pack,    only: p_ref
#endif MARS_GCM

  use tracer_manager_mod, only : tr_get_tracer_names=>get_tracer_names, &
       get_tracer_names, get_number_tracers, &
       set_tracer_profile, &
       get_tracer_index, NO_TRACER
  use field_manager_mod, only  : MODEL_ATMOS      
  use         platform_mod, only: I8_KIND

!  use shr_kind_mod, only : r8 => shr_kind_r8
#ifdef SPMD
  use mod_comm, only: mp_bcst_int, mp_bcst_r2d, mp_scatter3d, mp_bcst_real, &
       mp_send4d_ns, mp_recv4d_ns, mp_gather3d
#endif

  use fv_arrays_mod, only: fv_array_check, fv_stack_push, fv_array_sync, &
       fv_print_chksums, ksp, kep
  use mpp_mod, only: mpp_sync, mpp_root_pe, mpp_broadcast
  use mpp_domains_mod, only: mpp_get_data_domain, mpp_get_compute_domain
  use constants_mod,    only: grav, kappa, rdgas

  use pmaxmin_mod, only: pmaxming, pmaxmin

  implicit none
  private

  public :: fv_restart, read_fv_rst, write_fv_rst, add_tracers

contains

  subroutine read_fv_rst(im, jm, km, nq, dflnm, days, seconds, oform)

#include "fv_arrays.h"
    character*(*), intent(in)       :: dflnm                ! dynamics filename
    integer, intent(in) :: nq
    integer, intent(out):: im, jm, km
    integer, intent(out):: days
    integer, intent(out):: seconds
    character(len=*), intent(in) :: oform

! Local variables
    integer iuic                       ! Unit number
    integer i, j, k, n, jn, it, ntracers
    logical is_tracer_in_restart_file
    character(len=128)    :: tname
    real zsurf(nlon, beglat: endlat)
    real ginv, qmax, qmin
    real, allocatable :: w2d(:,:), w3d(:,:,:)

    type(fieldtype), allocatable :: tracer_fields(:), fields(:)
    type(atttype), allocatable :: attributes(:)
    integer :: ndim,natt,nvar,ntime
    real p0

    character(len=*), parameter :: fms_tracers_restart_file = &
         'INPUT/'//fms_tracers_file

    character(len=128) :: directory, restart_name, tr_name, dflnm_mod
    logical :: use_native_format
    integer :: ids, ide, jds, jde, ics,ice,jcs,jce

#ifdef MARS_GCM
!      ------Dont require specific water vapor fields in netcdf version 
!         of tracer restart file:   Hence this code is not necessary 
#else
    integer :: nsphum, nliq_wat, nice_wat, ncld_amt
    character(len=20) :: fv_tr_name(4)
    data fv_tr_name / "sphum","liq_wat","ice_wat","cld_amt" /
#endif


#ifdef use_shared_pointers
    pointer( p_zsurf, zsurf )
#include "fv_point.inc"
    call fv_stack_push( p_zsurf, nlon*(endlat-beglat+1) )
#endif

    ginv = 1./ GRAV

    !Modify the filename if it has an ensemble instance appendix
    !The following call does not modify the filename unless there 
    !is an ensemble instance appendix and fms_io knows about it.
    call get_instance_filename(dflnm, dflnm_mod)

! output format
    if (trim(uppercase(oform)) == 'NATIVE') then
        use_native_format = .true.
        restart_name = trim(dflnm_mod)
    else if (trim(uppercase(oform)) == 'NETCDF') then
        use_native_format = .false.
        if (trim(dflnm_mod(LEN_TRIM(dflnm_mod)-2:LEN_TRIM(dflnm_mod))) /= ".nc" ) &
             restart_name = trim(dflnm_mod)//".nc"
        if (file_exist(dflnm_mod) .and. .not. file_exist(trim(dflnm_mod)//".nc")) then
            call error_mesg( 'read_fv_rst', &
                 'NetCDF file does not exist. Switching to Native format.', &
                 NOTE)
            restart_name = trim(dflnm_mod)
            use_native_format = .true.
        endif

    else
        call error_mesg ('read_fv_rst', &
             'invalid value for argument oform='//trim(oform), FATAL)
    endif
    if (.not. file_exist(dflnm_mod) .and. .not. file_exist(trim(dflnm_mod)//".nc")) &
         call error_mesg ('read_fv_rst', &
         'Neither a Native or NetCDF restart file is present.', FATAL)

    if( master ) then
        if (use_native_format) then
            if (file_exist(dflnm_mod)) then
!!$         call mpp_open (iuic, dflnm_mod, action=MPP_RDONLY, form=MPP_NATIVE, access=MPP_SEQUENTIAL)
                iuic = open_restart_file(dflnm_mod, 'read')
                read(iuic) im, jm, km, nqrst
            endif
        else
            if (file_exist(trim(dflnm_mod)//'.nc')) then
                call mpp_open(iuic, dflnm_mod, &
                     action=MPP_RDONLY, form=MPP_NETCDF, threading=MPP_SINGLE )
                call mpp_read_meta(iuic)
                call mpp_get_info(iuic,ndim,nvar,natt,ntime)

                allocate(attributes(natt))
                call mpp_get_atts(iuic,attributes)

                do n= 1,natt
!            select case (attributes(n)%name)
                   select case ( mpp_get_att_name(attributes(n)))
                   case ('nlon')
                       im= int(mpp_get_att_real_scalar(attributes(n)))
                   case ('mlat')
                       jm= int(mpp_get_att_real_scalar(attributes(n)))
                   case ('nlev')
                       km= int(mpp_get_att_real_scalar(attributes(n)))
                   case ('nt_phys')
                       nqrst= int(mpp_get_att_real_scalar(attributes(n)))
                   case ('days')
                       days= int(mpp_get_att_real_scalar(attributes(n)))
                   case ('seconds')
                       seconds= int(mpp_get_att_real_scalar(attributes(n)))
                   case ('ks')
                       ks = int(mpp_get_att_real_scalar(attributes(n)))
                   end select
                enddo
                deallocate(attributes)


                allocate(fields(nvar))
                call mpp_get_fields(iuic, fields)
                do n=1,nvar
!            select case (fields(n)%name)
                   select case ( mpp_get_field_name(fields(n)))
                   case ('ak')
                       call mpp_read(iuic,fields(n),ak)
                   case ('bk')
                       call mpp_read(iuic,fields(n),bk)
                   end select
                enddo
                call mpp_close(iuic)
                deallocate(fields)
            endif
        endif
        if ( im /= nlon .or. jm /= mlat .or. km /= nlev ) then
            write(6,*) 'Dataset resolution:',im, jm, km, nqrst
            call error_mesg('read_fv_rst:','resolution inconsistent', FATAL)
        endif

        if ( nqrst > nt_phys .or. nqrst > nq) then
            write(6,*) ' '
            write(6,*) '---- Warning -------'
            write(6,*) 'Total number of tracers in restart file is greater than either'
            write(6,*) 'NT_PHYS or NQ.  The number NT_PHYS from the namelist is used.'
            write(6,*) 'NQRST=', nqrst, 'NT_PHYS=', nt_phys, ' NQ=', nq
            nqrst = nt_phys
        endif
        if (use_native_format) then
            read(iuic) days, seconds
            read(iuic) ak, bk, ks
        endif
        write(6,*) 'Restart days=', days,' sec=',seconds
        write(6,*) '----------------------------------'
        write(6,*) 'Model Top Pressure (pa)= ', ak(1)
        write(6,*) '----------------------------------'
        write(6,*) 'Checking Initial condition ...'
    endif

#ifdef SPMD           
!    call mp_bcst_int(days)
!    call mp_bcst_int(seconds)
!    call mp_bcst_int(im)
!    call mp_bcst_int(jm)
!    call mp_bcst_int(km)
!    call mp_bcst_int(nqrst)
!    call mp_bcst_int(ks)
!
!    call mp_bcst_r2d(km+1, 1, 1, 1, ak, 0)
!    call mp_bcst_r2d(km+1, 1, 1, 1, bk, 0)
    call mpp_broadcast( days, mpp_root_pe() )
    call mpp_broadcast( seconds, mpp_root_pe() )
    call mpp_broadcast( im, mpp_root_pe() )
    call mpp_broadcast( jm, mpp_root_pe() )
    call mpp_broadcast( km, mpp_root_pe() )
    call mpp_broadcast( nqrst, mpp_root_pe() )
    call mpp_broadcast( ks, mpp_root_pe() )

    call mpp_broadcast( ak, km+1, mpp_root_pe() )
    call mpp_broadcast( bk, km+1, mpp_root_pe() )
#endif

    ptop = ak(1)

    if (use_native_format) then   
!---------------------------
! read surface geopotential
!---------------------------
        allocate ( w2d(im,jm) )
#ifdef SPMD
        if ( master ) read(iuic) w2d
        call mp_scatter3d(w2d, phis, im,  jm, 1, beglat, endlat,  &
             1, 1, ighost, ighost, 0)
        call fv_array_sync
#else
        read(iuic) w2d
        do j=beglat,endlat
           do i=1,im
              phis(i,j) = w2d(i,j)
           enddo
        enddo
#endif
!       call pmaxming('PHIS', phis, im, jm, 1, beglat, endlat,   &
!                     ighost, ighost, ginv)

        allocate ( w3d(im, jm, km) )

!---------------------------
! Read u-wind
!---------------------------

#ifdef SPMD
        if ( master ) read(iuic) w3d
        call mp_scatter3d(w3d, u, im,  jm, km, beglat, endlat,  &
             1, km, ng_d, ng_s, 0)
        call fv_array_sync
#else
        read(iuic) u
#endif

!---------------------------
! Read v-wind
!---------------------------

#ifdef SPMD
        if ( master ) read(iuic) w3d
        call mp_scatter3d(w3d, v, im,  jm, km, beglat, endlat,  &
             1, km, ng_d, ng_d, 0)
        call fv_array_sync
#else
        read(iuic) v
#endif

!-----------------------------------
! Read virtual potential temperature
!-----------------------------------

#ifdef SPMD
        if ( master ) read(iuic) w3d
        call mp_scatter3d(w3d, pt, im,  jm, km, beglat, endlat,  &
             1, km, ng_d, ng_d, 0)
        call fv_array_sync
#else
        read(iuic) pt
#endif

!-----------------------------------
! Read pressure thickness (pascal)
!-----------------------------------

#ifdef SPMD
        if ( master ) read(iuic) w3d
        call mp_scatter3d(w3d, delp, im,  jm, km, beglat, endlat,  &
             1, km, 0, 0, 0)
        call fv_array_sync
#else
        read(iuic) delp
#endif

    else  
!this code may not work? all these fields do not have the same data domain
        call mpp_get_data_domain( fv_domain, ids, ide, jds, jde )
        call mpp_get_compute_domain( fv_domain, ics, ice, jcs, jce )
        call read_data ( restart_name, 'Surface_geopotential', phis(ids:ide,jcs:jce), domain = fv_domain)
        call read_data ( restart_name, 'U', u(ids:ide,jds:jde,:) , domain = fv_domain)
        call read_data ( restart_name, 'V', v(ids:ide,jds:jde,:), domain = fv_domain)
        call read_data ( restart_name, 'T', pt(ids:ide,jds:jde,:), domain = fv_domain)
        call read_data ( restart_name, 'DELP', delp(ids:ide,jcs:jce,:), domain = fv_domain) !RASF Bug fix for indices
    endif ! not use_native_format

#ifdef SHAVE_P
    call set_eta(km, ks, ptop, ak, bk)
    do j=beglat,endlat
       do i=1,im
          delp(i,j,1) = ak(2) - ak(1)
       enddo
    enddo
#endif

!------------------------------------
! Read tracers one at a time
!------------------------------------

    if (use_native_format) then 
        do n=1, nqrst

#ifdef SPMD
           if ( master ) read(iuic) w3d
           call mp_scatter3d(w3d, q(1,beglat-ng_d,1,n), im,  jm, km, beglat, endlat,  &
                1, km, ng_d, ng_d , 0)
           call fv_array_sync
#else
           read(iuic) w3d
           do k=1,nlev
              do j=beglat,endlat
                 do i=1,im
                    q(i,j,k,n) = w3d(i,j,k)
                 enddo
              enddo
           enddo
#endif
        enddo
    else        ! ----------read "dynamics" tracers  from tracer restart file 
#ifdef MARS_GCM
!rjw      ------No longer require specific water vapor fields in netcdf version of tracer restart file
!rjw          It now makes more sense to read all the tracers from the tracer file
!rjw           in a single loop, that appears below in the processing of field manager tracers
#else
        do n =1,nqrst
           call read_data(fms_tracers_restart_file,fv_tr_name(n),q(ids:ide,jds:jde,:,n) , domain = fv_domain)
        enddo
#endif MARS_GCM 
    endif ! --------------- Finished reading dynamcics tracers ------------


    if( age_tracer ) call error_mesg('read_fv_rst', 'age_tracer == .T. not yet working', FATAL)

    if (use_native_format) then 
        if ( age_tracer .and. nqrst == nq ) then  ! this check will not work properly (pletzer)
!           q = 0. ; age_time = 0.
            if(master) read(iuic) age_time
#ifdef SPMD
!            call mp_bcst_real(age_time)
            call mpp_broadcast( age_time, mpp_root_pe() )
#endif
        endif

        if ( master ) call close_file(iuic)
    endif

!-----------------------------------------
! Read additional tracers from netCDF file
!-----------------------------------------

#ifdef MARS_GCM
    if (do_fms_tracer_manager ) then !{
#else
    if (do_fms_tracer_manager .and. nq > nt_phys) then !{
#endif MARS_GCM

       !Modify the filename if it has an ensemble instance appendix
       call get_instance_filename(fms_tracers_restart_file,restart_name )
       restart_name=trim(restart_name)
        if( .not. file_exist(restart_name//'.nc') ) then !{

            if(master) then
                write(*,*)'---- Warning -------'
                write(*,*)'do_fms_tracer_manager=',do_fms_tracer_manager, &
                     ' no of tracers nq=', nq
                write(*,*)'but netcdf restart file ', restart_name//'.nc', ' does not exist'
                write(*,*)'--------------------'               
            endif

        else !}{

            if(master) then
                write(*,*)'Additional tracers present in field_table. '
                write(*,*)'These will be read from netcdf file ',restart_name
            endif

            call mpp_open(iuic, restart_name, &
                 action=MPP_RDONLY, form=MPP_NETCDF, threading=MPP_SINGLE )

            call mpp_read_meta(iuic)
            call mpp_get_info(iuic,ndim,nvar,natt,ntime)
            if ( nt_phys+nvar /= nq ) then
                if (master) then 
                    write(6,*) ' '
                    write(6,*) '---- Warning -------'
                    write(6,*) 'Total number of tracers nq from netcdf and binary restart files does not match'
                    write(6,*) 'nt_phys=', nt_phys,' nvar=', nvar,' nq=', nq, ' nt_phys+nvar /= nq'
                    write(*,*)'---------------------'        
                endif
            endif
            allocate(tracer_fields(nvar))
!if(master) 
            call mpp_get_fields(iuic, tracer_fields)

! read only the tracers that are registered in the tracer manager
            call get_number_tracers(MODEL_ATMOS, num_tracers=ntracers)
            n = 0 
            call mpp_get_data_domain( fv_domain, ids, ide, jds, jde )
            do it = 1, ntracers !{
! loop over tracers
               call get_tracer_names(MODEL_ATMOS, it, tname)
#ifdef MARS_GCM

#else
               if (use_native_format) then
! exclude tracers read from native format file 
                   if(tname == "sphum"  ) cycle
                   if(tname == "liq_wat") cycle
                   if(tname == "ice_wat") cycle
                   if(tname == "cld_amt") cycle
               endif
#endif MARS_GCM
! this tracer will be added
               n = n + 1
               is_tracer_in_restart_file = .FALSE.
               do jn = 1, nvar !{
! loop over netcdf file tracers                  
!                  if(  lowercase( trim(tracer_fields(jn)%name) ) == lowercase( trim(tname) )  ) then !{
                  if(  lowercase( trim(mpp_get_field_name(tracer_fields(jn))) ) == lowercase( trim(tname) )  ) then !{
                      if(master) print *,'tracer ', trim(tname), ' found!'
! ok found the tracer in the restart file
                      is_tracer_in_restart_file = .TRUE.
! read data and store in array w3d
!                     call mpp_read(iuic, tracer_fields(jn), w3d)
                      call read_data( restart_name, tname, &
                           q(ids:ide,jds:jde,:,it), domain = fv_domain)
                  endif !}
                  if(is_tracer_in_restart_file) exit
               enddo !}
               if(.NOT. is_tracer_in_restart_file) then !{
! missing tracer from restart file
                   if(master) then
                       write(6,*) '---- Warning -------'
                       write(6,*) 'Tracer ', tname, ' was defined in field table but could not be found in restart file.'
                       write(*,*)'---------------------'        
                   endif
! set default profile
                   call set_tracer_profile (MODEL_ATMOS, it, &
                        q(ids:ide,jds:jde,:,it))
               endif !}
            enddo !}


            call mpp_close(iuic)
            deallocate(tracer_fields)

        endif !}

    endif !}

    if (use_native_format) deallocate ( w3d )
!..............................................................................................

    do j=beglat,endlat
       do i=1,im
          zsurf(i,j) = phis(i,j)
       enddo
    enddo

    call pmaxmin('ZS', zsurf, qmin, qmax, im*(endlat-beglat+1), 1, ginv)
    if ( qmax > 1. ) then
        mountain = .true.
    else
        mountain = .false.
    endif

    call pmaxming('U ',       u, im, jm, km, beglat, endlat, ng_d, ng_s, 1.)
    call pmaxming('V ',       v, im, jm, km, beglat, endlat, ng_d, ng_d, 1.)
!    call pmaxming('DELP ', delp, im, jm, km, beglat, endlat, 0,       0, 1.)
    call pmaxming('T ',      pt, im, jm, km, beglat, endlat, ng_d, ng_d, 1.)
    do n=1, nqrst
       call pmaxming('Q ', q(1,beglat-ng_d,1,n), im, jm, km, beglat, endlat, ng_d, ng_d, 1.)
    enddo

!-----------------------
! Add additional tracers:
!-----------------------

#ifdef SET_Q_TOP
! Set water vapor at top layer to climatology value (for stratosphere)
    do j=beglat, endlat
       do i=1,im
          q(i,j,1,1) = 3.E-6
       enddo
    enddo
#endif

    if( use_set_eta ) call set_eta(km, ks, ptop, ak,  bk)

    call p_var(nlon, mlat, nlev, beglat, endlat, ptop, delp, ps,           &
         pe, peln,  pk,  pkz,  kappa, q, ng_d, ncnst, adjust_dry_mass )

!---------------------------------------------------
! Read surface pressure & winds for coupling purpose
!---------------------------------------------------

    !Modify the filename if it has an ensemble instance appendix
    call get_instance_filename('INPUT/fv_srf_wnd.res',restart_name )
    restart_name=trim(restart_name)

    if (file_exist(restart_name) .or. file_exist(trim(restart_name)//'.nc')) then
        if (use_native_format) then 
            if( master ) then
!!$         call mpp_open (iuic, restart_name, action=MPP_RDONLY,      &
!!$                        form=MPP_NATIVE, access=MPP_SEQUENTIAL)
                iuic = open_restart_file(restart_name, 'read')
                read(iuic) im, jm
                if ( im /= nlon .or. jm /= mlat ) then
                    write(6,*) 'Dataset resolution:',im, jm
                    call error_mesg('read_fv_rst:','resolution inconsistent in fv_srf_wnd', FATAL)
                endif
            endif

! Read ps_bp (surface pressure before physics update):
            if(master) read(iuic) w2d
#ifdef SPMD
            call mp_scatter3d(w2d, ps_bp, im,  jm, 1, beglat, endlat,  &
                 1, 1, 0, 0, 0)
            call fv_array_sync
#endif
! Read u-comp
            if(master) read(iuic) w2d
#ifdef SPMD
            call mp_scatter3d(w2d, u_srf, im,  jm, 1, beglat, endlat,  &
                 1, 1, 0, 0, 0)
            call fv_array_sync
#endif
! Read v-comp
            if(master)  read(iuic) w2d
#ifdef SPMD
            call mp_scatter3d(w2d, v_srf, im,  jm, 1, beglat, endlat,  &
                 1, 1, 0, 0, 0)
            call fv_array_sync
#endif
            if(master)  call close_file(iuic)


        else ! not native format

            call mpp_open(iuic, restart_name, &
                 action=MPP_RDONLY, form=MPP_NETCDF, threading=MPP_SINGLE )
            if (master ) then
                call mpp_read_meta(iuic)
                call mpp_get_info(iuic,ndim,nvar,natt,ntime)

                allocate(attributes(natt))
                call mpp_get_atts(iuic,attributes)

                do n= 1,natt
!            select case (attributes(n)%name)
                   select case ( mpp_get_att_name(attributes(n)))
                   case ('nlon')
                       im= int(mpp_get_att_real_scalar(attributes(n)))
                   case ('mlat')
                       jm= int(mpp_get_att_real_scalar(attributes(n)))
                   end select
                enddo
                deallocate(attributes)
            endif

            call mpp_close(iuic)

            if ( im /= nlon .or. jm /= mlat ) then
                write(6,*) 'Dataset resolution:',im, jm
                call error_mesg('read_fv_rst:','resolution inconsistent in fv_srf_wnd', FATAL)
            endif
            call read_data ( restart_name, 'ps_bp', ps_bp(ids:ide,jcs:jce), domain = fv_domain)
            call read_data ( restart_name, 'U_srf', u_srf(ids:ide,jcs:jce), domain = fv_domain)
            call read_data ( restart_name, 'V_srf', v_srf(ids:ide,jcs:jce), domain = fv_domain)
        endif

    else

        if(master) then
            write(*,*) ' '
            write(*,*) '--------------------------------------------'
            write(*,*) 'File not found: ',restart_name
            write(*,*) 'Surface winds will be generated from D grid'
            write(*,*) '--------------------------------------------'
        endif


        do j=beglat,endlat
           do i=1,im
              ps_bp(i,j) = ps(i,j)
           enddo
        enddo

        call d2a3d(u(1,beglat-ng_d,km), v(1,beglat-ng_d,km), u_srf, v_srf, &
             nlon, mlat, 1, beglat, endlat, ng_d, ng_s, coslon, sinlon)
    endif

    call pmaxming('u_srf ', u_srf, im, jm, 1, beglat, endlat, 0,  0, 1.)
    call pmaxming('v_srf ', v_srf, im, jm, 1, beglat, endlat, 0,  0, 1.)

    if (use_native_format) deallocate ( w2d )


! check sum input data
    call print_check_sum ('Check sums for FV input data:')
    if( master ) then 
        call error_mesg ('read_fv_rst', 'FV netcdf restart file read.', NOTE)
    endif


#ifdef PLET
! Do Pure Lagrangian Error Test
    if ( nq >= 7 ) then
        p0 = (1.E5) ** kappa
!$omp  parallel do private(i,j,k)
        do k=ksp,kep
           do j=beglat, endlat
              do i=1,im
                 q(i,j,k,nq-2) = pt(i,j,k)                   
                 q(i,j,k,nq-1) = pt(i,j,k)/pkz(i,j,k) * p0
                 q(i,j,k,nq) = pkz(i,j,k) * p0
              enddo
           enddo
        enddo
        call fv_array_sync()
    endif
#endif

  end subroutine read_fv_rst


  subroutine add_tracers( q, im, jm, km, nq, nqrst, beglat, endlat, ng,  &
       age_tracer, age_time  )

    integer, intent(in):: im,jm,km,nq
    integer, intent(in):: nqrst
    integer, intent(in):: beglat, endlat
    integer, intent(in):: ng
    logical, intent(in):: age_tracer

    real, intent(inout):: age_time
    real, intent(inout):: q(im, beglat-ng:endlat+ng, km, nq)
! Local:
    integer i,j,k,iq

    call fv_array_check( LOC(q) )
    do iq=nqrst+1, nq
!$omp  parallel do private(i,j,k)
       do k=ksp,kep
          do j=beglat, endlat
             do i=1,im
                q(i,j,k,iq) = 0.
             enddo
          enddo
       enddo
    enddo
    call fv_array_sync()

    if ( age_tracer ) age_time = 0.

  end subroutine add_tracers

  subroutine fv_restart(days, seconds)

#include "fv_arrays.h"

    integer, intent(out):: days
    integer, intent(out):: seconds

    real, allocatable :: g_phis(:,:)
    real, allocatable :: qtmp(:,:,:)
    integer :: iuhs          ! Unit to read in terrain data for cold start
    integer :: i,j,k
    integer :: im, jm, km
    character(len=128) :: restart_name

#ifdef MARS_GCM 
    character (len=128) :: filename, fieldname
#endif MARS_GCM

#include "fv_point.inc"

    call fv_print_chksums( 'Entering  fv_restart' )
    if (cold_start) then

#ifdef SW_DYN

        if(nlev /= 1)  call error_mesg('FV_init:','Set nlev=1 for Shallow Water Dynamics', FATAL)

!-----------------------
! Shallow water dynamics
!-----------------------
        ptop  = 0.
        ak(1) = 0.
        ak(2) = 0.
        bk(1) = 0.
        bk(2) = 1.
        KS    = 0
#ifndef USE_LIMA
        n_spong = 0
#endif
        call init_sw_ic(icase, nlon, mlat, nlev, ncnst, beglat, endlat, ng_d, ng_s,  &
             phis, u, v, pt, delp, q, grav, radius, omega, f_d, ighost )
#else

! Start from a "dry & cold" isothermal atmosphere at rest

#ifdef MARS_GCM
        filename= 'INPUT/surf.res.nc' 
        fieldname= 'topo'

        if (file_exist( trim(filename) )) then
            mountain = .true.

           if(master) then
              allocate ( g_phis(nlon,mlat) )
              call read_data( trim(filename), trim(fieldname), g_phis, no_domain=.true. )
           endif

           call mp_scatter3d(g_phis, phis,  nlon, mlat,  1,  &
                             beglat, endlat, 1, 1, ighost, ighost, 0)

           call fv_array_sync
           if(master) deallocate ( g_phis )

            phis = phis * grav
        else
            mountain = .false.
            if(master) write(6,*) 'No surface dataset found; setting phis = 0'
            phis = 0.
        endif
#else

        !Modify the filename if it has an ensemble instance appendix
        call get_instance_filename('INPUT/surf.res',restart_name )
        restart_name=trim(restart_name)

        if (file_exist(restart_name)) then
            mountain = .true.
            if(master) call mpp_open(iuhs, restart_name, action=MPP_RDONLY,        &
                 form=MPP_NATIVE, access=MPP_SEQUENTIAL)
#ifdef SPMD
            if(master) then
                allocate ( g_phis(nlon,mlat) )
                read(iuhs) g_phis
            endif
            call mp_scatter3d(g_phis, phis,  nlon, mlat,  1,  &
                 beglat, endlat, 1, 1, ighost, ighost, 0)
            call fv_array_sync
            if(master) deallocate ( g_phis )
#else
            read(iuhs) phis
#endif
            if(master) close (iuhs)
            phis = phis * grav
        else
            mountain = .false.
            if(master) write(6,*) 'No surface dataset found; setting phis = 0'
            phis = 0.
        endif

#endif MARS_GCM

        call set_eta(nlev, ks, ptop, ak, bk)
        call init_dry_atm(mountain, kappa, grav, rdgas)

        if ( age_tracer ) then
            age_time = 0.
!$omp parallel do private (i, j, k)
!         do k=1,nlev
            do k=ksp,kep
               do j=beglat, endlat
                  do i=1,nlon
                     q(i,j,k,ncnst) = 0.
                  enddo
               enddo
            enddo
            call fv_array_sync()
        endif

#endif
    else
!---------------------------
! Read from the restart file
!---------------------------
        restart_name ='INPUT/fv_rst.res'
        !The call get_instance_filename() is inside the read_fv_rst subroutine 
        call read_fv_rst(im, jm, km, ncnst, restart_name, days, seconds, restart_format)

!   call p_var(nlon, mlat, nlev, beglat, endlat, ptop, delp, ps,           &
!              pe, peln,  pk,  pkz,  kappa, q, ng_d, ncnst, adjust_dry_mass )
    endif

#ifdef SPMD
! Ghost phis boundary N/S
    if ( ighost /= 0 ) then
        call mp_send4d_ns(nlon, mlat, 1, 1, beglat, endlat,       &
             1, 1, ighost, ighost, phis)
        call mp_recv4d_ns(nlon, mlat, 1, 1, beglat, endlat,       &
             1, 1, ighost, ighost, phis)
        call fv_array_sync()
    endif
#endif

!------------------------------------------------
! Safety check of the (a,b) of the eta coordinate
!------------------------------------------------

    call check_eta(nlev, ks, ptop, ak, bk)

! Generate winds on the mass grid for the physics/coupler:
    if ( use_tendency ) then
        call d2a3d(u, v, ua, va, nlon, mlat, nlev, beglat, endlat,  &
             ng_d, ng_s, coslon, sinlon)
    endif
    call fv_print_chksums( 'Exiting  fv_restart' )
  end subroutine fv_restart
! $Id: fv_restart.F90,v 17.0 2009/07/21 02:53:25 fms Exp $

  subroutine write_fv_rst( dflnm, days, seconds, grav, oform)

#include "fv_arrays.h"

! !INPUT PARAMETERS:
    integer,  intent(in):: days
    integer,  intent(in):: seconds
    real, intent(in):: grav
    character*(*), intent(in):: dflnm           ! dynamics restart filename
    character(len=*), intent(in) :: oform

! local
    integer :: iuic                 ! Unit number
    real, allocatable :: w2d(:,:), w3d(:,:,:), latu(:), phis_alloc(:,:), delp_alloc(:,:,:)
    real :: ginv, qmax, qmin
    real :: pfull(nlev), phalf(nlev+1)
    integer i, j, k, n

    character(len=128)           :: tracer_name, tracer_longname, tracer_units
    type(axistype)               :: axis_lon, axis_lat, axis_lev, axis_levh, &
                                    axis_lonv, axis_latu, axis_time
    type(fieldtype), allocatable :: tracer_fields(:)
    type(fieldtype)              :: u_field, v_field, t_field, phis_field, delp_field

    type(fieldtype)              :: ak_field, bk_field

    character(len=*), parameter :: fms_tracers_restart_file = &
         'RESTART/'//fms_tracers_file

    character(len=128) :: directory, restart_name, tr_name
    logical :: use_native_format
    integer :: ids,ide, jds,jde, ics,ice,jcs,jce
    integer :: nsphum, nliq_wat, nice_wat, ncld_amt, ntracers
    real :: dummy(1) =1.0

#ifdef MARS_GCM
!rjw     fv_tr_name is not used in this subroutine      
#else
    character(len=20) :: fv_tr_name(4)
    data fv_tr_name / "sphum","liq_wat","ice_wat","cld_amt" /
#endif MARS_GCM

#include "fv_point.inc"

! output format
    if (trim(uppercase(oform)) == 'NATIVE') then
        use_native_format = .true.
    else if (trim(uppercase(oform)) == 'NETCDF') then
        use_native_format = .false.
    else
        call error_mesg ('write_fv_rst', &
             'invalid value for argument oform='//trim(oform), FATAL)
    endif

! check sum output data
  call print_check_sum ('Check sums for FV output data:')

    if (use_native_format) then
        if ( master ) then
!!$         if (file_exist(dflnm)) then
!!$             call mpp_open ( iuic, dflnm, action=MPP_OVERWR,        &
!!$                             form=MPP_NATIVE, access=MPP_SEQUENTIAL )
!!$         else
!!$             call mpp_open ( iuic, dflnm, action=MPP_WRONLY,        &
!!$                             form=MPP_NATIVE, access=MPP_SEQUENTIAL )
!!$            
!!$         endif
           !Modify the filename if it has an ensemble instance appendix
            call get_instance_filename(dflnm,restart_name )
            restart_name=trim(restart_name)
            iuic = open_restart_file(restart_name, 'write')
            write(iuic) nlon, mlat, nlev, nt_phys
            write(iuic) days, seconds
            write(iuic) ak, bk, ks
            write(6,*) ' '
            write(6,*) 'FV restart file header written for days=', days, 'sec=',seconds
        endif

        call pmaxmin('PS', ps(1,beglat), qmin, qmax, nlon, endlat-beglat+1, 0.01)

!---------------------------
! Write surface geopotential
!---------------------------
#ifdef SPMD
        allocate ( w2d(nlon,mlat) )
        call mp_gather3d(phis, w2d, nlon, mlat, 1, beglat, endlat, 1, 1,  &
             ighost, ighost, 0)
        if ( master ) then
            write(iuic) w2d
            ginv = 1./ grav
            call maxmin_global('Surface height', w2d, nlon, 1, mlat, ginv)
        endif
#else
        write(iuic) phis
#endif

        allocate ( w3d(nlon,mlat,nlev) )

!---------------------------
! Write u-wind
!---------------------------

#ifdef SPMD
        call mp_gather3d(u, w3d, nlon, mlat, nlev, beglat, endlat, 1, nlev, ng_d, ng_s, 0)
        if ( master ) then
            write(iuic) w3d
            call maxmin_global('U', w3d, nlon, mlat, nlev, 1.)
        endif
#else
        write(iuic) u
#endif

!---------------------------
! Write v-wind
!---------------------------

#ifdef SPMD
        call mp_gather3d(v, w3d, nlon, mlat, nlev, beglat, endlat, 1, nlev, ng_d, ng_d, 0)
        if ( master ) then
            write(iuic) w3d
            call maxmin_global('V', w3d, nlon, mlat, nlev, 1.)
        endif
#else
        write(iuic) v
#endif

!------------------------------------
! Write virtual potential temperature
!------------------------------------

#ifdef SPMD
        call mp_gather3d(pt, w3d, nlon, mlat, nlev, beglat, endlat, 1, nlev, ng_d, ng_d, 0)
        if ( master ) then
            write(iuic) w3d
            call maxmin_global('T', w3d, nlon, mlat, nlev, 1.)
        endif
#else
        write(iuic) pt
#endif

!------------------------------------
! Write pressure thickness (pascal)
!------------------------------------

#ifdef SPMD
        call mp_gather3d(delp, w3d, nlon, mlat, nlev, beglat, endlat, 1, nlev, 0, 0, 0)
        if ( master ) then
            write(iuic) w3d
!            call maxmin_global('DELP', w3d, nlon, mlat, nlev, 1.)
        endif
#else
        write(iuic) delp
#endif


        if(ncnst /=  0) then 
!------------------------------------
! Write tracers one at a time
!------------------------------------

            do n=1,nt_phys 

#ifdef SPMD
               call mp_gather3d(q(1,beglat-ng_d,1,n), w3d, nlon, mlat, nlev,    &
                    beglat, endlat, 1, nlev, ng_d, ng_d, 0)
#else
               do k=1,nlev
                  do j=beglat,endlat
                     do i=1,nlon
                        w3d(i,j,k) = q(i,j,k,n)
                     enddo
                  enddo
               enddo
#endif
               if ( master ) then
                   write(iuic) w3d
                   call maxmin_global('Q', w3d, nlon, mlat, nlev, 1.)
               endif
            enddo
            if ( master .and. age_tracer ) write(iuic) age_time
        endif

        if( master ) then 
            call close_file(iuic)
            write(*,*) 'FV restart file written and closed'
        endif

!--------------------------------------------------------------
! Write surface winds on A grid for coupler to restart properly
!--------------------------------------------------------------

        if ( master ) then
           !Modify the filename if it has an ensemble instance appendix
            call get_instance_filename('RESTART/fv_srf_wnd.res',restart_name )
            restart_name=trim(restart_name)
            iuic = open_restart_file(restart_name, 'write')
            write(iuic) nlon, mlat
        endif

#ifdef SPMD
        call mp_gather3d(ps_bp, w2d, nlon, mlat, 1, beglat, endlat, 1, 1,  &
             0, 0, 0)
#endif
        if (master) write(iuic) w2d

#ifdef SPMD
        call mp_gather3d(u_srf, w2d, nlon, mlat, 1, beglat, endlat, 1, 1,  &
             0, 0, 0)
#endif
        if (master) write(iuic) w2d

#ifdef SPMD
        call mp_gather3d(v_srf, w2d, nlon, mlat, 1, beglat, endlat, 1, 1,  &
             0, 0, 0)
#endif
        if (master) then
            write(iuic) w2d
            call close_file(iuic)
        endif

!----------------------------------------
! Write additional tracers to netCDF file
!----------------------------------------

        if (do_fms_tracer_manager .and. ncnst > nt_phys) then !{

            if(master) &
                 & write(*,*)'Additional tracers present in field_table. These will be saved in a netcdf file.'

#ifdef MARS_GCM
            call get_eta_level(nlev, p_ref, pfull, phalf, 0.01)
#else
            call get_eta_level(nlev, 1.E5, pfull, phalf, 0.01)
#endif MARS_GCM

            !Modify the filename if it has an ensemble instance appendix
            call get_instance_filename(fms_tracers_restart_file,restart_name )
            restart_name=trim(restart_name)
            call mpp_open(iuic, restart_name, &
                 action=MPP_OVERWR, form=MPP_NETCDF, threading=MPP_SINGLE )

! define axes
            call mpp_write_meta(iuic, axis_lon, 'lon', 'degree_E', 'longitude', &
                 data=lon )
            call mpp_write_meta(iuic, axis_lat, 'lat', 'degree_N', 'latitude', &
                 data=lat )
            call mpp_write_meta(iuic, axis_lev, 'pfull', 'mb', 'ref full pressure level', &
                 data=pfull )

! define fields
            allocate(tracer_fields(ncnst))

            do n = nt_phys+1, ncnst
               call tr_get_tracer_names(MODEL_ATMOS, n, &
                    tracer_name, tracer_longname, tracer_units)
               call mpp_write_meta(iuic, tracer_fields(n), &
                    (/axis_lon, axis_lat, axis_lev/), &
                    tracer_name, tracer_units, tracer_longname, pack=1) ! want doubles
            enddo

! write axes
            call mpp_write(iuic, axis_lon)
            call mpp_write(iuic, axis_lat)
            call mpp_write(iuic, axis_lev)

! write tracers
            do n = nt_phys+1, ncnst
#ifdef SPMD
               call mp_gather3d(q(1,beglat-ng_d,1,n), w3d, nlon, mlat, nlev,    &
                    beglat, endlat, 1, nlev, ng_d, ng_d, 0)
#else
               do k=1,nlev
                  do j=beglat,endlat
                     do i=1,nlon
                        w3d(i,j,k) = q(i,j,k,n)
                     enddo
                  enddo
               enddo
#endif
               if(master) call mpp_write(iuic, tracer_fields(n), data=w3d)

            enddo

            call mpp_close(iuic)
            deallocate(tracer_fields)

        endif !}


        deallocate ( w3d )
        deallocate ( w2d )

    else ! ! ------------------NetCDF restart files---------
        call mpp_get_data_domain   ( fv_domain, ids, ide, jds, jde )
        call mpp_get_compute_domain( fv_domain, ics, ice, jcs, jce )
        restart_name = trim(dflnm) ! add netcdf file suffix

        !Modify the filename if it has an ensemble instance appendix
        call get_instance_filename(restart_name,restart_name )
        restart_name=trim(restart_name)
            
        call mpp_open(iuic, restart_name, &
             action=MPP_OVERWR, form=MPP_NETCDF, threading=MPP_SINGLE )

! define axes
#ifdef MARS_GCM
        call get_eta_level(nlev, p_ref, pfull, phalf, 0.01)
#else
        call get_eta_level(nlev, 1.E5, pfull, phalf, 0.01)
#endif MARS_GCM
!        if(master) write(*,*) "phalf values are ",phalf    
! define longitude axis for u and tracer fields
        call mpp_write_meta(iuic, axis_lon, 'lon', 'degree_E', 'longitude', &
             data=lon )

! define longitude axis for v field
        call mpp_write_meta(iuic, axis_lonv, 'lonv', 'degree_E', 'longitude', &
             data=lonb(1:size(lonb)-1) )


! define latitude axis for v and tracer fields
        call mpp_write_meta(iuic, axis_lat, 'lat', 'degree_N', 'latitude', &
             data=lat )

! define latitude axis for u field
        allocate(latu(size(lat)))
        ! The first latitude corresponds to meaningless data for the South Pole. 
        ! For interpolation reasons, it has been decided to set this latitude to 
        ! the second latitude with a small offset for Ferret compatibility.
        latu(1)  = latb(2) - 1e-5
        latu(2:) = latb(2:size(lat))
        call mpp_write_meta(iuic, axis_latu, 'latu', 'degree_N', 'latitude', &
             data=latu )

! define pressure axis
        call mpp_write_meta(iuic, axis_lev, 'pfull', 'mb', 'ref full pressure level', &
             data=pfull )
        call mpp_write_meta(iuic, axis_levh, 'phalf', 'mb', 'ref half pressure level', &
             data=phalf )

        call mpp_write_meta(iuic, axis_time, 'Time', 'time level', 'Time', &
                            cartesian='T', data=dummy)

        call mpp_write_meta(iuic, ak_field, (/axis_levh/), &
             'ak', 'Pa', 'ak-field', pack=1) ! want doubles
        call mpp_write_meta(iuic, bk_field, (/axis_levh/), &
             'bk', ' ', 'bk-field', pack=1)

        call mpp_write_meta(iuic, 0, 'nlon', ival=nlon)     
        call mpp_write_meta(iuic, 0, 'mlat', ival=mlat)     
        call mpp_write_meta(iuic, 0, 'nlev', ival=nlev)     

        call mpp_write_meta(iuic, 0, 'nt_phys', nt_phys)     
        call mpp_write_meta(iuic, 0, 'days', days)     
        call mpp_write_meta(iuic, 0, 'seconds', seconds)     
        call mpp_write_meta(iuic, 0, 'ks', ks)     

        call mpp_write_meta(iuic, u_field, (/axis_lon , axis_latu, axis_lev, axis_time/), &
             'U', 'm/s', 'u-field', pack=1)
        call mpp_write_meta(iuic, v_field, (/axis_lonv, axis_lat , axis_lev, axis_time/), &
             'V', 'm/s', 'v-field', pack=1)
        call mpp_write_meta(iuic, t_field, (/axis_lon , axis_lat , axis_lev, axis_time/), &
             'T', 'K', 'Temperature', pack=1)
        call mpp_write_meta(iuic, phis_field, (/axis_lon, axis_lat, axis_time/), &
             'Surface_geopotential', 'm**2/s**2', 'Surface Height', pack=1)
        call mpp_write_meta(iuic, delp_field, (/axis_lon, axis_lat, axis_lev, axis_time/), &
             'DELP', 'pa', 'delp-field', pack=1)

! write axes
        call mpp_write(iuic, axis_time)
        call mpp_write(iuic, axis_lon)
        call mpp_write(iuic, axis_lonv)
        call mpp_write(iuic, axis_lat)
        call mpp_write(iuic, axis_latu)
        call mpp_write(iuic, axis_lev)

        call mpp_write(iuic, bk_field, bk)     
        call mpp_write(iuic, ak_field, ak)     

        call mpp_write(iuic, u_field, fv_domain, u(ids:ide,jds:jde,:))
        call mpp_write(iuic, v_field, fv_domain, v(ids:ide,jds:jde,:))
        call mpp_write(iuic, t_field, fv_domain, pt(ids:ide,jds:jde,:))
! The mpp_io code uses Cray pointers which doesn't work well with the PSET 
! 2D arrays of the FV code. Therefore a copy of the 2D array is needed before 
! passing the array to the mpp_write routine.
        allocate (phis_alloc(ids:ide,jds:jde))
        phis_alloc = -999.9
        phis_alloc(ids:ide,jcs:jce) = phis(ids:ide,jcs:jce)
        call mpp_write(iuic, phis_field, fv_domain, phis_alloc)
        allocate (delp_alloc(ids:ide,jds:jde,nlev))
        delp_alloc = -999.9
        delp_alloc(ids:ide,jcs:jce,:) = delp(ids:ide,jcs:jce,:)   !RASF Bug fix for array bounds
        call mpp_write(iuic, delp_field, fv_domain, delp_alloc)   !RASF Bug fix for array bounds
        deallocate(delp_alloc)


        call mpp_close(iuic)


        call error_mesg ('write_fv_rst', 'Writing NetCDF formatted restart file: '//trim(restart_name), NOTE)

        call get_number_tracers(MODEL_ATMOS, num_tracers=ntracers)


        restart_name = trim(fms_tracers_restart_file)!//'1.nc' ! add netcdf file suffix
        !Modify the filename if it has an ensemble instance appendix
        call get_instance_filename(restart_name,restart_name )
        restart_name=trim(restart_name)

        call mpp_open(iuic, restart_name, &
             action=MPP_OVERWR, form=MPP_NETCDF, threading=MPP_SINGLE )

! define axes

        call mpp_write_meta(iuic, axis_time, 'Time', 'time level', &
                            'Time',cartesian='T', data=dummy)

! define longitude axis for tracer fields
        call mpp_write_meta(iuic, axis_lon, 'lon', 'degree_E', 'longitude', &
             data=lon )

! define latitude axis for tracer fields
        call mpp_write_meta(iuic, axis_lat, 'lat', 'degree_N', 'latitude', &
             data=lat )

! define pressure axis
        call mpp_write_meta(iuic, axis_lev, 'pfull', 'mb', 'ref full pressure level', &
             data=pfull )

! define fields
        allocate(tracer_fields(ntracers))

        do n = 1,ntracers
           call tr_get_tracer_names(MODEL_ATMOS, n, &
                tracer_name, tracer_longname, tracer_units)
           call mpp_write_meta(iuic, tracer_fields(n), &
                (/axis_lon, axis_lat, axis_lev, axis_time/), &
                tracer_name, tracer_units, tracer_longname, pack=1)
        enddo

! write axes
        call mpp_write(iuic, axis_lon)
        call mpp_write(iuic, axis_lat)
        call mpp_write(iuic, axis_lev)
        call mpp_write(iuic, axis_time)

        do n = 1, ntracers
           call mpp_write(iuic, tracer_fields(n), fv_domain, q(ids:ide,jds:jde,:,n))
        enddo

        deallocate(tracer_fields)
        call mpp_close(iuic)


        !Modify the filename if it has an ensemble instance appendix
        call get_instance_filename('RESTART/fv_srf_wnd.res',restart_name )
        restart_name=trim(restart_name)
        call mpp_open(iuic, restart_name, &
             action=MPP_OVERWR, form=MPP_NETCDF, threading=MPP_SINGLE )

! define axes

! define longitude axis for u and tracer fields
        call mpp_write_meta(iuic, axis_lon, 'lon', 'degree_E', 'longitude', &
             data=lon )

! define longitude axis for v field
        call mpp_write_meta(iuic, axis_lonv, 'lonv', 'degree_E', 'longitude', &
             data=lonb(1:size(lonb)-1) )


! define latitude axis for v and tracer fields
        call mpp_write_meta(iuic, axis_lat, 'lat', 'degree_N', 'latitude', &
             data=lat )

! define latitude axis for u field
        latu(1)  = lat(1)
        latu(2:) = latb(2:size(lat))
        call mpp_write_meta(iuic, axis_latu, 'latu', 'degree_N', 'latitude', &
             data=latu )

        call mpp_write_meta(iuic, 'nlon', ival=nlon)     
        call mpp_write_meta(iuic, 'mlat', ival=mlat)     

        call mpp_write_meta(iuic, u_field, (/axis_lon , axis_latu/), &
             'U_srf', 'm/s', 'surface u-field', pack=1)
        call mpp_write_meta(iuic, v_field, (/axis_lonv, axis_lat /), &
             'V_srf', 'm/s', 'surface v-field', pack=1)
        call mpp_write_meta(iuic, phis_field, (/axis_lon, axis_lat/), &
             'ps_bp', 'pa', 'surface pressure', pack=1)

! write axes
        call mpp_write(iuic, axis_lon)
        call mpp_write(iuic, axis_lonv)
        call mpp_write(iuic, axis_lat)
        call mpp_write(iuic, axis_latu)
! The mpp_io code uses Cray pointers which doesn't work well with the PSET 
! 2D arrays of the FV code. Therefore a copy of the 2D array is needed before 
! passing the array to the mpp_write routine.
        phis_alloc = -999.9
        phis_alloc(ids:ide,jcs:jce) = ps_bp(ids:ide,jcs:jce)
        call mpp_write(iuic, phis_field, fv_domain, phis_alloc)
        phis_alloc(ids:ide,jcs:jce) = u_srf(ids:ide,jcs:jce)
        call mpp_write(iuic, u_field, fv_domain, phis_alloc)
        phis_alloc(ids:ide,jcs:jce) = v_srf(ids:ide,jcs:jce)
        call mpp_write(iuic, v_field, fv_domain, phis_alloc)




    endif ! end IF NETCDF
    call fv_array_sync()

  end subroutine write_fv_rst
!---------------------------------------------------------------------

  subroutine maxmin_global(qname, a, im, jm, km, fac)

    implicit none

    character*(*)  qname
    integer im, jm, km
    real a(im,jm, km)
    real fac
    real pmax(km), pmin(km)
    real qmax, qmin
    integer i, j, k

!$omp parallel do private(i, j, k)
!Balaji: not parallelized, called with unshared arrays
    do k=1, km
       pmax(k) = a(1,1,k)
       pmin(k) = a(1,1,k)
       do j=1,jm
          do i=1, im
             pmax(k) = max (pmax(k), a(i,j,k))
             pmin(k) = min (pmin(k), a(i,j,k))
          enddo
       enddo
    enddo

    qmax = pmax(1)
    qmin = pmin(1)
    do k=2,km
       qmax = max (qmax, pmax(k))
       qmin = min (qmin, pmin(k))
    enddo

    write(6,*) qname, ' max = ', qmax * fac, ' min = ', qmin * fac
  end subroutine maxmin_global


subroutine print_check_sum (label)

#include "fv_arrays.h"

 character(len=*),      intent(in) :: label
 integer :: n, chksum_unit
 integer :: isl, iel, jsl, jel
 integer(I8_KIND) :: zsum
#ifdef use_shared_pointers
#include "fv_point.inc"
#endif

  call mpp_get_compute_domain( fv_domain, isl, iel, jsl, jel )
  chksum_unit = stdout()

  if (mpp_pe() == mpp_root_pe()) write (chksum_unit,'(/a)') trim(label)
! sum all restart variables (except eta,peta)
  zsum = mpp_chksum(pt(isl:iel,jsl:jel,:))
  if (mpp_pe() == mpp_root_pe()) write (chksum_unit,10) '(t)',zsum
  zsum = mpp_chksum(u(isl:iel,jsl:jel,:))
  if (mpp_pe() == mpp_root_pe()) write (chksum_unit,10) '(u)',zsum
  zsum = mpp_chksum(v(isl:iel,jsl:jel,:))
  if (mpp_pe() == mpp_root_pe()) write (chksum_unit,10) '(v)',zsum
  zsum = 0
! sum of all tracers
  do n = 1, size(q,4)
    zsum = zsum + mpp_chksum(q(isl:iel,jsl:jel,:,n))
  enddo
  if (mpp_pe() == mpp_root_pe()) write (chksum_unit,10) '(r)',zsum
10 format ('chksum',a7,' = ',z16)

end subroutine print_check_sum

end module fv_restart_mod

module memutils_mod
!Author: Balaji (V.Balaji@noaa.gov)
!Various operations for memory management
!these currently include efficient methods for memory-to-memory copy
!including strided data and arbitrary gather-scatter vectors
!also various memory and cache inquiry operators
  implicit none
  private
#ifdef _CRAYT3E
  integer :: pe, shmem_my_pe
#endif

  integer(kind=8) :: l1_cache_line_size, l1_cache_size, l1_associativity
  integer(kind=8) :: l2_cache_line_size, l2_cache_size, l2_associativity

  logical :: memutils_initialized=.FALSE.

  interface memcpy
     module procedure memcpy_r8
     module procedure memcpy_r8_gather
     module procedure memcpy_r8_scatter
     module procedure memcpy_r8_gather_scatter
  end interface

  public :: get_l1_cache_line, get_l2_cache_line, memcpy, memutils_init
  public :: print_memuse_stats
#ifdef _CRAY
  public :: hplen
#endif
#ifdef _CRAYT90
  public :: stklen
#endif
  logical, private :: print_memory_usage=.FALSE.
  contains

    subroutine memutils_init(print_flag)
!initialize memutils module
!currently sets default cache characteristics
!(will provide overrides later)
!also sets pe to my_pe on t3e
      logical, optional :: print_flag
#ifdef _CRAYT3E
!all sizes in bytes
      l1_cache_line_size = 32
      l1_cache_size = 8192
      l1_associativity = 1
      l2_cache_line_size = 64
      l2_cache_size = 98304
      l2_associativity = 3
#else
!defaults
      l1_cache_line_size = 1
      l1_cache_size = 1
      l1_associativity = 1
      l2_cache_line_size = 1
      l2_cache_size = 1
      l2_associativity = 1
#endif
#ifdef _CRAYT3E
      pe = SHMEM_MY_PE()
#endif
      if( PRESENT(print_flag) )print_memory_usage = print_flag
      memutils_initialized = .TRUE.
      return
    end subroutine memutils_init

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                      !
!MEMCPY routines: <nelems> real*8 words are copied from RHS to LHS     !
!  Either side can have constant stride (lhs_stride, rhs_stride)       !
!      or indexed by a gather/scatter array (lhs_indx, rhs_indx)       !
! index arrays are 0-based (i.e C-like not fortran-like: this is       !
! for compatibility with the SHMEM_IXGET/PUT routines)                 !
!                                                                      !
! EXAMPLES:                                                            !
!                                                                      !
!Replace                                                               !
!  a(0:n-1) = b(0:n-1)                                                 !
!with                                                                  !
!  call memcpy(a,b,n)                                                  !
!                                                                      !
!Replace                                                               !
!  a(0:2*n-1:2) = b(0:3*n-1:3)                                         !
!with                                                                  !
!  call memcpy(a,b,dim,n,2,3)    !dim.GE.3*n                           !
!                                                                      !
!Replace                                                               !
!  a(0:n-1) = b(indx(1:n))                                             !
!with                                                                  !
!  call memcpy(a,b,dim,n,1,indx) !dim.GE.max(indx)                     !
!                                                                      !
!Replace                                                               !
!  a(indx(1:n)) = b(0:n-1)                                             !
!with                                                                  !
!  call memcpy(a,b,dim,n,indx,1) !dim.GE.max(indx)                     !
!                                                                      !
!Replace                                                               !
!  a(indxa(1:n)) = b(indxb(1:n))                                       !
!with                                                                  !
!  call memcpy(a,b,dim,n,indx,indxb) !dim.GE.max(indxa,indxb)          !
!                                                                      !
!  There are no error checks!!! (routines are built for speed)         !
!  Specifically there is no bounds-checking: if the stride or          !
!  indexing causes you to exceed <dim> you will have done a            !
!  potentially unsafe memory load                                      !
!                                                                      !
!T3E: we use the shmem routines on-processor to effect the transfer    !
!     via the (faster) E-registers                                     !
!                                                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    subroutine memcpy_r8( lhs, rhs, dim, nelems, lhs_stride, rhs_stride )
!base routine: handles constant stride memcpy
!default strides are of course 1
      integer, intent(in) :: dim
      real(kind=8), dimension(0:dim-1), intent(in)  :: rhs
      real(kind=8), dimension(0:dim-1), intent(out) :: lhs
      integer, intent(in), optional :: nelems, lhs_stride, rhs_stride
      integer :: n, rs, ls

!defaults
      n = dim
      ls = 1
      rs = 1
      if( PRESENT(nelems) )then
          n = nelems
!only check for stride if nelems is present
          if( PRESENT(lhs_stride) )ls = lhs_stride
          if( PRESENT(rhs_stride) )rs = rhs_stride
      endif
      if( ls.EQ.1 .AND. rs.EQ.1 )then
#ifdef _CRAYT3E
          call SHMEM_GET( lhs(0), rhs(0), n, pe )
#else
          lhs(0:n-1) = rhs(0:n-1)
#endif
      else
#ifdef _CRAYT3E
          call SHMEM_IGET( lhs(0), rhs(0), ls, rs, n, pe )
#else
          lhs(0:n*ls-1:ls) = rhs(0:n*rs-1:rs)
#endif
      endif
      return
    end subroutine memcpy_r8

    subroutine memcpy_r8_gather( lhs, rhs, dim, nelems, lhs_stride, rhs_indx )
!memcpy routine with gather: copies nelems words from rhs(indx(:)) to lhs(:)
      integer, intent(in) :: dim, nelems, lhs_stride
      real(kind=8), dimension(0:dim-1), intent(in)  :: rhs
      real(kind=8), dimension(0:dim-1), intent(out) :: lhs
      integer, intent(in), dimension(nelems) :: rhs_indx
#ifdef _CRAYT3E
!dir$ CACHE_BYPASS lhs, rhs, rhs_indx
      real(kind=8), dimension(nelems) :: tmp

      if( lhs_stride.EQ.1 )then
          call SHMEM_IXGET( lhs(0), rhs(0), rhs_indx, nelems, pe )
      else
          call SHMEM_IXGET( tmp, rhs(0), rhs_indx, nelems, pe )
          call SHMEM_IGET( lhs(0), tmp, lhs_stride, 1, nelems, pe )
      endif
#else
      lhs(0:nelems*lhs_stride-1:lhs_stride) = rhs(rhs_indx(1:nelems))
#endif
      return
    end subroutine memcpy_r8_gather

    subroutine memcpy_r8_scatter( lhs, rhs, dim, nelems, lhs_indx, rhs_stride )
!memcpy routine with scatter: copies nelems words from rhs(:) to lhs(indx(:))
      integer, intent(in) :: dim, nelems, rhs_stride
      real(kind=8), dimension(0:dim-1), intent(in)  :: rhs
      real(kind=8), dimension(0:dim-1), intent(out) :: lhs
      integer, intent(in), dimension(nelems) :: lhs_indx
#ifdef _CRAYT3E
!dir$ CACHE_BYPASS lhs, rhs, lhs_indx
      real(kind=8), dimension(nelems) :: tmp

      if( rhs_stride.EQ.1 )then
          call SHMEM_IXPUT( lhs(0), rhs(0), lhs_indx, nelems, pe )
      else
          call SHMEM_IGET( tmp, rhs(0), rhs_stride, 1, nelems, pe )
          call SHMEM_IXPUT( lhs(0), tmp, lhs_indx, nelems, pe )
      endif
      call SHMEM_QUIET          !required to ensure completion of put
#else
      lhs(lhs_indx(1:nelems)) = rhs(0:nelems*rhs_stride-1:rhs_stride)
#endif
      return
    end subroutine memcpy_r8_scatter

    subroutine memcpy_r8_gather_scatter( lhs, rhs, dim, nelems, lhs_indx, rhs_indx )
!memcpy routine with gather/scatter: copies nelems words from rhs(indx(:)) to lhs(indx(:))
      integer, intent(in) :: dim, nelems
      real(kind=8), dimension(0:dim-1), intent(in)  :: rhs
      real(kind=8), dimension(0:dim-1), intent(out) :: lhs
      integer, intent(in), dimension(nelems) :: lhs_indx, rhs_indx
#ifdef _CRAYT3E
!dir$ CACHE_BYPASS lhs, rhs, lhs_indx, rhs_indx
      real(kind=8), dimension(nelems) :: tmp

      call SHMEM_IXGET( tmp, rhs(0), rhs_indx, nelems, pe )
      call SHMEM_IXPUT( lhs(0), tmp, lhs_indx, nelems, pe )
      call SHMEM_QUIET          !required to ensure completion of put
#else
      lhs(lhs_indx(1:nelems)) = rhs(rhs_indx(1:nelems))
#endif
      return
    end subroutine memcpy_r8_gather_scatter

#ifdef _CRAY
  integer function hplen(             hpalloc, hplargest, hpshrink, hpgrow, hpfirst, hplast )
!using IHPSTAT calls from SR-2165 v2.0 p535
!with no arguments returns heap length (in words on PVP, bytes on t3e)
    integer, intent(out), optional :: hpalloc, hplargest, hpshrink, hpgrow, hpfirst, hplast
    integer :: IHPSTAT

    hplen = IHPSTAT(1)	                      !Heap length
    if( present(hpalloc  ) )hpalloc   = IHPSTAT( 4) !Blocks allocated
    if( present(hplargest) )hplargest = IHPSTAT(10) !Largest free block size
    if( present(hpshrink ) )hpshrink  = IHPSTAT(11) !Amount heap can shrink
    if( present(hpgrow   ) )hpgrow    = IHPSTAT(12) !Amount heap can grow
    if( present(hpfirst  ) )hpfirst   = IHPSTAT(13) !First word address
    if( present(hplast   ) )hplast    = IHPSTAT(14) !Last word address
    return
  end function hplen
#endif /* _CRAY */

#ifdef _CRAYT90
  integer function stklen(            stkhiwm, stknumber, stktotal, stkmost, stkgrew, stkgtimes )
!using STKSTAT(3C) struct
    integer, optional, intent(out) :: stkhiwm, stknumber, stktotal, stkmost, stkgrew, stkgtimes
    integer :: istat(20)

    call STKSTAT(istat)
    stklen = istat(1)	!Stack length
    if( present(stkhiwm  ) )stkhiwm   = istat(2) !stack hiwatermark
    if( present(stknumber) )stknumber = istat(3) !current #stacks
    if( present(stktotal ) )stktotal  = istat(4) !total #stacks
    if( present(stkmost  ) )stkmost   = istat(5) !most #stacks at one time
    if( present(stkgrew  ) )stkgrew   = istat(6) !#stacks that grew
    if( present(stkgtimes) )stkgtimes = istat(7) !#times stack grew
    return
  end function stklen
#endif /* _CRAYT90 */

!cache utilities: need to write version for other argument types
  function get_l1_cache_line(a)
    integer(kind=8) :: get_l1_cache_line
    real, intent(in) :: a
    integer(kind=8) :: i
    i = LOC(a)
    get_l1_cache_line = mod(i,l1_cache_size/l1_associativity)/l1_cache_line_size
  end function get_l1_cache_line

  function get_l2_cache_line(a)
    integer(kind=8) :: get_l2_cache_line
    real, intent(in) :: a
    integer(kind=8) :: i
    i = LOC(a)
    get_l2_cache_line = mod(i,l2_cache_size/l2_associativity)/l2_cache_line_size
  end function get_l2_cache_line

  subroutine print_memuse_stats( text, unit, always )
    use mpp_mod, only: mpp_pe, mpp_root_pe, mpp_npes, mpp_min, mpp_max, mpp_sum, stderr
    character(len=*), intent(in) :: text
    integer, intent(in), optional :: unit
    logical, intent(in), optional :: always
    real :: m, mmin, mmax, mavg, mstd
    integer :: mu
!memuse is an external function: works on SGI
!use #ifdef to generate equivalent on other platforms.
    integer :: memuse !default integer OK?
    character(len=8)  :: walldate
    character(len=10) :: walltime
    character(len=5)  :: wallzone
    integer           :: wallvalues(8)

    if( PRESENT(always) )then
        if( .NOT.always )return
    else
        if( .NOT.print_memory_usage )return
    end if
    mu = stderr(); if( PRESENT(unit) )mu = unit
#if defined(__sgi) || defined(__aix) || defined(__SX)
    m = memuse()*1e-3
#else
    call mem_dump(m)
#endif 
    mmin = m; call mpp_min(mmin)
    mmax = m; call mpp_max(mmax)
    mavg = m; call mpp_sum(mavg); mavg = mavg/mpp_npes()
    mstd = (m-mavg)**2; call mpp_sum(mstd); mstd = sqrt( mstd/mpp_npes() )
    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write( mu,'(a84,4es11.3)' ) trim(walldate)//' '//trim(walltime)//&
         ': Memuse(MB) at '//trim(text)//'=', mmin, mmax, mstd, mavg
    endif
    return
  end subroutine print_memuse_stats

!#######################################################################

subroutine mem_dump ( memuse )
use mpp_mod,    only : stdout
use mpp_io_mod, only : mpp_open, mpp_close, mpp_ascii, mpp_rdonly,     &
                       mpp_sequential, mpp_single

real, intent(out) :: memuse

! This routine returns the memory usage on Linux systems.
! It does this by querying a system file (file_name below).
! It is intended for use by print_memuse_stats above.

character(len=32) :: file_name = '/proc/self/status'
character(len=32) :: string
integer :: mem_unit
real    :: multiplier

  memuse = 0.0
  multiplier = 1.0

  call mpp_open ( mem_unit, file_name,                                 &
                      form=MPP_ASCII,        action=MPP_RDONLY,        &
                      access=MPP_SEQUENTIAL, threading=MPP_SINGLE )
  
  do; read (mem_unit,'(a)', end=10) string
    if ( INDEX ( string, 'VmHWM:' ) == 1 ) then
      read (string(7:LEN_TRIM(string)-2),*) memuse
      exit
    endif
  enddo
  
  if (TRIM(string(LEN_TRIM(string)-1:)) == "kB" ) &
    multiplier = 1.0/1024. ! Convert from kB to MB

10 call mpp_close ( mem_unit )
   memuse = memuse * multiplier

  return
end subroutine mem_dump

end module memutils_mod

module press_and_geopot_mod

! This module provides utilities that computes half- and full-
! level pressure values, given the surface pressure, and 
! geopotential heights -- assuming a vertical coordinate in which
! the half level values are p_half(k) = pk(k) + bk(k)*surface_pressure,
! where the constants pk, bk define the coordinate levels.
!
! The full-level values are given by the expression recommended by 
! Simmons and Burridge. (See Mon. Weather Review: Vol. 109, No. 4, pp. 758-766)
!  alpha  = 1.0  - p_half(k)*( ln(p_half(k+1)) - ln(p_half(k)) )/(p_half(k+1) - p_half(k))
!  ln(p_full(k)) = ln(p_half(k+1)) - alpha
!
! Geopotentials are computed by assuming isothermal temperatures and in each layer
! integrating the hydrostatic/ideal gas equations exactly

use       fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, &
                         write_version_number

use constants_mod, only: grav, rdgas, rvgas

implicit none

private

public :: press_and_geopot_init, press_and_geopot_end, pressure_variables, half_level_pressures
public :: compute_geopotential, compute_pressures_and_heights, compute_z_bot
 
interface half_level_pressures
   module procedure   half_level_pressures_1d, &
                      half_level_pressures_3d
end interface
 
interface pressure_variables
   module procedure   pressure_variables_1d, &
                      pressure_variables_2d, &
                      pressure_variables_3d
end interface

interface compute_pressures_and_heights
   module procedure   compute_pressures_and_heights_1d, &
                      compute_pressures_and_heights_2d, &
                      compute_pressures_and_heights_3d
end interface

!===============================================================================================

character(len=128), parameter :: version = '$Id: press_and_geopot.F90,v 17.0 2009/07/21 03:00:50 fms Exp $'
character(len=128), parameter :: tagname = '$Name: tikal $'

!===============================================================================================
 
real, allocatable, dimension(:) :: pk, bk
 
real    :: ln_top_level_factor
integer :: num_levels
logical :: use_virtual_temperature
character(len=64) :: vert_difference_option
 
logical :: module_is_initialized = .false.

contains
 
!------------------------------------------------------------------------------
 
subroutine press_and_geopot_init(pk_in, bk_in, use_virtual_temperature_in, vert_difference_option_in)
 
real,    intent (in), dimension(:)   :: pk_in, bk_in
logical, intent (in)                 :: use_virtual_temperature_in
character(len=*), intent (in)        :: vert_difference_option_in

if(module_is_initialized) return

call write_version_number(version, tagname)

num_levels = size(pk_in,1)-1

allocate(pk (num_levels+1))
allocate(bk (num_levels+1))
pk = pk_in
bk = bk_in

vert_difference_option  = vert_difference_option_in
use_virtual_temperature = use_virtual_temperature_in

ln_top_level_factor = -1.0

module_is_initialized = .true.
 
return
end subroutine press_and_geopot_init
 
!-----------------------------------------------------------------------
 
function half_level_pressures_3d(surface_p) result(p_half)
 
real, intent (in),  dimension(:,:)     :: surface_p
real, dimension(size(surface_p,1),size(surface_p,2),num_levels+1) :: p_half

integer :: k
 
if(.not.module_is_initialized) then
  call error_mesg('half_level_pressures','press_and_geopot_init has not been called', FATAL)
end if

do k=1,num_levels+1
  p_half(:,:,k) = pk(k) + bk(k)*surface_p(:,:)
end do
 
return
end function half_level_pressures_3d
 
!-----------------------------------------------------------------------
 
function half_level_pressures_1d(surface_p) result(p_half)
 
real, intent (in)             :: surface_p
real, dimension(num_levels+1) :: p_half

integer :: k
 
do k=1,num_levels+1
  p_half(k) = pk(k)+bk(k)*surface_p
end do
 
return
end function half_level_pressures_1d
 
!-------------------------------------------------------------------------------------
 
subroutine pressure_variables_3d(p_half, ln_p_half, p_full, ln_p_full, surface_p)
 
real, intent (out), dimension(:,:,:) :: p_half, ln_p_half, p_full, ln_p_full
real, intent (in),  dimension(:,:)   :: surface_p
 
real, dimension(size(p_half,1),size(p_half,2)) :: alpha

integer :: k

if(.not.module_is_initialized) then
  call error_mesg('pressure_variables','press_and_geopot_init has not been called', FATAL)
end if

p_half = half_level_pressures(surface_p)

if(trim(vert_difference_option) == 'simmons_and_burridge') then

  if(pk(1).eq.0.0 .and. bk(1).eq.0.0) then
 
    do k=2,size(p_half,3)
      ln_p_half(:,:,k) = log(p_half(:,:,k))
    end do
 
    do k=2,size(p_half,3)-1
      alpha  = 1.0  - p_half(:,:,k)*(ln_p_half(:,:,k+1) - ln_p_half(:,:,k))/(p_half(:,:,k+1) - p_half(:,:,k))
      ln_p_full(:,:,k) = ln_p_half(:,:,k+1) - alpha
    end do
    ln_p_full(:,:,1) = ln_p_half(:,:,2) + ln_top_level_factor
    ln_p_half(:,:,1) = 0.0
 
  else
 
    do k=1,size(p_half,3)
      ln_p_half(:,:,k) = log(p_half(:,:,k))
    end do
 
    do k=1,size(p_half,3)-1
      alpha  = 1.0  - p_half(:,:,k)*(ln_p_half(:,:,k+1) - ln_p_half(:,:,k))/(p_half(:,:,k+1) - p_half(:,:,k))
      ln_p_full(:,:,k) = ln_p_half(:,:,k+1) - alpha
    end do
 
  end if
  p_full = exp(ln_p_full)

else if(trim(vert_difference_option) == 'mcm') then

  do k = 1,size(p_full,3)
    p_full   (:,:,k) = 0.5*(p_half(:,:,k+1) + p_half(:,:,k))
    ln_p_full(:,:,k) = log(p_full(:,:,k))
  end do
  if(pk(1).eq.0.0 .and. bk(1).eq.0.0) then
    do k=2,size(p_half,3)
      ln_p_half(:,:,k) = log(p_half(:,:,k))
    end do
    ln_p_half(:,:,1) = 0.
  else
    do k=1,size(p_half,3)
      ln_p_half(:,:,k) = log(p_half(:,:,k))
    end do
  end if

else

  call error_mesg('pressure_variables','"'//trim(vert_difference_option)//'"'// &
                  ' is not a valid value for vert_difference_option', FATAL)

end if
 
return
end subroutine pressure_variables_3d
 
!-------------------------------------------------------------------------------------
subroutine compute_z_bot(psg, tg, z_bot, qg)
real, intent(in ), dimension(:,:) :: psg, tg
real, intent(out), dimension(:,:) :: z_bot
real, intent(in ), optional, dimension(:,:) :: qg

real, dimension(size(psg,1), size(psg,2)) ::    p_half_bot,    p_half_nxt
real, dimension(size(psg,1), size(psg,2)) :: ln_p_half_bot, ln_p_half_nxt
real, dimension(size(psg,1), size(psg,2)) :: ln_p_full_bot, alpha, virtual_t

num_levels = size(pk,1) - 1
p_half_bot = pk(num_levels+1) + psg*bk(num_levels+1)
p_half_nxt = pk(num_levels)   + psg*bk(num_levels)
ln_p_half_bot = log(p_half_bot)

if(trim(vert_difference_option) == 'simmons_and_burridge') then
  ln_p_half_nxt = log(p_half_nxt)
  alpha  = 1.0  - p_half_nxt*(ln_p_half_bot - ln_p_half_nxt)/(p_half_bot - p_half_nxt)
  ln_p_full_bot = ln_p_half_bot - alpha
else if(trim(vert_difference_option) == 'mcm') then
  ln_p_full_bot = log(.5*(p_half_bot + p_half_nxt))
endif

if(use_virtual_temperature) then
  if(present(qg)) then
    virtual_t = tg*(1. + (rvgas/rdgas - 1.)*qg)
  else
    call error_mesg('compute_z_bot','qg must be present when use_virtual_temperature=.true.', FATAL)
  endif
else
  virtual_t = tg
endif

z_bot = (rdgas*virtual_t*(ln_p_half_bot - ln_p_full_bot))/grav

return
end subroutine compute_z_bot
!-------------------------------------------------------------------------------------
 
subroutine pressure_variables_1d(p_half,ln_p_half,p_full,ln_p_full,surface_p)
 
real, intent (out), dimension(:) :: p_half, ln_p_half, p_full, ln_p_full
real, intent (in)   :: surface_p
 
real, dimension(1,1)              :: surface_p_2d
real, dimension(1,1,num_levels+1) :: p_half_3d
real, dimension(1,1,num_levels+1) :: ln_p_half_3d
real, dimension(1,1,num_levels)   :: p_full_3d
real, dimension(1,1,num_levels)   :: ln_p_full_3d
 
 
surface_p_2d(1,1) = surface_p
 
call pressure_variables_3d(p_half_3d,ln_p_half_3d,p_full_3d,ln_p_full_3d,surface_p_2d)
 
p_half    =    p_half_3d(1,1,:)
ln_p_half = ln_p_half_3d(1,1,:)
p_full    =    p_full_3d(1,1,:)
ln_p_full = ln_p_full_3d(1,1,:)
 
return
end subroutine pressure_variables_1d
 
!-----------------------------------------------------------------------

subroutine pressure_variables_2d(p_half,ln_p_half,p_full,ln_p_full,surface_p)
 
real, intent (out), dimension(:,:) :: p_half, ln_p_half, p_full, ln_p_full
real, intent (in) , dimension(:)   :: surface_p
 
real, dimension(1,size(surface_p))              :: surface_p_2d
real, dimension(1,size(surface_p),num_levels+1) :: p_half_3d
real, dimension(1,size(surface_p),num_levels+1) :: ln_p_half_3d
real, dimension(1,size(surface_p),num_levels)   :: p_full_3d
real, dimension(1,size(surface_p),num_levels)   :: ln_p_full_3d
 
 
surface_p_2d(1,:) = surface_p
 
call pressure_variables_3d(p_half_3d,ln_p_half_3d,p_full_3d,ln_p_full_3d,surface_p_2d)
 
p_half    =    p_half_3d(1,:,:)
ln_p_half = ln_p_half_3d(1,:,:)
p_full    =    p_full_3d(1,:,:)
ln_p_full = ln_p_full_3d(1,:,:)
 
return
end subroutine pressure_variables_2d

!-----------------------------------------------------------------------

subroutine compute_geopotential(t_grid, ln_p_half, ln_p_full, surf_geopotential, geopot_full, geopot_half, q_grid)

real, intent (in), dimension (:,:,:) :: t_grid, ln_p_half, ln_p_full
real, intent (in), dimension (:,:)   :: surf_geopotential
real, intent(out), dimension (:,:,:) :: geopot_full, geopot_half
real, intent (in), optional, dimension (:,:,:) :: q_grid

real, dimension (size(t_grid,1),size(t_grid,2),size(t_grid,3)  ) :: virtual_t

integer :: ktop, num_levels, k

if(.not.module_is_initialized) then
  call error_mesg('compute_geopotential','press_and_geopot_init has not been called', FATAL)
end if

num_levels = size(t_grid,3)

geopot_half(:,:,num_levels+1) = surf_geopotential

if(pk(1).eq.0.0) then
  ktop = 2
  geopot_half(:,:,1) = 0.0
else
  ktop = 1
endif

if(use_virtual_temperature) then
  if(present(q_grid)) then
    virtual_t = t_grid*(1. + (rvgas/rdgas - 1.)*q_grid)
  else
    call error_mesg('compute_geopotential','q_grid must be present when use_virtual_temperature=.true.', FATAL)
  endif
else
  virtual_t = t_grid
endif

do k=num_levels,ktop,-1
  geopot_half(:,:,k) = geopot_half(:,:,k+1) + rdgas*virtual_t(:,:,k)*(ln_p_half(:,:,k+1) - ln_p_half(:,:,k))
enddo

do k=1,num_levels
  geopot_full(:,:,k) = geopot_half(:,:,k+1) + rdgas*virtual_t(:,:,k)*(ln_p_half(:,:,k+1) - ln_p_full(:,:,k))
enddo

return
end subroutine compute_geopotential

!-----------------------------------------------------------------------

subroutine compute_pressures_and_heights_3d(t_grid, ps_grid, surf_geopotential, z_full, z_half, p_full, p_half, q_grid)

real, intent (in), dimension (:,:,:) :: t_grid
real, intent (in), dimension (:,:  ) :: ps_grid, surf_geopotential
real, intent(in), optional, dimension(:,:,:) :: q_grid

real, intent(out), dimension (size(t_grid,1),size(t_grid,2),size(t_grid,3)  ) :: z_full, p_full
real, intent(out), dimension (size(t_grid,1),size(t_grid,2),size(t_grid,3)+1) :: z_half, p_half

real, dimension(size(t_grid,1),size(t_grid,2),size(t_grid,3)  ) :: ln_p_full
real, dimension(size(t_grid,1),size(t_grid,2),size(t_grid,3)+1) :: ln_p_half

if(.not.module_is_initialized) then
  call error_mesg('compute_pressures_and_heights','press_and_geopot_init has not been called', FATAL)
end if

call pressure_variables (p_half, ln_p_half, p_full, ln_p_full, ps_grid)

call compute_geopotential(t_grid, ln_p_half, ln_p_full, surf_geopotential, z_full, z_half, q_grid)

z_full = z_full/grav
z_half = z_half/grav

return
end subroutine compute_pressures_and_heights_3d

!-----------------------------------------------------------------------
subroutine compute_pressures_and_heights_1d(t_grid, ps_grid, surf_geopotential, z_full, z_half, p_full, p_half, q_grid)

real, intent (in), dimension (:) :: t_grid
real, intent (in)                :: ps_grid, surf_geopotential
real, intent(in), optional, dimension(:) :: q_grid

real, intent(out), dimension (size(t_grid)  ) :: z_full, p_full
real, intent(out), dimension (size(t_grid)+1) :: z_half, p_half
 
real, dimension(1,1) :: ps_grid_2d, surf_geopotential_2d
real, dimension(1,1,size(t_grid))   :: t_grid_3d, z_full_3d, p_full_3d, q_grid_3d
real, dimension(1,1,size(t_grid)+1) :: z_half_3d, p_half_3d
 
t_grid_3d(1,1,:) = t_grid
ps_grid_2d(1,1)  = ps_grid
surf_geopotential_2d(1,1) = surf_geopotential
                      
if(present(q_grid)) then
  q_grid_3d(1,1,:) = q_grid
  call compute_pressures_and_heights_3d(t_grid_3d, ps_grid_2d, surf_geopotential_2d, z_full_3d, z_half_3d, p_full_3d, p_half_3d, &
                                        q_grid_3d)
else
  call compute_pressures_and_heights_3d(t_grid_3d, ps_grid_2d, surf_geopotential_2d, z_full_3d, z_half_3d, p_full_3d, p_half_3d)
endif

z_full = z_full_3d(1,1,:)
z_half = z_half_3d(1,1,:)
p_full = p_full_3d(1,1,:)
p_half = p_half_3d(1,1,:)

end subroutine compute_pressures_and_heights_1d

!-----------------------------------------------------------------------
subroutine compute_pressures_and_heights_2d(t_grid, ps_grid, surf_geopotential, z_full, z_half, p_full, p_half, q_grid)

real, intent (in), dimension (:,:) :: t_grid
real, intent (in), dimension (:)   :: ps_grid, surf_geopotential
real, intent(in), optional, dimension(:,:) :: q_grid

real, intent(out), dimension (size(t_grid,1),size(t_grid,2)  ) :: z_full, p_full
real, intent(out), dimension (size(t_grid,1),size(t_grid,2)+1) :: z_half, p_half

real, dimension(1,size(t_grid,1)) :: ps_grid_2d, surf_geopotential_2d
real, dimension(1,size(t_grid,1),size(t_grid,2))   :: t_grid_3d, z_full_3d, p_full_3d, q_grid_3d
real, dimension(1,size(t_grid,1),size(t_grid,2)+1) :: z_half_3d, p_half_3d
 
t_grid_3d(1,:,:) = t_grid
ps_grid_2d(1,:)  = ps_grid
surf_geopotential_2d(1,:) = surf_geopotential
                      
if(present(q_grid)) then
  q_grid_3d(1,:,:) = q_grid
  call compute_pressures_and_heights_3d(t_grid_3d, ps_grid_2d, surf_geopotential_2d, z_full_3d, z_half_3d, p_full_3d, p_half_3d, &
                                        q_grid_3d)
else
  call compute_pressures_and_heights_3d(t_grid_3d, ps_grid_2d, surf_geopotential_2d, z_full_3d, z_half_3d, p_full_3d, p_half_3d)
endif

z_full = z_full_3d(1,:,:)
z_half = z_half_3d(1,:,:)
p_full = p_full_3d(1,:,:)
p_half = p_half_3d(1,:,:)

end subroutine compute_pressures_and_heights_2d

!-----------------------------------------------------------------------
subroutine press_and_geopot_end

if(.not.module_is_initialized) return

deallocate(pk, bk)
module_is_initialized = .false.

return
end subroutine press_and_geopot_end
!-----------------------------------------------------------------------

end module press_and_geopot_mod

!
!  coupler_main couples component models and controls the time integration
!
program coupler_main
!-----------------------------------------------------------------------
!                   GNU General Public License                        
!                                                                      
! This program is free software; you can redistribute it and/or modify it and  
! are expected to follow the terms of the GNU General Public License  
! as published by the Free Software Foundation; either version 2 of   
! the License, or (at your option) any later version.                 
!                                                                      
! MOM is distributed in the hope that it will be useful, but WITHOUT    
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
! License for more details.                                           
!                                                                      
! For the full text of the GNU General Public License,                
! write to: Free Software Foundation, Inc.,                           
!           675 Mass Ave, Cambridge, MA 02139, USA.                   
! or see:   http://www.gnu.org/licenses/gpl.html                      
!-----------------------------------------------------------------------
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Bruce Wyman </CONTACT>
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> V. Balaji </CONTACT>


! <OVERVIEW>
!  A main program that couples component models for atmosphere, ocean, land, 
!  and sea ice on independent grids. 
! </OVERVIEW>

! <DESCRIPTION>
!  This version couples model components representing atmosphere, ocean, land 
!  and sea ice on independent grids. Each model component is represented by a 
!  data type giving the instantaneous model state.
!
!  The component models are coupled to allow implicit vertical diffusion of 
!  heat and moisture at the interfaces of the atmosphere, land, and ice models. 
!  As a result, the atmosphere, land, and ice models all use the same time step. 
!  The atmospheric model has been separated into down and up calls that 
!  correspond to the down and up sweeps of the standard tridiagonal elimination.
!
!  The ocean interface uses explicit mixing. Fluxes to and from the ocean must
!  be passed through the ice model. This includes atmospheric fluxes as well as 
!  fluxes from the land to the ocean (runoff).
!
!  This program contains the model's main time loop. Each iteration of the 
!  main time loop is one coupled (slow) time step. Within this slow time step 
!  loop is a fast time step loop, using the atmospheric time step, where the
!  tridiagonal vertical diffusion equations are solved. Exchange between sea 
!  ice and ocean occurs once every slow timestep.
!
! <PRE>
!      MAIN PROGRAM EXAMPLE
!      --------------------
!
!         DO slow time steps (ocean)
!
!              call flux_ocean_to_ice
!
!              call ICE_SLOW_UP
!
!              DO fast time steps (atmos)
!
!                   call flux_calculation
!
!                   call ATMOS_DOWN
!
!                   call flux_down_from_atmos
!
!                   call LAND_FAST
!
!                   call ICE_FAST
!
!                   call flux_up_to_atmos
!
!                   call ATMOS_UP
!
!              END DO
!
!              call ICE_SLOW_DN
!
!              call flux_ice_to_ocean
!
!              call OCEAN
!
!         END DO

!  </PRE>

! </DESCRIPTION>
! <INFO>
!   <NOTE>
!     <PRE>
!   1.If no value is set for current_date, start_date, or calendar (or default value 
!     specified) then the value from restart file "INPUT/coupler.res" will be used. 
!     If neither a namelist value or restart file value exist the program will fail. 
!   2.The actual run length will be the sum of months, days, hours, minutes, and 
!     seconds. A run length of zero is not a valid option. 
!   3.The run length must be an intergal multiple of the coupling timestep dt_cpld. 
!     </PRE>
!   </NOTE>

!   <ERROR MSG="no namelist value for current_date " STATUS="FATAL">
!     A namelist value for current_date must be given if no restart file for
!     coupler_main (INPUT/coupler.res) is found. 
!   </ERROR>
!   <ERROR MSG="invalid namelist value for calendar" STATUS="FATAL">
!     The value of calendar must be 'julian', 'noleap', or 'thirty_day'. 
!     See the namelist documentation. 
!   </ERROR>
!   <ERROR MSG="no namelist value for calendar" STATUS="FATAL">
!     If no restart file is present, then a namelist value for calendar 
!     must be specified. 
!   </ERROR>
!   <ERROR MSG="initial time is greater than current time" STATUS="FATAL">
!     If a restart file is present, then the namelist value for either 
!     current_date or start_date was incorrectly set. 
!   </ERROR>
!   <ERROR MSG="run length must be multiple of ocean time step " STATUS="FATAL">
!     There must be an even number of ocean time steps for the requested run length. 
!   </ERROR>
!   <ERROR MSG="final time does not match expected ending time " STATUS="WARNING">
!     This error should probably not occur because of checks done at initialization time. 
!   </ERROR>

! </INFO>

  use constants_mod,           only: constants_init

  use time_manager_mod,        only: time_type, set_calendar_type, set_time
  use time_manager_mod,        only: set_date, get_date, days_in_month, month_name
  use time_manager_mod,        only: operator(+), operator(-), operator (<)
  use time_manager_mod,        only: operator (>), operator ( /= ), operator ( / )
  use time_manager_mod,        only: operator (*), THIRTY_DAY_MONTHS, JULIAN
  use time_manager_mod,        only: NOLEAP, NO_CALENDAR, INVALID_CALENDAR
  use time_manager_mod,        only: date_to_string, increment_date
  use time_manager_mod,        only: operator(>=), operator(<=), operator(==)

  use fms_mod,                 only: open_namelist_file, field_exist, file_exist, check_nml_error
  use fms_mod,                 only: uppercase, error_mesg, write_version_number
  use fms_mod,                 only: fms_init, fms_end, stdout
  use fms_mod,                 only: read_data, write_data

  use fms_io_mod,              only: fms_io_exit
  use fms_io_mod,              only: restart_file_type, register_restart_field, save_restart

  use diag_manager_mod,        only: diag_manager_init, diag_manager_end, diag_grid_end
  use diag_manager_mod,        only: DIAG_OCEAN, DIAG_OTHER, DIAG_ALL, get_base_date
  use diag_manager_mod,        only: diag_manager_set_time_end

  use field_manager_mod,       only: MODEL_ATMOS, MODEL_LAND, MODEL_ICE

  use tracer_manager_mod,      only: tracer_manager_init, get_tracer_index
  use tracer_manager_mod,      only: get_number_tracers, get_tracer_names, NO_TRACER

  use coupler_types_mod,       only: coupler_types_init

  use data_override_mod,       only: data_override_init

!
! model interfaces used to couple the component models:
!               atmosphere, land, ice, and ocean
!

  use atmos_model_mod,         only: atmos_model_init, atmos_model_end
  use atmos_model_mod,         only: update_atmos_model_down
  use atmos_model_mod,         only: update_atmos_model_up
  use atmos_model_mod,         only: atmos_data_type
  use atmos_model_mod,         only: land_ice_atmos_boundary_type
  use atmos_model_mod,         only: atmos_data_type_chksum
  use atmos_model_mod,         only: lnd_ice_atm_bnd_type_chksum
  use atmos_model_mod,         only: lnd_atm_bnd_type_chksum
  use atmos_model_mod,         only: ice_atm_bnd_type_chksum
  use atmos_model_mod,         only: atmos_model_restart

  use land_model_mod,          only: land_model_init, land_model_end
  use land_model_mod,          only: land_data_type, atmos_land_boundary_type
  use land_model_mod,          only: update_land_model_fast, update_land_model_slow
  use land_model_mod,          only: atm_lnd_bnd_type_chksum
  use land_model_mod,          only: land_data_type_chksum
  use land_model_mod,          only: land_model_restart

  use ice_model_mod,           only: ice_model_init, ice_model_end
  use ice_model_mod,           only: update_ice_model_slow_up
  use ice_model_mod,           only: update_ice_model_fast
  use ice_model_mod,           only: update_ice_model_slow_dn
  use ice_model_mod,           only: ice_data_type, land_ice_boundary_type
  use ice_model_mod,           only: ocean_ice_boundary_type, atmos_ice_boundary_type
  use ice_model_mod,           only: ice_model_restart
  use ice_model_mod,           only: ice_data_type_chksum, ocn_ice_bnd_type_chksum
  use ice_model_mod,           only: atm_ice_bnd_type_chksum, lnd_ice_bnd_type_chksum

  use ocean_model_mod,         only: update_ocean_model, ocean_model_init
  use ocean_model_mod,         only: ocean_model_end, ocean_public_type, ocean_state_type, ice_ocean_boundary_type
  use ocean_model_mod,         only: ocean_model_restart
  use ocean_model_mod,         only: ocean_public_type_chksum, ice_ocn_bnd_type_chksum
!
! flux_ calls translate information between model grids - see flux_exchange.f90
!

  use flux_exchange_mod,       only: flux_exchange_init
  use flux_exchange_mod,       only: sfc_boundary_layer
  use flux_exchange_mod,       only: generate_sfc_xgrid
  use flux_exchange_mod,       only: flux_down_from_atmos
  use flux_exchange_mod,       only: flux_up_to_atmos
  use flux_exchange_mod,       only: flux_land_to_ice
  use flux_exchange_mod,       only: flux_ice_to_ocean
  use flux_exchange_mod,       only: flux_ocean_to_ice
  use flux_exchange_mod,       only: flux_check_stocks, flux_init_stocks, flux_ice_to_ocean_stocks, flux_ocean_from_ice_stocks

  use atmos_tracer_driver_mod, only: atmos_tracer_driver_gather_data

  use mpp_mod,                 only: mpp_clock_id, mpp_clock_begin, mpp_clock_end, mpp_chksum
  use mpp_mod,                 only: mpp_init, mpp_pe, mpp_npes, mpp_root_pe
  use mpp_mod,                 only: stderr, stdlog, mpp_error, NOTE, FATAL, WARNING
  use mpp_mod,                 only: mpp_set_current_pelist, mpp_declare_pelist
  use mpp_mod,                 only: input_nml_file

  use mpp_io_mod,              only: mpp_open, mpp_close, mpp_io_clock_on
  use mpp_io_mod,              only: MPP_NATIVE, MPP_RDONLY, MPP_DELETE

  use mpp_domains_mod,         only: mpp_broadcast_domain

  use memutils_mod,            only: print_memuse_stats

  implicit none

!-----------------------------------------------------------------------

  character(len=128) :: version = '$Id: coupler_main.F90,v 20.0 2013/12/13 23:27:07 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

!-----------------------------------------------------------------------
!---- model defined-types ----

  type (atmos_data_type) :: Atm
  type  (land_data_type) :: Land
  type   (ice_data_type) :: Ice
  ! allow members of ocean type to be aliased (ap)
  type (ocean_public_type), target :: Ocean
  type (ocean_state_type),  pointer :: Ocean_state => NULL()

  type(atmos_land_boundary_type)     :: Atmos_land_boundary
  type(atmos_ice_boundary_type)      :: Atmos_ice_boundary
  type(land_ice_atmos_boundary_type) :: Land_ice_atmos_boundary
  type(land_ice_boundary_type)       :: Land_ice_boundary
  type(ice_ocean_boundary_type)      :: Ice_ocean_boundary
  type(ocean_ice_boundary_type)      :: Ocean_ice_boundary

!-----------------------------------------------------------------------
! ----- coupled model time -----

  type (time_type) :: Time, Time_init, Time_end, &
                      Time_step_atmos, Time_step_cpld
  type(time_type) :: Time_atmos, Time_ocean
  integer :: num_atmos_calls, na
  integer :: num_cpld_calls, nc

!------ for intermediate restart
  type(restart_file_type), allocatable :: Ice_bc_restart(:), Ocn_bc_restart(:)
  character(len=64),       allocatable :: ice_bc_restart_file(:), ocn_bc_restart_file(:) 
  integer                              :: num_ice_bc_restart=0, num_ocn_bc_restart=0
  type(time_type)                      :: Time_restart, Time_restart_current, Time_start
  character(len=32)                    :: timestamp

! ----- coupled model initial date -----

  integer :: date_init(6) = (/ 0, 0, 0, 0, 0, 0 /)
  integer :: calendar_type = INVALID_CALENDAR

!-----------------------------------------------------------------------
!------ namelist interface -------

! <NAMELIST NAME="coupler_nml">
!   <DATA NAME="current_date"  TYPE="integer, dimension(6)"  DEFAULT="0">
!     The date that the current integration starts with. 
!   </DATA>
!   <DATA NAME="force_date_from_namelist"  TYPE="logical"  DEFAULT=".false.">
!     Flag that determines whether the namelist variable current_date should 
!     override the date in the restart file INPUT/coupler.res. If the restart 
!     file does not exist then force_date_from_namelist has not effect, the value of current_date 
!     will be used.
!   </DATA>
!   <DATA NAME="calendar"  TYPE="character(maxlen=17)"  DEFAULT="''">
!     The calendar type used by the current integration. Valid values are consistent 
!     with the time_manager module: 'julian', 'noleap', or 'thirty_day'. The value 
!     'no_calendar' can not be used because the time_manager's date  function are used. 
!     All values must be lowercase.
!   </DATA>
!   <DATA NAME="months "  TYPE="integer"  DEFAULT="0">
!     The number of months that the current integration will be run for. 
!   </DATA>
!   <DATA NAME="days "  TYPE="integer"  DEFAULT="0">
!     The number of days that the current integration will be run for. 
!   </DATA>
!   <DATA NAME="hours"  TYPE="integer"  DEFAULT="0">
!     The number of hours that the current integration will be run for. 
!   </DATA>
!   <DATA NAME="minutes "  TYPE="integer"  DEFAULT="0">
!     The number of minutes that the current integration will be run for. 
!   </DATA>
!   <DATA NAME="seconds"  TYPE="integer"  DEFAULT="0">
!     The number of seconds that the current integration will be run for. 
!   </DATA>
!   <DATA NAME="dt_atmos"  TYPE="integer"  DEFAULT="0">
!     Atmospheric model time step in seconds, including the fast coupling with 
!     land and sea ice. 
!   </DATA>
!   <DATA NAME="dt_cpld"  TYPE="integer"  DEFAULT="0">
!     Time step in seconds for coupling between ocean and atmospheric models: 
!     must be an integral multiple of dt_atmos and dt_ocean. This is the "slow" timestep.
!   </DATA>
!  <DATA NAME="do_atmos, do_ocean, do_ice, do_land, do_flux" TYPE="logical">
!  If true (default), that particular model component (atmos, etc.) is run.
!  If false, the execution of that component is skipped. This is used when
!  ALL the output fields sent by that component to the coupler have been
!  overridden using the data_override feature. For advanced users only:
!  if you're not sure, you should leave these values at TRUE.
!  </DATA> 
!  <DATA NAME="concurrent" TYPE="logical">
!  If true, the ocean executes concurrently with the atmosphere-land-ocean
!   on a separate set of PEs.
!  If false (default), the execution is serial: call atmos... followed by
!  call ocean...
!  If using concurrent execution, you must set one of
!   atmos_npes and ocean_npes, see below.
!  </DATA> 
!  <DATA NAME="atmos_npes, ocean_npes" TYPE="integer">
!  If concurrent is set to true, we use these to set the list of PEs on which
!   each component runs.
!  At least one of them must be set to a number between 0 and NPES.
!  If exactly one of these two is set non-zero, the other is set to the
!   remainder from NPES.
!  If both are set non-zero they must add up to NPES.
!  </DATA> 
!  <DATA NAME="atmos_nthreads, ocean_nthreads" TYPE="integer">
!  We set here the number of OpenMP threads to use
!  separately for each component (default 1)
!  </DATA> 
!  <DATA NAME="use_lag_fluxes" TYPE="logical">
!  If true, then mom4 is forced with SBCs from one coupling timestep ago
!  If false, then mom4 is forced with most recent SBCs.
!  For a leapfrog MOM coupling with dt_cpld=dt_ocean, lag fluxes
!  can be shown to be stable and current fluxes to be unconditionally unstable.
!  For dt_cpld>dt_ocean there is probably sufficient damping.
!  use_lag_fluxes is set to TRUE by default.
!  </DATA>
!  <DATA NAME="restart_interval" TYPE="integer, dimension(6)"  DEFAULT="0">
!     The time interval that write out intermediate restart file. The format is (yr,mo,day,hr,min,sec).
!     When restart_interval is all zero, no intermediate restart file will be written out.
!   </DATA>
!   <NOTE>
!     <PRE>
!     1.If no value is set for current_date, start_date, or calendar (or default value specified) then the value from restart
!       file "INPUT/coupler.res" will be used. If neither a namelist value or restart file value exist the program will fail. 
!     2.The actual run length will be the sum of months, days, hours, minutes, and seconds. A run length of zero is not a
!       valid option. 
!     3.The run length must be an intergal multiple of the coupling timestep dt_cpld. 
!     </PRE>
!   </NOTE>
! </NAMELIST>

  integer, dimension(6) :: restart_interval = (/ 0, 0, 0, 0, 0, 0/)
  integer, dimension(6) :: current_date     = (/ 0, 0, 0, 0, 0, 0 /)
  character(len=17) :: calendar = '                 '
  logical :: force_date_from_namelist = .false.  ! override restart values for date
  integer :: months=0, days=0, hours=0, minutes=0, seconds=0
  integer :: dt_atmos = 0  ! fluxes passed between atmosphere & ice/land
  integer :: dt_cpld  = 0  ! fluxes passed between ice & ocean


  integer :: atmos_npes=0, ocean_npes=0, ice_npes=0, land_npes=0
  integer :: atmos_nthreads=1, ocean_nthreads=1
  logical :: do_atmos =.true., do_land =.true., do_ice =.true., do_ocean=.true.
  logical :: do_flux =.true.
  logical :: concurrent=.FALSE.
  logical :: use_lag_fluxes=.TRUE.
  logical :: do_chksum=.FALSE.
  integer :: check_stocks = 0 ! -1: never 0: at end of run only n>0: every n coupled steps

  namelist /coupler_nml/ current_date, calendar, force_date_from_namelist, months, days, hours,      &
                         minutes, seconds, dt_cpld, dt_atmos, do_atmos,              &
                         do_land, do_ice, do_ocean, do_flux, atmos_npes, ocean_npes, &
                         ice_npes, land_npes, atmos_nthreads, ocean_nthreads, &
                         concurrent, use_lag_fluxes, do_chksum, &
                         check_stocks, restart_interval

  integer :: initClock, mainClock, termClock

  integer :: newClock0, newClock1, newClock2, newClock3, newClock4, newClock5, newClock6, newClock7, &
             newClock8, newClock9, newClock10, newClock11, newClock12, newClock13, newClock14, newClocka, &
             newClockb, newClockc, newClockd, newClocke, newClockf, newClockg, newClockh

  integer :: id_atmos_model_init, id_land_model_init, id_ice_model_init
  integer :: id_ocean_model_init, id_flux_exchange_init

  character(len=80) :: text
  character(len=48), parameter                    :: mod_name = 'coupler_main_mod'
 
  integer :: ensemble_id = 1 , outunit
  integer, allocatable :: ensemble_pelist(:, :) 

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

character(len=64), parameter    :: sub_name = 'coupler_main'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!#######################################################################

  call mpp_init()
!these clocks are on the global pelist
  initClock = mpp_clock_id( 'Initialization' )
  call mpp_clock_begin(initClock)
  
  call fms_init
  call constants_init

  call coupler_init
  if(do_chksum) call coupler_chksum('coupler_init+', 0)

  call mpp_set_current_pelist()

  call mpp_clock_end (initClock) !end initialization

  call mpp_clock_begin(mainClock) !begin main loop

!-----------------------------------------------------------------------
!------ ocean/slow-ice integration loop ------

     if(check_stocks >= 0) then
        call mpp_set_current_pelist()
        call flux_init_stocks(Time, Atm, Land, Ice, Ocean_state)
     endif

if( Atm%pe )then
 call mpp_set_current_pelist(Atm%pelist)
 newClock1 = mpp_clock_id( 'generate_sfc_xgrid' )
endif
call mpp_set_current_pelist()
newClock2 = mpp_clock_id( 'flux_ocean_to_ice' )
newClock3 = mpp_clock_id( 'flux_ice_to_ocean' )
newClock4 = mpp_clock_id( 'flux_check_stocks' ) 
if( Atm%pe )then
 call mpp_set_current_pelist(Atm%pelist)
 newClock5 = mpp_clock_id( 'ATM' )
 newClock6  = mpp_clock_id( '  ATM: update_ice_model_slow_up' )
 newClock7  = mpp_clock_id( '  ATM: atmos loop' )
 newClocka  = mpp_clock_id( '     A-L: atmos_tracer_driver_gather_data' )
 newClockb  = mpp_clock_id( '     A-L: sfc_boundary_layer' )
 newClockc  = mpp_clock_id( '     A-L: update_atmos_model_down' )
 newClockd  = mpp_clock_id( '     A-L: flux_down_from_atmos' )
 newClocke  = mpp_clock_id( '     A-L: update_land_model_fast' )
 newClockf  = mpp_clock_id( '     A-L: update_ice_model_fast' )
 newClockg  = mpp_clock_id( '     A-L: flux_up_to_atmos' )
 newClockh  = mpp_clock_id( '     A-L: update_atmos_model_up' )
 newClock8  = mpp_clock_id( '  ATM: update_land_model_slow' )
 newClock9  = mpp_clock_id( '  ATM: flux_land_to_ice' )
 newClock10 = mpp_clock_id( '  ATM: update_ice_model_slow_dn' )
 newClock11 = mpp_clock_id( '  ATM: flux_ice_to_ocean_stocks' )
endif
if( Ocean%is_ocean_pe )then
 call mpp_set_current_pelist(Ocean%pelist)
 newClock12 = mpp_clock_id( 'OCN' )
endif
call mpp_set_current_pelist()
newClock13 = mpp_clock_id( 'intermediate restart' )
newClock14 = mpp_clock_id( 'final flux_check_stocks' )

  do nc = 1, num_cpld_calls
     if(do_chksum) call coupler_chksum('top_of_coupled_loop+', nc)
     if( Atm%pe )then
        call mpp_set_current_pelist(Atm%pelist)
        call mpp_clock_begin(newClock1)
        call generate_sfc_xgrid( Land, Ice )
        call mpp_clock_end(newClock1)
     end if
     call mpp_set_current_pelist()
     if(do_chksum) then
       if (Atm%pe) then 
         call mpp_set_current_pelist(Atm%pelist)
         call atmos_ice_land_chksum('MAIN_LOOP-', nc)
       endif
       if (Ocean%is_ocean_pe) then 
         call mpp_set_current_pelist(Ocean%pelist)
         call ocean_chksum('MAIN_LOOP-', nc)
       endif
       call mpp_set_current_pelist()
     endif  

     ! Calls to flux_ocean_to_ice and flux_ice_to_ocean are all PE communication
     ! points when running concurrently. The calls are placed next to each other in
     ! concurrent mode to avoid multiple synchronizations within the main loop.
     ! This is only possible in the serial case when use_lag_fluxes.
     call mpp_clock_begin(newClock2)
     call flux_ocean_to_ice( Time, Ocean, Ice, Ocean_ice_boundary )
     call mpp_clock_end(newClock2)
     if(do_chksum) then
       call coupler_chksum('flux_ocn2ice+', nc)
       if (Atm%pe) then 
         call mpp_set_current_pelist(Atm%pelist)
         call atmos_ice_land_chksum('fluxocn2ice+', nc)
       endif
       if (Ocean%is_ocean_pe) then 
         call mpp_set_current_pelist(Ocean%pelist)
         call ocean_public_type_chksum('fluxocn2ice+', nc, Ocean)
       endif
       call mpp_set_current_pelist()
     endif

     ! Update Ice_ocean_boundary; first iteration is supplied by restart     
     if( use_lag_fluxes )then
        call mpp_clock_begin(newClock3)
        call flux_ice_to_ocean( Time, Ice, Ocean, Ice_ocean_boundary )
        call mpp_clock_end(newClock3)
     end if

     ! Update Ice_ocean_boundary; first iteration is supplied by restart     
     ! To print the value of frazil heat flux at the right time the following block
     ! needs to sit here rather than at the end of the coupler loop.
     if(check_stocks > 0) then
        call mpp_clock_begin(newClock4)
        if(check_stocks*((nc-1)/check_stocks) == nc-1 .AND. nc > 1) then
           call mpp_set_current_pelist()
           call flux_check_stocks(Time=Time, Atm=Atm, Lnd=Land, Ice=Ice, Ocn_state=Ocean_state)
        endif
        call mpp_clock_end(newClock4)
     endif

     if( Atm%pe )then
        call mpp_set_current_pelist(Atm%pelist)
        call mpp_clock_begin(newClock5)
        call mpp_clock_begin(newClock6)
        if (do_ice .AND. Ice%pe) then
           if(ice_npes .NE. atmos_npes) call mpp_set_current_pelist(Ice%pelist)
           call update_ice_model_slow_up( Ocean_ice_boundary, Ice )
        endif
        if(ice_npes .NE. atmos_npes) call mpp_set_current_pelist(Atm%pelist)
        call mpp_clock_end(newClock6)
        if(do_chksum) call atmos_ice_land_chksum('update_ice_slow_up+', nc)

        !-----------------------------------------------------------------------
        !   ------ atmos/fast-land/fast-ice integration loop -------

        call mpp_clock_begin(newClock7)
        do na = 1, num_atmos_calls
           if(do_chksum) call atmos_ice_land_chksum('top_of_atmos_loop-', (nc-1)*num_atmos_calls+na)

           Time_atmos = Time_atmos + Time_step_atmos

           if (do_atmos) then
              call mpp_clock_begin(newClocka)
              call atmos_tracer_driver_gather_data(Atm%fields, Atm%tr_bot)
              call mpp_clock_end(newClocka)
           endif

           if (do_flux) then
              call mpp_clock_begin(newClockb)
              call sfc_boundary_layer( REAL(dt_atmos), Time_atmos, &
                   Atm, Land, Ice, Land_ice_atmos_boundary )
              if(do_chksum)  call atmos_ice_land_chksum('sfc+', (nc-1)*num_atmos_calls+na)
              call mpp_clock_end(newClockb)
           end if

           !      ---- atmosphere down ----

           if (do_atmos) then
              call mpp_clock_begin(newClockc)
              call update_atmos_model_down( Land_ice_atmos_boundary, Atm )
              call mpp_clock_end(newClockc)
           endif
           if(do_chksum) call atmos_ice_land_chksum('update_atmos_down+', (nc-1)*num_atmos_calls+na)

           call mpp_clock_begin(newClockd)
           call flux_down_from_atmos( Time_atmos, Atm, Land, Ice, &
                Land_ice_atmos_boundary, &
                Atmos_land_boundary, &
                Atmos_ice_boundary )
           call mpp_clock_end(newClockd)
           if(do_chksum) call atmos_ice_land_chksum('flux_down_from_atmos+', (nc-1)*num_atmos_calls+na)

           !      --------------------------------------------------------------

           !      ---- land model ----

           call mpp_clock_begin(newClocke)
           if (do_land .AND. land%pe) then
              if(land_npes .NE. atmos_npes) call mpp_set_current_pelist(Land%pelist)  
              call update_land_model_fast( Atmos_land_boundary, Land )
           endif
           if(land_npes .NE. atmos_npes) call mpp_set_current_pelist(Atm%pelist)
           call mpp_clock_end(newClocke)
           if(do_chksum) call atmos_ice_land_chksum('update_land_fast+', (nc-1)*num_atmos_calls+na)

           !      ---- ice model ----
           call mpp_clock_begin(newClockf)
           if (do_ice .AND. Ice%pe) then
              if(ice_npes .NE. atmos_npes)call mpp_set_current_pelist(Ice%pelist)
              call update_ice_model_fast( Atmos_ice_boundary, Ice )
           endif
           if(ice_npes .NE. atmos_npes) call mpp_set_current_pelist(Atm%pelist)
           call mpp_clock_end(newClockf)
           if(do_chksum) call atmos_ice_land_chksum('update_ice_fast+', (nc-1)*num_atmos_calls+na)

           !      --------------------------------------------------------------
           !      ---- atmosphere up ----

           call mpp_clock_begin(newClockg)
           call flux_up_to_atmos( Time_atmos, Land, Ice, Land_ice_atmos_boundary, &
                & Atmos_land_boundary, Atmos_ice_boundary )
           call mpp_clock_end(newClockg)
           if(do_chksum) call atmos_ice_land_chksum('flux_up2atmos+', (nc-1)*num_atmos_calls+na)

           call mpp_clock_begin(newClockh)
           if (do_atmos) &
                call update_atmos_model_up( Land_ice_atmos_boundary, Atm )
           call mpp_clock_end(newClockh)
           if(do_chksum) call atmos_ice_land_chksum('update_atmos_up+', (nc-1)*num_atmos_calls+na)

           !--------------

        enddo
        call mpp_clock_end(newClock7)

        call mpp_clock_begin(newClock8)
        !   ------ end of atmospheric time step loop -----
        if (do_land .AND. Land%pe) then
           if(land_npes .NE. atmos_npes) call mpp_set_current_pelist(Land%pelist)
           call update_land_model_slow(Atmos_land_boundary,Land)
        endif
        if(land_npes .NE. atmos_npes) call mpp_set_current_pelist(Atm%pelist)
        !-----------------------------------------------------------------------
        call mpp_clock_end(newClock8)
        if(do_chksum) call atmos_ice_land_chksum('update_land_slow+', nc)

        !
        !     need flux call to put runoff and p_surf on ice grid
        !
        call mpp_clock_begin(newClock9)
        call flux_land_to_ice( Time, Land, Ice, Land_ice_boundary )
        call mpp_clock_end(newClock9)
        if(do_chksum) call atmos_ice_land_chksum('fluxlnd2ice+', nc)

        Atmos_ice_boundary%p = 0.0 ! call flux_atmos_to_ice_slow ?

        !   ------ slow-ice model ------

        if (do_ice) then 
           call mpp_clock_begin(newClock10)
           if( Ice%pe ) then
              if(ice_npes .NE. atmos_npes) call mpp_set_current_pelist(Ice%pelist)
              call update_ice_model_slow_dn( Atmos_ice_boundary, &
                   & Land_ice_boundary, Ice )
           endif
           if(ice_npes .NE. atmos_npes) call mpp_set_current_pelist(Atm%pelist)
           call mpp_clock_end(newClock10)
           if(do_chksum) call atmos_ice_land_chksum('update_ice_slow_dn+', nc)

           call mpp_clock_begin(newClock11)
           if( Ice%pe ) then
              if(ice_npes .NE. atmos_npes) call mpp_set_current_pelist(Ice%pelist)
              call flux_ice_to_ocean_stocks(Ice)
           endif
           if(ice_npes .NE. atmos_npes) call mpp_set_current_pelist(Atm%pelist)
           call mpp_clock_end(newClock11)
           if(do_chksum) call atmos_ice_land_chksum('fluxice2ocn_stocks+', nc)
        endif
        Time = Time_atmos
        call mpp_clock_end(newClock5)
     end if                     !Atm%pe block

     if( .NOT.use_lag_fluxes )then !this will serialize
        call mpp_set_current_pelist()
        call flux_ice_to_ocean( Time, Ice, Ocean, Ice_ocean_boundary )
     end if

     if( Ocean%is_ocean_pe )then
        call mpp_set_current_pelist(Ocean%pelist)
        call mpp_clock_begin(newClock12)

        if (do_chksum) call ocean_chksum('update_ocean_model-', nc)
        ! update_ocean_model since fluxes don't change here

        if (do_ocean) &
          call update_ocean_model( Ice_ocean_boundary, Ocean_state,  Ocean, &
                                   Time_ocean, Time_step_cpld )

        if (do_chksum) call ocean_chksum('update_ocean_model+', nc)
        ! Get stocks from "Ice_ocean_boundary" and add them to Ocean stocks.
        ! This call is just for record keeping of stocks transfer and
        ! does not modify either Ocean or Ice_ocean_boundary
        call flux_ocean_from_ice_stocks(Ocean_state, Ocean, Ice_ocean_boundary)

        Time_ocean = Time_ocean +  Time_step_cpld

        !-----------------------------------------------------------------------
        Time = Time_ocean

        call mpp_clock_end(newClock12)
     end if

!rabcall mpp_clock_begin(newClock13)
     !--- write out intermediate restart file when needed.
     if( Time >= Time_restart ) then
        Time_restart_current = Time
        Time_restart = increment_date(Time, restart_interval(1), restart_interval(2), &
             restart_interval(3), restart_interval(4), restart_interval(5), restart_interval(6) )
        timestamp = date_to_string(time_restart_current)
        outunit= stdout()
        write(outunit,*) '=> NOTE from program coupler: intermediate restart file is written and ', &
             trim(timestamp),' is appended as prefix to each restart file name'
        if( Atm%pe )then        
           call atmos_model_restart(Atm, timestamp)
           call land_model_restart(timestamp)
           call ice_model_restart(Ice, timestamp)
        endif
        if( Ocean%is_ocean_pe) then
           call ocean_model_restart(Ocean_state, timestamp)
        endif
        call coupler_restart(Time, Time_restart_current, timestamp)
     end if

     !--------------
     if(do_chksum) call coupler_chksum('MAIN_LOOP+', nc)
     write( text,'(a,i4)' )'Main loop at coupling timestep=', nc
     call print_memuse_stats(text)
!rabcall mpp_clock_end(newClock13)


  enddo

     call mpp_set_current_pelist()
call mpp_clock_begin(newClock14)
  if(check_stocks >= 0) then
     call mpp_set_current_pelist()
     call flux_check_stocks(Time=Time, Atm=Atm, Lnd=Land, Ice=Ice, Ocn_state=Ocean_state)
  endif
call mpp_clock_end(newClock14)

! Need final update of Ice_ocean_boundary for concurrent restart
!  if( concurrent )then
!      call mpp_set_current_pelist()
!      call flux_ice_to_ocean( Time, Ice, Ocean, Ice_ocean_boundary )
!  endif

  call mpp_set_current_pelist()
!-----------------------------------------------------------------------
  call mpp_clock_end(mainClock)
  call mpp_clock_begin(termClock)

  if(do_chksum) call coupler_chksum('coupler_end-', nc)
  call coupler_end

  call mpp_clock_end(termClock)

  call print_memuse_stats( 'Memory HiWaterMark', always=.TRUE. )
  call fms_end

!-----------------------------------------------------------------------

contains

!#######################################################################

  subroutine coupler_init

    use ensemble_manager_mod, only : ensemble_manager_init, get_ensemble_id,ensemble_pelist_setup
    use ensemble_manager_mod, only : get_ensemble_size, get_ensemble_pelist

!-----------------------------------------------------------------------
!   initialize all defined exchange grids and all boundary maps
!-----------------------------------------------------------------------
 
!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

    character(len=64), parameter    :: sub_name = 'coupler_init'
    character(len=256), parameter   :: error_header =                               &
         '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
    character(len=256), parameter   :: warn_header =                                &
         '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
    character(len=256), parameter   :: note_header =                                &
         '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

    integer :: unit,  ierr, io,    m, i, outunit, logunit, errunit
    integer :: date(6)
    type (time_type) :: Run_length
    character(len=9) :: month
    integer :: pe, npes

    integer :: ens_siz(6), ensemble_size

    integer :: atmos_pe_start=0, atmos_pe_end=0, &
               ocean_pe_start=0, ocean_pe_end=0
    integer :: n
    integer :: diag_model_subset=DIAG_ALL
    logical :: other_fields_exist
    character(len=256) :: err_msg
    integer :: date_restart(6)
    character(len=64)  :: filename, fieldname
    integer :: id_restart, l
    integer :: omp_get_thread_num, omp_get_num_threads
    integer :: get_cpu_affinity, base_cpu
    character(len=8)  :: walldate
    character(len=10) :: walltime
    character(len=5)  :: wallzone
    integer           :: wallvalues(8)
!-----------------------------------------------------------------------

    outunit = stdout()
    errunit = stderr()
    logunit = stdlog()
    
    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write(errunit,*) 'Entering coupler_init at '&
                       //trim(walldate)//' '//trim(walltime)
    endif

!----- write version to logfile -------
    call write_version_number(version, tagname)

!----- read namelist -------

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, coupler_nml, iostat=io)
    ierr = check_nml_error (io, 'coupler_nml')
#else
    unit = open_namelist_file()
    ierr=1; do while (ierr /= 0)
       read  (unit, nml=coupler_nml, iostat=io, end=10)
       ierr = check_nml_error (io, 'coupler_nml')
    enddo
10  call mpp_close(unit)
#endif

    if(ocean_nthreads /= 1) then
       call error_mesg ('coupler_init', 'OpenMP threading is not currently available for the ocean, '// &
            'Resetting variable ocean_nthreads to 1.', NOTE )
        ocean_nthreads = 1
    endif


!---- when concurrent is set true and mpp_io_nml io_clock_on is set true, the model
!---- will crash with error message "MPP_CLOCK_BEGIN: cannot change pelist context of a clock",
!---- so need to make sure it will not happen
    if(concurrent) then
       if(mpp_io_clock_on()) then
          call error_mesg ('program coupler', 'when coupler_nml variable concurrent is set to true, '// &
              'mpp_io_nml variable io_clock_non can not be set to true.', FATAL )
       endif
    endif
!----- read date and calendar type from restart file -----

    if( file_exist('INPUT/coupler.res') )then
!Balaji: currently written in binary, needs form=MPP_NATIVE
        call mpp_open( unit, 'INPUT/coupler.res', action=MPP_RDONLY )
        read( unit,*,err=999 )calendar_type
        read( unit,* )date_init
        read( unit,* )date
        goto 998 !back to fortran-4
!read old-style coupler.res
999     call mpp_close(unit)
        call mpp_open( unit, 'INPUT/coupler.res', action=MPP_RDONLY, form=MPP_NATIVE )
        read(unit)calendar_type
        read(unit)date
998     call mpp_close(unit)
    else
        force_date_from_namelist = .true.
    endif

!----- use namelist value (either no restart or override flag on) ---

    if ( force_date_from_namelist ) then

        if ( sum(current_date) <= 0 ) then
            call error_mesg ('program coupler',  &
                 'no namelist value for base_date or current_date', FATAL)
        else
            date      = current_date
        endif

!----- override calendar type with namelist value -----

        select case( uppercase(trim(calendar)) )
        case( 'JULIAN' )
            calendar_type = JULIAN
        case( 'NOLEAP' )
            calendar_type = NOLEAP
        case( 'THIRTY_DAY' )
            calendar_type = THIRTY_DAY_MONTHS
        case( 'NO_CALENDAR' )
            calendar_type = NO_CALENDAR
        end select

    endif

    call set_calendar_type (calendar_type, err_msg)
    if(err_msg /= '') then
      call mpp_error(FATAL, 'ERROR in coupler_init: '//trim(err_msg))
    endif

    if( concurrent .AND. .NOT.use_lag_fluxes )call mpp_error( WARNING, &
            'coupler_init: you have set concurrent=TRUE and use_lag_fluxes=FALSE &
            & in coupler_nml. When not using lag fluxes, components &
            & will synchronize at two points, and thus run serially.' )


    !Check with the ensemble_manager module for the size of ensemble
    !and PE counts for each member of the ensemble.
    !
    !NOTE: ensemble_manager_init renames all the output files (restart and diagnostics)
    !      to show which ensemble member they are coming from.
    !      There also need to be restart files for each member of the ensemble in INPUT.
    !
    !NOTE: if the ensemble_size=1 the input/output files will not be renamed.
    !
    
    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write(errunit,*) 'Starting initializing ensemble_manager at '&
                       //trim(walldate)//' '//trim(walltime)
    endif
    call ensemble_manager_init() ! init pelists for ensembles
    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write(errunit,*) 'Finished initializing ensemble_manager at '&
                       //trim(walldate)//' '//trim(walltime)
    endif
    ens_siz = get_ensemble_size()   
    ensemble_size = ens_siz(1)      
    npes = ens_siz(2)              

    !Check for the consistency of PE counts
    if( concurrent )then
!atmos_npes + ocean_npes must equal npes
        if( atmos_npes.EQ.0 )atmos_npes = npes - ocean_npes
        if( ocean_npes.EQ.0 )ocean_npes = npes - atmos_npes
!both must now be non-zero
        if( atmos_npes.EQ.0 .OR. ocean_npes.EQ.0 ) &
             call mpp_error( FATAL, 'coupler_init: atmos_npes or ocean_npes must be specified for concurrent coupling.' )
        if( atmos_npes+ocean_npes.NE.npes ) &
             call mpp_error( FATAL, 'coupler_init: atmos_npes+ocean_npes must equal npes for concurrent coupling.' )
    else                        !serial timestepping
        if( (atmos_npes.EQ.0) .and. (do_atmos .or. do_land .or. do_ice) ) atmos_npes = npes
        if( (ocean_npes.EQ.0) .and. (do_ocean) ) ocean_npes = npes
        if( max(atmos_npes,ocean_npes).EQ.npes )then !overlapping pelists
            ! do nothing
        else                    !disjoint pelists
            if( atmos_npes+ocean_npes.NE.npes ) call mpp_error( FATAL,  &
                 'coupler_init: atmos_npes+ocean_npes must equal npes for serial coupling on disjoint pelists.' )
        end if
    end if    

    if( land_npes == 0 ) land_npes = atmos_npes
    if( ice_npes  == 0 ) ice_npes  = atmos_npes    
    if(land_npes > atmos_npes) call mpp_error(FATAL, 'coupler_init: land_npes > atmos_npes')
    if(ice_npes  > atmos_npes) call mpp_error(FATAL, 'coupler_init: ice_npes > atmos_npes')

    allocate( Atm%pelist  (atmos_npes) )
    allocate( Ocean%pelist(ocean_npes) )
    allocate( Land%pelist (land_npes) )
    allocate( Ice%pelist  (ice_npes) )

    !Set up and declare all the needed pelists
    call ensemble_pelist_setup(concurrent, atmos_npes, ocean_npes, land_npes, ice_npes, &
                               Atm%pelist, Ocean%pelist, Land%pelist, Ice%pelist)

!set up affinities based on threads

    ensemble_id = get_ensemble_id() 
 
    allocate(ensemble_pelist(1:ensemble_size,1:npes))   
    call get_ensemble_pelist(ensemble_pelist) 

    Atm%pe            = ANY(Atm%pelist   .EQ. mpp_pe()) 
    Ocean%is_ocean_pe = ANY(Ocean%pelist .EQ. mpp_pe())  
    Ice%pe            = ANY(Ice%pelist   .EQ. mpp_pe())  
    Land%pe           = ANY(Land%pelist  .EQ. mpp_pe()) 
 
    !Why is the following needed?
    if( Atm%pe )then
!$      call omp_set_num_threads(atmos_nthreads)
        call mpp_set_current_pelist( Atm%pelist )
!$      base_cpu = get_cpu_affinity()
!$OMP PARALLEL
!$        call set_cpu_affinity( base_cpu + omp_get_thread_num() )
!$OMP END PARALLEL
    end if

    if( Ocean%is_ocean_pe )then
       call mpp_set_current_pelist( Ocean%pelist )
!$          call omp_set_num_threads(ocean_nthreads)
!           base_cpu = get_cpu_affinity()
!   !$OMP PARALLEL
!           call set_cpu_affinity( base_cpu + omp_get_thread_num() )
!   !$OMP END PARALLEL
       end if

   !--- initialization clock
    if( Atm%pe )then
       call mpp_set_current_pelist(Atm%pelist)
       id_atmos_model_init = mpp_clock_id( '  Init: atmos_model_init ' )
    endif
    if( Land%pe )then
       call mpp_set_current_pelist(Land%pelist)
       id_land_model_init  = mpp_clock_id( '  Init: land_model_init ' )
    endif
    if( Ice%pe )then
       call mpp_set_current_pelist(Ice%pelist)
       id_ice_model_init   = mpp_clock_id( '  Init: ice_model_init ' )
    endif
    if( Ocean%is_ocean_pe )then
       call mpp_set_current_pelist(Ocean%pelist)
       id_ocean_model_init = mpp_clock_id( '  Init: ocean_model_init ' )
    endif
    call mpp_set_current_pelist(ensemble_pelist(ensemble_id,:))
    id_flux_exchange_init = mpp_clock_id( '  Init: flux_exchange_init' )

    call mpp_set_current_pelist()
    mainClock = mpp_clock_id( 'Main loop' )
    termClock = mpp_clock_id( 'Termination' )
    
    !Write out messages on root PEs
    if(mpp_pe().EQ.mpp_root_pe() )then
       write( text,'(a,2i6,a,i2.2)' )'Atmos PE range: ', Atm%pelist(1)  , Atm%pelist(atmos_npes)  ,&
            ' ens_', ensemble_id
       call mpp_error( NOTE, 'coupler_init: '//trim(text) )
       if (ocean_npes .gt. 0) then   ! only if ocean is active (cjg)
         write( text,'(a,2i6,a,i2.2)' )'Ocean PE range: ', Ocean%pelist(1), Ocean%pelist(ocean_npes), &
              ' ens_', ensemble_id
         call mpp_error( NOTE, 'coupler_init: '//trim(text) )
       else
         write( text,'(a,i2.2)' )'Ocean PE range is not set (do_ocean=.false. and concurrent=.false.) for ens_', &
               ensemble_id
         call mpp_error( NOTE, 'coupler_init: '//trim(text) )
       end if
       write( text,'(a,2i6,a,i2.2)' )'Land PE range: ', Land%pelist(1)  , Land%pelist(land_npes)  ,&
            ' ens_', ensemble_id
       call mpp_error( NOTE, 'coupler_init: '//trim(text) )
       write( text,'(a,2i6,a,i2.2)' )'Ice PE range: ', Ice%pelist(1), Ice%pelist(ice_npes), &
            ' ens_', ensemble_id
       call mpp_error( NOTE, 'coupler_init: '//trim(text) )

       if( concurrent )then
          call mpp_error( NOTE, 'coupler_init: Running with CONCURRENT coupling.' )

          write( logunit,'(a)' )'Using concurrent coupling...'
          write( logunit,'(a,4i4)' ) &
               'atmos_pe_start, atmos_pe_end, ocean_pe_start, ocean_pe_end=', &
               Atm%pelist(1)  , Atm%pelist(atmos_npes), Ocean%pelist(1), Ocean%pelist(ocean_npes) 
       else
          call mpp_error( NOTE, 'coupler_init: Running with SERIAL coupling.' )
       end if
       if( use_lag_fluxes )then
          call mpp_error( NOTE, 'coupler_init: Sending LAG fluxes to ocean.' )
       else
          call mpp_error( NOTE, 'coupler_init: Sending most recent fluxes to ocean.' )
       end if
    endif

!----- write namelist to logfile -----
    if( mpp_pe() == mpp_root_pe() )write( logunit, nml=coupler_nml )

!----- write current/initial date actually used to logfile file -----

    if ( mpp_pe().EQ.mpp_root_pe() ) &
         write( logunit, 16 )date(1),trim(month_name(date(2))),date(3:6)
16  format ('  current date used = ',i4,1x,a,2i3,2(':',i2.2),' gmt') 

!-----------------------------------------------------------------------
!------ initialize diagnostics manager ------

!jwd Fork here is somewhat dangerous. It relies on "no side effects" from
!    diag_manager_init. diag_manager_init or this section should be 
!    re-architected to guarantee this or remove this assumption.
!    For instance, what follows assumes that get_base_date has the same
!    time for both Atm and Ocean pes. While this should be the case, the
!    possible error condition needs to be checked

    if( Atm%pe )then
        call mpp_set_current_pelist(Atm%pelist)
        if(atmos_npes /= npes)diag_model_subset = DIAG_OTHER  ! change diag_model_subset from DIAG_ALL
    elseif( Ocean%is_ocean_pe )then  ! Error check above for disjoint pelists should catch any problem
        call mpp_set_current_pelist(Ocean%pelist)
        if(ocean_npes /= npes)diag_model_subset = DIAG_OCEAN  ! change diag_model_subset from DIAG_ALL
    end if
    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write(errunit,*) 'Starting to initialize diag_manager at '&
                       //trim(walldate)//' '//trim(walltime)
    endif
    call diag_manager_init(DIAG_MODEL_SUBSET=diag_model_subset)   ! initialize diag_manager for processor subset output
    call print_memuse_stats( 'diag_manager_init' )
    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write(errunit,*) 'Finished initializing diag_manager at '&
                       //trim(walldate)//' '//trim(walltime)
    endif
!-----------------------------------------------------------------------
!------ reset pelist to "full group" ------

    call mpp_set_current_pelist()
!----- always override initial/base date with diag_manager value -----

    call get_base_date ( date_init(1), date_init(2), date_init(3), &
         date_init(4), date_init(5), date_init(6)  )

!----- use current date if no base date ------

    if ( date_init(1) == 0 ) date_init = date

!----- set initial and current time types ------

    Time_init = set_date (date_init(1), date_init(2), date_init(3), &
         date_init(4), date_init(5), date_init(6))

    Time      = set_date (date(1), date(2), date(3),  &
         date(4), date(5), date(6))

    Time_start = Time

!----- compute the ending time -----

    Time_end = Time
    do m=1,months
       Time_end = Time_end + set_time(0,days_in_month(Time_end))
    end do
    Time_end   = Time_end + set_time(hours*3600+minutes*60+seconds, days)
    !Need to pass Time_end into diag_manager for multiple thread case.
    call diag_manager_set_time_end(Time_end)

    Run_length = Time_end - Time

!--- get the time that last intermediate restart file was written out.
    if (file_exist('INPUT/coupler.intermediate.res')) then
       call mpp_open(unit,'INPUT/coupler.intermediate.res',action=MPP_RDONLY)
       read(unit,*) date_restart
       call mpp_close(unit)
    else
       date_restart = date
    endif

    Time_restart_current = Time
    if(ALL(restart_interval ==0)) then
       Time_restart = increment_date(Time_end, 0, 0, 10, 0, 0, 0)   ! no intermediate restart
    else
       Time_restart = set_date(date_restart(1), date_restart(2), date_restart(3),  &
                               date_restart(4), date_restart(5), date_restart(6) )
       Time_restart = increment_date(Time_restart, restart_interval(1), restart_interval(2), &
            restart_interval(3), restart_interval(4), restart_interval(5), restart_interval(6) )
       if(Time_restart <= Time) call mpp_error(FATAL, &
            '==>Error from program coupler: The first intermediate restart time is no larger than the start time')
    end if

!-----------------------------------------------------------------------
!----- write time stamps (for start time and end time) ------

    call mpp_open( unit, 'time_stamp.out', nohdrs=.TRUE. )

    month = month_name(date(2))
    if ( mpp_pe().EQ.mpp_root_pe() ) write (unit,20) date, month(1:3)

    call get_date (Time_end, date(1), date(2), date(3),  &
         date(4), date(5), date(6))
    month = month_name(date(2))
    if ( mpp_pe().EQ.mpp_root_pe() ) write (unit,20) date, month(1:3)

    call mpp_close(unit)

20  format (6i6,2x,a3)

!-----------------------------------------------------------------------
!----- compute the time steps ------

    Time_step_cpld  = set_time (dt_cpld ,0)
    Time_step_atmos = set_time (dt_atmos,0)

!----- determine maximum number of iterations per loop ------

    num_cpld_calls  = Run_length      / Time_step_cpld
    num_atmos_calls = Time_step_cpld  / Time_step_atmos

!-----------------------------------------------------------------------
!------------------- some error checks ---------------------------------

!----- initial time cannot be greater than current time -------

    if ( Time_init > Time ) call error_mesg ('program coupler',  &
         'initial time is greater than current time', FATAL)

!----- make sure run length is a multiple of ocean time step ------

    if ( num_cpld_calls * Time_step_cpld  /= Run_length )  &
         call error_mesg ('program coupler',  &
         'run length must be multiple of coupled time step', FATAL)

! ---- make sure cpld time step is a multiple of atmos time step ----

    if ( num_atmos_calls * Time_step_atmos /= Time_step_cpld )  &
         call error_mesg ('program coupler',   &
         'cpld time step is not a multiple of the atmos time step', FATAL)

!
!       Initialize the tracer manager. This needs to be done on all PEs,
!       before the individual models are initialized.
!

    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write(errunit,*) 'Starting to initialize tracer_manager at '&
                       //trim(walldate)//' '//trim(walltime)
    endif
    call tracer_manager_init
    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write(errunit,*) 'Finished initializing tracer_manager at '&
                       //trim(walldate)//' '//trim(walltime)
    endif
!
!       Initialize the coupler types
!

    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write(errunit,*) 'Starting to initialize coupler_types at '&
                       //trim(walldate)//' '//trim(walltime)
    endif
    call coupler_types_init
    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write(errunit,*) 'Finished initializing coupler_types at '&
                       //trim(walldate)//' '//trim(walltime)
    endif

!-----------------------------------------------------------------------
!------ initialize component models ------
!------ grid info now comes from grid_spec file

    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write(errunit,*) 'Beginning to initialize component models at '&
                       //trim(walldate)//' '//trim(walltime)
    endif
    if( Atm%pe )then
        call mpp_set_current_pelist(Atm%pelist)
!---- atmosphere ----
        if( mpp_pe().EQ.mpp_root_pe() ) then
          call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
          write(errunit,*) 'Starting to initialize atmospheric model at '&
                           //trim(walldate)//' '//trim(walltime)
        endif

        call mpp_clock_begin(id_atmos_model_init)
        call atmos_model_init( Atm, Time_init, Time, Time_step_atmos )
        call mpp_clock_end(id_atmos_model_init)
        if( mpp_pe().EQ.mpp_root_pe() ) then
          call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
          write(errunit,*) 'Finished initializing atmospheric model at '&
                           //trim(walldate)//' '//trim(walltime)
        endif
        call print_memuse_stats( 'atmos_model_init' )
        call data_override_init(Atm_domain_in = Atm%domain)
     endif
!---- land ----------
     if( Land%pe ) then
        call mpp_set_current_pelist(Land%pelist)
        if( mpp_pe().EQ.mpp_root_pe() ) then
          call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
          write(errunit,*) 'Starting to initialize land model at '&
                           //trim(walldate)//' '//trim(walltime)
        endif
        call mpp_clock_begin(id_land_model_init)
        call land_model_init( Atmos_land_boundary, Land, Time_init, Time, &
             Time_step_atmos, Time_step_cpld )
        call mpp_clock_end(id_land_model_init)
        if( mpp_pe().EQ.mpp_root_pe() ) then
          call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
          write(errunit,*) 'Finished initializing land model at '&
                           //trim(walldate)//' '//trim(walltime)
        endif
        call print_memuse_stats( 'land_model_init' )
        call data_override_init(Land_domain_in = Land%domain)
     endif
!---- ice -----------
     if( Ice%pe ) then
        call mpp_set_current_pelist(Ice%pelist)
        if( mpp_pe().EQ.mpp_root_pe() ) then
          call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
          write(errunit,*) 'Starting to initialize ice model at '&
                           //trim(walldate)//' '//trim(walltime)
        endif
        call mpp_clock_begin(id_ice_model_init)
        call ice_model_init( Ice, Time_init, Time, Time_step_atmos, Time_step_cpld )
        call mpp_clock_end(id_ice_model_init)
        if( mpp_pe().EQ.mpp_root_pe() ) then
          call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
          write(errunit,*) 'Finished initializing ice model at '&
                           //trim(walldate)//' '//trim(walltime)
        endif
        call print_memuse_stats( 'ice_model_init' )
        call data_override_init(Ice_domain_in = Ice%domain)
    end if
    if( Ocean%is_ocean_pe )then
        call mpp_set_current_pelist(Ocean%pelist)
!---- ocean ---------
        if( mpp_pe().EQ.mpp_root_pe() ) then
          call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
          write(errunit,*) 'Starting to initialize ocean model at '&
                           //trim(walldate)//' '//trim(walltime)
        endif
        call mpp_clock_begin(id_ocean_model_init)
        call ocean_model_init( Ocean, Ocean_state, Time_init, Time )
        call mpp_clock_end(id_ocean_model_init)
        if( mpp_pe().EQ.mpp_root_pe() ) then
          call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
          write(errunit,*) 'Finished initializing ocean model at '&
                           //trim(walldate)//' '//trim(walltime)
        endif
        call print_memuse_stats( 'ocean_model_init' )
        if( mpp_pe().EQ.mpp_root_pe() ) then
          call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
          write(errunit,*) 'Starting to initialize data_override at '&
                           //trim(walldate)//' '//trim(walltime)
        endif
        call data_override_init(Ocean_domain_in = Ocean%domain )
        if( mpp_pe().EQ.mpp_root_pe() ) then
          call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
          write(errunit,*) 'Finished initializing data_override at '&
                           //trim(walldate)//' '//trim(walltime)
        endif
    end if
    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write(errunit,*) 'Finished initializing component models at '&
                       //trim(walldate)//' '//trim(walltime)
    endif
    call mpp_set_current_pelist(ensemble_pelist(ensemble_id,:))

    call mpp_broadcast_domain(Ice%domain)
    call mpp_broadcast_domain(Ocean%domain)
!-----------------------------------------------------------------------
!---- initialize flux exchange module ----
    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write(errunit,*) 'Starting to initialize flux_exchange at '&
                       //trim(walldate)//' '//trim(walltime)
    endif
    call mpp_clock_begin(id_flux_exchange_init)
    call flux_exchange_init ( Time, Atm, Land, Ice, Ocean, Ocean_state,&
         atmos_ice_boundary, land_ice_atmos_boundary, &
         land_ice_boundary, ice_ocean_boundary, ocean_ice_boundary, &
         dt_atmos=dt_atmos, dt_cpld=dt_cpld)
    call mpp_set_current_pelist(ensemble_pelist(ensemble_id,:))
    call mpp_clock_end(id_flux_exchange_init)
    call mpp_set_current_pelist()
    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write(errunit,*) 'Finsihed initializing flux_exchange at '&
                       //trim(walldate)//' '//trim(walltime)
    endif

    Time_atmos = Time
    Time_ocean = Time

!
!       read in extra fields for the air-sea gas fluxes
!

    if ( Ice%pe ) then
      call mpp_set_current_pelist(Ice%pelist)
      allocate(Ice_bc_restart(Ice%ocean_fluxes%num_bcs))
      allocate(ice_bc_restart_file(Ice%ocean_fluxes%num_bcs))
      do n = 1, Ice%ocean_fluxes%num_bcs  !{
        if(Ice%ocean_fluxes%bc(n)%num_fields .LE. 0) cycle
        filename = trim(Ice%ocean_fluxes%bc(n)%ice_restart_file)
        do l = 1, num_ice_bc_restart
           if(trim(filename) == ice_bc_restart_file(l)) exit
        end do
        if(l>num_ice_bc_restart) then
           num_ice_bc_restart = num_ice_bc_restart + 1
           ice_bc_restart_file(l) = trim(filename)
        end if
        filename = 'INPUT/'//trim(filename)
        other_fields_exist = .false.
        do m = 1, Ice%ocean_fluxes%bc(n)%num_fields  !{
          fieldname = trim(Ice%ocean_fluxes%bc(n)%field(m)%name)
          id_restart = register_restart_field(Ice_bc_restart(l), ice_bc_restart_file(l), &
                       fieldname, Ice%ocean_fluxes%bc(n)%field(m)%values, Ice%domain    )
          if (field_exist(filename, fieldname, Ice%domain) ) then
            other_fields_exist = .true.
            write (outunit,*) trim(note_header), ' Reading restart info for ',         &
                 trim(fieldname), ' from ',  trim(filename)
            call read_data(filename, fieldname, Ice%ocean_fluxes%bc(n)%field(m)%values, Ice%domain)
          elseif (other_fields_exist) then
            call mpp_error(FATAL, trim(error_header) // ' Couldn''t find field ' //     &
                 trim(fieldname) // ' in file ' //trim(filename))
          endif
        enddo  !} m
      enddo  !} n
    endif
    if ( Ocean%is_ocean_pe ) then
      call mpp_set_current_pelist(Ocean%pelist)
      allocate(Ocn_bc_restart(Ocean%fields%num_bcs))
      allocate(ocn_bc_restart_file(Ocean%fields%num_bcs))
      do n = 1, Ocean%fields%num_bcs  !{
        if(Ocean%fields%bc(n)%num_fields .LE. 0) cycle
        filename = trim(Ocean%fields%bc(n)%ocean_restart_file)
        do l = 1, num_ocn_bc_restart
           if(trim(filename) == ocn_bc_restart_file(l)) exit
        end do
        if(l>num_ocn_bc_restart) then
           num_ocn_bc_restart = num_ocn_bc_restart + 1
           ocn_bc_restart_file(l) = trim(filename)
        end if
        filename = 'INPUT/'//trim(filename)
        other_fields_exist = .false.
        do m = 1, Ocean%fields%bc(n)%num_fields  !{
          fieldname = trim(Ocean%fields%bc(n)%field(m)%name)
          id_restart = register_restart_field(Ocn_bc_restart(l), Ocn_bc_restart_file(l), &
                       fieldname, Ocean%fields%bc(n)%field(m)%values, Ocean%domain    )
          if (field_exist(filename, fieldname, Ocean%domain) ) then
            other_fields_exist = .true.
            write (outunit,*) trim(note_header), ' Reading restart info for ',         &
                 trim(fieldname), ' from ', trim(filename)
            call read_data(filename, fieldname, Ocean%fields%bc(n)%field(m)%values, Ocean%domain)
          elseif (other_fields_exist) then
            call mpp_error(FATAL, trim(error_header) // ' Couldn''t find field ' //     &
                 trim(fieldname) // ' in file ' //trim(filename))
          endif
        enddo  !} m
      enddo  !} n
    endif

    call mpp_set_current_pelist()

!-----------------------------------------------------------------------
!---- open and close dummy file in restart dir to check if dir exists --

    call mpp_open( unit, 'RESTART/file' )
    call mpp_close(unit, MPP_DELETE)

    ! Call to daig_grid_end to free up memory used during regional
    ! output setup
    CALL diag_grid_end()

!-----------------------------------------------------------------------
    if (Atm%pe) then 
      call mpp_set_current_pelist(Atm%pelist)
      call atmos_ice_land_chksum('coupler_init+', 0)
    endif
    if (Ocean%is_ocean_pe) then 
      call mpp_set_current_pelist(Ocean%pelist)
      call ocean_chksum('coupler_init+', nc)
    endif
    call mpp_set_current_pelist()
    call print_memuse_stats('coupler_init')

    if( mpp_pe().EQ.mpp_root_pe() ) then
      call DATE_AND_TIME(walldate, walltime, wallzone, wallvalues)
      write(errunit,*) 'Exiting coupler_init at '&
                       //trim(walldate)//' '//trim(walltime)
    endif
  end subroutine coupler_init

!#######################################################################

  subroutine coupler_end

!-----------------------------------------------------------------------

    if (Atm%pe) then 
      call mpp_set_current_pelist(Atm%pelist)
      call atmos_ice_land_chksum('coupler_end', 0)
    endif
    if (Ocean%is_ocean_pe) then 
      call mpp_set_current_pelist(Ocean%pelist)
      call ocean_chksum('coupler_end', 0)
    endif
    call mpp_set_current_pelist()

!----- check time versus expected ending time ----

    if (Time /= Time_end) call error_mesg ('program coupler',  &
         'final time does not match expected ending time', WARNING)

!-----------------------------------------------------------------------
!the call to fms_io_exit has been moved here
!this will work for serial code or concurrent (disjoint pelists)
!but will fail on overlapping but unequal pelists
    if( Ocean%is_ocean_pe )then
        call mpp_set_current_pelist(Ocean%pelist)
        call ocean_model_end (Ocean, Ocean_state, Time)
    end if
    if( Atm%pe )then
        call mpp_set_current_pelist(Atm%pelist)
        call atmos_model_end (Atm)
    endif
    if( Land%pe ) then
        call mpp_set_current_pelist(Land%pelist)
        call  land_model_end (Atmos_land_boundary, Land)
    endif
    if( Ice%pe ) then
        call mpp_set_current_pelist(Ice%pelist)
        call   ice_model_end (Ice)
    end if

    !----- write restart file ------
    call coupler_restart(Time, Time_restart_current)

    call diag_manager_end (Time)
    call fms_io_exit
    call mpp_set_current_pelist()

!-----------------------------------------------------------------------

  end subroutine coupler_end

  !--- writing restart file that contains running time and restart file writing time.
  subroutine coupler_restart(Time_run, Time_res, time_stamp)
    type(time_type),   intent(in)           :: Time_run, Time_res
    character(len=*), intent(in),  optional :: time_stamp
    character(len=128)                      :: file_run, file_res
    integer :: yr, mon, day, hr, min, sec, date(6), unit, n

    call mpp_set_current_pelist()

    ! write restart file
    if(present(time_stamp)) then
       file_run = 'RESTART/'//trim(time_stamp)//'.coupler.res'
       file_res = 'RESTART/'//trim(time_stamp)//'.coupler.intermediate.res'
    else
       file_run = 'RESTART/coupler.res'
       file_res = 'RESTART/coupler.intermediate.res'
    endif

    !----- compute current date ------
    call get_date (Time_run, date(1), date(2), date(3),  &
                   date(4), date(5), date(6))
    call mpp_open( unit, file_run, nohdrs=.TRUE. )
    if ( mpp_pe().EQ.mpp_root_pe() )then
        write( unit, '(i6,8x,a)' )calendar_type, &
             '(Calendar: no_calendar=0, thirty_day_months=1, julian=2, gregorian=3, noleap=4)'

        write( unit, '(6i6,8x,a)' )date_init, &
             'Model start time:   year, month, day, hour, minute, second'
        write( unit, '(6i6,8x,a)' )date, &
             'Current model time: year, month, day, hour, minute, second'
    end if
    call mpp_close(unit)

    if(Time_res > Time_start) then
       call mpp_open( unit, file_res, nohdrs=.TRUE. )
       if ( mpp_pe().EQ.mpp_root_pe() )then
          call get_date(Time_res ,yr,mon,day,hr,min,sec)
          write( unit, '(6i6,8x,a)' )yr,mon,day,hr,min,sec, &
               'Current intermediate restart time: year, month, day, hour, minute, second'
       end if
       call mpp_close(unit)     
    end if

    if( Ocean%is_ocean_pe )then
        call mpp_set_current_pelist(Ocean%pelist)
        do n = 1, num_ocn_bc_restart
           call save_restart(Ocn_bc_restart(n), time_stamp)
        enddo
    endif
    if( Atm%pe )then
        call mpp_set_current_pelist(Atm%pelist)
        do n = 1, num_ice_bc_restart
           call save_restart(Ice_bc_restart(n), time_stamp)
        enddo
    endif


  end subroutine coupler_restart

!--------------------------------------------------------------------------

  subroutine coupler_chksum(id, timestep)

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep

    type :: tracer_ind_type
       integer :: atm, ice, lnd ! indices of the tracer in the respective models
    end type tracer_ind_type
    integer                            :: n_atm_tr, n_lnd_tr, n_exch_tr
    integer                            :: n_atm_tr_tot, n_lnd_tr_tot
    integer                            :: i, tr, n, m, outunit
    type(tracer_ind_type), allocatable :: tr_table(:)
    character(32) :: tr_name

    call get_number_tracers (MODEL_ATMOS, num_tracers=n_atm_tr_tot, &
                             num_prog=n_atm_tr)
    call get_number_tracers (MODEL_LAND, num_tracers=n_lnd_tr_tot, &
                             num_prog=n_lnd_tr)

    ! assemble the table of tracer number translation by matching names of
    ! prognostic tracers in the atmosphere and surface models; skip all atmos.
    ! tracers that have no corresponding surface tracers.
    allocate(tr_table(n_atm_tr))
    n = 1
    do i = 1,n_atm_tr
       call get_tracer_names( MODEL_ATMOS, i, tr_name )
       tr_table(n)%atm = i
       tr_table(n)%ice = get_tracer_index ( MODEL_ICE,  tr_name )
       tr_table(n)%lnd = get_tracer_index ( MODEL_LAND, tr_name )
       if(tr_table(n)%ice/=NO_TRACER.or.tr_table(n)%lnd/=NO_TRACER) &
            n = n+1
    enddo
    n_exch_tr = n-1

100 FORMAT("CHECKSUM::",A32," = ",Z20)
101 FORMAT("CHECKSUM::",A16,a,'%',a," = ",Z20)

    if( Atm%pe )then
       call mpp_set_current_pelist(Atm%pelist)

       outunit = stdout()
       write(outunit,*) 'BEGIN CHECKSUM(Atm):: ', id, timestep
       write(outunit,100) 'atm%t_bot', mpp_chksum(atm%t_bot)
       write(outunit,100) 'atm%z_bot', mpp_chksum(atm%z_bot)
       write(outunit,100) 'atm%p_bot', mpp_chksum(atm%p_bot)
       write(outunit,100) 'atm%u_bot', mpp_chksum(atm%u_bot)
       write(outunit,100) 'atm%v_bot', mpp_chksum(atm%v_bot)
       write(outunit,100) 'atm%p_surf', mpp_chksum(atm%p_surf)
       write(outunit,100) 'atm%gust', mpp_chksum(atm%gust)
       do tr = 1,n_exch_tr
          n = tr_table(tr)%atm
          if(n /= NO_TRACER ) then
             call get_tracer_names( MODEL_ATMOS, tr_table(tr)%atm, tr_name )
             write(outunit,100) 'atm%'//trim(tr_name), mpp_chksum(Atm%tr_bot(:,:,n))
          endif
       enddo
   
       write(outunit,100) 'land%t_surf', mpp_chksum(land%t_surf)
       write(outunit,100) 'land%t_ca', mpp_chksum(land%t_ca)
       write(outunit,100) 'land%rough_mom', mpp_chksum(land%rough_mom)
       write(outunit,100) 'land%rough_heat', mpp_chksum(land%rough_heat)
       write(outunit,100) 'land%rough_scale', mpp_chksum(land%rough_scale)
       do tr = 1,n_exch_tr
          n = tr_table(tr)%lnd
          if(n /= NO_TRACER ) then
             call get_tracer_names( MODEL_ATMOS, tr_table(tr)%atm, tr_name )
             write(outunit,100) 'land%'//trim(tr_name), mpp_chksum(Land%tr(:,:,:,n))
          endif
       enddo
   
       write(outunit,100) 'ice%t_surf', mpp_chksum(ice%t_surf)
       write(outunit,100) 'ice%rough_mom', mpp_chksum(ice%rough_mom)
       write(outunit,100) 'ice%rough_heat', mpp_chksum(ice%rough_heat)
       write(outunit,100) 'ice%rough_moist', mpp_chksum(ice%rough_moist)
       write(outunit,*) 'STOP CHECKSUM(Atm):: ', id, timestep
   
    !endif

    !if( Ocean%is_ocean_pe )then
        !call mpp_set_current_pelist(Ocean%pelist)

       write(outunit,*) 'BEGIN CHECKSUM(Ice):: ', id, timestep
       do n = 1, ice%ocean_fields%num_bcs  !{
          do m = 1, ice%ocean_fields%bc(n)%num_fields  !{
             !write(outunit,101) 'ice%', m, n, mpp_chksum(Ice%ocean_fields%bc(n)%field(m)%values)
             write(outunit,101) 'ice%',trim(ice%ocean_fields%bc(n)%name), &
                  trim(ice%ocean_fields%bc(n)%field(m)%name), mpp_chksum(Ice%ocean_fields%bc(n)%field(m)%values)
          enddo  !} m
       enddo  !} n
       write(outunit,*) 'STOP CHECKSUM(Ice):: ', id, timestep

    endif

    deallocate(tr_table)

    call mpp_set_current_pelist()

  end subroutine coupler_chksum

  !#######################################################################

  subroutine atmos_ice_land_chksum(id, timestep)

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep

! This subroutine calls subroutine that will print out checksums of the elements 
! of the appropriate type. 
! For coupled models typically these types are not defined on all processors.
! It is assumed that the appropriate pelist has been set before entering this routine.
! This can be achieved in the following way.
!       if (Atm%pe) then 
!         call mpp_set_current_pelist(Atm%pelist)
!         call atmos_ice_land_chksum('MAIN_LOOP-', nc)
!       endif
! If you are on the global pelist before you enter this routine using the above call, 
! you can return to the global pelist by invoking
!       call mpp_set_current_pelist()
! after you exit. This is only necessary if you need to return to the global pelist.

     call atmos_data_type_chksum(     id, timestep, Atm)
     call lnd_ice_atm_bnd_type_chksum(id, timestep, Land_ice_atmos_boundary)

     if(Ice%pe) then
        call mpp_set_current_pelist(Ice%pelist)
        call ice_data_type_chksum(       id, timestep, Ice)
        call atm_ice_bnd_type_chksum(    id, timestep, Atmos_ice_boundary)
        call ocn_ice_bnd_type_chksum(    id, timestep, Ocean_ice_boundary)
     endif
     if(Land%pe) then
        call mpp_set_current_pelist(Land%pelist)
        call land_data_type_chksum(      id, timestep, Land)
        call atm_lnd_bnd_type_chksum(    id, timestep, Atmos_land_boundary)
     endif
        
     call mpp_set_current_pelist(Atm%pelist)

  end subroutine atmos_ice_land_chksum

  subroutine ocean_chksum(id, timestep)

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep

! This subroutine calls subroutine that will print out checksums of the elements 
! of the appropriate type. 
! For coupled models typically these types are not defined on all processors.
! It is assumed that the appropriate pelist has been set before entering this routine.
! This can be achieved in the following way.
!       if (Ocean%is_ocean_pe) then 
!         call mpp_set_current_pelist(Ocean%pelist)
!         call ocean_chksum('MAIN_LOOP-', nc)
!       endif
! If you are on the global pelist before you enter this routine using the above call, 
! you can return to the global pelist by invoking
!       call mpp_set_current_pelist()
! after you exit. This is only necessary if you need to return to the global pelist.

        call ocean_public_type_chksum(id, timestep, Ocean)
        call ice_ocn_bnd_type_chksum( id, timestep, Ice_ocean_boundary)
        
  end subroutine ocean_chksum


  end program coupler_main

        module aer_in_act_mod

implicit none
      private 
      public Jhomo_wat, Jhete_dep, Jhomo_aer, &
                       aer_in_act_init, aer_in_act_end

!Parameters for look-up tables

integer, parameter :: tpDIM = 3 ! Dimension of temperature (K)
integer, parameter :: tp2DIM = 3 ! Dimension of temperature (K)
integer, parameter :: msDIM = 5 ! Dimension of scaled sub-micron dust mass
integer, parameter :: upDIM = 5 ! Dimension of updraft velocity (m/s)
real, parameter :: unitmass = 0.11 ! (ug/m3), one unit mass

real, dimension(tpDIM) :: tp = (/243.15, 253.15, 263.15/)
real, dimension(tp2DIM) :: tp2 = (/233.15, 223.15, 213.15/)   
real, dimension(tpDIM) :: a1 = (/1.416, 1.5809, 1.5171/)
real, dimension(tpDIM) :: a2 = (/3.7909, 6.4407, 8.184/)   
real, dimension(tp2DIM) :: b1 = (/0.1068, 0., -0.1016/)
real, dimension(tp2DIM) :: b2 = (/2.2905, 1.3846, 0.5668/)
real, dimension(tp2DIM) :: b3 = (/6.1191, 4.9161, 4.1684/)
real, dimension(tp2DIM) :: c1 = (/7.2759, 10.532, 17.628/)
real, dimension(tp2DIM) :: c2 = (/1.4301, 1.346, 1.3038/)
real, dimension(tp2DIM) :: d1 = (/0.2423, 0.4259, 0.6952/)
real, dimension(tp2DIM) :: d2 = (/-1.1814, -1.3778, -1.6693/)
real, dimension(tp2DIM) :: d3 = (/1.0016, 0.9998, 1.0114/)
real, dimension(tp2DIM) :: e1 = (/0.1412, 0.1541, 0.163/)
real, dimension(tp2DIM) :: e2 = (/0.3923, 0.3397, 0.3124/)
real, dimension(tp2DIM) :: e3 = (/-0.0819, -0.0269, 0.0009/)
real, dimension(tp2DIM) :: f = (/16., 19.6, 20.2/)
real, dimension(msDIM) :: ms = (/100.,10.,1.,0.1,0.01/) ! The last dimension is for mass threshold.
real, dimension(upDIM) :: up = (/0.1,0.05,0.01,0.005,0.001/)
real, dimension(tpDIM,msDIM,upDIM) :: crystal2

character(len=128) :: version = '$Id: aer_in_act.F90,v 19.0 2012/01/06 20:31:38 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
logical :: module_is_initialized  = .false.

contains

subroutine Jhete_dep (temp,Si,concen_dust_sub,crystal)
   real, intent(in) :: temp,Si,concen_dust_sub
   real, intent(out) :: crystal

   real dust

   if(.not. module_is_initialized) call aer_in_act_init()
   
   crystal=0.
   dust=concen_dust_sub/unitmass
   if (temp>243.15) then
      crystal=dust*min(exp(12.96*(Si-1)-0.639)*5.73e-4, 0.0091)
   else if (temp>223.15) then
      crystal=dust*min(exp(12.96*(Si-1.1))**0.3*9.09e-3, 0.0091)
   else if (Si<(6.5217e-3*(temp-273.15)+1.6276)) then
      crystal=min(max(exp(1.5*(Si-1.11))-1.,0.),0.05)*dust*18.12
   endif
end subroutine Jhete_dep

subroutine Jhomo_aer (dtcloud, temp, rh, updraft, aer, crystal)
   real, dimension(3), intent(inout) :: aer
   real, intent(in) :: dtcloud, temp, rh, updraft
   real, intent(out) :: crystal

   real totalnumber, ai, aw, J, Nhomo
   integer no_tp2
   
   crystal=0.
   
   if (temp<=237.15) then
      if (temp>228.15) then
         no_tp2 = 1
      else if (temp>218.15) then
         no_tp2 = 2
      else
         no_tp2 = 3
      endif
   Nhomo=c1(no_tp2)*updraft**c2(no_tp2)
!density sulfate 1.7418e3, sea-salt 2.17e3, OC 1.362e3      
!here only particles between 0.1 and 1 micron are considered. Smaller particles do not
!have a chance to freeze.
!Size dist. is the same as used in the prognostic paper.
   totalnumber=19.1*(aer(1)/1.48e-13 + aer(2)/1.85e-13 + aer(3)/1.16e-13)
   
   ai=exp((210368.+131.438*temp-3.32373e6/temp-41729.1*log(temp))/(8.314*temp))
   aw=min(rh-ai,0.34)
!homo. nucl. rate (cm-3 sec-1); from Koop et al. (2000)
   if(aw>0.26) then
      J=10.**(-906.7+8502*aw-26924*aw**2.+29180*aw**3.);
   else
      J=0;
   endif
!the volume-average diamter is 0.204 micron (4.46e-15 cm3)
   crystal=min(Nhomo,totalnumber*(1.-exp(-1.*J*dtcloud*4.46e-15)))
   endif
end subroutine Jhomo_aer

subroutine Jhomo_wat (T, J)
!return homogeneous nucleation rate constant J (cm-3 s-1) as a
!function of temperature T (K)
   real, intent(in) :: T
   real, intent(out) :: J
   real :: TT
   
   TT = T - 273.15

   if (TT>=-50 .and. TT<-30) then
      J=-0.0001536*TT**4-0.0265*TT**3
      J=J-1.7439*TT**2-52.6611*TT-606.3952
      J=10**J
   else if (TT<-50) then
      TT=-50;
      J=-0.0001536*TT**4-0.0265*TT**3
      J=J-1.7439*TT**2-52.6611*TT-606.3952
      J=10**J
   else
      J=0.
   endif
end subroutine Jhomo_wat

subroutine aer_in_act_init ()
   module_is_initialized  = .true.
end subroutine aer_in_act_init

subroutine aer_in_act_end ()
   module_is_initialized  = .false.
end subroutine aer_in_act_end

end module aer_in_act_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: General ODE solver \label{sec:ode-solver}
!
! !INTERFACE:
   subroutine ode_solver(solver,numc,nlev,dt,cc,right_hand_side_rhs,right_hand_side_ppdd)
!
! !DESCRIPTION:
! Here, 10 different numerical solvers for the right hand sides of the
! biogeochemical models are implemented for computing the ordinary
! differential equations (ODEs) which are calculated as the second
! step of the operational split method for the complete biogeochemical
! models. The remaining ODE is
! \begin{equation}\label{ODESystem}
!   \partial_t c_i
! =   P_i(\vec{c}) -D_i(\vec{c}), \;\; i = 1,\ldots,I,
! \end{equation}
! with $c_i$ denoting the concentrations of state variables.
! The right hand side denotes the reaction terms,
! which are composed of contributions
! $d_{i,j}(\vec{c})$, which represent reactive fluxes from
! $c_i$ to $c_j$, and in turn, $p_{i,j}(\vec{c})$ are reactive fluxes from
! $c_j$ received by $c_i$, see equation (\ref{eq:am:a}).
!
! These methods are:
!
! \begin{enumerate}
! \item First-order explicit (not unconditionally positive)
! \item Second order explicit Runge-Kutta (not unconditionally positive)
! \item Fourth-order explicit Runge-Kutta (not unconditionally positive)
! \item First-order Patankar (not conservative)
! \item Second-order Patankar-Runge-Kutta (not conservative)
! \item Fourth-order Patankar-Runge-Kutta (does not work, not conservative)
! \item First-order Modified Patankar (conservative and positive)
! \item Second-order Modified Patankar-Runge-Kutta (conservative and positive)
! \item Fourth-order Modified Patankar-Runge-Kutta
!       (does not work, conservative and positive)
! \item First-order Extended Modified Patankar
!       (stoichiometrically conservative and positive)
! \item Second-order Extended Modified Patankar-Runge-Kutta
!       (stoichiometrically conservative and positive)
! \end{enumerate}
!
! The schemes 1 - 5 and 7 - 8 have been described in detail by
! \cite{Burchardetal2003b}. Later, \cite{Bruggemanetal2005} could
! show that the Modified Patankar schemes 7 - 8 are only conservative
! for one limiting nutrient and therefore they developed the
! Extended Modified Patankar (EMP) schemes 10 and 11 which are also
! stoichiometrically conservative. Patankar and Modified Patankar
! schemes of fourth order have not yet been developed, such that
! choices 6 and 9 do not work yet.
!
! The call to {\tt ode\_solver()} requires a little explanation. The
! first argument {\tt solver} is an integer and specifies which solver
! to use. The arguments {\tt numc} and {\tt nlev} gives the dimensions
! of the data structure {\tt cc} i.e. {\tt cc(1:numc,0:nlev)}.
! {\tt dt} is simply the time step. The last argument is the most
! complicated. {\tt right\_hand\_side} is a subroutine with a fixed
! argument list. The subroutine evaluates the right hand side of the ODE
! and may be called more than once during one time-step - for higher order
! schemes. For an example of a correct {\tt right\_hand\_side} have a look
! at e.g. {\tt do\_bio\_npzd()}
!
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: solver,nlev,numc
   REALTYPE, intent(in)                :: dt
!
! !INPUT/OUTPUT PARAMETER:
   REALTYPE, intent(inout)             :: cc(1:numc,0:nlev)

   interface
      subroutine right_hand_side_ppdd(first,numc,nlev,cc,pp,dd)
         logical, intent(in)                  :: first
         integer, intent(in)                  :: numc,nlev
         REALTYPE, intent(in)                 :: cc(1:numc,0:nlev)

         REALTYPE, intent(out)                :: pp(1:numc,1:numc,0:nlev)
         REALTYPE, intent(out)                :: dd(1:numc,1:numc,0:nlev)
      end
   end interface

   interface
      subroutine right_hand_side_rhs(first,numc,nlev,cc,rhs)
         logical, intent(in)                  :: first
         integer, intent(in)                  :: numc,nlev
         REALTYPE, intent(in)                 :: cc(1:numc,0:nlev)
         REALTYPE, intent(out)                :: rhs(1:numc,0:nlev)
      end
   end interface
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard, Karsten Bolding
!
! !LOCAL VARIABLES:
!EOP
!-----------------------------------------------------------------------
!BOC
   select case (solver)
      case (1)
         call euler_forward(dt,numc,nlev,cc,right_hand_side_rhs)
      case (2)
         call runge_kutta_2(dt,numc,nlev,cc,right_hand_side_rhs)
      case (3)
         call runge_kutta_4(dt,numc,nlev,cc,right_hand_side_rhs)
      case (4)
         call patankar(dt,numc,nlev,cc,right_hand_side_ppdd)
      case (5)
         call patankar_runge_kutta_2(dt,numc,nlev,cc,right_hand_side_ppdd)
      case (6)
         call patankar_runge_kutta_4(dt,numc,nlev,cc,right_hand_side_ppdd)
      case (7)
         call modified_patankar(dt,numc,nlev,cc,right_hand_side_ppdd)
      case (8)
         call modified_patankar_2(dt,numc,nlev,cc,right_hand_side_ppdd)
      case (9)
         call modified_patankar_4(dt,numc,nlev,cc,right_hand_side_ppdd)
      case (10)
         call emp_1(dt,numc,nlev,cc,right_hand_side_rhs)
      case (11)
         call emp_2(dt,numc,nlev,cc,right_hand_side_rhs)
      case default
         stop "bio: no valid solver method specified in bio.nml !"
   end select

   return
   end subroutine ode_solver
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: First-order Euler-forward scheme
!
! !INTERFACE:
   subroutine euler_forward(dt,numc,nlev,cc,right_hand_side)
!
! !DESCRIPTION:
! Here, the first-order Euler-forward (E1) scheme is coded, with one
! evaluation of the right-hand sides per time step:
! \begin{equation}\label{eq:am:euler}
! \begin{array}{rcl}
! c_i^{n+1} &=&
! \displaystyle
!  c_i^n  + \Delta t \left\{P_i\left(\underline{c}^n\right)
! - D_i\left(\underline{c}^n\right) \right\}.
! \end{array}
! \end{equation}
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: numc,nlev
   REALTYPE, intent(in)                :: dt
!
! !INPUT/OUTPUT PARAMETER:
   REALTYPE, intent(inout)             :: cc(1:numc,0:nlev)

   interface
      subroutine right_hand_side(first,numc,nlev,cc,rhs)
         logical, intent(in)                  :: first
         integer, intent(in)                  :: numc,nlev
         REALTYPE, intent(in)                 :: cc(1:numc,0:nlev)
         REALTYPE, intent(out)                :: rhs(1:numc,0:nlev)
      end
   end interface
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard, Karsten Bolding
!
! !LOCAL VARIABLES:
  logical  :: first
  REALTYPE :: rhs(1:numc,0:nlev)
  integer  :: i,ci
!EOP
!-----------------------------------------------------------------------
!BOC
   first=.true.
!   STDERR 'euler_forward ',first
   call right_hand_side(first,numc,nlev,cc,rhs)
   first=.false.
!   STDERR 'euler_forward ',first

   do ci=1,nlev
      do i=1,numc
         cc(i,ci)=cc(i,ci)+dt*rhs(i,ci)
      end do
   end do

   return
   end subroutine euler_forward
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Second-order Runge-Kutta scheme
!
! !INTERFACE:
   subroutine runge_kutta_2(dt,numc,nlev,cc,right_hand_side)
!
! !DESCRIPTION:
! Here, the second-order Runge-Kutta (RK2) scheme is coded, with two
! evaluations of the right hand side per time step:
! \begin{equation}\label{eq:am:RK}
! \left.
! \begin{array}{rcl}
! c_i^{(1)} &=&
! \displaystyle
! c_i^n  + \Delta t \left\{P_i\left(\underline{c}^n\right)
! - D_i\left(\underline{c}^n\right) \right), \\ \\
!  c_i^{n+1} &=&
! \displaystyle
!  c_i^n  + \dfrac{\Delta t}{2}
! \left\{P_i\left(\underline{c}^n\right) + P_i\left(\underline{c}^{(1)}\right)
!  - D_i\left(\underline{c}^n\right) - D_i\left(\underline{c}^{(1)}\right)
! \right\}.
! \end{array}
! \right\}
! \end{equation}
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)                :: dt
   integer, intent(in)                 :: numc,nlev
!
! !INPUT/OUTPUT PARAMETER:
   REALTYPE, intent(inout)             :: cc(1:numc,0:nlev)

   interface
      subroutine right_hand_side(first,numc,nlev,cc,rhs)
         logical, intent(in)                  :: first
         integer, intent(in)                  :: numc,nlev
         REALTYPE, intent(in)                 :: cc(1:numc,0:nlev)
         REALTYPE, intent(out)                :: rhs(1:numc,0:nlev)
      end
   end interface
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard, Karsten Bolding
!
! !LOCAL VARIABLES:
  logical  :: first
  REALTYPE :: rhs(1:numc,0:nlev),rhs1(1:numc,0:nlev)
  REALTYPE :: cc1(1:numc,0:nlev)
  integer  :: i,ci
!EOP
!-----------------------------------------------------------------------
!BOC
   first=.true.
   call right_hand_side(first,numc,nlev,cc,rhs)
   first=.false.

   do ci=1,nlev
      do i=1,numc
         cc1(i,ci)=cc(i,ci)+dt*rhs(i,ci)
      end do
   end do

   call right_hand_side(first,numc,nlev,cc1,rhs1)

   do ci=1,nlev
      do i=1,numc
         cc(i,ci)=cc(i,ci)+dt*0.5*(rhs(i,ci)+rhs1(i,ci))
      end do
   end do

   return
   end subroutine runge_kutta_2
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Fourth-order Runge-Kutta scheme
!
! !INTERFACE:
   subroutine runge_kutta_4(dt,numc,nlev,cc,right_hand_side)
!
! !DESCRIPTION:
! Here, the fourth-order Runge-Kutta (RK4) scheme is coded,
! with four evaluations
! of the right hand sides per time step:
! \begin{equation}\label{eq2}
! \left.
! \begin{array}{rcl}
! c_i^{(1)} &=&
! \displaystyle
! c_i^n+\Delta t \left\{P_i\left(\underline c^n\right)
! -D_i\left(\underline c^n\right)\right\} \\ \\
! c_i^{(2)} &=&
! \displaystyle
! c_i^n+\Delta t \left\{P_i\left(\frac12\left(\underline c^n+\underline
! c^{(1)}\right)\right)-D_i\left(\frac12\left(\underline c^n+\underline
! c^{(1)}\right)\right)\right\} \\ \\
! c_i^{(3)} &=&
! \displaystyle
! c_i^n+\Delta t \left\{P_i\left(\frac12\left(\underline c^n+\underline
! c^{(2)}\right)\right)-D_i\left(\frac12\left(\underline c^n+\underline
! c^{(2)}\right)\right)\right\} \\ \\
! c_i^{(4)} &=&
! \displaystyle
! c_i^n+\Delta t \left\{P_i\left(\underline c^{(3)}\right)-D_i\left(\underline
! c^{(3)}\right)\right\} \\ \\
! c_i^{n+1} &=&
! \displaystyle
!  \frac16 \left\{c_i^{(1)}+2c_i^{(2)}+2c_i^{(3)}+c_i^{(4)}   \right\}.
! \end{array}
! \right\}
! \end{equation}
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)                :: dt
   integer, intent(in)                 :: numc,nlev
!
! !INPUT/OUTPUT PARAMETER:
   REALTYPE, intent(inout)             :: cc(1:numc,0:nlev)

   interface
      subroutine right_hand_side(first,numc,nlev,cc,rhs)
         logical, intent(in)                  :: first
         integer, intent(in)                  :: numc,nlev
         REALTYPE, intent(in)                 :: cc(1:numc,0:nlev)
         REALTYPE, intent(out)                :: rhs(1:numc,0:nlev)
      end
   end interface
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard, Karsten Bolding
!
! !LOCAL VARIABLES:
  logical  :: first
  REALTYPE :: rhs(1:numc,0:nlev),rhs1(1:numc,0:nlev)
  REALTYPE :: rhs2(1:numc,0:nlev),rhs3(1:numc,0:nlev)
  REALTYPE :: cc1(1:numc,0:nlev)
  integer  :: i,ci
!EOP
!-----------------------------------------------------------------------
!BOC
   first=.true.
   call right_hand_side(first,numc,nlev,cc,rhs)
   first=.false.

   do ci=1,nlev
      do i=1,numc
         cc1(i,ci)=cc(i,ci)+dt*rhs(i,ci)
      end do
   end do

   call right_hand_side(first,numc,nlev,cc1,rhs1)

   do ci=1,nlev
      do i=1,numc
         cc1(i,ci)=cc(i,ci)+dt*rhs1(i,ci)
      end do
   end do

   call right_hand_side(first,numc,nlev,cc1,rhs2)

   do ci=1,nlev
      do i=1,numc
         cc1(i,ci)=cc(i,ci)+dt*rhs2(i,ci)
      end do
   end do

   call right_hand_side(first,numc,nlev,cc1,rhs3)

   do ci=1,nlev
      do i=1,numc
         cc(i,ci)=cc(i,ci)+dt*1./3.*(0.5*rhs(i,ci)+rhs1(i,ci)+rhs2(i,ci)+0.5*rhs3(i,ci))
      end do
   end do

   return
   end subroutine runge_kutta_4
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: First-order Patankar scheme
!
! !INTERFACE:
   subroutine patankar(dt,numc,nlev,cc,right_hand_side)
!
! !DESCRIPTION:
! Here, the first-order Patankar-Euler scheme (PE1) scheme is coded,
! with one evaluation of the right hand sides per time step:
! \begin{equation}\label{eq:am:patankar}
! \begin{array}{rcl}
!   c_i^{n+1} &=&
! \displaystyle
!  c_i^n  + \Delta t \left\{P_i\left(\underline{c}^n\right)
!                                       - D_i\left(\underline{c}^n\right)
!                                         \frac{c_i^{n+1}}{c_i^n} \right\}.
! \end{array}
! \end{equation}
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)                :: dt
   integer, intent(in)                 :: numc,nlev
!
! !INPUT/OUTPUT PARAMETER:
   REALTYPE, intent(inout)             :: cc(1:numc,0:nlev)

   interface
      subroutine right_hand_side(first,numc,nlev,cc,pp,dd)
         logical, intent(in)                  :: first
         integer, intent(in)                  :: numc,nlev
         REALTYPE, intent(in)                 :: cc(1:numc,0:nlev)
         REALTYPE, intent(out)                :: pp(1:numc,1:numc,0:nlev)
         REALTYPE, intent(out)                :: dd(1:numc,1:numc,0:nlev)
      end subroutine right_hand_side
   end interface
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard, Karsten Bolding
!
! !LOCAL VARIABLES:
  logical  :: first
  REALTYPE :: ppsum,ddsum
  REALTYPE :: pp(1:numc,1:numc,0:nlev),dd(1:numc,1:numc,0:nlev)
  integer  :: i,j,ci
!EOP
!-----------------------------------------------------------------------
!BOC
!  absolutely essential since not all elements are calculated
   pp=_ZERO_
   dd=_ZERO_

   first=.true.
   call right_hand_side(first,numc,nlev,cc,pp,dd)
   first=.false.

   do ci=1,nlev
      do i=1,numc
         ppsum=_ZERO_
         ddsum=_ZERO_
         do j=1,numc
            ppsum=ppsum+pp(i,j,ci)
            ddsum=ddsum+dd(i,j,ci)
         end do
         cc(i,ci)=(cc(i,ci)+dt*ppsum)/(1.+dt*ddsum/cc(i,ci))
      end do
   end do

   return
   end subroutine patankar
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Second-order Patankar-Runge-Kutta scheme
!
! !INTERFACE:
   subroutine patankar_runge_kutta_2(dt,numc,nlev,cc,right_hand_side)
!
! !DESCRIPTION:
! Here, the second-order Patankar-Runge-Kutta (PRK2) scheme is coded,
! with two evaluations of the right hand sides per time step:
!
! \begin{equation}\label{eq:am:PRK}
!   \left.
!   \begin{array}{rcl}
!     c_i^{(1)} &=&
! \displaystyle
!  c_i^n  + \Delta t
!                   \left\{P_i\left(\underline{c}^n\right)
!                       - D_i\left(\underline{c}^n\right)
!                         \dfrac{c_i^{(1)}}{c_i^n}\right\},
!                   \\ \\
!     c_i^{n+1} &=&
! \displaystyle
!  c_i^n  + \dfrac{\Delta t}{2}
!                   \left\{P_i\left(\underline{c}^n\right)
!                         + P_i\left(\underline{c}^{(1)}\right)
!                         - \left( D_i\left(\underline{c}^n\right)
!                         + D_i\left(\underline{c}^{(1)}\right)\right)
!                         \dfrac{c_i^{n+1}}{c_i^{(1)}}
!                   \right\}.
!   \end{array}
!   \right\}
! \end{equation}
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)                :: dt
   integer, intent(in)                 :: numc,nlev
!
! !INPUT/OUTPUT PARAMETER:
   REALTYPE, intent(inout)             :: cc(1:numc,0:nlev)

   interface
      subroutine right_hand_side(first,numc,nlev,cc,pp,dd)
         logical, intent(in)                  :: first
         integer, intent(in)                  :: numc,nlev
         REALTYPE, intent(in)                 :: cc(1:numc,0:nlev)
         REALTYPE, intent(out)                :: pp(1:numc,1:numc,0:nlev)
         REALTYPE, intent(out)                :: dd(1:numc,1:numc,0:nlev)
      end subroutine right_hand_side
   end interface
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard, Karsten Bolding
!
! !LOCAL VARIABLES:
  logical  :: first
  REALTYPE :: ppsum(1:numc,0:nlev),ddsum(1:numc,0:nlev)
  REALTYPE :: pp(1:numc,1:numc,0:nlev),dd(1:numc,1:numc,0:nlev)
  REALTYPE :: cc1(1:numc,0:nlev)
  integer  :: i,j,ci
!EOP
!-----------------------------------------------------------------------
!BOC
!  absolutely essential since not all elements are calculated
   pp=_ZERO_
   dd=_ZERO_

   first=.true.
   call right_hand_side(first,numc,nlev,cc,pp,dd)
   first=.false.

   do ci=1,nlev
      do i=1,numc
         ppsum(i,ci)=_ZERO_
         ddsum(i,ci)=_ZERO_
         do j=1,numc
            ppsum(i,ci)=ppsum(i,ci)+pp(i,j,ci)
            ddsum(i,ci)=ddsum(i,ci)+dd(i,j,ci)
         end do
         cc1(i,ci)=(cc(i,ci)+dt*ppsum(i,ci))/(1.+dt*ddsum(i,ci)/cc(i,ci))
      end do
   end do

   call right_hand_side(first,numc,nlev,cc1,pp,dd)

   do ci=1,nlev
      do i=1,numc
         do j=1,numc
            ppsum(i,ci)=ppsum(i,ci)+pp(i,j,ci)
            ddsum(i,ci)=ddsum(i,ci)+dd(i,j,ci)
         end do
         cc(i,ci)=(cc(i,ci)+0.5*dt*ppsum(i,ci))/(1.+0.5*dt*ddsum(i,ci)/cc1(i,ci))
      end do
   end do

   return
   end subroutine patankar_runge_kutta_2
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Fourth-order Patankar-Runge-Kutta scheme
!
! !INTERFACE:
   subroutine patankar_runge_kutta_4(dt,numc,nlev,cc,right_hand_side)
!
! !DESCRIPTION:
! This subroutine should become the fourth-order Patankar Runge-Kutta
! scheme, but it does not yet work.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)                :: dt
   integer, intent(in)                 :: numc,nlev
!
! !INPUT/OUTPUT PARAMETER:
   REALTYPE, intent(inout)             :: cc(1:numc,0:nlev)

   interface
      subroutine right_hand_side(first,numc,nlev,cc,pp,dd)
         logical, intent(in)                  :: first
         integer, intent(in)                  :: numc,nlev
         REALTYPE, intent(in)                 :: cc(1:numc,0:nlev)
         REALTYPE, intent(out)                :: pp(1:numc,1:numc,0:nlev)
         REALTYPE, intent(out)                :: dd(1:numc,1:numc,0:nlev)
      end subroutine right_hand_side
   end interface
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard, Karsten Bolding
!
! !LOCAL VARIABLES:
  logical  :: first
  REALTYPE :: ppsum(1:numc,0:nlev),ddsum(1:numc,0:nlev)
  REALTYPE :: ppsum1(1:numc,0:nlev),ddsum1(1:numc,0:nlev)
  REALTYPE :: ppsum2(1:numc,0:nlev),ddsum2(1:numc,0:nlev)
  REALTYPE :: ppsum3(1:numc,0:nlev),ddsum3(1:numc,0:nlev)
  REALTYPE :: pp(1:numc,1:numc,0:nlev),dd(1:numc,1:numc,0:nlev)
  REALTYPE :: cc1(1:numc,0:nlev)
  integer  :: i,j,ci
!EOP
!-----------------------------------------------------------------------
!BOC
!  absolutely essential since not all elements are calculated
   pp=_ZERO_
   dd=_ZERO_

   first=.true.
   call right_hand_side(first,numc,nlev,cc,pp,dd)
   first=.false.

   do ci=1,nlev
      do i=1,numc
         ppsum(i,ci)=_ZERO_
         ddsum(i,ci)=_ZERO_
         do j=1,numc
            ppsum(i,ci)=ppsum(i,ci)+pp(i,j,ci)
            ddsum(i,ci)=ddsum(i,ci)+dd(i,j,ci)
         end do
         cc1(i,ci)=(cc(i,ci)+dt*ppsum(i,ci))/(1.+dt*ddsum(i,ci)/cc(i,ci))
      end do
   end do

   call right_hand_side(first,numc,nlev,cc1,pp,dd)

   do ci=1,nlev
      do i=1,numc
         ppsum1(i,ci)=_ZERO_
         ddsum1(i,ci)=_ZERO_
         do j=1,numc
            ppsum1(i,ci)=ppsum1(i,ci)+pp(i,j,ci)
            ddsum1(i,ci)=ddsum1(i,ci)+dd(i,j,ci)
         end do
         cc1(i,ci)=(cc(i,ci)+dt*ppsum1(i,ci))/(1.+dt*ddsum1(i,ci)/cc1(i,ci))
      end do
   end do

   call right_hand_side(first,numc,nlev,cc1,pp,dd)

   do ci=1,nlev
      do i=1,numc
         ppsum2(i,ci)=_ZERO_
         ddsum2(i,ci)=_ZERO_
         do j=1,numc
            ppsum2(i,ci)=ppsum2(i,ci)+pp(i,j,ci)
            ddsum2(i,ci)=ddsum2(i,ci)+dd(i,j,ci)
         end do
         cc1(i,ci)=(cc(i,ci)+dt*ppsum2(i,ci))/(1.+dt*ddsum2(i,ci)/cc1(i,ci))
      end do
   end do

   call right_hand_side(first,numc,nlev,cc1,pp,dd)

   do ci=1,nlev
      do i=1,numc
         ppsum3(i,ci)=_ZERO_
         ddsum3(i,ci)=_ZERO_
         do j=1,numc
            ppsum3(i,ci)=ppsum3(i,ci)+pp(i,j,ci)
            ddsum3(i,ci)=ddsum3(i,ci)+dd(i,j,ci)
         end do
         ppsum(i,ci)=1./3.*(0.5*ppsum(i,ci)+ppsum1(i,ci)+ppsum2(i,ci)+0.5*ppsum3(i,ci))
         ddsum(i,ci)=1./3.*(0.5*ddsum(i,ci)+ddsum1(i,ci)+ddsum2(i,ci)+0.5*ddsum3(i,ci))
         cc(i,ci)=(cc(i,ci)+dt*ppsum(i,ci))/(1.+dt*ddsum(i,ci)/cc1(i,ci))
      end do
   end do

   return
   end subroutine patankar_runge_kutta_4
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: First-order Modified Patankar scheme
!
! !INTERFACE:
   subroutine modified_patankar(dt,numc,nlev,cc,right_hand_side)
!
! !DESCRIPTION:
! Here, the first-order Modified Patankar-Euler scheme (MPE1) scheme is coded,
! with one evaluation of the right hand side per time step:
! \begin{equation}\label{eq:am:MP}
! \begin{array}{rcl}
!   c_i^{n+1} &=&
! \displaystyle
!  c_i^n
!               + \Delta t \left\{ \sum\limits_{\stackrel{j=1}{j \not= i}}^I
!                p_{i,j}\left(\underline{c}^n\right) \dfrac{c_j^{n+1}}{c_j^n}
!                                         + p_{i,i}\left(\underline{c}^n\right)
!                           - \sum_{j=1}^I d_{i,j}\left(\underline{c}^n\right)
!                                         \dfrac{c_i^{n+1}}{c_i^n} \right\}.
! \end{array}
! \end{equation}
!
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)                :: dt
   integer, intent(in)                 :: numc,nlev
!
! !INPUT/OUTPUT PARAMETER:
   REALTYPE, intent(inout)             :: cc(1:numc,0:nlev)

   interface
      subroutine right_hand_side(first,numc,nlev,cc,pp,dd)
         logical, intent(in)                  :: first
         integer, intent(in)                  :: numc,nlev
         REALTYPE, intent(in)                 :: cc(1:numc,0:nlev)
         REALTYPE, intent(out)                :: pp(1:numc,1:numc,0:nlev)
         REALTYPE, intent(out)                :: dd(1:numc,1:numc,0:nlev)
      end subroutine right_hand_side
   end interface
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard, Karsten Bolding
!
! !LOCAL VARIABLES:
  logical  :: first
  REALTYPE :: pp(1:numc,1:numc,0:nlev),dd(1:numc,1:numc,0:nlev)
  REALTYPE :: a(1:numc,1:numc),r(1:numc)
  integer  :: i,j,ci
!EOP
!-----------------------------------------------------------------------
!BOC
!  absolutely essential since not all elements are calculated
   pp=_ZERO_
   dd=_ZERO_

   first=.true.
   call right_hand_side(first,numc,nlev,cc,pp,dd)
   first=.false.

   do ci=1,nlev
      do i=1,numc
         a(i,i)=_ZERO_
         do j=1,numc
            a(i,i)=a(i,i)+dd(i,j,ci)
            if (i.ne.j) a(i,j)=-dt*pp(i,j,ci)/cc(j,ci)
         end do
         a(i,i)=dt*a(i,i)/cc(i,ci)
         a(i,i)=1.+a(i,i)
         r(i)=cc(i,ci)+dt*pp(i,i,ci)
      end do
      call matrix(numc,a,r,cc(:,ci))
   end do

   return
   end subroutine modified_patankar
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Second-order Modified Patankar-Runge-Kutta scheme
!
! !INTERFACE:
   subroutine modified_patankar_2(dt,numc,nlev,cc,right_hand_side)
!
! !DESCRIPTION:
! Here, the second-order Modified Patankar-Runge-Kutta (MPRK2) scheme is coded,
! with two evaluations of the right hand sides per time step:
!
! \begin{equation}\label{eq:am:MPRK}
!   \left. \begin{array}{rcl}
!     c_i^{(1)} &=&
! \displaystyle
! c_i^n  + \Delta t
! \left\{
! \sum\limits_{\stackrel{j=1}{j \not= i}}^I p_{i,j}\left(\underline{c}^n\right)
! \dfrac{c_j^{(1)}}{c_j^n}
! + p_{i,i}\left(\underline{c}^n\right)
! - \sum_{j=1}^I d_{i,j}\left(\underline{c}^n\right)
! \dfrac{c_i^{(1)}}{c_i^n}
! \right\},
! \\ \\
! c_i^{n+1} &=&
! \displaystyle
! c_i^n  + \dfrac{\Delta t}{2}
!                   \left\{
!                     \sum\limits_{\stackrel{j=1}{j \not= i}}^I
!                       \left(p_{i,j}\left(\underline{c}^n\right)
!                           + p_{i,j}\left(\underline{c}^{(1)}\right)
!                       \right) \dfrac{c_j^{n+1}}{c_j^{(1)}}
!                       + p_{i,i}\left(\underline{c}^n\right)
!                       + p_{i,i}\left(\underline{c}^{(1)}\right)
! \right.\\ \\
!               & &
! \displaystyle
! \left.\phantom{c_i^n  + \dfrac{\Delta t}{2} }
!                   - \sum_{j=1}^I
!                       \left(d_{i,j}\left(\underline{c}^n\right)
!                           + d_{i,j}\left(\underline{c}^{(1)}\right)
!                       \right) \dfrac{c_i^{n+1}}{c_i^{(1)}}
!                   \right\}.
!   \end{array}
!   \right\}
! \end{equation}
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)                :: dt
   integer, intent(in)                 :: numc,nlev
!
! !INPUT/OUTPUT PARAMETER:
   REALTYPE, intent(inout)             :: cc(1:numc,0:nlev)

   interface
      subroutine right_hand_side(first,numc,nlev,cc,pp,dd)
         logical, intent(in)                  :: first
         integer, intent(in)                  :: numc,nlev
         REALTYPE, intent(in)                 :: cc(1:numc,0:nlev)
         REALTYPE, intent(out)                :: pp(1:numc,1:numc,0:nlev)
         REALTYPE, intent(out)                :: dd(1:numc,1:numc,0:nlev)
      end subroutine right_hand_side
   end interface
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard, Karsten Bolding
!
! !LOCAL VARIABLES:
  logical  :: first
  REALTYPE :: pp(1:numc,1:numc,0:nlev),dd(1:numc,1:numc,0:nlev)
  REALTYPE :: pp1(1:numc,1:numc,0:nlev),dd1(1:numc,1:numc,0:nlev)
  REALTYPE :: a(1:numc,1:numc),r(1:numc)
  REALTYPE :: cc1(1:numc,0:nlev)
  integer  :: i,j,ci
!EOP
!-----------------------------------------------------------------------
!BOC
!  absolutely essential since not all elements are calculated
   pp=_ZERO_ ; pp1=_ZERO_
   dd=_ZERO_ ; dd1=_ZERO_

   first=.true.
   call right_hand_side(first,numc,nlev,cc,pp,dd)
   first=.false.

   do ci=1,nlev
      do i=1,numc
         a(i,i)=_ZERO_
         do j=1,numc
            a(i,i)=a(i,i)+dd(i,j,ci)
            if (i.ne.j) a(i,j)=-dt*pp(i,j,ci)/cc(j,ci)
         end do
         a(i,i)=dt*a(i,i)/cc(i,ci)
         a(i,i)=1.+a(i,i)
         r(i)=cc(i,ci)+dt*pp(i,i,ci)
      end do
      call matrix(numc,a,r,cc1(:,ci))
   end do

   call right_hand_side(first,numc,nlev,cc1,pp1,dd1)

   pp=0.5*(pp+pp1)
   dd=0.5*(dd+dd1)

   do ci=1,nlev
      do i=1,numc
         a(i,i)=_ZERO_
         do j=1,numc
            a(i,i)=a(i,i)+dd(i,j,ci)
            if (i.ne.j) a(i,j)=-dt*pp(i,j,ci)/cc1(j,ci)
         end do
         a(i,i)=dt*a(i,i)/cc1(i,ci)
         a(i,i)=1.+a(i,i)
         r(i)=cc(i,ci)+dt*pp(i,i,ci)
      end do
      call matrix(numc,a,r,cc(:,ci))
   end do

   return
   end subroutine modified_patankar_2
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Fourth-order Modified Patankar-Runge-Kutta scheme
!
! !INTERFACE:
   subroutine modified_patankar_4(dt,numc,nlev,cc,right_hand_side)
!
! !DESCRIPTION:
! This subroutine should become the fourth-order Modified Patankar Runge-Kutta
! scheme, but it does not yet work.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)                :: dt
   integer, intent(in)                 :: numc,nlev
!
! !INPUT/OUTPUT PARAMETER:
   REALTYPE, intent(inout)             :: cc(1:numc,0:nlev)

   interface
      subroutine right_hand_side(first,numc,nlev,cc,pp,dd)
         logical, intent(in)                  :: first
         integer, intent(in)                  :: numc,nlev
         REALTYPE, intent(in)                 :: cc(1:numc,0:nlev)
         REALTYPE, intent(out)                :: pp(1:numc,1:numc,0:nlev)
         REALTYPE, intent(out)                :: dd(1:numc,1:numc,0:nlev)
      end subroutine right_hand_side
   end interface
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard, Karsten Bolding
!
! !LOCAL VARIABLES:
  logical  :: first
  REALTYPE :: pp(1:numc,1:numc,0:nlev),dd(1:numc,1:numc,0:nlev)
  REALTYPE :: pp1(1:numc,1:numc,0:nlev),dd1(1:numc,1:numc,0:nlev)
  REALTYPE :: pp2(1:numc,1:numc,0:nlev),dd2(1:numc,1:numc,0:nlev)
  REALTYPE :: pp3(1:numc,1:numc,0:nlev),dd3(1:numc,1:numc,0:nlev)
  REALTYPE :: a(1:numc,1:numc),r(1:numc)
  REALTYPE :: cc1(1:numc,0:nlev)
  integer  :: i,j,ci
!EOP
!-----------------------------------------------------------------------
!BOC
!  absolutely essential since not all elements are calculated
   pp=_ZERO_ ; pp1=_ZERO_ ; pp2=_ZERO_ ; pp3=_ZERO_
   dd=_ZERO_ ; dd1=_ZERO_ ; dd2=_ZERO_ ; dd3=_ZERO_

   first=.true.
   call right_hand_side(first,numc,nlev,cc,pp,dd)
   first=.false.

   do ci=1,nlev
      do i=1,numc
         a(i,i)=_ZERO_
         do j=1,numc
            a(i,i)=a(i,i)+dd(i,j,ci)
            if (i.ne.j) a(i,j)=-dt*pp(i,j,ci)/cc(j,ci)
         end do
         a(i,i)=dt*a(i,i)/cc(i,ci)
         a(i,i)=1.+a(i,i)
         r(i)=cc(i,ci)+dt*pp(i,i,ci)
      end do
      call matrix(numc,a,r,cc1(:,ci))
   end do

   call right_hand_side(first,numc,nlev,cc1,pp1,dd1)

   do ci=1,nlev
      do i=1,numc
         a(i,i)=_ZERO_
         do j=1,numc
            a(i,i)=a(i,i)+dd1(i,j,ci)
            if (i.ne.j) a(i,j)=-dt*pp1(i,j,ci)/cc1(j,ci)
         end do
         a(i,i)=dt*a(i,i)/cc1(i,ci)
         a(i,i)=1.+a(i,i)
         r(i)=cc(i,ci)+dt*pp1(i,i,ci)
      end do
      call matrix(numc,a,r,cc1(:,ci))
   end do

   call right_hand_side(first,numc,nlev,cc1,pp2,dd2)

   do ci=1,nlev
      do i=1,numc
         a(i,i)=_ZERO_
         do j=1,numc
            a(i,i)=a(i,i)+dd2(i,j,ci)
            if (i.ne.j) a(i,j)=-dt*pp2(i,j,ci)/cc1(j,ci)
         end do
         a(i,i)=dt*a(i,i)/cc1(i,ci)
         a(i,i)=1.+a(i,i)
         r(i)=cc(i,ci)+dt*pp2(i,i,ci)
      end do
      call matrix(numc,a,r,cc1(:,ci))
   end do

   call right_hand_side(first,numc,nlev,cc1,pp3,dd3)

   pp=1./3.*(0.5*pp+pp1+pp2+0.5*pp3)
   dd=1./3.*(0.5*dd+dd1+dd2+0.5*dd3)

   do ci=1,nlev
      do i=1,numc
         a(i,i)=_ZERO_
         do j=1,numc
            a(i,i)=a(i,i)+dd(i,j,ci)
            if (i.ne.j) a(i,j)=-dt*pp(i,j,ci)/cc1(j,ci)
         end do
         a(i,i)=dt*a(i,i)/cc1(i,ci)
         a(i,i)=1.+a(i,i)
         r(i)=cc(i,ci)+dt*pp(i,i,ci)
      end do
      call matrix(numc,a,r,cc(:,ci))
   end do

   return
   end subroutine modified_patankar_4
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: First-order Extended Modified Patankar scheme
!
! !INTERFACE:
   subroutine emp_1(dt,numc,nlev,cc,right_hand_side)
!
! !DESCRIPTION:
! Here, the first-order Extended Modified Patankar scheme for
! biogeochemical models is coded, with one evaluation of the right-hand
! side per time step:
!
! \begin{eqnarray}
!    \lefteqn{\vec{c}^{n + 1} = \vec{c}^n + \Delta t \: \vec{f}(t^n,\vec{c}^n)\prod\limits_{j \in J^n} {\frac{c_j^{n + 1} }{c_j^n}}} \nonumber \\
!    & & \mbox{with } J^n = \left\{ {i:f_i (t^n,\vec{c}^n) < 0,i \in \{1,...,I\}} \right\}
! \end{eqnarray}
!
! This system of non-linear implicit equations is solved in auxiliary subroutine
! findp\_bisection, using the fact this system can be reduced to a polynomial in one
! unknown, and additionally using the restrictions imposed by the requirement of positivity.
! For more details, see \cite{Bruggemanetal2005}.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)                :: dt
   integer, intent(in)                 :: numc,nlev
!
! !INPUT/OUTPUT PARAMETER:
   REALTYPE, intent(inout)             :: cc(1:numc,0:nlev)

   interface
      subroutine right_hand_side(first,numc,nlev,cc,rhs)
         logical, intent(in)                  :: first
         integer, intent(in)                  :: numc,nlev
         REALTYPE, intent(in)                 :: cc(1:numc,0:nlev)
         REALTYPE, intent(out)                :: rhs(1:numc,0:nlev)
      end
   end interface
!
! !REVISION HISTORY:
!  Original author(s): Jorn Bruggeman
!
! !LOCAL VARIABLES:
  logical  :: first
  REALTYPE :: derivative(1:numc,0:nlev)
  integer  :: ci
  REALTYPE :: pi
!EOP
!-----------------------------------------------------------------------
!BOC
   first=.true.
   call right_hand_side(first,numc,nlev,cc,derivative)
   first=.false.

   do ci=1,nlev
      call findp_bisection(numc, cc(:,ci), derivative(:,ci), dt, 1.d-9, pi)
      cc(:,ci) = cc(:,ci) + dt*derivative(:,ci)*pi
   end do

   return
   end subroutine emp_1
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Second-order Extended Modified Patankar scheme
!
! !INTERFACE:
   subroutine emp_2(dt,numc,nlev,cc,right_hand_side)
!
! !DESCRIPTION:
! Here, the second-order Extended Modified Patankar scheme for
! biogeochemical models is coded, with two evaluations of the right-hand
! side per time step:
!
! \begin{eqnarray}
!   \vec{c}^{(1)} & = & \vec{c}^n  + \Delta t \: \vec{f}(t^n ,\vec{c}^n )\prod\limits_{j \in J^n } {\frac{{c_j^{(1)} }}{{c_j^n }}} \nonumber \\
!   \vec{c}^{n + 1} & = & \vec{c}^n  + \frac{{\Delta t}}{2}\left( {\vec{f}(t^n ,\vec{c}^n ) + \vec{f}(t^{n + 1} ,\vec{c}^{(1)} )} \right)\prod\limits_{k \in K^n } {\frac{{c_k^{n + 1} }}{{c_k^{(1)} }}}
! \end{eqnarray}
!
! where
!
! \begin{eqnarray}
!   J^n & = & \left\{ {i:f_i (t^n ,\vec{c}^n ) < 0, i \in \{ 1,...,I\} } \right\} \nonumber \\
!   K^n & = & \left\{ {i:f_i (t^n ,\vec{c}^n ) + f_i (t^{n+1} ,\vec{c}^{(1)} ) < 0, i \in \{ 1,...,I\} } \right\}.
! \end{eqnarray}
!
! The first step is identical to a step with the first-order EMP scheme. The second step mathmatically identical to
! a step with the first-order scheme if we rewrite it as
!
! \begin{eqnarray}
!   \lefteqn{\vec{c}^{n + 1} = \vec{c}^n + \Delta t \: \vec{h}(t^n,t^{n + 1},\vec{c}^n,\vec{c}^{(1)})\prod\limits_{k \in
!     K^n} {\frac{c_k^{n + 1} }{c_k^n }}} \nonumber \\
!   & & \mbox{with }\vec{h}(t^n,t^{n + 1},\vec{c}^n,\vec{c}^{(1)}) = \frac{1}{2}\left( {\vec{f}(t^n,\vec{c}^n) + \vec{f}(t^{n + 1},\vec{c}^{(1)})} \right)\prod\limits_{k \in K^n} {\frac{c_k^n }{c_k^{(1)} }}.
! \end{eqnarray}
!
! Therefore, this scheme can be implemented as two consecutive steps with the first-order scheme, the second using
! $\vec{h}(t^n,t^{n + 1},\vec{c}^n,\vec{c}^{(1)})$. The non-linear problem of each consecutive step is solved
! in auxiliary subroutine findp\_bisection.
!
! For more details, see \cite{Bruggemanetal2005}.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)                :: dt
   integer, intent(in)                 :: numc,nlev
!
! !INPUT/OUTPUT PARAMETER:
   REALTYPE, intent(inout)              :: cc(1:numc,0:nlev)

   interface
      subroutine right_hand_side(first,numc,nlev,cc,rhs)
         logical, intent(in)                  :: first
         integer, intent(in)                  :: numc,nlev
         REALTYPE, intent(in)                 :: cc(1:numc,0:nlev)
         REALTYPE, intent(out)                :: rhs(1:numc,0:nlev)
      end
   end interface
!
! !REVISION HISTORY:
!  Original author(s): Jorn Bruggeman
!
! !LOCAL VARIABLES:
  logical  :: first
  integer  :: i,ci
  REALTYPE :: pi, rhs(1:numc,0:nlev), cc_med(1:numc,0:nlev), rhs_med(1:numc,0:nlev)
!EOP
!-----------------------------------------------------------------------
!BOC
   first=.true.
   call right_hand_side(first,numc,nlev,cc,rhs)
   first=.false.

   do ci=1,nlev
      call findp_bisection(numc, cc(:,ci), rhs(:,ci), dt, 1.d-9, pi)
      cc_med(:,ci) = cc(:,ci) + dt*rhs(:,ci)*pi
   end do

   call right_hand_side(first,numc,nlev,cc_med,rhs_med)

   do ci=1,nlev
      rhs(:,ci) = 0.5 * (rhs(:,ci) + rhs_med(:,ci))

      ! Correct for the state variables that will be included in 'p'.
      do i=1,numc
         if (rhs(i,ci) .lt. 0.) rhs(:,ci) = rhs(:,ci) * cc(i,ci)/cc_med(i,ci)
      end do

      call findp_bisection(numc, cc(:,ci), rhs(:,ci), dt, 1.d-9, pi)

      cc(:,ci) = cc(:,ci) + dt*rhs(:,ci)*pi
   end do ! ci (z-levels)

   return
   end subroutine emp_2
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Calculation of the EMP product term 'p'
!
! !INTERFACE:
   subroutine findp_bisection(numc, cc, derivative, dt, accuracy, pi)
!
! !DESCRIPTION:
! Auxiliary subroutine for finding the Extended Modified Patankar
! product term $p$ with the bisection technique.
!
! This subroutine solves the non-linear problem
!
! \begin{eqnarray}
!    \lefteqn{\vec{c}^{n + 1} = \vec{c}^n + \Delta t \: \vec{f}(t^n,\vec{c}^n)\prod\limits_{j \in J^n} {\frac{c_j^{n + 1} }{c_j^n}}} \nonumber \\
!    & & \mbox{with } J^n = \left\{ {i:f_i (t^n,\vec{c}^n) < 0,i \in \{1,...,I\}} \right\}
! \end{eqnarray}
!
! using the fact that it can be reduced to the problem of finding the root of a polynomial
! in one unknown $p: = \prod\limits_{j \in J^n}{{c_j^{n + 1}}/{c_j^n}}$:
!
! \begin{equation}
!   g(p) = \prod\limits_{j \in J^n} {\left( {1 + \frac{\Delta t \: f_j(t^n,\vec{c}^n)}{c_j^n }p} \right)} - p = 0,
! \end{equation}
!
! with
!
! \begin{equation}
!   J^n = \left\{ {i:f_i (t^n,\vec{c}^n) < 0,i \in \{1,...,I\}} \right\},
! \end{equation}
!
! Additionally, it makes use of the the positivity requirement $\vec{c}^{n+1}_i>0\ \forall\ i$, which
! imposes restriction
!
! \begin{equation}
!   p \in \left( 0, \min \left( {1,\mathop {\min }\limits_{j \in J^n} \left( { -
!                   \frac{c_j^n }{\Delta t \: f_j (t^n,\vec{c}^n)}} \right)} \right) \right).
! \end{equation}
!
! It has been proved that there exists exactly one $p$ for which the above is
! true, see \cite{Bruggemanetal2005}.
! The resulting problem is solved using the bisection scheme, which is guaranteed to converge.
!
!
! !USES:
   implicit none
!
! !INPUT PARAMETERS:
   integer, intent(in)   :: numc
   REALTYPE, intent(in)  :: cc(1:numc), derivative(1:numc)
   REALTYPE, intent(in)  :: dt, accuracy
!
! !OUTPUT PARAMETER:
   REALTYPE, intent(out) :: pi
!
! !REVISION HISTORY:
!  Original author(s): Jorn Bruggeman
!
! !LOCAL VARIABLES:
   REALTYPE :: pileft, piright, fnow
   REALTYPE :: relderivative(1:numc)
   integer  :: iter, i, potnegcount
!EOP
!-----------------------------------------------------------------------
!BOC
! Sort the supplied derivatives (find out which are negative).
   potnegcount = 0
   piright = 1.
   do i=1,numc

      if (derivative(i).lt.0.) then
!        State variable could become zero or less; include it in the
!        J set of the EMP scheme.
         if (cc(i).eq.0.) write (*,*) "Error: state variable ",i," is zero and has negative derivative!"
         potnegcount = potnegcount+1
         relderivative(potnegcount) = dt*derivative(i)/cc(i)

!        Derivative is negative, and therefore places an upper bound on pi.
         if (-1./relderivative(potnegcount).lt.piright) piright = -1./relderivative(potnegcount)
     end if

   end do

   if (potnegcount.eq.0) then
!     All derivatives are positive, just do Euler.
      pi = 1.0
      return
   end if

   pileft = 0.      ! polynomial(0) = 1

!  Determine maximum number of bisection iterations from
!  requested accuracy.
!  maxiter = -int(ceiling(dlog10(accuracy)/dlog10(2.D0)))

   do iter=1,20
!     New pi to test is middle of current pi-domain.
      pi = 0.5*(piright+pileft)

!     Calculate polynomial value.
      fnow = 1.
      do i=1,potnegcount
         fnow = fnow*(1.+relderivative(i)*pi)
      end do

      if (fnow>pi) then
!        Polynomial(pi)>0; we have a new left bound for pi.
         pileft = pi
      elseif (fnow<pi) then
!       Polynomial(pi)<0; we have a new right bound for pi.
        piright = pi
      else
!       Freak occurrence: polynomial(pi)=0, we happened to pinpoint
!       the exact pi.
        exit
      end if
!     Check if we now pi accurately enough (accuracy refers to the
!     number of decimals we know).
      if ((piright-pileft)/pi<accuracy) exit
   end do

!  Low pi values imply very large negative relative derivative. This happens
!  for stiff systems (or very high delta_t), and for non-positive systems.
!  Then EMP is not suitable (it will stall state variable values), so warn user.
   if (pi.lt.1.d-4) then
     write (*,*) "Warning: small pi=",pi," in Extended Modified Patankar slows down system!"
!    write (*,*) "relative derivatives: ",derivative(:)*dt/cc(:)
!    write (*,*) "You system may be stiff or non-positive, or you time step is too large."
!    stop "ode_solvers::findp_bisection"
   end if

   return

   end subroutine findp_bisection
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Matrix solver
!
! !INTERFACE:
   subroutine matrix(n,a,r,c)
!
! !DESCRIPTION:
! This is a Gaussian solver for multi-dimensional linear equations.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: n
!
! INPUT/OUTPUT PARAMETERS:
  REALTYPE                             :: a(1:n,1:n),r(1:n)
!
! OUTPUT PARAMETERS:
  REALTYPE, intent(out)                :: c(1:n)
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard, Karsten Bolding
!
! !LOCAL VARIABLES:
  integer  :: i,j,k
!EOP
!-----------------------------------------------------------------------
!BOC
   do i=1,n
      r(i)=r(i)/a(i,i)
      do j=n,i,-1
         a(i,j)=a(i,j)/a(i,i)
      end do
      do k=i+1,n
         r(k)=r(k)-a(k,i)*r(i)
         do j=i+1,n
            a(k,j)=a(k,j)-a(k,i)*a(i,j)
         end do
      end do
   end do

   do i=n,1,-1
      c(i)=r(i)
      do j=i+1,n
         c(i)=c(i)-a(i,j)*c(j)
      end do
   end do

   return
   end subroutine matrix
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module clubb_driver_mod

! --- Imported from FMS modules ---

use       constants_mod, only: RAD_TO_DEG
use             mpp_mod, only: mpp_pe, mpp_root_pe, stdlog, mpp_chksum,        &
                               mpp_clock_id, mpp_clock_begin, mpp_clock_end,   &
                               CLOCK_MODULE_DRIVER
use    diag_manager_mod, only: register_diag_field, send_data
use    time_manager_mod, only: time_type, get_time, set_time, get_date,        &
                               operator(+), operator(-)
use             fms_mod, only: write_version_number, open_file,                &
                               open_namelist_file, check_nml_error,            &
                               file_exist, error_mesg, close_file,             &
                               read_data, write_data,                          &
                               mpp_error, FATAL, NOTE
use   field_manager_mod, only: MODEL_ATMOS
use  tracer_manager_mod, only: get_number_tracers, get_tracer_index,           &
                               get_tracer_names
use   rad_utilities_mod, only: aerosol_type
use     aer_ccn_act_mod, only: aer_ccn_act_init, aer_ccn_act_end
use   aer_ccn_act_k_mod, only: aer_ccn_act_k
use        ice_nucl_mod, only: ice_nucl_wpdf_init, ice_nucl_wpdf_end
implicit none 
public :: clubb_setup, & 
          clubb_init,  & 
          clubb,       & 
          clubb_end

!--------------------- version number ----------------------------------
character(len=128)   :: version = '$Id: CLUBB_driver_SCM.F90,v 1.1.6.2.2.2.2.1 2013/12/17 19:46:01 Niki.Zadeh Exp $'
character(len=128)   :: tagname = '$Name: nullify_rab_nnz $'

contains

! NULL routines return error if called but not compiled for clubb
  subroutine clubb(is, ie, js, je, lon, lat,                  &
                   Time_next,                                 &
                   dtmain,                                    &
                   phalf, pfull, zhalf, zfull, omega_avg,     &
                   t, q, r, u, v,                             &
                   u_star, b_star, q_star,                    &
                   tdt, qdt, rdt, udt, vdt,                   &
                   dcond_ls_liquid, dcond_ls_ice,             &
                   Ndrop_act_clubb, Icedrop_act_clubb,        &
                   ndust, rbar_dust,                          &
                   diff_t_clubb,                              &
                   qcvar_clubb,                               &
                   tdt_shf,  qdt_lhf ,                        &                   
                   Aerosol, mask,                             &
                   mc_full,                                   &
                   conv_frac_clubb,                           &
                   convective_humidity_ratio_clubb)

  integer, intent(in)                           ::  is, ie, js, je
  real, intent(in), dimension(:,:)              ::  lon, lat
  type(time_type), intent(in)                   ::  Time_next
  real, intent(in)                              ::  dtmain
  real, intent(in), dimension(:,:,:)            ::  phalf, pfull, zhalf, zfull, omega_avg
  real, intent(in), dimension(:,:,:)            ::  t, q, u, v
  real, intent(inout), dimension(:,:,:,:)       ::  r
  real, intent(in), dimension(:,:)              ::  u_star, b_star, q_star
  real, intent(inout), dimension(:,:,:)         ::  tdt, qdt, udt, vdt
  real, intent(inout), dimension(:,:,:,:)       ::  rdt
  real, intent(out), dimension(:,:,:)           ::  dcond_ls_liquid
  real, intent(out), dimension(:,:,:)           ::  dcond_ls_ice
  real, intent(out), dimension(:,:,:)           ::  Ndrop_act_clubb
  real, intent(out), dimension(:,:,:)           ::  Icedrop_act_clubb
  real, intent(out), dimension(:,:,:)           ::  ndust, rbar_dust
  real, intent(out), dimension(:,:,:)           ::  diff_t_clubb
  real, intent(out), optional, dimension(:,:,:) ::  qcvar_clubb   
  type(aerosol_type), intent(in), optional      ::  Aerosol
  real, intent(in), optional, dimension(:,:,:)  ::  mask
  real, intent(in), optional, dimension(:,:,:)  ::  mc_full
  real, intent(in), optional, dimension(:,:,:)  ::  conv_frac_clubb
  real, intent(in), optional, dimension(:,:,:)  ::  convective_humidity_ratio_clubb
  real, intent(in), optional, dimension(:,:)    ::  tdt_shf,  qdt_lhf

  call error_mesg ('clubb_driver_mod', 'Not compiled with -DCLUBB', FATAL)

  end subroutine clubb

  !=====================================================================
  !=====================================================================

  subroutine clubb_init(id, jd, kd, lon, lat, axes, Time, phalf )

  integer, intent(in)                  :: id, jd, kd
  real, dimension(:,:), intent(in)     :: lon, lat
  integer, dimension(4), intent(in)    :: axes
  type(time_type), intent(in)          :: Time
  real, dimension(:,:,:), intent(in)   :: phalf
 
  call error_mesg ('clubb_driver_mod', 'Not compiled with -DCLUBB', FATAL)

  end subroutine clubb_init
  !=====================================================================

  !=====================================================================
  subroutine clubb_setup(id, jd, phalf)

  !---------------------------------------------------------------------
  !  id, jd                             input
  !    subdomain dimensions
  !
  !  phalf                              input
  !    pressure at half levels in pascals
  !    [real, dimension(nlon,nlat,nlev+1)]
  !
  !---------------------------------------------------------------------

  ! ----- Calling arguments -----

  integer, intent(in)                 :: id, jd
  real, dimension(:,:,:), intent(in)  ::  phalf

  call error_mesg ('clubb_driver_mod', 'Not compiled with -DCLUBB', FATAL)

  end subroutine clubb_setup
  !=====================================================================

  !=====================================================================
  subroutine clubb_end

  call error_mesg ('clubb_driver_mod', 'Not compiled with -DCLUBB', FATAL)

  end subroutine clubb_end
  !=====================================================================
end module  clubb_driver_mod

module table_printer_mod
implicit none ; private

! TODO: add alignment to the list of arguments
! TODO: make possible to print line numbers

! ---- public interface
public :: table_printer_type
public :: init_with_headers  ! initializes the table with specified headers
public :: add_row
public :: print
public :: dealloc

! ---- module constants   
character(*), parameter :: DEFAULT_FORMAT      = '(g16.9)'
integer     , parameter :: DEFAULT_CELL_WIDTH  = 16
integer     , parameter :: DEFAULT_TABLE_WIDTH = HUGE(1)
integer     , parameter :: N_ROWS_INCREMENT    = 16

! ---- module types
type :: table_printer_type
   private
   integer   :: nr = 0
   integer   :: nc = 0
   character(32), pointer :: table(:,:) => null() ! table cells
end type

! ---- generic procedure interface
interface add_row
   module procedure add_row_real, add_row_integer
   module procedure add_row_logical, add_row_character
end interface add_row

contains 


! ==============================================================================
! deallocats all table data and resets the counters
subroutine dealloc(t)
   type(table_printer_type), intent(inout) :: t
   
   if (associated(t%table))  deallocate(t%table)
   t%table => null() ; t%nr = 0 ; t%nc = 0
end subroutine 


! ==============================================================================
! sets the column headers and resets the table data
subroutine init_with_headers(t,names)
   type(table_printer_type), intent(inout) :: t
   character(*), intent(in) :: names(:)
   
   call dealloc(t)
   t%nc = size(names)
   call realloc_table(t)
   t%table(1:,0) = names(:)
end subroutine 


! ==============================================================================
! increases a number of row storage. Private procedure.
subroutine realloc_table(t)
   type(table_printer_type), intent(inout) :: t

   character(32), pointer :: ptr(:,:)
   integer :: i,j,n

   ! reallocate data
   n = 0 ; if (associated(t%table)) n = ubound(t%table,2)
   if (t%nr >= n) then
      allocate(ptr(0:t%nc,0:t%nr+N_ROWS_INCREMENT))
      forall (i=lbound(ptr,1):ubound(ptr,1), j=lbound(ptr,2):ubound(ptr,2)) ptr(i,j) = ''
      if (associated(t%table)) then
         ptr(:,0:t%nr) = t%table(:,0:t%nr)
         deallocate(t%table)
      endif
      t%table => ptr
   endif
end subroutine


! ==============================================================================
! adds a row of real numbers to the table
subroutine add_row_real(t, name, data, format)
   type(table_printer_type), intent(inout) :: t
   character(*), intent(in) :: name    ! name of the row
   real        , intent(in) :: data(:) ! table data
   character(*), intent(in), optional :: format

   character(32) :: fcell
   integer :: i

   call realloc_table(t)

   fcell = DEFAULT_FORMAT; if (present(format)) fcell=format
   t%nr = t%nr + 1
   t%table(0,t%nr) = name
   do i = 1, min(t%nc,size(data))
      write(t%table(i,t%nr),fcell) data(i)
      t%table(i,t%nr) = adjustl(t%table(i,t%nr))
   enddo
end subroutine add_row_real


! ==============================================================================
! adds a row of integer numbers to the table
subroutine add_row_integer(t, name, data, format)
   type(table_printer_type), intent(inout) :: t
   character(*), intent(in) :: name    ! name of the row
   integer     , intent(in) :: data(:) ! table data
   character(*), intent(in), optional :: format

   character(32) :: fcell
   integer :: i

   call realloc_table(t)

   fcell = DEFAULT_FORMAT; if (present(format)) fcell=format
   t%nr = t%nr + 1
   t%table(0,t%nr) = name
   do i = 1, min(t%nc,size(data))
      write(t%table(i,t%nr),fcell) data(i)
      t%table(i,t%nr) = adjustl(t%table(i,t%nr))
   enddo
end subroutine add_row_integer


! ==============================================================================
! adds a row of logical values to the table
subroutine add_row_logical(t, name, data, format)
   type(table_printer_type), intent(inout) :: t
   character(*), intent(in) :: name    ! name of the row
   logical     , intent(in) :: data(:) ! table data
   character(*), intent(in), optional :: format

   character(32) :: fcell
   integer :: i

   call realloc_table(t)

   fcell = DEFAULT_FORMAT; if (present(format)) fcell=format
   t%nr = t%nr + 1
   t%table(0,t%nr) = name
   do i = 1, min(t%nc,size(data))
      write(t%table(i,t%nr),fcell) data(i)
      t%table(i,t%nr) = adjustl(t%table(i,t%nr))
   enddo
end subroutine add_row_logical


! ==============================================================================
! adds a row of character names
subroutine add_row_character(t, name, data)
   type(table_printer_type), intent(inout) :: t
   character(*), intent(in) :: name    ! name of the row
   character(*), intent(in) :: data(:) ! row data

   integer :: i

   call realloc_table(t)
   t%nr = t%nr + 1
   t%table(0,t%nr) = name
   do i = 1, min(t%nc,size(data))
      t%table(i,t%nr) = adjustl(data(i))
   enddo
end subroutine add_row_character

! =============================================================================
! prints the table
subroutine print(t,unit,max_width,cell_width,head_width,transposed)
   type(table_printer_type), intent(in) :: t
   integer, intent(in), optional :: unit       ! unit number for i/o
   integer, intent(in), optional :: max_width  ! maximum width of the cell
   integer, intent(in), optional :: cell_width ! width of each cell
   integer, intent(in), optional :: head_width ! width of the row header
   logical, intent(in), optional :: transposed ! if true, the table is transposed

   integer :: unit_
   integer :: max_width_, head_width_, cell_width_ 
   logical :: transposed_
   integer :: cells_per_line, k

   unit_ = 6 ; if (present(unit))unit_ = unit
   cell_width_ = DEFAULT_CELL_WIDTH  ; if (present(cell_width)) cell_width_ = cell_width
   head_width_ = cell_width_         ; if (present(head_width)) head_width_ = head_width
   max_width_  = DEFAULT_TABLE_WIDTH ; if (present(max_width))  max_width_  = max_width
   transposed_ = .FALSE. ; if (present(transposed)) transposed_ = transposed

   ! calculate max number of cells per line
   cells_per_line = (max_width_-head_width_)/(cell_width_+1)

   if (transposed_) then
     do k = 1, t%nr, cells_per_line
        call print_table_section(transpose(t%table),&
                k,min(t%nr,k+cells_per_line-1),1,t%nc,&
                unit_,cell_width_,head_width_)
     enddo   
   else
     do k = 1, t%nc, cells_per_line
        call print_table_section(t%table,&
                k,min(t%nc,k+cells_per_line-1),1,t%nr,&
                unit_,cell_width_,head_width_)
     enddo
   endif

end subroutine print

! =============================================================================
subroutine print_table_section(table,is,ie,js,je,unit,cell_width,head_width)
   character(*) :: table(0:,0:)
   integer, intent(in) :: is,ie,js,je ! boundaries of the chunk
   integer, intent(in) :: unit       ! unit number for i/o
   integer, intent(in) :: cell_width ! width of each cell
   integer, intent(in) :: head_width ! width of the row header
   
   integer :: i,j,k
   integer :: cells_per_line
   character(128) :: fhead,fcell,ftop,fmid,fbot! format strings
   character(32) :: l, cell
   character :: toprule,midrule,botrule,fieldsep
   
   ! TODO: make all 4 things below optional arguments
   toprule = '='
   midrule = '-'
   botrule = '='
   fieldsep = ' '
   
   ! create formats for the cells, and for the row headers
   write(l,*)cell_width; fcell = '(a'//trim(adjustl(l))//')'
   write(l,*)head_width; fhead = '(a'//trim(adjustl(l))//')'
   
   ! create formats for table separator
   write(l,*)head_width+(cell_width+1)*(ie-is+1)
   l = adjustl(l)
   ftop = "("//trim(l)//"('"//toprule//"'))"
   fmid = "("//trim(l)//"('"//midrule//"'))"
   fbot = "("//trim(l)//"('"//botrule//"'))"

   ! print table header
   write(unit,ftop) ! top-ruler
   write(unit,fhead,advance='no')''
   do i = is,ie
      write(unit,'(a1)',advance='no') fieldsep
      write(unit,fcell,advance='no') table(i,0)
   enddo
   write(unit,*) ! go to the next line
   write(unit,fmid) ! mid-ruler
   ! print table data
   do j = js,je
      write(unit,fhead,advance='no')table(0,j)
      do i = is,ie
         write(unit,'(a1)',advance='no') fieldsep
         if (trim(table(i,j))=='' ) then
            cell = '----'
         else if (len_trim(table(i,j))>cell_width) then
            cell = repeat('*',cell_width)
         else
            cell = table(i,j)
         endif   
         write(unit,fcell,advance='no') cell
      enddo
      write(unit,*) ! go to the next line
   enddo
   write(unit,fbot) ! bottom-ruler
   
end subroutine print_table_section

end module

! ############################################################################
#if 0
program test
   use table_printer_mod
   
   type(table_printer_type) :: t

   call init_with_headers(t,(/'a','b','c','d','e'/))
   call add_row(t,'test1',(/1.0,2.0,3.0,4.0,5.0/))
   call add_row(t,'test2',(/3.5,4.444444,5.6666666e33,1.0,1.0/),format='(e12.4)')
   call add_row(t,'test3',(/4.444444,5.6666666e33,77777.0,2.0,2.0/))
   call add_row(t,'test I',(/11,12,13,14,15/))
   call add_row(t,'test L',(/.TRUE.,.FALSE.,.TRUE.,.TRUE.,.FALSE./))
   call add_row(t,'test Char',(/'a1','b2','c3','d4','e5'/))
   call print(t)
   write(*,*)
   call print(t,max_width=70)
   write(*,*)
   call print(t,unit=33,max_width=80,head_width=10)
   call print(t,unit=33,max_width=80,head_width=10,transposed=.TRUE.)
   write(*,*)
   call print(t,head_width=10,cell_width=5)
   write(*,*)
   call print(t,cell_width=10)
   write(*,*)
   call print(t,cell_width=10,transposed=.TRUE.)

   call init_with_headers(t,(/' x','y ','z ','xx','yy','zz'/))
   call add_row(t,'test10',(/1.0,2.0,3.0,4.0,5.0,6.0/))
   call add_row(t,'test11',(/1.0,2.0,3.0,4.0,5.0/))
   call print(t,head_width=10)
   call print(t,head_width=10,transposed=.TRUE.)
   call dealloc(t)
   
end program
#endif

!-----------------------------------------------------------------------
! Copyright 2011 NOAA Geophysical Fluid Dynamics Lab, Princeton, NJ
! This program is distributed under the terms of the GNU General Public
! License. See the file COPYING contained in this directory
!-----------------------------------------------------------------------

module pressure_interp_mod

!-----------------------------------------------------------------------

use moisture_convert_mod, only:  sphum_to_rh, rh_to_sphum
use   plev_constants_mod, only:  GRAV, RDGAS, RVGAS

implicit none
private

public pres_interp_type
public wind_interp, pres_interp, pres_interp_init
public pres_interp_free

type pres_interp_type
     integer          :: nx, ny, nz, kx
     integer, pointer :: index(:,:,:)
     real,    pointer :: factr(:,:,:)
     logical, pointer :: mask (:,:,:)
     logical          :: use_extrap
end type pres_interp_type

contains

!#######################################################################

   subroutine wind_interp ( pfull, u, v, pout, kbot, up, vp, mask )

     real, intent(in),  dimension(:,:,:) :: pfull, u, v
     real, intent(in),  dimension(:)     :: pout
  integer, intent(in),  dimension(:,:)   :: kbot
     real, intent(out), dimension(:,:,:) :: up, vp
  logical, intent(out), dimension(:,:,:), optional :: mask

  integer, dimension(size(pfull,1),size(pfull,2)) :: index
     real, dimension(size(pfull,1),size(pfull,2)) :: factr
     real, dimension(size(pfull,1),size(pfull,2),  &
                                   size(pfull,3)) :: log_pfull
     real :: log_pout
  integer :: i, j, k, n, idim, jdim

      idim = size(pfull,1);  jdim = size(pfull,2)

      log_pfull = log(pfull)

!     ----- initialize optional mask -----
!     (true for extrap below bottom level)

      if (present(mask)) mask = .true.

!  ---- loop through output levels ----

   do n = 1, size(pout)

      log_pout = log(pout(n))

!     ---- set up indexing (find full p-level just below pout) -----

      index = kbot

      do j = 1, jdim
      do i = 1, idim
         do k = 2, kbot(i,j)
            if (log_pout <= log_pfull(i,j,k)) then
                index(i,j) = k
                if (present(mask)) mask(i,j,n) = .false.
                exit
            endif
         enddo
      enddo
      enddo

    
!     ---- do interpolation ----
!     ---- (note: wind is held fixed for extrapolation) ----

      do j = 1, jdim
      do i = 1, idim
         k = index(i,j)
         factr(i,j) = (log_pout          -log_pfull(i,j,k)) /   &
                      (log_pfull(i,j,k-1)-log_pfull(i,j,k))
        !factr(i,j) = min(1.,factr(i,j)) ! no extrap above top level
        !factr(i,j) = max(0.,factr(i,j)) ! no extrap below bottom level
         factr(i,j) = min(+1.5,factr(i,j)) ! limit extrap above top level
         factr(i,j) = max(-0.5,factr(i,j)) ! limit extrap below bottom level
         up(i,j,n) = u(i,j,k) + factr(i,j) * (u(i,j,k-1) - u(i,j,k))
         vp(i,j,n) = v(i,j,k) + factr(i,j) * (v(i,j,k-1) - v(i,j,k))
      enddo
      enddo

   enddo

   end subroutine wind_interp

!#######################################################################

   subroutine pres_interp (Control, data, data_out)

      type(pres_interp_type), intent(in)  :: Control
                        real, intent(in)  :: data(:,:,:)
                        real, intent(out) :: data_out(:,:,:)

      integer  i,j,k,kd,ku,n

      do n = 1, Control%nz

         do j = 1, Control%ny
         do i = 1, Control%nx
             k  = Control % index(i,j,n)
             data_out(i,j,n) = data(i,j,k) + Control % factr(i,j,n) *  &
                              (data(i,j,k-1) - data(i,j,k))
         enddo
         enddo

      enddo

   end subroutine pres_interp

!#######################################################################

   function pres_interp_init ( pfull, pout, kbot,               &
                               tin, tout, zin, zout, qin, qout, &
                               use_extrap ) result ( Control )

      real, intent(in), dimension(:,:,:) :: pfull
      real, intent(in), dimension(:)     :: pout
   integer, intent(in), dimension(:,:)   :: kbot
      real, intent(in), dimension(:,:,:), optional :: tin, zin, qin
      real, intent(out),dimension(:,:,:), optional :: tout, zout, qout
   logical, intent(in),                   optional :: use_extrap
      type(pres_interp_type) :: Control

      real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) ::  &
              log_pfull, tvin
      real, dimension(size(pfull,1),size(pfull,2)) :: tphalf
      real, dimension(size(pout,1)) :: log_pout
      real, dimension(size(pfull,1),size(pfull,2),size(pout)) :: tvout

      integer :: i, j, k, idim, jdim, n
      real    :: virtc, rdgrav2

!-----------------------------------------------------------------------

      idim = size(pfull,1);  jdim = size(pfull,2)

      log_pfull = log(pfull)
      log_pout  = log(pout)

!-----------------------------------------------------------------------
!------------------ setup control indexing -----------------------------

      Control % nx = idim
      Control % ny = jdim
      Control % nz = size(pout,1)
      Control % kx = size(pfull,3)

      Control % use_extrap = .true.
      if (present(use_extrap)) Control % use_extrap = use_extrap

      allocate (Control%index (Control%nx,Control%ny,Control%nz))
      allocate (Control%factr (Control%nx,Control%ny,Control%nz))
      allocate (Control%mask  (Control%nx,Control%ny,Control%nz))

      do n = 1, Control%nz

         Control % index(:,:,n) = kbot(:,:)
         Control % mask (:,:,n) = .true.

         do j = 1, jdim
         do i = 1, idim
             do k = 2, kbot(i,j)
                if (log_pout(n) <= log_pfull(i,j,k)) then
                    Control % index (i,j,n) = k
                    Control % mask  (i,j,n) = .false.
                    exit
                endif
             enddo
         enddo
         enddo

         do j = 1, jdim
         do i = 1, idim
             k = Control % index(i,j,n)
             Control % factr(i,j,n) =  &
                               (log_pout(n) - log_pfull(i,j,k)) / &
                        (log_pfull(i,j,k-1) - log_pfull(i,j,k))
            !Control % factr(i,j,n) = min(1.,Control%factr(i,j,n)) ! no extrap above top level
            !Control % factr(i,j,n) = max(0.,Control%factr(i,j,n)) ! no extrap below bottom level
             Control % factr(i,j,n) = min(+1.5,Control%factr(i,j,n)) ! limit extrap above top level
             Control % factr(i,j,n) = max(-0.5,Control%factr(i,j,n)) ! limit extrap below bottom level
         enddo
         enddo 

      enddo 

!-----------------------------------------------------------------------
    !--- temperature ---
      if (present(tin) .and. present(tout)) then
          call pres_interp (Control, tin, tout)
          if (Control%use_extrap) &
              call temp_extrap (Control, tin, log_pout, log_pfull, tout)
      endif
    !--- specific humidity ---
      if (present(qin) .and. present(qout)) then
          call pres_interp (Control, qin, qout)
          if (Control%use_extrap .and. present(tin) .and. present(tout)) &
              call q_extrap (Control, pfull, tin, qin, pout, tout, qout)
      endif

     !--- geopotential height ---
      if (present(zin) .and. present(zout) .and. &
          present(tin) .and. present(tout)) then
         !--- with moisture effects ---
          if (present(qin) .and. present(qout)) then
              virtc = (RVGAS-RDGAS)/RDGAS
              tvin  = tin  * (1.+virtc*qin)
              tvout = tout * (1.+virtc*qout)
          else
              tvin  = tin
              tvout = tout
          endif

          rdgrav2 = 0.5*RDGAS/GRAV
         ! interpolate between levels using hydrostatic equation
          do n = 1, Control%nz
          do j = 1, jdim
          do i = 1, idim
             k = Control % index(i,j,n)
             zout(i,j,n) = (log_pfull(i,j,k)-log_pout(n)) * &
                           (tvout(i,j,n)+tvin(i,j,k))*rdgrav2 + &
                           zin(i,j,k)
          enddo
          enddo
          enddo
      endif

!-----------------------------------------------------------------------

   end function pres_interp_init

!#######################################################################

   subroutine temp_extrap (Control, tin, log_pout, log_pfull, tout)

      type(pres_interp_type), intent(in) :: Control
      real, intent(in)    :: tin(:,:,:), log_pout(:), log_pfull(:,:,:)
      real, intent(inout) :: tout(:,:,:)

      integer :: i,j,k,n
      real :: rlapse, rrlaps, rglp21

      rlapse = 6.5e-3
      rrlaps = 1./rlapse

      do n = 1, Control%nz
      do j = 1, Control%ny
      do i = 1, Control%nx
         if ( Control % mask(i,j,n) ) then
            k = Control % index(i,j,n) - 1
            rglp21 = 0.5*(RDGAS/GRAV) * (log_pout(n)-log_pfull(i,j,k))
            tout(i,j,n) = tin(i,j,k) * (rrlaps+rglp21)/(rrlaps-rglp21)
         endif
      enddo
      enddo
      enddo

   end subroutine temp_extrap

!#######################################################################

   subroutine q_extrap (Control, pfull, tin, qin, pout, tout, qout)

      type(pres_interp_type), intent(in) :: Control
      real, intent(in)   , dimension(:,:,:) :: pfull, tin, qin, tout
      real, intent(in)   , dimension(:)     :: pout
      real, intent(inout), dimension(:,:,:) :: qout

      integer :: i, j, n, kb
      real    :: rh


      do n = 1, Control%nz
      do j = 1, Control%ny
      do i = 1, Control%nx
         if ( Control % mask(i,j,n) ) then
            kb = Control % index(i,j,n) - 1
            rh = sphum_to_rh ( qin(i,j,kb), tin(i,j,kb), pfull(i,j,kb) )
            qout(i,j,n) = rh_to_sphum ( rh, tout(i,j,n), pout(n) )
         endif
      enddo
      enddo
      enddo

   end subroutine q_extrap

!#######################################################################

   subroutine pres_interp_free (Control)
      type(pres_interp_type), intent(inout) :: Control

     deallocate (Control%index, Control%factr, Control%mask)
     Control%nx = 0; Control%ny = 0; Control%nz = 0; Control%kx = 0

   end subroutine pres_interp_free

!#######################################################################

end module pressure_interp_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
! !ROUTINE: Convert between buoyancy fluxes and others \label{sec:convertFluxes}
!
! !INTERFACE:
  subroutine  convert_fluxes(nlev,g,cp,rho_0,heat,p_e,rad,T,S,           &
                            tFlux,sFlux,btFlux,bsFlux,tRad,bRad)
!
! !DESCRIPTION:
!  This subroutine computes the buoyancy fluxes that are due
!  to
!  \begin{enumerate}
!    \item the surface heat flux,
!    \item the surface salinity flux caused by the value of
!          P-E (precipitation-evaporation),
!    \item and the short wave radiative flux.
!  \end{enumerate}
!  Additionally, it outputs the temperature flux ({\tt tFlux})
!  corresponding to the surface heat flux, the salinity flux
!  ({\tt sFlux})  corresponding to the value P-E, and the profile
!  of the temperature flux ({\tt tRad}) corresponding to the profile
!  of the radiative heat flux.
!
! This function is only called when the KPP turbulence model is used.
! When you call the KPP routines from another model outside GOTM, you
! are on your own in computing the  fluxes required by the KPP model, because
! they have to be consistent with the equation of state used in your model.
!
! !USES:
  use eqstate
  IMPLICIT NONE
!
! !INPUT PARAMETERS:
  integer,  intent(in)                :: nlev
  REALTYPE, intent(in)                :: g,cp,rho_0
  REALTYPE, intent(in)                :: heat,p_e
  REALTYPE, intent(in)                :: rad(0:nlev)
  REALTYPE, intent(in)                :: T(0:nlev)
  REALTYPE, intent(in)                :: S(0:nlev)
!
! !OUTPUT PARAMETERS:
  REALTYPE, intent(out)              ::  tFlux,sFlux
  REALTYPE, intent(out)               :: btFlux,bsFlux
  REALTYPE, intent(out)               :: tRad(0:nlev)
  REALTYPE, intent(out)               :: bRad(0:nlev)
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!  $Log: convert_fluxes.F90,v $
!  Revision 20.0  2013/12/14 00:13:58  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:01:18  smg
!  initial cvs ci to mom5
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:33:41  smg
!  updated to gotm-2012.03.09 CVS tagged code.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.2  2005-08-11 12:34:32  lars
!  corrected indentation for Protex
!
!  Revision 1.1  2005/06/27 10:54:33  kbk
!  new files needed
!
!
!EOP
!
! !LOCAL VARIABLES:
   integer                   :: i
   REALTYPE                  :: alpha,beta
!
!-----------------------------------------------------------------------
!BOC

   alpha   = eos_alpha(S(nlev),T(nlev),_ZERO_,g,rho_0)
   beta    = eos_beta (S(nlev),T(nlev),_ZERO_,g,rho_0)


   tFlux   =  heat/(rho_0*cp)
   btFlux  =  g*alpha*tFlux

   sFlux   =  -S(nlev)*p_e
   bsFlux  =  -g*beta*sFlux

   alpha   = eos_alpha(S(1),T(1),_ZERO_,g,rho_0)
   tRad(0) = rad(0)/(rho_0*cp)
   bRad(0) = g*alpha*tRad(0)

   do i=1,nlev
      alpha   = eos_alpha(S(i),T(i),_ZERO_,g,rho_0)
      tRad(i) = rad(i)/(rho_0*cp)
      bRad(i) = g*alpha*tRad(i)
   enddo

   return
   end subroutine convert_fluxes
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module ocean_adv_vel_diag_mod
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Numerical diagnostics for advection velocity related quantities. 
!</OVERVIEW>
!
!<DESCRIPTION>
! Numerical diagnostics for advection velocity related quantities.
! </DESCRIPTION>
!
!<NAMELIST NAME="ocean_adv_vel_diag_nml">
!  <DATA NAME="max_cfl_value" UNITS="dimensionless" TYPE="real">
!  Critical value for Courant number, above which the model will be brought down.
!  </DATA> 
!  <DATA NAME="large_cfl_value" UNITS="dimensionless" TYPE="real">
!  Large value for Courant number, above which will write some diagnostics. 
!  </DATA> 
!  <DATA NAME="verbose_cfl" TYPE="logical">
!  For printing out lots of information about regions of large Courant numbers.
!  </DATA> 
!
!  <DATA NAME="diag_step" UNITS="dimensionless" TYPE="integer">
!  Number of time steps between which compute the diagnostics.
!  </DATA> 
!
!</NAMELIST>
!
use constants_mod,       only: epsln
use diag_manager_mod,    only: register_diag_field, send_data, need_data
use fms_mod,             only: open_namelist_file, check_nml_error, close_file, write_version_number
use fms_mod,             only: FATAL, stdout, stdlog
use mpp_mod,             only: input_nml_file, mpp_error, mpp_max, mpp_pe
use mpp_mod,             only: mpp_clock_id, mpp_clock_begin, mpp_clock_end, CLOCK_ROUTINE
use time_manager_mod,    only: time_type, increment_time

use ocean_domains_mod,    only: get_local_indices
use ocean_operators_mod,  only: BAX, BAY, BDX_ET, BDY_NT, BDX_EU, BDY_NU
use ocean_operators_mod,  only: REMAP_ET_TO_EU, REMAP_NT_TO_NU, REMAP_BT_TO_BU
use ocean_parameters_mod, only: MOM_BGRID, MOM_CGRID
use ocean_parameters_mod, only: missing_value, rho0r 
use ocean_types_mod,      only: ocean_domain_type, ocean_grid_type
use ocean_types_mod,      only: ocean_adv_vel_type, ocean_density_type
use ocean_types_mod,      only: ocean_prog_tracer_type, ocean_thickness_type
use ocean_types_mod,      only: ocean_time_type, ocean_time_steps_type
use ocean_util_mod,       only: matrix, diagnose_2d, diagnose_3d, diagnose_3d_u
use ocean_workspace_mod,  only: wrk1, wrk2, wrk1_2d

implicit none

private

#include <ocean_memory.h>

real :: dtts
real :: dtuv
real :: dtime_t
real :: dtime_u

integer :: index_temp
integer :: diag_step=-1

! for output
integer :: unit=6

! for diagnostics clocks 
integer :: id_adv_vel_numerics
integer :: id_transport_on_s
integer :: id_transport_on_rho
integer :: id_transport_on_nrho
integer :: id_transport_on_theta

! for CFL checks 
real    :: max_cfl_value   = 100.0           
real    :: large_cfl_value = 10.0 
logical :: verbose_cfl     =.false.

! for transport_on_s 
integer :: id_tx_trans       =-1
integer :: id_ty_trans       =-1
integer :: id_tz_trans       =-1
integer :: id_tx_trans_int_z =-1
integer :: id_ty_trans_int_z =-1
integer :: id_tz_trans_int_z =-1
integer :: id_tz_trans_sq    =-1
integer :: id_ux_trans       =-1
integer :: id_uy_trans       =-1
integer :: id_uz_trans       =-1

! for transport_on_rho
integer :: id_tx_trans_rho=-1
integer :: id_ty_trans_rho=-1

! for transport_on_nrho
integer :: id_tx_trans_nrho=-1
integer :: id_ty_trans_nrho=-1

! for transport_on_theta
integer :: id_tx_trans_theta=-1
integer :: id_ty_trans_theta=-1

! for specifying transport units
! can either be Sv or mks
character(len=32) :: transport_dims ='Sv (10^9 kg/s)' 
real              :: transport_convert=1.0e-9 

logical :: used

type(ocean_grid_type), pointer   :: Grd =>NULL()
type(ocean_domain_type), pointer :: Dom =>NULL()

! for Bgrid or Cgrid
integer :: horz_grid

#ifdef MOM_STATIC_ARRAYS
 real, dimension(isd:ied,jsd:jed)  :: tmp 
#else
 real, dimension(:,:), allocatable :: tmp 
#endif

logical :: module_is_initialized = .FALSE.

character(len=128) :: version=&
     '$Id: ocean_adv_vel_diag.F90,v 20.0 2013/12/14 00:12:49 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

public ocean_adv_vel_diag_init
public ocean_adv_vel_diagnostics 

private remapping_check 
private cfl_check1
private cfl_check2
private maximum_bottom_w
private vertical_reynolds_check
public max_continuity_error

private transport_on_s
private transport_on_rho
private transport_on_nrho
private transport_on_theta

namelist /ocean_adv_vel_diag_nml/ max_cfl_value, large_cfl_value, verbose_cfl, diag_step


contains

!#######################################################################
! <SUBROUTINE NAME="ocean_adv_vel_diag_init">
!
! <DESCRIPTION>
! Initialize the ocean_adv_vel_diag module containing subroutines
! diagnosing advection velocity related properties of the simulation.
! </DESCRIPTION>
!
subroutine ocean_adv_vel_diag_init(Grid, Domain, Time, Time_steps, T_prog, Dens, hor_grid, cmip_units)

type(ocean_grid_type),    target, intent(in) :: Grid
type(ocean_domain_type),  target, intent(in) :: Domain
type(ocean_time_type),            intent(in) :: Time
type(ocean_time_steps_type),      intent(in) :: Time_steps
type(ocean_prog_tracer_type),     intent(in) :: T_prog(:)
type(ocean_density_type),         intent(in) :: Dens
integer,                          intent(in) :: hor_grid
logical,                          intent(in) :: cmip_units

integer :: n, ioun, io_status, ierr

integer :: stdoutunit,stdlogunit 
stdoutunit=stdout();stdlogunit=stdlog() 

if (module_is_initialized) return

module_is_initialized = .TRUE.

call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_adv_vel_diag_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_adv_vel_diag_nml')
#else
ioun = open_namelist_file()
read(ioun, ocean_adv_vel_diag_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_adv_vel_diag_nml')
call close_file(ioun)
#endif
write (stdoutunit,'(/)')
write (stdoutunit, ocean_adv_vel_diag_nml)
write (stdlogunit, ocean_adv_vel_diag_nml)

if (diag_step == 0) diag_step = 1

#ifndef MOM_STATIC_ARRAYS
call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
nk = Grid%nk
allocate ( tmp(isd:ied,jsd:jed) )
#endif

tmp = 0.0
Dom => Domain
Grd => Grid

dtuv    = Time_steps%dtuv
dtts    = Time_steps%dtts
dtime_t = Time_steps%dtime_t
dtime_u = Time_steps%dtime_u
horz_grid = hor_grid

! set index for potential temperature 
do n=1,size(T_prog,1)
  if(T_prog(n)%name == 'temp' ) then 
    index_temp = n
  endif 
enddo 

! for units placed on diagnosed transport 
if(cmip_units) then
  transport_convert=1.0
  transport_dims   = 'kg/s'
else
  transport_convert=1.0e-9 
  transport_dims   = 'Sv (10^9 kg/s)'
endif 



! register fields for diagnostic output

id_tx_trans = register_diag_field ('ocean_model','tx_trans', Grd%tracer_axes_flux_x(1:3),&
              Time%model_time, 'T-cell i-mass transport',trim(transport_dims),           &
              missing_value=missing_value, range=(/-1e20,1e20/),                         &
              standard_name='ocean_mass_x_transport')
id_ty_trans = register_diag_field ('ocean_model','ty_trans', Grd%tracer_axes_flux_y(1:3), &
              Time%model_time, 'T-cell j-mass transport',trim(transport_dims),            &
              missing_value=missing_value, range=(/-1e20,1e20/),                          &
              standard_name='ocean_mass_y_transport')
id_tx_trans_int_z = register_diag_field ('ocean_model','tx_trans_int_z',        &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                     &
              'T-cell i-mass transport vertically summed',trim(transport_dims), &
              missing_value=missing_value, range=(/-1e20,1e20/))
id_ty_trans_int_z = register_diag_field ('ocean_model','ty_trans_int_z',        &
              Grd%tracer_axes_flux_y(1:2), Time%model_time,                     &
              'T-cell j-mass transport vertically summed',trim(transport_dims), &
              missing_value=missing_value, range=(/-1e20,1e20/))

id_tz_trans = register_diag_field ('ocean_model','tz_trans', Grd%tracer_axes_wt(1:3), &
              Time%model_time, 'T-cell k-mass transport',trim(transport_dims),        &
              missing_value=missing_value, range=(/-1e20,1e20/),                      &
              standard_name='upward_ocean_mass_transport')
id_tz_trans_int_z = register_diag_field ('ocean_model','tz_trans_int_z',        &
              Grd%tracer_axes_wt(1:2), Time%model_time,                         &
              'T-cell k-mass transport vertically summed',trim(transport_dims), &
              missing_value=missing_value, range=(/-1e20,1e20/))
id_tz_trans_sq = register_diag_field ('ocean_model','tz_trans_sq', Grd%tracer_axes_wt(1:3),&
              Time%model_time, 'Square of T-cell k-mass transport (positive upwards)'      &
              ,trim(transport_dims)//'^2',                                                 &
              missing_value=missing_value, range=(/-1e20,1e20/),                           &
              standard_name='square_of_upward_ocean_mass_transport')

id_ux_trans = register_diag_field ('ocean_model','ux_trans', Grd%vel_axes_flux_x(1:3), &
              Time%model_time, 'U-cell i-mass transport',trim(transport_dims),         &
              missing_value=missing_value, range=(/-1e20,1e20/))
id_uy_trans = register_diag_field ('ocean_model','uy_trans', Grd%vel_axes_flux_y(1:3), &
              Time%model_time, 'U-cell j-mass transport',trim(transport_dims),         &
              missing_value=missing_value, range=(/-1e20,1e20/))
id_uz_trans = register_diag_field ('ocean_model','uz_trans', Grd%vel_axes_wu(1:3), &
              Time%model_time, 'U-cell k-mass transport',trim(transport_dims),     &
              missing_value=missing_value, range=(/-1e20,1e20/))

id_tx_trans_rho = register_diag_field ('ocean_model','tx_trans_rho', Dens%potrho_axes_flux_x(1:3),&
                  Time%model_time, 'T-cell i-mass transport on pot_rho',trim(transport_dims),     &
                  missing_value=missing_value, range=(/-1e20,1e20/))
id_ty_trans_rho = register_diag_field ('ocean_model','ty_trans_rho', Dens%potrho_axes_flux_y(1:3),&
                  Time%model_time, 'T-cell j-mass transport on pot_rho',trim(transport_dims),     &
                  missing_value=missing_value, range=(/-1e20,1e20/))

id_tx_trans_nrho = register_diag_field ('ocean_model','tx_trans_nrho', Dens%neutralrho_axes_flux_x(1:3),&
                   Time%model_time, 'T-cell i-mass transport on neutral rho',trim(transport_dims),      &
                   missing_value=missing_value, range=(/-1e20,1e20/))
id_ty_trans_nrho = register_diag_field ('ocean_model','ty_trans_nrho', Dens%neutralrho_axes_flux_y(1:3),&
                   Time%model_time, 'T-cell j-mass transport on neutral rho',trim(transport_dims),      &
                   missing_value=missing_value, range=(/-1e20,1e20/))

id_tx_trans_theta = register_diag_field ('ocean_model','tx_trans_theta', Dens%theta_axes_flux_x(1:3),&
                    Time%model_time, 'T-cell i-mass transport on theta',trim(transport_dims),        &
                    missing_value=missing_value, range=(/-1e20,1e20/))
id_ty_trans_theta = register_diag_field ('ocean_model','ty_trans_theta', Dens%theta_axes_flux_y(1:3),&
                    Time%model_time, 'T-cell j-mass transport on theta',trim(transport_dims),        &
                    missing_value=missing_value, range=(/-1e20,1e20/))

! set ids for clocks
id_adv_vel_numerics   = mpp_clock_id('(Ocean adv_vel_diag: numerics)'    ,grain=CLOCK_ROUTINE)
id_transport_on_s     = mpp_clock_id('(Ocean adv_vel_diag: s-trans)'     ,grain=CLOCK_ROUTINE)
id_transport_on_rho   = mpp_clock_id('(Ocean adv_vel_diag: rho-trans)'   ,grain=CLOCK_ROUTINE)
id_transport_on_nrho  = mpp_clock_id('(Ocean adv_vel_diag: nrho-trans)'  ,grain=CLOCK_ROUTINE)
id_transport_on_theta = mpp_clock_id('(Ocean adv_vel_diag: theta-trans)' ,grain=CLOCK_ROUTINE)

if(horz_grid == MOM_BGRID) then
  call remapping_check
endif

end subroutine ocean_adv_vel_diag_init
! </SUBROUTINE>  NAME="ocean_adv_vel_diag_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_adv_vel_diagnostics">
!
! <DESCRIPTION>
! Call diagnostics related to the velocity. 
! </DESCRIPTION>

subroutine ocean_adv_vel_diagnostics(Time, Thickness, Adv_vel, T_prog, Dens, visc_cbt)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_adv_vel_type),     intent(in) :: Adv_vel
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  type(ocean_density_type),     intent(in) :: Dens
  real, dimension(isd:,jsd:,:), intent(in) :: visc_cbt
  
  call mpp_clock_begin(id_adv_vel_numerics)
  if (diag_step > 0) then
      if (mod(Time%itt,diag_step) == 0) then
          call cfl_check1(Time, Thickness, Adv_vel)
          call cfl_check2(Time, Thickness, Adv_vel)
          call maximum_bottom_w(Adv_vel)
          call max_continuity_error(Adv_vel, Thickness)
          call vertical_reynolds_check(Adv_vel, Thickness, visc_cbt)
      endif
  endif
  call mpp_clock_end(id_adv_vel_numerics)
  
  call mpp_clock_begin(id_transport_on_s)
    call transport_on_s(Time, Adv_vel)
  call mpp_clock_end(id_transport_on_s)

  call mpp_clock_begin(id_transport_on_rho)
    call transport_on_rho(Time, Dens, Adv_vel)
  call mpp_clock_end(id_transport_on_rho)
  
  call mpp_clock_begin(id_transport_on_nrho)
    call transport_on_nrho(Time, Dens, Adv_vel)
  call mpp_clock_end(id_transport_on_nrho)
  
  call mpp_clock_begin(id_transport_on_theta)
    call transport_on_theta(Time, Dens, T_prog(index_temp), Adv_vel)
  call mpp_clock_end(id_transport_on_theta)


end subroutine ocean_adv_vel_diagnostics
! </SUBROUTINE>  NAME="ocean_adv_vel_diagnostics"



!#######################################################################
! <SUBROUTINE NAME="remapping_check">
!
! <DESCRIPTION>
! Compute remapping error for mapping from T to U cell fields.
!
! This error is only relevant for Bgrid calculations, where
! we need to remap some of the T-grid transports to U-grid.
! The C-grid does not have such remapping operations.
!
! The remapping error will be roundoff only for model
! grids where the tracer and velocity grid cell distances are 
! linearly related.  The spherical version of MOM satisfies the
! appropriate relation, and so should maintain roundoff for the 
! remapping error.  The tripolar version of MOM does not have 
! tracer and velocity grids related linearly, and so the 
! "remapping error" is nontrivial.  The significance of this error
! is unclear.  No adverse effects have been identified.
! </DESCRIPTION>
!
subroutine remapping_check

  real, dimension(isd:ied,jsd:jed) :: uet, vnt, ueu, vnu, u, v, dw, err
  integer                          :: i, j, ierr, jerr
  real                             :: remap_err, remap_err0, fudge

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_adv_vel_diag_mod (remapping_check) : module needs initialization ')
  endif 

  u(:,:)   = 1.0*Grd%umask(:,:,1)
  v(:,:)   = 1.0*Grd%umask(:,:,1)
  uet(:,:) = BAY(u(:,:)*Grd%dyu(:,:))/Grd%dyte(:,:)
  vnt(:,:) = BAX(v(:,:)*Grd%dxu(:,:))/Grd%dxtn(:,:)
  dw(:,:)  = REMAP_BT_TO_BU(BDX_ET(uet(:,:)) + BDY_NT(vnt(:,:)))
  
  ueu(:,:) = REMAP_ET_TO_EU(uet(:,:))  
  vnu(:,:) = REMAP_NT_TO_NU(vnt(:,:))
  err(:,:) = abs(dw(:,:)-(BDX_EU(ueu(:,:))   + BDY_NU(vnu(:,:))))

  ! used to distinguish processors when result is independent of processor
  fudge = 1 + 1.e-12*mpp_pe() 

  remap_err=0.0; ierr=isc; jerr=jsc
  do j=jsc,jec
    do i=isc,iec
      if (abs(err(i,j)) > abs(remap_err)) then 
        remap_err  = err(i,j)
        ierr = i
        jerr = j
      endif
    enddo
  enddo
  remap_err  = remap_err*fudge
  remap_err0 = remap_err
  remap_err  = abs(remap_err)
  call mpp_max(remap_err)

  if (abs(remap_err0) == remap_err) then
    remap_err = remap_err0
    write (unit,9000)  remap_err/fudge, ierr+Dom%ioff, jerr+Dom%joff, Grd%xu(ierr,jerr), Grd%yu(ierr,jerr)
    if(Grd%tripolar) write (unit,'(a)') &
    '==>Note: T-->U remapping error will be small (i.e., order 1e-20) only for spherical grids.'
  endif

9000  format(//'==>Maximum T-->U remapping error = ',es10.3,' m/s  at (i,j) = ','(',i4,',',i4,'),',' (lon,lat) = (',f7.2,',',f7.2,')')

end subroutine remapping_check
! </SUBROUTINE> NAME="remapping_check"


!#######################################################################
! <SUBROUTINE NAME="cfl_check1">
!
! <DESCRIPTION>
! Perform the first of two CFL checks for vertical velocity component. 
!
! Vectorized version from Russell.Fiedler@csiro.au computes cfl
! values at a single latitude. The location of the maximum at this
! latitude is calculated via the maxloc() intrinsic. The maximum 
! value for this processor is then updated if necessary.
! 
! </DESCRIPTION>
subroutine cfl_check1(Time, Thickness, Adv_vel)

  type(ocean_time_type),      intent(in) :: Time
  type(ocean_thickness_type), intent(in) :: Thickness
  type(ocean_adv_vel_type),   intent(in) :: Adv_vel

  real     :: cflwtp                ! percent of cfl criteria reached by vertical velocity component
  real     :: cflwtm                ! vertical velocity component which comes closest to its cfl criteria
  integer  :: icflwt,jcflwt,kcflwt  ! "i","j","k" coordinate of "cflwtm"
  real     :: dtmax
  real     :: cflwtp0
  real     :: fudge
  integer  :: i, j, k, tau

  ! work array containing cfl values 
  real , dimension(isc:iec) :: tempcfl

  ! array required for maxloc() intrinsic function
  integer, dimension(1) :: itemp

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL,&
    '==>Error in ocean_adv_vel_diag_mod (cfl_check1): module needs initialization ')
  endif 

  tau = Time%tau   

  write (stdoutunit,'(/60x,a/)') ' Vertical CFL summary I:  '
  write (stdoutunit,'(1x,a/)')'Location of largest vertical CFL.'

  ! to distinguish processors when tracer is independent of processor
  fudge = 1 + 1.e-12*mpp_pe() 

  icflwt=isc; jcflwt=jsc; kcflwt=1; cflwtp=epsln; cflwtm=0.0
  dtmax = max(dtime_t, dtime_u)  

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           tempcfl(i)=abs(Grd%tmask(i,j,k)*Adv_vel%wrho_bt(i,j,k)/Thickness%dzwt(i,j,k))
        enddo
        itemp=maxloc(tempcfl)+isc-1
        if(tempcfl(itemp(1))>cflwtp) then
            cflwtp=tempcfl(itemp(1))
            icflwt=itemp(1)
            jcflwt=j
            kcflwt=k
        endif
     enddo
  enddo

  ! multiply by 100.0 to convert to percentages 
  ! multiply by dtmax to convert to dimensionless CFL number 
  ! multipby cflwtp by rho0r for dimensional reasons as well
  cflwtp = 100.0*cflwtp*rho0r*dtmax
  cflwtm = Adv_vel%wrho_bt(icflwt,jcflwt,kcflwt)*rho0r
  cflwtp  = cflwtp*fudge
  cflwtp0 = cflwtp
  call mpp_max(cflwtp)

  if (cflwtp == cflwtp0) then
    write (unit,'(a,g10.3,a,f7.2,a,g10.3,a,i4,a,i4,a,i3,a,a,f12.3,a,f12.3,a,f10.3,a)')&
   ' w_bt (',cflwtm,' m/s) is ',cflwtp/fudge,' % of CFL (',abs(100.0*cflwtm/(cflwtp/fudge)),&
   ' m/s) at (i,j,k) = (',icflwt+Dom%ioff,',',jcflwt+Dom%joff,',',kcflwt,'),',&
   ' (lon,lat,dpt) = (',Grd%xt(icflwt,jcflwt),',',Grd%yt(icflwt,jcflwt),',',  &
   Thickness%depth_zwt(icflwt,jcflwt,kcflwt),' m)'
    write (unit,'(a,e12.3,a,e12.3,a,f10.3)')&
   ' where grid is (m) (dxte,dytn,dzwu) = (',&
   Grd%dxte(icflwt,jcflwt),',',Grd%dytn(icflwt,jcflwt),',',Thickness%dzwu(icflwt,jcflwt,kcflwt)
   write(unit,'(a,i6)') ' The number of cells in the column are kmt = ', Grd%kmt(icflwt,jcflwt)
   write(unit,'(a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dzt) = ', &
         Thickness%dst(icflwt,jcflwt,kcflwt),', ',Thickness%rho_dzt(icflwt,jcflwt,kcflwt,tau)
  endif

end subroutine cfl_check1
! </SUBROUTINE> NAME="cfl_check1"


!#######################################################################
! <SUBROUTINE NAME="cfl_check2">
!
! <DESCRIPTION>
! Perform the second of two vertical CFL checks.  
!
! Bring the model down if too many large Courant numbers detected.  
! </DESCRIPTION>
subroutine cfl_check2(Time, Thickness, Adv_vel)

 type(ocean_time_type),      intent(in) :: Time
 type(ocean_thickness_type), intent(in) :: Thickness
 type(ocean_adv_vel_type),   intent(in) :: Adv_vel

  real :: dtmax, cflw
  real :: wmax, pcflw, scl
  real, dimension(isd:ied,jsd:jed) :: w
  integer :: i, j, k
  integer :: is, ie, js, je
  integer :: tau

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL,&
    '==>Error ocean_adv_vel_diag_mod (cfl_check2): module needs initialization ')
  endif 

  tau = Time%tau   

  write (stdoutunit,'(/60x,a/)') ' Vertical CFL summary II:  '
  write (stdoutunit,'(1x,a,f5.2/)') &
  'Locations (if any) where vertical Courant number exceeds ', large_cfl_value

  dtmax = max(dtime_t, dtime_u)  
  do k=1,nk
    w(:,:) = rho0r*Adv_vel%wrho_bt(:,:,k)
    do j=jsc,jec
      do i=isc,iec
        cflw  = abs((dtmax/Thickness%dzwt(i,j,k))*w(i,j))*Grd%tmask(i,j,k)

        if (cflw >= large_cfl_value) then

          write (unit,'(/,a,i4,a1,i3,a,i3,a,f6.3)')      &
           ' Note: CFL velocity limit exceeded at (i,j,k) = (',&
           i+Dom%ioff, ',',j+Dom%joff,',',k,') by factor =',large_cfl_value 

          wmax  = Thickness%dzwt(i,j,k)/dtmax
          pcflw = abs(100.0*w(i,j)/wmax)
          write (unit,'(a,f8.2,a,g15.8,a)') ' w_bt reached', pcflw,' % of the local CFL limit (',wmax,' m/s)'
          write (unit,'(a,e12.3,a,e12.3,a,f10.3)') &
          ' where the grid cell has dimensions (metres) (dxt,dyt,dzwt) = (',&
          Grd%dxt(i,j),',',Grd%dyt(i,j),',',Thickness%dzwt(i,j,k)
          write(unit,'(a,i6)') ' The number of cells in the column are kmt = ', Grd%kmt(i,j)
          write(unit,'(a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dzt) = ', &
          Thickness%dst(i,j,k),', ',Thickness%rho_dzt(i,j,k,tau)
        endif 

        if (cflw >= max_cfl_value) then

           write (unit,'(/,a,i4,a1,i3,a,i3,a,f6.3)')     &
           ' Note: CFL vertical velocity limit exceeded at (i,j,k) = (',&
           i+Dom%ioff, ',',j+Dom%joff,',',k,') by factor =',max_cfl_value 

           write(*,'(/a)') '==>Error in ocean_adv_vel_diag: max_cfl_value exceeded.'
           write(*,'(a)')  '   The model is bringing itself down in order for the user to determine '
           write(*,'(a)')  '   whether the simulation is going to produce Inf or NaN, or whether it '
           write(*,'(a)')  '   will successfully run through the present phase with large Courant numbers.'
           write(*,'(a)')  '   It is often the case that early spin-ups produce very large Courant'
           write(*,'(a)')  '   numbers, with the model later adjusting to stable behaviour with modest'
           write(*,'(a)')  '   Courant numbers. To test if the model will reach stable behaviour,'
           write(*,'(a)')  '   try significally increasing "max_cfl_value" in ocean_adv_vel_diag_nml.'

          if(verbose_cfl) then 

              write(*,'(/a,f6.3/)') &
              ' Information about region where vertical Courant number is larger than',max_cfl_value
              is = max(isc,i-3)
              ie = min(iec,i+3)
              js = max(jsc,j-3)
              je = min(jec,j+3)
              scl = 0.0
              write (*,9100)  'w_bt (m/s)', Time%itt, k, Thickness%depth_zwt(is,js,k), &
                   Grd%xt(is,j), Grd%xt(ie,j), Grd%yt(i,js), Grd%yt(i,je), scl
              call matrix (w(is:ie,js:je), is, ie, js, je, scl)

          endif

          call mpp_error(FATAL,'==>Error in ocean_adv_vel_diag_mod: max_cfl_value exceeded.')

        endif

      enddo
    enddo
  enddo

9100 format(1x,a12,1x,'ts=',i10,1x,',k=',i3,', z(m)=',f8.1,', lon(deg):',f6.2,' --> ',f6.2,&
            ', lat(deg):',f6.2,' --> ',f6.2,', scaling=',1pg10.3)

end subroutine cfl_check2
! </SUBROUTINE> NAME="cfl_check2"


!#######################################################################
! <SUBROUTINE NAME="maximum_bottom_w">
!
! <DESCRIPTION>
! Compute maximum vertical velocity on the bottom of tracer and velocity cells.
! The vertical velocity at bottom of a column of tracer cells should be roundoff.  
! For flat bottom simulations, the vertical velocity on the bottom of the 
! velocity cell column should also be roundoff.  For simulations with topography,
! the vertical velocity on the bottom of a velocity cell column will not vanish
! due to the effects of topography.  
! </DESCRIPTION>
!
subroutine maximum_bottom_w(Adv_vel)

  type(ocean_adv_vel_type), intent(in) :: Adv_vel

  real    :: wtbot, wubot, wtbot0, wubot0, fudge
  integer :: i, j, k, iwtbot, jwtbot, kwtbot, iwubot, jwubot, kwubot

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error ocean_adv_vel_diag_mod (maximum_bottom_w): module needs initialization ')
  endif 

  ! Find Max error in "w_bt" at bottom

  wtbot=0.0; iwtbot=isc; jwtbot=jsc; kwtbot=1
  do j=jsc,jec
    do i=isc,iec
      k = Grd%kmt(i,j)
      if (k /= 0 .and. (abs(Adv_vel%wrho_bt(i,j,k)) > abs(wtbot))) then
        wtbot  = Adv_vel%wrho_bt(i,j,k)
        iwtbot = i
        jwtbot = j
        kwtbot = k
      endif
    enddo
  enddo
  wtbot = rho0r*abs(wtbot)

  ! Find Max "wrho_bu" at bottom
  ! Relevant only for Bgrid.
  ! Note that wrho_bu is nonzero at the bottom of a U-column
  ! since it is part of the slope velocity.

  wubot=0.0; iwubot=isc; jwubot=jsc; kwubot=1
  do j=jsc,jec
    do i=isc,iec
      k = Grd%kmu(i,j)
      if (k /= 0 .and. (abs(Adv_vel%wrho_bu(i,j,k)) > abs(wubot))) then 
        wubot  = Adv_vel%wrho_bu(i,j,k)
        iwubot = i
        jwubot = j
        kwubot = k
      endif
    enddo
  enddo
  wubot = rho0r*abs(wubot)

  write (stdoutunit,'(//60x,a/)') ' Bottom vertical velocity summary:'
  fudge = 1 + 1.e-12*mpp_pe() ! to distinguish processors when tracer is independent of processor
  wtbot  = wtbot*fudge
  wubot  = wubot*fudge
  wtbot0 = wtbot
  wubot0 = wubot
  wtbot  = abs(wtbot)
  wubot  = abs(wubot)
  call mpp_max(wtbot)
  call mpp_max(wubot)

  if (abs(wtbot0) == wtbot) then
    wtbot = wtbot0/fudge
    write (unit,9112) wtbot, iwtbot+Dom%ioff, jwtbot+Dom%joff, kwtbot, &
                      Grd%xt(iwtbot,jwtbot), Grd%yt(iwtbot,jwtbot), Grd%zt(kwtbot)
  endif
  
  if(horz_grid == MOM_BGRID) then
     if (abs(wubot0) == wubot) then
       wubot = wubot0/fudge
       write (unit,9113) wubot, iwubot+Dom%ioff, jwubot+Dom%joff, kwubot, &
                         Grd%xu(iwubot,jwubot), Grd%yu(iwubot,jwubot), Grd%zt(kwubot)
     endif
  endif

9112  format(/' Maximum T-cell bottom velocity (',es10.3,' m/s){error}  at (i,j,k) = ','(',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.0,'m)')
9113  format(' Maximum U-cell bottom velocity (',es10.3,' m/s){slope}  at (i,j,k) = ','(',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.0,'m)'/)

end subroutine maximum_bottom_w
! </SUBROUTINE> NAME="maximum_bottom_w"


!#######################################################################
! <SUBROUTINE NAME="max_continuity_error">
!
! <DESCRIPTION>
! Compute continuity error. Should be roundoff if all is working well.  
! </DESCRIPTION>
!
subroutine max_continuity_error(Adv_vel, Thickness)

  type(ocean_adv_vel_type),   intent(in) :: Adv_vel
  type(ocean_thickness_type), intent(in) :: Thickness
  
  real    :: bigt, bigu, bigt0, bigu0, fudge
  integer :: i, j, k, iu, ju, ku, it, jt, kt

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error ocean_adv_vel_diag_mod (max_continuity_error): module needs initialization ')
  endif 

  do k=1,nk
       
     tmp(:,:)    = Thickness%rho_dzt_tendency(:,:,k) - Thickness%mass_source(:,:,k)
     wrk1(:,:,k) =  (tmp(:,:)                        &
                   + BDX_ET(Adv_vel%uhrho_et(:,:,k)) &
                   + BDY_NT(Adv_vel%vhrho_nt(:,:,k)) &
                   + Adv_vel%wrho_bt(:,:,k-1)-Adv_vel%wrho_bt(:,:,k))*Grd%tmask(:,:,k)

     ! relevant only for Bgrid
     tmp(:,:)    = Grd%umask(:,:,k)*REMAP_BT_TO_BU(tmp(:,:))
     wrk2(:,:,k) =  (tmp(:,:)                        &
                   + BDX_EU(Adv_vel%uhrho_eu(:,:,k)) &
                   + BDY_NU(Adv_vel%vhrho_nu(:,:,k)) &
                   + Adv_vel%wrho_bu(:,:,k-1)-Adv_vel%wrho_bu(:,:,k))*Grd%umask(:,:,k)

  enddo

  bigt = epsln !find location of largest continuity error
  bigu = epsln 
  it = isc; jt = jsc; kt = 1
  iu = isc; ju = jsc; ku = 1
  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        if (abs(wrk1(i,j,k)) > abs(bigt)) then
          bigt = wrk1(i,j,k)
          it = i
          jt = j
          kt = k
        endif 
        if (abs(wrk2(i,j,k)) > abs(bigu)) then
          bigu = wrk2(i,j,k)
          iu = i
          ju = j
          ku = k
        endif 
      enddo
    enddo
  enddo
  
  ! to distinguish processors when tracer is independent of processor
  fudge = 1 + 1.e-12*mpp_pe() 

  bigt  = bigt*fudge*rho0r
  bigu  = bigu*fudge*rho0r
  bigt0 = bigt
  bigu0 = bigu
  bigt  = abs(bigt)
  bigu  = abs(bigu)
  call mpp_max(bigt)
  call mpp_max(bigu)

  write (stdoutunit,'(/60x,a/)') ' Continuity error summary:'

  if (abs(bigt0) == bigt) then
    bigt = bigt0/fudge
    write (unit,'(a,es10.3,a,i4,a1,i3,a1,i3,a,f9.2,a,f9.2,a,f9.2,a/)') ' Maximum T-cell Continuity Error (',bigt,&
    ' m/s) is at (i,j,k) = (',it+Dom%ioff,',',jt+Dom%joff,',',kt,'),  (lon,lat,dpt) = ('&
     ,Grd%xt(it,jt),',',Grd%yt(it,jt),',',  Grd%zt(kt),' m)'
  endif

  if(horz_grid==MOM_BGRID) then
     if (abs(bigu0) == bigu) then
       bigu = bigu0/fudge
       write (unit,'(/,a,es10.3,a,i4,a1,i3,a1,i3,a,f9.2,a,f9.2,a,f9.2,a)') ' Maximum U-cell Continuity Error (',bigu,&
       ' m/s) is at (i,j,k) = (',iu+Dom%ioff,',',ju+Dom%joff,',',ku,'),  (lon,lat,dpt) = ('&
        ,Grd%xu(iu,ju),',',Grd%yu(iu,ju),',',  Grd%zt(ku),' m)'
     endif
  endif

  
end subroutine max_continuity_error
! </SUBROUTINE> NAME="max_continuity_error"


!#######################################################################
! <SUBROUTINE NAME="transport_on_s">
!
! <DESCRIPTION>
! Compute transports on s-levels (defined by same k-level)
! and send to diag_manager.
! </DESCRIPTION>
!
subroutine transport_on_s(Time, Adv_vel)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_adv_vel_type), intent(in) :: Adv_vel
  integer :: i, j, k
  
  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error ocean_adv_vel_diag_mod (transport_on_s): module needs initialization ')
  endif 

  ! mass transports leaving faces of grid cells
  wrk1=0.0

  if (id_tx_trans > 0 .or. id_tx_trans_int_z > 0) then 
    wrk1_2d(:,:) = 0.0
    do k=1,nk
         do j=jsc,jec 
            do i=isc,iec
               wrk1(i,j,k) = Adv_vel%uhrho_et(i,j,k)*Grd%dyte(i,j)*transport_convert
               wrk1_2d(i,j) = wrk1_2d(i,j) + wrk1(i,j,k)
            enddo
         enddo
    enddo 
    if (id_tx_trans > 0) call diagnose_3d(Time, Grd, id_tx_trans, wrk1(:,:,:))
    if (id_tx_trans_int_z > 0) call diagnose_2d(Time, Grd, id_tx_trans_int_z, wrk1_2d(:,:))
  endif 
 
  if (id_ty_trans > 0 .or. id_ty_trans_int_z > 0) then 
    wrk1_2d(:,:) = 0.0
    do k=1,nk
      do j=jsc,jec
         do i=isc,iec
            wrk1(i,j,k) = Adv_vel%vhrho_nt(i,j,k)*Grd%dxtn(i,j)*transport_convert 
            wrk1_2d(i,j) = wrk1_2d(i,j) + wrk1(i,j,k) 
         enddo 
      enddo
    enddo 
    if (id_ty_trans > 0) call diagnose_3d(Time, Grd, id_ty_trans, wrk1(:,:,:))
    if (id_ty_trans_int_z > 0) call diagnose_2d(Time, Grd, id_ty_trans_int_z, wrk1_2d(:,:))
  endif 

  if (id_tz_trans > 0 .or. id_tz_trans_int_z > 0) then 
    wrk1_2d(:,:) = 0.0
    do k=1,nk
      do j=jsc,jec
         do i=isc,iec
            wrk1(i,j,k) = Adv_vel%wrho_bt(i,j,k)*Grd%dat(i,j)*transport_convert 
            wrk1_2d(i,j) = wrk1_2d(i,j) + wrk1(i,j,k) 
         enddo 
      enddo
    enddo 
     if (id_tz_trans > 0) call diagnose_3d(Time, Grd, id_tz_trans, wrk1(:,:,:))
     if (id_tz_trans_int_z > 0) call diagnose_2d(TIme, Grd, id_tz_trans_int_z, wrk1_2d(:,:))
  endif 

  if (id_tz_trans_sq > 0) then 
    do k=1,nk
      do j=jsc,jec
         do i=isc,iec
            wrk1(i,j,k) = (Adv_vel%wrho_bt(i,j,k)*Grd%dat(i,j)*transport_convert)**2 
         enddo 
      enddo
    enddo 
    call diagnose_3d(Time, Grd, id_tz_trans_sq, wrk1(:,:,:))
  endif 

  ! relevant only for Bgrid 
  if (id_ux_trans > 0) then 
    do k=1,nk
      do j=jsc,jec
         do i=isc,iec
            wrk1(i,j,k) = Adv_vel%uhrho_eu(i,j,k)*Grd%dyue(i,j)*transport_convert
         enddo 
      enddo
    enddo 
    call diagnose_3d_u(Time, Grd, id_ux_trans, wrk1(:,:,:))
  endif 

  ! relevant only for Bgrid 
  if (id_uy_trans > 0) then 
    do k=1,nk
      do j=jsc,jec
         do i=isc,iec
            wrk1(i,j,k) = Adv_vel%vhrho_nu(i,j,k)*Grd%dxun(i,j)*transport_convert 
         enddo 
      enddo
    enddo 
    call diagnose_3d_u(Time, Grd, id_uy_trans, wrk1(:,:,:))
  endif 

  ! relevant only for Bgrid 
  if (id_uz_trans > 0) then 
    do k=1,nk
      do j=jsc,jec
         do i=isc,iec
            wrk1(i,j,k) = Adv_vel%wrho_bu(i,j,k)*Grd%dxu(i,j)*Grd%dyu(i,j)*transport_convert
         enddo 
      enddo 
    enddo 
    call diagnose_3d_u(Time, Grd, id_uz_trans, wrk1(:,:,:))
  endif 

end subroutine transport_on_s
! </SUBROUTINE> NAME="transport_on_s"


!#######################################################################
! <SUBROUTINE NAME="transport_on_nrho">
!
! <DESCRIPTION>
! Classify horizontal transport according to neutral density classes. 
!
! NOTE: This diagnostic works with transport through cell faces.
! To get transport_on_nrho, a binning must be done, rather than 
! a remapping (as done for trans_rho_gm).  
!
! code history:
!
! 2002: Stephen.Griffies
! Zhi.Liang
! Alexander.Pletzer
!
! 2007: updated algorithm with weighting as done in the paper
! Lee, Nurser, Coward, and de Cuevas, 2007:
! "Eddy advective and diffusive transports of heat and salt 
! in the Southern Ocean" JPO, vol 37, pages 1376-1393
!
! 2010: updated by Rusty.Benson for optimization.
!
! 2010: Corrected weighting by Stephen.Griffies
!
! 2010: Removed the weighting in favor of a strait rebinning
!       approach.  The weighting approach was 
!       unnecessary, and added more cost to the scheme.  
! 
! </DESCRIPTION>
!
subroutine transport_on_nrho (Time, Dens, Adv_vel)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens
  type(ocean_adv_vel_type), intent(in) :: Adv_vel
  type(time_type)                      :: next_time 

  integer :: i, j, k, k_rho, neutralrho_nk
  real    :: work1(isc:iec,jsc:jec,size(Dens%neutralrho_ref))
  real    :: work2(isc:iec,jsc:jec,size(Dens%neutralrho_ref))
  real    :: tmp(2,isc:iec,jsc:jec)

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error ocean_adv_vel_diag_mod (transport_on_nrho): module needs initialization ')
  endif 

  neutralrho_nk = size(Dens%neutralrho_ref(:))
  next_time = increment_time(Time%model_time, int(dtts), 0)

  if (need_data(id_tx_trans_nrho,next_time) .or. need_data(id_ty_trans_nrho,next_time)) then

      work1(:,:,:) = 0.0
      work2(:,:,:) = 0.0

      do k_rho = 1,neutralrho_nk

         tmp(:,:,:) = 0.0
         do k = 1,nk
            do j = jsc,jec
               do i = isc,iec
                  if (k_rho == 1) then
                     if (Dens%neutralrho(i,j,k) < Dens%neutralrho_bounds(k_rho+1)) then
                         tmp(1,i,j) = tmp(1,i,j) + Adv_vel%uhrho_et(i,j,k)
                         tmp(2,i,j) = tmp(2,i,j) + Adv_vel%vhrho_nt(i,j,k)
                     endif
                  elseif (k_rho < neutralrho_nk) then
                     if ((Dens%neutralrho_bounds(k_rho) <= Dens%neutralrho(i,j,k)) .and.  &
                         (Dens%neutralrho(i,j,k)        <  Dens%neutralrho_bounds(k_rho+1)) ) then 
                           tmp(1,i,j) = tmp(1,i,j) + Adv_vel%uhrho_et(i,j,k)
                           tmp(2,i,j) = tmp(2,i,j) + Adv_vel%vhrho_nt(i,j,k)
                     endif
                  else    ! if (k_rho == neutralrho_nk) then
                     if (Dens%neutralrho_bounds(k_rho) <= Dens%neutralrho(i,j,k)) then 
                         tmp(1,i,j) = tmp(1,i,j) + Adv_vel%uhrho_et(i,j,k)             
                         tmp(2,i,j) = tmp(2,i,j) + Adv_vel%vhrho_nt(i,j,k)
                     endif
                  endif
               enddo
            enddo
         enddo

         do j = jsc,jec
            do i = isc,iec
               work1(i,j,k_rho) = (tmp(1,i,j)+work1(i,j,k_rho))*Grd%dyte(i,j)*transport_convert*Grd%tmask(i,j,1)
               work2(i,j,k_rho) = (tmp(2,i,j)+work2(i,j,k_rho))*Grd%dxtn(i,j)*transport_convert*Grd%tmask(i,j,1)
            enddo
         enddo

      enddo

      if (id_tx_trans_nrho > 0) then 
          used = send_data (id_tx_trans_nrho, work1, Time%model_time, &
                            ks_in=1, ke_in=neutralrho_nk)
      endif
      if (id_ty_trans_nrho > 0) then 
          used = send_data (id_ty_trans_nrho, work2, Time%model_time, &
                            ks_in=1, ke_in=neutralrho_nk)
      endif

  endif

end subroutine transport_on_nrho
! </SUBROUTINE> NAME="transport_on_nrho"


!#######################################################################
! <SUBROUTINE NAME="transport_on_rho">
!
! <DESCRIPTION>
! Classify horizontal transport according to potential density classes. 
!
! Diagnostic makes sense when potrho is monotonically increasing with 
! depth, although the algorithm does not explicitly make this assumption.  
!
! NOTE: This diagnostic works with transport through cell faces.
! To get transport_on_rho, a binning must be done, rather than 
! a remapping (as done for trans_rho_gm).  
!
! Code history 
!
! 2002: Stephen.Griffies
! Zhi.Liang
! Alexander.Pletzer
!
! 2007: updated algorithm with weighting as done in the paper
! Lee, Nurser, Coward, and de Cuevas, 2007:
! "Eddy advective and diffusive transports of heat and salt 
! in the Southern Ocean" JPO, vol 37, pages 1376-1393
!
! 2010: updated by Rusty.Benson for optimization.
!       corrected weigthing by Stephen.Griffies
!
! 2010: Removed the weighting in favor of a strait rebinning
!       approach.  The weighting approach was 
!       unnecessary, and added more cost to the scheme.  
!
! 2018: Rearranged looping to avoid scanning "impossible" levels by Russ Fiedler.
! </DESCRIPTION>
!
subroutine transport_on_rho (Time, Dens, Adv_vel)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens
  type(ocean_adv_vel_type), intent(in) :: Adv_vel
  type(time_type)                      :: next_time 

  integer :: i, j, k, k_rho, potrho_nk
  real    :: work1(isc:iec,jsc:jec,size(Dens%potrho_ref))
  real    :: work2(isc:iec,jsc:jec,size(Dens%potrho_ref))
  real    :: tmp(2,isc:iec,size(Dens%potrho_ref))

  real    :: rho_max, rho_min

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error ocean_adv_vel_diag_mod (transport_on_rho): module needs initialization ')
  endif 

  potrho_nk = size(Dens%potrho_ref(:))
  next_time = increment_time(Time%model_time, int(dtts), 0)

  if (need_data(id_tx_trans_rho,next_time) .or. need_data(id_ty_trans_rho,next_time)) then

      work1(:,:,:) = 0.0
      work2(:,:,:) = 0.0

      do j = jsc,jec
         tmp(:,:,:) = 0.0
         do k = 1,nk
            rho_max = maxval(Dens%potrho(isc:iec,j,k),mask=Grd%tmask(isc:iec,j,k)==1)
            if (rho_max == -huge(rho_max)) exit  ! All land in this row and lower
            rho_min = minval(Dens%potrho(isc:iec,j,k),mask=Grd%tmask(isc:iec,j,k)==1)

            k_rho = 1
            if (rho_min < Dens%potrho_bounds(k_rho+1)) then
               do i = isc,iec
                  if (Dens%potrho(i,j,k) < Dens%potrho_bounds(k_rho+1)) then
                     tmp(1,i,k_rho) = tmp(1,i,k_rho) + Adv_vel%uhrho_et(i,j,k)
                     tmp(2,i,k_rho) = tmp(2,i,k_rho) + Adv_vel%vhrho_nt(i,j,k)
                  endif
               enddo
            endif
            do k_rho = 2,potrho_nk-1
               if (Dens%potrho_bounds(k_rho) > rho_max .or. Dens%potrho_bounds(k_rho+1) <= rho_min) cycle
               do i = isc,iec
                  if ((Dens%potrho_bounds(k_rho) <= Dens%potrho(i,j,k)) .and. &
                      (Dens%potrho(i,j,k)        <  Dens%potrho_bounds(k_rho+1)) ) then 
                        tmp(1,i,k_rho) = tmp(1,i,k_rho) + Adv_vel%uhrho_et(i,j,k)
                        tmp(2,i,k_rho) = tmp(2,i,k_rho) + Adv_vel%vhrho_nt(i,j,k)
                  endif
               enddo
            enddo
            k_rho = potrho_nk
            if (rho_max >= Dens%potrho_bounds(k_rho)) then
               do i = isc,iec
                  if (Dens%potrho_bounds(k_rho) <= Dens%potrho(i,j,k)) then 
                     tmp(1,i,k_rho) = tmp(1,i,k_rho) + Adv_vel%uhrho_et(i,j,k)             
                     tmp(2,i,k_rho) = tmp(2,i,k_rho) + Adv_vel%vhrho_nt(i,j,k)
                  endif
               enddo
             endif
         enddo

         do k_rho = 1,potrho_nk
            do i = isc,iec
               work1(i,j,k_rho) = (tmp(1,i,k_rho)+work1(i,j,k_rho))*Grd%dyte(i,j)*transport_convert*Grd%tmask(i,j,1)
               work2(i,j,k_rho) = (tmp(2,i,k_rho)+work2(i,j,k_rho))*Grd%dxtn(i,j)*transport_convert*Grd%tmask(i,j,1)
            enddo
         enddo
      enddo

      if (id_tx_trans_rho > 0) then 
          used = send_data (id_tx_trans_rho, work1, Time%model_time, &
                            ks_in=1, ke_in=potrho_nk)
      endif
      if (id_ty_trans_rho > 0) then 
          used = send_data (id_ty_trans_rho, work2, Time%model_time, &
                            ks_in=1, ke_in=potrho_nk)
      endif

  endif

end subroutine transport_on_rho
! </SUBROUTINE> NAME="transport_on_rho"


!#######################################################################
! <SUBROUTINE NAME="transport_on_theta">
!
! <DESCRIPTION>
! Classify horizontal transport of mass according to potential 
! temperature classes.  This diagnostic is useful to deduce the 
! heat that is transported between potential temperature classes. 
!
! Diagnostic makes sense when theta is monotonically decreasing
! with depth, although the algorithm does not explicitly make
! this assumption.  
!
! NOTE: This diagnostic works with transport through cell faces.
! To get transport_on_theta, a binning must be done, rather than 
! a remapping (as done for trans_rho_gm).  
!
! Code history 
!
! 2002: Stephen.Griffies
! Zhi.Liang
! Alexander.Pletzer
!
! 2007: updated algorithm with weighting as done in the paper
! Lee, Nurser, Coward, and de Cuevas, 2007:
! "Eddy advective and diffusive transports of heat and salt 
! in the Southern Ocean" JPO, vol 37, pages 1376-1393
!
! 2010: updated by Rusty.Benson for optimization.
!       corrected weigthing by Stephen.Griffies
!
! 2010: Removed the weighting in favor of a strait rebinning
!       approach.  The weighting approach was 
!       unnecessary, and added more cost to the scheme.  
!
! 2018: Rearranged looping to avoid scanning "impossible" levels by Russ Fiedler.
! </DESCRIPTION>
!
subroutine transport_on_theta (Time, Dens, Theta, Adv_vel)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_density_type),     intent(in) :: Dens
  type(ocean_prog_tracer_type), intent(in) :: Theta
  type(ocean_adv_vel_type),     intent(in) :: Adv_vel

  type(time_type)                          :: next_time 

  integer :: i, j, k, k_theta, theta_nk, tau
  real    :: work1(isc:iec,jsc:jec,size(Dens%theta_ref))
  real    :: work2(isc:iec,jsc:jec,size(Dens%theta_ref))
  real    :: tmp(2,isc:iec,size(Dens%theta_ref))

  real    :: theta_max, theta_min

  tau = Time%tau

  theta_nk = size(Dens%theta_ref(:))
  next_time = increment_time(Time%model_time, int(dtts), 0)

  if (need_data(id_tx_trans_theta,next_time) .or. need_data(id_ty_trans_theta,next_time)) then

      work1(:,:,:)  = 0.0
      work2(:,:,:)  = 0.0

      do j = jsc,jec
         tmp(:,:,:) = 0.0
         do k = 1,nk
            theta_max = maxval(Theta%field(isc:iec,j,k,tau),mask=Grd%tmask(isc:iec,j,k)==1)
            if (theta_max == -huge(theta_max)) exit  ! All land in this row and lower
            theta_min = minval(Theta%field(isc:iec,j,k,tau),mask=Grd%tmask(isc:iec,j,k)==1)

            k_theta = 1
            if (theta_min < Dens%theta_bounds(k_theta+1)) then
               do i = isc,iec
                  if (Theta%field(i,j,k,tau) < Dens%theta_bounds(k_theta+1)) then
                     tmp(1,i,k_theta) = tmp(1,i,k_theta) + Adv_vel%uhrho_et(i,j,k)
                     tmp(2,i,k_theta) = tmp(2,i,k_theta) + Adv_vel%vhrho_nt(i,j,k)
                  endif
               enddo
            endif
            do k_theta = 2,theta_nk-1
               if (Dens%theta_bounds(k_theta) > theta_max .or. Dens%theta_bounds(k_theta+1) <= theta_min ) cycle
               do i = isc,iec
                  if ((Dens%theta_bounds(k_theta) <= Theta%field(i,j,k,tau)) .and. &
                      (Theta%field(i,j,k,tau)     <  Dens%theta_bounds(k_theta+1)) ) then 
                       tmp(1,i,k_theta) = tmp(1,i,k_theta) + Adv_vel%uhrho_et(i,j,k)
                       tmp(2,i,k_theta) = tmp(2,i,k_theta) + Adv_vel%vhrho_nt(i,j,k)
                     endif
               enddo
            enddo
            k_theta = theta_nk
            if (theta_max >= Dens%theta_bounds(k_theta)) then
               do i = isc,iec
                  if (Dens%theta_bounds(k_theta) <= Theta%field(i,j,k,tau)) then 
                      tmp(1,i,k_theta) = tmp(1,i,k_theta) + Adv_vel%uhrho_et(i,j,k)
                      tmp(2,i,k_theta) = tmp(2,i,k_theta) + Adv_vel%vhrho_nt(i,j,k)
                  endif
               enddo
            endif
         enddo

         do k_theta = 1,theta_nk
            do i = isc,iec
               work1(i,j,k_theta) = (tmp(1,i,k_theta)+work1(i,j,k_theta))*Grd%dyte(i,j)*transport_convert*Grd%tmask(i,j,1)
               work2(i,j,k_theta) = (tmp(2,i,k_theta)+work2(i,j,k_theta))*Grd%dxtn(i,j)*transport_convert*Grd%tmask(i,j,1)
            enddo
         enddo
      enddo

      if (id_tx_trans_theta > 0) then 
          used = send_data (id_tx_trans_theta, work1, Time%model_time, &
                            ks_in=1, ke_in=theta_nk)
      endif
      if (id_ty_trans_theta > 0) then 
          used = send_data (id_ty_trans_theta, work2, Time%model_time, &
                            ks_in=1, ke_in=theta_nk)
      endif

  endif

end subroutine transport_on_theta
! </SUBROUTINE> NAME="transport_on_theta"


!#######################################################################
! <SUBROUTINE NAME="vertical_reynolds_check">
!
! <DESCRIPTION>
! This subroutine computes the Reynolds number associated with vertical
! friction visc_cbt and vertical velocity wrho_bt.  This check is
! appropriate for either Bgrid or Cgrid. 
! </DESCRIPTION>
!
subroutine vertical_reynolds_check(Adv_vel, Thickness, visc_cbt)

  type(ocean_adv_vel_type),     intent(in) :: Adv_vel
  type(ocean_thickness_type),   intent(in) :: Thickness
  real, dimension(isd:,jsd:,:), intent(in) :: visc_cbt

  real    :: ramb, reyz
  real    :: fudge
  real    :: reynz0, reynz, reynw, reynmw
  integer :: ireynz, jreynz, kreynz
  integer :: i, j, k, kk

  integer :: stdoutunit 
  stdoutunit=stdout() 

  ! look for max grid reynolds numbers using velocities at "tau".

  ireynz=isc; jreynz=jsc; kreynz=1
  reynz=0.0 ; reynw=0.0 ; reynmw=0.0

  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        ramb = 1.0/(visc_cbt(i,j,k) + epsln)

        kk = min(k+1,nk)
        if (k >= Grd%kmt(i,j)) then
          reyz = 0.0
        else 
          reyz = Grd%tmask(i,j,kk)*abs(Adv_vel%wrho_bt(i,j,k)*Thickness%dzwt(i,j,k))*ramb
        endif
        if (reyz > reynz) then
          ireynz = i
          jreynz = j
          kreynz = k
          reynz  = reyz
          reynw  = Adv_vel%wrho_bt(i,j,k)
          reynmw = 1.0/ramb
        endif
      enddo
    enddo
  enddo
  write (stdoutunit,'(/60x,a/)') ' Vertical Laplacian Grid Reynolds number summary'


  fudge = 1 + 1.e-12*mpp_pe()  ! used to distinguish processors when result is independent of processor
  reynz = reynz*fudge 
  if(reynz == 0.0) then 
    reynz = reynz + 1.e-12*mpp_pe() 
  endif 

  reynz0 = reynz
  call mpp_max(reynz)
  
  if (reynz == reynz0) then
     write(unit,'(/,a,es9.2,a,i4,a1,i4,a1,i3,a,f7.2,a,f7.2,a,f8.2,a,/,1x,a,es9.2,a,es9.2,/)') &
           ' Maximum vertical grid Re # = ', reynz,&
           ' at (i,j,k) = (',ireynz+Dom%ioff,',',jreynz+Dom%joff,',',kreynz,&
           '),  (lon,lat,dpt) = (',Grd%xt(ireynz,jreynz),',', &
           Grd%yt(ireynz,jreynz),',', Grd%dzt(kreynz),' m). ', 'Vertical velocity "w_bt" is (m/s) ',&
            rho0r*reynw, ' and vertical viscosity (m^2/s) "visc_cbt" is ', reynmw
  endif

end subroutine vertical_reynolds_check
! </SUBROUTINE> NAME="vertical_reynolds_check"


end module ocean_adv_vel_diag_mod

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                                   !!
!!                   GNU General Public License                      !!
!!                                                                   !!
!! This file is part of the Flexible Modeling System (FMS).          !!
!!                                                                   !!
!! FMS is free software; you can redistribute it and/or modify       !!
!! it and are expected to follow the terms of the GNU General Public !!
!! License as published by the Free Software Foundation.             !!
!!                                                                   !!
!! FMS is distributed in the hope that it will be useful,            !!
!! but WITHOUT ANY WARRANTY; without even the implied warranty of    !!
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     !!
!! GNU General Public License for more details.                      !!
!!                                                                   !!
!! You should have received a copy of the GNU General Public License !!
!! along with FMS; if not, write to:                                 !!
!!          Free Software Foundation, Inc.                           !!
!!          59 Temple Place, Suite 330                               !!
!!          Boston, MA  02111-1307  USA                              !!
!! or see:                                                           !!
!!          http://www.gnu.org/licenses/gpl.txt                      !!
!!                                                                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module horiz_interp_mod

! <CONTACT EMAIL="Zhi.Liang@noaa.gov"> Zhi Liang </CONTACT>
! <CONTACT EMAIL="Bruce.Wyman@noaa.gov"> Bruce Wyman </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!   Performs spatial interpolation between grids.
! </OVERVIEW>

! <DESCRIPTION>
!     This module can interpolate data from any logically rectangular grid
!     to any logically rectangular grid. Four interpolation schems are used here:
!     conservative, bilinear, bicubic and inverse of square distance weighted. 
!     The four interpolation schemes are implemented seperately in 
!     horiz_interp_conserver_mod, horiz_interp_blinear_mod, horiz_interp_bicubic_mod
!     and horiz_interp_spherical_mod. bicubic interpolation requires the source grid
!     is regular lon/lat grid. User can choose the interpolation method in the 
!     public interface horiz_interp_new through optional argument interp_method,
!     with acceptable value "conservative", "bilinear", "bicubic" and "spherical".
!     The default value is "conservative". There is an optional mask field for 
!     missing input data. An optional output mask field may be used in conjunction with
!     the input mask to show where output data exists.
! </DESCRIPTION>

!-----------------------------------------------------------------------
!
!        Performs spatial interpolation between grids.
!
!-----------------------------------------------------------------------

use fms_mod,                    only: write_version_number, fms_error_handler
use fms_mod,                    only: file_exist, close_file
use fms_mod,                    only: check_nml_error, open_namelist_file
use mpp_mod,                    only: mpp_error, FATAL, stdout, stdlog, mpp_min
use mpp_mod,                    only: input_nml_file, WARNING, mpp_pe, mpp_root_pe
use constants_mod,              only: pi
use horiz_interp_type_mod,      only: horiz_interp_type, assignment(=)
use horiz_interp_type_mod,      only: CONSERVE, BILINEAR, SPHERICA, BICUBIC
use horiz_interp_conserve_mod,  only: horiz_interp_conserve_init, horiz_interp_conserve
use horiz_interp_conserve_mod,  only: horiz_interp_conserve_new, horiz_interp_conserve_del
use horiz_interp_bilinear_mod,  only: horiz_interp_bilinear_init, horiz_interp_bilinear
use horiz_interp_bilinear_mod,  only: horiz_interp_bilinear_new, horiz_interp_bilinear_del
use horiz_interp_bicubic_mod,   only: horiz_interp_bicubic_init, horiz_interp_bicubic
use horiz_interp_bicubic_mod,   only: horiz_interp_bicubic_new, horiz_interp_bicubic_del
use horiz_interp_spherical_mod, only: horiz_interp_spherical_init, horiz_interp_spherical
use horiz_interp_spherical_mod, only: horiz_interp_spherical_new, horiz_interp_spherical_del

 implicit none
 private

!---- interfaces ----

 public   horiz_interp_type, horiz_interp, horiz_interp_new, horiz_interp_del, &
          horiz_interp_init, horiz_interp_end, assignment(=)

! <INTERFACE NAME="horiz_interp_new">
!   <OVERVIEW>
!      Allocates space and initializes a derived-type variable
!      that contains pre-computed interpolation indices and weights.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Allocates space and initializes a derived-type variable
!      that contains pre-computed interpolation indices and weights
!      for improved performance of multiple interpolations between
!      the same grids. This routine does not need to be called if you
!      are doing a single grid-to-grid interpolation.
!   </DESCRIPTION>
!   <IN NAME="lon_in" TYPE="real" DIM="dimension(:), dimension(:,:)" UNITS="radians">
!      Longitude (in radians) for source data grid. You can pass 1-D lon_in to 
!      represent the geographical longitude of regular lon/lat grid, or just 
!      pass geographical longitude(lon_in is 2-D). The grid location may be 
!      located at grid cell edge or center, decided by optional argument "grid_at_center".
!   </IN>
!   <IN NAME="lat_in" TYPE="real" DIM="dimension(:), dimension(:,:)" UNITS="radians">
!      Latitude (in radians) for source data grid. You can pass 1-D lat_in to 
!      represent the geographical latitude of regular lon/lat grid, or just 
!      pass geographical latitude(lat_in is 2-D). The grid location may be 
!      located at grid cell edge or center, decided by optional argument "grid_at_center".
!   </IN>
!   <IN NAME="lon_out" TYPE="real" DIM="dimension(:), dimension(:,:)" UNITS="radians" >
!      Longitude (in radians) for destination data grid. You can pass 1-D lon_out to 
!      represent the geographical longitude of regular lon/lat grid, or just 
!      pass geographical longitude(lon_out is 2-D). The grid location may be 
!      located at grid cell edge or center, decided by optional argument "grid_at_center".
!   </IN>
!   <IN NAME="lat_out" TYPE="real" DIM="dimension(:), dimension(:,:)" UNITS="radians" >
!      Latitude (in radians) for destination data grid. You can pass 1-D lat_out to 
!      represent the geographical latitude of regular lon/lat grid, or just 
!      pass geographical latitude(lat_out is 2-D). The grid location may be 
!      located at grid cell edge or center, decided by optional argument "grid_at_center".
!   </IN>
!   <IN NAME="verbose" TYPE="integer">
!      Integer flag that controls the amount of printed output.
!      verbose = 0, no output; = 1, min,max,means; = 2, still more
!   </IN>
!   <IN NAME="interp_method" TYPE="character(len=*)" > 
!      interpolation method, = "conservative", using conservation scheme,
!      = "bilinear", using bilinear interpolation, = "spherical",using spherical regrid.
!      = "bicubic", using bicubic interpolation. The default value is "convervative".
!   </IN>
!   <IN NAME = "src_modulo" >
!      Indicate the source data grid is cyclic or not.
!   </IN>
!   <IN NAME = "grid_at_center" >
!      Indicate the data is on the center of grid box or the edge of grid box. 
!      When true, the data is on the center of grid box. default vaule is false.
!      This option is only available when interp_method = "bilinear" or "bicubic".
!   </IN>
!   <OUT NAME="Interp" >
!      A derived-type variable containing indices and weights used for subsequent 
!      interpolations. To reinitialize this variable for a different grid-to-grid 
!      interpolation you must first use the "horiz_interp_del" interface.
!   </OUT>

 interface horiz_interp_new
    module procedure horiz_interp_new_1d     ! Source grid is 1d, destination grid is 1d
    module procedure horiz_interp_new_1d_src ! Source grid is 1d, destination grid is 2d
    module procedure horiz_interp_new_2d     ! Source grid is 2d, destination grid is 2d
    module procedure horiz_interp_new_1d_dst ! Source grid is 2d, destination grid is 1d
 end interface
! </INTERFACE>

! <INTERFACE NAME="horiz_interp">
!
!   <OVERVIEW>
!     Subroutine for performing the horizontal interpolation between two grids.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Subroutine for performing the horizontal interpolation between
!     two grids. There are two forms of this interface.
!     Form A requires first calling horiz_interp_new, while Form B
!     requires no initialization.
!   </DESCRIPTION>

!   <IN NAME="Interp" >
!     Derived-type variable containing interpolation indices and weights.
!     Returned by a previous call to horiz_interp_new.
!   </IN>
!   <IN NAME="data_in">
!      Input data on source grid.
!   </IN>
!   <IN NAME="verbose">
!      flag for the amount of print output.
!               verbose = 0, no output; = 1, min,max,means; = 2, still more
!   </IN>
!   <IN NAME="mask_in">
!      Input mask, must be the same size as the input data. The real value of
!      mask_in must be in the range (0.,1.). Set mask_in=0.0 for data points 
!      that should not be used or have missing data. It is Not needed for 
!      spherical regrid.
!   </IN>
!   <IN NAME="missing_value" >
!      Use the missing_value to indicate missing data.
!   </IN>
!   <IN NAME="missing_permit">
!      numbers of points allowed to miss for the bilinear interpolation. The value
!      should be between 0 and 3.
!   </IN>
!   <IN NAME="lon_in, lat_in" >
!      longitude and latitude (in radians) of source grid. More explanation can 
!      be found in the documentation of horiz_interp_new.
!   </IN>
!   <IN NAME="lon_out, lat_out" >
!      longitude and latitude (in radians) of destination grid. More explanation can 
!      be found in the documentation of horiz_interp_new.
!   </IN>
!   <OUT NAME="data_out">
!      Output data on destination grid.
!   </OUT>
!   <OUT NAME="mask_out">
!      Output mask that specifies whether data was computed.
!   </OUT>

!   <ERROR MSG="size of input array incorrect" STATUS="FATAL">
!      The input data array does not match the size of the input grid edges
!      specified. If you are using the initialization interface make sure you
!      have the correct grid size.
!   </ERROR>
!   <ERROR MSG="size of output array incorrect" STATUS="FATAL">
!      The output data array does not match the size of the input grid
!      edges specified. If you are using the initialization interface make
!      sure you have the correct grid size.
!   </ERROR>

 interface horiz_interp
    module procedure horiz_interp_base_2d
    module procedure horiz_interp_base_3d
    module procedure horiz_interp_solo_1d
    module procedure horiz_interp_solo_1d_src
    module procedure horiz_interp_solo_2d
    module procedure horiz_interp_solo_1d_dst
    module procedure horiz_interp_solo_old
 end interface
! </INTERFACE>


 !--- namelist interface
 !<NAMELIST NAME="horiz_interp_nml">
 ! <DATA NAME="reproduce_siena" TYPE="logical" DEFAULT=".FALSE." >
 !   Set reproduce_siena = .true. to reproduce siena results. 
 !   Set reproduce_siena = .false. to decrease truncation error 
 !   in routine poly_area in file mosaic_util.c. The truncation error of
 !   second order conservative remapping might be big for high resolution
 !   grid.  
 ! </DATA>
 !</NAMELIST>

 logical :: reproduce_siena = .false.

 namelist /horiz_interp_nml/ reproduce_siena

!-----------------------------------------------------------------------
 character(len=128) :: version = '$Id$'
 character(len=128) :: tagname = '$Name$'
 logical            :: module_is_initialized = .FALSE.
!-----------------------------------------------------------------------

contains

!#######################################################################
!  <SUBROUTINE NAME="horiz_interp_init">
!  <OVERVIEW>
!     writes version number and tag name to logfile.out
!  </OVERVIEW>
!  <DESCRIPTION>       
!     writes version number and tag name to logfile.out
!  </DESCRIPTION>

  subroutine horiz_interp_init
  integer :: unit, ierr, io

  if(module_is_initialized) return
  call write_version_number (version, tagname)

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, horiz_interp_nml, iostat=io)
  ierr = check_nml_error(io,'horiz_interp_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file ( )
     ierr=1
     do while (ierr /= 0)
     read  (unit, nml=horiz_interp_nml, iostat=io, end=10)
     ierr = check_nml_error(io,'horiz_interp_nml')  ! also initializes nml error codes
     enddo
10   call close_file (unit)
  endif
#endif
  if (mpp_pe() == mpp_root_pe() ) then
     unit = stdlog()
     write (unit, nml=horiz_interp_nml)
  endif

  if( reproduce_siena ) then
     call mpp_error(FATAL, "horiz_interp_mod: You have overridden the default value of reproduce_siena " // &
                           "and set it to .true. in horiz_interp_nml. This is a temporary workaround to " // &
                           "allow for consistency in continuing experiments. Please remove this namelist " )
  endif

  call horiz_interp_conserve_init
  call horiz_interp_bilinear_init
  call horiz_interp_bicubic_init
  call horiz_interp_spherical_init

  module_is_initialized = .true.

  end subroutine horiz_interp_init

!  </SUBROUTINE>

!#######################################################################
!  <SUBROUTINE NAME="horiz_interp_new_1d" INTERFACE="horiz_interp_new">
!  <IN NAME="lon_in" TYPE="real" DIM="(:),(:,:)" UNITS="radians"></IN>
!  <IN NAME="lat_in" TYPE="real" DIM="(:),(:,:)"></IN>
!  <IN NAME="lon_out" TYPE="real" DIM="(:),(:,:)"></IN>
!  <IN NAME="lat_out" TYPE="real" DIM="(:),(:,:)"></IN>
!  <IN NAME="verbose" TYPE="integer, optional"></IN>
!  <IN NAME="interp_method" TYPE="character(len=*),optional"></IN>
!  <IN NAME="src_modulo" TYPE="logical, optional" > </IN>
!  <OUT NAME="Interp" TYPE="type(horiz_interp_type)"></OUT>

!<PUBLICROUTINE INTERFACE="horiz_interp_new">
  subroutine horiz_interp_new_1d (Interp, lon_in, lat_in, lon_out, lat_out, verbose, &
                                  interp_method, num_nbrs, max_dist, src_modulo,     &
                                  grid_at_center, mask_in, mask_out)
!</PUBLICROUTINE>

    !-----------------------------------------------------------------------
    type(horiz_interp_type), intent(inout)        :: Interp
    real, intent(in),  dimension(:)               :: lon_in , lat_in
    real, intent(in),  dimension(:)               :: lon_out, lat_out
    integer, intent(in),                 optional :: verbose
    character(len=*), intent(in),        optional :: interp_method
    integer, intent(in),                 optional :: num_nbrs
    real,    intent(in),                 optional :: max_dist
    logical, intent(in),                 optional :: src_modulo
    logical, intent(in),                 optional :: grid_at_center
    real, intent(in), dimension(:,:),    optional :: mask_in  ! dummy
    real, intent(out),dimension(:,:),    optional :: mask_out ! dummy
    !-----------------------------------------------------------------------
    real, dimension(:,:), allocatable :: lon_src, lat_src, lon_dst, lat_dst
    real, dimension(:),   allocatable :: lon_src_1d, lat_src_1d, lon_dst_1d, lat_dst_1d
    integer                           :: i, j, nlon_in, nlat_in, nlon_out, nlat_out
    logical                           :: center
    character(len=40)                 :: method
    !-----------------------------------------------------------------------
    call horiz_interp_init

    method = 'conservative'
    if(present(interp_method)) method = interp_method

    select case (trim(method))
    case ("conservative")
       Interp%interp_method = CONSERVE
       call horiz_interp_conserve_new ( Interp, lon_in, lat_in, lon_out, lat_out, verbose)
    case ("bilinear")
       Interp%interp_method = BILINEAR
       center = .false.
       if(present(grid_at_center) ) center = grid_at_center
       if(center) then
          nlon_out = size(lon_out(:)); nlat_out = size(lat_out(:))
          allocate(lon_dst(nlon_out,nlat_out), lat_dst(nlon_out,nlat_out))
          do i = 1, nlon_out
             lon_dst(i,:) = lon_out(i)
          enddo
          do j = 1, nlat_out
             lat_dst(:,j) = lat_out(j)
          enddo

          call horiz_interp_bilinear_new ( Interp, lon_in, lat_in, lon_dst, lat_dst, &
               verbose, src_modulo)
          deallocate(lon_dst, lat_dst)
       else
          nlon_in  = size(lon_in(:))-1;  nlat_in  = size(lat_in(:))-1
          nlon_out = size(lon_out(:))-1; nlat_out = size(lat_out(:))-1
          allocate(lon_src_1d(nlon_in), lat_src_1d(nlat_in))
          allocate(lon_dst(nlon_out,nlat_out), lat_dst(nlon_out,nlat_out))
          do i = 1, nlon_in
             lon_src_1d(i) = (lon_in(i) + lon_in(i+1)) * 0.5
          enddo
          do j = 1, nlat_in
             lat_src_1d(j) = (lat_in(j) + lat_in(j+1)) * 0.5
          enddo
          do i = 1, nlon_out
             lon_dst(i,:) = (lon_out(i) + lon_out(i+1)) * 0.5
          enddo
          do j = 1, nlat_out
             lat_dst(:,j) = (lat_out(j) + lat_out(j+1)) * 0.5
          enddo
          call horiz_interp_bilinear_new ( Interp, lon_src_1d, lat_src_1d, lon_dst, lat_dst, &
               verbose, src_modulo)
          deallocate(lon_src_1d, lat_src_1d, lon_dst, lat_dst)
       endif
    case ("bicubic")
       Interp%interp_method = BICUBIC
       center = .false.
       if(present(grid_at_center) ) center = grid_at_center
       !No need to expand to 2d, horiz_interp_bicubic_new does 1d-1d
       if(center) then 
          call horiz_interp_bicubic_new ( Interp, lon_in, lat_in, lon_out, lat_out, &
            verbose, src_modulo)
       else
          nlon_in  = size(lon_in(:))-1;  nlat_in  = size(lat_in(:))-1
          nlon_out = size(lon_out(:))-1; nlat_out = size(lat_out(:))-1
          allocate(lon_src_1d(nlon_in), lat_src_1d(nlat_in))
          allocate(lon_dst_1d(nlon_out), lat_dst_1d(nlat_out))
          do i = 1, nlon_in
             lon_src_1d(i) = (lon_in(i) + lon_in(i+1)) * 0.5
          enddo
          do j = 1, nlat_in
             lat_src_1d(j) = (lat_in(j) + lat_in(j+1)) * 0.5
          enddo
          do i = 1, nlon_out
             lon_dst_1d(i) = (lon_out(i) + lon_out(i+1)) * 0.5
          enddo
          do j = 1, nlat_out
             lat_dst_1d(j) = (lat_out(j) + lat_out(j+1)) * 0.5
          enddo
          call horiz_interp_bicubic_new ( Interp, lon_src_1d, lat_src_1d, lon_dst_1d, lat_dst_1d, &
               verbose, src_modulo)
          deallocate(lon_src_1d, lat_src_1d, lon_dst_1d, lat_dst_1d)
       endif
    case ("spherical")
       Interp%interp_method = SPHERICA
       nlon_in  = size(lon_in(:));   nlat_in  = size(lat_in(:))
       nlon_out  = size(lon_out(:)); nlat_out = size(lat_out(:))
       allocate(lon_src(nlon_in,nlat_in), lat_src(nlon_in,nlat_in))
       allocate(lon_dst(nlon_out,nlat_out), lat_dst(nlon_out,nlat_out))
       do i = 1, nlon_in
          lon_src(i,:) = lon_in(i)
       enddo
       do j = 1, nlat_in
          lat_src(:,j) = lat_in(j)
       enddo
       do i = 1, nlon_out
          lon_dst(i,:) = lon_out(i)
       enddo
       do j = 1, nlat_out
          lat_dst(:,j) = lat_out(j)
       enddo
       call horiz_interp_spherical_new ( Interp, lon_src, lat_src, lon_dst, lat_dst, &
            num_nbrs, max_dist, src_modulo)
       deallocate(lon_src, lat_src, lon_dst, lat_dst)
    case default
       call mpp_error(FATAL,'horiz_interp_mod: interp_method should be conservative, bilinear, bicubic, spherical')
    end select

    !-----------------------------------------------------------------------
    Interp%I_am_initialized = .true.

  end subroutine horiz_interp_new_1d
!  </SUBROUTINE>

!#######################################################################

 subroutine horiz_interp_new_1d_src (Interp, lon_in, lat_in, lon_out, lat_out,   &
                                     verbose, interp_method, num_nbrs, max_dist, &
                                     src_modulo, grid_at_center, mask_in, mask_out, is_latlon_out )

   type(horiz_interp_type), intent(inout)        :: Interp
   real, intent(in),  dimension(:)               :: lon_in , lat_in
   real, intent(in),  dimension(:,:)             :: lon_out, lat_out
   integer, intent(in),                 optional :: verbose
   character(len=*), intent(in),        optional :: interp_method
   integer, intent(in),                 optional :: num_nbrs  ! minimum number of neighbors
   real,    intent(in),                 optional :: max_dist
   logical, intent(in),                 optional :: src_modulo
   logical, intent(in),                 optional :: grid_at_center
   real, intent(in), dimension(:,:),    optional :: mask_in
   real, intent(out),dimension(:,:),    optional :: mask_out
   logical, intent(in),                 optional :: is_latlon_out

   real, dimension(:,:), allocatable :: lon_src, lat_src
   real, dimension(:),   allocatable :: lon_src_1d, lat_src_1d
   integer                           :: i, j, nlon_in, nlat_in
   character(len=40)                 :: method
   logical                           :: center
   logical                           :: dst_is_latlon
   !-----------------------------------------------------------------------
   call horiz_interp_init

   method = 'conservative'
   if(present(interp_method)) method = interp_method

   select case (trim(method))
   case ("conservative")
      Interp%interp_method = CONSERVE
      !--- check to see if the source grid is regular lat-lon grid or not.
      if(PRESENT(is_latlon_out)) then
         dst_is_latlon = is_latlon_out
      else
         dst_is_latlon = is_lat_lon(lon_out, lat_out) 
      end if
      if(dst_is_latlon ) then
         if(present(mask_in)) then
            if ( ANY(mask_in < -.0001) .or. ANY(mask_in > 1.0001)  ) call mpp_error(FATAL, &
                  'horiz_interp_conserve_new_1d_src(horiz_interp_conserve_mod): input mask not between 0,1')
            allocate(Interp%mask_in(size(mask_in,1), size(mask_in,2)) )
            Interp%mask_in = mask_in
         end if
         call horiz_interp_conserve_new ( Interp, lon_in, lat_in, lon_out(:,1), lat_out(1,:), &
              verbose=verbose )
      else
         call horiz_interp_conserve_new ( Interp, lon_in, lat_in, lon_out, lat_out, &
              verbose=verbose, mask_in=mask_in, mask_out=mask_out )
      end if
   case ("bilinear")
      Interp%interp_method = BILINEAR
      center = .false.
      if(present(grid_at_center) ) center = grid_at_center
      if(center) then
         call horiz_interp_bilinear_new ( Interp, lon_in, lat_in, lon_out, lat_out, &
              verbose, src_modulo )
      else
         nlon_in  = size(lon_in(:))-1;  nlat_in  = size(lat_in(:))-1
         allocate(lon_src_1d(nlon_in), lat_src_1d(nlat_in))
         do i = 1, nlon_in
            lon_src_1d(i) = (lon_in(i) + lon_in(i+1)) * 0.5
         enddo
         do j = 1, nlat_in
            lat_src_1d(j) = (lat_in(j) + lat_in(j+1)) * 0.5
         enddo
         call horiz_interp_bilinear_new ( Interp, lon_src_1d, lat_src_1d, lon_out, lat_out, &
              verbose, src_modulo )
         deallocate(lon_src_1d,lat_src_1d)
      endif
   case ("bicubic")
      Interp%interp_method = BICUBIC
      center = .false.
      if(present(grid_at_center) ) center = grid_at_center
      if(center) then
        call horiz_interp_bicubic_new ( Interp, lon_in, lat_in, lon_out, lat_out, &
              verbose, src_modulo )
      else
         nlon_in  = size(lon_in(:))-1;  nlat_in  = size(lat_in(:))-1
         allocate(lon_src_1d(nlon_in), lat_src_1d(nlat_in))
         do i = 1, nlon_in
            lon_src_1d(i) = (lon_in(i) + lon_in(i+1)) * 0.5
         enddo
         do j = 1, nlat_in
            lat_src_1d(j) = (lat_in(j) + lat_in(j+1)) * 0.5
         enddo
           call horiz_interp_bicubic_new ( Interp, lon_src_1d, lat_src_1d, lon_out, lat_out, &
              verbose, src_modulo )
         deallocate(lon_src_1d,lat_src_1d)
      endif
   case ("spherical")
      Interp%interp_method = SPHERICA
      nlon_in  = size(lon_in(:));  nlat_in  = size(lat_in(:))
      allocate(lon_src(nlon_in,nlat_in), lat_src(nlon_in,nlat_in))
      do i = 1, nlon_in
         lon_src(i,:) = lon_in(i)
      enddo
      do j = 1, nlat_in
         lat_src(:,j) = lat_in(j)
      enddo
      call horiz_interp_spherical_new ( Interp, lon_src, lat_src, lon_out, lat_out, &
           num_nbrs, max_dist, src_modulo)
      deallocate(lon_src, lat_src)
   case default
      call mpp_error(FATAL,'interp_method should be conservative, bilinear, bicubic, spherical')
   end select

   !-----------------------------------------------------------------------
   Interp%I_am_initialized = .true.

 end subroutine horiz_interp_new_1d_src

!#######################################################################

 subroutine horiz_interp_new_2d (Interp, lon_in, lat_in, lon_out, lat_out,   &
                                 verbose, interp_method, num_nbrs, max_dist, &
                                 src_modulo, mask_in, mask_out, is_latlon_in, is_latlon_out  )
 type(horiz_interp_type), intent(inout)     :: Interp
 real, intent(in),  dimension(:,:)          :: lon_in , lat_in
 real, intent(in),  dimension(:,:)          :: lon_out, lat_out
 integer, intent(in),              optional :: verbose
 character(len=*), intent(in),     optional :: interp_method
 integer, intent(in),              optional :: num_nbrs
 real,    intent(in),              optional :: max_dist
 logical, intent(in),              optional :: src_modulo
 real, intent(in), dimension(:,:), optional :: mask_in
 real, intent(out),dimension(:,:), optional :: mask_out
 logical, intent(in),              optional :: is_latlon_in, is_latlon_out
 logical           :: src_is_latlon, dst_is_latlon
 character(len=40) :: method
!-----------------------------------------------------------------------
   call horiz_interp_init

   method = 'bilinear'
   if(present(interp_method)) method = interp_method

   select case (trim(method))
   case ("conservative")
      Interp%interp_method = CONSERVE
      if(PRESENT(is_latlon_in)) then
         src_is_latlon = is_latlon_in
      else
         src_is_latlon = is_lat_lon(lon_in, lat_in)
      end if
      if(PRESENT(is_latlon_out)) then
         dst_is_latlon = is_latlon_out
      else
         dst_is_latlon = is_lat_lon(lon_out, lat_out)
      end if
      if(src_is_latlon .AND. dst_is_latlon) then
         if(present(mask_in)) then
            if ( ANY(mask_in < -.0001) .or. ANY(mask_in > 1.0001)  ) call mpp_error(FATAL, &
              'horiz_interp_conserve_new_2d(horiz_interp_conserve_mod): input mask not between 0,1')
            allocate(Interp%mask_in(size(mask_in,1), size(mask_in,2)) )
            Interp%mask_in = mask_in
         end if
         call horiz_interp_conserve_new ( Interp, lon_in(:,1), lat_in(1,:), lon_out(:,1), lat_out(1,:), &
              verbose=verbose )
      else if(src_is_latlon) then
         call horiz_interp_conserve_new ( Interp, lon_in(:,1), lat_in(1,:), lon_out, lat_out, &
              verbose=verbose, mask_in=mask_in, mask_out=mask_out )
      else if(dst_is_latlon) then
         call horiz_interp_conserve_new ( Interp, lon_in, lat_in, lon_out(:,1), lat_out(1,:), &
              verbose=verbose, mask_in=mask_in, mask_out=mask_out )
      else 
         call horiz_interp_conserve_new ( Interp, lon_in, lat_in, lon_out, lat_out, &
              verbose=verbose, mask_in=mask_in, mask_out=mask_out )
      end if

   case ("spherical") 
      Interp%interp_method = SPHERICA
      call horiz_interp_spherical_new ( Interp, lon_in, lat_in, lon_out, lat_out, &
                                    num_nbrs, max_dist, src_modulo )
   case ("bilinear")
      Interp%interp_method = BILINEAR
      call horiz_interp_bilinear_new ( Interp, lon_in, lat_in, lon_out, lat_out, &
                                        verbose, src_modulo )
   case default
      call mpp_error(FATAL,'when source grid are 2d, interp_method should be spherical or bilinear')
   end select     

!-----------------------------------------------------------------------
   Interp%I_am_initialized = .true.

 end subroutine horiz_interp_new_2d

!#######################################################################
 subroutine horiz_interp_new_1d_dst (Interp, lon_in, lat_in, lon_out, lat_out,   &
      verbose, interp_method, num_nbrs, max_dist, src_modulo, mask_in, mask_out, is_latlon_in )
   type(horiz_interp_type), intent(inout)     :: Interp
   real, intent(in),  dimension(:,:)          :: lon_in , lat_in
   real, intent(in),  dimension(:)            :: lon_out, lat_out
   integer, intent(in),              optional :: verbose
   character(len=*), intent(in),     optional :: interp_method
   integer, intent(in),              optional :: num_nbrs
   real,    intent(in),              optional :: max_dist
   logical, intent(in),              optional :: src_modulo
   real, intent(in), dimension(:,:), optional :: mask_in
   real, intent(out),dimension(:,:), optional :: mask_out
   logical, intent(in),              optional :: is_latlon_in

   character(len=40) :: method
   !-------------some local variables-----------------------------------------------
   integer                           :: i, j, nlon_out, nlat_out
   real, dimension(:,:), allocatable :: lon_dst, lat_dst
   logical                           :: src_is_latlon
   !-----------------------------------------------------------------------
   call horiz_interp_init

   method = 'bilinear'
   if(present(interp_method)) method = interp_method

   nlon_out = size(lon_out(:)); nlat_out = size(lat_out(:))
   allocate(lon_dst(nlon_out,nlat_out), lat_dst(nlon_out,nlat_out))
   do i = 1, nlon_out
      lon_dst(i,:) = lon_out(i)
   enddo
   do j = 1, nlat_out
      lat_dst(:,j) = lat_out(j)
   enddo

   select case (trim(method))
   case ("conservative")
      Interp%interp_method = CONSERVE
      if(PRESENT(is_latlon_in)) then
         src_is_latlon = is_latlon_in
      else
         src_is_latlon = is_lat_lon(lon_in, lat_in)
      end if      

      if(src_is_latlon) then
         if(present(mask_in)) then
            if ( ANY(mask_in < -.0001) .or. ANY(mask_in > 1.0001)  ) call mpp_error(FATAL, &
              'horiz_interp_conserve_new_1d_dst(horiz_interp_conserve_mod): input mask not between 0,1')
            allocate(Interp%mask_in(size(mask_in,1), size(mask_in,2)) )
            Interp%mask_in = mask_in
         end if
         call horiz_interp_conserve_new ( Interp, lon_in(:,1), lat_in(1,:), lon_out, lat_out, &
              verbose=verbose)
      else
         call horiz_interp_conserve_new ( Interp, lon_in, lat_in, lon_out, lat_out, &
              verbose=verbose, mask_in=mask_in, mask_out=mask_out )
      end if
   case ("bilinear")
      Interp%interp_method = BILINEAR
      call horiz_interp_bilinear_new ( Interp, lon_in, lat_in, lon_dst, lat_dst, &
           verbose, src_modulo )
   case ("spherical")
      Interp%interp_method = SPHERICA
      call horiz_interp_spherical_new ( Interp, lon_in, lat_in, lon_dst, lat_dst, &
           num_nbrs, max_dist, src_modulo)
   case default
      call mpp_error(FATAL,'when source grid are 2d, interp_method should be spherical or bilinear')
   end select

   deallocate(lon_dst,lat_dst)

   !-----------------------------------------------------------------------
   Interp%I_am_initialized = .true.

 end subroutine horiz_interp_new_1d_dst

!#######################################################################
! <SUBROUTINE NAME="horiz_interp_base_2d" INTERFACE="horiz_interp">
!   <IN NAME="Interp" TYPE="type(horiz_interp_type)"> </IN>
!   <IN NAME="data_in" TYPE="real" DIM="(:,:),(:,:,:)"> </IN>
!   <IN NAME="lon_in, lat_in" TYPE="real" DIM="(:),(:,:)"> </IN>
!   <IN NAME="lon_out, lat_out" TYPE="real" DIM="(:),(:,:)"> </IN>
!   <IN NAME="missing_value" TYPE="integer, optional" > </IN>
!   <IN NAME="missing_permit" TYPE="integer,optional" > </IN>
!   <IN NAME="verbose" TYPE="integer,optional"> </IN>
!   <IN NAME="mask_in" TYPE="real,optional" DIM="(:,:),(:,:,:)"> </IN>
!   <OUT NAME="data_out" TYPE="real" DIM="(:,:),(:,:,:)"> </OUT>
!   <OUT NAME="mask_out" TYPE="real,optional" DIM="(:,:),(:,:,:)"> </OUT>

!<PUBLICROUTINE INTERFACE="horiz_interp"> 
 subroutine horiz_interp_base_2d ( Interp, data_in, data_out, verbose, &
                                   mask_in, mask_out, missing_value, missing_permit, &
                                   err_msg, new_missing_handle )
!</PUBLICROUTINE>
!-----------------------------------------------------------------------
   type (horiz_interp_type), intent(in) :: Interp
      real, intent(in),  dimension(:,:) :: data_in
      real, intent(out), dimension(:,:) :: data_out
   integer, intent(in),                   optional :: verbose
      real, intent(in),   dimension(:,:), optional :: mask_in
      real, intent(out),  dimension(:,:), optional :: mask_out
      real, intent(in),                   optional :: missing_value
      integer, intent(in),                optional :: missing_permit
   character(len=*), intent(out),         optional :: err_msg
      logical, intent(in),                optional :: new_missing_handle
!-----------------------------------------------------------------------
   if(present(err_msg)) err_msg = ''
   if(.not.Interp%I_am_initialized) then
     if(fms_error_handler('horiz_interp','The horiz_interp_type variable is not initialized',err_msg)) return
   endif

   select case(Interp%interp_method)
   case(CONSERVE)
      call horiz_interp_conserve(Interp,data_in, data_out, verbose, mask_in, mask_out)
   case(BILINEAR)
      call horiz_interp_bilinear(Interp,data_in, data_out, verbose, mask_in, mask_out, &
                             missing_value, missing_permit, new_missing_handle )
   case(BICUBIC)
      call horiz_interp_bicubic(Interp,data_in, data_out, verbose, mask_in, mask_out, &
                             missing_value, missing_permit )
   case(SPHERICA)
      call horiz_interp_spherical(Interp,data_in, data_out, verbose, mask_in, mask_out, &
                             missing_value )
   case default
      call mpp_error(FATAL,'interp_method should be conservative, bilinear, bicubic, spherical')
   end select

   return

 end subroutine horiz_interp_base_2d
! </SUBROUTINE>

!#######################################################################

 subroutine horiz_interp_base_3d ( Interp, data_in, data_out, verbose, mask_in, mask_out, &
      missing_value, missing_permit, err_msg  )
   !-----------------------------------------------------------------------
   !   overload of interface horiz_interp_base_2d
   !   uses 3d arrays for data and mask
   !   this allows for multiple interpolations with one call
   !-----------------------------------------------------------------------
   type (horiz_interp_type), intent(in)           :: Interp
   real, intent(in),  dimension(:,:,:)            :: data_in
   real, intent(out), dimension(:,:,:)            :: data_out
   integer, intent(in),                  optional :: verbose
   real, intent(in),   dimension(:,:,:), optional :: mask_in
   real, intent(out),  dimension(:,:,:), optional :: mask_out
   real, intent(in),                     optional :: missing_value
   integer, intent(in),                  optional :: missing_permit
   character(len=*), intent(out),        optional :: err_msg
   !-----------------------------------------------------------------------
   integer :: n

   if(present(err_msg)) err_msg = ''
   if(.not.Interp%I_am_initialized) then          
     if(fms_error_handler('horiz_interp','The horiz_interp_type variable is not initialized',err_msg)) return
   endif

   do n = 1, size(data_in,3)
      if (present(mask_in))then
         if(present(mask_out)) then
            call horiz_interp_base_2d ( Interp, data_in(:,:,n), data_out(:,:,n), &
                 verbose, mask_in(:,:,n), mask_out(:,:,n), &
                 missing_value, missing_permit )
         else
            call horiz_interp_base_2d ( Interp, data_in(:,:,n), data_out(:,:,n), &
                 verbose, mask_in(:,:,n), missing_value = missing_value,  &
                 missing_permit = missing_permit )
         endif
      else
         if(present(mask_out)) then
            call horiz_interp_base_2d ( Interp, data_in(:,:,n), data_out(:,:,n), &
                 verbose, mask_out=mask_out(:,:,n), missing_value = missing_value,  &
                 missing_permit = missing_permit )
         else
            call horiz_interp_base_2d ( Interp, data_in(:,:,n), data_out(:,:,n), &
                 verbose, missing_value = missing_value,  &
                 missing_permit = missing_permit )
         endif
     endif
   enddo
  
   return
!-----------------------------------------------------------------------
 end subroutine horiz_interp_base_3d

!#######################################################################
!<PUBLICROUTINE INTERFACE="horiz_interp"> 
 subroutine horiz_interp_solo_1d ( data_in, lon_in, lat_in, lon_out, lat_out,    &
                                   data_out, verbose, mask_in, mask_out,         &
                                   interp_method, missing_value, missing_permit, &
                                   num_nbrs, max_dist,src_modulo, grid_at_center  )              
!</PUBLICROUTINE>
!-----------------------------------------------------------------------
!   interpolates from a rectangular grid to rectangular grid.
!   interp_method can be the value conservative, bilinear or spherical.
!   horiz_interp_new don't need to be called before calling this routine.

!-----------------------------------------------------------------------
      real, intent(in),  dimension(:,:) :: data_in
      real, intent(in),  dimension(:)   :: lon_in , lat_in
      real, intent(in),  dimension(:)   :: lon_out, lat_out
      real, intent(out), dimension(:,:) :: data_out
   integer, intent(in),                   optional :: verbose
      real, intent(in),   dimension(:,:), optional :: mask_in
      real, intent(out),  dimension(:,:), optional :: mask_out
   character(len=*), intent(in),          optional :: interp_method
      real, intent(in),                   optional :: missing_value
   integer, intent(in),                   optional :: missing_permit
   integer, intent(in),                   optional :: num_nbrs
      real, intent(in),                   optional :: max_dist
   logical, intent(in),                   optional :: src_modulo
   logical, intent(in),                   optional :: grid_at_center
!-----------------------------------------------------------------------
    type (horiz_interp_type) :: Interp
!-----------------------------------------------------------------------
    call horiz_interp_init

    call horiz_interp_new ( Interp, lon_in, lat_in, lon_out, lat_out, verbose, &
                             interp_method, num_nbrs, max_dist, src_modulo, grid_at_center )

    call horiz_interp ( Interp, data_in, data_out, verbose,   &
                        mask_in, mask_out, missing_value, missing_permit )

    call horiz_interp_del ( Interp )
!-----------------------------------------------------------------------

 end subroutine horiz_interp_solo_1d

!#######################################################################

 subroutine horiz_interp_solo_1d_src ( data_in, lon_in, lat_in, lon_out, lat_out,    &
                                       data_out, verbose, mask_in, mask_out,         &
                                       interp_method, missing_value, missing_permit, &
                                       num_nbrs, max_dist, src_modulo, grid_at_center )
!-----------------------------------------------------------------------
!
!   interpolates from a uniformly spaced grid to any output grid.
!   interp_method can be the value "onservative","bilinear" or "spherical".
!   horiz_interp_new don't need to be called before calling this routine.
!
!-----------------------------------------------------------------------
      real, intent(in),  dimension(:,:) :: data_in
      real, intent(in),  dimension(:)   :: lon_in , lat_in
      real, intent(in),  dimension(:,:) :: lon_out, lat_out
      real, intent(out), dimension(:,:) :: data_out
   integer, intent(in),                   optional :: verbose
      real, intent(in),   dimension(:,:), optional :: mask_in
      real, intent(out),  dimension(:,:), optional :: mask_out
   character(len=*), intent(in),          optional :: interp_method
      real, intent(in),                   optional :: missing_value
   integer, intent(in),                   optional :: missing_permit
   integer, intent(in),                   optional :: num_nbrs
      real, intent(in),                   optional :: max_dist
   logical, intent(in),                   optional :: src_modulo
   logical, intent(in),                   optional :: grid_at_center

!-----------------------------------------------------------------------
   type (horiz_interp_type) :: Interp
   logical                  :: dst_is_latlon
   character(len=128)       :: method
!-----------------------------------------------------------------------
    call horiz_interp_init
    method = 'conservative'
    if(present(interp_method)) method = interp_method
    dst_is_latlon = .true.
    if(trim(method) == 'conservative') dst_is_latlon = is_lat_lon(lon_out, lat_out)

    if(dst_is_latlon) then
       call horiz_interp_new ( Interp, lon_in, lat_in, lon_out, lat_out, verbose, &
                               interp_method, num_nbrs, max_dist, src_modulo,    &
                               grid_at_center, is_latlon_out = dst_is_latlon )
       call horiz_interp ( Interp, data_in, data_out, verbose,   &
                           mask_in, mask_out, missing_value, missing_permit )
    else
       call horiz_interp_new ( Interp, lon_in, lat_in, lon_out, lat_out, verbose, &
                               interp_method, num_nbrs, max_dist, src_modulo,    &
                               grid_at_center, mask_in, mask_out, is_latlon_out = dst_is_latlon)

       call horiz_interp ( Interp, data_in, data_out, verbose,   &
                           missing_value=missing_value, missing_permit=missing_permit )
    end if

    call horiz_interp_del ( Interp )

!-----------------------------------------------------------------------

 end subroutine horiz_interp_solo_1d_src


!#######################################################################

 subroutine horiz_interp_solo_2d ( data_in, lon_in, lat_in, lon_out, lat_out, data_out, &
                                   verbose, mask_in, mask_out, interp_method, missing_value,&
                                   missing_permit, num_nbrs, max_dist, src_modulo  )
!-----------------------------------------------------------------------
!
!   interpolates from any grid to any grid. interp_method should be "spherical"
!   horiz_interp_new don't need to be called before calling this routine.
!
!-----------------------------------------------------------------------
      real, intent(in),  dimension(:,:) :: data_in
      real, intent(in),  dimension(:,:) :: lon_in , lat_in
      real, intent(in),  dimension(:,:) :: lon_out, lat_out
      real, intent(out), dimension(:,:) :: data_out
   integer, intent(in),                   optional :: verbose
      real, intent(in),   dimension(:,:), optional :: mask_in
      real, intent(out),  dimension(:,:), optional :: mask_out
   character(len=*), intent(in),          optional :: interp_method
      real, intent(in),                   optional :: missing_value
   integer, intent(in),                   optional :: missing_permit
   integer, intent(in),                   optional :: num_nbrs
      real, intent(in),                   optional :: max_dist
   logical, intent(in),                   optional :: src_modulo
!-----------------------------------------------------------------------
   type (horiz_interp_type) :: Interp
   logical                  :: dst_is_latlon, src_is_latlon
   character(len=128)       :: method
!-----------------------------------------------------------------------
    call horiz_interp_init

    method = 'conservative'
    if(present(interp_method)) method = interp_method
    dst_is_latlon = .true.
    src_is_latlon = .true.
    if(trim(method) == 'conservative') then
       dst_is_latlon = is_lat_lon(lon_out, lat_out)
       src_is_latlon = is_lat_lon(lon_in, lat_in)
    end if

    if(dst_is_latlon .and. src_is_latlon) then
       call horiz_interp_new ( Interp, lon_in, lat_in, lon_out, lat_out, verbose, &
                               interp_method, num_nbrs, max_dist, src_modulo,    &
                               is_latlon_in=dst_is_latlon, is_latlon_out = dst_is_latlon )
       call horiz_interp ( Interp, data_in, data_out, verbose,   &
                           mask_in, mask_out, missing_value, missing_permit )
    else
       call horiz_interp_new ( Interp, lon_in, lat_in, lon_out, lat_out, verbose, &
                               interp_method, num_nbrs, max_dist, src_modulo,    &
                               mask_in, mask_out, &
                               is_latlon_in=dst_is_latlon, is_latlon_out = dst_is_latlon)
       call horiz_interp ( Interp, data_in, data_out, verbose,   &
                           missing_value=missing_value, missing_permit=missing_permit )
    end if

    call horiz_interp_del ( Interp )

!-----------------------------------------------------------------------

 end subroutine horiz_interp_solo_2d

!#######################################################################

 subroutine horiz_interp_solo_1d_dst ( data_in, lon_in, lat_in, lon_out, lat_out, data_out,    &
                                       verbose, mask_in, mask_out,interp_method,missing_value, &
                                       missing_permit,  num_nbrs, max_dist, src_modulo)
!-----------------------------------------------------------------------
!
!   interpolates from any grid to rectangular longitude/latitude grid. 
!   interp_method should be "spherical".
!   horiz_interp_new don't need to be called before calling this routine.
!
!-----------------------------------------------------------------------
      real, intent(in),  dimension(:,:) :: data_in
      real, intent(in),  dimension(:,:) :: lon_in , lat_in
      real, intent(in),  dimension(:)   :: lon_out, lat_out
      real, intent(out), dimension(:,:) :: data_out
   integer, intent(in),                   optional :: verbose  
      real, intent(in),   dimension(:,:), optional :: mask_in
      real, intent(out),  dimension(:,:), optional :: mask_out
   character(len=*), intent(in),          optional :: interp_method
      real, intent(in),                   optional :: missing_value
   integer, intent(in),                   optional :: missing_permit
   integer, intent(in),                   optional :: num_nbrs
      real, intent(in),                   optional :: max_dist
   logical, intent(in),                   optional :: src_modulo
!-----------------------------------------------------------------------
   type (horiz_interp_type) :: Interp
   logical                  :: src_is_latlon
   character(len=128)       :: method
!-----------------------------------------------------------------------
    call horiz_interp_init

    method = 'conservative'
    if(present(interp_method)) method = interp_method
    src_is_latlon = .true.
    if(trim(method) == 'conservative') src_is_latlon = is_lat_lon(lon_in, lat_in)

    if(src_is_latlon) then
       call horiz_interp_new ( Interp, lon_in, lat_in, lon_out, lat_out, verbose, &
                               interp_method, num_nbrs, max_dist, src_modulo,    &
                               is_latlon_in = src_is_latlon )
       call horiz_interp ( Interp, data_in, data_out, verbose,   &
                           mask_in, mask_out, missing_value, missing_permit )
    else
       call horiz_interp_new ( Interp, lon_in, lat_in, lon_out, lat_out, verbose, &
                               interp_method, num_nbrs, max_dist, src_modulo,    &
                               mask_in, mask_out, is_latlon_in = src_is_latlon)

       call horiz_interp ( Interp, data_in, data_out, verbose,   &
                           missing_value=missing_value, missing_permit=missing_permit )
    end if

    call horiz_interp_del ( Interp )

!-----------------------------------------------------------------------

 end subroutine horiz_interp_solo_1d_dst

!#######################################################################

 subroutine horiz_interp_solo_old (data_in, wb, sb, dx, dy,  &
                                   lon_out, lat_out, data_out,  &
                                   verbose, mask_in, mask_out)

!-----------------------------------------------------------------------
!       Overloaded version of interface horiz_interp_solo_2
!
! input
!
!   data_in     Global input data stored from west to east (first dimension),
!               south to north (second dimension).  [real, dimension(:,:)]
!
!   wb          Longitude (in radians) that corresponds to western-most
!               boundary of grid box i=1 in array data_in.  [real]
!
!   sb          Latitude (in radians) that corresponds to southern-most
!               boundary of grid box j=1 in array data_in.  [real]
!
!   dx          Grid spacing (in radians) for the longitude axis (first
!               dimension) for the input data.  [real]
!
!   dy          Grid spacing (in radians) for the latitude axis (second
!               dimension) for the input data.  [real]
!
!   lon_out    The longitude edges (in radians) for output data grid boxes.
!               The values are for adjacent grid boxes and must increase in
!               value. If there are MLON grid boxes there must be MLON+1
!               edge values.  [real, dimension(:)]
!
!   lat_out    The latitude edges (in radians) for output data grid boxes.
!               The values are for adjacent grid boxes and may increase or
!               decrease in value. If there are NLAT grid boxes there must
!               be NLAT+1 edge values.  [real, dimension(:)]
!
! OUTPUT
!   data_out    Output data on the output grid defined by grid box
!               edges: blon_out and blat_out.  [real, dimension(:,:)]
!
!-----------------------------------------------------------------------
      real, intent(in),  dimension(:,:) :: data_in
      real, intent(in)                  :: wb, sb, dx, dy
      real, intent(in),  dimension(:)   :: lon_out, lat_out
      real, intent(out), dimension(:,:) :: data_out
   integer, intent(in),                   optional :: verbose
      real, intent(in),   dimension(:,:), optional :: mask_in
      real, intent(out),  dimension(:,:), optional :: mask_out
!-----------------------------------------------------------------------
     real, dimension(size(data_in,1)+1)  :: blon_in
     real, dimension(size(data_in,2)+1)  :: blat_in
     integer :: i, j, nlon_in, nlat_in
     real    :: tpi
!-----------------------------------------------------------------------
   call horiz_interp_init
 
   tpi = 2.*pi
   nlon_in = size(data_in,1)
   nlat_in = size(data_in,2)

   do i = 1, nlon_in+1
      blon_in(i) = wb + float(i-1)*dx
   enddo
      if (abs(blon_in(nlon_in+1)-blon_in(1)-tpi) < epsilon(blon_in)) &
              blon_in(nlon_in+1)=blon_in(1)+tpi

   do j = 2, nlat_in
      blat_in(j) = sb + float(j-1)*dy
   enddo
      blat_in(1)         = -0.5*pi
      blat_in(nlat_in+1) =  0.5*pi


   call horiz_interp_solo_1d (data_in, blon_in, blat_in,    &
                              lon_out, lat_out, data_out,   &
                              verbose, mask_in, mask_out    )

!-----------------------------------------------------------------------

 end subroutine horiz_interp_solo_old

!#######################################################################
! <SUBROUTINE NAME="horiz_interp_del">

!   <OVERVIEW>
!     Deallocates memory used by "horiz_interp_type" variables.
!       Must be called before reinitializing with horiz_interp_new.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Deallocates memory used by "horiz_interp_type" variables.
!     Must be called before reinitializing with horiz_interp_new.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call horiz_interp_del ( Interp )
!   </TEMPLATE>

!   <INOUT NAME="Interp" TYPE="horiz_interp_type">
!     A derived-type variable returned by previous call
!              to horiz_interp_new. The input variable must have
!              allocated arrays. The returned variable will contain
!              deallocated arrays.
!   </INOUT>

! </SUBROUTINE>

 subroutine horiz_interp_del ( Interp )

   type (horiz_interp_type), intent(inout) :: Interp

!-----------------------------------------------------------------------
!  releases space used by horiz_interp_type variables
!  must be called before re-initializing the same variable
!-----------------------------------------------------------------------
   select case(Interp % interp_method) 
   case (CONSERVE)
      call horiz_interp_conserve_del(Interp )
   case (BILINEAR)
      call horiz_interp_bilinear_del(Interp )
   case (BICUBIC)
      call horiz_interp_bicubic_del(Interp )
   case (SPHERICA)
      call horiz_interp_spherical_del(Interp )
   end select

   Interp%I_am_initialized = .false.
!-----------------------------------------------------------------------

 end subroutine horiz_interp_del

 !#####################################################################

! <SUBROUTINE NAME="horiz_interp_end">

!   <OVERVIEW>
!     Dummy routine.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Dummy routine.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call horiz_interp_end
!   </TEMPLATE>

! </SUBROUTINE>

 subroutine horiz_interp_end
 return
 end subroutine horiz_interp_end

 !####################################################################
 function is_lat_lon(lon, lat)
    real, dimension(:,:), intent(in) :: lon, lat
    logical                          :: is_lat_lon
    integer                          :: i, j, nlon, nlat, num

    is_lat_lon = .true.
    nlon = size(lon,1)
    nlat = size(lon,2)
    LOOP_LAT: do j = 1, nlat
       do i = 2, nlon
          if(lat(i,j) .NE. lat(1,j)) then
             is_lat_lon = .false.
             exit LOOP_LAT
          end if
       end do
    end do LOOP_LAT

    if(is_lat_lon) then
       LOOP_LON: do i = 1, nlon
          do j = 2, nlat
             if(lon(i,j) .NE. lon(i,1)) then
                is_lat_lon = .false.
                exit LOOP_LON
             end if
          end do
       end do LOOP_LON
    end if

    num = 0
    if(is_lat_lon) num = 1
    call mpp_min(num)
    if(num == 1) then
       is_lat_lon = .true.
    else
       is_lat_lon = .false.
    end if

    return
 end function is_lat_lon

!#####################################################################

end module horiz_interp_mod

! <INFO>
!   <NOTE>             
!       Has not been checked with grids that do not cover the sphere.
!
!       Has not been checked with the optional mask arguments.
!
!       If a latitude or longitude index cannot be found the tolerance
!       used for making this determination may need to be increased.
!       This can be done by increasing the value of module variable
!       num_iters (default 4).
!   </NOTE>
!   <TESTPROGRAM>  
!     <PRE>
!       program test
!       use horiz_interp_mod
!       implicit none
!       integer, parameter :: nxi=177, nyi=91, nxo=133, nyo=77 ! resolution
!       real :: zi(nxi,nyi), zo(nxo,nyo)                       ! data
!       real :: xi(nxi+1), yi(nyi+1), xo(nxo+1), yo(nyo+1)     ! grid edges
!       real :: pi, tpi, hpi, dx, dy
!     
!       ! constants
!         hpi = acos(0.0)
!          pi = hpi*2.0
!         tpi = hpi*4.0
!     
!       ! grid setup: west to east, south to north
!         dx = tpi/real(nxi); call setaxis (0.,dx,xi);   xi(nxi+1) = xi(1)+tpi
!         dx = tpi/real(nxo); call setaxis (0.,dx,xo);   xo(nxo+1) = xo(1)+tpi
!         dy =  pi/real(nyi); call setaxis (-hpi,dy,yi); yi(nyi+1) = hpi
!         dy =  pi/real(nyo); call setaxis (-hpi,dy,yo); yo(nyo+1) = hpi
!     
!       ! random data on the input grid
!         call random_number (zi)
!     
!       ! interpolate (flipping y-axis)
!         call horiz_interp (zi(:,1:nyi:+1), xi, yi(1:nyi+1:+1), xo, yo(1:nyo+1:+1), zo, verbose=2)
!         call horiz_interp (zi(:,nyi:1:-1), xi, yi(nyi+1:1:-1), xo, yo(1:nyo+1:+1), zo, verbose=2)
!         call horiz_interp (zi(:,nyi:1:-1), xi, yi(nyi+1:1:-1), xo, yo(nyo+1:1:-1), zo, verbose=2)
!         call horiz_interp (zi(:,1:nyi:+1), xi, yi(1:nyi+1:+1), xo, yo(nyo+1:1:-1), zo, verbose=2)
!     
!       contains
!     ! set up a sequence of numbers
!         subroutine setaxis (xo,dx,x)
!         real, intent(in)  :: xo, dx
!         real, intent(out) :: x(:)
!         integer :: i
!           x(1) = xo
!           do i=2,size(x(:))
!             x(i) = x(i-1)+dx
!           enddo
!         end subroutine setaxis
!     
!       end program test
!     </PRE>
!   </TESTPROGRAM>
! </INFO>

#ifdef test_horiz_interp
! T More tests will be added in the future.
program horiz_interp_test

use mpp_mod,          only : mpp_init, mpp_exit, mpp_error, FATAL, stdout, mpp_npes
use mpp_mod,          only : mpp_clock_id, mpp_clock_begin, mpp_clock_end
use mpp_mod,          only : mpp_pe, mpp_root_pe, NOTE, MPP_CLOCK_SYNC, MPP_CLOCK_DETAILED
use mpp_mod,          only : input_nml_file
use mpp_io_mod,       only : mpp_io_init, mpp_io_exit
use mpp_domains_mod,  only : mpp_define_layout, mpp_define_domains, mpp_get_compute_domain
use mpp_domains_mod,  only : mpp_domains_init, domain2d
use fms_mod,          only : file_exist, open_namelist_file, close_file, check_nml_error
use horiz_interp_mod, only : horiz_interp_init, horiz_interp_new, horiz_interp_del
use horiz_interp_mod, only : horiz_interp, horiz_interp_type
use constants_mod,    only : constants_init, PI

implicit none

  integer :: ni_src = 360, nj_src = 180
  integer :: ni_dst = 144, nj_dst = 72

  namelist /test_horiz_interp_nml/ ni_src, nj_src, ni_dst, nj_dst

  real :: lon_src_beg = 0,    lon_src_end = 360
  real :: lat_src_beg = -90,  lat_src_end = 90
  real :: lon_dst_beg = -280, lon_dst_end = 80
  real :: lat_dst_beg = -90,  lat_dst_end = 90
  real :: D2R = PI/180.
  real, parameter :: SMALL = 1.0e-10

  type(domain2d)                    :: domain
  type(horiz_interp_type)           :: Interp
  integer                           :: id1, id2, id3, id4
  integer                           :: isc, iec, jsc, jec, i, j
  integer                           :: nml_unit, io, ierr, layout(2)
  real                              :: dlon_src, dlat_src, dlon_dst, dlat_dst
  real, allocatable, dimension(:)   :: lon1D_src, lat1D_src, lon1D_dst, lat1D_dst
  real, allocatable, dimension(:,:) :: lon2D_src, lat2D_src, lon2D_dst, lat2D_dst
  real, allocatable, dimension(:,:) :: data_src, data1_dst, data2_dst, data3_dst, data4_dst

  call constants_init
  call mpp_init
  call mpp_domains_init
  call mpp_io_init
  call horiz_interp_init

  !--- read namelist
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, test_horiz_interp_nml, iostat=io)
      ierr = check_nml_error(io, 'test_horiz_interp_nml')
#else
  if (file_exist('input.nml')) then
     ierr=1
     nml_unit = open_namelist_file()
     do while (ierr /= 0)
        read(nml_unit, nml=test_horiz_interp_nml, iostat=io, end=10)
        ierr = check_nml_error(io, 'test_horiz_interp_nml')
     enddo
10   call close_file(nml_unit)
  endif
#endif

  !--- define domains
  call mpp_define_layout( (/1, ni_dst, 1, nj_dst/), mpp_npes(), layout)
  call mpp_define_domains((/1, ni_dst, 1, nj_dst/), layout, domain)
  call mpp_get_compute_domain(domain,isc,iec,jsc,jec)

  !--- test conservative horiz_interp with a simple test. the source grid is the region
  !    (0:360,-90:90) with grid size ni_src, nj_src ( default 360X180). and the destination 
  !    is the region (-280:80, -90:90) with grid size ni_dstXnj_dst( default 144X72). 
  !    integer checksum and global sum will be printed out for both the 1D and 2D version. 

  allocate(lon2D_src(ni_src+1, nj_src+1), lat2D_src(ni_src+1, nj_src+1) )
  allocate(lon1D_src(ni_src+1), lat1D_src(nj_src+1), data_src(ni_src, nj_src) )

  allocate(lon2D_dst(isc:iec+1, jsc:jec+1), lat2D_dst(isc:iec+1, jsc:jec+1) )
  allocate(lon1D_dst(isc:iec+1), lat1D_dst(jsc:jec+1) )
  allocate(data1_dst(isc:iec, jsc:jec), data2_dst(isc:iec, jsc:jec) )
  allocate(data3_dst(isc:iec, jsc:jec), data4_dst(isc:iec, jsc:jec) )

  ! set up longitude and latitude of source/destination grid.   
  dlon_src = (lon_src_end-lon_src_beg)/ni_src 
  dlat_src = (lat_src_end-lat_src_beg)/nj_src
  dlon_dst = (lon_dst_end-lon_dst_beg)/ni_dst 
  dlat_dst = (lat_dst_end-lat_dst_beg)/nj_dst

  do i = 1, ni_src+1
     lon1D_src(i) = lon_src_beg + (i-1)*dlon_src
  end do

  do j = 1, nj_src+1
     lat1D_src(j) = lat_src_beg + (j-1)*dlat_src
  end do

  do i = isc, iec+1
     lon1D_dst(i) = lon_dst_beg + (i-1)*dlon_dst
  end do

  do j = jsc, jec+1
     lat1D_dst(j) = lat_dst_beg + (j-1)*dlat_dst
  end do

  ! scale grid to radians.
  lon1D_src = lon1D_src * D2R
  lat1D_src = lat1D_src * D2R
  lon1D_dst = lon1D_dst * D2R
  lat1D_dst = lat1D_dst * D2R

  do i = 1, ni_src+1
     lon2D_src(i,:) = lon1D_src(i)
  end do

  do j = 1, nj_src+1
     lat2D_src(:,j) = lat1D_src(j)
  end do

  do i = isc, iec+1
     lon2D_dst(i,:) = lon1D_dst(i)
  end do

  do j = jsc, jec+1
     lat2D_dst(:,j) = lat1D_dst(j)
  end do

  !--- set up the source data
  do j = 1, nj_src
     do i = 1, ni_src
        data_src(i,j) = i + j*0.001
     end do
  end do

  id1 = mpp_clock_id( 'horiz_interp_1dx1d', flags=MPP_CLOCK_SYNC+MPP_CLOCK_DETAILED )
  id2 = mpp_clock_id( 'horiz_interp_1dx2d', flags=MPP_CLOCK_SYNC+MPP_CLOCK_DETAILED )
  id3 = mpp_clock_id( 'horiz_interp_2dx1d', flags=MPP_CLOCK_SYNC+MPP_CLOCK_DETAILED )
  id4 = mpp_clock_id( 'horiz_interp_2dx2d', flags=MPP_CLOCK_SYNC+MPP_CLOCK_DETAILED )

  ! --- 1dx1d version conservative interpolation
  call mpp_clock_begin(id1)
  call horiz_interp_new(Interp, lon1D_src, lat1D_src, lon1D_dst, lat1D_dst, interp_method = "conservative")
  call horiz_interp(Interp, data_src, data1_dst)
  call horiz_interp_del(Interp)
  call mpp_clock_end(id1)

  ! --- 1dx2d version conservative interpolation
  call mpp_clock_begin(id2)
  call horiz_interp_new(Interp, lon1D_src, lat1D_src, lon2D_dst, lat2D_dst, interp_method = "conservative")
  call horiz_interp(Interp, data_src, data2_dst)
  call horiz_interp_del(Interp)
  call mpp_clock_end(id2)

  ! --- 2dx1d version conservative interpolation
  call mpp_clock_begin(id3)
  call horiz_interp_new(Interp, lon2D_src, lat2D_src, lon1D_dst, lat1D_dst, interp_method = "conservative")
  call horiz_interp(Interp, data_src, data3_dst)
  call horiz_interp_del(Interp)
  call mpp_clock_end(id3)

  ! --- 2dx2d version conservative interpolation
  call mpp_clock_begin(id4)
  call horiz_interp_new(Interp, lon2D_src, lat2D_src, lon2D_dst, lat2D_dst, interp_method = "conservative")
  call horiz_interp(Interp, data_src, data4_dst)
  call horiz_interp_del(Interp)
  call mpp_clock_end(id4)

  !--- compare the data after interpolation between 1-D and 2-D version interpolation
  do j = jsc, jsc
     do i = isc, iec

        if( abs(data1_dst(i,j)-data2_dst(i,j)) > SMALL ) then
           print*, "After interpolation At point (i,j) = (", i, ",", j, "), data1 = ", data1_dst(i,j), &
           ", data2 = ", data2_dst(i,j), ", data1-data2 = ",  data1_dst(i,j) - data2_dst(i,j)
           call mpp_error(FATAL,"horiz_interp_test: data1_dst does not approxiamate data2_dst")
        end if
     end do
  end do

  if(mpp_pe() == mpp_root_pe()) call mpp_error(NOTE,   &
       "The test that verify 1dx2d version horiz_interp can reproduce 1dx1d version of horiz_interp is succesful") 

  do j = jsc, jsc
     do i = isc, iec

        if( abs(data1_dst(i,j)-data3_dst(i,j)) > SMALL ) then
           print*, "After interpolation At point (i,j) = (", i, ",", j, "), data1 = ", data1_dst(i,j), &
           ", data2 = ", data3_dst(i,j), ", data1-data2 = ",  data1_dst(i,j) - data3_dst(i,j)
           call mpp_error(FATAL,"horiz_interp_test: data1_dst does not approxiamate data3_dst")
        end if
     end do
  end do

  if(mpp_pe() == mpp_root_pe()) call mpp_error(NOTE,   &
       "The test that verify 2dx1d version horiz_interp can reproduce 1dx1d version of horiz_interp is succesful") 

  do j = jsc, jsc
     do i = isc, iec

        if( abs(data1_dst(i,j)-data4_dst(i,j)) > SMALL ) then
           print*, "After interpolation At point (i,j) = (", i, ",", j, "), data1 = ", data1_dst(i,j), &
           ", data2 = ", data4_dst(i,j), ", data1-data2 = ",  data1_dst(i,j) - data4_dst(i,j)
           call mpp_error(FATAL,"horiz_interp_test: data1_dst does not approxiamate data4_dst")
        end if
     end do
  end do

  if(mpp_pe() == mpp_root_pe()) call mpp_error(NOTE,   &
       "The test that verify 2dx2d version horiz_interp can reproduce 1dx1d version of horiz_interp is succesful") 

  call mpp_io_exit
  call mpp_exit

end program horiz_interp_test
#endif

module land_model_mod ! This is the null version

!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Zhi Liang
!</CONTACT>
!
!<OVERVIEW>
! Null land model. 
!</OVERVIEW>
!<DESCRIPTION>
! Null land model. 
!</DESCRIPTION>
!
!<NAMELIST NAME="land_model_nml">
!  <DATA NAME="layout" TYPE="integer">
!  Processor domain layout for land model. 
!  </DATA> 
!  <DATA NAME="mask_table" TYPE="character">
!   A text file to specify n_mask, layout and mask_list to reduce number of processor
!   usage by masking out some domain regions which contain all land points. 
!   The default file name of mask_table is "INPUT/land_mask_table". Please note that 
!   the file name must begin with "INPUT/". The first 
!   line of mask_table will be number of region to be masked out. The second line 
!   of the mask_table will be the layout of the model. User need to set land_model_nml
!   variable layout to be the same as the second line of the mask table.
!   The following n_mask line will be the position of the processor to be masked out.
!   The mask_table could be created by tools check_mask. 
!   For example the mask_table will be as following if n_mask=2, layout=4,6 and 
!   the processor (1,2) and (3,6) will be masked out. 
!     2
!     4,6
!     1,2
!     3,6
!  </DATA>
!

!</NAMELIST>


use  mpp_mod,           only : mpp_pe, mpp_chksum, mpp_root_pe
use  mpp_mod,           only : input_nml_file

use  mpp_domains_mod,   only : CYCLIC_GLOBAL_DOMAIN, mpp_get_compute_domain
use  mpp_domains_mod,   only : domain2d, mpp_define_layout, mpp_define_domains
use  mpp_domains_mod,   only : mpp_get_ntile_count, mpp_get_tile_id, mpp_get_current_ntile

use time_manager_mod,   only : time_type

use diag_manager_mod,   only : diag_axis_init

use tracer_manager_mod, only : register_tracers

use field_manager_mod,  only : MODEL_LAND

use          fms_mod,  only : write_version_number, error_mesg, FATAL, mpp_npes, stdout
use          fms_mod,  only : open_namelist_file, check_nml_error, file_exist, close_file
use          fms_mod,  only : set_domain
use       fms_io_mod,  only : parse_mask_table

use         grid_mod,  only : get_grid_ntiles, get_grid_size, define_cube_mosaic
use         grid_mod,  only : get_grid_cell_vertices, get_grid_cell_centers
use         grid_mod,  only : get_grid_cell_area, get_grid_comp_area

implicit none
private

! ==== public interfaces =====================================================

public land_model_init          ! initialize the land model
public land_model_end           ! finish land model calculations
public land_model_restart       ! saves the land model restart(s)
public update_land_model_fast   ! time-step integration
public update_land_model_slow   ! time-step integration
public atmos_land_boundary_type ! data from coupler to land
public land_data_type           ! data from land to coupler
public :: Lnd_stock_pe          ! return stocks of conservative quantities
public land_data_type_chksum, atm_lnd_bnd_type_chksum

! ==== end of public interfaces ==============================================

character(len=*), parameter :: &
     version = '$Id: land_model.F90,v 20.0 2013/12/13 23:31:21 fms Exp $', &
     tagname = '$Name: tikal $'

type :: atmos_land_boundary_type
   real, dimension(:,:,:), pointer :: & ! (lon, lat, tile)
        t_flux    => NULL(), &   ! sensible heat flux, W/m2
        lw_flux   => NULL(), &   ! net longwave radiation flux, W/m2
        lwdn_flux => NULL(), &   ! downward longwave radiation flux, W/m2
        sw_flux   => NULL(), &   ! net shortwave radiation flux, W/m2
        swdn_flux => NULL(), &   ! downward shortwave radiation flux, W/m2
        lprec     => NULL(), &   ! liquid precipitation rate, kg/(m2 s)
        fprec     => NULL(), &   ! frozen precipitation rate, kg/(m2 s)
        tprec     => NULL(), &   ! temperture of precipitation, degK
        sw_flux_down_vis_dir   => NULL(), & ! visible direct 
        sw_flux_down_total_dir => NULL(), & ! total direct
        sw_flux_down_vis_dif   => NULL(), & ! visible diffuse
        sw_flux_down_total_dif => NULL(), & ! total diffuse
        dhdt      => NULL(), &   ! sensible w.r.t. surface temperature
        dhdq      => NULL(), &   ! sensible w.r.t. surface humidity
        drdt      => NULL(), &   ! longwave w.r.t. surface radiative temperature 
        cd_m      => NULL(), &   ! drag coefficient for momentum, dimensionless
        cd_t      => NULL(), &   ! drag coefficient for tracers, dimensionless
        ustar     => NULL(), &   ! turbulent wind scale, m/s
        bstar     => NULL(), &   ! turbulent buoyancy scale, m/s
        wind      => NULL(), &   ! abs wind speed at the bottom of the atmos, m/s
        z_bot     => NULL(), &   ! height of the bottom atmospheric layer above the surface, m
        drag_q    => NULL(), &   ! product of cd_q by wind
        p_surf    => NULL()      ! surface pressure, Pa

   real, dimension(:,:,:,:), pointer :: & ! (lon, lat, tile, tracer)
        tr_flux => NULL(),   &   ! tracer flux, including water vapor flux
        dfdtr   => NULL()        ! derivative of the flux w.r.t. tracer surface value, 
                                 ! including evap over surface specific humidity

   integer :: xtype             !REGRID, REDIST or DIRECT
end type atmos_land_boundary_type


type :: land_data_type
   logical :: pe ! data presence indicator for stock calculations
   real, pointer, dimension(:,:,:)   :: &  ! (lon, lat, tile)
        tile_size      => NULL(),  & ! fractional coverage of cell by tile, dimensionless
        t_surf         => NULL(),  & ! ground surface temperature, degK
        t_ca           => NULL(),  & ! canopy air temperature, degK
        albedo         => NULL(),  & ! broadband land albedo [unused?]
        albedo_vis_dir => NULL(),  & ! albedo for direct visible radiation
        albedo_nir_dir => NULL(),  & ! albedo for direct NIR radiation 
        albedo_vis_dif => NULL(),  & ! albedo for diffuse visible radiation 
        albedo_nir_dif => NULL(),  & ! albedo for diffuse NIR radiation
        rough_mom      => NULL(),  & ! surface roughness length for momentum, m
        rough_heat     => NULL(),  & ! roughness length for tracers and heat, m
        rough_scale    => NULL()     ! topographic scaler for momentum drag, m

   real, pointer, dimension(:,:,:,:)   :: &  ! (lon, lat, tile, tracer)
        tr    => NULL()              ! tracers, including canopy air specific humidity

   real, pointer, dimension(:,:) :: &  ! (lon, lat)
     discharge           => NULL(),  & ! liquid water flux from land to ocean
     discharge_heat      => NULL(),  & ! sensible heat of discharge (0 C datum)
     discharge_snow      => NULL(),  & ! solid water flux from land to ocean
     discharge_snow_heat => NULL()     ! sensible heat of discharge_snow (0 C datum)

   logical, pointer, dimension(:,:,:):: &
        mask => NULL()               ! true if land

   integer :: axes(2)        ! IDs of diagnostic axes
   type(domain2d) :: domain  ! our computation domain
   logical, pointer :: maskmap(:,:) 
   integer, pointer, dimension(:) :: pelist
end type land_data_type

!---- land_model_nml
integer :: layout(2)
! mask_table contains information for masking domain ( n_mask, layout and mask_list).
character(len=128) :: mask_table = "INPUT/land_mask_table"

namelist /land_model_nml/ layout, mask_table


contains

! ============================================================================
subroutine land_model_init (cplr2land, land2cplr, time_init, time, dt_fast, dt_slow, &
                            glon_bnd, glat_bnd, Domain_in)

  type(atmos_land_boundary_type), intent(inout) :: cplr2land ! boundary data
  type(land_data_type)          , intent(inout) :: land2cplr ! boundary data
  type(time_type), intent(in) :: time_init ! initial time of simulation (?)
  type(time_type), intent(in) :: time      ! current time
  type(time_type), intent(in) :: dt_fast   ! fast time step
  type(time_type), intent(in) :: dt_slow   ! slow time step
  real, dimension(:,:), optional :: glon_bnd, glat_bnd
  type(domain2d), optional :: Domain_in

 ! ---- local vars
  integer :: nlon, nlat ! size of global grid in lon and lat directions
  integer :: ntiles     ! number of tiles in the mosaic grid
  integer :: is,ie,js,je,id_lon,id_lat,i
  type(domain2d), save :: domain
  real, allocatable, dimension(:,:)  :: garea, gcellarea, gfrac
  real, allocatable, dimension(:,:)  :: glon, glat
  integer, allocatable, dimension(:) :: tile_ids
  integer :: ntracers, ntprog, ndiag, face, npes_per_tile
  integer :: namelist_unit, io, ierr, stdoutunit

!--- read namelist
#ifdef INTERNAL_FILE_NML
   read (input_nml_file, land_model_nml, iostat=io)
#else
   namelist_unit = open_namelist_file()
   ierr=1
   do while (ierr /= 0)
     read(namelist_unit, nml=land_model_nml, iostat=io, end=20)
     ierr = check_nml_error (io, 'land_model_nml')
   enddo
   20 call close_file (namelist_unit)
#endif

  stdoutunit = stdout()

  call write_version_number(version, tagname)

  ! define the processor layout information according to the global grid size 
  call get_grid_ntiles('LND',ntiles)
  call get_grid_size('LND',1,nlon,nlat)
 
  if(file_exist(mask_table)) then
     if(ntiles > 1) then
        call error_mesg('land_model_init', &
          'file '//trim(mask_table)//' should not exist when ntiles is not 1', FATAL)
     endif
     if(layout(1) == 0 .OR. layout(2) == 0 ) call error_mesg('land_model_init', &
          'land_model_nml layout should be set when file '//trim(mask_table)//' exists', FATAL)

     write(stdoutunit, '(a)') '==> NOTE from land_model_init:  reading maskmap information from '//trim(mask_table)
     allocate(land2cplr%maskmap(layout(1), layout(2)))
     call parse_mask_table(mask_table, land2cplr%maskmap, "Land model")
  else
     if(layout(1)*layout(2) .NE. mpp_npes()/ntiles) call mpp_define_layout((/1,nlon,1,nlat/), mpp_npes()/ntiles, layout)
  endif

  if(ntiles ==1) then
     if( ASSOCIATED(land2cplr%maskmap) ) then
        call mpp_define_domains((/1,nlon,1,nlat/), layout, domain, &
             xflags = CYCLIC_GLOBAL_DOMAIN, xhalo=1, yhalo=1, maskmap = land2cplr%maskmap , name='land model')
     else
        call mpp_define_domains((/1,nlon,1,nlat/), layout, domain, &
             xflags = CYCLIC_GLOBAL_DOMAIN, xhalo=1, yhalo=1, name='land model')
     end if
  else
     call define_cube_mosaic('LND', domain, layout, halo=1)
  endif

  land2cplr%domain = domain
  call set_domain(domain)

  npes_per_tile = mpp_npes()/ntiles
  face = (mpp_pe()-mpp_root_pe())/npes_per_tile + 1
  allocate(garea(nlon,nlat), gcellarea(nlon,nlat), gfrac(nlon,nlat))
  call get_grid_cell_area    ('LND',face,gcellarea)
  call get_grid_comp_area    ('LND',face,garea)
  gfrac = garea/gcellarea
  

  call mpp_get_compute_domain(domain, is,ie,js,je)
  allocate(land2cplr%tile_size(is:ie,js:je,1))
  land2cplr%tile_size(is:ie,js:je,1) = gfrac(is:ie,js:je)
  deallocate(gfrac, garea, gcellarea)

  allocate(tile_ids(mpp_get_current_ntile(domain)))
  tile_ids = mpp_get_tile_id(domain)
  allocate(glon(nlon,nlat), glat(nlon,nlat))
  call get_grid_cell_centers ('LND', tile_ids(1), glon,  glat)

  if(mpp_get_ntile_count(domain)==1) then
     ! grid has just one tile, so we assume that the grid is regular lat-lon
     ! define longitude axes and its edges
     id_lon  = diag_axis_init('lon', glon(:,1), 'degrees_E', 'X', &
          long_name='longitude', set_name='land', domain2=domain )

     ! define latitude axes and its edges
     id_lat = diag_axis_init ('lat', glat(1,:), 'degrees_N', 'Y', &
          long_name='latitude',  set_name='land', domain2=domain )
  else
     id_lon = diag_axis_init ( 'grid_xt', (/(real(i),i=1,nlon)/), 'degrees_E', 'X', &
          long_name='T-cell longitude', set_name='land', domain2=domain, aux='geolon_t' )
     id_lat = diag_axis_init ( 'grid_yt', (/(real(i),i=1,nlat)/), 'degrees_N', 'Y', &
          long_name='T-cell latitude',  set_name='land', domain2=domain, aux='geolat_t' )
  endif
  land2cplr%axes = (/id_lon,id_lat/)

  call register_tracers(MODEL_LAND, ntracers, ntprog, ndiag)

  allocate(land2cplr%mask          (is:ie,js:je,1))
  allocate(land2cplr%t_surf        (is:ie,js:je,1))
  allocate(land2cplr%t_ca          (is:ie,js:je,1))
  allocate(land2cplr%tr            (is:ie,js:je,1,ntprog))
  allocate(land2cplr%albedo        (is:ie,js:je,1))
  allocate(land2cplr%albedo_vis_dir(is:ie,js:je,1))
  allocate(land2cplr%albedo_nir_dir(is:ie,js:je,1))
  allocate(land2cplr%albedo_vis_dif(is:ie,js:je,1))
  allocate(land2cplr%albedo_nir_dif(is:ie,js:je,1))
  allocate(land2cplr%rough_mom     (is:ie,js:je,1))
  allocate(land2cplr%rough_heat    (is:ie,js:je,1))
  allocate(land2cplr%rough_scale   (is:ie,js:je,1))
  allocate(land2cplr%discharge     (is:ie,js:je))
  allocate(land2cplr%discharge_heat(is:ie,js:je))
  allocate(land2cplr%discharge_snow(is:ie,js:je))
  allocate(land2cplr%discharge_snow_heat(is:ie,js:je))

  land2cplr%mask              = .FALSE.
  land2cplr%t_surf            = 280.0
  land2cplr%t_ca              = 280.0
  land2cplr%tr                = 0.0
  land2cplr%albedo            = 0.0
  land2cplr%albedo_vis_dir    = 0.0
  land2cplr%albedo_nir_dir    = 0.0
  land2cplr%albedo_vis_dif    = 0.0
  land2cplr%albedo_nir_dif    = 0.0
  land2cplr%rough_mom         = 0.0
  land2cplr%rough_heat        = 0.0
  land2cplr%rough_scale       = 1.0
  land2cplr%discharge         = 0.0
  land2cplr%discharge_heat    = 0.0
  land2cplr%discharge_snow    = 0.0
  land2cplr%discharge_snow_heat = 0.0

  allocate(cplr2land%t_flux(is:ie,js:je,1) )
  allocate(cplr2land%lw_flux(is:ie,js:je,1) )
  allocate(cplr2land%sw_flux(is:ie,js:je,1) )
  allocate(cplr2land%lprec(is:ie,js:je,1) )
  allocate(cplr2land%fprec(is:ie,js:je,1) )
  allocate(cplr2land%tprec(is:ie,js:je,1) )
  allocate(cplr2land%dhdt(is:ie,js:je,1) )
  allocate(cplr2land%dhdq(is:ie,js:je,1) )
  allocate(cplr2land%drdt(is:ie,js:je,1) )
  allocate(cplr2land%p_surf(is:ie,js:je,1) )
  allocate(cplr2land%tr_flux(is:ie,js:je,1,ntprog) )
  allocate(cplr2land%dfdtr(is:ie,js:je,1,ntprog) )
  allocate(cplr2land%lwdn_flux(is:ie,js:je,1) )
  allocate(cplr2land%swdn_flux(is:ie,js:je,1) )
  allocate(cplr2land%sw_flux_down_vis_dir(is:ie,js:je,1) )
  allocate(cplr2land%sw_flux_down_total_dir(is:ie,js:je,1) )
  allocate(cplr2land%sw_flux_down_vis_dif(is:ie,js:je,1) )
  allocate(cplr2land%sw_flux_down_total_dif(is:ie,js:je,1) )
  allocate(cplr2land%cd_t(is:ie,js:je,1) )
  allocate(cplr2land%cd_m(is:ie,js:je,1) )
  allocate(cplr2land%bstar(is:ie,js:je,1) )
  allocate(cplr2land%ustar(is:ie,js:je,1) )
  allocate(cplr2land%wind(is:ie,js:je,1) )
  allocate(cplr2land%z_bot(is:ie,js:je,1) )
  allocate(cplr2land%drag_q(is:ie,js:je,1) )

  cplr2land%t_flux                 = 0.0
  cplr2land%lw_flux                = 0.0
  cplr2land%sw_flux                = 0.0
  cplr2land%lprec                  = 0.0
  cplr2land%fprec                  = 0.0
  cplr2land%tprec                  = 0.0
  cplr2land%dhdt                   = 0.0
  cplr2land%dhdq                   = 0.0
  cplr2land%drdt                   = 0.0
  cplr2land%p_surf                 = 1.0e5
  cplr2land%tr_flux                = 0.0
  cplr2land%dfdtr                  = 0.0
  cplr2land%lwdn_flux              = 0.0
  cplr2land%swdn_flux              = 0.0
  cplr2land%sw_flux_down_vis_dir   = 0.0
  cplr2land%sw_flux_down_total_dir = 0.0
  cplr2land%sw_flux_down_vis_dif   = 0.0
  cplr2land%sw_flux_down_total_dif = 0.0
  cplr2land%cd_t                   = 0.0
  cplr2land%cd_m                   = 0.0
  cplr2land%bstar                  = 0.0
  cplr2land%ustar                  = 0.0
  cplr2land%wind                   = 0.0
  cplr2land%z_bot                  = 0.0
  cplr2land%drag_q                 = 0.0

  deallocate(glon, glat, tile_ids)

end subroutine land_model_init

! ============================================================================
subroutine land_model_end (cplr2land, land2cplr)
  type(atmos_land_boundary_type), intent(inout) :: cplr2land
  type(land_data_type)          , intent(inout) :: land2cplr
  
end subroutine land_model_end

! ============================================================================
subroutine land_model_restart(timestamp)
  character(*), intent(in), optional :: timestamp
  
end subroutine land_model_restart

! ============================================================================
subroutine update_land_model_fast ( cplr2land, land2cplr )
  type(atmos_land_boundary_type), intent(in)    :: cplr2land
  type(land_data_type)          , intent(inout) :: land2cplr

  call error_mesg('update_land_model_fast','Should not be calling null version of update_land_model_fast',FATAL)

end subroutine update_land_model_fast


! ============================================================================
subroutine update_land_model_slow ( cplr2land, land2cplr )
  type(atmos_land_boundary_type), intent(inout) :: cplr2land
  type(land_data_type)          , intent(inout) :: land2cplr

  call error_mesg('update_land_model_slow','Should not be calling null version of update_land_model_slow',FATAL)

end subroutine update_land_model_slow

! ============================================================================
subroutine Lnd_stock_pe(bnd,index,value)

type(land_data_type), intent(in)  :: bnd 
integer             , intent(in)  :: index
real                , intent(out) :: value ! Domain water (Kg) or heat (Joules)

value = 0.0
 
end subroutine Lnd_stock_pe
! ============================================================================

!#######################################################################
! <SUBROUTINE NAME="atm_lnd_bnd_type_chksum">
!
! <OVERVIEW>
!  Print checksums of the various fields in the atmos_land_boundary_type.
! </OVERVIEW>

! <DESCRIPTION>
!  Routine to print checksums of the various fields in the atmos_land_boundary_type.
! </DESCRIPTION>

! <TEMPLATE>
!   call atm_lnd_bnd_type_chksum(id, timestep, albt)
! </TEMPLATE>

! <IN NAME="albt" TYPE="type(atmos_land_boundary_type)">
!   Derived-type variable that contains fields in the atmos_land_boundary_type.
! </INOUT>
!
! <IN NAME="id" TYPE="character">
!   Label to differentiate where this routine in being called from.
! </IN>
!
! <IN NAME="timestep" TYPE="integer">
!   An integer to indicate which timestep this routine is being called for.
! </IN>
!
subroutine atm_lnd_bnd_type_chksum(id, timestep, albt)

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(atmos_land_boundary_type), intent(in) :: albt
 integer ::   n, outunit
 
    outunit = stdout()

    write(outunit,*) 'BEGIN CHECKSUM(atmos_land_boundary_type):: ', id, timestep
    write(outunit,100) 'albt%t_flux                ', mpp_chksum( albt%t_flux)
    write(outunit,100) 'albt%lw_flux               ', mpp_chksum( albt%lw_flux)
    write(outunit,100) 'albt%lwdn_flux             ', mpp_chksum( albt%lwdn_flux)
    write(outunit,100) 'albt%sw_flux               ', mpp_chksum( albt%sw_flux)
    write(outunit,100) 'albt%swdn_flux               ', mpp_chksum( albt%swdn_flux)
    write(outunit,100) 'albt%lprec                 ', mpp_chksum( albt%lprec)
    write(outunit,100) 'albt%fprec                 ', mpp_chksum( albt%fprec)
    write(outunit,100) 'albt%tprec                 ', mpp_chksum( albt%tprec)
    write(outunit,100) 'albt%sw_flux_down_vis_dir  ', mpp_chksum( albt%sw_flux_down_vis_dir)
    write(outunit,100) 'albt%sw_flux_down_total_dir', mpp_chksum( albt%sw_flux_down_total_dir)
    write(outunit,100) 'albt%sw_flux_down_vis_dif  ', mpp_chksum( albt%sw_flux_down_vis_dif)
    write(outunit,100) 'albt%sw_flux_down_total_dif', mpp_chksum( albt%sw_flux_down_total_dif)
    write(outunit,100) 'albt%dhdt                  ', mpp_chksum( albt%dhdt)
    write(outunit,100) 'albt%dhdq                  ', mpp_chksum( albt%dhdq)
    write(outunit,100) 'albt%drdt                  ', mpp_chksum( albt%drdt)
    write(outunit,100) 'albt%cd_m                  ', mpp_chksum( albt%cd_m)
    write(outunit,100) 'albt%cd_t                  ', mpp_chksum( albt%cd_t)
    write(outunit,100) 'albt%ustar                 ', mpp_chksum( albt%ustar)
    write(outunit,100) 'albt%bstar                 ', mpp_chksum( albt%bstar)
    write(outunit,100) 'albt%wind                  ', mpp_chksum( albt%wind)
    write(outunit,100) 'albt%z_bot                 ', mpp_chksum( albt%z_bot)
    write(outunit,100) 'albt%drag_q                ', mpp_chksum( albt%drag_q)
    write(outunit,100) 'albt%p_surf                ', mpp_chksum( albt%p_surf)
    do n = 1,size(albt%tr_flux,4)
    write(outunit,100) 'albt%tr_flux               ', mpp_chksum( albt%tr_flux(:,:,:,n))
    enddo
    do n = 1,size(albt%dfdtr,4)
    write(outunit,100) 'albt%dfdtr                 ', mpp_chksum( albt%dfdtr(:,:,:,n))
    enddo

100 FORMAT("CHECKSUM::",A32," = ",Z20)

end subroutine atm_lnd_bnd_type_chksum

! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="land_data_type_chksum">
!
! <OVERVIEW>
!  Print checksums of the various fields in the land_data_type.
! </OVERVIEW>

! <DESCRIPTION>
!  Routine to print checksums of the various fields in the land_data_type.
! </DESCRIPTION>

! <TEMPLATE>
!   call land_data_type_chksum(id, timestep, land)
! </TEMPLATE>

! <IN NAME="land" TYPE="type(land_data_type)">
!   Derived-type variable that contains fields in the land_data_type.
! </INOUT>
!
! <IN NAME="id" TYPE="character">
!   Label to differentiate where this routine in being called from.
! </IN>
!
! <IN NAME="timestep" TYPE="integer">
!   An integer to indicate which timestep this routine is being called for.
! </IN>
!

subroutine land_data_type_chksum(id, timestep, land)
  use fms_mod,                 only: stdout
  use mpp_mod,                 only: mpp_chksum

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(land_data_type), intent(in) :: land
    integer ::   n, outunit
 
    outunit = stdout()

    write(outunit,*) 'BEGIN CHECKSUM(land_data_type):: ', id, timestep
    write(outunit,100) 'land%tile_size         ',mpp_chksum(land%tile_size)
    write(outunit,100) 'land%t_surf            ',mpp_chksum(land%t_surf)
    write(outunit,100) 'land%t_ca              ',mpp_chksum(land%t_ca)
    write(outunit,100) 'land%albedo            ',mpp_chksum(land%albedo)
    write(outunit,100) 'land%albedo_vis_dir    ',mpp_chksum(land%albedo_vis_dir)
    write(outunit,100) 'land%albedo_nir_dir    ',mpp_chksum(land%albedo_nir_dir)
    write(outunit,100) 'land%albedo_vis_dif    ',mpp_chksum(land%albedo_vis_dif)
    write(outunit,100) 'land%albedo_nir_dif    ',mpp_chksum(land%albedo_nir_dif)
    write(outunit,100) 'land%rough_mom         ',mpp_chksum(land%rough_mom)
    write(outunit,100) 'land%rough_heat        ',mpp_chksum(land%rough_heat)
    write(outunit,100) 'land%rough_scale       ',mpp_chksum(land%rough_scale)

    do n = 1, size(land%tr,4)
    write(outunit,100) 'land%tr                ',mpp_chksum(land%tr(:,:,:,n))
    enddo
    write(outunit,100) 'land%discharge         ',mpp_chksum(land%discharge)
    write(outunit,100) 'land%discharge_snow    ',mpp_chksum(land%discharge_snow)
    write(outunit,100) 'land%discharge_heat    ',mpp_chksum(land%discharge_heat)


100 FORMAT("CHECKSUM::",A32," = ",Z20)
end subroutine land_data_type_chksum

! </SUBROUTINE>
end module land_model_mod

module moistproc_kernels_mod

use sat_vapor_pres_mod,         only: compute_qs
use time_manager_mod,           only: time_type
use diag_manager_mod,           only: send_data
use constants_mod,              only: CP_AIR, GRAV, HLV, HLS, HLF, &
                                      RDGAS, RVGAS, TFREEZE, &
                                      SECONDS_PER_DAY, KAPPA
use field_manager_mod,          only: MODEL_ATMOS
use tracer_manager_mod,         only: get_tracer_index
use betts_miller_mod,           only: betts_miller
use bm_massflux_mod,            only: bm_massflux
use bm_omp_mod,                 only: bm_omp
use diag_cloud_mod,             only: diag_cloud_sum
use donner_deep_mod,            only: donner_deep
use moist_conv_mod,             only: moist_conv
use lscale_cond_mod,            only: lscale_cond
use uw_conv_mod,                only: uw_conv
use lin_cld_microphys_mod,      only: lin_cld_microphys_driver
use ras_mod,                    only: ras
use strat_cloud_mod,            only: strat_cloud, strat_cloud_sum, &
                                      strat_cloud_new
use rh_clouds_mod,              only: rh_clouds_sum
use cu_mo_trans_mod,            only: cu_mo_trans
use atmos_tracer_utilities_mod, only: wet_deposition
use moz_hook_mod,               only: moz_hook
use rad_utilities_mod,          only: aerosol_type
use moist_proc_utils_mod,       only: rh_calc
use detr_ice_num_mod ,          only: detr_ice_num

!--->h1g
use  mpp_mod,                   only: mpp_chksum, mpp_pe, mpp_root_pe
use  MG_microp_3D_mod,          only: MG_microp_3D
! <--- h1g

implicit none
private
public  moistproc_init, moistproc_end, moistproc_mca, moistproc_ras, &
        moistproc_lscale_cond, moistproc_strat_cloud, moistproc_cmt, &
        moistproc_uw_conv, moistproc_scale_uw, moistproc_scale_donner


!--------------------- version number ----------------------------------
character(len=128) :: &
version = '$Id: moistproc_kernels.F90,v 20.0 2013/12/13 23:18:29 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!-----------------------------------------------------------------------
real, public, allocatable, dimension(:,:)     :: rain_uw, snow_uw
real, public, allocatable, dimension(:,:,:)   :: ttnd_uw, qtnd_uw,   &
                                                 utnd_uw, vtnd_uw,   &
                                                 qltnd_uw, qitnd_uw, &
                                                 qatnd_uw, qntnd_uw, &  
                                                 qnitnd_uw,          &
                                                 delta_ql, delta_qi, &
                                                 delta_qa,           &
                                                 qlin, qiin, qain
real, public, allocatable, dimension(:,:,:,:) :: qtruw

logical :: moistproc_initialized = .false.

contains


!#######################################################################
subroutine moistproc_init(ix, jx, kx, num_uw_tracers, do_strat)
  integer, intent(in) :: ix, jx, kx, num_uw_tracers
  logical, intent(in) :: do_strat

      if (moistproc_initialized) return

      allocate( rain_uw  (ix,jx) )                   ; rain_uw  = 0.0
      allocate( snow_uw  (ix,jx) )                   ; snow_uw  = 0.0
      allocate( ttnd_uw  (ix,jx,kx) )                ; ttnd_uw  = 0.0
      allocate( qtnd_uw  (ix,jx,kx) )                ; qtnd_uw  = 0.0
      allocate( utnd_uw  (ix,jx,kx) )                ; utnd_uw  = 0.0
      allocate( vtnd_uw  (ix,jx,kx) )                ; vtnd_uw  = 0.0
      allocate( qltnd_uw (ix,jx,kx) )                ; qltnd_uw = 0.0
      allocate( qitnd_uw (ix,jx,kx) )                ; qitnd_uw = 0.0
      allocate( qatnd_uw (ix,jx,kx) )                ; qatnd_uw = 0.0
      allocate( qntnd_uw (ix,jx,kx) )                ; qntnd_uw = 0.0
      allocate( qnitnd_uw (ix,jx,kx) )               ; qnitnd_uw= 0.0
      allocate( qtruw    (ix,jx,kx,num_uw_tracers) ) ; qtruw    = 0.0
      if (do_strat) then
        allocate( delta_ql (ix,jx,kx) )              ; delta_ql = 0.0
        allocate( delta_qi (ix,jx,kx) )              ; delta_qi = 0.0
        allocate( delta_qa (ix,jx,kx) )              ; delta_qa = 0.0
        allocate( qlin     (ix,jx,kx) )              ; qlin     = 0.0
        allocate( qiin     (ix,jx,kx) )              ; qiin     = 0.0
        allocate( qain     (ix,jx,kx) )              ; qain     = 0.0
      endif

      moistproc_initialized = .true.
end subroutine moistproc_init

!#######################################################################
subroutine moistproc_end(do_strat)
  logical, intent(in) :: do_strat

      if (moistproc_initialized .eqv. .false. ) return
      deallocate( rain_uw    )
      deallocate( snow_uw    )
      deallocate( ttnd_uw    )
      deallocate( qtnd_uw    )
      deallocate( utnd_uw    )
      deallocate( vtnd_uw    )
      deallocate( qltnd_uw   )
      deallocate( qitnd_uw   )
      deallocate( qatnd_uw   )
      deallocate( qntnd_uw   )
      deallocate( qnitnd_uw   )
      deallocate( qtruw      )
      if (do_strat) then
        deallocate( delta_ql )
        deallocate( delta_qi )
        deallocate( delta_qa )
        deallocate( qlin     )
        deallocate( qiin     )
        deallocate( qain     )
      endif

      moistproc_initialized = .false.
end subroutine moistproc_end


!#######################################################################
subroutine moistproc_cmt ( Time, is, js, t, u, v, tracer, pfull, phalf, &
                           zfull, zhalf, pmass, tdt, udt, vdt, rdt,     &
                           ttnd_conv, dt, mc_cmt, det_cmt, diff_cu_mo,  &
                           num_tracers)
  type(time_type), intent(in)   :: Time
  integer, intent(in)           :: is, js, num_tracers
  real, intent(in)              :: dt
  real, intent(in),    dimension(:,:,:) :: pfull, phalf, zfull, zhalf, pmass, &
                                           mc_cmt, det_cmt
  real, intent(inout), dimension(:,:,:) :: t, u, v, tdt, udt, vdt, ttnd_conv, &
                                           diff_cu_mo
  real, intent(inout), dimension(:,:,:,:) :: rdt, tracer

  integer :: n
  real, dimension(size(t,1), size(t,2), size(t,3)) :: ttnd, utnd, vtnd
  real, dimension(size(rdt,1), size(rdt,2), size(rdt,3),num_tracers) :: qtr

      call cu_mo_trans (is, js, Time, mc_cmt, t, phalf, pfull, &
                        zhalf, zfull, dt, u, v, tracer,        &
                        pmass, det_cmt, utnd, vtnd, ttnd,      &
                        qtr, diff_cu_mo  )

!---------------------------------------------------------------------
!    update the current tracer tendencies with the contributions 
!    just obtained from cu_mo_trans.
!---------------------------------------------------------------------
      do n=1, num_tracers
        rdt(:,:,:,n) = rdt(:,:,:,n) + qtr(:,:,:,n)
      end do

!----------------------------------------------------------------------
!    add the temperature, specific humidity and momentum tendencies 
!    from ras (ttnd, qtnd, utnd, vtnd) to the arrays accumulating 
!    these tendencies from all physics processes (tdt, qdt, udt, vdt).
!----------------------------------------------------------------------
      tdt = tdt + ttnd 
      udt = udt + utnd
      vdt = vdt + vtnd
      ttnd_conv = ttnd_conv + ttnd


end subroutine moistproc_cmt


!#######################################################################
subroutine moistproc_lscale_cond (is, js, t, q, pfull, phalf, tdt, qdt, &
                                  ttnd, qtnd, qtnd_conv, lprec, fprec, precip,&
                                  rain, snow, dtinv, omega, do_rh_clouds, do_simple, &
                                  do_diag_clouds, coldT, kbot, mask)
  integer, intent(in)  :: is, js
  real, intent(in)     :: dtinv
  logical, intent(in)  :: do_rh_clouds, do_simple, do_diag_clouds
  logical, intent(in), dimension(:,:)   :: coldT
  real, intent(in),    dimension(:,:,:) :: pfull, phalf, omega
  real, intent(inout), dimension(:,:)   :: lprec, fprec, precip
  real, intent(inout), dimension(:,:,:) :: t, q, tdt, qdt, qtnd_conv, &
                                           ttnd, qtnd
  real, intent(out),   dimension(:,:)   :: rain, snow
  integer, intent(in) , dimension(:,:), optional :: kbot
  real, intent(in) , dimension(:,:,:),  optional :: mask

  real, dimension(size(t,1), size(t,2), size(t,3)) :: cnvcntq, rh

      call lscale_cond (t, q, pfull, phalf, coldT, rain, snow,  &
                        ttnd, qtnd, mask=mask)

!-----------------------------------------------------------------------
!    add the temperature and specific humidity increments to the updated
!    temperature and specific humidity fields (tin, qin). convert these
!    increments and the precipitation increments to rates and add to 
!    the arrays accumulating the total rates for all physical processes
!    (tdt, qdt, lprec, fprec).
!-----------------------------------------------------------------------
      t     = t   + ttnd 
      q     = q   + qtnd
      tdt   = tdt   + ttnd*dtinv 
      qdt   = qdt   + qtnd*dtinv
      lprec = lprec + rain*dtinv
      fprec = fprec + snow*dtinv

!--------------------------------------------------------------------
!    if rh_clouds is active, call rh_calc to determine the grid box
!    relative humidity. call rh_clouds_sum to pass this field to 
!    rh_clouds_mod so it may be used to determine the grid boxes which
!    will contain clouds for the radiation package.
!---------------------------------------------------------------------
      if (do_rh_clouds) then
        call rh_calc (pfull, t, q, rh, do_simple, mask)
        call rh_clouds_sum (is, js, rh)
      endif

!--------------------------------------------------------------------
!    if the gordon diagnostic cloud parameterization is active, set a 
!    flag to indicate those grid points where drying has resulted from 
!    convective activity (cnvcntq). call rh_calc to determine the grid 
!    box relative humidity. call diag_cloud_sum to define the cloud 
!    field that will be seen by the radiation package.
!---------------------------------------------------------------------
      if (do_diag_clouds) then
        cnvcntq (:,:,:) = 0.0
        where (qtnd_conv(:,:,:) < 0.0)
          cnvcntq (:,:,:) = 1.0
        end where
        call rh_calc (pfull, t, q, rh, do_simple, mask)
        call diag_cloud_sum (is, js, t, q, rh, omega, qtnd,  &
                             cnvcntq, precip, kbot)
      endif


end subroutine moistproc_lscale_cond


!#######################################################################
subroutine moistproc_mca( Time, is, js, t, q, tracer, pfull, phalf, coldT, dtinv, &
                          tdt, qdt, rdt, q_tnd, ttnd_conv, qtnd_conv,             &
                          lprec, fprec, do_strat, num_tracers, tracers_in_mca,    &
                          num_mca_tracers, kbot, mask)

  type(time_type), intent(in) :: Time
  integer, intent(in)         :: is, js, num_tracers, num_mca_tracers
  real, intent(in)            :: dtinv
  logical, intent(in)         :: do_strat
  logical, intent(in), dimension(:)       :: tracers_in_mca
  logical, intent(in), dimension(:,:)     :: coldT
  real, intent(in),    dimension(:,:,:)   :: pfull, phalf 
  real, intent(inout), dimension(:,:)     :: lprec, fprec
  real, intent(inout), dimension(:,:,:)   :: t, q, tdt, qdt, ttnd_conv, qtnd_conv
  real, intent(inout), dimension(:,:,:,:) :: rdt, q_tnd
  real, intent(out),   dimension(:,:,:,:) :: tracer
  integer, intent(in) , dimension(:,:), optional :: kbot
  real, intent(in) , dimension(:,:,:),  optional :: mask

  integer :: nn, n, nql, nqa, nqi, nqn
  real, dimension(size(t,1), size(t,2)) :: rain, snow
  real, dimension(size(t,1), size(t,2), size(t,3)) :: ttnd, qtnd
  real, dimension(size(rdt,1), size(rdt,2), size(rdt,3),num_mca_tracers) :: trcr, qtr


      nql = get_tracer_index ( MODEL_ATMOS, 'liq_wat' )
      nqi = get_tracer_index ( MODEL_ATMOS, 'ice_wat' )
      nqa = get_tracer_index ( MODEL_ATMOS, 'cld_amt' )
      nqn = get_tracer_index ( MODEL_ATMOS, 'liq_drp' )

!---------------------------------------------------------------------
!    check each active tracer to find any that are to be transported 
!    by moist convective adjustment and fill the mca_tracers array with
!    these fields.
!---------------------------------------------------------------------
      nn = 1
      do n=1, num_tracers
        if (tracers_in_mca(n)) then
          trcr(:,:,:,nn) = tracer(:,:,:,n)
          nn = nn + 1
        endif
      end do

!---------------------------------------------------------------------
!    call subroutine moist_conv to obtain the temperature, moisture
!    precipitation and tracer tendencies due to the moist convective
!    adjustment parameterization. currently there is no tracer tendency
!    due to this parameterization.
!---------------------------------------------------------------------
!++++yim Should also account for change in qn dut to moist convective adjustment.

      if (do_strat) then
        call moist_conv (t, q, pfull, phalf, coldT, ttnd, qtnd,          &
                         rain, snow, dtinv, Time, is, js,                &
                         trcr, qtr, Lbot= kbot, mask=mask,               &
                         ql=tracer(:,:,:,nql), qi=tracer(:,:,:,nqi),     &
                         cf=tracer(:,:,:,nqa), qldel=q_tnd(:,:,:,nql),   &
                         qidel=q_tnd(:,:,:,nqi), cfdel=q_tnd(:,:,:,nqa))
      else
        call moist_conv (t, q, pfull, phalf, coldT, ttnd, qtnd,          &
                         rain, snow, dtinv, Time, is, js,                &
                         trcr, qtr, Lbot=kbot, mask=mask)
      endif

!---------------------------------------------------------------------
!    update the current tracer tendencies with the contributions 
!    just obtained from moist convective adjustment. currently there
!    is no tracer transport by this process.
!    NOTE : the stratcloud tracers are updated within moist_conv.
!---------------------------------------------------------------------
      nn = 1
      do n=1, num_tracers
        if (tracers_in_mca(n)) then
          rdt(:,:,:,n) = rdt(:,:,:,n) + qtr(:,:,:,nn)
          nn = nn + 1
        endif
      end do

!----------------------------------------------------------------------
!    add the temperature and specific humidity tendencies from moist
!    convective adjustment (ttnd, qtnd) to the arrays accumulating 
!    these tendencies from all physics processes (tdt, qdt).
!----------------------------------------------------------------------
      tdt = tdt + ttnd 
      qdt = qdt + qtnd
      ttnd_conv = ttnd_conv + ttnd
      qtnd_conv = qtnd_conv + qtnd

!----------------------------------------------------------------------
!    increment the liquid, solid and total precipitation fields with 
!    the contribution from moist convective adjustment.
!----------------------------------------------------------------------
      lprec  = lprec  + rain
      fprec  = fprec  + snow

!----------------------------------------------------------------------
!    if strat_cloud_mod is activated, add the cloud liquid, ice and area
!    tendencies from moist convective adjustment to the 
!    arrays accumulating these tendencies from all physics processes 
!    (rdt).
!----------------------------------------------------------------------
      if (do_strat) then
        rdt(:,:,:,nql) = rdt(:,:,:,nql) + q_tnd(:,:,:,nql)
        rdt(:,:,:,nqi) = rdt(:,:,:,nqi) + q_tnd(:,:,:,nqi)
        rdt(:,:,:,nqa) = rdt(:,:,:,nqa) + q_tnd(:,:,:,nqa)
      endif


end subroutine moistproc_mca


!#######################################################################
subroutine moistproc_ras(Time, is, js, dt, coldT, t, q, u, v, tracer,       &
                         pfull, phalf, zhalf, tdt, qdt, udt, vdt, rdt,      &
                         q_tnd, ttnd, qtnd, ttnd_conv, qtnd_conv, mc, det0, &
                         lprec, fprec, rain, snow, rain3d, snow3d,          &
                         Aerosol, do_strat, do_liq_num, num_tracers,        &
                         tracers_in_ras, num_ras_tracers, kbot, mask, & 
                         do_ice_num, detrain_ice_num)

  type(time_type), intent(in)   :: Time
  integer, intent(in)           :: is, js, num_tracers, num_ras_tracers
  logical, intent(in)           :: do_strat, do_liq_num
  real, intent(in)              :: dt
  logical, intent(in), dimension(:)     :: tracers_in_ras
  logical, intent(in), dimension(:,:)   :: coldT
  real, intent(in),    dimension(:,:,:) :: pfull, phalf, zhalf
  real, intent(inout), dimension(:,:)   :: lprec, fprec
  real, intent(inout), dimension(:,:,:) :: t, q, u, v, tdt, qdt, udt, vdt,   &
                                           ttnd, qtnd, ttnd_conv, qtnd_conv
  real, intent(inout), dimension(:,:,:,:) :: rdt, tracer, q_tnd
  real, intent(out),   dimension(:,:)     :: rain, snow
  real, intent(out),   dimension(:,:,:)   :: rain3d,  snow3d, mc, det0

  type(aerosol_type),intent(in), optional :: Aerosol
  integer, intent(in), dimension(:,:), optional :: kbot
  real, intent(in), dimension(:,:,:),  optional :: mask
  logical, intent(in )                     :: do_ice_num, detrain_ice_num

  integer :: nn, n, nql, nqa, nqi, nqn, nqni
  real, dimension(size(t,1), size(t,2), size(t,3)) :: utnd, vtnd
  real, dimension(size(rdt,1), size(rdt,2), size(rdt,3),num_ras_tracers) :: trcr, qtr

      nql = get_tracer_index ( MODEL_ATMOS, 'liq_wat' )
      nqi = get_tracer_index ( MODEL_ATMOS, 'ice_wat' )
      nqa = get_tracer_index ( MODEL_ATMOS, 'cld_amt' )
      nqn = get_tracer_index ( MODEL_ATMOS, 'liq_drp' )
      nqni = get_tracer_index ( MODEL_ATMOS, 'ice_num' )
!----------------------------------------------------------------------
!    if any tracers are to be transported by ras convection, check each
!    active tracer to find those to be transported and fill the 
!    ras_tracers array with these fields.
!---------------------------------------------------------------------
     nn = 1
     do n=1, num_tracers
       if (tracers_in_ras(n)) then
         trcr(:,:,:,nn) = tracer(:,:,:,n)
         nn = nn + 1
       endif
     end do

!----------------------------------------------------------------------
!    call subroutine ras to obtain the temperature, specific humidity,
!    velocity, precipitation and tracer tendencies and mass flux 
!    associated with the relaxed arakawa-schubert parameterization.
!----------------------------------------------------------------------
     if (do_strat .and. (.not.do_liq_num)) then
       call ras (is,   js,     Time,     t,   q,          &
                 u,  v,    pfull,    phalf, zhalf, coldT, &
                 dt,   ttnd,   qtnd,     utnd,  vtnd,     &
                 rain3d, snow3d, rain, snow,              &
                 trcr, qtr, mask,  kbot, mc, det0,        &
                 tracer(:,:,:,nql), tracer(:,:,:,nqi),    &
                 tracer(:,:,:,nqa), q_tnd(:,:,:,nql),     &
                 q_tnd(:,:,:,nqi), q_tnd(:,:,:,nqa))       

     elseif (do_strat .and. do_liq_num) then
       call ras (is,   js,     Time,     t,   q,          &
                 u,  v,    pfull,    phalf, zhalf, coldT, &
                 dt,   ttnd,   qtnd,     utnd,  vtnd,     &
                 rain3d, snow3d, rain, snow,              &
                 trcr, qtr, mask,  kbot, mc, det0,        &
                 tracer(:,:,:,nql), tracer(:,:,:,nqi),    &
                 tracer(:,:,:,nqa), q_tnd(:,:,:,nql),     &
                 q_tnd(:,:,:,nqi), q_tnd(:,:,:,nqa),      &
                 tracer(:,:,:,nqn), q_tnd(:,:,:,nqn),     &
                 do_strat, Aerosol)
     else
       call ras (is,   js,     Time,     t,   q,          &
                 u,  v,    pfull,    phalf, zhalf, coldT, &
                 dt,   ttnd,   qtnd,     utnd,  vtnd,     &
                 rain3d, snow3d, rain, snow,              &
                 trcr, qtr, mask,  kbot,  mc, det0)
     endif

!---------------------------------------------------------------------
!    update the current tracer tendencies with the contributions 
!    just obtained from ras transport.
!    NOTE : the stratcloud tracers are updated within ras.        
!---------------------------------------------------------------------
     nn = 1
     do n=1, num_tracers
       if (tracers_in_ras(n)) then
         rdt(:,:,:,n) = rdt(:,:,:,n) + qtr (:,:,:,nn)
         nn = nn + 1
       endif
     end do
!----------------------------------------------------------------------
!    add the temperature, specific humidity and momentum tendencies 
!    from ras (ttnd, qtnd, utnd, vtnd) to the arrays accumulating 
!    these tendencies from all physics processes (tdt, qdt, udt, vdt).
!----------------------------------------------------------------------
     tdt = tdt + ttnd 
     qdt = qdt + qtnd
     udt = udt + utnd
     vdt = vdt + vtnd
!---------------------------------------------------------------------
!    if donner_deep_mod is also active, define the total time tendency 
!    due to all moist convective processes (donner (including its mca 
!    part), and ras) of temperature, specific humidity, rain, snow and,
!    if strat_cloud_mod is activated, the cloud liquid, cloud ice and 
!    cloud area. 
!---------------------------------------------------------------------
     ttnd_conv = ttnd_conv + ttnd
     qtnd_conv = qtnd_conv + qtnd

!----------------------------------------------------------------------
!    if strat_cloud_mod is activated, add the cloud liquid, ice and area
!    tendencies from ras to the arrays accumulating these tendencies 
!    from all physics processes (rdt).
!----------------------------------------------------------------------
     if (do_strat) then
       rdt(:,:,:,nql) = rdt(:,:,:,nql) + q_tnd(:,:,:,nql)
       rdt(:,:,:,nqi) = rdt(:,:,:,nqi) + q_tnd(:,:,:,nqi)
       rdt(:,:,:,nqa) = rdt(:,:,:,nqa) + q_tnd(:,:,:,nqa)
       if (do_liq_num) rdt(:,:,:,nqn) = rdt(:,:,:,nqn) + q_tnd(:,:,:,nqn)

!------------------------------------------------------------------------
!    currently this is the ice number tendency due to detrainment 
!    proportional by ice mass
!------------------------------------------------------------------------
       IF (do_ice_num .AND. detrain_ice_num) THEN
         CALL detr_ice_num (t, q_tnd(:,:,:,nqi), q_tnd(:,:,:,nqni))   
         rdt(:,:,:,nqni) = rdt(:,:,:,nqni) + q_tnd(:,:,:,nqni)
       END IF
     endif

!----------------------------------------------------------------------
!    increment the liquid, solid and total precipitation fields with 
!    the contribution from ras.
!----------------------------------------------------------------------
     lprec  = lprec  + rain
     fprec  = fprec  + snow

end subroutine moistproc_ras


!#######################################################################
subroutine moistproc_strat_cloud(Time, is, ie, js, je, lon, lat, ktop, dt, tm, t, q, tracer,&  ! cjg
                                 pfull, phalf, zhalf, omega, radturbten, mc_full, &
                                 diff_t, land, area, tdt, qdt, rdt, q_tnd, ttnd,  &
                                 qtnd, lprec, fprec, f_snow_berg, rain, &
                                 snow, rain3d, snow3d,  &
                                 snowclr3d, &
                                 Aerosol, lsc_cloud_area, lsc_liquid, lsc_ice,    &
                                 lsc_droplet_number, donner_humidity_area,        &
                                 donner_humidity_factor, shallow_cloud_area,      &
                                 cell_cld_frac, meso_cld_frac,                    &
                                 do_uw_conv, do_donner_deep, do_liq_num,          &
                                 do_clubb,                                        &  ! cjg
                                 do_lin_cld_microphys, id_qvout, id_qlout,        &
                                 id_qaout, id_qiout, id_qnout, id_qniout, &
                                 limit_conv_cloud_frac, mask, &
                                 hydrostatic, phys_hydrostatic,           &
                                 zfull, do_ice_num,  lsc_ice_number,   &
                                 lsc_snow, lsc_rain, lsc_snow_size,   &
                                 lsc_rain_size, do_legacy_strat_cloud, &
! ---> h1g
                                 dcond_ls_liquid, dcond_ls_ice,                   &
                                 Ndrop_act_CLUBB, Icedrop_act_CLUBB,              &
                                 ndust, rbar_dust, qcvar_clubb )
! <--- h1g

  type(time_type), intent(in) :: Time
  integer, intent(in)         :: is, ie, js, je, ktop, id_qvout, id_qlout, &
                                 id_qaout, id_qiout, id_qnout, id_qniout
  real, intent(in), dimension(:,:)  :: lon, lat
  real, intent(in)            :: dt
  logical, intent(in)         :: do_uw_conv, do_donner_deep, do_liq_num, &
                                 do_lin_cld_microphys,  &
                                 limit_conv_cloud_frac, &
                                 do_ice_num, do_legacy_strat_cloud
  integer, intent(in)         :: do_clubb                                 ! cjg
  real, intent(in),    dimension(:,:)     :: land, area
  real, intent(in),    dimension(:,:,:)   :: tm, pfull, phalf, zhalf, omega,  &
                                             radturbten, mc_full, diff_t,     &
                                             donner_humidity_area, donner_humidity_factor
  real, intent(in),    dimension(:,:,:)   :: zfull
  real, intent(inout), dimension(:,:)     :: lprec, fprec
  real, intent(inout), dimension(:,:,:)   :: t, q, tdt, qdt, ttnd, qtnd
  real, intent(inout), dimension(:,:,:,:) :: rdt, tracer, q_tnd
  real, intent(out),   dimension(:,:)     :: rain, snow
  real, intent(out),   dimension(:,:,:)   :: f_snow_berg
  real, intent(out),   dimension(:,:,:)   ::                 &
                  rain3d, snow3d, snowclr3d, lsc_cloud_area, lsc_liquid,  &
                  lsc_ice, lsc_droplet_number, lsc_ice_number, lsc_snow,  &
                  lsc_rain, lsc_snow_size, lsc_rain_size
! ---> h1g
  real, intent(in) , dimension(:,:,:), optional :: dcond_ls_liquid, dcond_ls_ice
  real, intent(in) , dimension(:,:,:), optional :: Ndrop_act_CLUBB,  Icedrop_act_CLUBB
  real, intent(in) , dimension(:,:,:), optional :: ndust, rbar_dust
  real, intent(in) , dimension(:,:,:), optional :: qcvar_clubb
! <--- h1g

  type(aerosol_type),intent(in), optional :: Aerosol
  logical, intent(in), optional           :: hydrostatic, phys_hydrostatic
  real, intent(in) , dimension(:,:,:),  optional :: mask, cell_cld_frac, meso_cld_frac, &
                                                    shallow_cloud_area

  logical :: used
  integer :: i, j, k, ix, jx, kx, nql, nqi, nqa, nqn, nqg, nqr, nqs, nqni
  real :: qrf, env_fraction, env_qv, dtinv
  real, dimension(size(t,1), size(t,2)) :: ice_lin, graupel_lin
  real, dimension(size(t,1), size(t,2), size(t,3)) :: delp, delz, qsat, &
                                                      convective_humidity_area,     &
                                                      convective_humidity_ratio

      ix=size(t,1) 
      jx=size(t,2) 
      kx=size(t,3)
      dtinv = 1./dt

!----------------------------------------------------------------------
!    define the grid box specific humidity and saturation specific 
!    humidity.
!------------------------------------------------------------------
      call compute_qs (t, pfull, qsat)
 
!----------------------------------------------------------------------
!    define the grid box area whose humidity is affected by the 
!    convective clouds and the environmental fraction and environmental
!    rh.
!-------------------------------------------------------------------
      do k=1, kx
       do j=1, jx
        do i=1, ix
          qrf = MAX (q(i,j,k), 0.0)
          if (do_uw_conv .and. do_donner_deep) then
            convective_humidity_area(i,j,k) = donner_humidity_area(i,j,k) +  &
                           shallow_cloud_area(i,j,k)
            env_qv = qrf - qsat(i,j,k)*(cell_cld_frac(i,j,k) +   &
                           donner_humidity_factor(i,j,k) + shallow_cloud_area(i,j,k))
          else if (do_donner_deep) then
            convective_humidity_area(i,j,k) = donner_humidity_area(i,j,k)
            env_qv = qrf - qsat(i,j,k)*(cell_cld_frac(i,j,k) +   &
                           donner_humidity_factor(i,j,k))
          else if (do_uw_conv) then
            convective_humidity_area(i,j,k) = shallow_cloud_area(i,j,k)
            env_qv = qrf -  shallow_cloud_area(i,j,k)*qsat(i,j,k)
          else
            convective_humidity_area(i,j,k) = 0.0
            env_qv = qrf
          endif
          env_fraction = 1.0 - convective_humidity_area(i,j,k)

!---------------------------------------------------------------------
!    define the ratio of the grid-box relative humidity to the humidity
!    in the environment of the convective clouds.
!----------------------------------------------------------------------
 
!----------------------------------------------------------------------
!    grid box has vapor and there is vapor outside of the convective a
!    clouds available for condensation.
!----------------------------------------------------------------
          if (qrf /= 0.0 .and. env_qv > 0.0) then
 
!--------------------------------------------------------------------
!    there is grid box area not filled with convective clouds
!--------------------------------------------------------------------  
            if (env_fraction > 0.0) then
              convective_humidity_ratio(i,j,k) =    &
                      MAX (qrf*env_fraction/env_qv, 1.0)
 
!---------------------------------------------------------------------
!    grid box is filled with convective clouds.
!----------------------------------------------------------------------
            else
              convective_humidity_ratio(i,j,k) = -10.0
            endif

!--------------------------------------------------------------------
!    either no vapor or all vapor taken up in convective clouds so 
!    none left for large-scale cd.
!---------------------------------------------------------------------
          else
            convective_humidity_ratio(i,j,k) = 1.0
          endif
        end do
       end do
      end do
        
!-----------------------------------------------------------------------
!    call strat_cloud to integrate the prognostic cloud equations. 
!-----------------------------------------------------------------------
      nql = get_tracer_index ( MODEL_ATMOS, 'liq_wat' )
      nqi = get_tracer_index ( MODEL_ATMOS, 'ice_wat' )
      nqa = get_tracer_index ( MODEL_ATMOS, 'cld_amt' )
      nqn = get_tracer_index ( MODEL_ATMOS, 'liq_drp' )
      nqni = get_tracer_index ( MODEL_ATMOS, 'ice_num' )
      if ( .not. do_lin_cld_microphys ) then
        if (do_clubb > 0 .and. do_liq_num) then
         call MG_microp_3D( Time, is, ie, js, je, lon, lat, dt,                                 &
                            pfull, phalf, zhalf, land,                                          &
                            t, q, tracer(:,:,:,nql), tracer(:,:,:,nqi), tracer(:,:,:,nqa),      &
                            tracer(:,:,:,nqn), tracer(:,:,:,nqni), convective_humidity_area,    &
                            dcond_ls_liquid, dcond_ls_ice,                                      &
                            Ndrop_act_CLUBB, Icedrop_act_CLUBB,                                 &
                            ndust, rbar_dust,                                                   &
                            ttnd, qtnd, q_tnd(:,:,:,nql), q_tnd(:,:,:,nqi), q_tnd(:,:,:,nqa),   &
                            q_tnd(:,:,:,nqn), q_tnd(:,:,:,nqni),                                &
                            rain3d, snow3d, rain, snow,                                         &
                            do_clubb=do_clubb, qcvar_clubb = qcvar_clubb,                       &
                            MASK3d=mask,  &
                            lsc_snow = lsc_snow,    &
                            lsc_rain = lsc_rain, &
                            lsc_snow_size = lsc_snow_size,   &
                            lsc_rain_size = lsc_rain_size )
        elseif ( do_legacy_strat_cloud ) then
          if (do_liq_num) then
            call strat_cloud (Time, is, ie, js, je, dt, pfull, phalf,    & 
                            radturbten, t, q, tracer(:,:,:,nql),         &
                            tracer(:,:,:,nqi), tracer(:,:,:,nqa),        &
                            omega, mc_full, diff_t, land, ttnd, qtnd,    &
                            q_tnd(:,:,:,nql), q_tnd(:,:,:,nqi),          &
                            q_tnd(:,:,:,nqa),  f_snow_berg,  &
                            rain3d, snow3d, snowclr3d, &
                            rain, snow, convective_humidity_ratio,   &
                            convective_humidity_area,     &  
                            limit_conv_cloud_frac, mask=mask,            &
                            qn=tracer(:,:,:,nqn), Aerosol=Aerosol,       &
                            SN=q_tnd(:,:,:,nqn))
          else
            call strat_cloud (Time, is, ie, js, je, dt, pfull, phalf,   & 
                          radturbten, t, q, tracer(:,:,:,nql),        &
                          tracer(:,:,:,nqi), tracer(:,:,:,nqa),      &
                          omega, mc_full, diff_t, land, ttnd, qtnd,    &
                          q_tnd(:,:,:,nql), q_tnd(:,:,:,nqi),   &
                          q_tnd(:,:,:,nqa), f_snow_berg,  &
                          rain3d, snow3d, snowclr3d,  &
                          rain, snow, convective_humidity_ratio,  &
                          convective_humidity_area, &
                          limit_conv_cloud_frac, mask=mask)
          endif  ! do_liq_num
        else  ! do_legacy_strat_cloud
          if (do_ice_num) then
            call strat_cloud_new (Time, is, ie, js, je, dt, pfull, phalf, &
                                  zhalf,  zfull, radturbten, t, q,  &
                                  tracer(:,:,:,nql), tracer(:,:,:,nqi), &
                                  tracer(:,:,:,nqa), omega, mc_full, &
                                  diff_t, land, ttnd, qtnd,           &
                                  q_tnd(:,:,:,nql), q_tnd(:,:,:,nqi),    &
                                  q_tnd(:,:,:,nqa),  f_snow_berg, &
                                  rain3d, snow3d,   &
                                  snowclr3d, rain, snow,       &
                                  convective_humidity_ratio,   &
                                  convective_humidity_area,    &
                                  limit_conv_cloud_frac, Aerosol, &       
                                  mask3d=mask, qn_in=tracer(:,:,:,nqn),  &
                                  SN_out = q_tnd(:,:,:,nqn),             &
                                  qni_in=tracer(:,:,:,nqni),   &
                                  SNi_out = q_tnd(:,:,:,nqni),  &
                                  lsc_snow = lsc_snow,    &
                                  lsc_rain = lsc_rain, &
                                  lsc_snow_size = lsc_snow_size,   &
                                  lsc_rain_size = lsc_rain_size )
          else
            if (do_liq_num) then
              call strat_cloud_new (Time, is, ie, js, je, dt, pfull, phalf, &
                                  zhalf, zfull, radturbten, t, q,   &
                                  tracer(:,:,:,nql), tracer(:,:,:,nqi),  &
                                  tracer(:,:,:,nqa), omega, mc_full, &
                                  diff_t, land, ttnd, qtnd,    &
                                  q_tnd(:,:,:,nql), q_tnd(:,:,:,nqi),   &
                                  q_tnd(:,:,:,nqa), f_snow_berg,   &
                                  rain3d, snow3d,   &
                                  snowclr3d,rain, snow,   &
                                  convective_humidity_ratio,   &
                                  convective_humidity_area,&
                                  limit_conv_cloud_frac, Aerosol,   &
                                  mask3d=mask, qn_in=tracer(:,:,:,nqn),  &
                                  SN_out= q_tnd(:,:,:,nqn),   &
                                  lsc_snow = lsc_snow,      &
                                  lsc_rain = lsc_rain, &
                                  lsc_snow_size = lsc_snow_size,   &
                                  lsc_rain_size = lsc_rain_size )
            else
              call strat_cloud_new (Time, is, ie, js, je, dt, pfull, phalf, &
                                  zhalf, zfull, radturbten, t, q,   &
                                  tracer(:,:,:,nql), tracer(:,:,:,nqi),  &
                                  tracer(:,:,:,nqa), omega, mc_full, &
                                  diff_t, land, ttnd, qtnd,    &
                                  q_tnd(:,:,:,nql), q_tnd(:,:,:,nqi),   &
                                  q_tnd(:,:,:,nqa), f_snow_berg,   &
                                  rain3d, snow3d,   &
                                  snowclr3d,rain, snow,   &
                                  convective_humidity_ratio,   &
                                  convective_humidity_area,&
                                  limit_conv_cloud_frac, Aerosol,   &
                                  mask3d=mask,   &
                                  lsc_snow = lsc_snow,      &
                                  lsc_rain = lsc_rain, &
                                  lsc_snow_size = lsc_snow_size,   &
                                  lsc_rain_size = lsc_rain_size )
            end if  ! do_ice_num
          end if  ! do_liq_num
        end if   ! do_legacy_strat_cloud
      else if ( do_lin_cld_microphys ) then
        nqr = get_tracer_index (MODEL_ATMOS, 'rainwat')
        nqs = get_tracer_index (MODEL_ATMOS, 'snowwat')
        nqg = get_tracer_index (MODEL_ATMOS, 'graupel')
        do k=1,kx
          delp(:,:,k) =  phalf(:,:,k+1) - phalf(:,:,k)
          delz(:,:,k) = (zhalf(:,:,k+1)-zhalf(:,:,k))*t(:,:,k)/tm(:,:,k)
        enddo

        call lin_cld_microphys_driver(q, tracer(:,:,:,nql), tracer(:,:,:,nqr), &
                        tracer(:,:,:,nqi), tracer(:,:,:,nqs), tracer(:,:,:,nqg), &
                        tracer(:,:,:,nqa), qtnd, q_tnd(:,:,:,nql),               &
                        q_tnd(:,:,:,nqr), q_tnd(:,:,:,nqi),                      &
                        q_tnd(:,:,:,nqs), q_tnd(:,:,:,nqg), q_tnd(:,:,:,nqa),    &
                        ttnd, t,   pfull, delz, delp, area,                    &
                        dt, land, rain, snow, ice_lin, graupel_lin,              &
                        hydrostatic, phys_hydrostatic,                           &
                        is, ie, js, je, 1, kx, ktop, kx, Time)

! Add all "solid" form of precipitation into surf_snow
        snow = (snow + ice_lin + graupel_lin) * dt/86400.
        rain =  rain * dt/86400.

! Update tendencies:
        rdt(:,:,:,nqr) = rdt(:,:,:,nqr) + q_tnd(:,:,:,nqr)
        rdt(:,:,:,nqs) = rdt(:,:,:,nqs) + q_tnd(:,:,:,nqs)
        rdt(:,:,:,nqg) = rdt(:,:,:,nqg) + q_tnd(:,:,:,nqg)

        ttnd =  ttnd * dt
        qtnd =  qtnd * dt
        q_tnd(:,:,:,nql) = q_tnd(:,:,:,nql) * dt
        q_tnd(:,:,:,nqi) = q_tnd(:,:,:,nqi) * dt
        q_tnd(:,:,:,nqa) = q_tnd(:,:,:,nqa) * dt

! Update rain_wat, snow_wat, graupel_wat
        tracer(:,:,:,nqr) = tracer(:,:,:,nqr) + q_tnd(:,:,:,nqr)*dt
        tracer(:,:,:,nqs) = tracer(:,:,:,nqs) + q_tnd(:,:,:,nqs)*dt
        tracer(:,:,:,nqg) = tracer(:,:,:,nqg) + q_tnd(:,:,:,nqg)*dt
      endif ! not do_lin_cld_microphys
    
!----------------------------------------------------------------------
!    upon return from strat_cloud, update the cloud liquid, ice and area.
!    update the temperature and specific humidity fields.
!----------------------------------------------------------------------
      tracer(:,:,:,nql) = tracer(:,:,:,nql) + q_tnd(:,:,:,nql)              
      tracer(:,:,:,nqi) = tracer(:,:,:,nqi) + q_tnd(:,:,:,nqi)
      tracer(:,:,:,nqa) = tracer(:,:,:,nqa) + q_tnd(:,:,:,nqa)
      if (do_liq_num) tracer(:,:,:,nqn) =    &
                                   tracer(:,:,:,nqn) + q_tnd(:,:,:,nqn)
      if (do_ice_num) tracer(:,:,:,nqni) =    &
                                   tracer(:,:,:,nqni) + q_tnd(:,:,:,nqni)

!   save the lsc fields for use in radiation package.
      lsc_cloud_area(:,:,:) = tracer(:,:,:,nqa)
      lsc_liquid(:,:,:)  =  tracer(:,:,:,nql)
      lsc_ice(:,:,:) =  tracer(:,:,:,nqi)
      if (do_liq_num) lsc_droplet_number(:,:,:) = tracer(:,:,:,nqn)
      if (do_ice_num) lsc_ice_number(:,:,:) = tracer(:,:,:,nqni)

      t = t + ttnd 
      q = q + qtnd
        
      used = send_data (id_qvout, q, Time, is, js, 1, rmask=mask)
      used = send_data (id_qaout, tracer(:,:,:,nqa), Time, is, js, 1, rmask=mask)
      used = send_data (id_qlout, tracer(:,:,:,nql), Time, is, js, 1, rmask=mask)
      used = send_data (id_qiout, tracer(:,:,:,nqi), Time, is, js, 1, rmask=mask)
      if (do_liq_num) then
      used = send_data (id_qnout, tracer(:,:,:,nqn), Time, is, js, 1, rmask=mask)
      endif
      if (do_ice_num) then
      used = send_data (id_qniout, tracer(:,:,:,nqni), Time, is, js, 1, rmask=mask)
      endif

!----------------------------------------------------------------------
!    call strat_cloud_sum to make the cloud variables available for 
!    access by the radiation package. NOTE: this is no longer necessary,
!    and can be judiciously removed (provided other affiliated code 
!    and options are nullified).
!----------------------------------------------------------------------
     call strat_cloud_sum (is, js, tracer(:,:,:,nql),  &
                             tracer(:,:,:,nqi), tracer(:,:,:,nqa))

!----------------------------------------------------------------------
!    convert increments to tendencies.
!----------------------------------------------------------------------
      ttnd = ttnd*dtinv 
      qtnd = qtnd*dtinv
      rain = rain*dtinv 
      snow = snow*dtinv
      q_tnd(:,:,:,nql) = q_tnd(:,:,:,nql)*dtinv
      q_tnd(:,:,:,nqi) = q_tnd(:,:,:,nqi)*dtinv
      q_tnd(:,:,:,nqa) = q_tnd(:,:,:,nqa)*dtinv
      if (do_liq_num) q_tnd(:,:,:,nqn) = q_tnd(:,:,:,nqn)*dtinv
      if (do_ice_num) q_tnd(:,:,:,nqni) = q_tnd(:,:,:,nqni)*dtinv
   
!----------------------------------------------------------------------
!    update the total tendency terms (temperature, vapor specific 
!    humidity, cloud liquid, cloud ice, cloud area, liquid precip,
!    frozen precip) with the contributions from the strat_cloud scheme.
!----------------------------------------------------------------------
      tdt = tdt + ttnd 
      qdt = qdt + qtnd
      rdt(:,:,:,nql) = rdt(:,:,:,nql) + q_tnd(:,:,:,nql)
      rdt(:,:,:,nqi) = rdt(:,:,:,nqi) + q_tnd(:,:,:,nqi)
      rdt(:,:,:,nqa) = rdt(:,:,:,nqa) + q_tnd(:,:,:,nqa)
      if (do_liq_num) rdt(:,:,:,nqn) = rdt(:,:,:,nqn) + q_tnd(:,:,:,nqn)
      if (do_ice_num)         rdt(:,:,:,nqni) = rdt(:,:,:,nqni) + q_tnd(:,:,:,nqni)
      lprec = lprec + rain
      fprec = fprec + snow

end subroutine moistproc_strat_cloud


!#######################################################################
subroutine moistproc_uw_conv(Time, is, ie, js, je, dt, t, q, u, v, tracer,            &
                             pfull, phalf, zfull, zhalf, omega, pblht,        &
                             ustar, bstar, qstar, land, coldT, Aerosol,       &
                             cush, cbmf, cmf, conv_calc_completed,            &
                             available_cf_for_uw, tdt, qdt, udt, vdt, rdt,    &
                             ttnd_conv, qtnd_conv, lprec, fprec, precip,      &
                             liq_precflx, ice_precflx,    &
                             do_strat, do_limit_uw, do_liq_num, num_tracers,  &
                             tracers_in_uw, num_uw_tracers, shallow_cloud_area,&
                             shallow_liquid, shallow_ice,  &
                             shallow_droplet_number, uw_wetdep, &
                             do_ice_num, detrain_ice_num)

  type(time_type), intent(in)   :: Time
  type(aerosol_type),intent(in) :: Aerosol
  integer, intent(in)           :: is, ie,js, je, num_tracers, num_uw_tracers
  real, intent(in)              :: dt
  logical, intent(in)           :: do_strat, do_limit_uw, do_liq_num
  logical, intent(in), dimension(:)       :: tracers_in_uw
  logical, intent(in), dimension(:,:)     :: coldT, conv_calc_completed
  real, intent(in),    dimension(:,:)     :: land, ustar, bstar, qstar, pblht
  real, intent(in),    dimension(:,:,:)   :: pfull, phalf, zfull, zhalf, omega, &
                                             t, q, u, v, available_cf_for_uw
  real, intent(in),    dimension(:,:,:,:) :: tracer
  real, intent(inout), dimension(:,:)     :: lprec, fprec, precip, cush, cbmf
  real, intent(inout), dimension(:,:,:)   :: tdt, qdt, udt, vdt,   &
                                             ttnd_conv, qtnd_conv, cmf
  real, intent(inout), dimension(:,:,:,:) :: rdt
  real, intent(inout), dimension(:,:,:)   :: shallow_cloud_area, &
                                             shallow_liquid,     &
                                             shallow_ice,        &
                                             shallow_droplet_number
  logical, intent(in )                    :: do_ice_num, detrain_ice_num
  real, intent(out),   dimension(:,:,:)   :: liq_precflx, ice_precflx
  real, intent(out),   dimension(:,:,:)   :: uw_wetdep

  integer :: n, nn, nql, nqi, nqa, nqn, nqni
  real, dimension(size(t,1), size(t,2), size(t,3)) :: thlflx, qtflx, precflx
  real, dimension(size(rdt,1), size(rdt,2), size(rdt,3), num_uw_tracers) :: trcr

      nql = get_tracer_index ( MODEL_ATMOS, 'liq_wat' )
      nqi = get_tracer_index ( MODEL_ATMOS, 'ice_wat' )
      nqa = get_tracer_index ( MODEL_ATMOS, 'cld_amt' )
      nqn = get_tracer_index ( MODEL_ATMOS, 'liq_drp' )
      nqni = get_tracer_index ( MODEL_ATMOS, 'ice_num' )

!----------------------------------------------------------------------
!    if any tracers are to be transported by UW convection, check each
!    active tracer to find those to be transported and fill the 
!    ras_tracers array with these fields.
!---------------------------------------------------------------------
      nn = 1
      do n=1, num_tracers
        if (tracers_in_uw(n)) then
          trcr(:,:,:,nn) = tracer(:,:,:,n)
          nn = nn + 1
        endif
      end do

      call uw_conv (is, js, Time, t, q, u, v, pfull, phalf, zfull, zhalf, &
                    tracer, omega, dt, pblht, ustar, bstar, qstar, land,  &
                    coldT, Aerosol, cush, do_strat,  conv_calc_completed, &
                    available_cf_for_uw, ttnd_uw(is:ie,js:je,:),          &
                    qtnd_uw(is:ie,js:je,:), qltnd_uw(is:ie,js:je,:),      &
                    qitnd_uw(is:ie,js:je,:), qatnd_uw(is:ie,js:je,:),     &
                    qntnd_uw(is:ie,js:je,:),                              &
                    utnd_uw(is:ie,js:je,:), vtnd_uw(is:ie,js:je,:),       &
                    rain_uw(is:ie,js:je), snow_uw(is:ie,js:je), cmf,      &
                    thlflx, qtflx, precflx, liq_precflx, ice_precflx,     &
                    shallow_liquid, shallow_ice, shallow_cloud_area,      &
                    shallow_droplet_number, cbmf, trcr,                   &
                    qtruw(is:ie,js:je,:,:), uw_wetdep)

!-------------------------------------------------------------------------
!    currently qnitnd_uw is the tendency due to detrainment proportional 
!    by ice mass
!-------------------------------------------------------------------------
      IF ( do_ice_num .AND. detrain_ice_num ) THEN
        CALL detr_ice_num (t, qitnd_uw(is:ie,js:je,:),  &
                                              qnitnd_uw(is:ie,js:je,:) )
      else
        qnitnd_uw(is:ie,js:je,:) = 0.
      END IF

      if (.not. do_limit_uw) then
        tdt=tdt+ttnd_uw(is:ie,js:je,:) 
        qdt=qdt+qtnd_uw(is:ie,js:je,:)
        udt=udt+utnd_uw(is:ie,js:je,:)
        vdt=vdt+vtnd_uw(is:ie,js:je,:)
        ttnd_conv = ttnd_conv + ttnd_uw(is:ie,js:je,:)
        qtnd_conv = qtnd_conv + qtnd_uw(is:ie,js:je,:)
        lprec=lprec+rain_uw(is:ie,js:je)
        fprec=fprec+snow_uw(is:ie,js:je)
        precip=precip+rain_uw(is:ie,js:je)+snow_uw(is:ie,js:je)

        if (do_strat) then
          rdt(:,:,:,nql) = rdt(:,:,:,nql) + qltnd_uw(is:ie,js:je,:)
          rdt(:,:,:,nqi) = rdt(:,:,:,nqi) + qitnd_uw(is:ie,js:je,:)
          rdt(:,:,:,nqa) = rdt(:,:,:,nqa) + qatnd_uw(is:ie,js:je,:)
          if (do_liq_num) rdt(:,:,:,nqn) = rdt(:,:,:,nqn) +   &
                                                 qntnd_uw(is:ie,js:je,:)
          if (do_ice_num) rdt(:,:,:,nqni) = rdt(:,:,:,nqni) +    &
                                                  qnitnd_uw(is:ie,js:je,:)
        endif

!---------------------------------------------------------------------
!    update the current tracer tendencies with the contributions 
!    just obtained from uw transport.
!---------------------------------------------------------------------
        nn = 1
        do n=1, num_tracers
          if (tracers_in_uw(n)) then
            rdt(:,:,:,n) = rdt(:,:,:,n) + qtruw(is:ie,js:je,:,nn)
            nn = nn + 1
          endif
        end do
      endif  !(.not. do_limit_uw)

end subroutine moistproc_uw_conv


!#######################################################################
subroutine moistproc_scale_donner(is,ie,js,je,q, delta_temp, delta_q, precip_returned,      &
                                  total_precip, lheat_precip, liquid_precip,    &
                                  frozen_precip, num_tracers, tracers_in_donner,&
                                  qtr, scale)

  integer, intent(in) :: is, ie, js, je, num_tracers
  logical, intent(in), dimension(:)       :: tracers_in_donner
  real, intent(inout), dimension(:,:)     :: precip_returned, total_precip, &
                                             lheat_precip
  real, intent(inout), dimension(:,:,:)   :: q, delta_temp, delta_q,    &
                                             liquid_precip, frozen_precip
  real, intent(inout), dimension(:,:,:,:) :: qtr
  real, intent(out),   dimension(:,:)     :: scale

  integer :: n, nn, i, j, k, ix, jx, kx
  real    :: qvin, dqv
  real, dimension(size(q,1), size(q,2), size(q,3)) :: temp

      ix = size(q,1)
      jx = size(q,2)
      kx = size(q,3)

!     Tendencies coming out of Donner deep are adjusted to prevent
!     the formation of negative water vapor, liquid or ice.

!     (1) Prevent negative liquid and ice specific humidities after
!     tendencies are applied

      where ((qlin(is:ie,js:je,:)+delta_ql(is:ie,js:je,:)) .lt. 0.)
        delta_temp(:,:,:)  = delta_temp (:,:,:) - (qlin(is:ie,js:je,:)+delta_ql(is:ie,js:je,:))*HLV/CP_AIR
        delta_q(:,:,:)     = delta_q    (:,:,:) + (qlin(is:ie,js:je,:)+delta_ql(is:ie,js:je,:))
        delta_ql(is:ie,js:je,:)    = delta_ql   (is:ie,js:je,:) - (qlin(is:ie,js:je,:)+delta_ql(is:ie,js:je,:))
      end where

      where ((qiin(is:ie,js:je,:)+delta_qi(is:ie,js:je,:)) .lt. 0.)
        delta_temp(:,:,:)  = delta_temp (:,:,:) - (qiin(is:ie,js:je,:)+delta_qi(is:ie,js:je,:))*HLS/CP_AIR
        delta_q(:,:,:)     = delta_q    (:,:,:) + (qiin(is:ie,js:je,:)+delta_qi(is:ie,js:je,:))
        delta_qi(is:ie,js:je,:)    = delta_qi   (is:ie,js:je,:) - (qiin(is:ie,js:je,:)+delta_qi(is:ie,js:je,:))
      end where

      where (abs(delta_ql(is:ie,js:je,:) + delta_qi(is:ie,js:je,:)) .lt. 1.e-10 )
        delta_qa(is:ie,js:je,:) = 0.0
      end where

!     (2) Compute limit on Donner tendencies to prevent water vapor
!     from going below 1.e-10. The value of 1.e-10 is consistent with qmin
!      in strat_cloud.F90

!     scaling factor for each grid point
      temp = 1.0
      do k=1,kx
       do j=1,jx
        do i=1,ix
          qvin = q(i,j,k)
          dqv  = delta_q    (i,j,k)
          if ( dqv.lt.0 .and. qvin+dqv.lt.1.e-10 ) then
            temp(i,j,k) = max( 0.0, -(qvin-1.e-10)/dqv )
          endif
        end do
       end do
      end do

!     scaling factor for each column is the minimum value within that column
      scale = minval( temp, dim=3 )

!     scale tendencies
      do k=1,kx
        delta_temp(:,:,k)  = scale(:,:) * delta_temp(:,:,k)
        delta_q(:,:,k)     = scale(:,:) * delta_q    (:,:,k)
        delta_qa(is:ie,js:je,k)    = scale(:,:) * delta_qa(is:ie,js:je,k)
        delta_ql(is:ie,js:je,k)    = scale(:,:) * delta_ql(is:ie,js:je,k)
        delta_qi(is:ie,js:je,k)    = scale(:,:) * delta_qi(is:ie,js:je,k)
      end do

      nn = 1
      do n=1, num_tracers
        if (tracers_in_donner(n)) then
          do k=1,kx
            qtr(:,:,k,nn) = scale(:,:) * qtr(:,:,k,nn)
          end do
          nn = nn + 1
        endif
      end do

      precip_returned = scale*precip_returned

      total_precip = scale*total_precip
      lheat_precip = scale*lheat_precip
      do k=1, kx
        liquid_precip(:,:,k) = scale(:,:)*liquid_precip(:,:,k)
        frozen_precip(:,:,k) = scale(:,:)*frozen_precip(:,:,k)
      end do

end subroutine moistproc_scale_donner


!#######################################################################
subroutine moistproc_scale_uw(is,ie,js,je, dt, q, tracer, tdt, qdt, udt, vdt, rdt,    &
                              ttnd_conv, qtnd_conv, lprec, fprec, precip,&
                              do_strat, do_liq_num, num_tracers,         &
                              tracers_in_uw, scale, do_ice_num)

  integer, intent(in)           :: is, ie, js, je, num_tracers
  real, intent(in)              :: dt
  logical, intent(in)           :: do_strat, do_liq_num, do_ice_num
  logical, intent(in), dimension(:)       :: tracers_in_uw
  real, intent(in),    dimension(:,:,:)   :: q
  real, intent(in),    dimension(:,:,:,:) :: tracer
  real, intent(inout), dimension(:,:)     :: lprec, fprec, precip
  real, intent(inout), dimension(:,:,:)   :: tdt, qdt, udt, vdt,  &
                                             ttnd_conv, qtnd_conv
  real, intent(inout), dimension(:,:,:,:) :: rdt
  real, intent(out),   dimension(:,:)     :: scale

  integer :: n, nn, i, j, k, ix, jx, kx, nql, nqi, nqa, nqn, nqni
  real    :: qvin, dqv
  real, dimension(size(q,1), size(q,2), size(q,3)) :: temp

      ix = size(q,1)
      jx = size(q,2)
      kx = size(q,3)
      nql = get_tracer_index ( MODEL_ATMOS, 'liq_wat' )
      nqi = get_tracer_index ( MODEL_ATMOS, 'ice_wat' )
      nqa = get_tracer_index ( MODEL_ATMOS, 'cld_amt' )
      nqn = get_tracer_index ( MODEL_ATMOS, 'liq_drp' )
      nqni = get_tracer_index ( MODEL_ATMOS, 'ice_num' )

!----------------------------------------------------------------------

!      Tendencies coming out of UW shallow are adjusted to prevent
!      the formation of negative water vapor, liquid or ice.
 
!      (1) Prevent negative liquid and ice specific humidities after tendencies are applied
       temp = tracer(:,:,:,nql)/dt + qltnd_uw(is:ie,js:je,:)
       where (temp(:,:,:) .lt. 0.)
         ttnd_uw(is:ie,js:je,:)  = ttnd_uw(is:ie,js:je,:)  - temp(:,:,:)*HLV/CP_AIR
         qtnd_uw(is:ie,js:je,:)  = qtnd_uw(is:ie,js:je,:)  + temp(:,:,:)
         qltnd_uw(is:ie,js:je,:) = qltnd_uw(is:ie,js:je,:) - temp(:,:,:)
       end where

       temp = tracer(:,:,:,nqi)/dt + qitnd_uw(is:ie,js:je,:)
       where (temp .lt. 0.)
         ttnd_uw(is:ie,js:je,:)  = ttnd_uw(is:ie,js:je,:)  - temp(:,:,:)*HLS/CP_AIR
         qtnd_uw(is:ie,js:je,:)  = qtnd_uw(is:ie,js:je,:)  + temp(:,:,:)
         qitnd_uw(is:ie,js:je,:) = qitnd_uw(is:ie,js:je,:) - temp(:,:,:)
       end where

       where (abs(qltnd_uw(is:ie,js:je,:)+qitnd_uw(is:ie,js:je,:))*dt .lt. 1.e-10 )
         qatnd_uw(is:ie,js:je,:) = 0.0
       end where

!      (2) Compute limit on UW tendencies to prevent water vapor
!      from going below 1.e-10. The value of 1.e-10 is consistent with qmin
!      in strat_cloud.F90

!      scaling factor for each grid point

       temp = 1.0
       do k=1,kx
        do j=1,jx
         do i=1,ix
           qvin = q(i,j,k) + tracer(i,j,k,nql) + tracer(i,j,k,nqi)
           dqv  = ( qtnd_uw(i+is-1,j+js-1,k) + qltnd_uw(i+is-1,j+js-1,k) + qitnd_uw(i+is-1,j+js-1,k) )*dt
           if ( dqv.lt.0 .and. qvin+dqv.lt.1.e-10 ) then
             temp(i,j,k) = max( 0.0, -(qvin-1.e-10)/dqv )
           endif
         end do
        end do
       end do

!      scaling factor for each column is the minimum value within that column
       scale = minval( temp, dim=3 )

!      scale tendencies
       do k=1,kx
         utnd_uw(is:ie,js:je,k)  = scale(:,:) * utnd_uw(is:ie,js:je,k)
         vtnd_uw(is:ie,js:je,k)  = scale(:,:) * vtnd_uw(is:ie,js:je,k)
         ttnd_uw(is:ie,js:je,k)  = scale(:,:) * ttnd_uw(is:ie,js:je,k)
         qtnd_uw(is:ie,js:je,k)  = scale(:,:) * qtnd_uw(is:ie,js:je,k)
         qltnd_uw(is:ie,js:je,k) = scale(:,:) * qltnd_uw(is:ie,js:je,k)
         qitnd_uw(is:ie,js:je,k) = scale(:,:) * qitnd_uw(is:ie,js:je,k)
         qatnd_uw(is:ie,js:je,k) = scale(:,:) * qatnd_uw(is:ie,js:je,k)
       end do

       if (do_liq_num) then
         do k=1,kx
          qntnd_uw(is:ie,js:je,k) = scale(:,:) * qntnd_uw(is:ie,js:je,k)
         end do
       end if

       if (do_ice_num) then
         do k=1,kx
           qnitnd_uw(is:ie,js:je,k) = scale(:,:) * qnitnd_uw(is:ie,js:je,k)
         end do
       end if
       rain_uw(is:ie,js:je) = scale(:,:) * rain_uw(is:ie,js:je)
       snow_uw(is:ie,js:je) = scale(:,:) * snow_uw(is:ie,js:je)

!      update tendencies
       tdt=tdt+ttnd_uw(is:ie,js:je,:)
       qdt=qdt+qtnd_uw(is:ie,js:je,:)
       udt=udt+utnd_uw(is:ie,js:je,:)
       vdt=vdt+vtnd_uw(is:ie,js:je,:)
       ttnd_conv = ttnd_conv + ttnd_uw(is:ie,js:je,:)
       qtnd_conv = qtnd_conv + qtnd_uw(is:ie,js:je,:)

!      update precipitation
       lprec=lprec+rain_uw(is:ie,js:je)
       fprec=fprec+snow_uw(is:ie,js:je)
       precip=precip+rain_uw(is:ie,js:je)+snow_uw(is:ie,js:je)

       if (do_strat) then
         rdt(:,:,:,nql) = rdt(:,:,:,nql) + qltnd_uw(is:ie,js:je,:)
         rdt(:,:,:,nqi) = rdt(:,:,:,nqi) + qitnd_uw(is:ie,js:je,:)
         rdt(:,:,:,nqa) = rdt(:,:,:,nqa) + qatnd_uw(is:ie,js:je,:)
         if (do_liq_num) rdt(:,:,:,nqn) = rdt(:,:,:,nqn) +    &
                                                 qntnd_uw(is:ie,js:je,:)
         if (do_ice_num) rdt(:,:,:,nqni) = rdt(:,:,:,nqni) +  &
                                                 qnitnd_uw(is:ie,js:je,:)
       endif

!------------------------------------------------------------------------
!      update the current tracer tendencies with the contributions 
!      obtained from uw transport.
!------------------------------------------------------------------------
       nn = 1
       do n=1, num_tracers
         if (tracers_in_uw(n)) then
           rdt(:,:,:,n) = rdt(:,:,:,n) + qtruw (is:ie,js:je,:,nn)
           nn = nn + 1
         endif
       end do

!-------------------------------------------------------------------------

end subroutine moistproc_scale_uw



!#########################################################################



end module moistproc_kernels_mod

module atmos_grid_mod
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">Z. Liang </CONTACT>
  ! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">S. M. Griffies</REVIEWER>


  !<OVERVIEW>
  ! <TT>atmos_grid_mod</TT> Generate horizontal grid ( either bgrid or spectral grid )
  !     for atmosphere and land model. 
  !</OVERVIEW>

  !<DESCRIPTION>
  ! There are four subgrids, labeled T (for tracer), C (corner of T), N (north of T) 
  ! and E (east of T). The following schematic describes the grid cell notation.
  !
  !
  !<PRE>
  !                          Ni,j
  !               +----------+-----------+Ci,j
  !               |                      |     
  !               |                      |
  !               |                      |
  !               +          +Ti,j       +Ei,j
  !               |                      |
  !               |                      |
  !               +----------+-----------+
  !
  !                          
  !</PRE>
  !
  ! The grid_spec file would contains all of the following information.
  !
  !<PRE>
  !   x_T, y_T           = Geographic location of T-cell center
  !   x_vert_T, y_vert_T = Geographic location of T-cell vertices(each cell has 4 vertices)
  !   x_C, y_C           = Geographic location of C-cell center
  !
  !</PRE>
  !
  !</DESCRIPTION>

  use mpp_mod,        only : mpp_pe, mpp_root_pe, mpp_chksum, mpp_error, FATAL, NOTE
  use mpp_io_mod,     only : mpp_write_meta, mpp_write, axistype, fieldtype
  use fms_mod,        only : write_version_number, file_exist, stdout, field_size, string
  use fms_mod,        only : open_namelist_file, close_file, check_nml_error, read_data
  use transforms_mod, only : transforms_init, get_grid_boundaries, get_deg_lon, get_deg_lat 
  use constants_mod,  only : PI, RADIUS

  implicit none
  private

  !------ namelist interface ---------------------------------------------
  !<NAMELIST NAME="atmos_grid_nml">
  !<DATA NAME="grid_type" TYPE="character(len=24)" >
  !  type of grid. Its value can be "bgrid" or "spectral". Its default value is "bgrid". 
  !</DATA>
  !<DATA NAME="debug" TYPE="logical">
  ! control standard output.
  !</DATA>
  !<DATA NAME="num_lon" TYPE="integer">
  ! number of longitude points.
  !</DATA>
  !<DATA NAME="num_lat" TYPE="integer">
  ! number of latitude points.
  ! </DATA>
  !<DATA NAME="num_fourier" TYPE="integer">
  ! the fourier wavenumbers in the truncation are set equal to fourier_inc*m, where m = 0, 
  ! num_fourier therefore, the total number of fourier modes is num_fourier +1. 
  ! This namelist option is only for grid_type = 'spectral'
  ! </DATA>
  !<DATA NAME="num_spherical" TYPE="integer">
  ! the wavenumber increment (see num_fourier above). This namelist option is only
  ! for grid_type = 'spectral'
  ! </DATA>
  !<DATA NAME="fourier_inc" TYPE="integer">
  ! the maximum meridional wavenumber Retained meridional wavewnumbers are n = 0,
  ! num_spherical The total spherical wavenumber is L = n+m. This namelist option is only
  ! for grid_type = 'spectral'
  ! </DATA>
  !<DATA NAME="lon_begin, lon_end" TYPE="real" >
  !  range of the longitude. Default value is : lon_begin=0, lon_end=360. If you want to
  !  generate regional grid, you may need to set these namelists. Otherwise use default value. 
  !  This namelist option is only for grid_type = 'bgrid'
  ! </DATA>
  !<DATA NAME="lat_begin, lat_end" TYPE="real" >
  !  range of the latitude. Default value is : lat_begin=-90, lat_end=90. If you want to
  !  generate regional grid, you may need to set these namelists. Otherwise use default value. 
  !  This namelist option is only for grid_type = 'bgrid'
  ! </DATA>
  !</NAMELIST>
  character(len=24) :: grid_type = 'bgrid'
  logical           :: debug = .false.
  integer           :: num_lon = 0
  integer           :: num_lat = 0
  integer           :: num_fourier = 0
  integer           :: num_spherical = 0
  integer           :: fourier_inc = 1
  real              :: lon_begin = 0.0
  real              :: lon_end   = 360.0
  real              :: lat_begin = -90.0
  real              :: lat_end   = 90.0

  namelist /atmos_grid_nml/ debug, grid_type, num_lon, num_lat, num_fourier, num_spherical, &
       fourier_inc, lon_begin, lon_end, lat_begin, lat_end

  !<PUBLICTYPE >
  type atmos_grid_type
     real, dimension(:,:), pointer   :: x_T => NULL()      ! geographical longitude of T-cell center
     real, dimension(:,:), pointer   :: y_T => NULL()      ! geographical latitude of T-cell center 
     real, dimension(:,:), pointer   :: x_C => NULL()      ! geographical longitude of C-cell center
     real, dimension(:,:), pointer   :: y_C => NULL()      ! geographical latitude of C-cell center 
     real, dimension(:,:,:), pointer :: x_vert_T => NULL() ! geographical longitude of T-cell vertices
     real, dimension(:,:,:), pointer :: y_vert_T => NULL() ! geographical latitude of T-cell vertices
  end type atmos_grid_type
  !</PUBLICTYPE>

  !-----------------------------------------------------------------------
  !--------private data---------------------------------------------------
  logical :: module_is_initialized = .false.

  !---  axis and field data type for output file -----------------------
  type(axistype),save  :: axis_xt, axis_yt, axis_xc, axis_yc, axis_v
  type(fieldtype),save :: fld_x_T, fld_y_T, fld_x_vert_T, fld_y_vert_T, fld_x_C, fld_y_C

  !---------version information-------------------------------------------
  character(len=128) :: version = '$Id: atmos_grid.f90,v 10.0 2003/10/24 22:01:43 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $' 
  !---------public interface----------------------------------------------
  public :: generate_atmos_grid, atmos_grid_init, atmos_grid_end, atmos_grid_type
  public :: write_atmos_grid_meta, write_atmos_grid_data

contains

  !#######################################################################
  ! <SUBROUTINE NAME="atmos_grid_init" >
  !   <OVERVIEW>
  !    Initialization routine.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !    Read namelist, write out version and namelist informaiton.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call atmos_grid_init ( )
  !   </TEMPLATE>
  ! </SUBROUTINE>

  subroutine atmos_grid_init 

    !--- local variables -------------------------------------------------
    integer ::  unit, ierr, io

    !---- read namelist --------------------------------------------------
    if (file_exist('input.nml')) then
       unit = open_namelist_file ( )
       ierr=1
       do while (ierr /= 0)
          read  (unit, nml=atmos_grid_nml, iostat=io, end=10)
          ierr = check_nml_error(io,'atmos_grid_nml')  ! also initializes nml error codes
       enddo
10     call close_file (unit)
    else
       call mpp_error(FATAL,'grid_generator: file input.nml does not exist')
    endif
    !--- write version info and namelist to logfile ----------------------

    call write_version_number(version, tagname)
    write (stdout(), nml=atmos_grid_nml)

    module_is_initialized = .true.

    !--- check namelist value
    if(trim(grid_type) .ne. 'bgrid' .and. trim(grid_type) .ne. 'spectral') &
         call mpp_error(FATAL,'atmos_grid_mod: '//trim(grid_type)//' is not a valid option of nml "grid_type" ')

    if(num_lon .le. 0 .or. num_lat .le. 0) then
       call mpp_error(FATAL, 'atmos_grid_mod: nml num_lon= '//trim(string(num_lon))//' and num_lat= ' &
            //trim(string(num_lat))//' should be positive number')
    endif

    if(trim(grid_type) == 'spectral') then
       if(num_fourier == 0 .or. num_spherical == 0) &
            call mpp_error(FATAL, 'atmos_grid_mod: nml "num_fourier"= '//trim(string(num_fourier))// &
            ' and "num_spherical"= '// trim(string(num_spherical))//' shoulbe be positive number')
    else   ! grid_type == bgrid
       if(lon_begin .ge. lon_end ) &
            call mpp_error(FATAL, 'atmos_grid_mod: nml lon_begin= '//trim(string(lon_begin))// &
            ' should be less than nml "lon_end"= '//trim(string(lon_end)) )
       if(lat_begin .ge. lat_end ) &
            call mpp_error(FATAL, 'atmos_grid_mod: nml lat_begin= '//trim(string(lat_begin))// &
            ' should be less than nml "lat_end"= '//trim(string(lat_end)) )
    endif

  end subroutine atmos_grid_init


  !#######################################################################
  ! <SUBROUTINE NAME="generate_atmos_grid" >
  !   <OVERVIEW>
  !    Generate horizontal grid.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !    Calculate geographic locations of T and C-cell center. 
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call generat_atmos_grid (Hgrid)
  !   </TEMPLATE>
  !   <INOUT NAME="Hgrid" TYPE="atmos_grid_type">
  !     A derived-type variable that contains horizontal grid information.
  !   </INOUT>
  ! </SUBROUTINE>

  subroutine generate_atmos_grid (Hgrid)

    type(atmos_grid_type), intent(inout) :: Hgrid

    select case(trim(grid_type))
    case('bgrid')
       call generate_bgrid (Hgrid)
    case('spectral')
       call generate_spectral_grid (Hgrid)
    end select

  end subroutine generate_atmos_grid

  !#######################################################################
  !--- generate spectral horizontal grid
  subroutine generate_spectral_grid (Hgrid)

    type(atmos_grid_type), intent(inout) :: Hgrid

    real    :: dlon, dlat, R2D 
    integer :: i, j, pe, root_pe
    integer :: chksum_x_t, chksum_y_t, chksum_x_c, chksum_y_c, chksum_x_vert_t, chksum_y_vert_t
    real, allocatable, dimension(:) :: lonb, latb, deg_lon, deg_lat

    R2D = 180./PI
    pe       = mpp_pe()
    root_pe  = mpp_root_pe()

    call transforms_init(RADIUS, num_lat, num_lon, num_fourier, fourier_inc, num_spherical)

    allocate(lonb(num_lon+1), latb(num_lat+1))
    allocate(deg_lon(num_lon), deg_lat(num_lat))
    call get_deg_lon(deg_lon)
    call get_deg_lat(deg_lat)
    call get_grid_boundaries(lonb, latb, global=.true.)
    allocate(hgrid%x_C(num_lon,num_lat), hgrid%y_C(num_lon,num_lat), &
         hgrid%x_T(num_lon,num_lat), hgrid%y_T(num_lon,num_lat), &
         hgrid%x_vert_T(num_lon,num_lat,4), hgrid%y_vert_T(num_lon,num_lat,4))

    do i=1,num_lon
       hgrid%x_C(i,:) = lonb(i+1)*R2D
       hgrid%x_T(i,:) = deg_lon(i)
       hgrid%x_vert_T(i,:,1) = lonb(i)*R2D
       hgrid%x_vert_T(i,:,2) = lonb(i+1)*R2D
       hgrid%x_vert_T(i,:,3) = lonb(i+1)*R2D
       hgrid%x_vert_T(i,:,4) = lonb(i)*R2D
    enddo

    do j=1,num_lat
       hgrid%y_C(:,j) = latb(j+1)*R2D
       hgrid%y_T(:,j) = deg_lat(j)
       hgrid%y_vert_T(:,j,1) = latb(j)*R2D
       hgrid%y_vert_T(:,j,2) = latb(j)*R2D
       hgrid%y_vert_T(:,j,3) = latb(j+1)*R2D
       hgrid%y_vert_T(:,j,4) = latb(j+1)*R2D
    enddo

    ! Print all grid coordinates

    write (stdout(),'(//,36x,a,/)') 'H G R I D   G E N E R A T I O N'
    write (stdout(),'(/)')
    write (stdout(),9105) num_lat
    write (stdout(),9001) (hgrid%y_T(1,j),j=1,num_lat)
    write (stdout(),9106) num_lat
    write (stdout(),9001) (hgrid%y_C(1,j),j=1,num_lat)
    write (stdout(),9107) num_lon
    write (stdout(),9001) (hgrid%x_T(i,1),i=1,num_lon)
    write (stdout(),9108) num_lon
    write (stdout(),9001) (hgrid%x_T(i,1),i=1,num_lon)
    write (stdout(),'(/)')

    if(debug) then
       chksum_x_t = mpp_chksum(Hgrid%x_T,(/pe/))
       chksum_y_t = mpp_chksum(Hgrid%y_T,(/pe/))
       chksum_x_c = mpp_chksum(Hgrid%x_C,(/pe/))
       chksum_y_c = mpp_chksum(Hgrid%y_C,(/pe/))
       chksum_x_vert_t = mpp_chksum(Hgrid%x_vert_T,(/pe/))
       chksum_y_vert_t = mpp_chksum(Hgrid%y_vert_T,(/pe/))
       write (stdout(),'(/(a,I20/))')'spectral_hgrid chksum: chksum_x_T = ', chksum_x_t
       write (stdout(),'(/(a,I20/))')'spectral_hgrid chksum: chksum_y_T = ', chksum_y_t
       write (stdout(),'(/(a,I20/))')'spectral_hgrid chksum: chksum_x_C = ', chksum_x_c
       write (stdout(),'(/(a,I20/))')'spectral_hgrid chksum: chksum_y_c = ', chksum_y_c
       write (stdout(),'(/(a,I20/))')'spectral_hgrid chksum: chksum_x_vert_T = ', chksum_x_vert_t
       write (stdout(),'(/(a,I20/))')'spectral_hgrid chksum: chksum_y_vert_T = ', chksum_y_vert_t
    endif

    deallocate(lonb, latb, deg_lon, deg_lat)
    return

9001 format (1x,10f10.4)
9105 format (/,' Latitude of T points (deg): yt(j) j=1,',i4)
9106 format (/,' Latitude of C points (deg): yu(j) j=1,',i4)
9107 format (/,' Longitude of T points (deg): xt(i) i=1,',i4)
9108 format (/,' Longitude of C points (deg): xu(i) i=1,',i4)
  end subroutine generate_spectral_grid

  !#####################################################################
  !--- generate horizontal bgrid
  subroutine generate_bgrid (hgrid)

    type(atmos_grid_type), intent(inout) :: hgrid

    real    :: dlon, dlat
    integer :: i, j, pe
    integer :: chksum_x_t, chksum_y_t, chksum_x_c, chksum_y_c, chksum_x_vert_t, chksum_y_vert_t

    pe       = mpp_pe()

    allocate(hgrid%x_C(num_lon,num_lat), hgrid%y_C(num_lon,num_lat), &
         hgrid%x_T(num_lon,num_lat), hgrid%y_T(num_lon,num_lat), &
         hgrid%x_vert_T(num_lon,num_lat,4), hgrid%y_vert_T(num_lon,num_lat,4))

    dlon = (lon_end-lon_begin)/num_lon
    dlat = (lat_end-lat_begin)/num_lat

    do i=1,num_lon
       hgrid%x_C(i,:)        = lon_begin + dlon*real(i)
       hgrid%x_T(i,:)        = lon_begin + dlon*(i-.5)
       hgrid%x_vert_T(i,:,1) = lon_begin + dlon*(i-1.0)
       hgrid%x_vert_T(i,:,2) = lon_begin + dlon*real(i)
       hgrid%x_vert_T(i,:,3) = lon_begin + dlon*real(i)
       hgrid%x_vert_T(i,:,4) = lon_begin + dlon*(i-1.0)
    enddo

    do j=1,num_lat
       hgrid%y_C(:,j)        = lat_begin + dlat*real(j)
       hgrid%y_T(:,j)        = lat_begin + dlat*(j-.5) 
       hgrid%y_vert_T(:,j,1) = lat_begin + dlat*real(j-1.0)
       hgrid%y_vert_T(:,j,2) = lat_begin + dlat*real(j-1.0)
       hgrid%y_vert_T(:,j,3) = lat_begin + dlat*real(j)
       hgrid%y_vert_T(:,j,4) = lat_begin + dlat*real(j)

    enddo

    ! Print all grid coordinates

    write (stdout(),'(//,36x,a,/)') 'H G R I D   G E N E R A T I O N'
    write (stdout(),'(/)')
    write (stdout(),9105) num_lat
    write (stdout(),9001) (hgrid%y_T(1,j),j=1,num_lat)
    write (stdout(),9106) num_lat
    write (stdout(),9001) (hgrid%y_C(1,j),j=1,num_lat)
    write (stdout(),9107) num_lon
    write (stdout(),9001) (hgrid%x_T(i,1),i=1,num_lon)
    write (stdout(),9108) num_lon
    write (stdout(),9001) (hgrid%x_C(i,1),i=1,num_lon)
    write (stdout(),'(/)')

    if(debug ) then
       chksum_x_t = mpp_chksum(Hgrid%x_T,(/pe/))
       chksum_y_t = mpp_chksum(Hgrid%y_T,(/pe/))
       chksum_x_c = mpp_chksum(Hgrid%x_C,(/pe/))
       chksum_y_c = mpp_chksum(Hgrid%y_C,(/pe/))
       chksum_x_vert_t = mpp_chksum(Hgrid%x_vert_T,(/pe/))
       chksum_y_vert_t = mpp_chksum(Hgrid%y_vert_T,(/pe/))
       write (stdout(),'(/(a,I20/))')'bgrid_hgrid chksum: chksum_x_T = ', chksum_x_t
       write (stdout(),'(/(a,I20/))')'bgrid_hgrid chksum: chksum_y_T = ', chksum_y_t
       write (stdout(),'(/(a,I20/))')'bgrid_hgrid chksum: chksum_x_C = ', chksum_x_c
       write (stdout(),'(/(a,I20/))')'bgrid_hgrid chksum: chksum_y_c = ', chksum_y_c
       write (stdout(),'(/(a,I20/))')'bgrid_hgrid chksum: chksum_x_vert_T = ', chksum_x_vert_t
       write (stdout(),'(/(a,I20/))')'bgrid_hgrid chksum: chksum_y_vert_T = ', chksum_y_vert_t
    endif

    return
9001 format (1x,10f10.4)
9105 format (/,' Latitude of T points (deg): yt(j) j=1,',i4)
9106 format (/,' Latitude of C points (deg): yu(j) j=1,',i4)
9107 format (/,' Longitude of T points (deg): xt(i) i=1,',i4)
9108 format (/,' Longitude of C points (deg): xu(i) i=1,',i4)

  end subroutine generate_bgrid

  !#######################################################################
  ! <SUBROUTINE NAME="write_atmos_grid_data">
  !   <OVERVIEW>
  !     write the Hgrid data to netcdf file
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     call write_atmos_grid_data (unit,Hgrid)
  !   </TEMPLATE>
  !   <IN NAME="unit" TYPE="integer" >
  !     The unit corresponding the output netcdf file. Always is returned by mpp_open.
  !   </IN>
  !   <IN NAME="Hgrid" TYPE="atmos_grid_type">
  !     A derived-type variable that contains horizontal grid information.
  !   </IN>
  ! </SUBROUTINE>

  subroutine write_atmos_grid_data (unit,Hgrid)
    integer,               intent(in) :: unit
    type(atmos_grid_type), intent(in) :: Hgrid

    !--- write out axis data
    call mpp_write(unit, axis_xt)
    call mpp_write(unit, axis_yt)
    call mpp_write(unit, axis_xc)
    call mpp_write(unit, axis_yc)
    call mpp_write(unit, axis_v)

    call mpp_write(unit, fld_x_T, hgrid%x_T)
    call mpp_write(unit, fld_y_T, hgrid%y_T)
    call mpp_write(unit, fld_x_C, hgrid%x_C)
    call mpp_write(unit, fld_y_C, hgrid%y_C)
    call mpp_write(unit, fld_x_vert_T, hgrid%x_vert_T)
    call mpp_write(unit, fld_y_vert_T, hgrid%y_vert_T)  

    return

  end subroutine write_atmos_grid_data

  !#######################################################################
  ! <SUBROUTINE NAME="write_atmos_grid_meta">

  !   <OVERVIEW>
  !     Write out horizontal grid meta data.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     call write_atmos_grid_meta(unit, Hgrid)
  !   </TEMPLATE>
  !   <IN NAME="unit" TYPE="integer" >
  !     The unit corresponding the output netcdf file. Always is returned by mpp_open.
  !   </IN>
  !   <IN NAME="Hgrid" TYPE="atmos_grid_type">
  !     A derived-type variable that contains horizontal grid information.
  !   </IN>
  ! </SUBROUTINE>

  subroutine write_atmos_grid_meta(unit, Hgrid )
    integer,               intent(in) :: unit
    type(atmos_grid_type), intent(in) :: Hgrid

    !--- write out axis meta ----------------------------------------
    call mpp_write_meta(unit, axis_xt,'grid_x_T','degree_east','Nominal Longitude of T-cell center', &
         cartesian ='X', data = hgrid%x_T(:,1) )
    call mpp_write_meta(unit, axis_yt,'grid_y_T','degree_north','Nominal Latitude of T-cell center', &
         cartesian ='Y', data = hgrid%y_T(1,:) )
    call mpp_write_meta(unit, axis_xc,'grid_x_C','degree_east','Nominal Longitude of C-cell center', &
         cartesian ='X', data = hgrid%x_C(:,1) )
    call mpp_write_meta(unit, axis_yc,'grid_y_C','degree_north','Nominal Latitude of C-cell center', &
         cartesian ='Y', data = hgrid%y_C(1,:) )
    call mpp_write_meta(unit, axis_v, 'vertex', 'none ', 'Vertex position from southwest couterclockwise', &
         data = (/1.,2.,3.,4./) )
    call mpp_write_meta(unit, fld_x_T, (/axis_xt, axis_yt/), 'x_T', 'degree_east',  &
         'Geographic longitude of T_cell centers', pack=1)
    call mpp_write_meta(unit, fld_y_T, (/axis_xt, axis_yt/), 'y_T', 'degree_north',  &
         'Geographic latitude of T_cell centers', pack=1)
    call mpp_write_meta(unit, fld_x_C, (/axis_xc, axis_yc/), 'x_C', 'degree_east',  &
         'Geographic longitude of C_cell centers', pack=1)
    call mpp_write_meta(unit, fld_y_C, (/axis_xc, axis_yc/), 'y_C', 'degree_north',  &
         'Geographic latitude of C_cell centers', pack=1)
    call mpp_write_meta(unit, fld_x_vert_T, (/axis_xt, axis_yt, axis_v/), 'x_vert_T', &
         'degree_east', 'Geographic longitude of T_cell vertices begin southwest counterclockwise', pack=1)
    call mpp_write_meta(unit, fld_y_vert_T, (/axis_xt, axis_yt, axis_v/), 'y_vert_T', &
         'degree_north', 'Geographic latitude of T_cell vertices begin southwest counterclockwise', pack=1)

    return
  end subroutine write_atmos_grid_meta

  !#######################################################################
  ! <SUBROUTINE NAME="atmos_grid_end">
  !   <OVERVIEW>
  !     Destruction routine.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Deallocates memory used by "atmos_grid_type" variables.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call atmos_grid_end ( Hgrid )
  !   </TEMPLATE>
  !   <INOUT NAME="Hgrid" TYPE="atmos_grid_type">
  !     A derived-type variable that contains horizontal grid information.
  !   </INOUT>
  ! </SUBROUTINE>

  subroutine atmos_grid_end(Hgrid)

    type(atmos_grid_type), intent(inout) :: Hgrid
    !--- release memory of module variables ------------------------------

    deallocate(Hgrid%x_C, Hgrid%y_C, Hgrid%x_T, Hgrid%y_T, Hgrid%x_vert_T, Hgrid%y_vert_T)

    module_is_initialized = .false.

    return

  end subroutine atmos_grid_end

  !#######################################################################

end module atmos_grid_mod

module atmos_dust_mod
! <DESCRIPTION>
!   This module evaluates the change of mass mixing ratio for mineral dust
!   particles due to their emission from preferential sources, and the removal
!   by gravitational settling. The dust particles are transported as dry
!   particles. No hygroscopic growth is considered.
!   The size distribution of sea salt ranges from 0.1 to 10 um (dry radius)
!   and is divided into 5 bins. For each bin, the volume size distribution
!   dV/dlnr is considered constant.
! </DESCRIPTION>
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Paul Ginoux
! </CONTACT>
!-----------------------------------------------------------------------

use mpp_mod, only: input_nml_file 
use              fms_mod, only : file_exist, &
                                 write_version_number, &
                                 mpp_pe, &
                                 mpp_root_pE, &
                                 close_file,           &
                                 open_namelist_file, file_exist,    &
                                 check_nml_error, error_mesg,  &
                                 stdlog
use     time_manager_mod, only : time_type
use     diag_manager_mod, only : send_data,            &
                                 register_diag_field
use   tracer_manager_mod, only : get_tracer_index, &
                                 set_tracer_atts
use    field_manager_mod, only : MODEL_ATMOS
use atmos_tracer_utilities_mod, only : wet_deposition,       &
                                 dry_deposition
use interpolator_mod,    only:  interpolate_type, interpolator_init, &
                                obtain_interpolator_time_slices, &
                                unset_interpolator_time_flag, &
                                interpolator, interpolator_end, &
                                CONSTANT, INTERP_WEIGHTED_P
use     constants_mod, only : PI, GRAV, RDGAS, DENS_H2O, PSTD_MKS, WTMAIR


implicit none
private
!-----------------------------------------------------------------------
!----- interfaces -------

public  atmos_dust_sourcesink, atmos_dust_init, atmos_dust_end, &
        atmos_dust_time_vary, atmos_dust_endts

!-----------------------------------------------------------------------
!----------- namelist -------------------
!-----------------------------------------------------------------------

!--- Arrays to help calculate tracer sources/sinks ---

character(len=6), parameter :: module_name = 'tracer'

integer :: ndust=0  ! tracer number for dust
!--- identification numbers for  diagnostic fields and axes ----

integer :: id_dust_emis(5), id_dust_setl(5)
integer :: id_dust_source

!--- Arrays to help calculate tracer sources/sinks ---
type(interpolate_type),save         ::  dust_source_interp


logical :: module_is_initialized=.FALSE.
logical :: used

real, save :: u_ts
real, save :: ch

!---------------------------------------------------------------------
!-------- namelist  ---------
character(len=32)  :: dust_source_filename = 'dust_source_1x1.nc'
character(len=32)  :: dust_source_name(1) = 'source'
real :: uthresh=-999.
real :: coef_emis =-999.

namelist /dust_nml/  dust_source_filename, dust_source_name, uthresh, coef_emis

!---- version number -----
character(len=128) :: version = '$Id: atmos_dust.F90,v 20.0 2013/12/13 23:23:54 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
!-----------------------------------------------------------------------

contains


!#######################################################################
!<SUBROUTINE NAME="atmos_dust_sourcesink">
!<OVERVIEW>
! The routine that calculate the sources and sinks of dust.
!</OVERVIEW>
 subroutine atmos_dust_sourcesink (i_DU,ra,rb,dustref,dustden, &
       lon, lat, frac_land, pwt, &
       zhalf, pfull, w10m, t, rh, &
       dust, dust_dt, dust_emis, dust_setl, Time, Time_next, is,ie,js,je,kbot)

!-----------------------------------------------------------------------
   integer, intent(in)                 :: i_DU
   real, intent(in)                    :: ra
   real, intent(in)                    :: rb
   real, intent(in)                    :: dustref
   real, intent(in)                    :: dustden
   real, intent(in),  dimension(:,:)   :: lon, lat
   real, intent(in),  dimension(:,:)   :: frac_land
   real, intent(in),  dimension(:,:)   :: w10m
   real, intent(out),  dimension(:,:)  :: dust_setl, dust_emis
   real, intent(in),  dimension(:,:,:) :: pwt, dust
   real, intent(in),  dimension(:,:,:) :: zhalf, pfull, t, rh
   real, intent(out), dimension(:,:,:) :: dust_dt
   type(time_type), intent(in) :: Time, Time_next     
   integer, intent(in),  dimension(:,:), optional :: kbot
integer, intent(in)                    :: is, ie, js, je
!-----------------------------------------------------------------------
integer  i, j, k, id, jd, kd, kb
!----------------------------------------------
!     Dust parameters
!----------------------------------------------
      real, dimension(5) ::   frac_s

      real, dimension(size(dust,3)) :: setl
      real, dimension(size(dust,1),size(dust,2)) :: u_ts_2d, source

      real, parameter :: small_value = 1.e-20
      real, parameter :: mtcm = 100.            ! meter to cm
      real, parameter :: mtv  = 1. ! factor conversion for mixing ratio of dust
      real, parameter :: ptmb = 0.01     ! pascal to mb

      real :: rhb, rcm
      real :: ratio_r, rho_wet_dust, viscosity, free_path, C_c, vdep
      real :: rho_air
      real :: rwet
!-----------------------------------
!    SET-Up  DATA
!-----------------------------------

!yim: per pag 2/1/08
!     data frac_s/0.1,0.225,0.225,0.225,0.225/
      data frac_s/0.05,0.1125,0.225,0.225,0.225/

!-----------------------------------------------------------------------

      id=size(dust,1); jd=size(dust,2); kd=size(dust,3)

     u_ts_2d(:,:) = u_ts 
!----------- compute dust emission ------------
      dust_emis(:,:)   = 0.0
      dust_setl(:,:)   = 0.0
      dust_dt(:,:,:) = 0.0

!----------- dust sources on local grid
     source(:,:)=0.0
     call interpolator(dust_source_interp, Time, source, &
                       trim(dust_source_name(1)), is, js)
! Send the dust source data to the diag_manager for output.
     if (id_dust_source > 0 ) &
          used = send_data ( id_dust_source, source , Time_next )

      where ( frac_land.gt.0.1 .and. w10m .gt. u_ts_2d )
          dust_emis = CH * frac_s(i_DU)*source * frac_land &
             * w10m**2 * (w10m - u_ts_2d)
      endwhere
      dust_dt(:,:,kd)=dust_dt(:,:,kd)+dust_emis(:,:)/pwt(:,:,kd)*mtv

! Send the emission data to the diag_manager for output.
      if (id_dust_emis(i_DU) > 0 ) then
        used = send_data ( id_dust_emis(i_DU), dust_emis, Time_next, &
              is_in=is,js_in=js )
      endif

         rcm=dustref*mtcm            ! Particles radius in centimeters
!------------------------------------------
!       Solve at the model TOP (layer plev-10)
!------------------------------------------
      do j=1,jd
        do i=1,id
          setl(:)=0.
          if (present(kbot)) then
              kb=kbot(i,j)
          else
             kb=kd
          endif
          do k=1,kb
              rhb=amin1(0.99,rh(i,j,k))
              rhb=amax1(0.01,rhb)
!----------------------------------------------------------
!     Aerosol growth with relative humidity
!----------------------------------------------------------

            rwet=dustref  ! Add any particle growth here
            ratio_r=(dustref/rwet)**3.   ! Ratio dry over wet radius cubic power
            rho_wet_dust=ratio_r*dustden+(1.-ratio_r)*DENS_H2O     ! Density of wet aerosol [kg/m3]
            viscosity = 1.458E-6 * t(i,j,k)**1.5/(t(i,j,k)+110.4)     ! Dynamic viscosity
            free_path=6.6e-8*t(i,j,k)/293.15*(PSTD_MKS/pfull(i,j,k))
            C_c=1. + free_path/dustref* &          ! Slip correction [none]
                  (1.257+0.4*exp(-1.1*dustref/free_path))
            Vdep=2./9.*C_c*GRAV*rho_wet_dust*rwet**2./viscosity   ! Settling velocity [m/s]
            rho_air = pfull(i,j,k)/t(i,j,k)/RDGAS      ! Air density [kg/m3]
            if (dust(i,j,k).gt.0.) then
              setl(k)=dust(i,j,k)*rho_air/mtv*vdep    ! settling flux [kg/m2/s]
            endif
          enddo
          dust_dt(i,j,1)=dust_dt(i,j,1)-setl(1)/pwt(i,j,1)*mtv
          dust_dt(i,j,2:kb)=dust_dt(i,j,2:kb) &
             + ( setl(1:kb-1) - setl(2:kb) )/pwt(i,j,2:kb)*mtv
          dust_setl(i,j)=setl(kb)
        enddo
      enddo 

! Send the settling data to the diag_manager for output.
      if (id_dust_setl(i_DU) > 0 ) then
        used = send_data ( id_dust_setl(i_DU), dust_setl, Time_next, &
              is_in=is,js_in=js )
      endif


!-----------------------------------------------------------------------

 end subroutine atmos_dust_sourcesink
!</SUBROUTINE>

!#######################################################################

!<SUBROUTINE NAME="atmos_dust_init">
!<OVERVIEW>
! The constructor routine for the dust module.
!</OVERVIEW>
 subroutine atmos_dust_init (lonb, latb, axes, Time, mask)
!-----------------------------------------------------------------------
real, intent(in),    dimension(:,:)               :: lonb, latb
type(time_type),  intent(in)                        :: Time
integer,          intent(in)                        :: axes(4)
real, intent(in), dimension(:,:,:), optional        :: mask
character(len=7), parameter :: mod_name = 'tracers'
integer :: n, m, logunit
!
!-----------------------------------------------------------------------
!
      integer  unit,ierr, io
      character(len=1)  :: numb(5)
      data numb/'1','2','3','4','5'/


      if (module_is_initialized) return

      call write_version_number(version, tagname)
!-----------------------------------------------------------------------
!    read namelist.
!-----------------------------------------------------------------------
      if ( file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
        read (input_nml_file, nml=dust_nml, iostat=io)
        ierr = check_nml_error(io,'dust_nml')
#else
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=dust_nml, iostat=io, end=10)
        ierr = check_nml_error(io, 'dust_nml')
        end do
10      call close_file (unit)
#endif
      endif

      if (uthresh .le. -990) then
        u_ts = 0.
      else
        u_ts=uthresh
      endif
      if (coef_emis .le. -990) then
        ch = 1.0e-10
      else
        ch = coef_emis
      endif
!----- set initial value of dust ------------
    logunit=stdlog()
    do m=1,5

       n = get_tracer_index(MODEL_ATMOS,'dust'//numb(m))
       if (n>0) then
         ndust=n
         call set_tracer_atts(MODEL_ATMOS,'dust'//numb(m),'dust'//numb(m),'mmr')
         if (ndust > 0 .and. mpp_pe() == mpp_root_pe()) then
                write (*,30) 'dust'//numb(m),ndust
                write (logunit,30) 'dust '//numb(m),ndust
         endif       
       endif


  30        format (A,' was initialized as tracer number ',i2)
! Register a diagnostic field : emission of dust
     id_dust_emis(m) = register_diag_field ( mod_name,            &
                     'dust'//numb(m)//'_emis', axes(1:2),Time,  &
                     'dust'//numb(m)//'_emis', 'kg/m2/s',       &
                     missing_value=-999.  )

! Register a diagnostic field : settling of dust
     id_dust_setl(m) = register_diag_field ( mod_name,            &
                     'dust'//numb(m)//'_setl', axes(1:2),Time,  &
                     'dust'//numb(m)//'_setl', 'kg/m2/s',       &
                     missing_value=-999.  )
enddo
!
     id_dust_source  = register_diag_field ( mod_name,             &
                      'DU_source',axes(1:2),Time,                    &
                      'DU_source', 'none')

     call interpolator_init (dust_source_interp, trim(dust_source_filename),  &
                             lonb, latb,&
                             data_out_of_bounds=  (/CONSTANT/), &
                             data_names = dust_source_name, &
                             vert_interp=(/INTERP_WEIGHTED_P/) )


     call write_version_number(version, tagname)

      module_is_initialized = .TRUE.

!-----------------------------------------------------------------------

 end subroutine atmos_dust_init
!</SUBROUTINE>

!######################################################################

subroutine atmos_dust_time_vary (Time)


type(time_type), intent(in) :: Time

      call obtain_interpolator_time_slices (dust_source_interp, Time)


end subroutine atmos_dust_time_vary 


!######################################################################

subroutine atmos_dust_endts              


      call unset_interpolator_time_flag (dust_source_interp)


end subroutine atmos_dust_endts 



!#######################################################################
!<SUBROUTINE NAME="atmos_dust_end">
!<OVERVIEW>
!  The destructor routine for the dust module.
!</OVERVIEW>
 subroutine atmos_dust_end

      call interpolator_end (dust_source_interp)
      module_is_initialized = .FALSE.

 end subroutine atmos_dust_end
!</SUBROUTINE>

end module atmos_dust_mod

module horiz_interp_conserve_mod

  ! <CONTACT EMAIL="Bruce.Wyman@noaa.gov"> Bruce Wyman </CONTACT>
  ! <CONTACT EMAIL="Zhi.Liang@noaa.gov"> Zhi Liang </CONTACT>

  ! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

  ! <OVERVIEW>
  !   Performs spatial interpolation between grids using conservative interpolation
  ! </OVERVIEW>

  ! <DESCRIPTION>
  !     This module can conservatively interpolate data from any logically rectangular grid
  !     to any rectangular grid. The interpolation scheme is area-averaging 
  !     conservative scheme. There is an optional mask field for missing input data in both
  !     horiz_interp__conserveinit and horiz_interp_conserve. For efficiency purpose, mask should only be 
  !     kept in horiz_interp_init (will remove the mask in horiz_interp in the future). 
  !     There are 1-D and 2-D version of horiz_interp_conserve_init for 1-D and 2-D grid.
  !     There is a optional argument mask in horiz_interp_conserve_init_2d and no mask should 
  !     to passed into horiz_interp_conserv. optional argument mask will not be passed into
  !     horiz_interp_conserve_init_1d and optional argument mask may be passed into 
  !     horiz_interp_conserve (For the purpose of reproduce Memphis??? results).   
  !     An optional output mask field may be used in conjunction with the input mask to show 
  !     where output data exists.
  ! </DESCRIPTION>

  use mpp_mod,               only: mpp_send, mpp_recv, mpp_pe, mpp_root_pe, mpp_npes
  use mpp_mod,               only: mpp_error, FATAL,  mpp_sync_self 
  use mpp_mod,               only: COMM_TAG_1, COMM_TAG_2
  use fms_mod,               only: write_version_number
  use fms_io_mod,            only: get_great_circle_algorithm
  use constants_mod,         only: PI
  use horiz_interp_type_mod, only: horiz_interp_type


  implicit none
  private

  ! public interface


  ! <INTERFACE NAME="horiz_interp_conserve_new">
  !   <OVERVIEW>
  !      Allocates space and initializes a derived-type variable
  !      that contains pre-computed interpolation indices and weights.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !      Allocates space and initializes a derived-type variable
  !      that contains pre-computed interpolation indices and weights
  !      for improved performance of multiple interpolations between
  !      the same grids. 

  !   </DESCRIPTION>
  !   <IN NAME="lon_in" TYPE="real" DIM="dimension(:), dimension(:,:)" UNITS="radians">
  !      Longitude (in radians) for source data grid. 
  !   </IN>
  !   <IN NAME="lat_in" TYPE="real" DIM="dimension(:), dimension(:,:)" UNITS="radians">
  !      Latitude (in radians) for source data grid.
  !   </IN>
  !   <IN NAME="lon_out" TYPE="real" DIM="dimension(:), dimension(:,:)" UNITS="radians" >
  !      Longitude (in radians) for destination data grid. 
  !   </IN>
  !   <IN NAME="lat_out" TYPE="real" DIM="dimension(:), dimension(:,:)" UNITS="radians" >
  !      Latitude (in radians) for destination data grid. 
  !   </IN>
  !   <IN NAME="verbose" TYPE="integer, optional" >
  !      flag for the amount of print output.
  !   </IN>
  !   <IN NAME="mask_in" TYPE="real, dimension(:,:),optional">
  !      Input mask.  must be the size (size(lon_in)-1, size(lon. The real value of
  !      mask_in must be in the range (0.,1.). Set mask_in=0.0 for data points 
  !      that should not be used or have missing data.
  !   </IN>
  !   <OUT NAME="mask_out" TYPE="real, dimension(:,:),optional">
  !      Output mask that specifies whether data was computed.
  !   </OUT>
  !   <INOUT NAME="Interp" TYPE="type(horiz_interp_type)" >
  !      A derived-type variable containing indices and weights used for subsequent 
  !      interpolations. To reinitialize this variable for a different grid-to-grid 
  !      interpolation you must first use the "horiz_interp_del" interface.
  !   </INOUT>
  interface horiz_interp_conserve_new
     module procedure horiz_interp_conserve_new_1dx1d
     module procedure horiz_interp_conserve_new_1dx2d
     module procedure horiz_interp_conserve_new_2dx1d
     module procedure horiz_interp_conserve_new_2dx2d
  end interface
  ! </INTERFACE>
  public :: horiz_interp_conserve_init 
  public :: horiz_interp_conserve_new, horiz_interp_conserve, horiz_interp_conserve_del

  integer :: pe, root_pe
  !-----------------------------------------------------------------------
  character(len=128) :: version = '$Id$'
  character(len=128) :: tagname = '$Name$'
  logical            :: module_is_initialized = .FALSE.

  logical         :: great_circle_algorithm = .false.

contains

  !#######################################################################
  !  <SUBROUTINE NAME="horiz_interp_conserve_init">
  !  <OVERVIEW>
  !     writes version number and tag name to logfile.out
  !  </OVERVIEW>
  !  <DESCRIPTION>       
  !     writes version number and tag name to logfile.out
  !  </DESCRIPTION>

  subroutine horiz_interp_conserve_init

    if(module_is_initialized) return
    call write_version_number (version, tagname)

    great_circle_algorithm = get_great_circle_algorithm()

    module_is_initialized = .true.

  end subroutine horiz_interp_conserve_init

  !  </SUBROUTINE>

  !#######################################################################
  !<PUBLICROUTINE INTERFACE="horiz_interp_conserve_new">
  subroutine horiz_interp_conserve_new_1dx1d ( Interp, lon_in, lat_in, lon_out, lat_out, verbose)
    type(horiz_interp_type), intent(inout) :: Interp
    real, intent(in),       dimension(:)   :: lon_in , lat_in
    real, intent(in),       dimension(:)   :: lon_out, lat_out
    integer, intent(in),       optional    :: verbose

  !</PUBLICROUTINE>
    !-----------------------------------------------------------------------
    real, dimension(size(lat_out(:))-1,2) :: sph
    real, dimension(size(lon_out(:))-1,2) :: theta
    real, dimension(size(lat_in(:)))      :: slat_in
    real, dimension(size(lon_in(:))-1)    :: dlon_in
    real, dimension(size(lat_in(:))-1)    :: dsph_in
    real, dimension(size(lon_out(:))-1)   :: dlon_out
    real, dimension(size(lat_out(:))-1)   :: dsph_out
    real    :: blon, fac, hpi, tpi, eps
    integer :: num_iters = 4
    integer :: i, j, m, n, nlon_in, nlat_in, nlon_out, nlat_out,   &
         iverbose, m2, n2, iter
    logical :: s2n
    character(len=64) :: mesg

    if(.not. module_is_initialized) call mpp_error(FATAL, &
         'horiz_interp_conserve_new_1dx1d: horiz_interp_conserve_init is not called')

    if(great_circle_algorithm) call mpp_error(FATAL, &
         'horiz_interp_conserve_new_1dx1d: great_circle_algorithm is not implemented, contact developer')
    !-----------------------------------------------------------------------
    iverbose = 0;  if (present(verbose)) iverbose = verbose

    pe      = mpp_pe()
    root_pe = mpp_root_pe()
    !-----------------------------------------------------------------------
    hpi = 0.5*pi
    tpi = 4.*hpi
    Interp%version = 1
    nlon_in = size(lon_in(:))-1;  nlat_in = size(lat_in(:))-1
    nlon_out = size(lon_out(:))-1;  nlat_out = size(lat_out(:))-1

    allocate ( Interp % facj (nlat_out,2), Interp % jlat (nlat_out,2),      &
               Interp % faci (nlon_out,2), Interp % ilon (nlon_out,2),      &
               Interp % area_src (nlon_in, nlat_in),   &
               Interp % area_dst (nlon_out, nlat_out) )

    !-----------------------------------------------------------------------
    !  --- set-up for input grid boxes ---

    do j = 1, nlat_in+1
       slat_in(j) = sin(lat_in(j))
    enddo

    do j = 1, nlat_in
       dsph_in(j) = abs(slat_in(j+1)-slat_in(j))
    enddo

    do i = 1,nlon_in
       dlon_in(i) = abs(lon_in(i+1)-lon_in(i))
    enddo

    !  set south to north flag
    s2n = .true.
    if (lat_in(1) > lat_in(nlat_in+1)) s2n = .false.

    !-----------------------------------------------------------------------
    !  --- set-up for output grid boxes ---

    do n = 1, nlat_out
       dsph_out(n) = abs(sin(lat_out(n+1))-sin(lat_out(n)))
    enddo

    do m = 1,nlon_out
       theta(m,1)  = lon_out(m)
       theta(m,2)  = lon_out(m+1)
       dlon_out(m) = abs(lon_out(m+1)-lon_out(m))
    enddo

    Interp%nlon_src = nlon_in;  Interp%nlat_src = nlat_in
    Interp%nlon_dst = nlon_out; Interp%nlat_dst = nlat_out
    !***********************************************************************

    !------ set up latitudinal indexing ------
    !------ make sure output grid goes south to north ------

    do n = 1, nlat_out
       if (lat_out(n) < lat_out(n+1)) then
          sph(n,1) = sin(lat_out(n))
          sph(n,2) = sin(lat_out(n+1))
       else
          sph(n,1) = sin(lat_out(n+1))
          sph(n,2) = sin(lat_out(n))
       endif
    enddo

    Interp%jlat = 0
    do n2 = 1, 2         ! looping on grid box edges
       do n = 1, nlat_out   ! looping on output latitudes
          eps = 0.0
          do iter=1,num_iters
             ! find indices from input latitudes
             do j = 1, nlat_in
                if ( (s2n .and. (slat_in(j)-sph(n,n2)) <= eps .and.   &
                     (sph(n,n2)-slat_in(j+1)) <= eps) .or. &
                     (.not.s2n .and. (slat_in(j+1)-sph(n,n2)) <= eps .and.  &
                     (sph(n,n2)-slat_in(j)) <= eps) ) then
                   Interp%jlat(n,n2) = j
                   ! weight with sin(lat) to exactly conserve area-integral
                   fac = (sph(n,n2)-slat_in(j))/(slat_in(j+1)-slat_in(j))
                   if (s2n) then
                      if (n2 == 1) Interp%facj(n,n2) = 1.0 - fac
                      if (n2 == 2) Interp%facj(n,n2) = fac
                   else
                      if (n2 == 1) Interp%facj(n,n2) = fac
                      if (n2 == 2) Interp%facj(n,n2) = 1.0 - fac
                   endif
                   exit
                endif
             enddo
             if ( Interp%jlat(n,n2) /= 0 ) exit
             ! did not find this output grid edge in the input grid
             ! increase tolerance for multiple passes
             eps  = epsilon(sph)*real(10**iter)
          enddo
          ! no match
          if ( Interp%jlat(n,n2) == 0 ) then
             write (mesg,710) n,sph(n,n2)
710          format (': n,sph=',i3,f14.7,40x)
             call mpp_error(FATAL, 'horiz_interp_conserve_mod:no latitude index found'//trim(mesg))
          endif
       enddo
    enddo

    !------ set up longitudinal indexing ------

    Interp%ilon = 0
    do m2 = 1, 2         ! looping on grid box edges
       do m = 1, nlon_out   ! looping on output longitudes
          blon = theta(m,m2)
          if ( blon < lon_in(1)         ) blon = blon + tpi
          if ( blon > lon_in(nlon_in+1) ) blon = blon - tpi
          eps = 0.0
          do iter=1,num_iters
             ! find indices from input longitudes
             do i = 1, nlon_in
                if ( (lon_in(i)-blon) <= eps .and. &
                     (blon-lon_in(i+1)) <= eps ) then
                   Interp%ilon(m,m2) = i
                   fac = (blon-lon_in(i))/(lon_in(i+1)-lon_in(i))
                   if (m2 == 1) Interp%faci(m,m2) = 1.0 - fac
                   if (m2 == 2) Interp%faci(m,m2) = fac
                   exit
                endif
             enddo
             if ( Interp%ilon(m,m2) /= 0 ) exit
             ! did not find this output grid edge in the input grid
             ! increase tolerance for multiple passes
             eps  = epsilon(blon)*real(10**iter)
          enddo
          ! no match
          if ( Interp%ilon(m,m2) == 0 ) then
             print *, 'lon_out,blon,blon_in,eps=',  &
                  theta(m,m2),blon,lon_in(1),lon_in(nlon_in+1),eps
             call mpp_error(FATAL, 'horiz_interp_conserve_mod: no longitude index found')
          endif
       enddo
    enddo

    !  --- area of input grid boxes ---

    do j = 1,nlat_in
       do i = 1,nlon_in
          Interp%area_src(i,j) = dlon_in(i) * dsph_in(j)
       enddo
    enddo

    !  --- area of output grid boxes ---

    do n = 1, nlat_out
       do m = 1, nlon_out
          Interp%area_dst(m,n) = dlon_out(m) * dsph_out(n)
       enddo
    enddo

    !-----------------------------------------------------------------------
    ! this output may be quite lengthy and is not recommended
    ! when using more than one processor
    if (iverbose > 2) then
       write (*,801) (i,Interp%ilon(i,1),Interp%ilon(i,2),  &
            Interp%faci(i,1),Interp%faci(i,2),i=1,nlon_out)
       write (*,802) (j,Interp%jlat(j,1),Interp%jlat(j,2),  &
            Interp%facj(j,1),Interp%facj(j,2),j=1,nlat_out)
801    format (/,2x,'i',4x,'is',5x,'ie',4x,'facis',4x,'facie',  &
            /,(i4,2i7,2f10.5))
802    format (/,2x,'j',4x,'js',5x,'je',4x,'facjs',4x,'facje',  &
            /,(i4,2i7,2f10.5))
    endif
    !-----------------------------------------------------------------------

  end subroutine horiz_interp_conserve_new_1dx1d

  !#######################################################################
  !<PUBLICROUTINE INTERFACE="horiz_interp_conserve_new">
  subroutine horiz_interp_conserve_new_1dx2d ( Interp, lon_in, lat_in, lon_out, lat_out, &
                                               mask_in, mask_out, verbose)
    type(horiz_interp_type),        intent(inout) :: Interp
    real, intent(in),              dimension(:)   :: lon_in , lat_in
    real, intent(in),              dimension(:,:) :: lon_out, lat_out
    real, intent(in),    optional, dimension(:,:) :: mask_in
    real, intent(inout), optional, dimension(:,:) :: mask_out
    integer, intent(in), optional                 :: verbose

  !</PUBLICROUTINE>

    integer :: create_xgrid_1DX2D_order1, get_maxxgrid, maxxgrid
    integer :: create_xgrid_great_circle
    integer :: nlon_in, nlat_in, nlon_out, nlat_out, nxgrid, i, j
    real, dimension(size(lon_in(:))-1, size(lat_in(:))-1) :: mask_src
    integer, allocatable, dimension(:)   :: i_src, j_src, i_dst, j_dst
    real,    allocatable, dimension(:)   :: xgrid_area, clon, clat
    real,    allocatable, dimension(:,:) :: dst_area, lon_src, lat_src

    if(.not. module_is_initialized) call mpp_error(FATAL, &
         'horiz_interp_conserve_new_1dx2d: horiz_interp_conserve_init is not called')

    if( (size(lon_out,1) .NE. size(lat_out,1)) .OR. (size(lon_out,2) .NE. size(lat_out,2)) )  &
        call mpp_error(FATAL, 'horiz_interp_conserve_mod: size mismatch between lon_out and lat_out')
    nlon_in  = size(lon_in(:)) - 1;  nlat_in  = size(lat_in(:)) - 1
    nlon_out = size(lon_out,1) - 1;  nlat_out = size(lon_out,2) - 1

    mask_src = 1.
    if(present(mask_in)) then
       if( (size(mask_in,1) .NE. nlon_in) .OR.  (size(mask_in,2) .NE. nlat_in)) call mpp_error(FATAL, &
         'horiz_interp_conserve_mod: size mismatch between mask_in and lon_in/lat_in')
       mask_src = mask_in
    end if

    maxxgrid = get_maxxgrid()
    allocate(i_src(maxxgrid), j_src(maxxgrid), i_dst(maxxgrid), j_dst(maxxgrid) )
    allocate( xgrid_area(maxxgrid), dst_area(nlon_out, nlat_out) )

    if( .not. great_circle_algorithm ) then
       nxgrid = create_xgrid_1DX2D_order1(nlon_in, nlat_in, nlon_out, nlat_out, lon_in, lat_in, lon_out, lat_out, &
                                          mask_src, i_src, j_src, i_dst, j_dst, xgrid_area)
    else
       allocate(lon_src(nlon_in+1,nlat_in+1), lat_src(nlon_in+1,nlat_in+1))
       allocate(clon(maxxgrid), clat(maxxgrid))       
       do j = 1, nlat_in+1
          do i = 1, nlon_in+1
             lon_src(i,j) = lon_in(i)
             lat_src(i,j) = lat_in(j)
          enddo
       enddo
       nxgrid =  create_xgrid_great_circle(nlon_in, nlat_in, nlon_out, nlat_out, lon_src, lat_src, lon_out, lat_out, &
                                          mask_src, i_src, j_src, i_dst, j_dst, xgrid_area, clon, clat)
       deallocate(lon_src, lat_src, clon, clat)
    endif
    allocate(Interp%i_src(nxgrid), Interp%j_src(nxgrid) )
    allocate(Interp%i_dst(nxgrid), Interp%j_dst(nxgrid) )
    allocate(Interp%area_frac_dst(nxgrid) )
    Interp%version = 2
    Interp%nxgrid   = nxgrid
    Interp%i_src = i_src(1:nxgrid)+1 ! in C, the starting index is 0
    Interp%j_src = j_src(1:nxgrid)+1
    Interp%i_dst = i_dst(1:nxgrid)+1
    Interp%j_dst = j_dst(1:nxgrid)+1

    ! sum over exchange grid area to get destination grid area
    dst_area = 0.
    do i = 1, nxgrid
       dst_area(Interp%i_dst(i), Interp%j_dst(i)) = dst_area(Interp%i_dst(i), Interp%j_dst(i)) + xgrid_area(i)       
    end do    

    do i = 1, nxgrid
       Interp%area_frac_dst(i) = xgrid_area(i)/dst_area(Interp%i_dst(i), Interp%j_dst(i) )
    end do
    Interp%nlon_src = nlon_in;  Interp%nlat_src = nlat_in
    Interp%nlon_dst = nlon_out; Interp%nlat_dst = nlat_out
    if(present(mask_out)) then
       if( (size(mask_out,1) .NE. nlon_out) .OR. (size(mask_out,2) .NE. nlat_out) ) call mpp_error(FATAL, &
         'horiz_interp_conserve_mod: size mismatch between mask_out and lon_out/lat_out')
       mask_out = 0.0
       do i = 1, nxgrid
          mask_out(Interp%i_dst(i),Interp%j_dst(i)) = mask_out(Interp%i_dst(i),Interp%j_dst(i)) + Interp%area_frac_dst(i)
       end do
    end if

    deallocate(i_src, j_src, i_dst, j_dst, xgrid_area, dst_area )

  end subroutine horiz_interp_conserve_new_1dx2d

  !#######################################################################
  !<PUBLICROUTINE INTERFACE="horiz_interp_conserve_new">
  subroutine horiz_interp_conserve_new_2dx1d ( Interp, lon_in, lat_in, lon_out, lat_out, &
                                               mask_in, mask_out, verbose)
    type(horiz_interp_type),        intent(inout) :: Interp
    real, intent(in),              dimension(:,:) :: lon_in , lat_in
    real, intent(in),              dimension(:)   :: lon_out, lat_out
    real, intent(in),    optional, dimension(:,:) :: mask_in
    real, intent(inout), optional, dimension(:,:) :: mask_out
    integer, intent(in), optional                 :: verbose

  !</PUBLICROUTINE>

    integer :: create_xgrid_2DX1D_order1, get_maxxgrid, maxxgrid
    integer :: create_xgrid_great_circle
    integer :: nlon_in, nlat_in, nlon_out, nlat_out, nxgrid, i, j
    real, dimension(size(lon_in,1)-1, size(lon_in,2)-1) :: mask_src
    integer, allocatable, dimension(:)   :: i_src, j_src, i_dst, j_dst
    real,    allocatable, dimension(:)   :: xgrid_area, clon, clat
    real,    allocatable, dimension(:,:) :: dst_area, lon_dst, lat_dst

    if(.not. module_is_initialized) call mpp_error(FATAL, &
         'horiz_interp_conserve_new_2dx1d: horiz_interp_conserve_init is not called')

    if( (size(lon_in,1) .NE. size(lat_in,1)) .OR. (size(lon_in,2) .NE. size(lat_in,2)) )  &
        call mpp_error(FATAL, 'horiz_interp_conserve_mod: size mismatch between lon_in and lat_in')
    nlon_in  = size(lon_in,1)   - 1;  nlat_in  = size(lon_in,2)   - 1
    nlon_out = size(lon_out(:)) - 1;  nlat_out = size(lat_out(:)) - 1

    mask_src = 1.
    if(present(mask_in)) then
       if( (size(mask_in,1) .NE. nlon_in) .OR.  (size(mask_in,2) .NE. nlat_in)) call mpp_error(FATAL, &
         'horiz_interp_conserve_mod: size mismatch between mask_in and lon_in/lat_in')
       mask_src = mask_in
    end if

    maxxgrid = get_maxxgrid()
    allocate(i_src(maxxgrid), j_src(maxxgrid), i_dst(maxxgrid), j_dst(maxxgrid) )
    allocate( xgrid_area(maxxgrid), dst_area(nlon_out, nlat_out) )

    if( .not. great_circle_algorithm ) then    
       nxgrid = create_xgrid_2DX1D_order1(nlon_in, nlat_in, nlon_out, nlat_out, lon_in, lat_in, lon_out, lat_out, &
                                       mask_src, i_src, j_src, i_dst, j_dst, xgrid_area)
    else
       allocate(lon_dst(nlon_out+1, nlat_out+1), lat_dst(nlon_out+1, nlat_out+1) )
       allocate(clon(maxxgrid), clat(maxxgrid))   
       do j = 1, nlat_out+1
          do i = 1, nlon_out+1
             lon_dst(i,j) = lon_out(i)
             lat_dst(i,j) = lat_out(j)
          enddo
       enddo
       nxgrid =  create_xgrid_great_circle(nlon_in, nlat_in, nlon_out, nlat_out, lon_in, lat_in, lon_dst, lat_dst, &
                                          mask_src, i_src, j_src, i_dst, j_dst, xgrid_area, clon, clat)
       deallocate(lon_dst, lat_dst, clon, clat)
    endif
    allocate(Interp%i_src(nxgrid), Interp%j_src(nxgrid) )
    allocate(Interp%i_dst(nxgrid), Interp%j_dst(nxgrid) )
    allocate(Interp%area_frac_dst(nxgrid) )
    Interp%version = 2
    Interp%nxgrid   = nxgrid
    Interp%i_src = i_src(1:nxgrid)+1 ! in C, the starting index is 0
    Interp%j_src = j_src(1:nxgrid)+1
    Interp%i_dst = i_dst(1:nxgrid)+1
    Interp%j_dst = j_dst(1:nxgrid)+1

    ! sum over exchange grid area to get destination grid area
    dst_area = 0.
    do i = 1, nxgrid
       dst_area(Interp%i_dst(i), Interp%j_dst(i)) = dst_area(Interp%i_dst(i), Interp%j_dst(i)) + xgrid_area(i)       
    end do    

    do i = 1, nxgrid
       Interp%area_frac_dst(i) = xgrid_area(i)/dst_area(Interp%i_dst(i), Interp%j_dst(i) )
    end do
    Interp%nlon_src = nlon_in;  Interp%nlat_src = nlat_in
    Interp%nlon_dst = nlon_out; Interp%nlat_dst = nlat_out
    if(present(mask_out)) then
       if( (size(mask_out,1) .NE. nlon_out) .OR. (size(mask_out,2) .NE. nlat_out) ) call mpp_error(FATAL, &
         'horiz_interp_conserve_mod: size mismatch between mask_out and lon_out/lat_out')
       mask_out = 0.0
       do i = 1, nxgrid
          mask_out(Interp%i_dst(i),Interp%j_dst(i)) = mask_out(Interp%i_dst(i),Interp%j_dst(i)) + Interp%area_frac_dst(i)
       end do
    end if

    deallocate(i_src, j_src, i_dst, j_dst, xgrid_area, dst_area)

  end subroutine horiz_interp_conserve_new_2dx1d

  !#######################################################################
  !<PUBLICROUTINE INTERFACE="horiz_interp_conserve_new">
  subroutine horiz_interp_conserve_new_2dx2d ( Interp, lon_in, lat_in, lon_out, lat_out, &
                                               mask_in, mask_out, verbose)
    type(horiz_interp_type),        intent(inout) :: Interp
    real, intent(in),              dimension(:,:) :: lon_in , lat_in
    real, intent(in),              dimension(:,:) :: lon_out, lat_out
    real, intent(in),    optional, dimension(:,:) :: mask_in
    real, intent(inout), optional, dimension(:,:) :: mask_out
    integer, intent(in), optional                 :: verbose
  !</PUBLICROUTINE>

    integer :: create_xgrid_2DX2D_order1, get_maxxgrid, maxxgrid
    integer :: create_xgrid_great_circle
    integer :: nlon_in, nlat_in, nlon_out, nlat_out, nxgrid, i
    real, dimension(size(lon_in,1)-1, size(lon_in,2)-1) :: mask_src
    integer, allocatable, dimension(:)   :: i_src, j_src, i_dst, j_dst
    real,    allocatable, dimension(:)   :: xgrid_area, clon, clat
    real,    allocatable, dimension(:,:) :: dst_area

    if(.not. module_is_initialized) call mpp_error(FATAL, &
         'horiz_interp_conserve_new_2dx2d: horiz_interp_conserve_init is not called')

    if( (size(lon_in,1) .NE. size(lat_in,1)) .OR. (size(lon_in,2) .NE. size(lat_in,2)) )  &
        call mpp_error(FATAL, 'horiz_interp_conserve_mod: size mismatch between lon_in and lat_in')
    if( (size(lon_out,1) .NE. size(lat_out,1)) .OR. (size(lon_out,2) .NE. size(lat_out,2)) )  &
        call mpp_error(FATAL, 'horiz_interp_conserve_mod: size mismatch between lon_out and lat_out')
    nlon_in  = size(lon_in,1)  - 1;  nlat_in  = size(lon_in,2)  - 1
    nlon_out = size(lon_out,1) - 1;  nlat_out = size(lon_out,2) - 1

    mask_src = 1.
    if(present(mask_in)) then
       if( (size(mask_in,1) .NE. nlon_in) .OR.  (size(mask_in,2) .NE. nlat_in)) call mpp_error(FATAL, &
         'horiz_interp_conserve_mod: size mismatch between mask_in and lon_in/lat_in')
       mask_src = mask_in
    end if

    maxxgrid = get_maxxgrid()
    allocate(i_src(maxxgrid), j_src(maxxgrid), i_dst(maxxgrid), j_dst(maxxgrid) )
    allocate( xgrid_area(maxxgrid), dst_area(nlon_out, nlat_out) )

    if( .not. great_circle_algorithm ) then   
       nxgrid = create_xgrid_2DX2D_order1(nlon_in, nlat_in, nlon_out, nlat_out, lon_in, lat_in, lon_out, lat_out, &
                                       mask_src, i_src, j_src, i_dst, j_dst, xgrid_area) 
    else
       allocate(clon(maxxgrid), clat(maxxgrid))   
       nxgrid =  create_xgrid_great_circle(nlon_in, nlat_in, nlon_out, nlat_out, lon_in, lat_in, lon_out, lat_out, &
                                          mask_src, i_src, j_src, i_dst, j_dst, xgrid_area, clon, clat)
       deallocate(clon, clat)
    endif

    allocate(Interp%i_src(nxgrid), Interp%j_src(nxgrid) )
    allocate(Interp%i_dst(nxgrid), Interp%j_dst(nxgrid) )
    allocate(Interp%area_frac_dst(nxgrid) )
    Interp%version = 2
    Interp%nxgrid   = nxgrid
    Interp%i_src = i_src(1:nxgrid)+1 ! in C, the starting index is 0
    Interp%j_src = j_src(1:nxgrid)+1
    Interp%i_dst = i_dst(1:nxgrid)+1
    Interp%j_dst = j_dst(1:nxgrid)+1

    ! sum over exchange grid area to get destination grid area
    dst_area = 0.
    do i = 1, nxgrid
       dst_area(Interp%i_dst(i), Interp%j_dst(i)) = dst_area(Interp%i_dst(i), Interp%j_dst(i)) + xgrid_area(i)       
    end do    

    do i = 1, nxgrid
       Interp%area_frac_dst(i) = xgrid_area(i)/dst_area(Interp%i_dst(i), Interp%j_dst(i) )
    end do

    Interp%nlon_src = nlon_in;  Interp%nlat_src = nlat_in
    Interp%nlon_dst = nlon_out; Interp%nlat_dst = nlat_out
    if(present(mask_out)) then
       if( (size(mask_out,1) .NE. nlon_out) .OR. (size(mask_out,2) .NE. nlat_out) ) call mpp_error(FATAL, &
         'horiz_interp_conserve_mod: size mismatch between mask_out and lon_out/lat_out')
       mask_out = 0.0
       do i = 1, nxgrid
          mask_out(Interp%i_dst(i),Interp%j_dst(i)) = mask_out(Interp%i_dst(i),Interp%j_dst(i)) + Interp%area_frac_dst(i)
       end do
    end if

    deallocate(i_src, j_src, i_dst, j_dst, xgrid_area, dst_area )

  end subroutine horiz_interp_conserve_new_2dx2d

  !########################################################################
  ! <SUBROUTINE NAME="horiz_interp_conserve">

  !   <OVERVIEW>
  !      Subroutine for performing the horizontal interpolation between two grids.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Subroutine for performing the horizontal interpolation between two grids. 
  !     horiz_interp_conserve_new must be called before calling this routine.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call horiz_interp_conserve ( Interp, data_in, data_out, verbose, mask_in, mask_out)
  !   </TEMPLATE>
  !   
  !   <IN NAME="Interp" TYPE="type(horiz_interp_type)">
  !     Derived-type variable containing interpolation indices and weights.
  !     Returned by a previous call to horiz_interp_new.
  !   </IN>
  !   <IN NAME="data_in" TYPE="real, dimension(:,:)">
  !      Input data on source grid.
  !   </IN>

  !   <IN NAME="verbose" TYPE="integer, optional">
  !      flag for the amount of print output.
  !               verbose = 0, no output; = 1, min,max,means; = 2, still more
  !   </IN>
  !   <IN NAME="mask_in" TYPE="real, dimension(:,:),optional">
  !      Input mask, must be the same size as the input data. The real value of
  !      mask_in must be in the range (0.,1.). Set mask_in=0.0 for data points 
  !      that should not be used or have missing data. mask_in will be applied only
  !      when horiz_interp_conserve_new_1d is called. mask_in will be passed into
  !      horiz_interp_conserve_new_2d.
  !   </IN>

  !   <OUT NAME="data_out" TYPE="real, dimension(:,:)">
  !      Output data on destination grid.
  !   </OUT>
  !   <OUT NAME="mask_out" TYPE="real, dimension(:,:),optional">
  !      Output mask that specifies whether data was computed. mask_out will be computed only
  !      when horiz_interp_conserve_new_1d is called. mask_out will be computed in
  !      horiz_interp_conserve_new_2d.
  !   </OUT>

  subroutine horiz_interp_conserve ( Interp, data_in, data_out, verbose, &
       mask_in, mask_out)
    !-----------------------------------------------------------------------
    type (horiz_interp_type), intent(in) :: Interp
    real, intent(in),  dimension(:,:) :: data_in
    real, intent(out), dimension(:,:) :: data_out
    integer, intent(in),                   optional :: verbose
    real, intent(in),   dimension(:,:), optional :: mask_in
    real, intent(out),  dimension(:,:), optional :: mask_out

    !  --- error checking ---
    if (size(data_in,1) /= Interp%nlon_src .or. size(data_in,2) /= Interp%nlat_src) &
         call mpp_error(FATAL, 'horiz_interp_conserve_mod: size of input array incorrect')

    if (size(data_out,1) /= Interp%nlon_dst .or. size(data_out,2) /= Interp%nlat_dst) &
         call mpp_error(FATAL, 'horiz_interp_conserve_mod: size of output array incorrect')

    select case ( Interp%version)
    case (1)
       call horiz_interp_conserve_version1(Interp, data_in, data_out, verbose, mask_in, mask_out)
    case (2)
       if(present(mask_in) .OR. present(mask_out) ) call mpp_error(FATAL,  &
            'horiz_interp_conserve: for version 2, mask_in and mask_out must be passed in horiz_interp_new, not in horiz_interp')
       call horiz_interp_conserve_version2(Interp, data_in, data_out, verbose)     
    end select

  end subroutine horiz_interp_conserve
  ! </SUBROUTINE>

  !##############################################################################
  subroutine horiz_interp_conserve_version1 ( Interp, data_in, data_out, verbose, &
       mask_in, mask_out)
    !-----------------------------------------------------------------------
    type (horiz_interp_type), intent(in) :: Interp
    real, intent(in),  dimension(:,:) :: data_in
    real, intent(out), dimension(:,:) :: data_out
    integer, intent(in),                   optional :: verbose
    real, intent(in),   dimension(:,:), optional :: mask_in
    real, intent(out),  dimension(:,:), optional :: mask_out
    !----------local variables----------------------------------------------------
    integer :: m, n, nlon_in, nlat_in, nlon_out, nlat_out,   &
         miss_in, miss_out, is, ie, js, je,   &
         np, npass, iverbose
    real    :: dsum, wsum, avg_in, min_in, max_in,   &
         avg_out, min_out, max_out, eps, asum,   &
         dwtsum, wtsum, arsum, fis, fie, fjs, fje
    !-----------------------------------------------------------------------
    iverbose = 0;  if (present(verbose)) iverbose = verbose

    eps = epsilon(wtsum)

    nlon_in  = Interp%nlon_src;  nlat_in  = Interp%nlat_src
    nlon_out = Interp%nlon_dst; nlat_out = Interp%nlat_dst

    if (present(mask_in)) then
       if ( count(mask_in < -.0001 .or. mask_in > 1.0001) > 0 ) &
            call mpp_error(FATAL, 'horiz_interp_conserve_mod: input mask not between 0,1')
    endif

    !-----------------------------------------------------------------------
    !---- loop through output grid boxes ----

    data_out = 0.0
    do n = 1, nlat_out
       ! latitude window
       ! setup ascending latitude indices and weights
       if (Interp%jlat(n,1) <= Interp%jlat(n,2)) then
          js = Interp%jlat(n,1); je = Interp%jlat(n,2)
          fjs = Interp%facj(n,1); fje = Interp%facj(n,2)
       else
          js = Interp%jlat(n,2); je = Interp%jlat(n,1)
          fjs = Interp%facj(n,2); fje = Interp%facj(n,1)
       endif

       do m = 1, nlon_out
          ! longitude window
          is = Interp%ilon(m,1); ie = Interp%ilon(m,2)
          fis = Interp%faci(m,1); fie = Interp%faci(m,2)
          npass = 1
          dwtsum = 0.
          wtsum = 0.
          arsum = 0.

          ! wrap-around on input grid
          ! sum using 2 passes (pass 1: end of input grid)
          if ( ie < is ) then
             ie = nlon_in
             fie = 1.0
             npass = 2
          endif

          do np = 1, npass
             ! pass 2: beginning of input grid
             if ( np == 2 ) then
                is = 1
                fis = 1.0
                ie = Interp%ilon(m,2)
                fie = Interp%faci(m,2)
             endif

             ! summing data*weight and weight for single grid point
             if (present(mask_in)) then
                call data_sum ( data_in(is:ie,js:je), Interp%area_src(is:ie,js:je), &
                     fis, fie, fjs,fje, dwtsum, wtsum, arsum, mask_in(is:ie,js:je)  )
             else if( ASSOCIATED(Interp%mask_in) ) then
                call data_sum ( data_in(is:ie,js:je), Interp%area_src(is:ie,js:je), &
                     fis, fie, fjs,fje, dwtsum, wtsum, arsum, Interp%mask_in(is:ie,js:je)  )
             else
                call data_sum ( data_in(is:ie,js:je), Interp%area_src(is:ie,js:je), &
                     fis, fie, fjs,fje,  dwtsum, wtsum, arsum    )
             endif
          enddo

          if (wtsum > eps) then
             data_out(m,n) = dwtsum/wtsum
             if (present(mask_out)) mask_out(m,n) = wtsum/arsum
          else
             data_out(m,n) = 0.
             if (present(mask_out)) mask_out(m,n) = 0.0
          endif

       enddo
    enddo

    !***********************************************************************
    ! compute statistics: minimum, maximum, and mean
    !-----------------------------------------------------------------------

    if (iverbose > 0) then

       ! compute statistics of input data

       call stats(data_in, Interp%area_src, asum, dsum, wsum, min_in, max_in, miss_in, mask_in)
       ! diagnostic messages
       ! on the root_pe, we can calculate the global mean, minimum and maximum.
       if(pe == root_pe) then
          if (wsum > 0.0) then
             avg_in=dsum/wsum
          else
             print *, 'horiz_interp stats: input area equals zero '
             avg_in=0.0
          endif
          if (iverbose > 1) print '(2f16.11)', 'global sum area_in  = ',  asum, wsum
       endif

       ! compute statistics of output data
       call stats(data_out, Interp%area_dst, asum, dsum, wsum, min_out, max_out, miss_out, mask_out)
       ! diagnostic messages
       if(pe == root_pe) then
          if (wsum > 0.0) then
             avg_out=dsum/wsum
          else
             print *, 'horiz_interp stats: output area equals zero '
             avg_out=0.0
          endif
          if (iverbose > 1) print '(2f16.11)', 'global sum area_out = ',  asum, wsum
       endif
       !---- output statistics ----
       ! the global mean, min and max are calculated on the root pe.
       if(pe == root_pe) then
          write (*,900)
          write (*,901)  min_in ,max_in ,avg_in
          if (present(mask_in))  write (*,903)  miss_in
          write (*,902)  min_out,max_out,avg_out
          if (present(mask_out)) write (*,903)  miss_out
       endif

900    format (/,1x,10('-'),' output from horiz_interp ',10('-'))
901    format ('  input:  min=',f16.9,'  max=',f16.9,'  avg=',f22.15)
902    format (' output:  min=',f16.9,'  max=',f16.9,'  avg=',f22.15)
903    format ('          number of missing points = ',i6)

    endif

    !-----------------------------------------------------------------------
  end subroutine horiz_interp_conserve_version1

  !#############################################################################
  subroutine horiz_interp_conserve_version2 ( Interp, data_in, data_out, verbose )
    !-----------------------------------------------------------------------
    type (horiz_interp_type), intent(in) :: Interp
    real,    intent(in),  dimension(:,:) :: data_in
    real,    intent(out), dimension(:,:) :: data_out
    integer, intent(in),        optional :: verbose  
    integer :: i, i_src, j_src, i_dst, j_dst

    data_out = 0.0
    do i = 1, Interp%nxgrid
       i_src = Interp%i_src(i); j_src = Interp%j_src(i)
       i_dst = Interp%i_dst(i); j_dst = Interp%j_dst(i)
       data_out(i_dst, j_dst) = data_out(i_dst, j_dst) + data_in(i_src,j_src)*Interp%area_frac_dst(i)
    end do
    
  end subroutine horiz_interp_conserve_version2

  !#######################################################################
  ! <SUBROUTINE NAME="horiz_interp_conserve_del">

  !   <OVERVIEW>
  !     Deallocates memory used by "horiz_interp_type" variables.
  !     Must be called before reinitializing with horiz_interp_new.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Deallocates memory used by "horiz_interp_type" variables.
  !     Must be called before reinitializing with horiz_interp_new.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call horiz_interp_conserve_del ( Interp )
  !   </TEMPLATE>

  !   <INOUT NAME="Interp" TYPE="horiz_interp_type">
  !     A derived-type variable returned by previous call
  !     to horiz_interp_new. The input variable must have
  !     allocated arrays. The returned variable will contain
  !     deallocated arrays.
  !   </INOUT>

  subroutine horiz_interp_conserve_del ( Interp )

    type (horiz_interp_type), intent(inout) :: Interp

    select case(Interp%version)  
    case (1)
       if(associated(Interp%area_src)) deallocate(Interp%area_src)
       if(associated(Interp%area_dst)) deallocate(Interp%area_dst)
       if(associated(Interp%facj))     deallocate(Interp%facj)
       if(associated(Interp%jlat))     deallocate(Interp%jlat)
       if(associated(Interp%faci))     deallocate(Interp%faci)
       if(associated(Interp%ilon))     deallocate(Interp%ilon)
    case (2)
       if(associated(Interp%i_src)) deallocate(Interp%i_src)
       if(associated(Interp%j_src)) deallocate(Interp%j_src)
       if(associated(Interp%i_dst)) deallocate(Interp%i_dst)
       if(associated(Interp%j_dst)) deallocate(Interp%j_dst)
       if(associated(Interp%area_frac_dst)) deallocate(Interp%area_frac_dst)
    end select

  end subroutine horiz_interp_conserve_del
  ! </SUBROUTINE>

  !#######################################################################
  !---This statistics is for conservative scheme
  subroutine stats ( dat, area, asum, dsum, wsum, low, high, miss, mask )
    real,    intent(in)  :: dat(:,:), area(:,:)
    real,    intent(out) :: asum, dsum, wsum, low, high
    integer, intent(out) :: miss
    real,    intent(in), optional :: mask(:,:)

    integer :: pe, root_pe, npes, p, buffer_int(1)
    real    :: buffer_real(5)

    pe = mpp_pe()
    root_pe = mpp_root_pe()
    npes = mpp_npes()

    ! sum data, data*area; and find min,max on each pe.

    if (present(mask)) then
       asum = sum(area(:,:))
       dsum = sum(area(:,:)*dat(:,:)*mask(:,:))
       wsum = sum(area(:,:)*mask(:,:))
       miss = count(mask(:,:) <= 0.5)
       low  = minval(dat(:,:),mask=mask(:,:) > 0.5)
       high = maxval(dat(:,:),mask=mask(:,:) > 0.5)
    else
       asum = sum(area(:,:))
       dsum = sum(area(:,:)*dat(:,:))
       wsum = sum(area(:,:))
       miss = 0
       low  = minval(dat(:,:))
       high = maxval(dat(:,:))
    endif

    ! other pe send local min, max, avg to the root pe and 
    ! root pe receive these information

    if(pe == root_pe) then
       do p = 1, npes - 1
          ! Force use of "scalar", integer pointer mpp interface
          call mpp_recv(buffer_real(1),glen=5,from_pe=root_pe+p, tag=COMM_TAG_1)
          asum = asum + buffer_real(1)
          dsum = dsum + buffer_real(2)
          wsum = wsum + buffer_real(3)
          low  = min(low, buffer_real(4))
          high = max(high, buffer_real(5))
          call mpp_recv(buffer_int(1),glen=1,from_pe=root_pe+p, tag=COMM_TAG_2)
          miss = miss + buffer_int(1)
       enddo
    else
       buffer_real(1) = asum
       buffer_real(2) = dsum
       buffer_real(3) = wsum
       buffer_real(4) = low
       buffer_real(5) = high
       ! Force use of "scalar", integer pointer mpp interface
       call mpp_send(buffer_real(1),plen=5,to_pe=root_pe, tag=COMM_TAG_1)
       buffer_int(1) = miss
       call mpp_send(buffer_int(1),plen=1,to_pe=root_pe, tag=COMM_TAG_2)
    endif

    call mpp_sync_self()   

  end subroutine stats

  !#######################################################################

  subroutine data_sum( data, area, facis, facie, facjs, facje,  &
       dwtsum, wtsum, arsum, mask )

    !  sums up the data and weights for a single output grid box
    !-----------------------------------------------------------------------
    real, intent(in), dimension(:,:) :: data, area
    real, intent(in)                 :: facis, facie, facjs, facje
    real, intent(inout)              :: dwtsum, wtsum, arsum
    real, intent(in), optional       :: mask(:,:)

    !  fac__ = fractional portion of each boundary grid box included
    !          in the integral
    !  dwtsum = sum(data*area*mask)
    !  wtsum  = sum(area*mask)
    !  arsum  = sum(area)
    !-----------------------------------------------------------------------
    real, dimension(size(area,1),size(area,2)) :: wt
    real    :: asum
    integer :: id, jd
    !-----------------------------------------------------------------------

    id=size(area,1); jd=size(area,2) 

    wt=area
    wt( 1,:)=wt( 1,:)*facis
    wt(id,:)=wt(id,:)*facie
    wt(:, 1)=wt(:, 1)*facjs
    wt(:,jd)=wt(:,jd)*facje

    asum = sum(wt)
    arsum = arsum + asum

    if (present(mask)) then
       wt = wt * mask
       dwtsum = dwtsum + sum(wt*data)
       wtsum =  wtsum + sum(wt)
    else
       dwtsum = dwtsum + sum(wt*data)
       wtsum =  wtsum + asum
    endif
    !-----------------------------------------------------------------------

  end subroutine data_sum


  !#######################################################################

end module horiz_interp_conserve_mod

#include "cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !MODULE:  time --- keep control of time \label{sec:time}
!
! !INTERFACE:
   MODULE time
!
! !DESCRIPTION:
!  This module provides a number of routines/functions and variables
!  related to the mode time in GOTM.
!  The basic concept used in this module is that time is expressed
!  as two integers --- one is the true Julian day and the other is
!  seconds since midnight. All calculations with time then become
!  very simple operations on integers.
!
! !USES:
   IMPLICIT NONE
!
!  default: all is private.
   private
!
! !PUBLIC MEMBER FUNCTIONS:
   public                              :: init_time, calendar_date
   public                              :: julian_day, update_time
   public                              :: write_time_string
   public                              :: time_diff
   public                              :: sunrise_sunset
#ifdef _PRINTSTATE_
   public                              :: print_state_time
#endif
!
! !PUBLIC DATA MEMBERS:
   character(len=19), public           :: timestr
   character(len=19), public           :: start
   character(len=19), public           :: stop
   REALTYPE,          public           :: timestep
   REALTYPE,          public           :: fsecs,simtime
   integer,target,    public           :: julianday,secondsofday
   integer,target,    public           :: yearday
   integer,           public           :: timefmt
   integer,           public           :: MinN,MaxN
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding & Hans Burchard
!  $Log: time.F90,v $
!  Revision 20.0  2013/12/14 00:14:05  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:01:18  smg
!  initial cvs ci to mom5
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:33:41  smg
!  updated to gotm-2012.03.09 CVS tagged code.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.11  2010-09-17 12:53:53  jorn
!  extensive code clean-up to ensure proper initialization and clean-up of all variables
!
!  Revision 1.10  2009-10-21 09:17:27  kb
!  ooobs - removed test print statements
!
!  Revision 1.8  2005-06-27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.7  2004/08/17 15:45:16  lars
!  corrected typos in docu
!
!  Revision 1.6  2003/03/28 09:38:54  kbk
!  removed tabs
!
!  Revision 1.5  2003/03/28 09:20:36  kbk
!  added new copyright to files
!
!  Revision 1.4  2003/03/28 07:56:05  kbk
!  removed tabs
!
!  Revision 1.3  2003/03/10 13:48:15  lars
!  changed intent(out) to intent(inout) for MaxN in init_time
!
!  Revision 1.2  2003/03/10 08:54:16  gotm
!  Improved documentation and cleaned up code
!
!  Revision 1.1.1.1  2001/02/12 15:55:57  gotm
!  initial import into CVS
!
!EOP
!
! !PRIVATE DATA MEMBERS:
   logical                   :: HasRealTime
   integer                   :: jul0,secs0
!
!-----------------------------------------------------------------------
!
   contains

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Initialise the time system
!
! !INTERFACE:
   subroutine init_time(MinN,MaxN)
!
! !DESCRIPTION:
!  The subroutine {\tt init\_time()} initialises the time module by reading
!  a namelist and take actions according to the specifications.
!  On exit from this subroutine the two variables MinN and MaxN have well
!  defined values and can be used in the time loop.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT/OUTPUT PARAMETERS:
   integer, intent(inout)    :: MinN,MaxN
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding & Hans Burchard
!
!EOP
!
! !LOCAL VARIABLES:
   integer                   :: jul1,secs1,jul2,secs2
   integer                   :: ndays,nsecs
!
!-------------------------------------------------------------------------
!BOC
!  Read time specific things from the namelist.
!
   LEVEL1 'init_time'
!
!  Calculate MaxN -> MinN is 1 if not changed by HotStart
!
   MinN = 1
   LEVEL2 'Time step:      ',timestep,' seconds'
   LEVEL2 'Time format:    ',timefmt
   select case (timefmt)
      case (1)
         HasRealTime=.false.
         LEVEL2 '# of timesteps: ',MaxN
         start='2000-01-01 00:00:00'
         call read_time_string(start,jul1,secs1)
         LEVEL2 'Fake start:     ',start
      case (2)
         HasRealTime=.true.
         LEVEL2 'Start:          ',start
         LEVEL2 'Stop:           ',stop
         call read_time_string(start,jul1,secs1)
         call read_time_string(stop,jul2,secs2)

         nsecs = time_diff(jul2,secs2,jul1,secs1)
         MaxN  = nint(nsecs/timestep)

         ndays = jul2-jul1
         if (nsecs .lt. 86400 .and. jul1 .ne. jul2) ndays = ndays-1
         nsecs = nsecs - 86400*ndays
         STDERR '        ==> ',ndays,' day(s) and ',nsecs,' seconds ==> ',MaxN,' micro time steps'
      case (3)
         HasRealTime=.true.
         LEVEL2 'Start:          ',start
         LEVEL2 '# of timesteps: ',MaxN

         call read_time_string(start,jul1,secs1)

         nsecs = nint(MaxN*timestep) + secs1
         ndays = nsecs/86400
         jul2  = jul1 + ndays
         secs2 = mod(nsecs,86400)

         call write_time_string(jul2,secs2,stop)
         LEVEL2 'Stop:           ',stop
      case default
         STDERR 'Fatal error: A non valid input format has been chosen'
         stop 'init_time'
   end select

   jul0  = jul1
   secs0 = secs1

   julianday    = jul0
   secondsofday = secs0
   fsecs = secs0

   simtime = timestep*(MaxN-MinN+1)

   return
   end subroutine init_time
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE:  Convert true Julian day to calendar date
!
! !INTERFACE:
   subroutine calendar_date(julian,yyyy,mm,dd)
!
! !DESCRIPTION:
!  Converts a Julian day to a calendar date --- year, month and day.
!  Based on a similar routine in \emph{Numerical Recipes}.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer                             :: julian
!
! !OUTPUT PARAMETERS:
   integer                             :: yyyy,mm,dd
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding & Hans Burchard
!
!EOP
!
! !LOCAL VARIABLES:
   integer, parameter        :: IGREG=2299161
   integer                   :: ja,jb,jc,jd,je
   REAL                      :: x
!
!-----------------------------------------------------------------------
!BOC
   if(julian .ge. IGREG ) then
      x = ((julian-1867216)-0.25)/36524.25
      ja = julian+1+int(x)-int(0.25*x)
   else
      ja = julian
   end if

   jb = ja+1524
   jc = int(6680 + ((jb-2439870)-122.1)/365.25)
   jd = int(365*jc+(0.25*jc))
   je = int((jb-jd)/30.6001)

   dd = jb-jd-int(30.6001*je)
   mm = je-1
   if (mm .gt. 12) mm = mm-12
   yyyy = jc - 4715
   if (mm .gt. 2) yyyy = yyyy-1
   if (yyyy .le. 0) yyyy = yyyy-1

   return
   end subroutine calendar_date
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE:  Convert a calendar date to true Julian day
!
! !INTERFACE:
   subroutine julian_day(yyyy,mm,dd,julian)
!
! !DESCRIPTION:
!  Converts a calendar date to a Julian day.
!  Based on a similar routine in \emph{Numerical Recipes}.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer                             :: yyyy,mm,dd
!
! !OUTPUT PARAMETERS:
   integer                             :: julian
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding & Hans Burchard
!
!EOP
!
! !LOCAL VARIABLES:
   integer, PARAMETER        :: IGREG=15+31*(10+12*1582)
   integer                   :: ja,jy,jm
!
!-----------------------------------------------------------------------
!BOC
   jy = yyyy
   if(jy .lt. 0) jy = jy+1
   if (mm .gt. 2) then
      jm = mm+1
   else
      jy = jy-1
      jm = mm+13
   end if
   julian = int(floor(365.25*jy)+floor(30.6001*jm)+dd+1720995)
   if (dd+31*(mm+12*yyyy) .ge. IGREG) then
      ja = int(0.01*jy)
      julian = julian+2-ja+int(0.25*ja)
   end if

   return
   end subroutine julian_day
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE:  Keep track of time (Julian days and seconds)
!
! !INTERFACE:
   subroutine update_time(n)
!
! !DESCRIPTION:
!  Based on a starting time this routine calculates the actual time
!  in a model integration using the number of time steps, {\tt n},
!  and the size of the time step, {\tt timestep}. More public variables
!  can be updated here if necessary.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: n
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding & Hans Burchard
!
!EOP
!
! !LOCAL VARIABLES:
   integer                   :: nsecs
   integer                   :: yyyy,mm,dd,jd_firstjan
!
!-----------------------------------------------------------------------
!BOC
   nsecs = nint(n*timestep) + secs0
   fsecs = n*timestep + secs0
   julianday    = jul0 + nsecs/86400
   secondsofday = mod(nsecs,86400)

   call calendar_date(julianday,yyyy,mm,dd)
   call julian_day(yyyy,1,1,jd_firstjan)
   yearday = julianday-jd_firstjan+1

   return
   end subroutine update_time
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE:  Convert a time string to Julian day and seconds
!
! !INTERFACE:
   subroutine read_time_string(timestr,jul,secs)
!
! !DESCRIPTION:
!  Converts a time string to the true Julian day and seconds of that day.
!  The format of the time string must be: {\tt yyyy-mm-dd hh:hh:ss }.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   character(len=19)                   :: timestr
!
! !OUTPUT PARAMETERS:
   integer, intent(out)                :: jul,secs
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding & Hans Burchard
!
!EOP
!
! !LOCAL VARIABLES:
   character                 :: c1,c2,c3,c4
   integer                   :: yy,mm,dd,hh,min,ss
!
!-----------------------------------------------------------------------
!BOC
   read(timestr,'(i4,a1,i2,a1,i2,1x,i2,a1,i2,a1,i2)')  &
                          yy,c1,mm,c2,dd,hh,c3,min,c4,ss
   call julian_day(yy,mm,dd,jul)
   secs = 3600*hh + 60*min + ss

   return
   end subroutine read_time_string
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE:  Convert Julian day and seconds into a time string
!
! !INTERFACE:
   subroutine write_time_string(jul,secs,timestr)
!
! !DESCRIPTION:
!  Formats Julian day and seconds of that day to a nice looking
!  character string.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: jul,secs
!
! !OUTPUT PARAMETERS:
   character(len=19)                   :: timestr
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding & Hans Burchard
!
!EOP
!
! !LOCAL VARIABLES:
   integer                   :: ss,min,hh,dd,mm,yy
!
!-----------------------------------------------------------------------
!BOC
   hh   = secs/3600
   min  = (secs-hh*3600)/60
   ss   = secs - 3600*hh - 60*min

   call calendar_date(jul,yy,mm,dd)

   write(timestr,'(i4.4,a1,i2.2,a1,i2.2,1x,i2.2,a1,i2.2,a1,i2.2)')  &
                        yy,'-',mm,'-',dd,hh,':',min,':',ss

   return
   end subroutine write_time_string
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE:  Return the time difference in seconds
!
! !INTERFACE:
   integer FUNCTION time_diff(jul1,secs1,jul2,secs2)
!
! !DESCRIPTION:
! This functions returns the time difference between two
! dates in seconds. The dates are given as Julian day and seconds
! of that day.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: jul1,secs1,jul2,secs2
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding & Hans Burchard
!
!EOP
!-----------------------------------------------------------------------
!BOC
   time_diff = 86400*(jul1-jul2) + (secs1-secs2)

   return
   end function  time_diff
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE:  Return the times of sunrise and sunset
!
! !INTERFACE:
   subroutine sunrise_sunset(latitude,declination,sunrise,sunset)
!
! !DESCRIPTION:
! This functions returns the time difference between two
! dates in seconds. The dates are given as Julian day and seconds
! of that day.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)                :: latitude,declination
!
! !OUTPUT PARAMETERS:
   REALTYPE, intent(out)               :: sunrise,sunset
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding & Hans Burchard
!
! !LOCAL VARIABLES:
   REALTYPE                  :: omega,hour
!EOP
!-----------------------------------------------------------------------
!BOC
   omega = acos(-tan(latitude*3.141516/180.)*tan(declination*3.141516/180.))
   hour  = omega*180/3.141516/15.
   sunrise = 12. - hour
   sunset  = 12. + hour
   return
   end subroutine  sunrise_sunset
!EOC

#ifdef _PRINTSTATE_
!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Print the current state of the time module.
!
! !INTERFACE:
   subroutine print_state_time()
!
! !DESCRIPTION:
!  This routine writes the value of all module-level variables to screen.
!
! !USES:
   IMPLICIT NONE
!
! !REVISION HISTORY:
!  Original author(s): Jorn Bruggeman
!
!EOP
!-----------------------------------------------------------------------
!BOC
   LEVEL1 'State of time module:'
   LEVEL2 'timestr',timestr
   LEVEL2 'start',start
   LEVEL2 'stop',stop
   LEVEL2 'timestep',timestep
   LEVEL2 'fsecs,simtime',fsecs,simtime
   LEVEL2 'julianday,secondsofday',julianday,secondsofday
   LEVEL2 'yearday',yearday
   LEVEL2 'timefmt',timefmt
   LEVEL2 'MinN,MaxN',MinN,MaxN
   LEVEL2 'HasRealTime',HasRealTime
   LEVEL2 'jul0,secs0',jul0,secs0

   end subroutine print_state_time
!EOC
#endif

!-----------------------------------------------------------------------

   end module time

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module edt_mod

!=======================================================================
!
!
!
!      EDT (Entrainment and Diagnostic Turbulence) MODULE
!
!
!      February 2002
!      Contact person: Steve Klein
!
!
!      These routines calculate the diffusivity coefficients for
!      momentum and temperature-moisture-scalars using the moist
!      thermodynamcs modules based on:
!
!      H. Grenier and C. Bretherton, 2001: A moist PBL parameterization
!      for large-scale models and its application to subtropical
!      cloud-topped marine boundary layers. Mon. Wea. Rev., 129,
!      357-377.
!
!      The actual routine is not described in this paper but is
!      a simplified extension of the parameterization discussed
!      here.  The original code, given to Steve Klein from 
!      Chris Bretherton in May 2001, was tested in the NCAR 
!      atmospheric model, formerly known as CCM. The code has 
!      been adapted for the FMS system by Steve Klein and Paul
!      Kushner.
!
!
!      To quote the Bretherton and Grenier description:
!
!      Driver routine to compute eddy diffusion coefficients for 
!      momentum, moisture, trace constituents and static energy.  Uses 
!      first order closure for stable turbulent layers. For convective 
!      layers, an entrainment closure is used, coupled to a diagnosis 
!      of layer-average TKE from the instantaneous thermodynamic and 
!      velocity profiles. Convective layers are diagnosed by extending 
!      layers of moist static instability into adjacent weakly stably 
!      stratified interfaces, stopping if the stability is too strong.  
!      This allows a realistic depiction of dry convective boundary 
!      layers with a downgradient approach."
! 
!      Authors:  Herve Grenier, 06/2000, Chris Bretherton 09/2000
!
!-----------------------------------------------------------------------
!
!-----------------------------------------------------------------------
!
! outside modules used
!

use      constants_mod, only: grav,vonkarm,cp_air,rdgas,rvgas,hlv,hls, &
                              tfreeze,radian

use            mpp_mod, only: input_nml_file
use            fms_mod, only: file_exist, open_namelist_file, error_mesg, FATAL,&
                              NOTE, mpp_pe, mpp_root_pe, close_file, read_data, &
                              write_data, write_version_number, stdlog, &
                              open_file, check_nml_error
use fms_io_mod,         only: register_restart_field, restart_file_type, &
                              save_restart, restore_state

use   diag_manager_mod, only: register_diag_field, send_data
        
use   time_manager_mod, only: time_type, get_date, month_name
 
use  monin_obukhov_mod, only: mo_diff

use sat_vapor_pres_mod, only: compute_qs

implicit none
private

!-----------------------------------------------------------------------
!
!      public interfaces

public edt, edt_init, edt_end, edt_on, qaturb, qcturb,tblyrtau

!-----------------------------------------------------------------------
!
!      global storage variable
!

real, allocatable, dimension(:,:,:) :: qaturb ! cloud fraction diagnosed
                                              ! from turbulence model
      ! (fraction)
real, allocatable, dimension(:,:,:) :: qcturb ! cloud condensate 
                                              ! diagnosed from turb.
      ! model (kg liq/kg air)
real, allocatable, dimension(:,:,:) :: tblyrtau  ! turbulent layer
                                                 ! time scale
 ! (seconds)
real, allocatable, dimension(:,:,:) :: sigmas ! standard deviation of 
                                              ! water perturbation
                                              ! (kg water/kg air)     

type(restart_file_type), pointer, save :: edt_restart => NULL()
!-----------------------------------------------------------------------
!
!      set default values to namelist parameters       
!

character :: sftype  = "z"           ! method for calculating sat frac
real      :: qcminfrac = 1.e-3       ! Min condensate counted as cloud
                                     ! as a fraction of qsat.
logical   :: use_qcmin = .true.      ! Use qcminfrac as indicator of
                                     ! of cloud top.
logical   :: use_extrapolated_ql  = .false.  ! should the layer top
                                             ! liquid water be used to
     ! estimate the evaporative
     ! enhancement
integer   :: n_print_levels = 14     ! how many of the lowest levels 
                                     ! should be printed out
integer, dimension(2) :: edt_pts = 0 ! the global indices for i,j
                                     ! at which diagnostics will 
                                     ! print out
logical   :: do_print = .false.      ! should selected variables 
                                     ! be sent to logfile
logical   :: column_match = .false.  ! should this column be printed 
                                     ! out?
integer   :: dpu = 0                 ! unit # for do_print output
 
real      :: min_adj_time = 0.25     ! minimum adjustment time of
                                     ! turbulent layer for thermo-
                                     ! dynamics, as a fraction of
                                     ! the physics time step. 
! 
! the following quantities only deal with the gaussian cloud model 
!
 
logical   :: do_gaussian_cloud = .false.  

real      :: kappa   = 0.5       ! absolute value of the correlation
                                 ! coefficient between sli and qt 
 ! fluctions
real      :: mesovar = 0.02      ! amplitude to mesoscale fluctuations
                                 ! in sigma-s as a fraction of the 
 ! saturation specific humidity
         

integer, parameter                 :: MAX_PTS = 20
integer, dimension (MAX_PTS)       :: i_edtprt_gl=0, j_edtprt_gl=0
real, dimension(MAX_PTS)           :: lat_edtprt=999., lon_edtprt=999.
integer                            :: num_pts_ij = 0
integer                            :: num_pts_latlon = 0



namelist /edt_nml/sftype, qcminfrac, use_qcmin,kappa, mesovar,edt_pts,    &
                  do_gaussian_cloud, n_print_levels, use_extrapolated_ql, &
                  min_adj_time, i_edtprt_gl, j_edtprt_gl,                 &
                  num_pts_ij, num_pts_latlon, lat_edtprt, lon_edtprt
  
 
integer     :: num_pts           !  total number of columns in which
                                 !  diagnostics are desired

!---------------------------------------------------------------------
!    deglon1 and deglat1 are the longitude and latitude of the columns
!    at which diagnostics will be calculated (degrees).
!---------------------------------------------------------------------
real,    dimension(:), allocatable  :: deglon1, deglat1
 
!---------------------------------------------------------------------
!    iradprt and jradprt are the processor-based i and j coordinates 
!    of the desired diagnostics columns.
!---------------------------------------------------------------------
integer, dimension(:), allocatable  :: j_edtprt, i_edtprt

!---------------------------------------------------------------------
!    do_raddg is an array of logicals indicating which latitude rows
!    belonging to the processor contain diagnostics columns.
!---------------------------------------------------------------------
logical, dimension(:), allocatable  :: do_edt_dg

!-----------------------------------------------------------------------
!
!      diagnostic fields       
!

character(len=10) :: mod_name = 'edt'
real              :: missing_value = -999.
integer           :: id_fq_cv_int,    id_fq_cv_top,      id_fq_cv_bot, &
                     id_fq_st,   id_n2,      id_s2,      id_ri,        &
                     id_leng,    id_bprod,   id_sprod,   id_trans,     &
                     id_diss,    id_qaedt,   id_qcedt,   id_tauinv,    &
                     id_eddytau, id_fq_turb, id_sigmas,  id_radf,      &
                     id_sh,      id_sm,      id_gh,      id_evhc
       
      
!-----------------------------------------------------------------------
!
!      set default values to parameters       
!

logical         :: edt_on = .false.
logical         :: init = .false.
real, parameter :: small  = 1.e-8      
real, parameter :: fpi  = 3.14159     ! pi
real, parameter :: d608 = (rvgas-rdgas)/rdgas
real, parameter :: d622 = rdgas/rvgas
real, parameter :: d378 = 1. - d622
real, parameter :: frac_sfclyr = 0.1  ! height of surface layer top as a 
                                      ! fraction of the pbl height

!-----------------------------------------------------------------------
!
!      the following parameters are those defined only in the routines
!      provided by Chris Bretherton and Herve Grenier
!

real, parameter :: ntzero  = 1.e-10   ! not zero, used to set min value
                                      ! to s2, shear-squared.
real, parameter :: zvir    = d608  

real, parameter :: b1      =   5.8    ! TKE dissipation = e^3/(b1*leng)
real            :: b123    =   3.2281 ! b1**(2/3)
real, parameter :: tunl    =   0.085  ! Asympt leng = 
                                      !       tunl*(turb lyr depth)
real, parameter :: alph1   =   0.5562 ! Galperin stability fn params
real, parameter :: alph2   =  -4.3640
real, parameter :: alph3   = -34.6764
real, parameter :: alph4   =  -6.1272
real, parameter :: alph5   =   0.6986
real, parameter :: ricrit  =   0.19   ! Critical Richardson # for turb.
real, parameter :: mu      =  70.     ! used in finding e/ebar in 
                                      ! convective layers (CLs)
real, parameter :: rinc    =  -0.5    ! Min W/<W> for incorp into CL

! params governing entr. effic. A=a1l*evhc, evhc=1+a2l*a3l*L*ql/jt2slv
! where ql is cloud-top liq. water and jt2slv is the jump in slv across
! the cloud-top entrainment zone.

real, parameter :: a1l       =  0.10  ! Dry entrainment efficiency param
                                      ! Herve set to 0.05 due to excess 
      ! TKE but a1l = 0.10 = 0.2*tunl*
      ! erat^-1.5 should be the "real" 
      ! value, where erat = <e>/wstar^2 
      ! for dry CBL = 0.3
real, parameter :: a2l       = 15.    ! Moist entrainment enhancement 
                                      ! param Herve's SCCM value was 15
real, parameter :: a3l       =  0.8   ! 
real, parameter :: jbumin    =  0.001 ! Min buoyancy jump at an entrain-
                                      ! ment interface (m/s2)
      ! (~ jump in K/30)
real, parameter :: evhcmax   = 10.    ! Max entrainment efficiency
real, parameter :: rimaxentr =  0.    ! Limiting Ri for entraining turb
                                      ! layer
      
!  parameters affecting TKE

real, parameter :: rmin    =   0.1    ! Min allowable e/<e> in a CL
real, parameter :: rmax    =   2.0    ! Max allowable e/<e> in a CL
real, parameter :: tkemax  =  20.     ! tke capped at tkemax (m2/s2)
real, parameter :: tkemin  =   1.e-6  ! tke minimum (m2/s2)

!-----------------------------------------------------------------------
!
! declare version number 
!

character(len=128) :: Version = '$Id: edt.F90,v 19.0 2012/01/06 20:09:18 fms Exp $'
character(len=128) :: Tagname = '$Name: tikal $'
logical            :: module_is_initialized = .false.
!-----------------------------------------------------------------------
!
! fms module subroutines include:
!
!      edt         main driver program of the module
!
!      edt_init    initialization routine       
!
!      edt_tend    adds in the longwave heating rate to the 
!                         global storage variable
!
!      edt_end     ending routine
!
!
!      Grenier-Bretherton subroutines are described after the 
!      subroutines listed above.
!


      integer, dimension(1) :: restart_versions = (/ 1 /)

contains




!======================================================================= 
!
!      subroutine edt_init 
!        
!
!      this subroutine reads the namelist file and restart data
!      and initializes some constants.
!        

subroutine edt_init(lonb, latb, axes,time,idim,jdim,kdim)

!-----------------------------------------------------------------------
!
!      variables
!
!      -----
!      input
!      -----
! 
!      idim,jdim,kdim    size of the first 3 dimensions 
!      axes, time        variables needed for netcdf diagnostics
!      latb, lonb        latitudes and longitudes at grid box corners
!
!
!      --------
!      internal
!      --------
! 
!      unit              unit number for namelist and restart file
!      io                internal variable for reading of namelist file
!      full              indices for full level axes coordinates
!      half              indices for half level axes coordinates
!
!-----------------------------------------------------------------------

integer,              intent(in) :: idim,jdim,kdim,axes(4)
type(time_type),      intent(in) :: time
real, dimension(:,:), intent(in) :: lonb, latb

integer               :: unit, io, logunit, ierr, vers, vers2, nn, i, j, id_restart
real                  :: dellat, dellon
character(len=4)      :: chvers
integer, dimension(3) :: full = (/1,2,3/), half = (/1,2,4/)

!-----------------------------------------------------------------------
!
!      namelist functions

#ifdef INTERNAL_FILE_NML
   read (input_nml_file, nml=edt_nml, iostat=io)
   ierr = check_nml_error(io,'edt_nml')
#else   
   if (file_exist('input.nml')) then
      unit = open_namelist_file ()
      ierr=1 ; Do While (ierr .ne. 0)
        Read  (unit, nml=edt_nml, iostat=io, End=10)
        ierr = check_nml_error(io,'edt_nml')
      enddo
10    Call Close_File (unit)
   endif
#endif

!------- write version number and namelist ---------

   if ( mpp_pe() == mpp_root_pe() ) then
       call write_version_number(version, tagname)
       logunit = stdlog()
       write (logunit, nml=edt_nml)
   endif
    
!---------------------------------------------------------------------
!    allocate and initialize a flag array which indicates the latitudes
!    containing columns where radiation diagnostics are desired.
!---------------------------------------------------------------------
   allocate (do_edt_dg (size(latb,2)-1) )
   do_edt_dg(:) = .false.

!-------------------------------------------------------------------
!    define the total number of points at which diagnostics are desired.
!    points may be specified either by lat-lon pairs or by global index
!    pairs. 
!-------------------------------------------------------------------
   num_pts = num_pts_latlon + num_pts_ij

!-------------------------------------------------------------------
!    continue on only if diagnostics are desired in at least one column.
!-------------------------------------------------------------------
   if (num_pts > 0) then

!-------------------------------------------------------------------
!    if more points are desired than space has been reserved for, print 
!    a message.
!-------------------------------------------------------------------
     if (num_pts > MAX_PTS) then
       call error_mesg ( 'edt_mod', &
      'must reset MAX_PTS or reduce number of diagnostics points', &
                                                          FATAL)
     endif

!-------------------------------------------------------------------
!    allocate space for arrays which will contain the lat and lon and
!    processor-local i and j indices.
!-------------------------------------------------------------------
     allocate ( deglon1 (num_pts))
     allocate ( deglat1 (num_pts))
     allocate ( j_edtprt (num_pts))
     allocate ( i_edtprt (num_pts))

!---------------------------------------------------------------------
!    if any points for diagnostics are specified by (i,j) global 
!    indices, determine their lat-lon coordinates. assumption is made 
!    that the deltas of latitude and longitude are uniform over 
!    the globe.
!---------------------------------------------------------------------
     do nn=1,num_pts_ij
       dellat = latb(1,2) - latb(1,1)
       dellon = lonb(2,1) - lonb(1,1)
       lat_edtprt(nn + num_pts_latlon) =     &
                   (-0.5*acos(-1.0) + (j_edtprt_gl(nn) - 0.5)*  &
                                        dellat) * radian
       lon_edtprt(nn + num_pts_latlon) =                & 
                    (i_edtprt_gl(nn) - 0.5)*dellon*radian
     end do

!--------------------------------------------------------------------
!    determine if the lat/lon values are within the global grid,
!    latitude between -90 and 90 degrees and longitude between 0 and
!    360 degrees.
!--------------------------------------------------------------------
     do nn=1,num_pts
       j_edtprt(nn) = 0
       i_edtprt(nn) = 0
       deglat1(nn) = 0.0
       deglon1(nn) = 0.0
       if (lat_edtprt(nn) .ge. -90. .and. &
           lat_edtprt(nn) .le.  90.) then
       else
         call error_mesg ('edt_mod', &
             ' invalid latitude for edt diagnostics ', FATAL)
       endif

       if (lon_edtprt(nn) .ge. 0. .and. &
           lon_edtprt(nn) .le. 360.) then
       else
         call error_mesg ('edt_mod', &
             ' invalid longitude for edt diagnostics ', FATAL)
       endif

!--------------------------------------------------------------------
!    determine if the diagnostics column is within the current 
!    processor's domain. if so, set a logical flag indicating the
!    presence of a diagnostic column on the particular row, define the 
!    i and j processor-coordinates and the latitude and longitude of 
!    the diagnostics column.
!--------------------------------------------------------------------
       do j=1,size(latb,2) - 1
         if (lat_edtprt(nn) .ge. latb(1,j)*radian .and.  &
             lat_edtprt(nn) .lt. latb(1,j+1)*radian) then
           do i=1,size(lonb,1) - 1
             if (lon_edtprt(nn) .ge. lonb(i,1)*radian   &
                               .and.&
                 lon_edtprt(nn) .lt. lonb(i+1,1)*radian)  &
                                then
               do_edt_dg(j) = .true.
               j_edtprt(nn) = j
               i_edtprt(nn) = i
               deglon1(nn) = 0.5*(lonb(i,1) + lonb(i+1,1))*radian
               deglat1(nn) = 0.5*(latb(1,j) + latb(1,j+1))*radian
               exit
             endif
           end do
           exit
         endif
       end do
     end do

!----------------------------------------------------------------------
!    open a unit for the radiation diagnostics output.
!---------------------------------------------------------------------
     dpu = open_file ('edt.out', action='write', &
                                 threading='multi', form='formatted')
     do_print = .true.

     if ( mpp_pe() == mpp_root_pe() ) then
        call write_version_number(version, tagname)
        write (dpu ,nml=edt_nml)
     endif
   endif     ! (num_pts > 0)

!-----------------------------------------------------------------------
!
!      initialize edt_on

   edt_on = .TRUE.
   module_is_initialized = .true.
!-----------------------------------------------------------------------
!
!      initialize b123 = b1**(2/3)

   b123 = b1**(2./3.)
       
!-----------------------------------------------------------------------
!
!      handle global storage
        
   if (allocated(qaturb)) deallocate (qaturb)
   allocate(qaturb(idim,jdim,kdim))
   if (allocated(qcturb)) deallocate (qcturb)
   allocate(qcturb(idim,jdim,kdim))
   if (allocated(tblyrtau)) deallocate (tblyrtau)
   allocate(tblyrtau(idim,jdim,kdim))
   if (allocated(sigmas)) deallocate (sigmas)
   allocate(sigmas(idim,jdim,kdim+1))


   allocate(edt_restart)
   id_restart = register_restart_field(edt_restart, 'edt.res.nc', 'qaturb'  , qaturb )
   id_restart = register_restart_field(edt_restart, 'edt.res.nc', 'qcturb'  , qcturb )
   id_restart = register_restart_field(edt_restart, 'edt.res.nc', 'tblyrtau', tblyrtau )
   id_restart = register_restart_field(edt_restart, 'edt.res.nc', 'sigmas'  , sigmas )

   if (File_Exist('INPUT/edt.res.nc')) then

     if (mpp_pe() == mpp_root_pe() ) then
       call error_mesg ('edt_mod',  'Reading netCDF formatted restart file: INPUT/edt.res.nc', &
                         NOTE)
     endif
     call restore_state(edt_restart)

   elseif (File_Exist('INPUT/edt.res')) then
     call error_mesg ('edt_mod', 'Native format restart file read no longer supported.',&
                       FATAL)
!     unit = Open_restart_File (FILE='INPUT/edt.res', ACTION='read')
!     read (unit, iostat=io, err=142) vers, vers2
!142  continue
! 
!!--------------------------------------------------------------------
!!    if eor is not encountered, then the file includes tdtlw as the
!!    first record (which this read statement read). that data is not 
!!    needed; note this and continue by reading next record.
!!--------------------------------------------------------------------
!     if (io == 0) then
!       call error_mesg ('edt_mod',  &
!           'reading pre-version number edt.res file, '//&
!           'ignoring tdtlw', NOTE)
!
!!--------------------------------------------------------------------
!!    if the first record was only one word long, then the file is a 
!!    newer one, and that record was the version number, read into vers. 
!!    if it is not a valid version, stop execution with a message.
!!--------------------------------------------------------------------
!     else
!       if (.not. any(vers == restart_versions) ) then
!         write (chvers, '(i4)') vers
!         call error_mesg ('edt_mod',  &
!              'restart version ' // chvers//' cannot be read '//&
!              'by this version of edt_mod.', FATAL)
!       endif
!     endif
!
!!---------------------------------------------------------------------
!     call read_data (unit, qaturb)
!     call read_data (unit, qcturb)
!     call read_data (unit, tblyrtau)
!     call read_data (unit, sigmas)
!     call Close_File (unit)
   else
     qaturb  (:,:,:) = 0.
     qcturb  (:,:,:) = 0.
     tblyrtau(:,:,:) = 0.
     sigmas  (:,:,:) = 0.
   endif

!-----------------------------------------------------------------------
!
! register diagnostic fields       

   id_fq_cv_int = register_diag_field (mod_name, 'fq_cv_int', axes(half), &
                  time, 'Frequency that the interface is in '//           &
                  'the interior of a convective layer from EDT',          &
                  'none', missing_value=missing_value )

   id_fq_cv_top = register_diag_field (mod_name, 'fq_cv_top', axes(half), &
                  time, 'Frequency that the interface is at '//           &
                  'the top of a convective layer from EDT',               &
                  'none', missing_value=missing_value )

   id_fq_cv_bot = register_diag_field (mod_name, 'fq_cv_bot', axes(half), &
                  time, 'Frequency that the interface is at '//           &
                  'the bottom of a convective layer from EDT',            &
                  'none', missing_value=missing_value )

   id_fq_st = register_diag_field (mod_name, 'fq_st', axes(half),  &
              time, 'Frequency of stable turbulence from EDT',     &
              'none', missing_value=missing_value )

   id_fq_turb = register_diag_field (mod_name, 'fq_turb', axes(full), &
                time, 'Frequency that the layer is fully '//          &
                'turbulent from EDT','none', missing_value=missing_value )

   id_n2 = register_diag_field (mod_name, 'n2', axes(half),        &
           time,'Moist Vaisala Frequency from EDT',                &
           '(1/sec)**2', missing_value=missing_value )
       
   id_s2 = register_diag_field (mod_name, 's2', axes(half),        &
           time,'Shear vector magnitude squared from EDT',         &
           '(1/sec)**2', missing_value=missing_value )
       
   id_ri = register_diag_field (mod_name, 'ri', axes(half),        &
           time, 'Moist Richardson number from EDT',               &
           'none', missing_value=missing_value )

   id_leng = register_diag_field (mod_name, 'leng', axes(half),    &
             time, 'Turbulent Length Scale from EDT',              &
             'meters', missing_value=missing_value )
       
   id_bprod = register_diag_field (mod_name, 'bprod', axes(half),  &
              time, 'Buoyancy production of TKE from EDT',         &
              '(meters**2)/(sec**3)', missing_value=missing_value )

   id_sprod = register_diag_field (mod_name, 'sprod', axes(half),  &
              time, 'Shear production of TKE from EDT',            &
              '(meters**2)/(sec**3)', missing_value=missing_value )
       
   id_trans = register_diag_field (mod_name, 'trans', axes(half),  &
              time, 'TKE transport from EDT',                      &
              '(meters**2)/(sec**3)', missing_value=missing_value )
       
   id_diss = register_diag_field (mod_name, 'diss', axes(half),    &
             time, 'TKE dissipation from EDT',                     &
             '(meters**2)/(sec**3)', missing_value=missing_value )

   id_radf  = register_diag_field (mod_name, 'radf', axes(half),   &
              time, 'TKE radiative forcing from EDT',              &
              '(meters**2)/(sec**3)', missing_value=missing_value )
       
   id_sh  = register_diag_field (mod_name, 'sh', axes(half),       &
            time, 'Galperin heat stability coefficient from EDT',  &
            'none', missing_value=missing_value )
 
   id_sm  = register_diag_field (mod_name, 'sm', axes(half),          &
            time, 'Galperin momentum stability coefficient from EDT', &
            'none', missing_value=missing_value )
 
   id_gh  = register_diag_field (mod_name, 'gh', axes(half),          &
            time, 'Galperin stability ratio from EDT',                &
            'none', missing_value=missing_value )
 
   id_evhc  = register_diag_field (mod_name, 'evhc', axes(half),       &
              time, 'Evaporative cooling enhancement factor from EDT', &
              'none', missing_value=missing_value )
 
   id_sigmas = register_diag_field (mod_name, 'sigmas', axes(half), &
               time, 'Std. dev. of water perturbation from EDT',    &
               '(kg water)/(kg air)', missing_value=missing_value )
       
   id_qaedt = register_diag_field (mod_name, 'qaedt', axes(full),  &
              time, 'statistical cloud fraction from EDT',         &
              'fraction', missing_value=missing_value )
       
   id_qcedt = register_diag_field (mod_name, 'qcedt', axes(full),  &
              time, 'statistical cloud condensate from EDT',       &
              'kg condensate/kg air', missing_value=missing_value )
       
   id_tauinv = register_diag_field (mod_name, 'tauinv', axes(half),&
               time, 'inverse large-eddy turnover time from EDT',  &
               '1/second', missing_value=missing_value )
       
   id_eddytau = register_diag_field (mod_name, 'eddytau', axes(full), &
                time, 'large-eddy turnover time from EDT',      &
                'seconds', missing_value=missing_value )
                          
!-----------------------------------------------------------------------
! 
!      subroutine end
!

end subroutine edt_init

!
!======================================================================= 




!======================================================================= 
!
!      subroutine edt
!        
!
!       this subroutine is the main driver program to the routines
!       provided by Chris Bretherton
!        

subroutine edt(is,ie,js,je,dt,time,tdtlw_in, u_star,b_star,q_star,t,qv,ql,qi,qa, &
               u,v,z_full,p_full,z_half,p_half,stbltop,k_m,k_t,pblh,kbot,tke)

!-----------------------------------------------------------------------
!
!      variables
!
!      -----
!      input
!      -----
!
!      is,ie,js,je  i,j indices marking the slab of model working on
!      dt        physics time step (seconds)
!      time      variable needed for netcdf diagnostics
!      u_star    friction velocity (m/s)
!      b_star    buoyancy scale (m/(s**2))
!      q_star    moisture scale (kg vapor/kg air)
!
!      three dimensional fields on model full levels, reals dimensioned
!      (:,:,pressure), third index running from top of atmosphere to 
!      bottom
!          
!      t         temperature (K)
!      qv        water vapor specific humidity (kg vapor/kg air)
!      ql        liquid water specific humidity (kg cond/kg air)
!      qi        ice water specific humidity (kg cond/kg air)
!      qa        cloud fraction 
!      u         zonal wind (m/s)
!      v         meridional wind (m/s) 
!      z_full    height of full levels (m)
!      p_full    pressure (Pa)
!
!      the following two fields are on the model half levels, with
!      size(z_half,3) = size(t,3) +1, z_half(:,:,size(z_half,3)) 
!      must be height of surface (if you are not using eta-model)
!
!      z_half    height at half levels (m)
!      p_half    pressure at half levels (Pa)
!        
!      ------
!      output
!      ------
!
!      stbltop   maximum altitude the very stable boundary layer
!                is permitted to operate
!
!      The following variables are defined at half levels and are
!      dimensions 1:nlev+1.
!
!      k_m       diffusivity for momentum (m**2/s)
!      k_t       diffusivity for temperature and scalars (m**2/s)
!
!      k_m and k_t are defined at half-levels so that size(k_m,3) 
!      should be at least as large as size(t,3). Note, however, that 
!      only the returned values at levels 2 to size(t,3) are 
!      meaningful; other values will be returned as zero.
!
!      --------------
!      optional input
!      --------------
!
!      kbot      integer indicating the lowest true layer of atmosphere
!
!      ---------------
!      optional output
!      ---------------
!
!      pblh      depth of planetary boundary layer (m)
!      tke       turbulent kinetic energy (m*m)/(s*s)
!
!      --------
!      internal
!      --------
!
!      z_surf    height of surface (m)
!      z_full_ag height of full model levels above the surface (m)
!      qt        total water specific humidity (kg water/kg air)
!      qc        cloud condensate spec. hum. (kg condensate/kg air)
!      qsl       saturation specific humidity at the midpoint pressure
!                and liquid-ice water temperature (kg water/kg air)
!      dqsldtl   temperature derivative of qsl (kg H20/kg air/Kelvin)
!      hleff     effective latent heat of vaporization (J/kg)
!      sli       ice-liq water static energy (J/kg) 
!      sliv      ice-liq water virtual static energy (J/kg)                                      
!      khfs      surface kinematic heat flux (K*(m/s)) 
!      kqfs      surface kinematic vapor flux (kg/kg)*(m/s)
!      slislope  sli slope wrt pressure in thermo layer (J/kg/Pa)
!      qtslope   qt slope wrt pressure in thermo layer (kg/kg/Pa)
!      qxtop     saturation excess at the top of the layer 
!                (kg wat/kg air)
!      qxbot     saturation excess at the bottom of the layer 
!                (kg wat/kg air)
!      sfuh      saturated fraction in upper half-layer
!      sflh      sflh saturated fraction in lower half-layer
!      sfclyr_h  height of the surface layer top (m)
!      ql_new    new value of cloud liquid  (kg cond/kg air)
!      qi_new    new value of cloud ice     (kg cond/kg air)
!      qa_new    new value of cloud fraction
!      mask      real array indicating the point is above the surface  &
!                if equal to 1.0 and indicating the point is below the &
!                surface if equal to 0.
!
!      mineddytau  minimum value to adjustment time (1/sec)
!
!
!      the following variables are defined on model half levels
!      (1:kdim+1)
!
!      z_half_ag height of half model levels above the surface (m)
!      chu       heat var. coef for dry states (1/m)
!      chs       heat var. coef for sat states (1/m)
!      cmu       moisture var. coef for dry states (kg/kg)*(m/s*s)
!      cms       moisture var. coef for sat states (kg/kg)*(m/s*s)
!      n2        moist squared buoyancy freq (1/s*s)
!      s2        squared deformation, or shear vector mag. (1/s*s)
!      ri        gradient Richardson number
!
!      formulas for selected internal variables
!      ----------------------------------------
!
!      qt   = qv + ql + qi                 qc   = ql + qi
!      sli  = cp*T + g*z - hleff*qc        sliv = sli*(1.+d608*qt)
!      khfs = mean of (w'T')               kqfs = mean of (w'q')
!
!-----------------------------------------------------------------------

integer,         intent(in)                            :: is,ie,js,je
real,            intent(in)                            :: dt
type(time_type), intent(in)                            :: time
real,            intent(in),  dimension(:,:)           :: u_star, b_star, q_star
real,            intent(in),  dimension(:,:,:)         :: tdtlw_in, &
                                                          t,qv,ql,qi,qa, &
                                                          u, v, &
                                                          z_full, p_full, &
                                                          z_half, p_half
real,            intent(out), dimension(:,:)           :: stbltop, pblh
real,            intent(out), dimension(:,:,:)         :: k_m,k_t
integer,         intent(in),  dimension(:,:),  optional:: kbot
real,            intent(out), dimension(:,:,:),optional:: tke

integer                                         :: i,j,k,kk,ibot
integer                                         :: ipt,jpt
integer                                         :: nlev,nlat,nlon
integer, dimension(4,size(t,1),size(t,2),size(t,3)+1):: turbtype

real                                            :: khfs,kqfs
real                                            :: sfclyr_h_max
real                                            :: mineddytau
real, dimension(size(t,1),size(t,2))            :: z_surf, sfclyr_h
real, dimension(size(t,1),size(t,2),size(t,3))  :: z_full_ag
real, dimension(size(t,1),size(t,2),size(t,3))  :: qt,sli,sliv
real, dimension(size(t,1),size(t,2),size(t,3))  :: esl, qsl, dqsldtl
real, dimension(size(t,1),size(t,2),size(t,3))  :: hleff,density
real, dimension(size(t,1),size(t,2),size(t,3))  :: slislope, qtslope
real, dimension(size(t,1),size(t,2),size(t,3))  :: qxtop, qxbot
real, dimension(size(t,1),size(t,2),size(t,3))  :: qa_new, qc_new
real, dimension(size(t,1),size(t,2),size(t,3))  :: mask, isturb
real, dimension(size(t,1),size(t,2),size(t,3))  :: eddytau,tauinvtmp

real, dimension(size(t,1),size(t,2),size(t,3)+1):: z_half_ag
real, dimension(size(t,1),size(t,2),size(t,3)+1):: n2, s2, ri, tauinv
real, dimension(size(t,1),size(t,2),size(t,3)+1):: leng, bprod, sprod
real, dimension(size(t,1),size(t,2),size(t,3)+1):: trans, diss, evhc
real, dimension(size(t,1),size(t,2),size(t,3)+1):: radf, sh, sm, gh
real, dimension(size(t,1),size(t,2),size(t,3)+1):: mask3, tmpdat
real, dimension(size(t,1),size(t,2),size(t,3)+1):: k_t_mo, k_m_mo

integer, dimension(4,size(t,3)+1) :: gb_turbtype

real                        :: gb_pblh,     gb_u_star
real, dimension(size(t,3))  :: gb_t,        gb_u,        gb_v
real, dimension(size(t,3))  :: gb_qv
real, dimension(size(t,3))  :: gb_dqsldtl,  gb_qa_new,   gb_qc_new
real, dimension(size(t,3))  :: gb_sli,      gb_qt
real, dimension(size(t,3))  :: gb_qc,       gb_sliv,     gb_sflh
real, dimension(size(t,3))  :: gb_slisl,    gb_qtsl,     gb_sfuh
real, dimension(size(t,3))  :: gb_tdtlw,    gb_hleff
real, dimension(size(t,3))  :: gb_qsl,      gb_esl,      gb_qxtop
real, dimension(size(t,3))  :: gb_qxbot,    gb_density,  gb_z_full
real, dimension(size(t,3))  :: gb_p_full,   gb_isturb,   gb_qltop
real, dimension(size(t,3)+1):: gb_cmu,      gb_chu
real, dimension(size(t,3)+1):: gb_chs,      gb_cms
real, dimension(size(t,3)+1):: gb_k_m,      gb_k_t,      gb_tke
real, dimension(size(t,3)+1):: gb_n2,       gb_s2,       gb_ri
real, dimension(size(t,3)+1):: gb_leng,     gb_bprod,    gb_sprod
real, dimension(size(t,3)+1):: gb_diss,     gb_trans,    gb_tauinv
real, dimension(size(t,3)+1):: gb_z_half,   gb_sigmas,   gb_p_half
real, dimension(size(t,3)+1):: gb_radf,     gb_sh,       gb_sm
real, dimension(size(t,3)+1):: gb_gh,       gb_evhc
logical :: used, topfound
 
integer, dimension(MAX_PTS) :: nsave
integer :: iloc(MAX_PTS), jloc(MAX_PTS), nn, npts, nnsave
integer :: year, month, day, hour, minute, second
character(len=16) :: mon


                    
!-----------------------------------------------------------------------
!
!      initialize variables

   pblh   = 0.0       
   
   k_t    = 0.0
   k_m    = 0.0
   tke    = 0.0
   
   turbtype = 0
   isturb = 0.0
   
   n2     = 0.0
   s2     = 0.0
   ri     = 0.0
   tauinv = 0.0
   leng   = 0.0
   bprod  = 0.0
   sprod  = 0.0
   trans  = 0.0
   diss   = 0.0
   radf   = 0.0
   sh     = 0.0
   sm     = 0.0
   evhc   = 0.0
   gh     = 0.0
   
   slislope = 0.0
   qtslope  = 0.0
   
   qxbot  = 0.0
   qxtop  = 0.0
   
   qc_new = 0.0
   qa_new = 0.0

   mineddytau =  min_adj_time * dt

!-----------------------------------------------------------------------
!
!      compute height above surface
!

   nlev = size(t,3)
   nlat = size(t,2)
   nlon = size(t,1)

   mask = 1.0
               
   if (present(kbot)) then
        do j=1,nlat
        do i=1,nlon
             z_surf(i,j) = z_half(i,j,kbot(i,j)+1)
        enddo
        enddo
   else
        z_surf(:,:) = z_half(:,:,nlev+1)
   end if

   do k = 1, nlev
        z_full_ag(:,:,k) = z_full(:,:,k) - z_surf(:,:)
        z_half_ag(:,:,k) = z_half(:,:,k) - z_surf(:,:)
   end do
   z_half_ag(:,:,nlev+1) = z_half(:,:,nlev+1) - z_surf(:,:)
   
   if (present(kbot)) then
        where (z_full_ag < 0)
           mask = 0.0
        endwhere
   end if
      
!-----------------------------------------------------------------------
!
!      Calculate saturation specific humidity and its temperature 
!      derivative, the effective latent heat
!
!      These are calculated according to the formulas:
!
!      qsl  = d622*esl/ [p_full  -  (1.-d622)*esl]
!
!      dqsldtl = d622*p_full*(desat/dT)/[p_full-(1.-d622)*esl]**2.
!
!       
!      where d622 = rdgas/rvgas; esl = saturation vapor pressure;
!      and desat/dT is the temperature derivative of esl. Note that: 
!
!              {             hlv          for t > tfreeze             }
!      hleff = { 0.05*(t-tfreeze+20.)*hlv + 0.05*(tfreeze-t)*hls      }
!              {                          for tfreeze-20.< t < tfreeze}
!              {             hls          for t < tfreeze-20.         }
!
!      This linear form is chosen because at Tfreeze-20. es = esi, and
!      at Tfreeze, es = esl, with linear interpolation in between.
!
!

   !calculate effective latent heat
   hleff = (min(1.,max(0.,0.05*(t       -tfreeze+20.)))*hlv + &
            min(1.,max(0.,0.05*(tfreeze -t          )))*hls)
   
   !calculate qsl and dqsldtl. return es for diagnostic use.
   call compute_qs (t-(hleff*(ql+qi)/cp_air), p_full, qsl, &
                                         esat = esl, dqsdT=dqsldtl)

!-----------------------------------------------------------------------
!
!      set up specific humidities and static energies  
!      compute airdensity

   qt      = qv + ql + qi
   
   sli     = cp_air*t + grav*z_full_ag - hleff*(ql + qi)
   sliv    = sli*(1+zvir*qt)
   density = p_full/rdgas/(t *(1.+d608*qv-ql-qi))              

!-----------------------------------------------------------------------
! 
!      big loop over points
!

   ibot = nlev

   do j=1,nlat
     npts = 0
     if (do_edt_dg(j+js-1) ) then       
       do nn=1,num_pts
         if ( js == j_edtprt(nn) .and.  &
              i_edtprt(nn) >= is .and. i_edtprt(nn) <= ie) then
           iloc(npts+1) = i_edtprt(nn) - is + 1
           jloc(npts+1) = j_edtprt(nn) - js + 1
           nsave(npts+1) = nn
           npts = npts + 1
         endif
       end do    ! (num_points)
     else
       ipt = 0
       jpt = 0
       column_match = .false.
     endif
     do i=1,nlon
       if (npts > 0) then
         do nn=1,npts

           ipt = iloc(nn)
           jpt = jloc(nn)
           if (i == ipt ) then
             column_match = .true.
             nnsave = nsave(nn)
             exit
           else
             column_match = .false.
           endif
         end do
         nn = nnsave
       else 
         column_match = .false.
         nn = 0
       endif
       !-----------------------------------------------------------
       ! should diagnostics be printed out for this column
       !
       !-----------------------------------------------------------
       !
       ! extract column data to pass to caleddy
       !
    
       if (present(kbot)) ibot = kbot(i,j)
    
       gb_t      (1:ibot  ) = t         (i,j,1:ibot  )
       gb_qv     (1:ibot  ) = max(0., qv(i,j,1:ibot  ) )
       gb_qc     (1:ibot  ) = max(0., ql(i,j,1:ibot  ) +          &
                                     qi(i,j,1:ibot  ) )
       gb_qt     (1:ibot  ) = max(0., qt(i,j,1:ibot  ) )
       gb_sli    (1:ibot  ) = sli       (i,j,1:ibot  )
       gb_sliv   (1:ibot  ) = sliv      (i,j,1:ibot  )
       gb_u      (1:ibot  ) = u         (i,j,1:ibot  )
       gb_v      (1:ibot  ) = v         (i,j,1:ibot  )
       gb_z_half (1:ibot+1) = z_half_ag (i,j,1:ibot+1)
       gb_z_full (1:ibot  ) = z_full_ag (i,j,1:ibot  )
       gb_p_half (1:ibot+1) = p_half    (i,j,1:ibot+1)
       gb_p_full (1:ibot  ) = p_full    (i,j,1:ibot  )
       gb_qsl    (1:ibot  ) = qsl       (i,j,1:ibot  )
       gb_esl    (1:ibot  ) = esl       (i,j,1:ibot  )
       gb_hleff  (1:ibot  ) = hleff     (i,j,1:ibot  )
       gb_density(1:ibot  ) = density   (i,j,1:ibot  )
       gb_dqsldtl(1:ibot  ) = dqsldtl   (i,j,1:ibot  )
       gb_tdtlw  (1:ibot  ) = tdtlw_in (i,j,1:ibot)
       gb_sigmas (1:ibot+1) = sigmas(is-1+i,js-1+j,1:ibot+1)
       kqfs                 = u_star(i,j)*q_star(i,j)
       khfs                 = u_star(i,j)*b_star(i,j)*gb_t(ibot)/ &
                              grav
       gb_u_star            = u_star(i,j)          

      !compute sigmas at surface
       gb_sigmas(ibot+1) =  ((mesovar*gb_qsl(ibot))**2.0) +     &
         ((q_star(i,j)-gb_dqsldtl(ibot)*b_star(i,j)*gb_t(ibot)/ &
         grav)**2.0)
       gb_sigmas(ibot+1) = sqrt( gb_sigmas(ibot+1) ) / ( 1. + &
                                 gb_hleff(ibot)*gb_dqsldtl(ibot)/cp_air )

       if (column_match) then
         call get_date(Time, year, month, day, hour, minute, second)
         mon = month_name (month)
         write (dpu,'(a)')  ' '
         write (dpu,'(a)')  ' '
         write (dpu,'(a)')  ' '
         write (dpu,'(a)')  '===================================='//&
                            '=================='
         write (dpu,'(a)')  ' '
         write (dpu,'(a)')  '               ENTERING EDT    '
         write (dpu,'(a)')  ' '
         write (dpu,'(a, i6,a,i4,i4,i4,i4)')  ' time stamp:',   &
                                       year, trim(mon), day, &
                                       hour, minute, second
         write (dpu,'(a)')  '  DIAGNOSTIC POINT COORDINATES :'
         write (dpu,'(a)')  ' '
         write (dpu,'(a,f8.3,a,f8.3)') ' longitude = ', deglon1(nn),&
                                       ' latitude  = ', deglat1(nn)
         write (dpu,'(a,i6,a,i6)')     ' global i =', i_edtprt_gl(nn), &
                                       ' global j = ', j_edtprt_gl(nn)
         write (dpu,'(a,i6,a,i6)')     ' processor i =', i_edtprt(nn),     &
                                       ' processor j = ',j_edtprt(nn)
         write (dpu,'(a,i6,a,i6)')     ' window    i =', ipt,          &
                                       ' window    j = ',jpt
         write (dpu,'(a)')  ' '
         write (dpu,'(a)')  ' sigmas at the surface .... '
         write (dpu,'(a)')  ' ' 
         write (dpu,'(a,f14.7,a)')  ' sigmas = ',1000.*             &
                                     gb_sigmas(ibot+1), ' g/kg'
         write (dpu,'(a,f14.7)  ')  ' acoef = ', 1./( 1.+           &
                                     gb_hleff(ibot)* gb_dqsldtl(ibot)/cp_air )            
         write (dpu,'(a,f14.7,a)')  ' sigmas/a = ', 1000.*          &
                                     gb_sigmas(ibot+1)*( 1. + gb_hleff(ibot)* &
                                     gb_dqsldtl(ibot)/cp_air ), ' g/kg'
         write (dpu,'(a,f14.7)'  )  ' mesovar = ', mesovar
         write (dpu,'(a,f14.7,a)')  ' mesovar*qsl = ',mesovar*      &
                                    gb_qsl(ibot)*1000.,' g/kg'
         write (dpu,'(a,f14.7,a)')  ' turb.fluct = ',1000.*         &
              (q_star(i,j)-gb_dqsldtl(ibot)*b_star(i,j)*gb_t(ibot)/ &
               grav),' g/kg'
         write (dpu,'(a)')  ' '
         write (dpu,'(a)')  ' '
         write (dpu,'(a)')  ' k      T         u         v       '//&
                            '  qv        qt ' 
         write (dpu,'(a)')  '       (K)      (m/s)     (m/s)     '//&
                            '(g/kg)    (g/kg)'
         write (dpu,'(a)')  '------------------------------------'//&
                            '-----------------'
         write (dpu,'(a)')  ' '
         do kk = nlev-n_print_levels,nlev
           write(dpu,18) kk,gb_t(kk),gb_u(kk),gb_v(kk),1000.*    &
                         gb_qv(kk), 1000.*gb_qt(kk)
         end do
18       format(1X,i2,1X,5(f9.4,1X))
         write (dpu,'(a)')  ' '
         write (dpu,'(a)')  ' k      qa        qc      sli/cp_air    '//&
                            'sliv/cp_air    tdtlw'
         write (dpu,'(a)')  '                (g/kg)     (K)      '//&
                            ' (K)      (K/day)'
         write (dpu,'(a)')  '------------------------------------'//&
                            '-----------------'
         write (dpu,'(a)')  ' '
         do kk = nlev-n_print_levels,nlev
           write(dpu,19) kk,qa(i,j,kk),1000.*gb_qc(kk),          &
                         gb_sli(kk)/cp_air,gb_sliv(kk)/cp_air,gb_tdtlw(kk)*86400.
         enddo    
19       format(1X,i2,1X,5(f9.4,1X))
         write (dpu,'(a)')  ' '
         write (dpu,'(a)')  ' k   z_full    z_half    p_full    p'//&
                            '_half    sigmas'
         write (dpu,'(a)')  '      (m)      (m)        (mb)      '//&
                            '(mb)     (g/kg)'
         write (dpu,'(a)')  '------------------------------------'//&
                            '-----------------'
         write (dpu,'(a)')  ' '
         do kk = nlev-n_print_levels,nlev
           write(dpu,19) kk,gb_z_full(kk),gb_z_half(kk+1),       &
                         gb_p_full(kk)/100.,gb_p_half(kk+1)/100.,1000.*   &
                         gb_sigmas(kk+1)
         enddo
         write (dpu,'(a)')  ' '
         write (dpu,'(a)')  ' '
         write (dpu,'(a)')  ' k     esl       qsl      dqsldtl   '//&
                            ' hleff '
         write (dpu,'(a)')  '       (mb)    (g/kg)     (g/kg/K)  '//&
                            '(MJ/kg)' 
         write (dpu,'(a)')  '------------------------------------'//&
                            '-------'
         write (dpu,'(a)')  ' '
         do kk = nlev-n_print_levels,nlev
           write(dpu,19) kk, gb_esl(kk)/100.,gb_qsl(kk)*1000.,   &
                         gb_dqsldtl(kk)*1000.,gb_hleff(kk)/1.0e+06
         enddo
         write (dpu,'(a)')  ' '
       end if
       
       ! call the initialization routine for variables needed 
       ! by caleddy
         
       call trbintd(gb_t,       gb_qv,     gb_qt,     gb_qc,      &
                    gb_sli,     gb_sliv,   gb_u,      gb_v,       &
                    gb_z_full,  gb_z_half, gb_p_full, gb_p_half,  &
                    gb_sigmas,  gb_qsl,    gb_esl,    gb_hleff,   &
                    gb_dqsldtl, gb_slisl,  gb_qtsl,   gb_qxtop,   &
                    gb_qxbot,   gb_qltop,  gb_sfuh,   gb_sflh,    &
                    gb_qc_new,  gb_qa_new, gb_chu,    gb_chs,     &
                    gb_cmu,     gb_cms,    gb_n2,     gb_s2,      &
                    gb_ri    )
            
       !-----------------------------------------------------------
       !
       ! call caleddy
       !

            
       call caleddy(gb_u_star, kqfs,      khfs,      gb_sli,      &
                    gb_qt,     gb_qc_new, gb_qa_new, gb_sliv,     &
                    gb_u,      gb_v,      gb_p_full, gb_z_full,   &
                    gb_sfuh,   gb_sflh,   gb_slisl,  gb_qtsl,     &
                    gb_tdtlw,  gb_hleff,  gb_density,gb_qsl,      &
                    gb_dqsldtl,gb_qltop,  gb_p_half, gb_z_half,   &
                    gb_chu,    gb_chs,    gb_cmu,    gb_cms,      &
                    gb_n2,     gb_s2,     gb_ri,     gb_pblh,     &
                    gb_turbtype,gb_k_t,   gb_k_m,    gb_tke,      &
                    gb_leng,   gb_bprod,  gb_sprod,  gb_trans,    &
                    gb_diss,   gb_isturb, gb_tauinv, gb_sigmas,   &
                    gb_radf,   gb_sh,     gb_sm,     gb_gh,       &
                    gb_evhc)
 
       !-----------------------------------------------------------
       !
       ! paste back outputs
       !

       pblh(i,j)              = gb_pblh
       k_t(i,j,1:ibot)        = gb_k_t(1:ibot)
       k_m(i,j,1:ibot)        = gb_k_m(1:ibot)
       tke(i,j,1:ibot+1)      = gb_tke(1:ibot+1)
    
       turbtype(:,i,j,1:ibot+1) = gb_turbtype(:,1:ibot+1)
       isturb(i,j,1:ibot)       = gb_isturb(1:ibot)
       n2(i,j,1:ibot+1)         = gb_n2(1:ibot+1)
       s2(i,j,1:ibot+1)         = gb_s2(1:ibot+1)
       ri(i,j,1:ibot+1)         = gb_ri(1:ibot+1)    
       tauinv(i,j,1:ibot+1)     = gb_tauinv(1:ibot+1)
       leng(i,j,1:ibot+1)       = gb_leng(1:ibot+1)
       bprod(i,j,1:ibot+1)      = gb_bprod(1:ibot+1)
       sprod(i,j,1:ibot+1)      = gb_sprod(1:ibot+1)
       trans(i,j,1:ibot+1)      = gb_trans(1:ibot+1)
       diss(i,j,1:ibot+1)       = gb_diss(1:ibot+1)
       radf(i,j,1:ibot+1)       = gb_radf(1:ibot+1)
       sh(i,j,1:ibot+1)         = gb_sh(1:ibot+1)
       sm(i,j,1:ibot+1)         = gb_sm(1:ibot+1)
       gh(i,j,1:ibot+1)         = gb_gh(1:ibot+1)
       evhc(i,j,1:ibot+1)       = gb_evhc(1:ibot+1)
                                                    
       slislope(i,j,1:ibot  )   = gb_slisl(1:ibot  )
       qtslope (i,j,1:ibot  )   = gb_qtsl (1:ibot  )
       qxtop   (i,j,1:ibot  )   = gb_qxtop(1:ibot  )
       qxbot   (i,j,1:ibot  )   = gb_qxbot(1:ibot  )
       qc_new  (i,j,1:ibot  )   = gb_qc_new(1:ibot  )
       qa_new  (i,j,1:ibot  )   = gb_qa_new(1:ibot  )
    
       sigmas(is-1+i,js-1+j,1:ibot+1) = gb_sigmas (1:ibot+1) 
    
       !determine maximum altitude that the very stable pbl
       !is permitted to operate.  this is set to the half
       !level altitude just beneath the first turbulent
       !level
       stbltop(i,j) = 0.
       topfound = .false.
     
       kk = ibot + 1
       do while (.not.topfound.and.kk.gt.1)
         kk = kk - 1
         if (gb_isturb(kk).gt.0.5) topfound = .true.
       enddo 
       stbltop(i,j) = gb_z_half(kk+1)
       
       if (column_match) then
         write (dpu,'(a)') ' '
         write (dpu,'(a,f14.7,a)') ' stbltop = ',stbltop(i,j), ' meters'
         write (dpu,'(a)') ' '
       end if
    
     enddo
   enddo

!-----------------------------------------------------------------------
! 
!      diagnose cloud fraction and condensate tendencies
!
      
!----------------------------------------------------------------
! If the interface at the top or the bottom of the layer is part
! of a turbulent layer then set the eddytau to the minimum 
! timescale of the two.
!
       
   do k = 1, nlev
     tauinvtmp(:,:,k) = max(tauinv(:,:,k),tauinv(:,:,k+1))
   enddo
       
   where (tauinvtmp .gt. 1.e-10 .and. isturb .gt. 0.5)
     eddytau = max ( 1./tauinvtmp, mineddytau )
   elsewhere
     eddytau = missing_value
   endwhere
       
   qaturb(is:ie,js:je,:)   = qa_new
   qcturb(is:ie,js:je,:)   = qc_new
   tblyrtau(is:ie,js:je,:) = eddytau
             
!-----------------------------------------------------------------------
! 
!      blend in monin-obukhov similarity theory mixing coefficients at 
!      interface levels which are inside the surface layer
!

   sfclyr_h     = frac_sfclyr*pblh
   sfclyr_h_max = maxval(sfclyr_h)

   kk = nlev
   do k = 2, nlev
     if (minval(z_half_ag(:,:,k)) < sfclyr_h_max) then
       kk = k
       exit
     end if
   end do
   k_m_mo = 0.0
   k_t_mo = 0.0
   call mo_diff(z_half_ag(:,:,kk:nlev), u_star, b_star, &
                k_m_mo(:,:,kk:nlev), k_t_mo(:,:,kk:nlev))

   do k = kk, nlev
     where(z_half_ag(:,:,k) < sfclyr_h(:,:) .and. &
           z_half_ag(:,:,k) > 0.)
       k_t(:,:,k) = k_t_mo(:,:,k)
       k_m(:,:,k) = k_m_mo(:,:,k)
     endwhere
   enddo

!-----------------------------------------------------------------------
! 
!      Diagnostics
!

   if ( id_fq_cv_int > 0 .or. id_fq_cv_top > 0 .or. id_n2 > 0 .or. & 
        id_fq_turb   > 0 .or. id_diss      > 0 .or. id_s2 > 0 .or. &
        id_fq_cv_bot > 0 .or. id_fq_st     > 0 .or. id_ri > 0 .or. &
        id_eddytau   > 0 .or. id_tauinv    > 0 .or.                &
        id_leng      > 0 .or. id_qaedt     > 0 .or.                &
        id_bprod     > 0 .or. id_sprod     > 0 .or.                &
        id_trans     > 0 .or. id_qcedt     > 0 .or.                &
        id_sigmas    > 0 ) then  
      
     mask3(:,:,1:(nlev+1)) = 1.
     if (present(kbot)) then
       where (z_half_ag < 0.)
         mask3(:,:,:) = 0.
       end where
     endif
     
     if ( id_fq_cv_int > 0 ) then
       where (turbtype(2,:,:,:) .eq. 1) 
         tmpdat = 1.
       elsewhere
         tmpdat = 0.
       end where
       used = send_data (id_fq_cv_int,tmpdat,time, is, js, 1,&
                         rmask=mask3 )
     end if

     if ( id_fq_cv_top > 0 ) then
       where (turbtype(4,:,:,:) .eq. 1) 
         tmpdat = 1.
       elsewhere
         tmpdat = 0.
       end where
       used = send_data (id_fq_cv_top,tmpdat,time, is, js, 1,&
                         rmask=mask3 )
     end if
            
     if ( id_fq_cv_bot > 0 ) then
       where (turbtype(3,:,:,:) .eq. 1) 
         tmpdat = 1.
       elsewhere
         tmpdat = 0.
       end where
       used = send_data (id_fq_cv_bot,tmpdat,time, is, js, 1,&
                         rmask=mask3 )
     end if
         
     if ( id_fq_st > 0 ) then
       where (turbtype(1,:,:,:) .eq. 1) 
         tmpdat = 1.
       elsewhere
         tmpdat = 0.
       end where                 
       used = send_data ( id_fq_st, tmpdat, time, is, js, 1, &
                          rmask=mask3 )
     end if

     if ( id_fq_turb > 0 ) then
       used = send_data ( id_fq_turb, isturb, time, is, js,1,&
                          rmask=mask )
     end if
                     
     if ( id_n2 > 0 ) then
       used = send_data ( id_n2, n2, time, is, js, 1,        &
                          rmask=mask3 )
     end if
         
     if ( id_s2 > 0 ) then
       used = send_data ( id_s2, s2, time, is, js, 1,        &
                          rmask=mask3 )
     end if
         
     if ( id_ri > 0 ) then
       used = send_data ( id_ri, ri, time, is, js, 1,        &
                          rmask=mask3 )
     end if
         
     if ( id_leng > 0 ) then
       used = send_data ( id_leng, leng, time, is, js, 1,    &
                          rmask=mask3 )
     end if
            
     if ( id_bprod > 0 ) then
       used = send_data ( id_bprod, bprod, time, is, js, 1,  &
                          rmask=mask3 )
     end if
         
     if ( id_sprod > 0 ) then
       used = send_data ( id_sprod, sprod, time, is, js, 1,  &
                          rmask=mask3 )            
     end if
    
     if ( id_trans > 0 ) then
          used = send_data ( id_trans, trans, time, is, js, 1,  &
                             rmask=mask3 )            
     end if
    
     if ( id_diss > 0 ) then
          used = send_data ( id_diss, diss, time, is, js, 1,    &
                             rmask=mask3 )            
     end if
    
     if ( id_radf > 0 ) then
          used = send_data ( id_radf, radf, time, is, js, 1,    &
                             rmask=mask3 )            
     end if
    
     if ( id_sh > 0 ) then
          used = send_data ( id_sh, sh, time, is, js, 1,        &
                             rmask=mask3 )            
     end if
    
     if ( id_sm > 0 ) then
          used = send_data ( id_sm, sm, time, is, js, 1,        & 
                             rmask=mask3 )            
     end if
    
     if ( id_gh > 0 ) then
          used = send_data ( id_gh, gh, time, is, js, 1,        &
                             rmask=mask3 )            
     end if
    
     if ( id_evhc > 0 ) then
          used = send_data ( id_evhc, evhc, time, is, js, 1,    &
                             rmask=mask3 )            
     end if
    
     if ( id_tauinv > 0 ) then
          used = send_data ( id_tauinv, tauinv, time, is, js, 1,&
                             rmask=mask3 )
     end if
     
     if ( id_eddytau > 0 ) then
          used = send_data ( id_eddytau, eddytau, time, is, js, &
                             1, rmask=mask )
     end if
     
     if ( id_sigmas > 0 ) then
          used = send_data ( id_sigmas, sigmas(is:ie,js:je,:),  &
                             time, is, js, 1, rmask=mask3 )
     end if
            
     if (id_qaedt > 0) then
       tmpdat = 0.0
       do k = 1, nlev   
         tmpdat(:,:,k) = isturb(:,:,k)*qa_new(:,:,k)
       enddo
       used = send_data ( id_qaedt, tmpdat(:,:,1:nlev),      &
                          time, is, js, 1, rmask=mask )                 
     end if

     if (id_qcedt > 0) then
       tmpdat = 0.0
       do k = 1, nlev   
         tmpdat(:,:,k) = isturb(:,:,k)*qc_new(:,:,k)
       enddo
       used = send_data ( id_qcedt, tmpdat(:,:,1:nlev),      &
                          time, is, js, 1, rmask=mask )      
     end if
 
   end if  ! do diagnostics if


!-----------------------------------------------------------------------
! 
!      close edt output file if data was written for this window

!!RSH  if (ipt .gt. 0 .and. jpt .gt. 0) call Close_File (dpu)
       
!-----------------------------------------------------------------------
! 
!      subroutine end
!

end subroutine edt

!
!======================================================================= 





!======================================================================= 
!
!      subroutine edt_end
!        
!
!      this subroutine writes out the restart field
!        

subroutine edt_end()

!-----------------------------------------------------------------------
!
!      variables
!
!      --------
!      internal
!      --------
!
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!
!      write out restart file
!
       call save_restart(edt_restart)

!-----------------------------------------------------------------------
! 
!      close edt output file if data was written for this window

       if (do_print ) call Close_File (dpu)
       
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
! 
!      subroutine end
!
       module_is_initialized = .false.
end subroutine edt_end

!
!======================================================================= 




!======================================================================= 
!======================================================================= 
!
!
!      Grenier-Bretherton turbulence subroutines follow. These include:
!
!
!      sfdiag             diagnoses the fraction of each interval
!                         between layer midpoints which is saturated;
!                         this fraction is used to calculate the 
!                         proper buoyancy frequency, n2.
!
!      trbintd            calculates the subgrid vertical variability
!                         to sl, the liquid water static energy, and
!                         qt, the total water specific humidity.
!
!                         also calculates the richardson number ri 
!                         from n2:
!
!                         n2 = ch*dslidz +  cm*dqtdz
!
!                         where
!
!                         dslidz and dqtdz are the vertical slopes
!                         of sl and qt in the interior of the grid
!                         box and ch and cm are thermodynamic 
!                         coefficients which are solely functions of 
!                         temperature and pressure, but have very 
!                         different values in saturated and unsaturated 
!                         air.
!                          
!      caleddy            main subroutine which calculates diffusivity
!                         coefficients
!
!      exacol          determines whether the column has adjacent 
!                         regions where Ri < 0 (unstable layers or ULs) 
!                         and determine the indices kbase, ktop which 
!                         delimit these unstable layers : 
!
!                         ri(kbase) > 0 and ri(ktop) > 0, 
!                         but ri(k)     < 0 for ktop < k < kbase. 
!
!      zisocl             solves for mean tke <e>, W, Sh, and Sm for 
!                         each convective layer.  here,
!
!                         W = leng**2 * (-Sh*n2 + Sm*s2), where
!
!                         leng = mixing length,
!                         s2   = shear vector magnitude
!                         Sh   = Galperin stab. function for buoyancy
!                         Sm   = Galperin stab. function for momentum
!
!                         in addition, it merges adjacent convective 
!                         layers when the intervening stable layers 
!                         would not consume too much tke for the 
!                         combined convective layer
!
!
!======================================================================= 
!======================================================================= 




!======================================================================= 

subroutine sfdiag (qsl, esl, dqsldtl, hleff, qt, qtslope,sli, slislope,&
                   p_full, z_full, p_half, z_half, sdevs, qxtop, qxbot,&
                   qltop, sfuh, sflh, qc_new, qa_new, sfi)
   
!----------------------------------------------------------------------- 
! 
!      Purpose: 
!      Interface for computing cloud variables for use by turb. scheme
! 
!      Authors: B. Stevens and C. Bretherton (August 2000)
! 
!-----------------------------------------------------------------------
!
!      variables
!
!      -----
!      input
!      -----
!      field 1-d arrays on model full levels, reals dimensioned
!      (1:nlev), index running from top of atmosphere to bottom
!      
!      qsl         saturation spec. humidity at the liquid-ice
!                  water temperature (kg water/kg air)
!      esl         saturation vapor pressure at the liquid-ice 
!                  water temperature (Pa)
!      dqsldtl     temperature derivative of qsl (kg water/kg air/K)
!      hleff       effective latent heat of vaporization (J/kg)        
!      qt          total water specific humidity (kg water/kg air)
!      qtslope     qt slope wrt pressure in thermo layer (kg/kg/Pa)
!      sli         ice-liq water static energy (J/kg) 
!      slislope    sli slope wrt pressure in thermo layer (J/kg/Pa)
!      p_full      pressure (Pa)
!      z_full      height of full level above the surface (m)
!
!      the following fields are on the model half levels, 
!      dimension(1:nlev+1)
!
!      p_half      pressure at half levels (Pa)
!      z_half      height of half model levels above the surface (m)
!      sdevs       standard deviation of water perturbation
!                  (kg water/kg air)
!
!      ------
!      output
!      ------
!
!      qxtop       saturation excess at top of layer (kg wat/kg air)
!      qxbot       saturation excess at bottom of layer (kg wat/kg air)
!      qltop       cloud liquid at top of layer (kg wat/kg air)
!      sfuh        saturated fraction in upper half-layer
!      sflh        sflh saturated fraction in lower half-layer
!      qc_new      thermodynamically diagnosed condensate value
!      qa_new      thermodynamically diagnosed cloud fraction
!
!      the following fields are on the model half levels, 
!      dimension(1:nlev+1)
!
!      sfi         interfacial saturated fraction
!


real, intent(in) , dimension(:) :: qsl, esl, dqsldtl, hleff
real, intent(in) , dimension(:) :: qt, qtslope, sli, slislope
real, intent(in) , dimension(:) :: p_full, z_full
real, intent(in) , dimension(:) :: p_half, z_half, sdevs 
real, intent(out), dimension(:) :: qxtop, qxbot, qltop, sfuh, sflh
real, intent(out), dimension(:) :: qc_new, qa_new
real, intent(out), dimension(:) :: sfi

integer :: k                      ! vertical index
integer :: nlev                   ! number of vertical levels
real    :: slitop, slibot         ! sli at top/bot of layer
real    :: qttop , qtbot          ! qt  at top/bot of layer
real    :: qsltop, qslbot         ! qsl at top/bot of layer
real    :: tlitop, tlibot         ! liq wat temp at top/bot of layer          
real    :: qxm                    ! sat excess at midpoint
real    :: qlm, qlbot             ! liq wat at midpoint, and bottom
real    :: tlim                   ! tli at midpoint
real    :: dqsldp                 ! pressure derivative of qsl
real    :: sigmasf                ! sdevs on full model levels
real    :: acoef                  ! 1./(1+L*dqsldT/cp_air)

!----------------------------------------------------------------------- 
!
!      code
!

   nlev   = size(p_full,1)
   sfi    = 0.0
   sfuh   = 0.0
   sflh   = 0.0    
   qc_new = 0.0
   qa_new = 0.0
   qltop  = 0.0
   
   if (column_match) then
     write (dpu,'(a)')  '-----------------------------------------'//&
                        '-------------'
     write (dpu,'(a)')  '        ENTERING SFDIAG                     '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' k  tlim   dqsldp slitop tlitop  qttop  q'//&
                        'sltop  qxtop  qltop   qxm    qlm'
     write (dpu,'(a)')  '    (K)(g/kg/100mb)(K)    (K)    (g/kg) ('//&
                        'g/kg)  (g/kg) (g/kg) (g/kg) (g/kg)'
     write (dpu,'(a)')  '-----------------------------------------'//&
                        '----------------------------------'
     write (dpu,'(a)')  ' '       
21 format(1X,i2,1X,f6.2,1X,f7.2,1X,8(f6.2,1X))
   end if
         
   do k = 2,nlev

!-----------------------------------------------------------
! calculate midpoint liquid-ice water temperature
     tlim = (sli(k) - grav*z_full(k))/cp_air

!-----------------------------------------------------------
! calculate dqsl/dp
     dqsldp = -1.*qsl(k)*qsl(k)/d622/esl(k)
            
!-----------------------------------------------------------
! Compute saturation excess at top and bottom of layer k

!extrapolation to layer top
     slitop = sli(k) + slislope(k) * (p_half(k) - p_full(k))
     qttop  = qt (k) + qtslope (k) * (p_half(k) - p_full(k))
     slitop = min ( max ( 0.25*sli(k), slitop), 4.*sli(k))
     qttop  = min ( max ( 0.25* qt(k), qttop ), 4.* qt(k))
     tlitop = (slitop - grav*z_half(k))/cp_air   
     qsltop  = qsl(k) + dqsldp      * (p_half(k) - p_full(k)) + &
                        dqsldtl (k) * (tlitop    - tlim     )
     qsltop  = min ( max ( 0.25*qsl(k), qsltop ) , 4.*qsl(k) )
     qxtop(k) = qttop  - qsltop
     qltop(k)  = max( 0., qxtop(k)/( 1.+ hleff(k)*dqsldtl(k)/cp_air))

    !extrapolation to layer bottom
     slibot = sli(k) + slislope(k) * (p_half(k+1) - p_full(k))
     qtbot  = qt (k) + qtslope (k) * (p_half(k+1) - p_full(k))
     slibot = min ( max ( 0.25*sli(k), slibot), 4.*sli(k))
     qtbot  = min ( max ( 0.25* qt(k), qtbot ), 4.* qt(k))
     tlibot = (slibot - grav*z_half(k+1))/cp_air
     qslbot = qsl(k) + dqsldp      * (p_half(k+1) - p_full(k))+ &
                       dqsldtl (k) * (tlibot      - tlim     ) 
     qslbot  = min ( max ( 0.25*qsl(k), qslbot ) ,4.*qsl(k) )     
     qxbot(k) = qtbot  - qslbot
     qlbot  = max( 0., qxbot(k)/( 1.+hleff(k)*dqsldtl(k)/cp_air ) )

!-----------------------------------------------------------
! Compute saturation excess at midpoint of layer k           
     qxm    = qxtop(k) + (qxbot(k)-qxtop(k))*                   &
              (p_full(k)-p_half(k))/(p_half(k+1) - p_half(k))
     qlm  = max( 0., qxm / ( 1. +  hleff(k)*dqsldtl(k)/cp_air ) )

     if (column_match) then
       write(dpu,21) k,tlim,1000.*dqsldp*100.*100.,slitop/cp_air,    &
                     tlitop,1000.*qttop,1000.*qsltop,1000.*qxtop(k), &
                     1000.*qltop(k),1000.*qxm,   1000.*qlm
       write(dpu,21) k,tlim,1000.*dqsldp*100.*100.,slibot/cp_air,    &
                     tlibot,1000.*qtbot,1000.*qslbot,1000.*qxbot(k), &
                     1000.*qlbot,1000.*qxm,   1000.*qlm
       write (dpu,'(a)')  ' '
     end if

!-----------------------------------------------------------
!
! TWO WAYS OF CALCULATING SATURATION FRACTION AND QA AND QC
!
!
!          FIRST WAY:  USE GAUSSIAN CLOUD MODEL
!
!

     if (do_gaussian_cloud) then
   
!calculate sigmas on model full levels
       sigmasf = 0.5 * (sdevs(k) + sdevs(k+1))
       acoef = 1. / ( 1. + hleff(k)*dqsldtl(k)/cp_air )
!sigmasf = max ( sigmasf, acoef*mesovar*qsl(k) )
       sigmasf = acoef*mesovar*qsl(k)
       call gaussian_cloud(qxtop(k), qxm,      qxbot(k),     &
                           acoef,    sigmasf,  qa_new(k),    &
                           qc_new(k),sfuh(k),  sflh(k))

!------------------------------------------------------
! Combine with sflh (still for layer k-1) to get 
! interface layer saturation fraction
!
! N.B.:
!
! if sfuh(k)>sflh(k-1),sfi(k) = sflh(k-1)
! if sfuh(k)<sflh(k-1),sfi(k) = mean(sfuh(k),sflh(k-1))
!
       sfi(k) =  0.5 * ( sflh(k-1) + min(sflh(k-1),sfuh(k)) )
 
     else
    
!
!
!          SECOND WAY:  ORIGINAL BRETHERTON-GRENIER WAY
!
!

!------------------------------------------------------
! Compute saturation fraction sfuh(k) of the upper half 
! of layer k.

       if      ( (qxtop(k).lt.0.) .and. (qxm.lt.0.) ) then
         sfuh(k) = 0.  ! Upper half-layer unsaturated
       else if ( (qxtop(k).gt.0.) .and. (qxm.gt.0.) ) then
         sfuh(k) = 1.  ! Upper half-layer fully saturated
       else               ! Either qxm < 0 and qxtop > 0 
                          ! or vice versa
         sfuh(k) = max(qxtop(k),qxm) / abs(qxtop(k) - qxm)
       end if

!------------------------------------------------------
! Combine with sflh (still for layer k-1) to get      
! interfac layer sat frac
!
! N.B.:
!
! if sfuh(k)>sflh(k-1),sfi(k) = sflh(k-1)
! if sfuh(k)<sflh(k-1),sfi(k) = mean(sfuh(k),sflh(k-1))
!
       sfi(k) =  0.5 * ( sflh(k-1) + min( sflh(k-1), sfuh(k)))

!------------------------------------------------------
! Update sflh to be for the lower half of layer k.             

       if      ( (qxbot(k).lt.0.) .and. (qxm.lt.0.) ) then
         sflh(k) = 0.  ! Upper half-layer unsaturated
       else if ( (qxbot(k).gt.0.) .and. (qxm.gt.0.) ) then
         sflh(k) = 1.  ! Upper half-layer fully saturated
       else            ! Either qxm < 0 and qxbot > 0 or vice versa
         sflh(k) = max(qxbot(k),qxm) / abs(qxbot(k) - qxm)
       end if
         
         !------------------------------------------------------
           !Compute grid volume mean condensate and cloud fraction
       qc_new(k) = 0.5 * ( sfuh(k) * 0.5 * (qltop(k) + qlm) )&
                 + 0.5 * ( sflh(k) * 0.5 * (qlbot    + qlm) )
       qa_new(k) = 0.5 * ( sfuh(k) + sflh(k) )
   
     end if
    
   end do

       
       !set surface saturated fraction equal to sflh(nlev)
       sfi(nlev+1)  = sflh(nlev)! Sat frac in lowest half-layer. 

   if (column_match) then
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' k     sfuh       sflh      sfi      qc_n'//&
                        'ew    qa_new'
     write (dpu,'(a)')  '                                     (g/kg)'
     write (dpu,'(a)')  '-----------------------------------------'//&
                        '------------'
     write (dpu,'(a)')  ' '
     do k = nlev-n_print_levels,nlev
       write(dpu,22) k,sfuh(k),sflh(k),sfi(k),1000.*qc_new(k),    &
                     qa_new(k)
     enddo    
22   format(1X,i2,1X,5(f9.4,1X))
     write (dpu,'(a)')  ' '
   end if
     
!-----------------------------------------------------------------------
! 
!      subroutine end
!

end subroutine sfdiag

!
!======================================================================= 




!======================================================================= 
!
!      subroutine trbintd
!

 subroutine trbintd (t, qv, qt, qc, sli, sliv, u, v, z_full, z_half,   &
                     p_full, p_half, sdevs, qsl, esl, hleff, dqsldtl,  &
                     slislope, qtslope, qxtop, qxbot, qltop, sfuh,sflh,&
                     qc_new, qa_new, chu, chs, cmu, cms, n2, s2, ri)

!----------------------------------------------------------------------- 
! 
! Purpose: 
!  time dependent initialization
! 
! Method: 
!  Diagnosis of variables that do not depend on mixing assumptions or
!  PBL depth.
!
! Authors: B. Stevens (extracted from pbldiff, August, 2000)
!          C. Bretherton (Dec. 2000)
! 
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!
!       variables
!
!       -----
!       input
!       -----
!       field 1-d arrays on model full levels, reals dimensioned
!       (1:nlev), index running from top of atmosphere to 
!       bottom
!           
!       t           temperature (K)
!       qv          water vapor spec. humidity (kg vapor/kg air)
!       qt          total water specific humidity (kg water/kg air)
!       qc          condensed water spec. humidity (kg cond/kg air)
!       sli         ice-liq water static energy (J/kg) 
!       sliv        ice-liq water virtual static energy (J/kg) 
!       u           zonal wind (m/s)
!       v           meridional wind (m/s) 
!       z_full      height of full level above the surface (m)
!       p_full      pressure (Pa)
!       sdevs       standard deviation of water perturbation s
!                   (kg water/kg air)
!       qsl         saturation spec. humidity at the liquid-ice
!                   water temperature (kg water/kg air)
!       esl         saturation vapor pressure at the liquid-ice 
!                   water temperature (Pa)
!       hleff       effective latent heat (J/kg condensate)
!       dqsldtl     temperature derivative of qsl (kg water/kg air/K)
!
!       the following fields are on the model half levels, 
!       dimension(1:nlev+1)
!       p_half      pressure at half levels (Pa)
!       z_half      height of half model levels above the surface (m)
!
!       ------
!       output
!       ------
!
!       slislope    sli slope wrt pressure in thermo layer (J/kg/Pa)
!       qtslope     qt slope wrt pressure in thermo layer (kg/kg/Pa)
!       qxtop       saturation excess at the top of the layer 
!                   (kg wat/kg air)
!       qxbot       saturation excess at the bottom of the layer 
!                   (kg wat/kg air)
!       qltop       liquid water at top of thermo layer (kg condensate/
!                   kg air)
!       sfuh        saturated fraction in upper half-layer
!       sflh        sflh saturated fraction in lower half-layer
!       qc_new      thermodynamically defined cloud condensate (kg/kg)
!       qa_new      thermodynamically defined cloud fraction 
!
!       the following fields are defined on model half levels,
!       dimension(1:nlev+1)
!
!       chu         heat var. coef for dry states (1/m)
!       chs         heat var. coef for sat states (1/m)
!       cmu         moisture var. coef for dry states (kg/kg)*(m/s*s)
!       cms         moisture var. coef for sat states (kg/kg)*(m/s*s)
!       n2          moist squared buoyancy freq (1/s*s)
!       s2          squared deformation, or shear vector mag. (1/s*s)
!       ri          gradient Richardson number
!
!

real, intent(in),    dimension (:) :: t, qv, qt, qc, sli, sliv, u, v,  &
                                      z_full, p_full, qsl, esl, hleff, &
                                      dqsldtl, sdevs, z_half, p_half
real, intent(out),   dimension (:) :: slislope, qtslope, qxtop, qxbot,   &
                                      sfuh, sflh, qc_new, qa_new, qltop, &
                                      chu, chs, cmu, cms, n2, s2, ri
  
! internal variables

integer            :: kdim        ! # of levels in the vertical
integer            :: k, km1, kp  ! level indexes
real               :: rdz         ! 1 / (delta z) between midpoints
real               :: dslidz      ! delta sli / delta z at interface
real               :: dqtdz       ! delta qt  / delta z at interface
real               :: ch          ! sfi weighted ch at the interface
real               :: cm          ! sfi weighted cm at the interface
real               :: product     ! temporary variable
real               :: dslidp_a    ! sli slope across interface above
real               :: dqtdp_a     ! qt  slope across interface above
real               :: dslidp_b    ! sli slope across interface below
real               :: dqtdp_b     ! qt  slope across interface below
real, dimension(size(t,1)) :: bfact ! buoyancy factor in n2 calculation
real, dimension(size(t,1)+1) :: sfi ! saturated fraction at interfaces

!----------------------------------------------------------------------- 
!
!  code
!

   kdim = size(t,1)

!-----------------------------------------------------------------------
! 
!  Thermodynamic coefficients for buoyancy flux - these
!  are calculated at midpoints; they will be averaged to interfaces,
!  where they will ultimately be used. At the surface, the coeff-
!  icients are taken from the lowest midpoint.
!
!  These formulas come from the following expression
!
!  grav* tv' / tv = ch * sli'   + cm * qt'
!
!  chu and cmu are the values for unsaturated air, whereas
!  chs and cms are the values for   saturated air.

   bfact       = grav/(t*(1.+zvir*qv - qc))
   chu(1:kdim) = (1. + zvir*qt)*bfact/cp_air
   chs(1:kdim) = ( (1. + (1. + zvir)*dqsldtl*t) / &
                   (1. + (hleff*dqsldtl/cp_air)   ) ) * bfact/cp_air
   cmu(1:kdim) = zvir  * bfact * t
   cms(1:kdim) = hleff * chs(1:kdim)  -  bfact * t

   chu(kdim+1) = chu(kdim)
   chs(kdim+1) = chs(kdim)
   cmu(kdim+1) = cmu(kdim)
   cms(kdim+1) = cms(kdim)
   
   if (column_match) then
     write (dpu,'(a)')  '--------------------------------------------'
     write (dpu,'(a)')  '        ENTERING TRBINTD                    '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' k     Tv       bfact '
     write (dpu,'(a)')  '       (K)    (m/K/s**2)' 
     write (dpu,'(a)')  '------------------------'
     write (dpu,'(a)')  ' '
     do k = kdim-n_print_levels,kdim
       write(dpu,17) k,t(k)*(1.+zvir*qv(k) - qc(k)),bfact(k)
     end do
17   format(1X,i2,1X,2(f9.4,1X))
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' k     cp_air*chu    cp_air*chs      cmu      cms'
     write (dpu,'(a)')  '     (m/K/s**2)(m/K/s**2) (m/s**2) (m/s**2)'
     write (dpu,'(a)')  '-------------------------------------------'
     write (dpu,'(a)')  ' '
     do k = kdim+1-n_print_levels,kdim+1
       write(dpu,20) k,cp_air*chu(k),cp_air*chs(k),cmu(k),cms(k)
     enddo    
20   format(1X,i2,1X,4(f9.4,1X))
     write (dpu,'(a)')  ' '
   end if
       
!-----------------------------------------------------------------------
!     
!  Compute slopes in conserved variab. sl, qt within thermo layer k. 
!  a indicates the 'above' gradient from layer k-1 to layer k and 
!  b indicates the 'below' gradient from layer k   to layer k+1.
!  We take the smaller (in absolute value) of these gradients
!  as the slope within layer k. If they have opposite sign, gradient
!  in layer k is taken to be zero.
!
!  Slopes at endpoints determined by extrapolation

   slislope(kdim) = (sli   (kdim) - sli   (kdim-1))/ &
                    (p_full(kdim) - p_full(kdim-1))
   qtslope (kdim) = (qt    (kdim) - qt    (kdim-1))/ &
                    (p_full(kdim) - p_full(kdim-1))
   slislope(1)    = (sli   (2)    - sli   (2)     )/ &
                    (p_full(2)    - p_full(1)     )     
   qtslope (1)    = (qt    (2)    - qt    (2)     )/ &
                    (p_full(2)    - p_full(1)     ) 
   dslidp_b        = slislope(1)
   dqtdp_b         = qtslope (1)
    
   do k = 2, kdim-1
   
     kp = k + 1
     dslidp_a  = dslidp_b
     dqtdp_a   = dqtdp_b
     dslidp_b  = (sli(kp)-sli(k))/(p_full(kp)-p_full(k))
     dqtdp_b   = (qt (kp)-qt (k))/(p_full(kp)-p_full(k))
     product   = dslidp_a*dslidp_b
     if (product .le. 0.) then 
       slislope(k) = 0.
     else if (product.gt.0. .and. dslidp_a.lt.0.) then 
       slislope(k) = max(dslidp_a,dslidp_b)
     else if (product.gt.0. .and. dslidp_a.gt.0.) then 
       slislope(k) = min(dslidp_a,dslidp_b)
     end if
 
     product   = dqtdp_a*dqtdp_b
     if (product .le. 0.) then 
       qtslope (k) = 0.
     else if (product.gt.0. .and. dqtdp_a.lt.0.) then 
       qtslope (k) = max(dqtdp_a,dqtdp_b)
     else if (product.gt.0. .and. dqtdp_a.gt.0.) then 
       qtslope (k) = min(dqtdp_a,dqtdp_b)
     end if
   
   end do ! loop over k


   if (column_match) then
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' k   slislope   qtslope  '
     write (dpu,'(a)')  '    (K/100mb)(g/kg/100mb)'
     write (dpu,'(a)')  '-------------------------'
     write (dpu,'(a)')  ' '
     do k = kdim-n_print_levels,kdim
       write(dpu,17) k,slislope(k)*100.*100./cp_air,                  &
                     1000.*qtslope(k)*100.*100.
     enddo
     write (dpu,'(a)')  ' '
   end if

!-----------------------------------------------------------------------
!     
!      Compute saturation fraction in the interfacial layers for use in
!      buoyancy flux computation.

   call sfdiag(qsl, esl, dqsldtl, hleff, qt, qtslope,sli, slislope,&
               p_full, z_full, p_half, z_half, sdevs, qxtop, qxbot,&
               qltop, sfuh, sflh, qc_new, qa_new, sfi)

!-----------------------------------------------------------------------
!     
!  Compute shear squared (s2), squared buoyancy frequency (n2) and 
!  Ri.  For the n2 calculation use gradients of sl and qt, weighted 
!  according to sfi, the fraction of the interfacial layer that is 
!  saturated.
!
!  This loop has to be done in increasing levels to avoid over-
!  writing chu, etc. arrays to interface values before we are done 
!  with their midpoint values.
!
!  Note that n2,s2,ri are set to zero at interfaces k = 1 and
!  k = kdim + 1, where they are not used.

   n2(kdim+1) = 0.
   s2(kdim+1) = 0.
   ri(kdim+1) = 0.

   if (column_match) then
     write (dpu,'(a)')  '---------------------------------------------'
     write (dpu,'(a)')  '                 IN TRBINTD'
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' k    rdz   dslidz   dqtdz    chu     chs'//&
                        '     ch       cmu    cms      cm'
     write (dpu,'(a)')  '     (1/km) (K/km) (g/kg/km)       (m/K/s'//&
                        '**2)              (m/s**2)'
     write (dpu,'(a)')  '-----------------------------------------'//&
                        '----------------------------------'
     write (dpu,'(a)')  ' '       
22   format(1X,i2,1X,9(f7.3,1X))
   end if
      
   do k = kdim, 2, -1
     km1     = k - 1
     rdz     = 1. / (z_full(km1) - z_full(k))
     dslidz  = (sli(km1) - sli(k)) * rdz
     dqtdz   = (qt (km1) - qt (k)) * rdz 
     chu(k)  = (chu(km1) + chu(k))*0.5
     chs(k)  = (chs(km1) + chs(k))*0.5
     cmu(k)  = (cmu(km1) + cmu(k))*0.5
     cms(k)  = (cms(km1) + cms(k))*0.5
     ch      = chu(k)*(1.-sfi(k)) + chs(k)*sfi(k)
     cm      = cmu(k)*(1.-sfi(k)) + cms(k)*sfi(k)
     n2(k)   = ch*dslidz +  cm*dqtdz
     s2(k)   = ((u(km1)-u(k))**2 + (v(km1)-v(k))**2)*(rdz**2)
     s2(k)   = max(ntzero,s2(k))
     ri(k)   = n2(k) / s2(k)
    
     if (column_match) then
       write(dpu,22) k,1000.*rdz,1000.*dslidz/cp_air,            &
                     1000.*1000.*dqtdz,cp_air*chu(k),cp_air*chs(k),cp_air*ch, &
                     cmu(k),cms(k),cm
     end if
    
   end do
   n2(1) = 0.
   s2(1) = 0.
   ri(1) = 0.
      
   if (column_match) then
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' k    sqrt(n2)  sqrt(s2)    ri'
     write (dpu,'(a)')  '      (1/hr)    (1/hr) '
     write (dpu,'(a)')  '---------------------------------'
     write (dpu,'(a)')  ' '
     do k = kdim-n_print_levels,kdim
       write(dpu,23) k,n2(k)*sqrt(abs(n2(k)))*3600./max(small,    &
                     abs(n2(k))),sqrt(s2(k))*3600.,ri(k)
     enddo
23   format(1X,i2,1X,3(f9.3,1X))
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  '--------------------------------------------'
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
   end if

!-----------------------------------------------------------------------
! 
!      subroutine end
!

end subroutine trbintd

!
!======================================================================= 




!======================================================================= 
!
!      subroutine exacol
!        
     
subroutine exacol(ri, bflxs, ktop, kbase, ncvfin) 

!----------------------------------------------------------------------- 
!
! object : determine whether the column has adjacent regions where 
!          Ri < 0 (unstable layers or ULs) and determine the indices 
!          kbase, ktop which delimit these unstable layers : 
!          ri(kbase) > 0 and ri(ktop) > 0, but 
!          ri(k) < 0 for ktop < k < kbase. 
!
! author : H. Grenier    05/2000, 
!          C. Bretherton 08/2000
!
!----------------------------------------------------------------------- 
!----------------------------------------------------------------------- 
!
!

real,    intent(in),  dimension(:) :: ri     ! Moist gradient Ri. #
real,    intent(in)                :: bflxs  ! Surface buoyancy flux 
                                             ! (m*m)/(s*s*s)
integer, intent(out), dimension(:) :: kbase  ! vertical index of UL base
integer, intent(out), dimension(:) :: ktop   ! vertical index of UL top
integer, intent(out)               :: ncvfin ! number of ULs

!
! internal variables
!
      
integer :: k, kdim, ncv         
real    :: riex(size(ri,1)) ! Column Ri profile extended to surface
                            ! by taking riex > rimaxentr for bflxs < 0
    !           riex < rimaxentr for bflxs > 0.


!-----------------------------------------------------------------------
!
!  Initialize variables

   ncvfin    = 0
   kdim      = size(ri,1) - 1
   ktop(:)   = 0
   kbase(:)  = 0
   
   riex(1:kdim) = ri(1:kdim)
   riex(kdim+1) = rimaxentr-bflxs ! Allows consistent treatment
                                  ! of surface with other intrfcs.
   ncv = 0

!-----------------------------------------------------------------------
!
!  Work upward from surf interface

   k = kdim+1
                   
   do while ( k.gt.2 )
   
     if (riex(k) .lt. rimaxentr) then 
             
 !------------------------------------------------------
 !
 ! A new convective layer has been found.
 ! Define kbase as interface below first unstable one
 ! then decrement k until top unstable level is found.
 ! Set ktop to the first interface above unstable layer. 
 
       ncv = ncv + 1
       kbase(ncv) = min(k+1,kdim+1)
       do while (riex(k) .lt. rimaxentr .and. k.gt.2)
         k = k-1
       end do  
       ktop(ncv) = k
     else
                 
!------------------------------------------------------
!
! Keep on looking for a CL.
              
       k = k-1
       
     end if
       
   end do
       
!--------------------------
!
! Set total number of CLs

   ncvfin = ncv   

   if (column_match) then
     write (dpu,'(a)')  '--------------------------------------------'
     write (dpu,'(a)')  '                 IN EXACOL'
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  '  k     riex'
     write (dpu,'(a)')  '-------------'
     write (dpu,'(a)')  ' '
     do k = kdim+1-n_print_levels,kdim+1
       write(dpu,28) k,riex(k)
     enddo
28 format(1X,i2,1X,f9.3)
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
     write (dpu,'(a,i3)')  ' ncvfin = ',ncvfin
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  'ncv  ktop  kbase'
     write (dpu,'(a)')  '--------------------'
     write (dpu,'(a)')  ' '
     do ncv = 1, ncvfin
       write(dpu,29) ncv, ktop(ncv), kbase(ncv)
     enddo
29 format(1X,i2,3X,i2,5X,i2)
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
   end if

!-----------------------------------------------------------------------
! 
!      subroutine end
!

end subroutine exacol

!
!======================================================================= 
       

!=======================================================================
!
!      subroutine zisocl
!        
     
subroutine zisocl(u_star, bflxs, tkes, zm, ql, zi, n2, s2, ri, ncvfin, &
                  kbase, ktop, belongcv, ebrk, wbrk, ghcl, shcl, smcl, &
  lbrk)

!-----------------------------------------------------------------------
!
! object : find <e>, <W>, <Sh>, <Sm>, ktop(ncv), accounting for the 
!          presence of stably stratified layers inside the convective 
!          layer(CL, to be defined) but with r2 > ratinv.
!
!          Re-arrange the indexing of arrays kbase/ktop if some CLs are 
!          found to be coupled such that ncv defines the index of each 
!          CL increasing with height.
!
! author : H. Grenier 05/08/2000
!
!----------------------------------------------------------------------- 
!----------------------------------------------------------------------- 
!
!
   
real, intent(in)               :: u_star ! friction velocity (m/s)   
real, intent(in)               :: bflxs  ! Surface buoyancy flux 
                                         ! (m*m*m)/(s*s)
real, intent(in)               :: tkes   ! TKE at the surface (m2/s2)
real, intent(in), dimension(:) :: zm ! Layer midpoint height (m)
real, intent(in), dimension(:) :: ql ! condensate spec. hum. (kg/kg)
real, intent(in), dimension(:) :: zi ! Interface height (m)
real, intent(in), dimension(:) :: n2 ! Moist squared buoy freq (s-2)
real, intent(in), dimension(:) :: s2 ! Shear deformation (s-2)
real, intent(in), dimension(:) :: ri ! Gradient Richardson number
    
integer, intent(inout)               :: ncvfin ! Total number of CLs
integer, intent(inout), dimension(:) :: kbase  ! Vert index of CL base
integer, intent(inout), dimension(:) :: ktop   ! Vert index of CL top

logical, intent(out), dimension(:) :: belongcv ! = T if flux level in CL
real,    intent(out), dimension(:) :: ebrk  ! vert ave. of TKE  in CL
real,    intent(out), dimension(:) :: wbrk  !   "       of W^2  "
real,    intent(out), dimension(:) :: ghcl  !   "       of Gh   "
real,    intent(out), dimension(:) :: shcl  !   "       of Sh   "
real,    intent(out), dimension(:) :: smcl  !   "       of Sm   "
real,    intent(out), dimension(:) :: lbrk  ! CL depth not within entr
                                            ! layers
  
! internal variables

logical :: extend       ! True if CL is extended in zisocl
logical :: bottom       ! True if CL base at surface(kb = kdim+1)
integer :: ncv          ! Index enumerating convective layers in col
integer :: incv
integer :: k
integer :: kdim         ! number of full vertical levels
integer :: kb           ! Local index for kbase
integer :: kt           ! Local index for ktop
integer :: ncvinit      ! Value of ncv at routine entrance 
integer :: cntu         ! counts upward no. of merged CLs
integer :: cntd         ! counts downward  "          "
integer :: kbinc        ! Index for incorporating underlying CL
integer :: ktinc        ! Index for incorporating  overlying CL
real    :: ebar
real    :: wint
real    :: dwinc
real    :: dzinc
real    :: dwsurf
real    :: gh
real    :: sh
real    :: sm
real    :: l2n2         ! Vert. integral of l^2N^2 over CL
real    :: l2s2         ! Vert. integral of l^2S^2 over CL
real    :: dl2n2        ! Vert. int. of l^2N^2 over incorp. layer
real    :: dl2s2        ! Vert. int. of l^2S^2 over incorp. layer
real    :: lint         ! CL depth excluding entrainment layers
real    :: lbulk        ! Depth of the convective layer
real    :: lz           ! Turbulent length scale
real    :: ricl         ! Ri Number for the whole convective layer
real    :: zbot         ! Height of CL base
real    :: l2rat        ! Square of ratio of actual to initial CL depth
real    :: tmpr

!-----------------------------------------------------------------------
!
!  Initialize variables

   kdim = size(ql,1)
   ncv = 1 

   if (column_match) then
     write (dpu,'(a)')  '-------------------------------------------'
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  '        ENTERING ZISOCL               '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  '  k    lint      lz      l2n2         l2s'//&
                        '2' 
     write (dpu,'(a)')  '       (m)       (m)    (m3/s2)      (m3/'//&
                        's2)'
     write (dpu,'(a)')  '-----------------------------------------'//&
                        '------'
   end if       
      
!-----------------------------------------------------------------------
!
!      Loop over convective layers to see if they need to be extended

   do while ( ncv .le. ncvfin )
       
     ncvinit = ncv
     cntu    = 0
     cntd    = 0
     kb      = kbase(ncv) 
     kt      = ktop(ncv)
     lbulk   = zi(kt)-zi(kb)
            
     if (column_match) then
       write (dpu,'(a)')  ' '
       write (dpu,'(a,i3)')  ' ncv    = ', ncv
       write (dpu,'(a,i3)')  ' kb     = ', kb
       write (dpu,'(a,i3)')  ' kt     = ', kt
       write (dpu,'(a,f14.7,a)')  ' zi(kt) = ', zi(kt), ' meters'
       write (dpu,'(a,f14.7,a)')  ' zi(kb) = ', zi(kb), ' meters'
       write (dpu,'(a,f14.7,a)')  ' lbulk  = ', lbulk, ' meters'
       write (dpu,'(a)')  ' '
     end if
    
!-----------------------------------------------------------
!            
! Add contribution (if any) from surface interfacial layer 
! to turbulent production and lengthscales.  If there is 
! positive surface buoyancy flux, the CL extends to the 
! surface and there is a surface interfacial layer contri-
! bution to W and the CL interior depth. If there is neg-
! ative buoyancy flux, the surface interfacial layer is 
! treated as energetically isolated from the rest of the CL
! and does not contribute to the layer-interior W or depth.
! This case also requires a redefinition of lbulk.

     bottom = kb .eq. kdim+1
     if (bottom .and. (bflxs .ge. 0.)) then
       lint = zm(kdim)
       dwsurf = (tkes/b1)*zm(kdim)
     else if (bottom .and. (bflxs .lt. 0.)) then
       lint = 0.
       dwsurf = 0.
       lbulk = zi(kt)-zm(kdim)
     else
       lint = 0.
       dwsurf = 0.
     end if
     l2n2 = 0.
     l2s2 = 0.
            
     if (column_match .and. bottom) then
       write(dpu,30) kdim+1,lint,lz,l2n2,l2s2
30   format(1X,i2,1X,2(f8.4,1X),2(f12.9,1X))
     end if
    
!-----------------------------------------------------------
!            
! Turbulence contribution from conv layer (CL) interior 
! kt < k < kb, which at this point contains only unstable 
! interfaces. Based on the CL interior stratification, 
! initial guesses at the stability functions are made. If 
! there is no CL interior interface, neutral stability is 
! assumed for now.

     if (kt .lt. kb-1) then 
            
       do k = kb-1, kt+1, -1
         lz   = lengthscale(zi(k),lbulk)
         l2n2 = l2n2 + lz*lz*n2(k)*(zm(k-1)-zm(k))
         l2s2 = l2s2 + lz*lz*s2(k)*(zm(k-1)-zm(k))
         lint = lint + (zm(k-1)-zm(k))      
         if (column_match) write(dpu,30) k,lint,lz,l2n2,  &
           l2s2
       enddo

!------------------------------------------------------
!
! Solve for bulk Sh, Sm, and wint over the CL interior
 
       ricl = min(l2n2/l2s2,ricrit) ! actually we should have 
                              ! ricl < 0 
       call galperin(ricl,gh,sh,sm)
       wint = -sh*l2n2 + sm*l2s2 + dwsurf 
       ebar = b1*wint/lint

     else

!-----------------------------------------------------------
!            
! There is no CL interior interface. The only way that 
! should happen at this point is if there is upward surface 
! buoy flux but no unstable interior interfaces. In that 
! case, the surface interface turbulent production terms are
! used as its CL 'interior'.

       if (bottom) then
         wint = dwsurf
         ebar = tkes     
      
!use neutral stability fns for layer extension
         call galperin(0.,gh,sh,sm) 
      
       else
         call error_mesg ('edt_mod', &
              'no convective layers found although ncv <= ncvfin', &
                           FATAL)
       endif
 
     endif
    
     if(column_match) then
       write (dpu,'(a)')  ' '
       write (dpu,'(a,f14.7)')  ' ricrit = ',ricrit
       write (dpu,'(a,f14.7)')  ' ricl   = ', ricl
       write (dpu,'(a,f14.7)')  ' gh     = ', gh
       write (dpu,'(a,f14.7)')  ' sh     = ', sh
       write (dpu,'(a,f14.7)')  ' sm     = ', sm
       write (dpu,'(a,f14.7,a)')  ' lbulk  = ', lbulk,  ' meters'
       write (dpu,'(a,f14.7,a)')  ' wint   = ', wint,   ' m3/s2'
       write (dpu,'(a,f14.7,a)')  ' dwsurf = ', dwsurf, ' m3/s2'
       write (dpu,'(a,f14.7,a)')  ' ebar   = ', ebar,   ' m2/s2' 
       write (dpu,'(a)')  ' '
     end if
    
!-----------------------------------------------------------
!            
! Try to extend the top of the convective layer. Compute 
! possible contributions to TKE production and lengthscale 
! were the CL top interfacial layer found by exacol incor-
! porated into the CL interior.

     extend = .false.    ! will become true if CL top is extended
     dzinc  = zm(kt-1)-zm(kt)
     lz     = lengthscale(zi(kt),lbulk)
     dl2n2  = lz*lz*n2(kt)*dzinc
     dl2s2  = lz*lz*s2(kt)*dzinc
     dwinc  = -sh*dl2n2 + sm*dl2s2

     if (column_match) then 
       write (dpu,'(a)')  '------------------------------------'//&
                          '-------'
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  '  trying to extend a layer upwards     '
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' k    dzinc      lz      dl2n2      '//&
                          '  dl2s2        dwinc' 
       write (dpu,'(a)')  '       (m)       (m)    (m3/s2)     '//&
                          ' (m3/s2)      (m3/s2)'
       write (dpu,'(a)')  '------------------------------------'//&
                          '----------------------'
       write (dpu,'(a)')  ' '
       write(dpu,31) kt,dzinc,lz,dl2n2,dl2s2,dwinc
31     format(1X,i2,1X,2(f8.4,1X),3(f12.9,1X))
     end if
    
!-----------------------------------------------------------
!            
! Test for incorporation of top layer kt into CL interior. 
! If true, extend CL by incorporating top layers until test 
! fails.
      
     l2n2 = -max(min(-l2n2,tkemax*lint/(b1*sh)),tkemin*lint/ (b1*sh))
     tmpr = -rinc*dzinc*l2n2/(lint+(1-rinc)*dzinc)
    
     if (column_match) then
       write (dpu,'(a)')  ' '
       write (dpu,'(a,f14.7,a)')  '-dl2n2 = ', -1.*dl2n2, ' m3/s2'
       write (dpu,'(a,f14.7,a)')  '  l2n2 = ',      l2n2, ' m3/s2'
       write (dpu,'(a,f14.7)')    '  rinc = ',      rinc
       write (dpu,'(a,f14.7,a)')  '  tmpr = ',      tmpr, ' m3/s2'
       !write (dpu,'(a,f14.7)')  ' will layer be extended (-dl2'//&
                        !    'n2 .gt. tmpr)? ', real( -dl2n2 .gt. tmpr )
       write (dpu,'(a)')  ' '
     end if
    
     do while (-dl2n2 .gt. tmpr)

!------------------------------------------------------
! Add contributions from layer kt to interior length-
! scale/TKE prod

       lint = lint + dzinc
       wint = wint + dwinc
       l2n2 = l2n2 + dl2n2
       l2n2 = -max(min(-l2n2,tkemax*lint/(b1*sh)),tkemin*lint/(b1*sh))
       l2s2 = l2s2 + dl2s2
       kt = kt-1
       extend = .true.
       if (kt .eq. 1) then
         call error_mesg ('edt_mod', &
              'trying to extend convective layer at model top',&
                           FATAL)
       end if

!------------------------------------------------------
! Check for existence of an overlying CL which might 
! be merged. If such exists (ktinc > 1), check for 
! merging by testing for incorporation of its top 
! interior interface into current CL. If no such layer 
! exists, ktop(ncv+cntu+1) will equal its default value
! of zero, so ktinc will be 1 and the test kt=ktinc
! will fail.

       ktinc = ktop(ncv+cntu+1)+1
       if (kt .eq. ktinc) then
         ncvfin = ncvfin - 1
         cntu   = cntu   + 1 
       end if

!------------------------------------------------------
! Compute possible lengthscale and TKE production
! contributions were layer kt incorporated into CL 
! interior. Then go back to top of loop to test for 
! incorporation.
            
       dzinc = zm(kt-1)-zm(kt)
       lz    = lengthscale(zi(kt),lbulk)
       dl2n2 = lz*lz*n2(kt)*dzinc
       dl2s2 = lz*lz*s2(kt)*dzinc
       dwinc = -sh*dl2n2 + sm*dl2s2
    
       if (column_match) write(dpu,31) kt,dzinc,lz,dl2n2, dl2s2,dwinc
    
 !------------------------------------------------------
 ! Recalculate tmpr
      
       tmpr  = -rinc*dzinc*l2n2/(lint+(1-rinc)*dzinc)
            
       if (column_match) then
         write (dpu,'(a)')  ' '
         write (dpu,'(a,f14.7,a)')  '-dl2n2 = ', -1.*dl2n2,    &
                                    ' m3/s2'
         write (dpu,'(a,f14.7,a)')  '  l2n2 = ',      l2n2,    &
                                    ' m3/s2'
         write (dpu,'(a,f14.7)')    '  rinc = ',      rinc
         write (dpu,'(a,f14.7,a)')  '  tmpr = ',      tmpr,    &
                                    ' m3/s2'
         !write (dpu,'(a,f14.7,a)')  ' will layer be extende'//&
                 !     'd (-dl2n2 .gt. tmpr)? ', real(-dl2n2 .gt. tmpr)
         write (dpu,'(a)')  ' '
       end if
    
     end do   ! Done with top extension of CL

     !-----------------------------------------------------------
     ! Shift indices appropriately if layers have been merged

     if (cntu .gt. 0) then
       do incv = 1, ncvfin - ncv
         kbase(ncv+incv) = kbase(ncv+cntu+incv)
         ktop(ncv+incv) = ktop(ncv+cntu+incv)
       end do
     end if

     !-----------------------------------------------------------
     !            
     ! Extend the CL base if possible.

     if (column_match .and. .not. bottom) then 
       write (dpu,'(a)')  '------------------------------------'//&
                          '-------'
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  '  trying to extend a layer downwards'
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  'k     dzinc       lz       dl2n2    '//&
                          '       dl2s2          dwinc' 
       write (dpu,'(a)')  '       (m)        (m)     (m3/s2)   '//&
                          '     (m3/s2)        (m3/s2)'
       write (dpu,'(a)')  '------------------------------------'//&
                          '---------------------------'
       write (dpu,'(a)')  ' '
     end if
    
     if (.not. bottom) then

!------------------------------------------------------
! Compute possible contributions to TKE production and 
! lengthscale, were the CL base interfacial layer found 
! by exacol incorporated into the CL interior.

       dzinc = zm(kb-1)-zm(kb)
       lz    = lengthscale(zi(kb),lbulk)
       dl2n2 = lz*lz*n2(kb)*dzinc
       dl2s2 = lz*lz*s2(kb)*dzinc
       dwinc = -sh*dl2n2 + sm*dl2s2

       if (column_match) write(dpu,31) kb,dzinc,lz,dl2n2,dl2s2,dwinc

!------------------------------------------------------
! Test for incorporation of base layer kb into CL 
! interior. If true, extend CL by incorporating base 
! layers until test fails.

       tmpr = -rinc*dzinc*l2n2/(lint+(1-rinc)*dzinc)
 
       if (column_match) then
         write (dpu,'(a)')  ' '
         write (dpu,'(a,f14.7,a)')  '-dl2n2 = ', -1.*dl2n2,    &
                                    ' m3/s2'
         write (dpu,'(a,f14.7,a)')  '  l2n2 = ',      l2n2,    &
                                    ' m3/s2'
         write (dpu,'(a,f14.7)')    '  rinc = ',      rinc
         write (dpu,'(a,f14.7,a)')  '  tmpr = ',      tmpr,    &
                                    ' m3/s2'
        !write (dpu,'(a,f14.7,a)')  ' will layer be extende'//&
                !     'd (-dl2n2 .gt. tmpr)? ', real(-dl2n2 .gt. tmpr)
         write (dpu,'(a)')  ' '
       end if

       do while((-dl2n2.gt. tmpr) .and. (.not. bottom) )

!-------------------------------------------------
! Add contributions from layer kb to interior 
! lengthscale/TKE prod
 
         lint = lint + dzinc
         wint = wint + dwinc
         l2n2 = l2n2 + dl2n2
         l2n2 = -max(min(-l2n2,tkemax*lint/(b1*sh)),tkemin&
                        *lint/(b1*sh))
         l2s2 = l2s2 + dl2s2

!-------------------------------------------------
! Extend base of CL downward a layer

         kb = kb+1
         extend = .true.

!-------------------------------------------------
! Check for existence of an underlying CL which 
! might be merged. If such exists (kbinc > 1), 
! check for merging by testing for incorporation 
! of its top interior interface into current CL.
! Note that this top 'interior' interface could be
! the surface.

         kbinc = 0
         if (ncv .gt. 1) kbinc = ktop(ncv-1)+1
         if (kb .eq. kbinc) then

!--------------------------------------------
! We are incorporating interior of CL ncv-1, 
! so merge this CL into the current CL.

           ncv    = ncv    - 1
           ncvfin = ncvfin - 1
           cntd   = cntd   + 1 
         end if

!-------------------------------------------------
! If CL would now reach the surface, check sign of
! surface buoyancy flux. If positive, add contri-
! butions of surface interfacial layer to TKE 
! production and lengthscale. If negative, we 
! regard the surface layer as stable and do not
! add surface interfacial layer contributions to 
! the CL. In either case the surface interface is 
! classified as part of the CL for bookkeeping 
! purposes (to ensure no base entrainment calcula-
! tion is done). If we are merging with a surface-
! driven CL with no interior unstable interfaces, 
! the above code will already have handled the 
! merging book-keeping.

         bottom = kb .eq. kdim+1
         if (bottom) then 
           if (bflxs .gt. 0.) then 
             dwsurf = (tkes/b1)*zm(kdim)
             lint = lint + zm(kdim)
           end if
         else

!--------------------------------------------
! Compute possible lengthscale and TKE prod-
! uction contributions were layer kb incor-
! porated into CL interior,then go back to 
! top of loop to test for incorporation
            
           dzinc = zm(kb-1) - zm(kb)
           lz    = lengthscale(zi(kb),lbulk)
           dl2n2 = lz*lz*n2(kb)*dzinc
           dl2s2 = lz*lz*s2(kb)*dzinc
           dwinc = -sh*dl2n2 + sm*dl2s2
                        
         end if

         if (column_match) write(dpu,31) kb,dzinc,lz,dl2n2,dl2s2,dwinc
    
!-------------------------------------------------
! Recalculate tmpr
      
         tmpr = -rinc*dzinc*l2n2/(lint+(1-rinc)*dzinc)

         if (column_match) then
           write (dpu,'(a)')  ' '
           write (dpu,'(a,f14.7,a)')  '-dl2n2 = ',-1.*dl2n2,' m3/s2'
           write (dpu,'(a,f14.7,a)')  '  l2n2 = ',     l2n2,' m3/s2'
           write (dpu,'(a,f14.7)')    '  rinc = ',     rinc
           write (dpu,'(a,f14.7,a)')  '  tmpr = ',     tmpr,' m3/s2'
           !write (dpu,'(a,f14.7,a)')  ' will layer be ex'//&
                     !     'tended (-dl2n2 .gt. tmpr)? ', real(-dl2n2 &
      !     .gt. tmpr)
           write (dpu,'(a)')  ' '
         end if
    
       end do ! for downward extension
 
       if (bottom .and. ncv .ne. 1) then 
         call error_mesg ('edt_mod', &
                          'bottom convective layer not indexed 1',&
                           FATAL)
       end if

     end if   ! Done with bottom extension of CL 

!-----------------------------------------------------------
! Shift indices if some layers with N2 < 0 have been found

     if (cntd .gt. 0) then
       do incv = 1, ncvfin - ncv
         kbase(ncv+incv) = kbase(ncvinit+incv)
         ktop(ncv+incv) = ktop(ncvinit+incv)
       end do
     end if

!-----------------------------------------------------------
! Sanity check for positive wint.
     if (wint .lt. 0.) then
       call error_mesg ('edt_mod', &
                        'interior avg TKE < 0', FATAL)
     end if

!-----------------------------------------------------------
! Recompute base and top indices, Ri_cl, Sh, Sm, and <W> 
! after layer extension if necessary. Ideally, we would 
! recompute l2n2 and l2s2 to account for the incorrect lbulk
! used in the computation of lz, but we take the simpler 
! approach of simply multiplying the lz's by the ratio of 
! the actual PBL depth to lbulk.
    
     if (extend) then

       ktop (ncv) = kt
       kbase(ncv) = kb
       zbot       = zi(kb)
       if (bottom .and. (bflxs.lt.0)) zbot = zm(kdim)
       l2rat      = ((zi(kt) - zbot)/lbulk)**2
       l2n2       = l2n2*l2rat
       l2s2       = l2s2*l2rat
       ricl = min(l2n2/l2s2,ricrit)
       call galperin(ricl,gh,sh,sm)
                 
 !------------------------------------------------------
 ! It is conceivable that even though the original wint 
 ! was positive, it will be negative after correction. 
 ! In this case, correct wint to be a small positive 
 ! number
       wint = max(dwsurf + (-sh*l2n2 + sm*l2s2),0.01*wint)

     end if  ! for extend if

     lbrk(ncv) = lint
     wbrk(ncv) = wint/lint
     ebrk(ncv) = b1*wbrk(ncv)
     ebrk(ncv) = max(min(ebrk(ncv),tkemax),tkemin)
     ghcl(ncv) = gh 
     shcl(ncv) = sh
     smcl(ncv) = sm
           
     if (column_match) then
       write (dpu,'(a)')  ' '
       write (dpu,'(a,i4)') ' FINAL RESULTS FOR CONVECTIVE LAYER', ncv
       write (dpu,'(a)')  ' '
       write (dpu,'(a,i4,i4)')   ' ktop(ncv), kbase(ncv) = ',     &
                                   ktop(ncv), kbase(ncv)
       write (dpu,'(a,f14.7,a)') ' lbrk(ncv) = ', lbrk(ncv),' m'
       write (dpu,'(a,f14.7,a)') ' wbrk(ncv) = ', wbrk(ncv),' m2/s2'
       write (dpu,'(a,f14.7,a)') ' sqrt(ebrk(ncv)) = ',           &
                                   sqrt(ebrk(ncv)), ' m/s'
       write (dpu,'(a,f14.7)')   ' ghcl(ncv) = ', ghcl(ncv)
       write (dpu,'(a,f14.7)')   ' shcl(ncv) = ', shcl(ncv)
       write (dpu,'(a,f14.7)')   ' smcl(ncv) = ', smcl(ncv)
     end if

            !-----------------------------------------------------------
    ! Increment counter for next CL

     ncv = ncv + 1

   end do     ! Loop over convective layers

       !----------------------------------------------------------------
       ! 
       ! set belongcv 

   belongcv(:) = .false.
   do ncv = 1, ncvfin
     do k = ktop(ncv), kbase(ncv)
       belongcv(k) = .true.
     enddo
   enddo

   if (column_match) then
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  '                  END OF ZISOCL '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  '-------------------------------------------'
   end if
              
!-----------------------------------------------------------------------
! 
!      subroutine end
!

end subroutine zisocl

!
!=======================================================================

!======================================================================= 
!
!      subroutine caleddy
!        
!
!      this is the main program provided by Chris Bretherton and Herve
!      Grenier
!        

subroutine caleddy( u_star,       kqfs,         khfs,         sl,      &
                    qt,           ql,           qa,           slv,     &
                    u,            v,            pm,           zm,      &
                    sfuh,         sflh,         slslope,      qtslope, &
                    qrl,          hleff,        density,      qsl,     &
                    dqsldtl,      qltop,        pi,           zi,      &
                    chu,          chs,          cmu,          cms,     &
                    n2,           s2,           ri,           pblh,    &
                    turbtype,     kvh,          kvm,          tke,     &
                    leng,         bprod,        sprod,        trans,   &
                    diss,         isturb,       adj_time_inv, sdevs,   &
                    radfvec,      shvec,        smvec,        ghvec,   &
                    evhcvec)


!-----------------------------------------------------------------------
!
!      Driver routine to compute eddy diffusion coefficients for 
!      momentum, moisture, trace constituents and static energy.  Uses 
!      first order closure for stable turbulent layers. For convective 
!      layers, an entrainment closure is used, coupled to a diagnosis 
!      of layer-average TKE from the instantaneous thermodynamic and 
!      velocity profiles. Convective layers are diagnosed by extending 
!      layers of moist static instability into adjacent weakly stably 
!      stratified interfaces, stopping if the stability is too strong.  
!      This allows a realistic depiction of dry convective boundary 
!      layers with a downgradient approach.
! 
!      Authors:  Herve Grenier, 06/2000, Chris Bretherton 09/2000
!
!-----------------------------------------------------------------------
! 
! Variable declarations
!
! Inputs
!

real, intent(in)               :: u_star  ! surface friction velocity
real, intent(in)               :: kqfs    ! kinematic surf constituent
                                          ! flux (kg/kg)*(m/s)
real, intent(in)               :: khfs    ! kinematic surface heat flux
                                          ! (K*m/s)

!
!       the following fields are defined on model full
!       levels with dimension (1:nlev)
!

real, intent(in), dimension(:) :: sl      ! liq water static energy 
                                          !  cp*T+g*z-L*ql (J/kg)
real, intent(in), dimension(:) :: qt      ! total water spec. hum.
                                          ! (kg water/kg air) 
real, intent(in), dimension(:) :: ql      ! liq water spec. hum.
                                          ! (kg condensate/kg air)
real, intent(in), dimension(:) :: qa      ! cloud fraction (fraction)
real, intent(in), dimension(:) :: slv     ! liq water virtual static
                                          ! energy (J/kg)
                                          !  sl*(1 + .608*qt)
real, intent(in), dimension(:) :: u       ! u wind input (m/s)
real, intent(in), dimension(:) :: v       ! v wind input (m/s)
real, intent(in), dimension(:) :: pm      ! midpoint pressures (Pa)
real, intent(in), dimension(:) :: zm      ! layer midpoint height 
                                          ! above sfc (m)
real, intent(in), dimension(:) :: sfuh    ! sat frac in upper half-lyr
real, intent(in), dimension(:) :: sflh    ! sat frac in lower half-lyr    
real, intent(in), dimension(:) :: slslope ! sl slope with respect to
                                          ! pressure in thermo lyr
  ! (J/kg/Pa)
real, intent(in), dimension(:) :: qtslope ! qt slope with respect to
                                          ! pressure in thermo lyr
                                          ! (kg water/kg air/Pa)
real, intent(in), dimension(:) :: qrl     ! LW heating rate (K/s)
real, intent(in), dimension(:) :: hleff   ! effective latent heat of 
                                          ! condensation (J/kg)
real, intent(in), dimension(:) :: density ! air density (kg/m3)
real, intent(in), dimension(:) :: qsl     ! saturation specific hum.
                                          ! (kg water/kg air)
real, intent(in), dimension(:) :: dqsldtl ! temperature derivative of
                                          ! qsl (kg water/kg air/K)
real, intent(in), dimension(:) :: qltop   ! cloud liquid at the top
                                          ! of the thermo layer
  
!
!       the following fields are defined on model half levels,
!       dimension(1:nlev+1)
!

real, intent(in), dimension(:) :: pi      ! interface pressures (Pa)
real, intent(in), dimension(:) :: zi      ! interface height above
                                          ! sfc (m)
real, intent(in), dimension(:) :: chu     ! Unsat sl (heat) coef (1/m)
real, intent(in), dimension(:) :: chs     ! Sat sl (heat) coef (1/m)
real, intent(in), dimension(:) :: cmu     ! Unsat qt (moisture) coef 
                                          ! (kg/kg)*(m/s*s)
real, intent(in), dimension(:) :: cms     ! Sat qt (moisture) coef 
                                          ! (kg/kg)*(m/s*s)
real, intent(in), dimension(:) :: n2      ! Moist squared buoy freq 
                                          ! (1/sec**2)
real, intent(in), dimension(:) :: s2      ! Squared deformation (s-2)
                                          ! (1/sec**2)
real, intent(in), dimension(:) :: ri      ! gradient Richardson number

!
! Outputs
!

real,    intent(out)   :: pblh     ! planetary boundary layer height (m)


!
!       the following field is defined on model full levels,
!       dimension(1:nlev)
!

real,    intent(out), dimension(:) :: isturb ! is full layer part of a 
     ! turbulent layer?

!
!       the following fields are defined on model half levels,
!       dimension(1:nlev+1)
!

integer, intent(out), dimension(:,:) :: turbtype! Interface turb. type
                                                ! 1 = stable turb 
          ! 2 = CL interior
                                                ! 3 = bottom entr intfc 
                                                ! 4 = upper entr intfc 
real,    intent(out), dimension(:) :: kvh       ! diffusivity for heat 
                                                ! and tracers (m*m/s)
real,    intent(out), dimension(:) :: kvm       ! diffusivity for mom.
                                                ! (m*m/s)
real,    intent(out), dimension(:) :: tke       ! turb. kin. energy 
                                                ! (m*m)/(s*s)
real,    intent(out), dimension(:) :: leng      ! turbulent length scale
                                                ! (m)
real,    intent(out), dimension(:) :: bprod     ! Buoyancy production
                                                ! (m*m)/(s*s*s)
real,    intent(out), dimension(:) :: sprod     ! shear production
                                                ! (m*m)/(s*s*s)
real,    intent(out), dimension(:) :: trans     ! TKE transport
                                                ! (m*m)/(s*s*s)
real,    intent(out), dimension(:) :: diss      ! TKE dissipation
                                                ! (m*m)/(s*s*s)
real,    intent(out), dimension(:) :: adj_time_inv  ! inverse adjustment 
                                                    ! time for turbulent
    ! layer (1/sec)
real,    intent(out), dimension(:) :: sdevs     ! std. dev. of water
                                                ! perturbation
        ! (kg water/kg air)
        ! defined on model half
        ! levels
real,    intent(out), dimension(:) :: radfvec   ! Buoyancy production
                                                ! from lw radiation
                                                ! (m*m)/(s*s*s)
real,    intent(out), dimension(:) :: shvec     ! Galperin heat stab. 
                                                ! fn. (none)
real,    intent(out), dimension(:) :: smvec     ! Galperin mom. stab. 
                                                ! fn. (none)
real,    intent(out), dimension(:) :: ghvec     ! Galperin stability
                                                ! ratio (none)
real,    intent(out), dimension(:) :: evhcvec   ! Evaporative cooling
                                                ! entrainment factor
! (none)


!
! Internal variables
!

logical :: in_CL                             ! True if interfaces k,k+1
                                             ! both in same CL
logical :: any_stable                        ! Are there any stable 
                                             ! turbulent layers?
logical :: cloudtop                          ! Is the interface at 
                                             ! cloudtop?
logical, dimension(size(sl,1)+1) :: belongcv ! True for interfaces 
                                             ! interior to convective
     ! layer (CL)
logical, dimension(size(sl,1)+1) :: belongst ! True for interfaces 
                                             ! interior to a stable
     ! turbulent layer
integer :: k                    ! vertical index
integer :: ks                   ! vertical index
integer :: kk                   ! vertical index
integer :: kdim                 ! number of full vertical levels
integer :: ncvfin               ! Total number of CL in column
integer :: ncvf                 ! Total number of CL in column prior to
                                ! addition of one layer rad-driven CLs
integer :: ncv                  ! index of current CL
integer :: ncvnew               ! index of added one layer rad-driven CL
integer :: ncvsurf              ! if nonzero, index of CL including 
                                ! surface
integer :: kb, kt               ! kbase and ktop for current CL


integer, dimension(size(sl,1)+1) :: kbase     ! vert. index for base
                                              ! interface of CL
integer, dimension(size(sl,1)+1) :: ktop      ! vert. index for top 
                                              ! interface of CL

real    :: bflxs    ! Surface buoyancy flux (m2/s3)
real    :: tkes     ! Surface TKE
real    :: jtzm     ! Interface layer thickness atop conv layer (CL) ncv
real    :: jtsl     ! Jump in s_l               atop       "
real    :: jtqt     ! Jump in q_t               atop       "
real    :: jtbu     ! Jump in buoyancy          atop       "
real    :: jtu      ! Jump in zonal wind        atop       "
real    :: jtv      ! Jump in meridional wind   atop       "
real    :: jt2slv   ! 2-layer Jump in s_lv              atop       "
real    :: radf     ! buoy flx jump at cloudtop from lw rad flx div
real    :: jbzm     ! Interface layer thickness at base of CL ncv
real    :: jbsl     ! Jump in s_l               at base    "
real    :: jbqt     ! Jump in qt                at base    "
real    :: jbbu     ! Jump in buoyancy          at base    "
real    :: jbu      ! Jump in zonal wind        at base    "
real    :: jbv      ! Jump in merid. wind       at base    "
real    :: ch       ! buoy flux coefs for sl, qt in a half-layer 
real    :: cm       ! 
real    :: n2h      ! Moist squared buoy freq for a half-layer (s-2)
real    :: ckh      ! Galperin stability function for heat
real    :: ckm      ! Galperin stability function for momentum
real    :: gh       ! Normalised buoyancy production (m*m*m)/(s*s)
real    :: lbulk    ! Depth of turbulent layer (m)
real    :: trma     ! intermediate variables
real    :: vus
real    :: vub
real    :: trmp
real    :: trmq
real    :: angle
real    :: qq
real    :: rootp             
real    :: evhc          ! (1+E) with E = evap. cool. efficiency [nd]
real    :: vys           ! n2h/n2 at upper inversion [nd]
real    :: vyb           ! Same at lower inversion [nd]
real    :: kentr         ! effective entrainment diffusivity we*dz (m*m/s)
real    :: lwp           ! liquid water path in layer kt (kg cond/m2)
real    :: opt_depth     ! optical depth of layer kt
real    :: radinvfrac    ! frac of lw cooling in layer kt put at inv.
real    :: qtsltmp       ! dqt/dz (kg/kg/m)
real    :: slsltmp       ! dsl/dz (J/kg/m)
real    :: qsltmp        ! qsl (kg water/kg air)
real    :: dqsldtltmp    ! dqsldtl (kg water/kg air/K)
real    :: hlefftmp      ! effective latent heat (J/kg water)
real    :: qstartmp      ! q* at upper/lower inversion (kg water/kg air)
real    :: bstartmp      ! b* at upper/lower inversion (m/s2)
real    :: temperature   ! actual temperature (K)
real    :: tmpfrac       ! fraction of cloud at top of convective layer
                         ! exposed to clear air above using maximum 
 ! overlap assumption
real, dimension(size(sl,1)+1) :: ebrk,wbrk,lbrk,ghcl,shcl,smcl
real, dimension(size(sl,1)+1) :: wcap          ! W (m2/s2)
real, dimension(size(sl,1)+1) :: rcap          ! e/<e> 

!-----------------------------------------------------------------------
!
!  Initialize to zero outputs needed at all interfaces, but
!  calculated only at turbulent interfaces. Only kvh and kvm are 
!  outputs, the other arrays are zeroed for plotting or diagnostic 
!  purposes. 

   kdim             = size(sl,1)
   kvh(:)           = 0.0
   kvm(:)           = 0.0
   wcap(:)          = 0.0
   leng(:)          = 0.0
   rcap(:)          = 0.0
   bprod(:)         = 0.0
   sprod(:)         = 0.0
   trans(:)         = 0.0
   diss(:)          = 0.0
   tke(:)           = 0.0
   turbtype(:,:)    = 0
   adj_time_inv(:)  = missing_value
   isturb(:)        = 0.0
   sdevs(:)         = missing_value
   radfvec(:)       = 0.0
   shvec(:)         = missing_value
   smvec(:)         = missing_value
   ghvec(:)         = missing_value
   evhcvec(:)       = missing_value
       
!-----------------------------------------------------------------------
!
!      Optional printout
        
   if (column_match) then
     write (dpu,'(a)')  '--------------------------------------------'
     write (dpu,'(a)')  '        ENTERING CALEDDY                '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  'checking inputs: '
     write (dpu,'(a)')  ' '
     write (dpu,'(a,f14.7,a)') ' u_star             = ',u_star, ' m/s'
     write (dpu,'(a,f14.7,a)') ' latent   heat flux = ',density(kdim)&
                               *hleff(kdim)*kqfs,' W/m2'
     write (dpu,'(a,f14.7,a)') ' sensible heat flux = ',density(kdim)&
                               *cp_air*khfs,' W/m2'
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' k     sl/cp_air        qt        qc        q'//&
                        'a     slv/cp_air' 
     write (dpu,'(a)')  '        (K)       (g/kg)    (g/kg)       '//&
                        '       (K)  '
     write (dpu,'(a)')  '-----------------------------------------'//&
                        '------------'
     write (dpu,'(a)')  ' '
     do kk = kdim-n_print_levels,kdim
       write(dpu,224) kk,sl (kk)/cp_air,1000.*qt(kk),1000.*ql(kk),    &
                      qa(kk),slv(kk)/cp_air
     end do
224  format(1X,i2,1X,5(f9.4,1X))
24   format(1X,i2,1X,4(f9.4,1X))
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' k      u          v      z_full     p_full'
     write (dpu,'(a)')  '      (m/s)      (m/s)     (m)        (mb) '
     write (dpu,'(a)')  '-------------------------------------------'
     write (dpu,'(a)')  ' '
     do kk = kdim-n_print_levels,kdim
       write(dpu,24) kk,u(kk),v(kk),zm(kk),pm(kk)/100.
     enddo    
     write (dpu,'(a)') ' '
     write (dpu,'(a)') ' '
     write (dpu,'(a)') ' k     sfuh      sflh     slslope   qtslope'
     write (dpu,'(a)') '                        (K/100mb)(g/kg/100mb)'              
     write (dpu,'(a)') '---------------------------------------------'
     write (dpu,'(a)') ' '
     do kk = kdim-n_print_levels,kdim
       write(dpu,24) kk,sfuh(kk),sflh(kk),slslope(kk)*100.*100./cp_air&
                     ,1000.*qtslope(kk)*100.*100.
     enddo
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  'k       rho       qrl      hleff'
     write (dpu,'(a)')  '      (kg/m3)   (K/day)   (MJ/kg)'
     write (dpu,'(a)')  '---------------------------------'
     write (dpu,'(a)')  ' '
     do kk = kdim-n_print_levels,kdim
       write(dpu,124) kk,density(kk),qrl(kk)*86400,hleff(kk)/1.e+06
124  format(1X,i2,1X,3(f9.4,1X))
     enddo
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' k   p_half  z_half  chu    chs     cmu  '//&
                        '   cms   sqrt(n2)  sqrt(s2)     ri'
     write (dpu,'(a)')  '     (mb)    (m)    (m/K/s**2)      (m/s*'//&
                        '*2)      (1/hr)    (1/hr) '
     write (dpu,'(a)')  '-----------------------------------------'//&
                        '--------------------------------------'
     write (dpu,'(a)')  ' '
     do kk = kdim+1-n_print_levels,kdim+1
       write(dpu,26) kk,pi(kk)/100.,zi(kk),cp_air*chu(kk),cp_air*chs(kk), &
                     cmu(kk),cms(kk),n2(kk)*sqrt(abs(n2(kk)))*3600./&
                     max(small,abs(n2(kk))),sqrt(s2(kk))*3600.,ri(kk)
     enddo
26   format(1X,i2,1X,f7.2,1X,f7.1,1X,2(f7.4,1X),2(f6.3,1X),3(f9.3,1X))
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  '-----------------------------------------'//&
                        '-------------------------------------'
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
   end if
       
!-----------------------------------------------------------------------
!
!  calculate 'surface' (actually lowest half-layer) buoyancy flux.
!
!  Note that sensible heat flux in W/m2 = density_air * cp * khfs
!              latent heat flux in W/m2 = density_air * L  * kqfs
!
!  units of bflxs below is m2/s3
!
!  Buoyancy flux in W/m2 = rho * bflxs / ch
!
   ch = chu(kdim+1)*(1-sflh(kdim)) + chs(kdim+1)*sflh(kdim)   
   cm = cmu(kdim+1)*(1-sflh(kdim)) + cms(kdim+1)*sflh(kdim)   
   bflxs  = ch*cp_air*khfs + cm*kqfs
   bprod(kdim+1) = bflxs       
             
!-----------------------------------------------------------------------
!
!  Diagnostic surface TKE used in calculating layer-average TKE.
!
!  Chris B. note:
!
!  Originally tkes was computed from the commented out line below.
!  This commented-out line can make tkes small or even negative. 
!  The replacement has at least equal justifiability, trying to 
!  represent tke at the surface rather than at zm(kdim).  Near the
!  surface is where averaging W to get <e> is not really just-
!  ifiable.
!
!  tkes = (b1*(ustar**3+vonkarm*zm(kdim)*bflxs))**2./3.
!  
!  [Steve Klein note:
!
!  The replacement line appears to create an inconsistency in the 
!  sense that the buoyancy flux in the lower half of level one does
!  not effectively contribute to dwsurf, the contribution to W,
!  in the lower half of level one. Hence diagnosing shear production
!  and dissipation at the surface is a bit of a ruse.]

   tkes          = max(min(b123*u_star**2,tkemax),tkemin)
   tke(kdim+1)   = tkes
   diss(kdim+1)  = tkes**(3/2)/b1/zm(kdim)              
   sprod(kdim+1) = tkes**(3/2)/b1/zm(kdim)

   if (column_match) then       
     write (dpu,'(a)')  ' '
     write (dpu,'(a,f14.7,a)')  ' ch (surface)  = ',cp_air*ch,' m/K/s**2'
     write (dpu,'(a,f14.7,a)')  ' cm (surface)  = ',cm,' m/s**2'
     write (dpu,'(a,f14.7,a)')  ' bflxs         = ',bflxs,' m2/s3'
     write (dpu,'(a,f14.7,a)')  ' buoyancy flux = ',density(kdim)*   &
                                bflxs/ch,' W/m2'
     write (dpu,'(a)')  ' '
     write (dpu,'(a,f14.7,a)')  ' u_star           = ', u_star,' m/s'
     write (dpu,'(a,f14.7,a)')  ' surface tke sqrt = ',sqrt(tkes),   &
                                ' m/s'
     write (dpu,'(a)')  ' '
   end if        

!-----------------------------------------------------------------------
!
!  Examine each column and determine whether it is convective.

    call exacol(ri, bflxs, ktop, kbase, ncvfin)

!-----------------------------------------------------------------------
!
!  CONVECTIVE LAYER (CL) computations
!
!  If some convective layers have been found, determine their bulk 
!  properties (<e>, <Sh>, <Sm>, and indices ktop/bkase for upper/
!  lower inversion ).

   ncvsurf = 0  
   
   if (ncvfin .gt. 0) then
   
      call zisocl(u_star, bflxs, tkes, zm, ql, zi, n2, s2, ri,     &
                  ncvfin, kbase, ktop, belongcv, ebrk, wbrk, ghcl, &
                  shcl, smcl, lbrk)
 
!-------------------------------------------------------------
!  CLs found by zisocl are in order of height, so if any CL 
!  contains the surface, it will be CL1.
         
     if (kbase(1) .eq. kdim+1) ncvsurf = 1
  
   else
       
     belongcv(:) = .false.
       
   end if

   if (column_match) write (dpu,'(a,i3)')  ' ncvsurf = ', ncvsurf

!-----------------------------------------------------------------------
!
!  Find single-level radiatively-driven cloud-topped convective 
!  layers (SRCLs). SRCLs extend through a single thermo layer k, 
!  with entrainment at interfaces k and k+1 (unless k+1 is the 
!  surface, in which case surface shear generation contributes to 
!  the layer-averaged energy). The conditions for an SRCL are:
!      1. cloud at level k
!      2. no cloud at level k+1 (else assuming that some fraction 
!         of the longwave flux div in layer k is concentrated at 
!         the top interface is invalid.
!      3. Longwave radiative cooling (shortwave heating is assumed
!         uniformly distributed through layer k, so not relevant to
!         buoyancy production of TKE)
!      4. Internal stratification n2h of half-layer from level k to
!         interface k is unstable using similar method as in sfdiag,
!         but applied to internal slopes of sl, qt in layer k.
!      5. Interfaces k, k+1 not both in the same existing convective
!         layer.
!      6. k >= 2 
!      7. Ri at interface k > ricrit, otherwise stable turb mixing 
!         will broadly distribute the cloud top in the vertical, 
!         preventing localized radiative radiative destabilization 
!         at the interface height.

   ncv = 1
   ncvf = ncvfin
   
   do k = kdim, 2, -1
             
     cloudtop  = .false. 
     if (ql(k)  .gt. qcminfrac*qsl(k)   .and. use_qcmin .and.   &
         ql(k-1).lt. qcminfrac*qsl(k-1))        cloudtop = .true.
     if (.not.use_qcmin .and. qa(k).gt.qa(k-1)) cloudtop = .true.
     
     if (qrl(k).lt. 0. .and. ri(k).gt.ricrit .and. cloudtop) then

       ch  = (1 -sfuh(k))*chu(k) + sfuh(k)*chs(k)
       cm  = (1 -sfuh(k))*cmu(k) + sfuh(k)*cms(k)
       n2h = ch*slslope(k) + cm*qtslope(k)

       if (n2h.le.0.) then

       !-------------------------------------------------
       ! Test if k and k+1 are part of the same preexist-
       ! ing CL. If not, find appropriate index for new 
       ! SRCL. Note that this calculation makes use of 
       ! ncv set from prior passes through the k do loop
       
         in_CL = .false.

         do while (ncv .le. ncvf)

           if (ktop(ncv) .le. k) then

           !---------------------------------------
           ! If kbase > k, k and k+1 are part of 
           ! same prior CL
             if (kbase(ncv) .gt. k) in_CL = .true.

             !---------------------------------------
             ! exit from do-loop once CL top at/above
             ! intfc k.
             exit  

           else

           !---------------------------------------
           !  Go up one CL
             ncv = ncv + 1  

           end if
         end do ! ncv

         !-------------------------------------------------
         ! Add a new SRCL

         if (.not.in_CL) then
           ncvfin        = ncvfin+1
           ncvnew        = ncvfin
           ktop(ncvnew)  = k
           kbase(ncvnew) = k+1
           belongcv(k)   = .true.
           belongcv(k+1) = .true.

           if (k.lt.kdim) then
             ebrk(ncvnew) = 0.
             lbrk(ncvnew) = 0.
             shcl(ncvnew) = 0.
             smcl(ncvnew) = 0.

           else 

           !---------------------------------------
           ! surface radiatively driven fog
             if (bflxs.gt.0.) then 
               !----------------------------------
               ! unstable surface layer 
               ! incorporate surface TKE into
               ebrk(ncvnew) = tkes
               lbrk(ncvnew) = zm(k)
               adj_time_inv(kdim+1) = sqrt(tkes)/zm(k)
             else   
               !----------------------------------
               ! stable surface layer 
               ! don't incorporate surface TKE 
               ebrk(ncvnew) = 0.
               lbrk(ncvnew) = 0.
             end if
             shcl(ncvnew) = 0.
             smcl(ncvnew) = 0.
             ncvsurf = ncvnew

           end if    ! k < kdim  

         end if    ! new SRCL

       end if    ! n2h < 0 

     end if ! qrl < 0, ri(k) > ricrit and cloudtop

   end do ! k do loop, end of SRCL section

!-----------------------------------------------------------------------
!
!      For each CL, compute length scale, r^2, e, Kh and Km

   if (column_match) then
     write (dpu,'(a)') ' '
     write (dpu,'(a)') ' '
     write (dpu,'(a)') ' IN CALEDDY CALCULATION OF L, R2, e, Kh, a'//&
                       'nd Km'
     write (dpu,'(a)') ' '       
   end if

   do ncv = 1, ncvfin

     kt    = ktop(ncv)
     kb    = kbase(ncv)
     lbulk = zi(kt)-zi(kb)          

     if (column_match) then
       write (dpu,'(a,i3)')  ' convective layer #',ncv
       write (dpu,'(a,i4,i4)')  ' kt, kb = ', kt,kb
       write (dpu,'(a,f14.7,a)')  ' lbulk = ', lbulk, ' m'
       write (dpu,'(a)')  ' '
     end if
    
     do k = min(kb,kdim), kt, -1             
       leng(k) = lengthscale(zi(k),lbulk)
       wcap(k) = (leng(k)**2)*(-shcl(ncv)*n2(k)+ &
                  smcl(ncv)*s2(k))
     end do    ! k do loop

     if (column_match) then
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' k     leng          wcap '
       write (dpu,'(a)')  '       (m)          (m2/s2)'
       write (dpu,'(a)')  '----------------------------'
       write (dpu,'(a)')  ' '
       do k = min(kb,kdim),kt,-1
         write(dpu,33) k,leng(k),wcap(k)
       enddo
33     format(1X,i2,1X,f9.4,1X,f14.9)    
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' '
     end if
    
     !-----------------------------------------------------------
     ! Calculate jumps at the lower inversion 

     if (kb .lt. kdim+1) then 

       jbzm = zm(kb-1) - zm(kb)
       jbsl = sl(kb-1) - sl(kb)
       jbqt = qt(kb-1) - qt(kb)
       jbbu = n2(kb)   * jbzm
       jbbu = max(jbbu,jbumin)
       jbu  = u(kb-1)  - u(kb)
       jbv  = v(kb-1)  - v(kb)
       ch   = (1 -sflh(kb-1))*chu(kb) + sflh(kb-1)*chs(kb)
       cm   = (1 -sflh(kb-1))*cmu(kb) + sflh(kb-1)*cms(kb)
       n2h  = (ch*jbsl + cm*jbqt)/jbzm
       vyb  = n2h*jbzm/jbbu
       vub  = min(1.,(jbu**2+jbv**2)/(jbbu*jbzm) )

     else  
 !------------------------------------------------------
 ! Zero bottom entrainment contribution for CL extending
 ! down to sfc
            
       vyb = 0.
       vub = 0.
          
     end if
            
     if (column_match .and. kb .lt. kdim+1) then
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' jumps at lower inversion '
       write (dpu,'(a)')  ' ------------------------ '
       write (dpu,'(a)')  ' '
       write (dpu,'(a,i3)')  ' inversion half level = ',kb
       write (dpu,'(a,f14.7,a)')  ' jbzm = ',jbzm,' m'
       write (dpu,'(a,f14.7,a)')  ' jbsl = ',jbsl/cp_air,' K'
       write (dpu,'(a,f14.7,a)')  ' jbqt = ',jbqt*1000.,' g/kg'
       write (dpu,'(a,f14.7,a)')  ' jbbu = ',jbbu,' m/s2'
       write (dpu,'(a,f14.7,a)')  ' jbumin = ',jbumin,' m/s2'
       write (dpu,'(a,f14.7,a)')  ' jbu = ',jbu,' m/s'
       write (dpu,'(a,f14.7,a)')  ' jbv = ',jbv,' m/s'
       write (dpu,'(a,f14.7,a)')  ' ch  = ',ch*cp_air, ' m/K/s2'
       write (dpu,'(a,f14.7,a)')  ' cm  = ',cm, ' m/s2'
       write (dpu,'(a,f14.7,a)')  ' sqrt(n2h) = ',n2h*            &
                                    sqrt(abs(n2h))*3600./abs(n2h),' 1/sec'
       write (dpu,'(a,f14.7,a)')  ' vyb = ', vyb
       write (dpu,'(a,f14.7,a)')  ' vub = ', vub
       write (dpu,'(a)')  ' '
     end if
    
     !-----------------------------------------------------------
     ! Calculate jumps at the upper inversion
     ! Note the check to force jtbu to be greater than or equal
     ! to jbumin.

     jtzm = zm(kt-1) - zm(kt)
     jtsl = sl(kt-1) - sl(kt)
     jtqt = qt(kt-1) - qt(kt)
     jtbu = n2(kt)   * jtzm 
     jtbu = max(jtbu,jbumin)
     jtu  = u(kt-1) - u(kt)
     jtv  = v(kt-1) - v(kt)
     ch   = (1 -sfuh(kt))*chu(kt) + sfuh(kt)*chs(kt)
     cm   = (1 -sfuh(kt))*cmu(kt) + sfuh(kt)*cms(kt)
     n2h  = (ch*jtsl + cm*jtqt)/jtzm
            
     ! Ratio of buoy flux to w'(b_l)'
     vys  = n2h*jtzm/jtbu 
            
     ! Inverse of shear prodution divided by buoyancy production
     vus  = min(1.,(jtu**2+jtv**2)/(jtbu*jtzm)) 
            
     if (column_match) then
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' jumps at upper inversion '
       write (dpu,'(a)')  ' ------------------------ '
       write (dpu,'(a)')  ' '
       write (dpu,'(a,i3)')  ' inversion half level = ',kt
       write (dpu,'(a,f14.7,a)')  ' jtzm = ',jtzm,' m'
       write (dpu,'(a,f14.7,a)')  ' jtsl = ',jtsl/cp_air,' K'
       write (dpu,'(a,f14.7,a)')  ' jtqt = ',jtqt*1000.,' g/kg'
       write (dpu,'(a,f14.7,a)')  ' jtbu = ',jtbu,' m/s2'
       write (dpu,'(a,f14.7,a)')  ' jbumin = ',jbumin,' m/s2'
       write (dpu,'(a,f14.7,a)')  ' jtu = ',jtu,' m/s'
       write (dpu,'(a,f14.7,a)')  ' jtv = ',jtv,' m/s'
       write (dpu,'(a,f14.7,a)')  ' ch  = ',ch*cp_air, ' m/K/s2'
       write (dpu,'(a,f14.7,a)')  ' cm  = ',cm, ' m/s2'
       write (dpu,'(a,f14.7,a)')  ' sqrt(n2h) = ',n2h*            &
                                    sqrt(abs(n2h))*3600./abs(n2h),' 1/sec'
       write (dpu,'(a,f14.7,a)')  ' vys = ', vys
       write (dpu,'(a,f14.7,a)')  ' vus = ', vus
       write (dpu,'(a)')  ' '
     end if
        
     !-----------------------------------------------------------
     ! 
     ! Calculate evaporative entrainment enhancement factor evhc. 
     ! We take the full inversion strength to be jt2slv, where
     ! jt2slv = slv(kt-2)  - slv(kt), and kt - 1 is in the 
     ! ambiguous layer.  However, for a cloud-topped CL overlain
     ! by another convective layer, it is possible that 
     ! slv(kt-2) < slv(kt). To avoid negative or excessive evhc, 
     ! we lower-bound jt2slv and upper-bound evhc.

     evhc = 1.
     cloudtop  = .false. 
     if (ql(kt)  .gt. qcminfrac*qsl(kt)   .and. use_qcmin .and. &
         ql(kt-1).lt. qcminfrac*qsl(kt-1))       cloudtop= .true.
     if (.not.use_qcmin .and. qa(kt).gt.qa(kt-1))cloudtop= .true.
    
     if (cloudtop) then 
       if (use_qcmin) then
         tmpfrac = 1.
       else
         tmpfrac = 1. - (qa(kt-1)/qa(kt))
       end if     
       jt2slv = slv(max(kt-2,1)) - slv(kt)
       jt2slv = max(jt2slv, jbumin*slv(kt-1)/grav)
       if (use_extrapolated_ql) then
         evhc = 1.+tmpfrac*a2l*a3l*hleff(kt)*qltop(kt)/ &
                jt2slv
       else
         evhc = 1.+tmpfrac*a2l*a3l*hleff(kt)*ql(kt)   / &
                jt2slv
       end if
       evhc   = min(evhc,evhcmax)
       evhcvec(kt) = evhc
     end if

     if (column_match) then
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' computing entrainment enhancem'//&
                          'ent factor '
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' ' 
       write (dpu,'(a,f14.7,a)')  ' slv(max(kt-2,1))/cp_air =  ',&
                                    slv(max(kt-2,1))/cp_air,' K'
       write (dpu,'(a,f14.7,a)')  ' slv(kt)/cp_air =  ', slv(kt)/&
                                    cp_air,' K'
       write (dpu,'(a,f14.7,a)')  ' jt2slv(kt)/cp_air =  ',jt2slv&
                                   /cp_air,' K'
       write (dpu,'(a,f14.7,a)')  ' ql(kt-1) = ',ql(kt-1)*   &
                                    1000.,' g/kg'
       write (dpu,'(a,f14.7,a)')  ' ql(kt) = ',ql(kt)*1000., &
                                  ' g/kg'
       write (dpu,'(a,f14.7,a)')  ' qltop(kt) = ',qltop(kt)* &
                                    1000.,' g/kg'
       write (dpu,'(a,f14.7,a)')  ' qa(kt-1) = ',qa(kt-1)
       write (dpu,'(a,f14.7,a)')  ' qa(kt) = ',  qa(kt)                    
       write (dpu,'(a,f14.7,a)')  ' evhc = ',evhc
     end if
    
     !-----------------------------------------------------------
     ! 
     ! Radiative forcing at the upper inversion if at a cloud top

     if (cloudtop) then
     
     !------------------------------------------------------
     !  estimate longwave opt depth in layer kt

       lwp = ql(kt) * (pi(kt+1) - pi(kt)) / grav
       opt_depth = 156*lwp

     !------------------------------------------------------
     ! Approximation to LW cooling frac at inversion
     ! The following formula is a polynomial approximation
     ! to exact solution which is
     ! radinvfrac = 1 - 2/opt_depth + 2/(exp(opt_depth)-1))
 
       radinvfrac  = opt_depth*(4.+opt_depth) / &
                     (6.*(4.+opt_depth) + opt_depth**2)

     !------------------------------------------------------
     ! units of radf = (m*m)/(s*s*s)
       radf = max(-radinvfrac*qrl(kt)*(zi(kt)-zi(kt+1)),0.)* &
              cp_air * chs(kt)

     else
       lwp        = 0.
       opt_depth  = 0.
       radinvfrac = 0.
       radf       = 0.
     end if

     !-----------------------------------------------------------
     ! 
     ! Solve cubic equation
     !   r^3 + trmp*r + trmq = 0,   r = sqrt<e>
     ! to estimate <e> for multilayer convection. Note, that if 
     ! the CL goes to the surface, vyb and vub are zero, and ebrk
     ! and lbrk have already incorporated the surface interfacial
     ! layer, so the formulas below still apply.  For a SRCL, 
     ! there are no interior interfaces so ebrk = lbrk = 0.
     ! The cases are:
     !    (1) no cloudtop cooling (radf=0) -- trmq = 0, 
     !        r = sqrt(-trmp)
     !    (2) radf > 0 but no interior CL interface -- trmp = 0, 
     !        trmq < 0
     !    (3) radf > 0 and interior CL interface(s) -- trmp < 0, 
     !        trmq < 0

     trma = 1. - (b1*a1l/lbulk)*(evhc*(-vys+vus)*(zi(kt)-zm(kt))& 
            +  (-vyb+vub)*(zm(kb-1)-zi(kb)) )
     trma = max(trma,0.5)  ! Prevents runaway entrainment instab.
     trmp = -ebrk(ncv) *(lbrk(ncv)/lbulk)/trma
     trmq = -b1*radf*(leng(kt)/lbulk)*(zi(kt)-zm(kt))/trma

     qq = (trmp/3.)**3+(trmq/2.)**2
     if (trmq .lt. 0.) then
       if (qq .gt. 0.) then 
         rootp = (-trmq/2.+sqrt(qq))**(1./3.)
         if (trmp .lt. 0.) then       
         !--------------------------------------------
         ! case 3 (in case 2, added term is zero)
           rootp = rootp  + (-trmq/2.-sqrt(qq))**(1./3.)
         end if
       else  
       !-------------------------------------------------
       ! also part of case 3
         angle = acos(-trmq/2./sqrt(-(trmp/3)**3))
         rootp = 2.*sqrt(-trmp/3.)*cos(angle/3.)
       end if
     else
     !------------------------------------------------------
     !  case 1: radf = 0, so trmq = 0
       rootp = sqrt(-trmp)
     endif
          
     if (column_match) then
       write (dpu,'(a,f14.7)')  ' trma = ',trma
       write (dpu,'(a,f14.7,a)')  ' trmp = ',trmp,' m2/s2'
       write (dpu,'(a,f14.7,a)')  ' trmq = ',trmq,' m3/s3'
       write (dpu,'(a,f14.7,a)')  ' qq   = ',  qq,' m6/s6'
       write (dpu,'(a,f14.7)')  ' b1   = ', b1
       write (dpu,'(a,f14.7)')  ' a1l  = ', a1l
       write (dpu,'(a,f14.7)')  ' vys  = ', vys
       write (dpu,'(a,f14.7)')  ' vus  = ', vus
       write (dpu,'(a,f14.7)')  ' vyb  = ', vyb
       write (dpu,'(a,f14.7)')  ' vub  = ', vub
       write (dpu,'(a,f14.7,a)') ' cwp  = ', 1000.*lwp,     &
                                 ' g/m2'
       write (dpu,'(a,f14.7)')  ' opt_depth  = ', opt_depth
       write (dpu,'(a,f14.7)')  ' radinvfrac = ',radinvfrac
       write (dpu,'(a,f14.7,a)')  ' radf = ', radf,' m2/s3' 
     end if
    
     !-----------------------------------------------------------
     ! limit CL-avg TKE used for entrainment
    
     ebrk(ncv) = rootp**2    
     ebrk(ncv) = max(min(ebrk(ncv),tkemax),tkemin) 
     wbrk(ncv) = ebrk(ncv)/b1

     if (column_match) then
       write (dpu,'(a,f14.7,a)')  ' rootp**2 = ',  rootp**2, ' m2/s2'
       write (dpu,'(a,f14.7,a)')  ' ebrk     = ', ebrk(ncv), ' m2/s2'
       write (dpu,'(a,f14.7,a)')  ' wbrk     = ', wbrk(ncv), ' m2/s2'
     end if
     
    !-----------------------------------------------------------
    ! ebrk should be greater than zero so if it is not a FATAL
    ! call is implemented

     if (ebrk(ncv) .eq. 0.) then
       call error_mesg ('edt_mod', &
                        'convective layer average tke = 0',  FATAL)
     end if
    
    !-----------------------------------------------------------
    ! Compute adjustment time for layer equal to lbulk / <e>
    ! Should this be divided by "c" = b1/mu, which for
    ! default value = 5.8/70 = 0.083
    
     do k = kb, kt, -1
       adj_time_inv(k) = sqrt(ebrk(ncv))/lbulk
     enddo
    
    !-----------------------------------------------------------
    ! We approximate TKE = <e> at entrainment interfaces con-
    ! sistent with entrainment closure.
            
     rcap(kt) = 1.   
     rcap(kb) = 1.   

    !-----------------------------------------------------------
    ! Calculate ratio rcap = e/<e> in convective layer interior. 
    ! Bound it by limits rmin = 0.1 to rmax = 2.0 to take care 
    ! of some pathological cases.

     if ((kb-kt).gt.1) then
       do k = kb-1, kt+1, -1
         rcap(k) = (mu*leng(k)/lbulk + wcap(k)/wbrk(ncv)) /    &
                   (mu*leng(k)/lbulk + 1.               )
         rcap(k) = min(max(rcap(k),rmin), rmax)
       end do
     end if
    
    !-----------------------------------------------------------
    ! Compute TKE throughout CL, and bound by tkemin & tkemax.
    !
    ! Question by Steve Klein:
    !
    ! Does tke(kb) properly account if kb is the top interface
    ! of another convective layer? 
    !
    
     do k = kb, kt, -1
       tke(k) = max(min(ebrk(ncv)*rcap(k),tkemax),tkemin) 
     end do 
                        
    !-----------------------------------------------------------
    ! Compute CL interior diffusivities, buoyancy and shear 
    ! production
    
     if ((kb-kt).gt.1) then

       do k = kb-1, kt+1, -1

         kvh(k)        = leng(k)*sqrt(tke(k))*shcl(ncv)
         kvm(k)        = leng(k)*sqrt(tke(k))*smcl(ncv)
         bprod(k)      = - kvh(k)*n2(k)
         sprod(k)      =   kvm(k)*s2(k)
         trans(k)      = mu*(ebrk(ncv)-tke(k))*           &
                         adj_time_inv(k)/b1 
         diss(k)       = sqrt(tke(k)*tke(k)*tke(k))/b1/   &
                         leng(k)
         shvec(k)      = shcl(ncv)
         smvec(k)      = smcl(ncv)
         ghvec(k)      = ghcl(ncv)

         turbtype(2,k) = 1
         isturb(k)     = 1.
         isturb(k-1)   = 1.
  
      !-------------------------------------------------
      ! compute sdevs
      ! 
      ! The approximation used is that qt and qs(Tl) are 
      ! correlated with strength kappa. The sign of the 
      ! correlation is positive if the vertical 
      ! gradients to qt and sli are of the same sign, 
      ! and negative otherwise.
 
         if (k .eq. kdim+1) call error_mesg ('edt_mod',   &
              'trying to compute sdevs at the surface',   &
                            FATAL)
         if (k .eq. 1)  call error_mesg ('edt_mod',       &
              'trying to compute sdevs at the model top', &
                            FATAL)
     
         qtsltmp    = (qt(k-1) - qt(k))/(zm(k-1) - zm(k))
         slsltmp    = (sl(k-1) - sl(k))/(zm(k-1) - zm(k))  
         qsltmp     = 0.5 * ( qsl    (k-1) + qsl    (k) )
         dqsldtltmp = 0.5 * ( dqsldtl(k-1) + dqsldtl(k) )   
         hlefftmp   = 0.5 * ( hleff  (k-1) + hleff  (k) )

         sdevs(k) = ( (mesovar*qsltmp)**2.0) +            &
                    ( ( (kvh(k)/sqrt(tke(k))) *           &
                    (qtsltmp-(kappa*slsltmp*dqsldtltmp/cp_air)))**2.0)
         sdevs(k) = sqrt(sdevs(k)) /                      &
                    (1.+hlefftmp*dqsldtltmp/cp_air)   

         if (column_match) then
           write (dpu,'(a)')  ' ' 
           write (dpu,'(a)')  ' ' 
           write (dpu,'(a,i4)')  ' sigmas for level ',k
           write (dpu,'(a)')  ' ' 
           write (dpu,'(a,f14.7,a)')  ' sigmas = ', 1000.*  &
                                        sdevs(k), ' g/kg'
           write (dpu,'(a,f14.7)')  ' acoef = ', 1. /       &
                                     ( 1. + hlefftmp*dqsldtltmp/cp_air )
           write (dpu,'(a,f14.7,a)')  ' sigmas/a = ',       &
                                        1000.*sdevs(k)*(1. +hlefftmp*dqsldtltmp/cp_air),&
                                      ' g/kg'
           write (dpu,'(a,f14.7)'  )  ' mesovar = ', mesovar
           write (dpu,'(a,f14.7,a)')  ' mesovar*qsl = ',    &
                                        mesovar*qsltmp*1000.,' g/kg'
           write (dpu,'(a,f14.7,a)')  ' turb.fluct = ',1000.&
                                      *(kvh(k)/sqrt(tke(k)))*(qtsltmp-            &
                                       (kappa*slsltmp*dqsldtltmp/cp_air)) ,' g/kg'
           write (dpu,'(a,f14.7,a)')  ' (kvh/sqrt(tke))* '//&
                                      ' qtsltmp = ',1000.*(kvh(k)/sqrt(tke(k)))*  &
                                        qtsltmp ,' g/kg'
           write (dpu,'(a,f14.7,a)')  ' (kvh/sqrt(tke))* '//&
                                      ' (kappa*slsltmp*dqsldtltmp/cp_air) = ',1000.*  &
                                        (kvh(k)/sqrt(tke(k)))*(kappa*slsltmp*       &
                                         dqsldtltmp/cp_air) ,' g/kg'
           write (dpu,'(a)')  ' '
           write (dpu,'(a)')  ' '
         end if
 
       end do
    
    
       !------------------------------------------------------
       !
       ! set sdevs at kt and kb equal to kt+1 and kb-1 values 
       ! respectively
       !
   
       sdevs(kt) = sdevs(kt+1)
       sdevs(kb) = sdevs(kb-1)

     end if

     !-----------------------------------------------------------
     ! Compute diffusivity we*dz and some diagnostics at the 
     ! upper inversion. Limit entrainment rate below the free 
     ! entrainment limit a1l * sqrt(e)

     kentr          = jtzm * a1l * sqrt(ebrk(ncv)) * &
                      min(evhc * ebrk(ncv)/(jtbu*leng(kt)),1.)
     kvh(kt)        = kentr
     kvm(kt)        = kentr
     bprod(kt)      = -kentr*n2h+radf
     sprod(kt)      =  kentr*s2(kt)
     trans(kt)      = mu*(ebrk(ncv)-tke(kt))*adj_time_inv(kt)/b1
     diss(kt)       = sqrt(tke(kt)*tke(kt)*tke(kt))/b1/leng(kt)
     radfvec(kt)    = radf
     turbtype(4,kt) = 1
     isturb(kt)     = 1.
    
     !-----------------------------------------------------------
     ! set isturb to 1 in the ambiguous layer
    
     isturb(kt-1) = 1.

     if (column_match) then
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' at upper inversion: '
       write (dpu,'(a,f14.7,a)')  ' kentr = ', kentr, ' m2/s'
       write (dpu,'(a,f14.7)')  ' mu    = ', mu
       write (dpu,'(a,f14.7,a)')  ' 1/adj_time_inv = ',           &
                                    1./adj_time_inv(kt), ' sec'
       write (dpu,'(a)')  ' '
     end if
      
     !-----------------------------------------------------------
     ! compute sdevs at CL top
     !
     ! FOR SOME REASON THIS DERIVATION DOES NOT WORK
     !
     ! note that a water perturbation q* and buoyancy 
     ! perturbation b* are computed from the below equations:
     !
     !      q*   =    (w'qt') / sqrt(tke)
     !           =   - kentr * (dqt/dz) / sqrt(tke)
     !
     !      b*   =    (w'b')  / sqrt(tke)
     !           =    bprod   / sqrt(tke)
     !
     !
            
     qtsltmp     = (qt(kt-1) - qt(kt))/(zm(kt-1) - zm(kt)) 
     qstartmp    =  - kentr * qtsltmp / sqrt(tke(kt))
     bstartmp    =    bprod(kt)       / sqrt(tke(kt)) 
     temperature = pm(kt)/density(kt)/rdgas
    
     !sdevs(kt)   =  ((mesovar*qsl(kt))**2.0) +       &
     !     ((qstartmp-dqsldtl(kt)*bstartmp*temperature/grav)**2.0)
     !sdevs(kt) = sqrt(sdevs(kt))/(1.+hleff(kt)*dqsldtl(kt)/cp_air)
    
    
     if ((kb-kt).le.1) sdevs(kt) = mesovar*qsl(kt)/             &
                      (1.+hleff(kt)*dqsldtl(kt)/cp_air)
   

     if (column_match) then
       write (dpu,'(a)')  ' ' 
       write (dpu,'(a)')  ' ' 
       write (dpu,'(a,i4)')  ' sigmas at kt level # ',kt
       write (dpu,'(a)')  ' ' 
       write (dpu,'(a,f14.7,a)')  ' sigmas = ', 1000.*sdevs(kt),  &
                                  ' g/kg'
       write (dpu,'(a,f14.7)')    ' acoef = ', 1. /(1.+hleff(kt)* &
                                    dqsldtl(kt)/cp_air )                      
       write (dpu,'(a,f14.7,a)')  ' sigmas/a = ', 1000.*sdevs(kt)*&
                                  ( 1. + hleff(kt)*dqsldtl(kt)/cp_air ), ' g/kg'
       write (dpu,'(a,f14.7)'  )  ' mesovar = ', mesovar
       write (dpu,'(a,f14.7,a)')  ' mesovar*qsl = ',mesovar*      &
                                    qsl(kt)*1000.,' g/kg'
       write (dpu,'(a,f14.7,a)')  ' turb.fluct = ',1000.* &
                                   (qstartmp-dqsldtl(kt)*bstartmp*temperature/grav) ,    &
                                  ' g/kg'
       write (dpu,'(a,f14.7,a)')  ' temperature = ',temperature,  ' K'
       write (dpu,'(a,f14.7,a)')  ' qstartmp = ',1000.*qstartmp , ' g/kg'
       write (dpu,'(a,f14.7,a)')  ' bstartmp = ',bstartmp ,' m/s2'
       write (dpu,'(a,f14.7,a)')  ' jtbu = ',jtbu ,' m/s2'
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' '
     end if
                          
    !-----------------------------------------------------------
    ! Compute Kh, Km and some diagnostics at the lower inversion

     if (kb .lt. kdim+1) then 
          
       kentr        = jbzm * a1l * sqrt(ebrk(ncv)) * &
                                min(ebrk(ncv)/(jbbu*leng(kb)),1.)

    !------------------------------------------------------
    ! The addition of the previous value of kvh and khm 
    ! handles the case of 2 CLs entraining into each other
       kvh(kb)      = kentr + kvh(kb)   
       kvm(kb)      = kentr + kvm(kb)   
 
       bprod(kb)    = bprod(kb) - kvh(kb)*n2(kb)
       sprod(kb)    = sprod(kb) + kvm(kb)*s2(kb)
       trans(kb)    = trans(kb) + mu*(ebrk(ncv)-tke(kb))*    &
                      adj_time_inv(kb)/b1
       diss(kb)     = diss(kb)+sqrt(tke(kb)*tke(kb)*tke(kb)) &
                      /b1/leng(kb)
       turbtype(3,kb) = 1
       isturb(kb-1)   = 1.

    !------------------------------------------------------
    ! set isturb to 1 in the ambiguous layer
         
       isturb(kb) = 1.

       if (column_match) then
         write (dpu,'(a)')  ' '
         write (dpu,'(a)')  ' at lower inversion: '
         write (dpu,'(a,f14.7,a)')  ' kentr = ', kentr, ' m2/s'
         write (dpu,'(a,f14.7)')  ' mu    = ', mu
         write (dpu,'(a,f14.7,a)')  ' adj_time_inv = ',        &
                                      1./adj_time_inv(kb), ' sec'
         write (dpu,'(a)')  ' '
       end if
    
    !------------------------------------------------------
    ! compute sdevs at CL bottom
    !
    ! note that same formulas are used here as for CL top
   
       qtsltmp     = (qt(kb-1) - qt(kb))/(zm(kb-1) - zm(kb)) 
       qstartmp    =  - kentr * qtsltmp / sqrt(tke(kb))
       bstartmp    =    bprod(kb)       / sqrt(tke(kb)) 
       temperature = pm(kb-1)/density(kb-1)/rdgas
 
         !sdevs(kb)   = ((mesovar*qsl(kb-1))**2.0) + ((qstartmp-&
 !              dqsldtl(kb-1)*bstartmp*temperature/grav)&
 !       **2.0)
                 !sdevs(kb)   = sqrt(sdevs(kb))/(1.+hleff(kb-1)*        &
 !                               dqsldtl(kb-1)/cp_air)
                         
       if ((kb-kt).le.1) sdevs(kb) = mesovar*qsl(kb-1)/       &
                                     (1.+hleff(kb-1)*dqsldtl(kb-1)/cp_air)

       if (column_match) then
         write (dpu,'(a)')  ' ' 
         write (dpu,'(a)')  ' ' 
         write (dpu,'(a,i5)')  ' sigmas at lower inversion l'//&
                               'evel # ',kb
         write (dpu,'(a)')  ' ' 
         write (dpu,'(a,f14.7,a)')  ' sigmas = ', 1000.*       &
                                      sdevs(kb), ' g/kg'
         write (dpu,'(a,f14.7)  ')  ' acoef = ', 1. /(1.+      &
                                      hleff(kb-1)*dqsldtl(kb-1)/cp_air )                         
         write (dpu,'(a,f14.7,a)')  ' sigmas/a = ', 1000.*     &
                                      sdevs(kb)*( 1. + hleff(kb-1)*dqsldtl(kb-1)/cp_air ), &
                                    ' g/kg'
         write (dpu,'(a,f14.7)'  )  ' mesovar = ', mesovar
         write (dpu,'(a,f14.7,a)')  ' mesovar*qsl = ',mesovar* &
                                      qsl(kb-1)*1000.,' g/kg'
         write (dpu,'(a,f14.7,a)')  ' turb.fluct = ',1000.*    &
                                     (qstartmp-dqsldtl(kb-1)*bstartmp*temperature/    &
                                      grav) , ' g/kg'
         write (dpu,'(a,f14.7,a)')  ' temperature = ',         &
                                      temperature,' K'
         write (dpu,'(a,f14.7,a)')  ' qstartmp = ',1000.*      &
                                      qstartmp ,' g/kg'
         write (dpu,'(a,f14.7,a)')  ' bstartmp = ',bstartmp ,  ' m/s2'
         write (dpu,'(a,f14.7,a)')  ' jbbu = ',jbbu ,' m/s2'
         write (dpu,'(a)')  ' '
         write (dpu,'(a)')  ' '
       end if

     end if

    !-----------------------------------------------------------
    ! put minimum threshold on TKE to prevent possible division 
    ! by zero.

     if (kb .lt. kdim+1) then
       wcap(kb) = bprod(kb)*leng(kb)/sqrt(max(tke(kb),tkemin))
     else
       wcap(kb) = tkes / b1
     end if
     wcap(kt) = bprod(kt)*leng(kt) / sqrt(max(tke(kt),tkemin))

     if (column_match) then
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  'k     leng     rcap     wcap      tk'//&
            'e'
       write (dpu,'(a)')  '      (m)              (m2/s2)   (m2'//&
            '/s2)'
       write (dpu,'(a)')  '------------------------------------'//&
            '----'
       write (dpu,'(a)')  ' '
       do k = kb,kt,-1
         write(dpu,34) k,leng(k),rcap(k),wcap(k),tke(k)
       enddo  
34     format(1X,i2,1X,4(f8.4,1X))
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' k     kvh      kvm      bprod      '//&
            '  sprod         trans         diss'
       write (dpu,'(a)')  '      (m2/s)   (m2/s)   (m2/s3)     '//&
            ' (m2/s3)       (m2/s3)      (m2/s3)'
       write (dpu,'(a)')  '------------------------------------'//&
            '-------------------------------------'
       write (dpu,'(a)')  ' '
       do k = kb,kt,-1
         write(dpu,35) k,kvh(k),kvm(k),bprod(k),sprod(k),trans(k),  &
         diss(k)
       enddo  
35     format(1X,i2,1X,2(f8.4,1X),4(f12.9,1X))
       write (dpu,'(a)')  ' '
       write (dpu,'(a)')  ' '
     end if
                 
  !----------------------------------------------------------------
  ! End big loop over ncv
 
   end do      

!-----------------------------------------------------------------------
!
!      If the lowest CL reaches the surface, define the PBL 
!      depth as the CL top.
!
   if (ncvsurf .gt. 0) then
     pblh   = zi(ktop(ncvsurf))
     if(bflxs.ge.0.) then
       turbtype(2,kdim+1) = 1
     else
       turbtype(3,kdim+1) = 1
     end if
   else
     pblh = 0.
   end if
                        
       
!-----------------------------------------------------------------------
!
!      STABLE TURBULENT LAYERS
!

!----------------------------------------------------------------
! find turbulent lengthscales in all stable turbulent layers

   belongst(1) = .false.   ! k = 1 assumed nonturbulent
       
   any_stable  = .false.
       
   do k = 2, kdim
         
     belongst(k)  = (ri(k) .lt. ricrit) .and. (.not. belongcv(k))
     if (belongst(k)) any_stable = .true.
     if (belongst(k) .and. (.not.belongst(k-1)) ) then
       kt    = k     ! Top of stable turb layer
     else if (.not. belongst(k) .and. belongst(k-1)) then
       kb    = k-1   ! Base of stable turb layer
       lbulk = zm(kt-1) - zm(kb)
       do ks = kt, kb
         leng(ks)=lengthscale(zi(ks),lbulk)
         adj_time_inv(ks) = 1. / lbulk
       end do
     end if
  
   end do ! k

   !----------------------------------------------------------------
   ! Now look whether stable turb layer extends to ground. Note that 
   ! interface kdim+1 is assumed to always be stable-turbulent if it 
   ! is not convective. Note that if it is convective, kdim will 
   ! also be convective, so the above loop will have finished 
   ! finding all elevated turbulent layers.

   belongst(kdim+1) = .not. belongcv(kdim+1)
   
   if (belongst(kdim+1)) then  
   
     turbtype(1,kdim+1) = 1
     if (belongst(kdim)) then
     !------------------------------------------------------
     ! surface stable layer includes interior stable turb-
     ! ulent interface kt already defined above. Note that
     ! zm(kb) = 0.
       lbulk = zm(kt-1)     
     else                     
     !------------------------------------------------------
     ! surface stable BL with no interior turbulence            
       kt = kdim+1 
     end if
     lbulk  = zm(kt-1)
     pblh   = lbulk   ! PBL Height <-> lowest stable turb. layer            
     do ks = kt,kdim+1
       leng(ks) = lengthscale(zi(ks),lbulk)
       adj_time_inv(ks) = 1./ lbulk
     end do 
     adj_time_inv(kdim+1) = adj_time_inv(kdim+1)*sqrt(tkes)
   end if  ! for belongst if

   !----------------------------------------------------------------
   ! Calculate tke, kvh, kvm

   if (column_match .and. any_stable) then
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' STABLE LAYERS '
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' k     kvh      kvm      leng      t'//&
                        'ke      bprod        sprod        diss'
     write (dpu,'(a)')  '      (m2/s)    (m2/s)    (m)    (m2'//&
                        '/s2)   (m2/s3)      (m2/s3)      (m2/s3) '
     write (dpu,'(a)')  '------------------------------------'//&
                        '-----------------------------------------'
     write (dpu,'(a)')  ' '            
   end if

   do k = 2, kdim
     if (belongst(k)) then    
       turbtype(1,k) = 1
       isturb(k)     = 1.
       isturb(k-1)   = 1.
       call galperin(ri(k),gh,ckh,ckm)
 
 ! note that original cb code did not limit the maximum
 ! gh to 0.0233 so that we should check that if the  
 ! limiter was invoked
!!RSH drop this fail for now (maybe ok during early spinup ?? )
!                  if (gh .eq. 0.0233) call error_mesg ('edt_mod',&
!                    'galperin stability fn = 0.0233',&
!                                      FATAL)
       
                 ! ri(k) should be less than ricrit     
       if (ri(k) .gt. ricrit) call error_mesg ('edt_mod',&
                                  'ri(k) > ricrit, but belongst(k) = T',FATAL)
 
       tke(k) = b1*(leng(k)**2)*(-ckh*n2(k)+ckm*s2(k))
       tke(k) = max(min(tke(k),tkemax),tkemin)
       kvh(k) = leng(k) * sqrt(tke(k)) * ckh
       kvm(k) = leng(k) * sqrt(tke(k)) * ckm
       bprod(k)  = - kvh(k)*n2(k)
       sprod(k)  =   kvm(k)*s2(k)
       diss (k)  = sqrt(tke(k)*tke(k)*tke(k))/b1/leng(k)
       adj_time_inv(k) = adj_time_inv(k)*sqrt(tke(k))
       shvec(k)  = ckh
       smvec(k)  = ckm
       ghvec(k)  = gh
   
       if (column_match) then         
         write(dpu,37) k,kvh(k),kvm(k),leng(k),tke(k),bprod(k),&
                      sprod(k),diss(k)
37       format(1X,i2,1X,3(f8.4,1X),4(f12.9,1X))
       end if

                 !------------------------------------------------------
 ! compute sdevs 
 ! (note same formulas as used in CL calculations)
 ! 

       if (k .eq. kdim+1)  call error_mesg ('edt_mod',       &
                          'trying to compute sdevs at the surface', FATAL)
       if (k .eq. 1)       call error_mesg ('edt_mod',       &
                          'trying to compute sdevs at the model top', FATAL)
     
       qtsltmp    = (qt(k-1) - qt(k))/(zm(k-1) - zm(k))
       slsltmp    = (sl(k-1) - sl(k))/(zm(k-1) - zm(k))  
       qsltmp     = 0.5 * ( qsl    (k-1) + qsl    (k) )
       dqsldtltmp = 0.5 * ( dqsldtl(k-1) + dqsldtl(k) )   
       hlefftmp   = 0.5 * ( hleff  (k-1) + hleff  (k) )
     
       sdevs(k) = ( (mesovar*qsltmp)**2.0) +                 &
                  ( (  (kvh(k)/sqrt(tke(k))) *               &
                  (qtsltmp-(kappa*slsltmp*dqsldtltmp/cp_air)) )&
                   **2.0) 
       sdevs(k) = sqrt(sdevs(k)) / (1.+hlefftmp*dqsldtltmp/cp_air)   

       if (column_match) then
         write (dpu,'(a)')  ' ' 
         write (dpu,'(a)')  ' ' 
         write (dpu,'(a)')  ' sigmas  .... '
         write (dpu,'(a)')  ' ' 
         write (dpu,'(a,f14.7,a)')  ' sigmas = ',1000.*sdevs(k), ' g/kg'
         write (dpu,'(a,f14.7)  ')  ' acoef = ', 1. / ( 1. +   &
                                      hlefftmp*dqsldtltmp/cp_air )
         write (dpu,'(a,f14.7,a)')  ' sigmas/a = ', 1000.*     &
                                      sdevs(k)* ( 1. + hlefftmp*dqsldtltmp/cp_air ), ' g/kg'
         write (dpu,'(a,f14.7)'  )  ' mesovar = ', mesovar
         write (dpu,'(a,f14.7,a)')  ' mesovar*qsl = ',mesovar* &
                                      qsltmp*1000.,' g/kg'
         write (dpu,'(a,f14.7,a)')  ' turb.fluct = ',1000.*    &
                                     (kvh(k)/sqrt(tke(k)))*(qtsltmp-(kappa*slsltmp*   &
                                      dqsldtltmp/cp_air)) ,' g/kg'
         write (dpu,'(a,f14.7,a)')  ' (kvh/sqrt(tke))*qtsltm'//&
                                    'p = ',1000.*(kvh(k)/sqrt(tke(k)))*qtsltmp ,' g/kg'
         write (dpu,'(a,f14.7,a)')  ' (kvh/sqrt(tke))*(kappa'//&
                                    '*slsltmp*dqsldtltmp/cp_air) = ',1000.*(kvh(k)/sqrt  &
                                    (tke(k)))*(kappa*slsltmp*dqsldtltmp/cp_air),' g/kg'
         write (dpu,'(a)')  ' '
         write (dpu,'(a)')  ' '
       end if
  

     end if  ! belongs to stable layer
            
   end do  ! k loop

!-----------------------------------------------------------------------
! 
!      set tke at surface equal to diagnostic variable tkes

   tke(kdim+1) = tkes

   if (column_match) then
     write (dpu,'(a)')  ' '
     write (dpu,'(a,f14.7,a)')  ' pblh = ', pblh, ' m'
     write (dpu,'(a,f14.7,a)')  ' tkes = ', tkes, ' m2/s2'
     write (dpu,'(a)')  ' '
     do k = kdim-n_print_levels,kdim
       write (dpu,'(a,i4,a,f14.7)') 'k = ',k,'; isturb =',isturb(k)
     enddo
     write (dpu,'(a)')  ' '
   end if
       
!-----------------------------------------------------------------------
! 
!      subroutine end
!

end subroutine caleddy

!
!======================================================================= 


!======================================================================= 
!
!      subroutine galperin
!        
      
subroutine galperin(ricl,gh,sh,sm)
        
!
!-----------------------------------------------------------------------
!
!      Given a Richardson number ricl, return the stability functions
!      sh and sm calculated according Galperin (1982).
!
!----------------------------------------------------------------------- 
!----------------------------------------------------------------------- 
!
!
  
real, intent(in)  :: ricl
real, intent(out) :: gh, sh, sm
  
! internal variables

real              :: ri, trma, trmb, trmc, det

!-----------------------------------------------------------------------
!
!      code
!

   ri   = min(ricl,0.163)
   trma = alph3*alph4*ri+2.*b1*(alph2-alph4*alph5*ri)
   trmb = ri*(alph3+alph4)+2.*b1*(-alph5*ri+alph1)
   trmc = ri
   det = max(trmb*trmb-4.*trma*trmc,0.)
   gh = (-trmb + sqrt(det))/2./trma
   gh = max(gh,-0.28)
   gh = min(gh,0.0233)
   sh = alph5 / (1.+alph3*gh)
   sm = (alph1 + alph2*gh)/(1.+alph3*gh)/(1.+alph4*gh)
          
!-----------------------------------------------------------------------
! 
!      subroutine end
!

end subroutine galperin

!
!======================================================================= 


!======================================================================= 
!
!      function lengthscale
!        
      
function lengthscale(height,depth)
        
!
!-----------------------------------------------------------------------
!
!  Calculate the turbulent length scale given the depth of the
!  turbulent layer.  Near the surface, the lengthscale asymptotes
!  to vonkarm*height.
!
!----------------------------------------------------------------------- 
!----------------------------------------------------------------------- 
!
!
 
real              :: lengthscale 
real, intent(in)  :: height,depth

!-----------------------------------------------------------------------
!
!  code
!

   lengthscale = vonkarm*height/(1.+(vonkarm*height/(tunl*depth)))       
          
!-----------------------------------------------------------------------
! 
!      function end
!

end function lengthscale

!
!=======================================================================

!======================================================================= 
!
!  subroutine gaussian_cloud
!    
!
!  this subroutine computes a new cloud fraction and cloud conden-
!  sate using the Gaussian cloud modell of Mellor (1977) and
!  Sommeria and Deardorff (1977). 
!    
!  In this derivation a background mesoscale variability to total
!  water variability equivalent to a fraction, mesovar, of qsl is 
!  assumed.
!

subroutine gaussian_cloud (qxtop, qxmid, qxbot, acoef, sigmasf, qalyr, &
                           qclyr, sfuh,  sflh)
 
!-----------------------------------------------------------------------
!
!      variables
!
!      -----
!      input
!      -----
!
!      qxtop      saturation excess at the top of the layer 
!                 (kg wat/kg air)
!      qxmid      saturation excess at the midpoint of the layer 
!                 (kg wat/kg air)
!      qxbot      saturation excess at the bottom of the layer 
!                 (kg wat/kg air)
!      sigmasf    standardard devations of water perturbation s
!                 (kg water / kg air)
!      acoef      thermo coefficient = 1./(1.+ L*dqsdT/cp)
!
!      ------
!      output
!      ------
!
!      qalyr      layer mean cloud fraction  (fraction)
!      qclyr      layer mean cloud condensate (kg condensate/kg air)
!      sfuh       saturated fraction of the upper half of the layer
!      sflh       saturated fraction of the lower half of the layer                  
!
!      --------
!      internal
!      --------
!
!
!-----------------------------------------------------------------------

real,    intent(in) :: qxtop, qxmid, qxbot, acoef, sigmasf
real,    intent(out):: qalyr, qclyr, sfuh, sflh

real :: q1top,q1mid,q1bot,cftop,cfmid,cfbot,qctop,qcmid,qcbot
real :: qcuh,qclh

!-----------------------------------------------------------------------
!
!      initialize variables

   qalyr    = 0.0
   qclyr    = 0.0
   sfuh     = 0.0
   sflh     = 0.0
   q1top    = 0.0
   q1mid    = 0.0
   q1bot    = 0.0
   cftop    = 0.0
   cfmid    = 0.0
   cfbot    = 0.0
   qctop    = 0.0
   qcmid    = 0.0
   qcbot    = 0.0
   qcuh     = 0.0
   qclh     = 0.0

!-----------------------------------------------------------------------
!
!      compute cloud fraction and cloud condensate at layer top, 
!      midpoint and bottom

   q1top = acoef * qxtop / sigmasf 
   cftop = max ( 0.5 * ( 2. -  erfcc( q1top / sqrt(2.) ) ) , 0.0 )
   qctop = cftop * q1top + ( exp(-0.5*q1top*q1top) / sqrt(2*fpi) )
   qctop = sigmasf * max ( qctop, 0. )  
   
   q1mid = acoef * qxmid / sigmasf  
   cfmid = max ( 0.5 * ( 2. -  erfcc( q1mid / sqrt(2.) ) ) , 0.0 )
   qcmid = cfmid * q1mid + ( exp(-0.5*q1mid*q1mid) / sqrt(2*fpi) )
   qcmid = sigmasf * max ( qcmid, 0. )   
   
   q1bot = acoef * qxbot / sigmasf  
   cfbot = max ( 0.5 * ( 2. -  erfcc( q1bot / sqrt(2.) ) ) , 0.0 )
   qcbot = cfbot * q1bot + ( exp(-0.5*q1bot*q1bot) / sqrt(2*fpi) )
   qcbot = sigmasf * max ( qcbot, 0. ) 
   
   sfuh  = 0.5 * (cftop + cfmid)
   sflh  = 0.5 * (cfmid + cfbot)
   qcuh  = 0.5 * (qctop + qcmid)
   qclh  = 0.5 * (qcmid + qcbot)
   qalyr = 0.5 * ( sfuh + sflh )
   qclyr = 0.5 * ( qcuh + qclh )

   if (qalyr .lt. qcminfrac) then
     qalyr = 0.
     qclyr = 0.
   end if

   if (column_match) then

     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' ========================================'//&
                        '======= '
     write (dpu,'(a)')  '             GAUSSIAN CLOUD MODEL         '
     write (dpu,'(a)')  ' '
     write (dpu,'(a,f14.7,a)')  ' sigmas = ', 1000.*sigmasf, ' g/kg'
     write (dpu,'(a,f14.7)'  )  ' acoef  = ', acoef
     write (dpu,'(a,f14.7,a)')  ' qxtop = ', qxtop*1000.,' g/kg'
     write (dpu,'(a,f14.7)')    ' q1top = ', q1top
     write (dpu,'(a,f14.7)')    ' cftop = ', cftop
     write (dpu,'(a,f14.7,a)')  ' qctop = ', 1000.*qctop,' g/kg'
     write (dpu,'(a)')  ' '
     write (dpu,'(a,f14.7,a)')  ' qxmid = ', qxmid*1000.,' g/kg'
     write (dpu,'(a,f14.7)')    ' q1mid = ', q1mid
     write (dpu,'(a,f14.7)')    ' cfmid = ', cfmid
     write (dpu,'(a,f14.7,a)')  ' qcmid = ', 1000.*qcmid,' g/kg'
     write (dpu,'(a)')  ' '
     write (dpu,'(a,f14.7,a)')  ' qxbot = ', qxbot*1000.,' g/kg'
     write (dpu,'(a,f14.7)')    ' q1bot = ', q1bot
     write (dpu,'(a,f14.7)')    ' cfbot = ', cfbot
     write (dpu,'(a,f14.7,a)')  ' qcbot = ', 1000.*qcbot,' g/kg'
     write (dpu,'(a)')  ' '
     write (dpu,'(a,f14.7)')    ' sfuh = ', sfuh
     write (dpu,'(a,f14.7)')    ' sflh = ', sflh
     write (dpu,'(a,f14.7,a)')  ' qcuh = ', 1000.*qcuh, ' g/kg'
     write (dpu,'(a,f14.7,a)')  ' qclh = ', 1000.*qclh, ' g/kg'
     write (dpu,'(a)')  ' '
     write (dpu,'(a,f14.7)')    ' qalyr = ', qalyr
     write (dpu,'(a,f14.7,a)')  ' qclyr = ', 1000.*qclyr, ' g/kg'
     write (dpu,'(a)')  ' '
     write (dpu,'(a)')  ' '
   end if    
      
       
!-----------------------------------------------------------------------
! 
!      subroutine end
!

end subroutine gaussian_cloud

!
!======================================================================= 


!======================================================================= 
!
!  function erfcc
!        
      
function erfcc(x)
        
!
!-----------------------------------------------------------------------
!
!  This numerical recipes routine calculates the complementary
!  error function.
!
!----------------------------------------------------------------------- 
!----------------------------------------------------------------------- 
!
!
 
real :: erfcc
real, intent(in) :: x 
real :: t,z


!-----------------------------------------------------------------------
!
!  code
!

   z=abs(x)      
   t=1./(1.+0.5*z)
  
   erfcc=t*exp(-z*z-1.26551223+t*(1.00002368+t*(.37409196+t*       &
        (.09678418+t*(-.18628806+t*(.27886807+t*(-1.13520398+t*    &
        (1.48851587+t*(-.82215223+t*.17087277)))))))))
  
   if (x.lt.0.) erfcc=2.-erfcc
      
!-----------------------------------------------------------------------
! 
!  function end
!

end function erfcc

!
!=======================================================================

end module edt_mod

module cohort_io_mod

use fms_mod,          only : error_mesg, FATAL, WARNING
use mpp_mod,          only : mpp_pe, mpp_max, mpp_send, mpp_recv, mpp_sync, &
                             COMM_TAG_1, COMM_TAG_2
use nf_utils_mod,     only : nfu_inq_dim, nfu_get_var, nfu_put_var, &
     nfu_get_rec, nfu_put_rec, nfu_def_dim, nfu_def_var, nfu_put_att, &
     nfu_inq_var
use land_io_mod,      only : print_netcdf_error, input_buf_size
use land_tile_mod,    only : land_tile_type, land_tile_list_type, &
     land_tile_enum_type, first_elmt, tail_elmt, next_elmt, get_elmt_indices, &
     current_tile, operator(/=)
use land_tile_io_mod, only : get_tile_by_idx, sync_nc_files

use vegn_cohort_mod, only: vegn_cohort_type
use land_data_mod, only : lnd

implicit none
private

! ==== public interfaces =====================================================
! input
public :: read_create_cohorts
public :: read_cohort_data_r0d_fptr
public :: read_cohort_data_i0d_fptr
! output
public :: create_cohort_dimension
public :: write_cohort_data_r0d_fptr
public :: write_cohort_data_i0d_fptr
! ==== end of public interfaces ==============================================

! ==== module constants ======================================================
character(len=*), parameter :: &
     module_name = 'cohort_io_mod', &
     version     = '$Id: vegn_cohort_io.F90,v 20.0 2013/12/13 23:31:02 fms Exp $', &
     tagname     = '$Name: tikal $'
! name of the "compressed" dimension (and dimension variable) in the output 
! netcdf files -- that is, the dimensions written out using compression by 
! gathering, as described in CF conventions.
character(len=*),   parameter :: cohort_index_name   = 'cohort_index'

! ==== NetCDF declarations ===================================================
include 'netcdf.inc'
#define __NF_ASRT__(x) call print_netcdf_error((x),module_name,__LINE__)

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

! ============================================================================
! given compressed index, sizes of the global grid, 2D array of tile lists
! and the lower boundaries of this array, returns a pointer to the cohort
! corresponding to the compressed index, or NULL is the index is outside 
! current domain, or such tile does not exist, or such cohort does not exist.
subroutine get_cohort_by_idx(idx,nlon,nlat,ntiles,tiles,is,js,ptr)
   integer, intent(in) :: idx ! index
   integer, intent(in) :: nlon, nlat, ntiles
   integer, intent(in) :: is, js
   type(land_tile_list_type), intent(in) :: tiles(is:,js:)
   type(vegn_cohort_type), pointer :: ptr
   
   ! ---- local vars
   integer :: tile_idx, k
   type(land_tile_type), pointer :: tile
   
   ptr=>NULL()
   
   tile_idx = modulo(idx,nlon*nlat*ntiles)
   call get_tile_by_idx(tile_idx,nlon,nlat,tiles,is,js,tile)
   if(associated(tile)) then
      if (associated(tile%vegn)) then
         k = idx/(nlon*nlat*ntiles) ! calculate cohort index within a tile
         ptr=>tile%vegn%cohorts(k+1)
      endif
   endif

end subroutine

! ============================================================================
subroutine read_create_cohorts(ncid)
  integer, intent(in) :: ncid

  integer :: ncohorts ! total number of cohorts in restart file
  integer :: nlon, nlat, ntiles ! size of respective dimensions
 
  integer, allocatable :: idx(:)
  integer :: i,j,t,k,m, n, nn, idxid
  integer :: bufsize
  type(land_tile_enum_type) :: ce, te
  type(land_tile_type), pointer :: tile
  character(len=64) :: info ! for error message

  ! get the size of dimensions
  nlon = lnd%nlon ; nlat = lnd%nlat
  __NF_ASRT__(nfu_inq_dim(ncid,'tile',len=ntiles))

  ! read the cohort index
  __NF_ASRT__(nfu_inq_dim(ncid,cohort_index_name,len=ncohorts))
  __NF_ASRT__(nfu_inq_var(ncid,cohort_index_name,id=idxid))
  bufsize = min(input_buf_size,ncohorts)
  allocate(idx(bufsize))
  
  do nn = 1, ncohorts, bufsize
     __NF_ASRT__(nf_get_vara_int(ncid,idxid,nn,min(bufsize,ncohorts-nn+1),idx))
     
     do n = 1,min(bufsize,ncohorts-nn+1)
        if(idx(n)<0) cycle ! skip illegal indices
        k = idx(n)
        i = modulo(k,nlon)+1   ; k = k/nlon
        j = modulo(k,nlat)+1   ; k = k/nlat
        t = modulo(k,ntiles)+1 ; k = k/ntiles
        k = k+1
        
        if (i<lnd%is.or.i>lnd%ie) cycle ! skip points outside of domain
        if (j<lnd%js.or.j>lnd%je) cycle ! skip points outside of domain
        
        ce = first_elmt(lnd%tile_map(i,j))
        do m = 1,t-1
           ce=next_elmt(ce)
        enddo
        tile=>current_tile(ce)
        if(.not.associated(tile%vegn)) then
           info = ''
           write(info,'("(",3i3,")")')i,j,t
           call error_mesg('read_create_cohort',&
                'vegn tile'//trim(info)//' does not exist, but is necessary to create a cohort', &
                WARNING)
        else
           tile%vegn%n_cohorts = tile%vegn%n_cohorts + 1
        endif
     enddo
  enddo

  ! go through all tiles in the domain and allocate requested numner of cohorts
  ce = first_elmt(lnd%tile_map); te = tail_elmt(lnd%tile_map)
  do while (ce/=te)
     tile=>current_tile(ce); ce = next_elmt(ce)
     if(.not.associated(tile%vegn))cycle
     allocate(tile%vegn%cohorts(tile%vegn%n_cohorts))
  enddo

  ! clean up memory
  deallocate(idx)
end subroutine read_create_cohorts


! ============================================================================
! creates cohort dimension, if necessary, in the output restart file. NOTE 
! that this subroutine should be called even if restart has not been created
! (because, for example, there happen to be no vegetation in a certain domain),
! for the reason that it calls mpp_max, and that should be called for each
! processor to work.
subroutine create_cohort_dimension(ncid)
  integer, intent(in) :: ncid


  ! ---- local vars
  type(land_tile_enum_type) :: ce, te ! tile list enumerators
  type(land_tile_type), pointer :: tile
 
  integer, allocatable :: idx(:)   ! integer compressed index of tiles
  integer :: i,j,k,c,n,ntiles,max_cohorts,p
  integer :: iret
  integer, allocatable :: ncohorts(:) ! array of idx sizes from all PEs in io_domain
  integer, allocatable :: idx2(:) ! array of cohort indices from all PEs in io_domain

  ! count total number of cohorts in compute domain and max number of
  ! of cohorts per tile
  ce = first_elmt(lnd%tile_map)
  te = tail_elmt (lnd%tile_map)
  n  = 0
  max_cohorts = 0
  do while (ce/=te)
     tile=>current_tile(ce)
     if(associated(tile%vegn))then
        n = n+tile%vegn%n_cohorts 
        max_cohorts = max(max_cohorts,tile%vegn%n_cohorts)
     endif
     ce=next_elmt(ce)
  enddo

  call mpp_max(max_cohorts)

  ! get the size of the tile dimension from the file
  __NF_ASRT__(nfu_inq_dim(ncid,'tile',len=ntiles))
  
  ! calculate compressed cohort index to be written to the restart file
  allocate(idx(max(n,1))) ; idx(:) = -1
  ce = first_elmt(lnd%tile_map, lnd%is, lnd%js)
  n = 1
  do while (ce/=te)
     tile=>current_tile(ce)
     if(associated(tile%vegn)) then
        call get_elmt_indices(ce,i,j,k)
        do c = 1,tile%vegn%n_cohorts
           idx (n) = &
                (c-1)*lnd%nlon*lnd%nlat*ntiles + &
                (k-1)*lnd%nlon*lnd%nlat + &
                (j-1)*lnd%nlon + &
                (i-1)        
           n = n+1
        enddo
     endif
     ce=next_elmt(ce)
  end do

  if (mpp_pe()/=lnd%io_pelist(1)) then
     ! if this processor is not doing io (that is, it's not root io_domain
     ! processor), simply send the data to the root io_domain PE
     call mpp_send(size(idx), plen=1,         to_pe=lnd%io_pelist(1), tag=COMM_TAG_1)
     call mpp_send(idx(1),    plen=size(idx), to_pe=lnd%io_pelist(1), tag=COMM_TAG_2)
  else
     ! gather the array of cohort index sizes
     allocate(ncohorts(size(lnd%io_pelist)))
     ncohorts(1) = size(idx)
     do p = 2,size(lnd%io_pelist)
        call mpp_recv(ncohorts(p), from_pe=lnd%io_pelist(p), glen=1, tag=COMM_TAG_1)
     enddo
     ! gather cohort index from the processors in our io_domain
     allocate(idx2(sum(ncohorts(:))))
     idx2(1:ncohorts(1))=idx(:)
     k=ncohorts(1)+1
     do p = 2,size(lnd%io_pelist)
        call mpp_recv(idx2(k), from_pe=lnd%io_pelist(p), glen=ncohorts(p), tag=COMM_TAG_2)
        k = k+ncohorts(p)
     enddo
     ! create cohort dimension in the output file
     iret = nf_redef(ncid)
     __NF_ASRT__(nfu_def_dim(ncid,'cohort',(/(i,i=1,max_cohorts)/),'cohort number within tile'))
     ! create cohort index
     __NF_ASRT__(nfu_def_dim(ncid,cohort_index_name,idx2,'compressed vegetation cohort index'))
     __NF_ASRT__(nfu_put_att(ncid,cohort_index_name,'compress','cohort tile lat lon'))
     __NF_ASRT__(nfu_put_att(ncid,cohort_index_name,'valid_min',0))
     ! deallocate the data we no longer need
     deallocate(ncohorts,idx2)
     ! leave the define mode to commit the new definitions to the disk
     iret = nf_enddef(ncid)
  endif
  call sync_nc_files(ncid)
end subroutine create_cohort_dimension


#define F90_TYPE real
#define NF_TYPE NF_DOUBLE
#define NF_FILL_VALUE NF_FILL_DOUBLE
#define READ_0D_FPTR read_cohort_data_r0d_fptr
#define WRITE_0D_FPTR write_cohort_data_r0d_fptr
#include "vegn_cohort_io.inc"

#define F90_TYPE integer
#define NF_TYPE NF_INT
#define NF_FILL_VALUE NF_FILL_INT
#define READ_0D_FPTR read_cohort_data_i0d_fptr
#define WRITE_0D_FPTR write_cohort_data_i0d_fptr
#include "vegn_cohort_io.inc"

end module cohort_io_mod

module damping_driver_mod

!-----------------------------------------------------------------------
!
!       This module controls four functions:
!
!   (1) rayleigh friction applied to momentum fields at levels
!       1 to kbot (i.e., momentum is damped toward zero).
!
!   (2) mountain gravity wave drag module may be called
!
!   (3) Alexander-Dunkerton gravity wave drag may be called
!
!   (4) Garner topo_drag module may be called
!
!-----------------------------------------------------------------------

 use      mg_drag_mod, only:  mg_drag, mg_drag_init, mg_drag_end, &
                              mg_drag_restart
 use      cg_drag_mod, only:  cg_drag_init, cg_drag_calc, cg_drag_end, &
                              cg_drag_time_vary, cg_drag_endts, &
                              cg_drag_restart
 use    topo_drag_mod, only:  topo_drag_init, topo_drag, topo_drag_end, &
                              topo_drag_restart
 use          mpp_mod, only:  input_nml_file
 use          fms_mod, only:  file_exist, mpp_pe, mpp_root_pe, stdlog, &
                              write_version_number, &
                              open_namelist_file, error_mesg, &
                              check_nml_error,                   &
                              FATAL, close_file
 use diag_manager_mod, only:  register_diag_field,  &
                              register_static_field, send_data
 use time_manager_mod, only:  time_type
 use    constants_mod, only:  cp_air, grav

 implicit none
 private

 public   damping_driver, damping_driver_init, damping_driver_end
 public   damping_driver_time_vary, damping_driver_endts
 public   damping_driver_restart

!-----------------------------------------------------------------------
!---------------------- namelist ---------------------------------------

   real     :: trayfric = 0.
   integer  :: nlev_rayfric = 1
   logical  :: do_mg_drag = .false.
   logical  :: do_cg_drag = .false.
   logical  :: do_topo_drag = .false.
   logical  :: do_conserve_energy = .false.

   namelist /damping_driver_nml/  trayfric,   nlev_rayfric,  &
                                  do_cg_drag, do_topo_drag, &
                                  do_mg_drag, do_conserve_energy

!
!   trayfric = damping time in seconds for rayleigh damping momentum
!              in the top nlev_rayfric layers (if trayfric < 0 then time
!              in days)
!                 [real, default: trayfric=0.]
!
!   nlev_rayfric = number of levels at the top of the model where
!                  rayleigh friction of momentum is performed, if
!                  trayfric=0. then nlev_rayfric has no effect
!                    [integer, default: nlev_rayfric=1]
!
!-----------------------------------------------------------------------
!----- id numbers for diagnostic fields -----

integer :: id_udt_rdamp,  id_vdt_rdamp,   &
           id_udt_gwd,    id_vdt_gwd,     &
                          id_sgsmtn,      &
           id_udt_cgwd,   id_taus
integer    id_vdt_cgwd

integer :: id_tdt_diss_rdamp,  id_diss_heat_rdamp, &
           id_tdt_diss_gwd,    id_diss_heat_gwd,   &
           id_tdt_diss_topo,   id_diss_heat_topo

integer :: id_udt_topo,   id_vdt_topo,   id_taubx,  id_tauby

!----- missing value for all fields ------

real :: missing_value = -999.

character(len=7) :: mod_name = 'damping'

!-----------------------------------------------------------------------

 logical :: do_rayleigh

 real, parameter ::  daypsec=1./86400.
 logical :: module_is_initialized =.false.

 real :: rfactr

!   note:  
!     rfactr = coeff. for damping momentum at the top level

 character(len=128) :: version = '$Id: damping_driver.F90,v 19.0 2012/01/06 20:05:04 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'

!-----------------------------------------------------------------------

contains

!#######################################################################

 subroutine damping_driver (is, js, lat, Time, delt, pfull, phalf, zfull, zhalf, &
                            u, v, t, q, r,  udt, vdt, tdt, qdt, rdt,  &
!                                   mask, kbot)
                            z_pbl,  mask, kbot)
 
!-----------------------------------------------------------------------
 integer,         intent(in)                :: is, js
 real, dimension(:,:), intent(in)           :: lat
 type(time_type), intent(in)                :: Time
 real,            intent(in)                :: delt
 real,    intent(in),    dimension(:,:,:)   :: pfull, phalf, &
                                               zfull, zhalf, &
                                               u, v, t, q
 real,    intent(in),    dimension(:,:,:,:) :: r
 real,    intent(inout), dimension(:,:,:)   :: udt,vdt,tdt,qdt
 real,    intent(inout), dimension(:,:,:,:) :: rdt
 real, dimension(:,:), intent(in)           :: z_pbl
 real,    intent(in),    dimension(:,:,:), optional :: mask
 integer, intent(in),    dimension(:,:),   optional :: kbot

!-----------------------------------------------------------------------
 real, dimension(size(udt,1),size(udt,2))             :: diag2
 real, dimension(size(udt,1),size(udt,2))             :: taubx, tauby
 real, dimension(size(udt,1),size(udt,2),size(udt,3)) :: taus
 real, dimension(size(udt,1),size(udt,2),size(udt,3)) :: utnd, vtnd, &
                                                         ttnd, pmass, &
                                                         p2
 integer :: k
 logical :: used

!-----------------------------------------------------------------------

   if (.not.module_is_initialized) call error_mesg ('damping_driver',  &
                     'damping_driver_init must be called first', FATAL)

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!----------------- r a y l e i g h   d a m p i n g ---------------------
!-----------------------------------------------------------------------
   if (do_rayleigh) then

       p2 = pfull * pfull
       call rayleigh (delt, p2, u, v, utnd, vtnd, ttnd)
       udt = udt + utnd
       vdt = vdt + vtnd
       tdt = tdt + ttnd

!----- diagnostics -----

       if ( id_udt_rdamp > 0 ) then
            used = send_data ( id_udt_rdamp, utnd, Time, is, js, 1, &
                               rmask=mask )
       endif

       if ( id_vdt_rdamp > 0 ) then
            used = send_data ( id_vdt_rdamp, vtnd, Time, is, js, 1, &
                               rmask=mask )
       endif

       if ( id_tdt_diss_rdamp > 0 ) then
            used = send_data ( id_tdt_diss_rdamp, ttnd, Time, is, js, 1, &
                               rmask=mask )
       endif

       if ( id_diss_heat_rdamp > 0 ) then
            do k = 1,size(u,3)
              pmass(:,:,k) = phalf(:,:,k+1)-phalf(:,:,k)
            enddo
            diag2 = cp_air/grav * sum(ttnd*pmass,3)
            used = send_data ( id_diss_heat_rdamp, diag2, Time, is, js )
       endif

   endif
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!--------- m t n   g r a v i t y   w a v e   d r a g -------------------
!-----------------------------------------------------------------------
   if (do_mg_drag) then

       call mg_drag (is, js, delt, u, v, t, pfull, phalf, zfull, zhalf,  &
                     utnd, vtnd, ttnd, taubx,tauby,taus,        kbot)
       udt = udt + utnd
       vdt = vdt + vtnd
       tdt = tdt + ttnd

!----- diagnostics -----

       if ( id_udt_gwd > 0 ) then
            used = send_data ( id_udt_gwd, utnd, Time, is, js, 1, &
                               rmask=mask )
       endif

       if ( id_vdt_gwd > 0 ) then
            used = send_data ( id_vdt_gwd, vtnd, Time, is, js, 1, &
                               rmask=mask )
       endif

       if ( id_taubx > 0 ) then
            used = send_data ( id_taubx, taubx, Time, is, js )
       endif

       if ( id_tauby > 0 ) then
            used = send_data ( id_tauby, tauby, Time, is, js )
       endif

       if ( id_taus > 0 ) then
           used = send_data ( id_taus, taus, Time, is, js, 1, &
                              rmask=mask )
       endif

       if ( id_tdt_diss_gwd > 0 ) then
            used = send_data ( id_tdt_diss_gwd, ttnd, Time, is, js, 1, &
                               rmask=mask )
       endif

       if ( id_diss_heat_gwd > 0 ) then
            do k = 1,size(u,3)
              pmass(:,:,k) = phalf(:,:,k+1)-phalf(:,:,k)
            enddo
            diag2 = cp_air/grav * sum(ttnd*pmass,3)
            used = send_data ( id_diss_heat_gwd, diag2, Time, is, js )
       endif

   endif

!   Alexander-Dunkerton gravity wave drag

   if (do_cg_drag) then

     call cg_drag_calc (is, js, lat, pfull, zfull, t, u, v, Time,    &
                        delt, utnd, vtnd)

     udt =  udt + utnd
     vdt =  vdt + vtnd

!----- diagnostics -----

     if ( id_udt_cgwd > 0 ) then
        used = send_data ( id_udt_cgwd, utnd, Time, is, js, 1, &
                          rmask=mask )
     endif
      if ( id_vdt_cgwd > 0 ) then
        used = send_data ( id_vdt_cgwd, vtnd, Time, is, js, 1, &
                          rmask=mask )
     endif


   endif

!-----------------------------------------------------------------------
!---------topographic   w a v e   d r a g -------------------
!-----------------------------------------------------------------------
   if (do_topo_drag) then

     call topo_drag ( is, js, delt, u, v, t, pfull, phalf, zfull, zhalf,  &
                      utnd, vtnd, ttnd, taubx, tauby, taus, kbot )

     udt = udt + utnd
     vdt = vdt + vtnd

!----- diagnostics -----

     if ( id_udt_topo > 0 ) then
        used = send_data ( id_udt_topo, utnd, Time, is, js, 1, &
                           rmask=mask )
     endif

     if ( id_vdt_topo > 0 ) then
        used = send_data ( id_vdt_topo, vtnd, Time, is, js, 1, &
                           rmask=mask )
     endif

     if ( id_taubx > 0 ) then
       used = send_data ( id_taubx, taubx, Time, is, js )
     endif

     if ( id_tauby > 0 ) then
        used = send_data ( id_tauby, tauby, Time, is, js )
     endif

     if ( id_taus > 0 ) then
        used = send_data ( id_taus, taus, Time, is, js, 1, &
                           rmask=mask )
     endif

     if ( id_tdt_diss_topo > 0 ) then
        used = send_data ( id_tdt_diss_topo, ttnd, Time, is, js, 1, &
                               rmask=mask )
     endif

     if ( id_diss_heat_topo > 0 ) then
          do k = 1,size(u,3)
             pmass(:,:,k) = phalf(:,:,k+1)-phalf(:,:,k)
          enddo
          diag2 = cp_air/grav * sum(ttnd*pmass,3)
          used = send_data ( id_diss_heat_topo, diag2, Time, is, js )
     endif

 endif

!-----------------------------------------------------------------------

 end subroutine damping_driver

!#######################################################################

 subroutine damping_driver_init ( lonb, latb, pref, axes, Time, sgsmtn)

 real,            intent(in) :: lonb(:,:), latb(:,:), pref(:)
 integer,         intent(in) :: axes(4)
 type(time_type), intent(in) :: Time
 real, dimension(:,:), intent(out) :: sgsmtn
!-----------------------------------------------------------------------
!     lonb  = longitude in radians of the grid box corners
!     latb  = latitude  in radians of the grid box corners
!     axes  = axis indices, (/x,y,pf,ph/)
!               (returned from diag axis manager)
!     Time  = current time (time_type)
!     sgsmtn = subgrid scale topography variance
!-----------------------------------------------------------------------
 integer :: unit, ierr, io, logunit
 logical :: used

!-----------------------------------------------------------------------
!----------------- namelist (read & write) -----------------------------

#ifdef INTERNAL_FILE_NML
   read (input_nml_file, nml=damping_driver_nml, iostat=io)
   ierr = check_nml_error(io,"damping_driver_nml")
#else
   if (file_exist('input.nml')) then
      unit = open_namelist_file ()
      ierr=1; do while (ierr /= 0)
         read  (unit, nml=damping_driver_nml, iostat=io, end=10)
         ierr = check_nml_error (io, 'damping_driver_nml')
      enddo
 10   call close_file (unit)
   endif
#endif

   call write_version_number(version, tagname)
   logunit = stdlog()
   if(mpp_pe() == mpp_root_pe() ) then
        write (logunit,nml=damping_driver_nml)
   endif

!-----------------------------------------------------------------------
!--------- rayleigh friction ----------

   do_rayleigh=.false.

   if (abs(trayfric) > 0.0001 .and. nlev_rayfric > 0) then
      if (trayfric > 0.0) then
         rfactr=(1./trayfric)
      else
         rfactr=(1./abs(trayfric))*daypsec
      endif
         do_rayleigh=.true.
   else
         rfactr=0.0
   endif

!-----------------------------------------------------------------------
!----- mountain gravity wave drag -----

   if (do_mg_drag) call mg_drag_init (lonb, latb, sgsmtn)

!--------------------------------------------------------------------
!----- Alexander-Dunkerton gravity wave drag -----
 
   if (do_cg_drag)  then
     call cg_drag_init (lonb, latb, pref, Time=Time, axes=axes)
   endif

!-----------------------------------------------------------------------
!----- initialize diagnostic fields -----

if (do_rayleigh) then

   id_udt_rdamp = &
   register_diag_field ( mod_name, 'udt_rdamp', axes(1:3), Time,       &
                       'u wind tendency for Rayleigh damping', 'm/s2', &
                        missing_value=missing_value               )

   id_vdt_rdamp = &
   register_diag_field ( mod_name, 'vdt_rdamp', axes(1:3), Time,       &
                       'v wind tendency for Rayleigh damping', 'm/s2', &
                        missing_value=missing_value               )

   id_tdt_diss_rdamp = &
   register_diag_field ( mod_name, 'tdt_diss_rdamp', axes(1:3), Time,  &
                      'Dissipative heating from Rayleigh damping',&
                             'deg_k/s', missing_value=missing_value   )
       
   id_diss_heat_rdamp = &
   register_diag_field ( mod_name, 'diss_heat_rdamp', axes(1:2), Time,   &
                'Integrated dissipative heating from Rayleigh damping',&
                  'W/m2' )
endif

if (do_mg_drag) then

 ! register and send static field
   id_sgsmtn = &
   register_static_field ( mod_name, 'sgsmtn', axes(1:2), &
               'sub-grid scale topography for gravity wave drag', 'm')
   if (id_sgsmtn > 0) used = send_data (id_sgsmtn, sgsmtn, Time)

 ! register non-static field
   id_udt_gwd = &
   register_diag_field ( mod_name, 'udt_gwd', axes(1:3), Time,        &
                     'u wind tendency for gravity wave drag', 'm/s2', &
                        missing_value=missing_value               )

   id_vdt_gwd = &
   register_diag_field ( mod_name, 'vdt_gwd', axes(1:3), Time,        &
                     'v wind tendency for gravity wave drag', 'm/s2', &
                        missing_value=missing_value               )

   id_taubx = &
   register_diag_field ( mod_name, 'taubx', axes(1:2), Time,        &
                         'x base flux for grav wave drag', 'kg/m/s2', &
                         missing_value=missing_value               )

   id_tauby = &
   register_diag_field ( mod_name, 'tauby', axes(1:2), Time,        &
                         'y base flux for grav wave drag', 'kg/m/s2', &
                         missing_value=missing_value )

   id_taus = &
   register_diag_field ( mod_name, 'taus', axes(1:3), Time,        &
                       'saturation flux for gravity wave drag', 'kg/m/s2', &
                      missing_value=missing_value               )

   id_tdt_diss_gwd = &
   register_diag_field ( mod_name, 'tdt_diss_gwd', axes(1:3), Time,    &
                          'Dissipative heating from gravity wave drag',&
                              'deg_k/s', missing_value=missing_value   )
       
   id_diss_heat_gwd = &
   register_diag_field ( mod_name, 'diss_heat_gwd', axes(1:2), Time,      &
                'Integrated dissipative heating from gravity wave drag',&
                                 'W/m2' )
endif

   if (do_cg_drag) then

    id_udt_cgwd = &
    register_diag_field ( mod_name, 'udt_cgwd', axes(1:3), Time,        &
                 'u wind tendency for cg gravity wave drag', 'm/s2', &
                      missing_value=missing_value               )


    id_vdt_cgwd = &
    register_diag_field ( mod_name, 'vdt_cgwd', axes(1:3), Time,        &
                 'v wind tendency for cg gravity wave drag', 'm/s2', &
                      missing_value=missing_value               )


   endif

!-----------------------------------------------------------------------
!----- topo wave drag -----



  if (do_topo_drag) then
          call topo_drag_init (lonb, latb)
          sgsmtn(:,:) = -99999.
  endif



  if (do_topo_drag) then

   id_udt_topo = &
   register_diag_field ( mod_name, 'udt_topo', axes(1:3), Time,        &
                       'u wind tendency for topo wave drag', 'm/s2', &
                        missing_value=missing_value               )

  id_vdt_topo = &
   register_diag_field ( mod_name, 'vdt_topo', axes(1:3), Time,        &
                       'v wind tendency for topo wave drag', 'm/s2', &
                         missing_value=missing_value               )

   id_taubx = &
   register_diag_field ( mod_name, 'taubx', axes(1:2), Time,        &
                     'x base flux for topo wave drag', 'kg/m/s2', &
                        missing_value=missing_value               )

    id_tauby = &
    register_diag_field ( mod_name, 'tauby', axes(1:2), Time,        &
                    'y base flux for topo wave drag', 'kg/m/s2', &
                      missing_value=missing_value )

    id_taus = &
   register_diag_field ( mod_name, 'taus', axes(1:3), Time,        &
                  'saturation flux for topo wave drag', 'kg/m/s2', &
                     missing_value=missing_value               )

   id_tdt_diss_topo = &
   register_diag_field ( mod_name, 'tdt_diss_topo', axes(1:3), Time,    &
                          'Dissipative heating from topo wave drag',&
                              'deg_k/s', missing_value=missing_value   )
       
   id_diss_heat_topo = &
   register_diag_field ( mod_name, 'diss_heat_topo', axes(1:2), Time,      &
                'Integrated dissipative heating from topo wave drag',&
                                 'W/m2' )
 endif


!-----------------------------------------------------------------------

   module_is_initialized =.true.

!******************** end of initialization ****************************
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

 end subroutine damping_driver_init


!#####################################################################

subroutine damping_driver_time_vary (delt)

real, intent(in) :: delt


       call cg_drag_time_vary (delt)

end subroutine damping_driver_time_vary



!#####################################################################

subroutine damping_driver_endts


     call cg_drag_endts

end subroutine damping_driver_endts



!######################################################################
!#######################################################################

 subroutine damping_driver_end

     if (do_mg_drag)   call mg_drag_end
     if (do_cg_drag)   call cg_drag_end
     if (do_topo_drag) call topo_drag_end

     module_is_initialized =.false.


 end subroutine damping_driver_end

!#######################################################################
! <SUBROUTINE NAME="damping_driver_restart">
!
! <DESCRIPTION>
! write out restart file.
! Arguments: 
!   timestamp (optional, intent(in)) : A character string that represents the model time, 
!                                      used for writing restart. timestamp will append to
!                                      the any restart file name as a prefix. 
! </DESCRIPTION>
!
subroutine damping_driver_restart(timestamp)
  character(len=*), intent(in), optional :: timestamp

     if (do_mg_drag)   call mg_drag_restart(timestamp)
     if (do_cg_drag)   call cg_drag_restart(timestamp)
     if (do_topo_drag) call topo_drag_restart(timestamp)

end subroutine damping_driver_restart
! </SUBROUTINE> NAME="damping_driver_restart" 

!#######################################################################

 subroutine rayleigh (dt, p2, u, v, udt, vdt, tdt)

  real,    intent(in)                      :: dt
  real,    intent(in),  dimension(:,:,:)   :: p2, u, v
  real,    intent(out), dimension(:,:,:)   :: udt, vdt, tdt

  real, dimension(size(u,1),size(u,2)) :: fact
  integer :: k
!-----------------------------------------------------------------------
!--------------rayleigh damping of momentum (to zero)-------------------

   do k = 1, nlev_rayfric
     fact(:,:) = rfactr*(1.+(p2(:,:,1)-p2(:,:,k))/(p2(:,:,1)+p2(:,:,k)))
     udt(:,:,k) = -u(:,:,k)*fact(:,:)
     vdt(:,:,k) = -v(:,:,k)*fact(:,:)
   enddo

   do k = nlev_rayfric+1, size(u,3)
     udt(:,:,k) = 0.0
     vdt(:,:,k) = 0.0
   enddo

!  total energy conservation
!  compute temperature change loss due to ke dissipation

   if (do_conserve_energy) then
       do k = 1, nlev_rayfric
          tdt(:,:,k) = -((u(:,:,k)+.5*dt*udt(:,:,k))*udt(:,:,k) +  &
                         (v(:,:,k)+.5*dt*vdt(:,:,k))*vdt(:,:,k)) / cp_air
       enddo
       do k = nlev_rayfric+1, size(u,3)
          tdt(:,:,k) = 0.0
       enddo
   else
       tdt = 0.0
   endif

!-----------------------------------------------------------------------

 end subroutine rayleigh

!#######################################################################

end module damping_driver_mod

module jablonowski_2006_mod

! Christiane Jablonwoski and David Williamson, 2006:
! A baroclinic instability test case for atmospheric model dynamical cores
! Quarterly J. Roy. Met. Soc., Vol. 132, October Part C, No. 621C, 2943-2975

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use               fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, stdlog, &
                                 write_version_number, close_file, check_nml_error

use         constants_mod, only: PI,    &
                                 GRAV,  & ! GRAV=9.800, not 9.806 as specified by Polvani
                                 RDGAS, & ! RDGAS=287.04, not 287.00 as specified by Polvani
                                 OMEGA, & ! same as specified by Polvani
                                 RADIUS,& ! same as specified by Polvani
                                 KAPPA    ! same as specified by Polvani

use   vert_coordinate_mod, only: compute_vert_coord

use        transforms_mod, only: get_grid_boundaries, get_sin_lat, get_cos_lat, trans_grid_to_spherical, trans_spherical_to_grid,&
                                 get_deg_lon, get_deg_lat, &
                                 vor_div_from_uv_grid, uv_grid_from_vor_div, get_grid_domain

use  press_and_geopot_mod, only: press_and_geopot_init, pressure_variables

use      diag_manager_mod, only: diag_axis_init, register_static_field, send_data

implicit none
private

character(len=128), parameter :: version = &
'$Id: jablonowski_2006.F90,v 19.0 2012/01/06 20:35:33 fms Exp $'

character(len=128), parameter :: tagname = &
'$Name: tikal $'

public :: jablonowski_2006

real, parameter :: P00=1.e5 ! Used to compute potential temperature. sea_level_press may be the same, but one should not assume that.

real, parameter :: halfpi=.5*PI
real :: xx, sin_latc, cos_latc, nv_surf

real :: n0    = .252 ! sigma level of jet max
real :: U0    =  35. ! max jet speed (m/sec)
real :: nt    = .20  ! sigma level of tropopause
real :: lapse = .005 ! lapse rate below tropopause (deg K/m)
real :: T0    = 288. ! global mean surface temperature (deg K)
real :: Up    =   1. ! amplitude of perturbation (m/sec)
real :: lonc  =  20. ! longitude center of perturbation (deg E)
real :: latc  =  40. ! latitude  center of perturbation (deg N)
real :: deltaT = 4.8e5 ! determines lapse rate above tropopause

namelist / jablonowski_2006_nml / n0, U0, nt, lapse, T0, Up, lonc, latc, deltaT

contains

!=========================================================================================================================

subroutine jablonowski_2006(sea_level_press, triang_trunc, &
                   vert_coord_option, vert_difference_option, scale_heights, surf_res, &
                   p_press, p_sigma, exponent, pk, bk, &
                   vors, divs, ts, ln_ps, ug, vg, tg, psg, vorg, divg, surf_geopotential)

real,    intent(in) :: sea_level_press
logical, intent(in) :: triang_trunc 
character(len=*), intent(in) :: vert_coord_option, vert_difference_option
real,    intent(in) :: scale_heights, surf_res, p_press, p_sigma, exponent
real,    intent(out), dimension(:) :: pk, bk
complex, intent(out), dimension(:,:,:) :: vors, divs, ts
complex, intent(out), dimension(:,:  ) :: ln_ps
real,    intent(out), dimension(:,:,:) :: ug, vg, tg
real,    intent(out), dimension(:,:  ) :: psg
real,    intent(out), dimension(:,:,:) :: vorg, divg
real,    intent(out), dimension(:,:  ) :: surf_geopotential

integer :: unit, ierr, io, i, j, k, num_lon, num_lat, num_levels
integer :: id_lon, id_lat, id_phalf, id_pfull, id_basic_flow, id_basic_temp, id_pot_temp, id_perturbation
logical :: used
real, dimension(size(ug,1), size(ug,2)) :: ln_psg
real, dimension(size(ug,3)  ) :: p_full, ln_p_full, sigma
real, dimension(size(ug,3)+1) :: p_half, ln_p_half
real, dimension(size(ug,3)) :: nv

! The allocatable arrays below must be allocated for the global domain
real, allocatable, dimension(:)   :: deg_lon, deg_lat, rad_lon, rad_lat, sin_lat, cos_lat, coriolis
real, allocatable, dimension(:,:) :: basic_flow, basic_temp, pot_temp
real, allocatable, dimension(:)   :: lon_factor1, lat_factor1, lat_factor2, z_factor1, z_factor2, z_factor3
real, allocatable, dimension(:,:) :: perturbation

!------------------------------------------------------------------------------------------------

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=jablonowski_2006_nml, iostat=io)
    ierr = check_nml_error(io, 'jablonowski_2006_nml')
#else
    unit = open_namelist_file()
    ierr=1
    do while (ierr /= 0)
      read(unit, nml=jablonowski_2006_nml, iostat=io, end=20)
      ierr = check_nml_error (io, 'jablonowski_2006_nml')
    enddo
20  call close_file (unit)
#endif
call write_version_number(version, tagname)
if(mpp_pe() == mpp_root_pe()) write (stdlog(), nml=jablonowski_2006_nml)

call compute_vert_coord(vert_coord_option, scale_heights, surf_res, exponent, p_press, p_sigma, sea_level_press, pk, bk)

call press_and_geopot_init(pk, bk, .false., vert_difference_option)
call pressure_variables(p_half, ln_p_half, p_full, ln_p_full, sea_level_press)
sigma = p_full/sea_level_press
nv = (sigma - n0)*halfpi

num_lon    = size(ug,1)
num_lat    = size(ug,2)
num_levels = size(ug,3)
allocate(rad_lon(num_lon), deg_lon(num_lon), lon_factor1(num_lon))
allocate(z_factor1(num_levels), z_factor2(num_levels), z_factor3(num_levels))
allocate(rad_lat(num_lat), deg_lat(num_lat), lat_factor1(num_lat), lat_factor2(num_lat))
allocate(sin_lat(num_lat), cos_lat(num_lat), coriolis(num_lat))
allocate(basic_flow(num_lat,num_levels), perturbation(num_lon,num_lat))
allocate(basic_temp(num_lat,num_levels), pot_temp(num_lat,num_levels))

call get_deg_lon(deg_lon)
rad_lon = PI*deg_lon/180.
call get_deg_lat(deg_lat)
rad_lat = PI*deg_lat/180.
call get_sin_lat(sin_lat)
call get_cos_lat(cos_lat)
coriolis = 2*OMEGA*sin_lat

xx = RDGAS*lapse/GRAV
do k=1,num_levels
  z_factor2(k) = U0*cos(nv(k))**1.5
  do j=1,num_lat
    basic_flow(j,k) = z_factor2(k)*sin(2*rad_lat(j))**2
  enddo
  z_factor3(k) = .75*PI*U0*sigma(k)*sin(nv(k))*sqrt(cos(nv(k)))/RDGAS
  if(sigma(k) <= nt) then
    z_factor1(k) = T0*sigma(k)**xx + deltaT*(nt-sigma(k))**5
  else
    z_factor1(k) = T0*sigma(k)**xx
  endif
enddo

do j=1,num_lat
  lat_factor1(j) = 10./63. - 2*sin_lat(j)**6 * (cos_lat(j)**2 + 1./3.)
  lat_factor2(j) = RADIUS*OMEGA*(1.6*cos_lat(j)**3 * (sin_lat(j)**2 + 2./3.) - .25*PI)
enddo

do k=1,num_levels
  do j=1,num_lat
     basic_temp(j,k) = z_factor1(k) + z_factor3(k)*(lat_factor1(j)*2*z_factor2(k) + lat_factor2(j))
  enddo
enddo

nv_surf = (1 - n0)*halfpi
do j=1,num_lat
  surf_geopotential(:,j) = U0*cos(nv_surf)**1.5 * (lat_factor1(j)*U0*cos(nv_surf)**1.5 + lat_factor2(j))
enddo

sin_latc = sin(PI*latc/180)
cos_latc = cos(PI*latc/180)
do i=1,num_lon
  lon_factor1(i) = cos(rad_lon(i)-PI*lonc/180)
enddo
do j=1,num_lat
  do i=1,num_lon
    xx = 10*acos(sin_latc*sin_lat(j) + cos_latc*cos_lat(j)*lon_factor1(i))
    perturbation(i,j) = Up*exp(-xx**2)
  enddo
enddo

id_phalf = diag_axis_init('phalf',.01*p_half,'hPa','z','approx half pressure level',direction=-1)
id_pfull = diag_axis_init('pfull',.01*p_full,'hPa','z','approx full pressure level',direction=-1,edges=id_phalf)
id_lon   = diag_axis_init('lon',deg_lon,'degrees E','x','longitude')
id_lat   = diag_axis_init('lat',deg_lat,'degrees N','y','latitude')
id_basic_flow   = register_static_field('jablonowski_2006', 'basic_flow',  (/id_lat,id_pfull/),'initial zonal wind', 'm/sec')
id_basic_temp   = register_static_field('jablonowski_2006', 'basic_temp',  (/id_lat,id_pfull/),'initial basic_temp', 'K')
id_pot_temp     = register_static_field('jablonowski_2006', 'pot_temp',    (/id_lat,id_pfull/),'initial potential temp', 'K')
id_perturbation = register_static_field('jablonowski_2006', 'perturbation',(/id_lon,id_lat/),  'initial perturbation','m/sec')
if(id_basic_flow > 0) used = send_data(id_basic_flow, basic_flow)
do k=1,num_levels
  do j=1,num_lat
    pot_temp(j,k) = basic_temp(j,k)*(P00/p_full(k))**KAPPA
  enddo
enddo
if(id_basic_temp > 0) used = send_data(id_basic_temp, basic_temp)
if(id_pot_temp   > 0) used = send_data(id_pot_temp,     pot_temp)
if(id_perturbation>0) used = send_data(id_perturbation, perturbation)

do k=1,num_levels
  do j=1,num_lat
    ug(:,j,k) = basic_flow(j,k)
    tg(:,j,k) = basic_temp(j,k)
  enddo
enddo
do j=1,num_lat
  do i=1,num_lon
    ug(i,j,:) = ug(i,j,:) + perturbation(i,j)
  enddo
enddo
vg = 0.0

! Transform grid fields to spherical waves then transform
! back to ensure that spectral and grid representations match.

call trans_grid_to_spherical(tg, ts)
call trans_spherical_to_grid(ts, tg)
call vor_div_from_uv_grid(ug, vg, vors, divs, triang=triang_trunc)
call uv_grid_from_vor_div(vors, divs, ug, vg)
call trans_spherical_to_grid(vors, vorg)
call trans_spherical_to_grid(divs, divg)
psg = sea_level_press
ln_psg = alog(psg)
call trans_grid_to_spherical(ln_psg, ln_ps)
call trans_spherical_to_grid(ln_ps,  ln_psg)
psg = exp(ln_psg)

deallocate(deg_lon, deg_lat, rad_lon, rad_lat, sin_lat, cos_lat, coriolis)
deallocate(basic_flow, basic_temp, pot_temp, perturbation)
deallocate(lon_factor1, lat_factor1, lat_factor2, z_factor1, z_factor2, z_factor3)

return
end subroutine jablonowski_2006
!================================================================================

end module jablonowski_2006_mod

                      module astronomy_mod
! <CONTACT EMAIL="Fei.Liu@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="">
! </REVIEWER>
! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>
! <OVERVIEW>
!    astronomy_mod provides astronomical variables for use
!    by other modules within fms. the only currently used interface is 
!    for determination of astronomical values needed by the shortwave
!    radiation packages.
! </OVERVIEW>
! <DESCRIPTION>
! </DESCRIPTION>

!  shared modules:

use fms_mod,           only: open_namelist_file, fms_init, &
                             mpp_pe, mpp_root_pe, stdlog, &
                             file_exist, write_version_number, &
                             check_nml_error, error_mesg, &
                             FATAL, NOTE, WARNING, close_file
use time_manager_mod,  only: time_type, set_time, get_time, &
                             get_date_julian, set_date_julian, &
                             set_date, length_of_year, &
                             time_manager_init, &
                             operator(-), operator(+), &
                             operator( // ), operator(<)
use constants_mod,     only: constants_init, PI
use mpp_mod,           only: input_nml_file

!--------------------------------------------------------------------

implicit none
private

!---------------------------------------------------------------------
!    astronomy_mod provides astronomical variables for use
!    by other modules within fms. the only currently used interface is 
!    for determination of astronomical values needed by the shortwave
!    radiation packages.
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module --------------------------

character(len=128)  :: version =  '$Id$'
character(len=128)  :: tagname =  '$Name$'


!---------------------------------------------------------------------
!-------  interfaces --------

public       &
              astronomy_init, get_period, set_period, &
              set_orbital_parameters, get_orbital_parameters, &
              set_ref_date_of_ae, get_ref_date_of_ae,  &
              diurnal_solar, daily_mean_solar, annual_mean_solar,  &
              astronomy_end, universal_time, orbital_time

interface diurnal_solar
   module procedure diurnal_solar_2d
   module procedure diurnal_solar_1d
   module procedure diurnal_solar_0d
   module procedure diurnal_solar_cal_2d
   module procedure diurnal_solar_cal_1d
   module procedure diurnal_solar_cal_0d
end interface

interface daily_mean_solar
   module procedure daily_mean_solar_2d
   module procedure daily_mean_solar_1d
   module procedure daily_mean_solar_2level
   module procedure daily_mean_solar_0d
   module procedure daily_mean_solar_cal_2d
   module procedure daily_mean_solar_cal_1d
   module procedure daily_mean_solar_cal_2level
   module procedure daily_mean_solar_cal_2level_radwt
   module procedure daily_mean_solar_cal_0d
end interface

interface annual_mean_solar
   module procedure annual_mean_solar_2d
   module procedure annual_mean_solar_1d
   module procedure annual_mean_solar_2level
end interface

interface get_period
   module procedure get_period_time_type, get_period_integer
end interface

interface set_period
   module procedure set_period_time_type, set_period_integer
end interface


private &

! called from astronomy_init and set_orbital_parameters:
              orbit,  &

! called from diurnal_solar, daily_mean_solar and orbit:
              r_inv_squared,   &

! called from  diurnal_solar and daily_mean_solar:
              angle,  declination,  &
              half_day
!             half_day, orbital_time, &

! called from  diurnal_solar:
!             universal_time


interface half_day
   module procedure half_day_2d, half_day_0d
end interface 


!---------------------------------------------------------------------
!-------- namelist  ---------

real    :: ecc   = 0.01671   ! eccentricity of orbital ellipse 
                             ! [ non-dimensional ]
real    :: obliq = 23.439    ! obliquity [ degrees ]
real    :: per   = 102.932   ! longitude of perihelion with respect 
                             ! to autumnal equinox in NH [ degrees ]
integer :: period = 0        ! specified length of year [ seconds ] ; 
                             ! must be specified to override default 
                             ! value given by length_of_year in 
                             ! time_manager_mod
integer :: day_ae    = 23    ! day of specified autumnal equinox
integer :: month_ae  = 9     ! month of specified autumnal equinox
integer :: year_ae   = 1998  ! year of specified autumnal equinox
integer :: hour_ae   = 5     ! hour of specified autumnal equinox
integer :: minute_ae = 37    ! minute of specified autumnal equinox
integer :: second_ae = 0     ! second of specified autumnal equinox
integer :: num_angles = 3600 ! number of intervals into which the year 
                             ! is divided to compute orbital positions


namelist /astronomy_nml/ ecc, obliq, per, period, &
                         year_ae, month_ae,  day_ae,         & 
                         hour_ae, minute_ae, second_ae, &
                         num_angles

!--------------------------------------------------------------------
!------   public data ----------


!--------------------------------------------------------------------
!------   private data ----------

type(time_type) :: autumnal_eq_ref  ! time_type variable containing
                                    ! specified time of reference 
                                    ! NH autumnal equinox

type(time_type) :: period_time_type ! time_type variable containing
                                    ! period of one orbit

real, dimension(:), allocatable ::      &
                          orb_angle ! table of orbital positions (0 to 
                                    ! 2*pi) as a function of time  used
                                    ! to find actual orbital position
                                    ! via interpolation

real    :: seconds_per_day=86400.   ! seconds in a day
real    :: deg_to_rad               ! conversion from degrees to radians
real    :: twopi                    ! 2 *PI
logical :: module_is_initialized=     &
                          .false.   ! has the module been initialized ?

real, dimension(:,:), allocatable ::       &
                       cosz_ann, &  ! annual mean cos of zenith angle
                       solar_ann, & ! annual mean solar factor
                       fracday_ann  ! annual mean daylight fraction
real    :: rrsun_ann                ! annual mean earth-sun distance
logical :: annual_mean_calculated =      &
                           .false.  ! have the annual mean values been 
                                    ! calculated ?
integer :: num_pts = 0              ! count of grid_boxes for which
                                    ! annual mean astronomy values have
                                    ! been calculated
integer :: total_pts                ! number of grid boxes owned by the
                                    ! processor


!--------------------------------------------------------------------
!--------------------------------------------------------------------



                           contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!####################################################################
! <SUBROUTINE NAME="astronomy_init">
!  <OVERVIEW>
!    astronomy_init is the constructor for astronomy_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    astronomy_init is the constructor for astronomy_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call astronomy_init (latb, lonb)
!  </TEMPLATE>
!  <IN NAME="latb" TYPE="real">
!   2d array of model latitudes at cell corners [radians]
!  </IN>
!  <IN NAME="lonb" TYPE="real">
!   2d array of model longitudes at cell corners [radians]
!  </IN>
! </SUBROUTINE>
!
subroutine astronomy_init (latb, lonb)
  
!-------------------------------------------------------------------
!    astronomy_init is the constructor for astronomy_mod.
!-------------------------------------------------------------------

real,   dimension(:,:), intent(in), optional   :: latb
real,   dimension(:,:), intent(in), optional   :: lonb

!--------------------------------------------------------------------
!   intent(in) variables:
!
!       latb         2d array of model latitudes at cell corners 
!                    [ radians ]
!       lonb         2d array of model longitudes at cell corners 
!                    [ radians ]
!
!--------------------------------------------------------------------

!-------------------------------------------------------------------
!  local variables:

      integer                         :: unit, ierr, io, seconds,  &
                                         days, jd, id

!-------------------------------------------------------------------
!  local variables:
!
!      unit
!      ierr
!      io
!      seconds
!      days
!      jd
!      id
!
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!    if module has already been initialized, exit.
!-------------------------------------------------------------------
      if (module_is_initialized) return

!-------------------------------------------------------------------
!    verify that modules used by this module have been initialized.
!-------------------------------------------------------------------
      call fms_init
      call time_manager_init
      call constants_init

!-----------------------------------------------------------------------
!    read namelist.              
!-----------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, astronomy_nml, iostat=io)
      ierr = check_nml_error(io,'astronomy_nml')
#else
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=astronomy_nml, iostat=io, end=10) 
        ierr = check_nml_error(io,'astronomy_nml')
        end do                   
10      call close_file (unit)   
      endif                      
#endif                                 
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number (version, tagname)
      if (mpp_pe() == mpp_root_pe() ) then
        unit = stdlog()
        write (unit, nml=astronomy_nml)
      endif
!--------------------------------------------------------------------
!    be sure input values are within valid ranges.
!    QUESTION : ARE THESE THE RIGHT LIMITS ???
!---------------------------------------------------------------------
      if (ecc < 0.0 .or. ecc > 0.99) &
        call error_mesg ('astronomy_mod', &
                      'ecc must be between 0 and 0.99', FATAL)
      if (obliq < -90. .or. obliq > 90.) &
        call error_mesg ('astronomy_mod', &
                  'obliquity must be between -90 and 90 degrees', FATAL)
      if (per <  0.0 .or. per > 360.0) &
        call error_mesg ('astronomy_mod', &
                 'perihelion must be between 0 and 360 degrees', FATAL)

!----------------------------------------------------------------------
!    set up time-type variable defining specified time of autumnal
!    equinox.
!----------------------------------------------------------------------
      autumnal_eq_ref = set_date (year_ae,month_ae,day_ae, &
                                  hour_ae,minute_ae,second_ae)

!---------------------------------------------------------------------
!    set up time-type variable defining length of year.
!----------------------------------------------------------------------
      if (period == 0) then  
        period_time_type = length_of_year()
        call get_time (period_time_type, seconds, days)
        period = seconds_per_day*days + seconds
      else   
        period_time_type = set_time(period,0)
      endif

!---------------------------------------------------------------------
!    define useful module variables.
!----------------------------------------------------------------------
      twopi = 2.*PI
      deg_to_rad = twopi/360.

!---------------------------------------------------------------------
!    call orbit to define table of orbital angles as function of 
!    orbital time.
!----------------------------------------------------------------------
! wfc moved here from orbit
      allocate ( orb_angle(0:num_angles) )
      call orbit

!--------------------------------------------------------------------
!    if annual mean radiation is desired, then latb will be present.
!    allocate arrays to hold the needed astronomical factors. define 
!    the total number of points that the processor is responsible for.
!--------------------------------------------------------------------
      if (present(latb)) then
        jd = size(latb,2) - 1
        id = size(lonb,1) - 1
        allocate (cosz_ann(id, jd))
        allocate (solar_ann(id, jd))
        allocate (fracday_ann(id, jd))
        total_pts = jd*id
      endif
     
!---------------------------------------------------------------------
!    mark the module as initialized.
!---------------------------------------------------------------------
      module_is_initialized=.true.

!---------------------------------------------------------------------

end subroutine astronomy_init




!###################################################################



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                    INTERFACE GET_PERIOD
!
!
! call get_period (period)
!
!  separate routines exist within this interface for integer
!  and time_type output:
!
!  integer, intent(out)         :: period
! OR
!  type(time_type), intent(out) :: period
!
!--------------------------------------------------------------------
!
!   intent(out) variable:
!
!    period_out        length of year for calendar in use
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

! <SUBROUTINE NAME="get_period_integer">
!  <OVERVIEW>
!    get_period_integer returns the length of the year as an integer
!    number of seconds.
!  </OVERVIEW>
!  <DESCRIPTION>
!    get_period_integer returns the length of the year as an integer
!    number of seconds.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call get_period_integer (period_out)
!  </TEMPLATE>
!  <OUT NAME="period_out" TYPE="integer">
!   number of seconds as the length of the year
!  </OUT>
! </SUBROUTINE>
!
subroutine get_period_integer (period_out)

!--------------------------------------------------------------------
!    get_period_integer returns the length of the year as an integer
!    number of seconds.
!--------------------------------------------------------------------

integer, intent(out) :: period_out

!--------------------------------------------------------------------
!   local variables:

      integer :: seconds, days

!---------------------------------------------------------------------
!    exit if module has not been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized)   &
        call error_mesg ( 'astronomy_mod',  &
         ' module has not been initialized', FATAL)

!--------------------------------------------------------------------
!    define length of year in seconds.
!--------------------------------------------------------------------
      call get_time (period_time_type, seconds, days)
      period_out = seconds_per_day*days + seconds


end subroutine get_period_integer

!####################################################################
! <SUBROUTINE NAME="get_period_time_type">
!  <OVERVIEW>
!    get_period_time_type returns the length of the year as a time_type
!    variable.
!  </OVERVIEW>
!  <DESCRIPTION>
!    get_period_time_type returns the length of the year as a time_type
!    variable.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call get_period_time_type (period_out)
!  </TEMPLATE>
!  <OUT NAME="period_out" TYPE="time_type">
!   the length of the year as a time_type
!  </OUT>
! </SUBROUTINE>
!
subroutine get_period_time_type (period_out)

!--------------------------------------------------------------------
!    get_period_time_type returns the length of the year as a time_type
!    variable.
!--------------------------------------------------------------------

type(time_type), intent(inout) :: period_out

!---------------------------------------------------------------------
!    exit if module has not been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized)   &
          call error_mesg ( 'astronomy_mod',  &
              ' module has not been initialized', FATAL)

!--------------------------------------------------------------------
!    define length of year as a time_type variable.
!--------------------------------------------------------------------
      period_out = period_time_type


end subroutine get_period_time_type



!#####################################################################


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                END INTERFACE GET_PERIOD
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                    INTERFACE SET_PERIOD
!
!
! call set_period (period_in)
!
!  separate routines exist within this interface for integer
!  and time_type output:
!
!  integer, intent(out)         :: period_in
! OR
!  type(time_type), intent(out) :: period_in
!
!--------------------------------------------------------------------
!
!   intent(in) variable:
!
!    period_in        length of year for calendar in use
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

! <SUBROUTINE NAME="set_period_integer">
!  <OVERVIEW>
!    set_period_integer saves as the input length of the year (an 
!    integer) in a time_type module variable.
!  </OVERVIEW>
!  <DESCRIPTION>
!    set_period_integer saves as the input length of the year (an 
!    integer) in a time_type module variable.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call set_period_integer (period_in)
!  </TEMPLATE>
!  <IN NAME="period_in" TYPE="time_type">
!   the length of the year as a time_type
!  </IN>
! </SUBROUTINE>
!
subroutine set_period_integer (period_in)

!--------------------------------------------------------------------
!    set_period_integer saves as the input length of the year (an 
!    integer) in a time_type module variable.
!--------------------------------------------------------------------

integer, intent(in) :: period_in

!---------------------------------------------------------------------
!    exit if module has not been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized)   &
        call error_mesg ( 'astronomy_mod',  &
         ' module has not been initialized', FATAL)

!---------------------------------------------------------------------
!    define time_type variable defining the length of year from the
!    input value (integer seconds).
!---------------------------------------------------------------------
      period_time_type = set_time(period_in, 0)



end subroutine set_period_integer



!#####################################################################

subroutine set_period_time_type(period_in)

!--------------------------------------------------------------------
!    set_period_time_type saves the length of the year (input as a 
!    time_type variable) into a time_type module variable.
!--------------------------------------------------------------------

type(time_type), intent(in) :: period_in

!---------------------------------------------------------------------
!    exit if module has not been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized)   &
        call error_mesg ( 'astronomy_mod',  &
         ' module has not been initialized', FATAL)

!---------------------------------------------------------------------
!    define time_type variable defining the length of year from the
!    input value (time_type).
!---------------------------------------------------------------------
      period_time_type = period_in


end subroutine set_period_time_type



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                END INTERFACE SET_PERIOD
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



!#####################################################################
! <SUBROUTINE NAME="set_orbital_parameters">
!  <OVERVIEW>
!    set_orbital_parameters saves the input values of eccentricity,
!    obliquity and perihelion time as module variables for use by
!    astronomy_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    set_orbital_parameters saves the input values of eccentricity,
!    obliquity and perihelion time as module variables for use by
!    astronomy_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call set_orbital_parameters (ecc_in, obliq_in, per_in)
!  </TEMPLATE>
!  <IN NAME="ecc_in" TYPE="real">
!   eccentricity of orbital ellipse
!  </IN>
!  <IN NAME="obliq_in" TYPE="real">
!   obliquity fof orbital ellipse
!  </IN>
!  <IN NAME="per_in" TYPE="real">
!   longitude of perihelion with respect to autumnal
!                      equinox in northern hemisphere
!  </IN>
! </SUBROUTINE>
!
subroutine set_orbital_parameters (ecc_in, obliq_in, per_in)

!--------------------------------------------------------------------
!    set_orbital_parameters saves the input values of eccentricity,
!    obliquity and perihelion time as module variables for use by
!    astronomy_mod.
!--------------------------------------------------------------------

real, intent(in) :: ecc_in
real, intent(in) :: obliq_in
real, intent(in) :: per_in

!--------------------------------------------------------------------  
!
!  intent(in) variables:
!
!     ecc_in           eccentricity of orbital ellipse 
!                      [ non-dimensional ]
!     obliq_in         obliquity
!                      [ degrees ]
!     per_in           longitude of perihelion with respect to autumnal
!                      equinox in northern hemisphere
!                      [ degrees ]
!
!-------------------------------------------------------------------

!---------------------------------------------------------------------
!    exit if module has not been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized)   &
        call error_mesg ( 'astronomy_mod',  &
         ' module has not been initialized', FATAL)

!--------------------------------------------------------------------
!    be sure input values are within valid ranges.
!    QUESTION : ARE THESE THE RIGHT LIMITS ???
!---------------------------------------------------------------------
      if (ecc_in < 0.0 .or. ecc_in > 0.99) &
        call error_mesg ('astronomy_mod', &
                      'ecc must be between 0 and 0.99', FATAL)
      if (obliq_in < -90.0 .or. obliq > 90.0) &
        call error_mesg ('astronomy_mod', &
                'obliquity must be between -90. and 90. degrees', FATAL)
      if (per_in < 0.0 .or. per_in > 360.0) &
        call error_mesg ('astronomy_mod', &
              'perihelion must be between 0.0 and 360. degrees', FATAL)

!---------------------------------------------------------------------
!    save input values into module variables.
!---------------------------------------------------------------------
      ecc   = ecc_in
      obliq = obliq_in
      per   = per_in

!---------------------------------------------------------------------
!    call orbit to define table of orbital angles as function of 
!    orbital time using the input values of parameters just supplied.
!----------------------------------------------------------------------
      call orbit

!----------------------------------------------------------------------



end subroutine set_orbital_parameters



!####################################################################
! <SUBROUTINE NAME="get_orbital_parameters">
!  <OVERVIEW>
!    get_orbital_parameters retrieves the orbital parameters for use
!    by another module.
!  </OVERVIEW>
!  <DESCRIPTION>
!    get_orbital_parameters retrieves the orbital parameters for use
!    by another module.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call get_orbital_parameters (ecc_out, obliq_out, per_out)
!  </TEMPLATE>
!  <OUT NAME="ecc_out" TYPE="real">
!   eccentricity of orbital ellipse
!  </OUT>
!  <OUT NAME="obliq_out" TYPE="real">
!   obliquity fof orbital ellipse
!  </OUT>
!  <OUT NAME="per_out" TYPE="real">
!   longitude of perihelion with respect to autumnal
!                      equinox in northern hemisphere
!  </OUT>
! </SUBROUTINE>
!
subroutine get_orbital_parameters (ecc_out, obliq_out, per_out)

!-------------------------------------------------------------------
!    get_orbital_parameters retrieves the orbital parameters for use
!    by another module.
!--------------------------------------------------------------------

real, intent(out) :: ecc_out, obliq_out, per_out

!--------------------------------------------------------------------  
!
!  intent(out) variables:
!
!     ecc_out          eccentricity of orbital ellipse 
!                      [ non-dimensional ]
!     obliq_out        obliquity
!                      [ degrees ]
!     per_out          longitude of perihelion with respect to autumnal
!                      equinox in northern hemisphere
!                      [ degrees ]
!
!-------------------------------------------------------------------

!---------------------------------------------------------------------
!    exit if module has not been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized)   &
        call error_mesg ( 'astronomy_mod',  &
         ' module has not been initialized', FATAL)

!--------------------------------------------------------------------
!    fill the output arguments with the eccentricity, obliquity and 
!    perihelion angle.
!--------------------------------------------------------------------
      ecc_out = ecc
      obliq_out = obliq
      per_out = per


end subroutine get_orbital_parameters



!####################################################################
! <SUBROUTINE NAME="set_ref_date_of_ae">
!  <OVERVIEW>
!    set_ref_date_of_ae provides a means of specifying the reference
!    date of the NH autumnal equinox for a particular year. 
!  </OVERVIEW>
!  <DESCRIPTION>
!    set_ref_date_of_ae provides a means of specifying the reference
!    date of the NH autumnal equinox for a particular year.  it is only
!    used if calls are made to the calandar versions of the routines 
!    diurnal_solar and daily_mean_solar. if the NOLEAP calendar is 
!    used, then the date of autumnal equinox will be the same every 
!    year. if JULIAN is used, then the date of autumnal equinox will 
!    return to the same value every 4th year.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call set_ref_date_of_ae (day_in,month_in,year_in, &
!                               second_in,minute_in,hour_in)
!  </TEMPLATE>
!  <IN NAME="day_in" TYPE="integer">
!   day of reference autumnal equinox
!  </IN>
!  <IN NAME="month_in" TYPE="integer">
!   month of reference autumnal equinox
!  </IN>
!  <IN NAME="year_in" TYPE="integer">
!   year of reference autumnal equinox
!  </IN>
!  <IN NAME="second_in" TYPE="real">
!   OPTIONAL: second of reference autumnal equinox
!  </IN>
!  <IN NAME="minute_in" TYPE="real">
!   OPTIONAL: minute of reference autumnal equinox
!  </IN>
!  <IN NAME="hour_in" TYPE="real">
!   OPTIONAL: hour of reference autumnal equinox
!  </IN>
! </SUBROUTINE>
!
subroutine set_ref_date_of_ae (day_in,month_in,year_in, &
                               second_in,minute_in,hour_in)

!---------------------------------------------------------------------
!    set_ref_date_of_ae provides a means of specifying the reference
!    date of the NH autumnal equinox for a particular year.  it is only
!    used if calls are made to the calandar versions of the routines 
!    diurnal_solar and daily_mean_solar. if the NOLEAP calendar is 
!    used, then the date of autumnal equinox will be the same every 
!    year. if JULIAN is used, then the date of autumnal equinox will 
!    return to the same value every 4th year.
!----------------------------------------------------------------------

integer, intent(in)           :: day_in, month_in, year_in
integer, intent(in), optional :: second_in, minute_in, hour_in

!--------------------------------------------------------------------  
!
!  intent(in) variables:
!
!     day_in           day of reference autumnal equinox
!                      [ non-dimensional ]
!     month_in         month of reference autumnal equinox
!                      [ non-dimensional ]
!     year_in          year of reference autumnal equinox
!                      [ non-dimensional ]
!
!  intent(in), optional variables:
!
!     second_in        second of reference autumnal equinox
!                      [ non-dimensional ]
!     minute_in        minute of reference autumnal equinox
!                      [ non-dimensional ]
!     hour_in          hour of reference autumnal equinox
!                      [ non-dimensional ]
! 
!------------------------------------------------------------------- 

!---------------------------------------------------------------------
!    exit if module has not been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized)   &
        call error_mesg ( 'astronomy_mod',  &
         ' module has not been initialized', FATAL)

!-------------------------------------------------------------------- 
!    save the input time of ae specification into a time_type module 
!    variable autumnal_eq_ref.
!--------------------------------------------------------------------
      day_ae =    day_in
      month_ae =  month_in
      year_ae =   year_in

      if (present(second_in)) then
        second_ae = second_in
        minute_ae = minute_in
        hour_ae =   hour_in
      else
        second_ae = 0
        minute_ae = 0
        hour_ae   = 0
      endif

      autumnal_eq_ref = set_date (year_ae,month_ae,day_ae, &
                                  hour_ae,minute_ae,second_ae)

!---------------------------------------------------------------------


end subroutine set_ref_date_of_ae



!####################################################################
! <SUBROUTINE NAME="get_ref_date_of_ae">
!  <OVERVIEW>
!     get_ref_date_of_ae retrieves the reference date of the autumnal
!     equinox as integer variables.
!  </OVERVIEW>
!  <DESCRIPTION>
!     get_ref_date_of_ae retrieves the reference date of the autumnal
!     equinox as integer variables.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call get_ref_date_of_ae (day_out,month_out,year_out, &
!                               second_out, minute_out,hour_out)
!  </TEMPLATE>
!  <OUT NAME="day_out" TYPE="integer">
!   day of reference autumnal equinox
!  </OUT>
!  <OUT NAME="month_out" TYPE="integer">
!   month of reference autumnal equinox
!  </OUT>
!  <OUT NAME="year_out" TYPE="integer">
!   year of reference autumnal equinox
!  </OUT>
!  <OUT NAME="second_out" TYPE="real">
!   second of reference autumnal equinox
!  </OUT>
!  <OUT NAME="minute_out" TYPE="real">
!   minute of reference autumnal equinox
!  </OUT>
!  <OUT NAME="hour_out" TYPE="real">
!   hour of reference autumnal equinox
!  </OUT>
! </SUBROUTINE>
!
subroutine get_ref_date_of_ae (day_out,month_out,year_out,&
                               second_out,minute_out,hour_out)

!---------------------------------------------------------------------
!     get_ref_date_of_ae retrieves the reference date of the autumnal
!     equinox as integer variables.
!---------------------------------------------------------------------

integer, intent(out) :: day_out, month_out, year_out,  &
                        second_out, minute_out, hour_out

!--------------------------------------------------------------------  
!
!  intent(out) variables:
!
!     day_out          day of reference autumnal equinox
!                      [ non-dimensional ]
!     month_out        month of reference autumnal equinox
!                      [ non-dimensional ]
!     year_out         year of reference autumnal equinox
!                      [ non-dimensional ]
!     second_out       second of reference autumnal equinox
!                      [ non-dimensional ]
!     minute_out       minute of reference autumnal equinox
!                      [ non-dimensional ]
!     hour_out         hour of reference autumnal equinox
!                      [ non-dimensional ]
! 
!------------------------------------------------------------------- 

!---------------------------------------------------------------------
!    exit if module has not been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized)   &
        call error_mesg ( 'astronomy_mod',  &
         ' module has not been initialized', FATAL)

!---------------------------------------------------------------------
!    fill the output fields with the proper module data.
!---------------------------------------------------------------------
      day_out    =  day_ae
      month_out  =  month_ae
      year_out   =  year_ae
      second_out =  second_ae
      minute_out =  minute_ae
      hour_out   =  hour_ae


end subroutine get_ref_date_of_ae



!#####################################################################


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                    INTERFACE DIURNAL_SOLAR
!
! call diurnal_solar (lat, lon, time, cosz, fracday, rrsun, dt_time)
!   or 
! call diurnal_solar (lat, lon, gmt, time_since_ae, cosz, fracday, 
!                     rrsun, dt)
!
!  the first option (used in conjunction with time_manager_mod)      
!  generates the real variables gmt and time_since_ae from the 
!  time_type input, and then calls diurnal_solar with these real
!  inputs. 
!
!  the time of day is set by 
!    real, intent(in) :: gmt
!  the time of year is set by 
!    real, intent(in) :: time_since_ae
!  with time_type input, both of these are extracted from 
!    type(time_type), intent(in) :: time
!
!
!  separate routines exist within this interface for scalar, 
!  1D or 2D input and output fields:
!
!    real, intent(in), dimension(:,:) :: lat, lon
! OR real, intent(in), dimension(:)   :: lat, lon
! OR real, intent(in)                 :: lat, lon
!
!    real, intent(out), dimension(:,:) :: cosz, fracday
! OR real, intent(out), dimension(:)   :: cosz, fracday
! OR real, intent(out)                 :: cosz, fracday
!
!  one may also average the output fields over the time interval 
!  between gmt and gmt + dt by including the optional argument dt (or 
!  dt_time). dt is measured in radians and must be less than pi 
!  (1/2 day). this average is computed analytically, and should be 
!  exact except for the fact that changes in earth-sun distance over 
!  the time interval dt are ignored. in the context of a diurnal GCM, 
!  this option should always be employed to insure that the total flux 
!  at the top of the atmosphere is not modified by time truncation 
!  error.
!
!    real, intent(in), optional :: dt
!    type(time_type), optional :: dt_time
! (see test.90 for examples of the use of these types)
!
!--------------------------------------------------------------------
!
!  intent(in) variables:
!
!     lat            latitudes of model grid points 
!                    [ radians ]
!     lon            longitudes of model grid points
!                    [ radians ]
!     gmt            time of day at longitude 0.0; midnight = 0.0, 
!                    one day = 2 * pi
!                    [ radians ]
!     time_since_ae  time of year; autumnal equinox = 0.0,
!                    one year = 2 * pi
!                    [ radians ]
!     time           time at which astronomical values are desired
!                    time_type variable [ seconds, days]
!     
!
!  intent(out) variables:
!
!     cosz           cosine of zenith angle, set to zero when entire
!                    period is in darkness
!                    [ dimensionless ]
!     fracday        daylight fraction of time interval
!                    [ dimensionless ]
!     rrsun          earth-sun distance (r) relative to semi-major axis
!                    of orbital ellipse (a) : (a/r)**2
!                    [ dimensionless ]
!
!  intent(in), optional variables:
!
!     dt            time interval after gmt over which the astronomical
!                   variables are to be averaged. this produces averaged
!                   output rather than instantaneous. 
!                   [ radians ], (1 day = 2 * pi)
!     dt_time       as in dt, but dt_time is a time_type variable
!                   time_type [ days, seconds ]
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

! <SUBROUTINE NAME="diurnal_solar_2d">
!  <OVERVIEW>
!    diurnal_solar_2d returns 2d fields of cosine of zenith angle, 
!    daylight fraction and earth-sun distance at the specified lati-
!    tudes, longitudes and time. these values may be instantaneous
!    or averaged over a specified time interval.
!  </OVERVIEW>
!  <DESCRIPTION>
!    diurnal_solar_2d returns 2d fields of cosine of zenith angle, 
!    daylight fraction and earth-sun distance at the specified lati-
!    tudes, longitudes and time. these values may be instantaneous
!    or averaged over a specified time interval.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call diurnal_solar_2d (lat, lon, gmt, time_since_ae, cosz, &
!                             fracday, rrsun, dt_time) 
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN> 
!  <IN NAME="lon" TYPE="real">
!   longitude of model grid points 
!  </IN>
!  <IN NAME="gmt" TYPE="real">
!   time of day at longitude 0.0; midnight = 0.0, 
!                    one day = 2 * pi
!  </IN>
!  <IN NAME="time_since_ae" TYPE="real">
!   time of year; autumnal equinox = 0.0,
!                    one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="fracday" TYPE="real">
!   daylight fraction of time interval
!  </OUT>
!  <OUT NAME="rrsun" TYPE="real">
!   earth-sun distance (r) relative to semi-major axis
!                    of orbital ellipse (a) : (a/r)**2
!  </OUT>
!  <IN NAME="dt" TYPE="real">
!   OPTIONAL: time interval after gmt over which the astronomical
!                   variables are to be averaged. this produces averaged
!                   output rather than instantaneous.
!  </IN>
! </SUBROUTINE>
!
subroutine diurnal_solar_2d (lat, lon, gmt, time_since_ae, cosz, &
                             fracday, rrsun, dt, allow_negative_cosz, &
                             half_day_out) 

!---------------------------------------------------------------------
!    diurnal_solar_2d returns 2d fields of cosine of zenith angle, 
!    daylight fraction and earth-sun distance at the specified lati-
!    tudes, longitudes and time. these values may be instantaneous
!    or averaged over a specified time interval.
!---------------------------------------------------------------------

real, dimension(:,:), intent(in)           :: lat, lon
real,                 intent(in)           :: gmt, time_since_ae
real, dimension(:,:), intent(out)          :: cosz, fracday
real,                 intent(out)          :: rrsun
real,                 intent(in), optional :: dt
logical,              intent(in), optional :: allow_negative_cosz
real, dimension(:,:), intent(out), optional :: half_day_out


!---------------------------------------------------------------------
!   local variables

      real, dimension(size(lat,1),size(lat,2)) :: t, tt, h, aa, bb,  &
                                                  st, stt, sh
      real                                     :: ang, dec
      logical :: Lallow_negative

!---------------------------------------------------------------------
!   local variables
!
!    t           time of day with respect to local noon (2 pi = 1 day)
!                [ radians ]
!    tt          end of averaging period [ radians ]
!    h           half of the daily period of daylight, centered at noon
!                [ radians, -pi --> pi ]
!    aa          sin(lat) * sin(declination)
!    bb          cos(lat) * cos(declination)
!    st          sine of time of day
!    stt         sine of time of day at end of averaging period
!    sh          sine of half-day period
!    ang         position of earth in its orbit wrt autumnal equinox
!                [ radians ]
!    dec         earth's declination [ radians ]
!    
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!    be sure the time in the annual cycle is legitimate.
!---------------------------------------------------------------------
      if (time_since_ae < 0.0 .or. time_since_ae > twopi) &
          call error_mesg('astronomy_mod', &
                    'time_since_ae not between 0 and 2pi', FATAL)

!--------------------------------------------------------------------
!    be sure the time at longitude = 0.0 is legitimate.
!---------------------------------------------------------------------
      if (gmt < 0.0 .or. gmt > twopi) &
         call error_mesg('astronomy_mod', &
                    'gmt not between 0 and 2pi', FATAL)

!---------------------------------------------------------------------
!    define the orbital angle (location in year), solar declination and
!    earth sun distance factor. use functions contained in this module.
!---------------------------------------------------------------------
      ang = angle(time_since_ae)
      dec = declination(ang)
      rrsun  = r_inv_squared(ang)

!---------------------------------------------------------------------
!    define terms needed in the cosine zenith angle equation.
!--------------------------------------------------------------------
      aa = sin(lat)*sin(dec)
      bb = cos(lat)*cos(dec)

!---------------------------------------------------------------------
!    define local time. force it to be between -pi and pi.
!--------------------------------------------------------------------
      t = gmt + lon - PI
      where(t >= PI) t = t - twopi  
      where(t < -PI) t = t + twopi   

      Lallow_negative = .false.
      if (present(allow_negative_cosz)) then
         if (allow_negative_cosz) Lallow_negative = .true.
      end if

!---------------------------------------------------------------------
!    perform a time integration to obtain cosz and fracday if desired.
!    output is valid over the period from t to t + dt.
!--------------------------------------------------------------------
      h   = half_day   (lat,dec)
      
      if ( present(half_day_out) ) then 
         half_day_out = h
      end if

      if ( present(dt) ) then   ! (perform time averaging)
        tt = t + dt
        st  = sin(t)
        stt = sin(tt)
        sh  = sin(h)
        cosz = 0.0

        if (.not. Lallow_negative) then
!-------------------------------------------------------------------
!    case 1: entire averaging period is before sunrise.
!-------------------------------------------------------------------
        where (t < -h .and. tt < -h) cosz = 0.0

!-------------------------------------------------------------------
!    case 2: averaging period begins before sunrise, ends after sunrise
!    but before sunset
!-------------------------------------------------------------------
        where ( (tt+h) /= 0.0 .and.   t < -h .and. abs(tt) <= h)   &
             cosz = aa + bb*(stt + sh)/ (tt + h)

!-------------------------------------------------------------------
!    case 3: averaging period begins before sunrise, ends after sunset,
!    but before the next sunrise. modify if averaging period extends 
!    past the next day's sunrise, but if averaging period is less than 
!    a half- day (pi) that circumstance will never occur.
!-------------------------------------------------------------------
        where (t < -h .and. h /= 0.0 .and. h < tt)    &
              cosz = aa + bb*( sh + sh)/(h+h)

!-------------------------------------------------------------------
!    case 4: averaging period begins after sunrise, ends before sunset.
!-------------------------------------------------------------------
        where ( abs(t) <= h .and. abs(tt) <= h)    &
             cosz = aa + bb*(stt - st)/ (tt - t)

!-------------------------------------------------------------------
!    case 5: averaging period begins after sunrise, ends after sunset. 
!    modify when averaging period extends past the next day's sunrise.  
!------------------------------------------------------------------- 
        where ((h-t) /= 0.0 .and. abs(t) <= h .and.  h < tt)    &
              cosz = aa + bb*(sh - st)/(h-t)

!-------------------------------------------------------------------
!    case 6: averaging period begins after sunrise , ends after the
!    next day's sunrise. note that this includes the case when the
!    day length is one day (h = pi).
!-------------------------------------------------------------------
        where (twopi - h < tt .and. (tt+h-twopi) /= 0.0 .and. t <= h ) &
           cosz = (cosz*(h - t) + (aa*(tt + h - twopi) +     &
            bb*(stt + sh))) / ((h - t) + (tt + h - twopi))

!-------------------------------------------------------------------
!    case 7: averaging period begins after sunset and ends before the
!    next day's sunrise
!-------------------------------------------------------------------
        where(  h <  t .and. twopi - h >= tt  ) cosz = 0.0

!-------------------------------------------------------------------
!    case 8: averaging period begins after sunset and ends after the
!    next day's sunrise but before the next day's sunset. if the
!    averaging period is less than a half-day (pi) the latter
!    circumstance will never occur.
!-----------------------------------------------------------------
        where(  h <  t .and. twopi - h < tt  ) 
          cosz = aa + bb*(stt + sh) / (tt + h - twopi)
        end where

        else
           cosz = aa + bb*(stt - st)/ (tt - t)
        end if



!-------------------------------------------------------------------
!    day fraction is the fraction of the averaging period contained 
!    within the (-h,h) period.
!-------------------------------------------------------------------
        where (t < -h .and.      tt < -h)      fracday = 0.0
        where (t < -h .and. abs(tt) <= h)      fracday = (tt + h )/dt
        where (t < -h .and.       h < tt)      fracday = ( h + h )/dt
        where (abs(t) <= h .and. abs(tt) <= h) fracday = (tt - t )/dt
        where (abs(t) <= h .and.       h < tt) fracday = ( h - t )/dt
        where (      h <  t                 )  fracday = 0.0
        where (twopi - h < tt)                 fracday = fracday +  &
                                                         (tt + h - &
                                                         twopi)/dt      
!----------------------------------------------------------------------
!    if instantaneous values are desired, define cosz at time t.
!----------------------------------------------------------------------
      else  ! (no time averaging)
        if (.not. Lallow_negative) then
           where (abs(t) < h)
             cosz = aa + bb*cos(t)
             fracday = 1.0
           elsewhere
             cosz = 0.0
             fracday = 0.0
           end where
        else
           cosz = aa + bb*cos(t)
           where (abs(t) < h)
             fracday = 1.0
           elsewhere
             fracday = 0.0
           end where
        end if
      end if

!----------------------------------------------------------------------
!    be sure that cosz is not negative.
!----------------------------------------------------------------------
      if (.not. Lallow_negative) then
         cosz = max(0.0, cosz)
      end if

!--------------------------------------------------------------------



end subroutine diurnal_solar_2d


!######################################################################
! <SUBROUTINE NAME="diurnal_solar_1d">
!  <OVERVIEW>
!    diurnal_solar_1d takes 1-d input fields, adds a second dimension
!    and calls diurnal_solar_2d. on return, the 2d fields are returned
!    to the original 1d fields.
!  </OVERVIEW>
!  <DESCRIPTION>
!    diurnal_solar_1d takes 1-d input fields, adds a second dimension
!    and calls diurnal_solar_2d. on return, the 2d fields are returned
!    to the original 1d fields.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call diurnal_solar_1d (lat, lon, gmt, time_since_ae, cosz, &
!                             fracday, rrsun, dt) 
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN> 
!  <IN NAME="lon" TYPE="real">
!   longitude of model grid points 
!  </IN>
!  <IN NAME="gmt" TYPE="real">
!   time of day at longitude 0.0; midnight = 0.0, 
!                    one day = 2 * pi
!  </IN>
!  <IN NAME="time_since_ae" TYPE="real">
!   time of year; autumnal equinox = 0.0,
!                    one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="fracday" TYPE="real">
!   daylight fraction of time interval
!  </OUT>
!  <OUT NAME="rrsun" TYPE="real">
!   earth-sun distance (r) relative to semi-major axis
!                    of orbital ellipse (a) : (a/r)**2
!  </OUT>
!  <IN NAME="dt" TYPE="real">
!   OPTIONAL: time interval after gmt over which the astronomical
!                   variables are to be averaged. this produces averaged
!                   output rather than instantaneous.
!  </IN>
! </SUBROUTINE>
!
subroutine diurnal_solar_1d (lat, lon, gmt, time_since_ae, cosz, &
                             fracday, rrsun, dt, allow_negative_cosz, &
                             half_day_out)

!--------------------------------------------------------------------
!    diurnal_solar_1d takes 1-d input fields, adds a second dimension
!    and calls diurnal_solar_2d. on return, the 2d fields are returned
!    to the original 1d fields.
!----------------------------------------------------------------------

!---------------------------------------------------------------------
real, dimension(:),  intent(in)           :: lat, lon
real,                intent(in)           :: gmt, time_since_ae
real, dimension(:),  intent(out)          :: cosz, fracday
real,                intent(out)          :: rrsun
real,                intent(in), optional :: dt
logical,             intent(in), optional :: allow_negative_cosz
real, dimension(:),  intent(out), optional :: half_day_out

!---------------------------------------------------------------------
!  local variables

      real, dimension(size(lat),1) :: lat_2d, lon_2d, cosz_2d,   &
                                      fracday_2d,halfday_2d

!--------------------------------------------------------------------
!    define 2-d versions of input data arrays.
!--------------------------------------------------------------------
      lat_2d(:,1) = lat
      lon_2d(:,1) = lon

!--------------------------------------------------------------------
!    call diurnal_solar_2d to calculate astronomy fields.
!--------------------------------------------------------------------
!     if (present(dt)) then
        call diurnal_solar_2d (lat_2d, lon_2d, gmt, time_since_ae,&
                               cosz_2d, fracday_2d, rrsun, dt=dt, &
                               allow_negative_cosz=allow_negative_cosz, &
                               half_day_out=halfday_2d)
!     else
!       call diurnal_solar_2d (lat_2d, lon_2d, gmt, time_since_ae, &
!                              cosz_2d, fracday_2d, rrsun)
!     endif

!-------------------------------------------------------------------
!    place output fields into 1-d arguments for return to 
!    calling routine.
!-------------------------------------------------------------------
      fracday = fracday_2d(:,1)
      cosz  = cosz_2d (:,1)
      if (present(half_day_out)) then 
         half_day_out = halfday_2d(:,1)
      end if


end subroutine diurnal_solar_1d


!#####################################################################
! <SUBROUTINE NAME="diurnal_solar_0d">
!  <OVERVIEW>
!    diurnal_solar_0d takes scalar input fields, makes them into 2d
!    arrays dimensioned (1,1), and calls diurnal_solar_2d. on return, 
!    the 2d fields are converted back to the desired scalar output.
!  </OVERVIEW>
!  <DESCRIPTION>
!    diurnal_solar_0d takes scalar input fields, makes them into 2d
!    arrays dimensioned (1,1), and calls diurnal_solar_2d. on return, 
!    the 2d fields are converted back to the desired scalar output.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call diurnal_solar_0d (lat, lon, gmt, time_since_ae, cosz, &
!                             fracday, rrsun, dt) 
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN> 
!  <IN NAME="lon" TYPE="real">
!   longitude of model grid points 
!  </IN>
!  <IN NAME="gmt" TYPE="real">
!   time of day at longitude 0.0; midnight = 0.0, 
!                    one day = 2 * pi
!  </IN>
!  <IN NAME="time_since_ae" TYPE="real">
!   time of year; autumnal equinox = 0.0,
!                    one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="fracday" TYPE="real">
!   daylight fraction of time interval
!  </OUT>
!  <OUT NAME="rrsun" TYPE="real">
!   earth-sun distance (r) relative to semi-major axis
!                    of orbital ellipse (a) : (a/r)**2
!  </OUT>
!  <IN NAME="dt" TYPE="real">
!   OPTIONAL: time interval after gmt over which the astronomical
!                   variables are to be averaged. this produces averaged
!                   output rather than instantaneous.
!  </IN>
! </SUBROUTINE>
!
subroutine diurnal_solar_0d (lat, lon, gmt, time_since_ae, cosz,  &
                             fracday, rrsun, dt, allow_negative_cosz, &
                             half_day_out)

!--------------------------------------------------------------------
!    diurnal_solar_0d takes scalar input fields, makes them into 2d
!    arrays dimensioned (1,1), and calls diurnal_solar_2d. on return, 
!    the 2d fields are converted back to the desired scalar output.
!----------------------------------------------------------------------

real, intent(in)           :: lat, lon, gmt, time_since_ae
real, intent(out)          :: cosz, fracday, rrsun
real, intent(in), optional :: dt
logical,intent(in), optional :: allow_negative_cosz
real, intent(out), optional :: half_day_out

!--------------------------------------------------------------------
!  local variables:
!
      real, dimension(1,1) :: lat_2d, lon_2d, cosz_2d, fracday_2d, halfday_2d

!---------------------------------------------------------------------
!    create 2d arrays from the scalar input fields.
!---------------------------------------------------------------------
      lat_2d = lat
      lon_2d = lon

!--------------------------------------------------------------------
!    call diurnal_solar_2d to calculate astronomy fields.
!--------------------------------------------------------------------
!     if (present(dt)) then
        call diurnal_solar_2d (lat_2d, lon_2d, gmt, time_since_ae,  &
                               cosz_2d, fracday_2d, rrsun, dt=dt, &
                               allow_negative_cosz=allow_negative_cosz, &
                               half_day_out=halfday_2d)
!     else
!       call diurnal_solar_2d (lat_2d, lon_2d, gmt, time_since_ae, &
!                              cosz_2d, fracday_2d, rrsun)
!     end if

!-------------------------------------------------------------------
!    place output fields into scalars for return to calling routine.
!-------------------------------------------------------------------
      fracday = fracday_2d(1,1)
      cosz = cosz_2d(1,1)
      if (present(half_day_out)) then 
         half_day_out = halfday_2d(1,1)
      end if



end subroutine diurnal_solar_0d



!####################################################################
! <SUBROUTINE NAME="diurnal_solar_cal_2d">
!  <OVERVIEW>
!    diurnal_solar_cal_2d receives time_type inputs, converts 
!    them to real variables and then calls diurnal_solar_2d to
!    compute desired astronomical variables.
!  </OVERVIEW>
!  <DESCRIPTION>
!    diurnal_solar_cal_2d receives time_type inputs, converts 
!    them to real variables and then calls diurnal_solar_2d to
!    compute desired astronomical variables.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call diurnal_solar_cal_2d (lat, lon, gmt, time_since_ae, cosz, &
!                             fracday, rrsun, dt) 
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN> 
!  <IN NAME="lon" TYPE="real">
!   longitude of model grid points 
!  </IN>
!  <IN NAME="gmt" TYPE="real">
!   time of day at longitude 0.0; midnight = 0.0, 
!                    one day = 2 * pi
!  </IN>
!  <IN NAME="time_since_ae" TYPE="real">
!   time of year; autumnal equinox = 0.0,
!                    one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="fracday" TYPE="real">
!   daylight fraction of time interval
!  </OUT>
!  <OUT NAME="rrsun" TYPE="real">
!   earth-sun distance (r) relative to semi-major axis
!                    of orbital ellipse (a) : (a/r)**2
!  </OUT>
!  <IN NAME="dt_time" TYPE="time_type">
!   OPTIONAL: time interval after gmt over which the astronomical
!                   variables are to be averaged. this produces averaged
!                   output rather than instantaneous.
!  </IN>
! </SUBROUTINE>
!
subroutine diurnal_solar_cal_2d (lat, lon, time, cosz, fracday,   &
                                 rrsun, dt_time, allow_negative_cosz, &
                                 half_day_out) 

!-------------------------------------------------------------------
!    diurnal_solar_cal_2d receives time_type inputs, converts 
!    them to real variables and then calls diurnal_solar_2d to
!    compute desired astronomical variables.
!-------------------------------------------------------------------

!-------------------------------------------------------------------
real, dimension(:,:), intent(in)            :: lat, lon
type(time_type),      intent(in)            :: time
real, dimension(:,:), intent(out)           :: cosz, fracday
real,                 intent(out)           :: rrsun
type(time_type),      intent(in), optional  :: dt_time
logical,              intent(in), optional  :: allow_negative_cosz
real, dimension(:,:), intent(out), optional  :: half_day_out
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables

      real :: dt
      real :: gmt, time_since_ae

!---------------------------------------------------------------------
!    extract time of day (gmt) from time_type variable time with
!    function universal_time.
!---------------------------------------------------------------------
      gmt = universal_time(time)

!---------------------------------------------------------------------
!    extract the time of year (time_since_ae) from time_type variable 
!    time using the function orbital_time.
!---------------------------------------------------------------------
      time_since_ae = orbital_time(time)

!---------------------------------------------------------------------
!    convert optional time_type variable dt_time (length of averaging 
!    period) to a real variable dt with the function universal_time.
!---------------------------------------------------------------------
      if (present(dt_time))  then
        dt = universal_time(dt_time)
        if (dt > PI) then
          call error_mesg ( 'astronomy_mod', &
             'radiation time step must be no longer than 12 hrs', &
                                                          FATAL)
        endif
        if (dt == 0.0) then
          call error_mesg ( 'astronomy_mod', &
              'radiation time step must not be an integral &
                                     &number of days', FATAL)
        endif

!--------------------------------------------------------------------
!    call diurnal_solar_2d to calculate astronomy fields, with or 
!    without the optional argument dt.
!--------------------------------------------------------------------
        call diurnal_solar_2d (lat, lon, gmt, time_since_ae, cosz, &
               fracday, rrsun, dt=dt, &
               allow_negative_cosz=allow_negative_cosz, & 
               half_day_out=half_day_out)
      else
        call diurnal_solar_2d (lat, lon, gmt, time_since_ae, cosz, &
               fracday, rrsun, &
               allow_negative_cosz=allow_negative_cosz, &
               half_day_out=half_day_out)
      end if


end subroutine diurnal_solar_cal_2d


!#####################################################################
! <SUBROUTINE NAME="diurnal_solar_cal_1d">
!  <OVERVIEW>
!    diurnal_solar_cal_1d receives time_type inputs, converts 
!    them to real variables and then calls diurnal_solar_2d to
!    compute desired astronomical variables.
!  </OVERVIEW>
!  <DESCRIPTION>
!    diurnal_solar_cal_1d receives time_type inputs, converts 
!    them to real variables and then calls diurnal_solar_2d to
!    compute desired astronomical variables.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call diurnal_solar_cal_1d (lat, lon, gmt, time_since_ae, cosz, &
!                             fracday, rrsun, dt) 
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN> 
!  <IN NAME="lon" TYPE="real">
!   longitude of model grid points 
!  </IN>
!  <IN NAME="gmt" TYPE="real">
!   time of day at longitude 0.0; midnight = 0.0, 
!                    one day = 2 * pi
!  </IN>
!  <IN NAME="time_since_ae" TYPE="real">
!   time of year; autumnal equinox = 0.0,
!                    one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="fracday" TYPE="real">
!   daylight fraction of time interval
!  </OUT>
!  <OUT NAME="rrsun" TYPE="real">
!   earth-sun distance (r) relative to semi-major axis
!                    of orbital ellipse (a) : (a/r)**2
!  </OUT>
!  <IN NAME="dt_time" TYPE="time_type">
!   OPTIONAL: time interval after gmt over which the astronomical
!                   variables are to be averaged. this produces averaged
!                   output rather than instantaneous.
!  </IN>
! </SUBROUTINE>
!
subroutine diurnal_solar_cal_1d (lat, lon, time, cosz, fracday,   &
                                 rrsun, dt_time, allow_negative_cosz, &
                                 half_day_out)

!--------------------------------------------------------------------
real, dimension(:), intent(in)           :: lat, lon
type(time_type),    intent(in)           :: time
real, dimension(:), intent(out)          :: cosz, fracday
real,               intent(out)          :: rrsun
type(time_type),    intent(in), optional :: dt_time
logical,            intent(in), optional :: allow_negative_cosz
real, dimension(:), intent(out), optional :: half_day_out
!--------------------------------------------------------------------

!-------------------------------------------------------------------
!   local variables

      real, dimension(size(lat),1) :: lat_2d, lon_2d, cosz_2d, & 
                                      fracday_2d, halfday_2d

!--------------------------------------------------------------------
!    define 2-d versions of input data arrays.
!--------------------------------------------------------------------
      lat_2d(:,1) = lat
      lon_2d(:,1) = lon

!--------------------------------------------------------------------
!    call diurnal_solar_cal_2d to convert the time_types to reals and
!    then calculate the astronomy fields.
!--------------------------------------------------------------------
      if (present(dt_time)) then
        call diurnal_solar_cal_2d (lat_2d, lon_2d, time, cosz_2d,    &
           fracday_2d, rrsun, dt_time=dt_time, &
           allow_negative_cosz=allow_negative_cosz, &
           half_day_out=halfday_2d)
      else
        call diurnal_solar_cal_2d (lat_2d, lon_2d, time, cosz_2d,    &
           fracday_2d, rrsun, &
           allow_negative_cosz=allow_negative_cosz, &
           half_day_out=halfday_2d)
      end if

!-------------------------------------------------------------------
!    place output fields into 1-d arguments for return to 
!    calling routine.
!-------------------------------------------------------------------
      fracday = fracday_2d(:,1)
      cosz  = cosz_2d (:,1)
      if (present(half_day_out)) then 
         half_day_out = halfday_2d(:,1)
      end if
      

end subroutine diurnal_solar_cal_1d



!#####################################################################
! <SUBROUTINE NAME="diurnal_solar_cal_0d">
!  <OVERVIEW>
!    diurnal_solar_cal_0d receives time_type inputs, converts 
!    them to real variables and then calls diurnal_solar_2d to
!    compute desired astronomical variables.
!  </OVERVIEW>
!  <DESCRIPTION>
!    diurnal_solar_cal_0d receives time_type inputs, converts 
!    them to real variables and then calls diurnal_solar_2d to
!    compute desired astronomical variables.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call diurnal_solar_cal_0d (lat, lon, gmt, time_since_ae, cosz, &
!                             fracday, rrsun, dt_time) 
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN> 
!  <IN NAME="lon" TYPE="real">
!   longitude of model grid points 
!  </IN>
!  <IN NAME="gmt" TYPE="real">
!   time of day at longitude 0.0; midnight = 0.0, 
!                    one day = 2 * pi
!  </IN>
!  <IN NAME="time_since_ae" TYPE="real">
!   time of year; autumnal equinox = 0.0,
!                    one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="fracday" TYPE="real">
!   daylight fraction of time interval
!  </OUT>
!  <OUT NAME="rrsun" TYPE="real">
!   earth-sun distance (r) relative to semi-major axis
!                    of orbital ellipse (a) : (a/r)**2
!  </OUT>
!  <IN NAME="dt_time" TYPE="time_type">
!   OPTIONAL: time interval after gmt over which the astronomical
!                   variables are to be averaged. this produces averaged
!                   output rather than instantaneous.
!  </IN>
! </SUBROUTINE>
!
subroutine diurnal_solar_cal_0d (lat, lon, time, cosz, fracday,   &
                                 rrsun, dt_time, allow_negative_cosz, &
                                 half_day_out)

!---------------------------------------------------------------------
real,            intent(in)           :: lat, lon
type(time_type), intent(in)           :: time
real,            intent(out)          :: cosz, fracday, rrsun
type(time_type), intent(in), optional :: dt_time
logical,         intent(in), optional :: allow_negative_cosz
real,            intent(out), optional :: half_day_out
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables

      real, dimension(1,1) :: lat_2d, lon_2d, cosz_2d, fracday_2d, halfday_2d

!--------------------------------------------------------------------
!    define 2-d versions of input data arrays.
!--------------------------------------------------------------------
      lat_2d = lat
      lon_2d = lon

!--------------------------------------------------------------------
!    call diurnal_solar_cal_2d to convert the time_types to reals and
!    then calculate the astronomy fields.
!--------------------------------------------------------------------
      if (present(dt_time)) then
        call diurnal_solar_cal_2d (lat_2d, lon_2d, time, cosz_2d,   &
           fracday_2d, rrsun, dt_time=dt_time, &
           allow_negative_cosz=allow_negative_cosz, &
           half_day_out=halfday_2d)
      else
        call diurnal_solar_cal_2d (lat_2d, lon_2d, time, cosz_2d,   &
           fracday_2d, rrsun, &
           allow_negative_cosz=allow_negative_cosz, &
           half_day_out=halfday_2d)
      end if

!-------------------------------------------------------------------
!    place output fields into 1-d arguments for return to 
!    calling routine.
!-------------------------------------------------------------------
      fracday= fracday_2d(1,1)
      cosz = cosz_2d(1,1)
      if (present(half_day_out)) then 
         half_day_out = halfday_2d(1,1)
      end if


end subroutine diurnal_solar_cal_0d


!####################################################################

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                END INTERFACE DIURNAL_SOLAR
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                 INTERFACE DAILY_MEAN_SOLAR
!
!
! call daily_mean_solar (lat, time, cosz, fracday, rrsun)
!   or 
! call daily_mean_solar (lat, time_since_ae, cosz, fracday, rrsun)
!   or
! call daily_mean_solar (lat, time, cosz, solar)
!   or 
! call daily_mean_solar (lat, time_since_ae, cosz, solar)
!
!  the first option (used in conjunction with time_manager_mod)
!  generates the real variable time_since_ae from the time_type
!  input time, and then calls daily_mean_solar with this real input 
!  (option 2).  the third and fourth options correspond to the first
!  and second and are used with then spectral 2-layer model, where 
!  only cosz and solar are desired as output. these routines generate
!  dummy arguments and then call option 2, where the calculation is
!  done.
!
!  the time of year is set by 
!    real, intent(in) :: time_since_ae
!  with time_type input, the time of year is extracted from
!    type(time_type), intent(in) :: time
!
!
!  separate routines exist within this interface for scalar, 
!  1D or 2D input and output fields:
!
!    real, intent(in), dimension(:,:) :: lat
! OR real, intent(in), dimension(:)   :: lat
! OR real, intent(in)                 :: lat
!
!    real, intent(out), dimension(:,:) :: cosz, fracday
! OR real, intent(out), dimension(:)   :: cosz, fracday
! OR real, intent(out)                 :: cosz, fracday
!
!--------------------------------------------------------------------
!
!  intent(in) variables:
!
!     lat            latitudes of model grid points 
!                    [ radians ]
!     time_since_ae  time of year; autumnal equinox = 0.0,
!                    one year = 2 * pi
!                    [ radians ]
!     time           time at which astronomical values are desired
!                    time_type variable [ seconds, days]
!     
!
!  intent(out) variables:
!
!     cosz           cosz is cosine of an effective zenith angle that 
!                    would produce the correct daily solar flux if the 
!                    sun were fixed at that position for the period of 
!                    daylight.  
!                    should one also, or instead, compute cosz weighted
!                    by the instantaneous flux, averaged over the day ??
!                    [ dimensionless ]
!     fracday        daylight fraction of time interval
!                    [ dimensionless ]
!     rrsun          earth-sun distance (r) relative to semi-major axis
!                    of orbital ellipse (a) : (a/r)**2
!                    [ dimensionless ]
!     solar          shortwave flux factor: cosine of zenith angle *
!                    daylight fraction / (earth-sun distance squared)
!                    [ dimensionless ]
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


! <SUBROUTINE NAME="daily_mean_solar_2d">
!  <OVERVIEW>
!    daily_mean_solar_2d computes the daily mean astronomical 
!    parameters for the input points at latitude lat and time of year 
!    time_since_ae.
!  </OVERVIEW>
!  <DESCRIPTION>
!    daily_mean_solar_2d computes the daily mean astronomical 
!    parameters for the input points at latitude lat and time of year 
!    time_since_ae.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call daily_mean_solar_2d (lat, time_since_ae, cosz, h_out, rr_out)
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN> 
!  <IN NAME="time_since_ae" TYPE="real">
!   time of year; autumnal equinox = 0.0,
!                    one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="h_out" TYPE="real">
!   2-d array of half-day lengths at the latitudes
!  </OUT>
!  <OUT NAME="rr_out" TYPE="real">
!   the inverse of the square of the earth-sun
!    distance relative to the mean distance at angle ang in the earth's
!    orbit.
!  </OUT>
! </SUBROUTINE>
!
subroutine daily_mean_solar_2d (lat, time_since_ae, cosz, h_out, rr_out)

!----------------------------------------------------------------------
!    daily_mean_solar_2d computes the daily mean astronomical 
!    parameters for the input points at latitude lat and time of year 
!    time_since_ae.
!    
!----------------------------------------------------------------------

!----------------------------------------------------------------------
real, dimension(:,:), intent(in)   :: lat
real,                 intent(in)   :: time_since_ae
real, dimension(:,:), intent(out)  :: cosz, h_out
real,                 intent(out)  :: rr_out
!----------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables

      real, dimension(size(lat,1),size(lat,2)) :: h
      real :: ang, dec, rr

!--------------------------------------------------------------------
!    be sure the time in the annual cycle is legitimate.
!---------------------------------------------------------------------
      if (time_since_ae < 0.0 .or. time_since_ae > twopi) &
        call error_mesg('astronomy_mod', &
                        'time_since_ae not between 0 and 2pi', FATAL)

!---------------------------------------------------------------------
!    define the orbital angle (location in year), solar declination,
!    half-day length and earth sun distance factor. use functions 
!    contained in this module.
!---------------------------------------------------------------------
      ang = angle (time_since_ae)
      dec = declination(ang)
      h   = half_day    (lat, dec)
      rr  = r_inv_squared (ang)

!---------------------------------------------------------------------
!    where the entire day is dark, define cosz to be zero. otherwise
!    use the standard formula. define the daylight fraction and earth-
!    sun distance.
!---------------------------------------------------------------------
      where (h == 0.0)
        cosz = 0.0
      elsewhere
        cosz = sin(lat)*sin(dec) + cos(lat)*cos(dec)*sin(h)/h
      end where
      h_out = h/PI
      rr_out = rr
!--------------------------------------------------------------------

end subroutine daily_mean_solar_2d



!#####################################################################
! <SUBROUTINE NAME="daily_mean_solar_1d">
!  <OVERVIEW>
!    daily_mean_solar_1d takes 1-d input fields, adds a second dimension
!    and calls daily_mean_solar_2d. on return, the 2d fields are 
!    returned to the original 1d fields.
!  </OVERVIEW>
!  <DESCRIPTION>
!    daily_mean_solar_1d takes 1-d input fields, adds a second dimension
!    and calls daily_mean_solar_2d. on return, the 2d fields are 
!    returned to the original 1d fields.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call daily_mean_solar_1d (lat, time_since_ae, cosz, h_out, rr_out)
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN> 
!  <IN NAME="time_since_ae" TYPE="real">
!   time of year; autumnal equinox = 0.0,
!                    one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="h_out" TYPE="real">
!   2-d array of half-day lengths at the latitudes
!  </OUT>
!  <OUT NAME="rr_out" TYPE="real">
!   the inverse of the square of the earth-sun
!    distance relative to the mean distance at angle ang in the earth's
!    orbit.
!  </OUT>
! </SUBROUTINE>
!
subroutine daily_mean_solar_1d (lat, time_since_ae, cosz, h_out, rr_out)

!--------------------------------------------------------------------
!    daily_mean_solar_1d takes 1-d input fields, adds a second dimension
!    and calls daily_mean_solar_2d. on return, the 2d fields are 
!    returned to the original 1d fields.
!----------------------------------------------------------------------

!----------------------------------------------------------------------
real, intent(in), dimension(:) :: lat
real, intent(in) :: time_since_ae
real, intent(out), dimension(size(lat(:))) ::        cosz
real, intent(out), dimension(size(lat(:)))           :: h_out
real, intent(out)           :: rr_out
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!   local variables

      real, dimension(size(lat),1) :: lat_2d, cosz_2d, hout_2d

!--------------------------------------------------------------------
!    define 2-d versions of input data array.
!--------------------------------------------------------------------
      lat_2d(:,1) = lat

!--------------------------------------------------------------------
!    call daily_mean_solar_2d to calculate astronomy fields.
!--------------------------------------------------------------------
      call daily_mean_solar_2d (lat_2d, time_since_ae, cosz_2d,      &
                                hout_2d, rr_out)

!-------------------------------------------------------------------
!    place output fields into 1-d arguments for return to 
!    calling routine.
!-------------------------------------------------------------------
      h_out = hout_2d(:,1)
      cosz  = cosz_2d(:,1)


end subroutine daily_mean_solar_1d


!######################################################################
! <SUBROUTINE NAME="daily_mean_solar_2level">
!  <OVERVIEW>
!    daily_mean_solar_2level takes 1-d input fields, adds a second 
!    dimension and calls daily_mean_solar_2d. on return, the 2d fields 
!    are returned to the original 1d fields.
!  </OVERVIEW>
!  <DESCRIPTION>
!    daily_mean_solar_2level takes 1-d input fields, adds a second 
!    dimension and calls daily_mean_solar_2d. on return, the 2d fields 
!    are returned to the original 1d fields.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call daily_mean_solar_2level (lat, time_since_ae, cosz, solar)
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN> 
!  <IN NAME="time_since_ae" TYPE="real">
!   time of year; autumnal equinox = 0.0,
!                    one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="solar" TYPE="real">
!   shortwave flux factor: cosine of zenith angle *
!                    daylight fraction / (earth-sun distance squared)
!  </OUT>
! </SUBROUTINE>
!
subroutine daily_mean_solar_2level (lat, time_since_ae, cosz, solar)

!--------------------------------------------------------------------
!    daily_mean_solar_2level takes 1-d input fields, adds a second 
!    dimension and calls daily_mean_solar_2d. on return, the 2d fields 
!    are returned to the original 1d fields.
!----------------------------------------------------------------------

!----------------------------------------------------------------------
real, intent(in), dimension(:)          :: lat
real, intent(in)                        :: time_since_ae
real, intent(out), dimension(size(lat(:))) :: cosz, solar
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!   local variables

      real, dimension(size(lat),1) :: lat_2d, cosz_2d, hout_2d
      real                         :: rr_out

!--------------------------------------------------------------------
!    define 2-d versions of input data array.
!--------------------------------------------------------------------
      lat_2d(:,1) = lat

!--------------------------------------------------------------------
!    call daily_mean_solar_2d to calculate astronomy fields.
!--------------------------------------------------------------------
      call daily_mean_solar_2d (lat_2d, time_since_ae, cosz_2d,      &
                                hout_2d, rr_out)

!-------------------------------------------------------------------
!    place output fields into 1-d arguments for return to 
!    calling routine.
!-------------------------------------------------------------------
      solar = cosz_2d(:,1)*hout_2d(:,1)*rr_out
      cosz  = cosz_2d(:,1)


end subroutine daily_mean_solar_2level



!####################################################################
! <SUBROUTINE NAME="daily_mean_solar_0d">
!  <OVERVIEW>
!    daily_mean_solar_1d takes 1-d input fields, adds a second dimension
!    and calls daily_mean_solar_2d. on return, the 2d fields are 
!    returned to the original 1d fields.
!  </OVERVIEW>
!  <DESCRIPTION>
!    daily_mean_solar_1d takes 1-d input fields, adds a second dimension
!    and calls daily_mean_solar_2d. on return, the 2d fields are 
!    returned to the original 1d fields.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call daily_mean_solar_0d (lat, time_since_ae, cosz, h_out, rr_out)
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN> 
!  <IN NAME="time_since_ae" TYPE="real">
!   time of year; autumnal equinox = 0.0,
!                    one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="h_out" TYPE="real">
!   2-d array of half-day lengths at the latitudes
!  </OUT>
!  <OUT NAME="rr_out" TYPE="real">
!   the inverse of the square of the earth-sun
!    distance relative to the mean distance at angle ang in the earth's
!    orbit.
!  </OUT>
! </SUBROUTINE>
!
subroutine daily_mean_solar_0d (lat, time_since_ae, cosz, h_out, rr_out)

!--------------------------------------------------------------------
!    daily_mean_solar_1d takes 1-d input fields, adds a second dimension
!    and calls daily_mean_solar_2d. on return, the 2d fields are 
!    returned to the original 1d fields.
!----------------------------------------------------------------------

real, intent(in)         :: lat, time_since_ae
real, intent(out)        :: cosz, h_out, rr_out

!--------------------------------------------------------------------
!   local variables

      real, dimension(1,1) :: lat_2d, cosz_2d, hout_2d

!--------------------------------------------------------------------
!    define 2-d versions of input data array.
!--------------------------------------------------------------------
      lat_2d = lat

!--------------------------------------------------------------------
!    call daily_mean_solar_2d to calculate astronomy fields.
!--------------------------------------------------------------------
      call daily_mean_solar_2d (lat_2d, time_since_ae, cosz_2d,     &
                                hout_2d, rr_out)

!-------------------------------------------------------------------
!    return output fields to scalars for return to calling routine.
!-------------------------------------------------------------------
      h_out = hout_2d(1,1)
      cosz  = cosz_2d(1,1)


end subroutine daily_mean_solar_0d

!####################################################################
! <SUBROUTINE NAME="daily_mean_solar_cal_2d">
!  <OVERVIEW>
!    daily_mean_solar_cal_2d receives time_type inputs, converts 
!    them to real variables and then calls daily_mean_solar_2d to
!    compute desired astronomical variables.
!  </OVERVIEW>
!  <DESCRIPTION>
!    daily_mean_solar_cal_2d receives time_type inputs, converts 
!    them to real variables and then calls daily_mean_solar_2d to
!    compute desired astronomical variables.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call daily_mean_solar_cal_2d (lat, time, cosz, fracday, rrsun) 
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN>
!  <IN NAME="time" TYPE="time_type">
!   time of year; autumnal equinox = 0.0, one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="fracday" TYPE="real">
!   daylight fraction of time interval
!  </OUT>
!  <OUT NAME="rrsun" TYPE="real">
!   earth-sun distance (r) relative to semi-major axis
!                    of orbital ellipse (a) : (a/r)**2
!  </OUT>
! </SUBROUTINE>
!
subroutine daily_mean_solar_cal_2d (lat, time, cosz, fracday, rrsun) 

!-------------------------------------------------------------------
!    daily_mean_solar_cal_2d receives time_type inputs, converts 
!    them to real variables and then calls daily_mean_solar_2d to
!    compute desired astronomical variables.
!-------------------------------------------------------------------
 
!-------------------------------------------------------------------
real, dimension(:,:), intent(in)  :: lat
type(time_type),      intent(in)  :: time
real, dimension(:,:), intent(out) :: cosz, fracday
real,                 intent(out) :: rrsun
!-------------------------------------------------------------------

!-------------------------------------------------------------------
!  local variables

      real :: time_since_ae

!--------------------------------------------------------------------
!    be sure the time in the annual cycle is legitimate.
!---------------------------------------------------------------------
      time_since_ae = orbital_time(time)
      if (time_since_ae < 0.0 .or. time_since_ae > twopi) &
          call error_mesg ('astronomy_mod', &
                         'time_since_ae not between 0 and 2pi', FATAL)

!--------------------------------------------------------------------
!    call daily_mean_solar_2d to calculate astronomy fields.
!--------------------------------------------------------------------
      call daily_mean_solar_2d (lat, time_since_ae, cosz,        &
                                fracday, rrsun)


end subroutine daily_mean_solar_cal_2d



!#####################################################################
! <SUBROUTINE NAME="daily_mean_solar_cal_1d">
!  <OVERVIEW>
!    daily_mean_solar_cal_1d receives time_type inputs, converts 
!    them to real, 2d variables and then calls daily_mean_solar_2d to
!    compute desired astronomical variables.
!  </OVERVIEW>
!  <DESCRIPTION>
!    daily_mean_solar_cal_1d receives time_type inputs, converts 
!    them to real, 2d variables and then calls daily_mean_solar_2d to
!    compute desired astronomical variables.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call daily_mean_solar_cal_1d (lat, time, cosz, fracday, rrsun) 
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN>
!  <IN NAME="time" TYPE="time_type">
!   time of year; autumnal equinox = 0.0, one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="fracday" TYPE="real">
!   daylight fraction of time interval
!  </OUT>
!  <OUT NAME="rrsun" TYPE="real">
!   earth-sun distance (r) relative to semi-major axis
!                    of orbital ellipse (a) : (a/r)**2
!  </OUT>
! </SUBROUTINE>
!
subroutine daily_mean_solar_cal_1d (lat, time, cosz, fracday, rrsun) 

!-------------------------------------------------------------------
!    daily_mean_solar_cal_1d receives time_type inputs, converts 
!    them to real, 2d variables and then calls daily_mean_solar_2d to
!    compute desired astronomical variables.
!-------------------------------------------------------------------

real, dimension(:),  intent(in)   :: lat
type(time_type),     intent(in)   :: time
real, dimension(:),  intent(out)  :: cosz, fracday
real,                intent(out)  :: rrsun

!---------------------------------------------------------------------
!  local variables

      real, dimension(size(lat),1) :: lat_2d, cosz_2d, fracday_2d
       

!--------------------------------------------------------------------
!    define 2-d versions of input data array.
!--------------------------------------------------------------------
      lat_2d(:,1) = lat

!--------------------------------------------------------------------
!    call daily_mean_solar_cal_2d to convert the time_types to reals and
!    then calculate the astronomy fields.
!--------------------------------------------------------------------
      call daily_mean_solar_cal_2d (lat_2d, time, cosz_2d,   &
                                    fracday_2d, rrsun)

!-------------------------------------------------------------------
!    place output fields into 1-d arguments for return to 
!    calling routine.
!-------------------------------------------------------------------
      fracday = fracday_2d(:,1)
      cosz  = cosz_2d(:,1)


end subroutine daily_mean_solar_cal_1d


!###################################################################
! <SUBROUTINE NAME="daily_mean_solar_cal_2level">
!  <OVERVIEW>
!    daily_mean_solar_cal_2level receives 1d arrays and time_type input,
!    converts them to real, 2d variables and then calls 
!    daily_mean_solar_2d to compute desired astronomical variables.
!  </OVERVIEW>
!  <DESCRIPTION>
!    daily_mean_solar_cal_2level receives 1d arrays and time_type input,
!    converts them to real, 2d variables and then calls 
!    daily_mean_solar_2d to compute desired astronomical variables.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call daily_mean_solar_cal_2level (lat, time, cosz, solar) 
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN>
!  <IN NAME="time" TYPE="time_type">
!   time of year; autumnal equinox = 0.0, one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="solar" TYPE="real">
!   shortwave flux factor: cosine of zenith angle *
!                    daylight fraction / (earth-sun distance squared)
!  </OUT>
! </SUBROUTINE>
!
subroutine daily_mean_solar_cal_2level (lat, time, cosz, solar) 

!-------------------------------------------------------------------
!    daily_mean_solar_cal_2level receives 1d arrays and time_type input,
!    converts them to real, 2d variables and then calls 
!    daily_mean_solar_2d to compute desired astronomical variables.
!-------------------------------------------------------------------

real, dimension(:),  intent(in)   :: lat
type(time_type),     intent(in)   :: time
real, dimension(:),  intent(out)  :: cosz, solar

!---------------------------------------------------------------------
!  local variables

      real, dimension(size(lat),1) :: lat_2d, cosz_2d, fracday_2d
      real                         :: rrsun
       

!--------------------------------------------------------------------
!    define 2-d versions of input data array.
!--------------------------------------------------------------------
      lat_2d(:,1) = lat

!--------------------------------------------------------------------
!    call daily_mean_solar_cal_2d to convert the time_types to reals and
!    then calculate the astronomy fields.
!--------------------------------------------------------------------
      call daily_mean_solar_cal_2d (lat_2d, time, cosz_2d,   &
                                    fracday_2d, rrsun)

!-------------------------------------------------------------------
!    place output fields into 1-d arguments for return to 
!    calling routine.
!-------------------------------------------------------------------
      solar = cosz_2d(:,1)*fracday_2d(:,1)*rrsun
      cosz  = cosz_2d(:,1)


end subroutine daily_mean_solar_cal_2level



!###################################################################
! <SUBROUTINE NAME="daily_mean_solar_cal_2level_radwt">
!  <OVERVIEW>
!    daily_mean_solar_cal_2level_radwt receives 1d arrays and time_type input.
!    It uses code copied from daily_mean_solar_2d to compute desired astronomical variables.
!    In addition to daily_mean solar, also radiation-weighted cosz
!    is computed.
!  </OVERVIEW>
!  <DESCRIPTION>
!    daily_mean_solar_cal_2level receives 1d arrays and time_type input.
!    It uses code copied from daily_mean_solar_2d to compute desired astronomical variables.
!    In addition to daily_mean solar, also radiation-weighted cosz
!    is computed. [Georg Feulner: Radiation-weighted daily average solar zenith angle, 27.11.13]
!    Blowing-up to 2-D variables is avoided here.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call daily_mean_solar_cal_2level_radwt (lat, time, cosz, solar, cosz_radwt) 
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN>
!  <IN NAME="time" TYPE="time_type">
!   time of year
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="solar" TYPE="real">
!   shortwave flux factor: cosine of zenith angle *
!                    daylight fraction / (earth-sun distance squared)
!  </OUT>
!  <OUT NAME="cosz_radwt" TYPE="real">
!   radiation-weighted cosine of solar zenith angle
!  </OUT>
! </SUBROUTINE>
!
subroutine daily_mean_solar_cal_2level_radwt (lat, time, cosz, solar, cosz_radwt) 

  real, dimension(:),  intent(in)   :: lat
  type(time_type),     intent(in)   :: time
  real, dimension(:),  intent(out)  :: cosz, solar, cosz_radwt

!---------------------------------------------------------------------
!  local variables

  real                         :: rrsun ! earth-sun distance (r) relative to semi-major axis
                                        ! of orbital ellipse (a) : (a/r)**2
                                        ! [ dimensionless ]
  real, dimension(size(lat,1)) :: lat2  ! lat with slightly shifted poles to avoid singularity in tangens
  real, dimension(size(lat,1)) :: tan_lat, sin_lat, cos_lat
  real, dimension(size(lat,1)) :: cos_half_day
  real, dimension(size(lat,1)) :: HA_SS ! hour angle at sunset; same as half_day elsewhere in this module
  real, dimension(size(lat,1)) :: sin_HA_SS
  real, dimension(size(lat,1)) :: fracday
  real, dimension(size(lat,1)) :: factor_A
  real                         :: time_since_ae ! time of year; autumnal equinox = 0.0,
                                                ! one year = 2 * pi
                                                ! [ radians ]
  real                         :: ang ! orbital position relative to NH autumnal equinox [ radians ]
  real                         :: dec ! solar declination angle in earth's orbit
  real                         :: tan_dec, sin_dec, cos_dec
  real                         :: eps = 1.0E-05
  integer                      :: i

!    code from daily_mean_solar_cal_2d: convert the time_types to reals and
!    then calculate the astronomy fields.
  time_since_ae = orbital_time(time)

!    code from daily_mean_solar_2d: calculate the astronomy fields.
  ang = angle (time_since_ae)
  dec = declination(ang)
  rrsun = r_inv_squared(ang)

!    code adapted from half_day_2d
  tan_dec = tan(dec)
  !    adjust latitude so that its tangent will be defined.
  ! TODO: compare to range 0.5*PI +/- eps instead of rounded 0.5*PI
  where (lat == 0.5*PI)
     lat2 = lat - eps
  elsewhere
     where (lat == -0.5*PI)
        lat2 = lat + eps
     elsewhere
        lat2 = lat
     end where
  end where
  tan_lat = tan(lat2)
  !    define the cosine of the half-day length. adjust for cases of
  !    all daylight or all night.
  cos_half_day = -tan_lat * tan_dec
  where (cos_half_day <= -1.0)
     HA_SS = PI
  elsewhere
     where (cos_half_day >= +1.0)
        HA_SS = 0.0
     elsewhere
        HA_SS = acos(cos_half_day)
     end where
  end where
  !where(cos_half_day > -1.0 .and. cos_half_day < 1.0) HA_SS = acos(cos_half_day)

!    code from daily_mean_solar_2d
  !    where the entire day is dark, define cosz to be zero. otherwise
  !    use the standard formula. define the daylight fraction and earth-
  !    sun distance.
  !write(*,*) 'HA_SS', HA_SS
  !write(*,*) 'lat', lat
  !write(*,*) 'dec', dec
!    new code
! 
  sin_lat(:)=sin(lat(:))
  !write(*,*) 'sin_lat', sin_lat
  cos_lat(:)=cos(lat(:))
  !write(*,*) 'cos_lat', cos_lat
  sin_dec=sin(dec)
  !write(*,*) 'sin_dec', sin_dec
  cos_dec=cos(dec)
  !write(*,*) 'cos_dec', cos_dec
  sin_HA_SS(:) = sin(HA_SS(:))
  !write(*,*) 'sin_HA_SS', sin_HA_SS
  !write(*,*) 'sin(lat)*sin(dec)', sin_lat*sin_dec
  !write(*,*) 'cos(lat)*cos(dec)', cos_lat*cos_dec
  !write(*,*) 'daily_mean_solar_cal_2level_radwt: size lat ',size(lat), 'bounds', lbound(lat), ubound(lat)
  !write(*,*) '  size cosz ', size(cosz), 'bounds', lbound(cosz), ubound(cosz)
  !write(*,*) '  size HA_SS ', size(HA_SS), 'bounds', lbound(HA_SS), ubound(HA_SS)
!    code from daily_mean_solar_2d
  where (HA_SS .eq. 0) ! (HA_SS .lt. eps .and. HA_SS .gt. -eps)
     cosz = 0.0
  elsewhere
  !   cosz = sin(lat)*sin(dec) + cos(lat)*cos(dec)*sin(HA_SS)/HA_SS
     cosz = sin_lat*sin_dec + cos_lat*cos_dec*sin_HA_SS/HA_SS
  end where
  ! Sigh deeply. ifort 17.0.4 produces buggy code for the above where-construct
  ! when compiling with options -O3 -xCORE-AVX2 -qno-opt-dynamic-align ,
  ! also with -fp-model precise . It works correctly with -fp-model consistent ,
  ! or without vectorization.
  ! Symptoms: Error: floating invalid is raised in the elsewhere branch.
  ! The same problem occurs when the where-construct is replaced by an explicit do-loop.
  ! Also, when the write-statement inside the do-loop is un-commented,
  ! it apparently prevents the buggy optimization.
  !do i=1,size(cosz)
  !   if (HA_SS(i) .eq. 0) then
  !      cosz(i) = 0.0
  !   else
  !      !write(*,*) i !, HA_SS(i), sin_HA_SS(i)
  !      !flush(*)
  !      cosz(i) = sin_lat(i)*sin_dec + cos_lat(i)*cos_dec*sin_HA_SS(i)/HA_SS(i)
  !   end if
  !end do
  !write(*,*) 'finished cosz', cosz
  fracday = HA_SS/PI
  
!    code from daily_mean_solar_cal_2level
  solar = cosz*fracday*rrsun

!    new code
! 
  factor_A = 2 * sin_lat**2 * sin_dec**2 * HA_SS &
       + 4 * sin_lat * sin_dec * cos_lat * cos_dec * sin_HA_SS &
       + cos_lat**2 * cos_dec**2 * (HA_SS + sin(2*HA_SS)/2) ! from G.F. 27.11.13
  where (cosz > 0) 
     ! Note: <\cos\theta_\mbox{s}> in the equations of G.F. is equal to astronomy_mod HA_SS*cosz/PI
     cosz_radwt = factor_A / (2*cosz*HA_SS) ! from G.F. 28.11.13
  elsewhere
     cosz_radwt = 0
  end where

end subroutine daily_mean_solar_cal_2level_radwt




!###################################################################
! <SUBROUTINE NAME="daily_mean_solar_cal_0d">
!  <OVERVIEW>
!    daily_mean_solar_cal_0d converts scalar input fields to real, 
!    2d variables and then calls daily_mean_solar_2d to compute desired
!    astronomical variables.
!  </OVERVIEW>
!  <DESCRIPTION>
!    daily_mean_solar_cal_0d converts scalar input fields to real, 
!    2d variables and then calls daily_mean_solar_2d to compute desired
!    astronomical variables.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call daily_mean_solar_cal_0d (lat, time, cosz, fracday, rrsun) 
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN>
!  <IN NAME="time" TYPE="time_type">
!   time of year; autumnal equinox = 0.0, one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="fracday" TYPE="real">
!   daylight fraction of time interval
!  </OUT>
!  <OUT NAME="rrsun" TYPE="real">
!   earth-sun distance (r) relative to semi-major axis
!                    of orbital ellipse (a) : (a/r)**2
!  </OUT>
! </SUBROUTINE>
!
subroutine daily_mean_solar_cal_0d (lat, time, cosz, fracday, rrsun) 

!-------------------------------------------------------------------
!    daily_mean_solar_cal_0d converts scalar input fields to real, 
!    2d variables and then calls daily_mean_solar_2d to compute desired
!    astronomical variables.
!-------------------------------------------------------------------

!--------------------------------------------------------------------
real,             intent(in)  :: lat
type(time_type),  intent(in)  :: time
real,             intent(out) :: cosz, fracday, rrsun
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables

      real, dimension(1,1) :: lat_2d, cosz_2d, fracday_2d

!--------------------------------------------------------------------
!    define 2-d versions of input data array.
!--------------------------------------------------------------------
      lat_2d = lat

!--------------------------------------------------------------------
!    call daily_mean_solar_cal_2d to convert the time_types to reals and
!    then calculate the astronomy fields.
!--------------------------------------------------------------------
      call daily_mean_solar_cal_2d (lat_2d, time, cosz_2d,           &
                                    fracday_2d, rrsun)

!-------------------------------------------------------------------
!    place output fields into scalar arguments for return to 
!    calling routine.
!-------------------------------------------------------------------
      fracday = fracday_2d(1,1)
      cosz  = cosz_2d(1,1)


end subroutine daily_mean_solar_cal_0d



!####################################################################

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                END INTERFACE DAILY_MEAN_SOLAR
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                   INTERFACE ANNUAL_MEAN_SOLAR
!
!  call annual_mean_solar (js, je, lat, cosz, solar, fracday, rrsun)
!     or
!  call annual_mean_solar (lat, cosz, solar)
!
!  the second interface above is used by the spectral 2-layer model,
!  which requires only cosz and solar as output arguments, and which
!  makes this call during the initialization phase of the model.

!  separate routines exist within this interface for 1D or 2D input 
!  and output fields:
!
!    real, intent(in), dimension(:,:) :: lat
! OR real, intent(in), dimension(:)   :: lat
!
!    real, intent(out), dimension(:,:) :: cosz, solar, fracday
! OR real, intent(out), dimension(:)   :: cosz, solar, fracday
!
!---------------------------------------------------------------------
!  intent(in) variables: 
!
!     js, je         starting/ ending subdomain j indices of data in 
!                    the physics wiondow being integrated
!     lat            latitudes of model grid points 
!                    [ radians ]
!     
!
!  intent(out) variables:
!
!     cosz           cosz is the average over the year of the cosine of
!                    an effective zenith angle that would produce the 
!                    correct daily solar flux if the sun were fixed at 
!                    that single position for the period of daylight on
!                    the given day. in this average, the daily mean 
!                    effective cosz is weighted by the daily mean solar 
!                    flux.
!                    [ dimensionless ]
!     solar          normalized solar flux, averaged over the year, 
!                    equal to the product of fracday*cosz*rrsun
!                    [ dimensionless ]
!     fracday        daylight fraction calculated so as to make the 
!                    average flux (solar) equal to the product of the
!                    flux-weighted avg cosz * this fracday * assumed 
!                    annual mean avg earth-sun distance of 1.0.
!                    [ dimensionless ]
!     rrsun          annual mean earth-sun distance (r) relative to 
!                    semi-major axis of orbital ellipse (a); assumed
!                    to be 1.0
!                    [ dimensionless ]
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





!--------------------------------------------------------------
! <SUBROUTINE NAME="annual_mean_solar_2d">
!  <OVERVIEW>
!    annual_mean_solar_2d returns 2d fields of annual mean values of
!    the cosine of zenith angle, daylight fraction and earth-sun 
!    distance at the specified latitude.
!  </OVERVIEW>
!  <DESCRIPTION>
!    annual_mean_solar_2d returns 2d fields of annual mean values of
!    the cosine of zenith angle, daylight fraction and earth-sun 
!    distance at the specified latitude.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call annual_mean_solar_2d (js, je, lat, cosz, solar, fracday,  &
!                                 rrsun)
!  </TEMPLATE>
!  <IN NAME="js, je" TYPE="real">
!   Starting/ending index of latitude window
!  </IN>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN>
!  <IN NAME="time" TYPE="time_type">
!   time of year; autumnal equinox = 0.0, one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="solar" TYPE="real">
!   shortwave flux factor: cosine of zenith angle *
!                    daylight fraction / (earth-sun distance squared)
!  </OUT>
!  <OUT NAME="fracday" TYPE="real">
!   daylight fraction of time interval
!  </OUT>
!  <OUT NAME="rrsun" TYPE="real">
!   earth-sun distance (r) relative to semi-major axis
!                    of orbital ellipse (a) : (a/r)**2
!  </OUT>
! </SUBROUTINE>
!
subroutine annual_mean_solar_2d (js, je, lat, cosz, solar, fracday,  &
                                 rrsun)

!---------------------------------------------------------------------
!    annual_mean_solar_2d returns 2d fields of annual mean values of
!    the cosine of zenith angle, daylight fraction and earth-sun 
!    distance at the specified latitude. 
!---------------------------------------------------------------------

!--------------------------------------------------------------------
integer,                 intent(in)    :: js, je
real, dimension(:,:),    intent(in)    :: lat
real, dimension(:,:),    intent(out)   :: solar, cosz, fracday
real,                    intent(out)   :: rrsun
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables

      real, dimension(size(lat,1),size(lat,2)) :: s,z
      real    :: t
      integer :: n, i

!--------------------------------------------------------------------
!    if the calculation has not yet been done, do it here.
!--------------------------------------------------------------------
      if (.not. annual_mean_calculated) then

!----------------------------------------------------------------------
!    determine annual mean values of solar flux and product of cosz 
!    and solar flux by integrating the annual cycle in num_angles 
!    orbital increments.
!----------------------------------------------------------------------
        solar = 0.0
        cosz = 0.0
        do n =1, num_angles
          t = float(n-1)*twopi/float(num_angles)
          call daily_mean_solar(lat,t, z, fracday, rrsun)
          s = z*rrsun*fracday
          solar = solar + s
          cosz  = cosz  + z*s
        end do
        solar = solar/float(num_angles)
        cosz  = cosz/float(num_angles)

!--------------------------------------------------------------------
!   define the flux-weighted annual mean cosine of the zenith angle.
!--------------------------------------------------------------------
        where(solar.eq.0.0) 
          cosz = 0.0
        elsewhere
          cosz = cosz/solar
        end where

!-------------------------------------------------------------------
!    define avg fracday such as to make the avg flux (solar) equal to 
!    the product of the avg cosz * avg fracday * assumed mean avg 
!    radius of 1.0. it is unlikely that these avg fracday and avg rr 
!    will ever be used.
!--------------------------------------------------------------------
        where(solar  .eq.0.0) 
          fracday = 0.0
        elsewhere
          fracday = solar/cosz
        end where
        rrsun = 1.00

!---------------------------------------------------------------------
!    save the values that have been calculated as module variables, if
!    those variables are present; i.e., not the spectral 2-layer model.
!---------------------------------------------------------------------
        if (allocated (cosz_ann)) then
          cosz_ann    = cosz
          solar_ann   = solar
          fracday_ann = fracday
          rrsun_ann = rrsun

!--------------------------------------------------------------------
!    increment the points computed counter. set flag to end execution
!    once values have been calculated for all points owned by the 
!    processor.
!--------------------------------------------------------------------
          num_pts = num_pts + size(lat,1)*size(lat,2)
          if ( num_pts == total_pts)  annual_mean_calculated = .true.
        endif

!--------------------------------------------------------------------
!    if the calculation has been done, return the appropriate module 
!    variables.
!--------------------------------------------------------------------
      else
        if (allocated (cosz_ann)) then
          cosz    = cosz_ann
          solar   = solar_ann
          fracday = fracday_ann
          rrsun = rrsun_ann
        endif
      endif

!----------------------------------------------------------------------


end subroutine annual_mean_solar_2d



!#####################################################################
! <SUBROUTINE NAME="annual_mean_solar_1d">
!  <OVERVIEW>
!    annual_mean_solar_1d creates 2-d input fields from 1-d input fields
!    and then calls annual_mean_solar_2d to obtain 2-d output fields 
!    which are then stored into 1-d fields for return to the calling 
!    subroutine.
!  </OVERVIEW>
!  <DESCRIPTION>
!    annual_mean_solar_1d creates 2-d input fields from 1-d input fields
!    and then calls annual_mean_solar_2d to obtain 2-d output fields 
!    which are then stored into 1-d fields for return to the calling 
!    subroutine.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call annual_mean_solar_1d (jst, jnd, lat, cosz, solar,  &
!                                 fracday, rrsun_out)
!  </TEMPLATE>
!  <IN NAME="jst, jnd" TYPE="real">
!   Starting/ending index of latitude window
!  </IN>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN>
!  <IN NAME="time" TYPE="time_type">
!   time of year; autumnal equinox = 0.0, one year = 2 * pi
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="solar" TYPE="real">
!   shortwave flux factor: cosine of zenith angle *
!                    daylight fraction / (earth-sun distance squared)
!  </OUT>
!  <OUT NAME="fracday" TYPE="real">
!   daylight fraction of time interval
!  </OUT>
!  <OUT NAME="rrsun_out" TYPE="real">
!   earth-sun distance (r) relative to semi-major axis
!                    of orbital ellipse (a) : (a/r)**2
!  </OUT>
! </SUBROUTINE>
!
subroutine annual_mean_solar_1d (jst, jnd, lat, cosz, solar,  &
                                 fracday, rrsun_out)

!---------------------------------------------------------------------
!    annual_mean_solar_1d creates 2-d input fields from 1-d input fields
!    and then calls annual_mean_solar_2d to obtain 2-d output fields 
!    which are then stored into 1-d fields for return to the calling 
!    subroutine.
!---------------------------------------------------------------------

!---------------------------------------------------------------------
integer,            intent(in)     :: jst, jnd
real, dimension(:), intent(in)     :: lat(:)
real, dimension(:), intent(out)    :: cosz, solar,  fracday
real,               intent(out)    :: rrsun_out
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables

      real, dimension(size(lat),1) :: lat_2d, solar_2d, cosz_2d,   &
                                      fracday_2d
      real :: rrsun

!--------------------------------------------------------------------
!    if the calculation has not been done, do it here.
!--------------------------------------------------------------------
      if ( .not. annual_mean_calculated) then

!--------------------------------------------------------------------
!    define 2-d versions of input data array.
!--------------------------------------------------------------------
        lat_2d(:,1) = lat

!--------------------------------------------------------------------
!    call annual_mean_solar_2d to calculate the astronomy fields.
!--------------------------------------------------------------------
        call annual_mean_solar_2d (jst, jnd, lat_2d, cosz_2d,   &
                                   solar_2d, fracday_2d, rrsun)

!-------------------------------------------------------------------
!    place output fields into 1-D arrays for return to calling routine.
!-------------------------------------------------------------------
        fracday = fracday_2d(:,1)
        rrsun_out = rrsun
        solar = solar_2d(:,1)
        cosz  =  cosz_2d(:,1)

!--------------------------------------------------------------------
!    if the calculation has been done, simply return the module 
!    variables contain the results at the desired latitudes.
!--------------------------------------------------------------------
      else
        cosz(:)    = cosz_ann(1,jst:jnd)
        solar(:)   = solar_ann(1,jst:jnd)
        fracday(:) = fracday_ann(1,jst:jnd)
        rrsun      = rrsun_ann
      endif

end subroutine annual_mean_solar_1d



!####################################################################
! <SUBROUTINE NAME="annual_mean_solar_2level">
!  <OVERVIEW>
!    annual_mean_solar_2level creates 2-d input fields from 1-d input 
!    fields and then calls annual_mean_solar_2d to obtain 2-d output 
!    fields which are then stored into 1-d fields for return to the 
!    calling subroutine. this subroutine will be called during model
!    initialization.
!  </OVERVIEW>
!  <DESCRIPTION>
!    annual_mean_solar_2level creates 2-d input fields from 1-d input 
!    fields and then calls annual_mean_solar_2d to obtain 2-d output 
!    fields which are then stored into 1-d fields for return to the 
!    calling subroutine. this subroutine will be called during model
!    initialization.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call annual_mean_solar_2level (lat, cosz, solar)
!  </TEMPLATE>
!  <IN NAME="lat" TYPE="real">
!   latitudes of model grid points 
!  </IN>
!  <OUT NAME="cosz" TYPE="real">
!   cosine of solar zenith angle
!  </OUT>
!  <OUT NAME="solar" TYPE="real">
!   shortwave flux factor: cosine of zenith angle *
!                    daylight fraction / (earth-sun distance squared)
!  </OUT>
! </SUBROUTINE>
!
subroutine annual_mean_solar_2level (lat, cosz, solar)

!---------------------------------------------------------------------
!    annual_mean_solar_2level creates 2-d input fields from 1-d input 
!    fields and then calls annual_mean_solar_2d to obtain 2-d output 
!    fields which are then stored into 1-d fields for return to the 
!    calling subroutine. this subroutine will be called during model
!    initialization.
!---------------------------------------------------------------------

!---------------------------------------------------------------------
real, dimension(:), intent(in)     :: lat
real, dimension(:), intent(out)    :: cosz, solar
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables

      real, dimension(size(lat),1) :: lat_2d, solar_2d, cosz_2d,   &
                                      fracday_2d
      integer :: jst, jnd
      real    :: rrsun

!--------------------------------------------------------------------
!    if the calculation has not been done, do it here.
!--------------------------------------------------------------------
      if ( .not. annual_mean_calculated) then

!--------------------------------------------------------------------
!    define 2-d versions of input data array.
!--------------------------------------------------------------------
        lat_2d(:,1) = lat
        jst = 1
        jnd = size(lat(:))

!--------------------------------------------------------------------
!    call annual_mean_solar_2d to calculate the astronomy fields.
!--------------------------------------------------------------------
        call annual_mean_solar_2d (jst, jnd, lat_2d, cosz_2d,   &
                                   solar_2d, fracday_2d, rrsun)

!-------------------------------------------------------------------
!    place output fields into 1-D arrays for return to calling routine.
!-------------------------------------------------------------------
        solar = solar_2d(:,1)
        cosz  =  cosz_2d(:,1)

!--------------------------------------------------------------------
!    if the calculation has been done, print an error message since
!    this subroutine should be called only once.
!--------------------------------------------------------------------
      else
        call error_mesg ('astronomy_mod', &
            'annual_mean_solar_2level should be called only once', &
                                                                 FATAL)
      endif
      annual_mean_calculated = .true.

end subroutine annual_mean_solar_2level


!####################################################################


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                END INTERFACE ANNUAL_MEAN_SOLAR
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!###################################################################
! <SUBROUTINE NAME="astronomy_end">
!  <OVERVIEW>
!    astronomy_init is the destructor for astronomy_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    astronomy_init is the destructor for astronomy_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call astronomy_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine astronomy_end

!----------------------------------------------------------------------
!    astronomy_end is the destructor for astronomy_mod.
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!    check if the module has been initialized.
!----------------------------------------------------------------------
      if (.not. module_is_initialized)  return 
!                call error_mesg ( 'astronomy_mod',  &
!                         ' module has not been initialized', FATAL)

!----------------------------------------------------------------------
!    deallocate module variables.
!----------------------------------------------------------------------
      deallocate (orb_angle)
      if (allocated(cosz_ann) ) then
        deallocate (cosz_ann)
        deallocate (fracday_ann)
        deallocate (solar_ann)
      endif

!----------------------------------------------------------------------
!    mark the module as uninitialized.
!----------------------------------------------------------------------
      module_is_initialized = .false.

!---------------------------------------------------------------------


end subroutine astronomy_end


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                    PRIVATE SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!####################################################################
! <SUBROUTINE NAME="orbit">
!  <OVERVIEW>
!    orbit computes and stores a table of value of orbital angles as a 
!    function of orbital time (both the angle and time are zero at 
!    autumnal equinox in the NH, and range from 0 to 2*pi).
!  </OVERVIEW>
!  <DESCRIPTION>
!    orbit computes and stores a table of value of orbital angles as a 
!    function of orbital time (both the angle and time are zero at 
!    autumnal equinox in the NH, and range from 0 to 2*pi).
!  </DESCRIPTION>
!  <TEMPLATE>
!   call orbit
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine orbit

!---------------------------------------------------------------------
!    orbit computes and stores a table of value of orbital angles as a 
!    function of orbital time (both the angle and time are zero at 
!    autumnal equinox in the NH, and range from 0 to 2*pi).
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables

      integer :: n
      real    :: d1, d2, d3, d4, d5, dt, norm

!--------------------------------------------------------------------
!    allocate the orbital angle array, sized by the namelist parameter
!    num_angles, defining the annual cycle resolution of the earth's
!    orbit. define some constants to be used.
!--------------------------------------------------------------------
! wfc moving to astronomy_init
!     allocate ( orb_angle(0:num_angles) )
      orb_angle(0) = 0.0
      dt = twopi/float(num_angles)
      norm = sqrt(1.0 - ecc**2)
      dt = dt*norm

!---------------------------------------------------------------------
!    define the orbital angle at each of the num_angles locations in 
!    the orbit.
!---------------------------------------------------------------------
      do n = 1, num_angles
        d1 = dt*r_inv_squared(orb_angle(n-1))
        d2 = dt*r_inv_squared(orb_angle(n-1)+0.5*d1)
        d3 = dt*r_inv_squared(orb_angle(n-1)+0.5*d2)
        d4 = dt*r_inv_squared(orb_angle(n-1)+d3)
        d5 = d1/6.0 + d2/3.0 +d3/3.0 +d4/6.0
        orb_angle(n) = orb_angle(n-1) + d5
      end do
  
!-------------------------------------------------------------------



end subroutine orbit



!###################################################################
! <FUNCTION NAME="r_inv_squared">
!  <OVERVIEW>
!    r_inv_squared returns the inverse of the square of the earth-sun
!    distance relative to the mean distance at angle ang in the earth's
!    orbit.
!  </OVERVIEW>
!  <DESCRIPTION>
!    r_inv_squared returns the inverse of the square of the earth-sun
!    distance relative to the mean distance at angle ang in the earth's
!    orbit.
!  </DESCRIPTION>
!  <TEMPLATE>
!    r = r_inv_squared (ang)
!  </TEMPLATE>
!  <IN NAME="ang" TYPE="real">
!    angular position of earth in its orbit, relative to a 
!            value of 0.0 at the NH autumnal equinox, value between
!            0.0 and 2 * pi
!  </IN>
! </FUNCTION>
!
function r_inv_squared (ang)

!--------------------------------------------------------------------
!    r_inv_squared returns the inverse of the square of the earth-sun
!    distance relative to the mean distance at angle ang in the earth's
!    orbit.
!--------------------------------------------------------------------

!--------------------------------------------------------------------
real, intent(in) :: ang
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!
!  intent(in) variables:
!
!      ang   angular position of earth in its orbit, relative to a 
!            value of 0.0 at the NH autumnal equinox, value between
!            0.0 and 2 * pi
!            [ radians ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables
 
      real :: r_inv_squared, r, rad_per

!---------------------------------------------------------------------
!  local variables:
!
!      r_inv_squared    the inverse of the square of the earth-sun
!                       distance relative to the mean distance 
!                       [ dimensionless ]
!      r                earth-sun distance relative to mean distance
!                       [ dimensionless ]
!      rad_per          angular position of perihelion 
!                       [ radians ]
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!    define the earth-sun distance (r) and then return the inverse of
!    its square (r_inv_squared) to the calling routine.
!--------------------------------------------------------------------
      rad_per       = per*deg_to_rad
      r             = (1. - ecc**2)/(1. + ecc*cos(ang - rad_per))
      r_inv_squared = r**(-2)


end function r_inv_squared




!####################################################################
! <FUNCTION NAME="angle">
!  <OVERVIEW>
!    angle determines the position within the earth's orbit at time t
!    in the year ( t = 0 at NH autumnal equinox.) by interpolating
!    into the orbital position table. 
!  </OVERVIEW>
!  <DESCRIPTION>
!    angle determines the position within the earth's orbit at time t
!    in the year ( t = 0 at NH autumnal equinox.) by interpolating
!    into the orbital position table. 
!  </DESCRIPTION>
!  <TEMPLATE>
!    r = angle (t)
!  </TEMPLATE>
!  <IN NAME="t" TYPE="real">
!    time of year (between 0 and 2*pi; t=0 at NH autumnal
!                equinox
!  </IN>
! </FUNCTION>
!
function angle (t)

!--------------------------------------------------------------------
!    angle determines the position within the earth's orbit at time t
!    in the year ( t = 0 at NH autumnal equinox.) by interpolating
!    into the orbital position table. 
!--------------------------------------------------------------------

!--------------------------------------------------------------------
real, intent(in) :: t
!--------------------------------------------------------------------

!-------------------------------------------------------------------
!
!  intent(in) variables:
!
!         t      time of year (between 0 and 2*pi; t=0 at NH autumnal
!                equinox
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables

      real :: angle, norm_time, x
      integer :: int, int_1

!--------------------------------------------------------------------
!   local variables:
!
!     angle       orbital position relative to NH autumnal equinox
!                 [ radians ]
!     norm_time   index into orbital table corresponding to input time
!                 [ dimensionless ]
!     x           fractional distance between the orbital table entries
!                 bracketing the input time
!                 [ dimensionless ]
!     int         table index which is lower than actual position, but
!                 closest to it
!                 [ dimensionless ]
!     int_1       next table index just larger than actual orbital 
!                 position
!                 [ dimensionless ]
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!    define orbital tables indices bracketing current orbital time
!    (int and int_1). define table index distance between the lower 
!    table value (int) and the actual orbital time (x). define orbital
!    position as being  x of the way between int and int_1. renormalize
!    angle to be within the range 0 to 2*pi.
!--------------------------------------------------------------------
      norm_time = t*float(num_angles)/twopi
      int = floor(norm_time)
      int = modulo(int,num_angles)
      int_1 = int+1
      x = norm_time - floor(norm_time)
      angle = (1.0 -x)*orb_angle(int) + x*orb_angle(int_1)
      angle = modulo(angle, twopi)

end function angle

!####################################################################
! <FUNCTION NAME="declination">
!  <OVERVIEW>
!    declination returns the solar declination angle at orbital
!    position ang in earth's orbit.
!  </OVERVIEW>
!  <DESCRIPTION>
!    declination returns the solar declination angle at orbital
!    position ang in earth's orbit.
!  </DESCRIPTION>
!  <TEMPLATE>
!    r =  declination (ang)
!  </TEMPLATE>
!  <IN NAME="ang" TYPE="real">
!     solar orbital position ang in earth's orbit
!  </IN>
! </FUNCTION>
!
function declination (ang)

!--------------------------------------------------------------------
!    declination returns the solar declination angle at orbital
!    position ang in earth's orbit.
!--------------------------------------------------------------------

!--------------------------------------------------------------------
real, intent(in) :: ang
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables

      real :: declination
      real :: rad_obliq, sin_dec

!--------------------------------------------------------------------
!   local variables:
!
!    declination         solar declination angle
!                        [ radians ]              
!    rad_obliq           obliquity of the ecliptic
!                        [ radians ]              
!    sin_dec             sine of the solar declination
!                        [ dimensionless ]
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    compute the solar declination.
!---------------------------------------------------------------------
      rad_obliq   =   obliq*deg_to_rad
      sin_dec     = - sin(rad_obliq)*sin(ang)
      declination =   asin(sin_dec)


end function declination


!#####################################################################


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                 INTERFACE HALF_DAY
!
! half_day (latitude, dec) result (h)
!
!
!  separate routines exist within this interface for scalar, 
!  or 2D input and output fields:
!
!    real, intent(in), dimension(:,:) :: latitude
! OR real, intent(in)                 :: latitude
!
!    real, dimension(size(latitude,1),size(latitude,2))  :: h
! OR real                                                :: h
!
!--------------------------------------------------------------------
!
!  intent(in) variables:
!
!     latitude       latitudes of model grid points 
!                    [ radians ]
!     dec            solar declination               
!                    [ radians ]
!
!  intent(out) variables:
!
!     h              half of the length of daylight at the given 
!                    latitude and orbital position (dec); value
!                    ranges between 0 (all darkness) and pi (all
!                    daylight)
!                    [ dimensionless ]
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! <FUNCTION NAME="half_day_2d">
!  <OVERVIEW>
!    half_day_2d returns a 2-d array of half-day lengths at the 
!    latitudes and declination provided.
!  </OVERVIEW>
!  <DESCRIPTION>
!    half_day_2d returns a 2-d array of half-day lengths at the 
!    latitudes and declination provided.
!  </DESCRIPTION>
!  <TEMPLATE>
!    h = half_day_2d (latitude, dec)
!  </TEMPLATE>
!  <IN NAME="latitude" TYPE="real">
!   latitutde of view point
!  </IN>
!  <IN NAME="dec" TYPE="real">
!   solar declination angle at view point
!  </IN>
! </FUNCTION>
!
function half_day_2d (latitude, dec) result(h)

!--------------------------------------------------------------------
!    half_day_2d returns a 2-d array of half-day lengths at the 
!    latitudes and declination provided.
!--------------------------------------------------------------------

!---------------------------------------------------------------------
real, dimension(:,:), intent(in)                     :: latitude
real,                 intent(in)                     :: dec
real, dimension(size(latitude,1),size(latitude,2))   :: h
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!   local variables

      real, dimension (size(latitude,1),size(latitude,2)):: & 
                                                  cos_half_day, lat
      real :: tan_dec 
      real :: eps = 1.0E-05

!---------------------------------------------------------------------
!   local variables
!
!     cos_half_day       cosine of half-day length
!                        [ dimensionless ]
!     lat                model latitude, adjusted so that it is never 
!                        0.5*pi or -0.5*pi
!     tan_dec            tangent of solar declination
!                        [ dimensionless ]
!     eps                small increment
!
!--------------------------------------------------------------------
   
!--------------------------------------------------------------------
!    define tangent of the declination.
!--------------------------------------------------------------------
      tan_dec = tan(dec)

!--------------------------------------------------------------------
!    adjust latitude so that its tangent will be defined.
!--------------------------------------------------------------------
      lat = latitude
      where (latitude ==  0.5*PI) lat= latitude - eps
      where (latitude == -0.5*PI) lat= latitude + eps

!--------------------------------------------------------------------
!    define the cosine of the half-day length. adjust for cases of 
!    all daylight or all night.
!--------------------------------------------------------------------
      cos_half_day = -tan(lat)*tan_dec
      where (cos_half_day <= -1.0)  h = PI
      where (cos_half_day >= +1.0)  h = 0.0
      where(cos_half_day > -1.0 .and. cos_half_day < 1.0) &
                                               h = acos(cos_half_day)


end function half_day_2d

!---------------------------------------------------------------
! <FUNCTION NAME="half_day_0d">
!  <OVERVIEW>
!    half_day_0d takes scalar input fields, makes them into 2-d fields
!    dimensioned (1,1), and calls half_day_2d. on return, the 2-d 
!    fields are converted to the desired scalar output.
!  </OVERVIEW>
!  <DESCRIPTION>
!    half_day_0d takes scalar input fields, makes them into 2-d fields
!    dimensioned (1,1), and calls half_day_2d. on return, the 2-d 
!    fields are converted to the desired scalar output.
!  </DESCRIPTION>
!  <TEMPLATE>
!    h = half_day_2d (latitude, dec)
!  </TEMPLATE>
!  <IN NAME="latitude" TYPE="real">
!   latitutde of view point
!  </IN>
!  <IN NAME="dec" TYPE="real">
!   solar declination angle at view point
!  </IN>
! </FUNCTION>
!
function half_day_0d(latitude, dec) result(h)

!--------------------------------------------------------------------
!    half_day_0d takes scalar input fields, makes them into 2-d fields
!    dimensioned (1,1), and calls half_day_2d. on return, the 2-d 
!    fields are converted to the desired scalar output.
!--------------------------------------------------------------------

real, intent(in) :: latitude, dec
real             :: h

!----------------------------------------------------------------------
!  local variables

      real, dimension(1,1) :: lat_2d, h_2d

!---------------------------------------------------------------------
!    create 2d array from the input latitude field.
!---------------------------------------------------------------------
      lat_2d = latitude

!---------------------------------------------------------------------
!    call half_day with the 2d arguments to calculate half-day length.
!---------------------------------------------------------------------
      h_2d = half_day (lat_2d, dec)

!---------------------------------------------------------------------
!    create scalar from 2d array.
!---------------------------------------------------------------------
      h = h_2d(1,1)



end function half_day_0d


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                 END INTERFACE HALF_DAY
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




!####################################################################
! <FUNCTION NAME="orbital_time">
!  <OVERVIEW>
!    orbital time returns the time (1 year = 2*pi) since autumnal 
!    equinox
!  </OVERVIEW>
!  <DESCRIPTION>
!    orbital time returns the time (1 year = 2*pi) since autumnal 
!    equinox; autumnal_eq_ref is a module variable of time_type and 
!    will have been defined by default or by a call to 
!    set_ref_date_of_ae; length_of_year is available through the time 
!    manager and is set at the value approriate for the calandar being 
!    used
!  </DESCRIPTION>
!  <TEMPLATE>
!    t = orbital_time(time)
!  </TEMPLATE>
!  <IN NAME="time" TYPE="time_type">
!   time (1 year = 2*pi) since autumnal equinox
!  </IN>
! </FUNCTION>
!
function orbital_time(time) result(t)

!---------------------------------------------------------------------
!    orbital time returns the time (1 year = 2*pi) since autumnal 
!    equinox; autumnal_eq_ref is a module variable of time_type and 
!    will have been defined by default or by a call to 
!    set_ref_date_of_ae; length_of_year is available through the time 
!    manager and is set at the value approriate for the calandar being 
!    used
!---------------------------------------------------------------------

type(time_type), intent(in) :: time
real                        :: t

!--------------------------------------------------------------------
      t = real ( (time - autumnal_eq_ref)//period_time_type)
      t = twopi*(t - floor(t))
      if (time < autumnal_eq_ref) t = twopi - t 


end function orbital_time


!#####################################################################
! <FUNCTION NAME="universal_time">
!  <OVERVIEW>
!    universal_time returns the time of day at longitude = 0.0 
!    (1 day = 2*pi)
!  </OVERVIEW>
!  <DESCRIPTION>
!    universal_time returns the time of day at longitude = 0.0 
!    (1 day = 2*pi)
!  </DESCRIPTION>
!  <TEMPLATE>
!    t = universal_time(time)
!  </TEMPLATE>
!  <IN NAME="time" TYPE="time_type">
!   time (1 year = 2*pi) since autumnal equinox
!  </IN>
! </FUNCTION>
!
function universal_time(time) result(t)

!--------------------------------------------------------------------
!    universal_time returns the time of day at longitude = 0.0 
!    (1 day = 2*pi)
!--------------------------------------------------------------------

type(time_type), intent(in) :: time
real                        :: t

!--------------------------------------------------------------------
!   local variables

      integer ::  seconds, days

      call get_time (time, seconds, days)
      t = twopi*real(seconds)/seconds_per_day 

end function universal_time


!#####################################################################





                   end module astronomy_mod

!FDOC_TAG_GFDL
module entrain_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Stephen Klein
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   none
! </REVIEWER>
! <OVERVIEW>
!
!      K-PROFILE BOUNDARY LAYER SCHEME WITH CLOUD TOP ENTRAINMENT
!
!
!      This routine calculates diffusivity coefficients for vertical
!      diffusion using a K-profile approach.  This scheme is modelled
!      after:
!
!      Lock, A.P., A.R. Brown, M.R. Bush, G.M. Martin, and R.N.B. Smith, 
!          2000: A new boundary layer mixing scheme. Part I: Scheme 
!          description and single-column modeling tests. Mon. Wea. Rev.,
!          128, 3187-3199.
!
!   
! </OVERVIEW>
! <DESCRIPTION>
!
!      The key part is the parameterization of entrainment at the top
!      convective layers. For an entrainment interface from surface
!      driven mixing, the entrainment rate, we, is parameterized as:
!
!                      
!      we, surf =  A / B
!
!      where A = ( beta_surf * (V_surf**3 + V_shear**3) / zsml )
!        and B = ( delta_b   + ((V_surf**3 + V_shear**3)**(2/3))/zsml )
!
!
!      In this formula,
!
!           zsml     =  depth of surface mixed layer
!
!           V_surf   =  surface driven scaling velocity
!                    =  (u_star*b_star*zsml)**(1/3)
!
!           V_shear  =  surface driven shear velocity,
!                    =  (Ashear**(1/3))*u_star
!
!           delta_b  =  buoyancy jump at the entrainment interface(m/s2)
!                    =  grav * delta_slv / slv
!
!      If an entrainment interface is associated only with cloud top
!      radiative cooling, the entrainment rate is parameterized as:
!
!
!                     
!      we, rad  =  ( A / B)
!
!            where A = beta_rad  *  V_rad**3 /  zradml
!              and B = delta_b   +  V_rad**2 /  zradml
!
!      where
!
!           zradml   =  depth of radiatively driven layer
!
!           V_rad    =  radiatively driven scaling velocity
!                    =  (grav*delta-F*zradml/(rho*cp_air*T)) **(1/3)
!                 
!
!      Note that the source of entrainment from cloud top buoyancy
!      reversal has been omitted in this implementation.
!  
!      If the entrainment interface for surface driven mixing coincides
!      with that for cloud top radiatively driven convection then the
!      following full entrainment rate:
!
!                          
!      we, full =   A / B
!
!            where A =   V_full**3 / zsml
!              and B =  delta_b+((V_surf**3+V_shear**3+V_rad**3)**(2/3))/zsml
!              and V_full**3 = beta_surf*(V_surf**3+V_shear**3) + beta_rad*V_rad**3
!   
! </DESCRIPTION>
!

!-----------------------------------------------------------------------
!
! outside modules used
!

use      constants_mod, only: grav,vonkarm,cp_air,rdgas,rvgas,hlv,hls, &
                              tfreeze, radian 

use            mpp_mod, only: input_nml_file
use            fms_mod, only: open_file, file_exist, open_namelist_file, &
                              error_mesg, FATAL, check_nml_error, &
                              mpp_pe, mpp_root_pe, close_file,           &
                              stdlog, write_version_number

use   diag_manager_mod, only: register_diag_field, send_data
        
use   time_manager_mod, only: time_type, get_date, month_name
 
use sat_vapor_pres_mod, only: lookup_es, lookup_des

use  monin_obukhov_mod, only: mo_diff

implicit none
private

!-----------------------------------------------------------------------
!
!      public interfaces

public entrain, entrain_init, entrain_end, entrain_on

!-----------------------------------------------------------------------
!
!      set default values to namelist parameters       
!
real :: akmax       =  1.e4 ! maximum value for a diffusion coefficient 
                            ! (m2/s)
real :: wentrmax    =  0.05 ! maximum entrainment rate (m/s)
real :: parcel_buoy =  1.0  ! scaling factor for surface parcel buoyancy
real :: frac_inner  =  0.1  ! surface layer height divided by pbl height
real :: beta_surf   =  0.23 ! scaling of surface buoyancy flux for 
                            ! convective pbl entrainment
real :: Ashear      = 25.0  ! scaling of surface shear contribution to
                            ! entrainment
real :: beta_rad    =  0.23 ! entrainment scaling factor for radiative
                            ! cooling (from Lock et al. 2000)
real :: radfmin     = 30.   ! minimum radiative forcing for entrainment 
                            ! to be effective (W/m2)
real :: qdotmin     = 10.   ! minimum longwave cooling rate (K/day) for
                            ! entrainment to be effective, used only if
                            ! no layers were found using radfmin    
real :: radperturb  =  0.3  ! parcel perturbation looking for depth of
                            ! radiatively driven layer (K)
real :: critjump    =  0.3  ! critical jump for finding stable inter-
                            ! faces to bound convective layers, or to 
                            ! identify ambigous layers (K)
integer :: parcel_option = 1! Should the cloud top parcel property
                            ! be limited to the value of the level
                            ! below minus radperturb (option = 1) or 
                            ! the value of level below (option = 2)    
real :: zcldtopmax  =  3.e3 ! maximum altitude for cloud top of 
                            ! radiatively driven convection (m)    
real :: pr          =  0.75 ! prandtl # (k_m/k_t) for radiatively driven 
                            ! convection 
real :: qamin       =  0.3  ! minimum cloud fraction for cloud top 
                            ! radiative cooling entrainment and kprofile
                            ! from radiative cooling to occur
logical :: do_jump_exit = .true.
                            ! should an internal stable layer limit
                            ! the depth of the radiatively driven
                            ! convection?
logical :: apply_entrain = .true. 
                            ! logical controlling whether results of
                            ! of entrainment module are applied:
                            ! if F, then no diffusion coefficients 
                            ! from entrain_mod will be applied to
                            ! the actual diffusion coefficients;
                            ! i.e. the module is purely diagnostic
logical :: convect_shutoff = .false.
                            ! if surface based moist convection is   
                            ! occurring in the grid box, set entrainment
                            ! at top of surface mixed layer to zero

!-----------------------------------------------------------------------   
!
!  Stuff needed to write out extradiagnostics from a single point
!
    
integer, dimension(2) :: ent_pts = 0 ! the global indices for i,j
                                     ! at which diagnostics will 
                                     ! print out
logical   :: do_print = .false.      ! should selected variables 
                                     ! be sent to logfile
logical   :: column_match = .false.  ! should this column be printed 
                                     ! out?
integer   :: dpu = 0                 ! unit # for do_print output
integer   :: n_print_levels = 14     ! how many of the lowest levels 
                                     ! should be printed out
 

integer, parameter                 :: MAX_PTS = 20
integer, dimension (MAX_PTS)       :: i_entprt_gl=0, j_entprt_gl=0
real, dimension(MAX_PTS)           :: lat_entprt=999., lon_entprt=999.
integer                            :: num_pts_ij = 0
integer                            :: num_pts_latlon = 0

     
namelist /entrain_nml/ wentrmax, parcel_buoy, frac_inner, beta_surf,   &
                       Ashear, beta_rad, radfmin, qdotmin, radperturb, &
                       critjump, zcldtopmax, pr, qamin, parcel_option, &
                       do_jump_exit, convect_shutoff, apply_entrain,   &
                       ent_pts,  i_entprt_gl, j_entprt_gl, num_pts_ij, &
                       num_pts_latlon, lat_entprt, lon_entprt

integer     :: num_pts           !  total number of columns in which
                                 !  diagnostics are desired
       
!-----------------------------------------------------------------------
!    deglon1 and deglat1 are the longitude and latitude of the columns
!    at which diagnostics will be calculated (degrees).
!-----------------------------------------------------------------------
real,    dimension(:), allocatable  :: deglon1, deglat1
 
!-----------------------------------------------------------------------
!    iradprt and jradprt are the processor-based i and j coordinates 
!    of the desired diagnostics columns.
!-----------------------------------------------------------------------
integer, dimension(:), allocatable  :: j_entprt, i_entprt

!-----------------------------------------------------------------------
!    do_raddg is an array of logicals indicating which latitude rows
!    belonging to the processor contain diagnostics columns.
!-----------------------------------------------------------------------
logical, dimension(:), allocatable  :: do_ent_dg

!-----------------------------------------------------------------------
!
!      diagnostic fields       
!

character(len=10) :: mod_name = 'entrain'
real              :: missing_value = 0.
integer           :: id_wentr_rad, id_wentr_pbl, id_radf,id_parcelkick,&
                     id_k_t_entr,  id_k_m_entr,  id_k_rad,  id_zsml,   &             
                     id_vsurf,     id_vshear,    id_vrad,   id_zradml, &
                     id_k_t_troen, id_k_m_troen, id_radfq,  id_pblfq,  &
                     id_zradbase,  id_zradtop,   id_convpbl,id_radpbl, &
                     id_svpcp,     id_zinv,      id_fqinv,  id_invstr
     
!-----------------------------------------------------------------------
!
!      set default values to parameters       
!

logical         :: entrain_on = .false.
real, parameter :: small  = 1.e-4      
real, parameter :: d608 = (rvgas-rdgas)/rdgas

!-----------------------------------------------------------------------
!
! declare version number 
!

character(len=128) :: Version = '$Id: entrain.F90,v 19.0 2012/01/06 20:09:20 fms Exp $'
character(len=128) :: Tagname = '$Name: tikal $'
logical            :: module_is_initialized = .false.      
!-----------------------------------------------------------------------
!
! Subroutines include:
!
!      entrain         main driver program of the module
!
!      entrain_init    initialization routine       
!
!      entrain_tend    adds in the longwave heating rate to the 
!                      global storage variable
!
!      entrain_end     ending routine
!
!      pbl_depth       routine to calculate the depth of surface driven
!                      mixed layer
!
!      radml_depth     subroutine to calculate the depth of the cloud
!                      topped radiatively driven mixed layer
!     
!      diffusivity_pbl subroutine to calculate diffusivity coefficients
!                      for surface driven mixed layer


contains



!======================================================================= 
!
! <SUBROUTINE NAME="entrain_init">
!  <OVERVIEW>
!
!      
!           
!  </OVERVIEW>
!  <DESCRIPTION>
!     This subroutine reads the namelist file, sets up individual 
!     points diagnostics if desired, and initializes netcdf output.
!  </DESCRIPTION>
!  <TEMPLATE>
!
!   call entrain_init(lonb, latb, axes,time,idim,jdim,kdim)
!
!  </TEMPLATE>
!  <IN NAME="lonb" TYPE="real">
!       2D array of model longitudes at cell corners (radians) 
!  </IN>
!  <IN NAME="latb" TYPE="real">
!       2D array of model latitudes at cell corners (radians)
!  </IN>
!  <IN NAME="axes" TYPE="integer">
!       Integer arrary for axes used needed for netcdf diagnostics
!  </IN>
!  <IN NAME="time" TYPE="time_type">
!       Time type variable used for netcdf diagnostics
!  </IN>
!  <IN NAME="idim" TYPE="integer">
!       Size of first (longitude) array dimension 
!  </IN>
!  <IN NAME="jdim" TYPE="integer">
!       Size of second (latitude) array dimension
!  </IN>
!  <IN NAME="kdim" TYPE="integer">
!       Size of third (vertical, full levels) array dimension
!  </IN>
! </SUBROUTINE>
!
subroutine entrain_init(lonb, latb, axes,time,idim,jdim,kdim)

!-----------------------------------------------------------------------
!
!      variables
!
!      -----
!      input
!      -----
! 
!      idim,jdim,kdim    size of the first 3 dimensions 
!      axes, time        variables needed for netcdf diagnostics
!      latb, lonb        latitudes and longitudes at grid box corners
!
!
!      --------
!      internal
!      --------
! 
!      unit              unit number for namelist and restart file
!      io                internal variable for reading of namelist file
!      full              indices for full level axes coordinates
!      half              indices for half level axes coordinates
!
!-----------------------------------------------------------------------

integer,              intent(in) :: idim,jdim,kdim,axes(4)
type(time_type),      intent(in) :: time
real, dimension(:,:), intent(in) :: lonb, latb

integer                        :: unit,io,ierr
integer, dimension(3)          :: half = (/1,2,4/)
integer                        :: nn, i, j
real                           :: dellat, dellon

!-----------------------------------------------------------------------
!
!      namelist functions

#ifdef INTERNAL_FILE_NML
       read (input_nml_file, nml=entrain_nml, iostat=io)
       ierr = check_nml_error(io,"entrain_nml")
#else
       If (File_Exist('input.nml')) Then
            unit = Open_namelist_File ()
            ierr=1
            Do While (ierr .ne. 0)
                 Read  (unit, nml=entrain_nml, iostat=io, End=10)
                 ierr = check_nml_error (io, 'entrain_nml')
            EndDo
  10        Call Close_File (unit)
       EndIf
#endif

       if ( mpp_pe() == mpp_root_pe() ) then
            call write_version_number(version, tagname)
            unit = stdlog()
            Write (unit,nml=entrain_nml)
       endif

       
!-----------------------------------------------------------------------
!    allocate and initialize a flag array which indicates the latitudes
!    containing columns where radiation diagnostics are desired.
!-----------------------------------------------------------------------
      allocate (do_ent_dg (size(latb,2)-1) )
      do_ent_dg(:) = .false.

!-----------------------------------------------------------------------
!    define the total number of points at which diagnostics are desired.
!    points may be specified either by lat-lon pairs or by global index
!    pairs. 
!-----------------------------------------------------------------------
      num_pts = num_pts_latlon + num_pts_ij

!-----------------------------------------------------------------------
!    continue on only if diagnostics are desired in at least one column.
!-----------------------------------------------------------------------
      if (num_pts > 0) then

!-----------------------------------------------------------------------
!    if more points are desired than space has been reserved for, print 
!    a message.
!-----------------------------------------------------------------------
        if (num_pts > MAX_PTS) then
          call error_mesg ( 'entrain_mod', &
         'must reset MAX_PTS or reduce number of diagnostics points',  &
                                                             FATAL)
        endif

!-----------------------------------------------------------------------
!    allocate space for arrays which will contain the lat and lon and
!    processor-local i and j indices.
!-----------------------------------------------------------------------
        allocate ( deglon1 (num_pts))
        allocate ( deglat1 (num_pts))
        allocate ( j_entprt (num_pts))
        allocate ( i_entprt (num_pts))

!-----------------------------------------------------------------------
!    if any points for diagnostics are specified by (i,j) global 
!    indices, determine their lat-lon coordinates. assumption is made 
!    that the deltas of latitude and longitude are uniform over 
!    the globe.
!-----------------------------------------------------------------------
        do nn=1,num_pts_ij
          dellat = latb(1,2) - latb(1,1)
          dellon = lonb(2,1) - lonb(1,1)
          lat_entprt(nn + num_pts_latlon) =     &
                      (-0.5*acos(-1.0) + (j_entprt_gl(nn) - 0.5)*  &
                                           dellat) * radian
          lon_entprt(nn + num_pts_latlon) =                & 
                       (i_entprt_gl(nn) - 0.5)*dellon*radian
        end do

!-----------------------------------------------------------------------
!    determine if the lat/lon values are within the global grid,
!    latitude between -90 and 90 degrees and longitude between 0 and
!    360 degrees.
!-----------------------------------------------------------------------
        do nn=1,num_pts
          j_entprt(nn) = 0
          i_entprt(nn) = 0
          deglat1(nn) = 0.0
          deglon1(nn) = 0.0
          if (lat_entprt(nn) .ge. -90. .and. &
              lat_entprt(nn) .le.  90.) then
          else
            call error_mesg ('entrain_mod', &
                ' invalid latitude for entrain diagnostics ', FATAL)
          endif

          if (lon_entprt(nn) .ge. 0. .and. &
              lon_entprt(nn) .le. 360.) then
          else
            call error_mesg ('entrain_mod', &
                ' invalid longitude for entrain diagnostics ', FATAL)
          endif

!-----------------------------------------------------------------------
!    determine if the diagnostics column is within the current 
!    processor's domain. if so, set a logical flag indicating the
!    presence of a diagnostic column on the particular row, define the 
!    i and j processor-coordinates and the latitude and longitude of 
!    the diagnostics column.
!-----------------------------------------------------------------------
          do j=1,size(latb,2) - 1
            if (lat_entprt(nn) .ge. latb(1,j)*radian .and.   &
                lat_entprt(nn) .lt. latb(1,j+1)*radian) then
              do i=1,size(lonb,1) - 1
                if (lon_entprt(nn) .ge. lonb(i,1)*radian     &
                                  .and.&
                    lon_entprt(nn) .lt. lonb(i+1,1)*radian)  &
                                   then
                  do_ent_dg(j) = .true.
                  j_entprt(nn) = j
                  i_entprt(nn) = i
                  deglon1(nn) = 0.5*(lonb(1,i) + lonb(i+1,1))*  &
                                radian
                  deglat1(nn) = 0.5*(latb(1,j) + latb(j+1,1))*   &
                                radian
                  exit
                endif
              end do
              exit
            endif
          end do
        end do

!-----------------------------------------------------------------------
!    open a unit for the entrain diagnostics output.
!-----------------------------------------------------------------------
        dpu = open_file ('entrain.out', action='write', &
                                 threading='multi', form='formatted')
       do_print = .true.
       if ( mpp_pe() == mpp_root_pe() ) then
            call write_version_number(version, tagname)
            Write (dpu ,nml=entrain_nml)
       endif
      endif     ! (num_pts > 0)

!-----------------------------------------------------------------------
!
!      initialize entrain_on

       entrain_on = .TRUE.
       module_is_initialized = .true.

       
!-----------------------------------------------------------------------
!
! register diagnostic fields       

       id_zsml = register_diag_field (mod_name, 'zsml', axes(1:2),     &
            time, 'depth of surface well-mixed layer', 'meters',       &
            missing_value=missing_value )

       id_vsurf = register_diag_field (mod_name, 'vsurf',              &
            axes(1:2), time,                                           &
            'surface buoyancy velocity scale', 'meters per second',    &
            missing_value=missing_value )

       id_vshear = register_diag_field (mod_name, 'vshear',            &
            axes(1:2), time,                                           &
            'surface shear driven velocity scale', 'meters per second',&
             missing_value=missing_value )

       id_parcelkick = register_diag_field (mod_name, 'parcelkick',    &
            axes(1:2),time, 'surface parcel excess', 'K',              &
            missing_value=missing_value )

       id_wentr_pbl = register_diag_field (mod_name,'wentr_pbl',       &
            axes(1:2), time,                                           &
            'Entrainment velocity from surface buoyancy flux',         &
            'meters per second', missing_value=missing_value )
       
       id_wentr_rad = register_diag_field (mod_name, 'wentr_rad',      &
            axes(1:2), time,                                           &
            'Entrainment velocity from cloud top radiative cooling',   &
            'meters per second', missing_value=missing_value )
       
       id_convpbl = register_diag_field (mod_name, 'convpbl_fq',       &
            axes(1:2), time, 'Frequency of convective boundary layer', &
            'none')
       
       id_pblfq = register_diag_field (mod_name,'entr_pbl_fq',         &
            axes(half), time,                                          &
            'Frequency of surface driven entrainment turbulent layer', &
            'none')
       
       id_radfq = register_diag_field (mod_name, 'entr_rad_fq',        &
            axes(half), time,                                          &
           'Frequency of radiative driven entrainment turbulent layer',&
            'none')
       
       id_k_t_troen = register_diag_field (mod_name, 'k_t_troen',      &
            axes(half), time, 'Heat entrainment diffusivity from PBL', &
            'meters squared per second', missing_value=missing_value )
       
       id_k_m_troen = register_diag_field (mod_name, 'k_m_troen',      &
            axes(half), time,                                          &
            'Momentum entrainment diffusivity from PBL',               &
            'meters squared per second', missing_value=missing_value )
       
       id_svpcp = register_diag_field (mod_name, 'svpcp',              &
            axes(1:2), time,                                           &
            'Liquid water virtual potential temperature at cloud top', &
            'K',missing_value=missing_value )

       id_zradbase = register_diag_field (mod_name, 'zradbase',        &
            axes(1:2), time,                                           &
            'base of radiatively driven well-mixed layer', 'm',        &
            missing_value=missing_value )

       id_zradtop = register_diag_field (mod_name, 'zradtop',          &
            axes(1:2), time,                                           &
            'top of radiatively driven well-mixed layer', 'm',         &
            missing_value=missing_value )

       id_zradml = register_diag_field (mod_name, 'zradml',            &
            axes(1:2), time,                                           &
            'depth of radiatively driven well-mixed layer', 'm',       &
            missing_value=missing_value )

       id_radpbl = register_diag_field (mod_name, 'radpbl_fq',         &
            axes(1:2), time,                                           &
            'Frequency of radiatively driven turbulent layer',         &
            'none' )
       
       id_vrad = register_diag_field (mod_name, 'vrad',                &
            axes(1:2), time,                                           &
            'radiatively driven layer velocity scale',                 &
            'meters per second', missing_value=missing_value )

       id_k_rad = register_diag_field (mod_name, 'k_rad',              &
            axes(half), time,                                          &
            'diffusivity from cloud top radiative cooling',            &
            'meters squared per second', missing_value=missing_value )
       
       id_radf  = register_diag_field (mod_name, 'radf', axes(1:2),    &
            time, 'Longwave jump in cloud top radiation',              &
            'Watts/m**2', missing_value=missing_value )
 
       id_k_t_entr = register_diag_field (mod_name, 'k_t_entr',        &
            axes(half), time,                                          &
            'Heat diffusivity from entrainment module',                &
            'meters squared per second')
       
       id_k_m_entr = register_diag_field (mod_name, 'k_m_entr',        &
            axes(half), time,                                          &
            'Momentum diffusivity from entrainment module',            &
            'meters squared per second' )

       id_zinv = register_diag_field (mod_name, 'zinv',                &
            axes(1:2), time,                                           &
            'Altitude of strongest inversion at altitudes less '//     &
            'than 3000 m',   'm', missing_value=missing_value )

       id_invstr = register_diag_field (mod_name, 'invstr',            &
            axes(1:2), time,                                           &
            'Strength of strongest inversion at altitudes less '//     &
            'than 3000 m',   'K', missing_value=missing_value )

       id_fqinv = register_diag_field (mod_name, 'fqinv',              &
            axes(1:2), time,                                           &
            'Frequency of inversions at altitudes less than 3000 m',   &
            'fraction', missing_value=missing_value )
              
                        
!-----------------------------------------------------------------------
! 
!      subroutine end
!

end subroutine entrain_init

!
!======================================================================= 




!======================================================================= 
!
!      subroutine entrain
!        

! <SUBROUTINE NAME="entrain">
!  <OVERVIEW>
!   
!      
!  </OVERVIEW>
!  <DESCRIPTION>
!      This is the main subroutine which takes in the state of the
!      atmosphere and returns vertical diffusion coefficients for
!      convective turbulent layers.  (Stable turbulent layers are
!      handled by stable_bl_turb.f90 in AM2)
!
!  </DESCRIPTION>
!  <TEMPLATE>
!   call entrain(is,ie,js,je,time, tdtlw_in, convect,u_star,b_star,             &
!               t,qv,ql,qi,qa,u,v,zfull,pfull,zhalf,phalf,          
!               diff_m,diff_t,k_m_entr,k_t_entr,use_entr,zsml,      
!               vspblcap,kbot)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      Indice of starting point in the longitude direction of the slab being passed to entrain
!  </IN>
!  <IN NAME="ie" TYPE="integer">
!      Indice of ending point in the longitude direction of the slab being passed to entrain  
!  </IN>
!  <IN NAME="js" TYPE="integer">
!      Indice of starting point in the latitude direction of the slab being passed to entrain
!  </IN>
!  <IN NAME="je" TYPE="integer">
!      Indice of ending point in the latitude direction of the slab being passed to entrain 
!  </IN>
!  <IN NAME="time" TYPE="time_type">
!      Time of the model: used for netcdf diagnostics
!  </IN>
!  <IN NAME="tdtlw_in" TYPE="real">
!      Longwave cooling rate (from the radiation scheme) (K/sec)
!  </IN>
!  <IN NAME="convect" TYPE="logical">
!      Is surface based convection occurring in this grid box at this time? (from convection scheme (or schemes))
!  </IN>
!  <IN NAME="u_star" TYPE="real">
!      Friction velocity (m/s) 
!  </IN>
!  <IN NAME="b_star" TYPE="real">
!      Buoyancy scale (m/s2)
!  </IN>
!  <IN NAME="t" TYPE="time_type">
!      Temperature (3d array) (K)
!  </IN>
!  <IN NAME="qv" TYPE="real">
!      Water vapor specific humidity (3d array) (kg/kg)
!  </IN>
!  <IN NAME="ql" TYPE="real">
!      Liquid water specific humidity (3d array) (kg/kg)
!  </IN>
!  <IN NAME="qi" TYPE="real">
!      Ice water specific humidity (3d array) (kg/kg)
!  </IN>
!  <IN NAME="qa" TYPE="real">
!      Cloud fraction (3d array) (fraction)
!  </IN>
!  <IN NAME="u" TYPE="real">
!      Zonal wind velocity (3d array) (m/s)
!  </IN>
!  <IN NAME="v" TYPE="logical">
!      Meridional wind velocity (3d array) (m/s) 
!  </IN>
!  <IN NAME="zfull" TYPE="real">
!      Geopotential height of full model levels (3d array) (m)
!  </IN>
!  <IN NAME="pfull" TYPE="real">
!      Pressure of full model levels (3d array) (Pa)
!  </IN>
!  <IN NAME="zhalf" TYPE="real">
!      Geopotential height of half model levels (3d array) (m)
!  </IN>
!  <IN NAME="phalf" TYPE="real">
!      Pressure of half model levels (3d array) (Pa)
!  </IN>
!  <INOUT NAME="diff_m" TYPE="real">
!      Vertical momentum diffusion coefficient (3d array) (m2/s)
!
!      Note that if apply_entrain = .true. then the output will be 
!      the diffusion coefficient diagnosed by entrain_mod (k_m_entr). 
!      If apply_entrain = .false. then the output will be identical to 
!      the input.  This permits one to run entrain_mod as a diagnostic 
!      module without using the diffusion coefficients determined by it. 
!  </INOUT>
!  <INOUT NAME="diff_t" TYPE="real">
!      Vertical heat and tracer diffusion coefficient (3d array) (m2/s) 
!
!      The note for diff_m also applies here.
!  </INOUT>
!  <OUT NAME="k_m_entr" TYPE="real">
!      Vertical momentum diffusion coefficient diagnosed by entrain_mod (3d array) (m2/s)
!  </OUT>
!  <OUT NAME="k_t_entr" TYPE="real">
!      Vertical heat and tracer diffusion coefficient diagnosed by entrain_mod (3d array) (m2/s)
!  </OUT>
!  <OUT NAME="use_entr" TYPE="real">
!      Was a diffusion coefficient calculated for this level by entrain_mod?  (1.0 = yes, 0.0 = no)
!  </OUT>
!  <OUT NAME="zsml" TYPE="real">
!      Height of surface based convective mixed layer (m)
!      This may be used by other routines, e.g. Steve Garner's gravity wave drag
!  </OUT>
!  <OUT NAME="vspblcap" TYPE="real">
!      Lowest height level for which entrain module calculated at diffusion coefficient (meters) 
!      (i.e. where use_entr = 1.0)
!      This is used by stable_bl_turb.f90 to limit the height of enhanced mixing in stable conditions.
!  </OUT>
!  <IN NAME="kbot" TYPE="integer">
!      Optional input integer indicating the lowest true layer of atmosphere (counting down from the top of the atmosphere).
!      This is used only for eta coordinate model.
!  </IN>
! </SUBROUTINE>
!
subroutine entrain(is,ie,js,je,time, tdtlw_in, convect,u_star,b_star,             &
                   t,qv,ql,qi,qa,u,v,zfull,pfull,zhalf,phalf,          &
                   diff_m,diff_t,k_m_entr,k_t_entr,use_entr,zsml,      &
                   vspblcap,kbot)

!-----------------------------------------------------------------------
!
!      variables
!
!      -----
!      input
!      -----
!
!      is,ie,js,je  i,j indices marking the slab of model working on
!      time      variable needed for netcdf diagnostics
!
!      convect   is surface based moist convection occurring in this
!                grid box?
!      u_star    friction velocity (m/s)
!      b_star    buoyancy scale (m/s**2)
!
!      three dimensional fields on model full levels, reals dimensioned
!      (:,:,pressure), third index running from top of atmosphere to 
!      bottom
!          
!      t         temperature (K)
!      qv        water vapor specific humidity (kg vapor/kg air)
!      ql        liquid water specific humidity (kg cond/kg air)
!      qi        ice water specific humidity (kg cond/kg air)
!      qa        cloud fraction 
!      zfull     height of full levels (m)
!      pfull     pressure (Pa)
!      u         zonal wind (m/s)
!      v         meridional wind (m/s)
!
!      the following two fields are on the model half levels, with
!      size(zhalf,3) = size(t,3) +1, zhalf(:,:,size(zhalf,3)) 
!      must be height of surface (if you are not using eta-model)
!
!      zhalf     height at half levels (m)
!      phalf     pressure at half levels (Pa)
!
!      ------------
!      input/output
!      ------------
!
!      the following variables are defined at half levels and are
!      dimensions 1:nlev
!
!      diff_t   input and output heat diffusivity (m2/sec)
!      diff_m   input and output momentum diffusivity (m2/sec)
!
!      The diffusivity coefficient output from the routine includes
!      the modifications to use the internally calculated diffusivity
!      coefficients should apply_entrain = .true.  Otherwise, the
!      input and output values of the diffusivity coefficients will
!      be the same.
!
!      ------
!      output
!      ------
!
!      The following variables are defined at half levels and are
!      dimensions 1:nlev.
!
!      k_t_entr  heat diffusivity coefficient (m**2/s)
!      k_m_entr  momentum diffusivity coefficient (m**2/s)
!      use_entr  Was a diffusion coefficient calculated for this
!                level?  (1.0 = yes, 0.0 = no)
!      zsml      height of surface driven mixed layer (m)
!      vspblcap  lowest height level for which entrain module calculated
!                at diffusion coefficient (meters) (i.e. where 
!                use_entr = 1.0)
!
!      --------------
!      optional input
!      --------------
!
!      kbot      integer indicating the lowest true layer of atmosphere
!                this is used only for eta coordinate model
!
!      --------
!      internal
!      --------
!
!
!      General variables
!      -----------------
!
!      zsurf       height of surface (m)
!      zfull_ag    height of full model levels above the surface (m)
!      slv         virtual static energy (J/kg)      
!      density     air density (kg/m3)
!      hleff       effective latent heat of vaporization/sublimation 
!                  (J/kg)
!      mask        real array indicating the point is above the surface
!                  if equal to 1.0 and indicating the point is below 
!                  the surface if equal to 0. (used for eta coordinate 
!                  model)
!      zhalf_ag    height of half model levels above the surface (m)
!
!
!
!      Variables related to surface driven convective layers
!      -----------------------------------------------------
!
!      vsurf       surface driven buoyancy velocity scale (m/s)
!      vshear      surface driven shear velocity scale (m/s)
!      parcelkick  buoyancy kick to surface parcel (K)
!      wentr_pbl   surface driven entrainment rate (m/s)
!      convpbl     1 is surface driven convective layer present
!                  0 otherwise
!      pblfq       1 if the half level is part of a surface driven
!                  layer, 0 otherwise
!      k_m_troen   momentum diffusion coefficient (m2/s)
!      k_t_troen   heat diffusion coefficient (m2/s)
!
!
!      Variables related to cloud top driven radiatively driven layers
!      ---------------------------------------------------------------
!
!      zradbase    height of base of radiatively driven mixed layer (m)
!      zradtop     height of top of radiatively driven mixed layer (m)
!      zradml      depth of radiatively driven mixed layer (m)
!      vrad        radiatively driven velocity scale (m/s)
!      radf        longwave jump at cloud top (W/m2) -- the radiative 
!                  forcing for cloud top driven mixing.
!      wentr_rad   cloud top driven entrainment (m/s)
!      svpcp       cloud top value of liquid water virtual static energy 
!                  divided by cp (K)
!      radpbl      1 if cloud top radiatively driven layer is present
!                  0 otherwise
!      radfq       1 if the half level is part of a radiatively driven
!                  layer, 0 otherwise
!      k_rad       radiatively driven diffusion coefficient (m2/s)
!
!      Diagnostic variables
!      --------------------
!
!      fqinv       1 if an inversion occurs at altitudes less 
!                    than 3000 m, 0 otherwise
!      zinv        altitude of inversion base (m)
!      invstr      strength of inversion in slv/cp (K)
!
!-----------------------------------------------------------------------

integer,         intent(in)                      :: is,ie,js,je
type(time_type), intent(in)                      :: time
real,            intent(in),    dimension(:,:,:) :: tdtlw_in       
logical,         intent(in),    dimension(:,:)   :: convect
real,            intent(in),    dimension(:,:)   :: u_star,b_star
real,            intent(in),    dimension(:,:,:) :: t,qv,ql,qi,qa
real,            intent(in),    dimension(:,:,:) :: u,v,zfull,pfull
real,            intent(in),    dimension(:,:,:) :: zhalf, phalf
real,            intent(inout), dimension(:,:,:) :: diff_m,diff_t
real,            intent(out),   dimension(:,:,:) :: k_m_entr,k_t_entr
real,            intent(out),   dimension(:,:,:) :: use_entr
real,            intent(out),   dimension(:,:)   :: zsml,vspblcap
integer,  intent(in),   dimension(:,:), optional :: kbot


integer                                         :: i,j,k,ibot
integer                                         :: nlev,nlat,nlon,ipbl
integer                                         :: kmax,kcldtop
logical                                         :: used
real                                            :: maxradf, tmpradf
real                                            :: maxqdot, tmpqdot
real                                            :: maxinv
real                                            :: wentr_tmp
real                                            :: k_entr_tmp,tmpjump
real                                            :: tmp1, tmp2
real                                            :: vsurf3, vshear3,vrad3
real                                            :: ztmp
real, dimension(size(t,1),size(t,2))            :: zsurf,parcelkick
real, dimension(size(t,1),size(t,2))            :: zradbase,zradtop
real, dimension(size(t,1),size(t,2))            :: vrad,radf,svpcp
real, dimension(size(t,1),size(t,2))            :: zradml, vsurf, vshear
real, dimension(size(t,1),size(t,2))            :: wentr_rad,wentr_pbl
real, dimension(size(t,1),size(t,2))            :: convpbl, radpbl
real, dimension(size(t,1),size(t,2))            :: zinv, fqinv, invstr
real, dimension(size(t,1),size(t,2),size(t,3))  :: slv, density
real, dimension(size(t,1),size(t,2),size(t,3))  :: mask,hleff
real, dimension(size(t,1),size(t,2),size(t,3))  :: zfull_ag
real, dimension(size(t,1),size(t,2),size(t,3)+1):: zhalf_ag
real, dimension(size(t,1),size(t,2),size(t,3))  :: radfq,pblfq
real, dimension(size(t,1),size(t,2),size(t,3)+1):: mask3,rtmp
real, dimension(size(t,1),size(t,2),size(t,3))  :: k_m_troen,k_t_troen
real, dimension(size(t,1),size(t,2),size(t,3))  :: k_rad

! temp 1-d arrays
real, dimension(size(t,3)+1)                    :: zhalf_ag_1
real, dimension(size(t,3)+1)                    :: k_m_troen_1, k_t_troen_1

integer                                         :: ipt,jpt
integer, dimension(MAX_PTS) :: nsave
integer :: iloc(MAX_PTS), jloc(MAX_PTS), nn, kk, npts, nnsave
integer :: year, month, day, hour, minute, second
character(len=16) :: mon
                    
!-----------------------------------------------------------------------
!
!      initialize variables

       convpbl    = 0.0
       wentr_pbl  = missing_value
       vsurf      = missing_value
       vshear     = missing_value
       pblfq      = 0.0
       parcelkick = missing_value
       k_t_troen  = missing_value
       k_m_troen  = missing_value
       radpbl     = 0.0
       svpcp      = missing_value
       zradbase   = missing_value
       zradtop    = missing_value
       zradml     = missing_value
       vrad       = missing_value
       radf       = missing_value
       radfq      = 0.0
       wentr_rad  = missing_value
       k_rad      = missing_value
       k_t_entr   = 0.0
       k_m_entr   = 0.0
       use_entr   = 0.0
       vspblcap   = 0.0
       fqinv      = 0.0
       zinv       = missing_value
       invstr     = missing_value
       zsml       = 0.0   ! note that this must be zero as this is 
                          ! indicates stable surface layer and this
                          ! value is output for use in gravity
                          ! wave drag scheme
                             
!-----------------------------------------------------------------------
!
!      compute height above surface
!

       nlev = size(t,3)
       nlat = size(t,2)
       nlon = size(t,1)
       
       mask = 1.0
                   
       if (present(kbot)) then
            do j=1,nlat
            do i=1,nlon
                 zsurf(i,j) = zhalf(i,j,kbot(i,j)+1)
            enddo
            enddo
       else
            zsurf(:,:) = zhalf(:,:,nlev+1)
       end if

       do k = 1, nlev
            zfull_ag(:,:,k) = zfull(:,:,k) - zsurf(:,:)
            zhalf_ag(:,:,k) = zhalf(:,:,k) - zsurf(:,:)
       end do
       zhalf_ag(:,:,nlev+1) = zhalf(:,:,nlev+1) - zsurf(:,:)
       
     
!-----------------------------------------------------------------------
!
!      set up specific humidities and static energies  
!      compute airdensity
!

       hleff   = (min(1.,max(0.,0.05*(t       -tfreeze+20.)))*hlv + &
                  min(1.,max(0.,0.05*(tfreeze -t          )))*hls)
     
       slv     = cp_air*t + grav*zfull_ag - hleff*(ql + qi)
       slv     = slv*(1+d608*(qv+ql+qi))
       density = pfull/rdgas/(t *(1.+d608*qv-ql-qi))              
    
!-----------------------------------------------------------------------
! 
!      big loop over points
!
       
       ibot = nlev
              
       do j=1,nlat
         npts = 0
       if (do_ent_dg(j+js-1) ) then       
       do nn=1,num_pts
         if (                          &
       js == j_entprt(nn) .and.  &
                 i_entprt(nn) >= is .and. i_entprt(nn) <= ie) then
      iloc(npts+1) = i_entprt(nn) - is + 1
      jloc(npts+1) = j_entprt(nn) - js + 1
      nsave(npts+1) = nn
      npts = npts + 1
         endif
        end do    ! (num_points)
       else
          ipt = 0
           jpt = 0
          column_match = .false.
       endif
       do i=1,nlon
         if (npts > 0) then
           do nn=1,npts
             ipt = iloc(nn)
             jpt = jloc(nn)
             if (i == ipt ) then
               column_match = .true.
               nnsave = nsave(nn)
               exit
             else
               column_match = .false.
             endif
           end do
           nn = nnsave
         else 
           column_match = .false.
           nn = 0
         endif

            !-----------------------------------------------------------
            !
            ! should diagnostics be printed out for this column
            !
    
            if (column_match) then
            call get_date(Time, year, month, day, hour, minute, second)
            mon = month_name (month)
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  '===================================='//&
                               '=================='
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  '               ENTERING ENTRAIN    '
            write (dpu,'(a)')  ' '
            write (dpu,'(a, i6,a,i4,i4,i4,i4)')  ' time stamp:',   &
                                       year, trim(mon), day, &
                                       hour, minute, second
            write (dpu,'(a)')  '  DIAGNOSTIC POINT COORDINATES :'
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f8.3,a,f8.3)') ' longitude = ', deglon1(nn),&
                                          ' latitude  = ', deglat1(nn)
            write (dpu,'(a,i6,a,i6)')    &
                                       ' global i =', i_entprt_gl(nn), &
                                       ' global j = ', j_entprt_gl(nn)
            write (dpu,'(a,i6,a,i6)')    &
                                   ' processor i =', i_entprt(nn),     &
                                   ' processor j = ',j_entprt(nn)
            write (dpu,'(a,i6,a,i6)')     &
                                       ' window    i =', ipt,          &
                                       ' window    j = ',jpt
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  ' k      T         u         v       '//&
                               '  qv        qt ' 
            write (dpu,'(a)')  '       (K)      (m/s)     (m/s)     '//&
                               '(g/kg)    (g/kg)'
            write (dpu,'(a)')  '------------------------------------'//&
                               '-----------------'
            write (dpu,'(a)')  ' '
            do kk = nlev-n_print_levels,nlev
                 write(dpu,18) kk,t(i,j,kk),u(i,j,kk),v(i,j,kk),       &
                      1000.*qv(i,j,kk), 1000.*(qv(i,j,kk)+ql(i,j,kk)+  &
                      qi(i,j,kk))
            end do
18          format(1X,i2,1X,5(f9.4,1X))
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  ' k      qa        qc      sliv/cp   '//&
                               'density    tdtlw'
            write (dpu,'(a)')  '                (g/kg)     (K)      '//&
                               ' (kg/m3)   (K/day)'
            write (dpu,'(a)')  '------------------------------------'//&
                               '-------------------'
            write (dpu,'(a)')  ' '
            do kk = nlev-n_print_levels,nlev
                 write(dpu,19) kk,qa(i,j,kk),1000.*                    &
                   (ql(i,j,kk)+qi(i,j,kk)),slv(i,j,kk)/cp_air,         &
                   density(i,j,kk),tdtlw_in(i,j,kk)*86400.
            enddo    
19          format(1X,i2,1X,5(f9.4,1X))
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  ' k   z_full    z_half    p_full    p'//&
                               '_half  '
            write (dpu,'(a)')  '      (m)      (m)        (mb)      '//&
                               '(mb)'
            write (dpu,'(a)')  '------------------------------------'//&
                               '--------'
            write (dpu,'(a)')  ' '
            do kk = nlev-n_print_levels,nlev
                 write(dpu,619) kk,zfull_ag(i,j,kk),zhalf_ag(i,j,kk+1),&
                                pfull(i,j,kk)/100.,phalf(i,j,kk+1)/100.
            enddo
619         format(1X,i2,1X,4(f9.4,1X))
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  ' '
            end if
    
    !-----------------------------------------------------------
    !  BEGIN BASIC CODE
    
    if (present(kbot)) ibot = kbot(i,j)
    
    !---------------
    ! reset indices
    ipbl    = -1
    kcldtop = -1
      
    !-----------------------------------------------------------
    !
    ! SURFACE DRIVEN CONVECTIVE LAYERS
    !
    ! Note this part is done only if b_star > 0., that is,
    ! upward surface buoyancy flux
 
    
    if (b_star(i,j) .gt. 0.) then
    
         !------------------------------------------------------
         ! Find depth of surface driven mixing by raising a 
         ! parcel from the surface with some excess buoyancy
         ! to its level of neutral buoyancy.  Note the use
         ! slv as the density variable permits one to goes
         ! through phase changes to find parcel top
 
         call pbl_depth(slv(i,j,1:ibot)/cp_air, &
              zfull_ag(i,j,1:ibot),u_star(i,j),b_star(i,j),    &
              ipbl,zsml(i,j),parcelkick(i,j))
            
                 
         !------------------------------------------------------
         ! Define velocity scales vsurf and vshear
         !           
         ! vsurf   =  (u_star*b_star*zsml)**(1/3)
         ! vshear  =  (Ashear**(1/3))*u_star
               
         vsurf3   = u_star(i,j)*b_star(i,j)*zsml(i,j)
         vshear3  = Ashear*u_star(i,j)*u_star(i,j)*u_star(i,j)
 
         if (id_vsurf  > 0) vsurf(i,j)  = vsurf3 **(1./3.)
         if (id_vshear > 0) vshear(i,j) = vshear3**(1./3.) 
 
         !------------------------------------------------------
         ! Following Lock et al. 2000, limit height of surface
         ! well mixed layer if interior stable interface is
         ! found.  An interior stable interface is diagnosed if
         ! the slope between 2 full levels is greater than
         ! the namelist parameter critjump
  
         if (ipbl .lt. ibot) then 
              do k = ibot, ipbl+1, -1
                   tmpjump =(slv(i,j,k-1)-slv(i,j,k))/cp_air 
                   if (tmpjump .gt. critjump) then
                         ipbl = k
                         zsml(i,j) = zhalf_ag(i,j,ipbl)
                         exit
                   end if
             enddo
         end if         

         !-------------------------------------
         ! compute entrainment rate
         !
 
         tmp1 = grav*max(0.1,(slv(i,j,ipbl-1)-slv(i,j,ipbl))/   &
                cp_air)/(slv(i,j,ipbl)/cp_air)
         tmp2 = ((vsurf3+vshear3)**(2./3.)) / zsml(i,j)
                  
         wentr_tmp= min( wentrmax,  max(0., (beta_surf *        &
                         (vsurf3 + vshear3)/zsml(i,j))/         &
                         (tmp1+tmp2) ) )
                                   
         k_entr_tmp = wentr_tmp*(zfull_ag(i,j,ipbl-1)-          &
                 zfull_ag(i,j,ipbl))  
         k_entr_tmp = min ( k_entr_tmp, akmax )

         pblfq(i,j,ipbl:ibot) = 1.
         convpbl(i,j)         = 1.
         use_entr(i,j,ipbl:ibot) = 1.
         wentr_pbl(i,j)       = wentr_tmp
         k_t_troen(i,j,ipbl)  = k_entr_tmp
         k_m_troen(i,j,ipbl)  = k_entr_tmp
         k_t_entr (i,j,ipbl)  = k_t_entr(i,j,ipbl) + k_entr_tmp
         k_m_entr (i,j,ipbl)  = k_m_entr(i,j,ipbl) + k_entr_tmp
         
         !------------------------------------------------------
         ! if surface based moist convection is occurring in the
         ! grid box set the entrainment rate to zero
         
         if (convect(i,j).and.convect_shutoff) then
                 
              wentr_pbl(i,j)      = 0.
              pblfq(i,j,ipbl)     = 0.
              k_t_entr (i,j,ipbl) = k_t_entr (i,j,ipbl) -      &
                                    k_t_troen(i,j,ipbl)
              k_m_entr (i,j,ipbl) = k_m_entr (i,j,ipbl) -      &
                                    k_m_troen(i,j,ipbl)          
              k_t_troen(i,j,ipbl)  = 0.
              k_m_troen(i,j,ipbl)  = 0. 
                 
         end if

         !------------------------------------------------------
         ! compute diffusion coefficients in the interior of
         ! the PBL
 
         if (ipbl .lt. ibot) then
      
              ! copy array slices into contigous arrays (pletzer)
              zhalf_ag_1 ((ipbl+1):ibot) = zhalf_ag (i,j,(ipbl+1):ibot)
              k_m_troen_1((ipbl+1):ibot) = k_m_troen(i,j,(ipbl+1):ibot)
              k_t_troen_1((ipbl+1):ibot) = k_t_troen(i,j,(ipbl+1):ibot)

              call diffusivity_pbl(zsml(i,j),u_star(i,j),      &
                   b_star(i,j), slv(i,j,(ipbl+1):ibot)/cp_air, &
                          zhalf_ag_1((ipbl+1):ibot),         &
                          k_m_troen_1((ipbl+1):ibot),        &
                          k_t_troen_1((ipbl+1):ibot))

              ! copy back
              k_m_troen(i,j,(ipbl+1):ibot) = k_m_troen_1((ipbl+1):ibot)
              k_t_troen(i,j,(ipbl+1):ibot) = k_t_troen_1((ipbl+1):ibot)
                      
              k_t_entr(i,j,(ipbl+1):ibot) =                    & 
                   k_t_entr(i,j,(ipbl+1):ibot) +               &
                   k_t_troen(i,j,(ipbl+1):ibot)
     
              k_m_entr(i,j,(ipbl+1):ibot) =                    & 
                   k_m_entr(i,j,(ipbl+1):ibot) +               &
                   k_m_troen(i,j,(ipbl+1):ibot)
         
         end if
         
    end if      
    
    
    !-----------------------------------------------------------
    !
    ! LW RADIATIVELY DRIVEN CONVECTIVE LAYERS
    !
    ! This part is done only if a level can be found with
    ! greater than radfmin (typically 30 W/m2) longwave
    ! divergence and if the level is at a lower altitude
    ! than zcldtopmax (typically 3000 m).
    !
    ! Note that if no layer is found with radiative divergence
    ! greater than radfmin, a check is made on the heating rates
    ! themselves and compared to qdotmin (10 K/day)

    !--------------------------
    ! find level of zcldtopmax
    
    kmax = ibot+1
    do k = 1, ibot
          if( zhalf_ag(i,j,k) < zcldtopmax) then
               kmax = k
               exit
          end if
    end do
       
    !-----------------------------------------------------------
    ! compute radiative driving
    !
    ! look at heating rate itself if no levels with radiative 
    ! forcing greater than radfmin are found.
    
    kcldtop = ibot+1
    maxradf = radfmin
    do k = kmax, ibot
         tmpradf = -1.*tdtlw_in(i,j,k)*cp_air*          &
                   ((phalf(i,j,k+1)-phalf(i,j,k))/grav)
         if (tmpradf .gt. maxradf) then
              kcldtop = k
              maxradf = tmpradf
         end if          
    enddo              
    
    !-----------------------------------------------------------
    ! Second try to find a radiatively driven level
    !
    ! exit if no levels with longwave cooling rate greater than
    ! qdotmin are found.
    
    if (kcldtop .eq. ibot+1) then
    
         kcldtop = ibot+1
         maxradf = radfmin
         maxqdot = qdotmin
                 
         do k = kmax, ibot
              tmpqdot = -1.*86400*tdtlw_in(i,j,k)
              tmpradf = -1.*tdtlw_in(i,j,k)*cp_air*     &
                           ((phalf(i,j,k+1)-phalf(i,j,k))/grav)
              if (tmpqdot .gt. maxqdot) then
                   kcldtop = k
                   maxradf = tmpradf
                   maxqdot = tmpqdot
              end if          
         enddo              
                 
         if (kcldtop .eq. ibot+1) go to 55
   
    end if

    !-----------------------------------------------------------
    ! following Lock for stable layer one level down;
    ! move cld top there if it exists
        
    !if (kcldtop .lt. ibot) then
    !    tmpjump =(slv(i,j,kcldtop)-slv(i,j,kcldtop+1))/cp_air
    !    if (tmpjump .gt. critjump) kcldtop = kcldtop+1           
    !end if    
    
    !-----------------------------------------------------------
    ! if layer is unstable move up a layer
    ! if that layer is also unstable exit
    
    if (slv(i,j,kcldtop-1) .lt. slv(i,j,kcldtop)) then  
         kcldtop = kcldtop - 1
         if (slv(i,j,kcldtop-1) .lt. slv(i,j,kcldtop)) then
              go to 55
         end if     
    end if
     
    !-----------------------------------------------------------
    ! exit if no cloud is present

    if ( qa(i,j,kcldtop-1)           .lt. qamin .and.          &
         qa(i,j,kcldtop  )           .lt. qamin .and.          &
         qa(i,j,min(kcldtop+1,ibot)) .lt. qamin ) go to 55
       
    !-----------------------------------------------------------
    ! compute cloud top temperature, svpcp. Ensure that
    ! that the cloud top parcel temperature, equal to
    ! svpcp minus radperturb, is no greater than
    ! the temperature of level kcldtop+1 minus radperturb if 
    ! parcel_option equals 1, and the temperature of level
    ! kcldtop+1 if parcel_option does not equal 1. This is
    ! done so that if kcldtop is in an ambiguous layer
    ! then there will not be a sudden jump in cloud top
    ! properties
    !
    ! Also assign radiative forcing at height of radiatively
    ! driven mixed layer.

    if (parcel_option .eq. 1) then
       svpcp(i,j) =min((slv(i,j,kcldtop  )/cp_air),            &
             (slv(i,j,min(kcldtop+1,ibot))/cp_air)             ) 
    else
       svpcp(i,j) =min((slv(i,j,kcldtop  )/cp_air),            &
             (slv(i,j,min(kcldtop+1,ibot))/cp_air) + radperturb) 
    end if
    
    radf(i,j) = maxradf
    zradtop(i,j) = zhalf_ag(i,j,kcldtop)
                 
    !-----------------------------------------------------------
    ! find depth of radiatively driven convection 
 
    if (kcldtop .lt. ibot) then 
         call radml_depth(svpcp(i,j),zradtop(i,j),             &
              slv(i,j,kcldtop:ibot)/cp_air,                    &
              zfull_ag(i,j,kcldtop:ibot),                      &
              zhalf_ag(i,j,kcldtop:ibot),zradbase(i,j),        &
              zradml(i,j))      
    else
         zradbase(i,j) = 0.0
         zradml(i,j)   = zradtop(i,j)  
    end if                   
                 
    !-----------------------------------------------------------
    ! compute radiation driven scale
    !
    ! Vrad**3 = g*zradml*radf/density/slv
    
    vrad3 = grav*zradml(i,j)*maxradf/density(i,j,kcldtop)/ &
            slv(i,j,kcldtop)   
    vrad(i,j) = vrad3 ** (1./3.)    
            
    !-----------------------------------------------------------
    ! compute entrainment rate
    !


    tmp1 = grav*max(0.1,((slv(i,j,kcldtop-1)/cp_air)-          &
            svpcp(i,j)))/(slv(i,j,kcldtop)/cp_air)
    
    tmp2 = (vrad(i,j)**2.) / zradml(i,j)
    wentr_rad(i,j) = min(wentrmax,beta_rad*vrad3/zradml(i,j)/  &
                     (tmp1+tmp2)) 
    k_entr_tmp = min ( akmax, wentr_rad(i,j)*                  &
               (zfull_ag(i,j,kcldtop-1)-zfull_ag(i,j,kcldtop)) )
             
    radfq(i,j,kcldtop)     = 1.
    radpbl(i,j)            = 1.
    use_entr(i,j,kcldtop)  = 1.
    k_rad(i,j,kcldtop)     = k_entr_tmp
    k_t_entr (i,j,kcldtop) = k_t_entr(i,j,kcldtop) + k_entr_tmp
    k_m_entr (i,j,kcldtop) = k_m_entr(i,j,kcldtop) + k_entr_tmp
    
    !-----------------------------------------------------------
    ! handle case of radiatively driven top being the same top
    ! as surface driven top
    
    if (ipbl .eq. kcldtop .and. ipbl .gt. 0) then

         tmp2 = ((vrad3+vsurf3+vshear3)**(2./3.)) / zradml(i,j)
 
         wentr_rad(i,j) = min( wentrmax,  max(0.,              &
              ((beta_surf *(vsurf3 + vshear3)+beta_rad*vrad3)/ &
              zradml(i,j))/(tmp1+tmp2) ) )
      
         wentr_pbl(i,j)       = wentr_rad(i,j)
                 
         k_entr_tmp = min ( akmax, wentr_rad(i,j)*             &
               (zfull_ag(i,j,kcldtop-1)-zfull_ag(i,j,kcldtop)) )
                 
         pblfq(i,j,ipbl)        = 1.
         radfq(i,j,kcldtop)     = 1.
         radpbl(i,j)            = 1.
         use_entr(i,j,kcldtop)  = 1.
         k_rad(i,j,kcldtop)     = k_entr_tmp
         k_t_troen(i,j,ipbl)    = k_entr_tmp
         k_m_troen(i,j,ipbl)    = k_entr_tmp
         k_t_entr (i,j,kcldtop) = k_entr_tmp
         k_m_entr (i,j,kcldtop) = k_entr_tmp
                                    
    end if
                                    
    !-----------------------------------------------------------
    ! if there are any interior layers to calculate diffusivity
      
    if ( kcldtop .lt. ibot ) then   

         do k = kcldtop+1,ibot
 
             ztmp = max(0.,(zhalf_ag(i,j,k)-zradbase(i,j))/    &
                    zradml(i,j) )
             
             if (ztmp.gt.0.) then
     
                  radfq(i,j,k) = 1.
                  use_entr(i,j,k) = 1.
                  k_entr_tmp = 0.85*vonkarm*vrad(i,j)*ztmp*    &
                  zradml(i,j)*ztmp*((1.-ztmp)**0.5)
                  k_entr_tmp = min ( k_entr_tmp, akmax )
                  k_rad(i,j,k) = k_entr_tmp
                  k_t_entr (i,j,k) = k_t_entr(i,j,k)           &
                                   + k_entr_tmp
                  k_m_entr (i,j,k) = k_m_entr(i,j,k)           &
                                   + pr*k_entr_tmp
             
             end if                   
         enddo  
 
    end if
           
    !-----------------------------------------------------------
    ! handle special case of zradbase < zsml
    !
    ! in this case there should be no entrainment from the 
    ! surface.
    
    if (zradbase(i,j) .lt. zsml(i,j) .and. convpbl(i,j) .eq. 1. &
        .and. ipbl .gt. kcldtop) then
         wentr_pbl(i,j)      = 0.
         pblfq(i,j,ipbl)     = 0.
         k_t_entr (i,j,ipbl) = k_t_entr (i,j,ipbl) -            &
                               k_t_troen(i,j,ipbl)
         k_m_entr (i,j,ipbl) = k_m_entr (i,j,ipbl) -            &
                               k_m_troen(i,j,ipbl)          
         k_t_troen(i,j,ipbl)  = 0.
         k_m_troen(i,j,ipbl)  = 0. 
    end if

55  continue
    
    !-----------------------------------------------------------
    !
    ! Modify diffusivity coefficients if apply_entrain = T
        
    if (apply_entrain) then
         do k = 2, ibot     
              if (use_entr(i,j,k).eq.1.) then   
                   diff_t(i,j,k) = k_t_entr(i,j,k)
                   diff_m(i,j,k) = k_m_entr(i,j,k)
              end if
         enddo      
    end if
           
    !-----------------------------------------------------------
    !
    ! compute maximum height to apply very stable mixing 
    ! coefficients (see stable_bl_turb.f90)
    
    vspblcap(i,j) = zhalf_ag(i,j,2)   
    if ( radpbl(i,j).eq.1.) vspblcap(i,j) = zradbase(i,j)  
    if (convpbl(i,j).eq.1.) vspblcap(i,j) = 0.

    !-----------------------------------------------------------
    !
    ! Diagnostic code for inversions
    
    if (id_fqinv > 0 .or. id_zinv > 0 .or. id_invstr > 0) then
       maxinv = 0.0
       do k = ibot,2,-1
            if ( t(i,j,k)            .lt. t(i,j,k-1) .and.     &
                (t(i,j,k-1)-t(i,j,k)).gt. maxinv     .and.     &
                 zhalf_ag(i,j,k)     .lt. 3000. ) then
                 maxinv      = t(i,j,k-1)-t(i,j,k)
                 invstr(i,j) = (slv(i,j,k-1)-slv(i,j,k))/cp_air
                 fqinv(i,j)  = 1.
                 zinv(i,j)   = zhalf_ag(i,j,k)   
            end if
        enddo                   
    end if 

    !-----------------------------------------------------------
    !
    ! Selected points printout
    

    if (column_match) then
    
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' u_star = ', u_star(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' b_star = ', b_star(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' convpbl = ', convpbl(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a,i3)')  ' ipbl = ', ipbl
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' parcelkick = ', parcelkick(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' zsml = ', zsml(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' vsurf = ', vsurf(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' vshear = ', vshear(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' wentr_pbl = ', wentr_pbl(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' radpbl = ', radpbl(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a,i3)')  ' kcldtop = ', kcldtop
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' svpcp = ', svpcp(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' zradtop = ', zradtop(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' zradbase = ', zradbase(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' wentr_rad = ', wentr_rad(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' vrad = ', vrad(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' radf = ', radf(i,j)
            write (dpu,'(a)')  ' '
            write (dpu,'(a,f10.4)')  ' vspblcap = ', vspblcap(i,j)
            write (dpu,'(a)')  ' '
       
       
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  ' k  use_entr    diff_t    diff_m  '//  &
                               '  k_t_entr  k_m_entr' 
            write (dpu,'(a)')  '                (m2/s)    (m2/s)    '//&
                               '(m2/s)    (m2/s)'
            write (dpu,'(a)')  '------------------------------------'//&
                               '------------------'
            write (dpu,'(a)')  ' '
            do kk = nlev-n_print_levels,nlev
             write(dpu,947) kk,use_entr(i,j,kk), diff_t(i,j,kk),       &
                      diff_m(i,j,kk), k_t_entr(i,j,kk), k_m_entr(i,j,kk)
            end do
947         format(1X,i2,3X,f4.1,4X,4(f9.4,1X))
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  ' '
            write (dpu,'(a)')  ' k   pblfq  radfq     '//&
                               'k_t_troen k_m_troen   k_rad' 
            write (dpu,'(a)')  '                       (m2/s)'//   &
                               '    (m2/s)     (m2/s) '
            write (dpu,'(a)')  '------------------------------------'//&
                               '------------------------------------'
            write (dpu,'(a)')  ' '
            do kk = nlev-n_print_levels,nlev
                 write(dpu,949) kk,pblfq(i,j,kk),radfq(i,j,kk),        &
                       k_t_troen(i,j,kk),k_m_troen(i,j,kk),k_rad(i,j,kk)
            end do
949         format(1X,i2,3X,2(f4.1,4X),3(f9.4,1X))

      end if

      enddo
      enddo
    
!-----------------------------------------------------------------------
! 
!      Diagnostics
!

       if ( id_convpbl    > 0 .or. id_wentr_pbl > 0 .or.               &
            id_k_m_entr   > 0 .or. id_wentr_rad > 0 .or.               &
            id_zsml       > 0 .or. id_k_t_entr  > 0 .or.               &
            id_pblfq      > 0 .or. id_radfq     > 0 .or.               &
            id_parcelkick > 0 .or. id_k_t_troen > 0 .or.               &
            id_k_rad      > 0 .or. id_k_m_troen > 0 .or.               &
            id_radf       > 0 .or. id_vrad      > 0 .or.               &
            id_zradbase   > 0 .or. id_radpbl    > 0 .or.               &
            id_zradtop    > 0 .or. id_zradml    > 0 .or.               &
            id_svpcp      > 0 .or. id_vsurf     > 0 .or.               &
            id_vshear     > 0  ) then 

          mask3(:,:,1:(nlev+1)) = 1.
          if (present(kbot)) then
               where (zhalf_ag < 0.)
                     mask3(:,:,:) = 0.
               end where
          endif
            
          !----------------------------------------------
          !
          ! Convective PBL diagnostics
          !
    
          if ( id_convpbl > 0 ) then
                 used = send_data ( id_convpbl, convpbl, time, is, js )
          end if
    
          if ( id_zsml > 0 ) then
                 used = send_data ( id_zsml, zsml, time, is, js )
          end if
    
          if ( id_vsurf > 0 ) then
                 used = send_data ( id_vsurf, vsurf, time, is, js )
          end if
    
          if ( id_vshear > 0 ) then
                 used = send_data ( id_vshear, vshear, time, is, js )
          end if
    
          if ( id_parcelkick > 0 ) then
                 used = send_data ( id_parcelkick, parcelkick, time,   &
                    is, js )
          end if
    
          if ( id_wentr_pbl > 0 ) then
               used = send_data ( id_wentr_pbl, wentr_pbl, time,     &
                          is, js)
          end if
            
          if ( id_pblfq > 0 ) then
               rtmp = 0.
               rtmp(:,:,1:nlev) = pblfq
               used = send_data ( id_pblfq, rtmp, time, is, js,      &
                          1, rmask=mask3 )
          end if
            
          if ( id_k_t_troen > 0 ) then
               rtmp = 0.
               rtmp(:,:,1:nlev) = k_t_troen
               used = send_data ( id_k_t_troen, rtmp, time, is, js,  &
                          1, rmask=mask3 )
          end if
            
          if ( id_k_m_troen > 0 ) then
               rtmp = 0.
               rtmp(:,:,1:nlev) = k_m_troen
               used = send_data ( id_k_m_troen, rtmp, time, is, js,  &
                          1, rmask=mask3 )
          end if
            
          !----------------------------------------------
          !
          ! Cloud top radiative cooling diagnostics
          !
    
          if ( id_radpbl > 0 ) then
                 used = send_data ( id_radpbl, radpbl, time, is, js )
          end if
    
          if ( id_vrad > 0 ) then
                 used = send_data ( id_vrad, vrad, time, is, js )
          end if
    
          if ( id_zradml > 0 ) then
                 used = send_data ( id_zradml, zradml, time, is, js )
          end if
    
          if ( id_svpcp > 0 ) then
                 used = send_data ( id_svpcp, svpcp, time, is, js )
          end if
    
          if ( id_zradtop > 0 ) then
                 used = send_data ( id_zradtop, zradtop, time, is, js )
          end if
    
          if ( id_zradbase > 0 ) then
                 used = send_data ( id_zradbase, zradbase, time, is, js)
          end if
    
          if ( id_radf > 0 ) then
                 used = send_data ( id_radf, radf, time, is, js )            
          end if
            
          if ( id_wentr_rad > 0 ) then
                 used = send_data ( id_wentr_rad, wentr_rad, time, is, &
                                      js)
          end if
            
          if ( id_radfq > 0 ) then
               rtmp = 0.
               rtmp(:,:,1:nlev) = radfq
               used = send_data ( id_radfq, rtmp, time, is, js,      &
                          1, rmask=mask3 )
          end if
            
          if ( id_k_rad > 0 ) then
               rtmp = 0.
               rtmp(:,:,1:nlev) = k_rad
               used = send_data ( id_k_rad, rtmp, time, is, js, 1,   &
                          rmask=mask3 )
          end if
            
          !----------------------------------------------
          !
          ! Total diffusivity coefficients
          !
    
          if ( id_k_t_entr > 0 ) then
               rtmp = 0.
               rtmp(:,:,1:nlev) = k_t_entr
               used = send_data ( id_k_t_entr, rtmp, time, is, js,   &
                          1, rmask=mask3 )
          end if
            
          if ( id_k_m_entr > 0 ) then
               rtmp = 0.
               rtmp(:,:,1:nlev) = k_m_entr
               used = send_data ( id_k_m_entr, rtmp, time, is, js,   &
                          1, rmask=mask3 )
          end if


          !----------------------------------------------
          !
          ! Inversion diagnostics
          !

          if ( id_fqinv > 0 ) then
                 used = send_data ( id_fqinv, fqinv, time, is, js )
          end if
    
          if ( id_zinv > 0 ) then
                 used = send_data ( id_zinv, zinv, time, is, js )
          end if
    
          if ( id_invstr > 0 ) then
                 used = send_data ( id_invstr, invstr, time, is, js )
          end if
              
       end if  ! do diagnostics if
       
!-----------------------------------------------------------------------
! 
!      subroutine end
!

end subroutine entrain

!
!======================================================================= 

!======================================================================= 
!
!  Subroutine to calculate pbl depth
!

! <SUBROUTINE NAME="pbl_depth">
!  <OVERVIEW>
!    
!  </OVERVIEW>
!  <DESCRIPTION>
!
!      Calculates the depth of the surface based convective layer
!  </DESCRIPTION>
!  <TEMPLATE>
!   call pbl_depth(t, z, u_star, b_star, ipbl, h, parcelkick)
!
!  </TEMPLATE>
!  <IN NAME="t" TYPE="real">
!       Liquid water virtual static energy divided by cp (K)
!  </IN>
!  <IN NAME="z" TYPE="real">
!       Geopoential height of levels t is defined on (m)       
!  </IN>
!  <IN NAME="u_star" TYPE="real">
!       Friction velocity (m/s)
!  </IN>
!  <IN NAME="b_star" TYPE="real">
!       Buoyancy scale (m/s2)
!  </IN>
!  <OUT NAME="ipbl" TYPE="integer">
!       Integer indicating the half model level which is the PBL top
!  </OUT>
!  <OUT NAME="h" TYPE="real">
!       PBL height (m)
!  </OUT>
!  <OUT NAME="parcelkick" TYPE="real">
!       Surface parcel excess (K)
!  </OUT>
! </SUBROUTINE>
!
subroutine pbl_depth(t, z, u_star, b_star, ipbl, h, parcelkick)

!
!  -----
!  INPUT
!  -----
!
!  t (= slv/cp)  liquid water virtual static energy divided by cp (K)
!  u_star        friction velocity (m/s)
!  b_star        buoyancy scale (m/s**2)
!       
!  ------
!  OUTPUT
!  ------
!
!  ipbl          half level containing pbl height
!  h             pbl height (m)
!  parcelkick    surface parcel excess (K)

real,    intent(in) ,  dimension(:) :: t, z
real,    intent(in)                 :: u_star, b_star
integer, intent(out)                :: ipbl
real,    intent(out)                :: h,parcelkick

real     :: svp,h1,h2,t1,t2
real     :: ws,k_t_ref
integer  :: k,nlev

!initialize zsml
h = 0.

!compute # of levels
nlev = size(t,1)

!calculate surface parcel properties
svp  = t(nlev)
h1   = z(nlev)
call mo_diff(h1, u_star, b_star, ws, k_t_ref)
ws = max(small,ws/vonkarm/h1)
svp  = svp*(1.+(parcel_buoy*u_star*b_star/grav/ws) )
parcelkick = svp*parcel_buoy*u_star*b_star/grav/ws

!search for level where this is exceeded              
h    = h1
t1   = t(nlev)
do k = nlev-1 , 2, -1
     h2 = z(k)
     t2 = t(k)
     if (t2.gt.svp) then
          h = h2 + (h1 - h2)*(t2 - svp)/(t2 - t1 )
          ipbl = k+1
          return
     end if
     h1 = h2
     t1 = t2
enddo

!one shouldn't end up here but nonetheless for safety this is put here
h = h2
ipbl = k+1

return

end subroutine pbl_depth

!=======================================================================

!======================================================================= 
!
!  Subroutine to do profile reconstuction
!

! <SUBROUTINE NAME="prof_recon">
!  <OVERVIEW>
!      
!  </OVERVIEW>
!  <DESCRIPTION>
!
!      Subroutine to do profile reconstruction
!
!      This is not turned on in the default version as I suspect there is a 
!      bug in this subroutine.
!
!  </DESCRIPTION>
!  <TEMPLATE>
!   call prof_recon(rho,t,pf,ph,zt,dt)
!
!  </TEMPLATE>
!  <IN NAME="rho" TYPE="real">
!       Air density (kg/m3)
!  </IN>
!  <IN NAME="t" TYPE="real">
!       Liquid water virtual static energy divided by cp (K)
!  </IN>
!  <IN NAME="pf" TYPE="real">
!       Full level pressures (Pa)
!  </IN>
!  <IN NAME="ph" TYPE="real">
!       Half level pressures (pa)
!  </IN>
!  <OUT NAME="zt" TYPE="real">
!       Top of radiatively driven layer in distance relative to boundary between cloud top layer and the level below (m)
!  </OUT>
!  <OUT NAME="dt" TYPE="real">
!       Cloud top jump in liquid water virtual static energy divided by cp (K)
!  </OUT>
! </SUBROUTINE>
!
subroutine prof_recon(rho,t,pf,ph,zt,dt)

!
!  -----
!  INPUT
!  -----
!
!  rho    air density (kg/m3)
!  t      liquid water virtual static energy divided by cp (K)
!  pf     full level pressure (Pa)
!  ph     half level pressure (Pa)
!       
!  ------
!  OUTPUT
!  ------
!
!  zt     top of radiatively driven layer in distance relative to
!         boundary between cloud top layer and the level below (m)
!  dt     cloud top jump in liquid water virtual static energy divided 
!         by cp (K)
!
 
real,   intent(in)                    :: rho
real,   intent(in) ,  dimension(-2:1) :: t, pf
real,   intent(in) ,  dimension( 0:1) :: ph
real,   intent(out)                   :: zt, dt

real, dimension(-2:1) :: pfp
real, dimension( 0:1) :: php

real                         :: slope,textrap
real                         :: a,b,c,det,pinv,ttop

!-----------------------------------------
! calculate all pressure relative to ph(0)
!
! pfp = full level relative pressures
! php = half level relative pressures
!
!  pfp(-2) < pfp(-1) < php(0) < pfp(0) < php(1) < pfp(1)
! 
! Note the following coordinate system
!
!            - - - - - - - - - - - - - -    
!
!                       *                   pfp(-2)
!
!            - - - - - - - - - - - - - - 
!
!                       *                   pfp(-1)
!
!            - - - - - - - - - - - - - -    php(0)
!
!  ambiguous layer ---> *                   pfp(0)
!
!            - - - - - - - - - - - - - -    php(1)
!
!                       *                   pfp(1)
!
!            - - - - - - - - - - - - - -
!

pfp = pf - ph(0)
php = ph - ph(0)

!----------------
! determine slope

slope = min ( (t(-2)-t(-1))/(pfp(-2)-pfp(-1)) , 0. )

! if this slope is such that the mean temperature of level 0 would
! exceed its actual temperature then assume a minimum protusion of
! mixed layer into ambiguous layer
!
! otherwise compute height of inversion using normal method


textrap = t(-1)+slope*(pfp(0)-pfp(-1))

if (textrap .lt. t(0)) then

     zt = 0.1*php(1)/rho/grav
     dt = t(0)-t(1)

else

     a = 0.5*slope
     b = t(-1)-t(1)-slope*pfp(-1)
     c = - php(1)*(t(0)-t(1))

     det = b*b - 4*a*c

     if (a.lt.0.) then
          pinv = (-b+sqrt(det))/(2*a)
     else
          pinv = c/b
     end if
     
     zt = (php(1)-pinv)/rho/grav
     ttop = t(-1) + slope*(pinv-pfp(-1))
     
     dt = ttop - t(1)
            
end if
 
return

end subroutine prof_recon

!=======================================================================

!======================================================================= 
!
!  Subroutine to calculate bottom and depth of radiatively driven mixed
!  layer
!
! <SUBROUTINE NAME="radml_depth">
!  <OVERVIEW>
!       
!  </OVERVIEW>
!  <DESCRIPTION>
!       Subroutine to calculate the depth of the the radiatively driven 
!       (i.e. stratocumulus) mixed layer 
!  </DESCRIPTION>
!  <TEMPLATE>
!   call radml_depth(svp, zt, t, zf, zh, zb, zml)
!
!  </TEMPLATE>
!  <IN NAME="svp" TYPE="real">
!       Cloud top value of the liquid water virtual static energy divided by cp (K)
!  </IN>
!  <IN NAME="zt" TYPE="real">
!       Top of radiatively driven layer (m)
!  </IN>
!  <IN NAME="t" TYPE="real">
!       Liquid water virtual static energy divided by cp (vertical profile) (K)
!  </IN>
!  <IN NAME="zf" TYPE="real">
!       Full level geopotential height relative to ground (vertical profile) (m)
!  </IN>
!  <IN NAME="zh" TYPE="real">
!       Half level geopotential height relative to ground (vertical profile) (m)
!  </IN>
!  <OUT NAME="zb" TYPE="real">
!       Base of radiatively driven mixed layer (m) 
!  </OUT>
!  <OUT NAME="zml" TYPE="real">
!       Depth of radiatively driven mixed layer (m) (equals zt minus zb)
!  </OUT>
! </SUBROUTINE>
!
subroutine radml_depth(svp, zt, t, zf, zh, zb, zml)

!
!  -----
!  INPUT
!  -----
!
!  svp    cloud top liquid water virtual static energy divided by cp (K)
!  zt     top of radiatively driven layer (m)
!  t      liquid water virtual static energy divided by cp (K)
!  zf     full level height above ground (m)
!  zh     half level height above ground (m)
!       
!  ------
!  OUTPUT
!  ------
!
!  zb      base height of radiatively driven mixed layer (m)
!  zml     depth of radiatively driven mixed layer (m)


real,   intent(in)                 :: svp, zt
real,   intent(in) ,  dimension(:) :: t, zf, zh
real,   intent(out)                :: zb, zml

real    :: svpar,h1,h2,t1,t2
integer :: k,nlev

!initialize zml
zml = 0.

!compute # of levels
nlev = size(t,1)

!calculate cloud top parcel properties
svpar  = svp - radperturb
h1   = zf(1)
t1   = t(1)

!search for level where this is exceeded              
do k = 2,nlev
     h2 = zf(k)
     t2 = t(k)
     
     if (t2.lt.svpar) then
          zb = h2 + (h1 - h2)*(svpar - t2)/(t1 - t2)
          zml = zt - zb
          return
     end if
     
     if (do_jump_exit .and. (t1-t2) .gt. critjump .and. k .gt. 2) then
          zb = zh(k)
          zml = zt - zb
          return
     end if
     
     h1 = h2
     t1 = t2
enddo

zb = 0.
zml = zt
  
return
end subroutine radml_depth

!=======================================================================


!=======================================================================

! <SUBROUTINE NAME="diffusivity_pbl">
!  <OVERVIEW>
!         
!  </OVERVIEW>
!  <DESCRIPTION>
!       Subroutine to return the vertical K-profile of diffusion 
!       coefficients for the surface driven convective mixed layer    
!  </DESCRIPTION>
!  <TEMPLATE>
!   call diffusivity_pbl(h, u_star, b_star, t, zm, k_m, k_t)
!
!  </TEMPLATE>
!  <IN NAME="h" TYPE="real">
!      Depth of surface driven mixed layer (m) 
!  </IN>
!  <IN NAME="u_star" TYPE="real">
!      Friction velocity (m/s)
!  </IN>
!  <IN NAME="b_star" TYPE="real">
!      Buoyancy scale (m/s2)
!  </IN>
!  <IN NAME="t" TYPE="real">
!      Liquid water virtual static energy divided by cp (K)
!  </IN>
!  <IN NAME="zm" TYPE="real">
!      Half level heights relative to the ground (m)
!  </IN>
!  <OUT NAME="k_m" TYPE="real">
!      Momentum diffusion coefficient (m2/s)
!  </OUT>
!  <OUT NAME="k_t" TYPE="real">
!      Heat and tracer diffusion coefficient (m2/s)
!  </OUT>
! </SUBROUTINE>
!
subroutine diffusivity_pbl(h, u_star, b_star, t, zm, k_m, k_t)
 
real,    intent(in)                :: h, u_star, b_star
real,    intent(in),  dimension(:) :: t,zm
real,    intent(out), dimension(:) :: k_m, k_t

real    :: k_m_ref, k_t_ref, factor, hinner
integer :: k, kk, nlev

nlev = size(t,1)

k_m = 0.0
k_t = 0.0

hinner = frac_inner*h
kk = nlev+1
do k = 1, nlev
  if( zm(k) < hinner) then
      kk = k
      exit
  end if
end do

call mo_diff(hinner, u_star, b_star, k_m_ref, k_t_ref)

if (kk .lt. nlev+1) then 
     call mo_diff(zm(kk:nlev), u_star, b_star, k_m(kk:nlev),           &
                                               k_t(kk:nlev))
end if

if (kk .gt. 1) then
     do k = 1,kk-1
        factor = (zm(k)/hinner)* (1.0 -(zm(k)-hinner)/(h-hinner))**2
        k_m(k) = min( k_m_ref*factor, akmax )
        k_t(k) = min( k_t_ref*factor, akmax )
     end do
end if

return
end subroutine diffusivity_pbl

!
!======================================================================= 

!======================================================================= 
!
!      subroutine entrain_tend
!        
!
!      this subroutine takes the longwave heating rate and assigns it
!      to tdtlw
!        

!subroutine entrain_tend(is,ie,js,je,tend)

!-----------------------------------------------------------------------
!
!      variables
!
!      -----
!      input
!      -----
!
!      is,ie,js,je       i,j indices marking the slab of model 
!      tend              longwave heating rate (deg K/sec)
!
!-----------------------------------------------------------------------

!integer, intent(in)                   :: is,ie,js,je
!real,    intent(in), dimension(:,:,:) :: tend

!-----------------------------------------------------------------------
!
!      assign tendency
!

!      if (.not. entrain_on) return
!      tdtlw(is:ie,js:je,:)=tend(:,:,:)

!-----------------------------------------------------------------------
! 
!      subroutine end
!

!end subroutine entrain_tend

!
!======================================================================= 




!======================================================================= 
!
!      subroutine entrain_end
!        
!
!      this subroutine writes out the restart field
!        

! <SUBROUTINE NAME="entrain_end">
!  <OVERVIEW>
!      
!  </OVERVIEW>
!  <DESCRIPTION>
!      All this module does is to set "module_is_initialized" to false.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call entrain_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine entrain_end()

!-----------------------------------------------------------------------
!
!      variables
!
!      --------
!      internal
!      --------
!
!      unit              unit number for namelist and restart file
!
!-----------------------------------------------------------------------

!integer :: unit

!-----------------------------------------------------------------------
!
!      write out restart file
!
!      unit = Open_File ('RESTART/entrain.res', &
!           FORM='native', ACTION='write')
!      call write_data (unit, tdtlw)
!      Call Close_File (unit)
      module_is_initialized = .false.
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
! 
!      subroutine end
!

end subroutine entrain_end

!
!=======================================================================

end module entrain_mod

module atmos_tracer_utilities_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   William Cooke
! </CONTACT>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Bruce Wyman
! </REVIEWER>


! <OVERVIEW>
!     This code provides some utility routines for atmospheric tracers in the FMS framework.
! </OVERVIEW>
! <DESCRIPTION>
!    This module gives utility routines which can be used to provide 
!    consistent removal mechanisms for atmospheric tracers. 
!
!    In particular it provides schemes for wet and dry deposiiton that 
!    can be easily utilized.
!
! </DESCRIPTION>


use            fms_mod, only : lowercase, &
                               write_version_number, &
                               stdlog, &
                               mpp_pe, &
                               mpp_root_pe, &
                               error_mesg, &
                               NOTE, FATAL
use   time_manager_mod, only : time_type
use   diag_manager_mod, only : send_data, &
                               register_diag_field
use tracer_manager_mod, only : query_method, &
                               get_tracer_names, &
                               get_number_tracers, &
                               MAX_TRACER_FIELDS
use  field_manager_mod, only : MODEL_ATMOS, parse
use   horiz_interp_mod, only : horiz_interp_type, horiz_interp_init, &
                               horiz_interp_new, horiz_interp, horiz_interp_del
use  monin_obukhov_mod, only : mo_profile
use      constants_mod, only : GRAV, &     ! acceleration due to gravity [m/s2]
                               RDGAS, &    ! gas constant for dry air [J/kg/deg]
                               vonkarm, &
                               PI, &
                               DENS_H2O, & ! Water density [kg/m3]
                               WTMH2O, &   ! Water molecular weight [g/mole]
                               WTMAIR, &   ! Air molecular weight [g/mole]
                               AVOGNO      ! Avogadro's number
use   interpolator_mod, only : interpolator,  &
                               obtain_interpolator_time_slices, &
                               unset_interpolator_time_flag, &
                               interpolate_type
use      astronomy_mod, only : universal_time

implicit none
private
!-----------------------------------------------------------------------
!----- interfaces -------

public  wet_deposition,    &
        dry_deposition,    &
        dry_deposition_time_vary,    &
        dry_deposition_endts,        &
        interp_emiss,      &
        atmos_tracer_utilities_end, &
        atmos_tracer_utilities_init, &
        get_wetdep_param, &
        get_rh,   &
        get_w10m, &
        get_cldf, &
        sjl_fillz

!---- version number -----
character(len=128) :: version = '$Id: atmos_tracer_utilities.F90,v 20.0 2013/12/13 23:24:13 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

logical :: module_is_initialized = .FALSE.

character(len=7), parameter :: mod_name = 'tracers'
integer, parameter :: max_tracers = MAX_TRACER_FIELDS
!-----------------------------------------------------------------------
!--- identification numbers for  diagnostic fields and axes ----
integer :: id_tracer_ddep(max_tracers), id_tracer_dvel(max_tracers), &
           id_tracer_wdep_ls(max_tracers),   id_tracer_wdep_cv(max_tracers),  &
           id_tracer_wdep_lsin(max_tracers), id_tracer_wdep_cvin(max_tracers),&
           id_tracer_wdep_lsbc(max_tracers), id_tracer_wdep_cvbc(max_tracers),&
           id_tracer_reevap_ls(max_tracers), id_tracer_reevap_cv(max_tracers),&
           id_tracer_wdep_ls_3d(max_tracers)
integer :: id_tracer_ddep_cmip(max_tracers)
integer :: id_w10m, id_delm
integer :: id_u_star, id_b_star, id_rough_mom, id_z_pbl,  &
           id_mo_length_inv, id_vds
character(len=32),  dimension(max_tracers) :: tracer_names     = ' '
character(len=32),  dimension(max_tracers) :: tracer_units     = ' '
character(len=128), dimension(max_tracers) :: tracer_longnames = ' '
character(len=32),  dimension(max_tracers) :: tracer_wdep_names     = ' '
character(len=32),  dimension(max_tracers) :: tracer_wdep_units     = ' '
character(len=128), dimension(max_tracers) :: tracer_wdep_longnames = ' '
character(len=32),  dimension(max_tracers) :: tracer_ddep_names     = ' '
character(len=32),  dimension(max_tracers) :: tracer_dvel_names     = ' '
character(len=32),  dimension(max_tracers) :: tracer_ddep_units     = ' '
character(len=32),  dimension(max_tracers) :: tracer_dvel_units     = ' '
character(len=128), dimension(max_tracers) :: tracer_ddep_longnames = ' '
character(len=128), dimension(max_tracers) :: tracer_dvel_longnames = ' '
real, allocatable :: blon_out(:,:), blat_out(:,:)
!----------------parameter values for the diagnostic units--------------
real, parameter :: mw_air = WTMAIR/1000.  ! Convert from [g/mole] to [kg/mole]
real, parameter :: mw_h2o = WTMH2O/1000.  ! Convert from [g/mole] to [kg/mole]
real, parameter :: twopi = 2*PI

type wetdep_type
   character (len=500) :: scheme, text_in_scheme, control
   real  :: Henry_constant
   real  :: Henry_variable
   real  :: frac_in_cloud
   real  :: frac_in_cloud_snow
   real  :: alpha_r
   real  :: alpha_s
   logical :: Lwetdep, Lgas, Laerosol, Lice
end type wetdep_type

type(wetdep_type), dimension(:), allocatable :: Wetdep


type drydep_type
   character (len=500) :: scheme, name, control
   real  :: land_dry_dep_vel
   real  :: sea_dry_dep_vel
   real  :: ice_dry_dep_vel
   real  :: snow_dry_dep_vel
   real  :: vegn_dry_dep_vel
   logical :: Ldrydep
end type drydep_type

type(drydep_type), dimension(:), allocatable :: Drydep


contains

!
! ######################################################################
!
!<SUBROUTINE NAME="atmos_tracer_utilities_init">
!<OVERVIEW>
! This is a routine to create and register the dry and wet deposition 
! fields of the tracers.
!</OVERVIEW>
!<DESCRIPTION>
!  This routine creates diagnostic names for dry and wet deposition fields of the tracers.
!  It takes the tracer name and appends "ddep" for the dry deposition field and "wdep" for 
!  the wet deposition field. This names can then be entered in the diag_table for 
!  diagnostic output of the tracer dry and wet deposition. The module name associated with
!  these fields in "tracers". The units of the deposition fields are assumed to be kg/m2/s.
!</DESCRIPTION>
!<TEMPLATE>
! call atmos_tracer_utilities_init(lonb,latb, mass_axes, Time)
!</TEMPLATE>
!   <IN NAME="lonb" TYPE="real" DIM="(:,:)">
!     The longitude corners for the local domain.
!   </IN>
!   <IN NAME="latb" TYPE="real" DIM="(:,:)">
!     The latitude corners for the local domain.
!   </IN>
!   <IN NAME="mass_axes" TYPE="integer" DIM="(3)">
!     The axes relating to the tracer array.
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>

subroutine atmos_tracer_utilities_init(lonb, latb, mass_axes, Time)

! Routine to initialize the tracer identification numbers. 
! This registers the 2D fields for the wet and dry deposition.
real, dimension(:,:),  intent(in) :: lonb, latb
integer, dimension(3), intent(in) :: mass_axes
type(time_type),       intent(in) :: Time

integer :: ntrace
character(len=20) :: units =''
!
integer :: n, logunit
character(len=128) :: name

logical  :: flag

! Make local copies of the local domain dimensions for use 
! in interp_emiss.
      allocate ( blon_out(size(lonb,1),size(lonb,2)))
      allocate ( blat_out(size(latb,1),size(latb,2)))
!      allocate ( data_out(size(lonb(:))-1, size(latb(:))-1))
      blon_out = lonb
      blat_out = latb
      
      do n = 1, max_tracers
         write ( tracer_names(n),     100 ) n
         write ( tracer_longnames(n), 102 ) n
         tracer_units(n) = 'none'
      enddo
  100 format ('tr',i3.3)
  102 format ('tracer ',i3.3)

call get_number_tracers(MODEL_ATMOS, num_tracers= ntrace)

   if (ntrace > 0) then
     allocate (Wetdep(ntrace))
     allocate (Drydep(ntrace))
   endif
   do n = 1, ntrace
!--- set tracer tendency names where tracer names have changed ---

call get_tracer_names(MODEL_ATMOS,n,tracer_names(n),tracer_longnames(n),tracer_units(n))
      write (name,100) n
      if (trim(tracer_names(n)) /= name) then
          tracer_ddep_names(n) = trim(tracer_names(n)) //'_ddep'
          tracer_dvel_names(n) = trim(tracer_names(n)) //'_dvel'
          tracer_wdep_names(n) = trim(tracer_names(n)) //'_wdep'
      endif
      write (name,102) n
      if (trim(tracer_longnames(n)) /= name) then
          tracer_wdep_longnames(n) = &
                  trim(tracer_longnames(n)) // ' wet deposition for tracers'
          tracer_ddep_longnames(n) = &
                  trim(tracer_longnames(n)) // ' dry deposition for tracers'
          tracer_dvel_longnames(n) = &
                  trim(tracer_longnames(n)) // ' dry deposition velocity for tracers'
      endif

      select case (trim(tracer_units(n)))
        case ('mmr')
          units = 'kg/m2/s'
        case ('kg/kg')
          units = 'kg/m2/s'
        case ('vmr')
          units = 'mole/m2/s'
        case ('mol/mol')
          units = 'mole/m2/s'
        case ('mole/mole')
          units = 'mole/m2/s'
        case default
          units = trim(tracer_units(n))//' kg/(m2 s)'
          call error_mesg('atmos_tracer_utilities_init',&
          ' Dry dep units set to '//trim(units)//' in atmos_tracer_utilities for '//trim(tracer_names(n)),&
           NOTE)
      end select

    
      flag = query_method ('wet_deposition',MODEL_ATMOS,n, &
                            Wetdep(n)%text_in_scheme,Wetdep(n)%control)
      call get_wetdep_param(Wetdep(n)%text_in_scheme,  &
                            Wetdep(n)%control,&
                            Wetdep(n)%scheme, &
                            Wetdep(n)%Henry_constant,  &
                            Wetdep(n)%Henry_variable, &
                            Wetdep(n)%frac_in_cloud, &
                            Wetdep(n)%frac_in_cloud_snow, &
                            Wetdep(n)%alpha_r, Wetdep(n)%alpha_s, &
                            Wetdep(n)%Lwetdep, Wetdep(n)%Lgas, &
                            Wetdep(n)%Laerosol, Wetdep(n)%Lice )

      Drydep(n)%Ldrydep = query_method ('dry_deposition', MODEL_ATMOS,&
                                  n,Drydep(n)%name, Drydep(n)%control)


      call get_drydep_param(Drydep(n)%name,Drydep(n)%control,  &
                         Drydep(n)%scheme,Drydep(n)%land_dry_dep_vel,  &
                                             Drydep(n)%sea_dry_dep_vel)
! When formulation of dry deposition is resolved perhaps use the following?
!      call get_drydep_param    &
!           (Drydep(n)%name, Drydep(n)%control, Drydep(n)%scheme,  &
!            Drydep(n)%land_dry_dep_vel, Drydep(n)%sea_dry_dep_vel,  & 
!            Drydep(n)%ice_dry_dep_vel, Drydep(n)%snow_dry_dep_vel, &
!                                             Drydep(n)%vegn_dry_dep_vel )

! Register the dry deposition of the n tracers
     id_tracer_ddep(n) = register_diag_field ( mod_name,                    &
            trim(tracer_ddep_names(n)), mass_axes(1:2), Time,               &
            trim(tracer_ddep_longnames(n)),                                 &
            trim(units), missing_value=-999.     )
     id_tracer_ddep_cmip(n) = register_diag_field ( mod_name,               &
            trim(tracer_ddep_names(n))//'_cmip', mass_axes(1:2), Time,      &
            trim(tracer_ddep_longnames(n)),                                 &
           'kg/m2/s', missing_value=-999.     )
! Register the dry deposition of the n tracers
     id_tracer_dvel(n) = register_diag_field ( mod_name,                    &
            trim(tracer_dvel_names(n)), mass_axes(1:2), Time,               &
            trim(tracer_dvel_longnames(n)),                                 &
            'm/s', missing_value=-999.     )
! Register the wet deposition of the n tracers by large scale clouds
     id_tracer_wdep_ls(n) = register_diag_field ( mod_name,                 &
            trim(tracer_wdep_names(n))//'_ls', mass_axes(1:2), Time,        &
            trim(tracer_wdep_longnames(n))//' in large scale',              &
            trim(units), missing_value=-999.    )

! Register the wet deposition of the n tracers by large scale clouds 3d
     id_tracer_wdep_ls_3d(n) = register_diag_field ( mod_name,         &
            trim(tracer_wdep_names(n))//'_ls_3d', mass_axes(1:3), Time, &
            trim(tracer_wdep_longnames(n))//' in large scale 3D',       &
            trim(units), missing_value=-999.    )

! Register the wet deposition of the n tracers by convective clouds
     id_tracer_wdep_cv(n) = register_diag_field ( mod_name,               &
              trim(tracer_wdep_names(n))//'_cv', mass_axes(1:2), Time, &
              trim(tracer_wdep_longnames(n))//' in convective scheme',                   &
              trim(units), missing_value=-999.    )
! Register in-cloud rainout by large scale clouds
     id_tracer_wdep_lsin(n) = register_diag_field ( mod_name,               &
            trim(tracer_wdep_names(n))//'_lsin', mass_axes(1:2), Time,      &
            trim(tracer_wdep_longnames(n))//' in_cloud by lscale precip',   &
            trim(units), missing_value=-999.    )
! Register below-cloud washout by large scale clouds
     id_tracer_wdep_lsbc(n) = register_diag_field ( mod_name,               &
            trim(tracer_wdep_names(n))//'_lsbc', mass_axes(1:2), Time,      &
            trim(tracer_wdep_longnames(n))//' below_cloud by lscale precip',&
            trim(units), missing_value=-999.  )
! Register in-cloud re-evaporation by large scale clouds
     id_tracer_reevap_ls(n) = register_diag_field ( mod_name,               &
            trim(tracer_names(n))//'_reevap_ls', mass_axes(1:3), Time,      &
            trim(tracer_longnames(n))//' re-evap by lscale clouds',         &
            trim(units), missing_value=-999.    )
! Register in-cloud rainout by convective clouds
! Register in-cloud rainout of the n tracers by convective clouds
     id_tracer_wdep_cvin(n) = register_diag_field ( mod_name,               &
            trim(tracer_wdep_names(n))//'_cvin', mass_axes(1:2), Time,      &
            trim(tracer_wdep_longnames(n))//' in_cloud by conv precip',     &
            trim(units), missing_value=-999.    )
! Register below-cloud washout by convective clouds
     id_tracer_wdep_cvbc(n) = register_diag_field ( mod_name,               &
            trim(tracer_wdep_names(n))//'_cvbc', mass_axes(1:2), Time,      &
            trim(tracer_wdep_longnames(n))//' below_cloud by conv precip',  &
            trim(units), missing_value=-999.  )
! Register re-evaporation by convective clouds
     id_tracer_reevap_cv(n) = register_diag_field ( mod_name,               &
            trim(tracer_names(n))//'_reevap_cv', mass_axes(1:3), Time,      &
            trim(tracer_longnames(n))//' re-evap by conv precip',         &
            trim(units), missing_value=-999.    )
   enddo
! Register scaling factor to calculate wind speed at 10 meters
   id_delm   = register_diag_field ( mod_name,                &
               'delm', mass_axes(1:2),Time,                   &
               'Scaling factor', 'none',                      &
                missing_value=-999.                           )
! Register the wind speed at 10 meters
   id_w10m   = register_diag_field ( mod_name,                &
               'w10m', mass_axes(1:2),Time,                   &
               'Wind speed at 10 meters', 'm/s',              &
                missing_value=-999.                           )

     id_u_star = register_diag_field ( mod_name,                    &
            'u_star_atm', mass_axes(1:2), Time,               &
            'u star',                                 &
            'm/s', missing_value=-999.     )
     id_b_star = register_diag_field ( mod_name,                    &
            'b_star_atm', mass_axes(1:2), Time,               &
            'b star',                                 &
            'm/s2', missing_value=-999.     )
     id_rough_mom = register_diag_field ( mod_name,                    &
            'rough_mom_atm', mass_axes(1:2), Time,               &
            'rough length z0',                                 &
            'm', missing_value=-999.     )
     id_z_pbl = register_diag_field ( mod_name,                    &
            'z_pbl_atm', mass_axes(1:2), Time,               &
            'z pbl',                                 &
            'm', missing_value=-999.     )
     id_mo_length_inv = register_diag_field ( mod_name,                &
            'mo_length_inv_atm', mass_axes(1:2), Time,               &
            'monin Obukhov length',                                 &
            'm', missing_value=-999.     )
     id_vds = register_diag_field ( mod_name,                    &
            'vds_atm', mass_axes(1:2), Time,               &
            'vds',                                 &
            'm/s', missing_value=-999.     )

 
      call write_version_number(version, tagname)

    if ( mpp_pe() == mpp_root_pe() ) then
         logunit=stdlog()
         call write_namelist_values (logunit,ntrace)
    endif

      module_is_initialized = .TRUE.

end subroutine atmos_tracer_utilities_init


!####################################################################

subroutine dry_deposition_time_vary (drydep_data, Time)

type(time_type), intent(in) :: Time
type(interpolate_type), dimension(:), intent(inout) :: drydep_data

      integer :: n


      do n=1,size(drydep_data,1)
        if (Drydep(n)%Ldrydep .and. Drydep(n)%scheme == 'file') then
          call obtain_interpolator_time_slices (drydep_data(n), Time)
        endif
      end do

end subroutine dry_deposition_time_vary 



!####################################################################

subroutine dry_deposition_endts (drydep_data)                          

type(interpolate_type), dimension(:), intent(inout) :: drydep_data

      integer :: n

      do n=1, size(drydep_data,1)     
        call unset_interpolator_time_flag (drydep_data(n))
      end do


end subroutine dry_deposition_endts       



!####################################################################

!</SUBROUTINE>
!
!#######################################################################
!
subroutine write_namelist_values (unit, ntrace)
    integer, intent(in) :: unit, ntrace
    integer :: n

    write (unit,10)
    do n = 1, ntrace
       write (unit,11) trim(tracer_wdep_names(n)),     &
                       trim(tracer_wdep_longnames(n)), &
                       trim(tracer_wdep_units(n))
       write (unit,11) trim(tracer_ddep_names(n)),     &
                       trim(tracer_ddep_longnames(n)), &
                       trim(tracer_ddep_units(n))
       write (unit,11) trim(tracer_dvel_names(n)),     &
                       trim(tracer_dvel_longnames(n)), &
                       'm/s'
    enddo

 10 format (' &TRACER_DIAGNOSTICS_NML', &
          /,'    TRACER:  names  longnames  (units)')
 11 format (a16,2x,a,2x,'(',a,')')

 end subroutine write_namelist_values

!
!#######################################################################
!
!<SUBROUTINE NAME = "dry_deposition">
subroutine dry_deposition( n, is, js, u, v, T, pwt, pfull, dz, &
                           u_star, landmask, dsinku, tracer, Time, &
                           Time_next, lon, half_day, drydep_data)
! When formulation of dry deposition is resolved perhaps use the following?
!                           landfr, seaice_cn, snow_area, & 
!                           vegn_cover, vegn_lai, & 
!                           b_star, z_pbl, rough_mom )
!
!<OVERVIEW>
! Routine to calculate the fraction of tracer to be removed by dry 
! deposition.
!</OVERVIEW>
!<DESCRIPTION>
! There are three types of dry deposition coded.
!
! 1) Wind driven derived dry deposition velocity.
!
! 2) Fixed dry deposition velocity.
! 
! 3) Dry deposition velocities read in from input file

! There are an addition three types of dry deposition coded 
! but presently commented out.
!
! 4) Wind driven derived dry deposition velocity, surface dependent.
!
! 5) Wind driven derived dry deposition velocity, surface and boundary
!    layer stability dependent.
!
! 6) Fixed dry deposition velocity, difference between land, snow-covered
!    land, sea and ice-covered sea.
! 
! The theory behind the wind driven dry deposition velocity calculation
! assumes that the deposition can be modeled as a parallel resistance type 
! problem.
!
!  Total resistance to HNO3-type dry deposition, 
!<PRE>       R = Ra + Rb
!  resisa = aerodynamic resistance
!  resisb = surface resistance (laminar layer + uptake)
!         = 5/u*  [s/cm]        for neutral stability
!      Vd = 1/R
!</PRE>
! For the fixed dry deposition velocity, there is no change in the 
! deposition velocity but the variation of the depth of the surface 
! layer implies that there is variation in the amount deposited.
!
! To utilize this section of code add one of the following lines as 
! a method for the tracer of interest in the field table.
!<PRE>
! "dry_deposition","wind_driven","surfr=XXX"
!     where XXX is the total resistance defined above.
!
! "dry_deposition","fixed","land=XXX, sea=YYY"
!     where XXX is the dry deposition velocity (m/s) over land
!       and YYY is the dry deposition velocity (m/s) over sea.
!
! "dry_deposition","file","FILENAME.NC"
!     where FILENAME.NC is the NetCDF file name.
!</PRE>
!</DESCRIPTION>
!<TEMPLATE>
! call dry_deposition( n, is, js, u, v, T, pwt, pfull, dz,
!                      u_star, landmask, dsinku, tracer, Time, drydep_data)
!</TEMPLATE>
!
!  <IN NAME="n" TYPE="integer">
!    The tracer number.
!  </IN>
!  <IN NAME="is, js" TYPE="integer">
!    Start indices for array (computational indices).
!  </IN>
!  <IN NAME="u" TYPE="real" DIM="(:,:)">
!    U wind field.
!  </IN>
!  <IN NAME="v" TYPE="real" DIM="(:,:)">
!    V wind field.
!  </IN>
!  <IN NAME="T" TYPE="real" DIM="(:,:)">
!    Temperature.
!  </IN>
!  <IN NAME="pwt" TYPE="real" DIM="(:,:)">
!     Pressure differential of half levels.
!  </IN>
!  <IN NAME="pfull" TYPE="real" DIM="(:,:)">
!     Full pressure levels.
!  </IN>
!  <IN NAME="u_star" TYPE="real" DIM="(:,:)">
!     Friction velocity.
!  </IN>
!  <IN NAME="lon" TYPE="real" DIM="(:,:)">
!     Longitude.
!  </IN>
!  <IN NAME="landmask" TYPE="logical">
!     Land - sea mask.
!  </IN>
!  <INOUT NAME="drydep_data" TYPE="interpolate_type">
!     Dry deposition data interpolated from input file.
!  </INOUT>
!
!  <OUT NAME="dsinku" TYPE="real" DIM="(:,:)">
!    The amount of tracer in the surface layer which is dry deposited per second.
!  </OUT>
!
integer, intent(in)                 :: n, is, js
real, intent(in), dimension(:,:)    :: u, v, T, pwt, pfull, u_star, tracer, dz
real, intent(in), dimension(:,:)    :: lon, half_day
logical, intent(in), dimension(:,:) :: landmask
! When formulation of dry deposition is resolved perhaps use the following?
!real, intent(in), dimension(:,:)    :: landfr, z_pbl, b_star, rough_mom
!real, intent(in), dimension(:,:)    :: seaice_cn, snow_area, vegn_cover,  &
!                                       vegn_lai
type(time_type), intent(in)         :: Time, Time_next
type(interpolate_type),intent(inout)  :: drydep_data
real, intent(out), dimension(:,:)   :: dsinku

real,dimension(size(u,1),size(u,2))   :: hwindv,frictv,resisa,drydep_vel
!real,dimension(size(u,1),size(u,2))   :: mo_length_inv, vds, rs, k1, k2
integer :: i,j, flagsr, id, jd
real    :: land_dry_dep_vel, sea_dry_dep_vel, ice_dry_dep_vel,  &
           snow_dry_dep_vel, vegn_dry_dep_vel,   &
           surfr, sear, icer,  snowr, vegnr
real    :: diag_scale
real    :: factor_tmp, gmt, dv_on, dv_off, dayfrac, vd_night, vd_day, loc_angle
logical :: used, diurnal
integer :: flag_species, flag_diurnal
character(len=10) ::units,names
character(len=500) :: name,control,scheme, speciesname,dummy

! Default zero
dsinku = 0.0
if (.not. Drydep(n)%Ldrydep) return
name =Drydep(n)%name
control = Drydep(n)%control
scheme = Drydep(n)%scheme
land_dry_dep_vel = Drydep(n)%land_dry_dep_vel
sea_dry_dep_vel = Drydep(n)%sea_dry_dep_vel
!ice_dry_dep_vel = Drydep(n)%ice_dry_dep_vel
!snow_dry_dep_vel = Drydep(n)%snow_dry_dep_vel
!vegn_dry_dep_vel = Drydep(n)%vegn_dry_dep_vel

! delta z = dp/(rho * grav)
! delta z = RT/g*dp/p    pwt = dp/g
!dz(:,:) = pwt(:,:)*rdgas*T(:,:)/pfull(:,:)
id=size(pfull,1); jd=size(pfull,2)


  select case(lowercase(scheme))
  
   case('wind_driven')
! Calculate horizontal wind velocity and aerodynamic resistance:
!   where xxfm=(u*/u) is drag coefficient, Ra=u/(u*^2), 
!   and  u*=sqrt(momentum flux)  is friction velocity.
!
!****  Compute dry sinks (loss frequency, need modification when 
!****    different vdep values are to be used for species)
        flagsr=parse(control,'surfr',surfr)
        if(flagsr == 0) surfr=500.
        hwindv=sqrt(u**2+v**2)
        frictv=u_star
        resisa=hwindv/(u_star*u_star)
        where (frictv .lt. 0.1) frictv=0.1
        dsinku = (1./(surfr/frictv + resisa))/dz
        drydep_vel(:,:) = 0.

!    case('sfc_dependent_wind_driven')
!! Calculate horizontal wind velocity and aerodynamic resistance:
!!   where xxfm=(u*/u) is drag coefficient, Ra=u/(u*^2), 
!!   and  u*=sqrt(momentum flux)  is friction velocity.
!!
!!****  Compute dry sinks (loss frequency, need modification when 
!!****    different vdep values are to be used for species)
!        flagsr=parse(control,'surfr',surfr)
!        if(flagsr == 0) surfr=500.
!
!        flagsr=parse(control,'sear',sear)
!        if(flagsr == 0) sear=surfr
!        
!        flagsr=parse(control,'icer',icer)
!        if(flagsr == 0) icer=surfr
!        
!        flagsr=parse(control,'snowr',snowr)
!        if(flagsr == 0) snowr=surfr
!        
!        flagsr=parse(control,'vegnr',vegnr)
!        if(flagsr == 0) vegnr=surfr
!
!        hwindv=sqrt(u**2+v**2)
!        frictv=u_star
!        resisa=hwindv/(u_star*u_star)
!        where (frictv .lt. 0.1) frictv=0.1
!        drydep_vel(:,:) = (1./(surfr/frictv + resisa))*  &
!                                         (landfr(:,:) - snow_area(:,:)) + &
!                          (1./(snowr/frictv + resisa))*snow_area(:,:)  +&
!                          (1./(sear/frictv + resisa))*   &
!                                 (1. - landfr(:,:) - seaice_cn(:,:))   + &
!                          (1./(icer/frictv + resisa))*seaice_cn(:,:)
!        dsinku(:,:) = drydep_vel(:,:) / dz(:,:)
!
!    case('sfc_BL_dependent_wind_driven')
!! Calculate horizontal wind velocity and aerodynamic resistance:
!!   where xxfm=(u*/u) is drag coefficient, Ra=u/(u*^2), 
!!   and  u*=sqrt(momentum flux)  is friction velocity.
!!
!!****  Compute dry sinks (loss frequency, need modification when 
!!****    different vdep values are to be used for species)
!        flagsr=parse(control,'surfr',surfr)
!        if(flagsr == 0) surfr=500.
!
!        flagsr=parse(control,'sear',sear)
!        if(flagsr == 0) sear=surfr
!        
!        flagsr=parse(control,'icer',icer)
!        if(flagsr == 0) icer=surfr
!        
!        flagsr=parse(control,'snowr',snowr)
!        if(flagsr == 0) snowr=surfr
!        
!        flagsr=parse(control,'vegnr',vegnr)
!        if(flagsr == 0) vegnr=surfr
!
!        hwindv=sqrt(u**2+v**2)
!        frictv=u_star
!        resisa=hwindv/(u_star*u_star)
!        where (frictv .lt. 0.1) frictv=0.1
!        mo_length_inv = - vonkarm * b_star/(frictv*frictv)      
!        where (rough_mom > 0.005)
!           k1 =  0.001222 * log10(rough_mom) + 0.003906
!        elsewhere
!           k1 =  0.001222 * log10(0.005) + 0.003906
!        endwhere        
!        where(mo_length_inv < 0)
!           k2 = 0.0009 * ( - z_pbl * mo_length_inv)**(2.0/3.0)
!        elsewhere
!           k2 = 0.0
!        endwhere        
!        vds = frictv * (k1 + k2)
!        rs  = 1.0 / vds
!        drydep_vel(:,:) = (1./(rs + resisa))*      &
!                                   (landfr(:,:) - snow_area(:,:))  +  &
!                          (1./(snowr/frictv + resisa))*snow_area(:,:)  + &
!                          (1./(sear/frictv + resisa))*   &
!                                (1. - landfr(:,:) - seaice_cn(:,:))  + &
!                          (1./(icer/frictv + resisa))*seaice_cn(:,:)
!        dsinku(:,:) = drydep_vel(:,:) / dz(:,:)

    case('fixed')
! For the moment let's try to calculate the delta-z of the bottom 
! layer and using a simple dry deposition velocity times the 
! timestep, idt, calculate the fraction of the lowest layer which 
! deposits.
       where (landmask(:,:))
! dry dep value over the land surface
         drydep_vel(:,:) = land_dry_dep_vel
      elsewhere
! dry dep value over the sea surface
         drydep_vel(:,:) = sea_dry_dep_vel
      endwhere
      dsinku(:,:) = drydep_vel(:,:) / dz(:,:)

!    case('sfc_dependent_fixed')
!      drydep_vel(:,:) = land_dry_dep_vel*    &
!                                     (landfr(:,:) - snow_area(:,:))   + &
!                        snow_dry_dep_vel*snow_area(:,:)   +  &
!                        sea_dry_dep_vel*  &
!                                  (1. - landfr(:,:) - seaice_cn(:,:))  + &
!                        ice_dry_dep_vel*seaice_cn(:,:)
!      dsinku(:,:) = drydep_vel(:,:) / dz(:,:) 

    case('file')
        flag_species = parse(control,'name',speciesname)
        if(flag_species>0) then
           name = trim(speciesname)
        else
           call get_tracer_names(MODEL_ATMOS,n,name)
        endif
        flag_diurnal = parse(control,'diurnal',dummy)
        diurnal = (flag_diurnal > 0)
        call interpolator( drydep_data, Time, drydep_vel, trim(name), is, js )

        if (diurnal) then
           do j = 1,jd
           do i = 1,id
! half_day is between 0 and pi, so dv_off btwn 0 to pi, dv_on btwn -pi and 0
              dv_off = MIN( 1.2*half_day(i,j), PI )
              dv_on = -dv_off
              dayfrac = dv_off/PI
! apply the mean dep vel during polar day or polar night (or nearby)
              if (dv_off > 0 .and. dv_off < PI  ) then
                 vd_night = MIN(0.001, 0.5*drydep_vel(i,j))
                 vd_day = ( drydep_vel(i,j)-vd_night*(1.-dayfrac) ) / dayfrac
                 gmt = universal_time(Time)
                 loc_angle = gmt + lon(i,j) - PI
                 if (loc_angle >= PI) loc_angle = loc_angle - twopi
                 if (loc_angle < -PI) loc_angle = loc_angle + twopi
                 if( loc_angle >= dv_off .or. loc_angle <= dv_on ) then
                    drydep_vel(i,j) = vd_night
                 else
                    factor_tmp = loc_angle - dv_on
                    factor_tmp = factor_tmp / MAX(2*dv_off,1.e-6)
                    drydep_vel(i,j) = 0.5*PI*sin(factor_tmp*PI)*(vd_day-vd_night) + vd_night
                 end if
              end if
           end do
           end do
        end if !(diurnal)

        dsinku(:,:) = drydep_vel(:,:) / dz(:,:)
    case('default')
        drydep_vel(:,:) = 0.
  end select

dsinku(:,:) = MAX(dsinku(:,:), 0.0E+00)
where(tracer>0)
  dsinku=dsinku*tracer
elsewhere
  dsinku=0.0
endwhere

! Now save the dry deposition to the diagnostic manager
! delta z = dp/(rho * grav)
! delta z *rho  = dp/g
! tracer(kgtracer/kgair) * dz(m)* rho(kgair/m3) = kgtracer/m2
! so rho drops out of the equation
    if (id_tracer_ddep(n) > 0 ) then
      call get_tracer_names(MODEL_ATMOS,n,names,units=units)
      select case (trim(units))
        case ('vmr')
          diag_scale = mw_air
        case ('mol/mol')
          diag_scale = mw_air
        case ('mole/mole')
          diag_scale = mw_air
        case default
          diag_scale = 1.
      end select
      used = send_data ( id_tracer_ddep(n), dsinku*pwt/diag_scale, Time_next, &
          is_in =is,js_in=js)
    endif
    if (id_tracer_ddep_cmip(n) > 0 ) then
      call get_tracer_names(MODEL_ATMOS,n,names,units=units)
      select case (trim(names))
        case ('so2')
          diag_scale = mw_air/0.064
        case ('so4')
          diag_scale = mw_air/0.096
        case ('dms')
          diag_scale = mw_air/0.062
        case ('nh3')
          diag_scale = mw_air/0.017
        case default
          diag_scale = 1.
        end select
       used = send_data ( id_tracer_ddep_cmip(n), dsinku*pwt/diag_scale,Time_next, &
           is_in =is,js_in=js)
    endif
    if (id_tracer_dvel(n) > 0 ) then
      used = send_data ( id_tracer_dvel(n), drydep_vel, Time_next, &
          is_in =is,js_in=js)
    end if
end subroutine dry_deposition
!</SUBROUTINE>
!
!#######################################################################
!
!<SUBROUTINE NAME = "wet_deposition">
!<TEMPLATE>
!CALL wet_deposition( n, T, pfull, phalf, zfull, zhalf, &
!                     rain, snow, qdt, cloud, rain3d, snow3d, &
!                     tracer, tracer_dt, Time, cloud_param, is, js, dt )
!</TEMPLATE>
subroutine wet_deposition( n, T, pfull, phalf, zfull, zhalf, &
                           rain, snow, qdt, cloud, cloud_frac, &
                           f_snow_berg, rain3d, snow3d, &
                           tracer, tracer_dt, Time, cloud_param, &
                           is, js, dt, sum_wdep_out )
!      
!<OVERVIEW>
! Routine to calculate the fraction of tracer removed by wet deposition
!</OVERVIEW>
!
!<IN NAME="n" TYPE="integer">
!   Tracer number
!</IN>
!<IN NAME="is, js" TYPE="integer">
!   start indices for array (computational indices)
!</IN>
!<IN NAME="T" TYPE="real" DIM="(:,:,:)">
!   Temperature
!</IN>
!<IN NAME="pfull" TYPE="real" DIM="(:,:,:)">
!   Full level pressure field (Pa)
!</IN>
!<IN NAME="phalf" TYPE="real" DIM="(:,:,:)">
!   Half level pressure field (Pa)
!</IN>
!<IN NAME="zfull" TYPE="real" DIM="(:,:,:)">
!   Full level height field (m)
!</IN>
!<IN NAME="zhalf" TYPE="real" DIM="(:,:,:)">
!   Half level height field (m)
!</IN>
!<IN NAME="rain" TYPE="real" DIM="(:,:)">
!   Precipitation in the form of rain
!</IN>
!<IN NAME="snow" TYPE="real" DIM="(:,:)">
!   Precipitation in the form of snow
!</IN>
!<IN NAME="qdt" TYPE="real" DIM="(:,:,:)">
!   The tendency of the specific humidity (+ condenstate) due to the cloud parametrization (kg/kg/s)
!</IN>
!<IN NAME="cloud" TYPE="real" DIM="(:,:,:)">
!   Cloud amount (liquid + ice) (kg/kg)
!</IN>
!<IN NAME="cloud_frac" TYPE="real" DIM="(:,:,:)">
!   Cloud area fraction
!</IN>
!<IN NAME="rain3d" TYPE="real" DIM="(:,:,:)">
!   Precipitation in the form of rain (kg/m2/s)
!</IN>
!<IN NAME="snow3d" TYPE="real" DIM="(:,:,:)">
!   Precipitation in the form of snow (kg/m2/s)
!</IN>
!<IN NAME="tracer" TYPE="real" DIM="(:,:,:)">
!   The tracer field 
!</IN>
!<IN NAME="Time" TYPE="type(time_type)">
!   The time structure for submitting wet deposition as a diagnostic
!</IN>
!<IN NAME="cloud_param" TYPE="character">
!   Is this a convective (convect) or large scale (lscale) cloud parametrization?
!</IN>
!<IN NAME="dt" TYPE="real">
!   The model timestep (in seconds)
!</IN>
!<OUT NAME="tracer_dt" TYPE="real" DIM="(:,:,:)">
!   The tendency of the tracer field due to wet deposition
!</OUT>
!<DESCRIPTION>
! Schemes allowed here are 
!
! 1) Deposition removed in the same fractional amount as the modeled precipitation rate is to 
!    a standardized precipitation rate.
!    Basically this scheme assumes that a fractional area of the gridbox is affected by 
!    precipitation and that this precipitation rate is due to a cloud of standardized cloud 
!    liquid water content. Removal is constant throughout the column where precipitation is occuring.
!
! 2) Removal according to Henry's Law. This law states that the ratio of the concentation in 
!    cloud water and the partial pressure in the interstitial air is a constant. If tracer
!    is in VMR, the units for Henry's constant are mole/L/Pa (normally it is mole/L/atm).
!    Parameters for a large number of species can be found at
!    http://www.mpch-mainz.mpg.de/~sander/res/henry.html
!
! 3) Aerosol removal, using specified in-cloud tracer fraction

! 4) Similar as 3) with some lwh modifications
!
! To utilize this section of code add one of the following lines as 
! a method for the tracer of interest in the field table.
!<PRE>
! "wet_deposition","henry","henry=XXX, dependence=YYY"
!     where XXX is the Henry's constant for the tracer in question
!       and YYY is the temperature dependence of the Henry's Law constant.
!
! "wet_deposition","fraction","lslwc=XXX, convlwc=YYY"
!     where XXX is the liquid water content of a standard large scale cloud
!       and YYY is the liquid water content of a standard convective cloud.
!</PRE>

!</DESCRIPTION>

!-----------------------------------------------------------------------
!     ... dummy arguments
!-----------------------------------------------------------------------
integer,          intent(in)                     :: n, is, js
real,             intent(in),  dimension(:,:,:)  :: T, pfull,phalf, zfull, zhalf, qdt, cloud, tracer
real,             intent(in),  dimension(:,:,:)  :: cloud_frac
real,             intent(in),  dimension(:,:,:)  :: f_snow_berg     
                                     ! snow production by Bergeron process
real,             intent(in),  dimension(:,:)    :: rain, snow
character(len=*), intent(in)                     :: cloud_param
type (time_type), intent(in)                     :: Time
real,             intent(out), dimension(:,:,:)  :: tracer_dt
real,             intent(in)                     :: dt
real,             intent(in),  dimension(:,:,:)  :: rain3d, snow3d
real,             intent(out),  dimension(:,:), optional :: sum_wdep_out

!-----------------------------------------------------------------------
!     ... local variables
!-----------------------------------------------------------------------
real, dimension(size(T,1),size(T,2),size(pfull,3)) :: &
      Htemp, xliq, n_air, rho_air, pwt, zdel, precip3d, scav_fact3d, &
      precip3ds, precip3dr
real, dimension(size(T,1),size(T,2)) :: &
      temp_factor, scav_factor, washout, sum_wdep, &
      w_h2o, K1, K2, beta, f_a,  scav_factor_s,  &
      wdep_in, wdep_bc, fluxr,fluxs, tracer_flux
real, dimension(size(T,1),size(T,2),size(pfull,3)) :: &
      in_temp, bc_temp, dt_temp, reevap_fraction, reevap_diag
integer, dimension(size(T,1),size(T,2)) :: &
      ktopcd, kendcd
real, dimension(size(rain3d,1),size(rain3d,2),size(rain3d,3)) :: rainsnow3d

integer :: i, j, k, kk, id, jd, kd, flaglw

real, dimension(size(T,3)) :: conc

real :: conc_rain, conc_rain_total, conc_sat

real, parameter ::  DENS_SNOW = 500.    ! Snow density [kg/m3]
real, parameter ::  RGAS      = 8.3143  ! ideal gas constant Pa m3/mol/K

real    :: &
      Henry_constant, Henry_variable, &
      clwc, wash, premin, prenow, hwtop, &
      diag_scale

real, parameter :: &
      inv298p15 = 1./298.15, &     ! 1/K
      kboltz = 1.38E-23,         & ! J/K
      rain_diam  = 1.89e-3,     &  ! mean diameter of rain drop (m)
      rain_vterm = 7.48,        &  ! rain drop terminal velocity (m/s)
      vk_air = 6.18e-6,         &  ! kinematic viscosity of air (m^2/s)
      d_g = 1.12e-5,            &  ! diffusive coefficient (m^2/s)
      geo_fac = 6.,             &  ! geometry factor (surface area/volume = geo_fac/diameter)
      cm3_2_m3 = 1.e-6             ! m3/cm3

real :: &
      k_g,                       & ! mass transfer coefficient (m/s)
      stay,                      & ! fraction
      fall_time                    ! fall time through layer (s)

real :: f_a0, scav_factor0, sa_drop0, fgas0
real :: frac_in_cloud, frac_in_cloud_snow, frac_int, ph
real , parameter :: &
      R_r = 0.001, &               ! radius of cloud-droplets for rain
      R_s = 0.001, &               ! radius of cloud-droplets for snow
      frac_int_gas = 1.0,   &
      frac_int_aerosol= 0.5

real :: alpha_r, alpha_s

logical :: &
      used, &
      Lwetdep, Lgas, Laerosol, Lice
character(len=500) :: &
      tracer_name, control, scheme, units, &
      text_in_scheme

!-----------------------------------------------------------------------

    ktopcd = 0
    kendcd = 0

    tracer_dt   = 0.
    wdep_in     = 0.
    wdep_bc     = 0.
    beta        = 0.
    reevap_fraction = 0.
    reevap_diag = 0.
    tracer_flux = 0.

    sum_wdep = 0.

    id = size(T,1)
    jd = size(T,2)
    kd = size(T,3)

    call get_tracer_names(MODEL_ATMOS,n,tracer_name, units = units)
    if ( .not. Wetdep(n)%Lwetdep) return
     text_in_scheme = Wetdep(n)%text_in_scheme
     control = Wetdep(n)%control
     scheme = Wetdep(n)%scheme
     Henry_constant = Wetdep(n)%Henry_constant
     Henry_variable = Wetdep(n)%Henry_variable
     frac_in_cloud = Wetdep(n)%frac_in_cloud
     frac_in_cloud_snow = Wetdep(n)%frac_in_cloud_snow
     alpha_r = Wetdep(n)%alpha_r
     alpha_s = Wetdep(n)%alpha_s
     Lwetdep = Wetdep(n)%Lwetdep
     Lgas    = Wetdep(n)%Lgas
     Laerosol = Wetdep(n)%Laerosol
     Lice    = Wetdep(n)%Lice

    rho_air(:,:,:) = pfull(:,:,:) / ( T(:,:,:)*RDGAS ) ! kg/m3
!   Lice = .not. (scheme=='henry_noice' .or. scheme=='henry_below_noice' .or. &
!                 scheme=='aerosol_noice' .or. scheme=='aerosol_below_noice' )
    if (Lice) then
       rainsnow3d(:,:,:) = rain3d(:,:,:) + snow3d(:,:,:)
    else
       rainsnow3d(:,:,:) = rain3d(:,:,:)
    end if
    do k=1,kd
       precip3d(:,:,k) = rainsnow3d(:,:,k+1)-rainsnow3d(:,:,k)
       precip3dr(:,:,k) = rain3d(:,:,k+1)-rain3d(:,:,k)
       pwt(:,:,k)  = ( phalf(:,:,k+1) - phalf(:,:,k) )/GRAV ! kg/m2
       zdel(:,:,k) = zhalf(:,:,k) - zhalf(:,:,k+1) ! m
    end do
    if (Lice) then
      do k=1,kd
        precip3ds(:,:,k) = snow3d(:,:,k+1)-snow3d(:,:,k)
      end do
    else
      do k=1,kd
        precip3ds(:,:,k) = 0.
      end do
    endif
!
!+++ pag: 
!
if(lowercase(scheme)=='wdep_gas' .or. lowercase(scheme)=='wdep_aerosol') then
      ph = 5.0
!  cloud liquid water content
      xliq(:,:,:) = 0.5E-3                           !default value
      if(trim(cloud_param) .eq. 'convect') then
         xliq(:,:,:) = 1.0e-3
      elseif(trim(cloud_param) .eq. 'lscale') then
         xliq(:,:,:) = 0.5e-3
      endif

!                    
! tracer == gas      
!             
      if(lowercase(scheme)=="wdep_gas") THEN
          frac_int = frac_int_gas
          do k = 1, kd
            do j = 1, jd
              do i = 1, id
                Htemp(i,j,k)=henry_constant &
                          *exp(-Henry_variable*(1./298.-1./T(i,j,k)))
                K1(i,j)=1.2e-2*exp(-2010*(1/298.-1/T(i,j,k)))
                K2(i,j)=6.6e-8*exp(-1510*(1/298.-1/T(i,j,k)))
                HTemp(i,j,k)=Htemp(i,j,k)*(1 + K1(i,j) &
                           /10.**(-ph) + K1(i,j)*K2(i,j)/(10.**(-ph))**2)
                f_a(i,j) = Htemp(i,j,k)/101.325*RGAS &
                           *T(i,j,k)*xliq(i,j,k)*rho_air(i,j,k)/DENS_H2O
                scav_fact3d(i,j,k)=f_a(i,j)/(1.+f_a(i,j))
              enddo
            enddo
          enddo
      elseif(lowercase(scheme)=="wdep_aerosol") THEN
          frac_int = frac_int_aerosol
          scav_fact3d(:,:,:)=frac_in_cloud
      else
      print *,' Aerosol number =',n,' tracer_name=',tracer_name,' scheme=',text_in_scheme
      print *, 'Please check "am2p12.ft'
      call ERROR_MESG('wet_deposition', 'Tracer is neither aerosol NOR gas.', FATAL )
    endif
!                    
!in cloud scavenging
!
        do k=1,kd
          do j = 1, jd
            do i = 1, id
              beta(i,j)  = MAX( 0.0, precip3d(i,j,k)/pwt(i,j,k)/xliq(i,j,k))
              in_temp(i,j,k) = (exp(-beta(i,j)*scav_fact3d(i,j,k)*dt)-1.0)
              if ( tracer(i,j,k) .gt. 0.) then
                wdep_in(i,j)=wdep_in(i,j) &
                             - in_temp(i,j,k)*tracer(i,j,k)*pwt(i,j,k)
                tracer_dt(i,j,k) = tracer_dt(i,j,k) &
                                   - in_temp(i,j,k)*tracer(i,j,k)/dt
              endif
!                    
!--reevaporation     
!    calculation of fracion of aerosols to-be
!    reevaporated to the atmosphere:

              beta(i,j)=precip3d(i,j,k)
              if (beta(i,j) < 0.) then
                beta(i,j) = beta(i,j)/rainsnow3d(i,j,k)
              endif
              if (rainsnow3d(i,j,k+1) == 0. ) then 
!--reevaporation total
                beta(i,j)=MIN(MAX(0.,-beta(i,j)),1.)
              else
                beta(i,j)=MIN(MAX(0.,-beta(i,j))*frac_int,1.)
              endif
! reevporating to atmosphere
              reevap_diag(i,j,k)=beta(i,j)*wdep_in(i,j)
              wdep_in(i,j) = wdep_in(i,j)*(1.-beta(i,j))
              tracer_dt(i,j,k) = tracer_dt(i,j,k) &
                                 - reevap_diag(i,j,k)/pwt(i,j,k)/dt
            enddo
          enddo
        enddo
! Below cloud scavenging
        do k=1,kd
          do j = 1, jd
            do i = 1, id
              fluxs(i,j) = (snow3d(i,j,k+1)+snow3d(i,j,k))/2.0
              fluxr(i,j) = (rain3d(i,j,k+1)+rain3d(i,j,k))/2.0
              bc_temp(i,j,k) = 3./4.*dt* &
                       (fluxr(i,j)*alpha_r/R_r/DENS_H2O &
                        + fluxs(i,j)*alpha_s/R_s/DENS_SNOW)
              if ( tracer(i,j,k) .gt. 0. ) then
                wdep_bc(i,j)=wdep_bc(i,j) &
                             + bc_temp(i,j,k)*tracer(i,j,k)*pwt(i,j,k)
                tracer_dt(i,j,k) = tracer_dt(i,j,k) &
                                   + bc_temp(i,j,k)*tracer(i,j,k)/dt
              endif
            enddo
          enddo
        enddo
!
!  end wdep_gas or wdep_aerosol
!
    else  

! Calculate fraction of precipitation reevaporated in layer
     do k=1,kd
       where( rainsnow3d(:,:,k) > 0. .and. precip3d(:,:,k) < 0. )
          reevap_fraction(:,:,k) = &
             -precip3d(:,:,k) / (rainsnow3d(:,:,k)) ! fraction
       end where
! Assume that the tracer reevaporation fraction is 50% of the precip
! reevaporation fraction, except when fraction = 100%
!      where( reevap_fraction(:,:,k) < 1. )
!         reevap_fraction(:,:,k) = 0.5*reevap_fraction(:,:,k)
!      end where
    end do
!  cloud liquid water content
!   xliq = 0.5E-3                           !default value
!   if(trim(cloud_param) .eq. 'convect') then
!      xliq = 1.0e-3
!   elseif(trim(cloud_param) .eq. 'lscale') then
!      xliq = 0.5e-3
!   endif

! Lgas = lowercase(scheme)=='henry' .or. lowercase(scheme)=='henry_below' .or. &
!        lowercase(scheme)=='henry_noice' .or. lowercase(scheme)=='henry_below_noice'
! Laerosol = lowercase(scheme)=='aerosol' .or. lowercase(scheme)=='aerosol_below' .or. &
!            lowercase(scheme)=='aerosol_noice' .or. lowercase(scheme)=='aerosol_below_noice'
! Assume that the aerosol reevaporation fraction is 50% of the precip
! reevaporation fraction, except when fraction = 100%
if( Lgas ) then
   frac_int = frac_int_gas
elseif( Laerosol ) then
   frac_int = frac_int_aerosol
else
   frac_int = 1.
end if

if( Lgas .or. Laerosol ) then
! units = VMR
!
! Henry_constant (mole/L/Pa) = [X](aq) / Px(g) 
! where [X](aq) is the concentration of tracer X in precipitation (mole/L)
!       Px(g) is the partial pressure of the tracer in the air (Pa)
!
! VMR (total) = VMR (gas) + VMR (aq)
!             = VMR (gas) + [X] * L
!
! where L = cloud liquid amount (kg H2O/mole air)
!
! Using Henry's Law, [X] = H * Px = H * VMR(gas) * Pfull
!
! So, VMR (total) =  VMR(gas) * [ 1 + H * Pfull * L ]
! 
! VMR(gas) = VMR(total) / [1 + H * Pfull * L]
!
! [X] = H * Pfull * VMR(total) / [ 1 + H * Pfull * L]
!
! Following Giorgi and Chameides, JGR, 90(D5), 1985, the first-order loss
! rate constant (s^-1) of X due to wet deposition equals:
!
! k = W_X / n_X
!
! where W_x = the loss rate (molec/cm3/s), and n_X = the number density (molec/cm3)
! 
! W_X = [X] * W_H2O / (55 mole/L)
! n_x = VMR(total) * n_air (molec/cm3) = VMR(total) * P/(kT) * 1E-6 m3/cm3
! 
! where P = atmospheric pressure (Pa)
!       k = Boltzmann's constant = 1.38E-23 J/K
!       T = temperature (K)
!       W_H2O = removal rate of water (molec/cm3/s)
! 
!             [X] * W_H2O / 55         
! So, k = ------------------------------
!         VMR(total) * P/(kT) * 1E-6
! 
!         W_H2O    H * VMR(total) * P / [ 1 + H * P *L ]
!       = ----- * ---------------------------------------
!          55          VMR(total) * P/(kT) * 1E-6
! 
!         W_H2O     H * kT * 1E6
!       = ----- *  -------------    
!          55      1 + H * P * L 
!
!         W_H2O     1     1     H * P * L
!       = ----- * ----- * - * -------------
!          55     n_air   L   1 + H * P * L
!
! where W_H2O = precip3d (kg/m2/s) * (AVOGNO/mw_h2o) (molec/kg) / zdel (m) * 1E-6 m3/cm3
!
   if( (Lgas .and. Henry_constant > 0) .or. Laerosol ) then
      in_temp(:,:,:) = 0.
      bc_temp(:,:,:) = 0.
      do k=1,kd
! Calculate the temperature dependent Henry's Law constant
         scav_factor(:,:) = 0.0
         xliq(:,:,k)  = MAX( cloud(:,:,k) * mw_air, 0. ) ! (kg H2O)/(mole air)
         n_air(:,:,k) = pfull(:,:,k) / (kboltz*T(:,:,k)) * cm3_2_m3 ! molec/cm3
         if (Lgas) then
            temp_factor(:,:) = 1/T(:,:,k)-inv298p15
            Htemp(:,:,k) = Henry_constant * &
                           exp( Henry_variable*temp_factor )
            f_a(:,:) = Htemp(:,:,k) * pfull(:,:,k) * xliq(:,:,k) ! / cloud_frac
            scav_factor(:,:) = f_a(:,:) / ( 1.+f_a(:,:) )
            scav_factor_s(:,:) = scav_factor(:,:)
         else if (Laerosol) then
            scav_factor(:,:) = frac_in_cloud
            if (frac_in_cloud == frac_in_cloud_snow) then
              scav_factor_s(:,:) = scav_factor(:,:)
            else
              scav_factor_s(:,:) = f_snow_berg(:,:,k)*frac_in_cloud_snow +&
                                   (1.-f_snow_berg(:,:,k))*frac_in_cloud
            endif 
         end if
!        where (precip3d(:,:,k) > 0.0)
         where (precip3d(:,:,k) > 0. .and. xliq(:,:,k) > 0.)
            w_h2o(:,:) = precip3d(:,:,k) * (AVOGNO/mw_h2o) / zdel(:,:,k) * cm3_2_m3 ! molec/cm3/s
            beta(:,:) = w_h2o(:,:) * mw_h2o  / (n_air(:,:,k) * xliq(:,:,k))
            where (precip3ds(:,:,k) > 0.0 .and. precip3dr(:,:,k) > 0.0)
              where (scav_factor(:,:) /= scav_factor_s(:,:)) 
                scav_factor(:,:) = ( scav_factor(:,:)*precip3dr(:,:,k) +  &
                   scav_factor_s(:,:) * precip3ds(:,:,k)) / precip3d(:,:,k)
              end where
            elsewhere
              where (precip3ds(:,:,k) > 0.0)
                 scav_factor(:,:) = scav_factor_s(:,:)
              endwhere
            endwhere
            in_temp(:,:,k) = beta(:,:) * scav_factor(:,:) ! 1/s
        endwhere
      enddo 
!-----------------------------------------------------------------
! Below-cloud wet scavenging
!-----------------------------------------------------------------
      if( lowercase(scheme)=='henry_below' .or. lowercase(scheme)=='henry_below_noice') then
         k_g = d_g/rain_diam * &
               ( 2. + 0.6 * sqrt( rain_diam*rain_vterm/vk_air ) * (vk_air/d_g)**(1./3.) )
         do i = 1,id
         do j = 1,jd
            conc(:) = tracer(i,j,:) * n_air(i,j,:) / cm3_2_m3 ! Convert from VMR to molec/m3
            do kk = 1,kd      
               stay = 1.
               if( precip3d(i,j,kk) > 0. ) then
                  conc_rain_total = 0.
                  stay = zfull(i,j,kk) / (rain_vterm * dt)
                  stay = min( stay, 1. )
                  do k = kk,kd
                     f_a0 = Htemp(i,j,k) * pfull(i,j,k) * xliq(i,j,kk) * n_air(i,j,kk)/n_air(i,j,k)
                     scav_factor0 = f_a0 / ( 1.+f_a0 )
                     conc_sat = conc(k) * scav_factor0 ! molec/m3 <== (xeqca1)
                     sa_drop0 = geo_fac / rain_diam * xliq(i,j,kk) * n_air(i,j,kk) / &
                                ( DENS_H2O * AVOGNO * cm3_2_m3 ) ! (m2 H2O) / (m3 air)
                     fgas0 = conc(k) * k_g ! molec/m2/s
                     fall_time = zdel(i,j,k) / rain_vterm ! sec
                     conc_rain = fgas0 * sa_drop0 * fall_time ! molec/m3 <== (xca1)
                     conc_rain_total = conc_rain_total + conc_rain ! molec/m3 <== (all1)
                     if ( conc_rain_total < conc_sat ) then
                        conc(k) = max( conc(k)-conc_rain, 0. )
                     end if
                  end do
                  conc(kk) = conc(kk) / n_air(i,j,kk) * cm3_2_m3 ! Convert to VMR
                  conc(kk) = tracer(i,j,kk) - conc(kk)
                  if ( conc(kk) /= 0. .and. tracer(i,j,kk) /= 0. ) then
                     fall_time = zdel(i,j,kk)/rain_vterm
                     bc_temp(i,j,kk) = bc_temp(i,j,kk) + &
                                       conc(kk) / (tracer(i,j,kk) * fall_time) * stay ! 1/s
                  end if
               end if         
            end do
         end do
         end do

      else if ( lowercase(scheme) == 'aerosol_below' .or. lowercase(scheme) == 'aerosol_below_noice') then

        do k=1,kd
           fluxs = (snow3d(:,:,k+1)+snow3d(:,:,k))/2.0
           fluxr = (rain3d(:,:,k+1)+rain3d(:,:,k))/2.0
           bc_temp(:,:,k) = 3./4. * &
                       (fluxr(:,:)*alpha_r/R_r/DENS_H2O + &
                        fluxs(:,:)*alpha_s/R_s/DENS_SNOW)
         end do

      end if


      do k = 1,kd
         wdep_in(:,:) = wdep_in(:,:) - &
                        in_temp(:,:,k)*tracer(:,:,k)*pwt(:,:,k)*  &
                                                         cloud_frac(:,:,k)
         wdep_bc(:,:) = wdep_bc(:,:) - &
                        bc_temp(:,:,k)*tracer(:,:,k)*pwt(:,:,k)
      enddo
      dt_temp(:,:,:) = 1. - exp( -bc_temp(:,:,:)*dt ) & ! fractional loss/timestep
                          * ( cloud_frac(:,:,:)*exp( -in_temp(:,:,:)*dt ) + (1-cloud_frac(:,:,:)) )
      tracer_dt(:,:,:) = dt_temp(:,:,:) / dt !+ve loss frequency (1/sec)
    endif

else if(lowercase(scheme)=='fraction') then
   tracer_dt = 0.0
!-----------------------------------------------------------------------
!
!     Compute areal fractions experiencing wet deposition:
!
!     Set minimum precipitation rate below which no wet removal
!     occurs to 0.01 cm/day ie 1.16e-6 mm/sec (kg/m2/s)
   premin=1.16e-6
!
!     Large scale cloud liquid water content (kg/m3)
!     and below cloud washout efficiency (cm-1):
   flaglw =parse(control,'lslwc',clwc)
   if (flaglw == 0 ) clwc=0.5e-3
   wash=1.0  
!
!     When convective adjustment occurs, use convective cloud liquid water content:
!
    if(trim(cloud_param) .eq. 'convect') then
      flaglw = parse(control,'convlwc',clwc)
      if (flaglw == 0) clwc=2.0e-3
      wash=0.3 
   end if
!
   do j=1,size(rain,2)
   do i=1,size(rain,1)
      tracer_dt(i,j,:)=0.0
      washout(i,j)=0.0
      prenow = rain(i,j) + snow(i,j)
      if(prenow .gt. premin) then      
!
! Assume that the top of the cloud is where the highest model level 
! specific humidity is reduced. And the the bottom of the cloud is the
! lowest model level where specific humidity is reduced.
!
         ktopcd(i,j) = 0
         do k = kd,1,-1
            if (qdt(i,j,k) < 0.0 ) ktopcd(i,j) = k
         enddo
         kendcd(i,j) = 0
         do k = 1,kd
            if (qdt(i,j,k) < 0.0 ) kendcd(i,j) = k
         enddo
!
!     Thickness of precipitating cloud deck:
!
         if(ktopcd(i,j).gt.1) then
            hwtop = 0.0
            do k=ktopcd(i,j),kendcd(i,j)
               hwtop=hwtop+(phalf(i,j,k+1)-phalf(i,j,k))*rdgas*T(i,j,k)/grav/pfull(i,j,k)
            enddo
            do k=ktopcd(i,j),kendcd(i,j)
!     Areal fraction affected by precip clouds (max = 0.5):
               tracer_dt(i,j,k)=prenow/(clwc*hwtop)
            end do  
          endif

         washout(i,j)=prenow*wash
          endif
   end do
   end do
          endif

! Now multiply by the tracer mixing ratio to get the actual tendency.
tracer_dt(:,:,:) = MIN( MAX(tracer_dt(:,:,:), 0.0E+00), 0.5/dt)
where (tracer > 0.)
   tracer_dt = tracer_dt*tracer
else where
   tracer_dt = 0.
end where

!++lwh
!
! Re-evaporation
!
do k = 1,kd
   where (reevap_fraction(:,:,k) > 0.) 
      reevap_diag(:,:,k) = reevap_fraction(:,:,k) * tracer_flux(:,:)
! tracer reevaporation fraction is reduced from precip reevaporation,
! except when complete reevaporation occurs
      where( reevap_fraction(:,:,k) < 1. )
         reevap_diag(:,:,k) = reevap_diag(:,:,k) * frac_int
      end where
      tracer_dt(:,:,k) = tracer_dt(:,:,k) - reevap_diag(:,:,k) / pwt(:,:,k)
   end where
   tracer_flux(:,:) = tracer_flux(:,:) + tracer_dt(:,:,k)*pwt(:,:,k)
end do
!--lwh
!
endif ! End branching pag/lwh
!
! Output diagnostics in kg/m2/s (if MMR) or mole/m2/s (if VMR)
if(trim(units) .eq. 'mmr') then
   diag_scale = 1.
        elseif(trim(units) .eq. 'vmr') then
   diag_scale = mw_air ! kg/mole
else
   write(*,*) ' Tracer number =',n,' tracer_name=',tracer_name
   write(*,*) ' scheme=',text_in_scheme
   write(*,*) ' control=',control
   write(*,*) ' scheme=',scheme
   write(*,*) 'Please check field table'
   write(*,*) 'tracers units =',trim(units),'it should be either  mmr or vmr!'
!  <ERROR MSG="Unsupported tracer units" STATUS="FATAL">
!     Tracer units must be either VMR or MMR
!  </ERROR>
   call error_mesg('wet_deposition', 'Unsupported tracer units.', FATAL )
          endif


! Column integral of wet deposition
sum_wdep = 0.
do k=1,kd
   sum_wdep = sum_wdep + tracer_dt(:,:,k)*pwt(:,:,k)/diag_scale
end do

if (present (sum_wdep_out))  sum_wdep_out = -sum_wdep

if(trim(cloud_param) == 'lscale') then
   if (id_tracer_reevap_ls(n) > 0 ) then
      used = send_data ( id_tracer_reevap_ls(n), reevap_diag/diag_scale, Time ,is,js,1)
   endif
   if (id_tracer_wdep_ls(n) > 0 ) then
      used = send_data ( id_tracer_wdep_ls(n), sum_wdep, Time, is_in =is, js_in=js )
   endif
   if (id_tracer_wdep_ls_3d(n) > 0 ) then
     used = send_data ( id_tracer_wdep_ls_3d(n), tracer_dt*pwt/diag_scale, Time, is_in =is, js_in=js ,ks_in=1)
   endif
   if (id_tracer_wdep_lsin(n) > 0 ) then
       used = send_data ( id_tracer_wdep_lsin(n), wdep_in/diag_scale, Time, is_in=is, js_in=js )
   endif
   if (id_tracer_wdep_lsbc(n) > 0 ) then
      used = send_data ( id_tracer_wdep_lsbc(n), wdep_bc/diag_scale, Time, is_in=is, js_in=js )
   endif

else if(trim(cloud_param) == 'convect') then
   if (id_tracer_reevap_cv(n) > 0 ) then
      used = send_data ( id_tracer_reevap_cv(n), reevap_diag/diag_scale, Time ,is,js,1)
   endif
   if(id_tracer_wdep_cv(n) > 0) then
      used = send_data( id_tracer_wdep_cv(n), sum_wdep, Time, is_in=is, js_in=js)
   endif
   if (id_tracer_wdep_cvin(n) > 0 ) then
       used = send_data ( id_tracer_wdep_cvin(n), wdep_in/diag_scale, Time, is_in=is, js_in=js)
   endif
   if (id_tracer_wdep_cvbc(n) > 0 ) then
      used = send_data ( id_tracer_wdep_cvbc(n), wdep_bc/diag_scale, Time, is_in=is, js_in=js)
   endif
endif

end subroutine wet_deposition
!</SUBROUTINE>
!
!#######################################################################
!
subroutine get_drydep_param(text_in_scheme,text_in_param,scheme,land_dry_dep_vel,sea_dry_dep_vel)
!subroutine get_drydep_param(text_in_scheme, text_in_param, scheme,  &
!                            land_dry_dep_vel, sea_dry_dep_vel, &
!                            ice_dry_dep_vel, snow_dry_dep_vel,  &
!                            vegn_dry_dep_vel)
!
! Subroutine to initialiize the parameters for the dry deposition scheme.
! If the dry dep scheme is a "fixed" form then the 
! dry_deposition velocity value has to be set.
! If the dry dep scheme is a "wind_driven" form then the dry_deposition
! velocity value will be calculated. So set to a dummy value of 0.0
! INTENT IN
!  text_in_scheme   : The text that has been parsed from tracer table as 
!                     the dry deposition scheme to be used.
!  text_in_param    : The parameters that are associated with the dry 
!                     deposition scheme.
! INTENT OUT
!  scheme           : The scheme that is being used.
!  land_dry_dep_vel : Dry deposition velocity over the land
!  sea_dry_dep_vel  : Dry deposition velocity over the sea
!
character(len=*), intent(in)    :: text_in_scheme, text_in_param
character(len=*), intent(out)   :: scheme
real, intent(out)               :: land_dry_dep_vel, sea_dry_dep_vel!, &
!                                   ice_dry_dep_vel, snow_dry_dep_vel, &
!                                   vegn_dry_dep_vel

integer :: flag

!Default
scheme                  = 'None'
land_dry_dep_vel=0.0
sea_dry_dep_vel=0.0
!ice_dry_dep_vel=0.0
!snow_dry_dep_vel=0.0
!vegn_dry_dep_vel=0.0

if(lowercase(trim(text_in_scheme(1:4))).eq.'wind') then
 scheme                  = 'Wind_driven'
endif

!if(lowercase(trim(text_in_scheme(1:15))).eq.'sfc_dependent_w') then
!scheme                 = 'sfc_dependent_wind_driven'
!endif
!
!if(lowercase(trim(text_in_scheme(1:6))).eq.'sfc_bl') then
!scheme                 = 'sfc_BL_dependent_wind_driven'
!endif

if(lowercase(trim(text_in_scheme(1:5))).eq.'fixed') then
scheme                 = 'fixed'
flag=parse(text_in_param,'land',land_dry_dep_vel)
flag=parse(text_in_param,'sea', sea_dry_dep_vel)
endif

!if(lowercase(trim(text_in_scheme(1:15))).eq.'sfc_dependent_f') then
!scheme                 = 'sfc_dependent_fixed'
!flag=parse(text_in_param,'land',land_dry_dep_vel)
!flag=parse(text_in_param,'sea', sea_dry_dep_vel)
!flag=parse(text_in_param,'ice', ice_dry_dep_vel)
!if (flag == 0) then
!   ice_dry_dep_vel = sea_dry_dep_vel
!end if
!flag=parse(text_in_param,'snow', snow_dry_dep_vel)
!if (flag == 0) then
!   snow_dry_dep_vel = land_dry_dep_vel
!end if
!flag=parse(text_in_param,'vegn', vegn_dry_dep_vel)
!if (flag == 0) then
!   vegn_dry_dep_vel = land_dry_dep_vel
!end if
!endif

if(lowercase(trim(text_in_scheme(1:4))).eq.'file') then
   scheme = 'file'
endif

end subroutine get_drydep_param
!
!#######################################################################
!
!<SUBROUTINE NAME="get_wetdep_param">
!<TEMPLATE>
!CALL get_wetdep_param(text_in_scheme, text_in_param, scheme,&
!                      henry_constant, henry_temp, &
!                      frac_in_cloud, alpha_r, alpha_s)
!</TEMPLATE>
subroutine get_wetdep_param(text_in_scheme,text_in_param,scheme,&
                            henry_constant, henry_temp, &
                            frac_in_cloud, frac_in_cloud_snow,  &
                            alpha_r,alpha_s, &
                            Lwetdep, Lgas, Laerosol, Lice, &
                            frac_in_cloud_uw, frac_in_cloud_donner)
!<OVERVIEW>
! Routine to initialize the parameters for the wet deposition scheme.
!</OVERVIEW>
!
! shm has modified this subroutine to include additional parameters:
!      frac_in_cloud, alpha_r, and alpha_s
!
! INTENT IN
!<IN NAME="text_in_scheme" TYPE="character">
!   Text read from the tracer table which provides information on which
!                   wet deposition scheme to use.
!</IN>
!<IN NAME="text_in_param" TYPE="character">
!   Parameters associated with the wet deposition scheme. These will be
!                   parsed in this routine.
!</IN>
!<OUT NAME="scheme" TYPE="character">
!   Wet deposition scheme to use.
!   Choices are: None, Fraction, Henry, Henry_below, Aerosol, Aerosol_below,
!                wdep_aerosol, wdep_gas
!</OUT>
!<OUT NAME="henry_constant" TYPE="real">
!   Henry's Law constant for the tracer (see wet_deposition for explanation of Henry's Law)
!</OUT>
!<OUT NAME="henry_temp" TYPE="real">
!   The temperature dependence of the Henry's Law constant.
!</OUT>
!<OUT NAME="frac_in_cloud" TYPE="real">
!   In-cloud fraction for aerosols
!</OUT>
!<OUT NAME="alpha_r" TYPE="real">
!   Controls below-cloud aerosol scavenging by rain
!</OUT>
!<OUT NAME="alpha_s" TYPE="real">
!   Controls below-cloud aerosol scavenging by snow
!</OUT>
!<OUT NAME="Lwetdep" TYPE="logical">
!   Does tracer have wet removal?
!</OUT>
!<OUT NAME="Lgas" TYPE="logical">
!   Is tracer a gas?
!</OUT>
!<OUT NAME="Laerosol" TYPE="logical">
!   Is tracer an aerosol?
!</OUT>
!<OUT NAME="Lice" TYPE="logical">
!   Is tracer removed by snow (or just rain)?
!</OUT>


character(len=*), intent(in)    :: text_in_scheme, text_in_param
character(len=*), intent(out)   :: scheme
real, intent(out)               :: henry_constant, henry_temp
real, intent(out)               :: frac_in_cloud, frac_in_cloud_snow
real, intent(out)               :: alpha_r, alpha_s
logical, intent(out)            :: Lwetdep, Lgas, Laerosol, Lice
real, intent(out), optional     :: frac_in_cloud_uw, frac_in_cloud_donner

integer :: flag

!Default
scheme                  = 'None'
henry_constant= 0.
henry_temp    = 0.
frac_in_cloud = 0.
frac_in_cloud_snow = 0.
alpha_r       = 0.
alpha_s       = 0.
Lwetdep = .false.
Lgas = .false.
Laerosol = .false.

if (present(frac_in_cloud_uw))     frac_in_cloud_uw = 0.
if (present(frac_in_cloud_donner)) frac_in_cloud_donner = 0.

if( trim(lowercase(text_in_scheme)) == 'fraction' ) then
   scheme                 = 'Fraction'
else if( trim(lowercase(text_in_scheme)) == 'henry' .or. &
         trim(lowercase(text_in_scheme)) == 'henry_below' .or. &
         trim(lowercase(text_in_scheme)) == 'henry_noice' .or. &
         trim(lowercase(text_in_scheme)) == 'henry_below_noice' ) then
   if( trim(lowercase(text_in_scheme)) == 'henry' ) then
      scheme                 = 'henry'
   else if ( trim(lowercase(text_in_scheme)) == 'henry_below' ) then
      scheme                 = 'henry_below'
   else if ( trim(lowercase(text_in_scheme)) == 'henry_noice' ) then
      scheme                 = 'henry_noice'
   else if ( trim(lowercase(text_in_scheme)) == 'henry_below_noice' ) then
      scheme                 = 'henry_below_noice'
   end  if
   flag=parse(text_in_param,'henry',     henry_constant)
   flag=parse(text_in_param,'dependence',henry_temp    )
   Lgas = .true.
else if( trim(lowercase(text_in_scheme)) == 'aerosol' .or. &
         trim(lowercase(text_in_scheme)) == 'aerosol_below' .or. &
         trim(lowercase(text_in_scheme)) == 'aerosol_noice' .or. &
         trim(lowercase(text_in_scheme)) == 'aerosol_below_noice' ) then
   if( trim(lowercase(text_in_scheme)) == 'aerosol' ) then
      scheme                 = 'aerosol'
   else if ( trim(lowercase(text_in_scheme)) == 'aerosol_below' ) then
      scheme                 = 'aerosol_below'
   else if ( trim(lowercase(text_in_scheme)) == 'aerosol_noice' ) then
      scheme                 = 'aerosol_noice'
   else if ( trim(lowercase(text_in_scheme)) == 'aerosol_below_noice' ) then
      scheme                 = 'aerosol_below_noice'
   end if
   flag=parse(text_in_param,'frac_incloud',frac_in_cloud)

   flag=parse(text_in_param,'frac_incloud_snow',frac_in_cloud_snow)
   if (flag == 0) then
      frac_in_cloud_snow = frac_in_cloud
   end if

   if (present(frac_in_cloud_uw)) then
      flag=parse(text_in_param,'frac_incloud_uw',frac_in_cloud_uw)
      if (flag == 0) then
         frac_in_cloud_uw = frac_in_cloud
      end if
   end if
   if (present(frac_in_cloud_donner)) then
      flag=parse(text_in_param,'frac_incloud_donner',   &
                                                frac_in_cloud_donner)
      if (flag == 0) then
         frac_in_cloud_donner = frac_in_cloud
      end if
   end if
   flag=parse(text_in_param,'alphar',alpha_r)
   flag=parse(text_in_param,'alphas',alpha_s)
   Laerosol = .true.
end if
if( trim(lowercase(text_in_scheme)) == 'wdep_aerosol') scheme= 'wdep_aerosol'
if ( trim(lowercase(text_in_scheme)) == 'wdep_gas' ) scheme= 'wdep_gas'
if (scheme .eq. 'wdep_aerosol' .or. scheme .eq. 'wdep_gas') then
   flag=parse(text_in_param,'frac_incloud',frac_in_cloud)
   flag=parse(text_in_param,'alphar',alpha_r)
   flag=parse(text_in_param,'alphas',alpha_s)
end if

Lice = .not. ( scheme=='henry_noice' .or. scheme=='henry_below_noice' .or. &
               scheme=='aerosol_noice' .or. scheme=='aerosol_below_noice' )
Lwetdep = scheme /= 'None'

end subroutine get_wetdep_param
!</SUBROUTINE>
!
!#######################################################################
!
!<SUBROUTINE NAME="interp_emiss">
subroutine interp_emiss(global_source, start_lon, start_lat, &
                        lon_resol, lat_resol, data_out)
!
!<OVERVIEW>
! A routine to interpolate emission fields of arbitrary resolution onto the 
! resolution of the model.
!</OVERVIEW>
!<DESCRIPTION>
! Routine to interpolate emission fields (or any 2D field) to the model 
! resolution. The local section of the global field is returned to the 
! local processor.
!</DESCRIPTION>
! 
!<TEMPLATE>
! call interp_emiss(global_source, start_lon, start_lat, &
!                        lon_resol, lat_resol, data_out)
!</TEMPLATE>
! INTENT IN
!<IN NAME="global_source" TYPE="real" DIM="(:,:)">
!  Global emission field.
!</IN>
!<IN NAME="start_lon" TYPE="real">
!  Longitude of starting point of emission field 
!  (in radians). This is the westernmost boundary of the 
!  global field.
!</IN>
!<IN NAME="start_lat" TYPE="real">
!  Latitude of starting point of emission field
!  (in radians). This is the southern boundary of the 
!  global field.
!</IN>
!<IN NAME="lon_resol" TYPE="real">
!  Longitudinal resolution of the emission data (in radians).
!</IN>
!<IN NAME="lat_resol" TYPE="real">
!  Latitudinal resolution of the emission data (in radians).
!</IN>
! 
! INTENT OUT
!<OUT NAME="data_out" TYPE="real" DIM="(:,:)">
!  Interpolated emission field on the local PE. 
!</OUT>

real, intent(in)  :: global_source(:,:)
real, intent(in)  :: start_lon,start_lat,lon_resol,lat_resol
real, intent(out) :: data_out(:,:)

integer :: i, j, nlon_in, nlat_in
real :: blon_in(size(global_source,1)+1)
real :: blat_in(size(global_source,2)+1)
type (horiz_interp_type) :: Interp
! Set up the global surface boundary condition longitude-latitude boundary values

   nlon_in = size(global_source,1)
   nlat_in = size(global_source,2)
! For some reason the input longitude needs to be incremented by 180 degrees.
   do i = 1, nlon_in+1
      blon_in(i) = start_lon + float(i-1)*lon_resol + PI
   enddo
      if (abs(blon_in(nlon_in+1)-blon_in(1)-twopi) < epsilon(blon_in)) &
              blon_in(nlon_in+1)=blon_in(1)+twopi

   do j = 2, nlat_in
      blat_in(j) = start_lat + float(j-1)*lat_resol
   enddo
      blat_in(1)         = -0.5*PI
      blat_in(nlat_in+1) =  0.5*PI

! Now interpolate the global data to the model resolution
   call horiz_interp_init
   call horiz_interp_new (Interp, blon_in, blat_in, &
                                  blon_out, blat_out)
   call horiz_interp (Interp, global_source, data_out)
   call horiz_interp_del ( Interp )


end subroutine interp_emiss
!</SUBROUTINE>
! ######################################################################
!

      subroutine GET_RH (T,Q,P,RH,mask)
!***********************************************************************
!  SUBROUTINE GET_RH
!  PURPOSE
!     VECTOR COMPUTATION OF RELATIVE HUMIDITY
!  DESCRIPTION OF PARAMETERS
!     T        TEMPERATURE VECTOR (DEG K)
!     P        PRESSURE VECTOR (Pa)
!     Q        SPECIFIC HUMIDITY (kg/kg)
!     RH       RELATIVE HUMIDITY
!     MASK     EARTH SURFACE BELOW GROUND (in pressure coordinates)
!
!***********************************************************************
!

      Real, parameter :: ONE    = 1.
      Real, parameter :: ZP622  = 0.622
      Real, parameter :: Z1P0S1 = 1.00001
      Real, parameter :: Z1P622 = 1.622
      Real, parameter :: Z138P9 = 138.90001
      Real, parameter :: Z198P9 = 198.99999
      Real, parameter :: Z200   = 200.0
      Real, parameter :: Z337P9 = 337.9

      real, intent(in), dimension(:,:,:) :: T !temp at curr time step [ deg k ]
      real, intent(in), dimension(:,:,:) :: P !pressure at full levels [ Pa ]
      real, intent(in), dimension(:,:,:) :: Q !specific humidity at current time step  [ kg / kg ]
      real, intent(in), dimension(:,:,:), optional :: mask !
      real, intent(out), dimension(:,:,:) :: RH !relative humidity [0-1]

! Dynamic Work Space
! ------------------
      real :: A1622
      real, dimension(size(q,1),size(q,2),size(q,3)) :: e1, e2, tq, qs
      integer, dimension(size(q,1),size(q,2),size(q,3)) :: i1, i2
      integer :: i,j,k

!
      real, dimension(67) :: EST1
      data EST1/       0.31195E-02, 0.36135E-02, 0.41800E-02, &
          0.48227E-02, 0.55571E-02, 0.63934E-02, 0.73433E-02, &
          0.84286E-02, 0.96407E-02, 0.11014E-01, 0.12582E-01, &
          0.14353E-01, 0.16341E-01, 0.18574E-01, 0.21095E-01, &
          0.23926E-01, 0.27096E-01, 0.30652E-01, 0.34629E-01, &
          0.39073E-01, 0.44028E-01, 0.49546E-01, 0.55691E-01, &
          0.62508E-01, 0.70077E-01, 0.78700E-01, 0.88128E-01, &
          0.98477E-01, 0.10983E+00, 0.12233E+00, 0.13608E+00, &
          0.15121E+00, 0.16784E+00, 0.18615E+00, 0.20627E+00, &
          0.22837E+00, 0.25263E+00, 0.27923E+00, 0.30838E+00, &
          0.34030E+00, 0.37520E+00, 0.41334E+00, 0.45497E+00, &
          0.50037E+00, 0.54984E+00, 0.60369E+00, 0.66225E+00, &
          0.72589E+00, 0.79497E+00, 0.86991E+00, 0.95113E+00, &
          0.10391E+01, 0.11343E+01, 0.12372E+01, 0.13484E+01, &
          0.14684E+01, 0.15979E+01, 0.17375E+01, 0.18879E+01, &
          0.20499E+01, 0.22241E+01, 0.24113E+01, 0.26126E+01, &
          0.28286E+01, 0.30604E+01, 0.33091E+01, 0.35755E+01/
!
      real, dimension(72)  :: EST2
      data EST2/ &
          0.38608E+01, 0.41663E+01, 0.44930E+01, 0.48423E+01, &
          0.52155E+01, 0.56140E+01, 0.60394E+01, 0.64930E+01, &
          0.69767E+01, 0.74919E+01, 0.80406E+01, 0.86246E+01, &
          0.92457E+01, 0.99061E+01, 0.10608E+02, 0.11353E+02, &
          0.12144E+02, 0.12983E+02, 0.13873E+02, 0.14816E+02, &
          0.15815E+02, 0.16872E+02, 0.17992E+02, 0.19176E+02, &
          0.20428E+02, 0.21750E+02, 0.23148E+02, 0.24623E+02, &
          0.26180E+02, 0.27822E+02, 0.29553E+02, 0.31378E+02, &
          0.33300E+02, 0.35324E+02, 0.37454E+02, 0.39696E+02, &
          0.42053E+02, 0.44531E+02, 0.47134E+02, 0.49869E+02, &
          0.52741E+02, 0.55754E+02, 0.58916E+02, 0.62232E+02, &
          0.65708E+02, 0.69351E+02, 0.73168E+02, 0.77164E+02, &
          0.81348E+02, 0.85725E+02, 0.90305E+02, 0.95094E+02, &
          0.10010E+03, 0.10533E+03, 0.11080E+03, 0.11650E+03, &
          0.12246E+03, 0.12868E+03, 0.13517E+03, 0.14193E+03, &
          0.14899E+03, 0.15634E+03, 0.16400E+03, 0.17199E+03, &
          0.18030E+03, 0.18895E+03, 0.19796E+03, 0.20733E+03, &
          0.21708E+03, 0.22722E+03, 0.23776E+03, 0.24871E+03/
!
      real, dimension(139) :: EST
      EQUIVALENCE (EST(1)  , EST1(1)), (EST(68),EST2(1))
!***********************************************************************
!
      A1622   = ONE  / Z1P622
      TQ = T - Z198P9
      I1(:,:,:) = 1
      I2(:,:,:) = 1
      where ( T < Z200 ) TQ = Z1P0S1
      where ( T > Z337P9 ) TQ = Z138P9
      IF (present(mask)) THEN
        where ( mask > 0. )
          I1 = int(TQ)
          I2 = I1 + 1
        end where
      else
        I1 = int(TQ)
        I2 = I1 + 1
      endif
      do i=1,size(q,1)
        do j=1,size(q,2)
          do k=1,size(q,3)
            E1(i,j,k) =  EST( I1(i,j,k) )
            E2(i,j,k) =  EST( I2(i,j,k) )
          enddo
        enddo
     enddo
      QS(:,:,:) = TQ(:,:,:) - float(I1(:,:,:))
      QS(:,:,:) = E1(:,:,:) + QS(:,:,:) * ( E2(:,:,:)-E1(:,:,:) )
      E1(:,:,:) = (0.01 * P(:,:,:)) * A1622
      where ( E1 < QS ) QS = E1
      if (present(mask)) then
        where ( mask > 0. )  QS = ZP622 * QS / ( P * 0.01)
      else
        QS(:,:,:) = ZP622 * QS(:,:,:) / ( P(:,:,:) * 0.01)
      endif
      RH(:,:,:) = Q(:,:,:)/QS(:,:,:)

end subroutine GET_RH

! ######################################################################
!
subroutine get_w10m(z_full, u, v, rough_mom,u_star, b_star, q_star, &
       w10m_ocean, w10m_land, Time_next, is,js)

real, intent(in),    dimension(:,:) :: z_full, u, v
real, intent(in),    dimension(:,:)   :: rough_mom
real, intent(in),    dimension(:,:)   :: u_star, b_star, q_star
type(time_type), intent(in)           :: Time_next
integer, intent(in)                   :: is,js

logical :: used

real, intent(out),   dimension(:,:)   :: w10m_ocean, w10m_land
real, dimension(size(u,1),size(u,2)) ::  del_m
real, dimension(size(u,1),size(u,2)) ::  del_h
real, dimension(size(u,1),size(u,2)) ::  del_q
! Reference heights for momentum and heat [m]
real, parameter :: zrefm = 10.
real, parameter :: zrefh = 2.
real, parameter :: scaling_factor=1.

     w10m_ocean(:,:)    = 0.0
     w10m_land (:,:)    = 0.0
     del_m(:,:)   = 0.0

      call mo_profile(zrefm, zrefh, z_full, &
           rough_mom, rough_mom, rough_mom, &
           u_star, b_star, q_star, &
           del_m, del_h, del_q )
!-----------------------------------------------------------------
!       ... Wind speed at anemometer level (10 meters above ground)
!-----------------------------------------------------------------
      w10m_ocean(:,:)=sqrt(u(:,:)**2 +v(:,:)**2 )*del_m(:,:)
      w10m_land (:,:)=sqrt(u(:,:)**2 +v(:,:)**2 )*del_m(:,:)*scaling_factor

! Send the scaling factor
      if (id_delm > 0 ) then
        used = send_data ( id_delm, del_m, Time_next, is_in=is,js_in=js )
      endif

! Send the 10m wind speed data to the diag_manager for output.
      if (id_w10m > 0 ) then
        used = send_data ( id_w10m, w10m_land, Time_next, is_in=is,js_in=js )
      endif

end subroutine get_w10m

! ######################################################################
!
subroutine get_cldf(ps, pfull, rh, cldf)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!
!!! This subroutine estimates the cloud fraction "cldf" for
!!! each grid box using an empirical function of the relative
!!! humidity in that grid box, following Sundqvist et al., Mon. Weather Rev.,
!!! v117, 164101657, 1989:
!!!
!!!             cldf = 1 - sqrt[ 1 - (RH - RH0)/(1 - RH0) ]
!!!
!!! where RH is the relative humidity and RH0 is the threshold relative
!!! humidity for condensation specified as a function of pressure based
!!! on Xu and Krueger, Mon. Weather Rev., v119, 342-367, 1991.
!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      real, intent(in),  dimension(:,:)   :: ps
      real, intent(in),  dimension(:,:,:) :: pfull
      real, intent(in),  dimension(:,:,:) :: rh
      real, intent(out), dimension(:,:,:) :: cldf
      real, parameter :: zrt = 0.6
      real, parameter :: zrs = 0.99
      integer           :: i,j,k, id, jd, kd
      real              :: p, r, r0, b0
      id=size(pfull,1); jd=size(pfull,2); kd=size(pfull,3)

      do k = 1, kd
      do j = 1, jd
      do i = 1, id
       P = pfull(i,j,k)
       R = RH(i,j,k)
       R0 = ZRT + (ZRS-ZRT) * exp(1.-(PS(i,j)/P)**2.5)
       B0 = (R-R0) / (1.-R0)
       if (R .lt.R0) B0 = 0.
       if (B0.gt.1.) B0 = 1.
       CLDF(i,j,k) = 1.-sqrt(1.-B0)
      end do
      end do
      end do

end subroutine get_cldf

!######################################################################
!<SUBROUTINE NAME="tracer_utilities_end">
!<OVERVIEW>
!  The destructor routine for the tracer utilities module.
!</OVERVIEW>
! <DESCRIPTION>
! This subroutine writes the version name to logfile and exits. 
! </DESCRIPTION>

subroutine atmos_tracer_utilities_end
 

   deallocate(blon_out, blat_out)
   module_is_initialized = .FALSE.

 end subroutine atmos_tracer_utilities_end
!</SUBROUTINE>

! ######################################################################
! !IROUTINE: sjl_fillz --- Fill from neighbors below and above
!
! !INTERFACE:
 subroutine sjl_fillz(im, km, nq, q, dp)

 implicit none

! !INPUT PARAMETERS:
   integer,  intent(in):: im                ! No. of longitudes
   integer,  intent(in):: km                ! No. of levels
   integer,  intent(in):: nq                ! Total number of tracers

   real, intent(in)::  dp(im,km)       ! pressure thickness
! !INPUT/OUTPUT PARAMETERS:
   real, intent(inout) :: q(im,km,nq)   ! tracer mixing ratio

! !DESCRIPTION:
!   Check for "bad" data and fill from east and west neighbors
!
! !BUGS:
!   Currently this routine only performs the east-west fill algorithm.
!   This is because the N-S fill is very hard to do in a reproducible
!   fashion when the problem is decomposed by latitudes.
!
! !REVISION HISTORY:
!   00.04.01   Lin        Creation
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
   integer i, k, ic
   real qup, qly, dup

   do ic=1,nq
! Top layer
      do i=1,im
         if( q(i,1,ic) < 0.) then
             q(i,2,ic) = q(i,2,ic) + q(i,1,ic)*dp(i,1)/dp(i,2)
             q(i,1,ic) = 0.
          endif
      enddo

! Interior
      do k=2,km-1
         do i=1,im
         if( q(i,k,ic) < 0. ) then
! Borrow from above
             qup =  q(i,k-1,ic)*dp(i,k-1)
             qly = -q(i,k  ,ic)*dp(i,k  )
             dup =  min( 0.75*qly, qup )        !borrow no more than 75% from top
             q(i,k-1,ic) = q(i,k-1,ic) - dup/dp(i,k-1)
! Borrow from below: q(i,k,ic) is still negative at this stage
             q(i,k+1,ic) = q(i,k+1,ic) + (dup-qly)/dp(i,k+1)
             q(i,k  ,ic) = 0.
          endif
          enddo
      enddo

! Bottom layer
      k = km
      do i=1,im
         if( q(i,k,ic) < 0.) then
! Borrow from above
             qup =  q(i,k-1,ic)*dp(i,k-1)
             qly = -q(i,k  ,ic)*dp(i,k  )
             dup =  min( qly, qup )
             q(i,k-1,ic) = q(i,k-1,ic) - dup/dp(i,k-1)
             q(i,k,ic) = 0.
          endif
      enddo
   enddo
end subroutine sjl_fillz

end module atmos_tracer_utilities_mod

 module sat_vapor_pres_k_mod

! This module is what I (pjp) think a kernel should be.
! There have been many proposals as to what a kernel should look like.
! If fact, so many different ideas have been expressed that the lack
! of agreement has greatly hampered progress.
! The only way to move forward is to limit the requirments for a kernel
! to only what is widely agreeded upon.
! I believe that there are only two things widely agreeded upon.

! 1) A kernel should be independent of the rest of FMS so that it can
!    easily be ported into another programming system.
!    This requires that a kernel does not access anything by use association.
!    The one exception is this kernel, because it is not practical for physics
!    modules to avoid using a module that computes the saturation vapor
!    pressure of water vapor.

! 2) For the sake of thread safety, module globals should be written only at initialization.
!    In this case, the module globals are the tables and a handful of scalars.

! 3) A kernel should not read from an external file.

! One of the things that was not widely agreeded upon is that a kernel should
! not be a fortran module. This complicates things greatly for questionable
! benefit and could be done as a second step anyway, if necessary.

 implicit none
 private

 character(len=128), parameter :: version = '$Id$'
 character(len=128), parameter :: tagname = '$Name$'

 public :: sat_vapor_pres_init_k
 public :: lookup_es_k
 public :: lookup_des_k
 public :: lookup_es_des_k
 public :: lookup_es2_k
 public :: lookup_des2_k
 public :: lookup_es2_des2_k
 public :: lookup_es3_k
 public :: lookup_des3_k
 public :: lookup_es3_des3_k
 public :: compute_qs_k
 public :: compute_mrs_k

 interface lookup_es_k
   module procedure lookup_es_k_0d
   module procedure lookup_es_k_1d
   module procedure lookup_es_k_2d
   module procedure lookup_es_k_3d
 end interface

 interface lookup_des_k
   module procedure lookup_des_k_0d
   module procedure lookup_des_k_1d
   module procedure lookup_des_k_2d
   module procedure lookup_des_k_3d
 end interface

 interface lookup_es_des_k
   module procedure lookup_es_des_k_0d
   module procedure lookup_es_des_k_1d
   module procedure lookup_es_des_k_2d
   module procedure lookup_es_des_k_3d
 end interface

 interface lookup_es2_k
   module procedure lookup_es2_k_0d
   module procedure lookup_es2_k_1d
   module procedure lookup_es2_k_2d
   module procedure lookup_es2_k_3d
 end interface

 interface lookup_des2_k
   module procedure lookup_des2_k_0d
   module procedure lookup_des2_k_1d
   module procedure lookup_des2_k_2d
   module procedure lookup_des2_k_3d
 end interface

 interface lookup_es2_des2_k
   module procedure lookup_es2_des2_k_0d
   module procedure lookup_es2_des2_k_1d
   module procedure lookup_es2_des2_k_2d
   module procedure lookup_es2_des2_k_3d
 end interface

 interface lookup_es3_k
   module procedure lookup_es3_k_0d
   module procedure lookup_es3_k_1d
   module procedure lookup_es3_k_2d
   module procedure lookup_es3_k_3d
 end interface

 interface lookup_des3_k
   module procedure lookup_des3_k_0d
   module procedure lookup_des3_k_1d
   module procedure lookup_des3_k_2d
   module procedure lookup_des3_k_3d
 end interface

 interface lookup_es3_des3_k
   module procedure lookup_es3_des3_k_0d
   module procedure lookup_es3_des3_k_1d
   module procedure lookup_es3_des3_k_2d
   module procedure lookup_es3_des3_k_3d
 end interface

 interface compute_qs_k
   module procedure compute_qs_k_0d
   module procedure compute_qs_k_1d
   module procedure compute_qs_k_2d
   module procedure compute_qs_k_3d
 end interface

 interface compute_mrs_k
   module procedure compute_mrs_k_0d
   module procedure compute_mrs_k_1d
   module procedure compute_mrs_k_2d
   module procedure compute_mrs_k_3d
 end interface

 real :: dtres, tepsl, tminl, dtinvl
 integer :: table_siz
 real, dimension(:), allocatable :: TABLE   !  sat vapor pres (es)
 real, dimension(:), allocatable :: DTABLE  !  first derivative of es
 real, dimension(:), allocatable :: D2TABLE ! second derivative of es
 real, dimension(:), allocatable :: TABLE2  !  sat vapor pres (es)
 real, dimension(:), allocatable :: DTABLE2 !  first derivative of es
 real, dimension(:), allocatable :: D2TABLE2 ! second derivative of es
 real, dimension(:), allocatable :: TABLE3  !  sat vapor pres (es)
 real, dimension(:), allocatable :: DTABLE3 !  first derivative of es
 real, dimension(:), allocatable :: D2TABLE3 ! second derivative of es

 logical  :: use_exact_qs
 logical  :: module_is_initialized = .false.

 contains

 subroutine sat_vapor_pres_init_k(table_size, tcmin, tcmax, TFREEZE, HLV, RVGAS, ES0, err_msg, &
                                  use_exact_qs_input, do_simple,  &
                                  construct_table_wrt_liq, &
                                  construct_table_wrt_liq_and_ice, &
                                  teps, tmin, dtinv)

! This routine has been generalized to return tables for any temperature range and resolution

 integer, intent(in) :: table_size
 real, intent(in) :: tcmin ! TABLE(1)          = sat vapor pressure at temperature tcmin (deg C)
 real, intent(in) :: tcmax ! TABLE(table_size) = sat vapor pressure at temperature tcmax (deg C)
 real, intent(in) :: TFREEZE, HLV, RVGAS, ES0
 logical, intent(in)  :: use_exact_qs_input, do_simple
 logical, intent(in)  :: construct_table_wrt_liq
 logical, intent(in)  :: construct_table_wrt_liq_and_ice
 character(len=*), intent(out) :: err_msg
 real, intent(out), optional :: teps, tmin, dtinv

! increment used to generate derivative table
  real, dimension(3) :: tem(3), es(3)
  real :: hdtinv, tinrc, tfact
  integer :: i

      err_msg = ''

      if (module_is_initialized) return

      if(allocated(TABLE) .or. allocated(DTABLE) .or. allocated(D2TABLE)) then
        err_msg = 'Attempt to allocate sat vapor pressure tables when already allocated'
        return
      else
        allocate(TABLE(table_size), DTABLE(table_size), D2TABLE(table_size))
      endif
      
   if (construct_table_wrt_liq) then
      if(allocated(TABLE2) .or. allocated(DTABLE2) .or. allocated(D2TABLE2)) then
        err_msg = 'Attempt to allocate sat vapor pressure table2s when already allocated'
        return
      else
        allocate(TABLE2(table_size), DTABLE2(table_size), D2TABLE2(table_size))
      endif
   endif

   if (construct_table_wrt_liq_and_ice) then
      if(allocated(TABLE3) .or. allocated(DTABLE3) .or. allocated(D2TABLE3)) then
        err_msg = 'Attempt to allocate sat vapor pressure table2s when already allocated'
        return
      else
        allocate(TABLE3(table_size), DTABLE3(table_size), D2TABLE3(table_size))
      endif
   endif

      table_siz = table_size
      dtres = (tcmax - tcmin)/real(table_size-1)
      tminl = real(tcmin)+TFREEZE  ! minimum valid temp in table
      dtinvl = 1./dtres
      tepsl = .5*dtres
      tinrc = .1*dtres
      if(present(teps )) teps =tepsl
      if(present(tmin )) tmin =tminl
      if(present(dtinv)) dtinv=dtinvl

! To be able to compute tables for any temperature range and resolution,
! and at the same time exactly reproduce answers from memphis revision,
! it is necessary to compute ftact differently than it is in memphis.
      tfact = 5.0*dtinvl

      hdtinv = dtinvl*0.5

! compute es tables from tcmin to tcmax
! estimate es derivative with small +/- difference

      if (do_simple) then

        do i = 1, table_size
          tem(1) = tminl + dtres*real(i-1)
          TABLE(i) = ES0*610.78*exp(-hlv/rvgas*(1./tem(1) - 1./tfreeze)) 
          DTABLE(i) = hlv*TABLE(i)/rvgas/tem(1)**2.
        enddo

      else

        do i = 1, table_size
          tem(1) = tminl + dtres*real(i-1)
          tem(2) = tem(1)-tinrc
          tem(3) = tem(1)+tinrc
          es = compute_es_k (tem, TFREEZE)
          TABLE(i) = es(1)
          DTABLE(i) = (es(3)-es(2))*tfact
        enddo

      endif !if (do_simple)

! compute one-half second derivative using centered differences
! differencing des values in the table

      do i = 2, table_size-1
         D2TABLE(i) = 0.25*dtinvl*(DTABLE(i+1)-DTABLE(i-1))
      enddo
    ! one-sided derivatives at boundaries

         D2TABLE(1) = 0.50*dtinvl*(DTABLE(2)-DTABLE(1))

         D2TABLE(table_size) = 0.50*dtinvl*&
              (DTABLE(table_size)-DTABLE(table_size-1))
      
   if (construct_table_wrt_liq) then
! compute es tables from tcmin to tcmax
! estimate es derivative with small +/- difference
 
      do i = 1, table_size
        tem(1) = tminl + dtres*real(i-1)
        tem(2) = tem(1)-tinrc
        tem(3) = tem(1)+tinrc
!   pass in flag to force all values to be wrt liquid
        es = compute_es_liq_k (tem, TFREEZE)
        TABLE2(i) = es(1)
        DTABLE2(i) = (es(3)-es(2))*tfact
      enddo
 
! compute one-half second derivative using centered differences
! differencing des values in the table

     do i = 2, table_size-1
       D2TABLE2(i) = 0.25*dtinvl*(DTABLE2(i+1)-DTABLE2(i-1))
     enddo
! one-sided derivatives at boundaries

     D2TABLE2(1) = 0.50*dtinvl*(DTABLE2(2)-DTABLE2(1))

     D2TABLE2(table_size) = 0.50*dtinvl*&
          (DTABLE2(table_size)-DTABLE2(table_size-1))
   endif


   if (construct_table_wrt_liq_and_ice) then
! compute es tables from tcmin to tcmax
! estimate es derivative with small +/- difference
 
      do i = 1, table_size
        tem(1) = tminl + dtres*real(i-1)
        tem(2) = tem(1)-tinrc
        tem(3) = tem(1)+tinrc
!   pass in flag to force all values to be wrt liquid
        es = compute_es_liq_ice_k (tem, TFREEZE)
        TABLE3(i) = es(1)
        DTABLE3(i) = (es(3)-es(2))*tfact
      enddo
 
! compute one-half second derivative using centered differences
! differencing des values in the table

     do i = 2, table_size-1
       D2TABLE3(i) = 0.25*dtinvl*(DTABLE3(i+1)-DTABLE3(i-1))
     enddo
! one-sided derivatives at boundaries

     D2TABLE3(1) = 0.50*dtinvl*(DTABLE3(2)-DTABLE3(1))

     D2TABLE3(table_size) = 0.50*dtinvl*&
          (DTABLE3(table_size)-DTABLE3(table_size-1))
   endif

      use_exact_qs = use_exact_qs_input
      module_is_initialized = .true.

 end subroutine sat_vapor_pres_init_k

!#######################################################################

 function compute_es_k(tem, TFREEZE) result (es)
 real, intent(in) :: tem(:), TFREEZE
 real :: es(size(tem,1))
         
 real    :: x, esice, esh2o, TBASW, TBASI
 integer :: i
 real, parameter :: ESBASW = 101324.60
 real, parameter :: ESBASI =    610.71

   TBASW = TFREEZE+100.
   TBASI = TFREEZE

   do i = 1, size(tem)

!  compute es over ice 

     if (tem(i) < TBASI) then
         x = -9.09718*(TBASI/tem(i)-1.0) - 3.56654*log10(TBASI/tem(i)) &
             +0.876793*(1.0-tem(i)/TBASI) + log10(ESBASI)
         esice =10.**(x)
     else
         esice = 0.
     endif

!  compute es over water greater than -20 c.
!  values over 100 c may not be valid
!  see smithsonian meteorological tables page 350.

     if (tem(i) > -20.+TBASI) then
         x = -7.90298*(TBASW/tem(i)-1.0) + 5.02808*log10(TBASW/tem(i)) &
             -1.3816e-07*(10.0**((1.0-tem(i)/TBASW)*11.344)-1.0)        &
             +8.1328e-03*(10.0**((TBASW/tem(i)-1.0)*(-3.49149))-1.0)    &
             +log10(ESBASW)
         esh2o = 10.**(x)
     else
         esh2o = 0.
     endif

!  derive blended es over ice and supercooled water between -20c and 0c

     if (tem(i) <= -20.+TBASI) then
         es(i) = esice
     else if (tem(i) >= TBASI) then
         es(i) = esh2o
     else
         es(i) = 0.05*((TBASI-tem(i))*esice + (tem(i)-TBASI+20.)*esh2o)
     endif

   enddo

 end function compute_es_k

!#######################################################################

 function compute_es_liq_k(tem, TFREEZE) result (es)
 real, intent(in) :: tem(:), TFREEZE
 real :: es(size(tem,1))
         
 real    :: x, esh2o, TBASW
 integer :: i
 real, parameter :: ESBASW = 101324.60

   TBASW = TFREEZE+100.

   do i = 1, size(tem)


!  compute es over water for all temps.
!  values over 100 c may not be valid
!  see smithsonian meteorological tables page 350.

         x = -7.90298*(TBASW/tem(i)-1.0) + 5.02808*log10(TBASW/tem(i)) &
             -1.3816e-07*(10.0**((1.0-tem(i)/TBASW)*11.344)-1.0)        &
             +8.1328e-03*(10.0**((TBASW/tem(i)-1.0)*(-3.49149))-1.0)    &
             +log10(ESBASW)
         esh2o = 10.**(x)


         es(i) = esh2o

   enddo

 end function compute_es_liq_k

!#######################################################################

 function compute_es_liq_ice_k(tem, TFREEZE) result (es)
 real, intent(in) :: tem(:), TFREEZE
 real :: es(size(tem,1))
         
 real    :: x, TBASW, TBASI
 integer :: i
 real, parameter :: ESBASW = 101324.60
 real, parameter :: ESBASI =    610.71

   TBASW = TFREEZE+100.
   TBASI = TFREEZE

   do i = 1, size(tem)

     if (tem(i) < TBASI) then

!  compute es over ice 

         x = -9.09718*(TBASI/tem(i)-1.0) - 3.56654*log10(TBASI/tem(i)) &
             +0.876793*(1.0-tem(i)/TBASI) + log10(ESBASI)
         es(i) =10.**(x)
     else

!  compute es over water 
!  values over 100 c may not be valid
!  see smithsonian meteorological tables page 350.

         x = -7.90298*(TBASW/tem(i)-1.0) + 5.02808*log10(TBASW/tem(i)) &
             -1.3816e-07*(10.0**((1.0-tem(i)/TBASW)*11.344)-1.0)        &
             +8.1328e-03*(10.0**((TBASW/tem(i)-1.0)*(-3.49149))-1.0)    &
             +log10(ESBASW)
         es(i) = 10.**(x)
     endif

   enddo

 end function compute_es_liq_ice_k

!#######################################################################

 subroutine compute_qs_k_3d (temp, press, eps, zvir, qs, nbad, q, hc, &
                          dqsdT, esat, es_over_liq, es_over_liq_and_ice)

 real, intent(in),  dimension(:,:,:)           :: temp, press   
 real, intent(in)                              :: eps, zvir
 real, intent(out), dimension(:,:,:)           :: qs   
 integer, intent(out)                          :: nbad
 real, intent(in),  dimension(:,:,:), optional :: q
 real, intent(in),                    optional :: hc
 real, intent(out), dimension(:,:,:), optional :: dqsdT, esat
 logical,intent(in),                  optional :: es_over_liq
 logical,intent(in),                  optional :: es_over_liq_and_ice

 real, dimension(size(temp,1), size(temp,2), size(temp,3)) ::   &
                                                  esloc, desat, denom
 integer :: i, j, k
 real    :: hc_loc

   if (present(hc)) then
     hc_loc = hc
   else
     hc_loc = 1.0
   endif
 if (present(es_over_liq)) then
   if (present (dqsdT)) then
     call lookup_es2_des2_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es2_k (temp, esloc, nbad)
   endif
 else if (present(es_over_liq_and_ice)) then
   if (present (dqsdT)) then
     call lookup_es3_des3_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es3_k (temp, esloc, nbad)
   endif
 else
   if (present (dqsdT)) then
     call lookup_es_des_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es_k (temp, esloc, nbad)
   endif
 endif
   esloc = esloc*hc_loc
   if (present (esat)) then
     esat = esloc
   endif 
   if (nbad == 0) then
     if (present (q) .and. use_exact_qs) then
       qs = (1.0 + zvir*q)*eps*esloc/press
       if (present (dqsdT)) then
         dqsdT = (1.0 + zvir*q)*eps*desat/press
       endif
     else  ! (present(q))
       denom = press - (1.0 - eps)*esloc
       do k=1,size(qs,3)
         do j=1,size(qs,2)
           do i=1,size(qs,1)
             if (denom(i,j,k) > 0.0) then
               qs(i,j,k) = eps*esloc(i,j,k)/denom(i,j,k)         
             else
               qs(i,j,k) = eps
             endif
           end do
         end do
       end do
       if (present (dqsdT)) then
         dqsdT = eps*press*desat/denom**2
       endif
     endif ! (present(q))
   else ! (nbad = 0)
     qs = -999.
     if (present (dqsdT)) then
       dqsdT = -999.
     endif
     if (present (esat)) then
       esat = -999.
     endif 
   endif ! (nbad = 0)

     
 end subroutine compute_qs_k_3d

!#######################################################################

 subroutine compute_qs_k_2d (temp, press, eps, zvir, qs, nbad, q, hc, &
                          dqsdT, esat, es_over_liq, es_over_liq_and_ice)

 real, intent(in),  dimension(:,:)           :: temp, press   
 real, intent(in)                            :: eps, zvir
 real, intent(out), dimension(:,:)           :: qs   
 integer, intent(out)                        :: nbad
 real, intent(in),  dimension(:,:), optional :: q
 real, intent(in),                  optional :: hc
 real, intent(out), dimension(:,:), optional :: dqsdT, esat
 logical,intent(in),                optional :: es_over_liq
 logical,intent(in),                  optional :: es_over_liq_and_ice

 real, dimension(size(temp,1), size(temp,2)) :: esloc, desat, denom
 integer :: i, j
 real    :: hc_loc

   if (present(hc)) then
     hc_loc = hc
   else
     hc_loc = 1.0
   endif

 if (present(es_over_liq)) then
   if (present (dqsdT)) then
     call lookup_es2_des2_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es2_k (temp, esloc, nbad)
   endif
 else if (present(es_over_liq_and_ice)) then
   if (present (dqsdT)) then
     call lookup_es3_des3_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es3_k (temp, esloc, nbad)
   endif
 else
   if (present (dqsdT)) then
     call lookup_es_des_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es_k (temp, esloc, nbad)
   endif
 endif
   esloc = esloc*hc_loc
   if (present (esat)) then
     esat = esloc
   endif 
   if (nbad == 0) then
     if (present (q) .and. use_exact_qs) then
       qs = (1.0 + zvir*q)*eps*esloc/press
       if (present (dqsdT)) then
         dqsdT = (1.0 + zvir*q)*eps*desat/press
       endif
     else  ! (present(q))
       denom = press - (1.0 - eps)*esloc
      do j=1,size(qs,2)
        do i=1,size(qs,1)
          if (denom(i,j) > 0.0) then
            qs(i,j) = eps*esloc(i,j)/denom(i,j)
          else
            qs(i,j) = eps
          endif
        end do
      end do
      if (present (dqsdT)) then
        dqsdT = eps*press*desat/denom**2
      endif
    endif ! (present(q))
   else ! (nbad = 0)
     qs = -999.
     if (present (dqsdT)) then
       dqsdT = -999.
     endif
     if (present (esat)) then
       esat = -999.
     endif 
   endif ! (nbad = 0)


 end subroutine compute_qs_k_2d

!#######################################################################

 subroutine compute_qs_k_1d (temp, press, eps, zvir, qs, nbad, q, hc, &
                          dqsdT, esat, es_over_liq, es_over_liq_and_ice)

 real, intent(in),  dimension(:)           :: temp, press   
 real, intent(in)                          :: eps, zvir
 real, intent(out), dimension(:)           :: qs   
 integer, intent(out)                      :: nbad
 real, intent(in),  dimension(:), optional :: q
 real, intent(in),                optional :: hc
 real, intent(out), dimension(:), optional :: dqsdT, esat
 logical,intent(in),              optional :: es_over_liq
 logical,intent(in),                  optional :: es_over_liq_and_ice

 real, dimension(size(temp,1)) :: esloc, desat, denom
 integer :: i
 real    :: hc_loc

   if (present(hc)) then
     hc_loc = hc
   else
     hc_loc = 1.0
   endif

 if (present(es_over_liq)) then
   if (present (dqsdT)) then
     call lookup_es2_des2_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es2_k (temp, esloc, nbad)
   endif
 else if (present(es_over_liq_and_ice)) then
   if (present (dqsdT)) then
     call lookup_es3_des3_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es3_k (temp, esloc, nbad)
   endif
 else
   if (present (dqsdT)) then
     call lookup_es_des_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es_k (temp, esloc, nbad)
   endif
 endif
   esloc = esloc*hc_loc
   if (present (esat)) then
     esat = esloc
   endif 
   if (nbad == 0) then
     if (present (q) .and. use_exact_qs) then
       qs = (1.0 + zvir*q)*eps*esloc/press
       if (present (dqsdT)) then
         dqsdT = (1.0 + zvir*q)*eps*desat/press
       endif
     else  ! (present(q))
       denom = press - (1.0 - eps)*esloc
       do i=1,size(qs,1)
         if (denom(i) >  0.0) then
           qs(i) = eps*esloc(i)/denom(i)
         else
           qs(i) = eps
         endif
       end do
       if (present (dqsdT)) then
         dqsdT = eps*press*desat/denom**2
       endif
     endif ! (present(q))
   else ! (nbad = 0)
     qs = -999.
     if (present (dqsdT)) then
       dqsdT = -999.
     endif
     if (present (esat)) then
       esat = -999.
     endif 
   endif ! (nbad = 0)


 end subroutine compute_qs_k_1d

!#######################################################################

 subroutine compute_qs_k_0d (temp, press, eps, zvir, qs, nbad, q, hc, &
                          dqsdT, esat, es_over_liq, es_over_liq_and_ice)

 real, intent(in)                :: temp, press   
 real, intent(in)                :: eps, zvir
 real, intent(out)               :: qs   
 integer, intent(out)            :: nbad
 real, intent(in),      optional :: q
 real, intent(in),      optional :: hc
 real, intent(out),     optional :: dqsdT, esat
 logical,intent(in),    optional :: es_over_liq
 logical,intent(in),                  optional :: es_over_liq_and_ice

 real    :: esloc, desat, denom
 real    :: hc_loc

   if (present(hc)) then
     hc_loc = hc
   else
     hc_loc = 1.0
   endif

 if (present(es_over_liq)) then
   if (present (dqsdT)) then
     call lookup_es2_des2_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es2_k (temp, esloc, nbad)
   endif
 else if (present(es_over_liq_and_ice)) then
   if (present (dqsdT)) then
     call lookup_es3_des3_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es3_k (temp, esloc, nbad)
   endif
 else
   if (present (dqsdT)) then
     call lookup_es_des_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es_k (temp, esloc, nbad)
   endif
 endif
   esloc = esloc*hc_loc
   if (present (esat)) then
     esat = esloc
   endif 
   if (nbad == 0) then
     if (present (q) .and. use_exact_qs) then
       qs = (1.0 + zvir*q)*eps*esloc/press
       if (present (dqsdT)) then
         dqsdT = (1.0 + zvir*q)*eps*desat/press
       endif
     else  ! (present(q))
       denom = press - (1.0 - eps)*esloc
       if (denom > 0.0) then
         qs = eps*esloc/denom
       else
         qs = eps
       endif
       if (present (dqsdT)) then
         dqsdT = eps*press*desat/denom**2
       endif
     endif ! (present(q))
   else ! (nbad = 0)
     qs = -999.
     if (present (dqsdT)) then
       dqsdT = -999.
     endif
     if (present (esat)) then
       esat = -999.
     endif 
   endif ! (nbad = 0)


 end subroutine compute_qs_k_0d

!#######################################################################

!#######################################################################

 subroutine compute_mrs_k_3d (temp, press, eps, zvir, mrs, nbad,   &
                 mr, hc, dmrsdT, esat,es_over_liq, es_over_liq_and_ice)

 real, intent(in),  dimension(:,:,:)           :: temp, press
 real, intent(in)                              :: eps, zvir
 real, intent(out), dimension(:,:,:)           :: mrs   
 integer, intent(out)                          :: nbad
 real, intent(in),  dimension(:,:,:), optional :: mr
 real, intent(in),                    optional :: hc
 real, intent(out), dimension(:,:,:), optional :: dmrsdT, esat
 logical,intent(in),                  optional :: es_over_liq
 logical,intent(in),                  optional :: es_over_liq_and_ice

 real, dimension(size(temp,1), size(temp,2), size(temp,3)) ::    &
                                                    esloc, desat, denom
 integer :: i, j, k
 real    :: hc_loc

   if (present(hc)) then
     hc_loc = hc
   else
     hc_loc = 1.0
   endif

 if (present (es_over_liq)) then
   if (present (dmrsdT)) then
     call lookup_es2_des2_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es2_k (temp, esloc, nbad)
   endif
 else if (present(es_over_liq_and_ice)) then
   if (present (dmrsdT)) then
     call lookup_es3_des3_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es3_k (temp, esloc, nbad)
   endif
 else
   if (present (dmrsdT)) then
     call lookup_es_des_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es_k (temp, esloc, nbad)
   endif
 endif
   esloc = esloc*hc_loc
   if (present (esat)) then
     esat = esloc
   endif 
   if (nbad == 0) then
     if (present (mr) .and. use_exact_qs) then
       mrs = (eps + mr)*esloc/press
       if (present (dmrsdT)) then
         dmrsdT =  (eps + mr)*desat/press
       endif
     else ! (present (mr))
       denom = press - esloc
       do k=1,size(mrs,3)
         do j=1,size(mrs,2)
           do i=1,size(mrs,1)
             if (denom(i,j,k) > 0.0) then
               mrs(i,j,k) = eps*esloc(i,j,k)/denom(i,j,k) 
             else
               mrs(i,j,k) = eps
             endif
           end do
         end do
       end do
       if (present (dmrsdT)) then
         dmrsdT = eps*press*desat/denom**2
       endif
     endif !(present (mr))
   else
     mrs = -999.
     if (present (dmrsdT)) then
       dmrsdT = -999.
     endif
     if (present (esat)) then
       esat = -999.
     endif 
   endif

     
 end subroutine compute_mrs_k_3d

!#######################################################################

 subroutine compute_mrs_k_2d (temp, press, eps, zvir, mrs, nbad,  &
                 mr, hc, dmrsdT, esat,es_over_liq, es_over_liq_and_ice)

 real, intent(in),  dimension(:,:)           :: temp, press
 real, intent(in)                            :: eps, zvir
 real, intent(out), dimension(:,:)           :: mrs   
 integer, intent(out)                        :: nbad
 real, intent(in), dimension(:,:), optional  :: mr
 real, intent(in),                 optional :: hc
 real, intent(out), dimension(:,:), optional :: dmrsdT, esat
 logical,intent(in),               optional :: es_over_liq
 logical,intent(in),                  optional :: es_over_liq_and_ice

 real, dimension(size(temp,1), size(temp,2)) :: esloc, desat, denom
 integer :: i, j
 real    :: hc_loc

   if (present(hc)) then
     hc_loc = hc
   else
     hc_loc = 1.0
   endif

 if (present (es_over_liq)) then
   if (present (dmrsdT)) then
     call lookup_es2_des2_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es2_k (temp, esloc, nbad)
   endif
 else if (present(es_over_liq_and_ice)) then
   if (present (dmrsdT)) then
     call lookup_es3_des3_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es3_k (temp, esloc, nbad)
   endif
 else
   if (present (dmrsdT)) then
     call lookup_es_des_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es_k (temp, esloc, nbad)
   endif
 endif
   esloc = esloc*hc_loc
   if (present (esat)) then
     esat = esloc
   endif 
   if (nbad == 0) then
     if (present (mr) .and. use_exact_qs) then
       mrs = (eps + mr)*esloc/press
       if (present (dmrsdT)) then
         dmrsdT = (eps + mr)*desat/press
       endif
     else ! (present (mr))
       denom = press - esloc
       do j=1,size(mrs,2)
         do i=1,size(mrs,1)
           if (denom(i,j) > 0.0) then
             mrs(i,j) = eps*esloc(i,j)/denom(i,j) 
           else
             mrs(i,j) = eps
           endif
         end do
       end do
       if (present (dmrsdT)) then
         dmrsdT = eps*press*desat/denom**2
       endif
     endif !(present (mr))
   else
     mrs = -999.
     if (present (dmrsdT)) then
       dmrsdT = -999.
     endif
     if (present (esat)) then
       esat = -999.
     endif 
   endif


 end subroutine compute_mrs_k_2d

!#######################################################################

 subroutine compute_mrs_k_1d (temp, press, eps, zvir, mrs, nbad,  &
                 mr, hc, dmrsdT, esat,es_over_liq, es_over_liq_and_ice)

 real, intent(in),  dimension(:)           :: temp, press
 real, intent(in)                          :: eps, zvir
 real, intent(out), dimension(:)           :: mrs   
 integer, intent(out)                      :: nbad
 real, intent(in),  dimension(:), optional :: mr
 real, intent(in),                optional :: hc
 real, intent(out), dimension(:), optional :: dmrsdT, esat
 logical,intent(in),              optional :: es_over_liq
 logical,intent(in),                  optional :: es_over_liq_and_ice

 real, dimension(size(temp,1)) :: esloc, desat, denom
 integer :: i
 real    :: hc_loc

   if (present(hc)) then
     hc_loc = hc
   else
     hc_loc = 1.0
   endif

 if (present (es_over_liq)) then
   if (present (dmrsdT)) then
     call lookup_es2_des2_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es2_k (temp, esloc, nbad)
   endif
 else if (present(es_over_liq_and_ice)) then
   if (present (dmrsdT)) then
     call lookup_es3_des3_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es3_k (temp, esloc, nbad)
   endif
 else
   if (present (dmrsdT)) then
     call lookup_es_des_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es_k (temp, esloc, nbad)
   endif
 endif
   esloc = esloc*hc_loc
   if (present (esat)) then
     esat = esloc
   endif 
   if (nbad == 0) then
     if (present (mr) .and. use_exact_qs) then
       mrs = (eps + mr)*esloc/press
       if (present (dmrsdT)) then
         dmrsdT =  (eps + mr)*desat/press
       endif
     else ! (present (mr))
       denom = press - esloc
       do i=1,size(mrs,1)
         if (denom(i) > 0.0) then
           mrs(i) = eps*esloc(i)/denom(i) 
         else
           mrs(i) = eps
         endif
       end do
       if (present (dmrsdT)) then
         dmrsdT = eps*press*desat/denom**2
       endif
     endif !(present (mr))
   else
     mrs = -999.
     if (present (dmrsdT)) then
       dmrsdT = -999.
     endif
     if (present (esat)) then
       esat = -999.
     endif 
   endif


 end subroutine compute_mrs_k_1d

!#######################################################################

 subroutine compute_mrs_k_0d (temp, press, eps, zvir, mrs, nbad,   &
                 mr, hc, dmrsdT, esat,es_over_liq, es_over_liq_and_ice)

 real, intent(in)                              :: temp, press
 real, intent(in)                              :: eps, zvir
 real, intent(out)                             :: mrs   
 integer, intent(out)                          :: nbad
 real, intent(in),                    optional :: mr
 real, intent(in),                    optional :: hc
 real, intent(out),                   optional :: dmrsdT, esat
 logical,intent(in),                  optional :: es_over_liq
 logical,intent(in),                  optional :: es_over_liq_and_ice

 real    :: esloc, desat, denom
 real    :: hc_loc

   if (present(hc)) then
     hc_loc = hc
   else
     hc_loc = 1.0
   endif

 if (present (es_over_liq)) then
   if (present (dmrsdT)) then
     call lookup_es2_des2_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es2_k (temp, esloc, nbad)
   endif
 else if (present(es_over_liq_and_ice)) then
   if (present (dmrsdT)) then
     call lookup_es3_des3_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es3_k (temp, esloc, nbad)
   endif
 else
   if (present (dmrsdT)) then
     call lookup_es_des_k (temp, esloc, desat, nbad)
     desat = desat*hc_loc
   else
     call lookup_es_k (temp, esloc, nbad)
   endif
 endif
   esloc = esloc*hc_loc
   if (present (esat)) then
     esat = esloc
   endif 
   if (nbad == 0) then
     if (present (mr) .and. use_exact_qs) then
       mrs = (eps + mr)*esloc/press
       if (present (dmrsdT)) then
         dmrsdT = (eps + mr)*desat/press
       endif
     else ! (present (mr))
       denom = press - esloc
       if (denom > 0.0) then
         mrs = eps*esloc/denom 
       else
         mrs = eps       
       endif
       if (present (dmrsdT)) then
         dmrsdT = eps*press*desat/denom**2
       endif
     endif !(present (mr))
   else
     mrs = -999.
     if (present (dmrsdT)) then
       dmrsdT = -999.
     endif
     if (present (esat)) then
       esat = -999.
     endif 
   endif


 end subroutine compute_mrs_k_0d



!#######################################################################

 subroutine lookup_es_des_k_3d (temp, esat, desat, nbad)
 real, intent(in),  dimension(:,:,:)  :: temp
 real, intent(out), dimension(:,:,:)  :: esat, desat
 integer, intent(out)                 :: nbad

 real    :: tmp, del
 integer :: ind, i, j, k

   nbad = 0
   do k = 1, size(temp,3)
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j,k)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz) then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i,j,k) = TABLE(ind+1) +  &
                     del*(DTABLE(ind+1) + del*D2TABLE(ind+1))
       desat(i,j,k) = DTABLE(ind+1) + 2.*del*D2TABLE(ind+1)
     endif
   enddo
   enddo
   enddo

 end subroutine lookup_es_des_k_3d

!#######################################################################

 subroutine lookup_es_des_k_2d (temp, esat, desat, nbad)
 real, intent(in),  dimension(:,:)  :: temp
 real, intent(out), dimension(:,:)  :: esat, desat
 integer, intent(out)               :: nbad

 real    :: tmp, del
 integer :: ind, i, j

   nbad = 0
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i,j) = TABLE(ind+1) + &
                   del*(DTABLE(ind+1) + del*D2TABLE(ind+1))
       desat(i,j) = DTABLE(ind+1) + 2.*del*D2TABLE(ind+1)
     endif
   enddo
   enddo

 end subroutine lookup_es_des_k_2d

!#######################################################################

 subroutine lookup_es_des_k_1d (temp, esat, desat, nbad)
 real, intent(in),  dimension(:)  :: temp
 real, intent(out), dimension(:)  :: esat, desat
 integer, intent(out)             :: nbad

 real    :: tmp, del
 integer :: ind, i

   nbad = 0
   do i = 1, size(temp,1)
     tmp = temp(i)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i) = TABLE(ind+1) + &
                   del*(DTABLE(ind+1) + del*D2TABLE(ind+1))
       desat(i) = DTABLE(ind+1) + 2.*del*D2TABLE(ind+1)
     endif
   enddo

 end subroutine lookup_es_des_k_1d

!#######################################################################

 subroutine lookup_es_des_k_0d (temp, esat, desat, nbad)
 real, intent(in)     :: temp
 real, intent(out)    :: esat, desat
 integer, intent(out) :: nbad

 real    :: tmp, del
 integer :: ind

   nbad = 0
   tmp = temp-tminl
   ind = int(dtinvl*(tmp+tepsl))
   if (ind < 0 .or. ind >= table_siz)  then
     nbad = nbad+1
   else
     del = tmp-dtres*real(ind)
     esat = TABLE(ind+1) + &
            del*(DTABLE(ind+1) + del*D2TABLE(ind+1))
     desat = DTABLE(ind+1) + 2.*del*D2TABLE(ind+1)
   endif

 end subroutine lookup_es_des_k_0d

!#######################################################################

 subroutine lookup_es_k_3d(temp, esat, nbad)
 real, intent(in),  dimension(:,:,:)  :: temp
 real, intent(out), dimension(:,:,:)  :: esat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i, j, k

   nbad = 0
   do k = 1, size(temp,3)
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j,k)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i,j,k) = TABLE(ind+1) + &
                     del*(DTABLE(ind+1) + del*D2TABLE(ind+1))
     endif
   enddo
   enddo
   enddo

 end subroutine lookup_es_k_3d

!#######################################################################

 subroutine lookup_des_k_3d(temp, desat, nbad)
 real, intent(in),  dimension(:,:,:)  :: temp
 real, intent(out), dimension(:,:,:)  :: desat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i, j, k

   nbad = 0
   do k = 1, size(temp,3)
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j,k)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       desat(i,j,k) = DTABLE(ind+1) + 2.*del*D2TABLE(ind+1)
     endif
   enddo
   enddo
   enddo

 end subroutine lookup_des_k_3d

!#######################################################################
 subroutine lookup_des_k_2d(temp, desat, nbad)
 real, intent(in),  dimension(:,:)  :: temp
 real, intent(out), dimension(:,:)  :: desat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i, j

   nbad = 0
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       desat(i,j) = DTABLE(ind+1) + 2.*del*D2TABLE(ind+1)
     endif
   enddo
   enddo

 end subroutine lookup_des_k_2d
!#######################################################################
 subroutine lookup_es_k_2d(temp, esat, nbad)
 real, intent(in),  dimension(:,:)  :: temp
 real, intent(out), dimension(:,:)  :: esat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i, j

   nbad = 0
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i,j) = TABLE(ind+1) + del*(DTABLE(ind+1) +   &
                                                  del*D2TABLE(ind+1))
     endif
   enddo
   enddo

 end subroutine lookup_es_k_2d
!#######################################################################
 subroutine lookup_des_k_1d(temp, desat, nbad)
 real, intent(in),  dimension(:)  :: temp
 real, intent(out), dimension(:)  :: desat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i

   nbad = 0
   do i = 1, size(temp,1)
     tmp = temp(i)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       desat(i) = DTABLE(ind+1) + 2.*del*D2TABLE(ind+1)
     endif 
   enddo

 end subroutine lookup_des_k_1d
!#######################################################################
 subroutine lookup_es_k_1d(temp, esat, nbad)
 real, intent(in),  dimension(:)  :: temp
 real, intent(out), dimension(:)  :: esat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i

   nbad = 0
   do i = 1, size(temp,1)
     tmp = temp(i)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i) = TABLE(ind+1) + del*(DTABLE(ind+1) + del*D2TABLE(ind+1))
     endif
   enddo

 end subroutine lookup_es_k_1d
!#######################################################################
 subroutine lookup_des_k_0d(temp, desat, nbad)
 real, intent(in)     :: temp
 real, intent(out)    :: desat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind

   nbad = 0
   tmp = temp-tminl
   ind = int(dtinvl*(tmp+tepsl))
   if (ind < 0 .or. ind >= table_siz)  then
     nbad = nbad+1
   else
     del = tmp-dtres*real(ind)
     desat = DTABLE(ind+1) + 2.*del*D2TABLE(ind+1)
   endif 

 end subroutine lookup_des_k_0d
!#######################################################################
 subroutine lookup_es_k_0d(temp, esat, nbad)
 real, intent(in)     :: temp
 real, intent(out)    :: esat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind

   nbad = 0
   tmp = temp-tminl
   ind = int(dtinvl*(tmp+tepsl))
   if (ind < 0 .or. ind >= table_siz)  then
     nbad = nbad+1
   else
     del = tmp-dtres*real(ind)
     esat = TABLE(ind+1) + del*(DTABLE(ind+1) + del*D2TABLE(ind+1))
   endif 

 end subroutine lookup_es_k_0d
!#######################################################################

 subroutine lookup_es2_des2_k_3d (temp, esat, desat, nbad)
 real, intent(in),  dimension(:,:,:)  :: temp
 real, intent(out), dimension(:,:,:)  :: esat, desat
 integer, intent(out)                 :: nbad

 real    :: tmp, del
 integer :: ind, i, j, k

   nbad = 0
   do k = 1, size(temp,3)
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j,k)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz) then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i,j,k) = TABLE2(ind+1) +  &
                     del*(DTABLE2(ind+1) + del*D2TABLE2(ind+1))
       desat(i,j,k) = DTABLE2(ind+1) + 2.*del*D2TABLE2(ind+1)
     endif
   enddo
   enddo
   enddo

 end subroutine lookup_es2_des2_k_3d

!#######################################################################

 subroutine lookup_es2_des2_k_2d (temp, esat, desat, nbad)
 real, intent(in),  dimension(:,:)  :: temp
 real, intent(out), dimension(:,:)  :: esat, desat
 integer, intent(out)               :: nbad

 real    :: tmp, del
 integer :: ind, i, j

   nbad = 0
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i,j) = TABLE2(ind+1) + &
                   del*(DTABLE2(ind+1) + del*D2TABLE2(ind+1))
       desat(i,j) = DTABLE2(ind+1) + 2.*del*D2TABLE2(ind+1)
     endif
   enddo
   enddo

 end subroutine lookup_es2_des2_k_2d

!#######################################################################

 subroutine lookup_es2_des2_k_1d (temp, esat, desat, nbad)
 real, intent(in),  dimension(:)  :: temp
 real, intent(out), dimension(:)  :: esat, desat
 integer, intent(out)             :: nbad

 real    :: tmp, del
 integer :: ind, i

   nbad = 0
   do i = 1, size(temp,1)
     tmp = temp(i)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i) = TABLE2(ind+1) + &
                   del*(DTABLE2(ind+1) + del*D2TABLE2(ind+1))
       desat(i) = DTABLE2(ind+1) + 2.*del*D2TABLE2(ind+1)
     endif
   enddo

 end subroutine lookup_es2_des2_k_1d

!#######################################################################

 subroutine lookup_es2_des2_k_0d (temp, esat, desat, nbad)
 real, intent(in)     :: temp
 real, intent(out)    :: esat, desat
 integer, intent(out) :: nbad

 real    :: tmp, del
 integer :: ind

   nbad = 0
   tmp = temp-tminl
   ind = int(dtinvl*(tmp+tepsl))
   if (ind < 0 .or. ind >= table_siz)  then
     nbad = nbad+1
   else
     del = tmp-dtres*real(ind)
     esat = TABLE2(ind+1) + &
            del*(DTABLE2(ind+1) + del*D2TABLE2(ind+1))
     desat = DTABLE2(ind+1) + 2.*del*D2TABLE2(ind+1)
   endif

 end subroutine lookup_es2_des2_k_0d

!#######################################################################

 subroutine lookup_es2_k_3d(temp, esat, nbad)
 real, intent(in),  dimension(:,:,:)  :: temp
 real, intent(out), dimension(:,:,:)  :: esat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i, j, k

   nbad = 0
   do k = 1, size(temp,3)
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j,k)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i,j,k) = TABLE2(ind+1) + &
                     del*(DTABLE2(ind+1) + del*D2TABLE2(ind+1))
     endif
   enddo
   enddo
   enddo

 end subroutine lookup_es2_k_3d

!#######################################################################

 subroutine lookup_des2_k_3d(temp, desat, nbad)
 real, intent(in),  dimension(:,:,:)  :: temp
 real, intent(out), dimension(:,:,:)  :: desat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i, j, k

   nbad = 0
   do k = 1, size(temp,3)
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j,k)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       desat(i,j,k) = DTABLE2(ind+1) + 2.*del*D2TABLE2(ind+1)
     endif
   enddo
   enddo
   enddo

 end subroutine lookup_des2_k_3d

!#######################################################################
 subroutine lookup_des2_k_2d(temp, desat, nbad)
 real, intent(in),  dimension(:,:)  :: temp
 real, intent(out), dimension(:,:)  :: desat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i, j

   nbad = 0
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       desat(i,j) = DTABLE2(ind+1) + 2.*del*D2TABLE2(ind+1)
     endif
   enddo
   enddo

 end subroutine lookup_des2_k_2d
!#######################################################################
 subroutine lookup_es2_k_2d(temp, esat, nbad)
 real, intent(in),  dimension(:,:)  :: temp
 real, intent(out), dimension(:,:)  :: esat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i, j

   nbad = 0
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i,j) = TABLE2(ind+1) + del*(DTABLE2(ind+1) +   &
                                                  del*D2TABLE2(ind+1))
     endif
   enddo
   enddo

 end subroutine lookup_es2_k_2d
!#######################################################################
 subroutine lookup_des2_k_1d(temp, desat, nbad)
 real, intent(in),  dimension(:)  :: temp
 real, intent(out), dimension(:)  :: desat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i

   nbad = 0
   do i = 1, size(temp,1)
     tmp = temp(i)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       desat(i) = DTABLE2(ind+1) + 2.*del*D2TABLE2(ind+1)
     endif 
   enddo

 end subroutine lookup_des2_k_1d
!#######################################################################
 subroutine lookup_es2_k_1d(temp, esat, nbad)
 real, intent(in),  dimension(:)  :: temp
 real, intent(out), dimension(:)  :: esat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i

   nbad = 0
   do i = 1, size(temp,1)
     tmp = temp(i)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i) = TABLE2(ind+1) + del*(DTABLE2(ind+1) + del*D2TABLE2(ind+1))
     endif
   enddo

 end subroutine lookup_es2_k_1d
!#######################################################################
 subroutine lookup_des2_k_0d(temp, desat, nbad)
 real, intent(in)     :: temp
 real, intent(out)    :: desat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind

   nbad = 0
   tmp = temp-tminl
   ind = int(dtinvl*(tmp+tepsl))
   if (ind < 0 .or. ind >= table_siz)  then
     nbad = nbad+1
   else
     del = tmp-dtres*real(ind)
     desat = DTABLE2(ind+1) + 2.*del*D2TABLE2(ind+1)
   endif 

 end subroutine lookup_des2_k_0d
!#######################################################################
 subroutine lookup_es2_k_0d(temp, esat, nbad)
 real, intent(in)     :: temp
 real, intent(out)    :: esat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind

   nbad = 0
   tmp = temp-tminl
   ind = int(dtinvl*(tmp+tepsl))
   if (ind < 0 .or. ind >= table_siz)  then
     nbad = nbad+1
   else
     del = tmp-dtres*real(ind)
     esat = TABLE2(ind+1) + del*(DTABLE2(ind+1) + del*D2TABLE2(ind+1))
   endif 

 end subroutine lookup_es2_k_0d
!#######################################################################

!#######################################################################

 subroutine lookup_es3_des3_k_3d (temp, esat, desat, nbad)
 real, intent(in),  dimension(:,:,:)  :: temp
 real, intent(out), dimension(:,:,:)  :: esat, desat
 integer, intent(out)                 :: nbad

 real    :: tmp, del
 integer :: ind, i, j, k

   nbad = 0
   do k = 1, size(temp,3)
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j,k)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz) then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i,j,k) = TABLE3(ind+1) +  &
                     del*(DTABLE3(ind+1) + del*D2TABLE3(ind+1))
       desat(i,j,k) = DTABLE3(ind+1) + 2.*del*D2TABLE3(ind+1)
     endif
   enddo
   enddo
   enddo

 end subroutine lookup_es3_des3_k_3d

!#######################################################################

 subroutine lookup_es3_des3_k_2d (temp, esat, desat, nbad)
 real, intent(in),  dimension(:,:)  :: temp
 real, intent(out), dimension(:,:)  :: esat, desat
 integer, intent(out)               :: nbad

 real    :: tmp, del
 integer :: ind, i, j

   nbad = 0
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i,j) = TABLE3(ind+1) + &
                   del*(DTABLE3(ind+1) + del*D2TABLE3(ind+1))
       desat(i,j) = DTABLE3(ind+1) + 2.*del*D2TABLE3(ind+1)
     endif
   enddo
   enddo

 end subroutine lookup_es3_des3_k_2d

!#######################################################################

 subroutine lookup_es3_des3_k_1d (temp, esat, desat, nbad)
 real, intent(in),  dimension(:)  :: temp
 real, intent(out), dimension(:)  :: esat, desat
 integer, intent(out)             :: nbad

 real    :: tmp, del
 integer :: ind, i

   nbad = 0
   do i = 1, size(temp,1)
     tmp = temp(i)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i) = TABLE3(ind+1) + &
                   del*(DTABLE3(ind+1) + del*D2TABLE3(ind+1))
       desat(i) = DTABLE3(ind+1) + 2.*del*D2TABLE3(ind+1)
     endif
   enddo

 end subroutine lookup_es3_des3_k_1d

!#######################################################################

 subroutine lookup_es3_des3_k_0d (temp, esat, desat, nbad)
 real, intent(in)     :: temp
 real, intent(out)    :: esat, desat
 integer, intent(out) :: nbad

 real    :: tmp, del
 integer :: ind

   nbad = 0
   tmp = temp-tminl
   ind = int(dtinvl*(tmp+tepsl))
   if (ind < 0 .or. ind >= table_siz)  then
     nbad = nbad+1
   else
     del = tmp-dtres*real(ind)
     esat = TABLE3(ind+1) + &
            del*(DTABLE3(ind+1) + del*D2TABLE3(ind+1))
     desat = DTABLE3(ind+1) + 2.*del*D2TABLE3(ind+1)
   endif

 end subroutine lookup_es3_des3_k_0d

!#######################################################################

 subroutine lookup_es3_k_3d(temp, esat, nbad)
 real, intent(in),  dimension(:,:,:)  :: temp
 real, intent(out), dimension(:,:,:)  :: esat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i, j, k

   nbad = 0
   do k = 1, size(temp,3)
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j,k)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i,j,k) = TABLE3(ind+1) + &
                     del*(DTABLE3(ind+1) + del*D2TABLE3(ind+1))
     endif
   enddo
   enddo
   enddo

 end subroutine lookup_es3_k_3d

!#######################################################################

 subroutine lookup_des3_k_3d(temp, desat, nbad)
 real, intent(in),  dimension(:,:,:)  :: temp
 real, intent(out), dimension(:,:,:)  :: desat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i, j, k

   nbad = 0
   do k = 1, size(temp,3)
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j,k)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       desat(i,j,k) = DTABLE3(ind+1) + 2.*del*D2TABLE3(ind+1)
     endif
   enddo
   enddo
   enddo

 end subroutine lookup_des3_k_3d

!#######################################################################
 subroutine lookup_des3_k_2d(temp, desat, nbad)
 real, intent(in),  dimension(:,:)  :: temp
 real, intent(out), dimension(:,:)  :: desat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i, j

   nbad = 0
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       desat(i,j) = DTABLE3(ind+1) + 2.*del*D2TABLE3(ind+1)
     endif
   enddo
   enddo

 end subroutine lookup_des3_k_2d
!#######################################################################
 subroutine lookup_es3_k_2d(temp, esat, nbad)
 real, intent(in),  dimension(:,:)  :: temp
 real, intent(out), dimension(:,:)  :: esat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i, j

   nbad = 0
   do j = 1, size(temp,2)
   do i = 1, size(temp,1)
     tmp = temp(i,j)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i,j) = TABLE3(ind+1) + del*(DTABLE3(ind+1) +   &
                                                  del*D2TABLE3(ind+1))
     endif
   enddo
   enddo

 end subroutine lookup_es3_k_2d
!#######################################################################
 subroutine lookup_des3_k_1d(temp, desat, nbad)
 real, intent(in),  dimension(:)  :: temp
 real, intent(out), dimension(:)  :: desat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i

   nbad = 0
   do i = 1, size(temp,1)
     tmp = temp(i)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       desat(i) = DTABLE3(ind+1) + 2.*del*D2TABLE3(ind+1)
     endif 
   enddo

 end subroutine lookup_des3_k_1d
!#######################################################################
 subroutine lookup_es3_k_1d(temp, esat, nbad)
 real, intent(in),  dimension(:)  :: temp
 real, intent(out), dimension(:)  :: esat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind, i

   nbad = 0
   do i = 1, size(temp,1)
     tmp = temp(i)-tminl
     ind = int(dtinvl*(tmp+tepsl))
     if (ind < 0 .or. ind >= table_siz)  then
       nbad = nbad+1
     else
       del = tmp-dtres*real(ind)
       esat(i) = TABLE3(ind+1) + del*(DTABLE3(ind+1) + del*D2TABLE3(ind+1))
     endif
   enddo

 end subroutine lookup_es3_k_1d
!#######################################################################
 subroutine lookup_des3_k_0d(temp, desat, nbad)
 real, intent(in)     :: temp
 real, intent(out)    :: desat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind

   nbad = 0
   tmp = temp-tminl
   ind = int(dtinvl*(tmp+tepsl))
   if (ind < 0 .or. ind >= table_siz)  then
     nbad = nbad+1
   else
     del = tmp-dtres*real(ind)
     desat = DTABLE3(ind+1) + 2.*del*D2TABLE3(ind+1)
   endif 

 end subroutine lookup_des3_k_0d
!#######################################################################
 subroutine lookup_es3_k_0d(temp, esat, nbad)
 real, intent(in)     :: temp
 real, intent(out)    :: esat
 integer, intent(out) :: nbad
 real    :: tmp, del
 integer :: ind

   nbad = 0
   tmp = temp-tminl
   ind = int(dtinvl*(tmp+tepsl))
   if (ind < 0 .or. ind >= table_siz)  then
     nbad = nbad+1
   else
     del = tmp-dtres*real(ind)
     esat = TABLE3(ind+1) + del*(DTABLE3(ind+1) + del*D2TABLE3(ind+1))
   endif 

 end subroutine lookup_es3_k_0d
!#######################################################################
 end module sat_vapor_pres_k_mod

module ocean_grids_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Zhi Liang 
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> M.J. Harrison 
!</REVIEWER>
!
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
! S.M. Griffies 
! </REVIEWER>
!
!<OVERVIEW>
! Set up the ocean model grid spacing 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module sets up the ocean model grid based on information read in 
! from the grid_spec.nc file. It translates the generic names from the 
! grid_spec.nc file to the names used by MOM. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies, M.J. Harrison, A. Rosati, and R.C. Pacanowski 
! A Technical Guide to MOM4 (2003)
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_grids_nml">
!
!  <DATA NAME="read_rho0_profile" TYPE="logical">
!  To read in an initial rho0(k) profile to assist in defining the 
!  initial settings for the pressure increments dst, for use in 
!  setting the pressure-based vertical coordinate grids.  Ideally,
!  this profile is determined by the level averaged density in 
!  the initial conditions. Note that it is essential to have 
!  rho0_profile have a sensible value at all depths even if there
!  is no water there, since there are places where we divide by 
!  rho0_profile in rock.  Also, be mindful that with denser water 
!  at depth, the pressure levels will be coarser at depth than if 
!  using the trivial density profile rho0(k)=rho0. 
!  This option is experimental, so it is recommended that user
!  maintain the default read_rho0_profile=.false.  
!  </DATA> 
!
!  <DATA NAME="do_bitwise_exact_sum" TYPE="logical">
!  Set true to do bitwise exact global sum. When it is false, the global
!  sum will be non-bitwise_exact, but will significantly increase efficiency. 
!  The default value is do_bitwise_exact_sum=.false.
!  </DATA> 
!
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging. Note that most of the debugging stuff 
!  has been removed, but keep flag around in case need in future.
!  </DATA> 
!
!  <DATA NAME="verbose_init" TYPE="logical">
!  Prints out lots of initial checksums.  Useful to have on, so 
!  defaulted to true. 
!   </DATA> 
!
! </NAMELIST>
!
use constants_mod,     only: pi, radian, radius, epsln, c2dbars, deg_to_rad
use diag_manager_mod,  only: diag_axis_init, set_diag_global_att
use diag_manager_mod,  only: register_static_field, send_data
use fms_mod,           only: write_version_number
use fms_mod,           only: read_data, write_data
use fms_mod,           only: open_namelist_file, close_file, check_nml_error
use fms_mod,           only: file_exist, field_exist, field_size, get_global_att_value
use mpp_domains_mod,   only: mpp_update_domains, domain2d
use mpp_domains_mod,   only: mpp_global_sum, CORNER, EAST, NORTH, XUPDATE
use mpp_domains_mod,   only: NON_BITWISE_EXACT_SUM, BITWISE_EXACT_SUM
use mpp_domains_mod,   only: mpp_define_domains, mpp_get_domain_extents, mpp_deallocate_domain
use mpp_domains_mod,   only: mpp_get_compute_domain, mpp_get_data_domain, mpp_get_global_domain
use mpp_mod,           only: input_nml_file, stdout, stdlog, mpp_error, mpp_sum, FATAL, NOTE, mpp_pe
use mosaic_mod,        only: get_mosaic_ntiles, get_mosaic_ncontacts, get_mosaic_contact

use ocean_domains_mod,    only: get_local_indices, get_global_indices, get_halo_sizes, get_domain_offsets
use ocean_parameters_mod, only: GEOPOTENTIAL, ZSTAR, ZSIGMA, PRESSURE, PSTAR, PSIGMA
use ocean_parameters_mod, only: PRESSURE_BASED, DEPTH_BASED
use ocean_parameters_mod, only: MOM_BGRID, MOM_CGRID 
use ocean_parameters_mod, only: missing_value, rho0, grav
use ocean_types_mod,      only: ocean_grid_type, ocean_time_type, ocean_domain_type
use ocean_workspace_mod,  only: wrk1_2d 
use ocean_util_mod,       only: diagnose_2d_u, diagnose_3d_u, diagnose_2d, diagnose_3d, write_chksum_2d

implicit none

private

#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS
integer, parameter :: xhalo=1
integer, parameter :: yhalo=1
#else
integer, private   :: xhalo
integer, private   :: yhalo
#endif

! for diagnostics 
integer :: id_ht          =-1
integer :: id_hu          =-1
integer :: id_dht_dx      =-1
integer :: id_dht_dy      =-1
integer :: id_gradH       =-1
integer :: id_kmt         =-1
integer :: id_kmu         =-1
integer :: id_tmask       =-1
integer :: id_umask       =-1
integer :: id_tmasken(2)  =-1

integer :: id_dxt=-1
integer :: id_dxu=-1
integer :: id_dyt=-1
integer :: id_dyu=-1
integer :: id_dxtn=-1
integer :: id_dyte=-1

logical :: used

character(len=128) :: version=&
     '$Id: ocean_grids.F90,v 20.0 2013/12/14 00:10:44 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

public ocean_grids_init
public set_ocean_grid_size
public set_ocean_hgrid_arrays
public set_ocean_vgrid_arrays
public init_grids_diag
public update_boundaries

private axes_info


! for setting dst with pressure-based vertical coordinate models 
real, allocatable, dimension(:) :: rho0_profile 

integer :: vert_coordinate 
integer :: vert_coordinate_class
integer :: horz_grid 

logical :: module_is_initialized = .FALSE.

! for bitwise exact global sums independent of PE number
logical :: do_bitwise_exact_sum = .false.
integer :: global_sum_flag

!mosaic         
integer             :: grid_version 
integer, parameter  :: VERSION_0 = 0  ! grid file with field geolon_t
integer, parameter  :: VERSION_1 = 1  ! grid file with field x_T
integer, parameter  :: VERSION_2 = 2  ! mosaic file

! nml variables 
logical :: debug_this_module = .false.
logical :: verbose_init      = .true.
logical :: read_rho0_profile = .false. 
logical :: write_grid        = .false.

namelist /ocean_grids_nml/ debug_this_module, verbose_init, read_rho0_profile, &
                           do_bitwise_exact_sum, write_grid

! grid file name
character(len=256) :: ocean_hgrid        ! will be set in set_ocean_grid_size
character(len=256) :: ocean_vgrid = 'INPUT/ocean_vgrid.nc'

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_grids_init">
!
! <DESCRIPTION>
! Initialize the grids module. 
! </DESCRIPTION>
!
subroutine ocean_grids_init(ver_coordinate, ver_coordinate_class, hor_grid, debug)

  integer, intent(in)           :: ver_coordinate
  integer, intent(in)           :: ver_coordinate_class
  integer, intent(in)           :: hor_grid 
  logical, intent(in), optional :: debug

  integer :: ioun, io_status, ierr
  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then
    call mpp_error(FATAL, '==>Error from ocean_grids_mod (ocean_grids_init): module has been initialized')
  endif 

  module_is_initialized = .TRUE.

  vert_coordinate       = ver_coordinate 
  vert_coordinate_class = ver_coordinate_class
  horz_grid             = hor_grid  

  call write_version_number(version, tagname)

  if (PRESENT(debug)) debug_this_module = debug

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_grids_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_grids_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_grids_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status, 'ocean_grids_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_grids_nml)  
  write (stdlogunit,ocean_grids_nml)

  if(do_bitwise_exact_sum) then
     global_sum_flag = BITWISE_EXACT_SUM
  else
     global_sum_flag = NON_BITWISE_EXACT_SUM
  endif


end subroutine ocean_grids_init
! </SUBROUTINE> NAME="ocean_grids_init"


!#######################################################################
! <SUBROUTINE NAME="set_ocean_grid_size">
!
! <DESCRIPTION>
! Set the ocean grid size.  Model expects the grid specification file
! to be called grid_spec.nc.  
! </DESCRIPTION>
!
subroutine set_ocean_grid_size(Grid, grid_file, grid_name)

  type(ocean_grid_type), intent(inout)        :: Grid
  character(len=*),      intent(in), optional :: grid_file
  character(len=*),      intent(in), optional :: grid_name

  integer                                   :: siz(4)
  integer                                   :: m
  integer                                   :: ntiles, ncontacts
  integer, dimension(2)                     :: tile1, tile2
  integer, dimension(2)                     :: istart1, iend1, jstart1, jend1
  integer, dimension(2)                     :: istart2, iend2, jstart2, jend2
  character(len=256)                        :: grd_file, ocean_mosaic, attvalue
  real                                      :: f_plane_latitude
  
  integer :: stdoutunit 
  stdoutunit=stdout() 

  Grid%ni=0 ; Grid%nj=0 ; Grid%nk=0 
  Grid%mosaic = .false.
  grd_file = "INPUT/grid_spec.nc"
  if(present(grid_file)) grd_file = grid_file
  if (.not. file_exist(grd_file) ) then 
       call mpp_error(FATAL, '==> Error from ocean_grids_mod(set_ocean_grid_size): '// &
                             'grid specification file '//grd_file//' does not exist')
  endif 
  !
  !  Determine if the grid is mosaic file
  !
  if(field_exist(grd_file, 'ocn_mosaic_file') .or. field_exist(grd_file, 'gridfiles') ) then ! read from mosaic file
     write(stdoutunit,*) '==>Note from ocean_grids_mod(set_ocean_grid_size): read grid from mosaic version grid'
     grid_version = VERSION_2
     Grid%mosaic = .true.
     if( field_exist(grd_file, 'ocn_mosaic_file') ) then ! coupler mosaic
        call read_data(grd_file, "ocn_mosaic_file", ocean_mosaic)
        ocean_mosaic = "INPUT/"//trim(ocean_mosaic)
     else
        ocean_mosaic = trim(grd_file)
     end if
     ntiles = get_mosaic_ntiles(ocean_mosaic)
     if(ntiles .NE. 1) call mpp_error(FATAL, '==>Error from ocean_grids_mod(set_ocean_grid_size): '//&
                   'ntiles should be 1 for ocean mosaic, contact developer')
! Notify diag_manager of mosaic grid
     call set_diag_global_att ('ocean','mosaic','1')
     call read_data(ocean_mosaic, "gridfiles", ocean_hgrid)
     ocean_hgrid = 'INPUT/'//trim(ocean_hgrid)
     call field_size(ocean_hgrid, 'x', siz)
     
     if(mod(siz(1),2) .NE. 1) call mpp_error(FATAL, '==>Error from ocean_grids_mod(set_ocean_grid_size): '//&
          'x-size of x in file '//trim(ocean_hgrid)//' should be 2*ni+1')
     if(mod(siz(2),2) .NE. 1) call mpp_error(FATAL, '==>Error from ocean_grids_mod(set_ocean_grid_size): '//&
          'y-size of x in file '//trim(ocean_hgrid)//' should be 2*nj+1')
     Grid%ni = siz(1)/2 
     Grid%nj = siz(2)/2 
     call field_size(ocean_vgrid , "zeta", siz) 
     if(mod(siz(1),2) .NE. 1) call mpp_error(FATAL, '==>Error from ocean_grids_mod(set_ocean_grid_size): '//&
          'size of dimension zeta in file '//trim(ocean_vgrid)//' should be 2*nk+1')
     Grid%nk  = siz(1)/2            
  else  if(field_exist(grd_file, 'x_T')) then
     ocean_hgrid = grd_file
     write(stdoutunit,*) '==>Note from ocean_grids_mod(set_ocean_grid_size): read grid from new version grid'
     grid_version = VERSION_1
     call field_size( ocean_hgrid, 'x_T', siz)
     Grid%ni = siz(1)
     Grid%nj = siz(2) 
     call field_size( ocean_hgrid, "zt", siz) 
     Grid%nk  = siz(1)     
  else if(field_exist(grd_file, 'geolon_t')) then
     ocean_hgrid = grd_file
     write(stdoutunit,*) '==>Note from ocean_grids_mod(set_ocean_grid_size): read grid from old version grid'
     grid_version = VERSION_0 
     call field_size( ocean_hgrid, 'geolon_t', siz)  
     Grid%ni = siz(1)
     Grid%nj = siz(2)
     call field_size( ocean_hgrid, "zt", siz) 
     Grid%nk  = siz(1)       
     else
     call mpp_error(FATAL, '==>Error from ocean_grids_mod(set_ocean_grid_size): '//&
                     'x_T, geolon_t, ocn_mosaic_file, gridfiles does not exist in file ' //trim(grd_file))
     endif

  if (Grid%ni == 0 .or. Grid%nj == 0 .or. Grid%nk == 0) then
     write(stdoutunit,*) '==>Error reading grid information from ',trim(grd_file),'. Make sure file exists'
     call mpp_error(FATAL,'==>Error reading grid information from grid file.  Are you sure file exists?')
  endif

  Grid%cyclic_x=.false.;Grid%cyclic_y=.false.;Grid%tripolar=.false.
  Grid%f_plane=.false.; Grid%beta_plane=.false.
  Grid%f_plane_latitude = -999.0

  if(grid_version == VERSION_2) then
     !z1l: f_plane, beta_plane area not supported in mosaic grid. Need to think about to implement this. 
     if(field_exist(ocean_mosaic, "contacts") ) then
        ncontacts = get_mosaic_ncontacts(ocean_mosaic)
        if(ncontacts < 1) call mpp_error(FATAL,'==>Error from ocean_grids_mod(set_ocean_grid_size): '//&
                       'number of contacts should be larger than 0 when field contacts exist in file '//trim(ocean_mosaic) )
        if(ncontacts > 2) call mpp_error(FATAL,'==>Error from ocean_grids_mod(set_ocean_grid_size): '//&
                       'number of contacts should be no larger than 2')
        call get_mosaic_contact( ocean_mosaic, tile1(1:ncontacts), tile2(1:ncontacts),           &
             istart1(1:ncontacts), iend1(1:ncontacts), jstart1(1:ncontacts), jend1(1:ncontacts), &
             istart2(1:ncontacts), iend2(1:ncontacts), jstart2(1:ncontacts), jend2(1:ncontacts)  )
        do m = 1, ncontacts
           if(istart1(m) == iend1(m) ) then  ! x-direction contact, only cyclic condition
              if(istart2(m) .NE. iend2(m) ) call mpp_error(FATAL,  &
                   "==>Error from ocean_grids_mod(set_ocean_grid_size): only cyclic condition is allowed for x-boundary")
             Grid%cyclic_x = .true.
           else if( jstart1(m) == jend1(m) ) then  ! y-direction contact, cyclic or folded-north
              if(jstart2(m) .NE. jend2(m) ) call mpp_error(FATAL,  &
                   "==>Error from ocean_grids_mod(set_ocean_grid_size): "//&
                   "only cyclic/folded-north condition is allowed for y-boundary")
              if( jstart1(m) == jstart2(m) ) then ! folded north
             Grid%tripolar = .true.
         else
                 Grid%cyclic_y = .true.
         endif 
           else 
              call mpp_error(FATAL,  &
                   "==>Error from ocean_grids_mod(set_ocean_grid_size): invalid boundary contact")
         end if
  end do
     end if
  else
     if( get_global_att_value(ocean_hgrid, "x_boundary_type", attvalue) ) then
        if(attvalue == 'cyclic') Grid%cyclic_x = .true.
     end if
     if( get_global_att_value(ocean_hgrid, "y_boundary_type", attvalue) ) then
        if(attvalue == 'cyclic') then
           Grid%cyclic_y = .true.
        else if(attvalue == 'fold_north_edge') then
           Grid%tripolar = .true.
        end if
     end if
     if(get_global_att_value(ocean_hgrid, "f_plane", attvalue) ) then
        if(attvalue == 'y') Grid%f_plane = .true.
     end if
     if(get_global_att_value(ocean_hgrid, "beta_plane", attvalue) ) then
        if(attvalue == 'y') Grid%beta_plane = .true.
     end if
     if( get_global_att_value(ocean_hgrid, "f_plane_latitude", f_plane_latitude) ) then
        Grid%f_plane_latitude = f_plane_latitude
     end if
  end if

  if(Grid%cyclic_x) then
     call mpp_error(NOTE,'==>Note from ocean_grids_mod(set_ocean_grid_size): x_boundary_type is cyclic')
  else
     call mpp_error(NOTE,'==>Note from ocean_grids_mod(set_ocean_grid_size): x_boundary_type is solid_walls')
  end if

  if(Grid%tripolar) then
     call mpp_error(NOTE,'==>Note from ocean_grids_mod(set_ocean_grid_size): y_boundary_type is fold_north_edge')
  else if(Grid%cyclic_y) then
     call mpp_error(NOTE,'==>Note from ocean_grids_mod(set_ocean_grid_size): y_boundary_type is cyclic')
  else
     call mpp_error(NOTE,'==>Note from ocean_grids_mod(set_ocean_grid_size): y_boundary_type is solid_walls')
  endif

  if(Grid%f_plane .or. Grid%beta_plane) then
     if(abs(Grid%f_plane_latitude) > 90.0 ) then
        write(stdoutunit,*)  "==>Error from ocean_grids_mod(set_ocean_grid_size): "// &
                 "f_plane_latitude must be between -90 and 90 degrees. Please check your grid file."
        call mpp_error(FATAL, "==>Error from ocean_grids_mod(set_ocean_grid_size): "// &
                 "f_plane_latitude must be between -90 and 90 degrees. Please check your grid file.")
     end if
     write(stdoutunit,'(a,f8.2)') '==>f-plane/beta-plane latitude = ',Grid%f_plane_latitude
  end if

  if(Grid%f_plane) then 
    write(stdoutunit,*) '==>NOTE: Setting geometry and Coriolis according to f-plane' 
  endif 
  if(Grid%beta_plane) then 
    write(stdoutunit,*) '==>NOTE: Setting geometry and Coriolis according to beta-plane' 
  endif 

  if(Grid%tripolar) then 
    write (stdoutunit,'(1x,/a)')  ' ==> Note: Energy conversion errors are nontrivial when using tripolar=.true.'
    write (stdoutunit,'(7x,a)')   'The cause is related to the need to update redundantly computed information' 
    write (stdoutunit,'(7x,a)')   'across the Arctic bipolar fold in a bit-wise exact manner for terms contributing'
    write (stdoutunit,'(7x,a)')   'to the energy conversion analysis.  The extra code and mpp calls have not been'
    write (stdoutunit,'(7x,a)')   'implemented.'
  endif 

  if (PRESENT(grid_name)) then
     Grid%name = grid_name
  else
     Grid%name = 'ocean'
  endif

end subroutine set_ocean_grid_size
! </SUBROUTINE> NAME="set_ocean_grid_size"


!#######################################################################
! <SUBROUTINE NAME="set_ocean_hgrid_arrays">
!
! <DESCRIPTION>
! Define horizontal (and some vertical) grid arrays.
!
!---------------------------------------------------------------------------------------------------------------------
! Grid%       grid_spec      grid_spec     grid_spec                       Description
!  var        field          field         field
!             VERSION_0      VERSION_1     VERSION_2(mosaic) 
!--------------------------------------------------------------------------------------------------------------------- 
!                                                    ocean_vgrid.nc
!                                                    k=1,nk
! zt          zt             zt            zeta(2k-1)
! zw          zw             zb            zeta(2k)
!
!                                                    ocean_hgrid.nc
!                                                    i=1,ni
!                                                    j=1,nj
! grid_x_t    gridlon_t      grid_x_T      x(2i  ,2)
! grid_x_u    gridlon_vert_t grid_x_C      x(2i+1,1)
! grid_y_t    gridlat_t      grid_y_T      y(ni/4,2j)
! grid_y_u    gridlat_vert_t grid_y_C      y(ni/4,2j+1)
!
!T
! xt(i,j)     geolon_t(i,j)  x_T(i,j)      x(2i,2j)
! yt          geolat_t       y_T           y(2i,2j)
! dtw         dtw            ds_01_11_T    dx(2i-1,2j)                 distance to western face of t cell
! dte         dte            ds_11_21_T    dx(2i,2j)                   distance to eastern face of t cell
! dts         dts            ds_10_11_T    dy(2i,2j-1)                 distance to southern face of t cell 
! dtn         dtn            ds_11_12_T    dy(2i,2j)                   distance to northern face of t cell
! 
! dxt         dxt            ds_01_21_T    dx(2i,2j)    +dx(2i-1,2j)   width of t cell   
! dxtn        dxtn           ds_02_22_T    dx(2i-1,2j+1)+dx(2i,2j+1)   width of northern face of t cell
! dxte        dxte           ds_00_20_C    dx(2i,2j)    +dx(2i+1,2j)   distance to adjacent t cell to the east!
! dyt         dyt            ds_10_12_T    dy(2i,2j)    +dy(2i,2j-1)   height of t cell
! dytn        dytn           ds_00_02_C    dy(2i,2j)    +dy(2i,2j+1)   distance to adjacent t cell to the north!
! dyte        dyte           ds_20_22_T    dy(2i+1,2j-1)+dy(2i+1,2j)   height of eastern face of t cell 
!
!C 
! NOTE: The "first" (I,J) C-cell is the one shifted NE of the "first" (I,J) T-cell
!            
!
! xu          geolon_c       x_C           x(2i+1,2j+1)
! yu          geolat_c       y_c           y(2i+1,2j+1)
! dxu         dxu            ds_01_21_C    dx(2i+1,2j+1)+dx(2i,2j+1)   width of u cell
! dxun        dxun           ds_02_22_C    dx(2i,2j+2)+dx(2i+1,2j+2)   width of northern face of u cell
! dyu         dyu            ds_10_12_C    dy(2i+1,2j+1)+dy(2i+1,2j)   height of u cell
! dyue        dyue           ds_20_22_C    dy(2i+2,2j)+dy(2i+2,2j+1)   height of eastern face of u cell
!
! dyun        dyun           ds_11_12_C    dy(2i+1,2j+1)+dy(2i+1,2j+2) distance to adjacent u cell to the north 
!                            +ds_10_11_C(i,j+1)                         satisfies sum rule dyte(i,j)=dyun(i,j-1) 
! dxue        dxue           ds_11_21_C    dx(2i+1,2j+1)+dx(2i+2,2j+1) distance to adjacent u cell to the east! 
!                            +ds_01_11_C(i+1,j)   
!
! duw         duw            ds_01_11_C    dx(2i,2j+1)                 distance to western face of u cell
! due         due            ds_11_21_C    dx(2i+1,2j+1)               distance to eastern face of u cell
! dus         dus            ds_10_11_C    dy(2i+1,2j)                 distance to southern face of u cell
! dun         dun            ds_11_12_C    dy(2i+1,2j+1)               distance to northern face of u cell
!  
! sin_rot     sin_rot        angle_C       sin(angle_dx(2*i+1,2*j+1)   sin of rotation angle at corner cell centers
! cos_rot     cos_rot        angle_C       cos(angle_dx(2*i+1,2*j+1)   cos of rotation angle at corner cell centers
!
!Following are the available fields in mosaic files
!--------------------------------------------------------
!Mosaic file     fields
!--------------------------------------------------------
!ocean_hgrid.nc  x, y, dx, dy, angle_dx, area
!ocean_vgrid.nc  zeta
!topog.nc        depth
!
! </DESCRIPTION>
subroutine set_ocean_hgrid_arrays(Domain, Grid)

  type(ocean_domain_type), intent(inout) :: Domain
  type(ocean_grid_type),   intent(inout) :: Grid

  real, dimension(:),   allocatable          :: data
  real, dimension(:,:), allocatable          :: tmp
  real, dimension(:,:), allocatable          :: tmp_local
  real, dimension(:,:), allocatable          :: tmp1_local
  real, dimension(:,:), allocatable          :: tmp2_local
  real, dimension(:,:), allocatable          :: tmpx
  real, dimension(:,:), allocatable          :: tmpy
  integer, dimension(:),allocatable          :: xext, yext
  type(ocean_domain_type)                    :: Domain2  

  integer :: isd2, ied2, jsd2, jed2
  integer :: isc2, iec2, jsc2, jec2
  integer :: isg2, ieg2, jsg2, jeg2
  integer :: isc1, iec1, jsc1, jec1
  integer :: i, j, k, lon_Tripol
  integer :: ioff, joff
  integer :: start(4), nread(4)

  integer :: stdoutunit 
  stdoutunit=stdout() 

  ! set the grid points coordinates (degrees) and grid spacing (degrees)

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  call get_global_indices(Domain, isg, ieg, jsg, jeg)
  call get_halo_sizes(Domain, xhalo, yhalo)

  ni = Grid%ni;nj = Grid%nj; nk = Grid%nk
 
  allocate (Grid%xt(isd:ied,jsd:jed))
  allocate (Grid%yt(isd:ied,jsd:jed))
  allocate (Grid%xu(isd:ied,jsd:jed))
  allocate (Grid%yu(isd:ied,jsd:jed))
  allocate (Grid%grid_x_t(ni))
  allocate (Grid%grid_y_t(nj))
  allocate (Grid%grid_x_u(ni))
  allocate (Grid%grid_y_u(nj))

  allocate (Grid%zt(nk))
  allocate (Grid%zw(nk))

  allocate(Grid%phit(isd:ied,jsd:jed))
  allocate(Grid%phiu(isd:ied,jsd:jed))
  allocate(Grid%h1t(isd:ied,jsd:jed))
  allocate(Grid%h2t(isd:ied,jsd:jed))
  allocate(Grid%h1u(isd:ied,jsd:jed))
  allocate(Grid%h2u(isd:ied,jsd:jed))

  allocate (Grid%dxt(isd:ied,jsd:jed))
  allocate (Grid%dxu(isd:ied,jsd:jed))
  allocate (Grid%dyt(isd:ied,jsd:jed))
  allocate (Grid%dyu(isd:ied,jsd:jed))
  allocate (Grid%dat(isd:ied,jsd:jed))
  allocate (Grid%dat_frac(isd:ied,jsd:jed))
  allocate (Grid%dau(isd:ied,jsd:jed))

  allocate (Grid%dxtn(isd:ied,jsd:jed))
  allocate (Grid%dytn(isd:ied,jsd:jed))
  allocate (Grid%dxte(isd:ied,jsd:jed))
  allocate (Grid%dyte(isd:ied,jsd:jed))
  allocate (Grid%dxun(isd:ied,jsd:jed))
  allocate (Grid%dyun(isd:ied,jsd:jed))
  allocate (Grid%dxue(isd:ied,jsd:jed))
  allocate (Grid%dyue(isd:ied,jsd:jed))

  allocate (Grid%dxtr(isd:ied,jsd:jed))
  allocate (Grid%dxur(isd:ied,jsd:jed))
  allocate (Grid%dytr(isd:ied,jsd:jed))
  allocate (Grid%dyur(isd:ied,jsd:jed))
  allocate (Grid%dxuer(isd:ied,jsd:jed))
  allocate (Grid%dyuer(isd:ied,jsd:jed))
  allocate (Grid%dxunr(isd:ied,jsd:jed))
  allocate (Grid%dyunr(isd:ied,jsd:jed))
  allocate (Grid%dxter(isd:ied,jsd:jed))
  allocate (Grid%dyter(isd:ied,jsd:jed))
  allocate (Grid%dxtnr(isd:ied,jsd:jed))
  allocate (Grid%dytnr(isd:ied,jsd:jed))
  allocate (Grid%dyue_dxuer(isd:ied,jsd:jed))
  allocate (Grid%dxun_dyunr(isd:ied,jsd:jed))
  allocate (Grid%datr(isd:ied,jsd:jed))
  allocate (Grid%daur(isd:ied,jsd:jed))
  allocate (Grid%dater(isd:ied,jsd:jed))
  allocate (Grid%datnr(isd:ied,jsd:jed))

  allocate (Grid%dxt_dxter(isd:ied,jsd:jed))
  allocate (Grid%dxte_dxtr(isd:ied,jsd:jed))
  allocate (Grid%dxt_dxtnr(isd:ied,jsd:jed))
  allocate (Grid%dxtn_dxtr(isd:ied,jsd:jed))
  allocate (Grid%dyt_dyter(isd:ied,jsd:jed))
  allocate (Grid%dyte_dytr(isd:ied,jsd:jed))
  allocate (Grid%dyt_dytnr(isd:ied,jsd:jed))
  allocate (Grid%dytn_dytr(isd:ied,jsd:jed))

  allocate (Grid%dh1dy(isd:ied,jsd:jed))
  allocate (Grid%dh2dx(isd:ied,jsd:jed))

  allocate ( Grid%duw(isd:ied,jsd:jed) )
  allocate ( Grid%due(isd:ied,jsd:jed) )
  allocate ( Grid%dus(isd:ied,jsd:jed) )
  allocate ( Grid%dun(isd:ied,jsd:jed) )
  allocate ( Grid%dtw(isd:ied,jsd:jed) )
  allocate ( Grid%dte(isd:ied,jsd:jed) )
  allocate ( Grid%dts(isd:ied,jsd:jed) )
  allocate ( Grid%dtn(isd:ied,jsd:jed) )

  allocate(Grid%sin_rot(isd:ied,jsd:jed))
  allocate(Grid%cos_rot(isd:ied,jsd:jed))

  allocate (Grid%obc_tmask(isd:ied,jsd:jed))
  allocate (Grid%obc_umask(isd:ied,jsd:jed))

#endif

  !--- initialize grid data
  
  Grid%xt=0.0;    Grid%yt=0.0;     Grid%grid_x_t=0.0; Grid%grid_y_t=0.0 
  Grid%xu=0.0;    Grid%yu=0.0;     Grid%grid_x_u=0.0; Grid%grid_y_u=0.0
  Grid%dxtn=1.0;  Grid%dytn=1.0;   Grid%dxte=1.0;     Grid%dyte=1.0
  Grid%dxun=1.0;  Grid%dyun=1.0;   Grid%dxue=1.0;     Grid%dyue=1.0
  Grid%duw=0.0 ;  Grid%due=0.0 ;   Grid%dus=0.0 ;     Grid%dun=0.0 
  Grid%dtw=0.0 ;  Grid%dte=0.0 ;   Grid%dts=0.0;      Grid%dtn=0.0
  Grid%zt=0.0;    Grid%zw=0.0;     Grid%sin_rot=0.0;  Grid%cos_rot=0.0  
  Grid%dxt=epsln; Grid%dxu=epsln ; Grid%dyt=epsln ;   Grid%dyu=epsln
  Grid%dh1dy=0.0; Grid%dh2dx=0.0

  call get_domain_offsets(Domain,ioff, joff)  
  select case( grid_version )
  case( VERSION_0 )
     call read_data(ocean_hgrid, "zt",             Grid%zt,       no_domain = .true.)
     call read_data(ocean_hgrid, "zw",             Grid%zw,       no_domain = .true.)
     call read_data(ocean_hgrid, "gridlon_t",      Grid%grid_x_t, no_domain = .true.)
     call read_data(ocean_hgrid, "gridlat_t",      Grid%grid_y_t, no_domain = .true.)
     allocate(data(ni+1))
     call read_data(ocean_hgrid, "gridlon_vert_t", data,          no_domain = .true.)
     Grid%grid_x_u = data(2:ni+1)
     deallocate(data)
     allocate(data(nj+1))
     call read_data(ocean_hgrid, "gridlat_vert_t", data,          no_domain = .true.)
     Grid%grid_y_u = data(2:nj+1)
     deallocate(data)
  case( VERSION_1 )
     call read_data(ocean_hgrid, "zt",             Grid%zt,       no_domain = .true.)
     call read_data(ocean_hgrid, "zb",             Grid%zw,       no_domain = .true.)
     call read_data(ocean_hgrid, "grid_x_T",      Grid%grid_x_t, no_domain = .true.)
     call read_data(ocean_hgrid, "grid_y_T",      Grid%grid_y_t, no_domain = .true.)
     call read_data(ocean_hgrid, "grid_x_C",      Grid%grid_x_u, no_domain = .true.)
     call read_data(ocean_hgrid, "grid_y_C",      Grid%grid_y_u, no_domain = .true.)
  case( VERSION_2 )
     allocate(data(2*nk+1) )  
     call read_data(ocean_vgrid, "zeta", data, no_domain=.TRUE.)
     do k=1,nk
        Grid%zt(k) = data(2*k)  
        Grid%zw(k) = data(2*k+1)  
     enddo
     deallocate(data)
     !--- set up domain for supergrid.
     allocate( xext(Domain%layout(1)), yext(Domain%layout(2)) )
     call mpp_get_domain_extents(domain%domain2d, xext, yext)
     xext = 2*xext
     yext = 2*yext

     call mpp_define_domains((/1,2*ni,1,2*nj/),domain%layout, Domain2%domain2d, maskmap=Domain%maskmap&
           , xflags = Domain%xflags, yflags = Domain%yflags, xhalo=2, yhalo=2,name='ocean_super_grid'&
           , xextent = xext, yextent = yext, symmetry = .true. )

     call mpp_get_compute_domain(Domain%domain2d, isc1, iec1, jsc1, jec1)
     call mpp_get_compute_domain(Domain2%domain2d, isc2, iec2, jsc2, jec2)
     call mpp_get_data_domain(Domain2%domain2d, isd2, ied2, jsd2, jed2)
     call mpp_get_global_domain(Domain2%domain2d, isg2, ieg2, jsg2, jeg2)
     !--- The following adjust is for the consideration of static memory.
     ioff = isc1 - isc; joff = jsc1 - jsc
     isc2 = isc2 - 2*ioff; iec2 = iec2 - 2*ioff
     jsc2 = jsc2 - 2*joff; jec2 = jec2 - 2*joff
     isd2 = isd2 - 2*ioff; ied2 = ied2 - 2*ioff
     jsd2 = jsd2 - 2*joff; jed2 = jed2 - 2*joff

     if(isc2 .NE. 2*isc-1 .OR. iec2 .NE. 2*iec .OR. jsc2 .NE. 2*jsc-1 .OR. jec2 .NE. 2*jec ) then
        call mpp_error(FATAL, 'ocean_grids_mod (set_ocean_hgrid_arrays): supergrid compute domain is not set properly')
     endif     
     if(isd2 .NE. 2*isd-1 .OR. ied2 .NE. 2*ied .OR. jsd2 .NE. 2*jsd-1 .OR. jed2 .NE. 2*jed ) then
        print*, isd, ied, jsd, jed, isd2, ied2, jsd2, jed2
        call mpp_error(FATAL, 'ocean_grids_mod (set_ocean_hgrid_arrays): supergrid data domain is not set properly')
     endif  

     Domain2%isc = isc2; Domain2%iec = iec2
     Domain2%jsc = jsc2; Domain2%jec = jec2
     Domain2%isd = isd2; Domain2%ied = ied2
     Domain2%jsd = jsd2; Domain2%jed = jed2
     Domain2%isg = isg2; Domain2%ieg = ieg2
     Domain2%jsg = jsg2; Domain2%jeg = jeg2
     Domain2%xhalo = 2;  Domain2%yhalo = 2
     Domain2%ioff = 2*ioff; Domain2%joff = 2*joff

     start = 1; nread = 1
     start(2) = 2; nread(1) = 2*ni+1; nread(2) = 2
     allocate(tmpx(2*ni+1,2), tmpy(2,2*nj+1) )
     call read_data(ocean_hgrid, "x", tmpx, start, nread, no_domain=.true.)

     do i = 1, ni
        Grid%grid_x_t(i) = tmpx(2*i,  1) 
        Grid%grid_x_u(i) = tmpx(2*i+1,2) 
     enddo     
     lon_Tripol = ni/4 ! 90 for 1 degree grid
     start = 1; nread = 1
     start(1) = 2*lon_Tripol+1; nread(1) = 2; nread(2) = 2*nj+1
     call read_data(ocean_hgrid, "y", tmpy, start, nread, no_domain=.true.)

     do j = 1, nj  
        Grid%grid_y_t(j) = tmpy(1 , 2*j)
        Grid%grid_y_u(j) = tmpy(1 , 2*j+1)
     enddo
     deallocate(tmpx, tmpy)
     allocate(tmpx(isc2:iec2+1, jsc2:jec2+1))
     allocate(tmpy(isc2:iec2+1, jsc2:jec2+1))
     call read_data(ocean_hgrid, "x", tmpx, Domain2%domain2d, position=CORNER)
     call read_data(ocean_hgrid, "y", tmpy, Domain2%domain2d, position=CORNER)
  end select

  !--- Grid%xt
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'geolon_t', Grid%xt, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'x_T', Grid%xt, Domain%domain2d)   
  case(VERSION_2)
     Grid%xt(isc:iec,jsc:jec) = tmpx(2*isc:2*iec:2,2*jsc:2*jec:2)
  end select
  call update_boundaries(Domain,Grid,Grid%xt,0,0,0,0)

  !--- Grid%yt
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'geolat_t', Grid%yt, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'y_T', Grid%yt, Domain%domain2d)   
  case(VERSION_2)
     Grid%yt(isc:iec,jsc:jec) = tmpy(2*isc:2*iec:2,2*jsc:2*jec:2)
  end select
  call update_boundaries(Domain,Grid,Grid%yt,0,0,0,0)

  !--- Grid%xu
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'geolon_c', Grid%xu, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'x_C', Grid%xu, Domain%domain2d)   
  case(VERSION_2)
     Grid%xu(isc:iec,jsc:jec) = tmpx(2*isc+1:2*iec+1:2,2*jsc+1:2*jec+1:2)
  end select
  call update_boundaries(Domain,Grid,Grid%xu,-1,-1,0,0)

  !--- Grid%yu
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'geolat_c', Grid%yu, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'y_C', Grid%yu, Domain%domain2d)   
  case(VERSION_2)
     Grid%yu(isc:iec,jsc:jec) = tmpy(2*isc+1:2*iec+1:2,2*jsc+1:2*jec+1:2)
  end select
  call update_boundaries(Domain,Grid,Grid%yu,-1,-1,0,0)

  if (Grid%beta_plane .or. Grid%f_plane) then
     Grid%phiu(:,:) = Grid%f_plane_latitude/radian
     Grid%phit(:,:) = Grid%phiu(:,:)
  else
     Grid%phit(:,:) = Grid%yt(:,:)/radian
     Grid%phiu(:,:) = Grid%yu(:,:)/radian
  endif

 Grid%h1t(:,:) = radius*cos(Grid%phit(:,:))
 where (cos(Grid%phit) == 0.0) Grid%h1t = radius*abs(epsln)
 Grid%h1u(:,:) = radius*cos(Grid%phiu(:,:))
 where (cos(Grid%phiu) == 0.0) Grid%h1u = radius*abs(epsln)
 Grid%h2t(:,:) = radius
 Grid%h2u(:,:) = radius

 ! set cell widths (meters) and area (meters^2)
 if(grid_version == VERSION_2) then
    deallocate(tmpx, tmpy)
    allocate(tmpx(isd2:ied2,jsd2:jed2+1), tmpy(isd2:ied2+1,jsd2:jed2))
    tmpx = 0.0
    tmpy = 0.0
    call read_data(ocean_hgrid, "dx", tmpx, Domain2%domain2d, position=NORTH)
    call read_data(ocean_hgrid, "dy", tmpy, Domain2%domain2d, position=EAST)   
    call update_boundaries(Domain2,Grid,tmpx,0,-1,0,1) 
    call update_boundaries(Domain2,Grid,tmpy,-1,0,1,0)
 end if

  ! --- Grid%dxt
  select case(grid_version) 
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dxt', Grid%dxt, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_01_21_T', Grid%dxt, Domain%domain2d)   
  case(VERSION_2)
     Grid%dxt(isc:iec,jsc:jec) = tmpx(2*isc-1:2*iec-1:2,2*jsc:2*jec:2) + tmpx(2*isc:2*iec:2,2*jsc:2*jec:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dxt,0,0,0,0,default_data=epsln)

  !--- Grid%dyt
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dyt', Grid%dyt, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_10_12_T', Grid%dyt, Domain%domain2d)   
  case(VERSION_2)
     Grid%dyt(isc:iec,jsc:jec) = tmpy(2*isc:2*iec:2,2*jsc-1:2*jec-1:2) + tmpy(2*isc:2*iec:2,2*jsc:2*jec:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dyt,0,0,0,0,default_data=epsln)

  ! --- Grid%dxu
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dxu', Grid%dxu, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_01_21_C', Grid%dxu, Domain%domain2d)   
  case(VERSION_2)
     Grid%dxu(isc:iec,jsc:jec) = tmpx(2*isc:2*iec:2,2*jsc+1:2*jec+1:2) + tmpx(2*isc+1:2*iec+1:2,2*jsc+1:2*jec+1:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dxu,-1,-1,0,0,default_data=epsln)

  !--- Grid%dyu
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dyu', Grid%dyu, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_10_12_C', Grid%dyu, Domain%domain2d)   
  case(VERSION_2)
     Grid%dyu(isc:iec,jsc:jec) = tmpy(2*isc+1:2*iec+1:2,2*jsc:2*jec:2) + tmpy(2*isc+1:2*iec+1:2,2*jsc+1:2*jec+1:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dyu,-1,-1,0,0,default_data=epsln)

  Grid%dat(:,:)  = Grid%dxt(:,:)*Grid%dyt(:,:)
  Grid%dau(:,:)  = Grid%dxu(:,:)*Grid%dyu(:,:)

  ! set lengths at edges of grid cells (meters)
  allocate(tmp1_local(isd:ied,jsd:jed), tmp2_local(isd:ied,jsd:jed))

  ! --- Grid%dxtn
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dxtn', Grid%dxtn, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_02_22_T', Grid%dxtn, Domain%domain2d)
  case(VERSION_2)
     Grid%dxtn(isc:iec,jsc:jec) = tmpx(2*isc-1:2*iec-1:2,2*jsc+1:2*jec+1:2) + tmpx(2*isc:2*iec:2,2*jsc+1:2*jec+1:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dxtn,0,-1,0,0,default_data=1.0)

  ! --- Grid%dytn
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dytn', Grid%dytn, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_00_02_C', Grid%dytn, Domain%domain2d)
  case(VERSION_2)
     Grid%dytn(isc:iec,jsc:jec) = tmpy(2*isc:2*iec:2,2*jsc:2*jec:2) + tmpy(2*isc:2*iec:2,2*jsc+1:2*jec+1:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dytn,0,-1,0,0,default_data=1.0)

  ! --- Grid%dxte
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dxte', Grid%dxte, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_00_20_C', Grid%dxte, Domain%domain2d)
  case(VERSION_2)
     Grid%dxte(isc:iec,jsc:jec) = tmpx(2*isc:2*iec:2,2*jsc:2*jec:2) + tmpx(2*isc+1:2*iec+1:2,2*jsc:2*jec:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dxte,-1,0,0,0,default_data=1.0) 

  ! --- Grid%dyte
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dyte', Grid%dyte, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_20_22_T', Grid%dyte, Domain%domain2d)
  case(VERSION_2)
     Grid%dyte(isc:iec,jsc:jec) = tmpy(2*isc+1:2*iec+1:2,2*jsc-1:2*jec-1:2) + tmpy(2*isc+1:2*iec+1:2,2*jsc:2*jec:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dyte,-1,0,0,0,default_data=1.0)

  ! --- Grid%dxun
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dxun', Grid%dxun, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_02_22_C', Grid%dxun, Domain%domain2d)
  case(VERSION_2)
     Grid%dxun(isc:iec,jsc:jec) = tmpx(2*isc:2*iec:2,2*jsc+2:2*jec+2:2) + tmpx(2*isc+1:2*iec+1:2,2*jsc+2:2*jec+2:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dxun,-1,-2,0,0,default_data=1.0)

  ! --- Grid%dyun
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dyun', Grid%dyun, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_10_11_C', tmp2_local, Domain%domain2d)
     call read_data(ocean_hgrid, 'ds_11_12_C', tmp1_local, Domain%domain2d)
     call update_boundaries(Domain,Grid,tmp2_local,-1,-1,0,0,field_ref=tmp1_local(isc:iec,jsc:jec) )
     Grid%dyun(isc:iec,jsc:jec) = tmp1_local(isc:iec,jsc:jec)+tmp2_local(isc:iec,jsc+1:jec+1) 
  case(VERSION_2)
     Grid%dyun(isc:iec,jsc:jec) = tmpy(2*isc+1:2*iec+1:2,2*jsc+1:2*jec+1:2) + tmpy(2*isc+1:2*iec+1:2,2*jsc+2:2*jec+2:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dyun,-1,-2,0,0,default_data=1.0)

  ! --- Grid%dxue
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dxue', Grid%dxue, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_01_11_C', tmp2_local, Domain%domain2d)
     call read_data(ocean_hgrid, 'ds_11_21_C', tmp1_local, Domain%domain2d)
     call update_boundaries(Domain,Grid,tmp2_local,-1,-1,0,0,field_ref=tmp1_local(isc:iec,jsc:jec),default_data=1.0)
     Grid%dxue(isc:iec,jsc:jec) = tmp1_local(isc:iec,jsc:jec)+tmp2_local(isc+1:iec+1,jsc:jec) 
  case(VERSION_2)
     Grid%dxue(isc:iec,jsc:jec) = tmpx(2*isc+1:2*iec+1:2,2*jsc+1:2*jec+1:2) + tmpx(2*isc+2:2*iec+2:2,2*jsc+1:2*jec+1:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dxue,-2,-1,0,0,default_data=1.0) 

  ! --- Grid%dyue
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dyue', Grid%dyue, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_20_22_C', Grid%dyue, Domain%domain2d)
  case(VERSION_2)
     Grid%dyue(isc:iec,jsc:jec) = tmpy(2*isc+2:2*iec+2:2,2*jsc:2*jec:2) + tmpy(2*isc+2:2*iec+2:2,2*jsc+1:2*jec+1:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dyue,-2,-1,0,0,default_data=1.0) 

  ! set reciprocals and related quantities

  do j=jsd,jed
     do i=isd,ied
        Grid%dxtr(i,j)       = 1.0/(Grid%dxt(i,j)+epsln)
        Grid%dxur(i,j)       = 1.0/(Grid%dxu(i,j)+epsln)
        Grid%dytr(i,j)       = 1.0/(Grid%dyt(i,j)+epsln)
        Grid%dyur(i,j)       = 1.0/(Grid%dyu(i,j)+epsln)
        Grid%dxuer(i,j)      = 1.0/(Grid%dxue(i,j)+epsln)
        Grid%dyuer(i,j)      = 1.0/(Grid%dyue(i,j)+epsln)
        Grid%dxunr(i,j)      = 1.0/(Grid%dxun(i,j)+epsln)
        Grid%dyunr(i,j)      = 1.0/(Grid%dyun(i,j)+epsln)
        Grid%dxter(i,j)      = 1.0/(Grid%dxte(i,j)+epsln)
        Grid%dyter(i,j)      = 1.0/(Grid%dyte(i,j)+epsln)
        Grid%dxtnr(i,j)      = 1.0/(Grid%dxtn(i,j)+epsln)
        Grid%dytnr(i,j)      = 1.0/(Grid%dytn(i,j)+epsln)
        Grid%dyue_dxuer(i,j) = Grid%dyue(i,j)/(Grid%dxue(i,j)+epsln)
        Grid%dxun_dyunr(i,j) = Grid%dxun(i,j)/(Grid%dyun(i,j)+epsln)
        Grid%datr(i,j)       = 1.0/(Grid%dat(i,j)+epsln)
        Grid%daur(i,j)       = 1.0/(Grid%dau(i,j)+epsln)
        Grid%dater(i,j)      = 1.0/(Grid%dxte(i,j)*Grid%dyte(i,j)+epsln)
        Grid%datnr(i,j)      = 1.0/(Grid%dxtn(i,j)*Grid%dytn(i,j)+epsln)

        Grid%dxt_dxter(i,j)  = Grid%dxt(i,j)/(Grid%dxte(i,j)+epsln)
        Grid%dxte_dxtr(i,j)  = Grid%dxte(i,j)/(Grid%dxt(i,j)+epsln)
        Grid%dxt_dxtnr(i,j)  = Grid%dxt(i,j)/(Grid%dxtn(i,j)+epsln)
        Grid%dxtn_dxtr(i,j)  = Grid%dxtn(i,j)/(Grid%dxt(i,j)+epsln)
        Grid%dyt_dyter(i,j)  = Grid%dyt(i,j)/(Grid%dyte(i,j)+epsln)
        Grid%dyte_dytr(i,j)  = Grid%dyte(i,j)/(Grid%dyt(i,j)+epsln)
        Grid%dyt_dytnr(i,j)  = Grid%dyt(i,j)/(Grid%dytn(i,j)+epsln)
        Grid%dytn_dytr(i,j)  = Grid%dytn(i,j)/(Grid%dyt(i,j)+epsln)

     enddo
  enddo

  ! set quantities which account for rotation of basis vectors

 allocate(tmp_local(isd:ied,jsd:jed))
 tmp_local=1.0
 
 ! expanded version of dh2dx(:,:) = BDX_EU(tmp(:,:))
 do j=jsc,jec
    do i=isc,iec
       Grid%dh2dx(i,j) = (Grid%dyue(i,j)*tmp_local(i,j) - Grid%dyue(i-1,j)*tmp_local(i-1,j))*Grid%daur(i,j)
    enddo
 enddo
 if (.not. Grid%tripolar .and. jec+joff == nj) then
   do i=isc,iec
     Grid%dh2dx(i,jec) = 0.0
   enddo
 endif

 call update_boundaries(Domain,Grid,Grid%dh2dx,-1,-1,0,0)

 ! expanded version of dh1dy(:,:) = BDY_NU(tmp(:,:))
 do j=jsc,jec
    do i=isc,iec
       Grid%dh1dy(i,j) = (Grid%dxun(i,j)*tmp_local(i,j) - Grid%dxun(i,j-1)*tmp_local(i,j-1))*Grid%daur(i,j)
    enddo
 enddo
 if (.not. Grid%tripolar .and. jec+joff == nj) then
   do i=isc,iec
     Grid%dh1dy(i,jec) = 0.0
   enddo
 endif

 call update_boundaries(Domain,Grid,Grid%dh1dy,-1,-1,0,0)

 ! build distances from grid point to cell faces {meters}
  ! --- Grid%duw
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'duw', Grid%duw, Domain%domain2d )
     call read_data(ocean_hgrid, 'due', tmp_local, Domain%domain2d  )
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_01_11_C', Grid%duw, Domain%domain2d)
     call read_data(ocean_hgrid, 'ds_11_21_C', tmp_local, Domain%domain2d)
  case(VERSION_2)
     Grid%duw(isc:iec,jsc:jec) = tmpx(2*isc:2*iec:2, 2*jsc+1:2*jec+1:2)
     tmp_local(isc:iec,jsc:jec) = tmpx(2*isc+1:2*iec+1:2, 2*jsc+1:2*jec+1:2)
  end select
  call update_boundaries(Domain,Grid,Grid%duw,-1,-1,0,0, field_ref=tmp_local(isc:iec,jsc:jec))

  ! --- Grid%due
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'due', Grid%due, Domain%domain2d )
     call read_data(ocean_hgrid, 'duw', tmp_local, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_11_21_C', Grid%due, Domain%domain2d)
     call read_data(ocean_hgrid, 'ds_01_11_C', tmp_local, Domain%domain2d)
  case(VERSION_2)
     Grid%due(isc:iec,jsc:jec) = tmpx(2*isc+1:2*iec+1:2, 2*jsc+1:2*jec+1:2)
     tmp_local(isc:iec,jsc:jec) = tmpx(2*isc:2*iec:2, 2*jsc+1:2*jec+1:2)
  end select
  call update_boundaries(Domain,Grid,Grid%due,-1,-1,0,0, field_ref=tmp_local(isc:iec,jsc:jec))

  ! --- Grid%dus
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dus', Grid%dus(isc:iec,jsc:jec), Domain%domain2d )
     call read_data(ocean_hgrid, 'dun', tmp_local, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_10_11_C', Grid%dus(isc:iec,jsc:jec), Domain%domain2d)
     call read_data(ocean_hgrid, 'ds_11_12_C', tmp_local, Domain%domain2d)
  case(VERSION_2)
     Grid%dus(isc:iec,jsc:jec) = tmpy(2*isc+1:2*iec+1:2, 2*jsc:2*jec:2)
     tmp_local(isc:iec,jsc:jec) = tmpy(2*isc+1:2*iec+1:2, 2*jsc+1:2*jec+1:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dus,-1,-1,0,0,field_ref=tmp_local(isc:iec,jsc:jec))

  ! --- Grid%dun
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dun', Grid%dun(isc:iec,jsc:jec), Domain%domain2d )
     call read_data(ocean_hgrid, 'dus', tmp_local, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_11_12_C', Grid%dun(isc:iec,jsc:jec), Domain%domain2d)
     call read_data(ocean_hgrid, 'ds_10_11_C', tmp_local, Domain%domain2d)
  case(VERSION_2)
     Grid%dun(isc:iec,jsc:jec) = tmpy(2*isc+1:2*iec+1:2, 2*jsc+1:2*jec+1:2)
     tmp_local(isc:iec,jsc:jec) = tmpy(2*isc+1:2*iec+1:2, 2*jsc:2*jec:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dun,-1,-1,0,0, field_ref=tmp_local(isc:iec,jsc:jec))

  ! --- Grid%dtw
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dtw', Grid%dtw(isc:iec,jsc:jec), Domain%domain2d )
     call read_data(ocean_hgrid, 'dte', tmp_local, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_01_11_T', Grid%dtw(isc:iec,jsc:jec), Domain%domain2d)
     call read_data(ocean_hgrid, 'ds_11_21_T', tmp_local, Domain%domain2d)
  case(VERSION_2)
     Grid%dtw(isc:iec,jsc:jec) = tmpx(2*isc-1:2*iec-1:2, 2*jsc:2*jec:2)
     tmp_local(isc:iec,jsc:jec) = tmpx(2*isc:2*iec:2, 2*jsc:2*jec:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dtw,0,0,0,0, field_ref=tmp_local(isc:iec,jsc:jec))

  ! --- Grid%dte
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dte', Grid%dte(isc:iec,jsc:jec), Domain%domain2d )
     call read_data(ocean_hgrid, 'dtw', tmp_local, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_11_21_T', Grid%dte(isc:iec,jsc:jec), Domain%domain2d)
     call read_data(ocean_hgrid, 'ds_01_11_T', tmp_local, Domain%domain2d)
  case(VERSION_2)
     Grid%dte(isc:iec,jsc:jec) = tmpx(2*isc:2*iec:2, 2*jsc:2*jec:2)
     tmp_local(isc:iec,jsc:jec) = tmpx(2*isc-1:2*iec-1:2, 2*jsc:2*jec:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dte,0,0,0,0, field_ref=tmp_local(isc:iec,jsc:jec))

  ! --- Grid%dts
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dts', Grid%dts(isc:iec,jsc:jec), Domain%domain2d )
     call read_data(ocean_hgrid, 'dtn', tmp_local, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_10_11_T', Grid%dts(isc:iec,jsc:jec), Domain%domain2d)
     call read_data(ocean_hgrid, 'ds_11_12_T', tmp_local, Domain%domain2d)
  case(VERSION_2)
     Grid%dts(isc:iec,jsc:jec) = tmpy(2*isc:2*iec:2, 2*jsc-1:2*jec-1:2)
     tmp_local(isc:iec,jsc:jec) = tmpy(2*isc:2*iec:2, 2*jsc:2*jec:2)
  end select
  call update_boundaries(Domain,Grid,Grid%dts,0,0,0,0, field_ref=tmp_local(isc:iec,jsc:jec))

  ! --- Grid%dtn
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'dtn', Grid%dtn(isc:iec,jsc:jec), Domain%domain2d )
     call read_data(ocean_hgrid, 'dts', tmp_local, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'ds_11_12_T', Grid%dtn(isc:iec,jsc:jec), Domain%domain2d)
     call read_data(ocean_hgrid, 'ds_10_11_T', tmp_local, Domain%domain2d)
  case(VERSION_2)
     Grid%dtn(isc:iec,jsc:jec) = tmpy(2*isc:2*iec:2, 2*jsc:2*jec:2)
     tmp_local(isc:iec,jsc:jec) = tmpy(2*isc:2*iec:2, 2*jsc-1:2*jec-1:2)
     deallocate(tmpx, tmpy)
  end select
  call update_boundaries(Domain,Grid,Grid%dtn,0,0,0,0, field_ref=tmp_local(isc:iec,jsc:jec))

  ! calculate rotation angles on velocity points
  select case(grid_version)
  case(VERSION_0)
     call read_data(ocean_hgrid, 'sin_rot', Grid%sin_rot, Domain%domain2d)
     call read_data(ocean_hgrid, 'cos_rot', Grid%cos_rot, Domain%domain2d)
  case(VERSION_1)
     call read_data(ocean_hgrid, 'angle_C', tmp_local, Domain%domain2d)
     tmp_local     = tmp_local*deg_to_rad
     Grid%sin_rot(isc:iec,jsc:jec) = sin(tmp_local(isc:iec,jsc:jec))
     Grid%cos_rot(isc:iec,jsc:jec) = cos(tmp_local(isc:iec,jsc:jec))
  case(VERSION_2)
     allocate(tmp(isc2:iec2+1,jsc2:jec2+1) )
     call read_data(ocean_hgrid, "angle_dx", tmp, Domain2%domain2d, position=CORNER)
     tmp = tmp*deg_to_rad
     do j = jsc, jec
        do i = isc, iec
           Grid%sin_rot(i,j) = sin(tmp(2*i+1,2*j+1) )
           Grid%cos_rot(i,j) = cos(tmp(2*i+1,2*j+1) )
        end do
     end do
     deallocate(tmp)
     call mpp_deallocate_domain(Domain2%domain2d)
  end select
  call update_boundaries(Domain,Grid,Grid%sin_rot,-1,-1,0,0)
  call update_boundaries(Domain,Grid,Grid%cos_rot,-1,-1,0,0)


 ! ensure that all grid factors are set properly at the southern boundary.
 ! many grid factors with index j=0 have no affect within the computational domain 
 ! Even so, for completeness they are explicity set below.
 tmp_local=1.0
 if (jsc+joff == 1) then
   
     call mpp_error(NOTE, '==>Note from ocean_grids_mod (set_ocean_hgrid_arrays): altering U-grid arrays at j=0')

     ! phiu(:,0), h1u(:,0), and dxu(:,0) are within the computational domain and are
     ! not arbitrary. their values follow directly from grid_spec definitions.
     ! dyu(:,0) is arbitrary and has been set equal to dyu(:,1) by update_boundaries.
     ! However, a symmetric ocean domain requires that dyu be symmetric so dyu(:,0) = dyu(:,nj) 

     if (Grid%beta_plane .or. Grid%f_plane) then
         Grid%phiu(:,0) = Grid%f_plane_latitude/radian
     else
         Grid%phiu(:,0) = Grid%yu(:,1)/radian - Grid%dyte(:,1)/radius
     endif
     Grid%phiu(:,0) = max(min(Grid%phiu(:,0),90.0/radian),-90.0/radian)
     where (cos(Grid%phiu(:,0)) == 0.0)
         Grid%h1u(:,0) = radius*abs(epsln)
     elsewhere
         Grid%h1u(:,0) = radius*cos(Grid%phiu(:,0))
     end where
     
     Grid%dxu(:,0)  = (Grid%dxu(:,1)/Grid%h1u(:,1))*Grid%h1u(:,0)
     Grid%dau(:,0)  = Grid%dxu(:,0)*Grid%dyu(:,0)
     
     Grid%dxur(:,0) = 1.0/(Grid%dxu(:,0)+epsln)
     Grid%dyur(:,0) = 1.0/(Grid%dyu(:,0)+epsln)
     Grid%daur(:,0) = 1.0/(Grid%dau(:,0)+epsln)

     Grid%dun(:,0)  = Grid%dyte(:,1) - Grid%dus(:,1)
     Grid%dus(:,0)  = Grid%dau(:,0)/(Grid%dxu(:,0)+epsln) - Grid%dun(:,0)
     Grid%due(:,0)  = (Grid%due(:,1)/Grid%h1u(:,1))*Grid%h1u(:,0)
     Grid%duw(:,0)  = Grid%dxu(:,0) - Grid%due(:,0)

     Grid%dxue(:,0)  = (Grid%dxue(:,1)/Grid%h1u(:,1))*Grid%h1u(:,0)
     Grid%dxun(:,0)  = (Grid%dxun(:,1)/Grid%h1t(:,2))*Grid%h1t(:,1)
     Grid%dxuer(:,0) = 1.0/(Grid%dxue(:,0)+epsln)
     Grid%dxunr(:,0) = 1.0/(Grid%dxun(:,0)+epsln)
                             
     Grid%dyun(:,0)  = Grid%dyte(:,1)
     Grid%dyunr(:,0) = 1.0/(Grid%dyun(:,0)+epsln)
     Grid%dxun_dyunr(:,0) = Grid%dxun(:,0)/(Grid%dyun(:,0)+epsln)

     ! not correct, but any use should be zeroed out by the land mask at j=0
     Grid%dyue(:,0)  = Grid%dyu(:,0) 
     Grid%dyuer(:,0) = 1.0/(Grid%dyue(:,0)+epsln) 
     Grid%dyue_dxuer(:,0) = Grid%dyue(:,0)/(Grid%dxue(:,0)+epsln)

     Grid%dh2dx(:,0) = 0.0
     Grid%dh1dy(:,1) = (Grid%dxun(:,1)*tmp_local(:,1) - Grid%dxun(:,0)*tmp_local(:,0))*Grid%daur(:,1)
     Grid%dh1dy(:,0) = 0.0

 endif

  deallocate(tmp_local, tmp1_local, tmp2_local)
 
  if (debug_this_module .or. verbose_init) then
     call write_chksum_2d('xt', Grid%xt(COMP))
     call write_chksum_2d('xu', Grid%xu(COMP))
     call write_chksum_2d('yt', Grid%yt(COMP))
     call write_chksum_2d('yu', Grid%yu(COMP))
     call write_chksum_2d('dxt', Grid%dxt(COMP))
     call write_chksum_2d('dxu', Grid%dxu(COMP))
     call write_chksum_2d('dyt', Grid%dyt(COMP))
     call write_chksum_2d('dyu', Grid%dyu(COMP))
     call write_chksum_2d('dat', Grid%dat(COMP))
     call write_chksum_2d('dau', Grid%dau(COMP))
     call write_chksum_2d('dxtn', Grid%dxtn(COMP))
     call write_chksum_2d('dytn', Grid%dytn(COMP))
     call write_chksum_2d('dxte', Grid%dxte(COMP))
     call write_chksum_2d('dyte', Grid%dyte(COMP))
     call write_chksum_2d('dxun', Grid%dxun(COMP))
     call write_chksum_2d('dyun', Grid%dyun(COMP))
     call write_chksum_2d('dxue', Grid%dxue(COMP))
     call write_chksum_2d('dyue', Grid%dyue(COMP))
     call write_chksum_2d('dtn+dts', Grid%dtn(COMP) + Grid%dts(COMP))
     call write_chksum_2d('dun+dus', Grid%dun(COMP) + Grid%dus(COMP))
     call write_chksum_2d('dte+dtw', Grid%dte(COMP) + Grid%dtw(COMP))
     call write_chksum_2d('due+duw', Grid%due(COMP) + Grid%duw(COMP))
     call write_chksum_2d('dte', Grid%dte(COMP))
     call write_chksum_2d('dtw', Grid%dtw(COMP))
     call write_chksum_2d('due', Grid%due(COMP))
     call write_chksum_2d('duw', Grid%duw(COMP))
     call write_chksum_2d('sin_rot', Grid%sin_rot(COMP))
     call write_chksum_2d('cos_rot', Grid%cos_rot(COMP))
  endif

  if(write_grid) then
     call write_data("ocean_grid_check.nc", "xt", Grid%xt(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "yt", Grid%yt(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "xu", Grid%xu(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "yu", Grid%yu(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "zt", Grid%zt,                  no_domain=.true.)
     call write_data("ocean_grid_check.nc", "zw", Grid%zw,                  no_domain=.true.)
     call write_data("ocean_grid_check.nc", "dxt", Grid%dxt(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dyt", Grid%dyt(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dxu", Grid%dxu(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dyu", Grid%dyu(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dat", Grid%dat(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dau", Grid%dau(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dxtn", Grid%dxtn(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dytn", Grid%dytn(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dxte", Grid%dxte(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dyte", Grid%dyte(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dxun", Grid%dxun(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dyun", Grid%dyun(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dxue", Grid%dxue(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dyue", Grid%dyue(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dtn", Grid%dtn(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dts", Grid%dts(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dun", Grid%dun(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dus", Grid%dus(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dte", Grid%dte(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "dtw", Grid%dtw(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "due", Grid%due(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "duw", Grid%duw(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "sin_rot", Grid%sin_rot(isc:iec,jsc:jec), Domain%domain2d)
     call write_data("ocean_grid_check.nc", "cos_rot", Grid%cos_rot(isc:iec,jsc:jec), Domain%domain2d)
  end if

end subroutine set_ocean_hgrid_arrays
! </SUBROUTINE> NAME="set_ocean_hgrid_arrays"


!#######################################################################
! <SUBROUTINE NAME="set_ocean_vgrid_arrays">
!
! <DESCRIPTION>
! Compute vertical (and some horizontal) grids for ocean model. 
! Also compute axes information for diagnostic manager.  
! </DESCRIPTION>
!
subroutine set_ocean_vgrid_arrays (Domain, Grid, obc)

  type(ocean_domain_type), intent(inout)        :: Domain
  type(ocean_grid_type),   intent(inout)        :: Grid
  logical,                 intent(in), optional :: obc

  real    :: ht_fax, ht_fay, ht_jp1_fax, ht_ip1_fay
  real    :: tcella_sphere, ucella_sphere
  real    :: wet_t_points, wet_u_points

  integer :: i, j, k, kzt, kzu, kmin

  logical :: have_obc=.false.

  real    :: sigma_sign, zwnk, zwnk_r

  integer :: stdoutunit 
  stdoutunit=stdout() 

  
  if (PRESENT(obc)) have_obc = obc
  
#ifndef MOM_STATIC_ARRAYS
  allocate (Grid%tcella(nk))
  allocate (Grid%ucella(nk))
  allocate (Grid%mask(isd:ied,jsd:jed,nk))
  allocate (Grid%tmask(isd:ied,jsd:jed,nk))
  allocate (Grid%umask(isd:ied,jsd:jed,nk))
  allocate (Grid%tmasken(isd:ied,jsd:jed,nk,2))
  allocate (Grid%tmask_depth(isd:ied,jsd:jed,nk))
  allocate (Grid%umask_depth(isd:ied,jsd:jed,nk))

  allocate (Grid%dht_dx(isd:ied,jsd:jed))
  allocate (Grid%dht_dy(isd:ied,jsd:jed))
  allocate (Grid%gradH(isd:ied,jsd:jed))

  allocate (Grid%dzt(nk))
  allocate (Grid%dztlo(nk))
  allocate (Grid%dztup(nk))
  allocate (Grid%dzw(0:nk))

  allocate (Grid%st(nk))
  allocate (Grid%sw(nk))
  allocate (Grid%dst(nk))
  allocate (Grid%dstlo(nk))
  allocate (Grid%dstup(nk))
  allocate (Grid%dsw(0:nk))

  allocate (Grid%fracdz(nk,0:1)) 
  allocate (Grid%dzwr(0:nk))

#endif

  ! set depth arrays
  Grid%dzw(0)         = Grid%zt(1)
  Grid%dzw(1)         = Grid%zt(2)-Grid%zt(1)
  Grid%dzwr(0)        = 1.0/Grid%dzw(0)
  Grid%dzwr(1)        = 1.0/Grid%dzw(1)
  Grid%dzt(1)         = Grid%zw(1)
  Grid%fracdz(1,0)    = Grid%zt(1)/Grid%dzt(1)  
  Grid%fracdz(1,1)    = (Grid%zw(1) - Grid%zt(1))/Grid%dzt(1)  
  do k=2,nk-1
     Grid%dzt(k)      = Grid%zw(k)-Grid%zw(k-1)
     Grid%dzw(k)      = Grid%zt(k+1)-Grid%zt(k)
     Grid%dzwr(k)     = 1.0/Grid%dzw(k)
     Grid%fracdz(k,0) = (Grid%zt(k) - Grid%zw(k-1))/Grid%dzt(k)
     Grid%fracdz(k,1) = (Grid%zw(k) - Grid%zt(k))/Grid%dzt(k)
  enddo
  Grid%dzt(nk)        = Grid%zw(nk)-Grid%zw(nk-1)
  Grid%dzw(nk)        = Grid%zw(nk) - Grid%zt(nk)  
  Grid%dzwr(nk)       = 1.0/Grid%dzw(nk)
  Grid%fracdz(nk,0)   = (Grid%zt(nk) - Grid%zw(nk-1))/Grid%dzt(nk)
  Grid%fracdz(nk,1)   = (Grid%zw(nk) - Grid%zt(nk))/Grid%dzt(nk)

  ! half-thicknesses 
  k=1
  Grid%dztlo(k) = Grid%zw(k)-Grid%zt(k)
  Grid%dztup(k) = Grid%dzw(k-1)
  do k=2,nk
     Grid%dztlo(k) = Grid%zw(k)-Grid%zt(k)
     Grid%dztup(k) = Grid%zt(k)-Grid%zw(k-1)
  enddo


 ! construct T cell and U cell land/sea masks
 do k=1,nk
    do j=jsd,jed
       do i=isd,ied
          if (Grid%kmt(i,j) .ge. k) then
             Grid%tmask(i,j,k) = 1.0
          else
             Grid%tmask(i,j,k) = 0.0
          endif
          if (Grid%kmu(i,j) .ge. k) then
             Grid%umask(i,j,k) = 1.0
          else
             Grid%umask(i,j,k) = 0.0
          endif
       enddo
    enddo
 enddo

 if(horz_grid == MOM_CGRID) then 
    Grid%mask(:,:,:) = Grid%tmask(:,:,:)
    do k=1,nk
       do j=jsd,jec
          do i=isd,iec
             Grid%tmasken(i,j,k,1) = min(Grid%tmask(i,j,k),Grid%tmask(i+1,j,k))
             Grid%tmasken(i,j,k,2) = min(Grid%tmask(i,j,k),Grid%tmask(i,j+1,k))
          enddo
       enddo
    enddo
    call mpp_update_domains(Grid%tmasken(:,:,:,1),Domain%domain2d)
    call mpp_update_domains(Grid%tmasken(:,:,:,2),Domain%domain2d)
 else 
    Grid%mask(:,:,:) = Grid%umask(:,:,:)
    do k=1,nk
       do j=jsd,jed
          do i=isd,ied
             Grid%tmasken(i,j,k,1) = Grid%umask(i,j,k)
             Grid%tmasken(i,j,k,2) = Grid%umask(i,j,k)
          enddo
       enddo
    enddo
 endif 


 ! Compute masks as if depth or pressure were the vertical coordinates.
 ! This new mask is used for case when have vert_coordinate=ZSIGMA or PSIGMA,
 ! in which case tmask and umask are 1 for all k=1,nk except where ht=0.0.
 ! We need tmask_depth and umask_depth for vertical remapping in case when 
 ! remap fields into depth or pressure space from terrain following s-space. 
 Grid%tmask_depth(:,:,:) = 0.0
 Grid%umask_depth(:,:,:) = 0.0

 k=1
 do j=jsd,jed
    do i=isd,ied
       if (Grid%ht(i,j) > 0.0) then
           Grid%tmask_depth(i,j,k) = 1.0
       endif
       if (Grid%hu(i,j) > 0.0) then
           Grid%umask_depth(i,j,k) = 1.0
       endif
    enddo
 enddo
 do k=1,nk-1
    do j=jsd,jed
       do i=isd,ied
          if (Grid%ht(i,j) >= Grid%zw(k)) then
              Grid%tmask_depth(i,j,k+1) = 1.0
          endif
          if (Grid%hu(i,j) >= Grid%zw(k)) then
              Grid%umask_depth(i,j,k+1) = 1.0
          endif
       enddo
    enddo
 enddo

  ! compute surface area and volume of ocean (T cells and U cells)
  Grid%tcellv    = 0.0 !total ocean volume on T cells (assuming eta=0)
  Grid%ucellv    = 0.0 !total ocean volume on U cells (assuming eta=0)
  Grid%tcella(:) = 0.0 !total ocean surface area on T cells in level k
  Grid%ucella(:) = 0.0 !total ocean surface area on U cells in level k

  ! exclude points at open boundaries from diagnostics
  do j=jsc,jec
    do i=isc,iec
       kzt = Grid%kmt(i,j)
       if(have_obc) kzt = kzt * int(Grid%obc_tmask(i,j))
       if (kzt .gt. 0) then
           do k=1,kzt
              Grid%tcella(k) = Grid%tcella(k) + Grid%dat(i,j)
           enddo
           Grid%tcellv = Grid%tcellv + Grid%dat(i,j)*Grid%ht(i,j)
       endif
    enddo
 enddo

 do j=jsc,jec
    do i=isc,iec
       kzu = Grid%kmu(i,j)
       if(have_obc) kzu = kzu * int(Grid%obc_umask(i,j))
       if (kzu .gt. 0) then
           do k=1,kzu
              Grid%ucella(k) = Grid%ucella(k) + Grid%dau(i,j)
           enddo
           Grid%ucellv = Grid%ucellv + Grid%dau(i,j)*Grid%hu(i,j)
       endif
    enddo
 enddo

 ! compute area of full domain, including land regions 
 tcella_sphere=0.0
 ucella_sphere=0.0
 do j=jsc,jec
    do i=isc,iec
       tcella_sphere = tcella_sphere + Grid%dat(i,j)
       ucella_sphere = ucella_sphere + Grid%dau(i,j)
    enddo
 enddo

 call mpp_sum (Grid%tcella, nk)
 call mpp_sum (Grid%ucella, nk)
 call mpp_sum (Grid%tcellv)
 call mpp_sum (Grid%ucellv)
 call mpp_sum (tcella_sphere)
 call mpp_sum (ucella_sphere)

 ! information about model grid size  
 Grid%total_t_points = Grid%ni*Grid%nj*Grid%nk
 if(global_sum_flag==BITWISE_EXACT_SUM) then 
     Grid%wet_t_points = nint(mpp_global_sum(Domain%domain2d,Grid%tmask(:,:,:), BITWISE_EXACT_SUM)) 
     Grid%wet_u_points = nint(mpp_global_sum(Domain%domain2d,Grid%umask(:,:,:), BITWISE_EXACT_SUM)) 
 else 
     wet_t_points = real(mpp_global_sum(Domain%domain2d,Grid%tmask(:,:,:), NON_BITWISE_EXACT_SUM), KIND=4)
     wet_u_points = real(mpp_global_sum(Domain%domain2d,Grid%umask(:,:,:), NON_BITWISE_EXACT_SUM), KIND=4)
     Grid%wet_t_points = nint(wet_t_points)
     Grid%wet_u_points = nint(wet_u_points)
 endif

 if (debug_this_module .or. verbose_init) then
     write (stdoutunit,'(/a,i12)')   '  Number of wet ocean tracer points          =', Grid%wet_t_points
     write (stdoutunit,'(a,i12)')    '  Number of wet ocean velocity points        =', Grid%wet_u_points
     write (stdoutunit,'(a,i12)')    '  Number of computed ocean tracer points     =', Grid%total_t_points

     write (stdoutunit,'(/a,es24.17,a)') &
     '  Wet ocean volume with eta_t=0.0   (T-cells)  =', Grid%tcellv,    ' m^3 (not bit reproducible)'
     write (stdoutunit,'(a,es24.17,a)') &
      '  Ocean surface area               (T-cells)  =', Grid%tcella(1), ' m^2 (not bit reproducible)'

     write (stdoutunit,'(/a,es24.17,a)') &
     '  Wet ocean volume with eta_u=0.0   (U-cells)  =', Grid%ucellv,    ' m^3 (not bit reproducible)'
     write (stdoutunit,'(a,es24.17,a)') &
     '  Wet ocean surface area            (U-cells)  =', Grid%ucella(1), ' m^2 (not bit reproducible)'

     write (stdoutunit,'(/a,es24.17,a)') &
     '  Wet ocean + masked-out (land) surface area (T-cells) =', tcella_sphere,  ' m^2 (not bit reproducible)'
     write (stdoutunit,'(a,es24.17,a/)') &
     '  Wet ocean + masked-out (land) surface area (U-cells) =', ucella_sphere,  ' m^2 (not bit reproducible)'
 endif
 
 ! compute bitwise reproducible surface areas
 if(global_sum_flag==BITWISE_EXACT_SUM) then 
     if(have_obc) then 
         Grid%tcellsurf = &
         mpp_global_sum(Domain%domain2d,Grid%dat(:,:)*Grid%tmask(:,:,1)*Grid%obc_tmask(:,:), BITWISE_EXACT_SUM)
         Grid%ucellsurf = &
         mpp_global_sum(Domain%domain2d,Grid%dau(:,:)*Grid%umask(:,:,1)*Grid%obc_umask(:,:), BITWISE_EXACT_SUM)
     else 
         Grid%tcellsurf = &
          mpp_global_sum(Domain%domain2d,Grid%dat(:,:)*Grid%tmask(:,:,1), BITWISE_EXACT_SUM)
         Grid%ucellsurf = &
          mpp_global_sum(Domain%domain2d,Grid%dau(:,:)*Grid%umask(:,:,1), BITWISE_EXACT_SUM)
     endif
 else 
     if(have_obc) then 
         Grid%tcellsurf = &
         real(mpp_global_sum(Domain%domain2d,Grid%dat(:,:)*Grid%tmask(:,:,1)*Grid%obc_tmask(:,:), NON_BITWISE_EXACT_SUM), KIND=4) 
         Grid%ucellsurf = &
         real(mpp_global_sum(Domain%domain2d,Grid%dau(:,:)*Grid%umask(:,:,1)*Grid%obc_umask(:,:), NON_BITWISE_EXACT_SUM), KIND=4) 
     else 
         Grid%tcellsurf = &
         real(mpp_global_sum(Domain%domain2d,Grid%dat(:,:)*Grid%tmask(:,:,1), NON_BITWISE_EXACT_SUM), KIND=4) 
         Grid%ucellsurf = &
         real(mpp_global_sum(Domain%domain2d,Grid%dau(:,:)*Grid%umask(:,:,1), NON_BITWISE_EXACT_SUM), KIND=4) 
     endif
 endif


 ! compute fraction of total wet area occupied by a single tracer cell
 do j=jsc,jec
    do i=isc,iec
       Grid%dat_frac(i,j) = Grid%dat(i,j)/Grid%tcellsurf
    enddo
 enddo

  ! compute topographic slopes at U-cell. Note: cannot use 
  ! operators as ocean_operators_init has not yet been called.
  do j=jsc,jec
    do i=isc,iec
      ht_fax           = 0.5*( Grid%ht(i,j) + Grid%ht(i+1,j))
      ht_fay           = 0.5*( Grid%ht(i,j) + Grid%ht(i,j+1))
      ht_jp1_fax       = 0.5*( Grid%ht(i,j+1) + Grid%ht(i+1,j+1))
      ht_ip1_fay       = 0.5*( Grid%ht(i+1,j) + Grid%ht(i+1,j+1))
      Grid%dht_dx(i,j) = (ht_ip1_fay-ht_fay)*Grid%dxur(i,j)*Grid%umask(i,j,1)
      Grid%dht_dy(i,j) = (ht_jp1_fax-ht_fax)*Grid%dyur(i,j)*Grid%umask(i,j,1)
      Grid%gradH(i,j)  = sqrt(Grid%dht_dx(i,j)**2 + Grid%dht_dy(i,j)**2)
    enddo
  enddo
  call update_boundaries(Domain,Grid,Grid%dht_dx,0,0,0,0)
  call update_boundaries(Domain,Grid,Grid%dht_dy,0,0,0,0)
  call update_boundaries(Domain,Grid,Grid%gradH,0,0,0,0)

  allocate(rho0_profile(nk))
  rho0_profile(:) = rho0
  if(read_rho0_profile) then 
      write(stdoutunit,'(a)') '==>Warning: ocean_grids_mod: read rho0 profile to set dst grid spacing.'
      write(stdoutunit,'(a)') '            This option is experimental, and NOT generally supported.'
      if(vert_coordinate_class==DEPTH_BASED) then 
          write(stdoutunit,'(a)') '   Since using DEPTH_BASED vertical coordinates, rho0_profile = rho0.'
      endif
      if(vert_coordinate_class==PRESSURE_BASED) then 
         call read_data('INPUT/rho0_profile.nc','rho0_profile', rho0_profile)
      endif 
  endif 

  ! compute static s-grid information 
  if(vert_coordinate == GEOPOTENTIAL .or. vert_coordinate == ZSTAR) then 
    do k=1,nk
      Grid%st(k)    = Grid%zt(k)
      Grid%sw(k)    = Grid%zw(k)
      Grid%dst(k)   = Grid%dzt(k)
      Grid%dstlo(k) = Grid%dztlo(k)
      Grid%dstup(k) = Grid%dztup(k)
    enddo
    do k=0,nk
      Grid%dsw(k) = Grid%dzw(k)
    enddo

  elseif(vert_coordinate == PRESSURE .or. vert_coordinate == PSTAR) then 
    do k=1,nk
      Grid%st(k)    =  rho0_profile(k)*grav*Grid%zt(k)
      Grid%sw(k)    =  rho0_profile(k)*grav*Grid%zw(k)
      Grid%dst(k)   = -rho0_profile(k)*grav*Grid%dzt(k)
      Grid%dstlo(k) = -rho0_profile(k)*grav*Grid%dztlo(k)
      Grid%dstup(k) = -rho0_profile(k)*grav*Grid%dztup(k)
    enddo
    do k=0,nk
      kmin = max(1,k)
      Grid%dsw(k)   = -rho0_profile(kmin)*grav*Grid%dzw(k)
    enddo

  elseif(vert_coordinate == ZSIGMA .or. vert_coordinate == PSIGMA) then 

     ! assume initial bottom pressure = rho0*g*ht, which means that  
     ! PSIGMA and ZSIGMA initialization are same, to within sign. 
     ! -1 <= ZSIGMA <= 0, so dst and dsw are positive 
     !  0 <= PSIGMA <= 1, so dst and dsw are negative 
     ! Recall s-coordinate is dimensionless when use ZSIGMA or PSIGMA.

     if(vert_coordinate==ZSIGMA) then  
         sigma_sign = -1.0
     elseif(vert_coordinate==PSIGMA) then
         sigma_sign =  1.0
     endif

     zwnk   = Grid%zw(nk)
     zwnk_r = 1.0/(epsln + zwnk)

     do k=1,nk
        Grid%st(k) = sigma_sign*Grid%zt(k)*zwnk_r
        Grid%sw(k) = sigma_sign*Grid%zw(k)*zwnk_r
     enddo

     ! set s-grid increments from st and sw
     Grid%dsw(0) = - Grid%st(1)
     Grid%dsw(1) = -(Grid%st(2)-Grid%st(1))
     Grid%dst(1) = - Grid%sw(1)
     do k=2,nk-1
        Grid%dst(k) = -(Grid%sw(k)  - Grid%sw(k-1))
        Grid%dsw(k) = -(Grid%st(k+1)- Grid%st(k))
     enddo
     Grid%dst(nk) = -(Grid%sw(nk)-Grid%sw(nk-1))
     Grid%dsw(nk) = -(Grid%sw(nk)-Grid%st(nk))

     k=1
     Grid%dstlo(k) = Grid%sw(k)-Grid%st(k)
     Grid%dstup(k) = Grid%dsw(k-1)
     do k=2,nk
        Grid%dstlo(k) = Grid%sw(k)-Grid%st(k)
        Grid%dstup(k) = Grid%st(k)-Grid%sw(k-1)
     enddo

  endif 

  ! set up the axis definition for variables
  call axes_info(Domain, Grid)


end subroutine set_ocean_vgrid_arrays
! </SUBROUTINE> NAME="set_ocean_vgrid_arrays"

!#######################################################################
! <SUBROUTINE NAME="init_grids_diag">
!
! <DESCRIPTION>
! Initialize some grid diagnostics. 
! </DESCRIPTION>
subroutine init_grids_diag(Grid, Time)

  type(ocean_grid_type), intent(inout) :: grid
  type(ocean_time_type), intent(in) :: Time

  integer :: id_geolon_t
  integer :: id_geolat_t
  integer :: id_geolon_uv
  integer :: id_geolat_uv
  integer :: id_area_t
  integer :: id_area_u

  ! output grid information to the diagnostic manager

  id_geolon_t = register_static_field('ocean_model','geolon_t', Grid%tracer_axes(1:2), &
                                      'tracer longitude','degrees_E', range=(/-281.,361./))
  if (id_geolon_t > 0)  used = send_data(id_geolon_t,Grid%xt(isc:iec,jsc:jec),  Time%model_time)

  id_geolat_t = register_static_field('ocean_model','geolat_t', Grid%tracer_axes(1:2), &
                                       'tracer latitude','degrees_N', range=(/-91.,91./))  
  if (id_geolat_t > 0)  used = send_data(id_geolat_t,Grid%yt(isc:iec,jsc:jec),  Time%model_time)

  id_geolon_uv = register_static_field('ocean_model','geolon_c', Grid%vel_axes_uv(1:2), &
                                       'uv longitude','degrees_E', range=(/-281.,361./))
  if (id_geolon_uv > 0) used = send_data(id_geolon_uv,Grid%xu(isc:iec,jsc:jec), Time%model_time)

  id_geolat_uv = register_static_field('ocean_model','geolat_c',Grid%vel_axes_uv(1:2), &
                                       'uv latitude','degrees_N', range=(/-91.,91./))
  if (id_geolat_uv > 0) used = send_data(id_geolat_uv,Grid%yu(isc:iec,jsc:jec), Time%model_time)

  id_area_t = register_static_field('ocean_model','area_t',Grid%tracer_axes(1:2), 'tracer cell area',&
                                    'm^2', range=(/0.,1.e15/))
  if (id_area_t > 0)    used = send_data(id_area_t,Grid%dat(isc:iec,jsc:jec),   Time%model_time)

  id_area_u = register_static_field('ocean_model','area_u',Grid%vel_axes_uv(1:2), 'velocity cell area',&
                                    'm^2', range=(/0.,1.e15/))  
  if (id_area_u > 0)    used = send_data(id_area_u,Grid%dau(isc:iec,jsc:jec),   Time%model_time)    

  id_kmt = register_static_field ('ocean_model', 'kmt', Grid%tracer_axes(1:2), &
           'number of depth levels on t-grid', 'dimensionless',                &
            missing_value=missing_value, range=(/-1e1,1e9/))
  if (id_kmt > 0) then 
      wrk1_2d(:,:) = Grid%kmt(:,:)
      call diagnose_2d(Time, Grid, id_kmt, wrk1_2d(:,:))
  endif 
  id_kmu = register_static_field ('ocean_model', 'kmu', Grid%vel_axes_uv(1:2), &
           'number of depth levels on u-grid', 'dimensionless',                &
            missing_value=missing_value, range=(/-1e1,1e9/))
  if (id_kmu > 0) then 
      wrk1_2d(:,:) = Grid%kmu(:,:)
      call diagnose_2d(Time, Grid, id_kmu, wrk1_2d(:,:))
  endif 

  id_ht  = register_static_field ('ocean_model', 'ht', Grid%tracer_axes(1:2),      &
                                  'ocean depth on t-cells', 'm',                   &
                                  missing_value=missing_value, range=(/-1e9,1e9/), &
                                  standard_name='sea_floor_depth_below_geoid')
  call diagnose_2d(Time, Grid, id_ht, Grid%ht(:,:))

  id_hu  = register_static_field ('ocean_model', 'hu', Grid%vel_axes_uv(1:2), 'ocean depth on u-cells', &
                                  'm',missing_value=missing_value, range=(/-1e9,1e9/))
  call diagnose_2d_u(Time, Grid, id_hu, Grid%hu(:,:))

  id_dht_dx  = register_static_field ('ocean_model', 'dht_dx', Grid%vel_axes_uv(1:2), 'd(ht)/dx on u-cells', &
                                      'm/m', missing_value=missing_value, range=(/-1e9,1e9/))
  call diagnose_2d_u(Time, Grid, id_dht_dx, Grid%dht_dx(:,:))

  id_dht_dy  = register_static_field ('ocean_model', 'dht_dy', Grid%vel_axes_uv(1:2), 'd(ht)/dy on u-cells', &
                                      'm/m', missing_value=missing_value, range=(/-1e9,1e9/))
  call diagnose_2d_u(Time, Grid, id_dht_dy, Grid%dht_dy(:,:))

  id_gradH = register_static_field ('ocean_model', 'gradH', Grid%vel_axes_uv(1:2), '|grad bottom on U-cell|', &
                                      'm/m', missing_value=missing_value, range=(/-1e9,1e9/))
  call diagnose_2d_u(Time, Grid, id_gradH, Grid%gradH(:,:))

  id_dxt = register_static_field ('ocean_model', 'dxt', Grid%tracer_axes(1:2), 'ocean dxt on t-cells', 'm',&
                                  missing_value=missing_value, range=(/-1e9,1e9/))
  call diagnose_2d(Time, Grid, id_dxt, Grid%dxt(:,:))

  id_dxu = register_static_field ('ocean_model', 'dxu', Grid%vel_axes_uv(1:2), 'ocean dxu on u-cells', 'm',&
                                  missing_value=missing_value, range=(/-1e9,1e9/))
  call diagnose_2d_u(Time, Grid, id_dxu, Grid%dxu(:,:))

  id_dyt = register_static_field ('ocean_model', 'dyt', Grid%tracer_axes(1:2), 'ocean dyt on t-cells', 'm',&
                                  missing_value=missing_value, range=(/-1e9,1e9/))
  call diagnose_2d(Time, Grid, id_dyt, Grid%dyt(:,:))

  id_dyu = register_static_field ('ocean_model', 'dyu', Grid%vel_axes_uv(1:2), 'ocean dyu on u-cells', 'm',&
                                  missing_value=missing_value, range=(/-1e9,1e9/))
  call diagnose_2d_u(Time, Grid, id_dyu, Grid%dyu(:,:))

  id_dxtn = register_static_field ('ocean_model', 'dxtn', Grid%tracer_axes(1:2), 'ocean dxtn on t-cells', 'm',&
                                  missing_value=missing_value, range=(/-1e9,1e9/))
  call diagnose_2d(Time, Grid, id_dxtn, Grid%dxtn(:,:))

  id_dyte = register_static_field ('ocean_model', 'dyte', Grid%tracer_axes(1:2), 'ocean dyte on t-cells', 'm',&
                                  missing_value=missing_value, range=(/-1e9,1e9/))
  call diagnose_2d(Time, Grid, id_dyte, Grid%dyte(:,:))

  id_tmask = register_static_field ('ocean_model', 'tmask', Grid%tracer_axes(1:3), 'tracer mask', 'dimensionless',&
                                  missing_value=missing_value, range=(/-1e1,1e1/))
  call diagnose_3d(Time, Grid, id_tmask, Grid%tmask(:,:,:))

  id_umask = register_static_field ('ocean_model', 'umask', Grid%vel_axes_uv(1:3), 'velocity mask', 'dimensionless',&
                                  missing_value=missing_value, range=(/-1e1,1e1/))
  call diagnose_3d_u(Time, Grid, id_umask, Grid%umask(:,:,:))

  id_tmasken(1) = register_static_field ('ocean_model', 'tmasken1', Grid%tracer_axes(1:3), &
                 'min(tmask(i),tmask(i+1))', 'dimensionless', missing_value=missing_value, range=(/-1e1,1e1/))
  call diagnose_3d(Time, Grid, id_tmasken(1), Grid%tmasken(:,:,:,1))

  id_tmasken(2) = register_static_field ('ocean_model', 'tmasken2', Grid%tracer_axes(1:3), &
                 'min(tmask(j),tmask(j+1))', 'dimensionless', missing_value=missing_value, range=(/-1e1,1e1/))
  call diagnose_3d(Time, Grid, id_tmasken(2), Grid%tmasken(:,:,:,2))


end subroutine init_grids_diag
! </SUBROUTINE> NAME="init_grids_diag"



!#######################################################################
! <SUBROUTINE NAME="axes_info">
!
! <DESCRIPTION>
! Set up axes definitions. 
! </DESCRIPTION>
!
subroutine axes_info(Domain, Grid)

  type(ocean_domain_type), intent(in)    :: Domain
  type(ocean_grid_type),   intent(inout) :: Grid

  integer :: id_xt, id_yt, id_xu, id_yu
  integer :: id_zt_bounds, id_zt, id_zw_bounds, id_zw
  integer :: id_st_bounds, id_st, id_sw_bounds, id_sw
  integer :: k

  real, allocatable, dimension(:) :: zt_bounds
  real, allocatable, dimension(:) :: zw_bounds
  real, allocatable, dimension(:) :: st_bounds
  real, allocatable, dimension(:) :: sw_bounds

  real :: meter2dbar 
  meter2dbar = c2dbars*rho0*grav 


  ! horizontal axes
  ! Note: 1d grid arrays are not in general representative of the grid.
  ! Need to generalize diagnostics to employ CF conventions.

  id_xt = diag_axis_init ('xt_'//trim(Grid%name),Grid%grid_x_t,'degrees_E','x','tcell longitude',&
       set_name='ocean', Domain2=Domain%domain2d, aux='geolon_t')
  id_yt = diag_axis_init ('yt_'//trim(Grid%name),Grid%grid_y_t,'degrees_N','y','tcell latitude',&
       set_name='ocean', Domain2=Domain%domain2d, aux='geolat_t')
  id_xu = diag_axis_init ('xu_'//trim(Grid%name),Grid%grid_x_u,'degrees_E','x','ucell longitude',&
       set_name='ocean', Domain2=Domain%domain2d, aux='geolon_c')
  id_yu = diag_axis_init ('yu_'//trim(Grid%name),Grid%grid_y_u,'degrees_N','y','ucell latitude',&
       set_name='ocean', Domain2=Domain%domain2d, aux='geolat_c')


  ! vertical axes (needs to be re-thought for partial cells and general vertical coordinates)

  allocate(zt_bounds(Grid%nk+1))
  allocate(zw_bounds(Grid%nk+1))
  zt_bounds(1) = Grid%zt(1)-Grid%dzt(1)/2.0
  zw_bounds(1) = Grid%zw(1)-Grid%dzw(1)/2.0
  do k=2,Grid%nk+1
     zt_bounds(k)=zt_bounds(k-1)+Grid%dzt(k-1)
     zw_bounds(k)=zw_bounds(k-1)+Grid%dzw(k-1)
  enddo

  allocate(st_bounds(Grid%nk+1))
  allocate(sw_bounds(Grid%nk+1))

  if(vert_coordinate_class==DEPTH_BASED) then 
      ! for depth-based, st and sw are > 0 and dst and dsw are > 0
      st_bounds(1) = Grid%st(1)-Grid%dst(1)/2.0
      sw_bounds(1) = Grid%sw(1)-Grid%dsw(1)/2.0
      do k=2,Grid%nk+1
         st_bounds(k)=st_bounds(k-1)+Grid%dst(k-1)
         sw_bounds(k)=sw_bounds(k-1)+Grid%dsw(k-1)
      enddo
  else
      ! for pressure-based, st and sw are > 0 but dst and dsw are < 0
      st_bounds(1) = Grid%st(1)+Grid%dst(1)/2.0
      sw_bounds(1) = Grid%sw(1)+Grid%dsw(1)/2.0
      do k=2,Grid%nk+1
         st_bounds(k)=st_bounds(k-1)-Grid%dst(k-1)
         sw_bounds(k)=sw_bounds(k-1)-Grid%dsw(k-1)
      enddo
  endif


  if(vert_coordinate==GEOPOTENTIAL) then 

      id_zt_bounds = diag_axis_init ('zt_edges_'//trim(Grid%name), zt_bounds, 'meters', 'z',&
           'tcell depth edges',direction=-1, set_name='ocean')

      id_zt = diag_axis_init ('zt_'//trim(Grid%name), Grid%zt, 'meters', 'z','tcell depth',&
           edges = id_zt_bounds,direction=-1, set_name='ocean')

      id_zw_bounds = diag_axis_init ( 'zw_edges_'//trim(Grid%name), zw_bounds, 'meters', 'z',&
           'ucell depth edges',direction=-1, set_name='ocean')

      id_zw = diag_axis_init ( 'zw_'//trim(Grid%name), Grid%zw, 'meters', 'z','ucell depth',&
           edges = id_zw_bounds,direction=-1, set_name='ocean')


      id_st_bounds = diag_axis_init ('st_edges_'//trim(Grid%name), st_bounds, 'meters', 'z',&
           'tcell depth edges',direction=-1, set_name='ocean')

      id_st = diag_axis_init ('st_'//trim(Grid%name), Grid%st, 'meters', 'z','tcell depth',&
           edges = id_st_bounds,direction=-1, set_name='ocean')

      id_sw_bounds = diag_axis_init ( 'sw_edges_'//trim(Grid%name), sw_bounds, 'meters', 'z',&
           'ucell depth edges',direction=-1, set_name='ocean')

      id_sw = diag_axis_init ( 'sw_'//trim(Grid%name), Grid%sw, 'meters', 'z','ucell depth',&
           edges = id_sw_bounds,direction=-1, set_name='ocean')

  elseif(vert_coordinate==ZSTAR) then 

      id_zt_bounds = diag_axis_init ('zt_edges_'//trim(Grid%name), zt_bounds, 'meters', 'z',&
           'tcell zstar depth edges',direction=-1, set_name='ocean')

      id_zt = diag_axis_init ('zt_'//trim(Grid%name), Grid%zt, 'meters', 'z','tcell zstar depth',&
           edges = id_zt_bounds,direction=-1, set_name='ocean')

      id_zw_bounds = diag_axis_init ( 'zw_edges_'//trim(Grid%name), zw_bounds, 'meters', 'z',&
           'ucell zstar depth edges',direction=-1, set_name='ocean')

      id_zw = diag_axis_init ( 'zw_'//trim(Grid%name), Grid%zw, 'meters', 'z','ucell zstar depth',&
           edges = id_zw_bounds,direction=-1, set_name='ocean')


      id_st_bounds = diag_axis_init ('st_edges_'//trim(Grid%name), st_bounds, 'meters', 'z',&
           'tcell zstar depth edges',direction=-1, set_name='ocean')

      id_st = diag_axis_init ('st_'//trim(Grid%name), Grid%st, 'meters', 'z','tcell zstar depth',&
           edges = id_st_bounds,direction=-1, set_name='ocean')

      id_sw_bounds = diag_axis_init ( 'sw_edges_'//trim(Grid%name), sw_bounds, 'meters', 'z',&
           'ucell zstar depth edges',direction=-1, set_name='ocean')

      id_sw = diag_axis_init ( 'sw_'//trim(Grid%name), Grid%sw, 'meters', 'z','ucell zstar depth',&
           edges = id_sw_bounds,direction=-1, set_name='ocean')

  elseif(vert_coordinate==ZSIGMA) then 

      id_zt_bounds = diag_axis_init ('zt_edges_'//trim(Grid%name), zt_bounds, 'meters', 'z',&
           'tcell depth edges',direction=-1, set_name='ocean')

      id_zt = diag_axis_init ('zt_'//trim(Grid%name), Grid%zt, 'meters', 'z','tcell depth',&
           edges = id_zt_bounds,direction=-1, set_name='ocean')

      id_zw_bounds = diag_axis_init ( 'zw_edges_'//trim(Grid%name), zw_bounds, 'meters', 'z',&
           'ucell depth edges',direction=-1, set_name='ocean')

      id_zw = diag_axis_init ( 'zw_'//trim(Grid%name), Grid%zw, 'meters', 'z','ucell depth',&
           edges = id_zw_bounds,direction=-1, set_name='ocean')


      id_st_bounds = diag_axis_init ('st_edges_'//trim(Grid%name), st_bounds, 'dimensioness', 'z',&
           'tcell sigma-depth edges',direction=1, set_name='ocean')

      id_st = diag_axis_init ('st_'//trim(Grid%name), Grid%st, 'dimensionless', 'z','tcell sigma-depth',&
           edges = id_st_bounds,direction=1, set_name='ocean')

      id_sw_bounds = diag_axis_init ( 'sw_edges_'//trim(Grid%name), sw_bounds, 'dimensionless', 'z',&
           'ucell sigma-depth edges',direction=1, set_name='ocean')

      id_sw = diag_axis_init ( 'sw_'//trim(Grid%name), Grid%sw, 'dimensionless', 'z','ucell sigma-depth',&
           edges = id_sw_bounds,direction=1, set_name='ocean')


  elseif(vert_coordinate==PRESSURE) then 

      id_zt_bounds = diag_axis_init ('zt_edges_'//trim(Grid%name), meter2dbar*zt_bounds, 'dbars', 'z',&
           'tcell pressure edges',direction=-1, set_name='ocean')

      id_zt = diag_axis_init ('zt_'//trim(Grid%name), meter2dbar*Grid%zt, 'dbars', 'z','tcell pressure',&
           edges = id_zt_bounds,direction=-1, set_name='ocean')

      id_zw_bounds = diag_axis_init ( 'zw_edges_'//trim(Grid%name), meter2dbar*zw_bounds, 'dbars', 'z',&
           'ucell pressure edges',direction=-1, set_name='ocean')

      id_zw = diag_axis_init ( 'zw_'//trim(Grid%name), meter2dbar*Grid%zw, 'dbars', 'z','ucell pressure',&
           edges = id_zw_bounds,direction=-1, set_name='ocean')


      id_st_bounds = diag_axis_init ('st_edges_'//trim(Grid%name), c2dbars*st_bounds, 'dbars', 'z',&
           'tcell pressure edges',direction=-1, set_name='ocean')

      id_st = diag_axis_init ('st_'//trim(Grid%name), c2dbars*Grid%st, 'dbars', 'z','tcell pressure',&
           edges = id_st_bounds,direction=-1, set_name='ocean')

      id_sw_bounds = diag_axis_init ( 'sw_edges_'//trim(Grid%name), c2dbars*sw_bounds, 'dbars', 'z',&
           'ucell pressure edges',direction=-1, set_name='ocean')

      id_sw = diag_axis_init ( 'sw_'//trim(Grid%name), c2dbars*Grid%sw, 'dbars', 'z','ucell pressure',&
           edges = id_sw_bounds,direction=-1, set_name='ocean')

  elseif(vert_coordinate==PSTAR) then 

      id_zt_bounds = diag_axis_init ('zt_edges_'//trim(Grid%name), meter2dbar*zt_bounds, 'dbars', 'z',&
           'tcell pstar edges',direction=-1, set_name='ocean')

      id_zt = diag_axis_init ('zt_'//trim(Grid%name), meter2dbar*Grid%zt, 'dbars', 'z','tcell pstar',&
           edges = id_zt_bounds,direction=-1, set_name='ocean')

      id_zw_bounds = diag_axis_init ( 'zw_edges_'//trim(Grid%name), meter2dbar*zw_bounds, 'dbars', 'z',&
           'ucell pstar edges',direction=-1, set_name='ocean')

      id_zw = diag_axis_init ( 'zw_'//trim(Grid%name), meter2dbar*Grid%zw, 'dbars', 'z','ucell pstar',&
           edges = id_zw_bounds,direction=-1, set_name='ocean')


      id_st_bounds = diag_axis_init ('st_edges_'//trim(Grid%name), c2dbars*st_bounds, 'dbars', 'z',&
           'tcell pstar edges',direction=-1, set_name='ocean')

      id_st = diag_axis_init ('st_'//trim(Grid%name), c2dbars*Grid%st, 'dbars', 'z','tcell pstar',&
           edges = id_st_bounds,direction=-1, set_name='ocean')

      id_sw_bounds = diag_axis_init ( 'sw_edges_'//trim(Grid%name), c2dbars*sw_bounds, 'dbars', 'z',&
           'ucell pstar edges',direction=-1, set_name='ocean')

      id_sw = diag_axis_init ( 'sw_'//trim(Grid%name), c2dbars*Grid%sw, 'dbars', 'z','ucell pstar',&
           edges = id_sw_bounds,direction=-1, set_name='ocean')


  elseif(vert_coordinate==PSIGMA) then 

      id_zt_bounds = diag_axis_init ('zt_edges_'//trim(Grid%name), meter2dbar*zt_bounds, 'dbars', 'z',&
           'tcell pressure edges',direction=-1, set_name='ocean')

      id_zt = diag_axis_init ('zt_'//trim(Grid%name), meter2dbar*Grid%zt, 'dbars', 'z','tcell pressure',&
           edges = id_zt_bounds,direction=-1, set_name='ocean')

      id_zw_bounds = diag_axis_init ( 'zw_edges_'//trim(Grid%name), meter2dbar*zw_bounds, 'dbars', 'z',&
           'ucell pressure edges',direction=-1, set_name='ocean')

      id_zw = diag_axis_init ( 'zw_'//trim(Grid%name), meter2dbar*Grid%zw, 'dbars', 'z','ucell pressure',&
           edges = id_zw_bounds,direction=-1, set_name='ocean')


      id_st_bounds = diag_axis_init ('st_edges_'//trim(Grid%name), st_bounds, 'dimensionless', 'z',&
           'tcell pressure-sigma edges',direction=-1, set_name='ocean')

      id_st = diag_axis_init ('st_'//trim(Grid%name), Grid%st, 'dimensionless', 'z',&
           'tcell pressure-sigma', edges = id_st_bounds,direction=-1, set_name='ocean')

      id_sw_bounds = diag_axis_init ( 'sw_edges_'//trim(Grid%name), sw_bounds, 'dimensionless', 'z', &
            'ucell pressure-sigma edges',direction=-1, set_name='ocean')

      id_sw = diag_axis_init ( 'sw_'//trim(Grid%name), Grid%sw, 'dimensionless', 'z',&
           'ucell pressure-sigma', edges = id_sw_bounds, direction=-1, set_name='ocean')

  endif


  ! attributes for variables

  Grid%tracer_axes        = (/ id_xt, id_yt, id_st /)
  Grid%tracer_axes_flux_x = (/ id_xu, id_yt, id_st /)
  Grid%tracer_axes_flux_y = (/ id_xt, id_yu, id_st /)
  Grid%tracer_axes_wt     = (/ id_xt, id_yt, id_sw /)

  Grid%tracer_axes_depth        = (/ id_xt, id_yt, id_zt /)
  Grid%tracer_axes_flux_x_depth = (/ id_xu, id_yt, id_zt /)
  Grid%tracer_axes_flux_y_depth = (/ id_xt, id_yu, id_zt /)
  Grid%tracer_axes_wt_depth     = (/ id_xt, id_yt, id_zw /)

  Grid%vel_axes_uv              = (/ id_xu, id_yu, id_st /)
  Grid%vel_axes_wu_depth        = (/ id_xu, id_yu, id_zw /)
  Grid%vel_axes_wt_depth        = (/ id_xt, id_yt, id_zw /)
  Grid%vel_axes_uv_depth        = (/ id_xu, id_yu, id_zt /)
  Grid%vel_axes_flux_x_depth    = (/ id_xt, id_yu, id_zt /)
  Grid%vel_axes_flux_y_depth    = (/ id_xu, id_yt, id_zt /)

  Grid%vel_axes_wu              = (/ id_xu, id_yu, id_sw /)
  Grid%vel_axes_wt              = (/ id_xt, id_yt, id_sw /)
  Grid%vel_axes_flux_x          = (/ id_xt, id_yu, id_st /)
  Grid%vel_axes_flux_y          = (/ id_xu, id_yt, id_st /)

  if(horz_grid == MOM_BGRID) then 
     Grid%vel_axes_u = (/ id_xu, id_yu, id_st /)
     Grid%vel_axes_v = (/ id_xu, id_yu, id_st /)
  else 
     Grid%vel_axes_u = (/ id_xu, id_yt, id_st /)
     Grid%vel_axes_v = (/ id_xt, id_yu, id_st /)
  endif 

  deallocate(zt_bounds, zw_bounds)
  deallocate(st_bounds, sw_bounds)

end subroutine axes_info
! </SUBROUTINE> NAME="axes_info"


!#######################################################################
! <SUBROUTINE NAME="update_boundaries">
!
! <DESCRIPTION>
! Set halo points at model boundaries equal to values at boundaries 
! if no grid connectivity exists. If model is connected along
! boundary (e.g., tripolar) then use mpp_update_domains.
! </DESCRIPTION>
!
subroutine update_boundaries(Domain, Grid, field, i_offset, j_offset, ishift, jshift, field_ref, default_data)  
type(ocean_domain_type),                            intent(inout) :: Domain
type(ocean_grid_type),                              intent(in)    :: Grid
real, dimension(Domain%isd:,Domain%jsd:),           intent(inout) :: field
integer,                                            intent(in)    :: i_offset, j_offset
integer,                                            intent(in)    :: ishift, jshift
real, dimension(Domain%isc:,Domain%jsc:), optional, intent(inout) :: field_ref
real,                                     optional, intent(in)    :: default_data

integer                                                      :: i,j
real, dimension(Domain%isd:Domain%ied+ishift,Domain%jsd:Domain%jed+jshift) :: tmp
real, dimension(:,:), allocatable                                          :: tmp2
integer                                                      :: isc, iec, jsc, jec
integer                                                      :: isd, ied, jsd, jed
integer                                                      :: isg, ieg, jsg, jeg
integer                                                      :: xhalo, yhalo
real                                                         :: default_value

 isc = Domain%isc; iec = Domain%iec
 jsc = Domain%jsc; jec = Domain%jec
 isd = Domain%isd; ied = Domain%ied
 jsd = Domain%jsd; jed = Domain%jed
 isg = Domain%isg; ieg = Domain%ieg
 jsg = Domain%jsg; jeg = Domain%jeg
 xhalo = Domain%xhalo; yhalo = Domain%yhalo
 default_value = 0
 if(present(default_data)) default_value = default_data

 if(ishift == 0 .AND. jshift == 0) then
    call mpp_update_domains(field,Domain%domain2d)
 else
    if(ishift == 1 .AND. jshift == 0) then
       allocate(tmp2(isd:ied+ishift,jsd:jed+jshift) )
       tmp2 = field
       call mpp_update_domains(tmp2, Domain%domain2d, position = EAST)
    else if(ishift == 0 .AND. jshift == 1) then
       allocate(tmp2(isd+ishift:ied+ishift,jsd+jshift:jed+jshift) )
       tmp2(isd+ishift:ied+ishift,jsd+jshift:jed+jshift) = field(isd+ishift:ied+ishift,jsd+jshift:jed+jshift)
       call mpp_update_domains(tmp2, Domain%domain2d)
    else
       call mpp_error(FATAL, "ocean_grids_mod(update_boundaries): invalid value of ishift and/or jshift")
    endif
    field(isd+ishift:ied+ishift,jsd+jshift:jed+jshift) = tmp2(isd+ishift:ied+ishift,jsd+jshift:jed+jshift)
    deallocate(tmp2)
 endif

!    call mpp_update_domains(field(isd+ishift:ied+ishift,jsd+jshift:jed+jshift), Domain%domain2d)
 iec = iec+ishift; jec = jec+jshift
 ied = ied+ishift; jed = jed+jshift
 ieg = ieg+ishift; jeg = jeg+jshift


 if (Grid%tripolar) then
    tmp = default_value
    if(i_offset == 0 .AND. j_offset == 0) then
       if(present(field_ref)) then
          tmp(isc:iec,jsc:jec) = field_ref(isc:iec,jsc:jec)
       else
          tmp(isc:iec,jsc:jec) = field(isc:iec,jsc:jec)
       endif 
       call mpp_update_domains(tmp,Domain%domain2d)    
    else if(i_offset == -1 .AND. j_offset == -1) then
       if(present(field_ref)) then
          tmp(isc:iec,jsc:jec) = field_ref(isc:iec,jsc:jec)
       else
          tmp(isc:iec,jsc:jec) = field(isc:iec,jsc:jec)
       endif
       call mpp_update_domains(tmp,Domain%domain2d,position=CORNER) 
    else if(i_offset == -1 .AND. j_offset == 0) then
       tmp(isc:iec,jsc:jec) = field(isc:iec,jsc:jec)
       call mpp_update_domains(tmp,Domain%domain2d,position=EAST)
    else if(i_offset == 0 .AND. j_offset == -1) then
       tmp(isc:iec,jsc:jec) = field(isc:iec,jsc:jec)
       call mpp_update_domains(tmp,Domain%domain2d,position=NORTH)
    else if(i_offset == -1 .AND. j_offset == -2) then
       tmp(isc:iec,jsc+1:jec) = field(isc:iec,jsc:jec-1)
       call mpp_update_domains(tmp, Domain%domain2d,position=CORNER)
    else if(i_offset == -2 .AND. j_offset == -1) then 
       tmp(isc:iec,jsc:jec) = field(isc-1:iec-1,jsc:jec)
       call mpp_update_domains(tmp, Domain%domain2d,position=CORNER)
    else 
       call mpp_error(FATAL, "ocean_grids_mod(update_boundaries): invalid value of i_offset and/or j_offset")
    endif
     if(jec + Domain%joff == jeg) field(isd:ied,jec+1:jed) = tmp(isd:ied,jec+1:jed)
 endif

! fill e/w halo points along computational rows
if (iec + Domain%ioff == ieg .and. .not. Grid%cyclic_x) then
   do i=iec+1,iec+xhalo
      field(i,jsc:jec) = field(iec,jsc:jec)
   enddo
endif
if (isc + Domain%ioff == isg .and. .not. Grid%cyclic_x) then
   do i=isc-xhalo,isc-1
      field(i,jsc:jec) = field(isc,jsc:jec)
   enddo
endif

! fill southernmost halo rows
if (jsc + Domain%joff == jsg .and. .not. Grid%cyclic_y) then
   do j=jsc-yhalo,jsc-1
      field(:,j) = field(:,jsc)
   enddo
endif

! fill northernmost halo rows
if (jec + Domain%joff == jeg) then
   if (.not. Grid%tripolar .and. .not. Grid%cyclic_y) then
      do j=jec+1,jec+yhalo
         field(:,j) = field(:,jec)
      enddo
   endif
endif

! fill halo points at west boundary along south halo rows 
if (.not. (Grid%cyclic_x .or. Grid%cyclic_y) .and. isc + Domain%ioff == isg .and. jsc + Domain%joff /= jsg ) then 
   do j=jsc-yhalo,jsc-1
      do i=isc-xhalo,isc-1
         field(i,j) = field(isc,j)
      enddo
   enddo
endif

! fill halo points at west boundary along north halo rows
if (.not. (Grid%cyclic_x .or. Grid%cyclic_y) .and. isc + Domain%ioff == isg .and. jec + Domain%joff /= jeg ) then 
   do j=jec+1,jec+yhalo
      do i=isc-xhalo,isc-1
         field(i,j) = field(isc,j)
      enddo
   enddo
endif

! fill halo points at east boundary along south halo rows
if (.not. (Grid%cyclic_x .or. Grid%cyclic_y) .and. iec + Domain%ioff == ieg .and. jsc + Domain%joff /= jsg) then 
   do j=jsc-yhalo,jsc-1
      do i=iec+1,iec+xhalo
         field(i,j) = field(iec,j)
      enddo
   enddo
endif

! fill halo points east boundary along north halo rows (I know, it is confusing !!)
if (.not. (Grid%cyclic_x .or. Grid%cyclic_y) .and. iec + Domain%ioff == ieg .and. jec + Domain%joff /= jeg) then 
   do j=jec+1,jec+yhalo
      do i=iec+1,iec+xhalo
         field(i,j) = field(iec,j)
      enddo
   enddo
endif

return

end subroutine update_boundaries
! </SUBROUTINE> NAME="update_boundaries"

end module ocean_grids_mod

module ocean_blob_dynamic_free_mod
!
!<CONTACT EMAIL="m.bates@student.unsw.edu.au"> Michael L. Bates
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! This module runs the dynamic free blob implementation of the embedded
! Lagrangian blob framework.  The module forms new dynamic free blobs,
! integrates the properties of existing blobs, and handles the transfer
! of bottom blobs to free blobs.
!</OVERVIEW>
!
!<DESCRIPTION>
! Free blobs are formed using the subroutine blob_dynamic_free_implicit,
! which is called from the blob driver module.  Free blobs must be formed 
! implicitly in time so that the surface forcing has already been applied.
! 
! The properties of free blobs are also integrated in this module, that is,
! position, velocity, mass and tracer content.  Position and velocity are
! integrated using an adaptive step Runge-Kutta scheme.  There are several
! schemes available of varying order.
!
! The module also receives blobs that are transferring from the bottom
! blob dynamic regime to the free blob regime (i.e. they have separated
! from the bottom boundary).
!</DESCRIPTION>
!
!<INFO>
!
! <REFERENCE>
!  Bogacki, P., Shampine, L.F., (1989) A 3(2) pair of Runge-Kutta formulas.
!  Applied Mathematical Letters 2(4), 321-325.
! </REFERENCE>
!
! <REFERENCE>
!  Cash, J.R., Karp, A.H. (1990) A variable order Runge-Kutta method for 
!  initial value problems with rapidly varying right-hand sides.
!  ACM Transactions on Mathematical Software 16(3), 201-222.
! </REFERENCE>
!
! <REFERENCE>
!  Griffies, S.M., Harrison, M.J., Pacanowski, R.C., Rosati, A. (2004)
!  A Technical Guide to MOM4.  GFDL Ocean Group Technical Report No. 5.
!  NOAA/Geophysical Fluid Dynamics Laboratory.
! </REFERENCE>
!
! <REFERENCE>
!  Marshall, J., Schott, F. (1999) Open-ocean convection: Observations, theory,
!  and models.  Reviews of Geophysics 37(1), 1-64.
! </REFERENCE>
!
!<NAMELIST NAME="ocean_blob_dynamic_free_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module.
!  Default is use_this_module=.false.
!  </DATA>
!
!  <DATA NAME="rayleigh_drag_new" TYPE="real">
!  Rayleigh drag coefficient (1/s) for new blobs that
!  are formed due to the vertical instability
!  criterion.  Corresponds to alpha in the notes.  
!  Default is rayleigh_drag_new=1.0e-5
!  </DATA>
!
!  <DATA NAME="rayleigh_drag_bot" TYPE="real">
!  Rayleigh drag coefficient (1/s) for bottom blobs
!  that become free blobs.  Corresponds to alpha in 
!  the notes.
!  Default is rayleigh_drag_bot=1.0e-7
!  </DATA>
!
!  <DATA NAME="update_method" TYPE="character">
!  Decide which method to use to integrate the 
!  blobs.  Choices are 'BS_RK3(2)' or 'CK_RK5(4)'
!  for the Bogaki-Shampine or Cash-Karp methods
!  respectively.
!  Default is update_method='CK_RK5(4)
!  </DATA>
!
!  <DATA NAME="rel_error" TYPE="real">
!  Relative error for the RK scheme (dimensionless).
!  A smaller number is more accurate, but, 
!  is more computationally expensive. Corresponds to
!  zeta* in the notes.
!  Must be 0<rel_error<=1.0
!  Default is rel_error=0.01
!  </DATA>
!
!  <DATA NAME="safety_factor" TYPE="real">
!  Safety factor for the RK scheme (dimensionless).
!  A smaller number should reduce the number
!  of rejected steps, but, decreases the locally
!  extrapolated step.  Corresponds to varrho in 
!  the notes.
!  Must be 0<safety_factor<=1.0
!  Default is safety_factor=0.8
!  </DATA>
!
!  <DATA NAME="minstep" TYPE="real">
!  Minimum step size (in seconds) for a blob.
!  Default is minstep=9.0
!  </DATA>
!
!  <DATA NAME="size_fact" TYPE="real">
!  An Adjustment for blob size, 0<size_fact<=1.0
!  Corresponds to Lambda in the notes.
!  Default is size_fact=1.0
!  </DATA>
!
!  <DATA NAME="det_param" TYPE="real">
!  The detrainment parameter (kg m^2/s). 
!  Corresponds to Gamma in the notes.
!  Default is det_param=5.0e-8
!  </DATA>
!
!  <DATA NAME="max_detrainment" TYPE="real">
!  The Maximum allowable detrainment velocity (m/s).
!  Default is max_detrainment=1.0e-3
!  </DATA>
!
!  <DATA NAME="bv_freq_threshold" TYPE="real">
!  The buoyancy frequency threshold at which 
!  the scheme will start to create blobs, i.e.
!  blobs will be formed when N^2<bv_freq_threshold
!  Default is bv_freq_threshold=-1.0e-15
!  </DATA>
!
!  <DATA NAME="full_N2" TYPE="logical">
!  Whether to use the buoyancy frequency calculated
!  from the combined E and L system (true) or, from
!  the E system only (false).
!  Default is full_N2=.true.
!  </DATA>
!
!  <DATA NAME="large_speed" TYPE="real">
!  A value for error checking.  If the speed of a
!  blob exceeds large_speed in any of x,y,z then
!  a warning flag is raised.
!  Default is large_speed=10.0
!  </DATA>
!
!</NAMELIST>
!</INFO>
!
use constants_mod,    only: deg_to_rad, epsln, pi
use diag_manager_mod, only: register_diag_field, send_data

use fms_mod,         only: stdout, stdlog, open_namelist_file, WARNING, FATAL
use fms_mod,         only: mpp_error, check_nml_error, close_file
use mpp_mod,         only: mpp_send, mpp_recv, NULL_PE, mpp_sum, mpp_sync_self
use mpp_mod,         only: mpp_set_current_pelist
use mpp_mod,         only: CLOCK_LOOP, CLOCK_ROUTINE, mpp_clock_id, mpp_clock_begin, mpp_clock_end
use mpp_domains_mod, only: mpp_update_domains, mpp_global_sum

use ocean_blob_util_mod,  only: E_and_L_totals, count_blob, reallocate_interaction_memory
use ocean_blob_util_mod,  only: insert_blob, allocate_interaction_memory, interp_tcoeff, interp_ucoeff
use ocean_blob_util_mod,  only: check_ijcell, check_kcell, kill_blob, free_blob_memory
use ocean_blob_util_mod,  only: blob_delete, unlink_blob, check_cyclic
use ocean_density_mod,    only: density, buoyfreq2
use ocean_parameters_mod, only: rho0, rho0r, grav, omega_earth
use ocean_parameters_mod, only: PRESSURE_BASED, DEPTH_BASED, onehalf, onethird, twothirds, onefourth
use ocean_types_mod,      only: ocean_time_type, ocean_grid_type, ocean_domain_type
use ocean_types_mod,      only: ocean_lagrangian_type, ocean_thickness_type
use ocean_types_mod,      only: ocean_blob_type, ocean_prog_tracer_type
use ocean_types_mod,      only: ocean_density_type, ocean_velocity_type, blob_diag_type
use ocean_types_mod,      only: ocean_external_mode_type, blob_grid_type, ocean_adv_vel_type
use ocean_util_mod,       only: write_timestamp
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3

implicit none

private

type(ocean_grid_type),   pointer :: Grd  => NULL()
type(ocean_domain_type), pointer :: Dom  => NULL()
type(ocean_domain_type), pointer :: Bdom => NULL() !A domain variable with halo=2
type(blob_grid_type),    pointer :: Info => NULL()

! Module wide variables that are inherited/derived from the main model
real, allocatable, dimension(:,:,:) :: umask    !umask, but, halo=2
real, allocatable, dimension(:,:,:) :: tmask    !tmask, but, halo=2
real, allocatable, dimension(:,:)   :: datdtime !Grd%dat*dtime
integer :: vert_coordinate_class
integer :: vert_coordinate
real :: dtime
real :: dtime_yr

! Useful variables
real :: two_omega
real :: p5_dtime
real :: grav_dtime
real :: det_factor

!RK coefficients
real, dimension(:,:), allocatable :: beta
real, dimension(:),   allocatable :: lgamma
real, dimension(:),   allocatable :: hgamma
real :: order
real :: orderp1_r

!Useful indexes
integer :: num_prog_tracers=0
integer :: index_temp=-1
integer :: index_salt=-1
integer :: isd,ied,jsd,jed
integer :: isc,iec,jsc,jec
integer :: isg,ieg,jsg,jeg
integer :: nk
integer :: isbd, iebd, jsbd, jebd
integer :: method
integer :: iq(4), jq(4)
integer :: ns, nsp1, total_ns, total_nsp1, total_nsp2

integer :: id_clock_dyn_update
integer :: id_clock_part_cycle
integer :: id_clock_rk
integer :: id_clock_updatevars
integer :: id_clock_findEvars

!Diagnostics
integer, allocatable, dimension(:) :: id_tracer_new
logical :: used
integer :: id_bot_to_free
integer :: id_new_blobs

!Buffers, for sending blobs between compute domains
type, private :: blob_buffer_type
   integer :: numblobs
   integer :: size
   integer :: pe
   integer, allocatable, dimension(:,:) :: integer_buff
   real,    allocatable, dimension(:,:) :: real_buff
   integer, allocatable, dimension(:,:,:) :: history_integer_buff
   real,    allocatable, dimension(:,:,:) :: history_real_buff
end type blob_buffer_type

integer :: rea_buff_size      !size of the real buffer
integer :: int_buff_size      !size of the integer buffer
integer :: hist_rea_buff_size !size of the real history buffer
integer :: hist_int_buff_size !size of the integer history buffer

!The buffers themselves
type(blob_buffer_type), pointer :: Ebuffer_out,  Ebuffer_in
type(blob_buffer_type), pointer :: Wbuffer_out,  Wbuffer_in
type(blob_buffer_type), pointer :: Nbuffer_out,  Nbuffer_in
type(blob_buffer_type), pointer :: Sbuffer_out,  Sbuffer_in
type(blob_buffer_type), pointer :: NEbuffer_out, NEbuffer_in
type(blob_buffer_type), pointer :: NWbuffer_out, NWbuffer_in
type(blob_buffer_type), pointer :: SEbuffer_out, SEbuffer_in
type(blob_buffer_type), pointer :: SWbuffer_out, SWbuffer_in

integer, parameter :: delta_buffer = 25   ! Size by which to increment the buffer

public blob_dynamic_free_init
public blob_dynamic_free_implicit
public blob_dynamic_free_update
public transfer_bottom_to_free
public blob_dynamic_free_end

! Module wide variables that are controlled by the ocean_blob_nml and ocean_blob_diag_nml
logical :: debug_this_module
logical :: really_debug
logical :: bitwise_reproduction
logical :: module_is_initialized=.false.
logical :: blob_diag
real    :: small_mass

! namelist defaults
logical           :: use_this_module   = .false.
real              :: rayleigh_drag_new = 1.0e-5  ! Rayleigh drag coefficient (1/s) for newly formed blobs
real              :: rayleigh_drag_bot = 1.0e-7  ! Rayleigh drag coefficient (1/s) for bottom blobs that become free blobs
character(len=10) :: update_method     = 'CK_RK5(4)'
real              :: rel_error         = 0.01    ! Relative error for the RK scheme (non-dimensional, 0<rel_error<=1.0)
real              :: safety_factor     = 0.8     ! Safety factor for the RK scheme (non-dimensional, 0<safety_factor<=1.0)
real              :: minstep           =  9.0    ! Minimum step for a blob (seconds)
real              :: first_step        = 50.0    ! Size of first step of a blob
real              :: size_fact         = 1.0     ! Adjustment for blob size (non-dimensional, 0<size_fact<=1.0)
real              :: det_param         = 5.e-8   ! Detrainment parameter (Gamma; kg m**2 / s)
real              :: max_detrainment   = 1.e-3   ! Maximum detrainment velocity (m/s)
real              :: bv_freq_threshold = -1.e-15 ! The stability threshold at which to form blobs (1/s**2)
logical           :: full_N2           =.true.
real              :: large_speed       = 10.0    ! For stability checking (m/s)

namelist /ocean_blob_dynamic_free_nml/ use_this_module, rayleigh_drag_new, &
     rayleigh_drag_bot, update_method, rel_error, safety_factor, minstep,  &
     first_step, size_fact, det_param, max_detrainment, bv_freq_threshold, &
     full_N2, large_speed

contains
!#######################################################################
! <SUBROUTINE NAME="blob_dynamic_free_init">
!
! <DESCRIPTION>
! Initialises the dynamic free blobs by checking the namelist and also
! inherited namelists (from ocean_blob_nml).  Also sets up some useful
! constants, allocates memory to special halo=2 masks and sets up 
! the blob buffers for sending blobs from one PE to another.
! </DESCRIPTION>
!
subroutine blob_dynamic_free_init(Grid, Domain, Time, T_prog, Blob_domain,         &
                                  PE_info, debug, big_debug, bitwise, num_tracers, &
                                  itemp, isalt, dtimein, ver_coord_class,          &
                                  ver_coord,  blob_diagnostics, free_minstep,      &
                                  free_total_ns, smallmass, use_dyn_fre)

  type(ocean_grid_type),        intent(in), target :: Grid
  type(ocean_domain_type),      intent(in), target :: Domain
  type(ocean_time_type),        intent(in)         :: Time
  type(ocean_prog_tracer_type), intent(in)         :: T_prog(:)
  type(ocean_domain_type),      intent(in), target :: Blob_domain
  type(blob_grid_type),         intent(in), target :: PE_info
  logical, intent(in)  :: debug
  logical, intent(in)  :: big_debug
  logical, intent(in)  :: bitwise
  integer, intent(in)  :: num_tracers
  integer, intent(in)  :: itemp
  integer, intent(in)  :: isalt
  real,    intent(in)  :: dtimein
  integer, intent(in)  :: ver_coord_class
  integer, intent(in)  :: ver_coord
  logical, intent(in)  :: blob_diagnostics
  real,    intent(out) :: free_minstep
  integer, intent(out) :: free_total_ns
  real,    intent(in)  :: smallmass
  logical, intent(out) :: use_dyn_fre

  real, parameter :: secs_in_year_r = 1.0 / (86400.0 * 365.25)

  integer :: n
  integer :: ioun, ierr, io_status
  integer :: stdoutunit,stdlogunit
  character(32) :: myname, myunit

  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL,&
         '==>Error in ocean_blob_dynamic_free_mod (ocean_blob_dynamic_free_init):' &
         //' module already initialized')
  endif 

  ! provide for namelist over-ride of default values
  ioun =  open_namelist_file()
  read (ioun,ocean_blob_dynamic_free_nml,IOSTAT=io_status)
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_blob_dynamic_free_nml)  
  write (stdlogunit,ocean_blob_dynamic_free_nml)
  ierr = check_nml_error(io_status,'ocean_blob_dynamic_free_nml')
  call close_file (ioun)

  module_is_initialized = .true.
  
  ! The way things are formulated, we cannot run the bottom blobs
  ! without running free blobs.  But, we can stop free blobs being
  ! formed by the vertical instability condition.  So, if dynamic
  ! bottom blos are selected, we overwrite use_this_module for 
  ! the dynamic free blobs, however, we ensure that the formation
  ! of free blobs by vertical instabily is not invoked.
  use_dyn_fre = use_this_module

  id_bot_to_free = register_diag_field('ocean_model', 'bot_to_free', Time%model_time, &
       'blobs separating from the bottom', 'number of blobs')

  if (.not. use_this_module) return

  id_new_blobs   = register_diag_field('ocean_model', 'new_free_blobs', Time%model_time, &
       'new free blobs', 'number of blobs')

  blob_diag            = blob_diagnostics
  free_minstep         = minstep
  index_temp           = itemp
  index_salt           = isalt
  num_prog_tracers     = num_tracers
  debug_this_module    = debug
  really_debug         = big_debug
  bitwise_reproduction = bitwise
  small_mass           = smallmass

  vert_coordinate_class = ver_coord_class
  vert_coordinate       = ver_coord

  Grd  => Grid
  Dom  => Domain
  Bdom => Blob_domain
  Info => PE_info

  isd=Dom%isd; ied=Dom%ied; jsd=Dom%jsd; jed=Dom%jed
  isc=Dom%isc; iec=Dom%iec; jsc=Dom%jsc; jec=Dom%jec
  isg=Dom%isg; ieg=Dom%ieg; jsg=Dom%jsg; jeg=Dom%jeg
  nk = Grd%nk

  isbd=Bdom%isd; iebd=Bdom%ied; jsbd=Bdom%jsd; jebd=Bdom%jed 

  !1: (i-1,j-1), 2:(i-1,j), 3:(i,j), 4:(i,j-1)
  iq(1)=-1; jq(1)=-1
  iq(2)=-1; jq(2)= 0
  iq(3)= 0; jq(3)= 0
  iq(4)= 0; jq(4)=-1 

  allocate(umask(isbd:iebd,jsbd:jebd,1:nk))
  allocate(tmask(isbd:iebd,jsbd:jebd,0:nk)) !we need tmask(0:nk) for the W grid
  umask(isc:iec,jsc:jec,1:nk) = Grd%umask(isc:iec,jsc:jec, 1:nk)
  tmask(isc:iec,jsc:jec,1:nk) = Grd%tmask(isc:iec,jsc:jec, 1:nk)
  tmask(isc:iec,jsc:jec,0)    = Grd%tmask(isc:iec,jsc:jec, 1)
  call mpp_update_domains(umask(:,:,:), Bdom%domain2d)
  call mpp_update_domains(tmask(:,:,:), Bdom%domain2d)
  ! special treatment for boundaries if they are NULL_PEs.
  ! Make sure that umask==0 and tmask==0
  if (Info%pe_S==NULL_PE) then
     umask(:,jsbd:jsd,:) = 0.0
     tmask(:,jsbd:jsd,:) = 0.0
  endif
  if (Info%pe_N==NULL_PE) then
     umask(:,jed:jebd,:) = 0.0
     tmask(:,jed:jebd,:) = 0.0
  endif
  if (Info%pe_E==NULL_PE) then
     umask(ied:iebd,:,:) = 0.0
     tmask(ied:iebd,:,:) = 0.0
  endif
  if (Info%pe_W==NULL_PE) then
     umask(isbd:isd,:,:) = 0.0
     tmask(isbd:isd,:,:) = 0.0
  endif

  allocate( datdtime(isd:ied,jsd:jed) )
  datdtime(:,:) = Grd%dat(:,:)*dtimein

  dtime      = dtimein
  dtime_yr   = dtime*secs_in_year_r
  grav_dtime = grav*dtime
  p5_dtime   = onehalf*dtime !for convenience
  two_omega  = 2.0*omega_earth

  solver_method: select case(trim(update_method))
  case('BS_RK3(2)')
     method = 1

     allocate(beta(1:3,0:2)); beta(:,:) = 0.
     allocate(lgamma(0:3)); lgamma(:)   = 0. !2nd order coefficients
     allocate(hgamma(0:3)); hgamma(:)   = 0. !3rd order coefficients
     
     beta(1,0)   =    1/2.
     beta(2,0:1) = (/ 0.,    3/4.       /)
     beta(3,0:2) = (/ 2/9.,  1/3., 4/9. /)
     
     hgamma(0:3) = (/ 2/9.,  1/3., 4/9., 0.   /)
     lgamma(0:3) = (/ 7/24., 1/4., 1/3., 1/8. /)
     
     order     = 2.
     orderp1_r = 1/(order + 1.)

  case('CK_RK5(4)')
     method = 3

     allocate(beta(1:5,0:4)); beta(:,:) = 0.
     allocate(lgamma(0:5));   lgamma(:) = 0. !4th order coefficients
     allocate(hgamma(0:5));   hgamma(:) = 0. !5th order coefficients
     
     beta(1,0)   =        1/5.
     beta(2,0:1) = (/     3/40.   ,   9/40.  /)
     beta(3,0:2) = (/     3/10.   ,  -9/10. ,   6/5.     /)
     beta(4,0:3) = (/   -11/54.   ,   5/2.  , -70/27.   ,    35/27.    /)
     beta(5,0:4) = (/  1631/55296., 175/512., 575/13824., 44275/110592.,   253/4096. /)
     
     hgamma(0:5) = (/   37/378.  , 0.,   250/621.  ,   125/594.  ,  0.       , 512/1771. /)
     lgamma(0:5) = (/ 2825/27648., 0., 18575/48384., 13525/55296., 277/14336.,   1/4.    /)
     
     order     = 4.
     orderp1_r = 1/(order + 1.)

  case default
     write(stdoutunit,'(a)')&
          '==>Error in ocean_blob_dynamic_free_mod (ocean_blob_dynamic_free_init):' &
          //' invalid solver chosen ('//update_method//').  Check update_method in namelist.'
     call mpp_error(FATAL,&
          '==>Error in ocean_blob_dynamic_free_mod (ocean_blob_dynamic_free_init):' &
          //' invalid solver chosen ('//update_method//').  Check update_method in namelist.')
  endselect solver_method

  if (method==0) minstep=dtime
  ns            = ubound(lgamma,1) !number of partial steps in a fractional step
  nsp1          = ns+1             !number of partial steps in a fractional step+1
  total_ns      = ceiling(dtime/minstep)
  total_nsp1    = total_ns+1
  total_nsp2    = total_nsp1+1
  free_total_ns = total_ns

  ! This collects all the constant terms together in the expression
  ! for the rate of change of mass.
  ! dm/dt = rhoL A D (A=blob surface area, D=detrainment rate)
  !       = -rhoL A Gamma/|rhoL - rhoE|
  !       = -m**2/3 Gamma rhoL (36pi)**1/3 / (rhoL**2/3 |rhoL-rhoE|)
  !
  ! In the Boussinesq case rhoL=rho0 (outside |rhoL-rhoE|)
  ! we also need to take into account that this is done for each PARTIAL step.
  if (vert_coordinate_class==DEPTH_BASED) then
     ! here: det_factor = Gamma (rho0*36pi)**1/3 / number of partial steps
     det_factor = det_param*( (rho0*36*pi)**onethird )
  else !PRESSURE_BASED
     ! here: det_factor = Gamma (36pi)**1/3
     det_factor = det_param*( (36*pi)**onethird )
  endif

  ! Allocate the buffers
  ! Things that dictate the size of the real buffer are:
  ! tracer content (num_prog_tracer), change in mass (1),
  ! change in tracer (num_prog_tracer; only needed for bitwise_reproduction),
  ! velocity(3), position (3),
  ! step size (1), blob time (1), mass (1),  stretching function (2) 
  ! drag (1), dmass(1), gprime (1) and age (1).  
  rea_buff_size = 2*num_prog_tracers+15
  ! Integer buffer is: ijk (3), model_steps (1), hash (1), number (1),
  ! nfrac_steps (1), nsteps (1)
  int_buff_size = 8
  if (bitwise_reproduction) then
     ! History real buffer is: entrainment (num_prog_tracers+1), detrainment (num_prog_tracers+1) 
     ! mass in/out (2).
     hist_rea_buff_size = 2*num_prog_tracers+3 !it is not 2*(num_prog_tracers+1)+2 because the dimension goes from 0 
     ! History integer buffer is: ijk (3)
     hist_int_buff_size = 3
  else
     ! History real buffer is: entrainment (num_prog_tracers+1), detrainment (num_prog_tracers+1) 
     hist_rea_buff_size = 2*num_prog_tracers + 1 !it is not 2*(num_prog_tracers+1) because the dimension goes from 0 
  endif
  call allocate_buffer(Ebuffer_out,  Info%pe_E);  call allocate_buffer(Ebuffer_in,  Info%pe_E)
  call allocate_buffer(Wbuffer_out,  Info%pe_W);  call allocate_buffer(Wbuffer_in,  Info%pe_W)
  call allocate_buffer(Nbuffer_out,  Info%pe_N);  call allocate_buffer(Nbuffer_in,  Info%pe_N)
  call allocate_buffer(Sbuffer_out,  Info%pe_S);  call allocate_buffer(Sbuffer_in,  Info%pe_S)
  call allocate_buffer(NEbuffer_out, Info%pe_NE); call allocate_buffer(NEbuffer_in, Info%pe_NE)
  call allocate_buffer(NWbuffer_out, Info%pe_NW); call allocate_buffer(NWbuffer_in, Info%pe_NW)
  call allocate_buffer(SEbuffer_out, Info%pe_SE); call allocate_buffer(SEbuffer_in, Info%pe_SE)
  call allocate_buffer(SWbuffer_out, Info%pe_SW); call allocate_buffer(SWbuffer_in, Info%pe_SW)

  id_clock_dyn_update = mpp_clock_id('(Ocean dyn. free blob: update)    ',grain=CLOCK_ROUTINE)
  id_clock_part_cycle = mpp_clock_id('(Ocean dyn. free blob: part step) ',grain=CLOCK_LOOP)
  id_clock_rk         = mpp_clock_id('(Ocean dyn. free blob: RK scheme) ',grain=CLOCK_LOOP)
  id_clock_updatevars = mpp_clock_id('(Ocean dyn. free blob: updatevars)',grain=CLOCK_LOOP)
  id_clock_findEvars  = mpp_clock_id('(Ocean dyn. free blob: findEvars) ',grain=CLOCK_LOOP)

  allocate(id_tracer_new(num_prog_tracers))
  do n=1,num_prog_tracers
     if (n==index_temp) then
        myname = 'heat'
        myunit = 'J'
     else
        myname = T_prog(n)%name
        myunit = 'kg'
     endif
     id_tracer_new(n) = register_diag_field('ocean_model',   'new_free_blob_'//trim(myname), &
          Grd%tracer_axes(1:3), Time%model_time, trim(myname)//' transferred from the E to the L system via new free blobs', myunit)
  enddo

contains

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that deallocates memory from a buffer    !
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine allocate_buffer(buffer, pe)
    type(blob_buffer_type), pointer    :: buffer
    integer,                intent(in) :: pe

    allocate(buffer)
    buffer%pe = pe
    buffer%numblobs = 0
    if (buffer%pe /= NULL_PE) then
       buffer%size = delta_buffer
       
       allocate(buffer%integer_buff(int_buff_size, delta_buffer))
       allocate(buffer%real_buff(   rea_buff_size, delta_buffer))
       
       if (bitwise_reproduction) then
          allocate(buffer%history_integer_buff(hist_int_buff_size, 0:total_nsp1, delta_buffer))
          allocate(buffer%history_real_buff( 0:hist_rea_buff_size, 0:total_nsp1, delta_buffer))
       else
          allocate(buffer%history_real_buff(0:hist_rea_buff_size, 1, delta_buffer))
       endif
    endif
  end subroutine allocate_buffer

end subroutine blob_dynamic_free_init
! </SUBROUTINE>  NAME="blob_dynamic_free_init"


!#######################################################################
! <SUBROUTINE NAME="blob_dynamic_free_implicit">
!
! <DESCRIPTION>
! Initialises dynamic blobs in vertical statically unstable regions.
! Due to the instability condition, blobs should be formed after the
! surface forcing has been applied (which is a major source of 
! instability in the water column).  The surface forcing is applied
! implicitly in time in MOM, therefore, we must form blobs implicitly
! in time.
!
! If N^2<bv_freq_threshold, then, two blobs are formed.  One rising
! and one sinking.  The rising blobs is destroyed immediately (after
! it has been moved up one cell) and its properties returned to the E
! system.  The sinking blob is added to a linked list, and its 
! properties integrated at a later time step.
! </DESCRIPTION>
!
subroutine blob_dynamic_free_implicit(Time, Thickness, T_prog, Dens, Adv_vel, &
                                      Velocity, head, blob_counter, EL_diag)
                                          
  type(ocean_time_type),                                intent(in)    :: Time
  type(ocean_thickness_type),                           intent(inout) :: Thickness
  type(ocean_prog_tracer_type),                         intent(inout) :: T_prog(:)
  type(ocean_density_type),                             intent(in)    :: Dens
  type(ocean_adv_vel_type),                             intent(in)    :: Adv_vel
  type(ocean_velocity_type),                            intent(in)    :: Velocity
  type(ocean_blob_type), pointer                                      :: head
  integer,               dimension(isc:iec,jsc:jec,nk), intent(inout) :: blob_counter
  type(blob_diag_type),  dimension(0:num_prog_tracers), intent(inout) :: EL_diag

  real, dimension(isd:ied,jsd:jed,nk) :: bvfreq2
  integer :: i, j, k, kp1, tau, taup1, n, nblobs
  real    :: mass_blob, rhodzt_blob, rhodztk, rhodztkp1
  real    :: rho_dzt_old, rho_dzt_dat_r
  real    :: small
  real    :: wE
  type(ocean_blob_type), pointer :: sink
  type(ocean_blob_type), pointer :: rise

  small  = 1e-3
  nblobs = 0

  ! No need for use_this_module test, as we test for 
  ! use_dyn_fre in ocean_blob_implicit

  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
         '==>Error in ocean_blob_static_free_mod (Lagrangian blob model): '&
         //'module needs to be initialized')
  endif 

  taup1 = Time%taup1
  tau   = Time%tau

  ! Begin by computing the square of the Brunt-Vaisalla Frequency
  if (full_N2) then
     ! Use the combied L and E system for calculating N**2
     do k=1,nk
        wrk1(:,:,k) = ( Thickness%rho_dzt(:,:,k,taup1)*T_prog(index_salt)%field(:,:,k,taup1) &
                        + Grd%datr(:,:)*T_prog(index_salt)%sum_blob(:,:,k,taup1)      )/Thickness%rho_dztT(:,:,k,taup1)
        wrk2(:,:,k) = ( Thickness%rho_dzt(:,:,k,taup1)*T_prog(index_temp)%field(:,:,k,taup1) &
                        + Grd%datr(:,:)*T_prog(index_temp)%sum_blob(:,:,k,taup1)      )/Thickness%rho_dztT(:,:,k,taup1)
     enddo
     wrk3(:,:,:) = density(wrk1(:,:,:), wrk2(:,:,:), Dens%pressure_at_depth(:,:,:))
     bvfreq2(:,:,:) = buoyfreq2(Time, Thickness, Dens, wrk1(:,:,:), wrk2(:,:,:), wrk3(:,:,:), use_this_module) 

     ! We need the E system density for calculations below
     wrk3(:,:,:) = density(T_prog(index_salt)%field(:,:,:,taup1), T_prog(index_temp)%field(:,:,:,taup1), Dens%pressure_at_depth(:,:,:))

  else
     ! Only use the E system for calculating N**2
     wrk3(:,:,:) = density(T_prog(index_salt)%field(:,:,:,taup1), T_prog(index_temp)%field(:,:,:,taup1), Dens%pressure_at_depth(:,:,:))
     bvfreq2(:,:,:) = buoyfreq2(Time, Thickness, Dens, T_prog(index_salt)%field(:,:,:,taup1), &
                                T_prog(index_temp)%field(:,:,:,taup1), wrk3(:,:,:), use_this_module) 
  endif

  do k=1,nk-1
     kp1 = k+1
     do j=jsc,jec
        do i=isc,iec
           if (bvfreq2(i,j,k) < bv_freq_threshold) then
              ! some shorthand variables for convenience
              rhodztk   = Thickness%rho_dzt(i,j,k,  taup1)
              rhodztkp1 = Thickness%rho_dzt(i,j,kp1,taup1)

              ! compute the mass per unit of the two blobs.  Note that
              ! dat is the same for both k and kp1;
              ! mass=(dat*rhodztk * dat*rhodztkp1)/(dat(rhodztk + rhodztkp1))
              !     =dat*rhodztk*rhodztkp1/(rhodztk + rhodztkp1)
              ! mass per unit area = rhodztk*rhodztkp1/(rhodztk + rhodztkp1)
              ! size_fact is a non-dimensional namelist parameter that is 
              ! scales the size of the blob.  0.0<size_fact<=1.0
              rhodzt_blob = size_fact*(rhodztk * rhodztkp1)/(rhodztk + rhodztkp1)

              mass_blob = rhodzt_blob * Grd%dat(i,j)

              ! form the sinking dynamic blob
              allocate(sink)
              allocate(sink%tracer(num_prog_tracers))
              allocate(sink%field(num_prog_tracers))
              
              sink%i         = i
              sink%j         = j
              sink%k         = k
              sink%blob_time = 0.0
              sink%mass      = mass_blob

              ! Assign tracer content and tracer concentration to the blob
              do n=1,num_prog_tracers
                 ! sink%tracer is blob_mass*[concentration]
                 sink%tracer(n) = sink%mass*T_prog(n)%field(i,j,k,taup1)
                 ! even though sink%field is initially the concentration of the grid cell
                 ! we need to calculate it like this to maintain bitwise agreement
                 sink%field(n)  = sink%tracer(n)/sink%mass
              enddo

              ! Calculate the density of the blob at kp1
              sink%density  = density(sink%field(index_salt), &
                                      sink%field(index_temp), &
                                      Dens%pressure_at_depth(i,j,kp1))
              sink%densityr = 1.0/sink%density

              ! the intial vertical velocity
              ! We use rho0r whether it is depth or pressure based coordinates to calculate
              ! the E system vertical velocity.  This represents an error of about 2% in 
              ! pressure based coordinates.
              wE = rho0r * Adv_vel%wrho_bt(i,j,k)
              sink%v(3) = wE - grav_dtime*(sink%density-wrk3(i,j,kp1))*sink%densityr

              if (sink%v(3) > 0.0) then
                 ! the vertical velocity is positive and therefore the blob will want to 
                 ! rise instead of sink.  this can be because of either
                 ! 1/ the pseudo-non-hydrostatic term is positive (i.e. sink%density<rhoE)
                 ! 2/ wE > abs(pseudo-non-hydrostatic term).
                 ! If a blob does not want to sink, then it wants to stay in the original
                 ! grid cell, and there is thus no point in forming it, so
                 ! we dont bother forming it and accept that the water column will remain
                 ! unstable.
                 call free_blob_memory(sink)
                 cycle
              endif

              ! count the blob
              call count_blob(sink, blob_counter)

              ! insert the blob into the linked list
              call insert_blob(sink, head)
              nblobs = nblobs+1

              sink%age = 0.0
              
              ! take the sink blob away from the E systems rho_dzt
              Thickness%rho_dzt(i,j,k,taup1) = Thickness%rho_dzt(i,j,k,taup1) &
                                              - sink%mass * Grd%datr(i,j)

              ! update rho_dztr
              Thickness%rho_dztr(i,j,k) = 1.0/(Thickness%rho_dzt(i,j,k,taup1)+epsln)

              ! We do not need to adjust the E system field for the k grid cell at this
              ! stage.

              ! we take the average of the four surrounding velocity grid cells for the 
              ! initial horizontal velocity of sink
              sink%v(1) = ( Velocity%u(i  ,j  ,k,1,tau) + Velocity%u(i-1,j  ,k,1,tau) &
                          + Velocity%u(i  ,j-1,k,1,tau) + Velocity%u(i-1,j-1,k,1,tau) &
                          )*onefourth

              sink%v(2) = ( Velocity%u(i  ,j  ,k,2,tau) + Velocity%u(i-1,j  ,k,2,tau) &
                          + Velocity%u(i  ,j-1,k,2,tau) + Velocity%u(i-1,j-1,k,2,tau) &
                          )*onefourth
              
              ! find the intial longitude and latitude
              sink%lon = Grd%xt(i,j) + dtime*sink%v(1)/Grd%h1t(i,j)
              sink%lat = Grd%yt(i,j) + dtime*sink%v(2)/Grd%h2t(i,j)

              sink%new  = .true.
              sink%step = first_step
              
              sink%model_steps = 0
              sink%nsteps      = 0

              sink%drag = rayleigh_drag_new
              
              ! Now create the rising blob
              allocate(rise)
              allocate(rise%tracer(num_prog_tracers))

              rise%mass = mass_blob
              ! Assign tracer content and tracer concentration to the blob
              do n=1,num_prog_tracers
                 ! rise%tracer is blob_mass*[concentration]
                 rise%tracer(n) = rise%mass*T_prog(n)%field(i,j,kp1,taup1)
              enddo

              ! take the rise blob away from the E systems rho_dzt
              Thickness%rho_dzt(i,j,kp1,taup1) = Thickness%rho_dzt(i,j,kp1,taup1) &
                                                 - rise%mass * Grd%datr(i,j)

              ! update rho_dztr
              Thickness%rho_dztr(i,j,kp1) = 1.0/(Thickness%rho_dzt(i,j,kp1,taup1)+epsln)
              
              ! Now we swap the two blobs.  sink goes to the kp1 cell and rise goes to the
              ! k cell.
              rise%k = k
              sink%k = kp1

              ! Calculate the depth and position the native vertical coordinate of sink.
              ! We recall that z and depth have opposite signs.
              sink%depth = Thickness%depth_zwt(i,j,k) - p5_dtime*sink%v(3)

              ! If the initial position of the blob is calculated to be deeper than
              ! the bottom of the kp1 cell (in coordinate space), we adjust the initial
              ! position to ensure that the blob remains in the kp1 cell.  We also adjust
              ! the initial velocity to reflect the new imposed position.
              ! Also calculate the volume
              if (vert_coordinate_class == DEPTH_BASED) then
                 sink%st = -( Thickness%depth_swt(i,j,k) + (sink%depth-Thickness%depth_zwt(i,j,k))/Thickness%dzt_dst(i,j,kp1) )
                 if (sink%st <= -Thickness%depth_swt(i,j,kp1)) then
                    sink%st    = -Thickness%depth_swt(i,j,kp1) + small
                    sink%depth =  Thickness%depth_zwt(i,j,kp1) - small*Thickness%dzt_dst(i,j,kp1)
                    sink%v(3)  = -( sink%depth-Thickness%depth_zwt(i,j,k) )/dtime
                 endif
                 sink%volume = sink%mass * rho0r
              else !PRESSURE_BASED
                 sink%st = Thickness%depth_swt(i,j,k) - (sink%depth-Thickness%depth_zwt(i,j,k))/Thickness%dzt_dst(i,j,kp1)
                 if (sink%st >= Thickness%depth_swt(i,j,kp1)) then
                    sink%st    =  Thickness%depth_swt(i,j,kp1) - small
                    sink%depth =  Thickness%depth_zwt(i,j,kp1) + small*Thickness%dzt_dst(i,j,kp1)
                    sink%v(3)  = -( sink%depth-Thickness%depth_zwt(i,j,k) )/dtime
                 endif
                 sink%volume = sink%mass * sink%densityr
              endif
              
              ! Add the blob tracer content to the total blob tracer content
              do n=1,num_prog_tracers
                 T_prog(n)%sum_blob(i,j,kp1,taup1) = T_prog(n)%sum_blob(i,j,kp1,taup1) + sink%tracer(n)
              enddo
              
              ! Now we take care of rise, returning its properties to the E system.

              ! Transfer mass from the Lagrangian system to the Eulerian System
              rho_dzt_old = Thickness%rho_dzt(i,j,k,taup1)
              Thickness%rho_dzt(i,j,k,taup1) = Thickness%rho_dzt(i,j,k,taup1)&
                                               + rise%mass*Grd%datr(i,j)
              Thickness%rho_dztr(i,j,k) = 1.0/(Thickness%rho_dzt(i,j,k,taup1)+epsln)
              rise%mass = rise%mass - rise%mass
              
              ! transfer tracer from the Lagrangian system to the Eulerian System
              rho_dzt_dat_r = Grd%datr(i,j)*Thickness%rho_dztr(i,j,k)
              do n=1,num_prog_tracers
                 T_prog(n)%field(i,j,k,taup1) = rho_dzt_old*Thickness%rho_dztr(i,j,k)*T_prog(n)%field(i,j,k,taup1) &
                                                + rise%tracer(n)*rho_dzt_dat_r
                 rise%tracer(n) = rise%tracer(n) - rise%tracer(n)
              enddo

              call free_blob_memory(rise)
              
              ! Add in some more structure to the sinking blob.  The structure is required
              ! for the E-L system interaction.
              call allocate_interaction_memory(sink, total_ns)

              ! Diagnostics
              EL_diag(0)%new(i,j,k) = EL_diag(0)%new(i,j,k) + sink%mass
              do n=1,num_prog_tracers
                 EL_diag(n)%new(i,j,k) = EL_diag(n)%new(i,j,k) + sink%tracer(n)
              enddo

              ! Need to set this to zero for diagnostics
              sink%ent = 0.0

              nullify(sink)
              
            endif !bv frequency small?
        enddo !i
     enddo !j
  enddo!k

  call mpp_sum(nblobs)
  if (id_new_blobs>0) used = send_data(id_new_blobs, real(nblobs), Time%model_time)

end subroutine blob_dynamic_free_implicit
! </SUBROUTINE>  NAME="blob_dynamic_free_implicit"


!######################################################################
! <SUBROUTINE NAME="blob_dynamic_free_update">
!
! <DESCRIPTION>
! This routine calls the routine to update blob positions.  When
! bitwise_reproduction=.false., it also figures out when to continue
! the integration of blobs that have changed PE's.
! </DESCRIPTION>
!
subroutine blob_dynamic_free_update(Time, Thickness, T_prog, Ext_mode, Dens,      &
                                    L_system, tend_blob, blob_source, press_grad, &
                                    u, w, model_rho, free_head, bottom, &
                                    mass_in, mass_out, EL_diag, ngrnd, nsfc, ndetrn)
  type(ocean_time_type),                               intent(in)    :: Time
  type(ocean_thickness_type),                          intent(inout) :: Thickness
  type(ocean_prog_tracer_type),                        intent(inout) :: T_prog(:)
  type(ocean_external_mode_type),                      intent(inout) :: Ext_mode
  type(ocean_density_type),                            intent(in)    :: Dens
  type(ocean_lagrangian_type),                         intent(inout) :: L_system
  real,dimension(num_prog_tracers,isd:ied,jsd:jed,nk), intent(inout) :: tend_blob
  real,dimension(isd:ied,jsd:jed),                     intent(inout) :: blob_source
  real, dimension(isbd:iebd,jsbd:jebd,1:nk,1:2),       intent(in)    :: press_grad
  real, dimension(isbd:iebd,jsbd:jebd,1:nk,1:2),       intent(in)    :: u
  real, dimension(isbd:iebd,jsbd:jebd,1:nk),           intent(in)    :: w
  real, dimension(isbd:iebd,jsbd:jebd,1:nk),           intent(in)    :: model_rho
  type(ocean_blob_type),                               pointer       :: free_head
  type(ocean_blob_type),                               pointer       :: bottom
  real, dimension(isd:ied,jsd:jed,1:nk),               intent(inout) :: mass_in
  real, dimension(isd:ied,jsd:jed,1:nk),               intent(inout) :: mass_out
  type(blob_diag_type), dimension(0:num_prog_tracers), intent(inout) :: EL_diag
  integer,                                             intent(inout) :: ngrnd
  integer,                                             intent(inout) :: nsfc
  integer,                                             intent(inout) :: ndetrn

  type(ocean_blob_type), pointer :: prev, this, next, buffer_head
  integer :: check_buffers
  integer :: i,j,k,n
  integer :: stdoutunit

  if (.not. use_this_module) return
  
  nullify(bottom)
  nullify(this)

  ! Clear buffers for sending and receiving free blobs
  call clear_buffer(Ebuffer_out);  call clear_buffer( Ebuffer_in)
  call clear_buffer(Wbuffer_out);  call clear_buffer( Wbuffer_in)
  call clear_buffer(Nbuffer_out);  call clear_buffer( Nbuffer_in)
  call clear_buffer(Sbuffer_out);  call clear_buffer( Sbuffer_in)
  call clear_buffer(NEbuffer_out); call clear_buffer(NEbuffer_in)
  call clear_buffer(NWbuffer_out); call clear_buffer(NWbuffer_in)
  call clear_buffer(SEbuffer_out); call clear_buffer(SEbuffer_in)
  call clear_buffer(SWbuffer_out); call clear_buffer(SWbuffer_in)

  if (debug_this_module) then
     stdoutunit = stdout()
     write(stdoutunit, '(a)') ' '
     call write_timestamp(Time%model_time)
     write(stdoutunit,'(a)') 'From ocean_blob_dynamic_free_mod'
     write(stdoutunit,'(a)') 'Totals before free dynamic blob update (tau)'
     call E_and_L_totals(L_system,Thickness,T_prog(:),Time%tau)
     write(stdoutunit,'(a)') ' '
  endif

  ! Reset the blob time to zero for the beginning of the Eulerian time step
  if (associated(free_head)) then
     this=>free_head
     timecycle: do
        this%blob_time = 0.0
        this=>this%next
        if(.not.associated(this)) exit timecycle
     enddo timecycle
  endif

  call mpp_clock_begin(id_clock_dyn_update)
  call dynamic_update(Time, Thickness, Ext_mode, L_system, Dens,     &
                      T_prog(:), tend_blob, blob_source, press_grad, &
                      u, w, model_rho, free_head, bottom,            &
                      mass_in, mass_out, EL_diag(:), ngrnd, nsfc, ndetrn)
  call mpp_clock_end(id_clock_dyn_update)

  if (bitwise_reproduction) then
     ! Send, receive and unpack buffers for free blobs
     call send_buffer( Ebuffer_out) 
     call send_buffer( Wbuffer_out)
     call send_buffer( Sbuffer_out)
     call send_buffer( Nbuffer_out)
     call send_buffer(NEbuffer_out)
     call send_buffer(NWbuffer_out)
     call send_buffer(SEbuffer_out)
     call send_buffer(SWbuffer_out)
  
     call receive_buffer( Wbuffer_in); call unpackbuffer(Time,  Wbuffer_in, free_head, Dens)
     call receive_buffer( Ebuffer_in); call unpackbuffer(Time,  Ebuffer_in, free_head, Dens)
     call receive_buffer( Nbuffer_in); call unpackbuffer(Time,  Nbuffer_in, free_head, Dens)
     call receive_buffer( Sbuffer_in); call unpackbuffer(Time,  Sbuffer_in, free_head, Dens)
     call receive_buffer(SWbuffer_in); call unpackbuffer(Time, SWbuffer_in, free_head, Dens)
     call receive_buffer(SEbuffer_in); call unpackbuffer(Time, SEbuffer_in, free_head, Dens)
     call receive_buffer(NWbuffer_in); call unpackbuffer(Time, NWbuffer_in, free_head, Dens)
     call receive_buffer(NEbuffer_in); call unpackbuffer(Time, NEbuffer_in, free_head, Dens)

     call mpp_sync_self()
  else
     ! When bitwise reproduction is not necessary, blobs can be packed into 
     ! buffers and sent to other PE's before they have finished a full E system
     ! step, i.e. this%blob_time < dtime.
     ! So, here, we unpack the blobs and continue to evolve them on the new PE.
     ! We need to take into account that a blob may traverse more than one PE
     ! in a given E system step, e.g.
     ! ------------------
     ! |       |        |
     ! | PE=2  +a  PE=3 |
     ! |      /|        |
     ! |     b |        |
     ! ------+-----------
     ! |    /  |        |
     ! |   c   |        |
     ! |       |        |
     ! |  PE=0 |   PE=1 |
     ! ------------------
     ! So, we need to keep on checking buffers and evolving blobs until all received 
     ! buffers are empty

     ! Send, receive and unpack buffers for free blobs
     call send_buffer( Ebuffer_out)
     call send_buffer( Wbuffer_out)
     call send_buffer( Sbuffer_out)
     call send_buffer( Nbuffer_out)
     call send_buffer(NEbuffer_out)
     call send_buffer(NWbuffer_out)
     call send_buffer(SEbuffer_out)
     call send_buffer(SWbuffer_out)

     buffer_head=> NULL()
     call receive_buffer( Wbuffer_in) 
     call unpackbuffer(Time,  Wbuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     call receive_buffer( Ebuffer_in)
     call unpackbuffer(Time,  Ebuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     call receive_buffer( Nbuffer_in)
     call unpackbuffer(Time,  Nbuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     call receive_buffer( Sbuffer_in)
     call unpackbuffer(Time,  Sbuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     call receive_buffer(SWbuffer_in)
     call unpackbuffer(Time, SWbuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     call receive_buffer(SEbuffer_in)
     call unpackbuffer(Time, SEbuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     call receive_buffer(NWbuffer_in)
     call unpackbuffer(Time, NWbuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     call receive_buffer(NEbuffer_in) 
     call unpackbuffer(Time, NEbuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     
     call mpp_sync_self()
     
     ! Clear buffers for sending and receiving free blobs
     call clear_buffer(Ebuffer_out);  call clear_buffer( Ebuffer_in)
     call clear_buffer(Wbuffer_out);  call clear_buffer( Wbuffer_in)
     call clear_buffer(Nbuffer_out);  call clear_buffer( Nbuffer_in)
     call clear_buffer(Sbuffer_out);  call clear_buffer( Sbuffer_in)
     call clear_buffer(NEbuffer_out); call clear_buffer(NEbuffer_in)
     call clear_buffer(NWbuffer_out); call clear_buffer(NWbuffer_in)
     call clear_buffer(SEbuffer_out); call clear_buffer(SEbuffer_in)
     call clear_buffer(SWbuffer_out); call clear_buffer(SWbuffer_in)

     check_buffers = 0
     this=>buffer_head
     if (associated(this)) then
        buff_cycle0: do
           if(this%blob_time == dtime) then
              call unlink_blob(this, buffer_head, prev, next)
              call insert_blob(this, free_head)
              this=>next
           else
              check_buffers = check_buffers + 1
              this=>this%next
           endif
           if (.not. associated(this)) exit buff_cycle0
        enddo buff_cycle0
     endif

     call mpp_sum(check_buffers)
     
     do while (check_buffers>0) 
        call dynamic_update(Time, Thickness, Ext_mode, L_system, Dens,     &
                            T_prog(:), tend_blob, blob_source, press_grad, &
                            u, w, model_rho, buffer_head, bottom,          &
                            mass_in, mass_out, EL_diag(:), ngrnd, nsfc, ndetrn)

        call mpp_set_current_pelist()

        ! Send, receive and unpack buffers for free blobs
        call send_buffer( Ebuffer_out) 
        call send_buffer( Wbuffer_out)
        call send_buffer( Sbuffer_out)
        call send_buffer( Nbuffer_out)
        call send_buffer(NEbuffer_out)
        call send_buffer(NWbuffer_out)
        call send_buffer(SEbuffer_out)
        call send_buffer(SWbuffer_out)

        call receive_buffer( Wbuffer_in) 
        call unpackbuffer(Time,  Wbuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
        call receive_buffer( Ebuffer_in)
        call unpackbuffer(Time,  Ebuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
        call receive_buffer( Nbuffer_in)
        call unpackbuffer(Time,  Nbuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
        call receive_buffer( Sbuffer_in)
        call unpackbuffer(Time,  Sbuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
        call receive_buffer(SWbuffer_in)
        call unpackbuffer(Time, SWbuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
        call receive_buffer(SEbuffer_in)
        call unpackbuffer(Time, SEbuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
        call receive_buffer(NWbuffer_in)
        call unpackbuffer(Time, NWbuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
        call receive_buffer(NEbuffer_in) 
        call unpackbuffer(Time, NEbuffer_in, buffer_head, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)

        call mpp_sync_self()

        ! Clear buffers for sending and receiving free blobs
        call clear_buffer(Ebuffer_out);  call clear_buffer( Ebuffer_in)
        call clear_buffer(Wbuffer_out);  call clear_buffer( Wbuffer_in)
        call clear_buffer(Nbuffer_out);  call clear_buffer( Nbuffer_in)
        call clear_buffer(Sbuffer_out);  call clear_buffer( Sbuffer_in)
        call clear_buffer(NEbuffer_out); call clear_buffer(NEbuffer_in)
        call clear_buffer(NWbuffer_out); call clear_buffer(NWbuffer_in)
        call clear_buffer(SEbuffer_out); call clear_buffer(SEbuffer_in)
        call clear_buffer(SWbuffer_out); call clear_buffer(SWbuffer_in)

        check_buffers = 0
        if (associated(buffer_head)) then
           this => buffer_head
           timecheck: do
              if(this%blob_time == dtime) then
                 call unlink_blob(this, buffer_head, prev, next)
                 call insert_blob(this, free_head)
                 this=>next
              else
                 check_buffers = check_buffers + 1
                 this=>this%next
              endif
              if(.not. associated(this)) exit timecheck
           enddo timecheck
        endif
        call mpp_sum(check_buffers)

     enddo

  endif!bitwise_reproduction

  ! Pack and send buffers for free blobs that have become bottom blobs

  ! Clear buffers for sending and receiving bottom blobs
  call clear_buffer(Ebuffer_out);  call clear_buffer( Ebuffer_in)
  call clear_buffer(Wbuffer_out);  call clear_buffer( Wbuffer_in)
  call clear_buffer(Nbuffer_out);  call clear_buffer( Nbuffer_in)
  call clear_buffer(Sbuffer_out);  call clear_buffer( Sbuffer_in)
  call clear_buffer(NEbuffer_out); call clear_buffer(NEbuffer_in)
  call clear_buffer(NWbuffer_out); call clear_buffer(NWbuffer_in)
  call clear_buffer(SEbuffer_out); call clear_buffer(SEbuffer_in)
  call clear_buffer(SWbuffer_out); call clear_buffer(SWbuffer_in)

  if (associated(bottom)) then
     this=>bottom
     blobcycle: do

        i = this%i
        j = this%j
        k = this%k

        if     (i>iec .and. j>jec) then
           call packbottombuffer(NEbuffer_out)
        elseif (i<isc .and. j>jec) then
           call packbottombuffer(NWbuffer_out)
        elseif (i>iec .and. j<jsc) then
           call packbottombuffer(SEbuffer_out)
        elseif (i<isc .and. j<jsc) then
           call packbottombuffer(SWbuffer_out)
        elseif (i>iec)             then
           call packbottombuffer(Ebuffer_out)
        elseif (i<isc)             then
           call packbottombuffer(Wbuffer_out)
        elseif (j>jec)             then
           call packbottombuffer(Nbuffer_out)
        elseif (j<jsc)             then
           call packbottombuffer(Sbuffer_out)
        endif
        this=>this%next
        if(.not.associated(this)) exit blobcycle
     enddo blobcycle
  endif

  ! Send buffers for free blobs that have become bottom blobs
  call send_buffer( Ebuffer_out)
  call send_buffer( Wbuffer_out)
  call send_buffer( Sbuffer_out)
  call send_buffer( Nbuffer_out)
  call send_buffer(NEbuffer_out)
  call send_buffer(NWbuffer_out)
  call send_buffer(SEbuffer_out)
  call send_buffer(SWbuffer_out)

  ! Receive and unpack free blobs that have become bottom blobs
  if (bitwise_reproduction) then
     call receive_buffer( Ebuffer_in); call unpackbuffer(Time,  Ebuffer_in, bottom, Dens)
     call receive_buffer( Wbuffer_in); call unpackbuffer(Time,  Wbuffer_in, bottom, Dens)
     call receive_buffer( Nbuffer_in); call unpackbuffer(Time,  Nbuffer_in, bottom, Dens)
     call receive_buffer( Sbuffer_in); call unpackbuffer(Time,  Sbuffer_in, bottom, Dens)
     call receive_buffer(NEbuffer_in); call unpackbuffer(Time, NEbuffer_in, bottom, Dens)
     call receive_buffer(NWbuffer_in); call unpackbuffer(Time, NWbuffer_in, bottom, Dens)
     call receive_buffer(SEbuffer_in); call unpackbuffer(Time, SEbuffer_in, bottom, Dens)
     call receive_buffer(SWbuffer_in); call unpackbuffer(Time, SWbuffer_in, bottom, Dens)
  else
     call receive_buffer( Ebuffer_in); call unpackbuffer(Time,  Ebuffer_in, bottom, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     call receive_buffer( Wbuffer_in); call unpackbuffer(Time,  Wbuffer_in, bottom, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     call receive_buffer( Nbuffer_in); call unpackbuffer(Time,  Nbuffer_in, bottom, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     call receive_buffer( Sbuffer_in); call unpackbuffer(Time,  Sbuffer_in, bottom, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     call receive_buffer(NEbuffer_in); call unpackbuffer(Time, NEbuffer_in, bottom, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     call receive_buffer(NWbuffer_in); call unpackbuffer(Time, NWbuffer_in, bottom, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     call receive_buffer(SEbuffer_in); call unpackbuffer(Time, SEbuffer_in, bottom, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
     call receive_buffer(SWbuffer_in); call unpackbuffer(Time, SWbuffer_in, bottom, Dens, Ext_mode, L_system, blob_source, tend_blob, mass_in, EL_diag)
  endif
  call mpp_sync_self()

contains
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that packs the buffer for free blobs that!
! have interacted with topography to become bottom blobs and have      !
! crossed a processor boundary.                                        !
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine packbottombuffer(buffer)
    type(blob_buffer_type), pointer :: buffer
    real, dimension(num_prog_tracers) :: dtracer
    real, dimension(0:num_prog_tracers) :: entrainment, detrainment
    integer :: s

    dtracer(:) = 0.0
    if (buffer%pe == Info%pe_this) then
       ! We have a cyclic grid and the blob is just going to
       ! end up back on the same processor.  So, we just adjust
       ! the (i,j) values for the blob.
       call check_cyclic(this, this%i, this%j, .true.)

       if (bitwise_reproduction) then
          do s=0,this%nfrac_steps
             call check_cyclic(this, this%di(s), this%dj(s), .false.)
          enddo
       endif

    else !going to a different PE
       if (bitwise_reproduction) then
          call packbuffer(this,buffer)
       else
          entrainment(:) = 0.0
          detrainment(:) = 0.0
          call packbuffer(this,buffer, entrainment(:), detrainment(:))
       endif
       this%mass=0.
       do n=1,num_prog_tracers
          this%tracer(n) = 0.
       enddo

    endif
  end subroutine packbottombuffer

end subroutine blob_dynamic_free_update
! </SUBROUTINE>  NAME="blob_dynamic_free_update"


!######################################################################
! <SUBROUTINE NAME="dynamic_update">
!
! <DESCRIPTION>
! This routine contains the RK scheme used to integrate the position 
! and velocity of blobs.  It also does many checks for (and 
! subsequently handles) things like grounding of blobs, blobs going to
! different PEs, blobs that interact with topography, blobs that 
! detrain to less than small_mass and blobs going outside the compute 
! domain.  
!
! It also does the interpolation of E system variables to a blob.
! </DESCRIPTION>
!
subroutine dynamic_update(Time, Thickness, Ext_mode, L_system, Dens, T_prog,   &
                          tend_blob, blob_source, press_grad, u, w, model_rho, & 
                          head, bottom_head, mass_in, mass_out, EL_diag,       &
                          ngrnd, nsfc, ndetrn)
  type(ocean_time_type),                               intent(in)    :: Time
  type(ocean_thickness_type),                          intent(inout) :: Thickness
  type(ocean_external_mode_type),                      intent(inout) :: Ext_mode
  type(ocean_lagrangian_type),                         intent(inout) :: L_system
  type(ocean_density_type),                            intent(in)    :: Dens
  type(ocean_prog_tracer_type),                        intent(in)    :: T_prog(:)
  real,dimension(num_prog_tracers,isd:ied,jsd:jed,nk), intent(inout) :: tend_blob
  real,dimension(isd:ied,jsd:jed),                     intent(inout) :: blob_source
  real,dimension(isbd:iebd,jsbd:jebd,1:nk,1:2),        intent(in)    :: press_grad
  real,dimension(isbd:iebd,jsbd:jebd,1:nk,1:2),        intent(in)    :: u
  real,dimension(isbd:iebd,jsbd:jebd,0:nk),            intent(in)    :: w
  real,dimension(isbd:iebd,jsbd:jebd,1:nk),            intent(in)    :: model_rho
  type(ocean_blob_type),                               pointer       :: head
  type(ocean_blob_type),                               pointer       :: bottom_head
  real,dimension(isd:ied,jsd:jed,1:nk),                intent(inout) :: mass_in
  real,dimension(isd:ied,jsd:jed,1:nk),                intent(inout) :: mass_out
  type(blob_diag_type),                                intent(inout) :: EL_diag(0:)
  integer,                                             intent(inout) :: ngrnd
  integer,                                             intent(inout) :: nsfc
  integer,                                             intent(inout) :: ndetrn
  
  type(ocean_blob_type), pointer :: prev, this, next
  real,    dimension(1:6,0:ns) :: V
  real,    dimension(num_prog_tracers) :: tracer, field
  real,    dimension(0:num_prog_tracers) :: entrainment, detrainment
  integer, dimension(3)   :: old_ijk
  real,    dimension(3)   :: old_lld, vel
  real,    dimension(2)   :: h, old_h
  real,    dimension(6)   :: Xn, update, Xnp1, Xnp1_hat
  real,    dimension(9)   :: tdsq_r
  real,    dimension(4)   :: udsq_r
  real,    dimension(0:2) :: px, py, uE, vE, wE, rhoE
  logical :: go_e, go_ne, go_n, go_nw, go_w, go_sw, go_s, go_se
  integer :: ii, iit, jjt, iiu, jju, dk, kdk
  integer :: i,j,k,tau,mm,m,n,r,s
  integer :: n_frac_steps
  integer :: total_blobs, leaving_pe, tfer_bottom, detrn_zero, move_lateral, ngrounded
  integer :: stdoutunit
  logical :: accept_step, reached_end, off(3), grounded
  logical :: change_pe, advance_blob, special
  real :: rhoL, rhoLr, rho, rhor, mass, volume
  real :: f, fs
  real :: lon, lat, geodepth
  real :: tstep, old_tstep, blob_time
  real :: trunc, hstar, tstar
  real :: dmdt_det, dmdt_ent
  real :: ubigd, tbigd, dzwtT, dz(2), vcoeff(2)

  tau = Time%tau

  ! Set debugging counters to zero
  total_blobs  = 0
  leaving_pe   = 0
  tfer_bottom  = 0
  detrn_zero   = 0
  move_lateral = 0
  ngrounded    = 0

  if(associated(head)) then
     this=>head

     blob_cycle: do
        ! time relative to the beginning of the time step
        blob_time = this%blob_time
        tstep     = this%step

        this%dmass      = 0.0
        this%dtracer(:) = 0.0
        if(bitwise_reproduction) then
           ! initialise the values of the history arrays
           this%di(:) = -1
           this%dj(:) = -1
           this%dk(:) = -1
           this%nfrac_steps      = 0
           this%entrainment(:,:) = 0.0
           this%detrainment(:,:) = 0.0
           this%mass_in(:)       = 0.0
           this%mass_out(:)      = 0.0
           
           this%di(0) = this%i
           this%dj(0) = this%j
           this%dk(0) = this%k
        endif

        ! Make adjustments to the lon-lat and i-j (if necessary)
        ! on a cyclic or tripolar grid.
        call check_cyclic(this, this%i, this%j, .true.)


        ! We dont want to alter the blob properties until 
        ! we have completed the full partial step.  So, we save
        ! the variables into local variables in case we need
        ! to redo something.

        ! These variables get updated from one RK sub-step to
        ! the next, so, we need to save copies of them in case
        ! the step is rejected.
        i        = this%i
        j        = this%j
        k        = this%k
        old_ijk  = (/ i, j, k/)
        lon      = this%lon
        lat      = this%lat
        geodepth = this%geodepth
        old_lld  = (/lon, lat, geodepth/)
        h(:)     = (/ this%h1, this%h2 /)
        old_h    = h

        ! These variables are only updated at the end
        ! of all the RK sub-steps, so, we do not need
        ! to save copies
        vel(:) = this%v(:)
        mass   = this%mass
        volume = this%volume
        rhoL   = this%density
        rhoLr  = this%densityr
        if (vert_coordinate_class==DEPTH_BASED) then
           rho  = rho0
           rhor = rho0r
        else !PRESSURE_BASED
           rho  = rhoL
           rhor = rhoLr
        endif
        do n=1,num_prog_tracers
           tracer(n) = this%tracer(n)
           field(n)  = this%field(n)
        enddo
        n_frac_steps = 0

        ! Set flags to default values
        reached_end  = .false.
        change_pe    = .false.
        advance_blob = .true.
        off(:)       = .false.
        grounded     = .false.

        ! Calculate the horizontal interpolation coefficients
        call interp_tcoeff(i,j,h(:),lon,lat,tdsq_r(:))
        call interp_ucoeff(i,j,h(:),lon,lat,udsq_r(:))

        call mpp_clock_begin(id_clock_part_cycle)
        partialstep: do while (.not. reached_end)
           accept_step = .false.
           
           ! Interpolate the E system variables to the blobs
           ! Note, we treat the stretching function separately
           ! Also: the stretching function does not require vertical 
           ! interpolation

           ! Figure out some stuff for the vertical interpolation
           ! for the T and U grids.  The W grid is handled differently.
           if (k==1 .and. geodepth<Thickness%geodepth_zt(i,j,k)) then
              special = .true.
              dzwtT   = Thickness%dzwtT(i,j,k)
              dk      = +1
           elseif(k==Grd%kmt(i,j) .and. geodepth>Thickness%geodepth_zt(i,j,k)) then
              special = .true.
              dzwtT   = Thickness%dzwtT(i,j,k-1)
              dk      = -1
           else
              special = .false.
              if(geodepth<Thickness%geodepth_zt(i,j,k)) then
                 dk = -1
                 dzwtT = Thickness%dzwtT(i,j,k-1)
              else
                 dk = +1
                 dzwtT = Thickness%dzwtT(i,j,k)
              endif
           endif
           kdk = k+dk

           ! Now do the horizontal interpolation at two levels, k and k+dk
           ubigd = 0.0
           px(:)=0.0; py(:)=0.0 
           uE(:)=0.0; vE(:)=0.0;
           do mm=1,Info%uidx(0,i,j)
              iiu=i+Info%iu(Info%uidx(mm,i,j))
              jju=j+Info%ju(Info%uidx(mm,i,j))
              ! Land points are treated as zero for pressure gradient
              ! and velocity
              px(1) = px(1) + umask(iiu,jju,k  )*press_grad(iiu,jju,k  ,1)*udsq_r(mm)
              px(2) = px(2) + umask(iiu,jju,kdk)*press_grad(iiu,jju,kdk,1)*udsq_r(mm)
              py(1) = py(1) + umask(iiu,jju,k  )*press_grad(iiu,jju,k  ,2)*udsq_r(mm)
              py(2) = py(2) + umask(iiu,jju,kdk)*press_grad(iiu,jju,kdk,2)*udsq_r(mm)
              uE(1) = uE(1) + umask(iiu,jju,k  )*u(iiu,jju,k  ,1)*udsq_r(mm)
              uE(2) = uE(2) + umask(iiu,jju,kdk)*u(iiu,jju,kdk,1)*udsq_r(mm)
              vE(1) = vE(1) + umask(iiu,jju,k  )*u(iiu,jju,k  ,2)*udsq_r(mm)
              vE(2) = vE(2) + umask(iiu,jju,kdk)*u(iiu,jju,kdk,2)*udsq_r(mm)
              ubigd = ubigd + udsq_r(mm)
           enddo
           ubigd = 1.0/ubigd
           
           px(1) = px(1)*ubigd 
           px(2) = px(2)*ubigd 
           py(1) = py(1)*ubigd 
           py(2) = py(2)*ubigd 
           uE(1) = uE(1)*ubigd 
           uE(2) = uE(2)*ubigd 
           vE(1) = vE(1)*ubigd 
           vE(2) = vE(2)*ubigd 

           rhoE(:) = 0.0
           tbigd   = 0.0
           do mm=1,Info%tidx(0,i,j)
              iit=i+Info%it(Info%tidx(mm,i,j))
              jjt=j+Info%jt(Info%tidx(mm,i,j))
              ! We ignore density for land points
              if (tmask(iit,jjt,k  ) /= 0.0) then
                 rhoE(1) = rhoE(1) + model_rho(iit,jjt,k  )*tdsq_r(mm)
                 tbigd = tbigd + tdsq_r(mm)
              endif
           enddo

           rhoE(1) = rhoE(1)/tbigd

           tbigd   = 0.0
           do mm=1,Info%tidx(0,i,j)
              iit=i+Info%it(Info%tidx(mm,i,j))
              jjt=j+Info%jt(Info%tidx(mm,i,j))
              ! We ignore density for land points
              if (tmask(iit,jjt,kdk) /= 0.0) then
                 rhoE(2) = rhoE(2) + model_rho(iit,jjt,kdk)*tdsq_r(mm)
                 tbigd = tbigd + tdsq_r(mm)
              endif
           enddo

           rhoE(2) = rhoE(2)/tbigd

           ! Vertically interpolate the horizontally interpolated values
           if (special) then
              ! The blob is either between the top tracer point and the surface
              ! or the lowest wet tracer point and the bottom
              dz(1)     = abs(geodepth - Thickness%geodepth_zt(i,j,k))
              vcoeff(1) = (dzwtT+dz(1))/dzwtT

              px(0)   = px(2)   + ( px(1)-px(2)     )*vcoeff(1)
              py(0)   = py(2)   + ( py(1)-py(2)     )*vcoeff(1)
              uE(0)   = uE(2)   + ( uE(1)-uE(2)     )*vcoeff(1)
              vE(0)   = vE(2)   + ( vE(1)-vE(2)     )*vcoeff(1)
              rhoE(0) = rhoE(2) + ( rhoE(1)-rhoE(2) )*vcoeff(1)
           else
              ! The blob lies vertically between two tracer points
              dz(1) = abs(geodepth - Thickness%geodepth_zt(i,j,k  ))
              dz(2) = abs(geodepth - Thickness%geodepth_zt(i,j,kdk))
              
              vcoeff(1) = dz(1)/dzwtT
              vcoeff(2) = dz(2)/dzwtT
              
              px(0)   = px(1)*vcoeff(2)   + px(2)*vcoeff(1)
              py(0)   = py(1)*vcoeff(2)   + py(2)*vcoeff(1)
              uE(0)   = uE(1)*vcoeff(2)   + uE(2)*vcoeff(1)
              vE(0)   = vE(1)*vcoeff(2)   + vE(2)*vcoeff(1)
              rhoE(0) = rhoE(1)*vcoeff(2) + rhoE(2)*vcoeff(1)
           endif

           ! Now handle the W grid
           kdk = k-1
           wE(:) = 0.0
           tbigd = 0.0
           do mm=1,Info%tidx(0,i,j)
              iit=i+Info%it(Info%tidx(mm,i,j))
              jjt=j+Info%jt(Info%tidx(mm,i,j))
              ! Vertical velocity is treated as zero for land points
              ! Note, this is actually the velocity of the fluid crossing
              ! coordinate surfaces, NOT the true velocity.  Thus, we are assuming
              ! that the vertical velocity of coordinate surfaces is small compared to the
              ! true vertical velocity.
              wE(1) = wE(1) + tmask(iit,jjt,k  )*w(iit,jjt,k  )*tdsq_r(mm)
              wE(2) = wE(2) + tmask(iit,jjt,kdk)*w(iit,jjt,kdk)*tdsq_r(mm)
              tbigd = tbigd + tdsq_r(mm)
           enddo
           tbigd = 1.0/tbigd
           wE(1) = wE(1)*tbigd
           wE(2) = wE(2)*tbigd

           dz(1) = Thickness%geodepth_zwt(i,j,k) - geodepth
           if (kdk==0) then
              dz(2) = geodepth - Ext_mode%eta_t(i,j,tau)
           else
              dz(2) = geodepth - Thickness%geodepth_zwt(i,j,kdk)
           endif
           wE(0) = (wE(1)*dz(2) + wE(2)*dz(1))/Thickness%dztT(i,j,k,tau)

           m=0
           trystep: do while (.not. accept_step)
              prev => NULL()
              next => NULL()
              
              ! Load the old variables into some local variables that we will change.
              ! We want to keep the old variables in case the step is rejected.
              i = old_ijk(1)
              j = old_ijk(2)
              k = old_ijk(3)
              h(:) = old_h(:)
              lon  = old_lld(1)
              lat  = old_lld(2)
              
              ! Horizontal distances are calculated relative to the inital 
              ! position for this partial step.  Vertical distance is calculated
              ! relative to the initial geodepth of the step
              Xn(1) =  0.         ! x-position
              Xn(2) =  vel(1)     ! u-velocity
              Xn(3) =  0.         ! y-position
              Xn(4) =  vel(2)     ! v-velocity
              Xn(5) = -old_lld(3) ! z-position (relative to z=0)
              Xn(6) =  vel(3)     ! w-velocity

              ! Temporary variables for the RK scheme
              Xnp1(:)     = Xn(:)
              Xnp1_hat(:) = Xn(:)
              update(:)   = Xn(:)
              
              ! Temporary variables for the entrainment/detrainment history
              entrainment(:) = 0.
              detrainment(:) = 0.

              ! rotation
              f  = two_omega*sin(deg_to_rad*lat)
              fs = two_omega*cos(deg_to_rad*lat)
                 
              ! Cycle through the RK sub-steps
              call mpp_clock_begin(id_clock_rk)
              do s=0,ns
                 ! dx/dt and d2x/dt2
                 V(1,s) =   update(2)
                 V(2,s) = - this%drag*update(2) + f*update(4) - fs*update(6) - px(0)*rhor + this%drag*uE(0)

                 ! dy/dt and d2y/dt2
                 V(3,s) =   update(4)
                 V(4,s) = - f*update(2) - this%drag*update(4) - py(0)*rhor + this%drag*vE(0)
                 
                 ! dz/dt and d2z/dt2
                 V(5,s) =   update(6)
                 V(6,s) =   fs*update(2) - this%drag*update(6) - grav*rhor*(rhoL - rhoE(0)) + this%drag*wE(0)
                 
                 ! calculate new update
                 if(s<ns) then
                    update(:) = Xn(:)
                    do r=0,s
                       update(:) = update(:) + tstep*beta(s+1,r)*V(:,r)
                    enddo
                 endif

                 ! The high and low order estimates
                 Xnp1(:)     = Xnp1(:)     + tstep*hgamma(s)*V(:,s)
                 Xnp1_hat(:) = Xnp1_hat(:) + tstep*lgamma(s)*V(:,s)

              enddo !s
              call mpp_clock_end(id_clock_rk)
              
              ! Estimate the error using the difference in the high and low order schemes.
              ! We only use the position (not velocity) in the error estimate.
              ii    = maxloc(abs((Xnp1(:) - Xnp1_hat(:))/(Xnp1(:)+epsln)),1)
              trunc = abs(Xnp1(ii) - Xnp1_hat(ii) + epsln)
              tstar = rel_error*abs(Xnp1(ii))
              hstar = tstep * (safety_factor*tstar/trunc)**(orderp1_r)

              ! Save the tstep so that we can update blob_time
              old_tstep = tstep

              ! Reject the step if the accuracy condition is not met. Redo the 
              ! trystep loop with an adjusted step.
              ! There are some caveats, listed below.
              if(trunc > tstar) then 
                 accept_step = .false.
                 if (hstar > minstep) then 
                    !If the suggested step is not smaller than the minimum step, 
                    !retry with the smaller step.
                    tstep = min(hstar, dtime - blob_time)
                 else
                    if (tstep<=minstep) then 
                       !If the step is smaller than the minimum step and 
                       !it is still rejected, we accept the step anyway.
                       accept_step = .true.
                    else
                       ! Otherwise, set the step to the minimum step size.
                       accept_step = .false.
                       tstep = min(minstep, dtime - blob_time)
                    endif
                 endif
                 
              else !Accept the step
                 accept_step = .true.
                 ! We want to impose some restrictions on the local extrapolation to ensure
                 ! we maintain stability and minimise the number of rejected steps:
                 ! 1/ only let the next step increase in size if the previous step was 
                 ! never rejected,
                 ! 2/ we don't let the next step be any larger than twice this step.
                 if (m==0 .and. hstar>=tstep) then
                    tstep = min(2*tstep, hstar)
                 elseif (hstar<tstep) then
                    tstep = max(minstep, hstar)
                 endif
                 ! 3/ We do not want tstep to be greater than dtime (the E system time step)
                 tstep = min(tstep, dtime)

                 ! There may be more adjustments to tstep later on, depending on
                 ! how close we are to reaching the Eulerian time step.
              endif
              
              if (accept_step) then
                 ! Do some rudimentary stability checking
                 if (abs(Xnp1(2))>large_speed .or. abs(Xnp1(4))>large_speed .or. abs(Xnp1(6))>large_speed) then
                    if (tstep<=minstep) then
                       call mpp_error(WARNING,&
                            '==>Warning in ocean_blob_dynamic_free_mod (dynamic_update): It looks like a blob is becoming unstable'//&
                            ' and the timestep is already as small as is permitted.  Suggest reducing minstep in the namelist.')
                    endif
                 endif

                 ! Update the grid stretching values
                 tbigd = 0.0
                 h(:)  = 0.0
                 do mm=1,Info%tidx(0,i,j)
                    iit=i+Info%it(Info%tidx(mm,i,j))
                    jjt=j+Info%jt(Info%tidx(mm,i,j))
                    ! Stretching function is defined over land points, so, we do 
                    ! not mask out land points.
                    h(:) = h(:) + Info%ht(iit,jjt,:)*tdsq_r(mm)
                    tbigd = tbigd + tdsq_r(mm)
                 enddo
                 h(:) = h(:)/tbigd

                 n_frac_steps = n_frac_steps+1

                 ! Entrainment and detrainment calculations are based on the properties of the blob
                 ! at the beginning of this blob step.
                 ! Calculate the detrainment
                 if (vert_coordinate_class==DEPTH_BASED) then
                    !det_factor = Gamma * (rho0*36pi)**1/3
                    dmdt_det = -det_factor * (mass**twothirds) / abs(rhoL - rhoE(0) + epsln)
                 else !PRESSURE_BASED
                    !det_factor = Gamma * (36pi)**1/3
                    dmdt_det = -det_factor * (mass**twothirds) * (rho**onethird) / abs(rhoL - rhoE(0) + epsln)
                 endif

                 ! Make sure we do not exceed the maximum detrainment
                 dmdt_det = sign(min(abs(dmdt_det),abs(max_detrainment)),dmdt_det)

                 ! Entrainment
                 dmdt_ent = 0.0

                 detrainment(0) = dmdt_det*old_tstep
                 entrainment(0) = dmdt_ent*old_tstep

                 do n=1,num_prog_tracers
                    ! Detrainment
                    detrainment(n) = detrainment(0)*field(n)
                    ! Entrainment
                    entrainment(n) = entrainment(0)*T_prog(n)%field(i,j,k,tau)
                 enddo

                 ! Check and see if the blob will detrain to zero mass during this step.
                 ! If it does, just dump all its properties in the original cell.
                 if ((entrainment(0)+detrainment(0)+mass) < small_mass) then
                    entrainment(0) = 0.0
                    detrainment(0) = -mass
                    do n=1,num_prog_tracers
                       entrainment(n) = 0.0
                       detrainment(n) = -tracer(n)
                    enddo
                    ! Update some counters
                    detrn_zero = detrn_zero + 1

                    ! If a blob detrains to less than small mass, we no longer
                    ! need to calculate its trajectory.  So that it stops being 
                    ! processed, we set the time to the end of full step.
                    old_tstep = 0.0
                    blob_time = dtime

                 else
                    ! Check if we have changed horizontal cells
                    call check_ijcell(Xnp1(1),Xnp1(3),i,j,h,old_lld(1:2),lon,lat,off(1:2)) 
                    
                 endif

                 ! Check to see if the blob has grounded on a land column
                 if (Grd%kmt(i,j)==0) then
                    ! If the blob has grounded, we put it back in its previous cell
                    ! It will have all its properties returned to the E system later
                    ! Here, grounded means a blob has moved laterally into a zero 
                    ! depth (i.e. land) column, NOT that it has interacted with topography.
                    off(1:2)  = .false.
                    grounded  = .true.
                    ngrounded = ngrounded + 1
                    i = old_ijk(1)
                    j = old_ijk(2)
                    lon = old_lld(1)
                    lat = old_lld(2)

                 endif

                 if (any(off(1:2))) change_pe = .true.
                 
                 ! Check if we have changed vertical cells and whether we have interacted with
                 ! the lower or upper boundary
                 if (.not. grounded) then
                    call check_kcell(Time, Ext_mode, Thickness,-Xnp1(5),Xnp1(6),i,j,k,off(3))
                 endif

                 if(change_pe .and. .not. bitwise_reproduction) then
                    ! Check to see if the blob has left this pe
                    ! If we are not enforcing bitwise reproduction, we pack 
                    ! the blob into a buffer immediately, as we do not need
                    ! to worry about saving the histories and processing the
                    ! blob histories in order.
                    Ext_mode%conv_blob(old_ijk(1),old_ijk(2)) = &
                         Ext_mode%conv_blob(old_ijk(1),old_ijk(2)) - mass
                    
                    L_system%conv_blob(old_ijk(1),old_ijk(2),old_ijk(3)) = &
                         L_system%conv_blob(old_ijk(1),old_ijk(2),old_ijk(3)) - mass

                    mass_out(old_ijk(1),old_ijk(2),old_ijk(3)) = &
                         mass_out(old_ijk(1),old_ijk(2),old_ijk(3)) + mass

                    ! Save some variables
                    do n=1,num_prog_tracers
                       this%tracer(n) = tracer(n)
                    enddo
                    this%v(1)      = Xnp1(2)
                    this%v(2)      = Xnp1(4)
                    this%v(3)      = Xnp1(6)
                    this%lon       = lon
                    this%lat       = lat
                    this%geodepth  = -Xnp1(5)
                    this%blob_time = blob_time + old_tstep
                    if (this%blob_time == dtime) then
                       this%step = max(tstep, minstep)
                    elseif ((this%blob_time + 1.1*tstep) > dtime) then
                       this%step = dtime - this%blob_time
                    else
                       this%step = max(tstep,minstep)
                    endif
                    this%mass      = mass
                    
                    this%i = i
                    this%j = j
                    this%k = k

                    ! If the blob interacts with topography in the new cell, we need to put it in the bottom
                    ! blob list.  Later, it will be packed into a buffer and sent to a neighbouring PE.
                    if (off(3) .and. k==Grd%kmt(i,j)) then
                       this%age = this%age+dtime_yr
                       call unlink_blob(this, head, prev, next)
                       call insert_blob(this, bottom_head)
                       tfer_bottom  = tfer_bottom + 1
                       this%nfrac_steps = n_frac_steps
                    else
                       if     (i>iec .and. j>jec) then
                          call packbuffer(this, NEbuffer_out, entrainment(:), detrainment(:))
                       elseif (i<isc .and. j>jec) then
                          call packbuffer(this, NWbuffer_out, entrainment(:), detrainment(:))
                       elseif (i>iec .and. j<jsc) then
                          call packbuffer(this, SEbuffer_out, entrainment(:), detrainment(:))
                       elseif (i<isc .and. j<jsc) then
                          call packbuffer(this, SWbuffer_out, entrainment(:), detrainment(:))
                       elseif (i>iec)             then
                          call packbuffer(this,  Ebuffer_out,  entrainment(:), detrainment(:))
                       elseif (i<isc)             then
                          call packbuffer(this,  Wbuffer_out,  entrainment(:), detrainment(:))
                       elseif (j>jec)             then
                          call packbuffer(this,  Nbuffer_out,  entrainment(:), detrainment(:))
                       elseif (j<jsc)             then
                          call packbuffer(this,  Sbuffer_out, entrainment(:), detrainment(:))
                       endif

                       call unlink_blob(this, head, prev, next)
                       call free_blob_memory(this)
                    endif

                    move_lateral = move_lateral + 1
                    leaving_pe   = leaving_pe   + 1

                    advance_blob=.false.

                    exit partialstep
                 endif!change_pe .and. .not. bitwise_reproduction

                
                 ! A little about the following order of operations:
                 ! Detrained mass and tracer is "given" to the cell that the blob is
                 ! entering (i.e. the cell that the blob resides in at the end of
                 ! a sub-cycle).  The mass used for calculating convergence/divergence 
                 ! must therefore be the mass of the blob before detrainment occurs.
                 if (bitwise_reproduction) then

                    ! If we detect that a blob changes cells, save the mass into the new
                    ! water column and and out of the old water column.
                    ! Note, the convention is that both are positive and we take care of
                    ! the sign when calculating the convergence.
                    if (old_ijk(1)/=i .or. old_ijk(2)/=j .or. old_ijk(3)/=k) then
                       this%mass_out(n_frac_steps-1) = mass
                       this%mass_in( n_frac_steps  ) = mass
                    endif

                    ! Save the indices to history too (for divergence and ent/detrainment)
                    this%di(n_frac_steps) = i
                    this%dj(n_frac_steps) = j
                    this%dk(n_frac_steps) = k
                    
                    ! save mass
                    mass = mass + entrainment(0) + detrainment(0)
                    this%entrainment(n_frac_steps,0) = entrainment(0)
                    this%detrainment(n_frac_steps,0) = detrainment(0)
                    
                    ! save tracer
                    do n=1,num_prog_tracers
                       tracer(n) = tracer(n) + entrainment(n) + detrainment(n)
                       this%entrainment(n_frac_steps,n) = entrainment(n)
                       this%detrainment(n_frac_steps,n) = detrainment(n)
                    enddo
                    
                 else!not bitwise_reproduction
                    ! If we detect that a blob changes cells, save the mass into the new
                    ! water column in to and out of the old water column.
                    ! save mass
                    if (old_ijk(1)/=i .or. old_ijk(2)/=j .or. old_ijk(3)/=k) then
                       Ext_mode%conv_blob(old_ijk(1),old_ijk(2)) = &
                            Ext_mode%conv_blob(old_ijk(1),old_ijk(2)) - mass
                       Ext_mode%conv_blob(i,j) = &
                            Ext_mode%conv_blob(i,j) + mass

                       L_system%conv_blob(old_ijk(1),old_ijk(2),old_ijk(3)) = &
                            L_system%conv_blob(old_ijk(1),old_ijk(2),old_ijk(3)) - mass
                       L_system%conv_blob(i,j,k) = &
                            L_system%conv_blob(i,j,k) + mass

                       mass_out(old_ijk(1),old_ijk(2),old_ijk(3)) = mass_out(old_ijk(1),old_ijk(2),old_ijk(3)) + mass
                       mass_in(          i,         j,         k) = mass_in(          i,         j,         k) + mass
                    endif

                    mass = mass + entrainment(0) + detrainment(0)
                    blob_source(i,j) = blob_source(i,j) - entrainment(0) - detrainment(0)
                    
                    ! save tracer
                    do n=1,num_prog_tracers
                       tracer(n) = tracer(n) + entrainment(n) + detrainment(n)
                       tend_blob(n,i,j,k) = tend_blob(n,i,j,k) - entrainment(n) - detrainment(n)
                    enddo

                    do n=0,num_prog_tracers 
                       EL_diag(n)%detrainment(i,j,k) = EL_diag(n)%detrainment(i,j,k) - detrainment(n) 
                       EL_diag(n)%entrainment(i,j,k) = EL_diag(n)%entrainment(i,j,k) + entrainment(n) 
                    enddo 

                 endif!bitwise_reproduction

                 ! save other variables
                 geodepth = -Xnp1(5)
                 old_lld  =  (/lon, lat, geodepth/)
                 old_ijk  =  (/i,   j,   k       /)
                 old_h    =  h
                 vel(1) = Xnp1(2)
                 vel(2) = Xnp1(4)
                 vel(3) = Xnp1(6)

                 !Avoid crazy numbers if the blob has detrained to be less than small mass
                 if(mass>small_mass) then
                    do n=1,num_prog_tracers
                       field(n) = tracer(n)/mass
                    enddo

                    rhoL  = density(field(index_salt), field(index_temp), Dens%pressure_at_depth(i,j,k))
                    rhoLr = 1./rhoL
                    if (vert_coordinate_class == PRESSURE_BASED) then
                       rho  = rhoL
                       rhor = rhoLr
                       !else DEPTH_BASED; rho=rho0; rhor=rho0r
                    endif
                 endif
                 volume = mass*rhor

                 !Now we handle the blobs that have penetrated the surface or bottom boundaries
                 if (off(3) .or. grounded) then
                    ! Update a counter
                    if (this%i /= i .or. this%j /= j) move_lateral = move_lateral + 1
                    if (.not. grounded .and. k==1) nsfc = nsfc+1
                    
                    ! Update the blob variables
                    this%step = max(tstep, minstep)
                    this%i    = i
                    this%j    = j
                    this%k    = k
                    this%lon  = lon
                    this%lat  = lat
                    this%geodepth = geodepth
                    this%v(:) = vel(:)
                    this%h1   = h(1)
                    this%h2   = h(2)
                    
                    this%mass     = mass
                    this%volume   = volume
                    this%density  = rhoL
                    this%densityr = rhoLr
                    this%gprime   = grav*(rhoE(0)-rhoL)/rhoE(0) !diagnostic
                    this%age      = this%age + dtime_yr
                    do n=1,num_prog_tracers
                       if(T_prog(n)%name(1:3) =='age') then
                          ! If it is an age tracer advance the age of the tracer
                          this%field(n)  = field(n) + dtime_yr
                          this%tracer(n) = this%field(n)*mass
                       else
                          this%tracer(n) = tracer(n)
                          this%field(n)  = field(n)
                       endif
                    enddo
                    this%model_steps = this%model_steps + 1
                    
                    if (k>=Grd%kmt(i,j) .and. .not. grounded) then !the blob has penetrated the bottom boundary
                       ! The geodepth and velocity will be adjusted in transfer_free_to_bottom
                       call unlink_blob(this, head, prev, next)
                       call insert_blob(this, bottom_head)
                       advance_blob=.false.
                       tfer_bottom  = tfer_bottom + 1
                       this%nfrac_steps = n_frac_steps
                       exit partialstep
                    else !the blob has penetrated the free surface, or, the blob has grounded
                       n_frac_steps = n_frac_steps+1

                       ! Diagnostics
                       EL_diag(0)%dstry(i,j,k) = EL_diag(0)%dstry(i,j,k) + mass
                       do n=1,num_prog_tracers
                          EL_diag(n)%dstry(i,j,k) = EL_diag(n)%dstry(i,j,k) + tracer(n)
                       enddo

                       if (bitwise_reproduction) then

                          this%nfrac_steps      = n_frac_steps
                          this%di(n_frac_steps) = this%i
                          this%dj(n_frac_steps) = this%j
                          this%dk(n_frac_steps) = this%k
                          this%dmass = -mass
                          this%mass  = 0.0
                          mass       = 0.0
                          do n=1,num_prog_tracers
                             this%dtracer(n) = -tracer(n)
                             this%tracer(n)  = 0.0
                             tracer(n)       = 0.0
                          enddo

                          ! If a blob changes PEs and it interacts with the surface boundary
                          ! we still need it to be packed into a buffer and sent to
                          ! the neighbouring PE for the history.  So, we fool the 
                          ! algorithm into thinking that the blob has completed its
                          ! full time step so that it will get packed into a buffer if necessary.
                          ! We do not need to do this procedure for the blob interacting with 
                          ! the bottom boundary, because it is handled separately in its own 
                          ! linked list.
                          old_tstep = 0.0
                          blob_time = dtime
                          exit trystep

                       else!not bitwise_reproduction
                          this%nfrac_steps = n_frac_steps

                          blob_source(this%i,this%j) = blob_source(this%i,this%j) + mass
                          this%mass = 0.0
                          mass      = 0.0
                          do n=1,num_prog_tracers
                             tend_blob(n,this%i,this%j,this%k) = tend_blob(n,this%i,this%j,this%k) + tracer(n)
                             this%tracer(n) = 0.0
                             tracer(n)      = 0.0
                          enddo

                          ! Diagnostics 
                          EL_diag(0)%dstry(i,j,k) = EL_diag(0)%dstry(i,j,k) + mass 
                          do n=1,num_prog_tracers 
                             EL_diag(n)%dstry(i,j,k) = EL_diag(n)%dstry(i,j,k) + tracer(n) 
                          enddo

                          ! For bitwise_reproduction=.false. we do not need to worry about
                          ! histories being stored in buffers, so, we just exit partialstep
                          !exit partialstep
                          old_tstep = 0.0
                          blob_time = dtime
                          exit trystep

                       endif!bitwise_reproduction
                    endif!k==kmt and not grounded
                 endif!off(3) or grounded

                 this%nfrac_steps = n_frac_steps
              endif !accept_step

              m=m+1
           enddo trystep
           
           ! The step has been accepted.  We now decide whether we need
           ! to conduct any more steps, and if we do, whether we need to 
           ! adjust tstep to ensure the final step coincides with the Eulerian
           ! model time step.
           blob_time      = blob_time + old_tstep
           this%blob_time = blob_time

           if (blob_time == dtime) then
              ! no more steps required.  Save all the new variables to the blob
              reached_end = .true.

              ! Update a counter
              if (this%i /= i .or. this%j /= j) move_lateral = move_lateral + 1

              ! Update the blob variables
              this%step = max(tstep,minstep)
              this%i    = i
              this%j    = j
              this%k    = k
              this%lon  = lon
              this%lat  = lat
              this%geodepth = geodepth
              this%v(:) = vel(:)
              this%h1   = h(1)
              this%h2   = h(2)

              this%mass     = mass
              this%volume   = volume
              this%density  = rhoL
              this%densityr = rhoLr
              this%gprime   = grav*(rhoE(0)-rhoL)/rhoE(0) !diagnostic
              this%age      = this%age + dtime_yr
              do n=1,num_prog_tracers
                 if(T_prog(n)%name(1:3) =='age') then
                    ! If it is an age tracer advance the age of the tracer
                    this%field(n)  = field(n) + dtime_yr
                    this%tracer(n) = this%field(n)*mass
                 else
                    this%tracer(n) = tracer(n)
                    this%field(n)  = field(n)
                 endif
              enddo
              this%model_steps = this%model_steps + 1

              if (bitwise_reproduction) then
                 ! check to see if the blob has left this pe
                 ! NOTE: we assume the blob does not go beyond the halo, so, we 
                 ! don't pack them into buffers until the end of the time step
                 ! We do this to maintain bitwise reproduction.  If we are not
                 ! maintaining bitwise reproduction, we pack a blob into a buffer
                 ! as soon as a change in pe is detected.
                 !
                 ! We also consider what happens when a blob traverses three
                 ! PE's in a time step.  e.g.
                 ! ------------------
                 ! |       |        |
                 ! | PE=2  +a  PE=3 |
                 ! |      /|        |
                 ! |     b |        |
                 ! ------+-----------
                 ! |    /  |        |
                 ! |   c   |        |
                 ! |       |        |
                 ! |  PE=0 |   PE=1 |
                 ! ------------------
                 ! Maintaining bitwise reproducability requires that each
                 ! PE knows about the history of the blob.  In the instance
                 ! depicted above, the blobs history must be processed on PE
                 ! 3,2 and 0.  We achieve this by keeping the history on
                 ! 3, and sending the history to 2 and 0.  When unpacking
                 ! the buffer, the unpacking subroutine checks if the blob 
                 ! is on that PE.  If it is not, it will set the blob%mass 
                 ! and blob%tracer(n) to zero.

                 if(change_pe) then
                    go_ne = .false.
                    go_nw = .false.
                    go_sw = .false.
                    go_se = .false.
                    go_e  = .false.
                    go_n  = .false.
                    go_w  = .false.
                    go_s  = .false.
                    
                    do s=0,this%nfrac_steps

                       ! If we are on a cyclic grid, and, there is only one
                       ! processor in the cyclic direction, we want to avoid
                       ! having the blob sent and received to the same list.
                       ! (which means it can appear twice in the list). 
                       ! This can cause non-conservation.
                       call check_cyclic(this, this%di(s), this%dj(s), .false.)

                       if     (iec<this%di(s) .and. jec<this%dj(s)) then
                          go_ne = .true.
                       elseif (this%di(s)<isc .and. jec<this%dj(s)) then
                          go_nw = .true.
                       elseif (this%di(s)<isc .and. this%dj(s)<jsc) then
                          go_sw = .true.
                       elseif (iec<this%di(s) .and. this%dj(s)<jsc) then
                          go_se = .true.
                       elseif (iec<this%di(s)) then
                          go_e  = .true.
                       elseif (jec<this%dj(s)) then
                          go_n = .true.
                       elseif (this%di(s)<isc) then
                          go_w  = .true.
                       elseif (this%dj(s)<jsc) then
                          go_s = .true.
                       endif

                    enddo

                    if (go_ne) call packbuffer(this, NEbuffer_out)
                    if (go_nw) call packbuffer(this, NWbuffer_out)
                    if (go_se) call packbuffer(this, SEbuffer_out)
                    if (go_sw) call packbuffer(this, SWbuffer_out)
                    if (go_e ) call packbuffer(this,  Ebuffer_out)
                    if (go_w ) call packbuffer(this,  Wbuffer_out)
                    if (go_n ) call packbuffer(this,  Nbuffer_out)
                    if (go_s ) call packbuffer(this,  Sbuffer_out)

                    if (.not. any((/go_ne, go_nw, go_se, go_sw, go_e, go_w, go_n, go_s/))) then
                       call check_cyclic(this, this%i, this%j, .true.)
                       i=this%i; j=this%j
                    endif

                    ! We leave the blobs history in the linked list on this processor
                    ! but, we remove its properties.  It will be deleted next call
                    ! to blob_delete, but, we need its history to be processed 
                    ! before it is deleted.  The history is processed only after
                    ! all blobs have been stepped.
                    ! A blob may go from one PE and then back to the same PE within an
                    ! E system time step, e.g.
                    ! ------------------
                    ! | PE=2  +a  PE=3 |
                    ! |      /|        |
                    ! |     b |        |
                    ! |      \|        |
                    ! |       +c       |
                    ! ------+-----------
                    ! |       |        |
                    ! |       |        |
                    ! |       |        |
                    ! |       |        |
                    ! |  PE=0 |   PE=1 |
                    ! ------------------
                    ! So, we only set its properties to zero if it is no longer on this PE.
                    if (i<isc .or. iec<i .or. j<jsc .or. jec<j) then
                       this%mass=0.
                       do n=1,num_prog_tracers
                          this%tracer(n)=0.
                       enddo
                    endif
                    leaving_pe = leaving_pe + 1
                 endif
              endif !bitwise_reproduction
              
           elseif( (blob_time + 1.1*tstep) > dtime ) then
              ! If we are within 10% of dtime with the suggested tstep, then, 
              ! we extend the step slightly to save having to take a really 
              ! small step next time. We ensure that the step size is chosen 
              ! so that blob_time coincides with the model step after the next blob step.
              reached_end = .false.
              tstep = dtime - blob_time

              ! Update the interpolation coefficients to reflect the new position
              call interp_tcoeff(i,j,h(:),lon,lat,tdsq_r(:))
              call interp_ucoeff(i,j,h(:),lon,lat,udsq_r(:))        
           else
              ! More step(s) required.  No need to adjust the step size.
              reached_end = .false.

              ! Update the interpolation coefficients to reflect the new position
              call interp_tcoeff(i,j,h(:),lon,lat,tdsq_r(:))
              call interp_ucoeff(i,j,h(:),lon,lat,udsq_r(:))
           endif !blobtime==dtime

        enddo partialstep
        call mpp_clock_end(id_clock_part_cycle)
        total_blobs = total_blobs + 1

        if (advance_blob) then
           this=>this%next
        else
           this=>next
        endif
        if (.not. associated(this)) exit blob_cycle
        
     end do blob_cycle
  endif !blob associated?

  ngrnd  = ngrnd  + ngrounded
  ndetrn = ndetrn + detrn_zero

  if (debug_this_module .and. bitwise_reproduction) then
     stdoutunit = stdout()
     write (stdoutunit, '(/,a)') 'Dynamic Free Blob Statistics'
     call write_timestamp(Time%model_time)
     call mpp_sum(total_blobs)
     write (stdoutunit, *) 'Total Free Dynamic Blobs             =', total_blobs
     call mpp_sum(leaving_pe)
     write (stdoutunit, *) 'Free Dynamic Blobs Changing PEs      =', leaving_pe
     call mpp_sum(tfer_bottom)
     write (stdoutunit, *) 'Free Dynamic Blob Transfer to bottom =', tfer_bottom
     call mpp_sum(detrn_zero)
     write (stdoutunit, *) 'Free Blobs detrained to zero mass    =', detrn_zero
     call mpp_sum(move_lateral)
     write (stdoutunit, *) 'Free Blobs changing water columns    =', move_lateral
     call mpp_sum(ngrounded)
     write (stdoutunit, *) 'Grounded Free Blobs                  =', ngrounded
  endif
     
end subroutine dynamic_update
! </SUBROUTINE>  NAME="dynamic_upate"

!######################################################################
! <SUBROUTINE NAME="transfer_bottom_to_free">
!
! <DESCRIPTION>
! Takes bottom blobs that have separated from the bottom boundary and
! turns it into a free blob.
! </DESCRIPTION>
!
subroutine transfer_bottom_to_free(Time, Thickness, T_prog, Dens, &
                                   new_free, head, use_bottom,    &
                                   EL_diag)
  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(inout) :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_blob_type),        pointer       :: new_free
  type(ocean_blob_type),        pointer       :: head
  logical,                      intent(in)    :: use_bottom
  type(blob_diag_type), dimension(0:num_prog_tracers) :: EL_diag

  type(ocean_blob_type), pointer :: this, next, prev
  integer :: i,j,k,tau,nblobs,n
  real, parameter :: small=1e-3
  integer :: stdoutunit

  tau = Time%tau
  nblobs = 0

  if (associated(new_free)) then
     this => new_free
     if (use_this_module) then
        blobcycle: do
           i = this%i
           j = this%j
           k = this%k
           
           ! Ensure that the blob is above the Eulerian topography
           ! so that the free blob module does not think that we have
           ! penetrated rock.
           if (vert_coordinate_class==DEPTH_BASED) then
              this%st       = -Thickness%depth_swt(i,j,k)    + small
              this%geodepth =  Thickness%geodepth_zwt(i,j,k) - small*Thickness%dzt_dst(i,j,k)
           else!PRESSURE_BASED
              this%st       = Thickness%depth_swt(i,j,k)    - small
              this%geodepth = Thickness%geodepth_zwt(i,j,k) + small*Thickness%dzt_dst(i,j,k)
           endif
           
           ! The drag coefficient
           this%drag = rayleigh_drag_bot

           ! Enforce a positive or zero velocity on the blob, so that any downward inertia 
           ! wont cause it to penetrate rock again straight away.
           if (this%v(3)<0) this%v(3)=0.
           
           ! Update some of the blob variables
           this%density  = density(this%field(index_salt), &
                                   this%field(index_temp), &
                                   Dens%pressure_at_depth(i,j,k))
           this%densityr = 1./this%density
           if (vert_coordinate_class == DEPTH_BASED) then
              this%volume = this%mass * rho0r 
           else
              this%volume = this%mass * this%densityr
           endif
           
           call unlink_blob(this, new_free, prev, next)
           call insert_blob(this, head)
           call reallocate_interaction_memory(this,head,total_ns)

           this=>next
           nblobs = nblobs+1
           if(.not.associated(this)) exit blobcycle
        enddo blobcycle

     else !not use_this_module
        ! If we are not using dynamic free blobs, return the 
        ! transferred blbos properties to the E system.
        blobcycle2: do
           i = this%i
           j = this%j
           k = this%k

           ! Diagnostics
           EL_diag(0)%dstry(i,j,k) = EL_diag(0)%dstry(i,j,k) + this%mass
           do n=1,num_prog_tracers
              EL_diag(n)%dstry(i,j,k) = EL_diag(n)%dstry(i,j,k) + this%tracer(n)
           enddo

           call kill_blob(Thickness, T_prog(:), this, i, j, k)
           this=>this%next
           nblobs=nblobs+1
           if(.not.associated(this)) exit blobcycle2
        enddo blobcycle2
     endif !use_this_module
     call blob_delete(Time, Thickness, T_prog(:), new_free)
  endif!associated(new_free)

  call mpp_sum(nblobs)
  if (id_bot_to_free>0) used = send_data(id_bot_to_free, real(nblobs), Time%model_time)

  if(debug_this_module .and. use_bottom) then
     stdoutunit = stdout()
     write(stdoutunit, '(/,a)') 'Bottom blobs separating from topograhy'
     write(stdoutunit, *) 'Bottom blobs transferred to free blobs = ', nblobs
  endif

end subroutine transfer_bottom_to_free

! </SUBROUTINE>  NAME="transfer_bottom_to_free"

!######################################################################
! <SUBROUTINE NAME="blob_dynamic_free_end">
!
! <DESCRIPTION>
! Clears memory to give a nice clean ending to the run.
! </DESCRIPTION>
!
subroutine blob_dynamic_free_end()

  if (.not. use_this_module) return

  call deallocate_buffer(Ebuffer_out);  call deallocate_buffer(Ebuffer_in)
  call deallocate_buffer(Wbuffer_out);  call deallocate_buffer(Wbuffer_in)
  call deallocate_buffer(Nbuffer_out);  call deallocate_buffer(Nbuffer_in)
  call deallocate_buffer(Sbuffer_out);  call deallocate_buffer(Sbuffer_in)
  call deallocate_buffer(NEbuffer_out); call deallocate_buffer(NEbuffer_in)
  call deallocate_buffer(NWbuffer_out); call deallocate_buffer(NWbuffer_in)
  call deallocate_buffer(SEbuffer_out); call deallocate_buffer(SEbuffer_in)
  call deallocate_buffer(SWbuffer_out); call deallocate_buffer(SWbuffer_in)

  nullify(Dom)
  nullify(Grd)
  nullify(Info)
  nullify(Bdom)

contains
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that deallocates memory from a buffer    !
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine deallocate_buffer(buffer)
    type(blob_buffer_type), pointer :: buffer
    if (buffer%pe /= NULL_PE) deallocate(buffer)
  end subroutine deallocate_buffer
end subroutine blob_dynamic_free_end
! </SUBROUTINE>  NAME="blob_dynamic_free_end"


!######################################################################
! <SUBROUTINE NAME="packbuffer">
!
! <DESCRIPTION>
! Packs a buffer with all the information needed to send a blob from
! one PE to another.
! </DESCRIPTION>
!
subroutine packbuffer(blob,buffer,entrainment,detrainment)
  type(ocean_blob_type),  pointer    :: blob
  type(blob_buffer_type), pointer    :: buffer
  real,         optional, intent(in) :: entrainment(0:)
  real,         optional, intent(in) :: detrainment(0:)
  integer :: n, nb, s, npt
  integer :: stdoutunit

  stdoutunit = stdout()

  if (buffer%pe == NULL_PE) then
     write (stdoutunit, '(a)'), 'Error: Trying to send blob to a NULL_PE'
     call mpp_error(FATAL, &
          '==>Error in ocean_blob_static_bottom_mod (packbuffer): '&
          //'Trying to send blob to a NULL_PE')
  endif

  buffer%numblobs = buffer%numblobs+1
  if (buffer%numblobs>buffer%size) call increase_buffer(buffer,buffer%numblobs)

  npt = num_prog_tracers
  nb  = buffer%numblobs
  
  ! Fill the real buffer
  do n=1,num_prog_tracers
     buffer%real_buff(2*n-1,nb) = blob%tracer(n)
     buffer%real_buff(2*n  ,nb) = blob%dtracer(n)
  enddo
  buffer%real_buff(2*npt+1 ,nb) = blob%v(1)
  buffer%real_buff(2*npt+2 ,nb) = blob%v(2)
  buffer%real_buff(2*npt+3 ,nb) = blob%v(3)
  buffer%real_buff(2*npt+4 ,nb) = blob%lon
  buffer%real_buff(2*npt+5 ,nb) = blob%lat
  buffer%real_buff(2*npt+6 ,nb) = blob%geodepth
  buffer%real_buff(2*npt+7 ,nb) = blob%step
  buffer%real_buff(2*npt+8 ,nb) = blob%mass
  buffer%real_buff(2*npt+9 ,nb) = blob%blob_time
  buffer%real_buff(2*npt+10,nb) = blob%h1
  buffer%real_buff(2*npt+11,nb) = blob%h2
  buffer%real_buff(2*npt+12,nb) = blob%drag
  buffer%real_buff(2*npt+13,nb) = blob%dmass
  buffer%real_buff(2*npt+14,nb) = blob%gprime
  buffer%real_buff(2*npt+15,nb) = blob%age

  ! Fill the integer buffer
  buffer%integer_buff(1,nb) = blob%i
  buffer%integer_buff(2,nb) = blob%j
  buffer%integer_buff(3,nb) = blob%k
  buffer%integer_buff(4,nb) = blob%model_steps
  buffer%integer_buff(5,nb) = blob%hash
  buffer%integer_buff(6,nb) = blob%number
  buffer%integer_buff(7,nb) = blob%nfrac_steps
  buffer%integer_buff(8,nb) = blob%nsteps

  if (bitwise_reproduction) then
     ! History buffers
     buffer%history_integer_buff(1,0,nb) = blob%di(0)
     buffer%history_integer_buff(2,0,nb) = blob%dj(0)
     buffer%history_integer_buff(3,0,nb) = blob%dk(0)
     
     buffer%history_real_buff(npt+3,0,nb) = blob%mass_out(0)
     if (blob%nfrac_steps>0) then
        do s=1,blob%nfrac_steps
           ! Integer buffer
           buffer%history_integer_buff(1,s,nb) = blob%di(s)
           buffer%history_integer_buff(2,s,nb) = blob%dj(s)
           buffer%history_integer_buff(3,s,nb) = blob%dk(s)
           
           ! Real buffer
           do n=0,num_prog_tracers
              buffer%history_real_buff(2*n  ,s,nb) = blob%entrainment(s,n)
              buffer%history_real_buff(2*n+1,s,nb) = blob%detrainment(s,n)
           enddo
           buffer%history_real_buff(npt+2,s,nb) = blob%mass_in(s)
           buffer%history_real_buff(npt+3,s,nb) = blob%mass_out(s)
        enddo
     endif
  else
     do n=0,num_prog_tracers
        buffer%history_real_buff(2*n  ,1,nb) = entrainment(n)
        buffer%history_real_buff(2*n+1,1,nb) = detrainment(n)
     enddo
  endif
end subroutine packbuffer
! </SUBROUTINE>  NAME="packbuffer"

!######################################################################
! <SUBROUTINE NAME="unpackbuffer">
!
! <DESCRIPTION>
! Unpacks a received buffer.
! </DESCRIPTION>
!
subroutine unpackbuffer(Time, buffer, head, Dens, Ext_mode, L_system, &
                        blob_source, tend_blob, mass_in, EL_diag)
  type(ocean_time_type),                    intent(in)    :: Time
  type(blob_buffer_type),                   pointer       :: buffer
  type(ocean_blob_type),                    pointer       :: head
  type(ocean_density_type),                 intent(in)    :: Dens
  type(ocean_external_mode_type), optional, intent(inout) :: Ext_mode
  type(ocean_lagrangian_type),    optional, intent(inout) :: L_system
  type(blob_diag_type),           optional, intent(inout) :: EL_diag(0:)
  real, optional, dimension(num_prog_tracers,isd:ied,jsd:jed,nk), intent(inout) :: tend_blob
  real, optional, dimension(isd:ied,jsd:jed),                     intent(inout) :: blob_source
  real, optional, dimension(isd:ied,jsd:jed,1:nk),                intent(inout) :: mass_in
  
  type(ocean_blob_type), pointer :: blob
  real, dimension(0:num_prog_tracers) :: entrainment, detrainment
  integer :: n, nb, s, npt
  integer :: i,j,k,tau

  tau = Time%tau

  if (buffer%pe /= NULL_PE .and. buffer%numblobs>0) then
     npt = num_prog_tracers
     
     do nb=1,buffer%numblobs
        allocate(blob)
        allocate(blob%tracer(num_prog_tracers))
        allocate(blob%field(num_prog_tracers))
        call allocate_interaction_memory(blob, total_ns)
        
        ! unpack the real buffer
        do n=1,num_prog_tracers
           blob%tracer(n)  = buffer%real_buff(2*n-1,nb)
           blob%dtracer(n) = buffer%real_buff(2*n  ,nb)
        enddo
        blob%v(1)     = buffer%real_buff(2*npt+ 1,nb)
        blob%v(2)     = buffer%real_buff(2*npt+ 2,nb)
        blob%v(3)     = buffer%real_buff(2*npt+ 3,nb)
        blob%lon      = buffer%real_buff(2*npt+ 4,nb)
        blob%lat      = buffer%real_buff(2*npt+ 5,nb)
        blob%geodepth = buffer%real_buff(2*npt+ 6,nb)
        blob%step     = buffer%real_buff(2*npt+ 7,nb)
        blob%mass     = buffer%real_buff(2*npt+ 8,nb)
        blob%blob_time= buffer%real_buff(2*npt+ 9,nb)
        blob%h1       = buffer%real_buff(2*npt+10,nb)
        blob%h2       = buffer%real_buff(2*npt+11,nb)
        blob%drag     = buffer%real_buff(2*npt+12,nb)
        blob%dmass    = buffer%real_buff(2*npt+13,nb)
        blob%gprime   = buffer%real_buff(2*npt+14,nb)
        blob%age      = buffer%real_buff(2*npt+15,nb)
        
        ! unpack the integer buffer
        blob%i           = buffer%integer_buff(1,nb)
        blob%j           = buffer%integer_buff(2,nb)
        blob%k           = buffer%integer_buff(3,nb)
        blob%model_steps = buffer%integer_buff(4,nb)
        blob%hash        = buffer%integer_buff(5,nb)
        blob%number      = buffer%integer_buff(6,nb)
        blob%nfrac_steps = buffer%integer_buff(7,nb)
        blob%nsteps      = buffer%integer_buff(8,nb)
        call check_cyclic(blob, blob%i, blob%j, .true.)

        i=blob%i; j=blob%j; k=blob%k

        ! If a blob has zero mass, we are only interested in its history arrays
        ! So, we don't need to bother with finding tracer concentration, density,
        ! or volume.
        if (isc <= i .and. i<=iec .and. jsc<=j .and. j<=jec .and. blob%mass>0) then
        ! Derived variables
           do n=1,num_prog_tracers
              blob%field(n)  = blob%tracer(n)/blob%mass
           enddo
           blob%density = density(blob%field(index_salt), & 
                                  blob%field(index_temp), &
                                  Dens%pressure_at_depth(i,j,k))
           blob%densityr = 1./blob%density
        
           if (vert_coordinate_class == DEPTH_BASED) then
              blob%volume = blob%mass * rho0r 
           else
              blob%volume = blob%mass * blob%densityr
           endif
        else
           blob%mass      = 0.0
           blob%tracer(:) = 0.0
        endif
        
        if (bitwise_reproduction) then
           ! History buffers
           blob%di(:) = -1
           blob%dj(:) = -1
           blob%dk(:) = -1
           blob%entrainment(:,:) = 0.0
           blob%detrainment(:,:) = 0.0
           blob%mass_in(:)       = 0.0
           blob%mass_out(:)      = 0.0
           
           s=0
           blob%di(s) = buffer%history_integer_buff(1,s,nb)
           blob%dj(s) = buffer%history_integer_buff(2,s,nb)
           blob%dk(s) = buffer%history_integer_buff(3,s,nb)
           blob%mass_out(s) = buffer%history_real_buff(npt+3,s,nb)

           if (blob%nfrac_steps>0) then
              do s=1,blob%nfrac_steps
                 ! Integer buffer
                 blob%di(s) = buffer%history_integer_buff(1,s,nb)
                 blob%dj(s) = buffer%history_integer_buff(2,s,nb)
                 blob%dk(s) = buffer%history_integer_buff(3,s,nb)
                 ! Real buffer
                 do n=1,num_prog_tracers
                    blob%entrainment(s,n) = buffer%history_real_buff(2*n  ,s,nb)
                    blob%detrainment(s,n) = buffer%history_real_buff(2*n+1,s,nb)
                 enddo
                 blob%mass_in(s)  = buffer%history_real_buff(npt+2,s,nb)
                 blob%mass_out(s) = buffer%history_real_buff(npt+3,s,nb)
              enddo

           endif
              
           do s=0,blob%nfrac_steps
              call check_cyclic(blob, blob%di(s), blob%dj(s), .false.)
           enddo

           call insert_blob(blob, head)

        else !not bitwise_reproduction
           ! blob_source is not always parsed, so, we do 
           ! not need to worry about it
           if(present(blob_source)) then !if blob_source is present, so is tend_blob, L_system and EL_diag
              Ext_mode%conv_blob(i,j)   = Ext_mode%conv_blob(i,j)   + blob%mass
              L_system%conv_blob(i,j,k) = L_system%conv_blob(i,j,k) + blob%mass
              mass_in(i,j,k)            = mass_in(i,j,k)            + blob%mass

              do n=0,num_prog_tracers
                 entrainment(n) = buffer%history_real_buff(2*n  ,1,nb)
                 detrainment(n) = buffer%history_real_buff(2*n+1,1,nb)
              enddo
              blob_source(i,j) = blob_source(i,j) - detrainment(0) - entrainment(0) 
              blob%mass        = blob%mass + detrainment(0) + entrainment(0) 
              EL_diag(0)%detrainment(i,j,k) = EL_diag(0)%detrainment(i,j,k) - detrainment(0) 
              EL_diag(0)%entrainment(i,j,k) = EL_diag(0)%entrainment(i,j,k) + entrainment(0) 
           
              do n=1,num_prog_tracers
                 tend_blob(n,i,j,k) = tend_blob(n,i,j,k) - detrainment(n) - entrainment(n) 
                 blob%tracer(n)     = blob%tracer(n) + detrainment(n) + entrainment(n)
                 EL_diag(n)%detrainment(i,j,k) = EL_diag(n)%detrainment(i,j,k) - detrainment(n) 
                 EL_diag(n)%entrainment(i,j,k) = EL_diag(n)%entrainment(i,j,k) + entrainment(n)
              enddo

              if (blob%mass>small_mass) then
                 do n=1,num_prog_tracers
                    blob%field(n) = blob%tracer(n)/blob%mass
                 enddo

                 blob%density = density(blob%field(index_salt), & 
                                        blob%field(index_temp), &
                                        Dens%pressure_at_depth(i,j,k))
                 blob%densityr = 1./blob%density
                 
                 if (vert_coordinate_class == DEPTH_BASED) then
                    blob%volume = blob%mass * rho0r 
                 else
                    blob%volume = blob%mass * blob%densityr
                 endif
              endif

              ! Check if the blob being received has penetrated the surface boundary.
              ! If so, return its properties to the E system and do not add it to
              ! the list.
              if (blob%geodepth < -Ext_mode%eta_t(i,j,tau)) then
                 ! Diagnostics
                 EL_diag(0)%dstry(i,j,k) = EL_diag(0)%dstry(i,j,k) + blob%mass
                 do n=1,num_prog_tracers
                    EL_diag(n)%dstry(i,j,k) = EL_diag(n)%dstry(i,j,k) + blob%tracer(n)
                 enddo
              
                 blob_source(i,j) = blob_source(i,j) + blob%mass
                 blob%mass        = 0.0
                 do n=1,num_prog_tracers
                    tend_blob(n,i,j,k) = tend_blob(n,i,j,k) + blob%tracer(n)
                    blob%tracer(n)     = 0.0
                 enddo

              endif

           endif

           ! If a blob is of zero mass, we are only interested in its detrainment
           ! properties.  So, to stop any confusion, we kill it after its 
           ! tendencies have been added to the gridded variables.
           if (blob%mass>0.0) then
              call insert_blob(blob, head)
           else
              call free_blob_memory(blob)
           endif
        endif
        nullify(blob)
     enddo
  endif
end subroutine unpackbuffer
! </SUBROUTINE>  NAME="unpackbuffer"

!######################################################################
! <SUBROUTINE NAME="increase_buffer">
!
! <DESCRIPTION>
! Increases the buffer size for sending blobs from one PE to another.
! </DESCRIPTION>
!
subroutine increase_buffer(buffer, newnum)
  type(blob_buffer_type), pointer :: buffer
  integer, intent(in) :: newnum

  ! local variables
  type(blob_buffer_type), pointer :: new_buffer
  integer :: newbuffsize, m

  allocate(new_buffer)
  m=1
  do while (newnum>newbuffsize)
     newbuffsize = buffer%size + m*delta_buffer
     m=m+1
  enddo

  allocate(new_buffer%integer_buff(int_buff_size,newbuffsize))
  allocate(new_buffer%real_buff(   rea_buff_size,newbuffsize))

  if (bitwise_reproduction) then
     allocate(new_buffer%history_integer_buff(hist_int_buff_size, 0:total_nsp1, newbuffsize))
     allocate(new_buffer%history_real_buff( 0:hist_rea_buff_size, 0:total_nsp1, newbuffsize))
  else
     allocate(new_buffer%history_real_buff( 0:hist_rea_buff_size, 1, newbuffsize))
  endif

  call clear_buffer(new_buffer)
  
  new_buffer%integer_buff(:,1:buffer%size) = buffer%integer_buff(:,:)
  new_buffer%real_buff(   :,1:buffer%size) = buffer%real_buff(:,:)

  if (bitwise_reproduction) new_buffer%history_integer_buff(:,:,1:buffer%size) = buffer%history_integer_buff(:,:,:)
  new_buffer%history_real_buff(:,:,1:buffer%size) = buffer%history_real_buff(:,:,:)

  new_buffer%pe = buffer%pe
  new_buffer%size = newbuffsize
  new_buffer%numblobs = buffer%numblobs

  deallocate(buffer)

  nullify(buffer)
  buffer=>new_buffer

end subroutine increase_buffer
! </SUBROUTINE>  NAME="increase_buffer"

!######################################################################
! <SUBROUTINE NAME="send_buffer">
!
! <DESCRIPTION>
! Sends a buffer to an adjoining PE
! </DESCRIPTION>
!
subroutine send_buffer(buffer)
  type(blob_buffer_type), pointer :: buffer
  integer :: nb, n_frac_steps
  if (buffer%pe /= NULL_PE) then
     call mpp_send(buffer%numblobs, plen=1, to_pe=buffer%pe)
     if (buffer%numblobs>0) then
        ! We cycle through the blobs because sending them en-mass can cause the
        ! program to hang.
        do nb=1,buffer%numblobs
           call mpp_send(buffer%integer_buff(:,nb), int_buff_size, buffer%pe) 
           call mpp_send(buffer%real_buff(:,nb),    rea_buff_size, buffer%pe)

           n_frac_steps = buffer%integer_buff(7,nb)
           if (bitwise_reproduction) then
              call mpp_send(buffer%history_integer_buff(:,0:n_frac_steps,nb), hist_int_buff_size*(n_frac_steps+1), buffer%pe)
              call mpp_send(buffer%history_real_buff(:,0:n_frac_steps,nb),  (1+hist_rea_buff_size)*(n_frac_steps+1), buffer%pe)
           else
              call mpp_send(buffer%history_real_buff(:,1,nb), 1+hist_rea_buff_size, buffer%pe)
           endif
        enddo
     endif
  endif
end subroutine send_buffer
! </SUBROUTINE>  NAME="send_buffer"

!######################################################################
! <SUBROUTINE NAME="receive_buffer">
!
! <DESCRIPTION>
! Receives a buffer from an adjoining PE
! </DESCRIPTION>
!
subroutine receive_buffer(buffer)
  type(blob_buffer_type), pointer :: buffer
  integer :: incoming, nb, n_frac_steps
  if (buffer%pe /= NULL_PE) then
     call mpp_recv(incoming, glen=1, from_pe=buffer%pe)
     if (incoming>0) then
        if (incoming>buffer%size) then
           call increase_buffer(buffer,incoming)
        endif
        do nb=1,incoming
           call mpp_recv(buffer%integer_buff(:,nb), int_buff_size, buffer%pe)
           call mpp_recv(buffer%real_buff(:,nb),    rea_buff_size, buffer%pe)

           n_frac_steps = buffer%integer_buff(7,nb)
           if (bitwise_reproduction) then
              call mpp_recv(buffer%history_integer_buff(:,0:n_frac_steps,nb), hist_int_buff_size*(n_frac_steps+1), buffer%pe)
              call mpp_recv(buffer%history_real_buff(:,0:n_frac_steps,nb),   (1+hist_rea_buff_size)*(n_frac_steps+1), buffer%pe)
           else
              call mpp_recv(buffer%history_real_buff(:,1,nb), 1+hist_rea_buff_size, buffer%pe)
           endif
        enddo
     endif
     buffer%numblobs = incoming
  endif
end subroutine receive_buffer
! </SUBROUTINE>  NAME="receive_buffer"

!######################################################################
! <SUBROUTINE NAME="clear_buffer">
!
! <DESCRIPTION>
! Clears the contents of a buffer
! </DESCRIPTION>
!
subroutine clear_buffer(buffer)
  type(blob_buffer_type), pointer :: buffer
  buffer%numblobs          = 0
  if (buffer%pe /= NULL_PE) then
     buffer%integer_buff(:,:) = 0
     buffer%real_buff(:,:)    = 0.0
     if (bitwise_reproduction) then
        buffer%history_integer_buff(:,:,:) = 0
        buffer%history_real_buff(:,:,:)    = 0.0
     endif
  endif
  !note, we do not clear buffer%size
end subroutine clear_buffer
! </SUBROUTINE>  NAME="clear_buffer"

end module ocean_blob_dynamic_free_mod

module ocean_nphysics_diff_mod
! 
!<CONTACT EMAIL="tim.leslie@gmail.com"> Tim Leslie
!</CONTACT>
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Compute the neutral diffusivity in this module. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes the neutral diffusivity. There are many 
! methods available. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies 
! Fundamentals of Ocean Climate Models (FOCM) (2004)
! Princeton University Press 
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, Elements of MOM (2012)
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_nphysics_diff_nml">
!
!  <DATA NAME="" TYPE="logical">
!  </DATA> 
!
!</NAMELIST>

#define COMP isc:iec,jsc:jec
#define HARM_MEAN(a,b) (2.0*(a)*(b)/((a)+(b)+epsln))

  use constants_mod,               only: epsln
  use fms_mod,                     only: open_namelist_file, check_nml_error, close_file, FATAL
  use mpp_domains_mod,             only: mpp_update_domains
  use mpp_mod,                     only: mpp_pe, mpp_min, stdout, stdlog, mpp_error, input_nml_file
  
  use ocean_domains_mod,           only: get_local_indices, set_ocean_domain
  use ocean_nphysics_util_new_mod, only: vert_smooth, horz_smooth, compute_rossby_radius
  use ocean_operators_mod,         only: S2D
  use ocean_parameters_mod,        only: omega_earth
  use ocean_tracer_diag_mod,       only: calc_mixed_layer_depth
  use ocean_types_mod,             only: ocean_grid_type, ocean_domain_type, ocean_time_type, ocean_thickness_type
  use ocean_types_mod,             only: ocean_prog_tracer_type, ocean_density_type
  use ocean_util_mod,              only: write_note
  use ocean_util_mod,              only: diagnose_2d, diagnose_3d, register_3d_t_field, register_2d_t_field

  implicit none

  public ocean_nphysics_diff_init
  public compute_diffusivity

  private check_stability
  private check_nml_options
  private compute_agm
  private compute_raw_growth_rate
  private compute_growth_rate
  private vertical_average
  private compute_length
  private compute_bczone_radius
  private compute_aredi
  private apply_grid_scaling

  private

#include <ocean_memory.h>

character(len=128) :: version=&
     '$Id: ocean_nphysics_diff.F90,v 20.0 2013/12/14 00:14:42 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

character(len=*), parameter :: FILENAME=&
     __FILE__


  integer :: id_agm_array
  integer :: id_aredi_array

  integer :: id_N2_ref
  integer :: id_agm_length
  integer :: id_raw_growth_rate
  integer :: id_growth_rate
  integer :: id_growth_rate_zave
  integer :: id_agm_fast

  integer :: id_ml_depth
  integer :: id_ave_ml_rate
  integer :: id_eg_rate

  integer :: id_bczone_radius
  integer :: id_rhines_length


  ! 2D array of micom gm diffusivities (m^2/sec)
  real, dimension(:,:), allocatable :: agm_micom

  ! 2D array of gm growth rate max (sec^-1)
  real, dimension(:,:), allocatable :: growth_rate_max

  ! beta = d(Coriolis)/dy (m^-1 sec^-1)
  real, dimension(:,:), allocatable :: beta_param

  ! for determining baroclinic zone radius (metre)
  real,    dimension(:,:), allocatable :: bczone_dxt
  real,    dimension(:,:), allocatable :: bczone_dyt
  integer, dimension(:,:), allocatable :: bczone_over

  type(ocean_domain_type), save :: BCzone_domain
  real :: agm_gamma_damp


  ! -- GM Diffusivity parameters set via namelist --
  
  ! globally constant diffusivities
  logical :: agm_const = .true.
  real    :: agm = 1.0e3 ! constant skew-diffusion diffusivity (m^2/sec)
  
  ! specify agm according to local horizontal area
  ! of grid and a specified velocity scale (m/s)
  logical :: agm_closure_micom = .false.
  real    :: agm_micom_vel     = 0.0 ! m/s

  ! specify agm according to latitude zones
  logical :: agm_lat_bands          = .false.
  real    :: agm_lat_bands_boundary = -999.   ! boundary between agm in the south and north zones in degrees
  real    :: agm_lat_bands_ratio    = 1.0     ! ratio agm(south)/agm(north)

  ! for computing time dependent agm according to flow properties
  logical :: agm_closure = .false.
  real    :: agm_max     = 2.e3   ! maximum diffusivity allowed when agm_closure=.true.
  real    :: agm_min     = 2.e2   ! minimum diffusivity allowed when agm_closure=.true.
  real    :: agm_scaling = 2.0    ! dimensionless tuning parameter for flow dependent agm

  ! agm computed as growth_rate*length_scale**2
  logical :: agm_closure_rate_len2 = .false.

  ! scaling flow dependent agm according to Rossby radius and grid scale 
  logical :: agm_grid_scaling       = .false.
  real    :: agm_grid_scaling_power = 2.0 ! no units

  ! for smoothing agm_array in space and time
  logical :: agm_smooth_space = .false.
  logical :: agm_smooth_time  = .false.
  real    :: agm_damping_time = 10.0 ! days

  ! for scaling agm by buoyancy ratio (N/Nref)^2
  logical :: agm_closure_n2_scale   = .false.
  real    :: agm_n2_scale_coeff     = 1e3   ! m^2/s
  logical :: agm_n2_scale_nref_cst  = .false.
  real    :: agm_n2_scale_buoy_freq = 0.004 ! 1/sec

  ! depths over which compute the Eady growth and/or horizontal density gradient
  ! defaults of 100-2000 taken from Treguier, Held, and Larichev (1997)
  real    :: agm_rate_upper_depth = 100.0  ! metre
  real    :: agm_rate_lower_depth = 2000.0 ! metre

  logical :: agm_rate_eady       = .false.
  logical :: agm_rate_baroclinic = .false.

  ! sec^-1 buoyancy frequency for use with agm_rate_baroclinic
  real    :: agm_rate_baro_buoy_freq  = 0.004 ! 1/sec

  ! for smoothing and capping the growth rate
  logical :: agm_rate_smooth_vert  = .false.
  logical :: agm_rate_smooth_horiz = .false.
  logical :: agm_rate_cap          = .false.

  ! dimensionless number to set maximum value of agm_growth.
  ! agm_rate_cap_scale = 0.5 yields a maximum agm_growth rate of coriolis parameter.
  real    :: agm_rate_cap_scale = 0.5 ! no units

  logical :: agm_rate_ave_mixed = .false.
  logical :: agm_rate_zave      = .false.

  ! compute agm according to Eden and Greatbatch (2008) and Eden(2007)
  logical :: agm_rate_eden_greatbatch   = .false.
  real    :: agm_rate_eg_alpha          = 0.07 ! no units
  logical :: agm_length_eden_greatbatch = .false.

  ! for capping the agm_length scale
  logical :: agm_length_cap = .false.
  real    :: agm_length_max = 50e3 ! metres

  ! for fixed length scale (metres) set by agm_length
  logical :: agm_length_fixed = .false.
  real    :: agm_length       = 50.e3  ! metres

  ! for length scale set according to estimate of first baroclinic Rossby radius
  logical :: agm_length_rossby = .false.

  ! for length scale set according to radius of baroclinic zone
  logical :: agm_length_bczone    = .false.
  integer :: agm_bczone_max_pts   = 10 ! max # points searched for determining baroclinic zone width
  real    :: agm_bczone_crit_rate = 1.4e-6  ! critical growth rate for determining baroclinic zone (sec^-1)


  ! -- Diffusivity for Redi diffusion tensor -- 
  ! will set aredi_array=agm_array
  logical :: aredi_equal_agm =.true.

  ! constant neutral diffusion tracer diffusivity (m^2/sec)
  real    :: aredi = 1.0e3  ! m^2/s
  logical :: aredi_fixed = .false.

  ! for scaling aredi_array according to size of grid and Rossby radius
  logical :: aredi_grid_scaling       = .false.
  real    :: aredi_grid_scaling_power = 2.0 ! no units



  ! -- Horizontal boundary layer diffusivity --
  ! for applying lateral diffusivity within neutral boundary layer
  logical :: neutral_horiz_mix_bdy =.false.
  logical :: ah_micom     = .false.
  real    :: ah_micom_vel = 0.0  ! velocity scale (m/s) for horizontal diffusivity w/i boundary
  logical :: ah_const     = .false.
  real    :: ah           = 0.0  ! constant horiz diffusivity in neutral bdy



  namelist /ocean_nphysics_diff_nml/                                                            &
       neutral_horiz_mix_bdy, ah_micom, ah_micom_vel, ah_const, ah,                             &       
       aredi_equal_agm, aredi_fixed, aredi, aredi_grid_scaling, aredi_grid_scaling_power,       &
       agm_const, agm, agm_lat_bands, agm_lat_bands_boundary, agm_lat_bands_ratio,              &
       agm_closure, agm_max, agm_min, agm_grid_scaling, agm_grid_scaling_power,                 &
       agm_smooth_space, agm_smooth_time, agm_damping_time,                                     &
       agm_closure_micom, agm_micom_vel,                                                        &
       agm_closure_n2_scale, agm_n2_scale_coeff, agm_n2_scale_nref_cst, agm_n2_scale_buoy_freq, &
       agm_closure_rate_len2, agm_scaling, agm_rate_upper_depth, agm_rate_lower_depth,          &
       agm_rate_eady, agm_rate_baroclinic, agm_rate_baro_buoy_freq,                             &
       agm_rate_smooth_vert, agm_rate_smooth_horiz, agm_rate_cap, agm_rate_cap_scale,           &
       agm_rate_ave_mixed, agm_rate_zave, agm_rate_eden_greatbatch, agm_rate_eg_alpha,          &
       agm_length_cap, agm_length_max, agm_length_fixed, agm_length,                            &
       agm_length_rossby, agm_length_bczone, agm_bczone_max_pts, agm_bczone_crit_rate,          &
       agm_length_eden_greatbatch

contains

  subroutine ocean_nphysics_diff_init(Domain, Grid, Time, Thickness, grid_length, dtime, smax, &
       ah_array, agm_array, aredi_array, agm_z_dep)

    type(ocean_domain_type),    intent(in) :: Domain
    type(ocean_grid_type),      intent(in) :: Grid
    type(ocean_time_type),      intent(in) :: Time
    type(ocean_thickness_type), intent(in) :: Thickness
    real, dimension(isd:,jsd:), intent(in) :: grid_length
    real,                       intent(in) :: dtime
    real,                       intent(in) :: smax

    real, dimension(isd:,jsd:),   intent(out) :: ah_array
    real, dimension(isd:,jsd:,:), intent(out) :: agm_array
    real, dimension(isd:,jsd:,:), intent(out) :: aredi_array
    logical,                      intent(out) :: agm_z_dep

    call check_nml_options(agm_z_dep)

#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
    nk = Grid%nk
#endif

    call init_globals(Domain, Grid, grid_length, dtime)

    call register_fields(Grid, Time)

    call diffusivity_init(Grid, grid_length, ah_array, agm_array, aredi_array)
    
    call check_stability(Grid, Thickness, aredi_array, smax, dtime)

  end subroutine ocean_nphysics_diff_init

  !#######################################################################
  ! <SUBROUTINE NAME="check_nml_options">
  !
  ! <DESCRIPTION>
  ! Read in the namelist parameters and ensure that valid values have been
  ! choosen.
  ! Also determine whether agm is z-dependent.
  ! </DESCRIPTION>
  !
  subroutine check_nml_options(agm_z_dep)

    logical, intent(out) :: agm_z_dep

    integer :: ierr, ioun, io_status
    integer :: stdoutunit, stdlogunit
    stdoutunit = stdout()
    stdlogunit = stdlog()

    ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_nphysics_diff_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_nphysics_diff_nml')
#else
    ioun =  open_namelist_file()
    read (ioun,ocean_nphysics_diff_nml,IOSTAT=io_status)
    ierr = check_nml_error(io_status,'ocean_nphysics_diff_nml')
    call close_file (ioun)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit,ocean_nphysics_diff_nml)  
    write (stdlogunit,ocean_nphysics_diff_nml)

    ! Check for horizontal boundary layer mixing
    if (neutral_horiz_mix_bdy) then
       if (count((/ah_micom, ah_const /)) /= 1) then
          call mpp_error(FATAL, &
               '==>Error: with neutral_horiz_mix_bdy=.true., must choose exactly 1 horizontal diffusivity closure')
       endif
       call write_note(FILENAME,&
       'neutral_horiz_mix_bdy=.true. => Adding horizontal diffusion in the boundary layer')
    endif

    ! Check neutral diffusion method
    if (count((/aredi_fixed, aredi_equal_agm /)) /= 1) then
          call mpp_error(FATAL, &
               '==>Error: must choose exactly 1 neutral diffusivity closure')
    endif
    if (aredi_fixed) then
       call write_note(FILENAME,&
       'Using fixed constant neutral diffusion diffusivity')
    else
       call write_note(FILENAME,&
       'Using same diffusion for neutral diffusion and GM')
    endif

    if (count((/agm_closure, agm_const /)) /= 1) then
          call mpp_error(FATAL, &
               '==>Error: must choose to use either constant GM diffusivity or a closure')
    endif

    ! Check GM method
    agm_z_dep = .false.
    if (agm_closure) then
       if (count((/agm_closure_n2_scale, agm_closure_micom, agm_closure_rate_len2 /)) /= 1) then
          call mpp_error(FATAL, &
               '==>Error: with agm_closure=.true., must choose exactly 1 GM diffusivity closure')
       endif
       
       if (agm_closure_rate_len2) then
          if (count((/agm_rate_eady, agm_rate_baroclinic /)) /= 1) then
             call mpp_error(FATAL, &
                  '==>Error: with agm_closure_rate_len2=.true., must choose exactly 1 growth rate')
          endif

          if (count((/agm_length_fixed, agm_length_rossby, agm_length_bczone, agm_length_eden_greatbatch /)) /= 1) then
             call mpp_error(FATAL, &
                  '==>Error: with agm_closure_rate_len2=.true., must choose exactly 1 length scale')
          endif
          call write_note(FILENAME,&
          'GM diffusivity = rate*length^2')
       else if (agm_closure_n2_scale) then
          call write_note(FILENAME,&
          'GM diffusivity = const*N^2')
       else if (agm_closure_micom) then
          call write_note(FILENAME,&
          'GM diffusivity = grid length * const velocity')
       endif

       ! Check for z-dependence.
       if (agm_closure_micom) then
       else if (agm_closure_n2_scale) then
          agm_z_dep = .true.
       else if (agm_closure_rate_len2) then
          if (.not. agm_rate_zave) agm_z_dep = .true.
          if (agm_length_eden_greatbatch) agm_z_dep = .true.
       endif
    else
       call write_note(FILENAME,&
       'Using constant GM diffusivity')
    endif

  end subroutine check_nml_options
  ! </SUBROUTINE> NAME="check_nml_options"

  !#######################################################################
  ! <SUBROUTINE NAME="init_globals">
  !
  ! <DESCRIPTION>
  ! Allocate and initialise all (non-namelist) global variables in the module.
  ! </DESCRIPTION>
  !
  subroutine init_globals(Domain, Grid, grid_length, dtime)

    type(ocean_domain_type),    intent(in) :: Domain
    type(ocean_grid_type),      intent(in) :: Grid
    real, dimension(isd:,jsd:), intent(in) :: grid_length
    real,                       intent(in) :: dtime

    real, dimension(isd:ied,jsd:jed) :: coriolis_param

    integer :: max_pts

    ! Coriolis parameter and beta parameter
    allocate (beta_param(isd:ied,jsd:jed))
    beta_param(COMP) = max(2.28e-11*abs(cos(Grid%phit(COMP))), epsln)

    if (agm_closure) then
       if (agm_smooth_time) then
          agm_gamma_damp = dtime/(24*60*60*agm_damping_time) !for damping time dependent agm_array
       endif
       
       if (agm_closure_micom) then
          allocate (agm_micom(isd:ied,jsd:jed))
          agm_micom(:,:) = agm_micom_vel*grid_length(:,:)
       endif

       if (agm_closure_rate_len2) then
          if (agm_rate_cap) then
             allocate (growth_rate_max(isd:ied,jsd:jed))
             coriolis_param(COMP) = 2.0*omega_earth*abs(sin(Grid%phit(COMP)))
             growth_rate_max(COMP) = agm_rate_cap_scale*coriolis_param(COMP)
          endif
         
          ! for computing the baroclinic zone radius using Hadley Centre search algorithm
          if (agm_length_bczone) then
             max_pts = agm_bczone_max_pts
             call set_ocean_domain(BCzone_domain,Grid,xhalo=max_pts,yhalo=max_pts,name='bczone',maskmap=Domain%maskmap)
             allocate (bczone_over(isc-max_pts:iec+max_pts,jsc-max_pts:jec+max_pts))
             allocate (bczone_dxt (isc-max_pts:iec+max_pts,jsc-max_pts:jec+max_pts))
             allocate (bczone_dyt (isc-max_pts:iec+max_pts,jsc-max_pts:jec+max_pts))
             bczone_dxt(COMP) = Grid%dxt(COMP)
             bczone_dyt(COMP) = Grid%dyt(COMP)
             call mpp_update_domains(bczone_dxt(:,:), BCzone_domain%domain2d)
             call mpp_update_domains(bczone_dyt(:,:), BCzone_domain%domain2d)
          endif
       endif
    endif

  end subroutine init_globals
  ! </SUBROUTINE> NAME="init_globals"

  !#######################################################################
  ! <SUBROUTINE NAME="register fields">
  !
  ! <DESCRIPTION>
  ! Register diagnostic fields.
  ! </DESCRIPTION>
  !
  subroutine register_fields(Grid, Time)
    type(ocean_grid_type), intent(in) :: Grid
    type(ocean_time_type), intent(in) :: Time

    id_agm_array = register_3d_t_field(Grid, Time, 'agm_array', &
         'Skew diffusivity', 'm^2/s', (/-1e-8,1.e8/))
    id_aredi_array = register_3d_t_field(Grid, Time, 'aredi_array', &
         'Neutral diffusivity', 'm^2/s', (/-1e-8,1.e8/))

    id_N2_ref = register_2d_t_field(Grid, Time, 'N2_ref', &
         'Reference squared buoyancy frequency', '1/s^2', (/-1e-8,1.e8/))
    id_agm_length = register_3d_t_field(Grid, Time, 'agm_length', &
         'Characteristic length in diffusivity closure calculation', 'm', (/-1e-8,1.e8/))

    id_raw_growth_rate = register_3d_t_field(Grid, Time, 'raw_growth_rate', &
         'Raw growth rate from either baroclinicity or eady rate', '1/s', (/-1e-8,1.e8/))
    id_growth_rate = register_3d_t_field(Grid, Time, 'growth_rate', &
         'Characteristic growth rate in diffusivity closure calculation', '1/s', (/-1e-8,1.e8/))
    id_growth_rate = register_2d_t_field(Grid, Time, 'growth_rate_zave', &
         'Verical average of growth rate used in diffusivity closure', '1/s', (/-1e-8,1.e8/))

    id_agm_fast = register_3d_t_field(Grid, Time, 'agm_fast', &
         'Skew diffusivity closure value before temporal smoothing is applied', 'm^2/s', (/-1e-8,1.e8/))

    id_ml_depth = register_2d_t_field(Grid, Time, 'ml_depth', &
         'Mixed layer depth used to compute constant growth rate region', 'm', (/0.0, 8000.0/))
    id_ave_ml_rate = register_2d_t_field(Grid, Time, 'ave_ml_rate', &
         'Average growth rate within the mixed layer', '1/s', (/-1e-8,1.e8/))
    id_eg_rate = register_2d_t_field(Grid, Time, 'eg_rate', &
         'Growth rate as calculated by the method of Eden & Greatbatch', '1/s', (/-1e-8,1.e8/))

    id_bczone_radius = register_2d_t_field(Grid, Time, 'bczone_radius', &
         'Radius of the baroclinic zone', 'm', (/-1e-8,1.e8/))
    id_rhines_length = register_2d_t_field(Grid, Time, 'rhines_length', &
         'The Rhines length as used in the Eden & Greatbatch closure', 'm', (/-1e-8,1.e8/))

  end subroutine register_fields
  ! </SUBROUTINE> NAME="register_fields"

  !#######################################################################
  ! <SUBROUTINE NAME="diffusivity_init">
  !
  ! <DESCRIPTION>
  ! Initialise the three diffusivity arrays.
  ! </DESCRIPTION>
  !
  subroutine diffusivity_init(Grid, grid_length, &
       ah_array, agm_array, aredi_array)

    type(ocean_grid_type),      intent(in) :: Grid
    real, dimension(isd:,jsd:), intent(in) :: grid_length

    real, dimension(isd:,jsd:),   intent(out) :: ah_array
    real, dimension(isd:,jsd:,:), intent(out) :: agm_array
    real, dimension(isd:,jsd:,:), intent(out) :: aredi_array

    real, dimension(isd:ied,jsd:jed) :: gravity_wave_speed
    real, dimension(isd:ied,jsd:jed) :: rossby_radius

    gravity_wave_speed(COMP) = 0.0
    call compute_rossby_radius(gravity_wave_speed, rossby_radius)

    ! horizontal diffusivity in neutral boundary layer region
    if (neutral_horiz_mix_bdy) then
       if (ah_micom) then
          ah_array(COMP) = ah_micom_vel*grid_length(COMP)*Grid%tmask(COMP,1)
       elseif (ah_const) then
          ah_array(:,:) = ah*Grid%tmask(:,:,1)
       endif
    else
       ah_array(:,:) = 0.0
    endif

    if (agm_const) then
       ! initialization based on constant coefficients
       agm_array(:,:,:) = agm

       ! Set diffusivity according to agm_lat_bands
       if (agm_lat_bands) then
          where (spread(Grid%yt(:,:), 3, nk) <= agm_lat_bands_boundary)
             agm_array(:,:,:) = agm*agm_lat_bands_ratio
          endwhere
       endif
    elseif (agm_closure) then
       ! grid-scale dependent diffusivity suggested by that commonly used in MICOM
       ! vel_micom (m/s) sets velocity scale.
       ! space scale is set by grid size.
       if (agm_closure_micom) then
          agm_array(:,:,:) = spread(agm_micom(:,:), 3, nk)
       else
          ! initialization based on constant coefficients
          agm_array(:,:,:) = agm
       endif
    endif

    ! now apply tracer mask
    agm_array(:,:,:) = agm_array(:,:,:)*Grid%tmask(:,:,:)

    ! Initialise Redi diffusivity
    if (aredi_fixed) then
       aredi_array(:,:,:) = aredi*Grid%tmask(:,:,:)
    endif

    call compute_aredi(Grid%tmask, grid_length, rossby_radius, agm_array, &
         aredi_array)

  end subroutine diffusivity_init
  ! </SUBROUTINE> NAME="diffusivity_init"

  !#######################################################################
  ! <SUBROUTINE NAME="check_stability">
  !
  ! <DESCRIPTION>
  ! Check the stability assumptions and print details of the limits of stability.
  ! </DESCRIPTION>
  !
  subroutine check_stability(Grid, Thickness, aredi_array, smax, dtime)

    type(ocean_grid_type),        intent(in) :: Grid
    type(ocean_thickness_type),   intent(in) :: Thickness
    real, dimension(isd:,jsd:,:), intent(in) :: aredi_array
    real,                         intent(in) :: smax
    real,                         intent(in) :: dtime

    real :: delta_iso, delta_iso0, delta_min, A_max, A_max0
    real, dimension(isd:ied,jsd:jed,nk) :: min_delta, min_xy_dz
    real, dimension(isd:ied,jsd:jed) :: min_xy
    integer :: i_delta, j_delta, k_delta, k
    integer, dimension(3) :: index_delta
    integer :: unit = 6 ! FIXME: This is a hack to have a non-root PE write to stdout
                        ! but will fail on SGICRAY where stdout != 6.

    ! FOCM - 15.1 Eqn 15.4

    ! compute maximum stable neutral slope available for neutral diffusion
    min_xy(COMP) = min(Grid%dxt(COMP), Grid%dyt(COMP))
    do k = 1, nk
       min_xy_dz(COMP,k) = min_xy(COMP)*Thickness%dzt(COMP,k)
    enddo
    min_delta(COMP,:) = min_xy_dz(COMP,:)/(2*aredi_array(COMP,:)*dtime + epsln)

    delta_iso = minval(min_delta(COMP,:), mask=Grid%tmask(COMP,:)==1.0)
    delta_iso = delta_iso + 1.e-12*mpp_pe() ! to separate redundancies
    delta_iso0 = delta_iso
    call mpp_min (delta_iso)

    ! show most unstable location
    if (delta_iso == delta_iso0) then
       index_delta = minloc(min_delta(COMP,:), mask=Grid%tmask(COMP,:)==1.0)
       i_delta = index_delta(1) - 1 + isc
       j_delta = index_delta(2) - 1 + jsc
       k_delta = index_delta(3)
       write(unit,'(a)')
       write(unit,'(a)')'---Neutral direction slope check I for linear stability of neutral diffusion---'
       write(unit,'(a,e14.7)')'With a neutral physics time step (secs) of ', dtime
       write(unit,'(a)')'the most stringent linear stability constraint was found at the following ocean cell:'
       write(unit,'(a,i4,a,i4,a,e14.7)')'long(',i_delta,',',j_delta,')                   = ',Grid%xt(i_delta,j_delta)
       write(unit,'(a,i4,a,i4,a,e14.7)')'lat (',i_delta,',',j_delta,')                   = ',Grid%yt(i_delta,j_delta)
       write(unit,'(a,i4,a,i4,a,i4,a,e14.7)')'thick(',i_delta,',',j_delta,',',k_delta,') = ', &
            Thickness%dzt(i_delta,j_delta,k_delta)
       write(unit,'(a,i4,a,i4,a,i4,a,e14.7)')'aredi(',i_delta,',',j_delta,',',k_delta,') = ', &
            aredi_array(i_delta,j_delta,k_delta)
       write(unit,'(a,e14.7,a)')'delta_iso           = ',delta_iso,' is the maximum neutral direction slope'
       write(unit,'(a)')'available for linear stability of the neutral diffusion scheme.'
       write(unit,'(a)')'The namelist parameter smax should conservatively be <= delta_iso.'
       if (smax >= delta_iso) then
          write(unit,'(a,f10.5,a)')'==> Warning: The namelist parameter smax= ',smax, ' is >= to delta_iso.'
          write(unit,'(a)')'Linear stability of the neutral diffusion scheme may be compromised.'
       endif
       write(unit,'(a)')
    endif

    ! Compute maximum diffusivity available given a maximum slope of smax
    delta_min = minval(min_xy_dz(COMP,:), mask=Grid%tmask(COMP,:)==1.0)
    A_max = delta_min/(2*smax*dtime + epsln) + 1.e-12*mpp_pe() ! to separate redundancies
    A_max0 = A_max
    call mpp_min (A_max)    

    ! show most unstable location
    if (A_max == A_max0) then
       index_delta = minloc(min_xy_dz(COMP,:), mask=Grid%tmask(COMP,:)==1.0)
       i_delta = index_delta(1) - 1 + isc
       j_delta = index_delta(2) - 1 + jsc
       k_delta = index_delta(3)

       write(unit,'(a)')
       write(unit,'(a)')'---Neutral direction slope check II for linear stability of neutral diffusion---'
       write(unit,'(a,e14.7)')'Assuming maximum Redi neutral diffusion slope of ', smax
       write(unit,'(a,e14.7)')'and neutral physics time step (secs) of ', dtime
       write(unit,'(a)')'the most stringent linear stability constraint was found at the following ocean cell:'
       write(unit,'(a,i4,a,i4,a,e14.7)')'long(',i_delta,',',j_delta,')                  = ',&
            Grid%xt(i_delta,j_delta)
       write(unit,'(a,i4,a,i4,a,e14.7)')'lat (',i_delta,',',j_delta,')                  = ',&
            Grid%yt(i_delta,j_delta)
       write(unit,'(a,i4,a,i4,a,i4,a,e14.7)')'thick(',i_delta,',',j_delta,',',k_delta,')= ',&
            Thickness%dzt(i_delta,j_delta,k_delta)
       write(unit,'(a,e14.7,a)')'A_max      = ',A_max,' (m^2/sec) is the maximum neutral diffusivity'
       write(unit,'(a)')'available for linear stability of the neutral diffusion scheme.'
       write(unit,'(a)')'Conservatively, neutral diffusivities used in the model should be less than A_max.'
       write(unit,'(a)')'--------------------------------------------------------------------------------'
       write(unit,'(a)')
    endif

  end subroutine check_stability
  ! </SUBROUTINE> NAME="check_stability"


  !#######################################################################
  ! <SUBROUTINE NAME="compute_diffusivity">
  !
  ! <DESCRIPTION>
  ! </DESCRIPTION>
  !
  subroutine compute_diffusivity(Domain, Grid, Time, Thickness, Dens, T_temp, T_salt, &
       absslope_z, N2_z, gravity_wave_speed, rossby_radius, &
       ksurf_blayer, grid_length, &
       agm_array, aredi_array)

    type(ocean_domain_type),      intent(inout) :: Domain
    type(ocean_grid_type),        intent(in)    :: Grid
    type(ocean_time_type),        intent(in)    :: Time
    type(ocean_thickness_type),   intent(in)    :: Thickness
    type(ocean_density_type),     intent(in)    :: Dens
    type(ocean_prog_tracer_type), intent(in)    :: T_temp
    type(ocean_prog_tracer_type), intent(in)    :: T_salt

    real, dimension(isd:,jsd:,:,0:), intent(in) :: absslope_z
    real, dimension(isd:,jsd:,:,0:), intent(in) :: N2_z
    real, dimension(isd:,jsd:),      intent(in) :: gravity_wave_speed
    real, dimension(isd:,jsd:),      intent(in) :: rossby_radius

    integer, dimension(isd:,jsd:), intent(in) :: ksurf_blayer
    real, dimension(isd:,jsd:),    intent(in) :: grid_length

    real, dimension(isd:,jsd:,:), intent(inout) :: agm_array
    real, dimension(isd:,jsd:,:), intent(inout) :: aredi_array

    ! update closure-based diffusivity for next time step
    if (agm_closure) then
       call compute_agm(Domain, Grid, Time, Thickness, Dens, T_temp, T_salt, &
            absslope_z, N2_z, gravity_wave_speed, rossby_radius, &
            ksurf_blayer, grid_length, &
            agm_array)
    endif

    call compute_aredi(Grid%tmask, grid_length, rossby_radius, agm_array, &
         aredi_array)

    call diagnose_3d(Time, Grid, id_agm_array, agm_array)
    call diagnose_3d(Time, Grid, id_aredi_array, aredi_array)

  end subroutine compute_diffusivity
  ! </SUBROUTINE> NAME="compute_diffusivity"


  !#######################################################################
  ! <SUBROUTINE NAME="compute_agm">
  !
  ! <DESCRIPTION>
  ! Compute the flow-dependent GM diffusivity.
  ! </DESCRIPTION>
  !
  subroutine compute_agm(Domain, Grid, Time, Thickness, Dens, T_temp, T_salt, &
       absslope_z, N2_z, gravity_wave_speed, rossby_radius, &
       ksurf_blayer, grid_length, &
       agm_array)
 
    type(ocean_domain_type),      intent(inout) :: Domain
    type(ocean_grid_type),        intent(in)    :: Grid
    type(ocean_time_type),        intent(in)    :: Time
    type(ocean_thickness_type),   intent(in)    :: Thickness
    type(ocean_density_type),     intent(in)    :: Dens
    type(ocean_prog_tracer_type), intent(in)    :: T_temp
    type(ocean_prog_tracer_type), intent(in)    :: T_salt

    real, dimension(isd:,jsd:,:,0:), intent(in) :: absslope_z
    real, dimension(isd:,jsd:,:,0:), intent(in) :: N2_z
    real, dimension(isd:,jsd:),      intent(in) :: gravity_wave_speed
    real, dimension(isd:,jsd:),      intent(in) :: rossby_radius

    integer, dimension(isd:,jsd:), intent(in) :: ksurf_blayer
    real, dimension(isd:,jsd:),    intent(in) :: grid_length

    real, dimension(isd:,jsd:,:), intent(inout) :: agm_array

    integer :: i, j, k
    real, dimension(isd:ied,jsd:jed,nk) :: agm_fast

    real, dimension(isd:ied,jsd:jed) :: N2_ref
    real, dimension(isd:ied,jsd:jed,nk) :: raw_growth_rate, growth_rate
    real, dimension(isd:ied,jsd:jed) :: growth_rate_zave
    real, dimension(isd:ied,jsd:jed,nk) :: agm_length

    agm_fast = 0.0
    if (agm_closure_micom) then
       do k = 1, nk
          agm_fast(COMP,k) = agm_micom(COMP)
       enddo
    elseif (agm_closure_n2_scale) then
       ! diffusivity computed as coeff*(N/Nref)**2
       if (agm_n2_scale_nref_cst) then
          N2_ref(COMP) = agm_n2_scale_buoy_freq**2
       else
          ! reference buoyancy taken one level beneath blayer base,
          ! and no deeper than one cell from bottom.
          N2_ref(COMP) = 0.0
          do j = jsc, jec
             do i = isc, iec
                if (ksurf_blayer(i,j) > 0 .and. Grid%kmt(i,j) > 1) then
                   k = min(Grid%kmt(i,j)-1, ksurf_blayer(i,j)+1)
                   N2_ref(i,j) = 0.5*(sum(N2_z(i,j,k,:)))
                endif
             enddo
          enddo
       endif
       call diagnose_2d(Time, Grid, id_N2_ref, N2_ref)

       do k = 1, nk
          agm_fast(COMP,k) = agm_n2_scale_coeff*(0.5*sum(N2_z(COMP,k,:))/(epsln+N2_ref(COMP)))
       enddo
    elseif (agm_closure_rate_len2) then
       ! diffusivity computed as growth_rate*length_scale**2
       call compute_raw_growth_rate(absslope_z, N2_z, raw_growth_rate)
       call compute_growth_rate(Domain, Time, Grid, Thickness, T_temp, T_salt, Dens, &
            gravity_wave_speed, rossby_radius, raw_growth_rate, &
            growth_rate, growth_rate_zave)
       call compute_length(Time, Grid, rossby_radius, growth_rate, growth_rate_zave, grid_length, agm_length)

       call diagnose_3d(Time, Grid, id_agm_length, agm_length)
       call diagnose_3d(Time, Grid, id_raw_growth_rate, raw_growth_rate)
       call diagnose_3d(Time, Grid, id_growth_rate, growth_rate)
       call diagnose_2d(Time, Grid, id_growth_rate_zave, growth_rate_zave)

       agm_fast(COMP,:) = agm_scaling*growth_rate(COMP,:)*agm_length(COMP,:)**2
    endif

    if (agm_grid_scaling) then
       call apply_grid_scaling(grid_length, rossby_radius, agm_grid_scaling_power, Grid%tmask, &
            agm_fast)
    endif

    ! Place upper and lower bounds on agm.
    agm_fast(COMP,:) = max(agm_min, min(agm_max, agm_fast(COMP,:)))

    call diagnose_3d(Time, Grid, id_agm_fast, agm_fast)

    ! time damping to get slowly evolving diffusivity
    if (agm_smooth_time) then
       agm_array(COMP,:) = agm_array(COMP,:) - agm_gamma_damp*(agm_array(COMP,:) - agm_fast(COMP,:))
    else
       agm_array(COMP,:) = agm_fast(COMP,:)
    endif

    ! spatial smoothing
    if (agm_smooth_space) then
       call horz_smooth(Domain, Grid%tmask, agm_array)
    endif

    ! need agm_array on full data domain
    agm_array(COMP,:) = agm_array(COMP,:)*Grid%tmask(COMP,:)
    call mpp_update_domains(agm_array(:,:,:), Domain%domain2d)

  end subroutine compute_agm
  ! </SUBROUTINE> NAME="compute_agm"

  !#######################################################################
  ! <SUBROUTINE NAME="compute_raw_growth_rate">
  !
  ! <DESCRIPTION>
  ! Compute the raw growth rate at each grid point, using either the eady
  ! growth rate or the baroclinicity to obtain raw_growth_rate = NS
  ! </DESCRIPTION>
  !
  subroutine compute_raw_growth_rate(absslope_z, N2_z, raw_growth_rate)

    real, dimension(isd:,jsd:,:,0:), intent(in) :: absslope_z
    real, dimension(isd:,jsd:,:,0:), intent(in) :: N2_z
    real, dimension(isd:,jsd:,:),    intent(out) :: raw_growth_rate

    ! average over vertical quarter cells to get raw Eady growth rate,
    ! NS, with regularization not yet applied.
    if (agm_rate_baroclinic) then
       raw_growth_rate(COMP,:) = sum(N2_z(COMP,:,:)*absslope_z(COMP,:,:), dim=4)/(epsln + 2.0*agm_rate_baro_buoy_freq)
    elseif (agm_rate_eady) then
       raw_growth_rate(COMP,:) = sum(sqrt(N2_z(COMP,:,:))*absslope_z(COMP,:,:), dim=4)/2.0
    endif
    
  end subroutine compute_raw_growth_rate
  ! </SUBROUTINE> NAME="compute_raw_growth_rate"

  !#######################################################################
  ! <SUBROUTINE NAME="compute_growth_rate">
  !
  ! <DESCRIPTION>
  ! Take the raw growth rate and convert it to a final growth rate to be
  ! used in the diffusivity calculations.
  ! </DESCRIPTION>
  !
  subroutine compute_growth_rate(Domain, Time, Grid, Thickness, T_temp, T_salt, Dens, &
       gravity_wave_speed, rossby_radius, raw_growth_rate, &
       growth_rate, growth_rate_zave)

    type(ocean_domain_type),    intent(inout) :: Domain
    type(ocean_time_type),      intent(in)    :: Time
    type(ocean_grid_type),      intent(in)    :: Grid
    type(ocean_thickness_type), intent(in)    :: Thickness
    type(ocean_density_type),   intent(in)    :: Dens

    real, dimension(isd:,jsd:),   intent(in) :: gravity_wave_speed
    real, dimension(isd:,jsd:),   intent(in) :: rossby_radius
    type(ocean_prog_tracer_type), intent(in) :: T_temp
    type(ocean_prog_tracer_type), intent(in) :: T_salt
    real, dimension(isd:,jsd:,:), intent(in) :: raw_growth_rate
    real, dimension(isd:,jsd:,:), intent(out) :: growth_rate
    real, dimension(isd:,jsd:),   intent(out) :: growth_rate_zave

    integer :: k, tau
    real, dimension(isd:ied,jsd:jed) :: ml_depth
    real, dimension(isd:ied,jsd:jed) :: int_dz
    real, dimension(isd:ied,jsd:jed) :: int_rate_dz
    real, dimension(isd:ied,jsd:jed) :: ave_ml_rate

    real, dimension(isd:ied,jsd:jed) :: eg_rate

    growth_rate(COMP,:) = raw_growth_rate(COMP,:)

    ! apply cap to the growth growth rate
    if (agm_rate_cap) then
       do k = 1, nk
          growth_rate(COMP,k) = HARM_MEAN(growth_rate(COMP,k), growth_rate_max(COMP))
       enddo
    endif

    ! vertically average growth rate within surface mixed layer
    growth_rate(COMP,:) = Grid%tmask(COMP,:)*growth_rate(COMP,:)
    if (agm_rate_ave_mixed) then
       tau = Time%tau
       ml_depth(COMP) = 0.0
       call calc_mixed_layer_depth(Thickness,    &
            T_salt%field(:,:,:,tau), T_temp%field(:,:,:,tau), &
            Dens%rho(:,:,:,tau), Dens%pressure_at_depth(:,:,:), &
            ml_depth)
       ml_depth(COMP) = Grid%tmask(COMP,1)*min(ml_depth(COMP), Grid%ht(COMP))

       ! do not believe growth_rate at k=1, so always skip its contribution
       int_dz(COMP) = 0.0
       int_rate_dz(COMP) = 0.0
       do k = 2, nk
          where (Thickness%depth_zt(COMP,k) <= ml_depth(COMP))
             int_dz(COMP) = int_dz(COMP) + Thickness%dzt(COMP,k)
             int_rate_dz(COMP) = int_rate_dz(COMP) + growth_rate(COMP,k)*Thickness%dzt(COMP,k)
          endwhere
       enddo
       ave_ml_rate(COMP) = int_rate_dz(COMP)/(int_dz(COMP)+epsln)

       call diagnose_2d(Time, Grid, id_ml_depth, ml_depth)
       call diagnose_2d(Time, Grid, id_ave_ml_rate, ave_ml_rate)

       do k = 1, nk
          where (Thickness%depth_zt(COMP,k) <= ml_depth(COMP))
             growth_rate(COMP,k) = Grid%tmask(COMP,k)*ave_ml_rate(COMP)
          endwhere
       enddo
    endif

    ! apply vertical 1-2-1 smoothing
    if (agm_rate_smooth_vert) then
       call vert_smooth(Grid%kmt(:,:), growth_rate)
    endif

    ! apply horizontal 1-2-1 smoothing
    if (agm_rate_smooth_horiz) then
       call mpp_update_domains(growth_rate(:,:,:), Domain%domain2d)
       do k = 1, nk
          growth_rate(:,:,k) = S2D(growth_rate(:,:,k))
       enddo
    endif

    ! FIXME: need to find some documentation of this method.
    if (agm_rate_eden_greatbatch) then
       eg_rate(COMP) = agm_rate_eg_alpha*gravity_wave_speed(COMP)/(rossby_radius(COMP) + epsln)
       call diagnose_2d(Time, Grid, id_eg_rate, eg_rate)
       do k = 1, nk
          growth_rate(COMP,k) = HARM_MEAN(growth_rate(COMP,k), eg_rate(COMP))
       enddo
    endif

    ! compute vertical average over specified depth
    call vertical_average(Thickness, Grid%tmask, growth_rate, growth_rate_zave)

    if (agm_rate_zave) then
       do k = 1, nk
          growth_rate(COMP,k) = growth_rate_zave(COMP)
       enddo
    endif

  end subroutine compute_growth_rate
  ! </SUBROUTINE> NAME="compute_growth_rate"  

  !#######################################################################
  ! <SUBROUTINE NAME="vertical_average">
  !
  ! <DESCRIPTION>
  ! Compute the vertical average of the given array between D_t and D_b, 
  ! as specified by agm_rate_upper_depth and agm_rate_lower_depth.
  ! </DESCRIPTION>
  !
  subroutine vertical_average(Thickness, tmask, array, array_ave)
    type(ocean_thickness_type),   intent(in) :: Thickness
    real, dimension(isd:,jsd:,:), intent(in) :: tmask
    real, dimension(isd:,jsd:,:), intent(in) :: array
    real, dimension(isd:,jsd:),   intent(out) :: array_ave

    integer :: k 
    real, dimension(isd:ied,jsd:jed) :: int_dz
    real, dimension(isd:ied,jsd:jed) :: int_array_dz

    int_array_dz(COMP) = 0.0
    int_dz(COMP) = 0.0
    do k = 1, nk-1
       where (Thickness%depth_zt(COMP,k) >= agm_rate_upper_depth .and. &
            Thickness%depth_zt(COMP,k) <= agm_rate_lower_depth)
          int_array_dz(COMP) = int_array_dz(COMP) + array(COMP,k)*Thickness%dzt(COMP,k)
          int_dz(COMP) = int_dz(COMP) + Thickness%dzt(COMP,k)
       endwhere
    enddo
    array_ave(COMP) = tmask(COMP,1)*int_array_dz(COMP)/(int_dz(COMP)+epsln)

  end subroutine vertical_average
  ! </SUBROUTINE> NAME="vertical_average"  


  !#######################################################################
  ! <SUBROUTINE NAME="compute_length">
  !
  ! <DESCRIPTION>
  ! Compute the flow-dependent length scale involved in the GM diffusivity
  ! calculations.
  ! </DESCRIPTION>
  !
  subroutine compute_length(Time, Grid, rossby_radius, growth_rate, growth_rate_zave, grid_length, agm_length)

    type(ocean_time_type),        intent(in) :: Time
    type(ocean_grid_type),        intent(in) :: Grid
    real, dimension(isd:,jsd:),   intent(in) :: rossby_radius
    real, dimension(isd:,jsd:,:), intent(in) :: growth_rate
    real, dimension(isd:,jsd:),   intent(in) :: growth_rate_zave
    real, dimension(isd:,jsd:),   intent(in) :: grid_length
    real, dimension(isd:,jsd:,:), intent(out) :: agm_length

    integer :: k
    real, dimension(isd:ied,jsd:jed,nk) :: rhines_length
    real, dimension(isd:ied,jsd:jed) :: bczone_radius

    ! set the length scale
    agm_length = 0.0
    if (agm_length_fixed) then
       agm_length(COMP,:) = agm_length
    elseif (agm_length_rossby) then
       agm_length(COMP,:) = spread(HARM_MEAN(grid_length(COMP), rossby_radius(COMP)), 3, nk)
    elseif (agm_length_bczone) then
       call compute_bczone_radius(growth_rate_zave, grid_length, bczone_radius)
       call diagnose_2d(Time, Grid, id_bczone_radius, bczone_radius)
       agm_length(COMP,:) = spread(HARM_MEAN(grid_length(COMP), bczone_radius(COMP)), 3, nk)
    elseif (agm_length_eden_greatbatch) then
       do k = 1, nk
          rhines_length(COMP,k) = growth_rate(COMP,k)/beta_param(COMP)
          agm_length(COMP,k) = min(rhines_length(COMP,k), rossby_radius(COMP))
          agm_length(COMP,k) = HARM_MEAN(grid_length(COMP), agm_length(COMP,k))
       enddo
       call diagnose_3d(Time, Grid, id_rhines_length, rhines_length)
    endif

    if (agm_length_cap) then
       agm_length(COMP,:) = min(agm_length_max, agm_length(COMP,:))
    endif

  end subroutine compute_length
  ! </SUBROUTINE> NAME="compute_length"

  !#######################################################################
  ! <SUBROUTINE NAME="compute_bczone_radius">
  !
  ! <DESCRIPTION>
  ! Subroutine computes the radius of the baroclinic zone in a manner
  ! suggested by the Hadley Centre approach (Malcolm Roberts, personal
  ! communication).
  !
  ! Algorithm is used in MOM3 and documented in the MOM3 Manual.
  ! </DESCRIPTION>
  !
  subroutine compute_bczone_radius(growth_rate_zave, grid_length, bczone_radius)

    real, dimension(isd:,jsd:), intent(in) :: growth_rate_zave
    real, dimension(isd:,jsd:), intent(in) :: grid_length
    real, dimension(isd:,jsd:), intent(out) :: bczone_radius

    integer :: i, j
    real :: n_zone, e_zone, s_zone, w_zone, fract, nstot, ewtot
    integer :: ip, jq, max_pts

    max_pts = agm_bczone_max_pts
    bczone_over = 0
    where (growth_rate_zave(COMP) > agm_bczone_crit_rate) bczone_over(COMP) = 1
    call mpp_update_domains(bczone_over(:,:), BCzone_domain%domain2d)

    ! Set default length for points outside baroclinic region.
    where (bczone_over(COMP) == 0) bczone_radius(COMP) = grid_length(COMP)

    do j = jsc, jec
       do i = isc, iec
          if (bczone_over(i,j)==1) then
             ! search northward
             n_zone = bczone_dyt(i,j)
             do jq = j+1, j+max_pts
                if (bczone_over(i,jq)==1) then
                   n_zone = n_zone + bczone_dyt(i,jq)
                else
                   exit
                endif
             enddo

             ! search southward
             s_zone = bczone_dyt(i,j)
             do jq = j-1, j-max_pts, -1
                if (bczone_over(i,jq)==1) then
                   s_zone = s_zone + bczone_dyt(i,jq)
                else
                   exit
                endif
             enddo

             ! search eastward
             e_zone = bczone_dxt(i,j)
             do ip = i+1, i+max_pts
                if (bczone_over(ip,j)==1) then
                   e_zone = e_zone + bczone_dxt(ip,j)
                else
                   exit
                endif
             enddo

             ! search westward
             w_zone = bczone_dxt(i,j)
             do ip = i-1, i-max_pts, -1
                if (bczone_over(ip,j)==1) then
                   w_zone = w_zone + bczone_dxt(ip,j)
                else
                   exit
                endif
             enddo

             ! total radius (subtraction accounts for double-counting central point)
             nstot = n_zone + s_zone - bczone_dyt(i,j)
             ewtot = e_zone + w_zone - bczone_dxt(i,j)

             if (nstot < ewtot) then
                fract = min(n_zone,s_zone)/max(n_zone,s_zone)
                bczone_radius(i,j) = fract*nstot
             else
                fract = min(e_zone,w_zone)/max(e_zone,w_zone)
                bczone_radius(i,j) = fract*ewtot
             endif
          endif
       enddo
    enddo

  end subroutine compute_bczone_radius
  ! </SUBROUTINE> NAME="compute_bczone_radius"

  !#######################################################################
  ! <SUBROUTINE NAME="compute_aredi">
  !
  ! <DESCRIPTION>
  ! Compute the flow-dependent neutral (Redi) diffusivity.
  ! </DESCRIPTION>
  !
  subroutine compute_aredi(tmask, grid_length, rossby_radius, agm_array, &
       aredi_array)

    real, dimension(isd:,jsd:,:), intent(in) :: tmask
    real, dimension(isd:,jsd:),   intent(in) :: grid_length
    real, dimension(isd:,jsd:),   intent(in) :: rossby_radius
    real, dimension(isd:,jsd:,:), intent(in) :: agm_array

    real, dimension(isd:,jsd:,:), intent(inout) :: aredi_array

    if (aredi_equal_agm) then
       aredi_array(COMP,:) = agm_array(COMP,:)
    elseif (aredi_grid_scaling) then
       aredi_array(COMP,:) = aredi*tmask(COMP,:)
       call apply_grid_scaling(grid_length, rossby_radius, aredi_grid_scaling_power, tmask, &
            aredi_array)
    endif

  end subroutine compute_aredi
  ! </SUBROUTINE> NAME="compute_aredi"

  !#######################################################################
  ! <SUBROUTINE NAME="apply_grid_scaling">
  !
  ! <DESCRIPTION>
  ! Scale the supplied array as a function of the grid length and the
  ! Rossby radius. The scaling factor takes a value between zero and one.
  !
  ! Interesting values of the scaling factor are
  ! 1.0 if Rossby radius = 0.0
  ! 0.5 if Rossby radius = grid length
  ! -> 0 as rossby radius -> inf
  ! </DESCRIPTION>
  !
  subroutine apply_grid_scaling(grid_length, rossby_radius, power, tmask, &
       array)

    real, dimension(isd:,jsd:),   intent(in) :: grid_length
    real, dimension(isd:,jsd:),   intent(in) :: rossby_radius
    real,                         intent(in) :: power
    real, dimension(isd:,jsd:,:), intent(in) :: tmask
    real, dimension(isd:,jsd:,:), intent(inout) :: array

    real, dimension(isd:ied,jsd:jed) :: grid_scaling
    integer :: k

    grid_scaling(COMP) = 1/(1 + (rossby_radius(COMP)/grid_length(COMP))**power)
    grid_scaling(COMP) = tmask(COMP,1)*grid_scaling(COMP)
    do k = 1, nk
       array(COMP,k) = array(COMP,k)*grid_scaling(COMP)
    enddo

  end subroutine apply_grid_scaling
  ! </SUBROUTINE> NAME="apply_grid_scaling"

end module ocean_nphysics_diff_mod

module oda_driver_mod

#ifdef ENABLE_ODA
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Matt Harrison 
!</CONTACT>
!
!<OVERVIEW>
! Top-level interface between MOM and ocean data assimilation modules
!</OVERVIEW>
!
!<DESCRIPTION>
! Top level module for ocean data assimilation.  Contains routines for 
! initialization, termination and update of ocean data assimilation increments.
!
! 1.) Get Observations for current model time (and domain)
!  based on data window (default=15 days).  For PE subdomains,
!  data are included if they lie within the region bounded by the
!  cell centers on the first x/y halo extent.
!
! 2.)  
!  IF EAKF (!!not yet implemented!!)
!           a.) ensemble state is distributed among NPES as follows:
!           Ens01:0:(NPE1-1), Ens02:NPE1:(NPE1+NPE2-1),...,
!           EnsN:sum(NPE1+...+NPE(N-1)):NPES
!           b.) Redistribute state to ensemble vector using global PEset.
!           (Ens01,...,EnsN):0:NPES
!           c.) Calculate increments using Ensemble information.
!           d.) Re-distribute increments to members and revert to
!               original PEset.
!  ELSE IF Var2d
!          Minimize quadratic CF based on specfied prior correlation maps
!          and optionally time-variant prior error variance.
!  ELSE ???           
!
!  ENDIF
!
! 3.) Apply increments to model state based on prior analysis.
!     Distribute increments uniformly over analysis period if "do_iau=T".
!
! 4.) Check for convective instability after applying increments.
!  
! 5.) Write Profile (observation space) first guess, analysis and mis-fits
!   
!========================================================================  
!</DESCRIPTION>
!
!  <DATA NAME="use_this_module" TYPE="logical">
!   use the oda module
!  </DATA>    
!<NAMELIST NAME="oda_nml">
!  <DATA NAME="assim_method" TYPE="character">
!   Options are: Var2d, EAKF and NO_ASSIM
!  </DATA>
!  <DATA NAME="assim_start_lat" TYPE="real">
!   Southern data mask  boundary
!  </DATA>  
!
!  <DATA NAME="assim_end_lat" TYPE="real">
!   Northern data mask  boundary
!  </DATA>  
!
!  <DATA NAME="nk_asm" TYPE="integer">
!   Bottom model level for data mask
!  </DATA>
!  
!  <DATA NAME="assim_interval" TYPE="integer">
!   Time between calls to oda (hours)
!  </DATA>  
!
!  <DATA NAME="do_iau" TYPE="logical">
!   Incremental analysis update (evenly distribute increments between
!   calls to ODA.)  
!  </DATA>
!
!  <DATA NAME="do_convect_adjust" TYPE="logical">
!   Adjust for gravitational instability in model after applying increments.
!  </DATA>  
!
!  <DATA NAME="max_profiles" TYPE="integer">
!   Size of allocation for profile data
!  </DATA>  
!
!  <DATA NAME="max_sfc_obs" TYPE="integer">
!   Size of allocation for surface observations
!  </DATA>  
!</NAMELIST>  

  use constants_mod,        only : epsln
  use ensemble_manager_mod, only : ensemble_manager_init, get_ensemble_id
  use ensemble_manager_mod, only : get_ensemble_size, get_ensemble_pelist,get_ensemble_filter_pelist
  use mpp_domains_mod,      only : domain2d, mpp_update_domains
  use mpp_domains_mod,      only : mpp_define_domains, CYCLIC_GLOBAL_DOMAIN, BGRID_NE
  use mpp_domains_mod,      only : FOLD_NORTH_EDGE, mpp_get_compute_domain, mpp_get_data_domain
  use mpp_domains_mod,      only : null_domain2d, mpp_redistribute, mpp_broadcast_domain
  use mpp_mod,              only : input_nml_file, mpp_npes, stdout, stdlog, mpp_error, FATAL
  use mpp_mod,              only : mpp_pe, mpp_declare_pelist,mpp_get_current_pelist
  use mpp_mod,              only : mpp_set_current_pelist, mpp_root_pe,mpp_sum, mpp_sync
  use mpp_io_mod,           only : MPP_MULTI, MPP_SINGLE, mpp_io_exit
  use oda_types_mod
  use oda_core_mod
  use time_manager_mod,     only : time_type, decrement_time, increment_time
  use time_manager_mod,     only : get_time, get_date
  use write_ocean_data_mod

  use ocean_convect_mod,    only : convection
  use ocean_domains_mod,    only : set_ocean_domain, get_local_indices
  use ocean_grids_mod,      only : set_ocean_grid_size, set_ocean_hgrid_arrays
  use ocean_grids_mod,      only : set_ocean_vgrid_arrays
  use ocean_parameters_mod, only : rho_cp
  use ocean_topog_mod,      only : ocean_topog_init
  use ocean_types_mod
  use ocean_workspace_mod, only : wrk1

  
  IMPLICIT NONE
  
  private

  integer, parameter :: NO_ASSIM = 0, Var2d=1, EAKF=2, TEST_ENSEMBLE_ENGINE=3
  integer, parameter :: max_prog_tracers = 2

  integer :: max_profiles = 100000, max_sfc_obs = 100 ! for run-time allocation of observation arrays
  integer :: asm_method = NO_ASSIM
  character(len=8) :: assim_method = 'NO_ASSIM'

  logical :: do_iau = .true. ! incremental analysis update (recommended)
  logical :: do_convect_adjust=.true. ! for doing convective adjustment
                                      ! after applying increments (recommended)

  logical :: save_omf_snaps = .true.
  logical :: save_oma_snaps = .false.
  
  type(grid_type), target, save  :: T_grid
  type(domain2d), pointer, save  :: Asm_domain

  integer :: isc, iec, jsc, jec, isd, ied, jsd, jed
  integer :: ni, nj, nk
  integer :: num_prog_tracers

  real, dimension(:,:,:), allocatable, save :: corr, omf, oma, amf

  integer :: nk_asm
  integer :: xhalo, yhalo
  integer :: index_temp, index_salt

  integer :: id_omf = -1
  integer :: id_oma = -1
  integer :: id_amf = -1
  integer :: id_put_array = -1 
  integer :: id_got_array = -1 
  integer, parameter :: max_ensemble_size = 10
  integer :: pe_start(max_ensemble_size)=0, pe_end(max_ensemble_size)=0
  integer :: ensemble_size = 1
  logical, dimension(max_ensemble_size) :: ensemble_pe = .false.
  integer, allocatable, dimension(:,:) :: ensemble_pelist
  integer :: pe, npes, npes_per_member, ensemble_id
  logical :: sequential_filter = .false.
  
  integer :: isd_filt, ied_filt, jsd_filt, jed_filt
  integer :: isc_filt, iec_filt, jsc_filt, jec_filt
  
  real :: assim_start_lat = -90.0 , assim_end_lat = 90.0
  integer :: assim_interval = 24
  integer :: assim_tsteps=0
  
  character(len=64) :: fname_fg, fname_anal, fname_omf, fname_oma
  integer ::  iunit_fg, iunit_omf, iunit_anal, iunit_oma  
  real, save :: dtimer
  
  type(ocean_domain_type), pointer, save :: Dom
  type(ocean_grid_type), pointer, save :: Grd

  type(ocean_dist_type), target, save    :: First_guess, Analysis
  type(ocean_profile_type), save, allocatable :: Profiles(:)
  type(ocean_surface_type), save, allocatable :: Sfc_obs(:)

  type(ocean_profile_type), save, allocatable, dimension(:) :: model_obs, &
                                                               model_obsd
  
  type(grid_type), save :: Ens_grid
  type(domain2d), save :: Filter_domain, Send_domain(max_ensemble_size)
  type(field_type), save :: Tracer_ens(max_prog_tracers, max_ensemble_size)
  type(field_type), save :: U_ens(max_ensemble_size), V_ens(max_ensemble_size)
  type(field_type), save :: SSH_ens(max_ensemble_size),T_ens(max_ensemble_size)

  integer :: assim_layout(2)
  integer :: filter_halo_x = 1, filter_halo_y = 1
  integer :: ensemble_siz(6)
  integer :: total_npes_pm,ocean_npes_pm,atmos_npes_pm
  integer, allocatable :: ocean_pelist(:, :) , ocean_pelist_filter(:), original_pelist(:)
  real,    allocatable :: put_array(:,:,:), got_array(:,:,:) 

  logical :: use_this_module=.false.
  
  public :: init_oda, oda

  namelist /oda_nml/ use_this_module,assim_method, assim_start_lat,         &
            assim_end_lat, nk_asm, assim_interval, do_iau, do_convect_adjust,&
            max_profiles, max_sfc_obs, save_omf_snaps,                       &
            save_oma_snaps, assim_layout
  
contains  
  

!#######################################################################
! <SUBROUTINE NAME="init_oda">
!
! <DESCRIPTION>
! Initialize ODA core. Grid and Domain association.  
! </DESCRIPTION>
! <IN NAME="Domain" TYPE="ocean_domain_type"></IN>
! <IN NAME="Grid" TYPE="ocean_grid_type"></IN>  
! <IN NAME="Ocn_Time" TYPE="ocean_time_type"></IN>
! <IN NAME="T_prog" TYPE="ocean_tracer_type(:)"></IN>
  
  subroutine init_oda(Domain, Grid, Ocn_Time, T_prog)
    ! initialize First_guess and Analysis grid and domain information
    ! grids are identical to ocean_model grid.  Halo size may differ.

    use fms_mod, only : open_namelist_file,close_file,check_nml_error
    use mpp_mod, only : mpp_set_current_pelist
    use diag_manager_mod, only : diag_axis_init, register_diag_field
    use mpp_domains_mod, only : mpp_global_field, mpp_define_layout
    use ocean_grids_mod, only : set_ocean_grid_size, set_ocean_hgrid_arrays, &
                                set_ocean_vgrid_arrays
    use ocean_topog_mod, only : ocean_topog_init
    use ocean_domains_mod, only : set_ocean_domain, get_local_indices

    type(ocean_domain_type), target :: Domain
    type(ocean_grid_type), target :: Grid ! domain and grid information for ocean model
    type(ocean_time_type), target :: Ocn_Time
    type(ocean_prog_tracer_type), intent(in) :: T_prog(:)

    type(time_type), pointer :: Time

    real :: adum,bdum,cdum
    
    integer :: len, xhalo, yhalo, halo(2), n, m, k, i, j, id_zt
    integer :: layout(2)
    integer :: ioun, io_status, ierr
    integer :: secs, days
    integer :: dt

    integer :: stdoutunit,stdlogunit 
    stdoutunit=stdout();stdlogunit=stdlog() 

    num_prog_tracers = size(T_prog)

    index_temp = -1; index_salt = -1

    do n=1, num_prog_tracers
       if (T_prog(n)%name == 'temp') index_temp = n
       if (T_prog(n)%name == 'salt') index_salt = n
    enddo

    Dom => Domain
    Grd => Grid
    
    Time => Ocn_Time%model_time

    call get_time(Ocn_time%time_step,secs,days)

    dt=secs+days*86400
    
        
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=oda_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'nml=oda_nml')
#else
    ioun = open_namelist_file()
    read(ioun,nml=oda_nml,iostat = io_status)
    ierr = check_nml_error(io_status,'oda_nml')
    call close_file(ioun)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit, oda_nml)  
    write (stdlogunit, oda_nml)

    if (.not.use_this_module) return
    
    assim_interval=assim_interval*3600    
    write(stdoutunit,*) 'Assimilation interval= ',assim_interval,' seconds'
    write(stdoutunit,*) 'Model timestep= ',dt,' seconds'
    adum=assim_interval
    adum=real(adum/dt)
    if (adum - floor(adum) .ne. 0.0) then
        call mpp_error(FATAL,'assim_interval must be integer multiple &
             &of model timestep')
    else
        assim_tsteps=assim_interval/dt
    endif
        
    dtimer=1.0/dt
    
    if (nk_asm > Grid%nk) nk_asm = Grid%nk
    if (nk_asm < 2) call mpp_error(FATAL,&
      'need to specify number of vertical levels for assimilation')

    ni = Grid%ni
    nj = Grid%nj
    nk = Grid%nk

    call mpp_get_compute_domain(Domain%domain2d, isc, iec, jsc, jec)
    call mpp_get_data_domain(Domain%domain2d, isd, ied, jsd, jed)

    T_grid%ni = ni
    T_grid%nj = nj
    T_grid%nk = nk

    T_grid%Dom => Domain%domain2d
    
    allocate(T_grid%x(0:ni+1,0:nj+1), T_grid%y(0:ni+1,0:nj+1),&
             T_grid%mask(0:ni+1,0:nj+1,nk))
    allocate(T_grid%z(nk))

    T_grid%x=0.0
    T_grid%y=0.0
    T_grid%z=0.0
    T_grid%mask=0.0
    
    allocate(corr(isd:ied,jsd:jed,nk))       
    allocate(omf(isd:ied,jsd:jed,nk))       
    allocate(oma(isd:ied,jsd:jed,nk))
    allocate(amf(isd:ied,jsd:jed,nk))
    corr(:,:,:) = 0.0
    omf(:,:,:) = 0.0
    oma(:,:,:) = 0.0
    amf(:,:,:) = 0.0

! get global grid information from ocean_model
       
    call mpp_global_field(Domain%domain2d, Grid%tmask(:,:,:), &
         T_grid%mask(1:ni,1:nj,:))

    do j=1,nj
       T_Grid%x(1:ni,j) = Grid%grid_x_t(1:ni)
    enddo

    do i=1,ni
       T_Grid%y(i,1:nj) = Grid%grid_y_t(1:nj)
    enddo
    

    
    if (Grid%cyclic_x) then
        T_grid%x(0,:) = T_grid%x(ni,:)-360.
        T_grid%x(ni+1,:) = T_grid%x(1,:)+360.
    else
        T_grid%x(0,:) = T_grid%x(1,:)-1.e-10
        T_grid%x(ni+1,:) = T_grid%x(ni,:)+1.e-10
    endif

    T_grid%y(:,0) = T_grid%y(:,1)-1.e-3
    T_grid%y(:,nj+1) = T_grid%y(:,nj)+1.e-3

    T_grid%z = Grid%zt

    
    do j=0,nj+1
       do i=0,ni+1
          if (T_grid%y(i,j) < assim_start_lat .or. &
               T_grid%y(i,j) > assim_end_lat ) then
              T_grid%mask(i,j,:) = 0.0
          endif
          do k=nk_asm+1,nk
             T_grid%mask(i,j,k) = 0.0
          enddo
       enddo
    enddo

    T_grid%cyclic = Grid%cyclic_x

    if (assim_tsteps < 1) then
        call mpp_error(FATAL,'invalid assim interval')
    else
        write(stdoutunit,*) 'Assimilating data every ', assim_tsteps, ' timesteps'
    endif


    select case (assim_method)
    case ('NO_ASSIM')
       asm_method = NO_ASSIM
    case ('EAKF')
       asm_method = EAKF
    case ('Var2d')
       asm_method = Var2d
    case ('TEST_ENS')
       asm_method = TEST_ENSEMBLE_ENGINE
    case default
       call mpp_error(FATAL,'Wrong assim_method')
    end select

    select case (asm_method)

    case(TEST_ENSEMBLE_ENGINE)
       !This is just to test the functionality of the ensemble run
       !and can serve as an example of how to use the ensemble in 
       !real life data assimilations.

       !allocate ens array(Temp(;,;,;,Nens))
       !define domain for ens members(Send_domain(Nens))
       !define domain for filter (filter_domain)
       !broadcast_domain(Send_domain)
       !do i=1,Nens
       !   redist(Send_domain, TEMP, filter_domain, Temp(:,:,:,i)
       !enddo
       !do i=1,Nens
       !   redist(filter_domain, temp(:,:,:,i), Send_domain, Temp2)
       !enddo
       !is(Temp .eq. Temp2)?
       
       !
       !Get ensemble size and id
       !npes_pm (# of pe's per member) are assumed to be the same for all members
       
       ensemble_id = get_ensemble_id() 
       ensemble_siz = get_ensemble_size()   
       ensemble_size = ensemble_siz(1)      
       total_npes_pm = ensemble_siz(2)               
       ocean_npes_pm = ensemble_siz(3) 
       atmos_npes_pm = ensemble_siz(4) 

       !First save the current pelist
       allocate(original_pelist(ocean_npes_pm)) !can the argument be mpp_npes() ?
       call mpp_get_current_pelist(original_pelist)

       !Get ocean_pelist
       allocate(ocean_pelist(1:ensemble_size,1:ocean_npes_pm))   
       call get_ensemble_pelist(ocean_pelist,'ocean') 

       !Set pelist to ocean_pelist for this ensemble member
       call mpp_set_current_pelist(ocean_pelist(ensemble_id,:))

       !
       !Define "send" domains for individual ensemble members
       !

       call mpp_define_domains((/1,ni,1,nj/), Domain%layout, Send_domain(ensemble_id),&
            xflags=Domain%xflags, yflags=Domain%yflags, xhalo = Domain%xhalo, &
            yhalo = Domain%yhalo, name='send')

       allocate(put_array(isd:ied,jsd:jed,nk))
       allocate(got_array(isd:ied,jsd:jed,nk))

       id_put_array = register_diag_field('oda','oda_put' ,&
         Grid%tracer_axes(1:3),Time,'oda_put_array','none',&
         missing_value=-1.0e+10 )

       id_got_array = register_diag_field('oda','oda_got' ,&
         Grid%tracer_axes(1:3),Time,'oda_got_array','none',&
         missing_value=-1.0e+10 )
       
       !
       !Define the "filter" domain which is the domain for doing 
       !ensemble calculations (avereages, assimilations, ...)
       !
       !The "filter" domain should be defined on a pelist which
       !is the union of Ocean PE's for all ensemble members.
       !
       allocate(ocean_pelist_filter(ensemble_size * ocean_npes_pm))
       call get_ensemble_filter_pelist(ocean_pelist_filter,'ocean') 

       call mpp_set_current_pelist(ocean_pelist_filter) 
       
       call mpp_define_domains((/1,ni,1,nj/), assim_layout, Filter_domain, &
            xflags=Domain%xflags, yflags=Domain%yflags,&
            xhalo = filter_halo_x, yhalo = filter_halo_y, name='filter')

       call mpp_get_data_domain(Filter_domain, isd_filt,ied_filt,jsd_filt,jed_filt)
       call mpp_get_compute_domain(Filter_domain, isc_filt,iec_filt,jsc_filt,jec_filt)       

       do m = 1, ensemble_size
          allocate(T_ens(m)%data(isd_filt:ied_filt,jsd_filt:jed_filt,nk))
       enddo

       !return to original pelist
       call mpp_set_current_pelist(original_pelist) 

       return

    case (EAKF)

        call mpp_error(FATAL,'Not currently supported')
        
    case (Var2d)

        call mpp_error(FATAL,'Not currently supported')
        
!        xhalo=1;yhalo=1

!        Asm_domain => Domain%domain2d

!        allocate(First_guess%temp%ex(isd:ied,jsd:jed,nk))

!        First_guess%temp%ex = 0.0
!        First_guess%temp%grid => T_grid
       
!        ! assign tracer values on computational domain
!        ! assume for now that the ocean decomposition is identical
!        ! to assim decompositionn with the exception of halo sizes

!        allocate(Analysis%temp%ex(isd:ied,jsd:jed,nk))

!        Analysis%temp%grid => First_guess%temp%grid

!        call oda_core_init(Domain%domain2d, T_grid,localize=.true.)
!        call dr_oi_init(Domain, Grid, Time, nk_asm)

   case (NO_ASSIM)

       xhalo=1;yhalo=1

       Asm_domain => Domain%domain2d

       allocate(First_guess%temp%ex(isd:ied,jsd:jed,nk))

       First_guess%temp%ex = 0.0
       First_guess%temp%grid => T_grid
       
       ! assign tracer values on computational domain
       ! assume for now that the ocean decomposition is identical
       ! to assim decompositionn with the exception of halo sizes

       call oda_core_init(Domain%domain2d, T_grid,localize=.true.)
      
    end select

    id_omf = register_diag_field('oda','omf_temp',&
         Grid%tracer_axes(1:3),Time,'data-first guess misfit (temp)','deg_C',&
         missing_value=-20.,range=(/-20.,20./))

    
    id_oma = register_diag_field('oda','oma_temp',&
         Grid%tracer_axes(1:3),Time,'data-analysis misfit (temp)','deg_C',&
         missing_value=-20.,range=(/-20.,20./))
    
    id_amf = register_diag_field('oda','amf_temp',&
         Grid%tracer_axes(1:3),Time,'correction for temperature','W/m^2',&
         missing_value=-2.e3,range=(/-2.e3,2.e3/))

    allocate(Profiles(max_profiles))
    allocate(model_obs(max_profiles), model_obsd(max_profiles))    
    allocate(Sfc_obs(max_sfc_obs))

    call write_ocean_data_init()
    
    return

  end subroutine init_oda
! </SUBROUTINE> NAME="init_oda"


!#######################################################################
! <SUBROUTINE NAME="oda">
!
! <DESCRIPTION>
! Request ocean state increments
! </DESCRIPTION>
! <IN NAME="Ocn_Time" TYPE="ocean_type_type"></IN>
! <INOUT NAME="T_prog" TYPE="ocean_prog_tracer_type(:)"></INOUT>
! <INOUT NAME="Thickness" TYPE="ocean_thickness_type"></INOUT>
! <INOUT NAME="Dens" TYPE="ocean_density_type"></INOUT>
  
  subroutine oda(Ocn_Time, T_prog, Thickness, Dens)

!  use eakf_mod, only : ensemble_filter
    use diag_manager_mod, only : send_data

    type(ocean_time_type), target :: Ocn_Time
    type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
    type(ocean_thickness_type), intent(inout), optional :: Thickness  
    type(ocean_density_type), intent(inout), optional :: Dens
    
    type(time_type) :: time

! snz adds a time-step index as the analysis time-step using time_step
    integer :: time_step_index = 0

    integer :: i,j, k, m, n, nprof, nsfc, itt, tau, taup1, &
         nprof_g
    real :: t, u, v, tfg, z1, z2
    logical :: assim_time, used

  integer :: stdoutunit 
  stdoutunit=stdout() 

    if (.not.use_this_module) return
    
    time = Ocn_time%model_time

    itt = Ocn_time%itt

    tau = Ocn_time%tau
           
    if (mod(itt-1,assim_tsteps) .eq. 0 .or. itt .eq. 0) then
        assim_time = .true.
        call get_obs(time, Profiles, Sfc_obs, nprof, nsfc)
        amf = 0.0;corr=0.0
    else
        assim_time = .false.
    endif
    
    

    select case (asm_method)

    case(TEST_ENSEMBLE_ENGINE)

       !First save the current pelist
       call mpp_get_current_pelist(original_pelist)

       !Set pelist to all filter PE's
       call get_ensemble_filter_pelist(ocean_pelist_filter,'ocean') 

       call mpp_set_current_pelist(ocean_pelist_filter) 
!       call mpp_set_current_pelist()

       put_array = T_prog(1)%field(:,:,:,1)
       got_array = -1.0

       do m = 1, ensemble_size
          call mpp_broadcast_domain(Send_domain(m))
       enddo
       
       !Distribute each ensemble member array to filter domain
       do m = 1, ensemble_size
          T_ens(m)%data(:,:,:) = 0.0
          call mpp_redistribute(Send_domain(m), put_array(:,:,:), &
               Filter_domain, T_ens(m)%data(:,:,:))          
       enddo

       !Here are filter calculations
       do m = 1, ensemble_size
          call mpp_update_domains(T_ens(m)%data(:,:,:), Filter_domain)
       enddo

       !Distribute the array back to ensemble members domains
       do m = 1, ensemble_size
          call mpp_redistribute(Filter_domain, T_ens(m)%data(:,:,:), &
               Send_domain(m), got_array(:,:,:))
       enddo

       !Since there was no real filter calculation the two arrays must match on each ensemble member
       do k=1,nk
          do j=jsc,jec; do i=isc,iec
             if (got_array(i,j,k)-put_array(i,j,k) .ne. 0.0) &
                  call mpp_error(FATAL,'Ensemble loopback test failed!')
          enddo;enddo
       enddo
       
       if (id_put_array > 0) used = send_data(id_put_array,put_array(isc:iec,jsc:jec,:),Time)
       if (id_got_array > 0) used = send_data(id_got_array,got_array(isc:iec,jsc:jec,:)&
                                                          -put_array(isc:iec,jsc:jec,:),Time)


       !return to original pelist
       call mpp_set_current_pelist(original_pelist) 
       

       return

    case (EAKF)

        call mpp_error(FATAL,'Not currently supported')

    case (Var2d)

       ! set first guess field to tau tracer

       First_guess%temp%ex(:,:,:) = &
            T_prog(index_temp)%field(:,:,:,tau)
       call mpp_update_domains( First_guess%temp%ex, Asm_domain)

       tau = Ocn_time%tau
       taup1 = Ocn_time%taup1       

       if (assim_time) then
           write(stdoutunit,*) 'itt = ',itt
           write(stdoutunit,*) 'Calculating analysis using observed data'
!           call dr_oi(First_guess,Profiles(1:nprof), Sfc_obs(1:nsfc), Analysis, Time)
           amf(:,:,:) = (Analysis%temp%ex(:,:,:) - &
                 First_guess%temp%ex(:,:,:))
           if (do_iau) then
! sub-divide increments equally between analysis intervals               
               corr = amf/assim_tsteps
           else
               corr = amf
           endif
       else
           if (do_iau) then
               write(stdoutunit,*) 'itt = ',itt
               write(stdoutunit,*) 'Applying analysis increment to ocean state'
           else
               corr = 0.0
           endif
       endif

       if (do_iau.or.assim_time) then
           wrk1(:,:,:) = T_prog(index_temp)%field(:,:,:,taup1)
           T_prog(index_temp)%field(:,:,:,taup1) = &
                wrk1(:,:,:) + corr(:,:,:)

           where (T_prog(index_temp)%field(:,:,:,taup1) .lt. -1.9)
               T_prog(index_temp)%field(:,:,:,taup1) = -1.9
           end where
           
           if (present(Dens).and.do_convect_adjust) then
               call convection(Ocn_Time, Thickness, T_prog, Dens)
               call mpp_update_domains(T_prog(index_temp)%field(:,:,:,taup1),Dom%domain2d)
               call mpp_update_domains(T_prog(index_salt)%field(:,:,:,taup1),Dom%domain2d)
           else
               write(stdoutunit,*) "WARNING:  Not doing convection in oda"
               call mpp_update_domains(T_prog(index_temp)%field(:,:,:,taup1),Dom%domain2d)               
           endif

           if (PRESENT(Thickness)) then
               amf(:,:,:) = dtimer*rho_cp*Thickness%dzt(:,:,:)*(T_prog(index_temp)%field(:,:,:,taup1) - wrk1(:,:,:))
           else
! NOTE: Warning!! this diagnostic is inaccurate
               do k=1,nk
                  amf(:,:,k) = dtimer*rho_cp*Grd%dzt(k)*(T_prog(index_temp)%field(:,:,k,taup1) - wrk1(:,:,k))
               enddo
           endif
       else
           amf = 0.0
       endif

   end select

   if (assim_time) then
       if (save_omf_snaps .or. save_oma_snaps) call open_profile_snaps(Time,nprof)

       if (asm_method == NO_ASSIM) then
           tau = Ocn_time%tau
           taup1 = Ocn_time%taup1                  
           First_guess%temp%ex(:,:,:) = &
                T_prog(index_temp)%field(:,:,:,taup1)
           call mpp_update_domains( First_guess%temp%ex, Asm_domain)
       endif
       

       if (nprof .gt. 0 .and. save_omf_snaps) then
   
   
           write(stdoutunit,*) 'itt = ',itt
           write(stdoutunit,*) 'Calculating first guess differences using observed data'
           call copy_obs(Profiles(1:nprof),model_obs(1:nprof)) ! copy profile data to separate array for holding model guess
           call copy_obs(Profiles(1:nprof),model_obsd(1:nprof))
           call forward_obs( model_obs(1:nprof), First_guess%temp%ex) ! put first guess in observation data (forward operator gets defined here)
           call assign_forward_model(model_obs(1:nprof),model_obsd(1:nprof))
           call diff_obs(model_obs(1:nprof),Profiles(1:nprof),model_obsd(1:nprof)) ! difference obs - model
           if (id_omf .gt. 0 ) then
               call backward_obs(model_obsd(1:nprof),omf)  ! D^T To
           endif

       endif

       if (save_omf_snaps) then
           call mpp_set_current_pelist((/mpp_pe()/))
       
           do i=1,nprof
              if (Profiles(i)%accepted) then
                  call write_profile(iunit_fg, model_obs(i))
                  call write_profile(iunit_omf, model_obsd(i))        
              endif
           enddo
           
           call mpp_set_current_pelist()
       endif
       
   endif



   
   if (asm_method /= NO_ASSIM .and. assim_time) then

       if (nprof .gt. 0 .and. save_oma_snaps) then
           write(stdoutunit,*) 'itt = ',itt
           write(stdoutunit,*) 'Calculating analysis differences using observed data'
           call forward_obs( model_obs(1:nprof), Analysis%temp%ex) ! put first guess in observation data (forward operator gets defined here)
           call diff_obs(model_obs(1:nprof),Profiles(1:nprof),model_obsd(1:nprof)) ! difference obs - model

       endif

       if (save_oma_snaps) then
           call mpp_set_current_pelist((/mpp_pe()/))
           
           do i=1,nprof
              if (Profiles(i)%accepted) then
                  
                  call write_profile(iunit_anal, model_obs(i))
                  call write_profile(iunit_oma,model_obsd(i))        
              endif
           enddo
  
           call mpp_set_current_pelist()
       endif

       
       if (id_oma .gt. 0 ) then
           call backward_obs(model_obsd(1:nprof),oma)  ! D^T To
       endif

   endif

       
           
   if (assim_time .and. (save_omf_snaps .or. save_oma_snaps)) call close_profile_snaps(nprof)
   
    if (id_omf > 0) used = send_data(id_omf,omf(isc:iec,jsc:jec,:),&
         &Time,rmask=Grd%tmask(isc-Dom%ioff:iec-Dom%ioff,&
         jsc-Dom%joff:jec-Dom%joff,:))

    if (id_oma > 0) used = send_data(id_oma,oma(isc:iec,jsc:jec,:),&
         &Time,rmask=Grd%tmask(isc-Dom%ioff:iec-Dom%ioff,&
         jsc-Dom%joff:jec-Dom%joff,:))

    if (id_amf > 0) used = send_data(id_amf,amf(isc:iec,jsc:jec,:),&
         &Time,rmask=Grd%tmask(isc-Dom%ioff:iec-Dom%ioff,&
         jsc-Dom%joff:jec-Dom%joff,:))
    

    return

  end subroutine oda
! </SUBROUTINE> NAME="init_oda"


  subroutine open_profile_snaps(Time,nprof)

    type(time_type), intent(in) :: Time
    integer, intent(in) :: nprof
    
    character(len=2) :: cmon,cday,chr
    character(len=4) :: cyr, cpe
    integer :: ipe
    integer :: year,month,day,hour,minute,second
  
  
    ipe = mpp_pe()

!    if (nprof.eq.0) return
    
    if (ipe .lt. 10) then
        write(cpe,'(a3,i1)') '000',ipe
    else if (ipe .lt. 100) then
        write(cpe,'(a2,i2)') '00',ipe
    else if (ipe .lt. 1000) then
        write(cpe,'(a1,i3)') '0',ipe
    else
        write(cpe,'(i4)') ipe
    endif
  
    call get_date(Time,year,month,day,hour,minute,second)
  
    if (year .lt. 10) then
        write(cyr,'(a3,i1)') '000',year
    else if (year .lt. 100) then
        write(cyr,'(a2,i2)') '00',year
    else if (year .lt. 1000) then
        write(cyr,'(a1,i3)') '0',year
    else
        write(cyr,'(i4)') year
    endif
  
    if (month .lt. 10) then
        write(cmon,'(a1,i1)') '0',month
    else
        write(cmon,'(i2)') month
    endif
    
    if (day .lt. 10) then
        write(cday,'(a1,i1)') '0',day
    else
        write(cday,'(i2)') day
    endif
    
    if (hour .lt. 10) then
        write(chr,'(a1,i1)') '0',hour
    else
        write(chr,'(i2)') hour
    endif
    

    if (save_omf_snaps) then
        write(fname_fg,'(a3,a4,a2,a2,a2,a3,a4,a3)') 'fg_',cyr,cmon,cday,chr,'.pe',cpe,'.nc'
        write(fname_omf,'(a4,a4,a2,a2,a2,a3,a4,a3)') 'omf_',cyr,cmon,cday,chr,'.pe',cpe,'.nc'
    endif

    if (save_oma_snaps) then
        write(fname_anal,'(a5,a4,a2,a2,a2,a3,a4,a3)') 'anal_',cyr,cmon,cday,chr,'.pe',cpe,'.nc'
        write(fname_oma,'(a4,a4,a2,a2,a2,a3,a4,a3)') 'oma_',cyr,cmon,cday,chr,'.pe',cpe,'.nc'  
    endif
    

    call mpp_set_current_pelist((/mpp_pe()/))

    if (nprof.ne.0 .and. save_omf_snaps) then
        iunit_fg = open_profile_file(fname_fg,1,&
             grid_lon=Grd%grid_x_t,grid_lat=Grd%grid_y_t,thread=MPP_SINGLE,fset=MPP_SINGLE)
        iunit_omf = open_profile_file(fname_omf,1,&
             grid_lon=Grd%grid_x_t,grid_lat=Grd%grid_y_t,thread=MPP_SINGLE,fset=MPP_SINGLE)
    endif

    if (nprof.ne.0 .and. save_oma_snaps) then    
        iunit_anal = open_profile_file(fname_anal,1,&
             grid_lon=Grd%grid_x_t,grid_lat=Grd%grid_y_t,thread=MPP_SINGLE,fset=MPP_SINGLE)
        iunit_oma = open_profile_file(fname_oma,1,&
             grid_lon=Grd%grid_x_t,grid_lat=Grd%grid_y_t,thread=MPP_SINGLE,fset=MPP_SINGLE)
    endif

    call mpp_set_current_pelist()

  end subroutine open_profile_snaps

  subroutine close_profile_snaps(nprof)

    integer, intent(in) :: nprof

    
    call mpp_set_current_pelist((/mpp_pe()/))

    if (nprof.ne.0 .and. save_omf_snaps) then
        call close_profile_file(iunit_fg)
        call close_profile_file(iunit_omf)
    endif

    if (nprof.ne.0 .and. save_oma_snaps) then    
        call close_profile_file(iunit_anal)
        call close_profile_file(iunit_oma)
    endif
    
    call mpp_set_current_pelist()

  end subroutine close_profile_snaps

#endif 
  
end module oda_driver_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The algebraic velocity variances \label{sec:variances}
!
! !INTERFACE:
   subroutine variances(nlev,SSU,SSV)
!
! !DESCRIPTION:

!  Using \eq{bijVertical} and the solution shown in \eq{b13} and
!  the variances of the turbulent velocity fluctations can be
!  evaluated according to
!  \begin{equation}
!    \label{variances}
!    \begin{array}{rcl}
!      \dfrac{\langle u'^2 \rangle}{k}
!      &=& \dfrac23 + \dfrac{1}{\mathcal{N}\eps} \left(
!        \left(\dfrac{a_2}{3}+a_3\right) \nu_t \left( \partder{U}{z} \right)^2
!                          -\dfrac23 a_2 \nu_t \left( \partder{V}{z} \right)^2
!                          -\dfrac43 a_5 G \right)
!      \comma
!      \\[7mm]
!      \dfrac{\langle v'^2 \rangle}{k}
!      &=& \dfrac23
!      +\dfrac{1}{\mathcal{N}\eps} \left(
!        \left(\dfrac{a_2}{3}+a_3\right) \nu_t \left(\partder{V}{z}\right)^2
!                          -\dfrac23 a_2 \nu_t \left(\partder{U}{z}\right)^2
!                          -\dfrac43 a_5 G \right)
!      \comma
!      \\[7mm]
!      \dfrac{\langle w'^2 \rangle}{k}
!      &=& \dfrac23
!      +\dfrac{1}{\mathcal{N}\eps} \left(
!        \left(\dfrac{a_2}{3}-a_3\right) P
!        +\dfrac83 a_5 G
!      \right)
!      \comma
!    \end{array}
!  \end{equation}
!  where the diffusivities are computed according to \eq{nu}
!  (also see \sect{sec:cmueC} and \sect{sec:cmueD}),
!  and the buoyancy production, $G$, follows from \eq{computeG}.
!
! !USES:
  use turbulence,  only:     uu,vv,ww
  use turbulence,  only:     tke,eps,P,B,num
  use turbulence,  only:     cc1,ct1,a2,a3,a5
  IMPLICIT NONE
!
! !INPUT PARAMETERS:

! number of vertical layers
  integer,  intent(in)                 :: nlev

! square of shear frequency (1/s^2)
! (from u- and v-component)
  REALTYPE, intent(in)                :: SSU(0:nlev),SSV(0:nlev)

! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: variances.F90,v $
!  Revision 20.0  2013/12/14 00:13:55  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:54  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1  2005-06-27 10:54:33  kbk
!  new files needed
!
!
!EOP
!-----------------------------------------------------------------------
! !LOCAL VARIABLES:

   integer                             :: i
   REALTYPE                            :: N,Nt
   REALTYPE                            :: fac1,fac2,fac3,fac4,fac5

!
!-----------------------------------------------------------------------
!BOC

   N    =   0.5*cc1
   Nt   =   ct1

   do i=0,nlev

      fac1 = 2./3.
      fac2 = 1.0/( N*eps(i) )
      fac3 = a2/3.0 + a3
      fac4 = a2/3.0 - a3
      fac5 = 2./3.*a2

      uu(i) = tke(i)*( fac1 + fac2*( fac3*num(i)*SSU(i)                &
                          - fac5*num(i)*SSV(i) - 4./3.*a5*B(i) ) )

      vv(i) = tke(i)*( fac1 + fac2*( fac3*num(i)*SSV(i)                &
                          - fac5*num(i)*SSU(i) - 4./3.*a5*B(i) ) )

      ww(i) = tke(i)*( fac1 + fac2*( fac4*P(i) + 8./3.*a5*B(i) ) )

   enddo

   return
   end subroutine variances

!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module idealized_ic_mod 
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  !<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Z. Liang  </CONTACT>
  !<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies </REVIEWER>

  !<OVERVIEW>
  ! For preparing idealized mom4 initial conditions
  !</OVERVIEW>
  !
  !<DESCRIPTION>
  ! This program prepares idealized initial conditions (active and passive tracer). 
  ! Results are netcdf files that are then read into mom4.
  ! Various idealized options are available as selected by a namelist.
  !</DESCRIPTION>
  !

  use fms_mod,         only : write_version_number, stdout, open_namelist_file
  use fms_mod,         only : file_exist, check_nml_error, read_data
  use mpp_mod,         only : mpp_chksum, mpp_pe, mpp_root_pe, mpp_npes, mpp_error, FATAL, NOTE 
  use mpp_io_mod,      only : mpp_open, mpp_close, mpp_write_meta, mpp_write, mpp_get_axis_data
  use mpp_io_mod,      only : mpp_get_info, mpp_get_axes, mpp_get_atts, mpp_get_axis_data, axistype
  use mpp_io_mod,      only : MPP_RDONLY, MPP_MULTI, MPP_SINGLE, MPP_OVERWR, MPP_NETCDF, fieldtype
  use mpp_domains_mod, only : domain2d, mpp_define_layout, mpp_define_domains
  use mpp_domains_mod, only : mpp_get_compute_domain, mpp_global_field, mpp_domains_set_stack_size
  use constants_mod,   only : RADIAN, grav, rho0, rho0r

  implicit none
  private

  integer, parameter :: max_tracer = 10

  !--- namelist ----------------------------------------------------------
  !<NAMELIST NAME="idealized_ic_nml">
  !  <DATA NAME="temp_type" TYPE="character(len=128)" >
  !  Control the iealized initial temperature condition options. 
  !  There are various options available and the default value is 
  !  "constant_temp_ic". When temp_type is
  !  1. = "constant_temp_ic", use spatially constant initial potential temperature.
  !  2. = "exponential_temp_ic", use initial potential temperature that is 
  !        exponential in the vertical.
  !  3. = "equatorial_temp_ic", use initial temp condition for idealized equatorial studies.
  !  4. = "shelfbowl_temp_ic", Initial conditions for Winton etal shelf-bowl test case.  
  !        Use tanh transition between cold shelf and warm bowl waters, instead of Heaviside. 
  !  5. = "zonal_levitus_temp_ic", use zonal average Levitus temp as initial conditions. 
  !  6. = "zonal_levitus_temp_dome_ic" zonal Levitus, except constant_temp_value in embayment
  !  7. = "temp_for_dome_ic" linear stratification with special treatment within embayment
  !  8. = "ideal_thermocline", idealized thermocline with profile from Smith and Vallis (2001). 
  !  </DATA>
  !
  !  <DATA NAME="salt_type" TYPE="character(len=128)" >
  !  Control the idealized initial salinity condition options. 
  !  The following options for salt_type are available, with default 
  !  "constant_salt_ic".
  !  "constant_salt_ic", use spatially constant initial salinity.
  !  "exponential_salt_ic", use initial salinity that is exponential in the vertical.
  !  "salinity_profile_ic", use initial salinity condition as set by profile in function salt0
  !  "salinity_for_dome_ic", salinity=1.0 for inflow in dome embayment and 0.0 elsewhere.
  !  "salinity_layer_ic"  , salinity=1.0 in a layer and 0.0 elsewhere. For passive salinity experiments. 
  !  "salinity_patch_ic"  , salinity=1.0 in a patch and 0.0 elsewhere. For passive salinity experiments. 
  !  "shelfbowl_salinity_ic", salinity=1.0 on shelf, and 0.0 elsewhere. For passive salinity experiments. 
  !  </DATA>
  !
  !  <DATA NAME="age_type" TYPE="character(len=128)" >
  !  Control the idealized initial age condition options. 
  !  There is only one option now available, and the default value is 
  !  "constant_age_ic". 
  !  </DATA>
  !
  !  <DATA NAME="constant_temp_value" TYPE="real">
  !  Value for uniform initial temp.
  !  </DATA>
  !  <DATA NAME="constant_salt_value" TYPE="real">
  !  Value for uniform initial salinity.
  !  </DATA>
  !
  !  <DATA NAME="efold_depth" TYPE="real" UNITS="metre">
  !  The efolding depth used for exponential temp or salinity profile. 
  !  Default=1000.0
  !  </DATA>
  !
  !  <DATA NAME="ideal_thermocline_deltaT" TYPE="real" UNITS="degC">
  !  Difference in temperature between bottom and surface for 
  !  the ideal thermocline initial conditions. Default
  !  ideal_thermocline_deltaT=20.0
  !  </DATA>
  !  <DATA NAME="ideal_thermocline_scale_thick" TYPE="real" UNITS="dimensionless">
  !  Dimensionless scale thickness for the ideal thermocline profile.  The dimensionful
  !  scale thickness is Hscale = H*ideal_thermocline_scale_thick, with H the ocean bottom.
  !  Default ideal_thermocline_scale_thick=0.10  (range of 0.05 to 0.15 recommended by 
  !  Smith and Vallis (2001).
  !  </DATA>
  !  <DATA NAME="ideal_thermocline_rho0" TYPE="real" UNITS="kg/m3">
  !  Density scale for use with the ideal thermocline configuration.
  !  Default ideal_thermocline_rho0=1035. 
  !  </DATA>
  !  <DATA NAME="ideal_thermocline_alpha" TYPE="real" UNITS="dimensionless">
  !  Linear scaling for thermocline. Default is ideal_thermocline_alpha=0.0005.
  !  </DATA>
  !  <DATA NAME="ideal_thermocline_alpha_eos" TYPE="real" UNITS="kg/(m3*C)">
  !  Linear equation of state parameter for ideal thermocline, assuming 
  !  rho = rho0 - ideal_thermocline_alpha_eos*theta. Default 
  !  ideal_thermocline_alpha_eos=0.255.
  !  </DATA>
  !  <DATA NAME="ideal_thermocline_offset" TYPE="real" UNITS="C">
  !  Offset to make the temperature profile realistic. 
  !  Default ideal_thermocline_offset=22.0.
  !  </DATA>
  !
  !  <DATA NAME="linear_theta_strat" TYPE="real" UNITS="degreesC/metre">
  !  The linear vertical stratification for theta for reference in DOME configuration. 
  !  </DATA>
  !
  !  <DATA NAME="dome_debug" TYPE="logical">
  ! For debugging DOME conditions. 
  !  </DATA>
  !  <DATA NAME="dome_embayment_west" TYPE="real" UNITS="dimensionless">
  ! western edge of dome embayment. Default=18.75
  !  </DATA>
  !  <DATA NAME="dome_embayment_east" TYPE="real" UNITS="dimensionless">
  ! eastern edge of dome embayment. Default=20.75
  !  </DATA>
  !  <DATA NAME="dome_embayment_north" TYPE="real" UNITS="dimensionless">
  ! northern edge of dome embayment. Default=69.75.  This is a resolution dependent
  ! value, and should be determined for each grid used. 
  !  </DATA>
  !  <DATA NAME="dome_embayment_south" TYPE="real" UNITS="dimensionless">
  ! southern edge of dome embayment. Default=69.0. This is a resolution dependent
  ! value, and should be determined for each grid used. 
  !  </DATA>
  !  <DATA NAME="dome_embayment_depth" TYPE="real" UNITS="m">
  ! Depth of the embayment. Default=600.0
  !  </DATA>
  !  <DATA NAME="dome_bottom" TYPE="real" UNITS="m">
  ! Depth of the deepest water in DOME configuration. Default=3600.0
  !  </DATA>
  !  <DATA NAME="dome_embayment_interface" TYPE="real" UNITS="m">
  ! Depth (m) determining the inflow mass flux.  Default=300.0
  !  </DATA>
  !  <DATA NAME="dome_embayment_coriolis" TYPE="real" UNITS="1/s">
  ! reference Coriolis parameter for determining Rossby radius in 
  ! the DOME inflow.  Default taken at 70N.
  !  </DATA>
  !  <DATA NAME="dome_crit_richardson" TYPE="real" UNITS="1/s">
  ! Critical Richardson number used for dome. When running with 
  ! coarse models, dome_crit_richardson=1/1000 is what Legg recommends,
  ! whereas in refined models (finer than 50km), dome_crit_richardson=1/3.
  ! Default is dome_crit_richardson=.001.
  !  </DATA>
  !  <DATA NAME="dome_drho_inflow" TYPE="real" UNITS="kg/m3">
  ! Density difference between inflow and reference for DOME 
  ! configuration. Default dome_drho_ref=2.0
  !  </DATA>
  !
  !  <DATA NAME="salinity_layer_ztop" TYPE="real">
  !  Depth at the top of the salinity layer. 
  !  </DATA>
  !  <DATA NAME="salinity_layer_zbot" TYPE="real">
  !  Depth at the bottom of the salinity layer. 
  !  </DATA>
  !  <DATA NAME="salinity_patch_ztop" TYPE="real">
  !  Depth at the top of the salinity patch. 
  !  </DATA>
  !  <DATA NAME="salinity_patch_zbot" TYPE="real">
  !  Depth at the bottom of the salinity patch. 
  !  </DATA>
  !  <DATA NAME="salinity_patch_ratio1" TYPE="real">
  !  For setting position of salinity patch.
  !  </DATA>
  !  <DATA NAME="salinity_patch_ratio2" TYPE="real">
  !  For setting position of salinity patch.
  !  </DATA>
  !
  !  <DATA NAME="constant_age_value" TYPE="real">
  !  Value for uniform initial age.
  !  </DATA>
  !
  !  <DATA NAME="generate_zonal_velocity_ic" TYPE="logical" >
  !  For generating the zonal velocity at the t-cell. 
  !  </DATA>
  !  <DATA NAME="generate_merid_velocity_ic" TYPE="logical" >
  !  For generating the meridional velocity at the t-cell. 
  !  </DATA>
  !  <DATA NAME="zonal_velocity_name" TYPE="character(len=128)" >
  !  name array of the zonal velocity component
  !  to be generated. Its default value is 'ut_inflow'.
  !  </DATA>
  !  <DATA NAME="merid_velocity_name" TYPE="character(len=128)" >
  !  name array of the meridional velocity component
  !  to be generated. Its default value is 'vt'.
  !  </DATA>
  !  <DATA NAME="zonal_velocity_file" TYPE="character(len=128)" >
  !  zonal velocity output file. Default is 'ut.res.nc'
  !  </DATA>
  !  <DATA NAME="merid_velocity_file" TYPE="character(len=128)" >
  !  meridional velocity output file.  Default is 'vt.res.nc'
  !  </DATA>
  !
  !  <DATA NAME="num_active_tracer" TYPE="integer" >
  !  Number of active tracers will be generated. Its value should be 0, 1, 2.
  !  Its default value is 2. ( temp and salt )
  !  </DATA>
  !  <DATA NAME="active_tracer" TYPE="character(len=128),dimension(2)" >
  !  name array of the active tracers will be generated. 
  !  Its element value should be 'temp' or 'salt'
  !  </DATA>
  !  <DATA NAME="active_tracer_file" TYPE="character(len=128)" >
  !  active tracer output file.
  !  </DATA>
  !
  !  <DATA NAME="num_passive_tracer" TYPE="integer" >
  !  Number of passive tracers will be generated. Its value should be no more than max_tracer.
  !  Its default value is 1 (age). 
  !  </DATA>
  !  <DATA NAME="" TYPE="character(len=128),dimension(max_tracer)" >
  !  name array of the passive tracers will be generated. 
  !  Its element value should be 'age'.
  !  </DATA>
  !  <DATA NAME="passive_tracer_file" TYPE="character(len=128)" >
  !  passive tracer output file.
  !  </DATA>
  !
  !  <DATA NAME="grid_file" TYPE="character(len=128)" >
  !  grid descriptor file.
  !  </DATA>
  !  <DATA NAME="t1" TYPE="real">
  !  For setting idealized vertical profile 
  !  </DATA>
  !  <DATA NAME="t0" TYPE="real">
  !  For setting idealized vertical profile 
  !  </DATA>
  !  <DATA NAME="z0" TYPE="real">
  !  For setting idealized vertical profile 
  !  </DATA>
  !  <DATA NAME="thk" TYPE="real">
  !  For setting idealized vertical profile 
  !  </DATA>
  !
  !  <DATA NAME="write_time_axis" TYPE="logical">
  !  For writing a time axis for the IC. This is useful if 
  !  wish to use the IC as a static dataset for sponges. 
  !  Default write_time_axis=.true. 
  !  </DATA>
  ! </NAMELIST>

  character(len=128) :: temp_type = 'constant_temp_ic'
  character(len=128) :: salt_type = 'constant_salt_ic'
  character(len=128) :: age_type  = 'constant_age_ic'

  logical :: dome_debug=.false.           ! for debugging 
  real :: dome_embayment_west=18.75       ! western edge of dome embayment (degrees)
  real :: dome_embayment_east=20.75       ! eastern edge of dome embayment (degrees)
  real :: dome_embayment_south=69.0       ! southern edge of the dome embayment (degrees)
  real :: dome_embayment_north=69.75      ! northern edge of the dome embayment (degrees)
  real :: dome_embayment_depth=600.0      ! depth of the dome embayment (m)
  real :: dome_bottom=3600.0              ! depth of deepest water in dome configuration (m)
  real :: dome_embayment_interface=300.0  ! depth (m) determining the inflow mass flux 
  real :: dome_embayment_coriolis=1.37e-4 ! reference Coriolis parameter 
  real :: dome_drho_inflow=2.0            ! increase in density going from reference to inflow 
  real :: dome_crit_richardson=0.001      ! critical Richardson number for DOME inflow 

  real :: deg2metre=111.324e3             ! convert degrees latitude to metres  

  real :: ideal_thermocline_deltaT      = 20.0
  real :: ideal_thermocline_scale_thick = 0.10
  real :: ideal_thermocline_rho0        = 1035.0
  real :: ideal_thermocline_alpha       = 5e-4
  real :: ideal_thermocline_alpha_eos   = 0.255
  real :: ideal_thermocline_offset      = 20.0

  real               :: constant_temp_value      = 12.0
  real               :: constant_salt_value      = 34.72

  real               :: linear_theta_strat       = 2.19e-3

  real               :: salinity_layer_ztop      = 160.0
  real               :: salinity_layer_zbot      = 165.0
  real               :: salinity_patch_ztop      = 160.0
  real               :: salinity_patch_zbot      = 165.0
  real               :: salinity_patch_ratio1    = .333333333
  real               :: salinity_patch_ratio2    = .666666666

  real               :: efold_depth=1000.0

  real               :: constant_age_value       = 0.0
  real               :: t0=7.5, t1=10.0, z0=30.0, thk=80.0
  integer            :: num_active_tracer = 2   
  character(len=128) :: grid_file = 'grid_spec.nc'

  logical            :: generate_zonal_velocity_ic=.false.
  logical            :: generate_merid_velocity_ic=.false.
  character(len=128) :: zonal_velocity_name = 'ut'
  character(len=128) :: merid_velocity_name = 'vt'
  character(len=128) :: zonal_velocity_file = 'ut.res.nc'
  character(len=128) :: merid_velocity_file = 'vt.res.nc'

  character(len=128) :: active_tracer(2)
  character(len=128) :: active_tracer_file = 'ocean_temp_salt.res.nc'

  integer            :: num_passive_tracer = 1
  character(len=128) :: passive_tracer(max_tracer)
  character(len=128) :: passive_tracer_file = 'ocean_age.res.nc'

  logical            :: write_time_axis=.false. 

  namelist /idealized_ic_nml/ temp_type, salt_type, constant_temp_value, constant_salt_value, &
       salinity_layer_ztop, salinity_layer_zbot, salinity_patch_ztop, salinity_patch_zbot,    &
       salinity_patch_ratio1, salinity_patch_ratio2,                                          &
       t1, t0, z0, thk,  num_active_tracer, active_tracer, active_tracer_file,                &
       num_passive_tracer, passive_tracer, passive_tracer_file, grid_file,                    &
       generate_zonal_velocity_ic, generate_merid_velocity_ic,                                &
       zonal_velocity_name, merid_velocity_name, zonal_velocity_file, merid_velocity_file,    &
       efold_depth, write_time_axis, linear_theta_strat,                                      &
       dome_embayment_west, dome_embayment_east, dome_embayment_south, dome_embayment_north,  &
       dome_embayment_depth, dome_bottom, dome_embayment_interface, dome_embayment_coriolis,  &
       dome_drho_inflow, dome_crit_richardson, dome_debug,                                    &
       ideal_thermocline_deltaT, ideal_thermocline_scale_thick,                               &
       ideal_thermocline_rho0, ideal_thermocline_alpha, ideal_thermocline_offset

  !--- version information 
  character(len=128) :: version = '$Id: idealized_ic.f90,v 14.0 2007/03/15 22:47:01 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $' 

  !--- output data -------------------------------------------------------
  real, dimension(:,:,:), allocatable :: temp, salt, age
  real, dimension(:,:,:), allocatable :: global_temp, global_salt, global_age
  real, dimension(:,:,:), allocatable :: ut, vt
  real, dimension(:,:,:), allocatable :: global_ut, global_vt
  !--- other variables
  logical                           :: generate_temp_ic     = .FALSE.
  logical                           :: generate_salt_ic     = .FALSE.
  logical                           :: generate_age_ic      = .FALSE.
  real, dimension(:,:), allocatable :: xt, yt, kmt 
  real, dimension(:),   allocatable :: zt, grid_x_t, grid_y_t
  logical                           :: module_is_initialized = .FALSE.
  integer                           :: ni, nj, nk, isc, iec, jsc, jec
  type(domain2d),save               :: domain
  !--- public interface --------------------------------------------------
  public  idealized_ic_init, write_idealized_ic_data, idealized_ic_end

contains

  !#######################################################################
  ! <SUBROUTINE NAME="idealized_ic_init">
  !
  ! <DESCRIPTION>
  ! Initialize the module generating ideal initial conditions.
  ! </DESCRIPTION>
  ! </SUBROUTINE>
  subroutine idealized_ic_init

    !--- local variables -------------------------------------------------
    integer :: unit, io_status, ierr, n
    integer :: chksum_t, chksum_s, chksum_a
    !---------------------------------------------------------------------

    if ( module_is_initialized ) call mpp_error(FATAL, 'idealized_ic_mod: attempted reinitialization')

    module_is_initialized = .TRUE.

    !--- default value of tracer_name
    active_tracer(1)  = 'temp'
    active_tracer(2)  = 'salt'
    passive_tracer(1) = 'age'

    if (file_exist('input.nml')) then
       unit = open_namelist_file ( )
       ierr=1
       do while (ierr /= 0)
          read  (unit, idealized_ic_nml,iostat=io_status, end = 10)
          ierr = check_nml_error(io_status,'idealized_ic_nml')
       enddo
10     call mpp_close (unit)
    else
       call mpp_error(NOTE,'idealized_ic_mod: file input.nml does not exist, use default namelist option')  
    endif

    if(num_active_tracer .gt. 2) call mpp_error(FATAL, &
            'idealized_ic_mod: num_active_tracer should be the value of 0, 1 or 2')

    if(num_passive_tracer .gt. max_tracer) call mpp_error(FATAL, &
            'idealized_ic_mod: num_passive_tracer should be no greater than max_tracer')   
 
    do n = 1, num_active_tracer
       select case(active_tracer(n))
       case('temp')
          generate_temp_ic = .true.
       case('salt')
          generate_salt_ic = .true.
       case default
          call mpp_error(FATAL, trim(active_tracer(n))//' is not a valid option of nml active_tracer')
       end select
    enddo

    do n = 1, num_passive_tracer
       select case(passive_tracer(n))
       case('age')
          generate_age_ic = .true.
       case default
          call mpp_error(FATAL, trim(passive_tracer(n))//' is not a valid option of nml passive_tracer')
       end select
    enddo

    !--- at least one of generate_temp_ic and generate_salt_ic should be true
    if(.not.generate_temp_ic .and. .not.generate_salt_ic .and. .not.generate_age_ic)  &
      call mpp_error(FATAL, &
         'idealized_ic_mod: nml "generate_temp_ic"="generate_salt_ic"="generate_salt_ic"=false.  At least one should be true')

    !--- write out version information and namelist option ---------------
    call write_version_number(version, tagname)
    if (mpp_pe() == mpp_root_pe()) then
       write (stdout(), nml= idealized_ic_nml)
    endif

    !--- get grid information
    call get_grid

    !--- allocate memory to module variables
    allocate(temp(isc:iec,jsc:jec,nk), salt(isc:iec,jsc:jec,nk), age(isc:iec,jsc:jec,nk) )
    allocate(global_temp(ni,nj,nk), global_salt(ni,nj,nk), global_age(ni,nj,nk) )

    ! idealized temperature initial conditions 
    if(generate_temp_ic) then
       call idealized_temp_ic()
       call mpp_domains_set_stack_size(ni*nj*nk*2)
       call mpp_global_field(domain,temp,global_temp)
       chksum_t = mpp_chksum(temp)
       write (stdout(),'(/(a,I20/))')' Idealized_ic Checksum: T=', chksum_t 
    endif

    ! idealized salinity initial conditions 
    if(generate_salt_ic) then 
       call idealized_salt_ic()
       call mpp_domains_set_stack_size(ni*nj*nk*2)
       call mpp_global_field(domain,salt,global_salt)
       chksum_s = mpp_chksum(salt)
       write (stdout(),'(/(a,I20/))') ' Idealized_ic Checksum: S=', chksum_s
    endif

    ! idealized age initial conditions 
    if(generate_age_ic) then 
       call idealized_age_ic()
       call mpp_domains_set_stack_size(ni*nj*nk*2)
       call mpp_global_field(domain,age,global_age)
       chksum_a = mpp_chksum(age)
       write (stdout(),'(/(a,I20/))') ' Idealized_ic Checksum: age=', chksum_a
    endif

    if(generate_zonal_velocity_ic) then 
       allocate(ut(isc:iec,jsc:jec,nk))
       allocate(global_ut(ni,nj,nk))
       call idealized_zonal_velocity_ic() 
       call mpp_domains_set_stack_size(ni*nj*nk*2)
       call mpp_global_field(domain,ut,global_ut)
       chksum_t = mpp_chksum(ut)
       write (stdout(),'(/(a,I20/))')' Idealized_ic Checksum: ut=', chksum_t 
    endif 
    if(generate_merid_velocity_ic) then 
       allocate(vt(isc:iec,jsc:jec,nk))
       allocate(global_vt(ni,nj,nk))
       call idealized_merid_velocity_ic() 
       call mpp_domains_set_stack_size(ni*nj*nk*2)
       call mpp_global_field(domain,vt,global_vt)
       chksum_t = mpp_chksum(vt)
       write (stdout(),'(/(a,I20/))')' Idealized_ic Checksum: vt=', chksum_t 
    endif 


    return

  end subroutine idealized_ic_init

  !#######################################################################
  !--- idealized temperature initial condition
  subroutine idealized_temp_ic

    real    :: t_value, fact
    integer :: i, j, k, kb

    select case (trim(temp_type))
    case('constant_temp_ic')
       t_value = constant_temp_value
       temp =  t_value
       write (stdout(),'(/a,(f6.2,a)/)') ' Note: constant temp IC is being set. T=',t_value,' deg C.'
    case('equatorial_temp_ic')
       write (stdout(),'(/a/)') ' Note: idealized equatorial temp IC is being set.'
       do k=1,nk
          if(z0 == 0.0) call mpp_error(FATAL,'idealized_ic_mod: nml "z0"= 0.0, but should be nonzero')
          t_value = t0*(1.0-tanh((zt(k)-thk)/z0)) + t1*(1.0-zt(k)/zt(nk))
          temp(:,:,k) = t_value
          write (stdout(),*) ' k=',k,' T=',t_value,' deg C.'
       enddo
    case('exponential_temp_ic')
       write (stdout(),'(/a/)') ' Note: exponential temperature IC is being set.'
       do k=1,nk
          t_value = 22.0*exp(-zt(k)/efold_depth)
          temp(:,:,k) = t_value
          write (stdout(),*) ' k=',k,' T=',t_value,' deg C.'
       enddo
    case('shelfbowl_temp_ic')
       write (stdout(),'(/a/)') ' Note: shelfbowl temperature ic being set, assuming south-edge of shelf is at 70N.'
       do k=1,nk
          do j=jsc,jec
             do i=isc,iec
                t_value = 5.0*(1.0 + 0.5*(1.0-tanh(0.5*(yt(i,j)-70.0))) )
                temp(i,j,k)  = t_value
             enddo
          enddo
       enddo
    case('zonal_levitus_temp_dome_ic')
       write (stdout(),'(/a/)') ' Note: zonal averaged Levitus temp plus cold embayment IC set for depth < 2000m.'
       do k=1,nk
          do j=jsc,jec
             do i=isc,iec
                temp(i,j,k)  = theta0 (yt(i,j), zt(k))
             enddo
          enddo
       enddo
       do j=jsc,jec
         do i=isc,iec
           if(yt(i,j) >= dome_embayment_south) then 
              temp(i,j,:) = constant_temp_value
           endif 
         enddo
       enddo
    case('temp_for_dome_ic')
       write (stdout(),'(/a/)') ' Note: linear stratification for DOME configuration with inflow condition.'
       do k=1,nk
          do j=jsc,jec
             do i=isc,iec
                temp(i,j,k) = dome_conditions(xt(i,j), yt(i,j), zt(k), 'temp')
             enddo
          enddo
       enddo

    case('ideal_thermocline')
       write (stdout(),'(/a/)') ' Note: ideal_thermocline stratification specified for temp IC.'
       do k=1,nk
          do j=jsc,jec
             do i=isc,iec
                temp(i,j,k) = ideal_thermocline(zt(k),zt(nk))
             enddo
          enddo
       enddo

    case('zonal_levitus_temp_ic')
       write (stdout(),'(/a/)') ' Note: zonal averaged Levitus temp IC set for depth < 2000m.'
       do k=1,nk
          do j=jsc,jec
             do i=isc,iec
                temp(i,j,k)  = theta0 (yt(i,j), zt(k))
             enddo
          enddo
       enddo

    case default
       call mpp_error(FATAL,'idealized_ic_mod: '//trim(temp_type)//' is not a valid option of nml "temp_type" ')
    end select

    ! zero out temperature in land points
    do j=jsc,jec
       do i=isc,iec
          kb = kmt(i,j)
          do k=1,nk
             if (k .gt. kb) then
                temp(i,j,k) = 0.0
             endif
          enddo
       enddo
    enddo

    return

  end subroutine idealized_temp_ic

!#######################################################################
  ! idealized salinity initial conditions 
  subroutine idealized_salt_ic

    real    :: s_value, fact
    real    :: xwidth, ywidth, xwest, xeast, ysouth, ynorth
    integer :: i,j,k,kb

    select case (trim(salt_type))
    case('constant_salt_ic')
       s_value = constant_salt_value
       salt = s_value
       write (stdout(),'(/a,2(f6.2,a)/)') ' Note: constant salinity IC being set. s=',s_value,' psu.'
    case('exponential_salt_ic')
       write (stdout(),'(/a/)') ' Note: exponential salinity IC is being set.'
       do k=1,nk
          s_value = 22.0*exp(-zt(k)/efold_depth)
          salt(:,:,k) = s_value
          write (stdout(),*) ' k=',k,' S=',s_value, ' psu.'
       enddo
    case('salinity_profile_ic')
       write (stdout(),'(/a/)') ' Note: general salinity IC profile from salt0 is being set.'
       do k=1,nk
          do j=jsc,jec
             do i=isc,iec
                salt(i,j,k)  = salt0 (zt(k))
             enddo
          enddo
       enddo
    case('salinity_for_dome_ic')
       write (stdout(),'(/a/)') ' Note: setting salinity according to DOME specification.'
       do k=1,nk
          do j=jsc,jec
             do i=isc,iec
                salt(i,j,k) = dome_conditions(xt(i,j), yt(i,j), zt(k), 'salinity')
             enddo
          enddo
       enddo
    case('salinity_layer_ic')
        write (stdout(),'(/a/)') ' Note: setting salinity to 1.0 in a layer, 0.0 elsewhere.'
        salt(:,:,:) = 0.0
        do k=1,nk
           if(zt(k) >=salinity_layer_ztop .and. zt(k) <= salinity_layer_zbot) then 
               salt(:,:,k) = 1.0
           endif
        enddo
    case('salinity_patch_ic')
        write (stdout(),'(/a/)') ' Note: setting salinity to 1.0 in a patch, 0.0 elsewhere.'
        salt(:,:,:) = 0.0
        xwidth = abs(xt(ni,1)-xt(1,1))
        ywidth = abs(yt(1,nj)-yt(1,1)) 
        xwest  = xt(1,1) + salinity_patch_ratio1*xwidth
        xeast  = xt(1,1) + salinity_patch_ratio2*xwidth
        ysouth = yt(1,1) + salinity_patch_ratio1*ywidth
        ynorth = yt(1,1) + salinity_patch_ratio2*ywidth
        write(stdout(),*)' for salinity_patch_ic, xwest  = ', xwest
        write(stdout(),*)' for salinity_patch_ic, xeast  = ', xeast
        write(stdout(),*)' for salinity_patch_ic, ynorth = ', ynorth
        write(stdout(),*)' for salinity_patch_ic, ysouth = ', ysouth
        do k=1,nk
           if(zt(k) >=salinity_patch_ztop .and. zt(k) <= salinity_patch_zbot) then 
               do j=jsc,jec
                  do i=isc,iec
                      if(xt(i,j) >= xwest  .and. xt(i,j) <= xeast   .and. &
                         yt(i,j) >= ysouth .and. yt(i,j) <= ynorth ) then    
                         salt(i,j,k) = 1.0
                      endif 
                  enddo
               enddo
           endif
        enddo
    case('shelfbowl_salinity_ic')
       write (stdout(),'(/a/)') ' Note: shelfbowl salinity ic being set, assuming south-edge of shelf is at 70N.'
       do k=1,nk
          do j=jsc,jec
             do i=isc,iec
                if(yt(i,j)>=69.5) then 
                  s_value=constant_salt_value
                else
                  s_value=0.0
                endif
                salt(i,j,k) = s_value
             enddo
          enddo
       enddo
    case default
       call mpp_error(FATAL,'idealized_ic_mod: '//trim(salt_type)//' is not a valid option of nml "salt_type" ')
    end select

    ! zero out salinity in land points
    do j=jsc,jec
       do i=isc,iec
          kb = kmt(i,j)
          do k=1,nk
             if (k .gt. kb) then
                salt(i,j,k) = 0.0
             endif
          enddo
       enddo
    enddo

    return

end  subroutine idealized_salt_ic


!#######################################################################
  ! idealized age initial conditions 
  subroutine idealized_age_ic

    real    :: age_value, fact
    integer :: i,j,k,kb

    select case (trim(age_type))
    case('constant_age_ic')
       age_value = constant_age_value
       age = age_value
       write (stdout(),'(/a,2(f6.2,a)/)') ' Note: constant age IC being set. age=',age_value,' seconds.'
    case default
       call mpp_error(FATAL,'idealized_ic_mod: '//trim(age_type)//' is not a valid option of nml "age_type" ')
    end select

    ! zero out age in land points
    do j=jsc,jec
       do i=isc,iec
          kb = kmt(i,j)
          do k=1,nk
             if (k .gt. kb) then
                age(i,j,k) = 0.0
             endif
          enddo
       enddo
    enddo

    return

end  subroutine idealized_age_ic

!#######################################################################
! idealized zonal velocity initial conditions (nothing yet here)
subroutine idealized_zonal_velocity_ic

  integer :: i,j,k

  write (stdout(),'(/a/)') ' Note: setting zonal velocity to zero.'
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           ut(i,j,k) = 0.0
        enddo
     enddo
  enddo

  return

end  subroutine idealized_zonal_velocity_ic



!#######################################################################
  ! idealized meridional velocity initial conditions 
subroutine idealized_merid_velocity_ic

  integer :: i,j,k

  write (stdout(),'(/a/)') ' Note: setting merid velocity according to DOME inflow conditions.'
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           vt(i,j,k) = dome_conditions(xt(i,j), yt(i,j), zt(k), 'vt')
        enddo
     enddo
  enddo

  return

end  subroutine idealized_merid_velocity_ic



!#######################################################################
  !--- read grid from grid_spec file.
  subroutine get_grid

    integer, dimension(2) :: layout  = (/ 1, 0 /)
    integer :: unit, npes, ndim, nvar, natt, ntime, len, i, j, k, kb, mk
    type(axistype), dimension(:), allocatable :: axes
    real, dimension(:,:), allocatable :: tmp, ht
    character(len=128) :: name

    !--- get grids information -------------------------------------------
    npes = mpp_npes()
    if(file_exist(trim(grid_file))) then
       call mpp_open(unit,trim(grid_file),MPP_RDONLY,MPP_NETCDF,threading=MPP_MULTI,fileset=MPP_SINGLE)
       call mpp_get_info(unit, ndim, nvar, natt, ntime)
       allocate(axes(ndim))
       call mpp_get_axes(unit,axes)
       do i=1, ndim
          call mpp_get_atts(axes(i),name=name,len=len)
          select case(trim(name))
          case ('grid_x_T')
             ni = len
             allocate(grid_x_t(ni))
             call mpp_get_axis_data(axes(i),data=grid_x_t)
          case ('grid_y_T')
             nj = len
             allocate(grid_y_t(nj))
             call mpp_get_axis_data(axes(i),data=grid_y_t)        
          case ( 'zt' )
             nk = len
             allocate(zt(nk))
             call mpp_get_axis_data(axes(i),data=zt ) 
          end select
       enddo
       call mpp_close(unit)
       if(ni == 0) call mpp_error(FATAL,'idealized_ic_mod: '//trim(grid_file)//' does not contain axis grid_x_T')
       if(nj == 0) call mpp_error(FATAL,'idealized_ic_mod: '//trim(grid_file)//' does not contain axis grid_y_T')
       if(nk == 0) call mpp_error(FATAL,'idealized_ic_mod: '//trim(grid_file)//' does not contain axis zt')

       !--- define domain ------------------------------------------------
       call mpp_define_layout((/1,ni,1,nj/),npes,layout)
       call mpp_define_domains((/1,ni,1,nj/),layout, domain)
       call mpp_get_compute_domain(domain, isc, iec, jsc, jec)
       allocate(xt(ni,nj), yt(ni,nj), kmt(isc:iec,jsc:jec),  &
            tmp(isc:iec,jsc:jec), ht(isc:iec,jsc:jec) )
       call read_data(trim(grid_file), 'x_T', xt)
       call read_data(trim(grid_file), 'y_T', yt)
       call read_data(trim(grid_file), 'depth_t', ht, domain)
       call read_data(trim(grid_file), 'num_levels', tmp,domain)
       kmt = tmp
       deallocate(tmp, axes)
    else
       call mpp_error(FATAL, 'idealized_ic_mod: file '//trim(grid_file)//' does not exist in your work directory')
    endif

  end subroutine get_grid

  !#######################################################################
  ! <SUBROUTINE NAME="write_idealized_ic_data">
  !
  ! <DESCRIPTION>
  !    Write out tracer data to netcdf file 
  ! </DESCRIPTION>
  ! </SUBROUTINE>
  subroutine write_idealized_ic_data

    real, dimension(:,:,:,:),         allocatable :: tracer
    character(len=128), dimension(:), allocatable :: fld_name, fld_unit, fld_longname
    integer                                       :: n

    if(num_active_tracer .gt. 0) then
       allocate(tracer(ni,nj,nk,num_active_tracer), fld_name(num_active_tracer) )
       allocate( fld_unit(num_active_tracer), fld_longname(num_active_tracer) )
       n = 0
       if(generate_temp_ic) then
          n = n + 1
          tracer(:,:,:,n) = global_temp
          fld_name(n)     = 'temp'
          fld_unit(n)     = 'deg_c'
          fld_longname(n) = 'initial potential temp'
       endif
       if(generate_salt_ic) then
          n = n + 1
          tracer(:,:,:,n) = global_salt
          fld_name(n)     = 'salt'
          fld_unit(n)     = 'psu'
          fld_longname(n) = 'initial salinity'
       endif
       call write_tracer_data(active_tracer_file, tracer, fld_name, fld_unit, fld_longname )
       deallocate(tracer, fld_name, fld_unit, fld_longname)
    endif

    if(num_passive_tracer .gt. 0) then
       allocate(tracer(ni,nj,nk,num_passive_tracer), fld_name(num_passive_tracer) )
       allocate(fld_unit(num_passive_tracer), fld_longname(num_passive_tracer) )
       n = 0
       if(generate_age_ic) then
          n = n + 1
         tracer(:,:,:,n) = global_age
          fld_name(n)     = 'age_global'
          fld_unit(n)     = 'sec'
          fld_longname(n) = 'initial age'
       endif
       call write_tracer_data(passive_tracer_file, tracer, fld_name, fld_unit, fld_longname )
       deallocate(tracer, fld_name, fld_unit, fld_longname)
    endif

    if(generate_zonal_velocity_ic) then
       call write_velocity_data(zonal_velocity_file, global_ut, 'ut', &
                                'm/s','zonal velocity component at t-cell')
    endif
    if(generate_merid_velocity_ic) then
       call write_velocity_data(merid_velocity_file, global_vt, 'vt', &
                                'm/s','merid velocity component at t-cell')
    endif


    return

  end subroutine write_idealized_ic_data


  !#######################################################################
  !--- write velocity data to netcdf file, including writing out meta.

  subroutine write_velocity_data(file, velocity, fld_name, fld_unit, fld_longname)

    character(len=*),        intent(in)    :: file
    real, dimension(:,:,:),  intent(inout) :: velocity
    character(len=*),        intent(in)    :: fld_name, fld_unit, fld_longname

    integer          :: unit
    type(axistype)   :: axis_xt, axis_yt, axis_zt, axis_t
    type(fieldtype)  :: fld_x_T, fld_y_T
    type(fieldtype)  :: fld_velocity

    call mpp_open(unit,trim(file), MPP_OVERWR, MPP_NETCDF, threading=MPP_SINGLE, fileset=MPP_SINGLE)

    !--- write out meta data ---------------------------------------------
    call mpp_write_meta(unit, axis_xt,'grid_x_T','degree_east','Nominal Longitude of T-cell center', &
         cartesian ='X', data = grid_x_t )
    call mpp_write_meta(unit, axis_yt,'grid_y_T','degree_north','Nominal Latitude of T-cell center', &
         cartesian ='Y', data = grid_y_t )
    call mpp_write_meta(unit,axis_zt,'zt','meters','zt',&
         data=zt,cartesian='Z',sense=-1)
    call mpp_write_meta(unit, fld_x_T, (/axis_xt, axis_yt/), 'x_T', 'degree_east',  &
         'Geographic longitude of T_cell centers', pack=1)
    call mpp_write_meta(unit, fld_y_T, (/axis_xt, axis_yt/), 'y_T', 'degree_north',  &
         'Geographic latitude of T_cell centers', pack=1)

    call mpp_write_meta(unit,axis_t,'TIME','days since 0001-01-01 00:00:00','TIME',cartesian='T' )

    if(write_time_axis) then 
           call mpp_write_meta(unit, fld_velocity, (/axis_xt, axis_yt, axis_zt, axis_t/), &
                               trim(fld_name), trim(fld_unit), trim(fld_longname), pack=1)
    else 
           call mpp_write_meta(unit, fld_velocity, (/axis_xt, axis_yt, axis_zt/), &
                               trim(fld_name), trim(fld_unit), trim(fld_longname), pack=1)
    endif

    !--- write out data --------------------------------------------------
    call mpp_write(unit, axis_xt)
    call mpp_write(unit, axis_yt)
    call mpp_write(unit, axis_zt)
    call mpp_write(unit, fld_x_T, xt)
    call mpp_write(unit, fld_y_T, yt)
    call mpp_write(unit, fld_velocity, velocity(:,:,:) )
    call mpp_close(unit)

  end subroutine write_velocity_data



  !#######################################################################
  !--- write tracer data to netcdf file, including writing out meta.

  subroutine write_tracer_data(file, tracer, fld_name, fld_unit, fld_longname)

    character(len=*),               intent(in)   :: file
    real, dimension(:,:,:,:),    intent(inout)   :: tracer
    character(len=*), dimension(:), intent(in)   :: fld_name, fld_unit, fld_longname

    integer                                      :: unit, num_tracers, n
    type(axistype)                               :: axis_xt, axis_yt, axis_zt, axis_t
    type(fieldtype)                              :: fld_x_T, fld_y_T
    type(fieldtype),dimension(size(fld_name(:))) :: fld_tracer

    num_tracers = size(fld_name(:))

    call mpp_open(unit,trim(file), MPP_OVERWR, MPP_NETCDF, threading=MPP_SINGLE, fileset=MPP_SINGLE)

    !--- write out meta data ---------------------------------------------
    call mpp_write_meta(unit, axis_xt,'grid_x_T','degree_east','Nominal Longitude of T-cell center', &
         cartesian ='X', data = grid_x_t )
    call mpp_write_meta(unit, axis_yt,'grid_y_T','degree_north','Nominal Latitude of T-cell center', &
         cartesian ='Y', data = grid_y_t )
    call mpp_write_meta(unit,axis_zt,'zt','meters','zt',&
         data=zt,cartesian='Z',sense=-1)
    call mpp_write_meta(unit, fld_x_T, (/axis_xt, axis_yt/), 'x_T', 'degree_east',  &
         'Geographic longitude of T_cell centers', pack=1)
    call mpp_write_meta(unit, fld_y_T, (/axis_xt, axis_yt/), 'y_T', 'degree_north',  &
         'Geographic latitude of T_cell centers', pack=1)

    call mpp_write_meta(unit,axis_t,'TIME','days since 0001-01-01 00:00:00','TIME',cartesian='T' )

    if(write_time_axis) then 
        do n=1,num_tracers
           call mpp_write_meta(unit, fld_tracer(n), (/axis_xt, axis_yt, axis_zt, axis_t/), &
                               trim(fld_name(n)), trim(fld_unit(n)), trim(fld_longname(n)), pack=1)
        enddo
    else 
        do n=1,num_tracers
           call mpp_write_meta(unit, fld_tracer(n), (/axis_xt, axis_yt, axis_zt/), &
                               trim(fld_name(n)), trim(fld_unit(n)), trim(fld_longname(n)), pack=1)
        enddo
    endif

    !--- write out data --------------------------------------------------
    call mpp_write(unit, axis_xt)
    call mpp_write(unit, axis_yt)
    call mpp_write(unit, axis_zt)
    call mpp_write(unit, fld_x_T, xt)
    call mpp_write(unit, fld_y_T, yt)
    do n = 1, num_tracers    
       call mpp_write(unit, fld_tracer(n), tracer(:,:,:,n) )
    enddo
    call mpp_close(unit)

  end subroutine write_tracer_data

  !#######################################################################
 ! <SUBROUTINE NAME="idealized_ic_end">
  !
  ! <DESCRIPTION>
  !  Release memory.
  ! </DESCRIPTION>
  ! </SUBROUTINE>
  subroutine idealized_ic_end

    deallocate(temp, salt, age, xt, yt, kmt, zt, grid_x_t, grid_y_t)

    module_is_initialized = .false.
    return

  end subroutine idealized_ic_end


  !#######################################################################
  ! This subroutine returns estimates of global mean potential
  ! temperature for model initialization as a function of depth.
  ! it is used to produce a reference thermal stratification for the
  ! upper 2000m of the OCEAN`s test case.  below 2000m, the
  ! potential temperature returned is 2.0 degrees C.  surface
  ! values are set slightly above 18.4 degrees C at the reference
  ! latitude "reflat".
  ! the estimates are produced from a 7th order ploynomial fit to
  ! the annual mean world ocean potential temperature observations
  ! of Levitus (1982).
  !
  ! input [units]:
  !
  !   a latitdue (ydeg): [degrees] <BR/>
  !   a zt value (depth): [meters] <BR/>
  !
  ! output [units]:
  !
  !   potential temperature estimate (est): [degrees centigrade]
  !
  ! variables:
  !
  !   coeft     = coefficients for the polynomial fit of potential
  !               temperature vs. depth
  !
  !   reflat    = reference latitude at which observed surface
  !               temperatures approximately equal coeft(1)
  !
  !   factor    = the ratio of the cosine of the latitude requested
  !               ("ydeg") to the reference latitude ("reflat")
  !               used to scale the upper 2000 meters of the vertical
  !               temperature profile
  !
  !   tmin,tmax = the minumum and maximum potential temperatures
  !               allowed at the time of model initialization
  !
  ! reference:
  !   Levitus, S., Climatological atlas of the world ocean, NOAA
  ! Prof. Paper 13, US Gov`t printing Office, Washington, DC, 1982.
  !
  ! Originally coded by Keith Dixon (Keith.Dixon)
  function theta0 (ydeg, depth)

    real, intent(in)   :: ydeg, depth
    integer, parameter :: ndeg=7
    real, save, dimension(ndeg+1) :: coeft = (/ 0.184231944E+02,-0.430306621E-01, 0.607121504E-04,-0.523806281E-07,&
                                                0.272989082E-10,-0.833224666E-14,0.136974583E-17,-0.935923382E-22 /)
    real, save :: tmin=2.0, tmax=25.0, reflat=34.0
    real       :: refcos, coslat, factor, z, est, bb, theta0, theta, t0, t1, h, z0
    integer    :: nn

    refcos = abs(cos(reflat/RADIAN))

    coslat = abs(cos(ydeg/RADIAN))
    factor = coslat/refcos

    if (depth > 2000.) then
       est = 2.0
    else
       est = 0.0
       bb = 1.0
       do nn=1,ndeg+1
          est = est + coeft(nn)*bb
          bb = bb*depth
       enddo
       est = est * factor
    endif

    if (est > tmax) est = tmax
    if (est < tmin) est = tmin

    theta0 = est

  end function theta0



  !#######################################################################
  ! This function returns ideal thermocline profile taken from 
  ! the appendix to Smith and Vallis (2001) JPO pages 554-571.  

  function ideal_thermocline(zdepth,zbottom)

    real, intent(in) :: zdepth
    real, intent(in) :: zbottom

    real :: ideal_thermocline
    real :: rho, delta_rho

    delta_rho = ideal_thermocline_alpha_eos*ideal_thermocline_deltaT

    rho = ideal_thermocline_rho0 &
    *(1.0 + (delta_rho/ideal_thermocline_rho0)*tanh(zdepth/zbottom/ideal_thermocline_scale_thick)**2) &
    *(1.0+ideal_thermocline_alpha*zdepth/zbottom) 
   
    ideal_thermocline = ideal_thermocline_offset + (ideal_thermocline_rho0-rho)/ideal_thermocline_alpha_eos

  
  end function ideal_thermocline
  !#######################################################################


  !#######################################################################
  ! This function returns initial and boundary conditions for DOME 
  ! as motivated by the work of Legg, Hallberg, and Girton (2006).
  ! It assumes a very coarse grid relative to the embayment size...
  ! e.g., four or less grid points within the embayment.  For this 
  ! case, we simply provide an exponential interface, with cold water
  ! beneath the interface with a southward velocity, and tagged with 
  ! salinity of one.  
  !
  ! For temperature, at the northern boundary of the embayment, we replace 
  ! a background temperature field with an inflow condition.
  ! 
  ! For salinity, it is given a value between zero and unity only on the
  ! northern boundary of the embayment, where the inflow water is 
  ! prescribed. 
  !
  ! For meridional velocity, there is a nonzero value only at the northern 
  ! row of the embayment with a specified profile. 
  ! 
  ! Picture at j=nj within the embayment:
  !
  !     ^            --------------------
  !     |            |                  |  ^
  !     |            |                  |  |
  !     |            |                  |  |dome_embayment_interface 
  !     |            |                  |  |
  !     |            |                  |  |
  !     |            |\    warm         |  v
  !     |            | \   reference    |  
  !     |            |  \               |
  !     |            |   \              |
  !dome_embayment_depth   \             |
  !     |            |     \<----exponential profile
  !     |            | cold \           |
  !     |            | inflow\          |
  !     |            |        \         |
  !     |            |         \        |
  !     |            |          \       |
  !     |            |           \      |
  !     |            |    X       \     |
  !     |            |             \    |
  !     v            |------------------|
  ! 
  !  A point in the inflow..X..has coordinates (inflow_x,inflow_z)
  !  with inflow_z the depth of the point, and inflow_x the distance
  !  from the western wall of the embayment. 
  ! 
  ! 


  function dome_conditions(xlon, ylat, zdepth, field_name)

    real,             intent(in) :: xlon
    real,             intent(in) :: ylat
    real,             intent(in) :: zdepth
    character(LEN=*), intent(in) :: field_name

    real :: dome_conditions
   
    real :: gprime   
    real :: deform 
    real :: vt_max 
    real :: interface_x 
    real :: interface_z 
    real :: inflow_x 
    real :: embayment_center 
    real :: tref
    real :: talpha
    real :: dtemp
    real :: temp_dome 
    real :: salinity_dome
    real :: vt_dome 

    ! values for reference background state 
    tref          = constant_temp_value - linear_theta_strat*zdepth
    temp_dome     = tref 
    salinity_dome = 0.0
    vt_dome       = 0.0

    ! compute properties at northern end of embayment 
    if(ylat  >=dome_embayment_north .and. &
       xlon  >=dome_embayment_west  .and. &
       xlon  <=dome_embayment_east) then 
!!$       xlon  <=dome_embayment_east  .and. &
!!$       zdepth<=dome_embayment_depth) then 

        ! reduced gravity between reference fluid and inflow fluid.
        ! assume reference fluid has density = rho0 
        gprime = dome_drho_inflow*rho0r*grav 

        ! maximum of inflow speed as determined by gprime and thickness of inflow
        vt_max = sqrt(gprime*dome_embayment_interface)

        ! deformation radius as determined by gprime, thickness of inflow, and coriolis 
        deform = vt_max/dome_embayment_coriolis

        ! distance in meters from the western wall of the embayment
        inflow_x = deg2metre*(xlon-dome_embayment_west)*cos(ylat)

        ! center of embayment 
        embayment_center =  dome_embayment_west + 0.5*(dome_embayment_east-dome_embayment_west) 
  
        ! depth of interface between reference and inflow water 
        interface_z = dome_embayment_interface + &
                      (dome_embayment_depth-dome_embayment_interface)*(1.0-exp(-inflow_x/deform))

        ! temperature difference between inflow (colder) and reference (warmer) 
        talpha = 2.0e-4
        dtemp  = dome_drho_inflow*rho0r/talpha

        ! values of the inflow along northern wall  
        if(zdepth >= interface_z .and. xlon <= embayment_center) then 
            temp_dome     = tref-dtemp
            salinity_dome = 1.0
            vt_dome       = -vt_max*exp(-inflow_x/deform)
        else 
            temp_dome     = tref  
            salinity_dome = 0.0
            vt_dome       = 0.0 
        endif

        if(dome_debug) then 
            write(*,*)' ' 
            write(*,'(a,f12.3,a,f12.3,a,f12.3,a)') &
                 ' in embayment with (x,y,z)     = (',xlon, ',', ylat, ',',zdepth,')' 
            write(*,'(a,f12.3,a,f12.3,a)') &
                 ' (inflow_x(km),interface_z(m)) = (',inflow_x/1000.0,',',interface_z,')'
            write(*,'(a,f12.3,a,f12.3,a,f12.3,a)') &
                 ' (temp,salinity,vt)            = (',temp_dome,',',salinity_dome,',',vt_dome,')'
        endif

    endif

    if(field_name==    'temp')     then 
       dome_conditions=temp_dome
    elseif(field_name=='salinity') then
       dome_conditions=salinity_dome
    elseif(field_name=='vt' )      then 
       dome_conditions=vt_dome
    endif     

  

  end function dome_conditions
  !#######################################################################





  !#######################################################################
  ! This function returns a salinity in psu
  function salt0 (depth)

    real, intent(in) :: depth
    real :: salt0

    salt0 = 32.0 + .001*depth 

  end function salt0
  !#######################################################################

end module idealized_ic_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: Diffusion schemes --- grid faces\label{sec:diffusionFace}
!
! !INTERFACE:
   subroutine diff_face(N,dt,cnpar,h,Bcup,Bcdw,Yup,Ydw,nuY,Lsour,Qsour,Y)
!
! !DESCRIPTION:
!
! !USES:
   use util,          only  : Dirichlet, Neumann
   use mtridiagonal

   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer,  intent(in)                :: N

!  time step (s)
   REALTYPE, intent(in)                :: dt

!  "implicitness" parameter
   REALTYPE, intent(in)                :: cnpar

!  layer thickness (m)
   REALTYPE, intent(in)                :: h(0:N)

!  type of upper BC
   integer,  intent(in)                :: Bcup

!  type of lower BC
   integer,  intent(in)                :: Bcdw

!  value of upper BC
   REALTYPE, intent(in)                :: Yup

!  value of lower BC
   REALTYPE, intent(in)                :: Ydw

!  diffusivity of Y
   REALTYPE, intent(in)                :: nuY(0:N)

!  linear source term
!  (treated implicitly)
   REALTYPE, intent(in)                :: Lsour(0:N)

!  constant source term
!  (treated explicitly)
   REALTYPE, intent(in)                :: Qsour(0:N)


! !INPUT/OUTPUT PARAMETERS:
   REALTYPE                            :: Y(0:N)
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: diff_face.F90,v $
!  Revision 20.0  2013/12/14 00:14:00  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:01:18  smg
!  initial cvs ci to mom5
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:33:41  smg
!  updated to gotm-2012.03.09 CVS tagged code.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.3  2005-11-03 20:56:55  hb
!  Source term linearisation now fully explicit again, reversion to old method
!
!  Revision 1.2  2005/09/16 13:54:02  lars
!  added missing IMPLICIT NONE
!
!  Revision 1.1  2005/06/27 10:54:33  kbk
!  new files needed
!
!
!EOP
!
! !LOCAL VARIABLES:
   integer                   :: i
   REALTYPE                  :: a,c,l
!
!-----------------------------------------------------------------------
!BOC
!
!  set up matrix
   do i=2,N-2
      c     = dt*( nuY(i+1) + nuY(i  ) )  / ( h(i)+h(i+1) ) / h(i+1)
      a     = dt*( nuY(i  ) + nuY(i-1) )  / ( h(i)+h(i+1) ) / h(i  )
      l     = dt*Lsour(i)

      cu(i) =-cnpar*c
      au(i) =-cnpar*a
      bu(i) =  _ONE_ + cnpar*(a + c) - l
      du(i) = (_ONE_ - (_ONE_-cnpar)*(a + c))*Y(i)                   &
            + (_ONE_ - cnpar)*( a*Y(i-1) + c*Y(i+1) ) + dt*Qsour(i)
   end do

!   set up upper boundary condition
   select case(Bcup)
   case(Neumann)
      a     = dt*( nuY(N-1) + nuY(N-2) )  / ( h(N-1)+h(N) ) / h(N-1)
      l     = dt*Lsour(N-1)

      au(N-1) =-cnpar*a
      bu(N-1) =  _ONE_ + cnpar*a - l
      du(N-1) = (_ONE_ - (_ONE_-cnpar)*a)*Y(N-1)                  &
              + (_ONE_ - cnpar)*a*Y(N-2) + dt*Qsour(N-1)                &
              + 2.0*dt*Yup/( h(N-1)+h(N) )
   case(Dirichlet)
      au(N-1) = _ZERO_
      bu(N-1) = _ONE_
      du(N-1) = Yup
   case default
      FATAL 'invalid boundary condition type for upper boundary'
      stop  'diff_face.F90'
   end select

!   set up lower boundary condition
   select case(Bcdw)
   case(Neumann)
      c     = dt*( nuY(2) + nuY(1) )  / ( h(1)+h(2) ) / h(2)
      l     = dt*Lsour(1)

      cu(1) =-cnpar*c
      bu(1) =  _ONE_ + cnpar*c - l
      du(1) = (_ONE_ - (_ONE_-cnpar)*c)*Y(1)                      &
            + (_ONE_ - cnpar)*c*Y(2)  + dt*Qsour(1)                     &
            + 2.0*dt*Ydw/( h(1)+h(2) )
   case(Dirichlet)
      bu(1) = _ONE_
      cu(1) = _ZERO_
      du(1) = Ydw
   case default
      FATAL 'invalid boundary condition type for lower boundary'
      stop  'diff_face.F90'
   end select


!  solve linear system
   call tridiagonal(N,1,N-1,Y)

   return
   end subroutine diff_face
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

                     module esfsw_driver_mod
!
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  smf
! </REVIEWER>
!
!
! <OVERVIEW>
!  Code that initializes and calculates shortwave radiative quantities
!  such as flux and heating rate.
! </OVERVIEW>
! <DESCRIPTION>
!  This code initializes the necessary shortwave radiative parameters
!  in the initialization subroutine. It then uses delta-eddington approximation
!  and doubling and adding technique to calculate solar flux and
!  heating rate.
! </DESCRIPTION>
!

!    shared modules:

use mpp_mod,              only:  input_nml_file
use fms_mod,              only:  open_namelist_file, fms_init, &
                                 mpp_pe, mpp_root_pe, stdlog, &
                                 file_exist, write_version_number, &
                                 check_nml_error, error_mesg, &
                                 FATAL, close_file
use constants_mod,        only:  PI, GRAV, radcon_mks, o2mixrat, &
                                 rhoair, pstd_mks, WTMAIR, &
                                 constants_init

!  shared radiation package modules:

use esfsw_parameters_mod, only:  Solar_spect, esfsw_parameters_init, &
                                 esfsw_parameters_end
use rad_utilities_mod,    only:  Rad_control, rad_utilities_init, &
                                 cldrad_properties_type, &
                                 cld_specification_type, &
                                 astronomy_type, &
                                 aerosol_diagnostics_type, &
                                 radiative_gases_type, &
                                 aerosol_type, aerosol_properties_type,&
                                 Cldrad_control, &
                                 atmos_input_type, surface_type, &
                                 sw_output_type, Sw_control
use tracer_manager_mod,   only : get_tracer_index,   &
                                 NO_TRACER
use field_manager_mod,    only : MODEL_ATMOS
!---------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!    esfsw_driver_mod is the internal driver for the esf shortwave
!    package.
!------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module -------------------

character(len=128)  :: version =  '$Id: esfsw_driver.F90,v 19.0 2012/01/06 20:15:51 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!---------------------------------------------------------------------
!-------  interfaces --------

public    &
         esfsw_driver_init, swresf,   &
         esfsw_driver_end

private     &

!   called from swresf:
         adding, deledd


!---------------------------------------------------------------------
!-------- namelist  ---------

 logical     ::  do_ica_calcs=.false.           ! do independent column
                                                ! calculations when sto-
                                                ! chastic clouds are
                                                ! active ?
logical      ::  do_rayleigh_all_bands = .true. ! rayleigh scattering 
                                                ! calculated in all sw 
                                                ! bands ?
logical      ::  do_herzberg = .false.          ! include the herzberg 
                                                ! effect on the o2 
                                                ! optical depth ?
logical      ::  do_quench = .false.            ! include the quenching
                                                ! effect of non-LTE 
                                                ! processes on the co2 
                                                ! optical depth ?
logical      ::  do_ch4_sw_effects = .false.    ! the shortwave effects
                                                ! of ch4 are included ?
logical      ::  do_n2o_sw_effects = .false.    ! the shortwave effects
                                                ! of n2o are included ?
logical      ::  do_coupled_stratozone = .false. ! include the coupled
                                                 ! stratospheric ozone effects?
  

namelist / esfsw_driver_nml /    &
                               do_ica_calcs, do_rayleigh_all_bands, &
                               do_herzberg, do_quench, &
                               do_ch4_sw_effects, do_n2o_sw_effects, &
                               do_coupled_stratozone

!---------------------------------------------------------------------
!------- public data ------


!---------------------------------------------------------------------
!------- private data ------


!---------------------------------------------------------------------
!    variables associated with absorptivity and sw transmission for
!    various gaseous atmospheric components
!
! powph2o      = the scaling factor used in the fit of the h2o          
!                transmission function                                  
!                                                                       
! p0h2o        = the reference pressure (mb) used in the fit of the     
!                h2o transmission function                              
!                                                                       
! c(n)co2(str) = coefficients for the absorptivity expression for co2   
!                for the pressure-scaled and non-scaled, respectively,  
!                portions of the fit (=1.0e-99 if no absorption)        
!                                                                       
! c(n)o2(str)  = coefficients for the absorptivity expression for o2    
!                for the pressure-scaled and non-scaled, respectively,  
!                portions of the fit (=1.0e-99 if no absorption)        
!                                                                       
! ""(schrun)   = coefficients for the absorptivity expression for the   
!                Schuman-Runge o2 band (non-scaled only)                
!                                                                       
! kh2o         =  the psuedo-absorption coefficients in cm2/gm for h2o  
!                                                                       
! ko3          = the absorption coefficients in cm2/gm for o3           
!                                                                       
! wtfreq       = the weight associated with each exponential term       
! strterm      = logical flag to indicate whether or not a h2o pseudo-  
!                absorption coefficient is assigned a non-scaled        
!                (true) or pressure-scaled (false) gas amount           
!---------------------------------------------------------------------
real, dimension (:), allocatable    :: c1co2, c1co2str, c1o2, c1o2str, &
                                       c2co2, c2co2str, c2o2, c2o2str, &
                                       c3co2, c3co2str, c3o2, c3o2str, &
                                       c4co2, c4co2str, c4o2, c4o2str, &
                                       c1ch4, c1ch4str, c2ch4,         &
                                       c2ch4str, c3ch4, c3ch4str,      &
                                       c4ch4, c4ch4str,                &
                                       c1n2o, c1n2ostr, c2n2o,         &
                                       c2n2ostr, c3n2o, c3n2ostr,      &
                                       c4n2o, c4n2ostr,                &
                                       powph2o, p0h2o
real                                :: c1o2strschrun, c2o2strschrun, &
                                       c3o2strschrun, c4o2strschrun
real, dimension (:), allocatable    :: kh2o, ko3, wtfreq
logical, dimension(:), allocatable  :: strterm

!---------------------------------------------------------------------
!    quantities associated with solar spectral parameterization
!                                                                       
! firstrayband = the first band number where the contribution by        
!                rayleigh scattering is included in the solar           
!                calculations                                           
!                                                                       
! nirbands     = the number of bands in the near-infrared (used in      
!                assigning the value of the surface albedo for the      
!                near-infrared, and the visible and ultraviolet         
!                regions, separately)                                   
! nfreqpts     = the number of pseudo-monochromatic frequencies         
! solflxband   = the solar flux in each parameterization band           
! solflxbandref = the solar flux in each parameterization band, used for
!                 defining band-averaged optical parameters. If the
!                 solar constant is time-invariant, it is also the solar
!                 flux in each parameterization band (solflxband).
! vis_wvnum    = the wavenumber of visible light (corresponds to
!                wavelength of 0.55 microns) [ cm **(-1) ]
!---------------------------------------------------------------------
real                                :: refquanray, solflxtotal
integer                             :: firstrayband, nirbands
integer, dimension (:), allocatable :: nfreqpts
real,    dimension(:), allocatable  :: solflxband
real,    dimension(:), allocatable  :: solflxbandref
real, dimension(:), allocatable     :: wtstr, cosangstr
real, dimension(4)                  :: wtstr_4 =      &
                                       (/0.347854845, 0.652145155,&
                                         0.347854845, 0.652145155/)

integer :: nbands, tot_wvnums, nfrqpts, nh2obands, nstreams
logical :: nstr4 = .false.
real    :: vis_wvnum = 1.0E+04/0.55
real    :: wvnum_870 = 1.0E+04/0.87
real    :: wvnum_340 = 1.0E+04/0.34
real    :: wvnum_380 = 1.0E+04/0.38
real    :: wvnum_440 = 1.0E+04/0.44
real    :: wvnum_670 = 1.0E+04/0.67
real    :: one_micron_wvnum = 1.0E+04/1.00
real    :: onepsix_micron_wvnum = 1.0E+04/1.61
integer :: onepsix_band_indx

!---------------------------------------------------------------------
!    variables associated with rayleigh scattering
!---------------------------------------------------------------------
real, dimension (:), allocatable    :: betaddensitymol

!----------------------------------------------------------------------
!    variables associated with total optical path of species ? - smf
!----------------------------------------------------------------------
real                            :: toto2strmaxschrun
real, dimension(:), allocatable :: totco2max, totco2strmax, &
                                   toto2max, toto2strmax, &
                                   totch4max, totch4strmax, &
                                   totn2omax, totn2ostrmax

!----------------------------------------------------------------------
!    variables associated with the herzberg effect. wtmo2 is the mol-
!    ecular weight of o2. herzberg_fac is a factor used in the last 
!    shortwave band, so that herzberg_fac*wo2 yields a correction for 
!    the o2 optical depth to account for the herzberg o2 heating. this 
!    is done only when do_herzberg is true.
!----------------------------------------------------------------------
real, parameter   :: wtmo2        = 3.19988E+01  
real, parameter   :: herzberg_fac = 9.9488377E-3

!----------------------------------------------------------------------
!    variables associated with the quenching effect. co2_quenchfac is a
!    multiplication factor that reduces the co2 gas optical depth, and 
!    hence, the solar heating in the upper atmosphere, to account for 
!    "quenching" due to non-LTE processes. co2_quenchfac_height is the 
!    reference height for co2_quenchfac [ meters ].
!----------------------------------------------------------------------
real, dimension(30) :: co2_quenchfac
data co2_quenchfac /1.0,.954,.909,.853,.800,.747,.693,.637,.583, .526,&
                    .467,.416,.368,.325,.285,.253,.229,.206,.186,.170,&
                    .163,.156,.151,.144,.138,.132,.127,.124,.068,.037/

real, dimension(30) :: co2_quenchfac_height
data co2_quenchfac_height /67304.,68310.,69303.,70288.,71267.,72245.,&
                           73221.,74195.,75169.,76141.,77112.,78082.,&
                           79051.,80018.,80985.,81950.,82914.,83876.,&
                           84838.,85798.,86757.,87715.,88672.,89627.,&
                           90582.,91535.,92487.,93438.,94387.,106747./



!---------------------------------------------------------------------
!    miscellaneous variables
!---------------------------------------------------------------------
integer, parameter :: NSOLWG = 1
real, dimension(NSOLWG) :: gausswt
logical        :: module_is_initialized = .false.
logical        :: do_esfsw_band_diagnostics = .false.
integer        :: naerosol_optical, naerosoltypes_used


!---------------------------------------------------------------------
!---------------------------------------------------------------------
 


                          contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!    
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
! <SUBROUTINE NAME="esfsw_driver_init">
!  <OVERVIEW>
!   Subroutine that defines the time-independent quantities associated
!   with the incoming shortwave radiation in the multiple-band solar
!   radiation parameterization.
!  </OVERVIEW>
!  <DESCRIPTION>
!   It first reads in the input namelist and then allocates gas absorption
!   coefficient variables. It then reads in the shortwave input namelist
!   file and assigns the gas absorption coefficients. Rayleigh scattering
!   coefficient is also calculated based on the temperature and pressure
!   structure of the atmosphere.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call esfsw_driver_init
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine esfsw_driver_init
 
!---------------------------------------------------------------------- 
!    esfsw_driver_init is the constructor for esfsw_driver_mod. it
!    defines the time-independent quantities associated with the 
!    incoming shortwave radiation in the multiple-band solar radiation 
!    parameterization.                                    
!---------------------------------------------------------------------- 

!---------------------------------------------------------------------
!  local variables:

      real,    dimension(Solar_spect%nbands)    :: freqnu
      real,    dimension(Solar_spect%nstreams)  :: ptstr 
      integer, dimension(0:Solar_spect%nbands) :: endwvnbands

      integer, dimension(:), allocatable  :: nwvnsolar
      real   , dimension(:), allocatable  :: solint   

      character(len=64)    :: file_name
      real, dimension(4)   :: ptstr_4 = (/-0.861136312,&
                                          -0.339981044, &
                                           0.861136312,  &
                                           0.339981044 /)
      real      :: ptstr_1 = 0.2
      real      :: temprefray  = 288.15
      real      :: pressrefray = 101325.       ! MKS units
      real      :: densmolref  = 2.54743E+19
      real      :: convfac     = 1.0E+18
      real      :: corrfac, gamma, f1, f2, f3, pinteg, &
                   twopiesq, densmolrefsqt3, wavelength,  &
                   freqsq, ristdm1, ri
      integer   :: iounit, nband, nf, ni, nw, nw1, nw2, nintsolar
      integer   :: unit, io, ierr, logunit
      integer   :: i
      integer   :: n
      real      :: input_flag = 1.0e-99

!---------------------------------------------------------------------
!  local variables:
!                                                                       
!      freqnu   
!      ptstr          gaussian points and weights for evaluation of the
!                     diffuse beam.
!      nwvnsolar      the number of wavenumbers in each region where the
!                     solar flux is constant                         
!      solint         the solar flux in watts per meter**2 in each      
!                     wavenumber region where it is constant    
!      endwvnbands    the wavenumber value for the band limits   
!      file_name
!      ptstr_4    
!      ptstr_1     
!      temprefray     reference temperature used in defining rayleigh
!                     optical depth
!      pressrefray    reference pressure used in defining rayleigh
!                     optical depth [ Pa ]
!      densmolref     reference density used in defining rayleigh
!                     optical depth
!      convfac     
!      corrfac
!      gamma
!      f1
!      f2
!      f3
!      pinteg
!      twopiesq
!      densmolrefsqt3
!      wavelength
!      freqsq
!      ristdm1
!      ri
!      iounit
!      nband
!      nf
!      ni
!      nw
!      nw1
!      nw2
!      nintsolar      the number of wavenumber regions where the  
!                     solar flux is constant.   
!      unit
!      io
!      ierr
!      i
!                                                                       
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return
 
!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call constants_init
      call rad_utilities_init
      call esfsw_parameters_init

!-----------------------------------------------------------------------
!    read namelist.
!-----------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
       read (input_nml_file, nml=esfsw_driver_nml, iostat=io)
       ierr = check_nml_error(io,'esfsw_driver_nml')
#else   
       if ( file_exist('input.nml')) then
         unit =  open_namelist_file ( )
         ierr=1; do while (ierr /= 0)
         read  (unit, nml=esfsw_driver_nml, iostat=io, end=10)
         ierr = check_nml_error(io,'esfsw_driver_nml')
         end do
10      call close_file (unit)
      endif
#endif
 
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
       call write_version_number(version, tagname)
       logunit = stdlog()
       if (mpp_pe() == mpp_root_pe() ) &
                          write (logunit, nml=esfsw_driver_nml)

!---------------------------------------------------------------------
!    define flag indicating if ICA calculations being done.
!---------------------------------------------------------------------
      Cldrad_control%do_ica_calcs = do_ica_calcs
      Cldrad_control%do_ica_calcs_iz = .true.

!---------------------------------------------------------------------
!    allocate module variables
!---------------------------------------------------------------------
      nbands = Solar_spect%nbands       
      tot_wvnums = Solar_spect%tot_wvnums
      nfrqpts = Solar_spect%nfrqpts
      nstreams = Solar_spect%nstreams
      nh2obands = Solar_spect%nh2obands
      allocate ( betaddensitymol (nbands) )
      allocate ( c1co2   (nh2obands),  &
                 c1co2str(nh2obands),  &
                 c1o2    (nh2obands),  &
                 c1o2str (nh2obands),  &
                 c2co2   (nh2obands),  &
                 c2co2str(nh2obands),  &
                 c2o2    (nh2obands),  &
                 c2o2str (nh2obands),  &
                 c3co2   (nh2obands),  &
                 c3co2str(nh2obands),  &
                 c3o2    (nh2obands),  &
                 c3o2str (nh2obands),  &
                 c4co2   (nh2obands),  &
                 c4co2str(nh2obands),  &
                 c4o2    (nh2obands),  &
                 c4o2str (nh2obands),  &
                 c1ch4   (nh2obands),  &
                 c1ch4str(nh2obands),  &
                 c2ch4   (nh2obands),  &
                 c2ch4str(nh2obands),  &
                 c3ch4   (nh2obands),  &
                 c3ch4str(nh2obands),  &
                 c4ch4   (nh2obands),  &
                 c4ch4str(nh2obands),  &
                 c1n2o   (nh2obands),  &
                 c1n2ostr(nh2obands),  &
                 c2n2o   (nh2obands),  &
                 c2n2ostr(nh2obands),  &
                 c3n2o   (nh2obands),  &
                 c3n2ostr(nh2obands),  &
                 c4n2o   (nh2obands),  &
                 c4n2ostr(nh2obands),  &
                 powph2o (nh2obands),  &
                 p0h2o   (nh2obands)    )
      allocate ( nfreqpts        (nbands) )
      allocate ( solflxband      (nbands) )
      allocate ( solflxbandref   (nbands) )
      allocate ( kh2o            (nfrqpts),   & 
                 ko3             (nfrqpts),   &
                 wtfreq          (nfrqpts),   &
                 strterm         (nfrqpts)   )
      allocate ( wtstr           (nstreams),   & 
                 cosangstr       (nstreams)  )
      allocate ( totco2max    (nh2obands),     &
                 totco2strmax (nh2obands),     &
                 toto2max     (nh2obands),     &
                 toto2strmax  (nh2obands),   &
                 totch4max    (nh2obands),   &
                 totch4strmax (nh2obands),   &
                 totn2omax    (nh2obands),   &
                 totn2ostrmax (nh2obands)    )

      betaddensitymol = 0.0 ; c1co2    = 0.0 ; c1co2str = 0.0
      c1o2     = 0.0 ; c1o2str  = 0.0 ; c2co2    = 0.0
      c2co2str = 0.0 ; c2o2     = 0.0 ; c2o2str  = 0.0
      c3co2    = 0.0 ; c3co2str = 0.0 ; c3o2     = 0.0
      c3o2str  = 0.0 ; c4co2    = 0.0 ; c4co2str = 0.0
      c4o2     = 0.0 ; c4o2str  = 0.0 ; powph2o  = 0.0
      p0h2o    = 0.0 ; nfreqpts        = 0.0 ; solflxband      = 0.0
      solflxbandref   = 0.0 ; kh2o            = 0.0 ; ko3             = 0.0
      wtfreq          = 0.0 ; strterm     = .FALSE. ; wtstr           = 0.0
      cosangstr       = 0.0 ; totco2max     = 0.0 ; totco2strmax  = 0.0
      toto2max      = 0.0 ; toto2strmax   = 0.0
      c1ch4    = 0.0 ; c1ch4str = 0.0; c2ch4    = 0.0
      c2ch4str = 0.0 ; c3ch4    = 0.0 ; c3ch4str = 0.0
      c4ch4    = 0.0 ; c4ch4str = 0.0
      totch4max     = 0.0 ; totch4strmax  = 0.0
      c1n2o    = 0.0 ; c1n2ostr = 0.0; c2n2o    = 0.0
      c2n2ostr = 0.0 ; c3n2o    = 0.0 ; c3n2ostr = 0.0
      c4n2o    = 0.0 ; c4n2ostr = 0.0
      totn2omax     = 0.0 ; totn2ostrmax  = 0.0

!---------------------------------------------------------------------
!    allocate local variables.
!---------------------------------------------------------------------
      if (nstreams == 4) then
        ptstr(:) = ptstr_4(:)
        wtstr(:) = wtstr_4(:)
        nstr4 = .true.
      else if (nstreams == 1) then
        ptstr(1) = ptstr_1
        wtstr(1) = 1.0
        nstr4 = .false.
      endif

!---------------------------------------------------------------------
!    read input file for band positions, solar fluxes and band
!    strengths.
!---------------------------------------------------------------------
      if (nbands == 25 .and. nfrqpts == 72) then 
        file_name = 'INPUT/esf_sw_input_data_n72b25'
      else if (nbands == 18 .and. nfrqpts == 38) then
        file_name = 'INPUT/esf_sw_input_data_n38b18'
      else
        call error_mesg ( 'esfsw_driver_mod', &
          'input file for desired bands and frqs is not available', &
                                                               FATAL)
      endif
      iounit = open_namelist_file (file_name)
      read(iounit,101) ( solflxbandref(nband), nband=1,NBANDS )
      read(iounit,102) ( nfreqpts(nband), nband=1,NBANDS )
      read(iounit,103) ( endwvnbands(nband), nband=1,NBANDS )
      read(iounit,103) FIRSTRAYBAND,NIRBANDS
      read(iounit,104) ( powph2o(nband), nband=1,NH2OBANDS )
      read(iounit,104) ( p0h2o(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c1co2(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c1co2str(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c2co2(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c2co2str(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c3co2(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c3co2str(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c1o2(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c1o2str(nband), nband=1,NH2OBANDS ),  &
                         c1o2strschrun
      read(iounit,105) ( c2o2(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c2o2str(nband), nband=1,NH2OBANDS ), &
                         c2o2strschrun
      read(iounit,105) ( c3o2(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c3o2str(nband), nband=1,NH2OBANDS ),  &
                         c3o2strschrun
      read(iounit,105) ( c1ch4(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c1ch4str(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c2ch4(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c2ch4str(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c3ch4(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c3ch4str(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c1n2o(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c1n2ostr(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c2n2o(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c2n2ostr(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c3n2o(nband), nband=1,NH2OBANDS )
      read(iounit,105) ( c3n2ostr(nband), nband=1,NH2OBANDS )
      do nf = 1,nfrqpts
        read(iounit,106) wtfreq(nf),kh2o(nf),ko3(nf),strterm (nf)
      end do

      read(iounit,107) nintsolar

      allocate ( nwvnsolar (nintsolar) )
      allocate ( solint    (nintsolar) )
 
      do ni = 1,nintsolar
        read(iounit,107) nwvnsolar (ni),solint(ni)
      end do
 
      call close_file (iounit)
 
      if (Solar_spect%tot_wvnums /=       &
                                 endwvnbands(Solar_spect%nbands)) then
        call error_mesg ( 'esfsw_driver_mod', &
         ' inconsistency between highest solar spectrum wavenumber '//&
          'in esfsw_parameters_mod and in esfsw_sriver input file', &
                                                           FATAL)
      endif

!---------------------------------------------------------------------
!    define the band index corresponding to near ultraviolet light
!    (0.34 microns). note that endwvnbands is in units of (cm**-1).
!---------------------------------------------------------------------
      do ni=1,nbands
        if (endwvnbands(ni) > wvnum_340) then
          Solar_spect%w340_band_indx = ni
          Solar_spect%w340_band_iz = .true.
          exit
        endif
      end do
!---------------------------------------------------------------------
!    define the band index corresponding to near ultraviolet light
!    (0.38 microns). note that endwvnbands is in units of (cm**-1).
!---------------------------------------------------------------------
      do ni=1,nbands
        if (endwvnbands(ni) > wvnum_380) then
          Solar_spect%w380_band_indx = ni
          Solar_spect%w380_band_iz = .true.
          exit
        endif
      end do
!---------------------------------------------------------------------
!    define the band index corresponding to blue light
!    (0.44 microns). note that endwvnbands is in units of (cm**-1).
!---------------------------------------------------------------------
      do ni=1,nbands
        if (endwvnbands(ni) > wvnum_440) then
          Solar_spect%w440_band_indx = ni
          Solar_spect%w440_band_iz = .true.
          exit
        endif
      end do
!---------------------------------------------------------------------
!    define the band index corresponding to red light
!    (0.67 microns). note that endwvnbands is in units of (cm**-1).
!---------------------------------------------------------------------
      do ni=1,nbands
        if (endwvnbands(ni) > wvnum_670) then
          Solar_spect%w670_band_indx = ni
          Solar_spect%w670_band_iz = .true.
          exit
        endif
      end do
!---------------------------------------------------------------------
!    define the band index corresponding to visible light
!    (0.55 microns). note that endwvnbands is in units of (cm**-1).
!---------------------------------------------------------------------
      do ni=1,nbands
        if (endwvnbands(ni) > vis_wvnum) then
          Solar_spect%visible_band_indx = ni
          Solar_spect%visible_band_indx_iz = .true.
          exit
        endif
      end do

!---------------------------------------------------------------------
!    define the band index corresponding to 870nm
!    (0.87 microns). note that endwvnbands is in units of (cm**-1).
!---------------------------------------------------------------------
      do ni=1,nbands
        if (endwvnbands(ni) > wvnum_870) then
          Solar_spect%eight70_band_indx = ni
          Solar_spect%eight70_band_indx_iz = .true.
          exit
        endif
      end do

!---------------------------------------------------------------------
!    define the band index corresponding to near infra red band
!    (1.00 microns). note that endwvnbands is in units of (cm**-1).
!---------------------------------------------------------------------
      do ni=1,nbands
        if (endwvnbands(ni) > one_micron_wvnum) then
          Solar_spect%one_micron_indx = ni
          Solar_spect%one_micron_indx_iz = .true.
          exit
        endif
      end do
 
!---------------------------------------------------------------------
!    define the band index corresponding to               
!    (1.61 microns). note that endwvnbands is in units of (cm**-1).
!---------------------------------------------------------------------
      do ni=1,nbands
        if (endwvnbands(ni) > onepsix_micron_wvnum) then
          onepsix_band_indx = ni
          exit
        endif
      end do

!--------------------------------------------------------------------
!    define the wavenumber one solar fluxes.                       
!----------------------------------------------------------------- --
      do ni = 1,nintsolar
        if ( ni.eq.1 ) then
          nw1 = 1
        else
          nw1 = nw1 + nwvnsolar(ni-1)
        end if
        nw2 = nw1 + nwvnsolar(ni) - 1
        do nw = nw1,nw2
          Solar_spect%solarfluxtoa(nw) = solint(ni)
        end do
      end do

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      deallocate  (solint    )
      deallocate  (nwvnsolar )
 
!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      if ( .not. Rad_control%using_solar_timeseries_data) then
        Solar_spect%solflxband = solflxbandref
      endif
      Solar_spect%solflxbandref = solflxbandref
      Solar_spect%endwvnbands = endwvnbands

!--------------------------------------------------------------------
!    override the input file value of firstrayband if the nml control
!    variables indicates rayleigh effects are to be considered in
!    all bands.
!--------------------------------------------------------------------
      if (do_rayleigh_all_bands)  firstrayband = 1

!----------------------------------------------------------------------
!    convert some values to mks to match model units
!--------------------------------------------------------------------
      p0h2o = 1.0E-2/p0h2o  ! invert, and convert mb to mks
      kh2o = kh2o *1.0E-01   ! cgs to mks
      ko3  = ko3 *1.0E-01    ! cgs to mks

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      do n=1,NH2OBANDS
        if (c1co2(n) /= input_flag .and.  &
            c2co2(n) /= input_flag .and.  &
            c3co2(n) /= input_flag ) then
          c4co2(n) = c1co2(n) * c2co2(n) ** c3co2(n)
          c4co2str(n) = c1co2str(n) * c2co2str(n) ** c3co2str(n)
          totco2max(n) = ( (1.0/c1co2(n) ) + c2co2(n) ** c3co2(n) ) ** &
                       (1.0/c3co2(n) ) - c2co2(n)
          if (nbands == 18) then
            if ( n /= 4) then
              totco2strmax(n) = ( (1.0/c1co2str(n) ) + c2co2str(n) ** &
                                 c3co2str(n) ) ** (1.0/c3co2str(n) ) - &
                                c2co2str(n)
            else 
              totco2strmax(n) = HUGE (c4o2strschrun) 
            endif
          else
              totco2strmax(n) = ( (1.0/c1co2str(n) ) + c2co2str(n) ** &
                                 c3co2str(n) ) ** (1.0/c3co2str(n) ) - &
                                c2co2str(n)
          endif
        else
          c4co2(n) = 0.0                              
          c4co2str(n) = 0.0
          totco2max(n) = 0.0                                            
          totco2strmax(n) = 0.0
        endif
        if (c1o2(n) /= input_flag .and.   &
            c2o2(n) /= input_flag .and.   &
            c3o2(n) /= input_flag ) then
          c4o2(n) = c1o2(n) * c2o2(n) ** c3o2(n)
          c4o2str(n) = c1o2str(n) * c2o2str(n) ** c3o2str(n)
          toto2max(n) = ( (1.0/c1o2(n) ) + c2o2(n) ** c3o2(n) ) ** &
                          (1.0/c3o2(n) ) - c2o2(n)
          if (nbands == 18) then
            if ( n /= 4) then
              toto2strmax(n) = ( (1.0/c1o2str(n) ) + c2o2str(n) ** &
                                c3o2str(n) ) ** (1.0/c3o2str(n) ) - &
                                c2o2str(n)
            else
              toto2strmax(n) = HUGE (c4o2strschrun) 
            endif
          else
              toto2strmax(n) = ( (1.0/c1o2str(n) ) + c2o2str(n) ** &
                                c3o2str(n) ) ** (1.0/c3o2str(n) ) - &
                                c2o2str(n)
          endif
        else
          c4o2(n) = 0.0                              
          c4o2str(n) = 0.0
          toto2max(n) = 0.0                                            
          toto2strmax(n) = 0.0
        endif
    if (do_ch4_sw_effects) then
        if (c1ch4(n) /= input_flag .and.  &
            c2ch4(n) /= input_flag .and.  &
            c3ch4(n) /= input_flag ) then
          c4ch4(n) = c1ch4(n) * c2ch4(n) ** c3ch4(n)
          c4ch4str(n) = c1ch4str(n) * c2ch4str(n) ** c3ch4str(n)
          totch4max(n) = ( (1.0/c1ch4(n) ) + c2ch4(n) ** c3ch4(n) ) ** &
                           (1.0/c3ch4(n) ) - c2ch4(n)
          totch4strmax(n) = ( (1.0/c1ch4str(n) ) + c2ch4str(n) ** &
                            c3ch4str(n) ) ** (1.0/c3ch4str(n) ) - &
                            c2ch4str(n)
        else
          c4ch4(n) = 0.
          c4ch4str(n) = 0.
          totch4max(n) = 0.
          totch4strmax(n) = 0.     
        endif
     endif
     if (do_n2o_sw_effects) then
        if (c1n2o(n) /= input_flag .and.  &
            c2n2o(n) /= input_flag .and.  &
            c3n2o(n) /= input_flag ) then
          c4n2o(n) = c1n2o(n) * c2n2o(n) ** c3n2o(n)
          c4n2ostr(n) = c1n2ostr(n) * c2n2ostr(n) ** c3n2ostr(n)
          totn2omax(n) = ( (1.0/c1n2o(n) ) + c2n2o(n) ** c3n2o(n) ) ** &
                           (1.0/c3n2o(n) ) - c2n2o(n)
          totn2ostrmax(n) = ( (1.0/c1n2ostr(n) ) + c2n2ostr(n) ** &
                               c3n2ostr(n) ) ** (1.0/c3n2ostr(n) ) - &
                               c2n2ostr(n)
        else
          c4n2o(n) = 0.
          c4n2ostr(n) = 0.
          totn2omax(n) = 0.
          totn2ostrmax(n) = 0.     
        endif
     endif
      end do

      c4o2strschrun = c1o2strschrun * c2o2strschrun ** c3o2strschrun
      toto2strmaxschrun = ( (1.0/c1o2strschrun) + c2o2strschrun ** &
                             c3o2strschrun) ** (1.0/c3o2strschrun) - &
                             c2o2strschrun

!     if (mpp_pe() == 0) then
!       print *, 'c1ch4    ', c1ch4    
!       print *, 'c2ch4    ', c2ch4    
!       print *, 'c3ch4    ', c3ch4    
!       print *, 'c4ch4    ', c4ch4    
!       print *, 'totch4max', totch4max
!       print *, 'c1ch4str ', c1ch4str    
!       print *, 'c2ch4str ', c2ch4str    
!       print *, 'c3ch4str ', c3ch4str    
!       print *, 'c4ch4str ', c4ch4str    
!       print *, 'totch4strmax', totch4strmax
!       print *, 'c1co2    ', c1co2    
!       print *, 'c2ch4    ', c2co2    
!       print *, 'c3ch4    ', c3co2    
!       print *, 'c4ch4    ', c4co2    
!       print *, 'totch4max', totco2max
!       print *, 'c1ch4str ', c1co2str    
!       print *, 'c2ch4str ', c2co2str    
!       print *, 'c3ch4str ', c3co2str    
!       print *, 'c4ch4str ', c4co2str    
!       print *, 'totch4strmax', totco2strmax
!       print *, 'c1n2o    ', c1n2o    
!       print *, 'c2ch4    ', c2n2o    
!       print *, 'c3ch4    ', c3n2o    
!       print *, 'c4ch4    ', c4n2o    
!       print *, 'totch4max', totn2omax
!       print *, 'c1ch4str ', c1n2ostr    
!       print *, 'c2ch4str ', c2n2ostr    
!       print *, 'c3ch4str ', c3n2ostr    
!       print *, 'c4ch4str ', c4n2ostr    
!       print *, 'totch4strmax', totn2ostrmax
!       print *, '1/c1', 1.0/c1co2str
!       print *, '1/c3', 1.0/c3co2str
!       print *, 'c2**c3', c2co2str**c3co2str
!       print *, '(1 / + c2**c3)**1/c3',  &
!                 (1.0/c1co2str + c2co2str**c3co2str)**(1./c3co2str)
!       print *, 'c4o2    ', c4o2    
!       print *, 'c4o2str    ', c4o2str    
!       print *, 'toto2max', toto2max
!       print *, 'toto2strmax', toto2strmax
!     endif

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      if ( .not. Rad_control%using_solar_timeseries_data) then
      solflxtotal = 0.0
      do nband = 1,NBANDS
        solflxtotal = solflxtotal + Solar_spect%solflxbandref(nband)
      end do
      endif
 
!----------------------------------------------------------------------
!    define the wavenumbers to evaluate rayleigh optical depth.      
!-------------------------------------------------------------------
      endwvnbands(0) = 0
      do nband = 1,NBANDS
        freqnu(nband) = 0.5 * ( endwvnbands(nband-1) +   &
                                endwvnbands(nband) )
      end do
 
!---------------------------------------------------------------------
!    define quantities used to determine the rayleigh optical depth. 
!    notes: refquanray is the quantity which multiplies pressure /  
!           temperature to yield the molecular density.                 
!           betaddensitymol is the quantity which multiples the       
!           molecular density to yield the rayleigh scattering      
!           coefficient.                                           
!           1.39E-02 is the depolorization factor.              
!-----------------------------------------------------------------
      refquanray = densmolref * temprefray / pressrefray 
      corrfac = ( 6.0E+00 + 3.0E+00 * 1.39E-02 )/( 6.0E+00 - 7.0E+00 * &
                  1.39E-02 )
      gamma = 1.39E-02 / ( 2.0E+00 - 1.39E-02 )
      f1 = 7.5E-01 / ( gamma * 2.0E+00 + 1.0E+00 )
      f2 = gamma * 3.0E+00 + 1.0E+00 
      f3 = 1.0E+00 - gamma 
      pinteg = 2.0E+00 * PI * ( 2.0E+00 * f1 * f2 * ( 1.0E+00 + f3 / &
               f2 / 3.0E+00 ) )
      twopiesq = 2.0E+00 *  PI ** 2
      densmolrefsqt3 = 3.0E+00 * densmolref ** 2
 
!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      do nband = 1,NBANDS
        wavelength = 1.0E+04 / freqnu(nband)
        freqsq = 1.0 / ( wavelength ) ** 2
        ristdm1 = ( 6.4328E+03 + 2.94981E+06 / ( 1.46E+02 - freqsq ) + &
                    2.554E+04 / ( 4.1E+01 - freqsq ) ) * 1.0E-08
        ri = ristdm1 + 1
        betaddensitymol(nband) = twopiesq*( ri ** 2 - 1.0E+00 ) ** 2 * &
                                 corrfac / ( densmolrefsqt3 *  &
                                 wavelength ** 4 ) * pinteg * convfac 
      end do
 
      gausswt(1) = 1.0

!---------------------------------------------------------------------
!    define the gaussian angles for evaluation of the diffuse beam.  
!--------------------------------------------------------------------
      do i = 1,nstreams
        cosangstr(i) = ( ptstr(i) + 1. ) * 5.0E-01
      end do

!--------------------------------------------------------------------
!    mark the module as initialized.
!--------------------------------------------------------------------
      module_is_initialized = .true.

!--------------------------------------------------------------------
 101  format( 12f10.4 )
 102  format( 32i4 )
 103  format( 20i6 )
 104  format( 12f10.2 )
 105  format( 1p,16e8.1 )
 106  format( 1p,3e16.6,l16 )
 107  format( i5,1p,e14.5 )
 
!---------------------------------------------------------------------


end subroutine esfsw_driver_init 



!#################################################################
! <SUBROUTINE NAME="swresf">
!  <OVERVIEW>
!   Subroutine that uses the delta-eddington technique in conjunction
!   with a multi-band parameterization for h2o+co2+o2+o3 absorption
!   in the solar spectrum to derive solar fluxes and heating rates.
!  </OVERVIEW>
!  <DESCRIPTION>
!    This subroutine calculates optical depth, single scattering albedo,
!    asymmetry parameter of a layer based on gaseous absorbers,
!    clouds, aerosols, and rayleigh scattering. It then uses delta-
!    eddington technique to calculate radiative flux at each layer. 
!    Doubling and adding technique is used to combine the layers
!    and calculate flux at TOA and surface and heating rate. This
!    subroutine allocates a substantial amount of memory and deallocates
!    the allocated memory at the end of the subroutine.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call swresf(is, ie, js, je, Atmos_input, Surface, Rad_gases, Aerosol, 
!               Astro, &
!               Cldrad_props, Cld_spec, Sw_output)
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!    starting subdomain i indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="ie" TYPE="integer">
!    ending subdomain i indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="js" TYPE="integer">
!    starting subdomain j indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="je" TYPE="integer">
!    ending subdomain j indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
!    Atmos_input_type variable containing the atmospheric
!    input fields on the radiation grid 
!  </IN>
!  <IN NAME="Aerosol" TYPE="aerosol_type">
!   Aerosol input data for shortwave radiation calculation
!  </IN>
!  <IN NAME="Astro" TYPE="astronomy_type">
!    Astronomy_type variable containing the astronomical
!    input fields on the radiation grid  
!  </IN>
!  <IN NAME="Rad_gases" TYPE="radiative_gases_type">
!    Radiative_gases_type variable containing the radiative 
!    gas input fields on the radiation grid 
!  </IN>
!  <IN NAME="Cldrad_props" TYPE="cldrad_properties_type">
!    The cloud radiative property input fields on the
!    radiation grid
!  </IN>
!  <INOUT NAME="Sw_output" TYPE="sw_output_type">
!    The shortwave radiation calculation result
!  </INOUT>
!  <IN NAME="Surface" TYPE="surface_type">
!   Surface data as boundary condition to radiation
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!   Cloud specification data as initial condition to radiation
!  </IN>
! </SUBROUTINE>

subroutine swresf (is, ie, js, je, Atmos_input, Surface, Rad_gases,  &
                   Aerosol, Aerosol_props, Astro, Cldrad_props,  &
                   Cld_spec, including_volcanoes, Sw_output,   &
                   Aerosol_diags, r, including_aerosols,   &
                   naerosol_optical) 

!----------------------------------------------------------------------
!    swresf uses the delta-eddington technique in conjunction with a    
!    multiple-band parameterization for h2o+co2+o2+o3 absorption to   
!    derive solar fluxes and heating rates.                             
!    notes: drops are assumed if temp>273.15K, ice crystals otherwise.
!-------------------------------------------------------------------

integer,                       intent(in)    :: is, ie, js, je
type(atmos_input_type),        intent(in)    :: Atmos_input
type(surface_type),            intent(in)    :: Surface
type(radiative_gases_type),    intent(in)    :: Rad_gases   
type(aerosol_type),            intent(in)    :: Aerosol     
type(aerosol_properties_type), intent(in)    :: Aerosol_props
type(astronomy_type),          intent(in)    :: Astro
type(cldrad_properties_type),  intent(in)    :: Cldrad_props
type(cld_specification_type),  intent(in)    :: Cld_spec      
logical,                       intent(in)    :: including_volcanoes
type(sw_output_type),          intent(inout) :: Sw_output   
type(aerosol_diagnostics_type),intent(inout) :: Aerosol_diags
real,dimension(:,:,:,:),       intent(inout) :: r
logical,                       intent(in)    :: including_aerosols  
integer,                       intent(in)    :: naerosol_optical


!-------------------------------------------------------------------
!  intent(in) variables:
!
!    is,ie,js,je    starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      Atmos_input    atmos_input_type structure, contains variables
!                     defining atmospheric state
!      Surface        surface_type structure, contains variables 
!                     defining the surface characteristics
!      Rad_gases      radiative_gases_type structure, contains var-
!                     iables defining the radiatively active gases, 
!                     passed through to lower level routines
!      Aerosol        aerosol_type structure, contains variables
!                     defining aerosol fields, passed through to
!                     lower level routines
!      Aerosol_props  aerosol radiative property input data for the 
!                     radiation package
!      Astro          astronomy_type structure
!      Cldrad_props   cloud radiative property input data for the 
!                     radiation package
!      Cld_spec       cld_specification_type structure, contains var-
!                     iables defining the cloud distribution, passed 
!                     through to lower level routines
!                                                                 
!   intent(inout) variables:
!
!      Sw_output         shortwave radiation output data
!
!---------------------------------------------------------------------

!-----------------------------------------------------------------------
!     local variables:
 

      logical, dimension (size(Atmos_input%temp,1), &
                          size(Atmos_input%temp,2), &
                          size(Atmos_input%temp,3)-1)  :: &
                             cloud

      logical, dimension (size(Atmos_input%temp,1), &
                          size(Atmos_input%temp,2))  ::   &
                              cloud_in_column,   daylight

      real, dimension (size(Atmos_input%temp,1), &
                       size(Atmos_input%temp,2), &
                       size(Atmos_input%temp,3)-1, &
                        Solar_spect%nbands)  :: &
            aeroasymfac,     aerosctopdep,   aeroextopdep, &
            rayopdep

      real, dimension (size(Atmos_input%temp,1), &
                       size(Atmos_input%temp,2), &
                       size(Atmos_input%temp,3)-1, &
                       nfrqpts,NSOLWG)  ::     &
                                                    gasopdep

      real, dimension (size(Atmos_input%temp,1), &
                       size(Atmos_input%temp,2), &
                       size(Atmos_input%temp,3)-1)  :: &
            cloudfrac,      cldfrac_band,    cldfrac,         &
            deltaz,         cloud_deltaz,                     &
            cldext,         cldsct,          cldasymm,         &
            cloudasymfac,   cloudextopdep,                     &
            cloudsctopdep,                   deltap,           &
            densitymol,     extopdepclr,                       &
            extopdepovc,    fclr,            fovc,             &
            gocpdp,         gclr,            gstrclr,          &
            gstrovc,        govc,            omegastrclr,      &
            omegastrovc,    rlayerdif,       rlayerdir,        &
            rlayerdifclr,   rlayerdifovc,    &
            rlayerdirclr,   rlayerdirovc,                     &
            sctopdepclr,    sctopdepovc,      &
            ssalbclr,        ssalbovc,                         &
            taustrclr,      taustrovc,        &
            tlayerde,       tlayerdeclr,      &
            tlayerdeovc,    tlayerdif,                        &
            tlayerdifclr,   tlayerdifovc,     &
            tlayerdir,      tlayerdirclr,     &
            tlayerdirovc
           
      real, dimension (size(Atmos_input%temp,1), &
                       size(Atmos_input%temp,2), &
                       size(Atmos_input%temp,3))  :: &
              reflectance,  transmittance,  tr_dir            

      real, dimension (size(Atmos_input%temp,1), &
                       size(Atmos_input%temp,2), &
                       size(Atmos_input%temp,3), &
                       Rad_control%nzens)  :: &
            dfswbandclr,     fswbandclr,    ufswbandclr, &
            dfswband,        fswband,       ufswband,  &
            sumtrclr,        sumreclr,      sumtr_dir_clr,  & 
            sumtr,           sumre,         sumtr_dir

      real, dimension (size(Atmos_input%temp,1), &
                       size(Atmos_input%temp,2), &
                       Rad_control%nzens)  :: sumtr_dir_up

      real, dimension (size(Atmos_input%temp,1), &
                       size(Atmos_input%temp,2), &
                       size(Atmos_input%temp,3))  :: &
            press,           pflux,            pflux_mks, &
            temp,                                       &
            reflectanceclr,  transmittanceclr, tr_dirclr

      real, dimension (size(Atmos_input%temp,1), &
                       size(Atmos_input%temp,2), &
                       size(Atmos_input%temp,3)-1 , &
                       Rad_control%nzens)  :: &
                hswbandclr,  hswband

      real, dimension (size(Atmos_input%temp,1), &
                       size(Atmos_input%temp,2))    ::  &
            sfcalb_dir,   sfcalb_dif,  wtfac_p,    &
            fracday_p,    solarflux_p

      real, dimension (size(Atmos_input%press,1),    &
                       size(Atmos_input%press,2),   &
                                         NSOLWG) ::         &
                 cosangsolar_p

      integer :: j, i, k, ng, np, nband, nf, ns, nz
      integer :: nzens

      integer :: nprofile, nprofiles
      real    :: profiles_inverse

      integer :: ix, jx, kx, israd, jsrad, ierad, jerad, ksrad, kerad
      real    :: ssolar  
      real    :: solflxtotal_local




!-----------------------------------------------------------------------
!     local variables:
!
!       aeramt
!       sum_g_omega_tau
!       opt_index_v3
!       irh
!    etc.
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('esfsw_driver_mod',   &
              'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!    define the solar_constant appropriate at Rad_time when solar
!    input is varying with time.
!---------------------------------------------------------------------
!-- The following fix is for openmp
      if (Rad_control%using_solar_timeseries_data) then
        solflxtotal_local = 0.0
        do nband = 1,NBANDS
          solflxtotal_local = solflxtotal_local + Solar_spect%solflxband(nband)
        end do
      else
        solflxtotal_local = solflxtotal
      endif

!---------------------------------------------------------------------
!
      
      cldfrac = Cld_spec%camtsw

!---------------------------------------------------------------------
!  convert to cgs and then back to mks for consistency with previous 
!---------------------------------------------------------------------
      press(:,:,:) = 0.1*(10.0*Atmos_input%press(:,:,:))
      pflux(:,:,:) =     (10.0*Atmos_input%pflux(:,:,:))
      deltaz(:,:,:) = Atmos_input%deltaz(:,:,:)
      temp  (:,:,:) = Atmos_input%temp  (:,:,:)
      cloud_deltaz = Atmos_input%clouddeltaz

!--------------------------------------------------------------------
!    define limits and dimensions 
!--------------------------------------------------------------------
      ix = size(temp,1)
      jx = size(temp,2)
      kx = size(temp,3) - 1
      israd = 1
      jsrad = 1
      ksrad = 1
      ierad = ix
      jerad = jx
      kerad = kx

!----------------------------------------------------------------------c
!    define a flag indicating columns in which there is sunshine during
!    this radiation time step. define a flag indicating points with both
!    sunlight and cloud.      
!----------------------------------------------------------------------c
      do j = JSRAD,JERAD
        do i = ISRAD,IERAD
          if ( Astro%fracday(i,j) /= 0.0) then
            daylight(i,j) = .true.                 
          else
            daylight(i,j) = .false.                
          endif     
          cloud_in_column(i,j) = .false.
        end do
      end do
        
      call compute_aerosol_optical_props     &
                (Atmos_input, Aerosol, Aerosol_props, &
                 including_volcanoes, Aerosol_diags, r,  &
                 including_aerosols, naerosol_optical, &
                 daylight, aeroextopdep, aerosctopdep, aeroasymfac) 

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      ssolar = Sw_control%solar_constant*Astro%rrsun

 
!----------------------------------------------------------------------
!    define a flag indicating points with both sunlight and cloud. set
!    the flag indicating that cloud is present in columns with such
!    points.
!----------------------------------------------------------------------
      if (.not. Cldrad_control%do_stochastic_clouds) then
        do j = JSRAD,JERAD
          do i = ISRAD,IERAD
            if (daylight(i,j)) then
              do k=KSRAD,KERAD
                if (cldfrac(i,j,k) > 0.0)  then
                  cloud_in_column(i,j) = .true.
                  cloud(i,j,k) = .true.
                  cloudfrac(i,j,k) = cldfrac(i,j,k)
                else
                  cloud(i,j,k) = .false.
                  cloudfrac(i,j,k) = 0.0
                endif
              end do
            else
              do k=KSRAD,KERAD
                cloud(i,j,k) = .false.
                cloudfrac(i,j,k) = 0.0
              end do
            endif
          end do
        end do
      endif

!----------------------------------------------------------------------c
!    define pressure related quantities, pressure is in mks units. 
!----------------------------------------------------------------------c
      pflux_mks = pflux*1.0E-1

      do k = KSRAD+1,KERAD+1
        deltap(:,:,k-1) = pflux_mks(:,:,k) - pflux_mks(:,:,k-1)
        gocpdp(:,:,k-1) = radcon_mks/deltap(:,:,k-1)
      end do
 
      call compute_gas_props (Atmos_input, Rad_gases, Astro,   &
                              daylight, gasopdep)
  
!---------------------------------------------------------------------
!    define the molecular density for use in calculating the           
!    rayleigh optical depth (deltaz is in meters).                     
!--------------------------------------------------------------------
      do k = KSRAD,KERAD
        densitymol(:,:,k) = refquanray * press(:,:,k) / temp(:,:,k)
      end do
 

! assumption is that there is 1 cloud profile for each sw band
      if (do_ica_calcs) then
        nprofiles = nbands
        profiles_inverse = 1.0/nprofiles
      else
        nprofiles = 1
        profiles_inverse = 1.0
      endif

!--------------------------------------------------------------------
!    define the rayleigh optical depths.                                
!---------------------------------------------------------------------
      do nband = 1, NBANDS
        rayopdep(:,:,:,nband) = betaddensitymol(nband)*  &
                                        densitymol(:,:,:)*deltaz(:,:,:)
      end do   ! (nband loop)

      nzens = Rad_control%nzens

!--------------------------------------------------------------------
 
      do nprofile=1, nprofiles
        if (do_ica_calcs) then
          cldfrac_band(:,:,:) = Cld_spec%camtsw_band(:,:,:,nprofile)
        endif

!----------------------------------------------------------------------c
!    np is a counter for the pseudo-monochromatic frequency point 
!    number.
!----------------------------------------------------------------------c
        np = 0
 
        do nz=1,nzens
          if (Rad_control%do_totcld_forcing) then
            dfswbandclr(:,:,:,nz) = 0.0
            fswbandclr(:,:,:,nz) = 0.0
            hswbandclr(:,:,:,nz) = 0.0
            ufswbandclr(:,:,:,nz) = 0.0
          endif
        end do
        reflectanceclr = 0.0
        transmittanceclr = 0.0

!----------------------------------------------------------------------c
!    begin band loop                                                   
!----------------------------------------------------------------------c
        do nband = 1,NBANDS
 
          do nz=1,nzens
            sumtr(:,:,:,nz) = 0.0
            sumtr_dir(:,:,:,nz) = 0.0
            sumtr_dir_up(:,:,nz) = 0.0
            sumre(:,:,:,nz) = 0.0
            if (Rad_control%do_totcld_forcing) then
              sumtrclr(:,:,:,nz) = 0.0
              sumreclr(:,:,:,nz) = 0.0
              sumtr_dir_clr(:,:,:,nz) = 0.0
            endif
          end do
          if (Cldrad_control%do_stochastic_clouds) then
            if (.not. do_ica_calcs) then
              cldfrac_band(:,:,:) = Cld_spec%camtsw_band(:,:,:,nband)
            endif
          endif
 
!----------------------------------------------------------------------
!    if stochastic clouds are activated (cloud fields differ with sw
!    parameterization band), define a flag indicating points with both
!    sunlight and cloud for the current sw parameterization band. set
!    the flag indicating that cloud is present in columns with such
!    points.
!----------------------------------------------------------------------
          if (Cldrad_control%do_stochastic_clouds) then
            do j = JSRAD,JERAD
              do i = ISRAD,IERAD
                cloud_in_column(i,j) = .false.
                if (daylight(i,j)) then
                  do k = KSRAD,KERAD
                    if (cldfrac_band(i,j,k) > 0.0)  then
                      cloud_in_column(i,j) = .true.
                      cloud(i,j,k) = .true.
                      cloudfrac(i,j,k) = cldfrac_band(i,j,k)
                    else
                      cloud(i,j,k) = .false.
                      cloudfrac(i,j,k) = 0.0
                    endif
                  end do
                else
                  do k = KSRAD,KERAD
                    cloud(i,j,k) = .false.
                    cloudfrac(i,j,k) = 0.0
                  end do
                endif
              end do
            end do
          endif


!---------------------------------------------------------------------
!    obtain cloud properties from the Cldrad_props input variable.
!--------------------------------------------------------------------
          cldext(:,:,:) = Cldrad_props%cldext(:,:,:,nband,nprofile)
          cldsct(:,:,:) = Cldrad_props%cldsct(:,:,:,nband,nprofile)
          cldasymm(:,:,:) = Cldrad_props%cldasymm(:,:,:,nband,nprofile)

          do k = KSRAD,KERAD
            do j=JSRAD,JERAD
              do i=ISRAD, IERAD
                if (cloud(i,j,k) ) then
                  cloudextopdep(i,j,k) = 1.0E-03*cldext(i,j,k) *    &
                                         cloud_deltaz(i,j,k)
                  cloudsctopdep(i,j,k) = 1.0E-03*cldsct(i,j,k) *    &
                                         cloud_deltaz(i,j,k)
                  cloudasymfac(i,j,k) = cldasymm(i,j,k)
                endif
              end do
            end do
          end do

!-----------------------------------------------------------------
!    define clear sky arrays
!-----------------------------------------------------------------
          if (nband >= firstrayband ) then
            do k=ksrad,kerad
              do j=jsrad,jerad
                do i=israd,ierad
                  if (daylight(i,j) ) then
                    sctopdepclr(i,j,k) = rayopdep(i,j,k,nband) +   &
                                            aerosctopdep(i,j,k,nband)
                    gclr(i,j,k) = aeroasymfac(i,j,k,nband)*  &
                                  aerosctopdep(i,j,k,nband)/&
                                                     sctopdepclr(i,j,k)
                    fclr(i,j,k) = aeroasymfac(i,j,k,nband)*gclr(i,j,k)
                    gstrclr(i,j,k) = ( gclr(i,j,k)  - fclr(i,j,k) )/  &
                                     ( 1.0 - fclr(i,j,k) )
                  endif
                end do
              end do
            end do
          endif

!-----------------------------------------------------------------
!    define cloudy sky arrays
!-----------------------------------------------------------------
          do k=KSRAD,KERAD
            do j=JSRAD,JERAD
              do i=ISRAD,IERAD
                if (cloud(i,j,k)) then
                  sctopdepovc(i,j,k) = rayopdep(i,j,k,nband) +    &
                                       aerosctopdep(i,j,k,nband) + &
                                       cloudsctopdep(i,j,k) 
                  govc(i,j,k) = ( ( cloudasymfac(i,j,k) *   &
                                    cloudsctopdep(i,j,k) ) +  &
                                  ( aeroasymfac(i,j,k,nband) *   &
                                    aerosctopdep(i,j,k,nband)))/   &
                                    sctopdepovc(i,j,k)
                  fovc(i,j,k) = ( ( cloudasymfac(i,j,k) ** 2 *  &
                                    cloudsctopdep(i,j,k) ) + &
                                  ( aeroasymfac(i,j,k,nband) ** 2 *  &
                                    aerosctopdep(i,j,k,nband) ))/  &
                                    sctopdepovc(i,j,k)
                  gstrovc(i,j,k) = ( govc(i,j,k)  - fovc(i,j,k))/  &
                                   ( 1.0 - fovc(i,j,k) )
                endif
              end do
            end do
          end do

!---------------------------------------------------------------------
!    begin frequency points in the band loop.                          
!--------------------------------------------------------------------
          do nf = 1,nfreqpts(nband)
            np = np + 1
 
!---------------------------------------------------------------------
!    begin gaussian angle loop (ng > 1 only when lswg = true).        
!--------------------------------------------------------------------
            do ng = 1,NSOLWG
 
!---------------------------------------------------------------------
!    clear sky mode                                                    
!    note: in this mode, the delta-eddington method is performed for all
!    spatial columns experiencing sunlight.         
!--------------------------------------------------------------------
              if (nband >= firstrayband )  then
                do k=ksrad,kerad
                  do j=jsrad,jerad
                    do i=israd,ierad
                      if (daylight(i,j) ) then
                        extopdepclr(i,j,k) = gasopdep(i,j,k,np,ng) +  &
                                             rayopdep(i,j,k,nband) +   &
                                             aeroextopdep(i,j,k,nband)
                        ssalbclr(i,j,k) = sctopdepclr(i,j,k)/    &
                                          extopdepclr(i,j,k)
                        taustrclr(i,j,k) = extopdepclr(i,j,k)*( 1.0 -  &
                                           ssalbclr(i,j,k)*fclr(i,j,k) )
                        omegastrclr(i,j,k) =      &
                               ssalbclr(i,j,k)*((1.0 - fclr(i,j,k))/  &
                               (1.0 -  ssalbclr(i,j,k)*fclr(i,j,k)))
                      endif
                    end do
                  end do
                end do
              endif

!--------------------------------------------------------------------
!    calculate the scaled single-scattering quantities for use in the   
!    delta-eddington routine.                                         
!--------------------------------------------------------------------
              do k=KSRAD,KERAD
                do j=JSRAD,JERAD
                  do i=ISRAD,IERAD
                    if (cloud(i,j,k) ) then
                      extopdepovc(i,j,k) = gasopdep(i,j,k,np,ng) +    &
                                           rayopdep(i,j,k,nband) +  &
                                           aeroextopdep(i,j,k,nband) + &
                                           cloudextopdep(i,j,k)
                      ssalbovc(i,j,k) = sctopdepovc(i,j,k) /    &
                                        extopdepovc(i,j,k)
                      taustrovc(i,j,k) = extopdepovc(i,j,k)*( 1.0 - &
                                         ssalbovc(i,j,k)*fovc(i,j,k) )
                      omegastrovc(i,j,k) = ssalbovc(i,j,k)*( ( 1.0 - &
                                           fovc(i,j,k) )/( 1.0 -   &
                                           ssalbovc(i,j,k) *   &
                                           fovc(i,j,k) ) )
                    endif
                  end do
                end do
              end do

!---------------------------------------------------------------------
!    do calculations for all desired zenith angles.
!---------------------------------------------------------------------
              do nz = 1, nzens
                if (Rad_control%hires_coszen) then
                  cosangsolar_p(:,:,ng) = Astro%cosz_p(:,:,nz)   
                else
                  cosangsolar_p(:,:,ng) = Astro%cosz(:,:)          
                endif

                where (cosangsolar_p(:,:,:) == 0.0)   &
                                            cosangsolar_p(:,:,:) = 1.0

!---------------------------------------------------------------------
!    clear sky mode                                                    
!    note: in this mode, the delta-eddington method is performed for all
!    spatial columns experiencing sunlight.         
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!    calculate the scaled single-scattering quantities for use in the   
!    delta-eddington routine.                                       
!---------------------------------------------------------------------
                if (nband >= firstrayband )  then

!---------------------------------------------------------------------
!    do diffuse calculation only for first zenith angle -- it is 
!    independent of zenith angle.
!---------------------------------------------------------------------
                  if (nz == 1) then
                    call deledd     &
                        (ix, jx, kx, taustrclr, omegastrclr, &
                         gstrclr, cosangsolar_p(:,:,ng), ng, daylight, &
                         rlayerdirclr, tlayerdirclr, tlayerdeclr, &
                         rlayerdif=rlayerdifclr, tlayerdif=tlayerdifclr)
                  else
                    call deledd     &
                        (ix, jx, kx, taustrclr, omegastrclr, &
                         gstrclr, cosangsolar_p(:,:,ng), ng, daylight,&
                         rlayerdirclr, tlayerdirclr, tlayerdeclr)
                  endif

!---------------------------------------------------------------------
!    the following needs to be done at daylight points only -- currently
!    this code is not active, since ng == 1.
!---------------------------------------------------------------------
                  if (ng /= 1) then
                    tlayerdifclr = 0.0       
                    if (NSTREAMS == 1) then
                      tlayerdifclr(:,:,:) =   &
                             exp(-gasopdep(:,:,:,np,ng)/cosangstr(1))
                    else
                      do ns = 1,NSTREAMS
                        tlayerdifclr(:,:,:) =    &
                             tlayerdifclr(:,:,:) +  & 
                                   exp( -gasopdep(:,:,:,np,ng)/&
                                         cosangstr(ns) )*wtstr(ns)* &
                                         cosangstr(ns)
                      end do
                    endif
                    rlayerdifclr = 0.0
                  endif
  
!---------------------------------------------------------------------
!    initialize the layer reflection and transmission arrays for the   
!    non-rayleigh-scattering case.                            
!-------------------------------------------------------------------
                else
!---------------------------------------------------------------------
!    the following needs to be done at daylight points only -- currently
!    this code is not active, since ng == 1, and all bands see rayleigh
!    scattering.
!---------------------------------------------------------------------
                  tlayerdifclr = 0.0       
                  if (NSTREAMS == 1) then
                    tlayerdifclr(:,:,:) =     &
                            exp( -gasopdep(:,:,:,np,ng)/cosangstr(1))
                  else
                    do ns = 1,NSTREAMS
                      tlayerdifclr(:,:,:) =   &
                         tlayerdifclr(:,:,:) +    &
                              exp(-gasopdep(:,:,:,np,ng)/&
                                cosangstr(ns))*wtstr(ns)*cosangstr(ns)
                    end do
                  endif
                  rlayerdirclr(:,:,:) = 0.0
                  do k=KSRAD,KERAD
                    tlayerdirclr(:,:,k) =      &
                                  exp( -gasopdep(:,:,k,np,ng) /   &
                                                 cosangsolar_p(:,:,ng) )
                  end do  
                  tlayerdeclr(:,:,:) = tlayerdirclr(:,:,:)
                  rlayerdifclr = 0.0
                endif

!---------------------------------------------------------------------
!    overcast sky mode                                                  
!    note: in this mode, the delta-eddington method is performed only 
!    for spatial columns containing a cloud and experiencing sunlight. 
!---------------------------------------------------------------------


!----------------------------------------------------------------------
!    calculate the reflection and transmission in the scattering layers 
!    using the delta-eddington method.                                  
!-------------------------------------------------------------------
                if (nz == 1) then
                  call deledd      &
                       (ix, jx, kx, taustrovc, omegastrovc, gstrovc, &
                        cosangsolar_p(:,:,ng), ng, daylight, &
                        rlayerdirovc, tlayerdirovc, tlayerdeovc, &
                        rlayerdif=rlayerdifovc, tlayerdif=tlayerdifovc,&
                        cloud=cloud)
                else
                  call deledd      &
                       (ix, jx, kx, taustrovc, omegastrovc, gstrovc, &
                        cosangsolar_p(:,:,ng), ng, daylight, &
                        rlayerdirovc, tlayerdirovc, tlayerdeovc,   & 
                        cloud=cloud)
                endif
                if (ng /= 1) then
                  tlayerdifovc(:,:,:) = tlayerdifclr(:,:,:)
                  rlayerdifovc(:,:,:) = rlayerdifclr(:,:,:)
                endif
 
!-------------------------------------------------------------------- 
!    weight the reflection and transmission arrays for clear and        
!    overcast sky conditions by the cloud fraction, to calculate the    
!    resultant values.                                                  
!---------------------------------------------------------------------- 
                do k=KSRAD,KERAD
                  do j=JSRAD,JERAD
                    do i=ISRAD,IERAD
                      if ( cloud(i,j,k) ) then
                        rlayerdir(i,j,k) = cloudfrac(i,j,k)*   &
                                           rlayerdirovc(i,j,k) +  &
                                           (1.0 - cloudfrac(i,j,k) )*  &
                                           rlayerdirclr(i,j,k)
                        rlayerdif(i,j,k) = cloudfrac(i,j,k) *  &
                                           rlayerdifovc(i,j,k) +  &
                                           ( 1.0 - cloudfrac(i,j,k) )* &
                                           rlayerdifclr(i,j,k)
                        tlayerdir(i,j,k) = cloudfrac(i,j,k) *   &
                                           tlayerdirovc(i,j,k) +  &
                                           ( 1.0 - cloudfrac(i,j,k) )* &
                                           tlayerdirclr(i,j,k)
                        tlayerdif(i,j,k) = cloudfrac(i,j,k) *   &
                                           tlayerdifovc(i,j,k) +  &
                                           ( 1.0 - cloudfrac(i,j,k) )* &
                                           tlayerdifclr(i,j,k)
                        tlayerde(i,j,k) =  cloudfrac(i,j,k) *   &
                                           tlayerdeovc(i,j,k) +  &
                                           (1.0 - cloudfrac(i,j,k) )* &
                                           tlayerdeclr(i,j,k)
                      else if (daylight(i,j)) then
                        rlayerdir(i,j,k) = rlayerdirclr(i,j,k)
                        tlayerdir(i,j,k) = tlayerdirclr(i,j,k)
                        rlayerdif(i,j,k) = rlayerdifclr(i,j,k)
                        tlayerdif(i,j,k) = tlayerdifclr(i,j,k)
                        tlayerde (i,j,k) = tlayerdeclr (i,j,k)
                      endif
                    end do
                  end do
                end do
 
!---------------------------------------------------------------------
!    define the surface albedo (infrared value for infrared bands,      
!    visible value for the remaining bands).                            
!----------------------------------------------------------------------c
                if (nband <= NIRBANDS ) then
                  sfcalb_dir(:,:) = Surface%asfc_nir_dir(:,:)
                  sfcalb_dif(:,:) = Surface%asfc_nir_dif(:,:)
                else
                  sfcalb_dir(:,:) = Surface%asfc_vis_dir(:,:)
                  sfcalb_dif(:,:) = Surface%asfc_vis_dif(:,:)
                end if
 
!-------------------------------------------------------------------- 
!    calculate the reflection and transmission at flux levels from the  
!    direct and diffuse values of reflection and transmission in the  
!    corresponding layers using the adding method.                      
!---------------------------------------------------------------------
                call adding         &
                    (ix, jx, kx, rlayerdir, tlayerdir, rlayerdif, &
                     tlayerdif, tlayerde, sfcalb_dir, sfcalb_dif,    &
                     daylight, reflectance, transmittance, tr_dir)    

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
                if (Rad_control%do_totcld_forcing) then
                  call adding       &
                      (ix, jx,  kx, rlayerdirclr, tlayerdirclr,   &
                       rlayerdifclr, tlayerdifclr, tlayerdeclr,   &
                       sfcalb_dir,  sfcalb_dif, cloud_in_column,  &
                       reflectanceclr, transmittanceclr, tr_dirclr)
                endif

!---------------------------------------------------------------------- 
!    weight and sum the reflectance and transmittance to calculate the 
!    band values.                                                     
!-------------------------------------------------------------------
                do j=JSRAD,JERAD
                  do i=ISRAD,IERAD
                    wtfac_p(i,j) = wtfreq(np)*gausswt(ng)*   &
                                                  cosangsolar_p(i,j,ng)
                  end do
                end do

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
                do k = KSRAD,KERAD+1
                  do j=JSRAD,JERAD
                    do i=ISRAD,IERAD
                      if (daylight(i,j) ) then
                        sumtr(i,j,k,nz) = sumtr(i,j,k,nz) +    &
                                      transmittance(i,j,k)*wtfac_p(i,j)
                        sumtr_dir(i,j,k,nz) = sumtr_dir(i,j,k,nz) +  &
                                        tr_dir(i,j,k)*wtfac_p(i,j)
                        sumre(i,j,k,nz) = sumre(i,j,k,nz) +     &
                                       reflectance(i,j,k)*wtfac_p(i,j)
                      endif
                    end do
                  end do
                end do
                  do j=JSRAD,JERAD
                    do i=ISRAD,IERAD
                      if (daylight(i,j) ) then
                        sumtr_dir_up(i,j,nz) = sumtr_dir_up(i,j,nz) + &
                          tr_dir(i,j,KERAD+1)*sfcalb_dir(i,j)*wtfac_p(i,j)
                      endif
                    end do
                  end do

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
                if (Rad_control%do_totcld_forcing) then
                  do k = KSRAD,KERAD+1
                    do j=JSRAD,JERAD
                      do i=ISRAD,IERAD
                        if (cloud_in_column(i,j)) then
                          sumtrclr(i,j,k,nz) =    &
                                sumtrclr(i,j,k,nz) +   &
                                transmittanceclr(i,j,k)* wtfac_p(i,j) 
                          sumtr_dir_clr(i,j,k,nz) = &
                                sumtr_dir_clr(i,j,k,nz) +  &
                                tr_dirclr(i,j,k)*wtfac_p(i,j)
                          sumreclr(i,j,k,nz) = sumreclr(i,j,k,nz) +   &
                                reflectanceclr(i,j,k)*wtfac_p(i,j)
                        else if (daylight(i,j) ) then
                          sumtrclr(i,j,k,nz) = sumtrclr(i,j,k,nz) +   &
                                transmittance(i,j,k)*wtfac_p(i,j)
                          sumtr_dir_clr(i,j,k,nz) =    &
                             sumtr_dir_clr(i,j,k,nz) + tr_dir(i,j,k)*&
                                                            wtfac_p(i,j)
                          sumreclr(i,j,k,nz) = sumreclr(i,j,k,nz) +   &
                                        reflectance(i,j,k)*wtfac_p(i,j)
                        endif
                      end do
                    end do
                  end do
                endif
              end do ! end of nz loop
            end do    ! end of gaussian loop
          end do  ! end of frequency points in the band loop
 
!----------------------------------------------------------------------
!    normalize the solar flux in the band to the appropriate value for  
!    the given total solar insolation.                                 
!---------------------------------------------------------------------
          do nz = 1,nzens
            if (Rad_control%hires_coszen) then
              fracday_p(:,:) = Astro%fracday_p(:,:,nz)
            else
              fracday_p(:,:) = Astro%fracday(:,:)
            endif
            solarflux_p(:,:) = fracday_p(:,:)*  &
                                   Solar_spect%solflxband(nband)*  &
                                                      ssolar/solflxtotal_local
 
            if (nband == Solar_spect%visible_band_indx) then
              Sw_output%bdy_flx(:,:,1,nz) =   &
                  Sw_output%bdy_flx(:,:,1,nz) + sumre(:,:,1,nz)*   &
                                                        solarflux_p(:,:)
              Sw_output%bdy_flx(:,:,3,nz) =    &
                  Sw_output%bdy_flx(:,:,3,nz) + sumtr(:,:,KERAD+1,nz)*&
                                                solarflux_p(:,:) -  &
                                                sumre(:,:,KERAD+1,nz)* &
                                                solarflux_p(:,:) 
            endif
            if (nband == onepsix_band_indx) then
               Sw_output%bdy_flx(:,:,2,nz) =     &
                   Sw_output%bdy_flx(:,:,2,nz) + sumre(:,:,1,nz)*  &
                                                        solarflux_p(:,:)
               Sw_output%bdy_flx(:,:,4,nz) =    &
                   Sw_output%bdy_flx(:,:,4,nz) + sumtr(:,:,KERAD+1,nz)*&
                                                 solarflux_p(:,:) - &
                                                 sumre(:,:,KERAD+1,nz)*&
                                                 solarflux_p(:,:)
            endif
          
!-------------------------------------------------------------------
!    calculate the band fluxes and heating rates.                       
!--------------------------------------------------------------------
            if (do_esfsw_band_diagnostics) then
              do k = KSRAD,KERAD+1
                do j=JSRAD,JERAD
                  do i=ISRAD,IERAD
                    dfswband(i,j,k,nz) = sumtr(i,j,k,nz)*   &
                                                       solarflux_p(i,j) 
                    ufswband(i,j,k,nz) = sumre(i,j,k,nz)*      &
                                                       solarflux_p(i,j)
                  end do
                end do
              end do
            endif
 
!----------------------------------------------------------------------
!    sum the band fluxes and heating rates to calculate the total       
!    spectral values.                                                  
!------------------------------------------------------------------
            do k = KSRAD,KERAD+1
              do j=JSRAD,JERAD
                do i=ISRAD,IERAD
                  if (daylight(i,j) ) then
                    Sw_output%dfsw (i,j,k,nz) =   &
                       Sw_output%dfsw(i,j,k,nz) + sumtr(i,j,k,nz)*&
                                                       solarflux_p(i,j)
                    Sw_output%ufsw (i,j,k,nz) =   &
                       Sw_output%ufsw(i,j,k,nz) + sumre(i,j,k,nz)*  &
                                                       solarflux_p(i,j)
                    fswband(i,j,k,nz) = ((sumre(i,j,k,nz)*  &
                                          solarflux_p(i,j)) - &
                                         (sumtr(i,j,k,nz)*    &
                                                      solarflux_p(i,j)))
                    Sw_output%fsw(i,j,k,nz) = Sw_output%fsw(i,j,k,nz) +&
                                                      fswband(i,j,k,nz)
                  endif
                end do
              end do
            end do
 
            do j=JSRAD,JERAD
              do i=ISRAD,IERAD
                if (daylight(i,j) ) then
                  Sw_output%dfsw_dir_sfc(i,j,nz) =   &
                            Sw_output%dfsw_dir_sfc(i,j,nz) +   &
                              sumtr_dir(i,j,KERAD+1,nz)*solarflux_p(i,j)
                  Sw_output%ufsw_dir_sfc(i,j,nz) =   &
                            Sw_output%ufsw_dir_sfc(i,j,nz) +   &
                              sumtr_dir_up(i,j,nz)*solarflux_p(i,j)
                  Sw_output%ufsw_dif_sfc(i,j,nz) =   &
                             Sw_output%ufsw_dif_sfc(i,j,nz) +   &
                                 sumre(i,j,KERAD+1,nz)*solarflux_p(i,j)
                endif
              end do
            end do

            if (nband > NIRBANDS) then
              do j=JSRAD,JERAD
                do i=ISRAD,IERAD
                  if (daylight(i,j) ) then
                    Sw_output%dfsw_vis_sfc(i,j,nz) =   &
                          Sw_output%dfsw_vis_sfc(i,j,nz) +   &
                                sumtr(i,j,KERAD+1,nz)*solarflux_p(i,j)
                    Sw_output%ufsw_vis_sfc(i,j,nz) =   &
                           Sw_output%ufsw_vis_sfc(i,j,nz) +   &
                                 sumre(i,j,KERAD+1,nz)*solarflux_p(i,j)
                    Sw_output%dfsw_vis_sfc_dir(i,j,nz) =   &
                            Sw_output%dfsw_vis_sfc_dir(i,j,nz) +   &
                              sumtr_dir(i,j,KERAD+1,nz)*solarflux_p(i,j)
                    Sw_output%ufsw_vis_sfc_dir(i,j,nz) =   &
                            Sw_output%ufsw_vis_sfc_dir(i,j,nz) +   &
                              sumtr_dir_up(i,j,nz)*solarflux_p(i,j)
                    Sw_output%ufsw_vis_sfc_dif(i,j,nz) =   &
                             Sw_output%ufsw_vis_sfc_dif(i,j,nz) +   &
                                 sumre(i,j,KERAD+1,nz)*solarflux_p(i,j)
                  endif
                end do
              end do
            endif

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
            do k = KSRAD,KERAD
              do j=JSRAD,JERAD
                do i=ISRAD,IERAD
                  if (daylight(i,j) ) then
                    hswband(i,j,k,nz) = (fswband(i,j,k+1,nz) -    &
                                      fswband(i,j,k,nz) )*gocpdp(i,j,k)
                    Sw_output%hsw(i,j,k,nz) =    &
                          Sw_output%hsw(i,j,k,nz) + hswband(i,j,k,nz)
                  endif
                end do
              end do
            end do

!----------------------------------------------------------------------
!    calculate the band fluxes and heating rates.                       
!---------------------------------------------------------------------
            if (nprofile == 1) then  ! clr sky need be done only for 
                                     ! first cloud profile
              if (Rad_control%do_totcld_forcing) then
                do j=JSRAD,JERAD
                  do i=ISRAD,IERAD
                    if (daylight(i,j) ) then
                      Sw_output%dfsw_dir_sfc_clr(i,j,nz) =   &
                         Sw_output%dfsw_dir_sfc_clr(i,j,nz) +   &
                          sumtr_dir_clr(i,j,KERAD+1,nz)*solarflux_p(i,j)
                    endif
                  end do
                end do
                if (nband > NIRBANDS) then
                  do j=JSRAD,JERAD
                    do i=ISRAD,IERAD
                      if (daylight(i,j) ) then
                        Sw_output%dfsw_vis_sfc_clr(i,j,nz) =   &
                           Sw_output%dfsw_vis_sfc_clr(i,j,nz) +   &
                              sumtrclr(i,j,KERAD+1,nz)*solarflux_p(i,j)
                      endif
                    end do
                  end do
                endif
                if (nband == Solar_spect%visible_band_indx) then
                  Sw_output%bdy_flx_clr(:,:,1,nz) =      &
                           sumreclr(:,:,1,nz)*solarflux_p(:,:)
                  Sw_output%bdy_flx_clr(:,:,3,nz) =    &
                          sumtrclr(:,:,KERAD+1,nz)*solarflux_p(:,:) - &
                          sumreclr(:,:,KERAD+1,nz)*solarflux_p(:,:) 
                endif
                if (nband == onepsix_band_indx) then
                  Sw_output%bdy_flx_clr(:,:,2,nz) =    &
                          sumreclr(:,:,1,nz)*solarflux_p(:,:)
                  Sw_output%bdy_flx_clr(:,:,4,nz) =    &
                         sumtrclr(:,:,KERAD+1,nz)*solarflux_p(:,:)  -  &
                         sumreclr(:,:,KERAD+1,nz)*solarflux_p(:,:) 
                endif
          
                if (do_esfsw_band_diagnostics) then
                  do k = KSRAD,KERAD+1
                    do j=JSRAD,JERAD
                      do i=ISRAD,IERAD
                        dfswbandclr(i,j,k,nz) =     &
                                   sumtrclr(i,j,k,nz)*solarflux_p(i,j)
                        ufswbandclr(i,j,k,nz) =    &
                                   sumreclr(i,j,k,nz)*solarflux_p(i,j)
                      end do
                    end do
                  end do
                endif

!----------------------------------------------------------------------c
!    sum the band fluxes and heating rates to calculate the total     
!    spectral values.                                                 
!----------------------------------------------------------------------c
                do k = KSRAD,KERAD+1
                  do j=JSRAD,JERAD
                    do i=ISRAD,IERAD
                      Sw_output%dfswcf(i,j,k,nz) =    &
                              Sw_output%dfswcf(i,j,k,nz) +  &
                                    sumtrclr(i,j,k,nz)*solarflux_p(i,j)
                      Sw_output%ufswcf(i,j,k,nz) =      &
                              Sw_output%ufswcf(i,j,k,nz) +  &
                                    sumreclr(i,j,k,nz)*solarflux_p(i,j)
                      fswbandclr(i,j,k,nz) =    &
                            (sumreclr(i,j,k,nz)*solarflux_p(i,j)) - &
                            (sumtrclr(i,j,k,nz)*solarflux_p(i,j))
                      Sw_output%fswcf(i,j,k,nz) =    &
                                    Sw_output%fswcf(i,j,k,nz) +    &
                                                  fswbandclr(i,j,k,nz)
                    end do
                  end do
                end do

!----------------------------------------------------------------------c
!    sum the band fluxes and heating rates to calculate the total    
!    spectral values.                                               
!----------------------------------------------------------------------c
                do k = KSRAD,KERAD
                  do j=JSRAD,JERAD
                    do i=ISRAD,IERAD
                      hswbandclr(i,j,k,nz) =    &
                                (fswbandclr(i,j,k+1,nz) -      &
                                    fswbandclr(i,j,k,nz))*gocpdp(i,j,k)
                      Sw_output%hswcf(i,j,k,nz) =   &
                                   Sw_output%hswcf(i,j,k,nz) +    &
                                                   hswbandclr(i,j,k,nz)
                    end do
                  end do
                end do
              endif
            endif ! (nprofile == 1)
          end do ! (nz loop)
        end do   ! (end of band loop)
      end do   ! (end of nprofile loop)

!----------------------------------------------------------------------
!    if the ica calculation was being done, the fluxes and heating rates
!    which have been summed over nprofiles cloud profiles must be 
!    averaged.
!------------------------------------------------------------------
      if (do_ica_calcs) then
        do j=JSRAD,JERAD
          do i=ISRAD,IERAD
            Sw_output%dfsw_dir_sfc (i,j,:) =   &
                      Sw_output%dfsw_dir_sfc(i,j,:)*profiles_inverse
            Sw_output%ufsw_dif_sfc (i,j,:) =   &
                      Sw_output%ufsw_dif_sfc(i,j,:)*profiles_inverse
            Sw_output%dfsw_vis_sfc (i,j,:) =   &
                      Sw_output%dfsw_vis_sfc(i,j,:)*profiles_inverse
            Sw_output%ufsw_vis_sfc (i,j,:) =   &
                      Sw_output%ufsw_vis_sfc(i,j,:)*profiles_inverse
            Sw_output%dfsw_vis_sfc_dir (i,j,:) =   &
                      Sw_output%dfsw_vis_sfc_dir(i,j,:)*profiles_inverse
            Sw_output%ufsw_vis_sfc_dif (i,j,:) =   &
                      Sw_output%ufsw_vis_sfc_dif(i,j,:)*profiles_inverse
            Sw_output%bdy_flx(i,j,:,:) =  &
                      Sw_output%bdy_flx(i,j,:,:)*profiles_inverse
          end do
        end do
        do k = KSRAD,KERAD+1
          do j=JSRAD,JERAD
            do i=ISRAD,IERAD
              Sw_output%dfsw (i,j,k,:) = Sw_output%dfsw(i,j,k,:)*  &
                                       profiles_inverse
              Sw_output%ufsw (i,j,k,:) = Sw_output%ufsw(i,j,k,:)*  &
                                       profiles_inverse
              Sw_output%fsw(i,j,k,:) = Sw_output%fsw(i,j,k,:)*  &
                                     profiles_inverse
            end do
          end do
        end do
        do k = KSRAD,KERAD
          do j=JSRAD,JERAD
            do i=ISRAD,IERAD
              Sw_output%hsw(i,j,k,:) = Sw_output%hsw(i,j,k,:)*  &
                                       profiles_inverse
            end do
          end do
        end do
      endif

      do j=JSRAD,JERAD
        do i=ISRAD,IERAD
          if (daylight(i,j) ) then
            Sw_output%dfsw_dif_sfc(i,j,: ) =   &
                              Sw_output%dfsw(i,j,KERAD+1,: ) -   &
                                      Sw_output%dfsw_dir_sfc(i,j,: )
          endif
        end do
      end do

      if (Rad_control%do_totcld_forcing) then
        do j=JSRAD,JERAD
          do i=ISRAD,IERAD
            if (daylight(i,j) ) then
              Sw_output%dfsw_dif_sfc_clr(i,j,: ) =   &
                                Sw_output%dfswcf(i,j,KERAD+1,:) -   &
                                Sw_output%dfsw_dir_sfc_clr(i,j,:)
            endif
          end do
        end do
      endif

      do j=JSRAD,JERAD
        do i=ISRAD,IERAD
          if (daylight(i,j) ) then
            Sw_output%dfsw_vis_sfc_dif(i,j,:) =   &
                                Sw_output%dfsw_vis_sfc(i,j,:) -   &
                                Sw_output%dfsw_vis_sfc_dir(i,j,:) 
          endif
        end do
      end do

!--------------------------------------------------------------------
!    convert sw fluxes to cgs and then back to  mks units.
!---------------------------------------------------------------------
      Sw_output%fsw(:,:,:,:) =     &
                            1.0E-03*(1.0E+03*Sw_output%fsw(:,:,:,:))
      Sw_output%dfsw(:,:,:,:) =    &
                            1.0E-03*(1.0E+03*Sw_output%dfsw(:,:,:,:))
      Sw_output%ufsw(:,:,:,:) =     &
                            1.0E-03*(1.0E+03*Sw_output%ufsw(:,:,:,:))
      if (Rad_control%do_totcld_forcing) then
        Sw_output%fswcf(:,:,:,:) =   &
                            1.0E-03*(1.0E+03*Sw_output%fswcf(:,:,:,:))
        Sw_output%dfswcf(:,:,:,:) =     &
                            1.0E-03*(1.0E+03*Sw_output%dfswcf(:,:,:,:))
        Sw_output%ufswcf(:,:,:,:) =     &
                            1.0E-03*(1.0E+03*Sw_output%ufswcf(:,:,:,:))
      endif

!---------------------------------------------------------------------


end subroutine swresf



!####################################################################

subroutine esfsw_driver_end

!---------------------------------------------------------------------
!    esfsw_driver_end is the destructor for esfsw_driver_mod.
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('esfsw_driver_mod',   &
              'module has not been initialized', FATAL )
      endif

!--------------------------------------------------------------------
!    close out the modules that this module initialized.
!--------------------------------------------------------------------
      call esfsw_parameters_end

!---------------------------------------------------------------------
!    mark the module as uninitialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.

!---------------------------------------------------------------------

end subroutine esfsw_driver_end




!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                    PRIVATE SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!#################################################################
! <SUBROUTINE NAME="compute_aerosol_optical_props">
!  <OVERVIEW>
!   Subroutine that uses the delta-eddington technique in conjunction
!   with a multi-band parameterization for h2o+co2+o2+o3 absorption
!   in the solar spectrum to derive solar fluxes and heating rates.
!  </OVERVIEW>
!  <DESCRIPTION>
!    This subroutine calculates optical depth, single scattering albedo,
!    asymmetry parameter of a layer based on gaseous absorbers,
!    clouds, aerosols, and rayleigh scattering. It then uses delta-
!    eddington technique to calculate radiative flux at each layer. 
!    Doubling and adding technique is used to combine the layers
!    and calculate flux at TOA and surface and heating rate. This
!    subroutine allocates a substantial amount of memory and deallocates
!    the allocated memory at the end of the subroutine.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call comput(is, ie, js, je, Atmos_input, Surface, Rad_gases, Aerosol, 
!               Astro, &
!               Cldrad_props, Cld_spec, Sw_output)
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!    starting subdomain i indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="ie" TYPE="integer">
!    ending subdomain i indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="js" TYPE="integer">
!    starting subdomain j indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="je" TYPE="integer">
!    ending subdomain j indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
!    Atmos_input_type variable containing the atmospheric
!    input fields on the radiation grid 
!  </IN>
!  <IN NAME="Aerosol" TYPE="aerosol_type">
!   Aerosol input data for shortwave radiation calculation
!  </IN>
!  <IN NAME="Astro" TYPE="astronomy_type">
!    Astronomy_type variable containing the astronomical
!    input fields on the radiation grid  
!  </IN>
!  <IN NAME="Rad_gases" TYPE="radiative_gases_type">
!    Radiative_gases_type variable containing the radiative 
!    gas input fields on the radiation grid 
!  </IN>
!  <IN NAME="Cldrad_props" TYPE="cldrad_properties_type">
!    The cloud radiative property input fields on the
!    radiation grid
!  </IN>
!  <INOUT NAME="Sw_output" TYPE="sw_output_type">
!    The shortwave radiation calculation result
!  </INOUT>
!  <IN NAME="Surface" TYPE="surface_type">
!   Surface data as boundary condition to radiation
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!   Cloud specification data as initial condition to radiation
!  </IN>
! </SUBROUTINE>

subroutine compute_aerosol_optical_props    &
          (Atmos_input, Aerosol, Aerosol_props, including_volcanoes,  &
           Aerosol_diags, r, including_aerosols, naerosol_optical, &
           daylight, aeroextopdep, aerosctopdep, aeroasymfac)

!----------------------------------------------------------------------
!    comput uses the delta-eddington technique in conjunction with a    
!    multiple-band parameterization for h2o+co2+o2+o3 absorption to   
!    derive solar fluxes and heating rates.                             
!    notes: drops are assumed if temp>273.15K, ice crystals otherwise.
!-------------------------------------------------------------------

type(atmos_input_type),        intent(in)    :: Atmos_input
type(aerosol_type),            intent(in)    :: Aerosol     
type(aerosol_properties_type), intent(in)    :: Aerosol_props
logical,                       intent(in)    :: including_volcanoes
type(aerosol_diagnostics_type),intent(inout) :: Aerosol_diags
real,dimension(:,:,:,:),       intent(inout) :: r
logical,                       intent(in)    :: including_aerosols  
integer,                       intent(in)    :: naerosol_optical
logical,dimension(:,:),        intent(in)    :: daylight
real, dimension(:,:,:,:),      intent(out)   :: aeroextopdep, &
                                                aerosctopdep, &
                                                aeroasymfac 


!-------------------------------------------------------------------
!  intent(in) variables:
!
!      Atmos_input    atmos_input_type structure, contains variables
!                     defining atmospheric state
!      Aerosol        aerosol_type structure, contains variables
!                     defining aerosol fields, passed through to
!                     lower level routines
!      Aerosol_props  aerosol radiative property input data for the 
!                     radiation package
!                                                                 
!   intent(inout) variables:
!
!      Sw_output         shortwave radiation output data
!
!---------------------------------------------------------------------

!-----------------------------------------------------------------------
!     local variables:
 
      real, dimension (size(Atmos_input%temp,3)-1)  :: &
                      arprod, asymm,   arprod2,      deltaz, &     
                      sum_g_omega_tau, sum_ext,      sum_sct

      integer, dimension (size (Atmos_input%press, 3)-1 ) ::   &
                      opt_index_v3, opt_index_v4, &
                      opt_index_v5, opt_index_v6, &
                      opt_index_v7, opt_index_v8, &
                      opt_index_v9, opt_index_v10, &
                      irh

      real, dimension (naerosol_optical)   ::            &
                      aerext,          aerssalb,       aerasymm

      real        :: aerext_i, aerssalb_i, aerasymm_i
      integer     :: j, i, k, nband, nsc
      integer     :: israd, jsrad, ierad, jerad, ksrad, kerad
      integer     :: nextinct  !variable to pass extinction to chemistry

!-----------------------------------------------------------------------
!     local variables:
!
!       aeramt
!       sum_g_omega_tau
!       opt_index_v3
!       irh
!    etc.
!
!--------------------------------------------------------------------


!--------------------------------------------------------------------
!    define limits and dimensions 
!--------------------------------------------------------------------
      israd = 1
      jsrad = 1
      ksrad = 1
      ierad = size(Atmos_input%temp,1)
      jerad = size(Atmos_input%temp,2)
      kerad = size(Atmos_input%temp,3) - 1

      naerosoltypes_used = size(Aerosol%aerosol,4)

      do j = JSRAD,JERAD
        do i = ISRAD,IERAD
          if (daylight(i,j) .or. Sw_control%do_cmip_diagnostics) then
            deltaz(:) = Atmos_input%deltaz(i,j,:)

            do nband = 1,Solar_spect%nbands
              if (including_aerosols) then                           
                aerext(:) = Aerosol_props%aerextband(nband,:)
                aerssalb(:) = Aerosol_props%aerssalbband(nband,:)
                aerasymm(:) = Aerosol_props%aerasymmband(nband,:)

!-------------------------------------------------------------------
!    define the local variables for the band values of aerosol and 
!    cloud single scattering parameters.                               
!    note: the unit for the aerosol extinction is kilometer**(-1).     
!--------------------------------------------------------------------
                do k = KSRAD,KERAD
                  irh(k) = MIN(100, MAX( 0,     &
                      NINT(100.*Atmos_input%aerosolrelhum(i,j,k))))
                  opt_index_v3(k) = &
                              Aerosol_props%sulfate_index (irh(k), &
                                            Aerosol_props%ivol(i,j,k))
                  opt_index_v4(k) =    &
                              Aerosol_props%omphilic_index( irh(k) )
                  opt_index_v5(k) =    &
                              Aerosol_props%bcphilic_index( irh(k) )
                  opt_index_v6(k) =    &
                              Aerosol_props%seasalt1_index( irh(k) )
                  opt_index_v7(k) =    &
                              Aerosol_props%seasalt2_index( irh(k) )
                  opt_index_v8(k) =    &
                              Aerosol_props%seasalt3_index( irh(k) )
                  opt_index_v9(k) =    &
                              Aerosol_props%seasalt4_index( irh(k) )
                  opt_index_v10(k) =    &
                              Aerosol_props%seasalt5_index( irh(k) )
                end do

!---------------------------------------------------------------------
!    calculate scattering properties for all aerosol constituents 
!    combined.
!---------------------------------------------------------------------
                do k = KSRAD,KERAD
                  sum_g_omega_tau(k) = 0.0
                  sum_ext(k) = 0.
                  sum_sct(k) = 0.
                end do
                do nsc = 1,NAEROSOLTYPES_USED
                  if (Aerosol_props%optical_index(nsc) > 0) then
                    aerext_i =     &
                            aerext(Aerosol_props%optical_index(nsc))
                    aerssalb_i =     &
                            aerssalb(Aerosol_props%optical_index(nsc))
                    aerasymm_i =     &
                            aerasymm(Aerosol_props%optical_index(nsc))
                    do k = KSRAD,KERAD
                      arprod(k) =    &
                            aerext_i*(1.e3*Aerosol%aerosol(i,j,k,nsc))
                      arprod2(k) = aerssalb_i*arprod(k)
                      asymm(k)   = aerasymm_i
                      sum_ext(k) = sum_ext(k) + arprod(k)
                      sum_sct(k) = sum_sct(k) + aerssalb_i*arprod(k)
                      sum_g_omega_tau(k) = sum_g_omega_tau(k) +     &
                                      aerasymm_i*(aerssalb_i*arprod(k))
                    end do
                  else if (Aerosol_props%optical_index(nsc) == &
                                     Aerosol_props%sulfate_flag) then
                    do k = KSRAD,KERAD
                      arprod(k) = aerext(opt_index_v3(k)) *    &
                                   (1.e3 * Aerosol%aerosol(i,j,k,nsc))
                      arprod2(k) = aerssalb(opt_index_v3(k))*arprod(k)
                      asymm(k)   = aerasymm(opt_index_v3(k))
                      sum_ext(k) = sum_ext(k) + arprod(k)
                      sum_sct(k) = sum_sct(k) +    &
                                    aerssalb(opt_index_v3(k))*arprod(k)
                      sum_g_omega_tau(k) = sum_g_omega_tau(k) +  &
                               aerasymm(opt_index_v3(k))*  &
                                   (aerssalb(opt_index_v3(k))*arprod(k))
                    end do
                  else if (Aerosol_props%optical_index(nsc) == &
                                     Aerosol_props%bc_flag) then
                    do k = KSRAD,KERAD
                      arprod(k) = aerext(opt_index_v3(k)) *    &
                                    (1.e3 * Aerosol%aerosol(i,j,k,nsc))
                      arprod2(k) = aerssalb(opt_index_v3(k))*arprod(k)
                      asymm(k)   = aerasymm(opt_index_v3(k))
                      sum_ext(k) = sum_ext(k) + arprod(k)
                      sum_sct(k) = sum_sct(k) +       &
                                    aerssalb(opt_index_v3(k))*arprod(k)
                      sum_g_omega_tau(k) = sum_g_omega_tau(k) + &
                               aerasymm(opt_index_v3(k)) * &
                                   (aerssalb(opt_index_v3(k))*arprod(k))
                    end do
                  else if (Aerosol_props%optical_index(nsc) == &
                               Aerosol_props%omphilic_flag) then
                    do k = KSRAD,KERAD
                      arprod(k) = aerext(opt_index_v4(k)) *    &
                                   (1.e3 * Aerosol%aerosol(i,j,k,nsc))
                      arprod2(k) = aerssalb(opt_index_v4(k))*arprod(k)
                      asymm(k)   = aerasymm(opt_index_v4(k))
                      sum_ext(k) = sum_ext(k) + arprod(k)
                      sum_sct(k) = sum_sct(k) + &
                                     aerssalb(opt_index_v4(k))*arprod(k)
                      sum_g_omega_tau(k) = sum_g_omega_tau(k) +   &
                               aerasymm(opt_index_v4(k))*     &
                                  (aerssalb(opt_index_v4(k))*arprod(k))
                    end do
                  else if (Aerosol_props%optical_index(nsc) == &
                                  Aerosol_props%bcphilic_flag) then
                    if (Rad_control%using_im_bcsul) then
                      do k = KSRAD,KERAD
                        arprod(k) = aerext(opt_index_v3(k)) *    &
                                   (1.e3 * Aerosol%aerosol(i,j,k,nsc))
                        arprod2(k) = aerssalb(opt_index_v3(k))*arprod(k)
                        asymm(k)   = aerasymm(opt_index_v3(k))
                        sum_ext(k) = sum_ext(k) + arprod(k)
                        sum_sct(k) = sum_sct(k) + &
                                     aerssalb(opt_index_v3(k))*arprod(k)
                        sum_g_omega_tau(k) = sum_g_omega_tau(k) +  &
                               aerasymm(opt_index_v3(k)) * &
                                  (aerssalb(opt_index_v3(k))*arprod(k))
                      end do
                    else  ! (using_im_bcsul)
                      do k = KSRAD,KERAD
                        arprod(k) = aerext(opt_index_v5(k)) *    &
                                   (1.e3 * Aerosol%aerosol(i,j,k,nsc))
                        arprod2(k) = aerssalb(opt_index_v5(k))*arprod(k)
                        asymm(k)   = aerasymm(opt_index_v5(k))
                        sum_ext(k) = sum_ext(k) + arprod(k)
                        sum_sct(k) = sum_sct(k) + &
                                     aerssalb(opt_index_v5(k))*arprod(k)
                        sum_g_omega_tau(k) = sum_g_omega_tau(k) +  &
                              aerasymm(opt_index_v5(k)) * &
                                 (aerssalb(opt_index_v5(k))*arprod(k))
                      end do
                    endif  !(using_im_bcsul)
                  else if (Aerosol_props%optical_index(nsc) == &
                                Aerosol_props%seasalt1_flag) then
                    do k = KSRAD,KERAD
                      arprod(k) = aerext(opt_index_v6(k)) *    &
                                   (1.e3 * Aerosol%aerosol(i,j,k,nsc))
                      arprod2(k) = aerssalb(opt_index_v6(k))*arprod(k)
                      asymm(k)   = aerasymm(opt_index_v6(k))
                      sum_ext(k) = sum_ext(k) + arprod(k)
                      sum_sct(k) = sum_sct(k) + &
                                     aerssalb(opt_index_v6(k))*arprod(k)
                      sum_g_omega_tau(k) = sum_g_omega_tau(k) +  &
                                aerasymm(opt_index_v6(k)) * &
                                  (aerssalb(opt_index_v6(k))*arprod(k))
                    end do
                  else if (Aerosol_props%optical_index(nsc) == &
                              Aerosol_props%seasalt2_flag) then
                    do k = KSRAD,KERAD
                      arprod(k) = aerext(opt_index_v7(k)) *    &
                                   (1.e3 * Aerosol%aerosol(i,j,k,nsc))
                      arprod2(k) = aerssalb(opt_index_v7(k))*arprod(k)
                      asymm(k)   = aerasymm(opt_index_v7(k))
                      sum_ext(k) = sum_ext(k) +  arprod(k)
                      sum_sct(k) = sum_sct(k) + &
                                     aerssalb(opt_index_v7(k))*arprod(k)
                      sum_g_omega_tau(k) = sum_g_omega_tau(k) + &
                               aerasymm(opt_index_v7(k)) * &
                                 (aerssalb(opt_index_v7(k))*arprod(k))
                    end do
                  else if (Aerosol_props%optical_index(nsc) == &
                               Aerosol_props%seasalt3_flag) then
                    do k = KSRAD,KERAD
                      arprod(k) = aerext(opt_index_v8(k)) *    &
                                   (1.e3 * Aerosol%aerosol(i,j,k,nsc))
                      arprod2(k) = aerssalb(opt_index_v8(k))*arprod(k)
                      asymm(k)   = aerasymm(opt_index_v8(k))
                      sum_ext(k) = sum_ext(k) + arprod(k)
                      sum_sct(k) = sum_sct(k) + &
                                     aerssalb(opt_index_v8(k))*arprod(k)
                      sum_g_omega_tau(k) = sum_g_omega_tau(k) +  &
                              aerasymm(opt_index_v8(k)) * &
                                  (aerssalb(opt_index_v8(k))*arprod(k))
                    end do
                  else if (Aerosol_props%optical_index(nsc) == &
                               Aerosol_props%seasalt4_flag) then
                    do k = KSRAD,KERAD
                      arprod(k) = aerext(opt_index_v9(k)) *    &
                                   (1.e3 * Aerosol%aerosol(i,j,k,nsc))
                      arprod2(k) = aerssalb(opt_index_v9(k))*arprod(k)
                      asymm(k)   = aerasymm(opt_index_v9(k))
                      sum_ext(k) = sum_ext(k) + arprod(k)
                      sum_sct(k) = sum_sct(k) + &
                                     aerssalb(opt_index_v9(k))*arprod(k)
                      sum_g_omega_tau(k) = sum_g_omega_tau(k) +  &
                                aerasymm(opt_index_v9(k))*  &
                                   (aerssalb(opt_index_v9(k))*arprod(k))
                    end do
                  else if (Aerosol_props%optical_index(nsc) == &
                             Aerosol_props%seasalt5_flag) then
                    do k = KSRAD,KERAD
                      arprod(k) = aerext(opt_index_v10(k)) *    &
                                   (1.e3 * Aerosol%aerosol(i,j,k,nsc))
                      arprod2(k) = aerssalb(opt_index_v10(k))*arprod(k)
                      asymm(k)   = aerasymm(opt_index_v10(k))
                      sum_ext(k) = sum_ext(k) + arprod(k)
                      sum_sct(k) = sum_sct(k) + &
                                    aerssalb(opt_index_v10(k))*arprod(k)
                      sum_g_omega_tau(k) = sum_g_omega_tau(k) +&
                              aerasymm(opt_index_v10(k)) * &
                                 (aerssalb(opt_index_v10(k))*arprod(k))
                    end do
                  endif

                  if (Sw_control%do_cmip_diagnostics) then
                    if (nband == Solar_spect%visible_band_indx) then
                      Aerosol_diags%extopdep(i,j,:,nsc,1) = arprod(:)
                      Aerosol_diags%absopdep(i,j,:,nsc,1) =    &
                                            arprod(:) - arprod2(:)
                      Aerosol_diags%asymdep(i,j,:,nsc,1) = asymm(:)
                    endif
                    if (nband == Solar_spect%eight70_band_indx) then
                      Aerosol_diags%extopdep(i,j,:,nsc,6) = arprod(:)
                      Aerosol_diags%absopdep(i,j,:,nsc,6) =    &
                                            arprod(:) - arprod2(:)
                      Aerosol_diags%asymdep(i,j,:,nsc,6) = asymm(:)
                    endif
                    if (nband == Solar_spect%one_micron_indx) then
                      Aerosol_diags%extopdep(i,j,:,nsc,2) = arprod(:)
                      Aerosol_diags%absopdep(i,j,:,nsc,2) =    &
                                               arprod(:) - arprod2(:)
                      Aerosol_diags%asymdep(i,j,:,nsc,2) = asymm(:)
                    endif
                    if (nband == Solar_spect%w340_band_indx) then
                      Aerosol_diags%extopdep(i,j,:,nsc,7) = arprod(:)
                      Aerosol_diags%absopdep(i,j,:,nsc,7) =    &
                                                arprod(:) - arprod2(:)
                      Aerosol_diags%asymdep(i,j,:,nsc,7) = asymm(:)
                    endif
                    if (nband == Solar_spect%w380_band_indx) then
                      Aerosol_diags%extopdep(i,j,:,nsc,8) = arprod(:)
                      Aerosol_diags%absopdep(i,j,:,nsc,8) =    &
                                                arprod(:) - arprod2(:)
                      Aerosol_diags%asymdep(i,j,:,nsc,8) = asymm(:)
                    endif
                    if (nband == Solar_spect%w440_band_indx) then
                      Aerosol_diags%extopdep(i,j,:,nsc,9) = arprod(:)
                      Aerosol_diags%absopdep(i,j,:,nsc,9) =    &
                                               arprod(:) - arprod2(:)
                      Aerosol_diags%asymdep(i,j,:,nsc,9) = asymm(:)
                    endif
                    if (nband == Solar_spect%w670_band_indx) then
                      Aerosol_diags%extopdep(i,j,:,nsc,10) = arprod(:)
                      Aerosol_diags%absopdep(i,j,:,nsc,10) =    &
                                                arprod(:) - arprod2(:)
                      Aerosol_diags%asymdep(i,j,:,nsc,10) = asymm(:)
                    endif
                  endif
                end do

!----------------------------------------------------------------------
!    add the effects of volcanic aerosols, if they are to be included.
!    include generation of diagnostics in the visible (0.55 micron) and
!    nir band (1.0 micron).
!----------------------------------------------------------------------
                if (including_volcanoes) then
                  do k = KSRAD,KERAD
                    sum_ext(k) = sum_ext(k) +    &
                                 Aerosol_props%sw_ext(i,j,k,nband)*  &
                                 deltaz(k)
                    sum_sct(k) = sum_sct(k) +    &
                                 Aerosol_props%sw_ssa(i,j,k,nband)*  &
                                 Aerosol_props%sw_ext(i,j,k,nband)*  &
                                 deltaz(k)
                    sum_g_omega_tau(k) =   &
                                 sum_g_omega_tau(k) +&
                                 Aerosol_props%sw_asy(i,j,k,nband)* &
                                 Aerosol_props%sw_ssa(i,j,k,nband)*  &
                                 Aerosol_props%sw_ext(i,j,k,nband)*  &
                                 deltaz(k)
                    if (Sw_control%do_cmip_diagnostics) then
                      if (nband == Solar_spect%visible_band_indx) then
                           Aerosol_diags%extopdep_vlcno(i,j,k,1) =   &
                                 Aerosol_props%sw_ext(i,j,k,nband)*  &
                                 deltaz(k)
                           Aerosol_diags%absopdep_vlcno(i,j,k,1) =   &
                            (1.0 - Aerosol_props%sw_ssa(i,j,k,nband))*&
                                Aerosol_props%sw_ext(i,j,k,nband)*  &
                                deltaz(k)
                      endif
                      if (nband == Solar_spect%eight70_band_indx) then
                           Aerosol_diags%extopdep_vlcno(i,j,k,3) =   &
                                 Aerosol_props%sw_ext(i,j,k,nband)*  &
                                 deltaz(k)
                           Aerosol_diags%absopdep_vlcno(i,j,k,3) =   &
                            (1.0 - Aerosol_props%sw_ssa(i,j,k,nband))*&
                                Aerosol_props%sw_ext(i,j,k,nband)*  &
                                deltaz(k)
                      endif
                      if (nband == Solar_spect%one_micron_indx) then
                           Aerosol_diags%extopdep_vlcno(i,j,k,2) =   &
                                 Aerosol_props%sw_ext(i,j,k,nband)*  &
                                 deltaz(k)
                           Aerosol_diags%absopdep_vlcno(i,j,k,2) =   &
                            (1.0 - Aerosol_props%sw_ssa(i,j,k,nband))*&
                                Aerosol_props%sw_ext(i,j,k,nband)*  &
                                deltaz(k)
                      endif
                    endif
                  end do
                endif   ! (including_volcanoes)
!
!----------------------------------------------------------------------
                do k = KSRAD,KERAD
                  aeroextopdep(i,j,k,nband) = sum_ext(k) 
                  aerosctopdep(i,j,k,nband) = sum_sct(k) 
                  aeroasymfac(i,j,k,nband) = sum_g_omega_tau(k) / &
                                                (sum_sct(k) + 1.0e-30 )
                end do
              else  ! (if not including_aerosols)
                do k = KSRAD,KERAD
                  aeroextopdep(i,j,k,nband) = 0.0                    
                  aerosctopdep(i,j,k,nband) = 0.0                  
                  aeroasymfac(i,j,k,nband) = 0.0                 
                end do
              endif ! (including_aerosols)
            end do ! (nband)
          endif  ! (daylight or cmip_diagnostics)

          if (including_volcanoes) then
            if (do_coupled_stratozone ) then
              nextinct = get_tracer_index(MODEL_ATMOS,'Extinction')
              if (nextinct  /= NO_TRACER) &
                    r(i,j,:,nextinct) = Aerosol_props%sw_ext(i,j,:,4)
            endif  
          endif  

        end do ! (i loop)
      end do   ! (j loop)

!---------------------------------------------------------------------
!

!---------------------------------------------------------------------


end subroutine compute_aerosol_optical_props

!#################################################################
! <SUBROUTINE NAME="compute_gas_props">
!  <OVERVIEW>
!   Subroutine that uses the delta-eddington technique in conjunction
!   with a multi-band parameterization for h2o+co2+o2+o3 absorption
!   in the solar spectrum to derive solar fluxes and heating rates.
!  </OVERVIEW>
!  <DESCRIPTION>
!    This subroutine calculates optical depth, single scattering albedo,
!    asymmetry parameter of a layer based on gaseous absorbers,
!    clouds, aerosols, and rayleigh scattering. It then uses delta-
!    eddington technique to calculate radiative flux at each layer. 
!    Doubling and adding technique is used to combine the layers
!    and calculate flux at TOA and surface and heating rate. This
!    subroutine allocates a substantial amount of memory and deallocates
!    the allocated memory at the end of the subroutine.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call comput(is, ie, js, je, Atmos_input, Surface, Rad_gases, Aerosol, 
!               Astro, &
!               Cldrad_props, Cld_spec, Sw_output)
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!    starting subdomain i indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="ie" TYPE="integer">
!    ending subdomain i indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="js" TYPE="integer">
!    starting subdomain j indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="je" TYPE="integer">
!    ending subdomain j indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
!    Atmos_input_type variable containing the atmospheric
!    input fields on the radiation grid 
!  </IN>
!  <IN NAME="Aerosol" TYPE="aerosol_type">
!   Aerosol input data for shortwave radiation calculation
!  </IN>
!  <IN NAME="Astro" TYPE="astronomy_type">
!    Astronomy_type variable containing the astronomical
!    input fields on the radiation grid  
!  </IN>
!  <IN NAME="Rad_gases" TYPE="radiative_gases_type">
!    Radiative_gases_type variable containing the radiative 
!    gas input fields on the radiation grid 
!  </IN>
!  <IN NAME="Cldrad_props" TYPE="cldrad_properties_type">
!    The cloud radiative property input fields on the
!    radiation grid
!  </IN>
!  <INOUT NAME="Sw_output" TYPE="sw_output_type">
!    The shortwave radiation calculation result
!  </INOUT>
!  <IN NAME="Surface" TYPE="surface_type">
!   Surface data as boundary condition to radiation
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!   Cloud specification data as initial condition to radiation
!  </IN>
! </SUBROUTINE>

subroutine compute_gas_props (Atmos_input, Rad_gases, Astro,   &
                              daylight, gasopdep)

!----------------------------------------------------------------------
!    comput uses the delta-eddington technique in conjunction with a    
!    multiple-band parameterization for h2o+co2+o2+o3 absorption to   
!    derive solar fluxes and heating rates.                             
!    notes: drops are assumed if temp>273.15K, ice crystals otherwise.
!-------------------------------------------------------------------

type(atmos_input_type),        intent(in)    :: Atmos_input
type(radiative_gases_type),    intent(in)    :: Rad_gases   
type(astronomy_type),          intent(in)    :: Astro
logical, dimension(:,:),       intent(in)    :: daylight
real, dimension(:,:,:,:,:),    intent(out)   :: gasopdep              


!-------------------------------------------------------------------
!  intent(in) variables:
!
!      Atmos_input    atmos_input_type structure, contains variables
!                     defining atmospheric state
!      Rad_gases      radiative_gases_type structure, contains var-
!                     iables defining the radiatively active gases, 
!                     passed through to lower level routines
!      Astro          astronomy_type structure
!                                                                 
!   intent(inout) variables:
!
!      Sw_output         shortwave radiation output data
!
!---------------------------------------------------------------------

!-----------------------------------------------------------------------
!     local variables:
 

      real, dimension (size(Atmos_input%temp,3)-1)  :: &
                   deltaz,     qo3,         rh2o,                    &
                   efftauo2,   efftauco2,   efftauch4,   efftaun2o, &
                   wh2ostr,    wo3,         wo2,         quenchfac, &
                   opdep,      delpdig,     deltap,      tco2,    &
                   tch4,       tn2o,        to2,         wh2o

           
      real, dimension (size(Atmos_input%temp,3))  :: &
            alphaco2,        alphaco2str,    alphao2,          &
            alphao2str,      alphach4,       alphach4str,      &
            alphan2o,        alphan2ostr,    scale,            &
            scalestr,        totco2,         totco2str,        &
            toto2,           toto2str,       totch4,           &
            totch4str,       totn2o,         totn2ostr,        &
            press,           pflux,          pflux_mks,        &
            temp,            z

      real :: cosangsolar
      real :: denom
      real :: wtquench
      real :: rrvco2 
      real :: rrvch4, rrvn2o

      integer  :: j, i, k, ng, nband, kq
      integer  :: np, nf
      integer  :: israd, jsrad, ierad, jerad, ksrad, kerad


!-----------------------------------------------------------------------
!     local variables:
!
!       aeramt
!       sum_g_omega_tau
!       opt_index_v3
!       irh
!    etc.
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!    define limits and dimensions 
!--------------------------------------------------------------------
      israd = 1
      jsrad = 1
      ksrad = 1
      ierad = size(Atmos_input%temp,1)
      jerad = size(Atmos_input%temp,2)
      kerad = size(Atmos_input%temp,3) - 1

!---------------------------------------------------------------------
!    initialize local variables.                                        
!------------------------------------------------------------------
      alphaco2   (1) = 0.0
      alphaco2str(1) = 0.0
      alphao2    (1) = 0.0
      alphao2str (1) = 0.0
      alphach4   (1) = 0.0
      alphach4str(1) = 0.0
      alphan2o   (1) = 0.0
      alphan2ostr(1) = 0.0

      rrvco2 = Rad_gases%rrvco2
      rrvch4 = Rad_gases%rrvch4
      rrvn2o = Rad_gases%rrvn2o

      do j = JSRAD,JERAD
        do i = ISRAD,IERAD
          if ( daylight(i,j) ) then

!---------------------------------------------------------------------
!  convert to cgs and then back to mks for consistency with previous 
!---------------------------------------------------------------------
            do k = KSRAD,KERAD+1
              press(k) = 0.1*(10.0*Atmos_input%press(i,j,k))
              pflux(k) =     (10.0*Atmos_input%pflux(i,j,k))
              temp (k) = Atmos_input%temp  (i,j,k)
            end do
            do k = KSRAD,KERAD
              rh2o  (k) = Atmos_input%rh2o  (i,j,k)
              qo3   (k) = Rad_gases%qo3(i,j,k)
              deltaz(k) = Atmos_input%deltaz(i,j,k)
            end do

!----------------------------------------------------------------------c
!    define pressure related quantities, pressure is in mks units. 
!----------------------------------------------------------------------c
            pflux_mks(:) = pflux(:)*1.0E-1

            do k = KSRAD+1,KERAD+1
              deltap(k-1) = pflux_mks(k) - pflux_mks(k-1)
              delpdig(k-1) = deltap(k-1)/ GRAV
              scalestr(k) = pflux_mks(k) 
              scale(k) = scalestr(k)*pflux_mks(k)/pstd_mks
            end do
 

            do k = KSRAD,KERAD
              wh2ostr(k) = rh2o(k)*delpdig(k)
              wo3(k)     = qo3(k)*delpdig(k)
              wo2(k) = o2mixrat*(WTMO2/WTMAIR)*delpdig(k)
            end do
  
!---------------------------------------------------------------------
!    if quenching factor effects are desired, calculate the height above
!    the surface of the model flux levels.
!---------------------------------------------------------------------
            if (do_quench) then
              z(KERAD+1) = 0.0
              do k = KERAD,KSRAD,-1
                z(k) = z(k+1) + deltaz(k)
              end do
          
!---------------------------------------------------------------------
!    define the quenching factor for each grid point.
!---------------------------------------------------------------------
              do k = KSRAD,KERAD
                if (z(k) < co2_quenchfac_height(1) ) then
                  quenchfac(k) = 1.0
                else if (z(k) > co2_quenchfac_height(30) ) then 
                  quenchfac(k) = 0.037
                else
                  do kq = 1,29
                    if (z(k) > co2_quenchfac_height(kq) .and. &
                        z(k) <= co2_quenchfac_height(kq+1)) then
                      wtquench = (z(k) - co2_quenchfac_height(kq))/ &
                                 (co2_quenchfac_height(kq+1) - &
                                  co2_quenchfac_height(kq))
                      quenchfac(k) = (1. - wtquench)*   &
                                           co2_quenchfac(kq) +   &
                                      wtquench*co2_quenchfac(kq+1)
                      exit
                    endif
                  end do
                endif
              end do
            else
              quenchfac(:) = 1.0
            endif !(do_quench)


            do ng = 1,NSOLWG
              cosangsolar  = Astro%cosz(i,j)
              if (cosangsolar == 0.0) cosangsolar = 1.0

!----------------------------------------------------------------------c
!    define the scaled and unscaled co2 and o2 pathlengths in 
!    centimeter-atm, and the unscaled h2o and o3 amounts in   
!    kgrams/meter**2. 
!    cm-atm needed as units because of c2co2 having those units.
!----------------------------------------------------------------------c
              denom = 1.0/(GRAV*rhoair*cosangsolar*2.0)
              do k = KSRAD+1,KERAD+1
                totco2(k) = 1.0E+02*rrvco2*scale(k)*denom       
                totco2str(k) = 2.0E+02*rrvco2*scalestr(k)*denom     
                toto2(k) = 1.0E+02*o2mixrat*scale(k)*denom      
                toto2str(k) = 2.0E+02*o2mixrat*scalestr(k)*denom      
                if (do_ch4_sw_effects) then
                  totch4(k) = 1.0E+02*rrvch4*scale(k)*denom     
                  totch4str(k) = 2.0E+02*rrvch4*scalestr(k)*denom     
                endif
                if (do_n2o_sw_effects) then
                  totn2o(k) = 1.0E+02*rrvn2o*scale(k)*denom     
                  totn2ostr(k) = 2.0E+02*rrvn2o*scalestr(k)*denom      
                endif
              end do

              np = 0
              do nband = 1, NBANDS

!-------------------------------------------------------------------
!    define the h2o scaled gas amounts in kgrams/meter**2            
!---------------------------------------------------------------------
                if (nband <= nh2obands) then
                  do k = KSRAD,KERAD
                    wh2o(k) = rh2o(k)*delpdig(k)*   &
                        exp(powph2o(nband)*alog(press(k)*p0h2o(nband)))
                  end do
 
!---------------------------------------------------------------------
!    calculate the "effective" co2, o2, ch4 and n2o gas optical depths 
!    for the appropriate absorbing bands.                               
!    note: for large zenith angles, alpha can exceed 1. In this case,a
!    the optical depths are set to the previous layer values.          
!-------------------------------------------------------------------
                  if ( c1co2(nband).ne.1.0E-99 ) then
                    do k = KSRAD+1,KERAD+1
                      if (totco2(k) < totco2max(nband) .and.  &
                          totco2str(k) < totco2strmax(nband))  then
                        alphaco2(k) =     &
                             c1co2(nband)*exp(c3co2(nband)* &
                                 alog((totco2(k) + c2co2(nband))))  -  &
                                                          c4co2(nband)
                        alphaco2str(k) = &
                          c1co2str(nband)*exp(c3co2str(nband)*  &
                            alog((totco2str(k) + c2co2str(nband)))) - &
                                                        c4co2str(nband)
                        tco2(k-1) =      &
                             (1.0 - alphaco2(k))*   &
                                            (1.0 - alphaco2str(k))/ &
                             ((1.0 - alphaco2(k-1))*    &
                                            (1.0 - alphaco2str(k-1)))
                        efftauco2(k-1) = -cosangsolar*alog( tco2(k-1))
                      else if (k > KSRAD+1) then
                        efftauco2(k-1) = efftauco2(k-2)
                      else
                        efftauco2(k-1) = 0.0
                      end if
                    end do
                  else    !( c1co2(nband).ne.1.0E-99 ) 
                    efftauco2(:) = 0.0
                  end if  !( c1co2(nband).ne.1.0E-99 ) 

                  if (do_ch4_sw_effects) then
                    if (c1ch4(nband).ne.1.0E-99 ) then
                      do k = KSRAD+1,KERAD+1
                        if (totch4(k) < totch4max(nband) .and.  &
                              totch4str(k) < totch4strmax(nband))  then
                           alphach4(k) =    &
                              c1ch4(nband)*exp(c3ch4(nband)*&
                              alog((totch4(k) + c2ch4(nband))))  -   &
                                                           c4ch4(nband)
                           alphach4str(k) = &
                            c1ch4str(nband)*exp(c3ch4str(nband)*  &
                            alog((totch4str(k) + c2ch4str(nband)))) - &
                                                        c4ch4str(nband)
                           tch4(k-1) = &
                                  (1.0 - alphach4(k))*    &
                                           (1.0 - alphach4str(k))/ &
                                   ((1.0 - alphach4(k-1))*   &
                                           (1.0 - alphach4str(k-1)))
                           efftauch4(k-1) = -cosangsolar*alog(tch4(k-1))
                         else if (k > KSRAD+1) then
                           efftauch4(k-1) = efftauch4(k-2)
                         else
                           efftauch4(k-1) = 0.0
                         end if
                       end do
                     else    !( c1ch4(nband).ne.1.0E-99 )
                       efftauch4(:) = 0.0
                     end if  !( c1ch4(nband).ne.1.0E-99 )
                   else    !do_ch4 = .false.
                     efftauch4(:) = 0.0
                   end if

                   if (do_n2o_sw_effects) then
                     if ( c1n2o(nband).ne.1.0E-99 ) then
                       do k = KSRAD+1,KERAD+1
                         if (totn2o(k) < totn2omax(nband) .and.  &
                              totn2ostr(k) < totn2ostrmax(nband)) then
                           alphan2o(k) = &
                                c1n2o(nband)*exp(c3n2o(nband)* &
                                   alog((totn2o(k) +c2n2o(nband)))) -  &
                                                          c4n2o(nband)
                           alphan2ostr(k) = &
                            c1n2ostr(nband)*exp(c3n2ostr(nband)*  &
                            alog((totn2ostr(k) + c2n2ostr(nband)))) -  &
                                                       c4n2ostr(nband)
                           tn2o(k-1) = &
                                    (1.0 - alphan2o(k)) *  &
                                              (1.0 - alphan2ostr(k))/ &
                                    (( 1.0 - alphan2o(k-1)) *  &
                                            (1.0 - alphan2ostr(k-1)))
                           efftaun2o(k-1) = -cosangsolar*alog(tn2o(k-1))
                         else if (k > KSRAD+1) then
                           efftaun2o(k-1) = efftaun2o(k-2)
                         else
                           efftaun2o(k-1) = 0.0
                         end if
                       end do
                     else    !( c1n2o(nband).ne.1.0E-99 )
                       efftaun2o(:) = 0.0
                     end if  !( c1n2o(nband).ne.1.0E-99 )
                   else  !do_n2o = .false.
                     efftaun2o(:) = 0.0
                   end if

                  if ( c1o2(nband).ne.1.0E-99 ) then
                    do k = KSRAD+1,KERAD+1
                      if (toto2(k) .lt. toto2max(nband) .and.   &
                          toto2str(k) .lt. toto2strmax(nband)) then
                        alphao2(k) = c1o2(nband)*exp( c3o2(nband)* &
                                     alog((toto2(k) + c2o2(nband)))) - &
                                                            c4o2(nband)
                        alphao2str( k) = &
                            c1o2str(nband)*exp(c3o2str(nband)*  &
                                alog((toto2str(k) + c2o2str(nband)))) &
                                                        - c4o2str(nband)
                        to2(k-1) = &
                               (1.0 - alphao2(k))*  &
                                    (1.0 - alphao2str(k) )/ &
                                ((1.0 - alphao2(k-1)) *  &
                                            (1.0 - alphao2str(k-1)))
                        efftauo2(k-1) = -cosangsolar*alog(to2(k-1))
                      else if (k.gt.KSRAD+1) then
                        efftauo2(k-1) = efftauo2(k-2)
                      else
                        efftauo2(k-1) = 0.0
                      end if
                    end do
                  else   !  ( c1o2(nband).ne.1.0E-99 ) 
                    efftauo2(:) = 0.0
                  end if  !  ( c1o2(nband).ne.1.0E-99 ) 
                end if  ! (nband <= nh2obands)
 
!---------------------------------------------------------------------
!    calculate the "effective" o2 gas optical depths for the Schuman- 
!    Runge band.                                                        
!-------------------------------------------------------------------
                if ( nband.EQ.NBANDS ) then
                  do k = KSRAD+1,KERAD+1
                    if ( toto2str(k).lt.toto2strmaxschrun) then
                      alphao2str(k) =  &
                           c1o2strschrun*exp( c3o2strschrun*&
                              alog((toto2str(k) + c2o2strschrun))) - &
                                                       c4o2strschrun
                      to2(k-1) = &
                          (1.0 - alphao2str(k))/(1.0 - alphao2str(k-1)) 
                      efftauo2(k-1) =  -cosangsolar*alog(to2(k-1) )
                      if (do_herzberg) then
                        efftauo2(k-1) = efftauo2(k-1) +     &
                                                 wo2(k-1)*herzberg_fac
                      endif
                    else if (k.gt.KSRAD+1) then
                      efftauo2(k-1) = efftauo2(k-2)
                    else
                      efftauo2(k-1) = 0.0
                    end if
                  end do
                end if

                do nf =1,nfreqpts(nband)
                  np = np + 1

!---------------------------------------------------------------------
!    define the h2o + o3 gas optical depths.                           
!--------------------------------------------------------------------
                  if (strterm(np)) then
                    opdep(:) = kh2o(np)*wh2ostr(:) + ko3(np)*wo3(:)
                  else
                    opdep(:) = kh2o(np)*wh2o(:) + ko3(np)*wo3(:)
                  end if

                  gasopdep(i,j,:,np,ng) =    &
                           opdep(:) + quenchfac(:)*efftauco2(:) +   &
                              efftauo2(:) + efftauch4(:) + efftaun2o(:)

                end do  ! (nf loop)
              end do   ! (nband loop)
            end do  ! (ng loop)
          endif  ! (daylight)
        end do ! (i loop)
      end do ! (j loop)

!---------------------------------------------------------------------



end subroutine compute_gas_props


!#####################################################################
!<SUBROUTINE NAME="adding">
! <OVERVIEW>
!  Subroutine that implements doubling and adding technique to combine
!  multiple atmospheric layers to calculate solar fluxes
! </OVERVIEW>
! <DESCRIPTION>
!  This subroutine implements the standard doubling and adding
!  technique to combine reflectance and transmittance of multiple 
!  atmospheric layers to compute solar flux and heating rate.
! </DESCRIPTION>
! <TEMPLATE>
!  call adding ( ix, jx, kx, &
!                rlayerdir, tlayerdir, rlayerdif, tlayerdif,  &
!                tlayerde, sfcalb, calc_flag, reflectance,   &
!                transmittance)
! </TEMPLATE>
! <IN NAME="ix" TYPE="integer">
!  ix is the current longitudinal index in the physics cell being
!  integrated.
! </IN>
! <IN NAME="jx" TYPE="integer">
!  jx is the current latitudinal index in the physics cell being
!  integrated.
! </IN>
! <IN NAME="kx" TYPE="integer">
!  ix is the current vertical index in the physics cell being
!  integrated.
! </IN>
! <IN NAME="rlayerdir" TYPE="real">
!  layer reflectivity to direct incident beam
! </IN>
! <IN NAME="tlayerdir" TYPE="real">
!  layer transmissivity to direct incident beam
! </IN>
! <IN NAME="rlayerdif" TYPE="real">
!  layer reflectivity to diffuse incident beam
! </IN>
! <IN NAME="tlayerdir" TYPE="real">
!  layer transmissivity to diffuse incident beam
! </IN>
! <IN NAME="tlayerde" TYPE="real">
!  layer diffuse transmissivity to direct incident beam
! </IN>
! <IN NAME="sfcalb" TYPE="real">
!  surface albedo
! </IN>
! <IN NAME="calcflag" TYPE="integer">
!  flag to indicate columns where adding is to be done
! </IN>
! <OUT NAME="reflectance" TYPE="real">
!  diffuse reflectance at a level
! </OUT>
! <OUT NAME="transmittance" TYPE="real">
!  diffuse transmittance at a level
! </OUT>
!</SUBROUTINE>
!

subroutine adding (ix, jx, kx, rlayerdir, tlayerdir, rlayerdif,   &
                   tlayerdif, tlayerde, sfcalb_dir, sfcalb_dif,  &
                   calc_flag, reflectance, transmittance, tr_dir)
 
!-------------------------------------------------------------------
!    adding calculates the reflection and transmission at flux levels 
!    from the direct and diffuse values of reflection and transmission
!    in the corresponding layers using the adding method.           
!    references:                                                        
!    bowen, m.m., and v. ramaswamy, effects of changes in radiatively
!        active species upon the lower stratospheric temperatures.,    
!        j. geophys. res., 18909-18921, 1994.                         
!--------------------------------------------------------------------

integer, intent(in)                    :: ix, jx, kx
real, dimension(:,:,:),   intent(in)   :: rlayerdir, rlayerdif, &
                                          tlayerdir, tlayerdif, & 
                                          tlayerde
real, dimension (:,:),    intent(in)   :: sfcalb_dir, sfcalb_dif
logical, dimension (:,:), intent(in)   :: calc_flag
real, dimension(:,:,:),   intent(out)  :: reflectance, transmittance, &
                                          tr_dir

!-------------------------------------------------------------------
!  intent(in) variables:
!
!    ix,jx,kx        dimensions of current physics window            
!    rlayerdir       layer reflectivity to a direct incident beam      
!    tlayerdir       layer transmissivity to a direct incident beam   
!    rlayerdif       layer reflectivity to a diffuse incident beam  
!    tlayerdif       layer transmissivity to a diffuse incident beam  
!    tlayerde        layer transmissivity (non-scattered) to the direct 
!                    incident beam                                 
!    sfcalb_dir      surface albedo, direct beam 
!    sfcalb_dif      surface albedo, diffuse beam
!    calc_flag       flag to indicate columns where adding is to be 
!                    done. calculations not done in "dark" columns and 
!                    on clr sky pass in columns without any clouds.
!
!  intent(out) variables:
!
!    reflectance     reflectance of the scattered radiation at a level 
!    transmittance   transmittance of the scattered radiation at a level
!    tr_dir
!
!-------------------------------------------------------------------

!-------------------------------------------------------------------
!   local variables:
 
      real, dimension (lbound(rlayerdir,3):ubound(rlayerdir,3)+1) ::  &
                            raddupdif2, raddupdir2

      real, dimension (lbound(rlayerdir,3):ubound(rlayerdir,3)  ) ::  &
                                      radddowndif2,  tadddowndir2

      real :: dm1tl2, dm2tl2, rdm2tl2, dm32, dm3r2, dm3r1p2, alpp2, &
              raddupdif2p, raddupdir2p, tlevel2p, radddowndifm, &
              tadddowndirm
      integer     ::  k, j, i

!-------------------------------------------------------------------
!   local variables:
!
!      raddupdif2
!      raddupdir2
!      tlevel2
!      radddowndif2
!      tadddowndir2
!      tlayerdif2
!      tlayerdir2
!      rlayerdif2
!      rlayerdir2
!      tlayerde2
!      dm1tl2
!      dm2tl2
!      rdm2tl2
!      dm32
!      dm3r2
!      dm3r1p2
!      alpp2
!      raddupdif2
!      raddupdir2p
!      tlevel2p
!      radddowndifm
!      tadddowndirm
!      i,j,k
!
!--------------------------------------------------------------------

!----------------------------------------------------------------------c
!    initialization for the surface layer.                           
!----------------------------------------------------------------------c
      do j=1,jx        
        do i=1,ix
          if (calc_flag(i,j) ) then
 
!------------------------------------------------------------------ 
!    add the inhomogeneous layers upward from the surface to the top of
!    the atmosphere.                                                  
!    radiation incident from above for diffuse beam, reflection of  
!    direct beam and conversion to diffuse.                           
!--------------------------------------------------------------------
            raddupdif2p = sfcalb_dif(i,j)
            raddupdir2p = sfcalb_dir(i,j)
            do k = kx, 1,-1
              dm2tl2    = tlayerdif(i,j,k)/(1.0 - rlayerdif(i,j,k)*  &
                          raddupdif2p )
              rdm2tl2    = dm2tl2*raddupdif2p     
              raddupdif2(k) = rlayerdif(i,j,k) + tlayerdif(i,j,k)*   &
                              rdm2tl2    
              raddupdir2(k) = rlayerdir(i,j,k) + tlayerde(i,j,k)*   &
                              raddupdir2p* dm2tl2 +   &     
                              (tlayerdir(i,j,k) - tlayerde(i,j,k))*  &
                              rdm2tl2   
              raddupdir2p = raddupdir2(k)
              raddupdif2p = raddupdif2(k)
            end do
 
!---------------------------------------------------------------------
!    define the direct transmittance. add the inhomogeneous layers 
!    downward from the second layer to the surface. radiation incident
!    from below for diffuse beam, transmission of direct beam and 
!    conversion to diffuse.                             
!-------------------------------------------------------------------
 
!--------------------------------------------------------------------
!    initialization for the first scattering layer.                   
!-------------------------------------------------------------------
            tlevel2p         = tlayerde(i,j,1)
            radddowndifm    =  rlayerdif(i,j,1)
            tadddowndirm    =  tlayerdir(i,j,1)
            do k= 2,kx    
              dm1tl2 = tlayerdif(i,j,k)/(1.0 - rlayerdif(i,j,k)*  &
                       radddowndifm)
              radddowndif2(k) = rlayerdif(i,j,k) + radddowndifm* &
                                tlayerdif(i,j,k)*dm1tl2      
              tadddowndir2(k) = tlevel2p*(tlayerdir(i,j,k) + &
                                rlayerdir(i,j,k)*radddowndifm* &
                                dm1tl2) + (tadddowndirm -  &
                                tlevel2p)*dm1tl2           

!---------------------------------------------------------------------
!    add downward to calculate the resultant reflectances and           
!    transmittances at flux levels.                                    
!------------------------------------------------------------------
              dm32  = 1.0/(1.0 - raddupdif2(k)*radddowndifm)
              dm3r2 = dm32*radddowndifm      
              dm3r1p2 = 1.0 + raddupdif2(k)*dm3r2   
              alpp2 = (tadddowndirm - tlevel2p)*dm32   
              transmittance(i,j,k) = (tlevel2p*(1.0 + raddupdir2(k)* &
                                      dm3r2) + alpp2)
              tr_dir(i,j,k) = tlevel2p
              reflectance(i,j,k) = (tlevel2p*raddupdir2(k)*   &
                                    dm3r1p2 + alpp2*   &
                                    raddupdif2(k))
              tlevel2p = tlevel2p*tlayerde (i,j,k) 
              radddowndifm = radddowndif2(k)
              tadddowndirm = tadddowndir2(k)
            end do
!! CORRECT ???
!           dm32  = 1.0/(1.0 - sfcalb(i,j)*radddowndifm)
            dm32          = 1.0/(1.0 - sfcalb_dif(i,j)*   &
                               radddowndifm       )
            dm3r2 = dm32*radddowndifm       
!! CORRECT ???
!           dm3r1p2 = 1.0 + sfcalb(i,j)*dm3r2         
            dm3r1p2          = 1.0 + sfcalb_dif(i,j) * dm3r2
            alpp2 = (tadddowndirm - tlevel2p)*dm32          
            transmittance(i,j,kx+1) = (tlevel2p*(1.0 +   &
!! CORRECT ???
!                                      sfcalb(i,j)* &
!12-08-03:  CHANGE THIS TO _dir as per SMF  sfcalb_dif(i,j)* &
                                       sfcalb_dir(i,j)* &
                                       dm3r2) + alpp2)
            tr_dir(i,j,kx+1) = tlevel2p
            reflectance(i,j,kx+1) = (tlevel2p*  &
!! CORRECT ???
!                                   sfcalb(i,j)*   &
                                    sfcalb_dir(i,j)* &
                                     dm3r1p2 + alpp2* &
!! CORRECT ???
!                                sfcalb(i,j) )
                                    sfcalb_dif(i,j))  
            reflectance(i,j,1) = raddupdir2p         
            transmittance(i,j,1) = 1.0
            tr_dir(i,j,1) = 1.0
          endif
        end do
      end do

!------------------------------------------------------------------


end subroutine adding 



!####################################################################
! <SUBROUTINE NAME="deledd">
!  <OVERVIEW>
!   Subroutine that calculates reflectivity and transmissivity in a
!   scattering layer using delta-eddington method
!  </OVERVIEW>
!  <DESCRIPTION>
!   This subroutine takes layer optical depth, single scattering abledo,
!   and asymmetry parameter, using delta-eddington method, to calculate
!   direct/diffuse reflectivity/transmissivity to direct/diffuse incident
!   radiation. The approximation uses the strong forward scattering of
!   aerosol particles.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call deledd (ix, jx, kx,  &
!                taustr, omegastr, gstr, cosang, ng , daylight,  &
!                rlayerdir, tlayerdir, rlayerdif, tlayerdif,   &
!                tlayerde,  cloud)
!  </TEMPLATE>
!  <IN NAME="ix" TYPE="integer">
!  ix is the current longitudinal index in the physics cell being
!  integrated.
!  </IN>
!  <IN NAME="jx" TYPE="integer">
!   jx is the current latitudinal index in the physics cell being
!   integrated.
!  </IN>
!  <IN NAME="kx" TYPE="integer">
!   ix is the current vertical index in the physics cell being
!   integrated.
!  </IN>
!  <IN NAME="taustr" TYPE="real">
!   the scaled optical depth, true optical depth normalized using
!   delta-eddington approximation
!  </IN>
!  <IN NAME="omegastr" TYPE="real">
!   the scaled single-scattering albedo
!  </IN>
!  <IN NAME="gstr" TYPE="real">
!   the scaled asymmetry factor
!  </IN>
!  <IN NAME="cosang" TYPE="real">
!   cosine of the solar zenith angle
!  </IN>
!  <IN NAME="ng" TYPE="real">
!   the number of gaussian angles to compute the diurnally    
!   averaged solar radiation (=1 unless lswg = true)
!  </IN>
!  <IN NAME="cloud" TYPE="real">
!   flag for existence of a cloud (used only in 'ovc' mode)
!  </IN>
!  <OUT NAME="rlayerdir" TYPE="real">
!   layer reflectivity to direct incident beam
!  </OUT>
!  <OUT NAME="tlayerdir" TYPE="real">
!   layer transmissivity to direct incident beam
!  </OUT>
!  <OUT NAME="rlayerdif" TYPE="real">
!   layer reflectivity to diffuse incident beam
!  </OUT>
!  <OUT NAME="tlayerdir" TYPE="real">
!   layer transmissivity to diffuse incident beam
!  </OUT>
!  <OUT NAME="tlayerde" TYPE="real">
!   layer diffuse transmissivity to direct incident beam
!  </OUT>
! </SUBROUTINE>
!
subroutine deledd (ix, jx, kx, taustr, omegastr, gstr, cosang, ng, &
                   daylight, rlayerdir, tlayerdir, tlayerde,   &
                   rlayerdif, tlayerdif, cloud)
 
!---------------------------------------------------------------------- 
!    deledd calculates the reflection and transmission in the 
!    scattering layers using the delta-eddington method.         
!    references:                                                   
!      joseph, j.h., w. wiscombe, and j.a. weinman, the delta-eddington
!      approximation for radiative flux transfer.,j. atmos. sci.,33,  
!      2452-2459, 1976.                                              
!-------------------------------------------------------------------

integer,                   intent(in)              :: ix, jx, kx
real, dimension(:,:,:),    intent(inout)           :: taustr, omegastr
real, dimension(:,:,:),    intent(in)              :: gstr
real, dimension(:,:),    intent(in)                ::  cosang
integer,                   intent(in)              :: ng
logical, dimension(:,:),   intent(in)              :: daylight
real, dimension(:,:,:),    intent(out)             :: rlayerdir,   &
                                                      tlayerdir,   &
                                                      tlayerde
real, dimension(:,:,:),    intent(inout), optional :: rlayerdif,   &
                                                      tlayerdif
logical, dimension(:,:,:), intent(in), optional    :: cloud          

!----------------------------------------------------------------------
!  intent(in) variables:
!
!    ix,jx,kx
!    gstr        the scaled asymmetry factor                       
!    cosang      the cosine of the solar zenith angle    
!    ng          the number of gaussian angles to compute the diurnally 
!                averaged solar radiation (=1 unless lswg = true)       
!    daylight
!
!  intent(inout) variables:
!
!    taustr      the scaled extinction optical depth                    
!    omegastr    the scaled single-scattering albedo               
!
!  intent(out) variables:
!
!    rlayerdir   the layer reflectivity to a direct incident beam      
!    tlayerdir   the layer transmissivity to a direct incident beam   
!    rlayerdif   the layer reflectivity to a diffuse incident beam   
!    tlayerdif   the layer transmissivity to a diffuse incident beam
!    tlayerde    the layer transmissivity (non-scattered) to the direct 
!                incident beam                                       
!
! intent(in),optional:
!
!    cloud       flag for existence of a cloud (used only in 'ovc' mode)
!
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!  local variables:

      real        :: qq(7), rr(5), ss(8), tt(8), ww(4)
      real        :: rsum, tsum
      real        :: onedi3 = 1.0/3.0           
      real        :: twodi3 = 2.0/3.0             
      integer     :: k, i, ns, j, nn, ntot

      integer, dimension(ix, jx, kx) :: cld_index

      real,    dimension(ix)                  ::   &
                                          gstr2, taustr2, omegastr2, &
                                           cosangzk2, rlayerdir2,    &
                                           tlayerde2, tlayerdir2, &
                                           sumr, sumt


!----------------------------------------------------------------------
!  local variables:
!
!      qq
!      rr
!      ss
!      tt
!      ww
!      rsum
!      tsum
!      alpha
!      onedi3
!      twodi3
!      i,j,k
!      ns
!      nn
!      ntot
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      do k=1,kx         
        do j=1,jx         

!---------------------------------------------------------------------
!    overcast sky mode. note: in this mode, the delta-eddington method
!    is performed only for spatial points containing a cloud.   
!-------------------------------------------------------------------
          nn = 0
          if (present(cloud)) then
            do i=1,ix          
              if (cloud(i,j,k) ) then
                nn = nn + 1
                cld_index(i,j,k) = nn
                gstr2(nn) = gstr(i,j,k)
                taustr2(nn) = taustr(i,j,k)
                omegastr2(nn) = omegastr(i,j,k)
                cosangzk2(nn) = cosang(i,j)

!----------------------------------------------------------------------
!    note: the following are done to avoid the conservative scattering 
!    case, and to eliminate floating point errors in the exponential 
!    calculations, respectively.                      
!----------------------------------------------------------------------c
                if (omegastr2(nn) >= 1.0) omegastr2(nn) = 9.9999999E-01
                if (taustr2(nn) >= 1.0E+02) taustr2(nn) = 1.0E+02
              endif
            end do

!----------------------------------------------------------------------c
!    clear sky mode. note: in this mode, the delta-eddington method is 
!    performed for all spatial points.                 
!----------------------------------------------------------------------c
          else
            do i=1,ix         
              if (daylight(i,j) ) then
                nn = nn + 1
                cld_index(i,j,k) = nn
                gstr2(nn) = gstr(i,j,k)
                taustr2(nn) = taustr(i,j,k)
                omegastr2(nn) = omegastr(i,j,k)
                cosangzk2(nn) = cosang(i,j   )

!----------------------------------------------------------------------c
!    note: the following are done to avoid the conservative scattering  
!    case, and to eliminate floating point errors in the exponential 
!    calculations, respectively.                    
!----------------------------------------------------------------------c
                if (omegastr2(nn) >= 1.0) omegastr2(nn) = 9.9999999E-01
                if (taustr2(nn) >= 1.0E+02) taustr2(nn) = 1.0E+02
              endif
            end do
          endif

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
          ntot = nn

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
          do nn=1,ntot      

!----------------------------------------------------------------------c
!    direct quantities                                            
!----------------------------------------------------------------------c
            ww(1) = omegastr2(nn)
            ww(2) = gstr2(nn)
            ww(3) = taustr2(nn)
            ww(4) = cosangzk2(nn)

            qq(1)     = 3.0 * ( 1.0 - ww(1) )
            qq(2)         = 1.0 - ww(1) * ww(2)
            qq(3)     = qq(1)/qq(2)
            qq(4) = sqrt( qq(1) * qq(2) )
            qq(5) = sqrt (qq(3))
            qq(6) = 1.0 + twodi3 * qq(5)         
            qq(7) = 1.0 - twodi3 * qq(5)       

            rr(1) = 1./qq(6)
            rr(2) = qq(7)*rr(1)
            rr(3) = exp( -ww(3)          * qq(4) )
            rr(4) = 1.0/rr(3)
            rr(5) = 1.0/(qq(6) * rr(4) - qq(7) * rr(3) * rr(2) )

            ss(1) = 0.75 * ww(1)/(1.0 - (qq(4)*ww(4)      ) ** 2 )
            ss(2) = ss(1)*ww(4)*( 1.0 + ww(2)*qq(1)*onedi3)
            ss(3) = ss(1)*(1.0 + ww(2)*qq(1)*ww(4)** 2 )
            ss(4) = ss(2) - twodi3*ss(3)     
            ss(5) = ss(2) + twodi3 * ss(3)     
            ss(6) = exp( -ww(3)          / ww(4) )
            ss(7) = (ss(4)*ss(6) - ss(5)*rr(3)*rr(2))*rr(5)
            ss(8) = (ss(5) - qq(7)*ss(7))*rr(1)

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
            rlayerdir2(nn) = qq(7) * ss(8) + qq(6)*ss(7) - ss(4)
            tlayerdir2(nn) = ((rr(3) * qq(6) * ss(8) + &
                               qq(7) * rr(4) * ss(7) -  &
                               ss(5) * ss(6) ) + ss(6) )
            tlayerde2(nn) = ss(6)

!----------------------------------------------------------------------c
!    diffuse quantities                                       
!    notes: the number of streams for the diffuse beam is fixed at 4.   
!    this calculation is done only for ng=1.                 
!----------------------------------------------------------------------c
            if (present (tlayerdif) .and. present(rlayerdif)) then
              if ( ng.eq.1 ) then   
                rsum = 0.0
                tsum = 0.0
                do ns = 1,NSTREAMS
                  tt(1) = 0.75 * ww(1)            / ( 1.0 - ( qq(4) * &
                          cosangstr(ns) ) ** 2 )
                  tt(2) = tt(1) * cosangstr(ns) * ( 1.0 +  &
                          ww(2)        * qq(1) * onedi3 )
                  tt(3) = tt(1) * ( 1.0 + ww(2)        * qq(1)*&
                          cosangstr(ns) ** 2 )
                  tt(4) = tt(2) - twodi3 * tt(3)
                  tt(5) = tt(2) + twodi3 * tt(3)
                  tt(6) = exp( -ww(3)          / cosangstr(ns) )
                  tt(7) = ( tt(4) * tt(6) - tt(5) *  &
                          rr(3) * rr(2)   ) * rr(5)
                  tt(8) = ( tt(5) - qq(7) * tt(7) )*rr(1)
                  if (nstr4) then
                    rsum = rsum + (qq(7)*tt(8) + qq(6)*tt(7) - tt(4))* &
                           wtstr(ns)*cosangstr(ns)
                    tsum = tsum + ((rr(3)*qq(6)*tt(8) +   &
                                    qq(7)*rr(4)*tt(7) -   &
                                    tt(5)*tt(6)) + tt(6))*  &
                                    wtstr(ns)*cosangstr(ns)
                  else 
                    rsum = rsum + (qq(7)*tt(8) + qq(6)*tt(7) - tt(4))
                    tsum = tsum + ( (rr(3)*qq(6)*tt(8) +    &
                                     qq(7)*rr(4)*tt(7) -   &
                                     tt(5)*tt(6)) + tt(6))
                  endif
                end do
                sumr(nn) = rsum
                sumt(nn) = tsum
              endif  !  ng == 1
            endif ! (present (tlayerdiff))
          end do  ! ntot loop

!---------------------------------------------------------------------
!     return results in proper locations in (i,j,k) arrays
!---------------------------------------------------------------------
          if (present(cloud)) then
            do i=1,ix           
              if (cloud(i,j,k) ) then
                rlayerdir(i,j,k) = rlayerdir2(cld_index(i,j,k))
                tlayerdir(i,j,k) = tlayerdir2(cld_index(i,j,k))
                tlayerde(i,j,k) = tlayerde2(cld_index(i,j,k))
                if (present(tlayerdif)) then
                  if (ng .eq. 1) then
                    rlayerdif(i,j,k) = sumr(cld_index(i,j,k))
                    tlayerdif(i,j,k) = sumt(cld_index(i,j,k))
                  endif
                endif
              endif
            end do

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
          else
            do i=1,ix            
              if (daylight(i,j) ) then
                rlayerdir(i,j,k) = rlayerdir2(cld_index(i,j,k))
                tlayerdir(i,j,k) = tlayerdir2(cld_index(i,j,k))
                tlayerde(i,j,k) = tlayerde2(cld_index(i,j,k))
                if (present(tlayerdif)) then
                  if (ng .eq. 1) then
                    rlayerdif(i,j,k) = sumr(cld_index(i,j,k))
                    tlayerdif(i,j,k) = sumt(cld_index(i,j,k))
                  endif
                endif
              endif
            end do
          endif
        end do
      end do

!---------------------------------------------------------------------
 
end subroutine deledd



!#####################################################################


                   end module esfsw_driver_mod

module moist_conv_mod

!-----------------------------------------------------------------------

 use           mpp_mod, only : mpp_pe,             &
                               mpp_root_pe,        &
                               stdlog
use   time_manager_mod, only : time_type
 use   Diag_Manager_Mod, ONLY: register_diag_field, send_data
use  sat_vapor_pres_mod, ONLY: lookup_es_des, compute_qs, descomp
use mpp_mod,             only: input_nml_file
use             fms_mod, ONLY:  error_mesg, file_exist, open_namelist_file,  &
                                check_nml_error, close_file,        &
                                FATAL, WARNING, NOTE, mpp_pe, mpp_root_pe, &
                                write_version_number, stdlog
use       constants_mod, ONLY: HLv, HLs, cp_air, grav, rdgas, rvgas

use           fms_mod, only : write_version_number, ERROR_MESG, FATAL
use field_manager_mod, only : MODEL_ATMOS
use tracer_manager_mod, only : get_tracer_index,   &
                               get_number_tracers, &
                               get_tracer_names,   &
                               get_tracer_indices, &
                               query_method,       &
                               NO_TRACER

implicit none
private

!------- interfaces in this module ------------

public :: moist_conv, moist_conv_Init, moist_conv_end

!-----------------------------------------------------------------------
!---- namelist ----

 real :: HC   = 1.00
 real :: beta = 0.0
 real :: TOLmin=.02, TOLmax=.10
 integer :: ITSMOD=30
 logical :: do_simple =.false.

!----- note beta is the fraction of convective condensation that is
!----- detrained into a stratiform cloud

 namelist /moist_conv_nml/  HC, beta, TOLmin, TOLmax, ITSMOD, do_simple

!-----------------------------------------------------------------------
!---- VERSION NUMBER -----

 character(len=128) :: version = '$Id: moist_conv.F90,v 19.0 2012/01/06 20:10:09 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'
 logical            :: module_is_initialized = .false.

!---------- initialize constants used by this module -------------------

 real, parameter :: d622 = rdgas/rvgas
 real, parameter :: d378 = 1.0-d622
 real, parameter :: grav_inv = 1.0/grav
 real, parameter :: rocp = rdgas/cp_air

real :: missing_value = -999.
integer :: nsphum, nql, nqi, nqa   ! tracer indices for stratiform clouds

integer :: id_tdt_conv, id_qdt_conv, id_prec_conv, id_snow_conv, &
           id_qldt_conv,   id_qidt_conv,   id_qadt_conv, &
           id_ql_conv_col, id_qi_conv_col, id_qa_conv_col,&
           id_q_conv_col, id_t_conv_col

character(len=3) :: mod_name = 'mca'

logical :: do_mca_tracer = .false.
integer :: num_mca_tracers = 0
integer               :: num_tracers
integer, allocatable, dimension(:) :: id_tracer_conv, id_tracer_conv_col

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

CONTAINS

!#######################################################################

 subroutine moist_conv ( Tin, Qin, Pfull, Phalf, coldT,        & ! required
                         Tdel, Qdel, Rain, Snow,               & ! required
                         dtinv, Time, is, js, tracers, qtrmca, & ! required
                         Lbot, mask, Conv,                     & ! optional
                         ql, qi, cf, qldel, qidel, cfdel)        ! optional

!-----------------------------------------------------------------------
!
!                       MOIST CONVECTIVE ADJUSTMENT
!
!-----------------------------------------------------------------------
!
!   INPUT:   Tin     temperature at full model levels
!            Qin     specific humidity of water vapor at full
!                      model levels
!            Pfull   pressure at full model levels
!            Phalf   pressure at half model levels
!            coldT   Should MCA produce snow in this column?
!
!   OUTPUT:  Tdel    temperature adjustment at full model levels (deg k)
!            Qdel    specific humidity adjustment of water vapor at
!                       full model levels
!            Rain    liquid precipitiation (in Kg m-2)
!            Snow    ice phase precipitation (kg m-2)
!  OPTIONAL
!
!   INPUT:   Lbot    integer index of the lowest model level,
!                      Lbot is always <= size(Tin,3)
!              ql    liquid water condensate
!              qi    ice condensate
!              cf    stratiform cloud fraction (used only when
!                    operating with stratiform cloud scheme) (fraction)
!
!  OUTPUT:   Conv    logical flag; TRUE then moist convective
!                       adjustment was performed at that model level.
!            cfdel   change in stratiform cloud fraction (fraction)
!            qldel   change in liquid water condensate due to
!                    convective detrainment (kg condensate /kg air)
!            qidel   change in ice condensate due to
!                    convective detrainment (kg condensate /kg air)
!
!-----------------------------------------------------------------------
!----------------------PUBLIC INTERFACE ARRAYS--------------------------
    real, intent(INOUT), dimension(:,:,:)           :: Tin, Qin
    real, intent(IN) ,   dimension(:,:,:)           :: Pfull, Phalf 
 logical, intent(IN) ,   dimension(:,:)             :: coldT
    real, intent(OUT),   dimension(:,:,:)           :: Tdel, Qdel
    real, intent(OUT),   dimension(:,:)             :: Rain, Snow
    real, intent(IN)                                :: dtinv
type(time_type), intent(in)                         :: Time
integer, intent(IN)                                :: is, js
    real, dimension(:,:,:,:), intent(in)            :: tracers
    real, dimension(:,:,:,:), intent(out)           :: qtrmca
 integer, intent(IN) ,   dimension(:,:),   optional :: Lbot
    real, intent(IN) ,   dimension(:,:,:), optional :: mask
 logical, intent(OUT),   dimension(:,:,:), optional :: Conv
    real, intent(INOUT), dimension(:,:,:), optional :: ql, qi, cf
    real, intent(OUT),   dimension(:,:,:), optional :: qldel, qidel, cfdel
         
!-----------------------------------------------------------------------
!----------------------PRIVATE (LOCAL) ARRAYS---------------------------
! logical, dimension(size(Tin,1),size(Tin,2),size(Tin,3)) :: DO_ADJUST
!    real, dimension(size(Tin,1),size(Tin,2),size(Tin,3)) ::  &
!-----------------------------------------------------------------------
!----------------------PRIVATE (LOCAL) ARRAYS---------------------------
integer, dimension(size(Tin,1),size(Tin,2)) :: ISMVF
integer, dimension(size(Tin,1),size(Tin,2),size(Tin,3)) :: IVF

real, dimension(size(Tin,1),size(Tin,2),size(Tin,3)) ::   &
  Qdif,Temp,Qmix,Esat,Qsat,Test1,Test2, &
   Esdiff_v

real, dimension(size(Tin,1),size(Tin,2),size(Tin,3)-1) ::   &
  Thalf,DelPoP,Esm,Esd,ALRM

real, dimension(size(Tin,3)) :: C,Ta,Qa
real, dimension(size(Tin,1),size(Tin,2)) :: HL

integer :: i,j,k,kk,KX,ITER,MXLEV,MXLEV1,kstart,KTOP,KBOT,KBOTM1
real    :: ALTOL,Sum0,Sum1,Sum2,EsDiff,EsVal,Thaf,Pdelta

logical  :: cloud_tracers_present
real, dimension(size(Phalf,1),size(Phalf,2),size(Phalf,3)) :: pmass
real, dimension(size(Phalf,1),size(Phalf,2)) :: tempdiag
integer  :: tr, num_cld_tracers
logical :: used
!-----------------------------------------------------------------------

      if (.not. module_is_initialized) call ERROR_MESG( 'MCA',  &
                                 'moist_conv_init has not been called', FATAL )

      num_cld_tracers = count( (/present(ql),present(qi),present(cf),present(qldel),present(qidel),present(cfdel)/) )
      if(num_cld_tracers == 0) then
        cloud_tracers_present = .false.
      else if(num_cld_tracers == 6) then
        cloud_tracers_present = .true.
      else
        call error_mesg('moist_conv','Either all or none of the cloud tracers and their tendencies must be present',FATAL)
      endif

        do k=1,size(Tin,3)
          pmass(:,:,k) = (Phalf(:,:,k+1)-Phalf(:,:,k))/GRAV
        end do

      KX=size(Tin,3)

!------ compute Proper HL
      if(do_simple) then
            HL = HLv
      else
        WHERE (coldT)
              HL = HLs
        ELSEWHERE
              HL = HLv
        END WHERE
      endif

!------ convert spec hum to mixing ratio ------
      Temp(:,:,:)=Tin(:,:,:)
      Qmix(:,:,:)=Qin(:,:,:)

      do k=1,KX-1
         DelPoP(:,:,k)=(Pfull(:,:,k+1)-Pfull(:,:,k))/Phalf(:,:,k+1)
      enddo

!-------------SATURATION VAPOR PRESSURE FROM ETABL----------------------
!  compute qs; also return dqsdT

      call compute_qs (Temp, Pfull, Qsat, dqsdT=Esdiff_v, hc = hc, &
                                                            esat=Esat)
      Qdif(:,:,:)=Max(0.0,Qmix(:,:,:)-Qsat(:,:,:))

!-----------------------------------------------------------------------
!                  MOIST CONVECTIVE ADJUSTMENT
!-----------------------------------------------------------------------

!  *** Set initial tolerance ***

           ALTOL = TOLmin

      do k=1,KX-1
         Thalf(:,:,k)=0.50*(Temp(:,:,k)+Temp(:,:,k+1))
      enddo

      call lookup_es_des (Thalf, Esm, Esd)

      do k=1,KX-1
         ALRM(:,:,k)=rocp*DelPoP(:,:,k)*Thalf(:,:,k)  &
         *(Phalf(:,:,k+1)+d622*HL(:,:)*Esm(:,:,k)/Thalf(:,:,k)/rdgas)  &
         /(Phalf(:,:,k+1)+d622*HL(:,:)*Esd(:,:,k)/cp_air)
      enddo

      IVF  (:,:,KX)=0
      Test1(:,:,KX)=0.0
      Test2(:,:,KX)=0.0

      do k=1,KX-1
         Test1(:,:,k)=Temp(:,:,k+1)-Temp(:,:,k)
         Test2(:,:,k)=ALRM(:,:,k)+ALTOL-Test1(:,:,k)
      enddo

!!!!! Test1(:,:,:)=0.0-Qdif(:,:,:)
      Test1(:,:,:)=(0.0-Qdif(:,:,:))*Qsat(:,:,:)

!-------IVF=1 in unstable layers where both levels are saturated--------

      do k=1,KX-1
         where (Test1(:,:,k) < 0.0 .and. Test1(:,:,k+1) < 0.0 .and. &
                Test2(:,:,k) < 0.0)
                         IVF(:,:,k)=1
         elsewhere
                         IVF(:,:,k)=0
         endwhere
      enddo

!  ------ Set convection flag (for optional output only) --------

      if (Present(Conv)) then
         Conv(:,:,1)=(IVF(:,:,1) == 1)
         do k=1,KX-1
            Conv(:,:,k+1)=(IVF(:,:,k) == 1 .or. IVF(:,:,k+1) == 1)
         enddo
      endif

!  ----- Set counter for each column -----

         ISMVF(:,:)=0
      do k=1,KX-1
         ISMVF(:,:)=ISMVF(:,:)+IVF(:,:,k)
      enddo

!-----------------------------------------------------------------------
!---------------LOOP OVER EACH VERTICAL COLUMN--------------------------
                       do j=1,size(Tin,2)
           OUTER_LOOP: do i=1,size(Tin,1)
!-----------------------------------------------------------------------
      if (ISMVF(i,j) == 0)  CYCLE

      if (Present(Lbot)) then
         MXLEV=Lbot(i,j)
      else
         MXLEV=KX
      endif
      MXLEV1=MXLEV-1

!  *** Re-set initial tolerance ***
           ALTOL = TOLmin

!----------(return here after increasing tolerance)--------------------
1450  CONTINUE

!--------------Iterations at the same tolerance-------------------------
                     do 1740 ITER=1,ITSMOD
!-----------------------------------------------------------------------
      kstart=1
 1500 CONTINUE
!-------------TEST TO DETERMINE UNSTABLE LAYER BLOCKS-------------------
!-------Find top (KTOP) and bottom (KBOT) of unstable layers------------
      do k=kstart,MXLEV1
          if (IVF(i,j,k) == 1)  GO TO 1505
      enddo
      CYCLE OUTER_LOOP
1505  KTOP=k

      do k=KTOP,MXLEV1
          if (IVF(i,j,k+1) == 0) then
             KBOT=k+1
             GO TO 1510
          endif
      enddo
      KBOT=MXLEV
1510  CONTINUE
!-----------------------------------------------------------------------

      KBOTM1=KBOT - 1
      Sum1=0.0
      Sum2=0.0
!-----------------------------------------------------------------------
                      do 1630 k=KTOP,KBOT
!-----------------------------------------------------------------------
      if(do_simple) then
        call DEsComp (Temp(i,j,k),EsDiff)
        C(k)=d622*HC*EsDiff/Pfull(i,j,k)
      else
        C(k)=Pfull(i,j,k)-d378*Esat(i,j,k)
        if (C(k) <= 0.0) then
          C(k)=0.0
        else
          C(k) = esdiff_v(i,j,k)
        endif
      endif  

      Sum0=0.0
      if (k == KBOT) GO TO 1625
      kk=k
1620  if (kk > KBOTM1) GO TO 1625
      Sum0=Sum0+ALRM(i,j,kk)
      kk=kk+1
      GO TO 1620

1625  CONTINUE
      Pdelta=Phalf(i,j,k+1)-Phalf(i,j,k)
      Sum1=Sum1 + Pdelta*((cp_air+HL(i,j)*C(k))*(Temp(i,j,k)+Sum0)+  &
                           HL(i,j)*(Qmix(i,j,k)-Qsat(i,j,k)))
      Sum2=Sum2 + Pdelta*(cp_air+HL(i,j)*C(k))
!-----------------------------------------------------------------------
1630                   CONTINUE
!-----------------------------------------------------------------------
      Ta(KBOT)=Sum1/Sum2
      k=KTOP
1645  if (k > KBOTM1) GO TO 1641
      Sum0=0.0
      kk=k
1640  if (kk > KBOTM1) GO TO 1642
      Sum0=Sum0+ALRM(i,j,kk)
      kk=kk+1
      GO TO 1640
1642  Ta(k)=Ta(KBOT)-Sum0
      k=k+1
      GO TO 1645

!---------UPDATE T,R,ES,Esm,Esd & Qsat FOR THE ADJUSTED POINTS----------

1641  do k=KTOP,KBOT
        Qa(k)=Qsat(i,j,k)+C(k)*(Ta(k)-Temp(i,j,k))
        Temp(i,j,k)=Ta(k)
        Qmix(i,j,k)=Qa(k)
        call compute_qs ( Temp(i,j,k), Pfull(i,j,k), Qsat(i,j,k), &
                     dqsdT = Esdiff_v(i,j,k), hc =hc, esat= Esat(i,j,k))
        Qdif(i,j,k)=Max(0.0,Qmix(i,j,k)-Qsat(i,j,k))
      enddo

      do k=KTOP,KBOTM1
        Thaf=0.50*(Temp(i,j,k)+Temp(i,j,k+1))
!DIR$ INLINE
        call lookup_es_des (Thaf, EsVal, Esdiff)
!DIR$ NOINLINE
        Esm (i,j,k)=HC*EsVal
        Esd (i,j,k)=HC*EsDiff
        ALRM(i,j,k)=rocp*DelPoP(i,j,k)*Thaf*  &
               (Phalf(i,j,k+1)+d622*HL(i,j)*Esm(i,j,k)/Thaf/rdgas)/  &
               (Phalf(i,j,k+1)+d622*HL(i,j)*Esd(i,j,k)/cp_air)
      enddo

!------------Is this the bottom of the current column ???---------------
      kstart=KBOT+1
      if (kstart <= MXLEV1) GO TO 1500
!-----------------------------------------------------------------------
                if (ITER == ITSMOD) GO TO 1740
!-----------------------------------------------------------------------

      do k=1,MXLEV1
        Thaf=0.50*(Temp(i,j,k)+Temp(i,j,k+1))
!DIR$ INLINE
        call lookup_es_des (Thaf, EsVal, EsDiff)
!DIR$ NOINLINE
        Esm (i,j,k)=HC*EsVal
        Esd (i,j,k)=HC*EsDiff
        ALRM(i,j,k)=rocp*DelPoP(i,j,k)*Thaf*  &
               (Phalf(i,j,k+1)+d622*HL(i,j)*Esm(i,j,k)/Thaf/rdgas)/  &
               (Phalf(i,j,k+1)+d622*HL(i,j)*Esd(i,j,k)/cp_air)
      enddo

      do k=1,MXLEV1
        IVF(i,j,k)=0
!!!!    if (Qdif(i,j,k) > 0.0 .and. Qdif(i,j,k+1) > 0.0 .and.  &
        if (Qdif(i,j,k)*Qsat(i,j,k) > 0.0 .and.     &
             Qdif(i,j,k+1)*Qsat(i,j,k+1) > 0.0 .and.  &
              (Temp(i,j,k+1)-Temp(i,j,k)) > (ALRM(i,j,k)+ALTOL)) then
                       IVF(i,j,k) = 1
        endif
      enddo

!   ------ reset optional convection flag ------

      if (Present(Conv)) then
         Conv(i,j,1)=(IVF(i,j,1) == 1)
         do k=1,MXLEV1
            Conv(i,j,k+1)=(IVF(i,j,k) == 1 .or. IVF(i,j,k+1) == 1)
         enddo
      endif

!   ------ Are all layers sufficiently stable ??? ------

              ISMVF(i,j)=0
           do k=1,MXLEV1
              ISMVF(i,j)=ISMVF(i,j)+IVF(i,j,k)
           enddo
              if (ISMVF(i,j) == 0) CYCLE OUTER_LOOP

!-----------------------------------------------------------------------
1740                       CONTINUE
!-----------------------------------------------------------------------

!---------Maximum iterations reached: Increase tolerance (ALTOL)--------
      ALTOL=2.0*ALTOL
!del  WRITE (*,9902) I,ALTOL
      call error_mesg ('moist_conv', 'Tolerence (ALTOL) doubled', NOTE)
      if (ALTOL <= TOLmax)  GO TO 1450

!     WRITE (*,9903)
!     WRITE (*,9904) (k,Temp(i,j,k),Qmix(i,j,k),Qsat(i,j,k),  &
!                       Qdif(i,j,k),ALRM(i,j,k),k=1,MXLEV1)
!     WRITE (*,9904) (k,Temp(i,j,k),Qmix(i,j,k),Qsat(i,j,k),  &
!                       Qdif(i,j,k)            ,k=MXLEV,MXLEV)

   call error_mesg ('moist_conv', 'maximum iterations reached', WARNING)
!-----------------------------------------------------------------------
                            enddo OUTER_LOOP
                            enddo
!-----------------------------------------------------------------------
!---------------------- END OF i,j LOOP --------------------------------
!-----------------------------------------------------------------------

!---- call Convective Detrainment subroutine -----

     if (cloud_tracers_present) then

          !reset quantities
          cfdel = 0.
          qldel = 0.
          qidel = 0.
     
          CALL CONV_DETR(Qmix,Qin,Phalf,Temp,cf,coldT,cfdel,qldel,qidel)
          
     endif

!----- compute adjustments to temp and spec hum ----

      Tdel(:,:,:)=Temp(:,:,:)-Tin(:,:,:)
      Qdel(:,:,:)=Qmix(:,:,:)-Qin(:,:,:)

!----- integrate precip -----

      Rain(:,:)=0.0
      Snow(:,:)=0.0
   do k =1,KX

     if(do_simple) then
       Rain(:,:)=Rain(:,:)+(Phalf(:,:,k)-Phalf(:,:,k+1))*  &
                               Qdel(:,:,k)*grav_inv
       if (cloud_tracers_present) then
          Rain(:,:)=Rain(:,:)+(Phalf(:,:,k)-Phalf(:,:,k+1))*  &
                                qldel(:,:,k)*grav_inv
       endif
     else
       WHERE(coldT(:,:)) 
         Snow(:,:)=Snow(:,:)+(Phalf(:,:,k)-Phalf(:,:,k+1))*  &
                               Qdel(:,:,k)*grav_inv
       ELSEWHERE
         Rain(:,:)=Rain(:,:)+(Phalf(:,:,k)-Phalf(:,:,k+1))*  &
                               Qdel(:,:,k)*grav_inv
       END WHERE

      !subtract off detrained condensate from surface precip
       if (cloud_tracers_present) then
         WHERE(coldT(:,:)) 
           Snow(:,:)=Snow(:,:)+(Phalf(:,:,k)-Phalf(:,:,k+1))*  &
                                qidel(:,:,k)*grav_inv
         ELSEWHERE
           Rain(:,:)=Rain(:,:)+(Phalf(:,:,k)-Phalf(:,:,k+1))*  &
                                qldel(:,:,k)*grav_inv
         END WHERE      
       end if
     endif

   enddo
      Rain(:,:)=Max(Rain(:,:),0.0)
      Snow(:,:)=Max(Snow(:,:),0.0)
!-----------------------------------------------------------------------
!-----------------   PRINT FORMATS   -----------------------------------

 9902 FORMAT(    ' *** ALTOL DOUBLED IN CONVAD AT I=',  &
                 I5,' ,ALTOL=', F10.4 )
 9903 FORMAT(/,' *** DIVERGENCE IN MOIST CONVECTIVE ADJUSTMENT ',/,  &
           4X,'K',14X,'T',14X,'R',13X,'Qsat',14X,'Qdif',12X,'ALRM',/)
 9904 FORMAT (I5,5E15.7)
!-----------------------------------------------------------------------


!------- update input values and compute tendency -------
                    
      Tin=Tin+Tdel;    Qin=Qin+Qdel
      
      Tdel=Tdel*dtinv; Qdel=Qdel*dtinv
      Rain=Rain*dtinv; Snow=Snow*dtinv
!------- update input values , compute and add on tendency -----------
!-------              in the case of strat                 -----------

      if (cloud_tracers_present) then
         ql(:,:,:)=ql(:,:,:)+qldel(:,:,:)
         qi(:,:,:)=qi(:,:,:)+qidel(:,:,:)
         cf(:,:,:)=cf(:,:,:)+cfdel(:,:,:)
 
         qldel(:,:,:)=qldel(:,:,:)*dtinv
         qidel(:,:,:)=qidel(:,:,:)*dtinv
         cfdel(:,:,:)=cfdel(:,:,:)*dtinv
      endif   
      
!---------------------------------------------------------------------
!   define the effect of moist convective adjustment on the tracer 
!   fields. code to do so does not currently exist.
!---------------------------------------------------------------------
      qtrmca = 0.
 

!------- diagnostics for dt/dt_ras -------
      if ( id_tdt_conv > 0 ) then
        used = send_data ( id_tdt_conv, Tdel, Time, is, js, 1, &
                           rmask=mask )
      endif
!------- diagnostics for dq/dt_ras -------
      if ( id_qdt_conv > 0 ) then
        used = send_data ( id_qdt_conv, Qdel, Time, is, js, 1, &
                           rmask=mask )
      endif
!------- diagnostics for precip_ras -------
      if ( id_prec_conv > 0 ) then
        used = send_data ( id_prec_conv, Rain+Snow, Time, is, js )
      endif
!------- diagnostics for snow_ras -------
      if ( id_snow_conv > 0 ) then
        used = send_data ( id_snow_conv, Snow, Time, is, js )
      endif

!------- diagnostics for water vapor path tendency ----------
      if ( id_q_conv_col > 0 ) then
        tempdiag(:,:)=0.
        do k=1,kx
          tempdiag(:,:) = tempdiag(:,:) + Qdel(:,:,k)*pmass(:,:,k)
        end do
        used = send_data ( id_q_conv_col, tempdiag, Time, is, js )
      end if
   
!------- diagnostics for dry static energy tendency ---------
      if ( id_t_conv_col > 0 ) then
        tempdiag(:,:)=0.
        do k=1,kx
          tempdiag(:,:) = tempdiag(:,:) + Tdel(:,:,k)*cp_air*pmass(:,:,k)
        end do
        used = send_data ( id_t_conv_col, tempdiag, Time, is, js )
      end if
   
   !------- stratiform cloud tendencies from cumulus convection ------------
   if (cloud_tracers_present) then

      !------- diagnostics for dql/dt from RAS or donner -------
      if ( id_qldt_conv > 0 ) then
        used = send_data ( id_qldt_conv, qldel(:,:,:), Time, is, js, 1, &
                           rmask=mask )
      endif
      
      !------- diagnostics for dqi/dt from RAS or donner -------
      if ( id_qidt_conv > 0 ) then
        used = send_data ( id_qidt_conv, qidel(:,:,:), Time, is, js, 1, &
                           rmask=mask )
      endif
      
      !------- diagnostics for dqa/dt from RAS or donner -------
      if ( id_qadt_conv > 0 ) then
        used = send_data ( id_qadt_conv, cfdel(:,:,:), Time, is, js, 1, &
                           rmask=mask )
      endif

      !------- diagnostics for liquid water path tendency ------
      if ( id_ql_conv_col > 0 ) then
        tempdiag(:,:)=0.
        do k=1,kx
          tempdiag(:,:) = tempdiag(:,:) + qldel(:,:,k)*pmass(:,:,k)
        end do
        used = send_data ( id_ql_conv_col, tempdiag, Time, is, js )
      end if
      
      !------- diagnostics for ice water path tendency ---------
      if ( id_qi_conv_col > 0 ) then
        tempdiag(:,:)=0.
        do k=1,kx
          tempdiag(:,:) = tempdiag(:,:) + qidel(:,:,k)*pmass(:,:,k)
        end do
        used = send_data ( id_qi_conv_col, tempdiag, Time, is, js )
      end if
      
      !---- diagnostics for column integrated cloud mass tendency ---
      if ( id_qa_conv_col > 0 ) then
        tempdiag(:,:)=0.
        do k=1,kx
          tempdiag(:,:) = tempdiag(:,:) + cfdel(:,:,k)*pmass(:,:,k)
        end do
        used = send_data ( id_qa_conv_col, tempdiag, Time, is, js )
      end if
         
   end if ! if ( cloud_tracers_present )

   do tr = 1, num_mca_tracers
!------- diagnostics for dtracer/dt from RAS -------------
     if ( id_tracer_conv(tr) > 0 ) then
       used = send_data ( id_tracer_conv(tr), qtrmca(:,:,:,tr), Time, is, js, 1, &
                          rmask=mask )
     endif
 
!------- diagnostics for column tracer path tendency -----
     if ( id_tracer_conv_col(tr) > 0 ) then
       tempdiag(:,:)=0.
       do k=1,kx
         tempdiag(:,:) = tempdiag(:,:) + qtrmca(:,:,k,tr)*pmass(:,:,k)
       end do
       used = send_data ( id_tracer_conv_col(tr), tempdiag, Time, is, js )
     end if

 
   enddo

 end subroutine moist_conv

!#######################################################################
!#######################################################################

SUBROUTINE CONV_DETR(qvout,qvin,phalf,T,cf,coldT,cfdel,qldel,qidel)


IMPLICIT NONE

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!      This subroutine takes a fraction of the water condensed
!      by the convection scheme and detrains in the top level
!      undergoing convective adjustment.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!       VARIABLES
!
!   ------
!   INPUT:
!   ------
!
!       qvout    water vapor specific humidity AFTER adjustment
!                (kg vapor/kg air)
!       qvin     water  vapor specific humidity BEFORE adjustment
!                (kg vapor/kg air)
!       phalf    pressure at model half levels (Pascals)
!       T        Temperature (Kelvin)
!       cf       cloud fraction (fraction)
!       coldT    is condensation of ice nature?
!
!   -------------
!   INPUT/OUTPUT:
!   -------------
!
!       cfdel    Change in cloud fraction due to detrainment (fraction)
!       qldel    Increase in liquid water due to detrainment
!                (kg condensate/kg air)
!       qidel    Increase in ice due to detrainment
!                (kg condensate/kg air)
!
!   -------------------
!       INTERNAL VARIABLES:
!   -------------------
!
!       precipsource  accumulated source of precipitation
!                     (kg condensate /meter/ (seconds*squared))
!       ktop          integer of top level undergoing convection
!       accum         logical variable indicating whether or not to
!                     add precip
!       fT            fraction of condensate that is liquid
!       i,j,k         looping variables
!       IDIM,JDIM,KDIM dimensions of input arrays
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!  User Interface variables
!  ------------------------

REAL,     INTENT (IN), DIMENSION(:,:,:)  :: qvout,qvin,T,cf
REAL,     INTENT (IN), DIMENSION(:,:,:)  :: phalf
LOGICAL,  INTENT (IN), DIMENSION(:,:)    :: coldT
REAL,     INTENT (INOUT),DIMENSION(:,:,:):: cfdel,qldel,qidel

!  Internal variables
!  ------------------

INTEGER                                  :: i,j,k,IDIM,JDIM,KDIM,ktop
LOGICAL                                  :: accum
REAL                                     :: precipsource

!
! Code
! ----

        ! reinitialize variables
        cfdel(:,:,:)   = 0.
        qidel(:,:,:)   = 0.
        qldel(:,:,:)   = 0.
        IDIM           = SIZE(qvout,1)
        JDIM           = SIZE(qvout,2)
        KDIM           = SIZE(qvout,3)

        !---loop over grid columns----!
        DO i = 1, IDIM
        DO j = 1, JDIM

             !reset variables
             precipsource     = 0.
             accum            = .FALSE.

             DO k = 1, KDIM

                 !begin new convective event
                 IF ((qvout(i,j,k) .ne. qvin(i,j,k)) .and. &
                     (.NOT. accum)) THEN
                     ktop  = k
                     accum = .TRUE.
                 END IF

                 !if convective event is over compute detrainment
                 IF ( (accum) .and. (qvout(i,j,k) .eq. qvin(i,j,k)) &
                      .and. (precipsource .gt. 0.)) THEN                      
                      if (coldT(i,j)) then
                      qidel(i,j,ktop) = beta * precipsource / &
                                    (phalf(i,j,ktop+1)-phalf(i,j,ktop))
                      else
                      qldel(i,j,ktop) = beta * precipsource / &
                                    (phalf(i,j,ktop+1)-phalf(i,j,ktop))
                      end if
                      cfdel(i,j,ktop) = MAX(0.,HC-cf(i,j,ktop))
                      accum        = .FALSE.
                      precipsource = 0.
                 END IF

                 !accumulate precip
                 IF (accum) THEN
                      precipsource = precipsource + &
                                   ( qvin(i,j,k)  -qvout(i,j,k))* &
                                   (phalf(i,j,k+1)-phalf(i,j,k))
                 END IF

             END DO    !---end k loop over vertical column

            !---clear any remaining precip
            IF ( (precipsource .gt. 0.) .and. (accum) ) THEN
                 if (coldT(i,j)) then
                 qidel(i,j,ktop) = beta * precipsource / &
                                    (phalf(i,j,ktop+1)-phalf(i,j,ktop))
                 else
                 qldel(i,j,ktop) = beta * precipsource / &
                                    (phalf(i,j,ktop+1)-phalf(i,j,ktop))
                 end if
            END IF

        END DO    !---end j loop
        END DO    !---end i loop

END SUBROUTINE CONV_DETR

!#######################################################################

subroutine moist_conv_init (axes, Time, tracers_in_mca)

 integer,         intent(in) :: axes(4)
 type(time_type), intent(in) :: Time
 logical, dimension(:), intent(in), optional :: tracers_in_mca

!-----------------------------------------------------------------------
      
 integer :: unit, io, ierr, logunit
 integer :: nn, tr
 character(len=128) :: diagname, diaglname, tendunits, name, units


!-----------------------------------------------------------------------

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=moist_conv_nml, iostat=io)
    ierr = check_nml_error(io,"moist_conv_nml")
#else
    if (file_exist('input.nml')) then
        unit = open_namelist_file ()
        ierr=1; do while (ierr /= 0)
            read  (unit, nml=moist_conv_nml, iostat=io, end=10)
            ierr = check_nml_error (io,'moist_conv_nml')
        enddo
 10     call close_file (unit)
    endif
#endif

!---------- output namelist --------------------------------------------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
           logunit = stdlog()
           write (logunit,nml=moist_conv_nml)
      endif

   id_tdt_conv = register_diag_field ( mod_name, &
     'tdt_conv', axes(1:3), Time, &
     'Temperature tendency from moist conv adj',     'deg_K/s',  &
                        missing_value=missing_value               )

   id_qdt_conv = register_diag_field ( mod_name, &
     'qdt_conv', axes(1:3), Time, &
     'Spec humidity tendency from moist conv adj',   'kg/kg/s',  &
                        missing_value=missing_value               )

   id_prec_conv = register_diag_field ( mod_name, &
     'prec_conv', axes(1:2), Time, &
    'Precipitation rate from moist conv adj',       'kg/m2/s' )

   id_snow_conv = register_diag_field ( mod_name, &
     'snow_conv', axes(1:2), Time, &
    'Frozen precip rate from moist conv adj',       'kg/m2/s' )

   id_q_conv_col = register_diag_field ( mod_name, &
     'q_conv_col', axes(1:2), Time, &
    'Water vapor path tendency from moist conv adj','kg/m2/s' )
   
   id_t_conv_col = register_diag_field ( mod_name, &
     't_conv_col', axes(1:2), Time, &
    'Column static energy tendency from moist conv adj','W/m2' )


!---------------------------------------------------------------------
! --- Find the tracer indices 
!---------------------------------------------------------------------
  call get_number_tracers (MODEL_ATMOS, num_prog= num_tracers)
  if ( num_tracers .gt. 0 ) then
  else
    call error_mesg('moist_conv_init', 'No atmospheric tracers found', FATAL)
  endif
    ! get tracer indices for stratiform cloud variables
      nsphum = get_tracer_index ( MODEL_ATMOS, 'sphum' )
      nql = get_tracer_index ( MODEL_ATMOS, 'liq_wat' )
      nqi = get_tracer_index ( MODEL_ATMOS, 'ice_wat' )
      nqa = get_tracer_index ( MODEL_ATMOS, 'cld_amt' )

     
!----------------------------------------------------------------------
!    determine how many tracers are to be transported by moist_conv_mod.
!----------------------------------------------------------------------
      num_mca_tracers = count(tracers_in_mca)
      if (num_mca_tracers > 0) then
        do_mca_tracer = .true.
      else
        do_mca_tracer = .false.
      endif

!---------------------------------------------------------------------
!    allocate the arrays to hold the diagnostics for the moist_conv 
!    tracers.
!---------------------------------------------------------------------
      allocate(id_tracer_conv    (num_mca_tracers)) ; id_tracer_conv = 0
      allocate(id_tracer_conv_col(num_mca_tracers)) ; id_tracer_conv_col = 0
      nn = 1
      do tr = 1,num_tracers
        if (tracers_in_mca(tr)) then
          call get_tracer_names(MODEL_ATMOS, tr, name=name, units=units)
 
!----------------------------------------------------------------------
!    for the column tendencies, the name for the diagnostic will be 
!    the name of the tracer followed by 'dt_MCA'. the longname will be 
!    the name of the tracer followed by ' tendency from MCA'. units are
!    the supplied units of the tracer divided by seconds.
!----------------------------------------------------------------------
      diagname = trim(name)//'dt_MCA'
      diaglname = trim(name)//' tendency from MCA'
      tendunits = trim(units)//'/s'
      id_tracer_conv(nn) = register_diag_field ( mod_name, &
                             trim(diagname), axes(1:3), Time, &
                             trim(diaglname), trim(tendunits),  &
                             missing_value=missing_value        )

!----------------------------------------------------------------------
!    for the column integral  tendencies, the name for the diagnostic 
!    will be the name of the tracer followed by 'dt_MCA_col'. the long-
!    name will be the name of the tracer followed by ' path tendency 
!    from MCA'. units are the supplied units of the tracer multiplied
!    by m**2 /kg divided by seconds.
!----------------------------------------------------------------------
      diagname = trim(name)//'dt_MCA_col'
      diaglname = trim(name)//' path tendency from MCA'
      tendunits = trim(units)//'m2/kg/s'
      id_tracer_conv_col(nn) = register_diag_field ( mod_name, &
                                 trim(diagname), axes(1:2), Time, &
                                 trim(diaglname), trim(tendunits),  &
                                 missing_value=missing_value)
      nn = nn + 1
     endif
    end do




      module_is_initialized = .true.

!-----------------------------------------------------------------------

 end subroutine moist_conv_init


!#######################################################################
subroutine moist_conv_end

integer :: log_unit

if(.not.module_is_initialized) then
  return
else
  module_is_initialized = .FALSE.
endif

log_unit = stdlog()
if ( mpp_pe() == mpp_root_pe() ) then
   write (log_unit,'(/,(a))') 'Exiting moist_conv.'
endif

end subroutine moist_conv_end

!#######################################################################

end module moist_conv_mod

!-----------------------------------------------------------------------
! Copyright 2011 NOAA Geophysical Fluid Dynamics Lab, Princeton, NJ
! This program is distributed under the terms of the GNU General Public
! License. See the file COPYING contained in this directory
!
! This program reads several input netcdf files, presumably containing "compressed
! by gathering" data, and combines them into a single output file
!
!-----------------------------------------------------------------------

#define __NF_ASRT__(ierr) call nfu_check_err(ierr,__FILE__,__LINE__)
program decompress

  use nfu_mod
  use nfu_compress_mod
  implicit none
  include 'netcdf.inc'

  integer, parameter :: PATH_MAX = 1024 ! max len of the file name; 
  integer, parameter :: HEADERPAD = 16384 ! Use mpp_io large headers;
  integer            :: blksz = 65536  ! blksz must be writable for nf__create

  character(PATH_MAX), allocatable :: files(:) ! names of all files on the command line
  character(PATH_MAX)              :: outfile  ! name of the output file
  integer :: nfiles    ! number of files on command line
  integer :: debug = 0 ! debug output verbosity level
  integer, allocatable :: input(:)             ! netcdf IDs of input files
  integer :: i,iret,ncid,dimid,varid,varid1,xtype,dimlen,vsize,ndims,nvars,natts
  integer :: in_format, cmode
  integer :: dimids(NF_MAX_VAR_DIMS), dimlens(NF_MAX_VAR_DIMS)
  character(NF_MAX_NAME) :: dimname,varname,attname
  logical :: is_dim, is_compressed, has_records, add_missing_value = .FALSE.
  real   , allocatable :: buffer(:)
  logical, allocatable :: mask(:)
  real :: missing

  ! get command line options and list of files
  call parse_command_line() ! modigies global data!

  call assert(nfiles>0,'at least one input file must be specified')
  if(debug>0) then
     do i = 1,nfiles
        write(*,'("input file",i3,":",a)')i, '"'//trim(files(i))//'"'
     enddo
     write(*,'("output file:",a)')'"'//trim(outfile)//'"'
  endif

  ! open all input files
  allocate(input(nfiles))
  do i = 1,nfiles
     __NF_ASRT__(nf_open(files(i),NF_NOWRITE,input(i)))
     __NF_ASRT__(nf_inq_format(input(i),in_format))
  enddo

  if (in_format==NF_FORMAT_NETCDF4) then
     cmode = NF_NETCDF4
  elseif (in_format==NF_FORMAT_NETCDF4_CLASSIC) then
     cmode=IOR(NF_NETCDF4,NF_CLASSIC_MODEL)
  elseif (in_format==NF_FORMAT_64BIT) then
     cmode=IOR(NF_CLOBBER,NF_64BIT_OFFSET)
     if(debug>0)write(*,'("output file is 64-bit netcdf")')
  elseif (in_format==NF_FORMAT_CLASSIC) then
     cmode=IOR(NF_CLOBBER,NF_CLASSIC_MODEL)
     if(debug>0)write(*,'("output file is 32-bit netcdf")')
  else
     call assert(.false.,'Unknown netCDF format')
  endif

  ! create output file
  __NF_ASRT__(nf__create(outfile,cmode,0,blksz,ncid))

  ! Create netcdf structure in the output NetCDF file, using last input file
  ! as a template.

  ! clone all dimensions except compressed ones; compressed are just skipped
  __NF_ASRT__(nf_inq_ndims(input(nfiles),ndims))
  do dimid = 1,ndims
     __NF_ASRT__(nfu_inq_dim(input(nfiles),dimid,dimname=dimname,dimlen=dimlen,is_unlim=has_records))
     if(nfu_inq_att(input(nfiles),dimname,'compress')==NF_NOERR) cycle
     if(has_records)&
          dimlen=NF_UNLIMITED
     if(debug>0)&
          write(*,*)'defining dimension "'//trim(dimname)//'" with length',dimlen
     __NF_ASRT__(nf_def_dim(ncid,dimname,dimlen,i)) ! i is just a space for id
  enddo

  ! clone all variable definitions, replacing compressed dimensions with sets
  ! of uncompressed ones
  __NF_ASRT__(nf_inq_nvars(input(nfiles),nvars))
  do varid = 1,nvars
     iret = nfu_inq_compressed_var(input(nfiles),varid,varname,xtype,ndims,dimids,&
          natts=natts,is_dim=is_dim, is_compressed=is_compressed)
     if(debug>0)&
          write(*,*)'defining variable "'//trim(varname)//'"'
     __NF_ASRT__(iret) ! just because the line is going to be too long
     if(is_dim.and.is_compressed) cycle
     do i = 1,ndims
        __NF_ASRT__(nf_inq_dimname(input(nfiles),dimids(i),dimname))
        __NF_ASRT__(nf_inq_dimid(ncid,dimname,dimids(i)))
     enddo
     __NF_ASRT__(nf_def_var(ncid,varname,xtype,ndims,dimids,varid1))
     do i=1,natts
        __NF_ASRT__(nf_inq_attname(input(nfiles),varid,i,attname))
        __NF_ASRT__(nf_copy_att(input(nfiles),varid,attname,ncid,varid1))
     enddo
     if(add_missing_value.and.is_compressed) then
        ! check if missing_value or _FillValue attributes are present 
        if ( nf_inq_atttype(input(nfiles),varid,'missing_value',iret)/=NF_NOERR .and. &
             nf_inq_atttype(input(nfiles),varid,'_FillValue',iret)/=NF_NOERR ) then
           ! if not, define the missing value attribute
           select case(xtype)
           case(NF_DOUBLE) 
              missing = NF_FILL_DOUBLE
           case(NF_FLOAT)
              missing = NF_FILL_FLOAT
           case(NF_INT)
              missing = NF_FILL_INT
           end select
           ! and add it to the output variable
           __NF_ASRT__(nf_put_att_double(ncid,varid1,'missing_value',xtype,1,missing))
        endif
     endif
  enddo

  ! clone all global attributes
  __NF_ASRT__(nf_inq_natts(input(nfiles),natts))
  do i = 1,natts
     __NF_ASRT__(nf_inq_attname(input(nfiles),NF_GLOBAL,i,attname))
     __NF_ASRT__(nf_copy_att(input(nfiles),NF_GLOBAL,attname,ncid,NF_GLOBAL))
  enddo

  ! ---- end of definition stage
  __NF_ASRT__(nf__enddef(ncid,HEADERPAD,4,0,4))


  ! grow unlimited dimension, if necessary
  do varid=1,nvars
     __NF_ASRT__(nfu_inq_compressed_var(input(nfiles),varid,name=varname,dimlens=dimlens,has_records=has_records))
     if(has_records) then
        ! just write an integer at the very end of the variable -- that extends the 
        ! record dimensions as well
        __NF_ASRT__(nf_inq_varid(ncid,varname,varid))
        __NF_ASRT__(nf_put_var1_int(ncid,varid,dimlens,0))
        exit ! this loop
     endif
  enddo

  ! gather and copy data
  __NF_ASRT__(nf_inq_nvars(ncid,nvars))
  do varid = 1,nvars
!     __NF_ASRT__(nfu_inq_compressed_var(ncid,varid,name=varname,varsize=vsize))
     __NF_ASRT__(nfu_inq_var(ncid,varid,varname,xtype,varsize=vsize))
     if(debug>0) &
          write(*,*)'processing var "'//trim(varname)//'"'
     allocate(buffer(vsize),mask(vsize))
     mask(:) = .false.

     ! obtain the missing value 
     if(nfu_get_att(ncid,varname,'missing_value',missing)==NF_NOERR) then
        ! do nothing, the value is already in the "missing" variable
     else if(nfu_get_att(ncid,varname,'_FillValue',missing)==NF_NOERR) then
        ! do nothing, the value is already in the "missing" variable
     else
        ! get fill value for the type instead of the missing value
        select case(xtype)
        case(NF_DOUBLE) 
           missing = NF_FILL_DOUBLE
        case(NF_FLOAT)
           missing = NF_FILL_FLOAT
        case(NF_INT)
           missing = NF_FILL_INT
        end select
     endif
     ! fill the buffer with the missing value
     buffer=missing

     ! read the variable
     do i=1,nfiles
        __NF_ASRT__(nfu_get_compressed_var_r8n(input(i),varname,buffer,mask))
     enddo
     ! write the variable
     __NF_ASRT__(nfu_put_var_r8(ncid,varname,buffer))
     deallocate(buffer,mask)
  enddo
     
  __NF_ASRT__(nf_close(ncid))

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

! ---- parses command line arguments, getting options and gathering list of
! file names
! NOTE: updates global variables.
subroutine parse_command_line()
  character(PATH_MAX) :: arg, param

  integer :: nargs     ! number of command-line arguments
  logical :: do_interpret_arguments
  integer :: i, iostat

  integer, external :: iargc

  nargs = iargc()
  if(nargs==0) then
     call usage()
     call exit(1)
  endif
  
  allocate(files(nargs))  ! allocate storage for all file names
  do_interpret_arguments = .true.
  add_missing_value = .false.
  i=1        ! counter of all command-line arguments
  nfiles = 0 ! counter of input files
  do while (i<=nargs)
     call getarg(i,arg)
     if(debug>1) write(*,*)'argument ',i, trim(arg)
     if(arg(1:1)=='-'.and.do_interpret_arguments) then
        select case(trim(arg))
        case('--')
           do_interpret_arguments = .false.

        case('-D','--debug-level')
           call assert(i<nargs,trim(arg)//' flag must be followed by integer verbosity level')
           call getarg(i+1,param)
           read(param,*,iostat=iostat) debug
           call assert(iostat==0,trim(arg)//' flag must be followed by integer verbosity level')
           i=i+1

        case('-m','--add-missing-value')
	   add_missing_value = .TRUE.

        case ('-h','-?','--help')
           call usage()
           call exit(1)

        case default
           call usage()
           call assert(.false.,'argument "'//trim(arg)//'" is illegal')
        end select
     else
        ! argument is either input or output file name, add it to the list
        nfiles = nfiles+1
        files(nfiles) = arg
     endif
     i = i+1
  enddo
  if (nfiles>0) then
     outfile = files(nfiles)
     nfiles  = nfiles-1
  endif
end subroutine


! ---- prints usage information
subroutine usage()
! this program reads several input netcdf files, presumably containing "compressed
! by gathering" data, and combines them into a single output file
  character(len=PATH_MAX) :: name
  call getarg(0,name)
  write(*,'(a)')'Converts one or several compressed-by-gathering netcdf file into'
  write(*,'(a)')'one regular netcdf. Normally used to convert lm3 restarts into a'
  write(*,'(a)')'form suitable for visualization applications.'
  write(*,'(a)')
  write(*,'(a)')'Usage:'
  write(*,'(a)')'  '//trim(name)//' [-D debug-level] [-m] in.nc [...] out.nc'
  write(*,'(a)')
  write(*,'(a)')'-D debug-level   Specifies level of debug output verbosity'
  write(*,'(a)')'-m               Forces adding a missing_value attribute to the variables'
  write(*,'(a)')'                 that do not have it'
  write(*,'(a)')'in.nc            Input file name(s)'
  write(*,'(a)')'out.nc           Output file name'
  write(*,'(a)')
  write(*,'(a)')'WARNING: output file is overwritten.'
end subroutine


! ===========================================================================
! ---- prints error message an exits if condition is not satisfied
subroutine assert(cond,message)
  logical     , intent(in) :: cond    ! condition to check
  character(*), intent(in) :: message ! error message to print if condition is not satisfied
  
  if(.not.cond) then
     write(*,*) 'ERROR :: ',trim(message)
     call exit(1)
  endif
end subroutine

end program decompress

#include "cosp_defs.H"
#ifdef COSP_GFDL
 
!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------
 
! $Id: pf_to_mr.F,v 20.0 2013/12/13 23:16:07 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) 2008, Lawrence Livermore National Security Limited Liability Corporation.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list 
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Lawrence Livermore National Security Limited Liability Corporation 
!       nor the names of its contributors may be used to endorse or promote products derived from 
!       this software without specific prior written permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
      
      subroutine pf_to_mr(npoints,nlev,ncol,rain_ls,snow_ls,grpl_ls,
     &                    rain_cv,snow_cv,prec_frac,
     &                    p,t,mx_rain_ls,mx_snow_ls,mx_grpl_ls,
     &                    mx_rain_cv,mx_snow_cv)


      implicit none

      INTEGER npoints       !  number of model points in the horizontal
      INTEGER nlev          !  number of model levels in column
      INTEGER ncol          !  number of subcolumns

      INTEGER j,ilev,ibox
      
      REAL rain_ls(npoints,nlev),snow_ls(npoints,nlev) ! large-scale precip. flux
      REAL grpl_ls(npoints,nlev)
      REAL rain_cv(npoints,nlev),snow_cv(npoints,nlev) ! convective precip. flux

      REAL prec_frac(npoints,ncol,nlev) ! 0 -> clear sky
                                        ! 1 -> LS precipitation
                                        ! 2 -> CONV precipitation
                                        ! 3 -> both
      REAL mx_rain_ls(npoints,ncol,nlev),mx_snow_ls(npoints,ncol,nlev)
      REAL mx_grpl_ls(npoints,ncol,nlev)
      REAL mx_rain_cv(npoints,ncol,nlev),mx_snow_cv(npoints,ncol,nlev)
      REAL p(npoints,nlev),t(npoints,nlev)
      REAL ar,as,ag,br,bs,bg,nr,ns,ng,rho0,rhor,rhos,rhog,rho
      REAL term1r,term1s,term1g,term2r,term2s,term2g,term3
      REAL term4r_ls,term4s_ls,term4g_ls,term4r_cv,term4s_cv
      REAL term1x2r,term1x2s,term1x2g,t123r,t123s,t123g
      
      ! method from Khairoutdinov and Randall (2003 JAS)

      ! --- List of constants from Appendix B
      ! Constant in fall speed formula
      ar=842.
      as=4.84
      ag=94.5
      ! Exponent in fall speed formula
      br=0.8
      bs=0.25
      bg=0.5
      ! Intercept parameter
      nr=8.*1000.*1000.
      ns=3.*1000.*1000.
      ng=4.*1000.*1000.
      ! Densities for air and hydrometeors
      rho0=1.29
      rhor=1000.
      rhos=100.
      rhog=400.
      ! Term 1 of Eq. (A19).
      term1r=ar*17.8379/6.
      term1s=as*8.28508/6.
      term1g=ag*11.6317/6.
      ! Term 2 of Eq. (A19).
      term2r=(3.14159265*rhor*nr)**(-br/4.)
      term2s=(3.14159265*rhos*ns)**(-bs/4.)
      term2g=(3.14159265*rhog*ng)**(-bg/4.)
      
      term1x2r=term1r*term2r
      term1x2s=term1s*term2s
      term1x2g=term1g*term2g
      do ilev=1,nlev
        do j=1,npoints
            rho=p(j,ilev)/(287.05*t(j,ilev))
            term3=(rho0/rho)**0.5
            ! Term 4 of Eq. (A19).
            t123r=term1x2r*term3
            t123s=term1x2s*term3
            t123g=term1x2g*term3
            term4r_ls=rain_ls(j,ilev)/(t123r)
            term4s_ls=snow_ls(j,ilev)/(t123s)
            term4g_ls=grpl_ls(j,ilev)/(t123g)
            term4r_cv=rain_cv(j,ilev)/(t123r)
            term4s_cv=snow_cv(j,ilev)/(t123s)
            do ibox=1,ncol
                mx_rain_ls(j,ibox,ilev)=0.
                mx_snow_ls(j,ibox,ilev)=0.
                mx_grpl_ls(j,ibox,ilev)=0.
                mx_rain_cv(j,ibox,ilev)=0.
                mx_snow_cv(j,ibox,ilev)=0.
                if ((prec_frac(j,ibox,ilev) .eq. 1.) .or.
     &              (prec_frac(j,ibox,ilev) .eq. 3.)) then 
                    mx_rain_ls(j,ibox,ilev)=
     &                     (term4r_ls**(1./(1.+br/4.)))/rho
                    mx_snow_ls(j,ibox,ilev)=
     &                     (term4s_ls**(1./(1.+bs/4.)))/rho
                    mx_grpl_ls(j,ibox,ilev)=
     &                     (term4g_ls**(1./(1.+bg/4.)))/rho
                endif
                if ((prec_frac(j,ibox,ilev) .eq. 2.) .or.
     &              (prec_frac(j,ibox,ilev) .eq. 3.)) then 
                    mx_rain_cv(j,ibox,ilev)=
     &                     (term4r_cv**(1./(1.+br/4.)))/rho
                    mx_snow_cv(j,ibox,ilev)=
     &                     (term4s_cv**(1./(1.+bs/4.)))/rho
                endif
            enddo ! loop over ncol
        enddo ! loop over npoints
      enddo ! loop over nlev
  
      end

module ocean_wave_mod
#define COMP isc:iec,jsc:jec
!
! <CONTACT EMAIL="Martin.Schmidt@io-warnemuende.de"> M. Schmidt
! </CONTACT>
!
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
! </REVIEWER>
!
!<OVERVIEW>
! Idealized wave model for delivering wave number and wave height
! for coupled current-wave action on sediment. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This idealized wave model delivers wave number and wave height 
! for calculation of the coupled current-wave action on sediment.
! Swell is not included in this model.
!
! All fields are defined at tracer grid, for later use in sediment dynamics
! in such modules as ocean_shared/generic_tracers/generic_ERGOM.F90
! </DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! P.C. Liu, D.J. Schwab and J.R. Bennett, 
!      Journ. of Phys. Oceanography 14, 1514 (1984).
!      D.J. Schwab, J.R. Bennett, P.C. Liu and M.A. Donelan,
!      Journ. of Geophysical Research  89 (C3), 3586 (1984).  
!</REFERENCE>
!
!<REFERENCE>
! Hughes, S. A. 1984. "TMA Shallow-Water Spectrum:
!      Description and Application," Technical Report CERC-84-7, 
!      US Army Engineer Waterways Experiment Station, Vicksburg, Miss.
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST>
!</NAMELIST>

use constants_mod,          only: pi, grav
use diag_manager_mod,       only: register_diag_field
use fms_mod,                only: open_namelist_file, check_nml_error, close_file, file_exist
use fms_mod,                only: write_version_number, FATAL, WARNING, NOTE
use fms_mod,                only: clock_flag_default
use mpp_mod,                only: mpp_clock_id, mpp_clock_begin, mpp_clock_end
use fms_io_mod,             only: reset_field_pointer, restart_file_type
use fms_io_mod,             only: register_restart_field, save_restart, restore_state
use mpp_mod,                only: input_nml_file, mpp_error, stdout, stdlog
use mpp_mod,                only: mpp_max, mpp_min, mpp_pe
use mpp_mod,                only: CLOCK_COMPONENT, CLOCK_SUBCOMPONENT, CLOCK_MODULE, CLOCK_ROUTINE
use ocean_domains_mod,      only: get_local_indices, get_global_indices
use mpp_domains_mod,        only: mpp_update_domains
use ocean_types_mod,        only: ocean_domain_type, ocean_grid_type, ocean_options_type
use ocean_types_mod,        only: ocean_time_type, ocean_time_steps_type
use ocean_parameters_mod,   only: missing_value
use ocean_workspace_mod,    only: wrk1_2d, wrk2_2d, wrk3_2d, wrk4_2d
use ocean_util_mod,         only: write_timestamp, diagnose_2d, write_chksum_2d
use ocean_types_mod,        only: ice_ocean_boundary_type
use wave_types_mod,         only: ocean_wave_type
use data_override_mod,      only: data_override

implicit none
private

public ocean_wave_init
public ocean_wave_model
public ocean_wave_end
public wave_model_is_initialised

type(ocean_domain_type), pointer   :: Dom =>NULL()
type(ocean_grid_type), pointer     :: Grd =>NULL()

character(len=128) :: &
     version='$Id: ocean_wave.F90,v 20.0 2013/12/14 00:17:26 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

real,parameter:: gtpi=grav/2.0/pi, epsln=1e-20 
real,parameter:: sqrt_2 = sqrt(2.)
real,parameter:: rhoair=1.2233, rhoh2o=1000., gamma=0.028  
real,parameter:: fac2=0.5*gamma*rhoair/rhoh2o/grav
real,parameter:: twopi=2.*pi, third=1./3., seventh=1./7.
real,parameter:: rho_ice=905.

#include <ocean_memory.h>

#ifndef MOM_STATIC_ARRAYS
real, dimension(:,:),  allocatable:: windx, windy      !wind fields for surface stress
real, dimension(:,:),  allocatable:: sn,cs,c,s         !direction fields for wave propagation
real, dimension(:,:),  allocatable:: wrk1,  wrk2       !work space in the compute domain
#else
real, dimension(isd:ied,jsd:jed)  :: windx, windy      !wind fields for surface stress
real, dimension(isd:ied,jsd:jed)  :: sn,cs,c,s         !direction fields for wave propagation
real, dimension(isc:iec,jsc:jec)  :: wrk1, wrk2        !work space in the compute domain
#endif
real     :: wavedamp = -10.
logical  :: module_is_initialized = .FALSE.
logical  :: first_call            = .TRUE.
logical  :: damp_where_ice        = .TRUE.
logical  :: filter_wave_mom       = .TRUE.
logical  :: write_a_restart       = .TRUE.
logical  :: use_this_module       = .FALSE.
logical  :: use_TMA               = .TRUE.
logical  :: debug_this_module     = .FALSE. ! for debugging--prints out a lot of checksums 
integer  :: tau_w, taup1_w
real     :: cgmax, gridmin, dttw, dtts, wave_damp

integer  :: id_windx  =-1 
integer  :: id_windy  =-1
integer  :: id_xmom   =-1
integer  :: id_ymom   =-1
integer  :: id_wave_k =-1
integer  :: id_height =-1
integer  :: id_wave_p =-1
integer  :: id_init
integer  :: id_diag

! for write statements 
integer :: stdoutunit,stdlogunit 


! for restart
integer                       :: id_restart(2) = 0
type(restart_file_type), save :: wave_restart



namelist /ocean_wave_nml/ wavedamp, damp_where_ice, write_a_restart, debug_this_module &
                          ,use_TMA, filter_wave_mom, use_this_module

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_wave_init">
!
! <DESCRIPTION>
! Initialize the wave module
! </DESCRIPTION>
!

subroutine ocean_wave_init(Grid, Domain, Waves, Time, Time_steps, Ocean_options, debug)
  type(ocean_grid_type),          intent(in), target   :: Grid
  type(ocean_domain_type),        intent(in), target   :: Domain
  type(ocean_wave_type),          intent(inout)        :: Waves
  type(ocean_time_type),          intent(in)           :: Time
  type(ocean_time_steps_type),    intent(inout)        :: Time_steps 
  type(ocean_options_type),       intent(inout)        :: Ocean_options 
  logical,                        intent(in), optional :: debug
  
  real    :: gridsp
  integer :: ioun, io_status, ierr
  integer :: i, j

  stdoutunit=stdout();stdlogunit=stdlog() 
  
  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_wave_mod (ocean_wave_init): module already initialized.')
  endif 
  
  id_init = mpp_clock_id('(Wave model initialization) ',grain=CLOCK_ROUTINE)
  id_diag = mpp_clock_id('(Wave diagnostics) '         ,grain=CLOCK_ROUTINE)
  
  call mpp_clock_begin(id_init)

  call write_version_number(version, tagname)
  
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, ocean_wave_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_wave_nml')
#else
  ioun = open_namelist_file()
  read  (ioun, ocean_wave_nml,iostat=io_status)
  ierr = check_nml_error(io_status, 'ocean_wave_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit, ocean_wave_nml)  
  write (stdlogunit, ocean_wave_nml)


  if(use_this_module) then
    write(stdoutunit,'(a)') '==>Note: Using the MOM simple ocean surface wave model'  
    module_is_initialized = .TRUE.
    Ocean_options%ocean_ideal_surf_wave = 'Used idealized ocean surface wave module.'
  else
    write(stdoutunit,'(a)') '==>Note: Not using the idealized ocean surface wave module.'  
    module_is_initialized = .FALSE.
    Ocean_options%ocean_ideal_surf_wave = 'Not using the idealized ocean surface wave module.'
    return
  endif

  if (PRESENT(debug) .and. .not. debug_this_module) then
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') '==>Note: running ocean_wave with debug_this_module=.true.'  
  endif 
  if(use_TMA) then 
    write(stdoutunit,'(a)') '==>Note: using TMA-spectrum for shallow areas'  
  else
    write(stdoutunit,'(a)') '==>Note: not using TMA-spectrum for shallow areas'  
  endif 

  if(.not. write_a_restart) then 
    write(stdoutunit,'(a)') '==>Note: running ocean_wave with write_a_restart=.false.'
    write(stdoutunit,'(a)') '   Will NOT write restart file, and so cannot restart the run.'
  endif 

  Dom => Domain
  Grd => Grid

#ifndef MOM_STATIC_ARRAYS

  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  call get_global_indices(Domain, isg, ieg, jsg, jeg)

  allocate(Waves%xmom(isd:ied,jsd:jed,0:1))
  allocate(Waves%ymom(isd:ied,jsd:jed,0:1))
  allocate(Waves%wave_k(isd:ied,jsd:jed))
  allocate(Waves%height(isd:ied,jsd:jed))
  allocate(Waves%wave_p(isd:ied,jsd:jed))

  allocate(windx(isd:ied,jsd:jed))
  allocate(windy(isd:ied,jsd:jed))
  allocate(sn(isd:ied,jsd:jed))
  allocate(cs(isd:ied,jsd:jed))
  allocate(s(isd:ied,jsd:jed))
  allocate(c(isd:ied,jsd:jed))
  allocate(wrk1(isc:iec,jsc:jec))
  allocate(wrk2(isc:iec,jsc:jec))
#endif

  Waves%xmom   = 0.0
  Waves%ymom   = 0.0
  Waves%wave_k = 0.0
  Waves%height = 0.0
  Waves%wave_p = 0.0
  windx        = 0.0
  windy        = 0.0
  sn           = 0.0
  cs           = 0.0
  s            = 0.0
  c            = 0.0
  wrk1         = 0.0 
  wrk2         = 0.0 


  id_windx  = register_diag_field ('ocean_model', 'windx_wave', Grd%tracer_axes(1:2), &
              Time%model_time, 'zonal wind speed for waves', 'm/s',                   &
              missing_value=missing_value, range=(/-1e3,1e3/))
  id_windy  = register_diag_field ('ocean_model', 'windy_wave', Grd%tracer_axes(1:2), &
              Time%model_time, 'meridional wind speed for waves', 'm/s',              &
              missing_value=missing_value, range=(/-1e3,1e3/))
  id_xmom   = register_diag_field ('ocean_model', 'xmom', Grd%tracer_axes(1:2), &
              Time%model_time, 'zonal wave momentum', 'm^2/s',                  &
              missing_value=missing_value, range=(/-1e3,1e3/))
  id_ymom   = register_diag_field ('ocean_model', 'ymom', Grd%tracer_axes(1:2), &
              Time%model_time, 'meridional wave momentum', 'm^2/s',             &
              missing_value=missing_value, range=(/-1e3,1e3/))
  id_height = register_diag_field ('ocean_model', 'height', Grd%tracer_axes(1:2), &
              Time%model_time, 'significant wave height', 'm',                    &
              missing_value=missing_value, range=(/-1e3,1e3/))
  id_wave_p = register_diag_field ('ocean_model', 'wave_p', Grd%tracer_axes(1:2), &
              Time%model_time, 'peak frequency', '1/s',                           &
              missing_value=missing_value, range=(/-1e3,1e3/))
  id_wave_k = register_diag_field ('ocean_model', 'wave_k', Grd%tracer_axes(1:2), &
              Time%model_time, 'wave number', '1/m',                              &
              missing_value=missing_value, range=(/-1e3,1e3/))

  ! initialise the time stepping
  tau_w   = 0
  taup1_w = 1
  dtts     = Time_steps%dtts

! find the minimum and maximum grid spacing to organise substepping
  gridmin          = 1.0e20
  do j=jsc,jec
     do i=isc,iec
        if (Grd%kmt(i,j) > 0) then
           gridsp = 1.0/(Grd%dxu(i,j)*Grd%dxu(i,j)) + 1.0/(Grd%dyu(i,j)*Grd%dyu(i,j))
           gridsp = sqrt(1.0/gridsp) 
           gridmin = min(gridsp,gridmin)
        endif
     enddo
  enddo
  call mpp_min (gridmin)
! readthe initial field or the restart file
  call read_wave(Waves)

  wave_damp = wavedamp/rho_ice  

  call mpp_clock_end(id_init) 

  return
end subroutine ocean_wave_init
! </SUBROUTINE> NAME="ocean_wave_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_wave_model">
!
! <DESCRIPTION>
! time step the wave model
! </DESCRIPTION>
!
subroutine ocean_wave_model(Time, Waves, Ice_ocean_boundary)
  type(ocean_time_type),          intent(in)    :: Time 
  type(ocean_wave_type),          intent(inout) :: Waves
  type(ice_ocean_boundary_type),  intent(in)    :: Ice_ocean_boundary

  integer :: i,j
  integer :: ndtt, nww
  real    :: wmax, cspeed, dtwmax

  if ( .not.module_is_initialized ) return  

  if(debug_this_module) then 
     write(stdoutunit,*) 'starting ocean_wave_model'
  endif 

  ! If we do not initialize them they will have junk in haloes (huge values) after data_overrides below.
  ! The subsequent mpp_update_domains calls are supposed to update these haloes with sensible values.
  ! But, that does not happen in the Baltic testcase and the haloes will contain junk even after mpp_update_domains calls!
  ! This would cause crash later when those huge values in the haloes are accessed for doing arithmatic 
  ! (e.g., in use_TMA block below).
  ! Zeroing out windx and windy on data domain at the onset avoids such crash. 
  ! But the root cause is not clear and there may be a bug somewhere. 
  ! Niki.Zadeh 
  windx = 0.0
  windy = 0.0

  call data_override('OCN', 'u_bot', wrk1, Time%model_time )
  call data_override('OCN', 'v_bot', wrk2, Time%model_time )

  do j=jsc,jec
     do i=isc,iec
       windx(i,j) = wrk1(i,j)
       windy(i,j) = wrk2(i,j)
     enddo
  enddo

  call mpp_update_domains (windx, Dom%domain2d)
  call mpp_update_domains (windy, Dom%domain2d)

  ! wavediag is needed to initialize wave_p      
  if (first_call) then
    call ocean_wave_diag(Waves) 
    first_call=.false.
    if(debug_this_module) write(stdoutunit,*) 'first start of ocean_wave_model'
  endif
! find the maximum speed for stability of time stepping
  wmax=epsln
  do j=jsc,jec
     do i=isc,iec
        if (Grd%kmt(i,j) > 0) then
           wmax=max(wmax, abs(windx(i,j)), abs(windy(i,j)))
!phase speed
           cspeed=gtpi/(Waves%wave_p(i,j)+epsln)
           wmax=max(wmax,abs(cspeed))        
        endif
     enddo
  enddo
  call mpp_max(wmax )
  dtwmax=0.5*gridmin/sqrt_2/wmax     
  ndtt=int(dtts/dtwmax)+1   
  
  if(debug_this_module) write(stdoutunit,*) 'ocean_wave_model: wmax    = ', wmax
  if(debug_this_module) write(stdoutunit,*) 'ocean_wave_model: gridmin = ', gridmin
  if(debug_this_module) write(stdoutunit,*) 'ocean_wave_model: ndtt    = ', ndtt
  
  dttw=dtts/float(ndtt)
!loop for waves       
  do nww=1,ndtt      
    tau_w=abs(tau_w-1)
    taup1_w=abs(taup1_w-1)  
    call ocean_wave_diag(Waves)  
    call ocean_wave_prop(Waves, Ice_ocean_boundary)  
!    call ocean_wave_prop(Time)  
  enddo      
! filtering xmom and ymom       
!  if (mod(itt,10).eq.0) then
  if(filter_wave_mom) call ocean_wave_filter(Waves, dtts)
!  endif

  call diagnose_2d(Time, Grd, id_windx, windx(:,:))
  call diagnose_2d(Time, Grd, id_windy, windy(:,:))
  if (id_xmom  > 0) call diagnose_2d(Time, Grd, id_xmom, Waves%xmom(:,:,taup1_w)*grav)
  if (id_ymom  > 0) call diagnose_2d(Time, Grd, id_ymom, Waves%ymom(:,:,taup1_w)*grav)
  call diagnose_2d(Time, Grd, id_height, Waves%height(:,:))
  call diagnose_2d(Time, Grd, id_wave_p, Waves%wave_p(:,:))
  call diagnose_2d(Time, Grd, id_wave_k, Waves%wave_k(:,:))

  if(debug_this_module) write(stdoutunit,*) 'ending ocean_wave_model'
    
  return
end subroutine ocean_wave_model
! </SUBROUTINE> NAME="ocean_wave_model"


!#######################################################################
! <SUBROUTINE NAME="ocean_wave_prop">
!
! <DESCRIPTION>
! wave propagation
! </DESCRIPTION>
!
subroutine ocean_wave_prop(Waves, Ice_ocean_boundary)
  type(ocean_wave_type),          intent(inout) :: Waves
  type(ice_ocean_boundary_type),  intent(in)    :: Ice_ocean_boundary

  integer :: i,j
  real    :: cm, adv_Txy, adv_Txx, adv_Tyy, adv_Tyx, SIP, SIM, SJP, SJM
  real    :: w1, w2, wspd, wspdr, tmp, cthe, sg, damp, diff

  if(debug_this_module) then 
     write(stdoutunit,*) 'ocean_wave_model: start wave_prop'
  endif 

  do j=jsd,jed
    do i=isd,ied      
      cm        = sqrt(Waves%xmom(i,j,tau_w)**2+Waves%ymom(i,j,tau_w)**2+epsln)   ! m^2/s
      cs(i,j)   = Waves%xmom(i,j,tau_w)/cm
      sn(i,j)   = Waves%ymom(i,j,tau_w)/cm  
      tmp       = gtpi/(Waves%wave_p(i,j)+epsln)
      c(i,j)    = tmp*Grd%tmask(i,j,1)                                ! m/s
      tmp       = tmp*cm    
      wrk1_2d(i,j) = tmp*Grd%tmask(i,j,1)
      s(i,j)    = sqrt(tmp)*Grd%tmask(i,j,1)
    enddo
  enddo

  do j=jsc,jec
    do i=isc,iec      
      adv_Txy = 0.5*( wrk1_2d(i,j)  *cs(i,j)  *(sn(i,j)  +abs(sn(i,j  )))  &
           + wrk1_2d(i,j+1)*cs(i,j+1)*(sn(i,j+1)-abs(sn(i,j+1)))) &
           -0.5*( wrk1_2d(i,j-1)*cs(i,j-1)*(sn(i,j-1)+abs(sn(i,j-1)))  &
           + wrk1_2d(i,j)  *cs(i,j)  *(sn(i,j)  -abs(sn(i,j  ))))

      adv_Txx = 0.5*( wrk1_2d(i,j)  *cs(i,j)  *(cs(i,j)  +abs(cs(i,j  )))  &
           + wrk1_2d(i+1,j)*cs(i+1,j)*(cs(i+1,j)-abs(cs(i+1,j)))) &
           -0.5*( wrk1_2d(i-1,j)*cs(i-1,j)*(cs(i-1,j)+abs(cs(i-1,j)))  &
           + wrk1_2d(i,j)  *cs(i,j)  *(cs(i,j)  -abs(cs(i,j  ))))
            
      SIP = Grd%tmask(i+1,j,1)*s(i+1,j)+(1.0-Grd%tmask(i+1,j,1))*&
            (2.0*s(i,j)-s(i-1,j))
      SIM = Grd%tmask(i-1,j,1)*s(i-1,j)+(1.0-Grd%tmask(i-1,j,1))*&
            (2.0*s(i,j)-s(i+1,j))            
      Waves%xmom(i,j,taup1_w) = Waves%xmom(i,j,tau_w) &
                          - dttw*( 0.25*adv_Txx*Grd%dxtr(i,j)+0.25*adv_Txy*Grd%dytr(i,j) &
                          + (SIP-SIM)*(SIP+SIM)/16.*Grd%dxtr(i,j))*Grd%tmask(i,j,1)
    enddo
  enddo

  do j=jsc,jec
    do i=isc,iec      
      adv_Tyy = 0.5*( wrk1_2d(i,j)  *sn(i,j)  *(sn(i,j)  +abs(sn(i,j  )))  &
           +wrk1_2d(i,j+1)*sn(i,j+1)*(sn(i,j+1)-abs(sn(i,j+1)))) &
           -0.5*( wrk1_2d(i,j-1)*sn(i,j-1)*(sn(i,j-1)+abs(sn(i,j-1)))  &
           +wrk1_2d(i,j)  *sn(i,j)  *(sn(i,j)  -abs(sn(i,j  ))))
      adv_Tyx = 0.5*( wrk1_2d(i,j)  *sn(i,j)  *(cs(i,j)  +abs(cs(i,j  )))  &
           + wrk1_2d(i+1,j)*sn(i+1,j)*(cs(i+1,j)-abs(cs(i+1,j)))) &
           -0.5*( wrk1_2d(i-1,j)*sn(i-1,j)*(cs(i-1,j)+abs(cs(i-1,j)))  &
           + wrk1_2d(i,j)  *sn(i,j)  *(cs(i,j)  -abs(cs(i,j  )))) 
            
      SJP = Grd%tmask(i,j+1,1)*s(i,j+1)+(1.0-Grd%tmask(i,j+1,1))*&
            (2.0*s(i,j)-s(i,j-1))
      SJM = Grd%tmask(i,j-1,1)*s(i,j-1)+(1.0-Grd%tmask(i,j-1,1))*&
            (2.0*s(i,j)-s(i,j+1))                
      Waves%ymom(i,j,taup1_w) = Waves%ymom(i,j,tau_w)       &
           - dttw*( 0.25*adv_Tyy*Grd%dytr(i,j)+0.25*adv_Tyx*Grd%dxtr(i,j)         &
           + (SJP-SJM)*(SJP+SJM)/16.*Grd%dytr(i,j))*Grd%tmask(i,j,1)
    enddo
  enddo    

  !  calculate the wind input to momentum flux for two directions:
  ! the wind direction (w1) and the wave field direction (w2)
  ! drag coefficient depends on direction, maximal for w2, reduced for w1
  do j=jsc,jec
    do i=isc,iec      
      wspd   = sqrt(windx(i,j)**2+windy(i,j)**2+epsln)
      wspdr  = 1/wspd
      cthe   = (windx(i,j)*cs(i,j) + windy(i,j)*sn(i,j))*wspdr

      sg     = max(5.0E-03,s(i,j) * abs(cthe))
      tmp    = wspd-0.83*c(i,j)*cthe
      w1     = tmp*abs(tmp)*wspdr*(0.4/log(50./sg))**2

      sg     = max(5.0E-06,s(i,j))
      tmp    = cthe*wspd-0.83*c(i,j)
      w2     = tmp*abs(tmp)*(0.4/log(50./sg))**2
      wrk3_2d(i,j) = dttw*(w1*windx(i,j) + w2*cs(i,j))*fac2 *Grd%tmask(i,j,1) 
      wrk4_2d(i,j) = dttw*(w1*windy(i,j) + w2*sn(i,j))*fac2 *Grd%tmask(i,j,1)
    enddo
  enddo    

  if (damp_where_ice) then
! Damp the time tendency
     do j=jsc,jec
        do i=isc,iec      
           if (Ice_ocean_boundary%mi(i,j) > 0) then
              damp = exp(wave_damp*Ice_ocean_boundary%mi(i,j)) 
              wrk3_2d(i,j) = wrk3_2d(i,j) * damp
              wrk4_2d(i,j) = wrk4_2d(i,j) * damp
           endif 
        enddo
     enddo 
  endif
   
  do j=jsc,jec
    do i=isc,iec      
      Waves%xmom(i,j,taup1_w) = Waves%xmom(i,j,taup1_w) + wrk3_2d(i,j)
      Waves%ymom(i,j,taup1_w) = Waves%ymom(i,j,taup1_w) + wrk4_2d(i,j)
    enddo
  enddo 

  if (damp_where_ice) then
! This is engeneering needs improvement with resolved ice classes ...
    do j=jsc,jec
      do i=isc,iec
        diff = Ice_ocean_boundary%mi(i,j)-Waves%height(i,j)*rho_ice
        if(diff >= 0.) then
           damp = exp(wave_damp*diff)
           Waves%xmom(i,j,taup1_w)=Waves%xmom(i,j,taup1_w)*damp   
           Waves%ymom(i,j,taup1_w)=Waves%ymom(i,j,taup1_w)*damp   
        endif
      enddo
    enddo
  endif

  call mpp_update_domains (Waves%xmom(:,:,taup1_w), Dom%domain2d)
  call mpp_update_domains (Waves%ymom(:,:,taup1_w), Dom%domain2d)

  if(debug_this_module) then 
     write(stdoutunit,*) 'ocean_wave_model: end wave_prop'
  endif 

  return

end subroutine ocean_wave_prop
! </SUBROUTINE> NAME="ocean_wave_prop"


!#######################################################################
! <SUBROUTINE NAME="ocean_wave_diag">
!
! <DESCRIPTION>
! wave diagnostics
! </DESCRIPTION>
!
subroutine ocean_wave_diag(Waves)
  type(ocean_wave_type), intent(inout) :: Waves

  real, parameter   :: const1=0.01788735, const2=14343.09    
  real, parameter   :: flimit=0.760545
  real              :: fphilf, uhilf
  real              :: cosm, sinm, depth, omega, omh, cm
  real, parameter          :: a0=1., a1=0.666, a2=0.445, a3=-0.105, a4=0.272
  integer :: i, j
    
    
  call mpp_clock_begin(id_diag)

  if(debug_this_module) then 
      write(stdoutunit,*) 'ocean_wave_model: start wave_diag'
  endif 


  if (use_TMA) then
    do j=jsd,jed 
      do i=isd,ied 
         cm=sqrt(Waves%xmom(i,j,tau_w)**2+Waves%ymom(i,j,tau_w)**2+epsln)
         cosm=Waves%xmom(i,j,tau_w)/cm
         sinm=Waves%ymom(i,j,tau_w)/cm
! The relevant 10m wind is the projection at the wave propagation direction
! This is not stated in the paper.
         uhilf=windx(i,j)*cosm+windy(i,j)*sinm
         depth=Grd%ht(i,j)
! calculate  omega=2*pi*f_p
         fphilf=const1*(max(epsln,uhilf)**2/(cm+epsln)**3)**seventh
         if (fphilf*uhilf.le.flimit) fphilf=(const2*cm)**(-third)      
         Waves%wave_p(i,j)=fphilf
         omega = twopi*Waves%wave_p(i,j)  
         omh   = omega**2*depth/grav
      
! using Pade approximation for wave number
        Waves%wave_k(i,j)=sqrt(omh**2+omh/((((a4*omh+a3)*omh+a2)*omh+a1)*omh+a0)) &
                   /(depth+epsln)
! calculate significant wave height
! height=4*sigma
        Waves%height(i,j)=4.0*sqrt(grav*cm/(omega+epsln))   ! cm ist scaled with 1/grav
! using TMA approximation, Hughes 1984
        if (omh.le.4.) then
          if (omh.le.1) then
            Waves%height(i,j)=Waves%height(i,j)*sqrt(0.5*omh)
          else
            Waves%height(i,j)=Waves%height(i,j)*sqrt(1.0-0.5*(2.0-sqrt(omh))**2)
          endif
        endif
 
      enddo
    enddo    

  else    ! use_TMA=.false. in following block 

    do j=jsd,jed 
      do i=isd,ied 
         cm=sqrt(Waves%xmom(i,j,tau_w)**2+Waves%ymom(i,j,tau_w)**2+epsln)
         cosm=Waves%xmom(i,j,tau_w)/cm
         sinm=Waves%ymom(i,j,tau_w)/cm
! The relevant 10m wind is the projection at the wave propagation direction
! This is not stated in the paper.
         uhilf=windx(i,j)*cosm+windy(i,j)*sinm
         depth=Grd%ht(i,j)
! calculate  omega=2*pi*f_p
         fphilf=const1*(max(epsln,uhilf)**2/(cm+epsln)**3)**seventh
         if (fphilf*uhilf.le.flimit) fphilf=(const2*cm)**(-third)      
         Waves%wave_p(i,j)=fphilf
         omega = twopi*Waves%wave_p(i,j)  
         omh   = omega**2*depth/grav
      
! using Pade approximation for wave number
        Waves%wave_k(i,j)=sqrt(omh**2+omh/((((a4*omh+a3)*omh+a2)*omh+a1)*omh+a0)) &
                   /(depth+epsln)
! calculate significant wave height
! height=4*sigma
        Waves%height(i,j)=4.0*sqrt(grav*cm/(omega+epsln))
 
      enddo
    enddo    
  
  endif

  if(debug_this_module) then 
      write(stdoutunit,*) 'ocean_wave_model: end wave_diag'
  endif 

  
  call mpp_clock_end(id_diag)

  return
end subroutine ocean_wave_diag
! </SUBROUTINE> NAME="ocean_wave_diag"


!#######################################################################
! <SUBROUTINE NAME="ocean_wave_filter">
!
! <DESCRIPTION>
! wave filter
! </DESCRIPTION>
!
subroutine ocean_wave_filter(Waves, dttw)
  type(ocean_wave_type), intent(inout) :: Waves
  real,                  intent(in)    :: dttw

  real, parameter :: wi=100.0
  integer :: i, j, n, ium, jum, im
  real    :: wich, rm


  if(debug_this_module) then 
     write(stdoutunit,*) 'ocean_wave_model: start wave_filter'
  endif 

  wich=min(0.9,wi/dttw)

  do j=jsc,jec
    do i=isc,iec
      n=0
      wrk1_2d(i,j)=0.0
      wrk2_2d(i,j)=0.0
      if (Grd%kmt(i,j).gt.0) then
         do ium=-1,1
            do jum=-1,1
               rm=Grd%tmask(i+ium,j+jum,1)
               im=nint(rm)
               n=n+im
               wrk1_2d(i,j)=wrk1_2d(i,j)+Waves%xmom(i+ium,j+jum,taup1_w)*rm
               wrk2_2d(i,j)=wrk2_2d(i,j)+Waves%ymom(i+ium,j+jum,taup1_w)*rm
            enddo
         enddo
         wrk1_2d(i,j)=wrk1_2d(i,j)/float(n)
         wrk2_2d(i,j)=wrk2_2d(i,j)/float(n)
      endif
   enddo
  enddo

  do j=jsc,jec
    do i=isc,iec
      if (Grd%kmt(i,j).gt.0) then
       Waves%xmom(i,j,taup1_w)=wich*Waves%xmom(i,j,taup1_w)+(1.-wich)*wrk1_2d(i,j)
       Waves%ymom(i,j,taup1_w)=wich*Waves%ymom(i,j,taup1_w)+(1.-wich)*wrk2_2d(i,j)
      endif
    enddo
  enddo

  call mpp_update_domains (Waves%xmom(:,:,taup1_w), Dom%domain2d)
  call mpp_update_domains (Waves%ymom(:,:,taup1_w), Dom%domain2d)

  if(debug_this_module) then 
      write(stdoutunit,*) 'ocean_wave_model: ending wave_filter'
  endif 
 
end subroutine ocean_wave_filter
! </SUBROUTINE> NAME="ocean_wave_filter"


!#######################################################################
! <SUBROUTINE NAME="read_wave">
!
! <DESCRIPTION>
!  Read wave restart information. 
! </DESCRIPTION>

subroutine read_wave(Waves)
  type(ocean_wave_type), intent(inout) :: Waves

  character*128 file_name

  file_name = 'ocean_wave.res.nc'
  id_restart(1) = register_restart_field(wave_restart, file_name, 'xmom', &
       Waves%xmom(:,:,taup1_w), domain=Dom%domain2d)
  id_restart(2) = register_restart_field(wave_restart, file_name, 'ymom', &
       Waves%ymom(:,:,taup1_w), domain=Dom%domain2d)       
  
  file_name = 'INPUT/ocean_wave.res.nc'
  if(.NOT. file_exist(trim(file_name)) ) return
  
  call restore_state(wave_restart)

  write (stdoutunit,'(/a)') &
  '  Reading TWO_LEVEL restart from INPUT/ocean_wave.res.nc'
  write (stdoutunit,'(a)')  &
  '  Expecting only one time record for each restart field.'
  
  call mpp_update_domains(Waves%xmom(:,:,taup1_w), Dom%domain2d)
  call mpp_update_domains(Waves%ymom(:,:,taup1_w), Dom%domain2d)
  Waves%xmom(:,:,tau_w) = Waves%xmom(:,:,taup1_w)
  Waves%ymom(:,:,tau_w) = Waves%ymom(:,:,taup1_w)
  
  return
end subroutine read_wave
! </SUBROUTINE> NAME="read_wave"


!#######################################################################
! <SUBROUTINE NAME="ocean_wave_restart">
!
! <DESCRIPTION>
!  Save wave restart information. 
! </DESCRIPTION>

subroutine ocean_wave_restart(Waves, time_stamp)
  type(ocean_wave_type), intent(inout)        :: Waves
  character(len=*),      intent(in), optional :: time_stamp
  
  call reset_field_pointer(wave_restart, id_restart(1),  Waves%xmom(:,:,taup1_w) )
  call reset_field_pointer(wave_restart, id_restart(2),  Waves%ymom(:,:,taup1_w) )

  call save_restart(wave_restart, time_stamp)
  return
end subroutine ocean_wave_restart
! </SUBROUTINE> NAME="ocean_wave_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_wave_end">
!
! <DESCRIPTION>
!  Write out external mode fields to restart file. 
! </DESCRIPTION>
subroutine ocean_wave_end(Time, Waves)
  type(ocean_time_type),  intent(in)    :: Time
  type(ocean_wave_type),  intent(inout) :: Waves

  if ( .not.use_this_module ) return

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_wave_mod (ocean_wave_end): module must be initialized')
  endif 

  if(.not. write_a_restart) then
    write(stdoutunit,'(/a)') &
    '==>Warning from ocean_wave_mod (ocean_wave_end): NO restart written.'
    call mpp_error(WARNING, &
    '==>Warning from ocean_wave_mod (ocean_wave_end): NO restart written.')
    return
  endif 

  call ocean_wave_restart(Waves)

  write(stdoutunit,*) ' '
  write(stdoutunit,*) &
  ' From ocean_wave_mod: ending external mode chksums at taup1'
  call write_timestamp(Time%model_time)
  call wave_chksum(Waves, taup1_w)

  module_is_initialized = .FALSE.

  nullify(Grd)
  nullify(Dom)

end subroutine ocean_wave_end
! </SUBROUTINE> NAME="ocean_wave_end"


!#######################################################################
! <SUBROUTINE NAME="wave_chksum">
!
! <DESCRIPTION>
!  Compute checksum for external mode fields.
! </DESCRIPTION>
!
subroutine wave_chksum(Waves, index)
  type(ocean_wave_type),  intent(inout) :: Waves
  integer,                intent(in)    :: index

  call write_chksum_2d('xmom', Waves%xmom(COMP,index))
  call write_chksum_2d('ymom', Waves%ymom(COMP,index))
  call write_chksum_2d('wave_k', Waves%wave_k(COMP))
  call write_chksum_2d('wave_p', Waves%wave_p(COMP))

end subroutine wave_chksum 
! </SUBROUTINE> NAME="wave_chksum"


!#######################################################################
! <FUNCTION NAME="wave_model_is_initialised">
!   <OVERVIEW>
!     Returns .true. if the wave model is initialised   
!   </OVERVIEW>
!   <DESCRIPTION>
!     This function returns .true. if the wave model is initialised
!     It is needed, because the wave model may be initialised after some module that requires a wave model
!   </DESCRIPTION>
!   <TEMPLATE>
!     use ocean_wave_mod,       only: wave_model_is_initialised     
!     if (wave_model_is_initialised() ) then
!   </TEMPLATE>
!   <IN NAME=""  TYPE="" >
!     No inputs needed.
!   </IN>
!   <OUT NAME=""  TYPE="logical" >
!     This function returns a logical. 
!   </OUT>

function wave_model_is_initialised()
  logical :: wave_model_is_initialised

  wave_model_is_initialised = .false.
  if(module_is_initialized) wave_model_is_initialised = .true.

end function wave_model_is_initialised
! </FUNCTION> NAME="wave_model_is_initialised"

end module ocean_wave_mod 

!-----------------------------------------------------------------------
! Copyright 2011 NOAA Geophysical Fluid Dynamics Lab, Princeton, NJ
! This program is distributed under the terms of the GNU General Public
! License. See the file COPYING contained in this directory
!
! This program lists the variables in a netcdf filei
!
!-----------------------------------------------------------------------

program list_ncvars

use  netcdf
implicit none

character(len=NF90_MAX_NAME) :: filename
logical :: list_nonstatic = .true.
logical :: list_static = .false.
logical :: var4d  = .false.
logical :: var3d  = .false.
logical :: var2d  = .false.
logical :: var1d  = .false.
logical :: var0d  = .false.
namelist /input/ filename, list_nonstatic, list_static, var4d, var3d, var2d, var1d, var0d

integer :: istat, ncid, numdim, numvar, numatt, recdim, &
           varid, ndim, dimids(NF90_MAX_VAR_DIMS), dimid, nc
logical :: static
character(len=NF90_MAX_NAME) :: name

   filename(1:1) = ' '
   read  (*,input,end=1,err=1)
1  continue

   if (filename(1:1) == ' ') then
       stop
   endif

  !--- opening input file ---
   istat = NF90_OPEN (trim(filename), NF90_NOWRITE, ncid)
   if (istat /= NF90_NOERR) call error_handler (istat)

  !--- get global info for this file ---
   istat = NF90_INQUIRE (ncid, numdim, numvar, numatt, recdim) 
   if (istat /= NF90_NOERR) call error_handler (istat)

  !--- loop over variables ---
   do varid = 1, numvar

      istat = NF90_INQUIRE_VARIABLE (ncid, varid, name=name, ndims=ndim, dimids=dimids)
      if (istat /= NF90_NOERR) call error_handler (istat)

     !--- skip dimensions ---
      istat = NF90_INQ_DIMID (ncid, trim(name), dimid)
      if (istat == NF90_NOERR) cycle

     !--- skip names ending in _T1, _T2, _DT ---
      nc = len_trim(name)
      if (name(nc-2:nc) == '_T1' .or. name(nc-2:nc) == '_T2' .or. &
          name(nc-2:nc) == '_DT' .or. name(nc-6:nc) == '_NITEMS') cycle

     !--- is there a record dimension ---
      static = .true.
      if (dimids(ndim) == recdim) then
          static = .false.
          ndim = ndim-1
      endif

      if (.not.list_nonstatic .and. .not.static) cycle
      if (.not.list_static    .and.      static) cycle
      if (.not.var4d .and. ndim == 4) cycle
      if (.not.var3d .and. ndim == 3) cycle
      if (.not.var2d .and. ndim == 2) cycle
      if (.not.var1d .and. ndim == 1) cycle
      if (.not.var0d .and. ndim == 0) cycle
      write (*,*) trim(name)
   enddo

contains

subroutine error_handler (ncode, string)
integer         , intent(in), optional :: ncode
character(len=*), intent(in), optional :: string
character(len=80) :: errstrg
   print *, 'ERROR in program list_ncvars'
   if (present(string)) print *, trim(string)
   if (present(ncode))  then
       errstrg = NF90_STRERROR (ncode) 
       print *, trim(errstrg)
   endif   
   stop 111
 end subroutine error_handler

end program list_ncvars

module atmos_tracer_driver_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   William Cooke
! </CONTACT>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Matt Harrison
! </REVIEWER>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Bruce Wyman
! </REVIEWER>


! <OVERVIEW>
!     This code allows the user to easily add tracers to the FMS framework.
! </OVERVIEW>

! <DESCRIPTION>
!
!     This is a null module to be used when no atmospheric model is required.
!
!     This code allows a user to easily implement tracer code in the FMS
!     framework.  The tracer and tracer tendency arrays are supplied along
!     with longtitude,  latitude, wind, temperature, and pressure
!     information which allows a  user to implement sources and sinks of the
!     tracer which depend on these parameters.
!
!     In the following example, radon being implemented in the atmosphere
!     will be used as an example of how to implement a tracer in the FMS
!     framework.
!
!     Within the global scope of tracer_driver_mod a use
!     statement should be inserted for each tracer to be added.
!<PRE>      use radon_mod, only : radon_sourcesink, radon_init, radon_end </PRE>
!     
!     An integer parameter, which  will be used as an identifier for the
!     tracer, should be assigned.
!<PRE>
!      integer :: nradon 
!</PRE>
!     Within tracer_driver_init a call to the tracer manager is needed in
!     order  to identify which tracer it has set the tracer as.
!<PRE>
!      nradon = get_tracer_index(MODEL_ATMOS,'radon')
!</PRE>
!     Here MODEL_ATMOS is a parameter defined in field_manager. 
!          'radon' is the name of the tracer within the field_table.
!     
!     If the tracer exists then the integer returned will be positive and it
!     can be used to call the initialization routines for the individual
!     tracers.
!<PRE>
!      if (nradon > 0) then
!           call radon_init(Argument list)
!      endif
!</PRE>     
!
!     Within tracer_driver the user can also use the identifier to surround
!     calls to the source-sink routines for the tracer of interest.
!
!<PRE>
!      if (nradon > 0 .and. nradon <= nt) then
!          call radon_sourcesink (Argument list)
!          rdt(:,:,:,nradon)=rdt(:,:,:,nradon)+rtnd(:,:,:)
!      endif
!</PRE>
!
!     It is the users responsibility to add the tendency generated by the
!     sourcesink routine.
!      
!     Within tracer_driver_end the user can add calls to the
!     terminators for the appropriate source sink routines.
!
!<PRE>      call radon_end</PRE>
!
!     This may simply be a deallocation statement or a routine to send
!     output to the logfile stating that the termination routine has been
!     called.
! </DESCRIPTION>


!-----------------------------------------------------------------------

use     time_manager_mod, only : time_type

implicit none
private
!-----------------------------------------------------------------------
!----- interfaces -------

public  atmos_tracer_driver, atmos_tracer_flux_init
public  atmos_tracer_driver_init, atmos_tracer_driver_end
public  atmos_tracer_driver_gather_data

!-----------------------------------------------------------------------
!----------- namelist -------------------
!-----------------------------------------------------------------------
!
!  When initializing additional tracers, the user needs to make the
!  following changes.
!
!  Add an integer variable below for each additional tracer. 
!  This should be initialized to zero. 
!
!-----------------------------------------------------------------------

character(len=6), parameter :: module_name = 'tracer'

logical :: module_is_initialized = .FALSE.


!---- version number -----
character(len=128) :: version = '$Id: atmos_tracer_driver.F90,v 15.0 2007/08/14 03:52:31 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
!-----------------------------------------------------------------------

contains

!#######################################################################

! <SUBROUTINE NAME="atmos_tracer_driver">
!   <OVERVIEW>
!     A routine which allows tracer code to be called.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This subroutine calls the source sink routines for atmospheric
!     tracers. This is the interface between the dynamical core of the 
!     model and the tracer code. It should supply all the necessary 
!     information to a user that they need in order to calculate the 
!     tendency of that tracer with respect to emissions or chemical losses.
!
!   </DESCRIPTION>
!   <TEMPLATE>
!     call atmos_tracer_driver (is, ie, js, je, Time, lon, lat, land, phalf, pfull, r,  &
!                           u, v, t, q, u_star, rdt, rm, rdiag, kbot)
!   </TEMPLATE>
!   <IN NAME="is, ie, js, je" TYPE="integer">
!     Local domain boundaries.
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="lon" TYPE="real" DIM="(:,:)">
!     Longitude of the centre of the model gridcells
!   </IN>
!   <IN NAME="lat" TYPE="real" DIM="(:,:)">
!     Latitude of the centre of the model gridcells
!   </IN>
!   <IN NAME="land" TYPE="logical" DIM="(:,:)">
!     Land/sea mask.
!   </IN>
!   <IN NAME="phalf" TYPE="real" DIM="(:,:,:)">
!     Pressures on the model half levels.
!   </IN>
!   <IN NAME="pfull" TYPE="real" DIM="(:,:,:)">
!     Pressures on the model full levels.
!   </IN>
!   <IN NAME="r" TYPE="real" DIM="(:,:,:,:)">
!     The tracer array in the component model.
!   </IN>
!   <IN NAME="u" TYPE="real" DIM="(:,:,:)">
!     Zonal wind speed.
!   </IN>
!   <IN NAME="v" TYPE="real" DIM="(:,:,:)">
!     Meridonal wind speed.
!   </IN>
!   <IN NAME="t" TYPE="real" DIM="(:,:,:)">
!     Temperature.
!   </IN>
!   <IN NAME="q" TYPE="real" DIM="(:,:,:)">
!     Specific humidity. This may also be accessible as a
!                        portion of the tracer array.
!   </IN>
!   <IN NAME="u_star" TYPE="real" DIM="(:,:)">
!     Friction velocity :: 
!     The magnitude of the wind stress is density*(ustar**2)
!     The drag coefficient for momentum is u_star**2/(u**2+v**2)
!   </IN>
!   <INOUT NAME="rdt" TYPE="real" DIM="(:,:,:,:)">
!     The tendency of the tracer array in the compenent
!     model. The tendency due to sources and sinks computed
!     in the individual tracer routines should be added to
!     this array before exiting tracer_driver.
!   </INOUT>
!   <IN NAME="rm" TYPE="real" DIM="(:,:,:,:)">
!     The tracer array in the component model for the previous timestep.
!   </IN>
!   <INOUT NAME="rdiag" TYPE="real" DIM="(:,:,:,:)">
!     The array of diagnostic tracers. As these may be changed within the
!     tracer routines for diagnostic purposes, they need to be writable.
!   </INOUT>
!   <IN NAME="kbot" TYPE="integer, optional" DIM="(:,:)">
!     Integer array describing which model layer intercepts the surface.
!   </IN>
 subroutine atmos_tracer_driver (is, ie, js, je, Time, lon, lat,  &
                           area, z_pbl, rough_mom, &
                           land, phalf, pfull,     &
                           u, v, t, q, r,          &
                           rm, rdt, dt,     &
                           u_star, b_star, q_star, &
                           z_half, z_full,&
                           t_surf_rad, albedo, &
                           Time_next, mask, &
                           kbot)

!-----------------------------------------------------------------------
integer, intent(in)                           :: is, ie, js, je
type(time_type), intent(in)                   :: Time
real, intent(in),    dimension(:,:)           :: lon, lat
real, intent(in),    dimension(:,:)           :: u_star, b_star, q_star
real, intent(in),    dimension(:,:)           :: land
real, intent(in),    dimension(:,:)           :: area, z_pbl, rough_mom
real, intent(in),    dimension(:,:,:)         :: phalf, pfull
real, intent(in),    dimension(:,:,:)         :: u, v, t, q
real, intent(inout), dimension(:,:,:,:)       :: r
real, intent(inout), dimension(:,:,:,:)       :: rm
real, intent(inout), dimension(:,:,:,:)       :: rdt
real, intent(in)                              :: dt !timestep(used in chem_interface)
real, intent(in),    dimension(:,:,:)         :: z_half !height in meters at half levels
real, intent(in),    dimension(:,:,:)         :: z_full !height in meters at full levels
real, intent(in),    dimension(:,:)           :: t_surf_rad !surface temperature
real, intent(in),    dimension(:,:)           :: albedo
type(time_type), intent(in)                   :: Time_next
integer, intent(in), dimension(:,:), optional :: kbot
real, intent(in), dimension(:,:,:),  optional :: mask


 return

 end subroutine atmos_tracer_driver
! </SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="atmos_tracer_flux_init">
!   <OVERVIEW>
!     Subroutine to initialize the ocean-atmosphere gas flux modules
!   </OVERVIEW>
!   <DESCRIPTION>
!     Subroutine to initialize the ocean-atmosphere gas flux modules
!   </DESCRIPTION>

subroutine atmos_tracer_flux_init

return

end subroutine atmos_tracer_flux_init
! </SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="atmos_tracer_driver_init">
!   <OVERVIEW>
!     Subroutine to initialize the tracer driver module.
!   </OVERVIEW>
!   <DESCRIPTION>
!   The purpose of the arguments here are for passing on to the individual
!   tracer code. The user may wish to provide initial values which can be
!   implemented in the initialization part of the tracer code. Remember that
!   the tracer manager will provide a simple fixed or exponential profile if
!   the user provides data for this within the field table. However if a more
!   complicated profile is required then it should be set up in the
!   initialization section of the user tracer code.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call atmos_tracer_driver_init (lonb,latb, r, mask, axes, Time)
!   </TEMPLATE>
!   <IN NAME="lonb" TYPE="real" DIM="(:)">
!     The longitudes for the local domain.
!   </IN>
!   <IN NAME="latb" TYPE="real" DIM="(:)">
!     The latitudes for the local domain.
!   </IN>
!   <IN NAME="mask" TYPE="real, optional" DIM="(:,:,:)">
!      optional mask (0. or 1.) that designates which grid points
!           are above (=1.) or below (=0.) the ground dimensioned as
!           (nlon,nlat,nlev).
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="axes" TYPE="integer" DIM="(4)">
!     The axes relating to the tracer array dimensioned as
!      (nlon, nlat, nlev, ntime)
!   </IN>
!   <INOUT NAME="r" TYPE="real" DIM="(:,:,:,:)">
!     Tracer fields dimensioned as (nlon,nlat,nlev,ntrace). 
!   </INOUT>
 subroutine atmos_tracer_driver_init (lonb, latb, r, axes, Time, phalf, mask)

!-----------------------------------------------------------------------
           real, intent(in),    dimension(:,:)             :: lonb, latb
           real, intent(inout), dimension(:,:,:,:)         :: r
type(time_type), intent(in)                                :: Time
        integer, intent(in)                                :: axes(4)
           real, intent(in),    dimension(:,:,:)           :: phalf
           real, intent(in),    dimension(:,:,:), optional :: mask

!-----------------------------------------------------------------------
!
!  When initializing additional tracers, the user needs to make changes 
!
!-----------------------------------------------------------------------

      module_is_initialized = .TRUE.

      return

 end subroutine atmos_tracer_driver_init
! </SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="atmos_tracer_driver_end">
!   <OVERVIEW>
!     Subroutine to terminate the tracer driver module.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Termination routine for tracer_driver. It should also call
!     the destructors for the individual tracer routines.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call atmos_tracer_driver_end
!   </TEMPLATE>
 subroutine atmos_tracer_driver_end

!-----------------------------------------------------------------------

      module_is_initialized = .FALSE.

!-----------------------------------------------------------------------

   return

 end subroutine atmos_tracer_driver_end
! </SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="atmos_tracer_driver_gather_data">
!   <OVERVIEW>
!     Subroutine to terminate the tracer driver module.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Termination routine for tracer_driver. It should also call
!     the destructors for the individual tracer routines.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call atmos_tracer_driver_gather_data
!   </TEMPLATE>
 subroutine atmos_tracer_driver_gather_data(gas_fields, tr_bot)

use coupler_types_mod, only: coupler_2d_bc_type

type(coupler_2d_bc_type), intent(inout) :: gas_fields
real, dimension(:,:,:), intent(in)      :: tr_bot

!-----------------------------------------------------------------------

!-----------------------------------------------------------------------

 return

 end subroutine atmos_tracer_driver_gather_data
! </SUBROUTINE>

!######################################################################

end module atmos_tracer_driver_mod

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                                   !!
!!                   GNU General Public License                      !!
!!                                                                   !!
!! This file is part of the Flexible Modeling System (FMS).          !!
!!                                                                   !!
!! FMS is free software; you can redistribute it and/or modify it    !!
!! under the terms of the GNU General Public License as published by !!
!! the Free Software Foundation, either version 3 of the License, or !!
!! (at your option) any later version.                               !!
!!                                                                   !!
!! FMS is distributed in the hope that it will be useful,            !!
!! but WITHOUT ANY WARRANTY; without even the implied warranty of    !!
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the      !!
!! GNU General Public License for more details.                      !!
!!                                                                   !!
!! You should have received a copy of the GNU General Public License !!
!! along with FMS. if not, see: http://www.gnu.org/licenses/gpl.txt  !!
!!                                                                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module atmosphere_mod

use                  fms_mod, only: set_domain, write_version_number, field_size, file_exist, &
                                    mpp_pe, mpp_root_pe, error_mesg, FATAL, read_data, write_data, nullify_domain

use            constants_mod, only: grav, pi

use           transforms_mod, only: trans_grid_to_spherical, trans_spherical_to_grid, &
                                    get_deg_lon, get_deg_lat, get_grid_boundaries, grid_domain,    &
                                    spectral_domain, get_grid_domain, get_lon_max, get_lat_max, atmosphere_domain

use         time_manager_mod, only: time_type, get_time, operator( + )

use     press_and_geopot_mod, only: compute_pressures_and_heights

use    spectral_dynamics_mod, only: spectral_dynamics_init, spectral_dynamics, spectral_dynamics_end, &
                                    get_num_levels, get_axis_id, spectral_diagnostics, get_initial_fields, &
                                    complete_robert_filter, get_surf_geopotential

use          tracer_type_mod, only: tracer_type

use        field_manager_mod, only: MODEL_ATMOS

use       tracer_manager_mod, only: get_number_tracers

#ifdef IDEALIZED_MOIST_MODEL
  use idealized_moist_phys_mod, only: idealized_moist_phys_init , idealized_moist_phys , idealized_moist_phys_end
#else
  use hs_forcing_mod, only: hs_forcing_init, hs_forcing
#endif

implicit none
private
!=================================================================================================================================

character(len=128) :: version= &
'$Id: atmosphere.F90,v 20.0 2013/12/13 23:25:37 fms Exp $'
      
character(len=128) :: tagname= &
'$Name: tikal $'
character(len=10), parameter :: mod_name='atmosphere'

!=================================================================================================================================

public :: atmosphere_init, atmosphere, atmosphere_end, atmosphere_domain

!=================================================================================================================================

integer, parameter :: num_time_levels = 2
integer :: is, ie, js, je, num_levels, num_tracers, nhum
logical :: dry_model

real, allocatable, dimension(:,:,:,:) :: p_half, p_full
real, allocatable, dimension(:,:,:,:) :: z_half, z_full

type(tracer_type), allocatable, dimension(:) :: tracer_attributes
real, allocatable, dimension(:,:,:,:,:) :: grid_tracers
real, allocatable, dimension(:,:,:    ) :: psg, wg_full
real, allocatable, dimension(:,:,:,:  ) :: ug, vg, tg

real, allocatable, dimension(:,:    ) :: dt_psg
real, allocatable, dimension(:,:,:  ) :: dt_ug, dt_vg, dt_tg
real, allocatable, dimension(:,:,:,:) :: dt_tracers

real, allocatable, dimension(:)   :: deg_lon, deg_lat
real, allocatable, dimension(:,:) :: rad_lon_2d, rad_lat_2d
real, allocatable, dimension(:,:) :: surf_geopotential
real, allocatable, dimension(:,:) :: rad_lonb_2d, rad_latb_2d
real, allocatable, dimension(:)   :: rad_lonb, rad_latb

integer :: previous, current, future
logical :: module_is_initialized =.false.

integer         :: dt_integer
real            :: dt_real
type(time_type) :: Time_step

!=================================================================================================================================
contains
!=================================================================================================================================

subroutine atmosphere_init(Time_init, Time, Time_step_in)

type (time_type), intent(in)  :: Time_init, Time, Time_step_in

integer :: seconds, days, lon_max, lat_max, ntr, nt, i, j
integer, dimension(4) :: siz
real, dimension(2) :: time_pointers
character(len=64) :: file, tr_name
character(len=256) :: message

if(module_is_initialized) return

call write_version_number(version, tagname)

Time_step = Time_step_in
call get_time(Time_step, seconds, days)
dt_integer   = 86400*days + seconds
dt_real      = float(dt_integer)

call get_number_tracers(MODEL_ATMOS, num_prog=num_tracers)
allocate (tracer_attributes(num_tracers))
call spectral_dynamics_init(Time, Time_step, tracer_attributes, dry_model, nhum)
call get_grid_domain(is, ie, js, je)
call get_num_levels(num_levels)

allocate (p_half       (is:ie, js:je, num_levels+1, num_time_levels))
allocate (z_half       (is:ie, js:je, num_levels+1, num_time_levels))
allocate (p_full       (is:ie, js:je, num_levels, num_time_levels))
allocate (z_full       (is:ie, js:je, num_levels, num_time_levels))
allocate (wg_full      (is:ie, js:je, num_levels))
allocate (psg          (is:ie, js:je, num_time_levels))
allocate (ug           (is:ie, js:je, num_levels, num_time_levels))
allocate (vg           (is:ie, js:je, num_levels, num_time_levels))
allocate (tg           (is:ie, js:je, num_levels, num_time_levels))
allocate (grid_tracers (is:ie, js:je, num_levels, num_time_levels, num_tracers ))

allocate (dt_psg     (is:ie, js:je))
allocate (dt_ug      (is:ie, js:je, num_levels))
allocate (dt_vg      (is:ie, js:je, num_levels))
allocate (dt_tg      (is:ie, js:je, num_levels))
allocate (dt_tracers (is:ie, js:je, num_levels, num_tracers))

allocate (deg_lon    (is:ie       ))
allocate (rad_lon_2d (is:ie, js:je))
allocate (deg_lat    (       js:je))
allocate (rad_lat_2d (is:ie, js:je))
allocate (rad_lonb_2d(is:ie+1, js:je+1))
allocate (rad_latb_2d(is:ie+1, js:je+1))
allocate (rad_lonb (is:ie+1))
allocate (rad_latb (js:je+1))

p_half = 0.; z_half = 0.; p_full = 0.; z_full = 0.
wg_full = 0.; psg = 0.; ug = 0.; vg = 0.; tg = 0.; grid_tracers = 0.
dt_psg = 0.; dt_ug  = 0.; dt_vg  = 0.; dt_tg  = 0.; dt_tracers = 0.

allocate (surf_geopotential(is:ie, js:je))
call get_surf_geopotential(surf_geopotential)

!--------------------------------------------------------------------------------------------------------------------------------
file = 'INPUT/atmosphere.res.nc'
if(file_exist(trim(file))) then
  call get_lon_max(lon_max)
  call get_lat_max(lat_max)
  call field_size(trim(file), 'ug', siz)
  if(lon_max /= siz(1) .or. lat_max /= siz(2)) then
    write(message,*) 'Resolution of restart data does not match resolution specified on namelist. Restart data: lon_max=', &
                     siz(1),', lat_max=',siz(2),'  Namelist: lon_max=',lon_max,', lat_max=',lat_max
    call error_mesg('atmosphere_init', message, FATAL)
  endif
  call nullify_domain()
! call read_data(trim(file), 'previous', previous)           ! No interface of read_data exists to read integer scalars
! call read_data(trim(file), 'current',  current)            ! No interface of read_data exists to read integer scalars
  call read_data(trim(file), 'time_pointers', time_pointers) ! Getaround for no interface to read integer scalars
  previous = int(time_pointers(1))                           ! Getaround for no interface to read integer scalars
  current  = int(time_pointers(2))                           ! Getaround for no interface to read integer scalars
  do nt=1,num_time_levels
    call read_data(trim(file), 'ug',   ug(:,:,:,nt), grid_domain, timelevel=nt)
    call read_data(trim(file), 'vg',   vg(:,:,:,nt), grid_domain, timelevel=nt)
    call read_data(trim(file), 'tg',   tg(:,:,:,nt), grid_domain, timelevel=nt)
    call read_data(trim(file), 'psg', psg(:,:,  nt), grid_domain, timelevel=nt)
    do ntr = 1,num_tracers
      tr_name = trim(tracer_attributes(ntr)%name)
      call read_data(trim(file), trim(tr_name), grid_tracers(:,:,:,nt,ntr), grid_domain, timelevel=nt)
    enddo ! end loop over tracers
  enddo ! end loop over time levels
  call read_data(trim(file), 'wg_full', wg_full, grid_domain)
else
  previous = 1; current = 1
  call get_initial_fields(ug(:,:,:,1), vg(:,:,:,1), tg(:,:,:,1), psg(:,:,1), grid_tracers(:,:,:,1,:))
endif
!--------------------------------------------------------------------------------------------------------------------------------
if(dry_model) then
  call compute_pressures_and_heights(tg(:,:,:,current), psg(:,:,current), surf_geopotential, &
       z_full(:,:,:,current), z_half(:,:,:,current), p_full(:,:,:,current), p_half(:,:,:,current))
  call compute_pressures_and_heights(tg(:,:,:,previous), psg(:,:,previous), surf_geopotential, &
       z_full(:,:,:,previous), z_half(:,:,:,previous), p_full(:,:,:,previous), p_half(:,:,:,previous))
else
  call compute_pressures_and_heights(tg(:,:,:,current), psg(:,:,current), surf_geopotential, &
       z_full(:,:,:,current), z_half(:,:,:,current), p_full(:,:,:,current), p_half(:,:,:,current), &
       grid_tracers(:,:,:,current,nhum))
  call compute_pressures_and_heights(tg(:,:,:,previous), psg(:,:,previous), surf_geopotential, &
       z_full(:,:,:,previous), z_half(:,:,:,previous), p_full(:,:,:,previous), p_half(:,:,:,previous), &
       grid_tracers(:,:,:,previous,nhum))
endif

call get_deg_lon(deg_lon)
do i=is,ie
  rad_lon_2d(i,:) = deg_lon(i)*pi/180.
enddo

call get_deg_lat(deg_lat)
do j=js,je
  rad_lat_2d(:,j) = deg_lat(j)*pi/180.
enddo

call get_grid_boundaries(rad_lonb, rad_latb)

do i = is,ie+1
  rad_lonb_2d(i,:) = rad_lonb(i)
enddo

do j = js,je+1
  rad_latb_2d(:,j) = rad_latb(j)
enddo

#ifdef IDEALIZED_MOIST_MODEL
   call idealized_moist_phys_init(Time, Time_step, nhum, rad_lat_2d, rad_lonb_2d, rad_latb_2d, tg(:,:,num_levels,current))
#else
   call hs_forcing_init(get_axis_id(), Time, rad_lonb_2d, rad_latb_2d)
#endif

module_is_initialized = .true.

return
end subroutine atmosphere_init

!=================================================================================================================================

subroutine atmosphere(Time)
type(time_type), intent(in) :: Time

real    :: delta_t
type(time_type) :: Time_next

if(.not.module_is_initialized) then
  call error_mesg('atmosphere','atmosphere module is not initialized',FATAL)
endif

dt_ug  = 0.0
dt_vg  = 0.0
dt_tg  = 0.0
dt_psg = 0.0
dt_tracers = 0.0

if(current == previous) then
  delta_t = dt_real
else
  delta_t = 2*dt_real
endif

Time_next = Time + Time_step

#ifdef IDEALIZED_MOIST_MODEL
   call idealized_moist_phys(Time, p_half, p_full, z_half, z_full, ug, vg, tg, grid_tracers, &
                             previous, current, dt_ug, dt_vg, dt_tg, dt_tracers)
#else
   call hs_forcing(1, ie-is+1, 1, je-js+1, delta_t, Time_next, rad_lon_2d, rad_lat_2d, &
                p_half(:,:,:,current ),       p_full(:,:,:,current   ), &
                    ug(:,:,:,previous),           vg(:,:,:,previous  ), &
                    tg(:,:,:,previous), grid_tracers(:,:,:,previous,:), &
                    ug(:,:,:,previous),           vg(:,:,:,previous  ), &
                    tg(:,:,:,previous), grid_tracers(:,:,:,previous,:), &
                 dt_ug(:,:,:         ),        dt_vg(:,:,:           ), &
                 dt_tg(:,:,:         ),   dt_tracers(:,:,:,:))
#endif

if(previous == current) then
  future = num_time_levels + 1 - current
else
  future = previous
endif

call spectral_dynamics(Time, psg(:,:,future), ug(:,:,:,future), vg(:,:,:,future), &
                       tg(:,:,:,future), tracer_attributes, grid_tracers(:,:,:,:,:), future, &
                       dt_psg, dt_ug, dt_vg, dt_tg, dt_tracers, wg_full, &
                       p_full(:,:,:,current), p_half(:,:,:,current), z_full(:,:,:,current))

call complete_robert_filter(tracer_attributes)

if(dry_model) then
  call compute_pressures_and_heights(tg(:,:,:,future), psg(:,:,future), surf_geopotential, &
       z_full(:,:,:,future), z_half(:,:,:,future), p_full(:,:,:,future), p_half(:,:,:,future))
else
  call compute_pressures_and_heights(tg(:,:,:,future), psg(:,:,future), surf_geopotential, &
       z_full(:,:,:,future), z_half(:,:,:,future), p_full(:,:,:,future), p_half(:,:,:,future), &
                                     grid_tracers(:,:,:,future,nhum))
endif

call spectral_diagnostics(Time_next, psg(:,:,future), ug(:,:,:,future), vg(:,:,:,future), &
                          tg(:,:,:,future), wg_full, grid_tracers(:,:,:,:,:), future)

previous = current
current  = future

return
end subroutine atmosphere

!=================================================================================================================================

subroutine atmosphere_end
integer :: ntr, nt
character(len=64) :: file, tr_name

if(.not.module_is_initialized) return

file='RESTART/atmosphere.res'
call nullify_domain()
call write_data(trim(file), 'time_pointers', (/real(previous),real(current)/))
do nt=1,num_time_levels
  call write_data(trim(file), 'ug',   ug(:,:,:,nt), grid_domain)
  call write_data(trim(file), 'vg',   vg(:,:,:,nt), grid_domain)
  call write_data(trim(file), 'tg',   tg(:,:,:,nt), grid_domain)
  call write_data(trim(file), 'psg', psg(:,:,  nt), grid_domain)
  do ntr = 1,num_tracers
    tr_name = trim(tracer_attributes(ntr)%name)
    call write_data(trim(file), tr_name, grid_tracers(:,:,:,nt,ntr), grid_domain)
  enddo
enddo
call write_data(trim(file), 'wg_full', wg_full, grid_domain)

deallocate (p_half, z_half, p_full, z_full, wg_full, psg, ug, vg, tg, grid_tracers)
deallocate (dt_psg, dt_ug, dt_vg, dt_tg, dt_tracers)
deallocate (deg_lon, rad_lon_2d, deg_lat, rad_lat_2d)

call set_domain(grid_domain)
#ifdef IDEALIZED_MOIST_MODEL
call idealized_moist_phys_end
#endif
call spectral_dynamics_end(tracer_attributes)
deallocate(tracer_attributes)

module_is_initialized = .false.

end subroutine atmosphere_end

!=================================================================================================================================

end module atmosphere_mod

module ocean_bihcst_friction_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Thickness weighted and density weighted time tendency for velocity
! from horizontal biharmonic friction 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes the thickness and density weighted time tendency
! for horizontal velocity arising from horizontal biharmonic friction. 
! The viscosity used to determine the strength of the tendency 
! can be a general function of space yet it is constant in time.  
! A namelist option exists that determines this viscosity 
! as a local function of the grid spacing. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
!  R. J. Murray and C.J.C. Reason,
!  A curvilinear version of the Bryan-Cox ocean model
!  Journal Computational Physics (2002), vol 171, pages 1-46
! </REFERENCE>
!
! <REFERENCE>
!  Elements of MOM (2012), S.M. Griffies 
! </REFERENCE>
!
! <NOTE>
! The numerical implementation requires one call to mpp_update_domains if 
! running the model with halo=1.  
! </NOTE>
!
! <NOTE>
! This scheme has been found to be faster than the Smagorinsky viscosity 
! scheme.  However, the algorithm here is less robust since it 
! contains null modes in the terms associated with the sphericity 
! of the earth.  Hence, there may be flow configurations that are 
! not dissipated.
! </NOTE>
!
! <NOTE>
! The model can generally run with both Laplacian and biharmonic friction
! enabled at the same time. Such has been found useful for some eddying 
! ocean simulations. 
! </NOTE>
!
! <NOTE>
! The numerical implementation in mom4p1 and mom5 does not include the sink due 
! to partial bottom cells. This sink was implemented in mom2 and mom3
! and mom4.  It is not known how relevant this sink is.  
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_bihcst_friction_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module.  Default is false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging by printing checksums.  
!  </DATA> 
!
!  <DATA NAME="abih" UNITS="m^4/sec" TYPE="real">
!  This is the value for the space-time constant biharmonic viscosity. 
!  </DATA> 
!  <DATA NAME="velocity_mix_micom" TYPE="logical">
!  If .true., then the viscosity is set according to a velocity scale times
!  the cube of the grid spacing. It is based on an approach recommended by 
!  Eric Chassignet that is used in the Miami Isopycnal Model.  
!  </DATA> 
!  <DATA NAME="vel_micom" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM viscosity. 
!  </DATA> 
!  <DATA NAME="eq_vel_micom" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM viscosity within a latitude
!  band surrounding the equator.  This is useful for some models of enhanced equatorial
!  resolution that can maintain numerical integrity in this region with less friction 
!  than outside the tropical band.  
!  </DATA> 
!  <DATA NAME="eq_lat_micom" TYPE="real">
!  Equatorial latitude band (degrees) within which the MICOM viscosity is set according 
!  to eq_vel_micom.
!  </DATA> 
!
!</NAMELIST>

use constants_mod,    only: pi, radius, epsln
use diag_manager_mod, only: register_diag_field, register_static_field
use fms_mod,          only: open_namelist_file, check_nml_error, write_version_number, close_file
use fms_mod,          only: FATAL, NOTE, stdout, stdlog
use mpp_domains_mod,  only: mpp_update_domains
use mpp_mod,          only: input_nml_file, mpp_error, mpp_pe, mpp_max, mpp_sum

use ocean_domains_mod,    only: get_local_indices
use ocean_obc_mod,        only: ocean_obc_enhance_visc_back
use ocean_operators_mod,  only: FAX, FAY, BAX, BAY, FMX, FMY
use ocean_operators_mod,  only: BDX_EU, BDY_NU, FDX_U, FDY_U, FDX_NT, FDY_ET
use ocean_parameters_mod, only: missing_value
use ocean_types_mod,      only: ocean_time_type, ocean_grid_type, ocean_domain_type
use ocean_types_mod,      only: ocean_thickness_type, ocean_velocity_type, ocean_options_type
use ocean_util_mod,       only: write_timestamp, diagnose_3d_u, diagnose_2d_u, write_chksum_3d
use ocean_workspace_mod,  only: wrk1_v

implicit none

public ocean_bihcst_friction_init
public bihcst_friction
public bihcst_viscosity_check
public bihcst_reynolds_check
private delsq_velocity

private

! time step 
real ::  dtime = 0.0  ! forward time step for friction (2*dtuv if threelevel, dtuv if twolevel) 

! for diagnostics 
integer :: id_aiso      =-1
integer :: id_bih_fric_u=-1
integer :: id_bih_fric_v=-1
logical :: used

real, dimension(:,:,:,:), allocatable :: del2_vel  ! del^2 of horizontal velocity
real, dimension(:,:,:),   allocatable :: visc_ceu  ! viscosity on east face of U cells (m^4/s)
real, dimension(:,:,:),   allocatable :: visc_cnu  ! viscosity on north face of U cells (m^4/s)
real, dimension(:,:,:),   allocatable :: visc_cu   ! variable viscosity averaged to U cell (m^4/s)

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()

integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk

character(len=256) :: version=&
  '=>Using: ocean_bihcst_friction.f90 ($Id: ocean_bihcst_friction.F90,v 20.0 2013/12/14 00:14:14 fms Exp $)'

character (len=128) :: tagname = &
  '$Name: tikal $'

logical :: module_is_initialized = .FALSE.
logical :: use_this_module       = .false.
logical :: debug_this_module     = .false.
logical :: have_obc              = .FALSE.
real ::    abih                  = 0.0    ! constant horz biharmonic viscosity (m^4/s)
real ::    vel_micom             = 0.0    ! background scaling velocity for micom viscosity (m/sec) 
real ::    eq_vel_micom          = 0.0    ! background scaling velocity (m/sec) w/i equatorial band for iso-visc
real ::    eq_lat_micom          = 0.0    ! equatorial latitude band for micom (degrees)
logical :: velocity_mix_micom    =.false. ! if true, diffusivity made a function of the grid spacing

namelist /ocean_bihcst_friction_nml/ use_this_module, debug_this_module, abih, &
                                     velocity_mix_micom, vel_micom, eq_vel_micom, eq_lat_micom

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_bihcst_friction_init">
!
! <DESCRIPTION>
! Initialize the horizontal biharmonic friction module by 
! registering fields for diagnostic output and performing some 
! numerical checks to see that viscosity is set appropriately.
! </DESCRIPTION>
!
subroutine ocean_bihcst_friction_init(Grid, Domain, Time, Ocean_options, d_time, &
                                      obc, use_bihcst_friction, debug)
   
  type(ocean_grid_type),   target, intent(in)    :: Grid
  type(ocean_domain_type), target, intent(in)    :: Domain
  type(ocean_time_type),           intent(in)    :: Time
  type(ocean_options_type),        intent(inout) :: Ocean_options
  real,                            intent(in)    :: d_time
  logical,                         intent(in)    :: obc
  logical,                         intent(inout) :: use_bihcst_friction
  logical,               optional, intent(in)    :: debug

  integer :: ioun, io_status, ierr
  integer :: i, j, k
  real, dimension(Domain%isd:Domain%ied,Domain%jsd:Domain%jed) :: Biso

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, '==>Error in ocean_bihcst_friction_init: module already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_bihcst_friction_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_bihcst_friction_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_bihcst_friction_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_bihcst_friction_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_bihcst_friction_nml)  
  write (stdlogunit,ocean_bihcst_friction_nml)

  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk

  if(use_this_module) then 
      call mpp_error(NOTE, '==>Note: USING ocean_bihcst_friction_mod')
      Ocean_options%horz_bih_friction = 'Used constant horizontal biharmonic friction.'
      use_bihcst_friction=.true.
  else
      call mpp_error(NOTE, '==>Note: NOT using ocean_bihcst_friction_mod')
      Ocean_options%horz_bih_friction = 'Did NOT use horizontal biharmonic friction.'
      use_bihcst_friction=.false.
      return 
  endif

  if (PRESENT(debug) .and. .not. debug_this_module) then 
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') &
    '==>Note: running with debug_this_module=.true. so will print lots of checksums.'  
  endif 

  Grd => Grid
  Dom => Domain

  dtime = d_time

  allocate (visc_ceu(isd:ied,jsd:jed,nk))   ! east face of U cell
  allocate (visc_cnu(isd:ied,jsd:jed,nk))   ! north face of U cell
  allocate (visc_cu(isd:ied,jsd:jed,nk))    ! for metric term
  allocate (del2_vel(isd:ied,jsd:jed,nk,2)) ! laplacian of velocity on U cell

  write(stdoutunit,'(/a,f10.2)') &
  '==> Note from ocean_bihcst_friction_mod: using forward time step of (secs)', dtime 

  have_obc = obc
  if (have_obc) then 
    write(stdoutunit,'(/a,f10.2)')'==> Note from ocean_bihcst_friction_mod: considering obc' 
  endif 

  Biso(:,:) = 0.0
  if(velocity_mix_micom) then 
     do j=jsd,jed
        do i=isd,ied
           Biso(i,j) = vel_micom*((2.0*Grd%dxu(i,j)*Grd%dyu(i,j))/(epsln + Grd%dxu(i,j) + Grd%dyu(i,j)))**3
           if(abs(Grd%yu(i,j)) < eq_lat_micom) then
             Biso(i,j) = eq_vel_micom*((2.0*Grd%dxu(i,j)*Grd%dyu(i,j))/(epsln + Grd%dxu(i,j) + Grd%dyu(i,j)))**3
           endif
       enddo  
     enddo
  else
    Biso(:,:) = abs(abih)
  endif 

  ! enhance background viscosity near open boundaries if needed
  if (have_obc) call ocean_obc_enhance_visc_back(Biso, 'bih')

  do k=1,nk
    visc_ceu(:,:,k) = FAX(Biso(:,:))  
    visc_cnu(:,:,k) = FAY(Biso(:,:))  
    visc_cu(:,:,k)  = Biso(:,:)          
  enddo
  call mpp_update_domains (visc_ceu, Dom%domain2d)
  call mpp_update_domains (visc_cnu, Dom%domain2d)
  call mpp_update_domains (visc_cu,  Dom%domain2d)


  ! diagnostics
  id_aiso = register_static_field ('ocean_model', 'aiso_bih', Grd%vel_axes_uv(1:2),      &
            'bih viscosity','m^4/sec',missing_value=missing_value, range=(/-10.0,1.e20/),&
            standard_name='ocean_momentum_xy_biharmonic_diffusivity')
  call diagnose_2d_u(Time, Grd, id_aiso, visc_cu(:,:,1))

  id_bih_fric_u = register_diag_field ('ocean_model', 'bih_fric_u', Grd%vel_axes_uv(1:3), &
                  Time%model_time,'Thickness and rho wghtd horz bih-frict on u',          &
                  '(kg/m^3)*(m^2/s^2)',missing_value=missing_value, range=(/-10.0,1.e10/))
  id_bih_fric_v = register_diag_field ('ocean_model', 'bih_fric_v', Grd%vel_axes_uv(1:3), &
                  Time%model_time,'Thickness and rho wghtd horz bih-frict on v',          &
                  '(kg/m^3)*(m^2/s^2)',missing_value=missing_value, range=(/-10.0,1.e10/))


end subroutine ocean_bihcst_friction_init
! </SUBROUTINE>  NAME="ocean_bihcst_friction_init"


!#######################################################################
! <SUBROUTINE NAME="bihcst_friction">
!
! <DESCRIPTION>
! This subroutine computes the thickness weighted acceleration on
! horizontal velocity arising from horizontal biharmonic friction.
! </DESCRIPTION>
!
subroutine bihcst_friction(Time, Thickness, Velocity, bih_viscosity, energy_analysis_step)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(in)    :: Thickness
  type(ocean_velocity_type),  intent(inout) :: Velocity
  real, dimension(isd:,jsd:), intent(inout) :: bih_viscosity
  logical,                    intent(in)    :: energy_analysis_step

  real, dimension(isd:ied,jsd:jed)   :: metric
  real, dimension(isd:ied,jsd:jed,2) :: uk
  real, dimension(isd:ied,jsd:jed)   :: tmp, tmp1, tmp2, m1, m2, n1, n2
  integer :: i, j, k, n, tau

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_bihcst_friction_mod (horz_bih_friction): module needs initialization')
  endif 

  if(.not. use_this_module) then 

      if(energy_analysis_step) then 
          do n=1,2
             do k=1,nk
                do j=jsc,jec
                   do i=isc,iec
                      Velocity%wrkv(i,j,k,n) = 0.0
                   enddo
                enddo
             enddo
          enddo
      endif

      return 
  endif

  tau = Time%tau 

  metric(:,:)     = 0.0
  wrk1_v(:,:,:,:) = 0.0

  call delsq_velocity (Time, Thickness, Velocity)
  if(Dom%xhalo==1 .or. Dom%yhalo==1 ) call mpp_update_domains (del2_vel(:,:,:,:), Dom%domain2d)

  ! Murray and Reason Eqn 29

  do k=1,nk

    ! metric terms for generalized coordinate system
    m1(:,:) = 2.0*visc_cu(:,:,k)*Grd%dh1dy(:,:) + BAY(FDY_U(visc_cu(:,:,k)))
    m2(:,:) = 2.0*visc_cu(:,:,k)*Grd%dh2dx(:,:) + BAX(FDX_U(visc_cu(:,:,k)))
    tmp1(:,:) = visc_ceu(:,:,k)*Grd%dyue(:,:)
    tmp2(:,:) = visc_cnu(:,:,k)*Grd%dxun(:,:)
    n1(:,:) = - Grd%dyur(:,:)*BDX_EU(tmp1(:,:)*FAX(Grd%dh2dx(:,:))) &
              - Grd%dxur(:,:)*BDY_NU(tmp2(:,:)*FAY(Grd%dh1dy(:,:)))
    n2(:,:) = + Grd%dyur(:,:)*BDX_EU(tmp1(:,:)*FAX(Grd%dh1dy(:,:))) &
              - Grd%dxur(:,:)*BDY_NU(tmp2(:,:)*FAY(Grd%dh2dx(:,:)))

    do n=1,2
       uk(:,:,:) = -del2_vel(:,:,k,:)
       metric(:,:) = (3-2*n)*(m1(:,:)*FDX_NT(BAX(uk(:,:,3-n)))  -&
                              m2(:,:)*FDY_ET(BAY(uk(:,:,3-n)))  )&
            +  n1(:,:)*uk(:,:,n) + (3-2*n)*n2(:,:)*uk(:,:,3-n)
       tmp(:,:) = ( BDX_EU(visc_ceu(:,:,k)*FMX(Thickness%rho_dzu(:,:,k,tau))*FDX_U(uk(:,:,n)))   &
                   +BDY_NU(visc_cnu(:,:,k)*FMY(Thickness%rho_dzu(:,:,k,tau))*FDY_U(uk(:,:,n))) ) &
            +metric(:,:)*Thickness%rho_dzu(:,:,k,tau)

       do j=jsc,jec
          do i=isc,iec  
             wrk1_v(i,j,k,n) = tmp(i,j)*Grd%umask(i,j,k)
          enddo
       enddo

    enddo

  enddo

  if(energy_analysis_step) then 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%wrkv(i,j,k,n) = wrk1_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo

  else 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%accel(i,j,k,n) = Velocity%accel(i,j,k,n) + wrk1_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo

      ! vertically averaged viscosity at U-cell centre
      bih_viscosity(:,:) = 0.0
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               bih_viscosity(i,j) = bih_viscosity(i,j) &
                + Grd%umask(i,j,k)*Thickness%rho_dzu(i,j,k,tau)*visc_cu(i,j,k)
            enddo
         enddo
      enddo
      do j=jsd,jed
         do i=isd,ied
            bih_viscosity(i,j) = Grd%umask(i,j,1)*bih_viscosity(i,j)/(epsln+Thickness%mass_u(i,j,tau))
         enddo
      enddo

      ! diagnostics 
      call diagnose_3d_u(Time, Grd, id_bih_fric_u, wrk1_v(:,:,:,1))
      call diagnose_3d_u(Time, Grd, id_bih_fric_v, wrk1_v(:,:,:,2))
  endif

  if(debug_this_module) then
      write(stdoutunit,*) ' ' 
      write(stdoutunit,*) 'From ocean_bihcst_friction_mod: friction chksums'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('rho_dzu(tau)', Thickness%rho_dzu(COMP,:,tau)*Grd%umask(COMP,:))
      call write_chksum_3d('bihcst friction(1)', wrk1_v(COMP,:,1)*Grd%umask(COMP,:))
      call write_chksum_3d('bihcst friction(2)', wrk1_v(COMP,:,2)*Grd%umask(COMP,:))
  endif 


end subroutine bihcst_friction
! </SUBROUTINE> NAME="bihcst_friction"


!#######################################################################
! <SUBROUTINE NAME="delsq_velocity">
!
! <DESCRIPTION>
! Subroutine computes the laplacian operator acting on velocity.
! </DESCRIPTION>
!
subroutine delsq_velocity (Time, Thickness, Velocity)

  type(ocean_time_type),      intent(in) :: Time
  type(ocean_thickness_type), intent(in) :: Thickness
  type(ocean_velocity_type),  intent(in) :: Velocity

  real, dimension(isd:ied,jsd:jed)       :: fe, fn, metric, n1, n2, tmp
  integer                                :: i, j, k, n, taum1, tau

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_bihcst_friction_mod (delsq_velocity): module needs to be initialized')
  endif 

  taum1 = Time%taum1
  tau   = Time%tau

  metric(:,:)  = 0.0

  ! metric terms for generalized system
  n1(:,:) = - Grd%dyur(:,:)*BDX_EU(Grd%dyue(:,:)*FAX(Grd%dh2dx(:,:)))      &
            - Grd%dxur(:,:)*BDY_NU(Grd%dxun(:,:)*FAY(Grd%dh1dy(:,:)))
  n2(:,:) = + Grd%dyur(:,:)*BDX_EU(Grd%dyue(:,:)*FAX(Grd%dh1dy(:,:)))      &
            - Grd%dxur(:,:)*BDY_NU(Grd%dxun(:,:)*FAY(Grd%dh2dx(:,:)))
  do k=1,nk

    do n=1,2

      ! Viscous flux across east and north face of U cells
      fe(:,:) = FDX_U(Velocity%u(:,:,k,n,taum1))*FMX(Thickness%rho_dzu(:,:,k,tau))
      fn(:,:) = FDY_U(Velocity%u(:,:,k,n,taum1))*FMY(Thickness%rho_dzu(:,:,k,tau))

      metric(:,:) = (3-2*n)*2.0*(Grd%dh1dy(:,:)*FDX_NT(BAX(Velocity%u(:,:,k,3-n,taum1)))-&
                                 Grd%dh2dx(:,:)*FDY_ET(BAY(Velocity%u(:,:,k,3-n,taum1)))  )& 
       + n1(:,:)*Velocity%u(:,:,k,n,taum1) + (3-2*n)*n2(:,:)*Velocity%u(:,:,k,3-n,taum1)

      ! note: do not use rho_dzur since rho_dzur is at time taup1
      tmp(:,:) =  BDX_EU(fe(:,:)) + BDY_NU(fn(:,:))
      do j=jsc,jec
         do i=isc,iec  
            del2_vel(i,j,k,n) = ( tmp(i,j)/Thickness%rho_dzu(i,j,k,tau) + metric(i,j) )*Grd%umask(i,j,k) 
         enddo
      enddo

    enddo
  enddo 

end subroutine delsq_velocity
! </SUBROUTINE> NAME="delsq_tracer"


!#######################################################################
! <SUBROUTINE NAME="bihcst_viscosity_check">
!
! <DESCRIPTION>
! Subroutine to perform linear stability check for the biharmonic
! operator given a value for the horizontal biharmonic viscosity.
! </DESCRIPTION>
!
subroutine bihcst_viscosity_check

  integer :: num, i, j, k
  integer, save :: unit=6, max_num=3
  real :: dsmin, crit

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return 
 
  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, '==>Error in ocean_bihcst_friction_mod (bih_viscosity_check): needs initialization')
  endif 

  write (stdoutunit,'(//60x,a/)') ' Excessive horizontal biharmonic friction summary:'
  write (stdoutunit,'(1x,a/)')'Locations (if any) where viscosity exceeds conservative linear stability constraint'
  num = 0
  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        if (Grd%umask(i,j,k) > 0.0) then            
          dsmin = min(Grd%dxu(i,j),Grd%dxu(i+1,j),Grd%dyu(i,j),Grd%dyu(i,j+1))
          crit = 0.0625*dsmin**4/max(dtime,epsln)
          if (visc_cu(i,j,k) > crit .and. num < max_num ) then
            num = num + 1
            write (unit,9600) 'visc_cu(',visc_cu(i,j,k), crit, i, j, k, Grd%xu(i,j), Grd%yu(i,j), Grd%zt(k), mpp_pe()
          endif
        endif 
      enddo
    enddo
  enddo
  call mpp_sum (num)
  if (num > max_num) write (stdoutunit,*) ' (a max of ',max_num,' violations per pe are listed)'

9600  format(/' Warning: ',a,es10.3,' m^4/s) exceeds max value (',es10.3,') at (i,j,k) = ','(',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.0,'m, pe=',i3,')')


end subroutine bihcst_viscosity_check
! </SUBROUTINE> NAME="bihcst_viscosity_check"


!#######################################################################
! <SUBROUTINE NAME="bihcst_reynolds_check">
!
! <DESCRIPTION>
! Subroutine to compute the biharmonic grid Reynolds number.  Large 
! Reynolds numbers indicate regions where solution may experience 
! some grid noise due to lack of enough horizontal friction. 
! </DESCRIPTION>
!
subroutine bihcst_reynolds_check(Time, Velocity)

  type(ocean_time_type),     intent(in) :: Time
  type(ocean_velocity_type), intent(in) :: Velocity

  real :: rame, ramn, reyx, reyy
  real :: reynx0, reyny0, reynx,reyny, reynu,reynv, reynmu,reynmv
  integer :: ireynx,jreynx,kreynx, ireyny,jreyny,kreyny
  integer :: i, j, k, tau
  integer, save :: unit=6

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, '==>Error in ocean_bihcst_friction_mod (bih_reynolds_check): needs initialization')
  endif 

  tau = Time%tau

  ! look for max grid reynolds numbers using velocities at "tau".

  ireynx=isc; jreynx=jsc; kreynx=1; reynx=0.0
  ireyny=isc; jreyny=jsc; kreyny=1; reyny=0.0
  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        rame = 1.0/(visc_cu(i,j,k) + epsln)
        ramn = 1.0/(visc_cu(i,j,k) + epsln)

        reyx = abs(Velocity%u(i,j,k,1,tau)*Grd%dxu(i,j)**3)*rame
        if (reyx > reynx) then
          ireynx = i
          jreynx = j
          kreynx = k
          reynx  = reyx
          reynu  = Velocity%u(i,j,k,1,tau)
          reynmu = 1.0/rame
        endif
        reyy = abs(Velocity%u(i,j,k,2,tau)*Grd%dyu(i,j)**3)*ramn
        if (reyy > reyny) then
          ireyny = i
          jreyny = j
          kreyny = k
          reyny  = reyy
          reynv  = Velocity%u(i,j,k,2,tau)
          reynmv = 1.0/ramn
        endif

      enddo
    enddo
  enddo
  write (stdoutunit,'(/60x,a/)') ' Horizontal biharmonic Reynolds number summary'

  reynx0 = reynx
  reyny0 = reyny
  call mpp_max(reynx)
  call mpp_max(reyny)
  
  if (reynx == reynx0) then
    write (unit,10300) reynx, ireynx, jreynx, kreynx, &
                       Grd%xu(ireynx,jreynx), Grd%yu(ireynx,jreynx), Grd%zt(kreynx), reynu, reynmu
  endif
  
  if (reyny == reyny0) then
    write (unit,10400) reyny, ireyny, jreyny, kreyny, &
                       Grd%xu(ireyny,jreyny), Grd%yu(ireyny,jreyny), Grd%zt(kreyny), reynv, reynmv
  endif

  10300 format (1x,'Maximum zonal Re =',es9.2,' at (i,j,k) = (',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.2,'), U =',es9.2, ', mix =',e9.2)
  10400 format (1x,'Maximum merid Re =',es9.2,' at (i,j,k) = (',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.2,'), V =',es9.2, ', mix =',e9.2)


end subroutine bihcst_reynolds_check
! </SUBROUTINE> NAME="bihcst_reynolds_check"


end module ocean_bihcst_friction_mod
      
      

! nf95 -r8 -g -I ~/regression/ia64/23-Jun-2005/CM2.1U_Control-1990_E1.k32pe/include/ -D_TEST_CLOUD_INTERPOLATOR -D_F95 cloud_interpolator.F90

#include <fms_platform.h>

#define _FLATTEN(A) reshape((A), (/size((A))/) )

MODULE cloud_interpolator_mod
  implicit none
  private

  public :: cld_ntrp_linear_cell_interp, cld_ntrp_locate_cell, cld_ntrp_get_cell_values
#ifdef _TEST_CLOUD_INTERPOLATOR
  public :: cld_ntrp_expand_index, cld_ntrp_contract_indices
#endif

character(128), parameter :: version = '$Id$'
real, parameter           :: tol = 10.0*epsilon(1.)

CONTAINS

!...............................................................................
  _PURE subroutine cld_ntrp_expand_index(Ic, ie, ier)
    integer, intent(in)  ::  Ic    ! contacted index
    integer, intent(out) ::  ie(:) ! expanded list of indices
    integer, intent(out) ::  ier   ! error flag (0=ok)

    integer j, nd

    ier =  0
    nd  = size(ie) ! dimension

    if(Ic >= 2**nd) then
       ie  = -1
       ier = 1 ! error
       return
    endif

    do j = 1, nd
       ie(j) = mod(Ic/2**(j-1), 2)
    end do
    
  end subroutine cld_ntrp_expand_index

!...............................................................................
!...............................................................................
  _PURE subroutine cld_ntrp_contract_indices(ie, Ic, ier)
    integer, intent(in) ::  ie(:)  ! expanded list of indices
    integer, intent(out)  ::  Ic   ! contacted index
    integer, intent(out) ::  ier   ! error flag (0=ok)

    integer j, nd    

    ier = 0
    nd  = size(ie) ! dimension

    Ic = ie(nd)
    do j = nd-1, 1, -1
       Ic = Ic * 2
       Ic = Ic + ie(j)
    end do

    if(Ic >= 2**nd) ier = 1

  end subroutine cld_ntrp_contract_indices

  
!...............................................................................
!...............................................................................
  _PURE subroutine cld_ntrp_linear_cell_interp(fvals, ts, f, ier)
    real, intent(in) :: fvals(0:)  ! values at the cell nodes
    real, intent(in) :: ts(:)      ! normalized [0,1]^nd cell coordinates
    real, intent(out):: f          ! interpolated value
    integer, intent(out) ::  ier   ! error flag (0=ok)
    
    integer j, nd, Ic, iflag
    integer ie(size(fvals))
    real    basis

    ier = 0
    f   = 0.
    nd   = size(ts)
    if(size(fvals) /= 2**nd) then
       ier = 1
       return
    endif
    
    do Ic = 0, 2**nd - 1
       basis = 1.
       call cld_ntrp_expand_index(Ic, ie, iflag)
       do j = 1, nd
          basis = basis * (  (1.0-real(ie(j)))*(1.0-ts(j)) + real(ie(j))*ts(j) )
       end do
       f = f + fvals(Ic)*basis
    end do
    
  end subroutine cld_ntrp_linear_cell_interp

!...............................................................................
!...............................................................................
  _PURE subroutine cld_ntrp_locate_cell(axis, x, index, ier)
    real, intent(in)     :: axis(:) ! axis 
    real, intent(in)     :: x       ! abscissae
    integer, intent(out) :: index   ! lower-left corner index
    integer, intent(out) ::  ier    ! error flag (0=ok)

    logical down
    integer n, index1, is
    real axis_1, axis_n, axis_min, axis_max
    ier   = 0
    index = -1
    down = .FALSE.
    n = size(axis)
    if(n < 2) then
       ier = 3
       return
    endif
    axis_1 = axis(1)
    axis_n = axis(n)
    axis_min = axis_1
    axis_max = axis_n
    if(axis_1 > axis_n) then
       down = .TRUE.
       axis_min = axis_n
       axis_max = axis_1
    endif

    if(x < axis_min-tol) then
       ier = 1
       return
    endif
    if(x > axis_max+tol) then
       ier = 2
       return
    endif

    index = floor(real(n-1)*(x - axis_1)/(axis_n-axis_1)) + 1
    index  = min(n-1, index)
    index1 = index+1

    if(.NOT. down) then
       if(axis(index) <= x+tol) then
          if(x <= axis(index1)+tol) then
             ! axis is uniform, or nearly so. Done!
             return
          else
             ! increase index
             is = index+1
             do index = is, n-1
                index1 = index+1
                if(axis(index1) >= x-tol) return
             enddo
          endif
       else
          ! decrease index
          is = index - 1
          do index = is, 1, -1
             if(axis(index) <= x+tol) return
          enddo
       endif
    else
       ! axis is pointing down
       if(axis(index) >= x-tol) then
          if(x >= axis(index1)-tol) then
             ! axis is uniform, or nearly so. Done!
             return
          else
             ! increase index
             is = index + 1
             do index = is, n-1
                index1 = index+1
                if(axis(index1) <= x+tol) return
             enddo
          endif
       else
          ! decrease index
          is = index - 1
          do index = is, 1, -1
             if(axis(index) >= x-tol) return
          enddo
       endif
    endif    
    
  end subroutine cld_ntrp_locate_cell

!...............................................................................
!...............................................................................
  _PURE subroutine cld_ntrp_get_flat_index(nsizes, indices, flat_index, ier)
    integer, intent(in)  :: nsizes(:)  ! size of array along each axis
    integer, intent(in)  :: indices(:) ! cell indices
    integer, intent(out) :: flat_index ! index into flattened array
    integer, intent(out) ::  ier       ! error flag (0=ok)

    integer nd, id

    ier = 0
    flat_index = -1
    nd = size(nsizes)
    if(nd /= size(indices)) then
       ! size mismatch
       ier = 1
       return
    endif
    
    flat_index = indices(nd)-1
    do id = nd-1, 1, -1
       flat_index = flat_index*nsizes(id) + indices(id)-1
    enddo
    flat_index = flat_index + 1    
    
  end subroutine cld_ntrp_get_flat_index

!...............................................................................
!...............................................................................
  _PURE subroutine cld_ntrp_get_cell_values(nsizes, fnodes, indices, fvals, ier)
    integer, intent(in)  :: nsizes(:)  ! size of fnodes along each axis
    real, intent(in)     :: fnodes(:)  ! flattened array of node values
    integer, intent(in)  :: indices(:) ! cell indices
    real, intent(out)    :: fvals(0:)  ! returned array values in the cell
    integer, intent(out) ::  ier       ! error flag (0=ok)

    integer id, nt, nd, flat_index, Ic, iflag
    integer, dimension(size(nsizes)) :: cell_indices, node_indices
    ier = 0
    fvals = 0.

    nd = size(nsizes)
    if(nd /= size(indices)) then
       ! size mismatch
       ier = 1
       return
    endif
    if(2**nd > size(fvals)) then
       ! not enough elements to hold result
       ier = 2
       return
    endif
    nt = 1
    do id = 1, nd
       nt = nt * nsizes(id)
    enddo
    if(nt /= size(fnodes)) then
       ! not enough node values
       ier = 3
       return
    endif

    do Ic = 0, 2**nd-1
       call cld_ntrp_expand_index(Ic, cell_indices, iflag)
       node_indices = indices + cell_indices
       call cld_ntrp_get_flat_index(nsizes, node_indices, flat_index, iflag)
       fvals(Ic) = fnodes(flat_index)
    enddo
    
  end subroutine cld_ntrp_get_cell_values

end MODULE cloud_interpolator_mod
!===============================================================================

#ifdef _TEST_CLOUD_INTERPOLATOR
program test
  use cloud_interpolator_mod
  implicit none

  call test_expansion_contraction
  call test_linear_cell_interpolation
  call test_cell_search
  call test_get_node_values

  contains
    subroutine test_expansion_contraction
      integer ie1(4), ie2(4), Ic, ier, idiff, j
      ie1 = (/1,0,1,1/)
      call cld_ntrp_contract_indices(ie1, Ic, ier)
      if(ier/=0) print *,'ERROR flag ier=', ier
      call cld_ntrp_expand_index(Ic, ie2, ier)
      if(ier/=0) print *,'ERROR flag ier=', ier
      idiff = 0
      do j = 1, size(ie1)
         idiff = idiff + abs(ie1(j)-ie2(j))
      end do
      if(idiff/=0) then
         print *,'ERROR: contraction/expansion test failed (ie1/=ie2)'
      endif
      print *,'ie1 = ', ie1
      print *,'ie2 = ', ie2
      print *,'Ic  = ', Ic
      
    end subroutine test_expansion_contraction

    subroutine test_linear_cell_interpolation
      integer, parameter :: nd = 3 
      real :: fvals(2**nd), ts(nd)
      real :: fi, fx
      integer ier
      ! f  = 1 + x + 2*y + 3*z
      fvals = (/ 1., 2., 3., 4., 4., 5., 6., 7. /)
      ts    = (/ 0.1, 0.2, 0.3 /)
      fx    = 1. + ts(1) + 2*ts(2) + 3*ts(3)
      call cld_ntrp_linear_cell_interp(fvals, ts, fi, ier)
      if(ier/=0) print *,'ERROR flag ier=', ier
      print *,'fi, fx = ', fi, fx
    end subroutine test_linear_cell_interpolation

    subroutine test_cell_search
      integer index, ier
      integer, parameter :: n = 5
      real :: axis1(n) = (/0., 0.1, 0.2, 0.3, 0.4/)
      real :: axis2(n) = (/0., 0.01, 0.02, 0.03, 0.4/)
      real :: axis3(n) = (/0.4, 0.3, 0.2, 0.1, 0./)
      real :: axis4(n) = (/0.4, 0.03, 0.02, 0.01, 0./)
      real x
      integer :: ier_tot = 0
      
      print *,'axis1=', axis1
      x = -0.0001
      call cld_ntrp_locate_cell(axis1, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', -1
      ier_tot = ier_tot + abs(index - (-1))
      x = 0.
      call cld_ntrp_locate_cell(axis1, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', 1
      ier_tot = ier_tot + abs(index - (1))
      x = 0.1
      call cld_ntrp_locate_cell(axis1, x, index, ier)
      print *, ' x=',x, ' index=', index, ' ==? ', 2
      ier_tot = ier_tot + abs(index - (2))
      x = 0.4
      call cld_ntrp_locate_cell(axis1, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', 4
      ier_tot = ier_tot + abs(index - (4))
      x = 0.40001
      call cld_ntrp_locate_cell(axis1, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', -1
      ier_tot = ier_tot + abs(index - (-1))

      print *,'axis2=', axis1
      x = -0.0001
      call cld_ntrp_locate_cell(axis2, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', -1
      ier_tot = ier_tot + abs(index - (-1))
      x = 0.
      call cld_ntrp_locate_cell(axis2, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', 1
      ier_tot = ier_tot + abs(index - (1))
      x = 0.1
      call cld_ntrp_locate_cell(axis2, x, index, ier)
      print *, ' x=',x, ' index=', index, ' ==? ', 4
      ier_tot = ier_tot + abs(index - (4))
      x = 0.4
      call cld_ntrp_locate_cell(axis2, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', 4
      ier_tot = ier_tot + abs(index - (4))
      x = 0.40001
      call cld_ntrp_locate_cell(axis2, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', -1
      ier_tot = ier_tot + abs(index - (-1))

      print *,'axis3=', axis1
      x = -0.0001
      call cld_ntrp_locate_cell(axis3, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', -1
      ier_tot = ier_tot + abs(index - (-1))
      x = 0.
      call cld_ntrp_locate_cell(axis3, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', 4
      ier_tot = ier_tot + abs(index - (4))
      x = 0.1
      call cld_ntrp_locate_cell(axis3, x, index, ier)
      print *, ' x=',x, ' index=', index, ' ==? ', 4
      ier_tot = ier_tot + abs(index - (4))
      x = 0.4
      call cld_ntrp_locate_cell(axis3, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', 1
      ier_tot = ier_tot + abs(index - (1))
      x = 0.40001
      call cld_ntrp_locate_cell(axis3, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', -1
      ier_tot = ier_tot + abs(index - (-1))

      print *,'axis4=', axis1
      x = -0.0001
      call cld_ntrp_locate_cell(axis4, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', -1
      ier_tot = ier_tot + abs(index - (-1))
      x = 0.
      call cld_ntrp_locate_cell(axis4, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', 4
      ier_tot = ier_tot + abs(index - (4))
      x = 0.1
      call cld_ntrp_locate_cell(axis4, x, index, ier)
      print *, ' x=',x, ' index=', index, ' ==? ', 1
      ier_tot = ier_tot + abs(index - (1))
      x = 0.4
      call cld_ntrp_locate_cell(axis4, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', 1
      ier_tot = ier_tot + abs(index - (1))
      x = 0.40001
      call cld_ntrp_locate_cell(axis4, x, index, ier)
      print *,' x=',x, ' index=', index, ' ==? ', -1
      ier_tot = ier_tot + abs(index - (-1))

      print *,'Total error in test_cell_search: ', ier_tot

    end subroutine test_cell_search

    subroutine test_get_node_values
      integer, parameter :: nd = 3, n1=6, n2=5, n3=4
      real, dimension(n1, n2, n3) :: fnodes
      real :: fvals(2**nd), fexact(2**nd)
      real x, y, z
      integer i, j, k, ier, indices(nd)
      real :: error_tot = 0.
      do k = 1, n3
         do j = 1, n2
            do i = 1, n1
               x = 1* real(i-1)/real(n1-1)
               y = 2* real(j-1)/real(n2-1)
               z = 3* real(k-1)/real(n3-1)
               fnodes(i,j,k) = x + y*z**2
            enddo
         enddo
      enddo

      indices = (/1,1,1/)
      call cld_ntrp_get_cell_values((/n1,n2,n3/), _FLATTEN(fnodes), indices, fvals, ier)
      fexact = (/0.0, 0.2, 0.0, 0.2, 0.0, 0.2, 0.5, 0.7/)
      if(ier/=0) print *,'ERROR flag ier=', ier
      print *,'indices ', indices
      print *,'fvals=', fvals, ' ==? ', fexact
      error_tot = error_tot + abs(sum(fvals - fexact))

      indices = (/5,4,2/)
      call cld_ntrp_get_cell_values((/n1,n2,n3/), _FLATTEN(fnodes), indices, fvals, ier)
      fexact = (/2.3, 2.5, 2.8, 3.0, 6.8, 7.0, 8.8, 9.0/)
      if(ier/=0) print *,'ERROR flag ier=', ier
      print *,'indices ', indices
      print *,'fvals=', fvals, ' ==? ', fexact
      error_tot = error_tot + abs(sum(fvals - fexact))

      print *,'Total error in test_get_node_values: ', error_tot


    end subroutine test_get_node_values

  end program test

#endif

!
! Cloud micro-physics package for GFDL global cloud resolving model
! The algorithms are originally based on Lin et al 1983. Many key
! elements have been changed/improved based on several other publications
! Developer: Shian-Jiann Lin
!
module lin_cld_microphys_mod
 use time_manager_mod,  only: time_type
 use fms_mod,           only: write_version_number, open_namelist_file, &
                              check_nml_error, file_exist, close_file,  &
                              error_mesg, FATAL

 implicit none
 private

 public  lin_cld_microphys_driver, lin_cld_microphys_init, lin_cld_microphys_end
 public  qsmith_init, qsmith, g_sum, wqsat_moist, wqsat2_moist, sat_adj2

!---- version number -----
 character(len=128) :: version = '$Id: lin_cloud_microphys.F90,v 20.0.2.1 2013/12/17 19:46:01 Niki.Zadeh Exp $'
 character(len=128) :: tagname = '$Name: nullify_rab_nnz $'

 contains


  subroutine lin_cld_microphys_driver(qv,    ql,    qr,    qi,    qs,    qg,    qa,  &
                               qv_dt, ql_dt, qr_dt, qi_dt, qs_dt, qg_dt, qa_dt,      &
                               pt_dt, pt, p3, dz,  delp, area, dt_in,                &
                               land,  rain, snow, ice, graupel,                      &
                               hydrostatic, phys_hydrostatic,                        &
                               iis,iie, jjs,jje, kks,kke, ktop, kbot, time)

  type(time_type), intent(in):: time
  logical,         intent(in):: hydrostatic, phys_hydrostatic
  integer,         intent(in):: iis,iie, jjs,jje  ! physics window
  integer,         intent(in):: kks,kke           ! vertical dimension
  integer,         intent(in):: ktop, kbot        ! vertical compute domain
  real,            intent(in):: dt_in

  real, intent(in   ), dimension(:,:)  :: area
  real, intent(in   ), dimension(:,:)  :: land  !land fraction
  real, intent(out  ), dimension(:,:)  :: rain, snow, ice, graupel
  real, intent(in   ), dimension(:,:,:):: p3, delp, dz    ! p3 not used
  real, intent(in   ), dimension(:,:,:):: pt, qv, ql, qr, qi, qs, qg, qa
  real, intent(inout), dimension(:,:,:):: pt_dt,  qa_dt
  real, intent(inout), dimension(:,:,:):: qv_dt, ql_dt, qr_dt, qi_dt,  &
                                          qs_dt, qg_dt

  call error_mesg ('lin_cloud_microphys_mod', 'lin_cloud_microphysics should not be active', FATAL)

  end subroutine lin_cld_microphys_driver


 subroutine sat_adj2(mdt, is, ie, js, je, ng, km, k, hydrostatic, consv_te, &
                     te0, qv, ql, qi, qr, qs, qa, area, peln, delz, pt, dp, last_step)
! This is designed for 6-class micro-physics schemes
! input pt is T_vir
 real, intent(in):: mdt
 integer, intent(in):: is, ie, js, je, km, ng, k
 logical, intent(in):: hydrostatic, last_step
 logical, intent(in):: consv_te
 real, intent(in), dimension(is-ng:ie+ng,js-ng:je+ng):: dp, area
 real, intent(in):: delz(is:ie,js:je)      ! Delta p at each model level
 real, intent(in):: peln(is:ie,km+1,js:je)           ! ln(pe)
 real, intent(inout), dimension(is-ng:ie+ng,js-ng:je+ng):: pt, qv, ql, qi, qr, qs, qa
 real, intent(inout):: te0(is:ie,js:je)

 call error_mesg ('lin_cloud_microphys_mod', 'lin_cloud_microphysics should not be active', FATAL)

 end subroutine sat_adj2


 subroutine lin_cld_microphys_init(id, jd, kd, axes, time)

    integer,         intent(in) :: id, jd, kd
    integer,         intent(in) :: axes(4)
    type(time_type), intent(in) :: time

 call error_mesg ('lin_cloud_microphys_mod', 'lin_cloud_microphysics should not be active', FATAL)

 end subroutine lin_cld_microphys_init


 subroutine lin_cld_microphys_end

 call error_mesg ('lin_cloud_microphys_mod', 'lin_cloud_microphysics should not be active', FATAL)

 end subroutine lin_cld_microphys_end


 subroutine qsmith_init

 call error_mesg ('lin_cloud_microphys_mod', 'lin_cloud_microphysics should not be active', FATAL)

 end subroutine qsmith_init


 real function wqsat2_moist(ta, qv, pa, dqdt)
  real, intent(in):: ta, pa, qv
  real, intent(out):: dqdt

 call error_mesg ('lin_cloud_microphys_mod', 'lin_cloud_microphysics should not be active', FATAL)

 end function wqsat2_moist

 real function wqsat_moist(ta, qv, pa)
  real, intent(in):: ta, pa, qv

 call error_mesg ('lin_cloud_microphys_mod', 'lin_cloud_microphysics should not be active', FATAL)

 end function wqsat_moist


 subroutine qsmith(im, km, ks, t, p, q, qs, dqdt)
  integer, intent(in):: im, km, ks
  real, intent(in),dimension(im,km):: t, p, q
  real, intent(out),dimension(im,km):: qs
  real, intent(out), optional:: dqdt(im,km)

  call error_mesg ('lin_cloud_microphys_mod', 'lin_cloud_microphysics should not be active', FATAL)

  end subroutine qsmith

 real function g_sum(p, ifirst, ilast, jfirst, jlast, area, mode)
 use mpp_mod,           only: mpp_sum
 integer, intent(IN) :: ifirst, ilast
 integer, intent(IN) :: jfirst, jlast
 integer, intent(IN) :: mode  ! if ==1 divided by area
 real, intent(IN) :: p(ifirst:ilast,jfirst:jlast)      ! field to be summed
 real, intent(IN) :: area(ifirst:ilast,jfirst:jlast)

 call error_mesg ('lin_cloud_microphys_mod', 'lin_cloud_microphysics should not be active', FATAL)

 end function g_sum

end module lin_cld_microphys_mod

module ocean_vert_gotm_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="mschmidt@io-warnemuende.de"> Martin Schmidt 
!</CONTACT>
!
!<CONTACT EMAIL="Mike.Herzfeld@csiro.au"> Mike Herzfeld
!</CONTACT>
!
!<CONTACT EMAIL="Russell.Fiedler@csiro.au"> Russell Fiedler 
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Vertical viscosity and diffusivity according GOTM.
!</OVERVIEW>
!
!<DESCRIPTION>
! This module contains interfaces to initialize and invoke the 
! Generalized Ocean Turbulence Model (GOTM) parameterizations.
! Full documentation of the schemes available with GOTM 
! can be found at www.gotm.net.
!
! MOM is distributed with the basic routines from the 4.0
! release of GOTM.  Questions about GOTM should be directed 
! to the GOTM users group at www.gotm.net.  
!
! This module assumes a twolevel time stepping scheme is used 
! to update the turbulence scalar fields tke and diss. 
!
! Presently it has only been implemented assuming Bgrid.
! So it needs to be updated for Cgrid layout.  
!
! Here is a brief outline of the GOTM scheme:
!
! The non-conservative part of the tke 
! equation is P+B-diss, where P=shear production, 
! B=buoyancy production.  The non-conservative part of 
! the diss equation is a linear combination of tke, 
! P, B and diss. 
!
! The conservatie part of both tke and diss equations is 
! 3D advection.  
!
! So vertical shear and buoyancy contribute to the 
! source and sinks (respectively) of tke and dissipation. 
!
! The mixing coefficients are the product of a stability
! function, sqrt(tke), and turbulence length scale (the latter 
! a non-linear function of tke and diss). 
!
! In the hydro model (i.e., MOM), buoyancy fluxes are the 
! surface boundary conditions for vertical diffusion of temp (heat
! fluxes) and salt (freshwater fluxes), which in turn determine the
! density, and thus enter GOTM via the calculation of buoyancy production.
!
! Hence, buoyancy fluxes are NOT directly required as surface boundary 
! conditions for GOTM. 
!
! Wind stress provides the surface boundary condition for vertical 
! momentum mixing in MOM.  This information then enters GOTM 
! via the shear production calculation.  However, wind stress
! can enter the GOTM tke equation as the surface boundary 
! condition for vertical diffusion of tke (i.e. the prescribed, 
! or Dirichlet, condition). This information is typically used in  
! Mellor-Yamada turbulence models. An alternate no-flux (Neumann)
! condition is used in the k-e models, and so do not require wind stress.
!
! Boundary conditions for vertical diffusion of diss involve roughness,
! tke, and constants (both Neumann and Dirichlet). 
!
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! Burchard, H., K. Bolding and M. R. Villarreal
! GOTM, a general ocean turbulence model. Theory
! implementation and test cases.
! European Communities, EUR 18745 EN, 1999
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_vert_gotm_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is .false. 
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging.  Default is .false. 
!  </DATA> 
!  <DATA NAME="do_turbulence_gotm" TYPE="logical">
!  For debugging.  If do_turbulence_gotm=.false., then
!  will not invoke the GOTM scheme. Will only advect 
!  tke and diss using 3d advection scheme. 
!  Default is .true., so that will invoke GOTM scheme.  
!  </DATA> 
!  <DATA NAME="do_advection_gotm" TYPE="logical">
!  For debugging.  If do_advection_gotm=.false., then
!  will not invoke the advection of tke and diss. 
!  Default is .true., so that will 3d advect tke and diss. 
!  </DATA> 
!  <DATA NAME="write_a_restart" TYPE="logical">
!  Set true to write a restart.  False setting only for rare 
!  cases where wish to benchmark model without measuring the cost
!  of writing restarts and associated chksums.  
!  Default is write_a_restart=.true. 
!  </DATA> 
!
!  <DATA NAME="advect_gotm_method" TYPE="character">
!  For choosing how to advect the GOTM scalar fields tke and diss.
!  Options are advect_gotm_method='upwind' (the default) 
!              advect_gotm_method='sweby'
!  </DATA> 
!
!  <DATA NAME="diff_cbt_min" UNITS="m^2/sec" TYPE="real">
!  Background diffusivity.  Default is 1.0e-5. 
!  </DATA> 
!  <DATA NAME="visc_cbu_min" UNITS="m^2/sec" TYPE="real">
!  Background viscosity.  Default is 1.0e-5. 
!  </DATA> 
!  <DATA NAME="z0s" UNITS="m" TYPE="real">
!  Surface roughness length.  Default is 1m.
!  </DATA> 
!  <DATA NAME="z0b" UNITS="m" TYPE="real">
!  Bottom roughness length.  Default is .002m.
!  </DATA> 
!  <DATA NAME="min_tke" UNITS="m^2/s^2" TYPE="real">
!  Minimum turbulent kinetic energy.  Default=1.0e-6.
!  </DATA> 
!  <DATA NAME="min_diss" UNITS="m^2/s^3" TYPE="real">
!  Minimum energy dissipation.  Default=1.0e-10.
!  </DATA> 
!
!</NAMELIST>

use constants_mod,    only: epsln
use diag_manager_mod, only: register_diag_field, register_static_field
use fms_mod,          only: FATAL, WARNING, stdout, stdlog
use fms_mod,          only: write_version_number, open_namelist_file, check_nml_error, close_file
use fms_mod,          only: file_exist 
use fms_io_mod,       only: register_restart_field, save_restart, restore_state
use fms_io_mod,       only: restart_file_type, reset_field_pointer
use mpp_domains_mod,  only: mpp_update_domains, NUPDATE, EUPDATE, XUPDATE, YUPDATE
use mpp_mod,          only: input_nml_file, mpp_error

use mtridiagonal,     only: init_tridiagonal
use turbulence,       only: init_turbulence, do_turbulence, tke, eps, num, nuh
use turbulence,       only: L1d => l, cde

use ocean_domains_mod,    only: set_ocean_domain, get_local_indices
use ocean_parameters_mod, only: missing_value, onesixth, rho0r, grav 
use ocean_types_mod,      only: ocean_grid_type, ocean_domain_type
use ocean_types_mod,      only: ocean_prog_tracer_type, ocean_adv_vel_type
use ocean_types_mod,      only: ocean_density_type, ocean_velocity_type
use ocean_types_mod,      only: ocean_time_type, ocean_time_steps_type, ocean_thickness_type
use ocean_types_mod,      only: ocean_gotm_type, advect_gotm_type
use ocean_util_mod,       only: write_timestamp, diagnose_2d, diagnose_3d, diagnose_3d_u, write_chksum_3d
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3, wrk4, wrk1_v
use ocean_obc_mod,        only: ocean_obc_mixing, ocean_obc_zero_boundary

implicit none

private

public  ocean_vert_gotm_init
public  ocean_vert_gotm_end
public  vert_mix_gotm_bgrid 
public  advect_gotm_compute
public  ocean_vert_gotm_restart

private advect_gotm_sweby
private advect_gotm_upwind 


#include <ocean_memory.h>


#ifdef MOM_STATIC_ARRAYS

real, dimension(isd:ied,jsd:jed,nk)         :: visc_cbt_gotm ! vertical viscosity (m^2/s)
real, dimension(isd:ied,jsd:jed,nk)         :: diff_cbt_gotm ! vertical diffusivity (m^2/s)
real, dimension(isd:ied,jsd:jed,nk)         :: drhodT        ! drho/dtheta     (kg/(m^3*C))
real, dimension(isd:ied,jsd:jed,nk)         :: drhodS        ! drho/dsalinity  (kg/(m^3*psu))
real, dimension(isc-2:iec+2,jsc-2:jec+2,nk) :: tmask_advect  ! advection mask
real, dimension(isd:ied,jsd:jed,nk)         :: flux_x        ! for x-advection
real, dimension(isd:ied,jsd:jed,nk)         :: flux_y        ! for y-advection
real, dimension(isd:ied,jsd:jed,nk)         :: flux_z        ! for z-advection
real, dimension(isd:ied,jsd:jed,nk)         :: gotm_tendency ! for advection tendency 

#else

real, dimension(:,:,:), allocatable :: visc_cbt_gotm ! vertical viscosity (m^2/s)
real, dimension(:,:,:), allocatable :: diff_cbt_gotm ! vertical diffusivity (m^2/s)
real, dimension(:,:,:), allocatable :: drhodT        ! drho/dtheta     (kg/m^3/C)
real, dimension(:,:,:), allocatable :: drhodS        ! drho/dsalinity  (kg/m^3/psu)
real, dimension(:,:,:), allocatable :: tmask_advect  ! advection mask
real, dimension(:,:,:), allocatable :: flux_x        ! for x-advection
real, dimension(:,:,:), allocatable :: flux_y        ! for y-advection
real, dimension(:,:,:), allocatable :: flux_z        ! for z-advection
real, dimension(:,:,:), allocatable :: gotm_tendency ! for advection tendency 

#endif

! number of GOTM fields that have time dimensions 
integer, parameter :: num_gotm = 2

! time step (secs) for evolving prognostic GOTM fields 
real :: dtime

! time step labels for gotm updates using two-level scheme 
integer :: tau_gotm
integer :: taup1_gotm

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), save    :: Dom_advect_gotm
type(advect_gotm_type), save, dimension(num_gotm) :: advect_gotm
type(ocean_gotm_type),  save, dimension(num_gotm) :: Gotm

integer :: index_tke
integer :: index_diss
integer :: num_prog_tracers=0
integer :: num_diag_tracers=0
integer :: index_temp
integer :: index_salt


! identification for diagnostic output
integer :: id_diff_cbt_gotm
integer :: id_visc_cbt_gotm
integer :: id_visc_cbu_gotm
integer :: id_gotm_nn
integer :: id_gotm_ss
logical :: used
integer, dimension(:), allocatable :: id_gotm_diag
integer, dimension(:), allocatable :: id_adv_flux_x
integer, dimension(:), allocatable :: id_adv_flux_y
integer, dimension(:), allocatable :: id_adv_flux_z
integer, dimension(:), allocatable :: id_adv_flux_x_int_z
integer, dimension(:), allocatable :: id_adv_flux_y_int_z
integer, dimension(:), allocatable :: id_gotm_errors

! for restart
integer  :: id_restart_tke
integer  :: id_restart_diss
integer  :: id_restart_diff
integer  :: id_restart_visc
type(restart_file_type), save :: Got_restart

character(len=256) :: version=&
     '$Id: ocean_vert_gotm.F90,v 20.0 2013/12/14 00:16:40 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

logical :: module_is_initialized = .FALSE.
integer :: advection_gotm_method = 1  ! internally set: 1=upwind, 2=sweby 
logical :: have_obc=.false.           ! for running with OBC

! nml parameters 
character(len=10) :: advect_gotm_method = 'upwind' ! options are "upwind" and "sweby" 
logical :: use_this_module    = .false.  ! logical switch for turning on the gotm scheme 
logical :: debug_this_module  = .false.  ! for debugging
logical :: do_turbulence_gotm = .true.   ! set to .false. when only wish to advect tke and diss. 
logical :: do_advection_gotm  = .true.   ! set to .false. when do not wish to advect tke and diss 
logical :: write_a_restart    = .true.   ! to write a restart 
logical :: map_velocity_gotm  = .false.  ! map velocity to t-points before calculating shear
logical :: map_production_gotm= .true.   ! calculate shear production, map to t-points and 
                                         ! calculate vertical shear at t-points
logical :: correct_adv_errors = .false.  ! set negative tke and diss to minimum value after advection
                                         ! needed for sweby advection in some cases
real :: diff_cbt_min          = 1.0e-5   ! background diffusivity (m^2/s)
real :: visc_cbu_min          = 1.0e-5   ! background viscosity (m^2/s)
real :: z0s                   = 1.0      ! surface roughness length (m)
real :: z0b                   = 0.002    ! bottom roughness length (m)
real :: min_tke               = 1.0e-6   ! minimum turbulent kinetic energy (m^2/s^2)
real :: min_diss              = 1.0e-10  ! minimum energy dissipation (m^2/s^3) 

namelist /ocean_vert_gotm_nml/ use_this_module, debug_this_module, write_a_restart,       & 
                               do_turbulence_gotm, do_advection_gotm, advect_gotm_method, &
                               diff_cbt_min, visc_cbu_min,                                &
                               z0s, z0b, min_tke, min_diss,                               &
                               map_velocity_gotm, map_production_gotm, correct_adv_errors

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_vert_gotm_init">
!
! <DESCRIPTION>
! Initialization for the MOM wrapper to the GOTM vertical mixing scheme.
!
! For restarts: 
!
! We use twolevel time stepping scheme to update tke and diss,
! so only need to read in the taup1_gotm value. 
! call mpp_update_domains since need tke and diss in halos for 
! the advection calculation. 
!
! We need viscosity and diffusivity saved to restarts in order 
! to update the tke and diss fields within GOTM. 
!
! </DESCRIPTION>
!
subroutine ocean_vert_gotm_init (Grid, Domain, Time, Time_steps, T_prog, obc, debug)
  
  type(ocean_grid_type),     target, intent(in) :: Grid
  type(ocean_domain_type),   target, intent(in) :: Domain
  type(ocean_time_type),             intent(in) :: Time
  type(ocean_time_steps_type),       intent(in) :: Time_steps
  type(ocean_prog_tracer_type),      intent(in) :: T_prog(:)
  logical,                           intent(in) :: obc
  logical,                 optional, intent(in) :: debug

  integer :: i, j, k, m, n, kp1
  integer :: ioun, io_status, ierr
  integer :: unit=104
  logical :: opened 
  character(len=64) :: file_name

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_vert_gotm_mod (ocean_vert_gotm_init): module is already initialized')
  endif 

  have_obc = obc 
  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_vert_gotm_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_vert_gotm_nml')
#else
  ioun =  open_namelist_file ()
  read  (ioun, ocean_vert_gotm_nml,iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_vert_gotm_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit, ocean_vert_gotm_nml)  
  write (stdlogunit, ocean_vert_gotm_nml)

  if(use_this_module) then 
    write(stdoutunit,'(/1x,a)') '==> NOTE: USING GOTM vertical mixing scheme.'
  else 
    write(stdoutunit,'(/1x,a)')'==> NOTE: NOT using GOTM vertical mixing scheme.'
    return
  endif 

  if (PRESENT(debug) .and. .not. debug_this_module) then
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') '==>Note: running ocean_vert_gotm_mod with debug_this_module=.true.'  
  endif 

  ! initial time step labels for gotm fields 
  tau_gotm   = 1
  taup1_gotm = 2

  ! use a two-level time scheme for tke and diss updates, 
  ! which means we update tke and diss using time step dtts.
  dtime=Time_steps%dtts 

  if(.not. write_a_restart) then 
    write(stdoutunit,'(a)') '==>Note: running ocean_vert_gotm with write_a_restart=.false.'
    write(stdoutunit,'(a)') '   Will NOT write restart file, and so cannot restart the run.'
  endif

  if(.not. do_turbulence_gotm) then 
  write(stdoutunit,'(/a)') &
   '==>Note from ocean_vert_gotm_mod: NOT invoking GOTM turbulence code. Are you sure you want this?'
  endif 
  
  if (map_velocity_gotm .and. map_production_gotm) then
    call mpp_error(FATAL, &
    '==>Error: Only one of both map_velocity_gotm or map_production_gotm can be .true.')
  endif 
  
  if (map_velocity_gotm) then
  write(stdoutunit,'(/a)') &
   '==>Note from ocean_vert_gotm_mod: mapping velocity to T-points before calculating vertical shear.'
  endif 

  if (map_production_gotm) then
  write(stdoutunit,'(/a)') &
   '==>Note from ocean_vert_gotm_mod: calculating shear production at U-points before mapping to T-points.'
  endif 
  
  if(.not. do_advection_gotm) then 
  write(stdoutunit,'(/a)') &
   '==>Note from ocean_vert_gotm_mod: NOT advecting GOTM tke and diss. Are you sure you want this?'
  endif 

  if(do_advection_gotm) then 
      if(advect_gotm_method=='upwind') then 
          advection_gotm_method = 1
          write(stdoutunit,'(/a)') &
          '==>Note from ocean_vert_gotm_mod: advecting tke and diss with 3D first order upwind scheme.'
      elseif(advect_gotm_method=='sweby') then 
          advection_gotm_method = 2
          write(stdoutunit,'(/a)') &
          '==>Note from ocean_vert_gotm_mod: advecting tke and diss with 3D sweby advection scheme.'
      else
          call mpp_error(FATAL, &
          '==>Error: ocean_vert_gotm_mod: NO advection scheme chosen for GOTM fields.')
      endif
  endif

  if (Time_steps%aidif /= 1.0) then
    call mpp_error(FATAL,&
    '==>ocean_vert_gotm_init: "gotm vmix" must use aidif=1.0 for implicit vertical mixing.')
  endif

  ! temperature and salinity indicies
  index_temp=-1; index_salt=-1
  num_prog_tracers = size(T_prog(:))
  do n= 1, num_prog_tracers
     if (T_prog(n)%name == 'temp') index_temp = n
     if (T_prog(n)%name == 'salt') index_salt = n
  enddo
  if (index_temp < 1 .or. index_salt < 1) then 
    call mpp_error(FATAL, &
    '==>Error: ocean_vert_gotm_mod: temp and/or salt not present in tracer array')
  endif 

  Dom => Domain
  Grd => Grid

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  nk = Grid%nk
  allocate (visc_cbt_gotm(isd:ied,jsd:jed,nk))
  allocate (diff_cbt_gotm(isd:ied,jsd:jed,nk))
  allocate (drhodT(isd:ied,jsd:jed,nk))
  allocate (drhodS(isd:ied,jsd:jed,nk))
  allocate (tmask_advect(isc-2:iec+2,jsc-2:jec+2,nk))    
  allocate (flux_x(isd:ied,jsd:jed,nk))
  allocate (flux_y(isd:ied,jsd:jed,nk))
  allocate (flux_z(isd:ied,jsd:jed,nk))
  allocate (gotm_tendency(isd:ied,jsd:jed,nk))
  do n=1,num_gotm
     allocate(Gotm(n)%field(isd:ied,jsd:jed,nk,2)) 
     allocate(advect_gotm(n)%field(isc-2:iec+2,jsc-2:jec+2,nk))
  enddo
#endif

  ! set defaults for T-cell viscosity and diffusity 
  visc_cbt_gotm = 0.
  diff_cbt_gotm = 0.
  do k=1,nk
     kp1=min(k+1,nk)
     do j=jsd,jed
        do i=isd,ied
           visc_cbt_gotm(i,j,k) = Grd%tmask(i,j,kp1)*visc_cbu_min
           diff_cbt_gotm(i,j,k) = Grd%tmask(i,j,kp1)*diff_cbt_min
        enddo
     enddo
  enddo

  drhodT(:,:,:)        = 0.0
  drhodS(:,:,:)        = 0.0
  tmask_advect(:,:,:)  = 0.0
  flux_x(:,:,:)        = 0.0
  flux_y(:,:,:)        = 0.0
  flux_z(:,:,:)        = 0.0
  gotm_tendency(:,:,:) = 0.0

  ! diagnostic flags
  allocate (id_gotm_diag(num_gotm))
  allocate (id_adv_flux_x(num_gotm))
  allocate (id_adv_flux_y(num_gotm))
  allocate (id_adv_flux_z(num_gotm))
  allocate (id_adv_flux_x_int_z(num_gotm))
  allocate (id_adv_flux_y_int_z(num_gotm))
  allocate (id_gotm_errors(num_gotm))

  ! turbulence kinetic energy 
  index_tke = 1
  Gotm(index_tke)%name = 'tke'
  Gotm(index_tke)%longname = 'turbulence kinetic energy'
  Gotm(index_tke)%units = 'm^2/s^2'
  Gotm(index_tke)%field(:,:,:,:) = 0.0
  Gotm(index_tke)%min_value = min_tke

  ! energy dissipation
  index_diss = 2
  Gotm(index_diss)%name = 'diss'
  Gotm(index_diss)%longname = 'energy dissipation'
  Gotm(index_diss)%units = 'm^2/s^3'
  Gotm(index_diss)%field(:,:,:,:) = 0.0
  Gotm(index_diss)%min_value = min_diss

  do n=1,num_gotm
     advect_gotm(n)%field(:,:,:) = 0.0
     do m=1,2
        Gotm(n)%field(:,:,:,m) = Grd%tmask(:,:,:)*Gotm(n)%min_value
     enddo 
  enddo

  file_name = 'gotm.res.nc'
  id_restart_tke  = register_restart_field(Got_restart, file_name, 'field_tke', Gotm(index_tke)%field(:,:,:,taup1_gotm), &
               domain=Dom%domain2d)
  id_restart_diss = register_restart_field(Got_restart, file_name, 'field_diss', Gotm(index_diss)%field(:,:,:,taup1_gotm), &
               domain=Dom%domain2d)
  id_restart_diff = register_restart_field(Got_restart, file_name, 'diff_cbt_gotm', diff_cbt_gotm(:,:,:), &
               domain=Dom%domain2d)
  id_restart_visc = register_restart_field(Got_restart, file_name, 'visc_cbt_gotm', visc_cbt_gotm(:,:,:), &
               domain=Dom%domain2d)

  if(file_exist('INPUT/gotm.res.nc')) then
      write(stdoutunit,*)' ' 
      write(stdoutunit,*) 'Reading GOTM restart for tke and diss'
      call restore_state(Got_restart)
      call mpp_update_domains(Gotm(index_tke)%field(:,:,:,taup1_gotm), Dom%domain2d)
      call mpp_update_domains(Gotm(index_diss)%field(:,:,:,taup1_gotm), Dom%domain2d)
      call mpp_update_domains(diff_cbt_gotm(:,:,:), Dom%domain2d)
      call mpp_update_domains(visc_cbt_gotm(:,:,:), Dom%domain2d)

      write(stdoutunit,*) 'From ocean_vert_gotm_mod: initial chksum ==>'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('start field_tke', Gotm(index_tke)%field(COMP,:,taup1_gotm)*Grd%tmask(COMP,:))
      call write_chksum_3d('start field_diss', Gotm(index_diss)%field(COMP,:,taup1_gotm)*Grd%tmask(COMP,:))
      call write_chksum_3d('start diff_cbt_gotm', diff_cbt_gotm(COMP,:)*Grd%tmask(COMP,:))
      call write_chksum_3d('start visc_cbt_gotm', visc_cbt_gotm(COMP,:)*Grd%tmask(COMP,:))
  endif


  ! read the GOTM input parameters 
  do 
     inquire(unit=unit, opened=opened)
     if(.NOT.opened)exit
     unit=unit+1
     if(unit ==500) then 
        call mpp_error( FATAL,'==>ocean_vert_gotm_mod: Unable to locate unit number for gotmturb.inp.')
     endif 
  enddo 
  call init_turbulence(unit,'INPUT/gotmturb.inp',nk)
  call init_tridiagonal(nk)

  ! initialize advection of scalar turbulence fields: tke and diss
  call set_ocean_domain(Dom_advect_gotm,Grd,xhalo=2,yhalo=2,name='advect_gotm', maskmap=Dom%maskmap)
  tmask_advect  = 0.0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           tmask_advect(i,j,k) = Grd%tmask(i,j,k)
        enddo
     enddo
  enddo
  call mpp_update_domains(tmask_advect,Dom_advect_gotm%domain2d)  


  ! register diagnostic output 
  id_gotm_diag        = -1
  id_adv_flux_x       = -1
  id_adv_flux_y       = -1
  id_adv_flux_z       = -1
  id_adv_flux_x_int_z = -1
  id_adv_flux_y_int_z = -1
  id_diff_cbt_gotm    = -1
  id_visc_cbt_gotm    = -1
  id_visc_cbu_gotm    = -1
  id_gotm_errors      = -1

  do n=1,num_gotm

      id_gotm_diag(n) = register_diag_field ('ocean_model', trim(Gotm(n)%name),   &
                   Grd%tracer_axes_wt(1:3), Time%model_time, trim(Gotm(n)%name), &
                   &trim(Gotm(n)%units), missing_value=missing_value, range=(/-1e18,1e18/))
      id_adv_flux_x(n) = register_diag_field ('ocean_model', trim(Gotm(n)%name)//'_xflux_adv', &
                   Grd%tracer_axes_flux_x(1:3), Time%model_time, 'rho*dzt*dyt*u*Gotm_field',   &
                   &' kg/sec', missing_value=missing_value, range=(/-1e18,1e18/))
      id_adv_flux_y(n)   = register_diag_field ('ocean_model', trim(Gotm(n)%name)//'_yflux_adv', &
                   Grd%tracer_axes_flux_y(1:3), Time%model_time, 'rho*dzt*dxt*v*Gotm_field',     &
                    &' kg/sec', missing_value=missing_value, range=(/-1e18,1e18/))
      id_adv_flux_z(n) = register_diag_field ('ocean_model', trim(Gotm(n)%name)//'_zflux_adv', &
                   Grd%tracer_axes_wt(1:3), Time%model_time, 'rho*dxt*dyt*wt*Gotm_field',      &
                   'kg/sec', missing_value=missing_value, range=(/-1e18,1e18/))            
      id_adv_flux_x_int_z(n) = register_diag_field ('ocean_model', trim(Gotm(n)%name)//'_xflux_adv_int_z', &
                   Grd%tracer_axes_flux_x(1:2), Time%model_time, 'rho*dzt*dyt*u*Gotm_field',               &
                   &' kg m/sec', missing_value=missing_value, range=(/-1e18,1e18/))
      id_adv_flux_y_int_z(n) = register_diag_field ('ocean_model', trim(Gotm(n)%name)//'_yflux_adv_int_z', &
                   Grd%tracer_axes_flux_y(1:2), Time%model_time, 'rho*dzt*dxt*v*Gotm_field',               &
                   &' kg m/sec', missing_value=missing_value, range=(/-1e18,1e18/))
      id_gotm_errors(n) = register_diag_field ('ocean_model', trim(Gotm(n)%name)//'_advect_error',   &
                   Grd%tracer_axes_wt(1:3), Time%model_time, trim(Gotm(n)%name), &
                   &trim(Gotm(n)%units), missing_value=missing_value, range=(/-1e18,1e18/))
  enddo 

  id_gotm_nn = register_diag_field ('ocean_model', 'gotm_nn',                       &
       Grd%tracer_axes_wt(1:3), Time%model_time, 'squared buoy freq given to GOTM', &
       '1/s^2', missing_value=missing_value, range=(/-1e18,1e18/))

  id_gotm_ss = register_diag_field ('ocean_model', 'gotm_ss',                     &
       Grd%tracer_axes(1:3), Time%model_time, 'squared vert shear given to GOTM', &
       '1/s^2', missing_value=missing_value, range=(/-1e18,1e18/))

  id_diff_cbt_gotm = register_diag_field('ocean_model','diff_cbt_gotm',Grd%tracer_axes(1:3),&
       Time%model_time, 'vert diffusivity from GOTM', 'm^2/sec',                            &
       missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_visc_cbt_gotm = register_diag_field('ocean_model','visc_cbt_gotm',Grd%tracer_axes(1:3),&
       Time%model_time, 'vert viscosity from GOTM', 'm^2/sec',                              &
       missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_visc_cbu_gotm = register_diag_field('ocean_model','visc_cbu_gotm',Grd%vel_axes_uv(1:3),&
       Time%model_time, 'vert viscosity from GOTM', 'm^2/sec',                              &
       missing_value = missing_value, range=(/-1.e5,1.e5/))


end subroutine ocean_vert_gotm_init
! </SUBROUTINE> NAME="ocean_vert_gotm_init">


!#######################################################################
! <SUBROUTINE NAME="vert_mix_gotm_bgrid">
!
! <DESCRIPTION>
! This subroutine computes the vertical diffusivity and viscosity 
! according to the GOTM mixing model.
!
! The tke, diss, NN, and SS arrays are computed on tracer cells.
!
! Use smf_bgrid since this array uses the primary smf array read in from 
! the coupler in ocean_core/ocean_sbc.F90 when using the FMS coupler.
!
! </DESCRIPTION>
!
subroutine vert_mix_gotm_bgrid (Time, Thickness, Velocity, T_prog, Dens, visc_cbu, visc_cbt, diff_cbt)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_velocity_type),    intent(in) :: Velocity
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  type(ocean_density_type),     intent(in) :: Dens

  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbu
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbt
  real, dimension(isd:,jsd:,:,:), intent(inout) :: diff_cbt

  real, dimension(0:nk)  :: dz
  real, dimension(0:nk)  :: NN1d
  real, dimension(0:nk)  :: SS1d
  real                   :: active_cells
  real                   :: u_taus, u_taub
  real                   :: momflux, depth
  real                   :: rho_N2, rho_inv 
  real                   :: smf1_active, smf2_active
  real                   :: bmf1_active, bmf2_active
  real                   :: dzwur
  integer                :: i, j, k, n, m, kb, kp1
  integer                :: tau, tau_gotm_old 

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if ( .not. module_is_initialized ) then 
     call mpp_error(FATAL,&
      '==>Error from ocean_vert_gotm_bgrid: module must be initialized')
  endif 

  if(.not. use_this_module) return 

  ! ocean model time step label 
  tau = Time%tau

  ! cycle the gotm time step labels 
  tau_gotm_old = tau_gotm
  tau_gotm     = taup1_gotm
  taup1_gotm   = tau_gotm_old

  ! partial derivatives of density wrt to temperature and salinity 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           drhodT(i,j,k) = Dens%drhodT(i,j,k)
           drhodS(i,j,k) = Dens%drhodS(i,j,k)
        enddo
     enddo
  enddo

  ! vertical derivative of temperature and salinity at bottom of tracer cells 
  wrk3(:,:,:) = 0.0 
  do k=1,nk
     kp1 = min(k+1,nk)
     do j=jsc,jec
        do i=isc,iec
           wrk3(i,j,k) = 1.0/Thickness%dzwt(i,j,k) 
           wrk1(i,j,k) = Grd%tmask(i,j,kp1)*wrk3(i,j,k) &
                         *(T_prog(index_temp)%field(i,j,k,tau)-T_prog(index_temp)%field(i,j,kp1,tau)) 
           wrk2(i,j,k) = Grd%tmask(i,j,kp1)*wrk3(i,j,k) &
                         *(Dens%rho_salinity(i,j,k,tau)-Dens%rho_salinity(i,j,kp1,tau)) 
        enddo
     enddo
  enddo

  ! squared buoyancy frequency at bottom of T-cells 
  wrk1_v(:,:,:,1) = 0.0
  do k=1,nk
     kp1 = min(k+1,nk)
     do j=jsc,jec
        do i=isc,iec
           rho_inv = 1.0/(epsln + Dens%rho(i,j,k,tau) + Dens%rho(i,j,kp1,tau)) 
           rho_N2  = -grav*( (drhodT(i,j,k)+drhodT(i,j,kp1))*wrk1(i,j,k) &
                            +(drhodS(i,j,k)+drhodS(i,j,kp1))*wrk2(i,j,k) ) 
           wrk1_v(i,j,k,1) = rho_inv*rho_N2
        enddo
     enddo
  enddo
      
  if (map_production_gotm) then

      ! recalculate visc_cbu to get a stable scheme (Hans Burchard priv. comm.) 
      ! visc_cbt_gotm should be defined in the data domain
      visc_cbu = 0.
      do k=1,nk
         do j=jsd,jec
            do i=isd,iec
               active_cells =  Grd%tmask(i+1,j+1,k) + Grd%tmask(i+1,j,k) + &
                               Grd%tmask(i,j+1,k)   + Grd%tmask(i,j,k)   + epsln
               visc_cbu(i,j,k) = ( Grd%tmask(i+1,j+1,k)*visc_cbt_gotm(i+1,j+1,k) + &
                                   Grd%tmask(i+1,j,k)  *visc_cbt_gotm(i+1,j,k)   + &
                                   Grd%tmask(i,j+1,k)  *visc_cbt_gotm(i,j+1,k)   + &
                                   Grd%tmask(i,j,k)    *visc_cbt_gotm(i,j,k) ) / active_cells   
            enddo
         enddo
      enddo

      ! squared vertical shear at bottom of U-cells
      ! note the visc_cbu factor will be divided out during next step 
      wrk4(:,:,:)=0.0
      do k=1,nk-1
         do j=jsd,jec
            do i=isd,iec
               dzwur = 1/Thickness%dzwu(i,j,k) 
               wrk4(i,j,k) = Grd%umask(i,j,k+1)*dzwur*dzwur*visc_cbu(i,j,k)      &
                    *(                                                           &
                     ( Velocity%u(i,j,k,1,tau) - Velocity%u(i,j,k+1,1,tau) )**2  &
                    +( Velocity%u(i,j,k,2,tau) - Velocity%u(i,j,k+1,2,tau) )**2  &
                     )
            enddo
         enddo
      enddo

      ! compute the squared vertical shear at the bottom of T cells as 
      ! an average of the four nearest shears on the bottom of U cells.
      ! (do not consider land cells in the average...only active cells.)
      ! division by visc_cbt_gotm factor is needed due to wrk4 definition.  
      wrk1_v(:,:,:,2) = 0.0
      do k=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               active_cells = (Grd%umask(i,j,k+1)   + Grd%umask(i-1,j,k+1)   + &
                               Grd%umask(i,j-1,k+1) + Grd%umask(i-1,j-1,k+1)) * visc_cbt_gotm(i,j,k) +epsln
               wrk1_v(i,j,k,2) = (wrk4(i,j,k)   + wrk4(i-1,j,k) + &
                                  wrk4(i,j-1,k) + wrk4(i-1,j-1,k))/active_cells
            enddo
         enddo
      enddo

  endif  ! map_production_gotm


  if (map_velocity_gotm) then
  
    ! squared vertical shear at bottom of U-cells as
    ! an average of the four nearest shears on the bottom of U cells.
    ! (do not consider land cells in the average...only active cells.)
    wrk2(:,:,:)=0.0
    wrk4(:,:,:)=0.0
    do k=1,nk-1
      do j=jsc,jec
        do i=isc,iec
           active_cells = Grd%umask(i,j,k+1)   + Grd%umask(i-1,j,k+1)   +          &
                          Grd%umask(i,j-1,k+1) + Grd%umask(i-1,j-1,k+1) + epsln
           wrk2(i,j,k)  = (Velocity%u(i,j,k,1,tau)   + Velocity%u(i-1,j,k,1,tau) + &
                           Velocity%u(i,j-1,k,1,tau) + Velocity%u(i-1,j-1,k,1,tau))/active_cells
           wrk4(i,j,k)  = (Velocity%u(i,j,k,2,tau)   + Velocity%u(i-1,j,k,2,tau) + &
                           Velocity%u(i,j-1,k,2,tau) + Velocity%u(i-1,j-1,k,2,tau))/active_cells
        enddo
      enddo
    enddo

    ! compute squared vertical shear at the bottom of T cells 
    wrk1_v(:,:,:,2) = 0.0
    do k=1,nk-1
      do j=jsc,jec
        do i=isc,iec
           wrk1_v(i,j,k,2) = Grd%tmask(i,j,k+1)*wrk3(i,j,k)*wrk3(i,j,k) &
                         * (                                            &
                             ( wrk2(i,j,k) - wrk2(i,j,k+1) )**2         &
                            +( wrk4(i,j,k) - wrk4(i,j,k+1) )**2         &
                           )
        enddo
      enddo
    enddo

  endif  !map_velocity_gotm


  ! 1D gotm scheme called for each vertical column 
  ! use smf_bgrid since this is directly from the FMS coupler. 
  if(do_turbulence_gotm) then 

      do j=jsc,jec
         do i=isc,iec

            if(Grd%tmask(i,j,1) > 0.0) then 

                ! surface and bottom friction velocities on T-cell
                active_cells= Grd%umask(i,j,1)   + Grd%umask(i-1,j,1)   + &
                              Grd%umask(i,j-1,1) + Grd%umask(i-1,j-1,1) + epsln

                u_taus  = Velocity%ustar(i,j) + epsln

                bmf1_active = (Velocity%bmf(i,j,1)   + Velocity%bmf(i-1,j,1) + &
                               Velocity%bmf(i,j-1,1) + Velocity%bmf(i-1,j-1,1))/active_cells
                bmf2_active = (Velocity%bmf(i,j,2)   + Velocity%bmf(i-1,j,2) + &
                               Velocity%bmf(i,j-1,2) + Velocity%bmf(i-1,j-1,2))/active_cells
                momflux = sqrt(bmf1_active**2 + bmf2_active**2)
                u_taub  = sqrt(momflux*rho0r) + epsln

                ! roughness lengths z0s and z0b have been read from nml 

                ! water column depth
                kb    = Grd%kmt(i,j)
                depth = Thickness%depth_zwt(i,j,kb)

                ! copy 3D variables into 1D arrays
                ! note the inverse ordering of k-label 
                do k=0,kb-1
                   m       = kb-k
                   tke(k)  = Gotm(index_tke)%field(i,j,m,tau_gotm)
                   eps(k)  = Gotm(index_diss)%field(i,j,m,tau_gotm)
                   L1d(k)  = cde*tke(k)**1.5/eps(k)
                   num(k)  = visc_cbt_gotm(i,j,m)
                   nuh(k)  = diff_cbt_gotm(i,j,m)
                   NN1d(k) = wrk1_v(i,j,m,1)
                   SS1d(k) = wrk1_v(i,j,m,2)
                   dz(k+1)   = Thickness%dzt(i,j,m)
                enddo
                ! surface and bottom conditions
                NN1d(0)  = NN1d(1)
                SS1d(0)  = SS1d(1)
                tke(kb)  = tke(kb-1)
                eps(kb)  = eps(kb-1)
                num(kb)  = num(kb-1)
                nuh(kb)  = nuh(kb-1)
                NN1d(kb) = NN1d(kb-1)
                SS1d(kb) = 0.0
                dz(0)   = 0

                ! invoke GOTM
                call do_turbulence(kb, dtime, depth, u_taus, u_taub, &
                                   z0s, z0b, dz(0:kb), NN1d(0:kb), SS1d(0:kb))

                ! copy 1D arrays into 3D arrays
                do k=0,kb-1
                   m = kb-k
                   Gotm(index_tke)%field(i,j,m,taup1_gotm)  = tke(k)
                   Gotm(index_diss)%field(i,j,m,taup1_gotm) = eps(k)
                   visc_cbt_gotm(i,j,m) = num(k)
                   diff_cbt_gotm(i,j,m) = nuh(k)
                enddo

            endif  ! endif for Grd%tmask > 0

         enddo     ! end i-loop
      enddo        ! end j-loop

      if(have_obc) then
         call ocean_obc_mixing(visc_cbt_gotm, diff_cbt_gotm, &
              Gotm(index_tke)%field(:,:,:,taup1_gotm), Gotm(index_diss)%field(:,:,:,taup1_gotm))
      endif

      ! update visc_cbt_gotm to halos in preparation for 
      ! 4-point average to get viscosity on U-cell 
      call mpp_update_domains (visc_cbt_gotm(:,:,:), Dom%domain2d)

  endif

  ! perform 4-point average to get viscosity onto bottom of U-cell. 
  ! also get viscosity for C-grid velocities.  
  wrk1(:,:,:) = 0.0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           diff_cbt(i,j,k,1) = diff_cbt_gotm(i,j,k)
           diff_cbt(i,j,k,2) = diff_cbt(i,j,k,1)
           visc_cbt(i,j,k)   = visc_cbt_gotm(i,j,k)
           active_cells =  Grd%tmask(i+1,j+1,k) + Grd%tmask(i+1,j,k) + &
                           Grd%tmask(i,j+1,k)   + Grd%tmask(i,j,k)   + epsln
           wrk1(i,j,k) = ( Grd%tmask(i+1,j+1,k)*visc_cbt_gotm(i+1,j+1,k) + &
                           Grd%tmask(i+1,j,k)  *visc_cbt_gotm(i+1,j,k)   + &
                           Grd%tmask(i,j+1,k)  *visc_cbt_gotm(i,j+1,k)   + &
                           Grd%tmask(i,j,k)    *visc_cbt_gotm(i,j,k) ) / active_cells   
           visc_cbu(i,j,k) = wrk1(i,j,k)
        enddo
     enddo
  enddo

  if(debug_this_module) then 
      write(stdoutunit,*)' ' 
      write(stdoutunit,*) 'From ocean_vert_gotm_mod: checksums'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('diff_cbt_gotm', diff_cbt_gotm(COMP,:)*Grd%tmask(COMP,:))
      call write_chksum_3d('visc_cbt_gotm', visc_cbt_gotm(COMP,:)*Grd%tmask(COMP,:))
      call write_chksum_3d('tke', Gotm(index_tke)%field(COMP,:,tau_gotm)*Grd%tmask(COMP,:))
      call write_chksum_3d('diss', Gotm(index_diss)%field(COMP,:,tau_gotm)*Grd%tmask(COMP,:))
      call write_chksum_3d('NN', wrk1_v(COMP,:,1)*Grd%tmask(COMP,:))
      call write_chksum_3d('SS', wrk1_v(COMP,:,2)*Grd%tmask(COMP,:))
  endif

  ! send diagnostics
  do n=1,num_gotm
     call diagnose_3d(Time, Grd, id_gotm_diag(n), Gotm(n)%field(:,:,:,tau_gotm))
  enddo

  call diagnose_3d(Time, Grd, id_diff_cbt_gotm, diff_cbt_gotm(:,:,:))
  call diagnose_3d(Time, Grd, id_visc_cbt_gotm, visc_cbt_gotm(:,:,:))
  call diagnose_3d_u(Time, Grd, id_visc_cbu_gotm, wrk1(:,:,:))
  call diagnose_3d(Time, Grd, id_gotm_nn, wrk1_v(:,:,:,1))
  call diagnose_3d(Time, Grd, id_gotm_ss, wrk1_v(:,:,:,2))


 end subroutine vert_mix_gotm_bgrid
 ! </SUBROUTINE> NAME="vert_mix_gotm_bgrid"



!#######################################################################
! <SUBROUTINE NAME="advect_gotm_compute">
!
! <DESCRIPTION>
! Wrapper for advection of GOTM scalar fields tke and diss. 
!
! Horizontally tke and diss are on tracer cells, so advection just as if 
! they were tracers. 
! Vertically they are between tracer cells. We do not average but shift 
! tke and diss upward to tracer points for vertical advection. At the bottom 
! tke and diss are define by the Dirichlet boundary condition.
!
! Since use a two-level time stepping scheme for tke and diss,
! it is necessary to advect these scalars with an upwind biased
! advection scheme.
!
! </DESCRIPTION>
!
subroutine advect_gotm_compute(Time, Adv_vel, Thickness, pme, river)

  type(ocean_time_type),      intent(in) :: Time
  type(ocean_adv_vel_type),   intent(in) :: Adv_vel
  type(ocean_thickness_type), intent(in) :: Thickness
  real, dimension(isd:,jsd:), intent(in) :: pme
  real, dimension(isd:,jsd:), intent(in) :: river

  if ( .not. module_is_initialized ) then 
    call  mpp_error(FATAL, &
     '==>Error from advect_gotm_compute: ocean_vert_gotm_mod not yet initialized')
  endif 

  if(.not. do_advection_gotm) return 

  ! update tke and diss to halos in preparation for advection 
  call mpp_update_domains (Gotm(index_tke)%field(:,:,:,taup1_gotm),  Dom%domain2d, complete=.false.)
  call mpp_update_domains (Gotm(index_diss)%field(:,:,:,taup1_gotm), Dom%domain2d, complete=.true.)

  if(advection_gotm_method==1) then 
    call advect_gotm_upwind(Time, Adv_vel, Thickness, pme, river)
  elseif(advection_gotm_method==2) then 
    call advect_gotm_sweby(Time, Adv_vel, Thickness, pme, river)
  endif 
!  call mpp_update_domains (Gotm(index_tke)%field(:,:,:,taup1_gotm),  Dom%domain2d)
!  call mpp_update_domains (Gotm(index_diss)%field(:,:,:,taup1_gotm), Dom%domain2d)

end subroutine advect_gotm_compute
! </SUBROUTINE> NAME="advect_gotm_compute"


!#######################################################################
! <SUBROUTINE NAME="advect_gotm_upwind">
!
! <DESCRIPTION>
! First order upwind to advect GOTM scalar turbulence quantities tke and diss.
! </DESCRIPTION>
!
subroutine advect_gotm_upwind(Time, Adv_vel, Thickness, pme, river)

  type(ocean_time_type),      intent(in) :: Time
  type(ocean_adv_vel_type),   intent(in) :: Adv_vel
  type(ocean_thickness_type), intent(in) :: Thickness
  real, dimension(isd:,jsd:), intent(in) :: pme
  real, dimension(isd:,jsd:), intent(in) :: river

  real, dimension(isd:ied,jsd:jed) :: fe, fn, ft1, ft2
  real, dimension(isd:ied,jsd:jed) :: tmp_flux
  real                             :: velocity, upos, uneg, wpos, wneg
  integer                          :: i, j, k, kp1, n
  integer                          :: tau 

  if ( .not. module_is_initialized ) then 
    call  mpp_error(FATAL, &
     '==>Error from advect_gotm_upwind: ocean_vert_gotm_mod not yet initialized')
  endif 

  flux_x  = 0.0
  flux_y  = 0.0
  flux_z  = 0.0
  tau     = Time%tau 

  do n=1,num_gotm

     gotm_tendency(:,:,:) = 0.0
     wrk1(:,:,:)          = 0.0
     wrk2(:,:,:)          = 0.0

     do k=1,nk 

        ! i-flux
        do j=jsc,jec
           do i=isc-1,iec
              velocity = 0.5*Adv_vel%uhrho_et(i,j,k)
              upos     = velocity + abs(velocity)
              uneg     = velocity - abs(velocity)
              fe(i,j)  = Grd%dyte(i,j)*(upos*Gotm(n)%field(i,j,k,taup1_gotm) + uneg*Gotm(n)%field(i+1,j,k,taup1_gotm)) &
                         *Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)  
              flux_x(i,j,k) = fe(i,j)
           enddo
        enddo

        ! j-flux
        do j=jsc-1,jec
           do i=isc,iec
              velocity = 0.5*Adv_vel%vhrho_nt(i,j,k)
              upos     = velocity + abs(velocity)
              uneg     = velocity - abs(velocity)
              fn(i,j)  = Grd%dxtn(i,j)*(upos*Gotm(n)%field(i,j,k,taup1_gotm) + uneg*Gotm(n)%field(i,j+1,k,taup1_gotm)) &
                         *Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)
              flux_y(i,j,k) = fn(i,j)
           enddo
        enddo

        ! divergence of horizontal advection fluxes  
        do j=jsc,jec
           do i=isc,iec
              wrk1(i,j,k) = Grd%tmask(i,j,k)*(fe(i,j)-fe(i-1,j)+fn(i,j)-fn(i,j-1))*Grd%datr(i,j)
           enddo
        enddo

     enddo  ! k-loop


     ! vertical fluxes 
     ft1=0.0
     do k=1,nk
        kp1 = min(k+1,nk)
        do j=jsc,jec
           do i=isc,iec
              velocity = 0.5*Adv_vel%wrho_bt(i,j,k)
              wpos     = velocity + abs(velocity) 
              wneg     = velocity - abs(velocity) 
              ft2(i,j) = (wneg*Gotm(n)%field(i,j,k,taup1_gotm) + wpos*Gotm(n)%field(i,j,kp1,taup1_gotm)) &
                         *Grd%tmask(i,j,k)*Grd%tmask(i,j,kp1) 
              flux_z(i,j,k) = Grd%dat(i,j)*ft2(i,j)
              wrk2(i,j,k)   = Grd%tmask(i,j,k)*(ft1(i,j)-ft2(i,j))
              ft1(i,j)      = ft2(i,j)
           enddo
        enddo
     enddo

     ! include effects from pme and river advecting tke and diss into 
     ! the top cell.  Assume pme and river have tke and diss equal 
     ! to that in the top model grid cell.
     do j=jsc,jec
        do i=isc,iec
           gotm_tendency(i,j,1) = Grd%tmask(i,j,1)*(pme(i,j)+river(i,j))*Gotm(n)%field(i,j,1,taup1_gotm)
        enddo
     enddo

     ! add Gotm(n)%field*Thickness%mass_source to maintain compatibility
     ! between evolution of the scalars tke & diss, and the evolution of mass.  
     ! assume that where there is creation of mass, this mass has tke and diss
     ! equal to that already in the grid cell. 
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              gotm_tendency(i,j,k) =   gotm_tendency(i,j,k) - wrk1(i,j,k) - wrk2(i,j,k) &
                                     + Gotm(n)%field(i,j,k,taup1_gotm)*Thickness%mass_source(i,j,k)
           enddo
        enddo
     enddo

     if (id_gotm_errors(n) > 0) then
     ! update the scalar Gotm field and store erroneous negative values.  
       do k=1,nk
         do j=jsc,jec
           do i=isc,iec
              Gotm(n)%field(i,j,k,taup1_gotm) =                                &
                   (Thickness%rho_dzt(i,j,k,tau)*Gotm(n)%field(i,j,k,taup1_gotm) &
                   + dtime*gotm_tendency(i,j,k)) * Thickness%rho_dztr(i,j,k)
              wrk1(i,j,k) = min(Gotm(n)%field(i,j,k,taup1_gotm),0.)
           enddo
         enddo
       enddo
       call diagnose_3d(Time, Grd, id_gotm_errors(n), wrk1(:,:,:))
     else
     ! update the scalar Gotm field.  
       do k=1,nk
         do j=jsc,jec
           do i=isc,iec
              Gotm(n)%field(i,j,k,taup1_gotm) =                                &
                   (Thickness%rho_dzt(i,j,k,tau)*Gotm(n)%field(i,j,k,taup1_gotm) &
                   + dtime*gotm_tendency(i,j,k)) * Thickness%rho_dztr(i,j,k)
           enddo
         enddo
       enddo
     endif
! set to minimum value if negative
     if (correct_adv_errors) then
       do k=1,nk
         do j=jsc,jec
           do i=isc,iec
              Gotm(n)%field(i,j,k,taup1_gotm) = max(Gotm(n)%field(i,j,k,taup1_gotm), Gotm(n)%min_value) 
           enddo
          enddo
       enddo
     endif

     ! diagnostics 

     call diagnose_3d(Time, Grd, id_adv_flux_x(n), flux_x(:,:,:))

     if (id_adv_flux_x_int_z(n) > 0) then 
         tmp_flux(:,:) = 0.0
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  tmp_flux(i,j) = tmp_flux(i,j) +  flux_x(i,j,k) 
               enddo
            enddo
         enddo
         call diagnose_2d(Time, Grd, id_adv_flux_x_int_z(n), tmp_flux(:,:))
     endif

     call diagnose_3d(Time, Grd, id_adv_flux_y(n), flux_y(:,:,:))

     if (id_adv_flux_y_int_z(n) > 0) then 
         tmp_flux(:,:) = 0.0
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  tmp_flux(i,j) = tmp_flux(i,j) +  flux_y(i,j,k) 
               enddo
            enddo
         enddo
         call diagnose_2d(Time, Grd, id_adv_flux_y_int_z(n), tmp_flux(:,:))
     endif

     call diagnose_3d(Time, Grd, id_adv_flux_z(n), flux_z(:,:,:))

  enddo  ! n-loop

end subroutine advect_gotm_upwind
! </SUBROUTINE> NAME="advect_gotm_upwind"



!#######################################################################
! <SUBROUTINE NAME="advect_gotm_sweby">
!
! <DESCRIPTION>
! Sweby scheme to advect GOTM scalar turbulence quantities tke and diss.
! </DESCRIPTION>
!
subroutine advect_gotm_sweby(Time, Adv_vel, Thickness, pme, river)

  type(ocean_time_type),      intent(in) :: Time
  type(ocean_adv_vel_type),   intent(in) :: Adv_vel
  type(ocean_thickness_type), intent(in) :: Thickness
  real, dimension(isd:,jsd:), intent(in) :: pme
  real, dimension(isd:,jsd:), intent(in) :: river

  real,dimension(isc:iec,jsc:jec)        :: ftp
  real,dimension(isc:iec,jsc:jec)        :: fbt
  real,dimension(isc:iec,jsc:jec)        :: wkm1
  real,dimension(isd:ied,jsd:jed)        :: tmp_flux

  integer                                :: i, j, k, n
  integer                                :: kp1, kp2, km1
  integer                                :: tau
  real                                   :: Rjm, Rj, Rjp, cfl, massflux
  real                                   :: d0, d1, thetaP, psiP 
  real                                   :: thetaM, psiM

  if ( .not. module_is_initialized ) then 
    call  mpp_error(FATAL, &
     '==>Error from advect_gotm_sweby: ocean_vert_gotm_mod not yet initialized')
  endif 

  flux_x  = 0.0
  flux_y  = 0.0
  flux_z  = 0.0
  tau     = Time%tau


  ! calculate flux at bottom face of the T-cells
  do n=1,num_gotm

     ftp           = 0.0
     fbt           = 0.0
     wkm1          = 0.0
     gotm_tendency = 0.0

     do k=1,nk

        do j=jsc,jec
           do i=isc,iec
              advect_gotm(n)%field(i,j,k) = Gotm(n)%field(i,j,k,taup1_gotm)
           enddo
        enddo

        kp1 = min(k+1,nk)
        kp2 = min(k+2,nk)
        km1 = max(k-1,1)

        do j=jsc,jec
           do i=isc,iec

              Rjp = (Gotm(n)%field(i,j,km1,taup1_gotm) - Gotm(n)%field(i,j,k,taup1_gotm))    &
                   *tmask_advect(i,j,km1)*tmask_advect(i,j,k)
              Rj  = (Gotm(n)%field(i,j,k,taup1_gotm) - Gotm(n)%field(i,j,kp1,taup1_gotm))    &
                   *tmask_advect(i,j,k)*tmask_advect(i,j,kp1)
              Rjm = (Gotm(n)%field(i,j,kp1,taup1_gotm) - Gotm(n)%field(i,j,kp2,taup1_gotm))  &
                   *tmask_advect(i,j,kp1)*tmask_advect(i,j,kp2)

              massflux = Grd%dat(i,j) * Adv_vel%wrho_bt(i,j,k)
              cfl = abs(Adv_vel%wrho_bt(i,j,k) * dtime  / Thickness%rho_dzt(i,j,k,tau))
              d0 = (2.0 - cfl) * (1.0 - cfl) * onesixth
              d1 = (1.0 - cfl * cfl) * onesixth

              thetaP = Rjm / (1.0e-30 + Rj)
              thetaM = Rjp / (1.0e-30 + Rj)

              psiP = max(0.0, min(min(1.0, d0 + d1 * thetaP),       &
                   (1.0 - cfl) / (1.0e-30 + cfl) * thetaP ) )
              psiM = max(0.0, min(min(1.0, d0 + d1 * thetaM),       &
                   (1.0 - cfl) / (1.0e-30 + cfl) * thetaM ) )

              fbt(i,j) =  0.5 * ( ( massflux + abs(massflux) )       &
                   * ( Gotm(n)%field(i,j,kp1,taup1_gotm) + psiP * Rj )    &
                   + ( massflux - abs(massflux) )                    &
                   * ( Gotm(n)%field(i,j, k ,taup1_gotm) - psiM * Rj ) )  &
                   * tmask_advect(i,j,kp1) * tmask_advect(i,j,k)

              advect_gotm(n)%field(i,j,k) = advect_gotm(n)%field(i,j,k) &
                   + dtime / Thickness%rho_dzt(i,j,k,tau) * (           &
                   Grd%datr(i,j) * ( fbt(i,j) - ftp(i,j))               &
                   + Gotm(n)%field(i,j,k,taup1_gotm) *                       &
                   (wkm1(i,j) - Adv_vel%wrho_bt(i,j,k)) )

              flux_z(i,j,k) = fbt(i,j)
              ftp(i,j)      = fbt(i,j)

           enddo
        enddo

        ! update vertical velocity for next k-level
        do j=jsc,jec
           do i=isc,iec
              wkm1(i,j) = Adv_vel%wrho_bt(i,j,k)
           enddo
        enddo

     enddo ! end of k-loop

     call mpp_update_domains (advect_gotm(n)%field, Dom_advect_gotm%domain2d, flags=XUPDATE)

     call diagnose_3d(Time, Grd, id_adv_flux_z(n), flux_z(:,:,:))

  enddo ! end of n-loop for Gotm


  ! calculate flux at the eastern face of the T-cells
  do n=1,num_gotm

     do k=1,nk

        do j=jsc,jec
           do i=isc-1,iec

              Rjp = (advect_gotm(n)%field(i+2,j,k) - advect_gotm(n)%field(i+1,j,k))    &
                   *tmask_advect(i+2,j,k)*tmask_advect(i+1,j,k)
              Rj  = (advect_gotm(n)%field(i+1,j,k) - advect_gotm(n)%field( i ,j,k) )   &
                   *tmask_advect(i+1,j,k)*tmask_advect(i,j,k)
              Rjm = (advect_gotm(n)%field(i,j,k) - advect_gotm(n)%field(i-1,j,k))      &
                   *tmask_advect(i,j,k)*tmask_advect(i-1,j,k)

              massflux = Grd%dyte(i,j) * Adv_vel%uhrho_et(i,j,k)
              cfl = abs(Adv_vel%uhrho_et(i,j,k) * dtime * 2.0    &
                   / ((Thickness%rho_dzt(i,j,k,tau) + Thickness%rho_dzt(i+1,j,k,tau)) * Grd%dxte(i,j)))
              d0 = (2.0 - cfl) * (1.0 - cfl) * onesixth
              d1 = (1.0 - cfl * cfl) * onesixth

              thetaP = Rjm / (1.0e-30 + Rj)
              thetaM = Rjp / (1.0e-30 + Rj)

              psiP = max(0.0, min(min(1.0, d0 + d1 * thetaP),  &
                   (1.0 - cfl) / (1.0e-30 + cfl) * thetaP ) )
              psiM = max(0.0, min(min(1.0, d0 + d1 * thetaM),  &
                   (1.0 - cfl) / (1.0e-30 + cfl) * thetaM ) )

              flux_x(i,j,k) =  0.5 * ( ( massflux + abs(massflux) )  &
                   * ( advect_gotm(n)%field( i ,j,k) + psiP * Rj )   &
                   + ( massflux - abs(massflux) )                    &
                   * ( advect_gotm(n)%field(i+1,j,k) - psiM * Rj ) ) &
                   * tmask_advect(i,j,k) * tmask_advect(i+1,j,k)
           enddo
        enddo

        ! update the scalar 
        do j=jsc,jec
           do i=isc,iec
              advect_gotm(n)%field(i,j,k) = advect_gotm(n)%field(i,j,k)                         &
                   + dtime * tmask_advect(i,j,k) * Grd%datr(i,j) / Thickness%rho_dzt(i,j,k,tau) &
                   * (flux_x(i-1,j,k) - flux_x(i,j,k)                                           &
                   + Gotm(n)%field(i,j,k,taup1_gotm)* (                                           &
                     Grd%dyte(i,j) *   Adv_vel%uhrho_et( i ,j,k)                                &
                   - Grd%dyte(i-1,j) * Adv_vel%uhrho_et(i-1,j,k) ) )
           enddo
        enddo

     enddo ! end of k-loop


     call mpp_update_domains (advect_gotm(n)%field, Dom_advect_gotm%domain2d, flags=YUPDATE)

     call diagnose_3d(Time, Grd, id_adv_flux_x(n), flux_x(:,:,:))

     if (id_adv_flux_x_int_z(n) > 0) then 
         tmp_flux(:,:) = 0.0
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  tmp_flux(i,j) = tmp_flux(i,j) +  flux_x(i,j,k) 
               enddo
            enddo
         enddo
         call diagnose_2d(Time, Grd, id_adv_flux_x_int_z(n), tmp_flux(:,:))
     endif

  enddo ! end of n-loop for Gotm


  ! calculate flux at the northern face of the T-cells 
  do n=1,num_gotm

     do j=jsc,jec
        do i=isc,iec
           wkm1(i,j) = 0.0
        enddo
     enddo

     do k=1,nk

        do j=jsc-1,jec
           do i=isc,iec

              Rjp = (advect_gotm(n)%field(i,j+2,k) - advect_gotm(n)%field(i,j+1,k))   &
                   *tmask_advect(i,j+2,k)*tmask_advect(i,j+1,k)
              Rj  = (advect_gotm(n)%field(i,j+1,k) - advect_gotm(n)%field(i,j,k))     &
                   *tmask_advect(i,j+1,k)*tmask_advect(i,j,k)
              Rjm = (advect_gotm(n)%field(i,j,k)   - advect_gotm(n)%field(i,j-1,k))   &
                   *tmask_advect(i,j,k)*tmask_advect(i,j-1,k)

              massflux = Grd%dxtn(i,j) * Adv_vel%vhrho_nt(i,j,k)
              cfl = abs(Adv_vel%vhrho_nt(i,j,k) * dtime * 2.0  &
                   / ((Thickness%rho_dzt(i,j,k,tau) + Thickness%rho_dzt(i,j+1,k,tau)) * Grd%dytn(i,j)))
              d0 = (2.0 - cfl) * (1.0 - cfl) * onesixth
              d1 = (1.0 - cfl * cfl) * onesixth

              thetaP = Rjm / (1.0e-30 + Rj)
              thetaM = Rjp / (1.0e-30 + Rj)

              psiP = max(0.0, min(min(1.0, d0 + d1 * thetaP),   &
                   (1.0 - cfl) / (1.0e-30 + cfl) * thetaP ) )
              psiM = max(0.0, min(min(1.0, d0 + d1 * thetaM),   &
                   (1.0 - cfl) / (1.0e-30 + cfl) * thetaM ) )

              flux_y(i,j,k) =  0.5 * ( ( massflux + abs(massflux) )  &
                   * ( advect_gotm(n)%field(i,j,k) + psiP * Rj )     &
                   + ( massflux - abs(massflux) )                    &
                   * ( advect_gotm(n)%field(i,j+1,k) - psiM * Rj ) ) &
                   * tmask_advect(i,j,k) * tmask_advect(i,j+1,k)

           enddo
        enddo

        ! update GOTM scalar field 
        do j=jsc,jec
           do i=isc,iec
              advect_gotm(n)%field(i,j,k) = advect_gotm(n)%field(i,j,k)                          &
                   + dtime * tmask_advect(i,j,k) * Grd%datr(i,j) / Thickness%rho_dzt(i,j,k,tau)  &
                   * (flux_y(i,j-1,k) - flux_y(i,j,k))
           enddo
        enddo

        ! calculate the overall tendency
        do j=jsc,jec
           do i=isc,iec
 
              advect_gotm(n)%field(i,j,k) = advect_gotm(n)%field(i,j,k)                        &
                   + dtime * Gotm(n)%field(i,j,k,taup1_gotm) / Thickness%rho_dzt(i,j,k,tau) * (  &
                   Adv_vel%wrho_bt(i,j,k) - wkm1(i,j)                                          &
                   + Grd%datr(i,j)*(                                                           &
                   ( Grd%dyte(i-1,j) * Adv_vel%uhrho_et(i-1,j,k)                               &
                   - Grd%dyte( i ,j) * Adv_vel%uhrho_et( i ,j,k))))

              gotm_tendency(i,j,k) = Thickness%rho_dzt(i,j,k,tau)                                     &
                                   *(advect_gotm(n)%field(i,j,k)-Gotm(n)%field(i,j,k,taup1_gotm))/dtime &
                                   *tmask_advect(i,j,k) 

           enddo
        enddo

        ! update vertical velocity for next level
        do j=jsc,jec
           do i=isc,iec
              wkm1(i,j) = Adv_vel%wrho_bt(i,j,k)
           enddo
        enddo

     enddo ! end of k-loop

     ! include effects from pme and river advecting tke and diss into 
     ! the top cell.  Assume pme and river have tke and diss equal 
     ! to that in the top model grid cell.
     do j=jsd,jed
        do i=isd,ied
           gotm_tendency(i,j,1) = gotm_tendency(i,j,1) + &
                                  Grd%tmask(i,j,1)*(pme(i,j)+river(i,j))*Gotm(n)%field(i,j,1,taup1_gotm)
        enddo
     enddo

     ! Note that we need to add the array 
     ! Gotm(n)%field*Thickness%mass_source to maintain compatibility
     ! between evolution of the scalars tke & diss, and the evolution of mass.  
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              gotm_tendency(i,j,k) = gotm_tendency(i,j,k) + &
                                     Gotm(n)%field(i,j,k,taup1_gotm)*Thickness%mass_source(i,j,k)
           enddo
        enddo
     enddo

     if (have_obc) call ocean_obc_zero_boundary(gotm_tendency, "T")

     if (id_gotm_errors(n) > 0) then
     ! update the scalar Gotm field and store erroneous negative values  
       do k=1,nk
         do j=jsc,jec
           do i=isc,iec
              Gotm(n)%field(i,j,k,taup1_gotm) =                                &
                   (Thickness%rho_dzt(i,j,k,tau)*Gotm(n)%field(i,j,k,taup1_gotm) &
                   + dtime*gotm_tendency(i,j,k)) * Thickness%rho_dztr(i,j,k)
              wrk1(i,j,k) = min(Gotm(n)%field(i,j,k,taup1_gotm),0.)
           enddo
         enddo
       enddo
       call diagnose_3d(Time, Grd, id_gotm_errors(n), wrk1(:,:,:))
     else
     ! update the scalar Gotm field.  
       do k=1,nk
         do j=jsc,jec
           do i=isc,iec
              Gotm(n)%field(i,j,k,taup1_gotm) =                                &
                   (Thickness%rho_dzt(i,j,k,tau)*Gotm(n)%field(i,j,k,taup1_gotm) &
                   + dtime*gotm_tendency(i,j,k)) * Thickness%rho_dztr(i,j,k)
           enddo
         enddo
       enddo
     endif
! set to minimum value if negative
     if (correct_adv_errors) then
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 Gotm(n)%field(i,j,k,taup1_gotm) = max(Gotm(n)%field(i,j,k,taup1_gotm), Gotm(n)%min_value) 
              enddo
           enddo
        enddo
     endif
     
     call diagnose_3d(Time, Grd, id_adv_flux_y(n), flux_y(:,:,:))

     if (id_adv_flux_y_int_z(n) > 0) then 
         tmp_flux(:,:) = 0.0
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  tmp_flux(i,j) = tmp_flux(i,j) + flux_y(i,j,k) 
               enddo
            enddo
         enddo
         call diagnose_2d(Time, Grd,id_adv_flux_y_int_z(n), tmp_flux(:,:))
     endif

  enddo ! end of n-loop


end subroutine advect_gotm_sweby
! </SUBROUTINE> NAME="advect_gotm_sweby"


!#######################################################################
! <SUBROUTINE NAME="ocean_vert_gotm_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocean_vert_gotm_restart(time_stamp)
  character(len=*),           intent(in), optional :: time_stamp

  call reset_field_pointer(Got_restart, id_restart_tke,  Gotm(index_tke)%field(:,:,:,taup1_gotm) )  
  call reset_field_pointer(Got_restart, id_restart_diss, Gotm(index_diss)%field(:,:,:,taup1_gotm) )  
  call reset_field_pointer(Got_restart, id_restart_diff, diff_cbt_gotm(:,:,:) )  
  call reset_field_pointer(Got_restart, id_restart_visc, visc_cbt_gotm(:,:,:) )  

  call save_restart(Got_restart, time_stamp)

end subroutine ocean_vert_gotm_restart
! </SUBROUTINE> NAME="ocean_vert_gotm_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_vert_gotm_end">
!
! <DESCRIPTION>
! Save the advection term for restarting the next time step. 
! </DESCRIPTION>
!
subroutine ocean_vert_gotm_end(Time)

  type(ocean_time_type), intent(in) :: Time

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. write_a_restart) then
    write(stdoutunit,'(/a)') &
    '==>Warning from ocean_vert_gotm (ocean_vert_gotm_end): NO restart written.'
    call mpp_error(WARNING,&
    '==>Warning from ocean_vert_gotm_mod (ocean_vert_gotm_end): NO restart written.')
    return
  endif 

  write(stdoutunit,*)' ' 
  write(stdoutunit,*) 'From ocean_vert_gotm_mod: ending tke and diss chksum ==>'
  call write_timestamp(Time%model_time)
  call write_chksum_3d('ending field_tke', Gotm(index_tke)%field(COMP,:,taup1_gotm)*Grd%tmask(COMP,:))
  call write_chksum_3d('ending field_diss', Gotm(index_diss)%field(COMP,:,taup1_gotm)*Grd%tmask(COMP,:))
  call write_chksum_3d('ending diff_cbt_gotm', diff_cbt_gotm(COMP,:)*Grd%tmask(COMP,:))
  call write_chksum_3d('ending visc_cbt_gotm', visc_cbt_gotm(COMP,:)*Grd%tmask(COMP,:))

  return

end subroutine ocean_vert_gotm_end 
! </SUBROUTINE> NAME="ocean_vert_gotm_end"



end module ocean_vert_gotm_mod

module timingModule

  use shr_kind_mod, only : r8 => shr_kind_r8, r4 => shr_kind_r4,       &
                                 i8 => shr_kind_i8, i4 => shr_kind_i4
  implicit none
!
! ... Use system etime() function for timing
!


#if defined( CRAY ) || defined( CRAY_T3E )
#define CPP_REAL r8
#define CPP_INT  i8
#else
#define CPP_REAL r4
#define CPP_INT  i4
#endif


#if defined(USE_VT)
#include "VT.inc"
      integer :: vterr
#endif

      integer, private      :: nblks
      parameter  (nblks   = 100)

      character*20, private :: blkname(nblks)

#if defined(USE_VT)
      integer, private      :: vt_blks(nblks)
#endif

      integer (CPP_INT), private      :: tblk

      real (CPP_REAL), private       :: etime
      real (CPP_REAL), private       :: totim
      real (CPP_REAL), private       :: tarray(2)
      type tms
           private
           real (CPP_REAL) :: usr, sys
      end type tms


      type (tms), private   :: accum(nblks), last(nblks)

      real (CPP_REAL), private       :: us_tmp1(nblks,2)
      real (CPP_REAL), private       :: us_tmp2(nblks,2)

  contains

#ifdef TIMING
  subroutine timing_init

# if defined( CRAY ) || defined( CRAY_T3E )
         real (CPP_REAL)   :: real8c, real8r
# endif
      
         integer (CPP_INT) :: C, R, M
         real (CPP_REAL)   :: wclk

         integer  n


         tblk=0
         do n = 1, nblks
            accum(n)%usr = 0.
            accum(n)%sys = 0.
            last(n)%usr  = 0.
            last(n)%sys  = 0.
         end do
!
! ... To reduce the overhead for the first call
!

# if defined( IRIX64 ) || ( defined FFC )
         totim = etime(tarray)
# else
         CALL SYSTEM_CLOCK(Count=C, Count_Rate=R, Count_Max=M)
#  if defined( CRAY ) || defined( CRAY_T3E )
         real8c = C
         real8r = R
         wclk   = real8c / real8r
         totim  = wclk
#  else
         wclk =  REAL(C) / REAL(R)
         totim = wclk
#  endif
# endif

         end subroutine timing_init


         subroutine timing_on(blk_name)
!
! timing_on
!


         character*(*)  blk_name



         character*20   UC_blk_name
         character*20   ctmp 
         integer i
         integer iblk
# if defined( CRAY ) || defined( CRAY_T3E )
         real (CPP_REAL)   :: real8c, real8r
# endif

         integer (CPP_INT) :: C, R, M
         real (CPP_REAL)   :: wclk

         integer ierr

         UC_blk_name = blk_name

         call upper(UC_blk_name,len_trim(UC_blk_name))
!c         ctmp=UC_blk_name(:len_trim(UC_blk_name))
         ctmp=trim(UC_blk_name)

!         write(*,*) 'timing_on ', ctmp
         iblk=0
         do i=1, tblk
            if ( ctmp .EQ. blkname(i) ) then
               iblk =i
            endif
         enddo
      
         if ( iblk .eq. 0 ) then
            tblk=tblk+1
            iblk=tblk
            call upper(UC_blk_name,len_trim(UC_blk_name))
!C            blkname(iblk)=UC_blk_name(:len_trim(UC_blk_name))
            blkname(iblk)=trim(UC_blk_name)

#if defined(USE_VT)
            vt_blks(iblk)=200+iblk
            call VTsymdef( vt_blks(iblk), blkname(iblk), blkname(iblk), vterr)
#endif

        endif

#if defined(USE_VT)
        call VTbegin(vt_blks(iblk), vterr)
#endif

# if defined( IRIX64 ) || ( defined FFC )
        totim = etime(tarray)
        last(iblk)%usr = tarray(1)
        last(iblk)%sys = tarray(2)
# else
        CALL SYSTEM_CLOCK(Count=C, Count_Rate=R, Count_Max=M)
#  if defined( CRAY ) || defined( CRAY_T3E )
        real8c = C
        real8r = R
        wclk   = real8c / real8r
#  else
        wclk = REAL(C) / REAL(R)
#  endif
        last(iblk)%usr = wclk
        last(iblk)%sys = 0.0
# endif

        end subroutine timing_on


        subroutine timing_off(blk_name)
!
! Timing_off
!

        character*(*) blk_name

        character*20  UC_blk_name
        character*20  ctmp
        integer i
# if defined( CRAY ) || defined( CRAY_T3E )
        real (CPP_REAL)   :: real8c, real8r
# endif

        integer (CPP_INT) :: C, R, M
        real (CPP_REAL)   :: wclk

        integer  iblk

        UC_blk_name = blk_name

        call upper(UC_blk_name,len_trim(UC_blk_name))
!v        ctmp=UC_blk_name(:len_trim(UC_blk_name))
        ctmp=trim(UC_blk_name)

        iblk=0
        do i=1, tblk
           if ( ctmp .EQ. blkname(i) ) then
              iblk =i
           endif
        enddo
      
!         write(*,*) 'timing_off ', ctmp, tblk, tblk
        if ( iblk .eq. 0 ) then
!           write(*,*) 'stop in timing off in ', ctmp
!           stop 
        endif

#if defined(USE_VT)
        call VTend(vt_blks(iblk), vterr)
#endif

# if defined( IRIX64 ) || ( defined FFC ) 
        totim = etime(tarray)
        accum(iblk)%usr = accum(iblk)%usr +           &
                        tarray(1) - last(iblk)%usr
        accum(iblk)%sys = accum(iblk)%sys +           &
                        tarray(2) - last(iblk)%sys
        last(iblk)%usr = tarray(1)
        last(iblk)%sys = tarray(2)
# else
        CALL SYSTEM_CLOCK(Count=C, Count_Rate=R, Count_Max=M)
#  if defined( CRAY ) || defined( CRAY_T3E )
        real8c = C
        real8r = R
        wclk   = real8c / real8r
#  else
        wclk = REAL(C) / REAL(R)
#  endif
        accum(iblk)%usr = accum(iblk)%usr + wclk - last(iblk)%usr
        accum(iblk)%sys = 0.0
        last(iblk)%usr  = wclk
        last(iblk)%sys  = 0.0
# endif

        end subroutine timing_off



        subroutine timing_prt(gid)
!
! Timing_prt
!
        integer  gid
        integer  n

        type (tms)   :: others, tmp(nblks)
        real         :: tmpmax(1)

#if defined( SPMD )

        do n = 1, nblks                   !will clean these later
           tmpmax(1) = accum(n)%usr
           call getmax(1, tmpmax(1))
           tmp(n)%usr = tmpmax(1)
           tmpmax(1) = accum(n)%sys
           call getmax(1, tmpmax(1))
           tmp(n)%sys = tmpmax(1)
        enddo
        if ( gid .eq. 0 ) then
#else
        do n = 1, nblks
           tmp(n)%usr = accum(n)%usr
           tmp(n)%sys = accum(n)%sys
        enddo
#endif

        print *
        print *,                                  &
        '  -------------------------------------------------------------'
        print *,                                  &
        '     Block                  User time  System Time   Total Time'
        print *,                                  &
        '  -------------------------------------------------------------'

        do n = 1, tblk
           print '(3x,a20,2x,3(1x,f12.4))', blkname(n),     &
               tmp(n)%usr, tmp(n)%sys, tmp(n)%usr + tmp(n)%sys
        end do


        print *
#if defined( SPMD )
        print *
        endif
#endif

        end subroutine timing_prt

!endif of (defined TIMING)
#else

 subroutine timing_init
 end subroutine timing_init

 subroutine timing_on(blk_name)
 character*(*)  blk_name
 end subroutine timing_on 

 subroutine timing_off(blk_name)
 character*(*)  blk_name
 end subroutine timing_off 

 subroutine timing_prt(gid)
 integer gid
 end subroutine timing_prt

#endif  

end module TimingModule

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The algebraic kb-equation\label{sec:kbalgebraic}
!
! !INTERFACE:
   subroutine kbalgebraic(nlev)
!
! !DESCRIPTION:
! The algebraic equation for $k_b$ simply assumes equilibrium in \eq{kbeq},
! \begin{equation}
!   \label{kbEquilibrium}
!   P_b = \epsilon_b
!   \point
! \end{equation}
! This equation can be re-written as
! \begin{equation}
!   \label{kbAgebraic}
!   k_b = \dfrac{k_b \epsilon}{k \epsilon_b} \dfrac{k}{\epsilon} P_b
!       = r \dfrac{k}{\epsilon} P_b = c_b \dfrac{k}{\epsilon} P_b
!   \comma
! \end{equation}
! where we used the definition of the time scale ratio $r$ in
! \eq{DefR}, and assumed that $r=c_b$ is a constant.
!

!
! !USES:
   use turbulence,  only:     tke,eps,kb,Pb
   use turbulence,  only:     ctt,kb_min

  IMPLICIT NONE
!
! !INPUT PARAMETERS:

! number of vertical layers
   integer,  intent(in)                 :: nlev

!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: kbalgebraic.F90,v $
!  Revision 20.0  2013/12/14 00:13:44  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1  2005-06-27 10:54:33  kbk
!  new files needed
!
!
!EOP
!-----------------------------------------------------------------------
! !LOCAL VARIABLES:

   integer                             :: i

!-----------------------------------------------------------------------
!BOC

   do i=0,nlev
      kb(i) = ctt*tke(i)/eps(i)*Pb(i)

      !  clip at kb_min
      kb(i) = max(kb(i),kb_min)
   enddo

   return
   end subroutine kbalgebraic

!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

                         module radiation_diag_mod

! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  ds
! </REVIEWER>
! <OVERVIEW>
!  Module that provides a diagnostic output file of radiation-
!    related variables in user-specified atmospheric columns for the
!    sea_esf_rad radiation package.
! </OVERVIEW>
! <DESCRIPTION>
! </DESCRIPTION>

!  shared modules:

use mpp_mod,            only: input_nml_file
use fms_mod,            only: open_namelist_file, fms_init, &
                              mpp_pe, mpp_root_pe, stdlog, &
                              file_exist, write_version_number, &
                              check_nml_error, error_mesg, &
                              FATAL, close_file, &
                              open_file     
use constants_mod,      only: constants_init, radcon_mks, radian

!  shared radiation package modules:

use rad_utilities_mod,  only: Lw_control,  Sw_control,&
                              rad_utilities_init, radiative_gases_type,&
                              astronomy_type, atmos_input_type, &
                              surface_type, cldrad_properties_type, &
                              cld_specification_type,  &
                              cld_space_properties_type, &
                              lw_diagnostics_type, lw_table_type, &
                              sw_output_type, lw_output_type, &
                              Rad_control

!--------------------------------------------------------------------

implicit none
private

!---------------------------------------------------------------------
!    radiation_diag_mod provides a diagnostic output file of radiation-
!    related variables in user-specified atmospheric columns for the
!    sea_esf_rad radiation package.
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module --------------------------

character(len=128)  :: version =  '$Id: radiation_diag.F90,v 19.0 2012/01/06 20:22:27 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!---------------------------------------------------------------------
!------    interfaces   ------

public    &
         radiation_diag_init,  &
         radiation_diag_driver,   &
         radiation_diag_end


private   &
         radiag


!---------------------------------------------------------------------
!---------- namelist  -----

integer, parameter                 :: MAX_PTS = 20
integer, dimension (MAX_PTS)       :: iradprt_gl=0, jradprt_gl=0
real, dimension(MAX_PTS)           :: latradprt=999., lonradprt=999.
integer                            :: num_pts_ij = 0
integer                            :: num_pts_latlon = 0


namelist / radiation_diag_nml /  &
                                  iradprt_gl, jradprt_gl, &
                                  num_pts_ij, num_pts_latlon,       &
                                  latradprt, lonradprt

!----------------------------------------------------------------------
!---  public data ---


!----------------------------------------------------------------------
!---  private data ---

!----------------------------------------------------------------------
!    bandlo and bandhi are the lower and upper frequencies defining 
!    each of the nblw longwave radiation bands in the longwave spectrum
!    (0 - 3000 cm-1).
!----------------------------------------------------------------------
real,    dimension(:), allocatable  :: bandlo, bandhi

!----------------------------------------------------------------------
!    bdlocm and bdhicm are the lower and upper frequencies defining 
!    each of the nbly frequency bands used in the exact cool-to-space
!    calculation.
! --------------------------------------------------------------------
real,    dimension(:), allocatable  :: bdlocm, bdhicm

!---------------------------------------------------------------------
!    iband is frequency band index to be used in combined band 
!    calculations. 
!---------------------------------------------------------------------
integer, dimension(:), allocatable  :: iband

!---------------------------------------------------------------------
!    deglon1 and deglat1 are the longitude and latitude of the columns
!    at which diagnostics will be calculated (degrees).
!---------------------------------------------------------------------
real,    dimension(:), allocatable  :: deglon1, deglat1

!---------------------------------------------------------------------
!    iradprt and jradprt are the processor-based i and j coordinates 
!    of the desired diagnostics columns.
!---------------------------------------------------------------------
integer, dimension(:), allocatable  :: jradprt, iradprt

!---------------------------------------------------------------------
!    do_raddg is an array of logicals indicating which latitude rows
!    belonging to the processor contain diagnostics columns.
!---------------------------------------------------------------------
logical, dimension(:), allocatable  :: do_raddg


integer     :: nbly              ! number of frequency bands for exact 
                                 ! cool-to-space calculation
integer     :: n_continuum_bands ! number of bands in the h2o continuum
integer     :: radiag_unit       ! i/o unit to which output file is 
                                 ! written
integer     :: num_pts           !  total number of columns in which
                                 !  diagnostics are desired
logical     :: module_is_initialized = .false.        
                                 ! module initialized ?


!---------------------------------------------------------------------
!---------------------------------------------------------------------





                       contains


 
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!
!                    PUBLIC SUBROUTINES
!
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!#####################################################################
! <SUBROUTINE NAME="radiation_diag_init">
!  <OVERVIEW> 
!   Constructor of the radiation_diag_mod module
!  </OVERVIEW>
!  <DESCRIPTION>
!   Constructor of the radiation_diag_mod module
!  </DESCRIPTION>
!  <TEMPLATE>
!   call radiation_diag_init (latb, lonb, Lw_tables)
!  </TEMPLATE>
!  <IN NAME="latb" TYPE="real">
!   2d array of model latitudes at cell corners [radians]
!  </IN>
!  <IN NAME="lonb" TYPE="real">
!   2d array of model longitudes at cell corners [radians]
!  </IN>
!  <IN NAME="Lw_tables" TYPE="lw_table_type">
!    lw_tables_type variable containing various longwave
!    table specifiers needed by radiation_diag_mod.
!  </IN>
! </SUBROUTINE>
!
subroutine radiation_diag_init (latb, lonb, Lw_tables)

!---------------------------------------------------------------------
!    radiation_diag_init is the constructor for radiation_diag_mod.
!---------------------------------------------------------------------

!---------------------------------------------------------------------
real, dimension(:,:), intent(in)  ::  latb, lonb         
type(lw_table_type),  intent(in)  ::  Lw_tables
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  intent(in) variables:
!
!       latb      2d array of model latitudes at cell corners [radians]
!       lonb      2d array of model longitudes at cell corners [radians]
!       Lw_tables lw_tables_type variable containing various longwave
!                 table specifiers needed by radiation_diag_mod.
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables

      integer     :: unit, ierr, io, logunit
      integer     :: nn, j, i, nblw
      real        :: dellat, dellon

!--------------------------------------------------------------------
!  local variables
!
!     unit
!
!-------------------------------------------------------------------

!--------------------------------------------------------------------
!    if routine has already been executed, return.
!--------------------------------------------------------------------
      if (module_is_initialized)  return
 
!-------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!-------------------------------------------------------------------
      call fms_init
      call constants_init
      call rad_utilities_init

!-----------------------------------------------------------------------
!    read namelist.              
!-----------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=radiation_diag_nml, iostat=io)
      ierr = check_nml_error(io,'radiation_diag_nml')
#else   
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=radiation_diag_nml, iostat=io, end=10) 
        ierr = check_nml_error(io,'radiation_diag_nml')
        end do                   
10      call close_file (unit)   
      endif                      
#endif
                                  
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                         write (logunit, nml=radiation_diag_nml)

!---------------------------------------------------------------------
!    allocate and initialize a flag array which indicates the latitudes
!    containing columns where radiation diagnostics are desired.
!---------------------------------------------------------------------
      allocate (do_raddg (size(latb,2)-1) )
      do_raddg(:) = .false.

!-------------------------------------------------------------------
!    define the total number of points at which diagnostics are desired.
!    points may be specified either by lat-lon pairs or by global index
!    pairs. 
!-------------------------------------------------------------------
      num_pts = num_pts_latlon + num_pts_ij

!-------------------------------------------------------------------
!    continue on only if diagnostics are desired in at least one column.
!-------------------------------------------------------------------
      if (num_pts > 0) then

!-------------------------------------------------------------------
!    if more points are desired than space has been reserved for, print 
!    a message.
!-------------------------------------------------------------------
        if (num_pts > MAX_PTS) then
          call error_mesg ( 'radiation_diag_mod', &
         'must reset MAX_PTS or reduce number of diagnostics points', &
                                                             FATAL)
        endif

!-------------------------------------------------------------------
!    allocate space for arrays which will contain the lat and lon and
!    processor-local i and j indices.
!-------------------------------------------------------------------
        allocate ( deglon1 (num_pts))
        allocate ( deglat1 (num_pts))
        allocate ( jradprt (num_pts))
        allocate ( iradprt (num_pts))

!---------------------------------------------------------------------
!    if any points for diagnostics are specified by (i,j) global 
!    indices, determine their lat-lon coordinates. assumption is made 
!    that the deltas of latitude and longitude are uniform over 
!    the globe.
!---------------------------------------------------------------------
        do nn=1,num_pts_ij
          dellat = latb(1,2) - latb(1,1)
          dellon = lonb(2,1) - lonb(1,1)
          latradprt(nn + num_pts_latlon) =     &
                      (-0.5*acos(-1.0) + (jradprt_gl(nn) - 0.5)*  &
                                           dellat) * radian
          lonradprt(nn + num_pts_latlon) =                & 
                       (iradprt_gl(nn) - 0.5)*dellon*radian
        end do

!--------------------------------------------------------------------
!    determine if the lat/lon values are within the global grid,
!    latitude between -90 and 90 degrees and longitude between 0 and
!    360 degrees.
!--------------------------------------------------------------------
        do nn=1,num_pts
          jradprt(nn) = 0
          iradprt(nn) = 0
          deglat1(nn) = 0.0
          deglon1(nn) = 0.0
          if (latradprt(nn) .ge. -90. .and. &
              latradprt(nn) .le.  90.) then
          else
            call error_mesg ('radiation_diag_mod', &
                ' invalid latitude for radiation diagnostics ', FATAL)
          endif

          if (lonradprt(nn) .ge. 0. .and. &
              lonradprt(nn) .le. 360.) then
          else
            call error_mesg ('radiation_diag_mod', &
                ' invalid longitude for radiation diagnostics ', FATAL)
          endif

!--------------------------------------------------------------------
!    determine if the diagnostics column is within the current 
!    processor's domain. if so, set a logical flag indicating the
!    presence of a diagnostic column on the particular row, define the 
!    i and j processor-coordinates and the latitude and longitude of 
!    the diagnostics column.
!--------------------------------------------------------------------
          do j=1,size(latb,2) - 1
            if (latradprt(nn) .ge. latb(1,j)*radian .and.  &
                latradprt(nn) .lt. latb(1,j+1)*radian) then
              do i=1,size(lonb,1) - 1
                if (lonradprt(nn) .ge. lonb(i,1)*radian   &
                                  .and.&
                    lonradprt(nn) .lt. lonb(i+1,1)*radian)  &
                                   then
                  do_raddg(j) = .true.
                  jradprt(nn) = j
                  iradprt(nn) = i
                  deglon1(nn) = 0.5*(lonb(i,1) + lonb(i+1,1))*  &
                                radian
                  deglat1(nn) = 0.5*(latb(1,j) + latb(1,j+1))*   &
                                radian
                  exit
                endif
              end do
              exit
            endif
          end do
        end do

!----------------------------------------------------------------------
!    open a unit for the radiation diagnostics output.
!---------------------------------------------------------------------
        radiag_unit = open_file ('radiation_diag.out', action='write', &
                                 threading='multi', form='formatted')

!----------------------------------------------------------------------
!    save the input fields from the lw_tables_type variable that will
!    be used by this module.
!----------------------------------------------------------------------
        nbly              = size(Lw_tables%bdlocm(:))
        nblw              = size(Lw_tables%bandlo(:))
        n_continuum_bands = size(Lw_tables%iband(:))

        allocate ( bdlocm (nbly) )
        allocate ( bdhicm (nbly) )
        allocate ( iband  (n_continuum_bands) )
        allocate ( bandlo (nblw) )
        allocate ( bandhi (nblw) )

        bdlocm(:) = Lw_tables%bdlocm(:)
        bdhicm(:) = Lw_tables%bdhicm(:)
        iband (:) = Lw_tables%iband(:)
        bandlo(:) = Lw_tables%bandlo(:)
        bandhi(:) = Lw_tables%bandhi(:)

      endif     ! (num_pts > 0)

!---------------------------------------------------------------------
!    set flag indicating successful initialization of module.
!---------------------------------------------------------------------
      module_is_initialized = .true.



end subroutine radiation_diag_init





!####################################################################
! <SUBROUTINE NAME="radiation_diag_driver">
!  <OVERVIEW>
!   Subroutine to  determine if a diagnostics column is present
!    in the current physics window, and, if so, calls radiag to 
!    obtain the desired variables in that column and output them to
!    a data file.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to  determine if a diagnostics column is present
!    in the current physics window, and, if so, calls radiag to 
!    obtain the desired variables in that column and output them to
!    a data file.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call radiation_diag_driver (is, ie, js, je, Atmos_input, Surface, Astro, &
!                                  Rad_gases, Cldrad_props,   &
!                                  Cld_spec, Sw_output,   &
!                                  Lw_output, Lw_diagnostics,   &
!                                  Cldspace_rad)
!  </TEMPLATE>
!  <IN NAME="is, ie, js, je" TYPE="integer">
!   starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
!   atmos_input_type variable containing the atmospheric
!                   input fields needed by the radiation package
!  </IN>
!  <IN NAME="Surface" TYPE="Surface">
!   Surface boundary condition to radiation package
!  </IN>
!  <IN NAME="Astro" TYPE="astronomy_type">
!   astronomy_type variable containing the astronomical
!     input fields needed by the radiation package
!  </IN>
!  <IN NAME="Rad_gases" TYPE="radiative_gases_type">
!   radiative_gases_type variable containing the radi-
!                   ative gas input fields needed by the radiation 
!                   package
!  </IN>
!  <IN NAME="Cldrad_props" TYPE="cldrad_prperties_type">
!   cldrad_prperties_type variable containing the cloud radiative
!   property input fields needed by the radiation package
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!   cld_specification_type variable containing 
!                   cloud information relevant to the radiation package
!  </IN>
!  <IN NAME="Sw_output" TYPE="sw_output_type">
!   sw_output_type variable containing shortwave 
!                   radiation output data 
!  </IN>
!  <IN NAME="Lw_output" TYPE="lw_output_type">
!   lw_output_type variable containing longwave 
!                   radiation output data
!  </IN>
!  <IN NAME="Lw_diagnostics" TYPE="lw_diagnostics_type">
!   lw_diagnostics_type variable containing diagnostic
!                   longwave output used by the radiation diagnostics
!                   module
!  </IN>
!  <IN NAME="Cldspace_rad" TYPE="cld_space_properties_type">
!   cld_space_properties_type variable containing infor-
!                   mation on cloud properties seen by the radiation 
!                   package in cloud-space coordinates
!  </IN>
! </SUBROUTINE>
!
subroutine radiation_diag_driver (is, ie, js, je, Atmos_input,  &
                                  Surface, Astro, Rad_gases,   &
                                  Cldrad_props, Cld_spec,  &
                                  Sw_output, Lw_output, Lw_diagnostics,&
                                  Cldspace_rad)

!---------------------------------------------------------------------
!    radiation_diag_driver determines if a diagnostics column is present
!    in the current physics window, and, if so, calls radiag to 
!    obtain the desired variables in that column and output them to
!    a data file.
!----------------------------------------------------------------------

integer,                         intent(in) :: is, ie, js, je
type(atmos_input_type),          intent(in) :: Atmos_input
type(surface_type),              intent(in) :: Surface
type(astronomy_type),            intent(in) :: Astro
type(radiative_gases_type),      intent(in) :: Rad_gases
type(cldrad_properties_type),    intent(in) :: Cldrad_props
type(cld_specification_type),    intent(in) :: Cld_spec       
type(sw_output_type), dimension(:), intent(in) :: Sw_output
type(lw_output_type), dimension(:), intent(in) :: Lw_output
type(lw_diagnostics_type),       intent(in) :: Lw_diagnostics
type(cld_space_properties_type), intent(in) :: Cldspace_rad

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      Atmos_input  atmos_input_type variable containing the atmospheric
!                   input fields needed by the radiation package
!      Surface      surface_type variable containing surface variables
!                   needed by the radiation package
!      Astro        astronomy_type variable containing the astronomical
!                   input fields needed by the radiation package
!      Rad_gases    radiative_gases_type variable containing the radi-
!                   ative gas input fields needed by the radiation 
!                   package
!      Cldrad_props cldrad_properties_type variable containing the 
!                   cloud radiative property input fields needed by the 
!                   radiation package
!      Cld_spec     cld_specification_type variable containing the 
!                   cloud specification input fields needed by the 
!                   radiation package
!      Sw_output    sw_output_type variable containing shortwave 
!                   radiation output data 
!      Lw_output    lw_output_type variable containing longwave 
!                   radiation output data 
!      Lw_diagnostics
!                   lw_diagnostics_type variable containing diagnostic
!                   longwave output used by the radiation diagnostics
!                   module
!      Cldspace_rad cld_space_properties_type variable containing infor-
!                   mation on cloud properties seen by the radiation 
!                   package in cloud-space coordinates
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables

      integer    :: j   ! do-loop index

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('radiation_diag_mod',   &
              'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!    if this physics window includes a point at which diagnostics are 
!    to be calculated, call radiag to compute and write out the desired 
!    column data to a data file.
!---------------------------------------------------------------------
      do j=js,je
        if (do_raddg(j)) then
          call radiag (is, ie, js, je, j, Atmos_input, Surface, Astro, &
                       Rad_gases, Cldrad_props, Cld_spec, Sw_output, &
                       Lw_output, Lw_diagnostics, Cldspace_rad)
        endif
      end do

!--------------------------------------------------------------------


end subroutine radiation_diag_driver



!###################################################################
! <SUBROUTINE NAME="radiation_diag_end">
!  <OVERVIEW>
!   radiation_diag_end is the destructor for radiation_diag_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!   radiation_diag_end is the destructor for radiation_diag_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call radiation_diag_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine radiation_diag_end

!--------------------------------------------------------------------
!    radiation_diag_end is the destructor for radiation_diag_mod.
!--------------------------------------------------------------------
      deallocate ( do_raddg )

      if (num_pts > 0 ) then
!--------------------------------------------------------------------
!    close the radiation_diag.out file.
!--------------------------------------------------------------------
        call close_file (radiag_unit)

!--------------------------------------------------------------------
!    deallocate module arrays.
!--------------------------------------------------------------------
        deallocate ( deglon1, deglat1, jradprt, iradprt,  &
                     bdlocm, bdhicm, iband, bandlo, bandhi )   
      endif

!--------------------------------------------------------------------
      module_is_initialized = .false.    

!---------------------------------------------------------------------


end subroutine radiation_diag_end


 
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!
!                     PRIVATE SUBROUTINES
!
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




!#####################################################################
! <SUBROUTINE NAME="radiag">
!  <OVERVIEW>
!   radiag calculates and outputs radiation diagnostics in user-
!    specified columns.
!  </OVERVIEW>
!  <DESCRIPTION>
!   radiag calculates and outputs radiation diagnostics in user-
!    specified columns.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call radiag (is, ie, js, je, jrow, Atmos_input, Surface, Astro, &
!                   Rad_gases, Cldrad_props, Cld_spec, Sw_output, Lw_output,  &
!                   Lw_diagnostics, Cldspace_rad)
!  </TEMPLATE>
!  <IN NAME="is, ie, js, je" TYPE="integer">
!   starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="jrow" TYPE="integer">
!   the current physics-window j index, which contains 
!                   a radiation diagnostics column
!  </IN>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
!   atmos_input_type variable containing the atmospheric
!                   input fields needed by the radiation package
!  </IN>
!  <IN NAME="Surface" TYPE="Surface">
!   Surface boundary condition to radiation package
!  </IN>
!  <IN NAME="Astro" TYPE="astronomy_type">
!   astronomy_type variable containing the astronomical
!     input fields needed by the radiation package
!  </IN>
!  <IN NAME="Rad_gases" TYPE="radiative_gases_type">
!   radiative_gases_type variable containing the radi-
!                   ative gas input fields needed by the radiation 
!                   package
!  </IN>
!  <IN NAME="Cldrad_props" TYPE="cldrad_prperties_type">
!   cldrad_prperties_type variable containing the cloud radiative
!   property input fields needed by the radiation package
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!   cld_specification_type variable containing 
!                   cloud information relevant to the radiation package
!  </IN>
!  <IN NAME="Sw_output" TYPE="sw_output_type">
!   sw_output_type variable containing shortwave 
!                   radiation output data 
!  </IN>
!  <IN NAME="Lw_output" TYPE="lw_output_type">
!   lw_output_type variable containing longwave 
!                   radiation output data
!  </IN>
!  <IN NAME="Lw_diagnostics" TYPE="lw_diagnostics_type">
!   lw_diagnostics_type variable containing diagnostic
!                   longwave output used by the radiation diagnostics
!                   module
!  </IN>
!  <IN NAME="Cldspace_rad" TYPE="cld_space_properties_type">
!   cld_space_properties_type variable containing infor-
!                   mation on cloud properties seen by the radiation 
!                   package in cloud-space coordinates
!  </IN>
! </SUBROUTINE>
!
subroutine radiag (is, ie, js, je, jrow, Atmos_input, Surface, Astro, &
                   Rad_gases, Cldrad_props, Cld_spec, Sw_output,  &
                   Lw_output, Lw_diagnostics, Cldspace_rad)

!--------------------------------------------------------------------
!    radiag calculates and outputs radiation diagnostics in user-
!    specified columns.
!--------------------------------------------------------------------

integer,                         intent(in) :: is, ie, js, je, jrow
type(atmos_input_type),          intent(in) :: Atmos_input
type(surface_type),              intent(in) :: Surface
type(astronomy_type),            intent(in) :: Astro
type(radiative_gases_type),      intent(in) :: Rad_gases
type(cldrad_properties_type),    intent(in) :: Cldrad_props
type(cld_specification_type),    intent(in) :: Cld_spec       
type(sw_output_type), dimension(:), intent(in) :: Sw_output
type(lw_output_type), dimension(:), intent(in) :: Lw_output
type(lw_diagnostics_type),       intent(in) :: Lw_diagnostics
type(cld_space_properties_type), intent(in) :: Cldspace_rad

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      jrow         the current physics-window j index, which contains 
!                   a radiation diagnostics column
!      Atmos_input  atmos_input_type variable containing the atmospheric
!                   input fields needed by the radiation package
!      Surface      surface_type variable containing surface variables
!                   needed by the radiation package
!      Astro        astronomy_type variable containing the astronomical
!                   input fields needed by the radiation package
!      Rad_gases    radiative_gases_type variable containing the radi-
!                   ative gas input fields needed by the radiation 
!                   package
!      Cldrad_props cldrad_properties_type variable containing the 
!                   cloud radiative property input fields needed by the 
!                   radiation package
!      Cld_spec     cld_specification_type variable containing the 
!                   cloud specification input fields needed by the 
!                   radiation package
!      Sw_output    sw_output_type variable containing shortwave 
!                   radiation output data 
!      Lw_output    lw_output_type variable containing longwave 
!                   radiation output data 
!      Lw_diagnostics
!                   lw_diagnostics_type variable containing diagnostic
!                   longwave output used by the radiation diagnostics
!                   module
!      Cldspace_rad cld_space_properties_type variable containing infor-
!                   mation on cloud properties seen by the radiation 
!                   package in cloud-space coordinates
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables:

      type(lw_output_type)   :: Lw_output_ad
      type(sw_output_type)   :: Sw_output_ad

!---------------------------------------------------------------------
!    these variables are dimensioned by the number of layers in the 
!    grid:
!
!     cts        approximate cool-to-space heating rates for 160-560
!                and 800-990, 1070-1200 cm-1 ranges. (h2o bands)
!                [ degrees K /day ]
!     ctsco2     approximate cool-to-space heating rates for 560-800
!                cm-1 range. (15 micron co2 band)
!                [ degrees K /day ]
!     ctso3      approximate cool-to-space heating rates for 990-1070
!                cm-1 range.  (9.6 micron o3 band)
!                [ degrees K /day ]
!     ctst       approximate cool-to-space heating rates for 160-1200
!                cm-1 range (sum of above 3 variables).
!                [ degrees K /day ]
!     hlwsw      total radiation heating rates.
!                [ degrees K /day ]
!     hlwswcf    total radiation heating rates in the absence of clouds.
!                [ degrees K /day ]
!     convert    factor to convert flux difference (cgs units) to 
!                heating rate in degrees/day.
!                [ (degrees K * sec**3) / ( grams * day) ]
!     cmxolw     amount of maximally overlapped longwave cloud.
!                [ dimensionless ]
!     crndlw     amount of randomly overlapped longwave cloud.
!                [ dimensionless ]
!     camtsw     shortwave cloud amount. 
!                [ dimensionless ]
!     htem       emissivity heating rate, summed over bands 0 - 160,
!                560 - 2200 cm-1.
!                [ degrees K /day ]
!     htem1      emissivity heating rate for 0-160, 1200-2200 cm-1 band,
!                when ch4, n2o are not active,  emissivity heating rate 
!                for 0-160, 1400-2200 cm-1 band when ch4, n2o are 
!                active.
!                [ degrees K /day ]
!     htem2      emissivity heating rate for 560-800 cm-1 band.
!                [ degrees K /day ]
!     htem3      emissivity heating rate for 800-900 cm-1 band
!                [ degrees K /day ]
!     htem4      emissivity heating rate for 900-990 cm-1 band
!                [ degrees K /day ]
!     htem5      emissivity heating rate for 990-1070 cm-1 band.
!                [ degrees K /day ]
!     htem6      emissivity heating rate for 1070-1200 cm-1 band
!                [ degrees K /day ]
!     htem7t     emissivity heating rate over 1200-1400 cm-1 band
!                [ degrees K /day ]
!
!---------------------------------------------------------------------
      real, dimension (size(Atmos_input%press,3) - 1 ) ::   &
                                           cts, ctsco2, ctso3, ctst, &
                                           hlwsw, hlwswcf, convert, &
                                           cmxolw, crndlw, camtsw, &
                                           htem, htem1, htem2, htem3, &
                                           htem4, htem5, htem6, htem7t


!---------------------------------------------------------------------
!    these variables are dimensioned by the number of flux levels
!    (number of layers + 1):
!
!     flx1       net emissivity flux for 0-160, 1200-2200 cm-1 band 
!                when ch4, n2o not active, net emissivity flux for 
!                0-160, 1400-2200 cm-1 band when ch4, n2o are active.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flx2       flux for 560-800 cm-1 band (as one band).
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flx3       flux for 800-900 cm-1 band.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flx4       flux for 900-990 cm-1 band.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flx5       flux for 990-1070 cm-1 band.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flx6       flux for 1070-1200 cm-1 band.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flx1cf     same as flx1, but for cloud-free conditions.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flx2cf     same as flx2, but for cloud-free conditions.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flx3cf     same as flx3, but for cloud-free conditions.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flx4cf     same as flx4, but for cloud-free conditions.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flx5cf     same as flx5, but for cloud-free conditions.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flx6cf     same as flx6, but for cloud-free conditions.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     press      pressure at data levels of model.
!                [ pascals ]
!     pflux      pressure at flux levels of model.
!                [ pascals ]
!     flwsw      sum of net lw and sw fluxes.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flxem      sum of emissivity fluxes over bands 0 - 160,
!                560 - 2200 cm-1.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flxemch4n2o  
!                sum of emissivity fluxes over the nbtrge bands in the 
!                1200 - 1400 cm-1 band.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flwswcf    sum of net lw and sw fluxes in the absence of clouds.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!
!----------------------------------------------------------------------
      real, dimension (size(Atmos_input%press,3)   ) ::   &
                                         flx1, flx2, flx3, flx4, flx5, &
                                         flx6, flx1cf, flx2cf, flx3cf, &
                                         flx4cf, flx5cf, flx6cf,    &
                                         press, pflux, flwsw, flxem, &
                                         flxemch4n2o, flwswcf      


!---------------------------------------------------------------------
!    these variables are dimensioned by the number of flux levels  
!    and the number of bands in the 1200 - 1400 cm-1 range when ch4 
!    and n2o are radiatively active gases.
!     flx7       when ch4, n2o are active, flux for 1200-1400 cm-1 
!                band (nbtrge bands).
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!     flx7cf     same as flx7, but for cloud-free conditions.
!                [ ergs / (cm**2  sec), or gram / sec**3 ]
!
!---------------------------------------------------------------------
      real, dimension (size(Atmos_input%press,3),        &
                       size (Lw_diagnostics%flx1e1f,3) ) :: flx7, flx7cf


!---------------------------------------------------------------------
!    this variable is dimensioned by the number of model layers 
!    and the number of bands in the 1200 - 1400 cm-1 range when ch4 
!    and n2o are radiatively active gases.
!     htem7      emissivity heating rate for each of the nbtrge bands
!                in the 1200-1400 cm-1 band
!                [ degrees K /day ]
!
!---------------------------------------------------------------------
      real, dimension (size(Atmos_input%press,3)-1,    &
                       size (Lw_diagnostics%flx1e1f,3))  :: htem7 


!---------------------------------------------------------------------
!    this variable is dimensioned by the number of model layers 
!    and the number of frequency bands used in the exact cool-to-space 
!    calculation.
!     exctsn     exact cool-to-space heating rates for each band.
!                [ degrees K /day ]
!---------------------------------------------------------------------
      real, dimension (size(Atmos_input%press,3)-1, nbly) :: exctsn


!---------------------------------------------------------------------
!    these variables are dimensioned by the number of frequency bands 
!    used in the exact cool-to-space calculation.
!     ftopn      total cool to space flux at toa for each of the nbly 
!                bands
!                [ Watts / m**2 , or kg / sec**3 ]
!     ftopac     total cool to space flux at toa summed between band 1
!                and band n
!                [ Watts / m**2 , or kg / sec**3 ]
!     vsumac     cool-to-space flux at the ground summed between bands 
!                1 and n.
!                [ Watts / m**2 , or kg / sec**3 ]
!---------------------------------------------------------------------
      real, dimension (nbly) ::  ftopac, ftopn, vsumac


!---------------------------------------------------------------------
!    various scalar variables:
!---------------------------------------------------------------------

      integer :: ncldsw    ! number of clouds at each grid point.
                           ! [ dimensionless ]
      integer :: nrndlw    ! number of randomly overlapped longwave 
                           ! clouds at each grid point.
                           ! [ dimensionless ]
      integer :: nmxolw    ! number of maximally overlapped longwave 
                           ! clouds at each grid point.
                           ! [ dimensionless ]
      real    :: fdiff     ! difference in fluxes (toa - grd)
                           ! [ Watts / m**2 , or kg / sec**3 ]
      real    ::  qsum     ! sum of cool-to-space fluxes through the 
                           ! column in a given band
                           ! [ Watts / m**2 , or kg / sec**3 ]
      real    :: ftopeft   ! flux at toa summed over nbtrge bands in 
                           ! 1200- 1400 cm-1 range.
                           ! [ Watts / m**2 , or kg / sec**3 ]
      real    :: cldext    ! exp (-cldext) = cloud sw extinction     
                           ! [ dimensionless ]
      real    :: cldssalb  ! cloud single-scattering albedo 
                           ! [ dimensionless ]
      real    :: cvisrfgd_dir  ! visible direct beam sfc albedo
                           ! [ dimensionless ]
      real    :: cvisrfgd_dif  ! visible diffuse beam sfc albedo
                           ! [ dimensionless ]
      real    :: cirrfgd_dir   ! infrared direct beam sfc albedo
                           ! [ dimensionless ]
      real    :: cirrfgd_dif   ! infrared diffuse beam sfc albedo
                           ! [ dimensionless ]
      real    :: dfsw_nir, dfsw_nir_dir, dfsw_nir_dif
!     real    :: ufsw_nir, ufsw_nir_dir, ufsw_nir_dif
      real    :: ufsw_nir,               ufsw_nir_dif
      integer :: ks=1      ! index of top level of radiation grid
      integer :: ke        ! index of lowest radiation grid level
      integer :: nlwcldb   ! number of lw cloud bands
      integer :: nbtrge    ! number of h2o bands in the 1200-1400 
                           ! cm-1 range
      integer :: iloc      ! physics window x coordinate of 
                           ! diagnostics column
      integer :: jloc      ! physics window y coordinate of 
                           ! diagnostics column

!---------------------------------------------------------------------
!  miscellaneous indices
!---------------------------------------------------------------------
      integer ::   kc, nprt, ny, nx, k, nn, m, n
      integer :: nz

      if (Rad_control%do_swaerosol_forcing) then
        Sw_output_ad = Sw_output(Rad_control%indx_swaf)
      endif
      if (Rad_control%do_lwaerosol_forcing) then
        Lw_output_ad = Lw_output(Rad_control%indx_lwaf)
      endif

!---------------------------------------------------------------------
!    define the vertical grid dimension and the number of h2o bands in 
!    the 1200 - 1400 cm-1 range.
!---------------------------------------------------------------------
      ke     = size (Atmos_input%press,3) - 1
      nbtrge = size (Lw_diagnostics%flx1e1f,3)

!--------------------------------------------------------------------
!    check for the diagnostic point(s) in the current jrow. define the 
!    physics window coordinates for those points and process the 
!    radiation diagnostic data.
!---------------------------------------------------------------------
      do nn=1,num_pts
        if (jrow == jradprt(nn)) then
          if ( (iradprt(nn) >= is) .and. (iradprt(nn) <= ie) ) then
            iloc = iradprt(nn) - is + 1
            jloc = jradprt(nn) - js + 1

!---------------------------------------------------------------------
!    write out the latitude and longitude of the model point for which
!    diagnostics will be produced.
!---------------------------------------------------------------------
            write (radiag_unit,99000) deglon1(nn), deglat1(nn)

!----------------------------------------------------------------------
!    write longwave cloud data. determine if any clouds are present
!    in the column. if there are, define the number of lw cloud bands.
!----------------------------------------------------------------------
            write (radiag_unit,9009)
            nmxolw     = Cld_spec%nmxolw(iloc, jloc)
            nrndlw     = Cld_spec%nrndlw(iloc, jloc)
            if (nmxolw > 0 .OR. nrndlw > 0) then
              write (radiag_unit,9010) nmxolw, nrndlw    
              nlwcldb = size (Cldrad_props%emmxolw,4)
!----------------------------------------------------------------------
!    write longwave cloud amounts and emissivities for each cloud band.
!    %emmxolw =  lw cloud emissivity for maximally overlapped clouds.
!                [ dimensionless ]
!    %emrndlw =  lw cloud emissivity for randomly overlapped clouds.
!                [ dimensionless ]
!----------------------------------------------------------------------
              do n=1,nlwcldb
                write (radiag_unit,9041) n
                do k = ks,ke
                  cmxolw(k) = Cld_spec%cmxolw(iloc, jloc, k)
                  crndlw(k) = Cld_spec%crndlw(iloc, jloc, k)
                  if (cmxolw(k) > 0.0 .or. crndlw(k) > 0.0)  then
                    write (radiag_unit,9030)   k,    &
                      cmxolw(k), Cldrad_props%emmxolw(iloc,jloc,k,n,1),&
                      crndlw(k), Cldrad_props%emrndlw(iloc,jloc,k,n,1)
                  endif
                end do
              end do

!--------------------------------------------------------------------
!    if no clouds are present, write a message.
!--------------------------------------------------------------------
            else
              write (radiag_unit, 9052)
            endif 

!----------------------------------------------------------------------
!    define the number of shortwave clouds.
!----------------------------------------------------------------------
            ncldsw = Cld_spec%ncldsw(iloc, jloc)
            write (radiag_unit, 9018)
            write (radiag_unit, 9019) ncldsw

!----------------------------------------------------------------------
!    if clouds exist, write shortwave cloud data.
!----------------------------------------------------------------------
            if (ncldsw /= 0) then

!---------------------------------------------------------------------
!     write out the relevant cloud-radiation variables for the lacis-
!     hansen parameterization from the data in Cldspace_rad:
!     %camtswkc   shortwave cloud amounts. their locations are specified
!                 in the ktopsw/kbtmsw indices. 
!                 [ dimensionless ]
!     %cvisrfswkc reflectivity of clouds in the visible frequency band.
!                 [ dimensionless ]
!     %cirabswkc  absorptivity of clouds in the infrared frequency band.
!                 [ dimensionless ]
!     %cirrfswkc  reflectivity of clouds in the infrared frequency band.
!                 [ dimensionless ]
!     %kbtmswkc   index of flux level pressure of cloud bottom.  
!     %ktopswkc   index of flux level pressure of cloud top. 
!---------------------------------------------------------------------
              if (Sw_control%do_lhsw) then
                write (radiag_unit,9035) 
                write (radiag_unit,9036)   (kc,    &
                         Cldspace_rad%camtswkc  (iloc, jloc,kc), &
                         Cldspace_rad%ktopswkc  (iloc,jloc,kc),   &
                         Cldspace_rad%kbtmswkc  (iloc,jloc,kc)   ,   &
                         Cldspace_rad%cvisrfswkc(iloc,jloc,kc),&
                         Cldspace_rad%cirrfswkc (iloc,jloc,kc),    &
                         Cldspace_rad%cirabswkc (iloc,jloc,kc),&
                                                      kc=ncldsw,1,-1)

!---------------------------------------------------------------------
!     write out the relevant cloud-radiation variables for the expo-
!     nential-sum-fit parameterization from the data in Cldspace_rad:
!---------------------------------------------------------------------
              else if (Sw_control%do_esfsw) then

!---------------------------------------------------------------------
!    for each shortwave cloud band, define an exinction factor,
!    single-scattering albedo and asymmetry factor and write them
!    out along with the cloud amount. use the contents of Cldrad_props,
!    Cld_spec and Atmos_input for these calculations:
!    %cldext      cloud extinction coefficient [ km -1 ]  
!    %cldsct      cloud scattering coefficient [ dimensionless ]
!    %cldsasymm   cloud asymmetry factor  [ dimensionless ]
!    %deltaz      model vertical grid interval [ meters ]
!---------------------------------------------------------------------
                do n=1,size(Cldrad_props%cldext,4)
                  write (radiag_unit,9040) n
                  do k=ks,ke
                    if (Cld_spec%camtsw(iloc,jloc,k) > 0.0) then
                      cldext = Cldrad_props%cldext(iloc,jloc,k,n,1)*   &
                               Atmos_input%clouddeltaz(iloc,jloc,k)* &
                               1.0E-03
                      if (cldext > 0.0) then           
                        cldssalb = Cldrad_props%cldsct(iloc,jloc,k,n,1)/ &
                                   Cldrad_props%cldext(iloc,jloc,k,n,1)
                      else
                        cldssalb = 0.0
                      endif
                      write (radiag_unit,9050) k,     &
                             Cld_spec%camtsw (iloc,jloc,k),   &
                             cldext, cldssalb,                      &
                             Cldrad_props%cldasymm(iloc,jloc,k,n,1)
                    endif
                  end do
                end do

!----------------------------------------------------------------------
!    if no shortwave scheme has been specified, abort.
!----------------------------------------------------------------------
              else
                call error_mesg ('radiation_diag_mod', &
                       'no shortwave clouds are activated', FATAL)
              endif

!----------------------------------------------------------------------
!    if no clouds are present in the column, write out a message. 
!----------------------------------------------------------------------
            else
              write (radiag_unit, 9053)
            endif

!--------------------------------------------------------------------
!    if microphysics has been activated, write microphysical parameters
!    at those levels where cloud is present. use variables found in 
!    Cld_spec.
!    %lwp        liquid water path                   [ kg / m**2 ]
!    %iwp        ice water path                      [ kg / m**2 ]
!    %reff_liq_micro effective cloud drop size       [ microns ]
!    %reff_ice_micro effective ice crystal size      [ microns ]
!----------------------------------------------------------------------
            if (ncldsw /= 0) then
              if (Lw_control%do_lwcldemiss .or.    &
                  Sw_control%do_esfsw) then
                write (radiag_unit, 9510)
                do k=ks,ke     
                  if (cmxolw(k) > 0.0 .or. crndlw(k) > 0.0) then
                    write (radiag_unit, 9520)   k,                &
                     1.0e03*Cld_spec%lwp      (iloc,jloc,k),   &
                     1.0e03*Cld_spec%iwp      (iloc,jloc,k),    &
                     Cld_spec%reff_liq_micro(iloc,jloc,k),  &
                     Cld_spec%reff_ice_micro(iloc,jloc,k)
                  endif
                end do
              endif
            endif

!--------------------------------------------------------------------
!    write out the visible and infrared reflectivities at the ground.
!    currently these are both given the same value (Surface%asfc), 
!    but could be different in the future.
!--------------------------------------------------------------------
!           cvisrfgd = Surface%asfc(iloc,jloc)
!           cirrfgd  = Surface%asfc(iloc,jloc)
            cvisrfgd_dir = Surface%asfc_vis_dir(iloc,jloc)
            cirrfgd_dir  = Surface%asfc_nir_dir(iloc,jloc)
            cvisrfgd_dif = Surface%asfc_vis_dif(iloc,jloc)
            cirrfgd_dif  = Surface%asfc_nir_dif(iloc,jloc)
            write (radiag_unit,9059)
!           write (radiag_unit,9060) cvisrfgd, cirrfgd 
            write (radiag_unit,9060) cvisrfgd_dir, cirrfgd_dir, &
                                     cvisrfgd_dif, cirrfgd_dif

!----------------------------------------------------------------------
!     write out the amounts of the radiative gases that the radiation
!     code sees.     
!--------------------------------------------------------------------
            write (radiag_unit,9069)
            write (radiag_unit,9070) Rad_gases%rrvco2
            write (radiag_unit,9071) Rad_gases%rrvf11
            write (radiag_unit,9072) Rad_gases%rrvf12
            write (radiag_unit,9075) Rad_gases%rrvf113
            write (radiag_unit,9076) Rad_gases%rrvf22
            write (radiag_unit,9073) Rad_gases%rrvch4
            write (radiag_unit,9074) Rad_gases%rrvn2o
 
!---------------------------------------------------------------------
!    define the shortwave parameterization being employed. define the 
!    assumption used to specify the solar zenith angle.
!---------------------------------------------------------------------
            write (radiag_unit, 9079)
            if (Sw_control%do_diurnal) then
              write (radiag_unit,99020) 
            else if (Sw_control%do_annual) then
              write (radiag_unit,99025)
            else if (Sw_control%do_daily_mean) then
              write (radiag_unit,99030)
            else ! (if all 3 are false)
              write (radiag_unit,99040)
            endif

!----------------------------------------------------------------------
!     write out the astronomical data used for this shortwave
!     calculation. use the contents in Astro:
!     %fracday         fraction of averaging period that has daylight.
!                      [ dimensionless ]
!     %cosz            mean cosine of zenith angle for all longitudes.
!                      [ dimensionless ]
!     %solar_constant  solar flux at toa at mean earth-sun radius. 
!                      [ Watts / m**2 , or kg / sec**3 ]
!     %rrsun           earth-sun distance relative to mean distance 
!                      [ dimensionless ]
!----------------------------------------------------------------------
            write (radiag_unit,9080)    &
                               Sw_control%solar_constant*Astro%rrsun, &
                               Astro%cosz(iloc,jloc), &
                               Astro%fracday(iloc,jloc)
            if (Rad_control%hires_coszen) then
              write (radiag_unit, 9081)
              do nz = 1,Rad_control%nzens
                write (radiag_unit, 9082) nz
            write (radiag_unit,9080)    &
                               Sw_control%solar_constant*Astro%rrsun, &
                               Astro%cosz_p(iloc,jloc,nz), &
                               Astro%fracday_p(iloc,jloc,nz)
              end do
             endif
        
!----------------------------------------------------------------------
!    write out atmospheric input data and longwave fluxes and heating
!    rates. Use atmospheric fields from Atmos_input and Rad_gases and 
!    longwave data from Lw_output:
!    %rh2o       mass mixing ratio of h2o at model data levels.
!                [ dimensionless ]
!    %qo3        mass mixing ratio of o3 at model data levels.
!                [ dimensionless ]
!    %temp       temperature at data levels of model.
!                [ degrees K ]
!    %heatra     lw heating rate.
!                [ degrees K / day ]
!    %flxnet     net longwave flux at model flux levels (including the 
!                ground and the top of the atmosphere).
!                [ Watts / m**2 , or kg / sec**3 ]
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!    define the pressures at model and flux levels.
!----------------------------------------------------------------------
            do k=ks,ke+1
              pflux(k)  = Atmos_input%pflux(iloc,jloc,k)
              press(k)  = Atmos_input%press(iloc,jloc,k)
            end do

            write(radiag_unit,9090)
            write(radiag_unit,9100)
            write(radiag_unit,9110) (k, press (k),   &
                                     Atmos_input%temp  (iloc,jloc,k),&
                                     Atmos_input%rh2o  (iloc,jloc,k), &
                                     Rad_gases%qo3     (iloc,jloc,k),&
                                     Lw_output(1)%heatra  (iloc,jloc,k),  &
                                     Lw_output(1)%flxnet  (iloc,jloc,k), &
                                     pflux             (k), k=ks,ke)
            write(radiag_unit,9120) press (ke+1), &
                             Atmos_input%temp  (iloc,jloc,ke+1), &
                             Lw_output(1)%flxnet  (iloc,jloc,ke+1), &
                             pflux             (ke+1)

!----------------------------------------------------------------------
!    write out shortwave fluxes and heating rates. use the data in
!    Sw_output:
!    %dfsw       downward short-wave radiation
!                [ Watts / m**2 , or kg / sec**3 ]
!    %fsw        net radiation (up-down) 
!                [ Watts / m**2 , or kg / sec**3 ]
!    %ufsw       upward short-wave radiation.
!                [ Watts / m**2 , or kg / sec**3 ]
!    %hsw        sw radiation heating rates.
!                [ degrees K / day ]
!----------------------------------------------------------------------
            write (radiag_unit,9130)
            if (Sw_control%do_esfsw) then
              write (radiag_unit, 99016)
            else if (Sw_control%do_lhsw) then
              write (radiag_unit, 99018)
            endif
          do nz=1,Rad_control%nzens
                write (radiag_unit, 9082) nz
            write (radiag_unit,9140)
            write (radiag_unit,9150) (k, press(k),   &
                                     Sw_output(1)%hsw  (iloc,jloc,k,nz), &
                                     Sw_output(1)%fsw  (iloc,jloc,k,nz), &
                                     Sw_output(1)%dfsw (iloc,jloc,k,nz),    &
                                     Sw_output(1)%ufsw (iloc,jloc,k,nz),&
                                     pflux          (k), k=ks,ke)
            write (radiag_unit,6556) press(ke+1),    &
                                     Sw_output(1)%fsw  (iloc,jloc,ke+1,nz), &
                                     Sw_output(1)%dfsw (iloc,jloc,ke+1,nz), &
                                     Sw_output(1)%ufsw (iloc,jloc,ke+1,nz), &
                                     pflux          (ke+1)

            if (Sw_control%do_esfsw) then
              dfsw_nir = Sw_output(1)%dfsw(iloc,jloc,ke+1,nz) -   &
                           Sw_output(1)%dfsw_vis_sfc(iloc,jloc,nz)
              dfsw_nir_dir = Sw_output(1)%dfsw_dir_sfc(iloc,jloc,nz) -   &
                             Sw_output(1)%dfsw_vis_sfc_dir(iloc,jloc,nz)
              dfsw_nir_dif = Sw_output(1)%dfsw_dif_sfc(iloc,jloc,nz) -   &
                             Sw_output(1)%dfsw_vis_sfc_dif(iloc,jloc,nz)
              ufsw_nir = Sw_output(1)%ufsw(iloc,jloc,ke+1,nz) -   &
                         Sw_output(1)%ufsw_vis_sfc(iloc,jloc,nz)
              ufsw_nir_dif = Sw_output(1)%ufsw_dif_sfc(iloc,jloc,nz) -   &
                            Sw_output(1)%ufsw_vis_sfc_dif(iloc,jloc,nz)
              write (radiag_unit, 99026)    &
                           Sw_output(1)%dfsw_vis_sfc(iloc,jloc,nz), &
                           Sw_output(1)%ufsw_vis_sfc(iloc,jloc,nz), &
                           Sw_output(1)%dfsw_vis_sfc_dir(iloc,jloc,nz), &
                           Sw_output(1)%dfsw_vis_sfc_dif(iloc,jloc,nz), &
                           Sw_output(1)%ufsw_vis_sfc_dif(iloc,jloc,nz), &
                           dfsw_nir, ufsw_nir,  &
                           dfsw_nir_dir,               &
                           dfsw_nir_dif, ufsw_nir_dif
            endif

!----------------------------------------------------------------------
!    compute and write out total radiative heating and total fluxes 
!    (lw + sw, up-down).
!----------------------------------------------------------------------
            do k=ks,ke+1
              flwsw(k) = Lw_output(1)%flxnet (iloc,jloc,k) +    &
                         Sw_output(1)%fsw    (iloc,jloc,k,nz)
            end do
            do k=ks,ke
              hlwsw(k) = Sw_output(1)%hsw    (iloc,jloc,k,nz) +    &
                         Lw_output(1)%heatra (iloc,jloc,k)
            end do
            write (radiag_unit,9160)
            write (radiag_unit,9170)
            write (radiag_unit,9190) (k, press(k),    &
                                      hlwsw(k), flwsw(k), &
                                      pflux(k), k=ks,ke)
            write (radiag_unit,9180)  press(ke+1), flwsw(ke+1),   &
                                      pflux(ke+1)
      end do

            if (Rad_control%do_totcld_forcing) then
!----------------------------------------------------------------------
!    write out atmospheric input data and longwave fluxes and heating
!    rates for the cloud-free case. use the following data from 
!    Lw_output:
!    %heatracf   lw heating rate in the absence of clouds.
!                [ degrees K / day ]
!    %flxnetcf   net longwave flux at model flux levels (including the 
!                ground and the top of the atmosphere) in the absence of
!                cloud.
!                [ Watts / m**2 , or kg / sec**3 ]
!----------------------------------------------------------------------
              write (radiag_unit,9400)
              write (radiag_unit,9100)
              write (radiag_unit,9110) (k, press (k),  &
                                    Atmos_input%temp  (iloc,jloc,k), &
                                    Atmos_input%rh2o  (iloc,jloc,k), &
                                    Rad_gases%qo3     (iloc,jloc,k), &
                                    Lw_output(1)%heatracf(iloc,jloc,k), &
                                    Lw_output(1)%flxnetcf(iloc,jloc,k), &
                                    pflux (k), k=ks,ke)
              write (radiag_unit,9120)  press (ke+1),  &
                                    Atmos_input%temp  (iloc,jloc,ke+1),&
                                    Lw_output(1)%flxnetcf(iloc,jloc,ke+1),&
                                    pflux(ke+1)

!----------------------------------------------------------------------
!    write out shortwave fluxes and heating rates for the cloud-free 
!    case. use the data in Sw_output:
!    %dfswcf     downward short-wave radiation in absence of clouds
!                [ Watts / m**2 , or kg / sec**3 ]
!    %fswcf      net radiation (up-down) in absence of clouds   
!                [ Watts / m**2 , or kg / sec**3 ]
!    %ufswcf     upward short-wave radiation in absence of clouds
!                [ Watts / m**2 , or kg / sec**3 ]
!    %hswcf      sw radiation heating rates in the absence of clouds.
!                [ degrees K / day ]
!----------------------------------------------------------------------
              write (radiag_unit,9410)
       do nz=1,Rad_control%nzens
                write (radiag_unit, 9082) nz
            write (radiag_unit,9140)
              write (radiag_unit,9150) (k, press(k),   &
                                        Sw_output(1)%hswcf (iloc,jloc,k,nz), &
                                        Sw_output(1)%fswcf (iloc,jloc,k,nz), &
                                        Sw_output(1)%dfswcf(iloc,jloc,k,nz),&
                                        Sw_output(1)%ufswcf(iloc,jloc,k,nz), &
                                        pflux(k), k=ks,ke)
              write (radiag_unit,6556)    &
                                    press(ke+1), &
                                    Sw_output(1)%fswcf(iloc,jloc,ke+1,nz),&
                                    Sw_output(1)%dfswcf(iloc,jloc,ke+1,nz),  &
                                    Sw_output(1)%ufswcf(iloc,jloc,ke+1,nz), &
                                    pflux(ke+1)

!----------------------------------------------------------------------
!    compute and write out total radiative heating and total fluxes 
!    (lw + sw, up-down) for the cloud-free case
!----------------------------------------------------------------------
              do k=ks,ke+1
                flwswcf(k) = Lw_output(1)%flxnetcf(iloc,jloc,k) +    &
                             Sw_output(1)%fswcf   (iloc,jloc,k,nz)
              end do
              do k=ks,ke
                hlwswcf(k) = Sw_output(1)%hswcf   (iloc,jloc,k,nz) +    &
                             Lw_output(1)%heatracf(iloc,jloc,k)
              end do

              write (radiag_unit,9420)
              write (radiag_unit,9170)
              write (radiag_unit,9190) (k, press(k), hlwswcf(k),   &
                                       flwswcf(k), pflux(k), k=ks,ke)
              write (radiag_unit,9180) press(ke+1), flwswcf(ke+1),  &
                                       pflux(ke+1)
      end do
            endif

            if (Rad_control%do_lwaerosol_forcing) then
!----------------------------------------------------------------------
!    write out atmospheric input data and longwave fluxes and heating
!    rates for the aerosol forcing case. use the following data from 
!    Lw_output_ad:
!    %heatra   lw heating rate.
!                [ degrees K / day ]
!    %flxnet   net longwave flux at model flux levels (including the 
!                ground and the top of the atmosphere.
!                [ Watts / m**2 , or kg / sec**3 ]
!    %heatracf   lw heating rate in the absence of clouds.
!                [ degrees K / day ]
!    %flxnetcf   net longwave flux at model flux levels (including the 
!                ground and the top of the atmosphere) in the absence of
!                cloud.
!                [ Watts / m**2 , or kg / sec**3 ]
!----------------------------------------------------------------------
              if (Lw_control%do_lwaerosol) then
! climate includes aerosol effects, lw aerosol forcing by exclusion
                write (radiag_unit,9603)
              else
! climate includes no aerosol effects, lw aerosol forcing by inclusion
                write (radiag_unit,9601)
              endif
              write (radiag_unit,9100)
              write (radiag_unit,9110) (k, press (k),  &
                                    Atmos_input%temp  (iloc,jloc,k), &
                                    Atmos_input%rh2o  (iloc,jloc,k), &
                                    Rad_gases%qo3     (iloc,jloc,k), &
                                    Lw_output_ad%heatra(iloc,jloc,k), &
                                    Lw_output_ad%flxnet(iloc,jloc,k), &
                                    pflux (k), k=ks,ke)
              write (radiag_unit,9120)  press (ke+1),  &
                                    Atmos_input%temp  (iloc,jloc,ke+1),&
                                    Lw_output_ad%flxnet(iloc,jloc,ke+1),&
                                    pflux(ke+1)
! clear-sky results
              if (Lw_control%do_lwaerosol) then
! climate includes aerosol effects, lw aerosol forcing by exclusion
                write (radiag_unit,9604)
              else
! climate includes no aerosol effects, lw aerosol forcing by inclusion
                write (radiag_unit,9602)
              endif
              write (radiag_unit,9100)
              write (radiag_unit,9110) (k, press (k),  &
                                    Atmos_input%temp  (iloc,jloc,k), &
                                    Atmos_input%rh2o  (iloc,jloc,k), &
                                    Rad_gases%qo3     (iloc,jloc,k), &
                                    Lw_output_ad%heatracf(iloc,jloc,k), &
                                    Lw_output_ad%flxnetcf(iloc,jloc,k), &
                                    pflux (k), k=ks,ke)
              write (radiag_unit,9120)  press (ke+1),  &
                                    Atmos_input%temp  (iloc,jloc,ke+1),&
                                    Lw_output_ad%flxnetcf(iloc,jloc,ke+1),&
                                    pflux(ke+1)
            endif

            if (Rad_control%do_swaerosol_forcing) then
!----------------------------------------------------------------------
!    write out atmospheric input data and shortwave fluxes and heating
!    rates for the aerosol forcing case. use the following data from 
!    Sw_output_ad:
!    %dfsw       downward short-wave radiation
!                [ Watts / m**2 , or kg / sec**3 ]
!    %fsw        net radiation (up-down)
!                [ Watts / m**2 , or kg / sec**3 ]
!    %ufsw       upward short-wave radiation
!                [ Watts / m**2 , or kg / sec**3 ]
!    %hsw        sw radiation heating rates
!                [ degrees K / day ]
!    %dfswcf     downward short-wave radiation in absence of clouds
!                [ Watts / m**2 , or kg / sec**3 ]
!    %fswcf      net radiation (up-down) in absence of clouds   
!                [ Watts / m**2 , or kg / sec**3 ]
!    %ufswcf     upward short-wave radiation in absence of clouds
!                [ Watts / m**2 , or kg / sec**3 ]
!    %hswcf      sw radiation heating rates in the absence of clouds.
!                [ degrees K / day ]
!----------------------------------------------------------------------
              if (Sw_control%do_swaerosol) then
! climate includes aerosol effects, sw aerosol forcing by exclusion
                write (radiag_unit,9703)
              else
! climate includes no aerosol effects, sw aerosol forcing by inclusion
                write (radiag_unit,9701)
              endif
              write (radiag_unit,9140)
    do nz = 1, Rad_control%nzens
              write (radiag_unit,9150) (k, press(k),   &
                                        Sw_output_ad%hsw (iloc,jloc,k,nz), &
                                        Sw_output_ad%fsw (iloc,jloc,k,nz), &
                                        Sw_output_ad%dfsw(iloc,jloc,k,nz),&
                                        Sw_output_ad%ufsw(iloc,jloc,k,nz), &
                                        pflux(k), k=ks,ke)
              write (radiag_unit,6556)    &
                                    press(ke+1), &
                                    Sw_output_ad%fsw(iloc,jloc,ke+1,nz),&
                                    Sw_output_ad%dfsw(iloc,jloc,ke+1,nz),  &
                                    Sw_output_ad%ufsw(iloc,jloc,ke+1,nz), &
                                    pflux(ke+1)
! clear-sky results
              if (Sw_control%do_swaerosol) then
! climate includes aerosol effects, sw aerosol forcing by exclusion
                write (radiag_unit,9704)
              else
! climate includes no aerosol effects, sw aerosol forcing by inclusion
                write (radiag_unit,9702)
              endif
              write (radiag_unit,9140)
              write (radiag_unit,9150) (k, press(k),   &
                                        Sw_output_ad%hswcf (iloc,jloc,k,nz), &
                                        Sw_output_ad%fswcf (iloc,jloc,k,nz), &
                                        Sw_output_ad%dfswcf(iloc,jloc,k,nz),&
                                        Sw_output_ad%ufswcf(iloc,jloc,k,nz), &
                                        pflux(k), k=ks,ke)
              write (radiag_unit,6556)    &
                                    press(ke+1), &
                                    Sw_output_ad%fswcf(iloc,jloc,ke+1,nz),&
                                    Sw_output_ad%dfswcf(iloc,jloc,ke+1,nz),  &
                                    Sw_output_ad%ufswcf(iloc,jloc,ke+1,nz), &
                                    pflux(ke+1)
        end do
            endif

            if (Rad_control%do_lwaerosol_forcing .and.   &
                Rad_control%do_swaerosol_forcing) then
       do nz=1,Rad_control%nzens
!----------------------------------------------------------------------
!    compute and write out total radiative heating and total fluxes 
!    (lw + sw, up-down) for the total-sky and cloud-free case
!    with lw and sw aerosol forcing
!----------------------------------------------------------------------
              do k=ks,ke+1
                flwsw(k) = Lw_output_ad%flxnet(iloc,jloc,k) +    &
                             Sw_output_ad%fsw   (iloc,jloc,k,nz)
                flwswcf(k) = Lw_output_ad%flxnetcf(iloc,jloc,k) +    &
                             Sw_output_ad%fswcf   (iloc,jloc,k,nz)
              end do
              do k=ks,ke
                hlwsw(k) = Sw_output_ad%hsw   (iloc,jloc,k,nz) +    &
                             Lw_output_ad%heatra(iloc,jloc,k)
                hlwswcf(k) = Sw_output_ad%hswcf   (iloc,jloc,k,nz) +    &
                             Lw_output_ad%heatracf(iloc,jloc,k)
              end do

              write (radiag_unit,9801)
              write (radiag_unit,9170)
              write (radiag_unit,9190) (k, press(k),    &
                                        hlwsw(k), flwsw(k), &
                                        pflux(k), k=ks,ke)
              write (radiag_unit,9180)  press(ke+1), flwsw(ke+1),   &
                                        pflux(ke+1)

              write (radiag_unit,9802)
              write (radiag_unit,9170)
              write (radiag_unit,9190) (k, press(k), hlwswcf(k),   &
                                       flwswcf(k), pflux(k), k=ks,ke)
              write (radiag_unit,9180) press(ke+1), flwswcf(ke+1),  &
                                       pflux(ke+1)
     end do
            endif

!----------------------------------------------------------------------
!    define emissivity fluxes, both the standard and cloud-free case.
!    note that Lw_diagnostics%fluxn is in cgs units (ergs/(cm**2 sec).
!----------------------------------------------------------------------
            do k=ks,ke+1
              flx1(k) = Lw_diagnostics%fluxn(iloc,jloc,k,1)
              flx2(k) = Lw_diagnostics%fluxn(iloc,jloc,k,2)
              flx3(k) = Lw_diagnostics%fluxn(iloc,jloc,k,3)
              flx4(k) = Lw_diagnostics%fluxn(iloc,jloc,k,4)
              flx5(k) = Lw_diagnostics%fluxn(iloc,jloc,k,5)
              flx6(k) = Lw_diagnostics%fluxn(iloc,jloc,k,6)
              if (Rad_control%do_totcld_forcing) then
                flx1cf(k) = Lw_diagnostics%fluxncf(iloc, jloc, k,1)
                flx2cf(k) = Lw_diagnostics%fluxncf(iloc, jloc, k,2)
                flx3cf(k) = Lw_diagnostics%fluxncf(iloc, jloc, k,3)
                flx4cf(k) = Lw_diagnostics%fluxncf(iloc, jloc, k,4)
                flx5cf(k) = Lw_diagnostics%fluxncf(iloc, jloc, k,5)
                flx6cf(k) = Lw_diagnostics%fluxncf(iloc, jloc, k,6)
              endif
              if (nbtrge > 0) then
                do m=1,nbtrge
                  if (Rad_control%do_totcld_forcing) then
                    flx7cf(k,m) =     &
                             Lw_diagnostics%fluxncf(iloc, jloc, k,6+m)
                  endif
                  flx7(k,m) = Lw_diagnostics%fluxn(iloc, jloc, k,6+m)
                end do
              endif
            end do

!--------------------------------------------------------------------
!    define the factor used to convert a flux divergence in cgs units 
!    to a heating rate in units of degrees per day. the 1.0e-03 
!    converts the fluxes (in cgs) to mks units [ (ergs/cm^2/s)  X 
!    1.0e-03  ---> (J/m^2/s) ]. radcon includes the conversion to 
!    degrees/day from degrees/second.
!---------------------------------------------------------------------
            do k=ks,ke
              convert(k) = 1.0e-03*radcon_mks*    &
                           (1.0/(pflux(k+1) - pflux(k)))
            end do

!----------------------------------------------------------------------
!    compute emissivity heating rates in degrees K / day.
!----------------------------------------------------------------------
            do k=ks,ke
              htem1(k) = (flx1(k+1) - flx1(k))*convert(k)
              htem2(k) = (flx2(k+1) - flx2(k))*convert(k)
              htem3(k) = (flx3(k+1) - flx3(k))*convert(k)
              htem4(k) = (flx4(k+1) - flx4(k))*convert(k)
              htem5(k) = (flx5(k+1) - flx5(k))*convert(k)
              htem6(k) = (flx6(k+1) - flx6(k))*convert(k)
            end do
            if (nbtrge > 0) then
              do m=1,nbtrge
                do k=ks,ke
                  htem7(k,m) = (flx7(k+1,m) - flx7(k,m))* convert(k)
                end do
              end do

!--------------------------------------------------------------------
!    define the sum of the heating rates in the 1200 - 1400 cm-1 band.
!--------------------------------------------------------------------
              do k=ks,ke
                htem7t(k) = 0.0E+00
                do m=1,nbtrge
                  htem7t(k) = htem7t(k) + htem7(k,m)
                end do
              end do
            endif

!----------------------------------------------------------------------
!    define the emissivity heating rate summed over all frequencies.
!----------------------------------------------------------------------
            do k=ks,ke
              htem(k) = htem1(k) + htem2(k) + htem3(k) + htem4(k) +   &
                        htem5(k) + htem6(k)
            end do
            if (nbtrge > 0) then
              do k=ks,ke
                htem(k) = htem(k) + htem7t(k)
              enddo
            endif

!----------------------------------------------------------------------
!    write approximate emissivity heating rates.
!----------------------------------------------------------------------
            if (nbtrge == 0) then
              write (radiag_unit,9200)
              write (radiag_unit,9210) (k, press(k), htem1(k),   &
                                        htem2(k), htem3(k), htem4(k), &
                                        htem5(k), htem6(k), htem(k), &
                                        k=ks,ke)
            else
              if (nbtrge .EQ. 1) then
                write (radiag_unit,9201)
                write (radiag_unit,9211) (k, press(k), htem1(k),  &
                                         htem2(k), htem3(k), htem4(k), &
                                         htem5(k), htem6(k),  &
                                         htem7(k,1), htem(k),k=ks,ke)
              else if (nbtrge .EQ. 2) then
                write (radiag_unit,9202)
                write (radiag_unit,9212) (k, press(k), htem1(k),  &
                                         htem2(k), htem3(k), htem4(k), &
                                         htem5(k), htem6(k),   &
                                         (htem7(k,n),n=1,nbtrge),  &
                                         htem7t(k), htem(k),k=ks,ke)
              else if (nbtrge .EQ. 4) then
                write (radiag_unit,9203)
                write (radiag_unit,9213) (k, press(k), htem1(k),   &
                                         htem2(k), htem3(k), htem4(k),&
                                         htem5(k), htem6(k),   &
                                         (htem7(k,n),n=1,nbtrge),   &
                                         htem7t(k), htem(k),k=ks,ke)
              else if (nbtrge .EQ. 10) then
                write (radiag_unit,9201)
                write (radiag_unit,9211) (k, press(k), htem1(k),  &
                                         htem2(k), htem3(k), htem4(k), &
                                         htem5(k), htem6(k), &
                                         htem7t(k), &
                                         htem(k),k=ks,ke)
              else if (nbtrge .EQ. 20) then
                write (radiag_unit,9201)
                write (radiag_unit,9211) (k, press(k), htem1(k),  &
                                         htem2(k), htem3(k), htem4(k), &
                                         htem5(k), htem6(k), &
                                         htem7t(k), &
                                         htem(k),k=ks,ke)
              endif
            endif

!----------------------------------------------------------------------
!    compute and write out approximate cool-to-space heating rates 
!    for the h2o, 15 micron co2 and 9.6 micron o3 bands individually, 
!    and for their sum. 
!----------------------------------------------------------------------
            do k=ks,ke
              ctsco2(k) = Lw_diagnostics%cts_out(iloc,jloc,k,2)
              ctso3(k)  = Lw_diagnostics%cts_out(iloc,jloc,k,5)
              cts (k)   = Lw_diagnostics%cts_out(iloc,jloc,k,1)
              cts (k)   = cts(k) +      &
                          Lw_diagnostics%cts_out(iloc,jloc,k,3)
              cts (k)   = cts(k) +     &
                          Lw_diagnostics%cts_out(iloc,jloc,k,4)
              cts (k)   = cts(k) +    &
                          Lw_diagnostics%cts_out(iloc,jloc,k,6)
            end do
            do k=ks,ke
              ctst(k) = ctso3(k) + ctsco2(k) + cts(k)
            end do

            write (radiag_unit,9220)
            write (radiag_unit,9230) (k, press(k), cts(k), ctsco2(k),  &
                                     ctso3(k), ctst(k), k=ks,ke)

!----------------------------------------------------------------------
!    write out exact cool-to-space heating rates, total and for each
!    individual band.
!    Lw_diagnostics%excts      exact cool-to-space heating rates for 
!                              160-1200 cm-1 range, when using ckd2.1
!                              continuum, or 560 - 1200 cm-1 range
!                              when using Roberts continuum.
!                              [ degrees K / day ]
!----------------------------------------------------------------------
            do n=1,nbly
              do k=ks,ke
                exctsn(k,n) =  Lw_diagnostics%exctsn(iloc,jloc,k,n)
              end do
            end do
            write (radiag_unit,9240)
            write (radiag_unit,9250) (k, press(k),            &
                                     Lw_diagnostics%excts(iloc,jloc,k),&
                                     (exctsn(k,n), n=1,7) , k=ks,ke)
            write (radiag_unit,9260)
            write (radiag_unit,9250) (k, press(k),   &
                                     (exctsn(k,n), n=8,15) , k=ks,ke)
            if (nbly == 48) then
              write (radiag_unit,9261)
              write (radiag_unit,9250) (k, press(k),   &
                                       (exctsn(k,n), n=16,23) , k=ks,ke)
              write (radiag_unit,9262)
              write (radiag_unit,9250) (k, press(k),   &
                                       (exctsn(k,n), n=24,31) , k=ks,ke)
              write (radiag_unit,9263)
              write (radiag_unit,9250) (k, press(k),   &
                                       (exctsn(k,n), n=32,39) , k=ks,ke)
              write (radiag_unit,9264)
              write (radiag_unit,9250) (k, press(k),   &
                                      (exctsn(k,n), n=40,47) , k=ks,ke)
            endif

!----------------------------------------------------------------------
!    compute net flux at each level summed over all bands.
!----------------------------------------------------------------------
            do k=ks,ke+1
              flxem(k) = flx1(k) + flx2(k) + flx3(k) + flx4(k) +  &
                         flx5(k) + flx6(k)
            end do
            if (nbtrge > 0) then
              flxemch4n2o(:) = 0.0E+00
              do m=1,nbtrge
                do k=ks,ke+1 
                  flxemch4n2o(k) = flxemch4n2o(k) + flx7(k,m)
                end do
              end do
              do k=ks,ke+1
                flxem(k) = flxem(k) + flxemch4n2o(k)
              end do
            endif

!----------------------------------------------------------------------
!    compute sum of flux through atmosphere for each band by converting
!    back the heating rates. the flux at toa is the difference 
!    between the surface flux and this net flux through the atmosphere.
!    %fctsg     cool-to-space flux at the ground for each band.
!                [ Watts / m**2 , or kg / sec**3 ]
!--------------------------------------------------------------------
            do n=1,nbly-1
              qsum = 0.0E+00
              do k=ks,ke
                qsum = qsum + 1.0e-03*exctsn(k,n)/convert(k)
              end do
              ftopn(n) = Lw_diagnostics%fctsg(iloc,jloc,n) - qsum
            end do
            ftopn(nbly) = 0.0E+00

!----------------------------------------------------------------------
!    compute the accumulated sum over bands from band 1 to band n for
!    the surface and toa fluxes.
!---------------------------------------------------------------------- 
            ftopac(1) = ftopn(1)
            vsumac(1) = Lw_diagnostics%fctsg(iloc,jloc,1)
            do n=2,nbly
              ftopac(n) = ftopac(n-1) + ftopn(n)
              vsumac(n) = vsumac(n-1) +           &
                                     Lw_diagnostics%fctsg(iloc,jloc,n)
            end do

!----------------------------------------------------------------------
!    write toa and surface fluxes and the differences between them.
!    %gxcts      flux at top of atmosphere for 160-1200 cm-1 range. 
!                [ Watts / m**2 , or kg / sec**3 ]
!    %flx1e1     flux at top of atmosphere for 0-160, 1200-2200
!                cm-1 range.
!                [ Watts / m**2 , or kg / sec**3 ]
!    %flx1e1f    flux at top of atmosphere for nbtrge bands in 1200-
!                1400 cm-1 range.
!                [ Watts / m**2 , or kg / sec**3 ]
!----------------------------------------------------------------------
            fdiff = Lw_diagnostics%gxcts(iloc,jloc) +   &
                    Lw_diagnostics%flx1e1(iloc,jloc) -    &
                    Lw_output(1)%flxnet(iloc,jloc,ke+1)
            write (radiag_unit,9270)      &
                                Lw_diagnostics%gxcts(iloc,jloc), &
                                Lw_diagnostics%flx1e1(iloc,jloc), &
                                Lw_diagnostics%gxcts(iloc,jloc)+ &
                                    Lw_diagnostics%flx1e1(iloc,jloc),&
                                Lw_output(1)%flxnet(iloc,jloc,ke+1), &
                                fdiff
            if (nbtrge > 0) then
              do m=1,nbtrge
                write (radiag_unit,9271) m,    &
                                   Lw_diagnostics%flx1e1f(iloc,jloc,m)
              end do
              ftopeft   = 0.0E+00
              do m=1,nbtrge
                ftopeft   = ftopeft +    &
                                    Lw_diagnostics%flx1e1f(iloc,jloc,m)
              end do
              write (radiag_unit,9272) ftopeft
            endif

!----------------------------------------------------------------------
!    write out toa and sfc fluxes for 8 combined continuum bands between
!    160-560 cm-1 when ckd2.1 is not active, toa and sfc fluxes for 40 
!    combined continuum bands when ckd2.1 is active.
!----------------------------------------------------------------------
            write(radiag_unit,9280)
            do ny=1,nbly-8   
              nprt = 1
              do nx=1,n_continuum_bands
                if (iband(nx) .EQ. ny) then
                  if (nprt .EQ. 1) then
                    write (radiag_unit,9290) ny,   &
                          bandlo(nx+16), bandhi(nx+16), &
                          ftopn(ny), ftopac(ny),    &
                          Lw_diagnostics%fctsg(iloc,jloc,ny), vsumac(ny)
                    nprt = 0
                  else
                    write (radiag_unit,9300) bandlo(nx+16),   &
                                             bandhi(nx+16)
                  endif
                endif
              end do
            end do

!----------------------------------------------------------------------
!    write out toa and sfc fluxes for remaining bands.
!----------------------------------------------------------------------
            do ny =nbly-7, nbly
              write (radiag_unit,9290) ny,     &
                        bdlocm(ny), bdhicm(ny), ftopn(ny),ftopac(ny), &
                        Lw_diagnostics%fctsg(iloc,jloc,ny), vsumac(ny)
            end do

!----------------------------------------------------------------------
!    write out emissivity fluxes.
!----------------------------------------------------------------------
            write (radiag_unit,9310)
            if (nbtrge == 0) then
              write (radiag_unit,9320) 
              write (radiag_unit,9330) (k, flx1(k),flx2(k), flx3(k),  &
                                       flx4(k), flx5(k), flx6(k), &
                                       flxem(k),  k=ks,ke+1)
            else
              if (nbtrge .EQ. 1) then
                write (radiag_unit,9321)
                write (radiag_unit,9331) (k, flx1(k),flx2(k), &
                                         flx3(k),flx4(k), &
                                         flx5(k), flx6(k), &
                                         flxemch4n2o(k), flxem(k), &
                                         k=ks,ke+1)
              else if (nbtrge .EQ. 2) then
                write (radiag_unit,9322)
                write (radiag_unit,9332) (k, flx1(k),flx2(k), &
                                         flx3(k),flx4(k), &
                                         flx5(k), flx6(k), &
                                         (flx7(k,m   ),m=1,nbtrge), &
                                         flxemch4n2o(k), flxem(k), &
                                         k=ks,ke+1)
              else if (nbtrge .EQ. 4) then
                write (radiag_unit,9323)
                write (radiag_unit,9333) (k, flx1(k),flx2(k), &
                                         flx3(k),flx4(k), &
                                         flx5(k), flx6(k),&
                                         (flx7(k,m),m=1,nbtrge),&
                                         flxemch4n2o(k), flxem(k), &
                                         k=ks,ke+1)
              endif
            endif
          endif
        endif
      end do    ! (num_pts loop)


!----------------------------------------------------------------------
!     format statements.
!----------------------------------------------------------------------

99000  format (/////' GRID POINT LOCATION (DEGREES) : LON = ', &
               F10.5, 2X, ' LAT = ', F10.5)
99016  format (/, ' THIS RUN USED THE EXPONENTIAL-SUM-FIT SW &
               &PARAMETERIZATION.',//)
99018  format (/, ' THIS RUN USED THE LACIS-HANSEN SW &
               &PARAMETERIZATION.',//)
99020  format (' SHORTWAVE CALCULATIONS BASED ON &
               &DIURNALLY VARYING ZENITH ANGLES')
99025  format (' SHORTWAVE CALCULATIONS BASED ON  &
               &ANNUAL MEAN ZENITH ANGLES')
99026  format ( '      VISIBLE SFC SW FLUXES:', //, &
                ' total downward   = ', F12.6,   &
                '   total upward   = ', F12.6,   /, &
                ' downward direct  = ', F12.6,  &
                '   upward direct  =   NONEXISTENT', /,    &
                ' downward diffuse = ', F12.6,  &
                '   upward diffuse = ', F12.6,  //,   &
                '       NIR SFC SW FLUXES:', //, &
                ' total downward   = ', F12.6, &
                '   total upward   = ', F12.6,  /,  &
                ' downward direct  = ', F12.6, &
                '   upward direct  =   NONEXISTENT', /,    &
                ' downward diffuse = ', F12.6, &
                '   upward diffuse = ', F12.6)
99030  format (' SHORTWAVE CALCULATIONS BASED ON &
               &DIURNALLY AVERAGED ZENITH ANGLES')
99040  format (' SHORTWAVE CALCULATIONS BASED ON &
               &SPECIFIED ASTRONOMICAL INPUTS')
9009   format (///, ' ************ LONGWAVE CLOUD DATA ***************')
9010   format (/,' NO. MAX OVERLAP CLOUDS= ',I2,    &
                  ' NO. RANDOM OVERLAP CLOUDS= ',I2)
9018   format (///, ' ************ SHORTWAVE CLOUD DATA **************')
9019   format (/,' NO. SW CLOUDS = ',I2)        
9030   format (I4,7X,4F14.6)
9035   format (22X,' SW CLOUD DATA '/,&
               ' CLD. NO',8X,'CLD. AMT.',2X, &
               'CLD TOP INDEX',2X,'CLD BOT INDEX',2X,'VIS. REFL',3X, &
               ' IR REFL',4X,' IR ABS.')  
9036   format (I5,7X,F12.6,I8,I15,6X,3F12.6)
9040   format (12X,      &
               ' SW CLOUD DATA, BAND = ',i2, &
               /,' MDL. LVL',7X, 'CLD. AMT.',7X,'EXT OP DEP.',3X, &
               ' SSALB.',2X,' ASYMM. PAR.')
9041   format (27X,' LW CLOUD DATA, BAND = ',i2,/,' MDL. LVL',4X, &
               'MXO CLD AMT.',2X,'MXO CLD EMIS',2X, &
               'RNDO CLD AMT.',2X,'RNDO CLD EMIS')
9050   format (I5,7X,F12.6,6X,3F12.6)
9052   format (/, ' THIS LW RADIATION CALL SEES NO CLOUDS.')
9053   format (/, ' THIS SW RADIATION CALL SEES NO CLOUDS.')
9059   format (//, ' *********** SURFACE ALBEDO DATA ****************')
!9060   format (/,10X,'VIS. SFC. ALBEDO=',F12.6,' IR SFC. ALBEDO=',  &
!              F12.6)
9060   format (/,'ALBEDO, VIS. SFC. DIRECT =',F10.6,' ALBEDO, NIR SFC. DIRECT =',  &
               F10.6,   &
              /,'ALBEDO, VIS. SFC. DIFFUSE=',F10.6,' ALBEDO, NIR SFC. DIFFUSE=',  &
               F10.6)
9069   format (//, ' *********** RADIATIVE GAS DATA ****************')
9070   format (/,' CO2 VOL.  MIXING RATIO = ', 6PF10.2,' ppmv')
9071   format (' F11 VOL.  MIXING RATIO = ',12PF10.2,' pptv')
9072   format (' F12 VOL.  MIXING RATIO = ',12PF10.2,' pptv')
9075   format (' F113 VOL. MIXING RATIO = ',12PF10.2,' pptv')
9076   format (' F22 VOL.  MIXING RATIO = ',12PF10.2,' pptv')
9073   format (' CH4 VOL.  MIXING RATIO = ', 9PF10.2,' ppbv')
9074   format (' N2O VOL.  MIXING RATIO = ', 9PF10.2,' ppbv')
9079   format (//, ' *********** ASTRONOMICAL DATA ****************')
9080   format (/,' INCOMING SOLAR FLUX =',F12.6,' W/M**2',/,  &
               ' COS(AZIMUTH)=',F12.6,10X,' FRACTION SUNUP=',F12.6)
9081   format (//, 'FOR THE HIRES ZENITH ANGLES OF THIS STEP:')
9082   format (/, ' ZENITH ANGLE NUMBER :', I4)
9090   format (//,'********* LW HEATING RATES AND FLUXES ***********',/)
9100   format ('  LVL',' PRESSURE   ',4X,' TEMP.     ','H2O MMR',5X,&
               'O3 MMR',7X,'HEAT RATE',2X,'NET FLUX',3X,'FLUX PRESS.')
9110   format (I4,E13.6,F12.4,2E12.5,2F12.6,E13.6)
9120   format (4X,E13.6,F12.4,36X,F12.6,E13.6)
9130   format (/,'*************** SW HEATING RATES AND FLUXES ******',/)
9140   format ('  LVL',' PRESSURE    ',3X,'HEAT RATE',2X,'NET FLUX',  &
               4X,'DN FLUX',6X,'UP FLUX',3X,'FLUX PRESS.') 
6556   format (4X,E13.6,12X,3F12.6,E13.6)
9150   format (I4,E13.6,4F12.6,E13.6)
9160   format (/,'*********** COMBINED HEATING RATES AND FLUXES ****',/)
9170   format ('  LVL',' PRESSURE    ',4X,'HEAT RATE',2X,'NET FLUX',  &
               3X,'FLUX PRESS.') 
9180   format (4X,E13.6,12X,F12.6,E13.6)
9190   format (I4,E13.6,2F12.6,E13.6)
9200   format (/,'****   APPROXIMATE HEATING RATES  (Q(APPROX)) ****'/ &
               '  LVL',' PRESSURE   ',5X,'  0-160,1200-2200 ', &
               '    560-800       ','     800-900      ',   &
               '      900-990     ', '    990-1070      ',  &
               '     1070-1200    ', '       TOTAL')
9210   format (I4,E13.6,7F18.6)
9201   format (/,'****   APPROXIMATE HEATING RATES  (Q(APPROX)) ****'/ &
               '  LVL',' PRESSURE   ',5X,'  0-160,1400-2200 ',  &
               '    560-800       ','     800-900      ',  &
               '      900-990     ', '    990-1070      ',   &
               '     1070-1200    ','     1200-1400    ', &
               '       TOTAL')
9211   format (I4,E13.6,8F18.6)
9202   format (/,'****   APPROXIMATE HEATING RATES  (Q(APPROX)) ****'/ &
               '  LVL',' PRESSURE   ',5X,'  0-160,1400-2200 ',   &
               '    560-800       ','     800-900      ', &
               '      900-990     ',  '    990-1070      ',  &
               '     1070-1200    ','  1200-1300 ', &
               '  1300-1400 ','  1200-1400 ','       TOTAL')
9212   format (I4,E13.6,6F18.6,3F12.6,F18.6)
9203   format (/,'****   APPROXIMATE HEATING RATES  (Q(APPROX)) ****'/ &
               '  LVL',' PRESSURE   ',5X,'  0-160,1400-2200 ',  &
               '    560-800       ','     800-900      ',   &
               '      900-990     ', '    990-1070      ',  &
               '     1070-1200    ','  1200-1250 ',  &
               '  1250-1300 ','  1300-1350 ','  1350-1400 ', &
               '  1200-1400 ','       TOTAL')
9213   format (I4,E13.6,6F18.6,5F12.6,F18.6)
9220   format (/,'*******APPROXIMATE CTS HEATING RATES *****'/    &
               '  LVL',' PRESSURE',&
               7X,' H2O BANDS    ',' 15 UM BAND   ',  &
               ' 9.6 UM BAND  ',' TOTAL')
9230   format (I4,E13.6,4F14.6)
9240   format (/,'********EXACT CTS HEATING RATES, BY BAND *******'/   &
               '  LVL',' PRESSURE   ','    TOTAL    ',5X,'1',11X,  &
               '2',11X,'3',  11X,'4',11X,'5',11X,'6',11X,'7',/)
9250   format (I4,E13.6,8F12.6)
9260   format ('  LVL PRESSURE   ',7X,'8',11X,'9',10X,'10',10X,'11', &
               10X,'12',10X,'13',10X,'14',10X,'15')
9261   format ('  LVL PRESSURE   ',6X,'16',10X,'17',10X,'18',10X,'19',&
               10X,'20',10X,'21',10X,'22',10X,'23')
9262   format ('  LVL PRESSURE   ',6X,'24',10X,'25',10X,'26',10X,'27',&
               10X,'28',10X,'29',10X,'30',10X,'31')
9263   format ('  LVL PRESSURE   ',6X,'32',10X,'33',10X,'34',10X,'35',&
               10X,'36',10X,'37',10X,'38',10X,'39')
9264   format ('  LVL PRESSURE   ',6X,'40',10X,'41',10X,'42',10X,'43',&
               10X,'44',10X,'45',10X,'46',10X,'47')
9270   format ( 40X,'   FLUXES'/   &
               ' FLUX AT TOP,160-1200 CM-1       =',F14.6,' W/M**2'/ &
               ' FLUX AT TOP,0-160,1200-2200 CM-1=',F14.6,' W/M**2'/&
               ' FLUX AT TOP,0-2200 CM-1         =',F14.6,' W/M**2'/&
               ' NET FLUX AT GROUND,0-2200 CM-1  =',F14.6,' W/M**2'/  &
               ' NET FLUX DIFFERENCE,0-2200 CM-1 =',F14.6,' W/M**2')
9271   format ( /,  &
               ' FLUX AT TOP, BAND ',I2,' 1200-1400 CM-1 RANGE =',  &
                F14.6, ' W/M**2')
9272   format ( /,   &
               ' FLUX AT TOP, 1200-1400 CM-1 BAND  =',F14.6, &
                 ' W/M**2')
9280   format (/,'**********CTS FLUXES **********'/   &
               1X,'BAND NO',8X,'LOFREQ',9X,'HIFREQ',9X,'F(1)',  &
               11X,'ACCUM. F(1)',4X,'CTS F(GRD)',5X,'ACCUM. CTS F(GRD)')
9290   format (I11,6F15.6)
9300   format (11X,2F15.6)
9310   format (/,'********* EMISSIVITY FLUXES ***********')
9320   format (/,2x,' lvl ',2x,   &
               ' h2o emiss ',' 560-800   ',' 800-900   ',  &
               ' 900-990   ',' 990-1070  ',' 1070-1200 ','  total    ') 
9321   format (/,2x,' lvl ',2x,   &
               ' h2o emiss ',' 560-800   ',' 800-900   ',' 900-990   ',&
               ' 990-1070  ',' 1070-1200 ',' 1200-1400 ',  &
               '  total    ')
9322   format (/,2x,' lvl ',2x,  &
               ' h2o emiss ',' 560-800   ',' 800-900   ',' 900-990   ',&
               ' 990-1070  ',' 1070-1200 ',' 1200-1300 ', &
               ' 1300-1400 ',' 1200-1400 ',' total     ')
9323   format (/,2x,' lvl ',2x,   &
               ' h2o emiss ',' 560-800   ',' 800-900   ',' 900-990   ',&
               ' 990-1070  ',' 1070-1200 ',' 1200-1250 ',' 1250-1300 ',&
               ' 1300-1350 ',' 1350-1400 ',' 1200-1400 ',  &
               '  total    ')
9330   format (i5,-3p,7f11.5)
9331   format (i5,-3p,8f11.5)
9332   format (i5,-3p,10f11.5)
9333   format (i5,-3p,12f11.5)
9400   format (/,'***** CLEAR-SKY LW HEATING RATES AND FLUXES ******',/)
9410   format (/,'**** CLEAR-SKY SW HEATING RATES AND FLUXES******',/)
9420   format (/,'*** COMBINED CLEAR-SKY HEATING RATES AND FLUXES **',/)
9510   format (///, '********* CLOUD MICROPHYSICAL PARAMETERS ******', &
               /, 2x,'lyr',8x, 'liq water path', 3x,    &
               'ice water path',3x, 'eff diam water', ' eff diam ice')
9520   format (I5,7X,F14.6,3x,F14.6,3x,F14.6,3x,F14.6)
9601   format (/,'***** TOTAL-SKY LW HEATING RATES AND FLUXES (AEROSOLS INCLUDED) ******',/)
9602   format (/,'***** CLEAR-SKY LW HEATING RATES AND FLUXES (AEROSOLS INCLUDED) ******',/)
9603   format (/,'***** TOTAL-SKY LW HEATING RATES AND FLUXES (AEROSOLS EXCLUDED) ******',/)
9604   format (/,'***** CLEAR-SKY LW HEATING RATES AND FLUXES (AEROSOLS EXCLUDED) ******',/)
9701   format (/,'***** TOTAL-SKY SW HEATING RATES AND FLUXES (AEROSOLS INCLUDED) ******',/)
9702   format (/,'***** CLEAR-SKY SW HEATING RATES AND FLUXES (AEROSOLS INCLUDED) ******',/)
9703   format (/,'***** TOTAL-SKY SW HEATING RATES AND FLUXES (AEROSOLS EXCLUDED) ******',/)
9704   format (/,'***** CLEAR-SKY SW HEATING RATES AND FLUXES (AEROSOLS EXCLUDED) ******',/)
9801   format (/,'**** COMBINED HEATING RATES AND FLUXES -- AEROSOL FORCING ****',/)
9802   format (/,'*** COMBINED CLEAR-SKY HEATING RATES AND FLUXES -- AEROSOL FORCING **',/)

!--------------------------------------------------------------------


end subroutine radiag         



!##################################################################



                    end module radiation_diag_mod

Module atmos_carbon_aerosol_mod

! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Shekar Reddy
! </CONTACT>
use mpp_mod, only: input_nml_file 
use fms_mod,                    only : file_exist, close_file, &
                                       write_version_number, &
                                       mpp_pe, mpp_root_pE, &
                                       open_namelist_file,  &
                                       check_nml_error, error_mesg,  &
                                       stdlog, FATAL, NOTE, WARNING
use time_manager_mod,           only : time_type, &
                                       days_in_month, days_in_year, &
                                       set_date, set_time, get_date_julian, &
                                       print_date, get_date, &
                                       operator(>), operator(+), operator(-)
use time_interp_mod,            only:  fraction_of_year, &
                                       time_interp_init
use diag_manager_mod,           only : send_data, register_diag_field, &
                                       diag_manager_init, get_base_time
use tracer_manager_mod,         only : get_tracer_index, &
                                       set_tracer_atts
use field_manager_mod,          only : MODEL_ATMOS
use atmos_tracer_utilities_mod, only : wet_deposition,       &
                                       dry_deposition
use interpolator_mod,           only:  interpolate_type, interpolator_init, &
                                       obtain_interpolator_time_slices,&
                                       unset_interpolator_time_flag, &
                                       interpolator, interpolator_end, &
                                       CONSTANT, INTERP_WEIGHTED_P
use constants_mod,              only : PI, GRAV, RDGAS
implicit none
private
!-----------------------------------------------------------------------
!----- interfaces -------

public  atmos_carbon_aerosol_driver,   &
        atmos_carbon_aerosol_init, &
        atmos_carbon_aerosol_time_vary, &
        atmos_carbon_aerosol_endts, &
        atmos_carbon_aerosol_end

!-----------------------------------------------------------------------
! tracer number for carbonaceous aerosols
integer :: nbcphobic=0
integer :: nbcphilic=0
integer :: nomphobic=0
integer :: nomphilic=0

!--- identification numbers for  diagnostic fields and axes ----
integer :: id_bcphob_emis, id_bcphil_emis, id_omphob_emis, id_omphil_emis
integer :: id_om_emis_col, id_bc_emis_col
integer :: id_om_emis_colv2, id_bc_emis_colv2
integer :: id_bcphob_sink, id_omphob_sink
integer :: id_emisbb, id_omemisbb_col
integer :: id_bcemisbf, id_bcemisbb, id_bcemissh, id_bcemisff, id_bcemisav
integer :: id_omemisbf, id_omemisbb, id_omemissh, id_omemisff, id_omemisbg, id_omemisoc
integer :: id_bc_tau
!----------------------------------------------------------------------
!--- Interpolate_type variable containing all the information needed to
! interpolate the emission provided in the netcdf input file.
type(interpolate_type),save  ::bcff_aerosol_interp
type(interpolate_type),save  ::bcbb_aerosol_interp
type(interpolate_type),save  ::bcbf_aerosol_interp
type(interpolate_type),save  ::bcsh_aerosol_interp
type(interpolate_type),save  ::bcav_aerosol_interp
type(interpolate_type),save  ::omff_aerosol_interp
type(interpolate_type),save  ::ombb_aerosol_interp
type(interpolate_type),save  ::ombf_aerosol_interp
type(interpolate_type),save  ::omsh_aerosol_interp
type(interpolate_type),save  ::omna_aerosol_interp
type(interpolate_type),save  ::omss_aerosol_interp
! Initial calendar time for model
type(time_type) :: model_init_time

! Difference between model initial time and source timeseries applied
! at model initial time
type(time_type), save :: bcff_offset
type(time_type), save :: bcbb_offset
type(time_type), save :: bcbf_offset
type(time_type), save :: bcsh_offset
type(time_type), save :: bcav_offset
type(time_type), save :: omff_offset
type(time_type), save :: ombb_offset
type(time_type), save :: ombf_offset
type(time_type), save :: omsh_offset
type(time_type), save :: omna_offset
type(time_type), save :: omss_offset

! timeseries which is mapped to model initial time
type(time_type), save :: bcff_entry
type(time_type), save :: bcbb_entry
type(time_type), save :: bcbf_entry
type(time_type), save :: bcsh_entry
type(time_type), save :: bcav_entry
type(time_type), save :: omff_entry
type(time_type), save :: ombb_entry
type(time_type), save :: ombf_entry
type(time_type), save :: omsh_entry
type(time_type), save :: omna_entry
type(time_type), save :: omss_entry

! The model initial time is later than the XXX_dataset_entry time  ?
logical, save    :: bcff_negative_offset
logical, save    :: bcbb_negative_offset
logical, save    :: bcbf_negative_offset
logical, save    :: bcsh_negative_offset
logical, save    :: bcav_negative_offset
logical, save    :: omff_negative_offset
logical, save    :: ombb_negative_offset
logical, save    :: ombf_negative_offset
logical, save    :: omsh_negative_offset
logical, save    :: omna_negative_offset
logical, save    :: omss_negative_offset

integer, save    :: bcff_time_serie_type
integer, save    :: bcbb_time_serie_type
integer, save    :: bcbf_time_serie_type
integer, save    :: bcsh_time_serie_type
integer, save    :: bcav_time_serie_type
integer, save    :: omff_time_serie_type
integer, save    :: ombb_time_serie_type
integer, save    :: ombf_time_serie_type
integer, save    :: omsh_time_serie_type
integer, save    :: omna_time_serie_type
integer, save    :: omss_time_serie_type
!----------------------------------------------------------------------
!-------- namelist  ---------
character(len=80) :: bcff_filename = 'carbon_aerosol_emission.nc'
character(len=80) :: bcbb_filename = 'carbon_aerosol_emission.nc'
character(len=80) :: bcbf_filename = 'carbon_aerosol_emission.nc'
character(len=80) :: bcsh_filename = 'carbon_aerosol_emission.nc'
character(len=80) :: bcav_filename = 'carbon_aerosol_emission.nc'
character(len=80) :: omff_filename = 'carbon_aerosol_emission.nc'
character(len=80) :: ombb_filename = 'carbon_aerosol_emission.nc'
character(len=80) :: ombf_filename = 'carbon_aerosol_emission.nc'
character(len=80) :: omsh_filename = 'carbon_aerosol_emission.nc'
character(len=80) :: omna_filename = 'carbon_aerosol_emission.nc'
character(len=80) :: omss_filename = 'gocart_emission.nc'

integer :: i
character(len=80), save, dimension(1) :: bcff_emission_name = (/' '/)
character(len=80), save, dimension(6) :: bcbb_emission_name = (/(' ',i=1,6)/)
character(len=80), save, dimension(1) :: bcbf_emission_name = (/' '/)
character(len=80), save, dimension(1) :: bcsh_emission_name = (/' '/)
character(len=80), save, dimension(1) :: bcav_emission_name = (/' '/)
character(len=80), save, dimension(1) :: omff_emission_name = (/' '/)
character(len=80), save, dimension(6) :: ombb_emission_name = (/(' ',i=1,6)/)
character(len=80), save, dimension(1) :: ombf_emission_name = (/' '/)
character(len=80), save, dimension(1) :: omsh_emission_name = (/' '/)
character(len=80), save, dimension(1) :: omna_emission_name = (/' '/)
character(len=80), save, dimension(1) :: omss_emission_name = (/' '/)

character(len=80), dimension(1) :: bcff_input_name = (/' '/)
character(len=80), dimension(6) :: bcbb_input_name = (/(' ',i=1,6)/)
character(len=80), dimension(1) :: bcbf_input_name = (/' '/)
character(len=80), dimension(1) :: bcsh_input_name = (/' '/)
character(len=80), dimension(1) :: bcav_input_name = (/' '/)
character(len=80), dimension(1) :: omff_input_name = (/' '/)
character(len=80), dimension(6) :: ombb_input_name = (/(' ',i=1,6)/)
character(len=80), dimension(1) :: ombf_input_name = (/' '/)
character(len=80), dimension(1) :: omsh_input_name = (/' '/)
character(len=80), dimension(1) :: omna_input_name = (/' '/)
character(len=80), dimension(1) :: omss_input_name = (/' '/)
! Default values for carbon_aerosol_nml
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! FOSSIL FUEL source can be either:
! for black carbon: 'cooke_and_wilson_1996' 
!                   'cooke_1999' 
!                   'bond_2004'
character(len=80)     :: bcff_source = ' '
character(len=80)     :: bcff_time_dependency_type = 'constant'
integer, dimension(6) :: bcff_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! fossil fuel emission 
! for organic matter: 'cooke_1999' 
!                     'bond_2004'
character(len=80)     :: omff_source = ' '
character(len=80)     :: omff_time_dependency_type = 'constant'
integer, dimension(6) :: omff_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! BIOMASS BURNING emissions can be either
! for black carbon: 'cooke_and_wilson_1996' 
!                   'bond_2004' 
!                   'GEIA level 1 and 2'
!                   'AEROCOM level 1 to 6'
character(len=80)     :: bcbb_source = ' '
character(len=80)     :: bcbb_time_dependency_type = 'constant'
integer, dimension(6) :: bcbb_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
! open biomass burning emission
! for organic matter: 'cooke_and_wilson_1996' 
!                     'bond_2004' 
!                     'GEIA level 1 and 2'
!                     'AEROCOM level 1 to 6'
character(len=80)     :: ombb_source = ' '
character(len=80)     :: ombb_time_dependency_type = 'constant'
integer, dimension(6) :: ombb_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! biofuel emission        
! for black carbon     'bond_2004' 
character(len=80)     :: bcbf_source = ' '
character(len=80)     :: bcbf_time_dependency_type = 'constant'
integer, dimension(6) :: bcbf_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ship emissions based on V. Eyrig
character(len=80)     :: bcsh_source = ' '
character(len=80)     :: bcsh_time_dependency_type
integer, dimension(6) :: bcsh_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! aircraft emissions based on Steven L. Baughcum
character(len=80)     :: bcav_source = ' '
character(len=80)     :: bcav_time_dependency_type = 'constant'
integer, dimension(6) :: bcav_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
! Emission index from Henricks et al., Simulating the global atmospheric
! black carbon cycle: a revisit to the contribution of aircraft emissions,
! Atmos. Chem. Phys., 4, 252102541, 2004.
real :: bc_aircraft_EI = 4.e-5   ! kg BC /kg fuel
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! biofuel emission for organic matter:  'bond_2004' 
character(len=80)     :: ombf_source = ' '
character(len=80)     :: ombf_time_dependency_type = 'constant'
integer, dimension(6) :: ombf_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ship emissions based on V. Eyrig
character(len=80)     :: omsh_source = ' '
character(len=80)     :: omsh_time_dependency_type = 'constant'
integer, dimension(6) :: omsh_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! for natural emssion: Gunther et al., 1996 inventory
character(len=80)     :: omna_source = ' '
character(len=80)     :: omna_time_dependency_type = 'constant'
integer, dimension(6) :: omna_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! for sea spray emssion: based on ODowd et al., A combined organic-inorganic sea-spray source function, Geophys. Res. Lett., v35, L01801, doi:10.1029/2007GL030331, 2008
character(len=80)     :: omss_source = ' '
character(len=80)     :: omss_time_dependency_type = 'constant'
integer, dimension(6) :: omss_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
real, save :: coef_omss_emis
real :: omss_coef=-999.
logical               :: do_dynamic_bc = .false.
real                  :: bcage = 1.0
real                  :: bcageslow = 25.
logical               :: do_dynamic_om = .false.
real                  :: omage = 0.5
real                  :: omageslow = 20.  !days
real                  :: frac_bc_phobic = 0.8
real                  :: frac_bc_philic = 0.2
real                  :: frac_bcbb_phobic = 0.8
real                  :: frac_bcbb_philic = 0.2
real                  :: frac_om_phobic = 0.5
real                  :: frac_om_philic = 0.5
!!!!!!!!!!!!!!!!!!!!!!!!!!
namelist /carbon_aerosol_nml/ &
 bcff_source, bcff_input_name, bcff_filename, &
  bcff_time_dependency_type, bcff_dataset_entry, &
 bcbb_source, bcbb_input_name, bcbb_filename, &
  bcbb_time_dependency_type, bcbb_dataset_entry, &
 bcbf_source, bcbf_input_name, bcbf_filename, &
  bcbf_time_dependency_type, bcbf_dataset_entry, &
 bcsh_source, bcsh_input_name, bcsh_filename, &
  bcsh_time_dependency_type, bcsh_dataset_entry, &
 bcav_source, bcav_input_name, bcav_filename, &
  bcav_time_dependency_type, bcav_dataset_entry, bc_aircraft_EI, &
 omff_source, omff_input_name, omff_filename, &
  omff_time_dependency_type, omff_dataset_entry, &
 ombb_source, ombb_input_name, ombb_filename, &
  ombb_time_dependency_type, ombb_dataset_entry, &
 ombf_source, ombf_input_name, ombf_filename, &
  ombf_time_dependency_type, ombf_dataset_entry, &
 omsh_source, omsh_input_name, omsh_filename, &
  omsh_time_dependency_type, omsh_dataset_entry, &
 omna_source, omna_input_name, omna_filename, &
  omna_time_dependency_type, omna_dataset_entry, &
 omss_source, omss_input_name, omss_filename, &
  omss_time_dependency_type, omss_dataset_entry, omss_coef, &
 do_dynamic_bc, bcage, bcageslow,            &
 do_dynamic_om, omage, omageslow,            &
 frac_bc_phobic, frac_bc_philic, frac_om_phobic, frac_om_philic, &
 frac_bcbb_philic, frac_bcbb_phobic

character(len=6), parameter :: module_name = 'tracer'

logical :: module_is_initialized = .FALSE.
logical :: used

!---- version number -----
character(len=128) :: version = '$Id: atmos_carbon_aerosol.F90,v 20.0 2013/12/13 23:23:44 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
!-----------------------------------------------------------------------

type(time_type)                        :: bcff_time
type(time_type)                        :: bcbb_time
type(time_type)                        :: bcbf_time
type(time_type)                        :: bcsh_time
type(time_type)                        :: bcav_time
type(time_type)                        :: omff_time
type(time_type)                        :: ombb_time
type(time_type)                        :: ombf_time
type(time_type)                        :: omsh_time
type(time_type)                        :: omna_time
type(time_type)                        :: omss_time



contains

!#######################################################################

subroutine atmos_carbon_aerosol_driver(lon, lat, ocn_flx_fraction,  &
                               pfull,phalf, &
                               z_half, z_pbl, &
                               t_surf, w10m, &
                               T, pwt, &
                               bcphob, bcphob_dt,  &
                               bcphil, bcphil_dt,  &
                               omphob, omphob_dt, &
                               omphil, omphil_dt, &
                               oh_conc,&
                               diag_time, is, ie, js, je )

!-----------------------------------------------------------------------
   real, intent(in),  dimension(:,:)   :: lon, lat
   real, intent(in),  dimension(:,:)   :: ocn_flx_fraction
   real, intent(in),  dimension(:,:)   :: z_pbl
   real, intent(in),  dimension(:,:,:) :: z_half
   real, intent(in),  dimension(:,:)   :: w10m, t_surf  ! ocean sea surface temperature and 10 meter wind speed
   real, intent(in),  dimension(:,:,:) :: pwt,pfull,phalf,T
   real, intent(in),  dimension(:,:,:) :: bcphob,bcphil
   real, intent(in),  dimension(:,:,:) :: omphob,omphil
   real, intent(in),  dimension(:,:,:) :: oh_conc
   real, intent(out), dimension(:,:,:) :: bcphob_dt,bcphil_dt
   real, intent(out), dimension(:,:,:) :: omphob_dt,omphil_dt
type(time_type), intent(in)            :: diag_time
integer, intent(in)                    :: is, ie, js, je
!-----------------------------------------------------------------------

real  dtr,bltop,z1,z2,del
real, dimension(size(bcphob,3)) :: fa1, fa2
real, dimension(size(bcphob,3),6) :: fbb
integer :: lf, nlevel_fire
real, dimension(6) :: alt_fire_min, alt_fire_max
! Lower altitude of injection from wild fires 
! These values correspond to the AEROCOM input data (cf. Dentener, ACP, 2006)
integer, parameter :: nlevel_fire_AEROCOM = 6
! Modified GEIA dataset proposed by Reddy and Boucher, J. Geophys. Res., 2004
integer, parameter :: nlevel_fire_GEIA    = 2
real, dimension(nlevel_fire_AEROCOM) :: &
      alt_fire_min_AEROCOM=(/0.,100.,500.,1000.,2000.,3000./)
real, dimension(nlevel_fire_GEIA) :: &
      alt_fire_min_GEIA=(/0.,300./)
! Upper altitude of injection from wild fires 
real, dimension(nlevel_fire_AEROCOM) :: &
      alt_fire_max_AEROCOM=(/100.,500.,1000.,2000.,3000.,6000./)
real, dimension(nlevel_fire_GEIA) :: &
      alt_fire_max_GEIA=(/300.,1500./)
real :: ze1 = 100.
real :: ze2 = 300.
integer        :: i, j,l, id,jd,kd,k
real  :: sst, Schm, SchmCO2, AKw

!
!-------------------------------------------------------------------------
real, dimension(size(bcphob,1),size(bcphob,2)) :: bcemisff_l1, bcemisff_l2
real, dimension(size(omphob,1),size(omphob,2)) :: omemisff_l1, omemisff_l2
real, dimension(size(bcphob,1),size(bcphob,2),6) :: bcemisbb
real, dimension(size(omphob,1),size(omphob,2),6) :: omemisbb

real,dimension(size(bcphob,1),size(bcphob,2)) ::  emisob, omemisob_2d
real,dimension(size(bcphob,1),size(bcphob,2),size(bcphob,3)) ::&
   bcphob_emis, bcphil_emis, bcphob_sink, bcemisob, bcemisff, bcemisav
real,dimension(size(bcphob,1),size(bcphob,2),size(bcphob,3)) :: bc_tau
real,dimension(size(omphob,1),size(omphob,2),size(omphob,3)) ::&
   omphob_emis, omphil_emis, omphob_sink, omemisob, omemisff
real, dimension(size(bcphob,1),size(bcphob,2)) ::          &
   bcemisbf, bcemissh
real, dimension(size(omphob,1),size(omphob,2)) ::          &
   omemisbf, omemissh, omemisbg, dmso, omemisocean
real,dimension(size(bcphob,1),size(bcphob,2)) :: bc_emis, om_emis
real,dimension(size(bcphob,1),size(bcphob,2),size(bcphob,3)) ::zzz1,  &
                                                               oh_conc1
!
!-----------------------------------------------------------------------
!
      id=size(bcphob,1); jd=size(bcphob,2); kd=size(bcphob,3)

      dtr= PI/180.

!----------- compute black carbon source ------------

    bcphob_dt = 0.0
    bcphil_dt = 0.0
    omphob_dt = 0.0
    omphil_dt = 0.0
! emission rates (kg/m2/s)
    bcemisff_l1(:,:) = 0.0
    bcemisff_l2(:,:) = 0.0
    bcemisff(:,:,:)  = 0.0
    bcemisbb(:,:,:)  = 0.0
    bcemisob(:,:,:)  = 0.0
    emisob(:,:) = 0.
    omemisob_2d(:,:) = 0.
    bcemisbf(:,:)    = 0.0
    bcemissh(:,:)    = 0.0
    bcemisav(:,:,:)  = 0.0

    bcphob_emis(:,:,:) = 0.0
    bcphil_emis(:,:,:) = 0.0
    bcphob_sink(:,:,:) = 0.0
    omphob_emis(:,:,:) = 0.0
    omphil_emis(:,:,:) = 0.0
    omphob_sink(:,:,:) = 0.0
    bc_tau(:,:,:)      = 0.0

    omemisff_l1(:,:) = 0.0
    omemisff_l2(:,:) = 0.0
    omemisff(:,:,:)  = 0.0
    omemisbb(:,:,:)  = 0.0
    omemisob(:,:,:)  = 0.0
    omemisbf(:,:)    = 0.0
    omemissh(:,:)    = 0.0
    omemisbg(:,:)    = 0.0
    dmso(:,:)        = 0.0
    omemisocean(:,:) = 0.0

    if ( trim(bcff_source) .ne. ' ') then
     call interpolator(bcff_aerosol_interp, bcff_time, bcemisff_l1, &
          trim(bcff_emission_name(1)), is, js)
   endif

   if ( trim(bcbb_source).ne.' ') then
    nlevel_fire = 1
    alt_fire_min(:) = 0.0
    alt_fire_max(:) = 0.0
    select case (trim(bcbb_source))
      case ('cooke_and_wilson_1996')
        call interpolator(bcbb_aerosol_interp, bcbb_time, bcemisbb(:,:,1), &
                         trim(bcbb_emission_name(1)), is, js)
      case ('bond_2004') 
        call interpolator(bcbb_aerosol_interp, bcbb_time, bcemisbb(:,:,1), &
                         trim(bcbb_emission_name(1)), is, js)
      case ('gocart_2007') 
        call interpolator(bcbb_aerosol_interp, bcbb_time, bcemisbb(:,:,1), &
                         trim(bcbb_emission_name(1)), is, js)
      case ('RETRO') 
        call interpolator(bcbb_aerosol_interp, bcbb_time, bcemisbb(:,:,1), &
                         trim(bcbb_emission_name(1)), is, js)
      case ('GEIA')
        nlevel_fire = nlevel_fire_GEIA
        alt_fire_min(1:nlevel_fire_GEIA) = alt_fire_min_GEIA(1:nlevel_fire_GEIA)
        alt_fire_max(1:nlevel_fire_GEIA) = alt_fire_max_GEIA(1:nlevel_fire_GEIA)
        do lf=1, nlevel_fire 
          call interpolator(bcbb_aerosol_interp, bcbb_time, bcemisbb(:,:,lf), &
                         trim(bcbb_emission_name(lf)), is, js)
        enddo
      case ('AEROCOM') 
! Wildfire emissions at 6 levels from 0 to 6 km
! (cf. AEROCOM web site or Dentener et al., ACPD, 2006)
        nlevel_fire = nlevel_fire_AEROCOM
        alt_fire_min(1:nlevel_fire_AEROCOM) = &
                 alt_fire_min_AEROCOM(1:nlevel_fire_AEROCOM)
        alt_fire_max(1:nlevel_fire_AEROCOM) = &
                 alt_fire_max_AEROCOM(1:nlevel_fire_AEROCOM)
        do lf=1, nlevel_fire 
          call interpolator(bcbb_aerosol_interp, bcbb_time, bcemisbb(:,:,lf), &
                        trim(bcbb_emission_name(lf)), is, js)
        enddo
    end select
   endif
   if ( trim(bcbf_source).ne. ' ') then
     call interpolator(bcbf_aerosol_interp, bcbf_time, bcemisbf, &
                       trim(bcbf_emission_name(1)), is, js)
   endif

   if ( trim(bcsh_source).ne. ' ') then
     call interpolator(bcsh_aerosol_interp, bcsh_time, bcemissh, &
                  trim(bcsh_emission_name(1)), is, js)
   endif
   if ( trim(bcav_source).ne. ' ') then
     call interpolator(bcav_aerosol_interp, bcav_time, phalf, bcemisav, &
                         trim(bcav_emission_name(1)), is, js)
   endif
   if ( trim(omff_source).ne. ' ') then
     call interpolator(omff_aerosol_interp, omff_time, omemisff_l1, &
                      trim(omff_emission_name(1)), is, js)
   endif
   if ( trim(ombb_source).ne. ' ') then
    omemisbb(:,:,:) = 0.0
    nlevel_fire = 1
    alt_fire_min(:) = 0.0
    alt_fire_max(:) = 0.0
    select case (trim(ombb_source))
      case ('cooke_and_wilson_1996')
        call interpolator(ombb_aerosol_interp, ombb_time, omemisbb(:,:,1), &
                           trim(ombb_emission_name(1)), is, js)
        omemisbb(:,:,1) = omemisbb(:,:,1)*7.0
      case ('bond_2004') 
        call interpolator(ombb_aerosol_interp, ombb_time, omemisbb(:,:,1), &
                       trim(ombb_emission_name(1)), is, js)
      case ('gocart_2007')
        call interpolator(ombb_aerosol_interp, ombb_time, omemisbb(:,:,1), &
                       trim(ombb_emission_name(1)), is, js)
      case ('RETRO')
        call interpolator(ombb_aerosol_interp, ombb_time, omemisbb(:,:,1), &
                       trim(ombb_emission_name(1)), is, js)
      case ('GEIA')
        nlevel_fire = nlevel_fire_GEIA
        alt_fire_min(1:nlevel_fire_GEIA) = alt_fire_min_GEIA(1:nlevel_fire_GEIA)
        alt_fire_max(1:nlevel_fire_GEIA) = alt_fire_max_GEIA(1:nlevel_fire_GEIA)
! GEIA emission inventory scaled by ATSR fire counts (Reddy and Boucher, 2004)
! There are 2 levels of emission
        do lf=1, nlevel_fire
          call interpolator(ombb_aerosol_interp, ombb_time, omemisbb(:,:,lf), &
                       trim(ombb_emission_name(lf)), is, js)
        enddo
      case ('AEROCOM')
        nlevel_fire = nlevel_fire_AEROCOM
        alt_fire_min(1:nlevel_fire_AEROCOM) = &
              alt_fire_min_AEROCOM(1:nlevel_fire_AEROCOM)
        alt_fire_max(1:nlevel_fire_AEROCOM) = &
              alt_fire_max_AEROCOM(1:nlevel_fire_AEROCOM)
! Wildfire emissions at 6 levels from 0 to 6 km
! (cf. AEROCOM web site or Dentener et al., ACPD, 2006)
        do lf=1, nlevel_fire
          call interpolator(ombb_aerosol_interp, ombb_time, omemisbb(:,:,lf), &
                        trim(ombb_emission_name(lf)), is, js)
        enddo
    end select
   endif
   if ( trim(ombf_source).ne. ' ') then
     call interpolator(ombf_aerosol_interp, ombf_time, omemisbf, &
                       trim(ombf_emission_name(1)), is, js)
   endif
   if ( trim(omsh_source).ne. ' ') then
     call interpolator(omsh_aerosol_interp, omsh_time, omemissh, &
                  trim(omsh_emission_name(1)), is, js)
   endif
   if ( trim(omna_source).ne. ' ') then
     call interpolator(omna_aerosol_interp, omna_time, omemisbg, &
                       trim(omna_emission_name(1)), is, js)
   endif
   if ( trim(omss_source).ne. ' ') then
     call interpolator(omss_aerosol_interp, omss_time, dmso, &
                       trim(omss_emission_name(1)), is, js)
     do j = 1, jd
     do i = 1, id
       SST = t_surf(i,j)-273.15     ! Sea surface temperature [Celsius]
       if (ocn_flx_fraction(i,j).gt.0.) then
!  < Schmidt number (Saltzman et al., 1993) >
         Schm = 2674.0 - 147.12*SST + 3.726*(SST**2) - 0.038*(SST**3)
         Schm = max(1., Schm)
! ---  Liss and Merlivat (1986) -----------
         SchmCO2 = 600.
         if (w10m(i,j) .le. 3.6) then
           AKw = 0.17 * w10m(i,j)
         else if (w10m(i,j) .le. 13.) then
           AKw = 2.85 * w10m(i,j) - 9.65
              else
           AKw = 5.90 * w10m(i,j) - 49.3
         end if
         if (w10m(i,j) .le. 3.6) then
           AKw = AKw * ((SchmCO2/Schm) ** 0.667)
         else
           AKw = AKw * sqrt(SchmCO2/Schm)
         end if
         omemisocean(i,j) = coef_omss_emis*AKw/100./3600. * 1.e-6*ocn_flx_fraction(i,j)
       end if

     enddo
     enddo


   endif
!
    do j = 1, jd
      do i = 1, id

! --- For fosil fuel emissions, calculate the fraction of emission for
! --- each vertical levels
        fa1(:) = 0.
        fa2(:) = 0.
        do l = kd,2,-1
          Z1 = z_half(i,j,l+1)-z_half(i,j,kd+1)
          Z2 = z_half(i,j,l)-z_half(i,j,kd+1)
          if (Z2.ge.0.and.Z1.lt.ze1) then
            if (Z1.gt.0) then
              if (Z2.lt.ze1) then
                fa1(l)=(Z2-Z1)/ze1
              else
                fa1(l)=(ze1-Z1)/ze1
              endif
            else
              if (Z2.le.ze1) then
                fa1(l)=Z2/ze1
              else
                fa1(l)=1.
              endif
            endif
          endif
          
          if (Z2.ge.ze1.and.z1.lt.ze2) then
            if (Z1.gt.Ze1) then
              if (Z2.lt.ze2) then
                fa2(l)=(z2-z1)/(ze2-ze1)
              else
                fa2(l)=(ze2-z1)/(ze2-ze1)
              endif
            else
              if (Z2.le.ze2) then
                fa2(l)=(z2-ze1)/(ze2-ze1)
              else
                fa2(l)=1.
              endif
            endif
          endif
          if (Z1.gt.Ze2) exit
        enddo
!
! Calculate fraction of emission at every levels for open fires
!
        fbb(:,:)=0.
!
! In case of multiple levels, which are fixed
!
        if (nlevel_fire .gt. 1) then
          do l = kd,2,-1
            Z1 = z_half(i,j,l+1)-z_half(i,j,kd+1)
            Z2 = z_half(i,j,l)-z_half(i,j,kd+1)
            do lf=1,nlevel_fire
              del=alt_fire_max(lf)-alt_fire_min(lf)
              if (del.gt.0. .and. &
                  Z1.lt.alt_fire_max(lf).and.Z2.gt.alt_fire_min(lf) ) then
                if (Z1.ge.alt_fire_min(lf)) then
                  if (Z2 .lt. alt_fire_max(lf)) then
                    fbb(l,lf)=(Z2-Z1)/del
                  else
                    fbb(l,lf)=(alt_fire_max(lf)-z1)/del
                  endif
                else
                  if (Z2.le.alt_fire_max(lf)) then
                    fbb(l,lf) = (Z2-alt_fire_min(lf))/del
                  else
                    fbb(l,lf)=1.
                  endif
                endif
              endif
            enddo
          enddo
        else
!
! --- Inject equally through the boundary layer -------
!
          bltop = z_pbl(i,j)
          do l = kd,1,-1
            z1=z_half(i,j,l+1)-z_half(i,j,kd+1)
            z2=z_half(i,j,l)-z_half(i,j,kd+1)
            if (bltop.lt.z1) exit
            if (bltop.ge.z2) fbb(l,1)=(z2-z1)/bltop
            if (bltop.gt.z1.and.bltop.lt.z2) fbb(l,1) = (bltop-z1)/bltop
          enddo
        endif
! Fossil fuel emission
        bcemisff(i,j,:)=fa1(:) * bcemisff_l1(i,j) + fa2(:) * bcemisff_l2(i,j)
        omemisff(i,j,:)=fa1(:) * omemisff_l1(i,j) + fa2(:) * omemisff_l2(i,j)
! Open biomass burning fires emission
        do lf =1, nlevel_fire
          bcemisob(i,j,:)= bcemisob(i,j,:) + fbb(:,lf)*bcemisbb(i,j,lf)
          omemisob(i,j,:)= omemisob(i,j,:) + fbb(:,lf)*omemisbb(i,j,lf)
        enddo
! Biogenic
! Bio-fuel (if not included in fossil fuel inevntory)
! International shipping
        omphob_emis(i,j,kd) =  omemisbf(i,j) + omemissh(i,j) + &
           omemisbg(i,j) + omemisocean(i,j)
        omphob_emis(i,j,:)= omphob_emis(i,j,:) + omemisff(i,j,:) + &
           omemisob(i,j,:)

        do l=1,kd
          emisob(i,j) = emisob(i,j) + bcemisob(i,j,l) + omemisob(i,j,l)
          omemisob_2d(i,j) = omemisob_2d(i,j) + omemisob(i,j,l)
        end do

        omphil_emis(i,j,:) = omphob_emis(i,j,:) * frac_om_philic/pwt(i,j,:)
        omphob_emis(i,j,:) = omphob_emis(i,j,:) * frac_om_phobic/pwt(i,j,:)
!
      enddo
    enddo

!------------------------------------------------------------------------
! if frac_bcbb_phobic .eq. frac_bc_phobic, then frac_bcbb_philic must equal
!  frac_bc_philic, since sum must be 1.
!------------------------------------------------------------------------
    if (frac_bcbb_phobic == frac_bc_phobic) then
      do j = 1, jd
        do i = 1, id
          bcphob_emis(i,j,kd) =  bcemisbf(i,j) + bcemissh(i,j)
          bcphob_emis(i,j,:)= bcphob_emis(i,j,:) + &
                              bc_aircraft_EI * bcemisav(i,j,:)    + &
                              bcemisff(i,j,:) + bcemisob(i,j,:)
          bcphil_emis(i,j,:) = bcphob_emis(i,j,:)*frac_bc_philic/pwt(i,j,:)
          bcphob_emis(i,j,:) = bcphob_emis(i,j,:)*frac_bc_phobic/pwt(i,j,:)
        enddo
      enddo
    else
      do j = 1, jd
        do i = 1, id
          bcphob_emis(i,j,kd) =  bcemisbf(i,j) + bcemissh(i,j)
          bcphob_emis(i,j,:)= bcphob_emis(i,j,:) + &
                              bc_aircraft_EI * bcemisav(i,j,:)    + &
                              bcemisff(i,j,:) 
          bcphil_emis(i,j,:) = (bcphob_emis(i,j,:)*frac_bc_philic +   &
                               bcemisob(i,j,:)*frac_bcbb_philic)/pwt(i,j,:)
          bcphob_emis(i,j,:) = (bcphob_emis(i,j,:)*frac_bc_phobic +   &
                               bcemisob(i,j,:)*frac_bcbb_phobic)/pwt(i,j,:)
        enddo
      enddo
    endif

!------- compute black carbon phobic sink --------------
!
!  BCphob has a half-life time of 1.0days 
!   (corresponds to an e-folding time of 1.44 days)
!
!  sink = 1./(86400.*1.44) = 8.023e-6

    do l = 1,kd
      zzz1(:,:,l)=z_half(:,:,l)-z_half(:,:,l+1)
    enddo
    oh_conc1 = oh_conc * pwt/zzz1*2.079e19

    bcphob_sink(:,:,:) = 0.0
    if (do_dynamic_bc) then
      where (bcphob > 0.0)
        bcphob_sink = (oh_conc1/2.16e11/bcage + 1./86400./bcageslow)*bcphob
      elsewhere
        bcphob_sink = 0.0
      endwhere
      bc_tau = 1./(1./bcageslow + oh_conc1/(2.5e6*bcage))
    else
      where (bcphob > 0.0)
        bcphob_sink = 8.038e-6*bcphob
      elsewhere
        bcphob_sink = 0.0
      endwhere
      bc_tau = 1.44
    endif
!

!------- tendency ------------------

    bcphob_dt = bcphob_emis - bcphob_sink
    bcphil_dt = bcphil_emis + bcphob_sink
!
!------- compute organic carbon sink --------------
!
!  OCphob has a half-life time of 2.0days 
!   (corresponds to an e-folding time of 2.88 days)
!
!  sink = 1./(86400.*1.44) = 8.023e-6
!
    omphob_sink(:,:,:) = 0.0
    if (do_dynamic_om) then
      where (omphob > 0.0)
        omphob_sink = (oh_conc1/2.16e11/omage + 1./86400./omageslow)*omphob
      elsewhere
        omphob_sink = 0.0
      endwhere
    else
      where (omphob >= 0.0)
        omphob_sink = 8.023e-6*omphob
      elsewhere
        omphob_sink = 0.0
      endwhere
    endif

!------- tendency ------------------

      omphob_dt = omphob_emis - omphob_sink
      omphil_dt = omphil_emis + omphob_sink

!-----------------------------------------------------------------


!
! Send registered results to diag manager
!
      if (id_bc_emis_col > 0) then
! column emissions for bc and om

        bc_emis = 0.
        do k=1,kd
          bc_emis(:,:) = bc_emis(:,:) + bcphob_emis(:,:,k) +  &
                                                       bcphil_emis(:,:,k)
        end do

        used = send_data ( id_bc_emis_col, bc_emis, diag_time, &
              is_in=is,js_in=js)
      endif
 
      if (id_om_emis_col > 0) then
! column emissions for bc and om

        om_emis = 0.
        do k=1,kd
          om_emis(:,:) = om_emis(:,:) + omphob_emis(:,:,k) +    &
                                                       omphil_emis(:,:,k)
        end do

        used = send_data ( id_om_emis_col, om_emis, diag_time, &
              is_in=is,js_in=js)
      endif

!
! Send registered results to diag manager
!
      if (id_bc_emis_colv2 > 0) then
! column emissions for bc (corrected cmip units)

        bc_emis = 0.
        do k=1,kd
          bc_emis(:,:) = bc_emis(:,:) + pwt(:,:,k)*&
                               (bcphob_emis(:,:,k) + bcphil_emis(:,:,k))
        end do
        used = send_data ( id_bc_emis_colv2, bc_emis, diag_time, &
              is_in=is,js_in=js)
      endif
 
      if (id_om_emis_colv2 > 0) then
! column emissions for om (corrected cmip units)

        om_emis = 0.
        do k=1,kd
          om_emis(:,:) = om_emis(:,:) + pwt(:,:,k)* &
                               (omphob_emis(:,:,k) + omphil_emis(:,:,k))
        end do
        used = send_data ( id_om_emis_colv2, om_emis, diag_time, &
              is_in=is,js_in=js)
      endif

!-----------------------------------------------------------------

      if (id_bcphob_emis > 0) then
        used = send_data ( id_bcphob_emis, bcphob_emis, diag_time, &
              is_in=is,js_in=js,ks_in=1)
      endif
      if (id_bcphil_emis > 0) then
        used = send_data ( id_bcphil_emis, bcphil_emis, diag_time, &
              is_in=is,js_in=js,ks_in=1)
      endif
      if (id_omphob_emis > 0) then
        used = send_data ( id_omphob_emis, omphob_emis, diag_time, &
              is_in=is,js_in=js,ks_in=1)
      endif
      if (id_omphil_emis > 0) then
        used = send_data ( id_omphil_emis, omphil_emis, diag_time, &
              is_in=is,js_in=js,ks_in=1)
      endif
      if (id_bcphob_sink > 0) then
        used = send_data ( id_bcphob_sink, bcphob_sink, diag_time, &
              is_in=is,js_in=js,ks_in=1)
      endif
      if (id_omphob_sink > 0) then
        used = send_data ( id_omphob_sink, omphob_sink, diag_time, &
              is_in=is,js_in=js,ks_in=1)
      endif
      if (id_bcemisbf > 0) then
        used = send_data ( id_bcemisbf, bcemisbf, diag_time, &
              is_in=is,js_in=js)
      endif
      if (id_emisbb > 0) then
        used = send_data ( id_emisbb, emisob, diag_time, &
              is_in=is,js_in=js)
      endif
      if (id_omemisbb_col > 0) then
        used = send_data ( id_omemisbb_col, omemisob_2d, diag_time, &
              is_in=is,js_in=js)
      endif
      if (id_bcemisbb > 0) then
        used = send_data ( id_bcemisbb, bcemisob, diag_time, &
              is_in=is,js_in=js,ks_in=1)
      endif
      if (id_bcemissh > 0) then
        used = send_data ( id_bcemissh, bcemissh, diag_time, &
              is_in=is,js_in=js)
      endif
      if (id_bcemisff > 0) then
        used = send_data ( id_bcemisff, bcemisff, diag_time, &
              is_in=is,js_in=js,ks_in=1)
      endif
      if (id_bcemisav > 0) then
        used = send_data ( id_bcemisav, bcemisav*bc_aircraft_EI, diag_time, &
              is_in=is,js_in=js,ks_in=1)
      endif
      if (id_omemisbf > 0) then
        used = send_data ( id_omemisbf, omemisbf, diag_time, &
              is_in=is,js_in=js)
      endif
      if (id_omemisbb > 0) then
        used = send_data ( id_omemisbb, omemisob, diag_time, &
              is_in=is,js_in=js,ks_in=1)
      endif
      if (id_omemissh > 0) then
        used = send_data ( id_omemissh, omemissh, diag_time, &
              is_in=is,js_in=js)
      endif
      if (id_omemisff > 0) then
        used = send_data ( id_omemisff, omemisff, diag_time, &
              is_in=is,js_in=js,ks_in=1)
      endif
      if (id_omemisbg > 0) then
        used = send_data ( id_omemisbg, omemisbg, diag_time, &
              is_in=is,js_in=js)
      endif
      if (id_omemisoc > 0) then
        used = send_data ( id_omemisoc, omemisocean, diag_time, &
              is_in=is,js_in=js)
      endif
      if (id_bc_tau > 0) then
        used = send_data ( id_bc_tau, bc_tau, diag_time, &
              is_in=is,js_in=js,ks_in=1)
      endif
!
 end subroutine atmos_carbon_aerosol_driver

!#######################################################################
!<SUBROUTINE NAME ="atmos_carbon_aerosol_init">

!<OVERVIEW>
! Subroutine to initialize the carbon aerosol module.
!</OVERVIEW>
!<DESCRIPTION>
! This subroutine querys the tracer manager to find the indices for the 
! various carbonaceous aerosol tracers. It also registers the emission 
! fields for diagnostic purposes.
!  
!</DESCRIPTION>
!<TEMPLATE>
!call atmos_carbon_aerosol_init (lonb, latb, r, axes, Time, mask)
!</TEMPLATE>
!   <IN NAME="lonb" TYPE="real" DIM="(:,:)">
!     The longitudes for the local domain.
!   </IN>
!   <IN NAME="latb" TYPE="real" DIM="(:,:)">
!     The latitudes for the local domain.
!   </IN>
!   <INOUT NAME="r" TYPE="real" DIM="(:,:,:,:)">
!     Tracer fields dimensioned as (nlon,nlat,nlev,ntrace). 
!   </INOUT>
!   <IN NAME="mask" TYPE="real, optional" DIM="(:,:,:)">
!      optional mask (0. or 1.) that designates which grid points
!           are above (=1.) or below (=0.) the ground dimensioned as
!           (nlon,nlat,nlev).
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="axes" TYPE="integer" DIM="(4)">
!     The axes relating to the tracer array dimensioned as
!      (nlon, nlat, nlev, ntime)
!   </IN>

 subroutine atmos_carbon_aerosol_init (lonb, latb, axes, Time, mask)

!-----------------------------------------------------------------------
real, dimension(:,:),    intent(in) :: lonb, latb
integer        , intent(in)                        :: axes(4)
type(time_type), intent(in)                        :: Time
real,            intent(in),    dimension(:,:,:), optional :: mask
character(len=7), parameter :: mod_name = 'tracers'
integer :: n
integer ::  unit, ierr, io, logunit


   if (module_is_initialized) return
!----------------------------------
!namelist files
      if ( file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
        read (input_nml_file, nml=carbon_aerosol_nml, iostat=io)
        ierr = check_nml_error(io,'carbon_aerosol_nml')
#else
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=carbon_aerosol_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'carbon_aerosol_nml')
        end do
10      call close_file (unit)
#endif
      endif
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit=stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                          write (logunit, nml=carbon_aerosol_nml)

!--------------------------------------------------------
!------namelist

!----- set initial value of carbon ------------

   n = get_tracer_index(MODEL_ATMOS,'bcphob')
   if (n>0) then
      nbcphobic = n
      call set_tracer_atts(MODEL_ATMOS,'bcphob','hphobic_bc','mmr')
      if (nbcphobic > 0 .and. mpp_pe() == mpp_root_pe()) &
          write (*,30) 'Hydrophobic BC',nbcphobic
      if (nbcphobic > 0 .and. mpp_pe() == mpp_root_pe()) &
          write (logunit,30) 'Hydrophobic BC',nbcphobic
   endif

   n = get_tracer_index(MODEL_ATMOS,'bcphil')
   if (n>0) then
      nbcphilic=n
      call set_tracer_atts(MODEL_ATMOS,'bcphil','hphilic_bc','mmr')
      if (nbcphilic > 0 .and. mpp_pe() == mpp_root_pe()) &
          write (*,30) 'Hydrophilic BC',nbcphilic
      if (nbcphilic > 0 .and. mpp_pe() == mpp_root_pe()) &
          write (logunit,30) 'Hydrophilic BC',nbcphilic
   endif

   n = get_tracer_index(MODEL_ATMOS,'omphob')
   if (n>0) then
      nomphobic=n
      call set_tracer_atts(MODEL_ATMOS,'omphob','phobic_om','mmr')
      if (nomphobic > 0 .and. mpp_pe() == mpp_root_pe()) &
          write (*,30) 'Hydrophobic OC',nomphobic
      if (nomphobic > 0 .and. mpp_pe() == mpp_root_pe()) &
          write (logunit,30) 'Hydrophobic OC',nomphobic
   endif

   n = get_tracer_index(MODEL_ATMOS,'omphil')
   if (n>0) then
      nomphilic=n
      call set_tracer_atts(MODEL_ATMOS,'omphil','philic_om','mmr')
      if (nomphilic > 0 .and. mpp_pe() == mpp_root_pe()) &
          write (*,30) 'Hydrophilic OC',nomphilic
      if (nomphilic > 0 .and. mpp_pe() == mpp_root_pe()) &
          write (logunit,30) 'Hydrophilic OC',nomphilic
   endif

30        format (A,' was initialized as tracer number ',i2)
!
!   Register Emissions as static fields (monthly)
!
     id_bcphob_emis = register_diag_field ( mod_name,           &
                    'bcphob_emis', axes(1:3),Time,          &
                    'BC phobic emission rate', 'kg/m2/sec' )

     id_bcphil_emis = register_diag_field ( mod_name,           &
                    'bcphil_emis', axes(1:3),Time,          &
                    'BC phylic emission rate', 'kg/m2/sec' )

     id_omphob_emis = register_diag_field ( mod_name,           &
                    'omphob_emis', axes(1:3),Time,          &
                    'OM phobic emission rate', 'kg/m2/sec' )

     id_omphil_emis = register_diag_field ( mod_name,           &
                    'omphil_emis', axes(1:3),Time,          &
                    'OM phylic emission rate', 'kg/m2/sec' )

     id_bc_emis_col = register_diag_field ( mod_name,           &
                    'bc_emis_col', axes(1:2),Time,          &
                    'total BC column emission rate', 'kg/m2/sec' )

     id_om_emis_col = register_diag_field ( mod_name,           &
                    'om_emis_col', axes(1:2),Time,          &
                    'total OM column emission rate', 'kg/m2/sec' )

     id_bc_emis_colv2 = register_diag_field ( mod_name,           &
                    'bc_emis_colv2', axes(1:2),Time,          &
                    'total BC column emission rate', 'kg/m2/sec' )

     id_om_emis_colv2 = register_diag_field ( mod_name,           &
                    'om_emis_colv2', axes(1:2),Time,          &
                    'total OM column emission rate', 'kg/m2/sec' )

     id_bcphob_sink = register_diag_field ( mod_name,           &
                    'bcphob_sink', axes(1:3),Time,          &
                    'BC phobic sink rate', 'kg/m2/sec' )

     id_omphob_sink = register_diag_field ( mod_name,           &
                    'omphob_sink', axes(1:3),Time,          &
                    'OM phobic sink rate', 'kg/m2/sec' )

     id_bcemisbf    = register_diag_field ( mod_name,           &
                    'bcemisbf', axes(1:2),Time,                 &
                    'BC biofuel emission', 'kg/m2/sec' )

     id_emisbb    = register_diag_field ( mod_name,           &
                    'emisbb', axes(1:2),Time,                 &
                    'column BC + OM open biomass burning emission', 'kg/m2/sec' )

     id_omemisbb_col    = register_diag_field ( mod_name,           &
                    'omemisbb_col', axes(1:2),Time,                 &
                    'column OM open biomass burning emission', 'kg/m2/sec' )

     id_bcemisbb    = register_diag_field ( mod_name,           &
                    'bcemisbb', axes(1:3),Time,                 &
                    'BC open biomass burning emission', 'kg/m2/sec' )

     id_bcemissh    = register_diag_field ( mod_name,           &
                    'bcemissh', axes(1:2),Time,                 &
                    'BC shipping emission', 'kg/m2/sec' )

     id_bcemisff    = register_diag_field ( mod_name,           &
                    'bcemisff', axes(1:3),Time,                 &
                    'BC fossil fuel emission', 'kg/m2/sec' )

     id_bcemisav    = register_diag_field ( mod_name,           &
                    'bcemisav', axes(1:3),Time,                 &
                    'BC aircraft emission', 'kg/m2/sec' )

     id_omemisbf    = register_diag_field ( mod_name,           &
                    'omemisbf', axes(1:2),Time,                 &
                    'OM biofuel emission', 'kg/m2/sec' )

     id_omemisbb    = register_diag_field ( mod_name,           &
                    'omemisbb', axes(1:3),Time,                 &
                    'OM open biomass burning emission', 'kg/m2/sec' )

     id_omemissh    = register_diag_field ( mod_name,           &
                    'omemissh', axes(1:2),Time,                 &
                    'OM shipping emission', 'kg/m2/sec' )

     id_omemisff    = register_diag_field ( mod_name,           &
                    'omemisff', axes(1:3),Time,                 &
                    'OM fossil fuel emission', 'kg/m2/sec' )

     id_omemisbg    = register_diag_field ( mod_name,           &
                    'omemisbg', axes(1:2),Time,                 &
                    'OM biogenic emission over land', 'kg/m2/sec' )

     id_omemisoc    = register_diag_field ( mod_name,           &
                    'omemisoc', axes(1:2),Time,                 &
                    'OM biogenic emission over ocean', 'kg/m2/sec' )

     id_bc_tau    = register_diag_field ( mod_name,           &
                    'bc_tau', axes(1:3),Time,                 &
                    'bcphob aging lifetime', 'days' )

!----------------------------------------------------------------------
!    initialize namelist entries
!----------------------------------------------------------------------
        bcff_offset = set_time (0,0)
        bcbb_offset = set_time (0,0)
        bcbf_offset = set_time (0,0)
        bcsh_offset = set_time (0,0)
        bcav_offset = set_time (0,0)
        omff_offset = set_time (0,0)
        ombb_offset = set_time (0,0)
        ombf_offset = set_time (0,0)
        omsh_offset = set_time (0,0)
        omna_offset = set_time (0,0)
        omss_offset = set_time (0,0)

        bcff_entry = set_time (0,0)
        bcbb_entry = set_time (0,0)
        bcbf_entry = set_time (0,0)
        bcsh_entry = set_time (0,0)
        bcav_entry = set_time (0,0)
        omff_entry = set_time (0,0)
        ombb_entry = set_time (0,0)
        ombf_entry = set_time (0,0)
        omsh_entry = set_time (0,0)
        omna_entry = set_time (0,0)
        omss_entry = set_time (0,0)

        bcff_negative_offset = .false.
        bcbb_negative_offset = .false.
        bcbf_negative_offset = .false.
        bcsh_negative_offset = .false.
        bcav_negative_offset = .false.
        omff_negative_offset = .false.
        ombb_negative_offset = .false.
        ombf_negative_offset = .false.
        omsh_negative_offset = .false.
        omna_negative_offset = .false.
        omss_negative_offset = .false.

        bcff_time_serie_type = 1
        bcbb_time_serie_type = 1
        bcbf_time_serie_type = 1
        bcsh_time_serie_type = 1
        bcav_time_serie_type = 1
        omff_time_serie_type = 1
        ombb_time_serie_type = 1
        ombf_time_serie_type = 1
        omsh_time_serie_type = 1
        omna_time_serie_type = 1
        omss_time_serie_type = 1
!----------------------------------------------------------------------
!    define the model base time  (defined in diag_table)
!----------------------------------------------------------------------
        model_init_time = get_base_time()
   if ( trim(bcff_source) .ne. ' ') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(bcff_time_dependency_type) == 'constant' ) then
        bcff_time_serie_type = 1
        bcff_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'bcff are constant in atmos_carbon_aerosol module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for bcff is selected.
!---------------------------------------------------------------------
      else if (trim(bcff_time_dependency_type) == 'time_varying') then
        bcff_time_serie_type = 3
        if (bcff_dataset_entry(1) == 1 .and. &
            bcff_dataset_entry(2) == 1 .and. &
            bcff_dataset_entry(3) == 1 .and. &
            bcff_dataset_entry(4) == 0 .and. &
            bcff_dataset_entry(5) == 0 .and. &
            bcff_dataset_entry(6) == 0 ) then
          bcff_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to bcff_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          bcff_entry  = set_date (bcff_dataset_entry(1), &
                                  bcff_dataset_entry(2), &
                                  bcff_dataset_entry(3), &
                                  bcff_dataset_entry(4), &
                                  bcff_dataset_entry(5), &
                                  bcff_dataset_entry(6))
        endif
        call print_date (bcff_entry , str= &
          'Data from bcff timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        bcff_offset = bcff_entry - model_init_time
        if (model_init_time > bcff_entry) then
          bcff_negative_offset = .true.
        else
          bcff_negative_offset = .false.
        endif
      else if (trim(bcff_time_dependency_type) == 'fixed_year') then
        bcff_time_serie_type = 2
        if (bcff_dataset_entry(1) == 1 .and. &
            bcff_dataset_entry(2) == 1 .and. &
            bcff_dataset_entry(3) == 1 .and. &
            bcff_dataset_entry(4) == 0 .and. &
            bcff_dataset_entry(5) == 0 .and. &
            bcff_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_carbon_aerosol_mod', &
            'must set bcff_dataset_entry when using fixed_year source', FATAL)
        endif

!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to bcff_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        bcff_entry  = set_date (bcff_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_carbon_aerosol_mod', &
           'bcff is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'bcff correspond to year :', &
                    bcff_dataset_entry(1)
        endif
     endif
     select case (trim(bcff_source))
       case ('cooke_and_wilson_1996')
         if (trim(bcff_input_name(1)) .eq. ' ') then
           bcff_emission_name(1)='bcff_cw96'
         else
           bcff_emission_name(1)=trim(bcff_input_name(1))
         endif
      case ('cooke_1999')
         if (trim(bcff_input_name(1)) .eq. ' ') then
           bcff_emission_name(1)='bcff_cooke99'
         else
           bcff_emission_name(1)=trim(bcff_input_name(1))
         endif
      case ('bond_2004') 
         if (trim(bcff_input_name(1)) .eq. ' ') then
           bcff_emission_name(1)='bcff_bond'
         else
           bcff_emission_name(1)=trim(bcff_input_name(1))
         endif
      case ('gocart_2007') 
         if (trim(bcff_input_name(1)) .eq. ' ') then
           bcff_emission_name(1)='bc_anthro'
         else
           bcff_emission_name(1)=trim(bcff_input_name(1))
         endif
      case ('AEROCOM') 
         if (trim(bcff_input_name(1)) .eq. ' ') then
           bcff_emission_name(1)='BC1ff'
         else
           bcff_emission_name(1)=trim(bcff_input_name(1))
         endif
     end select
     call interpolator_init (bcff_aerosol_interp,             &
                             trim(bcff_filename),           &
                             lonb, latb,                        &
                             data_out_of_bounds=  (/CONSTANT/), &
                             data_names = bcff_emission_name,        &
                             vert_interp=(/INTERP_WEIGHTED_P/)  )
   endif
   if ( trim(bcbb_source) .ne. ' ') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(bcbb_time_dependency_type) == 'constant' ) then
        bcbb_time_serie_type = 1
        bcbb_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'bcbb are constant in atmos_carbon_aerosol module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for bcbb is selected.
!---------------------------------------------------------------------
      else if (trim(bcbb_time_dependency_type) == 'time_varying') then
        bcbb_time_serie_type = 3
        if (bcbb_dataset_entry(1) == 1 .and. &
            bcbb_dataset_entry(2) == 1 .and. &
            bcbb_dataset_entry(3) == 1 .and. &
            bcbb_dataset_entry(4) == 0 .and. &
            bcbb_dataset_entry(5) == 0 .and. &
            bcbb_dataset_entry(6) == 0 ) then
          bcbb_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to bcbb_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          bcbb_entry  = set_date (bcbb_dataset_entry(1), &
                                  bcbb_dataset_entry(2), &
                                  bcbb_dataset_entry(3), &
                                  bcbb_dataset_entry(4), &
                                  bcbb_dataset_entry(5), &
                                  bcbb_dataset_entry(6))
        endif
        call print_date (bcbb_entry , str= &
          'Data from bcbb timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        bcbb_offset = bcbb_entry - model_init_time
        if (model_init_time > bcbb_entry) then
          bcbb_negative_offset = .true.
        else
          bcbb_negative_offset = .false.
        endif
      else if (trim(bcbb_time_dependency_type) == 'fixed_year') then
        bcbb_time_serie_type = 2
        if (bcbb_dataset_entry(1) == 1 .and. &
            bcbb_dataset_entry(2) == 1 .and. &
            bcbb_dataset_entry(3) == 1 .and. &
            bcbb_dataset_entry(4) == 0 .and. &
            bcbb_dataset_entry(5) == 0 .and. &
            bcbb_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_carbon_aerosol_mod', &
            'must set bcbb_dataset_entry when using fixed_year source', FATAL)
        endif
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to bcbb_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        bcbb_entry  = set_date (bcbb_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_carbon_aerosol_mod', &
           'bcbb is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'bcbb correspond to year :', &
                    bcbb_dataset_entry(1)
        endif
     endif
     select case (trim(bcbb_source))
       case ('cooke_and_wilson_1996')
         if (trim(bcbb_input_name(1)) .eq. ' ') then
           bcbb_emission_name(1)='bcbb_cw96'
         else
           bcbb_emission_name(1)=trim(bcbb_input_name(1))
         endif
         call interpolator_init (bcbb_aerosol_interp,           &
           trim(bcbb_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
           data_names=bcbb_emission_name(1:1), vert_interp=(/INTERP_WEIGHTED_P/))
      case ('bond_2004') 
         if (trim(bcbb_input_name(1)) .eq. ' ') then
           bcbb_emission_name(1)='bcob_bond'
         else
           bcbb_emission_name(1)=trim(bcbb_input_name(1))
         endif
         call interpolator_init (bcbb_aerosol_interp,           &
           trim(bcbb_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
           data_names=bcbb_emission_name(1:1), vert_interp=(/INTERP_WEIGHTED_P/))
      case ('gocart_2007') 
         if (trim(bcbb_input_name(1)) .eq. ' ') then
           bcbb_emission_name(1)='bc_biobur'
         else
           bcbb_emission_name(1)=trim(bcbb_input_name(1))
         endif
         call interpolator_init (bcbb_aerosol_interp,           &
           trim(bcbb_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
           data_names=bcbb_emission_name(1:1), vert_interp=(/INTERP_WEIGHTED_P/))
       case ('GEIA')
         if (trim(bcbb_input_name(1)) .eq. ' ') then
           bcbb_emission_name(1)='bc_geia1'
           bcbb_emission_name(2)='bc_geia2'
         else
           bcbb_emission_name(1)=trim(bcbb_input_name(1))
           bcbb_emission_name(2)=trim(bcbb_input_name(2))
         endif
         call interpolator_init (bcbb_aerosol_interp,           &
           trim(bcbb_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
           data_names=bcbb_emission_name(1:2),vert_interp=(/INTERP_WEIGHTED_P/))
       case ('AEROCOM')
         if (trim(bcbb_input_name(1)) .eq. ' ') then
           bcbb_emission_name(1)='GFED_BC_l1'
           bcbb_emission_name(2)='GFED_BC_l2'
           bcbb_emission_name(3)='GFED_BC_l3'
           bcbb_emission_name(4)='GFED_BC_l4'
           bcbb_emission_name(5)='GFED_BC_l5'
           bcbb_emission_name(6)='GFED_BC_l6'
         else
           bcbb_emission_name(1)(:)=trim(bcbb_input_name(1)(:))
           bcbb_emission_name(2)(:)=trim(bcbb_input_name(2)(:))
           bcbb_emission_name(3)(:)=trim(bcbb_input_name(3)(:))
           bcbb_emission_name(4)(:)=trim(bcbb_input_name(4)(:))
           bcbb_emission_name(5)(:)=trim(bcbb_input_name(5)(:))
           bcbb_emission_name(6)(:)=trim(bcbb_input_name(6)(:))
         endif
         call interpolator_init (bcbb_aerosol_interp,           &
           trim(bcbb_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
           data_names=bcbb_emission_name(1:6),vert_interp=(/INTERP_WEIGHTED_P/))
     end select
   endif
   if ( trim(bcsh_source) .ne. ' ') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(bcsh_time_dependency_type) == 'constant' ) then
        bcsh_time_serie_type = 1
        bcsh_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'bcsh are constant in atmos_carbon_aerosol module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for bcsh is selected.
!---------------------------------------------------------------------
      else if (trim(bcsh_time_dependency_type) == 'time_varying') then
        bcsh_time_serie_type = 3
        if (bcsh_dataset_entry(1) == 1 .and. &
            bcsh_dataset_entry(2) == 1 .and. &
            bcsh_dataset_entry(3) == 1 .and. &
            bcsh_dataset_entry(4) == 0 .and. &
            bcsh_dataset_entry(5) == 0 .and. &
            bcsh_dataset_entry(6) == 0 ) then
          bcsh_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to bcsh_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          bcsh_entry  = set_date (bcsh_dataset_entry(1), &
                                  bcsh_dataset_entry(2), &
                                  bcsh_dataset_entry(3), &
                                  bcsh_dataset_entry(4), &
                                  bcsh_dataset_entry(5), &
                                  bcsh_dataset_entry(6))
        endif
        call print_date (bcsh_entry , str= &
          'Data from bcsh timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        bcsh_offset = bcsh_entry - model_init_time
        if (model_init_time > bcsh_entry) then
          bcsh_negative_offset = .true.
        else
          bcsh_negative_offset = .false.
        endif
      else if (trim(bcsh_time_dependency_type) == 'fixed_year') then
        bcsh_time_serie_type = 2
        if (bcsh_dataset_entry(1) == 1 .and. &
            bcsh_dataset_entry(2) == 1 .and. &
            bcsh_dataset_entry(3) == 1 .and. &
            bcsh_dataset_entry(4) == 0 .and. &
            bcsh_dataset_entry(5) == 0 .and. &
            bcsh_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_carbon_aerosol_mod', &
            'must set bcsh_dataset_entry when using fixed_year source', FATAL)
        endif
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to bcsh_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        bcsh_entry  = set_date (bcsh_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_carbon_aerosol_mod', &
           'bcsh is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'bcsh correspond to year :', &
                    bcsh_dataset_entry(1)
        endif
     endif
     if (trim(bcsh_input_name(1)) .eq. ' ') then
       bcsh_emission_name(1)='bc_ship'
     else
       bcsh_emission_name(1)=trim(bcsh_input_name(1))
     endif

     call interpolator_init (bcsh_aerosol_interp,             &
                             trim(bcsh_filename),           &
                             lonb, latb,                        &
                             data_out_of_bounds=  (/CONSTANT/), &
                             data_names = bcsh_emission_name,        &
                             vert_interp=(/INTERP_WEIGHTED_P/)  )
   endif
   if ( trim(bcav_source) .ne. ' ') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(bcav_time_dependency_type) == 'constant' ) then
        bcav_time_serie_type = 1
        bcav_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'bcav are constant in atmos_carbon_aerosol module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for bcav is selected.
!---------------------------------------------------------------------
      else if (trim(bcav_time_dependency_type) == 'time_varying') then
        bcav_time_serie_type = 3
        if (bcav_dataset_entry(1) == 1 .and. &
            bcav_dataset_entry(2) == 1 .and. &
            bcav_dataset_entry(3) == 1 .and. &
            bcav_dataset_entry(4) == 0 .and. &
            bcav_dataset_entry(5) == 0 .and. &
            bcav_dataset_entry(6) == 0 ) then
          bcav_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to bcav_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          bcav_entry  = set_date (bcav_dataset_entry(1), &
                                  bcav_dataset_entry(2), &
                                  bcav_dataset_entry(3), &
                                  bcav_dataset_entry(4), &
                                  bcav_dataset_entry(5), &
                                  bcav_dataset_entry(6))
        endif
        call print_date (bcav_entry , str= &
          'Data from bcav timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        bcav_offset = bcav_entry - model_init_time
        if (model_init_time > bcav_entry) then
          bcav_negative_offset = .true.
        else
          bcav_negative_offset = .false.
        endif
      else if (trim(bcav_time_dependency_type) == 'fixed_year') then
        bcav_time_serie_type = 2
        if (bcav_dataset_entry(1) == 1 .and. &
            bcav_dataset_entry(2) == 1 .and. &
            bcav_dataset_entry(3) == 1 .and. &
            bcav_dataset_entry(4) == 0 .and. &
            bcav_dataset_entry(5) == 0 .and. &
            bcav_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_carbon_aerosol_mod', &
            'must set bcav_dataset_entry when using fixed_year source', FATAL)
        endif
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to bcav_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        bcav_entry  = set_date (bcav_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_carbon_aerosol_mod', &
           'bcav is defined from a single annual cycle - no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'bcav correspond to year :', bcav_dataset_entry(1)
        endif
     endif
     if (trim(bcav_input_name(1)) .eq. ' ') then
       bcav_emission_name(1)='bc_aircraft'
     else
       bcav_emission_name(1)=trim(bcav_input_name(1))
     endif
     call interpolator_init (bcav_aerosol_interp,             &
                             trim(bcav_filename),           &
                             lonb, latb,                        &
                             data_out_of_bounds=  (/CONSTANT/), &
                             data_names = bcav_emission_name,        &
                             vert_interp=(/INTERP_WEIGHTED_P/)  )
   endif
   if ( trim(bcbf_source) .ne. ' ') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(bcbf_time_dependency_type) == 'constant' ) then
        bcbf_time_serie_type = 1
        bcbf_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'bcbf are constant in atmos_carbon_aerosol module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for bcbf is selected.
!---------------------------------------------------------------------
      else if (trim(bcbf_time_dependency_type) == 'time_varying') then
        bcbf_time_serie_type = 3
        if (bcbf_dataset_entry(1) == 1 .and. &
            bcbf_dataset_entry(2) == 1 .and. &
            bcbf_dataset_entry(3) == 1 .and. &
            bcbf_dataset_entry(4) == 0 .and. &
            bcbf_dataset_entry(5) == 0 .and. &
            bcbf_dataset_entry(6) == 0 ) then
          bcbf_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to bcbf_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          bcbf_entry  = set_date (bcbf_dataset_entry(1), &
                                  bcbf_dataset_entry(2), &
                                  bcbf_dataset_entry(3), &
                                  bcbf_dataset_entry(4), &
                                  bcbf_dataset_entry(5), &
                                  bcbf_dataset_entry(6))
        endif
        call print_date (bcbf_entry , str= &
          'Data from bcbf timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        bcbf_offset = bcbf_entry - model_init_time
        if (model_init_time > bcbf_entry) then
          bcbf_negative_offset = .true.
        else
          bcbf_negative_offset = .false.
        endif
      else if (trim(bcbf_time_dependency_type) == 'fixed_year') then
        bcbf_time_serie_type = 2
        if (bcbf_dataset_entry(1) == 1 .and. &
            bcbf_dataset_entry(2) == 1 .and. &
            bcbf_dataset_entry(3) == 1 .and. &
            bcbf_dataset_entry(4) == 0 .and. &
            bcbf_dataset_entry(5) == 0 .and. &
            bcbf_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_carbon_aerosol_mod', &
            'must set bcbf_dataset_entry when using fixed_year source', FATAL)
        endif

!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to bcbf_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        bcbf_entry  = set_date (bcbf_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_carbon_aerosol_mod', &
           'bcbf is defined from a single annual cycle - no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'bcbf correspond to year :', &
                    bcbf_dataset_entry(1)
        endif
     endif
     if (trim(bcbf_input_name(1)) .eq. ' ') then
       bcbf_emission_name(1)='bcbf_bond'
     else
       bcbf_emission_name(1)=trim(bcbf_input_name(1))
     endif
     call interpolator_init (bcbf_aerosol_interp,             &
                             trim(bcbf_filename),           &
                             lonb, latb,                        &
                             data_out_of_bounds=  (/CONSTANT/), &
                             data_names = bcbf_emission_name,        &
                             vert_interp=(/INTERP_WEIGHTED_P/)  )
   endif
   if ( trim(omff_source) .ne. ' ') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(omff_time_dependency_type) == 'constant' ) then
        omff_time_serie_type = 1
        omff_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'omff are constant in atmos_carbon_aerosol module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for omff is selected.
!---------------------------------------------------------------------
      else if (trim(omff_time_dependency_type) == 'time_varying') then
        omff_time_serie_type = 3
        if (omff_dataset_entry(1) == 1 .and. &
            omff_dataset_entry(2) == 1 .and. &
            omff_dataset_entry(3) == 1 .and. &
            omff_dataset_entry(4) == 0 .and. &
            omff_dataset_entry(5) == 0 .and. &
            omff_dataset_entry(6) == 0 ) then
          omff_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to omff_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          omff_entry  = set_date (omff_dataset_entry(1), &
                                  omff_dataset_entry(2), &
                                  omff_dataset_entry(3), &
                                  omff_dataset_entry(4), &
                                  omff_dataset_entry(5), &
                                  omff_dataset_entry(6))
        endif
        call print_date (omff_entry , str= &
          'Data from omff timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        omff_offset = omff_entry - model_init_time
        if (model_init_time > omff_entry) then
          omff_negative_offset = .true.
        else
          omff_negative_offset = .false.
        endif
      else if (trim(omff_time_dependency_type) == 'fixed_year') then
        omff_time_serie_type = 2
        if (omff_dataset_entry(1) == 1 .and. &
            omff_dataset_entry(2) == 1 .and. &
            omff_dataset_entry(3) == 1 .and. &
            omff_dataset_entry(4) == 0 .and. &
            omff_dataset_entry(5) == 0 .and. &
            omff_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_carbon_aerosol_mod', &
            'must set omff_dataset_entry when using fixed_year source', FATAL)
        endif

!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to omff_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        omff_entry  = set_date (omff_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_carbon_aerosol_mod', &
           'omff is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'omff correspond to year :', &
                    omff_dataset_entry(1)
        endif
     endif
     select case (trim(omff_source))
      case ('cooke_1999')
         if (trim(omff_input_name(1)) .eq. ' ') then
           omff_emission_name(1)='omff_cooke99'
         else
           omff_emission_name(1)=trim(omff_input_name(1))
         endif
      case ('bond_2004') 
         if (trim(omff_input_name(1)) .eq. ' ') then
           omff_emission_name(1)='omff_bond'
         else
           omff_emission_name(1)=trim(omff_input_name(1))
         endif
      case ('gocart_2007') 
         if (trim(omff_input_name(1)) .eq. ' ') then
           omff_emission_name(1)='om_anthro'
         else
           omff_emission_name(1)=trim(omff_input_name(1))
         endif
      case ('AEROCOM') 
         if (trim(omff_input_name(1)) .eq. ' ') then
           omff_emission_name(1)='POMff'
         else
           omff_emission_name(1)=trim(omff_input_name(1))
         endif
     end select
     call interpolator_init (omff_aerosol_interp,           &
       trim(omff_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
       data_names=omff_emission_name(1:1),vert_interp=(/INTERP_WEIGHTED_P/))
   endif
   if ( trim(ombb_source) .ne. ' ') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(ombb_time_dependency_type) == 'constant' ) then
        ombb_time_serie_type = 1
        ombb_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'ombb are constant in atmos_carbon_aerosol module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for ombb is selected.
!---------------------------------------------------------------------
      else if (trim(ombb_time_dependency_type) == 'time_varying') then
        ombb_time_serie_type = 3
        if (ombb_dataset_entry(1) == 1 .and. &
            ombb_dataset_entry(2) == 1 .and. &
            ombb_dataset_entry(3) == 1 .and. &
            ombb_dataset_entry(4) == 0 .and. &
            ombb_dataset_entry(5) == 0 .and. &
            ombb_dataset_entry(6) == 0 ) then
          ombb_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to ombb_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          ombb_entry  = set_date (ombb_dataset_entry(1), &
                                  ombb_dataset_entry(2), &
                                  ombb_dataset_entry(3), &
                                  ombb_dataset_entry(4), &
                                  ombb_dataset_entry(5), &
                                  ombb_dataset_entry(6))
        endif
        call print_date (ombb_entry , str= &
          'Data from ombb timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        ombb_offset = ombb_entry - model_init_time
        if (model_init_time > ombb_entry) then
          ombb_negative_offset = .true.
        else
          ombb_negative_offset = .false.
        endif
      else if (trim(ombb_time_dependency_type) == 'fixed_year') then
        ombb_time_serie_type = 2
        if (ombb_dataset_entry(1) == 1 .and. &
            ombb_dataset_entry(2) == 1 .and. &
            ombb_dataset_entry(3) == 1 .and. &
            ombb_dataset_entry(4) == 0 .and. &
            ombb_dataset_entry(5) == 0 .and. &
            ombb_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_carbon_aerosol_mod', &
            'must set ombb_dataset_entry when using fixed_year source', FATAL)
        endif

!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to ombb_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        ombb_entry  = set_date (ombb_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_carbon_aerosol_mod', &
           'ombb is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'ombb correspond to year :', &
                    ombb_dataset_entry(1)
        endif
     endif
     select case (trim(ombb_source))
       case ('cooke_and_wilson_1996')
         if (trim(ombb_input_name(1)) .eq. ' ') then
           ombb_emission_name(1)='ombb_cw96'
         else
           ombb_emission_name(1)=trim(ombb_input_name(1))
         endif
         call interpolator_init (ombb_aerosol_interp,           &
           trim(ombb_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
           data_names=ombb_emission_name(1:1),vert_interp=(/INTERP_WEIGHTED_P/))
      case ('bond_2004') 
         if (trim(ombb_input_name(1)) .eq. ' ') then
           ombb_emission_name(1)='omob_bond'
         else
           ombb_emission_name(1)=trim(ombb_input_name(1))
         endif
         call interpolator_init (ombb_aerosol_interp,           &
           trim(ombb_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
           data_names=ombb_emission_name(1:1),vert_interp=(/INTERP_WEIGHTED_P/))
      case ('gocart_2007') 
         if (trim(ombb_input_name(1)) .eq. ' ') then
           ombb_emission_name(1)='om_biobur'
         else
           ombb_emission_name(1)=trim(ombb_input_name(1))
         endif
         call interpolator_init (ombb_aerosol_interp,           &
           trim(ombb_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
           data_names=ombb_emission_name(1:1),vert_interp=(/INTERP_WEIGHTED_P/))
       case ('GEIA')
         if (trim(ombb_input_name(1)) .eq. ' ') then
           ombb_emission_name(1)='om_geia1'
           ombb_emission_name(2)='om_geia2'
         else
           ombb_emission_name(1)=trim(ombb_input_name(1))
           ombb_emission_name(2)=trim(ombb_input_name(2))
         endif
         call interpolator_init (ombb_aerosol_interp,           &
           trim(ombb_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
           data_names=ombb_emission_name(1:2),vert_interp=(/INTERP_WEIGHTED_P/))
       case ('AEROCOM')
         if (trim(ombb_input_name(1)) .eq. ' ') then
           ombb_emission_name(1)='GFED_OM_l1'
           ombb_emission_name(2)='GFED_OM_l2'
           ombb_emission_name(3)='GFED_OM_l3'
           ombb_emission_name(4)='GFED_OM_l4'
           ombb_emission_name(5)='GFED_OM_l5'
           ombb_emission_name(6)='GFED_OM_l6'
         else
           ombb_emission_name(1)=trim(ombb_input_name(1))
           ombb_emission_name(2)=trim(ombb_input_name(2))
           ombb_emission_name(3)=trim(ombb_input_name(3))
           ombb_emission_name(4)=trim(ombb_input_name(4))
           ombb_emission_name(5)=trim(ombb_input_name(5))
           ombb_emission_name(6)=trim(ombb_input_name(6))
         endif
         call interpolator_init (ombb_aerosol_interp,           &
           trim(ombb_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
           data_names=ombb_emission_name(1:6),vert_interp=(/INTERP_WEIGHTED_P/))
     end select
   endif
   if ( trim(ombf_source) .ne. ' ') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(ombf_time_dependency_type) == 'constant' ) then
        ombf_time_serie_type = 1
        ombf_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'ombf are constant in atmos_carbon_aerosol module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for ombf is selected.
!---------------------------------------------------------------------
      else if (trim(ombf_time_dependency_type) == 'time_varying') then
        ombf_time_serie_type = 3
        if (ombf_dataset_entry(1) == 1 .and. &
            ombf_dataset_entry(2) == 1 .and. &
            ombf_dataset_entry(3) == 1 .and. &
            ombf_dataset_entry(4) == 0 .and. &
            ombf_dataset_entry(5) == 0 .and. &
            ombf_dataset_entry(6) == 0 ) then
          ombf_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to ombf_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          ombf_entry  = set_date (ombf_dataset_entry(1), &
                                  ombf_dataset_entry(2), &
                                  ombf_dataset_entry(3), &
                                  ombf_dataset_entry(4), &
                                  ombf_dataset_entry(5), &
                                  ombf_dataset_entry(6))
        endif
        call print_date (ombf_entry , str= &
          'Data from ombf timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        ombf_offset = ombf_entry - model_init_time
        if (model_init_time > ombf_entry) then
          ombf_negative_offset = .true.
        else
          ombf_negative_offset = .false.
        endif
      else if (trim(ombf_time_dependency_type) == 'fixed_year') then
        ombf_time_serie_type = 2
        if (ombf_dataset_entry(1) == 1 .and. &
            ombf_dataset_entry(2) == 1 .and. &
            ombf_dataset_entry(3) == 1 .and. &
            ombf_dataset_entry(4) == 0 .and. &
            ombf_dataset_entry(5) == 0 .and. &
            ombf_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_carbon_aerosol_mod', &
            'must set ombf_dataset_entry when using fixed_year source', FATAL)
        endif

!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to ombf_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        ombf_entry  = set_date (ombf_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_carbon_aerosol_mod', &
           'ombf is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'ombf correspond to year :', &
                    ombf_dataset_entry(1)
        endif
     endif
     if (trim(ombf_input_name(1)) .eq. ' ') then
       ombf_emission_name(1)='ombf_bond'
     else
       ombf_emission_name(1)=trim(ombf_input_name(1))
     endif
     call interpolator_init (ombf_aerosol_interp,           &
       trim(ombf_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
       data_names=ombf_emission_name(1:1),vert_interp=(/INTERP_WEIGHTED_P/))
   endif
   if ( trim(omsh_source) .ne. ' ') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(omsh_time_dependency_type) == 'constant' ) then
        omsh_time_serie_type = 1
        omsh_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'omsh are constant in atmos_carbon_aerosol module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for omsh is selected.
!---------------------------------------------------------------------
      else if (trim(omsh_time_dependency_type) == 'time_varying') then
        omsh_time_serie_type = 3
        if (omsh_dataset_entry(1) == 1 .and. &
            omsh_dataset_entry(2) == 1 .and. &
            omsh_dataset_entry(3) == 1 .and. &
            omsh_dataset_entry(4) == 0 .and. &
            omsh_dataset_entry(5) == 0 .and. &
            omsh_dataset_entry(6) == 0 ) then
          omsh_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to omsh_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          omsh_entry  = set_date (omsh_dataset_entry(1), &
                                  omsh_dataset_entry(2), &
                                  omsh_dataset_entry(3), &
                                  omsh_dataset_entry(4), &
                                  omsh_dataset_entry(5), &
                                  omsh_dataset_entry(6))
        endif
        call print_date (omsh_entry , str= &
          'Data from omsh timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        omsh_offset = omsh_entry - model_init_time
        if (model_init_time > omsh_entry) then
          omsh_negative_offset = .true.
        else
          omsh_negative_offset = .false.
        endif
      else if (trim(omsh_time_dependency_type) == 'fixed_year') then
        omsh_time_serie_type = 2
        if (omsh_dataset_entry(1) == 1 .and. &
            omsh_dataset_entry(2) == 1 .and. &
            omsh_dataset_entry(3) == 1 .and. &
            omsh_dataset_entry(4) == 0 .and. &
            omsh_dataset_entry(5) == 0 .and. &
            omsh_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_carbon_aerosol_mod', &
            'must set omsh_dataset_entry when using fixed_year source', FATAL)
        endif
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to omsh_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        omsh_entry  = set_date (omsh_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_carbon_aerosol_mod', &
           'omsh is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'omsh correspond to year :', &
                    omsh_dataset_entry(1)
        endif
     endif
     if (trim(omsh_input_name(1)) .eq. ' ') then
       omsh_emission_name(1)='om_ship'
     else
       omsh_emission_name(1)=trim(omsh_input_name(1))
     endif
     call interpolator_init (omsh_aerosol_interp,           &
       trim(omsh_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
       data_names=omsh_emission_name(1:1),vert_interp=(/INTERP_WEIGHTED_P/))
   endif
   if ( trim(omna_source) .ne. ' ') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(omna_time_dependency_type) == 'constant' ) then
        omna_time_serie_type = 1
        omna_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'omna are constant in atmos_carbon_aerosol module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for omna is selected.
!---------------------------------------------------------------------
      else if (trim(omna_time_dependency_type) == 'time_varying') then
        omna_time_serie_type = 3
        if (omna_dataset_entry(1) == 1 .and. &
            omna_dataset_entry(2) == 1 .and. &
            omna_dataset_entry(3) == 1 .and. &
            omna_dataset_entry(4) == 0 .and. &
            omna_dataset_entry(5) == 0 .and. &
            omna_dataset_entry(6) == 0 ) then
          omna_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to omna_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          omna_entry  = set_date (omna_dataset_entry(1), &
                                  omna_dataset_entry(2), &
                                  omna_dataset_entry(3), &
                                  omna_dataset_entry(4), &
                                  omna_dataset_entry(5), &
                                  omna_dataset_entry(6))
        endif
        call print_date (omna_entry , str= &
          'Data from omna timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        omna_offset = omna_entry - model_init_time
        if (model_init_time > omna_entry) then
          omna_negative_offset = .true.
        else
          omna_negative_offset = .false.
        endif
      else if (trim(omna_time_dependency_type) == 'fixed_year') then
        omna_time_serie_type = 2
        if (omna_dataset_entry(1) == 1 .and. &
            omna_dataset_entry(2) == 1 .and. &
            omna_dataset_entry(3) == 1 .and. &
            omna_dataset_entry(4) == 0 .and. &
            omna_dataset_entry(5) == 0 .and. &
            omna_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_carbon_aerosol_mod', &
            'must set omna_dataset_entry when using fixed_year source', FATAL)
        endif

!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to omna_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        omna_entry  = set_date (omna_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_carbon_aerosol_mod', &
           'omna is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'omna correspond to year :', &
                    omna_dataset_entry(1)
        endif
     endif
     if (trim(omna_input_name(1)) .eq. ' ') then
       omna_emission_name(1)='omemisnat'
     else
       omna_emission_name(1)=trim(omna_input_name(1))
     endif
     call interpolator_init (omna_aerosol_interp,           &
       trim(omna_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
       data_names=omna_emission_name(1:1),vert_interp=(/INTERP_WEIGHTED_P/))
   endif
   if ( trim(omss_source) .ne. ' ') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(omss_time_dependency_type) == 'constant' ) then
        omss_time_serie_type = 1
        omss_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'omss are constant in atmos_carbon_aerosol module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for omss is selected.
!---------------------------------------------------------------------
      else if (trim(omss_time_dependency_type) == 'time_varying') then
        omss_time_serie_type = 3
        if (omss_dataset_entry(1) == 1 .and. &
            omss_dataset_entry(2) == 1 .and. &
            omss_dataset_entry(3) == 1 .and. &
            omss_dataset_entry(4) == 0 .and. &
            omss_dataset_entry(5) == 0 .and. &
            omss_dataset_entry(6) == 0 ) then
          omss_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to omss_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          omss_entry  = set_date (omss_dataset_entry(1), &
                                  omss_dataset_entry(2), &
                                  omss_dataset_entry(3), &
                                  omss_dataset_entry(4), &
                                  omss_dataset_entry(5), &
                                  omss_dataset_entry(6))
        endif
        call print_date (omss_entry , str= &
          'Data from omss timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        omss_offset = omss_entry - model_init_time
        if (model_init_time > omss_entry) then
          omss_negative_offset = .true.
        else
          omss_negative_offset = .false.
        endif
      else if (trim(omss_time_dependency_type) == 'fixed_year') then
        omss_time_serie_type = 2
        if (omss_dataset_entry(1) == 1 .and. &
            omss_dataset_entry(2) == 1 .and. &
            omss_dataset_entry(3) == 1 .and. &
            omss_dataset_entry(4) == 0 .and. &
            omss_dataset_entry(5) == 0 .and. &
            omss_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_carbon_aerosol_mod', &
            'must set omss_dataset_entry when using fixed_year source', FATAL)
        endif

!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to omss_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        omss_entry  = set_date (omss_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_carbon_aerosol_mod', &
           'omss is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'omss correspond to year :', &
                    omss_dataset_entry(1)
        endif
     endif
     if (trim(omss_input_name(1)) .eq. ' ') then
       omss_emission_name(1)='DMSo'
     else
       omss_emission_name(1)=trim(omss_input_name(1))
     endif
     call interpolator_init (omss_aerosol_interp,           &
       trim(omss_filename), lonb, latb, data_out_of_bounds=(/CONSTANT/), &
       data_names=omss_emission_name(1:1),vert_interp=(/INTERP_WEIGHTED_P/))
     if (omss_coef .le. -990) then
       coef_omss_emis = 1.
     else
       coef_omss_emis = omss_coef
     endif
   endif


   call write_version_number(version, tagname)
   module_is_initialized = .TRUE.

!-----------------------------------------------------------------------

end subroutine atmos_carbon_aerosol_init



!######################################################################

subroutine atmos_carbon_aerosol_time_vary (model_time)


type(time_type), intent(in) :: model_time


    integer ::  yr, dum, mo_yr, mo, dy, hr, mn, sc, dayspmn


    if ( trim(bcff_source) .ne. ' ') then
!--------------------------------------------------------------------
!    define the time in the bcff data set from which data is to be 
!    taken. if bcff is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
     if(bcff_time_serie_type .eq. 3) then
       if (bcff_negative_offset) then
         bcff_time = model_time - bcff_offset
       else
         bcff_time = model_time + bcff_offset
       endif
     else 
       if(bcff_time_serie_type .eq. 2 ) then
         call get_date (bcff_entry, yr, dum,dum,dum,dum,dum)
         call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
         if (mo ==2 .and. dy == 29) then
           dayspmn = days_in_month(bcff_entry)
           if (dayspmn /= 29) then
             bcff_time = set_date (yr, mo, dy-1, hr, mn, sc)
           else
             bcff_time = set_date (yr, mo, dy, hr, mn, sc)
           endif
         else
           bcff_time = set_date (yr, mo, dy, hr, mn, sc)
         endif
       else
         bcff_time = model_time
       endif
     endif
     call obtain_interpolator_time_slices   &
                                   (bcff_aerosol_interp, bcff_time)
   endif

   if ( trim(bcbb_source).ne.' ') then

!--------------------------------------------------------------------
!    define the time in the bcbb data set from which data is to be 
!    taken. if bcbb is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
     if(bcbb_time_serie_type .eq. 3) then
       if (bcbb_negative_offset) then
         bcbb_time = model_time - bcbb_offset
       else
         bcbb_time = model_time + bcbb_offset
       endif
     else 
       if(bcbb_time_serie_type .eq. 2 ) then
         call get_date (bcbb_entry, yr, dum,dum,dum,dum,dum)
         call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
         if (mo ==2 .and. dy == 29) then
           dayspmn = days_in_month(bcbb_entry)
           if (dayspmn /= 29) then
             bcbb_time = set_date (yr, mo, dy-1, hr, mn, sc)
           else
             bcbb_time = set_date (yr, mo, dy, hr, mn, sc)
           endif
         else
           bcbb_time = set_date (yr, mo, dy, hr, mn, sc)
         endif
       else
         bcbb_time = model_time
       endif
     endif
     call obtain_interpolator_time_slices   &
                       (bcbb_aerosol_interp, bcbb_time)
   endif

   if ( trim(bcbf_source).ne. ' ') then
!--------------------------------------------------------------------
!    define the time in the bcbf data set from which data is to be 
!    taken. if bcbf is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
     if(bcbf_time_serie_type .eq. 3) then
       if (bcbf_negative_offset) then
         bcbf_time = model_time - bcbf_offset
       else
         bcbf_time = model_time + bcbf_offset
       endif
     else 
       if(bcbf_time_serie_type .eq. 2 ) then
         call get_date (bcbf_entry, yr, dum,dum,dum,dum,dum)
         call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
         if (mo ==2 .and. dy == 29) then
           dayspmn = days_in_month(bcbf_entry)
           if (dayspmn /= 29) then
             bcbf_time = set_date (yr, mo, dy-1, hr, mn, sc)
           else
             bcbf_time = set_date (yr, mo, dy, hr, mn, sc)
           endif
         else
           bcbf_time = set_date (yr, mo, dy, hr, mn, sc)
         endif
       else
         bcbf_time = model_time
       endif
     endif
     call obtain_interpolator_time_slices   &
                 (bcbf_aerosol_interp, bcbf_time)
   endif

   if ( trim(bcsh_source).ne. ' ') then
!--------------------------------------------------------------------
!    define the time in the bcsh data set from which data is to be 
!    taken. if bcsh is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
     if(bcsh_time_serie_type .eq. 3) then
       if (bcsh_negative_offset) then
         bcsh_time = model_time - bcsh_offset
       else
         bcsh_time = model_time + bcsh_offset
       endif
     else 
       if(bcsh_time_serie_type .eq. 2 ) then
         call get_date (bcsh_entry, yr, dum,dum,dum,dum,dum)
         call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
         if (mo ==2 .and. dy == 29) then
           dayspmn = days_in_month(bcsh_entry)
           if (dayspmn /= 29) then
             bcsh_time = set_date (yr, mo, dy-1, hr, mn, sc)
           else
             bcsh_time = set_date (yr, mo, dy, hr, mn, sc)
           endif
         else
           bcsh_time = set_date (yr, mo, dy, hr, mn, sc)
         endif
       else
         bcsh_time = model_time
       endif
     endif
     call obtain_interpolator_time_slices   &
                    (bcsh_aerosol_interp, bcsh_time)
   endif

   if ( trim(bcav_source).ne. ' ') then
!--------------------------------------------------------------------
!    define the time in the bcav data set from which data is to be 
!    taken. if bcav is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
     if(bcav_time_serie_type .eq. 3) then
       if (bcav_negative_offset) then
         bcav_time = model_time - bcav_offset
       else
         bcav_time = model_time + bcav_offset
       endif
     else 
       if(bcav_time_serie_type .eq. 2 ) then
         call get_date (bcav_entry, yr, dum,dum,dum,dum,dum)
         call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
         if (mo ==2 .and. dy == 29) then
           dayspmn = days_in_month(bcav_entry)
           if (dayspmn /= 29) then
             bcav_time = set_date (yr, mo, dy-1, hr, mn, sc)
           else
             bcav_time = set_date (yr, mo, dy, hr, mn, sc)
           endif
         else
           bcav_time = set_date (yr, mo, dy, hr, mn, sc)
         endif
       else
         bcav_time = model_time
       endif
     endif
     call obtain_interpolator_time_slices   &
                     (bcav_aerosol_interp, bcav_time)
   endif

   if ( trim(omff_source).ne. ' ') then
!--------------------------------------------------------------------
!    define the time in the omff data set from which data is to be 
!    taken. if omff is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
     if(omff_time_serie_type .eq. 3) then
       if (omff_negative_offset) then
         omff_time = model_time - omff_offset
       else
         omff_time = model_time + omff_offset
       endif
     else 
       if(omff_time_serie_type .eq. 2 ) then
         call get_date (omff_entry, yr, dum,dum,dum,dum,dum)
         call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
         if (mo ==2 .and. dy == 29) then
           dayspmn = days_in_month(omff_entry)
           if (dayspmn /= 29) then
             omff_time = set_date (yr, mo, dy-1, hr, mn, sc)
           else
             omff_time = set_date (yr, mo, dy, hr, mn, sc)
           endif
         else
           omff_time = set_date (yr, mo, dy, hr, mn, sc)
         endif
       else
         omff_time = model_time
       endif
     endif
     call obtain_interpolator_time_slices   &
                     (omff_aerosol_interp, omff_time)
   endif

   if ( trim(ombb_source).ne. ' ') then
!--------------------------------------------------------------------
!    define the time in the ombb data set from which data is to be 
!    taken. if ombb is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
     if(ombb_time_serie_type .eq. 3) then
       if (ombb_negative_offset) then
         ombb_time = model_time - ombb_offset
       else
         ombb_time = model_time + ombb_offset
       endif
     else 
       if(ombb_time_serie_type .eq. 2 ) then
         call get_date (ombb_entry, yr, dum,dum,dum,dum,dum)
         call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
         if (mo ==2 .and. dy == 29) then
           dayspmn = days_in_month(ombb_entry)
           if (dayspmn /= 29) then
             ombb_time = set_date (yr, mo, dy-1, hr, mn, sc)
           else
             ombb_time = set_date (yr, mo, dy, hr, mn, sc)
           endif
         else
           ombb_time = set_date (yr, mo, dy, hr, mn, sc)
         endif
       else
         ombb_time = model_time
       endif
     endif
     call obtain_interpolator_time_slices   &
                  (ombb_aerosol_interp, ombb_time)
   endif

   if ( trim(ombf_source).ne. ' ') then
!--------------------------------------------------------------------
!    define the time in the ombf data set from which data is to be 
!    taken. if ombf is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
     if(ombf_time_serie_type .eq. 3) then
       if (ombf_negative_offset) then
         ombf_time = model_time - ombf_offset
       else
         ombf_time = model_time + ombf_offset
       endif
     else 
       if(ombf_time_serie_type .eq. 2 ) then
         call get_date (ombf_entry, yr, dum,dum,dum,dum,dum)
         call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
         if (mo ==2 .and. dy == 29) then
           dayspmn = days_in_month(ombf_entry)
           if (dayspmn /= 29) then
             ombf_time = set_date (yr, mo, dy-1, hr, mn, sc)
           else
             ombf_time = set_date (yr, mo, dy, hr, mn, sc)
           endif
         else
           ombf_time = set_date (yr, mo, dy, hr, mn, sc)
         endif
       else
         ombf_time = model_time
       endif
     endif
     call obtain_interpolator_time_slices   &
                 (ombf_aerosol_interp, ombf_time)
   endif

   if ( trim(omsh_source).ne. ' ') then
!--------------------------------------------------------------------
!    define the time in the omsh data set from which data is to be 
!    taken. if omsh is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
     if(omsh_time_serie_type .eq. 3) then
       if (omsh_negative_offset) then
         omsh_time = model_time - omsh_offset
       else
         omsh_time = model_time + omsh_offset
       endif
     else 
       if(omsh_time_serie_type .eq. 2 ) then
         call get_date (omsh_entry, yr, dum,dum,dum,dum,dum)
         call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
         if (mo ==2 .and. dy == 29) then
           dayspmn = days_in_month(omsh_entry)
           if (dayspmn /= 29) then
             omsh_time = set_date (yr, mo, dy-1, hr, mn, sc)
           else
             omsh_time = set_date (yr, mo, dy, hr, mn, sc)
           endif
         else
           omsh_time = set_date (yr, mo, dy, hr, mn, sc)
         endif
       else
         omsh_time = model_time
       endif
     endif
     call obtain_interpolator_time_slices   &
                       (omsh_aerosol_interp, omsh_time)
   endif

   if ( trim(omna_source).ne. ' ') then
!--------------------------------------------------------------------
!    define the time in the omna data set from which data is to be 
!    taken. if omna is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
     if(omna_time_serie_type .eq. 3) then
       if (omna_negative_offset) then
         omna_time = model_time - omna_offset
       else
         omna_time = model_time + omna_offset
       endif
     else 
       if(omna_time_serie_type .eq. 2 ) then
         call get_date (omna_entry, yr, dum,dum,dum,dum,dum)
         call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
         if (mo ==2 .and. dy == 29) then
           dayspmn = days_in_month(omna_entry)
           if (dayspmn /= 29) then
             omna_time = set_date (yr, mo, dy-1, hr, mn, sc)
           else
             omna_time = set_date (yr, mo, dy, hr, mn, sc)
           endif
         else
           omna_time = set_date (yr, mo, dy, hr, mn, sc)
         endif
       else
         omna_time = model_time
       endif
     endif
     call obtain_interpolator_time_slices   &
                                     (omna_aerosol_interp, omna_time)
   endif
   if ( trim(omss_source).ne. ' ') then
!--------------------------------------------------------------------
!    define the time in the omss data set from which data is to be 
!    taken. if omss is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
     if(omss_time_serie_type .eq. 3) then
       if (omss_negative_offset) then
         omss_time = model_time - omss_offset
       else
         omss_time = model_time + omss_offset
       endif
     else 
       if(omss_time_serie_type .eq. 2 ) then
         call get_date (omss_entry, yr, dum,dum,dum,dum,dum)
         call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
         if (mo ==2 .and. dy == 29) then
           dayspmn = days_in_month(omss_entry)
           if (dayspmn /= 29) then
             omss_time = set_date (yr, mo, dy-1, hr, mn, sc)
           else
             omss_time = set_date (yr, mo, dy, hr, mn, sc)
           endif
         else
           omss_time = set_date (yr, mo, dy, hr, mn, sc)
         endif
       else
         omss_time = model_time
       endif
     endif
     call obtain_interpolator_time_slices   &
                                      (omss_aerosol_interp, omss_time)
  endif


end subroutine atmos_carbon_aerosol_time_vary 


!######################################################################

subroutine atmos_carbon_aerosol_endts 


   if ( trim(bcff_source) .ne. ' ') then
     call unset_interpolator_time_flag (bcff_aerosol_interp)
   endif

   if ( trim(bcbb_source).ne.' ') then
     call unset_interpolator_time_flag (bcbb_aerosol_interp)
   endif

   if ( trim(bcbf_source).ne. ' ') then
     call unset_interpolator_time_flag (bcbf_aerosol_interp)
   endif

   if ( trim(bcsh_source).ne. ' ') then
     call unset_interpolator_time_flag (bcsh_aerosol_interp)
   endif

   if ( trim(bcav_source).ne. ' ') then
     call unset_interpolator_time_flag (bcav_aerosol_interp)
   endif

   if ( trim(omff_source).ne. ' ') then
     call unset_interpolator_time_flag (omff_aerosol_interp)
   endif

   if ( trim(ombb_source).ne. ' ') then
     call unset_interpolator_time_flag (ombb_aerosol_interp)
   endif

   if ( trim(ombf_source).ne. ' ') then
     call unset_interpolator_time_flag (ombf_aerosol_interp)
   endif

   if ( trim(omsh_source).ne. ' ') then
     call unset_interpolator_time_flag (omsh_aerosol_interp)
   endif

   if ( trim(omna_source).ne. ' ') then
     call unset_interpolator_time_flag (omna_aerosol_interp)
   endif

   if ( trim(omss_source).ne. ' ') then
     call unset_interpolator_time_flag (omss_aerosol_interp)
  endif


end subroutine atmos_carbon_aerosol_endts 


!######################################################################


!</SUBROUTINE>

!#######################################################################

!<SUBROUTINE NAME="atmos_carbon_aerosol_end">
!<OVERVIEW>
!  The destructor routine for the carbon module.
!</OVERVIEW>
! <DESCRIPTION>
! This subroutine writes the version name to logfile and exits. 
! </DESCRIPTION>
!<TEMPLATE>
! call atmos_carbon_aero_end
!</TEMPLATE>
 subroutine atmos_carbon_aerosol_end
      call interpolator_end ( bcff_aerosol_interp)
      call interpolator_end ( bcbb_aerosol_interp)
      call interpolator_end ( bcbf_aerosol_interp)
      call interpolator_end ( bcsh_aerosol_interp)
      call interpolator_end ( bcav_aerosol_interp)
      call interpolator_end ( omff_aerosol_interp)
      call interpolator_end ( ombb_aerosol_interp)
      call interpolator_end ( ombf_aerosol_interp)
      call interpolator_end ( omsh_aerosol_interp)
      call interpolator_end ( omna_aerosol_interp)
      call interpolator_end ( omss_aerosol_interp)
      module_is_initialized = .FALSE.

 end subroutine atmos_carbon_aerosol_end
!</SUBROUTINE>
!#######################################################################
end module atmos_carbon_aerosol_mod

module spec_mpp_mod
!Balaji (V.Balaji)
!This module holds the data for the domains used by the spectral transform module

!This is the version for the transpose method
  use fms_mod,         only: mpp_pe, mpp_root_pe, mpp_npes, write_version_number, mpp_error, FATAL

  use mpp_domains_mod, only: mpp_domains_init, domain1D, domain2D, GLOBAL_DATA_DOMAIN, &
                             mpp_define_domains, mpp_get_compute_domain, mpp_get_compute_domains, &
                             mpp_get_domain_components, mpp_get_pelist

  implicit none
  private
  
  character(len=128), private :: version = '$Id: spec_mpp.F90,v 14.0 2007/03/15 22:12:44 fms Exp $'
  character(len=128), private :: tagname = '$Name: tikal $'
  type(domain2D), save, public :: grid_domain,  spectral_domain,  global_spectral_domain
  logical, private :: module_is_initialized=.FALSE.
  integer, private :: pe, npes

  public :: spec_mpp_init, get_grid_domain, get_spec_domain, spec_mpp_end, atmosphere_domain

  contains

!=======================================================================================================================

    subroutine spec_mpp_init( num_fourier, num_spherical, num_lon, lat_max, grid_layout, spectral_layout )
      integer, intent(in) ::  num_fourier, num_spherical, num_lon, lat_max
      integer, intent(in), optional :: grid_layout(2), spectral_layout(2)
      integer :: layout(2)
      character(len=4) :: chtmp1, chtmp2

      if( module_is_initialized ) return
      call mpp_domains_init()
      pe = mpp_pe()
      npes = mpp_npes()

      call write_version_number(version, tagname)

!grid domain: by default, 1D decomposition along Y
      layout = (/1,npes/)
      if( PRESENT(grid_layout) ) layout = grid_layout
      call mpp_define_domains( (/1,num_lon,1,lat_max/), layout, grid_domain )
      if(pe == mpp_root_pe()) call print_decomp (npes, layout, grid_domain )

!requirement of equal domains: can be generalized to retain mirror symmetry between N/S if unequal.
!the equal-domains requirement permits us to eliminate one buffer/unbuffer in the transpose_fourier routines.
      if( mod(lat_max,layout(2)).NE.0 ) then
!       call mpp_error( FATAL, 'SPEC_MPP_INIT: currently requires equal grid domains on all PEs.' )
        write(chtmp1,'(i4)') layout(2)
        write(chtmp2,'(i4)') lat_max
        call mpp_error( FATAL, 'SPEC_MPP_INIT:Requires num_lat_rows/num_pes=int;num_pes='&
       &//chtmp1//';num_lat_rows='//chtmp2 )
      endif

!spectral domain: by default, 1D decomposition along M
      layout=(/npes,1/)
      if( PRESENT(spectral_layout) ) layout = spectral_layout
      call mpp_define_domains( (/0,num_fourier,0,num_spherical/), layout, spectral_domain )

!global spectral domains (may be used for I/O) are the same as spectral domains, with global data boundaries
      call mpp_define_domains( (/0,num_fourier,0,num_spherical/), layout, global_spectral_domain, &
           xflags=GLOBAL_DATA_DOMAIN, yflags=GLOBAL_DATA_DOMAIN )

      module_is_initialized=.TRUE.
      return
    end subroutine spec_mpp_init
!=======================================================================================================================

subroutine print_decomp (npes, layout, Domain)
integer, intent(in) :: npes, layout(2)
type(domain2d), intent(in) :: Domain
integer, dimension(0:npes-1) :: xsize, ysize
integer :: i, j, xlist(layout(1)), ylist(layout(2))
type (domain1D) :: Xdom, Ydom

call mpp_get_compute_domains   ( Domain, xsize=xsize, ysize=ysize )
call mpp_get_domain_components ( Domain, Xdom, Ydom )
call mpp_get_pelist ( Xdom, xlist )
call mpp_get_pelist ( Ydom, ylist )

write (*,100)
write (*,110) (xsize(xlist(i)),i=1,layout(1))
write (*,120) (ysize(ylist(j)),j=1,layout(2))

100 format ('ATMOS MODEL DOMAIN DECOMPOSITION')
110 format ('  X-AXIS = ',24i4,/,(11x,24i4))
120 format ('  Y-AXIS = ',24i4,/,(11x,24i4))

end subroutine print_decomp
!=======================================================================================================================

subroutine get_grid_domain(is, ie, js, je)
integer, intent(out) :: is, ie, js, je

if(.not.module_is_initialized) call mpp_error( FATAL, 'subroutine get_grid_domain: spec_mpp is not initialized')

call mpp_get_compute_domain(grid_domain, is, ie, js, je)

return
end subroutine get_grid_domain
!=======================================================================================================================

subroutine get_spec_domain(ms, me, ns, ne)
integer, intent(out) :: ms, me, ns, ne

if(.not.module_is_initialized) call mpp_error( FATAL, 'subroutine get_spec_domain: spec_mpp is not initialized')

call mpp_get_compute_domain(spectral_domain, ms, me, ns, ne)

return
end subroutine get_spec_domain
!=======================================================================================================================

subroutine spec_mpp_end

module_is_initialized = .false.

return
end subroutine spec_mpp_end
!=======================================================================================================================

subroutine atmosphere_domain(Domain)
type(domain2d), intent(inout) :: Domain

Domain = grid_domain

end subroutine atmosphere_domain
!=======================================================================================================================

end module spec_mpp_mod

module matrix_invert_mod

use       fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, &
                         write_version_number

implicit none

public  :: invert
integer, private :: maxmag

character(len=128), parameter :: version = '$Id matrix_invert.f90 $'
character(len=128), parameter :: tagname = '$Name: tikal $'
logical :: entry_to_logfile_done = .false.

contains

subroutine invert(matrix, det)

real, intent(inout), dimension(:,:) :: matrix
real, intent(out) :: det

real, dimension(2*size(matrix,1)) :: dd, h
real, dimension(2*size(matrix,1),size(matrix,1)) :: ac, temp
real :: min_det=1.0e-30
character(len=24) :: chtmp
integer :: n, i, j, L, m, k

! *******************************************************************
!
! **** matrix_invert (MATRIX INVERSION AND DETERMINANT)
!
! **** QUESTIONS:  TRIVENI N. UPADHYAY, AUSTIN,TEXAS  X2207,MS 2186
!
! **** PURPOSE:
!        THIS SUBROUTINE INVERTS n by n NONSINGULAR MATRIX AND
!        FINDS IT'S DETERMINANT.
!
! **** ARGUMENTS:
!        matrix : INPUT MATRIX OF DIMENSION n by n TO BE INVERTED
!        n      : DIMENSION OF MATRIX
!        det    : DETERMINANT OF MATRIX
!
! **** PROCEDURE AND LIMITATIONS :
!          THIS SUBROUTINE USES THE METHOD OF ELEMENTARY
!        TRANFORMATIONS TO FIND THE INVERSE OF A MATRIX.
!        THE INPUT MATRIX IS DESTROYED IN COMPUTATION AND THE INVERSE
!        MATRIX TAKES ITS PLACE. FOR NUMERICAL ACCURACY, ELEMENTARY
!        TRANSFORMATIONS ARE PERFORMED IN CONJUNCTION WITH THE
!        'PIVOTAL' ELEMENT METHOD.
!          IF THE INPUT MATRIX IS SINGULAR (DETERMINANT LESS
!        THAN min_det), AN ERROR MESSAGE IS PRINTED OUT AND THE
!        PROGRAM IS TERMINATED.

if(.not.entry_to_logfile_done) then
  call write_version_number(version, tagname)
  entry_to_logfile_done = .true.
endif

n = size(matrix,1)

!   INITIALIZE

det = 1.0
ac(1:n,:) = matrix(:,:)
do j=1,n
  ac(n+1:2*n,j) = 0.0
  ac(n+j,    j) = 1.0
end do

do k=1,n

! FIND  LARGEST ELEMENT IN THE ROW

  h(k:n) = ac(k,k:n)
  m = n-k+1
  L = max_mag(h(k:n),M)+k

! INTERCHANGE COLUMNS IF THE LARGEST ELEMENT IS NOT THE DIAGONAL ELEMENT.

  if (k-L < 0) then
    do i=k,2*n
      dd(i)   = ac(i,k)
      ac(i,k) = ac(i,L)
      ac(i,L) = dd(i)
    end do
    det = -det
  end if
 
! DIVIDE THE COLUMN BY THE LARGEST ELEMENT
 
  det = det*ac(k,k)
  if (abs(det) < min_det) then
    write(chtmp,'(1pe24.16)') det
    call error_mesg('invert','DETERMINANT OF MATRIX ='//chtmp// &
    & ' THE MAGNITUDE OF THE DETERMINANT IS LESS THAN THE MINIMUM ALLOWED. &
    &  THE INPUT MATRIX APPEARS TO BE SINGULAR.',FATAL)
  endif
  h(k:2*n) = ac(k:2*n,k)/ac(k,k)
  do j=1,n
    temp(k:2*n,j) = h(k:2*n)*ac(k,j)
  end do
  ac(k:2*n,:) = ac(k:2*n,:) - temp(k:2*n,:)
  ac(k:2*n,k) = h(k:2*n)
end do

matrix(1:n,:) = ac(n+1:2*n,:)

return
end subroutine invert

function max_mag(h,m) result(max)

integer, intent(in) :: m
real, intent(in) :: h(m)
integer :: max, i
real :: rmax

max = 0
rmax = abs(h(1))
do i=1,m
  if (abs(h(i)) > rmax ) then
    rmax = abs(h(i))
    max = i-1
  endif
end do
return
end function max_mag

end module matrix_invert_mod

module bgrid_horiz_adjust_mod

!-----------------------------------------------------------------------
!   This modules has interfaces for computing various 
!         horizontal adjustment processes.
!
!   1) momentum adjustment using coriolis and pressure gradient
!   2) mass fluxes (used for divergence and advection)
!   3) mass divergence
!   4) thermodynamic term (horizontal part of omega-alpha term)
!   4) pressure gradient (several options)
!   5) grad(p)/p term (used for energy conservation)
!   6) divergence damping
!
!-----------------------------------------------------------------------

use bgrid_horiz_mod      , only: horiz_grid_type
use bgrid_vert_mod       , only: vert_grid_type, compute_pres_depth, &
                                 compute_geop_height, compute_pres_half
use bgrid_masks_mod      , only: grid_mask_type
use bgrid_halo_mod       , only: update_halo, TEMP
use bgrid_change_grid_mod, only: change_grid, TEMP_GRID, WIND_GRID, &
                                              UFLX_GRID, VFLX_GRID

use         constants_mod, only: OMEGA, RADIUS, RDGAS
use               fms_mod, only: error_mesg, FATAL

implicit none
private

public :: horiz_adjust_vel, horiz_adjust_mass, press_grad, &
          div_damping, compute_grad_pres, press_grad_fv

!-----------------------------------------------------------------------

   real, parameter :: RADIUS_INV = 1.0/RADIUS

!-----------------------------------------------------------------------

contains

!#######################################################################

subroutine horiz_adjust_vel ( Hgrid, Masks, dt, &
                              pgfew, pgfns, um, vm, udt, vdt,  &
                              alpha_implicit )

!-----------------------------------------------------------------------
!  update momentum tendencies using coriolis and pressure gradient
!
!    IN: Hgrid  = horizontal grid constants
!        Masks  = grid masking constants
!        dt     = time step
!        pgfew,
!         pgfns = pressure gradient force components (m/s2)
!        um,vm  = zonal and meridional wind components
!
! INOUT: udt,vdt = tendency of zonal and meridional wind components
!
! IN (opt): alpha_implicit = coefficient for coriolis/pgf time diff
!                               0.0 = explicit (not recommended)
!                               0.5 = trapezoidal implicit (default)
!                               1.0 = fully implicit
!
!-----------------------------------------------------------------------
type(horiz_grid_type), intent(in)      :: Hgrid
type (grid_mask_type), intent(in)      :: Masks
   real, intent(in)                    :: dt
   real, intent(in),    dimension(Hgrid%ilb:, Hgrid%jlb:, :) :: &
                                           pgfew, pgfns, um, vm
   real, intent(inout), dimension(Hgrid%ilb:, Hgrid%jlb:, :) :: &
                                                        udt, vdt
real, optional, intent(in)              :: alpha_implicit
!-----------------------------------------------------------------------

  real, dimension (Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub) :: &
      pgfu, pgfv, f0, fa, fb, cu, cv, up, vp, un, vn

    integer :: i, j, k
    real    :: alpha
!-----------------------------------------------------------------------

     alpha = 0.5; if (present(alpha_implicit)) alpha = alpha_implicit
     alpha = min(max(0.0,alpha),1.0)

!-----------------------------------------------------------------------
!-----------------update u and v (coriolis & pgf)-----------------------

      do k =            1, size(um,3)
      do j = Hgrid%Vel%js, Hgrid%Vel%je
      do i = Hgrid%Vel%is, Hgrid%Vel%ie

!     --------- pressure gradient force components---------------

         pgfu(i,j) = dt*pgfew(i,j,k)
         pgfv(i,j) = dt*pgfns(i,j,k)

!     ------------coriolis & curvature terms----------------------

         f0(i,j) = (um(i,j,k)*RADIUS_INV*Hgrid%tanphv(i,j)+  &
                              2.*OMEGA*Hgrid%sinphv(i,j))*dt
         fa(i,j) = f0(i,j)*(1.0-alpha)
         fb(i,j) = f0(i,j)*alpha

         cu(i,j) =  vm(i,j,k)*fa(i,j)
         cv(i,j) = -um(i,j,k)*fa(i,j)

!     ------------compute new u and v (coriolis & pgf)------------

         up(i,j) = pgfu(i,j) + cu(i,j) + um(i,j,k)
         vp(i,j) = pgfv(i,j) + cv(i,j) + vm(i,j,k)

         un(i,j) = ((fb(i,j)*vp(i,j)+up(i,j))/   &
                    (fb(i,j)*fb(i,j)+1.0))*Masks%Vel%mask(i,j,k)
         vn(i,j) = (vp(i,j)-fb(i,j)*un(i,j))*Masks%Vel%mask(i,j,k)

!     ---- return unfiltered tendencies with halos not updated ----

         udt(i,j,k) = udt(i,j,k) + (un(i,j)-um(i,j,k))/dt
         vdt(i,j,k) = vdt(i,j,k) + (vn(i,j)-vm(i,j,k))/dt
      enddo
      enddo
      enddo

!-----------------------------------------------------------------------

end subroutine horiz_adjust_vel

!#######################################################################

 subroutine horiz_adjust_mass ( nplev, Hgrid, Masks,  &
                                u, v, dpde, cew, cns,        &
                                flew, flns, div, omgalf      )

!-----------------------------------------------------------------------
!  Computes:  mass fluxes, divergence, thermodynamic term (horiz part)
!
!    IN: nplev  = vertical index of uppermost pure pressure level
!                 (use nplev=0 for sigma models)
!        Hgrid  = horizontal grid constants
!        Masks  = grid masking constants
!        u, v   = prognostic variables for zonal and meridional wind
!        dpde   = pressure thickness of model layers
!        cew,
!          cns  = zonal and meridional components of grad(p)/p (no units)
!
! INOUT: flew,
!          flns = zonal, meridional mass fluxes (summation) (Pa-m2/s)
!
!   OUT: div    = mass divergence (Pa/s)
!        omgalf = horizontal part of omega-alpha term (Pa/s)
!
!-----------------------------------------------------------------------
integer, intent(in)                   :: nplev
type(horiz_grid_type), intent(inout)  :: Hgrid
type (grid_mask_type), intent(in)     :: Masks
  real, intent(in),    dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: u, v, &
                                                        dpde, cew, cns
  real, intent(inout), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: flew, flns
  real, intent(out),   dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: div, omgalf
!-----------------------------------------------------------------------

    real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub) ::   &
                                  few, fns, udy, vdx, tew, tns, adpdxy

    integer :: i, j, k, is, ie, js, je


    is = Hgrid%Tmp%is;  ie = Hgrid%Tmp%ie
    js = Hgrid%Tmp%js;  je = Hgrid%Tmp%je

!-----------------------------------------------------------------------

!-----------------------------------------------------------------------

      few = 0.0;  fns = 0.0

   do k = 1, size(u,3)

     !---- average mass weights for mass fluxes ----
      call change_grid ( Hgrid, TEMP_GRID, WIND_GRID, dpde(:,:,k), adpdxy )

!---- compute mass fluxes, divergence & horizontal omega-alpha term ----
!-------add in compute flux corrections for grid separation ------------
!---- sum input/output mass fluxes -------

      do j = js-1, je+1
         udy(:,j)=Hgrid%Vel%dy   *u(:,j,k)*adpdxy(:,j)   *Masks%Vel%mask(:,j,k)
         vdx(:,j)=Hgrid%Vel%dx(j)*v(:,j,k)*adpdxy(:,j)   *Masks%Vel%mask(:,j,k)
      enddo

      do j = js,   je
      do i = is-1, ie
          few(i,j)   = (udy(i,j)+udy(i,j-1))*0.5
          tew(i,j)   = few(i,j)*cew(i,j,k)
      enddo
      enddo
      do j = js-1, je
      do i = is,   ie
          fns(i,j)   = (vdx(i,j)+vdx(i-1,j))*0.5
          tns(i,j)   = fns(i,j)*cns(i,j,k)
      enddo
      enddo

!-----------------------------------------------------------------------
! ------ sum fluxes (output needed for advection) ------
! ------ (halos will be updated in advection) ------

      flew(:,:,k) = flew(:,:,k) + few
      flns(:,:,k) = flns(:,:,k) + fns

!---------------------------divergence----------------------------------

      do j = js, je
      do i = is, ie
         div(i,j,k) = ((few(i  ,j)+fns(i,j  ))-  &
                       (few(i-1,j)+fns(i,j-1)))  &
                        *Hgrid%Tmp%rarea(j)*Masks%Tmp%mask(i,j,k)
      enddo
      enddo

!-------------- horizontal part of omega-alpha -------------------------
!        ------ do not do for pure pressure levels -----

      if (k > nplev) then
         do j = js, je
         do i = is, ie
            omgalf(i,j,k)=(tew(i,j)+tew(i-1,j)+tns(i,j)+tns(i,j-1)) &
                          *0.50*Hgrid%Tmp%rarea(j)*Masks%Tmp%mask(i,j,k)
         enddo
         enddo
      else
            omgalf(:,:,k) = 0.0
      endif

!-----------------------------------------------------------------------
!---- end level loop -----

   enddo

!-----------------------------------------------------------------------

 end subroutine horiz_adjust_mass

!#######################################################################
!        Simmons and Burridge (1981) pressure gradient

subroutine press_grad ( Hgrid, Vgrid, Masks, fssl, tq,         &
                        dpde, wta, wtb, cew, cns, pgfew, pgfns )

!-----------------------------------------------------------------------
!    IN: Hgrid  = horizontal constants
!        Vgrid  = vertical constants
!        Masks  = grid masking constants
!        fssl   = geopotential height (m2/s2) at eta=1.
!        tq     = virtual temperature
!        dpde   = pressure thickness of model layers
!        wta,
!          wtb  = weights for computing geopotential height
!                 (same as weight for computing full pressures)
!        cew,
!          cns  = zonal and meridional components of grad(p)/p
!
!   OUT: pgfew,
!         pgfns = pressure gradient force components (m/s2)
!
!-----------------------------------------------------------------------
type(horiz_grid_type), intent (inout) :: Hgrid
type (vert_grid_type), intent (in)  :: Vgrid
type (grid_mask_type), intent (in)  :: Masks
   real, intent (in) , dimension(Hgrid%ilb:Hgrid%iub, &
                                 Hgrid%jlb:Hgrid%jub) :: fssl
   real, intent (in),  dimension(Hgrid%ilb:Hgrid%iub, &
                                 Hgrid%jlb:Hgrid%jub,Vgrid%nlev) :: &
                                       tq, dpde, wta, wtb, cew, cns
   real, intent (out), dimension(Hgrid%ilb:Hgrid%iub, &
                                 Hgrid%jlb:Hgrid%jub,Vgrid%nlev) :: &
                                       pgfew, pgfns

!-----------------------------------------------------------------------
  real, dimension (Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub) :: &
                                       pew, pns, tew, tns

  real, dimension (Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub,  &
                   size(tq,3)) :: fim, ppcew, ppcns

    integer :: i, j, k, is, ie, js, je
!-----------------------------------------------------------------------
!------------- integration of geopotential height-----------------------
!        fim = geopotential height at model levels

   if (Vgrid%nlev /= size(tq,3)) call error_mesg ('geop_height',  &
                              'wrong number of vertical levels', FATAL)

   if (Vgrid%nlev > 1) then

       call compute_geop_height (Vgrid, fssl, tq, wta, wtb, fim, &
                                 mask=Masks%Tmp%mask)

   else

       fim(:,:,:) = dpde(:,:,:) ! special case for shallow water model

   endif

!----------- lat/lon contributions to pressure gradient ----------------
!   -------- two loops: pressure only, pressure/sigma -------
!   ppcew,ppcns = zonal and meridional auxillary pressure gradient
!                 force components (i.e., not on velocity grid)

   is = Hgrid%Vel%is;  ie = Hgrid%Vel%ie
   js = Hgrid%Vel%js;  je = Hgrid%Vel%je

   ! compute at pure pressure levels
   do k =  1, Vgrid%nplev
     do j = js, je+1
     do i = is, ie
       ppcew(i,j,k) = fim(i+1,j,k)-fim(i,j,k)
     enddo
     enddo
     do j = js, je
     do i = is, ie+1
       ppcns(i,j,k) = fim(i,j+1,k)-fim(i,j,k)
     enddo
     enddo
   enddo

   ! compute at sigma/pressure levels
   do k = Vgrid%nplev+1, Vgrid%nlev
     do j = js, je+1
     do i = is, ie
         pew(i,j)   = fim(i+1,j,k)-fim(i,j,k)
         tew(i,j)   = RDGAS*0.50*(tq(i+1,j,k)+tq(i,j,k))
       ppcew(i,j,k) = pew(i,j)+tew(i,j)*cew(i,j,k)
     enddo
     enddo
     do j = js, je
     do i = is, ie+1
         pns(i,j)   = fim(i,j+1,k)-fim(i,j,k)
         tns(i,j)   = RDGAS*0.50*(tq(i,j+1,k)+tq(i,j,k))
       ppcns(i,j,k) = pns(i,j)+tns(i,j)*cns(i,j,k)
     enddo
     enddo
   enddo

!--------------compute pressure gradient force components---------------

   do k =  1, Vgrid%nlev
   do j = js, je
   do i = is, ie
      pgfew(i,j,k)=-0.50*(ppcew(i,j,k)+ppcew(i,j+1,k))*Hgrid%Vel%rdx(j)
      pgfns(i,j,k)=-0.50*(ppcns(i,j,k)+ppcns(i+1,j,k))*Hgrid%Vel%rdy
   enddo
   enddo
   enddo

!-----------------------------------------------------------------------

 end subroutine press_grad

!#######################################################################
!      code for Lin (1997) finite volume pressure gradient

 subroutine press_grad_fv ( Hgrid, Vgrid, Masks, fssl, tq, phalf, &
                            wta, wtb, pgfew, pgfns                )       

!-----------------------------------------------------------------------
!    IN: Hgrid  = horizontal constants
!        Vgrid  = horizontal constants
!        Masks  = grid masking constants
!        fssl   = geopotential height (m2/s2) at eta=1.
!        tq     = virtual temperature
!        phalf  = pressure at model layer interfaces
!        wta,    
!          wtb  = weights for computing geopotential height
!                 (same as weight for computing full pressures)
!   OUT: pgfew,
!         pgfns = pressure gradient force components (m/s2)
!-----------------------------------------------------------------------
type(horiz_grid_type), intent (inout) :: Hgrid
type (vert_grid_type), intent (in)  :: Vgrid
type (grid_mask_type), intent (in)  :: Masks
   real, intent (in) , dimension(Hgrid%ilb:Hgrid%iub, &
                                 Hgrid%jlb:Hgrid%jub) :: fssl 
   real, intent (in),  dimension(Hgrid%ilb:Hgrid%iub, &
                                 Hgrid%jlb:Hgrid%jub,Vgrid%nlev+1) :: &
                                       phalf
   real, intent (in),  dimension(Hgrid%ilb:Hgrid%iub, &
                                 Hgrid%jlb:Hgrid%jub,Vgrid%nlev) :: &
                                       tq, wta, wtb
   real, intent (out), dimension(Hgrid%ilb:Hgrid%iub, &
                                 Hgrid%jlb:Hgrid%jub,Vgrid%nlev) :: &
                                       pgfew, pgfns

!-----------------------------------------------------------------------
  real, dimension (Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub) :: &
                                       few, pew, fns, pns
  real, dimension (Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub,  &
                   size(tq,3)+1) :: fi, pi
  real   :: dp1, dp2
  integer :: i, j, k, is, ie, js, je

!------------- integration of geopotential height-----------------------
!        fi = geopotential height at half levels
!        pi = ln pressure at half levels

   if (Vgrid%nlev /= size(tq,3)) call error_mesg ('geop_height',  &
                              'wrong number of vertical levels', FATAL)

 ! initialize
     is = Hgrid%Vel%is;  ie = Hgrid%Vel%ie
     js = Hgrid%Vel%js;  je = Hgrid%Vel%je

 ! define ln pressure
     pi(:,:,2:Vgrid%nlev+1) = log(phalf(:,:,2:Vgrid%nlev+1))
     if (Vgrid%pzero) then
 ! extrapolate when pressure at top = 0
       ! following simmons & burridge scheme
       pi(:,:,1) = 2.*pi(:,:,2)*phalf(:,:,2)/(phalf(:,:,2)-phalf(:,:,1)) - &
                      pi(:,:,2) - 2.
     else
       pi(:,:,1) = log(phalf(:,:,1))
     endif

 ! compute geop height at model layer interfaces
 ! integrate up from surface
     fi(:,:,Vgrid%nlev+1) = fssl
  if (Masks%sigma) then
     do k = Vgrid%nlev, 1, -1
        fi(:,:,k) = fi(:,:,k+1) + RDGAS*tq(:,:,k)*(pi(:,:,k+1)-pi(:,:,k))
     enddo
  else
     do k = Vgrid%nlev, 1, -1
        where (Masks%Tmp%mask(:,:,k) < 0.5)
            fi(:,:,k) = Vgrid%fhalf(k)
        elsewhere
            fi(:,:,k) = fi(:,:,k+1) + RDGAS*tq(:,:,k)*(pi(:,:,k+1)-pi(:,:,k))
        endwhere
     enddo
  endif

 ! loop over levels
   do k = 1, Vgrid%nlev

   ! compute pressure gradient at intermediate points
   ! E/W component
     do j = js, je+1
     do i = is, ie
        dp1 = pi(i+1,j,k+1) - pi(i  ,j,k)
        dp2 = pi(i  ,j,k+1) - pi(i+1,j,k)
        few(i,j) = (dp1*(fi(i,j,k+1)-fi(i+1,j,k)) + dp2*(fi(i,j,k)-fi(i+1,j,k+1)))
        pew(i,j) = dp1+dp2
     enddo
     enddo
   ! N/S component
     do j = js, je
     do i = is, ie+1
        dp1 = pi(i,j+1,k+1) - pi(i,j  ,k)
        dp2 = pi(i,j  ,k+1) - pi(i,j+1,k)
        fns(i,j) = (dp1*(fi(i,j,k+1)-fi(i,j+1,k)) + dp2*(fi(i,j,k)-fi(i,j+1,k+1)))
        pns(i,j) = dp1+dp2
     enddo
     enddo

   ! compute pressure gradient at velocity points
     do j = js, je
     do i = is, ie
        pgfew(i,j,k) = (few(i,j)+few(i,j+1))/(pew(i,j)+pew(i,j+1))*Hgrid%Vel%rdx(j)
        pgfns(i,j,k) = (fns(i,j)+fns(i+1,j))/(pns(i,j)+pns(i+1,j))*Hgrid%Vel%rdy
     enddo
     enddo

   enddo

 end subroutine press_grad_fv

!#######################################################################
!   compute grad P term consistent with Simmons and Burridge

 subroutine compute_grad_pres (Hgrid, nplev, phalf, dpde, &
                               wta, wtb, cew, cns)

!-----------------------------------------------------------------------
!   IN:  Hgrid  = horizontal constants
!        nplev  = vertical index of uppermost pure pressure level
!                 (use nplev=0 for sigma models)
!        phalf  = pressure at model layer interfaces
!        dpde   = pressure thickness of model layers
!        wta,
!          wtb  = weights for computing geopotential height
!                 (same as weight for computing full pressures)
!  OUT:  cew,
!          cns  = zonal and meridional components of grad(p)/p (no units)
!-----------------------------------------------------------------------

   type(horiz_grid_type), intent(in)  :: Hgrid
   integer,               intent(in)  :: nplev
   real, intent(in),  dimension(Hgrid%ilb:,Hgrid%jlb:,:) ::  &
                                       phalf, dpde, wta, wtb
   real, intent(out), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: cew, cns

   real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub) :: &
                                   pewa, pewb, pnsa, pnsb
   real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub, &
                                        size(dpde,3)) :: adpdx, adpdy
   integer :: i, j, k

 ! special case for one level model
   if (size(dpde,3) == 1) then
       cew(:,:,:) = 0.0
       cns(:,:,:) = 0.0
       return
   endif

 ! term vanishes on pressure levels 
   do k = 1, nplev
       cew(:,:,k) = 0.0
       cns(:,:,k) = 0.0
   enddo

!---- compute pressure depth at uflx and vflx points ----

   call change_grid (Hgrid, TEMP_GRID, UFLX_GRID, dpde(:,:,:), adpdx)
   call change_grid (Hgrid, TEMP_GRID, VFLX_GRID, dpde(:,:,:), adpdy)


! --- compute pressure differences ----

   do j = Hgrid%Tmp%js,   Hgrid%Tmp%je+1
   do i = Hgrid%Tmp%is-1, Hgrid%Tmp%ie
      pewa(i,j) = phalf(i+1,j,nplev+1)-phalf(i,j,nplev+1)
   enddo
   enddo

   do j = Hgrid%Tmp%js-1, Hgrid%Tmp%je
   do i = Hgrid%Tmp%is,   Hgrid%Tmp%ie+1
      pnsa(i,j) = phalf(i,j+1,nplev+1)-phalf(i,j,nplev+1)
   enddo
   enddo

! --- compute grad pressure term at model levels ----

   do k = nplev+1, size(phalf,3)-1

      !---- east-west contribution ----
       do j = Hgrid%Tmp%js,   Hgrid%Tmp%je+1
       do i = Hgrid%Tmp%is-1, Hgrid%Tmp%ie
           pewb(i,j) = phalf(i+1,j,k+1)-phalf(i,j,k+1)
           cew(i,j,k) = (wta(i+1,j,k)+wta(i,j,k)) * pewa(i,j) + &
                        (wtb(i+1,j,k)+wtb(i,j,k)) * pewb(i,j)
           cew(i,j,k) = 0.5 * cew(i,j,k) / adpdx(i,j,k)
           pewa(i,j) = pewb(i,j)
       enddo
       enddo
      !---- north-south contribution ----
       do j = Hgrid%Tmp%js-1, Hgrid%Tmp%je
       do i = Hgrid%Tmp%is,   Hgrid%Tmp%ie+1
           pnsb(i,j) = phalf(i,j+1,k+1)-phalf(i,j,k+1)
           cns(i,j,k) = (wta(i,j+1,k)+wta(i,j,k)) * pnsa(i,j) + &
                        (wtb(i,j+1,k)+wtb(i,j,k)) * pnsb(i,j)
           cns(i,j,k) = 0.5 * cns(i,j,k) / adpdy(i,j,k)
           pnsa(i,j) = pnsb(i,j)
       enddo
       enddo
   enddo

 end subroutine compute_grad_pres

!#######################################################################

 subroutine div_damping (Hgrid, Vgrid, Masks, dt, coeff, dpde, div,  &
                         u_dt, v_dt)

!-----------------------------------------------------------------------
!
!   Computes divergence damping tendency for momentum fields
!
!    IN: Hgrid  = horizontal constants
!        Vgrid  = horizontal constants
!        Masks  = grid masking constants
!        dt     = time step
!        coeff  = coefficient for divergence damping
!        dpde   = model layer pressure thickness
!        div    = mass divergence (Pa/s)
!
! INOUT: u_dt,
!          v_dt = zonal and meridional momentum tendencies (m/s2)
!
!-----------------------------------------------------------------------

type(horiz_grid_type), intent (inout)  :: Hgrid
type (vert_grid_type), intent (in)  :: Vgrid
type (grid_mask_type), intent (in)  :: Masks
 real, intent (in)                  :: dt, coeff
 real, intent (in) ,   dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: dpde, div
 real, intent (inout), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: u_dt, v_dt

!-----------------------------------------------------------------------

  real, dimension (Hgrid%jlb:Hgrid%jub) :: scoeff
  real, dimension (Hgrid%ilb:Hgrid%iub, &
                   Hgrid%jlb:Hgrid%jub) :: dew, dns, adpdxy
  real, dimension (Hgrid%ilb:Hgrid%iub, &
                   Hgrid%jlb:Hgrid%jub,size(div,3)) :: adiv

  real    :: dcoeff
  integer :: i, j, k, is, ie, hs, he, vs, ve, ks, ke
  logical :: fourth_order
!-----------------------------------------------------------------------

  is = Hgrid % Vel % is;  ie = Hgrid % Vel % ie
  vs = Hgrid % Vel % js;  ve = Hgrid % Vel % je
  hs = Hgrid % Tmp % js;  he = Hgrid % Tmp % je
  ks = 1
  ke = size(div,3)
  fourth_order = .false.
  if (coeff < 0.0) fourth_order = .true.
  scoeff = abs(coeff)
  ! maximum damping at the sub-pole row
  ! if (vs == Hgrid%Vel%jsg) scoeff(vs) = 1.0
  ! if (ve == Hgrid%Vel%jeg) scoeff(ve) = 1.0

  if (fourth_order) then
     ! additional 5-pt smoother when fourth-order
     scoeff = -0.50*(scoeff/8.)**2/dt
     do k = ks, ke
        do j = hs-1, he
        do i = is-1, ie
           dew(i,j) = div(i+1,j,k)-div(i,j,k)
           dns(i,j) = div(i,j+1,k)-div(i,j,k)
        enddo
        enddo

        do j = hs, he
        do i = is, ie
           adiv(i,j,k) = (dew(i,j)+dns(i,j)-dew(i-1,j)-dns(i,j-1))
        enddo
        enddo
     enddo

     call update_halo ( Hgrid, TEMP, adiv )
  else
     ! second order
     scoeff = 0.50*(scoeff/8.)/dt
     do k = ks, ke
     do j = hs-1, he+1
        adiv(:,j,k) = div(:,j,k)
     enddo
     enddo
  endif

! second-order scheme (only the gradient)
  do k = ks, ke
     do j = vs, ve+1
     do i = is, ie
        dew(i,j) = adiv(i+1,j,k)-adiv(i,j,k)
     enddo
     enddo
     do j = vs, ve
     do i = is, ie+1
        dns(i,j) = adiv(i,j+1,k)-adiv(i,j,k)
     enddo
     enddo

     call change_grid ( Hgrid, TEMP_GRID, WIND_GRID, dpde(:,:,k), adpdxy )

     do j = vs, ve
     do i = is, ie
        dcoeff = scoeff(j) / adpdxy(i,j) * Masks%Vel%mask(i,j,k)
        u_dt(i,j,k) = u_dt(i,j,k) + (dew(i,j)+dew(i,j+1)) * dcoeff * Hgrid%Vel%dx(j)
        v_dt(i,j,k) = v_dt(i,j,k) + (dns(i,j)+dns(i+1,j)) * dcoeff * Hgrid%Vel%dx(j)
     enddo
     enddo
  enddo

!-----------------------------------------------------------------------

 end subroutine div_damping

!#######################################################################

end module bgrid_horiz_adjust_mod

module bm_massflux_mod

!----------------------------------------------------------------------
use            mpp_mod, only:  input_nml_file
use            fms_mod, only:  file_exist, error_mesg, open_namelist_file,  &
                               check_nml_error, mpp_pe, FATAL,  &
                               close_file, mpp_root_pe, write_version_number, stdlog
use sat_vapor_pres_mod, only:  escomp, descomp
use      constants_mod, only:  HLv,HLs,Cp_air,Grav,rdgas,rvgas, cp_vapor, kappa

implicit none
private
!----------------------------------------------------------------------
!  ---- public interfaces ----

   public  bm_massflux, bm_massflux_init, bm_massflux_end

!-----------------------------------------------------------------------
!   ---- version number ----

 character(len=128) :: version = '$Id: bm_massflux.F90,v 19.0 2012/01/06 20:01:33 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'

!-----------------------------------------------------------------------
!   ---- local/private data ----

    real, parameter :: d622 = rdgas/rvgas
    real, parameter :: d378 = 1.-d622

    logical :: module_is_initialized=.false.

!-----------------------------------------------------------------------
!   --- namelist ----

real    :: tau_bm=7200.
real    :: rhbm = .8
real    :: revap = 1.0
real    :: minstatstab = .1
logical :: do_shallower = .false.
logical :: do_changeqref = .false.

namelist /bm_massflux_nml/  tau_bm, rhbm, do_shallower, do_changeqref, revap, &
   minstatstab

!-----------------------------------------------------------------------
!           description of namelist variables
!
!  tau_bm    =  betts-miller relaxation timescale (seconds)
!  rhbm      = relative humidity that you're relaxing towards
!             In contrast to standard BM, this can be put as high as 100%
!             as long as the convection scheme is not overwhelmd by 
!             the large-scale condensation.
!  revap     = the precipiation efficiency reevaporation parameter, i.e., 
!              the moistening of the atmosphere per heating.  
!
!  not used:
!
!
!  do_shallower = do the shallow convection scheme where it chooses a smaller
!                 depth such that precipitation is zero
! 
!  do_changeqref = do the shallow convection scheme where if changes the 
!                  profile of both q and T in order make precip zero
!
!-----------------------------------------------------------------------

contains

!#######################################################################

   subroutine bm_massflux (dt, tin, qin, pfull, phalf, coldT, &
                           rain, snow, tdel, qdel, q_ref, bmflag, &
                           klzbs, t_ref, massflux,&
                           mask, conv)

!-----------------------------------------------------------------------
!
!                     Betts-Miller Convection Scheme
!
!-----------------------------------------------------------------------
!
!   input:  dt       time step in seconds
!           tin      temperature at full model levels
!           qin      specific humidity of water vapor at full
!                      model levels
!           pfull    pressure at full model levels
!           phalf    pressure at half (interface) model levels
!           coldT    should precipitation be snow at this point?
!   optional:
!           mask     optional mask (0 or 1.) 
!           conv     logical flag; if true then no betts-miller
!                       adjustment is performed at that grid-point or
!                       model level
!
!  output:  rain     liquid precipitation (kg/m2)
!           snow     frozen precipitation (kg/m2)
!           tdel     temperature tendency at full model levels
!           qdel     specific humidity tendency (of water vapor) at
!                      full model levels
!           bmflag   flag for which routines you're calling
!           klzbs    stored klzb values
!           massflux the massflux used to calculate the humidity adjustment
!
!-----------------------------------------------------------------------
!--------------------- interface arguments -----------------------------

   real   , intent(in) , dimension(:,:,:) :: tin, qin, pfull, phalf
   real   , intent(in)                    :: dt
   logical, intent(in) , dimension(:,:)   :: coldT
   real   , intent(out), dimension(:,:)   :: rain,snow, bmflag, klzbs
   real   , intent(out), dimension(:,:,:) :: tdel, qdel, q_ref, t_ref, massflux
   real   , intent(in) , dimension(:,:,:), optional :: mask
   logical, intent(in) , dimension(:,:,:), optional :: conv
!-----------------------------------------------------------------------
!---------------------- local data -------------------------------------

   logical :: avgbl
   real,dimension(size(tin,1),size(tin,2),size(tin,3)) ::  rin
   real,dimension(size(tin,1),size(tin,2))             ::  &
                     hlcp, precip, cape, cin
   real,dimension(size(tin,3))                         :: rpc, tpc, &
             statstab, theta
   real                                                ::  & 
       cape1, cin1, tot, deltak, deltaq, qrefint, deltaqfrac, deltaqfrac2, &
       ptopfrac
integer  i, j, k, ix, jx, kx, klzb, ktop, klcl

!modif omp:
real :: prec_rev, ratio, q_src, ratio_q, ratio_T, en_acc, ratio_ml
!-----------------------------------------------------------------------
!     computation of precipitation by betts-miller scheme
!-----------------------------------------------------------------------

      if (.not. module_is_initialized) call error_mesg ('bm_massflux',  &
                         'bm_massflux_init has not been called.', FATAL)

      ix=size(tin,1)
      jx=size(tin,2)
      kx=size(tin,3)
      avgbl = .false.

!----- compute proper latent heat --------------------------------------
!
!  omp: at this stage,uses only the latent heat of vaporization. 
!       --- this is used only by the energy budget. The lapse rate 
!       has its own value. (This should be made consistent.)  
!      
!
!      WHERE (coldT)
!           hlcp = HLs/Cp_air
!      ELSEWHERE
           hlcp = HLv/Cp_air
!      END WHERE

!------------------- calculate CAPE and CIN ----------------------------

! calculate r
       rin = qin/(1.0 - qin)
       do i=1,ix
          do j=1,jx

             cape1 = 0.
             cin1 = 0.
             tot = 0.
             klzb=0
             klcl = 0
! the bmflag is written out to show what aspects of the bm scheme is called
! bmflag = 0 is no cape, no convection
! bmflag = 1 cape but no precip: nothing happens
! bmflag = 2 is deep convection
! it's either 0 or 2 in this scheme


             bmflag(i,j) = 0.
             tpc = tin(i,j,:)
             rpc = rin(i,j,:)
! calculate cape, cin, level of zero buoyancy, and parcel properties w/ leo's
! code
!             call capecalc( Cp_air, cp_vapor, d622, kx, pfull(i,j,:),&
!                            rin(i,j,:), rdgas, hlv, rvgas, tin(i,j,:),&
!                            cape1, cin1, tot, tpc, rpc, klcl, klzb)
! new code (second order in delta ln p and exact LCL calculation)
             call capecalcnew( kx,  pfull(i,j,:),  phalf(i,j,:),&
                            Cp_air, rdgas, rvgas, hlv, kappa, tin(i,j,:), &
                            rin(i,j,:), avgbl, cape1, cin1, tpc, &
                            rpc, klzb,klcl)
! set values for storage
             cape(i,j) = cape1
             cin(i,j) = cin1
             klzbs(i,j) = klzb
             massflux(i,j,1:kx) = 0.
             if(cape1.gt.0.) then
!             if( (tot .gt. 0.) .and. (cape1.gt.0.) ) then 
                bmflag(i,j) = 1.

! reference temperature is just that of the parcel all the way up

                t_ref(i,j,:) = tpc

                do k=klzb,kx
!                   q_ref(i,j,k) = rpc(k)/(1. + rpc(k))

! use this for relaxation toward virtual adiabat
!                t_ref(i,j,k) = tpc(k) * ( 1+0.608 * q_ref(i,j,k))/ (1+ 0.608 * qin(i,j,k))


! modif omp: free troposphere is relaxed  toward saturated profile at CURRENT temperature
!                   call escomp(tin(i,j,k),es)
!                   rs=d622*es/(pfull(i,j,k)+(d622-1.)*es)
!                   q_sat(k) = rs/(1. + rs)


! This shouldn't happen, but set reference humidity to be positive just in 
! case
!                   if (q_ref(i,j,k).lt.0.) then
!                      q_ref(i,j,k) = 0.
!                      write (*,*) 'doh! q neg'
!                   end if

                end do

! set the tendencies to zero where you don't adjust
! set the reference profiles to be the original profiles (for diagnostic 
! purposes only --  you can think of this as what you're relaxing to in
! areas above the actual convection

                

                do k=1,max(klzb-1,1)
                   qdel(i,j,k) = 0.0
                   tdel(i,j,k) = 0.0
                   q_ref(i,j,k) = qin(i,j,k)
                   t_ref(i,j,k) = tin(i,j,k)
                end do




! initialize p to zero for the loop

!modif omp: my way...

! check on the LCL. if LCL is less than 50mb above the surface, 
! the 'lcl' is put at the first 
! level above 950mb (required for adjustment near surface) 
! (adjustment dries out ML if lcl too low).

                if (phalf(i,j,kx+1) -phalf(i,j,klcl+1) .LT. 2500) then
                   do k = kx-1,1,-1
                      if (phalf(i,j,kx+1) -phalf(i,j,k+1) .GT. 2500) then
                         klcl = k
                         go to 11
                      end if
                   end do
                end if

! alternatively, just ensure that there is one layer where convection occurs.
!if (klcl .eq. kx ) then
!   klcl = kx -1
!end if


11  continue


                precip(i,j) = 0.0
                prec_rev = 0.0
                en_acc = 0.0
                q_src = 0.0

!adjustment above PBL. 1st compute difference between the 
! profile and computed tendecies

! We need the potential temperature for the static stability.  
                theta(1:kx) = tin(i,j,1:kx)* &
                   (phalf(i,j,kx+1)/pfull(i,j,1:kx))**kappa
! This is actually the static stability * dz (all you need).  
                statstab(1:kx-1) = theta(1:kx-1) - theta(2:kx)
! Since we're going to divide by the static stability, make sure it's not
! too close to zero (minstatstab is a nml parameter).
                do k=1,kx-1
                statstab(k) = max(statstab(k),minstatstab)
!               if (statstab(k).eq.minstatstab) then
!                write (*,*) 'ouch', k
!               end if 
                enddo
! This should never happen, but just in case, make sure the level of zero 
! buoyancy isn't at the very top.  
                if (klzb.eq.1) then
                   klzb = 2
!                   write (*,*) 'doh, klzb = 1'
                end if 
! T is adjusted toward pseudo-adiabat -- this and the static stab determines 
! a mass flux.  
! q is adjusted based on mass flux and moisture stability
                do k=klzb, klcl
! tdel is the temperature adjustment when you multiply it by dt/tau
                   tdel(i,j,k) = - (tin(i,j,k) - t_ref(i,j,k))
! This is actually the downward mass flux/dz*tau.
                   massflux(i,j,k) = tdel(i,j,k)/statstab(k-1)
! Cap the massflux at a maximum value.  1.0 is picked to be 1/2 the 
! maximum allowed by the Courant criterion for tau=7200 s, dt=1800 s
                   if (abs(massflux(i,j,k)).gt.1.0) then
!                   write (*,*) massflux(i,j,k)
                   massflux(i,j,k) = 1.0*massflux(i,j,k)/abs(massflux(i,j,k))
!                   write (*,*) massflux(i,j,k), k, tdel(i,j,k), statstab(k-1)
                   endif
! qdel is the humidity adjustment when you multiply it by dt/tau
! This is just upwind differencing.
! Also, there is a Courant criterion for this advection equation.  The 
! advection velocity is massflux(i,j,k)*dz/tau.  The condition is:
! dt < dz/M = tau/massflux(i,j,k), i.e., massflux(i,j,k) < tau/dt
! The massflux can achieve values around 10 (minstatstab = .5, and 
! the temperature deficits of 5 deg).  
                   if (massflux(i,j,k).gt.0.) then 
                      qdel(i,j,k) = massflux(i,j,k)*(qin(i,j,k-1) - qin(i,j,k))
                   else
                      qdel(i,j,k) = massflux(i,j,k)*(qin(i,j,k) - qin(i,j,k+1))
                   end if 
! Additional moistening from precip eff if heating > 0
                   if (tdel(i,j,k).gt.0.0) then
                      qdel(i,j,k) = qdel(i,j,k) + revap*Cp_air/hlv*tdel(i,j,k)
                   endif 
!!                   qdel(i,j,k) = - (qin(i,j,k) - rhbm * q_ref(i,j,k))
!                   qdel(i,j,k) = - (qin(i,j,k) - rhbm * q_sat(k))
                   precip(i,j) = precip(i,j) + tdel(i,j,k)*(phalf(i,j,k+1) - &
                        phalf(i,j,k))/grav/hlcp(i,j)
                   prec_rev = prec_rev + qdel(i,j,k)*(phalf(i,j,k+1) - &
                        phalf(i,j,k))/grav
                end do


                do k = klcl + 1, kx
!no temperature change in the ML
                   tdel(i,j,k) = 0.0
! relax the ML temp. toward the pseudo-adiabat
!                tdel(i,j,k) = - (tin(i,j,k) - t_ref(i,j,k))
                   precip(i,j) = precip(i,j) + tdel(i,j,k)*(phalf(i,j,k+1) - &
                        phalf(i,j,k))/grav/hlcp(i,j)
                end do

! at this point: precip = total amount of precip required to brin the temperature to the m. adiabat.
!                prec_rev = total water deficit (respectively to saturation at CURRENT temperature)

! humidity adjustment in the ML

! modif df: the following calculations are no longer used, due to the modification
!           described below
!                en_acc = precip(i,j) + min(prec_rev, revap*precip(i,j))
!                en_acc = en_acc * grav /   &
!                   (phalf(i,j,klcl+1) - phalf(i,j,klzb))


! en_acc is the average energy difference (measured in qv) between the atmosphere and the state at which it would
! equilibrate for the current adiabat. 

! adjustment in the pbl
                do k = klcl + 1, kx

! modif df: changed this line (it was caused energy not to be conserved in the
!           case where the atmosphere is too moist, and en_acc is negative --
!           this allowed q_src to be negative, and the expression in that 
!           case was incorrect.  this could have been fixed by putting in a 
!           different expression, but it seems like the boundary layer should
!           be able to be a source of moisture even if the free troposphere 
!           is being dried; further the boundary layer should never be 
!           moistened (which was happening before).  therefore, this line is 
!           removed and replaced just by uniform drying of the boundary layer)
!                qdel(i,j,k) = max( - qin(i,j,k) ,-en_acc)
                   qdel(i,j,k) = -qin(i,j,k)
                   q_src = q_src - qdel(i,j,k)*(phalf(i,j,k+1) - &
                        phalf(i,j,k))/grav
                end do

! Determine the adjustment time-scale


                if (precip(i,j) .gt. 0.0) then 

! If precip > 0, then correct energy. 

                   bmflag(i,j) = 2.

                   ratio = min(dt / tau_bm, 1.0)
! modif df: due to the modification above, it's impossible for this to be negative.
!           therefore everything is commented out.  in case someone wants to use
!           this however, i put in the proper correction into the ratio_q line
!           (the added minus sign, which keeps the timescale positive in this case),
!           so this will conserve energy if you uncomment all the rele,vant lines.  
!                if (q_src .lt. 0.0) then
!                   ratio_ML = 0.0
!                   if (prec_rev .gt. 0.0) then
!should not be happening
!                      write (*,*) 'BUGGGGGGG', precip(i,j), prec_rev, en_acc, q_src
!                      write (*,*) 'QREF:',q_ref(i,j,klcl+1:kx),'QIN',qin(i,j,klcl+1:kx)
!                   end if
!                   ratio_T = ratio
!                   ratio_q = -precip(i,j) * ratio_T / prec_rev
!                else

!try convection limited by low level moisture supply
! modif df: a lot of this doesn't make sense to me, so this is commented out and 
!           changed to what's described in olivier's writeup
!                   if (prec_rev .lt. 0.0 ) then
!                      ratio_q = ratio
!                      ratio_ML = ratio
!                      ratio_T = (ratio_ML * q_src - ratio_q * prec_rev)  &
!                           / precip(i,j)    
!                      if (ratio_T .GT. ratio) then
!                         ratio_T = ratio
!                         ratio_ML = ( ratio_T * precip(i,j) + ratio_q * prec_rev) &
!                           /q_src
!                         if (ratio_ML .GT. ratio) then
!                            write(*,*)'danger: ', ratio, ratio_ML, precip(i,j), q_src, prec_rev
!                         end if
!                      end if
!                   else 
!                      ratio_ML = ratio
!                      ratio_T = ratio * q_src / ((1.0 + revap) * precip(i,j))
!!               ratio_q = revap * ratio_T
!                      ratio_q = precip(i,j) * revap * ratio_T / prec_rev
!                      if (ratio_q .gt. ratio) then
!                         ratio_q = ratio
!                         ratio_T = (ratio_ML * q_src - ratio_q * prec_rev)  &
!                             / precip(i,j)  
!                      end if
!
!
!                      if ( ratio_T  .gt. ratio) then
!                  
!                         ratio_T = ratio
!                         ratio_q = max(ratio, precip(i,j)*revap*ratio_T/prec_rev)
!                         ratio_ML = (ratio_T*precip(i,j) + ratio_q*prec_rev) &
!                           /q_src
!                      end if
!                   end if
! Adjust T and q, and conserve energy by draining the boundary layer by the 
! required amount.  
! Don't allow the ML to be moistened!  
                   if (precip(i,j)+prec_rev.gt.0.0) then
                      ratio_q = ratio
                      ratio_T = ratio
                      ratio_ML = ( ratio_T * precip(i,j) + ratio_q * prec_rev) &
                        /q_src
! If you're draining the boundary layer too fast (in a way that would allow 
! humidities to become negative), then limit the convection by reducing 
! the adjustment of temperature and humidity in concert.  
                      if (ratio_ML.gt.ratio) then 
                         ratio_ML = ratio
                         ratio_T = (ratio_ML * q_src )  &
                              / (precip(i,j) + prec_rev)
                         ratio_q = ratio_T
                      end if
                   else
! If the scheme tries to moisten the ML, don't allow this.  
                      ratio_ML = 0.0
                      ratio_T = ratio
                      ratio_q = -ratio_T*precip(i,j)/prec_rev
                   end if

!adjust the tendencies
                
                   do k = klzb,klcl
                      qdel(i,j,k)= qdel(i,j,k) * ratio_q  
                      tdel(i,j,k)= tdel(i,j,k) * ratio_T 
                      massflux(i,j,k) = massflux(i,j,k)*ratio_q/dt* &
                          (phalf(i,j,k+1) - phalf(i,j,k))/grav
                   end do
                   do k = klcl+1,kx
                      qdel(i,j,k)= qdel(i,j,k) * ratio_ML  
                      tdel(i,j,k)= tdel(i,j,k) * ratio_T
                   end do
                   precip(i,j) = precip(i,j) * ratio_T
                       





                else

!omp: This is Dargan's and not used in my version (put do_shallower and  
!do change_qref as .false.

! Shallow / non-precipitating adjustment from dargan. It has not been tested 
! with this version of the deep convection scehme. Use do_shallower = .false.
! and do_changeqref = .false. to turn off. In this case, no convection occurs 
! when the computed precipitation is 0. 


! If precip < 0, then do the shallow conv routine.
! First option: do_shallower = true
! This chooses the depth of convection based on choosing the height that 
! it can make precip zero, i.e., subtract off heights until that precip 
! becomes positive.  

                    if (do_shallower) then
! ktop is the new top of convection.  set this initially to klzb.
                       ktop = klzb
! Work your way down until precip is positive again.
                       do while ( (precip(i,j).lt.0) .and. (ktop.le.kx) )
                          precip(i,j) = precip(i,j) - qdel(i,j,ktop)* &
                                   (phalf(i,j,ktop) - phalf(i,j,ktop+1))/grav
                          ktop = ktop + 1
                       end do
! since there will be an overshoot (precip is going to be greater than zero 
! once we finish this), the actual new top of convection is somewhere between
! the current ktop, and one level above this.  set ktop to the level above.
                       ktop = ktop - 1
! Adjust the tendencies in the places above back to zero, and the reference 
! profiles back to the original t,q.
                       if (ktop.gt.klzb) then
                          qdel(i,j,klzb:ktop-1) = 0.
                          q_ref(i,j,klzb:ktop-1) = qin(i,j,klzb:ktop-1)
                          tdel(i,j,klzb:ktop-1) = 0.
                          t_ref(i,j,klzb:ktop-1) = tin(i,j,klzb:ktop-1)
                       end if
! Then make the change only a fraction of the new top layer so the precip is 
! identically zero.
! Calculate the fractional penetration of convection through that top layer.  
! This is the amount necessary to make precip identically zero.  
                       ptopfrac = precip(i,j)/(qdel(i,j,ktop)* &
                          (phalf(i,j,ktop+1) - phalf(i,j,ktop)))
! Reduce qdel in the top layer by this fraction. 
                       qdel(i,j,ktop) = ptopfrac*qdel(i,j,ktop)
! Set precip to zero
                       precip(i,j) = 0.
! A diagnostic which allows calculating precip to make sure it's zero.
                       do k=ktop,kx
                          precip(i,j)=precip(i,j)+qdel(i,j,k)* &
                                 (phalf(i,j,k) - phalf(i,j,k+1))/grav
                       end do
                       if (abs(precip(i,j)).gt.1.e-5) &
                           write(6,*) 'doh! precip.ne.0'
! Now change the reference temperature in such a way to make the net 
! heating zero.
                       deltak = 0.
                       if (ktop.lt.kx) then
! Integrate temperature tendency up to 1 level below top.
                          do k=ktop+1,kx
                             deltak = deltak + tdel(i,j,k)* &
                                 (phalf(i,j,k) - phalf(i,j,k+1))
                          end do
! Then for the top level, use only a fraction.
                          deltak = deltak + ptopfrac*tdel(i,j,ktop)* &
                               (phalf(i,j,ktop) - phalf(i,j,ktop+1))
! Normalize by the pressure difference.
                          deltak = deltak/(phalf(i,j,kx+1) - & 
                           phalf(i,j,ktop+1) + ptopfrac*(phalf(i,j,ktop+1) - &
                           phalf(i,j,ktop)))
! Subtract this value uniformly from tdel, and make the according change to 
! t_ref.
                          do k=ktop,kx
                             tdel(i,j,k) = tdel(i,j,k) + deltak
                             t_ref(i,j,k) = t_ref(i,j,k) + deltak*tau_bm/dt
                          end do
                       end if
                    else if(do_changeqref) then
! Change the reference profile of q by a certain fraction so that precip is 
! zero.  This involves calculating the total integrated q_ref dp (this is the
! quantity intqref), as well as the necessary change in q_ref (this is the 
! quantity deltaq).  Then the fractional change in q_ref at each level (the 
! quantity deltaqfrac) is 1-deltaq/intqref.  (have to multiply q_ref by 
! 1-deltaq/intqref at every level)  Then the change in qdel is 
! -deltaq/intqref*q_ref*dt/tau_bm.
! Change the reference profile of T by a uniform amount so that precip is zero.
                       deltak = 0.
                       deltaq = 0.
                       qrefint = 0.
                       do k=klzb,kx
! deltaq = a positive quantity (since int qdel is positive).  It's how 
! much q_ref must be changed by, in an integrated sense.  The requisite 
! change in qdel is this without the factors of tau_bm and dt.
                          deltaq = deltaq - qdel(i,j,k)*tau_bm/dt* &
                                    (phalf(i,j,k) - phalf(i,j,k+1))
! deltak = the amount tdel needs to be changed
                          deltak  = deltak  + tdel(i,j,k)* &
                                    (phalf(i,j,k) - phalf(i,j,k+1))
! qrefint = integrated value of qref
                          qrefint = qrefint - q_ref(i,j,k)* &
                                    (phalf(i,j,k) - phalf(i,j,k+1))
                       end do
! Normalize deltak by total pressure.
                       deltak  = deltak /(phalf(i,j,kx+1) - phalf(i,j,klzb))
! multiplying factor for q_ref is 1 + the ratio
                       deltaqfrac = 1. - deltaq/qrefint
! multiplying factor for qdel adds dt/tau_bm
                       deltaqfrac2 = - deltaq/qrefint*dt/tau_bm
! let's check that the precip really is zero as in the shallower scheme
                       precip(i,j) = 0.0
                       do k=klzb,kx
                          qdel(i,j,k) = qdel(i,j,k) + deltaqfrac2*q_ref(i,j,k)
                          q_ref(i,j,k) = deltaqfrac*q_ref(i,j,k)
                          tdel(i,j,k) = tdel(i,j,k) + deltak
                          t_ref(i,j,k) = t_ref(i,j,k) + deltak*tau_bm/dt
                          precip(i,j) = precip(i,j) + qdel(i,j,k)* &
                                 (phalf(i,j,k) - phalf(i,j,k+1))/grav
                       end do
                       if (abs(precip(i,j)).gt.1.e-5) &
                         write(6,*) 'doh! precip.ne.0)'
                    else
                       precip(i,j) = 0.
                       tdel(i,j,:) = 0.
                       qdel(i,j,:) = 0.
                    end if
                end if
             else 
                tdel(i,j,:) = 0.0
                qdel(i,j,:) = 0.0
                precip(i,j) = 0.0
                q_ref(i,j,:) = qin(i,j,:)
                t_ref(i,j,:) = tin(i,j,:)
             end if
          end do
       end do

       rain = precip
       snow = 0.
   

!-----------------------------------------------------------------------

   end subroutine bm_massflux

!#######################################################################

    subroutine capecalc(cpd, cpv, epsilo, nlev, pback, rback, rd, rl, rv, &
                        tback, xcape, cin, tot, tpcback, rpcback,         &
                        klclback, klzbback)
!
! modif omp: klcl is an additional output

!      Calculates convective available potential energy for a cloud whose
!      temperature follows a saturated adiabat.
!
!      On Input
!
!      cpd     specific heat of dry air at constant pressure (J/(kg K))
!      cpv     specific heat of water vapor
!      epsilo  ratio of molecular weights of water vapor to dry air
!      nlev    number of levels 
!      p       pressure (Pa)
!              Index 1 refers to level nearest earth's surface.
!      r       mixing ratio (kg(H2O)/kg)
!              Index 1 refers to level nearest earth's surface.
!      rd      gas constant for dry air (J/(kg K))
!      rl      latent heat of vaporization (J/kg)
!      rv      gas constant for water vapor (J/(kg K))
!      t       temperature (K)
!              Index 1 refers to level nearest earth's surface.
!
!     Output:
!   
!     tpc      parcel temperature (K)
!              Set to environment below istart.
!              Index 1 refers to level nearest earth's surface.
!     rpc      parcel mixing ratio (kg(H2O)/kg)
!              Set to environment below istart.
!              Index 1 refers to level nearest earth's surface.
!     cin      convective inhibition (J/kg)
!              energy required to lift parcel from level istart to
!              level of free convection
!     xcape    convective available potential energy (J/kg)
!              energy released as parcel moves from level of free
!              convection to level of zero buoyancy
!     tot      xcape+cin (J/kg)
!     klcl     first level above the LCL
!     klzb     the level where you hit LZB
!
!     For definitions of cin and xcape, see notes (4 Apr 95) (LAN Notes).
!
        implicit none
        integer, intent(in) :: nlev
        REAL, INTENT (IN),    DIMENSION(:) :: pback, tback, rback
        real, intent (in) :: cpd, cpv, epsilo, rd, rl, rv
        integer, intent(out) :: klzbback, klclback
        real, intent (out) :: xcape, cin, tot
        real, intent (out), dimension(nlev) :: tpcback, rpcback

      integer :: istart, ieq, klcl, k, klzb, klfc, ieqa, nlevm
      logical :: capepos
      real, dimension(nlev) :: p, r, t, tpc, rpc
      real :: ro, tc, tp, plcl, es, rs, rlcl, tlcl, pb, tb, rb, q, cp, dp, &
              dt1, plzb, qe, tve, pc, qs, tv, rc, fact1, fact2, fact3, &
              dtdp, rbc, rbe, qc, tvc, delt

!modif omp
      real :: rsb, tplcl

!      parameter(nlev=25,nlevm=nlev-1)
!      dimension t(nlev),r(nlev),p(nlev)
!      dimension tpc(nlev),rpc(nlev)
!      logical capepos
!
      capepos=.false.
      nlevm = nlev-1

     do k=1,nlev
        t(k) = tback(nlev+1-k)
        r(k) = rback(nlev+1-k)
        p(k) = pback(nlev+1-k)
        tpc(k) = t(k)
        rpc(k) = r(k)
     end do

!
!     Calculate LCL
!     istart-index of level whose mixing ratio is conserved as a parcel 
!            leaves it undergoing dry adiabatic ascent
!
      istart=1
      ro=r(istart)
      tc=t(istart)
      tp=tc
      plcl=0.
      do k=1,istart
        tpc(k)=t(k)
        rpc(k)=r(k)
      end do
      do k=istart,nlev
        call establ(es,tp)
        rs=epsilo*es/(p(k)+(epsilo-1.)*es)
!       write(6,*) 'k,tp,rs= ',k,tp,rs
        ieq=iequ(rs,ro)
        if (ieq .eq. 0) then
          plcl=p(k)
          rlcl=r(k)
          tlcl=t(k)
          klcl=k
          go to 11
        end if
        if (k .eq. istart) then
           if (ieq .lt. 0) then
              plcl=p(istart)
              tlcl=t(istart)
              rlcl=r(istart)
! omp: try this before, did not change much. 
! (The lowest level should not be supersaturated.)
!             rlcl=rs
              klcl=istart
              go to 11
           else
              go to 13
           end if
        end if
        if (k .gt. 1) then
           pb=(p(k)+p(k-1))/2.
           tb=(t(k)+t(k-1))/2.
           rb=(r(k)+r(k-1))/2.
           if (rs .lt. ro) then

              fact1 = (ro - rs)/(rsb-rs)
              fact2 = (rsb - ro)/(rsb-rs)
             plcl=fact1* p(k-1) + fact2 * p(k) 
             tlcl=fact1* t(k-1) + fact2 * t(k) 
             rlcl=rb
             tplcl = fact1* tpc(k-1) + fact2 * tpc(k) 
             klcl=k
             go to 11
           end if
        end if
        if (k .eq. nlev) go to 11

!     Convert mixing ratio to specific humidity.
!
 13   continue
         q=ro/(1.+ro)
         cp=cpd*(1.+((cpv/cpd)-1.)*q)
         dp=p(k+1)-p(k)
         dtdp=rd*tp/cp
!        write(6,*) 'dp,dtdp,pb= ',dp,dtdp,pb
         dt1=dtdp*alog((p(k)+dp)/p(k))
         tp=tp+dt1
         tpc(k+1)=tp
         rpc(k+1)=ro
         rsb = rs
      end do
 11   continue
      ieq=iequ(plcl,0.)
      if (ieq .eq. 0) then
         xcape = 0.
         cin = 0.
         tot = 0.
         tpcback = tback
         rpcback = rback
!        write(6,*) 'plcl=0'
!         stop
         call error_mesg ('bm_massflux:capecalc', 'ieq = 0', FATAL)
      end if
!
!     Calculate temperature along saturated adiabat, starting at p(kLCL).
!
!       write(6,*) 'plcl,klcl,tlcl,rlcl= ',plcl,klcl,tlcl,rlcl
!       write(6,*) 'p(klcl)= ',p(klcl)

!modif omp: first find saturated temp at level klcl
!           In the previous version, the parcel temperature
!           was obtained from a dry adiabat ascent all the way
!           to the level k. 




      tc = tplcl
      call establ(es,tc)
      pc = plcl
      rs=epsilo*es/(pc+(epsilo-1.)*es)
      qs=rs/(1.+rs)
      tv=tc*(1.+.61*qs)
      dp=p(klcl)-plcl
      rc=(1.-qs)*rd+qs*rv
!        write(6,*) 'tv= ',tv
      pb=(p(klcl)+plcl)/2.
      fact1=rd/cpd
      fact2=tv+(rl*qs/rc)
!         write(6,*) 'fact1,fact2,rc= ',fact1,fact2,rc
      fact1=fact1*fact2
      fact3=epsilo*(rl**2)*es/(cpd*pb*rv*(tv**2))
!        write(6,*) 'fact1,fact3= ',fact1,fact3
      fact3=1.+fact3
      dtdp=fact1/fact3
!         write(6,*) 'dtdp= ',dtdp
      tc=tc+dtdp*alog((pc+dp)/pc)
!         write(6,*) 'tc,t= ',tc,t(k+1)
      tpc(klcl)=tc
      rpc(klcl)=rs
!         write(6,*) 'p,r,rs= ',p(k+1),r(k+1),rs

!       tc=tpc(klcl)
!end modif omp


! omp note: the adiabat is computed by a forward integeration of the
! lapse rate. Thiscould be improved at coarse resolution by implementing 
! a 2nd or 3rd order Runge-Kunta scheme.

       plzb=0.
       do k=klcl,nlevm
          qe=r(k)/(1.+r(k))
          tve=t(k)*(1.+.61*qe)
          call establ(es,tc)
          pc=p(k)
          rs=epsilo*es/(pc+(epsilo-1.)*es)
          qs=rs/(1.+rs)
          tv=tc*(1.+.61*qs)
!          write(6,*) 'k,tv,tve= ',k,tv,tve
          ieq=iequ(tv,tve)
          if ((ieq .gt. 0) .and. (.not. capepos)) then
             capepos=.true.
          end if
          if ((ieq .lt. 0) .and. (capepos)) then
             klzb=k
             plzb=(p(k)+p(k-1))/2.
!             write(6,*) 'klzb,plzb,p(klzb)= ',klzb,plzb,p(klzb)
             go to 12
          end if
          dp=p(k+1)-p(k)
          rc=(1.-qs)*rd+qs*rv
!           write(6,*) 'tv= ',tv
          pb=(p(k)+p(k+1))/2.
          fact1=rd/cpd
          fact2=tv+(rl*qs/rc)
!          write(6,*) 'fact1,fact2,rc= ',fact1,fact2,rc
          fact1=fact1*fact2
          fact3=epsilo*(rl**2)*es/(cpd*pb*rv*(tv**2))
!          write(6,*) 'fact1,fact3= ',fact1,fact3
          fact3=1.+fact3
          dtdp=fact1/fact3
!          write(6,*) 'dtdp= ',dtdp
          tc=tc+dtdp*alog((pc+dp)/pc)
!          write(6,*) 'tc,t= ',tc,t(k+1)
          tpc(k+1)=tc
          rpc(k+1)=rs
!          write(6,*) 'p,r,rs= ',p(k+1),r(k+1),rs
       end do
 12    continue
      ieq=iequ(plzb,0.)
      if (ieq .eq. 0) then
         xcape = 0.
         cin = 0.
         tot = 0.
         tpcback = tback
         rpcback = rback
!         write(6,*) 'plzb=0'
         return
      end if
      cin=0.
      xcape=0.
      tot=0.
!
!     Calculate convective inhibition.
!
       klfc=0
       do k=istart,nlevm
          ieq=iequ(p(k),plzb)
          if (ieq .le. 0) then
!             write(6,*) 'cin= ',cin
!            write(6,*) 'cape = 0 NO LFC'
             return 
          end if
          rbc=(rpc(k)+rpc(k+1))/2.
          rbe=(r(k)+r(k+1))/2.
          qc=rbc/(1.+rbc)
          qe=rbe/(1.+rbe)
          tvc=tpc(k)*(1.+.61*qc)
          tve=t(k)*(1.+.61*qe)
!          write(6,*) 'k,tvc,tve= ',k,tvc,tve
          ieq=iequ(tvc,tve)
          ieqa=iequ(p(k),plcl)
          if ((ieq .le. 0) .or. (ieqa .ge. 0)) then
             delt=rd*(tvc-tve)*alog(p(k)/p(k+1))
             cin=cin-delt
          else
             klfc=k
             go to 14
          end if
       end do
 14    continue
!
!      Calculate convective available potential energy.
!
!       write(6,*) 'klfc,p(klfc)= ',klfc,p(klfc)
!
! omp note: CAPE is calculated using full levels. This can create a
! significant amount of flickering, espcially when the LCL and LZB
! switch from one model level to another. 
!
       if (klfc .eq. 0) then
          xcape=0.
!          write(6,*) 'klfc=0'
          return
       end if
       do k=klfc,klzb
          ieq=iequ(p(k+1),plzb)
          if (ieq .ge. 0) then
             rbc=(rpc(k)+rpc(k+1))/2.
             rbe=(r(k)+r(k+1))/2.
             qc=rbc/(1.+rbc)
             qe=rbe/(1.+rbe)
             tvc=tpc(k)*(1.+.61*qc)
             tve=t(k)*(1.+.61*qe)
             ieq=iequ(tvc,tve)
             if (ieq .gt. 0) then
                delt=rd*(tvc-tve)*alog(p(k)/p(k+1))
!                write(6,*) 'cape k,delt,xcape= ',k,delt,xcape
                xcape=xcape+delt
                if (xcape .lt. 0.) then
!                   write(6,*) 'xcape error'
                    call error_mesg ('bm_massflux:capecalc', &
                                     'xcape error', FATAL)
!                   stop
                end if
              end if
          end if
       end do
       tot=xcape-cin
!       write(6,*) 'cin= ',cin,' J/kg'
!       write(6,*) 'xcape= ',xcape,' J/kg'
!       write(6,*) 'tot= ',tot,' J/kg'
       do k=1,nlev
          tpcback(k) = tpc(nlev+1-k)
          rpcback(k) = rpc(nlev+1-k)
       end do
       klzbback = nlev + 1 - klzb
      klclback = nlev + 1 - klcl

       return
       end subroutine capecalc

!###############################################################
!all new cape calculation.

      subroutine capecalcnew(kx,p,phalf,cp_air,rdgas,rvgas,hlv,kappa,tin,rin,&
                             avgbl,cape,cin,tp,rp,klzb,klcl)

!
!    Input:
!
!    kx          number of levels
!    p           pressure (index 1 refers to TOA, index kx refers to surface)
!    phalf       pressure at half levels
!    cp_air      specific heat of dry air
!    rdgas       gas constant for dry air
!    rvgas       gas constant for water vapor (used in Clausius-Clapeyron, 
!                not for virtual temperature effects, which are not considered)
!    hlv         latent heat of vaporization
!    kappa       the constant kappa
!    tin         temperature of the environment
!    rin         specific humidity of the environment
!    avgbl       if true, the parcel is averaged in theta and r up to its LCL
!
!    Output:
!    cape        Convective available potential energy
!    cin         Convective inhibition (if there's no LFC, then this is set 
!                to zero)
!    tp          Parcel temperature (set to the environmental temperature 
!                where no adjustment)
!    rp          Parcel specific humidity (set to the environmental humidity 
!                where no adjustment, and set to the saturation humidity at 
!                the parcel temperature below the LCL)
!    klzb        Level of zero buoyancy
!    klcl        Lifting condensation level
!
!    Algorithm: 
!    Start with surface parcel. 
!    Calculate the lifting condensation level (uses an analytic formula and a 
!       lookup table).  
!    Average under the LCL if desired, if this is done, then a new LCL must
!       be calculated.  
!    Calculate parcel ascent up to LZB.
!    Calculate CAPE and CIN.  
      implicit none
      integer, intent(in)                    :: kx
      logical, intent(in)                    :: avgbl
      real, intent(in), dimension(:)         :: p, phalf, tin, rin
      real, intent(in)                       :: rdgas, rvgas, hlv, kappa, cp_air
      integer, intent(out)                   :: klzb, klcl
      real, intent(out), dimension(:)        :: tp, rp
      real, intent(out)                      :: cape, cin

      integer            :: k, klfc, klcl2
      logical            :: nocape
      real, dimension(kx)   :: theta
      real                  :: t0, r0, es, rs, theta0, pstar, value, tlcl, &
                               a, b, dtdlnp, thetam, rm, tlcl2, &
                               plcl2, plcl, plzb

      pstar = 1.e5

      nocape = .true.
      cape = 0.
      cin = 0.
      plcl = 0.
      plzb = 0.
      klfc = 0
      klcl = 0
      klzb = 0
      tp(1:kx) = tin(1:kx)
      rp(1:kx) = rin(1:kx)

! start with surface parcel
      t0 = tin(kx)
      r0 = rin(kx)
! calculate the lifting condensation level by the following:
! are you saturated to begin with?  
!      call establ(es,t0)
      call escomp(t0,es)
      rs = rdgas/rvgas*es/p(kx)
      if (r0.ge.rs) then
! if youčre already saturated, set lcl to be the surface value.
         plcl = p(kx)
! the first level where youčre completely saturated.
         klcl = kx
! saturate out to get the parcel temp and humidity at this level
! first order (in delta T) accurate expression for change in temp
         tp(kx) = t0 + (r0 - rs)/(cp_air/hlv + hlv*rs/rvgas/t0**2.)
!         call establ(es,tp(kx))
         call escomp(tp(kx),es)
         rp(kx) = rdgas/rvgas*es/p(kx)
      else
! if not saturated to begin with, use the analytic expression to calculate the 
! exact pressure and temperature where youčre saturated.  
         theta0 = tin(kx)*(pstar/p(kx))**kappa
! the expression that we utilize is log(r/theta**(1/kappa)*pstar*rvgas/rdgas) =
! log(es/T**(1/kappa))
! The right hand side of this is only a function of temperature, therefore 
! this is put into a lookup table to solve for temperature.  
         if (r0.gt.0.) then
            value = log(theta0**(-1/kappa)*r0*pstar*rvgas/rdgas)
            call lcltabl(value,tlcl)
            plcl = pstar*(tlcl/theta0)**(1/kappa)
! just in case plcl is very high up
            if (plcl.lt.p(1)) then
               plcl = p(1)
               tlcl = theta0*(plcl/pstar)**kappa
               write (*,*) 'hi lcl'
            end if
            k = kx
         else
! if the parcel sp hum is zero or negative, set lcl to 2nd to top level
            plcl = p(2)
            tlcl = theta0*(plcl/pstar)**kappa
!            write (*,*) 'zero r0', r0
            do k=2,kx
               tp(k) = theta0*(p(k)/pstar)**kappa
               rp(k) = 0.
! this definition of CIN contains everything below the LCL
               cin = cin + rdgas*(tin(k) - tp(k))*log(phalf(k+1)/phalf(k))
            end do
            go to 11
         end if
! calculate the parcel temperature (adiabatic ascent) below the LCL.  
! the mixing ratio stays the same
!!! the right command??
         do while (p(k).gt.plcl)
            tp(k) = theta0*(p(k)/pstar)**kappa
!            call establ(es,tp(k))
            call escomp(tp(k),es)
            rp(k) = rdgas/rvgas*es/p(k)
! this definition of CIN contains everything below the LCL
            cin = cin + rdgas*(tin(k) - tp(k))*log(phalf(k+1)/phalf(k))
            k = k-1
         end do
! first level where you're saturated at the level
         klcl = k
         if (klcl.eq.1) klcl = 2
! do a saturated ascent to get the parcel temp at the LCL.  
! use your 2nd order equation up to the pressure above.  
! moist adaibat derivatives: (use the lcl values for temp, humid, and 
! pressure)
         a = kappa*tlcl + hlv/cp_air*r0
         b = hlv**2.*r0/cp_air/rvgas/tlcl**2.
         dtdlnp = a/(1. + b)
! first order in p
!         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl)
! second order in p (RK2)
! first get temp halfway up 
         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl)/2.
         if ((tp(klcl).lt.173.16).and.nocape) go to 11
         call escomp(tp(klcl),es)
         rp(klcl) = rdgas/rvgas*es/(p(klcl) + plcl)*2.
         a = kappa*tp(klcl) + hlv/cp_air*rp(klcl)
         b = hlv**2./cp_air/rvgas*rp(klcl)/tp(klcl)**2.
         dtdlnp = a/(1. + b)
! second half of RK2
         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl)
!         d2tdlnp2 = (kappa + b - 1. - b/tlcl*(hlv/rvgas/tlcl - &
!                   2.)*dtdlnp)/ (1. + b)*dtdlnp - hlv*r0/cp_air/ &
!                   (1. + b)
! second order in p
!         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl) + .5*d2tdlnp2*(log(&
!             p(klcl)/plcl))**2.
!         call establ(es,tp(klcl))
         call escomp(tp(klcl),es)
         rp(klcl) = rdgas/rvgas*es/p(klcl)
!         write (*,*) 'tp, rp klcl:kx, new', tp(klcl:kx), rp(klcl:kx)
! CAPE/CIN stuff
         if ((tp(klcl).lt.tin(klcl)).and.nocape) then
! if youčre not yet buoyant, then add to the CIN and continue
            cin = cin + rdgas*(tin(klcl) - &
                 tp(klcl))*log(phalf(klcl+1)/phalf(klcl))
         else
! if youčre buoyant, then add to cape
            cape = cape + rdgas*(tp(klcl) - &
                  tin(klcl))*log(phalf(klcl+1)/phalf(klcl))
! if itčs the first time buoyant, then set the level of free convection to k
            if (nocape) then
               nocape = .false.
               klfc = klcl
            endif
         end if
      end if
! then average the properties over the boundary layer if so desired.  to give 
! a new "parcel".  this may not be saturated at the LCL, so make sure you get 
! to a level where it is before moist adiabatic ascent!
!!!! take out all the below (between the exclamation points) if no avgbl !!!!
      if (avgbl) then
         theta(klcl:kx) = tin(klcl:kx)*(pstar/p(klcl:kx))**kappa
         thetam = 0.
         rm = 0.
         do k=klcl,kx
            thetam = thetam + theta(k)*(phalf(k+1) - phalf(k))
            rm = rm + rin(k)*(phalf(k+1) - phalf(k))
         end do
         thetam = thetam/(phalf(kx+1) - phalf(klcl))
         rm = rm/(phalf(kx+1) - phalf(klcl))
! check if youčre saturated at the top level.  if not, then get a new LCL
         tp(klcl) = thetam*(p(klcl)/pstar)**kappa
!         call establ(es,tp(klcl))
         call escomp(tp(klcl),es)
         rs = rdgas/rvgas*es/p(klcl)
! if youčre not saturated, get a new LCL
         if (rm.lt.rs) then
! reset CIN to zero.  
            cin = 0.
! again, use the analytic expression to calculate the exact pressure and 
! temperature where youčre saturated.  
! the expression that we utilize is log(r/theta**(1/kappa)*pstar*rvgas/rdgas)=
! log(es/T**(1/kappa))
! The right hand side of this is only a function of temperature, therefore 
! this is put into a lookup table to solve for temperature.  
            value = log(thetam**(-1/kappa)*rm*pstar*rvgas/rdgas)
            call lcltabl(value,tlcl2)
            plcl2 = pstar*(tlcl2/thetam)**(1/kappa)
! just in case plcl is very high up
            if (plcl2.lt.p(1)) then
               plcl2 = p(1)
            end if
            k = kx
! calculate the parcel temperature (adiabatic ascent) below the LCL.  
! the mixing ratio stays the same
!!! the right command??
            do while (p(k).gt.plcl2) 
               tp(k) = thetam*(p(k)/pstar)**kappa
!               call establ(es,tp(k))
               call escomp(tp(k),es)
               rp(k) = rdgas/rvgas*es/p(k)
! this definition of CIN contains everything below the LCL
               cin = cin + rdgas*(tin(k) - tp(k))*log(phalf(k+1)/phalf(k))
               k = k-1
            end do
! first level where you're saturated at the level
            klcl2 = k
            if(klcl2.eq.1) klcl2 = 2
! do a saturated ascent to get the parcel temp at the LCL.  
! use your 2nd order equation up to the pressure above.  
! moist adaibat derivatives: (use the lcl values for temp, humid, and 
! pressure)
            a = kappa*tlcl2 + hlv/cp_air*rm
            b = hlv**2.*rm/cp_air/rvgas/tlcl2**2.
            dtdlnp = a/(1. + b)
! first order in p
!            tp(klcl2) = tlcl2 + dtdlnp*log(p(klcl2)/plcl2)
! second order in p (RK2)
! first get temp halfway up 
         tp(klcl2) = tlcl2 + dtdlnp*log(p(klcl2)/plcl2)/2.
         if ((tp(klcl2).lt.173.16).and.nocape) go to 11
         call escomp(tp(klcl2),es)
         rp(klcl2) = rdgas/rvgas*es/(p(klcl2) + plcl2)*2.
         a = kappa*tp(klcl2) + hlv/cp_air*rp(klcl2)
         b = hlv**2./cp_air/rvgas*rp(klcl2)/tp(klcl2)**2.
         dtdlnp = a/(1. + b)
! second half of RK2
         tp(klcl2) = tlcl2 + dtdlnp*log(p(klcl2)/plcl2)
!            d2tdlnp2 = (kappa + b - 1. - b/tlcl2*(hlv/rvgas/tlcl2 - &
!                          2.)*dtdlnp)/ (1. + b)*dtdlnp - hlv*rm/cp_air/ &
!                          (1. + b)
! second order in p
!            tp(klcl2) = tlcl2 + dtdlnp*log(p(klcl2)/plcl2) + &
!               .5*d2tdlnp2*(log(p(klcl2)/plcl2))**2.
!            call establ(es,tp(klcl2))
            call escomp(tp(klcl2),es)
            rp(klcl2) = rdgas/rvgas*es/p(klcl2)
! CAPE/CIN stuff
            if ((tp(klcl2).lt.tin(klcl2)).and.nocape) then
! if youčre not yet buoyant, then add to the CIN and continue
               cin = cin + rdgas*(tin(klcl2) - &
                    tp(klcl2))*log(phalf(klcl2+1)/phalf(klcl2))
            else
! if youčre buoyant, then add to cape
               cape = cape + rdgas*(tp(klcl) - &
                     tin(klcl))*log(phalf(klcl+1)/phalf(klcl))
! if itčs the first time buoyant, then set the level of free convection to k
               if (nocape) then
                  nocape = .false.
                  klfc = klcl2
               endif
            end if
         end if
      end if
!!!! take out all of the above (within the exclamations) if no avgbl !!!!
! then, start at the LCL, and do moist adiabatic ascent by the first order 
! scheme -- 2nd order as well
      do k=klcl-1,1,-1
         a = kappa*tp(k+1) + hlv/cp_air*rp(k+1)
         b = hlv**2./cp_air/rvgas*rp(k+1)/tp(k+1)**2.
         dtdlnp = a/(1. + b)
! first order in p
!         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1))
! second order in p (RK2)
! first get temp halfway up 
         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1))/2.
         if ((tp(k).lt.173.16).and.nocape) go to 11
         call escomp(tp(k),es)
         rp(k) = rdgas/rvgas*es/(p(k) + p(k+1))*2.
         a = kappa*tp(k) + hlv/cp_air*rp(k)
         b = hlv**2./cp_air/rvgas*rp(k)/tp(k)**2.
         dtdlnp = a/(1. + b)
! second half of RK2
         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1))
!         d2tdlnp2 = (kappa + b - 1. - b/tp(k+1)*(hlv/rvgas/tp(k+1) - & 
!               2.)*dtdlnp)/(1. + b)*dtdlnp - hlv/cp_air*rp(k+1)/(1. + b)
! second order in p
!         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1)) + .5*d2tdlnp2*(log( &
!             p(k)/p(k+1)))**2.
! if you're below the lookup table value, just presume that there's no way 
! you could have cape and call it quits
         if ((tp(k).lt.173.16).and.nocape) go to 11
!         call establ(es,tp(k))
         call escomp(tp(k),es)
         rp(k) = rdgas/rvgas*es/p(k)
         if ((tp(k).lt.tin(k)).and.nocape) then
! if youčre not yet buoyant, then add to the CIN and continue
            cin = cin + rdgas*(tin(k) - tp(k))*log(phalf(k+1)/phalf(k))
         elseif((tp(k).lt.tin(k)).and.(.not.nocape)) then
! if you have CAPE, and itčs your first time being negatively buoyant, 
! then set the level of zero buoyancy to k+1, and stop the moist ascent
            klzb = k+1
            go to 11
         else
! if youčre buoyant, then add to cape
            cape = cape + rdgas*(tp(k) - tin(k))*log(phalf(k+1)/phalf(k))
! if itčs the first time buoyant, then set the level of free convection to k
            if (nocape) then
               nocape = .false.
               klfc = k
            endif
         end if
      end do
 11   if(nocape) then 
! this is if you made it through without having a LZB
! set LZB to be the top level.
         plzb = p(1)
         klzb = 0
         klfc = 0
         cin = 0.
         tp(1:kx) = tin(1:kx)
         rp(1:kx) = rin(1:kx)
      end if
!      write (*,*) 'plcl, klcl, tlcl, r0 new', plcl, klcl, tlcl, r0
!      write (*,*) 'tp, rp new', tp, rp
!       write (*,*) 'tp, new', tp
!       write (*,*) 'tin new', tin 
!       write (*,*) 'klcl, klfc, klzb new', klcl, klfc, klzb
      end subroutine capecalcnew

! lookup table with e_s(T) using the new analytic expression
      subroutine establ2(es,t)
      

! Table of es values as a function of temperature.  
! Uses the analytic expression for e_s which assumes fixed latent heat 
!    coefficient.  
! Gives the values from -100 to 60 Celsius in 1 degree increments.  

      implicit none 
      real, intent(in)     :: t
      real, intent(out)    :: es

      integer              :: it
      real, dimension(161) :: table
      real                 :: t1, t2

      data table / 6.4876769e-03,   7.7642650e-03,   9.2730105e-03, & ! XXX Too many continuation lines 
       1.1052629e-02,   1.3147696e-02,   1.5609446e-02,   1.8496657e-02,   2.1876647e-02,   2.5826384e-02,   3.0433719e-02, &
       3.5798760e-02,   4.2035399e-02,   4.9272997e-02,   5.7658264e-02,   6.7357319e-02,   7.8557979e-02,   9.1472273e-02, &
       1.0633921e-01,   1.2342784e-01,   1.4304057e-01,   1.6551683e-01,   1.9123713e-01,   2.2062738e-01,   2.5416374e-01, &
       2.9237778e-01,   3.3586224e-01,   3.8527718e-01,   4.4135673e-01,   5.0491638e-01,   5.7686092e-01,   6.5819298e-01, &
       7.5002239e-01,   8.5357615e-01,   9.7020925e-01,   1.1014164e+00,   1.2488446e+00,   1.4143067e+00,   1.5997959e+00, &
       1.8075013e+00,   2.0398249e+00,   2.2993996e+00,   2.5891082e+00,   2.9121041e+00,   3.2718336e+00,   3.6720588e+00, &
       4.1168837e+00,   4.6107798e+00,   5.1586157e+00,   5.7656865e+00,   6.4377468e+00,   7.1810447e+00,   8.0023579e+00, &
       8.9090329e+00,   9.9090255e+00,   1.1010944e+01,   1.2224096e+01,   1.3558536e+01,   1.5025116e+01,   1.6635542e+01, &
       1.8402429e+01,   2.0339361e+01,   2.2460955e+01,   2.4782931e+01,   2.7322176e+01,   3.0096824e+01,   3.3126327e+01, &
       3.6431545e+01,   4.0034823e+01,   4.3960087e+01,   4.8232935e+01,   5.2880735e+01,   5.7932732e+01,   6.3420149e+01, &
       6.9376307e+01,   7.5836738e+01,   8.2839310e+01,   9.0424352e+01,   9.8634795e+01,   1.0751630e+02,   1.1711742e+02, &
       1.2748974e+02,   1.3868802e+02,   1.5077039e+02,   1.6379851e+02,   1.7783773e+02,   1.9295728e+02,   2.0923048e+02, &
       2.2673493e+02,   2.4555268e+02,   2.6577049e+02,   2.8748004e+02,   3.1077813e+02,   3.3576694e+02,   3.6255429e+02, &
       3.9125382e+02,   4.2198536e+02,   4.5487511e+02,   4.9005594e+02,   5.2766770e+02,   5.6785749e+02,   6.1078000e+02, &
       6.5659776e+02,   7.0548154e+02,   7.5761062e+02,   8.1317317e+02,   8.7236659e+02,   9.3539788e+02,   1.0024840e+03, &
       1.0738523e+03,   1.1497408e+03,   1.2303987e+03,   1.3160868e+03,   1.4070779e+03,   1.5036572e+03,   1.6061228e+03, &
       1.7147860e+03,   1.8299721e+03,   1.9520206e+03,   2.0812857e+03,   2.2181372e+03,   2.3629602e+03,   2.5161565e+03, &
       2.6781448e+03,   2.8493609e+03,   3.0302589e+03,   3.2213112e+03,   3.4230097e+03,   3.6358656e+03,   3.8604109e+03, &
       4.0971982e+03,   4.3468019e+03,   4.6098188e+03,   4.8868684e+03,   5.1785938e+03,   5.4856626e+03,   5.8087673e+03, &
       6.1486259e+03,   6.5059830e+03,   6.8816104e+03,   7.2763077e+03,   7.6909031e+03,   8.1262545e+03,   8.5832496e+03, &
       9.0628075e+03,   9.5658788e+03,   1.0093447e+04,   1.0646529e+04,   1.1226176e+04,   1.1833474e+04,   1.2469546e+04, &
       1.3135552e+04,   1.3832687e+04,   1.4562188e+04,   1.5325331e+04,   1.6123432e+04,   1.6957848e+04,   1.7829980e+04, &
       1.8741270e+04,   1.9693207e+04,   2.0687323e+04,   2.1725199e+04 /

      t1 = t
      if (t.lt.173.16) t1 = 173.16
      if (t.gt.333.16) t1 = 333.16
      it = floor(t1 - 173.16)
      t2 = 173.16 + it
      es = (t2 + 1.0 - t1)*table(it+1) + (t1 - t2)*table(it+2)
      end subroutine establ2

! lookup table for the analytic evaluation of LCL
      subroutine lcltabl(value,tlcl)
!
! Table of values used to compute the temperature of the lifting condensation
! level.  
! 
! the expression that we utilize is log(r/theta**(1/kappa)*pstar*rvgas/rdgas) = 
! log(es/T**(1/kappa))
! 
! Gives the values of the temperature for the following range: 
!   starts with -23, is uniformly distributed up to -10.4.  There are a 
! total of 127 values, and the increment is .1.  
!
      implicit none 
      real, intent(in)     :: value
      real, intent(out)    :: tlcl

      integer              :: ival
      real, dimension(127) :: lcltable
      real                 :: v1, v2

      data lcltable/  1.7364512e+02,   1.7427449e+02,   1.7490874e+02, &
      1.7554791e+02,   1.7619208e+02,   1.7684130e+02,   1.7749563e+02, &
      1.7815514e+02,   1.7881989e+02,   1.7948995e+02,   1.8016539e+02, &
      1.8084626e+02,   1.8153265e+02,   1.8222461e+02,   1.8292223e+02, &
      1.8362557e+02,   1.8433471e+02,   1.8504972e+02,   1.8577068e+02, &
      1.8649767e+02,   1.8723077e+02,   1.8797006e+02,   1.8871561e+02, &
      1.8946752e+02,   1.9022587e+02,   1.9099074e+02,   1.9176222e+02, &
      1.9254042e+02,   1.9332540e+02,   1.9411728e+02,   1.9491614e+02, &
      1.9572209e+02,   1.9653521e+02,   1.9735562e+02,   1.9818341e+02, &
      1.9901870e+02,   1.9986158e+02,   2.0071216e+02,   2.0157057e+02, &
      2.0243690e+02,   2.0331128e+02,   2.0419383e+02,   2.0508466e+02, &
      2.0598391e+02,   2.0689168e+02,   2.0780812e+02,   2.0873335e+02, &
      2.0966751e+02,   2.1061074e+02,   2.1156316e+02,   2.1252493e+02, &
      2.1349619e+02,   2.1447709e+02,   2.1546778e+02,   2.1646842e+02, &
      2.1747916e+02,   2.1850016e+02,   2.1953160e+02,   2.2057364e+02, &
      2.2162645e+02,   2.2269022e+02,   2.2376511e+02,   2.2485133e+02, &
      2.2594905e+02,   2.2705847e+02,   2.2817979e+02,   2.2931322e+02, &
      2.3045895e+02,   2.3161721e+02,   2.3278821e+02,   2.3397218e+02, &
      2.3516935e+02,   2.3637994e+02,   2.3760420e+02,   2.3884238e+02, &
      2.4009473e+02,   2.4136150e+02,   2.4264297e+02,   2.4393941e+02, &
      2.4525110e+02,   2.4657831e+02,   2.4792136e+02,   2.4928053e+02, &
      2.5065615e+02,   2.5204853e+02,   2.5345799e+02,   2.5488487e+02, &
      2.5632953e+02,   2.5779231e+02,   2.5927358e+02,   2.6077372e+02, &
      2.6229310e+02,   2.6383214e+02,   2.6539124e+02,   2.6697081e+02, &
      2.6857130e+02,   2.7019315e+02,   2.7183682e+02,   2.7350278e+02, &
      2.7519152e+02,   2.7690354e+02,   2.7863937e+02,   2.8039954e+02, &
      2.8218459e+02,   2.8399511e+02,   2.8583167e+02,   2.8769489e+02, &
      2.8958539e+02,   2.9150383e+02,   2.9345086e+02,   2.9542719e+02, &
      2.9743353e+02,   2.9947061e+02,   3.0153922e+02,   3.0364014e+02, &
      3.0577420e+02,   3.0794224e+02,   3.1014515e+02,   3.1238386e+02, &
      3.1465930e+02,   3.1697246e+02,   3.1932437e+02,   3.2171609e+02, &
      3.2414873e+02,   3.2662343e+02,   3.2914139e+02,   3.3170385e+02 /

      v1 = value
      if (value.lt.-23.0) v1 = -23.0
      if (value.gt.-10.4) v1 = -10.4
      ival = floor(10.*(v1 + 23.0))
      v2 = -230. + ival
      v1 = 10.*v1
      tlcl = (v2 + 1.0 - v1)*lcltable(ival+1) + (v1 - v2)*lcltable(ival+2)


      end subroutine lcltabl



!#######################################################################


      SUBROUTINE ESTABL(ES,TP)
!
!   TABLE OF ES FROM -100 TO +60 C IN ONE-DEGREE INCREMENTS(ICE).
!
!   RAT GIVES THE RATIO OF ES(ICE)/ES(LIQUID)
!
!  es refers to liquid above 273, ice below 273
!
!

     implicit none
     real, intent(in)  :: TP
     real, intent(out) :: ES

     integer :: it
     real, dimension(161) :: table
     real :: ft, t2, tp1

!      DIMENSION TABLE(161)

      DATA TABLE/.01403,.01719,.02101,.02561,.03117,.03784, &
      .04584,.05542,.06685,.08049,.09672,.1160,.1388,.1658, &
      .1977,.2353,.2796,.3316,.3925,.4638,.5472,.6444,.7577, &
      .8894,1.042,1.22,1.425,1.622,1.936,2.252,2.615,3.032, &
      3.511,4.06,4.688,5.406,6.225,7.159,8.223,9.432,10.80, &
      12.36,14.13,16.12,18.38,20.92,23.80,27.03,30.67,34.76, &
      39.35,44.49,50.26,56.71,63.93,71.98,80.97,90.98,102.1, &
      114.5,128.3,143.6,160.6,179.4,200.2,223.3,248.8,276.9, &
      307.9,342.1,379.8,421.3,466.9,517.0,572.0,632.3,698.5, &
      770.9,850.2,937.0,1032.0,1146.6,1272.0,1408.1,1556.7, &
      1716.9,1890.3,2077.6,2279.6,2496.7,2729.8,2980.,3247.8, &
      3534.1,3839.8,4164.8,4510.5,4867.9,5265.1,5675.2,6107.8, &
      6566.2,7054.7,7575.3,8129.4,8719.2,9346.5,10013.,10722., &
      11474.,12272.,13119.,14017.,14969.,15977.,17044.,18173., &
      19367.,20630.,21964.,23373.,24861.,26430.,28086.,29831., &
      31671.,33608.,35649.,37796.,40055.,42430.,44927.,47551., &
      50307.,53200.,56236.,59422.,62762.,66264.,69934.,73777., &
      77802.,82015.,86423.,91034.,95855.,100890.,106160., &
      111660.,117400.,123400.,129650.,136170.,142980.,150070., &
      157460.,165160.,173180.,181530.,190220.,199260./ 

!      DATA TABLE/.01403,.01719,.02101,.02561,.03117,.03784,
!     A .04584,.05542,.06685,.08049,.09672,.1160,.1388,.1658,
!     B .1977,.2353,.2796,.3316,.3925,.4638,.5472,.6444,.7577,
!     C .8894,1.042,1.22,1.425,1.622,1.936,2.252,2.615,3.032,
!     D 3.511,4.06,4.688,5.406,6.225,7.159,8.223,9.432,10.80,
!     E 12.36,14.13,16.12,18.38,20.92,23.80,27.03,30.67,34.76,
!     F 39.35,44.49,50.26,56.71,63.93,71.98,80.97,90.98,102.1,
!     G 114.5,128.3,143.6,160.6,179.4,200.2,223.3,248.8,276.9,
!     H 307.9,342.1,379.8,421.3,466.9,517.0,572.0,632.3,698.5,
!     I 770.9,850.2,937.0,1032.0,1146.6,1272.0,1408.1,1556.7,
!     J 1716.9,1890.3,2077.6,2279.6,2496.7,2729.8,2980.,3247.8,
!     K 3534.1,3839.8,4164.8,4510.5,4867.9,5265.1,5675.2,6107.8,
!     L 6566.2,7054.7,7575.3,8129.4,8719.2,9346.5,10013.,10722.,
!     M 11474.,12272.,13119.,14017.,14969.,15977.,17044.,18173.,
!     N 19367.,20630.,21964.,23373.,24861.,26430.,28086.,29831.,
!     O 31671.,33608.,35649.,37796.,40055.,42430.,44927.,47551.,
!     P 50307.,53200.,56236.,59422.,62762.,66264.,69934.,73777.,
!     Q 77802.,82015.,86423.,91034.,95855.,100890.,106160.,
!     R 111660.,117400.,123400.,129650.,136170.,142980.,150070.,
!     S 157460.,165160.,173180.,181530.,190220.,199260./
!
      tp1 = tp
      IF (TP1 .LT. 173.16) GO TO 1
      IF (TP1 .LE. 333.16) GO TO 2
      TP1=333.16
      GO TO 2
 1    TP1=173.16
 2    IT= floor(TP1-173.16)
      FT= IT
      T2=173.16+FT
      ES=(T2+1.0-TP1)*TABLE(IT+1)+(TP1-T2)*TABLE(IT+2)
      ES=ES*.1
!
!     CONVERT FROM ES(LIQUID) TO ES(ICE)
!
!      R1=EXP(28.92-(6142./TP1))
!      R2=EXP(26.27-(5421./TP1))
!      RAT=R1/R2
!                        RAT=1.
!     ES=ES*R1/R2
      RETURN
      END subroutine establ

!#######################################################################


      integer function iequ(x,y)
!
!     Checks for equality of two variable, within a tolerance eps.
!
!     On Input:
!
!        x    first variable
!        y    second variable
!
!     On Output:
!
!        equ  flag, equal to zero if x=y within eps
!                   equal to 10 if x greater than y
!                   equal to -10, if x less than y
!

      real, intent(in) :: x, y
      real :: eps, epsm, d

      iequ=0
      eps=1.e-10
      epsm=-eps
      d=x-y
      if (d .gt. eps) iequ=10
      if (d .lt. epsm) iequ=-10
      return
      end function iequ


!#######################################################################

   subroutine bm_massflux_init ()

!-----------------------------------------------------------------------
!
!        initialization for bm_massflux
!
!-----------------------------------------------------------------------

  integer  unit,io,ierr, logunit

!----------- read namelist ---------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=bm_massflux_nml, iostat=io)
      ierr = check_nml_error(io,"bm_massflux_nml")
#else
      if (file_exist('input.nml')) then
         unit = open_namelist_file ( )
         ierr=1; do while (ierr /= 0)
            read  (unit, nml=bm_massflux_nml, iostat=io, end=10)
            ierr = check_nml_error (io,'bm_massflux_nml')
         enddo
  10     call close_file (unit)
      endif
#endif

!---------- output namelist --------------------------------------------

      call write_version_number(version, tagname)
      if ( mpp_pe() == mpp_root_pe() ) then
           logunit = stdlog()
           write (logunit,nml=bm_massflux_nml)
      endif
      call close_file (unit)

      module_is_initialized =.true.

   end subroutine bm_massflux_init

!#######################################################################

   subroutine bm_massflux_end()
   
      module_is_initialized =.false.
   
   end subroutine bm_massflux_end

!#######################################################################

end module bm_massflux_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The quasi-equilibrium stability functions \label{sec:cmueD}
!
! !INTERFACE:
   subroutine cmue_d(nlev)
!
! !DESCRIPTION:
!
!  This subroutine updates the explicit solution of
!  \eq{bijVertical} and \eq{giVertical} under the same assumptions
!  as those discussed in \sect{sec:cmueC}. Now, however, an additional
!  equilibrium assumption is invoked. With the help of \eq{PeVertical},
!  one can write the equilibrium condition for the TKE as
! \begin{equation}
!  \label{quasiEquilibrium}
!     \dfrac{P+G}{\epsilon} =
!    \hat{c}_\mu(\alpha_M,\alpha_N) \alpha_M
!    - \hat{c}'_\mu(\alpha_M,\alpha_N) \alpha_N = 1
!   \comma
! \end{equation}
! where \eq{alphaIdentities} has been used. This is an implicit relation
! to determine $\alpha_M$ as a function of $\alpha_N$.
! With the definitions given in \sect{sec:cmueC}, it turns out that
! $\alpha_M(\alpha_N)$ is a quadratic polynomial that is easily solved.
! The resulting value for $\alpha_M$ is substituted into the stability
! functions described in \sect{sec:cmueC}. For negative $\alpha_N$
! (convection) the shear number $\alpha_M$ computed in this way may
! become negative. The value of $\alpha_N$ is limited such that this
! does not happen, see \cite{UmlaufBurchard2005a}.
!
! !USES:
   use turbulence, only: an,as,at
   use turbulence, only: cmue1,cmue2
   use turbulence, only: cm0
   use turbulence, only: cc1
   use turbulence, only: ct1,ctt
   use turbulence, only: a1,a2,a3,a4,a5
   use turbulence, only: at1,at2,at3,at4,at5

   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer, intent(in)       :: nlev

! !DEFINED PARAMETERS:
   REALTYPE, parameter       :: anLimitFact = 0.5D0
   REALTYPE, parameter       :: small       = 1.0D-10

!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: cmue_d.F90,v $
!  Revision 20.0  2013/12/14 00:13:31  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1  2005-06-27 10:54:33  kbk
!  new files needed
!
!
!EOP
!-----------------------------------------------------------------------
! !LOCAL VARIABLES:
!
     integer                 ::   i
     REALTYPE                ::   N,Nt
     REALTYPE                ::   d0,d1,d2,d3,d4,d5
     REALTYPE                ::   n0,n1,n2,nt0,nt1,nt2
     REALTYPE                ::   dCm,nCm,nCmp,cm3_inv
     REALTYPE                ::   tmp0,tmp1,tmp2
     REALTYPE                ::   asMax,asMaxNum,asMaxDen
     REALTYPE                ::   anMin,anMinNum,anMinDen
!-----------------------------------------------------------------------
!BOC

     N    =   0.5*cc1
     Nt   =   ct1

     d0   =   36.* N**3. * Nt**2.
     d1   =   84.*a5*at3 * N**2. * Nt  + 36.*at5 * N**3. * Nt
     d2   =   9.*(at2**2.-at1**2.) * N**3. - 12.*(a2**2.-3.*a3**2.) * N * Nt**2.
     d3   =   12.*a5*at3*(a2*at1-3.*a3*at2) * N + 12.*a5*at3*(a3**2.-a2**2.) * Nt       &
            + 12.*at5*(3.*a3**2.-a2**2.) * N * Nt
     d4   =   48.*a5**2.*at3**2. * N + 36.*a5*at3*at5 * N**2.
     d5   =   3.*(a2**2.-3.*a3**2.)*(at1**2.-at2**2.) * N


     n0   =   36.*a1 * N**2. * Nt**2.
     n1   = - 12.*a5*at3*(at1+at2) * N**2. + 8.*a5*at3*(6.*a1-a2-3.*a3) * N * Nt        &
            + 36.*a1*at5 * N**2. * Nt
     n2   =   9.*a1*(at2**2.-at1**2.) * N**2.

     nt0  =   12.*at3 * N**3. * Nt
     nt1  =   12.*a5*at3**2.  * N**2.
     nt2  =   9.*a1*at3*(at1-at2) * N**2. + (  6.*a1*(a2-3.*a3)                         &
            - 4.*(a2**2.-3.*a3**2.) )*at3 * N * Nt

     cm3_inv = 1./cm0**3


 !   mininum value of "an" to insure that "as" > 0 in equilibrium
     anMinNum  = -(d1 + nt0) + sqrt((d1+nt0)**2. - 4.*d0*(d4+nt1))
     anMinDen  = 2.*(d4+nt1)
     anMin     = anMinNum / anMinDen

     if (abs(n2-d5).lt.small) then
!       (special treatment to  avoid a singularity)

        do i=0,nlev

!          clip an at minimum value
           an(i) = max(an(i),anLimitFact*anMin)

!          compute the equilibrium value of as
           tmp0  = -d0 - (d1 + nt0)*an(i) - (d4 + nt1)*an(i)*an(i)
           tmp1  = -d2 + n0 +  (n1-d3-nt2)*an(i)

           as(i) =  - tmp0/tmp1

!          compute stability function
           dCm  = d0  +  d1*an(i) +  d2*as(i) + d3*an(i)*as(i) + d4*an(i)*an(i) + d5*as(i)*as(i)
           nCm  = n0  +  n1*an(i) +  n2*as(i)
           nCmp = nt0 + nt1*an(i) + nt2*as(i)

           cmue1(i) =  cm3_inv*nCm /dCm
           cmue2(i) =  cm3_inv*nCmp/dCm

        end do

     else

        do i=0,nlev

           an(i) = max(an(i),anLimitFact*anMin)

!          compute the equilibrium value of as
           tmp0  = -d0 - (d1 + nt0)*an(i) - (d4 + nt1)*an(i)*an(i)
           tmp1  = -d2 + n0 + (n1-d3-nt2)*an(i)
           tmp2  =  n2-d5

           as(i) =  (-tmp1 + sqrt(tmp1*tmp1-4.*tmp0*tmp2) ) / (2.*tmp2)

!          compute stability function
           dCm  = d0  +  d1*an(i) +  d2*as(i) + d3*an(i)*as(i) + d4*an(i)*an(i) + d5*as(i)*as(i)
           nCm  = n0  +  n1*an(i) +  n2*as(i)
           nCmp = nt0 + nt1*an(i) + nt2*as(i)

           cmue1(i) =  cm3_inv*nCm /dCm
           cmue2(i) =  cm3_inv*nCmp/dCm

        end do

     endif

     return
   end subroutine cmue_d


!-----------------------------------------------------------------------
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module ocean_nphysics_tensor_mod
  !
  !<CONTACT EMAIL="t.leslie@unsw.edu.au"> Tim Leslie
  !</CONTACT>
  !
  !<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
  !</CONTACT>
  ! 
  !<OVERVIEW>
  !</OVERVIEW>
  !
  !<DESCRIPTION>
  !</DESCRIPTION>
  !
  ! <INFO>
  !
  ! <REFERENCE>
  ! S.M. Griffies
  ! The Gent-McWilliams Skew-flux
  ! Journal of Physical Oceanography (1998) vol 28 pages 831-841
  ! </REFERENCE>
  !
  ! <REFERENCE>
  ! R. Ferrari, S.M. Griffies, A.J.G. Nurser, and G.K. Vallis
  ! A boundary value problem for the parameterized mesoscale eddy transport
  ! Ocean Modelling, 2009.
  ! </REFERENCE>
  !
  ! <REFERENCE>
  ! S.M. Griffies
  ! Fundamentals of Ocean Climate Models (2004)
  ! Princeton University Press
  ! </REFERENCE>
  !
  ! <REFERENCE>
  ! S.M. Griffies: Elements of MOM (2012)
  ! </REFERENCE>
  !
  ! </INFO>
  !
  !<NAMELIST NAME="ocean_nphysics_tensor_nml">
  !  <DATA NAME="" TYPE="logical">
  !  </DATA>
  !
  !</NAMELIST>

#define COMP isc:iec,jsc:jec

  use constants_mod, only: epsln, pi
  use fms_mod,       only: open_namelist_file, check_nml_error, close_file
  use mpp_mod,       only: stdout, stdlog, input_nml_file 

  use ocean_domains_mod,           only: get_local_indices
  use ocean_nphysics_skew_mod,     only: skew_transport
  use ocean_sigma_transport_mod,   only: tmask_sigma_on, tmask_sigma
  use ocean_types_mod,             only: ocean_grid_type, ocean_domain_type
  use ocean_types_mod,             only: ocean_time_type, ocean_thickness_type
  use ocean_util_mod,              only: register_3d_t_field, diagnose_3d

  implicit none

  public ocean_nphysics_tensor_init
  public compute_tensors

  private sine_taper
  private compute_diffusion_tapers
  private compute_masked_tensor

  private

#include <ocean_memory.h>

character(len=128) :: version=&
     '$Id: ocean_nphysics_tensor.F90,v 20.0 2013/12/14 00:14:50 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

character(len=*), parameter :: FILENAME=&
     __FILE__


  ! Diagnostics

  ! Tensors
  integer :: id_symm_tensor1122
  integer :: id_symm_tensor33x
  integer :: id_symm_tensor33y
  integer :: id_symm_tensor13
  integer :: id_symm_tensor23
  integer :: id_upsilonx
  integer :: id_upsilony

  ! Tapers
  integer :: id_slope_taper
  integer :: id_depth_taper
  integer :: id_neutral_taper
  integer :: id_displacement_depth

  ! Namelist Values

  ! for tapering neutral physics over penetration depth of
  ! eddies as determined by slope and Rossby radius
  logical :: neutral_sine_taper = .true.
  real :: turb_blayer_min   = 0.0 ! metres (was always set to zero in mom4p0)
  real :: rossby_radius_max = 100e3  ! metres
  real :: rossby_radius_min = 15e3   ! metres

  ! for setting the slope tapering methods
  logical :: dm_taper = .true. ! true -> tanh tapering scheme of Danabasoglu and McWilliams
                               ! false -> quadratic tapering of Gerdes, Koberle, and Willebrand
  ! slope width over which fluxes tapered using tanh function using dm_taper scheme
  real :: swidth = 0.05*.01    ! [dimensionless]

  ! to remove diagonal elements to neutral diffusion within the neutral boundar layer
  logical :: neutral_taper_diagonal = .false.

  ! to reduce neutral fluxes to horz/vert diffusion next to model boundaries
  logical :: tmask_neutral_on = .false.

  namelist /ocean_nphysics_tensor_nml/ neutral_sine_taper, turb_blayer_min, &
       rossby_radius_max, rossby_radius_min, dm_taper, swidth,              &
       neutral_taper_diagonal, tmask_neutral_on

contains

  !#######################################################################
  ! <SUBROUTINE NAME="ocean_nphysics_tensor_init">
  !
  ! <DESCRIPTION>
  ! Initialise this module.
  ! </DESCRIPTION>
  !
  subroutine ocean_nphysics_tensor_init(Domain, Grid, Time)

    type(ocean_domain_type), intent(in) :: Domain
    type(ocean_grid_type),   intent(in) :: Grid
    type(ocean_time_type),   intent(in) :: Time

    integer :: ierr, ioun, io_status
    integer :: stdoutunit, stdlogunit
    stdoutunit = stdout()
    stdlogunit = stdlog()

    ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_nphysics_tensor_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_nphysics_tensor_nml')
#else
    ioun =  open_namelist_file()
    read (ioun,ocean_nphysics_tensor_nml,IOSTAT=io_status)
    ierr = check_nml_error(io_status,'ocean_nphysics_tensor_nml')
    call close_file (ioun)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit,ocean_nphysics_tensor_nml)  
    write (stdlogunit,ocean_nphysics_tensor_nml)

#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
    nk = Grid%nk
#endif

    call register_fields(Grid, Time)
   
  end subroutine ocean_nphysics_tensor_init
  ! </SUBROUTINE> NAME="ocean_nphysics_tensor_init"

  !#######################################################################
  ! <SUBROUTINE NAME="register fields">
  !
  ! <DESCRIPTION>
  ! Register diagnostic fields.
  ! </DESCRIPTION>
  !
  subroutine register_fields(Grid, Time)
    type(ocean_grid_type), intent(in) :: Grid
    type(ocean_time_type), intent(in) :: Time

    id_symm_tensor1122 = register_3d_t_field(Grid, Time, 'symm_tensor1122', &
         'Horizontal diagonal diffusion tensor component', 'm^2/s', (/-1e8,1.e8/))
    id_symm_tensor33x = register_3d_t_field(Grid, Time, 'symm_tensor33x',      &
         'x-component of 33 term in neutral diffusion tensor', 'm^2/s', range=(/-1e8,1.e8/))
    id_symm_tensor33y = register_3d_t_field(Grid, Time, 'symm_tensor33y',      &
         'y-component of 33 term in neutral diffusion tensor', 'm^2/s', range=(/-1e8,1.e8/))
    id_symm_tensor13 = register_3d_t_field(Grid, Time, 'symm_tensor13',      &
         '13 term in neutral diffusion tensor', 'm^2/s', range=(/-1e8,1.e8/))
    id_symm_tensor23 = register_3d_t_field(Grid, Time, 'symm_tensor23',      &
         '23 term in neutral diffusion tensor', 'm^2/s', range=(/-1e8,1.e8/))
    id_upsilonx = register_3d_t_field(Grid, Time, 'upsilonx',      &
         'x component of GM transport vector', 'm^2/s', range=(/-1e8,1.e8/))
    id_upsilony = register_3d_t_field(Grid, Time, 'upsilony',      &
         'y component of GM transport vector', 'm^2/s', range=(/-1e8,1.e8/))

    id_slope_taper = register_3d_t_field(Grid, Time, 'slope_taper',      &
         'Taper function for handling steep neutral slope', '-', range=(/0.0, 1.0/))
    id_depth_taper = register_3d_t_field(Grid, Time, 'depth_taper',      &
         'Taper function for handling surface region', '-', range=(/0.0, 1.0/))
    id_neutral_taper = register_3d_t_field(Grid, Time, 'neutral_taper',      &
         'Taper function product of slope_taper and depth_taper', '-', range=(/0.0, 1.0/))
    id_displacement_depth = register_3d_t_field(Grid, Time, 'displacement_depth',      &
         'Effective displacement depth due to undulating density surfaces', '-', range=(/0.0, 1.e5/))

  end subroutine register_fields
  ! </SUBROUTINE> NAME="register_fields"

  !#######################################################################
  ! <SUBROUTINE NAME="compute_tensors">
  !
  ! <DESCRIPTION>
  ! Compute the tensor components for the diffusion and skew-diffusion tensor.
  ! </DESCRIPTION>
  !
  subroutine compute_tensors(Time, Domain, Grid, Thickness,                    &
       slopex_xz, slopey_yz, Ndz_z, N2_z, gravity_wave_speed,                  &
       rossby_radius, absslope, absslope_z,                                    &
       aredi_array, ah_array, agm_array, ksurf_blayer, smax, surf_blthick,     &
       symm_tensor13_xz, symm_tensor23_yz, symm_tensor33_xz, symm_tensor33_yz, &
       symm_tensor1122_z, upsilonx_xz, upsilony_yz)

    type(ocean_time_type),      intent(in)    :: Time
    type(ocean_domain_type),    intent(inout) :: Domain
    type(ocean_grid_type),      intent(in)    :: Grid
    type(ocean_thickness_type), intent(in)    :: Thickness

    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: slopex_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: slopey_yz
    real, dimension(isd:,jsd:,:,0:),    intent(in) :: Ndz_z
    real, dimension(isd:,jsd:,:,0:),    intent(in) :: N2_z
    real, dimension(isd:,jsd:),         intent(in) :: gravity_wave_speed
    real, dimension(isd:,jsd:),         intent(in) :: rossby_radius
    real, dimension(isd:,jsd:,:),       intent(in) :: absslope
    real, dimension(isd:,jsd:,:,0:),    intent(in) :: absslope_z

    real, dimension(isd:,jsd:,:), intent(in) :: aredi_array
    real, dimension(isd:,jsd:),   intent(in) :: ah_array
    real, dimension(isd:,jsd:,:), intent(in) :: agm_array

    integer, dimension(isd:,jsd:), intent(in) :: ksurf_blayer
    real,                          intent(in) :: smax
    real, dimension(isd:,jsd:),    intent(in) :: surf_blthick

    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: symm_tensor13_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: symm_tensor23_yz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: symm_tensor33_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: symm_tensor33_yz
    real, dimension(isd:,jsd:,:,0:),    intent(out) :: symm_tensor1122_z
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: upsilonx_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: upsilony_yz

    ! Taper function based on depth, values in [0..1]
    real, dimension(isd:ied,jsd:jed,nk) :: depth_taper

    ! Taper over the eddy depth
    call sine_taper(Time, Grid, Thickness, absslope, surf_blthick, rossby_radius, depth_taper)

    call diffusion_tensor(Time, Grid, slopex_xz, slopey_yz, absslope_z, &
         aredi_array, ah_array, smax, depth_taper,                      &
         symm_tensor1122_z, symm_tensor13_xz, symm_tensor23_yz,         &
         symm_tensor33_xz, symm_tensor33_yz)

    call skew_transport(Domain, Time, Grid, Thickness,                     &
         agm_array, slopex_xz, slopey_yz, Ndz_z, N2_z, gravity_wave_speed, &
         depth_taper, ksurf_blayer, upsilonx_xz, upsilony_yz)

    call compute_masked_tensor(Grid%kmt, aredi_array, symm_tensor1122_z, &
         symm_tensor33_xz, symm_tensor33_yz, symm_tensor13_xz,           &
         symm_tensor23_yz, upsilonx_xz, upsilony_yz)

    call diagnose_3d(Time, Grid, id_symm_tensor1122, 0.5*sum(symm_tensor1122_z, dim=4))
    call diagnose_3d(Time, Grid, id_symm_tensor33x, 0.25*sum(sum(symm_tensor33_xz, dim=5), dim=4))
    call diagnose_3d(Time, Grid, id_symm_tensor33y, 0.25*sum(sum(symm_tensor33_yz, dim=5), dim=4))
    call diagnose_3d(Time, Grid, id_symm_tensor13, 0.25*sum(sum(symm_tensor13_xz, dim=5), dim=4))
    call diagnose_3d(Time, Grid, id_symm_tensor23, 0.25*sum(sum(symm_tensor23_yz, dim=5), dim=4))
    call diagnose_3d(Time, Grid, id_upsilonx, 0.25*sum(sum(upsilonx_xz, dim=5), dim=4))
    call diagnose_3d(Time, Grid, id_upsilony, 0.25*sum(sum(upsilony_yz, dim=5), dim=4))

  end subroutine compute_tensors
  ! </SUBROUTINE> NAME="compute_tensors"

  !#######################################################################
  ! <SUBROUTINE NAME="sine_taper">
  !
  ! <DESCRIPTION>
  ! Calculate a sine taper for those points shallower than the given threshold.
  !
  ! The depth_function gives the depth (in metres) at each (i,j,k) point.
  ! The threshold_depth is the depth (in metres) at each (i,j) point.
  ! The returned taper gives a value in the range [0, 1] at each (i,j,k) point,
  ! where those points at a depth below the threshold are set to 1.0 and those
  ! above approach 0.0 as they approach the surface according to a sine
  ! function.
  !
  ! </DESCRIPTION>
  !
  subroutine sine_taper(Time, Grid, Thickness, absslope, surf_blthick, rossby_radius, taper)
    type(ocean_time_type),        intent(in) :: Time
    type(ocean_grid_type),        intent(in) :: Grid
    type(ocean_thickness_type),   intent(in) :: Thickness
    real, dimension(isd:,jsd:,:), intent(in) :: absslope
    real, dimension(isd:,jsd:),   intent(in) :: surf_blthick
    real, dimension(isd:,jsd:),   intent(in) :: rossby_radius
    real, dimension(isd:,jsd:,:), intent(out) :: taper

    real, dimension(isd:ied,jsd:jed) :: capped_rossby_radius  ! [m]
    real, dimension(isd:ied,jsd:jed,nk) :: displacement_depth ! [m]
    real, dimension(isd:ied,jsd:jed,nk) :: depth_ratio        ! [1]

    integer :: k

    displacement_depth(:,:,:) = 0.0
    if (neutral_sine_taper) then
       ! EoM: 16.68
       capped_rossby_radius(COMP) = min(rossby_radius_max, max(rossby_radius_min, rossby_radius(COMP))) 
       do k = 1, nk
          ! FOCM 15.22
          displacement_depth(COMP,k) = max(turb_blayer_min, surf_blthick(COMP), capped_rossby_radius(COMP)*absslope(COMP,k))
       enddo

       where (Thickness%depth_zt(COMP,:) <= displacement_depth(COMP,:))
          depth_ratio(COMP,:) = Thickness%depth_zt(COMP,:)/(epsln+displacement_depth(COMP,:))
          taper(COMP,:) = 0.5*(1.0 + sin(pi*(depth_ratio(COMP,:) - 0.5))) ! FOCM 15.24
       elsewhere
          taper(COMP,:) = 1.0
       endwhere
       call diagnose_3d(Time, Grid, id_displacement_depth, displacement_depth, abs_max=1.5e4)
    else
       taper(COMP,:) = 1.0
    endif

    call diagnose_3d(Time, Grid, id_depth_taper, taper)

  end subroutine sine_taper
  ! </SUBROUTINE> NAME="sine_taper"


  !#######################################################################
  ! <SUBROUTINE NAME="diffusion_tensor">
  !
  ! <DESCRIPTION>
  ! Compute the components of the neutral diffusion tensor.
  ! </DESCRIPTION>
  !
  subroutine diffusion_tensor(Time, Grid, slopex_xz, slopey_yz, absslope_z,           &
       aredi_array, ah_array, smax, depth_taper, symm_tensor1122_z, symm_tensor13_xz, &
       symm_tensor23_yz, symm_tensor33_xz, symm_tensor33_yz)

    type(ocean_time_type),              intent(in) :: Time
    type(ocean_grid_type),              intent(in) :: Grid
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: slopex_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: slopey_yz
    real, dimension(isd:,jsd:,:,0:),    intent(in) :: absslope_z
    real, dimension(isd:,jsd:,:),       intent(in) :: aredi_array
    real, dimension(isd:,jsd:),         intent(in) :: ah_array
    real,                               intent(in) :: smax
    real, dimension(isd:,jsd:,:),       intent(in) :: depth_taper

    real, dimension(isd:,jsd:,:,0:),    intent(out) :: symm_tensor1122_z
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: symm_tensor13_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: symm_tensor23_yz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: symm_tensor33_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: symm_tensor33_yz

    ! Taper functions, values in [0..1]
    real, dimension(isd:ied,jsd:jed,nk,0:1) :: neutral_taper_z
    real, dimension(isd:ied,jsd:jed,nk,0:1) :: diagonal_taper_z
    real, dimension(isd:ied,jsd:jed,nk)     :: horiz_diff_taper

    ! Tapered Redi diffusivity [m^2/s]
    real, dimension(isd:ied,jsd:jed,nk,0:1)     :: tapered_aredi_z
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: full_tapered_aredi

    ! Tapered ah diffusivity [m^2/s]
    real, dimension(isd:ied,jsd:jed,nk) :: ah_term

    call compute_diffusion_tapers(Time, Grid, absslope_z, smax, depth_taper, &
         neutral_taper_z, diagonal_taper_z, horiz_diff_taper)
   
    tapered_aredi_z(COMP,:,0)      = aredi_array(COMP,:)*neutral_taper_z(COMP,:,0)
    tapered_aredi_z(COMP,:,1)      = aredi_array(COMP,:)*neutral_taper_z(COMP,:,1)
    full_tapered_aredi(COMP,:,:,:) = spread(tapered_aredi_z(COMP,:,:), 5, 2)

    ! Off diagonal terms
    symm_tensor13_xz(COMP,:,:,:) = full_tapered_aredi(COMP,:,:,:)*slopex_xz(COMP,:,:,:)
    symm_tensor23_yz(COMP,:,:,:) = full_tapered_aredi(COMP,:,:,:)*slopey_yz(COMP,:,:,:)

    ! Diagonal terms
    ah_term(COMP,:)             = spread(ah_array(COMP), 3, nk)*horiz_diff_taper(COMP,:)
    symm_tensor1122_z(COMP,:,0) = aredi_array(COMP,:)*diagonal_taper_z(COMP,:,0) + ah_term(COMP,:)
    symm_tensor1122_z(COMP,:,1) = aredi_array(COMP,:)*diagonal_taper_z(COMP,:,1) + ah_term(COMP,:)

    symm_tensor33_xz(COMP,:,:,:) = full_tapered_aredi(COMP,:,:,:)*slopex_xz(COMP,:,:,:)**2
    symm_tensor33_yz(COMP,:,:,:) = full_tapered_aredi(COMP,:,:,:)*slopey_yz(COMP,:,:,:)**2

  end subroutine diffusion_tensor
  ! </SUBROUTINE> NAME="diffusion_tensor"

  !#######################################################################
  ! <SUBROUTINE NAME="compute_diffusion_tapers">
  !
  ! <DESCRIPTION>
  ! Compute the taper functions to be applied to the components of the diffusion
  ! tensor.
  ! </DESCRIPTION>
  !
  subroutine compute_diffusion_tapers(Time, Grid, absslope_z, smax, depth_taper, &
       neutral_taper_z, diagonal_taper_z, horiz_diff_taper)
    
    type(ocean_time_type),           intent(in) :: Time
    type(ocean_grid_type),           intent(in) :: Grid
    real, dimension(isd:,jsd:,:,0:), intent(in) :: absslope_z
    real,                            intent(in) :: smax
    real, dimension(isd:,jsd:,:),    intent(in) :: depth_taper

    real, dimension(isd:,jsd:,:,0:), intent(out) :: neutral_taper_z
    real, dimension(isd:,jsd:,:,0:), intent(out) :: diagonal_taper_z
    real, dimension(isd:,jsd:,:),    intent(out) :: horiz_diff_taper

    ! Taper function, values in [0..1]
    real, dimension(isd:ied,jsd:jed,nk,0:1) :: slope_taper_z

    ! Taper for steep slope regions
    if (dm_taper) then
       slope_taper_z(COMP,:,:) = 0.5*(1.0 + tanh((smax-absslope_z(COMP,:,:))/(swidth+epsln)))
    else
       where (absslope_z(COMP,:,:) > smax)
          slope_taper_z(COMP,:,:) = (smax/absslope_z(COMP,:,:))**2
       elsewhere
          slope_taper_z(COMP,:,:) = 1.0
       endwhere
    endif

    neutral_taper_z(COMP,:,0) = slope_taper_z(COMP,:,0)*depth_taper(COMP,:)
    neutral_taper_z(COMP,:,1) = slope_taper_z(COMP,:,1)*depth_taper(COMP,:)

    if (neutral_taper_diagonal) then
       diagonal_taper_z(COMP,:,:) = neutral_taper_z(COMP,:,:)
    else
       diagonal_taper_z(COMP,:,:) = 1.0
    endif

    horiz_diff_taper(COMP,:) = 1.0 - depth_taper(COMP,:)

    call diagnose_3d(Time, Grid, id_slope_taper, 0.5*sum(slope_taper_z(:,:,:,:), dim=4))
    call diagnose_3d(Time, Grid, id_neutral_taper, 0.5*sum(neutral_taper_z(:,:,:,:), dim=4))

  end subroutine compute_diffusion_tapers
  ! </SUBROUTINE> NAME="compute_diffusion_tapers"


  !#######################################################################
  ! <SUBROUTINE NAME="compute_masked_tensor">
  !
  ! <DESCRIPTION>
  ! This function applies the boundary conditions relevent to the flags
  ! tmask_neutral_on and tmask_sigma_on.
  ! </DESCRIPTION>
  !
  subroutine compute_masked_tensor(kmt, aredi_array,          &
       symm_tensor1122_z, symm_tensor33_xz, symm_tensor33_yz, &
       symm_tensor13_xz, symm_tensor23_yz, upsilonx_xz, upsilony_yz)
    
    integer, dimension(isd:,jsd:),      intent(in)    :: kmt
    real, dimension(isd:,jsd:,:),       intent(in)    :: aredi_array
    real, dimension(isd:,jsd:,:,0:),    intent(inout) :: symm_tensor1122_z
    real, dimension(isd:,jsd:,:,0:,0:), intent(inout) :: symm_tensor33_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(inout) :: symm_tensor33_yz

    real, dimension(isd:,jsd:,:,0:,0:), intent(inout) :: symm_tensor13_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(inout) :: symm_tensor23_yz
    real, dimension(isd:,jsd:,:,0:,0:), intent(inout) :: upsilonx_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(inout) :: upsilony_yz

    integer :: k, ip, kr

    ! Apply masks to use horizonal diffusion at boundaries
    if (tmask_neutral_on) then
       ! Surface
       symm_tensor1122_z(COMP,1,0) = aredi_array(COMP,1)
       symm_tensor1122_z(COMP,1,1) = aredi_array(COMP,1)
       symm_tensor33_xz(COMP,1,:,:) = 0.0
       symm_tensor33_yz(COMP,1,:,:) = 0.0
       symm_tensor13_xz(COMP,1,:,:) = 0.0
       symm_tensor23_yz(COMP,1,:,:) = 0.0
       upsilonx_xz(COMP,1,:,:) = 0.0
       upsilony_yz(COMP,1,:,:) = 0.0

       ! Bottom
       do k = 2, nk
          where (k == kmt(COMP))
             symm_tensor1122_z(COMP,k,0) = aredi_array(COMP,k)
             symm_tensor1122_z(COMP,k,1) = aredi_array(COMP,k)
          endwhere
          do ip = 0, 1
             do kr = 0, 1
                where (k == kmt(COMP))
                   symm_tensor33_xz(COMP,k,ip,kr) = 0.0
                   symm_tensor33_yz(COMP,k,ip,kr) = 0.0
                   symm_tensor13_xz(COMP,k,ip,kr) = 0.0
                   symm_tensor23_yz(COMP,k,ip,kr) = 0.0
                   upsilonx_xz(COMP,k,ip,kr) = 0.0
                   upsilony_yz(COMP,k,ip,kr) = 0.0
                endwhere
             enddo
          enddo
       enddo
    endif

    if (tmask_sigma_on) then
       do k = 2, nk
          do ip = 0, 1
             do kr = 0, 1
                where (k == kmt(COMP) .and. tmask_sigma(COMP) == 1.0) 
                   symm_tensor1122_z(COMP,k,kr) = 0.0
                   symm_tensor33_xz(COMP,k,ip,kr) = 0.0
                   symm_tensor33_yz(COMP,k,ip,kr) = 0.0
                   symm_tensor13_xz(COMP,k,ip,kr) = 0.0
                   symm_tensor23_yz(COMP,k,ip,kr) = 0.0
                   upsilonx_xz(COMP,k,ip,kr) = 0.0
                   upsilony_yz(COMP,k,ip,kr) = 0.0
                endwhere
             enddo
          enddo
       enddo
    endif

  end subroutine compute_masked_tensor
  ! </SUBROUTINE> NAME="compute_masked_tensor"

end module ocean_nphysics_tensor_mod

      module mo_grid_mod
!---------------------------------------------------------------------
!       ... Basic grid point resolution parameters
!---------------------------------------------------------------------
      implicit none

      save

character(len=128), parameter :: version     = '$Id: moz.mods.F90,v 19.0 2012/01/06 20:34:14 fms Exp $'
character(len=128), parameter :: tagname     = '$Name: tikal $'
logical                       :: module_is_initialized = .false.

      integer, parameter :: &
                pcnst    =    84+1, &     ! number of advected constituents including cloud water
                pcnstm1  =    84, &     ! number of advected constituents excluding cloud water
                plev     =   1, &         ! number of vertical levels
                plevp    = plev+1, &      ! plev plus 1
                plevm    = plev-1, &      ! plev minus 1
                plon     =   1, &         ! number of longitudes
                plat     =   1            ! number of latitudes

      integer, parameter :: &
                pnats    =     0    ! number of non-advected trace species



      integer :: nodes                ! mpi task count
      integer :: plonl                ! longitude tile dimension
      integer :: pplon                ! longitude tile count
      integer :: plnplv               ! plonl * plev

      end module mo_grid_mod

      module chem_mods_mod
!--------------------------------------------------------------
!       ... basic chemistry array parameters
!--------------------------------------------------------------

      use mo_grid_mod, only : pcnstm1
!++lwh
      use mpp_mod,     only : mpp_error, FATAL
!--lwh

      implicit none

      save

      integer, parameter :: hetcnt     =     0, &    ! number of heterogeneous processes
                            phtcnt     =    41, &    ! number of photo processes
                            rxntot     =   224, &    ! number of total reactions
                            gascnt     =   183, &    ! number of gas phase reactions
                            nfs        =     3, &       ! number of "fixed" species
                            relcnt     =     0, &    ! number of relationship species
                            grpcnt     =     0, &    ! number of group members
                            imp_nzcnt  =   829, &     ! number of non-zero implicit matrix entries
                            rod_nzcnt  =     0, &     ! number of non-zero rodas matrix entries
                            extcnt     =     0, &    ! number of species with external forcing
                            clscnt1    =     8, &  ! number of species in explicit class
                            clscnt2    =     0, &  ! number of species in hov class
                            clscnt3    =     0, &  ! number of species in ebi class
                            clscnt4    =    76, &  ! number of species in implicit class
                            clscnt5    =     0, &  ! number of species in rodas class
                            indexm     =     1, &    ! index of total atm density in invariant array
                            ncol_abs   =     2, &    ! number of column densities
                            indexh2o   =     0, &    ! index of water vapor density
                            clsze      = 1       ! loop length for implicit chemistry

      integer ::            ngrp       = 0
      integer ::            drydep_cnt = 0
      integer ::            srfems_cnt = 0
      integer ::            rxt_alias_cnt = 0
      integer, allocatable :: grp_mem_cnt(:)
      integer, allocatable :: rxt_alias_map(:)
      real      :: adv_mass(pcnstm1)
      real      :: nadv_mass(grpcnt)
      character(len=16), allocatable :: rxt_alias_lst(:)
      character(len=8), allocatable  :: drydep_lst(:)
      character(len=8), allocatable  :: srfems_lst(:)
      character(len=8), allocatable  :: grp_lst(:)
      character(len=8)               :: het_lst(max(1,hetcnt))
      character(len=8)               :: extfrc_lst(max(1,extcnt))
      character(len=8)               :: inv_lst(max(1,nfs))

      type solver_class
         integer :: clscnt
         integer :: lin_rxt_cnt
         integer :: nln_rxt_cnt
         integer :: indprd_cnt
         integer :: iter_max
         integer :: cls_rxt_cnt(4)
         integer, pointer :: permute(:)
         integer, pointer :: diag_map(:)
         integer, pointer :: clsmap(:)
      end type solver_class

      type(solver_class) :: explicit, implicit, rodas

      contains

      subroutine endrun(msg)

      implicit none

      character(len=128), intent(in), optional  :: msg
      call mpp_error(FATAL, msg)

      end subroutine endrun 

      subroutine chem_mods_init
!--------------------------------------------------------------
!       ... intialize the class derived type
!--------------------------------------------------------------

      implicit none

      integer :: astat

      explicit%clscnt       =     8
      explicit%indprd_cnt   =    52

      implicit%clscnt       =    76
      implicit%lin_rxt_cnt  =    70
      implicit%nln_rxt_cnt  =   151
      implicit%indprd_cnt   =     3
      implicit%iter_max     =    11

      rodas%clscnt          =     0
      rodas%lin_rxt_cnt     =     0
      rodas%nln_rxt_cnt     =     0
      rodas%indprd_cnt      =     0

      if( explicit%clscnt > 0 ) then
         allocate( explicit%clsmap(explicit%clscnt),stat=astat )
         if( astat /= 0 ) then
            write(*,*) 'chem_mods_init: failed to allocate explicit%clsmap ; error = ',astat
            call endrun
         end if
         explicit%clsmap(:)  = 0
      end if
      if( implicit%clscnt > 0 ) then
         allocate( implicit%permute(implicit%clscnt),stat=astat )
         if( astat /= 0 ) then
            write(*,*) 'chem_mods_init: failed to allocate implicit%permute ; error = ',astat
            call endrun
         end if
         implicit%permute(:)  = 0
         allocate( implicit%diag_map(implicit%clscnt),stat=astat )
         if( astat /= 0 ) then
            write(*,*) 'chem_mods_init: failed to allocate implicit%diag_map ; error = ',astat
            call endrun
         end if
         implicit%diag_map(:)  = 0
         allocate( implicit%clsmap(implicit%clscnt),stat=astat )
         if( astat /= 0 ) then
            write(*,*) 'chem_mods_init: failed to allocate implicit%clsmap ; error = ',astat
            call endrun
         end if
         implicit%clsmap(:)  = 0
      end if
      if( rodas%clscnt > 0 ) then
         allocate( rodas%permute(rodas%clscnt),stat=astat )
         if( astat /= 0 ) then
            write(*,*) 'chem_mods_init: failed to allocate rodas%permute ; error = ',astat
            call endrun
         end if
         rodas%permute(:)  = 0
         allocate( rodas%diag_map(rodas%clscnt),stat=astat )
         if( astat /= 0 ) then
            write(*,*) 'chem_mods_init: failed to allocate rodas%diag_map ; error = ',astat
            call endrun
         end if
         rodas%diag_map(:)  = 0
         allocate( rodas%clsmap(rodas%clscnt),stat=astat )
         if( astat /= 0 ) then
            write(*,*) 'chem_mods_init: failed to allocate rodas%clsmap ; error = ',astat
            call endrun
         end if
         rodas%clsmap(:)  = 0
      end if

      end subroutine chem_mods_init

      end module chem_mods_mod
  
      module M_SPC_ID_MOD
  
      implicit none                                                             
  
      integer, parameter :: id_O3 =   1
      integer, parameter :: id_O =   2
      integer, parameter :: id_O1D =   3
      integer, parameter :: id_N2O =   4
      integer, parameter :: id_N =   5
      integer, parameter :: id_NO =   6
      integer, parameter :: id_NO2 =   7
      integer, parameter :: id_NO3 =   8
      integer, parameter :: id_HNO3 =   9
      integer, parameter :: id_HO2NO2 =  10
      integer, parameter :: id_N2O5 =  11
      integer, parameter :: id_CH4 =  12
      integer, parameter :: id_CH3O2 =  13
      integer, parameter :: id_CH3OOH =  14
      integer, parameter :: id_CH2O =  15
      integer, parameter :: id_CO =  16
      integer, parameter :: id_OH =  17
      integer, parameter :: id_HO2 =  18
      integer, parameter :: id_H2O2 =  19
      integer, parameter :: id_C3H6 =  20
      integer, parameter :: id_ISOP =  21
      integer, parameter :: id_PO2 =  22
      integer, parameter :: id_CH3CHO =  23
      integer, parameter :: id_POOH =  24
      integer, parameter :: id_CH3CO3 =  25
      integer, parameter :: id_CH3COOOH =  26
      integer, parameter :: id_PAN =  27
      integer, parameter :: id_ONIT =  28
      integer, parameter :: id_C2H6 =  29
      integer, parameter :: id_C2H4 =  30
      integer, parameter :: id_C4H10 =  31
      integer, parameter :: id_MPAN =  32
      integer, parameter :: id_ISOPO2 =  33
      integer, parameter :: id_MVK =  34
      integer, parameter :: id_MACR =  35
      integer, parameter :: id_MACRO2 =  36
      integer, parameter :: id_MACROOH =  37
      integer, parameter :: id_MCO3 =  38
      integer, parameter :: id_C2H5O2 =  39
      integer, parameter :: id_C2H5OOH =  40
      integer, parameter :: id_C10H16 =  41
      integer, parameter :: id_C3H8 =  42
      integer, parameter :: id_C3H7O2 =  43
      integer, parameter :: id_C3H7OOH =  44
      integer, parameter :: id_CH3COCH3 =  45
      integer, parameter :: id_ROOH =  46
      integer, parameter :: id_CH3OH =  47
      integer, parameter :: id_C2H5OH =  48
      integer, parameter :: id_GLYALD =  49
      integer, parameter :: id_HYAC =  50
      integer, parameter :: id_EO2 =  51
      integer, parameter :: id_EO =  52
      integer, parameter :: id_HYDRALD =  53
      integer, parameter :: id_RO2 =  54
      integer, parameter :: id_CH3COCHO =  55
      integer, parameter :: id_ISOPNO3 =  56
      integer, parameter :: id_ONITR =  57
      integer, parameter :: id_XO2 =  58
      integer, parameter :: id_XOOH =  59
      integer, parameter :: id_ISOPOOH =  60
      integer, parameter :: id_H2 =  61
      integer, parameter :: id_O3S = 62
      integer, parameter :: id_SO2 = 63
      integer, parameter :: id_SO4 = 64
      integer, parameter :: id_DMS = 65
      integer, parameter :: id_NH3 = 66
      integer, parameter :: id_NH4NO3 = 67
      integer, parameter :: id_NH4 = 68
      integer, parameter :: id_HCl = 69
      integer, parameter :: id_HOCl = 70
      integer, parameter :: id_ClONO2 = 71
      integer, parameter :: id_Cl = 72
      integer, parameter :: id_ClO = 73
      integer, parameter :: id_Cl2O2 = 74
      integer, parameter :: id_Cl2 = 75
      integer, parameter :: id_HOBr = 76
      integer, parameter :: id_HBr = 77
      integer, parameter :: id_BrONO2 = 78
      integer, parameter :: id_Br = 79
      integer, parameter :: id_BrO = 80
      integer, parameter :: id_BrCl = 81
      integer, parameter :: id_LCH4 = 82
      integer, parameter :: id_H = 83
      integer, parameter :: id_H2O = 84
  
  
      end module M_SPC_ID_MOD
                                                                                
      module M_RXT_ID_MOD
                                                                                
      implicit none                                                             
                                                                                
      integer, parameter :: rid_jo2 =    1                                      
      integer, parameter :: rid_jo1d =    2                                     
      integer, parameter :: rid_jo3p =    3                                     
      integer, parameter :: rid_jn2o =    4                                     
      integer, parameter :: rid_jno =    5                                      
      integer, parameter :: rid_jno2 =    6                                     
      integer, parameter :: rid_jn2o5 =    7                                    
      integer, parameter :: rid_jhno3 =    8                                    
      integer, parameter :: rid_jno3 =    9                                     
      integer, parameter :: rid_jho2no2 =   10                                  
      integer, parameter :: rid_jch3ooh =   11                                  
      integer, parameter :: rid_jch2o_a =   12                                  
      integer, parameter :: rid_jch2o_b =   13                                  
      integer, parameter :: rid_jh2o =   14                                     
      integer, parameter :: rid_jh2o2 =   15                                    
      integer, parameter :: rid_jch3cho =   16                                  
      integer, parameter :: rid_jpooh =   17                                    
      integer, parameter :: rid_jch3co3h =   18                                 
      integer, parameter :: rid_jpan =   19                                     
      integer, parameter :: rid_jmpan =   20                                    
      integer, parameter :: rid_jmacr_a =   21                                  
      integer, parameter :: rid_jmacr_b =   22                                  
      integer, parameter :: rid_jmvk =   23                                     
      integer, parameter :: rid_jc2h5ooh =   24                                 
      integer, parameter :: rid_jc3h7ooh =   25                                 
      integer, parameter :: rid_jrooh =   26                                    
      integer, parameter :: rid_jacet =   27                                    
      integer, parameter :: rid_jmgly =   28                                    
      integer, parameter :: rid_jxooh =   29                                    
      integer, parameter :: rid_jonitr =   30                                   
      integer, parameter :: rid_jisopooh =   31                                 
      integer, parameter :: rid_jhyac =   32                                    
      integer, parameter :: rid_jglyald =   33                                  
      integer, parameter :: rid_jclono2 =   34                                  
      integer, parameter :: rid_jhocl =   35                                    
      integer, parameter :: rid_jcl2o2 =   36                                   
      integer, parameter :: rid_jbrono2 =   37                                  
      integer, parameter :: rid_jhobr =   38                                    
      integer, parameter :: rid_jbrcl =   39                                    
      integer, parameter :: rid_jbro =   40                                     
      integer, parameter :: rid_jcl2 =   41                                     
      integer, parameter :: rid_usr1 =   42                                     
      integer, parameter :: rid_o1d_n2 =   44                                   
      integer, parameter :: rid_o1d_o2 =   45                                   
      integer, parameter :: rid_ox_l1 =   46                                    
      integer, parameter :: rid_ox_p1 =   49                                    
      integer, parameter :: rid_usr2 =   54                                     
      integer, parameter :: rid_usr3 =   55                                     
      integer, parameter :: rid_usr4 =   57                                     
      integer, parameter :: rid_usr5 =   58                                     
      integer, parameter :: rid_usr6 =   60                                     
      integer, parameter :: rid_usr7 =   62                                     
      integer, parameter :: rid_ox_p2 =   65                                    
      integer, parameter :: rid_usr8 =   72                                     
      integer, parameter :: rid_usr8a =   73                                    
      integer, parameter :: rid_ox_l2 =   77                                    
      integer, parameter :: rid_ox_l3 =   78                                    
      integer, parameter :: rid_usr9 =   79                                     
      integer, parameter :: rid_usr10 =   84                                    
      integer, parameter :: rid_ox_l4 =   85                                    
      integer, parameter :: rid_ox_p3 =   87                                    
      integer, parameter :: rid_ox_p4 =   92                                    
      integer, parameter :: rid_usr11 =   93                                    
      integer, parameter :: rid_usr12 =   97                                    
      integer, parameter :: rid_ox_l5 =   99                                    
      integer, parameter :: rid_ox_p5 =  101                                    
      integer, parameter :: rid_usr13 =  106                                    
      integer, parameter :: rid_ox_l6 =  110                                    
      integer, parameter :: rid_ox_p6 =  113                                    
      integer, parameter :: rid_ox_l7 =  119                                    
      integer, parameter :: rid_ox_l8 =  121                                    
      integer, parameter :: rid_ox_p7 =  122                                    
      integer, parameter :: rid_ox_p8 =  129                                    
      integer, parameter :: rid_usr14 =  135                                    
      integer, parameter :: rid_usr15 =  136                                    
      integer, parameter :: rid_ox_l9 =  138                                    
      integer, parameter :: rid_usr16 =  140                                    
      integer, parameter :: rid_usr17 =  141                                    
      integer, parameter :: rid_ox_p9 =  145                                    
      integer, parameter :: rid_usr22 =  149                                    
      integer, parameter :: rid_ox_p10 =  150                                   
      integer, parameter :: rid_ox_p11 =  164                                   
      integer, parameter :: rid_usr21 =  170                                    
      integer, parameter :: rid_usr24 =  180                                    
      integer, parameter :: rid_usr25 =  182                                    
      integer, parameter :: rid_strat13 =  184                                  
      integer, parameter :: rid_strat14 =  185                                  
      integer, parameter :: rid_strat20 =  186                                  
      integer, parameter :: rid_strat21 =  187                                  
      integer, parameter :: rid_strat22 =  188                                  
      integer, parameter :: rid_strat23 =  189                                  
      integer, parameter :: rid_strat24 =  190                                  
      integer, parameter :: rid_strat25 =  191                                  
      integer, parameter :: rid_strat26 =  192                                  
      integer, parameter :: rid_strat27 =  193                                  
      integer, parameter :: rid_strat28 =  194                                  
      integer, parameter :: rid_strat29 =  195                                  
      integer, parameter :: rid_strat33 =  196                                  
      integer, parameter :: rid_strat35 =  197                                  
      integer, parameter :: rid_strat37 =  198                                  
      integer, parameter :: rid_strat38 =  199                                  
      integer, parameter :: rid_strat39 =  200                                  
      integer, parameter :: rid_strat40 =  201                                  
      integer, parameter :: rid_strat41 =  202                                  
      integer, parameter :: rid_strat42 =  203                                  
      integer, parameter :: rid_strat43 =  204                                  
      integer, parameter :: rid_strat44 =  205                                  
      integer, parameter :: rid_strat45 =  206                                  
      integer, parameter :: rid_strat46 =  207                                  
      integer, parameter :: rid_strat47 =  208                                  
      integer, parameter :: rid_strat48 =  209                                  
      integer, parameter :: rid_strat69 =  210                                  
      integer, parameter :: rid_strat58 =  211                                  
      integer, parameter :: rid_strat59 =  212                                  
      integer, parameter :: rid_strat64 =  213                                  
      integer, parameter :: rid_strat71 =  214                                  
      integer, parameter :: rid_strat72 =  215                                  
      integer, parameter :: rid_strat73 =  216                                  
      integer, parameter :: rid_strat74 =  217                                  
      integer, parameter :: rid_strat75 =  218                                  
      integer, parameter :: rid_strat76 =  219                                  
      integer, parameter :: rid_strat77 =  220                                  
      integer, parameter :: rid_strat78 =  221                                  
      integer, parameter :: rid_strat79 =  222                                  
      integer, parameter :: rid_strat80 =  223                                  
                                                                                
      integer, parameter :: rid_r0043 =   43                                    
      integer, parameter :: rid_r0047 =   47                                    
      integer, parameter :: rid_r0048 =   48                                    
      integer, parameter :: rid_r0050 =   50                                    
      integer, parameter :: rid_r0051 =   51                                    
      integer, parameter :: rid_r0052 =   52                                    
      integer, parameter :: rid_r0053 =   53                                    
      integer, parameter :: rid_r0056 =   56                                    
      integer, parameter :: rid_r0059 =   59                                    
      integer, parameter :: rid_r0061 =   61                                    
      integer, parameter :: rid_r0063 =   63                                    
      integer, parameter :: rid_r0064 =   64                                    
      integer, parameter :: rid_r0066 =   66                                    
      integer, parameter :: rid_r0067 =   67                                    
      integer, parameter :: rid_r0068 =   68                                    
      integer, parameter :: rid_r0069 =   69                                    
      integer, parameter :: rid_r0070 =   70                                    
      integer, parameter :: rid_r0071 =   71                                    
      integer, parameter :: rid_r0074 =   74                                    
      integer, parameter :: rid_r0075 =   75                                    
      integer, parameter :: rid_r0076 =   76                                    
      integer, parameter :: rid_r0080 =   80                                    
      integer, parameter :: rid_r0081 =   81                                    
      integer, parameter :: rid_r0082 =   82                                    
      integer, parameter :: rid_r0083 =   83                                    
      integer, parameter :: rid_r0086 =   86                                    
      integer, parameter :: rid_r0088 =   88                                    
      integer, parameter :: rid_r0089 =   89                                    
      integer, parameter :: rid_r0090 =   90                                    
      integer, parameter :: rid_r0091 =   91                                    
      integer, parameter :: rid_r0094 =   94                                    
      integer, parameter :: rid_r0095 =   95                                    
      integer, parameter :: rid_r0096 =   96                                    
      integer, parameter :: rid_r0098 =   98                                    
      integer, parameter :: rid_r0100 =  100                                    
      integer, parameter :: rid_r0102 =  102                                    
      integer, parameter :: rid_r0103 =  103                                    
      integer, parameter :: rid_r0104 =  104                                    
      integer, parameter :: rid_r0105 =  105                                    
      integer, parameter :: rid_r0107 =  107                                    
      integer, parameter :: rid_r0108 =  108                                    
      integer, parameter :: rid_r0109 =  109                                    
      integer, parameter :: rid_r0111 =  111                                    
      integer, parameter :: rid_r0112 =  112                                    
      integer, parameter :: rid_r0114 =  114                                    
      integer, parameter :: rid_r0115 =  115                                    
      integer, parameter :: rid_r0116 =  116                                    
      integer, parameter :: rid_r0117 =  117                                    
      integer, parameter :: rid_r0118 =  118                                    
      integer, parameter :: rid_r0120 =  120                                    
      integer, parameter :: rid_r0123 =  123                                    
      integer, parameter :: rid_r0124 =  124                                    
      integer, parameter :: rid_r0125 =  125                                    
      integer, parameter :: rid_r0126 =  126                                    
      integer, parameter :: rid_r0127 =  127                                    
      integer, parameter :: rid_r0128 =  128                                    
      integer, parameter :: rid_r0130 =  130                                    
      integer, parameter :: rid_r0131 =  131                                    
      integer, parameter :: rid_r0132 =  132                                    
      integer, parameter :: rid_r0133 =  133                                    
      integer, parameter :: rid_r0134 =  134                                    
      integer, parameter :: rid_r0137 =  137                                    
      integer, parameter :: rid_r0139 =  139                                    
      integer, parameter :: rid_r0142 =  142                                    
      integer, parameter :: rid_r0143 =  143                                    
      integer, parameter :: rid_r0144 =  144                                    
      integer, parameter :: rid_r0146 =  146                                    
      integer, parameter :: rid_r0147 =  147                                    
      integer, parameter :: rid_r0148 =  148                                    
      integer, parameter :: rid_r0151 =  151                                    
      integer, parameter :: rid_r0152 =  152                                    
      integer, parameter :: rid_r0153 =  153                                    
      integer, parameter :: rid_r0154 =  154                                    
      integer, parameter :: rid_r0155 =  155                                    
      integer, parameter :: rid_r0156 =  156                                    
      integer, parameter :: rid_r0157 =  157                                    
      integer, parameter :: rid_r0158 =  158                                    
      integer, parameter :: rid_r0159 =  159                                    
      integer, parameter :: rid_r0160 =  160                                    
      integer, parameter :: rid_r0161 =  161                                    
      integer, parameter :: rid_r0162 =  162                                    
      integer, parameter :: rid_r0163 =  163                                    
      integer, parameter :: rid_r0165 =  165                                    
      integer, parameter :: rid_r0166 =  166                                    
      integer, parameter :: rid_r0167 =  167                                    
      integer, parameter :: rid_r0168 =  168                                    
      integer, parameter :: rid_r0169 =  169                                    
      integer, parameter :: rid_r0171 =  171                                    
      integer, parameter :: rid_r0172 =  172                                    
      integer, parameter :: rid_r0173 =  173                                    
      integer, parameter :: rid_r0174 =  174                                    
      integer, parameter :: rid_r0175 =  175                                    
      integer, parameter :: rid_r0176 =  176                                    
      integer, parameter :: rid_r0177 =  177                                    
      integer, parameter :: rid_r0178 =  178                                    
      integer, parameter :: rid_r0179 =  179                                    
      integer, parameter :: rid_r0181 =  181                                    
      integer, parameter :: rid_r0183 =  183                                    
      integer, parameter :: rid_r0224 =  224                                    
                                                                                
      end module M_RXT_ID_MOD
                                                                                
      module M_HET_ID_MOD
                                                                                
      implicit none                                                             
                                                                                
                                                                                
      end module M_HET_ID_MOD

module xbt_adjust

  use oda_types_mod, only : ocean_profile_type, missing_value

  implicit none
  
  real, parameter :: s1=0.30731408,s2=6.707e-9,s3=-8.1899e-5,sa=3.227,&
                     sb=-2.17e-4
  real, parameter :: t1=0.29585798,t2=1.002e-9,t3=-3.1658e-5,ta=3.426,&
       tb=-4.7e-4

contains
  
subroutine xbt_drop_rate_adjust(station)


  type(ocean_profile_type), intent(inout) :: station


  integer :: k
  real :: dpth_orig, dpth_new,tdrop
  integer :: fix_depth
  
  if (.not. station%accepted) return

  fix_depth = int(station%fix_depth)
  select case(fix_depth)
  case(-1)
      return
  case(0)
      return      
  case(1)
! use Hanawa et al (1994) drop rate correction
      do k=1,station%levels
         dpth_orig = station%depth(k)
         if (dpth_orig .ne. missing_value) then
             dpth_new = (1.0417*dpth_orig) - (75.096*(1.0-((1.0-(0.0002063*dpth_orig)))**0.5))
             station%depth(k)=dpth_new
         endif
      enddo
      station%fix_depth=-1.0
  case (2)
! use Kizu et al (2005) correction
      do k=1,station%levels
         dpth_orig = station%depth(k)
         if (dpth_orig .ne. missing_value) then
             if (dpth_orig .le. 250.0) then
                 dpth_new = dpth_orig*0.9572
             else if (dpth_orig .le. 500.) then
                 dpth_new = dpth_orig*0.9565
             else if (dpth_orig .le. 750.0) then
                 dpth_new = dpth_orig*0.9558
             else if (dpth_orig .le. 1000.) then
                 dpth_new = dpth_orig*0.9550
             else if (dpth_orig .le. 1250.0) then
                 dpth_new = dpth_orig*0.9542
             else if (dpth_orig .le. 1500.0) then
                 dpth_new = dpth_orig*0.9533
             else
                 dpth_new = dpth_orig*0.9524
             endif
             station%depth(k)=dpth_new       
         endif
      enddo
      station%fix_depth=-1.0      
  case(103)
      do k=1,station%levels      
         dpth_orig = station%depth(k)
         if (dpth_orig .ne. missing_value) then
             tdrop=(s1*dpth_orig + s2) - s3
             dpth_new = sa*tdrop + sb*tdrop*tdrop
             station%depth(k)=dpth_new             
         endif
      enddo
      station%fix_depth=-1.0      
  case(104)
      do k=1,station%levels
         dpth_orig = station%depth(k)
         if (dpth_orig .ne. missing_value) then
             tdrop=(t1*dpth_orig + t2) - t3
             dpth_new = ta*tdrop + tb*tdrop*tdrop
             station%depth(k)=dpth_new             
         endif
      enddo
      station%fix_depth=-1.0      
  end select

  return
end subroutine xbt_drop_rate_adjust

end module xbt_adjust

#include "cosp_defs.H"
#ifdef COSP_GFDL
 
!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: cosp_radar.F90,v 20.0 2013/12/13 23:16:05 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

MODULE MOD_COSP_RADAR
  USE MOD_COSP_CONSTANTS
  USE MOD_COSP_TYPES
  USE MOD_COSP_UTILS
  use radar_simulator_types
  use array_lib
  use atmos_lib
  use format_input
  IMPLICIT NONE
  
  INTERFACE
    subroutine radar_simulator(freq,k2,do_ray,use_gas_abs,use_mie_table,mt, &
        nhclass,hp,nprof,ngate,nsizes,D,hgt_matrix,hm_matrix,re_matrix,p_matrix,t_matrix, &
        rh_matrix,Ze_non,Ze_ray,h_atten_to_vol,g_atten_to_vol,dBZe, &
        g_to_vol_in,g_to_vol_out)
  
        use m_mrgrnk 
        use array_lib
        use math_lib
        use optics_lib
        use radar_simulator_types
        implicit none
        ! ----- INPUTS -----  
        type(mie), intent(in) :: mt
        type(class_param) :: hp
#ifdef COSP_GFDL
        real*8, intent(in)    :: freq
        real*8, intent(inout) :: k2
#else
        real*8, intent(in) :: freq,k2
#endif
        integer, intent(in) ::  do_ray,use_gas_abs,use_mie_table, &
            nhclass,nprof,ngate,nsizes
        real*8, dimension(nsizes), intent(in) :: D
        real*8, dimension(nprof,ngate), intent(in) :: hgt_matrix, p_matrix, &
            t_matrix,rh_matrix
        real*8, dimension(nhclass,nprof,ngate), intent(in) :: hm_matrix
        real*8, dimension(nhclass,nprof,ngate), intent(inout) :: re_matrix
        ! ----- OUTPUTS -----
        real*8, dimension(nprof,ngate), intent(out) :: Ze_non,Ze_ray, &
            g_atten_to_vol,dBZe,h_atten_to_vol    
        ! ----- OPTIONAL -----
        real*8, optional, dimension(ngate,nprof) :: &
            g_to_vol_in,g_to_vol_out
     end subroutine radar_simulator
  END INTERFACE

CONTAINS

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------------- SUBROUTINE COSP_RADAR ------------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_RADAR(gbx,sgx,sghydro,z)
  IMPLICIT NONE

  ! Arguments
#ifdef COSP_GFDL
  type(cosp_gridbox),intent(inout) :: gbx  ! Gridbox info
#else
  type(cosp_gridbox),intent(in) :: gbx  ! Gridbox info
#endif
  type(cosp_subgrid),intent(in) :: sgx  ! Subgrid info
  type(cosp_sghydro),intent(in) :: sghydro  ! Subgrid info for hydrometeors
  type(cosp_sgradar),intent(inout) :: z ! Output from simulator, subgrid

  ! Local variables 
  real*8 :: &
  freq, &           ! radar frequency (GHz)
  k2                ! |K|^2, -1=use frequency dependent default
  
  real*8, dimension(:,:), allocatable :: &
  g_to_vol ! integrated atten due to gases, r>v (dB)
  
  real*8, dimension(:,:), allocatable :: &
  Ze_non, &         ! radar reflectivity withOUT attenuation (dBZ)
  Ze_ray, &         ! Rayleigh reflectivity (dBZ)
  h_atten_to_vol, &     ! attenuation by hydromets, radar to vol (dB)
  g_atten_to_vol, &     ! gaseous atteunation, radar to vol (dB)
  dBZe, &           ! effective radar reflectivity factor (dBZ)
  hgt_matrix, &         ! height of hydrometeors (km)
  t_matrix, &                   !temperature (k)
  p_matrix, &                   !pressure (hPa)
  rh_matrix                     !relative humidity (%)
  
  real*8, dimension(:,:,:), allocatable :: &
  hm_matrix, &          ! hydrometeor mixing ratio (g kg^-1)
  re_matrix

  integer, parameter :: one = 1
  logical :: hgt_reversed
  integer :: pr,i

! ----- main program settings ------

  freq = gbx%radar_freq
  k2 = gbx%k2
 
  !
  ! note:  intitialization section that was here has been relocated to SUBROUTINE CONSTRUCT_COSP_GRIDBOX by roj, Feb 2008
  !
  mt_ttl=gbx%mt_ttl  ! these variables really should be moved into the mt structure rather than kept as global arrays.
  mt_tti=gbx%mt_tti

  ! Inputs to Quickbeam
  allocate(hgt_matrix(gbx%Npoints,gbx%Nlevels),p_matrix(gbx%Npoints,gbx%Nlevels), &
           t_matrix(gbx%Npoints,gbx%Nlevels),rh_matrix(gbx%Npoints,gbx%Nlevels))
  allocate(hm_matrix(gbx%Nhydro,gbx%Npoints,gbx%Nlevels)) 
  allocate(re_matrix(gbx%Nhydro,gbx%Npoints,gbx%Nlevels))

  ! Outputs from Quickbeam
  allocate(Ze_non(gbx%Npoints,gbx%Nlevels))
  allocate(Ze_ray(gbx%Npoints,gbx%Nlevels))
  allocate(h_atten_to_vol(gbx%Npoints,gbx%Nlevels))
  allocate(g_atten_to_vol(gbx%Npoints,gbx%Nlevels))
  allocate(dBZe(gbx%Npoints,gbx%Nlevels))
  
  ! Optional argument. It is computed and returned in the first call to
  ! radar_simulator, and passed as input in the rest
  allocate(g_to_vol(gbx%Nlevels,gbx%Npoints))
  
  p_matrix   = gbx%p/100.0     ! From Pa to hPa
  hgt_matrix = gbx%zlev/1000.0 ! From m to km
  t_matrix   = gbx%T-273.15    ! From K to C
  rh_matrix  = gbx%q
  re_matrix  = 0.0
  
  ! Quickbeam assumes the first row is closest to the radar
  call order_data(hgt_matrix,hm_matrix,p_matrix,t_matrix, &
      rh_matrix,gbx%surface_radar,hgt_reversed)
  
  ! ----- loop over subcolumns -----
  do pr=1,sgx%Ncolumns
      !  atmospheric profiles are the same within the same gridbox
      !  only hydrometeor profiles will be different
      if (hgt_reversed) then  
         do i=1,gbx%Nhydro  
            hm_matrix(i,:,:) = sghydro%mr_hydro(:,pr,gbx%Nlevels:1:-1,i)*1000.0 ! Units from kg/kg to g/kg
            if (gbx%use_reff) then
              re_matrix(i,:,:) = sghydro%Reff(:,pr,gbx%Nlevels:1:-1,i)*1.e6     ! Units from m to micron
            endif
         enddo  
      else  
         do i=1,gbx%Nhydro
            hm_matrix(i,:,:) = sghydro%mr_hydro(:,pr,:,i)*1000.0 ! Units from kg/kg to g/kg
            if (gbx%use_reff) then
              re_matrix(i,:,:) = sghydro%Reff(:,pr,:,i)*1.e6       ! Units from m to micron
            endif
         enddo
      endif  

      !   ----- call radar simulator -----
      if (pr == 1) then ! Compute gaseous attenuation for all profiles
         call radar_simulator(freq,k2,gbx%do_ray,gbx%use_gas_abs,gbx%use_mie_tables,gbx%mt, &    !  v0.2: mt changed to gbx%mt, roj
           gbx%Nhydro,gbx%hp,gbx%Npoints,gbx%Nlevels,gbx%nsizes,gbx%D, &                         !  v0.2: hp->gbx%hp, D->gbx%d, nsizes->gbx%nsizes, roj
           hgt_matrix,hm_matrix,re_matrix,p_matrix,t_matrix,rh_matrix, &
           Ze_non,Ze_ray,h_atten_to_vol,g_atten_to_vol,dBZe,g_to_vol_out=g_to_vol)
      else ! Use gaseous atteunuation for pr = 1
         call radar_simulator(freq,k2,gbx%do_ray,gbx%use_gas_abs,gbx%use_mie_tables,gbx%mt, &
           gbx%Nhydro,gbx%hp,gbx%Npoints,gbx%Nlevels,gbx%nsizes,gbx%D, &
           hgt_matrix,hm_matrix,re_matrix,p_matrix,t_matrix,rh_matrix, &
           Ze_non,Ze_ray,h_atten_to_vol,g_atten_to_vol,dBZe,g_to_vol_in=g_to_vol)
      endif
      ! ----- BEGIN output section -----
      ! spaceborne radar : from TOA to SURFACE
      if (gbx%surface_radar == 1) then
        z%Ze_tot(:,pr,:)=dBZe(:,:)
      else if (gbx%surface_radar == 0) then ! Spaceborne
        z%Ze_tot(:,pr,:)=dBZe(:,gbx%Nlevels:1:-1)
      endif

  enddo !pr
  
  ! Change undefined value to one defined in COSP
  where (z%Ze_tot == -999.0) z%Ze_tot = R_UNDEF
  
  deallocate(hgt_matrix,p_matrix,t_matrix,rh_matrix)
  deallocate(hm_matrix,re_matrix, &
      Ze_non,Ze_ray,h_atten_to_vol,g_atten_to_vol,dBZe)
  deallocate(g_to_vol)
 
  ! deallocate(mt_ttl,mt_tti)   !v0.2: roj feb 2008 can not be done here,
                                !these variables now part of gbx structure and dealocated later

END SUBROUTINE COSP_RADAR

END MODULE MOD_COSP_RADAR

module auscom_ice_mod
!
!==========================================================================

! AusCOM modules:
use auscom_ice_parameters_mod

!MOM4 modules: 
use fms_mod,         only: file_exist
use fms_mod,         only: open_namelist_file, close_file, check_nml_error
use mpp_domains_mod, only: mpp_update_domains, domain2d
use mpp_mod,         only: mpp_broadcast, mpp_pe, mpp_npes
use mpp_mod,         only: FATAL, stdlog, stdout
use mpp_mod,         only: mpp_error 
use mpp_domains_mod, only: mpp_get_compute_domain, &
                           mpp_get_data_domain
use ocean_types_mod, only: ice_ocean_boundary_type, &
                           ocean_public_type
use ocean_types_mod, only: ocean_prog_tracer_type, &
                           ocean_diag_tracer_type, &
                           ocean_Thickness_type, &
                           ocean_grid_type, &
                           ocean_time_type, &
                           ocean_time_steps_type

! --- fix mom5/cice energy leaking (Fabio Dias - Russ Fiedler, 29/6/2017)
use constants_mod, only: rho0r  &  !(m^3/kg)  rho0r == 1.0/rho0
                        ,rho0   &  ! 1.035e3 kg/m^3 (rho_sw)
                        ,hlf      ! 3.34e5  J/kg

use ocean_parameters_mod,     only: rho_cp, cp_ocean ! from ocean_parameters
! - end fix.

#if defined(UNIT_TESTING)
use dump_field, only: dump_field_2d, dump_field_close
#endif

implicit none

real, dimension(:,:), allocatable :: &
          AQICE,     & ! accumulated ice form/melt flux (C*m)
          QICE         ! total column cooling from ice formation (in C*m) 
                       ! (ICEFLUX can be either time accumulated or averaged!)  

integer :: ATIME       ! accumulated time for ice formation calculation (s)  

real, dimension(:,:), allocatable :: &
          AQICE_redist,     & ! accumulated ice form/melt flux (C*m)
          QICE_redist         ! total column cooling from ice formation (in C*m) 
                       ! (ICEFLUX can be either time accumulated or averaged!)  

integer :: ATIME_redist       ! accumulated time for ice formation calculation (s)  

integer :: iisc, iiec, jjsc, jjec
!integer :: iisd, iied, jjsd, jjed, iisc, iiec, jjsc, jjec

real :: salref = 34.7           !psu, NOT as used in POP (i.e., msu)
real :: salice = 4.0            !psu, re-set as in CICE

real :: dt_ocean

contains

!============================================================================
subroutine auscom_ice_init(domain, Time_steps)

implicit none

type(domain2d) :: domain
type(ocean_time_steps_type) :: Time_steps
integer :: ioun, io_status, ierr

! provide for namelist over-ride of default values
  ioun =  open_namelist_file()
  read (ioun,auscom_ice_nml,IOSTAT=io_status)
  write (stdlog(),auscom_ice_nml)
  write (stdout(),*) 'auscom_ice_nml='
  write (stdout(),'(/)')
  write (stdout(),auscom_ice_nml)
  ierr = check_nml_error(io_status,'auscom_ice_nml')
  call close_file (ioun)

call mpp_get_compute_domain(domain,iisc,iiec,jjsc,jjec)

allocate(QICE (iisc:iiec,jjsc:jjec));     QICE(:,:)  = 0
allocate(AQICE(iisc:iiec,jjsc:jjec));     AQICE(:,:) = 0
allocate(QICE_redist (iisc:iiec,jjsc:jjec));     QICE_redist(:,:)  = 0
allocate(AQICE_redist(iisc:iiec,jjsc:jjec));     AQICE_redist(:,:) = 0

ATIME = 0
ATIME_redist = 0


dt_ocean = Time_steps%dtts

end subroutine auscom_ice_init

!============================================================================
subroutine auscom_ice_formation_new(Time,T_prog,Thickness, Frazil)
!
!calculate ice formation (including top layer and 'sub-surface' layers)
!adapted from POP (ice.F, v 1.11, dated 2003/01/28)
!

! Calculate Frazil as a diagnstic tracer. This should allow us to balance heat budgets

! Using pointers to array sections. Can use array syntax. Much clearer. POTICE now an ARRAY

implicit none

type(ocean_time_type), intent(in)           :: Time
type(ocean_prog_tracer_type), intent(inout),target :: T_prog(:)
type(ocean_Thickness_type), intent(in),target      :: Thickness
type(ocean_diag_tracer_type), intent(inout),target :: Frazil
!
!
real :: cp_over_lhfusion
       !cp_over_lhfusion = rho_sw*cp_sw/(latent_heat_fusion*rho_fw)
       !   (/deg C)        (J/m^3/deg C)      (J/kg)     (1000kg/m^3)
real :: epsilon = 1.0e-20       !as in POP

integer :: i, k, index_temp, index_salt, taup1
integer :: num_prog_tracers

real, pointer :: PTR_TEMP(:,:),PTR_SALT(:,:),PTR_THICK(:,:), PTR_FRAZIL(:,:)

real, dimension(:,:),allocatable ::  POTICE, TEMP_BEFORE

taup1=Time%taup1

! fix auscom now calculating cp_over_lhfusion:
cp_over_lhfusion = rho_cp/hlf/1000.0

num_prog_tracers = size(T_prog)
do i=1, num_prog_tracers
   if (T_prog(i)%name == 'temp') index_temp = i
   if (T_prog(i)%name == 'salt') index_salt = i
enddo

allocate(POTICE(iisc:iiec,jjsc:jjec),TEMP_BEFORE(iisc:iiec,jjsc:jjec))

!  initialize flux to zero
QICE   = 0.0

!-----------------------------------------------------------------------
! compute frazil ice formation for sub-surface layers. if ice
! forms in lower layers but layers above are warm - the heat is
! used to melt the ice. the ice formation occurs at salinity, Si.
! this volume is replaced with an equal volume at the salinity of
! the layer above. the total ice heat flux is accumulated.
!
! (???) WARNING: unless a monotone advection scheme is in place,
! advective errors could lead to temps that are far below freezing
! in some locations and this scheme will form lots of ice.
! ice formation should be limited to the top layer (kmxice=1)
! if the advection scheme is not monotone.
!-----------------------------------------------------------------------

POTICE = 0.0

do k = kmxice, 1, -1
   PTR_TEMP => T_prog(index_temp)%field(iisc:iiec,jjsc:jjec,k,taup1)
   PTR_SALT => T_prog(index_salt)%field(iisc:iiec,jjsc:jjec,k,taup1)
   PTR_THICK => Thickness%dzt(iisc:iiec,jjsc:jjec,k)
   PTR_FRAZIL => Frazil%field(iisc:iiec,jjsc:jjec,k)

#if defined(UNIT_TESTING)
    call dump_field_2d('ice_formation.input.temp', mpp_pe(), PTR_TEMP)
    call dump_field_2d('ice_formation.input.salt', mpp_pe(), PTR_SALT)
    call dump_field_2d('ice_formation.input.thickness', mpp_pe(), PTR_THICK)
    call dump_field_2d('ice_formation.input.frazil', mpp_pe(), PTR_FRAZIL)
#endif

   ! Save original temperature

   TEMP_BEFORE = PTR_TEMP


   !***
   !*** potice is the potential amount of ice formation
   !*** (potice>0) or melting (potice<0) in layer k
   !***

   POTICE = (-0.054* PTR_SALT - PTR_TEMP) * PTR_THICK

   !***
   !*** if POTICE < 0, use the heat to melt any ice from lower layers
   !*** if POTICE > 0, keep on freezing (QICE < 0)
   !***

   POTICE = max(POTICE, QICE)

   !***
   !*** adjust tracer values based on freeze/melt
   !***

   PTR_TEMP = PTR_TEMP + POTICE / PTR_THICK

   if (iceform_adj_salt) then 
      PTR_SALT = PTR_SALT + (salref - salice) * POTICE * cp_over_lhfusion / PTR_THICK
   endif

   QICE = QICE - POTICE  ! accumulate (vertically) freezing potential


 !-----------------------------------------------------------------------
 !
 ! let any residual heat in the upper layer melt previously formed ice
 !
 !-----------------------------------------------------------------------

  if ( k == 1 ) then
     AQICE = AQICE + QICE       !in degC*m

 !-----------------------------------------------------------------------
 !
 ! recalculate freezing potential based on adjusted T, S.  only interested 
 ! in melt potential now (POTICE < 0) -------- use this melt to offset any 
 ! accumulated freezing (AQICE < 0) and adjust T,S to reflect this melting 
 !
 !-----------------------------------------------------------------------

     POTICE = (-0.054* PTR_SALT - PTR_TEMP) * PTR_THICK

 !surface layer ice form[>0]/melt[<0] potential

     POTICE = max(POTICE, AQICE)
 !tricky......
     AQICE = AQICE - POTICE

 !
 ! adjust T, S again:
 !

    PTR_TEMP = PTR_TEMP + POTICE / PTR_THICK

    if (iceform_adj_salt) then 
       PTR_SALT = PTR_SALT + (salref - salice) * POTICE * cp_over_lhfusion / PTR_THICK
    endif

   

 !-----------------------------------------------------------------------
 !
 ! compute the heat flux for input to the sea ice model. 
 ! note that either:
 !   AQICE<0 and SST=Tfreeze => qflux = -AQICE >0 (net ice made), or  
 !   AQICE=0 and SST>Tfreeze => qflux ~ Tfreeze-SST <0 (melt potential)
 !
 ! REMARK: qflux ( QICE below) is needed only if it's time to communicate
 !         with oasis. however, in order to isolate this subroutine from 
 !         any coupling details, qflux is computed at every ocean time 
 !         step (but only the last calculated one is sent to oasis/ice). 
 !         Note qflux will be converted to W/m^2 later in get_o2i_fields
 !         when coupling actually happens.
 !-----------------------------------------------------------------------

    POTICE = (-0.054* PTR_SALT - PTR_TEMP) * PTR_THICK
    QICE = POTICE - AQICE 

  endif

 !-----------------------------------------------------------------------
 !  Calculate total change to Temperature and therefore heat due to Frazil
 !-----------------------------------------------------------------------

  PTR_FRAZIL = rho_cp * frazil_factor * ( PTR_TEMP - TEMP_BEFORE) * PTR_THICK 

#if defined(UNIT_TESTING)
    call dump_field_2d('ice_formation.output.frazil', mpp_pe(), PTR_FRAZIL)
    call dump_field_2d('ice_formation.output.qice', mpp_pe(), QICE)
#endif

enddo  !loop k = kmxice, 1, -1

ATIME = ATIME + dt_ocean

#if defined(UNIT_TESTING)
    call dump_field_2d('ice_formation.output.atime', mpp_pe(), &
                       reshape((/ float(ATIME) /), (/ 1, 1 /)))
#endif

deallocate(TEMP_BEFORE,POTICE)

end subroutine auscom_ice_formation_new

!============================================================================
subroutine auscom_ice_formation_new_redist(Time,T_prog,Thickness, Frazil)

! Special version for the redistributin of heat FAFMIP experiments.
! Note that this routine needs to be called before the regular version
!It is possoble to change the salt. We save the incoming salt and reset it
!before exiting.
!
!calculate ice formation (including top layer and 'sub-surface' layers)
!adapted from POP (ice.F, v 1.11, dated 2003/01/28)
!

! Calculate Frazil as a diagnstic tracer. This should allow us to balance heat budgets

! Using pointers to array sections. Can use array syntax. Much clearer. POTICE now an ARRAY

implicit none

type(ocean_time_type), intent(in)           :: Time
type(ocean_prog_tracer_type), intent(inout),target :: T_prog(:)
type(ocean_Thickness_type), intent(in),target      :: Thickness
type(ocean_diag_tracer_type), intent(inout),target :: Frazil
!
!
real :: cp_over_lhfusion
       !cp_over_lhfusion = rho_sw*cp_sw/(latent_heat_fusion*rho_fw)
       !   (/deg C)        (J/m^3/deg C)      (J/kg)     (1000kg/m^3)
real :: epsilon = 1.0e-20       !as in POP

integer :: i, k
integer :: index_temp_redist = -1
integer ::  index_salt = -1
integer :: taup1
integer :: num_prog_tracers

real, pointer :: PTR_TEMP(:,:),PTR_SALT(:,:),PTR_THICK(:,:), PTR_FRAZIL(:,:)

real, dimension(:,:),allocatable ::  POTICE, TEMP_BEFORE, SALT_BEFORE

taup1=Time%taup1

! fix auscom now calculating cp_over_lhfusion:
cp_over_lhfusion = rho_cp/hlf/1000.0

num_prog_tracers = size(T_prog)
do i=1, num_prog_tracers
   if (T_prog(i)%name == 'redist_heat') index_temp_redist = i
   if (T_prog(i)%name == 'salt') index_salt = i
enddo

if ( index_temp_redist == -1 .or. index_salt == -1 ) then
    call mpp_error(FATAL, '==>Error: auscom_ice_mod: Redistributed tracer indices not found')
endif

allocate(POTICE(iisc:iiec,jjsc:jjec),TEMP_BEFORE(iisc:iiec,jjsc:jjec))
allocate(SALT_BEFORE(iisc:iiec,jjsc:jjec))

!  initialize flux to zero
QICE_redist   = 0.0

!-----------------------------------------------------------------------
! compute frazil ice formation for sub-surface layers. if ice
! forms in lower layers but layers above are warm - the heat is
! used to melt the ice. the ice formation occurs at salinity, Si.
! this volume is replaced with an equal volume at the salinity of
! the layer above. the total ice heat flux is accumulated.
!
! (???) WARNING: unless a monotone advection scheme is in place,
! advective errors could lead to temps that are far below freezing
! in some locations and this scheme will form lots of ice.
! ice formation should be limited to the top layer (kmxice=1)
! if the advection scheme is not monotone.
!-----------------------------------------------------------------------

POTICE = 0.0

do k = kmxice, 1, -1
   PTR_TEMP => T_prog(index_temp_redist)%field(iisc:iiec,jjsc:jjec,k,taup1)
   PTR_SALT => T_prog(index_salt)%field(iisc:iiec,jjsc:jjec,k,taup1)
   PTR_THICK => Thickness%dzt(iisc:iiec,jjsc:jjec,k)
   PTR_FRAZIL => Frazil%field(iisc:iiec,jjsc:jjec,k)


   ! Save original temperature

   TEMP_BEFORE = PTR_TEMP
   SALT_BEFORE = PTR_SALT


   !***
   !*** potice is the potential amount of ice formation
   !*** (potice>0) or melting (potice<0) in layer k
   !***

   POTICE = (-0.054* PTR_SALT - PTR_TEMP) * PTR_THICK

   !***
   !*** if POTICE < 0, use the heat to melt any ice from lower layers
   !*** if POTICE > 0, keep on freezing (QICE < 0)
   !***

   POTICE = max(POTICE, QICE_redist)

   !***
   !*** adjust tracer values based on freeze/melt
   !***

   PTR_TEMP = PTR_TEMP + POTICE / PTR_THICK
   if (iceform_adj_salt) then 
      PTR_SALT = PTR_SALT + (salref - salice) * POTICE * cp_over_lhfusion / PTR_THICK
   endif

   QICE_redist = QICE_redist - POTICE  ! accumulate (vertically) freezing potential


 !-----------------------------------------------------------------------
 !
 ! let any residual heat in the upper layer melt previously formed ice
 !
 !-----------------------------------------------------------------------

  if ( k == 1 ) then
     AQICE_redist = AQICE_redist + QICE_redist       !in degC*m

 !-----------------------------------------------------------------------
 !
 ! recalculate freezing potential based on adjusted T, S.  only interested 
 ! in melt potential now (POTICE < 0) -------- use this melt to offset any 
 ! accumulated freezing (AQICE < 0) and adjust T,S to reflect this melting 
 !
 !-----------------------------------------------------------------------

     POTICE = (-0.054* PTR_SALT - PTR_TEMP) * PTR_THICK

 !surface layer ice form[>0]/melt[<0] potential

     POTICE = max(POTICE, AQICE_redist)
 !tricky......
     AQICE_redist = AQICE_redist - POTICE

 !
 ! adjust T, S again:
 !

    PTR_TEMP = PTR_TEMP + POTICE / PTR_THICK

    if (iceform_adj_salt) then 
       PTR_SALT = PTR_SALT + (salref - salice) * POTICE * cp_over_lhfusion / PTR_THICK
    endif

   

 !-----------------------------------------------------------------------
 !
 ! compute the heat flux for input to the sea ice model. 
 ! note that either:
 !   AQICE<0 and SST=Tfreeze => qflux = -AQICE >0 (net ice made), or  
 !   AQICE=0 and SST>Tfreeze => qflux ~ Tfreeze-SST <0 (melt potential)
 !
 ! REMARK: qflux ( QICE below) is needed only if it's time to communicate
 !         with oasis. however, in order to isolate this subroutine from 
 !         any coupling details, qflux is computed at every ocean time 
 !         step (but only the last calculated one is sent to oasis/ice). 
 !         Note qflux will be converted to W/m^2 later in get_o2i_fields
 !         when coupling actually happens.
 !-----------------------------------------------------------------------

    POTICE = (-0.054* PTR_SALT - PTR_TEMP) * PTR_THICK
    QICE_redist = POTICE - AQICE_redist 

  endif

 !-----------------------------------------------------------------------
 !  Calculate total change to Temperature and therefore heat due to Frazil
 !-----------------------------------------------------------------------

  PTR_FRAZIL = rho_cp * frazil_factor * ( PTR_TEMP - TEMP_BEFORE) * PTR_THICK 

! Reset salt to it original value if it has changed since we need to preserve
! its value
  if (iceform_adj_salt) then 
     PTR_SALT = SALT_BEFORE
  endif

enddo  !loop k = kmxice, 1, -1

ATIME_redist = ATIME_redist + dt_ocean

deallocate(TEMP_BEFORE,POTICE, SALT_BEFORE)

end subroutine auscom_ice_formation_new_redist

!=========================================================================
subroutine auscom_ice_heatflux_new(Ocean_sfc)
!
! convert the iceflux m*degC into W/m^2 as required by ice model and set 
! the accumulated AQICE and ATIME back to zero. 
! called once in a coupling interval before calling get_o2i_fields.
! Now also resets FAFMIP values.
! In FAFMIP runs the heat flux is based on the redistributed heat tracer.

implicit none
type (ocean_public_type) :: Ocean_sfc

integer :: i, j

! If ATIME_redist > 0 then we know that the correct heat flux for frazil should
! be based on the redistributed heat in a FAFMIP type 2 heat experiment.

if ( ATIME_redist > 0 ) then

   do j = jjsc, jjec
      do i = iisc, iiec

        Ocean_sfc%frazil(i,j) = QICE_redist(i,j) * frazil_factor * rho_cp / float(ATIME_redist)
  ! here ATIME_redist can be accumulated time (seconds) in a coupling interval 
  ! or just the ocean time step, depending how often the ice_formation_new
  ! is called  (21/07/2008, E. Hunke suggested POP calls ice_foramtion
  !                         once per coupling interval) 

      enddo
   enddo

else

   do j = jjsc, jjec
      do i = iisc, iiec

           Ocean_sfc%frazil(i,j) = QICE(i,j) * frazil_factor * rho_cp / float(ATIME)
  ! here ATIME can be accumulated time (seconds) in a coupling interval 
  ! or just the ocean time step, depending how often the ice_formation_new
  ! is called  (21/07/2008, E. Hunke suggested POP calls ice_foramtion
  !                         once per coupling interval) 

      enddo
   enddo
endif

AQICE = 0.0
ATIME = 0
AQICE_redist = 0.0
ATIME_redist = 0

#if defined(UNIT_TESTING)
    call dump_field_2d('ice_heatflux.output.frazil', mpp_pe(), Ocean_sfc%frazil)
#endif

end subroutine auscom_ice_heatflux_new

!===========================================================================
end module auscom_ice_mod

              module donner_types_mod

character(len=128)   :: version = '$Id: donner_types.F90,v 13.0 2006/03/28 21:08:57 fms Exp $'
public

# include "donner_types.h"






            end module donner_types_mod

module vert_coordinate_mod

!=======================================================================
!
!                          VERT_COORDINATE MODULE
!
!                Sets the coefficients a and b that define 
!                    the generalized vertical coordinate
!
!=======================================================================

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, &
                   write_version_number, stdlog, close_file, &
                   check_nml_error

use constants_mod, only: pi

implicit none
private

public :: compute_vert_coord

!=======================================================================
! subroutine compute_vert_coord (vert_coord_option, scale_heights, surf_res, exponent, p_press, p_sigma, a, b)
!
! output:
!
!    real, dimension(:) :: a, b
!
!          a and b should be dimensioned by the number of interfaces
!                  = 1 + number of levels
!
!          these constants are intended for use in a model in which
!             the pressure at the interfaces will then be given
!
!                     p = a*p_ref + b*p_surf
!
!         where p_ref  is a constant reference pressure 
!           and p_surf is the instantaneous surface pressure
!      
!
!=======================================================================

character(len=128), parameter :: version = &
'$Id: vert_coordinate.F90,v 19.0 2012/01/06 20:35:42 fms Exp $'

character(len=128), parameter :: tagname = &
'$Name: tikal $'

character(len=8) :: ch_tmp
logical :: entry_to_logfile_done = .false.

integer, parameter :: max_levels=100
real, dimension(max_levels+1) :: pk, bk

namelist /vert_coordinate_nml/ pk, bk

contains

!=======================================================================

subroutine compute_vert_coord (vert_coord_option, scale_heights, surf_res, exponent, p_press, p_sigma, reference_press, a, b)

character(len=*), intent(in) :: vert_coord_option
real,    intent(in) :: scale_heights, surf_res, exponent, p_press, p_sigma, reference_press
real,    intent(out), dimension(:) :: a, b

real, dimension(size(a,1)) :: a_sigma, b_sigma, a_press, b_press, f
character(len=32) :: chtmp='size(a)=      size(b)=          '
character(len=16) :: chtmp2, chtmp3

if(.not.entry_to_logfile_done) then
  call write_version_number(version, tagname)
  entry_to_logfile_done = .true.
endif

if(size(a,1).ne.size(b,1)) then
  write(chtmp( 9:12),'(i4)') size(a,1)
  write(chtmp(23:26),'(i4)') size(b,1)
  call error_mesg('compute_vert_coord', 'size(a) does not equal size(b). '//chtmp, FATAL)
endif

if(trim(vert_coord_option) == 'uneven_sigma' .or. trim(vert_coord_option) == 'hybrid') then
  if(scale_heights == 0.) then
    call error_mesg('compute_vert_coord',' zero is an invalid value for scale_heights.', FATAL)
  endif
  if(exponent == 0.) then
    call error_mesg('compute_vert_coord',' zero is an invalid value for exponent.', FATAL)
  endif
  if(surf_res <= 0. .or. surf_res > 1.0 ) then
    write(chtmp2,'(1pe16.8)') surf_res
    call error_mesg('compute_vert_coord', &
     'the namelist parameter surf_res must be < 1.0, but surf_res='//chtmp2, FATAL)
  endif
endif

if(trim(vert_coord_option) == 'hybrid') then
  if(p_sigma < p_press) then 
    write(chtmp2,'(1pe16.8)') p_sigma
    write(chtmp3,'(1pe16.8)') p_press
    call error_mesg('compute_vert_coord', &
     ' p_sigma must be greater than p_press, but p_sigma='//chtmp2//'  p_press='//chtmp3, FATAL)
  endif
endif

!--------------------------------------------------------------------

if(trim(vert_coord_option) == 'input') then
  call read_namelist(a,b)
else if(trim(vert_coord_option) == 'even_sigma') then
  call compute_even_sigma(a, b)
else if(trim(vert_coord_option) == 'uneven_sigma') then
  call compute_uneven_sigma(a, b, scale_heights, surf_res, exponent, .true.)
else if(trim(vert_coord_option) == 'hybrid') then
  call compute_uneven_sigma(a_sigma, b_sigma, scale_heights, surf_res, exponent, .false.)
  call compute_uneven_sigma(b_press, a_press, scale_heights, surf_res, exponent, .false.)
  f = transition(b_sigma, p_sigma, p_press)
  a = a_sigma*f + a_press*(1.0 - f)
  b = b_sigma*f + b_press*(1.0 - f)
  a = reference_press*a
else if(trim(vert_coord_option) == 'mcm') then
  call compute_old_model_sigma(a, b)
else if(trim(vert_coord_option) == 'v197') then
  call compute_v197_sigma(a, b)
else
  call error_mesg('compute_vert_coord','"'//trim(vert_coord_option)//'" is not a valid value for vert_coord_option.', FATAL)
end if

return
end subroutine compute_vert_coord

!-------------------------------------------------------------------------

function transition(p, p_sigma, p_press) result(t)

real, intent(in), dimension(:) :: p
real, intent(in)               :: p_sigma, p_press
real, dimension(size(p,1))       :: t

real    :: x, xx
integer :: k

do k = 1, size(p,1)
  if(p(k) <= p_press) then
    t(k) = 0.0
  else if(p(k) >= p_sigma) then
    t(k) = 1.0
  else
    x  = p(k)    - p_press
    xx = p_sigma - p_press
    t(k) = (sin(0.5*pi*x/xx))**2
  end if
enddo

return
end function transition

!-----------------------------------------------------------------------

subroutine read_namelist (a, b)

real, intent (out), dimension(:) :: a, b
integer :: namelist_unit, ierr, io

pk = 0.
bk = 0.

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=vert_coordinate_nml, iostat=io)
    ierr = check_nml_error(io, 'vert_coordinate_nml')
#else
    namelist_unit = open_namelist_file()
    ierr=1
    do while (ierr /= 0)
      read(namelist_unit, nml=vert_coordinate_nml, iostat=io, end=20)
      ierr = check_nml_error (io, 'vert_coordinate_nml')
    enddo
20  call close_file (namelist_unit)
#endif

if(mpp_pe() == mpp_root_pe()) write (stdlog(), nml=vert_coordinate_nml)

if(pk(2)+bk(2) == 0.) then
  call error_mesg('read_namelist in vert_coordinate_mod','No levels specified in namelist vert_coordinate_nml &
                  & or namelist is missing ', FATAL)
endif

if(pk(size(a,1))+bk(size(b,1)) == 0.) then
  call error_mesg('read_namelist in vert_coordinate_mod','Not enough levels specified in namelist vert_coordinate_nml', FATAL)
endif

if(pk(size(a,1)+1)+bk(size(b,1)+1) /= 0.) then
  call error_mesg('read_namelist in vert_coordinate_mod','Too many levels specified in namelist vert_coordinate_nml', FATAL)
endif

a = pk(1:size(a,1))
b = bk(1:size(b,1))

return
end subroutine read_namelist
!-----------------------------------------------------------------------

subroutine compute_even_sigma (a, b)

real, intent (out), dimension(:) :: a, b
integer :: k, num_levels

num_levels = size(a,1)-1

a = 0.0
do k=1,num_levels
  b(k) = float(k - 1)/float(num_levels)
end do
b(num_levels+1) = 1.0

return
end subroutine compute_even_sigma

!-------------------------------------------------------------------------

subroutine compute_uneven_sigma (a, b, scale_heights, surf_res, exponent, zero_top)

real,    intent (out), dimension(:) :: a, b
real,    intent (in) :: scale_heights, surf_res, exponent
logical, intent (in) :: zero_top

integer :: k, num_levels
real :: z, zeta, s2

num_levels = size(a,1)-1

a = 0.0

s2 = 1.0 - surf_res

do k=1,num_levels
  zeta = (1.-(float(k-1)/float(num_levels)))
  z  = surf_res*zeta + s2*(zeta**exponent)
  b(k) = exp(-z*scale_heights)
end do

b(num_levels+1) = 1.0
if(zero_top) b(1) = 0.0

return
end subroutine compute_uneven_sigma

!-------------------------------------------------------------------------
subroutine compute_v197_sigma(a, b)
real, intent (out), dimension(:) :: a, b

integer :: num_levels

num_levels = size(b,1)-1
if(num_levels /= 18) then
  write(ch_tmp,'(i8)') num_levels
  call error_mesg('compute_v197_sigma','num_levels='//ch_tmp//' It must be 18', FATAL)
endif

b = (/0.0, .0089163, .0342936, .0740741, .1262002, .1886145, .2592592, & 
           .3360768, .4170096, .5000000, .5829904, .6639231, .7407407, & 
           .8113854, .8737997, .9259259, .9657064, .9910837, 1.0/)

a = 0.

return
end subroutine compute_v197_sigma
!-------------------------------------------------------------------------
subroutine compute_old_model_sigma(a, b)
real, intent (out), dimension(:) :: a, b

integer :: num_levels

num_levels = size(b,1)-1
if(num_levels /= 14) then
  write(ch_tmp,'(i8)') num_levels
  call error_mesg('compute_old_model_sigma','num_levels='//ch_tmp//' It must be 14', FATAL)
endif
b = (/0.0,.03,.0707,.1311,.2102,.3036,.4062,.5138,.6226,.7284,.8255,.9066,.9640,.9933,1.0/)
a = 0.

return
end subroutine compute_old_model_sigma
!-------------------------------------------------------------------------
end module vert_coordinate_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: MISR_simulator.F,v 20.0 2013/12/13 23:15:55 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif
! 
! Copyright (c) 2009,  Roger Marchand, version 1.2
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list of 
!       conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list 
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the University of Washington nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
! BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
! SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
! INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!

#ifdef COSP_GFDL
      SUBROUTINE MISR_simulator(
     &     npoints,
     &     nlev,
     &     ncol,
     &     sunlit,
     &     zfull,
     &     at,
     &     dtau_s,
     &     dtau_c,
     &     frac_out,
     &     missing_value, 
     &     fq_MISR_TAU_v_CTH,
     &     dist_model_layertops,
     &     MISR_mean_ztop,
     &     MISR_cldarea,
     &     dtau_col 
     & )
#else
      SUBROUTINE MISR_simulator(
     &     npoints,
     &     nlev,
     &     ncol,
     &     sunlit,
     &     zfull,
     &     at,
     &     dtau_s,
     &     dtau_c,
     &     frac_out,
     &     missing_value,
     &     fq_MISR_TAU_v_CTH,
     &     dist_model_layertops,
     &     MISR_mean_ztop,
     &     MISR_cldarea
     & )
#endif
    

      implicit none
      integer n_MISR_CTH
      parameter(n_MISR_CTH=16)
         
!     -----
!     Input 
!     -----

      INTEGER npoints                   !  if ncol ==1, the number of model points in the horizontal grid  
                            !   else    the number of GCM grid points
                            
      INTEGER nlev                      !  number of model vertical levels
      
      INTEGER ncol                      !  number of model sub columns 
                        !  (must already be generated in via scops and passed to this
                        !   routine via the variable frac_out )
  
      INTEGER sunlit(npoints)           !  1 for day points, 0 for night time

      REAL zfull(npoints,nlev)          !  height (in meters) of full model levels (i.e. midpoints)
                                        !  zfull(npoints,1)    is    top level of model
                                        !  zfull(npoints,nlev) is bottom level of model (closest point to surface)  

      REAL at(npoints,nlev)             !  temperature in each model level (K)
 
      REAL dtau_s(npoints,nlev)         !  visible wavelength cloud optical depth ... for "stratiform" condensate
                                        !  NOTE:  this the cloud optical depth of only the
                    !     the model cell (i,j)
                    
      REAL dtau_c(npoints,nlev)         !  visible wavelength cloud optical depth ... for "convective" condensate
                                        !  NOTE:  this the cloud optical depth of only the
                    !     the model cell (i,j)
                                     
      REAL frac_out(npoints,ncol,nlev)  !  NOTE: only need if columns>1 ... subgrid scheme in use.
      
      REAL missing_value
#ifdef COSP_GFDL
      REAL,optional ::          dtau_col(npoints,ncol,nlev)
                               ! tau values obtained from model
                               ! stochastic columns


#endif
                                 
!     ------
!     Outputs
!     ------
            
      REAL fq_MISR_TAU_v_CTH(npoints,7,n_MISR_CTH)      
      REAL dist_model_layertops(npoints,n_MISR_CTH)
      REAL MISR_cldarea(npoints)               ! fractional area coverged by clouds 
      REAL MISR_mean_ztop(npoints)             ! mean cloud top hieght(m) MISR would observe
                                   ! NOTE: == 0 if area ==0
                            

!     ------
!     Working variables 
!     ------

      REAL tau(npoints,ncol)        ! total column optical depth ... 

      INTEGER j,ilev,ilev2,ibox,k
      INTEGER itau
         
      LOGICAL box_cloudy(npoints,ncol)
      
      real isccp_taumin
      real boxarea
      real tauchk
      REAL box_MISR_ztop(npoints,ncol)  ! cloud top hieght(m) MISR would observe
      
      integer thres_crossed_MISR 
      integer loop,iMISR_ztop
      
      real dtau, cloud_dtau, MISR_penetration_height,ztest     
      
      real MISR_CTH_boundaries(n_MISR_CTH+1)
      
      DATA MISR_CTH_boundaries / -99, 0, 0.5, 1, 1.5, 2, 2.5, 3,
     c                    4, 5, 7, 9, 11, 13, 15, 17, 99 /
      
      DATA isccp_taumin / 0.3 /
    
      tauchk = -1.*log(0.9999999)
        
      !
      ! For each GCM cell or horizontal model grid point ...
      ! 
      do j=1,npoints    

         !
         !  estimate distribution of Model layer tops
         !  
         dist_model_layertops(j,:)=0

       do ilev=1,nlev 
            
        ! define location of "layer top"
        if(ilev.eq.1 .or. ilev.eq.nlev) then
            ztest=zfull(j,ilev)
        else
            ztest=0.5*(zfull(j,ilev)+zfull(j,ilev-1)) 
        endif   

        ! find MISR layer that contains this level
        ! note, the first MISR level is "no height" level
        iMISR_ztop=2
        do loop=2,n_MISR_CTH
        
            if ( ztest .gt.
     &                1000*MISR_CTH_boundaries(loop+1) ) then
        
                iMISR_ztop=loop+1
            endif
        enddo

        dist_model_layertops(j,iMISR_ztop)=
     &          dist_model_layertops(j,iMISR_ztop)+1
       enddo
    
    
         !
         ! compute total cloud optical depth for each column
         !       
       do ibox=1,ncol     
       
        ! Initialize tau to zero in each subcolum
            tau(j,ibox)=0. 
        box_cloudy(j,ibox)=.false.
        box_MISR_ztop(j,ibox)=0  
        
        ! initialize threshold detection for each sub column 
        thres_crossed_MISR=0;
       
        do ilev=1,nlev
     
#ifdef COSP_GFDL
           if (present(dtau_col)) then
                 dtau = dtau_col(j,ibox,ilev)
              else
#endif    
             dtau=0
             
             if (frac_out(j,ibox,ilev).eq.1) then
                        dtau = dtau_s(j,ilev)
                 endif
                 
                 if (frac_out(j,ibox,ilev).eq.2) then
                        dtau = dtau_c(j,ilev)
                 end if 
                 
#ifdef COSP_GFDL
              endif
#endif
             tau(j,ibox)=tau(j,ibox)+ dtau
              
                     
        ! NOW for MISR ..
        ! if there a cloud ... start the counter ... store this height
        if(thres_crossed_MISR .eq. 0 .and. dtau .gt. 0.) then
        
            ! first encountered a "cloud"
            thres_crossed_MISR=1  
            cloud_dtau=0            
        endif   
                
        if( thres_crossed_MISR .lt. 99 .and.
     &              thres_crossed_MISR .gt. 0 ) then
     
                if( dtau .eq. 0.) then
        
                    ! we have come to the end of the current cloud
                ! layer without yet selecting a CTH boundary.
                ! ... restart cloud tau counter 
                cloud_dtau=0
            else
                ! add current optical depth to count for 
                ! the current cloud layer
                cloud_dtau=cloud_dtau+dtau
            endif
                
            ! if the cloud is continuous but optically thin (< 1)
            ! from above the current layer cloud top to the current level
            ! then MISR will like see a top below the top of the current 
            ! layer
            if( dtau.gt.0 .and. (cloud_dtau-dtau) .lt. 1) then
            
                if(dtau .lt. 1 .or. ilev.eq.1 .or. ilev.eq.nlev) then

                    ! MISR will likely penetrate to some point
                    ! within this layer ... the middle
                    MISR_penetration_height=zfull(j,ilev)

                else
                    ! take the OD = 1.0 level into this layer
                    MISR_penetration_height=
     &                     0.5*(zfull(j,ilev)+zfull(j,ilev-1)) - 
     &                     0.5*(zfull(j,ilev-1)-zfull(j,ilev+1))
     &                  /dtau 
                endif   

                box_MISR_ztop(j,ibox)=MISR_penetration_height
                
            endif
        
            ! check for a distinctive water layer
            if(dtau .gt. 1 .and. at(j,ilev).gt.273 ) then
     
                    ! must be a water cloud ... 
                ! take this as CTH level
                thres_crossed_MISR=99
            endif
        
            ! if the total column optical depth is "large" than
            ! MISR can't seen anything else ... set current point as CTH level
            if(tau(j,ibox) .gt. 5) then 

                thres_crossed_MISR=99           
            endif

        endif ! MISR CTH booundary not set
        
        enddo  !ilev - loop over vertical levesl
    
        ! written by roj 5/2006
        ! check to see if there was a cloud for which we didn't 
        ! set a MISR cloud top boundary
        if( thres_crossed_MISR .eq. 1) then
    
        ! if the cloud has a total optical depth of greater
        ! than ~ 0.5 MISR will still likely pick up this cloud
        ! with a height near the true cloud top
        ! otherwise there should be no CTH
        if( tau(j,ibox) .gt. 0.5) then

            ! keep MISR detected CTH
            
        elseif(tau(j,ibox) .gt. 0.2) then

            ! MISR may detect but wont likley have a good height
            box_MISR_ztop(j,ibox)=-1
            
        else
            ! MISR not likely to even detect.
            ! so set as not cloudy
            box_MISR_ztop(j,ibox)=0

        endif
                        
        endif
    
       enddo  ! loop of subcolumns
       enddo    ! loop of gridpoints
       

        !     
        !   Modify MISR CTH for satellite spatial / pattern matcher effects
    !
    !   Code in this region added by roj 5/2006 to account
    !   for spatial effect of the MISR pattern matcher.
    !   Basically, if a column is found between two neighbors
    !   at the same CTH, and that column has no hieght or
    !   a lower CTH, THEN misr will tend to but place the
    !   odd column at the same height as it neighbors.
    !
    !   This setup assumes the columns represent a about a 1 to 4 km scale
    !   it will need to be modified significantly, otherwise
        if(ncol.eq.1) then
    
       ! adjust based on neightboring points ... i.e. only 2D grid was input
           do j=2,npoints-1
            
            if(box_MISR_ztop(j-1,1).gt.0 .and. 
     &             box_MISR_ztop(j+1,1).gt.0       ) then

                if( abs( box_MISR_ztop(j-1,1) -  
     &                   box_MISR_ztop(j+1,1) ) .lt. 500 
     &              .and.
     &                   box_MISR_ztop(j,1) .lt. 
     &                   box_MISR_ztop(j+1,1)     ) then
            
                    box_MISR_ztop(j,1) =
     &                      box_MISR_ztop(j+1,1)    
                endif

            endif
         enddo
        else
         
         ! adjust based on neighboring subcolumns ....
#ifdef COSP_GFDL
!RSH ADDS j loop and uses j as index rather than just j=1:
          do j=1,npoints
#endif
         do ibox=2,ncol-1
            
#ifndef COSP_GFDL
            if(box_MISR_ztop(1,ibox-1).gt.0 .and. 
     &             box_MISR_ztop(1,ibox+1).gt.0        ) then

                if( abs( box_MISR_ztop(1,ibox-1) -  
     &                   box_MISR_ztop(1,ibox+1) ) .lt. 500 
     &              .and.
     &                   box_MISR_ztop(1,ibox) .lt. 
     &                   box_MISR_ztop(1,ibox+1)     ) then
            
                    box_MISR_ztop(1,ibox) =
     &                      box_MISR_ztop(1,ibox+1)    
#else

            if(box_MISR_ztop(j,ibox-1).gt.0 .and. 
     &             box_MISR_ztop(j,ibox+1).gt.0        ) then

                if( abs( box_MISR_ztop(j,ibox-1) -  
     &                   box_MISR_ztop(j,ibox+1) ) .lt. 500 
     &              .and.
     &                   box_MISR_ztop(j,ibox) .lt. 
     &                   box_MISR_ztop(j,ibox+1)     ) then
            
                    box_MISR_ztop(j,ibox) =
     &                      box_MISR_ztop(j,ibox+1)    
#endif
                endif

            endif
         enddo
#ifdef COSP_GFDL
         enddo
#endif
      
        endif

        !     
    !     DETERMINE CLOUD TYPE FREQUENCIES
    !
    !     Now that ztop and tau have been determined, 
    !     determine amount of each cloud type
        boxarea=1./real(ncol)  
        do j=1,npoints 

         ! reset frequencies -- modified loop structure, roj 5/2006 
         do ilev=1,7  ! "tau loop"  
            do  ilev2=1,n_MISR_CTH                      
            fq_MISR_TAU_v_CTH(j,ilev,ilev2)=0.     
            enddo
         enddo
           
         MISR_cldarea(j)=0.
         MISR_mean_ztop(j)=0.

         do ibox=1,ncol

            if (tau(j,ibox) .gt. (tauchk)) then
               box_cloudy(j,ibox)=.true.
            endif
  
            itau = 0
        
            if (box_cloudy(j,ibox)) then
    
          !determine optical depth category
              if (tau(j,ibox) .lt. isccp_taumin) then
                  itau=1
              else if (tau(j,ibox) .ge. isccp_taumin                                    
     &          .and. tau(j,ibox) .lt. 1.3) then
                  itau=2
              else if (tau(j,ibox) .ge. 1.3 
     &          .and. tau(j,ibox) .lt. 3.6) then
                  itau=3
              else if (tau(j,ibox) .ge. 3.6 
     &          .and. tau(j,ibox) .lt. 9.4) then
                  itau=4
              else if (tau(j,ibox) .ge. 9.4 
     &          .and. tau(j,ibox) .lt. 23.) then
                  itau=5
              else if (tau(j,ibox) .ge. 23. 
     &          .and. tau(j,ibox) .lt. 60.) then
                  itau=6
              else if (tau(j,ibox) .ge. 60.) then
                  itau=7
              endif
              
             endif  

       ! update MISR histograms and summary metrics - roj 5/2005
       if (sunlit(j).eq.1) then 
                     
              !if cloudy added by roj 5/2005
          if( box_MISR_ztop(j,ibox).eq.0) then
          
            ! no cloud detected
            iMISR_ztop=0

          elseif( box_MISR_ztop(j,ibox).eq.-1) then

            ! cloud can be detected but too thin to get CTH
            iMISR_ztop=1    

            fq_MISR_TAU_v_CTH(j,itau,iMISR_ztop)=
     &            fq_MISR_TAU_v_CTH(j,itau,iMISR_ztop) + boxarea

          else
            
            !
            ! determine index for MISR bin set
            !

            iMISR_ztop=2
            
            do loop=2,n_MISR_CTH
        
                if ( box_MISR_ztop(j,ibox) .gt.
     &                1000*MISR_CTH_boundaries(loop+1) ) then
        
                  iMISR_ztop=loop+1

                endif
            enddo
          
            if(box_cloudy(j,ibox)) then
            
               ! there is an isccp clouds so itau(j) is defined
               fq_MISR_TAU_v_CTH(j,itau,iMISR_ztop)=
     &            fq_MISR_TAU_v_CTH(j,itau,iMISR_ztop) + boxarea
     
            else
                ! MISR CTH resolution is trying to fill in a
                ! broken cloud scene where there is no condensate.
                ! The MISR CTH-1D-OD product will only put in a cloud
                ! if the MISR cloud mask indicates cloud.
                ! therefore we will not include this column in the histogram
                ! in reality aerosoal and 3D effects or bright surfaces
                ! could fool the MISR cloud mask

                ! the alternative is to count as very thin cloud ??
!               fq_MISR_TAU_v_CTH(1,iMISR_ztop)=
!     &                     fq_MISR_TAU_v_CTH(1,iMISR_ztop) + boxarea
            endif


            MISR_mean_ztop(j)=MISR_mean_ztop(j)+
     &                       box_MISR_ztop(j,ibox)*boxarea          

            MISR_cldarea(j)=MISR_cldarea(j) + boxarea 
 
          endif
       else
          ! Set to issing data. A. Bodas - 14/05/2010
          do loop=1,n_MISR_CTH
             do k=1,7
                fq_MISR_TAU_v_CTH(j,k,loop) = missing_value
             enddo
             dist_model_layertops(j,loop) = missing_value
          enddo
          MISR_cldarea(j) = missing_value
          MISR_mean_ztop(npoints) = missing_value

       endif ! is sunlight ?
       
       enddo ! ibox - loop over subcolumns          
      
       if( MISR_cldarea(j) .gt. 0.) then
        MISR_mean_ztop(j)= MISR_mean_ztop(j) / MISR_cldarea(j)   ! roj 5/2006
       endif

       enddo  ! loop over grid points

      return
      end 

module atmos_age_tracer_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   William Cooke
! </CONTACT>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Larry Horowitz
! </REVIEWER>


! <OVERVIEW>
!     This code implements an age-of-air tracer.
! </OVERVIEW>

! <DESCRIPTION>
!     This code implements an age-of-air tracer, based on that in
!     the stratospheric chemistry code.
! </DESCRIPTION>

!-----------------------------------------------------------------------

use              fms_mod, only : file_exist,           &
                                 field_exist,          &
                                 write_version_number, &
                                 mpp_pe,               &
                                 mpp_root_pe,          &
                                 lowercase,   &
                                 error_mesg,           &
                                 FATAL,WARNING, NOTE,  &
                                 stdlog
use     time_manager_mod, only : time_type
use     diag_manager_mod, only : send_data,            &
                                 register_static_field
use   tracer_manager_mod, only : get_tracer_index,     &
                                 query_method
use    field_manager_mod, only : MODEL_ATMOS,          &
                                 parse
use     interpolator_mod, only : interpolate_type,     &
                                 interpolator_init,    &
                                 interpolator_end,     &
                                 interpolator,         &
                                 CONSTANT,             &
                                 INTERP_WEIGHTED_P  



implicit none
private
!-----------------------------------------------------------------------
!----- interfaces -------

public  atmos_age_tracer, atmos_age_tracer_init, atmos_age_tracer_end

!-----------------------------------------------------------------------
!----------- namelist -------------------
!-----------------------------------------------------------------------
! namelist /atmos_age_tracer_nml/  


!--- Arrays to help calculate tracer sources/sinks ---

character(len=6), parameter :: module_name = 'tracer'

!--- identification numbers for  diagnostic fields and axes ----

integer :: id_emiss

logical :: module_is_initialized=.FALSE.
real, parameter :: trop_age_cutoff = 0.1, trop_age_sq = trop_age_cutoff**2
real, parameter :: sec_per_day = 86400., &
                   age_relax_time = 10., & ! timescale for relaxation to zero in trop (days)
                   k_relax = 1./(age_relax_time*sec_per_day), & ! (1/sec)
                   days_per_year = 365.25, &
                   k_aging = 1./(days_per_year*sec_per_day) ! increase age at 1 yr/yr (convert to yr/sec)

!---- version number -----
character(len=128) :: version = '$Id: atmos_age_tracer.F90,v 19.0 2012/01/06 20:29:08 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
!-----------------------------------------------------------------------

contains


!#######################################################################
!<SUBROUTINE NAME="atmos_age_tracer">
!<OVERVIEW>
! The routine that calculate the sources and sinks of age tracer.
!</OVERVIEW>
!<DESCRIPTION>
!</DESCRIPTION>
!<TEMPLATE>
!call atmos_age_tracer (lon, lat, pwt, age, age_dt, Time, kbot)
!</TEMPLATE>
!   <IN NAME="lon" TYPE="real" DIM="(:,:)">
!     Longitude of the centre of the model gridcells
!   </IN>
!   <IN NAME="lat" TYPE="real" DIM="(:,:)">
!     Latitude of the centre of the model gridcells
!   </IN>
!   <IN NAME="pwt" TYPE="real" DIM="(:,:,:)">
!     The pressure weighting array. = dP/grav
!   </IN>
!   <IN NAME="age" TYPE="real" DIM="(:,:,:)">
!     The array of the age tracer
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="kbot" TYPE="integer, optional" DIM="(:,:)">
!     Integer array describing which model layer intercepts the surface.
!   </IN>

!   <OUT NAME="age_dt" TYPE="real" DIM="(:,:,:)">
!     The array of the tendency of the age tracer
!   </OUT>
 subroutine atmos_age_tracer (lon, lat, pwt, age, age_dt, Time, kbot)

!-----------------------------------------------------------------------
   real, intent(in),  dimension(:,:)   :: lon, lat
   real, intent(in),  dimension(:,:,:) :: pwt, age
   real, intent(out), dimension(:,:,:) :: age_dt
   type(time_type), intent(in)         :: Time     
   integer, intent(in),  dimension(:,:), optional :: kbot
!-----------------------------------------------------------------------
   real, dimension(size(age,1),size(age,2),size(age,3)) ::  &
         source, sink
   integer :: j,k,id,jd,kd
   real :: dagesq(size(age,1))
!-----------------------------------------------------------------------

!<ERROR MSG="tropchem_driver_init must be called first." STATUS="FATAL">
!   Tropchem_driver_init needs to be called before tracer_driver.
!</ERROR>
   if (.not. module_is_initialized)  &
      call error_mesg ('atmos_age_tracer','atmos_age_tracer_init must be called first.', FATAL)

   id=size(age,1); jd=size(age,2); kd=size(age,3)

!----------- compute age tracer source and sink------------
!
!  Increase at the rate of 1 per second outside the troposphere.
!  Results expressed in years. Relax towards zero with a 10 
!  day timescale in the troposphere, denoted by DAGESQ less than 0.01 
!
   sink = 0.
   source = 0.
   do k = 1,kd
   do j = 1,jd
      dagesq(:) = (age(:,j,k) - age(:,j,kd))**2

      where (dagesq(:) < trop_age_sq) 
           sink(:,j,k) = -age(:,j,k)*k_relax
      elsewhere
           source(:,j,k) = k_aging
      end where

   end do
   end do


!------- tendency ------------------

   age_dt=source+sink
      

!-----------------------------------------------------------------------

 end subroutine atmos_age_tracer
!</SUBROUTINE>

!#######################################################################

!<SUBROUTINE NAME="atmos_age_tracer_init">
!<OVERVIEW>
! The constructor routine for the age tracer module.
!</OVERVIEW>
!<DESCRIPTION>
! A routine to initialize the age tracer module.
!</DESCRIPTION>
!<TEMPLATE>
!call atmos_age_tracer_init (r, axes, Time, nage, lonb_mod, latb_mod, phalf, mask)
!</TEMPLATE>
!   <INOUT NAME="r" TYPE="real" DIM="(:,:,:,:)">
!     Tracer fields dimensioned as (nlon,nlat,nlev,ntrace). 
!   </INOUT>
!   <IN NAME="mask" TYPE="real, optional" DIM="(:,:,:)">
!      optional mask (0. or 1.) that designates which grid points
!           are above (=1.) or below (=0.) the ground dimensioned as
!           (nlon,nlat,nlev).
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="axes" TYPE="integer" DIM="(4)">
!     The axes relating to the tracer array dimensioned as
!      (nlon, nlat, nlev, ntime)
!   </IN>
!   <IN NAME="lonb_mod" TYPE="real" DIM="(:,:)">
!     The longitude corners for the local domain.
!   </IN>
!   <IN NAME="latb_mod" TYPE="real" DIM="(:,:)">
!     The latitude corners for the local domain.
!   </IN>
!   <IN NAME="phalf" TYPE="real" DIM="(:,:,:)">
!     Pressure on the model half levels (Pa)
!   </IN>
 subroutine atmos_age_tracer_init( r, axes, Time, nage, &
                                   lonb_mod, latb_mod, phalf, mask)

!-----------------------------------------------------------------------
!
!   r    = tracer fields dimensioned as (nlon,nlat,nlev,ntrace)
!   mask = optional mask (0. or 1.) that designates which grid points
!          are above (=1.) or below (=0.) the ground dimensioned as
!          (nlon,nlat,nlev).
!
!-----------------------------------------------------------------------
real,             intent(inout), dimension(:,:,:,:) :: r
type(time_type),  intent(in)                        :: Time
integer,          intent(in)                        :: axes(4)
real,             intent(in),    dimension(:,:)     :: lonb_mod
real,             intent(in),    dimension(:,:)     :: latb_mod
real,             intent(in),    dimension(:,:,:)   :: phalf
integer,          intent(out)                       :: nage
real, intent(in), dimension(:,:,:), optional        :: mask

!
!-----------------------------------------------------------------------
!
      integer :: n
      integer :: flag_file, flag_spec
      character(len=64) :: control='', name='', filename='', specname=''
      type(interpolate_type) :: init_conc
      logical :: tracer_initialized

      if (module_is_initialized) return

!---- write namelist ------------------

      call write_version_number(version, tagname)
!     if ( mpp_pe() == mpp_root_pe() ) &
!       write ( stdlog(), nml=atmos_age_tracer_nml )
 
      nage = -1
      n = get_tracer_index(MODEL_ATMOS,'AGE' )
!     if (n>0) nage = n
      if (n>0) then
        nage = n

!-----------------------------------------------------------------------
!     ... Initial conditions
!-----------------------------------------------------------------------
      tracer_initialized = .false.
      if ( field_exist('INPUT/atmos_tracers.res.nc', 'age') .or. &
           field_exist('INPUT/fv_tracer.res.nc', 'age') .or. &
           field_exist('INPUT/tracer_age.res', 'age') ) then
         tracer_initialized = .true.
      end if
      if(.not. tracer_initialized) then
!     if((.not. tracer_initialized) .and. (nage /= -1)) then
         if( query_method('init_conc',MODEL_ATMOS,n,name,control) ) then
            if( trim(name) == 'file' ) then
               flag_file = parse(control, 'file',filename)
               flag_spec = parse(control, 'name',specname)

               if( flag_file>0 ) then
                  call interpolator_init( init_conc,trim(filename),lonb_mod,latb_mod,&
                                          data_out_of_bounds=(/CONSTANT/), &
                                          vert_interp=(/INTERP_WEIGHTED_P/) )
                  if( flag_spec > 0 ) then
                     specname = lowercase(specname)
                  else
                     specname = 'age'
                  end if
                  call interpolator(init_conc, Time, phalf,r(:,:,:,n),trim(specname))                  
               end if
            end if
         end if
      end if
    endif



      module_is_initialized = .TRUE.

!-----------------------------------------------------------------------

 end subroutine atmos_age_tracer_init
!</SUBROUTINE>

!#######################################################################

!<SUBROUTINE NAME="atmos_age_tracer_end">
!<OVERVIEW>
!  The destructor routine for the age tracer module.
!</OVERVIEW>
! <DESCRIPTION>
! This subroutine writes the version name to logfile and exits. 
! </DESCRIPTION>
!<TEMPLATE>
! call atmos_age_tracer_end
!</TEMPLATE>
 subroutine atmos_age_tracer_end
 
      module_is_initialized = .FALSE.

 end subroutine atmos_age_tracer_end
!</SUBROUTINE>


end module atmos_age_tracer_mod

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! mask_mod reads the land/sea mask from netCDF file - Mike Winton (Michael.Winton)!
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
module mask_mod

use rot_mod, only: rot_intrp_sclr
use fms_mod,   only: error_mesg, FATAL

implicit none
include 'netcdf.inc'
private

public :: lonb, latb, mask, lonb_uv, latb_uv, mask_uv, make_mask

real,    allocatable, dimension(:  ) :: lonb, latb, lonb_uv, latb_uv
logical, allocatable, dimension(:,:) :: mask, mask_uv
real,    allocatable, dimension(:,:) :: rmask

contains

!
! make_v_grid - makes B-grid longitudes, latitudes and mask for velocity-cells
!
subroutine make_v_grid(mask_t, mask_v, lon_t, lat_t, lon_v, lat_v)
  logical, dimension (:,:),                           intent(in   ) :: mask_t
  logical, dimension (size(mask_t,1),size(mask_t,2))                :: mask_v
  real,    dimension (size(mask_t,1)+1),              intent(in   ) :: lon_t
  real,    dimension (size(mask_t,2)+1),              intent(in   ) :: lat_t
  real,    dimension (size(lon_t(:)))                                  :: lon_v
  real,    dimension (size(lat_t(:)))                                  :: lat_v

  integer, dimension(size(mask_t,1)) :: wes
  integer, dimension(size(mask_t,2)) :: sou
  integer                               i,j
  real,    dimension(size(mask_t,1)) :: lon_tmp
  real                                  pi

  sou = (/(j,j=1,size(sou(:)))/); wes = (/(i,i=1,size(wes(:)))/)
  sou = cshift(sou, -1)      ; wes = cshift(wes, -1)

  mask_v = mask_t(:,:)   .and. mask_t(wes,:) .and. &
           mask_t(:,sou) .and. mask_t(wes,sou)

  pi      = 4*atan(1.0)
  lon_tmp  = lon_t(1:size(lon_tmp(:)))
  lon_tmp  = lon_tmp-0.5*mod(lon_tmp+2*pi-cshift(lon_tmp,-1),2*pi)
  lon_v(1:size(lon_tmp(:))) = lon_tmp
  lon_v(size(lon_v(:)))     = lon_v(1)

  lat_v    = (lat_t+cshift(lat_t,-1))/2
  lat_v(1) = lat_t(1)              ! southernmost velocities not computed anyway
end subroutine make_v_grid

subroutine make_mask(lon_start, lon_end, lon_incr, lat_start, lat_end, lat_incr)
real :: lon_start, lon_end, lon_incr, lat_start, lat_end, lat_incr
integer      :: dims(4), start(4), count(4), rcode
integer      :: i, j, id, jd, im, jm 
integer      :: ncid, varid, xv_id, yv_id
real         :: pi
real, dimension(:  ), allocatable :: xd, yd, xt, yt
real, dimension(:,:), allocatable :: map

   pi = 4*atan(1.0)

   rcode = nf_open('INPUT/map.nc',0,ncid)
   if (rcode/=0) call error_mesg ('mask_mod', &
                                  'cannot open INPUT/map.nc', FATAL)
   rcode = nf_inq_varid(ncid, 'MAP', varid)
   rcode = nf_inq_vardimid(ncid, varid, dims)
   rcode = nf_inq_dimlen(ncid, dims(1), id)
   rcode = nf_inq_dimlen(ncid, dims(2), jd)

   allocate(xd(id), yd(jd), map(id,jd))

   start = 1; count = 1; count(1) = id;
   rcode = nf_get_vara_double(ncid, dims(1), start, count, xd)
   start = 1; count = 1; count(1) = jd;
   rcode = nf_get_vara_double(ncid, dims(2), start, count, yd)
   start = 1; count = 1; count(1) = id; count(2) = jd;
   rcode = nf_get_vara_double(ncid, varid, start, count, map)

   im = nint((lon_end-lon_start)/lon_incr)
   jm = nint((lat_end-lat_start)/lat_incr)
   allocate(rmask(im,jm), mask(im,jm), mask_uv(im,jm), xt(im), yt(jm) )
   allocate(lonb(im+1), lonb_uv(im+1), latb(jm+1), latb_uv(jm+1))
  
   xt = lon_start+(/(i-0.5,i=1,im)/)*lon_incr
   yt = lat_start+(/(j-0.5,j=1,jm)/)*lat_incr

   if (maxval(abs(yt))<45.0) then ! rotate poles onto equator
     call rot_intrp_sclr(map, xd, yd, id, jd, rmask, xt, yt, size(xt(:)),  &
                         size(yt(:)), 2*atan(1.0), -2*atan(1.0), atan(1.0) )
   else
     call rot_intrp_sclr(map, xd, yd, id, jd, rmask, xt, yt, size(xt(:)), &
                         size(yt(:)), 0.0, 0.0, 0.0                       )
   endif
   deallocate(map, xd, yd, xt, yt)

   lonb = (lon_start+(/(i,i=0,im)/)*lon_incr)*pi/180
   latb = (lat_start+(/(j,j=0,jm)/)*lat_incr)*pi/180
   mask = rmask > 0.5

   call make_v_grid(mask, mask_uv, lonb, latb, lonb_uv, latb_uv)

end subroutine make_mask

end module mask_mod

module land_tile_selectors_mod

use fms_mod, only : error_mesg, WARNING

implicit none
private

! ==== public interface ======================================================
public :: tile_selector_type      !

! selector tags
public :: SEL_SOIL, SEL_VEGN, SEL_LAKE, SEL_GLAC, SEL_SNOW, SEL_CANA

public :: tile_selectors_init     ! initialize module
public :: tile_selectors_end      ! clean up ufter ourselves

public :: register_tile_selector  ! register selector for diag field
public :: selector_suffix         ! return suffix for the field name

public :: get_selector            ! array of selectors
public :: get_n_selectors         ! number of available selectors
! ==== end of public interface ===============================================

! ==== module constants ======================================================
character(len=*), parameter :: &
     module_name = 'land_tile_selectors_mod', &
     version     = '$Id: land_tile_diag_sel.F90,v 18.0 2010/03/02 23:37:10 fms Exp $', &
     tagname     = '$Name: tikal $'

integer, parameter :: SEL_LEN           = 16  ! max length of the selector name
integer, parameter :: SEL_LONG_NAME_LEN = 128 ! max name of the selector long name
integer, parameter :: INIT_SEL_SIZE     = 1   ! initial size of the array of selectors

! tags for tile-specific diagnostic selectors
integer, parameter :: SEL_SOIL = 1
integer, parameter :: SEL_VEGN = 2
integer, parameter :: SEL_LAKE = 3
integer, parameter :: SEL_GLAC = 4
integer, parameter :: SEL_SNOW = 5
integer, parameter :: SEL_CANA = 6

! ==== derived types =========================================================
type :: tile_selector_type
   character(len=SEL_LEN)           :: name =''          ! name of the selector
   character(len=SEL_LONG_NAME_LEN) :: long_name = ''    ! long name of the selector
   logical, pointer                 :: mask(:) => NULL() ! mask (selector cache)
   integer :: tag = 0 ! tag of the model component
   integer :: idata1=0, idata2=0 ! integer data
   integer :: rdata1=0, rdata2=0 ! real data
end type tile_selector_type

! ==== module private data ===================================================
logical :: module_is_initialized = .false.

! ==== module public data ====================================================
! array of registered selectors
type(tile_selector_type), pointer :: selectors(:) => NULL()
integer :: n_selectors = 0 ! number of registered selectors

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-


! ============================================================================
subroutine tile_selectors_init()

  if (module_is_initialized) return

  module_is_initialized = .true.

  allocate (selectors(INIT_SEL_SIZE))
  n_selectors = 0 ! initialize number of regitered selectors
  ! register couple of default selectors (for all tiles and for each tile)
end subroutine tile_selectors_init


! ============================================================================
subroutine tile_selectors_end()

  integer :: i

  module_is_initialized = .false.
  do i = 1,n_selectors
     if(associated(selectors(i)%mask)) deallocate(selectors(i)%mask)
  enddo
  deallocate(selectors)
  n_selectors = 0
end subroutine tile_selectors_end


! ============================================================================
! registers a selector to be used for diagnostic output 
subroutine register_tile_selector( name, long_name, tag, idata1, idata2, rdata1, rdata2 )
  character(len=*), intent(in) :: name
  character(len=*), intent(in), optional :: long_name
  integer, intent(in), optional :: tag
  integer, intent(in), optional :: idata1, idata2
  real,    intent(in), optional :: rdata1, rdata2

  ! ---- local vars
  type(tile_selector_type), pointer :: new_selectors(:)
  character(len=SEL_LEN) :: name_
  integer :: i

  ! check for conflict of names -- presumably, if the selector was already
  ! registered, then it is an error to register it again
  name_=name
  do i = 1, n_selectors
     if (trim(name_)==trim(selectors(i)%name)) then
        call error_mesg(module_name,'attempt to register selector "'&
             //trim(name)//'" which has already been registered',WARNING)
        return ! just skip it 
     endif
  enddo

  ! allocate additional space for selectors if necessary 
  if(n_selectors >= size(selectors)) then
     allocate(new_selectors(max(n_selectors*2,1)))
     new_selectors(1:n_selectors) = selectors(1:n_selectors)
     deallocate(selectors)
     selectors => new_selectors
  endif

  ! set up the selector values
  n_selectors = n_selectors + 1
  selectors(n_selectors)%name = name
  if (present(long_name)) &
       selectors(n_selectors)%long_name = long_name
  if (present(tag)) selectors(n_selectors)%tag = tag
  if (present(idata1)) selectors(n_selectors)%idata1 = idata1
  if (present(idata2)) selectors(n_selectors)%idata2 = idata2
  if (present(rdata1)) selectors(n_selectors)%rdata1 = rdata1
  if (present(rdata2)) selectors(n_selectors)%rdata2 = rdata2
end subroutine register_tile_selector


! ============================================================================
! returns total number of selectors
function get_n_selectors()
  integer :: get_n_selectors
  get_n_selectors = n_selectors
end function 

! ============================================================================
! retrns n-th selector
function get_selector(n) result (sel)
  type(tile_selector_type) :: sel
  integer, intent(in) :: n

  if (n<1.or.n>get_n_selectors()) return
  sel = selectors(n)

end function 


! ============================================================================
! returns variable suffix for given selector
function selector_suffix(selector)
  character(len=SEL_LEN+1) :: selector_suffix
  type(tile_selector_type), intent(in) :: selector
  
  if(trim(selector%name)=='') then
     selector_suffix = ''
  else
     selector_suffix = '_'//trim(selector%name)
  endif
end function selector_suffix


! ============================================================================
subroutine update_tile_selectors()

  integer :: i
  do i = 1,n_selectors
     if(associated(selectors(i)%mask)) deallocate(selectors(i)%mask)
  enddo
end subroutine update_tile_selectors



end module land_tile_selectors_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The dynamic q2l-equation\label{sec:lengthscaleeq}
!
! !INTERFACE:
   subroutine lengthscaleeq(nlev,dt,depth,u_taus,u_taub,z0s,z0b,h,NN,SS)

!
! !DESCRIPTION:
! Following suggestions of \cite{Rotta51a}, \cite{MellorYamada82}
! proposed an equation for the product $q^2 l$ expressed by
! \begin{equation}
!   \label{MY}
!   \dot{\overline{q^2 l}}
!   = {\cal D}_l + l ( E_1  P + E_3 G - E_2  F \epsilon )
!   \comma
! \end{equation}
! where $\dot{\overline{q^2 l}}$ denotes the material derivative of $q^2 l$.
! The production terms $P$ and $G$ follow from \eq{PandG}, and $\epsilon$
! can be computed either directly from \eq{epsilonMY}, or from \eq{epsilon}
! with the help \eq{B1}.
!
! The so-called wall function, $F$, appearing in \eq{MY} is defined by
! \begin{equation}
!   \label{F}
!   F = 1 + E_2 \left( \dfrac{l}{\kappa {\cal L}_z} \right)^2
!   \comma
! \end{equation}
! $\kappa$ being the von K{\'a}rm{\'a}n constant and ${\cal L}_z$ some
! measure for the distance from the wall. Different possiblities
! for  ${\cal L}_z$ are implemented in GOTM, which can be activated
! be setting the parameter {\tt MY\_length} in {\tt gotmturb.nml} to
! appropriate values. Close to the wall, however, one always has
! ${\cal L}_z= \overline{z}$, where $\overline{z}$ is the distance from
! the wall.
!
! For horizontally homogeneous flows, the transport term ${\cal D}_l$
! appearing in \eq{MY} is expressed by a simple gradient formulation,
! \begin{equation}
!   \label{diffusionMYlength}
!   {\cal D}_l = \frstder{z} \left( q l S_l \partder{q^2 l}{z} \right)
!  \comma
! \end{equation}
! where $S_l$ is a constant of the model. The values for the model
! constants recommended by \cite{MellorYamada82} are displayed in
! \tab{tab:MY_constants}. They can be set in {\tt gotmturb.nml}. Note,
! that the parameter $E_3$ in stably stratifed flows is in principle
! a function of the so-called steady state Richardson-number,
! as discussed by \cite{Burchard2001c}, see discussion in the context
! of \eq{Ri_st}.
! \begin{table}[ht]
!   \begin{center}
! \begin{tabular}{ccccccc}
!                           & $B_1$  & $S_q$ & $S_l$ & $E_1$ & $E_2$ & $E_3$    \\[1mm]
!      \hline
!     \cite{MellorYamada82} & $16.6$ & $0.2$ & $0.2$ & $1.8$ & $1.33$ & $1.8$\\
!   \end{tabular}
!   \caption{\label{tab:MY_constants} Constants appearing in \eq{MY}
!     and \eq{epsilonMY}}
!   \end{center}
! \end{table}
!
! At the end of this routine the length-scale can be constrained according to a
! suggestion of \cite{Galperinetal88}. This feature is optional and can be activated
! by setting {\tt length\_lim = .true.} in {\tt gotmturb.nml}.
!
! !USES:
   use turbulence, only: P,B
   use turbulence, only: tke,tkeo,k_min,eps,eps_min,L
   use turbulence, only: kappa,e1,e2,e3,b1
   use turbulence, only: MY_length,cm0,cde,galp,length_lim
   use turbulence, only: q2l_bc, psi_ubc, psi_lbc, ubc_type, lbc_type
   use turbulence, only: sl
   use util,       only: Dirichlet,Neumann

   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer,  intent(in)                :: nlev

!  time step (s)
   REALTYPE, intent(in)                :: dt

!  local water depth (m)
   REALTYPE, intent(in)                :: depth

!  surface and bottom
!  friction velocity (m/s)
   REALTYPE, intent(in)                :: u_taus,u_taub

!  surface and bottom
!  roughness length (m)
   REALTYPE, intent(in)                :: z0s,z0b

!  layer thickness (m)
   REALTYPE, intent(in)                :: h(0:nlev)

!  square of shear and buoyancy
!  frequency (1/s^2)
   REALTYPE, intent(in)                :: NN(0:nlev),SS(0:nlev)
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!                     (re-write after first version of
!                      H. Burchard and K. Bolding
!
!  $Log: lengthscaleeq.F90,v $
!  Revision 20.0  2013/12/14 00:13:47  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.8  2007-01-06 11:49:15  kbk
!  namelist file extension changed .inp --> .nml
!
!  Revision 1.7  2005/11/15 11:35:02  lars
!  documentation finish for print
!
!  Revision 1.6  2005/11/03 20:53:37  hb
!  Patankar trick reverted to older versions for
!  stabilising 3D computations
!
!  Revision 1.5  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.4  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.3  2003/03/10 09:02:05  gotm
!  Added new Generic Turbulence Model +
!  improved documentation and cleaned up code
!
!
!EOP
!------------------------------------------------------------------------
!
! !LOCAL VARIABLES:
   REALTYPE                  :: DiffQ2lup,DiffQ2ldw,pos_bc
   REALTYPE                  :: prod,buoyan,diss
   REALTYPE                  :: prod_pos,prod_neg,buoyan_pos,buoyan_neg
   REALTYPE                  :: ki,epslim,NN_pos
   REALTYPE                  :: ds,db,Lcrit
   REALTYPE                  :: cnpar=_ONE_
   REALTYPE                  :: q2l(0:nlev),q3(0:nlev)
   REALTYPE                  :: avh(0:nlev)
   REALTYPE                  :: Lz(0:nlev)
   REALTYPE                  :: Lsour(0:nlev),Qsour(0:nlev)

   REALTYPE                  :: l_min

   integer                   :: i
!
!------------------------------------------------------------------------
!BOC

! compute lower bound for length scale
  l_min = cde*k_min**1.5/eps_min

!  some quantities in Mellor-Yamada notation
   do i=1,nlev-1
      q2l(i)=2.*tkeo(i)*L(i)
      q3 (i)=sqrt(8.*tke(i)*tke(i)*tke(i))
   end do

!  diagnostic length scale for wall function
   db=_ZERO_
   ds=_ZERO_
   do i=1,nlev-1
      db=db+h(i)
      ds=depth-db
      ! Parabola shape
      if (MY_length.eq.1) Lz(i)=kappa*(ds+z0s)*(db+z0b)/(ds+z0s+db+z0b)
      ! Triangle shape
      if (MY_length.eq.2) Lz(i)=kappa*min(ds+z0s,db+z0b)
      ! For infinite depth
      if (MY_length.eq.3) Lz(i)=kappa*(ds+z0s)
   end do

! prepare the production terms
   do i=1,nlev-1

!     compute diffusivity
      avh(i)      =  sl*sqrt(2.*tke(i))*L(i)

!     compute production terms in q^2 l - equation
      prod        =  e1*L(i)*P(i)
      buoyan      =  e3*L(i)*B(i)
      diss        =  q3(i)/b1*(1.+e2*(L(i)/Lz(i))*(L(i)/Lz(i)))

!     compute positive and negative parts of RHS
      if (prod+buoyan .gt. 0) then
         Qsour(i) =  prod + buoyan
         Lsour(i) = -diss/q2l(i)
      else
         Qsour(i) =  prod
         Lsour(i) = -(diss-buoyan)/q2l(i)
      end if

   end do

!  TKE and position for upper BC
   if (psi_ubc.eq.Neumann) then
!     tke at center "nlev"
      ki = tke(nlev-1)

!     flux at center "nlev"
      pos_bc = 0.5*h(nlev)
   else
!     tke at face "nlev-1"
      ki = tke(nlev-1)

!     value at face "nlev-1"
      pos_bc = h(nlev)
   end if

!  obtain BC for upper boundary of type "ubc_type"
   DiffQ2lup  = q2l_bc(psi_ubc,ubc_type,pos_bc,ki,z0s,u_taus)


!  TKE and position for lower BC
   if (psi_lbc.eq.Neumann) then
!     tke at center "1"
      ki = tke(1)

!     flux at center "1"
      pos_bc = 0.5*h(1)
   else
!     tke at face "1"
      ki = tke(1)

!     value at face "1"
      pos_bc = h(1)
   end if

!  obtain BC for lower boundary of type "lbc_type"
   DiffQ2ldw  = q2l_bc(psi_lbc,lbc_type,pos_bc,ki,z0b,u_taub)


!  do diffusion step
   call diff_face(nlev,dt,cnpar,h,psi_ubc,psi_lbc,                          &
                  DiffQ2lup,DiffQ2ldw,avh,Lsour,Qsour,q2l)


!  fill top and bottom value with something nice
!  (only for output)
   q2l(nlev)  = q2l_bc(Dirichlet,ubc_type,z0s,tke(nlev),z0s,u_taus)
   q2l(0   )  = q2l_bc(Dirichlet,lbc_type,z0b,tke(0   ),z0b,u_taub)



! compute L and epsilon
  do i=0,nlev
     L(i)=q2l(i)/(2.*tke(i))

!    apply the length-scale clipping of Galperin et al. (1988)
     if ((NN(i).gt.0).and.(length_lim)) then
        Lcrit=sqrt(2*galp*galp*tke(i)/NN(i))
        if (L(i).gt.Lcrit) L(i)=Lcrit
     end if

!    compute dissipation rate
     eps(i) = cde*sqrt(tke(i)*tke(i)*tke(i))/L(i)

!    check for very small lengh scale
     if (L(i).lt.l_min) L(i)=l_min

!    substitute minimum value
     if (eps(i).lt.eps_min) then
        eps(i) = eps_min
          L(i) = cde*sqrt(tke(i)*tke(i)*tke(i))/eps_min
     endif
  end do


  return
  end subroutine lengthscaleeq
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

! TK: modified to run mixed layer experiments with either qflux restoring
!       and/or qflux adjustment based on a previous qflux restoring run.
!
!     Added do_restore_sst, do_qflux_adj namelist parameters.  
!
!     If do_restore_sst is true, read in the observed sst 
!        appropriate to current point in seasonal cycle. 
!        Compute the heat flux restoring term for the time period.
!        Add this term to the atm-ocean heat flux.
!
!     If do_qflux_adj is true, read in the qflux adjustment 
!        appropriate to current point in seasonal cycle. 
!        Add this term to the atm-ocean heat flux.
!        Updated name of qflux_adjustment input file 11/01/01.
!
!       Note: Avoid resetting the SST/seaice with climatology, since these
!           are now computed.  (i.e., spec_ice should be false)
!
!     TK  11/15/01
!     TK   3/07/02   Adapted to galway code, leaving out warm_restore code.
!     TK   7/31/02   Adapted to havana code (minor updates)
!     TK  11/25/02   Modify get_heat_flux_adjust routine to extract 
!                    data onto local grid rather than interpolate.  
!                    (Also requires some mods to update_ocean_model.)
!     TK   3/26/03   Modified branch code (qflux_tk ocean_mixed_layer)
!                    to be compatible with the default ocean_model.f90
!                    pre-Inchon "latest" version of ocean_model.f90 
!                    which uses data override.  That version was checked out
!                    using:  cvs co -r latest fms_spectral_mixed_layer.
!
!     TK   4/3/03    Added get_sea_surface routine directly to this
!                    module for use with the ocean_model.  Then
!                    data override will input data on the ocean
!                    grid with no conflict...
!
!     TK   4/14/03   Modified get_heat_flux_adj subroutine to work
!                    with data override.
!
!     TK   4/15/03   Updated model to be compatible with default
!                    inchon code.  
!                    Used inchon ocean_mixed_layer/ocean_model.f90
!                    as basis for this...
! 
!     TK   7/24/03   Code clean-up and documentation.  Subroutine
!                    get_heat_flux_adj was made not public.
!                    Added xml comments.  Removed extra mlcp definition
!                    statement.  Changed default mixed layer depth
!                    to 50 meters.  None of these should change answers
!                    and did not in a 1-year test run of the
!                    AM2p12.7_Res run (checksums).
!
!     TK   9/10/03   Added boolean module_is_initialized and 
!                    associated tests to bring up to FMS specs.
!                    Should not change answers.   
!
!     TK   1/09/04   moved get_sea_surface call inside if statement
!                    Should not change answers.
!
!     TK   3/10/04   added 5 more pointers related to shortwave
!                    radiation fluxes to the ice_ocean_boundary_type.
!                    This change originates from Rick Hemler's 
!                    updates to radiation code.
!
!     TK   4/27/04   added/modified code so that observed sst's
!                    can be saved out (i.e., the restoring target).
!
!     TK   8/31/04   modified subroutine ocean_diagnostics to produce
!                    netcdf output that is modulo in longitude by having
!                    edges information (xb,yb) for the x,y axes (to be
!                    consistent with ice model, and needed to work
!                    correctly in ferret, etc.)
!
!     LAT  4/4/07    split the sw_flux into 4 components to comply with 
!                    the Nalanda flux exchange; sw_flux_nir_dir,
!                    sw_flux_nir_dif, sw_flux_vis_dir, sw_flux_vis_dif. Removed
!                    sw_flux and sw_flux_vis.
!
!     LAT  5/12/08   modified the top-level ocean interfaces to Bob Hallberg's
!                    proposed quasi-object-oriented approach to facilitate such
!                    things as data assimilation, running with ensembles and 
!                    nesting. Time is passed around explicitly. ocean_data_type
!                    is renamed to ocean_public_type, with time, mask, and all 
!                    variables written to restart files moved to ocean_state_type,
!                    pe renamed to is_ocean_pe, and instance_name, BGRID_NE and
!                    avg_kount added. ocean_state_type is a new, private pointer containing
!                    time and mask. The collective 'data' field in ice_ocean_boundary_type
!                    was not used and is removed. ocean_model_init,
!                    update_ocean_model and ocean_model_end contain the
!                    additional ocean_state arugument. time_step was removed from 
!                    ocean_public_type and is an argument 'Ocean_coupling_time_step' in
!                    update_ocean_model, so it does not need to be stored. Ocean_seg_start,
!                    Ocean_seg_end and num_ocean_calls were unused place holders and removed
!                    as arguments from the update_ocean_model interface. The
!                    argument Ice_boundary was renamed to Ice_ocean_boundary. A new subroutine,
!                    ocean_model_save_restart, has been added for incremental
!                    checkpointing. These changes bitwise reproduce answers.

module ocean_model_mod

  use    constants_mod, only:  Tfreeze, hlv, hlf, pi

  use time_manager_mod, only: time_type, operator(+), operator(>), get_date, &
                              get_time, set_time

  use mpp_mod,         only: mpp_pe, mpp_npes, stdout, mpp_error

  use mpp_domains_mod, only: mpp_domains_init, mpp_define_domains, domain2D, &
                             mpp_define_layout, mpp_get_compute_domain,      &
                             mpp_get_layout, FOLD_NORTH_EDGE, CYCLIC_GLOBAL_DOMAIN

  use mpp_parameter_mod, only: AGRID, BGRID_NE, CGRID_NE, BGRID_SW, CGRID_SW

  use fms_mod, only: open_namelist_file, close_file, check_nml_error, error_mesg, &
                     WARNING, FATAL, write_version_number, stdlog, open_restart_file, &
                     file_exist, field_exist, read_data, write_data, set_domain, mpp_pe,       &
                     mpp_root_pe, open_restart_file, field_size

  use diag_manager_mod, only: diag_axis_init, register_diag_field, send_data, set_diag_global_att

  use mosaic_mod,        only: get_mosaic_ntiles, get_mosaic_ncontacts, get_mosaic_contact

!   TK Mod: do not use ice_spec version of get_sea_surface in the
!      ocean model.  It has its own version (for data override).
!!  use ice_spec_mod,     only: get_sea_surface


! TK added this use statement, needed in local get_sea_surface routine...
  use data_override_mod,only: data_override
  use coupler_types_mod,only: coupler_2d_bc_type

use ocean_parameters_mod,         only: ocean_parameters_init, ocean_parameters_end

! <CONTACT EMAIL="Tom.Knutson@noaa.gov">
!   Tom Knutson
! </CONTACT>

! <OVERVIEW>
!   This is a slab-type ocean model.  It is the primary means
!      of determining the equilibrium climate sensitivity 
!      of an atmosphere/land/sea-ice model.
! </OVERVIEW>

! <DESCRIPTION>
!   This is a slab-type ocean model, sometimes referred to as
!      as a qflux-adjusted mixed-layer model.  It is a very
!      simple ocean model consisting of a single motionless 
!      layer without advection or diffusion, but possibly 
!      including sea ice.  This type of model is the 
!      primary tool used to determine the equilibrium climate 
!      sensitivity of an atmosphere/land/sea-ice model.
!
!   The model is designed to run in 3 stages:  restoring
!      mode, qflux-adjusted control run mode, and perturbation
!      experiment mode.  The model can also be run in 
!      "free mode" with no restoring or qflux adjustments,
!      although this is normally not done.  It can also
!      be run in various other combinations such as qflux-adjusted
!      with further restoring although this is also not 
!      normally done.
!
!   Note that the sea-ice model is an integral part of the slab-ocean 
!      model although that code exists elsewhere (in the SIS part of 
!      FMS).  Care should be taken that the ice restoring fluxes 
!      archived by the sea-ice model during the restoring phase 
!      are added to the sst restoring fluxes archived by this
!      model during the restoring phase in order to determine 
!      the total qflux adjustment field.  Similarly any ice-lid fluxes
!      archived in the control experiment by the ice model
!      should be added to the control run qflux adjustment field
!      to obtain the final qflux adjustment field used 
!      for a perturbation experiment (without a lid).  More 
!      discussion of these topics is provided in the postscript 
!      documentation for the model (in preparation).
!
!
!   <LINK SRC="http://www.gfdl.noaa.gov/~tk/Slab_Model_Documentation.htm"> Click here for additional documentation </LINK>
! </DESCRIPTION>



  implicit none
  include 'netcdf.inc'
  private

!-----------------------------------------------------------------------
!----------------- public interfaces -----------------------------------

  public :: ocean_model_init, ocean_model_end, update_ocean_model,    &
            read_ice_ocean_boundary, write_ice_ocean_boundary, ocean_stock_pe,&
            init_default_ice_ocean_boundary, ocean_model_init_sfc,    &
            ocean_model_flux_init, ocean_model_save_restart, ocean_model_restart, &
            ocean_public_type_chksum, ice_ocn_bnd_type_chksum
!            get_heat_flux_adj        ! TK Mod (make not public) 7/24/03

public    ocean_model_data_get
interface ocean_model_data_get
   module procedure ocean_model_data1D_get 
   module procedure ocean_model_data2D_get 
end interface

!-----------------------------------------------------------------------

character(len=128), parameter :: version = '$Id: ocean_model.F90,v 20.0 2013/12/13 23:43:43 fms Exp $'
character(len=128), parameter :: tagname = '$Name: tikal $'


! <PUBLICTYPE>
  type, public :: ocean_public_type
     type(domain2D) :: Domain

     real, pointer, dimension(:,:) :: &
          t_surf =>NULL(), &      !  mixed layer temperature
          s_surf =>NULL(), &      !  mixed layer salinity (a constant at present in this model)
          sea_lev =>NULL(), &     !  sea level (Not used in Mixed layer model)
          frazil =>NULL(), &      !  energy flux of frazil formation.
                                  !     unit:  when divided by dt_ocean, unit is W/m2
          u_surf =>NULL(), &      !  zonal ocean current (= 0 at present in this model)
          area   =>NULL() , &
         v_surf =>NULL()         !  meridional ocean current (= 0 at present in this model)
     logical, pointer, dimension(:,:) :: maskmap =>NULL()! A pointer to an array indicating which
                                                         ! logical processors are actually used for
                                                         ! the ocean code. The other logical
                                                         ! processors would be all land points and
                                                         ! are not assigned to actual processors.
                                                         ! This need not be assigned if all logical
                                                         ! processors are used. This variable is dummy and need 
                                                         ! not to be set, but it is needed to pass compilation.
     integer, pointer, dimension(:) :: pelist =>NULL()
     logical :: is_ocean_pe           ! .true. on processors that run the ocean model.
     character(len=32) :: instance_name = ""   ! A name that can be used to identify
                                               ! this instance of an ocean model, for example
                                               ! in ensembles when writing messages.
     integer :: stagger = BGRID_NE    ! The staggering relative to the tracer
                                      ! points of the two velocity components.
                                      ! Valid entries include AGRID, BGRID_NE,
                                      ! CGRID_NE, BGRID_SW, and CGRID_SW, 
                                      ! corresponding to the community-standard
                                      ! Arakawa notation. (These are named 
                                      ! integers taken from mpp_parameter_mod.)
                                      ! Following MOM, this is BGRID_NE by
                                      ! default.
     integer, dimension(3)            :: axes = 0 ! Axis numbers that are
                                                  ! available for I/O using 
                                                  ! this surface data.  
     type(coupler_2d_bc_type)         :: fields   ! array of fields used for additional tracers
     integer                          :: avg_kount  ! Used for accumulating
                                                    ! averages of this type 
  end type ocean_public_type
! </PUBLICTYPE>

  type, public :: ocean_state_type ; private
     logical :: is_ocean_pe = .false.    ! .true. if this is an ocean PE.
     type(time_type) :: ocean_time       ! The ocean's internal clock - it is
                                         ! here for error checking against the
                                         ! input variables, and because defined
                                         ! types cannot be empty.
     logical, pointer, dimension(:,:) :: mask =>NULL() ! mask is true for ocean points, false for land points
  end type ocean_state_type


!Balaji

! <PUBLICTYPE>
  type, public :: ice_ocean_boundary_type      
     real, dimension(:,:), pointer :: u_flux =>NULL(), &    ! zonal wind stress (Pa)
                                      v_flux =>NULL(), &    ! meridional wind stress (Pa)
                                      t_flux =>NULL(), &    ! sensible heat flux (w/m2)
                                      q_flux =>NULL(), &    ! specific humidity flux (kg/m2/s)
                                      salt_flux =>NULL(), & ! salinity flux (kd/m2/s) (Not used in mixed layer model) 
                                      lw_flux =>NULL(), &   ! net (down-up) longwave flux (W/m2)
                                      sw_flux_nir_dir => NULL(),  & ! direct NIR sw radiation (W/m2) 
                                      sw_flux_nir_dif => NULL(),  & ! diffuse NIR sw radiation (W/m2)
                                      sw_flux_vis_dir => NULL(),  & ! direct visible sw radiation (W/m2)
                                      sw_flux_vis_dif => NULL(),  & ! diffuse visible sw radiation (W/m2)
                                      lprec =>NULL(), &     ! mass flux of liquid precipitation (Kg/m2/s)
                                      fprec =>NULL()        ! mass flux of frozen precipitation (Kg/m2/s)
     real, dimension(:,:), pointer :: runoff =>NULL(), &    ! mass flux of liquid runoff (Kg/m2/s)
                                      calving =>NULL()      ! mass flux of frozen runoff (Kg/m2/s)
     real, dimension(:,:), pointer :: p =>NULL()   ! pressure on the surface of the ocean (Pa) 
                                                   ! (Not used in mixed layer model)
     real, pointer, dimension(:,:) :: runoff_hflx     =>NULL() ! heat flux of liquid runoff (kg/m2/s) 
     real, pointer, dimension(:,:) :: calving_hflx    =>NULL() ! heat flux of frozen runoff (kg/m2/s) 
     integer :: xtype             !REGRID, REDIST or DIRECT
     type(coupler_2d_bc_type)      :: fluxes  ! array of fields used for additional tracers
     real, pointer, dimension(:,:) :: mi              =>NULL() ! mass of overlying sea ice 
     real, pointer, dimension(:,:) :: wnd              =>NULL() ! wind speed
  end type ice_ocean_boundary_type
! </PUBLICTYPE>


  real, allocatable, dimension (:,:) :: geo_lonv, geo_latv, geo_lon, geo_lat
  real, allocatable, dimension (:,:  ) :: dum1
  real, allocatable, dimension (:,:,:) :: dum2
  integer :: im, jm
  real, allocatable, dimension(:) :: xb1d, yb1d ! 1d global grid for diag_manager

  integer :: id_sst, id_hflx, id_swflx_nir_dir, id_swflx_nir_dif, id_swflx_vis_dir, id_swflx_vis_dif, &
             id_lwflx, id_shflx, id_lhflx, id_snwflx, id_frazil       
  integer :: id_qflx_adj, id_qflux_restore_sst, id_net_hflx     ! TK Mod
  integer :: id_sst_obs     ! TK mod

  logical :: sent
  real    :: mlcp
  logical :: module_is_initialized = .FALSE.
  logical :: stock_warning_issued  = .FALSE.
!
! namelist
!
  real    :: mixed_layer_depth = 50.
  real    :: mixed_layer_salin = 33.333
  integer :: layout(2)=(/0,0/)
  logical :: do_qflux_adj     = .false.       ! TK mod
  logical :: do_restore_sst   = .false.       ! TK mod
  real    :: sst_restore_timescale   =  5.0   ! TK mod; restoring time scale for SST in days

! <NAMELIST NAME="ocean_model_nml">
!   <DATA NAME="mixed_layer_depth" UNITS="meters"
!         TYPE="real" DEFAULT="50.0">
!     Depth of the mixed layer
!   </DATA>
!   <DATA NAME="mixed_layer_salin" UNITS="parts per thousand"
!         TYPE="real" DEFAULT="33.333">
!     Salinitiy of the mixed layer
!   </DATA>
!   <DATA NAME="layout" UNITS=" "
!         TYPE="integer" DEFAULT="(/0,0/)">
!     Multiple processor layout variable
!   </DATA>
!   <DATA NAME="do_qflux_adj" UNITS=" "
!         TYPE="logical" DEFAULT=".false.">
!     Add qflux adjustment to mixed layer tendency equation?
!   </DATA>
!   <DATA NAME="do_restore_sst" UNITS=" "
!         TYPE="logical" DEFAULT=".false.">
!     Restore mixed layer temperature toward observed SST?
!   </DATA>
!   <DATA NAME="sst_restore_timescale" UNITS="days"
!         TYPE="real" DEFAULT="5.0.">
!     Time scale for mixed layer temperature restoring (if used)
!   </DATA>
! </NAMELIST>

  namelist /ocean_model_nml/ mixed_layer_depth, mixed_layer_salin, layout, &
                             do_qflux_adj, do_restore_sst, sst_restore_timescale  ! TK Mod

!-----------------------------------------------------------------------
!-------- mpp domain2d types ---------

contains

! <SUBROUTINE NAME="ocean_model_init">

!   <OVERVIEW>
!     This initializes the ocean model
!   </OVERVIEW>

!   <DESCRIPTION>
!     The ocean model is initialized by reading namelist, 
!      reading in restart data, setting up variables and domains,
!      etc.
!   </DESCRIPTION>


! <PUBLICROUTINE>
  subroutine ocean_model_init (Ocean_sfc, Ocean_state, Time_init, Time_in)

    type (ocean_public_type), target, &
         intent(inout) :: Ocean_sfc   ! Ocean definition variable
    type (ocean_state_type), pointer  &
                       :: Ocean_state ! Ocean internal state
    type (time_type), intent(in) :: &
         Time_init, &               ! Initial time (currently not used by routine)
         Time_in                    ! Current time - the time at which to initialize
                                    ! the ocean model.
! </PUBLICROUTINE>

    real, allocatable, dimension(:,:) :: rmask
    integer :: unit, ierr, io
    integer :: i, j, is, ie, js, je, domain_flags
    integer :: rcode, ncid, varid, dims(4), start(4), nread(4)
    character(len=80) :: domainname
    integer :: grid_version = -1, ntiles, stdoutunit
    real, allocatable, dimension(:,:) :: tmpx, tmpy
    integer, dimension(4) :: xsize
    character(len=256) :: grd_file, ocean_mosaic, ocean_hgrid, topog, attvalue

    module_is_initialized = .TRUE.

    stdoutunit=stdout()

    allocate (Ocean_state)
    Ocean_state%is_ocean_pe = Ocean_sfc%is_ocean_pe
    if (.not.ocean_state%is_ocean_pe) return
    Ocean_state%ocean_time  = Time_in
!
! read namelist
!
    unit = open_namelist_file()
    ierr=1
    do while (ierr /= 0)
      read(unit, nml=ocean_model_nml, iostat=io, end=10)
      ierr = check_nml_error (io, 'ocean_model_nml')
    enddo
10  call close_file (unit)
!
! write version number and namelist
!
    call write_version_number(version, tagname)
    if ( mpp_pe() == mpp_root_pe() ) write (stdlog(), nml=ocean_model_nml)

    call ocean_parameters_init()

    grd_file = "INPUT/grid_spec.nc"    
    rcode = nf_open(grd_file,0,ncid)
!   <ERROR MSG="cannot open INPUT/grid_spec.nc" STATUS="FATAL">
!     Grid specification file could not be opened.
!   </ERROR>
    if (rcode/=0) call error_mesg ('ocean_model_mod', &
         'cannot open '//grd_file, FATAL)
    rcode = nf_inq_varid(ncid, 'wet', varid)
    if (rcode == 0) then
       call error_mesg('ocean_model_mod', &
            'reading grid_spec version 0', WARNING)
       grid_version = 0
       rcode = nf_inq_vardimid(ncid, varid, dims)
       rcode = nf_inq_dimlen(ncid, dims(1), im)
       rcode = nf_inq_dimlen(ncid, dims(2), jm)
    else
       !
       !  Determine if the grid is mosaic file
       !
       if(field_exist(grd_file, 'ocn_mosaic_file') .or. field_exist(grd_file, 'gridfiles') ) then ! read from mosaic file
          write(stdoutunit,*) '==>Note from ocean_grids_mod(set_ocean_grid_size): read grid from mosaic version grid'
          grid_version = 2
          if( field_exist(grd_file, 'ocn_mosaic_file') ) then ! coupler mosaic
             call read_data(grd_file, "ocn_mosaic_file", ocean_mosaic)
             ocean_mosaic = "INPUT/"//trim(ocean_mosaic)
          else
             ocean_mosaic = trim(grd_file)
          end if
          ntiles = get_mosaic_ntiles(ocean_mosaic)
          if(ntiles .NE. 1) call mpp_error(FATAL, '==>Error from ocean_model_mod: '//&
               'ntiles should be 1 for ocean mosaic, contact developer')
          ! Notify diag_manager of mosaic grid
          call set_diag_global_att ('ocean','mosaic','1')
          call read_data(ocean_mosaic, "gridfiles", ocean_hgrid)
          ocean_hgrid = 'INPUT/'//trim(ocean_hgrid)
          call field_size(ocean_hgrid, 'x', xsize)
          
          if(mod(xsize(1),2) .NE. 1) call mpp_error(FATAL, '==>Error from ocean_model_mod: '//&
               'x-size of x in file '//trim(ocean_hgrid)//' should be 2*ni+1')
          if(mod(xsize(2),2) .NE. 1) call mpp_error(FATAL, '==>Error from ocean_model_mod: '//&
               'y-size of x in file '//trim(ocean_hgrid)//' should be 2*nj+1')
          im = (xsize(1)-1)/2 
          jm = (xsize(2)-1)/2 
       else
          call mpp_error(FATAL, 'ocean_model_mod: unknown grid_spec version, can handly only version 0 or 2 (mosaic)')
       end if
    end if
!
! set up domains
!
    call mpp_domains_init
    if( layout(1).EQ.0 .AND. layout(2).EQ.0 )call mpp_define_layout( (/1,im,1,jm/), mpp_npes(), layout )
    if( layout(1).NE.0 .AND. layout(2).EQ.0 )layout(2) = mpp_npes()/layout(1)
    if( layout(1).EQ.0 .AND. layout(2).NE.0 )layout(1) = mpp_npes()/layout(2)
    domainname = 'ML Ocean'
    call mpp_define_domains( (/1,im,1,jm/), layout, Ocean_sfc%Domain, xflags=CYCLIC_GLOBAL_DOMAIN, &
         name=domainname, yflags=FOLD_NORTH_EDGE )
!         yflags=CYCLIC_GLOBAL_DOMAIN )
    call mpp_get_compute_domain( Ocean_sfc%Domain, is, ie, js, je )

    allocate ( rmask (is:ie, js:je), Ocean_state%mask (is:ie, js:je) )
    allocate ( geo_lon  (is:ie  , js:je  ), geo_lat  (is:ie  , js:je  ) )

    if (grid_version == 0) then
       start = 1; nread = 1;
       start(1) = is; nread(1) = ie-is+1;
       start(2) = js; nread(2) = je-js+1;
       rcode = nf_get_vara_double(ncid, varid, start, nread, rmask)
       Ocean_state%mask = .false.; where (rmask > 0.5) Ocean_state%mask = .true.

       allocate ( geo_lonv (1:im+1,1:jm+1), geo_latv (1:im+1,1:jm+1) )
       start = 1; nread = 1;
       nread(1) = im+1;
       nread(2) = jm+1;
       rcode = nf_inq_varid(ncid, 'geo_lonc', varid)
       !   <ERROR MSG="cannot find geo_lonc on INPUT/grid_spec.nc" STATUS="FATAL">
       !     The geo_lonc field could not be located on the grid specification file.
       !   </ERROR>
       if (rcode/=0) call error_mesg ('ocean_model_mod', &
            'cannot find geo_lonc on INPUT/grid_spec.nc', FATAL)
       rcode = nf_get_vara_double(ncid, varid, start, nread, geo_lonv)
       rcode = nf_inq_varid(ncid, 'geo_latc', varid)
       !   <ERROR MSG="cannot find geo_latc on INPUT/grid_spec.nc" STATUS="FATAL">
       !     The geo_latc field could not be located on the grid specification file.
       !   </ERROR>
       if (rcode/=0) call error_mesg ('ocean_model_mod', &
            'cannot find geo_latc on INPUT/grid_spec.nc', FATAL)
       rcode = nf_get_vara_double(ncid, varid, start, nread, geo_latv)
    else ! grid_spec version 2
       ! compute Ocean_state%mask
       call read_data(grd_file, "ocn_topog_file", topog)
       topog = 'INPUT/'//trim(topog)
       call read_data(topog, "depth", rmask, Ocean_sfc%Domain)
       Ocean_state%mask = .false.; where (rmask > 0) Ocean_state%mask = .true.
       ! compute grid cell centers
       allocate(tmpx(xsize(1),xsize(2)), tmpy(xsize(1),xsize(2)) )
       start = 1; nread = 1
       nread(1) = xsize(1)
       nread(2) = xsize(2)
       call read_data(ocean_hgrid, "x", tmpx, start, nread, no_domain=.true.)
       call read_data(ocean_hgrid, "y", tmpy, start, nread, no_domain=.true.)
       allocate ( geo_lonv (1:im+1,1:jm+1), geo_latv (1:im+1,1:jm+1) )
       do j = js, je+1
          do i = is, ie+1
             geo_lonv(i,j) = tmpx(2*i-1,2*j-1)
             geo_latv(i,j) = tmpy(2*i-1,2*j-1)
          end do
       end do
       deallocate(tmpx, tmpy)
    end if
    deallocate ( rmask )

    ! Debugging
    !write(*,*) 'geo_lonv', geo_lonv, ';'
    !write(*,*) 'geo_latv', geo_latv, ';'
    !write(*,*) 'Ocean_state%mask', Ocean_state%mask, ';'
    !stop

    geo_lon = (geo_lonv(is:ie,js:je)    +geo_lonv(is+1:ie+1,js:je) &             
         +geo_lonv(is:ie,js+1:je+1)+geo_lonv(is+1:ie+1,js+1:je+1))/4
    geo_lat = (geo_latv(is:ie,js:je)    +geo_latv(is+1:ie+1,js:je) &
         +geo_latv(is:ie,js+1:je+1)+geo_latv(is+1:ie+1,js+1:je+1))/4

    allocate ( xb1d (im+1) )
    allocate ( yb1d (jm+1) )
    xb1d = sum(geo_lonv,2)/(jm+1);
    yb1d = sum(geo_latv,1)/(im+1);

    deallocate (geo_lonv)
    deallocate (geo_latv)

    mlcp = mixed_layer_depth*4e6

    allocate( Ocean_sfc%t_surf (is:ie,js:je), &
              Ocean_sfc%s_surf (is:ie,js:je), &
              Ocean_sfc%u_surf (is:ie,js:je), &
              Ocean_sfc%v_surf (is:ie,js:je), &
              Ocean_sfc%sea_lev(is:ie,js:je), &
              Ocean_sfc%frazil (is:ie,js:je)  )    

    Ocean_sfc%sea_lev = 0.
    Ocean_sfc%s_surf  = mixed_layer_salin;

    allocate ( dum1(is:ie,js:je), dum2(is:ie,js:je,2) )

!  The call to get_sea_surface is commented out because get_sea_surface
!  is also called in the sis ice model and it cannot put the fields on
!  the correct domain decomposition for both the ocean and ice models
!  at the same time. This is because get_sea_surface calls data_override,
!  which puts each override field on only one model domain, which is
!  specified in the data_table.
!  
!  A getaround is to initialize ssts to a simple function of latitude.

!   call get_sea_surface(Ocean_state%ocean_time, Ocean_sfc%t_surf, dum2, dum1)

    if ( file_exist('INPUT/ocean_model.res')) then

!         ---- set domain for global i/o ----
        call set_domain ( Ocean_sfc%Domain )

        unit = open_restart_file ('INPUT/ocean_model.res','read')

        call read_data ( unit, Ocean_sfc%t_surf )
        call read_data ( unit, Ocean_sfc%u_surf )
        call read_data ( unit, Ocean_sfc%v_surf )
        call read_data ( unit, Ocean_sfc%frazil )
        call close_file (unit)
    else
!     Cold start ssts are 0C poleward of 65 deg lat and 28C at equator
        Ocean_sfc%t_surf = 34*cos(pi*geo_lat/180.)**2 - 6. + Tfreeze
        where (Ocean_sfc%t_surf < Tfreeze) Ocean_sfc%t_surf = Tfreeze
        Ocean_sfc%u_surf  = 0.
        Ocean_sfc%v_surf  = 0.
        Ocean_sfc%frazil  = 0.
    endif

    call ocean_diagnostics (Ocean_sfc, Ocean_state%ocean_time)

  end subroutine ocean_model_init
! </SUBROUTINE>


! <SUBROUTINE NAME="update_ocean_model">

!   <OVERVIEW>
!     The main time-stepping routine for the mixed layer ocean model
!   </OVERVIEW>

!   <DESCRIPTION>
!     The mixed layer ocean model is integrated forward for
!      one ocean time step according to the following key set of 
!      equations:
!
!     hflx = Ice_ocean_boundary%sw_flux + Ice_ocean_boundary%lw_flux - &
!             (Ice_ocean_boundary%fprec+Ice_ocean_boundary%calving)*hlf - &
!             Ice_ocean_boundary%t_flux - Ice_ocean_boundary%q_flux*hlv
!
!     net_hflx(:,:) = hflx(:,:) + qflux_adj(:,:) + qflux_restore_sst(:,:)
!
!     Ocean_sfc%t_surf = Ocean_sfc%t_surf + dt_ocean * net_hflx/mlcp
!
!   </DESCRIPTION>


! <PUBLICROUTINE>
  subroutine update_ocean_model( Ice_ocean_boundary, Ocean_state, Ocean_sfc, &
       time_start_update, Ocean_coupling_time_step )

    type (ice_ocean_boundary_type), intent(inout) :: &
               Ice_ocean_boundary  ! Variable with fields for communication 
                                   ! from ice to the ocean
    type (ocean_state_type), pointer              :: &
               Ocean_state         ! Internal ocean state
    type (ocean_public_type), intent(inout) ::  &
               Ocean_sfc           ! Ocean definition variable 
    type (time_type), intent(in)          ::  &
               time_start_update,             &  ! time at beginning of update step
               Ocean_coupling_time_step          ! amount of time over which to advance ocean
! </PUBLICROUTINE>

    integer :: is, ie, js, je

    real, dimension(size(Ocean_state%mask,1),size(Ocean_state%mask,2)) :: sst, hflx
    real, dimension(size(Ocean_state%mask,1),size(Ocean_state%mask,2)) :: qflux_restore_sst, & ! TK mod  
                                                              qflux_adj, net_hflx  ! TK Mod
    real    :: dt_ocean
    integer :: dy, sc
    
      Ocean_state%ocean_time = Ocean_state%ocean_time + Ocean_coupling_time_step
      call get_time(Ocean_coupling_time_step,sc,dy)
      dt_ocean = 86400*dy + sc

!      if (time_start_update /= Ocean_state%ocean_time) then
!         call error_mesg('update_ocean_model', 'internal clock does not agree with time_start_update argument.', WARNING)
!      endif

    !Check if ocean_model has been initialized:
    if ( .NOT. module_is_initialized ) &
      !<ERROR MSG="Slab ocean_model not correctly initialized." STATUS="FATAL">
      ! The slab or mixed-layer type ocean model was not correctly initialized.
      ! </ERROR>
        call error_mesg( 'update_ocean_model', 'Slab ocean_model not correctly initialized.', FATAL )

      !check if required boundary fields have been initialized
      if( .NOT.ASSOCIATED(Ice_ocean_boundary%sw_flux_nir_dir) .OR. &
          .NOT.ASSOCIATED(Ice_ocean_boundary%sw_flux_nir_dif) .OR. &
          .NOT.ASSOCIATED(Ice_ocean_boundary%sw_flux_vis_dir) .OR. &
          .NOT.ASSOCIATED(Ice_ocean_boundary%sw_flux_vis_dif) .OR. &
          .NOT.ASSOCIATED(Ice_ocean_boundary%lw_flux) .OR. &
          .NOT.ASSOCIATED(Ice_ocean_boundary%fprec)   .OR. &
          .NOT.ASSOCIATED(Ice_ocean_boundary%calving) .OR. &
          .NOT.ASSOCIATED(Ice_ocean_boundary%t_flux)  .OR. &
          .NOT.ASSOCIATED(Ice_ocean_boundary%q_flux) ) &
      !<ERROR MSG="Ice_ocean_boundary not correctly initialized." STATUS="FATAL">
      ! The Ice_ocean_boundary variable was not correctly initialized.
      !</ERROR>
         call error_mesg( 'Update_ocean_model', 'Ice_ocean_boundary not correctly initialized.', FATAL )

      hflx = 0.0
      net_hflx = 0.0   ! TK Mod
      ! mlcp = 4e6*mixed_layer_depth   TK Mod: removed extra statement.
      ! TK Mods to implement qflux adjusted or restoring mixed layer models
      ! Original Galway Code (next 5 lines) for reference with SW flux partition from Nalanda
      ! where (Ocean_state%mask)
      !   hflx = Ice_ocean_boundary%sw_flux_nir_dir + Ice_ocean_boundary%sw_flux_nir_dif + &
      !   Ice_ocean_boundary%sw_flux_vis_dir + Ice_ocean_boundary%sw_flux_vis_dif + &
      !   Ice_ocean_boundary%lw_flux - (Ice_ocean_boundary%fprec+Ice_ocean_boundary%calving)*hlf - &
      !   Ice_ocean_boundary%t_flux - Ice_ocean_boundary%q_flux*hlv 
      !   Ocean_sfc%t_surf = Ocean_sfc%t_surf + dt_ocean*hflx/mlcp
      ! end where


      qflux_restore_sst(:,:) = 0.0
      if (do_restore_sst) then
     
! TK Mod (1/09/2004) moved this statement inside this if statement
!    since it is only needed if sst restoring is active.
!    (for spec_ice = true, the sst's are read in in ice_model.f90)  

        call get_sea_surface(Ocean_state%ocean_time, sst, dum2, dum1)

!  TK Mod: 4/24/04
        if (id_sst_obs    > 0) &
          sent = send_data(id_sst_obs, sst, Ocean_state%ocean_time, mask=Ocean_state%mask)
      
          ! Find the heat flux restoring term (qflux_restore_sst) due to sst
          ! restoring. The qflux_restore_sst values are saved for use in later
          ! flux adjusted runs. To find the sst restoring, use the observed sst
          ! for the date (stored in sst, which has a dual role in this routine)
    
          where (Ocean_state%mask)
            qflux_restore_sst = (sst - Ocean_sfc%t_surf) &
                                 * mlcp / (sst_restore_timescale * 86400)                  
          end where
        end if    

      if (do_qflux_adj) then
  
  !   Find the current climatological heat flux adjustment (qflux_adj).  
  !   The qflux_adj can be added to the heat flux to find the net
  !   heat flux anomaly into the mixed layer for the coupled mixed layer expt.
  
  !   Note that any ice model contributions need to be added in, which
  !   is handled in an off-line calculation to derive the final qflux
  !   adjustment.  These include ice restoring and ice lid contributions.

  !   Obtain indices for local array:
        call mpp_get_compute_domain( Ocean_sfc%Domain, is, ie, js, je )

        call get_heat_flux_adj (Ocean_state%ocean_time, qflux_adj)       

      else
        qflux_adj = 0.0
      end if    
    
      where (Ocean_state%mask)

! <PUBLICCOMMENT>
! The following are some key equations for this model:
     
       hflx = Ice_ocean_boundary%sw_flux_nir_dir + Ice_ocean_boundary%sw_flux_nir_dif + &
              Ice_ocean_boundary%sw_flux_vis_dir + Ice_ocean_boundary%sw_flux_vis_dif + &
              Ice_ocean_boundary%lw_flux - (Ice_ocean_boundary%fprec+Ice_ocean_boundary%calving)*hlf - &
              Ice_ocean_boundary%t_flux - Ice_ocean_boundary%q_flux*hlv

       net_hflx(:,:) = hflx(:,:) + qflux_adj(:,:) + qflux_restore_sst(:,:)

       Ocean_sfc%t_surf = Ocean_sfc%t_surf + dt_ocean*net_hflx/mlcp
     
! </PUBLICCOMMENT>     
      end where

!   End of TK Mods Section

      where (Ocean_state%mask .and. Ocean_sfc%t_surf < Tfreeze-0.054*mixed_layer_salin)
          Ocean_sfc%frazil = (Tfreeze-0.054*mixed_layer_salin-Ocean_sfc%t_surf)*mlcp
          Ocean_sfc%t_surf =  Tfreeze-0.054*mixed_layer_salin
      else where
          Ocean_sfc%frazil = 0.0
      end where

!-----------------------------------------------------------------------

      sst = 0.0; where (Ocean_state%mask) sst = Ocean_sfc%t_surf-Tfreeze

      if (id_sst    > 0) &
           sent = send_data(id_sst, sst, Ocean_state%ocean_time, mask=Ocean_state%mask)
      if (id_hflx   > 0) &
           sent = send_data(id_hflx, hflx, Ocean_state%ocean_time, mask=Ocean_state%mask)
      if (id_swflx_nir_dir  > 0) &
           sent = send_data(id_swflx_nir_dir, Ice_ocean_boundary%sw_flux_nir_dir, Ocean_state%ocean_time, mask=Ocean_state%mask)
      if (id_swflx_nir_dif  > 0) &
           sent = send_data(id_swflx_nir_dif, Ice_ocean_boundary%sw_flux_nir_dif, Ocean_state%ocean_time, mask=Ocean_state%mask)
      if (id_swflx_vis_dir  > 0) &
           sent = send_data(id_swflx_vis_dir, Ice_ocean_boundary%sw_flux_vis_dir, Ocean_state%ocean_time, mask=Ocean_state%mask)
      if (id_swflx_vis_dif  > 0) &
           sent = send_data(id_swflx_vis_dif, Ice_ocean_boundary%sw_flux_vis_dif, Ocean_state%ocean_time, mask=Ocean_state%mask)
      if (id_lwflx  > 0) &
           sent = send_data(id_lwflx, Ice_ocean_boundary%lw_flux, Ocean_state%ocean_time, mask=Ocean_state%mask)
      if (id_shflx  > 0) &
           sent = send_data(id_shflx, -Ice_ocean_boundary%t_flux, Ocean_state%ocean_time, mask=Ocean_state%mask)
      if (id_lhflx  > 0) &
           sent = send_data(id_lhflx, -Ice_ocean_boundary%q_flux*hlv, Ocean_state%ocean_time, mask=Ocean_state%mask)
      if (id_snwflx > 0) &
           sent = send_data(id_snwflx, -Ice_ocean_boundary%fprec*hlf, Ocean_state%ocean_time, mask=Ocean_state%mask)
      if (id_frazil > 0) &
           sent = send_data(id_frazil, Ocean_sfc%frazil/dt_ocean, Ocean_state%ocean_time, &
           mask=Ocean_state%mask)

! TK mods
      if (do_qflux_adj) then
        if (id_qflx_adj   > 0) &
           sent = send_data(id_qflx_adj, qflux_adj, Ocean_state%ocean_time, mask=Ocean_state%mask)
      end if      
   
      if (do_restore_sst) then
        if (id_qflux_restore_sst   > 0) &
           sent = send_data(id_qflux_restore_sst, qflux_restore_sst, Ocean_state%ocean_time, mask=Ocean_state%mask)
      end if      
   
      if (do_qflux_adj .or. do_restore_sst) then
        if (id_net_hflx   > 0) &
           sent = send_data(id_net_hflx, net_hflx, Ocean_state%ocean_time, mask=Ocean_state%mask)
      end if      

  end subroutine update_ocean_model
! </SUBROUTINE>

! <SUBROUTINE NAME="ocean_model_end">

!   <OVERVIEW>
!     End of integration routine for the mixed layer ocean model
!   </OVERVIEW>

!   <DESCRIPTION>
!     This routine writes and closes the restart file and is
!     called at the end of a model run on the system.

!   </DESCRIPTION>


! <PUBLICROUTINE>
  subroutine ocean_model_end (Ocean_sfc, Ocean_state, Time)

    type (ocean_public_type),           intent(inout) :: &
                     Ocean_sfc        ! Ocean definition variable
    type (ocean_state_type),            pointer       :: &
                     Ocean_state      ! Internal ocean state
    type (time_type),                   intent(in)    :: &
                     Time             ! Model time, used for writing restarts
! </PUBLICROUTINE>
    integer :: yr, mo, dy, hr, mn, sc
    integer :: unit

!    ---- set domain for global i/o ----
    call set_domain ( Ocean_sfc%Domain )

    unit = open_restart_file ('RESTART/ocean_model.res','write')

    call write_data ( unit, Ocean_sfc%t_surf )
    call write_data ( unit, Ocean_sfc%u_surf )
    call write_data ( unit, Ocean_sfc%v_surf )
    call write_data ( unit, Ocean_sfc%frazil )

    call close_file (unit)

    call ocean_parameters_end()

    module_is_initialized = .FALSE.
    
  end subroutine ocean_model_end
! </SUBROUTINE>
 
!#######################################################################
! <SUBROUTINE NAME="ocean_model_restart">
!
! <DESCRIPTION>
! dummy interface.
! Arguments: 
!   timestamp (optional, intent(in)) : A character string that represents the model time, 
!                                      used for writing restart. timestamp will append to
!                                      the any restart file name as a prefix. 
! </DESCRIPTION>
!
  subroutine ocean_model_restart(Ocean_state, timestamp)
     type(ocean_state_type),    pointer     :: Ocean_state
     character(len=*), intent(in), optional :: timestamp

    call error_mesg('ocean_model_restart(ocean_model_mod)', &
                     'intermediate restart capability is not implemented for this model', FATAL)

  end subroutine ocean_model_restart
! </SUBROUTINE> NAME="ocean_model_restart"

! <SUBROUTINE NAME="ocean_model_save_restart">

!   <OVERVIEW>
!     Routine to save ocean restart files.
!   </OVERVIEW>

!   <DESCRIPTION>
!     This routine writes restart data to restart files.
!     It exists for incremental checkpointing, as well as
!     writing restart files at the end of the run from 
!     ocean_model_end.
!   </DESCRIPTION>


! <PUBLICROUTINE>
  subroutine ocean_model_save_restart(Ocean_state, Time, directory, filename_suffix)
    type(ocean_state_type),     pointer    :: &
              Ocean_state     ! Internal ocean state
    type(time_type),            intent(in) :: &
              Time            ! Model time at this call. Needed for mpp_write calls.
    character(len=*), optional, intent(in) :: &
              directory       ! Optional directory into which to write restart files
    character(len=*), optional, intent(in) :: &
              filename_suffix ! Optional suffix (e.g., a time-stamp) to append
                              ! to the restart file names
! </PUBLICROUTINE>
    return
  end subroutine ocean_model_save_restart
! </SUBROUTINE>

  
  subroutine ocean_diagnostics (Ocean_sfc, Time)
    type (ocean_public_type), intent(in) :: Ocean_sfc
    type (time_type), intent(in) :: Time

! TK mods on 8/30/04:  needed to produce modulo netcdf output for ocean model.
    integer, dimension(2) :: axt    
    integer id_xb, id_xt, id_yb, id_yt

!     id_xt = diag_axis_init('xto', (xb1d(1:im)+xb1d(2:im+1))/2, 'degrees_E', 'x', &
!          set_name='ocean', Domain2=Ocean_sfc%Domain )
!     id_yt = diag_axis_init('yto', (yb1d(1:jm)+yb1d(2:jm+1))/2, 'degrees_N', 'y', &
!          set_name='ocean', Domain2=Ocean_sfc%Domain )
     id_xb = diag_axis_init('xb', xb1d, 'degrees_E', 'X', 'longitude', &
                                    set_name='ocean',Domain2=Ocean_sfc%Domain )
     id_xt = diag_axis_init('xto', (xb1d(1:im)+xb1d(2:im+1))/2, 'degrees_E', 'x', &
          'longitude',set_name='ocean',edges=id_xb,Domain2=Ocean_sfc%Domain )
     id_yb = diag_axis_init('yb', yb1d, 'degrees_N', 'Y', 'latitude', &
                                   set_name='ocean',Domain2=Ocean_sfc%Domain )
     id_yt = diag_axis_init('yto', (yb1d(1:jm)+yb1d(2:jm+1))/2, 'degrees_N', 'y', &
          'latitude',set_name='ocean',edges=id_yb,Domain2=Ocean_sfc%Domain )

    axt  = (/ id_xt, id_yt       /);

!    Sample of old style:  (changed (/id_xt,id_yt/) to axt)
!    id_sst = register_diag_field('ocean_model','SST',(/id_xt,id_yt/), Time, &
!         'sea surface temp.',  'deg-C', missing_value=1.e10)

    id_sst = register_diag_field('ocean_model','SST', axt, Time, &
         'sea surface temp.',  'deg-C', missing_value=1.e10)

    id_hflx = register_diag_field('ocean_model','HFLX',axt,Time,&
         'surface heat flux',  'W/m^2', missing_value=1.e10)

    id_swflx_nir_dir = register_diag_field('ocean_model','SWFLX_nir_dir',axt, &
         Time, 'short wave NIR direct flux', 'W/m^2', missing_value=1.e10)

    id_swflx_nir_dif = register_diag_field('ocean_model','SWFLX_nir_dif',axt, &
         Time, 'short wave NIR diffuse flux', 'W/m^2', missing_value=1.e10)

    id_swflx_vis_dir = register_diag_field('ocean_model','SWFLX_vis_dir',axt, &
         Time, 'short wave visible direct flux', 'W/m^2', missing_value=1.e10)

    id_swflx_vis_dif = register_diag_field('ocean_model','SWFLX_vis_dif',axt, &
         Time, 'short wave visible diffuse flux', 'W/m^2', missing_value=1.e10)

    id_lwflx = register_diag_field('ocean_model','LWFLX',axt, &
         Time, 'long wave flux', 'W/m^2', &
         missing_value=1.e10)

    id_shflx = register_diag_field('ocean_model','SHFLX',axt, &
         Time, 'sensible heat flux', 'W/m^2', &
         missing_value=1.e10)

    id_lhflx = register_diag_field('ocean_model','LHFLX',axt, &
         Time, 'latent heat flux','W/m^2', &
         missing_value=1.e10)

    id_snwflx = register_diag_field('ocean_model','SNWFLX',axt, &
         Time,'latent heat of snow','W/m^2', &
         missing_value=1.e10)

    id_frazil = register_diag_field('ocean_model','FRAZIL'  ,axt, &
         Time, 'frazil', 'W/m^2', &
         missing_value=1.e10)

!   TK mods
    if (do_restore_sst) then
         id_qflux_restore_sst = register_diag_field('ocean_model', &
         'QFLX_RESTORE_SST',axt, &
         Time, 'surface heat flux for SST restoring',  'W/m^2', &
         missing_value=1.e10)

         id_sst_obs = register_diag_field('ocean_model', &
         'SST_OBS',axt, &
         Time, 'Observed SST for restoring',  'K', &
         missing_value=1.e10)
    end if      

    if (do_qflux_adj) then
         id_qflx_adj = register_diag_field('ocean_model', &
         'QFLUX_ADJ',axt, &
         Time, 'surface heat flux adjustment',  'W/m^2', &
         missing_value=1.e10)
    end if                          

    if (do_qflux_adj .or. do_restore_sst) then
         id_net_hflx = register_diag_field('ocean_model', &
         'NET_HFLX',axt, &
         Time, 'net heat flux into mixed layer after adjustments',  &
         'W/m^2', missing_value=1.e10)
    end if                          

  end subroutine ocean_diagnostics

! <SUBROUTINE NAME="read_ice_ocean_boundary">

!   <OVERVIEW>
! This ocean_model doesn't support concurrent runs,
! so this routine should never be called. This is a dummy routine.
!   </OVERVIEW>

!   <DESCRIPTION>
! This ocean_model doesn't support concurrent runs,
! so this routine should never be called. This is a dummy routine.

!   </DESCRIPTION>


! <PUBLICROUTINE>

  subroutine read_ice_ocean_boundary(file_name,iob,Ocean)

    character(LEN=*),             intent(IN)    :: file_name  
    type(ice_ocean_boundary_type),intent(INOUT) :: iob
    type(ocean_public_type),      intent(IN)    :: Ocean
! </PUBLICROUTINE>

!   <ERROR MSG="ocean_mixed_layer model cannot run concurrently." STATUS="FATAL">
!     The ocean_mixed_layer model is not coded to run concurrently at present.
!   </ERROR>
    call error_mesg('ocean_model_mod', 'ocean_mixed_layer model cannot run concurrently', &
                    FATAL )
    return

  end subroutine read_ice_ocean_boundary
! </SUBROUTINE>

! <SUBROUTINE NAME="read_ice_ocean_boundary">

!   <OVERVIEW>
! This ocean_model doesn't support concurrent runs,
! so this routine should never be called. This is a dummy routine.
!   </OVERVIEW>

!   <DESCRIPTION>
! This ocean_model doesn't support concurrent runs,
! so this routine should never be called. This is a dummy routine.

!   </DESCRIPTION>


! <PUBLICROUTINE>

  subroutine write_ice_ocean_boundary(file_name,iob,Ocean)

    character(LEN=*),             intent(IN) :: file_name  
    type(ice_ocean_boundary_type),intent(IN) :: iob
    type(ocean_public_type),      intent(IN) :: Ocean
! </PUBLICROUTINE>

!   <ERROR MSG="ocean_mixed_layer model cannot run concurrently." STATUS="FATAL">
!     The ocean_mixed_layer model is not coded to run concurrently at present.
!   </ERROR>
    call error_mesg('ocean_model_mod', 'ocean_mixed_layer model cannot run concurrently', &
                    FATAL )
    return

  end subroutine write_ice_ocean_boundary
! </SUBROUTINE>

! <SUBROUTINE NAME="init_default_ice_ocean_boundary">

!   <OVERVIEW>
! dummy routine
!   </OVERVIEW>

!   <DESCRIPTION>
! dummy routine
!   </DESCRIPTION>


! <PUBLICROUTINE>

! dummy routine

  subroutine init_default_ice_ocean_boundary(iob)

    type(ice_ocean_boundary_type),intent(INOUT) :: iob
! </PUBLICROUTINE>

    return

  end subroutine init_default_ice_ocean_boundary
! </SUBROUTINE>

! dummy interface for ESM coupler
subroutine ocean_model_init_sfc(Ocean_state,Ocean)

    type(ocean_state_type),  pointer             :: Ocean_state
    type(ocean_public_type), intent(inout)       :: Ocean
    
return
end subroutine ocean_model_init_sfc

subroutine ocean_model_flux_init(Ocean_state)
  type(ocean_state_type), pointer :: Ocean_state  ! Internal ocean state

  if (.not.associated(Ocean_state)) then
    allocate(Ocean_state)
    Ocean_state%is_ocean_pe = .false.
  endif
return
end subroutine ocean_model_flux_init


!#######################################################################



!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! get_sea_surface - get SST, ice concentration and thickness from data         !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
subroutine get_sea_surface(time, ts, cn, iceh)
type (time_type),                         intent(in)  :: time
real, dimension(:, :),                    intent(out) :: ts
real, dimension(size(ts,1),size(ts,2),2), intent(out) :: cn
real, dimension(size(ts,1),size(ts,2)),   intent(out) :: iceh

real, dimension(size(ts,1),size(ts,2))                :: sst, icec

real ::  t_sw_freeze = -1.8

!! TK Comment.  Deleted code associated with mcm_ice namelist 
!!              parameter that was in ice_spec version.
!!              It will not be available here...
!

  icec = 0.0; iceh = 0.0; sst = t_sw_freeze;
!  TK Mod: change these to ocean grid:
  call data_override('OCN', 'sic_obs', icec, time)
  call data_override('OCN', 'sit_obs', iceh, time)
  call data_override('OCN', 'sst_obs', sst, time)
!  call data_override('ICE', 'sic_obs', icec, time)
!  call data_override('ICE', 'sit_obs', iceh, time)
!  call data_override('ICE', 'sst_obs', sst, time)

    where (icec >= 0.2)
      iceh = max(iceh, 1.0)
! TK Removed following statement.  It was not in earlier 
!       (pre-Inchon) code... 4/3/03
!!       icec = 1.0
      sst = t_sw_freeze
    else where
      icec = 0.0
      iceh = 0.0
    end where
  
! TK Mod: included following statement here so it is done
!   even for non mcm_ice...
  
  where (icec==0.0 .and. sst<=t_sw_freeze) sst = t_sw_freeze+1e-10

  cn(:,:,2) = icec
  cn(:,:,1) = 1-cn(:,:,2)
  ts = sst+Tfreeze

  return
end subroutine get_sea_surface

!#######################################################################


!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! get_heat_flux_adj - get climatological heat flux adjustment from restoring  run           !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
subroutine get_heat_flux_adj(time, qflux_adj)

! TK NOTE: This routine outputs qflux_adj.  This is the climatological value of the heat
!          flux restoring for the given time in the seasonal cycle.  It is also interpolated
!          to the appropriate model grid.  The output field is qflux_adj
!          to avoid confusing it with hflx in the main ocean mixed layer program.
!          8/22/01.

! TK NOTE:  Modified to work with data override routines.
!          4/14/03

type (time_type),                         intent(in)  :: time
real, dimension(:, :),                    intent(out) :: qflux_adj

!  TK Mod: input data on ocean grid:
  call data_override('OCN', 'qflux_adj', qflux_adj, time)
  
  return
end subroutine get_heat_flux_adj

!#######################################################################
! dummy routine

subroutine ocean_stock_pe(Ocean_state, index, value, time_index)
! Right now this is a dummy subroutine.
use stock_constants_mod, only : ISTOCK_WATER, ISTOCK_HEAT
type(ocean_state_type), pointer     :: Ocean_state    ! internal ocean state
integer,               intent(in)   :: index
real,                  intent(out)  :: value
integer, optional,     intent(in)   :: time_index

  integer :: i, j, k

  value = 0.0

  if (.not.associated(Ocean_state)) return
  if (.not.Ocean_state%is_ocean_pe) return

  if(.not.stock_warning_issued) then
     call error_mesg('ocean_stock_pe','Stocks not yet implemented. Returning zero.',WARNING)
     stock_warning_issued = .true.
  endif

  select case (index)
    case (ISTOCK_WATER) ; value = 0.0
    case (ISTOCK_HEAT) ; value = 0.0
    case default ; value = 0.0
  end select

end subroutine ocean_stock_pe
!#######################################################################
subroutine ocean_model_data2D_get(OS,Ocean, name, array2D,isc,jsc)
  type(ocean_state_type),     pointer    :: OS
  type(ocean_public_type),    intent(in) :: Ocean
  character(len=*)          , intent(in) :: name
  real, dimension(isc:,jsc:), intent(out):: array2D
  integer                   , intent(in) :: isc,jsc
  
  array2D(isc:,jsc:) = 0.0
  
end subroutine ocean_model_data2D_get

subroutine ocean_model_data1D_get(OS,Ocean, name, value)
  type(ocean_state_type),     pointer    :: OS
  type(ocean_public_type),    intent(in) :: Ocean
  character(len=*)          , intent(in) :: name
  real                      , intent(out):: value

  value = 0.0

end subroutine ocean_model_data1D_get

! Subroutines for calculating checksums
SUBROUTINE ocean_public_type_chksum(id, timestep, bnd_type)
  USE fms_mod, ONLY: stdout
  USE mpp_mod, ONLY: mpp_chksum

  CHARACTER(len=*), INTENT(in) :: id
  INTEGER, INTENT(in) :: timestep
  TYPE(ocean_public_type), INTENT(in) :: bnd_type

  INTEGER :: n, m, outunit

  outunit = stdout()
100 FORMAT("CHECKSUM::",A32," = ",Z20)
101 FORMAT("CHECKSUM::",A16,A,"%",A," = ",Z20)

  WRITE (outunit,*) 'BEGIN CHECKSUM(ocean_public_type):: ', id, timestep
  WRITE (outunit,100) 'ocean_public_type%t_surf ', mpp_chksum(bnd_type%t_surf)
  WRITE (outunit,100) 'ocean_public_type%s_surf ', mpp_chksum(bnd_type%s_surf)
  WRITE (outunit,100) 'ocean_public_type%sea_lev', mpp_chksum(bnd_type%sea_lev)
  WRITE (outunit,100) 'ocean_public_type%frazil ', mpp_chksum(bnd_type%frazil)
  WRITE (outunit,100) 'ocean_public_type%u_surf ', mpp_chksum(bnd_type%u_surf)
  ! %area is not initialised in ocean_mixed_layer
  !WRITE (outunit,100) 'ocean_public_type%area   ', mpp_chksum(bnd_type%area)
  WRITE (outunit,100) 'ocean_public_type%v_surf ', mpp_chksum(bnd_type%v_surf)

  DO n = 1, bnd_type%fields%num_bcs
     DO m = 1, bnd_type%fields%bc(n)%num_fields
        WRITE (outunit,101) 'ocean_public_type%', TRIM(bnd_type%fields%bc(n)%name),&
             & TRIM(bnd_type%fields%bc(n)%field(m)%name),&
             & mpp_chksum(bnd_type%fields%bc(n)%field(m)%values)
     END DO
  END DO
END SUBROUTINE ocean_public_type_chksum

SUBROUTINE ice_ocn_bnd_type_chksum(id, timestep, bnd_type)
  USE fms_mod, ONLY: stdout
  USE mpp_mod, ONLY: mpp_chksum

  CHARACTER(len=*), INTENT(in) :: id
  INTEGER, INTENT(in) :: timestep
  TYPE(ice_ocean_boundary_type), INTENT(in) :: bnd_type

  INTEGER :: n, m, outunit

  outunit = stdout()
100 FORMAT("CHECKSUM::",A32," = ",Z20)
101 FORMAT("CHECKSUM::",A16,A,"%",A," = ",Z20)

  WRITE (outunit,*) 'BEGIN CHECKSUM(ice_ocean_boundary_type):: ', id, timestep
  WRITE (outunit,100) 'ice_ocean_boundary_type%u_flux         ', mpp_chksum(bnd_type%u_flux)
  WRITE (outunit,100) 'ice_ocean_boundary_type%v_flux         ', mpp_chksum(bnd_type%v_flux)
  WRITE (outunit,100) 'ice_ocean_boundary_type%t_flux         ', mpp_chksum(bnd_type%t_flux)
  WRITE (outunit,100) 'ice_ocean_boundary_type%q_flux         ', mpp_chksum(bnd_type%q_flux)
  WRITE (outunit,100) 'ice_ocean_boundary_type%salt_flux      ', mpp_chksum(bnd_type%salt_flux)
  WRITE (outunit,100) 'ice_ocean_boundary_type%lw_flux        ', mpp_chksum(bnd_type%lw_flux)
  WRITE (outunit,100) 'ice_ocean_boundary_type%sw_flux_nir_dir', mpp_chksum(bnd_type%sw_flux_nir_dir)
  WRITE (outunit,100) 'ice_ocean_boundary_type%sw_flux_nir_dif', mpp_chksum(bnd_type%sw_flux_nir_dif)
  WRITE (outunit,100) 'ice_ocean_boundary_type%sw_flux_vis_dir', mpp_chksum(bnd_type%sw_flux_vis_dir)
  WRITE (outunit,100) 'ice_ocean_boundary_type%sw_flux_vis_dif', mpp_chksum(bnd_type%sw_flux_vis_dif)
  WRITE (outunit,100) 'ice_ocean_boundary_type%lprec          ', mpp_chksum(bnd_type%lprec)
  WRITE (outunit,100) 'ice_ocean_boundary_type%fprec          ', mpp_chksum(bnd_type%fprec)
  WRITE (outunit,100) 'ice_ocean_boundary_type%runoff         ', mpp_chksum(bnd_type%runoff)
  WRITE (outunit,100) 'ice_ocean_boundary_type%calving        ', mpp_chksum(bnd_type%calving)
  WRITE (outunit,100) 'ice_ocean_boundary_type%p              ', mpp_chksum(bnd_type%p)
  WRITE (outunit,100) 'ice_ocean_boundary_type%runoff_hflx    ', mpp_chksum(bnd_type%runoff_hflx)
  WRITE (outunit,100) 'ice_ocean_boundary_type%calving_hflx   ', mpp_chksum(bnd_type%runoff_hflx)

  DO n = 1, bnd_type%fluxes%num_bcs
     DO m = 1, bnd_type%fluxes%bc(n)%num_fields
        WRITE (outunit,101) 'ice_ocean_boundary_type%', TRIM(bnd_type%fluxes%bc(n)%name),&
             & TRIM(bnd_type%fluxes%bc(n)%field(m)%name),&
             & mpp_chksum(bnd_type%fluxes%bc(n)%field(m)%values)
     END DO
  END DO
END SUBROUTINE ice_ocn_bnd_type_chksum

end module ocean_model_mod

! ----------------------------------------------------------------
!                   GNU General Public License                        
! This file is a part of MOM.                                                                 
!                                                                      
! MOM is free software; you can redistribute it and/or modify it and  
! are expected to follow the terms of the GNU General Public License  
! as published by the Free Software Foundation; either version 2 of   
! the License, or (at your option) any later version.                 
!                                                                      
! MOM is distributed in the hope that it will be useful, but WITHOUT    
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
! License for more details.                                           
!                                                                      
! For the full text of the GNU General Public License,                
! write to: Free Software Foundation, Inc.,                           
!           675 Mass Ave, Cambridge, MA 02139, USA.                   
! or see:   http://www.gnu.org/licenses/gpl.html                      
!-----------------------------------------------------------------------
!
! 
!<CONTACT EMAIL="Richard.Slater@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="John.Dunne@noaa.gov"> John P. Dunne
!</REVIEWER>
!
!<OVERVIEW>
! Ocean Carbon Model Intercomparison Study II: Gas exchange coupler
!</OVERVIEW>
!
!<DESCRIPTION>
!       Implementation of routines to solve the gas fluxes at the
!       ocean surface for a coupled model
!       as outlined in the Biotic-HOWTO documentation,
!       revision 1.7, 1999/10/05.
!</DESCRIPTION>
!
! <REFERENCE>
! http://www.ipsl.jussieu.fr/OCMIP/phase2/simulations/Biotic/HOWTO-Biotic.html
! </REFERENCE>
!

!
!------------------------------------------------------------------
!
!       Module atmos_ocean_fluxes_mod
!
!       This module will take fields from an atmospheric and an
!       oceanic model and calculate ocean surface fluxes for
!       CO2, O2, CFC-11 or CFC-12 as outlined in the various
!       HOWTO documents at the OCMIP2 website. Multiple instances
!       of a given tracer may be given, resulting in multiple
!       surface fluxes. Additionally, data may be overridden at
!       the individual fields, or fluxes. This could be used in
!       the absence of an atmospheric or oceanic model.
!
!------------------------------------------------------------------
!

module  atmos_ocean_fluxes_mod  !{

!
!------------------------------------------------------------------
!
!       Global definitions
!
!------------------------------------------------------------------
!

!
!----------------------------------------------------------------------
!
!       Modules
!
!----------------------------------------------------------------------
!

use mpp_mod,           only: stdout, stdlog, mpp_error, FATAL, mpp_sum, mpp_npes

use coupler_types_mod, only: coupler_1d_bc_type
use coupler_types_mod, only: ind_alpha, ind_csurf, ind_sc_no
use coupler_types_mod, only: ind_pcair, ind_u10, ind_psurf
use coupler_types_mod, only: ind_deposition
use coupler_types_mod, only: ind_runoff
use coupler_types_mod, only: ind_flux, ind_deltap, ind_kw

use field_manager_mod, only: fm_path_name_len, fm_string_len, fm_exists, fm_get_index
use field_manager_mod, only: fm_new_list, fm_get_current_list, fm_change_list
use field_manager_mod, only: fm_field_name_len, fm_type_name_len, fm_dump_list
use field_manager_mod, only: fm_loop_over_list

use fm_util_mod,       only: fm_util_default_caller
use fm_util_mod,       only: fm_util_get_length
use fm_util_mod,       only: fm_util_set_value, fm_util_set_good_name_list, fm_util_set_no_overwrite
use fm_util_mod,       only: fm_util_set_caller, fm_util_reset_good_name_list, fm_util_reset_no_overwrite
use fm_util_mod,       only: fm_util_reset_caller, fm_util_get_string_array, fm_util_check_for_bad_fields
use fm_util_mod,       only: fm_util_get_string, fm_util_get_real_array, fm_util_get_real, fm_util_get_integer
use fm_util_mod,       only: fm_util_get_logical, fm_util_get_logical_array

!
!----------------------------------------------------------------------
!
!       force all variables to be "typed"
!
!----------------------------------------------------------------------
!

implicit none

!
!----------------------------------------------------------------------
!
!       Make all routines and variables private by default
!
!----------------------------------------------------------------------
!

private

!
!----------------------------------------------------------------------
!
!       Public routines
!
!----------------------------------------------------------------------
!

public  :: atmos_ocean_fluxes_calc
public  :: atmos_ocean_fluxes_init
public  :: aof_set_coupler_flux

!
!----------------------------------------------------------------------
!
!       Public parameters
!
!----------------------------------------------------------------------
!

!
!----------------------------------------------------------------------
!
!       Public types
!
!----------------------------------------------------------------------
!

!
!----------------------------------------------------------------------
!
!       Public variables
!
!----------------------------------------------------------------------
!

!
!----------------------------------------------------------------------
!
!       Private routines
!
!----------------------------------------------------------------------
!

!
!----------------------------------------------------------------------
!
!       Private parameters
!
!----------------------------------------------------------------------
!

character(len=48), parameter    :: mod_name = 'atmos_ocean_fluxes_mod'

!
!----------------------------------------------------------------------
!
!       Private types
!
!----------------------------------------------------------------------
!

!
!----------------------------------------------------------------------
!
!       Private variables
!
!----------------------------------------------------------------------
!

character(len=128) :: version = '$Id$'
character(len=128) :: tagname = '$Name$'

!
!-----------------------------------------------------------------------
!
!       Subroutine and function definitions
!
!-----------------------------------------------------------------------
!

contains


!#######################################################################
! <FUNCTION NAME="aof_set_coupler_flux">
!
! <DESCRIPTION>
! Set the values for a coupler flux and return its index (0 on error)
! </DESCRIPTION>
!
function aof_set_coupler_flux(name, flux_type, implementation, atm_tr_index, param, flag,       &
     mol_wt, ice_restart_file, ocean_restart_file, units, caller)           &
         result (coupler_index)  !{

implicit none

!
!       Return type
!

integer :: coupler_index

!
!       arguments
!

character(len=*), intent(in)                            :: name
character(len=*), intent(in)                            :: flux_type
character(len=*), intent(in)                            :: implementation
integer, intent(in), optional                           :: atm_tr_index
real, intent(in), dimension(:), optional                :: param
logical, intent(in), dimension(:), optional             :: flag
real, intent(in), optional                              :: mol_wt
character(len=*), intent(in), optional                  :: ice_restart_file
character(len=*), intent(in), optional                  :: ocean_restart_file
character(len=*), intent(in), optional                  :: units
character(len=*), intent(in), optional                  :: caller

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'aof_set_coupler_flux'

!
!       Local variables
!

integer                                                 :: n
integer                                                 :: length
integer                                                 :: num_parameters
integer                                                 :: outunit
character(len=fm_path_name_len)                         :: coupler_list
character(len=fm_path_name_len)                         :: current_list
character(len=fm_string_len)                            :: flux_type_test
character(len=fm_string_len)                            :: implementation_test
character(len=256)                                      :: error_header
character(len=256)                                      :: warn_header
character(len=256)                                      :: note_header
character(len=128)                                      :: flux_list
character(len=128)                                      :: caller_str
character(len=fm_string_len), pointer, dimension(:)     :: good_list => NULL()
character(len=256)                                      :: long_err_msg

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}
outunit = stdout()
write (outunit,*)
write (outunit,*) trim(note_header), ' Processing coupler fluxes ', trim(name)

!
!       define the coupler list name
!

coupler_list = '/coupler_mod/fluxes/' // trim(name)

!
!       Check whether a flux has already been set for this name, and if so, return
!       the index for it (this is because the fluxes may be defined in both the atmosphere
!       and ocean models) (check whether the good_list list exists, since this will
!       indicate that this routine has already been called, and not just that
!       the field table input has this list defined)
!

if (fm_exists('/coupler_mod/GOOD/fluxes/' // trim(name) // '/good_list')) then  !{
  write (outunit,*)
  write (outunit,*) trim(note_header), ' Using previously defined coupler flux'
  coupler_index = fm_get_index(coupler_list)
  if (coupler_index .le. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Could not get coupler flux ')
  endif  !}

!
!       allow atm_tr_index to be set here, since it will only be set from atmospheric
!       PEs, and the atmospheric routines call this routine last, thus overwriting the
!       current value is safe (furthermore, this is not a value which could have any meaningful
!       value set from the run script.
!

  if (present(atm_tr_index)) then  !{
    write (outunit,*) trim(note_header), ' Redefining atm_tr_index to ', atm_tr_index
    call fm_util_set_value(trim(coupler_list) // '/atm_tr_index', atm_tr_index, no_create = .true.,        &
         no_overwrite = .false., caller = caller_str)
  endif  !}
  return
endif  !}

!
!       Set a new coupler flux and get its index
!

coupler_index = fm_new_list(coupler_list)
if (coupler_index .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set coupler flux ')
endif  !}

!
!       Change to the new list, first saving the current list
!

current_list = fm_get_current_list()
if (current_list .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not get the current list')
endif  !}

if (.not. fm_change_list(coupler_list)) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not change to the new list')
endif  !}

!
!       Set the array in which to save the valid names for this list,
!       used later for a consistency check. This is used in the fm_util_set_value
!       routines to make the list of valid values
!

call fm_util_set_good_name_list('/coupler_mod/GOOD/fluxes/' // trim(name) // '/good_list')

!
!       Set other defaults for the fm_util_set_value routines
!

call fm_util_set_no_overwrite(.true.)
call fm_util_set_caller(caller_str)

!
!       Set various values to given values, or to defaults if not given
!

if (flux_type .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Blank flux_type given')
else  !}{
  if (fm_exists('/coupler_mod/types/' // trim(flux_type))) then  !{
    call fm_util_set_value('flux_type', flux_type)
!
!       check that the flux_type that we will use (possibly given from the field_table)
!       is defined
!
    flux_type_test = fm_util_get_string('flux_type', scalar = .true.)
    if (.not. fm_exists('/coupler_mod/types/' // trim(flux_type_test))) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Undefined flux_type given from field_table: ' // trim(flux_type_test))
    endif  !}
  else  !}{
    call mpp_error(FATAL, trim(error_header) // ' Undefined flux_type given as argument to the subroutine: ' // trim(flux_type))
  endif  !}
endif  !}

if (implementation .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Blank flux_type given')
else  !}{
  if (fm_exists('/coupler_mod/types/' // trim(flux_type) // '/implementation/' // trim(implementation))) then  !{
    call fm_util_set_value('implementation', implementation)
!
!       check that the flux_type/implementation that we will use
!       (both possibly given from the field_table) is defined
!
    implementation_test = fm_util_get_string('implementation', scalar = .true.)
    if (.not. fm_exists('/coupler_mod/types/' // trim(flux_type_test) //  '/implementation/' // trim(implementation_test))) then  !{
      if (flux_type .eq. flux_type_test) then
        if (implementation .eq. implementation_test) then
          call mpp_error(FATAL, trim(error_header) // ' Should not get here, as it is tested for above')
        else
          call mpp_error(FATAL, trim(error_header) //                                                   &
               ' Undefined flux_type/implementation (implementation given from field_table): ' //       &
               trim(flux_type_test) // '/implementation/' // trim(implementation_test))
        endif
      else
        if (implementation .eq. implementation_test) then
          long_err_msg = 'Undefined flux_type/implementation (flux_type given from field_table): '
          long_err_msg = long_err_msg // trim(flux_type_test) // '/implementation/' // trim(implementation_test)
          call mpp_error(FATAL, trim(error_header) // long_err_msg)
        else
          long_err_msg = ' Undefined flux_type/implementation (both given from field_table): '
          long_err_msg = long_err_msg //  trim(flux_type_test) // '/implementation/' // trim(implementation_test)
          call mpp_error(FATAL, trim(error_header) // long_err_msg)
        endif
      endif
    endif  !}
  else  !}{
    call mpp_error(FATAL, trim(error_header) // ' Undefined flux_type/implementation given as argument to the subroutine: ' //  &
         trim(flux_type) // '/implementation/' // trim(implementation))
  endif  !}
endif  !}

if (present(atm_tr_index)) then  !{
  call fm_util_set_value('atm_tr_index', atm_tr_index)
else  !}{
  call fm_util_set_value('atm_tr_index', 0)
endif  !}

if (present(mol_wt)) then  !{
  call fm_util_set_value('mol_wt', mol_wt)
else  !}{
  call fm_util_set_value('mol_wt', 0.0)
endif  !}

if (present(ice_restart_file)) then  !{
  call fm_util_set_value('ice_restart_file', ice_restart_file)
else  !}{
  call fm_util_set_value('ice_restart_file', 'ice_coupler_fluxes.res.nc')
endif  !}

if (present(ocean_restart_file)) then  !{
  call fm_util_set_value('ocean_restart_file', ocean_restart_file)
else  !}{
  call fm_util_set_value('ocean_restart_file', 'ocean_coupler_fluxes.res.nc')
endif  !}

if (present(param)) then  !{
  num_parameters = fm_util_get_integer('/coupler_mod/types/' //                                 &
       trim(fm_util_get_string('flux_type', scalar = .true.)) // '/implementation/' //          &
       trim(fm_util_get_string('implementation', scalar = .true.)) // '/num_parameters', scalar = .true.)
  length = min(size(param(:)),num_parameters)
  if (length .ne. num_parameters) then  !{
    write (outunit,*) trim(note_header), ' Number of parameters provided for ', trim(name), ' does not match the'
    write (outunit,*) 'number of parameters required (', size(param(:)), ' != ', num_parameters, ').'
    write (outunit,*) 'This could be an error, or more likely is just a result of the implementation being'
    write (outunit,*) 'overridden by the field table input'
  endif  !}
  if (length .gt. 0) then  !{
    call fm_util_set_value('param', param(1:length), length)
  else  !}{
    call fm_util_set_value('param', 'null', index = 0)
  endif  !}
else  !}{
  call fm_util_set_value('param', 'null', index = 0)
endif  !}

if (present(flag)) then  !{
  call fm_util_set_value('flag', flag, size(flag(:)))
else  !}{
  call fm_util_set_value('flag', .false., index = 0)
endif  !}

flux_list = '/coupler_mod/types/' // trim(flux_type) // '/'

if (present(units)) then  !{
  call fm_util_set_value(trim(fm_util_get_string(trim(flux_list) // 'flux/name', index = ind_flux)) // '-units', units)
else  !}{
  call fm_util_set_value(trim(fm_util_get_string(trim(flux_list) // 'flux/name', index = ind_flux)) // '-units',      &
                         fm_util_get_string(trim(flux_list) // 'flux/units', index = ind_flux))
endif  !}

do n = 1, fm_util_get_length(trim(flux_list) // 'flux/name')  !{
  if (n .ne. ind_flux) then  !{
    call fm_util_set_value(trim(fm_util_get_string(trim(flux_list) // 'flux/name', index = n)) // '-units',   &
                           fm_util_get_string(trim(flux_list) // 'flux/units', index = n))
  endif  !}
  call fm_util_set_value(trim(fm_util_get_string(trim(flux_list) // 'flux/name', index = n)) // '-long_name', &
                         fm_util_get_string(trim(flux_list) // 'flux/long_name', index = n))
enddo  !} n

do n = 1, fm_util_get_length(trim(flux_list) // 'atm/name')  !{
  call fm_util_set_value(trim(fm_util_get_string(trim(flux_list) // 'atm/name', index = n)) // '-units',      &
                         fm_util_get_string(trim(flux_list) // 'atm/units', index = n))
  call fm_util_set_value(trim(fm_util_get_string(trim(flux_list) // 'atm/name', index = n)) // '-long_name',  &
                         fm_util_get_string(trim(flux_list) // 'atm/long_name', index = n))
enddo  !} n

do n = 1, fm_util_get_length(trim(flux_list) // 'ice/name')  !{
  call fm_util_set_value(trim(fm_util_get_string(trim(flux_list) // 'ice/name', index = n)) // '-units',      &
                         fm_util_get_string(trim(flux_list) // 'ice/units', index = n))
  call fm_util_set_value(trim(fm_util_get_string(trim(flux_list) // 'ice/name', index = n)) // '-long_name',  &
                         fm_util_get_string(trim(flux_list) // 'ice/long_name', index = n))
enddo  !} n

!
!       Reset the defaults for the fm_util_set_value calls
!

call fm_util_reset_good_name_list
call fm_util_reset_no_overwrite
call fm_util_reset_caller

!
!       Change back to the saved current list
!

if (.not. fm_change_list(current_list)) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not change back to ' // trim(current_list))
endif  !}

!
!       Check for any errors in the number of fields in this list
!

if (caller_str .eq. ' ') then  !{
  caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'
endif  !}
good_list => fm_util_get_string_array('/coupler_mod/GOOD/fluxes/' // trim(name) // '/good_list', &
     caller = caller_str)
if (associated(good_list)) then  !{
  call fm_util_check_for_bad_fields(trim(coupler_list), good_list, caller = caller_str)
  deallocate(good_list)
else  !}{
  call mpp_error(FATAL, trim(error_header) // ' Empty "' // trim(name) // '" list')
endif  !}

return

end function aof_set_coupler_flux  !}
! </FUNCTION> NAME="aof_set_coupler_flux"


!#######################################################################
! <SUBROUTINE NAME="atmos_ocean_fluxes_init">
!
! <DESCRIPTION>
!     Initialize gas flux structures
! </DESCRIPTION>
!

subroutine atmos_ocean_fluxes_init(gas_fluxes, gas_fields_atm, gas_fields_ice)  !{

implicit none

!
!-----------------------------------------------------------------------
!     arguments
!-----------------------------------------------------------------------
!

type(coupler_1d_bc_type), intent(inout) :: gas_fluxes
type(coupler_1d_bc_type), intent(inout) :: gas_fields_atm
type(coupler_1d_bc_type), intent(inout) :: gas_fields_ice

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

character(len=64), parameter    :: sub_name = 'atmos_ocean_fluxes_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!-----------------------------------------------------------------------
!     local variables
!-----------------------------------------------------------------------
!

integer                                 :: num_parameters
integer                                 :: num_flags
integer                                 :: n
integer                                 :: m
character(len=128)                      :: caller_str
character(len=fm_type_name_len)         :: typ
character(len=fm_field_name_len)        :: name
integer                                 :: ind
integer                                 :: outunit
integer                                 :: total_fluxes
character(len=8)                        :: string
character(len=128)                      :: error_string
character(len=128)                      :: flux_list
logical, save                           :: initialized = .false.

!
! =====================================================================
!     begin executable code
! =====================================================================
!

!
!       don't execute if already called
!

if (initialized) then  !{

  return

endif  !}

initialized = .true.
outunit = stdout()
!write (outunit,*)
!write (outunit,*) 'Dumping field manager tree'
!if (.not. fm_dump_list('/', recursive = .true.)) then  !{
  !call mpp_error(FATAL, trim(error_header) // ' Problem dumping field manager tree')
!endif  !}

caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

!
!       Set other defaults for the fm_util_set_value routines
!

call fm_util_set_no_overwrite(.true.)
call fm_util_set_caller(caller_str)

!
!       determine the number of flux fields
!

gas_fluxes%num_bcs = fm_util_get_length('/coupler_mod/fluxes/')
gas_fields_atm%num_bcs = gas_fluxes%num_bcs
gas_fields_ice%num_bcs = gas_fluxes%num_bcs
if (gas_fluxes%num_bcs .lt. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not get number of fluxes')
elseif (gas_fluxes%num_bcs .eq. 0) then  !}{
  write (outunit,*) trim(note_header), ' No gas fluxes'
  return
else  !}{
  write (outunit,*) trim(note_header), ' Processing ', gas_fluxes%num_bcs, ' gas fluxes'
endif  !}

!
!       allocate the arrays
!

allocate (gas_fluxes%bc(gas_fluxes%num_bcs))

allocate (gas_fields_atm%bc(gas_fields_atm%num_bcs))

allocate (gas_fields_ice%bc(gas_fields_ice%num_bcs))

!
!       loop over the input fields, setting the values in the flux_type
!

n = 0
do while (fm_loop_over_list('/coupler_mod/fluxes', name, typ, ind))  !{
   
  if (typ .ne. 'list') then  !{
       
    call mpp_error(FATAL, trim(error_header) // ' ' // trim(name) // ' is not a list')
       
  else  !}{

    n = n + 1  ! increment the array index

    if (n .ne. ind) then  !{
      write (outunit,*) trim(warn_header), ' Flux index, ', ind,       &
           ' does not match array index, ', n, ' for ', trim(name)
    endif  !}

!
!       Change list to the new flux
!

    if (.not. fm_change_list('/coupler_mod/fluxes/' // trim(name))) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem changing to ' // trim(name))
    endif  !}

!
!       save and check the flux_type
!

    gas_fluxes%bc(n)%flux_type = fm_util_get_string('flux_type', scalar = .true.)
    if (.not. fm_exists('/coupler_mod/types/' // trim(gas_fluxes%bc(n)%flux_type))) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Undefined flux_type given for ' //          &
           trim(name) // ': ' // trim(gas_fluxes%bc(n)%flux_type))
    endif  !}
    gas_fields_atm%bc(n)%flux_type = gas_fluxes%bc(n)%flux_type
    gas_fields_ice%bc(n)%flux_type = gas_fluxes%bc(n)%flux_type

!
!       save and check the implementation
!

    gas_fluxes%bc(n)%implementation = fm_util_get_string('implementation', scalar = .true.)
    if (.not. fm_exists('/coupler_mod/types/' // trim(gas_fluxes%bc(n)%flux_type) //            &
         '/implementation/' // trim(gas_fluxes%bc(n)%implementation))) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Undefined implementation given for ' //     &
           trim(name) // ': ' // trim(gas_fluxes%bc(n)%flux_type) // '/implementation/' //      &
           trim(gas_fluxes%bc(n)%implementation))
    endif  !}
    gas_fields_atm%bc(n)%implementation = gas_fluxes%bc(n)%implementation
    gas_fields_ice%bc(n)%implementation = gas_fluxes%bc(n)%implementation

!
!       set the flux list name
!

    flux_list = '/coupler_mod/types/' // trim(gas_fluxes%bc(n)%flux_type) // '/'

!
!       allocate the arrays
!

    gas_fluxes%bc(n)%num_fields = fm_util_get_length(trim(flux_list) // 'flux/name')
    allocate (gas_fluxes%bc(n)%field(gas_fluxes%bc(n)%num_fields))
    gas_fields_atm%bc(n)%num_fields = fm_util_get_length(trim(flux_list) // 'atm/name')
    allocate (gas_fields_atm%bc(n)%field(gas_fields_atm%bc(n)%num_fields))
    gas_fields_ice%bc(n)%num_fields = fm_util_get_length(trim(flux_list) // 'ice/name')
    allocate (gas_fields_ice%bc(n)%field(gas_fields_ice%bc(n)%num_fields))

!
!       save the name and generate unique field names for Flux, Ice and Atm
!

    gas_fluxes%bc(n)%name = name
    do m = 1, fm_util_get_length(trim(flux_list) // 'flux/name')  !{
      gas_fluxes%bc(n)%field(m)%name = trim(name) // "_" // fm_util_get_string(trim(flux_list) // 'flux/name', index = m)
      gas_fluxes%bc(n)%field(m)%override = .false.
      gas_fluxes%bc(n)%field(m)%mean     = .false.
    enddo  !} m

    gas_fields_atm%bc(n)%name = name
    do m = 1, fm_util_get_length(trim(flux_list) // 'atm/name')  !{
      gas_fields_atm%bc(n)%field(m)%name = trim(name) // "_" // fm_util_get_string(trim(flux_list) // 'atm/name', index = m)
      gas_fields_atm%bc(n)%field(m)%override = .false.
      gas_fields_atm%bc(n)%field(m)%mean     = .false.
    enddo  !} m

    gas_fields_ice%bc(n)%name = name
    do m = 1, fm_util_get_length(trim(flux_list) // 'ice/name')  !{
      gas_fields_ice%bc(n)%field(m)%name = trim(name) // "_" // fm_util_get_string(trim(flux_list) // 'ice/name', index = m)
      gas_fields_ice%bc(n)%field(m)%override = .false.
      gas_fields_ice%bc(n)%field(m)%mean     = .false.
    enddo  !} m

!
!       save the units
!

    do m = 1, fm_util_get_length(trim(flux_list) // 'flux/name')  !{
      gas_fluxes%bc(n)%field(m)%units =         &
           fm_util_get_string(trim(fm_util_get_string(trim(flux_list) // 'flux/name', index = m)) // '-units', scalar = .true.)
    enddo  !} m
    do m = 1, fm_util_get_length(trim(flux_list) // 'atm/name')  !{
      gas_fields_atm%bc(n)%field(m)%units =             &
           fm_util_get_string(trim(fm_util_get_string(trim(flux_list) // 'atm/name', index = m)) // '-units')
    enddo  !} m
    do m = 1, fm_util_get_length(trim(flux_list) // 'ice/name')  !{
      gas_fields_ice%bc(n)%field(m)%units =             &
           fm_util_get_string(trim(fm_util_get_string(trim(flux_list) // 'ice/name', index = m)) // '-units')
    enddo  !} m

!
!       save the long names
!

    do m = 1, fm_util_get_length(trim(flux_list) // 'flux/name')  !{
      gas_fluxes%bc(n)%field(m)%long_name =      &
           fm_util_get_string(trim(fm_util_get_string(trim(flux_list) // 'flux/name', index = m)) // '-long_name', scalar = .true.)
      gas_fluxes%bc(n)%field(m)%long_name = trim(gas_fluxes%bc(n)%field(m)%long_name) // ' for ' // name
    enddo  !} m
    do m = 1, fm_util_get_length(trim(flux_list) // 'atm/name')  !{
      gas_fields_atm%bc(n)%field(m)%long_name =      &
           fm_util_get_string(trim(fm_util_get_string(trim(flux_list) // 'atm/name', index = m)) // '-long_name')
      gas_fields_atm%bc(n)%field(m)%long_name = trim(gas_fields_atm%bc(n)%field(m)%long_name) // ' for ' // name
    enddo  !} m
    do m = 1, fm_util_get_length(trim(flux_list) // 'ice/name')  !{
      gas_fields_ice%bc(n)%field(m)%long_name =      &
           fm_util_get_string(trim(fm_util_get_string(trim(flux_list) // 'ice/name', index = m)) // '-long_name')
      gas_fields_ice%bc(n)%field(m)%long_name = trim(gas_fields_ice%bc(n)%field(m)%long_name) // ' for ' // name
    enddo  !} m

!
!       save the atm_tr_index
!

    gas_fluxes%bc(n)%atm_tr_index = fm_util_get_integer('atm_tr_index', scalar = .true.)

!
!       save the molecular weight
!

    gas_fluxes%bc(n)%mol_wt = fm_util_get_real('mol_wt', scalar = .true.)
    gas_fields_atm%bc(n)%mol_wt = gas_fluxes%bc(n)%mol_wt
    gas_fields_ice%bc(n)%mol_wt = gas_fluxes%bc(n)%mol_wt

!
!       save the ice_restart_file
!

    gas_fluxes%bc(n)%ice_restart_file = fm_util_get_string('ice_restart_file', scalar = .true.)
    gas_fields_atm%bc(n)%ice_restart_file = gas_fluxes%bc(n)%ice_restart_file
    gas_fields_ice%bc(n)%ice_restart_file = gas_fluxes%bc(n)%ice_restart_file

!
!       save the ocean_restart_file
!

    gas_fluxes%bc(n)%ocean_restart_file = fm_util_get_string('ocean_restart_file', scalar = .true.)
    gas_fields_atm%bc(n)%ocean_restart_file = gas_fluxes%bc(n)%ocean_restart_file
    gas_fields_ice%bc(n)%ocean_restart_file = gas_fluxes%bc(n)%ocean_restart_file

!
!       save the params
!

    gas_fluxes%bc(n)%param => fm_util_get_real_array('param')

!
!       save the flags
!

    gas_fluxes%bc(n)%flag => fm_util_get_logical_array('flag')

!
!       Perform some integrity checks
!

    num_parameters = fm_util_get_integer(trim(flux_list) // 'implementation/' //        &
         trim(gas_fluxes%bc(n)%implementation) // '/num_parameters', scalar = .true.)
    if (num_parameters .gt. 0) then  !{
      if (.not. associated(gas_fluxes%bc(n)%param)) then  !{
        write (error_string,'(a,i2)') ': need ', num_parameters
        call mpp_error(FATAL, trim(error_header) // ' No param for ' // trim(name) // trim(error_string))
      elseif (size(gas_fluxes%bc(n)%param(:)) .ne. num_parameters) then  !}{
        write (error_string,'(a,i2,a,i2)') ': ', size(gas_fluxes%bc(n)%param(:)), ' given, need ', num_parameters
        call mpp_error(FATAL, trim(error_header) // ' Wrong number of param for ' // trim(name) // trim(error_string))
      endif  !}
    elseif (num_parameters .eq. 0) then  !}{
      if (associated(gas_fluxes%bc(n)%param)) then  !{
        write (error_string,'(a,i3)') ' but has size of ', size(gas_fluxes%bc(n)%param(:))
        call mpp_error(FATAL, trim(error_header) // ' No params needed for ' // trim(name) // trim(error_string))
      endif  !}
    else  !}{
      write (error_string,'(a,i2)') ': ', num_parameters
      call mpp_error(FATAL, trim(error_header) // 'Num_parameters is negative for ' // trim(name) // trim(error_string))
    endif  !}
    num_flags = fm_util_get_integer(trim(flux_list) // '/num_flags', scalar = .true.)
    if (num_flags .gt. 0) then  !{
      if (.not. associated(gas_fluxes%bc(n)%flag)) then  !{
        write (error_string,'(a,i2)') ': need ', num_flags
        call mpp_error(FATAL, trim(error_header) // ' No flag for ' // trim(name) // trim(error_string))
      elseif (size(gas_fluxes%bc(n)%flag(:)) .ne. num_flags) then  !}{
        write (error_string,'(a,i2,a,i2)') ': ', size(gas_fluxes%bc(n)%flag(:)), ' given, need ', num_flags
        call mpp_error(FATAL, trim(error_header) // ' Wrong number of flag for ' // trim(name) // trim(error_string))
      endif  !}
    elseif (num_flags .eq. 0) then  !}{
      if (associated(gas_fluxes%bc(n)%flag)) then  !{
        write (error_string,'(a,i3)') ' but has size of ', size(gas_fluxes%bc(n)%flag(:))
        call mpp_error(FATAL, trim(error_header) // ' No flags needed for ' // trim(name) // trim(error_string))
      endif  !}
    else  !}{
      write (error_string,'(a,i2)') ': ', num_flags
      call mpp_error(FATAL, trim(error_header) // 'Num_flags is negative for ' // trim(name) // trim(error_string))
    endif  !}

!
!       set some flags for this flux_type
!

    gas_fluxes%bc(n)%use_atm_pressure = fm_util_get_logical(trim(flux_list) // '/use_atm_pressure')
    gas_fields_atm%bc(n)%use_atm_pressure = gas_fluxes%bc(n)%use_atm_pressure
    gas_fields_ice%bc(n)%use_atm_pressure = gas_fluxes%bc(n)%use_atm_pressure

    gas_fluxes%bc(n)%use_10m_wind_speed = fm_util_get_logical(trim(flux_list) // '/use_10m_wind_speed')
    gas_fields_atm%bc(n)%use_10m_wind_speed = gas_fluxes%bc(n)%use_10m_wind_speed
    gas_fields_ice%bc(n)%use_10m_wind_speed = gas_fluxes%bc(n)%use_10m_wind_speed

    gas_fluxes%bc(n)%pass_through_ice = fm_util_get_logical(trim(flux_list) // '/pass_through_ice')
    gas_fields_atm%bc(n)%pass_through_ice = gas_fluxes%bc(n)%pass_through_ice
    gas_fields_ice%bc(n)%pass_through_ice = gas_fluxes%bc(n)%pass_through_ice

  endif  !}

enddo  !}

write (outunit,*)
write (outunit,*) 'Dumping fluxes tracer tree'
if (.not. fm_dump_list('/coupler_mod/fluxes', recursive = .true.)) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Problem dumping fluxes tracer tree')
endif  !}

!
!       Check that the number of fluxes is the same on all processors
!       If they are, then the sum of the number of fluxes across all processors
!       should equal to the number of fluxes on each processor times the number of processors
!

total_fluxes = gas_fluxes%num_bcs
call mpp_sum(total_fluxes)
if (total_fluxes .ne. mpp_npes() * gas_fluxes%num_bcs) then  !{
  write (string, '(i4)') gas_fluxes%num_bcs
  call mpp_error(FATAL, trim(error_header) //           &
       ' Number of fluxes does not match across the processors: ' // trim(string) // ' fluxes')
endif  !}

!
!       Reset the defaults for the fm_util_set_value calls
!

call fm_util_reset_no_overwrite
call fm_util_reset_caller

return
end subroutine  atmos_ocean_fluxes_init  !}
! </SUBROUTINE> NAME="atmos_ocean_fluxes_init"


!#######################################################################
! <SUBROUTINE NAME="atmos_ocean_fluxes_calc">
!
! <DESCRIPTION>
!     Calculate the ocean gas fluxes. Units should be mol/m^2/s, upward flux is positive.
! </DESCRIPTION>
!

subroutine atmos_ocean_fluxes_calc(gas_fields_atm, gas_fields_ice,      &
     gas_fluxes, seawater)  !{

!
!-----------------------------------------------------------------------
!     modules (have to come first)
!-----------------------------------------------------------------------
!

implicit none

!
!-----------------------------------------------------------------------
!     arguments
!-----------------------------------------------------------------------
!

type(coupler_1d_bc_type), intent(in)            :: gas_fields_atm
type(coupler_1d_bc_type), intent(in)            :: gas_fields_ice
type(coupler_1d_bc_type), intent(inout)         :: gas_fluxes
real, intent(in), dimension(:)                  :: seawater

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

character(len=64), parameter    :: sub_name = 'atmos_ocean_fluxes_calc'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!-----------------------------------------------------------------------
!     local variables
!-----------------------------------------------------------------------
!

integer                                 :: n
integer                                 :: i
integer                                 :: length
real, dimension(:), allocatable         :: kw
real, dimension(:), allocatable         :: cair
character(len=128)                      :: error_string

real, parameter :: epsln=1.0e-30
real, parameter :: permeg=1.0e-6

!
!       Return if no fluxes to be calculated
!

if (gas_fluxes%num_bcs .le. 0) then
  return
endif

!
!       check some things
!

if (.not. associated(gas_fluxes%bc)) then  !{
  if (gas_fluxes%num_bcs .ne. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Number of gas fluxes not zero')
  else  !}{
    return
  endif  !}
endif  !}

!
! =====================================================================
!     begin executable code
! =====================================================================
!

do n = 1, gas_fluxes%num_bcs  !{

!
!       only do calculations if the flux has not been overridden
!

  if ( .not. gas_fluxes%bc(n)%field(ind_flux)%override) then  !{

    if (gas_fluxes%bc(n)%flux_type .eq. 'air_sea_gas_flux_generic') then  !{

      length = size(gas_fluxes%bc(n)%field(1)%values(:))

      if (.not. allocated(kw)) then
        allocate( kw(length) )
        allocate ( cair(length) )
      elseif (size(kw(:)) .ne. length) then
        call mpp_error(FATAL, trim(error_header) // ' Lengths of flux fields do not match')
      endif

      if (gas_fluxes%bc(n)%implementation .eq. 'ocmip2') then  !}{

        do i = 1, length  !{
          if (seawater(i) == 1.) then  !{
            gas_fluxes%bc(n)%field(ind_kw)%values(i) = gas_fluxes%bc(n)%param(1) * gas_fields_atm%bc(n)%field(ind_u10)%values(i)**2
            cair(i) =                                                           &
                 gas_fields_ice%bc(n)%field(ind_alpha)%values(i) *              &
                 gas_fields_atm%bc(n)%field(ind_pCair)%values(i) *              &
                 gas_fields_atm%bc(n)%field(ind_psurf)%values(i) * gas_fluxes%bc(n)%param(2)
            gas_fluxes%bc(n)%field(ind_flux)%values(i) = gas_fluxes%bc(n)%field(ind_kw)%values(i) *                &
                 sqrt(660. / (gas_fields_ice%bc(n)%field(ind_sc_no)%values(i) + epsln)) *                           &
                 (gas_fields_ice%bc(n)%field(ind_csurf)%values(i) - cair(i))
            gas_fluxes%bc(n)%field(ind_deltap)%values(i) = (gas_fields_ice%bc(n)%field(ind_csurf)%values(i) - cair(i)) / &
                 (gas_fields_ice%bc(n)%field(ind_alpha)%values(i) * permeg + epsln)
          else  !}{
            gas_fluxes%bc(n)%field(ind_kw)%values(i) = 0.0
            gas_fluxes%bc(n)%field(ind_flux)%values(i) = 0.0
            gas_fluxes%bc(n)%field(ind_deltap)%values(i) = 0.0
            cair(i) = 0.0
          endif  !}
        enddo  !} i

      else  !}{

        call mpp_error(FATAL, ' Unknown implementation (' // trim(gas_fluxes%bc(n)%implementation) //    &
             ') for ' // trim(gas_fluxes%bc(n)%name))

      endif  !}

    elseif (gas_fluxes%bc(n)%flux_type .eq. 'air_sea_gas_flux') then  !{

      length = size(gas_fluxes%bc(n)%field(1)%values(:))

      if (.not. allocated(kw)) then
        allocate( kw(length) )
        allocate ( cair(length) )
      elseif (size(kw(:)) .ne. length) then
        call mpp_error(FATAL, trim(error_header) // ' Lengths of flux fields do not match')
      endif

      if (gas_fluxes%bc(n)%implementation .eq. 'ocmip2_data') then  !{

        do i = 1, length  !{
          if (seawater(i) == 1.) then  !{
            kw(i) = gas_fluxes%bc(n)%param(1) * gas_fields_atm%bc(n)%field(ind_u10)%values(i)
            cair(i) =                                                           &
                 gas_fields_ice%bc(n)%field(ind_alpha)%values(i) *              &
                 gas_fields_atm%bc(n)%field(ind_pCair)%values(i) *              &
                 gas_fields_atm%bc(n)%field(ind_psurf)%values(i) * gas_fluxes%bc(n)%param(2)
            gas_fluxes%bc(n)%field(ind_flux)%values(i) = kw(i) *                &
                 (gas_fields_ice%bc(n)%field(ind_csurf)%values(i) - cair(i))
          else  !}{
            gas_fluxes%bc(n)%field(ind_flux)%values(i) = 0.0
            cair(i) = 0.0
            kw(i) = 0.0
          endif  !}
        enddo  !} i

      elseif (gas_fluxes%bc(n)%implementation .eq. 'ocmip2') then  !}{

        do i = 1, length  !{
          if (seawater(i) == 1.) then  !{
            kw(i) = gas_fluxes%bc(n)%param(1) * gas_fields_atm%bc(n)%field(ind_u10)%values(i)**2
            cair(i) =                                                           &
                 gas_fields_ice%bc(n)%field(ind_alpha)%values(i) *              &
                 gas_fields_atm%bc(n)%field(ind_pCair)%values(i) *              &
                 gas_fields_atm%bc(n)%field(ind_psurf)%values(i) * gas_fluxes%bc(n)%param(2)
            gas_fluxes%bc(n)%field(ind_flux)%values(i) = kw(i) *                &
                 (gas_fields_ice%bc(n)%field(ind_csurf)%values(i) - cair(i))
          else  !}{
            gas_fluxes%bc(n)%field(ind_flux)%values(i) = 0.0
            cair(i) = 0.0
            kw(i) = 0.0
          endif  !}
        enddo  !} i

      elseif (gas_fluxes%bc(n)%implementation .eq. 'linear') then  !}{

        do i = 1, length  !{
          if (seawater(i) == 1.) then  !{
            kw(i) = gas_fluxes%bc(n)%param(1) * max(0.0, gas_fields_atm%bc(n)%field(ind_u10)%values(i) - gas_fluxes%bc(n)%param(2))
            cair(i) =                                                           &
                 gas_fields_ice%bc(n)%field(ind_alpha)%values(i) *              &
                 gas_fields_atm%bc(n)%field(ind_pCair)%values(i) *              &
                 gas_fields_atm%bc(n)%field(ind_psurf)%values(i) * gas_fluxes%bc(n)%param(3)
            gas_fluxes%bc(n)%field(ind_flux)%values(i) = kw(i) *                &
                 (gas_fields_ice%bc(n)%field(ind_csurf)%values(i) - cair(i))
          else  !}{
            gas_fluxes%bc(n)%field(ind_flux)%values(i) = 0.0
            cair(i) = 0.0
            kw(i) = 0.0
          endif  !}
        enddo  !} i
    
      else  !}{

        call mpp_error(FATAL, ' Unknown implementation (' // trim(gas_fluxes%bc(n)%implementation) //    &
             ') for ' // trim(gas_fluxes%bc(n)%name))

      endif  !}
    elseif (gas_fluxes%bc(n)%flux_type .eq. 'air_sea_deposition') then  !}{

      if (gas_fluxes%bc(n)%param(1) .le. 0.0) then
        write (error_string, '(1pe10.3)') gas_fluxes%bc(n)%param(1)
        call mpp_error(FATAL, ' Bad parameter (' // trim(error_string) //       &
             ') for air_sea_deposition for ' // trim(gas_fluxes%bc(n)%name))
      endif

      length = size(gas_fluxes%bc(n)%field(1)%values(:))

      if (gas_fluxes%bc(n)%implementation .eq. 'dry') then  !{

        do i = 1, length  !{
          if (seawater(i) == 1.) then  !{
            gas_fluxes%bc(n)%field(ind_flux)%values(i) =        &
                 gas_fields_atm%bc(n)%field(ind_deposition)%values(i) / gas_fluxes%bc(n)%param(1)
          else  !}{
            gas_fluxes%bc(n)%field(ind_flux)%values(i) = 0.0
          endif  !}
        enddo  !} i

      elseif (gas_fluxes%bc(n)%implementation .eq. 'wet') then  !}{

        do i = 1, length  !{
          if (seawater(i) == 1.) then  !{
            gas_fluxes%bc(n)%field(ind_flux)%values(i) =        &
                 gas_fields_atm%bc(n)%field(ind_deposition)%values(i) / gas_fluxes%bc(n)%param(1)
          else  !}{
            gas_fluxes%bc(n)%field(ind_flux)%values(i) = 0.0
          endif  !}
        enddo  !} i
    
      else  !}{

        call mpp_error(FATAL, ' Unknown implementation (' // trim(gas_fluxes%bc(n)%implementation) //    &
             ') for ' // trim(gas_fluxes%bc(n)%name))

      endif  !}

    elseif (gas_fluxes%bc(n)%flux_type .eq. 'land_sea_runoff') then  !}{

      if (gas_fluxes%bc(n)%param(1) .le. 0.0) then
        write (error_string, '(1pe10.3)') gas_fluxes%bc(n)%param(1)
        call mpp_error(FATAL, ' Bad parameter (' // trim(error_string) //       &
             ') for land_sea_runoff for ' // trim(gas_fluxes%bc(n)%name))
      endif

      length = size(gas_fluxes%bc(n)%field(1)%values(:))

      if (gas_fluxes%bc(n)%implementation .eq. 'river') then  !{

        do i = 1, length  !{
          if (seawater(i) == 1.) then  !{
            gas_fluxes%bc(n)%field(ind_flux)%values(i) =        &
                 gas_fields_atm%bc(n)%field(ind_deposition)%values(i) / gas_fluxes%bc(n)%param(1)
          else  !}{
            gas_fluxes%bc(n)%field(ind_flux)%values(i) = 0.0
          endif  !}
        enddo  !} i

      else  !}{

        call mpp_error(FATAL, ' Unknown implementation (' // trim(gas_fluxes%bc(n)%implementation) //    &
             ') for ' // trim(gas_fluxes%bc(n)%name))

      endif  !}

    else  !}{

      call mpp_error(FATAL, ' Unknown flux_type (' // trim(gas_fluxes%bc(n)%flux_type) //    &
           ') for ' // trim(gas_fluxes%bc(n)%name))

    endif  !}
      
  endif  !}

enddo  !} n

if (allocated(kw)) then
  deallocate(kw)
  deallocate(cair)
endif

return
end subroutine  atmos_ocean_fluxes_calc  !}
! </SUBROUTINE> NAME="atmos_ocean_fluxes_calc"

end module  atmos_ocean_fluxes_mod  !}

module get_cal_time_mod

!   <CONTACT EMAIL="fms@gfdl.noaa.gov">
!     fms
!   </CONTACT>
!   <OVERVIEW>
!      Given a time increment as a real number, and base time and calendar
!      as a character strings, returns time as a time_type variable.
!   </OVERVIEW>

use          fms_mod, only: error_mesg, FATAL, write_version_number, lowercase, &
                            open_namelist_file, check_nml_error, stdlog, close_file, &
                            mpp_pe, mpp_root_pe

use time_manager_mod, only: time_type, operator(+), operator(-), set_time, get_time, &
                            NO_CALENDAR, THIRTY_DAY_MONTHS, NOLEAP, JULIAN, GREGORIAN, &
                            set_calendar_type, get_calendar_type, set_date, &
                            get_date, days_in_month, valid_calendar_types
use mpp_mod,          only: input_nml_file

implicit none
private

public :: get_cal_time

logical :: module_is_initialized=.false. ! This module is initialized on
                                         ! the first call to get_cal_time
                                         ! because there is no constructor.
! <NAMELIST NAME="get_cal_time_nml">
! <DATA NAME="allow_calendar_conversion" TYPE="logical"  DEFAULT=".true.">
!   This sets the default value of the optional argument named "permit_calendar_conversion" of get_cal_time.
!   This namelist is deprecated as of the memphis release.
!   If calendar conversion is not desired, then it is recommended that permit_calendar_conversion 
!   be present in the call to get_cal_time and that it be set to .false.
! </DATA>

logical :: allow_calendar_conversion=.true.

namelist / get_cal_time_nml / allow_calendar_conversion
! </NAMELIST>

character(len=128) :: version='$Id$'
character(len=128) :: tagname='$Name$'

contains
!------------------------------------------------------------------------
! <FUNCTION NAME="get_cal_time">
!   <TEMPLATE>
!     get_cal_time(time_increment, units, calendar, permit_calendar_conversion)
!   </TEMPLATE>
!   <IN NAME="time_increment" TYPE="real"> A time interval.</IN>
!   <IN NAME="units" TYPE="character">
!
! Examples of acceptable values of units:
!
! 'days since 1980-01-01 00:00:00',
! 'hours since 1980-1-1 0:0:0',
! 'minutes since 0001-4-12'
!
! The first word in the string must be
! 'years', 'months', 'days', 'hours', 'minutes' or 'seconds'.
! The second word must be 'since'
!
! year number must occupy 4 spaces.
! Number of months, days, hours, minutes, seconds may occupy 1 or 2 spaces
! year, month and day must be separated by a '-'
! hour, minute, second must be separated by a ':'
! hour, minute, second are optional. If not present then zero is assumed.
!
! Because months are not equal increments of time, and, for julian calendar,
! neither are years, the 'years since' and 'month since' cases deserve
! further explaination. 
!
! When 'years since' is used:
! The year number is increased by floor(time_increment)   to obtain a time T1.
! The year number is increased by floor(time_increment)+1 to obtain a time T2.
! The time returned is T1 + (time_increment-floor(time_increment))*(T2-T1).
!
! When 'months since' is used:
! The month number is increased by floor(time_increment). If it falls outside
! to range 1 to 12 then it is adjusted along with the year number to convert
! to a valid date. The number of days in the month of this date is used to
! compute the time interval of the fraction.
! That is:
! The month number is increased by floor(time_increment) to obtain a time T1.
! delt = the number of days in the month in which T1 falls.
! The time returned is T1 + ((time_increment-floor(time_increment))*delt.
! Two of the consequences of this scheme should be kept in mind.
! -- The time since should not be from the 29'th to 31'st of a month,
!    since an invalid date is likely to result, triggering an error stop.
! -- When time since is from the begining of a month, the fraction of a month
!    will never advance into the month after that which results from only
!    the whole number.
!
! When NO_CALENDAR is in effect, units attribute must specify a starting
! day and second, with day number appearing first
!
! Example: 'days since 100 0' Indicates 100 days 0 seconds
! </IN>
!
! <IN NAME="calendar" TYPE="character">
! Acceptable values of calendar are:
! 'noleap'
! '365_day'
! '360_day'
! 'julian'
! 'thirty_day_months'
! 'no_calendar'
! </IN>
!
! <IN NAME="permit_calendar_conversion" TYPE="logical, optional" DEFAULT="allow_calendar_conversion">
! It is sometimes desirable to allow the value of the intent(in) argument
! "calendar" to be different than the calendar in use by time_manager_mod.
! If this is not desirable, then the optional variable "permit_calendar_conversion"
! should be set to .false. so as to allow an error check.
! When calendar conversion is done, the time returned is the time in the
! time_manager's calendar, but corresponds to the date computed using the input calendar.
! For example, suppose the time_manager is using the julian calendar and
! the values of the input arguments of get_cal_time are:
! time_increment = 59.0
! units = 'days since 1980-1-1 00:00:00'
! calendar = 'noleap'
! Because it will use the noleap calendar to calculate the date, get_cal_time will return
! value of time for midnight March 1 1980, but it will be time in the julian calendar
! rather than the noleap calendar. It will never return a value of time corresponding
! to anytime during the day Feb 29.
!
! Another example:
! Suppose the time_manager is using either the noleap or julian calendars,
! and the values of the input arguments are:
! time_increment = 30.0
! units = 'days since 1980-1-1'
! calendar = 'thirty_day_months'
! In this case get_cal_time will return the value of time for Feb 1 1980 00:00:00,
! but in the time_manager's calendar.

! Calendar conversion may result in a fatal error when the input calendar type is
! a calendar that has more days per year than that of the time_manager's calendar.
! For example, if the input calendar type is julian and the time_manager's calendar
! is thirty_day_months, then get_cal_time will try to convert Jan 31 to a time in
! the thirty_day_months calendar, resulting in a fatal error.

! Note: this option was originally coded to allow noleap calendar as input when
! the julian calendar was in effect by the time_manager.
! </IN>
! 
!---------------------------------------------------------------------------------------------

function get_cal_time(time_increment, units, calendar, permit_calendar_conversion)
real, intent(in) :: time_increment
character(len=*), intent(in) :: units
character(len=*), intent(in) :: calendar
logical, intent(in), optional :: permit_calendar_conversion
type(time_type) :: get_cal_time
integer :: year, month, day, hour, minute, second
integer :: i1, i2, i3, i4, i5, i6, increment_seconds, increment_days, increment_years, increment_months
real    :: month_fraction
integer :: calendar_tm_i, calendar_in_i, namelist_unit, ierr, io, logunit
logical :: correct_form
character(len=32) :: calendar_in_c
character(len=64) :: err_msg
character(len=4) :: formt='(i )'
type(time_type) :: base_time, base_time_plus_one_yr, base_time_plus_one_mo
real :: dt
logical :: permit_conversion_local

if(.not.module_is_initialized) then
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, get_cal_time_nml, iostat=io)
    ierr = check_nml_error (io, 'get_cal_time_nml')
#else
  namelist_unit = open_namelist_file()
  ierr=1
  do while (ierr /= 0)
    read(namelist_unit, nml=get_cal_time_nml, iostat=io, end=20)
    ierr = check_nml_error (io, 'get_cal_time_nml')
  enddo
  20 call close_file (namelist_unit)
#endif

  call write_version_number (version, tagname)
  logunit = stdlog()
  if(mpp_pe() == mpp_root_pe()) write (logunit, nml=get_cal_time_nml)
  module_is_initialized = .true.
endif

if(present(permit_calendar_conversion)) then
  permit_conversion_local = permit_calendar_conversion
else
  permit_conversion_local = allow_calendar_conversion
endif

calendar_in_c = lowercase(trim(cut0(calendar)))

correct_form = (trim(calendar_in_c)) == 'noleap'     .or. (trim(calendar_in_c)) == '365_day' .or. &
               (trim(calendar_in_c)) == '360_day'    .or. (trim(calendar_in_c)) == 'julian'  .or. &
               (trim(calendar_in_c)) == 'no_calendar'.or. (trim(calendar_in_c)) == 'thirty_day_months' .or. &
               (trim(calendar_in_c)) == 'gregorian'

if(.not.correct_form) then
  call error_mesg('get_cal_time','"'//trim(calendar_in_c)//'"'// &
   ' is not an acceptable calendar attribute. acceptable calendars are: '// &
   ' noleap, 365_day, 360_day, julian, no_calendar, thirty_day_months, gregorian',FATAL)
endif

calendar_tm_i = get_calendar_type()

if(.not.permit_conversion_local) then
  correct_form = (trim(calendar_in_c) == 'noleap'            .and. calendar_tm_i == NOLEAP)            .or. &
                 (trim(calendar_in_c) == '365_day'           .and. calendar_tm_i == NOLEAP)            .or. &
                 (trim(calendar_in_c) == '360_day'           .and. calendar_tm_i == THIRTY_DAY_MONTHS) .or. &
                 (trim(calendar_in_c) == 'thirty_day_months' .and. calendar_tm_i == THIRTY_DAY_MONTHS) .or. &
                 (trim(calendar_in_c) == 'julian'            .and. calendar_tm_i == JULIAN)            .or. &
                 (trim(calendar_in_c) == 'no_calendar'       .and. calendar_tm_i == NO_CALENDAR)       .or. &
                 (trim(calendar_in_c) == 'gregorian'         .and. calendar_tm_i == GREGORIAN)
  if(.not.correct_form) then
    call error_mesg('get_cal_time','calendar not consistent with calendar type in use by time_manager.'// &
         ' calendar='//trim(calendar_in_c)//'. Type in use by time_manager='//valid_calendar_types(calendar_tm_i),FATAL)
  endif
endif

if (permit_conversion_local) then
    select case (trim(calendar_in_c))
    case ('noleap')
        calendar_in_i = NOLEAP
    case ('365_day')
        calendar_in_i = NOLEAP
    case ('360_day')
        calendar_in_i = THIRTY_DAY_MONTHS
    case ('thirty_day_months')
        calendar_in_i = THIRTY_DAY_MONTHS
    case ('julian')
        calendar_in_i = JULIAN
    case ('no_calendar')
        calendar_in_i = NO_CALENDAR
    case ('gregorian')
        calendar_in_i = GREGORIAN
    case default
        call error_mesg('get_cal_time', &
                 trim(calendar_in_c)//' is an invalid calendar type (specified in call to get_cal_time)',FATAL)
    end select
else
    calendar_in_i = calendar_tm_i
end if

correct_form = lowercase(units(1:10)) == 'days since'    .or. &
               lowercase(units(1:11)) == 'hours since'   .or. &
               lowercase(units(1:13)) == 'minutes since' .or. &
               lowercase(units(1:13)) == 'seconds since'

if(calendar_in_i /= NO_CALENDAR) then
  correct_form = correct_form .or. &
               lowercase(units(1:11)) == 'years since'   .or. &
               lowercase(units(1:12)) == 'months since'
endif

if(.not.correct_form) then
  call error_mesg('get_cal_time',trim(units)//' is an invalid string for units.' // &
        ' units must begin with a time unit then the word "since"' // &
        ' Valid time units are: "seconds" "minutes", "hours", "days", and, ' // &
        ' except when NO_CALENDAR is in effect, "months" and "years"',FATAL)
endif

if(calendar_in_i /= calendar_tm_i) then
! switch to calendar type specified as input argument,
! will switch back before returning.
  call set_calendar_type(calendar_in_i)
endif

! index(string, substring[,back])
! Returns the starting position of substring as a substring of string,
! or zero if it does not occur as a substring. Default value of back is
! .false. If back is .false., the starting position of the first such
! substring is returned. If back is .true., the starting position of the 
! last such substring is returned.
! Returns zero if substring is not a substring of string (regardless of value of back)

i1 = index(units,'since') + 5
if(calendar_in_i == NO_CALENDAR) then
  base_time = set_time(units(i1:len_trim(units)))
else
  base_time = set_date(units(i1:len_trim(units)))
endif

if(lowercase(units(1:10)) == 'days since') then
  increment_days = floor(time_increment)
  increment_seconds = 86400*(time_increment - increment_days) 
else if(lowercase(units(1:11)) == 'hours since') then
  increment_days = floor(time_increment/24)
  increment_seconds = 86400*(time_increment/24 - increment_days)
else if(lowercase(units(1:13)) == 'minutes since') then
  increment_days = floor(time_increment/1440)
  increment_seconds = 86400*(time_increment/1440 - increment_days)
else if(lowercase(units(1:13)) == 'seconds since') then
  increment_days = floor(time_increment/86400)
  increment_seconds = 86400*(time_increment/86400 - increment_days)
else if(lowercase(units(1:11)) == 'years since') then
! The time period between between (base_time + time_increment) and
! (base_time + time_increment + 1 year) may be 360, 365, or 366 days.
! This must be determined to handle time increments with year fractions.
  call get_date(base_time, year,month,day,hour,minute,second)
  base_time             = set_date(year+floor(time_increment)  ,month,day,hour,minute,second)
  base_time_plus_one_yr = set_date(year+floor(time_increment)+1,month,day,hour,minute,second)
  call get_time(base_time_plus_one_yr - base_time, second, day)
  dt = (day*86400+second)*(time_increment-floor(time_increment))
  increment_days = floor(dt/86400)
  increment_seconds = dt - increment_days*86400
else if(lowercase(units(1:12)) == 'months since') then
  month_fraction = time_increment - floor(time_increment)
  increment_years  = floor(time_increment/12)
  increment_months = floor(time_increment) - 12*increment_years
  call get_date(base_time, year,month,day,hour,minute,second)
  base_time = set_date(year+increment_years,month+increment_months  ,day,hour,minute,second)
  dt = 86400*days_in_month(base_time) * month_fraction
  increment_days = floor(dt/86400)
  increment_seconds = dt - increment_days*86400
else
  call error_mesg('get_cal_time','"'//trim(units)//'"'//' is not an acceptable units attribute of time.'// &
    ' It must begin with: "years since", "months since", "days since", "hours since", "minutes since", or "seconds since"',FATAL)
endif

if (calendar_in_i /= calendar_tm_i) then
    if(calendar_in_i == NO_CALENDAR .or. calendar_tm_i == NO_CALENDAR) then
      call error_mesg('get_cal_time','Cannot do calendar conversion because input calendar is '// &
       trim(valid_calendar_types(calendar_in_i))//' and time_manager is using '//trim(valid_calendar_types(calendar_tm_i))// &
       ' Conversion cannot be done if either is NO_CALENDAR',FATAL)
    endif
    call get_date(base_time,year, month, day, hour, minute, second)
    get_cal_time = set_date(year,month,day,hour,minute,second) + set_time(increment_seconds, increment_days)
    call get_date(get_cal_time,year,month,day,hour,minute,second)
    call set_calendar_type(calendar_tm_i)
    get_cal_time = set_date(year,month,day,hour,minute,second, err_msg=err_msg)
    if(err_msg /= '') then
      call error_mesg('get_cal_time','Error in function get_cal_time: '//trim(err_msg)// &
                      ' Note that the time_manager is using the '//trim(valid_calendar_types(calendar_tm_i))//' calendar '// &
                      'while the calendar type passed to function get_cal_time is '//calendar_in_c,FATAL)
    endif
else
    get_cal_time = base_time + set_time(increment_seconds, increment_days)
endif

end function get_cal_time
! </FUNCTION>
!------------------------------------------------------------------------
function cut0(string)
character(len=256) :: cut0
character(len=*), intent(in) :: string
integer :: i

cut0 = string

do i=1,len(string)
  if(ichar(string(i:i)) == 0 ) then
    cut0(i:i) = ' '
  endif
enddo

return
end function cut0
!------------------------------------------------------------------------
end module get_cal_time_mod

#ifndef USE_ESMF_LIB
program main
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Matt Harrison
!</CONTACT>
!
!<CONTACT EMAIL="Dave.Bi@csiro.au"> Dave Bi (for OASIS3 hooks)
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Niki Zadeh (for OASIS3 hooks)
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> V. Balaji
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen Griffies 
!</REVIEWER>
!
!<OVERVIEW>
! Driver for ocean-only simulations and prototype setup for OASIS3 driver.  
!</OVERVIEW>
!
!<DESCRIPTION>
! Driver for the ocean-only simulations. Similar to the FMS coupler, but 
! allows one to run the ocean model without compiling  other models. 
! Much simpler than the full FMS coupler. 
!
! This driver also provides the prototype hooks for using MOM with OASIS3,
! with this code surrounded by the cpp-preprocessor option "ifdef OASIS3".  
! The couping of MOM to OASIS3 has not been tested at GFDL. Rather, 
! CSIRO in Australia uses MOM with OASIS3, with Dave.Bi@csiro.au the primary 
! contact for questions regarding MOM and OASIS3. 
! </DESCRIPTION>
!
! <NAMELIST NAME="ocean_solo_nml">
!
!   <DATA NAME="date_init"  TYPE="integer, dimension(6)"  DEFAULT="0">
!     The date that the current integration starts with. If the restart file
!      ocean_solo.res is present, date_init will be taken from there.
!   </DATA>
!   <DATA NAME="calendar"  TYPE="character(maxlen=17)"  DEFAULT="''">
!     The calendar type used by the current integration. Valid values are consistent 
!     with the time_manager module: 'julian', 'gregorian', 'noleap', or 'thirty_day'. 
!     The value 'no_calendar' can not be used because the time_manager's date 
!     function are used.
!     
!   </DATA>
!   <DATA NAME="months "  TYPE="integer"  DEFAULT="0">
!     The number of months that the current integration will be run for. 
!   </DATA>
!   <DATA NAME="days "  TYPE="integer"  DEFAULT="0">
!     The number of days that the current integration will be run for. 
!   </DATA>
!   <DATA NAME="hours"  TYPE="integer"  DEFAULT="0">
!     The number of hours that the current integration will be run for. 
!   </DATA>
!   <DATA NAME="minutes "  TYPE="integer"  DEFAULT="0">
!     The number of minutes that the current integration will be run for. 
!   </DATA>
!   <DATA NAME="seconds"  TYPE="integer"  DEFAULT="0">
!     The number of seconds that the current integration will be run for. 
!   </DATA>
!   <DATA NAME="dt_cpld"  TYPE="integer"  DEFAULT="0">
!     Time step in seconds for coupling between ocean and atmospheric models: 
!     must be an integral multiple of dt_ocean. This is the "slow" timestep.
!     Note that for an ocean_solo model, the coupling to an "atmosphere" is the coupling 
!     to some data files.  In this case, dt_cpld represents the time which data is updated.
!     For example, if data is "daily", then dt_cpld=86400 should be chosen.  
!     If data is fixed, then dt_cpld of any integer of dt_ocean is fine, with
!     dt_cpld=86400 the default. 
!   </DATA>
!  <DATA NAME="n_mask" TYPE="integer">
!    number of region to be masked out. Its value should be less than MAX_PES.
!  </DATA>
!  <DATA NAME="mask_list(2,MAXPES)" TYPE="integer, dimension(MAX_MASK_REGION,2)">
!    The position of the region to be masked out. mask_list(1,:) is the x-layout position
!    and mask_list(2,:) is y-layout position.  
!  </DATA>
!  <DATA NAME="layout_mask" TYPE="integer, dimension(2)">
!   Processor domain layout for all the component model. layout_mask need to be set when and only 
!   when n_mask is greater than 0 ( some domain region is masked out ). When this namelist is set,
!   it will overload the layout in each component model. The default value is (0,0).
!   Currently we require all the component model has the same layout and same grid size.
!  </DATA>
!  <DATA NAME="restart_interval" TYPE="integer, dimension(6)"  DEFAULT="0">
!     The time interval that write out intermediate restart file. The format is (yr,mo,day,hr,min,sec).
!     When restart_interval is all zero, no intermediate restart file will be written out.
!   </DATA>
!
! </NAMELIST>
!
!   <NOTE>
!     <PRE>
!     1.The actual run length will be the sum of months, 
!       days, hours, minutes, and seconds. A run length of zero
!       is not a valid option. 
!     2.The run length must be an integral multiple of the coupling 
!       timestep dt_cpld. 
!     </PRE>
!   </NOTE>
!
  use constants_mod,            only: constants_init
  use data_override_mod,        only: data_override_init, data_override
  use diag_manager_mod,         only: diag_manager_init, diag_manager_end
  use field_manager_mod,        only: field_manager_init
  use fms_mod,                  only: fms_init, fms_end, open_namelist_file, check_nml_error
  use fms_mod,                  only: close_file, file_exist, uppercase
  use fms_io_mod,               only: fms_io_exit
  use mpp_domains_mod,          only: domain2d, mpp_get_compute_domain
  use mpp_io_mod,               only: mpp_open, MPP_RDONLY, MPP_ASCII, MPP_OVERWR, MPP_APPEND, mpp_close, MPP_SINGLE
  use mpp_mod,                  only: input_nml_file, mpp_error, FATAL, NOTE, mpp_pe, mpp_npes, mpp_set_current_pelist
  use mpp_mod,                  only: stdlog, stdout, mpp_root_pe, mpp_clock_id
  use mpp_mod,                  only: mpp_clock_begin, mpp_clock_end, MPP_CLOCK_SYNC
  use mpp_mod,                  only: MPP_CLOCK_DETAILED, CLOCK_COMPONENT, MAXPES
  use time_interp_external_mod, only: time_interp_external_init
  use time_manager_mod,         only: set_calendar_type, time_type, increment_date
  use time_manager_mod,         only: set_time, set_date, get_time, get_date, month_name
  use time_manager_mod,         only: GREGORIAN, JULIAN, NOLEAP, THIRTY_DAY_MONTHS, NO_CALENDAR
  use time_manager_mod,         only: operator( <= ), operator( < ), operator( >= )
  use time_manager_mod,         only: operator( + ),  operator( - ), operator( / )
  use time_manager_mod,         only: operator( * ), operator( /= ), operator( > )
  use time_manager_mod,         only: date_to_string

  use ocean_model_mod,          only: ocean_model_init , update_ocean_model, ocean_model_end
  use ocean_model_mod,          only: ocean_model_restart, ocean_public_type, ocean_state_type
  use ocean_types_mod,          only: ice_ocean_boundary_type

  implicit none

  type (ocean_public_type)               :: Ocean_sfc          
  type (ocean_state_type),       pointer :: Ocean_state => NULL()
  type(ice_ocean_boundary_type), target  :: Ice_ocean_boundary 

  ! define some time types 
  type(time_type) :: Time_init    ! initial time for experiment
  type(time_type) :: Time_start   ! start time for experiment
  type(time_type) :: Time_end     ! end time for experiment (as determined by dtts)
  type(time_type) :: Run_len      ! length of experiment 
  type(time_type) :: Time        
  type(time_type) :: Time_step_coupled
  type(time_type) :: Time_restart_init
  type(time_type) :: Time_restart
  type(time_type) :: Time_restart_current

  character(len=17) :: calendar = 'julian'

  integer :: dt_cpld  = 86400
  integer :: num_cpld_calls  = 0
  integer :: nc
  integer :: calendar_type=-1

  integer :: date_init(6)=0, date(6)
  integer :: date_restart(6)
  integer :: years=0, months=0, days=0, hours=0, minutes=0, seconds=0

  integer :: isc,iec,jsc,jec
  integer :: unit, io_status, ierr

  integer :: flags=0, override_clock
  integer :: nfields 
  
  character(len=256) :: version = ''
  character(len=256) :: tag = ''

  character(len=9) :: month
  character(len=64):: timestamp

  integer :: n, m 
  integer :: layout_mask(2) = (/0 , 0/)
  integer :: n_mask = 0
  integer :: mask_list(2,MAXPES)
  integer, parameter :: mp = 2*MAXPES
  data ((mask_list(n,m),n=1, 2),m=1,MAXPES) /mp*0/
  integer :: restart_interval(6) = (/0,0,0,0,0,0/)
  integer :: mpi_comm_mom
  integer ::  stdoutunit,stdlogunit
  logical :: external_initialization

  namelist /ocean_solo_nml/ date_init, calendar, months, days, hours, minutes, seconds, dt_cpld, &
                            n_mask, layout_mask, mask_list, restart_interval

  call external_coupler_mpi_init(mpi_comm_mom, external_initialization)

  if ( external_initialization ) then
     call fms_init(mpi_comm_mom)
  else
     call fms_init()
  endif

  call constants_init

  flags = MPP_CLOCK_SYNC

  stdoutunit=stdout();stdlogunit=stdlog()

  ! provide for namelist over-ride
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_solo_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_solo_nml')
#else
  unit = open_namelist_file('input.nml')
  read  (unit, ocean_solo_nml,iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_solo_nml')
  call close_file (unit)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,'(/47x,a/)') '======== MODEL BEING DRIVEN BY OCEAN_SOLO_MOD ========'
  write (stdoutunit, ocean_solo_nml)  
  write (stdlogunit, ocean_solo_nml)

  write (stdlogunit,'(/,80("="),/(a))') trim(version), trim(tag)

  ! set the calendar 

  select case( uppercase(trim(calendar)) )
  case( 'GREGORIAN' )
     calendar_type = GREGORIAN
  case( 'JULIAN' )
     calendar_type = JULIAN
  case( 'NOLEAP' )
     calendar_type = NOLEAP
  case( 'THIRTY_DAY' )
     calendar_type = THIRTY_DAY_MONTHS
  case( 'NO_CALENDAR' )
     calendar_type = NO_CALENDAR
  case default
     call mpp_error(FATAL, &
     'ocean_solo: ocean_solo_nml entry calendar must be one of GREGORIAN|JULIAN|NOLEAP|THIRTY_DAY|NO_CALENDAR.' )
  end select 

  ! get ocean_solo restart : this can override settings from namelist
  if (file_exist('INPUT/ocean_solo.res')) then
      call mpp_open(unit,'INPUT/ocean_solo.res',form=MPP_ASCII,action=MPP_RDONLY)
      read(unit,*) calendar_type 
      read(unit,*) date_init
      read(unit,*) date
      call mpp_close(unit)
  endif

  if (file_exist('INPUT/ocean_solo.intermediate.res')) then
      call mpp_open(unit,'INPUT/ocean_solo.intermediate.res',form=MPP_ASCII,action=MPP_RDONLY)
      read(unit,*) date_restart
      call mpp_close(unit)
  else
      date_restart = date_init
  endif
      
  call set_calendar_type (calendar_type)

!!$ initialize pelists for ocean ensembles set current pelist to ensemble member
!!$ need to call prior to diagnostics_init
!!$ code presently not supported (mjh)
!!$  call ocean_ensemble_init() 
                             
  call field_manager_init(nfields)

  call diag_manager_init()

  call time_interp_external_init()

  if (sum(date_init) <= 0) then
      call mpp_error(FATAL,&
      '==>Error from ocean_solo_mod: date_init must be set either in ocean_solo.res or in ocean_solo_nml')
  else
      Time_init  = set_date(date_init(1),date_init(2), date_init(3), &
           date_init(4),date_init(5),date_init(6))
  endif

  if (file_exist('INPUT/ocean_solo.res')) then
      Time_start =  set_date(date(1),date(2),date(3),date(4),date(5),date(6))
  else
      Time_start = Time_init
      date = date_init
  endif

  Time_end          = increment_date(Time_start, years, months, days, hours, minutes, seconds)
  Run_len           = Time_end - Time_start


  Time_step_coupled = set_time(dt_cpld, 0)
  num_cpld_calls    = Run_len / Time_step_coupled
  Time = Time_start

  Time_restart_init = set_date(date_restart(1), date_restart(2), date_restart(3),  &
                               date_restart(4), date_restart(5), date_restart(6) )
  Time_restart_current = Time_start
  if(ALL(restart_interval ==0)) then
     Time_restart = increment_date(Time_end, 1, 0, 0, 0, 0, 0)   ! no intermediate restart
  else
     Time_restart = increment_date(Time_restart_init, restart_interval(1), restart_interval(2), &
        restart_interval(3), restart_interval(4), restart_interval(5), restart_interval(6) )
     if(Time_restart <= Time_start) call mpp_error(FATAL, &
       '==>Error from program ocean_solo: The first intermediate restart time is no larger than the start time')
  end if

  !-----------------------------------------------------------------------
  !------------------- some error checks ---------------------------------
  if ( num_cpld_calls * Time_step_coupled /= Run_len ) call mpp_error(FATAL, &
     '==>Error from program ocean_solo: run length must be multiple of cpld time step', FATAL)

  call mpp_open (unit, 'time_stamp.out', form=MPP_ASCII, action=MPP_APPEND,threading=MPP_SINGLE)

  month = month_name(date(2))
  if ( mpp_pe() == mpp_root_pe() ) write (unit,'(6i4,2x,a3)') date, month(1:3)

  call get_date (Time_end, date(1), date(2), date(3), date(4), date(5), date(6))
  month = month_name(date(2))
  if ( mpp_pe() == mpp_root_pe() ) write (unit,'(6i4,2x,a3)') date, month(1:3)

  call mpp_close (unit)  

  !----- check the value of layout and setup the maskmap for domain layout.
  if( n_mask > 0 ) then
      if( layout_mask(1)*layout_mask(2) - n_mask .NE. mpp_npes() ) call mpp_error(FATAL, &
      '==>Error from program ocean_solo: layout(1)*layout(2) - n_mask should equal to npes when n_mask>0')
      call mpp_error(NOTE, &
      '==>Error from program ocean_solo: layout_mask and mask_list is set in ocean_solo_nml, ' // &
      'the value of layout_mask will override the layout specified in ocean_model_mod')

      allocate(Ocean_sfc%maskmap(layout_mask(1), layout_mask(2)) )
      Ocean_sfc%maskmap = .TRUE.
      do n=1, n_mask
         if (mask_list(1,n) .gt. layout_mask(1) ) &
              call mpp_error( FATAL, &
              'program ocean_solo: mask_list elements outside layout defines.' )
         if (mask_list(2,n) .gt. layout_mask(2) ) &
              call mpp_error( FATAL, &
              'program ocean_solo: mask_list elements outside layout defines.' )
         Ocean_sfc%maskmap(mask_list(1,n),mask_list(2,n)) = .false.
      enddo
  else
      if( layout_mask(1)*layout_mask(2) .NE. 0 ) call mpp_error(NOTE, &
           'program ocean_solo: when no region is masked out, layout_mask need not be set' )
  end if



  call ocean_model_init(Ocean_sfc, Ocean_state, Time_init, Time)

  call data_override_init(Ocean_domain_in = Ocean_sfc%domain)

  override_clock = mpp_clock_id('Override', flags=flags,grain=CLOCK_COMPONENT)
  
  call mpp_get_compute_domain(Ocean_sfc%domain, isc, iec, jsc, jec)
  
  allocate ( Ice_ocean_boundary% u_flux (isc:iec,jsc:jec),          &
             Ice_ocean_boundary% v_flux (isc:iec,jsc:jec),          &
             Ice_ocean_boundary% t_flux (isc:iec,jsc:jec),          &
             Ice_ocean_boundary% q_flux (isc:iec,jsc:jec),          &
             Ice_ocean_boundary% salt_flux (isc:iec,jsc:jec),       &
             Ice_ocean_boundary% lw_flux (isc:iec,jsc:jec),         &
             Ice_ocean_boundary% sw_flux_vis_dir (isc:iec,jsc:jec), &
             Ice_ocean_boundary% sw_flux_vis_dif (isc:iec,jsc:jec), &
             Ice_ocean_boundary% sw_flux_nir_dir (isc:iec,jsc:jec), &
             Ice_ocean_boundary% sw_flux_nir_dif (isc:iec,jsc:jec), &
             Ice_ocean_boundary% lprec (isc:iec,jsc:jec),           &
             Ice_ocean_boundary% fprec (isc:iec,jsc:jec),           &
             Ice_ocean_boundary% runoff (isc:iec,jsc:jec),          &
             Ice_ocean_boundary% calving (isc:iec,jsc:jec),         &
             Ice_ocean_boundary% p (isc:iec,jsc:jec),               &
             Ice_ocean_boundary% wnd (isc:iec,jsc:jec))

  Ice_ocean_boundary%u_flux          = 0.0
  Ice_ocean_boundary%v_flux          = 0.0
  Ice_ocean_boundary%t_flux          = 0.0
  Ice_ocean_boundary%q_flux          = 0.0
  Ice_ocean_boundary%salt_flux       = 0.0
  Ice_ocean_boundary%lw_flux         = 0.0
  Ice_ocean_boundary%sw_flux_vis_dir = 0.0
  Ice_ocean_boundary%sw_flux_vis_dif = 0.0
  Ice_ocean_boundary%sw_flux_nir_dir = 0.0
  Ice_ocean_boundary%sw_flux_nir_dif = 0.0
  Ice_ocean_boundary%lprec           = 0.0
  Ice_ocean_boundary%fprec           = 0.0
  Ice_ocean_boundary%runoff          = 0.0
  Ice_ocean_boundary%calving         = 0.0
  Ice_ocean_boundary%p               = 0.0
  Ice_ocean_boundary%wnd             = 0.0

  call external_coupler_sbc_init(Ocean_sfc%domain, dt_cpld, Run_len)

  ! loop over the coupled calls 
  do nc=1, num_cpld_calls
     
     call mpp_clock_begin(override_clock)

     call ice_ocn_bnd_from_data(Ice_ocean_boundary)

     call mpp_clock_end(override_clock)

     call external_coupler_sbc_before(Ice_ocean_boundary, Ocean_sfc, nc, dt_cpld )

     
     call update_ocean_model(Ice_ocean_boundary, Ocean_state, Ocean_sfc, Time, Time_step_coupled)

     Time = Time + Time_step_coupled

     if( Time >= Time_restart ) then
       Time_restart_current = Time
       Time_restart = increment_date(Time, restart_interval(1), restart_interval(2), &
             restart_interval(3), restart_interval(4), restart_interval(5), restart_interval(6) )
       timestamp = date_to_string(time_restart_current)
        write(stdoutunit,*) '=> NOTE from program ocean_solo: intermediate restart file is written and ', &
             trim(timestamp),' is appended as prefix to each restart file name'
        call ocean_model_restart(Ocean_state, timestamp)
        call ocean_solo_restart(Time, Time_restart_current, timestamp)
     end if


     call external_coupler_sbc_after(Ice_ocean_boundary, Ocean_sfc, nc, dt_cpld )

  enddo

  ! close some of the main components 

  call ocean_model_end(Ocean_sfc, Ocean_state, Time)

  call diag_manager_end(Time)

  ! need to reset pelist before calling mpp_clock_end
  call mpp_set_current_pelist() 

  ! write restart file
  call ocean_solo_restart(Time_end, Time_restart_current)

  call external_coupler_restart( dt_cpld, num_cpld_calls )

  call fms_io_exit

  call external_coupler_exit

  call fms_end

  call external_coupler_mpi_exit(mpi_comm_mom, external_initialization)

  write(stdoutunit,*) 'MOM: --- completed ---'

  contains

  !--- writing restart file that contains running time and restart file writing time.
  subroutine ocean_solo_restart(Time_run, Time_res, time_stamp)
    type(time_type),   intent(in)           :: Time_run, Time_res
    character(len=*),  intent(in), optional :: time_stamp
    character(len=128)                      :: file_run, file_res
    integer :: yr, mon, day, hr, min, sec

    ! write restart file
    if(present(time_stamp)) then
       file_run = 'RESTART/'//trim(time_stamp)//'.ocean_solo.res'
       file_res = 'RESTART/'//trim(time_stamp)//'.ocean_solo.intermediate.res'
    else
       file_run = 'RESTART/ocean_solo.res'
       file_res = 'RESTART/ocean_solo.intermediate.res'
    endif

    call mpp_open( unit, file_run, nohdrs=.TRUE. )
    if ( mpp_pe().EQ.mpp_root_pe() )then
       write( unit, '(i6,8x,a)' )calendar_type, &
            '(Calendar: no_calendar=0, thirty_day_months=1, julian=2, gregorian=3, noleap=4)'

       call get_date(Time_init,yr,mon,day,hr,min,sec)
       write( unit, '(6i6,8x,a)' )yr,mon,day,hr,min,sec, &
            'Model start time:   year, month, day, hour, minute, second'
       call get_date(Time_run ,yr,mon,day,hr,min,sec)
       write( unit, '(6i6,8x,a)' )yr,mon,day,hr,min,sec, &
            'Current model time: year, month, day, hour, minute, second'
    end if
    call mpp_close(unit)

 if(Time_res > Time_start) then
    call mpp_open( unit, file_res, nohdrs=.TRUE. )
    if ( mpp_pe().EQ.mpp_root_pe() )then
       call get_date(Time_res ,yr,mon,day,hr,min,sec)
       write( unit, '(6i6,8x,a)' )yr,mon,day,hr,min,sec, &
            'Current intermediate restart time: year, month, day, hour, minute, second'
    end if
    call mpp_close(unit)     
 end if

end subroutine ocean_solo_restart

!====================================================================
! get forcing data from data_overide 
  subroutine ice_ocn_bnd_from_data(x)

      type (ice_ocean_boundary_type) :: x
      type(time_type)                :: Time_next

      Time_next = Time + Time_step_coupled
      call data_override('OCN', 't_flux',          x%t_flux         , Time_next)
      call data_override('OCN', 'u_flux',          x%u_flux         , Time_next)
      call data_override('OCN', 'v_flux',          x%v_flux         , Time_next)
      call data_override('OCN', 'q_flux',          x%q_flux         , Time_next)
      call data_override('OCN', 'salt_flux',       x%salt_flux      , Time_next)
      call data_override('OCN', 'lw_flux',         x%lw_flux        , Time_next)
      call data_override('OCN', 'sw_flux_vis_dir', x%sw_flux_vis_dir, Time_next)
      call data_override('OCN', 'sw_flux_vis_dif', x%sw_flux_vis_dif, Time_next)
      call data_override('OCN', 'sw_flux_nir_dir', x%sw_flux_nir_dir, Time_next)
      call data_override('OCN', 'sw_flux_nir_dif', x%sw_flux_nir_dif, Time_next)
      call data_override('OCN', 'lprec',           x%lprec          , Time_next)
      call data_override('OCN', 'fprec',           x%fprec          , Time_next)
      call data_override('OCN', 'runoff',          x%runoff         , Time_next)
      call data_override('OCN', 'calving',         x%calving        , Time_next)
      call data_override('OCN', 'p',               x%p              , Time_next)
      call data_override('OCN', 'wnd',             x%wnd            , Time_next)
            
  end subroutine ice_ocn_bnd_from_data


!-----------------------------------------------------------------------------------------
! 
! Subroutines  for enabling coupling to external programs through a third party coupler
! such as OASIS/PRISM.
! If no external coupler then these will mostly be dummy routines.
! These routines can also serve as spots to call other user defined routines
!-----------------------------------------------------------------------------------------


!-----------------------------------------------------------------------------------------
#ifdef OASIS3

! Here we provide some hooks for calling an interface between the OASIS3 coupler and MOM.
! The mom_oasis3_interface module is NOT general and it is expected that the user will 
! heavily modify it depending on the coupling strategy.
! For clarity all variables should be passed as arguments rather than as globals.
! This may require changes to the argument lists.

  subroutine external_coupler_mpi_init(mom_local_communicator, external_initialization)
! OASIS3/PRISM acts as the master and initializes MPI. Get a local communicator.
! need to initialize prism and get local communicator MPI_COMM_MOM first! 
  use mom_oasis3_interface_mod, only : mom_prism_init
  implicit none
  integer, intent(out) :: mom_local_communicator
  logical, intent(out) :: external_initialization
  mom_local_communicator = -100         ! Is there mpp_undefined parameter corresponding to MPI_UNDEFINED?
                                        ! probably wouldn't need logical flag.
  call mom_prism_init(mom_local_communicator)
  external_initialization = .true.
  end subroutine external_coupler_mpi_init
!-----------------------------------------------------------------------------------------

!-----------------------------------------------------------------------------------------
  subroutine external_coupler_sbc_init(Dom, dt_cpld, Run_len)
! Call to routine initializing arrays etc for transferring via coupler
! Perform sanity checks and make sure all inputs are compatible
  use mom_oasis3_interface_mod, only : coupler_init
  implicit none
  type(domain2d) :: Dom
  integer :: dt_cpld
  type(time_type) :: Run_len
  call coupler_init(Dom, dt_cpld, Run_len=Run_len)
  end  subroutine external_coupler_sbc_init
!-----------------------------------------------------------------------------------------


!-----------------------------------------------------------------------------------------
  subroutine external_coupler_sbc_before(Ice_ocean_boundary, Ocean_sfc, nsteps, dt_cpld )
! Perform transfers before ocean time stepping
! May need special tratment on first call.

  use mom_oasis3_interface_mod, only : from_coupler, into_coupler 

  implicit none
  type (ice_ocean_boundary_type), intent(INOUT) :: Ice_ocean_boundary
  type (ocean_public_type) , intent(INOUT)        :: Ocean_sfc
  integer , intent(IN)                       :: nsteps, dt_cpld
  
  integer                        :: rtimestep ! Receive timestep
  integer                        :: stimestep ! Send timestep

  rtimestep = (nsteps-1) * dt_cpld   ! runtime in this run segment!
  stimestep = rtimestep
  call from_coupler( rtimestep, Ice_ocean_boundary )
  call into_coupler( stimestep, Ocean_sfc, before_ocean_update = .true.)
  end subroutine external_coupler_sbc_before
!-----------------------------------------------------------------------------------------


!-----------------------------------------------------------------------------------------
  subroutine external_coupler_sbc_after(Ice_ocean_boundary, Ocean_sfc, nsteps, dt_cpld )
! Perform transfers after ocean time stepping

  use mom_oasis3_interface_mod, only : into_coupler

  implicit none
  type (ice_ocean_boundary_type) :: Ice_ocean_boundary
  type (ocean_public_type)         :: Ocean_sfc
  integer                        :: nsteps, dt_cpld
  
  integer                        :: stimestep ! Send timestep

  stimestep = nsteps * dt_cpld   ! runtime in this run segment!
  call into_coupler(stimestep, Ocean_sfc, before_ocean_update = .false.)
  end subroutine external_coupler_sbc_after
!-----------------------------------------------------------------------------------------
!-----------------------------------------------------------------------------------------
  subroutine external_coupler_restart( dt_cpld, num_cpld_calls )
! Clean up as appropriate and write a restart
  use mom_oasis3_interface_mod, only : write_coupler_restart
  implicit none
  integer, intent(in)               :: dt_cpld, num_cpld_calls
  integer                           :: timestep
  timestep = num_cpld_calls * dt_cpld
  call write_coupler_restart(timestep, write_restart=.true.)
  end subroutine external_coupler_restart


!-----------------------------------------------------------------------------------------
  subroutine external_coupler_exit
! Clean up as appropriate
! Final call to external program
  use mom_oasis3_interface_mod, only : mom_prism_terminate
  call mom_prism_terminate
  end subroutine external_coupler_exit
!-----------------------------------------------------------------------------------------

!-----------------------------------------------------------------------------------------
  subroutine external_coupler_mpi_exit(mom_local_communicator, external_initialization)
! mpp_exit wont call MPI_FINALIZE if mom_local_communicator /= MPI_COMM_WORLD
  implicit none
  integer, intent(in) :: mom_local_communicator
  logical, intent(in) :: external_initialization
  integer :: ierr
  call MPI_FINALIZE(ierr)
  return
  end subroutine external_coupler_mpi_exit
!-----------------------------------------------------------------------------------------

#else

! Dummy subroutines.

  subroutine external_coupler_mpi_init(mom_local_communicator, external_initialization)
  implicit none
  integer, intent(out) :: mom_local_communicator
  logical, intent(out) :: external_initialization
  external_initialization = .false.
  mom_local_communicator = -100         ! Is there mpp_undefined parameter corresponding to MPI_UNDEFINED?
                                        ! probably wouldn't need logical flag.
  return
  end subroutine external_coupler_mpi_init

!-----------------------------------------------------------------------------------------
  subroutine external_coupler_sbc_init(Dom, dt_cpld, Run_len)
  implicit none
  type(domain2d) :: Dom
  integer :: dt_cpld
  type(time_type) :: Run_len
  return
  end  subroutine external_coupler_sbc_init

  subroutine external_coupler_sbc_before(Ice_ocean_boundary, Ocean_sfc, nsteps, dt_cpld )
  implicit none
  type (ice_ocean_boundary_type), intent(INOUT) :: Ice_ocean_boundary
  type (ocean_public_type) , intent(INOUT)        :: Ocean_sfc
  integer , intent(IN)                       :: nsteps, dt_cpld
  return
  end subroutine external_coupler_sbc_before


  subroutine external_coupler_sbc_after(Ice_ocean_boundary, Ocean_sfc, nsteps, dt_cpld )
  type (ice_ocean_boundary_type) :: Ice_ocean_boundary
  type (ocean_public_type)         :: Ocean_sfc
  integer                        :: nsteps, dt_cpld
  return
  end subroutine external_coupler_sbc_after

  subroutine external_coupler_restart( dt_cpld, num_cpld_calls )
  implicit none
  integer, intent(in)               :: dt_cpld, num_cpld_calls
  return
  end subroutine external_coupler_restart

  subroutine external_coupler_exit
  return
  end subroutine external_coupler_exit

!-----------------------------------------------------------------------------------------
  subroutine external_coupler_mpi_exit(mom_local_communicator, external_initialization)
  implicit none
  integer, intent(in) :: mom_local_communicator
  logical, intent(in) :: external_initialization
  return
  end subroutine external_coupler_mpi_exit
!-----------------------------------------------------------------------------------------
#endif

end program main

#else

#include "ocean_solo_nuopc.inc"

#endif

module cg_drag_mod

use mpp_mod,                only:  input_nml_file
use fms_mod,                only:  fms_init, mpp_pe, mpp_root_pe,  &
                                   file_exist, check_nml_error,  &
                                   error_mesg,  FATAL, WARNING, NOTE, &
                                   close_file, open_namelist_file, &
                                   stdlog, write_version_number, &
                                   read_data, write_data
use fms_io_mod,             only:  register_restart_field, restart_file_type
use fms_io_mod,             only:  save_restart, restore_state, get_mosaic_tile_file
use time_manager_mod,       only:  time_manager_init, time_type
use diag_manager_mod,       only:  diag_manager_init,   &
                                   register_diag_field, send_data
use constants_mod,          only:  constants_init, PI, RDGAS, GRAV, CP_AIR, &
                                   SECONDS_PER_DAY

#ifdef COL_DIAG
use column_diagnostics_mod, only:  column_diagnostics_init, &
                                   initialize_diagnostic_columns, &
                                   column_diagnostics_header, &
                                   close_column_diagnostics_units
#endif

!-------------------------------------------------------------------

implicit none
private

!---------------------------------------------------------------------
!    cg_drag_mod computes the convective gravity wave forcing on 
!    the zonal flow. the parameterization is described in Alexander and 
!    Dunkerton [JAS, 15 December 1999]. 
!--------------------------------------------------------------------
  

!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------


character(len=128)  :: version =  '$Id: cg_drag.F90,v 20.0 2013/12/13 23:09:00 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'



!---------------------------------------------------------------------
!-------  interfaces --------

public    cg_drag_init, cg_drag_calc, cg_drag_end, cg_drag_restart, &
          cg_drag_time_vary, cg_drag_endts


private   read_nc_restart_file, gwfc

!--- for netcdf restart
type(restart_file_type), pointer, save :: Cg_restart => NULL()
type(restart_file_type), pointer, save :: Til_restart => NULL()
logical                                :: in_different_file = .false.
integer                                :: vers, old_time_step

!wfc++ Addition for regular use
      integer, allocatable, dimension(:,:)     ::  source_level

      real,     allocatable, dimension(:,:)     ::  source_amp
      real,     allocatable, dimension(:,:,:)   ::  gwd_u, gwd_v
!wfc--


!--------------------------------------------------------------------
!---- namelist -----

integer     :: cg_drag_freq=0     ! calculation frequency [ s ]
integer     :: cg_drag_offset=0   ! offset of calculation from 00Z [ s ]
                                  ! only has use if restarts are written
                                  ! at 00Z and calculations are not done
                                  ! every time step

real        :: source_level_pressure= 315.e+02    
                                  ! highest model level with  pressure 
                                  ! greater than this value (or sigma
                                  ! greater than this value normalized
                                  ! by 1013.25 hPa) will be the gravity
                                  ! wave source level at the equator 
                                  ! [ Pa ]
integer     :: nk=1               ! number of wavelengths contained in 
                                  ! the gravity wave spectrum
real        :: cmax=99.6          ! maximum phase speed in gravity wave
                                  ! spectrum [ m/s ]
real        :: dc=1.2             ! gravity wave spectral resolution 
                                  ! [ m/s ]
                                  ! previous values: 0.6
real        :: Bt_0=.003          ! sum across the wave spectrum of 
                                  ! the magnitude of momentum flux, 
                                  ! divided by density [ m^2/s^2 ]
            
real        :: Bt_aug=.000        ! magnitude of momentum flux divided by density 

real        :: Bt_nh=.003         ! magnitude of momentum flux divided by density   (SH limit )

real        :: Bt_sh=.003         ! magnitude of momentum flux divided by density  (SH limit )

real        :: Bt_eq=.000         ! magnitude of momentum flux divided by density  (equator) 

real        :: Bt_eq_width=4.0    ! scaling for width of equtorial momentum flux  (equator) 

real        :: phi0n = 30., phi0s = -30., dphin = 5., dphis = -5.

logical     :: calculate_ked=.false. 
                                  ! calculate ked diagnostic ?
integer     :: num_diag_pts_ij=0  ! number of diagnostic columns specif-
                                  ! ied by global (i,j) coordinates
integer     :: num_diag_pts_latlon=0 
                                  ! number of diagnostic columns
                                  ! specified by lat-lon coordinates
integer, parameter           ::  MAX_PTS= 20
                                  ! maximum number of diagnostic columns
integer, dimension(MAX_PTS)  ::  i_coords_gl=-100     
                                  ! global i coordinates for ij 
                                  ! diagnostic columns 
integer, dimension(MAX_PTS)  ::  j_coords_gl=-100   
                                  ! global j coordinates for ij 
                                  ! diagnostic columns 
real,    dimension(MAX_PTS)  ::  lat_coords_gl=-999. 
                                  ! latitudes for latlon diagnostic 
                                  ! columns  [degrees, -90. -> 90. ]
real,    dimension(MAX_PTS)  ::  lon_coords_gl=-999. 
                                  ! longitudes for latlon diagnostic 
                                  ! columns [ degrees, 0. -> 360. ]


namelist / cg_drag_nml /         &
                          cg_drag_freq, cg_drag_offset, &
                          source_level_pressure,   &
                          nk, cmax, dc, Bt_0, Bt_aug,  &
                          Bt_sh, Bt_nh, Bt_eq,  Bt_eq_width,  &
                          calculate_ked,    &
                          num_diag_pts_ij, num_diag_pts_latlon, &
                          i_coords_gl, j_coords_gl,   &
                          lat_coords_gl, lon_coords_gl, &
                          phi0n,phi0s,dphin,dphis

!--------------------------------------------------------------------
!-------- public data  -----


!--------------------------------------------------------------------
!------ private data ------

!--------------------------------------------------------------------
!   list of restart versions readable by this module.
!--------------------------------------------------------------------
integer, dimension(3)  :: restart_versions = (/ 1, 2, 3 /)
! v1 :
! v2 : 
! v3 : Now use NetCDF for restart file.
!
!--------------------------------------------------------------------
!   these arrays must be preserved across timesteps in case the
!   parameterization is not called every timestep:
!
!   gwd      time tendency for u eqn due to gravity wave forcing 
!            [ m/s^2 ]
!   ked      effective eddy diffusion coefficient resulting from 
!            gravity wave forcing [ m^2/s ]
!
!--------------------------------------------------------------------
!wfc++ not needed if calcucate_ked is removed.
!!!!rjw real,    dimension(:,:,:), allocatable   :: gwd, ked
!wfc--
!--------------------------------------------------------------------
!   these are the arrays which define the gravity wave source spectrum:
!
!   c0       gravity wave phase speeds [ m/s ]
!   kwv      horizontal wavenumbers of gravity waves  [  /m ]
!   k2       squares of wavenumbers [ /(m^2) ]
!
!-------------------------------------------------------------------
real,    dimension(:),     allocatable   :: c0, kwv, k2


!---------------------------------------------------------------------
!   wave spectrum parameters.
!---------------------------------------------------------------------
integer    :: nc        ! number of wave speeds in spectrum
                        ! (symmetric around c = 0)
integer    :: flag = 1  ! flag = 1  for peak flux at  c    = 0
                        ! flag = 0  for peak flux at (c-u) = 0
real       :: Bw = 0.4  ! amplitude for the wide spectrum [ m^2/s^2 ]  
                        ! ~ u'w'
real       :: Bn = 0.0  ! amplitude for the narrow spectrum [ m^2/s^2 ] 
                        ! ~ u'w';  previous values: 5.4
real       :: cw = 40.0 ! half-width for the wide c spectrum [ m/s ]
                        ! previous values: 50.0, 25.0 
real       :: cn =  2.0 ! half-width for the narrow c spectrum  [ m/s ]
integer    :: klevel_of_source
                        ! k index of the gravity wave source level at
                        ! the equator in a standard atmosphere

!---------------------------------------------------------------------
!   variables which control module calculations:
!   
!   cgdrag_alarm time remaining until next cg_drag calculation  [ s ]
!
!---------------------------------------------------------------------
integer          :: cgdrag_alarm

!---------------------------------------------------------------------
!   variables used with column diagnostics:
!
!   diag_units     output unit numbers
!   num_diag_pts   number of columns where diagnostics are desired 
!   column_diagnostics_desired
!                  column diagnostics are desired ?
!   do_column_diagnostics 
!                  a diagnostic column is in this jrow ?  
!   diag_lon       longitude of diagnostic columns [ degrees ]
!   diag_lat       latiude of diagnostic columns  [ degrees ]
!   diag_i         processor-based i index of diagnostic columns
!   diag_j         processor-based j index of diagnostic columns
!
!--------------------------------------------------------------------
integer                            :: num_diag_pts = 0  
logical                            :: column_diagnostics_desired=.false.
integer, dimension(:), allocatable :: diag_units         
logical, dimension(:), allocatable :: do_column_diagnostics
real,    dimension(:), allocatable :: diag_lon, diag_lat
integer, dimension(:), allocatable :: diag_j, diag_i   

!---------------------------------------------------------------------
!   variables for netcdf diagnostic fields.
!---------------------------------------------------------------------
integer          :: id_kedx_cgwd, id_kedy_cgwd, id_bf_cgwd, &
                    id_gwfx_cgwd, id_gwfy_cgwd
real             :: missing_value = -999.
character(len=7) :: mod_name = 'cg_drag'


logical          :: module_is_initialized=.false.

!-------------------------------------------------------------------
!-------------------------------------------------------------------



                        contains

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                      PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!####################################################################

subroutine cg_drag_init (lonb, latb, pref, Time, axes)

!-------------------------------------------------------------------
!   cg_drag_init is the constructor for cg_drag_mod.
!-------------------------------------------------------------------

!-------------------------------------------------------------------
real,    dimension(:,:), intent(in)      :: lonb, latb
real,    dimension(:),   intent(in)      :: pref
integer, dimension(4),   intent(in)      :: axes
type(time_type),         intent(in)      :: Time
!-------------------------------------------------------------------

!-------------------------------------------------------------------
!   intent(in) variables:
!
!       lonb      2d array of model longitudes on cell corners [radians]
!       latb      2d array of model latitudes at cell corners [radians]
!       pref      array of reference pressures at full levels (plus
!                 surface value at nlev+1), based on 1013.25hPa pstar
!                 [ Pa ]
!       Time      current time (time_type)
!       axes      data axes for diagnostics
!
!------------------------------------------------------------------

!-------------------------------------------------------------------
!   local variables: 

      integer                 :: unit, ierr, io, logunit
      integer                 :: n, i, j, k
      integer                 :: idf, jdf, kmax
      real                    :: pif = 3.14159265358979/180.
!      real                    :: pif = PI/180.

!      real, allocatable       :: lat(:,:)
      real                    :: lat(size(lonb,1) - 1, size(latb,2) - 1)
!-------------------------------------------------------------------
!   local variables: 
!   
!       unit           unit number for nml file 
!       ierr           error return flag 
!       io             error return code 
!       n              loop index
!       k              loop index
!       idf            number of i points on this processor
!       jdf            number of j points on this processor
!       kmax           number of k points on this processor
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if routine has already been executed, return.
!---------------------------------------------------------------------
      if (module_is_initialized) return

!---------------------------------------------------------------------
!    verify that all modules used by this module have been initialized.
!---------------------------------------------------------------------
      call fms_init
      call time_manager_init
      call diag_manager_init
      call constants_init
#ifdef COL_DIAG
      call column_diagnostics_init 
#endif SKIP
!---------------------------------------------------------------------
!    read namelist.
!---------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=cg_drag_nml, iostat=io)
      ierr = check_nml_error(io,"cg_drag_nml")
#else
      if (file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read (unit, nml=cg_drag_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'cg_drag_nml')
        enddo
10      call close_file (unit)
      endif
#endif

!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe()) write (logunit, nml=cg_drag_nml)

!-------------------------------------------------------------------
!  define the grid dimensions. idf and jdf are the (i,j) dimensions of 
!  domain on this processor, kmax is the number of model layers.
!-------------------------------------------------------------------
      kmax = size(pref(:)) - 1
      jdf  = size(latb,2) - 1
      idf  = size(lonb,1) - 1

      allocate(  source_level(idf,jdf)  )
      allocate(  source_amp(idf,jdf)  )
!      allocate(  lat(idf,jdf)  )

!--------------------------------------------------------------------
!    define the k level which will serve as source level for the grav-
!    ity waves. it is that model level just below the pressure specif-
!    ied as the source location via namelist input.
!--------------------------------------------------------------------
      do k=1,kmax
        if (pref(k) > source_level_pressure) then
          klevel_of_source = k
          exit
        endif
      end do

      do j=1,jdf
        do i=1,idf
          lat(i,j)=  0.5*( latb(i,j+1)+latb(i,j) )
          source_level(i,j) = (kmax + 1) - ((kmax + 1 -    &
                              klevel_of_source)*cos(lat(i,j)) + 0.5)
          source_amp(i,j) = Bt_0 +                         &
                      Bt_nh*0.5*(1.+tanh((lat(i,j)/pif-phi0n)/dphin)) + &
                      Bt_sh*0.5*(1.+tanh((lat(i,j)/pif-phi0s)/dphis))
        end do
      end do
      source_level = MIN (source_level, kmax-1)

!      deallocate( lat )

!---------------------------------------------------------------------
!    determine if column diagnostics are desired from this module. if
!    so, set a flag to so indicate.
!---------------------------------------------------------------------
      num_diag_pts = num_diag_pts_ij + num_diag_pts_latlon
      if (num_diag_pts > 0) then
        column_diagnostics_desired = .true.
      endif

!---------------------------------------------------------------------
!    if column diagnostics are desired, check that array dimensions are
!    sufficiently large for the number of requests. 
!---------------------------------------------------------------------
#ifdef COL_DIAG
      if (column_diagnostics_desired) then
        if (num_diag_pts > MAX_PTS) then
          call error_mesg ( 'cg_drag_mod', &
         ' must reset MAX_PTS or reduce number of diagnostic points', &
                                                     FATAL)
        endif

!---------------------------------------------------------------------
!    allocate arrays needed for column diagnostics. 
!---------------------------------------------------------------------
        allocate (do_column_diagnostics   (jdf)          )
        allocate (diag_units              (num_diag_pts) )
        allocate (diag_lon                (num_diag_pts) )
        allocate (diag_lat                (num_diag_pts) )
        allocate (diag_i                  (num_diag_pts) )
        allocate (diag_j                  (num_diag_pts) )

!---------------------------------------------------------------------
!    call initialize_diagnostic_columns to determine the locations 
!    (i, j, lat and lon) of any diagnostic columns in this processsor's 
!    space and to open output files for the diagnostics.
!---------------------------------------------------------------------
        call initialize_diagnostic_columns    &
                     (mod_name, num_diag_pts_latlon, num_diag_pts_ij, &
                      i_coords_gl, j_coords_gl, lat_coords_gl,   &
                      lon_coords_gl, lonb(:,1), latb(1,:), do_column_diagnostics, &
                      diag_lon, diag_lat, diag_i, diag_j, diag_units)
      endif
#endif

!---------------------------------------------------------------------
!    define the number of waves in the gravity wave spectrum, and define
!    an array of their speeds. They are defined symmetrically around
!    c = 0.0 m/s.
!---------------------------------------------------------------------
      nc = 2.0*cmax/dc + 1
      allocate ( c0(nc) )
      do n=1,nc
        c0(n) = (n-1)*dc - cmax
      end do
 
!--------------------------------------------------------------------
!    define the wavenumber kwv and its square k2 for the gravity waves 
!    contained in the spectrum. currently nk = 1, which means that the 
!    wavelength of all gravity waves considered is 300 km. 
!--------------------------------------------------------------------
      allocate ( kwv(nk) )
      allocate ( k2 (nk) )
      do n=1,nk
        kwv(n) = 2.*PI/((30.*(10.**n))*1.e3)
        k2(n) = kwv(n)*kwv(n)
      end do

!--------------------------------------------------------------------
!    initialize netcdf diagnostic fields.
!-------------------------------------------------------------------
      id_bf_cgwd =  &
         register_diag_field (mod_name, 'bf_cgwd', axes(1:3), Time, &
              'buoyancy frequency from cg_drag', ' /s',   &
              missing_value=missing_value)
      id_gwfx_cgwd =  &
         register_diag_field (mod_name, 'gwfx_cgwd', axes(1:3), Time, &
              'gravity wave forcing on mean flow', &
              'm/s^2',  missing_value=missing_value)
      id_gwfy_cgwd =  &
         register_diag_field (mod_name, 'gwfy_cgwd', axes(1:3), Time, &
              'gravity wave forcing on mean flow', &
              'm/s^2',  missing_value=missing_value)
      id_kedx_cgwd =  &
         register_diag_field (mod_name, 'kedx_cgwd', axes(1:3), Time, &
               'effective eddy viscosity from cg_drag', 'm^2/s',   &
               missing_value=missing_value)
      id_kedy_cgwd =  &
         register_diag_field (mod_name, 'kedy_cgwd', axes(1:3), Time, &
               'effective eddy viscosity from cg_drag', 'm^2/s',   &
               missing_value=missing_value)

!--------------------------------------------------------------------
!    allocate and define module variables to hold values across 
!    timesteps, in the event that cg_drag is not called on every step.
!--------------------------------------------------------------------
     allocate ( gwd_u(idf,jdf,kmax) )
     allocate ( gwd_v(idf,jdf,kmax) )

!--------------------------------------------------------------------
!    if present, read the restart data file.
!---------------------------------------------------------------------
      if (size(restart_versions(:)) .gt. 2 ) then
        call cg_drag_register_restart
      endif

      if (file_exist('INPUT/cg_drag.res.nc')) then
        call read_nc_restart_file

      elseif (file_exist('INPUT/cg_drag.res')) then
        call error_mesg ( 'cg_drag_mod', 'Native restart capability has been removed.', &
                                         FATAL)
!-------------------------------------------------------------------
!    if no restart file is present, initialize the gwd field to zero.
!    define the time remaining until the next cg_drag calculation from
!    the namelist inputs.
!-------------------------------------------------------------------
      else
        gwd_u(:,:,:) = 0.0
        gwd_v(:,:,:) = 0.0
        if (cg_drag_offset > 0) then
          cgdrag_alarm = cg_drag_offset
        else 
          cgdrag_alarm = cg_drag_freq
        endif
      endif
      vers = restart_versions(size(restart_versions(:)))
      old_time_step = cgdrag_alarm 
!---------------------------------------------------------------------
!    mark the module as initialized.
!---------------------------------------------------------------------
      module_is_initialized = .true.

!---------------------------------------------------------------------



end subroutine cg_drag_init


!####################################################################
 
subroutine cg_drag_time_vary (delt)

real           ,        intent(in)      :: delt

!---------------------------------------------------------------------
!    decrement the time remaining until the next cg_drag calculation.
!---------------------------------------------------------------------
      cgdrag_alarm = cgdrag_alarm - delt

!---------------------------------------------------------------------
 
end subroutine cg_drag_time_vary


!####################################################################
 
subroutine cg_drag_endts
 
!--------------------------------------------------------------------
!    if this was a calculation step, reset cgdrag_alarm to indicate 
!    the time remaining before the next calculation of gravity wave 
!    forcing.
!--------------------------------------------------------------------
      if (cgdrag_alarm <= 0 ) then
        cgdrag_alarm = cgdrag_alarm + cg_drag_freq
      endif

end subroutine cg_drag_endts


!####################################################################

subroutine cg_drag_calc (is, js, lat, pfull, zfull, temp, uuu, vvv,  &
                         Time, delt, gwfcng_x, gwfcng_y)
!--------------------------------------------------------------------  
!    cg_drag_calc defines the arrays needed to calculate the convective
!    gravity wave forcing, calls gwfc to calculate the forcing, returns 
!    the desired output fields, and saves the values for later retrieval
!    if they are not calculated on every timestep.
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
integer,                intent(in)      :: is, js
real, dimension(:,:),   intent(in)      :: lat
real, dimension(:,:,:), intent(in)      :: pfull, zfull, temp, uuu, vvv
type(time_type),        intent(in)      :: Time
real           ,        intent(in)      :: delt
real, dimension(:,:,:), intent(out)     :: gwfcng_x, gwfcng_y

!-------------------------------------------------------------------
!    intent(in) variables:
!
!       is,js    starting subdomain i,j indices of data in 
!                the physics_window being integrated
!       lat      array of model latitudes at cell boundaries [radians]
!       pfull    pressure at model full levels [ Pa ]
!       zfull    height at model full levels [ m ]
!       temp     temperature at model levels [ deg K ]
!       uuu      zonal wind  [ m/s ]
!       vvv      meridional wind  [ m/s ]
!       Time     current time, needed for diagnostics [ time_type ]
!       delt     physics time step [ s ]
!
!    intent(out) variables:
!
!       gwfcng_x time tendency for u eqn due to gravity-wave forcing
!                [ m/s^2 ]
!       gwfcng_y time tendency for v eqn due to gravity-wave forcing
!                [ m/s^2 ]
!
!-------------------------------------------------------------------

!-------------------------------------------------------------------
!    local variables:

      real,    dimension (size(uuu,1), size(uuu,2), size(uuu,3))  ::  &
                                         dtdz, ked_gwfc_x, ked_gwfc_y

      real,    dimension (size(uuu,1),size(uuu,2), 0:size(uuu,3)) ::  &
                                         zzchm, zu, zv, zden, zbf,    &
                                         gwd_xtnd, ked_xtnd, &
                                         gwd_ytnd, ked_ytnd

      integer           :: iz0
      logical           :: used
      real              :: bflim = 2.5E-5
      integer           :: ie, je
      integer           :: imax, jmax, kmax
      integer           :: i, j, k

!-------------------------------------------------------------------
!    local variables:
!
!       dtdz          temperature lapse rate [ deg K/m ]
!       ked_gwfc      effective diffusion coefficient from cg_drag_mod 
!                     [ m^2/s ]
!       zzchm         heights at model levels [ m ]
!       zu            zonal velocity [ m/s ]
!       zden          atmospheric density [ kg/m^3 ]
!       zbf           buoyancy frequency [ /s ]
!       gwd_xtnd      zonal wind tendency resulting from cg_drag_mod 
!                     [ m/s^2 ]
!       ked_xtnd      effective diffusion coefficient from cg_drag_mod 
!                     [ m^2/s ]
!       source_level  k index of gravity wave source level ((i,j) array)
!       iz0           k index of gravity wave source level in a column
!       used          return code for netcdf diagnostics
!       bflim         minimum allowable value of squared buoyancy 
!                     frequency [ /s^2 ]
!       ie, je        ending subdomain indices of data in the current 
!                     physics window being integrated
!       imax, jmax, kmax 
!                     physics window dimensions
!       i, j, k, nn   do loop indices
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    define processor extents and loop limits.
!---------------------------------------------------------------------
      imax = size(uuu,1)
      jmax = size(uuu,2)
      kmax = size(uuu,3)
      ie = is + imax - 1
      je = js + jmax - 1

!---------------------------------------------------------------------
!    if the convective gravity wave forcing should be calculated on 
!    this timestep (i.e., the alarm has gone off), proceed with the
!    calculation.
!---------------------------------------------------------------------


      if (cgdrag_alarm <= 0) then

!-----------------------------------------------------------------------
!    calculate temperature lapse rate. do one-sided differences over 
!    delta z at upper boundary and centered differences over 2 delta z 
!    in the interior.  dtdz is not needed at the lower boundary, since
!    the source level is constrained to be above level kmax.
!----------------------------------------------------------------------
        do j=1,jmax
          do i=1,imax
! The following index-offsets are needed in case a physics_window is being used.
            iz0 = source_level(i +is-1,j+js-1)
            dtdz(i,j,1) = (temp  (i,j,1) - temp  (i,j,2))/    &
                          (zfull(i,j,1) - zfull(i,j,2))
            do k=2,iz0
              dtdz(i,j,k) = (temp  (i,j,k-1) - temp  (i,j,k+1))/   &
                            (zfull(i,j,k-1) - zfull(i,j,k+1))
            end do

!--------------------------------------------------------------------
!    calculate air density.
!--------------------------------------------------------------------
            do k=1,iz0+1
              zden(i,j,k  ) = pfull(i,j,k)/(temp(i,j,k)*RDGAS)
            end do

!----------------------------------------------------------------------
!    calculate buoyancy frequency. restrict the squared buoyancy 
!    frequency to be no smaller than bflim.
!----------------------------------------------------------------------
            do k=1,iz0 
              zbf(i,j,k) = (GRAV/temp(i,j,k))*(dtdz(i,j,k) + GRAV/CP_AIR)
              if (zbf(i,j,k) < bflim) then
                zbf(i,j,k) = sqrt(bflim)
              else 
                zbf(i,j,k) = sqrt(zbf(i,j,k))
              endif
            end do

!----------------------------------------------------------------------
!    if zbf is to be saved for netcdf output, the remaining vertical
!    levels must be initialized.
!----------------------------------------------------------------------
            if (id_bf_cgwd > 0) then
              zbf(i,j,iz0+1:) = 0.0
            endif

!----------------------------------------------------------------------
!    define an array of heights at model levels and an array containing
!    the zonal wind component.
!----------------------------------------------------------------------
            do k=1,iz0+1
              zzchm(i,j,k) = zfull(i,j,k)
            end do
            do k=1,iz0   
              zu(i,j,k) = uuu(i,j,k)
              zv(i,j,k) = vvv(i,j,k)
            end do

!----------------------------------------------------------------------
!    add an extra level above model top so that the gravity wave forcing
!    occurring between the topmost model level and the upper boundary
!    may be calculated. define variable values at the new top level as
!    follows: z - use delta z of layer just below; u - extend vertical 
!    gradient occurring just below; density - geometric mean; buoyancy 
!    frequency - constant across model top.
!----------------------------------------------------------------------
            zzchm(i,j,0) = zzchm(i,j,1) + zzchm(i,j,1) - zzchm(i,j,2)
            zu(i,j,0)    = 2.*zu(i,j,1) - zu(i,j,2)
            zv(i,j,0)    = 2.*zv(i,j,1) - zv(i,j,2)
            zden(i,j,0)  = zden(i,j,1)*zden(i,j,1)/zden(i,j,2)
            zbf(i,j,0)   = zbf(i,j,1)
          end do
        end do
      
!---------------------------------------------------------------------
!    pass the vertically-extended input arrays to gwfc. gwfc will cal-
!    culate the gravity-wave forcing and, if desired, an effective eddy 
!    diffusion coefficient at each level above the source level. output
!    is returned in the vertically-extended arrays gwfcng and ked_gwfc.
!    upon return move the output fields into model-sized arrays. 
!---------------------------------------------------------------------
       call gwfc (is, ie, js, je, source_level, source_amp,    &
                     zden, zu, zbf,zzchm, gwd_xtnd, ked_xtnd)

         gwfcng_x  (:,:,1:kmax) = gwd_xtnd(:,:,1:kmax  )
          ked_gwfc_x(:,:,1:kmax) = ked_xtnd(:,:,1:kmax  )

       call gwfc (is, ie, js, je, source_level, source_amp,    &
                     zden, zv, zbf,zzchm, gwd_ytnd, ked_ytnd)
          gwfcng_y  (:,:,1:kmax) = gwd_ytnd(:,:,1:kmax  )
          ked_gwfc_y(:,:,1:kmax) = ked_ytnd(:,:,1:kmax  )

!--------------------------------------------------------------------
!    store the gravity wave forcing into a processor-global array.
!-------------------------------------------------------------------
          gwd_u(is:ie,js:je,:) = gwfcng_x(:,:,:)
          gwd_v(is:ie,js:je,:) = gwfcng_y(:,:,:)


#ifdef COL_DIAG
!--------------------------------------------------------------------
!  if column diagnostics are desired, determine if any columns are on
!  this processor. if so, call column_diagnostics_header to write
!  out location and timestamp information. then output desired 
!  quantities to the diag_unit file.
!---------------------------------------------------------------------
        if (column_diagnostics_desired) then
          do j=1,jmax
            if (do_column_diagnostics(j+js-1)) then
              do nn=1,num_diag_pts
                if (js + j - 1 == diag_j(nn)) then
                  call column_diagnostics_header   &
                       (mod_name, diag_units(nn), Time, nn, diag_lon, &
                        diag_lat, diag_i, diag_j) 
                  iz0 = source_level (diag_i(nn), j)
                  write (diag_units(nn),'(a, i5)')    &
                                              '  source_level  =', iz0
                  write (diag_units(nn),'(a)')     &
                         '   k         u           z        density&
                         &         bf      gwforcing'
                  do k=0,iz0 
                    write (diag_units(nn), '(i5, 2x, 5e12.5)')   &
                                       k,                         &
                                       zu       (diag_i(nn),j,k), &
                                       zzchm    (diag_i(nn),j,k), &
                                       zden     (diag_i(nn),j,k), &
                                       zbf      (diag_i(nn),j,k), &
                                       gwd_xtnd (diag_i(nn),j,k) 
                  end do
                  write (diag_units(nn), '(i5, 14x, 2e12.5)')     &
                                       iz0+1,                       &
                                       zzchm  (diag_i(nn),j,iz0+1), &
                                       zden   (diag_i(nn),j,iz0+1)
                endif
              end do  ! (nn loop)
            endif    ! (do_column_diagnostics)
          end do   ! (j loop)
        endif    ! (column_diagnostics_desired)
#endif


!--------------------------------------------------------------------
!    if activated, store the effective eddy diffusivity into a 
!    processor-global array, and if desired as a netcdf diagnostic, 
!    send the data to diag_manager_mod.
!-------------------------------------------------------------------

          if (id_kedx_cgwd > 0) then
            used = send_data (id_kedx_cgwd, ked_gwfc_x, Time, is, js, 1)
          endif

          if (id_kedy_cgwd > 0) then
            used = send_data (id_kedy_cgwd, ked_gwfc_y, Time, is, js, 1)
          endif



!--------------------------------------------------------------------
!    save any other netcdf file diagnostics that are desired.
!--------------------------------------------------------------------
        if (id_bf_cgwd > 0) then
          used = send_data (id_bf_cgwd,  zbf(:,:,1:), Time, is, js )
        endif

        if (id_gwfx_cgwd > 0) then
          used = send_data (id_gwfx_cgwd, gwfcng_x, Time, is, js, 1)
        endif
        if (id_gwfy_cgwd > 0) then
          used = send_data (id_gwfy_cgwd, gwfcng_y, Time, is, js, 1)
        endif



!--------------------------------------------------------------------
!    if this is not a timestep on which gravity wave forcing is to be 
!    calculated, retrieve the values calculated previously from storage
!    and return to the calling subroutine.
!--------------------------------------------------------------------
      else   ! (cgdrag_alarm <= 0)
        gwfcng_x(:,:,:) = gwd_u(is:ie,js:je,:)
        gwfcng_y(:,:,:) = gwd_v(is:ie,js:je,:)
     endif  ! (cgdrag_alarm <= 0)

!--------------------------------------------------------------------



end subroutine cg_drag_calc



!###################################################################

subroutine cg_drag_end

!--------------------------------------------------------------------
!    cg_drag_end is the destructor for cg_drag_mod.
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!    local variables

!For version 3 and after, use NetCDF restarts.
      if (mpp_pe() == mpp_root_pe() ) &
            call error_mesg ('cg_drag_mod', 'write_restart_nc: &
              &Writing netCDF formatted restart file as &
                &requested. ', NOTE)
      call cg_drag_restart


#ifdef COL_DIAG
      if (column_diagnostics_desired) then
        call close_column_diagnostics_units (diag_units)
      endif
#endif

!---------------------------------------------------------------------
!    mark the module as uninitialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.

!---------------------------------------------------------------------


end subroutine cg_drag_end



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PRIVATE SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


subroutine read_nc_restart_file
!-----------------------------------------------------------------------
!    subroutine read_restart_nc reads a netcdf restart file to obtain 
!    the variables needed upon experiment restart. 
!-----------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      character(len=64)     :: fname='INPUT/cg_drag.res.nc'
      character(len=8)      :: chvers

!---------------------------------------------------------------------
!   local variables:
!
!        fname            restart file name
!
!----------------------------------------------------------------------

!--------------------------------------------------------------------
!    output a message indicating entrance into this routine.
!--------------------------------------------------------------------
      if (mpp_pe() == mpp_root_pe() ) then
        call error_mesg ('cg_drag_mod',  'read_restart_nc:&
             &Reading netCDF formatted restart file:'//trim(fname), NOTE)
      endif

!-------------------------------------------------------------------
!    read the values of gwd_u and gwd_v
!-------------------------------------------------------------------
      if (size(restart_versions(:)) .le. 2 ) then
         call error_mesg ('cg_drag_mod',  'read_restart_nc: restart file format is netcdf, ' // &
              'restart_versions is not netcdf file version', FATAL)
      endif
      call restore_state(Cg_restart)
      if(in_different_file) call restore_state(Til_restart)
      if (.not. any(vers == restart_versions) ) then
        write (chvers, '(i4)') vers
        call error_mesg ('cg_drag_init', &
               'restart version '//chvers//' cannot be read &
               &by this module version', FATAL)
      endif
      vers = restart_versions(size(restart_versions(:)))

!--------------------------------------------------------------------
!    if current cg_drag calling frequency differs from that previously 
!    used, adjust the time remaining before the next calculation. 
!--------------------------------------------------------------------
      if (cg_drag_freq /= old_time_step) then
        cgdrag_alarm = cgdrag_alarm - old_time_step + cg_drag_freq
        if (mpp_pe() == mpp_root_pe() ) then
          call error_mesg ('cg_drag_mod',   &
                'cgdrag time step has changed, &
                &next cgdrag time also changed', NOTE)
        endif
        old_time_step = cg_drag_freq
      endif

!--------------------------------------------------------------------
!    if cg_drag_offset is specified and is smaller than the time remain-
!    ing until the next calculation, modify the time remaining to be 
!    that offset time. the assumption is made that the restart was
!    written at 00Z.
!--------------------------------------------------------------------
      if (cg_drag_offset /= 0) then
        if (cgdrag_alarm > cg_drag_offset) then
          cgdrag_alarm = cg_drag_offset
        endif
      endif

!---------------------------------------------------------------------
end subroutine read_nc_restart_file

!####################################################################
! register restart field to be read and written through save_restart and restore_state.
subroutine cg_drag_register_restart

  character(len=64) :: fname = 'cg_drag.res.nc'    ! name of restart file
  character(len=64) :: fname2 
  integer           :: id_restart

  call get_mosaic_tile_file(fname, fname2, .false. ) 
  allocate(Cg_restart)
  if(trim(fname2) == trim(fname)) then
     Til_restart => Cg_restart
     in_different_file = .false.
  else
     in_different_file = .true.
     allocate(Til_restart)
  endif

  id_restart = register_restart_field(Cg_restart, fname, 'restart_version', vers, no_domain = .true. )
  id_restart = register_restart_field(Cg_restart, fname, 'cgdrag_alarm', cgdrag_alarm, no_domain = .true. )
  id_restart = register_restart_field(Cg_restart, fname, 'cg_drag_freq', old_time_step, no_domain = .true. )
  id_restart = register_restart_field(Til_restart, fname, 'gwd_u', gwd_u)
  id_restart = register_restart_field(Til_restart, fname, 'gwd_v', gwd_v)

  return

end subroutine cg_drag_register_restart

!####################################################################
! <SUBROUTINE NAME="cg_drag_restart">
!
! <DESCRIPTION>
! write out restart file.
! Arguments: 
!   timestamp (optional, intent(in)) : A character string that represents the model time, 
!                                      used for writing restart. timestamp will append to
!                                      the any restart file name as a prefix. 
! </DESCRIPTION>
!
subroutine cg_drag_restart(timestamp)
  character(len=*), intent(in), optional :: timestamp

  call save_restart(Cg_restart, timestamp)
  if(in_different_file) call save_restart(Til_restart, timestamp)

end subroutine cg_drag_restart
! </SUBROUTINE> NAME=cg_drag_restart"


!####################################################################

subroutine gwfc (is, ie, js, je, source_level, source_amp, rho, u,    &
                 bf, z, gwf, ked)

!-------------------------------------------------------------------
!    subroutine gwfc computes the gravity wave-driven-forcing on the
!    zonal wind given vertical profiles of wind, density, and buoyancy 
!    frequency. 
!    Based on version implemented in SKYHI -- 27 Oct 1998 by M.J. 
!    Alexander and L. Bruhwiler.
!-------------------------------------------------------------------

!-------------------------------------------------------------------
integer,                     intent(in)             :: is, ie, js, je
integer, dimension(:,:),     intent(in)             :: source_level
real,    dimension(:,:),     intent(in)             :: source_amp
real,    dimension(:,:,0:),  intent(in)             :: rho, u, bf, z
real,    dimension(:,:,0:),  intent(out)            :: gwf
real,    dimension(:,:,0:),  intent(out)            :: ked

!-------------------------------------------------------------------
!  intent(in) variables:
!
!      is, ie, js, je   starting/ending subdomain i,j indices of data
!                       in the physics_window being integrated
!      source_level     k index of model level serving as gravity wave
!                       source
!      source_amp     amplitude of  gravity wave source
!                       
!      rho              atmospheric density [ kg/m^3 ] 
!      u                zonal wind component [ m/s ]
!      bf               buoyancy frequency [ /s ]
!      z                height of model levels  [ m ]
!
!  intent(out) variables:
!
!      gwf              gravity wave forcing in u equation  [ m/s^2 ]
!
!  intent(out), optional variables:
!
!      ked              eddy diffusion coefficient from gravity wave 
!                       forcing [ m^2/s ]
!
!------------------------------------------------------------------

!------------------------------------------------------------------
!  local variables

      real,    dimension (0:size(u,3)-1 ) ::       &
                                   wv_frcng, diff_coeff, c0mu, dz,    &
                                   fac, omc
      integer, dimension (nc) ::   msk
      real   , dimension (nc) ::   c0mu0, B0
      real                    ::   fm, fe, Hb, alp2, Foc, c, test, rbh,&
                                   eps, Bsum
      integer                 ::   iz0 
      integer                 ::   i, j, k, ink, n
      real                    ::   ampl
!------------------------------------------------------------------
!  local variables:
! 
!      wv_frcng    gravity wave forcing tendency [ m/s^2 ]
!      diff_coeff  eddy diffusion coefficient [ m2/s ]
!      c0mu        difference between phase speed of wave n and u 
!                  [ m/s ]
!      dz          delta z between model levels [ m ]
!      fac         factor used in determining if wave is breaking 
!                  [ s/m ]
!      omc         critical frequency that marks total internal 
!                  reflection  [ /s ]
!      msk         indicator as to whether wave n is still propagating 
!                  upwards (msk=1), or has been removed from the 
!                  spectrum because of breaking or reflection (msk=0)
!      c0mu0       difference between phase speed of wave n and u at the
!                  source level [ m/s ]
!      B0          wave momentum flux amplitude for wave n [ (m/s)^2 ]
!      fm          used to sum up momentum flux from all waves n 
!                  deposited at a level [ (m/s)^2 ]
!      fe          used to sum up contributions to diffusion coefficient
!                  from all waves n at a level [ (m/s)^3 ]
!      Hb          density scale height [ m ]
!      alp2        scale height factor: 1/(2*Hb)**2  [ /m^2 ]
!      Foc         wave breaking threshold [ s/m ]
!      c           wave phase speed used in defining wave momentum flux
!                  amplitude [ m/s ]
!      test        condition defining internal reflection [ /s ]
!      rbh         atmospheric density at half-level (geometric mean)
!                  [ kg/m^3 ]
!      eps         intermittency factor
!      Bsum        total mag of gravity wave momentum flux at source 
!                  level, divided by the density  [ m^2/s^2 ]
!      iz0         source level vertical index for the given column
!      i,j,k       spatial do loop indices
!      ink         wavenumber loop index 
!      n           phase speed loop index 
!      ampl        phase speed loop index 
!
!--------------------------------------------------------------------

!-------------------------------------------------------------------
!    initialize the output arrays. these will hold values at each 
!    (i,j,k) point, summed over the wavelengths and phase speeds
!    defining the gravity wave spectrum.
!-------------------------------------------------------------------
      gwf = 0.0
      ked = 0.0

      do j=1,size(u,2)
        do i=1,size(u,1)  
! The following index-offsets are needed in case a physics_window is being used.
          iz0 = source_level(i+is-1,j+js-1)
          ampl= source_amp(i+is-1,j+js-1)

!--------------------------------------------------------------------
!    define wave momentum flux (B0) at source level for each phase 
!    speed n, and the sum over all phase speeds (Bsum), which is needed 
!    to calculate the intermittency. 
!-------------------------------------------------------------------
          Bsum = 0.
          do n=1,nc
            c0mu0(n) = c0(n) - u(i,j,iz0)   

!---------------------------------------------------------------------
!    when the wave phase speed is same as wind speed, there is no
!    momentum flux.
!---------------------------------------------------------------------
            if (c0mu0(n) == 0.0)  then
              B0(n) = 0.0
            else 

!---------------------------------------------------------------------
!    define wave momentum flux at source level for phase speed n. Add
!    the contribution from this phase speed to the previous sum.
!---------------------------------------------------------------------
              c = c0(n)*flag + c0mu0(n)*(1 - flag)
              if (c0mu0(n) < 0.0) then
                B0(n) = -1.0*(Bw*exp(-alog(2.0)*(c/cw)**2) +    &
                              Bn*exp(-alog(2.0)*(c/cn)**2))
              else 
                B0(n) = (Bw*exp(-alog(2.0)*(c/cw)**2)  +  &
                         Bn*exp(-alog(2.0)*(c/cn)**2))
              endif
              Bsum = Bsum + abs(B0(n))
            endif
          end do

!---------------------------------------------------------------------
!    define the intermittency factor eps. the factor of 1.5 is currently
!    unexplained.
!---------------------------------------------------------------------
          if (Bsum == 0.0) then
            call error_mesg ('cg_drag_mod', &
               ' zero flux input at source level', FATAL)
          endif
          eps = (ampl*1.5/nk)/Bsum

!--------------------------------------------------------------------
!    loop over the nk different wavelengths in the spectrum.
!--------------------------------------------------------------------
          do ink=1,nk   ! wavelength loop

!----------------------------------------------------------------------
!    define variables needed at levels above the source level.
!---------------------------------------------------------------------
            do k=0,iz0
              fac(k) = 0.5*(rho(i,j,k)/rho(i,j,iz0))*kwv(ink)/bf(i,j,k)
            end do

            do k=0,iz0 
              dz(k) = z(i,j,k) - z(i,j,k+1)
              Hb = -(dz(k))/alog(rho(i,j,k)/rho(i,j,k+1))
              alp2 = 0.25/(Hb*Hb)
              omc(k) = sqrt((bf(i,j,k)*bf(i,j,k)*k2(ink))/    &
                            (k2(ink) + alp2))
            end do

!---------------------------------------------------------------------
!    initialize a flag which will indicate which waves are still 
!    propagating upwards.
!---------------------------------------------------------------------
            msk = 1

!----------------------------------------------------------------------
!    integrate upwards from the source level.  define variables over 
!    which to sum the deposited flux and effective eddy diffusivity 
!    from all waves breaking at a given level.
!----------------------------------------------------------------------
            do k=iz0, 0, -1
              fm = 0.
              fe = 0.
              do n=1,nc     ! phase speed loop

!----------------------------------------------------------------------
!    check only those waves which are still propagating, i.e., msk = 1.
!----------------------------------------------------------------------
                if (msk(n) == 1) then
                  c0mu(k) = c0(n) - u(i,j,k)

!----------------------------------------------------------------------
!    if phase speed matches the wind speed, remove c0(n) from the 
!    set of propagating waves.
!----------------------------------------------------------------------
                  if (c0mu(k) == 0.) then
                    msk(n) = 0
                  else

!---------------------------------------------------------------------
!    define the criterion which determines if wave is reflected at this 
!    level (test).
!---------------------------------------------------------------------
                    test = abs(c0mu(k))*kwv(ink) - omc(k)
                    if (test >= 0.0) then

!---------------------------------------------------------------------
!    wave has undergone total internal reflection. remove it from the
!    propagating set.
!---------------------------------------------------------------------
                      msk(n) = 0
                    else 

!---------------------------------------------------------------------
!    if wave is  not reflected at this level, determine if it is 
!    breaking at this level (Foc >= 0),  or if wave speed relative to 
!    windspeed has changed sign from its value at the source level 
!    (c0mu0(n)*c0mu <= 0). if it is above the source level and is
!    breaking, then add its momentum flux to the accumulated sum at 
!    this level, and increase the effective diffusivity accordingly. 
!    set flag to remove phase speed c0(n) from the set of active waves
!    moving upwards to the next level.
!---------------------------------------------------------------------
                      Foc = B0(n)/(c0mu(k) )**3 - fac(k)
                      if ((Foc >= 0.0) .or.     &
                              (c0mu0(n)*c0mu(k)  <= 0.0)) then
                        msk(n) = 0
                        if (k  < iz0) then
                          fm = fm + B0(n)
                          fe = fe + c0mu(k)*B0(n)
                        endif
                      endif                      
                    endif   ! (test >= 0.0)
                  endif ! (c0mu == 0.0)
                endif   ! (msk == 1)
              end do  ! phase speed loop

!----------------------------------------------------------------------
!    compute the gravity wave momentum flux forcing and eddy 
!    diffusion coefficient obtained across the entire wave spectrum
!    at this level.
!----------------------------------------------------------------------
              if ( k < iz0) then
                rbh = sqrt(rho(i,j,k)*rho(i,j,k+1))
                wv_frcng(k) = ( rho(i,j,iz0)/rbh)*fm*eps/dz(k)
                wv_frcng(k+1) =  0.5*(wv_frcng(k+1) + wv_frcng(k))
                diff_coeff(k) = (rho(i,j,iz0)/rbh)*fe*eps/(dz(k)*   &
                                 bf(i,j,k)*bf(i,j,k))
                diff_coeff(k+1) = 0.5*(diff_coeff(k+1) +    &
                                       diff_coeff(k))
              else 
                wv_frcng(iz0) = 0.0
                diff_coeff(iz0) = 0.0
              endif
            end do  ! (k loop)               

!---------------------------------------------------------------------
!    increment the total forcing at each point with that obtained from
!    the set of waves with the current wavenumber.
!---------------------------------------------------------------------
            do k=0,iz0      
              gwf(i,j,k) = gwf(i,j,k) + wv_frcng(k)
              ked(i,j,k) = ked(i,j,k) + diff_coeff(k)
            end do              
          end do   ! wavelength loop
        end do  ! i loop                      
      end do   ! j loop                 

!--------------------------------------------------------------------



end subroutine gwfc



!####################################################################


end module cg_drag_mod

      module mo_rodas_sol_mod

      use chem_mods_mod, only : clscnt5

      implicit none

      private
      public :: rodas_slv_init, rodas_sol

!     save

      integer :: ox_ndx
      integer :: oh_ndx, ho2_ndx, ch3o2_ndx, po2_ndx, ch3co3_ndx, &
                 c2h5o2_ndx, isopo2_ndx, macro2_ndx, mco3_ndx, c3h7o2_ndx, &
                 ro2_ndx, xo2_ndx, no_ndx, no2_ndx, no3_ndx, n2o5_ndx, &
                 c2h4_ndx, c3h6_ndx, isop_ndx, mvk_ndx, c10h16_ndx, n_ndx
      real :: epsilon(max(1,clscnt5))
      real :: err_wghts(max(1,clscnt5))

character(len=128), parameter :: version     = '$Id: mo_rodas_slv.F90,v 19.0 2012/01/06 20:34:04 fms Exp $'
character(len=128), parameter :: tagname     = '$Name: tikal $'
logical                       :: module_is_initialized = .false.

      contains

      subroutine rodas_slv_init (retain_cm3_bugs)
!-----------------------------------------------------------------------      
!        ... initialize the implict solver
!-----------------------------------------------------------------------      

      use chem_mods_mod,  only : rodas
      use mo_grid_mod,    only : pcnstm1
      use mo_chem_utls_mod, only : get_spc_ndx, get_rxt_ndx

      implicit none
      
      logical :: retain_cm3_bugs

!-----------------------------------------------------------------------      
!        ... local variables
!-----------------------------------------------------------------------      
      real, parameter :: rel_err      = 1.e-2
      real, parameter :: high_rel_err = 1.e-3
      integer :: m
      real    :: eps(pcnstm1)
      real    :: wghts(pcnstm1)

      eps(:) = rel_err
!      ox_ndx = get_spc_ndx( 'OX' )
! for ox budget (jmao,1/7/2011)
   if (retain_cm3_bugs) then
      ox_ndx = get_spc_ndx( 'OX' )
   else
      ox_ndx = get_spc_ndx( 'O3' )
   endif
      if( ox_ndx > 0 ) then
         eps(ox_ndx) = high_rel_err
      else
         m = get_spc_ndx( 'O3' )
         if( m > 0 ) then
            eps(m) = high_rel_err
         end if
      end if
      m = get_spc_ndx( 'NO' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'NO2' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'NO3' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'HNO3' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'HO2NO2' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'N2O5' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'OH' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'HO2' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if

      wghts(:) = 1.
      n_ndx = get_spc_ndx( 'N' )
      if( n_ndx > 0 ) then
         wghts(n_ndx) = 0.
      end if
      do m = 1,rodas%clscnt
         epsilon(m)   = eps(rodas%clsmap(m))
         err_wghts(m) = wghts(rodas%clsmap(m))
      end do

      end subroutine rodas_slv_init

      subroutine rodas_sol( base_sol, reaction_rates, &
                            het_rates, extfrc, &
                            nstep, delt, &
                            plonl, plnplv )
!-----------------------------------------------------------------------
!              ... rodas_sol advances the volumetric mixing ratio
!           forward one time step via the implicit runge-kutta rosenbrock scheme
!-----------------------------------------------------------------------

      use chem_mods_mod,           only : rod_nzcnt, clscnt5, clsze, &
                                      rxntot, hetcnt, extcnt, rodas
      use mo_grid_mod,             only : pcnstm1
      use mo_indprd_mod,           only : indprd
      use mo_rodas_prod_loss_mod,  only : rodas_prod_loss
      use mo_rod_lin_matrix_mod,   only : rod_linmat
      use mo_rod_nln_matrix_mod,   only : rod_nlnmat
      use mo_rod_factor_mod,       only : rod_lu_fac
      use mo_rod_solve_mod,        only : rod_lu_slv

      implicit none

!-----------------------------------------------------------------------
!             ... dummy arguments
!-----------------------------------------------------------------------
      integer, intent(in) ::   nstep                     ! time step index (zero based)
      integer, intent(in) ::   plonl                     ! longitude tile dimension
      integer, intent(in) ::   plnplv                    ! plonl*plev
      real, intent(in)    ::   delt                      ! time step (s)
      real, intent(in)    ::   reaction_rates(plnplv,rxntot)
      real, intent(in)    ::   het_rates(plnplv,max(1,hetcnt)), &
                               extfrc(plnplv,max(1,extcnt))
      real, intent(inout) ::   base_sol(plnplv,pcnstm1)

!-----------------------------------------------------------------------
!             ... local variables
!-----------------------------------------------------------------------
      integer, parameter :: att_limit = 5
      real, parameter    :: hmin      = 1.
      real, parameter    :: min_val   = 1.e-30
      real, parameter    :: con3      = 8./3.

      integer ::   isec, j, k, m
      integer ::   lev, indx
      integer ::   attempts, failures, step_fail_cnt
      real    ::   con1, con2
      real, dimension(max(1,rod_nzcnt)) :: sys_jac, lin_jac
      real, dimension(max(1,clscnt5))   :: yn, prod, loss, &
                                                 u1, u2, u3, u4, &
                                                 ind_prd
      real, dimension(plnplv,max(1,clscnt5))  :: gl_ind_prd
      real, dimension(max(1,rxntot))    :: lrxt
      real, dimension(max(1,hetcnt))    :: lhet
      real, dimension(max(1,pcnstm1))   :: lsol, y_temp
      real, dimension(max(1,clscnt5))         :: spc_err
      real    ::   err
      real    ::   hfull, hinv, interval
      real    ::   h
      logical ::   interval_done

!-----------------------------------------------------------------------      
!        ... if there is "independent" production put it in the forcing
!        ... set the iteration invariant part of the function f(y)
!-----------------------------------------------------------------------      
      if( rodas%indprd_cnt /= 0 .or. extcnt > 0 ) then
         call indprd( 5, gl_ind_prd, base_sol, extfrc, reaction_rates )
      else
         do m = 1,max(1,clscnt5)
            gl_ind_prd(:,m) = 0.
         end do
      end if
level_loop : &
!++lwh
!     do lev = 1,plev
      do lev = 1,plnplv/plonl
!--lwh
lon_tile_loop : &
         do isec = 1,plonl
            indx = (lev - 1)*plonl + isec
            h    = delt
            hinv = 1./h
            interval      = 0.
            step_fail_cnt = 0
            do m = 1,rxntot
               lrxt(m) = reaction_rates(indx,m) 
            end do
            if( hetcnt > 0 ) then
               do m = 1,hetcnt
                  lhet(m) = het_rates(indx,m) 
                end do
            end if
            if( rodas%indprd_cnt /= 0 .or. extcnt > 0 ) then
               do m = 1,max(1,clscnt5)
                  ind_prd(m) = gl_ind_prd(indx,m) 
               end do
            end if
!-----------------------------------------------------------------------      
!        ... full timestep loop
!-----------------------------------------------------------------------      
full_time_step_loop : &
            do
               interval_done = .false.
               failures      = 0
!-----------------------------------------------------------------------      
!        ... transfer from base to local work arrays
!-----------------------------------------------------------------------      
               do m = 1,pcnstm1
                  lsol(m)   = base_sol(indx,m) 
                  y_temp(m) = lsol(m)
               end do
!----------------------------------------------------------------------      
!        ... store values at t(n)
!-----------------------------------------------------------------------      
               do k = 1,clscnt5
                  j       = rodas%clsmap(k)
                  m       = rodas%permute(k)
                  yn(m) = lsol(j)
               end do
!-----------------------------------------------------------------------      
!        ... attemp step size
!-----------------------------------------------------------------------      
sub_step_loop : &
               do attempts = 1,att_limit
                  con1 = 2.*hinv
                  con2 = 4.*hinv
!-----------------------------------------------------------------------      
!        ... the linear component
!-----------------------------------------------------------------------      
                  if( rodas%lin_rxt_cnt > 0 ) then
                     call rod_linmat( lin_jac, lsol, lrxt, lhet )
                  end if
!-----------------------------------------------------------------------      
!        ... the non-linear component
!-----------------------------------------------------------------------      
                     call rod_nlnmat( sys_jac, lsol, lrxt, lin_jac, con1 )
!-----------------------------------------------------------------------      
!         ... factor the "system" matrix
!-----------------------------------------------------------------------      
                  call rod_lu_fac( sys_jac )
!-----------------------------------------------------------------------      
!           ... form dy/dt = prod - loss
!-----------------------------------------------------------------------      
                  call rodas_prod_loss( prod, loss, lsol, lrxt, lhet )
                   if( rodas%indprd_cnt > 0 .or. extcnt > 0 ) then
                     do m = 1,clscnt5
                        u1(m) = loss(m) - (prod(m) + ind_prd(m))
                     end do
                  else
                     do m = 1,clscnt5
                        u1(m) = loss(m) - prod(m)
                     end do
                  end if
                  do m = 1,clscnt5
                     u2(m) = u1(m)
                  end do
!-----------------------------------------------------------------------      
!           ... solve for the first intermediate
!-----------------------------------------------------------------------      
                  call rod_lu_slv( sys_jac, u1 )
!-----------------------------------------------------------------------      
!           ... solve for the second intermediate
!-----------------------------------------------------------------------      
                  do m = 1,clscnt5
                     u2(m) = u2(m) - con2*u1(m)
                  end do
                  call rod_lu_slv( sys_jac, u2 )
!-----------------------------------------------------------------------      
!           ... solve for the third intermediate
!-----------------------------------------------------------------------      
                  do k = 1,clscnt5
                     j = rodas%clsmap(k)
                     m = rodas%permute(k)
                     lsol(j) = yn(m) + 2.*u1(m)
                  end do
                  call rodas_prod_loss( prod, loss, lsol, lrxt, lhet )
                   if( rodas%indprd_cnt > 0 .or. extcnt > 0 ) then
                     do m = 1,clscnt5
                        u3(m) = loss(m) - (prod(m) + ind_prd(m) + hinv*(u1(m) - u2(m)))
                     end do
                  else
                     do m = 1,clscnt5
                        u3(m) = loss(m) - (prod(m) + hinv*(u1(m) - u2(m)))
                     end do
                  end if
                  call rod_lu_slv( sys_jac, u3 )
!-----------------------------------------------------------------------      
!           ... solve for the fourth intermediate
!-----------------------------------------------------------------------      
                  do k = 1,clscnt5
                     j = rodas%clsmap(k)
                     m = rodas%permute(k)
                     lsol(j) = yn(m) + 2.*u1(m) + u3(m)
                  end do
                  call rodas_prod_loss( prod, loss, lsol, lrxt, lhet )
                   if( rodas%indprd_cnt > 0 .or. extcnt > 0 ) then
                     do m = 1,clscnt5
                        u4(m) = loss(m) - (prod(m) + ind_prd(m) + hinv*(u1(m) - u2(m) - con3*u3(m)))
                     end do
                  else
                     do m = 1,clscnt5
                        u4(m) = loss(m) - (prod(m) + hinv*(u1(m) - u2(m) - con3*u3(m)))
                     end do
                  end if
                  call rod_lu_slv( sys_jac, u4 )
!-----------------------------------------------------------------------      
!           ... form y(n+1) from intermediates
!-----------------------------------------------------------------------      
                  do k = 1,clscnt5
                     j = rodas%clsmap(k)
                     m = rodas%permute(k)
                     lsol(j) = yn(m) + 2.*u1(m) + u3(m) + u4(m)
                  end do
!-----------------------------------------------------------------------      
!           ... form estimated trunc error
!-----------------------------------------------------------------------      
                  err = 0.
                  do k = 1,clscnt5
                     j = rodas%clsmap(k)
                     m = rodas%permute(k)
                     if( lsol(j) > min_val ) then
                        spc_err(k) = err_wghts(k) * u4(m) / (epsilon(k)*lsol(j))
                        err        = err + spc_err(k)*spc_err(k)
                        end if
                     end do
                  err = sqrt( err/real(clscnt5) )
                  if( err < 1. ) then
                     if( h == delt ) then
                        interval_done = .true.
                        hfull         = h
                        exit
                     end if
                     interval  = interval + h
                     h        = h * min( 10.,max( .1,1./(err**.33) ) )
                     h         = max( hmin,h )
                     hfull     = h
                     if( abs( interval - delt ) > 1.e-6*delt ) then
                        h    = min( delt-interval,h )
                        hinv = 1. / h
                     end if
                     exit
                  else
                     if( h == hmin ) then
                        interval      = interval + h
                        hfull         = h
                        step_fail_cnt = step_fail_cnt + 1
                        exit
                     end if
                     failures = failures + 1
                     if( attempts == att_limit ) then
                        interval = interval + h
                     end if
                     if( failures >= 2 ) then
                        h = .1 * h
                     else
                        h = h * min( 10.,max( .1,.5/(err**.33) ) )
                     end if
                     h = max( hmin,h )
                     h = min( delt-interval,h )
                     hinv = 1. / h
                     if( attempts == att_limit ) then
                        hfull         = h
                        step_fail_cnt = step_fail_cnt + 1
                        exit
                     end if
                     do m = 1,pcnstm1
                        lsol(m) = y_temp(m)
                     end do
                  end if
               end do sub_step_loop
               do m = 1,pcnstm1
                  base_sol(indx,m) = lsol(m)
               end do
               if( interval_done .or. abs( interval - delt ) <= 1.e-6*delt ) then
                  h = min( hfull,delt )
                  exit
               end if
            end do full_time_step_loop
         end do lon_tile_loop
      end do level_loop

      end subroutine rodas_sol

      end module mo_rodas_sol_mod

!FDOC_TAG_GFDL

                 module donner_deep_clouds_W_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   fil
! </CONTACT>
! <REVIEWER EMAIL="">
!   
! </REVIEWER>
! <OVERVIEW>
!          donner deep cloud radiative properties module
!   
! </OVERVIEW>
! <DESCRIPTION>
!   
! </DESCRIPTION>
!

use time_manager_mod,       only: time_type
use mpp_mod,                only: input_nml_file
use fms_mod,                only: open_namelist_file, file_exist,   &
                                  check_nml_error, error_mesg,   &
                                  close_file, FATAL,  &
                                  mpp_pe, mpp_root_pe, &
                                  write_version_number, stdlog
use rad_utilities_mod,      only: microphysics_type

!--------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!          donner deep cloud radiative properties module
!
!--------------------------------------------------------------------



!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------

   character(len=128)  :: version =  '$Id: donner_deep_clouds_W.F90,v 19.0 2012/01/06 20:15:19 fms Exp $'
   character(len=128)  :: tagname =  '$Name: tikal $'



!---------------------------------------------------------------------
!-------  interfaces --------

public          &
          donner_deep_clouds_W_init,   &
          donner_deep_clouds_W_end , donner_deep_clouds_amt

!---------------------------------------------------------------------
!-------- namelist  ---------

logical   :: using_dge_lw = .true.
logical   :: using_dge_sw = .true.



namelist /donner_deep_clouds_W_nml /     &
       using_dge_sw, using_dge_lw


!----------------------------------------------------------------------
!----  public data -------


!----------------------------------------------------------------------
!----  private data -------


  logical :: module_is_initialized = .false.
!----------------------------------------------------------------------
!----------------------------------------------------------------------




contains 





! <SUBROUTINE NAME="donner_deep_clouds_W_init">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call donner_deep_clouds_W_init  (pref, lonb, latb, axes, Time)
!
!  </TEMPLATE>
!  <IN NAME="pref" TYPE="real">
! 
!  </IN>
!  <IN NAME="lonb" TYPE="real">
! 
!  </IN>
!  <IN NAME="latb" TYPE="real">
! 
!  </IN>
!  <IN NAME="axes" TYPE="integer">
! 
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
! 
!  </IN>
! </SUBROUTINE>
!
subroutine donner_deep_clouds_W_init  (pref, lonb, latb, axes, Time)

real, dimension(:,:), intent(in) :: pref
real, dimension(:,:), intent(in) :: lonb, latb
integer, dimension(4), intent(in)      :: axes
type(time_type),       intent(in)      :: Time

      integer            :: unit, ierr, io, logunit

     if (module_is_initialized) return
!---------------------------------------------------------------------
!-----  read namelist  ------
  
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=donner_deep_clouds_W_nml, iostat=io)
      ierr = check_nml_error(io,"donner_deep_clouds_W_nml")
#else
      if (file_exist('input.nml')) then
        unit =  open_namelist_file ()
        ierr=1; do while (ierr /= 0)
        read (unit, nml=donner_deep_clouds_W_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'donner_deep_clouds_W_nml')
        enddo
10      call close_file (unit)
      endif
#endif

      if ( mpp_pe() == mpp_root_pe() ) then
         call write_version_number(version, tagname)
         logunit = stdlog()
         write (logunit,nml=donner_deep_clouds_W_nml)
      endif

!---------------------------------------------------------------------

       module_is_initialized = .true.


end subroutine donner_deep_clouds_W_init

! <SUBROUTINE NAME="donner_deep_clouds_W_end">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call donner_deep_clouds_W_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine donner_deep_clouds_W_end
       
!----------------------------------------------------------------------
!    diag_clouds_W_end is the destructor for diag_clouds_W_mod.
!----------------------------------------------------------------------
       
!---------------------------------------------------------------------
!    mark the module as not initialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.
       
!--------------------------------------------------------------------


end subroutine donner_deep_clouds_W_end


!#################################################################


!---------------------------------------------------------------------

! <SUBROUTINE NAME="donner_deep_clouds_amt">
!  <OVERVIEW>
!    donner_deep_clouds_amt defines the distribution of cloud water and
!    cloud ice concentration and particle size and total cloud fraction
!    in both the mesoscale and convective cell-scale components of the
!    clouds associated with donner_deep convection. these values will
!    be combined with the large-scale cloud fields to produce the dist-
!    ribution of cloud radiative properties that will be seen by the
!    radiation package.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    donner_deep_clouds_amt defines the distribution of cloud water and
!    cloud ice concentration and particle size and total cloud fraction
!    in both the mesoscale and convective cell-scale components of the
!    clouds associated with donner_deep convection. these values will
!    be combined with the large-scale cloud fields to produce the dist-
!    ribution of cloud radiative properties that will be seen by the
!    radiation package.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call donner_deep_clouds_amt (is, ie, js, je, Cell_microphys,  &
!                Meso_microphys)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <INOUT NAME="Cell_microphys" TYPE="microphysics_type">
! 
!  </INOUT>
!  <INOUT NAME="Meso_microphys" TYPE="microphysics_type">
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine donner_deep_clouds_amt (is, ie, js, je,   &
                   cell_cloud_frac, cell_liquid_amt, cell_liquid_size, &
                   cell_ice_amt, cell_ice_size, &
                   cell_droplet_number, &
                   meso_cloud_frac, meso_liquid_amt, meso_liquid_size, &
                   meso_ice_amt, meso_ice_size, &
                   meso_droplet_number,  nsum_out, &
                   Cell_microphys,  Meso_microphys)

!---------------------------------------------------------------------
!    donner_deep_clouds_amt defines the distribution of cloud water and
!    cloud ice concentration and particle size and total cloud fraction
!    in both the mesoscale and convective cell-scale components of the
!    clouds associated with donner_deep convection. these values will
!    be combined with the large-scale cloud fields to produce the dist-
!    ribution of cloud radiative properties that will be seen by the
!    radiation package.
!----------------------------------------------------------------------

integer,                 intent(in)    :: is,ie,js,je
real, dimension(:,:,:), intent(inout) ::   &
                   cell_cloud_frac, cell_liquid_amt, cell_liquid_size, &
                   cell_ice_amt, cell_ice_size, &
                   cell_droplet_number, &
                   meso_cloud_frac, meso_liquid_amt, meso_liquid_size, &
                   meso_ice_amt, meso_ice_size, &
                   meso_droplet_number
integer, dimension(:,:), intent(inout) ::  nsum_out
type(microphysics_type), intent(inout) :: Cell_microphys, Meso_microphys

!---------------------------------------------------------------------
!     call donner_deep_avg to obtain the specification fields for both
!     the mesoscale and convective cellscale clouds assocated with 
!     donner_deep convection.
!---------------------------------------------------------------------
      call donner_deep_avg (                           &
                      is, ie, js, je,           &
                      cell_cloud_frac,  Cell_microphys%cldamt, &
                      cell_liquid_amt, Cell_microphys%conc_drop, &
                      cell_liquid_size, Cell_microphys%size_drop,&
                      cell_ice_amt, Cell_microphys%conc_ice, &
                      cell_ice_size, Cell_microphys%size_ice, &
                 cell_droplet_number, Cell_microphys%droplet_number, &
                      meso_cloud_frac, Meso_microphys%cldamt,   &
                      meso_liquid_amt, Meso_microphys%conc_drop, &
                      meso_liquid_size, Meso_microphys%size_drop,&
                      meso_ice_amt, Meso_microphys%conc_ice, &
                      meso_ice_size, Meso_microphys%size_ice,   &
                 meso_droplet_number, Meso_microphys%droplet_number, &
                      nsum_out)

!---------------------------------------------------------------------



end subroutine donner_deep_clouds_amt  



!####################################################################

subroutine donner_deep_avg    &
               (is, ie, js, je,           &
                cell_cloud_frac,  cell_cloud_frac_out,   &
                cell_liquid_amt, cell_liquid_amt_out,      &
                cell_liquid_size, cell_liquid_size_out    ,&
                cell_ice_amt, cell_ice_amt_out, &
                cell_ice_size, cell_ice_size_out, &
                cell_droplet_number, cell_droplet_number_out, &
                meso_cloud_frac, meso_cloud_frac_out, &
                meso_liquid_amt, meso_liquid_amt_out, &
                meso_liquid_size, meso_liquid_size_out,&
                meso_ice_amt, meso_ice_amt_out, &
                meso_ice_size, meso_ice_size_out,   &
                meso_droplet_number, meso_droplet_number_out, &
                nsum)

!------------------------------------------------------------------
!    subroutine donner_deep_avg outputs the cloud microphysical quant-
!    ities associated with donner_deep convection for use by the rad-
!    iation package. these fields are the cloud liquid and ice amounts,
!    liquid and ice sizes, and fractional coverage, for both the con-
!    vective cell and mesoscale components of the convective system.
!--------------------------------------------------------------------

integer,                   intent(in)  :: is, ie, js, je
real,    dimension(:,:,:), intent(inout) :: cell_cloud_frac,        &
                                          cell_liquid_amt,   &
                                          cell_liquid_size,  &
                                          cell_ice_amt, &
                                          cell_ice_size,   &
                                       cell_droplet_number, &
                                          meso_cloud_frac,   &
                                          meso_liquid_amt, &
                                          meso_liquid_size, &
                                          meso_ice_amt,  &
                                          meso_ice_size, &
                                        meso_droplet_number
integer, dimension(:,:), intent(inout) :: nsum                        
real,    dimension(:,:,:), intent(out) :: cell_cloud_frac_out,        &
                                          cell_liquid_amt_out,   &
                                          cell_liquid_size_out,  &
                                          cell_ice_amt_out, &
                                          cell_ice_size_out,   &
                                        cell_droplet_number_out, &
                                          meso_cloud_frac_out,   &
                                          meso_liquid_amt_out, &
                                          meso_liquid_size_out, &
                                          meso_ice_amt_out,  &
                                          meso_ice_size_out, &
                                       meso_droplet_number_out

!----------------------------------------------------------------------
!  intent(in) variables:
!
!     is, ie         first and last values of i index values of points 
!                    in this physics window (processor coordinates)
!     js, je         first and last values of j index values of points 
!                    in this physics window (processor coordinates)
!
!  intent(out) variables:
!
!     cell_cloud_frac_out  fractional coverage of convective cells in 
!                          grid box [ dimensionless ]
!     cell_liquid_amt_out  liquid water content of convective cells 
!                          [ kg(h2o) / kg(air) ]
!     cell_liquid_size_out assumed effective size of cell liquid drops
!                          [ microns ]
!     cell_ice_amt_out     ice water content of cells 
!                          [ kg(h2o) / kg(air) ]
!     cell_ice_size_out    generalized effective diameter for ice in
!                          convective cells [ microns ]
!     meso_cloud_frac_out  fractional area of mesoscale clouds in grid 
!                          box [ dimensionless ]
!     meso_liquid_amt_out  liquid water content in mesoscale clouds
!                          [ kg(h2o) / kg(air) ]
!     meso_liquid_size_out assumed effective size of mesoscale drops
!                          [ microns ]
!     meso_ice_amt_out     ice water content of mesoscale elements 
!                          [ kg(h2o) / kg(air) ]
!     meso_ice_size_out    generalized ice effective size for anvil ice
!                          [ microns ]
!
!---------------------------------------------------------------------

   
!------------------------------------------------------------------
!   local variables

      real, dimension(size(cell_cloud_frac_out,1), &
                      size(cell_cloud_frac_out,2))   :: inv_nsum
      integer                                        :: num
      integer                                        ::   k
   
!---------------------------------------------------------------------
!   local variables:
!
!       inv_sum     inverse of number of elements in the time averaged
!                   output fields
!       num         number of grid columns which have not been given
!                   values for the output variables by donner_deep_mod
!       i,j,k       do-loop indices
!
!--------------------------------------------------------------------- 

!---------------------------------------------------------------------
!    check to make sure dimensions of arguments match the module
!    variable dimensions.
!---------------------------------------------------------------------
      if (size(cell_cloud_frac_out,3) /= size(cell_cloud_frac,3)) &
        call error_mesg (  'donner_rad_mod',  &
                         'input argument has the wrong size',FATAL)

!---------------------------------------------------------------------
!    check to see that all columns have been given values for the module
!    variables that are going to be averaged. 
!----------------------------------------------------------------------
      num = count(        nsum(:,:) == 0)

!----------------------------------------------------------------------
!    if all points have values of 0, then the scheme has not yet been
!    called. use the initialized values that are present.
!----------------------------------------------------------------------
      if (num == (ie-is+1)*(je-js+1) ) then
        cell_cloud_frac_out             = cell_cloud_frac
        cell_liquid_amt_out             = cell_liquid_amt
        cell_liquid_size_out            = cell_liquid_size
        cell_ice_amt_out                = cell_ice_amt
        cell_ice_size_out               = cell_ice_size
        cell_droplet_number_out         = cell_droplet_number
        meso_cloud_frac_out             = meso_cloud_frac
        meso_liquid_amt_out             = meso_liquid_amt
        meso_liquid_size_out            = meso_liquid_size
        meso_ice_amt_out                = meso_ice_amt
        meso_ice_size_out               = meso_ice_size
        meso_droplet_number_out         = meso_droplet_number
        
!----------------------------------------------------------------------
!    if any columns have not been given values, stop execution with an 
!    error message. 
!----------------------------------------------------------------------
      else if (num > 0) then
        call error_mesg ( 'donner_rad_mod', &
                         'nsum has some zero entries', FATAL)

!----------------------------------------------------------------------
!    if all columns have valid data, produce time averaged values of
!    the desired output fields.
!----------------------------------------------------------------------
      else
        inv_nsum(:,:) = 1.0/float(nsum(  :  , :   ))
        do k=1,size(cell_cloud_frac_out,3)
          cell_cloud_frac_out(:,:,k) =   &
                              cell_cloud_frac(:,:,        k)*inv_nsum
          cell_liquid_amt_out(:,:,k) =   &
                              cell_liquid_amt(:,:,        k)*inv_nsum
          cell_liquid_size_out(:,:,k) =  &
                              cell_liquid_size(:,:,k        )*inv_nsum
          cell_ice_amt_out(:,:,k) =      &
                              cell_ice_amt(:,:,k        )*inv_nsum
          cell_ice_size_out(:,:,k) =     &
                              cell_ice_size(:,:,k        )*inv_nsum
          cell_droplet_number_out(:,:,k) =     &
                              cell_droplet_number(:,:,k      )*inv_nsum
          meso_cloud_frac_out(:,:,k) =   &
                              meso_cloud_frac(:,:,        k)*inv_nsum
          meso_liquid_amt_out(:,:,k) =   &
                              meso_liquid_amt(:,:,        k)*inv_nsum
          meso_liquid_size_out(:,:,k) =  &
                              meso_liquid_size(:,:,        k)*inv_nsum
          meso_ice_amt_out(:,:,k) =      &
                              meso_ice_amt(:,:,        k)*inv_nsum
          meso_ice_size_out(:,:,k) =     & 
                              meso_ice_size(:,:,        k)*inv_nsum
          meso_droplet_number_out(:,:,k) =     & 
                              meso_droplet_number(:,:,     k)*inv_nsum
        end do
     
!---------------------------------------------------------------------
!     prevent the occurrence of cloud area with no condensate and cond-
!     ensate with no area, for both the convective cell clouds and the
!     mesoscale cloud.
!---------------------------------------------------------------------
        where (cell_cloud_frac_out  > 0.0 .and.  &
               cell_liquid_amt_out == 0.0 .and.  &
               cell_ice_amt_out    == 0.0)
          cell_cloud_frac_out  = 0.0
        end where
        where (cell_cloud_frac_out == 0.0 .and.   &
               cell_liquid_amt_out  > 0.0)
          cell_liquid_amt_out  = 0.0
        end where
        where (cell_cloud_frac_out == 0.0 .and.   &
               cell_ice_amt_out     > 0.0)
          cell_ice_amt_out     = 0.0
        end where

        where (meso_cloud_frac_out  > 0.0 .and.  &
               meso_liquid_amt_out == 0.0 .and.  &
               meso_ice_amt_out    == 0.0)
          meso_cloud_frac_out  = 0.0
        end where
        where (meso_cloud_frac_out == 0.0 .and.   &
               meso_liquid_amt_out  > 0.0)
          meso_liquid_amt_out  = 0.0
        end where
        where (meso_liquid_amt_out == 0.0)
          meso_liquid_size_out = 0.0
        end where
        where (meso_cloud_frac_out == 0.0 .and.   &
               meso_ice_amt_out     > 0.0)
          meso_ice_amt_out     = 0.0
        end where
      endif
 
!----------------------------------------------------------------------
!    reset the variables just processed so that new sums may be begun 
!    when donner_deep is called again.
!----------------------------------------------------------------------
      cell_cloud_frac                 = 0.0
      cell_liquid_amt                 = 0.0
      cell_liquid_size                = 0.0
      cell_ice_amt                    = 0.0
      cell_ice_size                   = 0.0
      cell_droplet_number             = 0.0
      meso_cloud_frac                 = 0.0
      meso_liquid_amt                 = 0.0
      meso_liquid_size                = 0.0
      meso_ice_amt                    = 0.0
      meso_ice_size                   = 0.0
      meso_droplet_number             = 0.0
      nsum                            = 0
       
!----------------------------------------------------------------------



end subroutine donner_deep_avg


!#####################################################################

       end module donner_deep_clouds_W_mod

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                                   !!
!!                   GNU General Public License                      !!
!!                                                                   !!
!! This file is part of the Flexible Modeling System (FMS).          !!
!!                                                                   !!
!! FMS is free software; you can redistribute it and/or modify       !!
!! it and are expected to follow the terms of the GNU General Public !!
!! License as published by the Free Software Foundation.             !!
!!                                                                   !!
!! FMS is distributed in the hope that it will be useful,            !!
!! but WITHOUT ANY WARRANTY; without even the implied warranty of    !!
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     !!
!! GNU General Public License for more details.                      !!
!!                                                                   !!
!! You should have received a copy of the GNU General Public License !!
!! along with FMS; if not, write to:                                 !!
!!          Free Software Foundation, Inc.                           !!
!!          59 Temple Place, Suite 330                               !!
!!          Boston, MA  02111-1307  USA                              !!
!! or see:                                                           !!
!!          http://www.gnu.org/licenses/gpl.txt                      !!
!!                                                                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module vgrid_mod
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">Z. Liang </CONTACT>
  ! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">S. M. Griffies</REVIEWER>
  !

  !<OVERVIEW>
  ! <TT>vgrid_mod</TT> Generate vertical grid. 
  !</OVERVIEW>

  !<DESCRIPTION>
  !   The grid file contains the following information,

  ! <PRE>
  !
  !       zt = depth of tracer points
  !       zb = depth of tracer_boundaries
  !
  !              +---------------+
  !              |               |
  !              |               |
  !              |               |
  !              |               |
  !              |      +zt_k    |
  !              |               |
  !              |               |
  !              |               |
  !              +------+zb_k----+
  !
  ! </PRE>
  !</DESCRIPTION>

  use mpp_mod,        only : mpp_pe, mpp_root_pe, mpp_error, FATAL, NOTE,  mpp_chksum
  use mpp_mod,        only : lowercase
  use mpp_io_mod,     only : MPP_NETCDF, MPP_RDONLY, MPP_ASCII, MPP_MULTI, MPP_SINGLE
  use mpp_io_mod,     only : mpp_open, mpp_write_meta, mpp_write, axistype, mpp_close
  use mpp_io_mod,     only : mpp_get_info, mpp_get_atts, mpp_get_axes, mpp_get_axis_data 
  use fms_mod,        only : write_version_number, open_namelist_file, string
  use fms_mod,        only : file_exist, close_file, check_nml_error, stdlog, stdout
  use grids_type_mod, only : vgrid_data_type
  use grids_util_mod, only : make_axis, get_file_unit
  use constants_mod,  only : PI

  implicit none
  private

  integer, parameter :: maxlen=10000,maxbounds=11
  !------ namelist interface ---------------------------------------------
  !------ specify a spherical grid resolution in depth
  integer                    :: nzdepths = 0 
  real, dimension(maxbounds) :: z_depth, dz_depth
  logical                    :: read_my_grid = .false.
  character(len=128)         :: my_grid_file = 'my_vgrid'
  logical                    :: debug = .false.
  character(len=24)          :: z_axis_t   = 'zt_k'
  character(len=24)          :: z_axis_b   = 'zw_k'
  integer                    :: z_axis_b_offset = 1
  !
  !<NAMELIST NAME="vgrid_nml">
  !<DATA NAME="nzdepths" TYPE="integer">
  ! number of depth regions for varying resolution
  ! </DATA>
  ! <DATA NAME="z_depth" TYPE="real" DIM="(nxlons)" UNITS="meters">
  ! boundaries for defining depth regions of varying resolution
  ! </DATA>
  ! <DATA NAME="dz_depth" TYPE="real" DIM="(nxlons)" UNITS="meters">
  ! nominal resolution of depth regions
  ! </DATA>
  ! <DATA NAME="stretch_z" TYPE="real">
  !  stretch factor of vertical grids.
  ! </DATA>
  !<DATA NAME="read_my_grid" TYPE="logical">
  ! read ASCII grid information for supplying user-defined grids. 
  !</DATA>
  !<DATA NAME="my_grid_file" TYPE="character(len=128)">
  ! Name of ASCII or netcdf user grid file
  !</DATA>
  !<DATA NAME="z_axis_t" TYPE="character(len=24)">
  ! Name of z_t axis, if the file is netcdf
  !</DATA>
  !<DATA NAME="z_axis_b" TYPE="character(len=24)">
  ! Name of z_b axis, if the file is netcdf
  !</DATA>
  !<DATA NAME="z_axis_b_offset" TYPE="integer">
  ! offset of z_b axis, if the file is netcdf
  ! 1 corresponds to an axis starting at k=0, z_b=0 (mom3)
  !</DATA>
  !<DATA NAME="debug" TYPE="logical">
  ! control standard output.
  !</DATA>
  !</NAMELIST>
  namelist /vgrid_nml/ nzdepths, z_depth, dz_depth, read_my_grid, my_grid_file, debug,&
                       z_axis_b_offset, z_axis_t, z_axis_b
  !-----------------------------------------------------------------------
  !--------private data---------------------------------------------------
  integer                         :: nk   !number of grid cells in depth
  real, dimension(:), allocatable :: zt0, zb0
  type(axistype),save             :: axis_zt, axis_zb
  logical                         :: module_is_initialized = .false.
  !---------version information-------------------------------------------
  character(len=128) :: version = '$Id: vgrid.f90,v 13.0 2006/03/28 21:45:06 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $' 
  !---------public interface----------------------------------------------
  public :: generate_vgrid, vgrid_init, vgrid_end, write_vgrid_meta, write_vgrid_data


contains

  !#######################################################################
  ! <SUBROUTINE NAME="vgrid_init" >
  !   <OVERVIEW>
  !    Initialization routine.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !    Read namelist, write out version and namelist informaiton and generate depth resolution.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call vgrid_init ( )
  !   </TEMPLATE>
  ! </SUBROUTINE>

  subroutine vgrid_init

    integer :: unit, ierr, io, k, pe
    integer :: ndim, nvar, natt, ntime, len, i, nkb
    character(len=128)          :: txt
    character(len=128)          :: name
    type(axistype), allocatable :: axes(:)
    logical                     :: found_z_t, found_z_b

    z_depth(:)  = 0.0
    dz_depth(:) = 0.0

    !---- read namelist --------------------------------------------------
    unit = open_namelist_file ( )
    ierr=1
    do while (ierr /= 0)
       read  (unit, nml=vgrid_nml, iostat=io, end=10)
       ierr = check_nml_error(io,'vgrid_nml') 
    enddo
10  call close_file (unit)

    !--- write version info and namelist to logfile ----------------------

    call write_version_number(version, tagname)
    if (mpp_pe() == mpp_root_pe()) then
       write (stdout(), nml=vgrid_nml)
    endif

    allocate (zt0(0:maxlen), zb0(0:maxlen))

    if (read_my_grid) then
       nk=0
       nkb=0
       if(.not. file_exist(trim(my_grid_file))) &
            call mpp_error(FATAL,'vgrid_mod: file '//trim(my_grid_file)//' does not exist')
       len = len_trim(my_grid_file)
       if(my_grid_file(len-2:len) == '.nc') then
          call mpp_open(unit,trim(my_grid_file),action=MPP_RDONLY,form=MPP_NETCDF,threading=MPP_MULTI,fileset=MPP_SINGLE)
          call mpp_get_info(unit, ndim, nvar, natt, ntime)
          allocate(axes(ndim))
          call mpp_get_axes(unit, axes)
          found_z_t = .false.; found_z_b = .false.
          do i=1, ndim
             call mpp_get_atts(axes(i),name=name,len=len)  
             if (trim(lowercase(name)) .eq. trim(lowercase(z_axis_t))) then
               found_z_t = .true.
               nk = len
               call mpp_get_axis_data(axes(i), zt0(1:nk) )
             endif  
             if (trim(lowercase(name)) .eq. trim(lowercase(z_axis_b))) then
               found_z_b = .true.
               nkb = len
               call mpp_get_axis_data(axes(i), zb0(1-z_axis_b_offset:nkb-z_axis_b_offset) )
             endif  
          enddo
          if(.not. found_z_t) call mpp_error(FATAL,'axis '//trim(z_axis_t)//' does not exist in file '//trim(my_grid_file) )
          if(.not. found_z_b) call mpp_error(FATAL,'axis '//trim(z_axis_b)//' does not exist in file '//trim(my_grid_file) )
          deallocate(axes)
          call mpp_close(unit)
       else
          call mpp_open(unit,trim(my_grid_file),action=MPP_RDONLY,form=MPP_ASCII,  &
               threading=MPP_MULTI,fileset=MPP_SINGLE)
          read(unit,*) txt ! header line (ignored) 
          read(unit,*) nk
          read(unit,*) zt0(1:nk)
          read(unit,*) txt ! header line (ignored) 
          read(unit,*) 
          read(unit,*) zb0(1:nk)
          call mpp_close(unit)
       endif
       if (nk == 0) call mpp_error(FATAL,'vgrid_mod: error reading file '//trim(my_grid_file) )

    else
       write (stdout(),'(//,36x,a,/)') 'V G R I D   G E N E R A T I O N'
       !--- check namelist
       if (nzdepths .lt. 2 ) then 
          call mpp_error(FATAL, 'vgrid_mod: nml "nzdepths" = '//trim(string(nzdepths))//' should be no less than 2')
       endif
       if (nzdepths .gt. maxbounds) then
          call mpp_error(FATAL, 'vgrid_mod: maxbouds= '//trim(string(maxbounds))// &
               ' is less than nml nzdepths= '//trim(string(nzdepths)) )
       endif

       write (stdout(),'(/a)') 'Generating the vertical resolution for the computational domain:'
       call make_axis('Z',maxlen, nzdepths,z_depth,dz_depth,zb0,zt0, nk,.false., .false.)

    endif

    ! print out vgrid coordinates

    write (stdout(),9103) nk
    write (stdout(),9002) (zt0(k),k=1,nk)
    write (stdout(),9104) nk
    write (stdout(),9002) (zb0(k),k=1,nk)

    ! Compute a grid checksum
    if(debug) then
       write (stdout(),'(/)')
       pe = mpp_pe()
       write (stdout(),*) 'Vertical Grid checksum = ',  mpp_chksum(zt0(1:nk),(/pe/))+&
            mpp_chksum(zb0(1:nk),(/pe/))
       write (stdout(),'(/)')
    endif
    module_is_initialized = .true.

    return

9002 format (1x,10f10.2)
9101 format (/,  a,i4,' in units of ',a,' as follows:')
9103 format (/,' Depth to T and U grid points (m): zt(k) k=1,',i3)
9104 format (/,' Depth to W grid points (m): zb(k) k=1,',i3)

  end subroutine vgrid_init

  !#######################################################################
  ! <SUBROUTINE NAME="generate_vgrid" >
  !   <OVERVIEW>
  !    Generate vertical grid.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     call generate_vgrid (Vgrid)
  !   </TEMPLATE>
  !   <INOUT NAME="Vgrid" TYPE="vgrid_data_type">
  !     A derived-type variable that contains vertical grid information.
  !   </INOUT>
  ! </SUBROUTINE>

  subroutine generate_vgrid (Vgrid)

    type(vgrid_data_type), intent(inout) :: Vgrid

    !--- allocate memory to data type ------------------------------------

    allocate(Vgrid%zt(nk), Vgrid%zb(nk))

    Vgrid%zt(:) = zt0(1:nk)   
    Vgrid%zb(:) = zb0(1:nk)

    deallocate(zt0, zb0)

  end subroutine generate_vgrid

  !#######################################################################
  ! <SUBROUTINE NAME="write_vgrid_data">
  !   <OVERVIEW>
  !     write the vertical grid data to netcdf file
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     call write_vgrid_data (unit)
  !   </TEMPLATE>
  !   <IN NAME="unit" TYPE="integer" >
  !     The unit corresponding the output netcdf file. Always is returned by mpp_open.
  !   </IN>
  ! </SUBROUTINE>

  subroutine write_vgrid_data (file)
    character(len=*), intent(in) :: file
    integer                      :: unit

    if(mpp_pe() .ne. mpp_root_pe() ) return

    unit = get_file_unit(file)

    call mpp_write(unit,axis_zt)
    call mpp_write(unit,axis_zb)

  end subroutine write_vgrid_data

  !#######################################################################
  ! <SUBROUTINE NAME="write_vgrid_meta">

  !   <OVERVIEW>
  !     Write out vertical grid meta data.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     call write_vgrid_meta(unit, Vgrid)
  !   </TEMPLATE>
  !   <IN NAME="unit" TYPE="integer" >
  !     The unit corresponding the output netcdf file. Always is returned by mpp_open.
  !   </IN>
  !   <IN NAME="Vgrid" TYPE="vgrid_data_type">
  !     A derived-type variable that contains vertical grid information.
  !   </IN>
  ! </SUBROUTINE>

  subroutine write_vgrid_meta(file, Vgrid)
    character(len=*),      intent(in) :: file
    type(vgrid_data_type), intent(in) :: Vgrid
    integer                           :: unit

    if(mpp_pe() .ne. mpp_root_pe() ) return

    unit = get_file_unit(file)

    call mpp_write_meta(unit,axis_zt,'zt','meters','zt',&
         data=Vgrid%zt(1:nk),cartesian='z',sense=-1)
    call mpp_write_meta(unit,axis_zb,'zb','meters','zb',&
         data=Vgrid%zb,cartesian='z',sense=-1)

    return

  end subroutine write_vgrid_meta

  !#######################################################################
  ! <SUBROUTINE NAME="vgrid_end">

  !   <OVERVIEW>
  !     Destruction routine.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Deallocates memory used by "vgrid_data_type" variables.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call vgrid_end ( Vgrid )
  !   </TEMPLATE>
  !   <INOUT NAME="Vgrid" TYPE="vgrid_data_type">
  !     A derived-type variable that contains vertical grid information.
  !   </INOUT>
  ! </SUBROUTINE>
  subroutine vgrid_end(Vgrid)
    type(vgrid_data_type), intent(inout) :: Vgrid

    deallocate(Vgrid%zt, Vgrid%zb )
    module_is_initialized = .false.

  end subroutine vgrid_end

  !#######################################################################


end module vgrid_mod

module cpl_netcdf_setup_mod
!
!=========================================================================

implicit none

include 'netcdf.inc'
integer :: pLonDimId, pLatDimId, timeDimId, pDepDimId

contains 

subroutine ncheck(status, error_str) 

    implicit none

    integer, intent(in) :: status
    character(len=*), intent(in), optional :: error_str

    if (status /= nf_noerr) then
      write(*,'(/a)')   'error - from NetCDF library'
      if (present(error_str)) then
          write(*,'(a)')   error_str
      endif
      write(*,'(a/)')   trim(nf_strerror(status))
      stop
    end if

end subroutine ncheck

subroutine create_ncfile(ncfile, ncid, ii, jj, kk, ll, ilout)
    ! Create 2, 3,or 4D ncfile, depending on optional args (kk,ll)

    implicit none

    integer, intent(in) :: ii,jj     	!x, y dimension size
    integer, optional :: kk, ll !z, t dimension size
    integer, optional :: ilout  !format io file id
    character(len=*), intent(in) :: ncfile  
    integer, intent(out) :: ncid

#if defined(DEBUG)
    if (present(ilout)) then 
      write(ilout,*) 'creating a new netcdf file: ',ncfile
      write(ilout,*) '    with nx, ny = ', ii, jj
    endif
#endif

    !create a new NetCDF and define the grid:
    call ncheck(nf_create(trim(ncfile),nf_write,ncid), "Creating: "//trim(ncfile))

    !define the dimensions
    if (present(ll)) then
        call ncheck(nf_def_dim(ncid,"time", nf_unlimited,  timeDimId), 'Defining time in '//trim(ncfile)//' in create_ncfile()')
    endif
    if (present(kk)) then
        call ncheck(nf_def_dim(ncid,"nz", kk,  pDepDimId), 'Defining nz in '//trim(ncfile)//' in create_ncfile()')
    endif
    call ncheck(nf_def_dim(ncid, "ny", jj,  pLatDimId), 'Defining ny in '//trim(ncfile)//' in create_ncfile()')
    call ncheck(nf_def_dim(ncid, "nx", ii,  pLonDimId), 'Defining nx in '//trim(ncfile)//' in create_ncfile()')

    call ncheck(nf_enddef(ncid))

    return
end subroutine create_ncfile

subroutine write_nc_1Dtime(vin, nt, vname, ncid)

    implicit none

    integer, intent(in) :: ncid,nt
    integer :: varid, ncstatus
    integer, dimension(1:6) :: adate
    real, intent(in) :: vin
    ! NOTE here real is default real*8 (which is actually the same as dbl_kind!)
    ! somehow the netcdf lib used here takes 'real' as real*4. therefore we need: 
    real*4 :: vtmp
    character(len=*), intent(in) :: vname
    character*80 ctimeatt

    vtmp = real(vin)
    ncstatus=nf_inq_varid(ncid,vname,varid)

    if (ncstatus/=nf_noerr) then
      call ncheck(nf_redef(ncid))
      call ncheck(nf_def_var(ncid,trim(vname),nf_real, 1, timeDimId, varid), 'Defining: '//trim(vname)//' in write_nc_1Dtime()')
      write(ctimeatt, &
          '("seconds since ",I4.4,"-",I2.2,"-",I2.2," ",I2.2,":",I2.2,":",I2.2)') adate(:)
      call ncheck(nf_put_att_text(ncid,varid,"units",len_trim(ctimeatt),trim(ctimeatt)), 'Adding attribute units to '//trim(vname)//' in write_nc_1Dtime()')
      call ncheck(nf_enddef(ncid))
    end if

    !write values into the 1D array
    call ncheck(nf_put_vara_real(ncid,varid,nt,1,vtmp), 'Writing values to '//trim(vname)//' in write_nc_1Dtime()')

    return
end subroutine write_nc_1Dtime

subroutine write_nc2D(ncid, vname, vin, prcn, nx, ny, istep, ilout)
    !
    !to output a 2D array into a 3D field (with time dimension) 
    !with either single or double precisioin depending on argumnet 'prcn'!
    !

    implicit none

    integer, intent(in) :: ncid
    integer, intent(in) :: prcn	!precision choice (1/2: signle/double)
    character(len=*), intent(in) :: vname
    integer, intent(in) :: nx, ny
    integer, intent(in) :: istep	!position in the time dim (No of record) 
    integer, optional :: ilout
    real, dimension(nx,ny), intent(in) :: vin

    integer :: varid, ncstatus 
    real*4, dimension(nx,ny) :: vtmp   !single precision

#if defined(DEBUG)
    if (present(ilout)) write(ilout,*) 'write_nc2D: handling var *** ',vname, ' rec: ', istep
#endif

    ncstatus=nf_inq_varid(ncid,vname,varid)
    if (ncstatus/=nf_noerr) then
      call ncheck(nf_redef(ncid))
      if (prcn == 1) then
        call ncheck(nf_def_var(ncid,trim(vname),nf_real, 3, &
                (/pLonDimId, pLatDimId, timeDimId/),varid), 'Defining real '//trim(vname)//' in write_nc2D')
      else
        call ncheck(nf_def_var(ncid,trim(vname),nf_double, 3, &
                (/pLonDimId, pLatDimId, timeDimId/),varid), 'Defining double '//trim(vname)//' in write_nc2D')
      endif
      call ncheck(nf_enddef(ncid))
#if defined(DEBUG)
      if (present(ilout)) write(ilout,*) 'write_nc2D: defined new var ***', vname 
#endif
    else
#if defined(DEBUG)
      if (present(ilout)) write(ilout,*) 'write_nc2D: found   old var ***', vname
#endif
    end if

    select case(prcn)
      case (1)
        vtmp = real(vin) !dbl precision to single precision
        call ncheck(nf_put_vara_real(ncid,varid,(/1,1,istep/),(/nx,ny,1/),vtmp), 'Writing real values to'//trim(vname)//' in write_nc2D')
      case default    !case (2)
        call ncheck(nf_put_vara_double(ncid,varid,(/1,1,istep/),(/nx,ny,1/),vin), 'Writing double values to'//trim(vname)//' in write_nc2D')
    end select

    return
end subroutine write_nc2D

end module cpl_netcdf_setup_mod

module atmos_co2_mod
! <CONTACT EMAIL="rdslater@splash.princeton.edu">
!   Richard D. Slater
! </CONTACT>

! <REVIEWER EMAIL="none@nowhere.dot">
!   none yet
! </REVIEWER>


! <OVERVIEW>
! </OVERVIEW>

! <DESCRIPTION>
! </DESCRIPTION>


use mpp_mod, only: input_nml_file 
use              fms_mod, only : file_exist, write_version_number,    &
                                 mpp_pe, mpp_root_pe,                 &
                                 close_file, stdlog, stdout,          &
                                 check_nml_error, error_mesg,         &
                                 open_namelist_file, FATAL, NOTE, WARNING

use   tracer_manager_mod, only : get_tracer_index, tracer_manager_init
use    field_manager_mod, only : MODEL_ATMOS
use     diag_manager_mod, only : register_diag_field, send_data
use     time_manager_mod, only : time_type
use        constants_mod, only : WTMCO2, WTMAIR, WTMC
use    data_override_mod, only : data_override
use              mpp_mod, only : mpp_pe, mpp_root_pe


implicit none

private

!-----------------------------------------------------------------------
!----- interfaces -------

public  atmos_co2_sourcesink
public  atmos_co2_emissions
public  atmos_co2_rad
public  atmos_co2_gather_data
public  atmos_co2_flux_init
public  atmos_co2_init
public  atmos_co2_end

!-----------------------------------------------------------------------
!----------- namelist -------------------
!-----------------------------------------------------------------------

character(len=48), parameter    :: mod_name = 'atmos_co2_mod'

integer, save   :: ind_co2_flux = 0
integer, save   :: ind_co2  = 0
integer, save   :: ind_sphum = 0
integer         :: id_co2restore, id_pwt, id_co2_mol_emiss, id_co2_emiss_orig
real            :: radiation_co2_dvmr = -1

!---------------------------------------------------------------------
!-------- namelist  ---------

real     :: restore_tscale   = -1
integer  :: restore_klimit   = -1
logical  :: do_co2_restore   = .false.
logical  :: co2_radiation_override = .false.
logical  :: do_co2_emissions = .false.

namelist /atmos_co2_nml/  &
          do_co2_restore, restore_tscale, restore_klimit,  &
          co2_radiation_override, do_co2_emissions

!-----------------------------------------------------------------------
!
!  When initializing additional tracers, the user needs to make the
!  following changes.
!
!  Add an integer variable below for each additional tracer. This should
!  be initialized to zero. 
!
!  Add id_tracername for each additional tracer. These are used in
!  initializing and outputting the tracer fields.
!
!-----------------------------------------------------------------------

!PUBLIC VARIABLES
public :: co2_radiation_override, do_co2_emissions

logical :: module_is_initialized = .FALSE.


!---- version number -----
character(len=128) :: version = '$$'
character(len=128) :: tagname = '$$'
!-----------------------------------------------------------------------

contains

!#######################################################################

!<SUBROUTINE NAME ="atmos_co2_sourcesink">
!<OVERVIEW>
!  A subroutine to calculate the internal sources and sinks of carbon dioxide.
!
! do_co2_restore   = logical to turn co2_restore on/off: default = .false.
! restore_co2_dvmr = partial pressure of co2 to which to restore  (mol/mol)
! restore_klimit   = atmospheric level to which to restore starting from top
! restore_tscale   = timescale in seconds with which to restore
!
!</OVERVIEW>
!<DESCRIPTION>
! A routine to calculate the sources and sinks of carbon dixoide.
!</DESCRIPTION>
!<TEMPLATE>
!call atmos_co2_sourcesink (Time, dt,  pwt, co2, sphum, co2_restore)
!
!</TEMPLATE>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="dt" TYPE="real">
!     Model timestep.
!   </IN>
!   <IN NAME="pwt" TYPE="real" DIM="(:,:,:)">
!     The pressure weighting array. = dP/grav (kg/m2)
!   </IN>
!   <IN NAME="co2" TYPE="real" DIM="(:,:,:)">
!     The array of the carbon dioxide mixing ratio (kg co2/kg moist air)
!   </IN>
!   <IN NAME="sphum" TYPE="real" DIM="(:,:,:)">
!     The array of the specific humidity mixing ratio (kg/kg)
!   </IN>

!   <OUT NAME="co2_restore" TYPE="real" DIM="(:,:,:)">
!     The array of the restoring tendency of the carbon dioxide mixing ratio.
!   </OUT>
!

subroutine atmos_co2_sourcesink(is, ie, js, je, Time, Time_next, dt, pwt, co2, sphum, co2_restore)

   integer, intent(in)                 :: is, ie, js, je
   type (time_type),      intent(in)   :: Time, Time_next
   real, intent(in)                    :: dt
   real, intent(in),  dimension(:,:,:) :: pwt          ! kg/m2
   real, intent(in),  dimension(:,:,:) :: co2          ! moist mmr
   real, intent(in),  dimension(:,:,:) :: sphum        
   real, intent(out), dimension(:,:,:) :: co2_restore
!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

character(len=64), parameter    :: sub_name = 'atmos_co2_sourcesink'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'


integer   :: i,j,k,id,jd,kd, logunit
logical   :: sent
logical   :: used
real      :: restore_co2_dvmr = -1

!-----------------------------------------------------------------------

id=size(co2,1); jd=size(co2,2); kd=min(size(co2,3),restore_klimit)

co2_restore(:,:,:)=0.0

logunit=stdlog()
if (ind_co2 > 0 .and. do_co2_restore) then

! input is in dvmr (mol/mol)
  call data_override('ATM', 'co2_dvmr_restore', restore_co2_dvmr, Time, override=used)
  if (.not. used) then
    call error_mesg (trim(error_header), ' data override needed for co2_dvmr_restore ', FATAL)
  endif
!  if (mpp_pe() == mpp_root_pe() ) &
!      write (logunit,*)' atmos_co2_sourcesink: mean restore co2_dvmr   = ', restore_co2_dvmr


  if (restore_tscale .gt. 0 .and. restore_co2_dvmr .ge. 0.0) then
! co2mmr = (wco2/wair) * co2vmr;  wet_mmr is approximated as dry_mmr * (1-Q)
    do k=1,kd
      do j=1,jd
        do i=1,id
! convert restore_co2_dvmr to wet mmr and get tendency
          co2_restore(i,j,k) = (restore_co2_dvmr * (WTMCO2/WTMAIR) * (1.0 - &
                           sphum(i,j,k)) - co2(i,j,k))/restore_tscale
        enddo
      enddo
    enddo

! restoring diagnostic in moles co2/m2/sec 
! pwt is moist air, so no need to divide by 1-sphum here
    if (id_co2restore > 0) sent = send_data (id_co2restore, co2_restore  *  &
                                         pwt / (WTMCO2*1.e-3), Time_next, is_in=is,js_in=js)
  endif

!else
!  if (mpp_pe() == mpp_root_pe() ) &
!      write (logunit,*)' atmos_co2_sourcesink: CO2 restoring not active: ',do_co2_restore
endif

!! add pwt as a diagnostic
if (id_pwt > 0) sent = send_data (id_pwt, pwt, Time_next, is_in=is,js_in=js)


end subroutine atmos_co2_sourcesink
!</SUBROUTINE >


!#######################################################################

!<SUBROUTINE NAME ="atmos_co2_rad">

!<OVERVIEW>
! Subroutine to get global avg co2 to be used in radiation.
! input co2 field is from data override 
!</OVERVIEW>

 subroutine atmos_co2_rad(Time, radiation_co2_dvmr)

!
!-----------------------------------------------------------------------
!     arguments
!-----------------------------------------------------------------------
!
   type (time_type),      intent(in)    :: Time
   real,                  intent(inout) :: radiation_co2_dvmr
!
!-----------------------------------------------------------------------
!     local variables
!-----------------------------------------------------------------------
!

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

character(len=64), parameter    :: sub_name = 'atmos_co2_rad'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
integer :: logunit
logical   :: used
!-----------------------------------------------------------------------

logunit=stdlog()

if (ind_co2 > 0 .and. co2_radiation_override) then

! input is in dvmr (mol/mol)

  call data_override('ATM', 'co2_dvmr_rad', radiation_co2_dvmr, Time, override=used)
  if (.not. used) then
    call error_mesg (trim(error_header), ' data override needed for co2_dvmr_rad ', FATAL)
  endif
!  if (mpp_pe() == mpp_root_pe() ) &
!      write (logunit,*)' atmos_co2_rad       : mean radiation co2_dvmr = ', radiation_co2_dvmr

!else
!  if (mpp_pe() == mpp_root_pe() ) &
!      write (logunit,*)' atmos_co2_rad: CO2 radiation override not active: ',co2_radiation_override
endif


!-----------------------------------------------------------------------

end subroutine atmos_co2_rad
!</SUBROUTINE>

!#######################################################################

!<SUBROUTINE NAME ="atmos_co2_emissions">
!<OVERVIEW>
!  A subroutine to calculate the internal sources and sinks of carbon dioxide
!  from input co2 emissions data.
!
! do_co2_emissions   = logical to activate using co2 emissions: default = .false.
!
!</OVERVIEW>
!<DESCRIPTION>
! A routine to calculate the sources and sinks of carbon dixoide from co2 emissions.
!</DESCRIPTION>
!<TEMPLATE>
!call atmos_co2_emissions (Time, dt,  pwt, co2, sphum, co2_emiss_dt, kbot)
!
!</TEMPLATE>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="dt" TYPE="real">
!     Model timestep.
!   </IN>
!   <IN NAME="pwt" TYPE="real" DIM="(:,:,:)">
!     The pressure weighting array. = dP/grav (kg/m2)
!   </IN>
!   <IN NAME="co2" TYPE="real" DIM="(:,:,:)">
!     The array of the carbon dioxide mixing ratio (kg co2/kg moist air)
!   </IN>
!   <IN NAME="sphum" TYPE="real" DIM="(:,:,:)">
!     The array of the specific humidity mixing ratio (kg/kg)
!   </IN>
!   <IN NAME="kbot" TYPE="integer, optional" DIM="(:,:)">
!     Integer array describing which model layer intercepts the surface.
!   </IN>

!   <OUT NAME="co2_emiss_dt" TYPE="real" DIM="(:,:,:)">
!     The array of the restoring tendency of the carbon dioxide emissions
!   </OUT>
!
!

subroutine atmos_co2_emissions(is, ie, js, je, Time, Time_next, dt, pwt, co2, sphum, co2_emiss_dt, kbot)

   integer, intent(in)                 :: is, ie, js, je
   type (time_type),      intent(in)   :: Time, Time_next
   real, intent(in)                    :: dt
   real, intent(in),  dimension(:,:,:) :: pwt          ! kg/m2
   real, intent(in),  dimension(:,:,:) :: co2          ! moist mmr
   real, intent(in),  dimension(:,:,:) :: sphum        
   real, intent(out), dimension(:,:,:) :: co2_emiss_dt 
   integer, intent(in),  dimension(:,:), optional :: kbot
!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

character(len=64), parameter    :: sub_name = 'atmos_co2_emissions'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'


integer   :: i,j,k,id,jd,kd,kb, logunit
logical   :: sent
real, dimension(size(co2,1),size(co2,2),size(co2,3)) ::  co2_emis_source
real, dimension(size(co2,1),size(co2,2)) :: co2_emis2d
logical   :: used


!---------------------------------------------------------------------------------------
! Original IPCC AR5 historical CO2 emissions converted to kg C/m2/sec 
! Assume scenario input will be in same format/units
!---------------------------------------------------------------------------------------

id=size(co2,1); jd=size(co2,2); kd=size(co2,3)

co2_emis2d(:,:)=0.0
co2_emis_source(:,:,:)=0.0
co2_emiss_dt(:,:,:)=0.0

logunit=stdlog()
if (ind_co2 > 0 .and. do_co2_emissions) then


  call data_override('ATM', 'co2_emiss', co2_emis2d, Time, override=used, &
                     is_in=is, ie_in=ie, js_in=js, je_in=je)
  if (.not. used) then
    call error_mesg (trim(error_header), ' data override needed for co2 emission ', FATAL)
  endif

  if (id_co2_emiss_orig > 0) sent = send_data (id_co2_emiss_orig, co2_emis2d, Time_next, is_in=is,js_in=js)

! lowest model layer
    do j=1,jd
      do i=1,id
        co2_emis_source(i,j,kd) = co2_emis2d(i,j) * (WTMCO2/WTMC) / pwt(i,j,kd)
      enddo
    enddo
  
  co2_emiss_dt = co2_emis_source

! co2 mol emission diagnostic in moles CO2/m2/sec 
  if (id_co2_mol_emiss > 0) sent = send_data (id_co2_mol_emiss,   &
                 co2_emiss_dt(:,:,kd)*pwt(:,:,kd)/(WTMCO2*1.e-3), Time_next, is_in=is,js_in=js)

endif


end subroutine atmos_co2_emissions
!</SUBROUTINE >


!#######################################################################

!<SUBROUTINE NAME ="atmos_co2_gather_data">
!<OVERVIEW>
!  A subroutine to gather fields needed for calculating the CO2 gas flux
!</OVERVIEW>
!

subroutine atmos_co2_gather_data (gas_fields, tr_bot)

use coupler_types_mod, only: coupler_2d_bc_type, ind_pcair

implicit none

!-----------------------------------------------------------------------

type(coupler_2d_bc_type), intent(inout) :: gas_fields
real, dimension(:,:,:), intent(in)      :: tr_bot

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

character(len=64), parameter    :: sub_name = 'atmos_co2_gather_data'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!-----------------------------------------------------------------------

!-----------------------------------------------------------------------

! 2008/06/17 JPD/jgj: OCMIP calculation expects pco2 in dry vmr (mol/mol) units 
! atm co2 is in moist mass mixing ratio (kg co2/kg moist air)
! tr_bot: co2 bottom layer moist mass mixing ratio
! convert to dry_mmr and then to dry_vmr for ocean model.
! dry_mmr = wet_mmr / (1-Q); co2vmr = (wair/wco2) * co2mmr

if (ind_co2_flux .gt. 0) then
  gas_fields%bc(ind_co2_flux)%field(ind_pcair)%values(:,:) = (tr_bot(:,:,ind_co2) / &
       (1.0 - tr_bot(:,:,ind_sphum))) * (WTMAIR/gas_fields%bc(ind_co2_flux)%mol_wt)
endif

end subroutine atmos_co2_gather_data
!</SUBROUTINE >

!#######################################################################


!#######################################################################

!<SUBROUTINE NAME ="atmos_co2_flux_init">

!<OVERVIEW>
! Subroutine to initialize the carbon dioxide flux
!</OVERVIEW>

 subroutine atmos_co2_flux_init

use atmos_ocean_fluxes_mod, only: aof_set_coupler_flux

!
!-----------------------------------------------------------------------
!     arguments
!-----------------------------------------------------------------------
!

!
!-----------------------------------------------------------------------
!     local variables
!-----------------------------------------------------------------------
!

integer :: n

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

character(len=64), parameter    :: sub_name = 'atmos_co2_flux_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer :: logunit

if ( .not. module_is_initialized) then

!----- set initial value of carbon ------------

  call tracer_manager_init      ! need to call here since the ocean pes never call it
  n = get_tracer_index(MODEL_ATMOS,'co2')
  if (n > 0) then
    ind_co2 = n
    if (ind_co2 > 0) then
      logunit=stdout()
      write (logunit,*) trim(note_header), ' CO2 was initialized as tracer number ', ind_co2
      logunit=stdlog()
      write (logunit,*) trim(note_header), ' CO2 was initialized as tracer number ', ind_co2
    endif
  endif
  module_is_initialized = .TRUE.
endif

!
!       initialize coupler flux
!

if (ind_co2 > 0) then
  ind_co2_flux = aof_set_coupler_flux('co2_flux',                       &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',       &
       atm_tr_index = ind_co2,                                          &
       mol_wt = WTMCO2, param = (/ 9.36e-07, 9.7561e-06 /),              &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')
endif

!-----------------------------------------------------------------------

end subroutine atmos_co2_flux_init
!</SUBROUTINE>


!#######################################################################

!<SUBROUTINE NAME ="atmos_co2_init">

!<OVERVIEW>
! Subroutine to initialize the carbon dioxide module.
!</OVERVIEW>

 subroutine atmos_co2_init (Time, axes)

!
!-----------------------------------------------------------------------
!     arguments
!-----------------------------------------------------------------------
!

type(time_type),  intent(in)                        :: Time
integer, dimension(3), intent(in)                   :: axes

!
!-----------------------------------------------------------------------
!     local variables
!         unit       io unit number used to read namelist file
!         ierr       error code
!         io         error status returned from io operation
!-----------------------------------------------------------------------
!
integer :: ierr, unit, io, logunit
integer :: n
real    :: missing_value = -1.e10
character(len=64) :: desc
!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

character(len=64), parameter    :: sub_name = 'atmos_co2_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'


     if (module_is_initialized) return

     call write_version_number(version, tagname)

!-----------------------------------------------------------------------
!    read namelist.
!-----------------------------------------------------------------------
      if ( file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
        read (input_nml_file, nml=atmos_co2_nml, iostat=io)
        ierr = check_nml_error(io,'atmos_co2_nml')
#else
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=atmos_co2_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'atmos_co2_nml')
        end do
10      call close_file (unit)
#endif
      endif

!---------------------------------------------------------------------
!    write namelist to logfile.
!---------------------------------------------------------------------
      logunit=stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                          write (logunit, nml=atmos_co2_nml)

!----- set initial value of carbon ------------

n = get_tracer_index(MODEL_ATMOS,'co2')
if (n > 0) then
  ind_co2 = n
    logunit=stdout()
    write (logunit,*) trim(note_header), ' CO2 was initialized as tracer number ', ind_co2
    logunit=stdlog()
    write (logunit,*) trim(note_header), ' CO2 was initialized as tracer number ', ind_co2

 ! initialize diagnostics

   desc = ' restoring tendency'

   id_co2restore  = register_diag_field ('atmos_co2_restoring', 'co2_restore', axes, Time, &
                   'CO2'//trim(desc), 'moles co2/m2/s',missing_value=missing_value)

   desc = ' pressure weighting array = dP/grav'
   id_pwt    = register_diag_field ('atmos_co2', 'pwt', axes, Time, &
                   trim(desc), 'kg/m2',missing_value=missing_value)

   desc = ' mol emission'
   id_co2_mol_emiss = register_diag_field ('atmos_co2_emissions', 'co2_mol_emission', axes(1:2), Time, &
                      'CO2'//trim(desc), 'moles co2/m2/s',missing_value=missing_value)

   desc = ' emission_orig'
   id_co2_emiss_orig = register_diag_field ('atmos_co2_emissions', 'co2_emissions_orig', axes(1:2), Time, &
                   'CO2'//trim(desc), 'kg C/m2/s',missing_value=missing_value)

!
!       get the index for sphum
!

  ind_sphum = get_tracer_index(MODEL_ATMOS,'sphum')
  if (ind_sphum .le. 0) then
    call error_mesg (trim(error_header), ' Could not find index for sphum', FATAL)
  endif

endif

logunit=stdlog()
if (.not.(ind_co2 > 0 .and. do_co2_restore)) then
   if (mpp_pe() == mpp_root_pe() ) &
     write (logunit,*)' CO2 restoring not active:do_co2_restore= ',do_co2_restore
endif

if (.not.(ind_co2 > 0 .and. co2_radiation_override)) then
   if (mpp_pe() == mpp_root_pe() ) &
     write (logunit,*)' CO2 radiation override not active:co2_radiation_override= ',co2_radiation_override
endif

if (.not.(ind_co2 > 0 .and. do_co2_emissions)) then
   if (mpp_pe() == mpp_root_pe() ) &
     write (logunit,*)' not using CO2 emissions: do_co2_emissions= ',do_co2_emissions
endif

call write_version_number(version, tagname)
module_is_initialized = .TRUE.


!-----------------------------------------------------------------------

end subroutine atmos_co2_init
!</SUBROUTINE>


!<SUBROUTINE NAME ="atmos_co2_end">
subroutine atmos_co2_end

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

character(len=64), parameter    :: sub_name = 'atmos_co2_end'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

   module_is_initialized = .FALSE.

end subroutine atmos_co2_end
!</SUBROUTINE>


end module atmos_co2_mod

module bgrid_cold_start_mod

use mpp_mod, only: input_nml_file 
use    bgrid_horiz_mod, only: horiz_grid_type, get_horiz_grid_bound, TGRID
use     bgrid_halo_mod, only: update_halo, TEMP
use gaussian_topog_mod, only: gaussian_topog_init
use            fms_mod, only: file_exist, open_namelist_file, open_restart_file, &
                              open_ieee32_file, check_nml_error, close_file,     &
                              mpp_pe, mpp_root_pe, set_domain, read_data,        &
                              stdlog, error_mesg, FATAL, write_version_number,   &
                              field_size, uppercase
use      constants_mod, only: GRAV, RDGAS

implicit none
private

public cold_start_resol, cold_start

!-----------------------------------------------------------------------
!----- namelist ------
!
!  nlon = number of grid points along the longitude axis (1st dimension)
!  nlat = number of grid points along the latitude axis (2nd dimension)
!  nlev = number of vertical levels (equally spaced in sigma)
!  pref = initial surface pressure in pascals
!  tref = initial temperature in deg kelvin
!  equal_vert_spacing = specifies whether equal vertical spacing in sigma
!                       should be used (TRUE) or unequal spacing using 
!                       the Smagorinski formula (FALSE).
!  topog_option = how to compute topography
!                  possible values are: FLAT, FILE, GAUSS
!  topog_file   = name of topography restart file in topog_option=FILE
!
!  NOTE: nlon and nlat are for the global compute grid
!

integer :: nlon = 0
integer :: nlat = 0
integer :: nlev = 0
   real :: pref = 1000.e2
   real :: tref = 255.
logical :: equal_vert_spacing = .true.
character(len=8)   :: topog_option = 'FLAT'
character(len=128) :: topog_file = ' '

namelist /bgrid_cold_start_nml/ nlon, nlat, nlev, pref, tref, &
                                equal_vert_spacing, topog_option, &
                                topog_file

!-----------------------------------------------------------------------

character(len=128) :: version = '$Id: bgrid_cold_start.F90,v 19.0 2012/01/06 19:54:36 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!-----------------------------------------------------------------------

contains

!#######################################################################

subroutine cold_start_resol ( nx, ny, nz )

      integer, intent(out) :: nx, ny, nz

      integer :: unit, ierr, io, logunit

!-------------- read namelist --------------

   if ( file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=bgrid_cold_start_nml, iostat=io)
ierr = check_nml_error(io,'bgrid_cold_start_nml')
#else
      unit = open_namelist_file ( )
      ierr=1; do while (ierr /= 0)
         read  (unit, nml=bgrid_cold_start_nml, iostat=io, end=10)
         ierr = check_nml_error(io,'bgrid_cold_start_nml')
      enddo
 10   call close_file (unit)
#endif
   endif

!-------- write version and namelist to log file --------

   call write_version_number(version, tagname)
   logunit = stdlog()
   if (mpp_pe() == mpp_root_pe()) write (logunit, nml=bgrid_cold_start_nml)

!------- must specify a resolution -----

   if (nlon == 0 .or. nlat == 0 .or. nlev == 0)  &
   call error_mesg ('bgrid_cold_start_mod', 'resolution not specified', FATAL)

!------- otherwise, return resolution to calling program ------

   nx  = nlon
   ny  = nlat
   nz  = nlev

end subroutine cold_start_resol

!#######################################################################

subroutine cold_start ( Hgrid, eta, peta, fis, res, ps, pssl, u, v, t )

   type(horiz_grid_type), intent(inout) :: Hgrid
   real, intent(out), dimension(:)      :: eta, peta
   real, intent(out), dimension(Hgrid%ilb:,Hgrid%jlb:)     :: fis, res, &
                                                              ps, pssl
   real, intent(out), dimension(Hgrid%ilb:,Hgrid%jlb:,:)   :: u, v, t
  !real, intent(out), dimension(Hgrid%ilb:,Hgrid%jlb:,:,:) :: r
   integer :: m
   real    :: rt

!   very simple initial condition
!   -----------------------------
!   uniform pressure (adjusted for topog)
!   isothermal
!   no wind


!--- no hybrid option ---
   peta = 0.0

   eta = compute_sigma (size(eta(:))-1)

   call compute_topog (Hgrid, fis, res)

   rt = RDGAS * tref

     ps   = pref*exp(-fis/rt)
     pssl = ps                ! no eta option
     u    = 0.0
     v    = 0.0
     t    = tref

end subroutine cold_start

!#######################################################################

 subroutine compute_topog (Hgrid, fis, res)

   type(horiz_grid_type), intent(inout) :: Hgrid
   real, intent(out), dimension(Hgrid%ilb:,Hgrid%jlb:) :: fis, res

   integer :: unit, ires, jres, siz(4), nc
   logical :: eof_found
!-----------------------------------------------------------------------

!---------------------------------------------
! OPTION 1: No mountains, flat topography
!---------------------------------------------
  if ( trim(uppercase(topog_option)) == 'FLAT' ) then
       fis = 0.
       res = 1.

!---------------------------------------------
! OPTION 2: gaussian-shaped mountains
!---------------------------------------------
  else if ( trim(uppercase(topog_option(1:5))) == 'GAUSS' ) then

       call gaussian_topog_init ( Hgrid%Tmp%alm(:,Hgrid%Tmp%js), &
                                  Hgrid%Tmp%aph(Hgrid%Tmp%is,:), &
                                  fis(:,:) )
       fis = fis * GRAV                       ! convert topog from meters to geop ht
       where (fis(:,:) < 0.0) fis(:,:) = 0.0  ! only in case of roundoff error
       res = 1.

!---------------------------------------------
! OPTION 3: read topography from restart file
!---------------------------------------------
  else if ( trim(uppercase(topog_option)) == 'FILE' ) then

   if ( file_exist(trim(topog_file)) ) then
      ! netcdf or native?
        nc = len_trim(topog_file)
      !------------------------------------------
      ! read topography from netcdf restart file

        if (topog_file(nc-2:nc) == '.nc') then

          ! read fis
            call field_size (topog_file(1:nc), 'fis', siz )
            if ( siz(1) /= Hgrid%nlon .or. siz(2) /= Hgrid%nlat )     &
                 call error_mesg ('bgrid_cold_start_mod', 'incorrect resolution &
                              &or no fis field in netcdf topography file', FATAL)
            call read_data (topog_file(1:nc), 'fis', fis, Hgrid%Tmp%Domain)
            ! read res (if it exists)
            call field_size (topog_file(1:nc), 'res', siz )
            if ( siz(1) == Hgrid%nlon .and. siz(2) == Hgrid%nlat ) then
                call read_data (topog_file(1:nc), 'res', res, Hgrid%Tmp%Domain)
            else
                res = 1.
            endif
      !------------------------------------------
      ! read topography from native restart file
      
        else

            unit = open_restart_file (topog_file(1:nc), action='read')
            read (unit) ires,jres
            if ( ires /= Hgrid%nlon .or. jres /= Hgrid%nlat )  &
                            call error_mesg ('bgrid_cold_start_mod',  &
                        'incorrect resolution in native topography file', FATAL)
            call set_domain (Hgrid%Tmp%Domain)
            call read_data  (unit, fis)                ! read topog
            call read_data  (unit, res, end=eof_found) ! read res (if it exists)
            if (eof_found) res = 1.
            call close_file (unit)

        endif

   else
      ! restart file does not exist
        call error_mesg ('bgrid_cold_start',  &
                         'restart file for topography does not exist', FATAL)
   endif

!---------------------------------------------
! OPTION 4: error condition
!---------------------------------------------
  else
        call error_mesg ('bgrid_cold_start',  &
                         'invalid value for topog_option', FATAL)
  endif

! halos
  call update_halo ( Hgrid, TEMP, fis )
  call update_halo ( Hgrid, TEMP, res )

!-----------------------------------------------------------------------

 end subroutine compute_topog

!#######################################################################

 function compute_sigma (nlev) result (eta)

   integer, intent(in) :: nlev
   real, dimension(nlev+1) :: eta
   real :: dz, qk
   integer :: k

     eta(1) = 0.0
     eta(nlev+1) = 1.0

   if ( equal_vert_spacing ) then

     ! levels with equal sigma spacing
       dz = 1./nlev
       do k = 2, nlev
         eta(k) = eta(k-1) + dz
       enddo

   else

     ! space levels according to Smagorinski (1965, MWR, pp.727-768)
     ! sigma spacing smaller at the top and bottom of model
       do k = 1, nlev-1
         qk = real(2*k)/real(2*nlev)
         eta(k+1) = qk*qk*(3.-2.*qk)
       enddo

   endif

 end function compute_sigma

!#######################################################################

end module bgrid_cold_start_mod

module bgrid_physics_mod

!-----------------------------------------------------------------------
!
!        interface for b-grid dynamics with atmospheric physics
!
!-----------------------------------------------------------------------

use bgrid_core_driver_mod, only: bgrid_dynam_type
use bgrid_halo_mod,        only: update_halo, NORTH, EAST, WEST, SOUTH, &
                                 TEMP, UWND, VWND
use bgrid_prog_var_mod,    only: prog_var_type
use bgrid_vert_mod,        only: vert_grid_type, compute_height, &
                                 compute_pres_full, compute_pres_half, &
				 compute_pres_depth
use bgrid_horiz_mod,       only: horiz_grid_type, get_horiz_grid_bound, TGRID

use bgrid_change_grid_mod, only: change_grid, TEMP_GRID, WIND_GRID
use bgrid_integrals_mod,   only: global_integral
use       bgrid_masks_mod, only: grid_mask_type

use      time_manager_mod, only: time_type, get_time, operator(-)
use               fms_mod, only: error_mesg, FATAL, write_version_number , mpp_pe
use    physics_driver_mod, only: physics_driver_init,  &
                                 physics_driver_end,   &
                                 physics_driver_moist_init, &
                                 physics_driver_moist_end, &
                                 physics_driver_down_time_vary, &
                                 physics_driver_up_time_vary,  &
                                 physics_driver_down_endts,  &
                                 physics_driver_up_endts, &
                                 physics_driver_down,  &
                                 physics_driver_up,    &
                                 surf_diff_type
use  field_manager_mod, only: MODEL_ATMOS
use tracer_manager_mod, only: get_tracer_index, NO_TRACER

!-----------------------------------------------------------------------

implicit none
private

public   bgrid_physics_down, bgrid_physics_up,  &
         bgrid_physics_init, bgrid_physics_end
public   surf_diff_type

!-----------------------------------------------------------------------
character(len=128) :: version = '$Id: bgrid_physics.F90,v 19.0.2.1 2013/12/18 23:34:26 Niki.Zadeh Exp $'
character(len=128) :: tagname = '$Name:  $'
!-----------------------------------------------------------------------

real, allocatable, dimension(:,:,:) :: u_dt, v_dt

contains

!#######################################################################

subroutine bgrid_physics_down (window, dt_phys,            &
                               Time_prev, Time, Time_next, &
                               Hgrid, Vgrid, Dynam,        &
                               Var, Var_dt,                &
                               frac_land,   albedo,        &
                               albedo_vis_dir, albedo_nir_dir,     &
                               albedo_vis_dif, albedo_nir_dif,     &
                               rough_vel,   t_surf,        &
                               u_star, b_star, q_star,     &
                               dtau_du, dtau_dv, tau_x, tau_y,     &
                               flux_sw,    &
                               flux_sw_dir,    &
                               flux_sw_dif,    &
                               flux_sw_down_vis_dir,  &
                               flux_sw_down_vis_dif,  &
                               flux_sw_down_total_dir,         &
                               flux_sw_down_total_dif,         &
                               flux_sw_vis, &
                               flux_sw_vis_dir, &
                               flux_sw_vis_dif, &
                               flux_lw, coszen,   &
                               gust, Surf_diff, frac_open_sea )

!-----------------------------------------------------------------------
!
!   Time_prev =  time at the previous time level, tau-1 (time_type)
!   Time      =  time at the current time level,  tau   (time_type)
!   Time_next =  time at the next time level,     tau+1 (time_type)
!
!   NOTE: for a two time level scheme (e.g., forward-backward scheme)
!         Time_prev = Time.
!
!-----------------------------------------------------------------------
  integer, intent(in)                :: window(2)
  real,    intent(in)                :: dt_phys
       type(time_type),intent(in)    :: Time_prev, Time, Time_next
type (horiz_grid_type),intent(inout) :: Hgrid
type  (vert_grid_type),intent(in)    :: Vgrid
type(bgrid_dynam_type),intent(in)    :: Dynam
type   (prog_var_type),intent(inout) :: Var
type   (prog_var_type),intent(inout) :: Var_dt

   ! Note: Var is intent inout because of diagnostic tracers

  real, intent(in),    dimension(Hgrid%Tmp%is:,Hgrid%Tmp%js:) :: &
                                           frac_land,  albedo,   &
                                     albedo_vis_dir, albedo_nir_dir, &
                                     albedo_vis_dif, albedo_nir_dif, &
                                           rough_vel,  t_surf,   &
                                           u_star,     b_star,   &
                                           q_star, dtau_du, dtau_dv, frac_open_sea
  real, intent(inout), dimension(Hgrid%Tmp%is:,Hgrid%Tmp%js:) :: tau_x,   tau_y
  real, intent(out),   dimension(Hgrid%Tmp%is:,Hgrid%Tmp%js:) ::  &
                                    flux_sw,        &
                                    flux_sw_dir,   &
                                    flux_sw_dif,   &
                                    flux_lw, coszen,    &
                                    flux_sw_down_vis_dir, &
                                    flux_sw_down_vis_dif, &
                                    flux_sw_down_total_dir, &
                                    flux_sw_down_total_dif, &
                                    flux_sw_vis, &
                                    flux_sw_vis_dir, &
                                    flux_sw_vis_dif, &
                                    gust

  type(surf_diff_type), intent(inout) :: Surf_diff
!-----------------------------------------------------------------------
  integer :: j, k, n, is, ie, js, je, i1, i2, j1, j2, sphum, nt, ntp
  integer :: ix, jx, idim, jdim
  real    :: dt 
  integer :: sec, day
!-----------------------------------------------------------------------

   real, dimension(window(1),window(2),Vgrid%nlev) :: p_full, z_full

   real, dimension(window(1),window(2),Vgrid%nlev+1) :: p_half, z_half
   real, dimension(1,1,Vgrid%nlev+1) :: phalfgrey

   real, dimension(Hgrid%ilb:Hgrid%iub, &
                   Hgrid%jlb:Hgrid%jub, &
                   Vgrid%nlev) :: uh, vh

   real, dimension(window(1),window(2)) :: pssl_new, area
   real, dimension(size(Var%r, 4))      :: gavg_rrv
   real, dimension(1,1)                 :: psurf

!-----------------------------------------------------------------------
!---------------------------- do physics -------------------------------

    idim = window(1)
    jdim = window(2)

!   --- momentum and momentum tendency on mass grid ---
!      note: tendency is saved for "physics_up" call 

    call update_halo (Hgrid, UWND, Var_dt%u, halos=SOUTH+WEST)
    call update_halo (Hgrid, VWND, Var_dt%v, halos=SOUTH+WEST)

    if (Dynam%Masks%sigma) then
        call change_grid (Hgrid, WIND_GRID, TEMP_GRID,    Var%u,    Var%v, uh  , vh  )
        call change_grid (Hgrid, WIND_GRID, TEMP_GRID, Var_dt%u, Var_dt%v, u_dt, v_dt)
    else
        call change_grid (Hgrid, WIND_GRID, TEMP_GRID, &
                          Var%u,    Var%v, uh  , vh  , mask_inp=Dynam%Masks%Vel%mask)
        call change_grid (Hgrid, WIND_GRID, TEMP_GRID, &
                       Var_dt%u, Var_dt%v, u_dt, v_dt, mask_inp=Dynam%Masks%Vel%mask)
    endif

!   --- loop through physics windows ---

    sphum = get_tracer_index ( MODEL_ATMOS, 'sphum' )
    if (sphum <= 0) call error_mesg ('bgrid_physics_mod', &
               'specific humidity tracer not found', FATAL)
    ntp = Var_dt%ntrace
    nt  = Var   %ntrace
    js = Hgrid%Tmp%js

    gavg_rrv = 0.
    call compute_g_avg(Hgrid, Vgrid, Var, Dynam%Masks, gavg_rrv, 'co2')

!---------------------------------------------------------------------
! compute the physics time step (from tau-1 to tau+1).
!---------------------------------------------------------------------
    call get_time (Time_next-Time_prev, sec, day)
    dt = real(sec+day*86400)
 
!---------------------------------------------------------------------
! call physics_driver_down_time_vary to do the time-dependent, spatially
! independent calculations before entering windows / threads loop. 
!--------------------------------------------------------------------- 
    call physics_driver_down_time_vary (Time, Time_next, gavg_rrv, dt)


    do while ( js <= Hgrid%Tmp%je )

       je = min ( js+jdim-1, Hgrid%Tmp%je )
       jx = je-js+1
       is = Hgrid%Tmp%is

    do while ( is <= Hgrid%Tmp%ie )

       ie = min ( is+idim-1, Hgrid%Tmp%ie )
       ix = ie-is+1

!      ---- pass updated surface pressure ----
       do j = 1, jx
          pssl_new(1:ix,j) = Var   %pssl(is:ie,js+j-1) + &
                             Var_dt%pssl(is:ie,js+j-1) * dt_phys
          area    (1:ix,j) = Hgrid%Tmp%area(js+j-1)
       enddo

       call compute_pres_full (Vgrid, pssl_new(1:ix,1:jx), &
                                        p_full(1:ix,1:jx,:))
       call compute_pres_half (Vgrid, pssl_new(1:ix,1:jx), &
                                        p_half(1:ix,1:jx,:))

!      compute a reference profile of pressure based on psurf = 1000 hPa
       psurf = reshape ( (/ 100000. /), (/ 1, 1 /) )
       call compute_pres_half (Vgrid, psurf, phalfgrey)


!      ----- compute height (in meters) -------
!      ----- spec humidity assumed to be tracer #1 --------

       call compute_height (Vgrid, Dynam%fisl(is:ie,js:je),     &
                                   Var%t (is:ie,js:je,:),       &
                                   Var%r (is:ie,js:je,:,sphum), &
                                   p_full (1:ix,1:jx,:),        &
                                   p_half (1:ix,1:jx,:),        &
                                   z_full (1:ix,1:jx,:),        &
                                   z_half (1:ix,1:jx,:),        &
                                   Dynam%Masks%Tmp%mask(is:ie,js:je,:) )

!      ---- j-axis indices in the global physics grid ----

       j1 = js-Hgrid%Tmp%js+1; j2 = j1+(je-js)
       i1 = is-Hgrid%Tmp%is+1; i2 = i1+(ie-is)

!-----------------------------------------------------------------------
!-------------------------- call physics -------------------------------
!------------ (need to add leap-frog option for uh,vh) -----------------
!-----------------------------------------------------------------------
  if ( .not. Dynam%Masks%sigma ) then
!------------ eta coordinate -------------------------------------------
      call physics_driver_down (i1, i2, j1, j2                 ,&
                           Time_prev, Time, Time_next          ,&
         Hgrid%Tmp%aph (is:ie,js:je), Hgrid%Tmp%alm (is:ie,js:je),&
         area     ( 1:ix, 1:jx),    p_half   ( 1:ix, 1:jx,:)     ,&
         p_full   ( 1:ix, 1:jx,:),  z_half   ( 1:ix, 1:jx,:)     ,&
         z_full   ( 1:ix, 1:jx,:)                                ,&
         phalfgrey                                               ,&
         uh       (is:ie,js:je,:)                                ,&
         vh       (is:ie,js:je,:)     ,  Var%t(is:ie,js:je,:)         ,&
         Var%r(is:ie,js:je,:,sphum)   ,  Var%r(is:ie,js:je,:, :   )   ,&
         uh       (is:ie,js:je,:)     ,  vh       (is:ie,js:je,:)     ,&
         Var%t (is:ie,js:je,:)        ,  Var%r (is:ie,js:je,:,sphum)  ,&
         Var%r (is:ie,js:je,:, :   )  ,                                &
         frac_land(is:ie,js:je)       , rough_vel(is:ie,js:je)        ,&
         frac_open_sea(is:ie,js:je)   ,                                &
         albedo   (is:ie,js:je)       , albedo_vis_dir (is:ie,js:je)  ,&
        albedo_nir_dir (is:ie,js:je) , albedo_vis_dif (is:ie,js:je)   ,&
        albedo_nir_dif (is:ie,js:je) , t_surf   (is:ie,js:je)         ,&
         u_star   (is:ie,js:je)   , b_star   (is:ie,js:je)   ,&
        q_star   (is:ie,js:je)   , dtau_du  (is:ie,js:je),   dtau_dv (is:ie,js:je),&
        tau_x    (is:ie,js:je)   , tau_y    (is:ie,js:je)   ,&
         u_dt     (is:ie,js:je,:) , v_dt     (is:ie,js:je,:) ,&
         Var_dt%t (is:ie,js:je,:) , Var_dt%r (is:ie,js:je,:,sphum),&
         Var_dt%r (is:ie,js:je,:,1:ntp) , flux_sw  (is:ie,js:je)   ,&
                           flux_sw_dir  (is:ie,js:je)              ,&
                           flux_sw_dif  (is:ie,js:je)              ,&
                           flux_sw_down_vis_dir  (is:ie,js:je)     ,&
                           flux_sw_down_vis_dif  (is:ie,js:je)     ,&
                           flux_sw_down_total_dir  (is:ie,js:je)   ,&
                           flux_sw_down_total_dif  (is:ie,js:je)   ,&
                           flux_sw_vis  (is:ie,js:je)          ,&
                           flux_sw_vis_dir  (is:ie,js:je)          ,&
                           flux_sw_vis_dif  (is:ie,js:je)          ,&
                           flux_lw  (is:ie,js:je)              ,&
                           coszen   (is:ie,js:je)              ,&
                           gust     (is:ie,js:je)              ,&
                           Surf_diff                           ,&
                           gavg_rrv                            ,&
                      mask=Dynam%Masks%Tmp%mask(is:ie,js:je,:) ,&
                      kbot=Dynam%Masks%Tmp%kbot(is:ie,js:je)    )
  else
!------------- sigma coordinate ----------------------------------------
      call physics_driver_down (i1, i2, j1, j2                 ,&
                           Time_prev, Time, Time_next          ,&
         Hgrid%Tmp%aph (is:ie,js:je), Hgrid%Tmp%alm (is:ie,js:je),&
         area     ( 1:ix, 1:jx),    p_half   ( 1:ix, 1:jx,:)     ,&
         p_full   ( 1:ix, 1:jx,:),  z_half   ( 1:ix, 1:jx,:)     ,&
         z_full   ( 1:ix, 1:jx,:)                                ,&
         phalfgrey                                               ,&
         uh       (is:ie,js:je,:)                                ,&
         vh       (is:ie,js:je,:)   ,  Var%t(is:ie,js:je,:)         ,&
         Var%r(is:ie,js:je,:,sphum)  ,  Var%r(is:ie,js:je,:, :   )   ,&
         uh       (is:ie,js:je,:)   ,  vh       (is:ie,js:je,:)     ,&
         Var%t (is:ie,js:je,:) ,  Var%r (is:ie,js:je,:,sphum)  ,&
         Var%r (is:ie,js:je,:, :   ) ,  &
         frac_land(is:ie,js:je)   , rough_vel(is:ie,js:je)  ,&
         frac_open_sea(is:ie,js:je)   ,                                &
         albedo   (is:ie,js:je)       , albedo_vis_dir (is:ie,js:je) ,&
        albedo_nir_dir (is:ie,js:je) , albedo_vis_dif (is:ie,js:je) ,&
        albedo_nir_dif (is:ie,js:je) , t_surf   (is:ie,js:je)       ,&
         u_star   (is:ie,js:je)   , b_star   (is:ie,js:je)   ,&
        q_star   (is:ie,js:je)   , dtau_du  (is:ie,js:je)   ,dtau_dv (is:ie,js:je),&
        tau_x    (is:ie,js:je)   , tau_y    (is:ie,js:je)   ,&
         u_dt     (is:ie,js:je,:) , v_dt     (is:ie,js:je,:) ,&
         Var_dt%t (is:ie,js:je,:) , Var_dt%r (is:ie,js:je,:,sphum),&
         Var_dt%r (is:ie,js:je,:,1:ntp) , flux_sw  (is:ie,js:je)   ,&
!                          Time_prev, Time, Time_next          ,&
!                          Hgrid%Tmp%aph (is:ie,js:je)         ,&
!                          Hgrid%Tmp%alm (is:ie,js:je)         ,&
!                          area     ( 1:ix, 1:jx)              ,&
!                          p_half   ( 1:ix, 1:jx,:)            ,&
!                          p_full   ( 1:ix, 1:jx,:)            ,&
!                          z_half   ( 1:ix, 1:jx,:)            ,&
!                          z_full   ( 1:ix, 1:jx,:)            ,&
!                          uh       (is:ie,js:je,:)            ,&
!                          vh       (is:ie,js:je,:)            ,&
!                          Var%t(is:ie,js:je,:)                ,&
!                          Var%r(is:ie,js:je,:,sphum)          ,&
!                          Var%r(is:ie,js:je,:,1:ntp)          ,&
!                          uh       (is:ie,js:je,:)            ,&
!                          vh       (is:ie,js:je,:)            ,&
!                          Var%t (is:ie,js:je,:)               ,&
!                          Var%r (is:ie,js:je,:,sphum)         ,&
!                          Var%r (is:ie,js:je,:,1:ntp)         ,&
!                          Var%r (is:ie,js:je,:,ntp+1:nt)      ,&
!                          frac_land(is:ie,js:je)              ,&
!                          rough_vel(is:ie,js:je)              ,&
!                          albedo   (is:ie,js:je)              ,&
!                          albedo_vis_dir (is:ie,js:je)              ,&
!                          albedo_nir_dir (is:ie,js:je)              ,&
!                          albedo_vis_dif (is:ie,js:je)              ,&
!                          albedo_nir_dif (is:ie,js:je)              ,&
!                          t_surf   (is:ie,js:je)              ,&
!                          u_star   (is:ie,js:je)              ,&
!                          b_star   (is:ie,js:je)              ,&
!                          q_star   (is:ie,js:je)              ,&
!                          dtau_dv  (is:ie,js:je)              ,&
!                          tau_x    (is:ie,js:je)              ,&
!                          tau_y    (is:ie,js:je)              ,&
!                          u_dt     (is:ie,js:je,:)            ,&
!                          v_dt     (is:ie,js:je,:)            ,&
!                          Var_dt%t (is:ie,js:je,:)            ,&
!                          Var_dt%r (is:ie,js:je,:,sphum)      ,&
!                          Var_dt%r (is:ie,js:je,:,1:ntp)      ,&
!                          flux_sw  (is:ie,js:je)              ,&
                           flux_sw_dir  (is:ie,js:je)              ,&
                           flux_sw_dif  (is:ie,js:je)              ,&
                           flux_sw_down_vis_dir  (is:ie,js:je)     ,&
                           flux_sw_down_vis_dif  (is:ie,js:je)     ,&
                           flux_sw_down_total_dir  (is:ie,js:je)   ,&
                           flux_sw_down_total_dif  (is:ie,js:je)   ,&
                           flux_sw_vis  (is:ie,js:je)          ,&
                           flux_sw_vis_dir  (is:ie,js:je)          ,&
                           flux_sw_vis_dif  (is:ie,js:je)          ,&
                           flux_lw  (is:ie,js:je)              ,&
                           coszen   (is:ie,js:je)              ,&
                           gust     (is:ie,js:je)              ,&
                           Surf_diff                           ,&
                           gavg_rrv                            )
  endif

        is = is + idim

     enddo

        js = js + jdim

     enddo


  call physics_driver_down_endts (is-Hgrid%Tmp%is+1, js-Hgrid%Tmp%js+1)

! halo rows for tendencies do not need updating until after physics_up
! update halos for diagnostic tracers only

  if (ntp < nt) call update_halo (Hgrid, TEMP, Var%r(:,:,:,ntp+1:nt))

!-----------------------------------------------------------------------

end subroutine bgrid_physics_down

!#######################################################################

subroutine bgrid_physics_up (window, dt_phys,            &
                             Time_prev, Time, Time_next, &
                             Hgrid, Vgrid, Dynam,        &
                             Var, Var_dt, omega,         &
                             frac_land, Surf_diff, lprec, fprec, gust, &
                             u_star, b_star, q_star )

!-----------------------------------------------------------------------
!
!   Time_prev =  time at the previous time level, tau-1 (time_type)
!   Time      =  time at the current time level,  tau   (time_type)
!   Time_next =  time at the next time level,     tau+1 (time_type)
!
!   NOTE: for a two time level scheme (e.g., forward-backward scheme)
!         Time_prev = Time.
!
!-----------------------------------------------------------------------
  integer, intent(in)                :: window(2)
  real,    intent(in)                :: dt_phys
       type(time_type),intent(in)    :: Time_prev, Time, Time_next
type (horiz_grid_type),intent(inout) :: Hgrid
type  (vert_grid_type),intent(in)    :: Vgrid
type(bgrid_dynam_type),intent(in)    :: Dynam
type   (prog_var_type),intent(inout)    :: Var
type   (prog_var_type),intent(inout) :: Var_dt

real, intent(in), dimension(Hgrid%ilb:Hgrid%iub, &
                            Hgrid%jlb:Hgrid%jub, &
                            Vgrid%nlev) :: omega

  real, intent(in),  dimension(Hgrid%Tmp%is:,Hgrid%Tmp%js:) :: frac_land
type(surf_diff_type), intent(inout) :: Surf_diff
  real, intent(out), dimension(Hgrid%Tmp%is:,Hgrid%Tmp%js:) :: lprec, fprec
  real, intent(inout), dimension(Hgrid%Tmp%is:,Hgrid%Tmp%js:) :: gust
  real,    intent(in), dimension(Hgrid%Tmp%is:,Hgrid%Tmp%js:) :: u_star, b_star, q_star

!-----------------------------------------------------------------------
  integer :: j, k, n, is, ie, js, je, i1, i2, j1, j2, sphum, ntp, npz,nt
  integer :: ix, jx, idim, jdim
  integer :: sec, day
  real    :: dt
!-----------------------------------------------------------------------

   real, dimension(window(1),window(2),Vgrid%nlev) :: p_full, z_full

   real, dimension(window(1),window(2),Vgrid%nlev+1) :: p_half, z_half

   real, dimension(Hgrid%ilb:Hgrid%iub, &
                   Hgrid%jlb:Hgrid%jub, &
                   Vgrid%nlev) :: uh, vh, uh_dt, vh_dt

   real, dimension(window(1),window(2)) :: pssl_new, area

!---------------------------------------------------------------------
!    compute the physics time step (from tau-1 to tau+1).
!---------------------------------------------------------------------
    call get_time (Time_next-Time_prev, sec, day)
    dt = real(sec+day*86400)
 
    call physics_driver_up_time_vary (Time, Time_next, dt)
 

!-----------------------------------------------------------------------
!---------------------------- do physics -------------------------------

    idim = window(1)
    jdim = window(2)

!   --- momentum and previous momentum tendency on mass grid ---

    if (Dynam%Masks%sigma) then
        call change_grid (Hgrid, WIND_GRID, TEMP_GRID,    Var%u,    Var%v, uh   , vh   )
        call change_grid (Hgrid, WIND_GRID, TEMP_GRID, Var_dt%u, Var_dt%v, uh_dt, vh_dt)
    else
        call change_grid (Hgrid, WIND_GRID, TEMP_GRID, &
                          Var%u,    Var%v, uh   , vh   , mask_inp=Dynam%Masks%Vel%mask)
        call change_grid (Hgrid, WIND_GRID, TEMP_GRID, &
                       Var_dt%u, Var_dt%v, uh_dt, vh_dt, mask_inp=Dynam%Masks%Vel%mask)
    endif

!   --- loop through physics windows ---

    sphum = get_tracer_index ( MODEL_ATMOS, 'sphum' )
    if (sphum <= 0) call error_mesg ('bgrid_physics_mod', &
               'specific humidity tracer not found', FATAL)
    ntp = Var_dt%ntrace
    js = Hgrid%Tmp%js
    npz = size(p_full,3)
    nt = Var%ntrace
    call physics_driver_moist_init (window(1), window(2),  npz, ntp, nt) 
    do while ( js <= Hgrid%Tmp%je )

       je = min ( js+jdim-1, Hgrid%Tmp%je )
       jx = je-js+1
       is = Hgrid%Tmp%is

    do while ( is <= Hgrid%Tmp%ie )

       ie = min ( is+idim-1, Hgrid%Tmp%ie )
       ix = ie-is+1

!      ---- pass updated surface pressure ----
       do j = 1, jx
          pssl_new(1:ix,j) = Var   %pssl(is:ie,js+j-1) + &
                             Var_dt%pssl(is:ie,js+j-1) * dt_phys
          area    (1:ix,j) = Hgrid%Tmp%area(js+j-1)
       enddo

       call compute_pres_full (Vgrid, pssl_new(1:ix,1:jx), &
                                        p_full(1:ix,1:jx,:))
       call compute_pres_half (Vgrid, pssl_new(1:ix,1:jx), &
                                        p_half(1:ix,1:jx,:))

       call compute_height (Vgrid, Dynam%fisl(is:ie,js:je),     &
                                   Var%t (is:ie,js:je,:),       &
                                   Var%r (is:ie,js:je,:,sphum), &
                                   p_full (1:ix,1:jx,:),        &
                                   p_half (1:ix,1:jx,:),        &
                                   z_full (1:ix,1:jx,:),        &
                                   z_half (1:ix,1:jx,:),        &
                                   Dynam%Masks%Tmp%mask(is:ie,js:je,:) )

!      ---- j-axis indices in the global physics grid ----

       j1 = js-Hgrid%Tmp%js+1; j2 = j1+(je-js)
       i1 = is-Hgrid%Tmp%is+1; i2 = i1+(ie-is)

!-----------------------------------------------------------------------
!-------------------------- call physics -------------------------------
!------------ (need to add leap-frog option for uh,vh) -----------------
!-----------------------------------------------------------------------
  if ( .not. Dynam%Masks%sigma ) then
!------------ eta coordinate -------------------------------------------
      call physics_driver_up (i1, i2, j1, j2                      ,&
                              Time_prev, Time, Time_next          ,&
                              Hgrid%Tmp%aph (is:ie,js:je)         ,&
                              Hgrid%Tmp%alm (is:ie,js:je)         ,&
                              area     ( 1:ix, 1:jx)              ,&
                              p_half   ( 1:ix, 1:jx,:)            ,&
                              p_full   ( 1:ix, 1:jx,:)            ,&
                              z_half   ( 1:ix, 1:jx,:)            ,&
                              z_full   ( 1:ix, 1:jx,:)            ,&
                              omega    (is:ie,js:je,:)            ,&
                              uh       (is:ie,js:je,:)            ,&
                              vh       (is:ie,js:je,:)            ,&
                              Var%t(is:ie,js:je,:)                ,&
                              Var%r(is:ie,js:je,:,sphum)          ,&
                              Var%r(is:ie,js:je,:,:)          ,&
                              uh       (is:ie,js:je,:)            ,&
                              vh       (is:ie,js:je,:)            ,&
                              Var%t (is:ie,js:je,:)               ,&
                              Var%r (is:ie,js:je,:,sphum)         ,&
                              Var%r (is:ie,js:je,:,:)         ,&
                              frac_land(is:ie,js:je)              ,&
                              u_star(is:ie,js:je)                 ,&
                              b_star(is:ie,js:je)                 ,&
                              q_star(is:ie,js:je)                 ,&
                              u_dt     (is:ie,js:je,:)            ,&
                              v_dt     (is:ie,js:je,:)            ,&
                              Var_dt%t (is:ie,js:je,:)            ,&
                              Var_dt%r (is:ie,js:je,:,sphum)      ,&
                              Var_dt%r (is:ie,js:je,:,:)      ,&
                              Surf_diff                           ,&
                              lprec    (is:ie,js:je)              ,&
                              fprec    (is:ie,js:je)              ,&
                              gust     (is:ie,js:je)              ,&
                         mask=Dynam%Masks%Tmp%mask(is:ie,js:je,:) ,&
                         kbot=Dynam%Masks%Tmp%kbot(is:ie,js:je)    )
  else
!------------- sigma coordinate ----------------------------------------
      call physics_driver_up (i1, i2, j1, j2                      ,&
                              Time_prev, Time, Time_next          ,&
                              Hgrid%Tmp%aph (is:ie,js:je)         ,&
                              Hgrid%Tmp%alm (is:ie,js:je)         ,&
                              area     ( 1:ix, 1:jx)              ,&
                              p_half   ( 1:ix, 1:jx,:)            ,&
                              p_full   ( 1:ix, 1:jx,:)            ,&
                              z_half   ( 1:ix, 1:jx,:)            ,&
                              z_full   ( 1:ix, 1:jx,:)            ,&
                              omega    (is:ie,js:je,:)            ,&
                              uh       (is:ie,js:je,:)            ,&
                              vh       (is:ie,js:je,:)            ,&
                              Var%t(is:ie,js:je,:)                ,&
                              Var%r(is:ie,js:je,:,sphum)          ,&
                              Var%r(is:ie,js:je,:,1:ntp)          ,&
                              uh       (is:ie,js:je,:)            ,&
                              vh       (is:ie,js:je,:)            ,&
                              Var%t (is:ie,js:je,:)               ,&
                              Var%r (is:ie,js:je,:,sphum)         ,&
                              Var%r (is:ie,js:je,:,1:ntp)         ,&
                              frac_land(is:ie,js:je)              ,&
                              u_star(is:ie,js:je)                 ,&
                              b_star(is:ie,js:je)                 ,&
                              q_star(is:ie,js:je)                 ,&
                              u_dt     (is:ie,js:je,:)            ,&
                              v_dt     (is:ie,js:je,:)            ,&
                              Var_dt%t (is:ie,js:je,:)            ,&
                              Var_dt%r (is:ie,js:je,:,sphum)      ,&
                              Var_dt%r (is:ie,js:je,:,1:ntp)      ,&
                              Surf_diff                           ,&
                              lprec    (is:ie,js:je)              ,&
                              fprec    (is:ie,js:je)              ,&
                              gust     (is:ie,js:je) )
  endif

        is = is + idim

     enddo

        js = js + jdim

     enddo

     call physics_driver_moist_end
     call physics_driver_up_endts (is-Hgrid%Tmp%is+1, js-Hgrid%Tmp%js+1)

!-----------------------------------------------------------------------
! compute momentum tendencies on mass grid for physics only
!    udt(phys) = udt(current) - udt(before physics)

     uh(:,:,:) = u_dt(:,:,:) - uh_dt(:,:,:)
     vh(:,:,:) = v_dt(:,:,:) - vh_dt(:,:,:)

!  update halos of momentum tendencies on mass grid
!  then move momentum tendencies to momentum grid

     call update_halo (Hgrid, TEMP, uh, halos=NORTH+EAST)
     call update_halo (Hgrid, TEMP, vh, halos=NORTH+EAST)

     call change_grid (Hgrid, TEMP_GRID, WIND_GRID, uh, vh, uh, vh)

     uh(:,Hgrid%jub,:) = 0.0   ! zero out unused polar halo row
     vh(:,Hgrid%jub,:) = 0.0   ! no harm done when not polar row

!---- update momentum tendencies ----

     Var_dt%u = Var_dt%u + uh * Dynam%Masks%Vel%mask
     Var_dt%v = Var_dt%v + vh * Dynam%Masks%Vel%mask

!---- update all halo rows ----

     call update_halo (Hgrid, TEMP, Var_dt%t)
     call update_halo (Hgrid, TEMP, Var_dt%r)
     call update_halo (Hgrid, UWND, Var_dt%u)
     call update_halo (Hgrid, VWND, Var_dt%v)

!-----------------------------------------------------------------------

end subroutine bgrid_physics_up

!#######################################################################

subroutine bgrid_physics_init (axes, Time, Hgrid, Vgrid, Dynam, &
                               Var, Surf_diff)

!-----------------------------------------------------------------------
!
!   axes      = array of axis indices for diagnostics (x,y,pf,ph)
!   Time      = current time (time_type)
!   Hgrid     = horizontal grid constants
!   Vgrid     = vertical grid constants
!   Dynam     = current state of the dynamical core
!   Var       = prognostic variables
!
!-----------------------------------------------------------------------
integer,               intent(in)    :: axes(4)
type (time_type),      intent(in)    :: Time
type (horiz_grid_type),intent(inout) :: Hgrid
type  (vert_grid_type),intent(in)    :: Vgrid
type(bgrid_dynam_type),intent(in)    :: Dynam
type   (prog_var_type),intent(inout) :: Var
type (surf_diff_type), intent(inout) :: Surf_diff
!-----------------------------------------------------------------------
   real, dimension(Hgrid%Tmp%is:Hgrid%Tmp%ie+1)   :: lonb
   real, dimension(Hgrid%Tmp%js:Hgrid%Tmp%je+1)   :: latb
   real, dimension(Hgrid%Tmp%is:Hgrid%Tmp%ie, &
                   Hgrid%Tmp%js:Hgrid%Tmp%je,Vgrid%nlev+1) :: phalf
   real, dimension(Vgrid%nlev+1,2) :: pref
   real, dimension(2,1,Vgrid%nlev) :: pref_full
   real, dimension(2,1)            :: pref_sl
   real, dimension(Hgrid%Tmp%is:Hgrid%Tmp%ie+1,Hgrid%Tmp%js:Hgrid%Tmp%je+1) :: lonb2d, latb2d
!-----------------------------------------------------------------------
   integer :: i, j, k, n, nt, is, ie, js, je, unit
!-----------------------------------------------------------------------

    nt = Var%ntrace

!----- write version to logfile --------

   call write_version_number(version, tagname)

!---------- get local grid box edges ---------

    call get_horiz_grid_bound (Hgrid, TGRID, lonb, latb)
    do j = Hgrid%Tmp%js,Hgrid%Tmp%je+1
       lonb2d(:,j) = lonb(:)
    end do
    do i = Hgrid%Tmp%is,Hgrid%Tmp%ie+1
       latb2d(i,:) = latb(:)
    end do

!---------- reference profile -----------

    pref_sl = reshape ( (/ 101325., 81060. /), (/ 2, 1 /) )
    call compute_pres_full (Vgrid, pref_sl, pref_full)
    pref(1:Vgrid%nlev,1) = pref_full(1,1,:)
    pref(1:Vgrid%nlev,2) = pref_full(2,1,:)
    pref(Vgrid%nlev+1,1) = pref_sl(1,1)
    pref(Vgrid%nlev+1,2) = pref_sl(2,1)

!------- pressure at model layer interfaces -----

    is = Hgrid % Tmp % is;  ie = Hgrid % Tmp % ie
    js = Hgrid % Tmp % js;  je = Hgrid % Tmp % je

    call compute_pres_half (Vgrid, Var%pssl(is:ie,js:je), phalf)

!---------- initialize physics -------

    if (Dynam%Masks%sigma) then
        call physics_driver_init (Time, lonb2d, latb2d, lonb2d, latb2d, axes, pref,  &
                                  Var%r(is:ie,js:je,:,1:nt),     &
                                  Surf_diff, phalf               )
    else
        call physics_driver_init (Time, lonb2d, latb2d, lonb2d, latb2d, axes, pref,   &
                                  Var%r(is:ie,js:je,:,1:nt),      &
                                  Surf_diff, phalf,               &
                        mask=Dynam%Masks%Tmp%mask(is:ie,js:je,:), &
                        kbot=Dynam%Masks%Vel%kbot(is:ie,js:je)    )
    endif

!       ---- boundaries for tracers ----
    call update_halo (Hgrid, TEMP, Var%r)

!       ---- storage for global data ----

    allocate (u_dt(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub,Vgrid%nlev))
    allocate (v_dt(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub,Vgrid%nlev))

!-----------------------------------------------------------------------

end subroutine bgrid_physics_init

!#######################################################################

subroutine bgrid_physics_end (Time)

!-----------------------------------------------------------------------
   type(time_type), intent(in) :: Time
!-----------------------------------------------------------------------
!  NOTE: this is not the dynamics time
!-----------------------------------------------------------------------

    call physics_driver_end (Time)

!-----------------------------------------------------------------------

end subroutine bgrid_physics_end

!#######################################################################

subroutine compute_g_avg(Hgrid, Vgrid, Var, Masks, rrv, tracer_name)

  type (horiz_grid_type),intent(inout) :: Hgrid
  type  (vert_grid_type),intent(in)    :: Vgrid
  type   (prog_var_type),intent(in)    :: Var
  type (grid_mask_type), intent(in)    :: Masks

  real, dimension(:),    intent(inout) :: rrv
  character(len=*), intent(in) :: tracer_name

  real, dimension (Hgrid%ilb:Hgrid%iub,          &
                   Hgrid%jlb:Hgrid%jub, Var%nlev) :: dpde, avg

  real avgps
  real psfc_sum, qp_sum, qp
  integer j, i, k, idx

    psfc_sum = 0.
    qp_sum = 0.
    idx = get_tracer_index(MODEL_ATMOS, trim(tracer_name))
    if(idx /= NO_TRACER) then
      call compute_pres_depth (Vgrid, Var%pssl, dpde)
      avg = Var%r(:,:,:,idx) * dpde
      avgps  = global_integral (Hgrid, 1, Var%ps,  do_exact=.true.)
      rrv(idx) = global_integral(Hgrid, 1, avg, Masks, .true.) / avgps
    endif

end subroutine compute_g_avg

end module bgrid_physics_mod

!-----------------------------------------------------------------------
! Copyright 2011 NOAA Geophysical Fluid Dynamics Lab, Princeton, NJ
! This program is distributed under the terms of the GNU General Public
! License. See the file COPYING contained in this directory
!
!-----------------------------------------------------------------------
#define __NF_TRY__(err_code,iret,LABEL) iret=err_code;\
call cdfe(iret,"",__LINE__,verb);\
if(iret/=NF_NOERR)goto LABEL

module nfu_mod

implicit none
private

! ==== public interface ======================================================
public :: nfu_def_var, nfu_def_dim
public :: nfu_inq_var, nfu_inq_dim, nfu_inq_att
public :: nfu_get_var_r8, nfu_get_var_r4, nfu_get_var_int
public :: nfu_put_var_r8, nfu_put_var_r4, nfu_put_var_int
public :: nfu_get_rec_r8, nfu_get_rec_r4
public :: nfu_put_rec_r8, nfu_put_rec_r4
public :: nfu_get_att, nfu_put_att, nfu_append_att, nfu_copy_att
public :: nfu_clone_dim, nfu_clone_var
public :: nfu_copy_var_data
public :: nfu_check_err
public :: nfu_get_valid_range, is_valid, validtype

! ---- error codes
public :: nfu_ediffdimsize,nfu_elimunlim

public :: cdfe
! ==== end of public interface ===============================================

! ==== module constants ======================================================
integer, parameter :: nfu_ediffdimsize = -1001
integer, parameter :: nfu_elimunlim    = -1002

type validtype
   logical :: hasmax = .false.
   logical :: hasmin = .false.
!   real(kind=8) :: max=HUGE(max),min=-HUGE(min)
   real(kind=8) :: max=0,min=0
end type

! ==== interfaces for overloaded functions ===================================
interface nfu_def_var
   module procedure nfu_def_var_0
   module procedure nfu_def_var_1
end interface

interface nfu_inq_var
   module procedure inq_var_i
   module procedure inq_var_n
end interface

interface nfu_inq_dim
   module procedure inq_dim_i
   module procedure inq_dim_n
end interface

interface nfu_inq_att
   module procedure inq_att_i_n
   module procedure inq_att_n_n
   module procedure inq_att_i_i
   module procedure inq_att_n_i
end interface

interface nfu_get_rec_r8
   module procedure get_r8_rec
   module procedure get_r8_n_rec
end interface

interface nfu_get_rec_r4
   module procedure get_r4_rec
   module procedure get_r4_n_rec
end interface

interface nfu_put_rec_r8
   module procedure put_r8_rec
   module procedure put_r8_n_rec_1d
   module procedure put_r8_n_rec_2d
end interface

interface nfu_put_rec_r4
   module procedure put_r4_rec
   module procedure put_r4_n_rec
end interface

interface nfu_get_att
   module procedure get_att_text
   module procedure get_att_int
   module procedure get_att_r4
   module procedure get_att_r8
   module procedure get_att_int_1
   module procedure get_att_r4_1
   module procedure get_att_r8_1
end interface

interface nfu_put_att
   module procedure put_att_text
   module procedure put_att_int
   module procedure put_att_r8
   module procedure put_att_r4
   module procedure put_att_int_1
   module procedure put_att_r8_1
   module procedure put_att_r4_1
end interface

interface nfu_append_att
   module procedure append_att_text_i
   module procedure append_att_text_n
end interface

interface nfu_clone_dim
  module procedure clone_dim_n
  module procedure clone_dim_i
end interface

interface nfu_clone_var
   module procedure clone_var_n
   module procedure clone_var_i
end interface

interface nfu_copy_var_data
   module procedure copy_var_data_i
   module procedure copy_var_data_n
end interface

! ==== module data ==========================================================
integer :: verb = 0 ! verbosity level

#include <netcdf.inc>

contains

! ============================================================================
function inq_dim_n(ncid,name,dimlen,is_unlim,dimid) result (iret)
  integer, intent(in) :: ncid
  character(*), intent(in) :: name
  integer, optional, intent(out) :: dimid
  logical, optional, intent(out) :: is_unlim
  integer, optional, intent(out) :: dimlen
  integer :: iret

  integer :: dimid_
  __NF_TRY__(nf_inq_dimid(ncid,name,dimid_),iret,7)
  if(present(dimid)) dimid = dimid_
  __NF_TRY__(inq_dim_i(ncid,dimid_,dimlen,is_unlim),iret,7)
7 return
end function


! ============================================================================
function inq_dim_i(ncid,dimid,dimlen,is_unlim,dimname) result (iret)
  integer, intent(in) :: ncid
  integer, intent(in) :: dimid
  character(*), optional, intent(out) :: dimname
  logical     , optional, intent(out) :: is_unlim
  integer     , optional, intent(out) :: dimlen
  integer :: iret
  
  integer :: unlimdimid

  if(present(dimname)) then
     __NF_TRY__(nf_inq_dimname(ncid,dimid,dimname),iret,7)
  end if
  if(present(is_unlim)) then
     __NF_TRY__(nf_inq_unlimdim(ncid,unlimdimid),iret,7)
     is_unlim = (dimid==unlimdimid)
  end if
  if(present(dimlen))then
     __NF_TRY__(nf_inq_dimlen(ncid,dimid,dimlen),iret,7)
  end if

7 return
end function

! ============================================================================
function inq_var_n(ncid, name, id, xtype, ndims, dimids, dimlens, natts, &
     is_dim, has_records, varsize, recsize, nrec) result(iret)
  integer :: iret
  integer, intent(in) :: ncid
  character(*),intent(in) :: name
  integer, intent(out), optional :: id
  integer, intent(out), optional :: xtype
  integer, intent(out), optional :: ndims
  integer, intent(out), optional :: dimids(:)
  integer, intent(out), optional :: dimlens(:)
  integer, intent(out), optional :: natts
  logical, intent(out), optional :: is_dim ! true if variable is a dimension variable
  logical, intent(out), optional :: has_records ! true if variable depends on record dimension
  integer, intent(out), optional :: varsize ! total size of the variable
  integer, intent(out), optional :: recsize ! size of a single record
  integer, intent(out), optional :: nrec    ! number of records

  integer :: vid
  character(len=NF_MAX_NAME) :: vname

  __NF_TRY__(nf_inq_varid(ncid,name,vid),iret,7)
  if(present(id)) id = vid
  iret = inq_var_i(ncid,vid,vname,xtype,ndims,dimids,dimlens,natts,&
       is_dim,has_records,varsize,recsize,nrec)

7 return  
end function

! ============================================================================
function inq_var_i(ncid, vid, name, xtype, ndims, dimids, dimlens,natts, &
     is_dim, has_records, varsize, recsize, nrec) result(iret)
  integer :: iret
  integer, intent(in) :: ncid
  integer, intent(in) :: vid
  character(*),intent(out), optional :: name
  integer, intent(out), optional :: xtype
  integer, intent(out), optional :: ndims
  integer, intent(out), optional :: dimids(:)
  integer, intent(out), optional :: dimlens(:)
  integer, intent(out), optional :: natts
  logical, intent(out), optional :: is_dim ! true if variable is a dimension variable
  logical, intent(out), optional :: has_records ! true if variable depends on record dimension
  integer, intent(out), optional :: varsize ! total size of the variable
  integer, intent(out), optional :: recsize ! size of a single record
  integer, intent(out), optional :: nrec    ! number of records

  integer :: vxtype, vndims, vdimids(NF_MAX_VAR_DIMS), vnatts
  integer :: vsize, vrecsize
  integer :: unlimdim, did, dlen, i
  character(len=NF_MAX_NAME) :: vname

  __NF_TRY__(nf_inq_var(ncid,vid,vname,vxtype,vndims,vdimids,vnatts),iret,7)
  if (present(name)) name = vname
  if (present(xtype)) xtype = vxtype
  if (present(ndims)) ndims = vndims
  if (present(dimids)) dimids(1:min(vndims,size(dimids))) = &
       vdimids(1:min(vndims,size(dimids)))
  if (present(natts)) natts = vnatts
  if (present(is_dim)) then
     is_dim = (nf_inq_dimid(ncid,vname,did)==NF_NOERR)
  endif
  __NF_TRY__(nf_inq_unlimdim(ncid,unlimdim),iret,7)
  if (present(has_records)) then
     has_records = ANY(vdimids(1:vndims)==unlimdim)
  endif
  if (present(varsize).or.present(recsize).or.present(dimlens)) then
     vsize = 1; vrecsize=1
     do i = 1,vndims
        __NF_TRY__(nf_inq_dimlen(ncid,vdimids(i),dlen),iret,7)
        vsize = vsize*dlen
        if(vdimids(i)/=unlimdim) vrecsize=vrecsize*dlen
        if(present(dimlens)) dimlens(i)=dlen
     enddo
     if(present(varsize)) varsize=vsize
     if(present(recsize)) recsize=vrecsize 
  endif
  if(present(nrec)) then
     nrec=1
     if(unlimdim/=-1.and.ANY(vdimids(1:vndims)==unlimdim)) then
        __NF_TRY__(nf_inq_dimlen(ncid,unlimdim,nrec),iret,7)
     endif
  endif

7 return  
end function

! ============================================================================
function inq_att_i_n(ncid, varid, att, xtype, len, attid) result (iret)
  integer     , intent(in) :: ncid
  integer     , intent(in) :: varid
  character(*), intent(in) :: att
  integer, optional, intent(out) :: xtype
  integer, optional, intent(out) :: len
  integer, optional, intent(out) :: attid
  integer :: iret

  integer :: xtype_, len_

  __NF_TRY__(nf_inq_att(ncid,varid,att,xtype_,len_),iret,7)
  if(present(attid)) then
     __NF_TRY__(nf_inq_attid(ncid,varid,att,attid),iret,7)
  endif
  if(present(xtype)) xtype = xtype_
  if(present(len))   len   = len_
  
7 return
end function

! ============================================================================
function inq_att_n_n(ncid, var, att, xtype, len, attid) result (iret)
  integer     , intent(in) :: ncid
  character(*), intent(in) :: var
  character(*), intent(in) :: att
  integer, optional, intent(out) :: xtype
  integer, optional, intent(out) :: len
  integer, optional, intent(out) :: attid
  integer :: iret


  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid,var,varid),iret,7)
  __NF_TRY__(inq_att_i_n(ncid,varid,att,xtype,len,attid),iret,7)
7 return
end function

! ============================================================================
function inq_att_i_i(ncid, varid, attid, xtype, len, name) result (iret)
  integer, intent(in) :: ncid
  integer, intent(in) :: varid
  integer, intent(in) :: attid
  integer, optional, intent(out) :: xtype
  integer, optional, intent(out) :: len
  character(*), optional, intent(out) :: name
  integer :: iret

  character(NF_MAX_NAME) :: name_

  __NF_TRY__(nf_inq_attname(ncid,varid,attid,name_),iret,7)
  __NF_TRY__(inq_att_i_n(ncid,varid,name_,xtype,len),iret,7)
  if(present(name)) name = name_
7 return
end function


! ============================================================================
function inq_att_n_i(ncid, var, attid, xtype, len, name) result (iret)
  integer, intent(in) :: ncid
  character(*) :: var
  integer, intent(in) :: attid
  integer, optional, intent(out) :: xtype
  integer, optional, intent(out) :: len
  character(*), optional, intent(out) :: name
  integer :: iret

  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid,var,varid),iret,7)
  __NF_TRY__(inq_att_i_i(ncid,varid,attid,xtype,len,name),iret,7)
7 return
end function

! ============================================================================
function nfu_def_dim(ncid,name,size,xtype,long_name,units,bounds,dimid,varid) &
     result (iret)
  integer         , intent(in) :: ncid  ! id of NetCDF file to create 
  character(len=*), intent(in) :: name  ! name of the dimension
  integer         , intent(in) :: size  ! size of the dimension
  integer,optional, intent(in) :: xtype ! external type of the associated variable
  character(len=*), intent(in), optional :: &
       long_name, &
       units,     &
       bounds
  integer,optional,intent(out) :: dimid,varid
  integer :: iret

  integer :: did,vid

  iret=nf_redef(ncid)

  did = -1; vid = -1
  __NF_TRY__(nf_def_dim(ncid,name,size,did),iret,7)
  if(present(xtype)) then
     __NF_TRY__(nf_def_var(ncid,name,xtype,1,(/did/),vid),iret,7)
     if (present(long_name)) then
        __NF_TRY__(nf_put_att_text(ncid,vid,'long_name',len(long_name),long_name),iret,7)
     endif
     if (present(units)) then
        __NF_TRY__(nf_put_att_text(ncid,vid,'units',len(units),units),iret,7)
     endif
     if (present(bounds)) then
        __NF_TRY__(nf_put_att_text(ncid,vid,'bounds',len(bounds),bounds),iret,7)
     endif
  endif
  if(present(dimid))dimid=did
  if(present(varid))varid=vid
7 return
end function

! ============================================================================
! define variable using its symbolic name and symbolic names of the dimensions
function nfu_def_var_0(ncid,name,xtype,dimc,dimv) result(iret)
  integer         , intent(in) :: ncid
  character(len=*), intent(in) :: name       ! name of the variable
  integer         , intent(in) :: xtype      ! external type of the var
  integer         , intent(in) :: dimc       ! number of dimensions
  character(len=*), intent(in) :: dimv(dimc) ! vector of dimension names 
  integer :: iret

  integer :: i,dimids(NF_MAX_VAR_DIMS),varid
  do i=1,dimc
     __NF_TRY__(nf_inq_dimid(ncid,dimv(i),dimids(i)),iret,7)
  enddo
  __NF_TRY__(nf_def_var(ncid,name,xtype,dimc,dimids,varid),iret,7)

7 return
end function


function nfu_def_var_1(ncid,name,xtype,dimv) result(iret)
  integer         , intent(in) :: ncid
  character(len=*), intent(in) :: name       ! name of the variable
  integer         , intent(in) :: xtype      ! external type of the var
  character(len=*), intent(in) :: dimv(:)    ! vector of dimension names 
  integer :: iret

  integer :: i,dimids(NF_MAX_VAR_DIMS),varid
  integer :: dimc

  dimc = size(dimv)
  do i=1,dimc
     __NF_TRY__(nf_inq_dimid(ncid,dimv(i),dimids(i)),iret,7)
  enddo
  __NF_TRY__(nf_def_var(ncid,name,xtype,dimc,dimids,varid),iret,7)

7 return
end function

! ===========================================================================
function clone_var_n(incid,vname,oncid,name) result(iret)
  integer :: iret ! return value
  integer      , intent(in) :: incid, oncid
  character*(*), intent(in) :: vname
  character*(*), intent(in), optional :: name

  integer :: varid
  __NF_TRY__(nf_inq_varid(incid,vname,varid),iret,7)
  __NF_TRY__(clone_var_i(incid,varid,oncid,name),iret,7)
7 return
end function

! ===========================================================================
function clone_var_i(incid,ivarid,oncid,name) result(iret)
  integer :: iret ! return value
  integer      , intent(in) :: incid, oncid
  integer      , intent(in) :: ivarid
  character*(*), intent(in), optional :: name
  
  character(len=NF_MAX_NAME) :: vname ! name of the var to be cloned
  character(len=NF_MAX_NAME) :: oname ! resulting name of the variable
  character(len=NF_MAX_NAME) :: str   ! name of the dimension or attribute 
  integer :: xtype,ndims,dimids(NF_MAX_VAR_DIMS),natts,i,ovarid

  ! get the info about variable to be cloned
  __NF_TRY__(nf_inq_var(incid,ivarid,vname,xtype,ndims,dimids,natts),iret,7)
  ! get respective dimension ids in output file
  do i = 1,ndims
     __NF_TRY__(nf_inq_dimname(incid,dimids(i),str),iret,7)
     __NF_TRY__(nf_inq_dimid(oncid,str,dimids(i)),iret,7)
  enddo
  ! set the name of the variable clone
  if (present(name)) then
     oname = name
  else
     oname = vname
  end if
  ! define clone variable
  __NF_TRY__(nf_def_var(oncid,oname,xtype,ndims,dimids,ovarid),iret,7)
  ! copy all attributes
  do i = 1,natts
     __NF_TRY__(nf_inq_attname(incid,ivarid,i,str),iret,7)
     __NF_TRY__(nf_copy_att(incid,ivarid,str,oncid,ovarid),iret,7)
  enddo
7 return
  ! note taht according to docs allocatable array is supposed to
  ! be deallocated on exit from procedure
end function

! ===========================================================================
function clone_dim_n(incid,iname,oncid,name) result(iret)
  integer :: iret
  integer, intent(in) :: incid,oncid
  character*(*),intent(in) :: iname
  character*(*),intent(in),optional :: name
  
  integer :: dimid
  
  __NF_TRY__(nf_inq_dimid(incid,iname,dimid),iret,7)
  iret = clone_dim_i(incid,dimid,oncid,name)
7 return  
end function

! ===========================================================================
function clone_dim_i(incid,dimid,oncid,name) result(iret)
  integer :: iret
  integer, intent(in) :: incid,dimid,oncid
  character*(*), intent(in), optional :: name ! name of the dimension copy
    
  character(len=NF_MAX_NAME) :: dname
  integer :: unlimid,len,newdimid,newlen,newunlimid

  ! get the name of the dimension
  __NF_TRY__(nf_inq_dim(incid,dimid,dname,len),iret,7)
  ! get the id of unlimited dimension in source file
  __NF_TRY__(nf_inq_unlimdim(incid,unlimid),iret,7)
  if(dimid==unlimid) len = NF_UNLIMITED
  ! if new output name is specified, replace the name of the input dim
  ! with it
  if(present(name)) dname = name
  ! check if the desired dimension already exists in the dest file
  if(nf_inq_dimid(oncid,dname,newdimid)==NF_NOERR) then
    ! dimension already exists in output file, make sure the size is the same,
    ! or both are unlimited dimensions
    __NF_TRY__(nf_inq_dimlen(oncid,newdimid,newlen),iret,7)
    __NF_TRY__(nf_inq_unlimdim(oncid,newunlimid),iret,7)
    
    if((dimid==unlimid).neqv.(newdimid==newunlimid)) then
       __NF_TRY__(nfu_elimunlim,iret,7)
    endif
    if(dimid/=unlimid.and.len/=newlen) then
       __NF_TRY__(nfu_ediffdimsize,iret,7)
    endif
  else
    __NF_TRY__(nf_def_dim(oncid,dname,len,newdimid),iret,7)
  endif
7 return  
end function

! ============================================================================
function copy_var_data_n(ncid,varname,ncid1,name) result (iret)
  integer :: iret
  integer     , intent(in) :: ncid
  character(*), intent(in) :: varname
  integer     , intent(in) :: ncid1
  character(*), intent(in), optional :: name ! name of output variable
  
  integer :: varid, varid1
  
  __NF_TRY__(nf_inq_varid(ncid,varname,varid),iret,7)
  if(present(name)) then
     __NF_TRY__(nf_inq_varid(ncid1,name,varid1),iret,7)
  else
     __NF_TRY__(nf_inq_varid(ncid1,varname,varid1),iret,7)
  endif
  
  __NF_TRY__(copy_var_data_i(ncid,varid,ncid1,varid1),iret,7)
7 continue
end function
  

function copy_var_data_i(ncid,varid,ncid1,varid1) result (iret)
  integer :: iret
  integer, intent(in) :: ncid,  varid
  integer, intent(in) :: ncid1, varid1
  
  integer :: recsize,nrec,rec
  real(kind=8), allocatable :: buffer(:)
  
  __NF_TRY__(nfu_inq_var(ncid,varid,recsize=recsize,nrec=nrec),iret,7)
  allocate(buffer(recsize))
  
  if(ncid/=ncid1.or.varid/=varid1) then
    do rec=1,nrec
       __NF_TRY__(nfu_get_rec_r8(ncid,varid,rec,buffer),iret,7)
       __NF_TRY__(nfu_put_rec_r8(ncid1,varid1,rec,buffer),iret,7)
    enddo
  endif

7 continue
  if (allocated(buffer)) deallocate(buffer)
end function


! ============================================================================
function nfu_get_var_r8(ncid,name,var) result(iret)
  integer :: iret ! return value
  integer, intent(in) :: ncid   ! id of netcdf data set
  character(*), intent(in)  :: name
  real(kind=8), intent(out) :: var(*) ! storage for the variable     [out]

  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid, name, varid), iret, 7)
  iret = nf_get_var_double(ncid,varid,var)
7 return
end function

function nfu_get_var_r4(ncid,name,var) result(iret)
  integer :: iret ! return value
  integer, intent(in) :: ncid   ! id of netcdf data set
  character(*), intent(in)  :: name
  real(kind=4), intent(out) :: var(*) ! storage for the variable     [out]

  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid, name, varid), iret, 7)
  iret = nf_get_var_real(ncid,varid,var)
7 return
end function

function nfu_get_var_int(ncid,name,var) result(iret)
  integer :: iret ! return value
  integer, intent(in) :: ncid   ! id of netcdf data set
  character(*), intent(in)  :: name
  integer     , intent(out) :: var(*) ! storage for the variable

  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid, name, varid), iret, 7)
  iret = nf_get_var_int(ncid,varid,var)
7 return
end function

! ============================================================================
function nfu_put_var_r8(ncid,name,var) result(iret)
  integer :: iret ! return value
  integer     , intent(in) :: ncid   ! id of netcdf data set
  character(*), intent(in) :: name
  real(kind=8), intent(in) :: var(*)

  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid, name, varid), iret, 7)
  iret = nf_put_var_double(ncid,varid,var)
7 return
end function

function nfu_put_var_r4(ncid,name,var) result(iret)
  integer :: iret ! return value
  integer     , intent(in) :: ncid   ! id of netcdf data set
  character(*), intent(in) :: name
  real(kind=4), intent(in) :: var(*)

  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid, name, varid), iret, 7)
  iret = nf_put_var_real(ncid,varid,var)
7 return
end function

function nfu_put_var_int(ncid,name,var) result(iret)
  integer :: iret ! return value
  integer     , intent(in) :: ncid   ! id of netcdf data set
  character(*), intent(in) :: name
  integer,      intent(in) :: var(*)

  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid, name, varid), iret, 7)
  iret = nf_put_var_int(ncid,varid,var)
7 return
end function

! ============================================================================
function get_r8_n_rec(ncid, name, rec, data) result(iret)
  integer :: iret
  integer     , intent(in)  :: ncid
  character(*), intent(in)  :: name
  integer     , intent(in)  :: rec
  real(kind=8), intent(out) :: data(*)

  integer :: varid
  
  __NF_TRY__(nf_inq_varid(ncid, name, varid), iret, 7)
  iret=get_r8_rec(ncid, varid, rec, data)
7 return

end function

! ============================================================================
function get_r4_n_rec(ncid, name, rec, data) result(iret)
  integer :: iret
  integer     , intent(in)  :: ncid
  character(*), intent(in)  :: name
  integer     , intent(in)  :: rec
  real(kind=4), intent(out) :: data(*)

  integer :: varid
  
  __NF_TRY__(nf_inq_varid(ncid, name, varid), iret, 7)
  iret=get_r4_rec(ncid, varid, rec, data)
7 return

end function

! ============================================================================
! reads double precision record from the file
function get_r8_rec(ncid, varid, rec, var) result(iret)
  integer :: iret
  integer, intent(in) :: ncid   ! id of netcdf data set
  integer, intent(in) :: varid  ! id of the variable           [in]
  integer, intent(in) :: rec       ! number of the record to get  [in]
  real(kind=8), intent(out) :: var(*) ! storage for the variable     [out]
 
  integer :: dimids(NF_MAX_VAR_DIMS), ndims, unlimdim
  integer :: start(NF_MAX_VAR_DIMS)
  integer :: count(NF_MAX_VAR_DIMS)
  integer :: i
      
  __NF_TRY__(nf_inq_unlimdim(ncid,unlimdim),iret,7)
  __NF_TRY__(nf_inq_varndims(ncid,varid,ndims),iret,7)
  __NF_TRY__(nf_inq_vardimid(ncid,varid,dimids),iret,7)

  do i = 1, ndims
     if (dimids(i).eq.unlimdim) then
        start(i) = rec
        count(i) = 1
     else
        start(i) = 1
        __NF_TRY__(nf_inq_dimlen(ncid,dimids(i),count(i)),iret,7)
     endif
     ! write(*,*) i, dimids(i), start(i), count(i)
  enddo
  iret = nf_get_vara_double(ncid,varid,start,count,var)

7 return
end function

! ============================================================================
! reads single precision record from the file
function get_r4_rec(ncid, varid, rec, var) result(iret)
  integer :: iret
  integer, intent(in) :: ncid   ! id of netcdf data set
  integer, intent(in) :: varid  ! id of the variable           [in]
  integer, intent(in) :: rec       ! number of the record to get  [in]
  real(kind=4), intent(out) :: var(*) ! storage for the variable     [out]
 
  integer :: dimids(NF_MAX_VAR_DIMS), ndims, unlimdim
  integer :: start(NF_MAX_VAR_DIMS)
  integer :: count(NF_MAX_VAR_DIMS)
  integer :: i
      
  __NF_TRY__(nf_inq_unlimdim(ncid,unlimdim),iret,7)
  __NF_TRY__(nf_inq_varndims(ncid,varid,ndims),iret,7)
  __NF_TRY__(nf_inq_vardimid(ncid,varid,dimids),iret,7)

  do i = 1, ndims
     if (dimids(i).eq.unlimdim) then
        start(i) = rec
        count(i) = 1
     else
        start(i) = 1
        __NF_TRY__(nf_inq_dimlen(ncid,dimids(i),count(i)),iret,7)
     endif
     ! write(*,*) i, dimids(i), start(i), count(i)
  enddo
  iret = nf_get_vara_real(ncid,varid,start,count,var)

7 return
end function

! ============================================================================
function put_r4_n_rec(ncid, name, rec, data) result(iret)
  integer :: iret
  integer, intent(in) :: ncid
  character(*), intent(in) :: name
  integer, intent(in) :: rec
  real(4), intent(in) :: data(*)

  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  iret = put_r4_rec(ncid, varid, rec, data)
7 return

end function

! ============================================================================
function put_r8_n_rec_2d(ncid, name, rec, data) result(iret)
  integer :: iret
  integer, intent(in) :: ncid
  character(*), intent(in) :: name
  integer, intent(in) :: rec
  real(8), intent(in) :: data(:,:)

  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  iret = put_r8_rec(ncid, varid, rec, data)
7 return

end function

! ============================================================================
function put_r8_n_rec_1d(ncid, name, rec, data) result(iret)
  integer :: iret
  integer, intent(in) :: ncid
  character(*), intent(in) :: name
  integer, intent(in) :: rec
  real(8), intent(in) :: data(*)

  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  iret = put_r8_rec(ncid, varid, rec, data)
7 return

end function

! ============================================================================
function put_r4_rec(ncid, varid, rec, data) result(iret)
  integer :: iret
  integer, intent(in) :: ncid
  integer, intent(in) :: varid
  integer, intent(in) :: rec
  real(4), intent(in) :: data(*)
      
  integer :: dimids(NF_MAX_VAR_DIMS), ndims
  integer :: unlimdim, unlimlen
  integer :: start(NF_MAX_VAR_DIMS)
  integer :: count(NF_MAX_VAR_DIMS)
  integer :: i
      
  __NF_TRY__(nf_inq_unlimdim(ncid,unlimdim),iret,7)
  __NF_TRY__(nf_inq_varndims(ncid,varid,ndims),iret,7)
  __NF_TRY__(nf_inq_vardimid(ncid,varid,dimids),iret,7)

  do i = 1, ndims
     if (dimids(i).eq.unlimdim) then
        start(i) = rec
        count(i) = 1
     else
        start(i) = 1
        __NF_TRY__(nf_inq_dimlen(ncid,dimids(i),count(i)),iret,7)
     endif
!          write(*,*) i, dimids(i), start(i), count(i)
  enddo
  iret = nf_put_vara_real(ncid,varid,start,count,data)
7 return
end function

! ============================================================================
function put_r8_rec(ncid, varid, rec, data) result(iret)
  integer :: iret
  integer, intent(in) :: ncid
  integer, intent(in) :: varid
  integer, intent(in) :: rec
  real(8), intent(in) :: data(*)
      
  integer :: dimids(NF_MAX_VAR_DIMS), ndims
  integer :: unlimdim, unlimlen
  integer :: start(NF_MAX_VAR_DIMS)
  integer :: count(NF_MAX_VAR_DIMS)
  integer :: i
      
  __NF_TRY__(nf_inq_unlimdim(ncid,unlimdim),iret,7)
  __NF_TRY__(nf_inq_varndims(ncid,varid,ndims),iret,7)
  __NF_TRY__(nf_inq_vardimid(ncid,varid,dimids),iret,7)

  do i = 1, ndims
     if (dimids(i).eq.unlimdim) then
        start(i) = rec
        count(i) = 1
     else
        start(i) = 1
        __NF_TRY__(nf_inq_dimlen(ncid,dimids(i),count(i)),iret,7)
     endif
!          write(*,*) i, dimids(i), start(i), count(i)
  enddo
  iret = nf_put_vara_double(ncid,varid,start,count,data)
7 return
end function

! ===========================================================================
function get_att_text(ncid, name, att, text) result(iret)
  integer :: iret
  integer, intent(in) :: ncid         ! id of the NetCDF file [in]
  character(*),intent(in) :: name   ! name of the variable  [in]
  character(*),intent(in) :: att    ! attribute name [in]
  character(*),intent(out) :: text   ! attribute value [out]
  
  integer :: varid

  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  iret = nf_get_att_text(ncid, varid, att, text)
      
7 return
end function

! ===========================================================================
function get_att_int(ncid, name, att, d) result(iret)
  integer :: iret
  integer, intent(in)      :: ncid   ! id of the NetCDF file [in]
  character(*),intent(in)  :: name   ! name of the variable  [in]
  character(*),intent(in)  :: att    ! attribute name [in]
  integer     ,intent(inout) :: d(:)   ! attribute value [out]
  
  integer :: varid,len
  integer, allocatable :: data(:)

  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  __NF_TRY__(nf_inq_attlen(ncid,varid,att,len),iret,7)
  allocate(data(len))
  iret = nf_get_att_int(ncid, varid, att, data)
  d(1:min(size(d),size(data))) = data(1:min(size(d),size(data)))
7 return
end function

! ===========================================================================
function get_att_r4(ncid, name, att, d) result(iret)
  integer :: iret
  integer, intent(in)      :: ncid   ! id of the NetCDF file [in]
  character(*),intent(in)  :: name   ! name of the variable  [in]
  character(*),intent(in)  :: att    ! attribute name [in]
  real(4)     ,intent(inout) :: d(:)   ! attribute value [out]
  
  integer :: varid,len
  real(4), allocatable :: data(:)

  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  __NF_TRY__(nf_inq_attlen(ncid,varid,att,len),iret,7)
  allocate(data(len))
  iret = nf_get_att_real(ncid, varid, att, data)
  d(1:min(size(d),size(data))) = data(1:min(size(d),size(data)))
7 return

end function

! ===========================================================================
function get_att_r8(ncid, name, att, d) result(iret)
  integer :: iret
  integer, intent(in)      :: ncid   ! id of the NetCDF file [in]
  character(*),intent(in)  :: name   ! name of the variable  [in]
  character(*),intent(in)  :: att    ! attribute name [in]
  real(8)     ,intent(out) :: d(:)   ! attribute value [out]
  
  integer :: varid,len
  real(8), allocatable :: data(:)

  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  __NF_TRY__(nf_inq_attlen(ncid,varid,att,len),iret,7)
  allocate(data(len))
  iret = nf_get_att_double(ncid, varid, att, data)
  d(1:min(size(d),size(data))) = data(1:min(size(d),size(data)))
7 return
end function


! ===========================================================================
function get_att_int_1(ncid, name, att, d) result(iret)
  integer :: iret
  integer, intent(in)      :: ncid   ! id of the NetCDF file [in]
  character(*),intent(in)  :: name   ! name of the variable  [in]
  character(*),intent(in)  :: att    ! attribute name [in]
  integer     ,intent(out) :: d    ! attribute value [out]

  integer :: data(1)

  iret = get_att_int(ncid,name,att,data)
  d = data(1)
end function

! ===========================================================================
function get_att_r4_1(ncid, name, att, d) result(iret)
  integer :: iret
  integer, intent(in)      :: ncid   ! id of the NetCDF file [in]
  character(*),intent(in)  :: name   ! name of the variable  [in]
  character(*),intent(in)  :: att    ! attribute name [in]
  real(4)     ,intent(out) :: d    ! attribute value [out]

  real(4) :: data(1)

  iret = get_att_r4(ncid,name,att,data)
  d = data(1)
end function

! ===========================================================================
function get_att_r8_1(ncid, name, att, d) result(iret)
  integer :: iret
  integer, intent(in)      :: ncid   ! id of the NetCDF file [in]
  character(*),intent(in)  :: name   ! name of the variable  [in]
  character(*),intent(in)  :: att    ! attribute name [in]
  real(8)     ,intent(out) :: d    ! attribute value [out]

  real(8) :: data(1)

  iret = get_att_r8(ncid,name,att,data)
  d = data(1)
end function


! ===========================================================================
function put_att_text(ncid,name,att,text) result(iret)
  integer :: iret
  integer      ,intent(in) :: ncid   ! id of the NetCDF file [in]
  character*(*),intent(in) :: name   ! name of the variable  [in]
  character*(*),intent(in) :: att    ! attribute name [in]
  character*(*),intent(in) :: text   ! text to put in attribute [in]
  
  integer :: varid
      
  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  iret = nf_put_att_text(ncid,varid,att,len(text),text)
      
7 return
end function

! ===========================================================================
function put_att_int(ncid,name,att,data) result(iret)
  integer :: iret
  integer      ,intent(in) :: ncid   ! id of the NetCDF file [in]
  character*(*),intent(in) :: name   ! name of the variable  [in]
  character*(*),intent(in) :: att    ! attribute name [in]
  integer      ,intent(in) :: data(:)! text to put in attribute [in]
  
  integer :: varid

  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  iret = nf_put_att_int(ncid,varid,att,NF_INT,size(data),data)
      
7 return
end function

! ===========================================================================
function put_att_r4(ncid,name,att,data) result(iret)
  integer :: iret
  integer      ,intent(in) :: ncid   ! id of the NetCDF file [in]
  character*(*),intent(in) :: name   ! name of the variable  [in]
  character*(*),intent(in) :: att    ! attribute name [in]
  real(4)      ,intent(in) :: data(:)! text to put in attribute [in]
  
  integer :: varid

  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  iret = nf_put_att_real(ncid,varid,att,NF_REAL,size(data),data)
      
7 return
end function

! ===========================================================================
function put_att_r8(ncid,name,att,data) result(iret)
  integer :: iret
  integer      ,intent(in) :: ncid   ! id of the NetCDF file [in]
  character*(*),intent(in) :: name   ! name of the variable  [in]
  character*(*),intent(in) :: att    ! attribute name [in]
  real(8)      ,intent(in) :: data(:)! text to put in attribute [in]
  
  integer :: varid

  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  iret = nf_put_att_double(ncid,varid,att,NF_DOUBLE,size(data),data)
      
7 return
end function

! ===========================================================================
function put_att_int_1(ncid,name,att,data) result(iret)
  integer :: iret
  integer      ,intent(in) :: ncid   ! id of the NetCDF file [in]
  character*(*),intent(in) :: name   ! name of the variable  [in]
  character*(*),intent(in) :: att    ! attribute name [in]
  integer      ,intent(in) :: data   ! text to put in attribute [in]
  
  integer :: varid

  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  iret = nf_put_att_int(ncid,varid,att,NF_INT,1,data)
      
7 return
end function

! ===========================================================================
function put_att_r4_1(ncid,name,att,data) result(iret)
  integer :: iret
  integer      ,intent(in) :: ncid   ! id of the NetCDF file [in]
  character*(*),intent(in) :: name   ! name of the variable  [in]
  character*(*),intent(in) :: att    ! attribute name [in]
  real(4)      ,intent(in) :: data   ! text to put in attribute [in]
  
  integer :: varid

  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  iret = nf_put_att_real(ncid,varid,att,NF_REAL,1,data)
      
7 return
end function

! ===========================================================================
function put_att_r8_1(ncid,name,att,data) result(iret)
  integer :: iret
  integer      ,intent(in) :: ncid   ! id of the NetCDF file [in]
  character*(*),intent(in) :: name   ! name of the variable  [in]
  character*(*),intent(in) :: att    ! attribute name [in]
  real(8)      ,intent(in) :: data   ! text to put in attribute [in]
  
  integer :: varid

  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  iret = nf_put_att_double(ncid,varid,att,NF_DOUBLE,1,data)
      
7 return
end function

! ===========================================================================
! appends specified text to the attribute
function append_att_text_n(ncid,var,att,data) result(iret)
  integer :: iret
  integer      ,intent(in) :: ncid   ! id of the NetCDF file [in]
  character*(*),intent(in) :: var  ! id of the variable  [in]
  character*(*),intent(in) :: att    ! attribute name [in]
  character*(*),intent(in) :: data   ! text to put in attribute [in]

  integer :: varid

  __NF_TRY__(nf_inq_varid(ncid,var,varid),iret,7)
  __NF_TRY__(append_att_text_i(ncid,varid,att,data),iret,7)
7 return
end function

! ===========================================================================
! appends specified text to the attribute
function append_att_text_i(ncid,varid,att,data) result(iret)
  integer :: iret
  integer      ,intent(in) :: ncid   ! id of the NetCDF file [in]
  integer      ,intent(in) :: varid  ! id of the variable  [in]
  character*(*),intent(in) :: att    ! attribute name [in]
  character*(*),intent(in) :: data   ! text to put in attribute [in]

  integer :: i,n ! original length of the attribute
  character, allocatable :: text(:)

  if(nf_inq_attlen(ncid,varid,att,n)/=NF_NOERR)then
     iret = nf_put_att_text(ncid,varid,att,len(data),data)
  else
     allocate(text(n+len(data)))
     __NF_TRY__(nf_get_att_text(ncid,varid,att,text),iret,7)
     ! erase trailing zero byte (normally appended by C), if necessary
     if(text(n)==char(0))n = n-1
     ! is there a better way to copy string to array of chars?
     ! or, even better, to allocate a string of specified length?
     do i = 1,len(data)
        text(n+i) = data(i:i)
     enddo
     __NF_TRY__(nf_put_att_text(ncid,varid,att,n+len(data),text),iret,7)
  endif
7 return
end function

! ===========================================================================
function nfu_copy_att(incid,iname,oncid,oname,aname) result(iret)
  integer :: iret
  integer, intent(in) :: incid,oncid
  character*(*), intent(in) :: iname,oname
  character*(*), intent(in) :: aname

  integer :: ivarid,ovarid

  __NF_TRY__(nf_inq_varid(incid,iname,ivarid),iret,7)
  __NF_TRY__(nf_inq_varid(oncid,oname,ovarid),iret,7)
  __NF_TRY__(nf_copy_att(incid,ivarid,aname,oncid,ovarid),iret,7)
7 return
end function

! ========================================================================
! based on presence/absence of attributes, defines valid range or missing 
! value. For details, see section 8.1 of NetCDF User Guide
function nfu_get_valid_range(ncid, name, v) result (iret)
  integer     , intent(in) :: ncid
  character(*), intent(in) :: name
  type(validtype),intent(out) :: v ! validator

  integer :: iret
  
  integer :: var_T, valid_T, scale_T, T ! types variable and of attributes
  real(kind=8) :: scale, offset, fill, r(2)
  
  ! find the type of the variable
  __NF_TRY__(nfu_inq_var(ncid,name,xtype=var_T),iret,7)

  ! find the widest type of scale and offset; note that the code
  ! uses assumption that NetCDF types are arranged in th order of rank,
  ! that is NF_BYTE < NF_CHAR < NF_SHORT < NF_INT < NF_FLOAT < NF_DOUBLE
  scale = 1; offset = 0;
  scale_T = 0
  if(nfu_inq_att(ncid,name,'scale_factor',xtype=T)==NF_NOERR) then
     __NF_TRY__(nfu_get_att(ncid,name,'scale_factor',scale),iret,7)
     scale_T = T
  endif
  if(nfu_inq_att(ncid,name,'add_offset',xtype=T)==NF_NOERR) then
     __NF_TRY__(nfu_get_att(ncid,name,'add_offset',offset),iret,7)
     scale_T = max(scale_T,T)
  endif
     
  ! examine possible range attributes
  valid_T = 0; v%hasmax=.false. ; v%hasmin=.false.
  if (nfu_inq_att(ncid,name,'valid_range',xtype=T)==NF_NOERR) then
     __NF_TRY__(nfu_get_att(ncid,name,'valid_range',r),iret,7)
     v%min = r(1)      ; v%max = r(2)
     v%hasmax = .true. ; v%hasmin = .true.
     valid_T = max(valid_T,T)
  else if(nfu_inq_att(ncid,name,'valid_max',xtype=T)==NF_NOERR) then
     __NF_TRY__(nfu_get_att(ncid,name,'valid_max',v%max),iret,7)
     v%hasmax = .true.
     valid_T = max(valid_T,T)
  else if(nfu_inq_att(ncid,name,'valid_min',xtype=T)==NF_NOERR) then
     __NF_TRY__(nfu_get_att(ncid,name,'valid_min',v%min),iret,7)
     v%hasmin = .true.
     valid_T = max(valid_T,T)
  else if(nfu_inq_att(ncid,name,'missing_value',xtype=T)==NF_NOERR) then
     ! here we always scale, since missing_value is supposed to be in 
     ! external representation
     __NF_TRY__(nfu_get_att(ncid,name,'missing_value',v%min),iret,7)
     v%min = v%min*scale + offset
  else
     ! as a last resort, define range based on _FillValue
     ! get fill value and its type: from var, from file, or default
     if(nfu_get_att(ncid,name,'_FillValue',fill)/=NF_NOERR) then
        if(nf_get_att_double(ncid,NF_GLOBAL,'_FillValue',fill)/=NF_NOERR) then
           select case(var_T)
           case(NF_CHAR)
              fill = NF_FILL_CHAR
           case(NF_BYTE)
              fill = NF_FILL_BYTE
           case(NF_SHORT)
              fill = NF_FILL_SHORT
           case(NF_INT)
              fill = NF_FILL_INT
           case(NF_REAL)
              fill = NF_FILL_REAL
           case(NF_DOUBLE)
              fill = NF_FILL_DOUBLE
           end select
        endif
     endif
     if(fill>0) then
        ! if _FillValue is positive, then it defines valid maximum
        v%hasmax = .true.
        v%max = fill
        select case(T)
        case (NF_BYTE,NF_CHAR,NF_SHORT,NF_INT)
           v%max = v%max-1
        case (NF_FLOAT)
           v%max = nearest(nearest(real(v%max,4),-1.0),-1.0)
        case (NF_DOUBLE)
           v%max = nearest(nearest(real(v%max,8),-1.0),-1.0)
        end select
     else
        ! if _FillValue is negative or zero, then it defines valid minimum
        v%hasmin = .true.
        v%min = fill
        select case(T)
        case (NF_BYTE,NF_CHAR,NF_SHORT,NF_INT)
           v%min = v%min+1
        case (NF_FLOAT)
           v%min = nearest(nearest(real(v%min,4),+1.0),+1.0)
        case (NF_DOUBLE)
           v%min = nearest(nearest(real(v%min,8),+1.0),+1.0)
        end select
     endif
     ! NOTE: if we go through _FillValue branch, valid_T is 0, so values
     ! are always scaled, as it should be because _FillValue is in external 
     ! representation
  endif
  ! If valid_range is the same type as scale_factor (actually the wider of
  ! scale_factor and add_offset) and this is wider than the external data, then it
  ! will be interpreted as being in the units of the internal (unpacked) data.
  ! Otherwise it is in the units of the external (packed) data.
  if(.not.((valid_T == scale_T).and.(scale_T>var_T))) then
     v%min = v%min*scale + offset
     v%max = v%max*scale + offset
  endif
7 return
end function
   
! ========================================================================
elemental function is_valid(x, v) result (lret)
  real           , intent(in) :: x ! real value to be examined
  type(validtype), intent(in) :: v ! validator
  logical :: lret

!  if (x is NaN) then
!     lret = .false.
!  else 
  if (v%hasmin.or.v%hasmax) then
     lret = ((.not.v%hasmin).or.v%min<=x).and.((.not.v%hasmax).or.x<=v%max)
  else
     lret = x/=v%min
  endif
end function

! ===========================================================================
subroutine nfu_check_err(code,file,line)
  integer      , intent(in) :: code  ! error code
  character*(*), intent(in) :: file  ! file name
  integer      , intent(in) :: line  ! line number

  call cdfe(code,file,line,1)
  if(code/=NF_NOERR) call exit(code)

end subroutine

! ===========================================================================
! prints error message
subroutine cdfe(code, file, line, verb)
  integer      , intent(in) :: code  ! error code
  character*(*), intent(in) :: file  ! file name
  integer      , intent(in) :: line  ! line number
  integer      , intent(in) :: verb  ! verbosity level
      
  if((code/=NF_NOERR).and.(verb>0)) then
     write(*,'("File ",a," ; Line ",i5," # ",a)') file,line,nfu_strerror(code)
!     write(*,*) file,line,nfu_strerror(code)
  endif
end subroutine

function nfu_strerror(code) result(string)
  character*(80) :: string
  integer, intent(in) :: code

  select case (code)
  case (nfu_ediffdimsize)
     string = 'dimension already exists and has different size'
  case (nfu_elimunlim)
     string = 'dimension already exists and has different UNLIMITED status'
  case default
     string = nf_strerror(code)
  end select
end function


end module nfu_mod

module spherical_mod

!Balaji: parallel spectral model using transpose method
!initialize spherical operates on global domain
!all other operators attempt to detect whether argument is global (0:M,0:N)
!                                                       or local (ms:me,ns:ne)

use       fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, &
                         write_version_number

use  spec_mpp_mod, only: get_spec_domain

!-------------------------------------------------------------------------
!   provides operations on spectral spherical harmonics fields that do not 
!      require transforms
!
!   spectral fields are complex with horizontal dimensions
!        (0:num_fourier,0:num_spherical)
!       where the zonal wavenumber of (m,n) is M = m*fourier_inc
!             the "meridional" wavenumber is n
!             the "total", 2D, spherical wavenumber L = M+n
!
!-----------------------------------------------------------------------

implicit none
private

character(len=128), parameter :: version = '$Id: spherical.F90,v 13.0 2006/03/28 21:18:30 fms Exp $'
character(len=128), parameter :: tagname ='$Name: tikal $'

interface compute_lon_deriv_cos
   module procedure compute_lon_deriv_cos_2d,  &
                    compute_lon_deriv_cos_3d
end interface

interface compute_lat_deriv_cos
   module procedure compute_lat_deriv_cos_2d,  &
                    compute_lat_deriv_cos_3d
end interface

interface compute_gradient_cos
   module procedure compute_gradient_cos_2d,  &
                    compute_gradient_cos_3d
end interface

interface compute_laplacian
   module procedure compute_laplacian_2d,  &
                    compute_laplacian_3d
end interface

interface compute_ucos_vcos
   module procedure compute_ucos_vcos_2d,  &
                    compute_ucos_vcos_3d
end interface

interface compute_vor_div
   module procedure compute_vor_div_2d,  &
                    compute_vor_div_3d
end interface

interface compute_vor
   module procedure compute_vor_2d,  &
                    compute_vor_3d
end interface

interface compute_div
   module procedure compute_div_2d,  &
                    compute_div_3d
end interface

interface compute_alpha_operator
   module procedure compute_alpha_operator_2d,  &
                    compute_alpha_operator_3d
end interface

interface triangular_truncation
   module procedure triangular_truncation_2d,  &
                    triangular_truncation_3d
end interface

interface rhomboidal_truncation
   module procedure rhomboidal_truncation_2d,  &
                    rhomboidal_truncation_3d
end interface

public :: spherical_init, spherical_end
public :: compute_lon_deriv_cos, compute_lat_deriv_cos
public :: compute_laplacian, compute_vor, compute_div
public :: get_spherical_wave, get_fourier_wave
public :: get_eigen_laplacian, compute_gradient_cos
public :: compute_ucos_vcos, compute_vor_div
public :: triangular_truncation, rhomboidal_truncation

real,    allocatable, dimension(:,:) :: eigen_laplacian, epsilon, r_epsilon
integer, allocatable, dimension(:,:) :: fourier_wave, spherical_wave

integer :: fourier_max, fourier_inc, num_fourier, num_spherical
integer :: ms, me, ns, ne
logical :: module_is_initialized = .false.

real, allocatable, dimension(:,:) :: coef_uvm
real, allocatable, dimension(:,:) :: coef_uvc
real, allocatable, dimension(:,:) :: coef_uvp
real, allocatable, dimension(:,:) :: coef_alpm
real, allocatable, dimension(:,:) :: coef_alpp
real, allocatable, dimension(:,:) :: coef_dym
real, allocatable, dimension(:,:) :: coef_dx
real, allocatable, dimension(:,:) :: coef_dyp
real, allocatable, dimension(:,:) :: triangle_mask

contains

!--------------------------------------------------------------------------
subroutine spherical_init(radius, num_fourier_in, fourier_inc_in, num_spherical_in)

real,    intent(in) :: radius
integer, intent(in) :: num_fourier_in, fourier_inc_in, num_spherical_in

integer :: m,n

if(module_is_initialized) return

call write_version_number(version, tagname)

call get_spec_domain(ms, me, ns, ne)

num_fourier = num_fourier_in
fourier_inc = fourier_inc_in
fourier_max = fourier_inc*num_fourier
num_spherical = num_spherical_in

allocate(eigen_laplacian(0:num_fourier,0:num_spherical))
allocate(epsilon        (0:num_fourier,0:num_spherical))
allocate(r_epsilon      (0:num_fourier,0:num_spherical))
allocate(fourier_wave   (0:num_fourier,0:num_spherical))
allocate(spherical_wave (0:num_fourier,0:num_spherical))
allocate(coef_uvm       (0:num_fourier,0:num_spherical))
allocate(coef_uvc       (0:num_fourier,0:num_spherical))
allocate(coef_uvp       (0:num_fourier,0:num_spherical))
allocate(coef_alpm      (0:num_fourier,0:num_spherical))
allocate(coef_alpp      (0:num_fourier,0:num_spherical))
allocate(coef_dym       (0:num_fourier,0:num_spherical))
allocate(coef_dx        (0:num_fourier,0:num_spherical))
allocate(coef_dyp       (0:num_fourier,0:num_spherical))
allocate(triangle_mask  (0:num_fourier,0:num_spherical))

module_is_initialized = .true.

triangle_mask = 1.0
do n=0,num_spherical
  do m=0,num_fourier
    fourier_wave(m,n)   = m*fourier_inc
    spherical_wave(m,n) = fourier_wave(m,n) + n
    if(spherical_wave(m,n).gt.num_spherical-1) triangle_mask(m,n) = 0.0
  end do
end do

epsilon= (spherical_wave**2 - fourier_wave**2)/(4.0*spherical_wave**2 - 1.0)
epsilon = sqrt(epsilon)

eigen_laplacian = spherical_wave*(spherical_wave + 1.0)/(radius*radius)

where (spherical_wave > 0) 
  coef_uvm = -radius*epsilon/spherical_wave
  coef_uvc = -radius*fourier_wave/(spherical_wave*(spherical_wave + 1.0))
else where 
  coef_uvm = 0.0
  coef_uvc = 0.0
end where

coef_uvp(:,0:num_spherical-1) =    &
    -radius*epsilon(:,1:num_spherical)/   &
     (spherical_wave(:,0:num_spherical-1) +1.0)

coef_alpm= (spherical_wave + 1.0)*epsilon/radius
coef_alpp(:,0:num_spherical-1) =    &
     spherical_wave(:,0:num_spherical-1)*epsilon(:,1:num_spherical)/radius

coef_dym = (spherical_wave - 1.0)*epsilon/radius
coef_dx = float(fourier_wave)/radius
coef_dyp(:,0:num_spherical-1) =                                           &
  (spherical_wave(:,0:num_spherical-1) + 2.0)*epsilon(:,1:num_spherical)/radius

return
end subroutine spherical_init

!---------------------------------------------------------------------------
subroutine get_spherical_wave(spherical_wave_out)
!---------------------------------------------------------------------------

integer, intent(out), dimension (:,:) :: spherical_wave_out

if( size(spherical_wave_out,1).EQ.num_fourier+1 .AND. size(spherical_wave_out,2).EQ.num_spherical+1 )then
    spherical_wave_out = spherical_wave
else if( size(spherical_wave_out,1).EQ.me-ms+1 .AND. size(spherical_wave_out,2).EQ.ne-ns+1 )then
    spherical_wave_out = spherical_wave(ms:me,ns:ne)
else
    call error_mesg( 'get_spherical_wave', 'invalid argument size', FATAL )
endif

return 
end subroutine get_spherical_wave

!---------------------------------------------------------------------------
subroutine get_fourier_wave(fourier_wave_out)
!---------------------------------------------------------------------------

integer, intent(out), dimension (:,:) :: fourier_wave_out

if( size(fourier_wave_out,1).EQ.num_fourier+1 .AND. size(fourier_wave_out,2).EQ.num_spherical+1 )then
    fourier_wave_out = fourier_wave
else if( size(fourier_wave_out,1).EQ.me-ms+1 .AND. size(fourier_wave_out,2).EQ.ne-ns+1 )then
    fourier_wave_out = fourier_wave(ms:me,ns:ne)
else
    call error_mesg( 'get_fourier_wave', 'invalid argument size', FATAL )
endif

return
end subroutine get_fourier_wave

!---------------------------------------------------------------------------
subroutine get_eigen_laplacian(eigen_laplacian_out)
!---------------------------------------------------------------------------

real, intent(out), dimension (:,:) :: eigen_laplacian_out

if( size(eigen_laplacian_out,1).EQ.num_fourier+1 .AND. size(eigen_laplacian_out,2).EQ.num_spherical+1 )then
    eigen_laplacian_out = eigen_laplacian
else if( size(eigen_laplacian_out,1).EQ.me-ms+1 .AND. size(eigen_laplacian_out,2).EQ.ne-ns+1 )then
    eigen_laplacian_out = eigen_laplacian(ms:me,ns:ne)
else
    call error_mesg( 'get_eigen_laplacian', 'invalid argument size', FATAL )
endif

return
end subroutine get_eigen_laplacian

!---------------------------------------------------------------------------
function compute_lon_deriv_cos_3d(spherical) result(deriv_lon)
!---------------------------------------------------------------------------

complex, intent(in), dimension (:,:,:) :: spherical
complex, dimension (size(spherical,1), size(spherical,2), size(spherical,3)) :: deriv_lon

integer :: k

if(.not. module_is_initialized ) then
  call error_mesg('compute_lon_deriv','module spherical not initialized', FATAL)
end if

if( size(spherical,1).EQ.num_fourier+1 .AND. size(spherical,2).EQ.num_spherical+1 )then
    do k=1,size(spherical,3)
       deriv_lon(:,:,k) = coef_dx(:,:)*cmplx(-aimag(spherical(:,:,k)),real(spherical(:,:,k)))
    end do
else if( size(spherical,1).EQ.me-ms+1 .AND. size(spherical,2).EQ.ne-ns+1 )then
    do k=1,size(spherical,3)
       deriv_lon(:,:,k) = coef_dx(ms:me,ns:ne)*cmplx(-aimag(spherical(:,:,k)),real(spherical(:,:,k)))
    end do
else
    call error_mesg( 'compute_lon_deriv_cos_3d', 'invalid argument size', FATAL )
endif

return
end function compute_lon_deriv_cos_3d

!--------------------------------------------------------------------------
function compute_lat_deriv_cos_3d(spherical) result(deriv_lat)
!--------------------------------------------------------------------------

complex, intent(in), dimension (:,0:,:) :: spherical
complex, dimension (size(spherical,1), 0:size(spherical,2)-1, size(spherical,3)) :: deriv_lat

integer :: k

if(.not. module_is_initialized ) then
  call error_mesg('compute_lat_deriv','module spherical not initialized', FATAL)
end if

if( size(spherical,2).EQ.num_spherical+1 )then
!could be global domain, or only global in N
    if( size(spherical,1).EQ.num_fourier+1 )then
        deriv_lat(:,0,:) = cmplx(0.,0.)
        do k=1,size(spherical,3)
           deriv_lat(:,1:num_spherical,k) = &  
                - spherical(:,0:num_spherical-1,k)*coef_dym(:,1:num_spherical)
           deriv_lat(:,0:num_spherical-1,k) =  deriv_lat(:,0:num_spherical-1,k)   &
                + spherical(:,1:num_spherical,k)*coef_dyp(:,0:num_spherical-1)
        end do
    else if( size(spherical,1).EQ.me-ms+1 )then
        deriv_lat(:,0,:) = cmplx(0.,0.)
        do k=1,size(spherical,3)
           deriv_lat(:,1:num_spherical,k) = &  
                - spherical(:,0:num_spherical-1,k)*coef_dym(ms:me,1:num_spherical)
           deriv_lat(:,0:num_spherical-1,k) =  deriv_lat(:,0:num_spherical-1,k)   &
                + spherical(:,1:num_spherical,k)*coef_dyp(ms:me,0:num_spherical-1)
        end do
    endif
else if( size(spherical,1).EQ.me-ms+1 .AND. size(spherical,2).EQ.ne-ns+1 )then
!need to write stuff to acquire data at ns-1,ne+1
    call abort()
else
    call error_mesg( 'compute_lat_deriv_cos_3d', 'invalid argument size', FATAL )
endif

return
end function compute_lat_deriv_cos_3d

!-------------------------------------------------------------------
subroutine compute_gradient_cos_3d(spherical, deriv_lon, deriv_lat) 
!-------------------------------------------------------------------

complex, intent(in), dimension (:,:,:) :: spherical
complex, intent(out), dimension (:,:,:) :: deriv_lat
complex, intent(out), dimension (:,:,:) :: deriv_lon

deriv_lon = compute_lon_deriv_cos(spherical)
deriv_lat = compute_lat_deriv_cos(spherical)

return
end subroutine compute_gradient_cos_3d

!----------------------------------------------------------------------
function compute_laplacian_3d(spherical, power) result(laplacian)
!----------------------------------------------------------------------

  complex, intent(in), dimension (:,:,:) :: spherical
  integer, optional :: power

  complex, dimension (size(spherical,1), size(spherical,2), size(spherical,3)) :: laplacian

  integer :: k
  real, dimension(size(spherical,1), size(spherical,2)) :: factor

  if(.not. module_is_initialized ) then
      call error_mesg('compute_laplacian','module spherical not initialized', FATAL)
  end if

  if( size(spherical,1).EQ.num_fourier+1 .AND. size(spherical,2).EQ.num_spherical+1 )then
      if(present(power)) then 
          if(power >= 0) then
              factor = (-eigen_laplacian)**power
          else 
              where (eigen_laplacian .ne. 0.0) 
                  factor = (-eigen_laplacian)**power
              else where
                  factor = 0.0
              end where
          end if
      else
          factor = -eigen_laplacian
      end if
  else if( size(spherical,1).EQ.me-ms+1 .AND. size(spherical,2).EQ.ne-ns+1 )then
      if(present(power)) then 
          if(power >= 0) then
              factor = (-eigen_laplacian(ms:me,ns:ne))**power
          else 
              where (eigen_laplacian(ms:me,ns:ne) .ne. 0.0) 
                  factor = (-eigen_laplacian(ms:me,ns:ne))**power
              else where
                  factor = 0.0
              end where
          end if
      else
          factor = -eigen_laplacian(ms:me,ns:ne)
      end if
  else
      call error_mesg( 'compute_laplacian', 'invalid argument size', FATAL )
  endif

  do k= 1,size(spherical,3)
     laplacian(:,:,k) = spherical(:,:,k)*factor
  end do

  return
end function compute_laplacian_3d

!----------------------------------------------------------------------
subroutine compute_ucos_vcos_3d(vorticity , divergence, u_cos, v_cos)
!----------------------------------------------------------------------

complex, intent(in), dimension (:,0:,:) :: vorticity
complex, intent(in), dimension (:,0:,:) :: divergence
complex, intent(out), dimension (:,0:,:) :: u_cos
complex, intent(out), dimension (:,0:,:) :: v_cos


integer :: k

if(.not. module_is_initialized ) then
  call error_mesg('compute_ucos_vcos','module spherical not initialized', FATAL)
end if

if( size(vorticity,2).EQ.num_spherical+1 )then
!could be global domain, or only global in N
    if( size(vorticity,1).EQ.num_fourier+1 )then
        do k=1,size(vorticity,3)
           u_cos(:,:,k) = coef_uvc(:,:)*                                     &
                cmplx(-aimag(divergence(:,:,k)),real(divergence(:,:,k)))
           v_cos(:,:,k) = coef_uvc(:,:)*                                     &
                cmplx(-aimag(vorticity(:,:,k)),real(vorticity(:,:,k)))

           u_cos(:,1:num_spherical,k) = u_cos(:,1:num_spherical,k) +         &
                coef_uvm(:,1:num_spherical)*vorticity(:,0:num_spherical-1,k)
           v_cos(:,1:num_spherical,k) = v_cos(:,1:num_spherical,k) -         &
                coef_uvm(:,1:num_spherical)*divergence(:,0:num_spherical-1,k)

           u_cos(:,0:num_spherical-1,k) = u_cos(:,0:num_spherical-1,k) -     &
                coef_uvp(:,0:num_spherical-1)*vorticity(:,1:num_spherical,k)
           v_cos(:,0:num_spherical-1,k) = v_cos(:,0:num_spherical-1,k) +     &
                coef_uvp(:,0:num_spherical-1)*divergence(:,1:num_spherical,k)         
        end do
    else if( size(vorticity,1).EQ.me-ms+1 )then
        do k=1,size(vorticity,3)
           u_cos(:,:,k) = coef_uvc(ms:me,:)*                                     &
                cmplx(-aimag(divergence(:,:,k)),real(divergence(:,:,k)))
           v_cos(:,:,k) = coef_uvc(ms:me,:)*                                     &
                cmplx(-aimag(vorticity(:,:,k)),real(vorticity(:,:,k)))

           u_cos(:,1:num_spherical,k) = u_cos(:,1:num_spherical,k) +         &
                coef_uvm(ms:me,1:num_spherical)*vorticity(:,0:num_spherical-1,k)
           v_cos(:,1:num_spherical,k) = v_cos(:,1:num_spherical,k) -         &
                coef_uvm(ms:me,1:num_spherical)*divergence(:,0:num_spherical-1,k)

           u_cos(:,0:num_spherical-1,k) = u_cos(:,0:num_spherical-1,k) -     &
                coef_uvp(ms:me,0:num_spherical-1)*vorticity(:,1:num_spherical,k)
           v_cos(:,0:num_spherical-1,k) = v_cos(:,0:num_spherical-1,k) +     &
                coef_uvp(ms:me,0:num_spherical-1)*divergence(:,1:num_spherical,k)         
        end do
    endif
else if( size(vorticity,1).EQ.me-ms+1 .AND. size(vorticity,2).EQ.ne-ns+1 )then
!need to write stuff to acquire data at ns-1,ne+1
    call abort()
else
    call error_mesg( 'compute_ucos_vcos', 'invalid argument size', FATAL )
endif

return
end subroutine compute_ucos_vcos_3d

!-------------------------------------------------------------------------
subroutine compute_vor_div_3d(u_cos, v_cos, vorticity, divergence)
!-------------------------------------------------------------------------

complex, intent(in), dimension (:,:,:) :: u_cos
complex, intent(in), dimension (:,:,:) :: v_cos
complex, intent(out), dimension (:,:,:) :: vorticity
complex, intent(out), dimension (:,:,:) :: divergence

vorticity  = compute_alpha_operator(v_cos, u_cos, -1)
divergence = compute_alpha_operator(u_cos, v_cos, +1)

return
end subroutine compute_vor_div_3d

!-------------------------------------------------------------------------
function compute_vor_3d(u_cos, v_cos) result(vorticity)
!-------------------------------------------------------------------------

complex, intent(in), dimension (:,:,:) :: u_cos
complex, intent(in), dimension (:,:,:) :: v_cos
complex, dimension (size(u_cos,1), size(u_cos,2), size(u_cos,3)) :: vorticity

vorticity = compute_alpha_operator(v_cos, u_cos, -1)

return
end function compute_vor_3d

!-------------------------------------------------------------------------
function compute_div_3d(u_cos, v_cos) result(divergence)
!-------------------------------------------------------------------------

complex, intent(in), dimension (:,:,:) :: u_cos
complex, intent(in), dimension (:,:,:) :: v_cos
complex, dimension (size(u_cos,1), size(u_cos,2), size(u_cos,3)) :: divergence

divergence = compute_alpha_operator(u_cos, v_cos, +1)

return
end function compute_div_3d

!--------------------------------------------------------------------------------
function compute_alpha_operator_3d(spherical_a, spherical_b, isign) result(alpha)
!--------------------------------------------------------------------------------

complex, intent(in), dimension (:,0:,:) :: spherical_a
complex, intent(in), dimension (:,0:,:) :: spherical_b
integer,intent(in) :: isign

complex, dimension (size(spherical_a,1), 0:size(spherical_a,2)-1, size(spherical_a,3)) :: alpha

integer :: k

if(.not. module_is_initialized ) then
  call error_mesg('compute_vor or div','module spherical not initialized', FATAL)
end if

alpha = cmplx(0.,0.)

if( size(spherical_a,2).EQ.num_spherical+1 )then
!could be global domain, or only global in N
    if( size(spherical_a,1).EQ.num_fourier+1 )then
        do k=1,size(spherical_a,3)
           alpha(:,:,k) = coef_dx(:,:)*    &
                cmplx(-aimag(spherical_a(:,:,k)),real(spherical_a(:,:,k)))
           alpha(:,1:num_spherical,k) = alpha(:,1:num_spherical,k) -  &
                isign*coef_alpm(:,1:num_spherical)  &
                *spherical_b(:,0:num_spherical-1,k)
           alpha(:,0:num_spherical-1,k) = alpha(:,0:num_spherical-1,k) +  &
                isign*coef_alpp(:,0:num_spherical-1)*spherical_b(:,1:num_spherical,k)
        end do
    else if( size(spherical_a,1).EQ.me-ms+1 )then
        do k=1,size(spherical_a,3)
           alpha(:,:,k) = coef_dx(ms:me,:)*    &
                cmplx(-aimag(spherical_a(:,:,k)),real(spherical_a(:,:,k)))
           alpha(:,1:num_spherical,k) = alpha(:,1:num_spherical,k) -  &
                isign*coef_alpm(ms:me,1:num_spherical)  &
                *spherical_b(:,0:num_spherical-1,k)
           alpha(:,0:num_spherical-1,k) = alpha(:,0:num_spherical-1,k) +  &
                isign*coef_alpp(ms:me,0:num_spherical-1)*spherical_b(:,1:num_spherical,k)
        end do
    endif
else if( size(spherical_a,1).EQ.me-ms+1 .AND. size(spherical_a,2).EQ.ne-ns+1 )then
!need to write stuff to acquire data at ns-1,ne+1
    call abort()
else
    call error_mesg( 'compute_alpha_operator_3d', 'invalid argument size', FATAL )
endif

return
end function compute_alpha_operator_3d

!-----------------------------------------------------------------------
subroutine triangular_truncation_3d(spherical, trunc)
!-----------------------------------------------------------------------

complex, intent(inout), dimension (:,:,:) :: spherical
integer, intent(in), optional :: trunc
integer :: k

if( size(spherical,1).EQ.num_fourier+1 .AND. size(spherical,2).EQ.num_spherical+1 )then
    if(present(trunc)) then
        do k=1, size(spherical,3)
           where (spherical_wave > trunc)
               spherical(:,:,k) = cmplx(0.,0.)
           end where
        end do
    else
        do k=1, size(spherical,3)
           spherical(:,:,k) = spherical(:,:,k)*triangle_mask
        end do
    end if
else if( size(spherical,1).EQ.me-ms+1 .AND. size(spherical,2).EQ.ne-ns+1 )then
    if(present(trunc)) then
        do k=1, size(spherical,3)
           where (spherical_wave(ms:me,ns:ne) > trunc)
               spherical(:,:,k) = cmplx(0.,0.)
           end where
        end do
    else
        do k=1, size(spherical,3)
           spherical(:,:,k) = spherical(:,:,k)*triangle_mask(ms:me,ns:ne)
        end do
    end if
else
    call error_mesg( 'triang_trunc', 'invalid argument size', FATAL )
endif

return
end subroutine triangular_truncation_3d

!-----------------------------------------------------------------------------
subroutine rhomboidal_truncation_3d(spherical, trunc_fourier, trunc_spherical)
!-----------------------------------------------------------------------------

complex, intent(inout), dimension (0:,0:,:) :: spherical
integer, intent(in), optional:: trunc_fourier, trunc_spherical

integer :: k,n,m

if( size(spherical,1).EQ.num_fourier+1 .AND. size(spherical,2).EQ.num_spherical+1 )then
    if(present(trunc_fourier).and.present(trunc_spherical)) then
        do k=1,size(spherical,3)
           do n=0,size(spherical,2)-1
              do m=0,size(spherical,1)-1
                 if(fourier_wave(m,n) .GT. trunc_fourier.OR.n .GT. trunc_spherical)  &
                      spherical(m,n,k) = cmplx(0.,0.)
              end do
           end do
        end do
    else
        spherical(:,num_spherical,:) = cmplx(0.,0.)
    end if
else if( size(spherical,1).EQ.me-ms+1 .AND. size(spherical,2).EQ.ne-ns+1 )then
!wavenumbers are numbered from (0,0) which is actually (ms,ns)
    if(present(trunc_fourier).and.present(trunc_spherical)) then
        do k=1,size(spherical,3)
           do n=0,size(spherical,2)-1
              do m=0,size(spherical,1)-1
                 if(fourier_wave(m+ms,n+ns).GT.trunc_fourier .OR. n+ns.GT.trunc_spherical)  &
                      spherical(m,n,k) = cmplx(0.,0.)
              end do
           end do
        end do
    else
!truncate on n=num_spherical, only on domain containing n=num_spherical
        if( ne.EQ.num_spherical )spherical(:,ne-ns,:) = cmplx(0.,0.)
    end if
else
    call error_mesg( 'rhomboid_trunc', 'invalid argument size', FATAL )
endif

return
end subroutine rhomboidal_truncation_3d

!rest are 2d versions of 3d routines

!---------------------------------------------------------------------------
function compute_lon_deriv_cos_2d(spherical) result(deriv_lon)
!---------------------------------------------------------------------------

complex, intent(in),  dimension (:,:) :: spherical
complex, dimension (size(spherical,1), size(spherical,2)) :: deriv_lon

complex, dimension (size(spherical,1), size(spherical,2), 1) :: spherical_3d
complex, dimension (size(spherical,1), size(spherical,2), 1) :: deriv_lon_3d

spherical_3d(:,:,1) = spherical(:,:)
deriv_lon_3d = compute_lon_deriv_cos_3d(spherical_3d)
deriv_lon(:,:) = deriv_lon_3d(:,:,1)


return
end function compute_lon_deriv_cos_2d

!--------------------------------------------------------------------------
function compute_lat_deriv_cos_2d(spherical) result(deriv_lat)
!--------------------------------------------------------------------------

complex, intent(in),  dimension (:,:) :: spherical
complex, dimension (size(spherical,1), size(spherical,2)) :: deriv_lat

complex, dimension (size(spherical,1), size(spherical,2), 1) :: spherical_3d
complex, dimension (size(spherical,1), size(spherical,2), 1) :: deriv_lat_3d

spherical_3d(:,:,1) = spherical(:,:)
deriv_lat_3d = compute_lat_deriv_cos_3d(spherical_3d)
deriv_lat(:,:) = deriv_lat_3d(:,:,1)


return
end function compute_lat_deriv_cos_2d

!-------------------------------------------------------------------
subroutine compute_gradient_cos_2d(spherical, deriv_lon, deriv_lat) 
!-------------------------------------------------------------------

complex, intent(in),  dimension(:,:) :: spherical
complex, intent(out), dimension(size(spherical,1), size(spherical,2)) :: deriv_lat
complex, intent(out), dimension(size(spherical,1), size(spherical,2)) :: deriv_lon

complex, dimension(size(spherical,1), size(spherical,2), 1) :: spherical_3d
complex, dimension(size(spherical,1), size(spherical,2), 1) :: deriv_lat_3d
complex, dimension(size(spherical,1), size(spherical,2), 1) :: deriv_lon_3d

spherical_3d(:,:,1) = spherical(:,:)
call compute_gradient_cos_3d(spherical_3d, deriv_lon_3d, deriv_lat_3d)
deriv_lon(:,:) = deriv_lon_3d(:,:,1)
deriv_lat(:,:) = deriv_lat_3d(:,:,1)

return
end subroutine compute_gradient_cos_2d

!----------------------------------------------------------------------
function compute_laplacian_2d(spherical, power) result(laplacian)
!----------------------------------------------------------------------

complex, intent(in), dimension (:,:) :: spherical
integer, optional :: power

complex, dimension (size(spherical,1), size(spherical,2)) :: laplacian

complex, dimension(size(spherical,1), size(spherical,2), 1) :: spherical_3d
complex, dimension(size(spherical,1), size(spherical,2), 1) :: laplacian_3d

spherical_3d(:,:,1) = spherical(:,:)
laplacian_3d = compute_laplacian_3d(spherical_3d, power)
laplacian(:,:) = laplacian_3d(:,:,1)

return
end function compute_laplacian_2d

!----------------------------------------------------------------------
subroutine compute_ucos_vcos_2d(vorticity , divergence, u_cos, v_cos)
!----------------------------------------------------------------------

complex, intent(in),  dimension (:,:) :: vorticity
complex, intent(in),  dimension (size(vorticity,1), size(vorticity,2)) :: divergence
complex, intent(out), dimension (size(vorticity,1), size(vorticity,2)) :: u_cos
complex, intent(out), dimension (size(vorticity,1), size(vorticity,2)) :: v_cos

complex, dimension (size(vorticity,1), size(vorticity,2), 1) :: vorticity_3d
complex, dimension (size(vorticity,1), size(vorticity,2), 1) :: divergence_3d
complex, dimension (size(vorticity,1), size(vorticity,2), 1) :: u_cos_3d
complex, dimension (size(vorticity,1), size(vorticity,2), 1) :: v_cos_3d

vorticity_3d(:,:,1)  = vorticity(:,:)
divergence_3d(:,:,1) = divergence(:,:)
call compute_ucos_vcos_3d(vorticity_3d, divergence_3d, u_cos_3d, v_cos_3d)
u_cos(:,:) = u_cos_3d(:,:,1)
v_cos(:,:) = v_cos_3d(:,:,1)

return
end subroutine compute_ucos_vcos_2d

!-------------------------------------------------------------------------
subroutine compute_vor_div_2d(u_div_cos, v_div_cos, vorticity, divergence)
!-------------------------------------------------------------------------

complex, intent(in),  dimension (:,:) :: u_div_cos
complex, intent(in),  dimension (size(u_div_cos,1), size(u_div_cos,2)) :: v_div_cos
complex, intent(out), dimension (size(u_div_cos,1), size(u_div_cos,2)) :: vorticity
complex, intent(out), dimension (size(u_div_cos,1), size(u_div_cos,2)) :: divergence

complex, dimension (size(u_div_cos,1), size(u_div_cos,2), 1) :: u_div_cos_3d
complex, dimension (size(u_div_cos,1), size(u_div_cos,2), 1) :: v_div_cos_3d
complex, dimension (size(u_div_cos,1), size(u_div_cos,2), 1) :: vorticity_3d
complex, dimension (size(u_div_cos,1), size(u_div_cos,2), 1) :: divergence_3d

u_div_cos_3d(:,:,1) = u_div_cos(:,:)
v_div_cos_3d(:,:,1) = v_div_cos(:,:)
call compute_vor_div_3d(u_div_cos_3d, v_div_cos_3d, vorticity_3d, divergence_3d)
vorticity(:,:)  = vorticity_3d(:,:,1)
divergence(:,:) = divergence_3d(:,:,1)

return
end subroutine compute_vor_div_2d

!-------------------------------------------------------------------------
function compute_vor_2d(u_div_cos, v_div_cos) result(vorticity)
!-------------------------------------------------------------------------

complex, intent(in),  dimension (:,:) :: u_div_cos
complex, intent(in),  dimension (:,:) :: v_div_cos
complex, dimension (size(u_div_cos,1), size(u_div_cos,2)) :: vorticity

complex, dimension (size(u_div_cos,1), size(u_div_cos,2), 1) :: u_div_cos_3d
complex, dimension (size(u_div_cos,1), size(u_div_cos,2), 1) :: v_div_cos_3d
complex, dimension (size(u_div_cos,1), size(u_div_cos,2), 1) :: vorticity_3d

u_div_cos_3d(:,:,1) = u_div_cos(:,:)
v_div_cos_3d(:,:,1) = v_div_cos(:,:)
vorticity_3d = compute_vor_3d(u_div_cos_3d, v_div_cos_3d)
vorticity(:,:) = vorticity_3d(:,:,1)

return
end function compute_vor_2d

!-------------------------------------------------------------------------
function compute_div_2d(u_div_cos, v_div_cos) result(divergence)
!-------------------------------------------------------------------------

complex, intent(in),  dimension (:,:) :: u_div_cos
complex, intent(in),  dimension (:,:) :: v_div_cos
complex, dimension (size(u_div_cos,1), size(u_div_cos,2)) :: divergence

complex, dimension (size(u_div_cos,1), size(u_div_cos,2), 1) :: u_div_cos_3d
complex, dimension (size(u_div_cos,1), size(u_div_cos,2), 1) :: v_div_cos_3d
complex, dimension (size(u_div_cos,1), size(u_div_cos,2), 1) :: divergence_3d

u_div_cos_3d(:,:,1) = u_div_cos(:,:)
v_div_cos_3d(:,:,1) = v_div_cos(:,:)
divergence_3d = compute_div_3d(u_div_cos_3d, v_div_cos_3d)
divergence(:,:) = divergence_3d(:,:,1)

return
end function compute_div_2d

!--------------------------------------------------------------------------------
function compute_alpha_operator_2d(spherical_a, spherical_b, isign) result(alpha)
!--------------------------------------------------------------------------------

complex, intent(in),  dimension (:,:) :: spherical_a
complex, intent(in),  dimension (:,:) :: spherical_b
integer, intent(in) :: isign

complex, dimension (size(spherical_a,1), size(spherical_a,2)) :: alpha

complex, dimension (size(spherical_a,1), size(spherical_a,2), 1) :: spherical_a_3d
complex, dimension (size(spherical_a,1), size(spherical_a,2), 1) :: spherical_b_3d
complex, dimension (size(spherical_a,1), size(spherical_a,2), 1) :: alpha_3d

spherical_a_3d(:,:,1) = spherical_a(:,:)
spherical_b_3d(:,:,1) = spherical_b(:,:)
alpha_3d = compute_alpha_operator_3d(spherical_a_3d, spherical_b_3d, isign)
alpha(:,:) = alpha_3d(:,:,1)

return
end function compute_alpha_operator_2d

!-----------------------------------------------------------------------
subroutine triangular_truncation_2d(spherical, trunc)
!-----------------------------------------------------------------------

complex, intent(inout), dimension (:,:) :: spherical
integer, intent(in), optional :: trunc
complex, dimension (size(spherical,1), size(spherical,2), 1) :: spherical_3d

spherical_3d(:,:,1) = spherical(:,:)
call triangular_truncation_3d(spherical_3d, trunc)
spherical(:,:) = spherical_3d(:,:,1)

return
end subroutine triangular_truncation_2d

!--------------------------------------------------------------------------------
subroutine rhomboidal_truncation_2d(spherical, trunc_fourier, trunc_spherical)
!--------------------------------------------------------------------------------

complex, intent(inout), dimension (:,:) :: spherical
integer, intent(in), optional :: trunc_fourier, trunc_spherical

complex, dimension (size(spherical,1), size(spherical,2), 1) :: spherical_3d

spherical_3d(:,:,1) = spherical(:,:)
call rhomboidal_truncation_3d(spherical_3d, trunc_fourier, trunc_spherical)
spherical(:,:) = spherical_3d(:,:,1)

return
end subroutine rhomboidal_truncation_2d

!-----------------------------------------------------------------------
subroutine spherical_end

if(.not.module_is_initialized) return

deallocate(eigen_laplacian, epsilon, r_epsilon, fourier_wave, spherical_wave)
deallocate(coef_uvm, coef_uvc, coef_uvp, coef_alpm, coef_alpp, coef_dym, coef_dx, coef_dyp, triangle_mask)
module_is_initialized = .false.

return
end subroutine spherical_end
!-----------------------------------------------------------------------

end module spherical_mod

#ifdef test_fms_io

 program fms_io_test
#include <fms_platform.h>

 use mpp_mod,         only: mpp_pe, mpp_npes, mpp_root_pe, mpp_init, mpp_exit
 use mpp_mod,         only: stdout, mpp_error, FATAL, NOTE, mpp_chksum
 use mpp_mod,         only: input_nml_file
 use mpp_domains_mod, only: domain2D, mpp_define_layout, mpp_define_mosaic
 use mpp_domains_mod, only: mpp_get_compute_domain, mpp_get_data_domain
 use mpp_domains_mod, only: mpp_domains_init, mpp_domains_exit
 use mpp_domains_mod, only: mpp_domains_set_stack_size, mpp_define_io_domain
 use mpp_io_mod,      only: mpp_open, mpp_close, MPP_ASCII, MPP_RDONLY
 use fms_io_mod,      only: read_data, write_data, fms_io_init, fms_io_exit
 use fms_io_mod,      only: file_exist, register_restart_field, save_restart, restore_state
 use fms_io_mod,      only: restart_file_type
 use mpp_io_mod,      only: MAX_FILE_SIZE

 implicit none

 integer :: sizex_latlon_grid = 144
 integer :: sizey_latlon_grid = 90
 integer :: size_cubic_grid = 48
 integer :: nz = 10, nt = 2, halo = 1
 integer :: nl = 5
 integer :: stackmax =4000000
 integer :: num_step = 4 ! number of time steps to run, this is used for intermediate run.
                         ! set num_step = 0 for no intermediate run.
 logical :: do_write=.true. ! set this to false for high resolution and single file,
                            ! split file capability is not implemented for write_data
 integer :: layout_cubic (2) = (/0,0/)
 integer :: layout_latlon(2) = (/0,0/)  
 integer :: io_layout(2) = (/0,0/) ! set ndivs_x and ndivs_y to divide each tile into io_layout(1)*io_layout(2)
                                   ! group and write out data from the root pe of each group.
 logical :: read_only = .False.

 namelist /test_fms_io_nml/ sizex_latlon_grid, sizey_latlon_grid, size_cubic_grid, &
                            nz, nt, halo, num_step, stackmax, do_write, layout_cubic, layout_latlon, io_layout, &
                            read_only, nl

 integer           :: unit, io_status, step
 character(len=20) :: time_stamp

 type data_storage_type
    real,    allocatable, dimension(:,:,:,:,:) :: data1_r4d, data2_r4d, data1_r4d_read, data2_r4d_read
    real,    allocatable, dimension(:,:,:,:)   :: data1_r3d, data2_r3d, data1_r3d_read, data2_r3d_read
    real,    allocatable, dimension(:,:,:)     :: data1_r2d, data2_r2d, data1_r2d_read, data2_r2d_read
    real,    allocatable, dimension(:,:)       :: data1_r1d, data2_r1d, data1_r1d_read, data2_r1d_read
    real,    allocatable, dimension(:)         :: data1_r0d, data2_r0d, data1_r0d_read, data2_r0d_read
    integer, allocatable, dimension(:,:,:,:)   :: data1_i3d, data2_i3d, data1_i3d_read, data2_i3d_read
    integer, allocatable, dimension(:,:,:)     :: data1_i2d, data2_i2d, data1_i2d_read, data2_i2d_read
    integer, allocatable, dimension(:,:)       :: data1_i1d, data2_i1d, data1_i1d_read, data2_i1d_read
    integer, allocatable, dimension(:)         :: data1_i0d, data2_i0d, data1_i0d_read, data2_i0d_read
 end type data_storage_type
 
 type(data_storage_type), save :: latlon_data
 type(data_storage_type), save :: cubic_data
 type(domain2d),          save :: domain_latlon
 type(domain2d),          save :: domain_cubic
 type(restart_file_type), save :: restart_latlon
 type(restart_file_type), save :: restart_cubic
 integer                       :: ntile_latlon = 1
 integer                       :: ntile_cubic = 6
 integer                       :: npes

 character(len=128) :: file_latlon, file_cubic
 integer :: outunit

 call mpp_init
 npes = mpp_npes()

 call mpp_domains_init  

 call fms_io_init

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, test_fms_io_nml, iostat=io_status)
#else
 if (file_exist('input.nml') )then
    call mpp_open(unit, 'input.nml',form=MPP_ASCII,action=MPP_RDONLY)
    read(unit,test_fms_io_nml,iostat=io_status)
    call mpp_close (unit)
 end if
#endif
  if (io_status > 0) then
     call mpp_error(FATAL,'=>test_fms_io: Error reading test_fms_io_nml')
  endif

 !-- list nt maximum to be 2 to avoid integer overflow.
 if(nt > 2 .OR. nt < 1) call mpp_error(FATAL,"test_fms_io: nt should be 1 or 2")

 outunit = stdout()
 write(outunit, test_fms_io_nml )
  call mpp_domains_set_stack_size(stackmax)
 !--- currently we assume at most two time level will be written to restart file.
 if(nt > 2) call mpp_error(FATAL, "test_fms_io: test_fms_io_nml variable nt should be no larger than 2")

 file_latlon   = "test.res.latlon_grid.save_restore.nc"
 file_cubic    = "test.res.cubic_grid.save_restore.nc"

 call setup_test_restart(restart_latlon, "latlon_grid", ntile_latlon, latlon_data, file_latlon, layout_latlon, domain_latlon)
 call setup_test_restart(restart_cubic,  "cubic_grid", ntile_cubic, cubic_data, file_cubic, layout_cubic, domain_cubic )

 if(file_exist('INPUT/'//trim(file_latlon), domain_latlon)) then
    call restore_state(restart_latlon)
    call compare_restart("latlon_grid save_restore", latlon_data, .true.)
 end if
 if(file_exist('INPUT/'//trim(file_cubic), domain_cubic) ) then
    call restore_state(restart_cubic)
    call compare_restart("cubic_grid save_restore", cubic_data, .true. )
 end if
 
 !---copy data
 if(mod(npes,ntile_latlon) == 0) call copy_restart_data(latlon_data)
 if(mod(npes,ntile_cubic) == 0 ) call copy_restart_data(cubic_data)

 do step = 1, num_step
    write(time_stamp, '(a,I4.4)') "step", step
    if(mod(npes,ntile_latlon) == 0) call save_restart(restart_latlon, time_stamp)
    if(mod(npes,ntile_cubic) == 0 ) call save_restart(restart_cubic, time_stamp)
 end do
 if(mod(npes,ntile_latlon) == 0) call save_restart(restart_latlon)
 if(mod(npes,ntile_cubic)  == 0) call save_restart(restart_cubic)

 if(mod(npes,ntile_latlon) == 0) call release_storage_memory(latlon_data)
 if(mod(npes,ntile_cubic) == 0 ) call release_storage_memory(cubic_data)

 if(mod(npes,ntile_cubic) == 0 ) call mpp_error(NOTE, "test_fms_io: restart test is done for latlon_grid")
 if(mod(npes,ntile_cubic) == 0 ) call mpp_error(NOTE, "test_fms_io: restart test is done for cubic_grid")

 call fms_io_exit
 call mpp_domains_exit
 call mpp_exit

contains

  !******************************************************************************
  subroutine setup_test_restart(restart_data, type, ntiles, storage, file, layout_in, domain)
    type(restart_file_type),   intent(inout) :: restart_data
    character(len=*), intent(in)             :: type
    integer,          intent(in)             :: ntiles
    type(data_storage_type), intent(inout)   :: storage
    character(len=*), intent(in)             :: file  
    integer,          intent(in)             :: layout_in(:)
    type(domain2d),   intent(inout)          :: domain
    character(len=128)                       :: file_r
    character(len=128)                       :: file_w
    integer                                  :: pe, npes_per_tile, tile
    integer                                  :: num_contact
    integer                                  :: n, layout(2)
    integer, allocatable, dimension(:,:)     :: global_indices, layout2D
    integer, allocatable, dimension(:)       :: pe_start, pe_end
    integer, dimension(1)                    :: tile1, tile2
    integer, dimension(1)                    :: istart1, iend1, jstart1, jend1
    integer, dimension(1)                    :: istart2, iend2, jstart2, jend2
    integer                                  :: i, j, k, nx, ny, l
    integer                                  :: isc, iec, jsc, jec
    integer                                  :: isd, ied, jsd, jed
    integer                                  :: id_restart

    file_r = "INPUT/test.res."//trim(type)//".read_write.nc"
    file_w = "RESTART/test.res."//trim(type)//".read_write.nc"

    select case(type)
    case("latlon_grid")
       nx = sizex_latlon_grid
       ny = sizey_latlon_grid
    case("cubic_grid")
       nx = size_cubic_grid
       ny = size_cubic_grid
    case default
       call mpp_error(FATAL, "test_fms_io: "//type//" is not a valid option")
    end select

    pe   = mpp_pe()
    if(mod(npes,ntiles) .NE. 0) then
       call mpp_error(NOTE, "test_fms_io: npes can not be divided by ntiles, no test will be done for "//trim(type))
       return
    end if
    npes_per_tile = npes/ntiles
    tile = pe/npes_per_tile + 1

    if(layout_in(1)*layout_in(2) == npes_per_tile) then
       layout = layout_in
    else
       call mpp_define_layout( (/1,nx,1,ny/), npes_per_tile, layout )
    endif
    if(io_layout(1) <1 .OR. io_layout(2) <1) call mpp_error(FATAL, &
            "program test_fms_io: both elements of test_fms_io_nml variable io_layout must be positive integer")
    if(mod(layout(1), io_layout(1)) .NE. 0 ) call mpp_error(FATAL, &
         "program test_fms_io: layout(1) must be divided by io_layout(1)")
    if(mod(layout(2), io_layout(2)) .NE. 0 ) call mpp_error(FATAL, &
         "program test_fms_io: layout(2) must be divided by io_layout(2)")    
    allocate(global_indices(4,ntiles), layout2D(2,ntiles), pe_start(ntiles), pe_end(ntiles) )
    do n = 1, ntiles
       global_indices(:,n) = (/1,nx,1,ny/)
       layout2D(:,n)       = layout
       pe_start(n)         = (n-1)*npes_per_tile
       pe_end(n)           = n*npes_per_tile-1
    end do
    num_contact = 0
    call mpp_define_mosaic(global_indices, layout2D, domain, ntiles, num_contact, tile1, tile2, &
                           istart1, iend1, jstart1, jend1, istart2, iend2, jstart2, jend2,      &
                           pe_start, pe_end, whalo=halo, ehalo=halo, shalo=halo, nhalo=halo, name = type  )
    if(io_layout(1) .NE. 1 .OR. io_layout(2) .NE. 1) call mpp_define_io_domain(domain, io_layout)

    call mpp_get_compute_domain(domain, isc, iec, jsc, jec)
    call mpp_get_data_domain(domain, isd, ied, jsd, jed)

    allocate(storage%data1_r3d(isd:ied, jsd:jed, nz, nt), storage%data1_r3d_read(isd:ied, jsd:jed, nz, nt) )
    allocate(storage%data2_r3d(isd:ied, jsd:jed, nz, nt), storage%data2_r3d_read(isd:ied, jsd:jed, nz, nt) )
    allocate(storage%data1_r4d(isd:ied, jsd:jed, nz, nl, nt) )
    allocate(storage%data1_r4d_read(isd:ied, jsd:jed, nz, nl, nt) )
    allocate(storage%data2_r4d(isd:ied, jsd:jed, nz, nl, nt) )
    allocate(storage%data2_r4d_read(isd:ied, jsd:jed, nz, nl, nt) )
    allocate(storage%data1_i3d(isd:ied, jsd:jed, nz, nt), storage%data1_i3d_read(isd:ied, jsd:jed, nz, nt) )
    allocate(storage%data2_i3d(isd:ied, jsd:jed, nz, nt), storage%data2_i3d_read(isd:ied, jsd:jed, nz, nt) )
    allocate(storage%data1_r2d(isd:ied, jsd:jed,     nt), storage%data1_r2d_read(isd:ied, jsd:jed,     nt) )
    allocate(storage%data2_r2d(isd:ied, jsd:jed,     nt), storage%data2_r2d_read(isd:ied, jsd:jed,     nt) )
    allocate(storage%data1_i2d(isd:ied, jsd:jed,     nt), storage%data1_i2d_read(isd:ied, jsd:jed,     nt) )
    allocate(storage%data2_i2d(isd:ied, jsd:jed,     nt), storage%data2_i2d_read(isd:ied, jsd:jed,     nt) )
    allocate(storage%data1_r1d(                  nz, nt), storage%data1_r1d_read(                  nz, nt) )
    allocate(storage%data2_r1d(                  nz, nt), storage%data2_r1d_read(                  nz, nt) )
    allocate(storage%data1_i1d(                  nz, nt), storage%data1_i1d_read(                  nz, nt) )
    allocate(storage%data2_i1d(                  nz, nt), storage%data2_i1d_read(                  nz, nt) )
    allocate(storage%data1_r0d(                      nt), storage%data1_r0d_read(                      nt) )
    allocate(storage%data2_r0d(                      nt), storage%data2_r0d_read(                      nt) )
    allocate(storage%data1_i0d(                      nt), storage%data1_i0d_read(                      nt) )
    allocate(storage%data2_i0d(                      nt), storage%data2_i0d_read(                      nt) )

    storage%data1_r3d = 0; storage%data1_r3d_read = 0; storage%data2_r3d = 0; storage%data2_r3d_read = 0
    storage%data1_i3d = 0; storage%data1_i3d_read = 0; storage%data2_i3d = 0; storage%data2_i3d_read = 0
    storage%data1_r2d = 0; storage%data1_r2d_read = 0; storage%data2_r2d = 0; storage%data2_r2d_read = 0
    storage%data1_i2d = 0; storage%data1_i2d_read = 0; storage%data2_i2d = 0; storage%data2_i2d_read = 0
    storage%data1_r1d = 0; storage%data1_r1d_read = 0; storage%data2_r1d = 0; storage%data2_r1d_read = 0
    storage%data1_i1d = 0; storage%data1_i1d_read = 0; storage%data2_i1d = 0; storage%data2_i1d_read = 0
    storage%data1_r0d = 0; storage%data1_r0d_read = 0; storage%data2_r0d = 0; storage%data2_r0d_read = 0
    storage%data1_i0d = 0; storage%data1_i0d_read = 0; storage%data2_i0d = 0; storage%data2_i0d_read = 0
    storage%data1_r4d = 0; storage%data1_r4d_read = 0; storage%data2_r4d = 0; storage%data2_r4d_read = 0
    do n = 1, nt
       storage%data1_r0d(n) =  tile + n*1e-3
       storage%data2_r0d(n) = -tile - n*1e-3
       storage%data1_i0d(n) =  tile*1e3 + n
       storage%data2_i0d(n) = -tile*1e3 - n
       do l = 1, nl
          do k = 1, nz
             do j = jsc, jec
                do i = isc, iec
                   storage%data1_r4d(i,j,k,l,n) =  l*1e9 + tile*1e6 + n*1e3 + k + i*1e-3 + j*1e-6;
                   storage%data2_r4d(i,j,k,l,n) =  -l*1e9 - tile*1e6 - n*1e3 + k - i*1e-3 - j*1e-6;
                enddo
             enddo
          enddo
       enddo
       do k = 1, nz
          storage%data1_r1d(k,n) =   tile*1e3 + n + k*1e-3
          storage%data2_r1d(k,n) =  -tile*1e3 - n - k*1e-3
          storage%data1_i1d(k,n) =   tile*1e6 + n*1e3 + k
          storage%data2_i1d(k,n) =  -tile*1e6 - n*1e3 - k
          do j = jsc, jec
             do i = isc, iec
                storage%data1_r3d(i,j,k,n) =  tile*1e6 + n*1e3 + k + i*1e-3 + j*1e-6; 
                storage%data2_r3d(i,j,k,n) = -tile*1e6 - n*1e3 - k - i*1e-3 - j*1e-6; 
                storage%data1_i3d(i,j,k,n) =  (n*ntiles+tile)*1e8 + k*1e6 + i*1e3 + j; 
                storage%data2_i3d(i,j,k,n) = -(n*ntiles+tile)*1e8 - k*1e6 - i*1e3 - j; 
             end do
          end do
       end do

       do j = jsc, jec
          do i = isc, iec
             storage%data1_r2d(i,j,n) =  tile*1e1 + n + i*1e-3 + j*1e-6; 
             storage%data2_r2d(i,j,n) = -tile*1e1 - n - i*1e-3 - j*1e-6; 
             storage%data1_i2d(i,j,n) =  tile*1e7 + n*1e6 + i*1e3 + j; 
             storage%data2_i2d(i,j,n) = -tile*1e7 - n*1e6 - i*1e3 - j; 
          end do
       end do
    end do
    if(file_exist(file_r, domain)) then
       do n = 1, nt
          call read_data(file_r, "data1_r3d", storage%data1_r3d_read(:,:,:,n), domain, timelevel = n )
          call read_data(file_r, "data2_r3d", storage%data2_r3d_read(:,:,:,n), domain, timelevel = n )
          call read_data(file_r, "data1_i3d", storage%data1_i3d_read(:,:,:,n), domain, timelevel = n )
          call read_data(file_r, "data2_i3d", storage%data2_i3d_read(:,:,:,n), domain, timelevel = n )
          call read_data(file_r, "data1_r2d", storage%data1_r2d_read(:,:,  n), domain, timelevel = n )
          call read_data(file_r, "data2_r2d", storage%data2_r2d_read(:,:,  n), domain, timelevel = n )
          call read_data(file_r, "data1_i2d", storage%data1_i2d_read(:,:,  n), domain, timelevel = n )
          call read_data(file_r, "data2_i2d", storage%data2_i2d_read(:,:,  n), domain, timelevel = n )
          call read_data(file_r, "data1_r1d", storage%data1_r1d_read(:,    n), domain, timelevel = n )
          call read_data(file_r, "data2_r1d", storage%data2_r1d_read(:,    n), domain, timelevel = n )
          call read_data(file_r, "data1_i1d", storage%data1_i1d_read(:,    n), domain, timelevel = n )
          call read_data(file_r, "data2_i1d", storage%data2_i1d_read(:,    n), domain, timelevel = n )
          call read_data(file_r, "data1_r0d", storage%data1_r0d_read(      n), domain, timelevel = n )
          call read_data(file_r, "data2_r0d", storage%data2_r0d_read(      n), domain, timelevel = n )
          call read_data(file_r, "data1_i0d", storage%data1_i0d_read(      n), domain, timelevel = n )
          call read_data(file_r, "data2_i0d", storage%data2_i0d_read(      n), domain, timelevel = n )
       end do
       call compare_restart(type//" read_write", storage, .false.)
    end if


    !--- high resolution restart is not implemented for write data
    if(do_write ) then 
       do n = 1, nt
          call write_data(file_w, "data1_r3d", storage%data1_r3d(:,:,:,n), domain )
          call write_data(file_w, "data2_r3d", storage%data2_r3d(:,:,:,n), domain )
          call write_data(file_w, "data1_i3d", storage%data1_i3d(:,:,:,n), domain )
          call write_data(file_w, "data2_i3d", storage%data2_i3d(:,:,:,n), domain )
          call write_data(file_w, "data1_r2d", storage%data1_r2d(:,:,  n), domain )
          call write_data(file_w, "data2_r2d", storage%data2_r2d(:,:,  n), domain )
          call write_data(file_w, "data1_i2d", storage%data1_i2d(:,:,  n), domain )
          call write_data(file_w, "data2_i2d", storage%data2_i2d(:,:,  n), domain )
          call write_data(file_w, "data1_r1d", storage%data1_r1d(:,    n), domain )
          call write_data(file_w, "data2_r1d", storage%data2_r1d(:,    n), domain )
          call write_data(file_w, "data1_i1d", storage%data1_i1d(:,    n), domain )
          call write_data(file_w, "data2_i1d", storage%data2_i1d(:,    n), domain )
          call write_data(file_w, "data1_r0d", storage%data1_r0d(      n), domain )
          call write_data(file_w, "data2_r0d", storage%data2_r0d(      n), domain )
          call write_data(file_w, "data1_i0d", storage%data1_i0d(      n), domain )
          call write_data(file_w, "data2_i0d", storage%data2_i0d(      n), domain )
       end do
    end if

    !--- test register_restart_field, save_restart, restore_state

    id_restart = register_restart_field(restart_data, file, "data1_r3d", storage%data1_r3d_read(:,:,:,1), &
                                domain, longname="first data_r3d",units="none", read_only=read_only)
    id_restart = register_restart_field(restart_data, file, "data1_r3d", storage%data1_r3d_read(:,:,:,2), &
                                domain, longname="first data_r3d",units="none", read_only=read_only)
    id_restart = register_restart_field(restart_data, file, "data2_r3d", storage%data2_r3d_read(:,:,:,1), &
                                storage%data2_r3d_read(:,:,:,2), &
                                domain, longname="second data_i3d", units="none")

    id_restart = register_restart_field(restart_data, file, "data1_r4d", storage%data1_r4d_read(:,:,:,:,1), &
                                domain, longname="first data_r4d",units="none")
    id_restart = register_restart_field(restart_data, file, "data1_r4d", storage%data1_r4d_read(:,:,:,:,2), &
                                domain, longname="first data_r4d",units="none")
    id_restart = register_restart_field(restart_data, file, "data2_r4d", storage%data2_r4d_read(:,:,:,:,1), &
                                domain, longname="second data_r4d",units="none")

    id_restart = register_restart_field(restart_data, file, "data1_i3d", storage%data1_i3d_read(:,:,:,1), &
                                domain, longname="first data_i3d",units="none")
    id_restart = register_restart_field(restart_data, file, "data1_i3d", storage%data1_i3d_read(:,:,:,2), &
                                domain, longname="first data_i3d",units="none")
    id_restart = register_restart_field(restart_data, file, "data2_i3d", storage%data2_i3d_read(:,:,:,1), &
                                storage%data2_i3d_read(:,:,:,2), &
                                domain, longname="second data_i3d", units="none")

    id_restart = register_restart_field(restart_data, file, "data1_r2d", storage%data1_r2d_read(:,:,  1), &
                                domain, longname="first data_r2d",units="none", read_only=read_only)
    id_restart = register_restart_field(restart_data, file, "data1_r2d", storage%data1_r2d_read(:,:,  2), &
                                domain, longname="first data_r2d",units="none", read_only=read_only)
    id_restart = register_restart_field(restart_data, file, "data2_r2d", storage%data2_r2d_read(:,:,  1), &
                                storage%data2_r2d_read(:,:,2), &
                                domain, longname="second data_i2d", units="none")

    id_restart = register_restart_field(restart_data, file, "data1_i2d", storage%data1_i2d_read(:,:,  1), &
                                domain, longname="first data_i2d",units="none", read_only=read_only)
    id_restart = register_restart_field(restart_data, file, "data1_i2d", storage%data1_i2d_read(:,:,  2), &
                                domain, longname="first data_i2d",units="none", read_only=read_only)
    id_restart = register_restart_field(restart_data, file, "data2_i2d", storage%data2_i2d_read(:,:,  1), &
                                storage%data2_i2d_read(:,:,2), &
                                domain, longname="second data_i2d", units="none", read_only=read_only)

    id_restart = register_restart_field(restart_data, file, "data1_r1d", storage%data1_r1d_read(:,    1), &
                                domain, longname="first data_r1d",units="none")
    id_restart = register_restart_field(restart_data, file, "data1_r1d", storage%data1_r1d_read(:,    2), &
                                domain, longname="first data_r1d",units="none")
    id_restart = register_restart_field(restart_data, file, "data2_r1d", storage%data2_r1d_read(:,    1), &
                                storage%data2_r1d_read(:,  2), &
                                domain, longname="second data_i1d", units="none")

    id_restart = register_restart_field(restart_data, file, "data1_i1d", storage%data1_i1d_read(:,    1), &
                                domain, longname="first data_i1d",units="none", read_only=read_only)
    id_restart = register_restart_field(restart_data, file, "data1_i1d", storage%data1_i1d_read(:,    2), &
                                domain, longname="first data_i1d",units="none", read_only=read_only)
    id_restart = register_restart_field(restart_data, file, "data2_i1d", storage%data2_i1d_read(:,    1), &
                                storage%data2_i1d_read(:,  2), &
                                domain, longname="second data_i1d", units="none")


    id_restart = register_restart_field(restart_data, file, "data1_r0d", storage%data1_r0d_read(      1), &
                                domain, longname="first data_r0d",units="none", read_only=read_only)
    id_restart = register_restart_field(restart_data, file, "data1_r0d", storage%data1_r0d_read(      2), &
                                domain, longname="first data_r0d",units="none", read_only=read_only)
    id_restart = register_restart_field(restart_data, file, "data2_r0d", storage%data2_r0d_read(      1), &
                                storage%data2_r0d_read(    2), &
                                domain, longname="second data_i0d", units="none")

    id_restart = register_restart_field(restart_data, file, "data1_i0d", storage%data1_i0d_read(      1), &
                                domain, longname="first data_i0d",units="none")
    id_restart = register_restart_field(restart_data, file, "data1_i0d", storage%data1_i0d_read(      2), &
                                domain, longname="first data_i0d",units="none")
    id_restart = register_restart_field(restart_data, file, "data2_i0d", storage%data2_i0d_read(      1), &
                                storage%data2_i0d_read(    2), &
                                domain, longname="second data_i0d", units="none")

  end subroutine setup_test_restart

  subroutine compare_restart(type, storage, compare_r4d)
    character(len=*), intent(in)             :: type
    type(data_storage_type), intent(inout)   :: storage
    logical,                 intent(in   )   :: compare_r4d

       if(compare_r4d) then   
          call compare_data_r5d(storage%data1_r4d, storage%data1_r4d_read, type//" data1_r4d")
          call compare_data_r5d(storage%data2_r4d(:,:,:,:,1:1), storage%data2_r4d_read(:,:,:,:,1:1), type//" data2_r4d")
       endif
       call compare_data_r4d(storage%data1_r3d, storage%data1_r3d_read, type//" data1_r3d")
       call compare_data_r4d(storage%data2_r3d, storage%data2_r3d_read, type//" data2_r3d")
       call compare_data_i4d(storage%data1_i3d, storage%data1_i3d_read, type//" data1_i3d")
       call compare_data_i4d(storage%data2_i3d, storage%data2_i3d_read, type//" data2_i3d")
       call compare_data_r3d(storage%data1_r2d, storage%data1_r2d_read, type//" data1_r2d")
       call compare_data_r3d(storage%data2_r2d, storage%data2_r2d_read, type//" data2_r2d")
       call compare_data_i3d(storage%data1_i2d, storage%data1_i2d_read, type//" data1_i2d")
       call compare_data_i3d(storage%data2_i2d, storage%data2_i2d_read, type//" data2_i2d")
       call compare_data_r2d(storage%data1_r1d, storage%data1_r1d_read, type//" data1_r1d")
       call compare_data_r2d(storage%data2_r1d, storage%data2_r1d_read, type//" data2_r1d")
       call compare_data_i2d(storage%data1_i1d, storage%data1_i1d_read, type//" data1_i1d")
       call compare_data_i2d(storage%data2_i1d, storage%data2_i1d_read, type//" data2_i1d")
       call compare_data_r1d(storage%data1_r0d, storage%data1_r0d_read, type//" data1_r0d")
       call compare_data_r1d(storage%data2_r0d, storage%data2_r0d_read, type//" data2_r0d")
       call compare_data_i1d(storage%data1_i0d, storage%data1_i0d_read, type//" data1_i0d")
       call compare_data_i1d(storage%data2_i0d, storage%data2_i0d_read, type//" data2_i0d")

  end subroutine compare_restart

  subroutine release_storage_memory(storage)
    type(data_storage_type), intent(inout)   :: storage

    deallocate(storage%data1_r3d, storage%data2_r3d, storage%data1_r3d_read, storage%data2_r3d_read)
    deallocate(storage%data1_i3d, storage%data2_i3d, storage%data1_i3d_read, storage%data2_i3d_read)
    deallocate(storage%data1_r2d, storage%data2_r2d, storage%data1_r2d_read, storage%data2_r2d_read)
    deallocate(storage%data1_i2d, storage%data2_i2d, storage%data1_i2d_read, storage%data2_i2d_read)
    deallocate(storage%data1_r1d, storage%data2_r1d, storage%data1_r1d_read, storage%data2_r1d_read)
    deallocate(storage%data1_i1d, storage%data2_i1d, storage%data1_i1d_read, storage%data2_i1d_read)
    deallocate(storage%data1_r0d, storage%data2_r0d, storage%data1_r0d_read, storage%data2_r0d_read)
    deallocate(storage%data1_i0d, storage%data2_i0d, storage%data1_i0d_read, storage%data2_i0d_read)
    deallocate(storage%data1_r4d, storage%data2_r4d, storage%data1_r4d_read, storage%data2_r4d_read)

  end subroutine release_storage_memory

  subroutine copy_restart_data(storage)
    type(data_storage_type), intent(inout)   :: storage
    integer :: n, l

    storage%data1_r3d_read = storage%data1_r3d; storage%data2_r3d_read = storage%data2_r3d
    storage%data1_i3d_read = storage%data1_i3d; storage%data2_i3d_read = storage%data2_i3d
    storage%data1_r2d_read = storage%data1_r2d; storage%data2_r2d_read = storage%data2_r2d
    storage%data1_i2d_read = storage%data1_i2d; storage%data2_i2d_read = storage%data2_i2d
    storage%data1_r1d_read = storage%data1_r1d; storage%data2_r1d_read = storage%data2_r1d
    storage%data1_i1d_read = storage%data1_i1d; storage%data2_i1d_read = storage%data2_i1d
    storage%data1_r0d_read = storage%data1_r0d; storage%data2_r0d_read = storage%data2_r0d
    storage%data1_i0d_read = storage%data1_i0d; storage%data2_i0d_read = storage%data2_i0d
    storage%data1_r4d_read = storage%data1_r4d; storage%data2_r4d_read = storage%data2_r4d

    return

  end subroutine copy_restart_data

  subroutine compare_data_r5d( a, b, string )
    real, intent(in), dimension(:,:,:,:,:) :: a, b
    character(len=*), intent(in)         :: string
    integer(LONG_KIND)                   :: sum1, sum2
    integer                              :: i, j, k, l, n
    integer, parameter                   :: stdunit = 6

    if(size(a,1) .ne. size(b,1) .or. size(a,2) .ne. size(b,2) .or. size(a,3) .ne. size(b,3) &
      .or. size(a,4) .ne. size(b,4) .or. size(a,5) .ne. size(b,5) ) &
         call mpp_error(FATAL,'compare_data_r5d: size of a and b does not match')
    do n = 1, size(a,5)
       do l = 1, size(a,4)
          do k = 1, size(a,3)
             do j = 1, size(a,2)
                do i = 1, size(a,1)
                   if(a(i,j,k,l,n) .ne. b(i,j,k,l,n)) then
                      write(stdunit,'(a,i3,a,i3,a,i3,a,i3,a,i3,a,i3,a,f18.6,a,f18.6)')" at pe ", mpp_pe(), &
                           ", at point (",i,", ", j, ", ", k, ", ", l, ", ", n, "), a = ", a(i,j,k,l,n), ",&
                           b = ", b(i,j,k,l,n)
                      call mpp_error(FATAL, trim(string)//': point by point comparison are not OK.')
                   endif
                enddo
             enddo
          enddo
       enddo
    enddo
    sum1 = mpp_chksum( a, (/mpp_pe()/) )
    sum2 = mpp_chksum( b, (/mpp_pe()/) )

    if( sum1.EQ.sum2 )then
       if( mpp_pe() .EQ. mpp_root_pe() )call mpp_error( NOTE, trim(string)//': OK.' )
       !--- in some case, even though checksum agree, the two arrays 
       !    actually are different, like comparing (1.1,-1.2) with (-1.1,1.2)
       !--- hence we need to check the value point by point.
    else
       call mpp_error( FATAL, trim(string)//': chksums are not OK.' )
    end if
  end subroutine compare_data_r5d


  subroutine compare_data_r4d( a, b, string )
    real, intent(in), dimension(:,:,:,:) :: a, b
    character(len=*), intent(in)         :: string
    integer(LONG_KIND)                   :: sum1, sum2
    integer                              :: i, j, k, l
    integer, parameter                   :: stdunit = 6

    if(size(a,1) .ne. size(b,1) .or. size(a,2) .ne. size(b,2) .or. size(a,3) .ne. size(b,3) .or. size(a,4) .ne. size(b,4) ) &
         call mpp_error(FATAL,'compare_data_r4d: size of a and b does not match')

    do l = 1, size(a,4)
       do k = 1, size(a,3)
          do j = 1, size(a,2)
             do i = 1, size(a,1)
                if(a(i,j,k,l) .ne. b(i,j,k,l)) then
                   write(stdunit,'(a,i3,a,i3,a,i3,a,i3,a,i3,a,f18.6,a,f18.6)')" at pe ", mpp_pe(), &
                        ", at point (",i,", ", j, ", ", k, ", ", l, "), a = ", a(i,j,k,l), ", b = ", b(i,j,k,l)
                   call mpp_error(FATAL, trim(string)//': point by point comparison are not OK.')
                endif
             enddo
          enddo
       enddo
    enddo
    sum1 = mpp_chksum( a, (/mpp_pe()/) )
    sum2 = mpp_chksum( b, (/mpp_pe()/) )

    if( sum1.EQ.sum2 )then
       if( mpp_pe() .EQ. mpp_root_pe() )call mpp_error( NOTE, trim(string)//': OK.' )
       !--- in some case, even though checksum agree, the two arrays 
       !    actually are different, like comparing (1.1,-1.2) with (-1.1,1.2)
       !--- hence we need to check the value point by point.
    else
       call mpp_error( FATAL, trim(string)//': chksums are not OK.' )
    end if
  end subroutine compare_data_r4d

  subroutine compare_data_i4d( a, b, string )
    integer, intent(in), dimension(:,:,:,:) :: a, b
    character(len=*), intent(in)            :: string
    real                                    :: real_a(size(a,1),size(a,2),size(a,3),size(a,4))
    real                                    :: real_b(size(b,1),size(b,2),size(b,3),size(b,4))

    real_a = a 
    real_b = b
    call compare_data_r4d(real_a, real_b, string)

  end subroutine compare_data_i4d


  subroutine compare_data_r3d( a, b, string )
    real, intent(in), dimension(:,:,:) :: a, b
    character(len=*), intent(in)       :: string
    integer(LONG_KIND)                 :: sum1, sum2
    integer                            :: i, j, l
    integer, parameter                 :: stdunit = 6

    if(size(a,1) .ne. size(b,1) .or. size(a,2) .ne. size(b,2) .or. size(a,3) .ne. size(b,3) ) &
         call mpp_error(FATAL,'compare_data_r3d: size of a and b does not match')

    do l = 1, size(a,3)
       do j = 1, size(a,2)
          do i = 1, size(a,1)
             if(a(i,j,l) .ne. b(i,j,l)) then
                write(stdunit,'(a,i3,a,i3,a,i3,a,i3,a,f16.9,a,f16.9)')" at pe ", mpp_pe(), &
                     ", at point (",i,", ", j, ", ", l, "), a = ", a(i,j,l), ", b = ", b(i,j,l)
                call mpp_error(FATAL, trim(string)//': point by point comparison are not OK.')
             endif
          enddo
       enddo
    enddo
    sum1 = mpp_chksum( a, (/mpp_pe()/) )
    sum2 = mpp_chksum( b, (/mpp_pe()/) )

    if( sum1.EQ.sum2 )then
       if( mpp_pe() .EQ. mpp_root_pe() )call mpp_error( NOTE, trim(string)//': OK.' )
       !--- in some case, even though checksum agree, the two arrays 
       !    actually are different, like comparing (1.1,-1.2) with (-1.1,1.2)
       !--- hence we need to check the value point by point.
    else
       call mpp_error( FATAL, trim(string)//': chksums are not OK.' )
    end if
  end subroutine compare_data_r3d

  subroutine compare_data_i3d( a, b, string )
    integer, intent(in), dimension(:,:,:) :: a, b
    character(len=*), intent(in)          :: string
    real                                  :: real_a(size(a,1),size(a,2),size(a,3))
    real                                  :: real_b(size(b,1),size(b,2),size(b,3))

    real_a = a 
    real_b = b
    call compare_data_r3d(real_a, real_b, string)

  end subroutine compare_data_i3d


  subroutine compare_data_r2d( a, b, string )
    real, intent(in), dimension(:,:) :: a, b
    character(len=*), intent(in)     :: string
    integer(LONG_KIND)               :: sum1, sum2
    integer                          :: i, l
    integer, parameter               :: stdunit = 6

    if(size(a,1) .ne. size(b,1) .or. size(a,2) .ne. size(b,2) ) &
         call mpp_error(FATAL,'compare_data_r2d: size of a and b does not match')

    do l = 1, size(a,2)
       do i = 1, size(a,1)
          if(a(i,l) .ne. b(i,l)) then
             write(stdunit,'(a,i3,a,i3,a,i3,a,f16.6,a,f16.6)')" at pe ", mpp_pe(), &
                  ", at point (",i, ", ", l, "), a = ", a(i,l), ", b = ", b(i,l)
             call mpp_error(FATAL, trim(string)//': point by point comparison are not OK.')
          endif
       enddo
    end do
    sum1 = mpp_chksum( a, (/mpp_pe()/) )
    sum2 = mpp_chksum( b, (/mpp_pe()/) )

    if( sum1.EQ.sum2 )then
       if( mpp_pe() .EQ. mpp_root_pe() )call mpp_error( NOTE, trim(string)//': OK.' )
       !--- in some case, even though checksum agree, the two arrays 
       !    actually are different, like comparing (1.1,-1.2) with (-1.1,1.2)
       !--- hence we need to check the value point by point.
    else
       call mpp_error( FATAL, trim(string)//': chksums are not OK.' )
    end if
  end subroutine compare_data_r2d

  subroutine compare_data_i2d( a, b, string )
    integer, intent(in), dimension(:,:) :: a, b
    character(len=*), intent(in)        :: string
    real                                :: real_a(size(a,1),size(a,2))
    real                                :: real_b(size(b,1),size(b,2))

    real_a = a 
    real_b = b
    call compare_data_r2d(real_a, real_b, string)

  end subroutine compare_data_i2d

  subroutine compare_data_r1d( a, b, string )
    real, intent(in), dimension(:) :: a, b
    character(len=*), intent(in)   :: string
    integer(LONG_KIND)             :: sum1, sum2
    integer                        :: l
    integer, parameter             :: stdunit = 6

    if(size(a,1) .ne. size(b,1) ) &
         call mpp_error(FATAL,'compare_data_r1d: size of a and b does not match')

    do l = 1, size(a(:))
       if(a(l) .ne. b(l)) then
          write(stdunit,'(a,i3,a,i3,a,f16.6,a,f16.6)')" at pe ", mpp_pe(), &
               ", at point (",l, "), a = ", a(l), ", b = ", b(l)
          call mpp_error(FATAL, trim(string)//': point by point comparison are not OK.')
       endif
    enddo
    sum1 = mpp_chksum( a, (/mpp_pe()/) )
    sum2 = mpp_chksum( b, (/mpp_pe()/) )

    if( sum1.EQ.sum2 )then
       if( mpp_pe() .EQ. mpp_root_pe() )call mpp_error( NOTE, trim(string)//': OK.' )
       !--- in some case, even though checksum agree, the two arrays 
       !    actually are different, like comparing (1.1,-1.2) with (-1.1,1.2)
       !--- hence we need to check the value point by point.
    else
       call mpp_error( FATAL, trim(string)//': chksums are not OK.' )
    end if
  end subroutine compare_data_r1d

  subroutine compare_data_i1d( a, b, string )
    integer, intent(in), dimension(:) :: a, b
    character(len=*), intent(in)      :: string
    real                              :: real_a(size(a(:)))
    real                              :: real_b(size(b(:)))

    real_a = a 
    real_b = b
    call compare_data_r1d(real_a, real_b, string)

  end subroutine compare_data_i1d

end program fms_io_test

#else
module null_fms_io_test
end module  

#endif  /* test_fms_io */

module leapfrog_mod

use fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, write_version_number

!===================================================================================================
implicit none
private
!===================================================================================================

interface leapfrog
  module procedure leapfrog_2d_complex, leapfrog_3d_complex
end interface

interface leapfrog_2level_A
  module procedure leapfrog_2level_A_2d_complex, &
                   leapfrog_2level_A_3d_complex, &
                   leapfrog_2level_A_3d_real
end interface

interface leapfrog_2level_B
  module procedure leapfrog_2level_B_2d_complex, &
                   leapfrog_2level_B_3d_complex, &
                   leapfrog_2level_B_3d_real
end interface

character(len=128), parameter :: version = '$Id leapfrog.f90 $'
character(len=128), parameter :: tagname = '$Name: tikal $'

public :: leapfrog, leapfrog_2level_A, leapfrog_2level_B

logical :: entry_to_logfile_done = .false.

contains

!================================================================================

subroutine leapfrog_2level_A_3d_complex (a, dt_a, previous, current, future, delta_t, robert_coeff)

complex, intent(inout), dimension(:,:,:,:) :: a
complex, intent(in),    dimension(:,:,:  ) :: dt_a
integer, intent(in) :: previous, current, future
real,    intent(in) :: delta_t, robert_coeff

if(.not.entry_to_logfile_done) then
  call write_version_number(version, tagname)
  entry_to_logfile_done = .true.
endif

if(previous == current) then
  a(:,:,:,future ) = a(:,:,:,previous) + delta_t*dt_a
  a(:,:,:,current) = a(:,:,:,current ) + robert_coeff*(a(:,:,:,previous) - 2.0*a(:,:,:,current))
else
  a(:,:,:,current) = a(:,:,:,current ) + robert_coeff*(a(:,:,:,previous) - 2.0*a(:,:,:,current))
  a(:,:,:,future ) = a(:,:,:,previous) + delta_t*dt_a
endif

return
end subroutine leapfrog_2level_A_3d_complex

!================================================================================

subroutine leapfrog_2level_B_3d_complex (a, current, future, robert_coeff)

complex, intent(inout), dimension(:,:,:,:) :: a
integer, intent(in) :: current, future
real,    intent(in) :: robert_coeff

if(.not.entry_to_logfile_done) then
  call write_version_number(version, tagname)
  entry_to_logfile_done = .true.
endif

a(:,:,:,current) = a(:,:,:,current) + robert_coeff * a(:,:,:,future)

return
end subroutine leapfrog_2level_B_3d_complex

!================================================================================

subroutine leapfrog_2level_A_3d_real (a, dt_a, previous, current, future, delta_t, robert_coeff)

real, intent(inout), dimension(:,:,:,:) :: a
real, intent(in),    dimension(:,:,:  ) :: dt_a
integer, intent(in) :: previous, current, future
real,    intent(in) :: delta_t, robert_coeff

if(.not.entry_to_logfile_done) then
  call write_version_number(version, tagname)
  entry_to_logfile_done = .true.
endif

if(previous == current) then
  a(:,:,:,future ) = a(:,:,:,previous) + delta_t*dt_a
  a(:,:,:,current) = a(:,:,:,current ) + robert_coeff*(a(:,:,:,previous) - 2.0*a(:,:,:,current))
else
  a(:,:,:,current) = a(:,:,:,current ) + robert_coeff*(a(:,:,:,previous) - 2.0*a(:,:,:,current))
  a(:,:,:,future ) = a(:,:,:,previous) + delta_t*dt_a
endif

return
end subroutine leapfrog_2level_A_3d_real

!================================================================================

subroutine leapfrog_2level_B_3d_real (a, current, future, robert_coeff)

real, intent(inout), dimension(:,:,:,:) :: a
integer, intent(in) :: current, future
real,    intent(in) :: robert_coeff

if(.not.entry_to_logfile_done) then
  call write_version_number(version, tagname)
  entry_to_logfile_done = .true.
endif

a(:,:,:,current) = a(:,:,:,current) + robert_coeff * a(:,:,:,future)

return
end subroutine leapfrog_2level_B_3d_real


!================================================================================

subroutine leapfrog_2level_A_2d_complex (a, dt_a, previous, current, future, delta_t, robert_coeff)

complex, intent(inout), dimension(:,:,:) :: a
complex, intent(in),    dimension(:,:  ) :: dt_a
integer, intent(in) :: previous, current, future
real,    intent(in) :: delta_t, robert_coeff

complex, dimension(size(a,1),size(a,2),1,size(a,3)) :: a_3d
complex, dimension(size(a,1),size(a,2),1)           :: dt_a_3d

if(.not.entry_to_logfile_done) then
  call write_version_number(version, tagname)
  entry_to_logfile_done = .true.
endif

a_3d(:,:,1,:) = a
dt_a_3d(:,:,1) = dt_a
call leapfrog_2level_A_3d_complex(a_3d, dt_a_3d, previous, current, future, delta_t, robert_coeff)
a = a_3d(:,:,1,:)

end subroutine leapfrog_2level_A_2d_complex
!================================================================================

subroutine leapfrog_2level_B_2d_complex (a, current, future, robert_coeff)

complex, intent(inout), dimension(:,:,:) :: a
integer, intent(in) :: current, future
real,    intent(in) :: robert_coeff
complex, dimension(size(a,1),size(a,2),1,size(a,3)) :: a_3d

if(.not.entry_to_logfile_done) then
  call write_version_number(version, tagname)
  entry_to_logfile_done = .true.
endif

a_3d(:,:,1,:) = a
call leapfrog_2level_B_3d_complex (a_3d, current, future, robert_coeff)
a = a_3d(:,:,1,:)

end subroutine leapfrog_2level_B_2d_complex
!================================================================================

subroutine leapfrog_3d_complex(a, dt_a, previous, current, future, delta_t, robert_coeff)

complex, intent(inout), dimension(:,:,:,:) :: a
complex, intent(in),    dimension(:,:,:  ) :: dt_a
integer, intent(in) :: previous, current, future
real,    intent(in) :: delta_t, robert_coeff

if(.not.entry_to_logfile_done) then
  call write_version_number(version, tagname)
  entry_to_logfile_done = .true.
endif

if(previous == current) then
  a(:,:,:,future ) = a(:,:,:,previous) + delta_t*dt_a
  a(:,:,:,current) = a(:,:,:,current ) + robert_coeff*(a(:,:,:,previous) - 2.0*a(:,:,:,current) + a(:,:,:,future ))
else
  a(:,:,:,current) = a(:,:,:,current ) + robert_coeff*(a(:,:,:,previous) - 2.0*a(:,:,:,current))
  a(:,:,:,future ) = a(:,:,:,previous) + delta_t*dt_a
  a(:,:,:,current) = a(:,:,:,current ) + robert_coeff*a(:,:,:,future)
endif

return
end subroutine leapfrog_3d_complex

!================================================================================

subroutine leapfrog_2d_complex(a, dt_a, previous, current, future, delta_t, robert_coeff)

complex, intent(inout), dimension(:,:,:) :: a
complex, intent(in),    dimension(:,:  ) :: dt_a
integer, intent(in) :: previous, current, future
real,    intent(in) :: delta_t, robert_coeff

complex, dimension(size(a,1),size(a,2),1,size(a,3)) :: a_3d
complex, dimension(size(a,1),size(a,2),1)           :: dt_a_3d

if(.not.entry_to_logfile_done) then
  call write_version_number(version, tagname)
  entry_to_logfile_done = .true.
endif

a_3d(:,:,1,:) = a
dt_a_3d(:,:,1) = dt_a
call leapfrog_3d_complex(a_3d, dt_a_3d, previous, current, future, delta_t, robert_coeff)
a = a_3d(:,:,1,:)

return
end subroutine leapfrog_2d_complex

!================================================================================

end module leapfrog_mod

             
module bgrid_core_mod

!-----------------------------------------------------------------------
!
!              gfdl global b-grid dynamical core
!
!           (with eta and hybrid pressure coordinate)
!
!-----------------------------------------------------------------------
!--------------------------- modules -----------------------------------
!-----------------------------------------------------------------------

use bgrid_prog_var_mod    , only: prog_var_type, var_init,   &
                                  prog_var_times_scalar
use bgrid_horiz_mod       , only: horiz_grid_type
use bgrid_vert_mod        , only: vert_grid_type, compute_pres_depth, &
                                  compute_pressures
use bgrid_masks_mod       , only: grid_mask_type, grid_masks_init
use bgrid_advection_mod   , only: advection_init, advection, advection_end
use bgrid_horiz_diff_mod  , only: horiz_diff_init, horiz_diff
use bgrid_horiz_adjust_mod, only: horiz_adjust_vel, horiz_adjust_mass,  &
                                  press_grad, compute_grad_pres, div_damping, &
                                  press_grad_fv
use bgrid_vert_adjust_mod , only: vert_adjust
use bgrid_polar_filter_mod, only: pfilt_control_type, polar_filter_init, &
                                  polar_filter, polar_filter_wind, TGRID
use bgrid_halo_mod        , only: update_halo, TEMP, UWND, VWND
use bgrid_sponge_mod      , only: sponge_driver, sponge_init

use                fms_mod, only: error_mesg, FATAL, write_version_number,        &
                                  mpp_clock_id, mpp_clock_begin, mpp_clock_end,   &
                                  MPP_CLOCK_SYNC, CLOCK_MODULE_DRIVER, uppercase, &
                                  stdlog
use          constants_mod, only:  CP_AIR, RDGAS, RVGAS

use  field_manager_mod, only: MODEL_ATMOS
use tracer_manager_mod, only: get_tracer_index

!-----------------------------------------------------------------------

implicit none
private

public  update_bgrid_core, bgrid_core_init, bgrid_core_end

public  bgrid_dynam_type

!-----------------------------------------------------------------------
!  ----- defined data types -----
!    Hgrid = horizontal grid constants
!    Vgrid = vertical grid constants
!    Masks = eta coordinate topography masks and indices
!    Pfilt = polar filter constants
!
!  ----- 2-dimensional (nlon,nlat) fields -----
!    fis  = geopotential height of the surface
!    fisl = geopotential height at eta=1. (for eta coord = 0.0,
!    res  = reciprical of eta at the surface
!
!  ----- time step terms ----
!    nt_adv = no. of advection time steps per atmosphere step (integer)
!    nt_adj = no. of adjustment time steps per advection step (integer)
!    dt_adj = adjustment time step in seconds (real)
!
!  ----- miscellaneous ----
!    fopt        = filtering option [integer]
!    pgf_method  = pressure gradient algorithm [integer]
!    sphum       = tracer index for specific humidity [integer]
!    coeff_ddamp = coefficient for divergence damping [real]
!    avg_omega   = omega averaging flag [logical]
!    verbose     = verbose flag [integer]
!-----------------------------------------------------------------------

type bgrid_dynam_type
   type(horiz_grid_type), pointer  :: Hgrid => NULL()
   type (vert_grid_type), pointer  :: Vgrid => NULL()
   type (grid_mask_type)           :: Masks
   type (pfilt_control_type)       :: Pfilt
   real, pointer, dimension(:,:)   :: fis  => NULL(), &
                                      fisl => NULL(), &
                                      res  => NULL()
   real                            :: dt_adj
   real                            :: coeff_ddamp
   integer                         :: nt_adv, nt_adj
   integer                         :: fopt, verbose
   integer                         :: pgf_method
   integer                         :: sphum
   logical                         :: avg_omega
end type bgrid_dynam_type

!-----------------------------------------------------------------------
!------- internal options ---------!  alpha_implicit determines how the
                                   !  coriolis and press grad force
   real  :: alpha_implicit = 0.5   !  terms are solved
                                   !    = 0.5  trapezoidal implicit
                                   !    = 1.0        fully implicit


! parameters for pressure gradient scheme
   integer, parameter :: SIMMONS_BURRIDGE=0, FINITE_VOLUME=1

!---- internal parameters ----

   real, parameter :: d608 = (RVGAS-RDGAS)/RDGAS

!---- version number ----

   character(len=128) :: version='$Id: bgrid_core.F90,v 19.0 2012/01/06 19:53:27 fms Exp $'
   character(len=128) :: tagname='$Name: tikal $'

!---- performance timing info ----

   integer :: id_advect, id_adjust
   logical :: do_clock_init = .true.

!-----------------------------------------------------------------------

contains

!#######################################################################

 subroutine bgrid_core_init (Dynam, Hgrid, Vgrid, fis, res, dt, ntadj, ntadv,   &
                              pgf_scheme, filter_option, filter_weight,   &
                              ref_lat_filter, ddamp_coeff, avg_omega,     &
                              verbose)

   type(bgrid_dynam_type), intent(inout)     :: Dynam
   type(horiz_grid_type), intent(in), target :: Hgrid
   type (vert_grid_type), intent(in), target :: Vgrid
   real, intent(in), dimension(:,:),  target :: fis, res
   real,            intent(in)               :: dt
   integer,         intent(in)               :: ntadj, ntadv

!          ---- optional arguments ----

   character(len=*),intent(in), optional :: pgf_scheme
   integer,         intent(in), optional :: filter_option,   &
                                            filter_weight,   &
                                            verbose
   real,            intent(in), optional :: ref_lat_filter,   &
                                            ddamp_coeff
   logical,         intent(in), optional :: avg_omega

!-----------------------------------------------------------------------
!
!    performs initialization for b-grid dynamics type
!
! input:  Hgrid      horizontal grid constants
!         Vgrid      vertical grid constants
!         fis        geopotential height of the surface
!         res        reciprocal of eta at the surface
!
!         dt         adjustment time step in seconds
!         ntadj      number of adjustment time steps for each
!                    advective time step [integer]
!         ntadv      number of advection time steps for each
!                    update call [integer]
!
!         IMPORTANT:  The input arguments (Hgrid, Vgrid, fis, res)
!                     must have space in memory for the entire
!                     duration of the model integration
!
! input (optional):
!
!  filter_option       Determines how polar filtering is performed.
! 
!  filter_weight       Weight applied to the polar filter that will
!                      increase (or decrease) the strength of the standard
!                      polar filter response function.
!
!  ref_lat_filter      The reference latitude at which polar filtering
!                      (in each hemisphere) will begin to be applied.
!
!  ddamp_coeff         Coefficient for divergence damping.
!
!  verbose             Flag that control additional printed output
!                      Currently, this option is not being used.
!
!  avg_omega           return the omega diagnostic averaged over all
!                      adjustment time steps
!
! NOTE: also see bgrid_core_driver for description of optional arguments
!
!-----------------------------------------------------------------------
   integer :: logunit
!  ---- required time step arguments -----

   Dynam % nt_adj = ntadj
   if (Dynam % nt_adj <= 0) call error_mesg ('bgrid_core_init',  &
                            'input argument ntadj must be >= 1', FATAL)

   Dynam % nt_adv = ntadv
   if (Dynam % nt_adv <= 0) call error_mesg ('bgrid_core_init',  &
                            'input argument ntadv must be >= 1', FATAL)

   Dynam % dt_adj = dt / float(Dynam%nt_adv*Dynam%nt_adj)
   if (Dynam % dt_adj <= 0.0) call error_mesg ('bgrid_core_init',  &
                             'input argument dt must be > 0.', FATAL)

!  ---- optional arguments ----

   Dynam % fopt = 2
   if (present(filter_option)) Dynam % fopt = filter_option

   Dynam % verbose = 0
   if (present(verbose)) Dynam % verbose = max(0, verbose)

   Dynam % avg_omega = .false.
   if (present(avg_omega)) Dynam % avg_omega = avg_omega

!  initialize performance clock 
   if (do_clock_init) then
     ! initialize performance timing
       id_advect = mpp_clock_id ('BGRID: advect loop', &
                           flags=MPP_CLOCK_SYNC, grain=CLOCK_MODULE_DRIVER)
       id_adjust = mpp_clock_id ('BGRID: adjust loop', &
                           flags=MPP_CLOCK_SYNC, grain=CLOCK_MODULE_DRIVER)
       do_clock_init = .false.
   endif
!-----------------------------------------------------------------------
!     ------ pointers ------

   Dynam % Hgrid => Hgrid
   Dynam % Vgrid => Vgrid
   Dynam % fis   => fis
   Dynam % res   => res

!-----------------------------------------------------------------------
!     ------- allocate space for other variables -------

   Dynam%fisl => var_init (Dynam%Hgrid)

!-----------------------------------------------------------------------
!  ---- eta coordinate masks ----

   call grid_masks_init ( Dynam%Hgrid, Dynam%Vgrid, Dynam%res, Dynam%Masks )

!  ---- define sea level geop height ----
   if (Dynam%Masks%sigma) then
        Dynam%fisl = Dynam%fis
   else
        Dynam%fisl = 0.0
   endif

!-----------------------------------------------------------------------
!       ---- initialize polar filtering -----

   call polar_filter_init ( Dynam%Pfilt, Dynam%Hgrid, Dynam%Vgrid%nlev,    &
                            reflat=ref_lat_filter, weight=filter_weight,   &
                            sigma=Dynam%Masks%sigma, verbose=Dynam%verbose )

!-----------------------------------------------------------------------
!------- initialization of other bgrid_core modules ----------

     call advection_init  ( Dynam%Hgrid )
     call horiz_diff_init ( Dynam%Hgrid )
     call sponge_init     ( Dynam%Hgrid )

!-----------------------------------------------------------------------
!------- save other settings -----

   ! divergence damping
     Dynam % coeff_ddamp = ddamp_coeff     
   ! tracer index for specific humidity
     Dynam % sphum = get_tracer_index ( MODEL_ATMOS, 'sphum' )
   ! pressure gradient scheme option
     if (uppercase(trim(pgf_scheme)) == 'SIMMONS_BURRIDGE') then
            Dynam % pgf_method = SIMMONS_BURRIDGE
     else if (uppercase(trim(pgf_scheme)) == 'FINITE_VOLUME') then
            Dynam % pgf_method = FINITE_VOLUME
            ! cannot use FV pgf with shallow water version (nlev=1)
            if (Dynam%Vgrid%nlev == 1) call error_mesg ('bgrid_core_init', &
                                    'invalid PGF scheme when nlev=1', FATAL)
     else if (uppercase(trim(pgf_scheme)) == 'DEFAULT') then
            Dynam % pgf_method = SIMMONS_BURRIDGE
     else
            call error_mesg ('bgrid_core_init',  &
                             'invalid PGF scheme', FATAL)
     endif

!-----------------------------------------------------------------------

     call write_version_number(version, tagname)

     logunit = stdlog()
     write (logunit,10) dt, dt/real(Dynam%nt_adv), Dynam%dt_adj
  10 format (/,'dynamical core time step (seconds) = ',f7.2, &
             /,'     advective time step (seconds) = ',f7.2, &
             /,'    adjustment time step (seconds) = ',f7.2,/)

!-----------------------------------------------------------------------

 end subroutine bgrid_core_init

!#######################################################################

 subroutine update_bgrid_core (Var, Var_dt, Dynam, omega, div, mfew, mfns )

!-----------------------------------------------------------------------
! Var       = prognostic variables
! Var_dt    = prognostic variable tendencies
! Dynam     = data type for dynamical core constants and data
! omega     = omega (vertical velocity) diagnostic (Pa/s)
!-----------------------------------------------------------------------
   type (prog_var_type), intent(in)    :: Var
   type (prog_var_type), intent(inout) :: Var_dt
   type(bgrid_dynam_type), intent(inout) :: Dynam
   real, intent(out), dimension(Dynam%Hgrid%ilb:Dynam%Hgrid%iub, &
                                Dynam%Hgrid%jlb:Dynam%Hgrid%jub, &
                                Dynam%Vgrid%nlev) :: omega, div, mfew, mfns
!-----------------------------------------------------------------------

real, dimension(Dynam%Hgrid%ilb:Dynam%Hgrid%iub, &
                Dynam%Hgrid%jlb:Dynam%Hgrid%jub) :: psdt

real, dimension(Dynam%Hgrid%ilb:Dynam%Hgrid%iub, &
                Dynam%Hgrid%jlb:Dynam%Hgrid%jub) :: pssl

real, dimension(Dynam%Hgrid%ilb:Dynam%Hgrid%iub, &
                Dynam%Hgrid%jlb:Dynam%Hgrid%jub, Dynam%Vgrid%nlev) :: &
                dpde, few, fns, divp, pgfew, pgfns, dpde_old,          &
                pfull, wta, wtb, cew, cns, u, v, tq, uo, vo, to, omgalf

real, dimension(Dynam%Hgrid%ilb:Dynam%Hgrid%iub, &
                Dynam%Hgrid%jlb:Dynam%Hgrid%jub, Dynam%Vgrid%nlev+1)  &
                :: phalf, etadot

   real    :: fadv, tdt_adj, scale
   integer :: i, k, n, m, nt
!-----------------------------------------------------------------------
!    ---- definition of local variables ----
!
!    psdt  = surface pressure tendency (Pa/s)
!    pssl  = surface pressure adjusted to eta=1.
!    tq    = (virtual) temperature
!    divp  = mass divergence (Pa/s)
!    pgfew = zonal pressure gradient force (at v pts) (m/s2)
!    pgfns = meridional pressure gradient force (at v pts) (m/s2)
!    dpde  = pressure thickness of model layers (Pa)
!    pfull = pressure at full model levels
!    phalf = pressure at half model levels (between full levels)
!    wta,
!      wtb = weights for obtaining the pressure at full levels (no units)
!    cew,
!      cns = grad(p)/p term (zonal and meridional components) (no units)
!    few,
!      fns = mass fluxes time summed over advection interval (Pa-m2/s)
!            (zonal and meridional components)
!   etadot = vertical mass flux summed over advection interval (Pa/s)
!   omgalf = thermodynamic (omega-alpha) term (Pa/s)
!   uo,vo,to = momentum and temperature at the start of an advective time step
!   dpde_old = pressure thickness of model layers at the start of an advective time step
!
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!------- number of tracers and variable (time) levels ---------

    nt = Var%ntrace

!   ---- set-up time step ----

    tdt_adj = Dynam % dt_adj

!   ------ pressure variables ------

    pssl = Var % pssl + tdt_adj * Var_dt % pssl

    call compute_pressures ( Dynam%Vgrid, pssl,           &
                             phalf, pfull, dpde, wta, wtb )

    call compute_grad_pres ( Dynam%Hgrid, Dynam%Vgrid%nplev, &
                             phalf, dpde, wta, wtb, cew, cns )

!   ------ zero fluxes and diagnostic output -----

    few     = 0.0;  fns     = 0.0;  etadot     = 0.0

    omega = 0.0;  div = 0.0;  mfew = 0.0;  mfns = 0.0

!-----------------------------------------------------------------------
!************** start of bgrid_core time step loop *********************
call mpp_clock_begin (id_advect)

 do m = 1, Dynam % nt_adv

!   ------ save this time level for advection ------

    dpde_old = dpde

    to = Var % t + tdt_adj * Var_dt % t
    uo = Var % u + tdt_adj * Var_dt % u
    vo = Var % v + tdt_adj * Var_dt % v

!   ------ variables at current time level ------

    tq = to
    call compute_virt_temp ( Dynam%sphum, tq, Var%r, Var_dt%r, tdt_adj )
    u  = uo
    v  = vo

!-----------------------------------------------------------------------
!*************** start of adjustment time step loop ********************
call mpp_clock_end   (id_advect)
call mpp_clock_begin (id_adjust)

 do n = 1, Dynam % nt_adj

!-----------------------------------------------------------------------
!------------------------- compute mass divergence ---------------------
!--------------------- horizontal alpha-omega term ---------------------

   call horiz_adjust_mass ( Dynam%Vgrid%nplev, Dynam%Hgrid, &
                            Dynam%Masks,       u,           &
                            v,                 dpde,        &
                            cew,               cns,         &
                            few,               fns,         &
                            divp,              omgalf       )


!    ---- polar filtering -----

     if (Dynam%fopt >= 1) then
       call polar_filter (Dynam%Pfilt, divp, omgalf, TGRID, Dynam%Masks%Tmp%mask)
     endif

     call update_halo (Dynam%Hgrid, TEMP, divp  )
     call update_halo (Dynam%Hgrid, TEMP, omgalf)

!--- save divergence diagnostic (units: 1/sec) ---
     div = div + divp/dpde

!-----------------------------------------------------------------------
!------- compute sfc pres tendency, vert. alpha-omega, & vert vel.------

    call vert_adjust ( Dynam%Vgrid, Dynam%res, divp, wta, wtb,    &
                       Dynam%Masks%Tmp%mask, omgalf, etadot, psdt )     

!-----------------------------------------------------------------------
!-------- update surface pressure tendency -----------------------------

    Var_dt % ps   = Var_dt % ps   + psdt
    Var_dt % pssl = Var_dt % pssl + psdt * Dynam % res

!-------- recompute pressure variables at next time level -----------

    pssl = Var % pssl + tdt_adj * Var_dt % pssl
    call compute_pressures ( Dynam%Vgrid, pssl, phalf, pfull, dpde, &
                             wta, wtb )

!----- do not execute the following code -----
!   with the shallow water version (nlev=1)
    if (Dynam%Vgrid%nlev > 1) then
!-------- update thermodynamic tendency ----------

       omgalf = omgalf/dpde
       Var_dt % t = Var_dt % t + omgalf * tq * RDGAS/CP_AIR

!  ---- compute omega diagnostic (Pa/s) ----

       if (Dynam%avg_omega) then
          omega = omgalf * pfull + omega
       else
          omega = omgalf * pfull
       endif

    endif

!-----------------------------------------------------------------------
!------------ compute geopotential height and rt/p ---------------------
!     ----- (use smoothed value for pssl if leapfrog) ----

    tq = Var % t + tdt_adj * Var_dt % t
    call compute_virt_temp ( Dynam%sphum, tq, Var%r, Var_dt%r, tdt_adj )

    call compute_grad_pres ( Dynam%Hgrid, Dynam%Vgrid%nplev, &
                             phalf, dpde, wta, wtb, cew, cns )


  select case (Dynam%pgf_method)
    case (SIMMONS_BURRIDGE)
      call press_grad ( Dynam%Hgrid, Dynam%Vgrid, Dynam%Masks,    &
                        Dynam%fisl, tq, dpde, wta, wtb, cew, cns, &
                        pgfew, pgfns )
    case (FINITE_VOLUME)
      call press_grad_fv ( Dynam%Hgrid, Dynam%Vgrid, Dynam%Masks, &
                           Dynam%fisl, tq, phalf, wta, wtb,       &
                           pgfew, pgfns )
  end select

!------------------- adjustment of wind components ---------------------

    call horiz_adjust_vel ( Dynam%Hgrid, Dynam%Masks,                &
                                        tdt_adj, pgfew, pgfns,       &
                            u, v, Var_dt%u, Var_dt%v, alpha_implicit )

  ! polar filtering of momentum (new scheme)
    if (Dynam%fopt == 2)  &
    call prog_var_filter_vel ( Dynam%Pfilt, tdt_adj, Dynam%Masks%Vel%mask, &
                               Var%u, Var%v, Var_dt%u, Var_dt%v            )

!-----------------------------------------------------------------------
!----------------------- advection -------------------------------------

    if (n ==  Dynam%nt_adj) then
        call mpp_clock_end   (id_adjust)
        call mpp_clock_begin (id_advect)

        ! accumulate mass fluxes for diagnostic output
              mfew = mfew + few
              mfns = mfns + fns

         call advection ( Dynam%Pfilt,                           &
                          Dynam%Hgrid, Dynam%Vgrid, Dynam%Masks, &
                          Dynam%fopt, tdt_adj, dpde_old, dpde,   &
                          few, fns, etadot,                      &
                          uo, vo, to,   Var, Var_dt              )

        call mpp_clock_end   (id_advect)
        call mpp_clock_begin (id_adjust)
    endif

!-----------------------------------------------------------------------

  ! polar filtering of momentum (old scheme)
    if (Dynam%fopt == 1)  &
    call prog_var_filter_vel ( Dynam%Pfilt, tdt_adj, Dynam%Masks%Vel%mask, &
                               Var%u, Var%v, Var_dt%u, Var_dt%v            )

  ! damping using filtered divergence
    if (abs(Dynam % coeff_ddamp) > 1.e-8) then
      call div_damping ( Dynam%Hgrid, Dynam%Vgrid, Dynam%Masks, &
                         tdt_adj, Dynam % coeff_ddamp,          &
                         dpde, divp, Var_dt%u, Var_dt%v )
    endif

!   ---- recompute momentum at next time level ----

    call update_halo (Dynam%Hgrid, UWND, Var_dt%u )
    call update_halo (Dynam%Hgrid, VWND, Var_dt%v )

    u = Var % u + tdt_adj * Var_dt % u
    v = Var % v + tdt_adj * Var_dt % v

!-----------------------------------------------------------------------

 enddo
 call mpp_clock_end   (id_adjust)
 call mpp_clock_begin (id_advect)

!-----------------------------------------------------------------------
!----------------- horizontal diffusion --------------------------------

    call horiz_diff ( Dynam%Hgrid, Dynam%Masks, Dynam%Vgrid%nplev, &
                      tdt_adj, dpde, pfull, Var, Var_dt            )

!-----------------------------------------------------------------------
!----------------- sponge at top of model -------------------

    call sponge_driver ( Dynam%Hgrid, Dynam%Vgrid%nplev, &
                         tdt_adj, dpde, Var, Var_dt      )

!    ---------------- halo updates --------------------
!    skip on the last pass will update last when needed

    if (m == Dynam % nt_adv) cycle
    call update_halo (Dynam%Hgrid, TEMP, Var_dt%t )
    call update_halo (Dynam%Hgrid, TEMP, Var_dt%r )
    call update_halo (Dynam%Hgrid, UWND, Var_dt%u )
    call update_halo (Dynam%Hgrid, VWND, Var_dt%v )

!-----------------------------------------------------------------------

 enddo
 call mpp_clock_end   (id_advect)

!-----------------------------------------------------------------------
!  ---- scale tendencies before physics for time step difference ----

   scale = 1.0 / float(Dynam%nt_adj*Dynam%nt_adv)
   call prog_var_times_scalar (Var_dt, scale)

  !-- return time averaged diagnostic quantities --
   if (Dynam%avg_omega) omega = omega * scale
   div  = div  * scale
   mfew = mfew * scale
   mfns = mfns * scale

!-----------------------------------------------------------------------

 end subroutine update_bgrid_core
        
!#######################################################################

 subroutine bgrid_core_end (Dynam)

!-----------------------------------------------------------------------
   type(bgrid_dynam_type), intent(inout) :: Dynam
!-----------------------------------------------------------------------
! Dynam = data type for dynamical core constants and data

   call advection_end

!-----------------------------------------------------------------------

 end subroutine bgrid_core_end

!#######################################################################

 subroutine compute_virt_temp ( sphum, tq, r, rdt, dt )

  integer, intent(in) :: sphum
  real, intent(inout) :: tq(:,:,:)
  real, intent(in)    :: r (:,:,:,:), rdt(:,:,:,:), dt

  real, dimension(size(r,1),size(r,2),size(r,3)) :: q

! compute virtual temperature
! using temperature and specific humidity (in the tracer array)

    if ( size(r,4) == 0 ) return
    if ( sphum <= 0 ) return

    q  = r(:,:,:,sphum) + dt * rdt(:,:,:,sphum)
    tq = tq * ( 1. + d608 * q )

 end subroutine compute_virt_temp

!#######################################################################
!-------- polar filter routine for momentum components ---------

 subroutine prog_var_filter_vel ( Pfilt, dt, mask, u, v, udt, vdt )

 type(pfilt_control_type), intent(in)    :: Pfilt
 real,                     intent(in)    :: dt
 real, dimension(:,:,:),   intent(in)    :: mask
 real, dimension(:,:,:),   intent(in)    :: u, v
 real, dimension(:,:,:),   intent(inout) :: udt, vdt

   real, dimension(size(u,1),size(u,2),size(u,3)) :: ut, vt

!  ---- momentum ----
     ut = u + dt*udt
     vt = v + dt*vdt
     call polar_filter_wind ( Pfilt, ut, vt, mask )
     udt = (ut-u)/dt
     vdt = (vt-v)/dt

 end subroutine prog_var_filter_vel

!#######################################################################
!#######################################################################

end module bgrid_core_mod

module ocean_residency_mod  !{
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies 
!</REVIEWER>
!
!<OVERVIEW>
! Ocean residency module
!</OVERVIEW>
!
!<DESCRIPTION>
!
!       This module is a superset of the ocean age tracer module. It may
!       be used to reproduce the age tracer, but it can also do much
!       more. Unlike the ocean age tracer module, here you may specify
!       a 3-d field by specifying a series of "rectangular prisms".
!       The grid cells which occupy this field may vary with time due
!       to the variations in the thickness of the surface layer.
!
!       You may also specify a 3-d field by choosing one of three mixed-layers
!       (KPP, density-derived or buoyancy-derived). You may also specify a
!       region based on a a range of a prognostic or diagnostic ocean
!       tracer (such as all points with a temperature of 10-20 degrees).
!
!       You may specify either the mixed-layer method or the tracer range along
!       with the geographic specification. If multiple methods are used, then 
!       the resultant field is the intersection of the two methods. In fact, the
!       geographic method is always in use, and defaults to the whole ocean.
!
!       There is an option of using the inverse of any method. This is sometimes
!       easier to use than explicitly specifying the inverse. For instance,
!       to get the temperatures outside of the range 10-20 degrees, one could
!       specify the 10-20 degree range and set <swap> to true, or, specify two
!       different regions, one less than 10 degrees and one greater than 20 degrees.
!
!       By default, the values inside the specified region are set to a
!       specified value each time-step (default is 0), and outside of this region
!       the field is integrated over time in units of years (integrand is
!       1/(365.25*86400) by default, but this value can be changed. The inner region
!       can be forced to be 0 (or the user-specified inner value) at each time-step
!       (the default), or it can be restored to this value at a user-specified
!       rate (given in days), or, it can be left alone (not integrated or set to
!       any value).
!       
!       Finally, since we are just integrating a specified field by a constant value
!       (by default), it is simple to make that field a simple function of another
!       tracer. This is the final option. You may specify a prognostic or diagnostic
!       variable to be the integrand, and have it scaled by a constant. One case
!       which has been done is to integrate irradiance in the mixed-layer.
!       
!       This module is split into several different modules. This particular module
!       is the only one called from outside, and it makes appropriate calls to 
!       the other modules to implement its features. This was done so that it would
!       be easier to expand the features of the ocean residency, without cluttering
!       the code too much. Ideally, this could all be done with classes, but there
!       is currently no support for classes in Fortran (pre-F2003). The current
!       modules are:
!
!       ocean_residency.F90             This module, the control center, and also does the
!                                       integrations and resetting in the inner regions.
!       ocean_residency_meta.F90        Has specifications of the ocean_residency type
!                                       and other utility routines. This is separate
!                                       to stop circular references
!       ocean_residency_ml.F90          Handles setting mixed-layer masks
!       ocean_residency_range.F90       Handles setting the masks for the tracer ranges
!       ocean_residency_integrand.F90   Handles setting the integrand to a non-constant
!                                       value
!
!       field_table namelist inputs:
!
!       The following 6 arrays specify the bounds of boxes, the intersection of which
!       will define the region where the integrand is set to restore_region_value. ALl arrays
!       must have the same number of elements. If none are specified, then no region will
!       be used, unless swap is true, which is a quick way of selecting the entire ocean.
!       This may be useful when one really wants to use one of the other methods of selecting,
!       such as mixed layer depth, or tracer range.
!
!       Longitudes will be shifted to lie in the range 0-360 degrees. If the eastern side is
!       greater than the western, then the selected region will consist of those grid cells from
!       the eastern value to 360, and 0 to the western value. If the northern value is less than
!       the southern value, or if the top depth is greater than the bottom depth, then
!       an error occurs, and the model stops.
!
!       Three special cases exist for the depth (which currently must be in meters).
!       If the bottom value is less than or equal to zero, then the top box is selected. 
!       If the top value is greater than the maximum depth, then the bottom box is selected.
!       If the top value is negative, then grid cells within "the absolute value of the top value"  
!       from the bottom are selected.
!
!       Note that the geographic specification is used for all residency tracers, so either
!       values for these 6 arrays must be given so as to select a region, or else swap must
!       be set to true and no arrays given.
!
!               east_bnd: array of boundary points of the eastern side of the box,
!                         in degrees longitude (default: NULL)
!              north_bnd: array of boundary points of the northern side of the box,
!                         in degrees latitude (default: NULL)
!              south_bnd: array of boundary points of the southern side of the box,
!                         in degrees latitude (default: NULL)
!               west_bnd: array of boundary points of the western side of the box,
!                         in degrees longitude (default: NULL)
!                top_bnd: array of boundary points of the top side of the box,
!                         in meters (default: NULL)
!             bottom_bnd: array of boundary points of the bottom side of the box,
!                         in meters (default: NULL)
!
!                   swap: if true, then select the inverse of the specified geographic region,
!                         otherwise, just use the specified region (default: false)
!                restore: restoring value for values in the defined regions
!                         negative => do nothing, 0 => force to integrate_region_value,
!                         positive => time scale in days to force to integrate_region_value
!                         (default: 0.0)
!   restore_region_value: value to set the mask to for grid cells within
!                         the specified region (default: 0.0)
! integrate_region_value: value to set the mask to for grid cells outside
!                         the specified region (default: secs_in_year_r)
!            swap_module: if true, then select the inverse of the region from the specified module,
!                         otherwise, just use the specified region (default: false)
!            module_name: if set, then it will be used to select the alternate
!                         method of selecting the region (default: ' ' -- only geographic
!                         selection is used)
!
!       For the following arrays, see the different extra modules for required and
!       possible values for the module selected.
!
!                 params: an array of real parameters which may be used for the method
!                         being used for selection (default: NULL)
!                  flags: an array of real parameters which may be used for the method
!                         being used for selection (default: NULL)
!                strings: an array of real parameters which may be used for the method
!                         being used for selection (default: NULL)
!
!       For the following arrays, see the different extra modules for required and
!       possible values for the module selected to specify the integrand.

!        int_module_name: if set, then the name of the module used to set
!                         the integrand (default: ' ' -- integrate time, in years)
!             int_params: an array of real parameters which may be used for the integrand
!                         (default: NULL)
!              int_flags: an array of real parameters which may be used for the integrand
!                         (default: NULL)
!            int_strings: an array of real parameters which may be used for the integrand
!                         (default: NULL)
!
!----------------------------------------------------------------------------------------
!
!       Sample field table entries:
!       ---------------------------
!
! "tracer_packages","ocean_mod","ocean_residency"
! names = age_surface, age_bottom_inv, kppbl_nil, kppbl_14d, kppbl_frc, kppbl_irr_14d, temp_15_20
! horizontal-advection-scheme = mdppm
! vertical-advection-scheme = mdppm
! units = yr
! min_tracer_limit=0.0
! /
!
!       This is the same as the old age tracer with all surface
!       values forced to zero
! 
! "namelists","ocean_mod","ocean_residency/age_surface"
! south_bnd = -90.0
! north_bnd =  90.0
! west_bnd =   0.0
! east_bnd = 360.0
! top_bnd = 0.0
! bottom_bnd = 0.0
! /
!
!       This integrates the age in the bottom box and forces to
!       zero everywhere else (note that swap is true)
! 
! "namelists","ocean_mod","ocean_residency/age_bottom_inv"
! south_bnd = -90.0
! north_bnd =  90.0
! west_bnd =   0.0
! east_bnd = 360.0
! top_bnd = 10000.0
! bottom_bnd = 10000.0
! swap = t
! /
!
!       This integrates the age of the water in the KPP
!       boundary layer, but lets the age outside of this region
!       keep its value until it again mixes with the boundary layer.
!       The module_name is set, and strings is set to pick the
!       type of mixed layer desired
!       (note that the global geographic area is explicitly specified,
!       and that the restoring time scale is negative)
! 
! "namelists","ocean_mod","ocean_residency/kppbl_nil"
! south_bnd = -90.0
! north_bnd =  90.0
! west_bnd =   0.0
! east_bnd = 360.0
! top_bnd = 0.0
! bottom_bnd = 10000.0
! restore = -1.0
! module_name = ocean_residency_ml
! strings = kpp_bl
! swap_module = t
! /
!
!       This is the same as above, but forces the age outside
!       the boundary layer to 0 with a 14 day time scale
!       (note that the global geographic region is specified by
!       setting swap to true, also note the value of restore)
! 
! "namelists","ocean_mod","ocean_residency/kppbl_14d"
! swap = t
! restore = 14.0
! module_name = ocean_residency_ml
! strings = kpp_bl
! swap_module = t
! /
!
!       This is the same as above, but forces age to zero outside
!       the boundary layer (note that restore did not need to
!       be explicitly specified, as the default is zero)
! 
! "namelists","ocean_mod","ocean_residency/kppbl_frc"
! swap = t
! restore = 0.0
! module_name = ocean_residency_ml
! strings = kpp_bl
! swap_module = t
! /
!
!       The following integrates irradiance in the boundary
!       layer (note that the units needed to be changed for
!       netCDF output purposes)
! 
! "prog_tracers","ocean_mod","residency_kppbl_irr_14d"
! units = W-yr/m^2
! /
! 
! "namelists","ocean_mod","ocean_residency/kppbl_irr_14d"
! swap = t
! restore = 14.0
! module_name = ocean_residency_ml
! strings = kpp_bl
! swap_module = t
! int_module_name = ocean_residency_integrand
! int_strings = irr
! /
!
!       This specifies the region as the area with
!       a temperature range of between 15 and 20 degrees
!       (note that the params holds the variable
!       range)
! 
! "namelists","ocean_mod","ocean_residency/temp_15_20"
! swap = t
! module_name = ocean_residency_range
! strings = tracer_range, temp
! params = 15.0, 20.0
! /
!
!</DESCRIPTION>
!
! $Id: ocean_residency.F90,v 20.0 2013/12/14 00:17:04 fms Exp $
!

!
!       modules
!

use time_manager_mod,         only: time_type
use field_manager_mod,        only: fm_string_len, fm_path_name_len, fm_field_name_len
use field_manager_mod,        only: fm_get_length, fm_get_value, fm_new_value
use mpp_mod,                  only: stdout, mpp_error, FATAL, mpp_pe, mpp_root_pe
use diag_manager_mod,         only: register_diag_field, send_data

use ocean_tpm_util_mod,       only: otpm_set_tracer_package, otpm_set_prog_tracer, otpm_set_diag_tracer
use fm_util_mod,              only: fm_util_set_value
use fm_util_mod,              only: fm_util_start_namelist, fm_util_end_namelist
use fm_util_mod,              only: fm_util_get_string, fm_util_get_string_array
use fm_util_mod,              only: fm_util_get_logical, fm_util_get_logical_array
use fm_util_mod,              only: fm_util_get_integer, fm_util_get_real, fm_util_get_real_array
use fm_util_mod,              only: fm_util_check_for_bad_fields

use ocean_types_mod,               only: ocean_prog_tracer_type, ocean_diag_tracer_type
use ocean_types_mod,               only: ocean_thickness_type, ocean_time_type, ocean_density_type
use ocean_residency_meta_mod,      only: ocean_residency_set_region_geog
use ocean_residency_meta_mod,      only: instance, num_instances, secs_in_year_r, sec_per_day
use ocean_residency_ml_mod,        only: do_ocean_residency_ml
use ocean_residency_ml_mod,        only: ocean_residency_ml_start, ocean_residency_ml_source
use ocean_residency_range_mod,     only: do_ocean_residency_range
use ocean_residency_range_mod,     only: ocean_residency_range_start, ocean_residency_range_source
use ocean_residency_integrand_mod, only: do_ocean_residency_integrand
use ocean_residency_integrand_mod, only: ocean_residency_integrand_start, ocean_residency_integrand_source

!
!       force all variables to be "typed"
!

implicit none

!
!       Set all variables to be private by default

private

!
!       Public routines
!

public  :: ocean_residency_init
public  :: ocean_residency_source
public  :: ocean_residency_start
public  :: ocean_residency_tracer

!
!       Private routines
!

!
!       Public parameters
!


!
!       Private parameters
!

character(len=fm_field_name_len), parameter     :: package_name = 'ocean_residency'
character(len=48), parameter                    :: mod_name = 'ocean_residency_mod'
character(len=48), parameter                    :: diag_name = 'ocean_residency'
character(len=fm_string_len), parameter         :: default_restart_file = 'ocean_residency.res.nc'

!
!       Public variables
!

logical, public :: do_ocean_residency

!
!       Public types
!


!
!       Private variables
!

integer :: package_index

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_residency_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the tracer packages
! </DESCRIPTION>
!

subroutine ocean_residency_init  !{

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

!
!       local parameters
!

character(len=64), parameter    :: sub_name = 'ocean_residency_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!-----------------------------------------------------------------------
!       local variables
!-----------------------------------------------------------------------
!

integer                                                 :: n
integer                                                 :: nn
integer                                                 :: num_regions
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=fm_field_name_len+3)                      :: long_suffix
character(len=256)                                      :: caller_str
character(len=fm_string_len), pointer, dimension(:)     :: good_list

  integer :: stdoutunit 
  stdoutunit=stdout() 

!
!       Initialize the ocean residency package
!

package_index = otpm_set_tracer_package(package_name,                           &
     units = 'yr', flux_units = 'm',                                            &
     min_tracer_limit = 0.0, max_tracer_limit = 1.0e+20,                        &
     restart_file = default_restart_file,                                       &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')

!
!       Check whether to use this package
!

path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
num_instances = fm_get_length(path_to_names)
if (num_instances .lt. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
endif  !}

!
!       Check some things
!

write (stdoutunit,*)
if (num_instances .eq. 0) then  !{
  write (stdoutunit,*)                                            &
       trim(note_header), ' No instances'
  do_ocean_residency = .false.
else  !}{
  write (stdoutunit,*) trim(note_header), ' ', num_instances, ' instances'
  do_ocean_residency = .true.
endif  !}

!
!       Return if we don't want to use this package
!

if (.not. do_ocean_residency) then  !{
  return
endif  !}

!
!       allocate the instance array
!

allocate ( instance(num_instances) )

!
!       loop over the names, saving them into the instance array
!

do n = 1, num_instances  !{

  if (fm_get_value(path_to_names, name, index = n)) then  !{
    instance(n)%name = name
  else  !}{
    write (name,*) n
    call mpp_error(FATAL, trim(error_header) //        &
         ' Bad field name for index ' // trim(name))
  endif  !}

enddo  !} n

do n = 1, num_instances  !{

!
!       determine the tracer name for this instance
!

  name = instance(n)%name
  if (name(1:1) .eq. '_') then  !{
    suffix = ' '
    long_suffix = ' '
  else  !}{
    suffix = '_' // name
    long_suffix = ' (' // trim(name) // ')'
  endif  !}

  instance(n)%tracer_index = otpm_set_prog_tracer('residency' // trim(suffix), package_name,    &
       longname = 'Residency' // trim(long_suffix), units = 'yr',                               &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')

enddo  !} n

!
!       set up the density diagnostic tracers
!

n = otpm_set_diag_tracer('rho_in_situ', longname = 'In situ density', units = 'kg/m^3',         &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
n = otpm_set_diag_tracer('rho_neutral', longname = 'Neutral density', units = 'kg/m^3',         &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
n = otpm_set_diag_tracer('rho_pot_0', longname = 'Potential density-0', units = 'kg/m^3',       &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
n = otpm_set_diag_tracer('rho_pot_1', longname = 'Potential density-1', units = 'kg/m^3',       &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
n = otpm_set_diag_tracer('rho_pot_2', longname = 'Potential density-2', units = 'kg/m^3',       &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
n = otpm_set_diag_tracer('rho_pot_3', longname = 'Potential density-3', units = 'kg/m^3',       &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
n = otpm_set_diag_tracer('rho_pot_4', longname = 'Potential density-4', units = 'kg/m^3',       &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')

!
!-----------------------------------------------------------------------
!       Set up the instance residency namelists
!-----------------------------------------------------------------------
!

!
!       Add the package name to the list of good namelists, to be used
!       later for a consistency check
!

if (fm_new_value('/ocean_mod/GOOD/good_namelists', package_name, append = .true.) .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) //                           &
       ' Could not add ' // trim(package_name) // ' to "good_namelists" list')
endif  !}

caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, num_instances  !{

!
!       create the instance namelist
!

  call fm_util_start_namelist(package_name, instance(n)%name, caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('num_regions', 1)
  call fm_util_set_value('integrate_region_value', secs_in_year_r)
  call fm_util_set_value('union', .true.)
  call fm_util_set_value('int_module_name', ' ')
  call fm_util_set_value('int_params', 0.0, index = 0)
  call fm_util_set_value('int_flags', .false., index = 0)
  call fm_util_set_value('int_strings', ' ', index = 0)

!
!       get the number of regions so that we may set up the extra namelists
!

  num_regions =  fm_util_get_integer('num_regions', scalar = .true.)

!
!       create namelists for each region
!

  if (num_regions .le. 0) then
    call mpp_error(FATAL,trim(error_header) // ' num_regions is non-positive for instance ' //   &
         trim(instance(n)%name) // ' in package ' // trim(package_name))
  endif

  do nn = 1, num_regions  !{

    if (num_regions .eq. 1) then
      suffix = ' '
    else
      write (long_suffix,*) nn
      suffix = '_' // long_suffix(scan(long_suffix,'0123456789'):)
    endif

    call fm_util_set_value('restore' // suffix, 0.0)
    call fm_util_set_value('restore_region_value' // suffix, 0.0)
    call fm_util_set_value('swap' // suffix, .false.)
    call fm_util_set_value('swap_module' // suffix, .false.)
    call fm_util_set_value('west_bnd' // suffix, 0.0, index = 0)
    call fm_util_set_value('east_bnd' // suffix, 0.0, index = 0)
    call fm_util_set_value('south_bnd' // suffix, 0.0, index = 0)
    call fm_util_set_value('north_bnd' // suffix, 0.0, index = 0)
    call fm_util_set_value('top_bnd' // suffix, 0.0, index = 0)
    call fm_util_set_value('bottom_bnd' // suffix, 0.0, index = 0)
    call fm_util_set_value('module_name' // suffix, ' ')
    call fm_util_set_value('params' // suffix, 0.0, index = 0)
    call fm_util_set_value('flags' // suffix, .false., index = 0)
    call fm_util_set_value('strings' // suffix, ' ', index = 0)

  enddo  !} nn

  call fm_util_end_namelist(package_name, instance(n)%name, check = .true., caller = caller_str)

enddo  !} n

!
!       Check for any errors in the number of fields in the namelists for this package
!

good_list => fm_util_get_string_array('/ocean_mod/GOOD/namelists/' // trim(package_name) // '/good_values',     &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
if (associated(good_list)) then  !{
  call fm_util_check_for_bad_fields('/ocean_mod/namelists/' // trim(package_name), good_list,                   &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')
  deallocate(good_list)
else  !}{
  call mpp_error(FATAL,trim(error_header) // ' Empty "' // trim(package_name) // '" list')
endif  !}

return

end subroutine ocean_residency_init  !}
! </SUBROUTINE> NAME="ocean_residency_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_residency_source">
!
! <DESCRIPTION>
!       Calculate the source arrays for the tracer packages
! </DESCRIPTION>
!

subroutine ocean_residency_source(isc, iec, jsc, jec, isd, ied, jsd, jed, nk,   &
     T_prog, T_diag, Time, Thickness, Dens, grid_xt, grid_yt, grid_zw,          &
     grid_tmask, grid_kmt, hblt_depth)

!
!       modules
!

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
integer, intent(in)                                             :: nk
type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
type(ocean_diag_tracer_type), dimension(:), intent(inout)       :: T_diag
type(ocean_time_type), intent(in)                               :: Time
type(ocean_thickness_type), intent(in)                          :: Thickness
type(ocean_density_type), intent(in)                            :: Dens
real, dimension(isd:,jsd:), intent(in)                          :: grid_xt
real, dimension(isd:,jsd:), intent(in)                          :: grid_yt
real, dimension(:), intent(in)                                  :: grid_zw
real, dimension(isd:,jsd:,:), intent(in)                        :: grid_tmask
integer, dimension(isd:,jsd:), intent(in)                       :: grid_kmt
real, intent(in), dimension(isd:,jsd:)                          :: hblt_depth

!
!       local parameters
!

character(len=64), parameter    :: sub_name = 'ocean_residency_source'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!       local variables
!

integer :: i
integer :: ind
integer :: j
integer :: k
integer :: n
integer :: nn
logical :: used
logical :: good

  integer :: stdoutunit 
  stdoutunit=stdout() 

!
!       set the source values for the residency tracers
!

do n = 1, num_instances  !{

!
!       set the values via the input values
!

  do nn = 1, instance(n)%num_regions  !{

    call ocean_residency_set_region_geog(isd, ied, jsd, jed, nk, instance(n)%region(nn)%mask,   &
         grid_xt, grid_yt, grid_zw(nk), Thickness%depth_zt, Thickness%depth_zwt,                &
         instance(n)%region(nn)%num_geog_regions,                                               &
         instance(n)%region(nn)%west_bnd, instance(n)%region(nn)%east_bnd,                      &
         instance(n)%region(nn)%south_bnd, instance(n)%region(nn)%north_bnd,                    &
         instance(n)%region(nn)%top_bnd, instance(n)%region(nn)%bottom_bnd,                     &
         grid_kmt, t_prog(instance(n)%tracer_index)%name,                                       &
         restore_region_value = 1.0, integrate_region_value = 0.0,                              &
         swap = instance(n)%region(nn)%swap,                                                    &
         initialize = .true.)

  enddo  !} nn

enddo  !} n

!
!       set the source values for the residency tracers which need to be set in other
!       modules
!

if (do_ocean_residency_ml) then  !{
  call ocean_residency_ml_source(isd, ied, jsd, jed, nk,                &
       t_prog, time, thickness, dens, Thickness%depth_zwt, hblt_depth)
endif  !}

if (do_ocean_residency_range) then  !{
  call ocean_residency_range_source(isd, ied, jsd, jed, nk, Time%taum1, t_prog, t_diag, grid_kmt)
endif  !}

!
!       save out the mask fields for each region
!

do n = 1, num_instances  !{

  do nn = 1, instance(n)%num_regions  !{

    do k = 1, nk
      do j = jsd, jed
        do i = isd, ied
          instance(n)%region(nn)%mask(i,j,k) = instance(n)%region(nn)%mask(i,j,k) * grid_tmask(i,j,k)
        enddo
      enddo
    enddo

    if (instance(n)%region(nn)%id_restore_region .gt. 0) then  !{
      used = send_data(instance(n)%region(nn)%id_restore_region,        &
           instance(n)%region(nn)%mask(:,:,:),                          &
           Time%model_time, rmask = grid_tmask(:,:,:),                  &
           is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
    endif  !}

  enddo  !} nn

enddo  !} n

!
!       merge the mask fields into one field
!

do n = 1, num_instances  !{

  if (instance(n)%num_regions .eq. 1) then  !{

    do k = 1, nk  !{
      do j = jsd, jed  !{
        do i = isd, ied  !{
          if (grid_tmask(i,j,k) .lt. 0.5) then  !{
            instance(n)%mask(i,j,k) = 0.0
            instance(n)%index(i,j,k) = -1
          elseif (instance(n)%region(1)%mask(i,j,k) .eq. 1.0) then  !}{
            instance(n)%mask(i,j,k) = instance(n)%region(1)%restore_region_value
            instance(n)%index(i,j,k) = 1
          else  !}{
            instance(n)%mask(i,j,k) = instance(n)%integrate_region_value
            instance(n)%index(i,j,k) = 0
          endif  !}
        enddo  !} i
      enddo  !} j
    enddo  !} k

  else  !}{

    do k = 1, nk  !{
      do j = jsd, jed  !{
        do i = isd, ied  !{
          if (grid_tmask(i,j,k) .gt. 0.5) then  !{

!
!       we're looking to set the restore_region_value for any point that has at least
!       one region set
!

            if (instance(n)%union) then  !{

!
!       find the first region with a value set
!

              ind = 0
              do nn = 1, instance(n)%num_regions  !{
                if (instance(n)%region(nn)%mask(i,j,k) .eq. 1.0) then  !{
                  ind = nn
                  exit
                endif  !}
              enddo  !} nn

!
!       if ind == 0, then this point is out of all regions
!

              if (ind .ne. 0) then  !{

!
!       Quit with an error if a
!       region with a different restore_region_value also has a value set
!

                do nn = ind + 1, instance(n)%num_regions  !{
                  if (instance(n)%region(nn)%mask(i,j,k) .eq. 1.0) then  !{
                    if (instance(n)%region(nn)%restore_region_value .ne.                                &
                        instance(n)%region(ind)%restore_region_value) then  !{
                      write (stdoutunit,*) trim(error_header), ' Grid point ', i, ', ', j, ', ',k,        &
                           ' in two regions for "', trim(instance(n)%name), '"'
                      call mpp_error(FATAL,trim(error_header) // ' Grid point in two regions for "' //  &
                           trim(instance(n)%name) // '"')
                    elseif (instance(n)%region(nn)%restore .ne. instance(n)%region(ind)%restore) then  !}{
                      write (stdoutunit,*) trim(error_header), ' Grid point ', i, ', ', j, ', ',k,        &
                           ' has different restore values for "', trim(instance(n)%name), '"'
                      call mpp_error(FATAL,trim(error_header) // ' Grid point has different restore values for "' //    &
                           trim(instance(n)%name) // '"')
                    endif  !}
                  endif  !}
                enddo  !} nn
              endif  !}

            else  !}{     ! not a union, therefore an intersection

!
!       Find the first region with a value set
!

              ind = 0
              do nn = 1, instance(n)%num_regions  !{
                if (instance(n)%region(nn)%mask(i,j,k) .eq. 1.0) then  !{
                  ind = nn
                  exit
                endif  !}
              enddo  !} nn

!
!       If ind == 0, then this point is out of all regions
!

              if (ind .gt. 0) then  !{

!
!       Otherwise, check whether this value is set for all regions with
!       the same restore_region_value. If so, use that value, otherwise
!       use the integrate_region_value. Also, quit with an error if a
!       region with a different restore_region_value also has a value set
!

                good = .true.
                do nn = ind + 1, instance(n)%num_regions  !{
                  if (instance(n)%region(nn)%mask(i,j,k) .eq. 1.0) then  !{
                    if (instance(n)%region(nn)%restore_region_value .ne.                                &
                        instance(n)%region(ind)%restore_region_value) then  !{
                      write (stdoutunit,*) trim(error_header), ' Grid point ', i, ', ', j, ', ',k,        &
                           ' in two regions for "', trim(instance(n)%name), '"'
                      call mpp_error(FATAL,trim(error_header) // ' Grid point in two regions for "' //  &
                           trim(instance(n)%name) // '"')
                    elseif (instance(n)%region(nn)%restore_region_value .ne.                            &
                            instance(n)%region(ind)%restore_region_value) then  !}{
                      write (stdoutunit,*) trim(error_header), ' Grid point ', i, ', ', j, ', ',k,        &
                           ' has different restore values for "', trim(instance(n)%name), '"'
                      call mpp_error(FATAL,trim(error_header) // ' Grid point has different restore values for "' //    &
                           trim(instance(n)%name) // '"')
                    else  !}{
                      good = good .and. instance(n)%region(nn)%mask(i,j,k) .eq. 1.0
                    endif  !}
                  endif  !}
                enddo  !} nn
                if (.not. good) then  !{
                  ind = 0
                endif  !}
              endif  !}

            endif  !}

            instance(n)%index(i,j,k) = ind
            if (ind .gt. 0) then
              instance(n)%mask(i,j,k) = instance(n)%region(ind)%restore_region_value
            else
              instance(n)%mask(i,j,k) = instance(n)%integrate_region_value
            endif

          else  !}{

            instance(n)%index(i,j,k) = -1
            instance(n)%mask(i,j,k) = 0.0

          endif  !}
        enddo  !} i
      enddo  !} j
    enddo  !} k

  endif  !}

enddo  !} n

!
!       set the integrate_region value if something other than time is to be integrated
!

if (do_ocean_residency_integrand) then  !{
  call ocean_residency_integrand_source(isd, ied, jsd, jed, nk, Time%taum1, t_prog, t_diag, grid_tmask)
endif  !}

do n = 1, num_instances  !{

  do k = 1, nk  !{
    do j = jsd, jed  !{
      do i = isd, ied  !{
        t_prog(instance(n)%tracer_index)%source(i,j,k) = t_prog(instance(n)%tracer_index)%source(i,j,k) +   &
             instance(n)%mask(i,j,k)
      enddo  !} i
    enddo  !} j
  enddo  !} k

!
!       Save the diagnostic for the merged mask array
!

  if (instance(n)%id_restore_region .gt. 0) then  !{
    used = send_data(instance(n)%id_restore_region,           &
         instance(n)%mask(:,:,:),                             &
         Time%model_time, rmask = grid_tmask(:,:,:),          &
         is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
  endif  !}

enddo  !} n

!
!       Restore to the restore_region values
!

do n = 1, num_instances  !{

  if (instance(n)%some_restore) then  !{

    do k = 1, nk
      do j = jsd, jed  !{
        do i = isd, ied  !{
          ind = instance(n)%index(i,j,k)
          !if (instance(n)%region(ind)%mask(i,j,k) .eq. 1.0) then  !{}
          if (ind .gt. 0) then  !{
            if (instance(n)%region(ind)%restore .gt. 0.0) then  !{
              instance(n)%mask(i,j,k) =                                                 &
                   (instance(n)%region(ind)%restore_region_value -                      &
                    t_prog(instance(n)%tracer_index)%field(i,j,k,Time%tau)) /           &
                   (instance(n)%region(ind)%restore * sec_per_day) * grid_tmask(i,j,k)
              t_prog(instance(n)%tracer_index)%source(i,j,k) =                          &
                   t_prog(instance(n)%tracer_index)%source(i,j,k) + instance(n)%mask(i,j,k)
            endif  !}
          endif  !}
        enddo  !}i
      enddo  !} j
    enddo  !} k

  endif  !}

enddo  !} n

return

end subroutine ocean_residency_source 
! </SUBROUTINE> NAME="ocean_residency_source"


!#######################################################################
! <SUBROUTINE NAME="ocean_residency_start">
!
! <DESCRIPTION>
!       Start the ocean residency package
!
!       Residency surface area specification
!
!  west_bnd     : western longitude of residency region
!  east_bnd     : eastern longitude of residency region
!  south_bnd    : southern latitude of residency region
!  north_bnd    : northern latitude of residency region
!  top_bnd      : top depth of residency region
!  bottom_bnd   : bottom depth of residency region
!
!       To set the volumes, a number of namelists are read,
!       each containing the above values. You may specify up to
!       num_geog_region rectangular cubes bounded by
!       (west_bnd, east_bnd, north_bnd, south_bnd, top_bnd, bottom_bnd).
!       Any grid box whose center is in one of these volumes will
!       be considered to be part of the volume where the
!       residency is reset to zero every time-step.
!
!       north_bnd may not equal south_bnd, and west_bnd may not equal east_bnd
!
!       top_depth may equal bottom_depth. In that case, then whatever vertical
!       box contains that depth will define the vertical range for the box
!
!       If south_bnd > north_bnd, then nothing will be done for that rectangle
!
!       The initial surface area is empty, with the default rectangle
!       setting the surface area to be empty
!
!       More than num_geog_regions rectanglar volumes may be used to specify
!       the volume by using more than one namelist
! </DESCRIPTION>
!
subroutine ocean_residency_start(isd, ied, jsd, jed, nk, model_time, grid_tracer_axes)  !{

!
!       modules
!

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: nk
type(time_type), intent(in)                             :: model_time
integer, dimension(:), intent(in)                       :: grid_tracer_axes

!
!       local parameters
!

character(len=64), parameter    :: sub_name = 'ocean_residency_start'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!       local variables
!

integer                                 :: i
integer                                 :: j
integer                                 :: k
integer                                 :: n
integer                                 :: nn
character(len=256)                      :: caller_str
integer                                 :: len_w
integer                                 :: len_e
integer                                 :: len_s
integer                                 :: len_n
integer                                 :: len_t
integer                                 :: len_b
character(len=fm_field_name_len+3)      :: long_suffix
character(len=fm_field_name_len+1)      :: suffix
character(len=24)                       :: num_suffix
character(len=24)                       :: num_long_suffix
character(len=24)                       :: number_str
logical                                 :: found_error

  integer :: stdoutunit 
  stdoutunit=stdout() 

!
!-----------------------------------------------------------------------
!       save the instance namelist values
!-----------------------------------------------------------------------
!

caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, num_instances !{

  call fm_util_start_namelist(package_name, instance(n)%name, caller = caller_str)

  instance(n)%num_regions            =  fm_util_get_integer      ('num_regions', scalar = .true.)
  instance(n)%integrate_region_value =  fm_util_get_real         ('integrate_region_value', scalar = .true.)
  instance(n)%union                  =  fm_util_get_logical      ('union', scalar = .true.)
  instance(n)%int_module_name        =  fm_util_get_string       ('int_module_name', scalar = .true.)
  instance(n)%int_params             => fm_util_get_real_array   ('int_params')
  instance(n)%int_flags              => fm_util_get_logical_array('int_flags')
  instance(n)%int_strings            => fm_util_get_string_array ('int_strings')

!
!       create namelists for each region
!

  if (instance(n)%num_regions .le. 0) then
    call mpp_error(FATAL,trim(error_header) // ' num_regions is non-positive for instance ' //   &
         trim(instance(n)%name) // ' in package ' // trim(package_name))
  endif

!
!       allocate storage for this instance and
!       set all of the values to the default
!

  allocate( instance(n)%region(instance(n)%num_regions) )
  do nn = 1, instance(n)%num_regions  !{
    allocate( instance(n)%region(nn)%mask(isd:ied,jsd:jed,nk) )
    do k = 1, nk
      do j = jsd, jed
        do i = isd, ied
          instance(n)%region(nn)%mask(i,j,k) = 0.0
        enddo
      enddo
    enddo
  enddo  !} nn
  allocate( instance(n)%mask(isd:ied,jsd:jed,nk) )
  do k = 1, nk
    do j = jsd, jed
      do i = isd, ied
        instance(n)%mask(i,j,k) = 0.0
      enddo
    enddo
  enddo
  allocate( instance(n)%index(isd:ied,jsd:jed,nk) )
  do k = 1, nk
    do j = jsd, jed
      do i = isd, ied
        instance(n)%index(i,j,k) = 0
      enddo
    enddo
  enddo
  !instance(n)%mask => instance(n)%region(1)%mask

  instance(n)%some_restore = .false.
  instance(n)%some_fix = .false.
  do nn = 1, instance(n)%num_regions  !{

    if (instance(n)%num_regions .eq. 1) then
      suffix = ' '
    else
      write (long_suffix,*) nn
      suffix = '_' // long_suffix(scan(long_suffix,'0123456789'):)
    endif

    instance(n)%region(nn)%restore              =  fm_util_get_real         ('restore' // suffix, scalar = .true.)
    instance(n)%region(nn)%restore_region_value =  fm_util_get_real         ('restore_region_value' // suffix, scalar = .true.)
    instance(n)%region(nn)%swap                 =  fm_util_get_logical      ('swap' // suffix, scalar = .true.)
    instance(n)%region(nn)%swap_module          =  fm_util_get_logical      ('swap_module' // suffix, scalar = .true.)
    instance(n)%region(nn)%west_bnd             => fm_util_get_real_array   ('west_bnd' // suffix)
    instance(n)%region(nn)%east_bnd             => fm_util_get_real_array   ('east_bnd' // suffix)
    instance(n)%region(nn)%south_bnd            => fm_util_get_real_array   ('south_bnd' // suffix)
    instance(n)%region(nn)%north_bnd            => fm_util_get_real_array   ('north_bnd' // suffix)
    instance(n)%region(nn)%top_bnd              => fm_util_get_real_array   ('top_bnd' // suffix)
    instance(n)%region(nn)%bottom_bnd           => fm_util_get_real_array   ('bottom_bnd' // suffix)
    instance(n)%region(nn)%module_name          =  fm_util_get_string       ('module_name' // suffix, scalar = .true.)
    instance(n)%region(nn)%params               => fm_util_get_real_array   ('params' // suffix)
    instance(n)%region(nn)%flags                => fm_util_get_logical_array('flags' // suffix)
    instance(n)%region(nn)%strings              => fm_util_get_string_array ('strings' // suffix)

    instance(n)%some_restore = instance(n)%some_restore .or. instance(n)%region(nn)%restore .gt. 0.0
    instance(n)%some_fix = instance(n)%some_fix .or. instance(n)%region(nn)%restore .eq. 0.0

  enddo  !} nn

  call fm_util_end_namelist(package_name, instance(n)%name, caller = caller_str)

!
!       Check some things
!

  do nn = 1, instance(n)%num_regions  !{

    if (.not. associated(instance(n)%region(nn)%west_bnd) .and.      &
        .not. associated(instance(n)%region(nn)%east_bnd) .and.      &
        .not. associated(instance(n)%region(nn)%south_bnd) .and.     &
        .not. associated(instance(n)%region(nn)%north_bnd) .and.     &
        .not. associated(instance(n)%region(nn)%top_bnd) .and.       &
        .not. associated(instance(n)%region(nn)%bottom_bnd)) then  !{

      write (stdoutunit,*) trim(note_header),               &
           ' No region specified, assuming it will be specified externally: ', trim(instance(n)%name), ' region: ', nn
      instance(n)%region(nn)%num_geog_regions = 0

    elseif (.not. associated(instance(n)%region(nn)%west_bnd) .or.   &
        .not. associated(instance(n)%region(nn)%east_bnd) .or.       &
        .not. associated(instance(n)%region(nn)%south_bnd) .or.      &
        .not. associated(instance(n)%region(nn)%north_bnd) .or.      &
        .not. associated(instance(n)%region(nn)%top_bnd) .or.        &
        .not. associated(instance(n)%region(nn)%bottom_bnd)) then  !}{

      call mpp_error(FATAL, trim(error_header) // ' Some regions not specified: ' // trim(instance(n)%name))

    else  !}{

      len_w = size(instance(n)%region(nn)%west_bnd)
      len_e = size(instance(n)%region(nn)%east_bnd)
      len_s = size(instance(n)%region(nn)%south_bnd)
      len_n = size(instance(n)%region(nn)%north_bnd)
      len_t = size(instance(n)%region(nn)%top_bnd)
      len_b = size(instance(n)%region(nn)%bottom_bnd)

      if (len_e .ne. len_w .or. len_e .ne. len_s .or. len_e .ne. len_n .or.         &
          len_e .ne. len_t .or. len_e .ne. len_b) then  !{
        call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal: ' // trim(instance(n)%name))
      endif  !}
      instance(n)%region(nn)%num_geog_regions = len_w

    endif  !}

  enddo  !} nn

!
!       register the fields
!

  if (instance(n)%name(1:1) .eq. '_') then  !{
    suffix = ' '
    long_suffix = ' '
  else  !}{
    suffix = '_' // instance(n)%name
    long_suffix = ' (' // trim(instance(n)%name) // ')'
  endif  !}

  instance(n)%id_change = register_diag_field(trim(diag_name),                  &
       'residency_change' // trim(suffix), grid_tracer_axes(1:3),               &
       model_time, 'Residency change' // trim(long_suffix), ' ',                &
       missing_value = -1.0e+10)

  instance(n)%id_restore_region = register_diag_field(trim(diag_name),          &
       'residency_in_merged_regions' // trim(suffix), grid_tracer_axes(1:3),    &
       model_time, 'Residency in merged regions' // trim(long_suffix), ' ',     &
       missing_value = -1.0e+10)

  do nn = 1, instance(n)%num_regions  !{

    if (instance(n)%num_regions .eq. 1) then
      num_suffix = ' '
    else
      write (number_str,*) nn
      num_suffix = '_' // number_str(scan(number_str,'0123456789'):)
      num_long_suffix = ' ' // number_str(scan(number_str,'0123456789'):)
    endif

    instance(n)%region(nn)%id_restore_region = register_diag_field(trim(diag_name),                     &
         'residency_restore_region' // trim(num_suffix) // trim(suffix), grid_tracer_axes(1:3),         &
         model_time, 'Residency in region' // trim(num_long_suffix) // trim(long_suffix), ' ',          &
         missing_value = -1.0e+10)

  enddo  !} nn

enddo  !} n

!
!       call the start routines for instances controlled by external modules
!

call ocean_residency_ml_start

call ocean_residency_range_start

call ocean_residency_integrand_start

!
!       check that the external tracers are all accounted for
!

found_error = .false.
do n = 1, num_instances  !{
  if (instance(n)%int_module_name .ne. ' ' .and. .not. instance(n)%int_found) then  !}{
    found_error = .true.
    write (stdoutunit,*) trim(error_header), ' Instance "', trim(instance(n)%name),      &
         '" not found with integrand module name "', trim(instance(n)%int_module_name), '"'
  endif  !}
  do nn = 1, instance(n)%num_regions  !{
    if (instance(n)%region(nn)%module_name .ne. ' ' .and. .not. instance(n)%region(nn)%found) then  !{
      found_error = .true.
      write (stdoutunit,*) trim(error_header), ' Instance "', trim(instance(n)%name),      &
           '" not found with module name "', trim(instance(n)%region(nn)%module_name), '"'
    endif  !}
  enddo  !} nn
enddo  !} n
if (found_error) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Some external instances not found')
endif  !}

return

end subroutine ocean_residency_start  !}
! </SUBROUTINE> NAME="ocean_residency_start"


!#######################################################################
! <SUBROUTINE NAME="ocean_residency_tracer">
!
! <DESCRIPTION>
!       Subroutine to do calculations needed every time-step after
!       the continuity equation has been integrated
! </DESCRIPTION>
!

subroutine ocean_residency_tracer(isc, iec, jsc, jec,           &
     isd, ied, jsd, jed, nk, T_prog, grid_tmask, taup1, model_time, dtts) !{

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
integer, intent(in)                                             :: nk
integer, intent(in)                                             :: taup1
type(time_type), intent(in)                                     :: model_time
real, dimension(isd:,jsd:,:), intent(in)                        :: grid_tmask
real, intent(in)                                                :: dtts

!
!       local parameters
!

!
!       local variables
!

integer :: i
integer :: j
integer :: k
integer :: n
integer :: ind
logical :: used

!
!       fix the restore_region values
!

do n = 1, num_instances  !{

  if (instance(n)%some_fix) then  !{

    do k = 1, nk
      do j = jsd, jed  !{
        do i = isd, ied  !{
          ind = instance(n)%index(i,j,k)
          !if (instance(n)%region(ind)%mask(i,j,k) .eq. 1.0) then  !{}
          if (ind .gt. 0) then  !{
            if (instance(n)%region(ind)%restore .eq. 0.0) then  !{
              instance(n)%mask(i,j,k) =                                                 &
                   (instance(n)%region(ind)%restore_region_value -                      &
                    t_prog(instance(n)%tracer_index)%field(i,j,k,taup1)) /              &
                   dtts * grid_tmask(i,j,k)
              t_prog(instance(n)%tracer_index)%field(i,j,k,taup1) = instance(n)%region(ind)%restore_region_value
            endif  !}
          endif  !}
        enddo  !}i
      enddo  !} j
    enddo  !} k

  endif  !}

  if (instance(n)%id_change .gt. 0) then
    used = send_data(instance(n)%id_change,                   &
         instance(n)%mask(:,:,:),                             &
         model_time, rmask = grid_tmask(:,:,:),               &
         is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
  endif

enddo  !} n

return

end subroutine ocean_residency_tracer  !}
! </SUBROUTINE> NAME="ocean_residency_tracer"

end module ocean_residency_mod  !}

module station_data_mod 
! <CONTACT EMAIL="Giang.Nong@gfdl.noaa.gov">
!   Giang Nong
! </CONTACT>
! <OVERVIEW>
! This module is used for outputing model results in a list
! of stations (not gridded arrrays). The user needs to supply
! a list of stations with lat, lon values of each station.
! Data at a single point (I,J) that is closest to each station will
! be written to a file. No interpolation is made when a station
! is between two or more grid points.<BR/>
! In the output file, a 3D field will have a format of array(n1,n2) and
! a 2D field is array(n1) where n1 is number of stations and n2 is number
! of vertical levels or depths.
! </OVERVIEW>
! <DESCRIPTION>
! Here are some basic steps of how to use station_data_mod <BR/>
!1/Call <TT>data_station_init</TT>  <BR/>
! user needs to supply 2 tables: list_stations and station_data_table as follows:<BR/>
! example of  list of stations (# sign means comment)<BR/>
!               #  station_id          lat    lon <BR/>
!                   station_1          20.4   100.8 <BR/>
! example of station_data_table (# sign means comment) <BR/>
! # General descriptor <BR/>
! Am2p14 station data <BR/>

!#  start time (should be the same as model's initial time) <BR/>
! 19800101 <BR/>
!# file inforamtion <BR/>
!#   filename,    output_frequency, frequency_unit, time_axis_unit <BR/>
!   "ocean_day"         1              "days"           "hours" <BR/>
!# field information <BR/>
!# module     field_name    filename    time_method   pack <BR/>
!  Ice_mod    temperature   ocean_day     . true.       2 <BR/>
!  Ice_mod    pressure      ocean_day      .false.      2    <BR/>
! 2/
! Call register_station_field to register each field that needs to be written to a file, the call
! <TT>register_station_field</TT> returns a field_id that will be used later in send_station_data <BR/>
! 3/
! Call <TT> send_station_data</TT> will send data at each station in the list
! to a file <BR/>
! 4/ Finally, call <TT>station_data_end</TT> after the last time step.<BR/>
! </DESCRIPTION>
use axis_utils_mod, only: nearest_index
use mpp_io_mod,    only : mpp_open, MPP_RDONLY, MPP_ASCII, mpp_close,MPP_OVERWR,MPP_NETCDF, &
                          mpp_write_meta, MPP_SINGLE, mpp_write, fieldtype,mpp_flush
use fms_mod,       only : error_mesg, FATAL, WARNING, stdlog, write_version_number,&
                          mpp_pe, lowercase, stdout, close_file, open_namelist_file, check_nml_error
use mpp_mod,       only : mpp_npes,  mpp_sync, mpp_root_pe, mpp_send, mpp_recv, mpp_max, &
                          mpp_get_current_pelist, input_nml_file, &
                          COMM_TAG_1, COMM_TAG_2, COMM_TAG_3, COMM_TAG_4
use mpp_domains_mod,only: domain2d, mpp_get_compute_domain
use diag_axis_mod, only : diag_axis_init
use diag_output_mod,only:  write_axis_meta_data, write_field_meta_data,diag_fieldtype,done_meta_data
use diag_manager_mod,only : get_date_dif, DIAG_SECONDS, DIAG_MINUTES, DIAG_HOURS, &
                            DIAG_DAYS, DIAG_MONTHS, DIAG_YEARS
use diag_util_mod,only    : diag_time_inc
use time_manager_mod, only: operator(>),operator(>=),time_type,get_calendar_type,NO_CALENDAR,set_time, &
                            set_date, increment_date, increment_time
implicit none
private
integer, parameter  :: max_fields_per_file = 150
integer, parameter  :: max_files = 31
integer             :: num_files = 0
integer             :: num_stations = 0
integer             :: max_stations = 20
integer             :: max_output_fields = 100
integer             :: num_output_fields = 0
real                :: EMPTY = 0.0
real                :: MISSING = 1.E20
logical             :: module_is_initialized = .false.
logical             :: need_write_axis = .true.
integer             :: base_year, base_month, base_day, base_hour, base_minute, base_second
type (time_type)    :: base_time
character (len=10)  :: time_unit_list(6) = (/'seconds   ', 'minutes   ', &
     'hours     ', 'days      ', 'months    ', 'years     '/)
integer, parameter  :: EVERY_TIME =  0
integer, parameter  :: END_OF_RUN = -1
character(len=128)  :: version = ''
character(len=128)  :: tagname = ''  
character(len=256)  :: global_descriptor
character (len = 7) :: avg_name = 'average'
integer             :: total_pe
integer             :: lat_axis, lon_axis
integer, allocatable:: pelist(:)
character(len=32)   :: pelist_name
type file_type
   character(len=128)  :: name
   integer             :: output_freq
   integer             :: output_units
   integer             :: time_units
   integer             :: fields(max_fields_per_file)
   integer             :: num_fields
   integer             :: file_unit
   integer             :: time_axis_id, time_bounds_id
   type (time_type)    :: last_flush
   type(fieldtype)     :: f_avg_start, f_avg_end, f_avg_nitems, f_bounds
end type file_type
type station_type
   character(len=128)  :: name
   real                :: lat, lon
   integer             :: id
   integer             :: global_i, global_j  ! index of global grid
   integer             :: local_i, local_j    ! index on the current PE
   logical             :: need_compute        ! true if the station present in this PE
end type station_type

type group_field_type
   integer             :: output_file
   integer             :: num_station ! number of stations on this PE
   integer, pointer    :: station_id(:)  =>null() ! id of station on this PE
   character(len=128)  :: output_name, module_name,long_name, units
   logical             :: time_average,time_max,time_min, time_ops, register
   integer             :: pack, axes(2), num_axes
   character(len=8)    :: time_method   !could be: true, false, max, min, mean, ...
   real, pointer       :: buffer(:, :)=>null()
   integer             :: counter,nlevel
   type(time_type)     :: last_output, next_output
   type(fieldtype)     :: f_type
end type group_field_type

type global_field_type
   real, pointer       :: buffer(:,:)=>null()
   integer             :: counter
end type global_field_type   


type(global_field_type),save            :: global_field
type (file_type),save                   :: files(max_files)
type(group_field_type),allocatable,save :: output_fields(:)
type (station_type),allocatable         :: stations(:)
type(diag_fieldtype),save               :: diag_field
public register_station_field, send_station_data, station_data_init, station_data_end

interface register_station_field
    module procedure register_station_field2d
    module procedure register_station_field3d
end interface
interface send_station_data
    module procedure send_station_data_2d
    module procedure send_station_data_3d
end interface
contains

! <INTERFACE NAME="station_data_init">
! <TEMPLATE>
! station_data_init()
! </TEMPLATE>
!   <DESCRIPTION>
! read in lat. lon of each station<BR/>
! create station_id based on lat, lon<BR/>
! read station_data_table, initialize output_fields and output files<BR/>
!   </DESCRIPTION>
! </INTERFACE>
subroutine station_data_init()

character(len=128)    :: station_name
real                  :: lat, lon  
integer               :: iunit,nfiles,nfields,time_units,output_freq_units,j,station_id,io_status,logunit, ierr
logical               :: init_verbose
character(len=128)    :: record
type file_part_type
   character(len=128) :: name
   integer            :: output_freq
   character(len=10)  :: output_freq_units 
   integer            :: format    ! must always be 1 for netcdf files
   character(len=10)  :: time_unit
end type file_part_type
type field_part_type
   character(len=128) :: module_name,field_name,file_name
   character(len=8)   :: time_method   
   integer            :: pack
end type field_part_type

type(file_part_type)  :: record_files
type(field_part_type) :: record_fields

namelist /station_data_nml/ max_output_fields, max_stations,init_verbose

  if (module_is_initialized) return
  init_verbose = .false.
  total_pe = mpp_npes()
  allocate(pelist(total_pe))
  call mpp_get_current_pelist(pelist, pelist_name) 

! read namelist
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, station_data_nml, iostat=io_status)
  ierr = check_nml_error(io_status, 'station_data_nml')
#else
  iunit = open_namelist_file ()
  ierr=1; do while (ierr /= 0)
  read  (iunit, nml=station_data_nml, iostat=io_status, end=10)
  ierr = check_nml_error(io_status, 'station_data_nml')
  enddo
10 call close_file (iunit)

#endif
  logunit = stdlog()
  write(logunit, station_data_nml)

  allocate(output_fields(max_output_fields), stations(max_stations))
! read list of stations
  if(init_verbose) then
     logunit = stdout()
     write(logunit, *) ' '
     write(logunit, *) '****** Summary of STATION information from list_stations ********'
     write(logunit, *) ' '
     write(logunit, *) 'station name      ', '   latitude ', '   longitude '
     write(logunit, *) ' '
  endif
  call mpp_open(iunit, 'list_stations',form=MPP_ASCII,action=MPP_RDONLY)
  do while (num_stations<max_stations)
     read(iunit,'(a)',end=76,err=75) record
     if (record(1:1) == '#') cycle 
     if(len_trim(record) < 1) cycle
     read(record, *, end = 76, err = 75) station_name, lat, lon 
     station_id = get_station_id(lat, lon)
     if(station_id > 0) then       
        stations(station_id)%name = station_name
     else
        call error_mesg('station_data_init','station DUPLICATED in file list_stations', FATAL)
     endif
     logunit = stdout()
     if( init_verbose.and.  mpp_pe() == mpp_root_pe()) &
          write(logunit,1)stations(station_id)%name,stations(station_id)%lat,stations(station_id)%lon
1 format(1x,A18, 1x,F8.2,4x,F8.2)     
75   continue
  enddo
  call error_mesg('station_data_init','max_stations exceeded, increase it via namelist', FATAL)
76 continue
  call mpp_close (iunit)
  logunit = stdout()
  if(init_verbose)  write(logunit, *)'*****************************************************************'
     
! read station_data table
  call mpp_open(iunit, 'station_data_table',form=MPP_ASCII,action=MPP_RDONLY)
! Read in the global file labeling string
  read(iunit, *, end = 99, err=99) global_descriptor

! Read in the base date
  read(iunit, *, end = 99, err = 99) base_year, base_month, base_day, &
       base_hour, base_minute, base_second
  if (get_calendar_type() /= NO_CALENDAR) then
     base_time = set_date(base_year, base_month, base_day, base_hour, &
          base_minute, base_second)
  else
! No calendar - ignore year and month
     base_time = set_time(base_hour*3600+base_minute*60+base_second, base_day)
     base_year  = 0
     base_month = 0
  end if
  nfiles=0
  do while (nfiles <= max_files)
     read(iunit,'(a)',end=86,err=85) record
     if (record(1:1) == '#') cycle        
     read(record,*,err=85,end=85)record_files%name,record_files%output_freq, &
          record_files%output_freq_units,record_files%format,record_files%time_unit
     if(record_files%format /= 1) cycle   !avoid reading field part
     time_units = 0
     output_freq_units = 0
     do j = 1, size(time_unit_list(:))
        if(record_files%time_unit == time_unit_list(j)) time_units = j
        if(record_files%output_freq_units == time_unit_list(j)) output_freq_units = j     
     end do
     if(time_units == 0) &
          call error_mesg('station_data_init',' check time unit in station_data_table',FATAL)
     if(output_freq_units == 0) & 
          call error_mesg('station_data_init',', check output_freq in station_data_table',FATAL)
      call init_file(record_files%name,record_files%output_freq, output_freq_units,time_units)
85    continue
   enddo
   call error_mesg('station_data_init','max_files exceeded, increase max_files', FATAL)
86 continue
   rewind(iunit)
   nfields=0
   do while (nfields <= max_output_fields)
       read(iunit,'(a)',end=94,err=93) record
       if (record(1:1) == '#') cycle
       read(record,*,end=93,err=93) record_fields
       if (record_fields%pack .gt. 8 .or.record_fields%pack .lt. 1) cycle !avoid reading file part
       nfields=nfields+1
       call init_output_field(record_fields%module_name,record_fields%field_name, &
            record_fields%file_name,record_fields%time_method,record_fields%pack)
93     continue
    enddo
    call error_mesg('station_data_init','max_output_fields exceeded, increase it via nml ', FATAL)
94  continue
    call close_file(iunit)
    call check_duplicate_output_fields
    call write_version_number (version, tagname)
    module_is_initialized = .true.
    return
99  continue
    call error_mesg('station_data_init','error reading station_datatable',FATAL)
end subroutine station_data_init
!----------------------------------------------------------------------
subroutine check_duplicate_output_fields()
! pair(output_name and output_file) should be unique in data_station_table, ERROR1
! pair(module_name and output_name) should be unique in data_station_table, ERROR2
integer            :: i, j, tmp_file
character(len=128) :: tmp_name, tmp_module

if(num_output_fields <= 1) return 
do i = 1, num_output_fields-1
   tmp_name = trim(output_fields(i)%output_name)
   tmp_file =  output_fields(i)%output_file
   tmp_module = trim(output_fields(i)%module_name)
   do j = i+1, num_output_fields
      if((tmp_name == trim(output_fields(j)%output_name)).and. &
           (tmp_file == output_fields(j)%output_file)) &
           call error_mesg (' ERROR1 in station_data_table:', &           
           &' module/field '//tmp_module//'/'//tmp_name//' duplicated', FATAL)
      if((tmp_name == trim(output_fields(j)%output_name)).and. &
           (tmp_module == trim(output_fields(j)%module_name))) &
           call error_mesg (' ERROR2 in station_data_table:', &           
           &' module/field '//tmp_module//'/'//tmp_name//' duplicated', FATAL)
   enddo
enddo
end subroutine check_duplicate_output_fields
!----------------------------------------------------------------------
function get_station_id(lat,lon)
  integer         :: get_station_id, i
  real, intent(in):: lat,lon
! each station should have distinct lat and lon
  get_station_id = -1
  do i = 1, num_stations
     if(stations(i)%lat == lat .and. stations(i)%lon == lon) return
  enddo
  num_stations = num_stations + 1
  stations(num_stations)%id = num_stations
  stations(num_stations)%lat = lat
  stations(num_stations)%lon = lon
  stations(num_stations)%need_compute = .false.
  stations(num_stations)%global_i = -1; stations(num_stations)%global_j = -1 
  stations(num_stations)%local_i = -1 ; stations(num_stations)%local_j = -1
  get_station_id = num_stations
end function get_station_id
!----------------------------------------------------------------------
subroutine init_file(filename, output_freq, output_units, time_units)
  character(len=*), intent(in) :: filename
  integer, intent(in)          :: output_freq, output_units, time_units
  character(len=128)           :: time_units_str
  real, dimension(1)           :: tdata

  num_files = num_files + 1
  if(num_files >= max_files) &
       call error_mesg('station_data, init_file', ' max_files exceeded, incease max_files', FATAL)
  files(num_files)%name = trim(filename)
  files(num_files)%output_freq = output_freq
  files(num_files)%output_units = output_units
  files(num_files)%time_units = time_units
  files(num_files)%num_fields = 0
  files(num_files)%last_flush = base_time
  files(num_files)%file_unit = -1
!---- register axis_id and time boundaries id
  write(time_units_str, 11) trim(time_unit_list(files(num_files)%time_units)), base_year, &
       base_month, base_day, base_hour, base_minute, base_second
11 format(a, ' since ', i4.4, '-', i2.2, '-', i2.2, ' ', i2.2, ':', i2.2, ':', i2.2)
  files(num_files)%time_axis_id = diag_axis_init ('Time', tdata, time_units_str, 'T',  &
       'Time' , set_name=trim(filename))
  files(num_files)%time_bounds_id = diag_axis_init('nv',(/1.,2./),'none','N','vertex number',&
       set_name=trim(filename))
end subroutine init_file

!--------------------------------------------------------------------------
subroutine init_output_field(module_name,field_name,file_name,time_method,pack)
  character(len=*), intent(in)           :: module_name, field_name, file_name
  character(len=*), intent(in)           :: time_method
  integer, intent(in)                    :: pack
  integer                                :: out_num, file_num,num_fields, method_selected, l1 
  character(len=8)                       :: t_method
! Get a number for this output field
  num_output_fields = num_output_fields + 1
  if(num_output_fields > max_output_fields) &
       call error_mesg('station_data', 'max_output_fields exceeded, increase it via nml', FATAL)
  out_num = num_output_fields
  file_num = find_file(file_name)
   if(file_num < 0) &
        call error_mesg('station_data,init_output_field', 'file '//trim(file_name) &
        //' is NOT found in station_data_table', FATAL)
! Insert this field into list of fields of this file
   files(file_num)%num_fields = files(file_num)%num_fields + 1
   if(files(file_num)%num_fields > max_fields_per_file) &
        call error_mesg('station_data, init_output_field', 'max_fields_per_file exceeded ', FATAL)
   num_fields = files(file_num)%num_fields
   files(file_num)%fields(num_fields)  = out_num
   output_fields(out_num)%output_name  = trim(field_name)
   output_fields(out_num)%module_name  = trim(module_name)
   output_fields(out_num)%counter      = 0
   output_fields(out_num)%output_file  = file_num
   output_fields(out_num)%pack         = pack
   output_fields(out_num)%time_average = .false.
   output_fields(out_num)%time_min     = .false.
   output_fields(out_num)%time_max     = .false. 
   output_fields(out_num)%time_ops     = .false.
   output_fields(out_num)%register     = .false.
   t_method = lowercase(time_method)
 select case (trim(t_method))
 case('.true.')
    output_fields(out_num)%time_average = .true.
    output_fields(out_num)%time_method  = 'mean'
 case('mean')
    output_fields(out_num)%time_average = .true.
    output_fields(out_num)%time_method  = 'mean'
 case('average')
    output_fields(out_num)%time_average = .true.
    output_fields(out_num)%time_method  = 'mean'
 case('avg')
    output_fields(out_num)%time_average = .true.
    output_fields(out_num)%time_method  = 'mean'
 case('.false.')
    output_fields(out_num)%time_average = .false.
     output_fields(out_num)%time_method  = 'point'
 case ('max')
    call error_mesg('station_data, init_output_field','time_method MAX is not supported',&
         FATAL)
    output_fields(out_num)%time_max = .true.
    output_fields(out_num)%time_method  = 'max'
    l1 = len_trim(output_fields(out_num)%output_name)
    if(output_fields(out_num)%output_name(l1-2:l1) /= 'max') &
           output_fields(out_num)%output_name = trim(field_name)//'_max'      
 case ('min')
    call error_mesg('station_data, init_output_field','time_method MIN is not supported',&
         FATAL)
    output_fields(out_num)%time_min = .true.
    output_fields(out_num)%time_method  = 'min'
    l1 = len_trim(output_fields(out_num)%output_name)
    if(output_fields(out_num)%output_name(l1-2:l1) /= 'min') &
         output_fields(out_num)%output_name = trim(field_name)//'_min'
 case default
    call error_mesg('station_data, init_output_field', 'error in time_method of field '&
         //trim(field_name), FATAL)
 end select
 if (files(file_num)%output_freq == EVERY_TIME) &
      output_fields(out_num)%time_average = .false.
 output_fields(out_num)%time_ops = output_fields(out_num)%time_min.or.output_fields(out_num)%time_max &
      .or.output_fields(out_num)%time_average
 output_fields(out_num)%time_method = trim(time_method)
end subroutine init_output_field
!--------------------------------------------------------------------------
function find_file(name)
integer                      :: find_file
character(len=*), intent(in) :: name
integer                      :: i

find_file = -1
do i = 1, num_files
   if(trim(files(i)%name) == trim(name)) then
      find_file = i
      return
   end if
end do
end function find_file
! <INTERFACE NAME="register_station_field">
! <TEMPLATE>
! register_station_field (module_name,fieldname,glo_lat,glo_lon,levels,init_time, 
!     domain,longname,units) <BR/>
! </TEMPLATE>
!   <DESCRIPTION>
! This function is similar to register_diag_field of diag_manager_mod. All arguments
! are inputs that user needs to supply, some are optional. The names of input args are
! self-describing.<BR/> levels is absent for 2D fields. <BR/>
! Note that pair (module_name, fieldname) must be unique in the 
! station_data_table or a fatal error will occur. <BR/>
! A field id is returned from this call that will be used later in send_station_data. <BR/>
!   </DESCRIPTION>
! </INTERFACE>


!--------------------------------------------------------------------------
function register_station_field2d (module_name,fieldname,glo_lat,glo_lon,init_time, &
     domain,longname,units)
  integer                                :: register_station_field2d
  character(len=*), intent(in)           :: module_name, fieldname
  real,dimension(:), intent(in)          :: glo_lat,glo_lon
  type(domain2d), intent(in)             :: domain
  type(time_type), intent(in)            :: init_time
  character(len=*), optional, intent(in) :: longname, units
  real                                   :: levels(1:1)

  levels = 0.
  register_station_field2d = register_station_field3d (module_name,fieldname,glo_lat,glo_lon,&
       levels,init_time,domain,longname,units)
end function register_station_field2d
!--------------------------------------------------------------------------

function register_station_field3d (module_name,fieldname,glo_lat,glo_lon,levels,init_time, &
     domain,longname,units)

! write field meta data on ROOT PE only
! allocate buffer
  integer                                :: register_station_field3d
  character(len=*), intent(in)           :: module_name, fieldname
  real,dimension(:), intent(in)          :: glo_lat,glo_lon,levels !in X,Y,Z direction respectively
  type(domain2d), intent(in)             :: domain
  type(time_type), intent(in)            :: init_time
  character(len=*), optional, intent(in) :: longname,units
  integer                                :: i,ii, nlat, nlon,nlevel, isc, iec, jsc, jec
  character(len=128)                     :: error_msg
  integer                                :: local_num_stations ! number of stations on this PE
  integer                                :: out_num ! position of this field in array output_fields
  integer                                :: file_num, freq, output_units, outunit
  real, allocatable                      :: station_values(:), level_values(:)
  character(len=128)                     :: longname2,units2


  if(PRESENT(longname)) then
     longname2 = longname
  else
     longname2 = fieldname
  endif
  if(PRESENT(units)) then
     units2 = units
  else
     units2 = "none"
  endif

  nlat = size(glo_lat); nlon = size(glo_lon); nlevel=size(levels)
  allocate(station_values(num_stations), level_values(nlevel))
  do i = 1, nlevel
     level_values(i) = real(i)
  enddo
! determine global index of this field in all stations
  outunit = stdout()
  do i = 1,num_stations
     station_values(i) = real(i)
     if(stations(i)%lat<glo_lat(1) .or. stations(i)%lat>glo_lat(nlat)) then
        write(error_msg,'(F9.3)') stations(i)%lat
        write(outunit,*) 'Station with latitude '//trim(error_msg)//' outside global latitude values'
        call error_mesg ('register_station_field', 'latitude out of range', FATAL)
     endif
      if(stations(i)%lon<glo_lon(1) .or. stations(i)%lon>glo_lon(nlon)) then
        write(error_msg,'(F9.3)') stations(i)%lon
        write(outunit,*) 'Station with longitude '//trim(error_msg)//' outside global longitude values'
        call error_mesg ('register_station_field', 'longitude out of range', FATAL)
     endif
     stations(i)%global_i = nearest_index(stations(i)%lon, glo_lon)
     stations(i)%global_j = nearest_index(stations(i)%lat, glo_lat)
     if(stations(i)%global_i<0 .or. stations(i)%global_j<0) &
          call error_mesg ('register_station_field', 'Error in global index of station',FATAL)
  enddo
! determine local index of this field in all stations , local index starts from 1
  call mpp_get_compute_domain(domain, isc,iec,jsc,jec)
  local_num_stations = 0
  do i = 1,num_stations
     if(isc<=stations(i)%global_i .and. iec>= stations(i)%global_i .and. &
        jsc<=stations(i)%global_j .and. jec>= stations(i)%global_j) then
        stations(i)%need_compute = .true.
        stations(i)%local_i = stations(i)%global_i - isc + 1
        stations(i)%local_j = stations(i)%global_j - jsc + 1
        local_num_stations = local_num_stations +1    
     endif
  enddo
! get the position of this field in the array output_fields
  out_num = find_output_field(module_name, fieldname)  
  if(out_num < 0 .and. mpp_pe() == mpp_root_pe()) then 
     call error_mesg ('register_station_field', &
          'module/field_name '//trim(module_name)//'/'//&
          trim(fieldname)//' NOT found in station_data table', WARNING)
     register_station_field3d = out_num
     return
  endif
  if(local_num_stations>0) then
     allocate(output_fields(out_num)%station_id(local_num_stations))
     allocate(output_fields(out_num)%buffer(local_num_stations,nlevel))
     output_fields(out_num)%buffer = EMPTY
! fill out list of available stations in this PE 
     ii=0
     do i = 1,num_stations       
        if(stations(i)%need_compute) then
           ii = ii+ 1
           if(ii>local_num_stations) call error_mesg ('register_station_field', &
                'error in determining local_num_station', FATAL)
           output_fields(out_num)%station_id(ii)=stations(i)%id
        endif
     enddo
  endif
  output_fields(out_num)%num_station = local_num_stations
  if( mpp_pe() == mpp_root_pe()) then
     allocate(global_field%buffer(num_stations,nlevel))
     global_field%buffer = MISSING
  endif
  output_fields(out_num)%register = .true.
  output_fields(out_num)%output_name = fieldname
  file_num = output_fields(out_num)%output_file
  output_fields(out_num)%last_output = init_time
  freq = files(file_num)%output_freq
  output_units = files(file_num)%output_units
  output_fields(out_num)%next_output = diag_time_inc(init_time, freq, output_units)
  register_station_field3d = out_num
  output_fields(out_num)%long_name = longname2
  output_fields(out_num)%units = units2
  output_fields(out_num)%nlevel = nlevel
! deal with axes
 
  output_fields(out_num)%axes(1) = diag_axis_init('Stations',station_values,'station number', 'X')
  if(nlevel == 1) then
     output_fields(out_num)%num_axes = 1     
  else
     output_fields(out_num)%num_axes = 2     
     output_fields(out_num)%axes(2) = diag_axis_init('Levels',level_values,'level number', 'Y' )   
  endif
  if(need_write_axis) then
     lat_axis = diag_axis_init('Latitude', stations(1:num_stations)%lat,'station latitudes', 'n')
     lon_axis = diag_axis_init('Longitude',stations(1:num_stations)%lon,  'station longitudes', 'n')
  endif
  need_write_axis = .false.
 
!  call mpp_sync()

end function register_station_field3d

!-------------------------------------------------------------------------

function find_output_field(module_name, field_name)
  integer find_output_field
  character(len=*), intent(in) :: module_name, field_name
  integer                      :: i

  find_output_field = -1
  do i = 1, num_output_fields
     if(trim(output_fields(i)%module_name) == trim(module_name) .and. &
          lowercase(trim(output_fields(i)%output_name)) == &
          lowercase(trim(field_name))) then 
        find_output_field = i
        return
     endif
  end do
end function find_output_field

!-------------------------------------------------------------------------
subroutine opening_file(file)
! open file, write axis meta_data for all files (only on ROOT PE, 
!                        do nothing on other PEs)
 integer, intent(in)  :: file
 character(len=128)   :: time_units
 integer              :: j,field_num,num_axes,axes(5),k
 logical              :: time_ops
 integer              :: time_axis_id(1),time_bounds_id(1)

 write(time_units, 11) trim(time_unit_list(files(file)%time_units)), base_year, &
      base_month, base_day, base_hour, base_minute, base_second
11 format(a, ' since ', i4.4, '-', i2.2, '-', i2.2, ' ', i2.2, ':', i2.2, ':', i2.2)
 call mpp_open(files(file)%file_unit, files(file)%name, action=MPP_OVERWR, &
       form=MPP_NETCDF, threading=MPP_SINGLE, fileset=MPP_SINGLE)
 call mpp_write_meta (files(file)%file_unit, 'title', cval=trim(global_descriptor))
 time_ops = .false.
 do j = 1, files(file)%num_fields
    field_num = files(file)%fields(j)
    if(output_fields(field_num)%time_ops) then
       time_ops = .true.
       exit
    endif
 enddo
!write axis meta data
 do j = 1, files(file)%num_fields
    field_num = files(file)%fields(j)
    num_axes = output_fields(field_num)%num_axes
    axes(1:num_axes) = output_fields(field_num)%axes(1:num_axes)
    do k = 1,num_axes
       if(axes(k)<0) &
            call error_mesg ('station_data opening_file','output_name '// &
            trim(output_fields(field_num)%output_name)// &
            ' has axis_id = -1', FATAL)
    enddo
    axes(num_axes + 1) = lat_axis
    axes(num_axes + 2) = lon_axis
    axes(num_axes + 3) = files(file)%time_axis_id
! need in write_axis: name, unit,long_name
    call write_axis_meta_data(files(file)%file_unit, axes(1:num_axes + 3), time_ops)
    if(time_ops) then
       axes(num_axes + 4) = files(file)%time_bounds_id
       call write_axis_meta_data(files(file)%file_unit, axes(1:num_axes + 4))     
    endif
 end do
!write field meta data
 do j = 1, files(file)%num_fields
    field_num = files(file)%fields(j)
    num_axes = output_fields(field_num)%num_axes
    axes(1:num_axes) = output_fields(field_num)%axes(1:num_axes)
    num_axes = num_axes + 1
    axes(num_axes) = files(file)%time_axis_id    
    diag_field = write_field_meta_data(files(file)%file_unit,output_fields(field_num)%output_name, &
         axes(1:num_axes),output_fields(field_num)%units, &
         output_fields(field_num)%long_name,time_method=output_fields(field_num)%time_method,&
         pack=output_fields(field_num)%pack)
    output_fields(field_num)%f_type = diag_field%Field
 end do
 if(time_ops) then
    time_axis_id(1) = files(file)%time_axis_id
    time_bounds_id(1) = files(file)%time_bounds_id
    diag_field=write_field_meta_data(files(file)%file_unit, avg_name // '_T1',time_axis_id, &
        time_units,"Start time for average period", pack=1)
    files(file)%f_avg_start = diag_field%Field

    diag_field=write_field_meta_data(files(file)%file_unit,avg_name // '_T2' ,time_axis_id, &
          time_units,"End time for average period", pack=1)
    files(file)%f_avg_end = diag_field%Field

    diag_field=write_field_meta_data(files(file)%file_unit,avg_name // '_DT' ,time_axis_id, &
          time_units,"Length of average period", pack=1)  
    files(file)%f_avg_nitems = diag_field%Field

    diag_field=write_field_meta_data(files(file)%file_unit, 'Time_bounds', (/time_bounds_id,time_axis_id/), &
           trim(time_unit_list(files(file)%time_units)), &
           'Time axis boundaries', pack=1) 
     files(file)%f_bounds =  diag_field%Field
 endif
 call done_meta_data(files(file)%file_unit)
end subroutine opening_file 
! <INTERFACE NAME="send_station_data">
! <TEMPLATE>
! send_station_data(field_id, data, time)
! </TEMPLATE>
!   <DESCRIPTION>
! data should have the size of compute domain(isc:iec,jsc:jec)<BR/>
! time is model's time<BR/>
! field_id is returned from <TT>register_station_field</TT><BR/>
! only data at stations will be be sent to root_pe which, in turn, sends to output file
!   </DESCRIPTION>
! </INTERFACE>
!-------------------------------------------------------------------------
subroutine send_station_data_2d(field_id, data, time)
  integer, intent(in)         :: field_id
  real,    intent(in)         :: data(:,:)
  type(time_type), intent(in) :: time
  real                        :: data3d(size(data,1),size(data,2),1)

  data3d(:,:,1) = data
  call send_station_data_3d(field_id, data3d, time)
end subroutine send_station_data_2d
!-------------------------------------------------------------------------
subroutine send_station_data_3d(field_id, data, time)
 
  integer, intent(in)         :: field_id
  real,    intent(in)         :: data(:,:,:)
  type(time_type), intent(in) :: time
  integer                     :: freq,units,file_num,local_num_stations,i,ii, max_counter
  integer                     :: index_x, index_y, station_id
  integer, allocatable        :: station_ids(:)  ! root_pe only,  to receive local station_ids
  real,    allocatable        :: tmp_buffer(:,:) ! root_pe only, to receive local buffer from each PE
  

  if (.not.module_is_initialized) &
     call error_mesg ('send_station_data_3d',' station_data NOT initialized', FATAL)

  if(field_id < 0) return  
  file_num = output_fields(field_id)%output_file
  if( mpp_pe() == mpp_root_pe() .and. files(file_num)%file_unit < 0) then
     call opening_file(file_num)
  endif
  freq = files(file_num)%output_freq
  units = files(file_num)%output_units
! compare time with next_output

  if (time > output_fields(field_id)%next_output .and. freq /= END_OF_RUN) then  ! time to write out     
! ALL PEs, including root PE, must send data to root PE        
     call mpp_send(output_fields(field_id)%num_station,plen=1,to_pe=mpp_root_pe(),tag=COMM_TAG_1)
     if(output_fields(field_id)%num_station > 0) then
        call mpp_send(output_fields(field_id)%station_id(1),plen=size(output_fields(field_id)%station_id),&
             to_pe=mpp_root_pe())
        call mpp_send(output_fields(field_id)%buffer(1,1),plen=size(output_fields(field_id)%buffer),&
             to_pe=mpp_root_pe())
     endif   
! get max_counter if the field is averaged
     if(output_fields(field_id)%time_average) then
        max_counter = output_fields(field_id)%counter
        call mpp_max(max_counter, pelist)
     endif
! receive local data from all PEs 
     if(mpp_pe() == mpp_root_pe()) then
        do i = 1,size(pelist)           
           call mpp_recv(local_num_stations,glen=1,from_pe=pelist(i),tag=COMM_TAG_1)
           if(local_num_stations> 0) then
              allocate(station_ids(local_num_stations))
              allocate(tmp_buffer(local_num_stations,output_fields(field_id)%nlevel))
              call mpp_recv(station_ids(1), glen=size(station_ids), from_pe=pelist(i))
              call mpp_recv(tmp_buffer(1,1),glen=size(tmp_buffer),  from_pe=pelist(i)) 
              do ii = 1,local_num_stations
                 global_field%buffer(station_ids(ii),:) = tmp_buffer(ii,:)
              enddo
              deallocate(station_ids, tmp_buffer)
           endif
        enddo
! send global_buffer content to file
        if(output_fields(field_id)%time_average) then  
           if(max_counter == 0 ) &
                call error_mesg ('send_station_data','counter=0 for averaged field '// &
                output_fields(field_id)%output_name, FATAL)
           global_field%buffer = global_field%buffer/real(max_counter)
        endif
! check if global_field contains any missing values
        if(any(global_field%buffer == MISSING)) &
             call error_mesg ('send_station_data','Global_field contains MISSING, field '// &
             output_fields(field_id)%output_name, FATAL)
        call station_data_out(file_num,field_id,global_field%buffer,output_fields(field_id)%next_output)
        global_field%buffer = MISSING
     endif
     call mpp_sync()
! clear buffer, increment next_output time and reset counter on ALL PEs
     if(output_fields(field_id)%num_station>0)  output_fields(field_id)%buffer = EMPTY
     output_fields(field_id)%last_output = output_fields(field_id)%next_output
     output_fields(field_id)%next_output =  diag_time_inc(output_fields(field_id)%next_output,&
          freq, units)
     output_fields(field_id)%counter = 0; max_counter = 0
    
  endif
! accumulate buffer only
  do i = 1 , output_fields(field_id)%num_station
     station_id = output_fields(field_id)%station_id(i)
     index_x = stations(station_id)%local_i; index_y = stations(station_id)%local_j
     if(index_x>size(data,1) .or. index_y>size(data,2)) &
          call error_mesg ('send_station_data','local index out of range for field '// &
          output_fields(field_id)%output_name, FATAL) 
     if(output_fields(field_id)%time_average) then
        output_fields(field_id)%buffer(i,:) = output_fields(field_id)%buffer(i,:) + &
             data(index_x,index_y,:)                                          ! accumulate buffer 
     else                                                                     ! not average
        output_fields(field_id)%buffer(i,:) = data(index_x,index_y,:)
     endif
  enddo
  if(output_fields(field_id)%time_average) &
       output_fields(field_id)%counter = output_fields(field_id)%counter + 1
end subroutine send_station_data_3d
!------------------------------------------------------------------------

subroutine station_data_out(file, field, data, time,final_call_in)

  integer, intent(in)          :: file, field
  real, intent(inout)          :: data(:, :)
  type(time_type), intent(in)  :: time
  logical, optional, intent(in):: final_call_in
  logical                      :: final_call
  integer                      :: i, num
  real :: dif, time_data(2, 1, 1), dt_time(1, 1, 1), start_dif, end_dif

  final_call = .false.
  if(present(final_call_in)) final_call = final_call_in
  dif = get_date_dif(time, base_time, files(file)%time_units)
  call mpp_write(files(file)%file_unit,output_fields(field)%f_type, data, dif)
  start_dif = get_date_dif(output_fields(field)%last_output, base_time,files(file)%time_units)
  end_dif = dif
  do i = 1, files(file)%num_fields
     num = files(file)%fields(i)     
      if(output_fields(num)%time_ops) then
         if(num == field) then
            time_data(1, 1, 1) = start_dif
            call mpp_write(files(file)%file_unit, files(file)%f_avg_start, &
                 time_data(1:1,:,:), dif)
            time_data(2, 1, 1) = end_dif
            call mpp_write(files(file)%file_unit, files(file)%f_avg_end, &
                 time_data(2:2,:,:), dif)
            dt_time(1, 1, 1) = end_dif - start_dif
            call mpp_write(files(file)%file_unit, files(file)%f_avg_nitems, &
                 dt_time(1:1,:,:), dif)
! Include boundary variable for CF compliance
            call mpp_write(files(file)%file_unit, files(file)%f_bounds, &
                 time_data(1:2,:,:), dif)
            exit
         endif
      end if
   end do
   if(final_call) then
      if(time >= files(file)%last_flush) then
         call mpp_flush(files(file)%file_unit)
         files(file)%last_flush = time
      endif
   else
      if(time > files(file)%last_flush) then
         call mpp_flush(files(file)%file_unit)
         files(file)%last_flush = time
      endif
   endif
end subroutine station_data_out
! <INTERFACE NAME="station_data_end">
! <TEMPLATE>
! station_data_end(time)
! </TEMPLATE>
!   <DESCRIPTION>
! Must be called <TT> after the last time step</TT> to write the buffer content
!   </DESCRIPTION>
! </INTERFACE>


!-----------------------------------------------------------------------------
subroutine station_data_end(time)

  type(time_type), intent(in) :: time            !model's time
  integer                     :: freq, max_counter, local_num_stations
  integer                     :: file, nfield, field, pe, col
  integer, allocatable        :: station_ids(:)  ! root_pe only,  to receive local station_ids
  real,    allocatable        :: tmp_buffer(:,:) ! root_pe only, to receive local buffer from each PE

  do file = 1, num_files
     freq = files(file)%output_freq
     do nfield = 1, files(file)%num_fields
        field = files(file)%fields(nfield)
        if(.not. output_fields(field)%register) cycle
        if(time >= output_fields(field)%next_output .or. freq == END_OF_RUN) then
! ALL PEs, including root PE, must send data to root PE        
           call mpp_send(output_fields(field)%num_station,plen=1,to_pe=mpp_root_pe(),tag=COMM_TAG_2)
           if(output_fields(field)%num_station > 0) then
              call mpp_send(output_fields(field)%station_id(1),plen=size(output_fields(field)%station_id),&
                   to_pe=mpp_root_pe(),tag=COMM_TAG_3)
              call mpp_send(output_fields(field)%buffer(1,1),plen=size(output_fields(field)%buffer),&
                   to_pe=mpp_root_pe(),tag=COMM_TAG_4)
           endif
! get max_counter if the field is averaged
           if(output_fields(field)%time_average) then
              max_counter = output_fields(field)%counter
              call mpp_max(max_counter, pelist)
           endif
! only root PE receives local data from all PEs 
           if(mpp_pe() == mpp_root_pe()) then
              do pe = 1,size(pelist)           
                 call mpp_recv(local_num_stations,glen=1,from_pe=pelist(pe),tag=COMM_TAG_2)
                 if(local_num_stations> 0) then
                    allocate(station_ids(local_num_stations))
                    allocate(tmp_buffer(local_num_stations,output_fields(field)%nlevel))
                    call mpp_recv(station_ids(1), glen=size(station_ids), from_pe=pelist(pe),tag=COMM_TAG_3)
                    call mpp_recv(tmp_buffer(1,1),glen=size(tmp_buffer),from_pe=pelist(pe),tag=COMM_TAG_4) 
                    do col = 1,local_num_stations
                       global_field%buffer(station_ids(col),:) = tmp_buffer(col,:)
                    enddo
                    deallocate(station_ids, tmp_buffer)
                 endif
              enddo
! send global_buffer content to file
              if(output_fields(field)%time_average)then           
                 if(max_counter == 0 )&
                      call error_mesg ('send_station_end','counter=0 for averaged field '// &
                      output_fields(field)%output_name, FATAL)
                 global_field%buffer = global_field%buffer/real(max_counter)
              endif
! check if global_field contains any missing values
              if(any(global_field%buffer == MISSING)) &
                   call error_mesg ('send_station_end','Global_field contains MISSING, field '// &
                   output_fields(field)%output_name, FATAL)              
              call station_data_out(file,field,global_field%buffer,output_fields(field)%next_output,.true.)
              global_field%buffer = MISSING
           endif
           call mpp_sync()
        endif
!deallocate field buffer
        if(output_fields(field)%num_station>0) &
             deallocate(output_fields(field)%buffer, output_fields(field)%station_id)
     enddo ! nfield
  enddo    ! file
  if(mpp_pe() == mpp_root_pe()) deallocate(global_field%buffer)
end subroutine station_data_end
!-----------------------------------------------------------------------------------

end module station_data_mod

module sw_core
 
! This module contains vertical independent part of the Lagrangian dynamics
! This is esentially shallow-water dynamics

  use tp_core,      only: tp2c, tpcc, xtp, ytp, ycc
#ifndef USE_LIMA
  use tp_core,      only: tp2d
#else
  use tp_core,      only: tp2d_lima
  use shr_kind_mod, only: r8 => shr_kind_r8
#endif
  implicit none

contains

#ifndef USE_LIMA
 subroutine c_sw(u,      v,       pt,     delp,                       &
                 uc,     vc,      ptc,    delpf,     ptk,             &
                 cosp,   acosp,   cose,   coslon,   sinlon,           &
                 dxdt,   dxe,     dtdx2,                              &
                 dtdx4,  dtxe5,   rdxe,   dycp,     dydt,             & 
                 dtdy5,  cye,     fc, zt_c,     tiny,     rcap,       &
                 im,     jm,      jfirst, jlast,    ng_c,             &
                 ng_d,   ng_s,    js2g0,  jn2g0,    js2gc,            &
                 jn1gc,  iord,    jord,   cosl5,    sinl5, dyn_step)
#else
 subroutine c_sw(u,      v,       pt,     delp,                       &
                 uc,     vc,      ptc,    delpf,     ptk,             &
                 cosp,   acosp,   cose,   coslon,   sinlon,           &
                 dxdt,   dxe,     dtdx2,                              &
                 dtdx4,  dtxe5,   rdxe,   dycp,     dydt,             &
                 dtdy5,  cye,     fc,     ifax,     trigs,            &
                 dc,     sc,      zt_c,   tiny,     rcap,             &
                 im,     jm,      jfirst, jlast,    ng_c,             &
                 ng_d,   ng_s,    js2g0,  jn2g0,    js2gc,            &
                 jn1gc,  iord,    jord,   cosl5,    sinl5  )
#endif
! Routine for shallow water dynamics on the C-grid

! !USES:

  use pft_module, only : pft2d


! INPUT:
  integer, intent(in):: im
  integer, intent(in):: jm
  integer, intent(in):: jfirst
  integer, intent(in):: jlast
  integer, intent(in):: js2g0
  integer, intent(in):: jn2g0
  integer, intent(in):: js2gc
  integer, intent(in):: jn1gc
  integer, intent(in):: iord
  integer, intent(in):: jord
  integer, intent(in):: ng_c
  integer, intent(in):: ng_s
  integer, intent(in):: ng_d
#ifndef USE_LIMA
  integer, intent(in):: dyn_step
#else
! polar filter related input arrays:
  integer, intent(in)::  ifax(13)                      !ECMWF fft
  real(r8), intent(in):: trigs(3*im/2+1)
  real(r8), intent(in):: dc(im,js2g0:jn2g0)
  real(r8), intent(in):: sc(js2g0:jn2g0)
#endif

! Prognostic variables:
  real, intent(in)   :: u(im,jfirst-ng_d:jlast+ng_s)
  real, intent(inout):: v(im,jfirst-ng_d:jlast+ng_d)  ! Wind in Y
  real, intent(in):: pt(im,jfirst-ng_d:jlast+ng_d) ! Wind in Y
  real, intent(in):: delp(im,jfirst:jlast)         ! Delta pressure
  real, intent(in):: delpf(im,jfirst-ng_d:jlast+ng_d)

#ifndef USE_LIMA
  real, intent(in):: fc(im,js2gc:jn1gc)
#else               
  real, intent(in):: fc(js2gc:jn1gc)
#endif

  real, intent(in):: cosp(jm)
  real, intent(in):: acosp(jm)
  real, intent(in):: cose(jm)

  real, intent(in):: dxdt(jm)
  real, intent(in):: dxe(jm)
  real, intent(in):: rdxe(jm)
  real, intent(in):: dtdx2(jm)
  real, intent(in):: dtdx4(jm)
  real, intent(in):: dtxe5(jm)
  real, intent(in):: dycp(jm)
  real, intent(in)::  cye(jm)

  real, intent(in):: sinlon(im)
  real, intent(in):: coslon(im)
  real, intent(in):: sinl5(im)
  real, intent(in):: cosl5(im)

  real, intent(in):: zt_c
  real, intent(in):: rcap
  real, intent(in):: tiny
  real, intent(in):: dydt
  real, intent(in):: dtdy5

! Output:
  real, intent(out):: uc(im,jfirst-ng_d:jlast+ng_d)
  real, intent(out):: vc(im,jfirst-2   :jlast+2 )
  real, intent(out):: ptc(im,jfirst:jlast)
  real, intent(out):: ptk(im,jfirst:jlast)

!--------------------------------------------------------------
! Local 

    real    fx(im,jfirst:jlast)
    real   xfx(im,jfirst:jlast)
    real   tm2(im,jfirst:jlast)

    real    va(im,jfirst-1:jlast)

    real   wk1(im,jfirst-1:jlast+1)
    real   cry(im,jfirst-1:jlast+1)
    real    fy(im,jfirst-1:jlast+1)

    real  ymass(im,jfirst: jlast+1) 
    real    yfx(im,jfirst: jlast+1)

    real   crx(im,jfirst-ng_c:jlast+ng_c)
    real    u2(im,jfirst-ng_d:jlast+ng_d)
    real    v2(im,jfirst-ng_d:jlast+ng_d)

    real  fxj(im)
    real  p1d(im)
    real  cx1(im)

    real  qtmp(-im/3:im+im/3)
    real  slope(-im/3:im+im/3)
    real  al(-im/3:im+im/3)
    real  ar(-im/3:im+im/3)
    real  a6(-im/3:im+im/3)

    real  us, vs, un, vn
    real  p1ke, p2ke

    logical ffsl(jm)
    logical sld

    integer i, j, im2
    integer js1g1
    integer js2g1
    integer js2gc1
    integer js2gcp1
    integer jn2gc
    integer jn1g1

    im2 = im/2
#ifdef USE_LIMA
    ffsl = .true.
#endif

! Set loop limits

    js1g1 = max(1,jfirst-1)
    js2g1 = max(2,jfirst-1)
    js2gcp1 = max(2,jfirst-ng_c-1)   ! NG-1 latitudes on S (starting at 2)
    jn1g1 = min(jm,jlast+1)
    jn2gc = min(jm-1,jlast+ng_c)   ! NG latitudes on N (ending at jm-1)
 
!
! Treat the special case of ng_c = 1
!
    if ( ng_c == 1 .AND. ng_d > 1 ) THEN
        js2gc1 = js2gc
    else
        js2gc1 = max(2,jfirst-ng_c+1)   ! NG-1 latitudes on S (starting at 2)
    endif

! Get D-grid V-wind at the poles.
    call vpol5(u, v, im, jm,            &
               coslon, sinlon, cosl5, sinl5, ng_d, ng_s, jfirst, jlast )

    do j=max(2,jfirst-ng_d),  min(jm-1,jlast+ng_d)
       do i=1,im-1
          v2(i,j) = v(i,j) + v(i+1,j)
       enddo
          v2(im,j) = v(im,j) + v(1,j)
    enddo

    do j=max(2,jfirst-ng_d), min(jm-1,jlast+ng_s-1)
       do i=1,im
          u2(i,j) = u(i,j) + u(i,j+1)
       enddo
    enddo

       if ( jfirst-ng_d <= 1 ) then
! Projection at SP
          us = 0.
          vs = 0.

          do i=1,im2
            us = us + (u2(i+im2,2)-u2(i,2))*sinlon(i)         &
                    + (v2(i,2)-v2(i+im2,2))*coslon(i)
            vs = vs + (u2(i+im2,2)-u2(i,2))*coslon(i)         &
                    + (v2(i+im2,2)-v2(i,2))*sinlon(i)
          enddo

          us = us/im
          vs = vs/im

! SP
          do i=1,im2
            u2(i,1)  = -us*sinlon(i) - vs*coslon(i)
            v2(i,1)  =  us*coslon(i) - vs*sinlon(i)
            u2(i+im2,1)  = -u2(i,1)
            v2(i+im2,1)  = -v2(i,1)
          enddo

          p1ke = 0.125*(u2(1, 1)**2 + v2(1, 1)**2)

        endif

        if ( jlast+ng_d >= jm ) then

! Projection at NP
          un = 0.
          vn = 0.

          j = jm-1
          do i=1,im2
            un = un + (u2(i+im2,j)-u2(i,j))*sinlon(i)        &
                    + (v2(i+im2,j)-v2(i,j))*coslon(i)
            vn = vn + (u2(i,j)-u2(i+im2,j))*coslon(i)        &
                    + (v2(i+im2,j)-v2(i,j))*sinlon(i)
          enddo

          un = un/im
          vn = vn/im

! NP
          do i=1,im2
            u2(i,jm) = -un*sinlon(i) + vn*coslon(i)
            v2(i,jm) = -un*coslon(i) - vn*sinlon(i)
            u2(i+im2,jm) = -u2(i,jm)
            v2(i+im2,jm) = -v2(i,jm)
          enddo

          p2ke = 0.125*(u2(1,jm)**2 + v2(1,jm)**2)

        endif

! A -> C
        do j=js2gc,jn2gc                ! uc needed N*ng S*ng
!       do j=max(2,jfirst-2),min(jm-1,jlast+2)
! i=1
            uc(1,j) = 0.25*(u2(1,j)+u2(im,j))
          do i=2,im
            uc(i,j) = 0.25*(u2(i,j)+u2(i-1,j))
          enddo
        enddo

        do j=max(2,jfirst-2), min(jm,jlast+2) ! ng_d must be 3
          do i=1,im
            vc(i,j) = 0.25*(v2(i,j)+v2(i,j-1))  ! v2 needed (-3:+2)
          enddo
        enddo

        if ( jfirst /= 1 ) then
          do i=1,im
            cry(i,jfirst-1) = dtdy5*vc(i,jfirst-1)
          enddo
        endif

        do j=js2g0,jn1g1                     ! ymass needed on NS
          do i=1,im
               cry(i,j) = dtdy5*vc(i,j)
             ymass(i,j) = cry(i,j)*cose(j)
          enddo
        enddo

! New va definition
        do j=js2g1,jn2g0                     ! va needed on S (for YCC, iv==1)
          do i=1,im
            va(i,j) = 0.5*(cry(i,j)+cry(i,j+1))
          enddo
        enddo

! SJL: Check if FFSL integer fluxes need to be computed

        do 2222 j=js2gc,jn2gc                ! ffsl needed on N*sg S*sg
          do i=1,im
            crx(i,j) = uc(i,j)*dtdx2(j)
          enddo
          ffsl(j) = .false.
          if( cosp(j) < zt_c ) then
            do i=1,im
              if( abs(crx(i,j)) > 1. ) then
                ffsl(j) = .true. 
                go to 2222
              endif
            enddo
          endif
2222    continue

! 2D transport of polar filtered delp (for computing fluxes!)
! Update is done on the unfiltered delp

#ifndef USE_LIMA
      call tp2c( ptk,  delpf(1,jfirst-ng_c),     &
              crx(1,jfirst-ng_c), cry(1,jfirst),             &
              im, jm, iord, jord, ng_c, xfx,                 &
              yfx, ffsl, rcap, acosp,                        &
              crx(1,jfirst), ymass, cosp,                    &
              0, jfirst, jlast, delp, dyn_step)
#else
      call tp2c( ptk,  va(1,jfirst),  delpf(1,jfirst-ng_c),     &
              crx(1,jfirst-ng_c), cry(1,jfirst),             &
              im, jm, iord, jord, ng_c, xfx,                 &
              yfx, ffsl, rcap, acosp,                        &
              crx(1,jfirst), ymass, cosp,                    &
              0, jfirst, jlast)   
#endif

   do j=js2g0,jn2g0                      ! xfx not ghosted
      if( ffsl(j) ) then
         do i=1,im
           xfx(i,j) = xfx(i,j)/sign(max(abs(crx(i,j)),tiny),crx(i,j))
         enddo
      endif
   enddo

! pt-advection using pre-computed mass fluxes
! tm2 below as the storage for pt increment
! WS 99.09.20 : pt, crx need on N*ng S*ng, yfx on N

#if !defined (SW_DYN)

#ifndef USE_LIMA
    call tp2c(tm2, pt(1,jfirst-ng_c),       &
              crx(1,jfirst-ng_c), cry(1,jfirst),          &
              im, jm,  iord, jord, ng_c, fx,              &
              fy(1,jfirst), ffsl, rcap, acosp,            &
              xfx, yfx, cosp, 1, jfirst, jlast, delp, dyn_step)
#else
    call tp2c(tm2 ,va(1,jfirst), pt(1,jfirst-ng_c),       &
              crx(1,jfirst-ng_c), cry(1,jfirst),          &
              im, jm,  iord, jord, ng_c, fx,              &
              fy(1,jfirst), ffsl, rcap, acosp,            &
              xfx, yfx, cosp, 1, jfirst, jlast)

#endif

#endif

#if ( !defined ALT_PFT )
! v2, crx as work arrays
#ifndef USE_LIMA
         call pft2d(ptk(1,js2g0), im, jn2g0-js2g0+1, v2, crx, 1)
#else
         call pft2d(ptk(1,js2g0), sc(js2g0), dc(1,js2g0), im,   &
                jn2g0-js2g0+1,  ifax, trigs, v2, crx )
#endif

#if !defined (SW_DYN)

#ifndef USE_LIMA
         call pft2d(tm2(1,js2g0), im, jn2g0-js2g0+1, v2, crx, 1)
#else
         call pft2d(tm2(1,js2g0), sc(js2g0), dc(1,js2g0),  im,  &
                jn2g0-js2g0+1,  ifax, trigs, v2, crx )
#endif

#endif

#endif

    do j=jfirst,jlast
       do i=1,im
          ptk(i,j) = delp(i,j) + ptk(i,j)
#ifdef SW_DYN
          ptc(i,j) = pt(i,j)
#else
          ptc(i,j) = (pt(i,j)*delp(i,j) + tm2(i,j))/ptk(i,j)
#endif
       enddo
    enddo

!------------------
! Momentum equation
!------------------
     call ycc(im, jm, fy, vc(1,jfirst-2), va(1,jfirst-1),   &
              va(1,jfirst-1), jord, 1, jfirst, jlast)

     do j=js2g1,jn2g0

          do i=1,im
            cx1(i) = dtdx4(j)*u2(i,j)
          enddo

          sld = .false.
          if( cosp(j) < zt_c ) then
            do i=1,im
              if( abs(cx1(i)) > 1. ) then
                sld = .true. 
                go to 3333
              endif
            enddo
          endif
3333      continue

          p1d(im) = uc(1,j)
          do i=1,im-1
            p1d(i) = uc(i+1,j)
          enddo

          call xtp(im,   sld, fxj, p1d, cx1, iord,   &
                   cx1,  cosp(j),  0,   slope,       &
                   qtmp, al,       ar,  a6)
 
          do i=1,im
            wk1(i,j) = dxdt(j)*fxj(i) + dydt*fy(i,j)
          enddo
     enddo


     if ( jfirst-1 <= 1 ) then
          do i=1,im
            wk1(i,1) = p1ke
          enddo
     endif

     if ( jlast+1 >= jm ) then
          do i=1,im
            wk1(i,jm) = p2ke
          enddo
     endif

! crx redefined
     do j=js2gc1,jn1gc
            crx(1,j) = dtxe5(j)*u(im,j)
          do i=2,im
            crx(i,j) = dtxe5(j)*u(i-1,j)
          enddo
     enddo

     if ( jfirst /=1 ) then 
          do i=1,im
             cry(i,jfirst-1) = dtdy5*v(i,jfirst-1)
          enddo
     endif

     do j=jfirst,jlast
        do i=1,im
             cry(i,j) = dtdy5*v(i,j)
           ymass(i,j) = cry(i,j)*cosp(j)       ! ymass actually unghosted
        enddo
     enddo

     do j=js2g0,jlast
          do i=1,im
            tm2(i,j) = 0.5*(cry(i,j)+cry(i,j-1)) ! cry ghosted on S 
          enddo
     enddo

!    Compute absolute vorticity on the C-grid.

     if ( jfirst-ng_d <= 1 ) then
          do i=1,im
            u2(i,1) = 0.
          enddo
     endif

     do j=js2gc,jn2gc
         do i=1,im
            u2(i,j) = uc(i,j)*cosp(j)
         enddo
     enddo

     if ( jlast+ng_d >= jm ) then
          do i=1,im
            u2(i,jm) = 0.
          enddo
     endif


#ifndef USE_LIMA
     do j=js2gc1,jn1gc
! The computed absolute vorticity on C-Grid is assigned to v2
          v2(1,j) = fc(1,j) + (u2(1,j-1)-u2(1,j))*cye(j) +     &
                    (vc(1,j) - vc(im,j))*rdxe(j)

          do i=2,im
             v2(i,j) = fc(i,j) + (u2(i,j-1)-u2(i,j))*cye(j) +  &
                       (vc(i,j) - vc(i-1,j))*rdxe(j)
          enddo
     enddo
#else               
     do j=js2gc1,jn1gc
! The computed absolute vorticity on C-Grid is assigned to v2
          v2(1,j) = fc(j) + (u2(1,j-1)-u2(1,j))*cye(j) +     &
                    (vc(1,j) - vc(im,j))*rdxe(j)

          do i=2,im
             v2(i,j) = fc(j) + (u2(i,j-1)-u2(i,j))*cye(j) +  &
                       (vc(i,j) - vc(i-1,j))*rdxe(j)
          enddo
     enddo
#endif

!         ffsl = .true.
     do 2233 j=js2gc1,jn1gc          ! ffsl needed on N*ng S*(ng-1)
          ffsl(j) = .false.
          if( cose(j) < zt_c ) then
            do i=1,im
              if( abs(crx(i,j)) > 1. ) then
                ffsl(j) = .true. 
                go to 2233
              endif
            enddo
          endif
2233    continue

   call tpcc( tm2, ymass, v2(1,jfirst-ng_d), crx(1,jfirst-ng_c),  &
              cry(1,jfirst), im, jm, ng_c, ng_d,                  &
              iord, jord, fx, fy(1,jfirst), ffsl, cose,           &
              jfirst, jlast, slope, qtmp, al, ar, a6 )

   do j=js2g0,jn2g0
         uc(1,j) = uc(1,j) + dtdx2(j)*(wk1(im,j)-wk1(1,j)) + dycp(j)*fy(1,j)
      do i=2,im
         uc(i,j) = uc(i,j) + dtdx2(j)*(wk1(i-1,j)-wk1(i,j)) + dycp(j)*fy(i,j)
      enddo
   enddo

   do j=js2g0,jlast
        do i=1,im-1
           vc(i,j) = vc(i,j) + dtdy5*(wk1(i,j-1)-wk1(i,j))-dxe(j)*fx(i+1,j)
        enddo
           vc(im,j) = vc(im,j) + dtdy5*(wk1(im,j-1)-wk1(im,j))-dxe(j)*fx(1,j)
   enddo

 end subroutine c_sw


!--------------------------------------------------------------------------
 subroutine d_sw( u,     v,      uc,       vc,                       &   
                  pt,    delp,   delpf,    cx3,                      &
                  cy3,    mfx,    mfy,     cdx,    cdy,              &
                  dtdx,  dtdxe,  dtxe5,  txe5,  dyce,   rdx,         &
                  cy,    dx,    f0,     js2g0,  jn1g1,               &  
                  im,    jm,     jfirst, jlast, ng_d,   ng_s,        &
                  nq,    iord,   jord,   sord,  zt_d,  rcap,         &
                  tiny,  dtdy,  dtdy5,  tdy5,   rdy,   cosp,         &
#ifndef USE_LIMA
                  acosp, cose,  coslon, sinlon, cosl5, sinl5, dyn_step )
#else
                  acosp, cose,  coslon, sinlon, cosl5, sinl5 )
#endif
!--------------------------------------------------------------------------
! Routine for shallow water dynamics on the D-grid

! INPUT:
  integer, intent(in):: im
  integer, intent(in):: jm
  integer, intent(in):: jfirst
  integer, intent(in):: jlast
  integer, intent(in):: iord
  integer, intent(in):: jord
  integer, intent(in):: sord               ! for pt and delp
  integer, intent(in):: js2g0
  integer, intent(in):: jn1g1
  integer, intent(in):: ng_d
  integer, intent(in):: ng_s
  integer, intent(in):: nq
#ifndef USE_LIMA
  integer, intent(in):: dyn_step
#endif

! Prognostic variables:
  real, intent(in):: u(im,jfirst-ng_d:jlast+ng_s)          ! Wind in X
  real, intent(in):: v(im,jfirst-ng_d:jlast+ng_d)          ! Wind in Y
  real, intent(inout):: delp(im,jfirst:jlast)         ! Delta pressure
  real, intent(inout):: pt(im,jfirst-ng_d:jlast+ng_d) ! (Virtual) Potential temperature
  real, intent(inout):: delpf(im,jfirst-ng_d:jlast+ng_d)

  real, intent(in):: cosp(jm)
  real, intent(in):: acosp(jm)
  real, intent(in):: cose(jm)

  real, intent(in):: sinlon(im)
  real, intent(in):: coslon(im)
  real, intent(in):: sinl5(im)
  real, intent(in):: cosl5(im)

  real, intent(in):: dtdx(jm)
  real, intent(in):: dtdxe(jm)
  real, intent(in):: dx(jm)
  real, intent(in):: rdx(jm)
  real, intent(in):: cy(jm)
  real, intent(in):: dyce(jm)
  real, intent(in):: dtxe5(jm)
  real, intent(in):: txe5(jm)

  real, intent(in):: cdx(js2g0:jn1g1)
  real, intent(in):: cdy(js2g0:jn1g1)
#ifndef USE_LIMA
  real, intent(in):: f0(im,jfirst-ng_d:jlast+ng_d)
#else               
  real, intent(in):: f0(jfirst-ng_d:jlast+ng_d)
#endif

  real, intent(in):: zt_d
  real, intent(in):: rcap
  real, intent(in):: tiny
  real, intent(in):: tdy5
  real, intent(in):: rdy
  real, intent(in):: dtdy
  real, intent(in):: dtdy5

! INPUT/OUTPUT:
  real, intent(inout):: uc(im,jfirst-ng_d:jlast+ng_d)
  real, intent(inout):: vc(im,jfirst-1   :jlast+2 )
  real, intent(inout):: cx3(im,jfirst-ng_d:jlast+ng_d)! Accumulated Courant number in X
  real, intent(inout):: cy3(im,jfirst:jlast+1)        ! Accumulated Courant number in Y
  real, intent(inout):: mfx(im,jfirst:jlast)          ! Mass flux in X  (unghosted)
  real, intent(inout):: mfy(im,jfirst:jlast+1)        ! Mass flux in Y

! Local 
    real    fx(im,jfirst:jlast)
    real   xfx(im,jfirst:jlast)

    real   wk1(im,jfirst-1:jlast+1)
    real   cry(im,jfirst-1:jlast+1)
    real    fy(im,jfirst-1:jlast+1)

    real  ymass(im,jfirst: jlast+1) 
    real    yfx(im,jfirst: jlast+1)

    real    ub(im,jfirst:  jlast+1)
#ifdef USE_LIMA
    real(r8)   va(im,jfirst-1:jlast)
#endif

    real   crx(im,jfirst-ng_d:jlast+ng_d)

    real  fxj(im)
    real  qtmp(-im/3:im+im/3)
    real  slope(-im/3:im+im/3)
    real  al(-im/3:im+im/3)
    real  ar(-im/3:im+im/3)
    real  a6(-im/3:im+im/3)

    real   c1, c2

    logical ffsl(jm)
    logical sld

    integer i, j
    integer js2gd, jn2g0, jn2g1, jn2gd, jn1gd

! Set loop limits

  jn2g0 = min(jm-1,jlast)
  jn2g1 = min(jm-1,jlast+1)
  js2gd = max(2,jfirst-ng_d)     ! NG latitudes on S (starting at 1)
  jn2gd = min(jm-1,jlast+ng_d)   ! NG latitudes on S (ending at jm-1)
  jn1gd = min(jm,jlast+ng_d)     ! NG latitudes on N (ending at jm)


! Get C-grid U-wind at poles.
! call upol5(uc,   vc,   im,  jm,  coslon,  sinlon,  &
!            cosl5, sinl5, jfirst, jlast, ng_d)

  do j=js2gd,jn2gd                     ! crx needed on N*ng S*ng
     do i=1,im
        crx(i,j) = dtdx(j)*uc(i,j)
     enddo
  enddo

  do 2225 j=js2gd,jn2gd                ! ffsl needed on N*ng S*ng
     ffsl(j) = .false.
     if( cosp(j) < zt_d ) then
         do i=1,im
            if( abs(crx(i,j)) > 1. ) then
               ffsl(j) = .true. 
               go to 2225
            endif
         enddo
      endif
2225    continue

  do j=js2g0,jn1g1                       ! cry, ymass needed on N
     do i=1,im
        cry(i,j) = dtdy*vc(i,j)
        ymass(i,j) = cry(i,j)*cose(j)
     enddo
  enddo

#ifdef USE_LIMA
  do j=js2g0,jn2g0                         ! No ghosting
     do i=1,im
        if( cry(i,j)*cry(i,j+1) > 0. ) then
           if( cry(i,j) > 0. ) then
              va(i,j) = cry(i,j)
           else
              va(i,j) = cry(i,j+1)         ! cry ghosted on N
           endif
        else
           va(i,j) = 0.
        endif
     enddo
  enddo
#endif


! transport polar filtered delp
#ifndef USE_LIMA
      call tp2c(ub(1,jfirst), delpf(1,jfirst-ng_d),   &
                crx(1,jfirst-ng_d),cry(1,jfirst),im,jm,sord,sord,   &
                ng_d, xfx, yfx, ffsl,                               &
                rcap, acosp,crx(1,jfirst), ymass,                   &
                cosp, 0, jfirst, jlast, delp, dyn_step)
#else
      call tp2c(ub(1,jfirst), va(1,jfirst), delpf(1,jfirst-ng_d),   &
                crx(1,jfirst-ng_d),cry(1,jfirst),im,jm,sord,sord,   &
                ng_d, xfx, yfx, ffsl,                               &
                rcap, acosp,crx(1,jfirst), ymass,                   &
                cosp, 0, jfirst, jlast)
#endif


! <<< Save necessary data for large time step tracer transport >>>
      if( nq > 0 ) then
          do j=js2g0,jn2g0                       ! No ghosting needed
  do i=1,im
              cx3(i,j) = cx3(i,j) + crx(i,j)
              mfx(i,j) = mfx(i,j) + xfx(i,j)
            enddo
          enddo

          do j=js2g0,jlast                      ! No ghosting needed
            do i=1,im
              cy3(i,j) = cy3(i,j) + cry(i,j)
              mfy(i,j) = mfy(i,j) + yfx(i,j)
            enddo
          enddo
      endif

     do j=js2g0,jn2g0                         ! No ghosting needed
        if( ffsl(j) ) then
          do i=1,im
             xfx(i,j) = xfx(i,j)/sign(max(abs(crx(i,j)),tiny),crx(i,j))
          enddo
        endif
     enddo

! Update delp
        do j=jfirst,jlast
          do i=1,im
! SAVE old delp: pressure thickness ~ "air density"
            wk1(i,j) = delp(i,j)
            delp(i,j) = wk1(i,j) + ub(i,j)
          enddo
        enddo

#if !defined ( SW_DYN )
! pt Advection
#ifndef USE_LIMA
  call tp2c(ub(1,jfirst), pt(1,jfirst-ng_d),    &
            crx(1,jfirst-ng_d),cry(1,jfirst),               &
            im,jm, sord, sord, ng_d, fx, fy(1,jfirst),      &
            ffsl, rcap, acosp, xfx, yfx(1,jfirst), cosp,    &
            1, jfirst,jlast, wk1(1,jfirst), dyn_step)
#else
  call tp2c(ub(1,jfirst),va(1,jfirst),pt(1,jfirst-ng_d),    &
            crx(1,jfirst-ng_d),cry(1,jfirst),               &
            im,jm, sord, sord, ng_d, fx, fy(1,jfirst),      &
            ffsl, rcap, acosp,                              &
            xfx, yfx(1,jfirst), cosp, 1, jfirst,jlast)
#endif

! Update pt.
      do j=jfirst,jlast
         do i=1,im
            pt(i,j) = (pt(i,j)*wk1(i,j)+ub(i,j)) / delp(i,j)
         enddo
      enddo
#endif

#ifdef ALT_KE
!----------------------------------------------------
! Computing KE directly on the corners using C-winds
!----------------------------------------------------
  do j=max(1,jfirst-1),jn1g1
     do i=1,im
        fy(i,j) = uc(i,j)**2 
     enddo
  enddo
 
  do j=js2g0,jn1g1 
     do i=1,im
        fxj(i) = vc(i,j)**2 
     enddo
        wk1(1,j) = fxj(im) + fxj(1)
     do i=2,im
        wk1(i,j) = fxj(i-1) + fxj(i)
     enddo
     do i=1,im
        wk1(i,j) = 0.25*(wk1(i,j) + fy(i,j) + fy(i,j-1))
     enddo
  enddo
#else
! Start using ub as v (CFL) on B-grid (cell corners)
      do j=js2g0,jn1g1                          ! ub needed on N
           ub(1,j) = dtdy5*(vc(1,j) + vc(im,j))  
         do i=2,im
            ub(i,j) = dtdy5*(vc(i,j) + vc(i-1,j))
         enddo
      enddo

      call ytp(im, jm, fy(1,jfirst), v(1,jfirst-ng_d), ub(1,jfirst),  &
               ub(1,jfirst), ng_d, jord, 1, jfirst, jlast)
! End using ub as v (CFL) on B-grid

   do j=js2g0,jn1g1                 ! ub needed on N
       do i=1,im                
          ub(i,j) = dtxe5(j)*(uc(i,j) + uc(i,j-1))
!                        uc will be used as wrok array after this point
       enddo
   enddo

  do j=js2g0,jn1g1                       ! wk1 needed on N
          sld = .false.
          if( cose(j) < zt_d ) then
            do i=1,im
              if( abs(ub(i,j)) > 1. ) then    ! ub ghosted on N
                sld = .true. 
                go to 2235
              endif
            enddo
          endif
2235      continue

     call xtp(im,  sld, fxj, u(1,j), ub(1,j),          &
              iord, ub(1,j), cose(j), 0,               &
              slope, qtmp, al, ar, a6 )

     do i=1,im
        wk1(i,j) =  txe5(j)*fxj(i) + tdy5*fy(i,j)  ! fy ghosted on N
     enddo
  enddo
#endif

! Add divergence damping to vector invariant form of the momentum eqn
! (absolute vorticity is damped by ffsl scheme, therefore divergence damping
! provides more consistent dissipation to divergent part of the flow)

!--------------------------
! Perform divergence damping 
!--------------------------

        do j=max(2,jfirst-1), jn2g1                   ! fy need on NS (below)
            do i=1,im
              fy(i,j) = v(i,j)*cosp(j)      ! v ghosted on NS at least
            enddo
        enddo

        do j=js2g0,jn1g1
! i=1
              uc(1,j) = u(im,j) - u(1,j)    ! u ghosted on N at least
            do i=2,im
              uc(i,j) = u(i-1,j) - u(i,j)
            enddo
        enddo

      if ( jfirst-1 <= 2 ) then
! j=2
           do i=1,im
              wk1(i,2) = wk1(i,2) - cdy(2)*fy(i, 2) + cdx(2)*uc(i,2)
           enddo
      endif

        do j=max(3,jfirst),jn2g1
            do i=1,im
              wk1(i,j) = wk1(i,j) + cdy(j)*(fy(i,j-1) - fy(i,j))  &
                                  + cdx(j)*uc(i,j)
            enddo
        enddo

      if ( jlast+1 >= jm ) then
           do i=1,im
              wk1(i,jm) = wk1(i,jm) + cdy(jm)*fy(i,jm-1) + cdx(jm)*uc(i,jm)
           enddo
      endif
!------------------------------------
! End divergence damping computation
!------------------------------------


! Compute Vorticity on the D grid
! delpf used as work array

      do j=js2gd,jn1gd
         do i=1,im
            delpf(i,j) = u(i,j)*cose(j)   ! u ghosted on N*ng S*ng
         enddo
      enddo

      if ( jfirst-ng_d <= 1 ) then
          c1 = 0.
          do i=1,im
            c1 = c1 + delpf(i,2)
          end do
          c1 = -c1*rdy*rcap

          do i=1,im
            uc(i,1) = c1
          enddo
      endif

      if ( jlast+ng_d >= jm ) then
          c2 = 0.
          do i=1,im
            c2 = c2 + delpf(i,jm)
          end do
          c2 = c2*rdy*rcap

          do i=1,im
            uc(i,jm) = c2
          enddo
      else

! This is an attempt to avoid ghosting u on N*(ng+1)
          do i=1,im
             uc(i,jn2gd) = 1.e40
          enddo
      endif

      do j=js2gd, min(jm-1,jlast+ng_d-1)
          do i=1,im-1
             uc(i,j) = ( delpf(i,j) - delpf(i,j+1)) * cy(j)  +         &
                        (v(i+1,j) - v(i,j))    * rdx(j)
          enddo
            uc(im,j) = (delpf(im,j) - delpf(im,j+1)) *  cy(j) +        &
                       (v(1,j) - v(im,j)) * rdx(j)
      enddo

! uc is relative vorticity at this point

#ifndef USE_LIMA
      do j=max(1,jfirst-ng_d), jn1gd
          do i=1,im
             uc(i,j) = uc(i,j) + f0(i,j)
! uc is absolute vorticity
          enddo
      enddo
#else               
      do j=max(1,jfirst-ng_d), jn1gd
          do i=1,im
             uc(i,j) = uc(i,j) + f0(j)
! uc is absolute vorticity
          enddo
      enddo
#endif

!-----------------------------
! Transport absolute vorticity
!-----------------------------
#ifndef USE_LIMA
      call tp2d(uc(1,jfirst-ng_d), crx(1,jfirst-ng_d),   &
                cry(1,jfirst), im, jm, iord, jord, ng_d, fx,           &
                fy(1,jfirst), ffsl, crx(1,jfirst),                     &
                ymass, cosp, acosp, 0, jfirst, jlast, delp, dyn_step)

#else
      call tp2d_lima(va(1,jfirst), uc(1,jfirst-ng_d), crx(1,jfirst-ng_d),   &
                cry(1,jfirst), im, jm, iord, jord, ng_d, fx,           &
                fy(1,jfirst), ffsl, crx(1,jfirst),                     &
                ymass, cosp, 0, jfirst, jlast)

#endif

      do j=js2g0,jlast
          do i=1,im-1
            uc(i,j) = dtdxe(j)*(wk1(i,j)-wk1(i+1,j)) + dyce(j)*fy(i,j)
          enddo
           uc(im,j) = dtdxe(j)*(wk1(im,j)-wk1(1,j)) + dyce(j)*fy(im,j)
      enddo

      do j=js2g0,jn2g0
          do i=1,im
            vc(i,j) = dtdy*(wk1(i,j)-wk1(i,j+1)) - dx(j)*fx(i,j)
          enddo
      enddo

 end subroutine d_sw


 subroutine upol5(u, v, im, jm, coslon, sinlon, cosl5, sinl5,    &
                  jfirst, jlast, ng)

! !INPUT PARAMETERS:
      integer im                       ! Total longitudes
      integer jm                       ! Total latitudes
      integer jfirst                   ! First PE latitude (no ghosting)
      integer jlast                    ! Last  PE latitude (no ghosting)
      integer ng

      real, intent(in):: coslon(im), sinlon(im)
      real, intent(in):: cosl5(im),  sinl5(im)
      real, intent(in):: v(im,jfirst:jlast)   ! Winds in Y (C-grid)
      real, intent(inout):: u(im,jfirst:jlast)      ! Winds in X (C-grid)

! LOCAL VARIABLES:

      integer i, imh
      real  uanp(im), uasp(im), vanp(im), vasp(im)
      real  un, vn, us, vs, r2im

      imh = im/2
      r2im = 0.5d0/dble(im)

      if ( jfirst == 1 ) then
!
! Treat SP
!
      do i=1,im-1
         uasp(i) = u(i,  2) + u(i+1,2)
      enddo
         uasp(im) = u(im,  2) + u(1,2)

      do i=1,im
         vasp(i) = v(i,  2) + v(i,  3)
      enddo

! Projection at SP

      us = 0.; vs = 0.
      do i=1,imh
         us = us + (uasp(i+imh)-uasp(i))*sinlon(i)     &
                 + (vasp(i)-vasp(i+imh))*coslon(i)
         vs = vs + (uasp(i+imh)-uasp(i))*coslon(i)     &
                 + (vasp(i+imh)-vasp(i))*sinlon(i)
      enddo
      us = us*r2im
      vs = vs*r2im

! get U-wind at SP

      do i=1,imh
         u(i,  1) = -us*sinl5(i) - vs*cosl5(i)
         u(i+imh,  1) = -u(i,  1)
      enddo

      endif

      if ( jlast == jm ) then
!
! Treat NP
!
      do i=1,im-1
         uanp(i) = u(i,jm-1) + u(i+1,jm-1)
      enddo
        uanp(im) = u(im,jm-1) + u(1,jm-1)

      do i=1,im
         vanp(i) = v(i,jm-1) + v(i,jm)
      enddo

! Projection at NP

      un = 0.;  vn = 0.
      do i=1,imh
         un = un + (uanp(i+imh)-uanp(i))*sinlon(i)  &
                 + (vanp(i+imh)-vanp(i))*coslon(i)
         vn = vn + (uanp(i)-uanp(i+imh))*coslon(i)  &
                 + (vanp(i+imh)-vanp(i))*sinlon(i)
      enddo
      un = un*r2im
      vn = vn*r2im

! get U-wind at NP
      do i=1,imh
         u(i,jm) = -un*sinl5(i) + vn*cosl5(i)
         u(i+imh,jm) = -u(i,jm)
      enddo

      endif

!EOC
 end subroutine upol5
!----------------------------------------------------------------------- 

!----------------------------------------------------------------------- 
!BOP
!
 subroutine vpol5(u, v, im, jm, coslon, sinlon, cosl5, sinl5,    &
                  ng_d,  ng_s,  jfirst, jlast)

! !INPUT PARAMETERS:
      integer im                       ! Total longitudes
      integer jm                       ! Total latitudes
      integer jfirst                   ! First PE latitude (no ghosting)
      integer jlast                    ! Last  PE latitude (no ghosting)
      integer, intent(in):: ng_s, ng_d
      real, intent(in):: coslon(im), sinlon(im)
      real, intent(in):: cosl5(im),sinl5(im)
      real, intent(in):: u(im,jfirst-ng_d:jlast+ng_s)

! !INPUT/OUTPUT PARAMETERS:
      real, intent(inout):: v(im,jfirst-ng_d:jlast+ng_d)

! !DESCRIPTION:
!
!   Treat the V winds at the poles.  This requires an average 
!   of the U- and V-winds, weighted by their angles of incidence
!   at the pole points.     
!
! !REVISION HISTORY:
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:

      integer i, imh
      real  uanp(im), uasp(im), vanp(im), vasp(im)
      real  un, vn, us, vs, r2im

! WS 99.05.25 :  Replaced conversions of IMR with IM
      r2im = 0.5d0/dble(im)
      imh  = im / 2

! WS 990726 :  Added condition to decide if poles are on this processor

   if ( jfirst-ng_d <= 1 ) then
         do i=1,im
            uasp(i) = u(i,  2) + u(i,3)
         enddo

         do i=1,im-1
            vasp(i)  = v(i,  2) + v(i+1,2)
         enddo
            vasp(im) = v(im,2) + v(1,2)

! Projection at SP
      us = 0.; vs = 0.

      do i=1,imh
         us = us + (uasp(i+imh)-uasp(i))*sinlon(i)    &
                 + (vasp(i)-vasp(i+imh))*coslon(i)
         vs = vs + (uasp(i+imh)-uasp(i))*coslon(i)    &
                 + (vasp(i+imh)-vasp(i))*sinlon(i)
      enddo
      us = us*r2im
      vs = vs*r2im

! get V-wind at SP

      do i=1,imh
         v(i,    1) =  us*cosl5(i) - vs*sinl5(i)
         v(i+imh,1) = -v(i,1)
      enddo

   endif

   if ( jlast+ng_d >= jm ) then

      do i=1,im
         uanp(i) = u(i,jm-1) + u(i,jm)
      enddo

      do i=1,im-1
         vanp(i) = v(i,jm-1) + v(i+1,jm-1)
      enddo
         vanp(im) = v(im,jm-1) + v(1,jm-1)

! Projection at NP

      un = 0.
      vn = 0.
      do i=1,imh
         un = un + (uanp(i+imh)-uanp(i))*sinlon(i)   &
                 + (vanp(i+imh)-vanp(i))*coslon(i)
         vn = vn + (uanp(i)-uanp(i+imh))*coslon(i)   &
                 + (vanp(i+imh)-vanp(i))*sinlon(i)
      enddo
      un = un*r2im
      vn = vn*r2im

! get V-wind at NP

      do i=1,imh
         v(i,    jm) = -un*cosl5(i) - vn*sinl5(i)
         v(i+imh,jm) = -v(i,jm)
      enddo

   endif

 end subroutine vpol5

!-----------------------------------------------------------------------
 end module sw_core

module fft99_mod

use constants_mod, only: pi
use mpp_mod,       only: mpp_error, FATAL

implicit none
private

public :: fft99, fft991, set99

contains

!##########################################################################

    subroutine fft99 (a,work,trigs,ifax,inc,jump,n,lot,isign) 

! purpose      performs multiple fast fourier transforms.  this package
!              will perform a number of simultaneous real/half-complex
!              periodic fourier transforms or corresponding inverse
!              transforms, i.e.  given a set of real data vectors, the
!              package returns a set of 'half-complex' fourier
!              coefficient vectors, or vice versa.  the length of the
!              transforms must be an even number greater than 4 that has
!              no other factors except possibly powers of 2, 3, and 5.
!              this is an all-fortran version of a optimized routine
!              fft99 written for xmp/ymps by dr. clive temperton of
!              ecmwf.
!
!              the package fft99f contains several user-level routines:
!
!            subroutine set99
!                an initialization routine that must be called once
!                before a sequence of calls to the fft routines
!                (provided that n is not changed).
!
!            subroutines fft99 and fft991
!                two fft routines that return slightly different
!                arrangements of the data in gridpoint space.
!
! usage        let n be of the form 2**p * 3**q * 5**r, where p .ge. 1,
!              q .ge. 0, and r .ge. 0.  then a typical sequence of
!              calls to transform a given set of real vectors of length
!              n to a set of 'half-complex' fourier coefficient vectors
!              of length n is
!
!                   dimension ifax(13),trigs(3*n/2+1),a(m*(n+2)),
!                  +          work(m*(n+1))
!
!                   call set99 (trigs, ifax, n)
!                   call fft99 (a,work,trigs,ifax,inc,jump,n,m,isign)
!
!              see the individual write-ups for set99, fft99, and
!              fft991 below, for a detailed description of the
!              arguments.
!
! history      the package was written by clive temperton at ecmwf in
!              november, 1978.  it was modified, documented, and tested
!              for ncar by russ rew in september, 1980.
!
!-----------------------------------------------------------------------
!
! subroutine set99 (trigs, ifax, n)
!
! purpose      a set-up routine for fft99 and fft991.  it need only be
!              called once before a sequence of calls to the fft
!              routines (provided that n is not changed).
!
! argument     ifax(13),trigs(3*n/2+1)
! dimensions
!
! arguments
!
! on input     trigs
!               a floating point array of dimension 3*n/2 if n/2 is
!               even, or 3*n/2+1 if n/2 is odd.
!
!              ifax
!               an integer array.  the number of elements actually used
!               will depend on the factorization of n.  dimensioning
!               ifax for 13 suffices for all n less than a million.
!
!              n
!               an even number greater than 4 that has no prime factor
!               greater than 5.  n is the length of the transforms (see
!               the documentation for fft99 and fft991 for the
!               definitions of the transforms).
!
! on output    ifax
!               contains the factorization of n/2.  ifax(1) is the
!               number of factors, and the factors themselves are stored
!               in ifax(2),ifax(3),...  if set99 is called with n odd,
!               or if n has any prime factors greater than 5, ifax(1)
!               is set to -99.
!
!              trigs
!               an array of trigonometric function values subsequently
!               used by the fft routines.
!
!-----------------------------------------------------------------------
!
! subroutine fft991 (a,work,trigs,ifax,inc,jump,n,m,isign)
!                       and
! subroutine fft99 (a,work,trigs,ifax,inc,jump,n,m,isign)
!
! purpose      perform a number of simultaneous real/half-complex
!              periodic fourier transforms or corresponding inverse
!              transforms, using ordinary spatial order of gridpoint
!              values (fft991) or explicit cyclic continuity in the
!              gridpoint values (fft99).  given a set
!              of real data vectors, the package returns a set of
!              'half-complex' fourier coefficient vectors, or vice
!              versa.  the length of the transforms must be an even
!              number that has no other factors except possibly powers
!              of 2, 3, and 5.  this is an all-fortran version of 
!              optimized routine fft991 written for xmp/ymps by
!              dr. clive temperton of ecmwf.
!
! argument     a(m*(n+2)), work(m*(n+1)), trigs(3*n/2+1), ifax(13)
! dimensions
!
! arguments
!
! on input     a
!               an array of length m*(n+2) containing the input data
!               or coefficient vectors.  this array is overwritten by
!               the results.
!
!              work
!               a work array of dimension m*(n+1)
!
!              trigs
!               an array set up by set99, which must be called first.
!
!              ifax
!               an array set up by set99, which must be called first.
!
!              inc
!               the increment (in words) between successive elements of
!               each data or coefficient vector (e.g.  inc=1 for
!               consecutively stored data).
!
!              jump
!               the increment (in words) between the first elements of
!               successive data or coefficient vectors.  on crays, 
!               try to arrange data so that jump is not a multiple of 8
!               (to avoid memory bank conflicts).  for clarification of
!               inc and jump, see the examples below.
!
!              n
!               the length of each transform (see definition of
!               transforms, below).
!
!              m
!               the number of transforms to be done simultaneously.
!
!              isign
!               = +1 for a transform from fourier coefficients to
!                    gridpoint values.
!               = -1 for a transform from gridpoint values to fourier
!                    coefficients.
!
! on output    a
!               if isign = +1, and m coefficient vectors are supplied
!               each containing the sequence:
!
!               a(0),b(0),a(1),b(1),...,a(n/2),b(n/2)  (n+2 values)
!
!               then the result consists of m data vectors each
!               containing the corresponding n+2 gridpoint values:
!
!               for fft991, x(0), x(1), x(2),...,x(n-1),0,0.
!               for fft99, x(n-1),x(0),x(1),x(2),...,x(n-1),x(0).
!                   (explicit cyclic continuity)
!
!               when isign = +1, the transform is defined by:
!                 x(j)=sum(k=0,...,n-1)(c(k)*exp(2*i*j*k*pi/n))
!                 where c(k)=a(k)+i*b(k) and c(n-k)=a(k)-i*b(k)
!                 and i=sqrt (-1)
!
!               if isign = -1, and m data vectors are supplied each
!               containing a sequence of gridpoint values x(j) as
!               defined above, then the result consists of m vectors
!               each containing the corresponding fourier cofficients
!               a(k), b(k), 0 .le. k .le n/2.
!
!               when isign = -1, the inverse transform is defined by:
!                 c(k)=(1/n)*sum(j=0,...,n-1)(x(j)*exp(-2*i*j*k*pi/n))
!                 where c(k)=a(k)+i*b(k) and i=sqrt(-1)
!
!               a call with isign=+1 followed by a call with isign=-1
!               (or vice versa) returns the original data.
!
!               note: the fact that the gridpoint values x(j) are real
!               implies that b(0)=b(n/2)=0.  for a call with isign=+1,
!               it is not actually necessary to supply these zeros.
!
! examples      given 19 data vectors each of length 64 (+2 for explicit
!               cyclic continuity), compute the corresponding vectors of
!               fourier coefficients.  the data may, for example, be
!               arranged like this:
!
! first data   a(1)=    . . .                a(66)=             a(70)
! vector       x(63) x(0) x(1) x(2) ... x(63) x(0)  (4 empty locations)
!
! second data  a(71)=   . . .                                  a(140)
! vector       x(63) x(0) x(1) x(2) ... x(63) x(0)  (4 empty locations)
!
!               and so on.  here inc=1, jump=70, n=64, m=19, isign=-1,
!               and fft99 should be used (because of the explicit cyclic
!               continuity).
!
!               alternatively the data may be arranged like this:
!
!                first         second                          last
!                data          data                            data
!                vector        vector                          vector
!
!                 a(1)=         a(2)=                           a(19)=
!
!                 x(63)         x(63)       . . .               x(63)
!        a(20)=   x(0)          x(0)        . . .               x(0)
!        a(39)=   x(1)          x(1)        . . .               x(1)
!                  .             .                               .
!                  .             .                               .
!                  .             .                               .
!
!               in which case we have inc=19, jump=1, and the remaining
!               parameters are the same as before.  in either case, each
!               coefficient vector overwrites the corresponding input
!               data vector.
!
!-----------------------------------------------------------------------
    integer, intent(in)    :: inc,jump,n,lot,isign
    integer, intent(inout) :: ifax(:)
    real,    intent(in)    :: trigs(:)
    real,    intent(inout) :: a(*),work(*)

!     dimension a(n),work(n),trigs(n),ifax(1)
!
!     subroutine "fft99" - multiple fast real periodic transform
!     corresponding to old scalar routine fft9
!     procedure used to convert to half-length complex transform
!     is given by cooley, lewis and welch (j. sound vib., vol. 12
!     (1970), 315-337)
!
!     a is the array containing input and output data
!     work is an area of size (n+1)*lot
!     trigs is a previously prepared list of trig function values
!     ifax is a previously prepared list of factors of n/2
!     inc is the increment within each data 'vector'
!         (e.g. inc=1 for consecutively stored data)
!     jump is the increment between the start of each data vector
!     n is the length of the data vectors
!     lot is the number of data vectors
!     isign = +1 for transform from spectral to gridpoint
!           = -1 for transform from gridpoint to spectral
!
!     ordering of coefficients:
!         a(0),b(0),a(1),b(1),a(2),b(2),...,a(n/2),b(n/2)
!         where b(0)=b(n/2)=0; (n+2) locations required
!
!     ordering of data:
!         x(n-1),x(0),x(1),x(2),...,x(n),x(0)
!         i.e. explicit cyclic continuity; (n+2) locations required
!
!     vectorization is achieved on cray by doing the transforms in
!     parallel
!
!     *** n.b. n is assumed to be an even number
!
!     definition of transforms:
!     -------------------------
!
!     isign=+1: x(j)=sum(k=0,...,n-1)(c(k)*exp(2*i*j*k*pi/n))
!         where c(k)=a(k)+i*b(k) and c(n-k)=a(k)-i*b(k)
!
!     isign=-1: a(k)=(1/n)*sum(j=0,...,n-1)(x(j)*cos(2*j*k*pi/n))
!               b(k)=-(1/n)*sum(j=0,...,n-1)(x(j)*sin(2*j*k*pi/n))
!

    integer :: nfax, nx, nh, ink, igo, ibase, jbase
    integer :: i, j, k, L, m, ia, la, ib

      nfax=ifax(1)
      nx=n+1
      nh=n/2
      ink=inc+inc
      if (isign.eq.+1) go to 30

!   if necessary, transfer data to work area
      igo=50
      if (mod(nfax,2).eq.1) goto 40
      ibase=inc+1
      jbase=1
    do L=1,lot
      i=ibase
      j=jbase
!dir$ ivdep
      do m=1,n
        work(j)=a(i)
        i=i+inc
        j=j+1
      enddo
      ibase=ibase+jump
      jbase=jbase+nx
    enddo

      igo=60
      go to 40

!   preprocessing (isign=+1)
!   ------------------------

   30 continue
      call fft99a(a,work,trigs,inc,jump,n,lot)
      igo=60

!   complex transform
!   -----------------

   40 continue
      ia=inc+1
      la=1
      do 80 k=1,nfax
      if (igo.eq.60) go to 60
   50 continue
      call vpassm (a(ia),a(ia+inc),work(1),work(2),trigs, &
                   ink,2,jump,nx,lot,nh,ifax(k+1),la)
      igo=60
      go to 70
   60 continue
      call vpassm (work(1),work(2),a(ia),a(ia+inc),trigs, &
                   2,ink,nx,jump,lot,nh,ifax(k+1),la)
      igo=50
   70 continue
      la=la*ifax(k+1)
   80 continue

    if (isign.eq.-1) go to 130

! if necessary, transfer data from work area

    if (mod(nfax,2).ne.1) then
      ibase=1
      jbase=ia
      do L=1,lot
        i=ibase
        j=jbase
!dir$ ivdep
        do m=1,n
          a(j)=work(i)
          i=i+1
          j=j+inc
        enddo
        ibase=ibase+nx
        jbase=jbase+jump
      enddo
    endif

!   fill in cyclic boundary points
      ia=1
      ib=n*inc+1
!dir$ ivdep
      do L=1,lot
        a(ia)=a(ib)
        a(ib+inc)=a(ia+inc)
        ia=ia+jump
        ib=ib+jump
      enddo
      go to 140

!   postprocessing (isign=-1):
!   --------------------------

  130 continue
      call fft99b(work,a,trigs,inc,jump,n,lot)

  140 continue

    end subroutine fft99

!##########################################################################

    subroutine fft99a (a,work,trigs,inc,jump,n,lot)
    integer, intent(in)    :: inc,jump,n,lot
    real,    intent(in)    :: trigs(:)
    real,    intent(inout) :: a(*),work(*)

!     dimension a(n),work(n),trigs(n)
!
!     subroutine fft99a - preprocessing step for fft99, isign=+1
!     (spectral to gridpoint transform)

    integer :: nh, nx, ink, k, L
    integer :: ia, ib, ja, jb, iabase, ibbase, jabase, jbbase
    real    :: c, s

      nh=n/2
      nx=n+1
      ink=inc+inc

!   a(0) and a(n/2)
      ia=1
      ib=n*inc+1
      ja=1
      jb=2
!dir$ ivdep
    do L=1,lot
      work(ja)=a(ia)+a(ib)
      work(jb)=a(ia)-a(ib)
      ia=ia+jump
      ib=ib+jump
      ja=ja+nx
      jb=jb+nx
    enddo
 
!   remaining wavenumbers
      iabase=2*inc+1
      ibbase=(n-2)*inc+1
      jabase=3
      jbbase=n-1

    do k=3,nh,2
      ia=iabase
      ib=ibbase
      ja=jabase
      jb=jbbase
      c=trigs(n+k)
      s=trigs(n+k+1)
!dir$ ivdep
      do L=1,lot
        work(ja)=(a(ia)+a(ib))- &
            (s*(a(ia)-a(ib))+c*(a(ia+inc)+a(ib+inc)))
        work(jb)=(a(ia)+a(ib))+ &
            (s*(a(ia)-a(ib))+c*(a(ia+inc)+a(ib+inc)))
        work(ja+1)=(c*(a(ia)-a(ib))-s*(a(ia+inc)+a(ib+inc)))+ &
            (a(ia+inc)-a(ib+inc))
        work(jb+1)=(c*(a(ia)-a(ib))-s*(a(ia+inc)+a(ib+inc)))- &
            (a(ia+inc)-a(ib+inc))
        ia=ia+jump
        ib=ib+jump
        ja=ja+nx
        jb=jb+nx
      enddo
      iabase=iabase+ink
      ibbase=ibbase-ink
      jabase=jabase+2
      jbbase=jbbase-2
    enddo

!   wavenumber n/4 (if it exists)
    if (iabase.eq.ibbase) then
      ia=iabase
      ja=jabase
!dir$ ivdep
      do L=1,lot
        work(ja)=2.0*a(ia)
        work(ja+1)=-2.0*a(ia+inc)
        ia=ia+jump
        ja=ja+nx
      enddo
    endif

    end subroutine fft99a

!##########################################################################

    subroutine fft99b (work,a,trigs,inc,jump,n,lot)
    integer, intent(in)    :: inc,jump,n,lot
    real,    intent(in)    :: trigs(:)
    real,    intent(inout) :: a(*),work(*)

!     dimension work(n),a(n),trigs(n)
!
!     subroutine fft99b - postprocessing step for fft99, isign=-1
!     (gridpoint to spectral transform)

    integer :: nh, nx, ink, k, L
    integer :: ia, ib, ja, jb, iabase, ibbase, jabase, jbbase
    real    :: scale, c, s

      nh=n/2
      nx=n+1
      ink=inc+inc

!   a(0) and a(n/2)
      scale=1.0/real(n)
      ia=1
      ib=2
      ja=1
      jb=n*inc+1
!dir$ ivdep
    do L=1,lot
      a(ja)=scale*(work(ia)+work(ib))
      a(jb)=scale*(work(ia)-work(ib))
      a(ja+inc)=0.0
      a(jb+inc)=0.0
      ia=ia+nx
      ib=ib+nx
      ja=ja+jump
      jb=jb+jump
    enddo

!   remaining wavenumbers
      scale=0.5*scale
      iabase=3
      ibbase=n-1
      jabase=2*inc+1
      jbbase=(n-2)*inc+1

    do k=3,nh,2
      ia=iabase
      ib=ibbase
      ja=jabase
      jb=jbbase
      c=trigs(n+k)
      s=trigs(n+k+1)
!dir$ ivdep
      do L=1,lot
        a(ja)=scale*((work(ia)+work(ib)) &
           +(c*(work(ia+1)+work(ib+1))+s*(work(ia)-work(ib))))
        a(jb)=scale*((work(ia)+work(ib)) &
           -(c*(work(ia+1)+work(ib+1))+s*(work(ia)-work(ib))))
        a(ja+inc)=scale*((c*(work(ia)-work(ib))-s*(work(ia+1)+work(ib+1))) &
            +(work(ib+1)-work(ia+1)))
        a(jb+inc)=scale*((c*(work(ia)-work(ib))-s*(work(ia+1)+work(ib+1))) &
            -(work(ib+1)-work(ia+1)))
        ia=ia+nx
        ib=ib+nx
        ja=ja+jump
        jb=jb+jump
      enddo
      iabase=iabase+2
      ibbase=ibbase-2
      jabase=jabase+ink
      jbbase=jbbase-ink
    enddo

!   wavenumber n/4 (if it exists)
    if (iabase.eq.ibbase) then
      ia=iabase
      ja=jabase
      scale=2.0*scale
!dir$ ivdep
      do L=1,lot
        a(ja)=scale*work(ia)
        a(ja+inc)=-scale*work(ia+1)
        ia=ia+nx
        ja=ja+jump
      enddo
    endif

    end subroutine fft99b

!##########################################################################

    subroutine fft991(a,work,trigs,ifax,inc,jump,n,lot,isign)
    integer, intent(in)    :: inc,jump,n,lot,isign
    integer, intent(inout) :: ifax(:)
    real,    intent(in)    :: trigs(:)
    real,    intent(inout) :: a(*),work((n+1)*lot)

!     dimension a(n),work(n),trigs(n),ifax(1)
!
!     subroutine "fft991" - multiple real/half-complex periodic
!     fast fourier transform
!
!     same as fft99 except that ordering of data corresponds to
!     that in mrfft2
!
!     procedure used to convert to half-length complex transform
!     is given by cooley, lewis and welch (j. sound vib., vol. 12
!     (1970), 315-337)
!
!     a is the array containing input and output data
!     work is an area of size (n+1)*lot
!     trigs is a previously prepared list of trig function values
!     ifax is a previously prepared list of factors of n/2
!     inc is the increment within each data 'vector'
!         (e.g. inc=1 for consecutively stored data)
!     jump is the increment between the start of each data vector
!     n is the length of the data vectors
!     lot is the number of data vectors
!     isign = +1 for transform from spectral to gridpoint
!           = -1 for transform from gridpoint to spectral
!
!     ordering of coefficients:
!         a(0),b(0),a(1),b(1),a(2),b(2),...,a(n/2),b(n/2)
!         where b(0)=b(n/2)=0; (n+2) locations required
!
!     ordering of data:
!         x(0),x(1),x(2),...,x(n-1)
!
!     vectorization is achieved on cray by doing the transforms in
!     parallel
!
!     *** n.b. n is assumed to be an even number
!
!     definition of transforms:
!     -------------------------
!
!     isign=+1: x(j)=sum(k=0,...,n-1)(c(k)*exp(2*i*j*k*pi/n))
!         where c(k)=a(k)+i*b(k) and c(n-k)=a(k)-i*b(k)
!
!     isign=-1: a(k)=(1/n)*sum(j=0,...,n-1)(x(j)*cos(2*j*k*pi/n))
!               b(k)=-(1/n)*sum(j=0,...,n-1)(x(j)*sin(2*j*k*pi/n))
!

    integer :: nfax, nx, nh, ink, igo, ibase, jbase
    integer :: i, j, k, L, m, ia, la, ib


      nfax=ifax(1)
      nx=n+1
      nh=n/2
      ink=inc+inc
      if (isign.eq.+1) go to 30

!     if necessary, transfer data to work area
      igo=50
      if (mod(nfax,2).eq.1) goto 40
      ibase=1
      jbase=1
    do L=1,lot
      i=ibase
      j=jbase
!dir$ ivdep
      do m=1,n
        work(j)=a(i)
        i=i+inc
        j=j+1
      enddo
      ibase=ibase+jump
      jbase=jbase+nx
    enddo
!
      igo=60
      go to 40
!
!   preprocessing (isign=+1)
!   ------------------------
!
   30 continue
      call fft99a(a,work,trigs,inc,jump,n,lot)
      igo=60
!
!   complex transform
!   -----------------
!
   40 continue
      ia=1
      la=1
    do k=1,nfax
      if (igo.eq.60) go to 60
   50 continue
        call vpassm (a(ia),a(ia+inc),work(1),work(2),trigs, &
                     ink,2,jump,nx,lot,nh,ifax(k+1),la)
      igo=60
      go to 70
   60 continue
        call vpassm (work(1),work(2),a(ia),a(ia+inc),trigs, &
                     2,ink,nx,jump,lot,nh,ifax(k+1),la)
      igo=50
   70 continue
      la=la*ifax(k+1)
    enddo

    if (isign.eq.-1) go to 130

! if necessary, transfer data from work area
    if (mod(nfax,2).ne.1) then
      ibase=1
      jbase=1
      do L=1,lot
        i=ibase
        j=jbase
!dir$ ivdep
        do m=1,n
          a(j)=work(i)
          i=i+1
          j=j+inc
        enddo
        ibase=ibase+nx
        jbase=jbase+jump
      enddo
    endif

!   fill in zeros at end
      ib=n*inc+1
!dir$ ivdep
      do L=1,lot
        a(ib)=0.0
        a(ib+inc)=0.0
        ib=ib+jump
      enddo
      go to 140

!     postprocessing (isign=-1):
!     --------------------------

  130 continue
      call fft99b (work,a,trigs,inc,jump,n,lot)

  140 continue

    end subroutine fft991

!##########################################################################

    subroutine set99 (trigs, ifax, n)
    integer, intent(in)  :: n
    integer, intent(out) :: ifax(:)
    real,    intent(out) :: trigs(:)

!     dimension ifax(13),trigs(1)
!
! mode 3 is used for real/half-complex transforms.  it is possible
! to do complex/complex transforms with other values of mode, but
! documentation of the details were not available when this routine
! was written.
!
    integer :: mode = 3
    integer :: i

      call fax (ifax, n, mode)
      i = ifax(1)
      if (ifax(i+1) .gt. 5 .or. n .le. 4) ifax(1) = -99
      if (ifax(1) .le. 0 ) then 
        call mpp_error(FATAL,'fft99_mod: in routine set99 -- invalid n')
      endif
      call fftrig (trigs, n, mode)

    end subroutine set99

!##########################################################################

    subroutine fax (ifax,n,mode)
    integer, intent(out) :: ifax(:)
    integer, intent(in)  :: n, mode

    integer :: nn, k, L, inc, nfax, ii, istop, i, item

      nn=n
      if (iabs(mode).eq.1) go to 10
      if (iabs(mode).eq.8) go to 10
      nn=n/2
      if ((nn+nn).eq.n) go to 10
      ifax(1)=-99
      return
   10 k=1
!     test for factors of 4
   20 if (mod(nn,4).ne.0) go to 30
      k=k+1
      ifax(k)=4
      nn=nn/4
      if (nn.eq.1) go to 80
      go to 20
!     test for extra factor of 2
   30 if (mod(nn,2).ne.0) go to 40
      k=k+1
      ifax(k)=2
      nn=nn/2
      if (nn.eq.1) go to 80
!     test for factors of 3
   40 if (mod(nn,3).ne.0) go to 50
      k=k+1
      ifax(k)=3
      nn=nn/3
      if (nn.eq.1) go to 80
      go to 40
!     now find remaining factors
   50 L=5
      inc=2
!     inc alternately takes on values 2 and 4
   60 if (mod(nn,L).ne.0) go to 70
      k=k+1
      ifax(k)=L
      nn=nn/L
      if (nn.eq.1) go to 80
      go to 60
   70 L=L+inc
      inc=6-inc
      go to 60
   80 ifax(1)=k-1
!     ifax(1) contains number of factors
      nfax=ifax(1)
!     sort factors into ascending order
      if (nfax.eq.1) go to 110
      do 100 ii=2,nfax
      istop=nfax+2-ii
      do 90 i=2,istop
      if (ifax(i+1).ge.ifax(i)) go to 90
      item=ifax(i)
      ifax(i)=ifax(i+1)
      ifax(i+1)=item
   90 continue
  100 continue
  110 continue

    end subroutine fax

!##########################################################################

    subroutine fftrig (trigs,n,mode)
    real,    intent(out) :: trigs(:)
    integer, intent(in)  :: n, mode

    real    :: del, angle
    integer :: imode, nn, nh, i, L, la

      imode=iabs(mode)
      nn=n
      if (imode.gt.1.and.imode.lt.6) nn=n/2
      del=(pi+pi)/real(nn)
      L=nn+nn
      do i=1,L,2
        angle=0.5*real(i-1)*del
        trigs(i)=cos(angle)
        trigs(i+1)=sin(angle)
      enddo
      if (imode.eq.1) return
      if (imode.eq.8) return

      del=0.5*del
      nh=(nn+1)/2
      L=nh+nh
      la=nn+nn
      do i=1,L,2
        angle=0.5*real(i-1)*del
        trigs(la+i)=cos(angle)
        trigs(la+i+1)=sin(angle)
      enddo
      if (imode.le.3) return

      del=0.5*del
      la=la+nn
    if (mode.ne.5) then
      do i=2,nn
        angle=real(i-1)*del
        trigs(la+i)=2.0*sin(angle)
      enddo
      return
    endif

      del=0.5*del
      do i=2,n
        angle=real(i-1)*del
        trigs(la+i)=sin(angle)
      enddo

    end subroutine fftrig

!##########################################################################

    subroutine vpassm (a,b,c,d,trigs,inc1,inc2,inc3,inc4,lot,n,ifac,la)
    integer, intent(in)  :: inc1, inc2, inc3, inc4, lot, n, ifac, la
    real,    intent(in)  :: a(*),b(*),trigs(*)
    real,    intent(out) :: c(*),d(*)
!
!     subroutine "vpassm" - multiple version of "vpassa"
!     performs one pass through data
!     as part of multiple complex fft routine
!     a is first real input vector
!     b is first imaginary input vector
!     c is first real output vector
!     d is first imaginary output vector
!     trigs is precalculated table of sines " cosines
!     inc1 is addressing increment for a and b
!     inc2 is addressing increment for c and d
!     inc3 is addressing increment between a"s & b"s
!     inc4 is addressing increment between c"s & d"s
!     lot is the number of vectors
!     n is length of vectors
!     ifac is current factor of n
!     la is product of previous factors
!

    real :: sin36=0.587785252292473
    real :: cos36=0.809016994374947
    real :: sin72=0.951056516295154
    real :: cos72=0.309016994374947
    real :: sin60=0.866025403784437

    integer :: i, j, k, L, m, iink, jink, jump, ibase, jbase, igo, ijk, la1
    integer :: ia, ja, ib, jb, kb, ic, jc, kc, id, jd, kd, ie, je, ke
    real    :: c1, s1, c2, s2, c3, s3, c4, s4

      m=n/ifac
      iink=m*inc1
      jink=la*inc2
      jump=(ifac-1)*jink
      ibase=0
      jbase=0
      igo=ifac-1
      if (igo.gt.4) return
!del  go to (10,50,90,130),igo

  select case (igo)

!   coding for factor 2

    case (1)
   10 ia=1
      ja=1
      ib=ia+iink
      jb=ja+jink
      do 20 L=1,la
      i=ibase
      j=jbase
!dir$ ivdep
      do 15 ijk=1,lot
      c(ja+j)=a(ia+i)+a(ib+i)
      d(ja+j)=b(ia+i)+b(ib+i)
      c(jb+j)=a(ia+i)-a(ib+i)
      d(jb+j)=b(ia+i)-b(ib+i)
      i=i+inc3
      j=j+inc4
   15 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
   20 continue
      if (la.eq.m) return
      la1=la+1
      jbase=jbase+jump
      do 40 k=la1,m,la
      kb=k+k-2
      c1=trigs(kb+1)
      s1=trigs(kb+2)
      do 30 L=1,la
      i=ibase
      j=jbase
!dir$ ivdep
      do 25 ijk=1,lot
      c(ja+j)=a(ia+i)+a(ib+i)
      d(ja+j)=b(ia+i)+b(ib+i)
      c(jb+j)=c1*(a(ia+i)-a(ib+i))-s1*(b(ia+i)-b(ib+i))
      d(jb+j)=s1*(a(ia+i)-a(ib+i))+c1*(b(ia+i)-b(ib+i))
      i=i+inc3
      j=j+inc4
   25 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
   30 continue
      jbase=jbase+jump
   40 continue
!     return

!   coding for factor 3

    case (2)
   50 ia=1
      ja=1
      ib=ia+iink
      jb=ja+jink
      ic=ib+iink
      jc=jb+jink
      do 60 L=1,la
      i=ibase
      j=jbase
!dir$ ivdep
      do 55 ijk=1,lot
      c(ja+j)=a(ia+i)+(a(ib+i)+a(ic+i))
      d(ja+j)=b(ia+i)+(b(ib+i)+b(ic+i))
      c(jb+j)=(a(ia+i)-0.5*(a(ib+i)+a(ic+i)))-(sin60*(b(ib+i)-b(ic+i)))
      c(jc+j)=(a(ia+i)-0.5*(a(ib+i)+a(ic+i)))+(sin60*(b(ib+i)-b(ic+i)))
      d(jb+j)=(b(ia+i)-0.5*(b(ib+i)+b(ic+i)))+(sin60*(a(ib+i)-a(ic+i)))
      d(jc+j)=(b(ia+i)-0.5*(b(ib+i)+b(ic+i)))-(sin60*(a(ib+i)-a(ic+i)))
      i=i+inc3
      j=j+inc4
   55 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
   60 continue
      if (la.eq.m) return
      la1=la+1
      jbase=jbase+jump
      do 80 k=la1,m,la
      kb=k+k-2
      kc=kb+kb
      c1=trigs(kb+1)
      s1=trigs(kb+2)
      c2=trigs(kc+1)
      s2=trigs(kc+2)
      do 70 L=1,la
      i=ibase
      j=jbase
!dir$ ivdep
      do 65 ijk=1,lot
      c(ja+j)=a(ia+i)+(a(ib+i)+a(ic+i))
      d(ja+j)=b(ia+i)+(b(ib+i)+b(ic+i))
      c(jb+j)=                                                           &
          c1*((a(ia+i)-0.5*(a(ib+i)+a(ic+i)))-(sin60*(b(ib+i)-b(ic+i)))) &
         -s1*((b(ia+i)-0.5*(b(ib+i)+b(ic+i)))+(sin60*(a(ib+i)-a(ic+i))))
      d(jb+j)=                                                           &
          s1*((a(ia+i)-0.5*(a(ib+i)+a(ic+i)))-(sin60*(b(ib+i)-b(ic+i)))) &
         +c1*((b(ia+i)-0.5*(b(ib+i)+b(ic+i)))+(sin60*(a(ib+i)-a(ic+i))))
      c(jc+j)=                                                           &
          c2*((a(ia+i)-0.5*(a(ib+i)+a(ic+i)))+(sin60*(b(ib+i)-b(ic+i)))) &
         -s2*((b(ia+i)-0.5*(b(ib+i)+b(ic+i)))-(sin60*(a(ib+i)-a(ic+i))))
      d(jc+j)=                                                           &
          s2*((a(ia+i)-0.5*(a(ib+i)+a(ic+i)))+(sin60*(b(ib+i)-b(ic+i)))) &
         +c2*((b(ia+i)-0.5*(b(ib+i)+b(ic+i)))-(sin60*(a(ib+i)-a(ic+i))))
      i=i+inc3
      j=j+inc4
   65 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
   70 continue
      jbase=jbase+jump
   80 continue
!     return

!   coding for factor 4

    case (3)
   90 ia=1
      ja=1
      ib=ia+iink
      jb=ja+jink
      ic=ib+iink
      jc=jb+jink
      id=ic+iink
      jd=jc+jink
      do 100 L=1,la
      i=ibase
      j=jbase
!dir$ ivdep
      do 95 ijk=1,lot
      c(ja+j)=(a(ia+i)+a(ic+i))+(a(ib+i)+a(id+i))
      c(jc+j)=(a(ia+i)+a(ic+i))-(a(ib+i)+a(id+i))
      d(ja+j)=(b(ia+i)+b(ic+i))+(b(ib+i)+b(id+i))
      d(jc+j)=(b(ia+i)+b(ic+i))-(b(ib+i)+b(id+i))
      c(jb+j)=(a(ia+i)-a(ic+i))-(b(ib+i)-b(id+i))
      c(jd+j)=(a(ia+i)-a(ic+i))+(b(ib+i)-b(id+i))
      d(jb+j)=(b(ia+i)-b(ic+i))+(a(ib+i)-a(id+i))
      d(jd+j)=(b(ia+i)-b(ic+i))-(a(ib+i)-a(id+i))
      i=i+inc3
      j=j+inc4
   95 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
  100 continue
      if (la.eq.m) return
      la1=la+1
      jbase=jbase+jump
      do 120 k=la1,m,la
      kb=k+k-2
      kc=kb+kb
      kd=kc+kb
      c1=trigs(kb+1)
      s1=trigs(kb+2)
      c2=trigs(kc+1)
      s2=trigs(kc+2)
      c3=trigs(kd+1)
      s3=trigs(kd+2)
      do 110 L=1,la
      i=ibase
      j=jbase
!dir$ ivdep
      do 105 ijk=1,lot
      c(ja+j)=(a(ia+i)+a(ic+i))+(a(ib+i)+a(id+i))
      d(ja+j)=(b(ia+i)+b(ic+i))+(b(ib+i)+b(id+i))
      c(jc+j)=                                     &
          c2*((a(ia+i)+a(ic+i))-(a(ib+i)+a(id+i))) &
         -s2*((b(ia+i)+b(ic+i))-(b(ib+i)+b(id+i)))
      d(jc+j)=                                     &
          s2*((a(ia+i)+a(ic+i))-(a(ib+i)+a(id+i))) &
         +c2*((b(ia+i)+b(ic+i))-(b(ib+i)+b(id+i)))
      c(jb+j)=                                     &
          c1*((a(ia+i)-a(ic+i))-(b(ib+i)-b(id+i))) &
         -s1*((b(ia+i)-b(ic+i))+(a(ib+i)-a(id+i)))
      d(jb+j)=                                     &
          s1*((a(ia+i)-a(ic+i))-(b(ib+i)-b(id+i))) &
         +c1*((b(ia+i)-b(ic+i))+(a(ib+i)-a(id+i)))
      c(jd+j)=                                     &
          c3*((a(ia+i)-a(ic+i))+(b(ib+i)-b(id+i))) &
         -s3*((b(ia+i)-b(ic+i))-(a(ib+i)-a(id+i)))
      d(jd+j)=                                     &
          s3*((a(ia+i)-a(ic+i))+(b(ib+i)-b(id+i))) &
         +c3*((b(ia+i)-b(ic+i))-(a(ib+i)-a(id+i)))
      i=i+inc3
      j=j+inc4
  105 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
  110 continue
      jbase=jbase+jump
  120 continue
!     return

!   coding for factor 5

    case (4)
  130 ia=1
      ja=1
      ib=ia+iink
      jb=ja+jink
      ic=ib+iink
      jc=jb+jink
      id=ic+iink
      jd=jc+jink
      ie=id+iink
      je=jd+jink
      do 140 L=1,la
      i=ibase
      j=jbase
!dir$ ivdep
      do 135 ijk=1,lot
      c(ja+j)=a(ia+i)+(a(ib+i)+a(ie+i))+(a(ic+i)+a(id+i))
      d(ja+j)=b(ia+i)+(b(ib+i)+b(ie+i))+(b(ic+i)+b(id+i))
      c(jb+j)=(a(ia+i)+cos72*(a(ib+i)+a(ie+i))-cos36*(a(ic+i)+a(id+i))) &
        -(sin72*(b(ib+i)-b(ie+i))+sin36*(b(ic+i)-b(id+i)))
      c(je+j)=(a(ia+i)+cos72*(a(ib+i)+a(ie+i))-cos36*(a(ic+i)+a(id+i))) &
        +(sin72*(b(ib+i)-b(ie+i))+sin36*(b(ic+i)-b(id+i)))
      d(jb+j)=(b(ia+i)+cos72*(b(ib+i)+b(ie+i))-cos36*(b(ic+i)+b(id+i))) &
        +(sin72*(a(ib+i)-a(ie+i))+sin36*(a(ic+i)-a(id+i)))
      d(je+j)=(b(ia+i)+cos72*(b(ib+i)+b(ie+i))-cos36*(b(ic+i)+b(id+i))) &
        -(sin72*(a(ib+i)-a(ie+i))+sin36*(a(ic+i)-a(id+i)))
      c(jc+j)=(a(ia+i)-cos36*(a(ib+i)+a(ie+i))+cos72*(a(ic+i)+a(id+i))) &
        -(sin36*(b(ib+i)-b(ie+i))-sin72*(b(ic+i)-b(id+i)))
      c(jd+j)=(a(ia+i)-cos36*(a(ib+i)+a(ie+i))+cos72*(a(ic+i)+a(id+i))) &
        +(sin36*(b(ib+i)-b(ie+i))-sin72*(b(ic+i)-b(id+i)))
      d(jc+j)=(b(ia+i)-cos36*(b(ib+i)+b(ie+i))+cos72*(b(ic+i)+b(id+i))) &
        +(sin36*(a(ib+i)-a(ie+i))-sin72*(a(ic+i)-a(id+i)))
      d(jd+j)=(b(ia+i)-cos36*(b(ib+i)+b(ie+i))+cos72*(b(ic+i)+b(id+i))) &
        -(sin36*(a(ib+i)-a(ie+i))-sin72*(a(ic+i)-a(id+i)))
      i=i+inc3
      j=j+inc4
  135 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
  140 continue
      if (la.eq.m) return
      la1=la+1
      jbase=jbase+jump
      do 160 k=la1,m,la
      kb=k+k-2
      kc=kb+kb
      kd=kc+kb
      ke=kd+kb
      c1=trigs(kb+1)
      s1=trigs(kb+2)
      c2=trigs(kc+1)
      s2=trigs(kc+2)
      c3=trigs(kd+1)
      s3=trigs(kd+2)
      c4=trigs(ke+1)
      s4=trigs(ke+2)
      do 150 L=1,la
      i=ibase
      j=jbase
!dir$ ivdep
      do 145 ijk=1,lot
      c(ja+j)=a(ia+i)+(a(ib+i)+a(ie+i))+(a(ic+i)+a(id+i))
      d(ja+j)=b(ia+i)+(b(ib+i)+b(ie+i))+(b(ic+i)+b(id+i))
      c(jb+j)=                                                          &
          c1*((a(ia+i)+cos72*(a(ib+i)+a(ie+i))-cos36*(a(ic+i)+a(id+i))) &
            -(sin72*(b(ib+i)-b(ie+i))+sin36*(b(ic+i)-b(id+i))))         &
         -s1*((b(ia+i)+cos72*(b(ib+i)+b(ie+i))-cos36*(b(ic+i)+b(id+i))) &
            +(sin72*(a(ib+i)-a(ie+i))+sin36*(a(ic+i)-a(id+i))))
      d(jb+j)=                                                          &
          s1*((a(ia+i)+cos72*(a(ib+i)+a(ie+i))-cos36*(a(ic+i)+a(id+i))) &
            -(sin72*(b(ib+i)-b(ie+i))+sin36*(b(ic+i)-b(id+i))))         &
         +c1*((b(ia+i)+cos72*(b(ib+i)+b(ie+i))-cos36*(b(ic+i)+b(id+i))) &
            +(sin72*(a(ib+i)-a(ie+i))+sin36*(a(ic+i)-a(id+i))))
      c(je+j)=                                                          &
          c4*((a(ia+i)+cos72*(a(ib+i)+a(ie+i))-cos36*(a(ic+i)+a(id+i))) &
            +(sin72*(b(ib+i)-b(ie+i))+sin36*(b(ic+i)-b(id+i))))         &
         -s4*((b(ia+i)+cos72*(b(ib+i)+b(ie+i))-cos36*(b(ic+i)+b(id+i))) &
            -(sin72*(a(ib+i)-a(ie+i))+sin36*(a(ic+i)-a(id+i))))
      d(je+j)=                                                          &
          s4*((a(ia+i)+cos72*(a(ib+i)+a(ie+i))-cos36*(a(ic+i)+a(id+i))) &
            +(sin72*(b(ib+i)-b(ie+i))+sin36*(b(ic+i)-b(id+i))))         &
         +c4*((b(ia+i)+cos72*(b(ib+i)+b(ie+i))-cos36*(b(ic+i)+b(id+i))) &
            -(sin72*(a(ib+i)-a(ie+i))+sin36*(a(ic+i)-a(id+i))))
      c(jc+j)=                                                          &
          c2*((a(ia+i)-cos36*(a(ib+i)+a(ie+i))+cos72*(a(ic+i)+a(id+i))) &
            -(sin36*(b(ib+i)-b(ie+i))-sin72*(b(ic+i)-b(id+i))))         &
         -s2*((b(ia+i)-cos36*(b(ib+i)+b(ie+i))+cos72*(b(ic+i)+b(id+i))) &
            +(sin36*(a(ib+i)-a(ie+i))-sin72*(a(ic+i)-a(id+i))))
      d(jc+j)=                                                          &
          s2*((a(ia+i)-cos36*(a(ib+i)+a(ie+i))+cos72*(a(ic+i)+a(id+i))) &
            -(sin36*(b(ib+i)-b(ie+i))-sin72*(b(ic+i)-b(id+i))))         &
         +c2*((b(ia+i)-cos36*(b(ib+i)+b(ie+i))+cos72*(b(ic+i)+b(id+i))) &
            +(sin36*(a(ib+i)-a(ie+i))-sin72*(a(ic+i)-a(id+i))))
      c(jd+j)=                                                          &
          c3*((a(ia+i)-cos36*(a(ib+i)+a(ie+i))+cos72*(a(ic+i)+a(id+i))) &
            +(sin36*(b(ib+i)-b(ie+i))-sin72*(b(ic+i)-b(id+i))))         &
         -s3*((b(ia+i)-cos36*(b(ib+i)+b(ie+i))+cos72*(b(ic+i)+b(id+i))) &
            -(sin36*(a(ib+i)-a(ie+i))-sin72*(a(ic+i)-a(id+i))))
      d(jd+j)=                                                          &
          s3*((a(ia+i)-cos36*(a(ib+i)+a(ie+i))+cos72*(a(ic+i)+a(id+i))) &
            +(sin36*(b(ib+i)-b(ie+i))-sin72*(b(ic+i)-b(id+i))))         &
         +c3*((b(ia+i)-cos36*(b(ib+i)+b(ie+i))+cos72*(b(ic+i)+b(id+i))) &
            -(sin36*(a(ib+i)-a(ie+i))-sin72*(a(ic+i)-a(id+i))))
      i=i+inc3
      j=j+inc4
  145 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
  150 continue
      jbase=jbase+jump
  160 continue

  end select

    end subroutine vpassm

!##########################################################################

end module fft99_mod

!FDOC_TAG_GFDL

                 module specified_clouds_W_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="">
!   
! </REVIEWER>
! <OVERVIEW>
!   
! </OVERVIEW>
! <DESCRIPTION>
!   
! </DESCRIPTION>
!

use  time_manager_mod,  only:  time_type
use   cloud_zonal_mod,  only:  getcld
use     cloud_obs_mod,  only:  cloud_obs, cloud_obs_init
use           mpp_mod,  only:  input_nml_file
use           fms_mod,  only:  open_namelist_file, file_exist, &
                               check_nml_error, &
                               close_file, &
                               mpp_pe, mpp_root_pe, &
                               write_version_number, stdlog
use rad_utilities_mod,  only:  cldrad_properties_type, &
                               Cldrad_control, &
                               cld_specification_type
use     constants_mod,  only:  pstd_mks

!--------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!             specified clouds radiative properties module;
!             used with cloud_obs_mod and cloud_zonal_mod
!
!--------------------------------------------------------------------



!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------

  character(len=128)  :: version =  '$Id: specified_clouds_W.F90,v 19.0 2012/01/06 20:24:09 fms Exp $'
  character(len=128)  :: tagname =  '$Name: tikal $'



!---------------------------------------------------------------------
!-------  interfaces --------

public          &
          specified_clouds_W_init, specified_clouds_amt, &
          specified_clouds_W_end

!---------------------------------------------------------------------
!-------- namelist  ---------


integer    :: dummy=0           



namelist /specified_clouds_W_nml /     &
                                         dummy   


!----------------------------------------------------------------------
!----  public data -------


!----------------------------------------------------------------------
!----  private data -------

integer, parameter  :: NOFCLDS_SP=3  ! total number of clouds per column
integer, parameter  :: NOFMXOLW=1    ! number of max overlap clouds
integer, parameter  :: NOFRNDLW=2    ! number of random overlap clouds
 

!--------------------------------------------------------------------
!   crfvis   :  visible band reflectivity
!--------------------------------------------------------------------
real  :: crfvis_hi  = 0.21
real  :: crfvis_mid = 0.45
real  :: crfvis_low = 0.59

!--------------------------------------------------------------------
!   crfir    :  near-ir band reflectivity
!--------------------------------------------------------------------
real  :: crfir_hi   = 0.21
real  :: crfir_mid  = 0.45
real  :: crfir_low  = 0.59

!--------------------------------------------------------------------
!   cldem    :  infrared emissivity
!--------------------------------------------------------------------
real  :: cldem_hi   = 1.00
real  :: cldem_mid  = 1.00
real  :: cldem_low  = 1.00

!--------------------------------------------------------------------
!   cabir    :  near-ir band absorptivity
!--------------------------------------------------------------------
real  :: cabir_hi   = 0.005
real  :: cabir_mid  = 0.02
real  :: cabir_low  = 0.035


logical  :: module_is_initialized = .false.

!------------------------------------------------------------------
!------------------------------------------------------------------



contains 





! <SUBROUTINE NAME="specified_clouds_W_init">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call specified_clouds_W_init (lonb, latb)
!
!  </TEMPLATE>
!  <IN NAME="lonb" TYPE="real">
! 
!  </IN>
!  <IN NAME="latb" TYPE="real">
! 
!  </IN>
! </SUBROUTINE>
!
subroutine specified_clouds_W_init (lonb, latb)


real, dimension(:,:), intent(in) :: lonb, latb


      integer          :: unit, ierr, io, logunit

!---------------------------------------------------------------------
!-----  read namelist  ------
  
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=specified_clouds_W_nml, iostat=io)
      ierr = check_nml_error(io,'specified_clouds_W_nml')
#else   
      if (file_exist('input.nml')) then
        unit =  open_namelist_file ()
        ierr=1; do while (ierr /= 0)
        read (unit, nml=specified_clouds_W_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'specified_clouds_W_nml')
        enddo
10      call close_file (unit)
      endif
#endif

!------- write version number and namelist ---------

      if ( mpp_pe() == mpp_root_pe() ) then
        call write_version_number(version, tagname)
        logunit = stdlog()
        write (logunit,nml=specified_clouds_W_nml)
      endif

!---------------------------------------------------------------------
!    if observed clouds is active, initialize that module.
!---------------------------------------------------------------------
      if (Cldrad_control%do_obs_clouds) then
        call cloud_obs_init (lonb, latb)
      endif
 
      module_is_initialized = .true.

end subroutine specified_clouds_W_init

! <SUBROUTINE NAME="specified_clouds_W_end">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call specified_clouds_W_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine specified_clouds_W_end
        
!----------------------------------------------------------------------
!    specified_clouds_W_end is the destructor for specified_clouds_W_mod.
!----------------------------------------------------------------------
        
!---------------------------------------------------------------------
!    mark the module as not initialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.

!--------------------------------------------------------------------
 

end subroutine specified_clouds_W_end


!######################################################################

! <SUBROUTINE NAME="specified_clouds_amt">
!  <OVERVIEW>
!    specified_clouds_amt defines the location, amount (cloud fraction),
!    number and type (hi, mid, low) of clouds present on the model grid.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    specified_clouds_amt defines the location, amount (cloud fraction),
!    number and type (hi, mid, low) of clouds present on the model grid.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call specified_clouds_amt (is, ie, js, je, Rad_time, lat, pflux, &
!                Cld_spec)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <IN NAME="Rad_time" TYPE="time_type">
!      Rad_time     time at which the climatologically-determined,
!                   time-varying specified cloud fields should apply
!                   [ time_type, days and seconds]
! 
!  </IN>
!  <IN NAME="lat" TYPE="real">
!      lat          latitude of model points  [ radians ]
! 
!  </IN>
!  <IN NAME="pflux" TYPE="real">
!      pflux        average of pressure at adjacent model levels
!                   [ (kg /( m s^2) ]
! 
!  </IN>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
!      Cld_spec     cld_specification_type variable containing the
!                   cloud specification input fields needed by the
!                   radiation package
!
!               the following elements of Cld_spec are defined here:
!
!                  %cmxolw  fraction of maximally overlapped clouds
!                           seen by the longwave radiation
!                           [ dimensionless ]
!                  %crndlw  fraction of randomly overlapped clouds
!                           seen by the longwave radiation
!                           [ dimensionless ]
!                  %camtsw  cloud fraction seen by the shortwave
!                           radiation; the sum of the maximally
!                           overlapped and randomly overlapped
!                           longwave cloud fractions  [ dimensionless ]
!                  %nmxolw  number of maximally overlapped longwave
!                           clouds in each grid column.
!                  %nrndlw  number of randomly overlapped longwave
!                           clouds in each grid column.
!                  %ncldsw  number of clouds seen by he shortwave
!                           radiation in each grid column.
!                  %hi_cld  logical flag indicating the presence of
!                           high clouds in a grid box
!                 %mid_cld  logical flag indicating the presence of
!                           middle clouds in a grid box
!                 %low_cld  logical flag indicating the presence of
!                           low clouds in a grid box
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine specified_clouds_amt (is, ie, js, je, Rad_time, lat, pflux, &
                                 Cld_spec)

!----------------------------------------------------------------------
!    specified_clouds_amt defines the location, amount (cloud fraction),
!    number and type (hi, mid, low) of clouds present on the model grid.
!----------------------------------------------------------------------
 
!--------------------------------------------------------------------
integer,                      intent(in)    :: is, ie, js, je
type(time_type),              intent(in)    :: Rad_time
real, dimension(:,:),         intent(in)    :: lat
real, dimension(:,:,:),       intent(in)    :: pflux
type(cld_specification_type), intent(inout) :: Cld_spec
!-------------------------------------------------------------------

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      Rad_time     time at which the climatologically-determined, 
!                   time-varying specified cloud fields should apply
!                   [ time_type, days and seconds]
!      lat          latitude of model points  [ radians ]
!      pflux        average of pressure at adjacent model levels
!                   [ (kg /( m s^2) ] 
!
!   intent(inout) variables:
!
!      Cld_spec     cld_specification_type variable containing the 
!                   cloud specification input fields needed by the 
!                   radiation package
!
!               the following elements of Cld_spec are defined here:
!
!                  %cmxolw  fraction of maximally overlapped clouds
!                           seen by the longwave radiation 
!                           [ dimensionless ]
!                  %crndlw  fraction of randomly overlapped clouds
!                           seen by the longwave radiation 
!                           [ dimensionless ]
!                  %camtsw  cloud fraction seen by the shortwave
!                           radiation; the sum of the maximally
!                           overlapped and randomly overlapped 
!                           longwave cloud fractions  [ dimensionless ]
!                  %nmxolw  number of maximally overlapped longwave 
!                           clouds in each grid column.
!                  %nrndlw  number of randomly overlapped longwave 
!                           clouds in each grid column.
!                  %ncldsw  number of clouds seen by he shortwave
!                           radiation in each grid column.
!                  %hi_cld  logical flag indicating the presence of
!                           high clouds in a grid box
!                 %mid_cld  logical flag indicating the presence of 
!                           middle clouds in a grid box
!                 %low_cld  logical flag indicating the presence of 
!                           low clouds in a grid box
!                                                                  
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      real, dimension    (size (Cld_spec%camtsw,1),                 &
                          size (Cld_spec%camtsw,2),                 &
                          NOFCLDS_SP       ) ::      camtsw3
      integer, dimension (size (Cld_spec%camtsw,1),                 &
                          size (Cld_spec%camtsw,2),                 &
                          NOFCLDS_SP       ) ::      ktopsw3, kbtmsw3
      real, dimension    (size (Cld_spec%camtsw,1),                 &
                          size (Cld_spec%camtsw,2),                 &
                          size (Cld_spec%camtsw,3)+1)  ::   phaf      

      integer  ::     k, j, i
      integer  ::     kerad

!---------------------------------------------------------------------
!    local variables:
!
!
!         camtsw3   cloud fraction in cloud space for the specified 
!                   cloud types;  currently, k = 1 is for hi cloud,
!                   k = 2 is for mid cloud, k = 3 is for low cloud
!         ktopsw3   model k index of cloud top for the specified cloud 
!                   types (hi, mid, low)
!         kbtmsw3   model k index of the cloud base for the specified 
!                   cloud types (hi, mid, low)
!            phaf   pressure at model interface levels adjusted so that
!                   a sigma value based on the mean sea level pressure 
!                   is the same as the sigma value based on actual 
!                   surface pressure
!         i, j, k   do loop indices
!           kerad   number of model layers
!
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!    define the number of model layers.
!---------------------------------------------------------------------
      kerad = size (Cld_spec%camtsw,3)

!-----------------------------------------------------------------------
!    define the number of random and maximally overlapped clouds and the
!    total number of clouds in a column. these numbers are prescribed.
!-----------------------------------------------------------------------
      Cld_spec%nmxolw(:,:) = NOFMXOLW
      Cld_spec%nrndlw(:,:) = NOFRNDLW
      Cld_spec%ncldsw(:,:) = NOFCLDS_SP 

!---------------------------------------------------------------------
!    define the interface pressure that produces the same value of
!    sigma based on the mean sea level pressure as is obtained using
!    the actual interface pressures and surface pressure.
!---------------------------------------------------------------------
      do k=1, kerad+1        
        phaf(:,:,k) = pflux(:,:,k)*pstd_mks/pflux(:,:,kerad+1)
      end do

!------------------------------------------------------------------
!    call getcld to obtain the cloud fractions, tops and bases for
!    the specified clouds. these are returned in cloud-space.
!------------------------------------------------------------------
      call getcld (Rad_time, lat, phaf, ktopsw3, kbtmsw3, camtsw3 )
      if (Cldrad_control%do_obs_clouds) then
        call cloud_obs (is, js, Rad_time, camtsw3)
      endif


!---------------------------------------------------------------------
!    map the cloud-space arrays obtained above to model space arrays. 
!    define the logical arrays which denote the grid boxes containing
!    the various cloud types (hi, middle, low).
!-------------------------------------------------------------------
      do j=1, size(Cld_spec%hi_cloud,2)
        do i=1,size(Cld_spec%hi_cloud,1)

!--------------------------------------------------------------------
!    high clouds
!--------------------------------------------------------------------
          do k=ktopsw3(i,j,1), kbtmsw3(i,j,1)-1
            Cld_spec%camtsw(i,j,k) = camtsw3(i,j,1)
            Cld_spec%hi_cloud(i,j,k) = .true.
            Cld_spec%crndlw(i,j,k) = camtsw3(i,j,1)
          end do

!--------------------------------------------------------------------
!    middle clouds
!--------------------------------------------------------------------
          do k=ktopsw3(i,j,2), kbtmsw3(i,j,2)-1
            Cld_spec%camtsw(i,j,k) = camtsw3(i,j,2)
            Cld_spec%mid_cloud(i,j,k) = .true.
            Cld_spec%crndlw(i,j,k) = camtsw3(i,j,2)
          end do

!--------------------------------------------------------------------
!    low clouds
!--------------------------------------------------------------------
          do k=ktopsw3(i,j,3), kbtmsw3(i,j,3)-1
            Cld_spec%camtsw(i,j,k) = camtsw3(i,j,3)
            Cld_spec%low_cloud(i,j,k) = .true.
            Cld_spec%cmxolw(i,j,k) = camtsw3(i,j,3)
          end do
        end do
      end do

!---------------------------------------------------------------------


end subroutine specified_clouds_amt 


!####################################################################

! <SUBROUTINE NAME="obtain_bulk_lw_specified">
!  <OVERVIEW>
!    obtain_bulk_lw_specified defines bulk longwave cloud radiative
!    properties for the specified cloud scheme.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    obtain_bulk_lw_specified defines bulk longwave cloud radiative
!    properties for the specified cloud scheme.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call obtain_bulk_lw_specified (is, ie, js, je, Cld_spec,   &
!                Cldrad_props)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
!      Cld_spec          cloud specification arrays defining the
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input
!                        to this subroutine
!                        [ cld_specification_type ]
! 
!  </INOUT>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output
!               from this routine:
!
!                    %emrndlw   longwave cloud emissivity for
!                               randomly overlapped clouds
!                               in each of the longwave
!                               frequency bands  [ dimensionless ]
!                    %emmxolw   longwave cloud emissivity for
!                               maximally overlapped clouds
!                               in each of the longwave
!                               frequency bands  [ dimensionless ]
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine obtain_bulk_lw_specified (is, ie, js, je, Cld_spec,   &
                                     Cldrad_props)

!---------------------------------------------------------------------
!    obtain_bulk_lw_specified defines bulk longwave cloud radiative 
!    properties for the specified cloud scheme.
!---------------------------------------------------------------------

integer,                      intent(in)    :: is, ie, js, je
type(cld_specification_type), intent(inout) :: Cld_spec
type(cldrad_properties_type), intent(inout) :: Cldrad_props

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!
!   intent(inout) variables:
!
!      Cld_spec          cloud specification arrays defining the 
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input 
!                        to this subroutine
!                        [ cld_specification_type ]
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output 
!               from this routine:
!
!                    %emrndlw   longwave cloud emissivity for 
!                               randomly overlapped clouds
!                               in each of the longwave 
!                               frequency bands  [ dimensionless ]
!                    %emmxolw   longwave cloud emissivity for 
!                               maximally overlapped clouds
!                               in each of the longwave 
!                               frequency bands  [ dimensionless ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      integer     ::  i,j,k    ! do loop indices

!---------------------------------------------------------------------
!    assign the proper values for cloud emissivity to each grid box
!    with cloudiness, dependent on whether the cloud in that box is 
!    defined as being high, middle or low cloud. high and middle clouds
!    are assumed to be random overlap, low clouds are assume to be
!    maximum overlap.
!----------------------------------------------------------------------
      do k=1, size(Cld_spec%hi_cloud,3)              
        do j=1,size(Cld_spec%hi_cloud,2)
          do i=1,size(Cld_spec%hi_cloud,1)
            if (Cld_spec%hi_cloud(i,j,k)) then
              Cldrad_props%emrndlw(i,j,k,:,1)  = cldem_hi
            else if (Cld_spec%mid_cloud(i,j,k)) then
              Cldrad_props%emrndlw(i,j,k,:,1)  = cldem_mid
            else if (Cld_spec%low_cloud(i,j,k)) then
              Cldrad_props%emmxolw(i,j,k,:,1)  = cldem_low
            endif
          enddo
        end do
      end do

!---------------------------------------------------------------------



end subroutine obtain_bulk_lw_specified



!####################################################################

! <SUBROUTINE NAME="obtain_bulk_sw_specified">
!  <OVERVIEW>
!    obtain_bulk_sw_specified defines bulk shortwave cloud radiative
!    properties for the specified cloud scheme.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    obtain_bulk_sw_specified defines bulk shortwave cloud radiative
!    properties for the specified cloud scheme.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call obtain_bulk_sw_specified (is, ie, js, je, Cld_spec, &
!                Cldrad_props)                     
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
!      Cld_spec          cloud specification arrays defining the
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input
!                        to this subroutine
!                        [ cld_specification_type ]
! 
!  </INOUT>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output
!               from this routine:
!
!                    %cirabsw   absorptivity of clouds in the
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cirrfsw   reflectivity of clouds in the
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cvisrfsw  reflectivity of clouds in the
!                               visible frequency band
!                               [ dimensionless ]
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine obtain_bulk_sw_specified (is, ie, js, je, Cld_spec, &
                                 Cldrad_props)                     

!---------------------------------------------------------------------
!    obtain_bulk_sw_specified defines bulk shortwave cloud radiative 
!    properties for the specified cloud scheme.
!---------------------------------------------------------------------

integer,                      intent(in)    :: is, ie, js, je
type(cld_specification_type), intent(inout) :: Cld_spec
type(cldrad_properties_type), intent(inout) :: Cldrad_props
!-------------------------------------------------------------------

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!
!   intent(inout) variables:
!
!      Cld_spec          cloud specification arrays defining the 
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input 
!                        to this subroutine
!                        [ cld_specification_type ]
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output 
!               from this routine:
!
!                    %cirabsw   absorptivity of clouds in the 
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cirrfsw   reflectivity of clouds in the 
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cvisrfsw  reflectivity of clouds in the 
!                               visible frequency band
!                               [ dimensionless ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      integer     ::  i,j,k    ! do loop indices

!---------------------------------------------------------------------
!    assign the proper values for cloud absorptivity and reflectivity
!    to each grid box with cloudiness, dependent on whether the cloud 
!    in that box is defined as being high, middle or low cloud. 
!----------------------------------------------------------------------
      do k=1, size(Cld_spec%hi_cloud,3)              
        do j=1,size(Cld_spec%hi_cloud,2)
          do i=1,size(Cld_spec%hi_cloud,1)
            if (Cld_spec%hi_cloud(i,j,k)) then
              Cldrad_props%cirabsw(i,j,k)  = cabir_hi 
              Cldrad_props%cirrfsw(i,j,k)  = crfir_hi
              Cldrad_props%cvisrfsw(i,j,k) = crfvis_hi
            else if (Cld_spec%mid_cloud(i,j,k)) then
              Cldrad_props%cirabsw(i,j,k)  = cabir_mid
              Cldrad_props%cirrfsw(i,j,k)  = crfir_mid
              Cldrad_props%cvisrfsw(i,j,k) = crfvis_mid
            else if (Cld_spec%low_cloud(i,j,k)) then
              Cldrad_props%cirabsw(i,j,k)  = cabir_low
              Cldrad_props%cirrfsw(i,j,k)  = crfir_low
              Cldrad_props%cvisrfsw(i,j,k) = crfvis_low
            endif
          end do
        end do
      end do

!---------------------------------------------------------------------



end subroutine obtain_bulk_sw_specified 




!######################################################################



                 end module specified_clouds_W_mod

module FMS_ocmip2_co2calc_mod  !{
!
!This module is ported almost verbatim from GOLD_ocmip2_co2calc.F90
!It is called FMS_ocmip2_co2calc_mod to avoid name collision with GOLD_ocmip2_co2calc.F90 
! and ocmip2_co2calc.F90 of MOM
!
!Modifications:
!1. mask check should surround all the calculations since MOM restart masks htotal on land 
!   and htotal cannot be zero in this calculation (division by htotal) 
!2. if (mask(i,j) .eq. 0.0) --> if (mask(i,j) .gt. 0.0) for floating point comparison efficiency
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> John P. Dunne
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Niki T. Zadeh
!</REVIEWER>
!
!<OVERVIEW>
! Surface fCO2 calculation
!</OVERVIEW>
!
!<DESCRIPTION>
! Calculate the fugacity of CO2 at the surface in thermodynamic
! equilibrium with the current alkalinity (Alk) and total dissolved
! inorganic carbon (DIC) at a particular temperature and salinity
! using an initial guess for the total hydrogen
! ion concentration (htotal)
!</DESCRIPTION>
!

!
!------------------------------------------------------------------
!
!       Global definitions
!
!------------------------------------------------------------------
!

use mpp_mod, only: mpp_error, WARNING

implicit none

private

public  :: FMS_ocmip2_co2calc,  FMS_ocmip2_co2calc_old, CO2_dope_vector
public  :: FMS_ocmip2_co2_alpha

character(len=128) :: version = '$Id: FMS_ocmip2_co2calc.F90,v 20.0 2013/12/14 00:18:00 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

type CO2_dope_vector
  integer  :: isc, iec, jsc, jec
  integer  :: isd, ied, jsd, jed
end type CO2_dope_vector
!
!-----------------------------------------------------------------------
!
!       Subroutine and function definitions
!
!-----------------------------------------------------------------------
!

contains

!#######################################################################
! <SUBROUTINE NAME="FMS_ocmip2_co2calc">
!
! <DESCRIPTION>
!       Calculate co2* from total alkalinity and total CO2 at
! temperature (t) and salinity (s).
! It is assumed that init_ocmip2_co2calc has already been called with
! the T and S to calculate the various coefficients.
!
! INPUT
!
!       dope_vec   = an array of indices corresponding to the compute 
!                    and data domain boundaries.
!
!       mask       = land mask array (0.0 = land)
!
!       dic_in     = total inorganic carbon (mol/kg) 
!                    where 1 T = 1 metric ton = 1000 kg
!
!       ta_in      = total alkalinity (eq/kg) 
!
!       pt_in      = inorganic phosphate (mol/kg) 
!
!       sit_in     = inorganic silicate (mol/kg) 
!
!       htotallo   = lower limit of htotal range
!
!       htotalhi   = upper limit of htotal range
!
!       htotal     = H+ concentration (mol/kg)
!
! OUTPUT
!       co2star    = CO2*water, or H2CO3 concentration (mol/kg)
!       alpha      = Solubility of CO2 for air (mol/kg/atm)
!       pco2surf   = oceanic pCO2 (ppmv)
!       co3_ion    = Carbonate ion, or CO3-- concentration (mol/kg)
!
! FILES and PROGRAMS NEEDED: drtsafe, ta_iter_1
!
! IMPORTANT: co2star and alpha need to be multiplied by rho before being
! passed to the atmosphere.
!
! </DESCRIPTION>

subroutine FMS_ocmip2_co2calc(dope_vec, mask,                      &
                          t_in, s_in, dic_in, pt_in, sit_in, ta_in, htotallo, &
                          htotalhi, htotal, co2star, alpha, pCO2surf, co3_ion)  !{

implicit none

!
!       local parameters
!

real, parameter :: permeg = 1.e-6
real, parameter :: xacc = 1.0e-10

!
!       arguments
!
type(CO2_dope_vector), intent(in)           :: dope_vec
real, dimension(dope_vec%isd:dope_vec%ied,dope_vec%jsd:dope_vec%jed), &
      intent(in)::             mask, &
                               t_in, &
                               s_in, &
                               dic_in, &
                               pt_in, &
                               sit_in, &
                               ta_in, &
                               htotallo, &
                               htotalhi
real, dimension(dope_vec%isd:dope_vec%ied,dope_vec%jsd:dope_vec%jed), &
      intent(inout)         :: htotal
real, dimension(dope_vec%isd:dope_vec%ied,dope_vec%jsd:dope_vec%jed), &
      intent(out), optional :: alpha, &
                               pCO2surf, &
                               co2star, &
                               co3_ion
!
!       local variables
!
integer :: isc, iec, jsc, jec
integer :: i,j
real :: alpha_internal
real :: bt
real :: co2star_internal
real :: dlogtk
real :: ft
real :: htotal2
real :: invtk
real :: is
real :: is2
real :: k1
real :: k2
real :: k1p
real :: k2p
real :: k3p
real :: kb
real :: kf
real :: ks
real :: ksi
real :: kw
real :: log100
real :: s2
real :: scl
real :: sqrtis
real :: sqrts
real :: st
real :: tk
real :: tk100
real :: tk1002
real :: logf_of_s

! Set the loop indices.
  isc = dope_vec%isc ; iec = dope_vec%iec
  jsc = dope_vec%jsc ; jec = dope_vec%jec

!
!       Initialize the module
!
  log100 = log(100.0)

  do j = jsc, jec  !{
    do i = isc, iec  !{
      if (mask(i,j) .gt. 0.0) then  !{
!
!---------------------------------------------------------------------
!
!***********************************************************************
! Calculate all constants needed to convert between various measured
! carbon species. References for each equation are noted in the code.
! Once calculated, the constants are stored and passed in the common
! block "const". The original version of this code was based on
! the code by Dickson in Version 2 of "Handbook of Methods for the
! Analysis of the Various Parameters of the Carbon Dioxide System
! in Seawater", DOE, 1994 (SOP No. 3, p25-26).
        tk        = 273.15 + t_in(i,j)
        tk100     = tk / 100.0
        tk1002     = tk100**2
        invtk     = 1.0 / tk
        dlogtk    = log(tk)
        is        = 19.924 * s_in(i,j) /(1000.0 -1.005 * s_in(i,j))
        is2       = is * is
        sqrtis    = sqrt(max(0.0,is))
        s2        = s_in(i,j) * s_in(i,j)
        sqrts     = sqrt(max(0.0,s_in(i,j)))
        scl       = s_in(i,j) / 1.80655
        logf_of_s = log(1.0 - 0.001005 * s_in(i,j))
!
! k0 from Weiss 1974
!
!
!        k0 = exp(93.4517/tk100 - 60.2409 + 23.3585 * log(tk100) +       &
!                 s_in(i,j) * (0.023517 - 0.023656 * tk100 +             &
!                 0.0047036 * tk1002))
!
! k1 = [H][HCO3]/[H2CO3]
! k2 = [H][CO3]/[HCO3]
!
! Millero p.664 (1995) using Mehrbach et al. data on seawater scale 
!

        k1 = 10.0**(-(3670.7 * invtk - 62.008 + 9.7944 * dlogtk -       &
                             0.0118 * s_in(i,j) + 0.000116 * s2))
        k2 = 10.0**(-(1394.7 * invtk + 4.777 -                          &
                             0.0184 * s_in(i,j) + 0.000118 * s2))
!
! kb = [H][BO2]/[HBO2]
!
! Millero p.669 (1995) using data from Dickson (1990)
!

        kb = exp((-8966.90 - 2890.53 * sqrts - 77.942 * s_in(i,j) +     &
                 1.728 * sqrts**3 - 0.0996 * s2) * invtk + (148.0248 +  &
                 137.1942 * sqrts + 1.62142 * s_in(i,j)) + (-24.4344 -  &
                 25.085 * sqrts - 0.2474 * s_in(i,j)) * dlogtk +        &
                 0.053105 * sqrts * tk)
!
! k1p = [H][H2PO4]/[H3PO4]
!
! DOE(1994) eq 7.2.20 with footnote using data from Millero (1974)
!

        k1p = exp(-4576.752 * invtk + 115.525 - 18.453 * dlogtk +       &
                  (-106.736 * invtk + 0.69171) * sqrts + (-0.65643 *    &
                  invtk - 0.01844) * s_in(i,j))
!
! k2p = [H][HPO4]/[H2PO4]
!
! DOE(1994) eq 7.2.23 with footnote using data from Millero (1974))
!

        k2p = exp(-8814.715 * invtk + 172.0883 - 27.927 * (-160.340 *   &
                  invtk + 1.3566) * sqrts + (0.37335 * invtk -          &
                  0.05778) * s_in(i,j))
!
!-----------------------------------------------------------------------
! k3p = [H][PO4]/[HPO4]
!
! DOE(1994) eq 7.2.26 with footnote using data from Millero (1974)
!

        k3p = exp(-3070.75 * invtk - 18.141 +(17.27039 * invtk +        &
                  2.81197) * sqrts + (-44.99486 * invtk - 0.09984) *    &
                  s_in(i,j))
!
!-----------------------------------------------------------------------
! ksi = [H][SiO(OH)3]/[Si(OH)4]
!
! Millero p.671 (1995) using data from Yao and Millero (1995)
!
        ksi = exp(-8904.2 * invtk + 117.385 - 19.334 * dlogtk +         &
                  (-458.79 * invtk + 3.5913) * sqrtis + (188.74 *       &
                  invtk - 1.5998) * is + (-12.1652 * invtk + 0.07871) * &
                  is2 + logf_of_s)
!
!-----------------------------------------------------------------------
! kw = [H][OH]
!
! Millero p.670 (1995) using composite data
!

        kw = exp(-13847.26 * invtk + 148.9652 - 23.6521 *  dlogtk +     &
                 (118.67 * invtk - 5.977 + 1.0495 * dlogtk) * sqrts -   &
                 0.01615 * s_in(i,j))
!
!-----------------------------------------------------------------------
! ks = [H][SO4]/[HSO4]
!
! Dickson (1990, J. chem. Thermodynamics 22, 113)
!
        ks = exp(-4276.1 * invtk + 141.328 - 23.093 * dlogtk +          &
                 (-13856.0 * invtk + 324.57 - 47.986 * dlogtk) *        &
                 sqrtis + (35474.0 * invtk - 771.54 + 114.723 *         &
                 dlogtk) * is - 2698.0 * invtk * sqrtis**3 +            &
                 1776.0 * invtk * is2 + logf_of_s)
!
!-----------------------------------------------------------------------
! kf = [H][F]/[HF]
!
! Dickson and Riley (1979) -- change pH scale to total
!
        kf = exp(1590.2 * invtk - 12.641 + 1.525 * sqrtis + logf_of_s + &
                 log(1.0 + (0.1400 / 96.062) * scl / ks))
!
!-----------------------------------------------------------------------
! Calculate concentrations for borate, sulfate, and fluoride
!
! Uppstrom (1974)
!
        bt = 0.000232 / 10.811 * scl
!
! Morris & Riley (1966)
!
        st = 0.14 / 96.062 * scl
!
! Riley (1965)
!
        ft = 0.000067 / 18.9984 * scl
!
!***********************************************************************
!
! Calculate [H+] total when DIC and TA are known at T, S and 1 atm.
! The solution converges to err of xacc. The solution must be within
! the range x1 to x2.
!
! If DIC and TA are known then either a root finding or iterative method
! must be used to calculate htotal. In this case we use the
! Newton-Raphson "safe" method taken from "Numerical Recipes"
! (function "rtsafe.f" with error trapping removed).
!
! As currently set, this procedure iterates about 12 times. The x1
! and x2 values set below will accomodate ANY oceanographic values.
! If an initial guess of the pH is known, then the number of
! iterations can be reduced to about 5 by narrowing the gap between
! x1 and x2. It is recommended that the first few time steps be run
! with x1 and x2 set as below. After that, set x1 and x2 to the
! previous value of the pH +/- ~0.5. The current setting of xacc will
! result in co2star accurate to 3 significant figures (xx.y). Making
! xacc bigger will result in faster convergence also, but this is not
! recommended (xacc of 10**-9 drops precision to 2 significant
! figures).
!

        htotal(i,j) = drtsafe(  k1, k2, kb, k1p, k2p, k3p, ksi, kw,   &
                                ks, kf, bt, dic_in(i,j), ft, pt_in(i,j),&
                                sit_in(i,j), st, ta_in(i,j),            &
                                htotalhi(i,j), htotallo(i,j),htotal(i,j), xacc)
!
! Calculate [CO2*] as defined in DOE Methods Handbook 1994 Ver.2, 
! ORNL/CDIAC-74, Dickson and Goyet, eds. (Ch 2 p 10, Eq A.49)
!
        htotal2 = htotal(i,j) * htotal(i,j)
        co2star_internal = dic_in(i,j) * htotal2 / (htotal2 +           &
                         k1 * htotal(i,j) + k1 * k2)
        if (present(co2star)) co2star(i,j) = co2star_internal
        if (present(co3_ion)) co3_ion(i,j) = co2star_internal * k1 * k2 / htotal2
!
! Weiss & Price (1980, Mar. Chem., 8, 347-359; Eq 13 with table 6
!                values)
!
        if (present(alpha) .or. present(pCO2surf)) then
          alpha_internal = exp(-162.8301 + 218.2968 / tk100 + 90.9241 *     &
                         (dlogtk -log100) - 1.47696 * tk1002 +          &
                         s_in(i,j) * (0.025695 - 0.025225 * tk100 +   &
                         0.0049867 * tk1002))
        endif
        if (present(alpha)) alpha(i,j) = alpha_internal
        if (present(pCO2surf)) then
          pCO2surf(i,j) = co2star_internal / (alpha_internal * permeg)
        endif

    else  !}{mask(i,j)=0.0

      if (present(co3_ion)) then
        co3_ion(i,j) = 0.0
      endif
      if (present(co2star)) then
        co2star(i,j) = 0.0
      endif
      if (present(alpha)) then  !{
        alpha(i,j) = 0.0
      endif  !}
      if (present(pco2surf)) then  !{
        pCO2surf(i,j) = 0.0
      endif  !}

    endif  !}mask

    enddo  !} i
  enddo  !} j

return

end subroutine  FMS_ocmip2_co2calc  !}
! </SUBROUTINE> NAME="FMS_ocmip2_co2calc"

!#######################################################################
! <FUNCTION NAME="drtsafe">
!
! <DESCRIPTION>
!       File taken from Numerical Recipes. Modified  R. M. Key 4/94
! </DESCRIPTION>

function drtsafe(k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf, &
               bt, dic, ft, pt, sit, st, ta, x1_in, x2_in, x, xacc)  !{

implicit none

!
!       arguments
!

real    :: k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf
real    :: bt, dic, ft, pt, sit, st, ta
real    :: drtsafe
real    :: x1_in, x2_in, x, xacc

!
!       local parameters
!

integer, parameter      :: maxit = 100

!
!       local variables
!

integer :: j
real    :: fl, df, fh, swap, xl, xh, dxold, dx, f, temp
real    :: x1
real    :: x2
logical :: bracketed

drtsafe=x
call ta_iter_1(k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf, &
               bt, dic, ft, pt, sit, st, ta, drtsafe, f, df)
dx=f/df
if (abs(dx) .lt. xacc) then
!     write (6,*) 'Exiting drtsafe at C on iteration  ', j, ', ph = ', -log10(drtsafe)
  return
endif

bracketed = .false.
x1 = x
x2 = x

do j = 1, 10

  x1 = x1 * 0.1
  x2 = x2 * 10.0
  call ta_iter_1(k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf, &
                 bt, dic, ft, pt, sit, st, ta, x1, fl, temp)
  call ta_iter_1(k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf, &
                 bt, dic, ft, pt, sit, st, ta, x2, fh, temp)
  if (fl*fh .lt. 0.0) then
    bracketed = .true.
    exit
  endif

enddo

if (.not. bracketed) then
  call mpp_error(WARNING, 'drtsafe: root not bracketed')
endif

if(fl .lt. 0.0) then
  xl=x1
  xh=x2
else
  xh=x1
  xl=x2
  swap=fl
  fl=fh
  fh=swap
end if
drtsafe=0.5*(x1+x2)
dxold=abs(x2-x1)
dx=dxold
call ta_iter_1(k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf, &
               bt, dic, ft, pt, sit, st, ta, drtsafe, f, df)
do j=1,maxit  !{
  if (((drtsafe-xh)*df-f)*((drtsafe-xl)*df-f) .ge. 0.0 .or.     &
      abs(2.0*f) .gt. abs(dxold*df)) then
    dxold=dx
    dx=0.5*(xh-xl)
    drtsafe=xl+dx
    if (xl .eq. drtsafe) then
!     write (6,*) 'Exiting drtsafe at A on iteration  ', j, ', ph = ', -log10(drtsafe)
      return
    endif
  else
    dxold=dx
    dx=f/df
    temp=drtsafe
    drtsafe=drtsafe-dx
    if (temp .eq. drtsafe) then
!     write (6,*) 'Exiting drtsafe at B on iteration  ', j, ', ph = ', -log10(drtsafe)
      return
    endif
  end if
  if (abs(dx) .lt. xacc) then
!     write (6,*) 'Exiting drtsafe at C on iteration  ', j, ', ph = ', -log10(drtsafe)
    return
  endif
  call ta_iter_1(k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf, &
                 bt, dic, ft, pt, sit, st, ta, drtsafe, f, df)
  if(f .lt. 0.0) then
    xl=drtsafe
    fl=f
  else
    xh=drtsafe
    fh=f
  end if
enddo  !} j

! should have an error condition here for not converging?

return

end  function  drtsafe  !}
! </FUNCTION> NAME="drtsafe"

!#######################################################################
! <SUBROUTINE NAME="ta_iter_1">
!
! <DESCRIPTION>
! This routine expresses TA as a function of DIC, htotal and constants.
! It also calculates the derivative of this function with respect to 
! htotal. It is used in the iterative solution for htotal. In the call
! "x" is the input value for htotal, "fn" is the calculated value for TA
! and "df" is the value for dTA/dhtotal
! </DESCRIPTION>

subroutine ta_iter_1(k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf, &
                     bt, dic, ft, pt, sit, st, ta, x, fn, df)  !{

implicit none

!
!       arguments
!

real    :: k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf
real    :: bt, dic, ft, pt, sit, st, ta, x, fn, df

!
!       local variables
!

real    :: x2, x3, k12, k12p, k123p, c, a, am1, am2, da, b, bm1, bm2, db
real    :: xpkbm1,xpkfm1,xpksim1,xpkscm1

x2 = x*x
x3 = x2*x
k12 = k1*k2
k12p = k1p*k2p
k123p = k12p*k3p
c = 1.0/(1.0 + st/ks)

a = x3 + k1p*x2 + k12p*x + k123p
am1 = 1.0/a
am2 = am1*am1
da = 3.0*x2 + 2.0*k1p*x + k12p

b = x2 + k1*x + k12
bm1 = 1.0/b
bm2 = bm1*bm1
db = 2.0*x + k1

xpkbm1  = 1.0/(x+kb)
xpkfm1  = 1.0/(x+kf)
xpksim1 = 1.0/(x+ksi)
xpkscm1 = 1.0/(x+ks*c)

!
!     fn = hco3+co3+borate+oh+hpo4+2*po4+silicate+hfree+hso4+hf+h3po4-ta
!OR
!fn = -ta  + kw/x - c x 
!   + dic (k1 x + 2 k12)/(k12 + k1 x + x^2)
!   + pt  (2 k123p + k12p x - x^3)/(k123p + k12p x + k1p x^2 + x^3)
!   + bt/(1. + x/kb) + sit/(1. + x/ksi) 
!   - st/(1. + (c ks)/x) - ft/(1. + kf/x)

fn = - ta + kw/x - c*x               &
     + dic*(k1*x+2.0*k12)*bm1        &
     + pt*(-x3+k12p*x+2.0*k123p)*am1 &
     + bt *kb *xpkbm1                &
     + sit*ksi*xpksim1               &
     - st *x  *xpkscm1               &
     - ft *x  *xpkfm1              

!
!     df = dfn/dx
!
df = - kw/x2 - c                                               &
     + dic*(bm1*k1 - bm2*db*(k1*x+2.0*k12))                    &
     + pt*(am1*(-3.*x2+k12p) - am2*da*(-x3+k12p*x+2.0*k123p))  &
     - bt*  kb  *xpkbm1 *xpkbm1                                &
     - sit* ksi *xpksim1*xpksim1                               &
     - st*  ks*c*xpkscm1*xpkscm1                               &
     - ft*  kf  *xpkfm1 *xpkfm1                                
     

return

end subroutine  ta_iter_1  !}
! </SUBROUTINE> NAME="ta_iter_1"

!#######################################################################
! <SUBROUTINE NAME="ocmip2_co2_alpha">
!
! <DESCRIPTION>
!       Calculate CO2 solubility, alpha, from
! temperature (t) and salinity (s).
!
! INPUT
!
!       isc        = first i-limit of the arrays
!       iec        = last i-limit of the arrays
!       jsc        = first j-limit of the arrays
!       jec        = last j-limit of the arrays
!
!       t          = temperature (degrees C)
!
!       s          = salinity (PSU)
!
!       mask       = land mask array (0.0 = land)
!
! OUTPUT
!       alpha      = Solubility of CO2 for air? (mol/kg/atm unless scaled)
!
! IMPORTANT: Some words about units - (JCO, 4/4/1999)
!
!     - Models may carry tracers in mol/m^3 (on a per volume basis)
!
!     - Conversely, this routine, which was written by observationalists
!       (C. Sabine and R. Key), passes input arguments in umol/kg  
!       (i.e., on a per mass basis)
!
!     - Thus, if the input or output units need to be changed from/to mol/m^3
!       then set scale to an appropriate value. For example, if the model
!       uses mol/m^3, then scale should be set to something like 1.0/1024.5
!       to convert from mol/m^3 to mol/kg.
!
! </DESCRIPTION>

subroutine FMS_ocmip2_co2_alpha(dope_vec, t, s, mask, alpha, scale)  !{

implicit none

!
!       arguments
!
type(CO2_dope_vector), intent(in)       :: dope_vec
real, dimension(dope_vec%isc:,dope_vec%jsc:), intent(in)  :: t
real, dimension(dope_vec%isc:,dope_vec%jsc:), intent(in)  :: s
real, dimension(dope_vec%isc:,dope_vec%jsc:), intent(in)  :: mask
real, dimension(dope_vec%isc:,dope_vec%jsc:), intent(out) :: alpha
real, intent(in), optional              :: scale

!
!       local variables
!

integer :: i
integer :: j
integer :: k
real    :: log100
real    :: tk
real    :: tk100
real    :: tk1002
real    :: logtk
real    :: ff
real    :: scale_factor

!
!       set the scale factor for unit conversion
!

if (present(scale)) then  !{
  scale_factor = scale
else  !}{
  scale_factor = 1.0
endif  !}

!
!---------------------------------------------------------------------
!
!***********************************************************************
! Calculate all constants needed to convert between various measured
! carbon species. References for each equation are noted in the code.
! Once calculated, the constants are stored and passed in the common
! block "const". The original version of this code was based on
! the code by Dickson in Version 2 of "Handbook of Methods for the
! Analysis of the Various Parameters of the Carbon Dioxide System
! in Seawater", DOE, 1994 (SOP No. 3, p25-26).
!
! Derive simple terms used more than once
!

log100 = log(100.0)
do j = dope_vec%jsc, dope_vec%jec  !{
  do i = dope_vec%isc, dope_vec%iec  !{

    if (mask(i,j) .ne. 0.0) then  !{

      tk     = 273.15 + t(i,j)
      tk100  = tk / 100.0
      tk1002 = tk100 * tk100
      logtk  = log(tk)

!
! f = k0(1-pH2O)*correction term for non-ideality
!
! Weiss & Price (1980, Mar. Chem., 8, 347-359; Eq 13 with table 6
!                values)
!

      ff = exp(-162.8301 + 218.2968 / tk100  +                                  &
               90.9241 * (logtk - log100) - 1.47696 * tk1002 +                  &
               s(i,j) * (0.025695 - 0.025225 * tk100 + 0.0049867 * tk1002))

!
!---------------------------------------------------------------
!c      Should we be using K0 or ff for the solubility here?
!         convert to output units
!---------------------------------------------------------------
!

      alpha(i,j) = ff / scale_factor

    else  !}{
    
      alpha(i,j) = 0.0

    endif  !}

  enddo  !} i
enddo  !} j

return

end subroutine  FMS_ocmip2_co2_alpha  !}
! </SUBROUTINE> NAME="ocmip2_co2_alpha"



!#######################################################################
! <SUBROUTINE NAME="FMS_ocmip2_co2calc_old">
!
! <DESCRIPTION>
!       Calculate co2* from total alkalinity and total CO2 at
! temperature (t) and salinity (s).
! It is assumed that init_ocmip2_co2calc has already been called with
! the T and S to calculate the various coefficients.
!
! INPUT
!
!       dope_vec   = an array of indices corresponding to the compute 
!                    and data domain boundaries.
!
!       mask       = land mask array (0.0 = land)
!
!       dic_in     = total inorganic carbon (mol/kg) 
!                    where 1 T = 1 metric ton = 1000 kg
!
!       ta_in      = total alkalinity (eq/kg) 
!
!       pt_in      = inorganic phosphate (mol/kg) 
!
!       sit_in     = inorganic silicate (mol/kg) 
!
!       htotallo   = lower limit of htotal range
!
!       htotalhi   = upper limit of htotal range
!
!       htotal     = H+ concentration (mol/kg)
!
! OUTPUT
!       co2star    = CO2*water, or H2CO3 concentration (mol/kg)
!       alpha      = Solubility of CO2 for air (mol/kg/atm)
!       pco2surf   = oceanic pCO2 (ppmv)
!       co3_ion    = Carbonate ion, or CO3-- concentration (mol/kg)
!
! FILES and PROGRAMS NEEDED: drtsafe_old, ta_iter_1
!
! IMPORTANT: co2star and alpha need to be multiplied by rho before being
! passed to the atmosphere.
!
! </DESCRIPTION>

subroutine FMS_ocmip2_co2calc_old(dope_vec, mask,                      &
                          t_in, s_in, dic_in, pt_in, sit_in, ta_in, htotallo, &
                          htotalhi, htotal, co2star, alpha, pCO2surf, co3_ion)  !{

implicit none

!
!       local parameters
!

real, parameter :: permeg = 1.e-6
real, parameter :: xacc = 1.0e-10

!
!       arguments
!
type(CO2_dope_vector), intent(in)           :: dope_vec
real, dimension(dope_vec%isd:dope_vec%ied,dope_vec%jsd:dope_vec%jed), &
      intent(in)::             mask, &
                               t_in, &
                               s_in, &
                               dic_in, &
                               pt_in, &
                               sit_in, &
                               ta_in, &
                               htotallo, &
                               htotalhi
real, dimension(dope_vec%isd:dope_vec%ied,dope_vec%jsd:dope_vec%jed), &
      intent(inout)         :: htotal
real, dimension(dope_vec%isd:dope_vec%ied,dope_vec%jsd:dope_vec%jed), &
      intent(out), optional :: alpha, &
                               pCO2surf, &
                               co2star, &
                               co3_ion
!
!       local variables
!
integer :: isc, iec, jsc, jec
integer :: i,j
real :: alpha_internal
real :: bt
real :: co2star_internal
real :: dlogtk
real :: ft
real :: htotal2
real :: invtk
real :: is
real :: is2
real :: k1
real :: k2
real :: k1p
real :: k2p
real :: k3p
real :: kb
real :: kf
real :: ks
real :: ksi
real :: kw
real :: log100
real :: s2
real :: scl
real :: sqrtis
real :: sqrts
real :: st
real :: tk
real :: tk100
real :: tk1002
real :: logf_of_s

! Set the loop indices.
  isc = dope_vec%isc ; iec = dope_vec%iec
  jsc = dope_vec%jsc ; jec = dope_vec%jec

!
!       Initialize the module
!
  log100 = log(100.0)

  do j = jsc, jec  !{
    do i = isc, iec  !{
      if (mask(i,j) .gt. 0.0) then  !{
!
!---------------------------------------------------------------------
!
!***********************************************************************
! Calculate all constants needed to convert between various measured
! carbon species. References for each equation are noted in the code.
! Once calculated, the constants are stored and passed in the common
! block "const". The original version of this code was based on
! the code by Dickson in Version 2 of "Handbook of Methods for the
! Analysis of the Various Parameters of the Carbon Dioxide System
! in Seawater", DOE, 1994 (SOP No. 3, p25-26).
        tk        = 273.15 + t_in(i,j)
        tk100     = tk / 100.0
        tk1002     = tk100**2
        invtk     = 1.0 / tk
        dlogtk    = log(tk)
        is        = 19.924 * s_in(i,j) /(1000.0 -1.005 * s_in(i,j))
        is2       = is * is
        sqrtis    = sqrt(max(0.0,is))
        s2        = s_in(i,j) * s_in(i,j)
        sqrts     = sqrt(max(0.0,s_in(i,j)))
        scl       = s_in(i,j) / 1.80655
        logf_of_s = log(1.0 - 0.001005 * s_in(i,j))
!
! k0 from Weiss 1974
!
!
!        k0 = exp(93.4517/tk100 - 60.2409 + 23.3585 * log(tk100) +       &
!                 s_in(i,j) * (0.023517 - 0.023656 * tk100 +             &
!                 0.0047036 * tk1002))
!
! k1 = [H][HCO3]/[H2CO3]
! k2 = [H][CO3]/[HCO3]
!
! Millero p.664 (1995) using Mehrbach et al. data on seawater scale 
!

        k1 = 10.0**(-(3670.7 * invtk - 62.008 + 9.7944 * dlogtk -       &
                             0.0118 * s_in(i,j) + 0.000116 * s2))
        k2 = 10.0**(-(1394.7 * invtk + 4.777 -                          &
                             0.0184 * s_in(i,j) + 0.000118 * s2))
!
! kb = [H][BO2]/[HBO2]
!
! Millero p.669 (1995) using data from Dickson (1990)
!

        kb = exp((-8966.90 - 2890.53 * sqrts - 77.942 * s_in(i,j) +     &
                 1.728 * sqrts**3 - 0.0996 * s2) * invtk + (148.0248 +  &
                 137.1942 * sqrts + 1.62142 * s_in(i,j)) + (-24.4344 -  &
                 25.085 * sqrts - 0.2474 * s_in(i,j)) * dlogtk +        &
                 0.053105 * sqrts * tk)
!
! k1p = [H][H2PO4]/[H3PO4]
!
! DOE(1994) eq 7.2.20 with footnote using data from Millero (1974)
!

        k1p = exp(-4576.752 * invtk + 115.525 - 18.453 * dlogtk +       &
                  (-106.736 * invtk + 0.69171) * sqrts + (-0.65643 *    &
                  invtk - 0.01844) * s_in(i,j))
!
! k2p = [H][HPO4]/[H2PO4]
!
! DOE(1994) eq 7.2.23 with footnote using data from Millero (1974))
!

        k2p = exp(-8814.715 * invtk + 172.0883 - 27.927 * (-160.340 *   &
                  invtk + 1.3566) * sqrts + (0.37335 * invtk -          &
                  0.05778) * s_in(i,j))
!
!-----------------------------------------------------------------------
! k3p = [H][PO4]/[HPO4]
!
! DOE(1994) eq 7.2.26 with footnote using data from Millero (1974)
!

        k3p = exp(-3070.75 * invtk - 18.141 +(17.27039 * invtk +        &
                  2.81197) * sqrts + (-44.99486 * invtk - 0.09984) *    &
                  s_in(i,j))
!
!-----------------------------------------------------------------------
! ksi = [H][SiO(OH)3]/[Si(OH)4]
!
! Millero p.671 (1995) using data from Yao and Millero (1995)
!
        ksi = exp(-8904.2 * invtk + 117.385 - 19.334 * dlogtk +         &
                  (-458.79 * invtk + 3.5913) * sqrtis + (188.74 *       &
                  invtk - 1.5998) * is + (-12.1652 * invtk + 0.07871) * &
                  is2 + logf_of_s)
!
!-----------------------------------------------------------------------
! kw = [H][OH]
!
! Millero p.670 (1995) using composite data
!

        kw = exp(-13847.26 * invtk + 148.9652 - 23.6521 *  dlogtk +     &
                 (118.67 * invtk - 5.977 + 1.0495 * dlogtk) * sqrts -   &
                 0.01615 * s_in(i,j))
!
!-----------------------------------------------------------------------
! ks = [H][SO4]/[HSO4]
!
! Dickson (1990, J. chem. Thermodynamics 22, 113)
!
        ks = exp(-4276.1 * invtk + 141.328 - 23.093 * dlogtk +          &
                 (-13856.0 * invtk + 324.57 - 47.986 * dlogtk) *        &
                 sqrtis + (35474.0 * invtk - 771.54 + 114.723 *         &
                 dlogtk) * is - 2698.0 * invtk * sqrtis**3 +            &
                 1776.0 * invtk * is2 + logf_of_s)
!
!-----------------------------------------------------------------------
! kf = [H][F]/[HF]
!
! Dickson and Riley (1979) -- change pH scale to total
!
        kf = exp(1590.2 * invtk - 12.641 + 1.525 * sqrtis + logf_of_s + &
                 log(1.0 + (0.1400 / 96.062) * scl / ks))
!
!-----------------------------------------------------------------------
! Calculate concentrations for borate, sulfate, and fluoride
!
! Uppstrom (1974)
!
        bt = 0.000232 / 10.811 * scl
!
! Morris & Riley (1966)
!
        st = 0.14 / 96.062 * scl
!
! Riley (1965)
!
        ft = 0.000067 / 18.9984 * scl
!
!***********************************************************************
!
! Calculate [H+] total when DIC and TA are known at T, S and 1 atm.
! The solution converges to err of xacc. The solution must be within
! the range x1 to x2.
!
! If DIC and TA are known then either a root finding or iterative method
! must be used to calculate htotal. In this case we use the
! Newton-Raphson "safe" method taken from "Numerical Recipes"
! (function "rtsafe.f" with error trapping removed).
!
! As currently set, this procedure iterates about 12 times. The x1
! and x2 values set below will accomodate ANY oceanographic values.
! If an initial guess of the pH is known, then the number of
! iterations can be reduced to about 5 by narrowing the gap between
! x1 and x2. It is recommended that the first few time steps be run
! with x1 and x2 set as below. After that, set x1 and x2 to the
! previous value of the pH +/- ~0.5. The current setting of xacc will
! result in co2star accurate to 3 significant figures (xx.y). Making
! xacc bigger will result in faster convergence also, but this is not
! recommended (xacc of 10**-9 drops precision to 2 significant
! figures).
!

        htotal(i,j) = drtsafe_old(  k1, k2, kb, k1p, k2p, k3p, ksi, kw,   &
                                ks, kf, bt, dic_in(i,j), ft, pt_in(i,j),&
                                sit_in(i,j), st, ta_in(i,j),            &
                                htotalhi(i,j), htotallo(i,j),htotal(i,j), xacc)
!
! Calculate [CO2*] as defined in DOE Methods Handbook 1994 Ver.2, 
! ORNL/CDIAC-74, Dickson and Goyet, eds. (Ch 2 p 10, Eq A.49)
!
        htotal2 = htotal(i,j) * htotal(i,j)
        co2star_internal = dic_in(i,j) * htotal2 / (htotal2 +           &
                         k1 * htotal(i,j) + k1 * k2)
        if (present(co2star)) co2star(i,j) = co2star_internal
        if (present(co3_ion)) co3_ion(i,j) = co2star_internal * k1 * k2 / htotal2
!
! Weiss & Price (1980, Mar. Chem., 8, 347-359; Eq 13 with table 6
!                values)
!
        if (present(alpha) .or. present(pCO2surf)) then
          alpha_internal = exp(-162.8301 + 218.2968 / tk100 + 90.9241 *     &
                         (dlogtk -log100) - 1.47696 * tk1002 +          &
                         s_in(i,j) * (0.025695 - 0.025225 * tk100 +   &
                         0.0049867 * tk1002))
        endif
        if (present(alpha)) alpha(i,j) = alpha_internal
        if (present(pCO2surf)) then
          pCO2surf(i,j) = co2star_internal / (alpha_internal * permeg)
        endif

    else  !}{mask(i,j)=0.0

      if (present(co3_ion)) then
        co3_ion(i,j) = 0.0
      endif
      if (present(co2star)) then
        co2star(i,j) = 0.0
      endif
      if (present(alpha)) then  !{
        alpha(i,j) = 0.0
      endif  !}
      if (present(pco2surf)) then  !{
        pCO2surf(i,j) = 0.0
      endif  !}

    endif  !}mask

    enddo  !} i
  enddo  !} j

return

end subroutine  FMS_ocmip2_co2calc_old  !}
! </SUBROUTINE> NAME="FMS_ocmip2_co2calc_old"


!#######################################################################
! <FUNCTION NAME="drtsafe_old">
!
! <DESCRIPTION>
!       File taken from Numerical Recipes. Modified  R. M. Key 4/94
! </DESCRIPTION>

function drtsafe_old(k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf, &
               bt, dic, ft, pt, sit, st, ta, x1, x2, x, xacc)  !{

implicit none

!
!       arguments
!

real    :: k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf
real    :: bt, dic, ft, pt, sit, st, ta
real    :: drtsafe_old
real    :: x1, x2, x, xacc

!
!       local parameters
!

integer, parameter      :: maxit = 100

!
!       local variables
!

integer :: j
real    :: fl, df, fh, swap, xl, xh, dxold, dx, f, temp

drtsafe_old=x
call ta_iter_1(k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf, &
               bt, dic, ft, pt, sit, st, ta, drtsafe_old, f, df)
dx=f/df
if (abs(dx) .lt. xacc) then
!     write (6,*) 'Exiting drtsafe_old at C on iteration  ', j, ', ph = ', -log10(drtsafe)
  return
endif

call ta_iter_1(k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf, &
               bt, dic, ft, pt, sit, st, ta, x1, fl, temp)
call ta_iter_1(k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf, &
               bt, dic, ft, pt, sit, st, ta, x2, fh, temp)

if(fl .lt. 0.0) then
  xl=x1
  xh=x2
else
  xh=x1
  xl=x2
  swap=fl
  fl=fh
  fh=swap
end if
drtsafe_old=0.5*(x1+x2)
dxold=abs(x2-x1)
dx=dxold

do j=1,maxit  !{
  if (((drtsafe_old-xh)*df-f)*((drtsafe_old-xl)*df-f) .ge. 0.0 .or.     &
      abs(2.0*f) .gt. abs(dxold*df)) then
    dxold=dx
    dx=0.5*(xh-xl)
    drtsafe_old=xl+dx
    if (xl .eq. drtsafe_old) then
!     write (6,*) 'Exiting drtsafe_old at A on iteration  ', j, ', ph = ', -log10(drtsafe)
      return
    endif
  else
    dxold=dx
    dx=f/df
    temp=drtsafe_old
    drtsafe_old=drtsafe_old-dx
    if (temp .eq. drtsafe_old) then
!     write (6,*) 'Exiting drtsafe_old at B on iteration  ', j, ', ph = ', -log10(drtsafe)
      return
    endif
  end if
  if (abs(dx) .lt. xacc) then
!     write (6,*) 'Exiting drtsafe_old at C on iteration  ', j, ', ph = ', -log10(drtsafe)
    return
  endif
  call ta_iter_1(k1, k2, kb, k1p, k2p, k3p, ksi, kw, ks, kf, &
                 bt, dic, ft, pt, sit, st, ta, drtsafe_old, f, df)
  if(f .lt. 0.0) then
    xl=drtsafe_old
    fl=f
  else
    xh=drtsafe_old
    fh=f
  end if
enddo  !} j


return

end  function  drtsafe_old  !}
! </FUNCTION> NAME="drtsafe_old"

end module  FMS_ocmip2_co2calc_mod  !}

module ocean_obc_barotrop_mod
#define COMP isc:iec,jsc:jec
  !
  ! <CONTACT EMAIL="martin.schmidt@io-warnemuende.de"> Martin Schmidt </CONTACT>
  ! <CONTACT EMAIL="Mike.Herzfeld@csiro.au"> Mike Herzfeld </CONTACT>
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Zhi Liang </CONTACT>
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Matthew Harrison </CONTACT>
  ! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen Griffies </REVIEWER>
  !
  ! 
  ! <OVERVIEW>
  !   Open Boundary condition for MOM.
  ! </OVERVIEW>
  !
  ! <DESCRIPTION>
  !   This module can extrapolate data on the open lateral
  !   boundaries for MOM. Tracer and surface height 
  !   are extrapolated on the boundary by using implicit radiation 
  !   boundary conditions, velocities are calculated on the boundary
  !   from a linear equation (omitted advection equation). The 
  !   gradient of each field is supposed to be zero  between boundary
  !   points and the first points accross the boundary.
  !
  !   This scheme has been tested only with the following vertical coordinates:
  !   vertical_coordinate=='geopotential' 
  !   vertical_coordinate=='zstar'
  !   Notably, there is no OBC prescription for pressure coordinates. 
  !
  ! </DESCRIPTION>
#include <fms_platform.h>

  use constants_mod,            only: grav
  use data_override_mod,        only: data_override
  use diag_manager_mod,         only: register_diag_field, send_data, diag_axis_init
  use fms_mod,                  only: write_version_number, open_namelist_file, close_file, file_exist
  use fms_mod,                  only: stdout, stdlog, check_nml_error, FATAL, NOTE 
  use fms_io_mod,               only: register_restart_field, save_restart, restore_state
  use fms_io_mod,               only: reset_field_pointer, restart_file_type
  use mpp_io_mod,               only: mpp_open, mpp_close, MPP_MULTI, MPP_OVERWR, MPP_SINGLE
  use mpp_domains_mod,          only: mpp_get_compute_domain, mpp_get_data_domain, mpp_get_global_domain
  use mpp_domains_mod,          only: domain2d, mpp_update_domains, mpp_get_compute_domains
  use mpp_domains_mod,          only: mpp_set_compute_domain, mpp_set_data_domain, mpp_set_global_domain
  use mpp_domains_mod,          only: mpp_define_domains
  use mpp_domains_mod,          only: BGRID_NE, SCALAR_PAIR

  use mpp_mod,                  only: input_nml_file, mpp_error, mpp_pe, mpp_chksum, mpp_npes, mpp_send, mpp_recv
  use mpp_mod,                  only: CLOCK_MODULE
  use mpp_mod,                  only: mpp_clock_id, mpp_clock_begin, mpp_clock_end
  use mpp_mod,                  only: mpp_get_current_pelist, mpp_declare_pelist, mpp_sync_self
  use mpp_mod,                  only: mpp_set_current_pelist
  use time_interp_external_mod, only: time_interp_external, init_external_field, get_external_field_size
  use time_manager_mod,         only: time_type
  use tracer_manager_mod,       only: get_tracer_names, get_tracer_indices, get_number_tracers
  use ocean_util_mod,           only: write_timestamp, write_chksum_2d

  use ocean_domains_mod,        only: get_local_indices, get_domain_offsets
  use ocean_parameters_mod,     only: missing_value, rho0, GEOPOTENTIAL
  use ocean_types_mod,          only: ocean_grid_type, ocean_domain_type, ocean_thickness_type
  use ocean_types_mod,          only: ocean_prog_tracer_type, ocean_adv_vel_type, ocean_options_type
  use ocean_types_mod,          only: ocean_external_mode_type, obc_flux
  use ocean_types_mod,          only: ocean_time_type, ocean_time_steps_type

implicit none
  private

interface
   integer function tm_scale_to_secs(buf, sec)
     character(len=16) :: buf
     real              :: sec
   end function tm_scale_to_secs
end interface


  public :: ocean_obc_barotrop_init, ocean_obc_end
  public :: ocean_obc_barotropic
  public :: ocean_obc_update_boundary, ocean_obc_prepare
  public :: ocean_obc_zero_boundary
  public :: ocean_obc_check_for_update
  public :: ocean_obc_adjust_divud
  public :: ocean_obc_damp_newton, ocean_obc_ud
  public :: mpp_update_domains_obc
  interface mpp_update_domains_obc
    module procedure mpp_update_domains_obc
  end interface mpp_update_domains_obc
!  public :: ocean_obc_restart

  !--- some module variables -------------------------------------------
  integer, parameter :: max_obc = 4             ! maximum number of open boundaries (increase if want more)
#ifdef USE_OCEAN_BGC
  integer, parameter :: max_prog_tracers=40     ! maximum number of prognostics tracers (increase if want more)
                                                ! it can be increased if needed.
#else                                                
  integer, parameter :: max_prog_tracers=10     ! maximum number of prognostics tracers (increase if want more)
#endif
  ! Boundary location flags
  integer, parameter :: WEST  = 1               ! western boundary
  integer, parameter :: EAST  = 2               ! eastern boundary
  integer, parameter :: SOUTH = 3               ! southern boundary
  integer, parameter :: NORTH = 4               ! northern boundary

  ! Boundary condition flags
  integer, parameter :: NOTHIN = 1              ! No OBC
  integer, parameter :: CLAMPD = 2              ! Clamped to zero
  integer, parameter :: NOGRAD = 4              ! No gradient
  integer, parameter :: INGRAD = 8              ! Interior cell no gradient
  integer, parameter :: LINEAR = 16             ! Linear extrapolation
  integer, parameter :: FILEIN = 32             ! Input from file
  integer, parameter :: MEANIN = 64             ! Mean obc value
  integer, parameter :: ORLANS = 128            ! Orlanski radiation
  integer, parameter :: CAMOBR = 256            ! Camerlengo radiation
  integer, parameter :: MILLER = 512            ! Miller & Thorpe radiation
  integer, parameter :: IOW    = 1024           ! Schmidt radiation
  integer, parameter :: GRAVTY = 2048           ! Gravity wave radiation
  integer, parameter :: UPSTRM = 4096           ! Upstream advection
  integer, parameter :: RAYMND = 8192           ! Raymond and Kuo radiation
  integer, parameter :: FLATHR = 16384          ! Flather radiation
  
  ! parameter for enhanced viscosity or diffusion
  integer, parameter :: NONE     = 0
  integer, parameter :: MODERATE = 1            ! enhance against interiour
  integer, parameter :: LARGE    = 2            ! enhance to maximum value (CFL)

  real, parameter    :: small = 1.0e-8          ! some small number
  real               :: dtuv, dtts, dtbt, dteta ! time step.
  real               :: dtime_e                 ! timestep (secs) (dtime_e=2*dteta for threelevel and dtime_e=dteta for twolevel)
  real               :: dtime_t                 ! timestep (secs) (dtime_t=2*dtts for threelevel and dtime_t=dtts for twolevel)
  integer            :: isc, iec, jsc, jec      ! computational domain decompsition
  integer            :: isd, ied, jsd, jed      ! data domain decompsition
  integer            :: isg, ieg, jsg, jeg      ! global domain decompsition
  integer            :: nk                      ! number of vertical levels
  integer            :: tendency=0              ! integer corresponding to the choice of time tendency 

  ! for restart
  integer                       :: id_restart(4) = 0
  type(restart_file_type), save :: Obc_restart

  type(ocean_domain_type), pointer :: Dom => NULL()  ! ocean domain
  type(ocean_grid_type),pointer    :: Grd => NULL()  ! ocean grid
  integer, allocatable             :: obc_out_unit(:)

  !--- derived types to specify the domain and grid --------------------
  type obc_bound_type
     integer           :: is, ie, js, je         ! index specifying bound location on current pe
     integer           :: isd,ied,jsd,jed        ! index specifying bound location on current pe of data domain
     integer           :: isg,ieg,jsg,jeg        ! global index specifying bound location 
     integer           :: iers,iere,jers,jere    ! global indecees of eta files
     integer           :: itrs,itre,jtrs,jtre    ! global indecees of tracer files
     integer           :: np                     ! specifies total number of boundary points
     integer           :: direction              ! its value can be "w"(west), "e"(east), "s"(south), "n"(north)     
     logical           :: on_bound               ! true means there are some points on the boundary on current pe.
     logical           :: report                 ! true means this PE writes a report on the configuration
     integer           :: bcond_nor              ! Normal velocity OBC
     integer           :: bcond_tan              ! Normal velocity OBC
     integer           :: bcond_eta              ! Surface elevation OB
     integer           :: bcond_ud               ! Normal depth integrated velocity OBC 
     integer           :: bcond_eta_t            ! Surface height OBC
     integer, pointer  :: bcond_tra(:)           ! Tracer OBC
     integer           :: bcond_mix              ! Vertical mixing coeff. OBC

     !-----------------------------------
     ! Computational domain boundary maps
     integer           :: nloc                   ! Number of boundary points

     ! Boundary i and j vectors containing the (i,j) locations for 
     ! the computational domain OBC.
     ! Note that for east and west OBCs   iloc = Obc%bound%is is constant, 
     ! and for north and south boundaries jloc = Obc%bound%js is constant.
     integer, pointer  :: iloc(:)    => NULL()   ! Boundary i location
     integer, pointer  :: jloc(:)    => NULL()   ! Boundary j location

     ! Boundary i and j vectors containing the interior cell immediately
     ! adjacent to the boundary, i.e.
     ! For western boundaries oi1 = iloc + 1, oj1 => jloc
     ! For eastern boundaries oi1 = iloc - 1, oj1 => jloc
     ! For southern boundaries oj1 = jloc + 1, oi1 => iloc
     ! For northern boundaries oj1 = jloc - 1, oi1 => iloc
     integer, pointer  :: oi1(:)     => NULL()   ! Boundary interior i location
     integer, pointer  :: oj1(:)     => NULL()   ! Boundary interior j location

     ! Boundary i and j vectors containing interior cells 2 cells distant
     ! from the boundary, i.e.
     ! For western boundaries oi2 = iloc + 2, oj1 => jloc
     ! For eastern boundaries oi2 = iloc - 2, oj1 => jloc
     ! For southern boundaries oj2 = jloc + 2, oi1 => iloc
     ! For northern boundaries oj2 = jloc - 2, oi1 => iloc
     integer, pointer  :: oi2(:)     => NULL()   ! Interior 2i location
     integer, pointer  :: oj2(:)     => NULL()   ! Interior 2j location

     ! Boundary vectors containing the variable index only for use with
     ! Obc%eta%data.
     ! For western and eastern boundaries, d1i_bt = 1, d1j_bt => jloc
     ! For southern and northern boundaries, d1i_bt => iloc, d1j_bt = 1
     integer, pointer  :: d1i_bt(:)  => NULL()   ! 1D i index pointer
     integer, pointer  :: d1j_bt(:)  => NULL()   ! 1D j index pointer

     ! Boundary vectors containing the face centered boundary location.
     ! For eastern and northern boundaries this corresponds to the 
     ! interior cell. This corresponds to the NVIE location (Herzfeld, 2008).
     ! For western boundaries icf => iloc, jcf => jloc
     ! For eastern boundaries icf => oi1, jcf => jloc
     ! For southern boundaries icf => iloc, jcf => jloc
     ! For northern boundaries icf => iloc, jcf => oi1
     integer, pointer  :: icf(:)     => NULL()   ! Boundary face i location
     integer, pointer  :: jcf(:)     => NULL()   ! Boundary face j location

     ! Boundary vectors containing the face outside the elevation location.
     ! For western and sorthern boundaries this is iloc - imap, jloc - jmap.
     ! This corresponds to the NVOE location (Herzfeld, 2008).
     ! For western boundaries ico_bt => iloc-imap, jco_bt => jlod
     ! For eastern boundaries ico_bt => iloc, jco_bt => jlod
     ! For southern boundaries ico_bt => iloc, jco_bt => jloc-jmap
     ! For northern boundaries ico_bt => iloc, jco_bt => jloc

     integer, pointer  :: ico_bt(:)     => NULL()   ! Outside face i location
     integer, pointer  :: jco_bt(:)     => NULL()   ! Outside face j location

     ! Boundary vectors containing the normal (nic) and tangential (tic)
     ! indicies to the boundary.
     ! For west and east boundaries nic => iloc, tic => jloc
     ! For south and west boundaries nic => jloc, tic => iloc
     integer, pointer  :: nic(:)     => NULL()   ! Pointer to normal index
     integer, pointer  :: tic(:)     => NULL()   ! Pointer to tangential index

     integer, pointer  :: ones_bt(:) => NULL()   ! Array of ones

     ! Boundary interior maps :
     ! For western boundaries imap = 1, jmap = 0
     ! For eastern boundaries imap = -1, jmap = 0
     ! For southern boundaries imap = 0, jmap = 1
     ! For northern boundaries imap = 0, jmap = -1
     integer           :: imap                   ! Boundary i interior map
     integer           :: jmap                   ! Boundary j interior map

     ! Boundary tangential maps :
     ! For western and eastern boundaries imapt = 0, jmapt = 1
     ! For northern and southern boundaries imapt = 1, jmapt = 0
     integer           :: imapt                   ! Boundary i tangential map
     integer           :: jmapt                   ! Boundary j tangential map

     ! Start and end coordinates for the boundary.
     ! Western and eastern boundaries : nsc = jsc, nec = jec
     ! Southern and northern boundaries : nsc = isc, nec = iec
     integer           :: nsc                    ! Start coordinate
     integer           :: nec                    ! End coordinate
     real              :: sign                   ! -1 for east/north

     !-----------------------------------
     ! Data domain boundary maps
     integer           :: nlod                   ! Number of boundary points

     ! Boundary i and j vectors containing the (i,j) locations for 
     ! the data domain OBC. Analogous to (iloc, jloc).
     integer, pointer  :: ilod(:)    => NULL()   ! Boundary i location
     integer, pointer  :: jlod(:)    => NULL()   ! Boundary j location

     ! Boundary i and j vectors containing the interior cell immediately
     ! adjacent to the boundary for the data domain. Analogous to (oi1, oj1).
     integer, pointer  :: di1(:)     => NULL()   ! Boundary interior i location
     integer, pointer  :: dj1(:)     => NULL()   ! Boundary interior j location

     ! Boundary i and j vectors containing interior cells 2 cells distant
     ! from the boundary for the data domain. Analogous to (oi2, oj2).
     integer, pointer  :: di2(:)     => NULL()   ! Interior 2i location
     integer, pointer  :: dj2(:)     => NULL()   ! Interior 2j location

     ! Boundary vectors containing the face centered boundary location for
     ! the data domain. Analogous to (icf, jcf).
     integer, pointer  :: idf(:)     => NULL()   ! Boundary face i location
     integer, pointer  :: jdf(:)     => NULL()   ! Boundary face j location

     ! Boundary vectors containing the face outside the elevation location for
     ! the data domain. Analogous to (ico, jco).
     integer, pointer  :: ido(:)     => NULL()   ! Outside face i location
     integer, pointer  :: jdo(:)     => NULL()   ! Outside face jlocation

     ! Boundary vectors containing the normal (nic) and tangential (tic)
     ! indicies to the data domain boundary. Analogous to (nic, tic).
     integer, pointer  :: nid(:)     => NULL()   ! Pointer to normal index
     integer, pointer  :: tid(:)     => NULL()   ! Pointer to tangential index

     ! Boundary vectors containing start and end indicies for the halo
     ! cells associated with the data domain boundary.
     ! For western boundaries : istr = max(isd,isd-2), iend = isd-1
     !                          jstr = jend => jlod
     ! For eastern boundaries : istr = isd+1, iend = min(ied,i+2)
     !                          jstr = jend => jlod
     ! For southern boundaries : jstr = max(jsd,j-2), jend = jsd-1
     !                           istr = iend => ilod
     ! For northern boundaries : jstr = jsd+1, jend = min(jed,j+2)
     !                           istr = iend => ilod
     integer, pointer  :: istr(:)    => NULL()   ! Boundary i halo start map
     integer, pointer  :: iend(:)    => NULL()   ! Boundary i halo end map
     integer, pointer  :: jstr(:)    => NULL()   ! Boundary j halo start map
     integer, pointer  :: jend(:)    => NULL()   ! Boundary j halo end map

     ! Start and end coordinates for the data domain boundary.
     ! Western and eastern boundaries : nsd = jsd, ned = jed
     ! Southern and northern boundaries : nsd = isd, ned = ied
     integer           :: nsd                    ! Start coordinate
     integer           :: ned                    ! End coordinate

     real,    pointer  :: dum(:)     => NULL()   ! 1D dummy array
     real,    pointer  :: pgrad(:)   => NULL()   ! barotropic phase speed
     real,    pointer  :: hadv (:,:) => NULL()   ! cross boundary horizontal tracer advection, 
                                                 ! updated in the tracer loop, so no tracer number needed
     logical, pointer  :: mask(:)    => NULL()   ! logical varible to indicate the grid is open or not.
     character(len=16) :: name                   ! 
     real              :: ctrop_max              ! maximum barotropic phase speed (should be 1 .. 2) 
     real              :: ctrop_min              ! minimum barotropic phase speed (should be 0 .. 1) 
     real              :: ctrop_inc              ! barotropic phase speed for incoming waves (times cgrid) (should be 0 .. 1) 
     real              :: ctrop_smooth           ! smooth parameter for barotropic phase speed (should be 0 .. 1) 
     integer           :: enh_pnts               ! number of points besides the boundary with enhanced viscosity
     real              :: enh_fac_v              ! enhancement factor of viscosity
     real              :: enh_fac_d              ! enhancement factor of diffusivity
     integer           :: obc_enhance_visc_back  ! enhance viscosity near boundary
     integer           :: obc_enhance_diff_back  ! enhance diffusion near boundary
     logical           :: obc_consider_convu     ! true to consider convu for d eta/dt
     logical           :: obc_vert_advel_t       ! consider vertical advection for tracers 
     logical           :: obc_vert_advel_u       ! consider vertical advection for velocity 
     logical           :: obc_adjust_forcing_bt  ! remove baroclinic press gradients from forcing_bt
     logical           :: obc_relax_eta          ! true to relax sea level
     logical           :: obc_relax_eta_profile  ! true to relax sea level comparing mean sea level with reference value
     logical           :: obc_damp_newton        ! true to apply newtonian damping
     logical           :: obc_ud_active          ! Set ud to active forcing (FLATHR or FILEIN)
     real              :: damp_factor            ! newton damping factor
     logical, pointer  :: obc_relax_tracer(:)    => NULL() ! true to relax a tracer
     logical, pointer  :: obc_consider_sources(:)=> NULL() ! true for valid source and SGS terms
     integer, pointer  :: obc_flow_relax(:)      => NULL() ! true to invoke flow relaxation
     logical, pointer  :: obc_tracer_no_inflow(:)=> NULL() ! true to treat a tracer with Orlanski scheme
     real,    pointer  :: buffer(:)              => NULL() ! used for bitwise average on the boundary
     integer, pointer  :: start(:)               => NULL() ! list of starting index on the boundary
     integer, pointer  :: end(:)                 => NULL() ! list of ending index on the boundary
     integer, pointer  :: pelist(:)              => NULL() ! pelist used for this boundary
     integer           :: index
     real, pointer     :: work(:)  => NULL()     ! storage buffer
     real, pointer     :: work2(:,:,:) => NULL() ! 2d - storage buffer (1 index dummy)
     real, pointer     :: dsur(:) => NULL()       !kk Gravity wave speed
     integer           :: id_xt, id_yt, id_xu, id_yu
     integer           :: id_ctrop, id_eta_data, id_rel_coef, id_transport
     integer, allocatable :: id_tracer_data(:), id_tracer_flux(:), id_cclin(:)
  end type obc_bound_type

  type obc_data_type_2d
     real, pointer     :: data(:,:) => NULL() ! boundary values of eta for relaxation
     character(len=128):: file, field         ! name of the inputfile and inputfield
     real              :: rel_coef_in         ! relaxation coefficient to data during inflow
     real              :: rel_coef_out        ! relaxation coefficient to data during outflow
     integer           :: id                  ! the data id for time interpolation
     integer           :: rel_pnts            ! defines width of the band near the boundary for relaxation     
  end type obc_data_type_2d

  type obc_data_type_3d
     real, pointer     :: data(:,:,:) => NULL() ! boundary values of eta for relaxation
     character(len=128):: file, field         ! name of the inputfile and inputfield
     real              :: rel_coef_in         ! relaxation coefficient to data during inflow
     real              :: rel_coef_out        ! relaxation coefficient to data during outflow
     integer           :: id                  ! the data id for time interpolation
     integer           :: rel_pnts            ! defines width of the band near the boundary for relaxation     
  end type obc_data_type_3d

  type ocean_obc_type
     integer                       :: nobc               ! number of boundaries
     type(obc_bound_type), pointer :: bound(:) => NULL() ! contains boundary information.
     type(obc_data_type_2d),  pointer :: eta(:)      => NULL() ! contains boundary data information for sea level.
     type(obc_data_type_3d),  pointer :: tracer(:,:) => NULL() ! contains boundary data information for tracers.
     type(obc_data_type_2d),  pointer :: ud(:) => NULL() ! contains boundary data information for normal depth 
                                                         ! integrated velocity component
     type(obc_data_type_3d),  pointer :: uvel(:,:) => NULL() ! contains boundary data information for normal velocity component     
  end type ocean_obc_type

  type(ocean_obc_type), save :: Obc

  !<INTERFACE NAME="obc_update_boundary">
  !   <DESCRIPTION>
  !   update field on the halo points at the global boundaries.
  !   </DESCRIPTION>
  !   <INOUT NAME="field">
  !      field to be update on the boundary
  !   </INOUT>
  interface ocean_obc_update_boundary
     module procedure ocean_obc_update_boundary_2d
     module procedure ocean_obc_update_boundary_3d
  end interface
  !</INTERFACE>

  !<INTERFACE NAME="obc_zero_boundary">
  !   <DESCRIPTION>
  !   set field at open boundaries to zero.
  !   </DESCRIPTION>
  !   <INOUT NAME="field">
  !      field to be set to zero on the boundary
  !   </INOUT>
  interface ocean_obc_zero_boundary
     module procedure ocean_obc_zero_boundary_2d
  end interface
  !</INTERFACE>

  !--- namelist interface ---------------------------------------------
  !<NAMELIST NAME="ocean_obc_nml">
  !  <DATA NAME="nobc" TYPE="integer" >
  !    number of open boundary condition. Its value should be less than max_obc. Increase max_obc if needed.
  !  </DATA>
  !  <DATA NAME="direction" TYPE="character(len=10), dimension(max_obc)" >
  !    open boundary direction. Each element value should be west, east, south or north.
  !  </DATA>
  !  <DATA NAME="is, ie, js, je" TYPE="integer, dimension(max_obc)" >
  !    open boundary position. 
  !  </DATA>
  !  <DATA NAME="name" TYPE="character(len=32), dimension(max_obc)" >
  !    type of open bounday.
  !  </DATA>
  !  <DATA NAME="obc_nor" TYPE="character, dimension(max_obc)" >
  !    Normal velocity OBC
  !  </DATA>
  !  <DATA NAME="obc_tan" TYPE="character, dimension(max_obc)" >
  !    Tangential velocity OBC
  !  </DATA>
  !  <DATA NAME="obc_eta" TYPE="character, dimension(max_obc)" >
  !    Surface elevation OBC
  !  </DATA>
  !  <DATA NAME="obc_tra" TYPE="character, dimension(max_obc,max_prog_tracers)" >
  !    Tracers OBC
  !  </DATA>
  !  <DATA NAME="obc_mix" TYPE="character, dimension(max_obc)" >
  !    Vertical mixing coefficient OBC
  !  </DATA>
  !  <DATA NAME="obc_relax_eta" TYPE="logical, dimension(max_obc)" >
  !    logical variable that decide whether relax eta or not. Default value is .false.
  !  </DATA>
  !  <DATA NAME="obc_consider_convu" TYPE="logical, dimension(max_obc)" >
  !    logical variable that decide whether to account for one 
  !    component of convu within the boundary. The appropriate behavior
  !    depends on the model configuration.
  !    Default value is .false.
  !  </DATA>
  !  <DATA NAME="obc_vert_advel_t" TYPE="logical, dimension(max_obc)" >
  !    logical variable that decide whether to account for vertical
  !    advection of tracers at the boundary. The appropriate behavior
  !    depends on the model configuration.
  !    Default value is .false. (Currently inactive)
  !  </DATA>
  !  <DATA NAME="obc_vert_advel_u" TYPE="logical, dimension(max_obc)" >
  !    logical variable that decide whether to account for vertical
  !    advection of momentum at the boundary. The appropriate behavior
  !    depends on the model configuration.
  !    Default value is .false. 
  !  </DATA>
  !  <DATA NAME="obc_relax_eta_profile" TYPE="logical, dimension(max_obc)" >
  !    logical variable that decide whether relax eta to a prescribed profile or not. 
  !    Default value is .false. In this case  only the average sea level is relaxed,
  !    the profile, hence the geostrophic current, is unchanged.
  !  </DATA>
  !  <DATA NAME="obc_relax_tracer" TYPE="logical, dimension(max_obc)" >
  !    logical variable that decide whether relax tracer or not. Default value is .false.
  !  </DATA>
  !  <DATA NAME="obc_flow_relax" TYPE="integer, dimension(max_obc)" >
  !    Integer variable specifying the flow relaxation zone 
  !    (flow realxation of Martinsen and Engedahl (1987). Default value is 1.
  !  </DATA>
  !  <DATA NAME="obc_consider_sources" TYPE="logical, dimension(max_obc)" >
  !    Logical variable specifying if source and SGS terms of the normal tracer
  !    scheme are valid. Default value is .false..
  !  </DATA>
  !  <DATA NAME="obc_tracer_no_inflow" TYPE="logical, dimension(max_obc)" >
  !    logical variable that decide whether apply orlanski obc on tracer or not. Default value is .false.
  !  </DATA>
  !  <DATA NAME="ctrop_max" TYPE="real, dimension(max_obc)" >
  !    Maximum value to clip diagnosed barotropic phase speed in terms of sqrt(gH).
  !    Should be about  1. 
  !  </DATA>
  !  <DATA NAME="ctrop_min" TYPE="real, dimension(max_obc)" >
  !    Minimum value to diagnosed barotropic phase speed in terms of sqrt(gH).
  !    Should be about  0.  Default is 0.1.
  !  </DATA>
  !  <DATA NAME="ctrop_inc" TYPE="real, dimension(max_obc)" >
  !    value to be set for barotropic phase speed if incoming waves are diagnosed.
  !    (in terms of sqrt(gH)) Should be about 0. Default is 0. 
  !  </DATA>
  !  <DATA NAME="rel_coef_eta_in" TYPE="real, dimension(max_obc)" >
  !    Relaxation coefficient to be used for incoming wave situation. 
  !  </DATA>
  !  <DATA NAME="rel_coef_eta_out" TYPE="real, dimension(max_obc)" >
  !    Relaxation coefficient to be used for outgoing wave situation. 
  !    Should be smaller then or equal to rel_coef_eta_in. 
  !  </DATA>
  !  <DATA NAME="filename_eta" TYPE="character, dimension(max_obc)" >
  !    Filename to read sea level data.
  !  </DATA>
  !  <DATA NAME="fieldname_eta" TYPE="character, dimension(max_obc)" >
  !    Fieldname  to read sea level data.
  !  </DATA>
  !  <DATA NAME="rel_eta_pnts" TYPE="integer, dimension(max_obc)" >
  !    Relax sea level at a stripe of rel_eta_pnts. Default = 1.
  !  </DATA>
  !  <DATA NAME="rel_coef_tracer_in" TYPE="real, dimension(max_obc,max_prog_tracers)" >
  !    Relaxation coefficient to be used for inflow situation. 
  !  </DATA>
  !  <DATA NAME="rel_coef_tracer_out" TYPE="real, dimension(max_obc,max_prog_tracers)" >
  !    Relaxation coefficient to be used for outflow situation. 
  !    Should be smaller then or equal to rel_coef_tracer_in. 
  !  </DATA>
  !  <DATA NAME="rel_clin_pnts" TYPE="integer, dimension(max_obc,max_prog_tracers)" >
  !    Relax a tracer at a stripe of rel_clin_pnts. Default = 1.
  !  </DATA>
  !  <DATA NAME="filename_tracer" TYPE="character, dimension(max_obc,max_prog_tracers)" >
  !    Filename to read a tracer. It is allowed to put all data for a boundary in one file.
  !  </DATA>
  !  <DATA NAME="fieldname_tracer" TYPE="character, dimension(max_obc,max_prog_tracers)" >
  !    Fieldname of a tracer. 
  !  </DATA>
  !  <DATA NAME="obc_enhance_visc_back" TYPE="logical, dimension(max_obc)" >
  !    logical variable that decide whether to enhance viscosity at the boundary. Default value is .false.
  !  </DATA>
  !  <DATA NAME="obc_enhance_diff_back" TYPE="logical, dimension(max_obc)" >
  !    logical variable that decide whether to enhance mixing at the boundary. Default value is .false.
  !  </DATA>
  !  <DATA NAME="enh_fac_v" TYPE="real, dimension(max_obc)" >
  !    'Safety factor' applied to maximum stable viscosity at the boundary. Default = 0.9
  !  </DATA>
  !  <DATA NAME="enh_fac_d" TYPE="real, dimension(max_obc)" >
  !    Factor applied to enhance mixing at the boundary. Default = 1.
  !  </DATA>
  !  <DATA NAME="enh_pnts" TYPE="integer, dimension(max_obc)" >
  !    Enhance viscosity and mixing at a stripe of enh_pnts
  !    decreasing with the distance from the boundary. Default = 1.
  !  </DATA>
  !  <DATA NAME="debug_phase_speed" TYPE="logical">
  !  Includes the phase speed into the model output.
  !  </DATA> 
  !  <DATA NAME="debug_this_module" TYPE="logical">
  !  For debugging.
  !  </DATA> 
  !  <DATA NAME="nt" TYPE="integer">
  !    number of tracers to use open boundary condition. 
  !  </DATA>
  !</NAMELIST>

  integer                               :: nobc= 0
  character(len=10), dimension(max_obc) :: direction='' ! open directions; to be consistent with is, ie, js, je
  integer, dimension(max_obc)           :: is=-999, ie=-999, js=-999, je=-999     ! boundary position
  integer, dimension(max_obc)           :: iers=-999, iere=-999, jers=-999, jere=-999     ! boundary position
  integer, dimension(max_obc)           :: itrs=-999, itre=-999, jtrs=-999, jtre=-999     ! boundary position
  character(len=32), dimension(max_obc) :: name 
  character(len=128), dimension(max_obc):: obc_nor = 'NOGRAD'
  character(len=128), dimension(max_obc):: obc_tan = 'NOGRAD'
  character(len=128), dimension(max_obc):: obc_eta = 'NOTHIN'
  character(len=128), dimension(max_obc):: obc_height = 'NOTHIN'
  character(len=128), dimension(max_obc):: obc_ud = 'NOGRAD'  
  character(len=128), dimension(max_obc):: obc_mix = 'NOGRAD'
  character(len=128), dimension(max_obc,max_prog_tracers):: obc_tra = 'NOGRAD'
  character(len=128), dimension(max_obc):: obc_enhance_visc_back = 'NONE'
  character(len=16),  dimension(max_obc):: obc_enhance_diff_back = 'NONE'
  logical, dimension(max_obc)           :: obc_damp_newton = .FALSE.
  logical, dimension(max_obc)           :: obc_consider_convu = .FALSE.
  logical, dimension(max_obc)           :: obc_vert_advel_t= .FALSE.
  logical, dimension(max_obc)           :: obc_vert_advel_u= .FALSE.
  logical, dimension(max_obc)           :: obc_adjust_forcing_bt = .FALSE.
  real,    dimension(max_obc)           :: rel_coef_eta_in  = 0.0           ! relaxation coefficient, specify in namelist
  real,    dimension(max_obc)           :: rel_coef_eta_out = 0.0           ! relaxation coefficient, specify in namelist
  real,    dimension(max_obc)           :: ctrop_max = 1.5                  ! will be multiplied with sqrt(g*H)
  real,    dimension(max_obc)           :: ctrop_min = 0.1                  ! will be multiplied with sqrt(g*H)
  real,    dimension(max_obc)           :: ctrop_inc = .0                   ! will be multiplied with cgrid
  real,    dimension(max_obc)           :: ctrop_smooth = 0.7
  real,    dimension(max_obc)           :: damp_factor = 1.
  integer, dimension(max_obc)           :: enh_pnts  = 1                     
  integer, dimension(max_obc)           :: rel_eta_pnts  = 1                     
  real,    dimension(max_obc)           :: enh_fac_v   = 0.9
  real,    dimension(max_obc)           :: enh_fac_d   = 1.0
  character(len=256), dimension(max_obc):: filename_eta
  character(len=32),  dimension(max_obc):: fieldname_eta
  character(len=256), dimension(max_obc):: filename_ud
  character(len=32),  dimension(max_obc):: fieldname_ud  
  logical,            dimension(max_obc,max_prog_tracers):: obc_relax_tracer = .FALSE.
  integer,            dimension(max_obc,max_prog_tracers):: obc_flow_relax = 1
  logical,            dimension(max_obc,max_prog_tracers):: obc_consider_sources = .FALSE.
  logical,            dimension(max_obc,max_prog_tracers):: obc_tracer_no_inflow = .FALSE.
  integer,            dimension(max_obc,max_prog_tracers):: rel_clin_pnts  = 1            ! relax at rel_clin_pnts                 
  real,               dimension(max_obc,max_prog_tracers):: rel_coef_tracer_in  = 0.0     ! relaxation coefficient
  real,               dimension(max_obc,max_prog_tracers):: rel_coef_tracer_out = 0.0     ! relaxation coefficient
  character(len=256), dimension(max_obc,max_prog_tracers):: filename_tracer
  character(len=32),  dimension(max_obc,max_prog_tracers):: fieldname_tracer
  logical                               :: debug_this_module = .FALSE.
  logical                               :: debug_phase_speed = .FALSE.    
  logical                               :: update_eta_tm1    = .FALSE. 
  integer, parameter                    :: mobcm1 = max_obc-1
  integer, parameter                    :: ntm2   = max_prog_tracers-2
  integer, parameter                    :: tobc   = max_obc*max_prog_tracers
  integer                               :: ne, te

  character(len=128)                    :: errorstring
  
  integer                               :: id_obc
  
  type(domain2d),allocatable, save      :: obc_eta_domain(:)
  type(domain2d),allocatable, save      :: obc_diag_domain(:)
  
  data (name(ne), ne=1,max_obc)          /'test_obc', mobcm1*'none'/
  data (fieldname_eta(ne), ne=1,max_obc) /'eta_t', mobcm1*'none'/
  data (filename_eta(ne), ne=1,max_obc)  /'obc_eta_t.nc', mobcm1*'none'/
  data (filename_ud(ne), ne=1,max_obc)  /'obc_ud.nc', mobcm1*'none'/
  data (fieldname_ud(ne), ne=1,max_obc) /'ud', mobcm1*'none'/  
  data ((fieldname_tracer(ne,te),  ne=1, max_obc), te=1, max_prog_tracers) &
           /tobc*'none'/
  data ((filename_tracer(ne,te),   ne=1, max_obc), te=1, max_prog_tracers) &
           /tobc*'none'/

  namelist /ocean_obc_nml/ nobc, direction, name, &
                           is, ie, js, je, &
                           iers, iere, jers, jere, &     
                           itrs, itre, jtrs, jtre, &    
                           obc_nor, obc_tan, obc_eta, obc_ud, obc_tra, &
                           obc_mix, rel_coef_eta_in, rel_coef_eta_out, &
                           rel_eta_pnts, rel_clin_pnts,      &
                           ctrop_max, ctrop_min, ctrop_inc, ctrop_smooth, &
                           filename_eta, fieldname_eta, &
                           filename_ud, fieldname_ud, &                           
                           obc_consider_convu, obc_adjust_forcing_bt, &
                           obc_vert_advel_t, obc_vert_advel_u, &
                           obc_enhance_visc_back, obc_enhance_diff_back, &
                           enh_pnts, enh_fac_v, enh_fac_d, &
                           obc_relax_tracer, obc_flow_relax, &
                           obc_consider_sources, obc_tracer_no_inflow, &
                           rel_coef_tracer_in, rel_coef_tracer_out, filename_tracer, fieldname_tracer,   &
                           debug_phase_speed, debug_this_module, obc_damp_newton, damp_factor
  logical              ::  south_west_corner=.false.
  logical              ::  south_east_corner=.false.
  logical              ::  north_west_corner=.false.
  logical              ::  north_east_corner=.false.
  integer              ::  i_sw, j_sw, i_nw, j_nw, i_se, j_se, i_ne, j_ne

  character(len=128)   :: version = '$ID$'
  character (len=128)  :: tagname = '$Name: tikal $'
  logical              :: module_is_initialized = .FALSE.
  real, allocatable    :: wrk2(:)         ! needed for enhanced diffusion
  real, allocatable    :: wrk3(:)         ! needed for enhanced diffusion
  real, allocatable    :: eta_tend_obc(:,:), rel_coef(:,:)   
  real, allocatable, dimension (:,:)        :: t_mask, u_mask, ht_bt
  real, allocatable, dimension (:,:),target :: dxu_bt, dyu_bt
  real, allocatable, dimension (:,:),target :: eta_t_tm1, eta_tm1
  real, allocatable, dimension (:,:)        :: ctrop      ! needed for restart of phase speed

contains

  !#######################################################################
  !  <SUBROUTINE NAME="ocean_obc_barotrop_init" >
  !   <DESCRIPTION>
  !      Allocates space and initializes a derived-type variable that 
  !      contains domain decompostion and grid information.
  !   </DESCRIPTION>
  !   <IN NAME="dtts, dtuv, dtbt, dteta" TYPE="real"></IN>
  !    time step.
  !   <IN NAME="Domain" TYPE="type(ocean_domain_type)" >
  !      A derived data type that contains domain information for MOM.
  !   </IN>
  !   <IN NAME="Grid" TYPE="type(ocean_grid_type)" >
  !      A derived data type that contains grid information for MOM.
  !   </IN>
  !   <INOUT NAME="have_obc" TYPE="logical" >
  !      logical variable to indicate if there is any open boundary condition. 
  !      if true, open boudanry exists. 
  !   </INOUT>
  !<PUBLICROUTINE>
  subroutine ocean_obc_barotrop_init(have_obc, Time, Time_steps, Domain, Grid, Ocean_options,   &
                           use_legacy_barotropic_halos, debug)
  !</PUBLICROUTINE>

    logical, intent(inout)                       :: have_obc
    type(ocean_time_type), intent(in)            :: Time
    type(ocean_time_steps_type), intent(in)      :: Time_steps
    type (ocean_domain_type),intent(in),  target :: Domain
    type(ocean_grid_type), intent(in), target    :: Grid
    type(ocean_options_type), intent(inout)      :: Ocean_options
    logical, intent(in), optional                :: debug
    logical, intent(in)                          :: use_legacy_barotropic_halos
    !--- some local variables ------------------------------------------
    integer :: m, n, i, j, unit, io_status, ierr, ioff, joff
    integer :: il, iu, jl, ju
    integer :: ni, nj, nsize
    integer :: west_at_pe, south_at_pe, east_at_pe, north_at_pe
    integer :: irig_s, ilef_s , jbou_s
    integer :: irig_n, ilef_n , jbou_n
    integer :: jlow_w, jup_w, ibou_w
    integer :: jlow_e, jup_e, ibou_e
    integer :: npes, pe, nlist, list, ntotal, sindex, eindex
    integer :: fld_size(4)

    !--- some local variables ------------------------------------------
    integer, allocatable :: isl(:), iel(:), jsl(:), jel(:), istart(:), iend(:), pelist(:)
    logical, allocatable :: on_bound(:)
    character*128        :: file_name
    character(len=5)     :: pe_name
    
    integer :: stdoutunit,stdlogunit
    stdoutunit=stdout();stdlogunit=stdlog()    

    if ( module_is_initialized ) then 
       call mpp_error(FATAL, '==>Error in ocean_obc_barotrop_mod (ocean_obc_barotrop_init): module already initialized')
    endif

    module_is_initialized = .TRUE.

    Dom => Domain
    Grd => Grid
    call mpp_get_global_domain(Domain%Domain2d, isg, ieg, jsg, jeg)

    if (PRESENT(debug)) debug_this_module = debug

    id_obc  = mpp_clock_id('(Ocean open boundaries) ',grain=CLOCK_MODULE)
    

    !--- read namelist and write out namelist --------------------------
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_obc_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_obc_nml')
#else
    unit = open_namelist_file()
    read  (unit, ocean_obc_nml,iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_obc_nml')
    call close_file (unit)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit, ocean_obc_nml)
    write (stdlogunit, ocean_obc_nml)

    !--- if there is no open boundary, just return
    Obc%nobc = nobc
    if(Obc%nobc == 0) then
       Ocean_options%OBC = 'Did NOT use any open/radiating boundary conditions.'
       return
    endif
    have_obc = .true.
    Ocean_options%OBC = 'Used open/radiating boundary conditions.'

    call mpp_clock_begin(id_obc)
! This is the boundary specific io_unit, which will be defined only for 
! tasks with points at boundary m. Initialize with stdoutunit. All tasks with
! no OBC write (if they do) to stdout.  
    allocate(obc_out_unit(nobc))
    obc_out_unit(:) = stdoutunit
    !--- number of boundaries should not be over the max_obc
    if(nobc .gt. max_obc) call mpp_error(FATAL,'==>Error in ocean_obc_barotrop_mod: nml nobc is greater than maximum'// &
         ' allowed bounds max_obc. Modify nobc or increase "max_obc" at top of ocean_obc_barotrop_mod' )

    !--- cyclic condition and open boundary condition along zonal direction 
    !--- these two boundary conditions cannot exist at the same place 
    do m = 1, nobc
       if((trim(direction(m)) == 'west' .or. trim(direction(m)) == 'east')  .and. Grid%cyclic_x) &
            call mpp_error(FATAL, "==>Error in ocean_obc_barotrop_mod: when west or east boundary is open, "//&
                        "cyclic condition in i-direction cannot exist")
       if((trim(direction(m)) == 'south' .or. trim(direction(m)) == 'north')  .and. Grid%cyclic_y) &
            call mpp_error(FATAL, "==>Error in ocean_obc_barotrop_mod: when south or north boundary is open, "//&
                        "cyclic condition in j-direction cannot exist")
    enddo

    !--- get the domain decomposition -----------------------------------
    npes = mpp_npes()
    allocate(isl(0:npes-1), iel(0:npes-1), jsl(0:npes-1), jel(0:npes-1) )
    call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)

    call mpp_get_compute_domains(Domain%domain2d, xbegin=isl, xend=iel, ybegin=jsl, yend=jel)
    call get_domain_offsets(Domain, ioff, joff)
    do m = 1, nobc
       is(m) = is(m) - ioff
       ie(m) = ie(m) - ioff
       js(m) = js(m) - joff
       je(m) = je(m) - joff
    enddo

    !--- get time step -------------------------------------------------
    dtts    = Time_steps%dtts
    dtuv    = Time_steps%dtuv
    dtbt    = Time_steps%dtbt
    dteta   = Time_steps%dteta
    dtime_t = Time_steps%dtime_t
    dtime_e = Time_steps%dtime_e
    tendency= Time_steps%tendency

    ! number of vertical grid points 
    nk      = size(Grid%zw)
    allocate(wrk2(1:nk))
    allocate(wrk3(1:nk))

!kk Get data on _bt domain    
    allocate (t_mask(isd:ied,jsd:jed))
    allocate (u_mask(isd:ied,jsd:jed))
    allocate (dxu_bt(isd:ied,jsd:jed))
    allocate (dyu_bt(isd:ied,jsd:jed))
    allocate (ht_bt(isd:ied,jsd:jed))
    t_mask     = 0.0
    u_mask     = 0.0
    dxu_bt     = 0.0
    dyu_bt     = 0.0
    ht_bt      = 0.0
    il = lbound(Grd%tmask,1)
    jl = lbound(Grd%tmask,2)
    iu = ubound(Grd%tmask,1)
    ju = ubound(Grd%tmask,2)
    t_mask(il:iu,jl:ju)   = Grd%tmask(:,:,1)
    u_mask(il:iu,jl:ju)   = Grd%umask(:,:,1)
    dxu_bt(il:iu,jl:ju)   = Grd%dxu(:,:)
    dyu_bt(il:iu,jl:ju)   = Grd%dyu(:,:)
    ht_bt (il:iu,jl:ju)   = Grd%ht(:,:)
    call mpp_update_domains(t_mask,   Dom%domain2d)
    call mpp_update_domains(u_mask,   Dom%domain2d)
    call mpp_update_domains(dxu_bt,   Dom%domain2d)
    call mpp_update_domains(dyu_bt,   Dom%domain2d)
    call mpp_update_domains(ht_bt,    Dom%domain2d)

    if(ied-isd+1 /= size(t_mask,1) .or. jed-jsd+1 /= size(t_mask,2)) then
       write (0,'(a,7i6)') 'illegal mask size ',ied,isd,size(t_mask,1), jed,jsd,size(t_mask,2),mpp_pe()
       call mpp_error(FATAL,trim(errorstring)//'illegal mask size')
    end if

    !--- Initialize Obc data type --------------------------------------
    allocate(Obc%bound (nobc))
    allocate(obc_eta_domain(nobc))
    allocate(obc_diag_domain(nobc))
    do m = 1, nobc
       call mpp_define_domains( (/1,Grid%ni,1,Grid%nj/), Dom%layout &
                               , obc_eta_domain(m), maskmap=Dom%maskmap)
       call mpp_define_domains( (/1,Grid%ni,1,Grid%nj/), Dom%layout &
                               , obc_diag_domain(m), maskmap=Dom%maskmap ) 
    enddo

    Obc%bound%is = -999; Obc%bound%ie = -1000    ! dummy number to indicate not on the boundary
    Obc%bound%js = -999; Obc%bound%je = -1000
    Obc%bound%on_bound = .FALSE.
    Obc%bound%report   = .FALSE.
    Obc%bound%obc_relax_eta = .false.
    Obc%bound%obc_relax_eta_profile = .false.

    allocate(istart(0:npes-1), iend(0:npes-1), on_bound(0:npes-1) )
    allocate(pelist(0:npes-1) )
    call mpp_get_current_pelist(pelist)

    write(pe_name,'(a,i4.4)' )'.', mpp_pe()   

    do m = 1, nobc
       Obc%bound(m)%name                  = trim(name(m))

       select case(trim(direction(m)))
       case('west')
          Obc%bound(m)%direction = WEST
       case('east')
          Obc%bound(m)%direction = EAST
       case('south')
          Obc%bound(m)%direction = SOUTH
       case('north')
          Obc%bound(m)%direction = NORTH
       case default
          call mpp_error(FATAL,'each element of nml direction should be west, east, south or north')
       end select

       ! Set the normal OBC
       select case(trim(obc_nor(m)))
       case('NOTHIN')
          Obc%bound(m)%bcond_nor = NOTHIN
       case('CLAMPD')
          Obc%bound(m)%bcond_nor = CLAMPD
       case('NOGRAD')
          Obc%bound(m)%bcond_nor = NOGRAD
       case('INGRAD')
          Obc%bound(m)%bcond_nor = INGRAD
       case('LINEAR')
          Obc%bound(m)%bcond_nor = LINEAR
       case default
          call mpp_error(FATAL,'each element of nml obc_nor should be NOTHIN, CLAMPD, NOGRAD, INGRAD or LINEAR')
       end select

       ! Set the normal barotropic velocity OBC
       Obc%bound(m)%obc_ud_active = .false.
       Obc%bound(m)%bcond_ud = 0
       if (index(trim(obc_ud(m)),'NOTHIN') /= 0) &
            Obc%bound(m)%bcond_ud = Obc%bound(m)%bcond_ud + NOTHIN
       if (index(trim(obc_ud(m)),'FLATHR') /= 0) then
          Obc%bound(m)%bcond_ud = Obc%bound(m)%bcond_ud + FLATHR + NOGRAD
          Obc%bound(m)%obc_ud_active = .true.
       endif
       if (index(trim(obc_ud(m)),'FILEIN') /= 0) then
          Obc%bound(m)%bcond_ud = Obc%bound(m)%bcond_ud + FILEIN
          Obc%bound(m)%obc_ud_active = .true.
       endif
       if (Obc%bound(m)%bcond_ud .eq. 0) then
          select case(trim(obc_ud(m)))
          case('CLAMPD')
             Obc%bound(m)%bcond_ud = CLAMPD
          case('NOGRAD')
             Obc%bound(m)%bcond_ud = NOGRAD
          case('INGRAD')
             Obc%bound(m)%bcond_ud = INGRAD
          case('LINEAR')
             Obc%bound(m)%bcond_ud = LINEAR
          case default
             Obc%bound(m)%bcond_ud = Obc%bound(m)%bcond_nor
          end select
       endif
       if(Obc%bound(m)%bcond_ud == 0) &
            call mpp_error(FATAL,' Invalid barotropic velocity OBC for boundary '//trim(Obc%bound(m)%name))

       ! Set the tangential OBC
       select case(trim(obc_tan(m)))
       case('NOTHIN')
          Obc%bound(m)%bcond_tan = NOTHIN
       case('CLAMPD')
          Obc%bound(m)%bcond_tan = CLAMPD
       case('NOGRAD')
          Obc%bound(m)%bcond_tan = NOGRAD
       case('INGRAD')
          Obc%bound(m)%bcond_tan = INGRAD
       case('LINEAR')
          Obc%bound(m)%bcond_tan = LINEAR
       case default
          call mpp_error(FATAL,'each element of nml obc_tan should be NOTHIN, CLAMPD, NOGRAD, INGRAD or LINEAR')
       end select

       ! Set the eta OBC
       Obc%bound(m)%bcond_eta = 0
       if (index(trim(obc_eta(m)),'NOTHIN') /= 0) &
            Obc%bound(m)%bcond_eta = Obc%bound(m)%bcond_eta + NOTHIN
       if (index(trim(obc_eta(m)),'FILEIN') /= 0) then
            Obc%bound(m)%bcond_eta = Obc%bound(m)%bcond_eta + FILEIN
            Obc%bound(m)%obc_relax_eta = .true.
            Obc%bound(m)%obc_relax_eta_profile = .true.
       endif
       if (index(trim(obc_eta(m)),'MEANIN') /= 0) then
            Obc%bound(m)%bcond_eta = Obc%bound(m)%bcond_eta + MEANIN
            Obc%bound(m)%obc_relax_eta = .true.
       endif
       if (index(trim(obc_eta(m)),'FLATHR') /= 0) then
          Obc%bound(m)%obc_relax_eta = .true.
          Obc%bound(m)%obc_relax_eta_profile = .true.
       endif
       if (index(trim(obc_eta(m)),'NOGRAD') /= 0) &
            Obc%bound(m)%bcond_eta = Obc%bound(m)%bcond_eta + NOGRAD
       if (index(trim(obc_eta(m)),'ORLANS') /= 0) &
            Obc%bound(m)%bcond_eta = Obc%bound(m)%bcond_eta + ORLANS
       if (index(trim(obc_eta(m)),'CAMOBR') /= 0) &
            Obc%bound(m)%bcond_eta = Obc%bound(m)%bcond_eta + CAMOBR
       if (index(trim(obc_eta(m)),'GRAVTY') /= 0 ) &
            Obc%bound(m)%bcond_eta = Obc%bound(m)%bcond_eta + GRAVTY
       if (index(trim(obc_eta(m)),'MILLER') /= 0 ) &
            Obc%bound(m)%bcond_eta = Obc%bound(m)%bcond_eta + MILLER
       if (index(trim(obc_eta(m)),'IOW') /= 0) &
            Obc%bound(m)%bcond_eta = Obc%bound(m)%bcond_eta + IOW
       if (index(trim(obc_eta(m)),'RAYMND') /= 0) &
            Obc%bound(m)%bcond_eta = Obc%bound(m)%bcond_eta + RAYMND
       call check_eta_OBC(Obc%bound(m)%bcond_eta, obc_eta(m))
       if (index(trim(obc_eta(m)),'RAYMND') /= 0) then
         if (.not.use_legacy_barotropic_halos) call mpp_error(FATAL,' barotropic OBC method RAYMND ' &
              //'does not work without use_legacy_barotropic_halos')
       endif
       

       ! Set the surface height OBC : this is currently always set to NOTHIN
       Obc%bound(m)%bcond_eta_t = 0
       if (index(trim(obc_height(m)),'NOTHIN') /= 0) &
            Obc%bound(m)%bcond_eta_t = Obc%bound(m)%bcond_eta_t + NOTHIN
       if (index(trim(obc_height(m)),'ORLANS') /= 0) &
            Obc%bound(m)%bcond_eta_t = Obc%bound(m)%bcond_eta_t + ORLANS
       if (index(trim(obc_height(m)),'CAMOBR') /= 0) &
            Obc%bound(m)%bcond_eta_t = Obc%bound(m)%bcond_eta_t + CAMOBR
       if (index(trim(obc_height(m)),'GRAVTY') /= 0 ) &
            Obc%bound(m)%bcond_eta_t = Obc%bound(m)%bcond_eta_t + GRAVTY
       if (index(trim(obc_height(m)),'MILLER') /= 0 ) &
            Obc%bound(m)%bcond_eta_t = Obc%bound(m)%bcond_eta_t + MILLER
       if (index(trim(obc_height(m)),'IOW') /= 0) &
            Obc%bound(m)%bcond_eta_t = Obc%bound(m)%bcond_eta_t + IOW
       if (index(trim(obc_height(m)),'RAYMND') /= 0) &
            Obc%bound(m)%bcond_eta_t = Obc%bound(m)%bcond_eta_t + RAYMND
       if(Obc%bound(m)%bcond_eta_t == 0) &
            call mpp_error(FATAL,' Invalid height OBC for boundary '//trim(Obc%bound(m)%name))

       Obc%bound(m)%ctrop_max             = ctrop_max(m)
       Obc%bound(m)%ctrop_min             = ctrop_min(m)
       Obc%bound(m)%ctrop_inc             = ctrop_inc(m)
       Obc%bound(m)%ctrop_smooth          = ctrop_smooth(m)
       Obc%bound(m)%enh_fac_v             = enh_fac_v(m)
       Obc%bound(m)%enh_fac_d             = enh_fac_d(m)
       Obc%bound(m)%obc_consider_convu    = obc_consider_convu(m)
       Obc%bound(m)%obc_damp_newton       = obc_damp_newton(m)
       Obc%bound(m)%damp_factor           = damp_factor(m)
       
       if (Obc%bound(m)%ctrop_max .lt. Obc%bound(m)%ctrop_min) then
         call mpp_error(FATAL,' ctrop_max <  ctrop_min for open boundary '//trim(Obc%bound(m)%name))
       endif

       if(Obc%bound(m)%direction == WEST .or. Obc%bound(m)%direction == EAST) then
          !--- define mask to indicate if it is open or not.
          allocate(Obc%bound(m)%mask(jsd:jed))
          Obc%bound(m)%mask = .FALSE.
          if (is(m) .ge. isc .and. is(m) .le. iec) then
             do j = jsd, jed             
                if(j .ge. js(m) .and. j .le. je(m)) then 
                   Obc%bound(m)%mask(j) = .TRUE.
                endif   
             enddo
             do j = jsc, jec                 !kk changed from data to compute domain
                if(j .ge. js(m) .and. j .le. je(m)) then 
                   Obc%bound(m)%on_bound = .true.
                endif   
             enddo
             if(Obc%bound(m)%on_bound) then
!--- only the southernmost PE writes a report on the configuration
!___ if debugging is switched on each PE reports
                if (js(m) .ge. jsc .and. js(m) .le. jec) Obc%bound(m)%report = .true.
!--- open obc.out file to be ready for writing.
                if (debug_this_module .or. Obc%bound(m)%report) &
                     call mpp_open( obc_out_unit(m), 'obc_b_'//trim(Obc%bound(m)%name)//'.out', &
                                  action=MPP_OVERWR, threading=MPP_MULTI,                     &
                                  fileset=MPP_MULTI, nohdrs=.TRUE. )  
                Obc%bound(m)%is       = is(m)
                Obc%bound(m)%ie       = ie(m)
                Obc%bound(m)%js       = max(js(m),jsc)
                Obc%bound(m)%je       = min(je(m),jec)
                Obc%bound(m)%np       = je(m) - js(m) + 1
                Obc%bound(m)%isd      = Obc%bound(m)%is
                Obc%bound(m)%ied      = Obc%bound(m)%ie
                Obc%bound(m)%jsd      = Obc%bound(m)%js
                Obc%bound(m)%jed      = Obc%bound(m)%je
                Obc%bound(m)%isg      = is(m)
                Obc%bound(m)%ieg      = ie(m)
                Obc%bound(m)%jsg      = js(m)
                Obc%bound(m)%jeg      = je(m)
! Extend the data limit of OBC if the compute limit is at compute domain limit
                if(Obc%bound(m)%js > js(m) ) Obc%bound(m)%jsd = max(js(m),jsd)
                if(Obc%bound(m)%je < je(m) ) Obc%bound(m)%jed = min(je(m),jed)

                   if (debug_this_module .or. Obc%bound(m)%report) &
                write(obc_out_unit(m),'(a,10i6)') 'After Open ',mpp_pe(), &
                   is(m),ie(m),Obc%bound(m)%js,Obc%bound(m)%je,Obc%bound(m)%np,Obc%bound(m)%jsd,Obc%bound(m)%jed,jsd,jed

                allocate(Obc%bound(m)%pgrad(Obc%bound(m)%js:Obc%bound(m)%je))
! I no global domain information for reading boundary data arespecified in the 
! namelist assume, that the data fit exactly at the boundary
                if (iers(m) == -999) then 
                  Obc%bound(m)%iers = is(m) 
                else 
                  Obc%bound(m)%iers = iers(m) 
                endif
                if (iere(m) == -999) then 
                  Obc%bound(m)%iere = ie(m) 
                else 
                  Obc%bound(m)%iere = iere(m) 
                endif 
                if (jers(m) == -999) then 
                  Obc%bound(m)%jers = js(m) 
                else 
                  Obc%bound(m)%jers = jers(m) 
                endif 
                if (jere(m) == -999) then 
                  Obc%bound(m)%jere = je(m) 
                else 
                  Obc%bound(m)%jere = jere(m) 
                endif 
                if (Obc%bound(m)%jers > js(m)) &
                  call mpp_error(FATAL, "ocean_obc_barotrop_mod: start of eta data > start of boundary")
                if (Obc%bound(m)%jere < je(m)) &
                  call mpp_error(FATAL, "ocean_obc_barotrop_mod: end of eta data < end of boundary")
             endif
          end if
          !--- loop over pelist to figure out the boundary index on each pe.       
          on_bound = .false.
          do pe = 0, npes-1
             if (is(m) .ge. isl(pe) .and. is(m) .le. iel(pe)) then
                istart(pe) = max(js(m),jsl(pe)); iend(pe) = min(je(m),jel(pe))
                if(iend(pe) .GE. istart(pe) ) then
                   on_bound(pe) = .true.
                   if (debug_this_module .or. Obc%bound(m)%report) then
                      write(obc_out_unit(m),'(a,11i5)') &
                       'PE_1 ',pe,is(m),isl(pe),is(m),iel(pe),istart(pe),iend(pe),js(m),jsl(pe),je(m),jel(pe)
                   end if
                end if
             end if
          end do
          nlist = count(on_bound)
          allocate( Obc%bound(m)%start(nlist), obc%bound(m)%end(nlist)    )
          allocate( Obc%bound(m)%pelist(nlist) )
          list = 0
          ntotal = 0
          Obc%bound(m)%index = -1
          sindex = 100000; eindex = -100000
          do n = 0, npes-1
             if(on_bound(n)) then
                list = list+1
                Obc%bound(m)%pelist(list) = pelist(n)
                if(Obc%bound(m)%on_bound) then
                   Obc%bound(m)%start(list)  = istart(n)
                   Obc%bound(m)%end(list)    = iend(n)
                   sindex                    = min(sindex, istart(n))
                   eindex                    = max(eindex, iend(n))
                   ntotal                    = ntotal + iend(n) - istart(n) + 1
                   if( mpp_pe() == pelist(n)) then
                     Obc%bound(m)%index = list
                        if (debug_this_module .or. Obc%bound(m)%report) &
                     write(obc_out_unit(m),'(a,9i6)') &
                       'PE_2 ',n,list,Obc%bound(m)%start(list),Obc%bound(m)%end(list),sindex,eindex,ntotal,pelist(n),mpp_pe()
                   end if
                end if
             end if
          end do
          if(Obc%bound(m)%on_bound) then
             if(Obc%bound(m)%index == -1) then
                  call mpp_error(FATAL, &
                  "ocean_obc_barotrop_mod: This PE must be on this boundary and index should not be -1")
             end if
             if(Obc%bound(m)%js .NE. Obc%bound(m)%start(Obc%bound(m)%index) .OR. &
                  Obc%bound(m)%je .NE. Obc%bound(m)%end(Obc%bound(m)%index) ) &
                  call mpp_error(FATAL, "ocean_obc_barotrop_mod: inconsistency for the index setup")
             if(eindex-sindex+1 .NE. ntotal .OR. Obc%bound(m)%np .NE. ntotal) &
                    call mpp_error(FATAL, "ocean_obc_barotrop_mod: size mismatch 1")
             allocate(Obc%bound(m)%buffer(sindex:eindex) )
          end if
       else    ! north or south direction
          allocate(Obc%bound(m)%mask(isd:ied))
          Obc%bound(m)%mask = .FALSE.
          if(js(m) .le. jec .and. js(m) .ge. jsc) then
             do i = isd, ied
                if(i .ge. is(m) .and. i .le. ie(m)) then 
                   Obc%bound(m)%mask(i) = .TRUE.
                endif
             enddo
             do i = isc, iec                    !kk changed from data to compute domain
                if(i .ge. is(m) .and. i .le. ie(m)) then 
                   Obc%bound(m)%on_bound = .true.
                endif
             enddo
             if(Obc%bound(m)%on_bound) then
!--- open obc.out file to be ready for writing.
!--- only the southernmost PE writes a report on the configuration
!___ if debugging is switched on each PE reports
                if (is(m) .ge. isc .and. is(m) .le. iec) Obc%bound(m)%report = .true.
!--- open obc.out file to be ready for writing.
                if (debug_this_module .or. Obc%bound(m)%report) &
                    call mpp_open( obc_out_unit(m), 'obc_b_'//trim(Obc%bound(m)%name)//'.out', &
                                   action=MPP_OVERWR, threading=MPP_MULTI,                     &
                                   fileset=MPP_MULTI, nohdrs=.TRUE. )  
                Obc%bound(m)%js       = js(m)
                Obc%bound(m)%je       = je(m)
                Obc%bound(m)%is       = max(is(m),isc)
                Obc%bound(m)%ie       = min(ie(m),iec)
                Obc%bound(m)%np       = ie(m) - is(m) + 1
                Obc%bound(m)%isd      = Obc%bound(m)%is
                Obc%bound(m)%ied      = Obc%bound(m)%ie
                Obc%bound(m)%jsd      = Obc%bound(m)%js
                Obc%bound(m)%jed      = Obc%bound(m)%je
                Obc%bound(m)%isg      = is(m)
                Obc%bound(m)%ieg      = ie(m)
                Obc%bound(m)%jsg      = js(m)
                Obc%bound(m)%jeg      = je(m)
                if(Obc%bound(m)%is > is(m) ) Obc%bound(m)%isd = max(is(m),isd)
                if(Obc%bound(m)%ie < ie(m) ) Obc%bound(m)%ied = min(ie(m),ied)

                write(obc_out_unit(m),'(a,10i6)') 'After Open_i ',mpp_pe(), &
                   Obc%bound(m)%is,Obc%bound(m)%ie,js(m),je(m),Obc%bound(m)%np,Obc%bound(m)%isd,Obc%bound(m)%ied,isd,ied

                allocate(Obc%bound(m)%pgrad(Obc%bound(m)%is:Obc%bound(m)%ie))

! I no global domain information for reading boundary data arespecified in the 
! namelist assume, that the data fit exactly at the boundary
                if (iers(m) == -999) then 
                  Obc%bound(m)%iers = is(m) 
                else 
                  Obc%bound(m)%iers = iers(m) 
                endif
                if (iere(m) == -999) then 
                  Obc%bound(m)%iere = ie(m) 
                else 
                  Obc%bound(m)%iere = iere(m) 
                endif 
                if (jers(m) == -999) then 
                  Obc%bound(m)%jers = js(m) 
                else 
                  Obc%bound(m)%jers = jers(m) 
                endif 
                if (jere(m) == -999) then 
                  Obc%bound(m)%jere = je(m) 
                else 
                  Obc%bound(m)%jere = jere(m) 
                endif 
                if (Obc%bound(m)%iers > is(m)) &
                  call mpp_error(FATAL, "ocean_obc_barotrop_mod: start of eta data > start of boundary")
                if (Obc%bound(m)%iere < ie(m)) &
                  call mpp_error(FATAL, "ocean_obc_barotrop_mod: end of eta data < end of boundary")
             endif
          endif

          !--- loop over pelist to figure out the boundary index on each pe.       
          on_bound = .false.
          do pe = 0, npes-1
             if (js(m) .ge. jsl(pe) .and. js(m) .le. jel(pe)) then
                istart(pe) = max(is(m),isl(pe)); iend(pe)  = min(ie(m),iel(pe))
                if(iend(pe) .GE. istart(pe) ) on_bound(pe)    = .true.
             end if
          end do
          nlist = count(on_bound)
          allocate( Obc%bound(m)%start(nlist), obc%bound(m)%end(nlist)    )
          allocate( Obc%bound(m)%pelist(nlist) )
          list = 0
          ntotal = 0
          Obc%bound(m)%index = -1
          sindex = 100000; eindex = -100000
          do n = 0, npes-1
             if(on_bound(n)) then
                list = list+1
                Obc%bound(m)%pelist(list)  = pelist(n)
                if(Obc%bound(m)%on_bound) then
                   Obc%bound(m)%start(list)  = istart(n)
                   Obc%bound(m)%end(list)    = iend(n)
                   sindex                     = min(sindex, istart(n))
                   eindex                     = max(eindex, iend(n))
                   ntotal                     = ntotal + iend(n) - istart(n) + 1
                   if( mpp_pe() == pelist(n)) Obc%bound(m)%index = list
                end if
             end if
          end do
          if(Obc%bound(m)%on_bound) then
             if(Obc%bound(m)%index > -1 .NEQV. obc%bound(m)%on_bound) call mpp_error(FATAL, &
                  "ocean_obc_barotrop_mod: inconsistency for the obc boundary distribution")
             if(Obc%bound(m)%on_bound ) then
                if(Obc%bound(m)%is .NE. Obc%bound(m)%start(Obc%bound(m)%index) .OR. &
                     Obc%bound(m)%ie .NE. Obc%bound(m)%end(Obc%bound(m)%index) ) &
                     call mpp_error(FATAL, "ocean_obc_barotrop_mod: inconsistency for the index setup")
             end if
             if(eindex-sindex+1 .NE. ntotal .OR. Obc%bound(m)%np .NE. ntotal)  &
                  call mpp_error(FATAL, "ocean_obc_barotrop_mod: size mismatch 2")
             allocate(Obc%bound(m)%buffer(sindex:eindex))
          end if
       endif

! Read data for relaxation into the compute area only        
    enddo
    update_eta_tm1 = .false.
    do m=1, Obc%nobc
      if(iand(Obc%bound(m)%bcond_eta, ORLANS) == ORLANS) update_eta_tm1 =.true.
      if(iand(Obc%bound(m)%bcond_eta, MILLER) == MILLER) update_eta_tm1 =.true.
      if(iand(Obc%bound(m)%bcond_eta, CAMOBR) == CAMOBR) update_eta_tm1 =.true.
      if(iand(Obc%bound(m)%bcond_eta, RAYMND) == RAYMND) update_eta_tm1 =.true.
    enddo
    allocate(ctrop(isd:ied,jsd:jed));  ctrop = 0.
    allocate(eta_tm1(isd:ied,jsd:jed));  eta_tm1 = 0.
    allocate(eta_tend_obc(isd:ied,jsd:jed));  eta_tend_obc = 0.
    allocate(rel_coef    (isd:ied,jsd:jed));  rel_coef     = 0.
    allocate(eta_t_tm1   (isd:ied,jsd:jed));  eta_t_tm1    = 0.0

! Now check for corner points, which are located at two boundaries 
! (south-west, north-west, north-east, south-east)    
! This code needs to be generalised later. Currently, only one
! boundary for each direction is possible. In complex coastal geometry
! this may be to restrictive, but should be sufficient for the beginning ... 
    west_at_pe = 0; south_at_pe= 0; east_at_pe = 0; north_at_pe= 0
    do m = 1, nobc
      if (.not. Obc%bound(m)%on_bound) cycle
      if (Obc%bound(m)%direction == WEST)  west_at_pe  = m
      if (Obc%bound(m)%direction == EAST)  east_at_pe  = m
      if (Obc%bound(m)%direction == NORTH) north_at_pe = m
      if (Obc%bound(m)%direction == SOUTH) south_at_pe = m
    enddo
    if (west_at_pe  * south_at_pe .ne. 0) then
      ilef_s = Obc%bound(south_at_pe)%is
      jbou_s = Obc%bound(south_at_pe)%js
      jlow_w  = Obc%bound(west_at_pe)%js
      ibou_w = Obc%bound(west_at_pe)%is
      if (ilef_s .le. ibou_w .and. jlow_w .le. jbou_s) then 
        ! a southern boundary west of a western is nonsense,
        ! however there may be an overlap 
        south_west_corner = .true.
        i_sw = ibou_w
        j_sw = jbou_s
      endif
    endif 
    if (west_at_pe  * north_at_pe .ne. 0) then
      ilef_n = Obc%bound(north_at_pe)%is
      jbou_n = Obc%bound(north_at_pe)%js
      jup_w  = Obc%bound(west_at_pe)%je
      ibou_w = Obc%bound(west_at_pe)%is
      if (ilef_n .le. ibou_w .and. jup_w .ge. jbou_n) then 
        ! a northern boundary west of a western is nonsense,
        ! however there may be an overlap 
        north_west_corner = .true.
        i_nw = ibou_w
        j_nw = jbou_n
      endif
    endif 
    if (east_at_pe  * north_at_pe .ne. 0) then
      irig_n = Obc%bound(north_at_pe)%ie
      jbou_n = Obc%bound(north_at_pe)%js
      jup_e  = Obc%bound(east_at_pe)%je
      ibou_e = Obc%bound(east_at_pe)%is
      if (irig_n .ge. ibou_e .and. jup_e .ge. jbou_n) then 
        ! a northern boundary east of an eastern is nonsense,
        ! however there may be an overlap 
        north_east_corner = .true.
        i_ne = ibou_e
        j_ne = jbou_n
      endif
    endif 
    if (east_at_pe  * south_at_pe .ne. 0) then
      irig_s = Obc%bound(south_at_pe)%ie
      jbou_s = Obc%bound(south_at_pe)%js
      jlow_e  = Obc%bound(east_at_pe)%js
      ibou_e = Obc%bound(east_at_pe)%is
      if (irig_s .ge. ibou_e .and. jlow_e .le. jbou_s) then 
        ! a southern boundary east of an eastern is nonsense,
        ! however there may be an overlap 
        south_east_corner = .true.
        i_se = ibou_e
        j_se = jbou_s
      endif
    endif 

    !------------------------------------------------------
    !------------------------------------------------------
    ! Get the computational domain boundary index maps
    do m = 1, nobc

      if(.not. Obc%bound(m)%on_bound) cycle

      ! Allocate map memory
      ni = Obc%bound(m)%ie - Obc%bound(m)%is
      nj = Obc%bound(m)%je - Obc%bound(m)%js
      nsize = max(ni, nj) + 1
      allocate(Obc%bound(m)%iloc(nsize))
      allocate(Obc%bound(m)%jloc(nsize))
      Obc%bound(m)%sign = 1.0

      !------------------------------------------------------
      ! Western and eastern boundary maps
      if(Obc%bound(m)%direction .eq. WEST .or. &
        Obc%bound(m)%direction .eq. EAST ) then
        ! Interior mapping indicies
        if(Obc%bound(m)%direction .eq. WEST) then
          Obc%bound(m)%imap = 1
          Obc%bound(m)%jmap = 0
        else
          Obc%bound(m)%imap = -1
          Obc%bound(m)%jmap = 0
          Obc%bound(m)%sign = -1.0
        endif
        ! Tangential mapping indicies
        Obc%bound(m)%imapt = 0
        Obc%bound(m)%jmapt = 1

        Obc%bound(m)%nsc = jsc
        Obc%bound(m)%nec = jec

        n = 1
        i =  Obc%bound(m)%is
        allocate(Obc%bound(m)%oi1(nsize))
        allocate(Obc%bound(m)%oi2(nsize))
        allocate(Obc%bound(m)%work(Obc%bound(m)%js:Obc%bound(m)%je))
        if(i .ne. Obc%bound(m)%ie) &
          write(obc_out_unit(m),*) &
           'WARNING : Start and end i locations differ for WEST or EAST obc. is=',i,' : ie=',Obc%bound(m)%ie
        do j = Obc%bound(m)%js, Obc%bound(m)%je
          Obc%bound(m)%iloc(n) = i
          Obc%bound(m)%jloc(n) = j
          Obc%bound(m)%oi1(n) = i + Obc%bound(m)%imap
          Obc%bound(m)%oi2(n) = i + 2 * Obc%bound(m)%imap
          n = n + 1
        enddo
        Obc%bound(m)%nloc = n - 1
        ! Set pointers
        Obc%bound(m)%nic => Obc%bound(m)%iloc
        Obc%bound(m)%tic => Obc%bound(m)%jloc
        Obc%bound(m)%oj1 => Obc%bound(m)%jloc
        Obc%bound(m)%oj2 => Obc%bound(m)%jloc
        Obc%bound(m)%icf => Obc%bound(m)%iloc
        if(Obc%bound(m)%direction==EAST) Obc%bound(m)%icf => Obc%bound(m)%oi1
        Obc%bound(m)%jcf => Obc%bound(m)%jloc
      endif

      !------------------------------------------------------
      ! Northern and southern boundaries
      if(Obc%bound(m)%direction .eq. NORTH .or. &
        Obc%bound(m)%direction .eq. SOUTH ) then
        ! Interior mapping indicies
        if(Obc%bound(m)%direction .eq. SOUTH) then
          Obc%bound(m)%imap = 0
          Obc%bound(m)%jmap = 1
        else
          Obc%bound(m)%imap = 0
          Obc%bound(m)%jmap = -1
          Obc%bound(m)%sign = -1.0
        endif
        ! Tangential mapping indicies
        Obc%bound(m)%imapt = 1
        Obc%bound(m)%jmapt = 0

        Obc%bound(m)%nsc = isc
        Obc%bound(m)%nec = iec

        ! Boundary index maps
        n = 1
        j =  Obc%bound(m)%js
        allocate(Obc%bound(m)%oj1(nsize))
        allocate(Obc%bound(m)%oj2(nsize))
        allocate(Obc%bound(m)%work(Obc%bound(m)%is:Obc%bound(m)%ie))
        if(j .ne. Obc%bound(m)%je) &
          write(obc_out_unit(m),*)        &
             'WARNING : Boundary',n,' start and end j locations differ for NORTH or SOUTH obc. js=' &
             ,j,' : je=',Obc%bound(m)%je
        do i = Obc%bound(m)%is, Obc%bound(m)%ie
          Obc%bound(m)%iloc(n) = i
          Obc%bound(m)%jloc(n) = j
          Obc%bound(m)%oj1(n) = j + Obc%bound(m)%jmap
          Obc%bound(m)%oj2(n) = j + 2 * Obc%bound(m)%jmap
          n = n + 1
        enddo
        Obc%bound(m)%nloc = n - 1
        ! Set pointers
        Obc%bound(m)%nic => Obc%bound(m)%jloc
        Obc%bound(m)%tic => Obc%bound(m)%iloc
        Obc%bound(m)%oi1 => Obc%bound(m)%iloc
        Obc%bound(m)%oi2 => Obc%bound(m)%iloc
        Obc%bound(m)%icf => Obc%bound(m)%iloc
        Obc%bound(m)%jcf => Obc%bound(m)%jloc
        if(Obc%bound(m)%direction==NORTH) Obc%bound(m)%jcf => Obc%bound(m)%oj1
        n = 1
      endif

!Needed for advection of tracers
      allocate(Obc%bound(m)%work2(Obc%bound(m)%is:Obc%bound(m)%ie,Obc%bound(m)%js:Obc%bound(m)%je,nk))

    enddo

    !------------------------------------------------------
    !------------------------------------------------------
    ! Get the data domain boundary index maps
    do m = 1, nobc

      if(.not. Obc%bound(m)%on_bound) cycle

      ! Allocate map memory
      ni = Obc%bound(m)%ied - Obc%bound(m)%isd
      nj = Obc%bound(m)%jed - Obc%bound(m)%jsd
      nsize = max(ni, nj) + 1
      allocate(Obc%bound(m)%ilod(nsize))
      allocate(Obc%bound(m)%jlod(nsize))
      allocate(Obc%bound(m)%dsur(nsize))
      allocate(Obc%bound(m)%dum (nsize))
      allocate(Obc%bound(m)%ones_bt(nsize))
      obc%bound(m)%ones_bt = 1

      !------------------------------------------------------
      ! Western and eastern boundary maps
      if(Obc%bound(m)%direction .eq. WEST .or. &
        Obc%bound(m)%direction .eq. EAST ) then

        Obc%bound(m)%nsd = jsd
        Obc%bound(m)%ned = jed
        n = 1
        i =  Obc%bound(m)%isd
        allocate(Obc%bound(m)%di1(nsize))
        allocate(Obc%bound(m)%di2(nsize))
        allocate(Obc%bound(m)%istr(nsize))
        allocate(Obc%bound(m)%iend(nsize))
        allocate(Obc%bound(m)%ico_bt(nsize))

        if(i .ne. Obc%bound(m)%ied) &
          write(obc_out_unit(m),*) 'WARNING : Start and end i data locations differ for WEST or EAST obc.'
        do j = Obc%bound(m)%jsd, Obc%bound(m)%jed
          Obc%bound(m)%ilod(n) = i
          Obc%bound(m)%jlod(n) = j
          Obc%bound(m)%di1(n) = i + Obc%bound(m)%imap
          Obc%bound(m)%di2(n) = i + 2 * Obc%bound(m)%imap
          if(Obc%bound(m)%direction==WEST) then
             Obc%bound(m)%istr(n) = max(isd,i-2)
             Obc%bound(m)%iend(n) = i - Obc%bound(m)%imap
          else
             Obc%bound(m)%istr(n) = i - Obc%bound(m)%imap
             Obc%bound(m)%iend(n) = min(ied,i+2)
          endif
!kk
          if(Obc%bound(m)%direction==WEST) then
             Obc%bound(m)%ico_bt(n) = i - Obc%bound(m)%imap
          else
             Obc%bound(m)%ico_bt(n) = i
          endif

!kk       csurf on data domain
          if(ht_bt(i,j) <= 0) then
            write(6,*) 'ht_bt(i,j) <= 0 W-O ',mpp_pe(),i,j,ht_bt(i,j)
          else
            Obc%bound(m)%dsur(n)  = sqrt(grav*ht_bt(i,j))
          end if
          n = n + 1
        enddo
        Obc%bound(m)%nlod = n - 1
        ! Set pointers
        Obc%bound(m)%nid => Obc%bound(m)%ilod
        Obc%bound(m)%tid => Obc%bound(m)%jlod
        Obc%bound(m)%dj1 => Obc%bound(m)%jlod
        Obc%bound(m)%dj2 => Obc%bound(m)%jlod
        Obc%bound(m)%idf => Obc%bound(m)%ilod
        if(Obc%bound(m)%direction==EAST) Obc%bound(m)%idf => Obc%bound(m)%di1
        Obc%bound(m)%jdf => Obc%bound(m)%jlod
        Obc%bound(m)%ido => Obc%bound(m)%ilod
        if(Obc%bound(m)%direction==WEST) Obc%bound(m)%ido => Obc%bound(m)%iend
        Obc%bound(m)%jdo => Obc%bound(m)%jlod
        Obc%bound(m)%jstr => Obc%bound(m)%jlod
        Obc%bound(m)%jend => Obc%bound(m)%jlod
        Obc%bound(m)%d1i_bt => Obc%bound(m)%ones_bt
        Obc%bound(m)%d1j_bt => Obc%bound(m)%jlod
        Obc%bound(m)%jco_bt => Obc%bound(m)%jlod
      endif

      !------------------------------------------------------
      ! Northern and southern boundaries
      if(Obc%bound(m)%direction .eq. NORTH .or. &
        Obc%bound(m)%direction .eq. SOUTH ) then

        Obc%bound(m)%nsd = isd
        Obc%bound(m)%ned = ied
        n = 1
        j =  Obc%bound(m)%jsd
        allocate(Obc%bound(m)%dj1(nsize))
        allocate(Obc%bound(m)%dj2(nsize))
        allocate(Obc%bound(m)%jstr(nsize))
        allocate(Obc%bound(m)%jend(nsize))
        allocate(Obc%bound(m)%jco_bt(nsize))
        if(j .ne. Obc%bound(m)%jed) &
          write(obc_out_unit(m),*) 'WARNING : Start and end j data locations differ for NORTH or SOUTH obc.'
        do i = Obc%bound(m)%isd, Obc%bound(m)%ied
          Obc%bound(m)%ilod(n) = i
          Obc%bound(m)%jlod(n) = j
          Obc%bound(m)%dj1(n) = j + Obc%bound(m)%jmap
          Obc%bound(m)%dj2(n) = j + 2 * Obc%bound(m)%jmap
          if(Obc%bound(m)%direction==SOUTH) then
             Obc%bound(m)%jstr(n) = max(jsd,j-2)
             Obc%bound(m)%jend(n) = j - Obc%bound(m)%jmap
          else
             Obc%bound(m)%jstr(n) = j - Obc%bound(m)%jmap
             Obc%bound(m)%jend(n) = min(jed,j+2)
          endif
!kk
          if(Obc%bound(m)%direction==SOUTH) then
             Obc%bound(m)%jco_bt(n) = j - Obc%bound(m)%jmap
          else
             Obc%bound(m)%jco_bt(n) = j
          endif

!kk       csurv on data domain
          if(ht_bt(i,j) <= 0) then
            write(6,*) 'ht_bt(i,j) <= 0 N-S ',mpp_pe(),i,j,ht_bt(i,j)
          else
            Obc%bound(m)%dsur(n)  = sqrt(grav*ht_bt(i,j))
          end if
          n = n + 1
        enddo
        Obc%bound(m)%nlod = n - 1
        ! Set pointers
        Obc%bound(m)%nid => Obc%bound(m)%jlod
        Obc%bound(m)%tid => Obc%bound(m)%ilod
        Obc%bound(m)%di1 => Obc%bound(m)%ilod
        Obc%bound(m)%di2 => Obc%bound(m)%ilod
        Obc%bound(m)%idf => Obc%bound(m)%ilod
        Obc%bound(m)%jdf => Obc%bound(m)%jlod
        if(Obc%bound(m)%direction==NORTH) Obc%bound(m)%jdf => Obc%bound(m)%dj1
        Obc%bound(m)%ido => Obc%bound(m)%ilod
        Obc%bound(m)%jdo => Obc%bound(m)%jlod
        if(Obc%bound(m)%direction==SOUTH) Obc%bound(m)%jdo => Obc%bound(m)%jend
        Obc%bound(m)%istr => Obc%bound(m)%ilod
        Obc%bound(m)%iend => Obc%bound(m)%ilod
        Obc%bound(m)%d1i_bt => Obc%bound(m)%ilod
        Obc%bound(m)%d1j_bt => Obc%bound(m)%ones_bt
        Obc%bound(m)%ico_bt => Obc%bound(m)%ilod
        n = 1
      endif
    enddo

    ! Get restart value for phase speed and relaxation coefficient    
    allocate(Obc%eta   (nobc))  
    do m = 1, nobc
       if (Obc%bound(m)%on_bound) then
          !         data needed for eta
          Obc%eta(m)%rel_coef_in                = rel_coef_eta_in(m)
          Obc%eta(m)%rel_coef_out               = rel_coef_eta_out(m)
          Obc%eta(m)%rel_pnts                   = rel_eta_pnts(m)
          Obc%eta(m)%file                       = trim(filename_eta(m))
          Obc%eta(m)%field                      = trim(fieldname_eta(m))
       endif
    enddo

    allocate(Obc%ud   (nobc))  
    do m = 1, nobc
       if (Obc%bound(m)%on_bound) then
          if(iand(Obc%bound(m)%bcond_ud, FILEIN) == FILEIN) then
             !         data needed for Flather 
             Obc%ud(m)%file                       = trim(filename_ud(m))
             Obc%ud(m)%field                      = trim(fieldname_ud(m))
          endif
       endif
    enddo    

    file_name = 'ocean_obc.res.nc'
    id_restart(1) = register_restart_field(Obc_restart, file_name, 'ctrop', ctrop(:,:), &
            domain=Dom%domain2d)
    id_restart(2) = register_restart_field(Obc_restart, file_name, 'rtrop', rel_coef(:,:), &
            domain=Dom%domain2d)
    id_restart(3) = register_restart_field(Obc_restart, file_name, 'eta_tm1', eta_tm1(:,:), &
            domain=Dom%domain2d)
    id_restart(4) = register_restart_field(Obc_restart, file_name, 'eta_t_tm1', eta_t_tm1(:,:), &
            domain=Dom%domain2d)
    if (file_exist('INPUT/ocean_obc.res.nc')) then
      write (stdoutunit,'(/a)') &
      '  Reading restart for phase speed from INPUT/ocean_obc.res.nc'
      call restore_state(Obc_restart)
      call mpp_update_domains(ctrop(:,:), Dom%domain2d)
      call mpp_update_domains(rel_coef(:,:), Dom%domain2d)
      call mpp_update_domains(eta_tm1(:,:), Dom%domain2d)
      call mpp_update_domains(eta_t_tm1(:,:), Dom%domain2d)
    
    else
      do m = 1, nobc
         if(.not. Obc%bound(m)%on_bound) cycle
      ! initialise the relaxation coefficient and phase speed
      ! For GRAVTY these will be never changed
         call phase_speed_GRAVTY(Obc%bound(m), Obc%eta(m))
      enddo   
    endif
    write(stdoutunit,*) ' '
    write(stdoutunit,*) &
      'From ocean_obc_barotrop_mod: initial obc chksums'
    call write_timestamp(Time%model_time)
    call write_chksum_2d('phase speed', ctrop(COMP))
    call write_chksum_2d('relaxation coefficient', rel_coef(COMP))
    call write_chksum_2d('eta_tm1', eta_tm1(COMP))
    call write_chksum_2d('eta_t_tm1', eta_t_tm1(COMP))
    
    write(stdoutunit,*) '-----------------------------------------------------------------'
    write(stdoutunit,*) 'The following setup for OBC has been found:'
    write(stdoutunit,*) 'Total number of OBC: ', nobc
    do m = 1, nobc
       write(stdoutunit,*) ' Setup of OBC ',m,', ',Obc%bound(m)%name,':'
       write(stdoutunit,*) ' direction: ', trim(direction(m))
       write(stdoutunit,*) ' ==> See files obc_'//trim(Obc%bound(m)%name)//'.out.* for more information.'
       write(stdoutunit,*) '     Enable debug_this_module for details on domain decomposition.'
       
       if(.not. Obc%bound(m)%on_bound) cycle
       
       write(obc_out_unit(m),*) 'Setup of OBC ',m,', ',Obc%bound(m)%name,':'
       write(obc_out_unit(m),*) ' direction     : ', trim(direction(m))
       write(obc_out_unit(m),*) ' points        : ', Obc%bound(m)%np
! if debugging is on each PE has an output file open otherwise this info is useless
       if(debug_this_module) then
         write(obc_out_unit(m),*) ' pe - name       :', trim(pe_name)
         write(obc_out_unit(m),*) ' ocean-domain, comp :', isc, iec, jsc, jec
         write(obc_out_unit(m),*) ' ocean-domain, data :', isd, ied, jsd, jed
         write(obc_out_unit(m),*) ' obc - domain, comp :', Obc%bound(m)%is, Obc%bound(m)%ie, Obc%bound(m)%js, Obc%bound(m)%je
         write(obc_out_unit(m),*) ' obc - domain, data :', Obc%bound(m)%isd, Obc%bound(m)%ied, Obc%bound(m)%jsd, Obc%bound(m)%jed
         if (south_west_corner) write(obc_out_unit(m),*) ' south-west corner points :', i_sw, j_sw
         if (south_east_corner) write(obc_out_unit(m),*) ' south-east corner points :', i_se, j_se
         if (north_east_corner) write(obc_out_unit(m),*) ' north-east corner points :', i_ne, j_ne
         if (north_west_corner) write(obc_out_unit(m),*) ' north-west corner points :', i_nw, j_nw
       endif
       if(.not. (Obc%bound(m)%report .or. debug_this_module)) cycle
       write(obc_out_unit(m),*) ' Normal 3D velocity OBC : ', trim(obc_nor(m))
       write(obc_out_unit(m),*) ' Tangential 3D velocity OBC : ', trim(obc_tan(m))
       write(obc_out_unit(m),*) ' Elevation OBC : ', trim(obc_eta(m))
       write(obc_out_unit(m),*) ' Normal 2D velocity OBC : ', trim(obc_ud(m))
       write(obc_out_unit(m),*) ' Vertical mixing coefficients OBC : ', trim(obc_mix(m))
       write(obc_out_unit(m),*) ' min phase speed (times sqrt(gH)) : ', Obc%bound(m)%ctrop_min
       write(obc_out_unit(m),*) ' max phase speed (times sqrt(gH)) : ', Obc%bound(m)%ctrop_max
       write(obc_out_unit(m),*) ' inc phase speed (times sqrt(gH)) : ', Obc%bound(m)%ctrop_inc
       write(obc_out_unit(m),*) ' smoothing parameter              : ', Obc%bound(m)%ctrop_smooth
       if (Obc%bound(m)%obc_damp_newton) then
          write(obc_out_unit(m),*) ' apply Newtonian damping of ',Obc%bound(m)%damp_factor
       else
          write(obc_out_unit(m),*) ' no Newtonian damping '
       endif
       if (Obc%bound(m)%obc_consider_convu) then 
          write(obc_out_unit(m),*) ' consider convu for d eta/dt'
       else  
          write(obc_out_unit(m),*) ' do not consider convu for d eta/dt'
       endif
       write(obc_out_unit(m),*) ' relax eta     :', Obc%bound(m)%obc_relax_eta
       if (Obc%bound(m)%obc_relax_eta_profile) then
          write(obc_out_unit(m),*) '  method        :', ' profile'
       else  
          write(obc_out_unit(m),*) '  method        :', ' average'
       endif
       write(obc_out_unit(m),*) '-----------------------------------------------------------------'
    enddo


    do m = 1, nobc
       call mpp_declare_pelist(Obc%bound(m)%pelist)
    enddo

    do m = 1, nobc
       if (Obc%bound(m)%on_bound) then
          call mpp_set_current_pelist(Obc%bound(m)%pelist)
! This part of the domain definition is the same for tracers and eta
          call mpp_set_compute_domain(obc_eta_domain(m),&
                                      Obc%bound(m)%isd, Obc%bound(m)%ied, &
                                      Obc%bound(m)%jsd, Obc%bound(m)%jed, &
                                      Obc%bound(m)%ied-Obc%bound(m)%isd+1, Obc%bound(m)%jed-Obc%bound(m)%jsd+1)
          call mpp_set_data_domain   (obc_eta_domain(m),&
                                      Obc%bound(m)%isd, Obc%bound(m)%ied, &
                                      Obc%bound(m)%jsd, Obc%bound(m)%jed, &
                                      Obc%bound(m)%ied-Obc%bound(m)%isd+1, Obc%bound(m)%jed-Obc%bound(m)%jsd+1,&
                                       .false., .false.)
          call mpp_set_compute_domain(obc_diag_domain(m),&
                                      Obc%bound(m)%is, Obc%bound(m)%ie, &
                                      Obc%bound(m)%js, Obc%bound(m)%je, &
                                      Obc%bound(m)%ie-Obc%bound(m)%is+1, Obc%bound(m)%je-Obc%bound(m)%js+1)
          call mpp_set_data_domain   (obc_diag_domain(m),&
                                      Obc%bound(m)%is, Obc%bound(m)%ie, &
                                      Obc%bound(m)%js, Obc%bound(m)%je, &
                                      Obc%bound(m)%ie-Obc%bound(m)%is+1, Obc%bound(m)%je-Obc%bound(m)%js+1,&
                                       .false., .false.)
          if(Obc%bound(m)%obc_relax_eta) then
             if(Obc%bound(m)%direction == WEST .or. Obc%bound(m)%direction == EAST) then
!kk               Changed from compute to data domain
                allocate(Obc%eta(m)%data(1,Obc%bound(m)%jsd:Obc%bound(m)%jed))
             else
                allocate(Obc%eta(m)%data(Obc%bound(m)%isd:Obc%bound(m)%ied,1))
             endif
             Obc%eta(m)%data = 0
             write(obc_out_unit(m),*) trim(Obc%eta(m)%file)
             write(obc_out_unit(m),*) trim(Obc%eta(m)%field)

             ! Set the global domain part for the eta input file
             call mpp_set_global_domain( obc_eta_domain(m), &
                                      xbegin=Obc%bound(m)%iers, ybegin=Obc%bound(m)%jers, &
                                      xend=Obc%bound(m)%iere, yend=Obc%bound(m)%jere, &
                                      xsize=Obc%bound(m)%iere-Obc%bound(m)%iers+1, &
                                      ysize=Obc%bound(m)%jere-Obc%bound(m)%jers+1)

             Obc%eta(m)%id   = init_external_field( &
                  Obc%eta(m)%file,Obc%eta(m)%field, &
                  domain=obc_eta_domain(m),        &
!                  desired_units='m', &
                  verbose=debug_this_module)

             fld_size(:)  = get_external_field_size(Obc%eta(m)%id)
             if(debug_this_module) write(obc_out_unit(m),*) 'fld_size for this PE',fld_size(:)
             if(fld_size(2) .ne. size(Obc%eta(m)%data,2)) then
                write(errorstring,'(I3,I3,1x)') fld_size(2), size(Obc%eta(m)%data,2)
                call mpp_error(FATAL,trim(errorstring)//'invalid dimension 2 of input field in '//trim(Obc%eta(m)%file))
             endif
         endif

         if(iand(Obc%bound(m)%bcond_ud, FILEIN) == FILEIN) then
              if(Obc%bound(m)%direction == WEST .or. Obc%bound(m)%direction == EAST) then
!kk               Changed from compute to data domain
                  allocate(Obc%ud(m)%data(1,Obc%bound(m)%jsd:Obc%bound(m)%jed))

                  write(*,*) ' e/w pe,js,je=',mpp_pe(),Obc%bound(m)%js,Obc%bound(m)%je
              else
                  allocate(Obc%ud(m)%data(Obc%bound(m)%isd:Obc%bound(m)%ied,1))

                  write(*,*) ' n/s pe,js,je=',mpp_pe(),Obc%bound(m)%is,Obc%bound(m)%ie
              endif
              Obc%ud(m)%data = 0
              write(stdoutunit,*) trim(Obc%ud(m)%file)
              write(stdoutunit,*) trim(Obc%ud(m)%field)
! ! Set the global domain part for the eta input file
              call mpp_set_global_domain( obc_eta_domain(m), &
                                       xbegin=Obc%bound(m)%iers, ybegin=Obc%bound(m)%jers, &
                                       xend=Obc%bound(m)%iere, yend=Obc%bound(m)%jere, &
                                       xsize=Obc%bound(m)%iere-Obc%bound(m)%iers+1, &
                                       ysize=Obc%bound(m)%jere-Obc%bound(m)%jers+1)

              Obc%ud(m)%id   = init_external_field( &
                   Obc%ud(m)%file,Obc%ud(m)%field, &
                   domain=obc_eta_domain(m))

              fld_size(:)  = get_external_field_size(Obc%ud(m)%id)
              if(debug_this_module) write(obc_out_unit(m),*) 'fld_size for this PE',fld_size(:)
              if(fld_size(2) .ne. size(Obc%ud(m)%data,2)) then
                 write(errorstring,'(I3,I3)') fld_size(2), size(Obc%ud(m)%data,2)
                 call mpp_error(FATAL,trim(errorstring)//'invalid dimension 2 of input field in '//trim(Obc%ud(m)%file))
              endif
           endif

          write(obc_out_unit(m),*) '-----------------------------------------------------------------'
          write(obc_out_unit(m),*) 'The following scheme for OBC data input has been found:'
          if (Obc%bound(m)%obc_relax_eta) then
             write(obc_out_unit(m),*) '  sea level relaxation'
             write(obc_out_unit(m),*) '  rel_coef_in : ', Obc%eta(m)%rel_coef_in
             write(obc_out_unit(m),*) '  rel_coef_out: ', Obc%eta(m)%rel_coef_out
             write(obc_out_unit(m),*) '  rel_pnts    : ', Obc%eta(m)%rel_pnts
             write(obc_out_unit(m),*) '  input-file  : ', trim(Obc%eta(m)%file)
             write(obc_out_unit(m),*) '  input-name  : ', trim(Obc%eta(m)%field)
          else
             write(obc_out_unit(m),*) '  no sea level relaxation'
          endif
       endif
       call mpp_set_current_pelist(pelist)
    enddo


! prepare diagnostics
    do m = 1, nobc
       if (Obc%bound(m)%on_bound) then
         call mpp_set_global_domain( obc_diag_domain(m), &
                                   xbegin=Obc%bound(m)%isg, ybegin=Obc%bound(m)%jsg, &
                                   xend  =Obc%bound(m)%ieg, yend  =Obc%bound(m)%jeg, &
                                   xsize =Obc%bound(m)%ieg - Obc%bound(m)%isg+1, &
                                   ysize =Obc%bound(m)%jeg - Obc%bound(m)%jsg+1)
         Obc%bound(m)%id_xt = diag_axis_init ('xt_'//trim(Obc%bound(m)%name),Grd%grid_x_t(Obc%bound(m)%isg:Obc%bound(m)%ieg), &
              'degrees_E','x','tcell longitude',set_name='ocean', Domain2=obc_diag_domain(m), aux='geolon_t')
         Obc%bound(m)%id_yt = diag_axis_init ('yt_'//trim(Obc%bound(m)%name),Grd%grid_y_t(Obc%bound(m)%jsg:Obc%bound(m)%jeg), &
              'degrees_N','y','tcell latitude',set_name='ocean', Domain2=obc_diag_domain(m), aux='geolat_t')
         
         Obc%bound(m)%id_ctrop = register_diag_field ('ocean_model', 'ctrop_p_'//trim(Obc%bound(m)%name),          &
                (/Obc%bound(m)%id_xt, Obc%bound(m)%id_yt/), Time%model_time, 'barotr phase speed on open bounds',  &
                                 'm/s', missing_value=missing_value, range=(/-1.e8,1.e8/))
         Obc%bound(m)%id_eta_data = register_diag_field ('ocean_model', 'eta_data_'//trim(Obc%bound(m)%name),                &
                       (/Obc%bound(m)%id_xt, Obc%bound(m)%id_yt/), Time%model_time, 'external sea level data on open bounds',&
                                 'm', missing_value=missing_value, range=(/-1.e8,1.e8/))
         Obc%bound(m)%id_rel_coef = register_diag_field ('ocean_model', 'rel_coeff_'//trim(Obc%bound(m)%name),           &
                                 (/Obc%bound(m)%id_xt, Obc%bound(m)%id_yt/), Time%model_time, 'relaxation coefficient',  &
                                 'none', missing_value=missing_value, range=(/-1.e8,1.e8/))

       endif
    enddo
    call mpp_clock_end(id_obc)

    return
  end subroutine ocean_obc_barotrop_init
  !  </SUBROUTINE> NAME="ocean_obc_barotrop_init"


  !<FUNCTION> NAME="ocean_obc_check_for_update"
  !<PUBLICROUTINE>
  function ocean_obc_check_for_update()
  !</PUBLICROUTINE>
    logical    :: ocean_obc_check_for_update
    logical    :: do_update
    integer    :: m
    do_update=.false.
    do m = 1, nobc
      if(iand(Obc%bound(m)%bcond_eta, RAYMND) == RAYMND) do_update=.true.
!      if(iand(Obc%bound(m)%bcond_eta, ORLANS) == ORLANS) do_update=.true.
    enddo
    ocean_obc_check_for_update=do_update
  end function ocean_obc_check_for_update
  !  </FUNCTION> NAME="ocean_obc_check_for_update"


  !#####################################################################
  !  <SUBROUTINE NAME="ocean_obc_prepare">
  !   <DESCRIPTION>
  !      Prepares OBC  
  !      
  !   </DESCRIPTION>
  !<PUBLICROUTINE>
  subroutine ocean_obc_prepare(Time)
  !</PUBLICROUTINE>
    type(ocean_time_type), intent(in)             :: Time 

    integer                                       :: m, n, i, j, taum1, tau
    integer                                       :: nn, id, jd
    logical                                       :: used
    integer                                       :: istrt, iend, jstrt, jend, ii, jj
    real                                          :: cdtdxr, cdtdyr, etasum, dummy_array(1)
    real, dimension(:), pointer :: data
    real, dimension(isd:ied,jsd:jed,nk)           :: wrk

!    call mpp_clock_begin(id_obc)

!   prepare the new data needed for time interpolation of external data.
    do m = 1, nobc

       !--- if on current pe there is no point on the bound, then just return
       if(.not. Obc%bound(m)%on_bound) cycle

!      Prepare sea level data for relaxation         
       if (Obc%bound(m)%obc_relax_eta) then
         

         call time_interp_external(Obc%eta(m)%id,Time%model_time,Obc%eta(m)%data,verbose=debug_this_module)
       endif

!      Prepare Flather
       if(iand(Obc%bound(m)%bcond_ud, FILEIN) == FILEIN) then
         call time_interp_external(Obc%ud(m)%id,Time%model_time,Obc%ud(m)%data,verbose=debug_this_module)
       endif     

    enddo

    ! Relax eta_t(taum1) towards the previous external data
    ! This is brought in the scheme like a smoother
    ! Data are added this way to fields
    ! store eta_t before obc apply for consistent tracer treatment
    ! relaxation coefficxient is from previous barotropic sequence,
    ! data are old from previous time step. They are updated later below.
    ! This subroutine should be called after smoothing eta_t
    
    taum1=Time%taum1
    eta_tend_obc = 0.
    
      do m = 1, nobc
        !--- if on current pe there is no point on the bound, then just return
        if(.not. Obc%bound(m)%on_bound ) cycle
        if(.not. Obc%bound(m)%obc_relax_eta) cycle
        if(Obc%bound(m)%id_eta_data > 0) then
          wrk = 0.
          if(Obc%bound(m)%direction == WEST .or. Obc%bound(m)%direction == EAST) then
            do j = Obc%bound(m)%js, Obc%bound(m)%je
              wrk(Obc%bound(m)%is,j,1) = Obc%eta(m)%data(1,j)
            enddo
          endif
          if(Obc%bound(m)%direction == SOUTH .or. Obc%bound(m)%direction == NORTH) then
            do i = Obc%bound(m)%is, Obc%bound(m)%ie
              wrk(i,Obc%bound(m)%js,1) = Obc%eta(m)%data(i,1)
            enddo
          endif
          used = send_data(Obc%bound(m)%id_eta_data, &
               wrk(Obc%bound(m)%is:Obc%bound(m)%ie,Obc%bound(m)%js:Obc%bound(m)%je,1),  &
               Time%model_time,                               &
               rmask=t_mask(Obc%bound(m)%is:Obc%bound(m)%ie,Obc%bound(m)%js:Obc%bound(m)%je))
        endif
      enddo
!      call mpp_clock_end(id_obc)

    return

  end subroutine ocean_obc_prepare
  !  </SUBROUTINE> NAME="ocean_obc_prepare"


  !#####################################################################
  !set the divergency of the vertically integrated velocity to zero if needed
  !<SUBROUTINE NAME="ocean_obc_adjust_divud" >
  !   <INOUT NAME="divud" TYPE="real, dimension(isd:,jsd:)"></INOUT>

  !<PUBLICROUTINE INTERFACE="ocean_obc_adjust_divud" >
  subroutine ocean_obc_adjust_divud(divud)
  !</PUBLICROUTINE>
    real, dimension(isd:,jsd:),   intent(inout) :: divud
    integer :: m
    
    call mpp_clock_begin(id_obc)
    
    do m = 1, nobc
       !--- if on current pe there is no point on the bound, then just return
       if(.not. Obc%bound(m)%on_bound) cycle
       if(Obc%bound(m)%obc_consider_convu) then
          call ocean_obc_update_boundary_2d(divud, 'T')
       else
          call ocean_obc_zero_boundary_2d(divud, 'T')
          call ocean_obc_update_boundary_2d(divud, 'T')
          if(debug_this_module) then
             write(obc_out_unit(m),*) 'Setting div_ud to zero for OBC ', trim(Obc%bound(m)%name)
          endif
       endif

    enddo
    call mpp_clock_end(id_obc)

  end subroutine ocean_obc_adjust_divud
  !  </SUBROUTINE> NAME="ocean_obc_adjust_divud"


  !#####################################################################
  !<SUBROUTINE NAME="ocean_obc_damp_newton" >

  !<PUBLICROUTINE INTERFACE="ocean_obc_damp_newton" >
  subroutine ocean_obc_damp_newton(udrho_bt,forcing)
  !</PUBLICROUTINE>
    real, dimension(isd:ied,jsd:jed,2),   intent(in) :: udrho_bt
    real, dimension(isd:ied,jsd:jed,2),   intent(inout) :: forcing
    character(len=1)    :: grid_type
    integer :: m, n, nn, i, j
    
    call mpp_clock_begin(id_obc)
    
    do m = 1, nobc
       !--- if on current pe there is no point on the bound, then just return
      if(.not. Obc%bound(m)%on_bound) cycle
      if(.not. Obc%bound(m)%obc_damp_newton) cycle
      
      
      if( Obc%bound(m)%direction == EAST.or. &
           Obc%bound(m)%direction == WEST) then
          
          do n = 1, Obc%bound(m)%nlod
             i = Obc%bound(m)%idf(n)   ! i boundary location
             j = Obc%bound(m)%jdf(n)   ! j boundary location
             nn = Obc%bound(m)%tid(n)  ! Index tangential to boundary
             
             if(Obc%bound(m)%mask(nn)) forcing(i,j,2) = -1*udrho_bt(i,j,2) * &
                  Obc%bound(m)%damp_factor

          enddo

      else if (Obc%bound(m)%direction == NORTH.or. &
           Obc%bound(m)%direction == SOUTH) then

          do n = 1, Obc%bound(m)%nlod
             i = Obc%bound(m)%idf(n)   ! i boundary location
             j = Obc%bound(m)%jdf(n)   ! j boundary location
             nn = Obc%bound(m)%tid(n)  ! Index tangential to boundary

             if(Obc%bound(m)%mask(nn)) forcing(i,j,1) = -1*udrho_bt(i,j,1) * &
                  Obc%bound(m)%damp_factor


          enddo

      endif

      if(debug_this_module) then
         write(obc_out_unit(m),*) 'Applying newtonian damping for OBC ', trim(Obc%bound(m)%name)
      endif

   enddo
   call mpp_clock_end(id_obc)

  end subroutine ocean_obc_damp_newton
  !  </SUBROUTINE> NAME="ocean_obc_damp_newton"


  !#####################################################################
  !<SUBROUTINE NAME="ocean_obc_ud" >

    !<PUBLICROUTINE INTERFACE="ocean_obc_ud" >
  subroutine ocean_obc_ud(eta_t, udrho)
    !</PUBLICROUTINE>
    real, dimension(isd:ied,jsd:jed),   intent(in) :: eta_t
    real, dimension(isd:ied,jsd:jed,2),   intent(inout) :: udrho
!    real                                              :: dt
!    real, dimension(isd:ied,jsd:jed,2),   intent(inout) :: forcing
    real :: ud_bound, eta_diff, tendency
    character(len=1)    :: grid_type
    integer :: m, n, nn, i, j, idf, jdf, ico, jco, vn, dd
    logical :: flather_on=.false. 
    real, dimension(:), pointer :: hdata
    real, dimension(:), pointer :: udata
    integer, dimension(:), pointer :: dn

    call mpp_clock_begin(id_obc)

    do m = 1, nobc
       !--- if on current pe there is no point on the bound, then just return
      if(.not. Obc%bound(m)%on_bound) cycle
      if(.not. Obc%bound(m)%obc_ud_active) cycle

      ! Set pointers and initialize
      if (Obc%bound(m)%direction == NORTH.or.Obc%bound(m)%direction == SOUTH) then
         vn = 2
         dn => Obc%bound(m)%ilod
      else
         vn = 1
         dn => Obc%bound(m)%jlod
      endif

      ! Initialise the outside elevation location. This is overwritten with data (below) or a NOGRAD
      ! condition (in ocean_obc_update_boundary() below) later.
      do n = 1, Obc%bound(m)%nlod
         ico = Obc%bound(m)%ico_bt(n)      ! i boundary outside face location
         jco = Obc%bound(m)%jco_bt(n)      ! j boundary outside face location
         nn = Obc%bound(m)%tid(n)          ! Index tangential to boundary
         if(Obc%bound(m)%mask(nn)) then
            udrho(ico,jco,vn) = 0.0
         endif
      enddo

      ! Set depth integrated velocity to FILEIN value. This assignment occurs on the outside elevation (i,j) node.
      ! Set bcond_eta = NOTHIN if this condition is used in isolation.
      if(iand(Obc%bound(m)%bcond_ud, FILEIN) == FILEIN) then
         if (Obc%bound(m)%direction == NORTH.or.Obc%bound(m)%direction == SOUTH) then
            udata => Obc%ud(m)%data(:,1)
         else
            udata => Obc%ud(m)%data(1,:)
         endif
         do n = 1, Obc%bound(m)%nlod
            ico = Obc%bound(m)%ico_bt(n)   ! i boundary outside face location
            jco = Obc%bound(m)%jco_bt(n)   ! j boundary outside face location
            nn = Obc%bound(m)%tid(n)       ! Index tangential to boundary
            dd = dn(n)                     ! Data index
            if(Obc%bound(m)%mask(nn)) then
               udrho(ico,jco,vn) = udata(dd)
            endif
         enddo
      endif

      ! Set depth integrated velocity to Flather condition. This is implemented 
      ! on the inside elevation node. The elevation external data is used if bcond_eta |= FLATHR.
      if(iand(Obc%bound(m)%bcond_ud, FLATHR) == FLATHR) then

         Obc%bound(m)%work = 0.0
         hdata => Obc%bound(m)%work
         if (Obc%bound(m)%direction == NORTH.or.Obc%bound(m)%direction == SOUTH) then
            if(iand(Obc%bound(m)%bcond_eta, FLATHR) == FLATHR) hdata => Obc%eta(m)%data(:,1)
         else
            if(iand(Obc%bound(m)%bcond_eta, FLATHR) == FLATHR) hdata => Obc%eta(m)%data(1,:)
         endif
         flather_on = .true. 

         do n = 1, Obc%bound(m)%nlod
            i = Obc%bound(m)%ilod(n)       ! i boundary location
            j = Obc%bound(m)%jlod(n)       ! j boundary location
            idf = Obc%bound(m)%idf(n)      ! i boundary inside face location
            jdf = Obc%bound(m)%jdf(n)      ! j boundary inside face location
            ico = Obc%bound(m)%ico_bt(n)      ! i boundary outside face location
            jco = Obc%bound(m)%jco_bt(n)      ! i boundary outside face location
            nn = Obc%bound(m)%tid(n)       ! Index tangential to boundary
            dd = dn(n)                     ! Data index
               
            if(Obc%bound(m)%mask(nn)) then
               eta_diff = eta_t(i,j)  - hdata(dd)
               ud_bound = udrho(ico,jco,vn) - Obc%bound(m)%sign * Obc%bound(m)%dsur(n) * eta_diff
               udrho(idf,jdf,vn) = ud_bound * rho0
            endif
         enddo
      endif
   enddo

   if(flather_on) then 
!      call mpp_update_domains (udrho(:,:,1),udrho(:,:,2), Dom%domain2d, gridtype=BGRID_NE)     
! guess this can be removed when working at the data domain or the large barotropic domain respectively???
   endif
   
   ! Set the depth integrated velocity on the outside elevation node, and tangential node.
   ! The normal depth averaged velocity currently uses the bcond_nor OBC.
   call ocean_obc_update_boundary(udrho(:,:,1),'M','u')
   call ocean_obc_update_boundary(udrho(:,:,2),'M','t')
   call ocean_obc_update_boundary(udrho(:,:,1),'Z','t')
   call ocean_obc_update_boundary(udrho(:,:,2),'Z','u')

   call mpp_clock_end(id_obc)

 end subroutine ocean_obc_ud
!  </SUBROUTINE> NAME="ocean_obc_ud"


  !#####################################################################
  !update surface height and the vertically integrated horizontal velocity
  !<SUBROUTINE NAME="ocean_obc_barotropic">
  !   <IN NAME="taum1, tau, taup1" TYPE="integer"> </IN>
  !   <INOUT NAME="eta" TYPE="real, dimension(isd:,jsd:,:)"></INOUT>

  !<PUBLICROUTINE INTERFACE="ocean_obc_barotropic" >
  subroutine ocean_obc_barotropic(eta, taum1, tau, taup1, tstep)
  !</PUBLICROUTINE>

    real, dimension(isd:,jsd:,:), target, intent(inout) :: eta
    integer, intent(in)                           :: taum1, tau, taup1
    real, intent(in)                              :: tstep

    real    :: cdtdxr, dt, etasum, dummy_array(1)
    integer :: i, j, m, n, nn, i1, j1, id, jd
    integer :: istrt, iend, jstrt, jend, ii, jj
    real, dimension(:), pointer :: data
    real, dimension(:,:), pointer :: dg
    real :: sign

  integer :: stdoutunit
  stdoutunit=stdout()

    call mpp_clock_begin(id_obc)

    !   Update from taup1 to taup1. This implies, that divuv must be set
    ! to zero at boundaries (obc_consider_convu=.false.), before regular
    ! points are updated.
    !   With obc_consider_convu=.true. the divergency
    !   in the boundaries direction is taken into account. Also fresh water
    ! flux is already taken into account with the regular scheme.
    

    do m = 1, nobc

       ! if on current pe there is no point on the bound, then just return
       if(.not. Obc%bound(m)%on_bound) cycle

       ! Set pointers
       if(Obc%bound(m)%direction == WEST .or. &
          Obc%bound(m)%direction == EAST) then
          dg => dxu_bt
       else
          dg => dyu_bt
       endif
       sign = Obc%bound(m)%sign
       dt = tstep

       ! Calculate the phase speed
       if(iand(Obc%bound(m)%bcond_eta, IOW) == IOW) then
          ! Original momp1 Orlanski like formulation by Martin Schmidt.
          call phase_speed_IOW(Obc%bound(m), Obc%eta(m), eta, taum1, taup1, dt)
          ! Get the sea level due to radiation
          do n = 1, Obc%bound(m)%nlod
             i = Obc%bound(m)%ilod(n)   ! i boundary location
             j = Obc%bound(m)%jlod(n)   ! j boundary location
             nn = Obc%bound(m)%tid(n)   ! Index tangential to boundary
             i1 = i  + Obc%bound(m)%imap
             j1 = j  + Obc%bound(m)%jmap

             cdtdxr = ctrop(i,j) * dt / dg(i,j)
             eta(i,j,taup1) = (eta(i,j,taup1) + cdtdxr * eta(i1,j1,taup1)) / &
                              (1. + cdtdxr)
          enddo
       else if(iand(Obc%bound(m)%bcond_eta, ORLANS) == ORLANS) then
          ! Orlanski (1976) implicit.
          ! Based on Chapman (1985) Table 1. eqn. 8 (ORI)
          call phase_speed_ORLANS(Obc%bound(m), Obc%eta(m), eta, tau, taup1, dt)
          ! Get the sea level due to radiation
          do n = 1, Obc%bound(m)%nlod
             i = Obc%bound(m)%ilod(n)   ! i boundary location
             j = Obc%bound(m)%jlod(n)   ! j boundary location
             i1 = i  + Obc%bound(m)%imap   ! i interior cell location
             j1 = j  + Obc%bound(m)%jmap   ! j interior cell location

             cdtdxr = ctrop(i,j) * dt / dg(i,j)
             eta(i,j,taup1) = (eta_tm1(i,j) * (1.0 - cdtdxr) + &
                  2.0 * cdtdxr * eta(i1,j1,tau)) / (1.0 + cdtdxr)
             ! Save the value of eta at the backward time step
             eta_tm1(i,j)   = eta(i,j,tau)
             eta_tm1(i1,j1) = eta(i1,j1,tau)
          enddo
          dt = dt * 2.0
       else if(iand(Obc%bound(m)%bcond_eta, GRAVTY) == GRAVTY) then
          ! Gravity wave radiation implicit.
          ! Based on Chapman (1985) Table 1. eqn. 4 (GWI)
          ! Gravity wave speed is a constant and is calculated in
          ! ocean_obc_barotrop_init. It is stored in ctrop.
          ! Hence values in ctrop are valid.
          ! Get the sea level due to radiation.
          do n = 1, Obc%bound(m)%nlod
             i = Obc%bound(m)%ilod(n)   ! i boundary location
             j = Obc%bound(m)%jlod(n)   ! j boundary location
             i1 = i  + Obc%bound(m)%imap   ! i interior cell location
             j1 = j  + Obc%bound(m)%jmap   ! j interior cell location

             cdtdxr = ctrop(i,j) * dt / dg(i,j)
             eta(i,j,taup1) = (eta(i,j,tau) + cdtdxr * eta(i1,j1,taup1)) / &
                              (1.0 + cdtdxr)
          enddo
       else if(iand(Obc%bound(m)%bcond_eta, CAMOBR) == CAMOBR) then
          ! Camerlengo & O'Brien (1980) implicit.
          ! Based on Chapman (1985) Table 1. eqn. 10 (MOI)
          call phase_speed_ORLANS(Obc%bound(m), Obc%eta(m), eta, tau, taup1, dt)
          ! Get the sea level due to radiation
          do n = 1, Obc%bound(m)%nlod
             i = Obc%bound(m)%ilod(n)   ! i boundary location
             j = Obc%bound(m)%jlod(n)   ! j boundary location
             i1 = i  + Obc%bound(m)%imap   ! i interior cell location
             j1 = j  + Obc%bound(m)%jmap   ! j interior cell location

             if (ctrop(i,j) .gt. 0.0) then
                eta(i,j,taup1) = eta(i1,j1,tau)
             else
                eta(i,j,taup1) = eta_tm1(i,j)
             endif
             ! Save the value of eta at the backward time step
             eta_tm1(i,j)   = eta(i,j,tau)
             eta_tm1(i1,j1) = eta(i1,j1,tau)
          enddo
          dt = dt * 2.0
       else if(iand(Obc%bound(m)%bcond_eta, MILLER) == MILLER) then
          ! Miller and Thorpe (1980) explicit.
          ! Based on Miller and Thorpe (1981) eqn. 15
          call phase_speed_MILLER(Obc%bound(m), Obc%eta(m), eta, tau, taup1, dt)
          ! Get the sea level due to radiation
          do n = 1, Obc%bound(m)%nlod
             i = Obc%bound(m)%ilod(n)   ! i boundary location
             j = Obc%bound(m)%jlod(n)   ! j boundary location
             i1 = i  + Obc%bound(m)%imap   ! i interior cell location
             j1 = j  + Obc%bound(m)%jmap   ! j interior cell location
             id = i  + 2*Obc%bound(m)%imap   ! 2xi interior cell location
             jd = j  + 2*Obc%bound(m)%jmap   ! 2xj interior cell location

             cdtdxr = ctrop(i,j) * dt / dg(i,j)
             eta(i,j,taup1) = eta(i,j,tau) - cdtdxr * &
                  (eta(i,j,tau) - eta(i1,j1,tau))
             ! Save the value of eta at the backward time step
             eta_tm1(i,j)   = eta(i,j,tau)
             eta_tm1(i1,j1) = eta(i1,j1,tau)
             eta_tm1(id,jd) = eta(id,jd,tau)
          enddo
       else if(iand(Obc%bound(m)%bcond_eta, RAYMND) == RAYMND) then
          ! Raymond and Kuo (1984) implicit.
          call phase_speed_RAYMND(Obc%bound(m), Obc%eta(m), eta, tau, taup1, dt)
          ! Get the sea level due to radiation
          do n = 1, Obc%bound(m)%nloc
             i = Obc%bound(m)%iloc(n)   ! i boundary location
             j = Obc%bound(m)%jloc(n)   ! j boundary location
             i1 = i  + Obc%bound(m)%imap   ! i interior cell location
             j1 = j  + Obc%bound(m)%jmap   ! j interior cell location
             id = i  + 2*Obc%bound(m)%imap   ! 2xi interior cell location
             jd = j  + 2*Obc%bound(m)%jmap   ! 2xj interior cell location

!  [m s-1][s m-1] = [nd]
             cdtdxr = ctrop(i,j) * dt / dg(i,j)
             eta(i,j,taup1) = (eta(i,j,tau) +  &
                  cdtdxr * eta(i1,j1,taup1) - Obc%bound(m)%dum(n)) / &
                  (1 + cdtdxr)
             ! Save the value of eta at the backward time step
             eta_tm1(i,j)   = eta(i,j,tau)
             eta_tm1(i1,j1) = eta(i1,j1,tau)
          enddo
       else if(iand(Obc%bound(m)%bcond_eta, NOGRAD) == NOGRAD) then
          ! Gravity wave radiation implicit.
          ! Based on Chapman (1985) Table 1. eqn. 4 (GWI)
          ! Gravity wave speed is a constant and is calculated in
          ! ocean_obc_barotrop_init. It is stored in ctrop.
          ! Hence values in ctrop are valid.
          ! Get the sea level due to radiation.
          do n = 1, Obc%bound(m)%nlod
             i = Obc%bound(m)%ilod(n)   ! i boundary location
             j = Obc%bound(m)%jlod(n)   ! j boundary location
             i1 = i  + Obc%bound(m)%imap   ! i interior cell location
             j1 = j  + Obc%bound(m)%jmap   ! j interior cell location

             eta(i,j,taup1) = eta(i1,j1,taup1)
          enddo
       endif

       ! Get the sea level relaxation component
       if(iand(Obc%bound(m)%bcond_eta, FILEIN) == FILEIN) then
          if(Obc%bound(m)%bcond_eta == FILEIN) then
             ! Force with the prescribed profile only
             do n = 1, Obc%bound(m)%nlod
                i = Obc%bound(m)%ilod(n)
                j = Obc%bound(m)%jlod(n)
                id = Obc%bound(m)%d1i_bt(n)
                jd = Obc%bound(m)%d1j_bt(n)

                ii = i
                jj = j
!kk                write(0,'(a,8i6,E10.2)') "kk_FILEIN ",n,i,j,id,jd,ii,jj,Obc%eta(m)%rel_pnts,Obc%eta(m)%data(id,jd)
                do nn = 1, Obc%eta(m)%rel_pnts
                   eta(ii,jj,taup1) = Obc%eta(m)%data(id,jd)
                   ii = ii + Obc%bound(m)%imap
                   jj = jj + Obc%bound(m)%jmap
                enddo
             enddo
          else
          ! Relax implicitly towards a prescribed profile
             do n = 1, Obc%bound(m)%nlod
                i = Obc%bound(m)%ilod(n)
                j = Obc%bound(m)%jlod(n)
                id = Obc%bound(m)%d1i_bt(n)
                jd = Obc%bound(m)%d1j_bt(n)

                cdtdxr = rel_coef(i,j) * dt
                ii = i
                jj = j
                do nn = 1, Obc%eta(m)%rel_pnts
                   eta(ii,jj,taup1) = (eta(ii,jj,taup1) + &
                        cdtdxr * Obc%eta(m)%data(id,jd)) / (1. + cdtdxr)
                   ii = ii + Obc%bound(m)%imap
                   jj = jj + Obc%bound(m)%jmap
                enddo
             enddo
          endif
       endif

       if(iand(Obc%bound(m)%bcond_eta, MEANIN) == MEANIN) then
          ! Relax mean sea level leaving the gradient profile in the
          ! boundary unchanged.
          if(Obc%bound(m)%on_bound) then
             n = Obc%bound(m)%nloc
             if(Obc%bound(m)%direction == WEST .or. &
                Obc%bound(m)%direction == EAST) then
                i = Obc%bound(m)%oi1(1)
                data => eta(i, Obc%bound(m)%jloc(1):Obc%bound(m)%jloc(n), &
                            taup1)
             else
                j = Obc%bound(m)%oj1(1)
                data => eta(Obc%bound(m)%iloc(1):Obc%bound(m)%iloc(n), j, &
                            taup1)
             endif
             etasum = boundary_average(obc%bound(m),data)
          else
             etasum = boundary_average(obc%bound(m), dummy_array)
          end if
          do n = 1, Obc%bound(m)%nlod
             i = Obc%bound(m)%ilod(n)
             j = Obc%bound(m)%jlod(n)
             id = Obc%bound(m)%d1i_bt(n)
             jd = Obc%bound(m)%d1j_bt(n)
             cdtdxr = rel_coef(i,j) * dt
             ii = i
             jj = j
             do nn = 1, Obc%eta(m)%rel_pnts
                eta(ii,j,taup1) = eta(ii,j,taup1) + &
                                     cdtdxr*(Obc%eta(m)%data(id,jd) - etasum)
                ii = ii + Obc%bound(m)%imap
                jj = jj + Obc%bound(m)%jmap
             enddo
          enddo
       endif
       ! Phase speed debugging information
       if(debug_phase_speed) then
          n = Obc%bound(m)%nlod/2     ! Print for a location halfway along the boundary
          i = Obc%bound(m)%ilod(n)
          j = Obc%bound(m)%jlod(n)
          i1 = i  + Obc%bound(m)%imap
          j1 = j  + Obc%bound(m)%jmap
          if(Obc%bound(m)%direction == WEST .or. &
             Obc%bound(m)%direction == EAST) then
             cdtdxr = dxu_bt(i1,j1)/dt
          else
             cdtdxr = dyu_bt(i1,j1)/dt
          endif
          write(obc_out_unit(m),*) 'Elevation phase speed, OBC ',Obc%bound(m)%name
          write(obc_out_unit(m),*) 'i = ',i,' j = ',j
          write(obc_out_unit(m),*) 'cgrid   = ',cdtdxr
          write(obc_out_unit(m),*) 'cmax    = ',min(Obc%bound(m)%ctrop_max * Obc%bound(m)%dsur(n), cdtdxr)
          write(obc_out_unit(m),*) 'cmin    = ',Obc%bound(m)%ctrop_min * Obc%bound(m)%dsur(n)
          write(obc_out_unit(m),*) 'ctrop   = ',ctrop(i,j)
       endif
    enddo

    ! Set the corner cells
    if ( south_west_corner ) then
       eta(i_sw,j_sw,taup1) = ( eta(i_sw+1,j_sw+1,taup1) &
                              + eta(i_sw+1,j_sw,  taup1) &
                              + eta(i_sw,  j_sw+1,taup1) ) /3.
    endif
    if ( south_east_corner ) then
       eta(i_se,j_se,taup1) = ( eta(i_se-1,j_se+1,taup1) &
                              + eta(i_se-1,j_se,  taup1) &
                              + eta(i_se,  j_se+1,taup1) ) /3.
    endif
    if ( north_west_corner ) then
       eta(i_nw,j_nw,taup1) = ( eta(i_nw+1,j_nw-1,taup1) &
                              + eta(i_nw+1,j_nw,  taup1) &
                              + eta(i_nw,  j_nw-1,taup1) ) /3.
    endif
    if ( north_east_corner ) then
       eta(i_ne,j_ne,taup1) = ( eta(i_ne-1,j_ne-1,taup1) &
                              + eta(i_ne-1,j_ne,  taup1) &
                              + eta(i_ne,  j_ne-1,taup1) ) /3.
    endif

    ! Update eta at global halo point to make the gradient accross boundary is 0
    call ocean_obc_update_boundary(eta(:,:,taup1), 'T')

    if(debug_this_module) then
       call write_chksum_2d('After ocean_obc_barotropic_dtbt, eta', eta(COMP,taup1))
    endif

    call mpp_clock_end(id_obc)

    return
  end subroutine ocean_obc_barotropic
  !</SUBROUTINE> NAME="ocean_obc_barotropic"


  !######################################################################
  !--- update field on the halo points at the boundaries
  !<SUBROUTINE NAME="ocean_obc_update_boundary_2d" INTERFACE="ocean_obc_update_boundary">
  !   <INOUT NAME="field" TYPE="real, dimension(:,:)"></INOUT> 
  !   <IN NAME="grid_type" TYPE=" character(len=1)"></IN> 
  !   <IN NAME="update_type" TYPE=" character(len=1)"></IN> 
  !<DESCRIPTION>
  ! This subroutine sets values at the halo points beyond open boundaries
  ! grid_type can be:    'T' for variables at tracer point or 
  !                      'C' for variables at velocity points 
  !                      'Z' velocity points at zonal (north, south) boundaries
  !                      'M' velocity points at meridional (east, west) boundaries
  ! 
  ! update_type can be: 's' for setting the field beyond the 
  !                         boundary to the value at the boundary 
  !                         - for a velocity 'Z' at northern and southern 
  !                           boundary
  !                         - for a velocity 'M' at western and eastern 
  !                           boundary
  !                         - for gridtype 'T' and 'C' at all boundaries
  !                         This is equivalent to the NOGRAD OBC.
  !                     'x' for linear extrapolation of the field beyond the 
  !                         boundary from the value at the boundary and the 
  !                         first internal point
  !                         This is equivalent to the LINEAR OBC.
  !                     'i' for setting the field beyond the boundary to   
  !                         the value at the first internal point:
  !                         - for a velocity 'Z' at northern and southern 
  !                           boundary
  !                         - for a velocity 'M' at western and eastern 
  !                           boundary
  !                         - for gridtype 'T' and 'C' at all boundaries
  !                         This is equivalent to the INGRAD OBC.
  !                     'z' for setting the field beyond the boundary to   
  !                         zero:
  !                         - for a velocity 'Z' at northern and southern 
  !                           boundary
  !                         - for a velocity 'M' at western and eastern 
  !                           boundary
  !                         - for gridtype 'T' and 'C' at all boundaries
  !                         This is called CLAMPD OBC here.

  !                        
  !</DESCRIPTION>
  !<PUBLICROUTINE INTERFACE="ocean_obc_update_boundary" >
  subroutine ocean_obc_update_boundary_2d(field,grid_type,update_type)
  !</PUBLICROUTINE>

    real, dimension(isd:,jsd:), intent(inout)  :: field
    character(len=1),               intent(in) :: grid_type
    character(len=1), optional,     intent(in) :: update_type

    integer :: i, j, m, is, ie, js, je, i1, j1, n, ii, jj
    real    :: u1, u2, x1, x2
    integer, dimension(nobc) :: uptype     ! OBC type
    integer, dimension(:), pointer :: ilod, jlod, oi1, oj1
    integer, dimension(:), pointer :: istr, iend, jstr, jend

    ! Set the boundary condition
    uptype = NOGRAD
    do m = 1, nobc
      if(PRESENT(update_type)) then
        if (update_type == 's') then
          uptype(m) = NOGRAD
        else if (update_type == 'x') then
          uptype(m) = LINEAR
        else if (update_type == 'i') then
          uptype(m) = INGRAD
        else if (update_type == 'z') then
          uptype(m) = CLAMPD
        else if (update_type == 'n') then   ! Normal velocity components 
          uptype(m) = Obc%bound(m)%bcond_nor
        else if (update_type == 't') then   ! Tangential velocity components
          uptype(m) = Obc%bound(m)%bcond_tan
        else if (update_type == 'u') then   ! Nornal depth integrated velocity components
          uptype(m) = Obc%bound(m)%bcond_ud
        else if (update_type == 'c') then   ! Cell centered components
          uptype(m) = NOGRAD                ! Unimplemented : default NOGRAD 
        else
          call mpp_error(FATAL, &
         'ocean_obc_barotrop_mod(ocean_obc_update_boundary) : update_type= '// update_type// &
         ' should be either "n", "t", "s", "x", "z", "u",  or "i" ' )
        endif
      endif
    enddo

    if(grid_type .ne. 'T' .and. grid_type .ne. 'C'.and. grid_type .ne. 'Z'.and. grid_type .ne. 'M') call mpp_error(FATAL, &
     'ocean_obc_barotrop_mod(ocean_obc_update_boundary) : grid_type= '// grid_type//' should be either "T", "C", "Z" or "M" ')

    ! Loop through the boundaries and update
    do m = 1, nobc

      if(.not.Obc%bound(m)%on_bound) cycle
       if((Obc%bound(m)%direction == WEST .or. &
           Obc%bound(m)%direction == EAST) .and. grid_type == 'Z') cycle  
       if((Obc%bound(m)%direction == NORTH .or. &
           Obc%bound(m)%direction == SOUTH) .and. grid_type == 'M') cycle  

       ! Set pointers
       ilod => Obc%bound(m)%ilod
       jlod => Obc%bound(m)%jlod
       istr => Obc%bound(m)%istr
       jstr => Obc%bound(m)%jstr
       iend => Obc%bound(m)%iend
       jend => Obc%bound(m)%jend

       ! Implement the OBC
!       if (uptype(m) .eq. LINEAR) then  ! Linear extrapolation
       if (iand(uptype(m), LINEAR) == LINEAR) then   ! Linear extrapolation
          oi1 => Obc%bound(m)%di1
          oj1 => Obc%bound(m)%dj1
          if (Obc%bound(m)%direction == EAST .or. &
              Obc%bound(m)%direction == NORTH) then
             if(grid_type /= 'T') then
                ilod => Obc%bound(m)%di1
                jlod => Obc%bound(m)%dj1
                oi1 => Obc%bound(m)%di2
                oj1 => Obc%bound(m)%dj2
                istr => Obc%bound(m)%ilod
                jstr => Obc%bound(m)%jlod
             endif
          endif

          do n = 1, Obc%bound(m)%nlod
             i = ilod(n)    ! i boundary location
             j = jlod(n)    ! j boundary location
             i1 = oi1(n)    ! i interior cell location
             j1 = oj1(n)    ! j interior cell location
             is = istr(n)   ! Start of i halo loop
             ie = iend(n)   ! End of i halo loop
             js = jstr(n)   ! Start of j halo loop
             je = jend(n)   ! End of j halo loop
                u1 = field(i,j)
                u2 = field(i1,j1)
                x1 = Grd%xt(i,j)
                x2 = Grd%xt(i1,j1)
                do jj = js, je
                   do ii = is, ie
                      field(ii,jj) = u1 + (u2-u1)*(Grd%xt(ii,jj) - x1)/(x2-x1)
                   enddo
                enddo
!!             endif
          enddo
!       else if (uptype(m) .eq. CLAMPD) then  ! Clamped to zero
       else if (iand(uptype(m), CLAMPD) == CLAMPD) then ! Clamped to zero
          if (Obc%bound(m)%direction == EAST .or. &
              Obc%bound(m)%direction == NORTH) then
             if(grid_type /= 'T') then
                istr => Obc%bound(m)%ilod
                jstr => Obc%bound(m)%jlod
             endif
          endif

          do n = 1, Obc%bound(m)%nlod
             is = istr(n)   ! Start of i halo loop
             ie = iend(n)   ! End of i halo loop
             js = jstr(n)   ! Start of j halo loop
             je = jend(n)   ! End of j halo loop
             do jj = js, je
                do ii = is, ie
                   field(ii,jj) = 0.0
                enddo
             enddo
          enddo
!       else if (uptype(m) .eq. NOGRAD) then   ! No-gradient
       else if (iand(uptype(m), NOGRAD) == NOGRAD) then ! No-gradient
          if (Obc%bound(m)%direction == EAST .or. &
              Obc%bound(m)%direction == NORTH) then
             if(grid_type /= 'T') then
                ilod => Obc%bound(m)%di1
                jlod => Obc%bound(m)%dj1
                istr => Obc%bound(m)%ilod
                jstr => Obc%bound(m)%jlod
             endif
          endif

          if(grid_type /= 'T') then
             do n = 1, Obc%bound(m)%nlod
                i = ilod(n)    ! Internal i boundary location
                j = jlod(n)    ! Internal j boundary location
                is = istr(n)   ! Start of i halo loop
                ie = iend(n)   ! End of i halo loop
                js = jstr(n)   ! Start of j halo loop
                je = jend(n)   ! End of j halo loop
                do jj = js, je
                   do ii = is, ie
                      field(ii,jj) = field(i,j)*u_mask(ii,jj)
                   enddo
                enddo
             enddo
          else
             do n = 1, Obc%bound(m)%nlod
                i = ilod(n)    ! Internal i boundary location
                j = jlod(n)    ! Internal j boundary location
                is = istr(n)   ! Start of i halo loop
                ie = iend(n)   ! End of i halo loop
                js = jstr(n)   ! Start of j halo loop
                je = jend(n)   ! End of j halo loop
                do jj = js, je
                   do ii = is, ie
                      field(ii,jj) = field(i,j)
                   enddo
                enddo
             enddo
          endif
!      else if (uptype(m) .eq. INGRAD) then  ! No-gradient to internal point
       else if (iand(uptype(m), INGRAD) == INGRAD) then ! No-gradient to internal point
          oi1 => Obc%bound(m)%di1
          oj1 => Obc%bound(m)%dj1
          if (Obc%bound(m)%direction == EAST .or. &
              Obc%bound(m)%direction == NORTH) then
             if(grid_type /= 'T') then
                oi1 => Obc%bound(m)%di2
                oj1 => Obc%bound(m)%dj2
                istr => Obc%bound(m)%ilod
                jstr => Obc%bound(m)%jlod
             endif
          endif

          if(grid_type /= 'T') then
             do n = 1, Obc%bound(m)%nlod
                i = oi1(n)     ! Internal i boundary location
                j = oj1(n)     ! Internal j boundary location
                is = istr(n)   ! Start of i halo loop
                ie = iend(n)   ! End of i halo loop
                js = jstr(n)   ! Start of j halo loop
                je = jend(n)   ! End of j halo loop
                do jj = js, je
                   do ii = is, ie
                      field(ii,jj) = field(i,j)*u_mask(ii,jj)
                   enddo
                enddo
             enddo
          else
             do n = 1, Obc%bound(m)%nlod
                i = oi1(n)     ! Internal i boundary location
                j = oj1(n)     ! Internal j boundary location
                is = istr(n)   ! Start of i halo loop
                ie = iend(n)   ! End of i halo loop
                js = jstr(n)   ! Start of j halo loop
                je = jend(n)   ! End of j halo loop
                do jj = js, je
                   do ii = is, ie
                      field(ii,jj) = field(i,j)
                   enddo
                enddo
             enddo
          endif
       else if (uptype(m) .eq. FILEIN) then   ! File input for velocity
          if (Obc%bound(m)%direction == EAST .or. &
              Obc%bound(m)%direction == NORTH) then
             if(grid_type /= 'T') then
                istr => Obc%bound(m)%ilod
                jstr => Obc%bound(m)%jlod
             endif
          endif

          if(grid_type == 'M' .or. grid_type == 'Z') then
             do n = 1, Obc%bound(m)%nlod
                i = Obc%bound(m)%ico_bt(n) ! i outside elevation face location
                j = Obc%bound(m)%jco_bt(n) ! j outside elevation face location
                is = istr(n)            ! Start of i halo loop
                ie = iend(n)            ! End of i halo loop
                js = jstr(n)            ! Start of j halo loop
                je = jend(n)            ! End of j halo loop
                do jj = js, je
                   do ii = is, ie
                      field(ii,jj) = field(i,j)*u_mask(ii,jj)
                   enddo
                enddo
             enddo
          endif
       endif

! There may be open points in the shadow of corners. These t-cells can be
! open or closed. It should be open, but who knows what happens ... 

      if ( south_west_corner ) then
         if(grid_type == 'T') then
            field(i_sw-1,j_sw-1) = field(i_sw,j_sw) * t_mask(i_sw,j_sw)
            field(max(isd,i_sw-2),j_sw-1) = field(i_sw,j_sw) * t_mask(i_sw,j_sw)
            field(i_sw-1,max(jsd,j_sw-2)) = field(i_sw,j_sw) * t_mask(i_sw,j_sw)
            field(max(isd,i_sw-2),max(jsd,j_sw-2)) = field(i_sw,j_sw) * t_mask(i_sw,j_sw)
         else
            field(i_sw-1,j_sw-1) = field(i_sw,j_sw) * u_mask(i_sw,j_sw)
            field(max(isd,i_sw-2),j_sw-1) = field(i_sw,j_sw) * u_mask(i_sw,j_sw)
            field(i_sw-1,max(jsd,j_sw-2)) = field(i_sw,j_sw) * u_mask(i_sw,j_sw)
            field(max(isd,i_sw-2),max(jsd,j_sw-2)) = field(i_sw,j_sw) * u_mask(i_sw,j_sw)
         endif
      endif
      if ( south_east_corner ) then
         if(grid_type == 'T') then
            field(i_se+1,j_se-1) = field(i_se,j_se) * t_mask(i_se,j_se)
            field(min(ied,i_se+2),j_se-1) = field(i_se,j_se) * t_mask(i_se,j_se)
            field(i_se+1,max(jsd,j_se-2)) = field(i_se,j_se) * t_mask(i_se,j_se)
            field(min(ied,i_se+2),max(jsd,j_se-2)) = field(i_se,j_se) * t_mask(i_se,j_se)
         else
            field(i_se+1,j_se-1) = field(i_se,j_se) * u_mask(i_se,j_se)
            field(min(ied,i_se+2),j_se-1) = field(i_se,j_se) * u_mask(i_se,j_se)
            field(i_se+1,max(jsd,j_se-2)) = field(i_se,j_se) * u_mask(i_se,j_se)
            field(min(ied,i_se+2),max(jsd,j_se-2)) = field(i_se,j_se) *u_mask(i_se,j_se)
         endif
      endif
      if ( north_west_corner ) then
         if(grid_type == 'T') then
            field(i_nw-1,j_nw+1) = field(i_nw,j_nw) * t_mask(i_nw,j_nw)
            field(i_nw-1,min(jed,j_nw+2)) = field(i_nw,j_nw) * t_mask(i_nw,j_nw)
            field(max(isd,i_nw-2),j_nw+1) = field(i_nw,j_nw) * t_mask(i_nw,j_nw)
            field(max(isd,i_nw-2),min(jed,j_nw+2)) = field(i_nw,j_nw) * t_mask(i_nw,j_nw)
         else
            field(i_nw-1,j_nw+1) = field(i_nw,j_nw) * u_mask(i_nw,j_nw)
            field(i_nw-1,min(jed,j_nw+2)) = field(i_nw,j_nw) * u_mask(i_nw,j_nw)
            field(max(isd,i_nw-2),j_nw+1) = field(i_nw,j_nw) * u_mask(i_nw,j_nw)
            field(max(isd,i_nw-2),min(jed,j_nw+2)) = field(i_nw,j_nw) * u_mask(i_nw,j_nw)
         endif
      endif
      if ( north_east_corner ) then
         if(grid_type == 'T') then
            field(i_ne+1,j_ne+1) = field(i_ne,j_ne) * t_mask(i_ne,j_ne)
            field(i_ne+1,min(jed,j_ne+2)) = field(i_ne,j_ne) * t_mask(i_ne,j_ne)
            field(min(ied,i_ne+2),j_ne+1) = field(i_ne,j_ne) * t_mask(i_ne,j_ne)
            field(min(ied,i_ne+2),min(jed,j_ne+2)) = field(i_ne,j_ne) * t_mask(i_ne,j_ne)
         else
            field(i_ne+1,j_ne+1) = field(i_ne,j_ne) * u_mask(i_ne,j_ne)
            field(i_ne+1,min(jed,j_ne+2)) = field(i_ne,j_ne) * u_mask(i_ne,j_ne)
            field(min(ied,i_ne+2),j_ne+1) = field(i_ne,j_ne) * u_mask(i_ne,j_ne)
            field(min(ied,i_ne+2),min(jed,j_ne+2)) = field(i_ne,j_ne) * u_mask(i_ne,j_ne)
         endif
      endif

   enddo

    return

  end subroutine ocean_obc_update_boundary_2d
  !</SUBROUTINE> NAME="ocean_obc_update_boundary_2d"


  !#####################################################################
  !--- update field on the halo points at the boundaries 
  !<SUBROUTINE NAME="ocean_obc_update_boundary_3d" INTERFACE="ocean_obc_update_boundary">
  !   <INOUT NAME="field" TYPE="real, dimension(:,:,:)"></INOUT> 
  subroutine ocean_obc_update_boundary_3d(field,grid_type,update_type)
    real, dimension(isd:,jsd:,:), intent(inout) :: field
    character(len=1),                intent(in) :: grid_type
    character(len=1), optional,      intent(in) :: update_type
    integer :: k, n3

    n3 = size(field,3)
    if(PRESENT(update_type)) then
      do k = 1, n3
        call ocean_obc_update_boundary_2d(field(:,:,k),grid_type,update_type)
      enddo
    else
      do k = 1, n3
        call ocean_obc_update_boundary_2d(field(:,:,k),grid_type)
      enddo
    endif
    return
  end subroutine ocean_obc_update_boundary_3d
  !</SUBROUTINE> NAME="ocean_obc_update_boundary_3d"


  !#####################################################################
  !--- set field on the boundaries to zero, do not change halos
  !<SUBROUTINE NAME="ocean_obc_zero_boundary_2d" INTERFACE="ocean_obc_zero_boundary">
  subroutine ocean_obc_zero_boundary_2d(field, grid_type)

    real, dimension(isd:,jsd:), intent(inout)  :: field
    character(len=1),           intent(in) :: grid_type

    integer :: i, j, m
    
    if(grid_type .ne. 'T' .and. grid_type .ne. 'C'.and. grid_type .ne. 'Z'.and. grid_type .ne. 'M') call mpp_error(FATAL, &
     'ocean_obc_barotrop_mod(ocean_obc_zero_boundary) : grid_type= '// grid_type//' should be either "T", "C", "Z" or "M" ')
    
    do m = 1, nobc
      !--- if on current pe there is no point on the bound, then just return
      if(.not.Obc%bound(m)%on_bound) cycle
            
      select case( Obc%bound(m)%direction )
      
      case (WEST)  
        if( grid_type == 'Z' ) cycle  

        i = Obc%bound(m)%is

        do j = Obc%bound(m)%jsd, Obc%bound(m)%jed
          if(Obc%bound(m)%mask(j)) field(i,j) = 0.
        enddo

      case (EAST)
        if( grid_type == 'Z' ) cycle  
        
        if( grid_type == 'T' ) then
          i = Obc%bound(m)%is 
        else
          i = Obc%bound(m)%is - 1
        endif  
        do j = Obc%bound(m)%jsd, Obc%bound(m)%jed
          if(Obc%bound(m)%mask(j)) field(i,j) = 0.
        enddo

      case (SOUTH)
        if( grid_type == 'M' ) cycle  

        j = Obc%bound(m)%js 
        do i = Obc%bound(m)%isd, Obc%bound(m)%ied
          if(Obc%bound(m)%mask(i)) field(i,j) = 0.
        enddo
        
      case (NORTH)
        if( grid_type == 'M' ) cycle  

        if( grid_type == 'T' ) then
          j = Obc%bound(m)%js 
        else
          j = Obc%bound(m)%js - 1
        endif  
        do i = Obc%bound(m)%isd, Obc%bound(m)%ied
          if(Obc%bound(m)%mask(i)) field(i,j) = 0.
        enddo
        
      end select

    enddo

    return

  end subroutine ocean_obc_zero_boundary_2d
  !</SUBROUTINE> NAME="ocean_obc_zero_boundary_2d"


  !#####################################################################
! <SUBROUTINE NAME="ocean_obc_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocean_obc_restart(time_stamp, ctrop_chksum)
  character(len=*), intent(in), optional    :: time_stamp
  integer(LONG_KIND), intent(out), optional :: ctrop_chksum

   if(present(ctrop_chksum)) ctrop_chksum = mpp_chksum(ctrop(COMP))
   call reset_field_pointer(Obc_restart, id_restart(1), ctrop(:,:) )

   call save_restart(Obc_restart, time_stamp)

end subroutine ocean_obc_restart
! </SUBROUTINE> NAME="ocean_obc_restart"


  !#####################################################################
  !--- release memory --------------------------------------------------
  !<SUBROUTINE NAME="ocean_obc_end">
  ! <DESCRIPTION>
  !    Destructor routine. Release memory.
  !   </DESCRIPTION>
  !   <OUT NAME="have_obc" TYPE="logical">
  !      Contains open boundary information
  !   </OUT>

  subroutine ocean_obc_end(Time)

    type(ocean_time_type), intent(in) :: Time
    integer(LONG_KIND)                :: ctrop_chksum
    integer :: m

  integer :: stdoutunit 
  stdoutunit=stdout() 

    do m = 1, nobc
      if(obc_out_unit(m) .NE. stdoutunit ) then
         call mpp_close(obc_out_unit(m))
      endif
    enddo   
    call ocean_obc_restart(ctrop_chksum=ctrop_chksum)
    
    write(stdoutunit,*) ' '
    write(stdoutunit,*) &
        'From ocean_obc_barotrop_mod: ending obc chksums'
    call write_timestamp(Time%model_time)

    write(stdoutunit,*) &
        'chksum for phase speed            = ', ctrop_chksum

    call write_chksum_2d('relaxation coefficient', rel_coef(COMP))
    call write_chksum_2d('eta_tm1', eta_tm1(COMP))
    call write_chksum_2d('eta_t_tm1', eta_t_tm1(COMP))
    
    deallocate( Obc%bound )

    module_is_initialized = .FALSE.
    
    nullify(Dom)
    
    return

  end subroutine ocean_obc_end
  !</SUBROUTINE> NAME="ocean_obc_end"


  !#######################################################################
  !<SUBROUTINE NAME="phase_speed_IOW">
  subroutine phase_speed_IOW(Bound, Data, eta, taum1, taup1, tstep, init)

    type(obc_bound_type),         intent(inout) :: Bound
    type(obc_data_type_2d) ,      intent(in)    :: Data
    real, dimension(isd:,jsd:,:), intent(in)    :: eta
    integer,                      intent(in)    :: taum1, taup1
    real, intent(in)                            :: tstep
    logical, intent(in), optional               :: init

    real    :: cgrid, detai, cmax, cmin, cinc, c1tmp, rfak
    integer :: i, j
    integer :: n, i1, i2, j1, j2
    real, dimension(:,:), pointer :: dg
    real :: dt
    real :: scale, f1, f2
    logical :: init_f

    ! Set variables for calculating the barotropic phase speed in the 
    !first call of the barotropic OBC. Usually, eta is Ext_mode%eta_t 
    ! or Ext_mode%eta_t_bar with splitting on.
    init_f = .false.
    if (PRESENT(init)) init_f = init
    
    if (init_f) then
       dt = dtbt
       scale = dtbt / tstep
       f1 = 0.0
       f2 = 1.0
    else
       dt = tstep
       scale = 1.0
       f1 = Bound%ctrop_smooth
       f2 = 1. - Bound%ctrop_smooth
    endif

    ! If on current pe there is no point on the bound, then just return
    if(.not. Bound%on_bound) return
    
    ! Set pointers
    if(Bound%direction == WEST .or. Bound%direction == EAST) then
       dg => dxu_bt
    else
       dg => dyu_bt
    endif
    
    do n = 1, Bound%nlod

       i = Bound%ilod(n)
       j = Bound%jlod(n)
       i1 = i  + Bound%imap
       j1 = j  + Bound%jmap
       i2 = i1 + Bound%imap
       j2 = j1 + Bound%jmap
 
       cgrid = dg(i1,j1)/dt
       detai = (eta(i1,j1,taup1) - eta(i2,j2,taup1) )
       ! clip with shallow water phase speed and CFL-phase speed
       cmax  = min(Bound%ctrop_max * Bound%dsur(n), cgrid)
       cmin  = Bound%ctrop_min * Bound%dsur(n)
       cinc  = Bound%ctrop_inc * cgrid
       if (ABS(detai).lt. small) then
          if (init_f) then
             ! badly defined phases -> move this feature out with 
             ! barotropic phase speed
             c1tmp = cmax
          else
             ! badly defined phases -> do (about) nothing
             c1tmp = 0.99*ctrop(i,j)
          endif
       else
          ! implicit time scheme for internal points
          c1tmp = cgrid*(eta(i1,j1,taum1)-eta(i1,j1,taup1))/detai * scale
       endif
       ! If incoming waves are detected:
       ! -> replace undesired incoming waves by outgoing waves
        if (c1tmp .le. 0.0) then
          ctrop(i,j) = cinc
       else
          c1tmp = min(cmax,c1tmp)  ! cmax is the phase speed limit
          c1tmp = max(cmin,c1tmp)  ! ensure minimum phase speed
          ! mix with previous phase values
          ctrop(i,j) = f1*ctrop(i,j) + f2*c1tmp
       endif
       ! Find the relaxation coefficient
       ! Relax with rel_coef_in for incoming waves and rel_coef_out 
       ! otherwise a smooth transition is needed            
        rfak = ctrop(i,j)/cmax
       rel_coef(i,j) = rfak * Data%rel_coef_out + (1.0-rfak) * Data%rel_coef_in
    enddo

!kk  Changes for Halos > 1 have to be done
   ! Corner cells
    if ( south_west_corner ) then
       rel_coef(i_sw,j_sw) =  (rel_coef(i_sw+1,j_sw)+rel_coef(i_sw,j_sw+1))*0.5
    endif
    if ( south_east_corner ) then
       rel_coef(i_se,j_se) =  (rel_coef(i_se-1,j_se)+rel_coef(i_se,j_se+1))*0.5
    endif
    if ( north_east_corner ) then
       rel_coef(i_ne,j_ne) =  (rel_coef(i_ne-1,j_ne)+rel_coef(i_ne,j_ne-1))*0.5
    endif
    if ( north_west_corner ) then
       rel_coef(i_nw,j_nw) =  (rel_coef(i_nw+1,j_nw)+rel_coef(i_nw,j_nw-1))*0.5
    endif

    return
  end subroutine phase_speed_IOW
  !</SUBROUTINE> NAME="phase_speed_IOW"


  !#######################################################################
  !<SUBROUTINE NAME="phase_speed_ORLANS">
  subroutine phase_speed_ORLANS(Bound, Data, eta, tau, taup1, tstep, init)

    type(obc_bound_type),         intent(inout) :: Bound
    type(obc_data_type_2d) ,      intent(in)    :: Data
    real, dimension(isd:,jsd:,:), intent(in)    :: eta
    integer,                      intent(in)    :: tau, taup1
    real, intent(in)                            :: tstep
    logical, intent(in), optional               :: init

    real    :: cgrid, detai, cmax, cmin, cinc, c1tmp, rfak
    integer :: i, j
    integer :: n, i1, i2, j1, j2
    real, dimension(:,:), pointer :: dg, eta_taum1
    real :: dt
    real :: scale, f1, f2
    logical :: init_f

    ! Set variables for calculating the barotropic phase speed in the 
    !first call of the barotropic OBC. Usually, eta is Ext_mode%eta_t 
    ! or Ext_mode%eta_t_bar with splitting on.
    init_f = .false.
    if (PRESENT(init)) init_f = init
    
    if (init_f) then
       dt = dtbt
       scale = dtbt / tstep
       f1 = 0.0
       f2 = 1.0
       eta_taum1 => eta_t_tm1
    else
       dt = tstep
       scale = 1.0
       f1 = Bound%ctrop_smooth
       f2 = 1. - Bound%ctrop_smooth
       eta_taum1 => eta_tm1
    endif

    ! If on current pe there is no point on the bound, then just return
    if(.not. Bound%on_bound) return

    ! Set pointers
    if(Bound%direction == WEST .or. Bound%direction == EAST) then
       dg => dxu_bt
    else
       dg => dyu_bt
    endif

    do n = 1, Bound%nlod

       i = Bound%ilod(n)
       j = Bound%jlod(n)
       i1 = i + Bound%imap
       j1 = j + Bound%jmap
       i2 = i1 + Bound%imap
       j2 = j1 + Bound%jmap

       cgrid = dg(i1,j1)/dt
       detai = eta(i1,j1,taup1) + eta_taum1(i1,j1) - 2.0 * eta(i2,j2,tau)
       ! clip with shallow water phase speed and CFL-phase speed
       cmax  = min(Bound%ctrop_max * Bound%dsur(n), cgrid)
       cmin  = Bound%ctrop_min * Bound%dsur(n)
       cinc  = Bound%ctrop_inc * cgrid
       if (ABS(detai).lt. small) then
          if (init_f) then
             ! badly defined phases -> move this feature out with 
             ! barotropic phase speed
             c1tmp = cmax
          else
             ! badly defined phases -> do (about) nothing
             c1tmp = ctrop(i,j)
          endif
       else
          ! implicit time scheme for internal points
          c1tmp = cgrid*(eta_taum1(i1,j1)-eta(i1,j1,taup1))/detai * scale
       endif
       ! If incoming waves are detected:
       ! -> replace undesired incoming waves by outgoing waves
       if (c1tmp .le. 0.0) then
          ctrop(i,j) = cinc
       else
          c1tmp = min(cmax,c1tmp)  ! cmax is the phase speed limit
          c1tmp = max(cmin,c1tmp)  ! ensure minimum phase speed
          ! mix with previous phase values
          ctrop(i,j) = f1*ctrop(i,j) + f2*c1tmp
       endif
       ! Find the relaxation coefficient
       ! Relax with rel_coef_in for incoming waves and rel_coef_out 
       ! otherwise a smooth transition is needed            
       rfak = ctrop(i,j)/cmax
       rel_coef(i,j) = rfak * Data%rel_coef_out + (1.0-rfak) * Data%rel_coef_in
    enddo

    ! Corner cells
    if ( south_west_corner ) then
       rel_coef(i_sw,j_sw) =  (rel_coef(i_sw+1,j_sw)+rel_coef(i_sw,j_sw+1))*0.5
    endif
    if ( south_east_corner ) then
       rel_coef(i_se,j_se) =  (rel_coef(i_se-1,j_se)+rel_coef(i_se,j_se+1))*0.5
    endif
    if ( north_east_corner ) then
       rel_coef(i_ne,j_ne) =  (rel_coef(i_ne-1,j_ne)+rel_coef(i_ne,j_ne-1))*0.5
    endif
    if ( north_west_corner ) then
       rel_coef(i_nw,j_nw) =  (rel_coef(i_nw+1,j_nw)+rel_coef(i_nw,j_nw-1))*0.5
    endif

    return
  end subroutine phase_speed_ORLANS
  !</SUBROUTINE> NAME="phase_speed_ORLANS"


  !#######################################################################
  !<SUBROUTINE NAME="phase_speed_GRAVTY">
  subroutine phase_speed_GRAVTY(Bound, Data)

    type(obc_bound_type),         intent(inout) :: Bound
    type(obc_data_type_2d),       intent(in)    :: Data
    
    integer :: i, j, n

    ! If on current pe there is no point on the bound, then just return
    if(.not. Bound%on_bound) return

    do n = 1, Bound%nlod
       i  = Bound%ilod(n)
       j  = Bound%jlod(n)
       ctrop(i,j) = Bound%dsur(n)
       ! Find the relaxation coefficient
       ! Relax with rel_coef_out 
       rel_coef(i,j) = Data%rel_coef_out
    enddo

    ! Corner cells
    if ( south_west_corner ) then
       rel_coef(i_sw,j_sw) =  (rel_coef(i_sw+1,j_sw)+rel_coef(i_sw,j_sw+1))*0.5
    endif
    if ( south_east_corner ) then
       rel_coef(i_se,j_se) =  (rel_coef(i_se-1,j_se)+rel_coef(i_se,j_se+1))*0.5
    endif
    if ( north_east_corner ) then
       rel_coef(i_ne,j_ne) =  (rel_coef(i_ne-1,j_ne)+rel_coef(i_ne,j_ne-1))*0.5
    endif
    if ( north_west_corner ) then
       rel_coef(i_nw,j_nw) =  (rel_coef(i_nw+1,j_nw)+rel_coef(i_nw,j_nw-1))*0.5
    endif

    return
  end subroutine phase_speed_GRAVTY
  !</SUBROUTINE> NAME="phase_speed_GRAVTY"


  !#######################################################################
  !<SUBROUTINE NAME="phase_speed_MILLER">
  subroutine phase_speed_MILLER(Bound, Data, eta, tau, taup1, tstep, init)

    type(obc_bound_type),         intent(inout) :: Bound
    type(obc_data_type_2d) ,      intent(in)    :: Data
    real, dimension(isd:,jsd:,:), intent(in)    :: eta
    integer,                      intent(in)    :: tau, taup1
    real, intent(in)                            :: tstep
    logical, intent(in), optional               :: init

    real    :: cgrid, cmax, cmin, cinc, c1tmp, rfak
    integer :: i, j
    integer :: n, i1, i2, j1, j2
    real, dimension(:,:), pointer :: dg, eta_taum1
    real :: dt
    real :: scale, f1, f2, r1, r2, r3
    logical :: init_f

    ! Set variables for calculating the barotropic phase speed in the 
    !first call of the barotropic OBC. Usually, eta is Ext_mode%eta_t 
    ! or Ext_mode%eta_t_bar with splitting on.
    init_f = .false.
    if (PRESENT(init)) init_f = init
    
    if (init_f) then
       dt = dtbt
       scale = dtbt / tstep
       f1 = 0.0
       f2 = 1.0
       eta_taum1 => eta_t_tm1
    else
       dt = tstep
       scale = 1.0
       f1 = Bound%ctrop_smooth
       f2 = 1. - Bound%ctrop_smooth
       eta_taum1 => eta_tm1
    endif

    ! If on current pe there is no point on the bound, then just return
    if(.not. Bound%on_bound) return

    ! Set pointers
    if(Bound%direction == WEST .or. Bound%direction == EAST) then
       dg => dxu_bt
    else
       dg => dyu_bt
    endif

    do n = 1, Bound%nlod

       i = Bound%ilod(n)
       j = Bound%jlod(n)
       i1 = i + Bound%imap
       j1 = j + Bound%jmap
       i2 = i1 + Bound%imap
       j2 = j1 + Bound%jmap

       cgrid = dg(i1,j1)/dt

       r1 = eta(i2,j2,tau) - eta(i1,j1,tau)
       r2 = eta_taum1(i1,j1) - eta_taum1(i,j)
       r3 = eta_taum1(i2,j2) - eta_taum1(i1,j1)
       ! clip with shallow water phase speed and CFL-phase speed
       cmax  = min(Bound%ctrop_max * Bound%dsur(n), cgrid)
       cmin  = Bound%ctrop_min * Bound%dsur(n)
       cinc  = Bound%ctrop_inc * cgrid
       if (ABS(r1).lt. small) then
          r1 = cmax
       else
          r1 = (eta(i1,j1,taup1) - eta(i1,j1,tau)) / r1
       endif
       if (ABS(r2).lt. small) then
          r2 = cmax
       else
          r2 = (eta(i,j,tau) - eta_taum1(i,j)) / r2
       endif
       if (ABS(r3).lt. small) then
          r3 = cmax
       else
          r3 = (eta(i1,j1,tau) - eta_taum1(i1,j1)) / r3
       endif
       c1tmp = cgrid * (r1 + r2 - r3) * scale;
       
       ! If incoming waves are detected:
       ! -> replace undesired incoming waves by outgoing waves
       if (c1tmp .le. 0.0) then
          ctrop(i,j) = cinc
       else
          c1tmp = min(cmax,c1tmp)  ! cmax is the phase speed limit
          c1tmp = max(cmin,c1tmp)  ! ensure minimum phase speed
          ! mix with previous phase values
          ctrop(i,j) = f1*ctrop(i,j) + f2*c1tmp
       endif
       ! Find the relaxation coefficient
       ! Relax with rel_coef_in for incoming waves and rel_coef_out 
       ! otherwise a smooth transition is needed            
       rfak = ctrop(i,j)/cmax
       rel_coef(i,j) = rfak * Data%rel_coef_out + (1.0-rfak) * data%rel_coef_in
    enddo

    ! Corner cells
    if ( south_west_corner ) then
       rel_coef(i_sw,j_sw) =  (rel_coef(i_sw+1,j_sw)+rel_coef(i_sw,j_sw+1))*0.5
    endif
    if ( south_east_corner ) then
       rel_coef(i_se,j_se) =  (rel_coef(i_se-1,j_se)+rel_coef(i_se,j_se+1))*0.5
    endif
    if ( north_east_corner ) then
       rel_coef(i_ne,j_ne) =  (rel_coef(i_ne-1,j_ne)+rel_coef(i_ne,j_ne-1))*0.5
    endif
    if ( north_west_corner ) then
       rel_coef(i_nw,j_nw) =  (rel_coef(i_nw+1,j_nw)+rel_coef(i_nw,j_nw-1))*0.5
    endif

    return
  end subroutine phase_speed_MILLER
  !</SUBROUTINE> NAME="phase_speed_MILLER"


  !#######################################################################
  !<SUBROUTINE NAME="phase_speed_RAYMND">
  subroutine phase_speed_RAYMND(Bound, Data, eta, tau, taup1, tstep, init)

    type(obc_bound_type),         intent(inout) :: Bound
    type(obc_data_type_2d) ,      intent(in)    :: Data
    real, dimension(isd:,jsd:,:), intent(in)    :: eta
    integer,                      intent(in)    :: tau, taup1
    real, intent(in)                            :: tstep
    logical, intent(in), optional               :: init


    real    :: cgrid, detat, cmax, cmin, cinc, c1tmp, rfak
    real    :: rx, ry, dx, dy, d, dmp, dmm, dm
    integer :: i, j
    integer :: n, i1, i2, j1, j2
    integer :: ip, jp, im, jm, i1p, j1p, i1m, j1m
    real, dimension(:,:), pointer :: dg, eta_taum1
    real :: dt
    real :: scale, f1, f2
    logical :: init_f

    ! Set variables for calculating the barotropic phase speed in the 
    !first call of the barotropic OBC. Usually, eta is Ext_mode%eta_t 
    ! or Ext_mode%eta_t_bar with splitting on.
    init_f = .false.
    if (PRESENT(init)) init_f = init
    
    if (init_f) then
       dt = dtbt
       scale = dtbt / tstep
       f1 = 0.0
       f2 = 1.0
       eta_taum1 => eta_t_tm1
    else
       dt = tstep
       scale = 1.0
       f1 = Bound%ctrop_smooth
       f2 = 1. - Bound%ctrop_smooth
       eta_taum1 => eta_tm1
    endif

    ! If on current pe there is no point on the bound, then just return
    if(.not. Bound%on_bound) return

    if(Bound%direction == WEST .or. Bound%direction == EAST) then
       dg => dxu_bt
    else
       dg => dyu_bt
    endif

    do n = 1, Bound%nloc

       i = Bound%iloc(n)
       j = Bound%jloc(n)
       i1 = i + Bound%imap
       j1 = j + Bound%jmap
       i2 = i1 + Bound%imap
       j2 = j1 + Bound%jmap
       ip = i + Bound%imapt
       jp = j + Bound%jmapt
       im = i - Bound%imapt
       jm = j - Bound%jmapt
       i1p = i1 + Bound%imapt
       j1p = j1 + Bound%jmapt
       i1m = i1 - Bound%imapt
       j1m = j1 - Bound%jmapt
       dmp = t_mask(i1p,j1p)
       dmm = t_mask(i1m,j1m)
       dm  = t_mask(i1,j1)

       cgrid = dg(i1,j1)/dt !! scaling factor for phase speeds
                            !! The maximum non-dimensional CFL  phase speed, c*
                            !! is unity where c* = c[m s-1]/cgrid[m s-1]        
                              

! clip with shallow water phase speed and CFL-phase speed
! csur = sqrt(gH)
       
       cmax  = min(Bound%ctrop_max * Bound%dsur(n), cgrid)
       cmin  = Bound%ctrop_min * Bound%dsur(n)
       cinc  = Bound%ctrop_inc * cgrid

       ! Difference in time
       detat = eta(i1,j1,taup1) - eta_taum1(i1,j1)

       ! Difference in space
       dx = eta(i1,j1,taup1) - eta(i2,j2,taup1)
       dy = detat * (eta(i1p,j1p,tau) - eta(i1m,j1m,tau))
       if (dy > 0.0) then
          dy = eta(i1,j1,tau) - eta(i1m,j1m,tau) ! [m]
       else
          dy = eta(i1p,j1p,tau) - eta(i1,j1,tau) 
       endif
! set dy to zero, if one of the tangent points is land. Otherwise either
! the first check is wrong or dy is not well defined.
! This does not fit well in the B-grid scheme ... 
       dy = dy * dm * dmp * dmm 
       d = dx * dx + dy * dy 

       ! Normal phase speed
       if (ABS(d).lt. small) then
          rx = cmax
       else
          rx = max(0.0, -detat * dx / d)          ! [nd]
!!!!          rx = min(max(0.0, -detat * dx / d), cmax)
       endif

      ! [m s-1]
       c1tmp = cgrid * rx * scale

       ! Tangential phase speed
       ry = 0.0
       if (rx /= 0 .and. d /= 0) ry = -detat * dy / d
       if (ry > 0.0) then
          ry = min(ry,Bound%ctrop_max)
          d = eta(i,j,tau) - eta(im,jm,tau)
       else
          ry = max(ry,-1*Bound%ctrop_max)          
          d = eta(ip,jp,tau) - eta(i,j,tau)
       endif
! The tangent component must be zero, if one of the neigbours is land. 
       Bound%dum(n) = ry *d * dm * dmp * dmm
       ! Note : eta(i,j,taup1) = (eta(i,j,tau) +  &
       !                          rx * eta(i1,j1,taup1) - ry * d) / &
       !                         (1 + rx)

       ! If incoming waves are detected:
       ! -> replace undesired incoming waves by outgoing waves
       if (c1tmp .le. 0.0) then
          ctrop(i,j) = cinc
       else
          c1tmp = min(cmax,c1tmp)  ! cmax is the phase speed limit
          c1tmp = max(cmin,c1tmp)  ! ensure minimum phase speed
          ! mix with previous phase values
          ctrop(i,j) = f1*ctrop(i,j) + f2*c1tmp
       endif
       ! Find the relaxation coefficient
       ! Relax with rel_coef_in for incoming waves and rel_coef_out 
       ! otherwise a smooth transition is needed            
       rfak = ctrop(i,j)/cmax
       rel_coef(i,j) = rfak * Data%rel_coef_out + (1.0-rfak) * data%rel_coef_in

    enddo

    ! Corner cells
    if ( south_west_corner ) then
       rel_coef(i_sw,j_sw) =  (rel_coef(i_sw+1,j_sw)+rel_coef(i_sw,j_sw+1))*0.5
    endif
    if ( south_east_corner ) then
       rel_coef(i_se,j_se) =  (rel_coef(i_se-1,j_se)+rel_coef(i_se,j_se+1))*0.5
    endif
    if ( north_east_corner ) then
       rel_coef(i_ne,j_ne) =  (rel_coef(i_ne-1,j_ne)+rel_coef(i_ne,j_ne-1))*0.5
    endif
    if ( north_west_corner ) then
       rel_coef(i_nw,j_nw) =  (rel_coef(i_nw+1,j_nw)+rel_coef(i_nw,j_nw-1))*0.5
    endif

    return
  end subroutine phase_speed_RAYMND
  !</SUBROUTINE> NAME="phase_speed_RAYMND"


  !#######################################################################
  !<FUNCTION NAME="boundary_average">
  function boundary_average(Bound, data)
     real,    dimension(:),    intent(in) :: data
     type(obc_bound_type),  intent(inout) :: Bound             ! lateral boundary data
     real                                 :: boundary_average     
     integer                              :: nlist, n, sendsize, index

     if(Bound%on_bound) then
        nlist = size(Bound%pelist(:))
        index = Bound%index
        sendsize = Bound%end(Bound%index)-Bound%start(index) + 1
        if(size(data) .NE. sendsize ) call mpp_error(FATAL, &
             "ocean_obc_barotrop_mod: size mismatch between data and boundary index")
        Bound%buffer(Bound%start(index):Bound%end(index)) = data(:)
        do n = 1, nlist
           if(mpp_pe() .NE. Bound%pelist(n) ) then
              call mpp_send(Bound%buffer(Bound%start(index)), plen=sendsize, to_pe=Bound%pelist(n))
           end if
        end do

        !--- receive the data
        do n = 1, nlist
           if(mpp_pe() .NE. Bound%pelist(n) ) then
              call mpp_recv(Bound%buffer(Bound%start(n)), glen=Bound%end(n)-Bound%start(n)+1, from_pe=Bound%pelist(n))
           end if
        end do
     end if

     call mpp_sync_self(Bound%pelist)
     if(Bound%on_bound) then
        boundary_average = sum(Bound%buffer)/Bound%np
     else
        boundary_average = 0
     end if

  end function boundary_average
  !</FUNCTION> NAME="boundary_average"


  !#######################################################################
  !<SUBROUTINE NAME="check_eta_OBC">
  subroutine check_eta_OBC(obc, name)
     integer, intent(in)                :: obc
     character(len=*), intent(in)       :: name
     integer                            :: n, m, nl, code;

     if(obc == 0) &
          call mpp_error(FATAL,' Invalid eta OBC: '//name)
     nl = 1
     n = 0
     code = 0
     if (index(trim(name),'|') /= 0) then
        nl = 2
        n = -1
     endif
     do m = 1, nl
        if (iand(code, NOTHIN) /= NOTHIN .and. index(trim(name),'NOTHIN') /= 0) then
           n = n + 1
           code = code + NOTHIN
        endif
        if (iand(code, FILEIN) /= FILEIN .and. index(trim(name),'FILEIN') /= 0) then
           n = n + 1
           code = code + FILEIN
        endif
        if (iand(code, MEANIN) /= MEANIN .and. index(trim(name),'MEANIN') /= 0) then
           n = n + 1
           code = code + MEANIN
        endif
        if (iand(code, FLATHR) /= FLATHR .and. index(trim(name),'FLATHR') /= 0) then
           n = n + 1
           code = code + FLATHR
        endif
        if (iand(code, NOGRAD) /= NOGRAD .and. index(trim(name),'NOGRAD') /= 0) then
           n = n + 1
           code = code + NOGRAD
        endif
        if (iand(code, ORLANS) /= ORLANS .and. index(trim(name),'ORLANS') /= 0) then
           n = n + 1
           code = code + ORLANS
        endif
        if (iand(code, CAMOBR) /= CAMOBR .and. index(trim(name),'CAMOBR') /= 0) then
           n = n + 1
           code = code + CAMOBR
        endif
        if (iand(code, GRAVTY) /= GRAVTY .and. index(trim(name),'GRAVTY') /= 0) then
           n = n + 1
           code = code + GRAVTY
        endif
        if (iand(code, MILLER) /= MILLER .and. index(trim(name),'MILLER') /= 0) then
           n = n + 1
           code = code + MILLER
        endif
        if (iand(code, RAYMND) /= RAYMND .and. index(trim(name),'RAYMND') /= 0) then
           n = n + 1
           code = code + RAYMND
        endif
        if (iand(code, IOW) /= IOW .and. index(trim(name),'IOW') /= 0) then
           n = n + 1
           code = code + IOW
        endif
     enddo
     if (n /= 1) &
          call mpp_error(FATAL,' Invalid eta OBC: '//name)
     
  end subroutine check_eta_OBC
  !</SUBROUTINE> NAME="check_eta_OBC"


  !#######################################################################
  !<SUBROUTINE NAME="mpp_update_domains_obc">
  subroutine mpp_update_domains_obc(Domain)
    type (ocean_domain_type),intent(inout)           :: Domain

! make an incomlete communication, it will be completed in the calling subroutine
      call mpp_update_domains(ctrop   , Domain%domain2d, complete=.false.)
      if (update_eta_tm1)   &
      call mpp_update_domains(eta_tm1 , Domain%domain2d, complete=.false.)
    return
  end subroutine mpp_update_domains_obc

end module ocean_obc_barotrop_mod
 !</SUBROUTINE> NAME="mpp_update_domains_obc"

!FDOC_TAG_GFDL

module cu_mo_trans_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  Isaac Held
! </CONTACT>
! <OVERVIEW>
!    A simple module that computes a diffusivity proportional to the 
!    convective mass flux, for use with diffusive 
!    convective momentum transport closure
! </OVERVIEW>
! <DESCRIPTION>
!   A diffusive approximation to convective momentum transport is crude but
!    has been found to be useful in improving the simulation of tropical
!     precipitation in some models.  The diffusivity computed here is
!     simply 
!<PRE>
! diffusivity = c*W*L 
! W = M/rho  (m/sec) 
! M = convective mass flux (kg/(m2 sec)) 
! rho - density of air <p>
! L = depth of convecting layer (m)
! c = normalization constant = diff_norm/g 
!   (diff_norm is a namelist parameter;
!      the factor of g = acceleration of gravity here is an historical artifact) <p>
! for further discussion see 
!     <LINK SRC="cu_mo_trans.pdf">cu_mo_trans.pdf</LINK>
!</PRE>
! </DESCRIPTION>


!=======================================================================
!
!                 DIFFUSIVE CONVECTIVE MOMENTUM TRANSPORT MODULE
!
!=======================================================================

  use   constants_mod, only:  GRAV, RDGAS, RVGAS, CP_AIR
 

  use         mpp_mod, only: input_nml_file
  use         fms_mod, only: file_exist, check_nml_error,    &
                             open_namelist_file, close_file, &
                             write_version_number,           &
                             mpp_pe, mpp_root_pe, stdlog,    &
                             error_mesg, FATAL, NOTE

  use  Diag_Manager_Mod, ONLY: register_diag_field, send_data
  use  Time_Manager_Mod, ONLY: time_type

implicit none
private


! public interfaces
!=======================================================================
public :: cu_mo_trans_init, &
          cu_mo_trans,      &
          cu_mo_trans_end

!=======================================================================

! form of interfaces
!=======================================================================

      
logical :: module_is_initialized = .false.


!---------------diagnostics fields------------------------------------- 

integer :: id_diff_cmt, id_utnd_cmt, id_vtnd_cmt, id_ttnd_cmt, &
           id_massflux_cmt, id_detmf_cmt

character(len=11) :: mod_name = 'cu_mo_trans'

real :: missing_value = -999.
logical  ::  do_diffusive_transport = .false.
logical  ::  do_nonlocal_transport = .false.


!--------------------- namelist variables with defaults -------------

real    :: diff_norm =   1.0
logical :: limit_mass_flux = .false.  ! when true, the mass flux 
                                      ! out of a grid box is limited to
                                      ! the mass in that grid box
character(len=64) :: transport_scheme = 'diffusive'
integer :: non_local_iter = 2  ! iteration count for non-local scheme
logical :: conserve_te = .true.  ! conserve total energy ?
real    ::  gki = 0.7  ! Gregory et. al. constant for p-gradient param
real    :: amplitude = 1.0 ! Tuning parameter (1=full strength)

namelist/cu_mo_trans_nml/ diff_norm, &
                          limit_mass_flux, &
                          non_local_iter, conserve_te, gki, &
                          amplitude,  &
                          transport_scheme


!--------------------- version number ---------------------------------

character(len=128) :: version = '$Id: cu_mo_trans.F90,v 19.0 2012/01/06 20:05:02 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

contains

!#######################################################################

! <SUBROUTINE NAME="cu_mo_trans_init">
!  <OVERVIEW>
!   initializes module
!  </OVERVIEW>
!  <DESCRIPTION>
!   Reads namelist and registers one diagnostic field
!     (diff_cmt:  the kinematic diffusion coefficient)
!  </DESCRIPTION>
!  <TEMPLATE>
!   call cu_mo_trans_init( axes, Time )
!
!  </TEMPLATE>
!  <IN NAME=" axes" TYPE="integer">
!    axes identifier needed by diag manager
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!    time at initialization needed by diag manager
!  </IN>
! </SUBROUTINE>
!
subroutine cu_mo_trans_init( axes, Time, doing_diffusive )

 integer,         intent(in) :: axes(4)
 type(time_type), intent(in) :: Time
 logical,         intent(out) :: doing_diffusive

integer :: unit, ierr, io, logunit
integer, dimension(3)  :: half =  (/1,2,4/)

!------ read namelist ------

   if ( file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=cu_mo_trans_nml, iostat=io)
      ierr = check_nml_error(io,'cu_mo_trans_nml')
#else   
      unit = open_namelist_file ( )
      ierr=1; do while (ierr /= 0)
         read  (unit, nml=cu_mo_trans_nml, iostat=io, end=10)
         ierr = check_nml_error(io,'cu_mo_trans_nml')
      enddo
 10   call close_file (unit)
#endif
   endif

!--------- write version number and namelist ------------------

      call write_version_number(version, tagname)
      logunit = stdlog()
      if ( mpp_pe() == mpp_root_pe() ) &
        write ( logunit, nml=cu_mo_trans_nml )

!----------------------------------------------------------------------
!    define logicals indicating momentum transport scheme to use.
!----------------------------------------------------------------------
      if (trim(transport_scheme) == 'diffusive') then
        do_diffusive_transport = .true.
      else if (trim(transport_scheme) == 'nonlocal') then
        do_nonlocal_transport = .true.
      else
        call error_mesg ('cu_mo_trans', &
         'invalid specification of transport_scheme', FATAL)
      endif

      doing_diffusive = do_diffusive_transport

! --- initialize quantities for diagnostics output -------------

   if (do_diffusive_transport) then
     id_diff_cmt = &
      register_diag_field ( mod_name, 'diff_cmt', axes(1:3), Time,    &
                        'cu_mo_trans coeff for momentum',  'm2/s', &
                         missing_value=missing_value               )
     id_massflux_cmt = &
      register_diag_field ( mod_name, 'massflux_cmt', axes(half), Time, &
                        'cu_mo_trans mass flux',  'kg/(m2 s)', &
                         missing_value=missing_value               )
    else if (do_nonlocal_transport) then 
     id_utnd_cmt = &
      register_diag_field ( mod_name, 'utnd_cmt', axes(1:3), Time,    &
                        'cu_mo_trans u tendency',  'm/s2', &
                         missing_value=missing_value               )
     id_vtnd_cmt = &
      register_diag_field ( mod_name, 'vtnd_cmt', axes(1:3), Time,    &
                        'cu_mo_trans v tendency',  'm/s2', &
                         missing_value=missing_value               )
     id_ttnd_cmt = &
      register_diag_field ( mod_name, 'ttnd_cmt', axes(1:3), Time,    &
                        'cu_mo_trans temp tendency',  'deg K/s', &
                         missing_value=missing_value               )
     id_massflux_cmt = &
      register_diag_field ( mod_name, 'massflux_cmt', axes(half), Time, &
                        'cu_mo_trans mass flux',  'kg/(m2 s)', &
                         missing_value=missing_value               )
     id_detmf_cmt = &
      register_diag_field ( mod_name, 'detmf_cmt', axes(1:3), Time,  &
                      'cu_mo_trans detrainment mass flux',  'kg/(m2 s)',&
                         missing_value=missing_value               )
    endif

!--------------------------------------------------------------

  module_is_initialized = .true.


end subroutine cu_mo_trans_init

!#######################################################################

! <SUBROUTINE NAME="cu_mo_trans_end">
!  <OVERVIEW>
!   terminates module
!  </OVERVIEW>
!  <DESCRIPTION>
!   This is the destructor for cu_mo_trans
!  </DESCRIPTION>
!  <TEMPLATE>
!   call cu_mo_trans_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine cu_mo_trans_end()

  module_is_initialized = .false.

end subroutine cu_mo_trans_end

!#######################################################################

! <SUBROUTINE NAME="cu_mo_trans">
!  <OVERVIEW>
!   picks one of the available cumulus momentum transport parameteriz-
!    ations based on namelist-supplied information (currently diffusive 
!    or non-local options are available).  For the diffusive scheme, it
!    returns a diffusivity proportional to the convective mass 
!    flux. For the non-local scheme temperature, specific humidity and
!    momentum tendencies are returned.
!  </OVERVIEW>
!  <DESCRIPTION>
!  </DESCRIPTION>
!  <TEMPLATE>
!   call cu_mo_trans (is, js, Time, mass_flux, t,           &
!                p_half, p_full, z_half, z_full, diff)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! ! horizontal domain on which computation to be performed is
!    (is:is+size(t,1)-1,ie+size(t,2)-1) in global coordinates
!   (used by diag_manager only)
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
! current time, used by diag_manager
!  </IN>
!  <IN NAME="mass_flux" TYPE="real">
! convective mass flux (Kg/(m**2 s)), dimension(:,:,:), 3rd dimension is
!    vertical level (top down) -- defined at interfaces, so that
!    size(mass_flux,3) = size(p_half,3); entire field processed;
!   all remaining fields are 3 dimensional;
!  size of first two dimensions must confrom for all variables
!  </IN>
!  <IN NAME="t" TYPE="real">
! temperature (K) at full levels, size(t,3) = size(p_full,3)
!  </IN>
!  <IN NAME="p_half" TYPE="real">
! pressure at interfaces (Pascals) 
!  size(p_half,3) = size(p_full,3) + 1
!  </IN>
!  <IN NAME="p_full" TYPE="real">
! pressure at full levels (levels at which temperature is defined)
!  </IN>
!  <IN NAME="z_half" TYPE="real">
! height at half levels (meters); size(z_half,3) = size(p_half,3)
!  </IN>
!  <IN NAME="z_full" TYPE="real">
! height at full levels (meters); size(z_full,3) = size(p_full,3)
!  </IN>
!  <OUT NAME="diff" TYPE="real">
! kinematic diffusivity (m*2/s); defined at half levels 
!   size(diff,3) = size(p_half,3)
!  </OUT>
! </SUBROUTINE>
!




subroutine cu_mo_trans (is, js, Time, mass_flux, t,           &
                        p_half, p_full, z_half, z_full, dt, uin, vin,&
                        tracer, pmass, det0, utnd, vtnd, ttnd, &
                        qtrcumo, diff)

type(time_type), intent(in) :: Time
integer,         intent(in) :: is, js

real,   intent(in) :: dt
real, intent(inout)   , dimension(:,:,:,:) :: tracer           
real, intent(inout)   , dimension(:,:,:) :: uin, vin, t        
real, intent(in)   , dimension(:,:,:) :: mass_flux, &
                                         pmass, det0, &
                                         p_half, p_full, z_half, z_full
real, intent(out), dimension(:,:,:) :: utnd, vtnd          
real, intent(out), dimension(:,:,:) :: ttnd          
real, intent(out), dimension(:,:,:,:) :: qtrcumo                   
real, intent(inout), dimension(:,:,:) :: diff                      


      integer :: im, jm, km, nq, nq_skip

!-----------------------------------------------------------------------

 if (.not.module_is_initialized) call error_mesg ('cu_mo_trans',  &
                      'cu_mo_trans_init has not been called.', FATAL)

!-----------------------------------------------------------------------
!   utnd = 0.
!   vtnd = 0.
!   ttnd = 0.
!   qtrcumo = 0.

    if (do_diffusive_transport) then
      call diffusive_cu_mo_trans (is, js, Time, mass_flux, t,      &
                      p_half, p_full, z_half, z_full, diff)
    utnd = 0.
    vtnd = 0.
    ttnd = 0.
    qtrcumo = 0.
      
    else if (do_nonlocal_transport) then
!      call error_mesg ('cu_mo_trans',  &
!        'non-local transport not currently available', FATAL)
       im = size(uin,1)
       jm = size(uin,2)
       km = size(uin,3)
       nq = size(tracer,4)
       nq_skip = nq
       qtrcumo(:,:,:,1:nq_skip) = 0.0
       call non_local_mot (im, jm, km, is, js, Time, dt, t, uin, vin,  &
                           nq, nq_skip,   &
                 tracer, pmass, mass_flux, det0, utnd, vtnd, ttnd,  &
                 qtrcumo)
    endif

end subroutine cu_mo_trans


!#######################################################################

! <SUBROUTINE NAME="diffusive_cu_mo_trans">
!  <OVERVIEW>
!   returns a diffusivity proportional to the 
!    convective mass flux, for use with diffusive 
!    convective momentum transport closure
!  </OVERVIEW>
!  <DESCRIPTION>
!   A diffusive approximation to convective momentum transport is crude but
!    has been found to be useful in inproving the simulation of tropical
!    precipitation in some models.  The diffusivity computed here is
!    simply 
!<PRE>
! diffusivity = c*W*L
! W = M/rho  (m/sec)
! M = convective mass flux (kg/(m2 sec)) 
! rho - density of air
! L = depth of convecting layer (m)
! c = normalization constant = diff_norm/g
!   (diff_norm is a namelist parameter;
!      the factor of g here is an historical artifact)
! for further discussion see cu_mo_trans.ps
!</PRE>
!  </DESCRIPTION>
!  <TEMPLATE>
!   call diffusive_cu_mo_trans (is, js, Time, mass_flux, t,      &
!                p_half, p_full, z_half, z_full, diff)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! ! horizontal domain on which computation to be performed is
!    (is:is+size(t,1)-1,ie+size(t,2)-1) in global coordinates
!   (used by diag_manager only)
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
! current time, used by diag_manager
!  </IN>
!  <IN NAME="mass_flux" TYPE="real">
! convective mass flux (Kg/(m**2 s)), dimension(:,:,:), 3rd dimension is
!    vertical level (top down) -- defined at interfaces, so that
!    size(mass_flux,3) = size(p_half,3); entire field processed;
!   all remaining fields are 3 dimensional;
!  size of first two dimensions must confrom for all variables
!  </IN>
!  <IN NAME="t" TYPE="real">
! temperature (K) at full levels, size(t,3) = size(p_full,3)
!  </IN>
!  <IN NAME="p_half" TYPE="real">
! pressure at interfaces (Pascals) 
!  size(p_half,3) = size(p_full,3) + 1
!  </IN>
!  <IN NAME="p_full" TYPE="real">
! pressure at full levels (levels at which temperature is defined)
!  </IN>
!  <IN NAME="z_half" TYPE="real">
! height at half levels (meters); size(z_half,3) = size(p_half,3)
!  </IN>
!  <IN NAME="z_full" TYPE="real">
! height at full levels (meters); size(z_full,3) = size(p_full,3)
!  </IN>
!  <OUT NAME="diff" TYPE="real">
! kinematic diffusivity (m*2/s); defined at half levels 
!   size(diff,3) = size(p_half,3)
!  </OUT>
! </SUBROUTINE>
!
subroutine diffusive_cu_mo_trans (is, js, Time, mass_flux, t,     &
                        p_half, p_full, z_half, z_full, diff)

  type(time_type), intent(in) :: Time
  integer,         intent(in) :: is, js

real, intent(in)   , dimension(:,:,:) :: mass_flux, t, &
                                         p_half, p_full, z_half, z_full
real, intent(out), dimension(:,:,:) :: diff                      

real, dimension(size(t,1),size(t,2),size(t,3)) :: rho
real, dimension(size(t,1),size(t,2))           :: zbot, ztop

integer :: k, nlev
logical :: used

!-----------------------------------------------------------------------

 if (.not.module_is_initialized) call error_mesg ('cu_mo_trans',  &
                      'cu_mo_trans_init has not been called.', FATAL)

!-----------------------------------------------------------------------

nlev = size(t,3)

zbot = z_half(:,:,nlev+1)
ztop = z_half(:,:,nlev+1)
  
do k = 2, nlev
  where(mass_flux(:,:,k) .ne. 0.0 .and. mass_flux(:,:,k+1) == 0.0) 
    zbot = z_half(:,:,k)
  endwhere
  where(mass_flux(:,:,k-1) == 0.0 .and. mass_flux(:,:,k) .ne. 0.0) 
    ztop = z_half(:,:,k)
  endwhere
end do

rho  = p_full/(RDGAS*t)  ! density 
   ! (including the virtual temperature effect here might give the 
   ! impression that this theory is accurate to 2%!)

! diffusivity = c*W*L
! W = M/rho  (m/sec)
! M = convective mass flux (kg/(m2 sec)) 
! L = ztop - zbot = depth of convecting layer (m)
! c = normalization constant = diff_norm/g
!   (the factor of g here is an historical artifact)

diff(:,:,1) = 0.0
do k = 2, nlev
  diff(:,:,k) = diff_norm*mass_flux(:,:,k)*(ztop-zbot)/(rho(:,:,k)*GRAV)
end do


! --- diagnostics
     if ( id_diff_cmt > 0 ) then
        used = send_data ( id_diff_cmt, diff, Time, is, js, 1 )
     endif
     if ( id_massflux_cmt > 0 ) then
        used = send_data ( id_massflux_cmt, mass_flux, Time, is, js, 1 )
     endif

end subroutine diffusive_cu_mo_trans


!#######################################################################

 subroutine non_local_mot(im, jm, km, is, js, Time, dt, tin, uin, vin, nq, nq_skip, qin, pmass, mc,       &
                          det0, utnd, vtnd, ttnd, qtnd)
!
! This is a non-local cumulus transport algorithm based on the given cloud mass fluxes (mc).
! Detrainment fluxes are computed internally by mass (or momentum) conservation.
! Simple upwind algorithm is used. It is possible replace the large-scale part by
! a higher-order upwind scheme (such as van Leer or PPM). But the cost is perhaps
! not worth it becasue there is so much uncertainty in the accuracy of the cloud
! mass fluxes.
! Contact Shian-Jiann Lin for more information and a tech-note.
!
   implicit none
  integer, intent(in):: im, jm, km                   ! dimensions
  integer, intent(in):: is, js                                   
  type(time_type), intent(in) :: Time      ! timestamp for diagnmostics
  integer, intent(in):: nq                           ! tracer dimension
  integer, intent(in):: nq_skip                      ! # of tracers to skip
                                ! Here the assumption is that sphum is the #1 tracer
!  integer, intent(in):: iter                         ! Number of iterations
  real,    intent(in):: dt                           ! model time step (seconds)
  real,    intent(inout):: tin (im,jm,km)  ! temperature    
  real,    intent(inout):: uin(im,jm,km), vin(im,jm,km) ! input winds (m/s)
  real,    intent(inout):: qin(im,jm,km,nq)
  real,    intent(in):: pmass(im,jm,km)              ! layer mass (kg/m**2)
  real,    intent(in):: mc(im,jm,km+1)               ! cloud mass flux [kg/(s m**2)]
                                                     ! positive -> upward
  real,    intent(in):: det0(im,jm,km)               ! detrained mass fluxes

!  real,    intent(in):: cp                           ! 
!  real,    intent(in):: gki                          ! Gregory et al constant (0.7)
!  logical, intent(in):: conserve                     ! Conserve Total Energy?
! Output
! added on tendencies
! real,    intent(inout)::ttnd(im,jm,km)             ! temperature due to TE conservation
  real,    intent(out)::ttnd(im,jm,km)             ! temperature due to TE conservation
! real,    intent(inout)::qtnd(im,jm,km,nq)
  real,    intent(out)::qtnd(im,jm,km,nq)

  real,    intent(out)::utnd(im,jm,km), vtnd(im,jm,km)   ! m/s**2
!
! Local 
  real dm1(km), u1(km), v1(km), u2(km), v2(km)
  real q1(km,nq), q2(km,nq), qc(km,nq)
  real uc(km), vc(km)
  real mc1(km+1)
  real mc2(km+1)
  real det1(km), det2(km)

  integer i, j, k, it, iq
  integer ktop, kbot, kdet
  real rdt, ent, fac_mo, fac_t
  real,  parameter:: eps = 1.E-15       ! Cutoff value
! real,  parameter:: amplitude = 1.0    ! Tuning parameter (1=full strength)
  real x_frac
  real rtmp
  logical :: used

  utnd = 0.
  vtnd = 0.
  ttnd =0.
  qtnd = 0.

  rdt   = 1./dt
  fac_mo = amplitude * dt
!  fac_t = 0.5/(dt*cp)
  fac_t = 0.5/(dt*CP_AIR)

!  write(*,*) 'Within non_local_mot, num_tracers=', nq

  do j=1,jm
     do i=1,im

! Copy to 1D arrays to better utilize the cache
        do k=1,km
           dm1(k) = pmass(i,j,k)
        enddo

        do k=1,km
          if (limit_mass_flux) then
 ! Limit mass flux by available layer mass
            mc1(k) = min(dm1(k),   mc(i,j,k)*fac_mo) 
           det1(k) = min(dm1(k), det0(i,j,k)*fac_mo)  
          else
            mc1(k) =  mc(i,j,k)*fac_mo
           det1(k) =  det0(i,j,k)*fac_mo  
          endif
        enddo

!---------------------------
! Locate cloud base
!---------------------------
        kbot = 1
        do k = km,2,-1
           if( mc1(k) > eps ) then
                 kbot = k
                 go to 1111
           endif
        end do
1111    continue

!---------------------------
! Locate cloud top
!---------------------------
        ktop = km
        do k = 1, km-1 
           if( mc1(k+1) > eps ) then
                 ktop = k
                 go to 2222
           endif
        end do
2222    continue

        if ( kbot > ktop+1 ) then    ! ensure there are at least 3 layers to work with

           kdet = ktop
           do k=kbot-1,ktop,-1
              if ( det1(k) > eps ) then
                 kdet = k
                 go to 3333
              endif
           enddo
3333       continue
                                     ! cloudbase, interior, and cloudtop layers
           do k=ktop, kbot
              u1(k) = uin(i,j,k)
              u2(k) = u1(k)
              v1(k) = vin(i,j,k)
              v2(k) = v1(k)
           enddo

        if ( nq_skip < nq ) then
           do iq=nq_skip+1,nq
           do k=ktop, kbot
              q1(k,iq) = qin(i,j,k,iq)
              q2(k,iq) = q1(k,iq)
           enddo
           enddo
        endif

!       do it=1, iter
        do it=1, non_local_iter

!          x_frac = real(it) / real(iter)
           x_frac = real(it) / real(non_local_iter)
           do k=ktop, kbot
                 mc2(k) = x_frac * mc1(k)
                det2(k) = x_frac * det1(k)
           enddo

!----------------------------------------------------------
! In-cloud fields: Cloud base
!----------------------------------------------------------
           rtmp = 1. / (dm1(kbot)+mc2(kbot))
           uc(kbot) = (dm1(kbot)*u1(kbot) + mc2(kbot)*u2(kbot-1)) * rtmp
           vc(kbot) = (dm1(kbot)*v1(kbot) + mc2(kbot)*v2(kbot-1)) * rtmp

           if ( nq_skip < nq ) then
              do iq=nq_skip+1,nq
                 qc(kbot,iq) = (dm1(kbot)*q1(kbot,iq) + mc2(kbot)*q2(kbot-1,iq)) * rtmp
              enddo
           endif
!----------------------------------------------------------
! In-cloud fields: interior
!----------------------------------------------------------
!
!
! Below the detrainment level:  (det=0)
           if ( kdet < kbot-1 ) then
!-----------------------------------------------------------
! The in-cloud fields are modified (diluted) by entrainment of
! environment air, and the GKI effect will not be added here.
!-----------------------------------------------------------
              do k=kbot-1, kdet+1,-1
                 ent = mc2(k) - mc2(k+1) + det2(k)
                uc(k) = (mc2(k+1)*uc(k+1)+ent*u2(k)) / mc2(k)  
                vc(k) = (mc2(k+1)*vc(k+1)+ent*v2(k)) / mc2(k) 
              enddo
              if ( nq_skip < nq ) then
                 do iq=nq_skip+1,nq
                    do k=kbot-1, kdet+1,-1
                       ent = mc2(k) - mc2(k+1) + det2(k)
                       qc(k,iq) = (mc2(k+1)*qc(k+1,iq)+ent*q2(k,iq)) / mc2(k) 
                    enddo
                 enddo
              endif
           endif
!
! Pressure-gradient effect of Gregory et al 1997 added when
! the clouds are detraining.
! Entrained mass fluxes are diagnosed by mass conservation law
           if ( kdet > ktop ) then
              do k=kdet, ktop+1, -1
                 ent = mc2(k) - mc2(k+1) + det2(k)
                 uc(k) = (mc2(k+1)*uc(k+1)+ent*u2(k))/(mc2(k+1)+ent)     &
                        + gki*(u2(k)-u2(k+1))
                 vc(k) = (mc2(k+1)*vc(k+1)+ent*v2(k))/(mc2(k+1)+ent)     &
                        + gki*(v2(k)-v2(k+1))
              enddo
              if ( nq_skip < nq ) then
                 do iq=nq_skip+1,nq
                    do k=kdet, ktop+1, -1
                       ent = mc2(k) - mc2(k+1) + det2(k)
                       qc(k,iq) = (mc2(k+1)*qc(k+1,iq)+ent*q2(k,iq))/(mc2(k+1)+ent)
                    enddo
                 enddo
              endif
           endif

!----------------
! Update fields:
!----------------
! Cloud top
          rtmp = 1. / (dm1(ktop)+mc2(ktop+1))
          u2(ktop) = (dm1(ktop)*u1(ktop)+mc2(ktop+1)*uc(ktop+1)) * rtmp
          v2(ktop) = (dm1(ktop)*v1(ktop)+mc2(ktop+1)*vc(ktop+1)) * rtmp
          if ( nq_skip < nq ) then
               do iq=nq_skip+1,nq
                  q2(ktop,iq) = (dm1(ktop)*q1(ktop,iq)+mc2(ktop+1)*qc(ktop+1,iq)) * rtmp
               enddo
          endif

!---------------------------------------------------------------------
! Interior (this loop can't be vectorized due to k to k-1 dependency)
!---------------------------------------------------------------------
           do k=ktop+1,kbot-1
              u2(k) = (dm1(k)*u1(k) + mc2(k)*(u2(k-1)-uc(k)) + mc2(k+1)*uc(k+1)) /  &
                      (dm1(k) + mc2(k+1))
              v2(k) = (dm1(k)*v1(k) + mc2(k)*(v2(k-1)-vc(k)) + mc2(k+1)*vc(k+1)) /  &
                      (dm1(k) + mc2(k+1))
           enddo

          if ( nq_skip < nq ) then
           do iq=nq_skip+1,nq
           do k=ktop+1,kbot-1
              q2(k,iq) = (dm1(k)*q1(k,iq)+mc2(k)*(q2(k-1,iq)-qc(k,iq))+mc2(k+1)*qc(k+1,iq))  &
                       / (dm1(k) + mc2(k+1))
           enddo
           enddo
          endif

!---------------------------------
! Update fields in the Cloud base
!---------------------------------
               rtmp = mc2(kbot)/dm1(kbot)
           u2(kbot) = u1(kbot) + rtmp*(u2(kbot-1)-uc(kbot))
           v2(kbot) = v1(kbot) + rtmp*(v2(kbot-1)-vc(kbot))
          if ( nq_skip < nq ) then
            do iq=nq_skip+1,nq
               q2(kbot,iq) = q1(kbot,iq) + rtmp*(q2(kbot-1,iq)-qc(kbot,iq))
            enddo
          endif
        enddo         ! end iteration

!--------------------
! Compute tendencies:
!--------------------
           do k=ktop,kbot
              utnd(i,j,k) = (u2(k) - u1(k)) * rdt
              vtnd(i,j,k) = (v2(k) - v1(k)) * rdt
! Update winds:
              uin(i,j,k) = u2(k)
              vin(i,j,k) = v2(k)
           enddo
           if ( nq_skip < nq ) then
              do iq=nq_skip+1,nq
                 do k=ktop,kbot
! qtnd is the total tendency
!                   qtnd(i,j,k,iq) = qtnd(i,j,k,iq) + (q2(k,iq) - q1(k,iq)) * rdt
                    qtnd(i,j,k,iq) =                (q2(k,iq) - q1(k,iq)) * rdt
                    qin(i,j,k,iq) = q2(k,iq)
                 enddo
              enddo
           endif
  
!          if ( conserve ) then
           if ( conserve_te ) then
           do k=ktop,kbot
! ttnd is the total tendency containing contribution from RAS
              ttnd(i,j,k) = ((u1(k)+u2(k))*(u1(k)-u2(k)) + (v1(k)+v2(k))*(v1(k)-v2(k))) &
!                          * fac_t + ttnd(i,j,k)
                           * fac_t 
              tin(i,j,k) = tin(i,j,k) + ttnd(i,j,k)*dt
           enddo
            else
             do k=ktop,kbot
               ttnd(i,j,k) = 0.0
             enddo
           endif
        endif
     enddo
  enddo

! --- diagnostics
     if ( id_utnd_cmt > 0 ) then
        used = send_data ( id_utnd_cmt, utnd, Time, is, js, 1 )
     endif
     if ( id_vtnd_cmt > 0 ) then
        used = send_data ( id_vtnd_cmt, vtnd, Time, is, js, 1 )
     endif
     if (conserve_te) then
     if ( id_ttnd_cmt > 0 ) then
        used = send_data ( id_ttnd_cmt, ttnd, Time, is, js, 1 )
     endif
     endif
     if ( id_massflux_cmt > 0 ) then
        used = send_data ( id_massflux_cmt, mc, Time, is, js, 1 )
     endif
     if ( id_detmf_cmt > 0 ) then
        used = send_data ( id_detmf_cmt, det0, Time, is, js, 1 )
     endif

 end subroutine non_local_mot

end module cu_mo_trans_mod

! <INFO>

! </INFO>

module ocean_increment_eta_mod
!
!<CONTACT EMAIL="russell.fiedler@csiro.au">  Russell Fiedler
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov.au"> Paul Sandery 
!</CONTACT>
!
!<OVERVIEW>
! Thickness weighted eta tendency [meter^2/sec^2] from increments.
!</OVERVIEW>
!
!<DESCRIPTION>
!
! This increment module performs incremental update analysis (IUA), 
! an approach used in data assimilation and forecasting to reduce
! spurious perturbations when correcting the model state. 
! IUA involves restoring to analysis increments i.e. differences between model
! and analysis fields rather than actual fields (See Bloom et al., 1996). 
! The user can define the period that IUA is carried out
! and also the fraction of the increment to be restored over that period.
!
! This module applies a general 2D source to eta. The sources
! can occur at any location and with any distribution in the domain
! An array of eta tendencies due to the increments is augmented through a
! call to increment_eta_source.  The array of eta tendencies must be
! reset to zero between calls.
!
! The user is responsible for providing (and registering) the data on
! the model grid of values towards which the etas are being driven.
!</DESCRIPTION>
!
! <REFERENCE>
! S.C. Bloom, L.L. Takacs, A.M. da Silva, and D. Ledvina
! Data Assimilation Using Incremental Analysis Updates
! Monthly Weather Review  Volume 124, Issue 6 (June 1996)
! pages 1256--1271 
! </REFERENCE>
!
!<NAMELIST NAME="ocean_increment_eta_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  For using this module.  Default use_this_module=.false.
!  </DATA> 
!  <DATA NAME="fraction_increment" TYPE="real">
!  For prescribing the fraction of the increment. 
!  applied to the restoring period.  Default fraction_increment=1.0
!  </DATA>
!  <DATA NAME="days_to_increment" TYPE="integer">
!  For specifying the amount of days to restore.
!  Default days_to_increment=1
!  </DATA>
!  <DATA NAME="secs_to_increment" TYPE="integer">
!  For specifying the amount of seconds to restore.
!  Default secs_to_increment=0
!  </DATA>
!</NAMELIST>
!
use diag_manager_mod,         only: register_diag_field
use fms_mod,                  only: write_version_number, open_namelist_file, close_file
use fms_mod,                  only: file_exist
use fms_mod,                  only: open_namelist_file, check_nml_error, close_file
use fms_mod,                  only: read_data, lowercase, FATAL, WARNING, stdout, stdlog
use mpp_mod,                  only: input_nml_file, mpp_sum, mpp_error
use time_interp_external_mod, only: init_external_field, time_interp_external
use time_manager_mod,         only: time_type, set_date, get_time
use time_manager_mod,         only: operator( + ), operator( - ), operator( // )
use time_manager_mod,         only: operator( > ), operator( == ), operator( <= )

use ocean_domains_mod,        only: get_local_indices
use ocean_parameters_mod,     only: missing_value 
use ocean_types_mod,          only: ocean_domain_type, ocean_grid_type, ocean_thickness_type
use ocean_types_mod,          only: ocean_External_mode_type, ocean_time_type 
use ocean_workspace_mod,      only: wrk1_2d, wrk2_2d
use ocean_util_mod,           only: diagnose_2d
use ocean_parameters_mod,     only: rho0
implicit none

private

#include <ocean_memory.h>


type ocean_increment_type
   integer :: id                                             ! time_interp_external index
   character(len=32) :: name                                 ! eta name corresponding to increment
   real, dimension(:,:), pointer :: damp_coeff   => NULL() ! 2D inverse forcing rate (eta units/ sec)
end type ocean_increment_type


type(ocean_increment_type),SAVE :: Increment
type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

public ocean_increment_eta_init
public ocean_increment_eta_source

character(len=126)  :: version = '$Id: ocean_increment_eta.F90,v 20.0 2013/12/14 00:15:56 fms Exp $'
character (len=128) :: tagname = '$Name: tikal $'

! for diagnostics 
logical :: used
integer :: id_increment_tend
logical :: module_is_initialized = .false.
logical :: use_this_module       = .false. 
real    :: time_scale
real    :: fraction_increment    = 1.0
integer :: days_to_increment     = 1
integer :: secs_to_increment     = 0

namelist /ocean_increment_eta_nml/ use_this_module, fraction_increment, days_to_increment, secs_to_increment

! Time info
integer :: days_end_increment, secs_end_increment
integer :: days, secs

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_increment_eta_init">
!
! <DESCRIPTION>
! This subroutine is intended to be used to initialize the increments.
! Everything in this subroutine is a user prototype, and should be replacable.
! </DESCRIPTION>
!
subroutine ocean_increment_eta_init(Grid, Domain, Time)

  type(ocean_grid_type),        intent(in), target :: Grid
  type(ocean_domain_type),      intent(in), target :: Domain
  type(ocean_time_type),        intent(in)         :: Time

  integer :: i, j
  integer :: ioun, io_status, ierr

  character(len=128) :: name

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 


  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_increment_mod (ocean_increment_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.


  call write_version_number(version, tagname)

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_Increment_eta_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_increment_eta_nml')
#else
  ioun =  open_namelist_file()
  read (ioun,ocean_Increment_eta_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_increment_eta_nml')
  call close_file (ioun)
#endif
  write (stdlogunit,ocean_Increment_eta_nml)
  write (stdoutunit,'(/)') 
  write (stdoutunit,ocean_Increment_eta_nml)

  Dom => Domain
  Grd => Grid

#ifndef MOM_STATIC_ARRAYS    
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
#endif

  allocate(Increment%damp_coeff(isd:ied,jsd:jed))
  Increment%id = -1

  if(.not. use_this_module) return 

  if ( days_to_increment  < 0  .or. secs_to_increment < 0 .or. &
  days_to_increment==0 .and. secs_to_increment == 0 ) then

     call mpp_error(FATAL,&
      '==>Error: invalid restoring period, ensure days_to_increment + secs_to_increment is greater than zero')
  endif

  time_scale=fraction_increment/(days_to_increment*86400.0 + secs_to_increment)

  call get_time(Time%model_time,secs,days)
  days_end_increment=days + days_to_increment
  secs_end_increment=secs + secs_to_increment


  ! read forcing rates (1/sec) 
  Increment%damp_coeff(:,:) = 0.0  

  do j=jsd,jed
     do i=isd,ied
        if(Grd%tmask(i,j,1) == 0.0) then 
            Increment%damp_coeff(i,j) = 0.0
        else
            Increment%damp_coeff(i,j) = time_scale
        endif
     enddo
  enddo

  ! read forcing data
  name = 'INPUT/eta_increment.nc'
  if(file_exist(trim(name))) then
      Increment%id = init_external_field(name,'eta_inc',domain=Domain%domain2d)
      if (Increment%id < 1) then 
          call mpp_error(FATAL,&
               '==>Error: in ocean_increment_eta_mod: forcing rates are specified but increment values are not')
      endif
      write(stdoutunit,*) '==> Using increment data specified from file '//trim(name) 
  else
      write(stdoutunit,*) '==> '//trim(name)//' not found.  Increment not being applied '
  endif

  ! register diagnostic output
  id_increment_tend = -1

  id_increment_tend = register_diag_field ('ocean_model', 'eta_t_increment_tend', &
                Grd%tracer_axes(1:2), Time%model_time, 'eta_t tendency due to increment', &
                'm/s', missing_value=missing_value, range=(/-1.e10,1.e10/))


end subroutine ocean_increment_eta_init
! </SUBROUTINE> NAME="ocean_increment_eta_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_increment_eta_source">
!
! <DESCRIPTION>
! This subroutine calculates thickness weighted and density weighted
! time tendencies of etas due to damping by increments.
! </DESCRIPTION>
!
subroutine ocean_increment_eta_source(Time, Ext_mode)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_external_mode_type), intent(inout) :: Ext_mode

  integer :: taum1, tau
  integer :: i, j
  integer :: days,secs

  if(.not. use_this_module) return 

  taum1 = Time%taum1
  tau   = Time%tau
  wrk1_2d  = 0.0 
  wrk2_2d  = 0.0

  ! halt forcing
  call get_time(Time%model_time,secs,days)
  if(days + secs/86400.0 .ge. days_end_increment + secs_end_increment/86400.0 ) then
    Increment%id=0
  endif

  if (Increment%id > 0) then

     ! get increment value for current time
     call time_interp_external(Increment%id, Time%model_time, wrk1_2d) 

     do j=jsd,jed
         do i=isd,ied  
            wrk2_2d(i,j) = Increment%damp_coeff(i,j)    &
                      *wrk1_2d(i,j)
           Ext_mode%source(i,j) = Ext_mode%source(i,j)+rho0*wrk2_2d(i,j) 
         enddo
     enddo


   endif

   call diagnose_2d(Time, Grd, id_increment_tend, wrk2_2d(:,:))

  return

end subroutine ocean_increment_eta_source
! </SUBROUTINE> NAME="increment_eta_source"


end module ocean_increment_eta_mod

!FDOC_TAG_GFDL fdoc.pl generated xml skeleton
! $Id$

#include <fms_platform.h>
#include "fms_switches.h"
#define _FLATTEN(A) reshape((A), (/size((A))/) )

module drifters_mod
! <CONTACT EMAIL="Alexander.Pletzer@noaa.gov">
!   Alexander Pletzer
! </CONTACT>
! <REVIEWER EMAIL="">
!   
! </REVIEWER>
! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>
! <OVERVIEW>
!   
! </OVERVIEW>
! <TT>Drifters_mod</TT>is a module designed to advect a set of particles, in parallel or 
! sequentially, given an prescribed velocity field. 
! 
! <DESCRIPTION>
! Drifters are idealized point particles with positions that evolve in time according
! to a prescribed velocity field, starting from some initial conditions. Drifters have
! no mass, no energy, no size, and no friction and therefore have no impact on the 
! dynamics of the underlying system. The only feature that distinguishes a drifter
! from another is its trajectory. This makes drifters ideal for tracking pollution
! clouds and probing fields (e.g. temperature, salinity) along ocean currents, to name 
! a few applications.
! Drifters can mimic real experiments such as the Argo floats 
! http://www.metoffice.com/research/ocean/argo/ukfloats.html.
!
! When run in parallel, on a 2d decomposed domain, <TT>drifters_mod</TT> will handle all the
! bookkeeping and communication transparently for the user. This involves adding/removing 
! drifters as they enter/leave a processor element (PE) domain. Note that the number of drifters 
! can vary greatly both between PE domains and within a PE domain in the course of a simulation; the drifters' 
! module will also manage dynamically the memory for the user.
! 
! There are a number of basic assumptions which could make the drifters' module 
! ill-suited for some tasks. First and foremost, it is assumed that the motion of 
! drifters is not erratic but follows deterministic trajectories. Furthermore, 
! drifters should not cross both compute and data domain boundaries within less 
! than a time step. This limitation is imposed by the Runge-Kutta integration 
! scheme, which must be able to complete, within a time step, a trajectory 
! calculation that starts inside the compute domain and ends inside the data domain. Therefore, the drifters, 
! as they are presently modelled, are unlikely to work for very fast objects. 
! This constraint also puts a upper limit to the domain decomposition, although
! it can often be remedied by increasing the number of ghost nodes.
! 
! Another fundamental assumption is that the (e.g. velocity) fields are structured, 
! on a per PE domain basis. There is no support for locally nested or unstrucured 
! meshes. Meshes need not be smooth and continuous across PE domains, however.    
! </DESCRIPTION>
!

! <INFO>

!   <REFERENCE>            </REFERENCE>
!   <COMPILER NAME="">     </COMPILER>
!   <PRECOMP FLAG="">      </PRECOMP>
!   <LOADER FLAG="">       </LOADER>
!   <TESTPROGRAM NAME="">  </TESTPROGRAM>
!   <BUG>                  </BUG>
!   <NOTE> 
!     See NOTE above.
!   </NOTE>
!   <FUTURE>               </FUTURE>

! </INFO>

#ifdef _SERIAL

! serial code
#define _MPP_PE 0
#define _MPP_ROOT 0
#define _MPP_NPES 1
#define _TYPE_DOMAIN2D integer

#else

! parallel code
  use mpp_mod        , only : mpp_pe, mpp_npes
  use mpp_domains_mod, only : domain2d
#define _MPP_PE mpp_pe()
#define _MPP_ROOT mpp_root_pe()
#define _MPP_NPES mpp_npes()
#define _TYPE_DOMAIN2D type(domain2d)

#endif

  use drifters_core_mod,  only: drifters_core_type, drifters_core_new, drifters_core_del, assignment(=)

  use drifters_input_mod, only: drifters_input_type, drifters_input_new, drifters_input_del, assignment(=)

  use drifters_io_mod,    only: drifters_io_type, drifters_io_new, drifters_io_del, drifters_io_set_time_units, &
                                drifters_io_set_position_names, drifters_io_set_position_units, &
                                drifters_io_set_field_names, drifters_io_set_field_units, drifters_io_write

  use drifters_comm_mod,  only: drifters_comm_type, drifters_comm_new, drifters_comm_del, drifters_comm_set_pe_neighbors, &
                                drifters_comm_set_domain, drifters_comm_gather, drifters_comm_update

  use cloud_interpolator_mod, only: cld_ntrp_linear_cell_interp, cld_ntrp_locate_cell, cld_ntrp_get_cell_values

  implicit none
  private  

  public :: drifters_type, assignment(=), drifters_push, drifters_compute_k, drifters_set_field
  public :: drifters_new, drifters_del, drifters_set_domain, drifters_set_pe_neighbors
  public :: drifters_set_v_axes, drifters_set_domain_bounds, drifters_positions2lonlat
  public :: drifters_print_checksums, drifters_save, drifters_write_restart, drifters_distribute

  integer, parameter, private :: MAX_STR_LEN = 128
  character(len=MAX_STR_LEN), parameter, private :: version = '$Id$'
  real :: DRFT_EMPTY_ARRAY(0)

  type drifters_type
     ! Be sure to update drifters_new, drifters_del and drifters_copy_new
     ! when adding members
     type(drifters_core_type)  :: core
     type(drifters_input_type) :: input
     type(drifters_io_type)    :: io
     type(drifters_comm_type)  :: comm
     real    :: dt             ! total dt, over a complete step
     real    :: time
     ! fields
     real, _ALLOCATABLE :: fields(:,:) _NULL
     ! velocity field axes
     real, _ALLOCATABLE :: xu(:) _NULL
     real, _ALLOCATABLE :: yu(:) _NULL
     real, _ALLOCATABLE :: zu(:) _NULL
     real, _ALLOCATABLE :: xv(:) _NULL
     real, _ALLOCATABLE :: yv(:) _NULL
     real, _ALLOCATABLE :: zv(:) _NULL
     real, _ALLOCATABLE :: xw(:) _NULL
     real, _ALLOCATABLE :: yw(:) _NULL
     real, _ALLOCATABLE :: zw(:) _NULL
     ! Runge Kutta coefficients holding intermediate results (positions)
     real, _ALLOCATABLE :: temp_pos(:,:) _NULL
     real, _ALLOCATABLE :: rk4_k1(:,:) _NULL
     real, _ALLOCATABLE :: rk4_k2(:,:) _NULL
     real, _ALLOCATABLE :: rk4_k3(:,:) _NULL
     real, _ALLOCATABLE :: rk4_k4(:,:) _NULL
     ! store filenames for convenience
     character(len=MAX_STR_LEN) :: input_file, output_file
     ! Runge Kutta stuff
     integer :: rk4_step
     logical :: rk4_completed
     integer :: nx, ny
     logical, _ALLOCATABLE   :: remove(:) _NULL
  end type drifters_type

  interface assignment(=)
     module procedure drifters_copy_new
  end interface

  interface drifters_push
    module procedure drifters_push_2
    module procedure drifters_push_3
  end interface

  interface drifters_compute_k
     module procedure drifters_computek2d
     module procedure drifters_computek3d
  end interface

  interface drifters_set_field
    module procedure drifters_set_field_2d
    module procedure drifters_set_field_3d
  end interface

  

contains

  !============================================================================
! <SUBROUTINE NAME="drifters_new">
!  <OVERVIEW>
!  Constructor. 
!  </OVERVIEW>
!  <DESCRIPTION>
! Will read positions stored in the netCDF file <TT>input_file</TT>.
! The trajectories will be saved in files <TT>output_file.PE</TT>, 
! one file per PE domain.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call   drifters_new(self, input_file, output_file, ermesg)
!		
!  </TEMPLATE>
!  <INOUT NAME="self" TYPE="drifters_type" DIM="SCALAR" UNITS="" DEFAULT="">
!   Opaque data structure.
!  </INOUT>
!  <IN NAME="input_file" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!     NetCDF input file name containing initial positions.
!  </IN>
!  <IN NAME="output_file" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!     NetCDF output file. Will contain trajectory positions and interpolated fields.
!  </IN>
!  <OUT NAME="ermesg" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!     Error message (if any).
!  </OUT>
! </SUBROUTINE>
!
  subroutine drifters_new(self, input_file, output_file, ermesg)

    type(drifters_type) :: self
    character(len=*), intent(in)  :: input_file
    character(len=*), intent(in)  :: output_file
    character(len=*), intent(out) :: ermesg
    
    integer nd, nf, npdim, i
    character(len=6) :: pe_str

    ermesg = ''

    self%input_file  = input_file
    self%output_file = output_file

    call drifters_input_new(self%input, input_file, ermesg)
    if(ermesg/='') return

    ! number of dimensions
    nd = size(self%input%velocity_names)
    ! estimate for the max number of particles (will resize if exceeded)
    npdim = int(1.3*size(self%input%positions, 2))
    call drifters_core_new(self%core, nd=nd, npdim=npdim, ermesg=ermesg)
    if(ermesg/='') return

    ! number of fields
    nf = size(self%input%field_names)

    ! one output file per PE
    pe_str = '    '
    write(pe_str, '(i6)') _MPP_PE
    pe_str = adjustr(pe_str)
    do i = 1, 5
       if(pe_str(i:i)==' ') pe_str(i:i)='0'
    enddo
    call drifters_io_new(self%io, output_file//'.'//pe_str, nd, nf, ermesg)
    if(ermesg/='') return

    call drifters_comm_new(self%comm)
    if(ermesg/='') return

    ! Set meta data
    call drifters_io_set_time_units(self%io, name=self%input%time_units, &
         & ermesg=ermesg)

    call drifters_io_set_position_names(self%io, names=self%input%position_names, &
         & ermesg=ermesg)
    if(ermesg/='') return
    call drifters_io_set_position_units(self%io, names=self%input%position_units, &
         & ermesg=ermesg)
    if(ermesg/='') return

    call drifters_io_set_field_names(self%io, names=self%input%field_names, &
         & ermesg=ermesg)
    if(ermesg/='') return
    call drifters_io_set_field_units(self%io, names=self%input%field_units, &
         & ermesg=ermesg)
    if(ermesg/='') return    

    self%dt   = -1
    self%time = -1
    self%rk4_step = 0
    self%nx       = 0
    self%ny       = 0
    self%rk4_completed = .FALSE.

    allocate(self%rk4_k1(self%core%nd, self%core%npdim))
    self%rk4_k1 = -huge(1.)
    allocate(self%rk4_k2(self%core%nd, self%core%npdim))
    self%rk4_k2 = -huge(1.)
    allocate(self%rk4_k3(self%core%nd, self%core%npdim))
    self%rk4_k3 = -huge(1.)
    allocate(self%rk4_k4(self%core%nd, self%core%npdim))
    self%rk4_k4 = -huge(1.)
    allocate(self%remove(self%core%npdim))
    self%remove = .FALSE.
    allocate(self%temp_pos(nd, self%core%npdim))
    self%temp_pos = -huge(1.)

    allocate(self%fields(nf, self%core%npdim))
    self%fields = -huge(1.)

  end subroutine drifters_new

  !============================================================================
! <SUBROUTINE NAME="drifters_del">
!  <OVERVIEW>
!   Destructor.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Call this to reclaim memory.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call   drifters_del(self, ermesg)
!		
!  </TEMPLATE>
!  <INOUT NAME="self" TYPE="drifters_type" DIM="SCALAR" UNITS="" DEFAULT="">
!   Opaque data structure.
!  </INOUT>
!  <OUT NAME="ermesg" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!   Error message (if any).
!  </OUT>
! </SUBROUTINE>
!
  subroutine drifters_del(self, ermesg)
    type(drifters_type) :: self
    character(len=*), intent(out) :: ermesg
    
    integer flag
    ermesg = ''
    deallocate(self%fields, stat=flag)
    deallocate(self%xu, stat=flag)
    deallocate(self%yu, stat=flag)
    deallocate(self%zu, stat=flag)
    deallocate(self%xv, stat=flag)
    deallocate(self%yv, stat=flag)
    deallocate(self%zv, stat=flag)
    deallocate(self%xw, stat=flag)
    deallocate(self%yw, stat=flag)
    deallocate(self%zw, stat=flag)
    deallocate(self%temp_pos, stat=flag)
    deallocate(self%rk4_k1, stat=flag)
    deallocate(self%rk4_k2, stat=flag)
    deallocate(self%rk4_k3, stat=flag)
    deallocate(self%rk4_k4, stat=flag)
    deallocate(self%remove, stat=flag)
    
    call drifters_core_del(self%core, ermesg)
    if(ermesg/='') return
    call drifters_input_del(self%input, ermesg)
    if(ermesg/='') return
    call drifters_io_del(self%io, ermesg)
    if(ermesg/='') return
    call drifters_comm_del(self%comm)
    if(ermesg/='') return

  end subroutine drifters_del

  !============================================================================
! <SUBROUTINE NAME="drifters_copy_new">
!  <OVERVIEW>
!   Copy constructor.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Copy a drifter state into a new state. Note: this will not open new files; this will
!   copy all members into a new container.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call   drifters_copy_new(new_instance, old_instance)
!		
!  </TEMPLATE>
!  <INOUT NAME="new_instance" TYPE="drifters_type" DIM="SCALAR" UNITS="" DEFAULT="">
!   New data structure.
!  </INOUT>
!  <IN NAME="old_instance" TYPE="drifters_type" DIM="SCALAR" UNITS="" DEFAULT="">
!   Old data structure.
!  </IN>
! </SUBROUTINE>
!
  !============================================================================
  subroutine drifters_copy_new(new_instance, old_instance)

    type(drifters_type), intent(in)    :: old_instance
    type(drifters_type), intent(inout) :: new_instance

    character(len=MAX_STR_LEN) :: ermesg

    ermesg = ''

    ! make sure new_instance is empty
    call drifters_del(new_instance, ermesg)
    if(ermesg/='') return

    new_instance%core  = old_instance%core
    new_instance%input = old_instance%input
    new_instance%io    = old_instance%io
    new_instance%comm  = old_instance%comm

     new_instance%dt     = old_instance%dt
     new_instance%time   = old_instance%time

     allocate(new_instance%fields( size(old_instance%fields, 1), &
          &                        size(old_instance%fields, 2) ))
     new_instance%fields = old_instance%fields

     allocate(new_instance%xu( size(old_instance%xu) ))
     allocate(new_instance%yu( size(old_instance%yu) ))
     allocate(new_instance%zu( size(old_instance%zu) ))
     new_instance%xu = old_instance%xu
     new_instance%yu = old_instance%yu
     new_instance%zu = old_instance%zu
     allocate(new_instance%xv( size(old_instance%xv) ))
     allocate(new_instance%yv( size(old_instance%yv) ))
     allocate(new_instance%zv( size(old_instance%zv) ))
     new_instance%xv = old_instance%xv
     new_instance%yv = old_instance%yv
     new_instance%zv = old_instance%zv
     allocate(new_instance%xw( size(old_instance%xw) ))
     allocate(new_instance%yw( size(old_instance%yw) ))
     allocate(new_instance%zw( size(old_instance%zw) ))
     new_instance%xw = old_instance%xw
     new_instance%yw = old_instance%yw
     new_instance%zw = old_instance%zw

     allocate(new_instance%temp_pos( size(old_instance%temp_pos,1), &
          &                          size(old_instance%temp_pos,2) ))
     new_instance%temp_pos = old_instance%temp_pos
     allocate(new_instance%rk4_k1( size(old_instance%rk4_k1,1), &
          &                        size(old_instance%rk4_k1,2) ))
     allocate(new_instance%rk4_k2( size(old_instance%rk4_k2,1), &
          &                        size(old_instance%rk4_k2,2) ))
     allocate(new_instance%rk4_k3( size(old_instance%rk4_k3,1), &
          &                        size(old_instance%rk4_k3,2) ))
     allocate(new_instance%rk4_k4( size(old_instance%rk4_k4,1), &
          &                        size(old_instance%rk4_k4,2) ))
     new_instance%rk4_k1 = old_instance%rk4_k1
     new_instance%rk4_k2 = old_instance%rk4_k2 
     new_instance%rk4_k3 = old_instance%rk4_k3
     new_instance%rk4_k4 = old_instance%rk4_k4

     new_instance%rk4_step = old_instance%rk4_step
     new_instance%rk4_completed = old_instance%rk4_completed
     new_instance%nx = old_instance%nx
     new_instance%ny = old_instance%ny

     allocate(new_instance%remove(size(old_instance%remove)))
     new_instance%remove = old_instance%remove


  end subroutine drifters_copy_new

  !============================================================================
! <SUBROUTINE NAME="drifters_set_domain">
!  <OVERVIEW>
!   Set the compute, data, and global domain boundaries. 
!  </OVERVIEW>
!  <DESCRIPTION>
!   The data domain extends beyond the compute domain and is shared between 
!   two or more PE domains. A particle crossing the compute domain boundary 
!   will trigger a communication with one or more neighboring domains. A particle 
!   leaving the data domain will be removed from the list of particles.   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call   drifters_set_domain(self, &
!		& xmin_comp, xmax_comp, ymin_comp, ymax_comp, &
!		& xmin_data, xmax_data, ymin_data, ymax_data, &
!		& xmin_glob, xmax_glob, ymin_glob, ymax_glob, &
!		& ermesg)
!		
!  </TEMPLATE>
!  <INOUT NAME="self" TYPE="drifters_type" DIM="SCALAR" UNITS="" DEFAULT="">
!   Opaque data structure.
!  </INOUT>
!  <IN NAME="xmin_comp" TYPE="real" DIM="SCALAR" UNITS="" DEFAULT="">
!   Min of longitude-like axis on compute domain.
!  </IN>
!  <IN NAME="xmax_comp" TYPE="real" DIM="SCALAR" UNITS="" DEFAULT="">
!   Max of longitude-like axis on compute domain.
!  </IN>
!  <IN NAME="ymin_comp" TYPE="real" DIM="SCALAR" UNITS="" DEFAULT="">
!   Min of latitude-like axis on compute domain.
!  </IN>
!  <IN NAME="ymax_comp" TYPE="real" DIM="SCALAR" UNITS="" DEFAULT="">
!   Max of latitude-like axis on compute domain.
!  </IN>
!  <IN NAME="xmin_data" TYPE="real" DIM="SCALAR" UNITS="" DEFAULT="">
!   Min of longitude-like axis on data domain.
!  </IN>
!  <IN NAME="xmax_data" TYPE="real" DIM="SCALAR" UNITS="" DEFAULT="">
!   Max of longitude-like axis on data domain.
!  </IN>
!  <IN NAME="ymin_data" TYPE="real" DIM="SCALAR" UNITS="" DEFAULT="">
!   Min of latitude-like axis on data domain.
!  </IN>
!  <IN NAME="ymax_data" TYPE="real" DIM="SCALAR" UNITS="" DEFAULT="">
!   Max of latitude-like axis on data domain.
!  </IN>
!  <IN NAME="xmin_glob" TYPE="real" DIM="SCALAR" UNITS="" DEFAULT="">
!   Min of longitude-like axis on global domain.
!  </IN>
!  <IN NAME="xmax_glob" TYPE="real" DIM="SCALAR" UNITS="" DEFAULT="">
!   Max of longitude-like axis on global domain.
!  </IN>
!  <IN NAME="ymin_glob" TYPE="real" DIM="SCALAR" UNITS="" DEFAULT="">
!   Min of latitude-like axis on global domain.
!  </IN>
!  <IN NAME="ymax_glob" TYPE="real" DIM="SCALAR" UNITS="" DEFAULT="">
!   Max of latitude-like axis on global domain.
!  </IN>
!  <OUT NAME="ermesg" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!   Error message (if any).
!  </OUT>
! </SUBROUTINE>
!
  subroutine drifters_set_domain(self, &
       & xmin_comp, xmax_comp, ymin_comp, ymax_comp, &
       & xmin_data, xmax_data, ymin_data, ymax_data, &
       & xmin_glob, xmax_glob, ymin_glob, ymax_glob, &
       & ermesg)
    type(drifters_type) :: self
    ! compute domain boundaries
    real, optional, intent(in) :: xmin_comp, xmax_comp, ymin_comp, ymax_comp
    ! data domain boundaries
    real, optional, intent(in) :: xmin_data, xmax_data, ymin_data, ymax_data
    ! global boundaries (only specify those if domain is periodic)
    real, optional, intent(in) :: xmin_glob, xmax_glob, ymin_glob, ymax_glob    
    character(len=*), intent(out) :: ermesg

    ermesg = ''
    if(present(xmin_comp)) self%comm%xcmin = xmin_comp
    if(present(xmax_comp)) self%comm%xcmax = xmax_comp
    if(present(ymin_comp)) self%comm%ycmin = ymin_comp
    if(present(ymax_comp)) self%comm%ycmax = ymax_comp

    if(present(xmin_data)) self%comm%xdmin = xmin_data
    if(present(xmax_data)) self%comm%xdmax = xmax_data
    if(present(ymin_data)) self%comm%ydmin = ymin_data
    if(present(ymax_data)) self%comm%ydmax = ymax_data

    if(present(xmin_glob)) self%comm%xgmin = xmin_glob
    if(present(xmax_glob)) self%comm%xgmax = xmax_glob
    if(present(ymin_glob)) self%comm%ygmin = ymin_glob
    if(present(ymax_glob)) self%comm%ygmax = ymax_glob

    ! Note: the presence of both xgmin/xgmax will automatically set the 
    ! periodicity flag
    if(present(xmin_glob) .and. present(xmax_glob)) self%comm%xperiodic = .TRUE.
    if(present(ymin_glob) .and. present(ymax_glob)) self%comm%yperiodic = .TRUE.    

  end subroutine drifters_set_domain

  !============================================================================
! <SUBROUTINE NAME="drifters_set_pe_neighbors">
!  <OVERVIEW>
!   Given an MPP based deomposition, set the PE numbers that are adjacent to this
!   processor.
!  </OVERVIEW>
!  <DESCRIPTION>
!   This will allow several PEs to track the trajectories of particles in the 
!   buffer regions. 
!  </DESCRIPTION>
!  <TEMPLATE>
!   call   drifters_set_pe_neighbors(self, domain, ermesg)
!		
!  </TEMPLATE>
!  <INOUT NAME="self" TYPE="drifters_type" DIM="SCALAR" UNITS="" DEFAULT="">
!   Opaque data structure.
!  </INOUT>
!  <INOUT NAME="domain" TYPE="" DIM="SCALAR" UNITS="" DEFAULT="">
!   MPP domain.
!  </INOUT>
!  <OUT NAME="ermesg" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!   Error message (if any).
!  </OUT>
! </SUBROUTINE>
!
  subroutine drifters_set_pe_neighbors(self, domain, ermesg)

    type(drifters_type) :: self
    _TYPE_DOMAIN2D      :: domain
    character(len=*), intent(out) :: ermesg

    ermesg = ''
    
    call drifters_comm_set_pe_neighbors(self%comm, domain)

  end subroutine drifters_set_pe_neighbors

  !============================================================================
#define _DIMS 2
#define drifters_push_XXX drifters_push_2
#include "drifters_push.h"
#undef _DIMS
#undef drifters_push_XXX

  !============================================================================
#define _DIMS 3
#define drifters_push_XXX drifters_push_3
#include "drifters_push.h"
#undef _DIMS
#undef drifters_push_XXX

  !============================================================================
  subroutine drifters_modulo(self, positions, ermesg)
    type(drifters_type) :: self
    real, intent(inout) :: positions(:,:)
    character(len=*), intent(out) :: ermesg

    integer ip, np
    real x, y

    ermesg = ''
    np = self%core%np

    if(self%comm%xperiodic) then
       do ip = 1, np
          x = positions(1, ip)
          positions(1, ip) = self%comm%xgmin + &
               & modulo(x - self%comm%xgmin, self%comm%xgmax-self%comm%xgmin)
       enddo
    endif

    if(self%comm%yperiodic) then
       do ip = 1, np
          y = positions(2, ip)
          positions(2, ip) = self%comm%ygmin + &
               & modulo(y - self%comm%ygmin, self%comm%ygmax-self%comm%ygmin)
       enddo
    endif

  end subroutine drifters_modulo
    
  !============================================================================
#define _DIMS 2
#define drifters_set_field_XXX drifters_set_field_2d
#include "drifters_set_field.h"
#undef _DIMS
#undef drifters_set_field_XXX

  !============================================================================
#define _DIMS 3
#define drifters_set_field_XXX drifters_set_field_3d
#include "drifters_set_field.h"
#undef _DIMS
#undef drifters_set_field_XXX
  !============================================================================
! <SUBROUTINE NAME="drifters_save">
!  <OVERVIEW>
!   Append new positions to NetCDF file.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Use this method to append the new trajectory positions and the interpolated
!   probe fields to a netCDF file.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call   drifters_save(self, ermesg)
!		
!  </TEMPLATE>
!  <INOUT NAME="self" TYPE="drifters_type" DIM="SCALAR" UNITS="" DEFAULT="">
!   Opaque daata structure.
!  </INOUT>
!  <OUT NAME="ermesg" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!   Error message (if any).
!  </OUT>
! </SUBROUTINE>
!
  subroutine drifters_save(self, ermesg)
    type(drifters_type) :: self
    character(len=*), intent(out) :: ermesg

    integer nf, np

    ermesg = ''
    nf = size(self%input%field_names)
    np = self%core%np

    ! save to disk
    call drifters_io_write(self%io, self%time, np, self%core%nd, nf, &
         & self%core%ids, self%core%positions, &
         & fields=self%fields(:,1:np), ermesg=ermesg)

  end subroutine drifters_save
  !============================================================================
! <SUBROUTINE NAME="drifters_distribute">
!  <OVERVIEW>
!   Distribute particles across PEs.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Use this method after setting the domain boundaries 
!   (<TT>drifters_set_domain</TT>) to spread the particles across PE
!   domains.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call   drifters_distribute(self, ermesg)
!		
!  </TEMPLATE>
!  <INOUT NAME="self" TYPE="drifters_type" DIM="SCALAR" UNITS="" DEFAULT="">
!    Opaque handle.
!  </INOUT>
!  <OUT NAME="ermesg" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!    Error message (if any).
!  </OUT>
! </SUBROUTINE>
!
  subroutine drifters_distribute(self, ermesg)
    type(drifters_type) :: self
    character(len=*), intent(out) :: ermesg

    real x, y
    integer i, nptot, nd

    ermesg = ''
    nd = self%core%nd
    if(nd < 2) then
       ermesg = 'drifters_distribute: dimension must be >=2'
       return
    endif

    nptot = size(self%input%positions, 2)
    do i = 1, nptot
       x = self%input%positions(1,i)
       y = self%input%positions(2,i)
       if(x >= self%comm%xdmin .and. x <= self%comm%xdmax .and. &
        & y >= self%comm%ydmin .and. y <= self%comm%ydmax) then

          self%core%np = self%core%np + 1
          self%core%positions(1:nd, self%core%np) = self%input%positions(1:nd, i)
          self%core%ids(self%core%np)             = i

       endif
    enddo

  end subroutine drifters_distribute

  !============================================================================
! <SUBROUTINE NAME="drifters_write_restart">
!  <OVERVIEW>
!   Write restart file.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Gather all the particle positions distributed across PE domains on root PE 
!   and save the data in netCDF file.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call   drifters_write_restart(self, filename, &
!		& x1, y1, geolon1, &
!		& x2, y2, geolat2, &
!		& root, mycomm, ermesg)
!		
!  </TEMPLATE>
!  <INOUT NAME="self" TYPE="drifters_type" DIM="SCALAR" UNITS="" DEFAULT="">
!    Opaque data structure.
!  </INOUT>
!  <IN NAME="filename" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!    Restart file name.
!  </IN>
!  <IN NAME="x1" TYPE="real" DIM="" UNITS="" DEFAULT="">
!    Pseudo-longitude axis supporting longitudes.
!  </IN>
!  <INOUT NAME="y1" TYPE="" DIM="" UNITS="" DEFAULT="">
!    Pseudo-latitude axis supporting longitudes.
!  </INOUT>
!  <INOUT NAME="geolon1" TYPE="" DIM="" UNITS="" DEFAULT="">
!    Longitude array (x1, y1).
!  </INOUT>
!  <IN NAME="x2" TYPE="real" DIM="" UNITS="" DEFAULT="">
!    Pseudo-longitude axis supporting latitudes.
!  </IN>
!  <INOUT NAME="y2" TYPE="" DIM="" UNITS="" DEFAULT="">
!   Pseudo-latitude axis supporting latitudes.
!  </INOUT>
!  <INOUT NAME="geolat2" TYPE="" DIM="" UNITS="" DEFAULT="">
!   Latitudes array (x2, y2)
!  </INOUT>
!  <IN NAME="root" TYPE="integer" DIM="SCALAR" UNITS="" DEFAULT="">
!   Root PE.
!  </IN>
!  <IN NAME="mycomm" TYPE="integer" DIM="SCALAR" UNITS="" DEFAULT="">
!   MPI communicator.
!  </IN>
!  <OUT NAME="ermesg" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!   Error message (if any).
!  </OUT>
! </SUBROUTINE>
!
  subroutine drifters_write_restart(self, filename, &
       & x1, y1, geolon1, &
       & x2, y2, geolat2, &
       & root, mycomm, ermesg)
    ! gather all positions and ids and save the result in 
    ! self%input data structure on PE "root", then write restart file

    type(drifters_type) :: self
    character(len=*), intent(in)  :: filename

    ! if these optional arguments are passed, the positions will 
    ! mapped to lon/lat degrees and saved in the file.
    real, intent(in), optional    :: x1(:), y1(:), geolon1(:,:)
    real, intent(in), optional    :: x2(:), y2(:), geolat2(:,:) 
  
    integer, intent(in), optional :: root    ! root pe
    integer, intent(in), optional :: mycomm  ! MPI communicator
    character(len=*), intent(out) :: ermesg

    integer :: np
    logical :: do_save_lonlat
    real, allocatable    ::  lons(:), lats(:)

    ermesg = ''

    np = self%core%np
    
    allocate(lons(np), lats(np))
    lons = -huge(1.)
    lats = -huge(1.)

    ! get lon/lat if asking for
    if(present(x1) .and. present(y1) .and. present(geolon1) .and. &
         & present(x2) .and. present(y2) .and. present(geolat2)) then
       do_save_lonlat = .TRUE.
    else
       do_save_lonlat = .FALSE.
    endif

    if(do_save_lonlat) then

       ! Interpolate positions onto geo longitudes/latitudes
       call drifters_positions2lonlat(self,   &
            & positions=self%core%positions(:,1:np), &
            & x1=x1, y1=y1, geolon1=geolon1,         &
            & x2=x2, y2=y2, geolat2=geolat2,         &
            & lons=lons, lats=lats, ermesg=ermesg)
       if(ermesg/='') return ! problems, bail off

    endif

    call drifters_comm_gather(self%comm, self%core, self%input, &
         & lons, lats, do_save_lonlat, &
         & filename, &
         & root, mycomm)
     
  end subroutine drifters_write_restart

  !============================================================================
#define _DIMS 2
#define drifters_compute_k_XXX drifters_computek2d
#include "drifters_compute_k.h"
#undef _DIMS
#undef drifters_compute_k_XXX

   !============================================================================
#define _DIMS 3
#define drifters_compute_k_XXX drifters_computek3d
#include "drifters_compute_k.h"
#undef _DIMS
#undef drifters_compute_k_XXX


 !============================================================================
! <SUBROUTINE NAME="drifters_set_v_axes">
!  <OVERVIEW>
!   Set velocity field axes.
!  </OVERVIEW>
!  <DESCRIPTION>
!  Velocity axis components may be located on different grids or cell faces. For instance, zonal (u)
!  and meridional (v) velcity components are staggered by half a cell size in Arakawa's C and D grids.
!  This call will set individual axes for each components do as to allow interpolation of the velocity
!  field on arbitrary positions.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call   drifters_set_v_axes(self, component, x, y, z, ermesg)
!		
!  </TEMPLATE>
!  <INOUT NAME="self" TYPE="drifters_type" DIM="SCALAR" UNITS="" DEFAULT="">
!  Opaque data structure.
!  </INOUT>
!  <IN NAME="component" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!  Velocity component: either 'u', 'v', or 'w'.
!  </IN>
!  <IN NAME="x" TYPE="real" DIM="" UNITS="" DEFAULT="">
!  X-axis.
!  </IN>
!  <INOUT NAME="y" TYPE="" DIM="" UNITS="" DEFAULT="">
!  Y-axis.
!  </INOUT>
!  <INOUT NAME="z" TYPE="" DIM="" UNITS="" DEFAULT="">
!  Z-axis.
!  </INOUT>
!  <OUT NAME="ermesg" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!  Error message (if any).
!  </OUT>
! </SUBROUTINE>
!
  subroutine drifters_set_v_axes(self, component, x, y, z, ermesg)
    type(drifters_type) :: self
    character(len=*), intent(in)  :: component
    real, intent(in)              :: x(:), y(:), z(:)
    character(len=*), intent(out) :: ermesg

    integer ier, nx, ny, nz
    
    ermesg = ''
    nx = size(x)
    ny = size(y)
    nz = size(z)
    select case (component(1:1))
       case ('u', 'U')
          if(nx > 0) then
             deallocate(self%xu, stat=ier)
             allocate(self%xu(nx))
             self%xu = x
             self%nx = max(self%nx, size(x))
          endif
          if(ny > 0) then
             deallocate(self%yu, stat=ier)
             allocate(self%yu(ny))
             self%yu = y
             self%ny = max(self%ny, size(y))
          endif
          if(nz > 0) then
             deallocate(self%zu, stat=ier)
             allocate(self%zu(nz))
             self%zu = z
          endif
      case ('v', 'V')
          if(nx > 0) then
             deallocate(self%xv, stat=ier)
             allocate(self%xv(nx))
             self%xv = x
             self%nx = max(self%nx, size(x))
          endif
          if(ny > 0) then
             deallocate(self%yv, stat=ier)
             allocate(self%yv(ny))
             self%yv = y
             self%ny = max(self%ny, size(y))
          endif
          if(nz > 0) then
             deallocate(self%zv, stat=ier)
             allocate(self%zv(nz))
             self%zv = z
          endif
      case ('w', 'W')
          if(nx > 0) then
             deallocate(self%xw, stat=ier)
             allocate(self%xw(nx))
             self%xw = x
             self%nx = max(self%nx, size(x))
          endif
          if(ny > 0) then
             deallocate(self%yw, stat=ier)
             allocate(self%yw(ny))
             self%yw = y
             self%ny = max(self%ny, size(y))
          endif
          if(nz > 0) then
             deallocate(self%zw, stat=ier)
             allocate(self%zw(nz))
             self%zw = z
          endif
      case default
         ermesg = 'drifters_set_v_axes: ERROR component must be "u", "v" or "w"'        
    end select
  end subroutine drifters_set_v_axes

  !============================================================================
! <SUBROUTINE NAME="drifters_set_domain_bounds">
!  <OVERVIEW>
!  Set boundaries of "data" and "compute" domains
!  </OVERVIEW>
!  <DESCRIPTION>
!  Each particle will be tracked sol long is it is located in the data domain. 
!  </DESCRIPTION>
!  <TEMPLATE>
!   call   drifters_set_domain_bounds(self, domain, backoff_x, backoff_y, ermesg)
!		
!  </TEMPLATE>
!  <INOUT NAME="self" TYPE="drifters_type" DIM="SCALAR" UNITS="" DEFAULT="">
!  Opaque data structure.
!  </INOUT>
!  <INOUT NAME="domain" TYPE="" DIM="SCALAR" UNITS="" DEFAULT="">
!  Instance of Domain2D (see mpp_domain)
!  </INOUT>
!  <IN NAME="backoff_x" TYPE="integer" DIM="SCALAR" UNITS="" DEFAULT="">
!  Data domain is reduced (if backoff_x > 0) by backoff_x nodes at east and west boundaries.
!  </IN>
!  <IN NAME="backoff_y" TYPE="integer" DIM="SCALAR" UNITS="" DEFAULT="">
!  Data domain is reduced (if backoff_y > 0) by backoff_y nodes at north and south boundaries.
!  </IN>
!  <OUT NAME="ermesg" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!  Error message (if any).
!  </OUT>
! </SUBROUTINE>
!
  subroutine drifters_set_domain_bounds(self, domain, backoff_x, backoff_y, ermesg)
    type(drifters_type) :: self
    _TYPE_DOMAIN2D      :: domain
    integer, intent(in) ::  backoff_x ! particles leaves domain when crossing ied-backoff_x
    integer, intent(in) ::  backoff_y ! particles leaves domain when crossing jed-backoff_y
    character(len=*), intent(out) :: ermesg
    
    ermesg = ''

    if(.not._ALLOCATED(self%xu) .or. .not._ALLOCATED(self%yu)) then
       ermesg = 'drifters_set_domain_bounds: ERROR "u"-component axes not set'
       return
    endif
    call drifters_comm_set_domain(self%comm, domain, self%xu, self%yu, backoff_x, backoff_y)
    if(.not._ALLOCATED(self%xv) .or. .not._ALLOCATED(self%yv)) then
       ermesg = 'drifters_set_domain_bounds: ERROR "v"-component axes not set'
       return
    endif
    if(_ALLOCATED(self%xw) .and. _ALLOCATED(self%yw)) then
       call drifters_comm_set_domain(self%comm, domain, self%xv, self%yv, backoff_x, backoff_y)
    endif

    
  end subroutine drifters_set_domain_bounds

  !============================================================================
! <SUBROUTINE NAME="drifters_positions2lonlat">
!  <OVERVIEW>
!  Interpolates positions onto longitude/latitude grid.
!  </OVERVIEW>
!  <DESCRIPTION>
!  In many cases, the integrated positions will not be longitudes  or latitudes. This call
!  can be ionvoked to recover the longitude/latitude positions from the "logical" positions.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call   drifters_positions2lonlat(self, positions, &
!		&                                        x1, y1, geolon1, &
!		&                                        x2, y2, geolat2, &
!		&                                        lons, lats, &
!		&                                        ermesg)
!		
!  </TEMPLATE>
!  <INOUT NAME="self" TYPE="drifters_type" DIM="SCALAR" UNITS="" DEFAULT="">
!  Opaque data structure.
!  </INOUT>
!  <IN NAME="positions" TYPE="real" DIM="" UNITS="" DEFAULT="">
!  Logical positions.
!  </IN>
!  <IN NAME="x1" TYPE="real" DIM="" UNITS="" DEFAULT="">
!  X-axis of "geolon1" field.
!  </IN>
!  <INOUT NAME="y1" TYPE="" DIM="" UNITS="" DEFAULT="">
!  Y-axis of "geolon1" field.
!  </INOUT>
!  <INOUT NAME="geolon1" TYPE="" DIM="" UNITS="" DEFAULT="">
!  Longitude field as an array of (x1, y1).
!  </INOUT>
!  <IN NAME="x2" TYPE="real" DIM="" UNITS="" DEFAULT="">
!  X-axis of "geolat2" field.
!  </IN>
!  <INOUT NAME="y2" TYPE="" DIM="" UNITS="" DEFAULT="">
!  Y-axis of "geolat2" field.
!  </INOUT>
!  <INOUT NAME="geolat2" TYPE="" DIM="" UNITS="" DEFAULT="">
!  Latitude field as an array of (x2, y2)
!  </INOUT>
!  <OUT NAME="lons" TYPE="real" DIM="" UNITS="" DEFAULT="">
!  Returned longitudes.
!  </OUT>
!  <INOUT NAME="lats" TYPE="" DIM="" UNITS="" DEFAULT="">
!  Returned latitudes.
!  </INOUT>
!  <OUT NAME="ermesg" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!  Error message (if any).
!  </OUT>
! </SUBROUTINE>
!
  subroutine drifters_positions2lonlat(self, positions, &
       &                                        x1, y1, geolon1, &
       &                                        x2, y2, geolat2, &
       &                                        lons, lats, &
       &                                        ermesg)

    type(drifters_type) :: self
    ! Input positions
    real, intent(in)    :: positions(:,:)
    ! Input mesh
    real, intent(in)    :: x1(:), y1(:), geolon1(:,:) ! geolon1(x1, y1)
    real, intent(in)    :: x2(:), y2(:), geolat2(:,:) ! geolat2(x2, y2)
    ! Output lon/lat 
    real, intent(out)   :: lons(:), lats(:)
    character(len=*), intent(out) :: ermesg

    real    fvals(2**self%core%nd), ts(self%core%nd)
    integer np, ij(2), ip, ier, n1s(2), n2s(2), i, j, iertot
    character(len=10) :: n1_str, n2_str, np_str, iertot_str

    ermesg = ''
    lons = -huge(1.)
    lats = -huge(1.)

    ! check dimensions
    n1s = (/size(x1), size(y1)/)
    n2s = (/size(x2), size(y2)/)
    if(n1s(1) /= size(geolon1, 1) .or. n1s(2) /= size(geolon1, 2)) then
       ermesg = 'drifters_positions2geolonlat: ERROR incompatibles dims between (x1, y1, geolon1)'
       return
    endif
    if(n2s(1) /= size(geolat2, 1) .or. n2s(2) /= size(geolat2, 2)) then
       ermesg = 'drifters_positions2geolonlat: ERROR incompatibles dims between (x2, y2, geolat2)'
       return
    endif

    np = size(positions, 2)
    if(size(lons) < np .or. size(lats) < np) then
       write(np_str, '(i10)') np
       write(n1_str, '(i10)') size(lons)
       write(n2_str, '(i10)') size(lats)
       ermesg = 'drifters_positions2geolonlat: ERROR size of "lons" ('//trim(n1_str)// &
            & ') or "lats" ('//trim(n2_str)//') < '//trim(np_str)
       return
    endif

    ! Interpolate
    iertot = 0
    do ip = 1, np

       ! get longitude
       call cld_ntrp_locate_cell(x1, positions(1,ip), i, ier)
       iertot = iertot + ier
       call cld_ntrp_locate_cell(y1, positions(2,ip), j, ier)
       iertot = iertot + ier
       ij(1) = i; ij(2) = j;
       call cld_ntrp_get_cell_values(n1s, _FLATTEN(geolon1), ij, fvals, ier)
       iertot = iertot + ier
       ts(1) = (positions(1,ip) - x1(i))/(x1(i+1) - x1(i))
       ts(2) = (positions(2,ip) - y1(j))/(y1(j+1) - y1(j))
       call cld_ntrp_linear_cell_interp(fvals, ts, lons(ip), ier)
       iertot = iertot + ier

       ! get latitude
       call cld_ntrp_locate_cell(x2, positions(1,ip), i, ier)
       iertot = iertot + ier
       call cld_ntrp_locate_cell(y2, positions(2,ip), j, ier)
       iertot = iertot + ier
       ij(1) = i; ij(2) = j;
       call cld_ntrp_get_cell_values(n2s, _FLATTEN(geolat2), ij, fvals, ier)
       iertot = iertot + ier
       ts(1) = (positions(1,ip) - x2(i))/(x2(i+1) - x2(i))
       ts(2) = (positions(2,ip) - y2(j))/(y2(j+1) - y2(j))
       call cld_ntrp_linear_cell_interp(fvals, ts, lats(ip), ier)
       iertot = iertot + ier

    enddo

  if(iertot /= 0) then
     write(iertot_str, '(i10)') iertot
     ermesg = 'drifters_positions2geolonlat: ERROR '//trim(iertot_str)// &
          & ' interpolation errors (domain out of bounds?)'
  endif

  end subroutine drifters_positions2lonlat

  !============================================================================
! <SUBROUTINE NAME="drifters_print_checksums">
!  <OVERVIEW>
!  Print Runge-Kutta check sums.
!  </OVERVIEW>
!  <DESCRIPTION>
!  Useful for debugging only. 
!  </DESCRIPTION>
!  <TEMPLATE>
!   call   drifters_print_checksums(self, pe, ermesg)
!		
!  </TEMPLATE>
!  <INOUT NAME="self" TYPE="drifters_type" DIM="SCALAR" UNITS="" DEFAULT="">
!  Opaque handle.
!  </INOUT>
!  <IN NAME="pe" TYPE="integer" DIM="SCALAR" UNITS="" DEFAULT="">
!  Processor element.
!  </IN>
!  <OUT NAME="ermesg" TYPE="character" DIM="SCALAR" UNITS="" DEFAULT="">
!  Error message (if any).
!  </OUT>
! </SUBROUTINE>
!
  subroutine drifters_print_checksums(self, pe, ermesg)

    type(drifters_type) :: self
    integer, intent(in), optional :: pe
    character(len=*), intent(out) :: ermesg

    integer, parameter :: i8 = selected_int_kind(13)
    integer(i8) :: mold, chksum_pos, chksum_k1, chksum_k2, chksum_k3, chksum_k4
    integer(i8) :: chksum_tot
    integer nd, np, me

    ermesg = ''

    if(.not. present(pe)) then
       me = _MPP_PE
    else
       me = pe
    endif

    if(me == _MPP_PE) then

       nd = self%core%nd
       np = self%core%np
       chksum_pos = transfer(sum(sum(self%core%positions(1:nd,1:np),1)), mold)
       chksum_k1  = transfer(sum(sum(self%rk4_k1(1:nd,1:np),1)), mold)
       chksum_k2  = transfer(sum(sum(self%rk4_k2(1:nd,1:np),1)), mold)
       chksum_k3  = transfer(sum(sum(self%rk4_k3(1:nd,1:np),1)), mold)
       chksum_k4  = transfer(sum(sum(self%rk4_k4(1:nd,1:np),1)), mold)
       chksum_tot = chksum_pos + chksum_k1 + chksum_k2 + chksum_k3 +chksum_k4

       print *,'==============drifters checksums=========================='
       print '(a,i25,a,i6,a,e15.7)','==positions: ', chksum_pos,  ' PE=', me, ' time = ', self%time
       print '(a,i25,a,i6,a,e15.7)','==k1       : ', chksum_k1,   ' PE=', me, ' time = ', self%time
       print '(a,i25,a,i6,a,e15.7)','==k2       : ', chksum_k2,   ' PE=', me, ' time = ', self%time
       print '(a,i25,a,i6,a,e15.7)','==k3       : ', chksum_k3,   ' PE=', me, ' time = ', self%time
       print '(a,i25,a,i6,a,e15.7)','==k4       : ', chksum_k4,   ' PE=', me, ' time = ', self%time
       print '(a,i25,a,i6,a,e15.7)','==total    : ', chksum_tot,  ' PE=', me, ' time = ', self%time

    endif

  end subroutine drifters_print_checksums

  subroutine drifters_reset_rk4(self, ermesg)
    type(drifters_type) :: self
    character(len=*), intent(out) :: ermesg
    
    integer ier, nd
    
    ermesg = ''

    if(size(self%rk4_k1, 2) < self%core%np) then
       deallocate(self%rk4_k1, stat=ier)
       allocate(self%rk4_k1(self%core%nd, self%core%npdim))
       self%rk4_k1 = 0
    endif
    if(size(self%rk4_k2, 2) < self%core%np) then
       deallocate(self%rk4_k2, stat=ier)
       allocate(self%rk4_k2(self%core%nd, self%core%npdim))
       self%rk4_k2 = 0
    endif
    if(size(self%rk4_k3, 2) < self%core%np) then
       deallocate(self%rk4_k3, stat=ier)
       allocate(self%rk4_k3(self%core%nd, self%core%npdim))
       self%rk4_k3 = 0
    endif
    if(size(self%rk4_k4, 2) < self%core%np) then
       deallocate(self%rk4_k4, stat=ier)
       allocate(self%rk4_k4(self%core%nd, self%core%npdim))
       self%rk4_k4 = 0
    endif

    if(size(self%remove) < self%core%np) then
       deallocate(self%remove, stat=ier)
       allocate(self%remove(self%core%npdim))
       self%remove = .FALSE.
    endif
          
    if(size(self%temp_pos, 2) < self%core%np) then
       deallocate(self%temp_pos, stat=ier)
       nd = size(self%input%velocity_names)
       allocate(self%temp_pos(nd, self%core%npdim))
       self%temp_pos = -huge(1.)
    endif

  end subroutine drifters_reset_rk4

end module drifters_mod

!##############################################################################
! Unit test
! =========
!
! Compilation instructions:
!
!
! Example 1: Altix with MPP
! set FMS="/net2/ap/regression/ia64/25-May-2006/SM2.1U_Control-1990_D1_lm2/"
! set NETCDF="-lnetcdf"
! set MPI="-lmpi"
! set MPP="-I $FMS/exec $FMS//exec/mpp*.o $FMS/exec/threadloc.o"
! set INC="-I/usr/include -I/usr/local/include -I $FMS/src/shared/include -I./"
! set F90="ifort -Duse_libMPI -r8 -g -check bounds"
!
! Example 2: IRIX with MPP
! set FMS="/net2/ap/regression/sgi/25-May-2006/SM2.1U_Control-1990_D1_lm2/"
! set NETCDF="-lnetcdf"
! set MPI="-lmpi -lexc"
! set MPP="-I $FMS/exec/ $FMS/exec/mpp*.o $FMS/exec/threadloc.o $FMS/exec/nsclock.o"
! set INC="-I/usr/include -I/usr/local/include -I $FMS/src/shared/include -I./"
! set F90="f90 -Duse_libMPI -r8 -g -64 -macro_expand -DEBUG:conform_check=YES:subscript_check=ON:trap_uninitialized=ON:verbose_runtime=ON"
!
! Example 3: ia32 without MPP/MPI
! set MPI=""
! set MPP=""
! set NETCDF="-L/net/ap/Linux.i686/pgf95/lib -lnetcdf"
! set INC="-I/net/ap/Linux.i686/pgf95/include -I /home/ap/HIM/him_global/include -I./"
! set 
! set F90="/usr/local/nf95/bin/nf95 -g -r8 -C=all -colour"
! or  
! set F90="pgf95 -g -r8 -Mbounds -Mchkfpstk -Mchkptr -Mstabs"
! or
! set F90="lf95 --dbl"
!
! All platforms:
!
! set SRCS="cloud_interpolator.F90 quicksort.F90 drifters_core.F90 drifters_io.F90 drifters_input.F90 drifters_comm.F90 drifters.F90"
! $F90 -D_DEBUG -D_TEST_DRIFTERS $INC $MPP $SRCS $NETCDF $MPI
! 
! 
! Run the test unit:
! =================
! rm -f drifters_out_test_3d.nc.*
! mpirun -np # a.out
! drifters_combine -f drifters_out_test_3d.nc
! md5sum drifters_out_test_3d.nc
! 548603caca8db971f2e833b9ce8b85f0  drifters_out_test_3d.nc
! md5sum drifters_res.nc 
! 6b697d25ff9ee719b5cedbdc6ccb702a  drifters_res.nc
!
! NOTE: checksums on drifters_res.nc may vary according to PE layouts. The
! differences should only affect the (arbitrary) order in which drifters
! are saved onto file.

! On IRIX64:
! set F90="f90 -r8 -g -64 -macro_expand -DEBUG:conform_check=YES:subscript_check=ON:trap_uninitialized=ON:verbose_runtime=ON" 
! $F90 -D_DEBUG -D_TEST_DRIFTERS $INC -I $MPPLIB_DIR $SRCS $MPPLIB_DIR/mpp*.o $MPPLIB_DIR/nsclock.o $MPPLIB_DIR/threadloc.o -L/usr/local/lib -lnetcdf -lmpi -lexc
! 
! input file: drifters_inp_test_3d.nc
!!$netcdf drifters_inp_test_3d {
!!$dimensions:
!!$	nd = 3 ; // number of dimensions (2 or 3)
!!$	np = 4 ; // number of particles
!!$variables:
!!$	double positions(np, nd) ;
!!$		positions:names = "x y z" ;
!!$		positions:units = "- - -" ;
!!$	int ids(np) ;
!!$
!!$// global attributes:
!!$		:velocity_names = "u v w" ;
!!$		:field_names = "temp" ;
!!$		:field_units = "C" ;
!!$		:time_units = "seconds" ;
!!$		:title = "example of input data for drifters" ;
!!$data:
!!$
!!$ positions =
!!$  -0.8, 0., 0.,
!!$  -0.2, 0., 0., 
!!$   0.2, 0., 0.,
!!$   0.8, 0., 0.;
!!$
!!$ ids = 1, 2, 3, 4 ; // must range from 1 to np, in any order
!!$}


#ifdef _TEST_DRIFTERS

! number of dimensions (2 or 3)
#define _DIMS 3

subroutine my_error_handler(mesg)
#ifndef _SERIAL
  use mpp_mod, only : FATAL, mpp_error
#endif
  implicit none
  character(len=*), intent(in) :: mesg
#ifndef _SERIAL
  call mpp_error(FATAL, mesg)
#else
  print *, mesg
  stop 
#endif
end subroutine my_error_handler

program test

  ! Example showing how to use drifters_mod.
  
  use drifters_mod
#ifndef _SERIAL
  use mpp_mod
  use mpp_domains_mod
#endif
  implicit none
  
  ! declare drifters object
  type(drifters_type) :: drfts  ! drifters' object
  type(drifters_type) :: drfts2 ! to test copy
  character(len=128)  :: ermesg

  real    :: t0, dt, t, tend, rho
  real    :: xmin, xmax, ymin, ymax, zmin, zmax, theta
  real, parameter :: pi = 3.1415926535897931159980
  real, allocatable :: x(:), y(:)
#if _DIMS == 2
  real, allocatable :: u(:,:), v(:,:), w(:,:), temp(:,:)
#endif
#if _DIMS == 3
  real, allocatable :: z(:), u(:,:,:), v(:,:,:), w(:,:,:), temp(:,:,:)
#endif
  integer :: layout(2), nx, ny, nz, halox, haloy, i, j, k, npes, pe, root
  integer :: isd,  ied,  jsd,  jed, isc,  iec,  jsc,  jec
  integer :: pe_beg, pe_end
  integer :: ibnds(1) ! only used in _SERIAL mode

  _TYPE_DOMAIN2D :: domain

#ifndef _SERIAL
  call mpp_init
#endif
  npes   = _MPP_NPES
  pe     = _MPP_PE
  root   = _MPP_ROOT
  pe_beg = npes/2
  pe_end = npes-1


  ! input parameters
  t0 = 0.0 ! initial time
  tend = 2.0*pi ! max time
  dt =  tend/20.0 ! time step
  ! domain boundaries
  xmin = -1. ; xmax = 1.
  ymin = -1. ; ymax = 1.
  zmin = -1. ; zmax = 1.
  nx = 41; ny = 41; nz = 21;
  halox = 2; haloy = 2;

  allocate( x(1-halox:nx+halox), y(1-haloy:ny+haloy))
  x = xmin + (xmax-xmin)*(/ (real(i-1)/real(nx-1), i = 1-halox, nx+halox) /)
  y = ymin + (ymax-ymin)*(/ (real(j-1)/real(ny-1), j = 1-haloy, ny+haloy) /)

#if _DIMS == 2
  allocate( u(1-halox:nx+halox, 1-haloy:ny+haloy), &
       &    v(1-halox:nx+halox, 1-haloy:ny+haloy), &
       &    w(1-halox:nx+halox, 1-haloy:ny+haloy), &
       & temp(1-halox:nx+halox, 1-haloy:ny+haloy))
#endif
#if _DIMS == 3
  allocate( z(nz) )
  z = zmin + (zmax-zmin)*(/ (real(k-1)/real(nz-1), k = 1, nz) /)
  allocate( u(1-halox:nx+halox, 1-haloy:ny+haloy, nz), &
       &    v(1-halox:nx+halox, 1-haloy:ny+haloy, nz), &
       &    w(1-halox:nx+halox, 1-haloy:ny+haloy, nz), &
       & temp(1-halox:nx+halox, 1-haloy:ny+haloy, nz))
#endif


#ifndef _SERIAL
  ! decompose domain
  call mpp_domains_init ! (MPP_DEBUG)
!!$  call mpp_domains_set_stack_size(stackmax)

  call mpp_declare_pelist( (/ (i, i=pe_beg, pe_end) /), '_drifters')
#endif

  ! this sumulates a run on a subset of PEs
  if(pe >= pe_beg .and. pe <= pe_end) then 
     
#ifndef _SERIAL
     call mpp_set_current_pelist( (/ (i, i=pe_beg, pe_end) /) )

     call mpp_define_layout( (/1,nx, 1,ny/), pe_end-pe_beg+1, layout )
     if(pe==root) print *,'LAYOUT: ', layout
     call mpp_define_domains((/1,nx, 1,ny/), layout, domain, &
          & xhalo=halox, yhalo=haloy) !,&
     !& xflags=CYCLIC_GLOBAL_DOMAIN, yflags=CYCLIC_GLOBAL_DOMAIN)
#endif

     ! constructor
#if _DIMS == 2
     call drifters_new(drfts, &
          & input_file ='drifters_inp_test_2d.nc'  , &
          & output_file='drifters_out_test_2d.nc', &
          & ermesg=ermesg)
#endif
#if _DIMS == 3
     call drifters_new(drfts, &
          & input_file ='drifters_inp_test_3d.nc'  , &
          & output_file='drifters_out_test_3d.nc', &
          & ermesg=ermesg)
#endif
     if(ermesg/='') call my_error_handler(ermesg)

     ! set start/end pe
     drfts%comm%pe_beg = pe_beg
     drfts%comm%pe_end = pe_end

     ! set the initial time and dt
     drfts%time = t0
     drfts%dt   = dt

#ifndef _SERIAL
     call mpp_get_data_domain   ( domain, isd,  ied,  jsd,  jed  )
     call mpp_get_compute_domain( domain, isc,  iec,  jsc,  jec  )
#else
     ibnds = lbound(x); isd = ibnds(1)
     ibnds = ubound(x); ied = ibnds(1)
     ibnds = lbound(y); jsd = ibnds(1)
     ibnds = ubound(y); jed = ibnds(1)
     isc = isd; iec = ied - 1
     jsc = jsd; jec = jed - 1
#endif


     ! set the PE domain boundaries. Xmin_comp/ymin_comp, xmax_comp/ymax_comp
     ! refer to the "compute" domain, which should cover densily the domain: ie
     ! xcmax[pe] = xcmin[pe_east]
     ! ycmax[pe] = ycmin[pe_north]
     ! Xmin_data/ymin_data, xmax_data/ymax_data refer to the "data" domain, which
     ! should be larger than the compute domain and therefore overlap: ie
     ! xdmax[pe] > xdmin[pe_east]
     ! ydmax[pe] > ydmin[pe_north]
     ! Particles in the overlap regions are tracked by several PEs. 

     call drifters_set_domain(drfts, &
          & xmin_comp=x(isc  ), xmax_comp=x(iec+1), &
          & ymin_comp=y(jsc  ), ymax_comp=y(jec+1), &
          & xmin_data=x(isd  ), xmax_data=x(ied  ), &
          & ymin_data=y(jsd  ), ymax_data=y(jed  ), &
          !!$       & xmin_glob=xmin    , xmax_glob=xmax    , & ! periodicity in x
!!$       & ymin_glob=ymin    , ymax_glob=ymax    , & ! periodicity in y
     & ermesg=ermesg)
     if(ermesg/='') call my_error_handler(ermesg)

     ! set neighboring PEs [domain2d is of type(domain2d)]

     call drifters_set_pe_neighbors(drfts, domain=domain, ermesg=ermesg)
     if(ermesg/='') call my_error_handler(ermesg)

     ! set the velocities axes. Each velocity can have different axes.

     call drifters_set_v_axes(drfts, component='u', &
          & x=x, y=y, &
#if _DIMS == 2
          & z=DRFT_EMPTY_ARRAY, &
#endif
#if _DIMS >= 3
          & z=z, &
#endif
          & ermesg=ermesg)
     if(ermesg/='') call my_error_handler(ermesg)

     call drifters_set_v_axes(drfts, component='v', &
          & x=x, y=y, &
#if _DIMS == 2
          & z=DRFT_EMPTY_ARRAY, &
#endif
#if _DIMS >= 3
          & z=z, &
#endif
          & ermesg=ermesg)
     if(ermesg/='') call my_error_handler(ermesg)

#if _DIMS == 3
     call drifters_set_v_axes(drfts, component='w', &
          & x=x, y=y, &
#if _DIMS == 2
          & z=DRFT_EMPTY_ARRAY, &
#endif
#if _DIMS >= 3
          & z=z, &
#endif
          & ermesg=ermesg)
     if(ermesg/='') call my_error_handler(ermesg)
#endif

     ! Distribute the drifters across PEs
     call drifters_distribute(drfts, ermesg)
     if(ermesg/='') call my_error_handler(ermesg)

     t = t0

     do while (t <= tend+epsilon(1.))

        ! Update time

        t = t + dt/2.0

        ! Set velocity and field
#if _DIMS == 2
        do j = 1-haloy, ny+haloy
           do i = 1-halox, nx+halox
              theta = atan2(y(j), x(i))
              rho   = sqrt(x(i)**2 + y(j)**2)
              u(i,j) = - rho * sin(theta)
              v(i,j) = + rho * cos(theta)
              temp(i,j) = (x(i)**2 + y(j)**2)
           enddo
        enddo
        ! Push the drifters
        call drifters_push(drfts, u=u, v=v, ermesg=ermesg)
        if(ermesg/='') call my_error_handler(ermesg)
#endif
#if _DIMS == 3
        do k = 1, nz
           do j = 1-haloy, ny+haloy
              do i = 1-halox, nx+halox
                 theta = atan2(y(j), x(i))
                 rho   = sqrt(x(i)**2 + y(j)**2)
                 u(i,j,k) = - rho * sin(theta)
                 v(i,j,k) = + rho * cos(theta)
                 w(i,j,k) = + 0.01 * cos(t)
                 temp(i,j,k) = (x(i)**2 + y(j)**2) * (1.0 - z(k)**2)
              enddo
           enddo
        enddo
        ! Push the drifters
        call drifters_push(drfts, u=u, v=v, w=w, ermesg=ermesg)
        if(ermesg/='') call my_error_handler(ermesg)
#endif


        ! Check if RK4 integration is complete

        if(drfts%rk4_completed) then

           ! Interpolate fields

           call drifters_set_field(drfts, index_field=1, x=x, y=y, &
#if _DIMS >= 3
                & z=z, &
#endif
                &    data=temp, ermesg=ermesg)
           if(ermesg/='') call my_error_handler(ermesg)

           ! Save data 

           call drifters_save(drfts, ermesg=ermesg)
           if(ermesg/='') call my_error_handler(ermesg)

        endif

     enddo

     ! Write restart file

     call drifters_write_restart(drfts, filename='drifters_res.nc', &
          & ermesg=ermesg)  
     if(ermesg/='') call my_error_handler(ermesg)

     ! test copy
     drfts2 = drfts

     ! destroy

     call drifters_del(drfts, ermesg=ermesg)
     if(ermesg/='') call my_error_handler(ermesg)

     deallocate(x, y)
     deallocate(u, v, temp)
#if _DIMS == 3
     deallocate(z, w)
#endif

  endif

#ifndef _SERIAL
  call mpp_exit
#endif

end program test
#endif 

#include <fms_platform.h>

! ----------------------------------------------------------------
!                   GNU General Public License                        
! This file is a part of MOM.                                                                 
!                                                                      
! MOM is free software; you can redistribute it and/or modify it and  
! are expected to follow the terms of the GNU General Public License  
! as published by the Free Software Foundation; either version 2 of   
! the License, or (at your option) any later version.                 
!                                                                      
! MOM is distributed in the hope that it will be useful, but WITHOUT    
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
! License for more details.                                           
!                                                                      
! For the full text of the GNU General Public License,                
! write to: Free Software Foundation, Inc.,                           
!           675 Mass Ave, Cambridge, MA 02139, USA.                   
! or see:   http://www.gnu.org/licenses/gpl.html                      
!-----------------------------------------------------------------------
!
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> John P. Dunne
!</REVIEWER>
!
!<OVERVIEW>
! Ocean perturbation CO2 module, based on Sarmiento, Orr and Siegenthaler, 1992
!</OVERVIEW>
!
!<DESCRIPTION>
!       Implementation of routines to solve the Ocean perturbation CO2
!       simulations as outlined by "A Perturbation Simulation of
!       CO2 Uptake in an Ocean General Circulation Model", Jorge L. Sarmiento,
!       James C. Orr and Ulrich Siegenthaler, 1992, JGR, 97,
!       pp 3621-3645.
!</DESCRIPTION>
!
! <INFO>
! <REFERENCE>
!       A Perturbation Simulation of
!       CO2 Uptake in an Ocean General Circulation Model, Jorge L. Sarmiento,
!       James C. Orr and Ulrich Siegenthaler, 1992, JGR, 97,
!       pp 3621-3645.
! </REFERENCE>
!
! </INFO>
!
module  ocean_pert_co2_mod

use atmos_ocean_fluxes_mod, only: aof_set_coupler_flux
use diag_manager_mod,   only: register_diag_field, diag_axis_init
use field_manager_mod,  only: fm_get_index
use time_manager_mod,   only: time_type
use field_manager_mod,  only: fm_field_name_len, fm_path_name_len, fm_string_len
use field_manager_mod,  only: fm_get_length, fm_get_value, fm_new_value
use fms_mod,            only: field_exist
use mpp_mod,            only: stdout, stdlog, mpp_error, mpp_sum, FATAL
use time_manager_mod,   only: get_date
use mpp_domains_mod,    only: domain2d
use constants_mod,      only: WTMCO2

use ocean_tpm_util_mod, only: otpm_set_tracer_package, otpm_set_prog_tracer
use fm_util_mod,        only: fm_util_check_for_bad_fields, fm_util_set_value
use fm_util_mod,        only: fm_util_get_string, fm_util_get_logical, fm_util_get_integer, fm_util_get_real
use fm_util_mod,        only: fm_util_get_logical_array, fm_util_get_real_array, fm_util_get_string_array
use fm_util_mod,        only: fm_util_start_namelist, fm_util_end_namelist
use coupler_types_mod,  only: ind_alpha, ind_csurf, coupler_2d_bc_type, ind_flux
use ocean_types_mod,    only: ocean_prog_tracer_type, ocean_grid_type, ocean_time_type
use ocmip2_co2calc_mod, only: ocmip2_co2_alpha
use ocean_util_mod,     only: diagnose_2d, diagnose_2d_comp

implicit none

private

public  :: ocean_pert_co2_end
public  :: ocean_pert_co2_init
public  :: ocean_pert_co2_flux_init
public  :: ocean_pert_co2_sbc
public  :: ocean_pert_co2_source
public  :: ocean_pert_co2_start
public  :: ocean_pert_co2_init_sfc
public  :: ocean_pert_co2_avg_sfc
public  :: ocean_pert_co2_sum_sfc
public  :: ocean_pert_co2_zero_sfc

private :: allocate_arrays

character(len=fm_field_name_len), parameter     :: package_name = 'ocean_pert_co2'
character(len=48), parameter                    :: mod_name = 'ocean_pert_co2_mod'
character(len=48), parameter                    :: diag_name = 'ocean_pert_co2'
character(len=fm_string_len), parameter         :: default_restart_file = 'ocean_pert_co2.res.nc'
character(len=fm_string_len), parameter         :: default_ice_restart_file = 'ice_perturbation_co2.res.nc'
character(len=fm_string_len), parameter         :: default_ocean_restart_file = 'ocean_pert_co2_airsea_flux.res.nc'

!  pert_tco2_global           = global annual surface mean perturbation TCO2 concentration
!  pert_tco2_global_wrk       = work variable used in calculation of
!                         pert_tco2_global
!  sal_global           = surface global annual mean salinity
!                         concentration (PSU)
!  sal_global_wrk       = work variable used in calculation of
!                         sal_global
!  do_pert_co2_virtual_flux  = true to compute virtual flux for perturbation TCO2
type instance_type

  real, _ALLOCATABLE, dimension(:,:)    :: alpha  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: csurf  _NULL
  real                                  :: pert_tco2_global = 0.0
  real                                  :: pert_tco2_global_wrk = 0.0
  logical                               :: do_pert_co2_virtual_flux
  character(len=fm_string_len)          :: implementation
  real                                  :: global_wrk_duration = 0.0
  integer                               :: id_alpha = -1
  integer                               :: id_csurf = -1
  integer                               :: id_pco2surf = -1
  integer                               :: id_z0 = -1
  integer                               :: id_z1 = -1
  integer                               :: id_sfc_flux_pert_co2 = -1
  integer                               :: id_vstf_pert_tco2 = -1
  integer                               :: ind_pert_tco2
  integer                               :: ind_co2_flux
  character(len=fm_field_name_len)      :: name
  real, _ALLOCATABLE, dimension(:,:)    :: pco2surf  _NULL
  real                                  :: sal_global = 35.0
  real                                  :: sal_global_wrk = 0.0
  integer                               :: id_sc_co2 = -1
  real, _ALLOCATABLE, dimension(:,:)    :: sc_co2  _NULL
  real                                  :: sc_co2_0
  real                                  :: sc_co2_1
  real                                  :: sc_co2_2
  real                                  :: sc_co2_3
  real, _ALLOCATABLE, dimension(:,:)    :: vstf_pert_tco2  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: z0  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: z1  _NULL

end type instance_type

logical, public :: do_ocean_pert_co2

integer                                 :: indsal
integer                                 :: indtemp
integer                                 :: package_index
logical                                 :: module_initialized = .false.

character(len=128) :: version = '$Id: ocean_pert_co2.F90,v 20.0 2013/12/14 00:09:34 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!       Calculated parameters (with possible initial input values):
!
!  global_wrk_duration  = total time during calculation of global
!                         variables

real, allocatable, dimension(:,:)               :: sc_no_term
type(instance_type), allocatable, dimension(:)  :: instance
integer                                         :: instances

contains

!#######################################################################
! <SUBROUTINE NAME="allocate_arrays">
!
! <DESCRIPTION>
!     Dynamically allocate arrays
! </DESCRIPTION>
!
subroutine allocate_arrays(isc, iec, jsc, jec, nk, isd, ied, jsd, jed)

integer, intent(in)     :: isc
integer, intent(in)     :: iec
integer, intent(in)     :: jsc
integer, intent(in)     :: jec
integer, intent(in)     :: isd
integer, intent(in)     :: ied
integer, intent(in)     :: jsd
integer, intent(in)     :: jed
integer, intent(in)     :: nk

integer :: i, j, n

! global variables
allocate( sc_no_term(isc:iec,jsc:jec) )

! initialize some arrays
sc_no_term(isc:iec,jsc:jec) = 1.0

!       allocate instance array elements
do n = 1, instances
  allocate( instance(n)%csurf(isc:iec,jsc:jec) )
  allocate( instance(n)%alpha(isc:iec,jsc:jec) )
  allocate( instance(n)%pco2surf(isc:iec,jsc:jec) )
  allocate( instance(n)%z0(isc:iec,jsc:jec) )
  allocate( instance(n)%z1(isc:iec,jsc:jec) )
  if (instance(n)%do_pert_co2_virtual_flux) then
    allocate( instance(n)%vstf_pert_tco2(isc:iec,jsc:jec) )
  endif
  allocate( instance(n)%sc_co2(isc:iec,jsc:jec) )
enddo

!       initialize instance array elements
do n = 1, instances

  do j = jsc, jec
    do i = isc, iec
      instance(n)%csurf(i,j) = 0.0
      instance(n)%alpha(i,j) = 0.0
      instance(n)%pco2surf(i,j) = 0.0
      instance(n)%sc_co2(i,j) = 0.0
      instance(n)%z0(i,j) = 0.0
      instance(n)%z1(i,j) = 0.0
    enddo
  enddo
  if (instance(n)%do_pert_co2_virtual_flux) then
    do j = jsc, jec
      do i = isc, iec
        instance(n)%vstf_pert_tco2(i,j) = 0.0
      enddo
    enddo
  endif

enddo

return
end subroutine  allocate_arrays
! </SUBROUTINE> NAME="allocate_arrays"


!#######################################################################
! <SUBROUTINE NAME="ocean_pert_co2_bbc">
!
! <DESCRIPTION>
!     calculate the surface boundary conditions
! </DESCRIPTION>
!
subroutine ocean_pert_co2_bbc

end subroutine  ocean_pert_co2_bbc
! </SUBROUTINE> NAME="ocean_pert_co2_bbc"


!#######################################################################
! <SUBROUTINE NAME="ocean_pert_co2_end">
!
! <DESCRIPTION>
!     Clean up various quantities for this run.
! </DESCRIPTION>
!
subroutine ocean_pert_co2_end(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,        &
     T_prog, grid_dat, grid_tmask, mpp_domain2d, rho_dzt, taup1)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
type(ocean_prog_tracer_type), intent(in), dimension(:)  :: T_prog
integer, intent(in)                                     :: taup1
real, dimension(isd:,jsd:), intent(in)            :: grid_dat
real, dimension(isd:,jsd:,:), intent(in)         :: grid_tmask
type(domain2d), intent(in)                              :: mpp_domain2d
real, dimension(isd:,jsd:,:,:), intent(in)       :: rho_dzt

integer                                 :: i
integer                                 :: j
integer                                 :: k
integer                                 :: n
real                                    :: total_pert_tco2

  integer :: stdoutunit 
  stdoutunit=stdout() 

!       integrate the total concentrations of some tracers
!       for the end of the run

!       Use taup1 time index for the start of a run, and taup1 time
!       index for the end of a run so that we are integrating the
!       same time level and should therefore get identical results
do n = 1, instances

  total_pert_tco2 = 0.0

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        total_pert_tco2 = total_pert_tco2 +                             &
             t_prog(instance(n)%ind_pert_tco2)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo

  call mpp_sum(total_pert_tco2)

  write (stdoutunit,*) '  Instance ', trim(instance(n)%name)
  write (stdoutunit,                                                      &
       '(/'' Total pert TCO2  = '',es19.12,'' Gmol-C'')')               &
       total_pert_tco2 * 1.0e-09
enddo

write(stdoutunit,*)

return
end subroutine  ocean_pert_co2_end
! </SUBROUTINE> NAME="ocean_pert_co2_end"


!#######################################################################
! <SUBROUTINE NAME="ocean_pert_co2_sbc">
!
! <DESCRIPTION>
!     Calculate the surface boundary conditions
! </DESCRIPTION>
!

subroutine ocean_pert_co2_sbc(isc, iec, jsc, jec,       &
     isc_bnd, jsc_bnd,                      &
     T_prog, Grid, Time, ice_ocean_boundary_fluxes)

integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: isc_bnd
integer, intent(in)                                             :: jsc_bnd
type(ocean_prog_tracer_type), intent(inout), dimension(:)       :: T_prog
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time
type(coupler_2d_bc_type), intent(in)                            :: ice_ocean_boundary_fluxes

integer :: i, j, k, n, m
integer :: i_bnd_off
integer :: j_bnd_off
integer :: kz
logical :: used

!     use the surface fluxes from the coupler
!       stf is in mol/m^2/s, flux from coupler is positive upwards
i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

do n = 1, instances
  do j = jsc, jec
    do i = isc, iec
      t_prog(instance(n)%ind_pert_tco2)%stf(i,j) =                      &
            -ice_ocean_boundary_fluxes%bc(instance(n)%ind_co2_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
    enddo
  enddo
enddo

!     add in the virtual fluxes as defined by equations (2) and (3)
!     in the OCMIP2 ABIOTIC HOWTO.
!       Note: the factor of 1000 is to convert the delta salinity from
!             model units to PSU

!       Save variables for diagnostics
do n = 1, instances
   call diagnose_2d_comp(Time, Grid, instance(n)%id_sc_co2, instance(n)%sc_co2(:,:))
   call diagnose_2d(Time, Grid, instance(n)%id_sfc_flux_pert_co2, t_prog(instance(n)%ind_pert_tco2)%stf(:,:))
enddo

return

end subroutine  ocean_pert_co2_sbc
! </SUBROUTINE> NAME="ocean_pert_co2_sbc"


!#######################################################################
! <SUBROUTINE NAME="ocean_pert_co2_flux_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the ocean-atmosphere gas fluxes
! </DESCRIPTION>

subroutine ocean_pert_co2_flux_init

character(len=64), parameter    :: sub_name = 'ocean_pert_co2_flux_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=256)                                      :: caller_str

  integer :: stdoutunit 
  stdoutunit=stdout() 

!       First, perform some initialization if this module has not been
!       initialized because the normal initialization routine will
!       not have been called as part of the normal ocean model
!       initialization if this is an Atmosphere pe of a coupled
!       model running in concurrent mode
if (.not. module_initialized) then

   ! Initialize the package
  package_index = otpm_set_tracer_package(package_name,            &
       restart_file = default_restart_file,     &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')

  ! Check whether to use this package
  path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
  instances = fm_get_length(path_to_names)
  if (instances .lt. 0) then
    call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
  endif

  write (stdoutunit,*)
  if (instances .eq. 0) then
    write (stdoutunit,*) trim(note_header), ' No instances'
    do_ocean_pert_co2 = .false.
  else
    if (instances .eq. 1) then
      write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
    else
      write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
    endif
    do_ocean_pert_co2 = .true.
  endif

  module_initialized = .true.

endif

! Return if we don't want to use this package
if (.not. do_ocean_pert_co2) then
  return
endif

if (.not. allocated(instance)) then

   ! allocate storage for instance array
  allocate ( instance(instances) )

  ! loop over the names, saving them into the instance array
  do n = 1, instances

    if (fm_get_value(path_to_names, name, index = n)) then
      instance(n)%name = name
    else
      write (name,*) n
      call mpp_error(FATAL, trim(error_header) //        &
           'Bad field name for index ' // trim(name))
    endif

  enddo

endif

! Set up the ocean-atmosphere gas flux fields
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

  name = instance(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
  else
    suffix = '_' // name
  endif

  ! Coupler fluxes
  instance(n)%ind_co2_flux = aof_set_coupler_flux('pert_co2_flux' // suffix,                    &
       flux_type = 'air_sea_gas_flux', implementation = 'linear',                               &
       mol_wt = WTMCO2, param = (/ 4.033e-10, 2.0, 1.0 /),                                                       &
       ice_restart_file = default_ice_restart_file,                                             &
       ocean_restart_file = default_ocean_restart_file,                                         &
       caller = caller_str)

  instance(n)%implementation = fm_util_get_string ('/coupler_mod/fluxes/pert_co2_flux' // trim(suffix) //       &
       '/implementation', scalar = .true.)
  if (.not. (instance(n)%implementation .eq. 'linear' .or.              &
             instance(n)%implementation .eq. 'ocmip2' .or.              &
             instance(n)%implementation .eq. 'ocmip2_data')) then
    call mpp_error(FATAL, trim(error_header) //                         &
         'Unsupported flux implementation: "' // trim(instance(n)%implementation) // '"')
  endif
enddo

return

end subroutine  ocean_pert_co2_flux_init
! </SUBROUTINE> NAME="ocean_pert_co2_flux_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_pert_co2_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the tracer packages
!
!       Save pointers to various "types", such as Grid and Domains.
! </DESCRIPTION>

subroutine ocean_pert_co2_init

character(len=64), parameter    :: sub_name = 'ocean_pert_co2_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=fm_field_name_len+3)                      :: long_suffix
character(len=256)                                      :: caller_str
character(len=fm_string_len), pointer, dimension(:)     :: good_list

  integer :: stdoutunit 
  stdoutunit=stdout() 

  ! Initialize the package
package_index = otpm_set_tracer_package(package_name,            &
     restart_file = default_restart_file,   &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')

! Check whether to use this package
path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
instances = fm_get_length(path_to_names)
if (instances .lt. 0) then
  call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
endif

write (stdoutunit,*)
if (instances .eq. 0) then
  write (stdoutunit,*) trim(note_header), ' No instances'
  do_ocean_pert_co2 = .false.
else
  if (instances .eq. 1) then
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
  else
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
  endif
  do_ocean_pert_co2 = .true.
endif

module_initialized = .true.

! Return if we don't want to use this package
if (.not. do_ocean_pert_co2) then
  return
endif

! allocate storage for instance array
allocate ( instance(instances) )

! loop over the names, saving them into the instance array
do n = 1, instances

  if (fm_get_value(path_to_names, name, index = n)) then
    instance(n)%name = name
  else
    write (name,*) n
    call mpp_error(FATAL, trim(error_header) //        &
         'Bad field name for index ' // trim(name))
  endif

enddo

! Set up the field input
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

  name = instance(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // name
    long_suffix = ' (' // trim(name) // ')'
  endif

  ! perturbation TCO2
  instance(n)%ind_pert_tco2 = otpm_set_prog_tracer('pert_tco2' // suffix,       &
       package_name,                                                            &
       longname = 'perturbation TCO2' // trim(long_suffix),                     &
       units = 'mol/kg', flux_units = 'mol/m^2/s',                             &
       caller = caller_str)

enddo

!       Process the namelists

!       Add the package name to the list of good namelists, to be used
!       later for a consistency check
if (fm_new_value('/ocean_mod/GOOD/good_namelists', package_name, append = .true.) .le. 0) then
  call mpp_error(FATAL, trim(error_header) //                           &
       ' Could not add ' // trim(package_name) // ' to "good_namelists" list')
endif

! Set up the instance namelists
do n = 1, instances
   ! create the instance namelist
  call fm_util_start_namelist(package_name, instance(n)%name, caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('sal_global', 35.0)                            ! PSU
  call fm_util_set_value('do_pert_co2_virtual_flux', .false.)
  call fm_util_set_value('pert_tco2_global', 2.0)                       ! mol/m^3

  ! New Wanninkhof numbers
  call fm_util_set_value('sc_co2_0', 2068.9)
  call fm_util_set_value('sc_co2_1', -118.63)
  call fm_util_set_value('sc_co2_2', 2.9311)
  call fm_util_set_value('sc_co2_3', -0.027)

  call fm_util_end_namelist(package_name, instance(n)%name, check = .true., caller = caller_str)

enddo

! Check for any errors in the number of fields in the namelists for this package
good_list => fm_util_get_string_array('/ocean_mod/GOOD/namelists/' // trim(package_name) // '/good_values',     &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
if (associated(good_list)) then
  call fm_util_check_for_bad_fields('/ocean_mod/namelists/' // trim(package_name), good_list,                   &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')
  deallocate(good_list)
else
  call mpp_error(FATAL,trim(error_header) // ' Empty "' // trim(package_name) // '" list')
endif

return

end subroutine ocean_pert_co2_init
! </SUBROUTINE> NAME="ocean_pert_co2_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_pert_co2_init_sfc">
!
! <DESCRIPTION>
!       Initialize surface fields for flux calculations
!
!       Note: this subroutine should be merged into ocean_pert_co2_start
! </DESCRIPTION>
subroutine ocean_pert_co2_init_sfc(isc, iec, jsc, jec, isd, ied, jsd, jed,  &
     isc_bnd, jsc_bnd,                                         &
     Ocean_fields, T_prog, rho, taum1, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: jsc_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho
integer, intent(in)                                     :: taum1
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer :: i, j, m, n
integer :: i_bnd_off
integer :: j_bnd_off
integer :: nn
integer :: ind

real    :: epsln=1.0e-30

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

do n = 1, instances

   ! CO2 flux
  ind = instance(n)%ind_co2_flux
  if (.not. field_exist('INPUT/'//trim(Ocean_fields%bc(ind)%ocean_restart_file),    &
                        Ocean_fields%bc(ind)%field(ind_alpha)%name)) then
     !  Compute the moist air compensation term (placed in alpha) and the
     !  surface delta ocean perturbation CO2

     ! z0 has units of ppm/(umol/kg) and z1 has units of 1/(umol/kg),
     ! and we need to convert then to (kg/kg)/(mol/m^3) and 1/(mol/m^3), respectively
     
     ! Changed 0.31618 to 0.031618, as it appears to have been an error in the paper
    if (instance(n)%implementation .eq. 'linear') then
      do j = jsc, jec
        do i = isc, iec
          instance(n)%alpha(i,j) = (1.0 - exp(20.1050 -                                           &
               0.0097982 * (t_prog(indtemp)%field(i,j,1,taum1) + 273.15) -                        &
               6163.10 / (t_prog(indtemp)%field(i,j,1,taum1) + 273.15))) * 1.0e+06 * grid_tmask(i,j,1)
        enddo
      enddo
    else
      call ocmip2_co2_alpha(                                                    &
           isd, jsd, isc, iec, jsc, jec,                              &
           t_prog(indtemp)%field(isd:ied,jsd:jed,1,taum1),                      &
           t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1), grid_tmask(isd:ied,jsd:jed,1), instance(n)%alpha)
      do j = jsc, jec
        do i = isc, iec
          instance(n)%sc_co2(i,j) =                                             &
             instance(n)%sc_co2_0 + t_prog(indtemp)%field(i,j,1,taum1) *        &
             (instance(n)%sc_co2_1 + t_prog(indtemp)%field(i,j,1,taum1) *       &
              (instance(n)%sc_co2_2 + t_prog(indtemp)%field(i,j,1,taum1) *      &
               instance(n)%sc_co2_3)) * grid_tmask(i,j,1)
          sc_no_term(i,j) = sqrt(660.0 / (instance(n)%sc_co2(i,j) + epsln)) * grid_tmask(i,j,1)
        enddo
      enddo
    endif
    do j = jsc, jec
      do i = isc, iec
        instance(n)%z0(i,j) = (1.7561 -                                                         &
             0.031618 * t_prog(indtemp)%field(i,j,1,taum1) +                                    &
             0.0004444 * t_prog(indtemp)%field(i,j,1,taum1)**2) * grid_tmask(i,j,1)
        instance(n)%z1(i,j) = (0.004096 -                                                       &
             7.7086e-05 * t_prog(indtemp)%field(i,j,1,taum1) +                                  &
             6.10e-07 * t_prog(indtemp)%field(i,j,1,taum1)**2) * grid_tmask(i,j,1)
        instance(n)%pco2surf(i,j) = (instance(n)%z0(i,j) *                                      &
             t_prog(instance(n)%ind_pert_tco2)%field(i,j,1,taum1) * 1.0e+06 / 1024.5 /          &
             (1.0 - instance(n)%z1(i,j) *                                                       &
              t_prog(instance(n)%ind_pert_tco2)%field(i,j,1,taum1) * 1.0e+06 / 1024.5)) * grid_tmask(i,j,1)
        instance(n)%csurf(i,j) = instance(n)%alpha(i,j) * instance(n)%pco2surf(i,j) * 1.0e-06
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             instance(n)%alpha(i,j) * rho(i,j,1,taum1) * sc_no_term(i,j)
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             instance(n)%csurf(i,j) * rho(i,j,1,taum1) * sc_no_term(i,j)
      enddo
    enddo

  endif

enddo

return

end subroutine ocean_pert_co2_init_sfc
! </SUBROUTINE> NAME="ocean_pert_co2_init_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_pert_co2_sum_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>

subroutine ocean_pert_co2_sum_sfc(isc, iec, jsc, jec, isd, ied, jsd, jed,   &
     isc_bnd, jsc_bnd,                            &
     Ocean_fields, T_prog, rho, taum1, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: jsc_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
type(ocean_prog_tracer_type), intent(in), dimension(:)  :: T_prog
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho
integer, intent(in)                                     :: taum1
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer :: i, j, n, nn
integer :: i_bnd_off
integer :: j_bnd_off
integer :: ind

real    :: epsln=1.0e-30

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

do n = 1, instances

    ind = instance(n)%ind_co2_flux

    !  Compute the moist air compensation term (placed in alpha) and the
    !  surface delta ocean perturbation CO2

    !       z0 has units of ppm/(umol/kg) and z1 has units of 1/(umol/kg),
    !       and we need to convert then to (kg/kg)/(mol/m^3) and 1/(mol/m^3), respectively

    !       Changed 0.31618 to 0.031618, as it appears to have been an error in the paper
    if (instance(n)%implementation .eq. 'linear') then
      do j = jsc, jec
        do i = isc, iec
          instance(n)%alpha(i,j) = (1.0 - exp(20.1050 -                                           &
               0.0097982 * (t_prog(indtemp)%field(i,j,1,taum1) + 273.15) -                        &
               6163.10 / (t_prog(indtemp)%field(i,j,1,taum1) + 273.15))) * 1.0e+06 * grid_tmask(i,j,1)
        enddo
      enddo
    else
      call ocmip2_co2_alpha(                                                    &
           isd, jsd, isc, iec, jsc, jec,                              &
           t_prog(indtemp)%field(isd:ied,jsd:jed,1,taum1),                      &
           t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1), grid_tmask(isd:ied,jsd:jed,1), instance(n)%alpha)
      do j = jsc, jec
        do i = isc, iec
          instance(n)%sc_co2(i,j) =                                             &
             instance(n)%sc_co2_0 + t_prog(indtemp)%field(i,j,1,taum1) *        &
             (instance(n)%sc_co2_1 + t_prog(indtemp)%field(i,j,1,taum1) *       &
              (instance(n)%sc_co2_2 + t_prog(indtemp)%field(i,j,1,taum1) *      &
               instance(n)%sc_co2_3)) * grid_tmask(i,j,1)
          sc_no_term(i,j) = sqrt(660.0 / (instance(n)%sc_co2(i,j) + epsln)) * grid_tmask(i,j,1)
        enddo
      enddo
    endif
    do j = jsc, jec
      do i = isc, iec
        instance(n)%z0(i,j) = (1.7561 -                                                         &
             0.031618 * t_prog(indtemp)%field(i,j,1,taum1) +                                    &
             0.0004444 * t_prog(indtemp)%field(i,j,1,taum1)**2) * grid_tmask(i,j,1)
        instance(n)%z1(i,j) = (0.004096 -                                                       &
             7.7086e-05 * t_prog(indtemp)%field(i,j,1,taum1) +                                  &
             6.10e-07 * t_prog(indtemp)%field(i,j,1,taum1)**2) * grid_tmask(i,j,1)
        instance(n)%pco2surf(i,j) = (instance(n)%z0(i,j) *                                      &
             t_prog(instance(n)%ind_pert_tco2)%field(i,j,1,taum1) * 1.0e+06 / 1024.5 /          &
             (1.0 - instance(n)%z1(i,j) *                                                       &
              t_prog(instance(n)%ind_pert_tco2)%field(i,j,1,taum1) * 1.0e+06 / 1024.5)) * grid_tmask(i,j,1)
        instance(n)%csurf(i,j) = instance(n)%alpha(i,j) * instance(n)%pco2surf(i,j) * 1.0e-06
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +            &
             instance(n)%alpha(i,j) * rho(i,j,1,taum1) * sc_no_term(i,j)
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +            &
             instance(n)%csurf(i,j) * rho(i,j,1,taum1) * sc_no_term(i,j)
      enddo
    enddo
enddo

return

end subroutine ocean_pert_co2_sum_sfc
! </SUBROUTINE> NAME="ocean_pert_co2_sum_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_pert_co2_zero_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>
subroutine ocean_pert_co2_zero_sfc(Ocean_fields)

type(coupler_2d_bc_type), intent(inout) :: Ocean_fields

integer         :: n
integer         :: ind

do n = 1, instances
  ind = instance(n)%ind_co2_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0
enddo

return

end subroutine ocean_pert_co2_zero_sfc
! </SUBROUTINE> NAME="ocean_pert_co2_zero_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_pert_co2_avg_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>

subroutine ocean_pert_co2_avg_sfc(isc, iec, jsc, jec, isd, jsd,     &
     isc_bnd, jsc_bnd, Ocean_fields, Ocean_avg_kount, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: jsc_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
integer                                                 :: Ocean_avg_kount
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer :: i_bnd_off
integer :: j_bnd_off
integer :: i, j, n
integer :: ind
real    :: divid

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

divid = 1./float(Ocean_avg_kount)

do n = 1, instances

  ind = instance(n)%ind_co2_flux

  do j = jsc, jec
    do i = isc, iec
      if (grid_tmask(i,j,1) == 1.0) then
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
      endif
    enddo
  enddo
enddo

return

end subroutine ocean_pert_co2_avg_sfc
! </SUBROUTINE> NAME="ocean_pert_co2_avg_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_pert_co2_sfc_end">
!
! <DESCRIPTION>
!       Initialize surface fields for flux calculations
! </DESCRIPTION>
subroutine ocean_pert_co2_sfc_end 

end subroutine ocean_pert_co2_sfc_end 
! </SUBROUTINE> NAME="ocean_pert_co2_sfc_end"


!#######################################################################
! <SUBROUTINE NAME="ocean_pert_co2_source">
!
! <DESCRIPTION>
!     compute the source terms, including boundary
!     conditions (not done in setvbc, to minimize number
!     of hooks required in MOM base code)
! </DESCRIPTION>
!
subroutine ocean_pert_co2_source(Grid, Time)

type(ocean_grid_type), intent(in) :: Grid
type(ocean_time_type), intent(in) :: Time

integer :: n

do n = 1, instances
   call diagnose_2d_comp(Time, Grid, instance(n)%id_alpha, instance(n)%alpha(:,:))
   call diagnose_2d_comp(Time, Grid, instance(n)%id_csurf, instance(n)%csurf(:,:))
   call diagnose_2d_comp(Time, Grid, instance(n)%id_pco2surf, instance(n)%pco2surf(:,:))
   call diagnose_2d_comp(Time, Grid, instance(n)%id_z0, instance(n)%z0(:,:))
   call diagnose_2d_comp(Time, Grid, instance(n)%id_z1, instance(n)%z1(:,:))
enddo

return

end subroutine  ocean_pert_co2_source
! </SUBROUTINE> NAME="ocean_pert_co2_source"


!#######################################################################
! <SUBROUTINE NAME="ocean_pert_co2_start">
!
! <DESCRIPTION>
! Initialize variables, read in namelists, calculate constants
! for a given run and allocate diagnostic arrays
! </DESCRIPTION>
!
subroutine ocean_pert_co2_start(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,     &
     T_prog, taup1, model_time, grid_dat, grid_tmask,                           &
     grid_tracer_axes, rho_dzt)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
integer, intent(in)                                     :: taup1
type(time_type), intent(in)                             :: model_time
real, dimension(isd:,jsd:), intent(in)                  :: grid_dat
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask
integer, dimension(:), intent(in)                       :: grid_tracer_axes
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho_dzt

character(len=64), parameter    :: sub_name = 'ocean_pert_co2_start'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer                                 :: i, j, k, n
character(len=fm_field_name_len+1)      :: suffix
character(len=fm_field_name_len+3)      :: long_suffix
character(len=256)                      :: caller_str
real                                    :: total_pert_tco2

  integer :: stdoutunit 
  stdoutunit=stdout() 

write(stdoutunit,*) 
write(stdoutunit,*) trim(note_header),                     &
                  'Starting ', trim(package_name), ' module'

!       Determine indices for temperature and salinity
indtemp = fm_get_index('/ocean_mod/prog_tracers/temp')
if (indtemp .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the temperature index')
endif

indsal = fm_get_index('/ocean_mod/prog_tracers/salt')
if (indsal .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the salinity index')
endif

! dynamically allocate the global arrays
call allocate_arrays(isc, iec, jsc, jec, nk, isd, ied, jsd, jed)

! save the *global* namelist values
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

! read in the namelists for each instance
do n = 1, instances
  call fm_util_start_namelist(package_name, instance(n)%name, caller = caller_str)

  instance(n)%sal_global                = fm_util_get_real   ('sal_global', scalar = .true.)
  instance(n)%do_pert_co2_virtual_flux  = fm_util_get_logical('do_pert_co2_virtual_flux', scalar = .true.)
  instance(n)%pert_tco2_global          = fm_util_get_real   ('pert_tco2_global', scalar = .true.)
  instance(n)%sc_co2_0                  = fm_util_get_real   ('sc_co2_0', scalar = .true.)
  instance(n)%sc_co2_1                  = fm_util_get_real   ('sc_co2_1', scalar = .true.)
  instance(n)%sc_co2_2                  = fm_util_get_real   ('sc_co2_2', scalar = .true.)
  instance(n)%sc_co2_3                  = fm_util_get_real   ('sc_co2_3', scalar = .true.)

  call fm_util_end_namelist(package_name, instance(n)%name, caller = caller_str)
enddo

!     Set up analyses

!       register the instance fields
do n = 1, instances

  if (instance(n)%name(1:1) .eq. '_') then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // instance(n)%name
    long_suffix = ' (' // trim(instance(n)%name) // ')'
  endif

  instance(n)%id_sc_co2 = register_diag_field(trim(diag_name),          &
       'sc_co2_' // trim(suffix), grid_tracer_axes(1:2),                &
       model_time, 'Schmidt number - CO2' // trim(long_suffix), ' ',    &
       missing_value = -1.0e+10)
  instance(n)%id_alpha = register_diag_field(trim(diag_name),           &
       'alpha' // trim(suffix), grid_tracer_axes(1:2),                  &
       model_time, 'Alpha CO2' // trim(long_suffix), ' ',               &
       missing_value = -1.0e+10)

  instance(n)%id_csurf = register_diag_field(trim(diag_name),           &
       'csurf' // trim(suffix), grid_tracer_axes(1:2),                  &
       model_time, 'CO2* water' // trim(long_suffix), ' ',              &
       missing_value = -1.0e+10)

  instance(n)%id_pco2surf = register_diag_field(trim(diag_name),        &
       'pco2surf' // trim(suffix), grid_tracer_axes(1:2),               &
       model_time, 'Oceanic pCO2' // trim(long_suffix), 'ppm',          &
       missing_value = -1.0e+10)

  instance(n)%id_z0 = register_diag_field(trim(diag_name),              &
       'z0' // trim(suffix), grid_tracer_axes(1:2),                     &
       model_time, 'z0' // trim(long_suffix), ' ',                      &
       missing_value = -1.0e+10)

  instance(n)%id_z1 = register_diag_field(trim(diag_name),              &
       'z1' // trim(suffix), grid_tracer_axes(1:2),                     &
       model_time, 'z1' // trim(long_suffix), ' ',                      &
       missing_value = -1.0e+10)

  instance(n)%id_sfc_flux_pert_co2 = register_diag_field(trim(diag_name),       &
       'sfc_flux_pert_co2' // trim(suffix), grid_tracer_axes(1:2),              &
       model_time, 'CO2 surface flux' // trim(long_suffix), 'mol m^-1 s^-1',    &
       missing_value = -1.0e+10)
enddo

!       integrate the total concentrations of some tracers
!       for the start of the run

!       Use taup1 time index for the start of a run, and taup1 time
!       index for the end of a run so that we are integrating the
!       same time level and should therefore get identical results
do n = 1, instances

  total_pert_tco2 = 0.0

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        total_pert_tco2 = total_pert_tco2 +                             &
             t_prog(instance(n)%ind_pert_tco2)%field(i,j,k,taup1) *       &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo

  call mpp_sum(total_pert_tco2)

  write (stdoutunit,*) '  Instance ', trim(instance(n)%name)
  write (stdoutunit,                                                      &
       '(/'' Total pert TCO2  = '',es19.12,'' Gmol-C'')')               &
       total_pert_tco2 * 1.0e-09
enddo

write(stdoutunit,*)
write(stdoutunit,*) trim(note_header), 'ocean_pert CO2 tracer runs initialized'
write(stdoutunit,*)

return

end subroutine  ocean_pert_co2_start
! </SUBROUTINE> NAME="ocean_pert_co2_start"

end module  ocean_pert_co2_mod

#include"cppdefs.h"
!-------------------------------------------------------------------------
!BOP
!
! !ROUTINE: Algebraic length-scale with two master scales \label{sec:potentialml}
!
! !INTERFACE:
   subroutine potentialml(nlev,z0b,z0s,h,depth,NN)

! !DESCRIPTION:
!  Computes the length scale by defining two master
!  length scales $l_u$ and $l_d$
!  \begin{equation}
!  \begin{array}{l}
!  \int_{z_0}^{z_0+l_u(z_0)} (b(z_0)-b(z)) dz =k(z_0) \comma \\[4mm]
!  \int_{z_0-l_d(z_0)}^{z_0} (b(z)-b(z_0)) dz =k(z_0)
!  \end{array}
!  \end{equation}
!
!   From $l_u$ and $l_d$ two length--scales are defined: $l_k$,
!   a characteristic mixing length,
!   and $l_\epsilon$, a characteristic dissipation length.
!   They are computed according to
!   \begin{equation}
!   \begin{array}{l}
!   l_k(z_0)= \text{Min} ( l_d(z_0),l_u(z_0)) \comma \\[4mm]
!   l_{\epsilon}(z_0)=\left( l_d(z_0)l_u(z_0)\right)^\frac{1}{2}
!   \point
!   \end{array}
!   \end{equation}
!
!   $l_k$ is used in {\tt kolpran()} to compute eddy viscosity/difussivity.
!   $l_{\epsilon}$ is used to compute the dissipation rate, $\epsilon$
!    according to
!   \begin{equation}
!     \epsilon=C_{\epsilon} k^{3/2} l_{\epsilon}^{-1}
!     \comma
!     C_{\epsilon}=0.7
!    \point
!   \end{equation}
!
! !USES:
   use turbulence, only: L,eps,tke,k_min,eps_min
   use turbulence, only: cde,galp,kappa,length_lim

   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer,  intent(in)                :: nlev

!  bottom and surface roughness (m)
   REALTYPE, intent(in)                :: z0b,z0s

!  layer thickness (m)
   REALTYPE, intent(in)                :: h(0:nlev)

!  local depth (m)
   REALTYPE, intent(in)                :: depth

!  buoyancy frequency (1/s^2)
   REALTYPE, intent(in)                :: NN(0:nlev)
!
! !REVISION HISTORY:
!  Original author(s):  Manuel Ruiz Villarreal, Hans Burchard
!
!  $Log: potentialml.F90,v $
!  Revision 20.0  2013/12/14 00:13:48  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.6  2005-11-15 11:35:02  lars
!  documentation finish for print
!
!  Revision 1.5  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.4  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.3  2003/03/10 09:02:05  gotm
!  Added new Generic Turbulence Model +
!  improved documentation and cleaned up code
!
!  Revision 1.2  2002/02/08 08:59:59  gotm

!  Revision 1.1.1.1  2001/02/12 15:55:58  gotm
!  initial import into CVS
!
!EOP
!-------------------------------------------------------------------------
!
! !LOCAL VARIABLES:
   integer                   :: i,j
   REALTYPE                  :: ds(0:nlev),db(0:nlev)
   REALTYPE                  :: lu(0:nlev),ld(0:nlev)
   REALTYPE                  :: lk(0:nlev),leps(0:nlev)
   REALTYPE                  :: Lcrit,buoydiff,integral,ceps
   REALTYPE, parameter       :: NNmin=1.e-8
!
!-------------------------------------------------------------------------
!BOC
   db(0)=0.
   ds(nlev)=0.

   do i=1,nlev-1
      db(i)=db(i-1)+h(i)      ! distance of intercace i from bottom
      ds(i)=depth-db(i)       ! distance of intercace i from surface
   end do
!
!  Calculation of lu and ld by solving the integral equation following
!  Gaspar (1990). Some other approximations of the integral equation
!  are possible.
!
! Computation of lupward
!
   do i=1,nlev-1
      lu(i)=0.
      integral=0.
      buoydiff=0.
      do j=i+1,nlev
         buoydiff=buoydiff+NN(j-1)*0.5*(h(j)+h(j-1))
         integral=integral+buoydiff*h(j)
         if (integral.ge.tke(i)) then
            if(j.ne.nlev) then
               if(j.ne.i+1) then
                  lu(i)=lu(i)-(integral-tke(i))/buoydiff
               else
!           To avoid lu(i) from becoming too large if NN(i) is too small
               if(NN(i).gt.NNmin) then
                     lu(i)=sqrt(2.)*sqrt(tke(i))/sqrt(NN(i))
                  else
                     lu(i)=h(i)
                  end if
               end if
               goto 600
            end if
         end if
         lu(i)=lu(i)+h(j)
      end do
600   continue
!     Implicitely done in the do loop: if (lu(i).gt.ds(i)) lu(i)=ds(i)
!     lu limited by distance to surface
   end do

!  Computation of ldownward
   do i=nlev-1,1,-1
      ld(i)=0.
      integral=0.
      buoydiff=0.
      do j=i-1,1,-1
         buoydiff=buoydiff+NN(j)*0.5*(h(j+1)+h(j))
         integral=integral-buoydiff*h(j)
         if (integral.ge.tke(i)) then
            if(j.ne.0) then
               if(j.ne.i-1) then
                  ld(i)=ld(i)-(integral-tke(i))/buoydiff
               else
!              To avoid ld(i) from becoming too large if NN(i) is too small
                  if(NN(i).gt.NNmin) then
                     ld(i)=sqrt(2.)*sqrt(tke(i))/sqrt(NN(i))
                  else
                     ld(i)=h(i)
                  end if
               end if
               goto 610
            end if
         end if
         ld(i)=ld(i)+h(j)
      end do
610   continue
!     if (ld(i).gt.db(i)) ld(i)=db(i) !ld limited by distance to bottom
   end do

!   Calculation of lk and leps, mixing and dissipation lengths
   do i=nlev-1,1,-1
!  Suggested by Gaspar:        lk(i)   = min(lu(i),ld(i))
      lk(i)=sqrt(lu(i)*ld(i))
      leps(i) = sqrt(lu(i)*ld(i))
   end do

!  We set L=lk because it is the one we use to calculate num and nuh
   ceps=0.7
   do i=1,nlev-1
      L(i)=lk(i)
   end do

! do the boundaries assuming linear log-law length-scale
   L(0)=kappa*z0b
   L(nlev)=kappa*z0s

   do i=0,nlev

      !  clip the length-scale at the Galperin et al. (1988) value
      !  under stable stratifcitation
      if ((NN(i).gt.0).and.(length_lim)) then
         Lcrit=sqrt(2*galp*galp*tke(i)/NN(i))
         if (L(i).gt.Lcrit) L(i)=Lcrit
      end if

!     compute the dissipation rate
      eps(i)=cde*sqrt(tke(i)*tke(i)*tke(i))/L(i)

      ! substitute minimum value
      if (eps(i).lt.eps_min) then
        eps(i) = eps_min
          L(i) = cde*sqrt(tke(i)*tke(i)*tke(i))/eps_min
      endif

   enddo

   return
   end subroutine potentialml
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

#include "cosp_defs.H"
#ifdef COSP_GFDL
 
!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: zeff.F90,v 20.0 2013/12/13 23:16:53 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

  subroutine zeff(freq,D,N,nsizes,k2,tt,ice,xr,z_eff,z_ray,kr,qe,qs,rho_e)
  use math_lib
  use optics_lib
  implicit none
  
! Purpose:
!   Simulates radar return of a volume given DSD of spheres
!   Part of QuickBeam v1.03 by John Haynes
!   http://reef.atmos.colostate.edu/haynes/radarsim
!
! Inputs:
!   [freq]      radar frequency (GHz)
!   [D]         discrete drop sizes (um)
!   [N]         discrete concentrations (cm^-3 um^-1)
!   [nsizes]    number of discrete drop sizes
!   [k2]        |K|^2, -1=use frequency dependent default 
!   [tt]        hydrometeor temperature (C)
!   [ice]       indicates volume consists of ice
!   [xr]        perform Rayleigh calculations?
!   [qe]        if using a mie table, these contain ext/sca ...
!   [qs]        ... efficiencies; otherwise set to -1
!   [rho_e]     medium effective density (kg m^-3) (-1 = pure)
!
! Outputs:
!   [z_eff]     unattenuated effective reflectivity factor (mm^6/m^3)
!   [z_ray]     reflectivity factor, Rayleigh only (mm^6/m^3)
!   [kr]        attenuation coefficient (db km^-1)
!
! Created:
!   11/28/05  John Haynes (haynes@atmos.colostate.edu)

! ----- INPUTS -----  
  integer, intent(in) :: ice, xr
  integer, intent(in) :: nsizes
  real*8, intent(in) :: freq,D(nsizes),N(nsizes),tt,qe(nsizes), &
    qs(nsizes), rho_e(nsizes)
  real*8, intent(inout) :: k2
  
! ----- OUTPUTS -----
  real*8, intent(out) :: z_eff,z_ray,kr
    
! ----- INTERNAL -----
  integer :: &
  correct_for_rho        ! correct for density flag
  real*8, dimension(nsizes) :: &
  D0, &                  ! D in (m)
  N0, &                  ! N in m^-3 m^-1
  sizep, &               ! size parameter
  qext, &           ! extinction efficiency
  qbsca, &               ! backscatter efficiency
  rho_ice, &             ! bulk density ice (kg m^-3)
  f                 ! ice fraction
  real*8 :: &
  wl, &                  ! wavelength (m)
  cr                            ! kr(dB/km) = cr * kr(1/km)
  complex*16 :: &
  m                 ! complex index of refraction of bulk form
  complex*16, dimension(nsizes) :: &
  m0                ! complex index of refraction
  
  integer*4 :: i,one
  real*8 :: pi
  real*8 :: eta_sum, eta_mie, const, z0_eff, z0_ray, k_sum, &
            n_r, n_i, dqv(1), dqsc, dg, dph(1)
  integer*4 :: err
  complex*16 :: Xs1(1), Xs2(1)

  one=1
  pi = acos(-1.0)
  rho_ice(:) = 917
  z0_ray = 0.0

! // conversions
  D0 = d*1E-6            ! m
  N0 = n*1E12            ! 1/(m^3 m)
  wl = 2.99792458/(freq*10)   ! m
  
! // dielectric constant |k^2| defaults
  if (k2 < 0) then
    k2 = 0.933
    if (abs(94.-freq) < 3.) k2=0.75
    if (abs(35.-freq) < 3.) k2=0.88
    if (abs(13.8-freq) < 3.) k2=0.925
  endif  
  
  if (qe(1) < -9) then

!   // get the refractive index of the bulk hydrometeors
    if (ice == 0) then
      call m_wat(freq,tt,n_r,n_i)
    else
      call m_ice(freq,tt,n_r,n_i)
    endif
    m = cmplx(n_r,-n_i)
    m0(:) = m
    
    correct_for_rho = 0
    if ((ice == 1) .and. (minval(rho_e) >= 0)) correct_for_rho = 1
    
!   :: correct refractive index for ice density if needed
    if (correct_for_rho == 1) then
      f = rho_e/rho_ice
      m0 = ((2+m0**2+2*f*(m0**2-1))/(2+m0**2+f*(1-m0**2)))**(0.5)
    endif       
    
!   :: Mie calculations
    sizep = (pi*D0)/wl
    dqv(1) = 0.
    do i=1,nsizes
      call mieint(sizep(i), m0(i), one, dqv, qext(i), dqsc, qbsca(i), &
        dg, xs1, xs2, dph, err)
    end do
    
  else
!   // Mie table used
    
    qext = qe
    qbsca = qs
    
  endif
  
! // eta_mie = 0.25*sum[qbsca*pi*D^2*N(D)*deltaD]
!                   <--------- eta_sum --------->
! // z0_eff = (wl^4/!pi^5)*(1./k2)*eta_mie
  eta_sum = 0.
  if (size(D0) == 1) then
    eta_sum = qbsca(1)*(n(1)*1E6)*D0(1)**2
  else
    call avint(qbsca*N0*D0**2,D0,nsizes,D0(1),D0(size(D0,1)),eta_sum)
  endif
 
  eta_mie = eta_sum*0.25*pi
  const = (wl**4/pi**5)*(1./k2)
  z0_eff = const*eta_mie

! // kr = 0.25*cr*sum[qext*pi*D^2*N(D)*deltaD]
!                 <---------- k_sum --------->  
  k_sum = 0.
  if (size(D0) == 1) then
    k_sum = qext(1)*(n(1)*1E6)*D0(1)**2
  else
    call avint(qext*N0*D0**2,D0,nsizes,D0(1),D0(size(D0,1)),k_sum)
  endif
  cr = 10./log(10.)
  kr = k_sum*0.25*pi*(1000.*cr)
     
! // z_ray = sum[D^6*N(D)*deltaD]
  if (xr == 1) then
    z0_ray = 0.
    if (size(D0) == 1) then
      z0_ray = (n(1)*1E6)*D0(1)**6
    else
      call avint(N0*D0**6,D0,nsizes,D0(1),D0(size(D0)),z0_ray)
    endif
  endif
  
! // convert to mm^6/m^3
  z_eff = z0_eff*1E18 !  10.*alog10(z0_eff*1E18)
  z_ray = z0_ray*1E18 !  10.*alog10(z0_ray*1E18)
  
  end subroutine zeff

!FDOC_TAG_GFDL
               module bulkphys_rad_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   fil
! </CONTACT>
! <REVIEWER EMAIL="">
!  
! </REVIEWER>
! <OVERVIEW>
!    bulkphys_rad_mod defines cloud radiative properties based on
!    bulk cloud physics values in contrast to microphysically-based
!    properties.
! </OVERVIEW>
! <DESCRIPTION>
!   
! </DESCRIPTION>
!
 
!    shared modules:

use mpp_mod,                only: input_nml_file
use fms_mod,                only: open_namelist_file, mpp_pe, &
                                  fms_init, mpp_root_pe, stdlog,  &
                                  write_version_number, file_exist, & 
                                  check_nml_error, error_mesg,   &
                                  FATAL, close_file

!    shared radiation package modules:

use rad_utilities_mod,      only:  rad_utilities_init, &
                                  cldrad_properties_type, &
                                  cld_specification_type, &
                                  Cldrad_control

!    individual cloud modules:

use rh_based_clouds_mod,    only: rh_based_clouds_init, &
                                  obtain_bulk_sw_rh,   &
                                  obtain_bulk_lw_rh
use diag_clouds_W_mod,      only: diag_clouds_W_init, &
                                  obtain_bulk_sw_diag, &
                                  obtain_bulk_lw_diag
use strat_clouds_W_mod,     only: strat_clouds_W_init, &
                                  obtain_bulk_lw_strat, &
                                  obtain_bulk_sw_strat
use standalone_clouds_mod,  only: standalone_clouds_init,  &
                                  define_column_properties, &
                                  obtain_bulk_sw_sa, obtain_bulk_lw_sa

!--------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!    bulkphys_rad_mod defines cloud radiative properties based on
!    bulk cloud physics values in contrast to microphysically-based
!    properties.
!--------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module --------------------------

character(len=128)  :: version =  '$Id: bulkphys_rad.F90,v 19.0 2012/01/06 20:13:07 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'



!---------------------------------------------------------------------
!-------  interfaces --------

public                                            &
          bulkphys_rad_init, bulkphys_lw_driver,  &
          bulkphys_sw_driver, bulkphys_rad_end

!---------------------------------------------------------------------
!-------- namelist  ---------
 
integer     :: dummy = 1

namelist /bulkphys_rad_nml /  dummy


!----------------------------------------------------------------------
!----  public data -------


!----------------------------------------------------------------------
!----  private data -------

!--------------------------------------------------------------------
!    visible band reflectivity, nir band reflectivity and nir absorp-
!    tivities are given for high, middle and low clouds. two separate
!    sets of parameters are present; set 1 has been used for all cloud
!    parameterizations except for mgrp_prscr_clds, which used the
!    values in data set 2.
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   crfvis: visible band reflectivity. 
!--------------------------------------------------------------------
real  :: crfvis_hi_1  = 0.21
real  :: crfvis_hi_2  = 0.21
real  :: crfvis_mid_1 = 0.45
real  :: crfvis_mid_2 = 0.48
real  :: crfvis_low_1 = 0.59
real  :: crfvis_low_2 = 0.69

!--------------------------------------------------------------------
!   crfir: near-ir band reflectivity.
!--------------------------------------------------------------------
real  :: crfir_hi_1   = 0.21
real  :: crfir_hi_2   = 0.21
real  :: crfir_mid_1  = 0.45
real  :: crfir_mid_2  = 0.48
real  :: crfir_low_1  = 0.59
real  :: crfir_low_2  = 0.69

!--------------------------------------------------------------------
!   cabir: near-ir band absorptivity.
!--------------------------------------------------------------------
real  :: cabir_hi_1   = 0.005
real  :: cabir_hi_2   = 0.005
real  :: cabir_mid_1  = 0.02
real  :: cabir_mid_2  = 0.02
real  :: cabir_low_1  = 0.035
real  :: cabir_low_2  = 0.035

!--------------------------------------------------------------------
!   cldem:  infrared emissivity.
!--------------------------------------------------------------------
real  :: cldem_hi   = 1.00
real  :: cldem_mid  = 1.00
real  :: cldem_low  = 1.00

!------------------------------------------------------------------
!    these variables hold the values that are to be used for the
!    cloud radiative properties for the cloud parameterization 
!    activated.
!------------------------------------------------------------------
real  :: crfvis_hi, crfvis_mid, crfvis_low,    &
         crfir_hi,  crfir_mid,  crfir_low,  &
         cabir_hi,  cabir_mid,  cabir_low

real  :: min_cld_drop_rad, max_cld_drop_rad, &
         min_cld_ice_size, max_cld_ice_size

!-------------------------------------------------------------------
!    logical flag.
!-------------------------------------------------------------------
logical  :: module_is_initialized = .false.

!-------------------------------------------------------------------
!-------------------------------------------------------------------



                           contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
!#####################################################################

! <SUBROUTINE NAME="bulkphys_rad_init">
!  <OVERVIEW>
!    subroutine bulkphys_rad_init is the constructor for
!    bulkphys_rad_mod.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    subroutine bulkphys_rad_init is the constructor for
!    bulkphys_rad_mod.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call bulkphys_rad_init (pref, lonb, latb)
!
!  </TEMPLATE>
!  <IN NAME="pref" TYPE="real">
!       pref      array containing two reference pressure profiles
!                 for use in defining transmission functions [ Pa ]
! 
!  </IN>
!  <IN NAME="lonb" TYPE="real">
!       lonb      2d array of model longitudes on cell corners
!                 [ radians ]
! 
!  </IN>
!  <IN NAME="latb" TYPE="real">
!       latb      2d array of model latitudes at cell corners [radians]
! 
!  </IN>
! </SUBROUTINE>
!
subroutine bulkphys_rad_init (min_cld_drop_rad_in, max_cld_drop_rad_in,&
                              min_cld_ice_size_in, max_cld_ice_size_in,&
                              pref, lonb, latb)

!---------------------------------------------------------------------
!    subroutine bulkphys_rad_init is the constructor for 
!    bulkphys_rad_mod.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
real,                 intent(in) :: min_cld_drop_rad_in, &
                                    max_cld_drop_rad_in,&
                                    min_cld_ice_size_in,  &
                                    max_cld_ice_size_in
real, dimension(:,:), intent(in) :: pref
real, dimension(:,:), intent(in) :: lonb, latb

!---------------------------------------------------------------------
!   intent(in) variables:
!
!       pref      array containing two reference pressure profiles 
!                 for use in defining transmission functions [ Pa ]
!       lonb      2d array of model longitudes on cell corners [ radians ]
!       latb      2d array of model latitudes at cell corners [radians]
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!    local variables:

      integer  ::   unit, ierr, io, logunit
      integer  ::   idum

!---------------------------------------------------------------------
!    local variables:
!
!      unit     io unit for reading nml file and writing logfile
!      ierr     error code
!      io       error status returned from io operation  
!      idum     dummy integer argument needed to satisfy 
!               diag_clouds_W_init call
!
!--------------------------------------------------------------------

!-------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return
 
!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call rad_utilities_init
      if (Cldrad_control%do_diag_clouds)  call diag_clouds_W_init (idum)
      if (Cldrad_control%do_strat_clouds) call strat_clouds_W_init(latb, lonb)
      if (Cldrad_control%do_rh_clouds)    call rh_based_clouds_init 

!---------------------------------------------------------------------
!    read namelist.
!---------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=bulkphys_rad_nml, iostat=io)
      ierr = check_nml_error(io,'bulkphys_rad_nml')
#else   
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ()
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=bulkphys_rad_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'bulkphys_rad_nml')
        enddo
10      call close_file (unit)
      endif
#endif
 
!---------------------------------------------------------------------
!    write namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() )    &
                      write (logunit, nml=bulkphys_rad_nml)

      min_cld_drop_rad = min_cld_drop_rad_in
      max_cld_drop_rad = max_cld_drop_rad_in
      min_cld_ice_size = min_cld_ice_size_in
      max_cld_ice_size = max_cld_ice_size_in

!--------------------------------------------------------------------
!    when executing the gcm or the standalone gcm, define the values
!    of absorptivity and reflectivity to be used for low, middle and
!    high clouds. the values used are different for different cloud 
!    parameterizations.
!---------------------------------------------------------------------
        if (Cldrad_control%do_mgroup_prescribed_iz) then
        if (Cldrad_control%do_mgroup_prescribed) then
          crfvis_hi  = crfvis_hi_2
          crfir_hi   = crfir_hi_2
          crfvis_mid = crfvis_mid_2
          crfir_mid  = crfir_mid_2
          crfvis_low = crfvis_low_2
          crfir_low  = crfir_low_2
          cabir_hi   = cabir_hi_2
          cabir_mid  = cabir_mid_2
          cabir_low  = cabir_low_2
        else
          crfvis_hi  = crfvis_hi_1
          crfir_hi   = crfir_hi_1
          crfvis_mid = crfvis_mid_1
          crfir_mid  = crfir_mid_1
          crfvis_low = crfvis_low_1
          crfir_low  = crfir_low_1
          cabir_hi   = cabir_hi_1
          cabir_mid  = cabir_mid_1
          cabir_low  = cabir_low_1
        endif
      else
        call error_mesg ('bulkphys_rad_mod', &
        ' do_mgroup_prescribed not yet defined', FATAL)
      endif

!---------------------------------------------------------------------
!    when running in standalone columns mode, call 
!    define_column_properties to define the cloud radiative properties.
!---------------------------------------------------------------------
    if (Cldrad_control%do_specified_strat_clouds_iz .and.  &
        Cldrad_control%do_specified_clouds_iz) then
       if (Cldrad_control%do_specified_strat_clouds  .or.  &
           Cldrad_control%do_specified_clouds ) then 
        call standalone_clouds_init   (pref, lonb, latb)
        call define_column_properties (pref, lonb, latb)
       endif 
    else
        call error_mesg ('bulkphys_rad_mod', &
        ' do_specified_strat not yet defined', FATAL)
   endif

!---------------------------------------------------------------------
!    mark the module as initialized.
!---------------------------------------------------------------------
      module_is_initialized = .true.

!----------------------------------------------------------------------



end subroutine bulkphys_rad_init



!#################################################################

! <SUBROUTINE NAME="bulkphys_sw_driver">
!  <OVERVIEW>
!    bulkphys_sw_driver obtains bulk shortwave cloud radiative
!    properties for the active cloud scheme.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    bulkphys_sw_driver obtains bulk shortwave cloud radiative
!    properties for the active cloud scheme.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call bulkphys_sw_driver (is, ie, js, je, cosz, Cld_spec,   &
!                Cldrad_props)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <IN NAME="cosz" TYPE="real">
!      cosz         cosine of the zenith angle [ dimensionless ]
! 
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!      Cld_spec     cloud specification arrays defining the
!                   location, amount and type (hi, middle, lo)
!                   of clouds that are present, provides input
!                   to this subroutine
!                   [ cld_specification_type ]
! 
!  </IN>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output
!               from this routine:
!
!                    %cirabsw   absorptivity of clouds in the
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cirrfsw   reflectivity of clouds in the
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cvisrfsw  reflectivity of clouds in the
!                               visible frequency band
!                               [ dimensionless ]
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine bulkphys_sw_driver (is, ie, js, je, cosz, Cld_spec,   &
                              Cldrad_props)

!---------------------------------------------------------------------
!    bulkphys_sw_driver obtains bulk shortwave cloud radiative 
!    properties for the active cloud scheme.
!---------------------------------------------------------------------
 
integer,                      intent(in)    :: is, ie, js, je
real,    dimension(:,:),      intent(in)    :: cosz
type(cld_specification_type), intent(in)    :: Cld_spec
type(cldrad_properties_type), intent(inout) :: Cldrad_props

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      cosz         cosine of the zenith angle [ dimensionless ]
!      Cld_spec     cloud specification arrays defining the 
!                   location, amount and type (hi, middle, lo)
!                   of clouds that are present, provides input 
!                   to this subroutine
!                   [ cld_specification_type ]
!
!   intent(inout) variables:
!
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output 
!               from this routine:
!
!                    %cirabsw   absorptivity of clouds in the 
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cirrfsw   reflectivity of clouds in the 
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cvisrfsw  reflectivity of clouds in the 
!                               visible frequency band
!                               [ dimensionless ]
!
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!   local variables:

      integer     ::    i, j, k       ! do-loop indices

!---------------------------------------------------------------------
!    call obtain_bulk_sw_rh to obtain the cloud-radiative properties 
!    for rh_based_clouds.
!---------------------------------------------------------------------
      if (Cldrad_control%do_rh_clouds) then
        call obtain_bulk_sw_rh (is, ie, js, je, cosz, Cld_spec,   &
                                Cldrad_props)

!--------------------------------------------------------------------
!    values for zonal_clouds, prescribed_clouds and obs_clouds are
!    specified and constant in time. assign the proper values for cloud
!    absorptivity and reflectivity to each grid box with cloudiness, 
!    dependent on whether the cloud in that box is defined as being 
!    high, middle or low cloud. 
!----------------------------------------------------------------------
      else if(Cldrad_control%do_zonal_clouds .or. &
              Cldrad_control%do_mgroup_prescribed .or.  &
              Cldrad_control%do_obs_clouds) then
        do k=1, size(Cld_spec%hi_cloud,3)              
          do j=1,size(Cld_spec%hi_cloud,2)
            do i=1,size(Cld_spec%hi_cloud,1)
              if (Cld_spec%hi_cloud(i,j,k)) then
                Cldrad_props%cirabsw(i,j,k)  = cabir_hi 
                Cldrad_props%cirrfsw(i,j,k)  = crfir_hi
                Cldrad_props%cvisrfsw(i,j,k) = crfvis_hi
              else if (Cld_spec%mid_cloud(i,j,k)) then
                Cldrad_props%cirabsw(i,j,k)  = cabir_mid
                Cldrad_props%cirrfsw(i,j,k)  = crfir_mid
                Cldrad_props%cvisrfsw(i,j,k) = crfvis_mid
              else if (Cld_spec%low_cloud(i,j,k)) then
                Cldrad_props%cirabsw(i,j,k)  = cabir_low
                Cldrad_props%cirrfsw(i,j,k)  = crfir_low
                Cldrad_props%cvisrfsw(i,j,k) = crfvis_low
              endif
            end do
          end do
        end do

!---------------------------------------------------------------------
!    call obtain_bulk_sw_diag to define the cloud radiative properties
!    for the gordon diagnostic cloud scheme.
!---------------------------------------------------------------------
      else if (Cldrad_control%do_diag_clouds) then
        call obtain_bulk_sw_diag (is, ie, js, je, cosz, Cld_spec,  &
                                  Cldrad_props)

!---------------------------------------------------------------------
!    call obtain_bulk_sw_strat to define the cloud radiative properties
!    for the klein prognostic cloud scheme.
!---------------------------------------------------------------------
      else if (Cldrad_control%do_strat_clouds) then
        call obtain_bulk_sw_strat (is, ie, js, je, cosz, Cld_spec,   &
                                   Cldrad_props)

!-------------------------------------------------------------------
!    call obtain_bulk_sw_sa to define the cloud radiative properties
!    when specified clouds are used in standalone columns mode.
!-------------------------------------------------------------------
      else if (Cldrad_control%do_specified_clouds) then
        call obtain_bulk_sw_sa (is, ie, js, je, Cldrad_props)
      endif

!----------------------------------------------------------------------
 

end subroutine bulkphys_sw_driver



!####################################################################

! <SUBROUTINE NAME="bulkphys_lw_driver">
!  <OVERVIEW>
!    bulkphys_lw_driver defines bulk longwave cloud radiative
!    properties for the active cloud scheme.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    bulkphys_lw_driver defines bulk longwave cloud radiative
!    properties for the active cloud scheme.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call bulkphys_lw_driver (is, ie, js, je, Cld_spec, Cldrad_props)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!      Cld_spec          cloud specification arrays defining the
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input
!                        to this subroutine
!                        [ cld_specification_type ]
! 
!  </IN>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output
!               from this routine:
!
!                    %emrndlw   longwave cloud emissivity for
!                               randomly overlapped clouds
!                               in each of the longwave
!                               frequency bands  [ dimensionless ]
!                    %emmxolw   longwave cloud emissivity for
!                               maximally overlapped clouds
!                               in each of the longwave
!                               frequency bands  [ dimensionless ]
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine bulkphys_lw_driver (is, ie, js, je, Cld_spec, Cldrad_props)

!---------------------------------------------------------------------
!    bulkphys_lw_driver defines bulk longwave cloud radiative 
!    properties for the active cloud scheme.
!---------------------------------------------------------------------

integer,                      intent(in)    :: is, ie, js, je
type(cld_specification_type), intent(in)    :: Cld_spec
type(cldrad_properties_type), intent(inout) :: Cldrad_props

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      Cld_spec          cloud specification arrays defining the 
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input 
!                        to this subroutine
!                        [ cld_specification_type ]
!
!   intent(inout) variables:
!
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output 
!               from this routine:
!
!                    %emrndlw   longwave cloud emissivity for 
!                               randomly overlapped clouds
!                               in each of the longwave 
!                               frequency bands  [ dimensionless ]
!                    %emmxolw   longwave cloud emissivity for 
!                               maximally overlapped clouds
!                               in each of the longwave 
!                               frequency bands  [ dimensionless ]
!
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!   local variables:

      integer    :: i, j, k      ! do-loop indices

!------------------------------------------------------------------
!    call obtain_bulk_lw_rh to define long-wave cloud emissivity for
!    rh_based_clouds_mod.
!-------------------------------------------------------------------
      if (Cldrad_control%do_rh_clouds) then
        call obtain_bulk_lw_rh (is, ie, js, je, Cld_spec, Cldrad_props)

!---------------------------------------------------------------------
!    assign the proper values for cloud emissivity to each grid box
!    with cloudiness, dependent on whether the cloud in that box is 
!    defined as being high, middle or low cloud. high and middle clouds
!    are assumed to be random overlap, low clouds are assume to be
!    maximum overlap.
!----------------------------------------------------------------------
      else if (Cldrad_control%do_zonal_clouds .or.   &
               Cldrad_control%do_mgroup_prescribed .or.  &
               Cldrad_control%do_obs_clouds)  then
        do k=1, size(Cld_spec%hi_cloud,3)              
          do j=1,size(Cld_spec%hi_cloud,2)
            do i=1,size(Cld_spec%hi_cloud,1)
              if (Cld_spec%hi_cloud(i,j,k)) then
                Cldrad_props%emrndlw(i,j,k,:,1)  = cldem_hi
              else if (Cld_spec%mid_cloud(i,j,k)) then
                Cldrad_props%emrndlw(i,j,k,:,1)  = cldem_mid
              else if (Cld_spec%low_cloud(i,j,k)) then
                Cldrad_props%emmxolw(i,j,k,:,1)  = cldem_low
              endif
            end do
          end do
        end do

!------------------------------------------------------------------
!    call obtain_bulk_lw_diag to define long-wave cloud emissivity for
!    diag_based_clouds_mod.
!-------------------------------------------------------------------
      else if (Cldrad_control%do_diag_clouds) then
        call obtain_bulk_lw_diag (is, ie, js, je, Cld_spec,  &
                                  Cldrad_props)
 
!------------------------------------------------------------------
!    call obtain_bulk_lw_strat to define long-wave cloud emissivity for
!    strat_clouds_mod.
!-------------------------------------------------------------------
      else if (Cldrad_control%do_strat_clouds) then
        call obtain_bulk_lw_strat (is, ie, js, je, Cld_spec,   &
                                   Cldrad_props)

!--------------------------------------------------------------------
!    call obtain_bulk_lw_sa to define long-wave cloud emissivity for
!    specified clouds when running in standalone columns mode.
!-------------------------------------------------------------------
      else if (Cldrad_control%do_specified_clouds) then
        call obtain_bulk_lw_sa (is, ie, js, je, Cldrad_props)
      endif

!---------------------------------------------------------------------



end subroutine bulkphys_lw_driver



!###################################################################
 
! <SUBROUTINE NAME="bulkphys_rad_end">
!  <OVERVIEW>
!    bulkphys_rad_end is the destructor for bulkphys_rad_mod.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    bulkphys_rad_end is the destructor for bulkphys_rad_mod.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call bulkphys_rad_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine bulkphys_rad_end

!-------------------------------------------------------------------
!    bulkphys_rad_end is the destructor for bulkphys_rad_mod.
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!    mark the module as not initialized.
!--------------------------------------------------------------------
     module_is_initialized = .false.

!--------------------------------------------------------------------


end subroutine bulkphys_rad_end



                     end module bulkphys_rad_mod

 

module diffusivity_mod

!=======================================================================
!
!                          DIFFUSIVITY MODULE
!
!     Routines for computing atmospheric diffusivities in the 
!       planetary boundary layer and in the free atmosphere
!
!=======================================================================


use     constants_mod, only : grav, vonkarm, cp_air, rdgas, rvgas

use           mpp_mod, only : input_nml_file
use           fms_mod, only : error_mesg, FATAL, file_exist,   &
                              check_nml_error, open_namelist_file,      &
                              mpp_pe, mpp_root_pe, close_file, &
                              write_version_number, stdlog

use monin_obukhov_mod, only : mo_diff

implicit none
private

! public interfaces
!=======================================================================

 public diffusivity, pbl_depth, molecular_diff

!=======================================================================

! form of iterfaces

!=======================================================================
! subroutine diffusivity (t, q, u, v, p_full, p_half, z_full, z_half, 
!                         u_star, b_star, h, k_m, k_t)

! input:
  
!        t     : real, dimension(:,:,:) -- (:,:,pressure), third index running
!                          from top of atmosphere to bottom
!                 temperature (K)
!
!        q     : real, dimension(:,:,:)
!                 water vapor specific humidity (nondimensional)
!
!        u     : real, dimension(:,:)
!                 zonal wind (m/s)
!
!        v     : real, dimension(:,:,:) 
!                 meridional wind (m/s) 
!
!        z_full  : real, dimension(:,:,: 
!                 height of full levels (m)
!                 1 = top of atmosphere; size(p_half,3) = surface
!                 size(z_full,3) = size(t,3)
!
!        z_half  : real, dimension(:,:,:)
!                 height of  half levels (m)
!                 size(z_half,3) = size(t,3) +1
!              z_half(:,:,size(z_half,3)) must be height of surface!
!                                  (if you are not using eta-model)
!
!        u_star: real, dimension(:,:)
!                friction velocity (m/s)
!
!        b_star: real, dimension(:,:)
!                buoyancy scale (m/s**2)

!   (u_star and b_star can be obtained by calling 
!     mo_drag in monin_obukhov_mod)

! output:

!        h     : real, dimension(:,:,) 
!                 depth of planetary boundary layer (m)
!
!        k_m   : real, dimension(:,:,:)
!                diffusivity for momentum (m**2/s)
!
!                defined at half-levels
!                size(k_m,3) should be at least as large as size(t,3)
!                only the returned values at 
!                      levels 2 to size(t,3) are meaningful
!                other values will be returned as zero
!
!        k_t   : real, dimension(:,:,:)
!                diffusivity for temperature and scalars (m**2/s)
!
!
!=======================================================================


!--------------------- version number ----------------------------------

character(len=128) :: version = '$Id: diffusivity.F90,v 19.0 2012/01/06 20:05:43 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!=======================================================================

!  DEFAULT VALUES OF NAMELIST PARAMETERS:

logical :: fixed_depth         = .false.
real    :: depth_0             =  5000.0
real    :: frac_inner          =  0.1
real    :: rich_crit_pbl       =  1.0
real    :: entr_ratio          =  0.2
real    :: parcel_buoy         =  2.0
real    :: znom                =  1000.0
logical :: free_atm_diff       = .false.
logical :: free_atm_skyhi_diff = .false.
logical :: pbl_mcm             = .false.
real    :: rich_crit_diff      =  0.25
real    :: mix_len             = 30.
real    :: rich_prandtl        =  1.00
real    :: background_m        =  0.0
real    :: background_t        =  0.0
logical :: ampns               = .false. ! include delta z factor in 
                                         ! defining ri ?
real    :: ampns_max           = 1.0E20  ! limit to reduction factor
                                         ! applied to ri due to delta z
                                         ! factor
logical :: do_entrain          =.true.
logical :: do_simple           =.false.

namelist /diffusivity_nml/ fixed_depth, depth_0, frac_inner,& 
                           rich_crit_pbl, entr_ratio, parcel_buoy,&
                           znom, free_atm_diff, free_atm_skyhi_diff,&
                           pbl_mcm, rich_crit_diff, mix_len, rich_prandtl,&
                           background_m, background_t, ampns, ampns_max, &
                           do_entrain, do_simple
                          
!=======================================================================

!  OTHER MODULE VARIABLES

real    :: small  = 1.e-04
real    :: gcp    = grav/cp_air
logical :: module_is_initialized   = .false.
real    :: beta   = 1.458e-06
real    :: rbop1  = 110.4
real    :: rbop2  = 1.405

real, parameter :: d608 = (rvgas-rdgas)/rdgas


contains

!=======================================================================

subroutine diffusivity_init

integer :: unit, ierr, io, logunit

!------------------- read namelist input -------------------------------

      if (file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
         read (input_nml_file, nml=diffusivity_nml, iostat=io)
         ierr = check_nml_error(io,"diffusivity_nml")
#else
         unit = open_namelist_file ()
         ierr=1; do while (ierr /= 0)
            read  (unit, nml=diffusivity_nml, iostat=io, end=10)
            ierr = check_nml_error(io,'diffusivity_nml')
         enddo
  10     call close_file (unit)
#endif

!------------------- dummy checks --------------------------------------
         if (frac_inner .le. 0. .or. frac_inner .ge. 1.) &
            call error_mesg ('diffusivity_init',  &
            'frac_inner must be between 0 and 1', FATAL) 
         if (rich_crit_pbl .lt. 0.) &
            call error_mesg ('diffusivity_init',  &
           'rich_crit_pbl must be greater than or equal to zero', FATAL)
         if (entr_ratio .lt. 0.) &
            call error_mesg ('diffusivity_init',  &
            'entr_ratio must be greater than or equal to zero', FATAL)
         if (znom .le. 0.) &
            call error_mesg ('diffusivity_init',  &
            'znom must be greater than zero', FATAL)
         if (.not.free_atm_diff .and. free_atm_skyhi_diff)&
            call error_mesg ('diffusivity_init',  &
            'free_atm_diff must be set to true if '//&
            'free_atm_skyhi_diff = .true.', FATAL) 
         if (rich_crit_diff .le. 0.) &
            call error_mesg ('diffusivity_init',  &
            'rich_crit_diff must be greater than zero', FATAL)
         if (mix_len .lt. 0.) &
            call error_mesg ('diffusivity_init',  &
            'mix_len must be greater than or equal to zero', FATAL)
         if (rich_prandtl .lt. 0.) &
            call error_mesg ('diffusivity_init',  &
            'rich_prandtl must be greater than or equal to zero', FATAL)
         if (background_m .lt. 0.) &
            call error_mesg ('diffusivity_init',  &
            'background_m must be greater than or equal to zero', FATAL)
         if (background_t .lt. 0.) &
            call error_mesg ('diffusivity_init',  &
            'background_t must be greater than or equal to zero', FATAL)
         if (ampns_max .lt. 1.) &
            call error_mesg ('diffusivity_init',  &
            'ampns_max must be greater than or equal to one', FATAL)
         if (ampns .and. .not. free_atm_skyhi_diff) &
            call error_mesg ('diffusivity_init',  &
            'ampns is only valid when free_atm_skyhi_diff is &
                   & also true', FATAL)
      
      endif  !end of reading input.nml

!---------- output namelist to log-------------------------------------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
           logunit = stdlog()
           write (logunit, nml=diffusivity_nml)
      endif

      module_is_initialized = .true.

return
end subroutine diffusivity_init

!=======================================================================

subroutine diffusivity_end

      module_is_initialized = .false.

end subroutine diffusivity_end

!=======================================================================

subroutine diffusivity(t, q, u, v, p_full, p_half, z_full, z_half,  &
                       u_star, b_star, h, k_m, k_t, kbot)

real,    intent(in),           dimension(:,:,:) :: t, q, u, v
real,    intent(in),           dimension(:,:,:) :: p_full, p_half
real,    intent(in),           dimension(:,:,:) :: z_full, z_half
real,    intent(in),           dimension(:,:)   :: u_star, b_star
real,    intent(inout),        dimension(:,:,:) :: k_m, k_t
real,    intent(out),          dimension(:,:)   :: h
integer, intent(in), optional, dimension(:,:)   :: kbot

real, dimension(size(t,1),size(t,2),size(t,3))  :: svcp,z_full_ag, &
                                                   k_m_save, k_t_save
real, dimension(size(t,1),size(t,2),size(t,3)+1):: z_half_ag
real, dimension(size(t,1),size(t,2))            :: z_surf
integer                                         :: i,j,k,nlev,nlat,nlon

if(.not.module_is_initialized) call diffusivity_init

nlev = size(t,3)

k_m_save = k_m
k_t_save = k_t

!compute height of surface
if (present(kbot)) then
   nlat = size(t,2)
   nlon = size(t,1)
   do j=1,nlat
   do i=1,nlon
          z_surf(i,j) = z_half(i,j,kbot(i,j)+1)
   enddo
   enddo
else
   z_surf(:,:) = z_half(:,:,nlev+1)
end if


!compute density profile, and heights relative to surface
do k = 1, nlev
  z_full_ag(:,:,k) = z_full(:,:,k) - z_surf(:,:)
  z_half_ag(:,:,k) = z_half(:,:,k) - z_surf(:,:)
  
  if(do_simple) then
    svcp(:,:,k)  =   t(:,:,k) + gcp*(z_full_ag(:,:,k))
  else
    svcp(:,:,k)  =   t(:,:,k)*(1. + d608*q(:,:,k)) + gcp*(z_full_ag(:,:,k))
  endif
end do
z_half_ag(:,:,nlev+1) = z_half(:,:,nlev+1) - z_surf(:,:)


if(fixed_depth)  then
   h = depth_0
else 
   call pbl_depth(svcp,u,v,z_full_ag,u_star,b_star,h,kbot=kbot)
end if

if(pbl_mcm) then
   call diffusivity_pbl_mcm (u,v, t, p_full, p_half, &
                             z_full_ag, z_half_ag, h, k_m, k_t)
else
   call diffusivity_pbl  (svcp, u, v, z_half_ag, h, u_star, b_star,&
                       k_m, k_t, kbot=kbot)
end if

if(free_atm_diff) &
   call diffusivity_free (svcp, u, v, z_full_ag, z_half_ag, h, k_m, k_t)

k_m = k_m + k_m_save
k_t = k_t + k_t_save

!NOTE THAT THIS LINE MUST FOLLOW DIFFUSIVITY_FREE SO THAT ENTRAINMENT
!K's DO NOT GET OVERWRITTEN IN DIFFUSIVITY_FREE SUBROUTINE
if(entr_ratio .gt. 0. .and. .not. fixed_depth .and. do_entrain) &
    call diffusivity_entr(svcp,z_full_ag,h,u_star,b_star,k_m,k_t)

!set background diffusivities
if(background_m.gt.0.0) k_m = max(k_m,background_m)
if(background_t.gt.0.0) k_t = max(k_t,background_t)


return
end subroutine diffusivity

!=======================================================================

subroutine pbl_depth(t, u, v, z, u_star, b_star, h, kbot)


real,   intent(in) ,           dimension(:,:,:) :: t, u, v, z
real,   intent(in) ,           dimension(:,:)   :: u_star,b_star
real,   intent(out),           dimension(:,:)   :: h
integer,intent(in) , optional, dimension(:,:)   :: kbot

real,    dimension(size(t,1),size(t,2),size(t,3))  :: rich
real,    dimension(size(t,1),size(t,2))            :: ws,k_t_ref,&
                                                      h_inner,tbot
real                                               :: rich1, rich2,&
                                                      h1,h2,svp,t1,t2
integer, dimension(size(t,1),size(t,2))            :: ibot
integer                                            :: i,j,k,nlon,&
                                                      nlat, nlev

nlev = size(t,3)
nlat = size(t,2)
nlon = size(t,1)

!assign ibot, compute tbot (virtual temperature at lowest level)
if (present(kbot)) then
    ibot(:,:) = kbot
    do j = 1,nlat
    do i = 1,nlon
          tbot(i,j) = t(i,j,ibot(i,j))
    enddo
    enddo
else
    ibot(:,:) = nlev
    tbot(:,:) = t(:,:,nlev)
end if


!compute richardson number for use in pbl depth of neutral/stable side
do k = 1,nlev
  rich(:,:,k) =  z(:,:,k)*grav*(t(:,:,k)-tbot(:,:))/tbot(:,:)&
                /(u(:,:,k)*u(:,:,k) + v(:,:,k)*v(:,:,k) + small )
end do

!compute ws to be used in evaluating parcel buoyancy
!ws = u_star / phi(h_inner,u_star,b_star)  .  To find phi
!a call to mo_diff is made.

h_inner(:,:)=frac_inner*znom
call mo_diff(h_inner, u_star, b_star, ws, k_t_ref)
ws = max(small,ws/vonkarm/h_inner)


do j = 1, nlat
 do i = 1, nlon

        !do neutral or stable case 
        if (b_star(i,j).le.0. .or. do_simple) then    
              
              h1     = z(i,j,ibot(i,j))
              h(i,j) = h1
              rich1  = rich(i,j,ibot(i,j))
              do k = ibot(i,j)-1, 1, -1
                       rich2 = rich(i,j,k)
                       h2    = z(i,j,k)
                       if(rich2.gt.rich_crit_pbl) then
                             h(i,j) = h2 + (h1 - h2)*(rich2 - rich_crit_pbl)&
                                                    /(rich2 - rich1        )
                             go to 10
                       endif
                       rich1 = rich2
                       h1    = h2
              enddo 

        !do unstable case
        else

              svp    = tbot(i,j)*(1.+ &
                       (parcel_buoy*u_star(i,j)*b_star(i,j)/grav/ws(i,j)) )
              h1     = z(i,j,ibot(i,j))
              h(i,j) = h1
              t1     = tbot(i,j)
              do k = ibot(i,j)-1 , 1, -1
                       h2 = z(i,j,k)
                       t2 = t(i,j,k)
                       if (t2.gt.svp) then
                             h(i,j) = h2 + (h1 - h2)*(t2 - svp)/(t2 - t1 )
                             go to 10
                       end if
                       h1 = h2
                       t1 = t2
              enddo

        end if
10 continue
  enddo
enddo

return
end subroutine pbl_depth

!=======================================================================

subroutine diffusivity_pbl(t, u, v, z_half, h, u_star, b_star, &
                           k_m, k_t, kbot)

real,    intent(in)  ,           dimension(:,:,:) :: t, u, v, z_half
real,    intent(in)  ,           dimension(:,:)   :: h, u_star, b_star
real,    intent(inout) ,           dimension(:,:,:) :: k_m, k_t
integer, intent(in)  , optional, dimension(:,:)   :: kbot

real, dimension(size(t,1),size(t,2))              :: h_inner, k_m_ref,&
                                                     k_t_ref, factor
real, dimension(size(t,1),size(t,2),size(t,3)+1)  :: zm
real                                              :: h_inner_max
integer                                           :: k, kk, nlev


nlev = size(t,3)

!assign z_half to zm, and set to zero any values of zm < 0.
!the setting to zero is necessary so that when using eta model
!below ground half levels will have zero k_m and k_t
zm = z_half
if (present(kbot)) then
   where(zm < 0.)
        zm = 0.
   end where
end if

h_inner    = frac_inner*h
h_inner_max = maxval(h_inner)

kk = nlev
do k = 2, nlev
  if( minval(zm(:,:,k)) < h_inner_max) then
      kk = k
      exit
  end if
end do

k_m = 0.0
k_t = 0.0

call mo_diff(h_inner        , u_star, b_star, k_m_ref         , k_t_ref)
call mo_diff(zm(:,:,kk:nlev), u_star, b_star, k_m(:,:,kk:nlev), k_t(:,:,kk:nlev))

do k = 2, nlev
  where(zm(:,:,k) >= h_inner .and. zm(:,:,k) < h) 
    factor = (zm(:,:,k)/h_inner)* &
             (1.0 - (zm(:,:,k) - h_inner)/(h - h_inner))**2
    k_m(:,:,k) = k_m_ref*factor
    k_t(:,:,k) = k_t_ref*factor
  end where
end do

return
end subroutine diffusivity_pbl

!=======================================================================

subroutine diffusivity_pbl_mcm(u, v, t, p_full, p_half, z_full, z_half, &
                               h, k_m, k_t)

real, intent(in)  , dimension(:,:,:) :: u, v, t, z_full, z_half
real, intent(in)  , dimension(:,:,:) :: p_full, p_half
real, intent(in)  , dimension(:,:)   :: h
real, intent(inout) , dimension(:,:,:) :: k_m, k_t

integer                                        :: k, nlev
real, dimension(size(z_full,1),size(z_full,2)) :: delta_u, delta_v, delta_z

real :: htcrit_ss
real :: h_ss
real, dimension(size(z_full,1),size(z_full,2)) :: sig_half, z_half_ss, elmix_ss

!  htcrit_ss = height at which mixing length is a maximum (75m)
!  h_ss   = height at which mixing length vanishes (4900m)
!  elmix_ss   = mixing length 

! Define some constants:
!  salaps = standard atmospheric lapse rate (K/m)
!  tsfc   = idealized global mean surface temperature (15C)
real :: tsfc = 288.16
real :: salaps = -6.5e-3

nlev = size(z_full,3)

k_m = 0.

h_ss = depth_0
htcrit_ss = frac_inner*h_ss

do k = 2, nlev

! TK mods 8/13/01:  (code derived from SS)
! Compute the height of each half level assuming a constant
! standard lapse rate using the above procedure.
! WARNING: These should be used with caution.  They will
!  have large errors above the tropopause.

! In order to determine the height, the layer mean temperature
! from the surface to that level is required.  A surface 
! temperature of 15 deg Celsius and a standard lapse rate of 
! -6.5 deg/km will be used to estimate an average temperature 
! profile. 
 
   sig_half = p_half(:,:,k)/p_half(:,:,nlev+1)
   z_half_ss = -rdgas * .5*(tsfc+tsfc*(sig_half**(-rdgas*salaps/grav))) * alog(sig_half)/grav

   !compute mixing length as in SS (no geographical variation)
    elmix_ss = 0.
  
    where (z_half_ss < htcrit_ss .and. z_half_ss > 0.)
         elmix_ss = vonkarm*z_half_ss
    endwhere
    where (z_half_ss >= htcrit_ss .and. z_half_ss < h_ss)
         elmix_ss = vonkarm*htcrit_ss*(h_ss-z_half_ss)/(h_ss-htcrit_ss)
    endwhere

   delta_z = rdgas*0.5*(t(:,:,k)+t(:,:,k-1))*(p_full(:,:,k)-p_full(:,:,k-1))/&
             (grav*p_half(:,:,k))
   delta_u =      u(:,:,k-1) -      u(:,:,k)
   delta_v =      v(:,:,k-1) -      v(:,:,k)
   
   k_m(:,:,k) =   elmix_ss * elmix_ss *&
                  sqrt(delta_u*delta_u + delta_v*delta_v)/delta_z

end do

k_t = k_m

return
end subroutine diffusivity_pbl_mcm

!=======================================================================

subroutine diffusivity_free(t, u, v, z, zz, h, k_m, k_t)

real, intent(in)    , dimension(:,:,:) :: t, u, v, z, zz
real, intent(in)    , dimension(:,:)   :: h
real, intent(inout) , dimension(:,:,:) :: k_m, k_t

real, dimension(size(t,1),size(t,2))   :: dz, b, speed2, rich, fri, &
                                          alpz, fri2
integer                                :: k

do k = 2, size(t,3)

!----------------------------------------------------------------------
!  define the richardson number. set it to zero if it is negative. save
!  a copy of it for later use (rich2).
!----------------------------------------------------------------------
  dz     = z(:,:,k-1) - z(:,:,k)
  b      = grav*(t(:,:,k-1)-t(:,:,k))/t(:,:,k)
  speed2 = (u(:,:,k-1) - u(:,:,k))**2 + (v(:,:,k-1) - v(:,:,k))**2 
  rich= b*dz/(speed2+small)
  rich = max(rich, 0.0)

  if (free_atm_skyhi_diff) then
!---------------------------------------------------------------------
!   limit the standard richardson number to between 0 and the critical 
!   value (rich2). compute the richardson number factor needed in the 
!   eddy mixing coefficient using this standard richardson number.
!---------------------------------------------------------------------
    where (rich(:,:) >= rich_crit_diff) 
      fri2(:,:) = 0.0
    elsewhere
      fri2(:,:)  = (1.0 - rich/rich_crit_diff)**2
    endwhere
  endif

!---------------------------------------------------------------------
!  if ampns is activated, compute the delta z factor. define rich 
!  including this factor.
!---------------------------------------------------------------------
  if (ampns) then
    alpz(:,:) = MIN ( (1.  + 1.e-04*(dz(:,:)**1.5)), ampns_max)
    rich(:,:) = rich(:,:) / alpz(:,:)
  endif

!---------------------------------------------------------------------
!   compute the richardson number factor to be used in the eddy 
!   mixing coefficient. if ampns is on, this value includes it; other-
!   wise it does not.
!---------------------------------------------------------------------
  fri(:,:)   = (1.0 - rich/rich_crit_diff)**2

!---------------------------------------------------------------------
!   compute the eddy mixing coefficients in the free atmosphere ( zz 
!   > h). in the non-ampns case, values are obtained only when the 
!   standard richardson number is sub-critical; in the ampns case values
!   are obtained only when the richardson number computed with the 
!   ampns factor is sub critical. when the ampns factor is activated,
!   it is also included in the mixing coefficient. the value of mixing
!   for temperature, etc. is reduced dependent on the ri stability 
!   factor calculated without the ampns factor.
!---------------------------------------------------------------------
  if (free_atm_skyhi_diff) then

!---------------------------------------------------------------------
!   this is the skyhi-like formulation -- possible ampns factor, ratio
!   of k_m to k_t defined based on computed stability factor.
!---------------------------------------------------------------------
    if (ampns) then
      where (rich < rich_crit_diff .and. zz(:,:,k) > h) 
           k_m(:,:,k) = mix_len*mix_len*sqrt(speed2)*fri(:,:)* &
                        ( 1.  + 1.e-04*(dz(:,:)**1.5))/dz
           k_t(:,:,k) = k_m(:,:,k)* (0.1 + 0.9*fri2(:,:))
      end where
    else
      where (rich < rich_crit_diff .and. zz(:,:,k) > h)
        k_m(:,:,k) = mix_len*mix_len*sqrt(speed2)*fri(:,:)/dz
        k_t(:,:,k) = k_m(:,:,k)* (0.1 + 0.9*fri2(:,:))
      end where
    endif
  else

!---------------------------------------------------------------------
!   this is the non-skyhi-like formulation -- no ampns factor, ratio
!   of k_m to k_t defined by rich_prandtl.
!---------------------------------------------------------------------
    where (rich < rich_crit_diff .and. zz(:,:,k) > h) 
         k_t(:,:,k) = mix_len*mix_len*sqrt(speed2)*fri(:,:)/dz
         k_m(:,:,k) = k_t(:,:,k)*rich_prandtl
    end where
  end if
end do


end subroutine diffusivity_free

!=======================================================================

subroutine molecular_diff ( temp, press, k_m, k_t)

real, intent(in),    dimension (:,:,:)  ::  temp, press
real, intent(inout), dimension (:,:,:)  ::  k_m, k_t    

      real, dimension (size(temp,1), size(temp,2)) :: temp_half, &
                                                      rho_half, rbop2d
      integer      :: k

!---------------------------------------------------------------------

      do k=2,size(temp,3)
        temp_half(:,:) = 0.5*(temp(:,:,k) + temp(:,:,k-1))
        rho_half(:,:) = press(:,:,k)/(rdgas*temp_half(:,:) )
        rbop2d(:,:)  = beta*temp_half(:,:)*sqrt(temp_half(:,:))/  & 
                       (rho_half(:,:)*(temp_half(:,:)+rbop1))
        k_m(:,:,k) = rbop2d(:,:)
        k_t(:,:,k) = rbop2d(:,:)*rbop2
      end do

      k_m(:,:,1) = 0.0
      k_t(:,:,1) = 0.0



end subroutine molecular_diff 



!=======================================================================

subroutine diffusivity_entr(t, z,  h, u_star, b_star, k_m, k_t)

real, intent(in)    , dimension(:,:,:) :: t, z
real, intent(in)    , dimension(:,:)   :: h, u_star, b_star
real, intent(inout) , dimension(:,:,:) :: k_m, k_t

integer                                :: k, nlev

nlev=size(t,3)

do k = 2,nlev
    where (b_star .gt. 0. .and. z(:,:,k-1) .gt. h .and. &
                                z(:,:,k)   .le. h) 
        k_t(:,:,k) = (z(:,:,k-1)-z(:,:,k))*entr_ratio*t(:,:,k)* &
                      u_star*b_star/grav/max(small,t(:,:,k-1)-t(:,:,k))
        k_m(:,:,k) = k_t(:,:,k)
    end where
enddo
end subroutine diffusivity_entr

!=======================================================================

end module diffusivity_mod

! ============================================================================
! glac model module
! ============================================================================
module glacier_mod

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod,            only: error_mesg, file_exist,     &
                              check_nml_error, stdlog, write_version_number, &
                              close_file, mpp_pe, mpp_root_pe, FATAL, NOTE
use time_manager_mod,   only: time_type, increment_time, time_type_to_real
use diag_manager_mod,   only: diag_axis_init
use constants_mod,      only: tfreeze, hlv, hlf, dens_h2o, PI

use glac_tile_mod,      only: glac_tile_type, glac_pars_type, glac_prog_type, &
     read_glac_data_namelist, glac_data_thermodynamics, glac_data_hydraulics, &
     glac_data_radiation, glac_data_diffusion, max_lev, cpw, clw, csw

use land_constants_mod, only : &
     NBANDS
use land_tile_mod, only : land_tile_type, land_tile_enum_type, &
     first_elmt, tail_elmt, next_elmt, current_tile, operator(/=)
use land_tile_diag_mod, only : &
     register_tiled_diag_field, send_tile_data, diag_buff_type
use land_data_mod,      only : land_state_type, lnd
use land_io_mod, only : print_netcdf_error
use land_tile_io_mod, only: create_tile_out_file, read_tile_data_r1d_fptr, &
     write_tile_data_r1d_fptr, get_input_restart_name, sync_nc_files
use nf_utils_mod, only : nfu_def_dim, nfu_put_att
use land_debug_mod, only : is_watch_point
implicit none
private

! ==== public interfaces =====================================================
public :: read_glac_namelist
public :: glac_init
public :: glac_end
public :: save_glac_restart
public :: glac_get_sfc_temp
public :: glac_radiation
public :: glac_diffusion
public :: glac_step_1
public :: glac_step_2
! =====end of public interfaces ==============================================



! ==== module constants ======================================================
character(len=*), parameter :: &
       module_name = 'glacier',&
       version     = '$Id: glacier.F90,v 20.0 2013/12/13 23:29:35 fms Exp $',&
       tagname     = '$Name: tikal $'
 
! ==== module variables ======================================================

!---- namelist ---------------------------------------------------------------
logical :: lm2                   = .true.  ! *** CODE WORKS ONLY FOR .TRUE. !!! ****
logical :: conserve_glacier_mass = .true.
character(len=16):: albedo_to_use = ''  ! or 'brdf-params'
real    :: init_temp            = 260.       ! cold-start glac T
real    :: init_w               = 150.       ! cold-start w(l)/dz(l)
real    :: init_groundwater     =   0.       ! cold-start gw storage
namelist /glac_nml/ lm2, conserve_glacier_mass,  albedo_to_use, &
                    init_temp, init_w, init_groundwater, cpw, clw, csw
!---- end of namelist --------------------------------------------------------

logical         :: module_is_initialized =.FALSE.
logical         :: use_brdf
type(time_type) :: time
real            :: delta_time       ! fast time step

integer         :: num_l            ! # of water layers
real            :: dz    (max_lev)  ! thicknesses of layers
real            :: zfull (max_lev)
real            :: zhalf (max_lev+1)


! ---- diagnostic field IDs
integer :: id_zhalf, id_zfull
integer :: id_lwc, id_swc, id_temp, id_ie, id_sn, id_bf, id_hie, id_hsn, id_hbf

! ==== end of module variables ===============================================

! ==== NetCDF declarations ===================================================
include 'netcdf.inc'
#define __NF_ASRT__(x) call print_netcdf_error((x),module_name,__LINE__)

contains

! ============================================================================
subroutine read_glac_namelist()
  ! ---- local vars
  integer :: unit         ! unit for namelist i/o
  integer :: io           ! i/o status for the namelist
  integer :: ierr         ! error code, returned by i/o routines
  integer :: l            ! level iterator

  call read_glac_data_namelist(num_l, dz)

  call write_version_number(version, tagname)
#ifdef INTERNAL_FILE_NML
     read (input_nml_file, nml=glac_nml, iostat=io)
     ierr = check_nml_error(io, 'glac_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file()
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=glac_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'glac_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif
  if (mpp_pe() == mpp_root_pe()) then
     unit = stdlog()
     write (unit, nml=glac_nml)
  endif

  ! ---- set up vertical discretization
  zhalf(1) = 0
  do l = 1, num_l;   
     zhalf(l+1) = zhalf(l) + dz(l)
     zfull(l) = 0.5*(zhalf(l+1) + zhalf(l))
  enddo

end subroutine read_glac_namelist


! ============================================================================
! initialize glacier model
subroutine glac_init ( id_lon, id_lat )
  integer, intent(in)  :: id_lon  ! ID of land longitude (X) axis  
  integer, intent(in)  :: id_lat  ! ID of land latitude (Y) axis

  ! ---- local vars
  integer :: unit         ! unit for various i/o
  type(land_tile_enum_type)     :: te,ce ! last and current tile list elements
  type(land_tile_type), pointer :: tile  ! pointer to current tile
  character(len=256) :: restart_file_name
  logical :: restart_exists

  module_is_initialized = .TRUE.
  time       = lnd%time
  delta_time = time_type_to_real(lnd%dt_fast)

  ! -------- initialize glac state --------
  call get_input_restart_name('INPUT/glac.res.nc',restart_exists,restart_file_name)
  if (restart_exists) then
     call error_mesg('glac_init',&
          'reading NetCDF restart "'//trim(restart_file_name)//'"',&
          NOTE)
     __NF_ASRT__(nf_open(restart_file_name,NF_NOWRITE,unit))
     call read_tile_data_r1d_fptr(unit, 'temp'         , glac_temp_ptr  )
     call read_tile_data_r1d_fptr(unit, 'wl'           , glac_wl_ptr )
     call read_tile_data_r1d_fptr(unit, 'ws'           , glac_ws_ptr )
     call read_tile_data_r1d_fptr(unit, 'groundwater'  , glac_gw_ptr )
     call read_tile_data_r1d_fptr(unit, 'groundwater_T', glac_gwT_ptr)
     __NF_ASRT__(nf_close(unit))     
  else
     call error_mesg('glac_init',&
          'cold-starting glacier',&
          NOTE)
     te = tail_elmt (lnd%tile_map)
     ce = first_elmt(lnd%tile_map)
     do while(ce /= te)
        tile=>current_tile(ce) ! get pointer to current tile
        ce=next_elmt(ce)       ! advance position to the next tile
        
        if (.not.associated(tile%glac)) cycle

        if (init_temp.ge.tfreeze.or.lm2) then      ! USE glac TFREEZE HERE
           tile%glac%prog(1:num_l)%wl = init_w*dz(1:num_l)
           tile%glac%prog(1:num_l)%ws = 0
        else
           tile%glac%prog(1:num_l)%wl = 0
           tile%glac%prog(1:num_l)%ws = init_w*dz(1:num_l)
        endif
        tile%glac%prog%T             = init_temp
        tile%glac%prog%groundwater   = init_groundwater
        tile%glac%prog%groundwater_T = init_temp
     enddo
  endif
  
  if (trim(albedo_to_use)=='brdf-params') then
     use_brdf = .true.
  else if (trim(albedo_to_use)=='') then
     use_brdf = .false.
  else
     call error_mesg('glac_init',&
          'option albedo_to_use="'// trim(albedo_to_use)//&
          '" is invalid, use "brdf-params", or nothing ("")',&
          FATAL)
  endif

  if (.not.lm2) then
     call error_mesg('glac_init',&
          'currently only lm2=.TRUE. is supported',&
          FATAL)
  endif

  call glac_diag_init ( id_lon, id_lat, zfull(1:num_l), zhalf(1:num_l+1) )

end subroutine glac_init


! ============================================================================
subroutine glac_end ()

  module_is_initialized =.FALSE.

end subroutine glac_end


! ============================================================================
subroutine save_glac_restart (tile_dim_length, timestamp)
  integer, intent(in) :: tile_dim_length ! length of tile dim. in the output file
  character(*), intent(in) :: timestamp ! timestamp to add to the file name

  integer :: unit ! restart file i/o unit

  call error_mesg('glac_end','writing NetCDF restart',NOTE)
  call create_tile_out_file(unit,'RESTART/'//trim(timestamp)//'glac.res.nc', &
          lnd%coord_glon, lnd%coord_glat, glac_tile_exists, tile_dim_length)

  ! in addition, define vertical coordinate
  if (mpp_pe()==lnd%io_pelist(1)) then
     __NF_ASRT__(nfu_def_dim(unit,'zfull',zfull(1:num_l),'full level','m'))
     __NF_ASRT__(nfu_put_att(unit,'zfull','positive','down'))
  endif
  ! synchronize the output between writers and readers
  call sync_nc_files(unit)
        
  ! write out fields
  call write_tile_data_r1d_fptr(unit,'temp'         ,glac_temp_ptr,'zfull','glacier temperature','degrees_K')
  call write_tile_data_r1d_fptr(unit,'wl'           ,glac_wl_ptr  ,'zfull','liquid water content','kg/m2')
  call write_tile_data_r1d_fptr(unit,'ws'           ,glac_ws_ptr  ,'zfull','solid water content','kg/m2')
  call write_tile_data_r1d_fptr(unit,'groundwater'  ,glac_gw_ptr  ,'zfull')
  call write_tile_data_r1d_fptr(unit,'groundwater_T',glac_gwT_ptr ,'zfull')
   
  ! close file
  __NF_ASRT__(nf_close(unit))

end subroutine save_glac_restart


! ============================================================================
! returns glacier surface temperature
subroutine glac_get_sfc_temp ( glac, glac_T )
  type(glac_tile_type), intent(in)  :: glac
  real,                 intent(out) :: glac_T

  glac_T = glac%prog(1)%T
end subroutine glac_get_sfc_temp


! ============================================================================
subroutine glac_radiation ( glac, cosz, &
     glac_refl_dir, glac_refl_dif, glac_refl_lw, glac_emis )
  type(glac_tile_type), intent(in) :: glac
  real, intent(in)  :: cosz
  real, intent(out) :: &
       glac_refl_dir(NBANDS), glac_refl_dif(NBANDS), & ! glacier albedos for direct and diffuse light
       glac_refl_lw,   &  ! glacier reflectance for longwave (thermal) radiation
       glac_emis          ! glacier emissivity

  call glac_data_radiation ( glac, cosz, use_brdf, glac_refl_dir, glac_refl_dif, glac_emis )
  glac_refl_lw = 1 - glac_emis
end subroutine glac_radiation


! ============================================================================
! compute glac-only properties needed to do glac-canopy-atmos energy balance
subroutine glac_diffusion ( glac, glac_z0s, glac_z0m )
  type(glac_tile_type), intent(in) :: glac
  real, intent(out) :: glac_z0s, glac_z0m

  call glac_data_diffusion ( glac, glac_z0s, glac_z0m )
  
end subroutine glac_diffusion


! ============================================================================
! update glac properties explicitly for time step.
! integrate glac-heat conduction equation upward from bottom of glac
! to surface, delivering linearization of surface ground heat flux.
subroutine glac_step_1 ( glac, &
                         glac_T, glac_rh, glac_liq, glac_ice, glac_subl, &
                         glac_tf, glac_G0, &
                         glac_DGDT, conserve_glacier_mass_out )
  type(glac_tile_type),intent(inout) :: glac
  real, intent(out) :: &
       glac_T, &
       glac_rh, glac_liq, glac_ice, glac_subl, &
       glac_tf, & ! freezing temperature of glacier, degK
       glac_G0, &
       glac_DGDT
  logical, intent(out) :: conserve_glacier_mass_out

  ! ---- local vars 
  real                   :: bbb, denom, dt_e
  real, dimension(num_l) :: aaa, ccc, thermal_cond, heat_capacity, vlc, vsc
  integer :: l

! ----------------------------------------------------------------------------
! in preparation for implicit energy balance, determine various measures
! of water availability, so that vapor fluxes will not exceed mass limits
! ----------------------------------------------------------------------------

  conserve_glacier_mass_out = conserve_glacier_mass

  if(is_watch_point()) then
    write(*,*) 'checkpoint gs1 a'
    write(*,*) 'mask    ',  .TRUE.
    write(*,*) 'T       ', glac%prog(1)%T
  endif

  glac_T = glac%prog(1)%T

  if(is_watch_point()) then
     write(*,*) 'checkpoint gs1 b'
     write(*,*) 'mask    ', .TRUE.
     write(*,*) 'glac_T       ', glac_T
  endif

  do l = 1, num_l
     vlc(l) = max(0.0, glac%prog(l)%wl / (dens_h2o * dz(l)))
     vsc(l) = max(0.0, glac%prog(l)%ws / (dens_h2o * dz(l)))
  enddo

  call glac_data_thermodynamics ( glac%pars, vlc(1), vsc(1),  &  
       glac_rh, glac%heat_capacity_dry, thermal_cond )

  do l = 1, num_l
     heat_capacity(l) = glac%heat_capacity_dry(l)*dz(l) &
          + clw*glac%prog(l)%wl + csw*glac%prog(l)%ws
  enddo

  if (lm2) then
     glac_liq = 0
     glac_ice = 1.e6
  else
     glac_liq  = max(glac%prog(1)%wl, 0.0)
     glac_ice  = max(glac%prog(1)%ws, 0.0)
  endif
  if (glac_liq + glac_ice > 0 ) then
     glac_subl = glac_ice / (glac_liq + glac_ice)
  else
     glac_subl = 0
  endif
  
  if(num_l > 1) then
     do l = 1, num_l-1
        dt_e = 2 / ( dz(l+1)/thermal_cond(l+1) &
                + dz(l)/thermal_cond(l)   )
        aaa(l+1) = - dt_e * delta_time / heat_capacity(l+1)
        ccc(l)   = - dt_e * delta_time / heat_capacity(l)
     enddo

     bbb = 1.0 - aaa(num_l)
     denom = bbb
     dt_e = aaa(num_l)*(glac%prog(num_l)%T - glac%prog(num_l-1)%T) &
               + glac%geothermal_heat_flux * delta_time / heat_capacity(num_l)
     glac%e(num_l-1) = -aaa(num_l)/denom
     glac%f(num_l-1) = dt_e/denom
     do l = num_l-1, 2, -1
        bbb = 1.0 - aaa(l) - ccc(l)
        denom = bbb + ccc(l)*glac%e(l)
        dt_e = - ( ccc(l)*(glac%prog(l+1)%T - glac%prog(l)%T  ) &
             -aaa(l)*(glac%prog(l)%T   - glac%prog(l-1)%T) )
        glac%e(l-1) = -aaa(l)/denom
        glac%f(l-1) = (dt_e - ccc(l)*glac%f(l))/denom
     enddo
     denom = delta_time/(heat_capacity(1) )
     glac_G0    = ccc(1)*(glac%prog(2)%T- glac%prog(1)%T &
          + glac%f(1)) / denom
     glac_DGDT  = (1 - ccc(1)*(1-glac%e(1))) / denom   
  else  ! one-level case
     denom = delta_time/heat_capacity(1)
     glac_G0    = 0.
     glac_DGDT  = 1. / denom
  endif

  ! set freezing temperature of glaciers
  glac_tf = glac%pars%tfreeze

  if(is_watch_point())then
     write(*,*) 'checkpoint gs1 c'
     write(*,*) 'mask    ', .TRUE.
     write(*,*) 'T       ', glac_T
     write(*,*) 'rh      ', glac_rh
     write(*,*) 'liq     ', glac_liq
     write(*,*) 'ice     ', glac_ice
     write(*,*) 'subl    ', glac_subl
     write(*,*) 'G0      ', glac_G0
     write(*,*) 'DGDT    ', glac_DGDT
     do l = 1, num_l
        write(*,*) 'T(dbg,l)', glac%prog(l)%T
     enddo

  endif
end subroutine glac_step_1


! ============================================================================
! apply boundary flows to glac water and move glac water vertically.
  subroutine glac_step_2 ( glac, diag, glac_subl, snow_lprec, snow_hlprec,  &
                           subs_DT, subs_M_imp, subs_evap, &
                           glac_levap, glac_fevap, glac_melt, &
                           glac_lrunf, glac_hlrunf, glac_Ttop, glac_Ctop )
! *** WARNING!!! MOST OF THIS CODE IS SIMPLY COPIED FROM SOIL FOR POSSIBLE
! FUTURE DEVELOPMENT. (AND SIMILAR CODE IN SOIL MOD HAS BEEN FURTHER DEVELOPED,
! SO THIS IS MAINLY JUNK.) ONLY THE LM2 BRANCHES WORK. FOR LM2, THE SURFACE OF THE
! GLACIER IS EFFECTIVELY SEALED W.R.T. MASS TRANSER: 
! NO LIQUID CAN INFILTRATE, AND NO GLACIER MASS
! CAN ENTER THE ATMOSPHERE. ONLY SUPERFICIAL SNOW PARTICIPATES IN THE WATER
! CYCLE. HOWEVER, SENSIBLE HEAT TRANSFER AND GLACIER MELT CAN OCCUR,
! TO AN UNLIMITED EXTENT, AS NEEDED
! TO KEEP GLACIER AT OR BELOW FREEZING. MELT WATER STAYS IN GLACIER.

  type(glac_tile_type), intent(inout) :: glac
  type(diag_buff_type), intent(inout) :: diag
  real, intent(in) :: &
     glac_subl     !
  real, intent(in) :: &
     snow_lprec, &
     snow_hlprec, &
     subs_DT,       &!
     subs_M_imp,       &! rate of phase change of non-evaporated glac water
     subs_evap
  real, intent(out) :: &
     glac_levap, glac_fevap, glac_melt, &
     glac_lrunf, glac_hlrunf, glac_Ttop, glac_Ctop

  ! ---- local vars ----------------------------------------------------------
  real, dimension(num_l) :: del_t, eee, fff, &
             psi, DThDP, hyd_cond, DKDP, K, DKDPm, DKDPp, grad, &
             vlc, vsc, dW_l, u_minus, u_plus, DPsi, glac_w_fc
  real, dimension(num_l+1) :: flow
  real, dimension(num_l  ) :: div
  real :: &
     lprec_eff, hlprec_eff, tflow, hcap,cap_flow, &
     melt_per_deg, melt,&
     lrunf_sn,lrunf_ie,lrunf_bf, hlrunf_sn,hlrunf_ie,hlrunf_bf, &
     Qout, DQoutDP,&
     tau_gw, c0, c1, c2, x, aaa, bbb, ccc, ddd, xxx, Dpsi_min, Dpsi_max
  logical :: stiff
  real, dimension(num_l-1) :: del_z
  integer :: l
  real :: jj
  ! --------------------------------------------------------------------------

  jj = 1.
  DPsi = 0.0
  c1   = 0.0
  
  if(is_watch_point()) then
     write(*,*) ' ***** glac_step_2 checkpoint 1 ***** '
     write(*,*) 'mask    ', .TRUE.
     write(*,*) 'subs_evap    ', subs_evap
     write(*,*) 'snow_lprec   ', snow_lprec
     write(*,*) 'subs_M_imp   ', subs_M_imp
     write(*,*) 'theta_s ', glac%pars%w_sat
     do l = 1, num_l
        write(*,'(i2.2,99(a,g23.16))')l,&
             ' T =', glac%prog(l)%T,&
             ' Th=', (glac%prog(l)%ws+glac%prog(l)%wl)/(dens_h2o*dz(l)),&
             ' wl=', glac%prog(l)%wl,&
             ' ws=', glac%prog(l)%ws,&
             ' gw=', glac%prog(l)%groundwater
     enddo
     
  endif

  ! ---- record fluxes ---------
  IF (LM2) THEN ! EVAP SHOULD BE ZERO ANYWAY, BUT THIS IS JUST TO BE SURE...
  glac_levap  = 0.
  glac_fevap  = 0.
  ELSE
  glac_levap  = subs_evap*(1-glac_subl)
  glac_fevap  = subs_evap*   glac_subl
  ENDIF
  glac_melt   = subs_M_imp / delta_time

  ! ---- load surface temp change and perform back substitution --------------
  del_t(1) = subs_DT
  glac%prog(1)%T = glac%prog(1)%T + del_t(1)
  if ( num_l > 1) then
    do l = 1, num_l-1
      del_t(l+1) = glac%e(l) * del_t(l) + glac%f(l)
      glac%prog(l+1)%T = glac%prog(l+1)%T + del_t(l+1)
    end do
  end if

  if(is_watch_point()) then
     write(*,*) ' ***** glac_step_2 checkpoint 2 ***** '
     write(*,*) 'levap=',glac_levap
     write(*,*) 'fevap=',glac_fevap
     write(*,*) 'subs_M_imp=',subs_M_imp
     do l = 1, num_l
        write(*,'(i2.2,x,a,g23.16)') l, 'T', glac%prog(l)%T
     enddo
  endif

IF (LM2) THEN ! *********************************************************
    glac_lrunf  = snow_lprec
    glac_hlrunf = snow_hlprec
ELSE   ! ****************************************************************
  ! ---- extract evap from glac and do implicit melt --------------------
    glac%prog(1)%wl = glac%prog(1)%wl - glac_levap*delta_time
    glac%prog(1)%ws = glac%prog(1)%ws - glac_fevap*delta_time
    hcap = glac%heat_capacity_dry(1)*dz(1) &
                       + clw*glac%prog(1)%wl + csw*glac%prog(1)%ws
    glac%prog(1)%T = glac%prog(1)%T + (   &
                  +((clw-cpw)*glac_levap                              &
                  + (csw-cpw)*glac_fevap)*(glac%prog(1)%T  -tfreeze) &
                                               )*delta_time/ hcap
    glac%prog(1)%wl = glac%prog(1)%wl + subs_M_imp
    glac%prog(1)%ws = glac%prog(1)%ws - subs_M_imp
    glac%prog(1)%T  = tfreeze + (hcap*(glac%prog(1)%T-tfreeze) ) &
                              / ( hcap + (clw-csw)*subs_M_imp )
  ! ---- remainder of mass fluxes and associated sensible heat fluxes --------
  if(is_watch_point()) then
     write(*,*) ' ***** glac_step_2 checkpoint 3 ***** '
     do l = 1, num_l
        write(*,'(i2.2,99(a,g23.16))') l,&
             ' T =', glac%prog(l)%T,&
             ' wl=', glac%prog(l)%wl,&
             ' ws=', glac%prog(l)%ws
     enddo
  endif

  ! ---- fetch glac hydraulic properties -------------------------------------
  vlc=1;vsc=0
  do l = 1, num_l
     vlc(l) = max(0., glac%prog(l)%wl / (dens_h2o*dz(l)))
     vsc(l) = max(0., glac%prog(l)%ws / (dens_h2o*dz(l)))
  enddo
  call glac_data_hydraulics (glac, vlc, vsc, &
                   psi, DThDP, hyd_cond, DKDP, Dpsi_min, Dpsi_max, tau_gw, &
                   glac_w_fc )
     if(is_watch_point()) then
        write(*,*) ' ***** glac_step_2 checkpoint 3.1 ***** '
        do l = 1, num_l
           write(*,'(i2.2,99(x,a,g23.16))') l, 'vlc', vlc(l),&
                'K  ', hyd_cond(l)
        enddo
     
     endif
    div = 0.
    do l = 1, num_l
      div(l) = 0.15*dens_h2o*dz(l)/tau_gw
    enddo
    lrunf_bf = sum(div)

  ! ---- glac-water flow ----------------------------------------------------
    stiff = all(DThDP.eq.0)
    if (snow_lprec/=0 .and. psi(num_l)>0) then
      lrunf_sn = snow_lprec*min((psi(num_l)/zhalf(num_l))**glac%pars%rsa_exp,1.)
      hlrunf_sn = lrunf_sn*snow_hlprec/snow_lprec
    else
      lrunf_sn = 0.
      hlrunf_sn = 0.
    endif
    lprec_eff = snow_lprec - lrunf_sn
    hlprec_eff = snow_hlprec - hlrunf_sn
    flow(1) = delta_time*lprec_eff
    do l = 1, num_l-1
      del_z(l) = zfull(l+1)-zfull(l)
      K(l) = 0.5*(hyd_cond(l)+hyd_cond(l+1))
      DKDPm(l) = 0. !0.5*DKDP(l)
      DKDPp(l) = 0. ! 0.5*DKDP(l+1)
!        K(l) = hyd_cond(l)
!        DKDPm(l) = DKDP(l)
!        DKDPp(l) = 0
      grad(l)  = jj*(psi(l+1)-psi(l))/del_z(l) - 1
    enddo


    if(is_watch_point()) then
       write(*,*) ' ***** glac_step_2 checkpoint 3.1 ***** '
       do l = 1, num_l
          write(*,'(i2.2,x,a,99g23.16)') l, 'DThDP,hyd_cond,psi,DKDP', &
               DThDP(l), hyd_cond(l), psi(l), DKDP(l)
       enddo
       do l = 1, num_l-1
          write(*,'(i2.2,x,a,99g23.16)') l, 'K,DKDPm,DKDPp,grad,del_z', &
               K(l), DKDPm(l), DKDPp(l), grad(l)
      enddo
    endif

    l = num_l
    xxx = dens_h2o*dz(l)*DThDP(l)/delta_time
    aaa =     - ( jj* K(l-1)/del_z(l-1) - DKDPm(l-1)*grad(l-1))
        bbb = xxx - (- jj*K(l-1)/del_z(l-1) - DKDPp(l-1)*grad(l-1) )
        ddd = - K(l-1) *grad(l-1) - div(l)
    eee(l-1) = -aaa/bbb
    fff(l-1) =  ddd/bbb
    
    if(is_watch_point()) then
       write(*,'(a,i4,99g23.16)') 'l,a,b, ,d', l,aaa, bbb,ddd       
    endif


    do l = num_l-1, 2, -1
      xxx = dens_h2o*dz(l)*DThDP(l)/delta_time
      aaa = - ( jj*K(l-1)/del_z(l-1) - DKDPm(l-1)*grad(l-1))
      bbb = xxx-( -jj*K(l-1)/del_z(l-1) - DKDPp(l-1)*grad(l-1)&
                  -jj*K(l  )/del_z(l  ) + DKDPm(l  )*grad(l  ))
      ccc =   - (  jj*K(l  )/del_z(l  ) + DKDPp(l  )*grad(l  ))
      ddd =       K(l)*grad(l) - K(l-1)*grad(l-1) &
                            - div(l)
      eee(l-1) =                    -aaa/(bbb+ccc*eee(l))
      fff(l-1) =  (ddd-ccc*fff(l))/(bbb+ccc*eee(l))
      if(is_watch_point()) then
         write(*,'(a,i4,99g23.16)') 'l,a,b,c,d', l,aaa, bbb,ccc,ddd
      endif
    enddo

    l = 1
    xxx = dens_h2o*dz(l)*DThDP(l)/delta_time
    bbb = xxx - ( -jj*K(l  )/del_z(l  ) + DKDPm(l  )*grad(l  ))
    ccc =     - (  jj*K(l  )/del_z(l  ) + DKDPp(l  )*grad(l  ))
    ddd =          flow(1)/delta_time +    K(l)     *grad(l) &
                            - div(l)
    if (stiff) then
      dPsi(l) =  - psi(l)
    else
      dPsi(l) = (ddd-ccc*fff(l))/(bbb+ccc*eee(l))
      dPsi(l) = min (dPsi(l), Dpsi_max)
      dPsi(l) = max (dPsi(l), Dpsi_min)
    endif
    flow(l) = (dPsi(l)*(bbb+ccc*eee(l))+ccc*fff(l) &
                      - K(l)*grad(l))*delta_time
    lrunf_ie         = lprec_eff - flow(l)/delta_time

    if(is_watch_point()) then
       write(*,'(a,i4,99g23.16)') 'l,  b,c,d', l, bbb,ccc,ddd

       write(*,*) ' ***** glac_step_2 checkpoint 3.2 ***** '
       write(*,*) 'ie,sn,bf:', lrunf_ie,lrunf_sn,lrunf_bf
       do l = 1, num_l-1
          write(*,'(a,i4,99g23.16)') 'l,eee(l),fff(l)', l,eee(l), fff(l)
       enddo
       write(*,*) 'DThDP(1)', DThDP(1)
       write(*,*) 'ddd(1)', ddd
       write(*,*) 'ccc(1)', ccc
       write(*,*) 'bbb(1)', bbb
       write(*,*) 'dPsi(1)', dPsi(1)
       write(*,*) 'Psi(1)', Psi(1)
    endif

    do l = 2, num_l
      dPsi(l) = eee(l-1)*dPsi(l-1) + fff(l-1)
    enddo

    do l = 1, num_l-1
      flow(l+1) = delta_time*( &
           -K(l)*(grad(l)&
           +jj*(DPsi(l+1)-DPsi(l))/ del_z(l)) &
           -grad(l)*(DKDPp(l)*Dpsi(l+1)+ &
                           DKDPm(l)*Dpsi(l) )  )
      dW_l(l) = flow(l) - flow(l+1) - div(l)*delta_time
      glac%prog(l)%wl = glac%prog(l)%wl + dW_l(l)
    enddo
    flow(num_l+1) = 0.
    dW_l(num_l) = flow(num_l) - flow(num_l+1) &
                          - div(num_l)*delta_time
    glac%prog(num_l)%wl = glac%prog(num_l)%wl + dW_l(num_l)
  
  if(is_watch_point()) then
     write(*,*) ' ***** glac_step_2 checkpoint 3.3 ***** '
     write(*,*) 'psi_sat',glac%pars%psi_sat_ref
     write(*,*) 'Dpsi_max',Dpsi_max
     do l = 1, num_l
        write(*,'(i2.2,99(a,g23.16))')l,&
             ' Th=', (glac%prog(l)%ws+glac%prog(l)%wl)/(dens_h2o*dz(l)),&
             ' wl=', glac%prog(l)%wl,&
             ' ws=', glac%prog(l)%ws,&
             'Dpsi=', dPsi(l), &
             'flow=', flow(l)
     enddo
  endif

  if  (snow_hlprec.ne.0.) then
    tflow = tfreeze + snow_hlprec/(clw*snow_lprec)
  else
    tflow = tfreeze
  endif

  if(is_watch_point()) then
     write(*,*) ' ***** glac_step_2 checkpoint 3.4 ***** '
     write(*,*) ' tfreeze', tfreeze
     write(*,*) ' snow_hlprec', snow_hlprec
  endif

! For initial testing, use top-down-flow weights to advect heat.
  u_minus = 1.
  u_plus  = 0.
  if (flow(1).lt.0.) u_minus(1) = 0.
  hcap = (glac%heat_capacity_dry(num_l)*dz(num_l) &
                              + csw*glac%prog(num_l)%ws)/clw
  aaa = -flow(num_l) * u_minus(num_l)
  bbb =  hcap + glac%prog(num_l)%wl - dW_l(num_l) - aaa
  eee(num_l-1) = -aaa/bbb
  fff(num_l-1) = aaa*(glac%prog(num_l)%T-glac%prog(num_l-1)%T) / bbb

  do l = num_l-1, 2, -1
    hcap = (glac%heat_capacity_dry(l)*dz(l) &
                              + csw*glac%prog(l)%ws)/clw
    aaa = -flow(l)   * u_minus(l)
    ccc =  flow(l+1) * u_plus (l)
    bbb =  hcap + glac%prog(l)%wl - dW_l(l) - aaa - ccc
    eee(l-1) = -aaa / ( bbb +ccc*eee(l) )
    fff(l-1) = (   aaa*(glac%prog(l)%T-glac%prog(l-1)%T)    &
                       + ccc*(glac%prog(l)%T-glac%prog(l+1)%T)    &
                       - ccc*fff(l) ) / ( bbb +ccc*eee(l) )
  enddo
    
  hcap = (glac%heat_capacity_dry(1)*dz(1) + csw*glac%prog(1)%ws)/clw
  aaa = -flow(1) * u_minus(1)
  ccc =  flow(2) * u_plus (1)
  bbb =  hcap + glac%prog(1)%wl - dW_l(1) - aaa - ccc

  del_t(1) =  (  aaa*(glac%prog(1)%T-tflow          ) &
                     + ccc*(glac%prog(1)%T-glac%prog(2)%T) &
                     - ccc*fff(1) ) / (bbb+ccc*eee(1))
  glac%prog(1)%T = glac%prog(1)%T + del_t(1)

  if(is_watch_point()) then
     write(*,*) ' ***** glac_step_2 checkpoint 3.4.1 ***** '
     write(*,*) 'hcap', hcap
     write(*,*) 'aaa', aaa
     write(*,*) 'bbb', bbb
     write(*,*) 'ccc', ccc
     write(*,*) 'del_t(1)', del_t(1)
     write(*,*) ' T(1)', glac%prog(1)%T
  endif

  do l = 1, num_l-1
    del_t(l+1) = eee(l)*del_t(l) + fff(l)
    glac%prog(l+1)%T = glac%prog(l+1)%T + del_t(l+1)
  enddo

  tflow = glac%prog(num_l)%T

  if(is_watch_point()) then
     write(*,*) ' ***** glac_step_2 checkpoint 3.5 ***** '
     write(*,*) 'hcap', hcap
     write(*,*) 'cap_flow', cap_flow
     do l = 1, num_l
        write(*,'(i2.2,99(a,g23.16))')l, ' T', glac%prog(l)%T, ' flow ',flow(l)
     enddo
     write(*,*) 'delta_time,tau_gw,c0,c1,c2,x', delta_time,tau_gw,c0,&
          c1,c2,x
     write(*,*) 'level=', num_l+1, ' flow ',flow(num_l+1)
     write(*,*) 'gw(1)',glac%prog(1)%groundwater
  endif

  ! ---- groundwater ---------------------------------------------------------
  ! THIS T AVERAGING IS WRONG, BECAUSE IT NEGLECTS THE MEDIUM  ***
  ! ALSO, FREEZE-THAW IS NEEDED!
  ! PROBABLY THIS SECTION WILL BE DELETED ANYWAY, WITH GW TREATED ABOVE.
    if (lprec_eff.ne.0. .and. flow(1).ge.0. ) then
      hlrunf_ie = lrunf_ie*hlprec_eff/lprec_eff
    else if (flow(1).lt.0. ) then
      hlrunf_ie = hlprec_eff - (flow(1)/delta_time)*clw &
                         *(glac%prog(1)%T-tfreeze)
    else
      hlrunf_ie = 0.
    endif
    hlrunf_bf = clw*sum(div*(glac%prog%T-tfreeze))
    glac_lrunf  = lrunf_sn + lrunf_ie + lrunf_bf
    glac_hlrunf = hlrunf_sn + hlrunf_bf + hlrunf_ie 
  if(is_watch_point()) then
     write(*,*) ' ***** glac_step_2 checkpoint 3.7 ***** '
     write(*,*) 'hcap', hcap
     write(*,*) 'cap_flow', cap_flow
     do l = 1, num_l
        write(*,'(i2.2,99(a,g23.16))')l, ' T', glac%prog(l)%T
     enddo
  endif
    do l = 1, num_l
    ! ---- compute explicit melt/freeze --------------------------------------
      hcap = glac%heat_capacity_dry(l)*dz(l) &
               + clw*glac%prog(l)%wl + csw*glac%prog(l)%ws
      melt_per_deg = hcap/hlf
      if (glac%prog(l)%ws>0 .and. glac%prog(l)%T>glac%pars%tfreeze) then
        melt =  min(glac%prog(l)%ws, (glac%prog(l)%T-glac%pars%tfreeze)*melt_per_deg)
      else if (glac%prog(l)%wl>0 .and. glac%prog(l)%T<glac%pars%tfreeze) then
        melt = -min(glac%prog(l)%wl, (glac%pars%tfreeze-glac%prog(l)%T)*melt_per_deg)
      else
        melt = 0
      endif

      if(is_watch_point()) then
         write(*,'(a,i4,99g23.16)') 'l,T,wl(1),ws(1),melt:', l,glac%prog(l)%T, glac%prog(l)%wl, &
              glac%prog(l)%ws, melt
      endif

      glac%prog(l)%wl = glac%prog(l)%wl + melt
      glac%prog(l)%ws = glac%prog(l)%ws - melt
      glac%prog(l)%T = tfreeze &
         + (hcap*(glac%prog(l)%T-tfreeze) - hlf*melt) &
                              / ( hcap + (clw-csw)*melt )
      if(is_watch_point()) then
         write(*,'(a,i4,99g23.16)') 'l,T,wl(1),ws(1):', l,glac%prog(l)%T, glac%prog(l)%wl, &
              glac%prog(l)%ws
      endif

      glac_melt = glac_melt + melt / delta_time
    enddo
  if(is_watch_point()) then
     write(*,*) ' ***** glac_step_2 checkpoint 5 ***** '
     write(*,*) 'i,j,k,melt:',&
          glac_melt*delta_time
     do l = 1, num_l
        write(*,'(i2.2,99(a,g23.16))')l, &
             ' T =', glac%prog(l)%T, &
             ' Th=', (glac%prog(l)%ws+glac%prog(l)%wl)/(dens_h2o*dz(l)),&
             ' wl=', glac%prog(l)%wl,&
             ' ws=', glac%prog(l)%ws,&
             ' gw=', glac%prog(l)%groundwater
     enddo
  endif

ENDIF  !*****************************************************************************

  glac_Ttop = glac%prog(1)%T
  glac_Ctop = glac%heat_capacity_dry(1)*dz(1) &
    + clw*glac%prog(1)%wl + csw*glac%prog(1)%ws

! ----------------------------------------------------------------------------
! given solution for surface energy balance, write diagnostic output.
!  

  ! ---- increment time
  time = increment_time(time, int(delta_time), 0)
  
  ! ---- diagnostic section
  call send_tile_data (id_temp, glac%prog%T,     diag )
  call send_tile_data (id_lwc,  glac%prog(1:num_l)%wl/dz(1:num_l), diag )
  call send_tile_data (id_swc,  glac%prog(1:num_l)%ws/dz(1:num_l), diag )
  if (.not.lm2) then
  call send_tile_data (id_ie,   lrunf_ie,        diag )
  call send_tile_data (id_sn,   lrunf_sn,        diag )
  call send_tile_data (id_bf,   lrunf_bf,        diag )
  call send_tile_data (id_hie,  hlrunf_ie,       diag )
  call send_tile_data (id_hsn,  hlrunf_sn,       diag )
  call send_tile_data (id_hbf,  hlrunf_bf,       diag )
  endif

end subroutine glac_step_2

! ============================================================================
subroutine glac_diag_init ( id_lon, id_lat, zfull, zhalf )
  integer,         intent(in) :: id_lon  ! ID of land longitude (X) axis  
  integer,         intent(in) :: id_lat  ! ID of land longitude (X) axis
  real,            intent(in) :: zfull(:)! Full levels, m
  real,            intent(in) :: zhalf(:)! Half levels, m

  ! ---- local vars ----------------------------------------------------------
  integer :: axes(3)

  ! define vertical axis
  id_zhalf = diag_axis_init ( &
       'glac_zhalf', zhalf, 'meters', 'z', 'half level',  -1, set_name='glac' )
  id_zfull = diag_axis_init ( &
       'glac_zfull', zfull, 'meters', 'z', 'full level',  -1, set_name='glac', &
       edges=id_zhalf )

  ! define array of axis indices
  axes = (/ id_lon, id_lat, id_zfull /)

  ! define diagnostic fields
  id_lwc = register_tiled_diag_field ( module_name, 'glac_liq', axes,        &
       Time, 'bulk density of liquid water', 'kg/m3', missing_value=-100.0 )
  id_swc  = register_tiled_diag_field ( module_name, 'glac_ice',  axes,      &
       Time, 'bulk density of solid water', 'kg/m3',  missing_value=-100.0 )
  id_temp  = register_tiled_diag_field ( module_name, 'glac_T',  axes,       &
       Time, 'temperature',            'degK',  missing_value=-100.0 )
if (.not.lm2) then
  id_ie  = register_tiled_diag_field ( module_name, 'glac_rie',  axes(1:2),  &
       Time, 'inf exc runf',            'kg/(m2 s)',  missing_value=-100.0 )
  id_sn  = register_tiled_diag_field ( module_name, 'glac_rsn',  axes(1:2),  &
       Time, 'satn runf',            'kg/(m2 s)',  missing_value=-100.0 )
  id_bf  = register_tiled_diag_field ( module_name, 'glac_rbf',  axes(1:2),  &
       Time, 'baseflow',            'kg/(m2 s)',  missing_value=-100.0 )
  id_hie  = register_tiled_diag_field ( module_name, 'glac_hie',  axes(1:2), &
       Time, 'heat ie runf',            'W/m2',  missing_value=-100.0 )
  id_hsn  = register_tiled_diag_field ( module_name, 'glac_hsn',  axes(1:2), &
       Time, 'heat sn runf',            'W/m2',  missing_value=-100.0 )
  id_hbf  = register_tiled_diag_field ( module_name, 'glac_hbf',  axes(1:2), &
       Time, 'heat bf runf',            'W/m2',  missing_value=-100.0 )
endif

  
end subroutine glac_diag_init

! ============================================================================
! tile existence detector: returns a logical value indicating wether component
! model tile exists or not
logical function glac_tile_exists(tile)
   type(land_tile_type), pointer :: tile
   glac_tile_exists = associated(tile%glac)
end function glac_tile_exists


! ============================================================================
! accessor functions: given a pointer to a land tile, they return pointer
! to the desired member of the land tile, of NULL if this member does not
! exist.
subroutine glac_temp_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr(:)
   integer :: n
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%glac)) then
        n = size(tile%glac%prog)
        ptr(1:n) => tile%glac%prog(1:n)%T
      endif
   endif
end subroutine glac_temp_ptr

subroutine glac_wl_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr(:)
   integer :: n
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%glac)) then
        n = size(tile%glac%prog)
        ptr(1:n) => tile%glac%prog(1:n)%wl
      endif
   endif
end subroutine glac_wl_ptr

subroutine glac_ws_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr(:)
   integer :: n
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%glac)) then
        n = size(tile%glac%prog)
        ptr(1:n) => tile%glac%prog(1:n)%ws
      endif
   endif
end subroutine glac_ws_ptr

subroutine glac_gw_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr(:)
   integer :: n
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%glac)) then
        n = size(tile%glac%prog)
        ptr(1:n) => tile%glac%prog(1:n)%groundwater
      endif
   endif
end subroutine glac_gw_ptr

subroutine glac_gwT_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr(:)
   integer :: n
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%glac)) then
        n = size(tile%glac%prog)
        ptr(1:n) => tile%glac%prog(1:n)%groundwater_T
      endif
   endif
end subroutine glac_gwT_ptr

end module glacier_mod

        module aer_ccn_act_k_mod

implicit none
private
    private    CalcG,  erff, CalcAlphaGamma, CalcBeta
      
    public aer_ccn_act_k, aer_ccn_act2_k, aer_ccn_act_wpdf_k,  &
           aer_ccn_act_k_init, aer_ccn_act_k_end, &
           dlocate, ghquad, aer_ccn_act_wpdf_m_k

!--------------------- version number ---------------------------------

character(len=128) :: version = '$Id: aer_ccn_act_k.F90,v 19.0 2012/01/06 20:31:36 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!---------------- private data -------------------

  integer, parameter :: TY = 3  !  Number of aerosol types
  integer, parameter :: MD = 2  !  Number of lognormal modes

  real :: T = 283.15 !  Temperature (K)
  real :: P = 0.800e5 !  Pressure (Pa)
  real, parameter :: R = 8.314  !  Gas constant (J mol-1 K-1)
  real, parameter :: ZERO = 273.15 !  Zero degree C (K)
  real, parameter :: ATM = 1.01325e5 !  Standard atmosphere pressure (Pa)
  real, parameter :: PI = 3.1415926
  real, parameter :: eps = 1.e-5  ! epsilon used to prevent index
                                     ! calculation errors

  
!NO 1 Ammonium Sulfate  NO 2 Sea Salt NO 3 Organics
  
  real, dimension(TY) :: B_term = (/0.7822,0.6342,1.3764/) ! 2 * 0.3492/(Bprim)**(1/3)
  real, dimension(TY) :: Mass_scal = (/0.15896,0.198,0.1241/) ! scaling mass (ug m-3)

  real, dimension(MD) :: N = (/340., 60./) ! Total Number Concen (cm-3)
  real, dimension(MD) :: Dm = (/0.01, 0.07/) ! Geometric mean diameter (micron)
  real, dimension(MD) :: LNSIGMA = (/0.47, 0.6931/) ! ln( Sigma (St. Dev.) )

  logical :: nooc

!Parameters for look-up tables

  integer :: res, res2
  real    :: sul_concen, low_concen, high_concen
  real    :: lowup, highup, lowup2, highup2, lowmass2, &
             highmass2, lowmass3, highmass3,  &
             lowmass4, highmass4, lowmass5, highmass5, &
             lowT2, highT2

! real ::  lowup=0.3 !m/s
! real ::  highup=10.

! real ::  lowup2=0.0001 !m/s
! real ::  lowup2=0.05   !m/s
! real ::  highup2=0.3
! real ::  lowmass2=0.01 !ug m-3
! real ::  highmass2=1000.
! real ::  highmass2=100.
! real ::  lowmass3=0.01 !ug m-3
! real ::  highmass3=1000.
! real ::  highmass3=100.
! real :: lowT2=243.15 !K
! real :: highT2=308.15

real, dimension(:,:,:,:,:), allocatable  :: droplets, droplets2

!-----------------------------------------------------------------------
!-------------------- namelist -----------------------------------------

logical :: module_is_initialized  = .false.
 
contains

subroutine aer_ccn_act_k_init      &
             (droplets_in, droplets2_in, res_in, res2_in, nooc_in,  &
              sul_concen_in, low_concen_in, high_concen_in, &
              lowup_in, highup_in, lowup2_in, highup2_in, lowmass2_in, &
              highmass2_in, lowmass3_in, highmass3_in,  &
              lowmass4_in, highmass4_in, lowmass5_in, highmass5_in, &
              lowT2_in, highT2_in)     

real, dimension(:,:,:,:,:), intent(in) :: droplets_in
real, dimension(:,:,:,:,:), intent(in) :: droplets2_in
integer, intent(in) :: res_in, res2_in
logical, intent(in) :: nooc_in
real, intent(in)    :: sul_concen_in, low_concen_in, high_concen_in
real, intent(in)    :: lowup_in, highup_in, lowup2_in, highup2_in,  &
                       lowmass2_in, highmass2_in, lowmass3_in,  &
                       highmass3_in, lowmass4_in, highmass4_in,  &
                       lowmass5_in, highmass5_in, lowT2_in, highT2_in

    if (module_is_initialized) return

    res = res_in
    res2 = res2_in

    allocate (droplets (res, res,res,res,res))
    allocate (droplets2 (res2, res2,res2,res2,res2))

    droplets = droplets_in
    droplets2 = droplets2_in
    nooc = nooc_in
    sul_concen = sul_concen_in
    low_concen = low_concen_in
    high_concen = high_concen_in
    lowup = lowup_in
    highup = highup_in
    lowup2 = lowup2_in
    highup2 = highup2_in
    lowmass3 = lowmass3_in
    highmass3 = highmass3_in
    lowmass4 = lowmass4_in
    highmass4 = highmass4_in
    lowmass5 = lowmass5_in
    highmass5 = highmass5_in
    lowmass2 = lowmass2_in
    highmass2 = highmass2_in
    lowT2 = lowT2_in
    highT2 = highT2_in

    module_is_initialized = .true.


end subroutine aer_ccn_act_k_init



subroutine aer_ccn_act_k (T1, P1, Updraft1, TotalMass, tym,      &      
                          Drop, ier, ermesg)
integer, intent(in) :: tym
real, dimension(tym), intent(inout) :: TotalMass
real, intent(in) :: T1, P1, Updraft1
real, intent(inout) :: Drop
integer, intent(out) :: ier
character(len=*), intent(out) :: ermesg
    
real tmass, tmass2, tmass3, tmass4, updr
integer nomass, nomass2, nomass3, nomass4, noup
        
  ier = 0

  if ( .not. module_is_initialized) then
    ier = 1
    ermesg = 'aer_ccn_act_k: module has not been initialized before &
                                &first call'
    return
  endif
  if (tym /=  4) then
    ier = 2
    ermesg = 'aer_ccn_act_k:dimension of TotalMass is incorrect'
    return
  endif
  
  if (nooc) TotalMass(4) = 0.

  tmass=(TotalMass(1)+TotalMass(3)+TotalMass(4))*1.e12
    
  if (Updraft1>lowup2 .and. tmass>lowmass2) then

    tmass3=TotalMass(2)*1.e12
    if(TotalMass(1)*1.e12<sul_concen) then
      if (tmass3<low_concen) then
        tmass=TotalMass(1)*1.e12
        tmass2=0.
      else if (tmass3>high_concen) then
        tmass2=TotalMass(1)*1.e12
        tmass=0.
      else
        tmass=TotalMass(1)*1.e12* &
                      (high_concen-tmass3)/(high_concen-low_concen)
        tmass2=TotalMass(1)*1.e12* &
                      (tmass3-low_concen)/(high_concen-low_concen)
      end if
    else
      tmass2=TotalMass(1)*1.e12
      tmass=0.
    end if
   
    tmass3=TotalMass(3)*1.e12
    tmass4=TotalMass(4)*1.e12
    
    if (Updraft1>highup2) then
    
      updr=max(min(Updraft1,highup-eps),lowup)
    
      noup= log(updr/lowup)/log(highup/lowup)*(res2-1.)

      tmass=max(min(tmass,highmass2-eps),lowmass2)
      nomass= log(tmass/lowmass2)/log(highmass2/lowmass2)*(res2-1.)

      tmass2=max(min(tmass2,highmass3-eps),lowmass3)
      nomass2= log(tmass2/lowmass3)/log(highmass3/lowmass3)*(res2-1.)
    
      tmass3=max(min(tmass3,highmass4-eps),lowmass4)
      nomass3= log(tmass3/lowmass4)/log(highmass4/lowmass4)*(res2-1.)
 
      tmass4=max(min(tmass4,highmass5-eps),lowmass5)
      nomass4= log(tmass4/lowmass5)/log(highmass5/lowmass5)*(res2-1.)

      Drop = 0.166667*(droplets2(noup+1,nomass4+1,nomass3+1,nomass2+1,nomass+1)+&
                       droplets2(noup+1,nomass4+1,nomass3+1,nomass2+1,nomass+2)+ &
                       droplets2(noup+1,nomass4+1,nomass3+1,nomass2+2,nomass+1)+ &
                       droplets2(noup+1,nomass4+1,nomass3+2,nomass2+1,nomass+1)+ &
                       droplets2(noup+1,nomass4+2,nomass3+1,nomass2+1,nomass+1)+ &
                       droplets2(noup+2,nomass4+1,nomass3+1,nomass2+1,nomass+1))
  
    else

      updr=max(min(Updraft1,highup2-eps),lowup2)
    
      noup= log(updr/lowup2)/log(highup2/lowup2)*(res-1.)

      tmass=max(min(tmass,highmass2-eps),lowmass2)
      nomass= log(tmass/lowmass2)/log(highmass2/lowmass2)*(res-1.)

      tmass2=max(min(tmass2,highmass3-eps),lowmass3)
      nomass2= log(tmass2/lowmass3)/log(highmass3/lowmass3)*(res-1.)
    
      tmass3=max(min(tmass3,highmass4-eps),lowmass4)
      nomass3= log(tmass3/lowmass4)/log(highmass4/lowmass4)*(res-1.)

      tmass4=max(min(tmass4,highmass5-eps),lowmass5)
      nomass4= log(tmass4/lowmass5)/log(highmass5/lowmass5)*(res-1.)

      Drop = 0.166667*(droplets(noup+1,nomass4+1,nomass3+1,nomass2+1,nomass+1)+&
                       droplets(noup+1,nomass4+1,nomass3+1,nomass2+1,nomass+2)+ &
                       droplets(noup+1,nomass4+1,nomass3+1,nomass2+2,nomass+1)+ &
                       droplets(noup+1,nomass4+1,nomass3+2,nomass2+1,nomass+1)+ &
                       droplets(noup+1,nomass4+2,nomass3+1,nomass2+1,nomass+1)+ &
                       droplets(noup+2,nomass4+1,nomass3+1,nomass2+1,nomass+1))
  
    endif
  
  
  else
  
    Drop=0.
  
  endif
  
end subroutine aer_ccn_act_k

subroutine aer_ccn_act2_k (T1, P1, Updraft1, TotalMass, tym, mu, &
                           airdens,Nc,qc,qt,qe,tc,te,Drop, ier, ermesg)

!T1 temperature (K)
!P1 pressure (Pa)
!Updraft1 updraft velocity (m/s)
!TotalMass aerosol mass ()
!mu entrainment coef. (/s)
!airdens air density (kg/m3 air)
!Nc droplet mixing ratio (#/kg air)
!qc in-cloud vapor mixing ratio (kg water/kg air)
!qt in-cloud total water mixing ratio qc + ql (kg water/kg air)
!qe environment vapor mixing ratio (kg water/kg air)
!tc in-cloud temperature (K)
!te environment temperature (K)
!Drop droplet number concentration (#/cc)

integer, intent(in) :: tym
real, dimension(tym), intent(in) :: TotalMass
real, intent(in) :: T1, P1, Updraft1, mu,airdens, Nc, qc, qt, qe, tc, te
real, intent(inout) :: Drop
integer, intent(out) :: ier
character(len=*), intent(out) :: ermesg

real :: G, alpha, gamma, Smax
real :: Diam, beta, Le_cpa, Dcut
integer :: i, j
        
  ier = 0
  if ( .not. module_is_initialized) then
    ier = 1
    ermesg = 'aer_ccn_act2_k: module has not been initialized before &
                                &first call'
    return
  endif
  if (tym /= 4) then
    ier = 2
    ermesg = ' aer_ccn_act2_k:dimension of TotalMass is incorrect'
    return
  endif

  Drop=0.
  
  if (Nc > 0.) then    
    T = T1
    P = P1

    call CalcAlphaGamma(alpha, gamma)
    call CalcBeta(beta, Le_cpa)
              
! Diam  average diameter of droplets (micron)
    if (qt > qc) then
      Diam= ((qt-qc)/Nc*1.91e15)**(1./3.)    
    else
      Diam= 20.
    endif

!set the upper and lower limits of Diam
    if (Diam < 10.) Diam=10.
  
    call calcG(Diam, G)
    
    Smax=(alpha-gamma*mu*(qt-qe)*airdens+beta*mu*(Le_cpa*(qc-qe)+(tc-te)))*Updraft1/ &
         (gamma)/(0.5*3.1415*1.e3*G*Diam*1.e-6*Nc*airdens)
  
    if (Smax>0.) then
      do i=1,TY
        Dcut=B_term(i)/T/(Smax**(2./3.))
        do j=1, MD
          Drop=Drop+TotalMass(i)/Mass_scal(i)*N(j)*0.5* &
               (1.-erff(log(Dcut/Dm(j))/LNSIGMA(j)*0.707107))      
        end do
      end do
    endif
  endif

end subroutine aer_ccn_act2_k

!-->cjg: addition
!
! Additional subroutines to compute CCN activation by integrating
! over an assumed subgrid-scale PDF of w

subroutine aer_ccn_act_wpdf_k (T, p, wm, wp2, totalmass, tym, drop,  &
                               ier, ermesg)

! Compute CCN activation assuming a normal distribution of w
! given by its mean (wm) and second moment (wp2)

integer,          intent(in)    :: tym
real,             intent(in)    :: T, p, wm, wp2
real,             intent(inout) :: totalmass(tym)
real,             intent(out)   :: drop
integer,          intent(out)   :: ier
character(len=*), intent(out)   :: ermesg

!  Parameters

real, parameter    :: wp2_eps = 0.0001 ! w variance threshold
integer, parameter :: npoints = 64     ! # for Gauss-Hermite quadrature
real, parameter    :: wmin =  0.0      ! min w for ccn_act
real, parameter    :: wmax = 10.0      ! max w for ccn_act

!  Internal

real(kind=8), dimension(npoints) :: x, w
integer init

logical lintegrate
integer i, ia, ib
real wtmp
real(kind=8) :: tmp, a, b, sum1, sum2

save init, x, w

data init/0/


  ier = 0
  if ( .not. module_is_initialized) then
    ier = 1
    ermesg = 'aer_ccn_act_wpdf _k: module has not been initialized &
                                             &before first call'
    return
  endif
  if (tym /=  4) then
    ier = 2
    ermesg = 'aer_ccn_act_wpdf_k:dimension of TotalMass is incorrect'
    return
  endif

! On first call, initialize arrays with abscissas and weights for
! integration

if ( init .eq. 0 ) then
  call ghquad( npoints, x, w )
  init = 1
endif

! Determine whether integration is needed to compute number
! of activated drops. lintegrate = .true. indicates that
! numerical integration is to be performed.

lintegrate = .false.
if ( wp2 .gt. wp2_eps ) then

  ! Integration bounds: from wmin to wmax (0 to 10 m/s)

  tmp = 1.0d0 / sqrt(2.0 * wp2 ) 
  a = (wmin - wm ) * tmp
  b = (wmax - wm ) * tmp

  ! Locate indices within integration bounds

  call dlocate( x, npoints, a, ia )
  call dlocate( x, npoints, b, ib )

  ! ia (ib) is zero if a (b) is smaller than the lowest abscissa.
  ! In that case, start the integration with the first abscissa.
!  ia = max(ia,1)
!  ib = max(ib,1)
  ia = min(max(ia,1),size(x))
  ib = min(max(ib,1),size(x))

  if ( ib .gt. ia ) lintegrate = .true.

endif

! Compute number of activated drops.

if (lintegrate) then

  ! Perform integration

  sum1 = 0.0d0
  sum2 = 0.0d0
  tmp = sqrt(2.0 * wp2 )
  do i=ia,ib
    wtmp = tmp * x(i) + wm
    call aer_ccn_act_k( T, p, wtmp, totalmass, TYm, drop, ier, ermesg )
    if (ier /= 0) return
    sum1 = sum1 + w(i)*drop
    sum2 = sum2 + w(i)
  enddo

  ! Normalize

  drop = sum1 / sum2

else

  ! No integration, use single point evaluation

  call aer_ccn_act_k( T, p, wm, totalmass, TYm, drop, ier, ermesg )
  if (ier /= 0) return

endif


end subroutine aer_ccn_act_wpdf_k

!----------------------------------------------------------------------
subroutine aer_ccn_act_wpdf_m_k (T, p, wm, wp2, offs, totalmass, tym, drop,  &
!cms                               ier, ermesg)
                                       ier, ermesg)

! Compute CCN activation assuming a normal distribution of w
! given by its mean (wm) and second moment (wp2)

integer,          intent(in)    :: tym
real,             intent(in)    :: T, p, wm, wp2
integer,          intent(in)    :: offs
real,             intent(inout) :: totalmass(tym)
real,             intent(out)   :: drop
integer,          intent(out)   :: ier
character(len=*), intent(out)   :: ermesg

!  Parameters

real, parameter    :: wp2_eps = 0.0001 ! w variance threshold
integer, parameter :: npoints = 64     ! # for Gauss-Hermite quadrature
real, parameter    :: wmin =  0.0      ! min w for ccn_act
real, parameter    :: wmax = 10.0      ! max w for ccn_act

!  Internal

real(kind=8), dimension(npoints) :: x, w
integer init

logical lintegrate
integer i, ia, ib

real wtmp
real(kind=8) :: tmp, a, b, sum1, sum2

save init, x, w

data init/0/


  ier = 0
  if ( .not. module_is_initialized) then
    ier = 1
    ermesg = 'aer_ccn_act_wpdf _k: module has not been initialized &
                                             &before first call'
    return
  endif
  if (tym /=  4) then
    ier = 2
    ermesg = 'aer_ccn_act_wpdf_k:dimension of TotalMass is incorrect'
    return
  endif

! On first call, initialize arrays with abscissas and weights for
! integration

if ( init .eq. 0 ) then
  call ghquad( npoints, x, w )
  init = 1
endif

! Determine whether integration is needed to compute number
! of activated drops. lintegrate = .true. indicates that
! numerical integration is to be performed.

lintegrate = .false.
if ( wp2 .gt. wp2_eps ) then

  ! Integration bounds: from wmin to wmax (0 to 10 m/s)

  tmp = 1.0d0 / sqrt(2.0 * wp2 ) 
  a = (wmin - wm ) * tmp
  b = (wmax - wm ) * tmp

  ! Locate indices within integration bounds

  call dlocate( x, npoints, a, ia )
  call dlocate( x, npoints, b, ib )

  ! ia (ib) is zero if a (b) is smaller than the lowest abscissa.
  ! In that case, start the integration with the first abscissa.
!  ia = max(ia,1)
!  ib = max(ib,1)

!cms++ 
  ia = ia + offs
!cms--

  ia = min(max(ia,1),size(x))
  ib = min(max(ib,1),size(x))

  if ( ib .gt. ia ) lintegrate = .true.

endif

! Compute number of activated drops.

if (lintegrate) then

  ! Perform integration

  sum1 = 0.0d0
  sum2 = 0.0d0
  tmp = sqrt(2.0 * wp2 )
  do i=ia,ib
    wtmp = tmp * x(i) + wm
    call aer_ccn_act_k( T, p, wtmp, totalmass, TYm, drop, ier, ermesg )
    if (ier /= 0) return
    sum1 = sum1 + w(i)*drop
    sum2 = sum2 + w(i)
  enddo

  ! Normalize

  drop = sum1 / sum2

else

  ! No integration, use single point evaluation

  call aer_ccn_act_k( T, p, wm, totalmass, TYm, drop, ier, ermesg )
  if (ier /= 0) return

endif


end subroutine aer_ccn_act_wpdf_m_k


subroutine dlocate(xx,n,x,j)

! Subroutine to locate the position of element in an ordered array

integer,      intent(in)  :: n
real(kind=8), intent(in)  :: x, xx(n)
integer,      intent(out) :: j
integer jl,jm,ju

jl=0
ju=n+1
do while (ju-jl.gt.1)
  jm=(ju+jl)/2
  if((xx(n).gt.xx(1)).eqv.(x.gt.xx(jm)))then
    jl=jm
  else
    ju=jm
  endif
enddo
j=jl

return
end subroutine dlocate

subroutine ghquad( n, x, w )

! This subroutine returns double precision abscissas [x(1:n)] and
! weights [w(1:n)] of a n-point Gauss-Hermite quadrature formula,
! with n = {8, 12, 16, 24, 32, 48, 64, 96}.
! 
! The values of the absicssas and weights were computed offline 
! using subroutine 'gaussq' from netlib.org

integer, intent(in)       :: n
real(kind=8), intent(out) :: x(n), w(n)

select case (n)

  case(  8)
    x(1:n/2) =                                      &
    (/                                              &
      -0.2930637420257D+01, -0.1981656756696D+01,   &
      -0.1157193712447D+01, -0.3811869902073D+00    &
    /)
    x(n/2+1:n) = -x(n/2:1:-1)
    w(1:n/2) =                                      &
    (/                                              &
       0.1996040722114D-03,  0.1707798300741D-01,   &
       0.2078023258149D+00,  0.6611470125582D+00    &
    /)
    w(n/2+1:n) = w(n/2:1:-1)

  case( 12)
    x(1:n/2) =                                      &
    (/                                              &
      -0.3889724897870D+01, -0.3020637025121D+01,   &
      -0.2279507080501D+01, -0.1597682635153D+01,   &
      -0.9477883912402D+00, -0.3142403762544D+00    &
    /)
    x(n/2+1:n) = -x(n/2:1:-1)
    w(1:n/2) =                                      &
    (/                                              &
       0.2658551684356D-06,  0.8573687043588D-04,   &
       0.3905390584629D-02,  0.5160798561588D-01,   &
       0.2604923102642D+00,  0.5701352362625D+00    &
    /)
    w(n/2+1:n) = w(n/2:1:-1)

  case( 16)
    x(1:n/2) =                                      &
    (/                                              &
      -0.4688738939306D+01, -0.3869447904860D+01,   &
      -0.3176999161980D+01, -0.2546202157847D+01,   &
      -0.1951787990916D+01, -0.1380258539199D+01,   &
      -0.8229514491447D+00, -0.2734810461382D+00    &
    /)
    x(n/2+1:n) = -x(n/2:1:-1)
    w(1:n/2) =                                      &
    (/                                              &
       0.2654807474011D-09,  0.2320980844865D-06,   &
       0.2711860092538D-04,  0.9322840086242D-03,   &
       0.1288031153551D-01,  0.8381004139899D-01,   &
       0.2806474585285D+00,  0.5079294790166D+00    &
    /)
    w(n/2+1:n) = w(n/2:1:-1)

  case( 24)
    x(1:n/2) =                                      &
    (/                                              &
      -0.6015925561426D+01, -0.5259382927668D+01,   &
      -0.4625662756424D+01, -0.4053664402448D+01,   &
      -0.3520006813035D+01, -0.3012546137566D+01,   &
      -0.2523881017011D+01, -0.2049003573662D+01,   &
      -0.1584250010962D+01, -0.1126760817611D+01,   &
      -0.6741711070372D+00, -0.2244145474725D+00    &
    /)
    x(n/2+1:n) = -x(n/2:1:-1)
    w(1:n/2) =                                      &
    (/                                              &
       0.1664368496489D-15,  0.6584620243078D-12,   &
       0.3046254269988D-09,  0.4018971174941D-07,   &
       0.2158245704902D-05,  0.5688691636404D-04,   &
       0.8236924826884D-03,  0.7048355810073D-02,   &
       0.3744547050323D-01,  0.1277396217846D+00,   &
       0.2861795353464D+00,  0.4269311638687D+00    &
    /)
    w(n/2+1:n) = w(n/2:1:-1)

  case( 32)
    x(1:n/2) =                                      &
    (/                                              &
      -0.7125813909831D+01, -0.6409498149270D+01,   &
      -0.5812225949516D+01, -0.5275550986516D+01,   &
      -0.4777164503503D+01, -0.4305547953351D+01,   &
      -0.3853755485471D+01, -0.3417167492819D+01,   &
      -0.2992490825002D+01, -0.2577249537732D+01,   &
      -0.2169499183606D+01, -0.1767654109463D+01,   &
      -0.1370376410953D+01, -0.9765004635897D+00,   &
      -0.5849787654359D+00, -0.1948407415694D+00    &
    /)
    x(n/2+1:n) = -x(n/2:1:-1)
    w(1:n/2) =                                      &
    (/                                              &
       0.7310676427384D-22,  0.9231736536518D-18,   &
       0.1197344017093D-14,  0.4215010211326D-12,   &
       0.5933291463397D-10,  0.4098832164771D-08,   &
       0.1574167792546D-06,  0.3650585129562D-05,   &
       0.5416584061820D-04,  0.5362683655280D-03,   &
       0.3654890326654D-02,  0.1755342883157D-01,   &
       0.6045813095591D-01,  0.1512697340766D+00,   &
       0.2774581423025D+00,  0.3752383525928D+00    &
    /)
    w(n/2+1:n) = w(n/2:1:-1)

  case( 48)
    x(1:n/2) =                                      &
    (/                                              &
      -0.8975315081932D+01, -0.8310752190705D+01,   &
      -0.7759295519766D+01, -0.7266046554164D+01,   &
      -0.6810064578074D+01, -0.6380564096186D+01,   &
      -0.5971072225014D+01, -0.5577316981224D+01,   &
      -0.5196287718792D+01, -0.4825757228133D+01,   &
      -0.4464014546934D+01, -0.4109704603561D+01,   &
      -0.3761726490228D+01, -0.3419165969364D+01,   &
      -0.3081248988645D+01, -0.2747308624822D+01,   &
      -0.2416760904873D+01, -0.2089086660944D+01,   &
      -0.1763817579895D+01, -0.1440525220138D+01,   &
      -0.1118812152402D+01, -0.7983046277786D+00,   &
      -0.4786463375945D+00, -0.1594929358489D+00    &
    /)
    x(n/2+1:n) = -x(n/2:1:-1)
    w(1:n/2) =                                      &
    (/                                              &
       0.7935551460774D-35,  0.5984612693314D-30,   &
       0.3685036080151D-26,  0.5564577468902D-23,   &
       0.3188387323505D-20,  0.8730159601187D-18,   &
       0.1315159622658D-15,  0.1197589865479D-13,   &
       0.7046932581546D-12,  0.2815296537838D-10,   &
       0.7930467495165D-09,  0.1622514135896D-07,   &
       0.2468658993670D-06,  0.2847258691735D-05,   &
       0.2528599027748D-04,  0.1751504318012D-03,   &
       0.9563923198194D-03,  0.4153004911978D-02,   &
       0.1444496157498D-01,  0.4047967698460D-01,   &
       0.9182229707929D-01,  0.1692044719456D+00,   &
       0.2539615426648D+00,  0.3110010303780D+00    &
    /)
    w(n/2+1:n) = w(n/2:1:-1)

  case( 64)
    x(1:n/2) =                                      &
    (/                                              &
      -0.1052612316796D+02, -0.9895287586830D+01,   &
      -0.9373159549647D+01, -0.8907249099965D+01,   &
      -0.8477529083380D+01, -0.8073687285010D+01,   &
      -0.7689540164040D+01, -0.7321013032781D+01,   &
      -0.6965241120551D+01, -0.6620112262636D+01,   &
      -0.6284011228775D+01, -0.5955666326799D+01,   &
      -0.5634052164350D+01, -0.5318325224633D+01,   &
      -0.5007779602199D+01, -0.4701815647408D+01,   &
      -0.4399917168228D+01, -0.4101634474567D+01,   &
      -0.3806571513945D+01, -0.3514375935741D+01,   &
      -0.3224731291992D+01, -0.2937350823005D+01,   &
      -0.2651972435431D+01, -0.2368354588632D+01,   &
      -0.2086272879882D+01, -0.1805517171466D+01,   &
      -0.1525889140210D+01, -0.1247200156943D+01,   &
      -0.9692694230712D+00, -0.6919223058100D+00,   &
      -0.4149888241211D+00, -0.1383022449870D+00    &
    /)
    x(n/2+1:n) = -x(n/2:1:-1)
    w(1:n/2) =                                      &
    (/                                              &
       0.5535706535857D-48,  0.1679747990108D-42,   &
       0.3421138011256D-38,  0.1557390624630D-34,   &
       0.2549660899113D-31,  0.1929103595465D-28,   &
       0.7861797788926D-26,  0.1911706883301D-23,   &
       0.2982862784280D-21,  0.3152254566504D-19,   &
       0.2351884710676D-17,  0.1280093391322D-15,   &
       0.5218623726591D-14,  0.1628340730710D-12,   &
       0.3959177766948D-11,  0.7615217250145D-10,   &
       0.1173616742322D-08,  0.1465125316476D-07,   &
       0.1495532936727D-06,  0.1258340251031D-05,   &
       0.8788499230850D-05,  0.5125929135786D-04,   &
       0.2509836985131D-03,  0.1036329099508D-02,   &
       0.3622586978534D-02,  0.1075604050988D-01,   &
       0.2720312895369D-01,  0.5873998196410D-01,   &
       0.1084983493062D+00,  0.1716858423491D+00,   &
       0.2329947860627D+00,  0.2713774249413D+00    &
    /)
    w(n/2+1:n) = w(n/2:1:-1)

  case( 96)
    x(1:n/2) =                                      &
    (/                                              &
      -0.1311613002166D+02, -0.1252923074668D+02,   &
      -0.1204480674113D+02, -0.1161362082884D+02,   &
      -0.1121687519420D+02, -0.1084488807385D+02,   &
      -0.1049185453928D+02, -0.1015395127471D+02,   &
      -0.9828492746192D+01, -0.9513501769412D+01,   &
      -0.9207469353372D+01, -0.8909210581460D+01,   &
      -0.8617773244215D+01, -0.8332377307170D+01,   &
      -0.8052373330720D+01, -0.7777213031061D+01,   &
      -0.7506427894428D+01, -0.7239613294008D+01,   &
      -0.6976416464285D+01, -0.6716527240497D+01,   &
      -0.6459670819555D+01, -0.6205602024718D+01,   &
      -0.5954100706412D+01, -0.5704968013526D+01,   &
      -0.5458023340071D+01, -0.5213101801819D+01,   &
      -0.4970052133167D+01, -0.4728734920353D+01,   &
      -0.4489021106217D+01, -0.4250790715903D+01,   &
      -0.4013931763628D+01, -0.3778339308797D+01,   &
      -0.3543914636027D+01, -0.3310564538524D+01,   &
      -0.3078200688047D+01, -0.2846739077725D+01,   &
      -0.2616099526362D+01, -0.2386205234770D+01,   &
      -0.2156982386193D+01, -0.1928359784146D+01,   &
      -0.1700268521938D+01, -0.1472641679023D+01,   &
      -0.1245414039907D+01, -0.1018521831948D+01,   &
      -0.7919024787540D+00, -0.5654943662667D+00,   &
      -0.3392366188789D+00, -0.1130688831515D+00    &
    /)
    x(n/2+1:n) = -x(n/2:1:-1)
    w(1:n/2) =                                      &
    (/                                              &
       0.1315337147701D-74,  0.3480841387719D-68,   &
       0.4468702421681D-63,  0.1093382473752D-58,   &
       0.8733732835919D-55,  0.3022293931502D-51,   &
       0.5383222506970D-48,  0.5537064819783D-45,   &
       0.3568938561781D-42,  0.1531798964711D-39,   &
       0.4587401665859D-37,  0.9946800059220D-35,   &
       0.1608873207938D-32,  0.1989546894270D-30,   &
       0.1919970706795D-28,  0.1471241554974D-26,   &
       0.9085965647049D-25,  0.4580601098550D-23,   &
       0.1906260188688D-21,  0.6612951176481D-20,   &
       0.1928879326837D-18,  0.4766831171186D-17,   &
       0.1004905149157D-15,  0.1818169130493D-14,   &
       0.2838767395169D-13,  0.3843681724877D-12,   &
       0.4533303374584D-11,  0.4676010385985D-10,   &
       0.4233593783511D-09,  0.3375584731128D-08,   &
       0.2377366214757D-07,  0.1482969405005D-06,   &
       0.8213544547833D-06,  0.4048233178777D-05,   &
       0.1779180591822D-04,  0.6985432444541D-04,   &
       0.2454180927305D-03,  0.7726958216817D-03,   &
       0.2183131976097D-02,  0.5541631289439D-02,   &
       0.1265137511280D-01,  0.2600034027124D-01,   &
       0.4813990673109D-01,  0.8035395008064D-01,   &
       0.1209831168625D+00,  0.1643796305985D+00,   &
       0.2016130134792D+00,  0.2232700234975D+00    &
    /)
    w(n/2+1:n) = w(n/2:1:-1)

  case default
     stop 'ghquad: invalid value of n'

end select

return
end subroutine ghquad

!
!<--cjg: end of addition


subroutine CalcG(Dp, G)

real, intent(inout) :: Dp
real, intent(inout) :: G
real :: rhow = 1.0e3  ! density of water (Kg m-3)
real :: Mw = 0.018  ! molecular weight of water (Kg mol-1)
real :: alpc = 1.0  ! mass accomodation coef. 
real :: alpt = 0.97  ! thermal accomodation coef.
!real :: alpc = 0.042  ! mass accomodation coef. 
!real :: alpt = 1.  ! thermal accomodation coef.
!real :: alpc = 0.2  ! mass accomodation coef. 
!real :: alpt = 1.  ! thermal accomodation coef.
real :: delt = 2.16e-1 !thermal jump (micron)
real :: delv = 1.096e-1 !vapor jump (micron)
real vpres, Dv, ka, Le, mass, heat, TC
      
      
      Dv = 0.211/(P/ATM)*(T/ZERO)**1.94*1e-4  ! diffusivity of water vapor (m2 s-1)
      Dv = Dv/(Dp/(Dp+delv*2.)+2*Dv/(alpc*(Dp*1e-6))*(2.*PI*Mw/R/T)**0.5)
      ka = 1e-3*(4.39+0.071*T)  ! thermal conductivity (J m-1 s-1 K-1)
      ka = ka/(Dp/(Dp+delt*2.)+2*ka/(alpt*(Dp*1e-6)*1.007e3*P)*(2.*PI*R*T/0.028965)**0.5)
      TC = T-ZERO
      vpres = (6.107799961+TC*(4.436518521e-1+TC*(1.428945805e-2+TC*(2.650648471e-4 &
              +TC*(3.031240396e-6+TC*(2.034080948e-8+6.136820929e-11*TC))))))*1e2  ! saturated water vapor pressure(Pa)
      Le = 597.3*(ZERO/T)**(0.167+3.67e-4*T)*4.182*1e3  ! latent heat of water (J Kg -1) 
      
      mass = rhow*R*T/(vpres*Dv*Mw)
      heat = Le*rhow/(ka*T)*(Le*Mw/T/R-1)
!      print *, Dv, vpres, Mw, rhow, mass, heat
      G = 4./(mass+heat) ! (m2 s-1)
end subroutine CalcG

recursive function erff(x) RESULT(y)

! Error function from Numerical Recipes.
! erf(x) = 1 - erfc(x)

real dumerfc, x
real t, z, y


  z = abs(x)
  t = 1.0 / ( 1.0 + 0.5 * z )

  dumerfc =     t * exp(-z * z - 1.26551223 + t *      &
            ( 1.00002368 + t * ( 0.37409196 + t *    &
            ( 0.09678418 + t * (-0.18628806 + t *    &
            ( 0.27886807 + t * (-1.13520398 + t *    &
            ( 1.48851587 + t * (-0.82215223 + t * 0.17087277 )))))))))

  if ( x.lt.0.0 ) dumerfc = 2.0 - dumerfc
 
  y = 1.0 - dumerfc

end function erff


subroutine CalcAlphaGamma(alpha, gamma)

  real, intent(inout) :: alpha, gamma
  real rhoa ! density of air (Kg m-3)
  real :: Cpa = 1.007e3 ! specific heat of air (J Kg-1 K-1)
  real :: Mw = 0.018  ! molecular weight of water (Kg mol-1)
  real :: Ma = 0.028965  ! molecular weight of air (Kg mol-1)
  real :: g = 9.815 ! gravitational acceleration (m s-2) 
  real vpres, Dv, ka, Le, TC
  
  rhoa = P*Ma/R/T  ! (Kg m-3)
  Dv = 0.211/(P/ATM)*(T/ZERO)**1.94*1e-4  ! diffusivity of water vapor (m2 s-1)
!  Dv = Dv/(1+2*Dv/(alpc*Dp)*(2.*PI*Mw/R/T)**0.5)
  ka = 1e-3*(4.39+0.071*T)  ! thermal conductivity (J m-1 s-1 K-1)
  TC = T-ZERO
  vpres = (6.107799961+TC*(4.436518521e-1+TC*(1.428945805e-2+TC*(2.650648471e-4 &
          +TC*(3.031240396e-6+TC*(2.034080948e-8+6.136820929e-11*TC))))))*1e2  ! saturated water vapor pressure (Pa)
  Le = 597.3*(ZERO/T)**(0.167+3.67e-4*T)*4.182*1e3  ! latent heat of water (J Kg -1)
  alpha = g*Mw*Le/(Cpa*R*T**2.)-g*Ma/(R*T) ! (m-1)
  gamma = R*T/(vpres*Mw)+Mw*Le**2./(Cpa*P*Ma*T) ! (m3 Kg-1)
end subroutine CalcAlphaGamma

subroutine CalcBeta(beta, Le_cpa)

  real, intent(inout) :: beta, Le_cpa 
  real rhoa ! density of air (Kg m-3)
  real :: Cpa = 1.007e3 ! specific heat of air (J Kg-1 K-1)
  real :: Mw = 0.018  ! molecular weight of water (Kg mol-1)
  real :: Ma = 0.028965  ! molecular weight of air (Kg mol-1)
  real vpres, Dv, ka, Le, TC
  
  rhoa = P*Ma/R/T  ! (Kg m-3)
  Dv = 0.211/(P/ATM)*(T/ZERO)**1.94*1e-4  ! diffusivity of water vapor (m2 s-1)
!      Dv = Dv/(1+2*Dv/(alpc*Dp)*(2.*PI*Mw/R/T)**0.5)
  ka = 1e-3*(4.39+0.071*T)  ! thermal conductivity (J m-1 s-1 K-1)
  TC = T-ZERO
  vpres = (6.107799961+TC*(4.436518521e-1+TC*(1.428945805e-2+TC*(2.650648471e-4 &
          +TC*(3.031240396e-6+TC*(2.034080948e-8+6.136820929e-11*TC))))))*1e2  ! saturated water vapor pressure (Pa)
  Le = 597.3*(ZERO/T)**(0.167+3.67e-4*T)*4.182*1e3  ! latent heat of water (J Kg -1)
  Le_cpa = Le/Cpa
  beta = Mw*Le/(R*T**2.) ! (K-1)
end subroutine CalcBeta

subroutine aer_ccn_act_k_end()

  module_is_initialized = .false.

end subroutine aer_ccn_act_k_end

end module aer_ccn_act_k_mod

module strat_cloud_utilities_mod

use  fms_mod,        only : write_version_number

IMPLICIT NONE
PRIVATE

!-------------------------------------------------------------------------
!--interfaces-------------------------------------------------------------

public strat_cloud_utilities_init

PUBLIC diag_id_type, diag_pt_type, strat_nml_type,  &
       atmos_state_type, particles_type, cloud_state_type, &
       precip_state_type, cloud_processes_type, strat_constants_type

!----------------------------------------------------------------------
!----version number----------------------------------------------------

Character(len=128) :: Version = '$Id: strat_cloud_utilities.F90,v 20.0 2013/12/13 23:22:15 fms Exp $'
Character(len=128) :: Tagname = '$Name: tikal $'

logical  :: module_is_initialized = .false.


!########################################################################

TYPE diag_id_type

!  cloud area variables

  integer :: aall, aliq, aice, cf_liq_init, cf_ice_init, aauto
  integer :: SA3d, qadt_lsform, qadt_lsdiss, qadt_rhred, qadt_eros,  &
             qadt_fill, qadt_super, qadt_destr, qadt_limits, qadt_ahuco, &
             SA_imb
  integer :: SA2d, qa_lsform_col, qa_lsdiss_col, qa_rhred_col,  &
             qa_eros_col, qa_fill_col, qa_super_col, qa_destr_col,     &
             qa_limits_col, qa_ahuco_col, SA_imb_col

!  cloud liquid variables

  integer :: SL3d, qldt_cond, qldt_evap, qldt_eros, qldt_berg, qldt_freez,&
             liq_adj, qldt_rime, qldt_accr, qldt_auto, qldt_fill,  &
             qldt_destr, qldt_freez2, qldt_sedi, qldt_accrs, qldt_bergs, &
             qldt_HM_splinter, SL_imb
  integer :: SL2d, ql_cond_col, ql_evap_col, ql_eros_col, ql_berg_col,   &
             ql_freez_col, liq_adj_col, ql_rime_col, ql_accr_col,  &
             ql_auto_col, ql_fill_col, ql_destr_col, ql_freez2_col,  &
             ql_sedi_col, ql_accrs_col, ql_bergs_col, ql_HM_splinter_col, &
             SL_imb_col

!  cloud ice variables

  integer :: SI3d, qidt_dep, qidt_subl, qidt_fall, qidt_eros, qidt_melt, &
             qidt_melt2, qidt_fill, qidt_destr, qidt_qvdep, qidt_auto,  &
             qidt_accr, qidt_accrs, ice_adj,  SI_imb
  integer :: SI2d, qi_dep_col, qi_subl_col, qi_fall_col, qi_eros_col,  &    
             qi_melt_col, qi_melt2_col, qi_fill_col, qi_destr_col,  &
             qi_qvdep_col, qi_auto_col, qi_accr_col, qi_accrs_col,  &
             ice_adj_col, SI_imb_col  

!  cloud droplet variables

  integer :: droplets_col250, gb_droplets_col, potential_droplets, &
             droplets, droplets_wtd, ql_wt, droplets_col, rvolume
  integer :: SN3d, qndt_cond , qndt_evap, qndt_fill, qndt_berg, &
             qndt_destr, qndt_super, qndt_freez, qndt_sacws, qndt_sacws_o, &
             qndt_eros, qndt_pra, qndt_auto, qndt_nucclim, qndt_sedi, &
             qndt_melt, qndt_ihom, qndt_size_adj, qndt_fill2,   &
             qndt_contact_frz, qndt_cleanup, qndt_cleanup2, SN_imb
  integer :: SN2d, qn_cond_col, qn_evap_col, qn_fill_col, qn_berg_col,  &
             qn_destr_col, qn_super_col, qn_freez_col, qn_sacws_col,  &
             qn_sacws_o_col, qn_eros_col, qn_pra_col, qn_auto_col,    &
             qn_nucclim_col, qn_sedi_col, qn_melt_col, qn_ihom_col,  &
             qn_size_adj_col, qn_fill2_col, qn_contact_frz_col,  &
             qn_cleanup_col, qn_cleanup2_col, SN_imb_col

!  cloud ice particle variables

  integer :: nice, nice_col, gb_nice_col, potential_crystals
  integer :: SNi3d, qnidt_fill, qnidt_nnuccd, qnidt_nsubi,  &
             qnidt_nerosi, qnidt_nprci, qnidt_nprai,                 &
             qnidt_nucclim1, qnidt_nucclim2, qnidt_sedi,             &
             qnidt_melt, qnidt_size_adj, qnidt_fill2,                &
             qnidt_super, qnidt_ihom, qnidt_destr,                   &
             qnidt_cleanup, qnidt_cleanup2, qnidt_nsacwi, SNi_imb  
  integer :: SNi2d, qni_fill_col, qni_nnuccd_col, qni_nsubi_col, &
             qni_nerosi_col, qni_nprci_col, qni_nprai_col, &
             qni_nucclim1_col, qni_nucclim2_col, qni_sedi_col, &
             qni_melt_col, qni_size_adj_col, qni_fill2_col, &
             qni_super_col, qni_ihom_col, qni_destr_col, &
             qni_cleanup_col, qni_cleanup2_col,                    &
             qni_nsacwi_col, SNi_imb_col

!  aerosol diagnostics

  integer :: delta_cf, sulfate, seasalt_sub, seasalt_sup, om,   &
             rhcrit, rhcrit_min, rhiin, rhlin, cfin, imass7,     &
             ni_dust, ni_sulf, ni_bc, ndust1, ndust2, ndust3,  &
             ndust4, ndust5, dust_berg_flag, subgrid_w_variance
 
!  rain diagnostics

  integer :: rain3d, qrout, rain_clr, rain_cld, a_rain_clr, a_rain_cld, &
             rain_evap, rain_freeze, srfrain_accrs, srfrain_freez,  &
             srfrain_evap, rain_evap_col, rain_freeze_col,  &
             srfrain_accrs_col, srfrain_freez_col, srfrain_evap_col, &
             rain_mass_conv, rain_imb, rain_imb_col, cld_liq_imb,  &
             cld_liq_imb_col, neg_rain, qrout_col

!  snow diagnostics

  integer :: snow3d, qsout, snow_clr, snow_cld, a_snow_clr, a_snow_cld, &
             snow_melt, snow_melt_col, snow_mass_conv, sedi_ice, snow_imb, &
             snow_imb_col, cld_ice_imb, cld_ice_imb_col, neg_snow, qsout_col
             

!  total precip diagnostics

  integer :: a_precip_cld, a_precip_clr, sedi_sfc

!  temperature diagnostics

  integer ::  ST3d, ST_imb 
  integer ::  ST2d, ST_imb_col

!  vapor diagnostics

  integer :: SQ3d, qdt_liquid_init, qdt_ice_init, qdt_rain_evap,   &
             qdt_cond, qdt_deposition, qdt_eros_l, qdt_eros_i,        &
             qdt_qv_on_qi, qdt_sedi_ice2vapor, qdt_sedi_liquid2vapor,  &
             qdt_super_sat_rm, qdt_destr, qdt_cleanup_liquid,  &
             qdt_cleanup_ice, qdt_snow_sublim, qdt_snow2vapor, SQ_imb  
  integer :: SQ2d, q_liquid_init_col, q_ice_init_col, q_rain_evap_col, &
             q_cond_col, q_deposition_col, q_eros_l_col, q_eros_i_col, &
             q_qv_on_qi_col, q_sedi_ice2vapor_col, q_sedi_liquid2vapor_col,&
             q_super_sat_rm_col, q_destr_col, q_cleanup_liquid_col, &
             q_cleanup_ice_col, q_snow_sublim_col, q_snow2vapor_col,  &
             SQ_imb_col

!   miscellaneous diagnostics

  integer :: f_snow_berg, f_snow_berg_col, &
             lsf_strat, lcf_strat, mfls_strat, &
             dcond, vfall


END TYPE diag_id_type


!#########################################################################

TYPE diag_pt_type

!  cloud area variables

  integer :: aall, aliq, aice, cf_liq_init, cf_ice_init, aauto
  integer :: SA3d, qadt_lsform, qadt_lsdiss, qadt_rhred, qadt_eros,  &
             qadt_fill, qadt_super, qadt_destr, qadt_limits, qadt_ahuco, &
             SA_imb

!  cloud liquid variables

  integer :: SL3d, qldt_cond, qldt_evap, qldt_eros, qldt_berg, qldt_freez,&
             liq_adj, qldt_rime, qldt_accr, qldt_auto, qldt_fill,  &
             qldt_destr, qldt_freez2, qldt_sedi, qldt_accrs, qldt_bergs, &
             qldt_HM_splinter, SL_imb

!  cloud ice variables

  integer :: SI3d, qidt_dep, qidt_subl, qidt_fall, qidt_eros, qidt_melt, &
             qidt_melt2, qidt_fill, qidt_destr, qidt_qvdep, qidt_auto,  &
             qidt_accr, qidt_accrs, ice_adj,  SI_imb

!  cloud droplet variables

  integer :: droplets_col250, gb_droplets_col, potential_droplets, &
             droplets, droplets_wtd, ql_wt, droplets_col, rvolume
  integer :: SN3d, qndt_cond , qndt_evap, qndt_fill, qndt_berg, &
             qndt_destr, qndt_super, qndt_freez, qndt_sacws, qndt_sacws_o, &
             qndt_eros, qndt_pra, qndt_auto, qndt_nucclim, qndt_sedi, &
             qndt_melt, qndt_ihom, qndt_size_adj, qndt_fill2,   &
             qndt_contact_frz, qndt_cleanup, qndt_cleanup2, SN_imb

!  cloud ice particle variables

  integer :: nice, nice_col, gb_nice_col, potential_crystals
  integer :: SNi3d, qnidt_fill, qnidt_nnuccd, qnidt_nsubi,  &
             qnidt_nerosi, qnidt_nprci, qnidt_nprai,                 &
             qnidt_nucclim1, qnidt_nucclim2, qnidt_sedi,             &
             qnidt_melt, qnidt_size_adj, qnidt_fill2,                &
             qnidt_super, qnidt_ihom, qnidt_destr,                   &
             qnidt_cleanup, qnidt_cleanup2, qnidt_nsacwi, SNi_imb  

!  aerosol diagnostics

  integer :: delta_cf, sulfate, seasalt_sub, seasalt_sup, om,   &
             rhcrit, rhcrit_min, rhiin, rhlin, cfin, imass7,     &
             ni_dust, ni_sulf, ni_bc, ndust1, ndust2, ndust3,  &
             ndust4, ndust5, dust_berg_flag, subgrid_w_variance
 
!  rain diagnostics

  integer :: rain3d, qrout, rain_clr, rain_cld, a_rain_clr, a_rain_cld, &
             rain_evap, rain_freeze, srfrain_accrs, srfrain_freez,  &
             srfrain_evap, rain_mass_conv, rain_imb, cld_liq_imb, neg_rain

!  snow diagnostics

  integer :: snow3d, qsout, snow_clr, snow_cld, a_snow_clr, a_snow_cld, &
             snow_melt, snow_mass_conv, sedi_ice, snow_imb, cld_ice_imb, &
             neg_snow

!  total precip diagnostics

  integer :: a_precip_cld, a_precip_clr, sedi_sfc

!  temperature diagnostics

  integer ::  ST3d, ST_imb 

!  vapor diagnostics

  integer :: SQ3d, qdt_liquid_init, qdt_ice_init, qdt_rain_evap,   &
             qdt_cond, qdt_deposition, qdt_eros_l, qdt_eros_i,        &
             qdt_qv_on_qi, qdt_sedi_ice2vapor, qdt_sedi_liquid2vapor,  &
             qdt_super_sat_rm, qdt_destr, qdt_cleanup_liquid,  &
             qdt_cleanup_ice, qdt_snow_sublim, qdt_snow2vapor, SQ_imb  

!   miscellaneous diagnostics

  integer :: f_snow_berg, &
             lsf_strat, lcf_strat, mfls_strat, &
             dcond, vfall

END TYPE diag_pt_type


!#########################################################################

type strat_nml_type

!-------------------------------------------------------------------------
!    see strat_nml.h for a description of these variables.
!-------------------------------------------------------------------------

  real    :: U00, rthresh, var_limit, sea_salt_scale,         &
             om_to_oc,  N_land, N_ocean, U_evap, eros_scale,  &
             eros_scale_c, eros_scale_t, mc_thresh,           &
             diff_thresh, qmin, Dmin, efact, vfact, cfact,    &
             iwc_crit,  vfall_const2, vfall_exp2,             &
             qthalfwidth, N_min, num_mass_ratio1,             &
             num_mass_ratio2, qcvar

  logical :: do_netcdf_restart, u00_profile, use_kk_auto,     &
             use_online_aerosol, use_sub_seasalt,             &
             eros_choice, super_choice, tracer_advec,         &
             do_old_snowmelt, retain_cm3_bug, do_pdf_clouds, do_liq_num,      &
             do_dust_berg, pdf_org, do_ice_nucl_wpdf, debugo, &
             mass_cons, do_hallet_mossop, activate_all_ice_always

  integer :: num_strat_pts, betaP, nsublevels, kmap, kord,    &
             super_ice_opt, isamp, jsamp, ksamp

  character(len=64)                :: microphys_scheme, &
                                      macrophys_scheme, &
                                      aerosol_activation_scheme

  integer, dimension(:,:), pointer :: strat_pts=>NULL()

end type strat_nml_type


!#########################################################################

type atmos_state_type

!       airdens        air density                     kg air/(m*m*m)
!       qs             saturation specific humidity    kg vapor/kg air
!       dqsdT          T derivative of qs              kg vapor/kg air/K
!       gamma          (L/cp)*dqsdT                    dimensionless
!       deltpg         pressure thickness of grid box  kg air/(m*m)
!                      divided by gravity
!       U_ca           grid box relative humidity      fraction

  real, dimension(:,:,:), pointer ::  &
                                        pfull          =>NULL(), &
                                        phalf          =>NULL(), &
                                        zhalf          =>NULL(), &
                                        zfull          =>NULL(), &
                                        radturbten2    =>NULL(), &
                                        T_in           =>NULL(), &
                                        qv_in          =>NULL(), &
                                        omega          =>NULL(), &
                                        Mc             =>NULL(), &
                                        diff_t         =>NULL(), &
                                        qrat           =>NULL(), &
                                        airdens        =>NULL(), &
                                        tn             =>NULL(), & 
                                        qvn            =>NULL(), &
                                        qs             =>NULL(), &
                                        dqsdT          =>NULL(), &
                                        qsi            =>NULL(), &
                                        qsl            =>NULL(), &
                                        rh_crit        =>NULL(), &
                                        rh_crit_min    =>NULL(), &
                                        gamma          =>NULL(), &
                                        esat0          =>NULL(), &
                                        U_ca           =>NULL(), &
                                        ahuco          =>NULL(), &
                                        delp           =>NULL(), &
                                        U01            =>NULL(), &
                                        deltpg         =>NULL()

end type atmos_state_type


!##########################################################################

type  particles_type 

! drop1           number conc                     [1/cm^3]
! drop2           mass concentration              [1/kg]
  real, dimension(:,:,:), pointer ::  &
                                        concen_dust_sub=>NULL(), &
                                        drop1          =>NULL(), &
                                        drop2          =>NULL(), &
                                        crystal1       =>NULL(), &
                                        rbar_dust      =>NULL(), &
                                        ndust          =>NULL(), &
                                        hom            =>NULL()

end type particles_type 


!########################################################################

type cloud_state_type

!       ql_upd         updated value of ql             kg condensate/
!                                                      kg air
!       
!       qi_upd         updated value of qi             kg condensate/
!                                                      kg air
!
!       qa_upd         updated value of qa             fraction
!
!       qa_mean        qa + SA; semi-implicit          fraction
!                      saturated volume fraction
!       ql_mean        ql + positive increment         kg condensate/
!                      of ql; i.e. a sort of           kg air
!                      intermediate ql
!
!       qi_mean        ql + positive increment         kg condensate/
!                      of qi; i.e. a sort of           kg air
!                      intermediate qi
  real, dimension(:,:,:), pointer ::   &
                                        ql_upd         =>NULL(), &
                                        qi_upd         =>NULL(), &
                                        qa_upd         =>NULL(), &
                                        qn_upd         =>NULL(), &
                                        qni_upd        =>NULL(), &
                                        ql_mean        =>NULL(), &
                                        qi_mean        =>NULL(), &
                                        qa_mean        =>NULL(), &
                                        qn_mean        =>NULL(), &
                                        qni_mean       =>NULL(), &
                                        ql_in          =>NULL(), &
                                        qi_in          =>NULL(), &
                                        qa_in          =>NULL(), &
                                        qn_in          =>NULL(), &
                                        qni_in         =>NULL(), &
                                        SL_out         =>NULL(), &
                                        SI_out         =>NULL(), &
                                        SA_out         =>NULL(), &
                                        SN_out         =>NULL(), &
                                        SNi_out        =>NULL(), &
                                        SA_0           =>NULL(), &
                                        qa_upd_0       =>NULL()

end type cloud_state_type
 

!#########################################################################

type precip_state_type

  real, dimension(:,:,:), pointer ::   &
                                        lsc_snow       =>NULL(), &
                                        lsc_rain       =>NULL(), &
                                        lsc_snow_size  =>NULL(), &
                                        lsc_rain_size  =>NULL(), &
!rain and snow mixing ratios from the Morrison scheme (kg/kg) :
                                        qrout3d_mg     =>NULL(), &
                                        qsout3d_mg     =>NULL(), &
                                        rain3d         =>NULL(), &
                                        snow3d         =>NULL(), &
                                        snowclr3d      =>NULL()

  real, dimension(:,:), pointer   ::   &
                                        surfrain       =>NULL(), &
                                        surfsnow       =>NULL()
             
end type precip_state_type


!#########################################################################

type cloud_processes_type

!       da_ls          change in saturated volume      fraction
!                      fraction due to large-scale
!                      processes
!       D_eros         Sink in ql, qi and qa equation  dimensionless
!                      due to turbulent erosion of
!                      cloud sides
!       dcond_ls       change in condensate due to     kg condensate/
!                      non-convective condensation.    kg air
!                      After phase determination,
!                      this variable refers only to
!                      liquid condensation.
!
!       dcond_ls_ice   change in ice due to            kg condensate/
!                      non-convective condensation.    kg air
!       qvg            equilibrium value of water      kg vapor /
!                      vapor in the clear portion      kg air
!                      of the grid box that PDF 
!                      clouds wants                          
!

  real, dimension(:,:,:), pointer ::   &
                                        da_ls          =>NULL(), &
                                        D_eros         =>NULL(), &
                                        qvg            =>NULL(), &
                                        dcond_ls       =>NULL(), &
                                        dcond_ls_ice   =>NULL(), &
                                        dcond_ls_tot   =>NULL(), &
                                        delta_cf       =>NULL(), &
                                        f_snow_berg    =>NULL()

end type cloud_processes_type


!##########################################################################

type strat_constants_type

!       inv_dtcloud   inverse of model timestep [ sec (-1) ]
  real, dimension(:,:,:), pointer :: mask=>NULL()
  real                            :: dtcloud, inv_dtcloud
  integer                         :: overlap
  logical                         :: limit_conv_cloud_frac,      &
                                     mask_present,               &
                                     do_rk_microphys,            &
                                     do_mg_microphys,            &       
                                     do_mg_ncar_microphys,       &
                                     tiedtke_macrophysics,       &
                                     dqa_activation,             &
                                     total_activation,           &
                                     do_predicted_ice_number

end type strat_constants_type


!#########################################################################


CONTAINS

subroutine strat_cloud_utilities_init

      if (module_is_initialized) return

!------------------------------------------------------------------------
!    write version number to output file.
!------------------------------------------------------------------------
      call write_version_number(version, tagname)

!------------------------------------------------------------------------
!    mark this module as initialized.
!------------------------------------------------------------------------
      module_is_initialized = .true.

!------------------------------------------------------------------------

end subroutine strat_cloud_utilities_init



!########################################################################


end module strat_cloud_utilities_mod

module stock_constants_mod

  use mpp_mod, only : mpp_pe, mpp_root_pe, mpp_sum
  use time_manager_mod, only : time_type, get_time
  use time_manager_mod, only : operator(+), operator(-)
  use diag_manager_mod, only : register_diag_field,send_data

  implicit none

  character(len=128), parameter :: version = '$Id$'


  integer,public,    parameter                :: NELEMS=3
  integer,           parameter                :: NELEMS_report=3
  integer,public,    parameter                :: ISTOCK_WATER=1, ISTOCK_HEAT=2, ISTOCK_SALT=3
  integer,public,    parameter                :: ISTOCK_TOP=1, ISTOCK_BOTTOM=2, ISTOCK_SIDE=3
  integer,public                              :: stocks_file
  ! Stock related stuff
  ! Shallow (no constructor) data structures holding the starting stock values (per PE) and
  ! flux integrated increments at present time.

  integer, parameter :: NSIDES  = 3         ! top, bottom, side
 
  type stock_type ! per PE values
     real  :: q_start = 0.0    ! total stocks at start time
     real  :: q_now   = 0.0    ! total stocks at time t    
     
     ! The dq's below are the stocks increments at the present time
     ! delta_t * surf integr of flux
     ! one for each side (ISTOCK_TOP, ISTOCK_BOTTOM, ISTOCK_SIDE)
     real  :: dq(NSIDES)    = 0.0    ! stock increments at present time on the Ice   grid     
     real  :: dq_IN(NSIDES) = 0.0    ! stock increments at present time on the Ocean grid       
  end type stock_type

  type(stock_type), save, dimension(NELEMS) :: Atm_stock, Ocn_stock, Lnd_stock, Ice_stock
  type(time_type), save :: init_time

  public stocks_report
  public stocks_report_init
  public stocks_set_init_time

  integer,private,   parameter                :: NCOMPS=4
  integer,private,   parameter                :: ISTOCK_ATM=1,ISTOCK_LND=2,ISTOCK_ICE=3,ISTOCK_OCN=4
  character(len=3) , parameter, dimension(NCOMPS)  :: COMP_NAMES=(/'ATM', 'LND', 'ICE', 'OCN'/)


  character(len=5) , parameter, dimension(NELEMS)  :: STOCK_NAMES=(/'water', 'heat ', 'salt '/)
  character(len=12), parameter, dimension(NELEMS)  :: STOCK_UNITS=(/'[Kg]    ','[Joules]','[Kg]    '/)


contains


    subroutine stocks_report_init(Time)
    type(time_type)               , intent(in) :: Time

    character(len=80) :: formatString,space
    integer :: i,s
    real, dimension(NELEMS) :: val_atm, val_lnd, val_ice, val_ocn

    do i = 1, NELEMS_report
       val_atm(i) = Atm_stock(i)%q_start
       val_lnd(i) = Lnd_stock(i)%q_start
       val_ice(i) = Ice_stock(i)%q_start
       val_ocn(i) = Ocn_stock(i)%q_start
       call mpp_sum(val_atm(i))
       call mpp_sum(val_lnd(i))
       call mpp_sum(val_ice(i))
       call mpp_sum(val_ocn(i))
    enddo



    if(mpp_pe() == mpp_root_pe()) then
!       earth_area = 4.*PI*Radius**2

       write(stocks_file,*) '================Stocks Report Guide====================================='
       write(stocks_file,*) ' '
       write(stocks_file,*) 'S(t) = Total amount     of a tracer in the component model at time t.'
       write(stocks_file,*) '       Calculated via the component model itself.'
       write(stocks_file,*) ' '
       write(stocks_file,*) 'F(t) = Cumulative input of a tracer to the component model at time t.'
       write(stocks_file,*) '       Calculated via interchange of fluxes with other component models.'
       write(stocks_file,*) ' '
       write(stocks_file,*) 'S(t) - S(0) = Cumulative increase of the component stocks at time t'
       write(stocks_file,*) '              Calculated by the component itself.'
       write(stocks_file,*) ' '
       write(stocks_file,*) 'In a conserving component F(t)=S(t)-S(0) to within numerical accuracy.'
       write(stocks_file,*) ' '
       write(stocks_file,*) 'Component Model refers to one of OCN, ATM, LND or ICE'
       write(stocks_file,*) ''
       write(stocks_file,*) 'NOTE: When use_lag_fluxes=.true. is used in coupler, the ocean stocks '
       write(stocks_file,*) '      calculations are in error by an order which scales as the inverse'
       write(stocks_file,*) '      of the number of time steps.'
       write(stocks_file,*) ' '
       write(stocks_file,*) '======================================================================='       


       write(stocks_file,*) '======================Initial Stock S(0)==============================='       
!The following produces  formatString='(5x,a,a,12x,a,a, 9x)' but is general to handle more elements         
       formatString= '(5x'
       do i=1,NELEMS_report
          s = 25-len_trim(STOCK_NAMES(i))-len_trim(STOCK_UNITS(i))
          write(space,'(i2)') s 
          formatString= trim(formatString)//',a,a,'//trim(space)
          formatString= trim(formatString)//trim('x') 
       enddo
       formatString= trim(formatString)//')'
       
       write(stocks_file,formatString) (trim(STOCK_NAMES(i)),trim(STOCK_UNITS(i)), i=1,NELEMS_report)

!The following produces  formatString=' (a,x,es22.15,3x,es22.15,3x)' but is general to handle more elements
       formatString= '(a,x'
       do i=1,NELEMS_report
          write(space,'(i2)') s 
          formatString= trim(formatString)//',es22.15,3x'
       enddo
       formatString= trim(formatString)//')'
       
      
       write(stocks_file,formatString) 'ATM', (val_atm(i), i=1,NELEMS_report) 
       write(stocks_file,formatString) 'LND', (val_lnd(i), i=1,NELEMS_report)
       write(stocks_file,formatString) 'ICE', (val_ice(i), i=1,NELEMS_report)
       write(stocks_file,formatString) 'OCN', (val_ocn(i), i=1,NELEMS_report)

       write(stocks_file,*) '========================================================================'       
       write(stocks_file,'(a)'  ) ' '!blank line

    end if
    
    call stocks_set_init_time(Time)

  end subroutine stocks_report_init


  subroutine stocks_report(Time)
    type(time_type)               , intent(in) :: Time

    type(time_type) :: timeSinceStart
    type(stock_type) :: stck
    real, dimension(NCOMPS) :: f_value, f_ice_grid, f_ocn_grid, f_ocn_btf, q_start, q_now,c_value
    character(len=80) :: formatString
    integer :: iday0, isec0, iday, isec, hours
    real    :: days
    integer :: diagID , comp,elem,i
    integer, parameter :: initID = -2 ! initial value for diag IDs. Must not be equal to the value 
    ! that register_diag_field returns when it can't register the filed -- otherwise the registration 
    ! is attempted every time this subroutine is called

    integer, dimension(NCOMPS,NELEMS), save :: now_valueDiagID = initID
    integer, dimension(NCOMPS,NELEMS), save :: f_valueDiagID = initID
    integer, dimension(NCOMPS,NELEMS), save :: c_valueDiagID = initID
    integer, dimension(NCOMPS,NELEMS), save :: fmc_valueDiagID = initID
    integer, dimension(NCOMPS,NELEMS), save :: f_lostDiagID = initID

    real :: diagField
    logical :: used
    character(len=30) :: field_name, units

    if(mpp_pe()==mpp_root_pe()) then
       call get_time(init_time, isec0, iday0)
       call get_time(Time, isec, iday)
       
       hours = iday*24 + isec/3600 - iday0*24 - isec0/3600
       days  = hours/24.  
       write(stocks_file,*) '==============================================='
       write(stocks_file,'(a,f12.3)') 't = TimeSinceStart[days]= ',days 
       write(stocks_file,*) '==============================================='
    endif

    do elem = 1,NELEMS_report

       do comp = 1,NCOMPS

          if(comp == ISTOCK_ATM) stck = Atm_stock(elem)
          if(comp == ISTOCK_LND) stck = Lnd_stock(elem)
          if(comp == ISTOCK_ICE) stck = Ice_stock(elem)
          if(comp == ISTOCK_OCN) stck = Ocn_stock(elem)


          f_ice_grid(comp) = sum(stck%dq)
          f_ocn_grid(comp) = sum(stck%dq_IN)
          f_ocn_btf(comp)  = stck%dq_IN( ISTOCK_BOTTOM )

          q_start(comp) = stck%q_start
          q_now(comp)   = stck%q_now 

          call mpp_sum(f_ice_grid(comp))
          call mpp_sum(f_ocn_grid(comp))
          call mpp_sum(f_ocn_btf(comp))
          call mpp_sum(q_start(comp))
          call mpp_sum(q_now(comp))

          c_value(comp) = q_now(comp) - q_start(comp)

          if(mpp_pe() == mpp_root_pe()) then

             if(now_valueDiagID(comp,elem) == initID) then
                field_name = trim(COMP_NAMES(comp)) // trim(STOCK_NAMES(elem))
                field_name  = trim(field_name) // 'StocksChange_Sum'
                units = trim(STOCK_UNITS(elem))
                now_valueDiagID(comp,elem) = register_diag_field('stock_print', field_name, Time, &
                     units=units)
             endif

             if(f_valueDiagID(comp,elem) == initID) then
                field_name = trim(COMP_NAMES(comp)) // trim(STOCK_NAMES(elem))
                field_name  = trim(field_name) // 'StocksChange_Flux'
                units = trim(STOCK_UNITS(elem))
                f_valueDiagID(comp,elem) = register_diag_field('stock_print', field_name, Time, &
                     units=units)
             endif

             if(c_valueDiagID(comp,elem) == initID) then
                field_name = trim(COMP_NAMES(comp)) // trim(STOCK_NAMES(elem))
                field_name = trim(field_name) // 'StocksChange_Comp'
                units = trim(STOCK_UNITS(elem))
                c_valueDiagID(comp,elem) = register_diag_field('stock_print', field_name, Time, &
                     units=units)
             endif

             if(fmc_valueDiagID(comp,elem) == initID) then
                field_name = trim(COMP_NAMES(comp)) // trim(STOCK_NAMES(elem))
                field_name = trim(field_name) // 'StocksChange_Diff'
                units = trim(STOCK_UNITS(elem))
                fmc_valueDiagID(comp,elem) = register_diag_field('stock_print', field_name, Time, &
                     units=units)
             endif

             f_value(comp) = f_ice_grid(comp)

             if(comp == ISTOCK_OCN) then

                f_value(comp) = f_ocn_grid(comp)

                if(f_lostDiagID(comp,elem) == initID) then
                   field_name = trim(COMP_NAMES(comp)) // trim(STOCK_NAMES(elem))
                   field_name = trim(field_name) // 'StocksExchangeLost'
                   units = trim(STOCK_UNITS(elem))
                   f_lostDiagID(comp,elem) = register_diag_field('stock_print', field_name, Time, &
                        units=units)
                endif

                DiagID=f_lostDiagID(comp,elem)
                diagField = f_ice_grid(comp) - f_ocn_grid(comp)
                if (DiagID > 0)  used = send_data(DiagID, diagField, Time)

             endif


             DiagID=now_valueDiagID(comp,elem)
             diagField = q_now(comp)
             if (DiagID > 0)  used = send_data(DiagID, diagField, Time)
             DiagID=f_valueDiagID(comp,elem)
             diagField = f_value(comp)
             if (DiagID > 0)  used = send_data(DiagID, diagField, Time)
             DiagID=c_valueDiagID(comp,elem)
             diagField = c_value(comp)
             if (DiagID > 0)  used = send_data(DiagID, diagField, Time)
             DiagID=fmc_valueDiagID(comp,elem)
             diagField = f_value(comp)-c_value(comp)
             if (DiagID > 0)  used = send_data(DiagID, diagField, Time)


             !             formatString = '(a,a,a,i16,2x,es22.15,2x,es22.15,2x,es22.15,2x,es22.15,2x,es22.15,2x,es22.15)'
             !
             !             write(stocks_file,formatString) trim(COMP_NAMES(comp)),STOCK_NAMES(elem),STOCK_UNITS(elem) &
             !                  ,hours, q_now, q_now-q_start, f_value, f_value - (q_now - q_start), (f_value - (q_now - q_start))/q_start


          endif
       enddo


       if(mpp_pe()==mpp_root_pe()) then
!          write(stocks_file,'(a)'  ) ' '!blank line
!          write(stocks_file,'(a,f12.3)') 't = TimeSinceStart[days]= ',days 
!          write(stocks_file,'(a)'  )   ' '!blank line
!          write(stocks_file,'(a,30x,a,20x,a,20x,a,20x,a)') 'Component ','ATM','LND','ICE','OCN'
!          write(stocks_file,'(55x,a,20x,a,20x,a,20x,a)')  'ATM','LND','ICE','OCN'
!          write(stocks_file,'(a,f12.3,12x,a,20x,a,20x,a,20x,a)') 't = TimeSinceStart[days]= ',days,'ATM','LND','ICE','OCN'

          write(stocks_file,'(a,a,40x,a,20x,a,20x,a,20x,a)') 'Stocks of ',trim(STOCK_NAMES(elem)),'ATM','LND','ICE','OCN'
          formatString = '(a,a,2x,es22.15,2x,es22.15,2x,es22.15,2x,es22.15)'

          write(stocks_file,formatString) 'Total =S(t)               ',STOCK_UNITS(elem),&
               ( q_now(i), i=1,NCOMPS)
          write(stocks_file,formatString) 'Change=S(t)-S(0)          ',STOCK_UNITS(elem),&
               ( q_now(i)-q_start(i), i=1,NCOMPS)
          write(stocks_file,formatString) 'Input =F(t)               ',STOCK_UNITS(elem),&
               ( f_value(i), i=1,NCOMPS)
          write(stocks_file,formatString) 'Diff  =F(t) - (S(t)-S(0)) ',STOCK_UNITS(elem),&
               ( f_value(i) - c_value(i), i=1,NCOMPS)                           
          write(stocks_file,formatString) 'Error =Diff/S(0)          ','[NonDim]    ', &
               ((f_value(i) - c_value(i))/(1+q_start(i)), i=1,NCOMPS)  !added 1 to avoid div by zero. Assuming q_start large          

          write(stocks_file,'(a)'  ) ' '!blank line
          formatString = '(a,a,a,6x,es22.15)'
          write(stocks_file,formatString) 'Lost Stocks in the exchange between Ice and Ocean ',trim(STOCK_NAMES(elem)),trim(STOCK_UNITS(elem)),  &
               f_ice_grid(ISTOCK_OCN) - f_ocn_grid(ISTOCK_OCN) + f_ocn_btf(ISTOCK_OCN)

          write(stocks_file,'(a)') ' ' !blank line  
          write(stocks_file,'(a)') ' ' !blank line

       endif
    enddo

  end subroutine stocks_report

  subroutine stocks_set_init_time(Time)
    type(time_type)     , intent(in) :: Time
    init_time = Time
    
  end subroutine stocks_set_init_time

end module stock_constants_mod

MODULE rotstayn_klein_mp_mod

use mpp_mod,             only : input_nml_file
use fms_mod,             only : error_mesg, FATAL, mpp_pe, mpp_root_pe, &
                                open_namelist_file, check_nml_error, &
                                close_file, write_version_number, &
                                file_exist, stdlog
use cloud_generator_mod, only : cloud_generator_init, do_cloud_generator, &
                                compute_overlap_weighting
use  constants_mod,      only : hlv,hlf,hls, rdgas, cp_air, grav, &
                                tfreeze, dens_h2o, rvgas
use  aer_in_act_mod,     only : Jhete_dep
use  sat_vapor_pres_mod, only : compute_qs,  sat_vapor_pres_init 
use polysvp_mod,         only : polysvp_init, polysvp_end, polysvp_l,  &
                                polysvp_i
use strat_cloud_utilities_mod,     &
                         only : strat_cloud_utilities_init, &
                                diag_id_type, diag_pt_type, strat_nml_type

implicit none
private 

!-------------------------------------------------------------------------
!---interfaces------------------------------------------------------------

public   rotstayn_klein_microp, rotstayn_klein_microp_init, &
         rotstayn_klein_microp_end
private  cloud_clear_xfer

!-------------------------------------------------------------------------
!---version number-------------------------------------------------------

Character(len=128) :: Version = '$Id: rotstayn_klein_mp.F90,v 20.0 2013/12/13 23:22:05 fms Exp $'
Character(len=128) :: Tagname = '$Name: tikal $'

!-------------------------------------------------------------------------
!---namelist-------------------------------------------------------------
 
logical :: rk_alt_adj_opt = .false.             ! we should use an altern-
                                                ! ative method to determine
                                                ! supersaturation  using
                                                ! formula used in mg_micro?
logical :: rk_act_only_if_ql_gt_qmin = .false.  ! compute qn source term
                                                ! (activated nuclei)
                                                ! only when ql is > qmin ?
logical :: use_inconsistent_lh = .true.         ! use the legacy latent
                                                ! heat treatment for the 
                                                ! condensation of super-
                                                ! saturated vapor ?
                                                ! (this is non-entropy-
                                                ! conserving and physically
                                                ! unrealistic ??)

namelist / rotstayn_klein_mp_nml /   rk_alt_adj_opt, &
                                     rk_act_only_if_ql_gt_qmin, &
                                     use_inconsistent_lh


!-------------------------------------------------------------------------
!---local module variables and parameters---------------------------------

real, parameter :: d622 = rdgas / rvgas
real, parameter :: d378 = 1. - d622
real, parameter :: rho_ice        =  100.  ! mass density of ice crystals 
                                           ! [ kg/(m*m*m) ]
real, parameter :: ELI            =  0.7   ! collection efficiency of 
                                           ! cloud liquid by falling ice
                                           ! [ dimensionless ]
logical         :: cloud_generator_on      ! stochastic clouds are active?

!----------------------------------------------------------------------- 
logical         :: module_is_initialized = .false.


!----------------------------------------------------------------------


CONTAINS


!########################################################################

SUBROUTINE rotstayn_klein_microp_init

!-----------------------------------------------------------------------
      integer :: unit, ierr, io, logunit

!------------------------------------------------------------------------
!    if module has already been initialized, return.
!------------------------------------------------------------------------
      if (module_is_initialized) return

!-------------------------------------------------------------------------
!    process namelist.
!-------------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=rotstayn_klein_mp_nml, iostat=io)
      ierr = check_nml_error(io,'rotstayn_klein_mp_nml')
#else
      if ( file_exist('input.nml')) then
        unit = open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=rotstayn_klein_mp_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'rotstayn_klein_mp_nml')
        enddo
10      call close_file (unit)
      endif
#endif

!-------------------------------------------------------------------------
!    write version and namelist to standard log.
!-------------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if ( mpp_pe() == mpp_root_pe() ) &
                         write (logunit, nml=rotstayn_klein_mp_nml)

!------------------------------------------------------------------------
!    be sure needed modules have been initialized.
!------------------------------------------------------------------------
      call sat_vapor_pres_init
      call strat_cloud_utilities_init
      call polysvp_init
      call cloud_generator_init
      cloud_generator_on = do_cloud_generator()

!-----------------------------------------------------------------------
!    mark the module as initialized.
!-----------------------------------------------------------------------
      module_is_initialized = .true.


END SUBROUTINE rotstayn_klein_microp_init


!########################################################################

SUBROUTINE rotstayn_klein_microp (&
                     idim, jdim, kdim, Nml, N3D, overlap, dtcloud,  &
                     inv_dtcloud, pfull, deltpg, airdens, mask_present, &
                     mask, esat0, ql, qi, qa, ql_mean, qa_mean, qn_mean, &
                     omega, T, U, qv, qs, D_eros, dcond_ls, dcond_ls_ice, &
                     qvg, gamma, delta_cf, drop1, concen_dust_sub, ql_upd,&
                     qi_upd, qn_upd, qi_mean, qa_upd, ahuco, n_diag_4d, &
                     diag_4d, diag_id, diag_pt, n_diag_4d_kp1,   &
                     diag_4d_kp1, limit_conv_cloud_frac, SA, SN, ST, SQ, &
                     SL, SI, rain3d, snow3d, snowclr3d, surfrain,   &
                     surfsnow, f_snow_berg, otun)                 

!------------------------------------------------------------------------
type(strat_nml_type),                intent(in)   :: Nml
LOGICAL,                             INTENT(IN)   :: mask_present,   &
                                                     limit_conv_cloud_frac
INTEGER,                             INTENT(IN)   :: overlap
INTEGER,                             INTENT(IN)   :: idim, jdim, kdim
INTEGER,                             intent(in)   :: n_diag_4d,  &
                                                     n_diag_4d_kp1
REAL,                                INTENT(IN)   :: dtcloud, inv_dtcloud
REAL, dimension(idim, jdim,kdim),    INTENT(IN)   :: MASK
REAL, dimension(idim,jdim,kdim),     INTENT(IN)   ::   &
                              N3D, pfull, deltpg, airdens, ql, qi, qa, &
                              ql_mean, qn_mean, qa_mean, T, qv, drop1, U, &
                              qvg, esat0, gamma, concen_dust_sub, D_eros, &
                              omega, ahuco
real, dimension(idim,jdim,kdim),     INTENT(INOUT)::   &
                              SN, qi_mean, ST, SQ, SL, SI, SA, qa_upd, &
                              ql_upd, qi_upd, qn_upd, qs, delta_cf, &
                              dcond_ls,dcond_ls_ice    
REAL, dimension(idim,jdim,kdim,0:n_diag_4d),   &
                                     INTENT(INOUT)::  diag_4d
REAL, dimension( idim,jdim,kdim+1,0:n_diag_4d_kp1),   &
                                     INTENT(INOUT)::  diag_4d_kp1
TYPE(diag_id_type),                  intent(in)   :: diag_id
TYPE(diag_pt_type),                  intent(in)   :: diag_pt
real, dimension(idim, jdim, kdim+1), INTENT(OUT)  :: rain3d, snow3d
real, dimension(idim, jdim, kdim+1), INTENT(OUT)  :: snowclr3d
real, dimension(idim,jdim),          INTENT(OUT)  :: surfrain,surfsnow
real, dimension(idim, jdim, kdim  ), INTENT(OUT)  :: f_snow_berg 
INTEGER,                             INTENT(IN)   :: otun
!------------------------------------------------------------------------

!------------------------------------------------------------------------
!---local variables-----------------------------------------------------
!
!       rain_cld       grid mean flux of rain enter-   kg condensate/
!                      ing the grid box from above     (m*m)/s
!                      and entering the saturated 
!                      portion of the grid box
!
!
!       rain_clr       grid mean flux of rain enter-   kg condensate/
!                      ing the grid box from above     (m*m)/s
!                      and entering the unsaturated 
!                      portion of the grid box
!
!       a_rain_clr     fraction of grid box occupied   fraction
!                      by rain_clr
!
!       a_rain_cld     fraction of grid box occupied   fraction
!                      by rain_cld
!
!
!       snow_cld       flux of ice entering the        kg condensate/
!                      saturated portion of the        (m*m)/s
!                      grid box from above by means
!                      of gravitational settling 
!
!       snow_clr       flux of ice outside of cloud    kg condensate/
!                      entering the unsaturated        (m*m)/s
!                      portion of the grid box from      
!                      above
!
!       a_snow_clr     area fraction of grid box       fraction
!                      covered by snow flux in
!                      unsaturated air
!
!       a_snow_cld     area fraction of grid box       fraction
!                      covered by the snow flux in
!                      saturated air
!
!       da_cld2clr     fraction of the area in which   fraction
!                      rain/snow in saturated volume 
!                      above falls into unsaturated 
!                      volume in the current layer.
!
!       da_clr2cld     as in da_cld2clr except for     fraction
!                      the transfer from unsaturated
!                      to saturated volume
!                      non-convective condensation.    kg air
!
!       dprec_cld2clr  grid mean flux that is trans-   kg condensate/
!                      ferred from rain/snow in        (m*m)/s
!                      saturated volume to rain/snow 
!                      in unsaturated volume at layer 
!                      interfaces.
!
!       dprec_clr2cld  as in dprec_cld2clr except for  kg condensate/
!                      the transfer from unsaturated   (m*m)/s
!                      to saturated volume.
!
!       C_dt           product of A and dtcloud in     dimensionless in 
!                      in the analytic integration     qa integration
!                      of the qa equation, or C and
!                      dtcloud in the analytic         kg condensate/
!                      integration of the ql and qi    kg air in ql or 
!                      equations.                      qi integration
!
!       D_dt           product of B and dtcloud in     dimensionless in
!                      in the analytic integration     qa, ql, and qi
!                      of the qa equation, or D and    integration
!                      dtcloud in the analytic         
!                      integration of the ql and qi    
!                      equations.                      
!
!       D1_dt          first sink in either ql or qi   dimensionless
!                      equation. This is analogous to
!                      D_dt.  In ql equation, this 
!                      sink represents the conversion
!                      of cloud liquid to rain. In the
!                      qi equation it represents the
!                      settling of ice crystals.
!
!       D2_dt          second sink in ql or qi         dimensionless
!                      equation. This is analogous 
!                      to D_dt. In ql equation this
!                      sink represents the conversion
!                      of cloud liquid to ice. In the
!                      qi equation this sink 
!                      represents the melting of 
!                      cloud ice into rain.
!
!       Vfall          fall speed of ice crystals      m/s
!
!       lamda_f        slope factor in the SIZE        1/m
!                      distribution of ice crystals
!       rad_liq        mean volume radius of liquid    microns
!                      cloud drops
!
!       A_plus_B       sum of vapor diffusion factor   m*s/kg
!                      and thermal conductivity factor
!                      which is used in various 
!                      microphysical formula for the 
!                      evaporation of rain and snow
!
!       U_clr          relative humidity in the clear  fraction
!                      portion of the grid box.
!
!------------------------------------------------------------------------

      real, dimension(idim,jdim,kdim+1)  :: rain_clr, rain_cld, &
                                            a_rain_clr, a_rain_cld, &
                                            snow_clr, snow_cld, &
                                            a_snow_clr, a_snow_cld
      real, dimension(idim,jdim,kdim)    :: A_plus_B, C_dt, D_dt, &
                                            da_cld2clr, da_clr2cld, &
                                            dprec_clr2cld, dprec_cld2clr, &
                                            Vfall, lamda_f, tmp1, tmp2, &
                                            tmp3, tmp8, crystal,          &
                                            rad_liq, D1_dt, D2_dt, qc1, &
                                            qc0, qceq, qcbar, U_clr, &
                                            qs_d_a, tmp2s_a, tmp3s_a, &
                                            tmp5s_a, est_a, sum_freeze, &
                                            sum_cond,  sum_ice_adj, &
                                            sum_rime, sum_berg, tmp5
      real                               :: dum, Si0, qs_t, qs_d, tmp2s, &
                                            tmp3s, tmp5s, est, rhi, tc, &
                                            tcrit, qldt_sum
      integer                            :: i, j, k, km1

 
!------------------------------------------------------------------------  
!    initialize top levels of precip and precip area arrays.
!------------------------------------------------------------------------  
      a_rain_cld(:,:,1) = 0.
      a_rain_clr(:,:,1) = 0.
      rain_cld(:,:,1)   = 0.
      rain_clr(:,:,1)   = 0.
      snow_cld(:,:,1)   = 0.
      snow_clr(:,:,1)   = 0.
      a_snow_clr(:,:,1) = 0.
      a_snow_cld(:,:,1) = 0.

!-----------------------------------------------------------------------
!    compute A_plus_B which is the sum of vapor diffusion factor and 
!    thermal conductivity factor which is used in various microphysical
!    formula for the evaporation of rain and snow [m s / kg ].
!    The conductivity/diffusivity factor, A_plus_B is given by:
!
!    (4) A_plus_B =   { (hlv/Ka/T)*((hlv/rvgas/T)-1.) } + 
!
!                    { (rvgas*T/chi*esat) }
!
!    where Ka is the thermal conductivity of air = 0.024 J/m/s/K
!    and chi is the diffusitivy of water vapor in air which is
!    given by
!
!    (5) chi = 2.21 E-05 (m*m)/s  * (1.E+05)/pfull
!
!    where p is the pressure in Pascals.
!-----------------------------------------------------------------------
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            A_plus_B(i,j,k) = ((hlv/0.024/T(i,j,k))*  &
                              ((hlv/rvgas/T(i,j,k)) - 1.) ) +        &
                              (rvgas*T(i,j,k)*pfull(i,j,k)/2.21/  &
                                                           esat0(i,j,k))  
          end do
        end do
      end do

      sum_freeze = 0.
      sum_rime = 0.
      sum_berg = 0.
      sum_ice_adj = 0.
      sum_cond = 0.

!------------------------------------------------------------------------
!    begin big vertical loop.
!------------------------------------------------------------------------
      do k=1, kdim  
        km1 = MAX(k-1, 1)

!------------------------------------------------------------------------
!    compute weighting factor for overlap when stochastic clouds are
!    activated.
!------------------------------------------------------------------------
        if (cloud_generator_on) then
          if (k .GT. 1) THEN 
            tmp3(:,:,k) = compute_overlap_weighting (   &
                                  qa_mean(:,:,km1),qa_mean(:,:,k),&
                                              pfull(:,:,k-1),pfull(:,:,k))
            tmp3(:,:,k) = min(1., max(0., tmp3(:,:,k)))       
          else
            tmp3(:,:,k) = 0.
          endif 
        endif

!-----------------------------------------------------------------------
!
!
!
!            TRANSFER OF RAIN FLUXES AND SNOW FLUXES BETWEEN 
!      
!           SATURATED AND UNSATURATED PORTIONS OF THE GRID BOX
!
!                           AT LAYER INTERFACES
!                           
!
!       Do transfer of rain and snow fluxes between clear and cloud 
!       portions of the grid box. This formulism follows the rain/snow
!       parameterization developed by Jakob and Klein (2000).  It 
!       treats the grid mean flux of rain and snow separately according 
!       to the portion that exists in unsaturated air and the portion 
!       that exists in saturated air.  At the top of each level, some 
!       precipitation that was in unsaturated air in the levels above 
!       may enter saturated air and vice versa. These transfers are 
!       calculated here under an assumption for the overlap between 
!       precipitation area and saturated area at the same and adjacent 
!       levels.
!
!       For rain, the area of the grid box in which rain in saturated 
!       air of the level above enters unsaturated air in the current 
!       level is called da_cld2clr and is given by 
!       maximum(a_rain_cld - qa , 0.) in the case of maximum overlap of
!       rain_cld and qa, but equal to a_rain_cld*(1.-qa) in the case of
!       random overlap of cloud and precipitation. The grid mean flux of 
!       rain which is transfered from saturated air to unsaturated air 
!       is given by rain_cld*da_cld2clr/a_rain_cld.
!
!       The area of the grid box where rain in unsaturated air of the
!       level above enters saturated air in the current level is
!       called da_clr2cld and is given by
!       maximum(0.,mininum(a_rain_clr,qa(j)-qa(j-1))) in the case of
!       maximum overlap of cloud and rain_clr, but equal to a_rain_clr*
!       qa for the case of random overlap of cloud and precipitation.  
!       The grid mean flux of rain transfered from unsaturated air to 
!       saturated air is given by rain_clr*da_clr2cld/a_rain_clr.
!
!       NOTE: the overlap assumption used is set by the namelist 
!             variable in cloud_rad
!
!       Overlap values are:      1  = maximum
!                                2  = random
!
!       If cloud_generator is on, the overlap choice is taken from
!       there, by computing a quantity alpha, which is weighting 
!       between maximum and random overlap solutions.
!
!                alpha = 1 ---> maximum,
!                alpha = 0 ---> random
!
!       alpha is stored in tmp3.
!       tmp1 has the maximum overlap solution
!       tmp2 has the random overlap solution
 
!------------------------------------------------------------------------
!    rain transfers are done first; compute cloud to clear transfer.
!------------------------------------------------------------------------
        call cloud_clear_xfer (k, Nml, cloud_generator_on, overlap, tmp3, &
                               qa_mean, a_rain_clr, a_rain_cld,   &
                                                      rain_clr, rain_cld)
  
!------------------------------------------------------------------------
!    snow transfers are done second, in a manner exactly like that
!    done for the rain fluxes
!------------------------------------------------------------------------
        call cloud_clear_xfer (k, Nml, cloud_generator_on, overlap, tmp3, &
                               qa_mean, a_snow_clr, a_snow_cld,  &
                                                      snow_clr, snow_cld)

!-----------------------------------------------------------------------
!
!
!                   MELTING OF CLEAR SKY SNOW FLUX
!
!
!    Melting of falling ice to rain occurs when T > tfreeze. The amount of
!    melting is limited to the melted amount that would cool the 
!    temperature to tfreeze.
!
!    In the snowmelt bug version, the temperature of melting was 
!    tfreeze + 2. like the original Tiedtke (1993) paper, instead of 
!    tfreeze.
!
!    compute grid mean change in snow flux to cool the grid box to tfreeze 
!    and store in temporary variable tmp1
!-----------------------------------------------------------------------
        if (Nml%do_old_snowmelt) then
          tmp1(:,:,k) = cp_air*(T(:,:,k) - tfreeze - 2.)*   &
                                              deltpg(:,:,k)*inv_dtcloud/hlf
        else
          tmp1(:,:,k) = cp_air*(T(:,:,k) - tfreeze)*  &
                                              deltpg(:,:,k)*inv_dtcloud/hlf
        end if
        
!------------------------------------------------------------------------
!    If snow_clr > tmp1, then the amount of snow melted is limited to tmp1,
!    otherwise melt snow_clr.  The amount melted is stored in tmp2. 
!    update temp and rain to account for the melting and conserve heat and
!    h2o.
!------------------------------------------------------------------------
        tmp2(:,:,k) = max(min(snow_clr(:,:,k), tmp1(:,:,k)), 0.)     
        ST(:,:,k) = ST(:,:,k) - hlf*tmp2(:,:,k)*dtcloud/deltpg(:,:,k)/ &
                                                                    cp_air
        rain_clr(:,:,k) = rain_clr(:,:,k) + tmp2(:,:,k)
 
!------------------------------------------------------------------------
!    change the area of clear-sky rain (a_rain_clr) to be the area of 
!    clear-sky snow (a_snow_clr) IF AND only IF melting occurs and 
!    a_rain_clr < a_snow_clr.
!------------------------------------------------------------------------
        where (tmp2(:,:,k) .gt. 0. .and. a_snow_clr(:,:,k) .gt. Nml%qmin)
          a_rain_clr(:,:,k) = max(a_rain_clr(:,:,k), a_snow_clr(:,:,k))
        end where

!------------------------------------------------------------------------
!    if all of the snow has melted, then zero out a_snow_clr
!------------------------------------------------------------------------
        where (snow_clr(:,:,k).lt.tmp1(:,:,k) .and.   &
                                        a_snow_clr(:,:,k).gt.Nml%qmin)
          snow_clr(:,:,k) = 0.
          a_snow_clr(:,:,k) = 0.
        elsewhere
          snow_clr(:,:,k) = snow_clr(:,:,k) - tmp2(:,:,k)          
        end where

!------------------------------------------------------------------------
!    define snow melt diagnostic.
!------------------------------------------------------------------------
        if (diag_id%snow_melt  + diag_id%snow_melt_col > 0)    &
            diag_4d(:,:,k,diag_pt%snow_melt) = tmp2(:,:,k)/deltpg(:,:,k)  
             
!-----------------------------------------------------------------------
!
!
!                        MELTING OF CLOUDY SKY SNOW FLUX
!
!
!    Melting of falling ice to rain occurs when T > tfreeze. The 
!    amount of melting is limited to the melted amount that would 
!    cool the temperature to tfreeze.
!-------------------------------------------------------------------------
        if (.not.Nml%do_old_snowmelt) then

!----------------------------------------------------------------------
!    compute grid mean change in snow flux to cool the grid box to tfreeze
!    and store in temporary variable tmp1
!
!    note that tmp1 already has the value of this variable from the 
!    clear-sky melt calculation, so one does not need to repeat the 
!    calculation here.
!
!    However, note that clear-sky snow melt may have already reduced the 
!    temperature of the grid box - this snow melt is in variable tmp2 from 
!    lines above. Thus the amount that one can melt is less.
!------------------------------------------------------------------------
          tmp1(:,:,k) = tmp1(:,:,k) - tmp2(:,:,k)
        
!------------------------------------------------------------------------
!    If snow_cld > tmp1, then the amount of snow melted is limited to 
!    tmp1, otherwise melt snow_cld.  The amount melted is stored in tmp2
!    update temp and rain to account for the melting and conserve heat and
!    h2o.
!------------------------------------------------------------------------
          tmp2(:,:,k) = max(min(snow_cld(:,:,k), tmp1(:,:,k)),0.)     
          ST(:,:,k) = ST(:,:,k) - hlf*tmp2(:,:,k)*dtcloud/  &
                                                     deltpg(:,:,k)/cp_air 
          rain_cld(:,:,k) = rain_cld(:,:,k) + tmp2(:,:,k)
 
!-----------------------------------------------------------------------
!    change the area of cloudy-sky rain (a_rain_cld) to be the area of 
!    cloudy-sky snow (a_snow_cld) IF AND only IF melting occurs and 
!    a_rain_cld < a_snow_cld.
!-----------------------------------------------------------------------
          where (tmp2 (:,:,k).gt. 0. .and. a_snow_cld(:,:,k) .gt. Nml%qmin)
            a_rain_cld(:,:,k) = max(a_rain_cld(:,:,k), a_snow_cld(:,:,k))
          end where

!------------------------------------------------------------------------
!    If all of the snow has melted, then zero out a_snow_cld.
!------------------------------------------------------------------------
          where (snow_cld(:,:,k).lt.tmp1(:,:,k) .and.   &
                                         a_snow_cld(:,:,k).gt.Nml%qmin)
            snow_cld(:,:,k)= 0.
            a_snow_cld(:,:,k) = 0.
          elsewhere
            snow_cld(:,:,k) = snow_cld(:,:,k) - tmp2(:,:,k)          
          end where

!------------------------------------------------------------------------
!    define snow melt diagnostic -- add to clear sky melting.
!------------------------------------------------------------------------
          if (diag_id%snow_melt  + diag_id%snow_melt_col > 0)   &
                      diag_4d(:,:,k,diag_pt%snow_melt) =   &
                                diag_4d(:,:,k,diag_pt%snow_melt) + &
                                                tmp2(:,:,k)/deltpg(:,:,k) 
        end if  ! (.not. do_old_snowmelt)  
                            
!----------------------------------------------------------------------!
!
!
!              COMPUTE SLOPE FACTOR FOR ICE MICROPHYSICS                  
!
!       [The following microphysics follows that of Rotstayn (1997)]
!       The number concentration of ice crystals of diameter D in the
!       SIZE interval D to D+dD is assumed to be 
!       distributed as in a Marshall Palmer distribution :
!
!  (22) N(D)dD = Nof * Exp( - lamda_f * D)
!
!       The slope factor and intercept are not assumed to be constant,
!       but the slope factor is
!
!  (23) lamda_f = 1.6X10^(3.+0.023(tfreeze-T))
!
!       Integration of (22) over all particle sizes with a constant
!       density of ice crystals , rho_ice, and assumed spherical shape
!       yields a relationship between the intercept parameter and qi
!
!  (24) Nof = airdens*qi_local*(lamda_f^4)/pi*rho_ice
!       
!
!       For the calculation of riming and sublimation of snow, 
!       lamda_f is needed, so it is calculated here.
!
!       Also qi_mean is updated here with the flux of ice that falls 
!       into the cloudy portion of the grid box from above. This permits
!       the Bergeron and riming process to know about the ice that falls
!       into the grid box in the same time step.

!       Increment qi_mean by the ice flux entering the the grid box. To 
!       convert ice_flux to units of condensate by multiply by dtcloud and
!       dividing by the mass per unit area of the grid box. Implicit here 
!       is the assumption that the ice entering the cloud will be spread 
!       instantaneously over  all of the cloudy area.
!-----------------------------------------------------------------------

!------------------------------------------------------------------------
!    update the qi variable with the amount of snow added to the box. 
!------------------------------------------------------------------------
        qi_mean(:,:,k) = qi_mean(:,:,k) + snow_cld(:,:,k)*  &
                                                    dtcloud/deltpg(:,:,k)  

!-----------------------------------------------------------------------
!    snow falling into cloud reduces the amount that falls out of cloud: 
!    a loss of cloud ice from settling is defined to be negative. define
!    the ice-fall diagnostic.
!-----------------------------------------------------------------------
        if (diag_id%qidt_fall + diag_id%qi_fall_col > 0)  &
                 diag_4d(:,:,k,diag_pt%qidt_fall) =    &
                                            snow_cld(:,:,k)/deltpg(:,:,k)
         
!-----------------------------------------------------------------------
!    compute slope factor lamda_f.
!RSH  -- conditionally calculate this only when needed
!-----------------------------------------------------------------------
        where ( ((a_snow_cld(:,:,k).gt.Nml%qmin) .and.   &
                     (ql_mean(:,:,k).gt.Nml%qmin) .and. &
                (qa_mean(:,:,k).gt.Nml%qmin) ) .or. snow_clr(:,:,k) > 0.0 )
          lamda_f(:,:,k) = 1.6*10**(3.+0.023*(tfreeze - T(:,:,k)))
        elsewhere
          lamda_f(:,:,k) = 0.
        endwhere

!----------------------------------------------------------------------!
!                                                                      !
!                                                                      !
!                                                                      !
!                       LIQUID PHASE MICROPHYSICS                      !
!                                                                      !
!                                 AND                                  !
!                                                                      !
!                  ANALYTIC INTEGRATION OF QL EQUATION                 !
!                                                                      !
!                                                                      !
!                                                                      !
!       Accretion
!
!       The parameterization of collection of cloud liquid drops by
!       rain drops follows the parameterization of Rotstayn (1997).
!       The parameterization starts with the continous-collection 
!       equation of drops by a rain drop of diameter D, falling with
!       speed V(D).   The fall speed of rain drops is taken from
!       Gunn and Kinzer(1949):
!
!  (25) V(D) = 141.4 (m**0.5,s-1) * sqrt(D) * (rho_ref/airdens)**0.5
!
!       where D is the radius of the rain drops in meters. Here
!       rho_ref is a reference air density.  This formula is generally
!       good for 1 mm < D < 4 mm.
!
!       The distribution of rain drops by SIZE follows a Marshall-
!       Palmer distribution:
!
!  (26) N(D) dD = Nor * Exp (- lamda *D)
!
!       where N(D)dD is the number of rain drops with SIZE D in the
!       interval D to D+dD, Nor is the intercept (assumed fixed at
!       8E+04 (1/m*m*m*m).  lamda is the slope intercept parameter
!       and with (21) it can be shown that lamda is a function of
!       the rain rate.
!
!       With these assumptions the local rate of accretion of cloud
!       liquid reduces to:
!
!  (27) dl/dt_local = - CB*Eco*((rain_rate_local/dens_h2o)**(7/9))*
!                        
!                       (rho_ref/airdens)**(1/9)   * ql_local
!
!       where CB is the accretion constant:
! 
!       CB = 65.772565 [(m)**(-7/9)] * [(s)**(-2/9)]
!
!       AND Eco is the collection efficiency of a cloud droplet by a 
!       rain droplet.   A good fit to the Table 8.2 of Rogers and Yau 
!       (1988) for rain drops between SIZE 1mm and 3mm is:
!
!  (28) Eco = rad_liq**2 / (rad_liq**2 + 20.5 microns**2) .
!
!       In generalizing to grid mean conditions (27) becomes:
!
!  (29) dl/dt = - (arain_cld/qa_mean) * CB * Eco * 
!
!                 [(rain_cld/a_rain_cld/dens_h2o)**(7/9)] * ql
!        
!       Note that the very weak dependence on air density is
!       neglected at this point.
!
!       The particle sizes are computed from the following equation
!
!  (30) rad_liq = (3*airdens*ql/(4*pi*liq_dens*qa*N)^(1/3)
!
!       
!       For numerical treatment we write (25) as:
!
!       dl/dt = - D_acc * l 
!
!       and if we do so:
!
!  (31) D_acc   =  (arain_cld/qa_mean) * CB * Eco * 
!
!                 [(rain_cld/a_rain_cld/dens_h2o)**(7/9)] 
!
!       In the work below, D_acc is added to D1_dt, the first processes
!       contributing to the depletion of cloud liquid in the analytic
!       integration.  D1_dt represents the conversion of liquid to rain.
!------------------------------------------------------------------------

        if (.not. Nml%do_liq_num) then

!-----------------------------------------------------------------------
!    compute rad_liq.  The constant below is equal to   
!    1.E+06 * (3/4*pi)^(1/3), where the 1E+06 is the factor to convert 
!    meters to microns. do not let very small cloud fractions contribute 
!    to autoconversion or accretion.
!-----------------------------------------------------------------------
          where (qa_mean(:,:,k) .gt. Nml%qmin) 
            rad_liq(:,:,k)= 620350.49 *( (airdens(:,:,k)*ql_mean(:,:,k)/ &
                              max(qa_mean(:,:,k), Nml%qmin)/   &
                                          N3D(:,:,k)/dens_h2o)**(1./3.))
          elsewhere
            rad_liq(:,:,k) = 0.0
          end where
        else        
          where (qa_mean(:,:,k) .gt. Nml%qmin .and.   &
                 qn_upd(:,:,k) .gt.Nml%qmin) 
            rad_liq(:,:,k) = 620350.49*( (ql_mean(:,:,k)/  &
                             max(qn_mean(:,:,k),   &
                                            Nml%qmin)/dens_h2o)**(1./3.))
          elsewhere
            rad_liq(:,:,k) = 0.
          endwhere
        endif
        
!------------------------------------------------------------------------
!    save  particle size diagnostic.
!------------------------------------------------------------------------
        if (diag_id%rvolume > 0) diag_4d(:,:,k,diag_pt%rvolume) =   &
                              rad_liq(:,:,k) *diag_4d(:,:,k,diag_pt%aliq)

!------------------------------------------------------------------------
!    compute accretion D term from formula above.
!------------------------------------------------------------------------
        where  (rad_liq(:,:,k) > 0.0) 
          D1_dt(:,:,k) =  dtcloud*65.772565*(a_rain_cld(:,:,k)/  &
                                      max(qa_mean(:,:,k), Nml%qmin))* &
                        (rad_liq(:,:,k)*rad_liq(:,:,k)/  &
                             (rad_liq(:,:,k)*rad_liq(:,:,k) + 20.5) )*   &
                        ((rain_cld(:,:,k)/   &
                               max(a_rain_cld(:,:,k), Nml%qmin)/  &
                                                      dens_h2o)**(7./9.))
        elsewhere
          D1_dt(:,:,k) = 0.
        end where
            
!------------------------------------------------------------------------
!    save  accretion process diagnostics.
!------------------------------------------------------------------------
        if (diag_id%qldt_accr  + diag_id%ql_accr_col > 0)   &
                           diag_4d(:,:,k,diag_pt%qldt_accr) = -D1_dt(:,:,k)
        if (diag_id%qndt_pra  + diag_id%qn_pra_col > 0)    &
                            diag_4d(:,:,k,diag_pt%qndt_pra) = -D1_dt(:,:,k)
    
!------------------------------------------------------------------------
!       Autoconversion
!
!       The autoconversion parameterization follow that of Manton
!       and Cotton (1977).  This formula has been used in Chen and
!       Cotton (1987) and is used in the CSIRO GCM (Rotstayn 1997)
!       and the LMD GCM (Boucher, Le Treut and Baker 1995).  In this
!       formulation the time rate of change of grid mean liquid is
!
!  (32) dl/dt= -CA * qa * [(ql/qa)^(7/3)] * [(N*dens_h2o)^(-1/3)] 
!
!               * H(rad_liq - rthresh)
!
!       where N is the number of cloud droplets per cubic metre,
!       rthresh is a particle radius threshold needed to for autoconv-
!       ersion to occur, H is the Heaviside function, and CA is
!       a constant which is:
!
!  (33) CA =  0.104 * grav * Ec * (airdens)^(4/3) / mu 
!        
!       where grav is gravitational acceleration, Ec is the collection
!       efficiency, airdens is the density of air, and mu is the 
!       dynamic viscosity of air.   This constant is evaluated 
!       ignoring the temperature dependence of mu and with a fixed 
!       airdens of 1 kg/m3.
!
!       With   Ec = 0.55        (standard choice - see references)
!            grav = 9.81        m/(s*s)
!         airdens = 1.00        kg air/(m*m*m)
!              mu = 1.717  E-05 kg condensate/(m*s) 
!
!              CA = 32681. [(kg air)^(4/3)]/kg liq/m/s
!
!
!       For numerical treatment we write (32) as:
!
!       dl/dt = - D_aut * l 
!
!       and if we do so:
!
!  (34) D_aut   =   CA * [(N*dens_h2o)^(-1/3)] * [(ql/qa)^(4/3)] * &
!                   H(r-rthresh)
!
!       In the work below, D_aut is temporarily stored in the variable
!       tmp1 before being added to D1_dt.  D1_dt represents the 
!       conversion of liquid to rain.
!
!       Following Rotstayn, autoconversion is limited to the amount that
!       would reduce the local liquid cloud condensate to the critical
!       value at which autoconversion begins. This limiter is likely to
!       be invoked frequently and is computed from
!
!  (35) D_dt = log( (rad_liq/rthresh)**3. )
!
!       This limiter is stored in tmp2.
!
!
!
!       -------------------------------------------------
!
!       Khairoutdinov and Kogan (2000) Autoconversion
!
!       Reference: Khairoutdinov, M. and Y. Kogan, 2000: A new cloud 
!                  physics parameterization in a large-eddy simulation
!                  model of marine stratocumulus. Mon. Wea. Rev., 128,
!                  229-243.
!
!       If the namelist parameter use_kk_auto = true, then the 
!       Khairoutdinov and Kogan (KK) autoconversion parameterization
!       is used in place of the Manton and Cotton formula described
!       above.
!
!       In SI units this formula is:
!
!  (32A) dl/dt= -CA * qa * [(ql/qa)^(2.47)] * [(N)^(-1.79)] 
!
!
!       where N is the number of cloud droplets per cubic metre
!       and CA is a constant which is:
!
!  (33A) CA =  7.4188E+13 (kg condensate/kg air)**(-1.47)
!                         (# drops/meters**3)**(1.79)
!                         seconds**(-1) 
!        
!       For numerical treatment we write (32A) as:
!
!       dl/dt = - D_aut * l 
!
!       and if we do so:
!
!  (34A) D_aut   =   CA * [(N)^(-1.79)] * [(ql/qa)^(1.47)]
!------------------------------------------------------------------------
        if (Nml%do_liq_num) then
          if (Nml%use_kk_auto) then
            where (ql_mean(:,:,k) > 0.0) 
              tmp1(:,:,k) = dtcloud*1350.*(1.e-6*   &
                max(qn_mean(:,:,k)*airdens(:,:,k),  &
                      max(qa_mean(:,:,k), Nml%qmin)*Nml%N_min))**(-1.79)* &
                            (ql_mean(:,:,k))**(1.47)*  &
                                     max(qa_mean(:,:,k),Nml%qmin)**(0.32)
            elsewhere
              tmp1(:,:,k) = 0.
            end where
          else
            where (ql_mean(:,:,k) > 0.0) 
              tmp1(:,:,k) = 32681.*dtcloud*    &
                             ((max(qn_mean(:,:,k), Nml%qmin)*  &
                                    airdens(:,:,k)*dens_h2o)**(-1./3.))*  &
                                       (ql_mean(:,:,k)**(4./3.))/   &
                                             max(qa_mean(:,:,k), Nml%qmin)
!------------------------------------------------------------------------
!    compute limiter as in (35) and  limit autoconversion to the limiter
!------------------------------------------------------------------------
              tmp2(:,:,k) =max(3*log(max(rad_liq(:,:,k), Nml%qmin)/  &
                                                         Nml%rthresh), 0.)
              tmp1(:,:,k) = min(tmp1(:,:,k), tmp2(:,:,k))
            elsewhere
              tmp1(:,:,k) = 0.
            end where
          endif
        else

!------------------------------------------------------------------------
!   for non-predicted cloud number:
!------------------------------------------------------------------------
          if (Nml%use_kk_auto) then

!------------------------------------------------------------------------
!    compute autoconversion sink as in (34A)
!------------------------------------------------------------------------
            where (ql_mean(:,:,k).gt.Nml%qmin)
              tmp1(:,:,k) = 7.4188E+13*dtcloud*(N3D(:,:,k)**(-1.79))*     &
                   ((ql_mean(:,:,k)/max(qa_mean(:,:,k), Nml%qmin))**(1.47))
            elsewhere
              tmp1(:,:,k) = 0.
            endwhere
          else

!------------------------------------------------------------------------
!    compute autoconversion sink as in (34)
!------------------------------------------------------------------------
            where (ql_mean(:,:,k) > 0.0) 
              tmp1(:,:,k) = 32681.*dtcloud*((N3D(:,:,k)*   &
                              dens_h2o)**(-1./3.))*((ql_mean(:,:,k)/   &
                                  max(qa_mean(:,:,k), Nml%qmin))**(4./3.))
        
!------------------------------------------------------------------------
!    compute limiter as in (35) and  limit autoconversion to the limiter
!------------------------------------------------------------------------
              tmp2(:,:,k) = max(3*log(max(rad_liq(:,:,k), Nml%qmin)/  &
                                                       Nml%rthresh), 0.)
              tmp1(:,:,k) = min(tmp1(:,:,k), tmp2(:,:,k))
            elsewhere
              tmp1(:,:,k) = 0.
            end where
          endif
        endif

!------------------------------------------------------------------------
!    add autoconversion to D1_dt
!------------------------------------------------------------------------
        D1_dt(:,:,k) = D1_dt(:,:,k) + tmp1(:,:,k)

!------------------------------------------------------------------------
!    autoconversion will increase a_rain_cld to area of cloud
!------------------------------------------------------------------------
        where (tmp1(:,:,k) .gt. Nml%Dmin) a_rain_cld(:,:,k) =   &
                                                           qa_mean(:,:,k)

!------------------------------------------------------------------------
!    save autoconversion diagnostics.
!------------------------------------------------------------------------
        if  (diag_id%qldt_auto  + diag_id%ql_auto_col > 0)   &
                           diag_4d(:,:,k,diag_pt%qldt_auto) = -tmp1(:,:,k)  
        if  (diag_id%qndt_auto  + diag_id%qn_auto_col > 0)   &
                           diag_4d(:,:,k,diag_pt%qndt_auto) = -tmp1(:,:,k)  
        if ( diag_id%aauto > 0 ) then
          where ( rad_liq(:,:,k) .gt. Nml%rthresh )    &
                            diag_4d(:,:,k,diag_pt%aauto) = qa_mean(:,:,k)
        end if
        
!-----------------------------------------------------------------------
!       Bergeron-Findeisan Process 
!
!       where ice and liquid coexist, the differential saturation
!       vapor pressure between liquid and ice phases encourages
!       the growth of ice crystals at the expense of liquid droplets.
!
!       Rotstayn (2000) derive an equation for the growth of ice by
!       starting with the vapor deposition equation for an ice crystal
!       and write it in terms of ice specific humidity as:
!
!                 {(Ni/airdens)**2/3}*7.8
!  (36) dqi/dt =  ------------------------  X [(esl-esi)/esi] X
!                 [rhoice**1/3]* A_plus_B
!
!                 ((max(qi,Mio*Ni/airdens))**(1/3))*
!
!       Here Ni is the ice crystal number which is taken from the 
!       parameterization of Meyers et al. :
!
!  (37) Ni = 1000 * exp( (12.96* [(esl-esi)/esi]) - 0.639 )
!
!       The use of the maximum operator assumed that there is a 
!       background ice crystal always present on which deposition can 
!       occur.  Mio is an initial ice crystal mass taken to be 10-12kg.
!
!       Figure 9.3 of Rogers and Yau (1998) shows the nearly linear
!       variation of [(esl-esi)/esi] from 0. at 273.16K to 0.5 at 
!       233.16K.  Analytically this is parameterized as (tfreeze-T)/80.
!
!
!       Generalizing (36) to grid mean conditions and writing it in 
!       terms of a loss of cloud liquid yields:
!
!                  (1000*exp((12.96*(tfreeze-T)/80)-0.639)/airdens)**2/3
!  (38) dql/dt = - ----------------------------------------------------- 
!                           [rhoice**1/3]* A_plus_B * ql
!
!       *qa*7.8*((max(qi/qa,Mio*Ni/airdens))**(1/3))*[(tfreeze-T)/80]*ql
!
!       Note that the density of ice is set to 700 kg m3 the value 
!       appropriate for pristine ice crystals.  This value is 
!       necessarily different than the value of ice used in the riming 
!       and sublimation part of the code which is for larger particles 
!       which have much lower densities.
!------------------------------------------------------------------------
        if (Nml%do_dust_berg) then
          do j=1,jdim
            do i=1,idim
              if ( (T(i,j,k) .lt. tfreeze) .and.   &
                   (ql_mean(i,j,k) .gt. Nml%qmin) .and.   &
                   (qa_mean(i,j,k) .gt. Nml%qmin))  then
                Si0 = 1. + 0.0125*(tfreeze-T(i,j,k))
                call Jhete_dep (T(i,j,k), Si0, concen_dust_sub(i,j,k), &
                                                            crystal(i,j,k))
                if (diag_id%dust_berg_flag > 0)   &
                             diag_4d(i,k,j,diag_pt%dust_berg_flag) = 1.
              else
                crystal(i,j,k)=0.
              endif
            end do
          end do

!------------------------------------------------------------------------
!    save ice crystal diagnostics.
!------------------------------------------------------------------------
          if  (diag_id%qndt_cond + diag_id%qn_cond_col > 0) &
                        diag_4d(:,:,k,diag_pt%qndt_cond) = crystal(:,:,k)
          
!------------------------------------------------------------------------
!    do Bergeron process
!------------------------------------------------------------------------
          where ( (T(:,:,k) .lt. tfreeze) .and.  &
                  (ql_mean(:,:,k) .gt. Nml%qmin) .and.   &
                  (qa_mean(:,:,k) .gt. Nml%qmin))              
            D2_dt(:,:,k) = dtcloud*qa_mean(:,:,k)*((1.e6*crystal(:,:,k)/  &
                                  airdens(:,:,k))**(2./3.))* 7.8*  &
                      ((max(qi_mean(:,:,k)/qa_mean(:,:,k),   &
                                1.E-12*1.e6*crystal(:,:,k)/   &
                                       airdens(:,:,k)))**(1./3.))*  &
                            0.0125*(tfreeze - T(:,:,k))/((700.**(1./3.))* &
                                           A_plus_B(:,:,k)*ql_mean(:,:,k))
          elsewhere
            D2_dt(:,:,k) = 0.0
          end where

!------------------------------------------------------------------------
!    if dust not included in bergeron process:
!------------------------------------------------------------------------
        else
          where ( (T(:,:,k) .lt. tfreeze) .and.  &
                  (ql_mean(:,:,k) .gt. Nml%qmin) .and.   &
                  (qa_mean(:,:,k) .gt. Nml%qmin))           
            D2_dt(:,:,k) = dtcloud*qa_mean(:,:,k)*((Nml%cfact*1000.*  &
                           exp((12.96*0.0125*(tfreeze - T(:,:,k))) -   &
                               0.639)/airdens(:,:,k))**(2./3.))* 7.8* &
                               ((max(qi_mean(:,:,k)/qa_mean(:,:,k),  &
                                       1.E-12*Nml%cfact*1000.*   &
                            exp((12.96*0.0125*(tfreeze-T(:,:,k)))-0.639)/ &
                                   airdens(:,:,k)))**(1./3.))*0.0125*     &
                                (tfreeze - T(:,:,k))/((700.**(1./3.))*  &
                                          A_plus_B(:,:,k)*ql_mean(:,:,k))
          elsewhere
            D2_dt(:,:,k) = 0.0        
          end where
        endif

        sum_berg(:,:,k) = D2_dt(:,:,k)

!------------------------------------------------------------------------
!    diagnostics for bergeron process
!------------------------------------------------------------------------
        if  (diag_id%qldt_berg  + diag_id%ql_berg_col > 0)   &
                         diag_4d(:,:,k,diag_pt%qldt_berg) = - D2_dt(:,:,k)
        if  (diag_id%qndt_berg  + diag_id%qn_berg_col > 0)    &
                         diag_4d(:,:,k,diag_pt%qndt_berg) = - D2_dt(:,:,k)

!------------------------------------------------------------------------
!       Accretion of cloud liquid by ice ('Riming')
!       
!       [The below follows Rotstayn]
!       Accretion of cloud liquid by ice ('Riming') is derived in
!       the same way as the accretion of cloud liquid by rain. That
!       is the continous-collection equation for the growth of an
!       ice crystal is integrated over all ice crystal sizes. This
!       calculation assumes all crystals fall at the mass weighted
!       fall speed, Vfall.  This yields the following equation after
!       accounting for the area of the interaction
!
!  (39) dql/dt = -  ( a_snow_cld / qa/a_snow_cld ) *
!                   ( ELI * lamda_f * snow_cld / 2/ rho_ice ) * ql 
!
!
!       Note that in the version with the snowmelt bug, riming was
!       prevented when temperatures were in excess of freezing.
!-----------------------------------------------------------------------

!------------------------------------------------------------------------
!    compute the tendency due to riming.
!------------------------------------------------------------------------
        if (Nml%do_old_snowmelt) then
          where ((a_snow_cld(:,:,k).gt.Nml%qmin) .and.    &
                 (ql_mean(:,:,k).gt.Nml%qmin) .and. &
                 (qa_mean(:,:,k).gt.Nml%qmin) .and.   &
                 (T(:,:,k) .lt. tfreeze) )            
            tmp1(:,:,k) = dtcloud*0.5*ELI*lamda_f(:,:,k)*snow_cld(:,:,k)/ &
                                                   qa_mean(:,:,k)/rho_ice 
          elsewhere
            tmp1(:,:,k) = 0.0
          end where
        else
          where ((a_snow_cld(:,:,k).gt.Nml%qmin) .and. &
                 (ql_mean(:,:,k).gt.Nml%qmin) .and. &
                 (qa_mean(:,:,k).gt.Nml%qmin) )            
            tmp1(:,:,k) = dtcloud*0.5*ELI*lamda_f(:,:,k)*  &
                                    snow_cld(:,:,k)/qa_mean(:,:,k)/rho_ice 
          elsewhere
            tmp1(:,:,k) = 0.0
          end where
        end if        
        D2_dt(:,:,k) = D2_dt(:,:,k) + tmp1(:,:,k)

        sum_rime(:,:,k) = tmp1(:,:,k)

!-----------------------------------------------------------------------
!    save the riming diagnostics.
!-----------------------------------------------------------------------
        if  (diag_id%qldt_rime  + diag_id%ql_rime_col > 0)   &
                            diag_4d(:,:,k,diag_pt%qldt_rime) = -tmp1(:,:,k)

!------------------------------------------------------------------------
!       Freezing of cloud liquid to cloud ice occurs when
!       the temperature is less than -40C. At these very cold temper-
!       atures it is assumed that homogenous freezing of cloud liquid
!       droplets will occur.   To accomplish this numerically in one 
!       time step:
!
!  (40) D*dtcloud =  ln( ql / Nml%qmin ).
!
!       With this form it is guaranteed that if this is the only
!       process acting that ql = qmin after one integration.
!------------------------------------------------------------------------

!-------------------------------------------------------------------------
!    do homogeneous freezing. save freezing diagnostics and modify
!    bergeron and riming diagnostics if homogeneous freezing has occurred.
!-------------------------------------------------------------------------
        do j=1,jdim
          do i=1,idim
            if ((T(i,j,k) .lt. tfreeze - 40.) .and.     &
                (ql_mean(i,j,k) .gt. Nml%qmin).and.     &
                (qa_mean(i,j,k) .gt. Nml%qmin))  then
              D2_dt(i,j,k) = log ( ql_mean(i,j,k)/Nml%qmin )
              sum_freeze(i,j,k) = D2_dt(i,j,k)
              sum_rime(i,j,k) = 0.
              sum_berg(i,j,k) = 0.
              if (diag_id%qldt_freez + diag_id%ql_freez_col > 0)  then
                diag_4d(i,j,k,diag_pt%qldt_freez) = -D2_dt(i,j,k)
              endif
              if  (diag_id%qldt_rime  + diag_id%ql_rime_col > 0) then
                diag_4d(i,j,k,diag_pt%qldt_rime) = 0.
              endif
              if (diag_id%qldt_berg  + diag_id%ql_berg_col > 0) then
                diag_4d(i,j,k,diag_pt%qldt_berg) = 0. 
              endif
            endif      
          end do
        end do
  
!------------------------------------------------------------------------
!       Analytic integration of ql equation
!
!
!       The next step is to analytically integrate the cloud liquid
!       condensate equation.  This follows the Tiedtke approach.
!
!       The qc equation is written in the form:
!
!  (41) dqc/dt    =   C   -  qc * D   
!
!       Note that over the physics time step, C and D are assumed to 
!       be constants.
!
!       Defining qc(t) = qc0 and qc(t+dtcloud) = qc1, the analytic
!       solution of the above equation is:
!
!  (42) qc1 = qceq -  (qceq - qc0) * exp (-D*dtcloud)
! 
!       where qceq is the equilibrium cloud condensate that is approached
!       with an time scale of 1/D,
!
!  (43) qceq  =   C / D 
!
!
!       To diagnose the magnitude of each of the right hand terms of
!       (41) integrated over the time step, define the average cloud
!       condensate in the interval t to t + dtcloud qcbar as:
!
!  (44) qcbar  = qceq - [ (qc1-qc0) / ( dtcloud * D ) ]
! 
!       from which the magnitudes of the C and D terms integrated
!       over the time step are:
!
!       C   and   -D * (qcbar)
!   
!
!       Additional notes on this analytic integration:
!
!       1.   Because of finite machine precision it is required that
!            D*dt is greater than a minimum value.  This minimum
!            alue occurs where 1. - exp(-D*dt) = 0. instead of 
!            D*dt.  This value will be machine dependent. See discussion
!            at top of code for Dmin.
!
!------------------------------------------------------------------------

!------------------------------------------------------------------------
!    C_dt is set to large-scale condensation. Sink of cloud liquid 
!    is set to the sum of D1 (liquid to rain component), and D2 
!    (liquid to ice component), D_eros (erosion), and large-scale 
!    evaporation (note use of ql mean).        
!------------------------------------------------------------------------
        C_dt(:,:,k) = max(dcond_ls(:,:,k),0.)     
        D_dt(:,:,k) = D1_dt(:,:,k) + D2_dt(:,:,k) + D_eros(:,:,k) + &
                                     (max(-1.*dcond_ls(:,:,k), 0.)/    &
                                          max(ql_mean(:,:,k), Nml%qmin)) 

!------------------------------------------------------------------------
!    do analytic integration      
!------------------------------------------------------------------------
        where ( D_dt(:,:,k).gt.Nml%Dmin ) 
          qc0 (:,:,k) = ql_upd(:,:,k)
          qceq(:,:,k) = C_dt(:,:,k)/D_dt(:,:,k)
          qc1(:,:,k) = qceq(:,:,k) - (qceq(:,:,k) - qc0(:,:,k))*  &
                                                   exp( -1.* D_dt(:,:,k) )
          qcbar(:,:,k) = qceq(:,:,k) - ((qc1(:,:,k) -   &
                                                  qc0(:,:,k))/D_dt(:,:,k))
        elsewhere
          qc0(:,:,k)   = ql_upd(:,:,k)
          qceq(:,:,k)  = qc0(:,:,k) + C_dt(:,:,k)   
          qc1(:,:,k)   = qc0(:,:,k) + C_dt(:,:,k)
          qcbar(:,:,k) = qc0(:,:,k) + 0.5*C_dt(:,:,k)

        end where

!------------------------------------------------------------------------
!    set total tendency term and update cloud
!    Note that the amount of SL calculated here is stored in tmp1.
!------------------------------------------------------------------------
        SL(:,:,k) = SL(:,:,k) + qc1(:,:,k) - qc0(:,:,k)
        tmp1(:,:,k) = qc1(:,:,k) - qc0(:,:,k)        
        ql_upd(:,:,k) = qc1(:,:,k)

!------------------------------------------------------------------------
!    compute the amount each term contributes to the change

!       Apportion SL between various processes.  This is necessary to
!       account for how much the temperature changes due to various
!       phase changes.   For example:
!
!       liquid to ice   = (D2/D)*(-Dterm)
!
!       liquid to rain  = (D1/D)*(-Dterm) 
!
!       (no phase change but needed to know how much to increment 
!        rainflux)
!
!       vapor to liquid = - { ((-dcond_ls/ql_mean)+D_eros)/D}*(-Dterm) 
!                        where dcond_ls < 0 
!                                  
!                         but
!
!                        dcond_ls  -(D_eros/D)*(-Dterm)
!                        where dcond_ls > 0
!

!       initialize tmp2 to hold (-Dterm)/D
!------------------------------------------------------------------------
     if (Nml%retain_cm3_bug) then
        tmp2(:,:,k) = D_dt(:,:,k)*qcbar(:,:,k)/max(D_dt(:,:,k), Nml%Dmin)
 
     else
          where (D_dt(:,:,k) > Nml%Dmin) 
          tmp2(:,:,k) = D_dt(:,:,k)*qcbar(:,:,k)/max(D_dt(:,:,k), Nml%Dmin)
          elsewhere
          tmp2(:,:,k) = 0.0              
          endwhere
      endif

         if (diag_id%qldt_cond + diag_id%ql_cond_col > 0)  &
                 diag_4d(:,:,k,diag_pt%qldt_cond) =    &
                                       max(dcond_ls(:,:,k),0.) *inv_dtcloud
         if (diag_id%qldt_evap + diag_id%ql_evap_col > 0)   &
              diag_4d(:,:,k,diag_pt%qldt_evap) =    &
                  - (max(0., -1.*dcond_ls(:,:,k) )/  &
                     max(ql_mean(:,:,k), Nml%qmin))*tmp2(:,:,k)*inv_dtcloud
        if (diag_id%qldt_accr  + diag_id%ql_accr_col > 0)   &
            diag_4d(:,:,k,diag_pt%qldt_accr) =    &
                  diag_4d(:,:,k,diag_pt%qldt_accr)*tmp2(:,:,k)*inv_dtcloud
        if (diag_id%qldt_auto  + diag_id%ql_auto_col > 0)  &
            diag_4d(:,:,k,diag_pt%qldt_auto) =    &
                 diag_4d (:,:,k,diag_pt%qldt_auto)*tmp2(:,:,k)*inv_dtcloud
        if (diag_id%qldt_eros + diag_id%ql_eros_col > 0)  &
            diag_4d(:,:,k,diag_pt%qldt_eros) =    &
                                  -  D_eros(:,:,k)*tmp2(:,:,k)*inv_dtcloud 
        if (diag_id%qldt_berg + diag_id%ql_berg_col > 0)   &
           diag_4d(:,:,k,diag_pt%qldt_berg) =    &
                 diag_4d (:,:,k,diag_pt%qldt_berg)*tmp2(:,:,k)*inv_dtcloud
        sum_berg(:,:,k) = sum_berg(:,:,k)*tmp2(:,:,k)*inv_dtcloud
        if (diag_id%qldt_rime  + diag_id%ql_rime_col > 0)   &
           diag_4d(:,:,k,diag_pt%qldt_rime) =   &
                 diag_4d (:,:,k,diag_pt%qldt_rime)*tmp2(:,:,k)*inv_dtcloud
        sum_rime(:,:,k) = sum_rime(:,:,k)*tmp2(:,:,k)*inv_dtcloud
        if (diag_id%qldt_freez + diag_id%ql_freez_col > 0)  &
                 diag_4d(:,:,k,diag_pt%qldt_freez) =   &
                  diag_4d(:,:,k,diag_pt%qldt_freez)*tmp2(:,:,k)*inv_dtcloud
        sum_freeze(:,:,k) = sum_freeze(:,:,k)*tmp2(:,:,k)*inv_dtcloud
!-------------------------------------------------------------------------
!    do phase changes from large-scale processes and boundary
!    layer condensation/evaporation
!-------------------------------------------------------------------------
        ST(:,:,k) = ST(:,:,k) + (hlv*max(dcond_ls(:,:,k), 0.)/cp_air) -   &
                    (hlv*(max(-1.*dcond_ls(:,:,k), 0.)/     &
                       max(ql_mean(:,:,k), Nml%qmin))*tmp2(:,:,k)/cp_air)
        SQ(:,:,k) = SQ (:,:,k) - max(dcond_ls(:,:,k),0.) +            &
                    (max(-1.*dcond_ls(:,:,k), 0.)/    &
                               max(ql_mean(:,:,k), Nml%qmin))*tmp2(:,:,k)

!------------------------------------------------------------------------  
!    if debug is requested, output some fields.
!------------------------------------------------------------------------  
        if (Nml%debugo .and.                        k .eq. Nml%ksamp) then
          write(otun,*) "ccc ST 5 ",   ST(Nml%isamp,Nml%jsamp,Nml%ksamp)
        end if

!------------------------------------------------------------------------
!    add in  temperature tendencies resuklting from liquid to ice  trans-
!    formations and cloud erosion.
!------------------------------------------------------------------------
        ST(:,:,k) = ST(:,:,k) + (hlf*D2_dt(:,:,k) - hlv*D_eros(:,:,k))* &
                                                        tmp2(:,:,k)/cp_air

!------------------------------------------------------------------------  
!    if debug is requested, output some fields.
!------------------------------------------------------------------------  
        if (Nml%debugo .and.                        k .eq. Nml%ksamp) then
          write(otun,*) "ccc D_eros, D2_dt, tmp2 ",   &
                         D_eros(Nml%isamp, Nml%jsamp,Nml%ksamp),   &
                         D2_dt(Nml%isamp,Nml%jsamp,Nml%ksamp),&
                         tmp2(Nml%isamp,Nml%jsamp,Nml%ksamp)
          write(otun,*) "ccc ST 6 ",   ST(Nml%isamp,Nml%jsamp,Nml%ksamp)
        end if

!------------------------------------------------------------------------  
!    cloud evaporation adds to water vapor
!------------------------------------------------------------------------  
        SQ(:,:,k) = SQ(:,:,k) + D_eros(:,:,k)*tmp2(:,:,k)  
             
!------------------------------------------------------------------------  
!    add conversion of liquid to rain to the rainflux
!------------------------------------------------------------------------  
        rain_cld(:,:,k) = rain_cld(:,:,k) + D1_dt(:,:,k)*tmp2(:,:,k)*  &
                                                 deltpg(:,:,k)*inv_dtcloud
     
!------------------------------------------------------------------------  
!    save liquid converted to ice into tmp3 and increment qi_mean
!------------------------------------------------------------------------  
        tmp3(:,:,k)    = tmp2(:,:,k)*D2_dt(:,:,k)
        qi_mean(:,:,k) = qi_mean(:,:,k) + tmp3(:,:,k)
 
        
!******************************************************************
!
!       Analytic integration of qn equation
!
!       The qn equation is written in the form:
!
!  (m1) dqc/dt    =   (1 - qabar) * A * qc^   -  qc * D
!                 =   C - qc * D
!
!       where  qc^ is the large-scale qn calculated from the
!       activation parameterization.   Note that over the physics
!       time step, C and D are assumed to be constants.
!
!       Defining qc(t) = qc0 and qc(t+dtcloud) = qc1, the analytic
!       solution of the above equation is:
!
!  (m2) qc1 = qceq -  (qceq - qc0) * exp (-D*dtcloud)
! 
!       where qceq is the equilibrium cloud droplet number that is approached
!       with an time scale of 1/D,
!
!  (m3) qceq  = C / D
!
!
!       To diagnose the magnitude of each of the right hand terms of
!       (m1) integrated over the time step, define the average cloud
!       condensate in the interval t to t + dtcloud qcbar as:
!
!  (m4) qcbar  = qceq - [ (qc1-qc0) / ( dtcloud * D ) ]
! 
!       from which the magnitudes of the C and D terms integrated
!       over the time step are:
!
!       C and -D * (qcbar)
!------------------------------------------------------------------------
        if (Nml%do_liq_num) then
            
!------------------------------------------------------------------------
!    calculate C_dt
!------------------------------------------------------------------------
          IF (    rk_act_only_if_ql_gt_qmin) THEN
            where (ql_upd(:,:,k) .GT. Nml%qmin ) 
              C_dt(:,:,k) = max (delta_cf(:,:,k), 0.)*drop1(:,:,k)*  &
                                                      1.e6/airdens(:,:,k)
            elsewhere
              C_dt(:,:,k)=0.
            end where
          ELSE
            C_dt(:,:,k)=max(delta_cf(:,:,k), 0.)*drop1(:,:,k)*  &
                                                       1.e6/airdens(:,:,k)
          END IF

!------------------------------------------------------------------------
!    set total tendency term and update cloud
!    Note that the amount of SN calculated here is stored in tmp1.
!------------------------------------------------------------------------
          D_dt(:,:,k) =  Nml%num_mass_ratio1*D1_dt(:,:,k) +   &
                        (Nml%num_mass_ratio2*D2_dt(:,:,k) + D_eros(:,:,k))
          qc0(:,:,k) = qn_upd(:,:,k)
          where (D_dt(:,:,k) > Nml%Dmin) 
            qceq(:,:,k) = C_dt(:,:,k) / D_dt(:,:,k)
            qc1(:,:,k) = qceq(:,:,k) - (qceq(:,:,k) - qc0(:,:,k))*  &
                                                    exp(-1.*D_dt(:,:,k))
            qcbar(:,:,k) = qceq(:,:,k) - ((qc1(:,:,k) -qc0(:,:,k))/ &
                                                            D_dt(:,:,k))
          elsewhere
            qceq(:,:,k) = qc0(:,:,k) + C_dt(:,:,k)

            qc1 (:,:,k) = qc0(:,:,k) + C_dt(:,:,k)
            qcbar(:,:,k) = qc0(:,:,k) + 0.5*C_dt(:,:,k)
          end where

!------------------------------------------------------------------------
!    set total tendency term and update cloud
!    Note that the amount of SN calculated here is stored in tmp1.
!------------------------------------------------------------------------
          SN(:,:,k) = SN(:,:,k) + qc1(:,:,k) - qc0(:,:,k)
          qn_upd(:,:,k)     = qc1(:,:,k)

!------------------------------------------------------------------------
!    compute the amount each term contributes to the change for diagnostics
!    d2_dt stuff not fully implemented ...
!        where ( C_dt .gt. 0 )
!                Cterm  =  C_dt             
!                Dterm  =  D_dt *      qcbar 
!        elsewhere
!                Cterm  =  0.             
!                Dterm  =  D_dt *      qcbar 
!        end where
!------------------------------------------------------------------------
          if (diag_id%qndt_cond + diag_id%qn_cond_col > 0) then
            where ( C_dt(:,:,k) .gt. 0 )
              diag_4d(:,:,k,diag_pt%qndt_cond) = C_dt(:,:,k)
            elsewhere
              diag_4d(:,:,k,diag_pt%qndt_cond) = 0.
            endwhere
          end if  
       if (Nml%retain_cm3_bug) then
          tmp8(:,:,k) = D_dt(:,:,k)*qcbar(:,:,k)/max(D_dt(:,:,k), Nml%Dmin)
       else
          where (D_dt(:,:,k) > Nml%Dmin) 
          tmp8(:,:,k) = D_dt(:,:,k)*qcbar(:,:,k)/max(D_dt(:,:,k), Nml%Dmin)
          elsewhere
          tmp8(:,:,k) = 0.0              
          endwhere
       endif

          if (diag_id%qndt_pra  + diag_id%qn_pra_col > 0) then
            diag_4d(:,:,k,diag_pt%qndt_pra) =    &
                   Nml%num_mass_ratio1*diag_4d(:,:,k,diag_pt%qndt_pra)* &
                                                    tmp8(:,:,k)*inv_dtcloud
          end if
          if (diag_id%qndt_auto  + diag_id%qn_auto_col > 0) then
            diag_4d(:,:,k,diag_pt%qndt_auto) =   &
                   Nml%num_mass_ratio1*diag_4d(:,:,k,diag_pt%qndt_auto)* &
                                                   tmp8(:,:,k) *inv_dtcloud
          end if
          if (diag_id%qndt_berg  + diag_id%qn_berg_col > 0) then
            diag_4d(:,:,k,diag_pt%qndt_berg) =  &
                 Nml%num_mass_ratio2*diag_4d(:,:,k,diag_pt%qndt_berg)*   &
                                                   tmp8(:,:,k) *inv_dtcloud
          end if
          if (diag_id%qndt_eros  + diag_id%qn_eros_col > 0) then
            diag_4d(:,:,k,diag_pt%qndt_eros) = -D_eros(:,:,k)*  &
                                                   tmp8(:,:,k)*inv_dtcloud
          end if
        end if  ! (Nml%do_liq_num)

        if (Nml%do_liq_num) then
          if (diag_id%qndt_cond + diag_id%qn_cond_col > 0)   &
                   diag_4d(:,:,k,diag_pt%qndt_cond) =   &
                               diag_4d(:,:,k,diag_pt%qndt_cond)*inv_dtcloud
          if (diag_id%qndt_evap + diag_id%qn_evap_col > 0)   &
                   diag_4d(:,:,k,diag_pt%qndt_evap) =   &
                              diag_4d(:,:,k,diag_pt%qndt_evap)*inv_dtcloud 
        endif  

!----------------------------------------------------------------------! 
!                                                                      !
!                                END OF                                !
!                                                                      !
!                       LIQUID PHASE MICROPHYSICS                      !
!                                                                      !
!                                 AND                                  !
!                                                                      !
!                  ANALYTIC INTEGRATION OF QL EQUATION                 !
!                                                                      !
!                               SECTION                                !
!                                                                      !
!                                                                      !
!                                                                      !
!----------------------------------------------------------------------!


!----------------------------------------------------------------------!
!                                                                      !
!                                                                      !
!                                                                      !
!                        ICE PHASE MICROPHYSICS                        !
!                                                                      !
!                                 AND                                  !
!                                                                      !
!                  ANALYTIC INTEGRATION OF QI EQUATION                 !
!                                                                      !
!                                                                      !
!                                                                      !
!       Ice settling
!
!       Ice settling is treated as in Heymsfield Donner 1990. 
!       The mass weighted fall speed is parameterized as in equation
!       #49.
!
!       In terms of the analytic integration with respect qi of Tiedtke,
!       the flux in from the top of the grid layer is equated to the
!       source term, and the flux out of the bottom of the layer is 
!       equated to the sink term:
!
!  (47) C_dt =  snow_cld * dtcloud * grav / deltp
!
!  (48) D_dt =  airdens * grav * Vfall * dtcloud / deltp
!
!       All ice crystals are assumed to fall with the same fall speed
!       which is given as in Heymsfield and Donner (1990) as:
!
!  (49) Vfall = 3.29 * ( (airdens*qi_mean/qa_mean)**0.16)
!
!       which is the formula in Heymsfield and Donner.  Note however
!       that because this is uncertain, sensitivity runs will be made
!       with different formulations. Note that when Vfall is computed 
!       the source incremented qi, qi_mean, is used.  This gives some 
!       implicitness to the scheme.
!------------------------------------------------------------------------

!------------------------------------------------------------------------
!    compute Vfall
!------------------------------------------------------------------------
        where (qi_mean(:,:,k) > 0.0) 
          Vfall(:,:,k) = Nml%vfact*3.29*((airdens(:,:,k) *qi_mean(:,:,k)/ &
                                     max(qa_mean(:,:,k), Nml%qmin))**0.16)
        elsewhere
          Vfall(:,:,k) = 0.
        end where
        if (diag_id%vfall > 0) diag_4d(:,:,k,diag_pt%vfall) = Vfall(:,:,k)* qa_mean(:,:,k)

!------------------------------------------------------------------------
!    add to ice source the settling ice flux from above
!    also note that tmp3 contains the source of liquid converted to ice 
!    from above
!------------------------------------------------------------------------
        C_dt(:,:,k) = tmp3(:,:,k) + snow_cld(:,:,k)*dtcloud/deltpg(:,:,k)
        
!------------------------------------------------------------------------
!    Compute settling of ice. The result is multiplied by dtcloud/deltp to
!    convert to units of D_dt. Note that if tracers are not advected then 
!    this is done relative to the local vertical motion.
!------------------------------------------------------------------------
        if (Nml%tracer_advec) then
          tmp1(:,:,k) = 0.
        else
          tmp1(:,:,k) = omega(:,:,k)
        end if 
        
        where (qi_mean(:,:,k) .gt. Nml%qmin .and.   &
               qa_mean(:,:,k) .gt. Nml%qmin)
          D1_dt(:,:,k) = max(0., ((airdens(:,:,k)*Vfall(:,:,k)) +   &
                                (tmp1(:,:,k)/grav))*dtcloud/deltpg(:,:,k) )
          a_snow_cld(:,:,k) = qa_mean(:,:,k)     
        elsewhere
          D1_dt(:,:,k)      = 0.
          snow_cld(:,:,k)   = 0.
          a_snow_cld(:,:,k) = 0.    
        end where 

!-------------------------------------------------------------------------
!       Melting of in-cloud ice
!
!       Melting occurs where the temperature is greater than Tfreezing. 
!       This is an instaneous process such that no stratiform ice will
!       remain in the grid at the end of the timestep. 
!       No ice settles out of the grid box (i.e. D1 is set to zero) when
!       the amount of ice to be melted is less than that that would
!       bring the grid box to the freezing point.
!
!       The ice that melts becomes rain.  This is because if an ice
!       crystal of dimension ~100 microns and mass density of 100 kg/m2
!       melts it will become a droplet of SIZE 40 microns which is 
!       clearly a drizzle SIZE drop.  Ice crystals at temperatures near 
!       freezing are assumed to be this large, consistent with the 
!       assumption of particle SIZE temperature dependence.
!------------------------------------------------------------------------

!------------------------------------------------------------------------
!    compute grid mean change in cloud ice to cool the grid box to 0C 
!    and store in temporary variable tmp1
!------------------------------------------------------------------------
        tmp1(:,:,k) = cp_air*(T(:,:,k)-tfreeze)/hlf

!-------------------------------------------------------------------------
!    If qi_mean > tmp1, then the amount of ice melted is limited to tmp1, 
!    otherwise melt all qi_mean.  The amount melted is stored in tmp2
!------------------------------------------------------------------------
        tmp2(:,:,k)  = max(min(qi_mean(:,:,k), tmp1(:,:,k)),0.)     
        D2_dt(:,:,k) = max(0., log(max(qi_mean(:,:,k),Nml%qmin)/   &
                              max(qi_mean(:,:,k) - tmp2(:,:,k), Nml%qmin)))
            
!-----------------------------------------------------------------------
!    melting of ice adds area to a_rain_cld
!-----------------------------------------------------------------------
        where (D2_dt(:,:,k) .gt. Nml%Dmin) 
          a_rain_cld(:,:,k) = qa_mean(:,:,k)
        endwhere
                  
!------------------------------------------------------------------------
!    If all of the ice can melt, then don't permit any ice to fall out of
!    the grid box and set a_snow_cld to zero.
!-------------------------------------------------------------------------
        where (qi_mean(:,:,k) .lt. tmp1(:,:,k) .and.   &
               qi_mean(:,:,k) .gt. Nml%qmin) 
          D1_dt(:,:,k) = 0.
          snow_cld(:,:,k) = 0.
          a_snow_cld(:,:,k) = 0.
        end where
         
!------------------------------------------------------------------------
!       Analytic integration of qi equation
!
!       This repeats the procedure done for the ql equation.
!       See above notes for detail.

        !At this point C_dt already includes the source of cloud ice 
        !falling from above as well as liquid converted to ice. 
        !Therefore add in large_scale deposition.
        !
        !Compute D_dt which has contributions from D1_dt (ice settling)
        !and D2_dt (ice melting), D_eros (cloud erosion), and large-
        !scale sublimation (note use of qi mean).
!-----------------------------------------------------------------------
        C_dt(:,:,k) = C_dt(:,:,k) + max(dcond_ls_ice(:,:,k), 0.)
        sum_cond(:,:,k) =  max(dcond_ls_ice(:,:,k), 0.)*inv_dtcloud
        D_dt(:,:,k) = D1_dt(:,:,k) + D2_dt(:,:,k) + D_eros(:,:,k) +   &
                       (max(-1.*dcond_ls_ice(:,:,k), 0.)/   &
                                max(qi_mean(:,:,k), Nml%qmin))
        
!-----------------------------------------------------------------------
!    do analytic integration      
!-----------------------------------------------------------------------
        where ( D_dt(:,:,k).gt.Nml%Dmin ) 
          qc0(:,:,k) = qi_upd(:,:,k)
          qceq(:,:,k) = C_dt(:,:,k)/D_dt(:,:,k)
          qc1(:,:,k) = qceq(:,:,k) - (qceq(:,:,k) - qc0(:,:,k))*  &
                                                  exp( -1.* D_dt(:,:,k) )
          qcbar(:,:,k) = qceq(:,:,k) - ((qc1(:,:,k) - qc0(:,:,k))/  &
                                                             D_dt(:,:,k))
        elsewhere
          qc0(:,:,k) = qi_upd(:,:,k)
          qceq(:,:,k) = qc0(:,:,k)+ C_dt(:,:,k)   
          qc1(:,:,k) = qc0(:,:,k) + C_dt(:,:,k)
          qcbar(:,:,k) = qc0(:,:,k) + 0.5*C_dt(:,:,k)
        end where

!-----------------------------------------------------------------------
!    set total tendency term and update cloud
!    Note that the amount of SL calculated here is stored in tmp1.
!-----------------------------------------------------------------------
        SI (:,:,k) = SI(:,:,k) + qc1(:,:,k) - qc0(:,:,k)
        tmp1(:,:,k) = qc1(:,:,k) - qc0(:,:,k)        
        qi_upd(:,:,k) = qc1(:,:,k)

!-----------------------------------------------------------------------
!    compute the amount each term contributes to the change     
!    Apportion SI between various processes.  This is necessary to
!    account for how much the temperature and water vapor changes 
!    due to various phase changes.   For example:
!
!    ice settling = (D1/D)*(-Dterm)*deltp/grav/dtcloud
!                     
!    vapor to ice =
!           -{ ((-dcond_ls_ice/qi_mean)+D_eros)/ D }*(-Dterm) 
!           where dcond_ls_ice  < 0. 
!
!    but
!    vapor to ice =
!           dcond_ls_ice -(D_eros/D)* (-Dterm)
!           where dcond_ls_ice > 0.
!       
!    melting of ice = (D2/D)*(-Dterm)*deltp/grav/dtcloud
!-----------------------------------------------------------------------

!------------------------------------------------------------------------
!    initialize tmp2 to hold (-Dterm)/D
!------------------------------------------------------------------------
   if (Nml%retain_cm3_bug) then
        tmp2 (:,:,k) = D_dt(:,:,k)*qcbar(:,:,k)/max(D_dt(:,:,k), Nml%Dmin)
   else
       where (D_dt(:,:,k) > Nml%Dmin)
          tmp2(:,:,k) = D_dt(:,:,k)*qcbar(:,:,k)/max(D_dt(:,:,k), Nml%Dmin)
      elsewhere
          tmp2(:,:,k) = 0.0
      endwhere
   endif

!------------------------------------------------------------------------
!    do phase changes from large-scale processes 
!------------------------------------------------------------------------
        ST(:,:,k) = ST(:,:,k) + hls*max(dcond_ls_ice(:,:,k) ,0.)/cp_air - &
                         hls*(max(-1.*dcond_ls_ice(:,:,k), 0.)/   &
                         max(qi_mean(:,:,k), Nml%qmin))*tmp2(:,:,k)/cp_air
        SQ(:,:,k)  = SQ(:,:,k) - max(dcond_ls_ice(:,:,k) ,0.) +       &
                         (max(-1.*dcond_ls_ice(:,:,k), 0.)/  &
                                max(qi_mean(:,:,k), Nml%qmin))*tmp2(:,:,k) 

!------------------------------------------------------------------------
!    cloud erosion changes temperature and vapor
!------------------------------------------------------------------------
        ST(:,:,k) = ST(:,:,k) - hls*D_eros(:,:,k)*tmp2(:,:,k)/cp_air
        SQ(:,:,k) = SQ (:,:,k) + D_eros(:,:,k)*tmp2(:,:,k) 
 
!-----------------------------------------------------------------------
!    add settling ice flux to snow_cld 
!-----------------------------------------------------------------------
        snow_cld(:,:,k) = D1_dt(:,:,k)*tmp2(:,:,k)*deltpg(:,:,k)*  &
                                                               inv_dtcloud
       
!-----------------------------------------------------------------------
!    add melting of ice to temperature tendency
!-----------------------------------------------------------------------
        ST(:,:,k) = ST(:,:,k) - hlf*D2_dt(:,:,k)*tmp2(:,:,k)/cp_air

!-----------------------------------------------------------------------
!    add melting of ice to the rainflux
!-----------------------------------------------------------------------
        rain_cld(:,:,k) = rain_cld(:,:,k) + D2_dt(:,:,k)*tmp2(:,:,k)*  &
                                                deltpg(:,:,k)*inv_dtcloud

!------------------------------------------------------------------------
!    diagnostics for cloud ice tendencies
!------------------------------------------------------------------------
        if (diag_id%qidt_dep + diag_id%qi_dep_col > 0)      &
                  diag_4d (:,:,k,diag_pt%qidt_dep) =   &
                                  max(dcond_ls_ice(:,:,k), 0.)*inv_dtcloud
        if (diag_id%qidt_subl + diag_id%qi_subl_col > 0)   &
                  diag_4d(:,:,k,diag_pt%qidt_subl) =   &
                        -(max(0., -1.*dcond_ls_ice(:,:,k) )/   &
                           max(qi_mean(:,:,k), Nml%qmin))*tmp2(:,:,k)  &
                                                              *inv_dtcloud
        if (diag_id%qidt_melt + diag_id%qi_melt_col > 0)    &
                  diag_4d(:,:,k,diag_pt%qidt_melt) = -D2_dt(:,:,k)*  &
                                                   tmp2(:,:,k) *inv_dtcloud
        if (diag_id%qidt_eros + diag_id%qi_eros_col > 0)    &
                  diag_4d(:,:,k,diag_pt%qidt_eros) =  - D_eros(:,:,k)*  &
                                                   tmp2(:,:,k) *inv_dtcloud
        
!----------------------------------------------------------------------! 
!                                                                      !
!                                END OF                                !
!                                                                      !
!                        ICE PHASE MICROPHYSICS                        !
!                                                                      !
!                                 AND                                  !
!                                                                      !
!                  ANALYTIC INTEGRATION OF QI EQUATION                 !
!                                                                      !
!                                 SECTION                              !
!                                                                      !
!                                                                      !
!                                                                      !
!----------------------------------------------------------------------!



!-----------------------------------------------------------------------
!
!
!
!                       RAIN EVAPORATION
!                           
!
!       Rain evaporation is derived by integration of the growth 
!       equation of a droplet over the assumed Marshall-Palmer 
!       distribution of rain drops (equation #22).  This leads to the 
!       following formula:
!
!  (50) dqv/dt_local =  56788.636 * {rain_rate/dens_h2o}^(11/18) *(1-U)/
!
!                      ( SQRT(airdens)* A_plus_B)
!
!       Numerically this equation integrated by use of time-centered
!       values for qs and qv.   This leads to the solution:
!
!  (51) qv_clr(t+1)-qv_clr(t) = K3 *[qs(t)-qv_clr(t)]/
!                               {1.+0.5*K3*(1+gamma)}
!       where 
!
!       K3= 56788.636 * dtcloud * {rain_rate_local/dens_h2o}^(11/18) /
!           ( SQRT(airdens)* A_plus_B * qs)
!
!       and gamma is given by (3). Note that in (51), it is made 
!       explicit that it is the vapor concentration in the unsaturated 
!       part of the grid box that is used in the rain evaporation 
!       formula.
!
!       Now there are several limiters to this formula. First,
!       you cannot evaporate more than is available in a time step.
!       The amount available for evaporation locally is 
!       (rain_clr/a_rain_clr)*(grav*dtcloud/deltp).   Second, to
!       avoid supersaturating the box or exceeding the critical
!       relative humidity above which rain does not evaporate, 
!       the amount of evaporation is limited.
!
!       Finally rain evaporation occurs only if the relative humidity
!       in the unsaturated portion of the grid box, U_clr, is less
!       then a threshold, U_evap.   U_evap, will not necessarily be
!       one.   For example, stratiform precipitation in convective
!       regions rarely saturates subcloud air because of the presence
!       of downdrafts.  If the convection scheme does not have down-
!       drafts then it doesn't make sense to allow the sub-cloud layer
!       to saturate. U_clr may be solved from (8) as:
!
!  (52) U_clr = ( U - qa ) / (1. - qa)
!
!       Some variables are temporarily stored in tmp1.
!
!       Note that for pdf clouds the relative humidity in the clear part
!       of the grid box can be calculated exactly from the beta distr-
!       ibution. 
!------------------------------------------------------------------------

!------------------------------------------------------------------------
!    compute U_clr. keep U_clr > 0. and U_clr < 1.
!------------------------------------------------------------------------
        if (.not. Nml%do_pdf_clouds) then 
          where (snow_clr(:,:,k) > 0. .or.   &
                 rain_clr(:,:,k) > 0. )           
            U_clr(:,:,k) = (U(:,:,k) - qa_mean(:,:,k))/  &
                                      max((1. - qa_mean(:,:,k)), Nml%qmin)
          elsewhere
            U_clr(:,:,k) = 0.
          end where
        else
          U_clr(:,:,k) = qvg(:,:,k)/qs(:,:,k)
        end if
        U_clr(:,:,k) = min(max(U_clr(:,:,k), 0.), 1.)
        
!------------------------------------------------------------------------
!    compute K3
!------------------------------------------------------------------------
        where (rain_clr(:,:,k) > 0)
          tmp1(:,:,k) = 56788.636*dtcloud*((rain_clr(:,:,k)/   &
                            max(a_rain_clr(:,:,k), Nml%qmin)/  &
                                           dens_h2o)**(11./18.))/  &
                            SQRT(airdens(:,:,k))/A_plus_B(:,:,k)/qs(:,:,k)

!------------------------------------------------------------------------
!    compute local change in vapor mixing ratio due to rain evaporation
!------------------------------------------------------------------------
          tmp1(:,:,k) = tmp1(:,:,k)*qs(:,:,k)*(1. - U_clr(:,:,k))/  &
                               (1. + 0.5*tmp1(:,:,k)*(1. + gamma(:,:,k)))

!------------------------------------------------------------------------
!    limit change in qv to the amount that would raise the relative
!    humidity to U_evap in the clear portion of the grid box
!------------------------------------------------------------------------
          tmp1(:,:,k) = min(tmp1(:,:,k), ((1.-qa_mean(:,:,k))/  &
                            max(a_rain_clr(:,:,k), Nml%qmin))*qs(:,:,k)* &
                          max(0. ,Nml%U_evap-U_clr(:,:,k))/  &
                            (1. + (Nml%U_evap*(1. - qa_mean(:,:,k)) +  &
                                           qa_mean(:,:,k))*gamma(:,:,k)) )
        
!------------------------------------------------------------------------
!    do limiter by amount available
!------------------------------------------------------------------------
          tmp1(:,:,k) = tmp1(:,:,k)*a_rain_clr(:,:,k)*  &
                                                 deltpg(:,:,k)*inv_dtcloud
          tmp2(:,:,k) = max(min(rain_clr(:,:,k), tmp1(:,:,k)), 0.)
    
          SQ(:,:,k) = SQ(:,:,k) + tmp2(:,:,k)*dtcloud/deltpg(:,:,k)
          ST(:,:,k) = ST(:,:,k) - hlv*tmp2(:,:,k)*dtcloud/   &
                                                      deltpg(:,:,k)/cp_air
        elsewhere
          tmp1(:,:,k) = 0.
          tmp2(:,:,k) = 0.
        end where
                                                        
!------------------------------------------------------------------------
!    if all of the rain evaporates set things to zero.    
!------------------------------------------------------------------------
        where (tmp1(:,:,k) .gt. rain_clr(:,:,k) .and.    &
               a_rain_clr(:,:,k) .gt. Nml%qmin)         
          rain_clr(:,:,k) = 0.
          a_rain_clr(:,:,k) = 0.
        elsewhere
          rain_clr(:,:,k) = rain_clr(:,:,k) - tmp2 (:,:,k)    
        endwhere
        
!------------------------------------------------------------------------
!    save evaporation diagnostics
!------------------------------------------------------------------------
        if (diag_id%rain_evap + diag_id%rain_evap_col > 0)     &
              diag_4d(:,:,k,diag_pt%rain_evap) = tmp2(:,:,k)/deltpg(:,:,k)

!-----------------------------------------------------------------------
!
!
!
!                              SNOW SUBLIMATION
!                           
!
!       Sublimation of cloud ice
!
!       [The following follows Rotstayn (1997)]
!       Given the assumptions of the Marshall-Palmer distribution of
!       ice crystals (18), the crystal growth equation as a function
!       of the humidity of the air and the diffusivity of water vapor
!       and thermal conductivity of air is integrated over all crystal
!       sizes.   This yields:
!
!  (53) dqi/dt_local = - a_snow_clr* K3 * (qs - qv_clr)
!
!       where the leading factor of a_snow_clr is the portion of the
!       grid box undergoing sublimation. K3 is given by
!
!  (54) K3 = (4/(pi*rho_air*qs*rho_ice*A_plus_B))*
!            ((snow_clr/a_snow_clr/3.29)**1.16 ) *
!           [ 0.65*lamda_f^2 + 
!             198.92227 * (airdens)^0.5 * 
!             ((snow_clr/a_snow_clr)**(1/14.5)) * lamda_f^(3/2) ]
!
!       Note that equation (53) is identical to equation (30) of 
!       Rotstayn.
!
!       Numerically this is integrated as in rain evaporation.
!-------------------------------------------------------------------------
        where (snow_clr(:,:,k) > 0.0) 

!-------------------------------------------------------------------------
!    compute K3.
!-------------------------------------------------------------------------
          tmp1(:,:,k) = dtcloud*(4./3.14159/rho_ice/airdens(:,:,k)/       &
                        A_plus_B(:,:,k)/qs(:,:,k))*((snow_clr(:,:,k)/  &
                       max(a_snow_clr(:,:,k), Nml%qmin)/3.29)**(1./1.16))*&
                        (0.65*lamda_f(:,:,k)*lamda_f(:,:,k) +         &
                            198.92227*lamda_f(:,:,k)*  &
                                  SQRT(airdens(:,:,k)*lamda_f(:,:,k))*   &
                                          ( (snow_clr(:,:,k)/    &
                           max(a_snow_clr(:,:,k),Nml%qmin))**(1./14.5) )  )

!-------------------------------------------------------------------------
!    compute local change in vapor mixing ratio due to snow sublimation.
!-------------------------------------------------------------------------
          tmp1(:,:,k) = tmp1(:,:,k)*qs(:,:,k)*(1. - U_clr(:,:,k))/  &
                                (1. + 0.5*tmp1(:,:,k)*(1. + gamma(:,:,k)))

!-------------------------------------------------------------------------
!    limit change in qv to the amount that would raise the relative
!    humidity to U_evap in the clear portion of the grid box
!-------------------------------------------------------------------------
          tmp1 (:,:,k) = min(tmp1(:,:,k), ((1. - qa_mean(:,:,k))/  &
                           max(a_snow_clr(:,:,k), Nml%qmin))*qs(:,:,k)* &
                           max(0., Nml%U_evap  -U_clr(:,:,k))/  &
                               (1. + (Nml%U_evap*(1. - qa_mean(:,:,k)) + &
                                           qa_mean(:,:,k))*gamma(:,:,k)) )
        
!-------------------------------------------------------------------------
!    do limiter by amount available
!-------------------------------------------------------------------------
          tmp1(:,:,k) = tmp1(:,:,k)*a_snow_clr(:,:,k)*    &
                                                deltpg(:,:,k)*inv_dtcloud
        elsewhere
          tmp1(:,:,k)= 0.0
        endwhere
        tmp2(:,:,k) = max(min(snow_clr(:,:,k), tmp1(:,:,k)), 0.)
        SQ(:,:,k) = SQ(:,:,k) + tmp2(:,:,k)*dtcloud/deltpg(:,:,k)
        ST(:,:,k) = ST(:,:,k) - hls*tmp2(:,:,k)*dtcloud/deltpg(:,:,k)/  &
                                                                    cp_air

!-------------------------------------------------------------------------
!    if all of the snow sublimates set things to zero.    
!-------------------------------------------------------------------------
        where (tmp1(:,:,k) .gt. snow_clr(:,:,k) .and.   &
               a_snow_clr(:,:,k) .gt. Nml%qmin)         
          snow_clr(:,:,k) = 0.
          a_snow_clr(:,:,k) = 0.
        elsewhere
          snow_clr(:,:,k) = snow_clr(:,:,k) - tmp2(:,:,k)     
        endwhere
         
!-------------------------------------------------------------------------
!    save snow sublimation diagnostics.
!-------------------------------------------------------------------------
        if  (diag_id%qdt_snow_sublim + diag_id%q_snow_sublim_col > 0)     &
              diag_4d(:,:,k,diag_pt%qdt_snow_sublim) = tmp2(:,:,k)/deltpg(:,:,k) 
       
!------------------------------------------------------------------------
!    save diagnostics for the predicted cloud tendencies so that 
!    destruction diagnostics may be computed after adjustment is done.
!------------------------------------------------------------------------
        if (diag_id%qadt_destr + diag_id%qa_destr_col > 0)    &
               diag_4d(:,:,k,diag_pt%qadt_destr) =    &
                 diag_4d(:,:,k,diag_pt%qadt_destr) + SA(:,:,k) *inv_dtcloud
        if   (diag_id%qldt_destr + diag_id%ql_destr_col > 0)    &
              diag_4d(:,:,k,diag_pt%qldt_destr) =   &
                 diag_4d(:,:,k,diag_pt%qldt_destr) + SL(:,:,k) *inv_dtcloud
        if   (diag_id%qidt_destr + diag_id%qi_destr_col > 0)    &
               diag_4d(:,:,k,diag_pt%qidt_destr) =   &
                 diag_4d(:,:,k,diag_pt%qidt_destr) + SI(:,:,k)*inv_dtcloud
        if   (diag_id%qndt_destr + diag_id%qn_destr_col > 0 .and.    &
                    Nml%do_liq_num )      &
                diag_4d(:,:,k,diag_pt%qndt_destr) = &
                 diag_4d(:,:,k,diag_pt%qndt_destr) + SN(:,:,k)*inv_dtcloud
      
!-----------------------------------------------------------------------
!    adjustment to try to prevent negative water vapor. adjustment will not
!    remove more condensate than available. cloud amount is not adjusted. 
!    this is left for the remainder of the destruction code. (cjg)
!    tmp1 = updated vapor
!    tmp2 = liquid which can be evaporated
!    tmp3 = ice which can be sublimated
!-----------------------------------------------------------------------
        tmp1(:,:,k) = qv(:,:,k) + SQ(:,:,k)
        tmp2(:,:,k) = 0.0
        tmp3(:,:,k) = 0.0
        where ( tmp1(:,:,k).lt.0.0 .and. T(:,:,K).le.tfreeze-40.)
          tmp2(:,:,k) = min( -tmp1(:,:,k), ql_upd(:,:,k) ) 
          tmp3 (:,:,k) = min( -tmp1(:,:,k) - tmp2(:,:,k), qi_upd(:,:,k) ) 
          ql_upd(:,:,k) = ql_upd (:,:,k) - tmp2(:,:,k)
          qi_upd(:,:,k) = qi_upd(:,:,k) - tmp3(:,:,k)
          SL(:,:,k) = SL(:,:,k) - tmp2(:,:,k)
          SI(:,:,k) = SI(:,:,k) - tmp3(:,:,k)
          SQ(:,:,k) = SQ(:,:,k) + tmp2(:,:,k) + tmp3(:,:,k)
          ST(:,:,k) = ST(:,:,k) - hlv*tmp2(:,:,k)/cp_air -   &
                                               hls*tmp3(:,:,k)/cp_air
        end where
        where ( tmp1(:,:,k).lt.0.0 .and. T(:,:,k).gt.tfreeze-40.)
          tmp3(:,:,k) = min( -tmp1(:,:,k), qi_upd(:,:,k) ) 
          tmp2(:,:,k) = min( -tmp1(:,:,k) - tmp3(:,:,k), ql_upd(:,:,k) )
          ql_upd(:,:,k) = ql_upd(:,:,k) - tmp2(:,:,k)
          qi_upd(:,:,k) = qi_upd(:,:,k) - tmp3(:,:,k)
          SL(:,:,k) = SL(:,:,k) - tmp2(:,:,k)
          SI(:,:,k) = SI(:,:,k) - tmp3(:,:,k)
          SQ(:,:,k) = SQ(:,:,k) + tmp2(:,:,k) + tmp3(:,:,k)
          ST(:,:,k) = ST(:,:,k) - hlv*tmp2(:,:,k)/cp_air -    &
                                               hls*tmp3(:,:,k)/cp_air
        end where
      end do !  (big k loop) 

!-----------------------------------------------------------------------
!    cloud destruction occurs where both ql and qi are .le. qmin, or if 
!    qa is .le. qmin. In this case, ql, qi, and qa are set to zero 
!    conserving moisture and energy.
!-----------------------------------------------------------------------
      if (.not.Nml%do_liq_num) then
        where ((ql_upd .le. Nml%qmin .and. qi_upd .le. Nml%qmin) .or.   &
               (qa_upd .le. Nml%qmin))
          SL = SL - ql_upd 
          SI = SI - qi_upd 
          SQ = SQ + ql_upd + qi_upd 
          ST = ST - (hlv*ql_upd + hls*qi_upd )/cp_air
          SA = SA  - qa_upd 
          ql_upd = 0.0
          qi_upd = 0.0
          qa_upd = 0.0
        end where
      else
        where ((ql_upd .le. Nml%qmin .and. qi_upd .le. Nml%qmin) .or.  &
               (qa_upd .le. Nml%qmin))
          SL = SL - ql_upd 
          SI = SI - qi_upd 
          SQ = SQ + ql_upd + qi_upd 
          ST = ST - (hlv*ql_upd + hls*qi_upd)/cp_air
          SA = SA - qa_upd 
          SN = SN - qn_upd 
          ql_upd = 0.0
          qi_upd = 0.0
          qa_upd = 0.0
          qn_upd = 0.0
        end where
      endif  

!------------------------------------------------------------------------
!    save destruction diagnostics.
!------------------------------------------------------------------------
      if   (diag_id%qadt_destr + diag_id%qa_destr_col > 0)   &
               diag_4d(:,:,:,diag_pt%qadt_destr) =    &
                     diag_4d(:,:,:,diag_pt%qadt_destr) - SA*inv_dtcloud
      if   (diag_id%qldt_destr + diag_id%ql_destr_col > 0)    &
               diag_4d(:,:,:,diag_pt%qldt_destr) =   &
                     diag_4d(:,:,:,diag_pt%qldt_destr) - SL*inv_dtcloud
      if   (diag_id%qidt_destr + diag_id%qi_destr_col > 0) &
               diag_4d(:,:,:,diag_pt%qidt_destr) =    &
                    diag_4d(:,:,:,diag_pt%qidt_destr) - SI*inv_dtcloud
      if   (diag_id%qndt_destr + diag_id%qn_destr_col > 0)    &
               diag_4d(:,:,:,diag_pt%qndt_destr) =   &
                    diag_4d(:,:,:,diag_pt%qndt_destr) - SN*inv_dtcloud
                                                           
!-----------------------------------------------------------------------
!
!       Adjustment.  Due to numerical errors in detrainment or advection
!       sometimes the current state of the grid box may be super-
!       saturated. Under the assumption that the temperature is constant
!       in the grid box and that q <= qs, the excess vapor is condensed. 
!       
!       What happens to the condensed water vapor is determined by the
!       namelist parameter super_choice.
!
!       If super_choice = .false. (default), then the condensed water is
!       is added to the precipitation fluxes.  If super_choice = .true.,
!       then the condensed water is added to the cloud condensate field.
!       Note that in this case the cloud fraction is raised to one.
!
!       The phase partitioning depends on super_choice; if super_choice
!       is false then at T < -20C, snow is produced.  If super_choice
!       is true, then at T < -40C, ice is produced.  The latter choice 
!       is consistent with that done in the large-scale condensation
!       section above.        
!
!       If pdf clouds are operating then this section is bypassed - 
!       as statistical clouds should remove supersaturation according
!       to the beta distribution used.
!------------------------------------------------------------------------
      if (.not.Nml%do_pdf_clouds) then

!-------------------------------------------------------------------------
!    updated temperature in tmp8, updated qs in tmp2,  
!    updated gamma in tmp3, updated dqsdT in tmp5
!------------------------------------------------------------------------
        tmp8 = T + ST
        IF (rk_alt_adj_opt .and. Nml%super_choice ) THEN
          where ( tmp8 > tfreeze - 40. )      
            est_a = polysvp_l(tmp8, idim, jdim, kdim)   

!------------------------------------------------------------------------
!    calculate denominator in qsat formula
!    limit denominator to esat, and thus qs to d622
!    this is done to avoid blow up in the upper stratosphere
!    where pfull ~ esat  
!------------------------------------------------------------------------
            qs_d_a = pfull - d378*est_a
            qs_d_a = max(qs_d_a, est_a) 
            tmp2s_a = d622*est_a/qs_d_a 
            tmp5s_a = hlv*tmp2s_a/(rvgas*tmp8**2)
            tmp3s_a = tmp5s_a*hlv/cp_air

!-------------------------------------------------------------------------
!     calculate excess water vapor
!-------------------------------------------------------------------------
            tmp1 = max(0., qv + SQ - tmp2s_a)/(1. + tmp3s_a)
          elsewhere
            est_a = polysvp_i  (tmp8, idim, jdim,kdim)   

!------------------------------------------------------------------------
!    calculate denominator in qsat formula
!    limit denominator to esat, and thus qs to d622
!    this is done to avoid blow up in the upper stratosphere
!    where pfull ~ esat  
!------------------------------------------------------------------------
            qs_d_a = pfull - d378*est_a
            qs_d_a = max(qs_d_a, est_a) 
            tmp2s_a = d622*est_a/qs_d_a 
            tmp5s_a = hls*tmp2s_a/(rvgas*tmp8**2)
            tmp3s_a = tmp5s_a*hls/cp_air

!-------------------------------------------------------------------------
!     calculate excess water vapor
!-------------------------------------------------------------------------
            tmp1 = max(0., qv + SQ - tmp2s_a)/(1. + tmp3s_a)
          end where
        ELSE ! rk_alt_adj_if

!------------------------------------------------------------------------
!RSH 10/28/10 -- proposal -- needs additional investigation
!RSH to avoid having non-saturation after adjustment, the value of L used 
!    here must agree with that used below when adjustments made to ST due 
!    to condensation of the supersaturated vapor.
!    Therefore compute_qs should be called with optional 
!    argument esat_over_liq = .true. when t > tcrit  (-40 C when 
!    super_choice is .true.,  -20 C when .false.), and without the optional
!    argument when t is cooler than tcrit, so that in that case es is 
!    calculated wrt to ice. then hlv would be used for temps above -40C 
!    and hls used at t < -40C, consistent with the ST terms below, and the 
!    condition for an increase in droplet number below.
!
!   NOTE: this requires setting sat_vapor_pres_nml variable
!            construct_table_wrt_liq = .true.
!    so that es table wrt liquid at all temps is computed.
!
!   NOTE: The above is essentially what rk_alt_adj_opt is doing, but
!   with different formulae for es.
!------------------------------------------------------------------------
!         if (use_inconsistent_lh) then
            call compute_qs (tmp8, pfull, tmp2, dqsdT=tmp5)
            tmp3 = tmp5*(min(1., max(0.,     &
                                   0.05*(tmp8 - tfreeze + 20.)))*hlv +  &
                              min(1., max(0.,    &
                                      0.05*(tfreeze - tmp8)))*hls)/cp_air

!-------------------------------------------------------------------------
!    compute excess over saturation
!-------------------------------------------------------------------------
            tmp1 = max(0., qv + SQ - tmp2)/(1. + tmp3)
!RSH
!         else
!           if (Nml%super_choice) then
!             tcrit = tfreeze - 40.
!           else
!             tcrit = tfreeze - 20.
!           endif
!           call compute_qs (tmp8, pfull, tmp2, dqsdT=tmp5,  &
!                                                   es_over_liq = .true.)
!           where (tmp8 > tcrit) 
!             tmp3 = tmp5*hlv/cp_air
!-------------------------------------------------------------------------
!    compute excess over saturation
!-------------------------------------------------------------------------
!             tmp1 = max(0., qv + SQ - tmp2)/(1. + tmp3)
!           endwhere
!           call compute_qs (tmp8, pfull, tmp2, dqsdT=tmp5)
!           where (tmp8 <= tcrit) 
!             tmp3 = tmp5*hls/cp_air
!-------------------------------------------------------------------------
!    compute excess over saturation
!-------------------------------------------------------------------------
!             tmp1 = max(0., qv + SQ - tmp2)/(1. + tmp3)
!           end where
!         endif

        END IF !  rk_alt_adj_if

!------------------------------------------------------------------------
!    change vapor content
!------------------------------------------------------------------------
        SQ = SQ - tmp1

!------------------------------------------------------------------------
!    if super_choice is .true., then put supersaturation into cloud,
!------------------------------------------------------------------------
        if (Nml%super_choice) then


!------------------------------------------------------------------------
!    assign additional droplets where supersaturation is predicted. 
!------------------------------------------------------------------------
          if (Nml%do_liq_num) then
            do k=1,kdim
              do j=1,jdim
                do i=1,idim
                  if (T(i,j,k) > tfreeze - 40. .and. &
                      tmp1(i,j,k) > 0.0) then
                    qn_upd(i,j,k) = qn_upd(i,j,k) + drop1(i,j,k)*1.0e6/  &
                                    airdens(i,j,k)*(1. - qa_upd(i,j,k))
                    SN(i,j,k) = SN(i,j,k) + drop1(i,j,k)*1.e6/  &
                                   airdens(i,j,k)*(1.-qa_upd(i,j,k))
                  endif
                end do
              end do
            end do
          endif
          if (diag_id%qndt_super + diag_id%qn_super_col > 0) then
            if (Nml%do_liq_num) then
              where (T .gt. tfreeze - 40. .and. tmp1 .gt. 0.)
                diag_4d(:,:,:,diag_pt%qndt_super) =     &
                         diag_4d(:,:,:,diag_pt%qndt_super) + drop1*1.e6/ &
                                         airdens*(1. - qa_upd)*inv_dtcloud
              endwhere
            endif 
          end if

!------------------------------------------------------------------------
!  THE -40C THRESHOLD IN THE FOLLOWING IS NOT CONSISTENT WITH THE 
!  CALCULATION OF QS ABOVE. IT IS UNPHYSICAL TO ASSUME THE FORMATION OF 
!  SUPERCOOLED DROPLETS BETWEEN QS_ICE AND QS_LIQ! ( ... but similar 
!  assumptions are occasionally made in cloud cover schemes) 
!  RSH:  this may be addressed by proposed mod of 10/28/10.
!------------------------------------------------------------------------

!------------------------------------------------------------------------
!    add excess condensate to appropriate cloud condensate species. 
!    change cloud area and increment temperature.
!------------------------------------------------------------------------
          do k=1,kdim
            do j=1,jdim
              do i=1,idim
                if (tmp1(i,j,k) .gt. 0.) then
                  if (T(i,j,k) .le. tfreeze - 40.)then
                    qi_upd(i,j,k)   = qi_upd(i,j,k) + tmp1(i,j,k)
                    SI(i,j,k) = SI(i,j,k) + tmp1(i,j,k)
                    ST(i,j,k) = ST(i,j,k) + hls*tmp1(i,j,k)/cp_air
                  else   
                    ql_upd(i,j,k)   = ql_upd(i,j,k) + tmp1(i,j,k)
                    SL(i,j,k) = SL(i,j,k) + tmp1(i,j,k)
                    ST(i,j,k) = ST(i,j,k) + hlv*tmp1(i,j,k)/cp_air      
                  endif
                  if (limit_conv_cloud_frac) then
                    tmp2s = ahuco(i,j,k)
                  else
                    tmp2s = 0.
                  endif
!moved from above:
!------------------------------------------------------------------------
!    cloud fraction source diagnostic
!------------------------------------------------------------------------
          if (diag_id%qadt_super + diag_id%qa_super_col > 0) then
              diag_4d(i,j,k,diag_pt%qadt_super) = (1.-qa_upd(i,j,k)-tmp2s)*inv_dtcloud
          end if
                  SA(i,j,k) = SA(i,j,k) + (1.-qa_upd(i,j,k) - tmp2s)  
                  qa_upd(i,j,k)   = 1. - tmp2s        
                endif
              enddo
            enddo
          enddo
                                                               
!------------------------------------------------------------------------
!    save adjustment diagnostics.
!------------------------------------------------------------------------
            where (T .le. tfreeze - 40.)
              sum_ice_adj(:,:,:) = tmp1*inv_dtcloud
            endwhere
          if (diag_id%liq_adj  + diag_id%liq_adj_col +   &
              diag_id%ice_adj + diag_id%ice_adj_col  > 0) then       
            where (T .le. tfreeze - 40.)
              diag_4d(:,:,:,diag_pt%ice_adj) = tmp1*inv_dtcloud
            elsewhere
              diag_4d(:,:,:,diag_pt%liq_adj) = tmp1*inv_dtcloud
            endwhere
          end if

!-----------------------------------------------------------------------
!    put supersaturation into precip. add in excess to precipitation 
!    fluxes, change their area and increment temperature.
!-----------------------------------------------------------------------
        else
          where (T .le. tfreeze - 20. .and. tmp1 .gt. 0.)
            snow_cld = snow_cld + qa_mean*tmp1*deltpg*inv_dtcloud
            snow_clr = snow_clr + (1. - qa_mean)*tmp1*deltpg*inv_dtcloud
            a_snow_cld = qa_mean
            a_snow_clr = 1. - qa_mean
            ST  = ST + hls*tmp1/cp_air
          end where
          where (T .gt. tfreeze - 20. .and. tmp1 .gt. 0.)    
            rain_cld = rain_cld + qa_mean*tmp1*deltpg*inv_dtcloud
            rain_clr = rain_clr + (1. - qa_mean)*tmp1*deltpg*inv_dtcloud
            a_rain_cld = qa_mean
            a_rain_clr = 1. - qa_mean
            ST  = ST + hlv*tmp1/cp_air
          end where

!-------------------------------------------------------------------------
!    save adjustment diagnostics.
!-------------------------------------------------------------------------
            where (T .le. tfreeze - 20.)
              sum_ice_adj(:,:,:) = tmp1*inv_dtcloud
            endwhere
          if (diag_id%liq_adj + diag_id%liq_adj_col +   &
              diag_id%ice_adj + diag_id%ice_adj_col  > 0) then       
            where (T .le. tfreeze - 20.)
              diag_4d(:,:,:,diag_pt%ice_adj) = tmp1*inv_dtcloud
            elsewhere
              diag_4d(:,:,:,diag_pt%liq_adj) = tmp1*inv_dtcloud
            endwhere
          end if
        end if !super choice
      end if !for Nml%do_pdf_clouds

!------------------------------------------------------------------------
!    complete calculation of the adjustment part of the destruction 
!    diagnostics.
!------------------------------------------------------------------------
      if  (diag_id%qadt_destr + diag_id%qa_destr_col > 0)  &
           diag_4d(:,:,:,diag_pt%qadt_destr) =   &
                      diag_4d(:,:,:,diag_pt%qadt_destr) + SA*inv_dtcloud
      if  (diag_id%qldt_destr + diag_id%ql_destr_col > 0)   &
           diag_4d(:,:,:,diag_pt%qldt_destr) =    &
                      diag_4d(:,:,:,diag_pt%qldt_destr) + SL*inv_dtcloud
      if  (diag_id%qidt_destr + diag_id%qi_destr_col > 0)   &
           diag_4d(:,:,:,diag_pt%qidt_destr) =    &
                      diag_4d(:,:,:,diag_pt%qidt_destr) + SI*inv_dtcloud
      if  (diag_id%qndt_destr + diag_id%qn_destr_col > 0 .and.    &
                                                  Nml%do_liq_num )   &
           diag_4d(:,:,:,diag_pt%qndt_destr) =    &
                      diag_4d(:,:,:,diag_pt%qndt_destr) + SN*inv_dtcloud

!-----------------------------------------------------------------------
!    final clean up to remove numerical noise
!----------------------------------------------------------------------
      ql_upd = ql + SL
      where ( abs(ql_upd) .le. Nml%qmin .and. qv + SQ + ql_upd > 0.0 )    
        SL = -ql
        SQ = SQ + ql_upd
        ST = ST - hlv*ql_upd/cp_air
        ql_upd = 0.0
      end where
      qi_upd = qi + SI
      where ( abs(qi_upd) .le. Nml%qmin .and. qv + SQ + qi_upd > 0.0 )   
        SI = -qi
        SQ = SQ + qi_upd
        ST = ST - hls*qi_upd/cp_air
        qi_upd = 0.0
      end where
      qa_upd = qa + SA
      where ( abs(qa_upd) .le. Nml%qmin )         
        SA  = -qa
        qa_upd = 0.0
      end where

!------------------------------------------------------------------------
!    add the noise elimination contribution to the destruction diagnostics.
!------------------------------------------------------------------------
      if (diag_id%qadt_destr + diag_id%qa_destr_col > 0)    &
           diag_4d(:,:,:,diag_pt%qadt_destr) =    &
                   diag_4d(:,:,:,diag_pt%qadt_destr) - SA*inv_dtcloud
           diag_4d(:,:,:,diag_pt%qadt_destr) =    &
                   -diag_4d(:,:,:,diag_pt%qadt_destr) 
      if (diag_id%qldt_destr + diag_id%ql_destr_col > 0)    &
           diag_4d(:,:,:,diag_pt%qldt_destr) =     &
                   diag_4d(:,:,:,diag_pt%qldt_destr) - SL*inv_dtcloud
      if (diag_id%qidt_destr + diag_id%qi_destr_col > 0)    &
           diag_4d(:,:,:,diag_pt%qidt_destr) =    &
                  -( diag_4d(:,:,:,diag_pt%qidt_destr) - SI*inv_dtcloud)
      if (diag_id%qndt_destr + diag_id%qn_destr_col > 0 .and.    &
                                                    Nml%do_liq_num )  &
           diag_4d(:,:,:,diag_pt%qndt_destr) =    &
                   diag_4d(:,:,:,diag_pt%qndt_destr) - SN *inv_dtcloud
       
      if (diag_id%qldt_destr + diag_id%ql_destr_col > 0)    &
           diag_4d(:,:,:,diag_pt%qldt_destr) =     &
                   -diag_4d(:,:,:,diag_pt%qldt_destr) 
      if (diag_id%qndt_destr + diag_id%qn_destr_col > 0 .and.    &
                                                    Nml%do_liq_num )  &
           diag_4d(:,:,:,diag_pt%qndt_destr) =    &
                   -diag_4d(:,:,:,diag_pt%qndt_destr) 

!-----------------------------------------------------------------------
!    add the ice falling out from cloud to  the qidt_fall diagnostic.
!-----------------------------------------------------------------------
        if (diag_id%qidt_fall + diag_id%qi_fall_col > 0)  &
             diag_4d(:,:,:,diag_pt%qidt_fall) =    &
                      diag_4d(:,:,:,diag_pt%qidt_fall) - (snow_cld/deltpg)
        
!-----------------------------------------------------------------------
!    save output fields of profiles of total rain and snow and clear-sky
!    snow.
!-----------------------------------------------------------------------
      rain3d(:,:,1) = 0.
      snow3d(:,:,1) = 0.
      snowclr3d(:,:,1) = 0.
      do k=1,kdim 
        rain3d(:,:,k+1) = rain_clr(:,:,k) + rain_cld(:,:,k)
        snow3d(:,:,k+1) = snow_clr(:,:,k) + snow_cld(:,:,k)
        snowclr3d(:,:,k+1) = snow_clr(:,:,k)

!-----------------------------------------------------------------------
!    save rain and snow diagnostics
!-----------------------------------------------------------------------
        diag_4d_kp1(:,:,k+1,diag_pt%rain_clr) = rain_clr(:,:,k)
        diag_4d_kp1(:,:,k+1,diag_pt%rain_cld) = rain_cld(:,:,k)
        diag_4d_kp1(:,:,k+1,diag_pt%a_rain_clr) = a_rain_clr(:,:,k)
        diag_4d_kp1(:,:,k+1,diag_pt%a_rain_cld) = a_rain_cld(:,:,k)
        diag_4d_kp1(:,:,k+1,diag_pt% snow_clr) = snow_clr(:,:,k)
        diag_4d_kp1(:,:,k+1,diag_pt%snow_cld) = snow_cld(:,:,k)
        diag_4d_kp1(:,:,k+1,diag_pt%a_snow_clr) = a_snow_clr(:,:,k)
        diag_4d_kp1(:,:,k+1,diag_pt%a_snow_cld) = a_snow_cld(:,:,k)
        diag_4d_kp1(:,:,k+1,diag_pt%a_precip_clr) =   &
                                  max(a_rain_clr(:,:,k),a_snow_clr(:,:,k))
        diag_4d_kp1(:,:,k+1,diag_pt%a_precip_cld) =    &
                                  max(a_rain_cld(:,:,k),a_snow_cld(:,:,k))
      end do

!-----------------------------------------------------------------------
!    put rain and ice fluxes into surfrain and surfsnow if the grid point 
!    is at the bottom of a column. If MASK is not present then this code 
!    is executed only if k .eq. kdim.
!    IF MASK is present some grid points may be beneath ground. If a given
!    grid point is at the bottom of the column then the surface values of
!    rain and snow must be created. Also if the MASK is present then the 
!    code forces all tendencies below ground to be zero. Note that
!    MASK = 1. equals above ground point, MASK = 0. equals below ground 
!    point.
!------------------------------------------------------------------------
      if ( mask_present ) then

!------------------------------------------------------------------------
!    zero out all tendencies below ground
!------------------------------------------------------------------------
        ST = MASK*ST
        SQ = MASK*SQ
        SL = MASK*SL
        SI = MASK*SI
        SA = MASK*SA
        rain3d(:,:,1:kdim) = mask*rain3d(:,:,1:kdim)
        snow3d(:,:,1:kdim) = mask*snow3d(:,:,1:kdim)
        rain3d(:,:,kdim+1) = mask(:,:,kdim)*rain3d(:,:,kdim+1)
        snow3d(:,:,kdim+1) = mask(:,:,kdim)*snow3d(:,:,kdim+1)
        if (Nml%do_liq_num) then
          SN = MASK*SN
        endif

!------------------------------------------------------------------------
!    determine the true bottom of columns which contain some below-ground
!    points. grab that value as surfrain or surfsnow and set the other
!    rain and asnow arrays at that level to 0.
!------------------------------------------------------------------------
        DO k=1,kdim-1
          where(MASK(:,:,k) .eq. 1. .and. MASK(:,:,k+1) .eq. 0.)
            surfrain(:,:) = dtcloud*rain3d(:,:,k+1)
            surfsnow(:,:) = dtcloud*snow3d(:,:,k+1)
          end where
        END DO

!-----------------------------------------------------------------------
!    define the precip at the surface in those columns with no below-ground
!    points.
!-----------------------------------------------------------------------
        where(MASK(:,:,kdim) .eq. 1.)
          surfrain(:,:) = dtcloud*rain3d(:,:,kdim+1)
          surfsnow(:,:) = dtcloud*snow3d(:,:,kdim+1)
        end where
      else

!------------------------------------------------------------------------
!    when mask not present, the surface precip is defined as the values
!    at level kdim.
!------------------------------------------------------------------------
        surfrain(:,:) = dtcloud*rain3d(:,:,kdim+1)
        surfsnow(:,:) = dtcloud*snow3d(:,:,kdim+1)
      end if 
                  
!-----------------------------------------------------------------------
!  Used for BC aerosol in-cloud scavenging:
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            qldt_sum = sum_berg(i,j,k) + sum_rime(i,j,k) +   &
                       sum_ice_adj(i,j,k) + sum_cond(i,j,k) +   &
                       sum_freeze(i,j,k)
            if (qldt_sum > 0.)  then
              f_snow_berg(i,j,k) = (sum_berg(i,j,k) + sum_freeze(i,j,k) + &
                          sum_ice_adj(i,j,k) + sum_cond(i,j,k))/qldt_sum 
            else
              f_snow_berg(i,j,k) = 0.
            endif
          end do
        end do
      end do
        



END SUBROUTINE rotstayn_klein_microp


!########################################################################

SUBROUTINE rotstayn_klein_microp_end

!-----------------------------------------------------------------------
!    call destructors for modules used here.
!-----------------------------------------------------------------------
      call polysvp_end

!-----------------------------------------------------------------------
!    mark the module as uninitialized.
!-----------------------------------------------------------------------
      module_is_initialized = .false.

!----------------------------------------------------------------------

END SUBROUTINE rotstayn_klein_microp_end


!########################################################################

subroutine cloud_clear_xfer (k, Nml, cloud_generator_on, overlap,  &
                             tmp3, qa_mean, a_clr, a_cld, clr, cld)

!---------------------------------------------------------------------
integer,                intent(in)    :: k, overlap
type(strat_nml_type),   intent(in)    :: Nml
logical,                intent(in)    :: cloud_generator_on
real, dimension(:,:,:), intent(in)    :: tmp3, qa_mean
real, dimension(:,:,:), intent(inout) :: a_clr, a_cld, clr, cld

!------------------------------------------------------------------------
!---local variables-----------------------------------------------------

      real, dimension (size(tmp3,1), size(tmp3,2)) ::    &
                               da_cld2clr, da_clr2cld, dprec_cld2clr,  &
                                                 dprec_clr2cld, tmp1, tmp2
      integer :: km1

!------------------------------------------------------------------------
      km1 = MAX(k-1,1)
      if (overlap .eq. 1)  then
        da_cld2clr = min(a_cld(:,:,km1), max(0.,   &
                                         a_cld(:,:,km1) - qa_mean(:,:,k)))
      end if        
      if (overlap .eq. 2)  then    
        da_cld2clr = min(a_cld(:,:,km1), max(0.,  &
                                    a_cld(:,:,km1)*(1. - qa_mean(:,:,k))))
      end if
       
      if (cloud_generator_on) then
        tmp1 = min(a_cld(:,:,km1), max(0.,     &
                                      a_cld(:,:,km1) - qa_mean(:,:,k))) 
        tmp2 = min(a_cld(:,:,km1), max(0.,    &
                                     a_cld(:,:,km1)*(1. - qa_mean(:,:,k))))
        da_cld2clr = min(a_cld(:,:,km1), max(0.,   &
                             tmp3(:,:,k)*tmp1 + (1. - tmp3(:,:,k))*tmp2)) 
      end if      

!-------------------------------------------------------------------------
!    compute clear to cloud transfer
!-------------------------------------------------------------------------
      if (overlap .eq. 1)                                            &
        da_clr2cld = min(max(qa_mean(:,:,k) - qa_mean(:,:,km1), 0.), &
                                                           a_clr(:,:,km1))
      if (overlap .eq. 2)                                            &
        da_clr2cld = min(max( a_clr(:,:,km1)*qa_mean(:,:,k), 0.), &
                                                           a_clr(:,:,km1))
      if (cloud_generator_on) then
        tmp1 = min(max(qa_mean(:,:,k) - qa_mean(:,:,km1), 0.),  &
                                                          a_clr(:,:,km1)) 
        tmp2 = min(max( a_clr(:,:,km1)*qa_mean(:,:,k), 0.),   &
                                                           a_clr(:,:,km1))
        da_clr2cld = min(a_clr(:,:,km1), max(0.,   &
                             tmp3(:,:,k)*tmp1 + (1. - tmp3(:,:,k))*tmp2))
      end if      
        
!------------------------------------------------------------------------
!    calculate precipitation transfers
!------------------------------------------------------------------------
      dprec_cld2clr = cld(:,:,km1)*(da_cld2clr/max(a_cld(:,:,km1),  &
                                                                Nml%qmin))
      dprec_clr2cld = clr(:,:,km1)*(da_clr2cld(:,:)/max(a_clr(:,:,km1), &
                                                                 Nml%qmin))
        
!------------------------------------------------------------------------
!    add in transfers
!------------------------------------------------------------------------
      a_clr(:,:,k) = a_clr(:,:,km1) + da_cld2clr - da_clr2cld
      a_cld(:,:,k) = a_cld(:,:,km1) - da_cld2clr + da_clr2cld
      clr(:,:,k) = clr(:,:,km1) + dprec_cld2clr - dprec_clr2cld   
      cld(:,:,k) = cld(:,:,km1) - dprec_cld2clr + dprec_clr2cld

!----------------------------------------------------------------------


end subroutine cloud_clear_xfer


!#######################################################################



END MODULE rotstayn_klein_mp_mod

program compare_grid
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">Z. Liang </CONTACT>
  ! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">S. M. Griffies</REVIEWER>

  !<OVERVIEW>
  ! compare depth and land/sea mask of two grid_spec file. 
  !</OVERVIEW>

  !<DESCRIPTION>
  ! This program reads in two grid descriptor files (generated via ocean_grid_generator) 
  ! and creates a text file output listing line-by-line differences between the
  ! two files. Output file format is the same as the grid_edits file used by
  ! edit_grid.F90. These two files should have same grid size. 
  !
  ! Originally developed by Jeffery B. Greenblatt on 12/11/2001 at Princeton University     
  !</DESCRIPTION>

  use mpp_mod,    only : mpp_error, FATAL, NOTE, mpp_pe, mpp_init, mpp_exit
  use mpp_io_mod, only : mpp_open, mpp_read, mpp_close, fieldtype
  use mpp_io_mod, only : mpp_get_info, mpp_get_atts, mpp_get_fields
  use mpp_io_mod, only : MPP_RDONLY, MPP_NETCDF, MPP_SINGLE, MPP_OVERWR, MPP_ASCII 
  use fms_mod,    only : fms_init, fms_end, file_exist, stdout, close_file
  use fms_mod,    only : open_namelist_file, check_nml_error, write_version_number

  implicit none

  !--- namelist information --------------------------------------------
  !
  !<NAMELIST NAME="compare_grid_nml">
  !<DATA NAME="grid_file_1" TYPE="character(len=128)">
  !  First grid files to be compared with grid_file_2.
  !</DATA>
  !<DATA NAME="grid_file_2" TYPE="character(len=128)">
  !  Second grid files to be compared with grid_file_1.
  !</DATA>
  !<DATA NAME="grid_edits" TYPE="character(len=128)">
  !  output text file. Each line is in the format as 
  !  "i, j, depth_new, #was depth_old ". depth_new is 
  !  the depth at point (i,j) of grid_file_2 and depth_old 
  !  is the depth at point (i,j) of grid_file_1. 
  !</DATA>
  !<DATA NAME="mask_diff" TYPE="character(len=128)">
  !  output text file. Each line is in the format as 
  !  "i, j, wet_new, #was wet_old ". wet_new is 
  !  the land/sea mask at point (i,j) of grid_file_2 and wet_old 
  !  is the land/sea mask at point (i,j) of grid_file_1. 
  !</DATA>
  !</NAMELIST>
  character(len=128) :: grid_file_1 = 'grid_file_1'
  character(len=128) :: grid_file_2 = 'grid_file_2'
  character(len=128) :: grid_edits  = 'grid_edits.txt'
  character(len=128) :: mask_diff   = 'mask_diff.txt'

  namelist /compare_grid_nml/ grid_file_1, grid_file_2, grid_edits, mask_diff

  !--- version information variables -----------------------------------
  character(len=128) :: version = '$Id: compare_grid.f90,v 11.0 2004/09/28 20:07:16 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

  !--- compare_grid_type
  type compare_grid_type
     real,    dimension(:,:), pointer :: ht => NULL()
     integer, dimension(:,:), pointer :: wet => NULL()
     real,    dimension(:,:), pointer :: geolon_t => NULL()
     real,    dimension(:,:), pointer :: geolat_t => NULL()
     integer                          :: ni, nj
  end type compare_grid_type

  !--- other variables
  type(compare_grid_type) :: grid_1
  type(compare_grid_type) :: grid_2

  call fms_init ()

  call compare_grid_init ()

  ! --- Read grid files ------------------------------------------------

  call read_grid(grid_file_1, grid_1)
  call read_grid(grid_file_2, grid_2)

  ! Ensure we are comparing same-size arrays
  call grid_check()

  ! Now compare selected arrays and write out differences
  call grid_compare()

  call fms_end()

contains 
  !#####################################################################
  ! --- read the namelist and write the version information to logfile. Also
  ! --- write the namelist to standard output
  subroutine compare_grid_init

    integer :: io_status, unit, ierr

 ! --- provide for namelist over-ride of defaults ---------------------
  if(file_exist('input.nml')) then
     unit = open_namelist_file()
     read (unit,compare_grid_nml,IOSTAT=io_status)
     write (stdout(),'(/)')
     write (stdout(),compare_grid_nml)  
     ierr = check_nml_error(io_status, 'compare_grid_nml')
     call close_file(unit)
  else
     call mpp_error(NOTE, 'file input.nml does not exist' )
  endif

   !--- write out version information ---------------------------------
    call write_version_number(version, tagname)

  end subroutine compare_grid_init

  !#####################################################################

  !--- read the grid information from file.
  subroutine read_grid(file, grid)
    character(len=*),           intent(in) :: file   
    type(compare_grid_type), intent(inout) :: grid

    !--- Local variables
    integer            :: i, j, unit, len, ndim, nvar, natt, ntime
    integer            :: siz_in(3)
    logical            :: ht_found, wet_found, xt_found, yt_found
    character(len=128) :: name
    type(fieldtype), dimension(:), allocatable :: fields
    real, dimension(:,:), allocatable :: tmp 

    if(.not. file_exist(trim(file)) ) &
        call mpp_error(FATAL, 'compare_grid: file '//trim(file)//' does not exist')

    call mpp_open(unit,trim(file),MPP_RDONLY,MPP_NETCDF,threading=MPP_SINGLE,&
         fileset=MPP_SINGLE)
    call mpp_get_info(unit,ndim,nvar,natt,ntime)

    allocate(fields(nvar))
    call mpp_get_fields(unit,fields)

    ht_found=.false.
    wet_found=.false.  

    do i=1,nvar
       call mpp_get_atts(fields(i),name=name,siz=siz_in)
       select case (trim(name))
       case('depth_t')
          grid%ni = siz_in(1); grid%nj = siz_in(2)
          allocate(grid%ht(grid%ni,grid%nj))
          call mpp_read(unit,fields(i),grid%ht)
          ht_found = .true.
       case ('wet')
          allocate(grid%wet(siz_in(1), siz_in(2)),tmp(siz_in(1), siz_in(2)))
          call mpp_read(unit,fields(i),tmp)
          grid%wet = tmp
          deallocate(tmp)
          wet_found = .true.    
       case('x_T')
          allocate(grid%geolon_t(siz_in(1), siz_in(2)))
          call mpp_read(unit,fields(i),grid%geolon_t)
          xt_found = .true.
       case('y_T')
          allocate(grid%geolat_t(siz_in(1), siz_in(2)))
          call mpp_read(unit,fields(i),grid%geolat_t)
          yt_found = .true.
       end select
    enddo

    if (.not. ht_found) call mpp_error(FATAL,'compare_grid: depth_t not found in the file '//trim(file) )
    if (.not. wet_found) call mpp_error(FATAL,'compare_grid: wet not found in the file '//trim(file) )
    if (.not. xt_found) call mpp_error(FATAL,'compare_grid: x_T not found in the file '//trim(file) )
    if (.not. yt_found) call mpp_error(FATAL,'compare_grid: x_T not found in the file '//trim(file) )

    call mpp_close(unit)

  end subroutine read_grid
 
  !#####################################################################
  ! compare grid size and geographic grid.
  subroutine grid_check
    integer :: i, j

    if(grid_1%ni .ne. grid_2%ni .or. grid_1%nj .ne. grid_2%nj ) then
       call mpp_error(FATAL,'compare_grid: grid sizes of '//trim(grid_file_1)//  &
            ' and'//trim(grid_file_2)//' do not match')
    endif

    !--- make sure it is the same grid
    do j = 1, grid_1%nj
       do i = 1, grid_1%ni
          if(grid_1%geolon_t(i,j) .ne. grid_2%geolon_t(i,j) .or.  grid_1%geolat_t(i,j) .ne. grid_2%geolat_t(i,j)) then
               write(stdout(),*) 'grid_1%geolon_t(',i,',',j,') = ', grid_1%geolon_t(i,j),  &
                                'grid_2%geolon_t(',i,',',j,') = ', grid_2%geolon_t(i,j)
               write(stdout(),*) 'grid_1%geolat_t(',i,',',j,') = ', grid_1%geolat_t(i,j),  &
                                'grid_2%geolat_t(',i,',',j,') = ', grid_2%geolat_t(i,j)
               call mpp_error(FATAL, 'file '//trim(grid_file_1)//' and file '//trim(grid_file_2)// &
               ' do not have the same geographical grid' )
          endif
       enddo
    enddo

  end subroutine grid_check

  !#####################################################################
  !--- compare the two grid file and write out the difference to file grid_edits
  subroutine grid_compare

  logical :: flag
  integer :: i, j, unit

  !--- check the depth_t
  call mpp_open(unit,trim(grid_edits),MPP_OVERWR,MPP_ASCII,threading=&
       MPP_SINGLE,fileset=MPP_SINGLE, nohdrs = .TRUE.)

  flag = .false.
  write(unit, *) '#   i     j           depth_new'
  write(unit, *) '#'
  do i = 1, grid_1%ni
     do j = 1, grid_2%nj
        if (grid_1%ht(i,j) .ne. grid_2%ht(i,j)) then
           write(unit, '(i6,a,i6,a,f24.15,a,f24.15)') i,',',j,',',grid_2%ht(i,j),'   # was ',grid_1%ht(i,j)
           flag = .true.
        endif
     enddo
  enddo
  if (.not. flag) write(unit,*) '# NO CHANGES in ht'
  call mpp_close(unit)

  !--- check land_sea mask
  call mpp_open(unit,trim(mask_diff),MPP_OVERWR,MPP_ASCII,threading=&
       MPP_SINGLE,fileset=MPP_SINGLE)

  write(unit, *) '#   i     j    mask_new'
  write(unit, *) '#'
  flag = .false.
  do i = 1, grid_1%ni
     do j = 1, grid_1%nj
        if (grid_1%wet(i,j) .ne. grid_2%wet(i,j)) then
           write(unit, '(i6,a,i6,a,i6,a,i6)') i,',',j,',',grid_2%wet(i,j),'        # was ', grid_1%wet(i,j)
           flag = .true.
        endif
     enddo
  enddo
  if (.not. flag) write(unit,*) '# NO CHANGES in wet'
  call mpp_close(unit)

  end subroutine grid_compare

  !#####################################################################

end program compare_grid

module bgrid_halo_mod

use bgrid_horiz_mod, only: horiz_grid_type, update_np, update_sp, &
                           TGRID, VGRID
use         fms_mod, only: error_mesg, FATAL, mpp_clock_id, &
                           mpp_clock_begin, mpp_clock_end,  &
                           MPP_CLOCK_SYNC, CLOCK_ROUTINE
use mpp_domains_mod, only: mpp_update_domains, SUPDATE, NUPDATE,  &
                                               WUPDATE, EUPDATE

implicit none
private


!------------ public interfaces ------------

public :: update_halo, vel_flux_boundary

interface update_halo
    module procedure  update_halo_2d, update_halo_3d, update_halo_4d
end interface

interface vel_flux_boundary
    module procedure  vel_flux_boundary_2d, vel_flux_boundary_3d
end interface

!-------- public parameters ----------

! possible values for field argument
integer, parameter, public :: TEMP = 21, UWND = 22, VWND = 23, WIND = 24

! possible values for optional halo argument
integer, parameter, public  :: SOUTH = 1, NORTH = 2
integer, parameter, public  ::  WEST = 4,  EAST = 8
integer, parameter, private ::  ALL = SOUTH+NORTH+WEST+EAST ! default

! possible values for optional flags argument
integer, parameter, public :: NOPOLE   = 1
integer, parameter, public :: POLEONLY = 2

!---------------------------------------------------------------
! private timing variables

   integer :: id_update3
   logical :: do_clock_init = .true.

! private module variables (used across module subroutines)

   integer :: domain_flags
   logical :: update_sbnd, update_nbnd, update_wbnd, update_ebnd, &
              no_pole_vel, do_pole_only
   logical :: do_channel

contains

!#######################################################################

 subroutine update_halo_3d (Hgrid, field, data, halos, flags)

!----------------------------------------------------------
!  Halo update for 3-dimensional fields
!----------------------------------------------------------
!  Hgrid = horizontal grid constants
!  field = integer identifier for field
!            possible values: TEMP, UWND, VWND
!  data  = 3-D data
!  halos = identifies which halos should be updated (optional)
!            possible values: NORTH, EAST, WEST, SOUTH
!            default(all): NORTH+EAST+WEST+SOUTH
!  flags = options for handling the pole
!            possible values: NOPOLE, POLEONLY
!----------------------------------------------------------

   type(horiz_grid_type), intent(inout) :: Hgrid
   integer,               intent(in)    :: field
   real,                  intent(inout) :: data(Hgrid%ilb:,Hgrid%jlb:,:)
   integer, optional,     intent(in)    :: halos, flags

   integer :: is, ie, iflags, halosize, xygrid

   if (do_clock_init) call clock_init
   call mpp_clock_begin (id_update3)

!  ----- check dimensions ------

   if (size(data,2) /= Hgrid % jsize)  call error_mesg  &
                    ('update_halo in bgrid_halo_mod',   &
                     'j dimension has wrong size', FATAL)

   if (size(data,1) /= Hgrid % isize)  call error_mesg  &
                    ('update_halo in bgrid_halo_mod',   &
                     'i dimension has wrong size', FATAL)

!  ----- check/set optional flag arguments ----

   call set_domain_flags ( Hgrid, halos, flags )

!  ------ need to determine and check grid -------

   select case (field)
     case (TEMP)
        is = Hgrid % Tmp % is;  ie = Hgrid % Tmp % ie;  xygrid = TGRID
        ! update non-polar boundaries
        if (.not.do_pole_only) call mpp_update_domains (data, Hgrid%Tmp%Domain, domain_flags)
     case (UWND:VWND)
        is = Hgrid % Vel % is;  ie = Hgrid % Vel % ie;  xygrid = VGRID
        ! update non-polar boundaries
        if (.not.do_pole_only) call mpp_update_domains (data, Hgrid%Tmp%Domain, domain_flags)
     case default
        call error_mesg ('update_halo in bgrid_halo_mod', &
                         'invalid field', FATAL)
   end select

!  ----- update east-west cyclic boundaries (for 1-d decomp only) ----

   halosize = 1
   if (update_wbnd) data(is-halosize:is-1,:,:) = data(ie-halosize+1:ie,:,:)
   if (update_ebnd) data(ie+1:ie+halosize,:,:) = data(is:is+halosize-1,:,:)

!  ------ update south pole ------

   if ( (update_sbnd.or.do_pole_only) .and. update_sp (Hgrid,xygrid) ) then
      call south_boundary_3d (Hgrid, field, data(:,:,:), no_pole_vel)
   endif

!  ------ update north pole ------

   if ( (update_nbnd.or.do_pole_only) .and. update_np (Hgrid,xygrid) ) then
      call north_boundary_3d (Hgrid, field, data(:,:,:), no_pole_vel)
   endif

   call mpp_clock_end (id_update3)

 end subroutine update_halo_3d

!#######################################################################

 subroutine update_halo_4d (Hgrid, field, data, halos, flags)

!----------------------------------------------------------
!  Halo update for 4-dimensional fields
!----------------------------------------------------------
!  Hgrid = horizontal grid constants
!  field = integer identifier for field
!            possible values: TEMP, UWND, VWND, WIND
!            note: if field=WIND, then 4th dim of data must be 2
!  data  = 4-D data
!  halos = identifies which halos should be updated (optional)
!            possible values: NORTH, EAST, WEST, SOUTH
!            default(all): NORTH+EAST+WEST+SOUTH
!  flags = options for handling the pole
!            possible values: NOPOLE, POLEONLY
!----------------------------------------------------------

   type(horiz_grid_type), intent(inout) :: Hgrid
   integer,               intent(in)    :: field
   real,                  intent(inout) :: data(Hgrid%ilb:,Hgrid%jlb:,:,:)
   integer, optional,     intent(in)    :: halos, flags

   integer :: is, ie, iflags, n, halosize, xygrid

   if (do_clock_init) call clock_init
   call mpp_clock_begin (id_update3)

!  ----- check dimensions ------

   if (size(data,2) /= Hgrid % jsize)  call error_mesg  &
                    ('update_halo in bgrid_halo_mod',   &
                     'j dimension has wrong size', FATAL)

   if (size(data,1) /= Hgrid % isize)  call error_mesg  &
                    ('update_halo in bgrid_halo_mod',   &
                     'i dimension has wrong size', FATAL)

   if (field == WIND .and. size(data,4) /= 2) call error_mesg  &
             ('update_halo in bgrid_halo_mod',   &
      '4th dimension must have size 2 for wind components', FATAL)

!  ----- check/set optional flag arguments ----

   call set_domain_flags ( Hgrid, halos, flags )

!  ------ need to determine and check grid -------

   select case (field)
     case (TEMP)
        is = Hgrid % Tmp % is;  ie = Hgrid % Tmp % ie;  xygrid = TGRID
        ! update non-polar boundaries
        if (.not.do_pole_only) call mpp_update_domains (data, Hgrid%Tmp%Domain, domain_flags)
     case (UWND:WIND)
        is = Hgrid % Vel % is;  ie = Hgrid % Vel % ie;  xygrid = VGRID
        ! update non-polar boundaries
        if (.not.do_pole_only) call mpp_update_domains (data, Hgrid%Tmp%Domain, domain_flags)
     case default
        call error_mesg ('update_halo in bgrid_halo_mod', &
                         'invalid field', FATAL)
   end select

!  ----- update east-west cyclic boundaries (for 1-d decomp only) ----

       halosize = 1
       if (update_wbnd) data(is-halosize:is-1,:,:,:) = data(ie-halosize+1:ie,:,:,:)
       if (update_ebnd) data(ie+1:ie+halosize,:,:,:) = data(is:is+halosize-1,:,:,:)

!  ------ update south pole ------

   do_channel = Hgrid%channel

   if ( (update_sbnd.or.do_pole_only) .and. update_sp (Hgrid,xygrid) ) then
      if (field == WIND) then
          call south_boundary_3d (Hgrid, UWND, data(:,:,:,1), no_pole_vel)
          call south_boundary_3d (Hgrid, VWND, data(:,:,:,2), no_pole_vel)
       else
          do n = 1, size(data,4)
            call south_boundary_3d (Hgrid, field, data(:,:,:,n), no_pole_vel)
          enddo
       endif
   endif

!  ------ update north pole ------

   if ( (update_nbnd.or.do_pole_only) .and. update_np (Hgrid,xygrid) ) then
      if (field == WIND) then
          call north_boundary_3d (Hgrid, UWND, data(:,:,:,1), no_pole_vel)
          call north_boundary_3d (Hgrid, VWND, data(:,:,:,2), no_pole_vel)
      else
          do n = 1, size(data,4)
            call north_boundary_3d (Hgrid, field, data(:,:,:,n), no_pole_vel)
          enddo
      endif
   endif

   call mpp_clock_end (id_update3)

 end subroutine update_halo_4d

!#######################################################################
! updates halos at (and beyond) the north pole

 subroutine north_boundary_3d (Hgrid, field, data, nopole)

   type(horiz_grid_type), intent(in)    :: Hgrid
   integer,               intent(in)    :: field
   real,                  intent(inout) :: data(:,Hgrid%jlb:,:)
   logical,               intent(in)    :: nopole

   integer :: js, je, jeg, halo

      halo = 1  ! assumed halo size = 1

! --- update north pole boundary ---

      select case (field)
         case (TEMP)
!        ---- mass ----
            js = Hgrid % Tmp % js;  je = Hgrid % Tmp % je
            data (:, je+1:je+halo, :) = data (:, je:je-halo+1:-1, :)
         case (UWND)
!        ---- u comp ----
            js = Hgrid % Vel % js;  je = Hgrid % Vel % je;  jeg = Hgrid % Vel % jeg
            if (.not. nopole) then
                if (.not.do_channel) then
                    if ( jeg+1 <= je+halo ) data (:, jeg+1,:) = 0.0
                else
                    if ( jeg+1 <= je+halo ) data (:, jeg+1,:) = data (:, jeg,:)
                endif
            endif
            if ( jeg+2 <= je+halo ) &
            data (:, jeg+2:jeg+halo, :) = data (:, je:je-halo+2:-1, :)
         case (VWND)
!        ---- v comp ----
            js = Hgrid % Vel % js;  je = Hgrid % Vel % je;  jeg = Hgrid % Vel % jeg
            if (.not. nopole) then
                if ( jeg+1 <= je+halo ) data (:, jeg+1, :) = 0.0
            endif
            if ( jeg+2 <= je+halo ) &
            data (:, jeg+2:jeg+halo, :) = - data (:, je:je-halo+2:-1, :)
      end select

 end subroutine north_boundary_3d

!#######################################################################
! updates halos at (and beyond) the south pole

 subroutine south_boundary_3d (Hgrid, field, data, nopole)

   type(horiz_grid_type), intent(in)    :: Hgrid
   integer,               intent(in)    ::  field
   real,                  intent(inout) :: data(:,Hgrid%jlb:,:)
   logical,               intent(in)    :: nopole
      

   integer :: js, je, halo

      halo = 1  ! assumed halo size = 1

! --- update south pole boundary ---

      select case (field)
         case (TEMP)
!        ---- mass ----
            js = Hgrid % Tmp % js;  je = Hgrid % Tmp % je
            data (:, js-1:js-halo:-1, :) = data (:, js:js+halo-1, :)
         case (UWND)
!        ---- u comp ----
            js = Hgrid % Vel % js;  je = Hgrid % Vel % je
            if (.not. nopole) then
                if (.not.do_channel) then
                    data (:, js-1, :) = 0.0
                else
                    data (:, js-1, :) = data (:, js, :)
                endif
            endif
            data (:, js-2:js-halo:-1, :) = data (:, js:js+halo-2, :)
         case (VWND)
!        ---- v comp ----
            js = Hgrid % Vel % js;  je = Hgrid % Vel % je
            if (.not. nopole) data (:, js-1, :) = 0.0
            data (:, js-2:js-halo:-1, :) = - data (:, js:js+halo-2, :)
      end select

 end subroutine south_boundary_3d

!#######################################################################

 subroutine vel_flux_boundary_3d (Hgrid, data)

! zero-out the flux between pole and first velocity row
! do this on both sides of the ppole
! meridional indexing coincides with mass grid
! assumed halo size is one

!  Hgrid = horizontal grid constants
!  data = 3-D data

   type(horiz_grid_type), intent(in)    :: Hgrid
   real,                  intent(inout) :: data(:,Hgrid%jlb:,:)

      if ( update_sp (Hgrid,TGRID) ) then
           data (:, Hgrid%Tmp%js-1, :) = 0.0
           data (:, Hgrid%Tmp%js  , :) = 0.0
      endif

      if ( update_np (Hgrid,TGRID) ) then
           data (:, Hgrid%Tmp%je  , :) = 0.0
           data (:, Hgrid%Tmp%je+1, :) = 0.0
      endif

 end subroutine vel_flux_boundary_3d

!#######################################################################
! overload interfaces
!#######################################################################

 subroutine update_halo_2d (Hgrid, field, data, halos, flags)

   type(horiz_grid_type), intent(inout) :: Hgrid
   integer,               intent(in)    :: field
   real,                  intent(inout) :: data(:,:)
   integer, optional,     intent(in)    :: halos, flags

   real, dimension(size(data,1),size(data,2),1) :: data3

   data3(:,:,1) = data
   call update_halo_3d (Hgrid, field, data3, halos, flags)
   data = data3(:,:,1)

 end subroutine update_halo_2d

!#######################################################################

 subroutine vel_flux_boundary_2d (Hgrid, data)

   type(horiz_grid_type), intent(in)    :: Hgrid
   real,                  intent(inout) :: data(:,Hgrid%jlb:)

   real, dimension(size(data,1),size(data,2),1) :: data3

   data3(:,:,1) = data
   call vel_flux_boundary_3d (Hgrid, data3)
   data = data3(:,:,1)

 end subroutine vel_flux_boundary_2d

!#######################################################################
! private interfaces
!#######################################################################

 subroutine set_domain_flags ( Hgrid, halos, flags )
 type(horiz_grid_type), intent(in) :: Hgrid
 integer, optional,     intent(in) :: halos, flags
 integer :: ihalos, iflags

! sets module variables -- domain_flags,
!                          update_sbnd, update_nbnd,
!                          update_wbnd, update_ebnd,
!                          no_pole_vel, do_pole_only

   ihalos = ALL;  if (present(halos)) ihalos = halos
   iflags = 0;    if (present(flags)) iflags = flags

   domain_flags = 0

   ! south and north boundary
     update_sbnd  = btest(ihalos,0)
     update_nbnd  = btest(ihalos,1)
     if ( update_sbnd ) domain_flags = domain_flags + SUPDATE
     if ( update_nbnd ) domain_flags = domain_flags + NUPDATE
     ! turn off polar update if domain is periodic in y
    !if (Hgrid%Vel%jeg == Hgrid%Tmp%jeg) then
     if (Hgrid%double_periodic) then
        update_sbnd = .false.
        update_nbnd = .false.
     endif
   ! west and east boundary
     update_wbnd  = btest(ihalos,2)
     update_ebnd  = btest(ihalos,3)
     if (Hgrid%decompx) then
        if ( update_wbnd ) domain_flags = domain_flags + WUPDATE
        if ( update_ebnd ) domain_flags = domain_flags + EUPDATE
        update_wbnd = .false. ! turn off ?
        update_ebnd = .false.
     endif

   ! set additional flags related to polar boundary
     no_pole_vel  = btest(iflags,0)    !4)
     do_pole_only = btest(iflags,1)    !5)

   ! might update south or north poles ?
   ! if (do_pole_only) then
   !     update_sbnd = .true.
   !     update_nbnd = .true.
   ! endif

 end subroutine set_domain_flags

!#######################################################################
! initializes mpp performance clock for bgrid halo updates

 subroutine clock_init
   id_update3 = mpp_clock_id ('BGRID: update_halo',   &
                  flags=MPP_CLOCK_SYNC, grain=CLOCK_ROUTINE)
   do_clock_init = .false. 
 end subroutine clock_init

!#######################################################################

end module bgrid_halo_mod

#include <fms_platform.h>
MODULE CONV_PLUMES_k_MOD

  use  aer_ccn_act_k_mod,   only: aer_ccn_act_k
  use  conv_utilities_k_mod,only: findt_k, exn_k, qsat_k, adicloud, sounding, uw_params
  use Sat_Vapor_Pres_k_Mod, ONLY: compute_qs_k

!---------------------------------------------------------------------
  implicit none
  private

!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------

  character(len=128) :: version = '$Id: conv_plumes_k.F90,v 20.0 2013/12/13 23:21:34 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

!---------------------------------------------------------------------
!-------  interfaces --------

  public  :: cp_init_k, cp_end_k, cp_clear_k, ct_init_k, ct_end_k,  &
             ct_clear_k, cumulus_plume_k, cumulus_tend_k

  character(len=11) :: mod_name = 'conv_plumes'

  public cwetdep_type
  type cwetdep_type
   character(len=200) :: scheme
   real :: Henry_constant
   real :: Henry_variable
   real :: frac_in_cloud
   real :: frac_in_cloud_snow
   real :: alpha_r
   real :: alpha_s
   logical :: Lwetdep, Lgas, Laerosol, Lice
  end type cwetdep_type

  public cpnlist
  type cpnlist
     integer :: mixing_assumption, mp_choice
     real :: rle, rpen, rmaxfrac, wmin, rbuoy, rdrag, frac_drs, bigc
     real :: auto_th0, auto_rate, tcrit, cldhgt_max, atopevap, rad_crit,  &
             wtwmin_ratio, deltaqc0, emfrac_max, wrel_min,                        &
             Nl_land, Nl_ocean, r_thresh, qi_thresh, peff_l, peff_i, peff, rh0, cfrac,hcevap, weffect,t00
     logical :: do_ice, do_ppen, do_forcedlifting, do_pevap, do_pdfpcp, isdeep, use_online_aerosol
     logical :: do_auto_aero, do_pmadjt, do_emmax, do_pnqv, do_weffect, do_qctflx_zero,do_detran_zero
     character(len=32), dimension(:), _ALLOCATABLE  :: tracername _NULL
     character(len=32), dimension(:), _ALLOCATABLE  :: tracer_units _NULL
     type(cwetdep_type), dimension(:), _ALLOCATABLE :: wetdep _NULL
  end type cpnlist

  public cplume
  type cplume
     integer :: ltop, let, krel
     real    :: cush, cldhgt, prel, zrel
     real    :: maxcldfrac
     real, _ALLOCATABLE :: thcu  (:) _NULL, qctu  (:) _NULL, uu    (:) _NULL
     real, _ALLOCATABLE :: vu    (:) _NULL, qlu   (:) _NULL, qiu   (:) _NULL
     real, _ALLOCATABLE :: pptr  (:) _NULL, ppti  (:) _NULL, wu    (:) _NULL
     real, _ALLOCATABLE :: umf   (:) _NULL, emf   (:) _NULL, thvu  (:) _NULL
     real, _ALLOCATABLE :: rei   (:) _NULL, fer   (:) _NULL, fdr   (:) _NULL
     real, _ALLOCATABLE :: dp    (:) _NULL, thc   (:) _NULL, qct   (:) _NULL
     real, _ALLOCATABLE :: ql    (:) _NULL, qi    (:) _NULL, qa    (:) _NULL
     real, _ALLOCATABLE :: u     (:) _NULL, v     (:) _NULL, p     (:) _NULL
     real, _ALLOCATABLE :: ps    (:) _NULL, ufrc  (:) _NULL, thvtop(:) _NULL
     real, _ALLOCATABLE :: thvbot(:) _NULL, fdrsat(:) _NULL, z     (:) _NULL
     real, _ALLOCATABLE :: qn    (:) _NULL, qnu   (:) _NULL, zs    (:) _NULL
     real, _ALLOCATABLE :: hlu   (:) _NULL, hl    (:) _NULL, clu   (:) _NULL
     real, _ALLOCATABLE :: ciu   (:) _NULL, buo   (:) _NULL, t     (:) _NULL
     real, _ALLOCATABLE :: crate (:) _NULL, prate (:) _NULL, peff  (:) _NULL
!++++yim
     real, _ALLOCATABLE :: tr  (:,:) _NULL, tru (:,:) _NULL, tru_dwet(:,:) _NULL
     real, _ALLOCATABLE :: pptn  (:) _NULL
  end type cplume

  public ctend
  type ctend
     integer :: botlev, toplev
     real    :: rain, snow, denth, uav, vav, conint, freint,  &
                dtint, dqint, dqtmp, dting
     real, _ALLOCATABLE :: uten  (:) _NULL, vten  (:) _NULL, tten  (:) _NULL
     real, _ALLOCATABLE :: qvten (:) _NULL, qlten (:) _NULL, qiten (:) _NULL
     real, _ALLOCATABLE :: qaten (:) _NULL, thcten(:) _NULL, qctten(:) _NULL
     real, _ALLOCATABLE :: qvdiv (:) _NULL, qldiv (:) _NULL, qidiv (:) _NULL
     real, _ALLOCATABLE :: thcflx(:) _NULL, qctflx(:) _NULL
     real, _ALLOCATABLE :: umflx (:) _NULL, vmflx (:) _NULL, qvflx (:) _NULL
     real, _ALLOCATABLE :: qlflx (:) _NULL, qiflx (:) _NULL, qaflx (:) _NULL
     real, _ALLOCATABLE :: qnflx (:) _NULL, qnten (:) _NULL, pflx  (:) _NULL
     real, _ALLOCATABLE :: hlflx (:) _NULL, hlten (:) _NULL
     real, _ALLOCATABLE :: tevap (:) _NULL, qevap (:) _NULL
     real, _ALLOCATABLE :: qldet (:) _NULL, qidet (:) _NULL, qadet (:) _NULL
     real, _ALLOCATABLE :: qndet (:) _NULL
!++++yim
     real, _ALLOCATABLE :: trflx(:,:) _NULL,trten (:,:) _NULL, trwet(:,:) _NULL
  end type ctend

contains

!#####################################################################
!#####################################################################

!++++yim
  subroutine cp_init_k(kd, num_tracers, cp)
!++++yim    
    integer, intent(in) :: kd, num_tracers
    type(cplume), intent(inout) :: cp
    
    allocate ( cp%hlu   (0:kd)); cp%hlu   =0.;
    allocate ( cp%thcu  (0:kd)); cp%thcu  =0.;
    allocate ( cp%qctu  (0:kd)); cp%qctu  =0.;
    allocate ( cp%uu    (0:kd)); cp%uu    =0.;
    allocate ( cp%vu    (0:kd)); cp%vu    =0.;
    allocate ( cp%qlu   (0:kd)); cp%qlu   =0.;
    allocate ( cp%qiu   (0:kd)); cp%qiu   =0.;
    allocate ( cp%clu   (0:kd)); cp%clu   =0.;
    allocate ( cp%ciu   (0:kd)); cp%ciu   =0.;
    allocate ( cp%buo   (0:kd)); cp%buo   =0.;
    allocate ( cp%t     (0:kd)); cp%t     =0.;
    allocate ( cp%crate (0:kd)); cp%crate =0.;
    allocate ( cp%prate (0:kd)); cp%prate =0.;
    allocate ( cp%qnu   (0:kd)); cp%qnu   =0.;
    allocate ( cp%pptn  (1:kd)); cp%pptn  =0.;
    allocate ( cp%pptr  (1:kd)); cp%pptr  =0.;
    allocate ( cp%ppti  (1:kd)); cp%ppti  =0.;
    allocate ( cp%wu    (0:kd)); cp%wu    =0.;
    allocate ( cp%umf   (0:kd)); cp%umf   =0.;
    allocate ( cp%emf   (0:kd)); cp%emf   =0.;
    allocate ( cp%thvu  (1:kd)); cp%thvu  =0.;
    allocate ( cp%rei   (1:kd)); cp%rei   =0.;
    allocate ( cp%fer   (1:kd)); cp%fer   =0.;
    allocate ( cp%fdr   (1:kd)); cp%fdr   =0.;
    allocate ( cp%dp    (1:kd)); cp%dp    =0.;
    allocate ( cp%hl    (1:kd)); cp%hl    =0.;
    allocate ( cp%thc   (1:kd)); cp%thc   =0.;
    allocate ( cp%qct   (1:kd)); cp%qct   =0.;
    allocate ( cp%u     (1:kd)); cp%u     =0.;
    allocate ( cp%v     (1:kd)); cp%v     =0.;
    allocate ( cp%ql    (1:kd)); cp%ql    =0.;
    allocate ( cp%qi    (1:kd)); cp%qi    =0.;
    allocate ( cp%qa    (1:kd)); cp%qa    =0.;
    allocate ( cp%qn    (1:kd)); cp%qn    =0.;
    allocate ( cp%p     (1:kd)); cp%p     =0.;
    allocate ( cp%ps    (0:kd)); cp%ps    =0.;
    allocate ( cp%z     (1:kd)); cp%z     =0.;
    allocate ( cp%zs    (0:kd)); cp%zs    =0.;
    allocate ( cp%ufrc  (1:kd)); cp%ufrc  =0.;
    allocate ( cp%thvbot(1:kd)); cp%thvbot=0.;
    allocate ( cp%thvtop(1:kd)); cp%thvtop=0.;
    allocate ( cp%fdrsat(1:kd)); cp%fdrsat=0.;
    allocate ( cp%peff  (1:kd)); cp%peff  =0.;
!++++yim
    allocate ( cp%tr(1:kd,1:num_tracers)); cp%tr=0.;
    allocate ( cp%tru(0:kd,1:num_tracers)); cp%tru=0.;
    allocate ( cp%tru_dwet(0:kd,1:num_tracers)); cp%tru_dwet=0.;
  end subroutine cp_init_k

!#####################################################################
!#####################################################################

  subroutine cp_end_k (cp)
    type(cplume), intent(inout) :: cp
    deallocate (cp%thcu, cp%qctu, cp%uu, cp%vu, cp%qlu, cp%qiu,  &
                cp%pptr, cp%ppti, cp%wu, cp%umf, cp%emf, cp%thvu,  &
                cp%rei, cp%fer, cp%fdr, cp%dp, cp%thc, cp%qct, cp%u, &
                cp%v, cp%p, cp%ps, cp%ufrc, cp%thvbot, cp%thvtop, &
                cp%fdrsat, cp%peff, cp%qnu, cp%ql, cp%qi, cp%qa, cp%qn, &
                cp%pptn, cp%z, cp%zs, cp%hl, cp%hlu, cp%clu, cp%ciu, &
                cp%buo, cp%t, cp%crate, cp%prate, cp%tr, cp%tru, &
                cp%tru_dwet)
  end subroutine cp_end_k

!#####################################################################
!#####################################################################

  subroutine cp_clear_k (cp)
    type(cplume), intent(inout) :: cp
    cp%thcu  =0.;    cp%qctu  =0.;    cp%uu    =0.;    cp%vu    =0.;
    cp%qlu   =0.;    cp%qiu   =0.;    cp%qnu   =0.;    cp%pptr  =0.;
    cp%ppti  =0.;    cp%wu    =0.;    cp%umf   =0.;    cp%emf   =0.;
    cp%thvu  =0.;    cp%rei   =0.;    cp%fer   =0.;    cp%fdr   =0.;
    cp%dp    =0.;    cp%thc   =0.;    cp%qct   =0.;    cp%u     =0.;
    cp%v     =0.;    cp%ql    =0.;    cp%qi    =0.;    cp%qa    =0.; 
    cp%qn    =0.;    cp%p     =0.;    cp%ps    =0.;
    cp%ufrc  =0.;    cp%thvbot=0.;    cp%thvtop=0.;    cp%hlu   =0.;
    cp%fdrsat=0.;    cp%z     =0.;    cp%zs    =0.;    cp%hl    =0.;
    cp%clu   =0.;    cp%ciu   =0.;    cp%buo   =0.;    cp%t     =0.;
    cp%crate =0.;    cp%prate =0.;    cp%peff  =0.;    !cp%maxcldfrac = 1.;
!++++yim
    cp%pptn  =0.;    cp%tr    =0.;    cp%tru   =0.;    cp%tru_dwet = 0.
  end subroutine cp_clear_k

!#####################################################################
!#####################################################################

!++++yim
  subroutine ct_init_k (kd, num_tracers, ct)
!++++yim
    integer, intent(in) :: kd, num_tracers
    type(ctend), intent(inout) :: ct
    allocate ( ct%uten  (1:kd)); ct%uten  =0.;
    allocate ( ct%vten  (1:kd)); ct%vten  =0.;
    allocate ( ct%tten  (1:kd)); ct%tten  =0.;
    allocate ( ct%qvten (1:kd)); ct%qvten =0.;
    allocate ( ct%qlten (1:kd)); ct%qlten =0.;
    allocate ( ct%qiten (1:kd)); ct%qiten =0.;
    allocate ( ct%qaten (1:kd)); ct%qaten =0.;
    allocate ( ct%qnten (1:kd)); ct%qnten =0.;
    allocate ( ct%qldet (1:kd)); ct%qldet =0.;
    allocate ( ct%qidet (1:kd)); ct%qidet =0.;
    allocate ( ct%qadet (1:kd)); ct%qadet =0.;
    allocate ( ct%qndet (1:kd)); ct%qndet =0.;
    allocate ( ct%hlten (1:kd)); ct%hlten =0.;
    allocate ( ct%thcten(1:kd)); ct%thcten=0.;
    allocate ( ct%qctten(1:kd)); ct%qctten=0.;
    allocate ( ct%qvdiv (1:kd)); ct%qvdiv =0.;
    allocate ( ct%qldiv (1:kd)); ct%qldiv =0.;
    allocate ( ct%qidiv (1:kd)); ct%qidiv =0.;
    allocate ( ct%hlflx (0:kd)); ct%hlflx =0.;
    allocate ( ct%thcflx(0:kd)); ct%thcflx=0.;
    allocate ( ct%qctflx(0:kd)); ct%qctflx=0.;
    allocate ( ct%qvflx (0:kd)); ct%qvflx =0.;
    allocate ( ct%qlflx (0:kd)); ct%qlflx =0.;
    allocate ( ct%qiflx (0:kd)); ct%qiflx =0.;
    allocate ( ct%qaflx (0:kd)); ct%qaflx =0.;
    allocate ( ct%qnflx (0:kd)); ct%qnflx =0.;
    allocate ( ct%umflx (0:kd)); ct%umflx =0.;
    allocate ( ct%vmflx (0:kd)); ct%vmflx =0.;
    allocate ( ct%pflx  (1:kd)); ct%pflx  =0.;
    allocate ( ct%tevap (1:kd)); ct%tevap =0.;
    allocate ( ct%qevap (1:kd)); ct%qevap =0.;
!++++yim
    allocate ( ct%trflx  (0:kd,1:num_tracers)); ct%trflx  =0.;
    allocate ( ct%trten  (1:kd,1:num_tracers)); ct%trten  =0.;
    allocate ( ct%trwet  (1:kd,1:num_tracers)); ct%trwet  =0.;
  end subroutine ct_init_k

!#####################################################################
!#####################################################################

  subroutine ct_end_k (ct)
    type(ctend), intent(inout) :: ct
    deallocate (ct%uten, ct%vten, ct%tten, ct%qvten, ct%qlten,  &
                ct%qiten, ct%qaten, ct%qnten, ct%hlten, ct%thcten, &
                ct%qldet, ct%qidet, ct%qadet, ct%qndet,            &
                ct%qctten, ct%qvdiv, ct%qldiv, ct%qidiv, ct%hlflx, &
                ct%thcflx, ct%qctflx, ct%qvflx, ct%qlflx, ct%qiflx, &
                ct%qaflx, ct%qnflx, ct%umflx, ct%vmflx, ct%pflx, &
                ct%tevap, ct%qevap, ct%trflx, ct%trten, ct%trwet)
  end subroutine ct_end_k

!#####################################################################
!#####################################################################

  subroutine ct_clear_k(ct)
    type(ctend), intent(inout) :: ct
    
    ct%uten  =0.;    ct%vten  =0.;    ct%tten  =0.;
    ct%qvten =0.;    ct%qlten =0.;    ct%qiten =0.;
    ct%qaten =0.;    ct%qnten =0.;    ct%thcten=0.;
    ct%qctten=0.;    
    ct%qldet =0.;    ct%qidet =0.;    ct%qadet =0.;
    ct%qndet =0.;    
    ct%qvdiv =0.;    ct%qldiv =0.;    ct%qidiv =0.;
    ct%thcflx=0.;    ct%qctflx=0.;    ct%qvflx =0.;
    ct%qlflx =0.;    ct%qiflx =0.;    ct%qaflx =0.;    ct%qnflx =0.;
    ct%umflx =0.;    ct%vmflx =0.;    ct%pflx  =0.;
    ct%hlflx =0.;    ct%hlten =0.;
    ct%denth =0.;    ct%rain  =0.;    ct%snow  =0.;    
    ct%tevap =0.;    ct%qevap =0.;
    ct%dting =0.;
!++++yim
    ct%trflx =0.;    ct%trten =0.;    ct%trwet =0.
  end subroutine ct_clear_k

!#####################################################################
!#####################################################################

  subroutine mixing_k (cpn, z0, p0, hl0, thc0, qct0, hlu, thcu, qctu, &
                       wu, scaleh, rei, fer, fdr, fdrsat, rho0j, rkm, &
                       Uw_p, umfkm1, dp, dt)       
  
    type(cpnlist),  intent(in)    :: cpn
    type(uw_params),  intent(inout)    :: Uw_p
    real,           intent(in)    :: z0, p0, hl0, thc0, qct0 !envirn. properties at level k
    real,           intent(in)    :: hlu, thcu, qctu, wu !updraft properties at level k-1
    real,           intent(in)    :: scaleh, rkm
    real,           intent(in)    :: umfkm1, dp, dt
    real,           intent(inout) :: rei, fer, fdr, fdrsat, rho0j
    
    real    :: excessu, excess0, hlfs, qtfs, thvfs,  &
               xbuo0, xsat, xs, xs1, xs2
    real    :: thj, qvj, qlj, qij, qse, thvj, thv0j
    real    :: aquad, bquad, cquad, ee2, ud2
    real    :: emmax

!-----A.  Entrainment and Detrainment
!     first, to determine fraction (xsat) of mixture that is to be detrained out 
!     of clouds, i.e., the mixture with negative buoyancy. We consider a thin 
!     layer between two interfaces, so using mid-point value to represent the 
!     mean value of the layer. The properties of updraft at midpoint is assumed
!     to be undiluted from the lower interface.  

!-----calculate fraction of mixture that is just saturated

    excessu = qctu - qsat_k((hlu-Uw_p%grav*z0)/Uw_p%cp_air, p0,Uw_p) 
              excessu = max(excessu,0.0)
    excess0 = qct0 - qsat_k((hl0-Uw_p%grav*z0)/Uw_p%cp_air, p0, Uw_p) 

    if(excessu*excess0.le.0)then
       xsat = -excessu/(excess0-excessu)
    else
       xsat = 1.0
    endif
    hlfs =(1.-xsat)*hlu  + xsat*hl0
    qtfs =(1.-xsat)*qctu + xsat*qct0
    call findt_k (z0,p0,hlfs,qtfs, thj, qvj, qlj, qij, qse, thvfs, &
                  cpn%do_ice, Uw_p)
    call findt_k (z0,p0,hlu, qctu, thj, qvj, qlj, qij, qse, thvj, &
                  cpn%do_ice, Uw_p)   
    call findt_k (z0,p0,hl0, qct0, thj, qvj, qlj, qij, qse, thv0j, &
                  cpn%do_ice, Uw_p)   
    rho0j = p0/(Uw_p%rdgas*thv0j*exn_k(p0,Uw_p))

!-----calculate fraction of mixture with zero buoyancy
    if(thvfs.ge.thv0j) then
       xbuo0=xsat
    else if(thvj.le.thv0j) then
       xbuo0=0.
    else
       xbuo0=xsat*(thvj-thv0j)/(thvj-thvfs)
    endif

    !-----calculate fraction of mixture with negative buoyancy but can 
    !     penetrate a critical distance lc=rle*scaleh
    if(thvfs.ge.thv0j.or.xsat.le.0.05) then
       xs=xsat !mixture has to be saturated
    else
       aquad = wu**2.
       bquad = -(2.*wu**2. + 2.*cpn%rbuoy*Uw_p%grav*cpn%rle*scaleh*&
                                              (thvj-thvfs)/thv0j/xsat)
       cquad = wu**2. - 2.*cpn%rbuoy*Uw_p%grav*cpn%rle*scaleh* &
                                                        (1-thvj/thv0j)
       call roots(aquad,bquad,cquad,xs1,xs2)
       xs=min(xs1,xs2)
    endif
    xs=min(xs,xsat)
    xs=max(xbuo0,xs)
    xs=min(1.0,xs)
    
    ee2     = xs**2.
    ud2     = 1. - 2.*xs + xs**2.
    rei     = rkm/scaleh/Uw_p%grav/rho0j  !make entrainment rate in unit of 1/Pa
    fer     = rei * ee2
    fdr     = rei * ud2

 if(cpn%do_emmax) then
    emmax = cpn%emfrac_max * dp / dt / Uw_p%GRAV
    if ((fer-fdr)*dp*umfkm1 .gt. emmax) then
       rei = emmax / dp / umfkm1 / (ee2-ud2)
       fer = rei * ee2
       fdr = rei * ud2
    end if
 end if

    fdrsat  = rei * (ud2-(1. - 2.*xsat + xsat**2.))

    if (fdr.ne.0) then
       fdrsat  = min(fdrsat/fdr, 1.)
    else
       fdrsat  = 0.
    end if
    fdrsat  = max(fdrsat, cpn%frac_drs)

  end subroutine mixing_k

!#####################################################################
!#####################################################################

  subroutine cumulus_plume_k (cpn, sd, ac, cp, rkm, cbmf, wrel, scaleh,&
                              Uw_p, ier, ermesg)       
  

    type(cpnlist),      intent(in)    :: cpn
    type(uw_params),    intent(inout) :: Uw_p
    type(sounding),     intent(in)    :: sd
    type(adicloud),     intent(in)    :: ac
    real,               intent(in)    :: rkm, cbmf, wrel, scaleh
    type(cplume),       intent(inout) :: cp
    integer,            intent(out)   :: ier
    character(len=*),   intent(out)   :: ermesg

    real, dimension(4)            :: totalmass
    integer                       :: tym
    real                          :: drop
   
    integer :: k, klm, km1, krel, let, ltop
    real    :: thv0rel, wtw, wtwtop
    real    :: thj, qvj, qlj, qij, qse, rhos0j, rho0j
    real    :: bogtop, bogbot, delbog, drage, expfac
    real    :: zrel, prel, nu, leff, qrj, qsj, temp
    real    :: qctu_new, hlu_new, qlu_new, qiu_new, clu_new, ciu_new
    real    :: scaleh1
    real    :: qct_env_k, hl_env_k
    real    :: t_mid, tv_mid, air_density, total_condensate,   &
               total_rain, total_snow, delta_tracer, delta_qn, wrel2, gamma
    real    :: cflim
    integer :: n
    logical :: kbelowlet

    ier = 0
    ermesg = ' '
    tym = size(totalmass,1)
    call cp_clear_k (cp)
    cp%p=sd%p; cp%ps=sd%ps; cp%dp=sd%dp; cp%u=sd%u; cp%v=sd%v;
    cp%hl=sd%hl; cp%thc=sd%thc; cp%qct=sd%qct; 
    cp%ql=sd%ql; cp%qi=sd%qi; cp%qa=sd%qa; cp%qn=sd%qn;
!++++yim
    cp%tr=sd%tr;
    cp%thvbot=sd%thvbot; cp%thvtop=sd%thvtop;
    cp%z=sd%z; cp%zs=sd%zs;

    wtw  = wrel*wrel
    wtwtop =  cpn%wtwmin_ratio * wtw

    delta_qn =0.

    !determine release height and parcel properties (krel, prel, thv0rel, thvurel)
    if(ac % plcl .gt. sd % pinv)then
       krel    = sd % kinv
       prel    = sd % pinv
       zrel    = sd % zinv
       thv0rel = sd % thvinv
    else
       krel    = ac % klcl
       prel    = ac % plcl
       zrel    = ac % zlcl
       thv0rel = ac % thv0lcl
    endif

    cp%krel=krel
    cp%prel=prel
    cp%zrel=zrel

    !(krel-1) represents the bottom of the updraft
    call findt_k (zrel,prel,ac%hlsrc,ac%qctsrc, thj, qvj, qlj,  &
                  qij, qse, cp%thvu(krel-1), cpn%do_ice, Uw_p)   
    cp%ps   (krel-1) = max(prel, cp%ps(krel)+1.) !prel
    cp%hlu  (krel-1) = ac % hlsrc
    cp%thcu (krel-1) = ac % thcsrc
    cp%qctu (krel-1) = ac % qctsrc
    cp%uu   (krel-1) = ac % usrc
    cp%vu   (krel-1) = ac % vsrc
    cp%umf  (krel-1) = cbmf*sd%rho(krel-1)/ac%rho0lcl
    cp%wu   (krel-1) = wrel
    cp%ufrc (krel-1) = cp%umf(krel-1)/(sd%rho(krel-1)*cp%wu(krel-1))
    cp%tru  (krel-1,:) = cp%tr(1,:)
    !==================================================
    !     yim's CONVECTIVE NUCLEATION
    !==================================================
    totalmass(1)=     sd%am1(krel-1); !totalmass(1)=aerol;
    totalmass(2)=     sd%am2(krel-1); !totalmass(2)=0.;
    totalmass(3)=     sd%am3(krel-1); !totalmass(3)=0.;
    totalmass(4)=     sd%am4(krel-1); !totalmass(4)=0.;
    if (SUM(totalmass(:)) /= 0.0 .and. cpn%use_online_aerosol) then
      wrel2 = wrel*cpn%wrel_min
      call aer_ccn_act_k(thj*exn_k(prel,Uw_p), prel, wrel2, totalmass, &
                         tym, drop, ier, ermesg)
      if (ier /= 0) then
        return
      endif
      cp%qnu(krel-1) = drop * 1.0e6 / (prel /    &
                      (Uw_p%rdgas*cp%thvu(krel-1)*exn_k(prel,Uw_p)))
    else
      drop = 0.
      cp%qnu(krel-1) = 0.0
    endif


    !(krel) represents the first partial updraft layer
    cp%z      (krel) = (cp%zs(krel-1) + cp%zs(krel))*0.5
    cp%p      (krel) = (cp%ps(krel-1) + cp%ps(krel))*0.5
    cp%dp     (krel) =  cp%ps(krel-1) - cp%ps(krel)   
    cp%thvbot (krel) = thv0rel
    if(krel.ne. sd % kinv) then
       cp%hl  (krel) = cp%hl (krel)+sd%sshl (krel)*  &
                                                (cp%p(krel)-sd%p(krel))
       cp%thc (krel) = cp%thc(krel)+sd%ssthc(krel)*   &
                                                (cp%p(krel)-sd%p(krel))
       cp%qct (krel) = cp%qct(krel)+sd%ssqct(krel)* &
                                               (cp%p(krel)-sd%p(krel))
       call findt_k (cp%z(krel),cp%p(krel),cp%hl(krel), cp%qct(krel), &
                     thj, qvj, qlj, qij, qse, cp%thvu(krel),  &
                     cpn%do_ice, Uw_p)
    endif

    !Compute updraft properties above the LCL
    kbelowlet=.true.
    let=krel
    klm=sd%ktopconv-1
    do k=krel,klm
       km1=k-1
       hl_env_k  = cp%hl(k)
       qct_env_k = cp%qct(k)

       !Calculation entrainment and detrainment rate
       if (cpn%mixing_assumption.eq.0) then
          scaleh1 = scaleh
          call mixing_k (cpn, cp%z(k), cp%p(k), hl_env_k, cp%thc(k), &
                         qct_env_k, cp%hlu(km1), cp%thcu(km1),  &
                         cp%qctu(km1), cp%wu(km1), scaleh1, cp%rei(k), &
                         cp%fer(k), cp%fdr(k), cp%fdrsat(k), rho0j, &
                         rkm, Uw_p, cp%umf(km1), cp%dp(k), sd%delt)      
       else if (cpn%mixing_assumption.eq.1) then
          temp         = sqrt(cp%ufrc(km1)) !scaleh for fixed length scale for donner_plumes
          rho0j        = sd%rho(k)
          cp%rei(k)    = rkm/temp/Uw_p%grav/rho0j
          cp%fer(k)    = cp%rei(k)
          cp%fdr(k)    = 0.
          cp%fdrsat(k) = 0.
       else if (cpn%mixing_assumption.eq.2) then
          scaleh1 = max(1000., cp%z(k))
          call mixing_k (cpn, cp%z(k), cp%p(k), hl_env_k, cp%thc(k), &
                         qct_env_k, cp%hlu(km1), cp%thcu(km1),  &
                         cp%qctu(km1), cp%wu(km1), scaleh1, cp%rei(k), &
                         cp%fer(k), cp%fdr(k), cp%fdrsat(k), rho0j, &
                         rkm, Uw_p, cp%umf(km1), cp%dp(k), sd%delt)      
       else if (cpn%mixing_assumption.eq.3) then
          scaleh1 = cpn%t00*Uw_p%rdgas/Uw_p%grav*log(cp%p(1)/cp%p(k))
          scaleh1 = max (1000., scaleh1)
          call mixing_k (cpn, cp%z(k), cp%p(k), hl_env_k, cp%thc(k), &
                         qct_env_k, cp%hlu(km1), cp%thcu(km1),      &
                         cp%qctu(km1), cp%wu(km1), scaleh1, cp%rei(k), &
                         cp%fer(k), cp%fdr(k), cp%fdrsat(k), rho0j, &
                         rkm, Uw_p, cp%umf(km1), cp%dp(k), sd%delt)
       else if (cpn%mixing_assumption.eq.4) then
          scaleh1 = 2000.
          call mixing_k (cpn, cp%z(k), cp%p(k), hl_env_k, cp%thc(k), &
                         qct_env_k, cp%hlu(km1), cp%thcu(km1),  &
                         cp%qctu(km1), cp%wu(km1), scaleh1, cp%rei(k), &
                         cp%fer(k), cp%fdr(k), cp%fdrsat(k), rho0j, &
                         rkm, Uw_p, cp%umf(km1), cp%dp(k), sd%delt)
       else
          scaleh1 = cpn%t00*Uw_p%rdgas/Uw_p%grav*log(cp%p(1)/cp%p(k))
          scaleh1 = max (1000., scaleh1)
          call mixing_k (cpn, cp%z(k), cp%p(k), hl_env_k, cp%thc(k), &
                         qct_env_k, cp%hlu(km1), cp%thcu(km1),      &
                         cp%qctu(km1), cp%wu(km1), scaleh1, cp%rei(k), &
                         cp%fer(k), cp%fdr(k), cp%fdrsat(k), rho0j, &
                         rkm, Uw_p, cp%umf(km1), cp%dp(k), sd%delt)
       end if

       !Calculate the mass flux
       cp%umf(k)=cp%umf(km1)*exp(cp%dp(k)*(cp%fer(k)-cp%fdr(k)))
       cp%emf(k)=0.0

       !Thermodynamics for the dilute plume
       cp%hlu (k)=hl_env_k -(hl_env_k -cp%hlu (km1))*  &
                                            exp(-cp%fer(k)*cp%dp(k))
       cp%qctu(k)=qct_env_k-(qct_env_k-cp%qctu(km1))*  &
                                            exp(-cp%fer(k)*cp%dp(k))
       cp%qnu (k)=cp%qn (k)-(cp%qn (k)-cp%qnu (km1))*  &
                                            exp(-cp%fer(k)*cp%dp(k))
       cp%tru (k,:)=cp%tr (k,:)-(cp%tr (k,:)-cp%tru (km1,:))*  &
                                            exp(-cp%fer(k)*cp%dp(k))
       if(cp%fer(k)*cp%dp(k).lt.1.e-4)then
          cp%uu(k)=cp%uu(km1) - sd%dudp(k)*cp%dp(k)
          cp%vu(k)=cp%vu(km1) - sd%dvdp(k)*cp%dp(k)
       else
          cp%uu(k)=cp%u(k)-cpn%bigc*sd%dudp(k)/cp%fer(k)-  &
                   exp(-cp%fer(k)*cp%dp(k))* &
                  (cp%u(k)-cpn%bigc*sd%dudp(k)/cp%fer(k) - cp%uu(km1))
          cp%vu(k)=cp%v(k)-cpn%bigc*sd%dvdp(k)/cp%fer(k)-  &
                   exp(-cp%fer(k)*cp%dp(k))* &
                  (cp%v(k)-cpn%bigc*sd%dvdp(k)/cp%fer(k) - cp%vu(km1))
       endif
       if (cpn%mp_choice.eq.0) then
          call micro_donner_k (cpn, cp%zs(k), cp%ps(k), cp%hlu(k), &
                               cp%qctu(k), cp%zs(km1), cp%qlu(km1), &
                               cp%clu(km1), cp%qiu(km1), cp%ciu(km1), &
                               cp%wu(km1), cp%crate(k), cp%prate(k),   &
                               qrj, qsj, qlu_new, clu_new, qiu_new, &
                               ciu_new, hlu_new, qctu_new, temp, &
                               cpn%do_ice, Uw_p)
       else if (cpn%mp_choice.eq.1) then
          call precipitation_k (cp%zs(k), cp%ps(k), cp%hlu(k), &
                                cp%qctu(k), cp%qnu(k), cpn, qrj, qsj, &
                                hlu_new, qctu_new, qlu_new, qiu_new, &
                                clu_new, ciu_new, temp, cpn%do_ice, &
                                delta_qn, Uw_p, kbelowlet)        
       else if (cpn%mp_choice.eq.2) then
          call precip_new_k    (cp%zs(k), cp%ps(k), cp%hlu(k), &
                                cp%qctu(k), cp%qnu(k), cpn, qrj, qsj, &
                                hlu_new, qctu_new, qlu_new, qiu_new, &
                                clu_new, ciu_new, temp, cpn%do_ice, &
                                delta_qn, Uw_p, kbelowlet, sd%land, sd%delt, cp%wu(km1))
       else if (cpn%mp_choice.eq.3) then
          call precip3_k       (cp%zs(k), cp%ps(k), cp%hlu(k), &
                                cp%qctu(k), cp%qnu(k), cpn, qrj, qsj, &
                                hlu_new, qctu_new, qlu_new, qiu_new, &
                                clu_new, ciu_new, temp, cpn%do_ice, &
                                delta_qn, Uw_p, kbelowlet)        
       else if (cpn%mp_choice.eq.4) then
          call precip4_k (cp%zs(k), cp%ps(k), cp%hlu(k), &
                                cp%qctu(k), cp%qnu(k), cpn, qrj, qsj, &
                                hlu_new, qctu_new, qlu_new, qiu_new, &
                                clu_new, ciu_new, temp, cpn%do_ice, &
                                delta_qn, Uw_p, kbelowlet)        
       else if (cpn%mp_choice.eq.5) then
          call precip5_k (cp%zs(k), cp%ps(k), cp%hlu(k), &
                                cp%qctu(k), cp%qnu(k), cpn, qrj, qsj, &
                                hlu_new, qctu_new, qlu_new, qiu_new, &
                                clu_new, ciu_new, temp, cpn%do_ice, &
                                delta_qn, Uw_p, kbelowlet, sd%dp(k))        
       end if

       cp%qctu(k)=qctu_new
       cp%hlu (k)=hlu_new
       cp%qlu (k)=qlu_new
       cp%qiu (k)=qiu_new
       cp%clu (k)=clu_new
       cp%ciu (k)=ciu_new
       cp%peff(k)=(qrj+qsj)/max(qlu_new+qiu_new+qrj+qsj,1.e-28);

       cp%thvu(k)=temp/exn_k(cp%ps(k),Uw_p)*(1.+Uw_p%zvir*(cp%qctu(k)-cp%qlu(k)-cp%qiu(k))-cp%qlu(k)-cp%qiu(k))
       cp%buo (k)=(cp%thvu(k)-cp%thvtop(k))!/cp%thvtop(k)*Uw_p%grav
       cp%t   (k)=temp
       nu = max(min((268. - temp)/20.,1.0),0.0)
       leff = (1-nu)*Uw_p%HLv + nu*Uw_p%HLs
       cp%thcu(k)=temp/exn_k(cp%ps(k),Uw_p)

       !Calculate vertical velocity
!!$       bogbot = (cp%thvu(km1)/cp%thvbot(k) - 1.)
!!$       if(bogbot.gt.0.)then
!!$          bogbot =  bogbot /cpn%rbuoy
!!$       else
!!$          bogbot =  bogbot*cpn%rbuoy
!!$       endif
!!$       bogtop = (cp%thvu(k)/cp%thvtop(k) - 1.)
!!$       if(bogtop.gt.0.)then
!!$          bogtop =  bogtop /cpn%rbuoy
!!$       else
!!$          bogtop =  bogtop*cpn%rbuoy
!!$       endif

       bogbot = (cp%thvu(km1)/cp%thvbot(k) - 1.)
       bogbot =  bogbot*cpn%rbuoy
       bogtop = (cp%thvu(k)/cp%thvtop(k) - 1.)
       bogtop =  bogtop*cpn%rbuoy

       if(bogbot.gt.0.and.bogtop.gt.0) then
          let = k
          kbelowlet = .true.
       else
          kbelowlet = .false.
       end if

       delbog = bogtop - bogbot
       drage = cp%fer(k) * ( 1. + cpn%rdrag )
       expfac = exp(-2.* drage * cp%dp(k))
       if(drage * cp%dp(k).gt.1.e-3) then
          wtw = wtw*expfac + (delbog + (1.-expfac) *               &
               (bogbot+delbog/(-2.*drage*cp%dp(k))))/(rho0j*drage)
       else
          wtw = wtw + cp%dp(k) * (bogbot+bogtop)/rho0j
       endif
       wtwtop = max( cpn%wtwmin_ratio * wtw, wtwtop )

       if (cpn%do_forcedlifting) then
          if (wtw.le.0. .and. k <= ac%klfc) then
             wtw=wrel*wrel
!         else if (wtw.le.0.) then
           else if (wtw.le.wtwtop) then
             exit
          end if
       else
!         if(wtw.le.0.) exit
          if(wtw.le.wtwtop) exit
       end if

       cp%wu(k) = sqrt(wtw)
       if(cp%wu(k).gt.100.)then
          print *, 'Very big wu in UW-ShCu',bogbot,bogtop,expfac,cp%fer(k)
          return
       endif
       
       rhos0j     = cp%ps(k)/(Uw_p%rdgas*0.5*(cp%thvbot(k+1)+  &
                                    cp%thvtop(k))*exn_k(cp%ps(k),Uw_p))
       cp%ufrc(k) = cp%umf(k)/(rhos0j*max(cp%wu(k), cpn%wmin))
       cflim = MIN(cpn%rmaxfrac, cp%maxcldfrac)
       if(cp%ufrc(k).gt.cflim        )then
          cp%ufrc(k) = cflim
          cp%umf (k) = cflim         * rhos0j * cp%wu(k)
          cp%fdr (k) = cp%fer(k)-log(cp%umf(k)/cp%umf(km1))/cp%dp(k)
       endif
       cp%pptr(k) = qrj*cp%umf(k)
       cp%ppti(k) = qsj*cp%umf(k)
       cp%pptn(k) = delta_qn*cp%umf(k)
!temperature (at full level)    
       t_mid = 0.5 * (cp%t(k) + cp%t(km1))
! virtual temperature (at full level)
       tv_mid = 0.5 * ( cp%t(k) * (1+Uw_p%zvir*(cp%qctu(k)-  &
                                               cp%qlu(k)-cp%qiu(k))) &
               + cp%t(km1) * (1+Uw_p%zvir*(cp%qctu(km1)-   &
                                             cp%qlu(km1)-cp%qiu(km1))) )
! air density (kg/m3)
       air_density = 0.5*(cp%ps(km1)+cp%ps(k)) / (Uw_p%rdgas*tv_mid)
       total_condensate = cp%qlu(k) + cp%qiu(k) + qrj + qsj ! kg/kg
       total_rain = qrj * air_density ! kg/m3
       total_snow = qsj * air_density ! kg/m3
       if (total_rain+total_snow > 0.) then
          do n=1,size(cp%tru,2)
             if (cpn%wetdep(n)%Lwetdep) then
                call wet_deposition_0D( cpn%wetdep(n)%Henry_constant, &
                                        cpn%wetdep(n)%Henry_variable, &
                                        cpn%wetdep(n)%frac_in_cloud, &
                                        cpn%wetdep(n)%alpha_r, &
                                        cpn%wetdep(n)%alpha_s, &
                                        t_mid, cp%ps(km1), cp%ps(k), &
                                        air_density, &
                                        total_condensate, total_rain, total_snow, &
                                        cp%tru(k,n), &
                                        cpn%wetdep(n)%Lgas, cpn%wetdep(n)%Laerosol, cpn%wetdep(n)%Lice, &
                                        delta_tracer )
                cp%tru_dwet(k,n) = -delta_tracer ! tracer source from wet deposition (negative=sink)
                cp%tru(k,n) = cp%tru(k,n) - delta_tracer ! adjust in-cloud concentration for wet dep
             end if
       end do
       end if
       
    enddo !End of Updraft Loop

    ltop = k 
    cp%umf (ltop) = 0.
    cp%pptr(ltop) = 0.
    cp%ppti(ltop) = 0.
    cp%pptn(ltop) = 0.
    cp%peff(ltop) = 0.

    cp%let    = let
    cp%ltop   = ltop
    cp%cldhgt = sd%z(ltop)-ac%zlcl
    !Restriction of convection too deep or too shallow
    if(cp%cldhgt.ge.cpn%cldhgt_max .or. ltop.lt.krel+2 .or.   &
                                                   let.le.krel+1) then
       return
    endif

    !convective scale height
    cp % cush=sd%z(ltop) - sd%zs(0)

    if (cpn%mixing_assumption.eq.2) then
    	 cp % cush = cpn%t00*Uw_p%rdgas/Uw_p%grav*log(cp%p(1)/cp%p(k))
    endif	 

    if (cpn%do_ppen) then !Calculate penetrative entrainment
       call penetrative_mixing_k(cpn, sd, Uw_p, cp) 
    else
       cp%fdr(ltop) = 1./sd%dp(ltop)
    end if

    if (cpn%mixing_assumption.eq.1) then
       cp%fdr(ltop)    = 1./sd%dp(ltop)
       cp%fdrsat(ltop) = 1.
    end if

  end subroutine cumulus_plume_k


!++++yim
  subroutine precipitation_k (zs, ps, hlu, qctu, qnu, cpn, qrj, qsj, &
                              hlu_new, qctu_new, qlu_new, qiu_new, &
                              clu_new, ciu_new, temp, doice, delta_qn, &
                              Uw_p, kbelowlet)       
    type(cpnlist),  intent(in)    :: cpn
    type(uw_params),  intent(inout)    :: Uw_p
    real,           intent(in)    :: zs, ps, hlu, qctu
    real,           intent(inout)    :: qnu, delta_qn
    real,           intent(inout) :: qrj, qsj, hlu_new, qctu_new,  &
                                     qlu_new, qiu_new, clu_new,  &
                                     ciu_new, temp
    logical,        intent(in)    :: doice, kbelowlet

    real    :: thj, qvj, qlj, qij, qse, thvj, nu, exnj,  &
               auto_th, leff, pcp, qctmp, deltaqc, auto_th2

    !Precip at the flux level
    call findt_k (zs,ps,hlu,qctu,thj,qvj,qlj,qij,qse,thvj,doice, &
                  Uw_p)  
    exnj=exn_k(ps,Uw_p)
    temp=thj*exnj-273.15
    if (temp.ge.0.0) then
       auto_th=cpn%auto_th0
    else
       auto_th=cpn%auto_th0*(1.0-temp/cpn%tcrit)
    end if
    auto_th=max(auto_th,0.0)

    if (.not.kbelowlet) auto_th=1.e10

    temp=temp+273.15

  if (.not.cpn%do_auto_aero) then
    qctmp   = qlj+qij;
    if (cpn%do_pdfpcp) then
       deltaqc = min(cpn%deltaqc0, auto_th)
       if (qctmp .lt. (auto_th - deltaqc)) then
          pcp = 0.
       else if (qctmp .lt. (auto_th + deltaqc)) then
          pcp = (qctmp + deltaqc - auto_th)**2./(4.*deltaqc)
       else
          pcp = qctmp-auto_th
       end if
    else
       pcp = max(qctmp-auto_th,0.)
    end if
    qctmp = 1./max(qctmp,1.e-28)
    qrj = pcp*qlj*qctmp
    qsj = pcp*qij*qctmp
    nu  = max(min((268. - temp)/20.,1.0),0.0)
 
    if (qlj.le.0) then
       delta_qn = -qnu
       qnu = 0
    else
       delta_qn = qnu * qrj * qctmp
       qnu      = qnu - delta_qn
    end if
 else
      auto_th2 = max (4.18667e-15*qnu*cpn%rad_crit**3., 0.0)
      if((qlj+qij).gt.auto_th)then
        qsj = (qlj+qij-auto_th)*qij/(qlj+qij)
        nu = max(min((268. - temp)/20.,1.0),0.0)
      else
        qsj = 0.0
        nu  = 0.0
      endif
 
      if(qlj .gt. auto_th2)then
        qrj = qlj-auto_th2
        nu = max(min((268. - temp)/20.,1.0),0.0)
!++++yim in-cloud removal of dropelts
        delta_qn = qnu
        if (qlj .gt. 0.) then
          qnu = qnu*auto_th2/qlj
        else
          qnu = 0.
        end if
        delta_qn = delta_qn - qnu
      else
        qrj = 0.0
        nu  = 0.0
        delta_qn = 0.
      endif
 end if

    leff     = (1-nu)*Uw_p%HLv + nu*Uw_p%HLs
    qctu_new = qctu - (qrj + qsj)
    hlu_new  = hlu  + (qrj + qsj)*leff
    qlu_new  = qlj - qrj
    qiu_new  = qij - qsj
    clu_new  = qlu_new
    ciu_new  = qiu_new

    return
    
  end subroutine precipitation_k


  subroutine precip5_k (zs, ps, hlu, qctu, qnu, cpn, qrj, qsj, &
                              hlu_new, qctu_new, qlu_new, qiu_new, &
                              clu_new, ciu_new, temp, doice, delta_qn, &
                              Uw_p, kbelowlet, delp)       
    type(cpnlist),  intent(in)    :: cpn
    type(uw_params),  intent(inout)    :: Uw_p
    real,           intent(in)    :: zs, ps, hlu, qctu, delp
    real,           intent(inout)    :: qnu, delta_qn
    real,           intent(inout) :: qrj, qsj, hlu_new, qctu_new,  &
                                     qlu_new, qiu_new, clu_new,  &
                                     ciu_new, temp
    logical,        intent(in)    :: doice, kbelowlet

    real    :: thj, qvj, qlj, qij, qse, thvj, nu, exnj,  &
               auto_th, leff, pcp, qctmp, deltaqc, auto_th2, peff

    !Precip at the flux level
    call findt_k (zs,ps,hlu,qctu,thj,qvj,qlj,qij,qse,thvj,doice, &
                  Uw_p)  
    exnj=exn_k(ps,Uw_p)
    temp=thj*exnj-273.15
    if (temp.ge.0.0) then
       peff=cpn%peff_l*delp
    else
       peff=cpn%peff_i*delp
    end if
    peff=max(1.0-peff,0.0)

    if (.not.kbelowlet) peff=0.0

    temp=temp+273.15

    qctmp   = qlj+qij;
    pcp = max(qctmp*peff,0.)
    qctmp = 1./max(qctmp,1.e-28)
    qrj = pcp*qlj*qctmp
    qsj = pcp*qij*qctmp
    nu  = max(min((268. - temp)/20.,1.0),0.0)
 
    if (qlj.le.0) then
       delta_qn = -qnu
       qnu = 0
    else
       delta_qn = qnu * qrj * qctmp
       qnu      = qnu - delta_qn
    end if

    leff     = (1-nu)*Uw_p%HLv + nu*Uw_p%HLs
    qctu_new = qctu - (qrj + qsj)
    hlu_new  = hlu  + (qrj + qsj)*leff
    qlu_new  = qlj - qrj
    qiu_new  = qij - qsj
    clu_new  = qlu_new
    ciu_new  = qiu_new

    return
    
  end subroutine precip5_k


  subroutine precip4_k (zs, ps, hlu, qctu, qnu, cpn, qrj, qsj, &
                              hlu_new, qctu_new, qlu_new, qiu_new, &
                              clu_new, ciu_new, temp, doice, delta_qn, &
                              Uw_p, kbelowlet)       
    type(cpnlist),  intent(in)    :: cpn
    type(uw_params),  intent(inout)    :: Uw_p
    real,           intent(in)    :: zs, ps, hlu, qctu
    real,           intent(inout)    :: qnu, delta_qn
    real,           intent(inout) :: qrj, qsj, hlu_new, qctu_new,  &
                                     qlu_new, qiu_new, clu_new,  &
                                     ciu_new, temp
    logical,        intent(in)    :: doice, kbelowlet

    real    :: thj, qvj, qlj, qij, qse, thvj, nu, exnj,  &
               auto_th, leff, pcp, qctmp, deltaqc, auto_th2, peff

    !Precip at the flux level
    call findt_k (zs,ps,hlu,qctu,thj,qvj,qlj,qij,qse,thvj,doice, &
                  Uw_p)  
    exnj=exn_k(ps,Uw_p)
    temp=thj*exnj-273.15
    if (temp.ge.0.0) then
       peff=cpn%peff_l
    else
!      peff=(1.0-cpn%peff)*min(temp/cpn%tcrit,1.0)
       peff=cpn%peff_i
    end if
!    peff=max(1.0-peff,0.0)

    if (.not.kbelowlet) peff=0.0

    temp=temp+273.15

    qctmp   = qlj+qij;
    pcp = max(qctmp*peff,0.)
    qctmp = 1./max(qctmp,1.e-28)
    qrj = pcp*qlj*qctmp
    qsj = pcp*qij*qctmp
    nu  = max(min((268. - temp)/20.,1.0),0.0)
 
    if (qlj.le.0) then
       delta_qn = -qnu
       qnu = 0
    else
       delta_qn = qnu * qrj * qctmp
       qnu      = qnu - delta_qn
    end if

    leff     = (1-nu)*Uw_p%HLv + nu*Uw_p%HLs
    qctu_new = qctu - (qrj + qsj)
    hlu_new  = hlu  + (qrj + qsj)*leff
    qlu_new  = qlj - qrj
    qiu_new  = qij - qsj
    clu_new  = qlu_new
    ciu_new  = qiu_new

    return
    
  end subroutine precip4_k


  subroutine precip3_k (zs, ps, hlu, qctu, qnu, cpn, qrj, qsj, &
                              hlu_new, qctu_new, qlu_new, qiu_new, &
                              clu_new, ciu_new, temp, doice, delta_qn, &
                              Uw_p, kbelowlet)       
    type(cpnlist),  intent(in)    :: cpn
    type(uw_params),  intent(inout)    :: Uw_p
    real,           intent(in)    :: zs, ps, hlu, qctu
    real,           intent(inout)    :: qnu, delta_qn
    real,           intent(inout) :: qrj, qsj, hlu_new, qctu_new,  &
                                     qlu_new, qiu_new, clu_new,  &
                                     ciu_new, temp
    logical,        intent(in)    :: doice, kbelowlet

    real    :: thj, qvj, qlj, qij, qse, thvj, nu, exnj,  &
               auto_th, leff, pcp, qctmp, deltaqc, peff

    !Precip at the flux level
    call findt_k (zs,ps,hlu,qctu,thj,qvj,qlj,qij,qse,thvj,doice, &
                  Uw_p)  
    exnj=exn_k(ps,Uw_p)
    temp=thj*exnj-273.15
    if (temp.ge.0.0) then
       auto_th=cpn%auto_th0
    else
       auto_th=cpn%auto_th0*(1.0-temp/cpn%tcrit)
    end if
    auto_th=max(auto_th,0.0)

    if (.not.kbelowlet) auto_th=1.e10

    temp=temp+273.15

    qctmp   = qlj+qij; 
    if (cpn%do_pdfpcp) then
       deltaqc = min(cpn%deltaqc0, auto_th)
       if (qctmp .lt. (auto_th - deltaqc)) then
          pcp = 0.
       else if (qctmp .lt. (auto_th + deltaqc)) then
          pcp = (qctmp + deltaqc - auto_th)**2./(4.*deltaqc)
       else
          pcp = qctmp-auto_th
       end if
    else
       pcp = max(qctmp-auto_th,0.)
    end if

    if (temp.ge.0.0) then
       peff=cpn%peff_l
    else
       peff=cpn%peff_i
    end if
    pcp = qctmp*peff

    qctmp = 1./max(qctmp,1.e-28)
    qrj = pcp*qlj*qctmp
    qsj = pcp*qij*qctmp
    nu  = max(min((268. - temp)/20.,1.0),0.0)
    
    if (qlj.le.0) then
       delta_qn = -qnu
       qnu = 0
    else
       delta_qn = qnu * qrj * qctmp
       qnu      = qnu - delta_qn
    end if

    leff     = (1-nu)*Uw_p%HLv + nu*Uw_p%HLs
    qctu_new = qctu - (qrj + qsj)
    hlu_new  = hlu  + (qrj + qsj)*leff
    qlu_new  = qlj - qrj
    qiu_new  = qij - qsj
    clu_new  = qlu_new
    ciu_new  = qiu_new

    return
    
  end subroutine precip3_k



  subroutine precip_new_k    (zs, ps, hlu, qctu, qnu, cpn, qrj, qsj, &
                              hlu_new, qctu_new, qlu_new, qiu_new, &
                              clu_new, ciu_new, temp, doice, delta_qn, &
                              Uw_p, kbelowlet, land, delt, wu)
    type(cpnlist),  intent(in)    :: cpn
    type(uw_params),  intent(inout)    :: Uw_p
    real,           intent(in)    :: zs, ps, hlu, qctu, land, delt, wu
    real,           intent(inout)    :: qnu, delta_qn
    real,           intent(inout) :: qrj, qsj, hlu_new, qctu_new,  &
                                     qlu_new, qiu_new, clu_new,  &
                                     ciu_new, temp
    logical,        intent(in)    :: doice, kbelowlet

    real    :: thj, qvj, qlj, qij, qse, thvj, nu, exnj,  &
               auto_th, leff, pcp, qctmp
    real    :: Nl, fliq, ql0, qi0

    !Precip at the flux level
    call findt_k (zs,ps,hlu,qctu,thj,qvj,qlj,qij,qse,thvj,doice, &
                  Uw_p)  
    exnj=exn_k(ps,Uw_p)
    temp=thj*exnj
    qctmp = qlj+qij; 
    if (qctmp > 0.0) then
       Nl = cpn%Nl_land*land + cpn%Nl_ocean*(1.-land) !Nl is mixing ratio=(1/m3)/(kg/m3)
       fliq = qlj/qctmp;

       !ql0=(4./3.*pi*1000) * (12.e-6)^3. * (100.e6) = 7.238e-4kg/kg
       ql0 =4188.79 * (cpn%r_thresh)**3. * Nl !4188.79=4/3*pi*1000; Nl=N/rho=N0/rho0;
       if (temp.ge.248.) then
          qi0 =cpn%qi_thresh
       else
          qi0 =cpn%qi_thresh*min(max(1.0+(248.-temp)/(cpn%tcrit+25.15),0.0),1.0)
       end if

       if (qij.eq.0.0) then
          auto_th=ql0
       else if (qlj.eq.0.0) then
          auto_th=qi0
       else
          auto_th=ql0*fliq+qi0*(1.-fliq)
       end if

       if (cpn%do_weffect) then
          auto_th=auto_th*(max(wu,1.))**cpn%weffect
       end if

       if (.not.kbelowlet) auto_th=1.e10

!       pcp = max(qctmp-auto_th,0.)*cpn%peff*delt/(1.+cpn%peff*delt)
!       pcp = max(qctmp-auto_th,0.)*cpn%peffdelt
       pcp = max(qctmp-auto_th,0.)

       qrj = pcp*fliq
       qsj = pcp*(1.-fliq)
       nu  = max(min((268. - temp)/20.,1.0),0.0)
    
       if (qlj.le.0) then
          delta_qn = -qnu
          qnu = 0
       else
          delta_qn = qnu * qrj / qctmp
          qnu      = qnu - delta_qn
       end if
       leff     = (1-nu)*Uw_p%HLv + nu*Uw_p%HLs
       qctu_new = qctu - (qrj + qsj)
       hlu_new  = hlu  + (qrj + qsj)*leff
       qlu_new  = qlj - qrj
       qiu_new  = qij - qsj
       clu_new  = qlu_new
       ciu_new  = qiu_new
    else
       qrj      = 0.
       qsj      = 0.
       qctu_new = qctu
       hlu_new  = hlu  
       qlu_new  = qlj 
       qiu_new  = qij 
       clu_new  = qlu_new
       ciu_new  = qiu_new
    end if

    return
    
  end subroutine precip_new_k



  subroutine micro_donner_k (cpn, zs, ps, hlu, qctu, zs1, qlu1, clu1, &
                             qiu1, ciu1, w1, cr12, pr12, qrj, qsj, &
                             qlu_new, clu_new, qiu_new, ciu_new, &
                             hlu_new, qctu_new, temp, doice, Uw_p)       
    type(cpnlist),  intent(in)    :: cpn
    type(uw_params),  intent(inout)    :: Uw_p
    real,           intent(in)    :: zs, ps, hlu, qctu
    real,           intent(in)    :: zs1, qlu1, clu1, qiu1, ciu1, w1
    real,           intent(inout) :: qrj, qsj, cr12, pr12
    real,           intent(inout) :: qlu_new, clu_new, qiu_new, &
                                     ciu_new, hlu_new, qctu_new, temp
    logical,        intent(in)    :: doice

    real    :: thj, qvj, qlj, qij, qse, thvj, nu, leff
    real    :: dt_micro, rw1, cw1, drwa, drwb, flw, rw2, cw2, pw2, dcw

    call findt_k (zs,ps,hlu,qctu,thj,qvj,qlj,qij,qse,thvj,doice, &
                  Uw_p)   
    temp = thj*exn_k(ps,Uw_p)
    if (doice) then
      nu   = max(min((268. - temp)/20.,1.0),0.0)
    else
      nu = 0.
    endif

    leff = (1.-nu)*Uw_p%HLv + nu*Uw_p%HLs
    if (qlj+qij .gt. 0.0) then
       flw  = qlj/(qlj+qij)
    else
       qrj      = 0.
       qsj      = 0.
       qlu_new  = 0.
       qiu_new  = 0.
       qctu_new = qctu
       hlu_new  = hlu
       clu_new  = 0.
       ciu_new  = 0.
       return
    end if

    cw1 = clu1 + ciu1

    rw1 = qlu1 + qiu1 - cw1
    rw1 = max(rw1, 0.0)

    cw2 = qlj + qij - rw1

    dcw = cw2 - cw1; 

    dt_micro = (zs - zs1) / w1

    cr12 = dcw/dt_micro

    drwa = cpn%auto_rate * (cw2 - cpn%auto_th0) * dt_micro

    drwa=min(max(drwa, 0.0), cw2-cpn%auto_th0)

    cw2 = cw2 - drwa

    drwb = 5.26e-03 * cw2 * (rw1**0.875) * dt_micro

    drwb=min(max(drwb, 0.0), cw2)

    cw2 = cw2 - drwb

    rw2 = rw1 + drwa + drwb

    rw2 = max(rw2, 0.0)

    pw2 = 5.1*(rw2**1.125)*dt_micro/100.

    pw2 =min(pw2, rw2)

    pw2 = min(pw2, qlj + qij)

    pr12=pw2/dt_micro
   
    rw2 =rw2-pw2

    qrj = pw2*flw
    qsj = pw2*(1.-flw)

    qlu_new  = qlj - qrj
    qiu_new  = qij - qsj
    qctu_new = qctu - (qrj + qsj)
    hlu_new  = hlu  + (qrj + qsj)*leff

    cw2 = max(qlu_new + qiu_new -rw2, 0.0)
    clu_new = cw2*flw
    ciu_new  = cw2*(1. - flw)

    if (qlu_new .lt. 0. .or. qiu_new .lt. 0. .or. clu_new .lt. 0.0 .or.&
        ciu_new .lt. 0.0) then
       print*, qlu_new, qiu_new, clu_new, ciu_new,   &
                             qrj, qsj, qlj, qij, '??????????????????'
    end if
    return
    
  end subroutine micro_donner_k



!#####################################################################
!#####################################################################

  subroutine penetrative_mixing_k(cpn, sd, Uw_p, cp)
    type(cpnlist),  intent(in)    :: cpn
    type(sounding), intent(in)    :: sd
    type(uw_params),   intent(inout) :: Uw_p
    type(cplume),   intent(inout) :: cp

    integer :: k, ltop, let
    real    :: rhos0j, bogtop, bogbot
    real    :: aquad, bquad, cquad, xs1, xs2, ppen
    real    :: thj, qvj, qse, thvj, qctulet, hlulet, umflet
    real    :: dqct1, dqct2, qctflxkm1, tmp

    ltop=cp%ltop
    let =cp%let

    cp % emf (ltop)  = 0.0
    cp % fdr (ltop)  = 0.0
    cp % hlu (ltop)  = cp % hl (ltop)
    cp % qctu(ltop)  = cp % qct(ltop)
    cp % qlu (ltop)  = cp % ql (ltop)
    cp % qiu (ltop)  = cp % qi (ltop)
    cp % tru (ltop,:)= cp % tr (ltop,:)

    qctulet = cp%qctu(let)
    hlulet  = cp%hlu (let)
    umflet  = cp%umf (let)

    do k=ltop-1,let,-1

       cp%fdr(k)  = 0.
       cp%qlu(k)  = cp%ql(k)
       cp%qiu(k)  = cp%qi(k)

       rhos0j = cp%ps(k) /(Uw_p%rdgas*0.5*   &
                     (cp%thvbot(k+1)+cp%thvtop(k))*exn_k(cp%ps(k),Uw_p))
       if(k.eq.ltop-1)then
          !Calculate ppen
!!$          bogbot = (cp%thvu(k)/cp%thvbot(ltop) - 1.)/cpn%rbuoy
!!$          if(bogbot.gt.0.)then
!!$             bogbot =  bogbot /cpn%rbuoy
!!$          else
!!$             bogbot =  bogbot*cpn%rbuoy
!!$          endif
!!$          bogtop = (cp%thvu(ltop)/cp%thvtop(ltop) - 1.)/cpn%rbuoy
!!$          if(bogtop.gt.0.)then
!!$             bogtop =  bogtop /cpn%rbuoy
!!$          else
!!$             bogtop =  bogtop*cpn%rbuoy
!!$          endif

          bogbot = (cp%thvu(k)/cp%thvbot(ltop) - 1.)
          bogbot =  bogbot*cpn%rbuoy
          bogtop = (cp%thvu(ltop)/cp%thvtop(ltop) - 1.)
          bogtop =  bogtop*cpn%rbuoy

          aquad = (bogtop - bogbot) / (cp%ps(ltop)-cp%ps(k))
          bquad = 2*bogbot
          cquad = -cp%wu(k) * cp%ps(k) /   &
                      (Uw_p%rdgas*cp%thvbot(ltop)*exn_k(cp%ps(k),Uw_p))
          call roots(aquad,bquad,cquad,xs1,xs2)
          if(xs1.le.0..and.xs2.le.0.)then
             ppen = max(xs1,xs2)
          else
             ppen = min(xs1,xs2)
          endif
          ppen = min(0.,max(-cp%dp(k+1),ppen))
          if(xs1.eq.-9.99e33.or.xs2.eq.-9.99e33) ppen=0.
          !Calculate returning mass flux
          cp%emf (k)=max(cp%umf(k)*ppen*cp%rei(ltop)*  &
                                                 cpn%rpen,-0.1*rhos0j)
          cp%hlu (k)=cp%hl (ltop)+sd%sshl (ltop)*(cp%ps(k)-cp%p(ltop))
          cp%qctu(k)=cp%qct(ltop)+sd%ssqct(ltop)*(cp%ps(k)-cp%p(ltop))
          cp%tru(k,:)=cp%tr(ltop,:)+sd%sstr(ltop,:)*   &
                                                 (cp%ps(k)-cp%p(ltop))
       else
          cp%emf (k)=max(cp%emf(k+1)-cp%umf(k)*cp%dp(k+1)*  &
                                      cp%rei(k+1)*cpn%rpen,-0.1*rhos0j)
          if (cp%emf(k).ne.0) then
            cp%hlu (k)=(cp%hlu (k+1)*cp%emf(k+1)+cp%hl (k+1)* &
                                        (cp%emf(k)-cp%emf(k+1)))/cp%emf(k)
            cp%qctu(k)=(cp%qctu(k+1)*cp%emf(k+1)+cp%qct(k+1)*  &
                                        (cp%emf(k)-cp%emf(k+1)))/cp%emf(k)
            cp%tru(k,:)=(cp%tru(k+1,:)*cp%emf(k+1)+cp%tr(k+1,:)* &
                                        (cp%emf(k)-cp%emf(k+1)))/cp%emf(k)
          endif
       endif
       cp%umf(k)=0.0 
    enddo

    k=let
    cp%fdr (k) = 1./sd%dp(k)
    
 if (cpn%do_pmadjt) then
    dqct1=cp%qctu(k-1)-(cp%qct(k)  +sd%ssqct(k)  *(sd%ps(k-1)-sd%p(k)))
    dqct2=cp%qctu(k)  -(cp%qct(k)  +sd%ssqct(k)  *(sd%ps(k)-sd%p(k)))
    qctflxkm1=cp%umf(k-1)*dqct1
    if ((cp%emf(k)*dqct2.gt.qctflxkm1).and.(qctflxkm1.gt.0.).and.(dqct2.lt.0)) then
       tmp=qctflxkm1/dqct2/cp%emf(k)
       cp%emf=cp%emf*tmp
    end if

    tmp=umflet-cp%emf(k)
    if (tmp.gt.0) then
       qctulet = (umflet*qctulet - cp%emf(k)*cp%qctu(k))/tmp
       hlulet  = (umflet*hlulet  - cp%emf(k)*cp%hlu (k))/tmp
    else
       qctulet = cp%qctu(k)
       hlulet  = cp%hlu (k)
    end if
    call findt_k (cp%zs(k), cp%ps(k), hlulet, qctulet, thj, qvj,       &
                  cp%qlu(k), cp%qiu(k), qse, thvj, cpn%do_ice, Uw_p)
 end if

  end subroutine penetrative_mixing_k

!#####################################################################
!#####################################################################

  subroutine cumulus_tend_k(cpn, sd, Uw_p, cp, ct, do_coldT)
  
    type(cpnlist),  intent(in)    :: cpn
    type(uw_params),  intent(inout)    :: Uw_p
    type(sounding), intent(in)    :: sd
    type(cplume),   intent(inout) :: cp
    type(ctend),    intent(inout) :: ct
    logical,        intent(in)    :: do_coldT

    integer :: k, krel, ltop, kp1, km1, ktop, i
    real    :: dpsum, qtdef, hldef, umftmp, qlutmp, qiutmp, qnutmp, fdrtmp
    real, dimension(size(cp%tr,2)) :: trdef
    real    :: dpevap, x1, x2, x3, xx1, xx2, xx3, q1, q2, emftmp
    real    :: dqt

    call ct_clear_k (ct);

    krel=cp%krel
    ltop=cp%ltop

    ! Calculate Fluxes of heat, moisture, momentum
    dpsum = 0.0
    do k = 1, krel-1
       dpsum = dpsum + sd%dp(k)
    enddo

    qtdef = max(0.,cp%umf(krel)*(cp%qctu(krel) - cp%qct(krel)))
    trdef(:) = max(0.,cp%umf(krel)*(cp%tru(krel,:) - cp%tr(krel,:)))
    !yy1  = min(0.,umf(krel)*(thcu(krel) - thc0(krel)))
    hldef = min(0.,cp%umf(krel)*(cp%hlu (krel) - cp%hl (krel)))
    do k=1,krel-1
!      ct%hlflx (k)=0.0; 
       ct%hlflx (k)=0.0; !ct%hlflx (k-1) + hldef*sd%dp(k)/dpsum;
!      ct%thcflx(k)=0.0; !thcflx(k)=thcflx(k-1) + yy1*dp(k)/dpsum
       ct%qctflx(k)=ct%qctflx(k-1) + qtdef*sd%dp(k)/dpsum;
       ct%thcflx(k)=0.0;
       ct%trflx(k,:)=ct%trflx(k-1,:) + trdef(:)*sd%dp(k)/dpsum
       ct%qlflx(k)=0.0;
       ct%qiflx(k)=0.0;
       ct%qnflx(k)=0.0;
       ct%umflx(k)=0.0;
       ct%vmflx(k)=0.0;
       cp%pptr (k)=0.0; 
       cp%ppti (k)=0.0;
       cp%pptn (k)=0.0;
    enddo

    if (cpn%do_qctflx_zero) then
       do k=1,krel-1
          ct%qctflx(k) =0.;
          ct%trflx (k,:)=0.;
       end do
    end if

    do k = krel,ltop-1 !pzhu do k = krel,ltop
       kp1 = k+1

       ct%hlflx (k)= cp%umf(k)*(cp%hlu (k)-(cp%hl (kp1)+  &
                       sd%sshl (kp1)*(sd%ps(k)-sd%p(kp1)))) + &
                       cp%emf(k) * (cp%hlu (k)-  &
                           (cp%hl (k)+sd%sshl (k)*(sd%ps(k)-sd%p(k))))
       ct%thcflx(k)= cp%umf(k)*(cp%thcu(k)-(cp%thc(kp1)+  &
                        sd%ssthc(kp1)*(sd%ps(k)-sd%p(kp1)))) + &
                       cp%emf(k) * (cp%thcu(k)-  &
                            (cp%thc(k)+sd%ssthc(k)*(sd%ps(k)-sd%p(k))))
       ct%qctflx(k)= cp%umf(k)*(cp%qctu(k)-(cp%qct(kp1)+  &
                        sd%ssqct(kp1)*(sd%ps(k)-sd%p(kp1)))) + &
                       cp%emf(k) * (cp%qctu(k)-  &
                            (cp%qct(k)+sd%ssqct(k)*(sd%ps(k)-sd%p(k))))
       
       ct%umflx(k) =cp%umf(k) * (cp%uu(k) - cp%u(kp1))  +   &
                                      cp%emf(k) * (cp%u(kp1) -cp%u(k))
       ct%vmflx(k) =cp%umf(k) * (cp%vu(k) - cp%v(kp1))  +  &
                                      cp%emf(k) * (cp%v(kp1) -cp%v(k))

       ct%qlflx(k) =cp%umf(k) * (cp%qlu(k)- cp%ql(kp1)) +   &
                                      cp%emf(k) * (cp%ql(kp1)-cp%ql(k))
       ct%qiflx(k) =cp%umf(k) * (cp%qiu(k)- cp%qi(kp1)) +   &
                                      cp%emf(k) * (cp%qi(kp1)-cp%qi(k))
       ct%qaflx(k) =cp%umf(k) * (1.       - cp%qa(kp1)) +   &
                                       cp%emf(k) * (cp%qa(kp1)-cp%qa(k))
       ct%qnflx(k) =cp%umf(k) * (cp%qnu(k)- cp%qn(kp1)) +  &
                                      cp%emf(k) * (cp%qn(kp1)-cp%qn(k))

!++++yim
       ct%trflx(k,:) =cp%umf(k) * (cp%tru(k,:)- (cp%tr(kp1,:)+  &
                             sd%sstr(kp1,:)*(sd%ps(k)-sd%p(kp1))) ) + &
                       cp%emf(k) * (cp%tru(kp1,:)-   &
                         (cp%tr(k,:)+sd%sstr(k,:)*(sd%ps(k)-sd%p(k))) )
       ct%qvflx(k) =ct%qctflx(k)-ct%qlflx(k)-ct%qiflx(k)
    enddo

    do k = 2,ltop
       km1 = k-1
       kp1 = k+1
       x1=sd%p(k)   -sd%ps(k)
       x2=sd%ps(km1)-sd%p (k)
       x3=sd%ps(km1)-sd%ps(k)
       umftmp = (cp%umf(km1)*x1+cp%umf(k)*x2)/x3
       emftmp = (cp%emf(km1)*x1+cp%emf(k)*x2)/x3
       qlutmp = (cp%qlu(km1)*x1+cp%qlu(k)*x2)/x3
       qiutmp = (cp%qiu(km1)*x1+cp%qiu(k)*x2)/x3
       qnutmp = (cp%qnu(km1)*x1+cp%qnu(k)*x2)/x3

       fdrtmp = cp%fdrsat(k)*cp%fdr(k)
       ct%qldet(k) =  Uw_p%grav*(umftmp       )*(fdrtmp*(qlutmp-sd%ql(k)))
       ct%qidet(k) =  Uw_p%grav*(umftmp       )*(fdrtmp*(qiutmp-sd%qi(k)))
       ct%qadet(k) =  Uw_p%grav*(umftmp-emftmp)*(fdrtmp*(1.    -sd%qa(k)))
       ct%qndet(k) =  Uw_p%grav*(umftmp       )*(fdrtmp*(qnutmp-sd%qn(k)))

       x1 =sd%ps(k)  -sd%p (kp1)
       x2 =sd%p (k)  -sd%ps(k)
       x3 =sd%p (k)  -sd%p (kp1)
       xx1=sd%ps(km1)-sd%p (k)
       xx2=sd%p (km1)-sd%ps(km1)
       xx3=sd%p (km1)-sd%p (k)

       q2=(sd%ql(k)  *x1  + sd%ql(kp1)*x2  )/x3
       q1=(sd%ql(km1)*xx1 + sd%ql(k)  *xx2 )/xx3
       ct%qlten(k) = - Uw_p%grav*(umftmp * (sd%ql(k)-q2      )/x2 + &
                                  emftmp * (q1      -sd%ql(k))/xx1 )

       q2=(sd%qi(k)  *x1  + sd%qi(kp1)*x2  )/x3
       q1=(sd%qi(km1)*xx1 + sd%qi(k)  *xx2 )/xx3
       ct%qiten(k) = - Uw_p%grav*(umftmp * (sd%qi(k)-q2      )/x2 + &
                                  emftmp * (q1      -sd%qi(k))/xx1 )

       q2=(sd%qa(k)  *x1  + sd%qa(kp1)*x2  )/x3
       q1=(sd%qa(km1)*xx1 + sd%qa(k)  *xx2 )/xx3
       ct%qaten(k) = - Uw_p%grav*(umftmp * (sd%qa(k)-q2      )/x2 + &
                                  emftmp * (q1      -sd%qa(k))/xx1 )

       q2=(sd%qn(k)  *x1  + sd%qn(kp1)*x2  )/x3
       q1=(sd%qn(km1)*xx1 + sd%qn(k)  *xx2 )/xx3
       ct%qnten(k) = - Uw_p%grav*(umftmp * (sd%qn(k)-q2      )/x2 + &
                                  emftmp * (q1      -sd%qn(k))/xx1 )
    end do

    ct%qlten = ct%qlten + ct%qldet 
    ct%qiten = ct%qiten + ct%qidet
    ct%qaten = ct%qaten + ct%qadet
    ct%qnten = ct%qnten + ct%qndet

    if (cpn%do_detran_zero) then
       ct%qlten = 0.
       ct%qiten = 0.
       ct%qaten = 0.
       ct%qnten = 0.
    end if

    ! Calculate model tendencies
    do k = 1,ltop
       km1 = k-1
       kp1 = k+1
       ct%uten (k) = (ct%umflx(km1)-ct%umflx(k))*Uw_p%grav/sd%dp(k)
       ct%vten (k) = (ct%vmflx(km1)-ct%vmflx(k))*Uw_p%grav/sd%dp(k)

       ct%thcten(k) = (ct%thcflx(km1) - ct%thcflx(k))*   &
                                                   Uw_p%grav/sd%dp(k)
!      ct%hlten (k) = (ct%hlflx (km1) - ct%hlflx (k)   &
!            +(cp%pptr(k) + cp%ppti(k)) *sd%leff(k))*Uw_p%grav/sd%dp(k)
       ct%hlten (k) = (ct%hlflx (km1) - ct%hlflx (k) +   &
                       Uw_p%HLv*cp%pptr(k) + Uw_p%HLs*cp%ppti(k))* &
                                                      Uw_p%grav/sd%dp(k)
       ct%qctten(k) = (ct%qctflx(km1) - ct%qctflx(k) -   &
                           cp%pptr(k) - cp%ppti(k)) *Uw_p%grav/sd%dp(k)
       ct%qvten (k) = ct%qctten(k)-ct%qlten(k)-ct%qiten(k)
       ct%pflx  (k) = cp%pptr(k) + cp%ppti(k)

!      ct%tten  (k) = (ct%hlten(k)+sd%leff(k)*  &
!                                (ct%qlten(k)+ct%qiten(k)))/Uw_p%cp_air
       ct%tten  (k) = (ct%hlten(k)+Uw_p%HLv*ct%qlten(k)+    &
                                      Uw_p%HLs*ct%qiten(k))/Uw_p%cp_air
       ct%trten(k,:) = (ct%trflx(km1,:)-ct%trflx(k,:))*   &
                                                    Uw_p%grav/sd%dp(k)
       ct%trwet(k,:) = cp%tru_dwet(k,:) *cp%umf(k)*Uw_p%grav/sd%dp(k)

    enddo

    do k = cp%let,ltop
       if (ct%qctten(k).gt.0 .and. ct%qvten(k).lt.0) then
          qlutmp     =(1.-sd%nu(k))*ct%qvten(k)
          qiutmp     =    sd%nu(k) *ct%qvten(k)
          ct%qlten(k)=ct%qlten(k)+qlutmp
          ct%qiten(k)=ct%qiten(k)+qiutmp
          ct%qvten(k)=0.
          ct%tten (k)=ct%tten(k)+(Uw_p%HLv*qlutmp+Uw_p%HLs*qiutmp)/Uw_p%cp_air
       end if
    end do

    ct%dtint=0.; ct%dqint=0.; ct%conint=0.; ct%freint=0.; !dpsum=0.;

    ct%qlflx(ltop)=(1.-cpn%atopevap)*ct%qlflx(ltop-1);
    ct%qiflx(ltop)=(1.-cpn%atopevap)*ct%qiflx(ltop-1);
    ktop=ltop

    do k = 1,ktop
       km1 = k-1
       ct%qldiv(k) = -(ct%qlflx(k) - ct%qlflx(km1) +   &
                                       cp%pptr(k))* Uw_p%grav/sd%dp(k)
       ct%qidiv(k) = -(ct%qiflx(k) - ct%qiflx(km1) +   &
                                       cp%ppti(k))* Uw_p%grav/sd%dp(k)
    end do

    do k = 1,ltop
       km1 = k-1
       ct%qvdiv(k) = -(ct%qvflx(k) - ct%qvflx(km1))* Uw_p%grav/sd%dp(k)
       ct%dtint    = ct%dtint    + ct%tten (k)*Uw_p%cp_air/sd%leff(k)* &
                                                    sd%dp(k)/Uw_p%grav
       ct%dqint    = ct%dqint    + ct%qvten(k)* sd%dp(k)/Uw_p%grav
       ct%conint   = ct%conint   + ct%qldiv(k)* sd%dp(k)/Uw_p%grav
       ct%freint   = ct%freint   + ct%qidiv(k)* sd%dp(k)/Uw_p%grav
    end do

    if (do_coldT) then
       do k = 1,ltop
          if (sd%coldT) then
             ct%tten(k)=ct%tten(k)+cp%pptr(k)*Uw_p%HLf*Uw_p%grav/  &
                                                   sd%dp(k)/Uw_p%cp_air
             cp%ppti(k)=cp%ppti(k)+cp%pptr(k)
             cp%pptr(k)=0.
          else
             ct%tten(k)=ct%tten(k)-cp%ppti(k)*Uw_p%HLf*Uw_p%grav/  &
                                                   sd%dp(k)/Uw_p%cp_air
             cp%pptr(k)=cp%pptr(k)+cp%ppti(k)
             cp%ppti(k)=0.
          end if
          ct%snow  = ct%snow  + cp%ppti(k)
          ct%rain  = ct%rain  + cp%pptr(k)
       end do
       if (cpn%do_pevap .and. ct%snow+ct%rain > 0.) then
          call precip_evap (sd, cp, cpn, ct, Uw_p, dpevap)
          ct%tten (:)=ct%tten (:)+ct%tevap(:)
          ct%qvten(:)=ct%qvten(:)+ct%qevap(:)
          if (sd%coldT) then
             ct%snow  = ct%snow - dpevap
          else
             ct%rain  = ct%rain - dpevap
          end if
       end if
    end if

    if(cpn%do_pnqv) then
       do k = sd%kmax,3,-1
          dqt  =  ct%qvten(k) * sd%delt
          if (dqt.lt.0 .and. sd%qv(k)+dqt.lt.1.e-10) then
             fdrtmp = -(sd%qv(k)-1.e-10)/sd%delt - ct%qvten(k)
             ct%qvten(k) = ct%qvten(k) + fdrtmp
             dpsum = 0.0
             do i = k-1,1,-1
                dpsum = dpsum + sd%dp(i)
             enddo
             do i = k-1,1,-1
                ct%qvten(i) = ct%qvten(i) - fdrtmp*sd%dp(k)/dpsum
             enddo
          end if
       end do
    end if

    ct%dting=0.;
    ct%denth=0.; ct%dqtmp=0.; ct%uav=0.;ct%vav=0.; dpsum=0.;
    do k = 1,sd%kmax! ltop
       ct%denth = ct%denth + (Uw_p%cp_air*ct%tten(k)-Uw_p%HLv*ct%qlten(k)-Uw_p%HLs*ct%qiten(k))*sd%dp(k)/Uw_p%grav
       ct%dqtmp = ct%dqtmp + (ct%qvten(k) + ct%qlten(k) + ct%qiten(k))*sd%dp(k)/Uw_p%grav
       ct%uav   = ct%uav   + ct%uten(k)*sd%dp(k)/Uw_p%grav
       ct%vav   = ct%vav   + ct%vten(k)*sd%dp(k)/Uw_p%grav
       ct%dting = ct%dting + Uw_p%cp_air*ct%tten(k)*sd%dp(k)/Uw_p%grav
!       dpsum    = dpsum    + sd%dp(k)
     end do
     ct%denth = ct%denth - Uw_p%HLv*ct%rain - Uw_p%HLs*ct%snow
     ct%dqtmp = ct%dqtmp + ct%rain + ct%snow

  end subroutine cumulus_tend_k

!#####################################################################
!#####################################################################

 subroutine roots(a,b,c,r1,r2)
   real a,b,c,r1,r2,q
   
   if(a.eq.0)then            ! form b*x + c = 0
      if(b.eq.0)then         ! failure: c = 0
         r1 = -9.99e33
      else                   ! b*x + c = 0
         r1 = -c / b
      endif
      r2 = r1
   else
      if(b.eq.0.)then        ! form a*x**2 + c = 0
         if(a*c.gt.0.)then   ! failure: x**2 = -c/a < 0
            r1 =  -9.99e33
         else                ! x**2 = -c/a
            r1 = sqrt(-c/a)
         endif
         r2 = -r1
      else 
         if((b**2. - 4.*a*c).lt.0.)then ! failure, no real(r8) roots
            r1 =  -9.99e33
            r2 = -r1
         else
            q = - 0.5 * ( b + sign(1.0,b) * sqrt(b**2. - 4.*a*c) )
            r1 = q/a
            r2 = c/q
         endif
      endif
   endif
   return
 end subroutine roots

!#####################################################################
!#####################################################################

  SUBROUTINE precip_evap (sd, cp, cpn, ct, Uw_p, dpevap)

    implicit none
    
    type(sounding), intent(in)      :: sd
    type(cplume),   intent(in)      :: cp
    type(cpnlist),  intent(in)      :: cpn
    type(ctend),    intent(inout)   :: ct
    type(uw_params),intent(inout)   :: Uw_p
    real,           intent(inout)   :: dpevap

    real, parameter :: cem    = 0.054
    real, parameter :: ceta   = -544.0E-6
    real, parameter :: d622   = 287.04/461.50
    real, parameter :: d378   = 1.0-d622

    real, dimension(size(sd%t)) :: mass, temp_new, qvap_new, pptp, pflx, pflx_evap
    real    :: prec, def, evef, prec_mmph, pfac, emx, dpcu, HL, dqs, qs
    real    :: hcevap, cfrac

    integer :: k, ier

    cfrac     = cpn%cfrac
    hcevap    = cpn%hcevap

    pflx      = 0.0
    pflx_evap = 0.0
    qvap_new  = sd%qv
    temp_new  = sd%t

    if (sd%coldT) then
       HL=Uw_p%HLs
    else
       HL=Uw_p%HLv
    end if

    !pptp (unit: kg/m2 or mm) - precipitated water in the layer dp
    pptp   = (cp%pptr(:)+cp%ppti(:))*sd%delt
    mass   = sd%dp/Uw_p%grav
    dpcu   = 0.0
    dpevap = 0.0
    do k = cp%ltop, 1, -1
       dpcu = dpcu + pptp(k)
       prec = MAX(dpcu - dpevap, 0.0 )

! --- Compute precipitation efficiency factor
       prec_mmph = prec * 3600.0 / sd%delt
       pfac      = SQRT( sd%p(k) / sd%ps(0) )
       emx       = SQRT( cem * cfrac * prec_mmph * pfac )   
       evef      = 1.0 - EXP( ceta * sd%delt * emx ) 

       def=0. !Evaporate precip where needed
       if ( sd%rh(k) <= hcevap .and. prec > 0.0 ) then
          call compute_qs_k (sd%t(k), sd%p(k), Uw_p%epsilo, Uw_p%zvir, &
                             qs, ier, dqsdT=dqs) 
          def=(hcevap*sd%qs(k) - sd%qv(k))/(1.+(HL*hcevap*dqs/Uw_p%Cp_Air ))
          def=evef*def
          def=MIN( def, prec/mass(k) )
          def=MAX( def, 0.0)
       else
          def=0.0
       end if
       pflx_evap(k)= def * mass(k)
       dpevap      = dpevap + pflx_evap(k)
       qvap_new(k) = sd%qv(k) + def
       temp_new(k) = sd%t (k) - (def * HL/Uw_p%Cp_Air)
       pflx    (k) = prec
    end do
    dpevap      = min(dpevap, dpcu) / sd%delt
    ct%tevap(:) = (temp_new(:) - sd%t (:))/sd%delt
    ct%qevap(:) = (qvap_new(:) - sd%qv(:))/sd%delt
  
  end SUBROUTINE PRECIP_EVAP

!#####################################################################
!#####################################################################

end MODULE CONV_PLUMES_k_MOD

                     module longwave_driver_mod
!
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  ds
! </REVIEWER>
! <OVERVIEW>
!  Code to set up longwave radiation calculation
! </OVERVIEW>
! <DESCRIPTION>
! </DESCRIPTION>
! 

use mpp_mod,            only: input_nml_file
use fms_mod,            only: open_namelist_file, fms_init, &
                              mpp_pe, mpp_root_pe, stdlog, &
                              file_exist, write_version_number, &
                              check_nml_error, error_mesg, &
                              FATAL, close_file
use time_manager_mod,   only: time_type

! shared radiation package modules:

use rad_utilities_mod,  only: rad_utilities_init, Rad_control, &
                              cldrad_properties_type, &
                              cld_specification_type, lw_output_type, &
                              atmos_input_type, radiative_gases_type, &
                              aerosol_type, aerosol_properties_type,  &
                              aerosol_diagnostics_type, &
                              Lw_control, assignment(=), &
                              lw_table_type, lw_diagnostics_type

!   radiation package module:

use sealw99_mod,        only: sealw99_init,sealw99_time_vary, sealw99, &
                              sealw99_endts, sealw99_end

!------------------------------------------------------------------

implicit none
private

!-------------------------------------------------------------------
!    longwave_driver_mod is the driver for the longwave radiation
!    component of the sea_esf_rad radiation package.
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module --------------------------

character(len=128)  :: version =  '$Id: longwave_driver.F90,v 19.0 2012/01/06 20:18:03 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'

!---------------------------------------------------------------------
!-------  interfaces --------

public      &
   longwave_driver_init, longwave_driver_time_vary, longwave_driver,   &
   longwave_driver_endts, longwave_driver_end

private      &

! called from longwave_driver:
         longwave_driver_alloc


!---------------------------------------------------------------------
!-------- namelist  ---------

character(len=16) :: lwform= 'sealw99'
 

namelist / longwave_driver_nml /    &
                                 lwform

!---------------------------------------------------------------------
!------- public data ------


!---------------------------------------------------------------------
!------- private data ------

logical :: module_is_initialized =  .false.   ! module initialized ?
logical :: do_sealw99 = .false.               ! sealw99 parameter-
                                              ! ization active ?


!---------------------------------------------------------------------
!---------------------------------------------------------------------



                          contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!
!                    PUBLIC SUBROUTINES
!
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

! <SUBROUTINE NAME="longwave_driver_init">
!  <OVERVIEW>
!   longwave_driver_init is the constructor for longwave_driver_mod
!  </OVERVIEW>
!  <DESCRIPTION>
!   This subroutine initializes longwave radiation package
!  </DESCRIPTION>
!  <TEMPLATE>
!   call longwave_driver_init (latb, lonb, pref, Lw_tables)
!  </TEMPLATE>
!  <IN NAME="latb" TYPE="real">
!   2d array of model latitudes at cell corners [radians]
!  </IN>
!  <IN NAME="lonb" TYPE="real">
!   2d array of model longitudes at cell corners [radians]
!  </IN>
!  <IN NAME="pref" TYPE="real">
!   array containing two reference pressure profiles [pascals]
!  </IN>
!  <INOUT NAME="Lw_tables" TYPE="lw_table_type">
!   lw_tables_type variable containing various longwave
!                 table specifiers needed by radiation_diag_mod.
!  </INOUT>
! </SUBROUTINE>
!
subroutine longwave_driver_init (latb, lonb, pref, Lw_tables)
 
!---------------------------------------------------------------------
!    longwave_driver_init is the constructor for longwave_driver_mod.
!---------------------------------------------------------------------

!---------------------------------------------------------------------
real, dimension(:,:),   intent(in)    :: latb, lonb
real, dimension(:,:),   intent(in)    :: pref
type(lw_table_type),    intent(inout) :: Lw_tables

!---------------------------------------------------------------------
!  intent(in) variables:
!
!       latb      2d array of model latitudes at cell corners 
!                 [ radians ]
!       lonb      2d array of model longitudes at cell corners 
!                 [ radians ]
!       pref      array containing two reference pressure profiles 
!                 [ Pa ]
!
!  intent(out) variables:
!
!       Lw_tables lw_tables_type variable containing various longwave
!                 table specifiers needed by radiation_diag_mod.
!
!--------------------------------------------------------------------
 
!--------------------------------------------------------------------
!  local variables

      integer     :: unit, ierr, io, logunit

!---------------------------------------------------------------------
!  local variables:
!
!        unit            io unit number used for namelist file
!        ierr            error code
!        io              error status returned from io operation
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return
 
!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call rad_utilities_init

!-----------------------------------------------------------------------
!    read namelist.
!-----------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=longwave_driver_nml, iostat=io)
      ierr = check_nml_error(io,'longwave_driver_nml')
#else   
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=longwave_driver_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'longwave_driver_nml')
        end do
10      call close_file (unit)
      endif
#endif
 
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                          write (logunit, nml=longwave_driver_nml)

!--------------------------------------------------------------------
!    determine if valid specification of lw radiation has been made.
!    if optional packages are provided at some later time, this is where
!    the choice of package will be made.
!---------------------------------------------------------------------
      if (trim(lwform) == 'sealw99') then
        do_sealw99 = .true.
        call sealw99_init ( latb, lonb, pref, Lw_tables)
      else
        call error_mesg ( 'longwave_driver_mod', &
                 'invalid longwave radiation form specified', FATAL)
      endif

!---------------------------------------------------------------------
!    set flag indicating successful initialization of module.
!---------------------------------------------------------------------
      module_is_initialized = .true.

!---------------------------------------------------------------------


end  subroutine longwave_driver_init


!#####################################################################

subroutine longwave_driver_time_vary (Time, Rad_gases_tv)
 
!-------------------------------------------------------------------- 
type(time_type), intent(in) :: Time
type(radiative_gases_type), intent(inout) :: Rad_gases_tv

 

      call sealw99_time_vary (Time, Rad_gases_tv)
 
end subroutine longwave_driver_time_vary      

        
 
!#####################################################################

subroutine longwave_driver_endts (Rad_gases_tv)
          
type(radiative_gases_type), intent(in) :: Rad_gases_tv
 

     call sealw99_endts (Rad_gases_tv)


end subroutine longwave_driver_endts 



!#####################################################################
! <SUBROUTINE NAME="longwave_driver">
!  <OVERVIEW>
!   Subroutine to set up and execute longwave radiation calculation
!  </OVERVIEW>
!  <DESCRIPTION>
!   longwave_driver allocates and initializes longwave radiation out-
!    put variables and selects an available longwave radiation param-
!    eterization, executes it, and then returns the output fields to 
!    sea_esf_rad_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call longwave_driver (is, ie, js, je, Atmos_input, Rad_gases, &
!                         Aerosol, Cldrad_props, Cld_spec, Lw_output, &
!                         Lw_diagnostics)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!   starting subdomain i indice of data in the physics_window being
!       integrated
!  </IN>
!  <IN NAME="ie" TYPE="integer">
!   ending subdomain i indice of data in the physics_window being
!       integrated
!  </IN>
!  <IN NAME="js" TYPE="integer">
!   starting subdomain j indice of data in the physics_window being
!       integrated
!  </IN>
!  <IN NAME="je" TYPE="integer">
!   ending subdomain j indice of data in the physics_window being
!       integrated
!  </IN>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
!   atmos_input_type variable containing the atmospheric
!                   input fields needed by the radiation package
!  </IN>
!  <IN NAME="Rad_gases" TYPE="radiative_gases_type">
!   radiative_gases_type variable containing the radi-
!                   ative gas input fields needed by the radiation 
!                   package
!  </IN>
!  <IN NAME="Cldrad_props" TYPE="cldrad_properties_type">
!   cldrad_properties_type variable containing the 
!                   cloud radiative property input fields needed by the 
!                   radiation package
!  </IN>
!  <INOUT NAME="Lw_output" TYPE="lw_output_type">
!   lw_output_type variable containing longwave 
!                   radiation output data
!  </INOUT>
!  <INOUT NAME="Lw_diagnostics" TYPE="lw_diagnostics_type">
!   lw_diagnostics_type variable containing diagnostic
!                   longwave output used by the radiation diagnostics
!                   module
!  </INOUT>
!  <IN NAME="Aerosol" TYPE="aerosol_type">
!   Aerosol input data to longwave radiation
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!   Cloud specification input data to longwave radiation
!  </IN>
! </SUBROUTINE>
!
subroutine longwave_driver (is, ie, js, je, Rad_time, Atmos_input,  &
                            Rad_gases, Aerosol, Aerosol_props,   &
                            Cldrad_props, Cld_spec, Aerosol_diags, &
                            Lw_output, Lw_diagnostics)

!--------------------------------------------------------------------
!    longwave_driver allocates and initializes longwave radiation out-
!    put variables and selects an available longwave radiation param-
!    eterization, executes it, and then returns the output fields to 
!    sea_esf_rad_mod.
!--------------------------------------------------------------------

integer,                      intent(in)     :: is, ie, js, je
type(time_type),              intent(in)     :: Rad_time
type(atmos_input_type),       intent(in)     :: Atmos_input  
type(radiative_gases_type),   intent(inout)  :: Rad_gases   
type(aerosol_type),           intent(in)     :: Aerosol     
type(aerosol_properties_type),intent(inout)  :: Aerosol_props
type(aerosol_diagnostics_type),intent(inout)  :: Aerosol_diags
type(cldrad_properties_type), intent(in)     :: Cldrad_props
type(cld_specification_type), intent(in)     :: Cld_spec     
type(lw_output_type), dimension(:),  intent(inout)  :: Lw_output
type(lw_diagnostics_type),    intent(inout)  :: Lw_diagnostics

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je    starting/ending subdomain i,j indices of data in 
!                     the physics_window being integrated
!      Rad_time       time at which the climatologically-determined, 
!                     time-varying input fields to radiation should 
!                     apply    
!                     [ time_type, days and seconds]
!      Atmos_input    atmos_input_type variable containing the atmos-
!                     pheric input fields needed by the radiation 
!                     package
!      Rad_gases      radiative_gases_type variable containing the radi-
!                     ative gas input fields needed by the radiation 
!                     package
!      Aerosol        aerosol_type variable containing the aerosol 
!                     fields that are seen by the longwave radiation 
!                     package
!      Cldrad_props   cldrad_properties_type variable containing the 
!                     cloud radiative property input fields needed by 
!                     the radiation package
!      Cld_spec       cld_specification_type variable containing the 
!                     cloud specification input fields needed by the 
!                     radiation package
!
!   intent(inout) variables:
!
!      Aerosol_props  aerosol_properties_type variable containing the 
!                     aerosol radiative properties needed by the rad-
!                     iation package 
!      Lw_output      lw_output_type variable containing longwave 
!                     radiation output data 
!      Lw_diagnostics lw_diagnostics_type variable containing diagnostic
!                     longwave output used by the radiation diagnostics
!                     module
!  
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables

      type(lw_output_type)  :: Lw_output_std, Lw_output_ad
      logical :: calc_includes_aerosols
      integer  :: ix, jx, kx  ! dimensions of current physics window

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('longwave_driver_mod',   &
          'module has not been initialized', FATAL )
      endif

!--------------------------------------------------------------------
!    call longwave_driver_alloc to allocate component arrays of a
!    lw_output_type variable.
!----------------------------------------------------------------------
      ix = ie - is + 1
      jx = je - js + 1
      kx = size (Atmos_input%press,3) - 1
!**************************************
      ! This is a temporary fix! Lw_output needs to be allocated at a higher level!
      ! Constructor and destructor for lw_output_type needs to be provided through
      ! rad_utilities
!**************************************
      call longwave_driver_alloc (ix, jx, kx, Lw_output(1))
      call longwave_driver_alloc (ix, jx, kx, Lw_output_std)
      if (Rad_control%do_lwaerosol_forcing) then
      ! This is a temporary fix! Lw_output needs to be allocated at a higher level!
        call longwave_driver_alloc (ix, jx, kx, Lw_output(Rad_control%indx_lwaf))
        call longwave_driver_alloc (ix, jx, kx, Lw_output_ad)
      endif

!--------------------------------------------------------------------
!    calculate the longwave radiative heating rates and fluxes.
!--------------------------------------------------------------------
      if (do_sealw99) then

             
!--------------------------------------------------------------------
!    call sealw99 to use the simplified-exchange-approximation (sea)
!    parameterization.
!----------------------------------------------------------------------
         if (Rad_control%do_lwaerosol_forcing) then
           if (Lw_control%do_lwaerosol) then
             calc_includes_aerosols = .false.
           else
             calc_includes_aerosols = .true.
           endif

!----------------------------------------------------------------------
!    call sealw99 with aerosols (if model is being run without) and 
!    without aerosols (if model is being run with). save the radiation
!    fluxes to Lw_output_ad (which does not feed back into the model),
!    but which may be used to define the aerosol forcing.
!----------------------------------------------------------------------
           call sealw99 (is, ie, js, je, Rad_time, Atmos_input,  &
                     Rad_gases, Aerosol, Aerosol_props, Cldrad_props, &
                     Cld_spec, Aerosol_diags, Lw_output_ad, &
                     Lw_diagnostics, calc_includes_aerosols)
           Lw_output(Rad_control%indx_lwaf) = Lw_output_ad
         endif
 
!----------------------------------------------------------------------
!    standard call, where radiation output feeds back into the model.
!----------------------------------------------------------------------
        call sealw99 (is, ie, js, je, Rad_time, Atmos_input,  &
                      Rad_gases, Aerosol, Aerosol_props, Cldrad_props, &
                      Cld_spec, Aerosol_diags, Lw_output_std,  &
                      Lw_diagnostics, Lw_control%do_lwaerosol)
        Lw_output(1) = Lw_output_std
      else

!--------------------------------------------------------------------
!    at the current time sealw99 is the only longwave parameterization 
!    available.
!----------------------------------------------------------------------
        call error_mesg ('longwave_driver_mod', &
         'invalid longwave radiation parameterization selected', FATAL)
      endif

      call longwave_driver_dealloc (Lw_output_std)
      if (Rad_control%do_lwaerosol_forcing) then
        call longwave_driver_dealloc (Lw_output_ad)
      endif

!---------------------------------------------------------------------

end subroutine longwave_driver


!#####################################################################
! <SUBROUTINE NAME="longwave_driver_end">
!  <OVERVIEW>
!   Subroutine to end longwave calculation
!  </OVERVIEW>
!  <DESCRIPTION>
!   This subroutine end longwave calculation
!  </DESCRIPTION>
!  <TEMPLATE>
!   call longwave_driver_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine longwave_driver_end                  

!--------------------------------------------------------------------
!    longwave_driver_end is the destructor for longwave_driver_mod.
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('longwave_driver_mod',   &
          'module has not been initialized', FATAL )
      endif

!--------------------------------------------------------------------
!    call sealw99_end to close sealw99_mod.
!-------------------------------------------------------------------
      if (do_sealw99) then
        call sealw99_end
      endif

!--------------------------------------------------------------------
!    mark the module as uninitialized.
!--------------------------------------------------------------------
      module_is_initialized = .false.

!---------------------------------------------------------------------


end subroutine longwave_driver_end                  


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!
!                     PRIVATE SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!#####################################################################
! <SUBROUTINE NAME="longwave_driver_alloc">
!  <OVERVIEW>
!   Subroutine to allocate output variables from longwave calculation
!  </OVERVIEW>
!  <DESCRIPTION>
!   This subroutine allocates and initializes the components
!    of the lw_output_type variable Lw_output which holds the longwave
!    output needed by radiation_driver_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call longwave_driver_alloc (ix, jx, kx, Lw_output)
!  </TEMPLATE>
!  <IN NAME="ix" TYPE="integer">
!   Dimension 1 length of radiation arrays to be allocated
!  </IN>
!  <IN NAME="jx" TYPE="integer">
!   Dimension 2 length of radiation arrays to be allocated
!  </IN>
!  <IN NAME="kx" TYPE="integer">
!   Dimension 3 length of radiation arrays to be allocated
!  </IN>
!  <OUT NAME="Lw_output" TYPE="lw_output_type">
!   lw_output_type variable containing longwave 
!                   radiation output data
!  </OUT>
! </SUBROUTINE>
!
subroutine longwave_driver_alloc (ix, jx, kx, Lw_output)

!--------------------------------------------------------------------
!    longwave_driver_alloc allocates and initializes the components
!    of the lw_output_type variable Lw_output which holds the longwave
!    output needed by radiation_driver_mod.
!--------------------------------------------------------------------

integer,                   intent(in)    :: ix, jx, kx
type(lw_output_type),      intent(inout) :: Lw_output

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      ix,jx,kx     (i,j,k) dimensions of current physics window 
!
!
!   intent(inout) variables:
!
!      Lw_output    lw_output_type variable containing longwave 
!                   radiation output data 
!  
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!    allocate and initialize arrays to hold net longwave fluxes and 
!    the longwave heating rate at each gridpoint. if the
!    cloud-forcing calculation is to be done, also allocate and init-
!    ialize arrays for fluxes and heating rates without clouds.
!-------------------------------------------------------------------
      allocate (Lw_output%flxnet( ix, jx, kx+1) )
      allocate (Lw_output%heatra( ix, jx, kx  ) )
      allocate (Lw_output%netlw_special   &
                                ( ix, jx, Rad_control%mx_spec_levs  ) )
      allocate (Lw_output%bdy_flx         &
                                ( ix, jx, 4) )
      Lw_output%flxnet(:,:,:) = 0.0
      Lw_output%heatra(:,:,:) = 0.0
      Lw_output%netlw_special(:,:,:) = 0.0
      Lw_output%bdy_flx (:,:,:) = 0.0      
      if (Rad_control%do_totcld_forcing)  then
        allocate (Lw_output%flxnetcf( ix, jx, kx+1) )
        allocate (Lw_output%heatracf( ix, jx, kx  ) )
        allocate (Lw_output%netlw_special_clr  &
                                ( ix, jx, Rad_control%mx_spec_levs  ) )
        allocate (Lw_output%bdy_flx_clr         &
                                ( ix, jx, 4) )
        Lw_output%flxnetcf(:,:,:) = 0.0
        Lw_output%heatracf(:,:,:) = 0.0
        Lw_output%netlw_special_clr(:,:,:) = 0.0
        Lw_output%bdy_flx_clr (:,:,:) = 0.0      
      endif
    
!--------------------------------------------------------------------

end subroutine longwave_driver_alloc


!#####################################################################
! <SUBROUTINE NAME="longwave_driver_dealloc">
!  <OVERVIEW>
!   Subroutine to deallocate output variables from longwave calculation
!  </OVERVIEW>
!  <DESCRIPTION>
!   This subroutine allocates and initializes the components
!    of the lw_output_type variable Lw_output which holds the longwave
!    output needed by radiation_driver_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call longwave_driver_alloc (Lw_output)
!  </TEMPLATE>
!  <OUT NAME="Lw_output" TYPE="lw_output_type">
!   lw_output_type variable containing longwave 
!                   radiation output data
!  </OUT>
! </SUBROUTINE>
!
subroutine longwave_driver_dealloc (Lw_output)

!--------------------------------------------------------------------
!    longwave_driver_alloc deallocates the components
!    of the lw_output_type variable Lw_output.
!--------------------------------------------------------------------

type(lw_output_type),      intent(inout) :: Lw_output

!--------------------------------------------------------------------
!
!   intent(inout) variables:
!
!      Lw_output    lw_output_type variable containing longwave 
!                   radiation output data 
!  
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!    deallocate arrays to hold net longwave fluxes and 
!    the longwave heating rate at each gridpoint
!-------------------------------------------------------------------
      deallocate (Lw_output%flxnet)
      deallocate (Lw_output%heatra)
      deallocate (Lw_output%netlw_special)
      deallocate (Lw_output%bdy_flx)
      if (Rad_control%do_totcld_forcing)  then
        deallocate (Lw_output%flxnetcf)
        deallocate (Lw_output%heatracf)
        deallocate (Lw_output%netlw_special_clr)
        deallocate (Lw_output%bdy_flx_clr)
      endif
    
!--------------------------------------------------------------------

end subroutine longwave_driver_dealloc

!###################################################################



                end module longwave_driver_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
! !ROUTINE: Interpolate from observation space to model grid
!
! !INTERFACE:
   subroutine gridinterpol(N,cols,obs_z,obs_prof,nlev,model_z,model_prof)
!
! !DESCRIPTION:
!
!  This is a utility subroutine in which observational data, which might
!  be given on an arbitrary, but structured grid, are linearly interpolated and
!  extrapolated to the actual (moving) model grid.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer,  intent(in)                :: N,cols
   REALTYPE, intent(in)                :: obs_z(0:N),obs_prof(0:N,cols)
   integer,  intent(in)                :: nlev
   REALTYPE, intent(in)                :: model_z(0:nlev)
!
! !OUTPUT PARAMETERS:
   REALTYPE, intent(out)               :: model_prof(0:nlev,cols)
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding & Hans Burchard
!  $Log: gridinterpol.F90,v $
!  Revision 20.0  2013/12/14 00:14:02  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:01:18  smg
!  initial cvs ci to mom5
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:33:41  smg
!  updated to gotm-2012.03.09 CVS tagged code.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.5  2005-11-18 10:59:34  kbk
!  removed unused variables - some left in parameter lists
!
!  Revision 1.4  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.3  2003/03/28 09:20:36  kbk
!  added new copyright to files
!
!  Revision 1.2  2003/03/10 08:54:16  gotm
!  Improved documentation and cleaned up code
!
!  Revision 1.1.1.1  2001/02/12 15:55:58  gotm
!  initial import into CVS
!
!EOP
!
! !LOCAL VARIABLES:
   integer                   :: i,j,ii
   REALTYPE                  :: rat
!-----------------------------------------------------------------------
!BOC
!  Set surface values to uppermost input value
   do i=nlev,1,-1
      if(model_z(i) .ge. obs_z(N)) then
         do j=1,cols
            model_prof(i,j) = obs_prof(N,j)
         end do
      end if
   end do

!  Set bottom values to lowest input value
   do i=1,nlev
      if(model_z(i) .le. obs_z(1)) then
         do j=1,cols
            model_prof(i,j) = obs_prof(1,j)
         end do
      end if
   end do

!  Interpolate inner values linearly
   do i=1,nlev
      if ((model_z(i) .lt. obs_z(N)) .and. (model_z(i) .gt. obs_z(1))) then
         ii=0
224      ii=ii+1
         if (obs_z(ii) .le. model_z(i)) goto 224
         rat=(model_z(i)-obs_z(ii-1))/(obs_z(ii)-obs_z(ii-1))
         do j=1,cols
            model_prof(i,j)=(1-rat)*obs_prof(ii-1,j)+rat*obs_prof(ii,j)
         end do
      end if
   end do

   return
   end
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module ocean_operators_mod
!   
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> A. Rosati
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Zhi Liang
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Alexander Pletzer
!</REVIEWER>
!
!<OVERVIEW>
! Operators for MOM
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes discrete operators used by MOM.  
!</DESCRIPTION>
!
! <INFO>
!
!<NOTE>
! All operators will be replaced by generic forms when Fortran
! can properly support functions of allocatable arrays.  The 
! problems presently with this replacement are are as follows:
! Allocatable arrays cannot be inside of derived types.
! Only pointers to allocatable arrays can be inside derived types.
! Supposedly the former will be allowed in Fortran 95
! Also, functions cannot be typed as a derived type without conflicts
! which preclude using function as general operators operating on
! derived types.
! </NOTE>
!
! <NOTE>
! Mnemonics for simple operators
!
! 1st letter (direction of operation)
! <BR/>
! F => Forward direction with respect to the index.
! <BR/>
! B => Backward direction with respect to the index.
!
! 2nd letter (operation)
! <BR/>
! D => Derivative
! <BR/> 
! A => Average
! <BR/>
! M => Minimum
!
! 3rd letter (axis)
!
! X => along the X axis
! <BR/>
! Y => along the Y axis
! <BR/>
! Z => along the Z axis
!
! 4th letter (placement of quantity being operated on)
!
! E => East face
! <BR/>
! N => North face
! <BR/>
! B => Bottom face
! <BR/>
! P => Point (grid point within cell)
!
! 5th letter (type of grid cell)
!
! U => U-cell
! <BR/>
! T => T-cell
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_operators_nml">
!  <DATA NAME="use_legacy_DIV_UD" TYPE="logical">
!  Set use_legacy_DIV_UD=.true. to reproduce Riga results for 
!  DIV_UD on Bgrid. For the case that the model grid is tripolar grid, 
!  when barotropic_halo > 1 in ocean_barotropic.F90, then 
!  we must set use_legacy_DIV_UD=.false., since will not reproduce between
!  different number of processors if set use_legacy_DIV_UD=.true.
!
!  Tests indicate that with wider barotropic halos, there are
!  some performance enhancements for use_legacy_DIV_UD=.false.  
!  Hence, the default is use_legacy_DIV_UD=.false.
!
!  For the case that the model grid is regular lat-lon grid,
!  use_legacy_DIV_UD could be set to .true. or .false. for 
!  any positive value of barotropic_halo.
!
!  Note that the only difference between the new and old DIV_UD
!  is order of operations induced by parentheses, which occurs in the  
!  tripolar fold region in the Arctic: 
!  old: DIV_UD(i,j) = (uh_bay  - uhim_bay  + vh_bax  - vhjm_bax)*datr_bt(i,j)
!  new: DIV_UD(i,j) = ((uh_bay - uhim_bay) + (vh_bax - vhjm_bax))*datr_bt(i,j) 
!  </DATA> 
!</NAMELIST>

  use mpp_domains_mod,   only: mpp_update_domains, CGRID_NE, BGRID_NE
  use mpp_domains_mod,   only: mpp_get_data_domain, mpp_get_compute_domain
  use mpp_domains_mod,   only: EAST, NORTH, CORNER
  use mpp_mod,           only: mpp_error, FATAL, stdlog, stdout, input_nml_file
  use fms_mod,           only: open_namelist_file, check_nml_error, close_file, file_exist

  use ocean_domains_mod,    only: get_local_indices, get_halo_sizes    
  use ocean_domains_mod,    only: set_ocean_domain
  use ocean_parameters_mod, only: onefourth, oneeigth, onesixteenth
  use ocean_parameters_mod, only: MOM_BGRID, MOM_CGRID 
  use ocean_types_mod,      only: ocean_grid_type, ocean_domain_type, ocean_thickness_type 

  implicit none

  private

  public FAX, FAY ! forward averaging operators
  public BAX, BAY ! backward averaging operators
  public FMX, FMY ! forward minimum operators

  public FDZ_T    ! forward derivative operator in vertical  

  ! derivative operators along constant depth surfaces 
  ! account taken of general sloping of the k-surfaces 
  public FDX_ZT, FDY_ZT  ! forward 

  ! derivative operators along constant k-levels 
  ! equaly, derivatives along constant vertical coordinate surfaces 
  public FDX_T,  FDY_T   ! forward for fields at T-points
  public FDX_U,  FDY_U   ! forward for fields at U-points
  public FDX_NT, FDY_ET  ! forward for fields at T-cell faces 
  public BDX_ET, BDY_NT  ! backward for fields at T-cell faces
  public BDX_EU, BDY_NU  ! backward for fields at U-cell faces 

  ! Not-so-simple operators (no mnemonics) 
  public REMAP_NT_TO_NU    ! remap thickness weighted advective velocity on north face of T-cells to U-cells 
  public REMAP_ET_TO_EU    ! remap thickness weighted advective velocity on east face of T-cells to U-cells 
  public REMAP_BT_TO_BU    ! remap T-cell thickness or vertical velocity on base of T-cells to U-cells
  public DIV_UD            ! divergence of thickness weighted barotropic velocity
  public GRAD_BAROTROPIC_P ! Gradient of surface pressure or bottom Montgomery potential
  public S2D               ! Smoothing operator: 2D version of [1/4, 1/2, 1/4] filter
  public LAP_T             ! Lateral Laplacian of T-cell fields weighted by a diffusivity 
  public set_barotropic_domain
  public get_use_legacy_DIV_UD

  !namelist
  logical :: use_legacy_DIV_UD = .false. 
  namelist /ocean_operators_nml/ use_legacy_DIV_UD

  integer :: barotropic_halo, isd_bt, ied_bt, jsd_bt, jed_bt
  real, dimension(:,:),   allocatable :: dxtn_bt,  dyte_bt
  real, dimension(:,:),   allocatable :: dxte_bt,  dytn_bt
  real, dimension(:,:),   allocatable :: dxter_bt, dytnr_bt
  real, dimension(:,:),   allocatable :: dxu_bt,   dyu_bt
  real, dimension(:,:),   allocatable :: dxur_bt,  dyur_bt
  real, dimension(:,:),   allocatable :: dat_bt,   datr_bt
  real, dimension(:,:),   allocatable :: umask_bt
  real, dimension(:,:,:), allocatable :: tmasken_bt
  type(ocean_domain_type), pointer    :: Dom_bt => NULL()

  character (len=128) :: version = &
       '$Id: ocean_operators.F90,v 20.0 2013/12/14 00:10:53 fms Exp $'

  character (len=128) :: tagname = &
       '$Name: tikal $'

  type(ocean_grid_type), pointer      :: Grd =>NULL()
  type(ocean_domain_type), pointer    :: Dom =>NULL()
  type(ocean_thickness_type), pointer :: Thk =>NULL()
  type(ocean_domain_type), save       :: Dom_flux

  !for Bgrid or Cgrid
  integer :: horz_grid

#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS
  real, dimension(isd:ied,jsd:jed,nk) :: fmx_tmask
  real, dimension(isd:ied,jsd:jed,nk) :: fmy_tmask
  integer, parameter                  :: halo = 1
#else
  real, dimension(:,:,:), allocatable :: fmx_tmask
  real, dimension(:,:,:), allocatable :: fmy_tmask
  integer                             :: halo
#endif

  logical :: module_is_initialized = .FALSE.

  public ocean_operators_init

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_operators_init">
!
! <DESCRIPTION>
! Initialize the operator module
! </DESCRIPTION>
!
subroutine ocean_operators_init(Grid, Domain, Thickness, hor_grid)

    type(ocean_grid_type), intent(in), target      :: Grid
    type(ocean_domain_type), intent(in), target    :: Domain
    type(ocean_thickness_type), intent(in), target :: Thickness
    integer, intent(in)                            :: hor_grid 

    integer :: xhalo
    integer :: yhalo
    integer :: k
    integer :: stdoutunit, stdlogunit
    integer :: ioun, io_status, ierr

    stdoutunit=stdout()
    stdlogunit = stdlog()

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_operators_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_operators_nml')
#else
    ioun = open_namelist_file()
    read  (ioun, ocean_operators_nml,iostat=io_status)
    ierr = check_nml_error(io_status, 'ocean_operators_nml')
    call close_file(ioun)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit, ocean_operators_nml)
    write (stdlogunit, ocean_operators_nml)

    Grd => Grid
    Dom => Domain
    Thk => Thickness
    horz_grid = hor_grid 

    call set_ocean_domain(Dom_flux, Grid, name='horz diff flux', maskmap=Dom%maskmap)

#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
    call get_halo_sizes(Domain,xhalo, yhalo)
    if (xhalo /= yhalo) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_operators_mod (ocean_operators_init): with static memory, xhalo must equal yhalo')
    endif 
    nk = Grd%nk
    allocate(fmx_tmask(isd:ied,jsd:jed,nk))
    allocate(fmy_tmask(isd:ied,jsd:jed,nk))
    halo = xhalo
#endif
    do k=1,nk
       fmx_tmask(:,:,k) = FMX(Grd%tmask(:,:,k))
       fmy_tmask(:,:,k) = FMY(Grd%tmask(:,:,k))
    enddo

! set up data for the operator used in barotropic domain.
   if( .NOT. Associated(Dom_bt) ) then
      call mpp_error(FATAL, 'ocean_operators_mod(ocean_operators_init): &
                &set_barotropic_domain must be called before calling ocean_operators_init')
   endif

   call get_halo_sizes(Dom_bt,xhalo, yhalo)
   if (xhalo /= yhalo) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_operators_mod (ocean_operators_init): xhalo must equal yhalo for barotropic domain')
   endif 
   barotropic_halo = xhalo
   ! when barotropic_halo > 1, use_legacy_DIV_UD must be false.
   if( barotropic_halo > 1 .AND. use_legacy_DIV_UD .AND. Grd%tripolar ) then
       call mpp_error(FATAL, &
      '==>Error in ocean_operators_mod (ocean_operators_init):  use_legacy_DIV_UD must be false '// &
        'when barotropic_halo > 1 and the grid is tripolar')
   endif 

   isd_bt = isc - barotropic_halo
   ied_bt = iec + barotropic_halo
   jsd_bt = jsc - barotropic_halo
   jed_bt = jec + barotropic_halo

   allocate(dxtn_bt(isd_bt:ied_bt,  jsd_bt:jed_bt))
   allocate(dyte_bt(isd_bt:ied_bt,  jsd_bt:jed_bt))
   allocate(dxte_bt(isd_bt:ied_bt,  jsd_bt:jed_bt))
   allocate(dytn_bt(isd_bt:ied_bt,  jsd_bt:jed_bt))
   allocate(dxter_bt(isd_bt:ied_bt, jsd_bt:jed_bt))
   allocate(dytnr_bt(isd_bt:ied_bt, jsd_bt:jed_bt))
   allocate(dxu_bt(isd_bt:ied_bt,   jsd_bt:jed_bt))
   allocate(dyu_bt(isd_bt:ied_bt,   jsd_bt:jed_bt))
   allocate(dat_bt(isd_bt:ied_bt,   jsd_bt:jed_bt))
   allocate(datr_bt(isd_bt:ied_bt,  jsd_bt:jed_bt))
   allocate(dxur_bt(isd_bt:ied_bt,  jsd_bt:jed_bt))
   allocate(dyur_bt(isd_bt:ied_bt,  jsd_bt:jed_bt))
   allocate(umask_bt(isd_bt:ied_bt, jsd_bt:jed_bt))
   allocate(tmasken_bt(isd_bt:ied_bt, jsd_bt:jed_bt, 2))
   dxtn_bt    = 0
   dyte_bt    = 0
   dxte_bt    = 0
   dytn_bt    = 0
   dxter_bt   = 0
   dytnr_bt   = 0
   dxu_bt     = 0
   dyu_bt     = 0
   dat_bt     = 0
   datr_bt    = 0
   dxur_bt    = 0
   dyur_bt    = 0
   umask_bt   = 0
   tmasken_bt = 0

   dxtn_bt(isd:ied, jsd:jed)       = Grid%dxtn
   dyte_bt(isd:ied, jsd:jed)       = Grid%dyte
   dxte_bt(isd:ied, jsd:jed)       = Grid%dxte
   dytn_bt(isd:ied, jsd:jed)       = Grid%dytn
   dxter_bt(isd:ied, jsd:jed)      = Grid%dxter
   dytnr_bt(isd:ied, jsd:jed)      = Grid%dytnr
   dxu_bt(isd:ied, jsd:jed)        = Grid%dxu
   dyu_bt(isd:ied, jsd:jed)        = Grid%dyu
   dat_bt(isd:ied, jsd:jed)        = Grid%dat
   datr_bt(isd:ied, jsd:jed)       = Grid%datr
   dxur_bt(isd:ied, jsd:jed)       = Grid%dxur
   dyur_bt(isd:ied, jsd:jed)       = Grid%dyur
   umask_bt(isd:ied, jsd:jed)      = Grid%umask(:,:,1)
   tmasken_bt(isd:ied, jsd:jed, 1) = Grid%tmasken(:,:,1,1)
   tmasken_bt(isd:ied, jsd:jed, 2) = Grid%tmasken(:,:,1,2)
   if(barotropic_halo > 1 ) then
      call mpp_update_domains(dxtn_bt,  Dom_bt%domain2d, position=NORTH  )
      call mpp_update_domains(dyte_bt,  Dom_bt%domain2d, position=EAST   )
      call mpp_update_domains(dxte_bt,  Dom_bt%domain2d, position=EAST   )
      call mpp_update_domains(dytn_bt,  Dom_bt%domain2d, position=NORTH  )
      call mpp_update_domains(dxter_bt, Dom_bt%domain2d, position=EAST   )
      call mpp_update_domains(dytnr_bt, Dom_bt%domain2d, position=NORTH  )
      call mpp_update_domains(dxu_bt,   Dom_bt%domain2d, position=CORNER )
      call mpp_update_domains(dyu_bt,   Dom_bt%domain2d, position=CORNER )
      call mpp_update_domains(dxur_bt,  Dom_bt%domain2d, position=CORNER )
      call mpp_update_domains(dyur_bt,  Dom_bt%domain2d, position=CORNER )
      call mpp_update_domains(dat_bt,   Dom_bt%domain2d )
      call mpp_update_domains(datr_bt,  Dom_bt%domain2d )
      call mpp_update_domains(umask_bt, Dom_bt%domain2d, position=CORNER )
      call mpp_update_domains(tmasken_bt(:,:,1), Dom_bt%domain2d, position=EAST )
      call mpp_update_domains(tmasken_bt(:,:,2), Dom_bt%domain2d, position=NORTH)
   endif


    write( stdlogunit,'(/a/)') trim(version)

    return

  end subroutine ocean_operators_init
! </SUBROUTINE> NAME="ocean_operators_init"

!#######################################################################
! <SUBROUTINE NAME="set_barotropic_domain">
!
! <DESCRIPTION>
! Set the barotropic domain used in barotropic time step.
! </DESCRIPTION>
!
! <IN NAME="Domain_in" TYPE="type(ocean_domain_type)">
! Store the barotropic domain.
! </IN>
!
subroutine set_barotropic_domain( Domain_in )
   type(ocean_domain_type), intent(inout), target :: Domain_in

   Dom_bt => Domain_in

end subroutine set_barotropic_domain
! </SUBROUTINE> NAME="set_barotropic_domain"


!#######################################################################
! <FUNCTION NAME="get_use_legacy_DIV_UD">
!
! <DESCRIPTION>
! Return the value of ocean_operators_nml variable use_legacy_DIV_UD
! </DESCRIPTION>
!
function get_use_legacy_DIV_UD()
   logical :: get_use_legacy_DIV_UD

   get_use_legacy_DIV_UD = use_legacy_DIV_UD

   return

end function get_use_legacy_DIV_UD
! </FUNCTION>


!#######################################################################
! <FUNCTION NAME="REMAP_NT_TO_NU">
!
! <DESCRIPTION>
! REMAP_NT_TO_NU remaps a normal flux at the north 
! face of T-cells to the north face of U-cells
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be remapped 
! </IN>
!
function REMAP_NT_TO_NU(a) 
    real, intent(in), dimension(isd:,jsd:) :: a
    real, dimension(isd:ied,jsd:jed)       :: REMAP_NT_TO_NU
    integer :: i, j

    do j=jsc-halo,jec+halo-1
       do i=isc-halo,iec+halo-1
          REMAP_NT_TO_NU(i,j) = ((a(i,j)*Grd%duw(i,j) + a(i+1,j)*Grd%due(i,j))*Grd%dus(i,j+1) +&
               ((a(i,j+1)*Grd%duw(i,j+1) + a(i+1,j+1)*Grd%due(i,j+1)))*Grd%dun(i,j))*Grd%dater(i,j+1)
       enddo
    enddo
    REMAP_NT_TO_NU(iec+halo,:) = 0.0
    REMAP_NT_TO_NU(:,jec+halo) = 0.0

end function REMAP_NT_TO_NU
! </FUNCTION> NAME="REMAP_NT_TO_NU"


!#######################################################################
! <FUNCTION NAME="REMAP_ET_TO_EU">
!
! <DESCRIPTION>
! REMAP_ET_TO_EU remaps a normal flux at the east 
! face of T-cells to the east face of U-cells
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be remapped 
! </IN>
!
function REMAP_ET_TO_EU(a) 

    real, intent(in), dimension(isd:,jsd:) :: a
    real, dimension(isd:ied,jsd:jed)       :: REMAP_ET_TO_EU
    integer :: i, j

    do j=jsc-halo,jec+halo-1
       do i=isc-halo,iec+halo-1
          REMAP_ET_TO_EU(i,j) = ((a(i,j)*Grd%dus(i,j) + a(i,j+1)*Grd%dun(i,j))*Grd%duw(i+1,j) +&
               ((a(i+1,j)*Grd%dus(i+1,j) + a(i+1,j+1)*Grd%dun(i+1,j)))*Grd%due(i,j))*Grd%datnr(i+1,j)
       enddo
    enddo
    REMAP_ET_TO_EU(iec+halo,:) = 0.0
    REMAP_ET_TO_EU(:,jec+halo) = 0.0

end function REMAP_ET_TO_EU
! </FUNCTION> NAME="REMAP_ET_TO_EU"


!#######################################################################
! <FUNCTION NAME="REMAP_BT_TO_BU">
!
! <DESCRIPTION>
! REMAP_BT_TO_BU remaps a T-cell thickness or 
! vertical velocity on the base of T-cells to U-cells
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be remapped 
! </IN>
function REMAP_BT_TO_BU(a) 

    real, intent(in), dimension(isd:,jsd:) :: a
    real, dimension(isd:ied,jsd:jed)       :: REMAP_BT_TO_BU
    integer :: i, j

    do j=jsc-halo,jec+halo-1
       do i=isc-halo,iec+halo-1
          REMAP_BT_TO_BU(i,j) = (a(i,j)*Grd%dte(i,j)*Grd%dus(i,j) + a(i+1,j)*Grd%dtw(i+1,j)*Grd%dus(i,j)&
               + a(i,j+1)*Grd%dte(i,j+1)*Grd%dun(i,j) + a(i+1,j+1)*Grd%dtw(i+1,j+1)*Grd%dun(i,j))*Grd%daur(i,j)
       enddo
    enddo
    REMAP_BT_TO_BU(iec+halo,:) = 0.0
    REMAP_BT_TO_BU(:,jec+halo) = 0.0

end function REMAP_BT_TO_BU
! </FUNCTION> NAME="REMAP_BT_TO_BU"


!#######################################################################
! <FUNCTION NAME="DIV_UD">
!
! <DESCRIPTION>
! Compute divergence of vertically integrated velocity.  
! For MOM with generalized vertical coordinates, ud has an extra
! density factor built in.  
!
! The Bgrid uh and vh fields are located on the corner points, so require
! some backward averaging.  
!
! The Cgrid uh and vh fields are located on the T-cell faces, so need no
! spatial averaging. 
!
! Bgrid code is a speedier version of
! <BR/>
! uhy(:,:) = BAY(ud(:,:,1)*dyu(:,:))
! <BR/>
! vhx(:,:) = BAX(ud(:,:,2)*dxu(:,:))
! <BR/>
! DIV_UD(ud) = BDX_ET(uhy(:,:)/dyte(:,:)) + BDY_NT(vhx(:,:)/dxtn(:,:))
!
! Cgrid divergence is straightforward divergence operator.
!
! </DESCRIPTION>
!
function DIV_UD (ud, halo_in, halo_out )

    integer, intent(in)                                                  :: halo_in, halo_out
    real, intent(in), dimension(isc-halo_in:,jsc-halo_in:,:)             :: ud
    real, dimension(isc-halo_out:iec+halo_out,jsc-halo_out:jec+halo_out) :: DIV_UD
    integer :: i, j, jstart, jend, istart, iend
    real    :: uh, uhim, uhjm, uhimjm, vh, vhim, vhjm, vhimjm
    real    :: uh_bay, vh_bax, uhim_bay, vhjm_bax

    if( halo_in < halo_out) call mpp_error(FATAL, &
         'ocean_operators(DIV_UD): halo_in must be no less than halo_out')

    istart = isc - halo_out
    iend   = iec + halo_out
    jstart = jsc - halo_out
    jend   = jec + halo_out

    DIV_UD = 0.d0

    if(horz_grid == MOM_CGRID) then

          do j=jstart+1,jend
             do i=istart+1,iend
                uhim = ud(i-1,j,1)*dat_bt(i-1,j)*dxter_bt(i-1,j)
                vhjm = ud(i,j-1,2)*dat_bt(i,j-1)*dytnr_bt(i,j-1)
                uh   = ud(i,j,1)*dat_bt(i,j)*dxter_bt(i,j)
                vh   = ud(i,j,2)*dat_bt(i,j)*dytnr_bt(i,j)
                DIV_UD(i,j) = ((uh - uhim) + (vh - vhjm))*datr_bt(i,j)
             enddo
          enddo

    else ! Bgrid 

       if( use_legacy_DIV_UD) then
          do j=jstart+1,jend
             i = istart+1
             uhim = ud(i-1,j,1)*dyu_bt(i-1,j)
             vhim = ud(i-1,j,2)*dxu_bt(i-1,j)
             uhimjm = ud(i-1,j-1,1)*dyu_bt(i-1,j-1)
             vhimjm = ud(i-1,j-1,2)*dxu_bt(i-1,j-1)
             uhim_bay = 0.5*(uhim+uhimjm)
             do i=istart+1,iend
                uh  = ud(i,j,1)*dyu_bt(i,j)
                vh  = ud(i,j,2)*dxu_bt(i,j)

                uhjm = ud(i,j-1,1)*dyu_bt(i,j-1)
                vhjm = ud(i,j-1,2)*dxu_bt(i,j-1)

                uh_bay = 0.5*(uh+uhjm)
                vh_bax = 0.5*(vh+vhim)

                vhjm_bax = 0.5*(vhjm+vhimjm)

                DIV_UD(i,j) = (uh_bay - uhim_bay + vh_bax - vhjm_bax)*datr_bt(i,j)

                uhim = uh
                vhim = vh
                uhimjm = uhjm
                vhimjm = vhjm
                uhim_bay = uh_bay
             enddo
          enddo

       else

          do j=jstart+1,jend
             i = istart+1
             uhim = ud(i-1,j,1)*dyu_bt(i-1,j)
             vhim = ud(i-1,j,2)*dxu_bt(i-1,j) 
             uhimjm = ud(i-1,j-1,1)*dyu_bt(i-1,j-1)
             vhimjm = ud(i-1,j-1,2)*dxu_bt(i-1,j-1)
             uhim_bay = 0.5*(uhim+uhimjm)
             do i=istart+1,iend
                uh  = ud(i,j,1)*dyu_bt(i,j)
                vh  = ud(i,j,2)*dxu_bt(i,j)

                uhjm = ud(i,j-1,1)*dyu_bt(i,j-1)
                vhjm = ud(i,j-1,2)*dxu_bt(i,j-1)

                uh_bay = 0.5*(uh+uhjm)
                vh_bax = 0.5*(vh+vhim)

                vhjm_bax = 0.5*(vhjm+vhimjm)

                DIV_UD(i,j) = ((uh_bay - uhim_bay) + (vh_bax - vhjm_bax))*datr_bt(i,j)

                uhim = uh
                vhim = vh
                uhimjm = uhjm
                vhimjm = vhjm
                uhim_bay = uh_bay
             enddo
          enddo

       endif  ! endif for legacy operator 

    endif ! endif for horz_grid 

    DIV_UD(:,:jstart) = 0.0
    DIV_UD(:istart,:) = 0.0

end function DIV_UD
! </FUNCTION> NAME="DIV_UD"


!#######################################################################
! <FUNCTION NAME="GRAD_BAROTROPIC_P">
!
! <DESCRIPTION>
! Compute horizontal gradient of the pressure field associated with 
! either the free surface height or the bottom pressure. 
!
! Account taken here for either Bgrid or Cgrid operators. 
! For the Bgrid, the gradient is centered onto the U-cell 
! for use in updating barotropic velocity. For the Cgrid, the 
! two components are centred on the T-cell faces.  
!
! The Bgrid algorithm is a speedier version of
! <BR/>
! grad_barotropic_p(:,:,1) = FDX_NT(FAY(press(:,:)))
! <BR/>
! grad_barotropic_p(:,:,2) = FDY_ET(FAX(press(:,:)))
! </DESCRIPTION>
!
function GRAD_BAROTROPIC_P (press, halo_in, halo_out )

    integer, intent(in)                                    :: halo_in, halo_out
    real, intent(in), dimension(isc-halo_in:,jsc-halo_in:) :: press
    real, dimension(isc-halo_out:iec+halo_out,jsc-halo_out:jec+halo_out,2) :: GRAD_BAROTROPIC_P
    integer :: i, j, jstart, jend, istart, iend
    real    :: p_fay, p_fax, pip_fay, pjp_fax

    if( halo_in < halo_out) then
         call mpp_error(FATAL,'ocean_operators(GRAD_BAROTROPIC_P): halo_in must be no less than halo_out')
    endif 

    istart = isc - halo_out
    iend   = iec + halo_out
    jstart = jsc - halo_out
    jend   = jec + halo_out

    if(horz_grid == MOM_BGRID) then 

       do j=jstart,jend-1
          do i=istart,iend-1
             p_fay = 0.5*(press(i,j) + press(i,j+1))
             p_fax = 0.5*(press(i,j) + press(i+1,j))
             pip_fay = 0.5*(press(i+1,j) + press(i+1,j+1))
             pjp_fax = 0.5*(press(i,j+1) + press(i+1,j+1))

             GRAD_BAROTROPIC_P(i,j,1) = (pip_fay - p_fay)*dxur_bt(i,j)*umask_bt(i,j)
             GRAD_BAROTROPIC_P(i,j,2) = (pjp_fax - p_fax)*dyur_bt(i,j)*umask_bt(i,j)
          enddo
       enddo

    else ! cgrid 

       do j=jstart,jend-1
          do i=istart,iend-1
             GRAD_BAROTROPIC_P(i,j,1) = (press(i+1,j) - press(i,j))*dxter_bt(i,j)*tmasken_bt(i,j,1)
             GRAD_BAROTROPIC_P(i,j,2) = (press(i,j+1) - press(i,j))*dytnr_bt(i,j)*tmasken_bt(i,j,2)
          enddo
       enddo

    endif 

    GRAD_BAROTROPIC_P(iend:,:,:) = 0.0
    GRAD_BAROTROPIC_P(:,jend:,:) = 0.0

end function GRAD_BAROTROPIC_P
! </FUNCTION> NAME="GRAD_BAROTROPIC_P"

!#######################################################################
! <FUNCTION NAME="S2D">
!
! <DESCRIPTION>
! Smooth a 2D field with a 2D version of a 1D filter with weights (1/4, 1/2, 1/4)
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be smoothed 
! </IN>
!
function S2D(a) 

    real, intent(in), dimension(isd:,jsd:) :: a
    real, dimension(isd:ied,jsd:jed)       :: S2D
    real, dimension(-1:1,-1:1)             :: fir
    integer :: i, j, iq, jq

    fir(-1,-1) = onesixteenth
    fir(0,-1)  = oneeigth
    fir(1,-1)  = onesixteenth
    fir(-1,0)  = oneeigth
    fir(0,0)   = onefourth
    fir(1,0)   = oneeigth
    fir(-1,1)  = onesixteenth
    fir(0,1)   = oneeigth
    fir(1,1)   = onesixteenth         
    do j=jsc-halo+1,jec+halo-1
       do i=isc-halo+1,iec+halo-1
          S2D(i,j) = 0.0
          do jq=-1,1
             do iq=-1,1
                S2D(i,j) = S2D(i,j) + fir(iq,jq)*a(i+iq,j+jq)
             enddo
          enddo
       enddo
    enddo
    S2D(iec+halo,:) = 0.0
    S2D(isc-halo,:) = 0.0
    S2D(:,jec+halo) = 0.0
    S2D(:,jsc-halo) = 0.0

end function S2D
! </FUNCTION> NAME="S2D"


!#######################################################################
! <FUNCTION NAME="LAP_T">
!
! <DESCRIPTION>
!  Compute horizontal 5-point Laplacian operator on eta_t.
!  Result lives at T-cell center. 
!
!  Redundancy update for tripolar is needed to conserve  
!  total volume and tracer.  It is likely unimportant 
!  when call LAP_T from within the barotropic loop. Yet it 
!  is essential when call LAP_T from ocean_surface_smooth.
!
!  Mixing coefficient is assumed to be centred on the T-cell.
!  It is averaged to compute its value on the i-face and j-face
!  for computing fluxes. 
!
! </DESCRIPTION>
!
function LAP_T (a, mix, update)

    real, intent(in),    dimension(isd:ied,jsd:jed) :: a
    real, intent(in),    dimension(isd:ied,jsd:jed) :: mix
    logical, intent(in),                   optional :: update

    real, dimension(isd:ied,jsd:jed) :: fx, fy, LAP_T
    real                             :: chg

    integer :: i, j, k
    logical :: update_domains

    k = 1

    if (PRESENT(update)) then 
       update_domains = update
    else 
       update_domains = .false.
    endif  

    do j = jsc-halo, jec+halo
       do i = isc-halo,iec+halo-1
          fx(i,j) = 0.5*(mix(i,j)+mix(i+1,j))*((a(i+1,j)-a(i,j))*Grd%dxter(i,j))*fmx_tmask(i,j,k)
       enddo
    enddo
    fx(iec+halo,:) = 0.0

    do j = jsc-halo, jec+halo-1
       do i = isc-halo,iec+halo
          fy(i,j) = 0.5*(mix(i,j)+mix(i,j+1))*((a(i,j+1)-a(i,j))*Grd%dytnr(i,j))*fmy_tmask(i,j,k)
       enddo
    enddo
    fy(:,jec+halo) = 0.0

    if(Grd%tripolar .and. update_domains) then
       call mpp_update_domains(fx, fy, Dom_flux%domain2d, gridtype=CGRID_NE)
    endif 

    LAP_T(:,:) = 0.0

    do j=jsc,jec
       do i=isc,iec
          chg        = (Grd%dyte(i,j)*fx(i,j) - Grd%dyte(i-1,j)*fx(i-1,j))*Grd%datr(i,j) &
                     + (Grd%dxtn(i,j)*fy(i,j) - Grd%dxtn(i,j-1)*fy(i,j-1))*Grd%datr(i,j)
          LAP_T(i,j) = Grd%tmask(i,j,k)*chg
       enddo
    enddo
 
end function LAP_T
! </FUNCTION> NAME="LAP_T">


!#######################################################################
! <FUNCTION NAME="FAX">
!
! <DESCRIPTION>
! Forwards average in the i-direction on the X-axis.
! If input is a(i,j) then output is defined at (i+1/2,j)
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be averaged  
! </IN>
function FAX(a) 

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: FAX
  integer :: i, j

  do j=jsc-halo,jec+halo
     do i=isc-halo,iec+halo-1
        FAX(i,j) = 0.5*(a(i,j) + a(i+1,j))
     enddo
     FAX(iec+halo,j) = 0.0
  enddo
end function FAX
! </FUNCTION> NAME="FAX"


!#######################################################################
! <FUNCTION NAME="BAX">
!
! <DESCRIPTION>
! Backwards average in the i-direction along the X-axis.
! If input is a(i,j) then output is defined at (i-1/2,j)
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be averaged  
! </IN>
!
function BAX(a) 

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: BAX
  integer :: i, j

  do j=jsc-halo,jec+halo
     do i=isc-halo+1,iec+halo
        BAX(i,j) = 0.5*(a(i,j) + a(i-1,j))
     enddo
     BAX(isc-halo,j) = 0.0
  enddo
end function BAX
! </FUNCTION> NAME="BAX"


!#######################################################################
! <FUNCTION NAME="FAY">
!
! <DESCRIPTION>
! Forwards average in the j-direction on the Y-axis
! If input is a(i,j) then output is defined at (i,j+1/2)
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be averaged  
! </IN>
function FAY(a)

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: FAY
  integer :: i, j

  do j=jsc-halo,jec+halo-1
     do i=isc-halo,iec+halo
        FAY(i,j) = 0.5*(a(i,j) + a(i,j+1))
     enddo
  enddo
  FAY(:,jec+halo) = 0.0

end function FAY
! </FUNCTION> NAME="FAY"


!#######################################################################
! <FUNCTION NAME="BAY">
!
! <DESCRIPTION>
! Backwards average in the j-direction along the Y-axis
! If input is a(i,j) then output is defined at (i,j-1/2)
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be averaged  
! </IN>
function BAY(a)

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed) :: BAY
  integer :: i, j

  do j=jsc-halo+1,jec+halo
     do i=isc-halo,iec+halo
        BAY(i,j) = 0.5*(a(i,j) + a(i,j-1))
     enddo
  enddo
  BAY(:,jsc-halo) = 0.0

end function BAY
! </FUNCTION> NAME="BAY"


!#######################################################################
! <FUNCTION NAME="BDX_EU">
!
! <DESCRIPTION>
! Backwards Derivative in X of a quantity defined on the East face of a U-cell
! If input is a(i,j) then output is defined at (i-1/2,j)
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be finite differenced 
! </IN>
function BDX_EU(a)

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: BDX_EU
  integer :: i, j

  do j=jsc-halo,jec+halo
     do i=isc-halo+1,iec+halo
        BDX_EU(i,j) = (Grd%dyue(i,j)*a(i,j) - Grd%dyue(i-1,j)*a(i-1,j))*Grd%daur(i,j)
     enddo
     BDX_EU(isc-halo,j) = 0.0
  enddo

end function BDX_EU
! </FUNCTION> NAME="BDX_EU"


!#######################################################################
! <FUNCTION NAME="BDX_ET">
!
! <DESCRIPTION>
! Backwards derivative in X of a quantity defined on the East face of a T-cell.
! If input is a(i,j) then output is defined at (i-1/2,j)
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be finite differenced 
! </IN>
function BDX_ET(a)

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: BDX_ET
  integer :: i, j

  do j=jsc-halo,jec+halo
     do i=isc-halo+1,iec+halo
        BDX_ET(i,j) = (Grd%dyte(i,j)*a(i,j) - Grd%dyte(i-1,j)*a(i-1,j))*Grd%datr(i,j) 
     enddo
     BDX_ET(isc-halo,j) = 0.0
  enddo

end function BDX_ET
! </FUNCTION> NAME="BDX_ET"


!#######################################################################
! <FUNCTION NAME="FDX_U">
!
! <DESCRIPTION>
! Forward Derivative in X of a quantity defined on the grid point of a U-cell.
! If input is a(i,j) then output is defined at (i+1/2,j).
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be finite differenced 
! </IN>
function FDX_U(a)

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: FDX_U
  integer :: i, j

  do j=jsc-halo,jec+halo
     do i=isc-halo,iec+halo-1
        FDX_U(i,j) = (a(i+1,j) - a(i,j))*Grd%dxuer(i,j)
     enddo
     FDX_U(iec+halo,j) = 0.0
  enddo

end function FDX_U
! </FUNCTION> NAME="FDX_U"


!#######################################################################
! <FUNCTION NAME="FDX_ZT">
!
! <DESCRIPTION>
!
! Forward Derivative in X of a quantity defined on a tracer grid point
! where it is necessary to take derivative with depth held constant.  
! When grid points live at different depths, then have an extra 
! contribution to the derivative.  
!
! Input a(i,j,1) is at the grid point of a T-cell at level k-1.
! Input a(i,j,2) is at the grid point of a T-cell at level k.
!
! Output is defined at (i+1/2,j) which is at the east face in a T-cell at level k.
!
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be finite differenced 
! </IN>
! <IN NAME="k" TYPE="integer">
! Depth level 
! </IN>
function FDX_ZT(a,k)

  real, intent(in), dimension(isd:,jsd:,:) :: a
  real, dimension(isd:ied,jsd:jed) :: FDX_ZT
  integer, intent(in)  :: k
  integer :: i, j

  do i=isc-halo,iec+halo-1
     FDX_ZT(i,:) = (a(i+1,:,2) - a(i,:,2))*Grd%dxter(i,:)
  enddo
  FDX_ZT(iec+halo,:) = 0.0

!   expanded form of 
!   FDX_ZT(:,:) = FDX_ZT(:,:) - FAX(FDZ_T(a(:,:,1:2),k-1))*FDX_T(Thk%depth_zt(:,:,k))

  do j=jsc-halo,jec+halo
     do i=isc-halo,iec+halo-1   
        FDX_ZT(i,j) = FDX_ZT(i,j) - 0.5*( -(a(i,  j,2) - a(i,  j,1))/Thk%dzwt(i,  j,k-1)   &
                                          -(a(i+1,j,2) - a(i+1,j,1))/Thk%dzwt(i+1,j,k-1) ) &
                                   *((Thk%depth_zt(i+1,j,k) - Thk%depth_zt(i,j,k))*Grd%dxter(i,j))
     enddo
  enddo

end function FDX_ZT
! </FUNCTION> NAME="FDX_ZT"


!#######################################################################
! <FUNCTION NAME="FDX_T">
!
! <DESCRIPTION>
!
! Forward Derivative in X of a quantity defined on the grid point
! of a T-cell.
!
! For lateral derivatives where vertical coordinate is held constant.  
!
! Input a(i,j) is at the grid point of a T-cell
! Output is defined at (i+1/2,j) which is at the east face in a T-cell.
!
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be finite differenced 
! </IN>
function FDX_T(a)

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: FDX_T
  integer :: i, j

  do j=jsc-halo,jec+halo
     do i=isc-halo,iec+halo-1
        FDX_T(i,j) = (a(i+1,j) - a(i,j))*Grd%dxter(i,j) 
     enddo
     FDX_T(iec+halo,j) = 0.0
  enddo

end function FDX_T
! </FUNCTION> NAME="FDX_T"


!#######################################################################
! <FUNCTION NAME="FDY_ZT">
!
! <DESCRIPTION>
! Forward Derivative in Y of a quantity defined on a tracer grid point
! where it is necessary to take derivative with depth held constant.  
! When grid points live at different depths, then have an extra 
! contribution to the derivative.  
!
! Input a(i,j,1) is at the grid point of a T-cell at level k-1.
! Input a(i,j,2) is at the grid point of a T-cell at level k.
!
! Output is defined at (i,j+1/2) which is at the north face in a T-cell at level k.
!
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be finite differenced 
! </IN>
! <IN NAME="k" TYPE="integer">
! Depth level 
! </IN>
function FDY_ZT(a,k)

  real, intent(in), dimension(isd:,jsd:,:) :: a
  real, dimension(isd:ied,jsd:jed) ::  FDY_ZT
  integer, intent(in)  :: k
  integer :: i, j

  do j=jsc-halo,jec+halo-1
     do i=isc-halo,iec+halo
        FDY_ZT(i,j) = (a(i,j+1,2) - a(i,j,2))*Grd%dytnr(i,j)
     enddo
  enddo
  FDY_ZT(:,jec+halo) = 0.0

! expanded form of 
! FDY_ZT(:,:) = FDY_ZT(:,:) - FAY(FDZ_T(a(:,:,1:2),k-1))*FDY_T(Grd%depth_zt(:,:,k))

  do j=jsc-halo,jec+halo-1
     do i=isc-halo,iec+halo
        FDY_ZT(i,j) = FDY_ZT(i,j) - 0.5*( -(a(i,  j,2) - a(i,  j,1))/Thk%dzwt(i,  j,k-1)   &
                                          -(a(i,j+1,2) - a(i,j+1,1))/Thk%dzwt(i,j+1,k-1) ) &
                                    *((Thk%depth_zt(i,j+1,k) - Thk%depth_zt(i,j,k))*Grd%dytnr(i,j))
     enddo
  enddo


end function FDY_ZT
! </FUNCTION> NAME="FDY_ZT"


!#######################################################################
! <FUNCTION NAME="FDY_T">
!
! <DESCRIPTION>
! Forward Derivative in Y of a quantity defined on the grid Point
! of a T-cell.
!
! For lateral derivatives where vertical coordinate is held constant.  
!
! Input a(i,j) is at the grid point of a T-cell.
! Output is defined at (i,j+1/2) which is at the north face in a T-cell.
!
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be finite differenced 
! </IN>
function FDY_T(a)

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: FDY_T
  integer :: i, j

  do j=jsc-halo,jec+halo-1
     do i=isc-halo,iec+halo
        FDY_T(i,j) = (a(i,j+1) - a(i,j))*Grd%dytnr(i,j)
     enddo
  enddo
  do i=isc-halo,iec+halo
    FDY_T(i,jec+halo) = 0.0
  enddo

end function FDY_T
! </FUNCTION> NAME="FDY_T"


!#######################################################################
! <FUNCTION NAME="FDX_NT">
!
! <DESCRIPTION>
! Forward Derivative in X of a quantity defined on the North face of a T-cell.
! If input is a(i,j) then output is defined at (i+1/2,j).
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be finite differenced 
! </IN>
function FDX_NT(a)

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: FDX_NT
  integer :: i, j

  do j=jsc-halo,jec+halo
     do i=isc-halo,iec+halo-1
        FDX_NT(i,j) = (a(i+1,j) - a(i,j))*Grd%dxur(i,j)
     enddo
     FDX_NT(iec+halo,j) = 0.0
  enddo

end function FDX_NT
! </FUNCTION> NAME="FDX_NT"


!#######################################################################
! <FUNCTION NAME="BDY_NU">
!
! <DESCRIPTION>
! Backward Derivative in Y of a quantity defined on the North face of a U-cell.
! If input is a(i,j) then output is defined at (i,j-1/2).
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be finite differenced 
! </IN>
function BDY_NU(a)

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: BDY_NU
  integer :: i, j

  do j=jsc-halo+1,jec+halo
     do i=isc-halo,iec+halo
        BDY_NU(i,j) = (Grd%dxun(i,j)*a(i,j) - Grd%dxun(i,j-1)*a(i,j-1))*Grd%daur(i,j)
     enddo
  enddo
  BDY_NU(:,jsc-halo) = 0.0

end function BDY_NU
! </FUNCTION> NAME="BDY_NU"


!#######################################################################
! <FUNCTION NAME="BDY_NT">
!
! <DESCRIPTION>
! Backward Derivative in Y of a quantity defined on the North face of a T-cell.
! If input is a(i,j) then output is defined at (i,j-1/2).
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be finite differenced 
! </IN>
function BDY_NT(a)

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: BDY_NT
  integer :: i, j

  do j=jsc-halo+1,jec+halo
     do i=isc-halo,iec+halo
        BDY_NT(i,j) = (Grd%dxtn(i,j)*a(i,j) - Grd%dxtn(i,j-1)*a(i,j-1))*Grd%datr(i,j)  
     enddo
  enddo
  BDY_NT(:,jsc-halo) = 0.0

end function BDY_NT
! </FUNCTION> NAME="BDY_NT"


!#######################################################################
! <FUNCTION NAME="FDY_U">
!
! <DESCRIPTION>
! Forward Derivative in Y of a quantity defined on the grid Point of a U-cell.
! If input is a(i,j) then output is defined at (i,j+1/2).
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be finite differenced 
! </IN>
function FDY_U(a)

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: FDY_U
  integer :: i, j

  do j=jsc-halo,jec+halo-1
     do i=isc-halo,iec+halo
        FDY_U(i,j) = (a(i,j+1) - a(i,j))*Grd%dyunr(i,j)
     enddo
  enddo
  FDY_U(:,jec+halo) = 0.0

end function FDY_U
! </FUNCTION> NAME="FDY_U"


!#######################################################################
! <FUNCTION NAME="FDY_ET">
!
! <DESCRIPTION>
! Forward Derivative in Y of a quantity defined on the East face of a T-cell.
! If input is a(i,j) then output is defined at (i,j+1/2).
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be finite differenced 
! </IN>
function FDY_ET(a)

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: FDY_ET
  integer :: i, j

  do j=jsc-halo,jec+halo-1
     do i=isc-halo,iec+halo
        FDY_ET(i,j) = (a(i,j+1) - a(i,j))*Grd%dyur(i,j)
     enddo
  enddo
  FDY_ET(:,jec+halo) = 0.0

end function FDY_ET
! </FUNCTION> NAME="FDY_ET"


!#######################################################################
! <FUNCTION NAME="FDZ_T">
!
! <DESCRIPTION>
! Forward Derivative in Z of a field on the T-cell point at level k.
!
! input a(i,j,1) is at the grid point of a T-cell at level k.
! input a(i,j,2) is at the grid point of a T-cell at level k+1.
!
! output is at (i,j,k+3/2) which is bottom face of T-cell at level k.
!
! minus sign due to convention that z-increases upwards, whereas
! k increases downward.  
!
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to be finite differenced 
! </IN>
! <IN NAME="k" TYPE="integer">
! Depth level index 
! </IN>
!
function FDZ_T(a, k)

  real, intent(in), dimension(isd:,jsd:,:) :: a
  real, dimension(isd:ied,jsd:jed)         :: FDZ_T
  integer, intent(in) :: k

  FDZ_T(:,:) =  -(a(:,:,2) - a(:,:,1))/Thk%dzwt(:,:,k) 

end function FDZ_T
! </FUNCTION> NAME="FDZ_T"


!#######################################################################
! <FUNCTION NAME="FMX">
!
! <DESCRIPTION>
! Forwards Minimum in the X direction.
! If input is a(i,j) then output is defined at (i+1/2,j).
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to find minimum
! </IN>
!
function FMX (a)

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: FMX
  integer :: i, j

  do j=jsc-halo,jec+halo
     do i=isc-halo,iec+halo-1
        FMX(i,j) = min(a(i+1,j), a(i,j))
     enddo
     FMX(iec+halo,j) = 0.0
  enddo

end function FMX
! </FUNCTION> NAME="FMX"


!#######################################################################
! <FUNCTION NAME="FMY">
!
! <DESCRIPTION>
! Forwards Minimum in the Y direction.
! If input is a(i,j) then output is defined at (i,j+1/2).
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! Field to find minimum
! </IN>
function FMY (a)

  real, intent(in), dimension(isd:,jsd:) :: a
  real, dimension(isd:ied,jsd:jed)       :: FMY
  integer :: i, j

  do j=jsc-halo,jec+halo-1
     do i=isc-halo,iec+halo
        FMY(i,j) = min(a(i,j+1), a(i,j))
     enddo
  enddo
  FMY(:,jec+halo) = 0.0

end function FMY
! </FUNCTION> NAME="FMY"



end module ocean_operators_mod

module vegn_radiation_mod

use fms_mod,            only : write_version_number, error_mesg, FATAL
use constants_mod,      only : stefan

use land_constants_mod, only : NBANDS
use vegn_data_mod,      only : spdata, min_cosz
use vegn_tile_mod,      only : vegn_tile_type
use vegn_cohort_mod,    only : vegn_cohort_type, vegn_data_cover, get_vegn_wet_frac
use snow_mod,           only : snow_radiation

use land_debug_mod,     only : is_watch_point 

implicit none
private

! ==== public interfaces =====================================================
public :: vegn_radiation_init
public :: vegn_radiation
! ==== end of public interfaces ==============================================

! ==== module constants ======================================================
character(len=*), private, parameter :: &
   version = '$Id: vegn_radiation.F90,v 17.0 2009/07/21 03:03:28 fms Exp $', &
   tagname = '$Name: tikal $' ,&
   module_name = 'vegn_radiation'
! values for internal vegetation radiation option selector
integer, parameter :: VEGN_RAD_BIGLEAF   = 1 ! "big-leaf" radiation
integer, parameter :: VEGN_RAD_TWOSTREAM = 2 ! two-stream radiation code

! values for internal intercepted snow radiation properties selector -- currently
! works only for VEGN_RAD_TWOSTREAM
integer, parameter :: SNOW_RAD_IGNORE       = 1 ! no influence of intercepted snow
integer, parameter :: SNOW_RAD_PAINT_LEAVES = 2 ! intecepted snow modifies leaf 
   ! reflectance and transmittance

! ==== module variables ======================================================
integer :: vegn_rad_option = -1 ! selector of the current vegetation radiation option
integer :: snow_rad_option = -1 ! selector of the current snow rad properties option


contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

#if defined(__GFORTRAN__)

#define __DEBUG__(x) write(*,*) "x" , x

#else

#define __DEBUG__(x) write(*,*) #x , x

#endif


! ============================================================================
! initialize vegetation radiation options
subroutine vegn_radiation_init(rad_to_use,snow_rad_to_use)
  character(*), intent(in) :: rad_to_use
  character(*), intent(in) :: snow_rad_to_use

  call write_version_number(version, tagname)

  ! convert symbolic names of radiation options into numeric IDs to
  ! speed up selection during run-time
  if(trim(rad_to_use)=='big-leaf') then
     vegn_rad_option = VEGN_RAD_BIGLEAF
  else if(trim(rad_to_use)=='two-stream') then
     vegn_rad_option = VEGN_RAD_TWOSTREAM
  else
     call error_mesg('vegn_radiation_init',&
          'vegetation radiation option rad_to_use="'//trim(rad_to_use)//'" is invalid, '// &
          'use "big-leaf" or "two-stream"',&
          FATAL)
  endif
  if (trim(snow_rad_to_use)=='ignore') then
     snow_rad_option = SNOW_RAD_IGNORE
  else if (trim(snow_rad_to_use)=='paint-leaves') then
     snow_rad_option = SNOW_RAD_PAINT_LEAVES
  else
     call error_mesg('vegn_radiation_init',&
          'vegetation radiation option snow_rad_to_use="'//trim(snow_rad_to_use)//'" is invalid, '// &
          'use "ignore" or "paint-leaves"',&
          FATAL)
  endif

end subroutine vegn_radiation_init


! ============================================================================
! compute vegetation-only properties needed to do soil-canopy-atmos 
! energy balance. in this version, also derive the aerodynamic soil-canopy
! variables, but probably this should be separated, like radiation is.
subroutine vegn_radiation ( vegn, &
     cosz, snow_depth, snow_refl_dif, snow_emis, &
     vegn_refl_dif, vegn_tran_dif, vegn_refl_dir, vegn_sctr_dir, vegn_tran_dir, &
     vegn_refl_lw, vegn_tran_lw )

  type(vegn_tile_type), intent(inout) :: vegn ! it is only inout because 
                                ! vegn_data_cover modifies cohort; cane we avoid this?
  real, intent(in)  :: cosz     ! cosine of zenith angle of direct (solar) beam
  real, intent(in)  :: snow_depth
  real, intent(in)  :: snow_refl_dif(NBANDS)
  real, intent(in)  :: snow_emis
  real, intent(out) :: &
       vegn_refl_dif(NBANDS), & ! reflectance of canopy for diffuse light
       vegn_tran_dif(NBANDS), & ! transmittance of canopy for diffuse light
       vegn_refl_dir(NBANDS), & ! reflectance of canopy for direct light
       vegn_sctr_dir(NBANDS), & ! part of direct light that is scattered downward
       vegn_tran_dir(NBANDS), & ! part of direct light that passes through the canopy unmolested
       vegn_refl_lw, & ! reflectance of canopy for long-wave (thermal) radiation 
       vegn_tran_lw    ! transmittance of canopy for long-wave (thermal) radiation

  ! ---- local vars 
  real :: vegn_cover, vegn_cover_snow_factor, vegn_lai, &
       vegn_leaf_refl(NBANDS), vegn_leaf_emis, vegn_K

  call vegn_data_cover ( vegn%cohorts(1), snow_depth, vegn_cover, vegn_cover_snow_factor )
  select case(vegn_rad_option)
  case(VEGN_RAD_BIGLEAF)
     call vegn_rad_properties_bigleaf ( vegn%cohorts(1), snow_refl_dif, snow_emis, &
          vegn_leaf_refl, vegn_leaf_emis, vegn_lai, vegn_K )
     vegn_refl_dif = vegn_cover * vegn_leaf_refl
     vegn_refl_dir = vegn_cover * vegn_leaf_refl
     vegn_tran_dif = 1 - vegn_cover 
     vegn_sctr_dir = 0
     vegn_tran_dir = 1 - vegn_cover
  case(VEGN_RAD_TWOSTREAM)
     call vegn_rad_properties_twostream ( vegn%cohorts(1), cosz, &
          vegn_refl_dif, vegn_tran_dif, &
          vegn_refl_dir, vegn_sctr_dir, vegn_tran_dir,&
          vegn_leaf_emis )
!
! ++++ pcm
     vegn_refl_dif = vegn_cover_snow_factor * vegn_refl_dif
     vegn_refl_dir = vegn_cover_snow_factor * vegn_refl_dir
     vegn_sctr_dir = vegn_cover_snow_factor * vegn_sctr_dir
     vegn_tran_dif = vegn_cover_snow_factor * vegn_tran_dif &
                       + (1-vegn_cover_snow_factor)
     vegn_tran_dir = vegn_cover_snow_factor * vegn_tran_dir &
                       + (1-vegn_cover_snow_factor)
! ---- pcm
!
  case default
     call error_mesg('vegn_radiation', &
          'invalid vegetation radiation option', FATAL)
  end select
  vegn_refl_lw       = vegn_cover * (1-vegn_leaf_emis)
  vegn_tran_lw       = 1 - vegn_cover

  ! store the extinction coefficients for use in photosynthesis calculations -- 
  ! currently calculated as if all light were direct
  vegn%cohorts(1)%extinct = &
       (spdata(vegn%cohorts(1)%species)%phi1+spdata(vegn%cohorts(1)%species)%phi2*cosz)&
       / max(cosz,min_cosz)

end subroutine vegn_radiation

! ============================================================================
! compute vegetation-only properties needed to do soil-canopy-atmos 
! energy balance.
subroutine vegn_rad_properties_bigleaf ( cohort, snow_refl, snow_emis, &
     vegn_leaf_refl, vegn_leaf_emis, vegn_lai, vegn_K )
  type(vegn_cohort_type), intent(in) :: cohort
  real, intent(in)  :: snow_refl(NBANDS), snow_emis
  real, intent(out) :: vegn_leaf_refl(NBANDS), vegn_leaf_emis, vegn_lai, vegn_K

  ! ---- local vars 
  real :: a_vs

  if ( cohort%Ws_max > 0 ) then
     a_vs = cohort%prog%Ws / cohort%Ws_max
     ! restrict snow-covered fraction to the interval [0,1]:
     a_vs = min(max(a_vs,0.0), 1.0)
  else
     a_vs = 0
  endif

  ! ---- snow-interception-adjusted radiative properties of vegetation ---------
  vegn_leaf_refl = cohort%leaf_refl + (snow_refl - cohort%leaf_refl)*a_vs
  vegn_leaf_emis = cohort%leaf_emis + (snow_emis - cohort%leaf_emis)*a_vs

  vegn_K = 2.  ! this is a temporary placeholder for now. value does not matter
               ! as long as substrate albedoes for dif/dir are the same.
  vegn_lai      = cohort%lai

end subroutine vegn_rad_properties_bigleaf


! ============================================================================
subroutine vegn_rad_properties_twostream( cohort, cosz, &
          vegn_refl_dif, vegn_tran_dif, &
          vegn_refl_dir, vegn_sctr_dir, vegn_tran_dir, &
          vegn_leaf_emis )
  type(vegn_cohort_type), intent(in) :: cohort
  real, intent(in) :: cosz ! cosine of direct light zenith angle
  real, intent(out), dimension(NBANDS) :: &
       vegn_refl_dif, & ! reflectance for diffuse light
       vegn_tran_dif, & ! transmittance for diffuse light 
       vegn_refl_dir, & ! reflectance for direct light
       vegn_sctr_dir, & ! part of direct light scattered downward (source of 
                        ! diffuse due to direct light scattering)
       vegn_tran_dir    ! transmittance of direct light 
  real, intent(out) :: &
       vegn_leaf_emis   ! emissivity of leaves

  ! ---- local constants
  real, parameter :: albedo_surf = 0.0 ! since we need values for black-background contribution

  ! ---- local vars
  integer :: i
  integer :: sp ! current species, solely to shorten the notation 
  real :: leaf_refl, leaf_tran ! optical properties of partially snow-covered leaves
  real :: snow_refl_dif(NBANDS) ! snow reflectances
  real :: snow_refl_dir(NBANDS), snow_refl_lw, snow_emis ! snow rad. properies (unused)
  real :: fs ! fractional coverage of intercepted snow

  ! get the snow fraction
  select case (snow_rad_option)
  case(SNOW_RAD_PAINT_LEAVES) 
     call get_vegn_wet_frac(cohort, fs=fs)
  case default
     fs = 0
  end select

  ! get the snow radiative properties for current canopy temperature
  call snow_radiation ( cohort%prog%Tv, cosz, snow_refl_dir, snow_refl_dif, snow_refl_lw, snow_emis )

  sp = cohort%species
  do i = 1, NBANDS
     ! calculate the radiative properties of partially snow-covered leaves, assuming
     ! that the transmittance of snow is zero.
     leaf_refl = (1-fs)*cohort%leaf_refl(i) + fs*snow_refl_dif(i)
     leaf_tran = (1-fs)*cohort%leaf_tran(i)

     call twostream ( max(cosz, min_cosz), &
          spdata(sp)%mu_bar, cohort%lai, albedo_surf, &
          spdata(sp)%phi1, spdata(sp)%phi2, &
          leaf_refl, leaf_tran, &
          vegn_tran_dir(i), vegn_sctr_dir(i), vegn_refl_dir(i), &
          vegn_tran_dif(i), vegn_refl_dif(i)  )
  enddo

  vegn_leaf_emis = cohort%leaf_emis*(1-fs) + snow_emis*fs

end subroutine vegn_rad_properties_twostream


! ============================================================================
subroutine twostream( &
   mu, mu_bar, LAI, albedo_g, phi1, phi2, rl, tl, transm_dir, scatter_dir, albedo_dir, &
   transm_dif, albedo_dif )
   
  real, intent(in)  :: mu         ! cosine of direct light zenith angle
  real, intent(in)  :: mu_bar     ! average inverse diffuse optical depth per unit leaf area
  real, intent(in)  :: LAI        ! leaf area index
  real, intent(in)  :: albedo_g   ! ground surface albedo
  real, intent(in)  :: phi1, phi2 ! coefficients of expression for G_mu
  real, intent(in)  :: rl         ! reflectivity of leaves
  real, intent(in)  :: tl         ! transmittance of leaves
  ! output
  real, intent(out) :: transm_dir ! canopy transmittance for direct beam -- that 
                                  ! is, the part of the beam that passes through 
                                  ! the canopy untouched
  real, intent(out) :: scatter_dir! part of direct beam scattered down, at the 
                                  ! bottom of the canopy 
  real, intent(out) :: albedo_dir ! overall land surface albedo for direct beam 
  real, intent(out) :: transm_dif ! canopy transmittance for diffuse incident light
  real, intent(out) :: albedo_dif ! overall land surface albedo for diffuse incident light

  ! ---- local vars 
  real :: G_mu        ! relative projected leaf area in direction of direct beam
  real :: K           ! optical depth for direct beam per unit LAI
  real :: g1,g2,g3,g4 ! coefficients in the two-stream equation
  real :: kappa       ! eigenvalue of free solution
  real :: a_up, b_up, c_up ! coefficients of upward diffuse light flux
  real :: a_dn, b_dn, c_dn ! coefficients of downward diffuse light flux
  real :: x1,x2       ! intermediate coefficients
  real :: a11,a12,a21,a22, d1,d2 ! coefficients of linear system
  real :: D           ! determinant of the matrix
  real :: A,B         ! coefficients of diffuse light function
  real :: dif_dn_bot, dif_up_bot, dif_up_top
   
  real, parameter :: eta = 6.0; ! this value is suitable only for uniform leaf 
                                ! angular distribution !!!
   
  if(is_watch_point()) then
     write(*,*)'############ twostream input ############'
     __DEBUG__(mu)
     __DEBUG__(mu_bar)
     __DEBUG__(LAI)
     __DEBUG__(albedo_g)
     __DEBUG__(phi1)
     __DEBUG__(phi2)
     __DEBUG__(rl)
     __DEBUG__(tl)
     write(*,*)'############ twostream input ############'
  endif    
  ! calculate coefficients of optical path
  G_mu=phi1+phi2*mu;
  K = G_mu/mu;
 
  ! given optical parameters, calculate coefficients of basic equation
  g1 = (1-(rl+tl)/2+(rl-tl)/eta)/mu_bar;
  g2 = (  (rl+tl)/2+(rl-tl)/eta)/mu_bar;
  g3 = G_mu*((rl+tl)/2+mu*(rl-tl)/eta/G_mu);
  g4 = G_mu*((rl+tl)/2-mu*(rl-tl)/eta/G_mu);
   
  ! calculate eigenvalue of free solution (=exponent coefficient of 
  ! free solution, notes 12)
  kappa = sqrt(g1**2-g2**2);
   
  ! calculate forced term coefficients for diffuse light intensity
  c_up = ( K*g3-g1*g3-g2*g4)/(K*K-g1*g1+g2*g2);
  c_dn = (-K*g4-g1*g4-g2*g3)/(K*K-g1*g1+g2*g2);
  ! calculate intermediate coefficients for solution
  x1 = g1+g2+kappa; x2 = g1+g2-kappa;

  !write(*,*)mu,K,g1,g2,g3,g4,c_up,c_dn
   
  ! calculate coefficients of the matrix
  a11 = x2; 
  a12 = x1; 
  d1  = -c_dn;
  a21 = exp(kappa*LAI)*(x1-albedo_g*x2);
  a22 = exp(-kappa*LAI)*(x2-albedo_g*x1);
  d2  = exp(-K*LAI)*(albedo_g*c_dn + albedo_g*mu - c_up);
  ! solve the equation system 
  D = a11*a22-a12*a21;
  A = (d1*a22-d2*a12)/D;
  B = (a11*d2-a21*d1)/D;
  
  ! calculate coefficients of the diffuse light solution
  a_up = A*x1; b_up=B*x2;
  a_dn = A*x2; b_dn=B*x1;
  
  ! calculate downward diffuse light at the bottom of the canopy
  dif_dn_bot = a_dn*exp(kappa*LAI) + b_dn*exp(-kappa*LAI)+c_dn*exp(-K*LAI);
  dif_up_bot = a_up*exp(kappa*LAI) + b_up*exp(-kappa*LAI)+c_up*exp(-K*LAI);
  
  ! calculate canopy transmittance and scattered part for direct light
  scatter_dir = dif_dn_bot/mu; ! scatter
  transm_dir  = exp(-K*LAI); ! transmittance for unmolested direct light

  ! calculate canopy reflectance for direct light
  dif_up_top = a_up + b_up + c_up;
  albedo_dir = dif_up_top/mu;
     
  ! calculate upward diffuse light at the top of the canopy
  ! no need to recalculate D, since the matrix is the same
  d1 = 1.0;
  d2 = 0.0;
  A = (d1*a22-d2*a12)/D;
  B = (a11*d2-a21*d1)/D;

  ! calculate coefficients of the diffuse light solution
  a_up = A*x1; b_up=B*x2;
  a_dn = A*x2; b_dn=B*x1;
  
  transm_dif = a_dn*exp(kappa*LAI) + b_dn*exp(-kappa*LAI);
  albedo_dif = a_up + b_up;

  if(is_watch_point()) then
     write(*,*)'############ twostream output #############'
     __DEBUG__(transm_dir)
     __DEBUG__(scatter_dir)
     __DEBUG__(albedo_dir)
     __DEBUG__(transm_dif)
     __DEBUG__(albedo_dif)
     write(*,*)'############ end of twostream output #############'
  endif
end subroutine twostream

end module vegn_radiation_mod

module nfc_mod

  use nfu_mod

implicit none
private

! ==== public interface ======================================================
public :: nfu_inq_compressed_dim, nfu_inq_compressed_var
public :: nfu_get_compressed_var
public :: nfu_put_compressed_var
public :: nfu_get_compressed_rec
! ==== end of public interface ===============================================

! ==== interfaces for overloaded functions ===================================
#define __INTERFACE_SECTION__
interface nfu_inq_compressed_dim
   module procedure inq_compressed_dim_n, inq_compressed_dim_i
end interface

interface nfu_inq_compressed_var
   module procedure inq_compressed_var_n, inq_compressed_var_i
end interface

#define F90_TYPE real(8)
#define NF_TYPE  double
#include "getput_compressed.inc"

#define F90_TYPE integer
#define NF_TYPE  int
#include "getput_compressed.inc"

#undef __INTERFACE_SECTION__
! ---- module constants ------------------------------------------------------
character(len=*), parameter :: &
     version = '$Id: nfc.F90,v 20.0 2013/12/13 23:30:40 fms Exp $', &
     tagname = '$Name: tikal $'

! ---- private type - used to hold dimension/packing information during unpacking
! (see get_compressed_var_i_r8)
type diminfo_type
   integer, pointer :: idx(:)=>NULL() ! packing information
   integer :: length  ! size of the dimension in the input array
   integer :: stride  ! stide along the dimension in the output array
end type 

! ==== NetCDF declarations ===================================================
include 'netcdf.inc'
#define __NF_TRY__(err_code,iret,LABEL)iret=err_code;if(iret/=NF_NOERR)goto LABEL
contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-


! ===========================================================================
function inq_compressed_dim_n(ncid,name,ndims,dimids,dimlens,dimid) result (iret)
  integer :: iret
  integer, intent(in)  :: ncid
  character(*), intent(in) :: name
  integer, intent(out), optional :: ndims
  integer, intent(out), optional :: dimids(:)
  integer, intent(out), optional :: dimlens(:)
  integer, intent(out), optional :: dimid

  integer :: dimid_

  __NF_TRY__(nf_inq_dimid(ncid,name,dimid_),iret,7)
  if(present(dimid)) dimid = dimid_
  __NF_TRY__(inq_compressed_dim_i(ncid,dimid_,ndims,dimids,dimlens),iret,7)
7 return
end function

! ===========================================================================
function inq_compressed_dim_i(ncid,dimid,ndims,dimids,dimlens,dimname) result (iret)
  integer :: iret
  integer, intent(in)  :: ncid,dimid
  integer, intent(out), optional :: ndims
  integer, intent(out), optional :: dimids(:)
  integer, intent(out), optional :: dimlens(:)
  character(*), intent(out), optional :: dimname
  
  character(NF_MAX_NAME) :: dimname_
  character(1024) :: compress ! should be more than enough to hold the compression info
  integer :: dimlen,dimid0,varid,n,is,ie

  __NF_TRY__(nfu_inq_dim(ncid,dimid,name=dimname_),iret,7)
  if(present(dimname)) dimname = dimname_
  compress = ''
  __NF_TRY__(nf_inq_varid(ncid,dimname_,varid),iret,7)
  __NF_TRY__(nf_get_att_text(ncid,varid,'compress',compress),iret,7)

  ! parse the description of the compression
  ie = len_trim(compress)
  n = 0
  do while(ie>0)
     is = scan(compress(1:ie),' ',back=.true.)
     if(is==ie) then
        ! skip space runs
     else
        n = n+1
        iret = nfu_inq_dim(ncid,compress(is+1:ie),len=dimlen,dimid=dimid0)
        __NF_TRY__(iret,iret,7)
        if(present(dimids)) dimids(n) = dimid0
        if(present(dimlens)) dimlens(n) = dimlen
     endif
     ie = is-1
  enddo
  if(present(ndims))ndims=n
7 return
end function

! ============================================================================
function inq_compressed_var_n(ncid, name, id, xtype, ndims, dimids, dimlens, natts, &
     is_dim, has_records, varsize, recsize, nrec, is_compressed) result(iret)
  integer :: iret
  integer, intent(in) :: ncid
  character(*),intent(in) :: name
  integer, intent(out), optional :: id
  integer, intent(out), optional :: xtype
  integer, intent(out), optional :: ndims
  integer, intent(out), optional :: dimids(:)
  integer, intent(out), optional :: dimlens(:)
  integer, intent(out), optional :: natts
  logical, intent(out), optional :: is_dim ! true if variable is a dimension variable
  logical, intent(out), optional :: has_records ! true if variable depends on record dimension
  integer, intent(out), optional :: varsize ! total size of the variable
  integer, intent(out), optional :: recsize ! size of a single record
  integer, intent(out), optional :: nrec    ! number of records
  logical, intent(out), optional :: is_compressed ! true if variable is actually compressed

  integer :: vid
  character(len=NF_MAX_NAME) :: vname

  __NF_TRY__(nf_inq_varid(ncid,name,vid),iret,7)
  if(present(id)) id = vid
  iret = inq_compressed_var_i(ncid,vid,vname,xtype,ndims,dimids,dimlens,natts,&
       is_dim,has_records,varsize,recsize,nrec,is_compressed)

7 return  
end function

! ============================================================================
function inq_compressed_var_i(ncid, vid, name, xtype, ndims, dimids, dimlens, &
     natts, is_dim, has_records, varsize, recsize, nrec, is_compressed) result(iret)
  integer :: iret
  integer, intent(in) :: ncid
  integer, intent(in) :: vid
  character(*),intent(out), optional :: name
  integer, intent(out), optional :: xtype
  integer, intent(out), optional :: ndims
  integer, intent(out), optional :: dimids(:)
  integer, intent(out), optional :: dimlens(:)
  integer, intent(out), optional :: natts
  logical, intent(out), optional :: is_dim ! true if variable is a dimension variable
  logical, intent(out), optional :: has_records ! true if variable depends on record dimension
  integer, intent(out), optional :: varsize ! total size of the variable
  integer, intent(out), optional :: recsize ! size of a single record
  integer, intent(out), optional :: nrec    ! number of records
  logical, intent(out), optional :: is_compressed ! true if variable is actually compressed

  
  integer :: nd0, dids0(NF_MAX_VAR_DIMS),dlens0(NF_MAX_VAR_DIMS)
  integer :: nd1, dids1(NF_MAX_VAR_DIMS),dlens1(NF_MAX_VAR_DIMS)
  integer :: i,n,unlimdim,vsize,rsize
  logical :: compressed

  iret =  nfu_inq_var(ncid, vid, name, xtype, nd0, dids0, dlens0, natts, &
     is_dim, has_records, varsize, recsize, nrec)

  nd1=1
  if(present(is_compressed)) is_compressed=.false.
  do i = 1, nd0
     __NF_TRY__(nfu_inq_dim(ncid,dids0(i),is_compressed=compressed),iret,7)
     if (compressed) then
        iret = nfu_inq_compressed_dim(ncid,dids0(i),&
                             ndims=n,dimids=dids1(nd1:),dimlens=dlens1(nd1:))
        if (iret/=NF_NOERR) goto 7
        nd1 = nd1+n
        if(present(is_compressed)) is_compressed=.true.
     else
        dlens1(nd1) = dlens0(i)
        dids1(nd1) = dids0(i)
        nd1 = nd1+1
     endif
  enddo
  nd1 = nd1-1

  if(present(ndims))   ndims   = nd1
  if(present(dimids))  dimids  = dids1
  if(present(dimlens)) dimlens = dlens1
  if(present(varsize).or.present(recsize)) then
     __NF_TRY__(nf_inq_unlimdim(ncid,unlimdim),iret,7)
     vsize = 1; rsize=1
     do i = 1,nd1
        vsize = vsize*dlens1(i)
        if(dids1(i)/=unlimdim)&
             rsize = rsize*dlens1(i)
     enddo
     if (present(varsize)) varsize=vsize
     if (present(recsize)) recsize=rsize
  end if
7 return

end function

#define __BODY_SECTION__
#define F90_TYPE real(8)
#define NF_TYPE  double
#include "getput_compressed.inc"

#define F90_TYPE integer
#define NF_TYPE  int
#include "getput_compressed.inc"

end module nfc_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: Update internal wave mixing\label{sec:internalWaves}
!
! !INTERFACE:
   subroutine internal_wave(nlev,NN,SS)
!
! !DESCRIPTION:
!  Imposes eddy viscosity and diffusivity characteristic
!  of internal wave activity and shear instability when there is extinction
!  of turbulence as suggested by \cite{KanthaClayson94}.
!  In this case, the new values of $\nu_t$ and $\nu'_t=\nu^B_t$,
!  defined in \eq{fluxes},
!  are used instead of those computed with the model.
!
!  When k is small (extinction of turbulence, diagnosed by
!  $k<${\tt klimiw}),
!  $\nu_t$ and $\nu'_t$ are set to empirical values typical
!  in the presence of internal wave activity (IW) and shear
!  instability (SI). This model is described by
!  \begin{equation}
!    \nu_t = \nu_t^{IW}  + \nu_t^{SI}      \comma
!    \nu'_t= \nu'^{IW}_t + \nu'^{SI}_t     \comma
!  \end{equation}
!  where
!  \begin{equation}
!    \nu_t^{IW}  =         10^{-4}          \comma
!    \nu'^{IW}_t = 5 \cdot 10^{-5}          \point
!  \end{equation}
!  The `SI' parts are functions of the Richardson number according to
!  \begin{eqnarray}
!  \nu_t^{SI} = \nu'^{SI}_t = 0              \comma
!     & R_i>0.7 \comma \\[4mm]
!  \nu_t^{SI} = \nu'^{SI}_t = 5 \cdot 10^{-3} \left( 1-\left(\frac {R_i}
!  {0.7}\right)^2\right)^3                    \comma
!     & 0<R_i<0.7 \comma \\[4mm]
!  \nu_t^{SI} = \nu'^{SI}_t = 5 \cdot 10^{-3} \comma
!     & R_i < 0
!     \point
!  \end{eqnarray}
!  The unit of all diffusivities is m$^2$s$^{-1}$.
!
! !USES:
   use turbulence,    only:            iw_model,alpha,klimiw,rich_cr
   use turbulence,    only:            numiw,nuhiw,numshear
   use turbulence,    only:            tke,num,nuh
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer,  intent(in)                :: nlev
   REALTYPE, intent(in)                :: NN(0:nlev),SS(0:nlev)
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding, Hans Burchard,
!                      Manuel Ruiz Villarreal
!EOP
!-----------------------------------------------------------------------
! !LOCAL VARIABLES:
   REALTYPE              :: rich(0:nlev)
   REALTYPE              :: rich2,pot,x
   integer               :: i
!
!-----------------------------------------------------------------------
!BOC
   if (iw_model.eq.2) then
      rich2 = rich_cr*rich_cr
      do i=1,nlev-1
         if (tke(i).le.klimiw) then
            rich(i)=NN(i)/(SS(i)+1.e-10)
            if (rich(i).lt.rich_cr) then
               if (rich(i).gt.0) then
                  pot=1-rich(i)*rich(i)/rich2
                  x=numshear*pot*pot*pot
                  num(i)=numiw+x
                  nuh(i)=nuhiw+x
               else
                  num(i)=numiw+numshear
                  nuh(i)=nuhiw+numshear
               end if
            else
               num(i)=numiw
               nuh(i)=nuhiw
            end if
         end if
      end do
   end if

   return
   end subroutine internal_wave

!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

!BOP
! !ROUTINE: Perform 2D horizontal-to-lagrangian transport
!
! !INTERFACE:
#ifndef USE_LIMA
subroutine tracer_2d(q, nq, dp1, cx, cy, mfx, mfy, iord, jord,   &
                     ng, cose, cosp, acosp, acap, rcap, tra_step,  &
                     fill, im, jm, km, jfirst, jlast, flx, dt, frac)
#else
subroutine tracer_2d_lima(q, nq, dp1, cx, cy, mfx, mfy, iord, jord,   &
                     ng, cose, cosp, acosp, acap, rcap, fill,    &
                     im, jm, km, jfirst, jlast, va, flx, dt, frac)
#endif
 
! !USES:
use fv_pack, only : beglon, endlon, beglat, endlat
#ifndef USE_LIMA
   use tp_core,          only: split_trac
   use diag_manager_mod, only: send_data
   use fv_diagnostics,   only: id_divg, fv_time
#else
   use shr_kind_mod,     only: r8 => shr_kind_r8
   use tp_core,          only: tp2c
   use fill_module,      only: fillxy
   use diag_manager_mod, only: send_data
   use fv_diagnostics,   only: id_divg, fv_time
#endif

#ifdef SPMD
   use mod_comm,         only: mp_send4d_ns, mp_recv4d_ns, mp_send3d_2,   &
                               mp_recv3d_2,  mp_reduce_max, gid
#endif
   use fv_arrays_mod, only: fv_array_check, fv_array_sync, jsp, jep, ksp, kep
   use mpp_mod, only: mpp_sync
   use fv_arrays_mod, only: fv_stack_push

   implicit none

! !INPUT PARAMETERS:

   integer, intent(in):: im, jm, km
   integer, intent(in):: jfirst, jlast
   integer, intent(in):: ng          ! Max number of ghost latitudes
   integer, intent(in):: nq
   integer, intent(in):: iord,  jord
#ifndef USE_LIMA
   integer, intent(inout):: tra_step
#endif

   real, intent(in)::  cose(jm)
   real, intent(in)::  cosp(jm)
   real, intent(in):: acosp(jm)
   real, intent(in):: acap, rcap
   real, intent(in):: dt

   logical, intent(in):: fill

! !INPUT/OUTPUT PARAMETERS:
   real, intent(inout)::  cx(im,jfirst-ng:jlast+ng,km)
   real, intent(inout):: mfx(im,jfirst:jlast,km)

   real, intent(inout)::  cy(im,jfirst:jlast+1,km)
   real, intent(inout):: mfy(im,jfirst:jlast+1,km)

   real, intent(inout):: dp1(im,jfirst:jlast,km)
   real, intent(inout)::   q(im,jfirst-ng:jlast+ng,km,nq)
   real, intent(out):: frac

! Input work arrays (useless output)
   real, intent(out):: flx(im,jfirst:jlast,km)

#ifdef USE_LIMA 
   real, intent(out)::  va(im,jfirst:jlast,km)
#endif
! !DESCRIPTION:
!
!  Perform large-time-step tracer transport using accumulated Courant
!  numbers (cx, cy) and the mass fluxes (mfx, mfy) within the Lagrangian
!  layers.  This routine is 100\% parallel in the vertical direction
!  (with SMP).  Merdional Courant number will be further split, if
!  necessary, to ensure stability.  Cy <= 1 away from poles; Cy $\le$
!  1/2 at the latitudes closest to the poles.
!
! !CALLED FROM:
!     fvcore
!
!EOP
!---------------------------------------------------------------------
!BOC
      real, parameter:: esl = 1.e-10

! Local variables:
      real  cymax(km)
      real  cy_global
      real  cmax
      real  sum1, sum2
      real  rdt
      real  dp2(im,jfirst:jlast,km)


! Local 2d arrays
#ifdef USE_LIMA
      real(r8) a2(im,jfirst:jlast)
#endif
      real  fx(im,jfirst:jlast)
      real  fy(im,jfirst:jlast+1)
      real  dh(im,jfirst:jlast)

      logical ffsl(jm,km)
      logical used
      integer i, j, k
      integer it, iq, nsplt
      integer js2g0, js2gd, jn2g0,jn2gd


#ifdef use_shared_pointers
      pointer( p_dp2, dp2 )
      pointer( p_cymax, cymax )
      call fv_stack_push( p_dp2, im*km*(jlast-jfirst+1) )
      call fv_stack_push( p_cymax, km )
#endif
      js2g0 = max(2,jfirst)
      jn2g0 = min(jm-1,jlast)
      js2gd = max(2,jfirst-ng)     ! NG latitudes on S (starting at 2)
      jn2gd = min(jm-1,jlast+ng)   ! NG latitudes on S (ending at jm-1)

      call fv_array_check( LOC(cx) )
      call fv_array_check( LOC(mfx) )
      call fv_array_check( LOC(cy) )
      call fv_array_check( LOC(mfy) )
      call fv_array_check( LOC(dp1) )
      call fv_array_check( LOC(q) )
      call fv_array_check( LOC(flx) )
#ifdef USE_LIMA 
      call fv_array_check( LOC(va) )
#endif

!$omp parallel do private(i,j,k,cmax)
      do k=ksp,kep !1,km
         cymax(k) = 0.
         do j=js2g0,jlast
            cmax = 0.
            do i=1,im
               cmax = max( abs(cy(i,j,k)), cmax)
            enddo
            if( j==2 .or. j==jm ) then
! Do not allow N-S CFL number at poles to be greater than 0.5
! The limit is 1.0 elsewhere
                cymax(k) = max(cymax(k), 2.*cmax)
            else
                cymax(k) = max(cymax(k), cmax)
            endif
         enddo
      enddo
      call fv_array_sync()

#ifdef SPMD
#ifndef USE_LIMA
      if ( tra_step/=1 )  &
           call mp_recv4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng, ng, cx)
#else
      call mp_recv4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng, ng, cx)
#endif
      call mp_recv3d_2(gid+1,  im,  jm,      km,                       &
           1,  im,  jfirst,  jlast+1, 1, km,           &
           1,  im,  jlast+1, jlast+1, 1, km, cy, mfy )
      call mp_reduce_max(km, cymax)
! Send data on the way for ghosting the first tracer
      call mp_send4d_ns( im, jm, km, 1, jfirst, jlast, 1, km,       &
                         ng, ng, q(1,jfirst-ng,1,1) )
#endif
      call fv_array_sync()

! Start FMS diagnostics ----------

      if ( id_divg > 0 ) then
!------------------------------------------------------------
! (cx, cy) now ghosted; Compute mean divergence on the C grid
!------------------------------------------------------------
          rdt = 1./ dt
!$omp parallel do private(i,j,k, sum1)
          do k=ksp,kep !1,km
             do j=js2g0,jn2g0
                do i=1,im-1
                   flx(i,j,k) = cx(i+1,j,k) - cx(i,j,k) + (cy(i,j+1,k)*cose(j+1) -  &
                        cy(i,j,k)*cose(j))*acosp(j) 
                enddo
!              i=im
                flx(im,j,k) = cx(1,j,k) - cx(im,j,k) + (cy(im,j+1,k)*cose(j+1) -    &
                     cy(im,j,k)*cose(j))*acosp(j) 
             enddo
! Poles:
             if ( jfirst == 1 ) then
                 sum1 = 0.
                 do i=1,im
                    sum1 = sum1 + cy(i,1,k)
                 enddo
                 sum1 =-sum1*rcap*cose(2)
                 do i=1,im
                    flx(i,1,k) = sum1
                 enddo
             endif
             if ( jlast == jm ) then
                 sum1 = 0.
                 do i=1,im
                    sum1 = sum1 + cy(i,jm,k)
                 enddo
                 sum1 =-sum1*rcap*cose(jm)
                 do i=1,im
                    flx(i,jm,k) = sum1
                 enddo
             endif
             do j=jfirst, jlast
                do i=1,im
                   flx(i,j,k) = flx(i,j,k) * rdt
                enddo
             enddo
          enddo

          call fv_array_sync()
          used = send_data( id_divg, flx(beglon:endlon,beglat:endlat,:), fv_time ) 
      endif
! End FMS diagnostics ----------

! find global max cymax
      cy_global = cymax(1)
      if ( km /= 1 ) then                ! if NOT shallow water test case
         do k=2,km
            cy_global = max(cymax(k), cy_global)
         enddo
      endif

      nsplt = int(1. + cy_global)
      frac  = 1. / float(nsplt)

!     if ( gid == 0 .and. nsplt > 1 )  write(6,*) 'Tracer_2d_split=', nsplt, cy_global

      
      call fv_array_sync() ! don't modify flx before send_data completed
!$omp parallel do private(i,j,k)
      do 4000 k=ksp,kep !1,km

         if( nsplt /= 1 ) then
!!!     do j=2,jm-1
             do j=js2gd,jn2gd                  
                do i=1,im
                   cx(i,j,k) =  cx(i,j,k) * frac      ! cx ghosted on N*ng S*ng
                enddo
             enddo

!!!     do j=2,jm-1
             do j=js2g0,jn2g0
                do i=1,im
                   mfx(i,j,k) = mfx(i,j,k) * frac
                enddo
             enddo

!!!     do j=2,jm
             do j=js2g0,min(jm,jlast+1)
                do i=1,im
                   cy(i,j,k) =  cy(i,j,k) * frac    ! cy ghosted on N
                   mfy(i,j,k) = mfy(i,j,k) * frac    ! mfy ghosted on N
                enddo
             enddo
         endif

#ifdef USE_LIMA  
!!!     do j=2,jm-1
         do j=js2g0,jn2g0
            do i=1,im
               if(cy(i,j,k)*cy(i,j+1,k) > 0.) then
                   if( cy(i,j,k) > 0.) then
                       va(i,j,k) = cy(i,j,k)
                   else
                       va(i,j,k) = cy(i,j+1,k)      ! cy ghosted on N
                   endif
               else
                   va(i,j,k) = 0.
               endif
            enddo
         enddo
#endif

! Check if FFSL extension is needed.

         do 2222 j=js2gd,jn2gd             ! flux needed on N*ng S*ng
            ffsl(j,k) = .false.
            do i=1,im
               if(abs(cx(i,j,k)) > 1.) then  ! cx ghosted on N*ng S*ng
                   ffsl(j,k) = .true.
                   go to 2222
               endif
            enddo
2222     continue


! Scale E-W mass fluxes
         do j=js2g0,jn2g0
            if( ffsl(j,k) ) then
                do i=1,im
                   flx(i,j,k) = mfx(i,j,k)/sign(max(abs(cx(i,j,k)), esl),cx(i,j,k))
                enddo
            else
                do i=1,im
                   flx(i,j,k) = mfx(i,j,k)
                enddo
            endif
         enddo
4000  continue
!        call fv_array_sync()
        
      do 6000 it=1, nsplt

!$omp parallel do private(i, j, k, sum1, sum2)
         do k=ksp,kep !1,km
            do j=js2g0,jn2g0
               do i=1,im-1
                  dp2(i,j,k) =  dp1(i,j,k) + mfx(i,j,k) - mfx(i+1,j,k) +  &
                       (mfy(i,j,k) - mfy(i,j+1,k)) * acosp(j)
               enddo
               dp2(im,j,k) = dp1(im,j,k) + mfx(im,j,k) - mfx(1,j,k) +     &
                    (mfy(im,j,k) - mfy(im,j+1,k)) * acosp(j)
            enddo

! Poles
            if ( jfirst == 1  ) then
                sum1 = 0.
                do i=1,im
                   sum1 = sum1 + mfy(i,2,k)
                enddo

                sum1 = - sum1 * rcap
                do i=1,im
                   dp2(i,1,k) = dp1(i, 1,k) +  sum1
                enddo
            endif

            if ( jlast  == jm ) then
                sum2 = 0.
                do i=1,im
                   sum2 = sum2 + mfy(i,jm,k)
                enddo

                sum2 = sum2 * rcap
                do i=1,im
                   dp2(i,jm,k) = dp1(i,jm,k) +  sum2
                enddo
            endif
         enddo
         call fv_array_sync()

         do 5000 iq=1,nq

#ifdef SPMD
!            if( iq.EQ.1 ) &
!                 call mp_send4d_ns( im, jm, km, 1, jfirst, jlast, 1, km, &
!                 ng, ng, q(1,jfirst-ng,1,1) )
!------------------------------------
! Receive data for the current tracer
!------------------------------------
            call mp_recv4d_ns( im, jm, km, 1, jfirst, jlast, 1, km,    &
                 ng, ng, q(1,jfirst-ng,1,iq))
!-------------------------------
! Send the next tracer if needed
!-------------------------------
            if ( iq /= nq )  then
                call mp_send4d_ns( im, jm, km, 1, jfirst, jlast, 1, km, &
                     ng, ng, q(1,jfirst-ng,1, iq+1) )
            else
!Last tracer is reached for this sub-step; send the next (first) tracer
                if( it /= nsplt .and. nq /=1 )                            &
                     call mp_send4d_ns( im, jm, km, 1, jfirst, jlast, 1, km, &
                     ng, ng, q(1,jfirst-ng,1, 1) )
            endif
            call fv_array_sync()
#endif

!$omp parallel do private(i, j, k, fx, fy, dh)
            do k=ksp,kep !1,km
#ifndef USE_LIMA
               call split_trac(dp1(1,jfirst,k), dp2(1,jfirst,k), dh,     &
                    q(1,jfirst-ng,k,iq), cx(1,jfirst-ng,k),   &
                    cy(1,jfirst,k), im, jm, iord, jord, ng,   &
                    fx, fy, ffsl(1,k), tra_step, fill,   &
                    acap, acosp, flx(1,jfirst,k), mfy(1,jfirst,k),  & 
                    cosp, 1, jfirst, jlast )
#else
               call tp2c(a2, va(1,jfirst,k),     q(1,jfirst-ng,k,iq),  &
                    cx(1,jfirst-ng,k) , cy(1,jfirst,k),       &
                    im, jm,  iord,       jord,   ng,              &
                    fx, fy,  ffsl(1,k),  rcap,   acosp,           &
                    flx(1,jfirst,k),     mfy(1,jfirst,k),         &
                    cosp, 1, jfirst, jlast )

               do j=jfirst,jlast
                  do i=1,im
                     a2(i,j) = q(i,j,k,iq)*dp1(i,j,k) + a2(i,j)
                  enddo
               enddo

               if (fill) call fillxy ( a2,  im, jm, jfirst, jlast,  &
                    acap, cosp, acosp )

               do j=jfirst,jlast
                  do i=1,im
                     q(i,j,k,iq) = a2(i,j) / dp2(i,j,k)
                  enddo
               enddo

#endif
            enddo
            call fv_array_sync()
5000     end do !continue

         if( it /= nsplt ) then           ! not the last

#ifdef SPMD
!------------------
! Handle nq=1 case:
!------------------
             if( nq==1 )       &
                  call mp_send4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng, ng, q)
#endif

!$omp parallel do private(i, j, k)
             do k=ksp,kep !1,km
                do j=jfirst,jlast
                   do i=1,im
                      dp1(i,j,k) = dp2(i,j,k)
                   enddo
                enddo
             enddo
             call fv_array_sync()
         endif
6000  end do !continue

#ifndef USE_LIMA
      if (tra_step == 1) then
             tra_step = 2
      elseif(tra_step == 2) then
             tra_step = 1
      endif
#endif

#ifndef USE_LIMA
end subroutine tracer_2d
#else               
end subroutine tracer_2d_lima
#endif

!------------------------------------------------------------------------------
!BOP
!
! !MODULE: mod_comm --- SPMD parallel decompostion/communication module
module mod_comm
!
! !USES:
#if defined ( SPMD )

#if defined( TIMING )
      use timingModule, only : timing_on, timing_off
#endif
      use shr_kind_mod, only : r8 => shr_kind_r8, r4 => shr_kind_r4,  &
                               i8 => shr_kind_i8, i4 => shr_kind_i4
      implicit none

#if defined ( USE_SHMEM )

#if defined(USE_VT)
#include "mpif.h"
#endif

#if defined(IRIX64)
#include "mpp/shmem.fh"
#else
#include "shmem.fh"
#endif
#else
#include "mpif.h"
#if defined(LINUX) && (USE_MPI_IO)
#include "mpiof.h"
#endif
#endif

! !PUBLIC MEMBER FUNCTIONS:

      public mp_init, mp_exit, y_decomp, set_decomp,               &
             mp_send4d_ns, mp_recv4d_ns, mp_send2_ns, mp_recv2_ns, &
             mp_send3d, mp_recv3d, mp_send3d_2, mp_recv3d_2,       &
             mp_reduce_sum, mp_reduce_max, mp_minmax, mp_sum1d, mp_add1d, &
             mp_bcst_real, mp_bcst_int, mp_bcst_r2d, mp_gath_r2d, mp_gath_3d, &
             mp_scat3d_int, mp_scat3d, mp_gath4_r2d, &
#if defined(USE_MPI_IO)
             mp_scatter3d, mp_gather3d, mp_wrt3d,                     &
             mp_file_open, mp_file_write_at, mp_file_close
#else
             mp_scatter3d, mp_gather3d, mp_wrt3d
#endif

! !PUBLIC DATA MEMBERS:
      integer, SAVE:: gid                         ! PE id
      integer(i4), SAVE, private :: numpro        ! Permanent No. of PEs
      integer(i4), SAVE, private :: numcpu        ! No. of threads

!------------------------------------------------------------------------------
!  Local parameters for use with MPI-2 and MPI-1
!------------------------------------------------------------------------------
      integer, parameter:: nbuf = 2               ! Max No. of sends per call
      integer, parameter:: nghost = 3             ! Max No. of ghost indices
      integer, parameter:: max_call = 2           ! Max No. of back-to-back...
                                                  ! ...mp_send calls

#if defined(MPI2) || defined(USE_SHMEM)
! Statically define the model dimension
#     define PLON        144
#     define PLAT         91
#     define PLEV         48
      integer, parameter:: idimsize = PLON*nghost*(PLEV+1)
#else
! Dynamic memory allocation with MPI1
      integer, save:: PLON
      integer, save:: PLAT
      integer, save:: PLEV
      integer, save:: idimsize
#endif

#if defined(USE_SHMEM)
      integer, parameter :: mp_r4 = r4
      integer, parameter :: mp_r8 = r8
      integer, parameter :: mp_i4 = i4
      integer, SAVE::  reduce_sync(SHMEM_REDUCE_SYNC_SIZE)
      integer, SAVE:: collect_sync(SHMEM_COLLECT_SYNC_SIZE)
      integer, SAVE::   bcast_sync(SHMEM_BCAST_SYNC_SIZE)
#else
      integer, parameter :: mp_r4 = MPI_REAL
      integer, parameter :: mp_r8 = MPI_DOUBLE_PRECISION
      integer, parameter :: mp_i4 = MPI_INTEGER
#endif

!------------------------------------------------------------------------------
!  Local variables for use with MPI-2, MPI-1, and SHMEM
!------------------------------------------------------------------------------
      integer, SAVE:: gsize                       ! No. of PEs
      integer, SAVE:: nowpro                      ! Temp. PE id
      integer, SAVE:: np_loop                     ! No. of sends for bcasts 
                                                  ! np_loop = numpro for MPI
      integer, allocatable, SAVE:: yfirst(:)      ! First latitude
      integer, allocatable, SAVE:: ylast(:)       ! Last latitude
      integer, allocatable, SAVE:: zfirst(:)      ! First level
      integer, allocatable, SAVE:: zlast(:)       ! Last level
      integer, SAVE:: ncall_r, ncall_s

!------------------------------------------------------------------------------
!  Variables to control global array locations and window synchronization
!------------------------------------------------------------------------------
      integer win_count                           ! Counts No. of windows in use
      integer lastwin                             ! ID of last synch'd window
      integer pkgs_per_pro                        ! No. of MPI packages per PE
      integer igosouth, igonorth                  ! Index of send direction
      integer ifromsouth, ifromnorth              ! Index of recv direction

!------------------------------------------------------------------------------
!  Local type declaration for mp_windows
!------------------------------------------------------------------------------
      type window
         integer :: id             ! Window id
         integer :: wsize          ! Size of global window (point based)
         integer :: ncall_s        ! Count send calls on window
         integer :: ncall_r        ! Count recv calls on window

#if defined(MPI2)
#if defined(LINUX)
#define MPI_OFFSET_KIND 8
#define MPI_ADDRESS_KIND 8
#endif
         integer(kind=MPI_ADDRESS_KIND) :: offset_s
         integer(kind=MPI_ADDRESS_KIND) :: offset_r
#else
         integer :: offset_s      ! Starting position in GA send
         integer :: offset_r      ! Starting position in GA recv
#endif
         integer :: dest          ! For use with send calls
         integer :: src           ! For use with recv calls
         integer :: size_r        ! Size of incoming message
     end type window

!------------------------------------------------------------------------------
! Beginning Global Array variable declaration:
!------------------------------------------------------------------------------

      type (window) :: r8_win
      type (window) :: r4_win
      type (window) :: i4_win

      integer ierror, irr

!-----------------------------
!  SHMEM variable declarations
!-----------------------------

#if defined(USE_SHMEM)
      integer ga_ptr
      integer, SAVE:: commglobal   ! Global Communicator

#define ga_t1_r ga_r8_r
#define ga_t1_s ga_r8_s
#define t1_win  r8_win

      real(r8), SAVE, TARGET:: ga_r8a_r(MAX( PLON*PLAT*(PLEV+1), idimsize*nbuf*max_call ))
      real(r8), SAVE, TARGET:: ga_r8a_s(MAX( PLON*PLAT*(PLEV+1), idimsize*nbuf*max_call ))

      real(r8), SAVE, TARGET:: ga_r8b_r(MAX( PLON*PLAT*(PLEV+1), idimsize*nbuf*max_call ))
      real(r8), SAVE, TARGET:: ga_r8b_s(MAX( PLON*PLAT*(PLEV+1), idimsize*nbuf*max_call ))

      real(r8), DIMENSION(:), SAVE, POINTER:: ga_r8_r
      real(r8), DIMENSION(:), SAVE, POINTER:: ga_r8_s

      real(r4), SAVE, TARGET:: ga_r4a_r(PLON*PLAT*PLEV)
      real(r4), SAVE, TARGET:: ga_r4a_s(PLON*PLAT*PLEV)

      real(r4), SAVE, TARGET:: ga_r4b_r(PLON*PLAT*PLEV)
      real(r4), SAVE, TARGET:: ga_r4b_s(PLON*PLAT*PLEV)

      real(r4), DIMENSION(:), SAVE, POINTER:: ga_r4_r
      real(r4), DIMENSION(:), SAVE, POINTER:: ga_r4_s

      integer(i4), SAVE, TARGET:: ga_i4a_r(PLON*PLAT*PLEV)
      integer(i4), SAVE, TARGET:: ga_i4a_s(PLON*PLAT*PLEV)

      integer(i4), SAVE:: ga_i4c_r(PLON*PLAT*PLEV)
      integer(i4), SAVE:: ga_i4c_s(PLON*PLAT*PLEV)

      integer(i4), SAVE, TARGET:: ga_i4b_r(PLON*PLAT*PLEV)
      integer(i4), SAVE, TARGET:: ga_i4b_s(PLON*PLAT*PLEV)

      integer(i4), DIMENSION(:), SAVE, POINTER:: ga_i4_r
      integer(i4), DIMENSION(:), SAVE, POINTER:: ga_i4_s

#else
# ifdef MPI2
!-----------------------------
!  MPI-2 variable declarations
!-----------------------------
      real(r8),    SAVE:: ga_t1_r(idimsize*nbuf*max_call)
      real(r8),    SAVE:: ga_t1_s(idimsize*nbuf*max_call)
      real(r8),    SAVE:: ga_r8_r(PLON*PLAT*PLEV)
      real(r8),    SAVE:: ga_r8_s(PLON*PLAT*PLEV)

      real(r4),    SAVE:: ga_r4_r(PLON*PLAT*PLEV)
      real(r4),    SAVE:: ga_r4_s(PLON*PLAT*PLEV)

      integer(i4), SAVE:: ga_i4_r(PLON*PLAT*PLEV)
      integer(i4), SAVE:: ga_i4_s(PLON*PLAT*PLEV)
      type (window) :: t1_win

#if defined(LINUX) || defined(OSF1)
#if defined(LINUX)
#define MPI_ADDRESS_KIND 8
#endif
      integer, parameter:: MPI_MODE_NOCHECK    = 0 
      integer, parameter:: MPI_MODE_NOSTORE    = 0    
      integer, parameter:: MPI_MODE_NOPUT      = 0 
      integer, parameter:: MPI_MODE_NOPRECEDE  = 0 
      integer, parameter:: MPI_MODE_NOSUCCEED  = 0 
#endif
      integer(kind=MPI_ADDRESS_KIND) bsize
      integer, SAVE:: commglobal   ! Global Communicator
      integer, SAVE:: Status(MPI_STATUS_SIZE)
#else
      real(r8), allocatable, SAVE:: ga_t1_r(:)
      real(r8), allocatable, SAVE:: ga_t1_s(:)
      real(r8), allocatable, SAVE:: ga_r8_r(:)
      real(r8), allocatable, SAVE:: ga_r8_s(:)

      real(r4), allocatable, SAVE:: ga_r4_r(:)
      real(r4), allocatable, SAVE:: ga_r4_s(:)

      integer(i4), allocatable, SAVE:: ga_i4_r(:)
      integer(i4), allocatable, SAVE:: ga_i4_s(:)
!-----------------------------
!  MPI-1 variable declarations
!-----------------------------
      type (window) :: t1_win
      integer, SAVE:: nsend                   ! Number of messages out-going
      integer, SAVE:: nrecv                   ! Number of messages in-coming
      integer, SAVE:: nread                   ! Number of messages read
      integer, allocatable, SAVE:: sqest(:)   ! Request handler for sends
      integer, allocatable, SAVE:: rqest(:)   ! Request handler for recvs
      integer, SAVE:: bsize             
      integer, SAVE:: commglobal              ! Global Communicator
      integer, SAVE:: Status(MPI_STATUS_SIZE)
      integer, allocatable, SAVE:: Stats(:)
#endif
#endif
!Balaji
      logical :: no_mod_comm=.TRUE. !TRUE on PEs that should NOT call mod_comm
                                    !set FALSE in mp_init by all PEs
                                    !that call mp_init

! !DESCRIPTION:
!
!    This module contains all SPMD parallelism decomposition and communication
!         routines.  MPI2 and MPI1 have been implemented. 
!
!    1) All implementations use real*8, real*4, and integer*4 windows
!       which are used with global arrays as follows:
!             r8_win -> ga_r8 - for use with real*8 types
!             r4_win -> ga_r4 - for use with real*4 types
!             i4_win -> ga_i4 - for use with integer*4 types
!
!       note: MPI routines need 2 buffers per GA, ga_<type>_s & ga_<type>_r
!             ga_<type>_r is used for the MPI2 windows
!
!    2) All global arrays are 1-dimensional, they are accessed
!       as needed inside the Ga_Put/Ga_Get routines with offset vars.
!       (Ga_Put/Ga_Get routines are all 4d with openmp on the 3rd (k) dim.)
!
! !REVISION HISTORY:
!    2001.09.01   Lin
!    2002.04.16   Putman  Modified for Global Array code
!    2002.04.16   Putman  Added ProTeX documentation
!    2002.05.28   Putman  Added use of precision module
!    2003.10.30   Lin     MLP removeid; dynamic memory allocation with MPI1
!
!EOP
!------------------------------------------------------------------------------
      contains
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_init --- Initialize SPMD parallel communication
!
! !INTERFACE:
      subroutine mp_init( im, jm, km, comm )
!
! !INPUT PARAMETERS:
      integer, intent(in) :: im
      integer, intent(in) :: jm
      integer, intent(in) :: km
      integer, optional :: comm
! !DESCRIPTION:
!
!     Initialize SPMD parallel communication
!
! !REVISION HISTORY: 
!    2001.09.01   Lin
!    2002.02.15   Putman	Modified for Global Array code
!    2002.04.09   Putman	Added ProTeX documentation
!    2002.08.06   Sawyer        Added optional communicator input argument                                               
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
        integer mysize

#if defined(USE_SHMEM)
        integer num_pes, my_pe
#endif


!Balaji: no_mod_comm is declared TRUE by default
!        but all PEs calling mp_init will set it to FALSE
! (i.e mp_init should be called only by those PEs that run mod_comm)
        no_mod_comm = .FALSE.
#if defined(MPI2) || defined(USE_SHMEM)
      if ( im*jm*km > PLON*PLAT*PLEV .or. im*(km+1) > PLON*(PLEV+1) ) then
         write(*,*) 'Warning in mp_init; buffer size decleared within mod_comm'
         write(*,*) 'is too small: blow up is to be expected'
      endif
#endif
        win_count = 0
 
#if defined(USE_SHMEM)
#if defined(IRIX64)
        CALL START_PES(0)
#else
        call SHMEM_INIT()
#endif

#if defined(USE_VT)
        call MPI_INIT(ierror)
#endif
        numpro = num_pes()
        gid = my_pe()
	ga_ptr = 1
	ga_r8_r => ga_r8a_r
	ga_r8_s => ga_r8a_s
	ga_r4_r => ga_r4a_r
	ga_r4_s => ga_r4a_s
	ga_i4_r => ga_i4a_r
	ga_i4_s => ga_i4a_s
	reduce_sync = SHMEM_SYNC_VALUE
	collect_sync = SHMEM_SYNC_VALUE
	bcast_sync = SHMEM_SYNC_VALUE
        call omp_start
        if( gid == 0 ) write(*,*) 'SHMEM is used within mod_comm'
#else
! MPI1 or MPI2

        if ( present(comm) ) then
          call mpi_start( comm )
        else
          call mpi_start( MPI_COMM_WORLD )
        endif

        call omp_start
#ifdef MPI2
        if( gid == 0 ) write(*,*) 'MPI2 is used within mod_comm'
#else
        if( gid == 0 ) write(*,*) 'MPI-1 is used within mod_comm'

        allocate( sqest(MAX(nbuf,numpro)*max_call) )
        allocate( rqest(MAX(nbuf,numpro)*max_call) )
        allocate( Stats(MAX(nbuf,numpro)*max_call*MPI_STATUS_SIZE) )

        plon  = im;  plat = jm;  plev = km
        idimsize = plon*nghost*(plev+1) 

        allocate ( ga_t1_r(idimsize*nbuf*max_call) )
        allocate ( ga_t1_s(idimsize*nbuf*max_call) )
        allocate ( ga_r8_r(PLON*PLAT*PLEV) )
        allocate ( ga_r8_s(PLON*PLAT*PLEV) )
        allocate ( ga_r4_r(PLON*PLAT*PLEV) )
        allocate ( ga_r4_s(PLON*PLAT*PLEV) )
        allocate ( ga_i4_r(PLON*PLAT*PLEV) )
        allocate ( ga_i4_s(PLON*PLAT*PLEV) )
#endif
        mysize = idimsize*nbuf*max_call
        call win_init_r8(t1_win, ga_t1_r, mysize)
#endif
        mysize = PLON*PLAT*PLEV
        call win_init_r8(r8_win, ga_r8_r, mysize)
        call win_init_r4(r4_win, ga_r4_r, mysize)
        call win_init_i4(i4_win, ga_i4_r, mysize)

        igosouth   = 0
        igonorth   = 1
        ifromsouth = 1
        ifromnorth = 0

        ncall_s = 0
        ncall_r = 0
        lastwin = r8_win%id

        np_loop = numpro

        allocate( yfirst( numpro ) )
        allocate( ylast ( numpro ) )
        allocate( zfirst( numpro ) )
        allocate( zlast ( numpro ) )
!EOC
      end subroutine mp_init

!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_exit --- End SPMD parallel communication
!
! !INTERFACE:
      subroutine mp_exit ( solo )

      logical, intent(in) :: solo          ! If mod_comm is the sole communication
                                           ! module or called within another framework
! !DESCRIPTION:
!
!     End SPMD parallel communication
!
! !REVISION HISTORY: 
!    2001.09.01   Lin
!    2002.02.15   Putman	Modified for Global Array code
!    2002.04.09   Putman	Added ProTeX documentation
!    2003.11.18   Lin           Added input solo enabling mod_comm to be a sub-module
!
!EOP
!------------------------------------------------------------------------------
!BOC
      if( no_mod_comm )return

        deallocate( yfirst )
        deallocate( ylast )
        deallocate( zfirst )
        deallocate( zlast )

#if !defined(USE_SHMEM)

#ifdef MPI2
        call MPI_WIN_FREE( t1_win%id, ierror )
        call MPI_WIN_FREE( r8_win%id, ierror )
        call MPI_WIN_FREE( r4_win%id, ierror )
        call MPI_WIN_FREE( i4_win%id, ierror )
#else
        deallocate( sqest )
        deallocate( rqest )
        deallocate( Stats )

        deallocate( ga_t1_r )
        deallocate( ga_t1_s )
        deallocate( ga_r8_r )
        deallocate( ga_r8_s )
        deallocate( ga_r4_r )
        deallocate( ga_r4_s )
        deallocate( ga_i4_r )
        deallocate( ga_i4_s )
#endif
        if(solo) call MPI_FINALIZE (ierror)

#elif defined(USE_SHMEM)
        call mp_barrier()
#if defined(USE_VT)
    	if(solo) call MPI_FINALIZE (ierror)
#endif
#endif
!EOC
      end subroutine mp_exit
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: omp_start --- Start openMP parallelism
!
! !INTERFACE:
      subroutine omp_start
! !DESCRIPTION:
!
!     Start openMP parallelism
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
        integer ios, n, nowpro, nowcpu
        integer omp_get_num_threads
        character*80 evalue
        integer mp_suggested_numthreads

      if( no_mod_comm )return
#if defined(SET_CPUS)

!wfc moved up        character*80 evalue
        call getenv('AGCM_N_THREADS_PER_PROCESS',evalue)
        if (gid == 0) then
          read(evalue,*,iostat=ios) numcpu
          if ( ios .ne. 0 ) then
              print *, 'ERROR: cannot read AGCM_N_THREADS_PER_PROCESS', &
                       trim(evalue)
               call exit(1)
          end if
        endif
        call mp_bcst_int(numcpu)

#if defined(_OPENMP)

#if defined (IRIX64)
       call mp_set_numthreads(numcpu)  !keep it for a while, :)
#else
       call omp_set_num_threads(numcpu)
#endif

#else
       print *, 'ERROR: must turn on OPENMP to set numcpu in mod_comm'
       call exit(1)
#endif

#else 

#if defined(_OPENMP)

#if defined (IRIX64)
!wfc moved up        integer mp_suggested_numthreads
        numcpu = mp_suggested_numthreads(0)
#else
!$omp parallel
        numcpu = omp_get_num_threads()
!$omp end parallel
#endif

#else
        numcpu = 1
#endif

#endif

#if defined(MPI2) || defined(USE_SHMEM)
#if defined(MT_OFF)
        pkgs_per_pro = 1
#else
        pkgs_per_pro = numcpu
#endif
#endif

#if defined(PIN_CPUS)
       if (gid == 0 ) write(6,*) 'SGI specific CPU pinning activated!'
!$omp parallel do private(n,nowcpu)
        nowpro = gid
        do n=1,numcpu
          nowcpu = n + (nowpro) * numcpu-1
          call mp_assign_to_cpu(nowcpu)
        enddo
#endif
!EOC
      end subroutine omp_start
!------------------------------------------------------------------------------

#if !defined(USE_SHMEM)
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mpi_start --- Start MPI parallelism
!
! !INTERFACE:
      subroutine mpi_start( comm )
! !INPUT PARAMETERS:
      integer :: comm   ! Global communicator (may be MPI_COMM_WORLD)
! !DESCRIPTION:
!
!     Start MPI parallelism
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!    02.08.06   Sawyer  Added communicator input arguments
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
        logical flag
        integer npthreads

      if( no_mod_comm )return
#if defined(MPI2) && !defined(AIX) && (!defined LINUX) && (!defined OSF1)
        call MPI_INITIALIZED( flag, ierror )
        if ( .not. flag ) then
          call MPI_INIT_THREAD(MPI_THREAD_MULTIPLE, npthreads, ierror)
        endif
        call MPI_QUERY_THREAD(npthreads, ierror)
#if !defined(MT_OFF)
        if (npthreads /= MPI_THREAD_MULTIPLE) then
!-- begin SJL ----
!         write(*,*) gid, 'did not provide MPI_THREAD_MULTIPLE. ', &
!               'Change to MPI_THREAD_MULTIPLE with MPI_INIT_THREAD ', &
!               'for multi-threading MPI2'
!
!         call MPI_FINALIZE(ierror)
!         call exit(1)
! -- End SJL mode ----
!         write(*,*) 'Calling MPI_INIT_THREAD ...'
          call MPI_INIT_THREAD(MPI_THREAD_MULTIPLE, npthreads, ierror)
          call MPI_QUERY_THREAD(npthreads, ierror)
!         write(*,*) 'npthreads=',npthreads, 'MPI_THREAD_MULTIPLE=',MPI_THREAD_MULTIPLE
        endif
#endif
#else
        call MPI_INITIALIZED( flag, ierror )
        if ( .not. flag ) then
          call MPI_INIT( ierror )
        endif
#endif
        call MPI_COMM_RANK (comm, gid, ierror)
        call MPI_COMM_SIZE (comm, numpro, ierror)
        call MPI_COMM_DUP  (comm, commglobal, ierror)
!EOC
      end subroutine mpi_start
!------------------------------------------------------------------------------
#endif

!------------------------------------------------------------------------------
!BOP
! !ROUTINE: win_init_r8 --- Initialize real*8 communication window
!
! !INTERFACE:
      subroutine win_init_r8(win, ga, isize)
! !INPUT PARAMETERS:
        integer, intent(in) :: isize
        real(r8), intent(in) :: ga(isize)
! !OUTPUT PARAMETERS:
        type (window), intent(inout) :: win
! !DESCRIPTION:
!
!     Initialize real*8 communication window
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
        integer mp_size, info

      if( no_mod_comm )return
        win_count = win_count + 1

#if defined(MPI2)
        call MPI_INFO_CREATE(info, ierror)
        call MPI_INFO_SET(info, "no_locks", "true", ierror)
#if defined(AIX)
        info = MPI_INFO_NULL
#endif
        call MPI_TYPE_SIZE(mp_r8, mp_size, ierror)
        bsize = isize*mp_size
        call MPI_WIN_CREATE(ga, bsize, mp_size, info, commglobal, &
                            win%id, ierror)
#if !defined(AIX)
        call MPI_INFO_FREE(info, ierror)
#endif
        call MPI_WIN_FENCE(MPI_MODE_NOPRECEDE, win%id, ierror)
#else
        win%id = win_count
#endif
        win%wsize = isize
        win%ncall_s = 0
        win%ncall_r = 0
!EOC
      end subroutine win_init_r8
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: win_init_r4 --- Initialize real*4 communication window
!
! !INTERFACE:
      subroutine win_init_r4(win, ga, isize)
! !INPUT PARAMETERS:
        integer, intent(in) :: isize
        real(r4), intent(in) :: ga(isize)
! !OUTPUT PARAMETERS:
        type (window), intent(inout) :: win
! !DESCRIPTION:
!
!     Initialize real*4 communication window
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
        integer mp_size, info

      if( no_mod_comm )return
        win_count = win_count + 1

#if defined(MPI2)
        call MPI_INFO_CREATE(info, ierror)
        call MPI_INFO_SET(info, "no_locks", "true", ierror)
#if defined(AIX)
        info = MPI_INFO_NULL
#endif
        call MPI_TYPE_SIZE(mp_r4, mp_size, ierror)
        bsize = isize*mp_size
        call MPI_WIN_CREATE(ga, bsize, mp_size, info, commglobal, &
                            win%id, ierror)
#if !defined(AIX)
        call MPI_INFO_FREE(info, ierror)
#endif
        call MPI_WIN_FENCE(MPI_MODE_NOPRECEDE, win%id, ierror)
#else
        win%id = win_count
#endif
        win%wsize = isize
        win%ncall_s = 0
        win%ncall_r = 0
!EOC
      end subroutine win_init_r4
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: win_init_i4 --- Initialize integer*4 communication window
!
! !INTERFACE:
      subroutine win_init_i4(win, ga, isize)
! !INPUT PARAMETERS:
        integer, intent(in) :: isize
        integer(i4), intent(in) :: ga(isize)
! !OUTPUT PARAMETERS:
        type (window), intent(inout) :: win
! !DESCRIPTION:
!
!     Initialize integer*4 communication window
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
        integer mp_size, info

      if( no_mod_comm )return
        win_count = win_count + 1

#if defined(MPI2)
        call MPI_INFO_CREATE(info, ierror)
        call MPI_INFO_SET(info, "no_locks", "true", ierror)
#if defined(AIX)
        info = MPI_INFO_NULL
#endif
        call MPI_TYPE_SIZE(mp_i4, mp_size, ierror)
        bsize = isize*mp_size
        call MPI_WIN_CREATE(ga, bsize, mp_size, info, commglobal, &
                            win%id, ierror)
#if !defined(AIX)
        call MPI_INFO_FREE(info, ierror)
#endif
        call MPI_WIN_FENCE(MPI_MODE_NOPRECEDE, win%id, ierror)
#else
        win%id = win_count
#endif
        win%wsize = isize
        win%ncall_s = 0
        win%ncall_r = 0
!EOC
      end subroutine win_init_i4
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
!BOP
! !ROUTINE: y_decomp --- Decompose the Latitude & Level direction
!
! !INTERFACE:
      subroutine y_decomp(jm, km, jfirst, jlast, kfirst, klast, myid)
! !INPUT PARAMETERS:
      integer, intent(in):: jm     ! Dimensions
      integer, intent(in):: km     ! Levels
      integer, intent(in):: myid
! !OUTPUT PARAMETERS:
      integer, intent(out):: jfirst, jlast, kfirst, klast
! !DESCRIPTION:
!
!     Decompose the Latitude & Level direction for SPMD parallelism
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer p, p1, p2, lats, pleft
      integer, allocatable:: ydist(:)

      if( no_mod_comm )return
      if (myid == 0) then
          print *, "Two-level Parallelism: Domains x Threads=", numpro, numcpu
      endif

      allocate( ydist( numpro ) )

      lats = jm / numpro
      pleft = jm - lats * numpro


      do p=1,numpro
         ydist(p) = lats
      enddo

      if ( pleft .ne. 0 ) then
          p1 = (numpro+1) / 2 
          p2 = p1 + 1
        do while ( pleft .ne. 0 )
           if( p1 .eq. 1 ) p1 = numpro
               ydist(p1) = ydist(p1) + 1
               pleft = pleft - 1
               if ( pleft .ne. 0 ) then
                    ydist(p2) = ydist(p2) + 1
                    pleft = pleft - 1
               endif
               p2 = p2 + 1
               p1 = p1 - 1
        enddo
      endif

! Safety check:

      do p=1,numpro-1
      if( ydist(p) < 3 ) then
          write(*,*) 'Number of Proc is too large for jm=',jm
          call exit(1)
      endif
      enddo

      lats = 0
      do p = 1, numpro
         lats = lats + ydist(p)
      enddo

      if ( lats /= jm ) then
         print *, "Decomp: big trouble sum(ydist) = ", lats, "!=", jm
      endif
 
      jfirst = 1
      jlast  = ydist(1)
      yfirst(1) = jfirst
      ylast(1) = jlast
      kfirst = 1
      klast = km
      zfirst(1) = kfirst
      zlast(1) = klast

      do p = 1,numpro-1
         yfirst(p+1) = ylast(p) + 1
         ylast(p+1) = ylast(p) + ydist(p+1) 
         if( p == myid ) then
            jfirst = yfirst(p+1)
            jlast  = ylast (p+1)
         endif
         zfirst(p+1) = kfirst
         zlast(p+1) = klast
      enddo

      deallocate (ydist)
!EOC
      end subroutine y_decomp
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: set_decomp --- Set the Latitude & Level decomposition
!
! !INTERFACE:
      subroutine set_decomp(nprocs, jm, km, ydist, zdist)
! !INPUT PARAMETERS:
      integer, intent(in):: nprocs
      integer, intent(in):: jm, km
      integer, intent(in):: ydist(nprocs)
      integer, intent(in):: zdist(nprocs)   ! Currently not used
!
! !DESCRIPTION:
!
!     Set the Latitude & Level decomposition:
!             if it is defined external to mod_comm
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer lats, p

      if( no_mod_comm )return
! Safety check:
      lats = 0
      do p = 1, nprocs
         lats = lats + ydist(p)
      enddo

      if ( lats .ne. jm ) then
         print *, "Decomp: big trouble sum(ydist) = ", lats, "!=", jm
      endif

      yfirst(1) = 1
      ylast(1) = ydist(1)
      zfirst(1) = 1
      zlast(1) = km

      do p = 1,nprocs-1
         yfirst(p+1) = ylast(p) + 1
         ylast(p+1) = ylast(p) + ydist(p+1)
         zfirst(p+1) = 1
         zlast(p+1) = km
      enddo
!EOC
      end subroutine set_decomp
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_send4d_ns --- Send 4d north/south ghost latitudes
!
! !INTERFACE:
      subroutine mp_send4d_ns(im, jm, km, nq, jfirst, jlast, kfirst, klast, &
                              ng_s, ng_n, q)
!
! !INPUT PARAMETERS:
      integer, intent(in):: im, jm, km, nq
      integer, intent(in):: jfirst, jlast
      integer, intent(in):: kfirst, klast
      integer, intent(in):: ng_s      ! southern zones to ghost 
      integer, intent(in):: ng_n      ! northern zones to ghost 
      real(r8), intent(in):: q(im,jfirst-ng_s:jlast+ng_n,kfirst:klast,nq)
!
! !DESCRIPTION:
!
!     Send 4d north/south ghost latitudes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Open(t1_win)

!--------------
! Send to south
!--------------

      if ( jfirst > 1 ) then
#if !defined(USE_SHMEM) && !defined(MPI2)
        t1_win%src      = gid - 1
        t1_win%offset_r = ifromsouth*idimsize + (t1_win%ncall_s-1)*idimsize*nbuf
        t1_win%size_r   = im*ng_s*(klast-kfirst+1)*nq
        call Ga_RecvInit_r8(t1_win, ga_t1_r)
#endif
        t1_win%dest     = gid - 1
        t1_win%offset_s = igosouth*idimsize + (t1_win%ncall_s-1)*idimsize*nbuf
        call Ga_Put4d_r8(q, t1_win, im, jm, km, nq, &
                         1, im, jfirst-ng_s, jlast+ng_n, kfirst, klast, 1, nq, &
                         1, im, jfirst, jfirst+ng_n-1, kfirst, klast, 1, nq,   &
                         ga_t1_s, ga_t1_r )
      endif

!--------------
! Send to north
!--------------
      if ( jlast < jm ) then
#if !defined(USE_SHMEM) && !defined(MPI2)
        t1_win%src      = gid + 1
        t1_win%offset_r = ifromnorth*idimsize + (t1_win%ncall_s-1)*idimsize*nbuf
        t1_win%size_r   = im*ng_n*(klast-kfirst+1)*nq
        call Ga_RecvInit_r8(t1_win, ga_t1_r)
#endif
        t1_win%dest     = gid + 1
        t1_win%offset_s = igonorth*idimsize + (t1_win%ncall_s-1)*idimsize*nbuf
        call Ga_Put4d_r8(q, t1_win, im, jm, km, nq, &
                         1, im, jfirst-ng_s, jlast+ng_n, kfirst, klast, 1, nq, &
                         1, im, jlast-ng_s+1, jlast, kfirst, klast, 1, nq,     &
                         ga_t1_s, ga_t1_r )
      endif

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_send4d_ns
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_recv4d_ns --- Receive 4d north/south ghost latitudes
!
! !INTERFACE:
      subroutine mp_recv4d_ns(im, jm, km, nq, jfirst, jlast, kfirst, klast, &
                              ng_s, ng_n, q)
!
! !INPUT PARAMETERS:
      integer, intent(in):: im, jm, km, nq
      integer, intent(in):: jfirst, jlast
      integer, intent(in):: kfirst, klast
      integer, intent(in):: ng_s      ! southern zones to ghost 
      integer, intent(in):: ng_n      ! northern zones to ghost 
! !OUTPUT PARAMETERS:
      real(r8), intent(inout):: q(im,jfirst-ng_s:jlast+ng_n,kfirst:klast,nq)
!
! !DESCRIPTION:
!
!     Receive 4d north/south ghost latitudes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Close(t1_win)


! Recv from south
      if ( jfirst > 1 ) then
        t1_win%src  = gid-1
        t1_win%offset_r = ifromsouth*idimsize + (t1_win%ncall_r-1)*idimsize*nbuf
        call Ga_Get4d_r8(q, t1_win, im, jm, km, nq, &
                         1, im, jfirst-ng_s, jlast+ng_n, kfirst, klast, 1, nq, &
                         1, im, jfirst-ng_s, jfirst-1,   kfirst, klast, 1, nq, &
                         ga_t1_r  )
      endif
! Recv from north
      if ( jlast < jm ) then
        t1_win%src  = gid+1
        t1_win%offset_r = ifromnorth*idimsize + (t1_win%ncall_r-1)*idimsize*nbuf
        call Ga_Get4d_r8(q, t1_win, im, jm, km, nq, &
                         1, im, jfirst-ng_s, jlast+ng_n, kfirst, klast, 1, nq, &
                         1, im, jlast+1,     jlast+ng_n, kfirst, klast, 1, nq, &
                         ga_t1_r  )
      endif

      call Win_Finalize(t1_win)

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_recv4d_ns
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_send2_ns --- Send 2 variables north/south ghost latitudes
!
! !INTERFACE:
      subroutine mp_send2_ns(im, jm, km, jfirst, jlast, kfirst, klast, &
                             nd, q1, q2)
!
! !INPUT PARAMETERS:
      integer, intent(in):: im, jm, km
      integer, intent(in):: jfirst, jlast
      integer, intent(in):: kfirst, klast !careful: klast might be klast+1
      integer, intent(in):: nd
      real(r8), intent(in):: q1(im,jfirst-nd:jlast+nd,kfirst:klast) 
      real(r8), intent(in):: q2(im,jfirst-nd:jlast+nd,kfirst:klast) 
!
! !DESCRIPTION:
!
!     Send 2 variables north/south ghost latitudes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Open(t1_win)

! Send to south
      if ( jfirst > 1 ) then
#if !defined(USE_SHMEM) && !defined(MPI2)
        t1_win%src  = gid - 1
        t1_win%size_r = im*(klast-kfirst+1)
        t1_win%offset_r = ifromsouth*idimsize + (t1_win%ncall_s-1)*idimsize*nbuf
        call Ga_RecvInit_r8(t1_win, ga_t1_r)
        t1_win%offset_r = t1_win%offset_r + im*(klast-kfirst+1)
        call Ga_RecvInit_r8(t1_win, ga_t1_r)
#endif
        t1_win%dest = gid - 1
        t1_win%offset_s = igosouth*idimsize + (t1_win%ncall_s-1)*idimsize*nbuf
        call Ga_Put4d_r8( q1, t1_win, im, jm, km, 2, &
                          1, im, jfirst-nd, jlast+nd, kfirst, klast, 1, 1, &
                          1, im, jfirst,    jfirst,   kfirst, klast, 1, 1, &
                          ga_t1_s, ga_t1_r  )
        t1_win%offset_s = t1_win%offset_s + im*(klast-kfirst+1)
        call Ga_Put4d_r8( q2, t1_win, im, jm, km, 2, &
                          1, im, jfirst-nd, jlast+nd, kfirst, klast, 2, 2, &
                          1, im, jfirst,    jfirst,   kfirst, klast, 2, 2, &
                          ga_t1_s, ga_t1_r  )
      endif
! Send to north
      if ( jlast < jm ) then
#if !defined(USE_SHMEM) && !defined(MPI2)
        t1_win%src  = gid + 1
        t1_win%size_r = im*(klast-kfirst+1)
        t1_win%offset_r = ifromnorth*idimsize + (t1_win%ncall_s-1)*idimsize*nbuf
        call Ga_RecvInit_r8(t1_win, ga_t1_r)
        t1_win%offset_r = t1_win%offset_r + im*(klast-kfirst+1)
        call Ga_RecvInit_r8(t1_win, ga_t1_r)
#endif
        t1_win%dest = gid + 1
        t1_win%offset_s = igonorth*idimsize + (t1_win%ncall_s-1)*idimsize*nbuf
        call Ga_Put4d_r8( q1, t1_win, im, jm, km, 2, &
                          1, im, jfirst-nd, jlast+nd, kfirst, klast, 1, 1, &
                          1, im, jlast,     jlast,    kfirst, klast, 1, 1, &
                          ga_t1_s, ga_t1_r  )
        t1_win%offset_s = t1_win%offset_s + im*(klast-kfirst+1)
        call Ga_Put4d_r8( q2, t1_win, im, jm, km, 2, &
                          1, im, jfirst-nd, jlast+nd, kfirst, klast, 2, 2, &
                          1, im, jlast,     jlast,    kfirst, klast, 2, 2, &
                          ga_t1_s, ga_t1_r  )
      endif

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_send2_ns
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_recv2_ns --- Receive 2 variables north/south ghost latitudes
!
! !INTERFACE:
      subroutine mp_recv2_ns(im, jm, km, jfirst, jlast, kfirst, klast, &
                             nd, q1, q2)
!
! !INPUT PARAMETERS:
      integer, intent(in):: im, jm, km
      integer, intent(in):: jfirst, jlast
      integer, intent(in):: kfirst, klast !careful: klast might be klast+1
      integer, intent(in):: nd
! !OUTPUT PARAMETERS:
      real(r8), intent(inout):: q1(im,jfirst-nd:jlast+nd,kfirst:klast) 
      real(r8), intent(inout):: q2(im,jfirst-nd:jlast+nd,kfirst:klast)
!
! !DESCRIPTION:
!
!     Receive 2 variables north/south ghost latitudes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      integer j

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Close(t1_win)

! Recv from south
      if ( jfirst > 1 ) then
        j = jfirst - 1
        t1_win%src  = gid - 1
        t1_win%offset_r = ifromsouth*idimsize + (t1_win%ncall_r-1)*idimsize*nbuf
        call Ga_Get4d_r8( q1, t1_win, im, jm, km, 2, &
                          1, im, jfirst-nd, jlast+nd, kfirst, klast, 1, 1, &
                          1, im, j,         j,        kfirst, klast, 1, 1, &
                          ga_t1_r  )
        t1_win%offset_r = t1_win%offset_r + im*(klast-kfirst+1)
        call Ga_Get4d_r8( q2, t1_win, im, jm, km, 2, &
                          1, im, jfirst-nd, jlast+nd, kfirst, klast, 2, 2, &
                          1, im, j,         j,        kfirst, klast, 2, 2, &
                          ga_t1_r  )
      endif
! Recv from north
      if ( jlast < jm ) then
        j = jlast + 1
        t1_win%src  = gid + 1
        t1_win%offset_r = ifromnorth*idimsize + (t1_win%ncall_r-1)*idimsize*nbuf
        call Ga_Get4d_r8( q1, t1_win, im, jm, km, 2, & 
                          1, im, jfirst-nd, jlast+nd, kfirst, klast, 1, 1, &
                          1, im, j,         j,        kfirst, klast, 1, 1, &
                          ga_t1_r  )
        t1_win%offset_r = t1_win%offset_r + im*(klast-kfirst+1)
        call Ga_Get4d_r8( q2, t1_win, im, jm, km, 2, &
                          1, im, jfirst-nd, jlast+nd, kfirst, klast, 2, 2, &
                          1, im, j,         j,        kfirst, klast, 2, 2, &
                          ga_t1_r  )
      endif

      call Win_Finalize(t1_win)

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_recv2_ns
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_send3d --- Send ghost region
!
! !INTERFACE:
      subroutine mp_send3d(dest, src, im, jm, km, if, il, jf, jl, kf, kl, &
                                                  i1, i2, j1, j2, k1, k2, q)
!
! !INPUT PARAMETERS:
      integer, intent(in):: dest, src
      integer, intent(in):: im, jm, km
      integer, intent(in):: if, il, jf, jl, kf, kl 
      integer, intent(in):: i1, i2, j1, j2, k1, k2
      real(r8), intent(in):: q(if:il, jf:jl, kf:kl)
!
! !DESCRIPTION:
!
!     Send a general 3d real*8 ghost region
!
! !REVISION HISTORY:
!    02.04.15   Putman  
!
!EOP
!------------------------------------------------------------------------------
!BOC

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Open(t1_win)

#if !defined(USE_SHMEM) && !defined(MPI2)
! Init Recv src
      if ( src >= 0 .and. src < numpro ) then     ! is PE in valid range?
        t1_win%src = src
        t1_win%size_r = (i2-i1+1)*(j2-j1+1)*(k2-k1+1)  ! chunk size
        t1_win%offset_r = (t1_win%ncall_s-1)*idimsize*nbuf
        call Ga_RecvInit_r8(t1_win, ga_t1_r)
      endif
#endif
! Send ghost region
      if ( dest >= 0 .and. dest < numpro ) then
        t1_win%dest = dest
        t1_win%offset_s = (t1_win%ncall_s-1)*idimsize*nbuf
        call Ga_Put4d_r8( q, t1_win, im, jm, km, 1, &
                          if, il, jf, jl, kf, kl, 1, 1,  &
                          i1, i2, j1, j2, k1, k2, 1, 1, ga_t1_s, ga_t1_r  )
      endif

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_send3d
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_recv3d --- Recv ghost region
!
! !INTERFACE:
      subroutine mp_recv3d(src, im, jm, km, if, il, jf, jl, kf, kl, &
                                                i1, i2, j1, j2, k1, k2, qout)
!
! !INPUT PARAMETERS:
      integer, intent(in):: src
      integer, intent(in):: im, jm, km
      integer, intent(in):: if, il, jf, jl, kf, kl 
      integer, intent(in):: i1, i2, j1, j2, k1, k2
! !OUTPUT PARAMETERS:
      real(r8), intent(inout):: qout(if:il, jf:jl, kf:kl)
!
! !DESCRIPTION:
!
!     Recv a general 3d real*8 ghost region
!
! !REVISION HISTORY:
!    02.04.15   Putman  
!
!EOP
!------------------------------------------------------------------------------
!BOC

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Close(t1_win)

! Recv from src
      if ( src >= 0 .and. src < numpro ) then     ! is PE in valid range?
        t1_win%src  = src
        t1_win%offset_r = (t1_win%ncall_r-1)*idimsize*nbuf
        call Ga_Get4d_r8( qout, t1_win, im, jm, km, 1, &
                          if, il, jf, jl, kf, kl, 1, 1,   &
                          i1, i2, j1, j2, k1, k2, 1, 1, ga_t1_r  )
      endif

      call Win_Finalize(t1_win)

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_recv3d
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_send3d_2 --- Send 2 ghost regions
!
! !INTERFACE:
      subroutine mp_send3d_2(dest, src, im, jm, km, if, il, jf, jl, kf, kl, &
                                        i1, i2, j1, j2, k1, k2, q1, q2)
!
! !INPUT PARAMETERS:
      integer, intent(in):: dest, src
      integer, intent(in):: im, jm, km
      integer, intent(in):: if, il, jf, jl, kf, kl
      integer, intent(in):: i1, i2, j1, j2, k1, k2
      real(r8), intent(in):: q1(if:il, jf:jl, kf:kl)
      real(r8), intent(in):: q2(if:il, jf:jl, kf:kl)
!
! !DESCRIPTION:
!
!     Send two general 3d real*8 ghost region
!
! !REVISION HISTORY:
!    02.04.15   Putman
!
!EOP
!------------------------------------------------------------------------------
!BOC

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Open(t1_win)

#if !defined(USE_SHMEM) && !defined(MPI2)
! Init Recv src
      if ( src >= 0 .and. src < numpro ) then     ! is PE in valid range?
        t1_win%src = src
        t1_win%size_r = (i2-i1+1)*(j2-j1+1)*(k2-k1+1)  ! chunk size
        t1_win%offset_r = (t1_win%ncall_s-1)*idimsize*nbuf
        call Ga_RecvInit_r8(t1_win, ga_t1_r)
        t1_win%offset_r = t1_win%offset_r + t1_win%size_r 
        call Ga_RecvInit_r8(t1_win, ga_t1_r)
      endif
#endif
! Send ghost region
      if ( dest >= 0 .and. dest < numpro ) then
        t1_win%dest = dest
        t1_win%offset_s = (t1_win%ncall_s-1)*idimsize*nbuf
        call Ga_Put4d_r8( q1, t1_win, im, jm, km, 2, &
                          if, il, jf, jl, kf, kl, 1, 1,  &
                          i1, i2, j1, j2, k1, k2, 1, 1, ga_t1_s, ga_t1_r  )
        t1_win%offset_s = t1_win%offset_s + (i2-i1+1)*(j2-j1+1)*(k2-k1+1)
        call Ga_Put4d_r8( q2, t1_win, im, jm, km, 2, &
                          if, il, jf, jl, kf, kl, 2, 2,  &
                          i1, i2, j1, j2, k1, k2, 2, 2, ga_t1_s, ga_t1_r  )
      endif

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_send3d_2
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_recv3d_2 --- Recv 2 ghost regions
!
! !INTERFACE:
      subroutine mp_recv3d_2(src, im, jm, km, if, il, jf, jl, kf, kl, &
                                  i1, i2, j1, j2, k1, k2, qout1, qout2)
!
! !INPUT PARAMETERS:
      integer, intent(in):: src
      integer, intent(in):: im, jm, km
      integer, intent(in):: if, il, jf, jl, kf, kl
      integer, intent(in):: i1, i2, j1, j2, k1, k2
! !OUTPUT PARAMETERS:
      real(r8), intent(inout):: qout1(if:il, jf:jl, kf:kl)
      real(r8), intent(inout):: qout2(if:il, jf:jl, kf:kl)
!
! !DESCRIPTION:
!
!     Recv two general 3d real*8 ghost regions
!
! !REVISION HISTORY:
!    02.04.15   Putman
!
!EOP
!------------------------------------------------------------------------------
!BOC

      if( no_mod_comm )return

#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Close(t1_win)

! Recv from src
      if ( src >= 0 .and. src < numpro ) then     ! is PE in valid range?
        t1_win%src  = src
        t1_win%offset_r = (t1_win%ncall_r-1)*idimsize*nbuf
        call Ga_Get4d_r8( qout1, t1_win, im, jm, km, 2, &
                          if, il, jf, jl, kf, kl, 1, 1,   &
                          i1, i2, j1, j2, k1, k2, 1, 1, ga_t1_r  )
        t1_win%offset_r = t1_win%offset_r + (i2-i1+1)*(j2-j1+1)*(k2-k1+1)
        call Ga_Get4d_r8( qout2, t1_win, im, jm, km, 2, &
                          if, il, jf, jl, kf, kl, 2, 2,   &
                          i1, i2, j1, j2, k1, k2, 2, 2, ga_t1_r  )
      endif

      call Win_Finalize(t1_win)

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_recv3d_2
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_reduce_sum --- Sum real*8 scalar over all processes
!
! !INTERFACE:
      subroutine mp_reduce_sum (sum)
!
! !OUTPUT PARAMETERS:
      real(r8), intent(inout):: sum
!
! !DESCRIPTION:
!
!     Sum real*8 scalar over all processes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      integer  n
      real(r8) sumin
      real(r8) sumg(numpro)

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

#if defined(USE_SHMEM)
      call Win_Open(r8_win)
      ga_r8_s(1) = sum
      call SHMEM_REAL8_SUM_TO_ALL (ga_r8_r, ga_r8_s, 1, 0, 0, numpro, &
                             ga_r8_s(2), reduce_sync)
      call Win_Close(r8_win)
      sum = ga_r8_r(1)
      call Win_Finalize(r8_win)
#else
      sumin = sum
      call MPI_ALLREDUCE( sumin, sum, 1, mp_r8, MPI_SUM, &
                          commglobal, ierror )
#endif

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_reduce_sum
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_reduce_max --- Reduce maximum real*8 scalar over all processes
!
! !INTERFACE:
      subroutine mp_reduce_max(km, cymax)
!-----
! !INPUT PARAMETERS:
      integer, intent(in):: km
!
! !OUTPUT PARAMETERS:
      real(r8), intent(inout):: cymax(km)
!
! !DESCRIPTION:
!
!     Reduce maximum real*8 scalar over all processes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      integer k, n
      real(r8) maxin(km)

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

#if defined(USE_SHMEM)
      call Win_Open(r8_win)
      do k=1,km
         ga_r8_s(k) = cymax(k)
      enddo
      call SHMEM_REAL8_MAX_TO_ALL (ga_r8_r, ga_r8_s, km, 0, 0, numpro, &
                                   ga_r8_s(km+1), reduce_sync)
      call Win_Close(r8_win)
      do k=1,km
         cymax(k) = ga_r8_r(k)
      enddo
      call Win_Finalize(r8_win)
#else
!$omp parallel do private(k, irr)
      do k=1,km
        maxin(k) = cymax(k)
      enddo
      call MPI_ALLREDUCE( maxin, cymax, km, mp_r8, MPI_MAX, &
                          commglobal, irr )
#endif

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_reduce_max
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_minmax --- Reduce min/max real*8 scalar over all processes
!
! !INTERFACE:
      subroutine mp_minmax(qmin, qmax)
!
! !OUTPUT PARAMETERS:
      real(r8), intent(inout):: qmin, qmax
!
! !DESCRIPTION:
!
!     Reduce minimum/maximum real*8 scalar over all processes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      real(r8) minin, maxin
      integer n

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

#if defined(USE_SHMEM)
      call Win_Open(r8_win)
      ga_r8_s(1) = qmax
      ga_r8_s(2) = -1.*qmin
      call SHMEM_REAL8_MAX_TO_ALL (ga_r8_r, ga_r8_s, 2, 0, 0, numpro, &
                             ga_r8_s(3), reduce_sync)
      call Win_Close(r8_win)
      qmax = ga_r8_r(1)
      qmin = -1.*ga_r8_r(2)
      call Win_Finalize(r8_win)
#else
      maxin = qmax
      minin = qmin
      call MPI_ALLREDUCE(maxin, qmax, 1, mp_r8, MPI_MAX, &
                         commglobal, ierror)
      call MPI_ALLREDUCE(minin, qmin, 1, mp_r8, MPI_MIN, &
                         commglobal, ierror)
#endif

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_minmax
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_sum1d --- Sum real*8 over all latitudes
!
! !INTERFACE:
      subroutine mp_sum1d(jm, jfirst, jlast, qin, sum0)
!
! !INPUT PARAMETERS:
      integer, intent(in):: jm
      integer, intent(in):: jfirst, jlast
      real(r8), intent(in):: qin(jfirst:jlast)
! !OUTPUT PARAMETERS:
      real(r8), intent(out)::  sum0
!
! !DESCRIPTION:
!
!     Sum real*8 over all latitudes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      integer j, n
      real(r8) qout(jm)

      if( no_mod_comm )return
#if defined(QUICK_DIRTY_CODE)
     sum0 = 0.
     do j=jfirst,jlast
        sum0 = sum0 + qin(j)
     enddo
     call mp_reduce_sum(sum0)
#else
      call mp_gather3d(qin, qout, 1, jm, 1, jfirst, jlast, &
                       1, 1, 0, 0, 0)
! Compute the sum if "Master"
      if ( gid == 0 ) then
         sum0 = 0.
         do j=1,jm
            sum0 = sum0 + qout(j)
         enddo
      endif
      call mp_bcst_real(sum0)
#endif
!EOC
      end subroutine mp_sum1d
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_add1d --- Sum real*8 array over all processes
!
! !INTERFACE:
      subroutine mp_add1d(jdim, qin)
!
! !INPUT PARAMETERS:
      integer, intent(in):: jdim
! !OUTPUT PARAMETERS:
      real(r8), intent(inout):: qin(jdim)
!
! !DESCRIPTION:
!
!     Sum real*8 array over all processes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      real(r8) qout(jdim,numpro)
      integer j, n

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Open(r8_win)

#if !defined(USE_SHMEM) && !defined(MPI2)
! Init Recvs
      if (gid==0) then
        do n=1,numpro
          r8_win%src = n-1
          r8_win%size_r = jdim 
          r8_win%offset_r = r8_win%src*jdim
          call Ga_RecvInit_r8(r8_win, ga_r8_r)
        enddo
      endif
#endif

      r8_win%dest = 0
      r8_win%offset_s = gid*jdim
      call Ga_Put4d_r8(qin, r8_win, 1, 1, jdim, numpro, &
                            1, 1, 1, 1, 1, jdim, gid+1, gid+1, &
                            1, 1, 1, 1, 1, jdim, gid+1, gid+1, &
                            ga_r8_s, ga_r8_r  )

      call Win_Close(r8_win)

      if (gid==0) then
        do n=1,numpro
          r8_win%src = n-1
          r8_win%offset_r = r8_win%src*jdim
          call Ga_Get4d_r8(qout(1,n), r8_win, 1, 1, jdim, numpro, &
                         1, 1, 1, 1, 1, jdim, r8_win%src+1, r8_win%src+1, &
                         1, 1, 1, 1, 1, jdim, r8_win%src+1, r8_win%src+1, &
                         ga_r8_r  )
        enddo
        do j=1,jdim
          qin(j) = 0.
          do n=1,numpro
            qin(j) = qin(j) + qout(j,n)
          enddo
        enddo
      endif

      call Win_Finalize(r8_win)

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_add1d
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_bcst_real --- Broadcast real*8 scalar
!
! !INTERFACE:
      subroutine mp_bcst_real(val)
!
! !OUTPUT PARAMETERS:
      real(r8), intent(inout):: val
!
! !DESCRIPTION:
!
!     Broadcast real*8 scalar from Process=id to All other Processes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
      real(r8) val_arr(1)

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

     val_arr(1) = val
     call Ga_Broadcast_r8(val_arr, 1)
     val = val_arr(1)

!EOC
      end subroutine mp_bcst_real
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_bcst_int --- Broadcast integer*4 scalar
!
! !INTERFACE:
      subroutine mp_bcst_int(intv)
!
! !OUTPUT PARAMETERS:
      integer(i4), intent(inout):: intv
!
! !DESCRIPTION:
!
!     Broadcast integer*4 scalar from Process=id to All other Processes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
       integer n
       integer(i4) intv_arr(1)

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif
   
      intv_arr(1) = intv
      call Ga_Broadcast_i4(intv_arr, 1)
      intv = intv_arr(1)

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_bcst_int
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_bcst_r2d --- Broadcast real*8 2d array
!
! !INTERFACE:
      subroutine mp_bcst_r2d(im, jm, jfirst, jlast, qin, id)
!
! !INPUT PARAMETERS:
      integer, intent(in):: im, jm
      integer, intent(in):: id        ! source ID
      integer, intent(in):: jfirst, jlast
! !OUTPUT PARAMETERS:
      real(r8), intent(inout):: qin(im,jm)
!
! !DESCRIPTION:
!
!     Broadcast real*8 2d array from Process=id to All other Processes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Ga_Broadcast_r8 ( qin, im*jm ) 

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_bcst_r2d
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_gath_r2d --- Gather real*8 2d array
!
! !INTERFACE:
      subroutine mp_gath_r2d(im, jm, jfirst, jlast, qin, id)
!
! !INPUT PARAMETERS:
      integer, intent(in):: im, jm
      integer, intent(in):: id        ! source ID
      integer, intent(in):: jfirst, jlast
! !OUTPUT PARAMETERS:
      real(r8), intent(inout):: qin(im,jm)
!
! !DESCRIPTION:
!
!     Gather real*8 2d array from All Processes to Process=id
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      integer n, j1, j2
 
      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Open(r8_win)

#if !defined(USE_SHMEM) && !defined(MPI2)
! Init Recvs
      if (gid == id) then
         do n=1,numpro
           r8_win%src  = n-1
           r8_win%size_r = im*(ylast(n)-yfirst(n)+1)
           r8_win%offset_r = (yfirst(n)-1)*im
           call Ga_RecvInit_r8(r8_win, ga_r8_r)
         enddo
      endif
#endif

      r8_win%dest = id
      r8_win%offset_s = (jfirst-1)*im
      call Ga_Put4d_r8 ( qin, r8_win, 1, im, jm, 1, &
                         1, 1, 1, im, 1,      jm,    1, 1, &
                         1, 1, 1, im, jfirst, jlast, 1, 1, &
                         ga_r8_s, ga_r8_r  )

      call Win_Close(r8_win)

      if (gid == id) then
         do n=1,numpro
           j1 = yfirst(n)
           j2 = ylast(n)
           r8_win%src  = n-1
           r8_win%offset_r = (j1-1)*im
           call Ga_Get4d_r8 ( qin, r8_win, 1, im, jm, 1, &
                              1, 1, 1, im, 1,  jm, 1, 1, &
                              1, 1, 1, im, j1, j2, 1, 1, &
                              ga_r8_r  )
         enddo
      endif

      call Win_Finalize(r8_win)

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_gath_r2d
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_gath_3d_int --- Gather integer*4 3d array
!
! !INTERFACE:
      subroutine mp_gath_3d_int(q, idim, jdim, kdim, i1, i2, j1, j2, k1, k2, id)
!
! !INPUT PARAMETERS:
      integer, intent(in):: idim, jdim, kdim
      integer, intent(in):: id
      integer, intent(in):: i1, i2, j1, j2, k1, k2
! !OUTPUT PARAMETERS:
      integer(i4), intent(inout)::    q(idim,jdim,kdim)
!
! !DESCRIPTION:
!
!     Gather integer*4 3d array from All Processes to Process=id,
!            with non-standard (ie, /= PLON, PLAT, PLEV) array dimensions.
!
! !REVISION HISTORY:
!    2002.09.09   Putman        
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      integer n, ndims
      parameter (ndims=6)
      integer(i4) all_dims(ndims, numpro)
      integer ir1, ir2, jr1, jr2, kr1, kr2

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      all_dims(1,gid+1) = i1
      all_dims(2,gid+1) = i2
      all_dims(3,gid+1) = j1
      all_dims(4,gid+1) = j2
      all_dims(5,gid+1) = k1
      all_dims(6,gid+1) = k2

      call Ga_AllToAll_i4(all_dims, numpro*ndims, ndims, gid*ndims+1)

      call Win_Open(i4_win)
#if !defined(USE_SHMEM) && !defined(MPI2)
      if (gid==id) then
        i4_win%offset_r = 0
        do n=1,numpro
          i4_win%src = n-1
          ir1 = all_dims(1,n)
          ir2 = all_dims(2,n)
          jr1 = all_dims(3,n)
          jr2 = all_dims(4,n)
          kr1 = all_dims(5,n)
          kr2 = all_dims(6,n)
          if (n>1) then
            i4_win%offset_r = i4_win%offset_r + &
                             ((all_dims(2,n-1)-all_dims(1,n-1)+1) * &
                              (all_dims(4,n-1)-all_dims(3,n-1)+1) * &
                              (all_dims(6,n-1)-all_dims(5,n-1)+1))
          endif
          i4_win%size_r = (ir2-ir1+1)*(jr2-jr1+1)*(kr2-kr1+1)
          call Ga_RecvInit_i4(i4_win, ga_i4_r)
        enddo
      endif
#endif
      i4_win%dest = id
      i4_win%offset_s = 0
      do n=1,gid
        i4_win%offset_s = i4_win%offset_s + &
                         ((all_dims(2,n)-all_dims(1,n)+1) * &
                          (all_dims(4,n)-all_dims(3,n)+1) * &
                          (all_dims(6,n)-all_dims(5,n)+1))
      enddo
      call Ga_Put4d_i4(q, i4_win, idim, jdim, kdim, 1, &
                          1,  idim, 1,  jdim, 1,  kdim, 1, 1, &
                          i1, i2,   j1, j2,   k1, k2,   1, 1, &
                          ga_i4_s, ga_i4_r  )
      call Win_Close(i4_win)
      if (gid==id) then
        i4_win%offset_r = 0
        do n=1,numpro
          i4_win%src = n-1
          ir1 = all_dims(1,n)
          ir2 = all_dims(2,n)
          jr1 = all_dims(3,n)
          jr2 = all_dims(4,n)
          kr1 = all_dims(5,n)
          kr2 = all_dims(6,n)
          if (n>1) then
            i4_win%offset_r = i4_win%offset_r + &
                             ((all_dims(2,n-1)-all_dims(1,n-1)+1) * &
                              (all_dims(4,n-1)-all_dims(3,n-1)+1) * &
                              (all_dims(6,n-1)-all_dims(5,n-1)+1))
          endif
          call Ga_Get4d_i4(q, i4_win, idim, jdim, kdim, 1, &
                              1,   idim, 1,   jdim, 1,   kdim, 1, 1, &
                              ir1, ir2,  jr1, jr2,  kr1, kr2,  1, 1, &
                              ga_i4_r  )
        enddo
      endif
      call Win_Finalize(i4_win)

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_gath_3d_int
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_gath_3d --- Gather real*8 3d array
!
! !INTERFACE:
      subroutine mp_gath_3d(q, idim, jdim, kdim, i1, i2, j1, j2, k1, k2, id)
!
! !INPUT PARAMETERS:
      integer, intent(in):: idim, jdim, kdim
      integer, intent(in):: id
      integer, intent(in):: i1, i2, j1, j2, k1, k2
! !OUTPUT PARAMETERS:
      real(r8), intent(inout)::    q(idim,jdim,kdim)
!
! !DESCRIPTION:
!
!     Gather real*8 3d array from All Processes to Process=id, 
!            with non-standard (ie, /= PLON, PLAT, PLEV) array dimensions.
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      integer n, ndims
      parameter (ndims=6)
      integer(i4) all_dims(ndims, numpro)
      integer ir1, ir2, jr1, jr2, kr1, kr2

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      all_dims(1,gid+1) = i1
      all_dims(2,gid+1) = i2
      all_dims(3,gid+1) = j1
      all_dims(4,gid+1) = j2
      all_dims(5,gid+1) = k1
      all_dims(6,gid+1) = k2

      call Ga_AllToAll_i4(all_dims, numpro*ndims, ndims, gid*ndims+1)

      call Win_Open(r8_win)
#if !defined(USE_SHMEM) && !defined(MPI2)
      if (gid==id) then
        r8_win%offset_r = 0
        do n=1,numpro
          r8_win%src = n-1
          ir1 = all_dims(1,n)
          ir2 = all_dims(2,n)
          jr1 = all_dims(3,n)
          jr2 = all_dims(4,n)
          kr1 = all_dims(5,n)
          kr2 = all_dims(6,n)
          if (n>1) then
            r8_win%offset_r = r8_win%offset_r + & 
                             ((all_dims(2,n-1)-all_dims(1,n-1)+1) * &
                              (all_dims(4,n-1)-all_dims(3,n-1)+1) * &
                              (all_dims(6,n-1)-all_dims(5,n-1)+1))
          endif
          r8_win%size_r = (ir2-ir1+1)*(jr2-jr1+1)*(kr2-kr1+1)
          call Ga_RecvInit_r8(r8_win, ga_r8_r)
        enddo
      endif
#endif
      r8_win%dest = id
      r8_win%offset_s = 0
      do n=1,gid
        r8_win%offset_s = r8_win%offset_s + &
                         ((all_dims(2,n)-all_dims(1,n)+1) * &
                          (all_dims(4,n)-all_dims(3,n)+1) * &
                          (all_dims(6,n)-all_dims(5,n)+1))
      enddo

      call Ga_Put4d_r8(q, r8_win, idim, jdim, kdim, 1, &
                          1,  idim, 1,  jdim, 1,  kdim, 1, 1, &
                          i1, i2,   j1, j2,   k1, k2,   1, 1, &
                          ga_r8_s, ga_r8_r  )
      call Win_Close(r8_win)
      if (gid==id) then
        r8_win%offset_r = 0
        do n=1,numpro
          r8_win%src = n-1
          ir1 = all_dims(1,n)
          ir2 = all_dims(2,n)
          jr1 = all_dims(3,n)
          jr2 = all_dims(4,n)
          kr1 = all_dims(5,n)
          kr2 = all_dims(6,n)
          if (n>1) then
            r8_win%offset_r = r8_win%offset_r + &
                             ((all_dims(2,n-1)-all_dims(1,n-1)+1) * &
                              (all_dims(4,n-1)-all_dims(3,n-1)+1) * &
                              (all_dims(6,n-1)-all_dims(5,n-1)+1))
          endif
          call Ga_Get4d_r8(q, r8_win, idim, jdim, kdim, 1, &
                              1,   idim, 1,   jdim, 1,   kdim, 1, 1, &
                              ir1, ir2,  jr1, jr2,  kr1, kr2,  1, 1, &
                              ga_r8_r  )
        enddo
      endif
      call Win_Finalize(r8_win)

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_gath_3d
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_scat3d_int --- Scatter integer*4 3d array
!
! !INTERFACE:
      subroutine mp_scat3d_int(q, idim, jdim, kdim, i1, i2, j1, j2, k1, k2, id)
!
! !INPUT PARAMETERS:
      integer, intent(in):: idim, jdim, kdim
      integer, intent(in):: id
      integer, intent(in):: i1, i2, j1, j2, k1, k2
! !OUTPUT PARAMETERS:
      integer(i4), intent(inout):: q(idim,jdim,kdim)
!
! !DESCRIPTION:
!
!     Scatter integer*4 3d array from Process=id to All other Processes, 
!            with non-standard (ie, /= PLON, PLAT, PLEV) array dimensions.
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      integer i, j, k, n

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Open(i4_win)

#if !defined(USE_SHMEM) && !defined(MPI2)
! Init Recvs
      i4_win%src  = id
      i4_win%size_r = (i2-i1+1)*(j2-j1+1)*(k2-k1+1)
      i4_win%offset_r = 0
      call Ga_RecvInit_i4(i4_win, ga_i4_r)
#endif

      if (gid == id) then
        do n=1,numpro
          i4_win%dest = n-1
          i4_win%offset_s = 0
          call Ga_Put4d_i4 ( q, i4_win, idim, jdim, kdim, 1, &
                               1,  idim, 1,  jdim, 1,  kdim, 1, 1, &
                               i1, i2,   j1, j2,   k1, k2,   1, 1, &
                               ga_i4_s, ga_i4_r  )
        enddo
      endif

      call Win_Close(i4_win)

      i4_win%src  = id
      i4_win%offset_r = 0
      call Ga_Get4d_i4 ( q, i4_win, idim, jdim, kdim, 1, &
                           1,  idim, 1,  jdim, 1,  kdim, 1, 1, &
                           i1, i2,   j1, j2,   k1, k2,   1, 1, &
                           ga_i4_r  )

      call Win_Finalize(i4_win)

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_scat3d_int
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_scat3d --- Scatter real*8 3d array
!
! !INTERFACE:
      subroutine mp_scat3d(q, idim, jdim, kdim, i1, i2, j1, j2, k1, k2, id)
!
! !INPUT PARAMETERS:
      integer, intent(in):: idim, jdim, kdim
      integer, intent(in):: id
      integer, intent(in):: i1, i2, j1, j2, k1, k2
! !OUTPUT PARAMETERS:
      real(r8), intent(inout)::    q(idim,jdim,kdim)
!
! !DESCRIPTION:
!
!     Scatter real*8 3d array from Process=id to All other Processes, 
!            with non-standard (ie, /= PLON, PLAT, PLEV) array dimensions.
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      integer i, j, k, n

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Open(r8_win)

#if !defined(USE_SHMEM) && !defined(MPI2)
! Init Recvs
      r8_win%src  = id
      r8_win%size_r = (i2-i1+1)*(j2-j1+1)*(k2-k1+1)
      r8_win%offset_r = 0
      call Ga_RecvInit_r8(r8_win, ga_r8_r)
#endif

      if (gid == id) then
        do n=1,numpro
          r8_win%dest = n-1
          r8_win%offset_s = 0
          call Ga_Put4d_r8 ( q, r8_win, idim, jdim, kdim, 1, &
                                1,  idim, 1,  jdim, 1,  kdim, 1, 1, &
                                i1, i2,   j1, j2,   k1, k2,   1, 1, &
                                ga_r8_s, ga_r8_r  )
        enddo
      endif

      call Win_Close(r8_win)

      r8_win%src  = id
      r8_win%offset_r = 0
      call Ga_Get4d_r8 ( q, r8_win, idim, jdim, kdim, 1, &
                            1,  idim, 1,  jdim, 1,  kdim, 1, 1, &
                            i1, i2,   j1, j2,   k1, k2,   1, 1, &
                            ga_r8_r  )

      call Win_Finalize(r8_win)

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_scat3d
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_gath4_r2d --- Gather real*4 2d array
!
! !INTERFACE:
      subroutine mp_gath4_r2d(im, jm, jfirst, jlast, qin, id)
!
! !INPUT PARAMETERS:
      integer, intent(in):: im, jm
      integer, intent(in):: id        ! source ID
      integer, intent(in):: jfirst, jlast
! !OUTPUT PARAMETERS:
      real(r4), intent(inout):: qin(im,jm)
!
! !DESCRIPTION:
!
!     Gather real*4 2d array from Process=id to All other Processes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.02.15   Putman	Modified for Global Arrays code   
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      integer n, j1, j2

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Open(r4_win)

#if !defined(USE_SHMEM) && !defined(MPI2)
! Init Recvs
      if (gid == id) then
         do n=1,numpro
           r4_win%src  = n-1
           r4_win%size_r = im*(ylast(n)-yfirst(n)+1) 
           r4_win%offset_r = (yfirst(n)-1)*im
           call Ga_RecvInit_r4(r4_win, ga_r4_r)
         enddo
      endif
#if defined(OSF1)
      call mp_barrier
#endif
#endif

      r4_win%dest = id
      r4_win%offset_s = (jfirst-1)*im
      call Ga_Put4d_r4 ( qin, r4_win, 1, im, jm, 1, &
                         1, 1, 1, im, 1,      jm,    1, 1, &
                         1, 1, 1, im, jfirst, jlast, 1, 1, &
                         ga_r4_s, ga_r4_r  )

      call Win_Close(r4_win)

      if (gid == id) then
         do n=1,numpro
           j1 = yfirst(n)
           j2 = ylast(n)
           r4_win%src  = n-1
           r4_win%offset_r = (j1-1)*im
           call Ga_Get4d_r4 ( qin,  r4_win, 1, im, jm, 1, &
                              1, 1, 1, im, 1,  jm, 1, 1, &
                              1, 1, 1, im, j1, j2, 1, 1, &
                              ga_r4_r  )
         enddo
      endif

      call Win_Finalize(r4_win)

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_gath4_r2d
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_barrier --- Synchronize all SPMD processes
!
! !INTERFACE:
      subroutine mp_barrier
!
! !DESCRIPTION:
!
!     Synchronize all SPMD processes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
      if( no_mod_comm )return
#if defined (USE_SHMEM)
        call SHMEM_BARRIER_ALL()
#else
        call MPI_BARRIER(commglobal, ierror)
#endif
!EOC
      end subroutine mp_barrier
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_scatter3d --- Scatter real*8 4d array
!
! !INTERFACE:
      subroutine mp_scatter3d(qin, qout, im, jm, km, jfirst, jlast, &
                              kfirst, klast, ng_s, ng_n, id)
!
! !INPUT PARAMETERS:
      integer, intent(in):: im, jm, km
      integer, intent(in):: jfirst, jlast, kfirst, klast
      integer, intent(in):: ng_s, ng_n
      integer, intent(in):: id           ! Source (usually 0)
      real(r8), intent(in):: qin(im,jm,km)
! !OUTPUT PARAMETERS:
      real(r8), intent(out):: qout(im,jfirst-ng_s:jlast+ng_n,kfirst:klast)
!
! !DESCRIPTION:
!
!     Scatter real*8 4d array from Process=id to All other Processes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2001.11.15   Putman	Modified for Global Arrays code
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      integer n
      integer j1, j2, k1, k2
 
      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Open(r8_win)

#if !defined(USE_SHMEM) && !defined(MPI2)
! Init Recvs
      r8_win%src = id
      r8_win%size_r = im*(jlast-jfirst+1)*(klast-kfirst+1)
      r8_win%offset_r = ((jfirst-1)*km+(kfirst-1))*im
      call Ga_RecvInit_r8(r8_win, ga_r8_r)
#endif

      if (gid == id) then
         do n=1,numpro
           j1 = yfirst(n)
           j2 = ylast(n)
           if (km == PLEV) then
             k1 = zfirst(n)
             k2 = zlast(n)
           else
             k1 = 1
             k2 = km
           endif
           r8_win%dest = n-1
           r8_win%offset_s = ((j1-1)*km+(k1-1))*im
           call Ga_Put4d_r8 ( qin, r8_win, im, jm, km, 1, &
                              1, im, 1,  jm, 1,  km, 1,1, &
                              1, im, j1, j2, k1, k2, 1,1, &
                              ga_r8_s, ga_r8_r  )
         enddo
      endif

      call Win_Close(r8_win)

      r8_win%offset_r = ((jfirst-1)*km+(kfirst-1))*im
      r8_win%src = id
      call Ga_Get4d_r8 ( qout, r8_win, im, jm, km, 1, &
                         1, im, jfirst-ng_s, jlast+ng_n, kfirst, klast, 1, 1, &
                         1, im, jfirst,      jlast,      kfirst, klast, 1, 1, &
                         ga_r8_r  )

      call Win_Finalize(r8_win)

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_scatter3d
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_gather3d --- Gather real*8 4d array
!
! !INTERFACE:
      subroutine mp_gather3d(qin, qout, im, jm, km, jfirst, jlast, &
                             kfirst, klast, ng_s, ng_n, id)
!
! !INPUT PARAMETERS:
      integer, intent(in):: im, jm, km
      integer, intent(in):: jfirst, jlast, kfirst, klast
      integer, intent(in):: ng_s, ng_n
      integer, intent(in):: id         ! process ID to gather data to
      real(r8), intent(in):: qin(im,jfirst-ng_s:jlast+ng_n,kfirst:klast)
! !OUTPUT PARAMETERS:
      real(r8), intent(out) :: qout(im,jm,km)
!
! !DESCRIPTION:
!
!     Gather real*8 4d array from Process=id to All other Processes
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2001.11.15   Putman	Modified for Global Arrays code
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      integer i, j, k, iq
      integer j1, j2, k1, k2
      integer n

      if( no_mod_comm )return
#if defined( TIMING )
      call timing_on('COMM_TOTAL')
#endif

      call Win_Open(r8_win)

#if !defined(USE_SHMEM) && !defined(MPI2)
! Init Recvs
      if (gid == id) then
         do n=1,numpro
           j1 = yfirst(n)
           j2 = ylast(n)
           if (km == PLEV) then
             k1 = zfirst(n)
             k2 = zlast(n)
           else
             k1 = 1
             k2 = km
           endif
           r8_win%src  = n-1
           r8_win%size_r = im*(j2-j1+1)*(k2-k1+1)
           r8_win%offset_r = ((j1-1)*km+(k1-1))*im
           call Ga_RecvInit_r8(r8_win, ga_r8_r)
         enddo
      endif
#endif

      r8_win%dest = id
      r8_win%offset_s = ((jfirst-1)*km+(kfirst-1))*im
      call Ga_Put4d_r8 ( qin, r8_win, im, jm, km,  1, &
                         1, im, jfirst-ng_s, jlast+ng_n, kfirst, klast, 1,  1, &
                         1, im, jfirst,      jlast,      kfirst, klast, 1,  1, &
                         ga_r8_s, ga_r8_r  )

      call Win_Close(r8_win)

      if (gid == id) then
         do n=1,numpro
           j1 = yfirst(n)
           j2 = ylast(n)
           if (km == PLEV) then
             k1 = zfirst(n)
             k2 = zlast(n)
           else
             k1 = 1
             k2 = km
           endif
           r8_win%src  = n-1
           r8_win%offset_r = ((j1-1)*km+(k1-1))*im
           call Ga_Get4d_r8 ( qout, r8_win, im, jm, km,  1, &
                              1, im,  1, jm,  1, km, 1,  1, &
                              1, im, j1, j2, k1, k2, 1,  1, &
                              ga_r8_r  )
         enddo
      endif

      call Win_Finalize(r8_win)

#if defined( TIMING )
      call timing_off('COMM_TOTAL')
#endif

!EOC
      end subroutine mp_gather3d
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_wrt3d --- Write real*8 3d array to file
!
! !INTERFACE:
      subroutine mp_wrt3d(iout, nrec, r_zero, qin, im, jm, km, &
                          jfirst, jlast, kfirst, klast, id )
!
! !INPUT PARAMETERS:
      integer, intent(in):: iout
      integer, intent(in):: nrec
      integer, intent(in):: im, jm, km
      integer, intent(in):: jfirst, jlast, kfirst, klast
      integer, intent(in):: id         ! process ID
      real(r8), intent(in):: r_zero
      real(r8), intent(in):: qin(im,jfirst:jlast,kfirst:klast)
!
! !DESCRIPTION:
!
!     Write real*8 3d array to 4-byte unit number iout, record=nrec:
!           If < r_zero write 0.
!
! !REVISION HISTORY: 
!    2001.09.01   Lin    
!    2001.11.15   Putman	Modified for Global Arrays code
!    2002.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      integer i, j, k, iq
      real(r4) a2(im,jm)
      integer n
      integer qsize
      integer send_tag, recv_tag
      real(r8) qout(im,jm,km)

      real(r8) qmax


      if( no_mod_comm )return
      call mp_gather3d(qin, qout, im, jm, km, jfirst, jlast, &
                       kfirst, klast, 0, 0, 0)
      if (gid == id) then
        do k=1,km
          do j=1,jm
            do i=1,im
              if( abs(qout(i,j,k)) < r_zero ) then
                 qout(i,j,k) = 0.
              endif
              a2(i,j) = qout(i,j,k)
            enddo
          enddo
        write(iout,rec=nrec+k) a2
        enddo
      endif
!EOC
      end subroutine mp_wrt3d
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Win_Open --- Open a communication window
!
! !INTERFACE:
      subroutine Win_Open(win)
! !OUTPUT PARAMETERS:
      type(window), intent(inout):: win
!
! !DESCRIPTION:
!
!     Begin a communication epoch, by opening a comm window.
!     Update number of send calls on the window (win%ncall_s).
!     Barrier synchronzize if necessary.
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC

      if( no_mod_comm )return
      win%ncall_s = win%ncall_s + 1
      ncall_s = ncall_s + 1

#if defined(USE_SHMEM)
      if (ncall_s == 1) then
         if (ga_ptr == 1) then 
            ga_ptr = 2
            ga_r8_r => ga_r8b_r
            ga_r8_s => ga_r8b_s
            ga_r8_r => ga_r8b_r
            ga_r8_s => ga_r8b_s
            ga_r4_r => ga_r4b_r
            ga_r4_s => ga_r4b_s
            ga_i4_r => ga_i4b_r
            ga_i4_s => ga_i4b_s
         else
            ga_ptr = 1
            ga_r8_r => ga_r8a_r
            ga_r8_s => ga_r8a_s
            ga_r8_r => ga_r8a_r
            ga_r8_s => ga_r8a_s
            ga_r4_r => ga_r4a_r
            ga_r4_s => ga_r4a_s
            ga_i4_r => ga_i4a_r
            ga_i4_s => ga_i4a_s
         endif
      endif
#endif

!EOC
      end subroutine Win_Open
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Win_Close --- Close a communication window
!
! !INTERFACE:
      subroutine Win_Close(win)
! !OUTPUT PARAMETERS:
      type(window), intent(inout):: win
!
! !DESCRIPTION:
!
!     End a communication epoch, by closing a comm window.
!     Update number of receive calls on the window (win%ncall_r).
!     Barrier synchronzize if necessary.
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC

      if( no_mod_comm )return
      win%ncall_r = win%ncall_r + 1
      ncall_r = ncall_r + 1
#if defined(USE_SHMEM)
      if (ncall_r == 1) then
          call mp_barrier()
      endif
#endif
#if defined(MPI2)
      if (win%ncall_r == 1) then
          call MPI_WIN_FENCE(MPI_MODE_NOSTORE + MPI_MODE_NOSUCCEED, &
                             win%id, ierror)
      endif
#endif

!EOC
      end subroutine Win_Close
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Win_Finalize --- Reset a communication window after a comm epoch.
!
! !INTERFACE:
      subroutine Win_Finalize(win)
! !OUTPUT PARAMETERS:
      type(window), intent(inout):: win
!
! !DESCRIPTION:
!
!     Complete a communication epoch and reset a comm window.
!     Update global lastwin with win%id.
!     Barrier synchronzize if necessary.
!
! !REVISION HISTORY:
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC

      if( no_mod_comm )return
      if (ncall_s == ncall_r) then
#if !defined(USE_SHMEM) && !defined(MPI2)
        call MPI_WAITALL(nsend, sqest, Stats, ierror)
        nsend = 0
        nrecv = 0
        nread = 0
#endif
        ncall_s = 0
        ncall_r = 0
      endif

      if (win%ncall_s == win%ncall_r) then
#if defined(MPI2)
        call MPI_WIN_FENCE(MPI_MODE_NOPRECEDE, win%id, ierror)
#endif
        lastwin = win%id
        win%ncall_s = 0
        win%ncall_r = 0
      endif

!EOC
      end subroutine Win_Finalize
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_Put4d_r8 --- Write to real*8 4d global array
!
! !INTERFACE:
      subroutine Ga_Put4d_r8 ( q, win, im, jm, km, nq, &
                                  ifrom, ito, jfrom, jto, kfrom, kto, &
                                  nqfrom, nqto, i1, i2, j1, j2, k1, k2, &
                                  nq1, nq2, ga_s, ga_r )
! !INPUT PARAMETERS:
      type(window), intent(in)  :: win           ! Global Array Window
      integer, intent(in)  :: im, jm, km, nq
      integer, intent(in)  :: ifrom, ito, jfrom, jto, kfrom, kto, nqfrom, nqto
      real(r8), intent(in)  :: q(ifrom:ito,jfrom:jto,kfrom:kto,nqfrom:nqto)
      integer, intent(in)  :: i1, i2, j1, j2, k1, k2, nq1, nq2

! !OUTPUT PARAMETERS:
      real(r8), intent(inout):: ga_s(win%wsize)
      real(r8), intent(inout):: ga_r(win%wsize)
!
! !DESCRIPTION:
!
!     Write to real*8 4d global array.
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer i, j, k, iq, inc, inc1
      integer i_length, j_length, k_length, ij_length, ijk_length
      integer send_tag, qsize

#if defined(MPI2)
      integer p, tmpsize, mysize
      integer(kind=MPI_ADDRESS_KIND) mydisp
#endif
#if defined(USE_SHMEM)
#if defined(OSF1)
      integer(kind=8) p, tmpsize, mysize, mydisp
#else
      integer p, tmpsize, mysize, mydisp
#endif
#endif

      if( no_mod_comm )return
      i_length   = i2-i1+1
      j_length   = j2-j1+1
      k_length   = k2-k1+1
      ij_length  = i_length*j_length 
      ijk_length = i_length*j_length*k_length

! Begin Non-Blocking Sends ( MPI-2 and MPI-1 )
        do iq = nq1, nq2
!$omp parallel do private(i,j,k,inc,inc1)
          do k = k1, k2
                inc1 = (win%offset_s) + ((iq-nq1)*ijk_length) &
                       + ((k-k1)*ij_length) -i1+1
            do j = j1, j2
                inc = inc1 + (j-j1)*i_length
              do i = i1, i2
                 ga_s(inc+i) = q(i,j,k,iq)
              enddo
            enddo
          enddo
        enddo

      qsize = (i2-i1+1)*(j2-j1+1)*(k2-k1+1)*(nq2-nq1+1)

#if defined(MPI2) || defined(USE_SHMEM)
      tmpsize = ceiling(real(qsize)/real(pkgs_per_pro))

!$omp parallel do private(p,mysize,mydisp, irr)
      do p=1,MIN(pkgs_per_pro,qsize)
        mysize = MIN(tmpsize, MAX(qsize-(tmpsize*(p-1)),0))
        mydisp = win%offset_s + (p-1)*tmpsize

#if defined(MPI2)
        call MPI_PUT(ga_s(mydisp+1), mysize, mp_r8, &
                     win%dest, mydisp, mysize, mp_r8, &
                     win%id, irr)
#else
           call SHMEM_PUT64(ga_r(mydisp+1), ga_s(mydisp+1), &
                                 mysize, win%dest)
#endif
      enddo
#else
      send_tag = gid
      nsend = nsend + 1
      call MPI_ISEND(ga_s(win%offset_s+1), qsize, mp_r8, win%dest, &
                     send_tag, commglobal, sqest(nsend), irr)
#endif

!EOC
      end subroutine Ga_Put4d_r8
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_RecvInit_r8 --- Initiate real*8 Non-Blocking receive
!
! !INTERFACE:
      subroutine Ga_RecvInit_r8( win, ga )
! !INPUT PARAMETERS:
      type(window), intent(in)    :: win           ! Global Array Window
! !OUTPUT PARAMETERS:
      real(r8), intent(inout):: ga(win%wsize)
!
! !DESCRIPTION:
!
!     Initiate real*8 Non-Blocking receive ( MPI-1 ).
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer qsize, recv_tag

      if( no_mod_comm )return
#if !defined(USE_SHMEM) && !defined(MPI2)
      if (win%wsize >= win%offset_r + win%size_r) then
        recv_tag = win%src
        qsize    = win%size_r
        nrecv    = nrecv + 1
        call MPI_IRECV(ga(win%offset_r+1), qsize, mp_r8, win%src, &
                       recv_tag, commglobal, rqest(nrecv), ierror)
      endif
#endif

!EOC
      end subroutine Ga_RecvInit_r8
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_Get4d_r8 --- Read from real*8 4d global array
!
! !INTERFACE:
      subroutine Ga_Get4d_r8 ( q, win, im, jm, km, nq, &
                                  ifrom, ito, jfrom, jto, kfrom, kto, &
                                  nqfrom, nqto, i1, i2, j1, j2, k1, k2, &
                                  nq1, nq2, ga )
! !INPUT PARAMETERS:
      type(window), intent(in)    :: win           ! Global Array Window
      integer, intent(in)  :: im, jm, km, nq
      integer, intent(in)  :: i1, i2, j1, j2, k1, k2, nq1, nq2
      integer, intent(in)  :: ifrom, ito, jfrom, jto, kfrom, kto, nqfrom, nqto
      real(r8), intent(in)  :: ga(win%wsize)
! !OUTPUT PARAMETERS:
      real(r8), intent(inout) :: q(ifrom:ito, jfrom:jto, kfrom:kto, nqfrom:nqto)
!
! !DESCRIPTION:
!
!     Read from real*8 4d global array.
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer i, j, k, iq, inc, inc1
      integer i_length, j_length, k_length, ij_length, ijk_length

      if( no_mod_comm )return
#if !defined(USE_SHMEM) && !defined(MPI2)
      nread = nread + 1
      call MPI_WAIT(rqest(nread), Status, ierror)
#endif

      i_length   = i2-i1+1
      j_length   = j2-j1+1
      k_length   = k2-k1+1
      ij_length  = i_length*j_length
      ijk_length = i_length*j_length*k_length

        do iq = nq1, nq2
!$omp parallel do private(i,j,k,inc,inc1)
          do k = k1, k2
                inc1 = (win%offset_r) + ((iq-nq1)*ijk_length) &
                       + ((k-k1)*ij_length) -i1+1
            do j = j1, j2
                inc = inc1 + (j-j1)*i_length
              do i = i1, i2
                q(i,j,k,iq) = ga(inc+i)
              enddo
            enddo
          enddo
        enddo

!EOC
      end subroutine Ga_Get4d_r8
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_Put4d_r4 --- Write to real*4 4d global array
!
! !INTERFACE:
      subroutine Ga_Put4d_r4 ( q, win, im, jm, km, nq, &
                                  ifrom, ito, jfrom, jto, kfrom, kto, &
                                  nqfrom, nqto, i1, i2, j1, j2, k1, k2, &
                                  nq1, nq2, ga_s, ga_r )
! !INPUT PARAMETERS:
      type(window), intent(in)  :: win           ! Global Array Window
      integer, intent(in)  :: im, jm, km, nq
      integer, intent(in)  :: ifrom, ito, jfrom, jto, kfrom, kto, nqfrom, nqto
      real(r4), intent(in)  :: q(ifrom:ito,jfrom:jto,kfrom:kto,nqfrom:nqto)
      integer, intent(in)  :: i1, i2, j1, j2, k1, k2, nq1, nq2
! !OUTPUT PARAMETERS:
      real(r4), intent(inout):: ga_s(win%wsize)
      real(r4), intent(inout):: ga_r(win%wsize)
!
! !DESCRIPTION:
!
!     Write to real*4 4d global array.
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer i, j, k, iq, inc, inc1
      integer i_length, j_length, k_length, ij_length, ijk_length
      integer send_tag, qsize
#if defined(MPI2)
      integer p, tmpsize, mysize
      integer(kind=MPI_ADDRESS_KIND) mydisp
#endif
#if defined(USE_SHMEM)
#if defined(OSF1)
      integer(kind=8) p, tmpsize, mysize, mydisp
#else
      integer p, tmpsize, mysize, mydisp
#endif
#endif

      if( no_mod_comm )return
      i_length   = i2-i1+1
      j_length   = j2-j1+1
      k_length   = k2-k1+1
      ij_length  = i_length*j_length
      ijk_length = i_length*j_length*k_length

! Begin Non-Blocking Sends ( MPI-2 and MPI-1 )
        do iq = nq1, nq2
!$omp parallel do private(i,j,k,inc,inc1)
          do k = k1, k2
                inc1 = (win%offset_s) + ((iq-nq1)*ijk_length) &
                       + ((k-k1)*ij_length) -i1+1
            do j = j1, j2
                inc = inc1 + (j-j1)*i_length
              do i = i1, i2
                ga_s(inc+i) = q(i,j,k,iq)
              enddo
            enddo
          enddo
        enddo

      qsize = (i2-i1+1)*(j2-j1+1)*(k2-k1+1)*(nq2-nq1+1)
#if defined(MPI2) || defined(USE_SHMEM)
      tmpsize = ceiling(real(qsize)/real(pkgs_per_pro))

!$omp parallel do private(p,mysize,mydisp,irr)
      do p=1,MIN(pkgs_per_pro,qsize)
        mysize = MIN(tmpsize, MAX(qsize-(tmpsize*(p-1)),0))
        mydisp = win%offset_s + (p-1)*tmpsize
#if defined(MPI2)
        call MPI_PUT(ga_s(mydisp+1), mysize, mp_r4, &
                     win%dest, mydisp, mysize, mp_r4, &
                     win%id, irr)
#else
           call SHMEM_PUT32(ga_r(mydisp+1), ga_s(mydisp+1), &
                                 mysize, win%dest)
#endif
      enddo
#else
      send_tag = gid
      nsend = nsend + 1
      call MPI_ISEND(ga_s(win%offset_s+1), qsize, mp_r4, win%dest, &
                     send_tag, commglobal, sqest(nsend), ierror)
#endif

!EOC
      end subroutine Ga_Put4d_r4
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_RecvInit_r4 --- Initiate real*4 Non-Blocking receive
!
! !INTERFACE:
      subroutine Ga_RecvInit_r4( win, ga )
! !INPUT PARAMETERS:
      type(window), intent(in)    :: win           ! Global Array Window
! !OUTPUT PARAMETERS:
      real(r4), intent(inout):: ga(win%wsize)
!
! !DESCRIPTION:
!
!     Initiate real*4 Non-Blocking receive ( MPI-1 ).
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer qsize, recv_tag

      if( no_mod_comm )return
#if !defined(USE_SHMEM) && !defined(MPI2)
      recv_tag = win%src
      qsize    = win%size_r
      nrecv    = nrecv + 1
      call MPI_IRECV(ga(win%offset_r+1), qsize, mp_r4, win%src, &
                     recv_tag, commglobal, rqest(nrecv), ierror)
#endif
!EOC
      end subroutine Ga_RecvInit_r4
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_Get4d_r4 --- Read from real*4 4d global array
!
! !INTERFACE:
      subroutine Ga_Get4d_r4 ( q, win, im, jm, km, nq, &
                                  ifrom, ito, jfrom, jto, kfrom, kto, &
                                  nqfrom, nqto, i1, i2, j1, j2, k1, k2, &
                                  nq1, nq2, ga )
! !INPUT PARAMETERS:
      type(window), intent(in)    :: win           ! Global Array Window
      integer, intent(in)  :: im, jm, km, nq
      integer, intent(in)  :: i1, i2, j1, j2, k1, k2, nq1, nq2
      integer, intent(in)  :: ifrom, ito, jfrom, jto, kfrom, kto, nqfrom, nqto
      real(r4), intent(in)  :: ga(win%wsize)
! !OUTPUT PARAMETERS:
      real(r4), intent(inout) :: q(ifrom:ito, jfrom:jto, kfrom:kto, nqfrom:nqto)
!
! !DESCRIPTION:
!
!     Read from real*4 4d global array.
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer i, j, k, iq, inc, inc1
      integer i_length, j_length, k_length, ij_length, ijk_length
      if( no_mod_comm )return
#if !defined(USE_SHMEM) && !defined(MPI2)
      nread = nread + 1
      call MPI_WAIT(rqest(nread), Status, ierror)
#endif

      i_length   = i2-i1+1
      j_length   = j2-j1+1
      k_length   = k2-k1+1
      ij_length  = i_length*j_length
      ijk_length = i_length*j_length*k_length

        do iq = nq1, nq2
!$omp parallel do private(i,j,k,inc,inc1)
          do k = k1, k2
                inc1 = (win%offset_r) + ((iq-nq1)*ijk_length) &
                       + ((k-k1)*ij_length) -i1+1
            do j = j1, j2
                inc = inc1 + (j-j1)*i_length
              do i = i1, i2
                q(i,j,k,iq) = ga(inc+i)
              enddo
            enddo
          enddo
        enddo

!EOC
      end subroutine Ga_Get4d_r4
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_Put4d_i4 --- Write to integer*4 4d global array
!
! !INTERFACE:
      subroutine Ga_Put4d_i4 ( q, win, im, jm, km, nq, &
                                  ifrom, ito, jfrom, jto, kfrom, kto, &
                                  nqfrom, nqto, i1, i2, j1, j2, k1, k2, &
                                  nq1, nq2, ga_s, ga_r )
! !INPUT PARAMETERS:
      type(window), intent(in)  :: win           ! Global Array Window
      integer, intent(in)  :: im, jm, km, nq
      integer, intent(in)  :: ifrom, ito, jfrom, jto, kfrom, kto, nqfrom, nqto
      integer(i4), intent(in)  :: q(ifrom:ito,jfrom:jto,kfrom:kto,nqfrom:nqto)
      integer, intent(in)  :: i1, i2, j1, j2, k1, k2, nq1, nq2
! !OUTPUT PARAMETERS:
      integer(i4), intent(inout):: ga_s(win%wsize)
      integer(i4), intent(inout):: ga_r(win%wsize)
!
! !DESCRIPTION:
!
!     Write to integer*4 4d global array.
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer i, j, k, iq, inc, inc1
      integer i_length, j_length, k_length, ij_length, ijk_length
      integer send_tag, qsize
#if defined(MPI2)
      integer p, tmpsize, mysize
      integer(kind=MPI_ADDRESS_KIND) mydisp
#endif
#if defined(USE_SHMEM)
#if defined(OSF1)
      integer(kind=8) p, tmpsize, mysize, mydisp
#else
      integer p, tmpsize, mysize, mydisp
#endif
#endif

      if( no_mod_comm )return
      i_length   = i2-i1+1
      j_length   = j2-j1+1
      k_length   = k2-k1+1
      ij_length  = i_length*j_length
      ijk_length = i_length*j_length*k_length

! Begin Non-Blocking Sends ( MPI-2 and MPI-1 )
        do iq = nq1, nq2
!$omp parallel do private(i,j,k,inc,inc1)
          do k = k1, k2
                inc1 = (win%offset_s) + ((iq-nq1)*ijk_length) &
                       + ((k-k1)*ij_length) -i1+1
            do j = j1, j2
                inc = inc1 + (j-j1)*i_length
              do i = i1, i2
                ga_s(inc+i) = q(i,j,k,iq)
              enddo
            enddo
          enddo
        enddo

      qsize = (i2-i1+1)*(j2-j1+1)*(k2-k1+1)*(nq2-nq1+1)
#if defined(MPI2) || defined(USE_SHMEM)
      tmpsize = ceiling(real(qsize)/real(pkgs_per_pro))
!$omp parallel do private(p,mysize,mydisp, irr)
      do p=1,MIN(pkgs_per_pro,qsize)
        mysize = MIN(tmpsize, MAX(qsize-(tmpsize*(p-1)),0))
        mydisp = win%offset_s + (p-1)*tmpsize
#if defined(MPI2)
        call MPI_PUT(ga_s(mydisp+1), mysize, mp_i4, &
                     win%dest, mydisp, mysize, mp_i4, &
                     win%id, irr)
#else
           call SHMEM_PUT32(ga_r(mydisp+1), ga_s(mydisp+1), &
                                 mysize, win%dest)
#endif
      enddo
#else
      send_tag = gid
      nsend = nsend + 1
      call MPI_ISEND(ga_s(win%offset_s+1), qsize, mp_i4, win%dest, &
                     send_tag, commglobal, sqest(nsend), ierror)
#endif

!EOC
      end subroutine Ga_Put4d_i4
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_RecvInit_i4 --- Initiate integer*4 Non-Blocking receive
!
! !INTERFACE:
      subroutine Ga_RecvInit_i4( win, ga )
! !INPUT PARAMETERS:
      type(window), intent(in)    :: win           ! Global Array Window
! !OUTPUT PARAMETERS:
      integer(i4), intent(inout):: ga(win%wsize)
!
! !DESCRIPTION:
!
!     Initiate integer*4 Non-Blocking receive ( MPI-1 ).
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer qsize, recv_tag

      if( no_mod_comm )return
#if !defined(USE_SHMEM) && !defined(MPI2)
      recv_tag = win%src
      qsize    = win%size_r
      nrecv    = nrecv + 1
      call MPI_IRECV(ga(win%offset_r+1), qsize, mp_i4, win%src, &
                     recv_tag, commglobal, rqest(nrecv), ierror)
#endif
!EOC
      end subroutine Ga_RecvInit_i4
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_Get4d_i4 --- Read from integer*4 4d global array
!
! !INTERFACE:
      subroutine Ga_Get4d_i4 ( q, win, im, jm, km, nq, &
                                  ifrom, ito, jfrom, jto, kfrom, kto, &
                                  nqfrom, nqto, i1, i2, j1, j2, k1, k2, &
                                  nq1, nq2, ga )
! !INPUT PARAMETERS:
      type(window), intent(in)    :: win           ! Global Array Window
      integer, intent(in)  :: im, jm, km, nq
      integer, intent(in)  :: i1, i2, j1, j2, k1, k2, nq1, nq2
      integer, intent(in)  :: ifrom, ito, jfrom, jto, kfrom, kto, nqfrom, nqto
      integer(i4), intent(in)  :: ga(win%wsize)
! !OUTPUT PARAMETERS:
      integer(i4), intent(inout) :: q(ifrom:ito, jfrom:jto, kfrom:kto, nqfrom:nqto)
!
! !DESCRIPTION:
!
!     Read from integer*4 4d global array.
!
! !REVISION HISTORY: 
!    02.02.15   Putman
!    02.04.09   Putman	Added ProTeX documentation
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer i, j, k, iq, inc, inc1
      integer i_length, j_length, k_length, ij_length, ijk_length
      if( no_mod_comm )return
#if !defined(USE_SHMEM) && !defined(MPI2)
      nread = nread + 1
      call MPI_WAIT(rqest(nread), Status, ierror)
#endif

      i_length   = i2-i1+1
      j_length   = j2-j1+1
      k_length   = k2-k1+1
      ij_length  = i_length*j_length
      ijk_length = i_length*j_length*k_length

        do iq = nq1, nq2
!$omp parallel do private(i,j,k,inc,inc1)
          do k = k1, k2
                inc1 = (win%offset_r) + ((iq-nq1)*ijk_length) &
                       + ((k-k1)*ij_length) -i1+1
            do j = j1, j2
                inc = inc1 + (j-j1)*i_length
              do i = i1, i2
                q(i,j,k,iq) = ga(inc+i)
              enddo
            enddo
          enddo
        enddo

!EOC
      end subroutine Ga_Get4d_i4
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_Broadcast_r8 --- Broadcast an real*8 1d global array
!
! !INTERFACE:
        subroutine Ga_Broadcast_r8 ( q, isize )
! !INPUT PARAMETERS:
        integer, intent(in)  :: isize
! !OUTPUT PARAMETERS:
        real(r8), intent(inout) :: q(isize)
!
! !DESCRIPTION:
!
!	Broadcast an real*8 1d global array.
!
! !REVISION HISTORY:
!    03.04.02	Putman
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
        integer i
#if defined(USE_SHMEM)
#if defined(OSF1)
        integer(kind=8) p, tmpsize, mysize, mydisp
#else
        integer p, tmpsize, mysize, mydisp
#endif
#endif

      if( no_mod_comm )return
#if defined(USE_SHMEM)
        mysize = isize
	call mp_barrier
        do i=1,mysize
           ga_r8_s(i) = q(i)
        enddo
	call SHMEM_BROADCAST64(ga_r8_r, ga_r8_s, mysize, 0, 0, 0, numpro, bcast_sync)
	if (gid /= 0) then
	do i=1,isize
           q(i) = ga_r8_r(i)
	enddo
	endif
#endif
#if !defined(USE_SHMEM)
      call MPI_BCAST(q, isize, mp_r8, 0, commglobal, ierror)
#endif

!EOC
      end subroutine Ga_Broadcast_r8
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_Broadcast_r4 --- Broadcast an real*4 1d global array
!
! !INTERFACE:
      subroutine Ga_Broadcast_r4 ( q, isize )
! !INPUT PARAMETERS:
      integer, intent(in)  :: isize
! !OUTPUT PARAMETERS:
      real(r4), intent(inout) :: q(isize)
!
! !DESCRIPTION:
!
!	Broadcast an real*4 1d global array.
!
! !REVISION HISTORY:
!    03.04.02	Putman
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
        integer i
#if defined(USE_SHMEM)
#if defined(OSF1)
        integer(kind=8) mysize
#else
        integer mysize
#endif
#endif

      if( no_mod_comm )return
#if defined(USE_SHMEM)
	mysize = isize
	call mp_barrier
        do i=1,mysize
           ga_r4_s(i) = q(i)
        enddo
	call SHMEM_BROADCAST32(ga_r4_r, ga_r4_s, mysize, 0, 0, 0, numpro, bcast_sync)
	if (gid /= 0) then
	do i=1,isize
           q(i) = ga_r4_r(i)
	enddo
	endif
#endif
#if !defined(USE_SHMEM)
      call MPI_BCAST(q, isize, mp_r4, 0, commglobal, ierror)
#endif

!EOC
      end subroutine Ga_Broadcast_r4
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_Broadcast_i4 --- Broadcast an integer*4 1d global array
!
! !INTERFACE:
      subroutine Ga_Broadcast_i4 ( q, isize )
! !INPUT PARAMETERS:
      integer, intent(in)  :: isize
! !OUTPUT PARAMETERS:
      integer(i4), intent(inout) :: q(isize)
!
! !DESCRIPTION:
!
!	Broadcast an integer*4 1d global array.
!
! !REVISION HISTORY:
!    03.04.02	Putman
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
        integer i
#if defined(USE_SHMEM)
#if defined(OSF1)
        integer(kind=8) mysize
#else
        integer mysize
#endif
#endif

      if( no_mod_comm )return
#if defined(USE_SHMEM)
	mysize = isize
	call mp_barrier
        do i=1,mysize
           ga_i4_s(i) = q(i)
        enddo
	call SHMEM_BROADCAST32(ga_i4_r, ga_i4_s, mysize, 0, 0, 0, numpro, bcast_sync)
	if (gid /= 0) then
	do i=1,isize
           q(i) = ga_i4_r(i)
	enddo
	endif
#endif
#if !defined(USE_SHMEM)
      call MPI_BCAST(q, isize, mp_i4, 0, commglobal, ierror)
#endif

!EOC
      end subroutine Ga_Broadcast_i4
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_AllToAll_r8 --- All to All of an integer*4 1d global array
!
! !INTERFACE:
        subroutine Ga_AllToAll_r8 ( q, Gsize, Lsize, istart )
! !INPUT PARAMETERS:
        integer, intent(in)  :: Gsize   ! Global size of array
        integer, intent(in)  :: Lsize   ! size of Local portion
        integer, intent(in)  :: istart  ! starting point
! !OUTPUT PARAMETERS:
        real(r8), intent(inout) :: q(Gsize)
!
! !DESCRIPTION:
!
!	All to All of an integer*4 1d global array.
!
! !REVISION HISTORY:
!    03.04.02	Putman
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
        integer n, i
#if defined(USE_SHMEM)
#if defined(OSF1)
        integer(kind=8) my_Lsize
#else
        integer my_Lsize
#endif
#endif

      if( no_mod_comm )return
#if defined(USE_SHMEM)
	my_Lsize = Lsize
	call mp_barrier
        do i=1,Lsize
           ga_r8_s(i) = q(i+istart-1)
        enddo
	call SHMEM_COLLECT8(ga_r8_r, ga_r8_s, my_Lsize, 0, 0, numpro, collect_sync)
	do i=1,Gsize
	   q(i) = ga_r8_r(i)
	enddo
#endif
#if !defined(USE_SHMEM)
        call MPI_ALLGATHER(q(istart), Lsize, mp_r8, q, Lsize, mp_r8, commglobal, ierror)
#endif

!EOC
      end subroutine Ga_AllToAll_r8
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_AllToAll_r4 --- All to All of an integer*4 1d global array
!
! !INTERFACE:
      subroutine Ga_AllToAll_r4 ( q, Gsize, Lsize, istart )
! !INPUT PARAMETERS:
        integer, intent(in)  :: Gsize   ! Global size of array
        integer, intent(in)  :: Lsize   ! size of Local portion
        integer, intent(in)  :: istart  ! starting point
! !OUTPUT PARAMETERS:
        real(r4), intent(inout) :: q(Gsize)
!
! !DESCRIPTION:
!
!	All to All of an integer*4 1d global array.
!
! !REVISION HISTORY:
!    03.04.02	Putman
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
         integer n, i
#if defined(USE_SHMEM)
#if defined(OSF1)
         integer(kind=8) my_Lsize
#else
         integer my_Lsize
#endif
#endif

      if( no_mod_comm )return
#if defined(USE_SHMEM)
	my_Lsize = Lsize
	call mp_barrier
        do i=1,Lsize
           ga_r4_s(i) = q(i+istart-1)
        enddo
	call SHMEM_COLLECT4(ga_r4_r, ga_r4_s, my_Lsize, 0, 0, numpro, collect_sync)
	do i=1,Gsize
	   q(i) = ga_r4_r(i)
	enddo
#endif
#if !defined(USE_SHMEM)
        call MPI_ALLGATHER(q(istart), Lsize, mp_r4, q, Lsize, mp_r4, commglobal, ierror)
#endif

!EOC
      end subroutine Ga_AllToAll_r4
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: Ga_AllToAll_i4 --- All to All of an integer*4 1d global array
!
! !INTERFACE:
        subroutine Ga_AllToAll_i4( q, Gsize, Lsize, istart)
! !INPUT PARAMETERS:
        integer, intent(in)  :: Gsize   ! Global size of array
        integer, intent(in)  :: Lsize   ! size of Local portion
        integer, intent(in)  :: istart  ! starting point
! !OUTPUT PARAMETERS:
        integer(i4), intent(inout) :: q(Gsize)
!
! !DESCRIPTION:
!
!	All to All of an integer*4 1d global array.
!
! !REVISION HISTORY:
!    03.04.02	Putman
!
!EOP
!------------------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
        integer n, i
#if defined(USE_SHMEM)
#if defined(OSF1)
        integer(kind=8) my_Lsize
#else
        integer my_Lsize
#endif
#endif

      if( no_mod_comm )return
#if defined(USE_SHMEM)
	my_Lsize = Lsize
	call mp_barrier
        do i=1,Lsize
           ga_i4_s(i) = q(i+istart-1)
        enddo
	call SHMEM_COLLECT4(ga_i4_r, ga_i4_s, my_Lsize, 0, 0, numpro, collect_sync)
	do i=1,Gsize
	   q(i) = ga_i4_r(i)
	enddo
#endif
#if !defined(USE_SHMEM)
        call MPI_ALLGATHER(q(istart), Lsize, mp_i4, q, Lsize, mp_i4, commglobal, ierror)
#endif

!EOC
      end subroutine Ga_AllToAll_i4
!------------------------------------------------------------------------------


#if defined(USE_MPI_IO)
!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_file_open --- Open a binary file for writing with MPI-IO
!
! !INTERFACE:
      subroutine mp_file_open ( unit, filename )
! !INPUT PARAMETERS:
      character(*), intent(in) :: filename
! !OUTPUT PARAMETERS:
      integer, intent(inout) :: unit
!
! !DESCRIPTION:
!
!     Open a binary file for writing with MPI-IO
!
! !REVISION HISTORY:
!    2002.06.15   Putman
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:

      if( no_mod_comm )return
      call MPI_FILE_OPEN( commglobal, trim(filename),  &
                          MPI_MODE_CREATE+MPI_MODE_WRONLY, &
                          MPI_INFO_NULL, unit, ierror )

!EOC
      end subroutine mp_file_open
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_file_write_at --- Write real*4 data to a binary file with MPI-IO
!
! !INTERFACE:
      subroutine mp_file_write_at ( unit, nrec, g_size, l_size, g_start, qout )
! !INPUT PARAMETERS:
      integer, intent(in) :: unit    ! File unit number
      integer, intent(in) :: nrec    ! Current record number
      integer, intent(in) :: g_size  ! Size of global array being writen
      integer, intent(in) :: l_size  ! Local size of global array this proc is writing
      integer, intent(in) :: g_start ! location in global array this proc writes to
      real(r4), intent(in):: qout(l_size)  ! Local data to be written
!
! !DESCRIPTION:
!
!     Write real*4 data to a binary file with MPI-IO
!
! !REVISION HISTORY:
!    2002.06.15   Putman
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer(MPI_OFFSET_KIND) offset 
      integer io_stat(MPI_STATUS_SIZE)

      if( no_mod_comm )return
      offset = nrec-1
      call MPI_FILE_WRITE_AT( unit, (offset*g_size + g_start)*4, &
                              qout, l_size, MPI_REAL, io_stat, ierror )

!EOC
      end subroutine mp_file_write_at
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!BOP
! !ROUTINE: mp_file_close --- CLose a binary file for writing with MPI-IO
!
! !INTERFACE:
      subroutine mp_file_close ( unit )
! !INPUT PARAMETERS:
      integer, intent(in) :: unit
!
! !DESCRIPTION:
!
!     Close a binary file for writing with MPI-IO
!
! !REVISION HISTORY:
!    2002.06.15   Putman
!
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:

      if( no_mod_comm )return
      call MPI_FILE_CLOSE( unit, ierror )

!EOC
      end subroutine mp_file_close
!------------------------------------------------------------------------------
#endif

#endif

end module mod_comm

module land_utils_mod

use land_tile_mod, only : land_tile_type, land_tile_enum_type, land_tile_list_type, &
     first_elmt, tail_elmt, next_elmt, operator(/=), get_elmt_indices, current_tile

implicit none
private
! ==== public interfaces =====================================================
public :: put_to_tiles_r0d_fptr
public :: put_to_tiles_r1d_fptr
! ==== end of public interfaces ==============================================

! ==== module constants ======================================================
character(len=*), parameter :: &
     version = '$Id: land_utils.F90,v 17.0 2009/07/21 03:02:46 fms Exp $', &
     tagname = '$Name: tikal $'

contains

! ============================================================================
subroutine put_to_tiles_r0d_fptr(x2d, tile_map, fptr)
  real, intent(in)                         :: x2d     (:,:)
  type(land_tile_list_type), intent(inout) :: tile_map(:,:)
  ! subroutine returning the pointer to the tile data
  interface
     subroutine fptr(tile, ptr)
       use land_tile_mod, only : land_tile_type
       type(land_tile_type), pointer :: tile ! input
       real                , pointer :: ptr  ! returned pointer to the data
     end subroutine fptr 
  end interface

  integer :: i,j
  type(land_tile_enum_type)     :: te,ce   ! tail and current tile list elements
  type(land_tile_type), pointer :: tileptr ! pointer to tile   
  real                , pointer :: ptr     ! pointer to the data element within a tile

  ce = first_elmt( tile_map )
  te = tail_elmt ( tile_map )
  do while(ce /= te)
     call get_elmt_indices(ce,i,j)
     tileptr => current_tile(ce)
     call fptr(tileptr,ptr)
     if (associated(ptr)) ptr=x2d(i,j)
     ce=next_elmt(ce)
  enddo
end subroutine


! ============================================================================
subroutine put_to_tiles_r1d_fptr(x2d, tile_map, fptr)
  real, intent(in)                         :: x2d     (:,:,:)
  type(land_tile_list_type), intent(inout) :: tile_map(:,:)
  ! subroutine returning the pointer to the tile data
  interface
     subroutine fptr(tile, ptr)
       use land_tile_mod, only : land_tile_type
       type(land_tile_type), pointer :: tile ! input
       real                , pointer :: ptr(:) ! returned pointer to the data
     end subroutine fptr 
  end interface

  integer :: i,j
  type(land_tile_enum_type)     :: te,ce   ! tail and current tile list elements
  type(land_tile_type), pointer :: tileptr ! pointer to tile   
  real                , pointer :: ptr(:)  ! pointer to the data element within a tile

  ce = first_elmt( tile_map )
  te = tail_elmt ( tile_map )
  do while(ce /= te)
     call get_elmt_indices(ce,i,j)
     tileptr => current_tile(ce)
     call fptr(tileptr,ptr)
     if (associated(ptr)) ptr(:)=x2d(i,j,:)
     ce=next_elmt(ce)
  enddo
end subroutine

end module land_utils_mod

module fft_mod

! <CONTACT EMAIL="Bruce.Wyman@noaa.gov">
!   Bruce Wyman
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!     Performs simultaneous fast Fourier transforms (FFTs) between
!     real grid space and complex Fourier space.
! </OVERVIEW>

! <DESCRIPTION>
!     This routine computes multiple 1-dimensional FFTs and inverse FFTs.
!     There are 2d and 3d versions between type real grid point space
!     and type complex Fourier space. There are single (32-bit) and
!     full (64-bit) versions.
!
!     On Cray and SGI systems, vendor-specific scientific library
!     routines are used, otherwise a user may choose a NAG library version
!     or stand-alone version using Temperton's FFT.
! </DESCRIPTION>

!-----------------------------------------------------------------------
!these are used to determine hardware/OS/compiler

#ifdef __sgi
#  ifdef _COMPILER_VERSION
!the MIPSPro compiler defines _COMPILER_VERSION
#    define sgi_mipspro
#  else
#    define sgi_generic
#  endif
#endif

!fft uses the SCILIB on SGICRAY, and the NAG library otherwise
#if defined(_CRAY) || defined(sgi_mipspro)
#  define SGICRAY
#endif

use platform_mod, only: R8_KIND, R4_KIND
use      fms_mod, only: write_version_number,  &
                        error_mesg, FATAL
#ifndef SGICRAY
#ifndef NAGFFT
use    fft99_mod, only: fft991, set99
#endif
#endif

implicit none
private

!----------------- interfaces --------------------

public :: fft_init, fft_end, fft_grid_to_fourier, fft_fourier_to_grid

! <INTERFACE NAME="fft_grid_to_fourier">

!   <OVERVIEW>
!     Given multiple sequences of real data values, this routine
!     computes the complex Fourier transform for all sequences.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Given multiple sequences of real data values, this routine
!     computes the complex Fourier transform for all sequences.
!   </DESCRIPTION>
!   <TEMPLATE>
!     fourier = fft_grid_to_fourier ( grid )
!   </TEMPLATE>
!   <IN NAME="grid">
!     Multiple sequence of real data values. The first dimension
!     must be n+1 (where n is the size of a single sequence).
!   </IN>
!   <OUT NAME="fourier">
!     Multiple sequences of transformed data in complex Fourier space.
!     The first dimension must equal n/2+1 (where n is the size
!     of a single sequence). The remaining dimensions must be the
!     same size as the input argument "grid".
!   </OUT>
!   <NOTE>
!     The complex Fourier components are passed in the following format.
!     <PRE>
!        fourier (1)     = cmplx ( a(0), b(0) )
!        fourier (2)     = cmplx ( a(1), b(1) )
!            :              :
!            :              :
!        fourier (n/2+1) = cmplx ( a(n/2), b(n/2) )
!     </PRE>
!   where n = length of each real transform
!   </NOTE>
!   <ERROR MSG="fft_init must be called" STATUS="Error">
!     The initialization routine fft_init must be called before routines
!     fft_grid_to_fourier. 
!   </ERROR>
!   <ERROR MSG="size of first dimension of input data is wrong" STATUS="Error">
!     The real grid point field must have a first dimension equal to n+1
!      (where n is the size of each real transform). This message occurs
!      when using the SGI/Cray fft.
!   </ERROR>
!   <ERROR MSG="length of input data too small" STATUS="Error">
!      The real grid point field must have a first dimension equal to n
!      (where n is the size of each real transform). This message occurs
!      when using the NAG or Temperton fft.
!   </ERROR>
!   <ERROR MSG="float kind not supported for nag fft" STATUS="Error">
!      32-bit real data is not supported when using the NAG fft. You
!      may try modifying this part of the code by uncommenting the
!      calls to the NAG library or less consider using the Temperton fft.
!   </ERROR>
interface fft_grid_to_fourier
  module procedure fft_grid_to_fourier_float_2d, fft_grid_to_fourier_double_2d, &
                   fft_grid_to_fourier_float_3d, fft_grid_to_fourier_double_3d
end interface
! </INTERFACE>

! <INTERFACE NAME="fft_fourier_to_grid">

!   <OVERVIEW>
!     Given multiple sequences of Fourier space transforms,
!     this routine computes the inverse transform and returns
!     the real data values for all sequences.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Given multiple sequences of Fourier space transforms,
!     this routine computes the inverse transform and returns
!     the real data values for all sequences.
!   </DESCRIPTION>
!   <TEMPLATE>
!     grid = fft_fourier_to_grid ( fourier )
!   </TEMPLATE>
!   <IN NAME="fourier">
!     Multiple sequence complex Fourier space transforms.
!     The first dimension must equal n/2+1 (where n is the
!     size of a single real data sequence).
!   </IN>
!   <OUT NAME="grid">
!     Multiple sequence of real data values. The first dimension
!     must be n+1 (where n is the size of a single sequence).
!     The remaining dimensions must be the same size as the input
!     argument "fourier".
!   </OUT>
!   <ERROR MSG="fft_init must be called" STATUS="Error">
!     The initialization routine fft_init must be called before routines fft_fourier_to_grid.
!   </ERROR>
!   <ERROR MSG="size of first dimension of input data is wrong" STATUS="Error">
!      The complex Fourier field must have a first dimension equal to
!      n/2+1 (where n is the size of each real transform). This message
!      occurs when using the SGI/Cray fft. 
!   </ERROR>
!   <ERROR MSG="length of input data too small" STATUS="Error">
!      The complex Fourier field must have a first dimension greater
!      than or equal to n/2+1 (where n is the size of each real
!      transform). This message occurs when using the NAG or Temperton fft. 
!   </ERROR>
!   <ERROR MSG="float kind not supported for nag fft" STATUS="Error">
!      float kind not supported for nag fft 
!      32-bit real data is not supported when using the NAG fft. You
!      may try modifying this part of the code by uncommenting the
!      calls to the NAG library or less consider using the Temperton fft.
!   </ERROR>
interface fft_fourier_to_grid
  module procedure fft_fourier_to_grid_float_2d, fft_fourier_to_grid_double_2d, &
                   fft_fourier_to_grid_float_3d, fft_fourier_to_grid_double_3d
end interface
! </INTERFACE>

!---------------------- private data -----------------------------------

! tables for trigonometric constants and factors
! (not all will be used)
real(R8_KIND), allocatable, dimension(:) :: table8
real(R4_KIND), allocatable, dimension(:) :: table4
real         , allocatable, dimension(:) :: table99
integer      , allocatable, dimension(:) :: ifax

logical :: do_log =.true.
integer :: leng, leng1, leng2, lenc    ! related to transform size

logical :: module_is_initialized=.false.

!  cvs version and tag name
character(len=128) :: version = '$Id$'
character(len=128) :: tagname = '$Name$'

!-----------------------------------------------------------------------
!
!                    WRAPPER FOR FFT
!
!   Provides fast fourier transtorm (FFT) between real grid
!   space and complex fourier space.
!
!   The complex fourier components are passed in the following format.
!
!        fourier (1)     = cmplx ( a(0), b(0) )
!        fourier (2)     = cmplx ( a(1), b(1) )
!            :              :
!            :              :
!        fourier (n/2+1) = cmplx ( a(n/2), b(n/2) )
!
!   where n = length of each real transform
!
!   fft uses the SCILIB on SGICRAY, otherwise the NAG library or
!   a standalone version of Temperton's fft is used
!     SCFFTM and CSFFTM are used on Crays
!     DZFFTM and ZDFFTM are used on SGIs
!   The following NAG routines are used: c06fpf, c06gqf, c06fqf.
!   These routine names may be slightly different on different 
!   platforms.
!
!-----------------------------------------------------------------------

contains

!#######################################################################

! <FUNCTION NAME="fft_grid_to_fourier_float_2d" INTERFACE="fft_grid_to_fourier">
!   <IN NAME="grid" TYPE="real(R4_KIND)" DIM="(:,:)"></IN>
!   <OUT NAME="fourier" TYPE="complex(R4_KIND)" DIM="(lenc,size(grid,2))"> </OUT>

! </FUNCTION>
 function fft_grid_to_fourier_float_2d (grid) result (fourier)

!-----------------------------------------------------------------------

   real   (R4_KIND), intent(in),  dimension(:,:)  :: grid
   complex(R4_KIND), dimension(lenc,size(grid,2)) :: fourier

!-----------------------------------------------------------------------
!
!  input
!  -----
!   grid = Multiple transforms in grid point space, the first dimension
!          must be n+1 (where n is the size of each real transform).
!
!  returns
!  -------
!    Multiple transforms in complex fourier space, the first dimension
!    must equal n/2+1 (where n is the size of each real transform).
!    The remaining dimensions must be the same size as the input
!    argument "grid".
!
!-----------------------------------------------------------------------
#ifdef SGICRAY
#  ifdef _CRAY
!  local storage for cray fft
   real(R4_KIND), dimension((2*leng+4)*size(grid,2)) :: work
#  else
!  local storage for sgi fft
   real(R4_KIND), dimension(leng2) :: work
#  endif
#else
#  ifdef NAGFFT
!  local storage for nag fft
   real(R4_KIND), dimension(size(grid,2),leng) :: data, work
#  else
!  local storage for temperton fft
   real, dimension(leng2,size(grid,2)) :: data
   real, dimension(leng1,size(grid,2)) :: work
#  endif   
#endif   

#if defined(SGICRAY) || defined(NAGFFT)
   real(R4_KIND) :: scale
#endif
   integer :: j, k, num, len_grid

!-----------------------------------------------------------------------

      if (.not.module_is_initialized) &
        call error_handler ('fft_grid_to_fourier',  &
                            'fft_init must be called.')

!-----------------------------------------------------------------------

      len_grid = size(grid,1)
#ifdef SGICRAY
      if (len_grid /= leng1) call error_handler ('fft_grid_to_fourier',  &
                        'size of first dimension of input data is wrong')
#else
      if (len_grid < leng) call error_handler ('fft_grid_to_fourier',  &
                                   'length of input data too small.')
#endif
!-----------------------------------------------------------------------
!----------------transform to fourier coefficients (+1)-----------------

      num   = size(grid,2)    ! number of transforms

#ifdef SGICRAY
!  Cray/SGI fft
      scale = 1./real(leng)
#  ifdef _CRAY
      call scfftm (-1,leng,num,scale, grid,leng1, fourier,lenc,  &
                   table4, work, 0)
#  else
      call scfftm (-1,leng,num,scale, grid,leng1, fourier,lenc,  &
                   table4, work, 0)
#  endif
#else
#  ifdef NAGFFT
!  NAG fft
!  will not allow float kind for NAG
      call error_handler ('fft_grid_to_fourier',  &
                          'float kind not supported for nag fft')
      do j=1,size(grid,2)
         data(j,1:leng) = grid(1:leng,j)
      enddo
      scale = 1./sqrt(float(leng))
      data = data * scale
      fourier(1,:) = cmplx( data(:,1), 0. )
      do k=2,lenc-1
         fourier(k,:) = cmplx( data(:,k), data(:,leng-k+2) )
      enddo
      fourier(lenc,:) = cmplx( data(:,lenc), 0. )
#  else
!  Temperton fft
      do j=1,num
        data(1:leng,j) = grid(1:leng,j)
      enddo
      call fft991 (data,work,table99,ifax,1,leng2,leng,num,-1)
      do j=1,size(grid,2)
      do k=1,lenc
        fourier(k,j) = cmplx( data(2*k-1,j), data(2*k,j) )
      enddo
      enddo
#  endif
#endif
!-----------------------------------------------------------------------

 end function fft_grid_to_fourier_float_2d

!#######################################################################

! <FUNCTION NAME="fft_fourier_to_grid_float_2d" INTERFACE="fft_fourier_to_grid">
!   <IN NAME="fourier" TYPE="real(R4_KIND)" DIM="(:,:)"></IN>
!   <OUT NAME="grid" TYPE="complex(R4_KIND)" DIM="(leng1,size(fourier,2))"> </OUT>

! </FUNCTION>
 function fft_fourier_to_grid_float_2d (fourier) result (grid)

!-----------------------------------------------------------------------

   complex(R4_KIND),  intent(in),  dimension(:,:)     :: fourier
   real   (R4_KIND), dimension(leng1,size(fourier,2)) :: grid

!-----------------------------------------------------------------------
!
!  input
!  -----
!  fourier = Multiple transforms in complex fourier space, the first 
!            dimension must equal n/2+1 (where n is the size of each
!            real transform).
!
!  returns
!  -------
!    Multiple transforms in grid point space, the first dimension
!    must be n+1 (where n is the size of each real transform).
!    The remaining dimensions must be the same size as the input
!    argument "fourier".
!
!-----------------------------------------------------------------------
#ifdef SGICRAY
#  ifdef _CRAY
!  local storage for cray fft
   real(R4_KIND), dimension((2*leng+4)*size(fourier,2)) :: work
#  else
!  local storage for sgi fft
   real(R4_KIND), dimension(leng2) :: work
#  endif
#else
#  ifdef NAGFFT
!  local storage for nag fft
   real(R4_KIND), dimension(size(fourier,2),leng) :: data, work
#  else
!  local storage for temperton fft
   real, dimension(leng2,size(fourier,2)) :: data
   real, dimension(leng1,size(fourier,2)) :: work
#  endif   
#endif   

#if defined(SGICRAY) || defined(NAGFFT)
   real(R4_KIND) :: scale
#endif
   integer :: j, k, num, len_fourier

!-----------------------------------------------------------------------

   if (.not.module_is_initialized) &
      call error_handler ('fft_grid_to_fourier',  &
                          'fft_init must be called.')

!-----------------------------------------------------------------------

      len_fourier = size(fourier,1)
      num         = size(fourier,2)    ! number of transforms

#ifdef SGICRAY
      if (len_fourier /= lenc) call error_handler ('fft_fourier_to_grid', &
               'size of first dimension of input data is wrong')
#else
      if (len_fourier < lenc) call error_handler ('fft_fourier_to_grid',  &
                               'length of input data too small.')
#endif
!-----------------------------------------------------------------------
!----------------inverse transform to real space (-1)-------------------

#ifdef SGICRAY
!  Cray/SGI fft
      scale = 1.0
#  ifdef _CRAY
      call csfftm (+1,leng,num,scale, fourier,len_fourier,  &
                     grid,leng1, table4, work, 0)
#  else
      call csfftm (+1,leng,num,scale, fourier,len_fourier,  &
                     grid,leng1, table4, work, 0)
#  endif
#else
#  ifdef NAGFFT
!  NAG fft
!  will not allow float kind for nag
      call error_handler ('fft_fourier_to_grid',  &
                          'float kind not supported for nag fft')

  ! save input complex array in real format (herm.)
      do k=1,lenc
         data(:,k) = real(fourier(k,:))
      enddo
      do k=2,lenc-1
         data(:,leng-k+2) = aimag(fourier(k,:))
      enddo

  ! scale and transpose data
      scale = sqrt(real(leng))
      do j=1,num
         grid(1:leng,j) = data(j,1:leng)*scale
      enddo
#  else
!  Temperton fft
      do j=1,num
      do k=1,lenc
         data(2*k-1,j) = real (fourier(k,j))
         data(2*k  ,j) = aimag(fourier(k,j))
      enddo
      enddo
      call fft991 (data,work,table99,ifax,1,leng2,leng,num,+1)
      do j=1,num
         grid(1:leng,j) = data(1:leng,j)
      enddo
#  endif
#endif

!-----------------------------------------------------------------------

 end function fft_fourier_to_grid_float_2d

!#######################################################################
! <FUNCTION NAME="fft_grid_to_fourier_double_2d" INTERFACE="fft_grid_to_fourier">
!   <IN NAME="grid" TYPE="real(R8_KIND)" DIM="(:,:)"></IN>
!   <OUT NAME="fourier" TYPE="complex(R8_KIND)" DIM="(lenc,size(grid,2))"> </OUT>

! </FUNCTION>
 function fft_grid_to_fourier_double_2d (grid) result (fourier)

!-----------------------------------------------------------------------

   real   (R8_KIND), intent(in),  dimension(:,:)  :: grid
   complex(R8_KIND), dimension(lenc,size(grid,2)) :: fourier

!-----------------------------------------------------------------------
!
!  input
!  -----
!   grid = Multiple transforms in grid point space, the first dimension
!          must be n+1 (where n is the size of each real transform).
!
!  returns
!  -------
!    Multiple transforms in complex fourier space, the first dimension
!    must equal n/2+1 (where n is the size of each real transform).
!    The remaining dimensions must be the same size as the input
!    argument "grid".
!
!-----------------------------------------------------------------------
#ifdef SGICRAY
#  ifdef _CRAY
!  local storage for cray fft
   real(R8_KIND), dimension((2*leng+4)*size(grid,2)) :: work
#  else
!  local storage for sgi fft
   real(R8_KIND), dimension(leng2) :: work
#  endif
#else
#  ifdef NAGFFT
!  local storage for nag fft
   real(R8_KIND), dimension(size(grid,2),leng) :: data, work
#  else
!  local storage for temperton fft
   real, dimension(leng2,size(grid,2)) :: data
   real, dimension(leng1,size(grid,2)) :: work
#  endif   
#endif   

#if defined(SGICRAY) || defined(NAGFFT)
   real(R8_KIND) :: scale
#endif
   integer :: j, k, num, len_grid
#ifdef NAGFFT
   integer :: ifail
#endif

!-----------------------------------------------------------------------

      if (.not.module_is_initialized) &
        call error_handler ('fft_grid_to_fourier',  &
                            'fft_init must be called.')

!-----------------------------------------------------------------------

      len_grid = size(grid,1)
#ifdef SGICRAY
      if (len_grid /= leng1) call error_handler ('fft_grid_to_fourier',  &
                        'size of first dimension of input data is wrong')
#else
      if (len_grid < leng) call error_handler ('fft_grid_to_fourier',  &
                                   'length of input data too small.')
#endif
!-----------------------------------------------------------------------
!----------------transform to fourier coefficients (+1)-----------------

      num   = size(grid,2)    ! number of transforms
#ifdef SGICRAY
!  Cray/SGI fft
      scale = 1./float(leng)
#  ifdef _CRAY
      call scfftm (-1,leng,num,scale, grid,leng1, fourier,lenc,  &
                   table8, work, 0)
#  else
      call dzfftm (-1,leng,num,scale, grid,leng1, fourier,lenc,  &
                   table8, work, 0)
#  endif
#else
#  ifdef NAGFFT
!  NAG fft
      do j=1,size(grid,2)
         data(j,1:leng) = grid(1:leng,j)
      enddo
      call c06fpf ( num, leng, data, 's', table8, work, ifail )
      scale = 1./sqrt(float(leng))
      data = data * scale
      fourier(1,:) = cmplx( data(:,1), 0. )
      do k=2,lenc-1
         fourier(k,:) = cmplx( data(:,k), data(:,leng-k+2) )
      enddo
      fourier(lenc,:) = cmplx( data(:,lenc), 0. )
#  else
!  Temperton fft
      do j=1,num
        data(1:leng,j) = grid(1:leng,j)
      enddo
      call fft991 (data,work,table99,ifax,1,leng2,leng,num,-1)
      do j=1,size(grid,2)
      do k=1,lenc
        fourier(k,j) = cmplx( data(2*k-1,j), data(2*k,j) )
      enddo
      enddo
#  endif
#endif
!-----------------------------------------------------------------------

 end function fft_grid_to_fourier_double_2d

!#######################################################################

! <FUNCTION NAME="fft_fourier_to_grid_double_2d" INTERFACE="fft_fourier_to_grid">
!   <IN NAME="fourier" TYPE="real(R8_KIND)" DIM="(:,:)"></IN>
!   <OUT NAME="grid" TYPE="complex(R8_KIND)" DIM="(leng1,size(fourier,2))"> </OUT>

! </FUNCTION>
 function fft_fourier_to_grid_double_2d (fourier) result (grid)

!-----------------------------------------------------------------------

   complex(R8_KIND),  intent(in),  dimension(:,:)     :: fourier
   real   (R8_KIND), dimension(leng1,size(fourier,2)) :: grid

!-----------------------------------------------------------------------
!
!  input
!  -----
!  fourier = Multiple transforms in complex fourier space, the first 
!            dimension must equal n/2+1 (where n is the size of each
!            real transform).
!
!  returns
!  -------
!    Multiple transforms in grid point space, the first dimension
!    must be n+1 (where n is the size of each real transform).
!    The remaining dimensions must be the same size as the input
!    argument "fourier".
!
!-----------------------------------------------------------------------
#ifdef SGICRAY
#  ifdef _CRAY
!  local storage for cray fft
   real(R8_KIND), dimension((2*leng+4)*size(fourier,2)) :: work
#  else
!  local storage for sgi fft
   real(R8_KIND), dimension(leng2) :: work
#  endif
#else
#  ifdef NAGFFT
!  local storage for nag fft
   real(R8_KIND), dimension(size(fourier,2),leng) :: data, work
#  else
!  local storage for temperton fft
   real, dimension(leng2,size(fourier,2)) :: data
   real, dimension(leng1,size(fourier,2)) :: work
#  endif   
#endif   

#if defined(SGICRAY) || defined(NAGFFT)
   real(R8_KIND) :: scale
#endif
   integer :: j, k, num, len_fourier
#ifdef NAGFFT
   integer :: ifail
#endif

!-----------------------------------------------------------------------

      if (.not.module_is_initialized) &
        call error_handler ('fft_grid_to_fourier',  &
                            'fft_init must be called.')

!-----------------------------------------------------------------------

      len_fourier = size(fourier,1)
      num         = size(fourier,2)    ! number of transforms

#ifdef SGICRAY
      if (len_fourier /= lenc) call error_handler ('fft_fourier_to_grid', &
               'size of first dimension of input data is wrong')
#else
      if (len_fourier < lenc) call error_handler ('fft_fourier_to_grid',  &
                               'length of input data too small.')
#endif
!-----------------------------------------------------------------------
!----------------inverse transform to real space (-1)-------------------

#ifdef SGICRAY
!  Cray/SGI fft
      scale = 1.0
#  ifdef _CRAY
      call csfftm (+1,leng,num,scale, fourier,len_fourier,  &
                     grid,leng1, table8, work, 0)
#  else
      call zdfftm (+1,leng,num,scale, fourier,len_fourier,  &
                     grid,leng1, table8, work, 0)
#  endif
#else
#  ifdef NAGFFT
!  NAG fft

    ! save input complex array in real format (herm.)
      do k=1,lenc
         data(:,k) = real(fourier(k,:))
      enddo
      do k=2,lenc-1
         data(:,leng-k+2) = aimag(fourier(k,:))
      enddo

      call c06gqf ( num, leng, data, ifail )
      call c06fqf ( num, leng, data, 's', table8, work, ifail )

    ! scale and transpose data
      scale = sqrt(real(leng))
      do j=1,num
         grid(1:leng,j) = data(j,1:leng)*scale
      enddo
#  else
!  Temperton fft
      do j=1,num
      do k=1,lenc
         data(2*k-1,j) = real (fourier(k,j))
         data(2*k  ,j) = aimag(fourier(k,j))
      enddo
      enddo
      call fft991 (data,work,table99,ifax,1,leng2,leng,num,+1)
      do j=1,num
         grid(1:leng,j) = data(1:leng,j)
      enddo
#  endif
#endif

!-----------------------------------------------------------------------

 end function fft_fourier_to_grid_double_2d

!#######################################################################
!                   interface overloads
!#######################################################################
! <FUNCTION NAME="fft_grid_to_fourier_float_3d" INTERFACE="fft_grid_to_fourier">
!   <IN NAME="grid" TYPE="real(R4_KIND)" DIM="(:,:,:)"></IN>
!   <OUT NAME="fourier" TYPE="complex(R4_KIND)" DIM="(lenc,size(grid,2),size(grid,3))"> </OUT>

! </FUNCTION>

 function fft_grid_to_fourier_float_3d (grid) result (fourier)

!-----------------------------------------------------------------------
   real   (R4_KIND),    intent(in),  dimension(:,:,:) :: grid
   complex(R4_KIND), dimension(lenc,size(grid,2),size(grid,3)) :: fourier
   integer :: n
!-----------------------------------------------------------------------

    do n = 1, size(grid,3)
      fourier(:,:,n) = fft_grid_to_fourier_float_2d (grid(:,:,n))
    enddo

!-----------------------------------------------------------------------

 end function fft_grid_to_fourier_float_3d

!#######################################################################

! <FUNCTION NAME="fft_fourier_to_grid_float_3d" INTERFACE="fft_fourier_to_grid">
!   <IN NAME="fourier" TYPE="real(R4_KIND)" DIM="(:,:,:)"></IN>
!   <OUT NAME="grid" TYPE="complex(R4_KIND)" DIM="(leng1,size(fourier,2),size(fourier,3))"> </OUT>

! </FUNCTION>
 function fft_fourier_to_grid_float_3d (fourier) result (grid)

!-----------------------------------------------------------------------
   complex(R4_KIND),  intent(in),  dimension(:,:,:) :: fourier
   real   (R4_KIND), dimension(leng1,size(fourier,2),size(fourier,3)) :: grid
   integer :: n
!-----------------------------------------------------------------------

    do n = 1, size(fourier,3)
      grid(:,:,n) = fft_fourier_to_grid_float_2d (fourier(:,:,n))
    enddo

!-----------------------------------------------------------------------

 end function fft_fourier_to_grid_float_3d

!#######################################################################

! <FUNCTION NAME="fft_grid_to_fourier_double_3d" INTERFACE="fft_grid_to_fourier">
!   <IN NAME="grid" TYPE="real(R8_KIND)" DIM="(:,:,:)"></IN>
!   <OUT NAME="fourier" TYPE="complex(R8_KIND)" DIM="(lenc,size(grid,2),size(grid,3))"> </OUT>

! </FUNCTION>
 function fft_grid_to_fourier_double_3d (grid) result (fourier)

!-----------------------------------------------------------------------
   real   (R8_KIND),    intent(in),  dimension(:,:,:) :: grid
   complex(R8_KIND), dimension(lenc,size(grid,2),size(grid,3)) :: fourier
   integer :: n
!-----------------------------------------------------------------------

    do n = 1, size(grid,3)
      fourier(:,:,n) = fft_grid_to_fourier_double_2d (grid(:,:,n))
    enddo

!-----------------------------------------------------------------------

 end function fft_grid_to_fourier_double_3d

!#######################################################################

! <FUNCTION NAME="fft_fourier_to_grid_double_3d" INTERFACE="fft_fourier_to_grid">
!   <IN NAME="fourier" TYPE="real(R8_KIND)" DIM="(:,:,:)"></IN>
!   <OUT NAME="grid" TYPE="complex(R8_KIND)" DIM="(leng1,size(fourier,2),size(fourier,3))"> </OUT>

! </FUNCTION>
 function fft_fourier_to_grid_double_3d (fourier) result (grid)

!-----------------------------------------------------------------------
   complex(R8_KIND),  intent(in),  dimension(:,:,:) :: fourier
   real   (R8_KIND), dimension(leng1,size(fourier,2),size(fourier,3)) :: grid
   integer :: n
!-----------------------------------------------------------------------

    do n = 1, size(fourier,3)
      grid(:,:,n) = fft_fourier_to_grid_double_2d (fourier(:,:,n))
    enddo

!-----------------------------------------------------------------------

 end function fft_fourier_to_grid_double_3d

!#######################################################################

! <SUBROUTINE NAME="fft_init">

!   <OVERVIEW>
!     This routine must be called to initialize the size of a
!        single transform and setup trigonometric constants.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This routine must be called once to initialize the size of a
!   single transform. To change the size of the transform the
!   routine fft_exit must be called before re-initialing with fft_init.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call fft_init ( n )
!   </TEMPLATE>
!   <IN NAME="n" TYPE="integer" >
!     The number of real values in a single sequence of data.
!        The resulting transformed data will have n/2+1 pairs of
!        complex values.
!   </IN>
 subroutine fft_init (n)

!-----------------------------------------------------------------------
   integer, intent(in) :: n
!-----------------------------------------------------------------------
!
!   n = size (length) of each transform
!
!-----------------------------------------------------------------------
#ifdef SGICRAY
   real   (R4_KIND) ::  dummy4(1)
   complex(R4_KIND) :: cdummy4(1)
   real   (R8_KIND) ::  dummy8(1)
   complex(R8_KIND) :: cdummy8(1)
   integer :: isys(0:1)
#else
#  ifdef NAGFFT
   real(R8_KIND) :: data8(n), work8(n)
   real(R4_KIND) :: data4(n), work4(n)
   integer       :: ifail4, ifail8
#  endif
#endif
!-----------------------------------------------------------------------
!   --- fourier transform initialization ----

!   <ERROR MSG="attempted to reinitialize fft"
!          STATUS="FATAL">
!     You must call fft_exit before calling fft_init for a second time.
!   </ERROR>

      if (module_is_initialized) &
      call error_handler ('fft_init', 'attempted to reinitialize fft')

!  write version and tag name to log file
   if (do_log) then
      call write_version_number (version, tagname)
      do_log = .false.
   endif

!  variables that save length of transform
      leng = n; leng1 = n+1; leng2 = n+2; lenc = n/2+1

#ifdef SGICRAY
#  ifdef _CRAY
!  initialization for cray
!  float kind may not apply for cray
      allocate (table4(100+2*leng), table8(100+2*leng))   ! size may be too large?
      call scfftm (0,leng,1,0.0, dummy4, 1, cdummy4, 1, table4, dummy4, 0)
      call scfftm (0,leng,1,0.0, dummy8, 1, cdummy8, 1, table8, dummy8, 0)
#  else
!  initialization for sgi
      allocate (table4(leng+256), table8(leng+256))
      isys(0) = 1
      call scfftm (0,leng,1,0.0, dummy4, 1, cdummy4, 1, table4, dummy8, isys)
      call dzfftm (0,leng,1,0.0, dummy8, 1, cdummy8, 1, table8, dummy8, isys)
#  endif
#else
#  ifdef NAGFFT
!  initialization for nag fft
      ifail8 = 0
      allocate (table8(100+2*leng))   ! size may be too large?
      call c06fpf ( 1, leng, data8, 'i', table8, work8, ifail8 )

!  will not allow float kind for nag
      ifail4 = 0
!!!!! allocate (table4(100+2*leng))
!!!!! call c06fpe ( 1, leng, data4, 'i', table4, work4, ifail4 )

      if (ifail4 /= 0 .or. ifail8 /= 0) then
          call error_handler ('fft_init', 'nag fft initialization error')
      endif
#  else
!  initialization for Temperton fft
      allocate (table99(3*leng/2+1))
      allocate (ifax(10))
      call set99 ( table99, ifax, leng )
#  endif
#endif

      module_is_initialized = .true.

!-----------------------------------------------------------------------

 end subroutine fft_init
! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="fft_end">

!   <OVERVIEW>
!     This routine is called to unset the transform size and deallocate memory.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This routine is called to unset the transform size and
!   deallocate memory. It can not be called unless fft_init
!   has already been called. There are no arguments.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call fft_end
!   </TEMPLATE>
!   <ERROR MSG="attempt to un-initialize fft that has not been initialized" STATUS="Error">
!     You can not call fft_end unless fft_init has been called.
!   </ERROR>
 subroutine fft_end

!-----------------------------------------------------------------------
!
!   unsets transform size and deallocates memory
!
!-----------------------------------------------------------------------
!   --- fourier transform un-initialization ----

      if (.not.module_is_initialized) &
        call error_handler ('fft_end', &
          'attempt to un-initialize fft that has not been initialized')

      leng = 0; leng1 = 0; leng2 = 0; lenc = 0

      if (allocated(table4))  deallocate (table4)
      if (allocated(table8))  deallocate (table8)
      if (allocated(table99)) deallocate (table99)

      module_is_initialized = .false.

!-----------------------------------------------------------------------

 end subroutine fft_end
! </SUBROUTINE>

!#######################################################################
! wrapper for handling errors

 subroutine error_handler ( routine, message )
 character(len=*), intent(in) :: routine, message

   call error_mesg ( routine, message, FATAL )

!  print *, 'ERROR: ',trim(routine)
!  print *, 'ERROR: ',trim(message)
!  stop 111

 end subroutine error_handler

!#######################################################################

end module fft_mod

#ifdef test_fft
program test
use fft_mod
integer, parameter :: lot = 2
real   , allocatable :: ain(:,:), aout(:,:)
complex, allocatable :: four(:,:)
integer :: i, j, m, n
integer :: ntrans(2) = (/ 60, 90 /)

! test multiple transform lengths
  do m = 1,2

  ! set up input data
    n = ntrans(m)
    allocate (ain(n+1,lot),aout(n+1,lot),four(n/2+1,lot))
    call random_number (ain(1:n,:))
    aout(1:n,:) = ain(1:n,:)

    call fft_init (n)
  ! transform grid to fourier and back
    four = fft_grid_to_fourier (aout)
    aout = fft_fourier_to_grid (four)

  ! print original and transformed
    do j=1,lot
    do i=1,n
      write (*,'(2i4,3(2x,f15.9))') j, i, ain(i,j), aout(i,j), aout(i,j)-ain(i,j)
    enddo
    enddo

    call fft_end
    deallocate (ain,aout,four)
  enddo

end program test
#endif

! <INFO>
!   <REFERENCE>        
!     For the SGI/Cray version refer to the manual pages for
!     DZFFTM, ZDFFTM, SCFFTM, and CSFFTM. 
!   </REFERENCE>
!   <REFERENCE>
!     For the NAG version refer to the NAG documentation for
!     routines C06FPF, C06FQF, and C06GQF. 
!   </REFERENCE>
!   <PRECOMP FLAG="-D NAGFFT">  
!      -D NAGFFT
!      On non-Cray/SGI machines, set to use the NAG library FFT routines.
!      Otherwise the Temperton FFT is used by default.
!   </PRECOMP> 
!   <PRECOMP FLAG="-D test_fft">
!      Provides source code for a simple test program.
!   The program generates several sequences of real data.
!   This data is transformed to Fourier space and back to real data,
!   then compared to the original real data.
!   </PRECOMP>
!   <LOADER FLAG="-lscs">   
!     On SGI machines the scientific library needs to be loaded by
!     linking with:
!   </LOADER>
!   <LOADER FLAG="-L/usr/local/lib -lnag">    
!     If using the NAG library, the following loader options (or
!     something similar) may be necessary:
!   </LOADER>
!   <NOTE>             
!     The routines are overloaded for 2d and 3d versions.
!     The 2d versions copy data into 3d arrays then calls the 3d interface.
!
!     On SGI/Cray machines:
!
!     There are single (32-bit) and full (64-bit) versions.
!     For Cray machines the single precision version does not apply.
!
!     On non-SGI/CRAY machines:
!
!     The NAG library option uses the "full" precision NAG
!     routines (C06FPF,C06FQF,C06GQF). Users may have to specify
!     a 64-bit real compiler option (e.g., -r8).
!
!     The stand-alone Temperton FFT option works for the
!     real precision specified at compile time.
!     If you compiled with single (32-bit) real precision
!     then FFT's cannot be computed at full (64-bit) precision.
!   </NOTE>
! </INFO>

module ocean_diagnostics_mod
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Routine that calls the various numerical diagnostics.
!</OVERVIEW>
!
!<DESCRIPTION>
! Routine that calls the various numerical diagnostics.
! </DESCRIPTION>
!
use diag_manager_mod,        only: need_data
use fms_mod,                 only: open_namelist_file, check_nml_error, close_file, write_version_number
use fms_mod,                 only: FATAL, stdout, stdlog
use mpp_mod,                 only: input_nml_file, mpp_error
use mpp_mod,                 only: mpp_clock_id, mpp_clock_begin, mpp_clock_end, CLOCK_MODULE
use time_manager_mod,        only: time_type, increment_time

use ocean_adv_vel_diag_mod,  only: ocean_adv_vel_diag_init, ocean_adv_vel_diagnostics
use ocean_domains_mod,       only: get_local_indices
use ocean_tracer_diag_mod,   only: ocean_tracer_diag_init, ocean_tracer_diagnostics
use ocean_types_mod,         only: ocean_prog_tracer_type, ocean_diag_tracer_type
use ocean_types_mod,         only: ocean_domain_type, ocean_grid_type
use ocean_types_mod,         only: ocean_adv_vel_type, ocean_velocity_type
use ocean_types_mod,         only: ocean_time_type, ocean_time_steps_type
use ocean_types_mod,         only: ocean_external_mode_type, ocean_density_type
use ocean_types_mod,         only: ocean_thickness_type, ocean_lagrangian_type
use ocean_velocity_diag_mod, only: ocean_velocity_diag_init, ocean_velocity_diagnostics

use ocean_pik_diag_mod,   only: ocean_pik_diag_init, ocean_pik_diagnostics

implicit none

private

#include <ocean_memory.h>

integer :: num_prog_tracers = 0
integer :: index_temp = -1
integer :: index_salt = -1

! for diagnostics clocks 
integer :: id_adv_vel_diag
integer :: id_pik_diag
integer :: id_tracer_diag
integer :: id_velocity_diag

logical :: module_is_initialized = .FALSE.

character(len=128) :: version=&
     '$Id: ocean_diagnostics.F90,v 20.0 2013/12/14 00:12:51 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

public :: ocean_diag_init, ocean_diagnostics

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_diag_init">
!
! <DESCRIPTION>
! Initialize the ocean_diag module.
! </DESCRIPTION>
!
subroutine ocean_diag_init(Grid, Domain, Time, Time_steps, Thickness, T_prog, T_diag, Dens, &
                           vert_coordinate_class, horz_grid, have_obc, cmip_units, use_blobs)

type(ocean_grid_type),        intent(in)    :: Grid
type(ocean_domain_type),      intent(in)    :: Domain
type(ocean_time_type),        intent(in)    :: Time
type(ocean_time_steps_type),  intent(in)    :: Time_steps
type(ocean_thickness_type),   intent(in)    :: Thickness
type(ocean_prog_tracer_type), intent(in)    :: T_prog(:)
type(ocean_diag_tracer_type), intent(in)    :: T_diag(:)
type(ocean_density_type),     intent(inout) :: Dens
integer,                      intent(in)    :: vert_coordinate_class 
integer,                      intent(in)    :: horz_grid 
logical,                      intent(in)    :: have_obc
logical,                      intent(in)    :: cmip_units
logical,                      intent(in)    :: use_blobs

integer :: n

integer :: stdoutunit,stdlogunit 
stdoutunit=stdout();stdlogunit=stdlog() 

module_is_initialized = .TRUE.

call write_version_number(version, tagname)

#ifndef MOM_STATIC_ARRAYS
call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
nk = Grid%nk
#endif

num_prog_tracers = size(T_prog, 1)

do n = 1, num_prog_tracers
   if (trim(T_prog(n)%name) == 'temp') index_temp = n
   if (trim(T_prog(n)%name) == 'salt') index_salt = n
enddo

if (index_temp < 1 .or. index_salt < 1) then 
   call mpp_error(FATAL,'==>Error in ocean_diagnostics_mod (ocean_diag_init): temp and/or salt not in tracer array')
endif 

id_adv_vel_diag  = mpp_clock_id('(Ocean diagnostics: adv_vel)'  ,grain=CLOCK_MODULE)
id_pik_diag      = mpp_clock_id('(Ocean diagnostics: pik_diag)' ,grain=CLOCK_MODULE)
id_tracer_diag   = mpp_clock_id('(Ocean diagnostics: tracer)'   ,grain=CLOCK_MODULE)
id_velocity_diag = mpp_clock_id('(Ocean diagnostics: velocity)' ,grain=CLOCK_MODULE)

call ocean_adv_vel_diag_init (Grid, Domain, Time, Time_steps, T_prog, Dens, horz_grid, cmip_units)
call ocean_pik_diag_init (Grid, Domain, Time)
call ocean_tracer_diag_init  (Grid, Domain, Time, Time_steps, Thickness, T_prog, T_diag, Dens, &
                              vert_coordinate_class, use_blobs, have_obc)
call ocean_velocity_diag_init(Grid, Domain, Time, Time_steps, horz_grid)


end subroutine ocean_diag_init
! </SUBROUTINE>  NAME="ocean_diag_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_diagnostics">
!
! <DESCRIPTION>
! Call some ocean numerical diagnostics 
! </DESCRIPTION>
!
subroutine ocean_diagnostics(Time, Thickness, T_prog, T_diag, Adv_vel,&
                             Ext_mode, Dens, Velocity, &  
                             pme, melt, runoff, calving, visc_cbt, diff_cbt)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness 
  type(ocean_prog_tracer_type),   intent(in)    :: T_prog(:)
  type(ocean_diag_tracer_type),   intent(in)    :: T_diag(:)
  type(ocean_adv_vel_type),       intent(in)    :: Adv_vel
  type(ocean_external_mode_type), intent(in)    :: Ext_mode
  type(ocean_density_type),       intent(inout) :: Dens
  type(ocean_velocity_type),      intent(inout) :: Velocity

  real, dimension(isd:,jsd:),    intent(in) :: pme
  real, dimension(isd:,jsd:),    intent(in) :: melt
  real, dimension(isd:,jsd:),    intent(in) :: runoff
  real, dimension(isd:,jsd:),    intent(in) :: calving
  real, dimension(isd:,jsd:,:),  intent(in) :: visc_cbt
  real, dimension(isd:,jsd:,:,:),intent(in) :: diff_cbt
  
  if (size(T_prog,1) /= num_prog_tracers) then 
     call mpp_error(FATAL, '==>Error from ocean_diagnostics_mod (ocean_diagnostics): wrong size for tracer array')
  endif 

  call mpp_clock_begin(id_adv_vel_diag)
  call ocean_adv_vel_diagnostics(Time, Thickness, Adv_vel, T_prog, Dens, visc_cbt)
  call mpp_clock_end(id_adv_vel_diag)

  call mpp_clock_begin(id_pik_diag)
  call ocean_pik_diagnostics(Time, adv_vel)
  call mpp_clock_end(id_pik_diag)

  call mpp_clock_begin(id_tracer_diag)
  call ocean_tracer_diagnostics(Time, Thickness, T_prog, T_diag, Dens, &
                                Ext_mode, Velocity, Adv_vel, &
                                diff_cbt, pme, melt, runoff, calving)
  call mpp_clock_end(id_tracer_diag)

  call mpp_clock_begin(id_velocity_diag)
  call ocean_velocity_diagnostics(Time, Thickness, Dens, Ext_mode, Velocity, Adv_vel)
  call mpp_clock_end(id_velocity_diag)

end subroutine ocean_diagnostics
! </SUBROUTINE>  NAME="ocean_diagnostics"


end module ocean_diagnostics_mod

#include <fms_platform.h>

module lake_tile_mod

use mpp_domains_mod, only : &
     domain2d, mpp_get_compute_domain, mpp_global_field

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only : &
     write_version_number, file_exist, check_nml_error, &
     read_data, close_file, stdlog
use constants_mod, only : &
     pi, tfreeze, hlf
use land_constants_mod, only : &
     NBANDS
use land_io_mod, only : &
     init_cover_field
use land_tile_selectors_mod, only : &
     tile_selector_type, SEL_LAKE, register_tile_selector

implicit none
private

! ==== public interfaces =====================================================
public :: lake_pars_type
public :: lake_prog_type
public :: lake_tile_type

public :: new_lake_tile, delete_lake_tile
public :: lake_tiles_can_be_merged, merge_lake_tiles
public :: lake_is_selected
public :: get_lake_tile_tag
public :: lake_tile_stock_pe
public :: lake_tile_heat

public :: read_lake_data_namelist
public :: lake_cover_cold_start

public :: lake_data_radiation
public :: lake_data_diffusion
public :: lake_data_thermodynamics

public :: max_lev
public :: lake_width_inside_lake
public :: large_lake_sill_width
! =====end of public interfaces ==============================================
interface new_lake_tile
   module procedure lake_tile_ctor
   module procedure lake_tile_copy_ctor
end interface


! ==== module constants ======================================================
character(len=*), private, parameter   :: &
     version     = '$Id: lake_tile.F90,v 20.0 2013/12/13 23:29:39 fms Exp $', &
     tagname     = '$Name: tikal $', &
     module_name = 'lake_tile_mod'

integer, parameter :: max_lev          = 80
integer, parameter :: n_dim_lake_types = 1  ! size of lookup table
real,    parameter :: psi_wilt         = -150.  ! matric head at wilting
real,    parameter :: comp             = 0.001  ! m^-1

! from the modis brdf/albedo product user's guide:
real            :: g_iso  = 1.
real            :: g_vol  = 0.189184
real            :: g_geo  = -1.377622
real            :: g0_iso = 1.0
real            :: g1_iso = 0.0
real            :: g2_iso = 0.0
real            :: g0_vol = -0.007574
real            :: g1_vol = -0.070987
real            :: g2_vol =  0.307588
real            :: g0_geo = -1.284909
real            :: g1_geo = -0.166314
real            :: g2_geo =  0.041840

! ==== types =================================================================
type :: lake_pars_type
  real w_sat
  real awc_lm2
  real k_sat_ref
  real psi_sat_ref
  real chb
  real alpha              ! *** REPLACE LATER BY alpha(layer)
  real heat_capacity_ref
  real thermal_cond_ref
  real refl_dry_dir(NBANDS)
  real refl_dry_dif(NBANDS)
  real refl_sat_dir(NBANDS)
  real refl_sat_dif(NBANDS)
  real emis_dry
  real emis_sat
  real z0_momentum
  real z0_momentum_ice
  real depth_sill
  real width_sill
  real whole_area
  real connected_to_next
  real backwater
  real backwater_1
  real tau_groundwater
  real rsa_exp         ! riparian source-area exponent
end type lake_pars_type

type :: lake_prog_type
  real dz
  real wl
  real ws
  real T
  real K_z
  real groundwater
  real groundwater_T
end type lake_prog_type

type :: lake_tile_type
   integer :: tag ! kind of the lake
   type(lake_prog_type), pointer :: prog(:)
   type(lake_pars_type)          :: pars
   real,                 pointer :: w_fc(:)
   real,                 pointer :: w_wilt(:)
   real :: Eg_part_ref
   real :: z0_scalar
   real :: z0_scalar_ice
   real :: geothermal_heat_flux
   real, pointer :: e(:),f(:)
   real, pointer :: heat_capacity_dry(:)
end type lake_tile_type

! ==== module data ===========================================================
real, public :: &
     cpw = 1952.0, & ! specific heat of water vapor at constant pressure
     clw = 4218.0, & ! specific heat of water (liquid)
     csw = 2106.0    ! specific heat of water (ice)

!---- namelist ---------------------------------------------------------------
real    :: lake_width_inside_lake = 1.e5
real    :: large_lake_sill_width = 200.
real    :: min_lake_frac         = 0.
real    :: max_lake_rh           = 1.
real    :: lake_rh_exp           = 1.
real    :: dry_lake_depth_frac   = 0.
real    :: k_over_B              = 0.25      ! reset to 0 for MCM
real    :: k_over_B_ice          = 0.25
real    :: rate_fc               = 0.1/86400 ! 0.1 mm/d drainage rate at FC
real    :: sfc_heat_factor       = 1
real    :: geothermal_heat_flux_constant = 0.0  ! true continental average is ~0.065 W/m2
integer, public :: num_l         = 18           ! number of lake levels
integer, public :: n_outlet      = 0
logical :: use_lm2_awc           = .false.
logical, public :: lake_specific_width    = .false.
integer :: n_map_1st_lake_type = 10
  
integer, public :: outlet_face(100)
integer, public :: outlet_i(100)
integer, public :: outlet_j(100)
real, public :: outlet_width(100)

! from analysis of modis data (ignoring temperature dependence):
  real :: f_iso_ice(NBANDS) = (/ 0.056, 0.131 /)
  real :: f_vol_ice(NBANDS) = (/ 0.017, 0.053 /)
  real :: f_geo_ice(NBANDS) = (/ 0.004, 0.010 /)
  real :: f_iso_liq(NBANDS) = (/ 0.056, 0.131 /)
  real :: f_vol_liq(NBANDS) = (/ 0.017, 0.053 /)
  real :: f_geo_liq(NBANDS) = (/ 0.004, 0.010 /)
  real :: refl_ice_dif(NBANDS), refl_liq_dif(NBANDS)

! ---- remainder are used only for cold start ---------
logical :: round_frac_down       = .false.  ! when false, any lake_frac < min_lake_frac
                                            ! is set to min_lake_frac.
                                            ! when true, any lake_frac < min_lake_frac
                                            ! is set to 0.
                                            
character(len=16):: lake_to_use     = 'single-tile'
       ! 'multi-tile' for tiled soil [default]
       ! 'single-tile' for geographically varying soil with single type per
       !     model grid cell
       ! 'uniform' for global constant soil, e.g., to reproduce MCM
       ! 'from-rivers' to get the fraction of lakes from river module
logical :: use_single_lake       = .false.   ! true for single global lake,
                                             ! e.g., to recover MCM
logical :: use_mcm_albedo        = .false.   ! .true. for CLIMAP albedo inputs
logical :: use_single_geo        = .false.   ! .true. for global gw res time,
                                             ! e.g., to recover MCM
integer :: lake_index_constant   = 1         ! index of global constant lake,
                                             ! used when use_single_lake
real    :: gw_res_time           = 60.*86400 ! mean groundwater residence time,
                                             ! used when use_single_geo
real    :: rsa_exp_global        = 1.5
real, dimension(n_dim_lake_types) :: &
  dat_w_sat             =(/ 1.000   /),&
  dat_awc_lm2           =(/ 1.000   /),&
  dat_k_sat_ref         =(/ 0.021   /),&
  dat_psi_sat_ref       =(/ -.059   /),&
  dat_chb               =(/   3.5   /),&
  dat_heat_capacity_ref =(/ 8.4e7   /),&
  dat_thermal_cond_ref  =(/ 8.4e7   /),&
  dat_emis_dry          =(/ 0.950   /),&
  dat_emis_sat          =(/ 0.980   /),&
  dat_z0_momentum       =(/ 1.4e-4  /),&
  dat_z0_momentum_ice   =(/ 1.4e-4  /),&
  dat_tf_depr           =(/  0.00   /)
real, dimension(n_dim_lake_types, NBANDS) :: &
     dat_refl_dry_dif, dat_refl_dry_dir, &
     dat_refl_sat_dif, dat_refl_sat_dir
data &
                   !  VIS    NIR
  dat_refl_dry_dif / 0.060, 0.060 /, &
  dat_refl_dry_dir / 0.060, 0.060 /, &
  dat_refl_sat_dir / 0.060, 0.060 /, &
  dat_refl_sat_dif / 0.060, 0.060 /
integer, dimension(n_dim_lake_types) :: &
  input_cover_types     =(/ 10 /)
character(len=4), dimension(n_dim_lake_types) :: &
  tile_names            =(/ 'lake' /)

namelist /lake_data_nml/ lake_width_inside_lake, &
     large_lake_sill_width, &
     lake_specific_width, n_outlet, outlet_face, outlet_i, outlet_j, outlet_width, &
     min_lake_frac, round_frac_down, max_lake_rh, lake_rh_exp, &
     dry_lake_depth_frac, &
     lake_to_use,input_cover_types, tile_names, &
     k_over_B, k_over_B_ice,         &
     rate_fc, sfc_heat_factor, geothermal_heat_flux_constant,  &
     num_l, &
     use_lm2_awc,    n_map_1st_lake_type, &
     use_single_lake,           use_mcm_albedo,            &
     use_single_geo,            lake_index_constant,         &
     gw_res_time,            rsa_exp_global,      &
     dat_w_sat,               dat_awc_lm2,     &
     dat_k_sat_ref,            &
     dat_psi_sat_ref,               dat_chb,          &
     dat_heat_capacity_ref,         dat_thermal_cond_ref,   &
     dat_refl_dry_dir,            dat_refl_sat_dir,              &
     dat_refl_dry_dif,            dat_refl_sat_dif,              &
     dat_emis_dry,              dat_emis_sat,                &
     dat_z0_momentum,   dat_z0_momentum_ice,        dat_tf_depr, &
     f_iso_ice, f_vol_ice, f_geo_ice, f_iso_liq, f_vol_liq, f_geo_liq 


!---- end of namelist --------------------------------------------------------

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

! ============================================================================
subroutine read_lake_data_namelist(lake_n_lev)
  integer, intent(out) :: lake_n_lev
  ! ---- local vars
  integer :: unit         ! unit for namelist i/o
  integer :: io           ! i/o status for the namelist
  integer :: ierr         ! error code, returned by i/o routines
  integer :: i
  real    :: z

  call write_version_number(version, tagname)
#ifdef INTERNAL_FILE_NML
     read (input_nml_file, nml=lake_data_nml, iostat=io)
     ierr = check_nml_error(io, 'lake_data_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file()
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=lake_data_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'lake_data_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif
  unit=stdlog()
  write(unit, nml=lake_data_nml)

  ! initialize global module data here

  refl_ice_dif = g_iso*f_iso_ice + g_vol*f_vol_ice + g_geo*f_geo_ice
  refl_liq_dif = g_iso*f_iso_liq + g_vol*f_vol_liq + g_geo*f_geo_liq

  ! register selectors for tile-specific diagnostics
  do i=1, n_dim_lake_types
     call register_tile_selector(tile_names(i), long_name='',&
          tag = SEL_LAKE, idata1 = i )
  enddo

  ! set up output arguments
  lake_n_lev = num_l
end subroutine 


! ============================================================================
function lake_tile_ctor(tag) result(ptr)
  type(lake_tile_type), pointer :: ptr ! return value
  integer, intent(in)           :: tag ! kind of lake

  allocate(ptr)
  ptr%tag = tag
  ! allocate storage for tile data
  allocate(ptr%prog   (num_l),  &
           ptr%w_fc   (num_l),  &
           ptr%w_wilt (num_l),  &
           ptr%heat_capacity_dry(num_l),  &
           ptr%e      (num_l),  &
           ptr%f      (num_l)   )
  call init_lake_data_0d(ptr)

end function lake_tile_ctor


! ============================================================================
function lake_tile_copy_ctor(lake) result(ptr)
  type(lake_tile_type), pointer    :: ptr  ! return value
  type(lake_tile_type), intent(in) :: lake ! tile to copy
  
  allocate(ptr)
  ptr=lake ! copy all non-pointer data
  ! allocate storage for tile data
  allocate(ptr%prog   (num_l),  &
           ptr%w_fc   (num_l),  &
           ptr%w_wilt (num_l),  &
           ptr%heat_capacity_dry(num_l),  &
           ptr%e      (num_l),  &
           ptr%f      (num_l)   )
  ! copy all allocatable data
  ptr%prog(:)   = lake%prog(:)
  ptr%w_fc(:)   = lake%w_fc(:)
  ptr%w_wilt(:) = lake%w_wilt(:)
  ptr%e(:)      = lake%e(:)
  ptr%f(:)      = lake%f(:)
  ptr%heat_capacity_dry(:) = lake%heat_capacity_dry(:)
end function lake_tile_copy_ctor


! ============================================================================
subroutine delete_lake_tile(ptr)
  type(lake_tile_type), pointer :: ptr

  deallocate(ptr%prog, ptr%w_fc, ptr%w_wilt,ptr%heat_capacity_dry, ptr%e, ptr%f)

  deallocate(ptr)
end subroutine delete_lake_tile


subroutine init_lake_data_0d(lake)
  type(lake_tile_type), intent(inout) :: lake

!  real tau_groundwater
!  real rsa_exp         ! riparian source-area exponent

  integer :: k
  k = lake%tag

  lake%pars%w_sat             = dat_w_sat            (k)
  lake%pars%awc_lm2           = dat_awc_lm2          (k)
  lake%pars%k_sat_ref         = dat_k_sat_ref        (k)
  lake%pars%psi_sat_ref       = dat_psi_sat_ref      (k)
  lake%pars%chb               = dat_chb              (k)
  lake%pars%alpha             = 1
  lake%pars%heat_capacity_ref = dat_heat_capacity_ref(k)
  lake%pars%thermal_cond_ref  = dat_thermal_cond_ref (k)
  lake%pars%refl_dry_dir      = dat_refl_dry_dir     (k,:)
  lake%pars%refl_dry_dif      = dat_refl_dry_dif     (k,:)
  lake%pars%refl_sat_dir      = dat_refl_sat_dir     (k,:)
  lake%pars%refl_sat_dif      = dat_refl_sat_dif     (k,:)
  lake%pars%emis_dry          = dat_emis_dry         (k)
  lake%pars%emis_sat          = dat_emis_sat         (k)
  lake%pars%z0_momentum       = dat_z0_momentum      (k)
  lake%pars%z0_momentum_ice   = dat_z0_momentum_ice  (k)

  lake%pars%tau_groundwater   = 86400.*30.
  lake%pars%rsa_exp           = rsa_exp_global

  ! -------- derived constant lake parameters --------
  ! w_fc (field capacity) set to w at which hydraulic conductivity equals
  ! a nominal drainage rate "rate_fc"
  ! w_wilt set to w at which psi is psi_wilt
  if (use_lm2_awc) then
     lake%w_wilt(:) = 0.15
     lake%w_fc  (:) = 0.15 + lake%pars%awc_lm2
  else
     lake%w_wilt(:) = lake%pars%w_sat &
          *(lake%pars%psi_sat_ref/(psi_wilt*lake%pars%alpha))**(1/lake%pars%chb)
     lake%w_fc  (:) = lake%pars%w_sat &
          *(rate_fc/(lake%pars%k_sat_ref*lake%pars%alpha**2))**(1/(3+2*lake%pars%chb))
  endif

  ! below made use of phi_e from parlange via entekhabi
  lake%Eg_part_ref = (-4*lake%w_fc(1)**2*lake%pars%k_sat_ref*lake%pars%psi_sat_ref*lake%pars%chb &
       /(pi*lake%pars%w_sat)) * (lake%w_fc(1)/lake%pars%w_sat)**(2+lake%pars%chb)   &
       *(2*pi/(3*lake%pars%chb**2*(1+3/lake%pars%chb)*(1+4/lake%pars%chb)))/2

  lake%z0_scalar = lake%pars%z0_momentum * exp(-k_over_B)
  lake%z0_scalar_ice = lake%pars%z0_momentum_ice * exp(-k_over_B_ice)
  lake%geothermal_heat_flux = geothermal_heat_flux_constant

end subroutine 


! ============================================================================
function lake_cover_cold_start(land_mask, lonb, latb, domain) result (lake_frac)
! creates and initializes a field of fractional lake coverage
  logical, intent(in) :: land_mask(:,:)    ! land mask
  real,    intent(in) :: lonb(:,:), latb(:,:)! boundaries of the grid cells
  real,    pointer    :: lake_frac (:,:,:) ! output: map of lake fractional coverage
  type(domain2d), intent(in) :: domain

  allocate( lake_frac(size(land_mask,1),size(land_mask,2),n_dim_lake_types))

  if (trim(lake_to_use)=='from-rivers') then
     lake_frac = 0.0
     call read_data('INPUT/river_data.nc', 'lake_frac', lake_frac(:,:,1), &
          domain=domain)
     ! make sure 'missing values' don't get into the result
     where (lake_frac < 0) lake_frac = 0
     where (lake_frac > 1) lake_frac = 1
  else
     call init_cover_field(lake_to_use, 'INPUT/ground_type.nc', 'cover','frac', &
          lonb, latb, lake_index_constant, input_cover_types, lake_frac)
  endif
  
  if (round_frac_down) then
      where (lake_frac.gt.0. .and. lake_frac.lt.min_lake_frac) lake_frac = 0.
    else
      where (lake_frac.gt.0. .and. lake_frac.lt.min_lake_frac) lake_frac = min_lake_frac
    endif
  
end function 

! =============================================================================
function lake_tiles_can_be_merged(lake1,lake2) result(response)
  logical :: response
  type(lake_tile_type), intent(in) :: lake1,lake2

  response = (lake1%tag==lake2%tag)
end function

! =============================================================================
! combine two lake tiles with specified weights; the results goes into the 
! second one
! THIS NEEDS TO BE REVISED FOR TILE-DEPENDENT DZ
subroutine merge_lake_tiles(t1,w1,t2,w2)
  type(lake_tile_type), intent(in)    :: t1
  type(lake_tile_type), intent(inout) :: t2
  real, intent(in) :: w1, w2 ! relative weights

  ! ---- local vars
  real    :: x1, x2 ! normalized relative weights
  real    :: HEAT1, HEAT2 ! temporaries for heat
  real    :: C1, C2 ! heat capacities
  real    :: gw
  integer :: i

WRITE (*,*) 'SORRY, BUT merge_lake_tiles NEEDS TO BE REVISED TO ALLOW FOR ', &
            'HORIZONTALLY VARYING VERTICAL DISCRETIZATION'

  ! calculate normalized weights
  x1 = w1/(w1+w2)
  x2 = 1.0 - x1

  ! combine state variables
  do i = 1,num_l
    ! calculate "dry" heat capacities:
    C1 = sfc_heat_factor*t1%pars%heat_capacity_ref
    C2 = sfc_heat_factor*t2%pars%heat_capacity_ref
    ! calculate heat content at this level for both source tiles
    HEAT1 = &
    0.
!    (C1*dz(i)+clw*t1%prog(i)%wl+csw*t1%prog(i)%ws) * (t1%prog(i)%T-tfreeze)
    HEAT2 = &
    0.
!    (C2*dz(i)+clw*t2%prog(i)%wl+csw*t2%prog(i)%ws) * (t2%prog(i)%T-tfreeze)
    ! calculate (and assign) combined water mass
    t2%prog(i)%wl = t1%prog(i)%wl*x1 + t2%prog(i)%wl*x2
    t2%prog(i)%ws = t1%prog(i)%ws*x1 + t2%prog(i)%ws*x2
    ! if dry heat capacity of combined lake is to be changed, update it here
    ! ...
    ! calculate combined temperature, based on total heat content and combined
    ! heat capacity
!    t2%prog(i)%T = (HEAT1*x1+HEAT2*x2) / &
!      (C2*dz(i)+clw*t2%prog(i)%wl+csw*t2%prog(i)%ws) + tfreeze
    t2%prog(i)%T = 0.

    ! calculate combined groundwater content
    gw = t1%prog(i)%groundwater*x1 + t2%prog(i)%groundwater*x2
    ! calculate combined groundwater temperature
    if(gw/=0) then
       t2%prog(i)%groundwater_T = ( &
            t1%prog(i)%groundwater*x1*(t1%prog(i)%groundwater_T-tfreeze) + &
            t2%prog(i)%groundwater*x2*(t2%prog(i)%groundwater_T-tfreeze)   &
            ) / gw + Tfreeze
    else
       t2%prog(i)%groundwater_T = &
            x1*t1%prog(i)%groundwater_T + x2*t2%prog(i)%groundwater_T
    endif
    t2%prog(i)%groundwater = gw
  enddo

end subroutine

! =============================================================================
! returns true if tile fits the specified selector
function lake_is_selected(lake, sel)
  logical lake_is_selected
  type(tile_selector_type),  intent(in) :: sel
  type(lake_tile_type),      intent(in) :: lake

  lake_is_selected = (sel%idata1 == lake%tag)
end function


! ============================================================================
! returns tag of the tile
function get_lake_tile_tag(lake) result(tag)
  integer :: tag
  type(lake_tile_type), intent(in) :: lake
  
  tag = lake%tag
end function


! ============================================================================
! compute bare-lake albedos and bare-lake emissivity
subroutine lake_data_radiation ( lake, cosz, use_brdf, &
                                  lake_alb_dir, lake_alb_dif, lake_emis )
  type(lake_tile_type), intent(in)  :: lake
  real,                 intent(in)  :: cosz
  logical,              intent(in)  :: use_brdf
  real,                 intent(out) :: lake_alb_dir(:), lake_alb_dif(:), lake_emis

  ! ---- local vars
  real :: lake_sfc_vlc, blend
  real :: liq_value_dir(NBANDS), ice_value_dir(NBANDS)
  real :: liq_value_dif(NBANDS), ice_value_dif(NBANDS)
  real :: zenith_angle, zsq, zcu

  ! ---- radiation properties
  lake_sfc_vlc = lake%prog(1)%wl/lake%prog(1)%dz
  blend        = lake_sfc_vlc/lake%pars%w_sat
  if (use_brdf) then
      zenith_angle = acos(cosz)
      zsq = zenith_angle*zenith_angle
      zcu = zenith_angle*zsq
      liq_value_dir =  f_iso_liq*(g0_iso+g1_iso*zsq+g2_iso*zcu) &
                     + f_vol_liq*(g0_vol+g1_vol*zsq+g2_vol*zcu) &
                     + f_geo_liq*(g0_geo+g1_geo*zsq+g2_geo*zcu)
      ice_value_dir =  f_iso_ice*(g0_iso+g1_iso*zsq+g2_iso*zcu) &
                     + f_vol_ice*(g0_vol+g1_vol*zsq+g2_vol*zcu) &
                     + f_geo_ice*(g0_geo+g1_geo*zsq+g2_geo*zcu)
      liq_value_dif = refl_liq_dif
      ice_value_dif = refl_ice_dif
    else
      liq_value_dir = lake%pars%refl_sat_dir
      ice_value_dir = lake%pars%refl_dry_dir
      liq_value_dif = lake%pars%refl_sat_dif
      ice_value_dif = lake%pars%refl_dry_dif
    endif
  lake_alb_dir = ice_value_dir + blend*(liq_value_dir-ice_value_dir)
  lake_alb_dif = ice_value_dif + blend*(liq_value_dif-ice_value_dif)
  lake_emis = lake%pars%emis_dry   + blend*(lake%pars%emis_sat-lake%pars%emis_dry  )
end subroutine

! ============================================================================
! compute bare-lake roughness
subroutine lake_data_diffusion ( lake,lake_z0s, lake_z0m )
  type(lake_tile_type), intent(in)  :: lake
  real,                 intent(out) :: lake_z0s, lake_z0m

  ! ---- surface roughness
  if (lake%prog(1)%ws.le.0.) then
      lake_z0s = lake%z0_scalar
      lake_z0m = lake%pars%z0_momentum
    else
      lake_z0s = lake%z0_scalar_ice
      lake_z0m = lake%pars%z0_momentum_ice
    endif
end subroutine

! ============================================================================
! compute lake thermodynamic properties.
subroutine lake_data_thermodynamics ( lake_pars, lake_depth, &
     lake_rh, heat_capacity_dry, thermal_cond)
  type(lake_pars_type), intent(in)  :: lake_pars
  real,                 intent(in)  :: lake_depth
  real,                 intent(out) :: lake_rh
  real,                 intent(out) :: heat_capacity_dry(:)
  real,                 intent(out) :: thermal_cond(:)

  ! ---- local vars
  integer l
  real lake_depth_frac, lake_rh_base

! ----------------------------------------------------------------------------

  lake_depth_frac = (lake_depth/lake_pars%depth_sill)
  lake_rh_base = (lake_depth_frac-dry_lake_depth_frac)/(1.-dry_lake_depth_frac)
  if (lake_rh_base.gt.0.) then
      lake_rh = min(max_lake_rh, lake_rh_base**lake_rh_exp )
    else
      lake_rh = 0.
    endif

  do l = 1, num_l
     heat_capacity_dry(l) = lake_pars%heat_capacity_ref
     thermal_cond(l)  = lake_pars%thermal_cond_ref
  enddo

end subroutine

! ============================================================================
subroutine lake_tile_stock_pe (lake, twd_liq, twd_sol  )
  type(lake_tile_type),  intent(in)    :: lake
  real,                  intent(out)   :: twd_liq, twd_sol
  integer n
  
  twd_liq = 0.
  twd_sol = 0.
  do n=1, size(lake%prog)
    twd_liq = twd_liq + lake%prog(n)%wl + lake%prog(n)%groundwater
    twd_sol = twd_sol + lake%prog(n)%ws
    enddo

end subroutine lake_tile_stock_pe


! ============================================================================
! returns lake tile heat content, J/m2
function lake_tile_heat (lake) result(heat) ; real heat
  type(lake_tile_type),  intent(in)  :: lake

  integer :: i

  heat = 0
  do i = 1, num_l
     heat = heat + &
          (lake%heat_capacity_dry(i)*lake%prog(i)%dz + clw*lake%prog(i)%wl &
	     + csw*lake%prog(i)%ws)*(lake%prog(i)%T-tfreeze) + &
          clw*lake%prog(i)%groundwater*(lake%prog(i)%groundwater_T-tfreeze) - &
          hlf*lake%prog(i)%ws
  enddo
end function

end module lake_tile_mod

                 module esfsw_parameters_mod
!
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  smf
! </REVIEWER>
! <OVERVIEW>
!  Code to initialize shortwave parameters and access flux data.
! </OVERVIEW>
! <DESCRIPTION>
!  This code initializes shortwave radiation calculation parameters such as
!  solar flux input at top of the atmosphere, number of shortwave bands
!  depending on the spectral resolution used, number of frequency points
!  in the gaussian quadrature algorithm, the number of streams used in
!  multiple stream flux algorithm, and the number of water vapor bands.
!
!  The code also provides two access methods: get and put solar flux data
!  
! </DESCRIPTION>

!    shared modules:

use mpp_mod,           only: input_nml_file
use fms_mod,           only: open_namelist_file, fms_init, &
                             mpp_pe, mpp_root_pe, stdlog, &
                             file_exist, write_version_number, &
                             check_nml_error, error_mesg, &
                             FATAL, close_file

!  shared radiation package modules:

use rad_utilities_mod, only: solar_spectrum_type


!--------------------------------------------------------------------

implicit none
private

!-------------------------------------------------------------------
!     esfsw_parameters_mod defines parameters for esf shortwave code,
!     including a description of the band structure  used to define the
!     solar spectrum.
!------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module -------------------

character(len=128)  :: version =  '$Id: esfsw_parameters.F90,v 19.0 2012/01/06 20:16:23 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'

!--------------------------------------------------------------------
!----- interfaces ------

public       &
         esfsw_parameters_init, &
         esfsw_parameters_end

!---------------------------------------------------------------------
!-------- namelist  ---------

character(len=16)  :: sw_resolution = '   ' ! either 'high' or 'low'
integer            :: sw_diff_streams = 0   ! number of streams of
                                            ! diffuse radiation that
                                            ! are considered


namelist /esfsw_parameters_nml/    &
                                 sw_resolution,   &
                                 sw_diff_streams

!-------------------------------------------------------------------
!----- public data --------

!---------------------------------------------------------------------
!    TOT_WVNUMS     number of wavenumbers included in the parameter-
!                   ization of the solar spectrum 
!    Solar_spect    solar_spectrum_type variable defining the nature
!                   of the solar spectral paramaterization
!---------------------------------------------------------------------
integer, parameter                      :: TOT_WVNUMS  = 57600
type(solar_spectrum_type), public, save :: Solar_spect


!-------------------------------------------------------------------
!----- private data --------

logical :: module_is_initialized = .false.  ! module is initialized ?


!---------------------------------------------------------------------
!---------------------------------------------------------------------



                      contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!     
!                     PUBLIC SUBROUTINES
!            
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!#####################################################################
!
! <SUBROUTINE NAME="esfsw_parameters_init">
!  <OVERVIEW>
!   Subroutine that initializes and set up shortwave radiation.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine that initializes shortwave radiation calculation parameters such as
!   solar flux input at top of the atmosphere, number of shortwave bands
!   depending on the spectral resolution used, number of frequency points
!   in the gaussian quadrature algorithm, the number of streams used in
!   multiple stream flux algorithm, and the number of water vapor bands.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call esfsw_parameters_init
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine esfsw_parameters_init

!------------------------------------------------------------------
!    esfsw_parameters_init is the constructor for esfsw_parameters_mod.
!------------------------------------------------------------------

!------------------------------------------------------------------
!  local variables:

      integer    ::  unit, ierr, io, logunit

!---------------------------------------------------------------------
!  local variables:
!
!        unit            io unit number used for namelist file
!        ierr            error code
!        io              error status returned from io operation
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return
 
!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init

!-----------------------------------------------------------------------
!    read namelist.
!-----------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=esfsw_parameters_nml, iostat=io)
      ierr = check_nml_error(io,'esfsw_parameters_nml')
#else   
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=esfsw_parameters_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'esfsw_parameters_nml')
        end do
10      call close_file (unit)
      endif
#endif

!--------------------------------------------------------------------
!    process the namelist entries to obtain the parameters specifying
!    the solar spectral parameterization.
!--------------------------------------------------------------------
      if (trim(sw_resolution) == 'high') then
        Solar_spect%nbands = 25
        Solar_spect%nfrqpts = 72
        Solar_spect%nh2obands = 14
      else if (trim(sw_resolution) == 'low') then
        Solar_spect%nbands = 18
        Solar_spect%nfrqpts = 38
        Solar_spect%nh2obands = 9
      else
        call error_mesg ( 'esfsw_parameters_mod',   &
       ' sw_resolution must be specified as "high" or "low".', FATAL)
      endif
      if (sw_diff_streams == 4) then
        Solar_spect%nstreams = 4
      else if (sw_diff_streams == 1) then
        Solar_spect%nstreams = 1
      else
        call error_mesg ( 'esfsw_parameters_mod',   &
          ' sw_diff_streams must be specified as either 1 or 4.', FATAL)
      endif

!---------------------------------------------------------------------
!    include the total number of wavenumbers in the solar parameter-
!    ization in the solar_spectrum_type variable.
!---------------------------------------------------------------------
      Solar_spect%tot_wvnums = TOT_WVNUMS

!---------------------------------------------------------------------
!    write version number and namelist to logfile also write out
!    some key parameters obtained from an input data file.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) then
        write (logunit,9000)     &
            Solar_spect%NBANDS, Solar_spect%NFRQPTS,  &
            Solar_spect%NSTREAMS, Solar_spect%NH2OBANDS 
        write (logunit, nml=esfsw_parameters_nml)
      endif  

!-------------------------------------------------------------------
!    indicate that visible_band_indx has not yet been defined.
!-------------------------------------------------------------------
      Solar_spect%visible_band_indx = -10000000
      Solar_spect%visible_band_indx_iz = .false.

!-------------------------------------------------------------------
!    indicate that eight70_band_indx has not yet been defined.
!-------------------------------------------------------------------
      Solar_spect%eight70_band_indx = -10000000
      Solar_spect%eight70_band_indx_iz = .false.

!-------------------------------------------------------------------
!    allocate space for the array components of the solar_spect_type
!    variable.
!-------------------------------------------------------------------
      allocate (Solar_spect%solflxband (Solar_spect%nbands) )
      allocate (Solar_spect%solflxbandref (Solar_spect%nbands) )
      allocate (Solar_spect%endwvnbands (0:Solar_spect%nbands) )
      allocate (Solar_spect%solarfluxtoa (Solar_spect%tot_wvnums))

!------------------------------------------------------------------
!    mark the module as initialized.
!------------------------------------------------------------------
      module_is_initialized = .true.

!------------------------------------------------------------------
9000  format ( '  NBANDS=  ', i4, '  NFRQPTS=', i4, &
               '  NSTREAMS= ', i4, '  NH2OBANDS= ', i4 )

!------------------------------------------------------------------


end subroutine esfsw_parameters_init



!####################################################################
!
! <SUBROUTINE NAME="esfsw_parameters_end">
!  <OVERVIEW>
!   Subroutine that is the destructor for esfsw_parameters_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine that deallocates module variables and marks the module  
!   as uninitialized.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call esfsw_parameters_end
!  </TEMPLATE>
! </SUBROUTINE>
!

subroutine esfsw_parameters_end

!--------------------------------------------------------------------
!    esfsw_parameters_end is the destructor for esfsw_parameters_mod.
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('esfsw_parameters_mod',   &
             'module has not been initialized', FATAL )
      endif

!--------------------------------------------------------------------
!    deallocate the components of the solar_spect_type variable.
!---------------------------------------------------------------------
      deallocate (Solar_spect%solflxband, &
                  Solar_spect%solflxbandref, &
                  Solar_spect%endwvnbands, &
                  Solar_spect%solarfluxtoa)

!-------------------------------------------------------------------
!    mark the module as uninitialized.
!--------------------------------------------------------------------
      module_is_initialized = .false.

!--------------------------------------------------------------------

end subroutine esfsw_parameters_end



!###################################################################

      end module esfsw_parameters_mod

module nfu_mod

implicit none
private

! ==== public interfaces =====================================================
public :: nfu_inq_dim, nfu_inq_var, nfu_inq_att
public :: nfu_def_dim, nfu_def_var
public :: nfu_put_att
public :: nfu_get_dim, nfu_get_dim_bounds
public :: nfu_put_var, nfu_put_rec
public :: nfu_get_var, nfu_get_rec

public :: nfu_get_valid_range, nfu_is_valid, nfu_validtype, nfu_validtype2ascii
! ==== end of public interfaces ==============================================

#define __INTERFACE_SECTION__

interface nfu_inq_dim
   module procedure inq_dim_i
   module procedure inq_dim_n
end interface
interface nfu_inq_att
   module procedure inq_att_i_n
   module procedure inq_att_n_n
   module procedure inq_att_i_i
   module procedure inq_att_n_i
end interface
interface nfu_inq_var
   module procedure inq_var_i
   module procedure inq_var_n
end interface
interface nfu_def_dim
   module procedure def_dim_0
   module procedure def_dim_r
   module procedure def_dim_i
end interface
interface nfu_def_var
   module procedure def_var_i, def_var_n, def_var_scalar
end interface
interface nfu_put_att
   module procedure put_att_text_i
   module procedure put_att_text_n
   module procedure put_att_int_i
   module procedure put_att_int_n
end interface

#define F90_TYPE integer
#define NF_TYPE  int
#include "getput.inc"

#define F90_TYPE real(8)
#define NF_TYPE  double
#include "getput.inc"

interface nfu_get_valid_range
   module procedure get_valid_range_i
   module procedure get_valid_range_n
end interface
interface nfu_is_valid
   module procedure nfu_is_valid_i
   module procedure nfu_is_valid_r
end interface
#undef __INTERFACE_SECTION__
! ---- module constants ------------------------------------------------------
character(len=*), parameter :: &
     module_name = 'nf_utils_mod', &
     version     = '$Id: nfu.F90,v 20.0 2013/12/13 23:30:42 fms Exp $', &
     tagname     = '$Name: tikal $'

! ---- module types ----------------------------------------------------------
type nfu_validtype
   private
   logical :: hasmax = .false.
   logical :: hasmin = .false.
!   real(kind=8) :: max=HUGE(max),min=-HUGE(min)
   real(kind=8) :: max=0,min=0
end type

! ---- module variables ------------------------------------------------------
logical :: module_is_initialized =.FALSE.

! ==== NetCDF declarations ===================================================
include 'netcdf.inc'
#define __NF_TRY__(err_code,iret,LABEL)iret=err_code;if(iret/=NF_NOERR)goto LABEL
contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

#define __BODY_SECTION__
! ============================================================================
function inq_dim_n(ncid, name, len, dimid, is_compressed) result (iret)
  integer :: iret
  integer, intent(in) :: ncid
  character(*),intent(in) :: name
  integer, intent(out), optional :: len
  integer, intent(out), optional :: dimid
  logical, intent(out), optional :: is_compressed

  integer :: id,varid,attlen

  __NF_TRY__(nf_inq_dimid(ncid,name, id),iret,7)
  if(present(dimid))dimid = id
  if(present(len)) &
       iret = nf_inq_dimlen(ncid,id,len)
  if (present(is_compressed)) then
     is_compressed = .FALSE.
     if (nf_inq_varid(ncid,name,varid)==NF_NOERR) then
        is_compressed=(nf_inq_attlen(ncid,varid,'compress',attlen)==NF_NOERR)
     endif        
  endif
7 return
end function

! ============================================================================
function inq_dim_i(ncid, id, name, len, is_compressed) result (iret)
  integer :: iret
  integer, intent(in) :: ncid
  integer, intent(in) :: id
  character(*), intent(out), optional :: name
  integer     , intent(out), optional :: len
  logical     , intent(out), optional :: is_compressed

  character(len=NF_MAX_NAME) :: dname
  integer :: varid,attlen

  __NF_TRY__(nf_inq_dimname(ncid,id,dname),iret,7)
  if(present(name)) then
     name=dname
  endif
  if(present(len)) then
     __NF_TRY__(nf_inq_dimlen(ncid,id,len),iret,7)
  end if
  if (present(is_compressed)) then
     is_compressed = .FALSE.
     if (nf_inq_varid(ncid,dname,varid)==NF_NOERR) then
        is_compressed=(nf_inq_attlen(ncid,varid,'compress',attlen)==NF_NOERR)
     endif        
  endif
7 return
end function

! ============================================================================
function inq_var_n(ncid, name, id, xtype, ndims, dimids, dimlens, natts, &
     is_dim, has_records, varsize, recsize, nrec) result(iret)
  integer :: iret
  integer, intent(in) :: ncid
  character(*),intent(in) :: name
  integer, intent(out), optional :: id
  integer, intent(out), optional :: xtype
  integer, intent(out), optional :: ndims
  integer, intent(out), optional :: dimids(:)
  integer, intent(out), optional :: dimlens(:)
  integer, intent(out), optional :: natts
  logical, intent(out), optional :: is_dim ! true if variable is a dimension variable
  logical, intent(out), optional :: has_records ! true if variable depends on record dimension
  integer, intent(out), optional :: varsize ! total size of the variable
  integer, intent(out), optional :: recsize ! size of a single record
  integer, intent(out), optional :: nrec    ! number of records

  integer :: vid
  character(len=NF_MAX_NAME) :: vname

  __NF_TRY__(nf_inq_varid(ncid,name,vid),iret,7)
  if(present(id)) id = vid
  iret = inq_var_i(ncid,vid,vname,xtype,ndims,dimids,dimlens,natts,&
       is_dim,has_records,varsize,recsize,nrec)

7 return  
end function

! ============================================================================
function inq_var_i(ncid, vid, name, xtype, ndims, dimids, dimlens,natts, &
     is_dim, has_records, varsize, recsize, nrec) result(iret)
  integer :: iret
  integer, intent(in) :: ncid
  integer, intent(in) :: vid
  character(*),intent(out), optional :: name
  integer, intent(out), optional :: xtype
  integer, intent(out), optional :: ndims
  integer, intent(out), optional :: dimids(:)
  integer, intent(out), optional :: dimlens(:)
  integer, intent(out), optional :: natts
  logical, intent(out), optional :: is_dim ! true if variable is a dimension variable
  logical, intent(out), optional :: has_records ! true if variable depends on record dimension
  integer, intent(out), optional :: varsize ! total size of the variable
  integer, intent(out), optional :: recsize ! size of a single record
  integer, intent(out), optional :: nrec    ! number of records

  integer :: vxtype, vndims, vdimids(NF_MAX_VAR_DIMS), vnatts
  integer :: vsize, vrecsize
  integer :: unlimdim, did, dlen, i
  character(len=NF_MAX_NAME) :: vname

  __NF_TRY__(nf_inq_var(ncid,vid,vname,vxtype,vndims,vdimids,vnatts),iret,7)
  if (present(name)) name = vname
  if (present(xtype)) xtype = vxtype
  if (present(ndims)) ndims = vndims
  if (present(dimids)) dimids(1:min(vndims,size(dimids))) = &
       vdimids(1:min(vndims,size(dimids)))
  if (present(natts)) natts = vnatts
  if (present(is_dim)) then
     is_dim = (nf_inq_dimid(ncid,vname,did)==NF_NOERR)
  endif
  __NF_TRY__(nf_inq_unlimdim(ncid,unlimdim),iret,7)
  if (present(has_records)) then
     has_records = ANY(vdimids(1:vndims)==unlimdim)
  endif
  if (present(varsize).or.present(recsize).or.present(dimlens)) then
     vsize = 1; vrecsize=1
     do i = 1,vndims
        __NF_TRY__(nf_inq_dimlen(ncid,vdimids(i),dlen),iret,7)
        vsize = vsize*dlen
        if(vdimids(i)/=unlimdim) vrecsize=vrecsize*dlen
        if(present(dimlens)) dimlens(i)=dlen
     enddo
     if(present(varsize)) varsize=vsize
     if(present(recsize)) recsize=vrecsize 
  endif
  if(present(nrec)) then
     nrec=1
     if(unlimdim/=-1.and.ANY(vdimids(1:vndims)==unlimdim)) then
        __NF_TRY__(nf_inq_dimlen(ncid,unlimdim,nrec),iret,7)
     endif
  endif

7 return  
end function

! ============================================================================
function inq_att_i_n(ncid, varid, att, xtype, len, attid) result (iret)
  integer     , intent(in) :: ncid
  integer     , intent(in) :: varid
  character(*), intent(in) :: att
  integer, optional, intent(out) :: xtype
  integer, optional, intent(out) :: len
  integer, optional, intent(out) :: attid
  integer :: iret

  integer :: xtype_, len_

  __NF_TRY__(nf_inq_att(ncid,varid,att,xtype_,len_),iret,7)
  if(present(attid)) then
     __NF_TRY__(nf_inq_attid(ncid,varid,att,attid),iret,7)
  endif
  if(present(xtype)) xtype = xtype_
  if(present(len))   len   = len_
  
7 return
end function

! ============================================================================
function inq_att_n_n(ncid, var, att, xtype, len, attid) result (iret)
  integer     , intent(in) :: ncid
  character(*), intent(in) :: var
  character(*), intent(in) :: att
  integer, optional, intent(out) :: xtype
  integer, optional, intent(out) :: len
  integer, optional, intent(out) :: attid
  integer :: iret


  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid,var,varid),iret,7)
  __NF_TRY__(inq_att_i_n(ncid,varid,att,xtype,len,attid),iret,7)
7 return
end function

! ============================================================================
function inq_att_i_i(ncid, varid, attid, xtype, len, name) result (iret)
  integer, intent(in) :: ncid
  integer, intent(in) :: varid
  integer, intent(in) :: attid
  integer, optional, intent(out) :: xtype
  integer, optional, intent(out) :: len
  character(*), optional, intent(out) :: name
  integer :: iret

  character(NF_MAX_NAME) :: name_

  __NF_TRY__(nf_inq_attname(ncid,varid,attid,name_),iret,7)
  __NF_TRY__(inq_att_i_n(ncid,varid,name_,xtype,len),iret,7)
  if(present(name)) name = name_
7 return
end function

! ============================================================================
function inq_att_n_i(ncid, var, attid, xtype, len, name) result (iret)
  integer, intent(in) :: ncid
  character(*) :: var
  integer, intent(in) :: attid
  integer, optional, intent(out) :: xtype
  integer, optional, intent(out) :: len
  character(*), optional, intent(out) :: name
  integer :: iret

  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid,var,varid),iret,7)
  __NF_TRY__(inq_att_i_i(ncid,varid,attid,xtype,len,name),iret,7)
7 return
end function

! ============================================================================
function def_dim_0(ncid,name,size,xtype,long_name,units,edges,dimid,varid) &
     result (iret)
  integer         , intent(in) :: ncid  ! id of NetCDF file to create 
  character(len=*), intent(in) :: name  ! name of the dimension
  integer         , intent(in) :: size  ! size of the dimension
  integer,optional, intent(in) :: xtype ! external type of the associated variable
  character(len=*), intent(in), optional :: &
       long_name, &
       units,     &
       edges
  integer,optional,intent(out) :: dimid,varid
  integer :: iret

  integer :: did,vid

  iret = nf_redef(ncid)

  did = -1; vid = -1
  __NF_TRY__(nf_def_dim(ncid,name,size,did),iret,7)
  if(present(xtype)) then
     __NF_TRY__(nf_def_var(ncid,name,xtype,1,(/did/),vid),iret,7)
     if (present(long_name)) then
        __NF_TRY__(nfu_put_att(ncid,vid,'long_name',long_name),iret,7)
     endif
     if (present(units)) then
        __NF_TRY__(nfu_put_att(ncid,vid,'units',units),iret,7)
     endif
     if (present(edges)) then
        __NF_TRY__(nfu_put_att(ncid,vid,'edges',edges),iret,7)
     endif
  endif
  if(present(dimid))dimid=did
  if(present(varid))varid=vid
7 return
end function

! ============================================================================
function def_dim_r(ncid,name,data,long_name,units,edges,dimid,varid) result (iret)
  integer :: iret
  integer, intent(in) :: ncid
  character(len=*), intent(in) :: name
  real            , intent(in) :: data(:)
  character(len=*), intent(in), optional :: long_name, units, edges
  integer,optional,intent(out) :: dimid,varid
  
  integer :: vid
  iret = nf_redef(ncid)
  
  __NF_TRY__(def_dim_0(ncid,name,size(data),NF_DOUBLE,long_name,units,edges,dimid,varid=vid),iret,7)
  iret = nf_enddef(ncid)
  iret = nf_put_var_double(ncid,vid,data)
  if(present(varid)) varid = vid
7 return
end function

! ============================================================================
function def_dim_i(ncid,name,data,long_name,units,edges,dimid,varid) result (iret)
  integer :: iret
  integer, intent(in) :: ncid
  character(len=*), intent(in) :: name
  integer         , intent(in) :: data(:)
  character(len=*), intent(in), optional :: long_name, units, edges
  integer,optional,intent(out) :: dimid,varid
  
  integer :: vid
  iret = nf_redef(ncid)
  
  __NF_TRY__(def_dim_0(ncid,name,size(data),NF_INT,long_name,units,edges,dimid,varid=vid),iret,7)
  iret = nf_enddef(ncid)
  iret = nf_put_var_int(ncid,vid,data)
  if(present(varid)) varid = vid
7 return
end function

! ============================================================================
function def_var_n(ncid,name,xtype,dims,long_name,units,varid) result(iret)
  integer         , intent(in) :: ncid
  character(len=*), intent(in) :: name       ! name of the variable
  integer         , intent(in) :: xtype      ! external type of the var
  character(len=*), intent(in) :: &
       dims(:)       ! vector of dimension names 
  character(len=*), intent(in), optional :: &
       long_name, &  ! name of the variable
       units         ! name of the variable
  integer         , intent(out), optional :: &
       varid   ! ID of the defined variable
  integer :: iret

  ! ---- local vars
  integer :: dimc,dimids(NF_MAX_VAR_DIMS)
  integer :: i

  dimc = size(dims)
  do i = 1,dimc
     __NF_TRY__(nf_inq_dimid(ncid,dims(i),dimids(i)),iret,7)
  enddo
  iret=def_var_i(ncid,name,xtype,dimids(1:dimc),long_name,units,varid)

7 return
end function

! ============================================================================
function def_var_scalar(ncid,name,xtype,long_name,units,varid) result(iret)
  integer         , intent(in) :: ncid
  character(len=*), intent(in) :: name       ! name of the variable
  integer         , intent(in) :: xtype      ! external type of the var
  character(len=*), intent(in), optional :: &
       long_name, &  ! name of the variable
       units         ! name of the variable
  integer         , intent(out), optional :: &
       varid   ! ID of the defined variable
  integer :: iret

  ! ---- local vars
  integer :: varid_

  iret = nf_redef(ncid); ! ignore errors here since file can be in define mode already
  __NF_TRY__(nf_def_var(ncid,name,xtype,0,(/1/),varid_),iret,7)
  if(present(varid)) varid = varid_
  if(present(long_name)) then
     __NF_TRY__(nfu_put_att(ncid,varid_,'long_name',long_name),iret,7)
  endif
  if(present(units)) then
     __NF_TRY__(nfu_put_att(ncid,varid_,'units',units),iret,7)
  endif
  
7 return
end function

! ============================================================================
function def_var_i(ncid,name,xtype,dimids,long_name,units,varid) result(iret)
  integer         , intent(in) :: ncid
  character(len=*), intent(in) :: name       ! name of the variable
  integer         , intent(in) :: xtype      ! external type of the var
  integer         , intent(in) :: &
       dimids(:)     ! vector of dimension ids
  character(len=*), intent(in), optional :: &
       long_name, &  ! name of the variable
       units         ! name of the variable
  integer         , intent(out), optional :: &
       varid   ! ID of the defined variable
  integer :: iret

  ! ---- local vars
  integer :: dimc,varid_

  dimc = size(dimids)
  iret = nf_redef(ncid); ! ignore errors here since file can be in define mode already
  __NF_TRY__(nf_def_var(ncid,name,xtype,dimc,dimids,varid_),iret,7)
  if(present(varid)) varid = varid_
  if(present(long_name)) then
     __NF_TRY__(nfu_put_att(ncid,varid_,'long_name',long_name),iret,7)
  endif
  if(present(units)) then
     __NF_TRY__(nfu_put_att(ncid,varid_,'units',units),iret,7)
  endif
  
7 return
end function

! ============================================================================
function put_att_text_i(ncid,varid,name,text) result (iret)
  integer :: iret
  integer         , intent(in) :: ncid,varid
  character(len=*), intent(in) :: name,text
  
  iret = nf_redef(ncid)
  iret = nf_put_att_text(ncid,varid,name,len(text),text)
end function

! ============================================================================
function put_att_text_n(ncid,varname,name,text) result (iret)
  integer :: iret
  integer         , intent(in) :: ncid
  character(len=*), intent(in) :: varname,name,text
  
  integer :: varid
  
  __NF_TRY__(nf_inq_varid(ncid,varname,varid),iret,7)
  iret = nf_redef(ncid)
  iret = nf_put_att_text(ncid,varid,name,len(text),text)
7 return
end function

! ============================================================================
function put_att_int_i(ncid,varid,name,value) result (iret)
  integer :: iret
  integer         , intent(in) :: ncid,varid
  character(len=*), intent(in) :: name
  integer         , intent(in) :: value
  
  iret = nf_redef(ncid)
  iret = nf_put_att_int(ncid,varid,name,NF_INT,1,value)
end function

! ============================================================================
function put_att_int_n(ncid,varname,name,value) result (iret)
  integer :: iret
  integer         , intent(in) :: ncid
  character(len=*), intent(in) :: varname,name
  integer         , intent(in) :: value
  
  integer :: varid
  
  __NF_TRY__(nf_inq_varid(ncid,varname,varid),iret,7)
  iret = nf_redef(ncid)
  iret = nf_put_att_int(ncid,varid,name,NF_INT,1,value)
7 return
end function

! ============================================================================
function nfu_get_dim(ncid, dimid, x) result(iret)
  integer, intent(in) :: ncid,dimid
  real   , intent(out) :: x(:)
  integer :: iret
  
  integer :: varid
  character(len=NF_MAX_NAME) :: name
  
  __NF_TRY__(nf_inq_dimname(ncid,dimid,name),iret,7)
  __NF_TRY__(nf_inq_varid(ncid,name,varid),iret,7)
  __NF_TRY__(nf_get_var_double(ncid,varid,x),iret,7)

7 return
end function

! ============================================================================
function nfu_get_dim_bounds(ncid,dimid,edges)result(iret)
  integer, intent(in) :: ncid,dimid
  real   , intent(out) :: edges(:)
  integer :: iret
    
  ! ---- local vars
  character(len=NF_MAX_NAME) :: name, edges_name
  real    :: x(size(edges)-1)
  integer :: varid, len
  
  __NF_TRY__( nf_inq_dimname(ncid,dimid,name),iret,7 )
  __NF_TRY__( nf_inq_dimlen(ncid,dimid,len),iret,7 )
  __NF_TRY__( nf_inq_varid(ncid,name,varid),iret,7 )
  edges_name = " "
  if (nf_get_att_text(ncid,varid,'edges',edges_name)==NF_NOERR) then
     __NF_TRY__(nf_inq_varid(ncid,edges_name,varid),iret,7)
     __NF_TRY__(nf_get_var_double(ncid,varid,edges),iret,7)
  else
     __NF_TRY__( nf_get_var_double(ncid,varid,x),iret,7 )
     edges(2:len) = (x(1:len-1)+x(2:len))/2
     edges(1) = x(1)-(edges(2)-x(1))
     edges(len+1) = x(len)+(x(len)-edges(len))
  endif
7 return
end function





! ============================================================================
! nfu_get_var interface
! ============================================================================
#define F90_TYPE integer
#define NF_TYPE  int
#include "getput.inc"

#define F90_TYPE real(8)
#define NF_TYPE  double
#include "getput.inc"



function get_valid_range_n(ncid, varname, v) result (iret)
  integer           , intent(in)  :: ncid
  character(*)      , intent(in)  :: varname
  type(nfu_validtype), intent(out) :: v ! validator

  integer :: iret
  integer :: varid

  __NF_TRY__(nfu_inq_var(ncid,varname,id=varid),iret,7)
  iret = get_valid_range_i(ncid, varid, v)

7 return
end function

! ========================================================================
! based on presence/absence of attributes, defines valid range or missing 
! value. For details, see section 8.1 of NetCDF User Guide
function get_valid_range_i(ncid, varid, v) result (iret)
  integer           , intent(in)  :: ncid
  integer           , intent(in)  :: varid
  type(nfu_validtype), intent(out) :: v ! validator

  integer :: iret
  
  integer :: var_T, valid_T, scale_T, T ! types variable and of attributes
  real(kind=8) :: scale, offset, fill, r(2)
  
  ! find the type of the variable
  __NF_TRY__(nfu_inq_var(ncid,varid,xtype=var_T),iret,7)

  ! find the widest type of scale and offset; note that the code
  ! uses assumption that NetCDF types are arranged in th order of rank,
  ! that is NF_BYTE < NF_CHAR < NF_SHORT < NF_INT < NF_FLOAT < NF_DOUBLE
  scale = 1; offset = 0;
  scale_T = 0
  if(nfu_inq_att(ncid,varid,'scale_factor',xtype=T)==NF_NOERR) then
     __NF_TRY__(nf_get_att_double(ncid,varid,'scale_factor',scale),iret,7)
     scale_T = T
  endif
  if(nfu_inq_att(ncid,varid,'add_offset',xtype=T)==NF_NOERR) then
     __NF_TRY__(nf_get_att_double(ncid,varid,'add_offset',offset),iret,7)
     scale_T = max(scale_T,T)
  endif
     
  ! examine possible range attributes
  valid_T = 0; v%hasmax=.false. ; v%hasmin=.false.
  if (nfu_inq_att(ncid,varid,'valid_range',xtype=T)==NF_NOERR) then
     __NF_TRY__(nf_get_att_double(ncid,varid,'valid_range',r),iret,7)
     v%min = r(1)      ; v%max = r(2)
     v%hasmax = .true. ; v%hasmin = .true.
     valid_T = max(valid_T,T)
  else if(nfu_inq_att(ncid,varid,'valid_max',xtype=T)==NF_NOERR) then
     __NF_TRY__(nf_get_att_double(ncid,varid,'valid_max',v%max),iret,7)
     v%hasmax = .true.
     valid_T = max(valid_T,T)
  else if(nfu_inq_att(ncid,varid,'valid_min',xtype=T)==NF_NOERR) then
     __NF_TRY__(nf_get_att_double(ncid,varid,'valid_min',v%min),iret,7)
     v%hasmin = .true.
     valid_T = max(valid_T,T)
  else if(nfu_inq_att(ncid,varid,'missing_value',xtype=T)==NF_NOERR) then
     ! here we always scale, since missing_value is supposed to be in 
     ! external representation
     __NF_TRY__(nf_get_att_double(ncid,varid,'missing_value',v%min),iret,7)
     v%min = v%min*scale + offset
  else
     ! as a last resort, define range based on _FillValue
     ! get fill value and its type: from var, from file, or default
     if(nf_get_att_double(ncid,varid,'_FillValue',fill)/=NF_NOERR) then
        if(nf_get_att_double(ncid,NF_GLOBAL,'_FillValue',fill)/=NF_NOERR) then
           select case(var_T)
           case(NF_CHAR)
              fill = NF_FILL_CHAR
           case(NF_BYTE)
              fill = NF_FILL_BYTE
           case(NF_SHORT)
              fill = NF_FILL_SHORT
           case(NF_INT)
              fill = NF_FILL_INT
           case(NF_REAL)
              fill = NF_FILL_REAL
           case(NF_DOUBLE)
              fill = NF_FILL_DOUBLE
           end select
        endif
     endif
     if(fill>0) then
        ! if _FillValue is positive, then it defines valid maximum
        v%hasmax = .true.
        v%max = fill
        select case(T)
        case (NF_BYTE,NF_CHAR,NF_SHORT,NF_INT)
           v%max = v%max-1
        case (NF_FLOAT)
           v%max = nearest(nearest(real(v%max,4),-1.0),-1.0)
        case (NF_DOUBLE)
           v%max = nearest(nearest(real(v%max,8),-1.0),-1.0)
        end select
     else
        ! if _FillValue is negative or zero, then it defines valid minimum
        v%hasmin = .true.
        v%min = fill
        select case(T)
        case (NF_BYTE,NF_CHAR,NF_SHORT,NF_INT)
           v%min = v%min+1
        case (NF_FLOAT)
           v%min = nearest(nearest(real(v%min,4),+1.0),+1.0)
        case (NF_DOUBLE)
           v%min = nearest(nearest(real(v%min,8),+1.0),+1.0)
        end select
     endif
     ! NOTE: if we go through _FillValue branch, valid_T is 0, so values
     ! are always scaled, as it should be because _FillValue is in external 
     ! representation
  endif
  ! If valid_range is the same type as scale_factor (actually the wider of
  ! scale_factor and add_offset) and this is wider than the external data, then it
  ! will be interpreted as being in the units of the internal (unpacked) data.
  ! Otherwise it is in the units of the external (packed) data.
  if(.not.((valid_T == scale_T).and.(scale_T>var_T))) then
     v%min = v%min*scale + offset
     v%max = v%max*scale + offset
  endif
7 return
end function

! ========================================================================
elemental function nfu_is_valid_r(x, v) result (lret)
  real               , intent(in) :: x ! real value to be examined
  type(nfu_validtype), intent(in) :: v ! validator
  logical :: lret

!  if (x is NaN) then
!     lret = .false.
!  else 
  if (v%hasmin.or.v%hasmax) then
     lret = .not.(((v%hasmin).and.x<v%min).or.((v%hasmax).and.x>v%max))
  else
     lret = (x /= v%min)
  endif
end function

! ========================================================================
elemental function nfu_is_valid_i(x, v) result (lret)
  integer            , intent(in) :: x ! real value to be examined
  type(nfu_validtype), intent(in) :: v ! validator
  logical :: lret
  
  lret = nfu_is_valid_r(real(x),v)
end function

! ========================================================================
function nfu_validtype2ascii(v) result (string)
  character(len=64) :: string
  type(nfu_validtype), intent(in) :: v

  if(v%hasmin.and.v%hasmax) then
     write(string,'("[",g23.16,",",g23.16,"]")') v%min, v%max
  else if (v%hasmin) then
     write(string,'("[",g23.16,")")') v%min
  else if (v%hasmax) then
     write(string,'("(",g23.16,"]")') v%max
  else 
     write(string,'("/=",g23.16)') v%min
  endif
end function

end module nfu_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The algebraic k-equation\label{sec:tkealgebraic}
!
! !INTERFACE:
   subroutine tkealgebraic(nlev,u_taus,u_taub,NN,SS)
!
! !DESCRIPTION:
!  This subroutine computes the turbulent kinetic energy based
!  on \eq{tkeA}, but using the local equilibrium assumption
!  \begin{equation}
!   \label{localEQa}
!     P+G-\epsilon=0
!    \point
!  \end{equation}
! This statement can be re-expressed in the form
!  \begin{equation}
!   \label{localEQb}
!     k= (c_\mu^0)^{-3} \, l^2 ( c_\mu M^2 - c'_\mu N^2 )
!    \comma
!  \end{equation}
!  were we used the expressions in \eq{PandG} together with
!  \eq{fluxes} and \eq{nu}. The rate of dissipaton, $\epsilon$,
!  has been expressed in terms of $l$ via \eq{epsilon}.
!  This equation has been implemented to update $k$ in a diagnostic
!  way. It is possible to compute the value of $k$ as the weighted average
!  of \eq{localEQb} and the value of $k$ at the old timestep. The weighting factor
!  is defined by the {\tt parameter c\_filt}. It is recommended to take this factor
!  small (e.g.\ {\tt c\_filt = 0.2}) in order to reduce the strong oscillations
!  associated with this scheme, and to couple it with an algebraically prescribed
!  length scale with the length scale limitation active ({\tt length\_lim=.true.} in
!  {\tt gotmturb.nml}, see \cite{Galperinetal88}).
!
! !USES:
   use turbulence,   only: tke,tkeo,L,k_min
   use turbulence,   only: cmue2,cde,cmue1,cm0

   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer,  intent(in)                :: nlev

!  surface and bottom
!  friction velocity (m/s)
   REALTYPE, intent(in)                :: u_taus,u_taub

!  square of shear and buoyancy
!  frequency (1/s^2)
   REALTYPE, intent(in)                :: NN(0:nlev),SS(0:nlev)

! !DEFINED PARAMETERS:
   REALTYPE , parameter                :: c_filt=1.0
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard & Karsten Bolding
!
!  $Log: tkealgebraic.F90,v $
!  Revision 20.0  2013/12/14 00:13:52  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:54  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.7  2007-01-06 11:49:15  kbk
!  namelist file extension changed .inp --> .nml
!
!  Revision 1.6  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.5  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.4  2003/03/28 08:29:16  kbk
!  removed tabs
!
!  Revision 1.3  2003/03/10 09:02:05  gotm
!  Added new Generic Turbulence Model + improved documentation and cleaned up code
!
!  Revision 1.2  2002/02/08 08:59:58  gotm
!
!  Revision 1.1.1.1  2001/02/12 15:55:58  gotm
!  initial import into CVS
!
!EOP
!-----------------------------------------------------------------------
!
! !LOCAL VARIABLES:
   integer                   :: i
!
!-----------------------------------------------------------------------
!BOC
!
!  save value at old time step
   tkeo = tke

!  compute new tke as the weighted average of old and new value
   do i=1,nlev-1
      tke(i)= c_filt*( L(i)*L(i)/cde*(cmue1(i)*SS(i)-cmue2(i)*NN(i)) )   &
             + (_ONE_ - c_filt)*tkeo(i)
   end do

!  formally compute BC
   tke(0   ) = u_taub*u_taub/sqrt(cm0*cde)
   tke(nlev) = u_taus*u_taus/sqrt(cm0*cde)


!  clip at k_min
   do i=0,nlev
      tke(i) = max(tke(i),k_min)
   enddo

   return
   end subroutine tkealgebraic
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module ocean_vert_kpp_mom4p0_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> A. Rosati
!</CONTACT>
!
!<REVIEWER EMAIL="wily@ucar.edu"> Bill Large 
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen Griffies 
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> M.J. Harrison 
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">  Hyun-Chul Lee 
!</REVIEWER>
!
!<OVERVIEW>
! Vertical viscosity and diffusivity according KPP using 
! code from MOM4p0, which is hard-wired for full cell 
! GEOPOTENTIAL vertical coordinate model. It remains part of 
! MOM for legacy purposes.  
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes vertical viscosity and diffusivity according to 
! the K-profile parameterization scheme of Large, McWilliams, and 
! Doney (1994). It computes both local and non-local mixing.
!
! This module contains code that is hard-wired for GEOPOTENTIAL coordinates, 
! and so is NOT generally recommended.  It remains part of MOM for 
! legacy purposes. 
!
! This version of KPP has been implemented only for the Bgrid.
!
! This module also adds mixing due to barotropic tide drag 
! (coastal_tide_mix) and baroclinic tides (int_tide_mix). 
! The barotropic (coastal_tides) and baroclinic (int_tides) mixing 
! schemes are directly analogous to those available in the 
! module ocean_vert_tidal.F90.  However, some of the averaging and 
! smoothing operations differ, and so detailed comparisons will show
! differences. We retain the code here, in KPP, for legacy purposes. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! W.G. Large and J.C. McWilliams and S.C. Doney
! Oceanic vertical mixing: A review and a model with
! a nonlocal boundary layer parameterization
! Reviews of Geophysics (1994) vol 32 pages 363-403
! </REFERENCE>
!
! <REFERENCE>
! Hyun-Chul Lee, A. Rosati, and M.J. Spelman
! Barotropic tidal mixing impact in a coupled climate model:
! ocean condition and meridional overturning circulation 
! in the northern Atlantic
! Ocean Modelling, vol 11, pages 464--477
! </REFERENCE>
!
! <NOTE>
! Original numerical algorithm by Bill Large at NCAR June 6, 1994
! </NOTE>
!
! <NOTE>
! Equation numbers in the code refer to the Large etal paper. 
! </NOTE>
!
! <NOTE>
! Surface fresh water contributes to surface buoyancy via conversion to 
! a locally implied salt flux. 
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_vert_kpp_mom4p0_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Logical switch to enable kpp diffusion.  Default is false. 
!  </DATA> 
!
!  <DATA NAME="shear_instability" TYPE="logical">
!  logical switch for shear instability mixing.
!  Default shear_instability=.true.
!  </DATA> 
!  <DATA NAME="double_diffusion" TYPE="logical">
!  Logical switch for double-diffusive mixing.
!  Default double_diffusion=.true.  
!  </DATA> 
!  <DATA NAME="diff_cbt_iw" UNITS="m^2/sec" TYPE="real">
!  Background vertical diffusivity.  Note that if using Bryan-Lewis as a 
!  background diffusivity, then should set diff_cbt_iw=0.0. 
!  </DATA> 
!  <DATA NAME="visc_cbu_iw" UNITS="m^2/sec" TYPE="real">
!  Background vertical viscosity
!  </DATA> 
!  <DATA NAME="visc_cbu_limit" UNITS="m^2/sec" TYPE="real">
!  Enhanced vertical viscosity due to shear instability 
!  </DATA> 
!  <DATA NAME="diff_cbt_limit" UNITS="m^2/sec" TYPE="real">
!  Enhanced vertical diffusivity due to shear instability 
!  </DATA> 
!  <DATA NAME="visc_con_limit" UNITS="m^2/sec" TYPE="real">
!  Enhanced vertical viscosity in regions of convection
!  </DATA> 
!  <DATA NAME="diff_con_limit" UNITS="m^2/sec" TYPE="real">
!  Enhanced vertical diffusivity in regions of convection
!  </DATA> 
!  <DATA NAME="concv" UNITS="dimensionless" TYPE="real">
!  constant for pure convection (eqn. 23 of Large etal)
!  </DATA> 
!  <DATA NAME="Ricr" UNITS="dimensionless" TYPE="real">
!  Critical bulk Richardson number.  Default from NCAR is 
!  0.3, though this number has a large uncertainty and some
!  find that 1.0 can be of use. 
!  </DATA> 
!  <DATA NAME="non_local_kpp" TYPE="logical">
!  logical switch for enabling the non-local mixing aspect of kpp. 
!  Default is .true. as this is what the original KPP scheme suggests. 
!  </DATA> 
!  <DATA NAME="smooth_blmc" TYPE="logical">
!  Smooth boundary layer diffusitivies to remove grid scale noise.
!  Such noise is apparent in the diagnosed mixed layer depth as well
!  as the SST, especially when running coupled models where forcing 
!  has high temporal frequency. 
!  </DATA> 
!
!  <DATA NAME="coastal_tidal_mix" TYPE="logical">
!  For adding an extra vertical shear associated with tidal mixing.
!  This method has found to be of use for mixing near shelves.  
!  </DATA> 
!  <DATA NAME="p_tide" TYPE="real">
!  The p constant in the Munk-Anderson scheme
!  Default p_tide=-0.25
! </DATA> 
!  <DATA NAME="sigma_tide" TYPE="real">
!  The sigma constant in the Munk-Anderson scheme
!  Default sigma_tide=3.0
! </DATA> 
!
!  <DATA NAME="int_tidal_mix" TYPE="logical">
!  For adding an internal tidal mixing over rough topography.
!  This method has found to be of use for mixing in the rough topography in open ocean.  
!  Default int_tidal_mix=.false.
!  </DATA> 
!  <DATA NAME="int_tide_zeta1" TYPE="real" UNITS="metre">
!  Shallow depth for computation of internal tide.
!  Default int_tide_zeta1=300.0
! </DATA> 
!  <DATA NAME="int_tide_zeta2" TYPE="real" UNITS="metre">
!  Deeper depth for computation of internal tide.
!  Default int_tide_zeta2=1800.0
! </DATA> 
!  <DATA NAME="int_tide_min_depth" TYPE="real" UNITS="metre">
!  Minimum depth for internal tide mixing to be computed. 
!  Default int_tide_min_depth=100.0
! </DATA> 
!  <DATA NAME="int_tide_q" TYPE="real" UNITS="dimensionless">
!  Fraction of internal tide energy locally dissipated. 
!  Default int_tide_q=.33333
! </DATA> 
!  <DATA NAME="int_tide_gamma" TYPE="real" UNITS="dimensionless">
!  Dimensionless efficiency for converting energy dissipation to diffusivity.
!  Default int_tide_gamma=0.2
! </DATA> 
!
!  <DATA NAME="wsfc_combine_runoff_calve" TYPE="logical">
!  For computing wsfc as in the mom4p0d code, where we combine
!  the runoff+calving into a single field called river.  
!  The alternative keeps the fields separate, as would be appropriate
!  for a land model that separately tracks the tracer content in the 
!  calving and runoff. 
!  Default wsfc_combine_runoff_calve=.true., as this will recover
!  the previous behaviour, to the bit. 
!  </DATA> 
!
!</NAMELIST>

use constants_mod,    only: epsln
use diag_manager_mod, only: register_diag_field, register_static_field
use fms_mod,          only: FATAL, NOTE, stdout, stdlog
use fms_mod,          only: write_version_number, open_namelist_file, check_nml_error, close_file
use fms_mod,          only: read_data
use mpp_domains_mod,  only: mpp_update_domains, NUPDATE, EUPDATE
use mpp_mod,          only: input_nml_file, mpp_error

use ocean_density_mod,     only: density, density_delta_z, density_delta_sfc
use ocean_domains_mod,     only: get_local_indices
use ocean_parameters_mod,  only: GEOPOTENTIAL, cp_ocean, rho0, rho0r, grav, missing_value
use ocean_types_mod,       only: ocean_grid_type, ocean_domain_type
use ocean_types_mod,       only: ocean_prog_tracer_type, ocean_diag_tracer_type
use ocean_types_mod,       only: ocean_velocity_type, ocean_density_type
use ocean_types_mod,       only: ocean_time_type, ocean_time_steps_type, ocean_thickness_type
use ocean_workspace_mod,   only: wrk1, wrk2, wrk3, wrk4, wrk5
use ocean_util_mod,        only: diagnose_2d, diagnose_3d, diagnose_sum
use ocean_tracer_util_mod, only: diagnose_3d_rho


implicit none

private

public ocean_vert_kpp_mom4p0_init
public vert_mix_kpp_mom4p0

private bldepth
private wscale
private ri_iwmix
private ddmix
private blmix_kpp
private enhance
private ri_for_kpp 
private watermass_diag_init
private watermass_diag 

#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS

real, dimension(isd:ied,jsd:jed)                :: bfsfc      ! surface buoyancy forcing    (m^2/s^3)
real, dimension(isd:ied,jsd:jed)                :: ws         ! scalar velocity scale (m/s)
real, dimension(isd:ied,jsd:jed)                :: wm         ! momentum velocity scale (m/s)
real, dimension(isd:ied,jsd:jed)                :: Ustk2      ! magnitude of surface stokes drift velocity ^2 (m^2 / s^2)
real, dimension(isd:ied,jsd:jed)                :: caseA      ! = 1 in case A; =0 in case B
real, dimension(isd:ied,jsd:jed)                :: stable     ! = 1 in stable forcing; =0 in unstable
real, dimension(isd:ied,jsd:jed,3)              :: dkm1       ! boundary layer diff_cbt at kbl-1 level
real, dimension(isd:ied,jsd:jed,nk,3)           :: blmc       ! boundary layer mixing coefficients
real, dimension(isd:ied,jsd:jed)                :: sigma      ! normalized depth (d / hbl)
real, dimension(isd:ied,jsd:jed)                :: rhosfc     ! potential density of sfc layer(kg/m^3)
real, dimension(isd:ied,jsd:jed,nk)             :: talpha     ! -d(rho)/ d(pot.temperature)  (kg/m^3/C)
real, dimension(isd:ied,jsd:jed,nk)             :: sbeta      ! d(rho)/ d(salinity)       (kg/m^3/PSU)
real, dimension(isd:ied,jsd:jed,nk)             :: alphaDT    ! alpha * DT  across interfaces (kg/m^3)
real, dimension(isd:ied,jsd:jed,nk)             :: betaDS     ! beta  * DS  across interfaces (kg/m^3)
real, dimension(isd:ied,jsd:jed)                :: Bo         ! surface turb buoy. forcing  (m^2/s^3)
real, dimension(isd:ied,jsd:jed)                :: Bosol      ! radiative buoy forcing      (m^2/s^3)
real, dimension(isd:ied,jsd:jed,nk)             :: dbloc      ! local delta buoy at interfaces(m/s^2)
real, dimension(isd:ied,jsd:jed,nk)             :: dbsfc      ! delta buoy w/ respect to sfc  (m/s^2)
real, dimension(isd:ied,jsd:jed,nk)             :: dVsq       ! (velocity shear re sfc)^2   (m/s)^2
real, dimension(isd:ied,jsd:jed,2)              :: Rib        ! Bulk Richardson number
real, dimension(isd:ied,jsd:jed,3)              :: gat1
real, dimension(isd:ied,jsd:jed,3)              :: dat1
real, dimension(isd:ied,jsd:jed)                :: tidal_vel_amp   ! tidal amplitude velocity  (m/s) 
real, dimension(isd:ied,jsd:jed,nk)             :: tidal_fric_turb ! tidal friction            (1/s^2) 

real, dimension(isd:ied,jsd:jed)                :: rough_amp          ! roughness amplitude of topography  (m)
real, dimension(isd:ied,jsd:jed)                :: eflux_int_tide_bf  ! energy flux /buoyancy frequency
real, dimension(isd:ied,jsd:jed,nk)             :: f_int_tide         ! vertical distribution function   

type wsfc_type
  real, dimension(isd:ied,jsd:jed)              :: wsfc        ! rho0r*(stf - pme*(t(i,j,k=1)-tpme) - river*(t(i,j,k=1)-triver))
end type wsfc_type
real, dimension(isd:ied,jsd:jed)                :: sw_frac_hbl ! fractional shortwave penetration at base of mixed layer
integer, dimension(isd:ied,jsd:jed)             :: kbl         ! index of first grid level below hbl

real, private, dimension(isd:ied,jsd:jed,nk)    :: riu         ! Richardson number at base of U-cells
real, private, dimension(isd:ied,jsd:jed,nk)    :: rit         ! Richardson number at base of T-cells
real, private, dimension(isd:ied,jsd:jed,nk)    :: riu_tide    ! Richardson number at base of U-cells due to tidal friction
real, private, dimension(isd:ied,jsd:jed,nk)    :: rit_tide    ! Richardson number at base of T-cells due to tidal friction
real, private, dimension(isd:ied,jsd:jed,nk)    :: ghats       ! nonlocal transport (s/m^2)
real, private, dimension(isd:ied,jsd:jed)       :: hblt        ! boundary layer depth with tmask 
real, private, dimension(isd:ied,jsd:jed)       :: hbl         ! boundary layer depth
real, private, dimension(isd:ied,jsd:jed,nk)    :: bf_int_tide ! Buoyancy frequency in t-point


#else

real, dimension(:,:), allocatable      :: bfsfc    ! surface buoyancy forcing    (m^2/s^3)
real, dimension(:,:), allocatable      :: ws       ! scalar velocity scale (m/s)
real, dimension(:,:), allocatable      :: wm       ! momentum velocity scale (m/s)
real, dimension(:,:), allocatable      :: Ustk2    ! Magnitude of surface stokes drift velocity ^2 (m^2/s^2)
real, dimension(:,:), allocatable      :: caseA    ! = 1 in case A; =0 in case B
real, dimension(:,:), allocatable      :: stable   ! = 1 in stable forcing; =0 in unstable
real, dimension(:,:,:), allocatable    :: dkm1     ! boundary layer diff_cbt at kbl-1 level
real, dimension(:,:,:,:), allocatable  :: blmc     ! boundary layer mixing coefficients
real, dimension(:,:), allocatable      :: sigma    ! normalized depth (d / hbl)
real, dimension(:,:), allocatable      :: rhosfc   ! potential density of sfc layer(kg/m^3)
real, dimension(:,:,:), allocatable    :: talpha   ! -d(rho)/ d(pot.temperature)  (kg/m^3/C)
real, dimension(:,:,:), allocatable    :: sbeta    ! d(rho)/ d(salinity)       (kg/m^3/PSU)
real, dimension(:,:,:), allocatable    :: alphaDT  ! alpha * DT  across interfaces (kg/m^3)
real, dimension(:,:,:), allocatable    :: betaDS   ! beta  * DS  across interfaces (kg/m^3)
real, dimension(:,:), allocatable      :: Bo       ! surface turb buoy. forcing  (m^2/s^3)
real, dimension(:,:), allocatable      :: Bosol    ! radiative buoy forcing      (m^2/s^3)
real, dimension(:,:,:), allocatable    :: dbloc    ! local delta buoy at interfaces(m/s^2)
real, dimension(:,:,:), allocatable    :: dbsfc    ! delta buoy w/ respect to sfc  (m/s^2)
real, dimension(:,:,:), allocatable    :: dVsq     ! (velocity shear re sfc)^2   (m/s)^2
real, dimension(:,:,:), allocatable    :: Rib      ! Bulk Richardson number
real, dimension(:,:,:), allocatable    :: gat1
real, dimension(:,:,:), allocatable    :: dat1

real, dimension(:,:), allocatable      :: tidal_vel_amp   ! tidal amplitude velocity (m/s)
real, dimension(:,:,:), allocatable    :: tidal_fric_turb ! tidal friction           (1/s^2) 

real, dimension(:,:), allocatable      :: rough_amp          ! roughness amplitude of topography  (m)
real, dimension(:,:), allocatable      :: eflux_int_tide_bf  ! energy flux /buoyancy frequency
real, dimension(:,:,:), allocatable    :: f_int_tide         ! vertical distribution function   

type wsfc_type
  real, dimension(:,:), pointer        :: wsfc => NULL()  ! rho0r*(stf - pme*(t(i,j,k=1)-tpme) - river*(t(i,j,k=1)-triver))
end type wsfc_type
real, dimension(:,:), allocatable      :: sw_frac_hbl     ! fractional shortwave penetration at base of mixed layer
integer, dimension(:,:), allocatable   :: kbl             ! index of first grid level below hbl

real, private, dimension(:,:,:), allocatable :: riu         ! Richardson number at base of U-cells
real, private, dimension(:,:,:), allocatable :: rit         ! Richardson number at base of T-cells
real, private, dimension(:,:,:), allocatable :: rit_tide    ! Richardson number at base of T-cells due to tidal friction
real, private, dimension(:,:,:), allocatable :: riu_tide    ! Richardson number at base of U-cells due to tidal friction
real, private, dimension(:,:,:), allocatable :: ghats       ! nonlocal transport (s/m^2)
real, private, dimension(:,:),   allocatable :: hblt        ! boundary layer depth with tmask 
real, private, dimension(:,:),   allocatable :: hbl         ! boundary layer depth
real, private, dimension(:,:,:), allocatable :: bf_int_tide ! Buoyancy frequency in t-point

#endif

type(wsfc_type), dimension(:), allocatable     :: wsfc
real, parameter :: epsilon = 0.1
real, parameter :: vonk    = 0.4
real, parameter :: conc1   = 5.0
real, parameter :: zmin    = -4.e-7  ! m3/s3 limit for lookup table of wm and ws
real, parameter :: zmax    = 0.0     ! m3/s3 limit for lookup table of wm and ws
real, parameter :: umin    = 0.0     ! m/s limit for lookup table of wm and ws
real, parameter :: umax    = 0.04    ! m/s limit for lookup table of wm and ws

real :: Ricr               = 0.3     ! critical bulk Richardson Number
real :: visc_cbu_limit     = 50.0e-4 ! max visc due to shear instability
real :: diff_cbt_limit     = 50.0e-4 ! max diff due to shear instability
real :: visc_con_limit     = 0.1     ! m^2/s. visc due to convective instability
real :: diff_con_limit     = 0.1     ! m^2/s. diff due to convective instability
real :: visc_cbu_iw        = 1.0e-4  ! m^2/s. visc background due to internal waves
real :: diff_cbt_iw        = 0.1e-4  ! m^2/s. diffusivity background due to internal waves
real :: Vtc                          ! non-dimensional coefficient for velocity 
                                     ! scale of turbulant velocity shear        
                                     ! (=function of concv,concs,epsilon,vonk,Ricr)

real    :: cg            ! non-dimensional coefficient for counter-gradient term
real    :: deltaz        ! delta zehat in table
real    :: deltau        ! delta ustar in table
real    :: concv  = 1.8  ! constant for pure convection (eqn. 23)
real    :: Lgam = 1.04     ! adjustment to non-gradient flux (McWilliam & Sullivan 2000)
real    :: Cw_0 = 0.15     ! eq. (13) in Smyth et al (2002)
real    :: l_smyth = 2.0   ! eq. (13) in Smyth et al (2002)
real    :: LTmax = 5.0     ! maximum Langmuir turbulence enhancement factor (langmuirfactor) allowed
real    :: Wstfac = 0.6    ! stability adjustment coefficient, eq. (13) in Smyth et al (2002)

! for vertical coordinate 
integer :: vert_coordinate

real :: rho_cp
real :: inv_rho_cp

! for global area normalization
real :: cellarea_r

logical :: use_this_module           = .false. ! for turning on the kpp scheme 
logical :: shear_instability         = .true.  ! for shear instability mixing
logical :: double_diffusion          = .true.  ! for double-diffusive mixing
logical :: wsfc_combine_runoff_calve = .true.  ! for combining runoff+calving to compute wfsc
real    :: shear_instability_flag    = 1.0     ! set to 1.0 if shear_instability=.true.

! internally set for computing watermass diagnstics
logical :: compute_watermass_diag = .false. 

! for diagnostics 
integer, dimension(:), allocatable :: id_nonlocal(:)
integer, dimension(:), allocatable :: id_nonlocal_on_nrho(:)
logical :: used
integer :: id_diff_cbt_kpp_t   =-1
integer :: id_diff_cbt_kpp_s   =-1
integer :: id_diff_cbt_int     =-1
integer :: id_visc_cbt_int     =-1
integer :: id_diff_cbt_coast   =-1
integer :: id_visc_cbt_coast   =-1
integer :: id_hblt             =-1
integer :: id_tidal_vel_amp    =-1
integer :: id_tidal_fric_turb  =-1
integer :: id_rough_amp        =-1
integer :: id_eflux_int_tide_bf=-1
integer :: id_f_int_tide       =-1
integer :: id_bf_int_tide      =-1

integer  :: id_neut_rho_kpp_nloc          =-1
integer  :: id_wdian_rho_kpp_nloc         =-1
integer  :: id_tform_rho_kpp_nloc         =-1
integer  :: id_neut_rho_kpp_nloc_on_nrho  =-1
integer  :: id_wdian_rho_kpp_nloc_on_nrho =-1
integer  :: id_tform_rho_kpp_nloc_on_nrho =-1

integer :: id_eta_tend_kpp_nloc     =-1
integer :: id_eta_tend_kpp_nloc_glob=-1

integer  :: id_neut_temp_kpp_nloc          =-1
integer  :: id_wdian_temp_kpp_nloc         =-1
integer  :: id_tform_temp_kpp_nloc         =-1
integer  :: id_neut_temp_kpp_nloc_on_nrho  =-1
integer  :: id_wdian_temp_kpp_nloc_on_nrho =-1
integer  :: id_tform_temp_kpp_nloc_on_nrho =-1

integer  :: id_neut_salt_kpp_nloc          =-1
integer  :: id_wdian_salt_kpp_nloc         =-1
integer  :: id_tform_salt_kpp_nloc         =-1
integer  :: id_neut_salt_kpp_nloc_on_nrho  =-1
integer  :: id_wdian_salt_kpp_nloc_on_nrho =-1
integer  :: id_tform_salt_kpp_nloc_on_nrho =-1


logical :: non_local_kpp      = .true.  ! enable/disable non-local term in KPP
logical :: smooth_blmc        = .false. ! smooth boundary layer diffusitivies to remove grid scale noise
logical :: do_langmuir        = .false. ! whether or not calculate langmuir turbulence enhancement factor

logical :: coastal_tidal_mix  = .false. ! add tidal speed (m/s) to Ri to increase coastal mixing
real    :: sigma_tide         = 3.0     ! the sigma constant in the Munk-Anderson scheme
real    :: p_tide             = -0.25   ! the p constant in the Munk-Anderson scheme
real    :: coastal_tidal_flag = 0.0     ! set to unity if coastal_tidal_mix=.true.

logical :: int_tidal_mix      = .false. ! add internal tidal dissipation over rough topograpgy in the open ocean
real    :: int_tide_zeta1     = 300.0   ! shallow depth (m) for computation of internal tide mixing
real    :: int_tide_zeta2     = 1800.0  ! deeper depth (m) for computation of internal tide mixing
real    :: int_tide_min_depth = 100.0   ! minimum depth (m) a region must posses to employ int tide mixing
real    :: int_tide_q         = 0.33333 ! Fraction of internal tide energy locally dissipated.
real    :: int_tide_gamma     = 0.2     ! Dimensionless efficiency for converting energy dissipation to diffusivity.

integer, parameter :: nni = 890         ! number of values for zehat in the look up table
integer, parameter :: nnj = 480         ! number of values for ustar in the look up table
real, dimension(0:nni+1,0:nnj+1) :: wmt ! lookup table for wm, the turbulent velocity scale for momentum
real, dimension(0:nni+1,0:nnj+1) :: wst ! lookup table for ws, the turbulent velocity scale scalars

real :: tracer_timestep = 0

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type), pointer   :: Grd => NULL()

integer :: num_prog_tracers=0, index_temp, index_salt
integer :: num_diag_tracers=0, index_frazil

character(len=256) :: version=&
     '$Id: ocean_vert_kpp_mom4p0.F90,v 20.0 2013/12/14 00:16:42 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

logical :: module_is_initialized = .FALSE.

namelist /ocean_vert_kpp_mom4p0_nml/ use_this_module, shear_instability, double_diffusion,  &
                              diff_cbt_iw, visc_cbu_iw,                             &
                              visc_cbu_limit, diff_cbt_limit,                       &
                              visc_con_limit, diff_con_limit,                       &
                              concv, Ricr, non_local_kpp, smooth_blmc,              &
                              Lgam, Cw_0,l_smyth, LTmax, Wstfac,                    &
                              coastal_tidal_mix, p_tide, sigma_tide,                &
                              int_tidal_mix, int_tide_zeta1, int_tide_zeta2,        &
                              int_tide_min_depth, int_tide_q, int_tide_gamma,       &
                              wsfc_combine_runoff_calve, do_langmuir

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_vert_kpp_mom4p0_init">
!
! <DESCRIPTION>
! Initialization for the KPP vertical mixing scheme
!
!     input:
!       dzt    = thickness of vertical levels (m)                         <BR/>
!       km     = number of vertical levels                                <BR/> 
!       yt     = latitude of grid points (deg)                            <BR/> 
!       jmt    = number of latitudes                                      <BR/>  
!       dtxcel = time step accelerator as a function of level             <BR/>    
!       dtimet = forward time step for tracer diffusion (sec)             <BR/>   
!       dtimeu = forward time step for velcotiy friction (sec)            <BR/>   
!       error  = logical to signal problems                               <BR/>
!       cifdef = array of character strings for listing enabled "ifdefs"  <BR/>
!       ifdmax = size of "cifdef"                                         <BR/> 
!       nifdef = current number of enabled "ifdefs"                       <BR/>   
!       vmixset= logical to determine if a vertical mixing scheme was     <BR/> 
!                chosen
!
!     output:
!       shear_instability = logical switch for shear instability mixing   <BR/>   
!       double_diffusion = logical switch for double-diffusive mixing     <BR/>
!       visc_cbu_limit = visc max due to shear instability  (m**2/sec)    <BR/>
!       diff_cbt_limit = diffusivity ..                     (m**2/sec)    <BR/>
!       visc_cbu_iw  = visc background due to internal waves(m**2/sec)    <BR/>
!       diff_cbt_iw  = diffusivity ..                       (m**2/sec)    <BR/> 
!       visc_con_limit = visc due to convective instability (m**2/sec)    <BR/>
!       diff_con_limit = diffusivity ..                     (m**2/sec)    <BR/>
!       Vtc = non-dimensional constant used in calc. bulk Ri              <BR/>
!       cg  = constant used in calc.nonlocal transport term               <BR/>  
!       wmt = turbulent velocity scale for momentum                       <BR/>  
!       wst = turbulent velocity scale for scaler                         <BR/> 
!       error  = true if some inconsistancy was found                    
!
! </DESCRIPTION>
!
subroutine ocean_vert_kpp_mom4p0_init (Grid, Domain, Time, Time_steps, Dens, T_prog, T_diag, ver_coordinate)
  
  type(ocean_grid_type),        intent(in), target  :: Grid
  type(ocean_domain_type),      intent(in), target  :: Domain
  type(ocean_time_type),        intent(in)          :: Time
  type(ocean_time_steps_type),  intent(in)          :: Time_steps
  type(ocean_density_type),     intent(in)          :: Dens
  type(ocean_prog_tracer_type), intent(in)          :: T_prog(:)
  type(ocean_diag_tracer_type), intent(in)          :: T_diag(:)
  integer,                      intent(in)          :: ver_coordinate
  
  real, parameter :: cstar  = 10.0  ! proportionality coefficient for nonlocal transport
  real, parameter :: conam  = 1.257
  real, parameter :: concm  = 8.380 
  real, parameter :: conc2  = 16.0
  real, parameter :: zetam  = -0.2
  real, parameter :: conas  = -28.86
  real, parameter :: concs  = 98.96
  real, parameter :: conc3  = 16.0
  real, parameter :: zetas  = -1.0

  real :: zehat ! = zeta * ustar**3
  real :: zeta  ! = stability parameter d/L
  real :: usta

  real :: sqrt_cd, A_tidal
  real :: tidal_vel_amp_t, kapa_int_tide, rho_ref_int_tide
  real :: delz_int_tide, active_cells
  real :: zeta_int_tide1, zeta_int_tide2
  real :: upper_int_tide1, lower_int_tide1
  real :: upper_int_tide2, lower_int_tide2
  integer :: i, j, k, kmax, n, ioun, io_status, ierr

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_vert_kpp_mod (ocean_vert_kpp_mom4p0_init): module is already initialized')
  endif 

  module_is_initialized = .TRUE.
  vert_coordinate = ver_coordinate 
  rho_cp     = rho0*cp_ocean 
  inv_rho_cp = 1.0/rho_cp 

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_vert_kpp_mom4p0_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_vert_kpp_mom4p0_nml')
#else
  ioun =  open_namelist_file ()
  read  (ioun, ocean_vert_kpp_mom4p0_nml,iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_vert_kpp_mom4p0_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit, ocean_vert_kpp_mom4p0_nml)  
  write (stdlogunit, ocean_vert_kpp_mom4p0_nml)

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  nk = Grid%nk
#endif 

  if(use_this_module) then 
    write(stdoutunit,'(/1x,a)') '==> NOTE: USING KPP_mom4p0 vertical mixing scheme.'
    write(stdoutunit,'(1x,a)')  '          This scheme is hard-wired for GEOPOTENTIAL coordinates.'
    write(stdoutunit,'(1x,a)')  '          It is not generally recommended for use, other than for legacy.'
    write(stdoutunit,'(1x,a)')  '==> NOTE: KPP is typically run with penetrative shortwave heating.'
    write(stdoutunit,'(1x,a/)') '==> NOTE: KPP is typically run with a seasonal and/or diurnal cycle.'
  else 
    write(stdoutunit,'(/1x,a)')'==> NOTE: NOT USING KPP_mom4p0 vertical mixing scheme.'
    return
  endif 

  if(vert_coordinate /= GEOPOTENTIAL) then 
    call mpp_error(NOTE,&
    '==>ocean_vert_kpp_mom4p0_mod: This module is hard-wired for full cell GEOPOTENTIAL coordinate. ')
  endif  

  write(stdoutunit,'(/a,f10.2)')'==>From ocean_vert_kpp_mom4p0_mod: time step for vert-frict of (secs)', &
                               Time_steps%dtime_u 
  write(stdoutunit,'(/a,f10.2)')'==>From ocean_vert_kpp_mom4p0_mod: time step for vert-diff  of (secs)', &
                               Time_steps%dtime_t 

  tracer_timestep = Time_steps%dtts

  index_temp=-1;index_salt=-1
  num_prog_tracers = size(T_prog(:))
  do n= 1, num_prog_tracers
     if (T_prog(n)%name == 'temp') index_temp = n
     if (T_prog(n)%name == 'salt') index_salt = n
  enddo
  allocate( wsfc(num_prog_tracers) )

  index_frazil=-1
  num_diag_tracers = size(T_diag(:))
  do n= 1, num_diag_tracers
     if (T_diag(n)%name == 'frazil') index_frazil = n
  enddo

  if (index_temp < 1 .or. index_salt < 1) then 
    call mpp_error(FATAL,'==>Error: ocean_vert_kpp_mom4p0_mod: temp and/or salt not present in tracer array')
  endif 

  Dom => Domain
  Grd => Grid

  cellarea_r = 1.0/(epsln + Grd%tcellsurf)

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  nk = Grid%nk

  allocate (ghats(isd:ied,jsd:jed,nk))
  allocate (riu(isd:ied,jsd:jed,nk))
  allocate (riu_tide(isd:ied,jsd:jed,nk))
  allocate (rit(isd:ied,jsd:jed,nk))
  allocate (rit_tide(isd:ied,jsd:jed,nk))
  allocate (hblt(isd:ied,jsd:jed))
  allocate (hbl(isd:ied,jsd:jed))
  do n=1,num_prog_tracers 
    allocate( wsfc(n)%wsfc(isd:ied,jsd:jed) )
  enddo


  allocate (bfsfc(isd:ied,jsd:jed))         ! surface buoyancy forcing    (m^2/s^3)
  allocate (caseA(isd:ied,jsd:jed))         ! = 1 in case A; =0 in case B
  allocate (stable(isd:ied,jsd:jed))        ! = 1 in stable forcing; =0 in unstable
  allocate (dkm1(isd:ied,jsd:jed,3))        ! boundary layer diff_cbt at kbl-1 level
  allocate (blmc(isd:ied,jsd:jed,nk,3))     ! boundary layer mixing coefficients
  allocate (sigma(isd:ied,jsd:jed))         ! normalized depth (d / hbl)
  allocate (rhosfc(isd:ied,jsd:jed))        ! potential density of sfc layer(g/m^3)
  allocate (talpha(isd:ied,jsd:jed,nk))     ! -d(rho)/ d(pot.temperature)  (g/m^3/C)
  allocate (sbeta(isd:ied,jsd:jed,nk))      ! d(rho)/ d(salinity)       (g/m^3/PSU)
  allocate (alphaDT(isd:ied,jsd:jed,nk))    ! alpha * DT  across interfaces (g/m^3)
  allocate (betaDS(isd:ied,jsd:jed,nk))     ! beta  * DS  across interfaces (g/m^3)
  allocate (Bo(isd:ied,jsd:jed))            ! surface turb buoy. forcing  (m^2/s^3)
  allocate (Bosol(isd:ied,jsd:jed))         ! radiative buoy forcing      (m^2/s^3)
  allocate (dbloc(isd:ied,jsd:jed,nk))      ! local delta buoy at interfaces(m/s^2)
  allocate (dbsfc(isd:ied,jsd:jed,nk))      ! delta buoy w/ respect to sfc  (m/s^2)
  allocate (dVsq(isd:ied,jsd:jed,nk))       ! (velocity shear re sfc)^2   (m/s)^2
  allocate (kbl(isd:ied,jsd:jed))           ! index of first grid level below hbl
  allocate (Rib(isd:ied,jsd:jed,2))         ! Bulk Richardson number
  allocate (wm(isd:ied,jsd:jed))            ! momentum turbulent velocity scales  (m/s)
  allocate (ws(isd:ied,jsd:jed))            ! scalar turbulent velocity scales  (m/s)
  allocate (Ustk2(isd:ied,jsd:jed))         ! Magnitude of surface stokes drift velocity ^2 (m^2/s^2)
  allocate (gat1(isd:ied,jsd:jed,3))
  allocate (dat1(isd:ied,jsd:jed,3))
  allocate(sw_frac_hbl(isd:ied,jsd:jed))
  allocate (tidal_vel_amp(isd:ied,jsd:jed))      ! tidal speed (m/s)
  allocate (tidal_fric_turb(isd:ied,jsd:jed,nk)) ! tidal friction (1/s^2)
  allocate (rough_amp(isd:ied,jsd:jed))          ! roughness amplitude of topography  (m)
  allocate (eflux_int_tide_bf(isd:ied,jsd:jed))  ! energy flux /buoyancy frequency
  allocate (f_int_tide(isd:ied,jsd:jed,nk))      ! vertical distribution function
  allocate (bf_int_tide(isd:ied,jsd:jed,nk))     ! Buoyancy frequency
#endif

  ghats(:,:,:)     = 0.0
  riu(:,:,:)       = 0.0
  riu_tide(:,:,:)  = 0.0
  rit(:,:,:)       = 0.0
  rit_tide(:,:,:)  = 0.0
  hblt(:,:)        = 0.0
  hbl(:,:)         = 0.0
  sw_frac_hbl(:,:) = 0.0
  Ustk2(:,:)       = 0.0

  do n = 1, num_prog_tracers  
    wsfc(n)%wsfc(:,:) = 0.0
  enddo  
  tidal_vel_amp(:,:)     = 0.0
  tidal_fric_turb(:,:,:) = 0.0
  rough_amp(:,:)         = 0.0
  eflux_int_tide_bf(:,:) = 0.0
  f_int_tide(:,:,:)      = 0.0
  bf_int_tide(:,:,:)     = 0.0


!-----------------------------------------------------------------------
!     initialize some constants for kmix subroutines, and initialize
!     for kmix subroutine "wscale" the 2D-lookup table for wm and ws
!     as functions of ustar and zetahat (=vonk*sigma*hbl*bfsfc).
!-----------------------------------------------------------------------
 

!-----------------------------------------------------------------------
! define some non-dimensional constants  (recall epsilon=0.1)
!-----------------------------------------------------------------------

!     Vtc used in eqn. 23
      Vtc     = concv * sqrt(0.2/concs/epsilon) / vonk**2 / Ricr

!     cg = cs in eqn. 20
      cg      = cstar * vonk * (concs * vonk * epsilon)**(1./3.)

!-----------------------------------------------------------------------
! construct the wm and ws lookup tables (eqn. 13 & B1)
!-----------------------------------------------------------------------

      deltaz = (zmax-zmin)/(nni+1) 
      deltau = (umax-umin)/(nnj+1)
      
      do i=0,nni+1
         zehat = deltaz*(i) + zmin
         do j=0,nnj+1
            usta = deltau*(j) + umin
            zeta = zehat/(usta**3+epsln)

            if(zehat >= 0.) then
               wmt(i,j) = vonk*usta/(1.+conc1*zeta)
               wst(i,j) = wmt(i,j)
            else
               if(zeta > zetam) then
                  wmt(i,j) = vonk* usta * (1.-conc2*zeta)**(1./4.)
               else
                  wmt(i,j) = vonk* (conam*usta**3-concm*zehat)**(1./3.)
               endif
               if(zeta > zetas) then
                  wst(i,j) = vonk* usta * (1.-conc3*zeta)**(1./2.)
               else
                  wst(i,j) = vonk* (conas*usta**3-concs*zehat)**(1./3.)
               endif
            endif   
         enddo   
      enddo

      ! set flag for shear instability mixing 
      if (shear_instability) then
          write (stdoutunit,'(a)') 'Computing vertical mixing from shear instability in KPP module.'
          shear_instability_flag=1.0
      else 
          write (stdoutunit,'(a)') 'NOT computing vertical mixing from shear instability in KPP module.'
          shear_instability_flag=0.0
      endif 

!-----------------------------------------------------------------------
! read tidal speed (m/s) from Global Inverse Solution
! TPX06.0 created by OSU (only M2 tides), interpolated 1/4 x 1/4  
! to ocean model grid by Gaussian method
!
! After read data, then compute static tidal frictional turbulence
!-----------------------------------------------------------------------
      if (coastal_tidal_mix) then
          write (stdoutunit,'(a)') 'Computing vertical mixing from barotropic tides within KPP_mom4p0 module.'
          coastal_tidal_flag=1.0
      endif 
      if (int_tidal_mix) then
          write (stdoutunit,'(a)') 'Computing vertical mixing from internal tides within KPP_mom4p0 module.'
      endif 

      if (coastal_tidal_mix .or. int_tidal_mix) then
          call read_data('INPUT/tideamp.nc','tideamp', tidal_vel_amp, Domain%domain2d, 1)
          write (stdoutunit,*) 'Completed read of tidal velocity amplitude'
          call mpp_update_domains (tidal_vel_amp(:,:), Dom%domain2d)
      endif

      ! calculate the tidal frictional turbulence (frictioanl shear term) based 
      ! on the tidal velocity amplitude as a static variable.
      if (coastal_tidal_mix) then
          sqrt_cd = sqrt(2.4e-3)
          do j=jsd,jed
             do i=isd,ied
                A_tidal = sqrt_cd * tidal_vel_amp(i,j)/vonk
                kmax = Grd%kmt(i,j)
                if (kmax > 0) then
                    do k=1,kmax
                       tidal_fric_turb(i,j,k) = 0.5*(A_tidal/(Grd%zw(kmax)-Grd%zt(k)))**2
                    enddo
                endif
             enddo
          enddo

         ! update halo regions to compute tidal frictional turbulence to place onto U-cell 
         call mpp_update_domains (tidal_fric_turb(:,:,:), Dom%domain2d)

      endif

!-----------------------------------------------------------------------
! Parameterization of internal tidal dissipation over rough topography
! Read input data of roughness amplitude of topography, rough_amp (meter unit)
! logical switch is int_tidal_mix, default is .false.
! eflux_int_tide_bf: internal tidal mixing energy flux devided by buoyancy frequency
! kapa_int_tide : wave number of rough topography = 2*3.14/(10 km), (Jayne and St. Laurent, 2001)
! rho_ref_int_tide=1035 , refernce sea water density, (Gill,1982)
! f_int_tide , vertical distribution function
! zeta_int_tide=500 m, vertical e-folding scale
!-----------------------------------------------------------------------
      if (int_tidal_mix) then

          call read_data('INPUT/rough_amp.nc','roughness_length', rough_amp, Domain%domain2d, 1)
          write (stdoutunit,*) 'Completed read of roughness amplitude of topography'

      kapa_int_tide=2.0*3.1415926/(10.*1.e3)
      rho_ref_int_tide=1035.0                 

          do j=jsc,jec
             do i=isc,iec

        active_cells = Grd%umask(i,j,1) + Grd%umask(i-1,j,1) + Grd%umask(i,j-1,1) + Grd%umask(i-1,j-1,1) + epsln
                tidal_vel_amp_t=(tidal_vel_amp(i,j)+tidal_vel_amp(i,j-1)        &
                                +tidal_vel_amp(i-1,j)+tidal_vel_amp(i-1,j-1))/active_cells
                eflux_int_tide_bf(i,j)=0.5*rho_ref_int_tide*kapa_int_tide*rough_amp(i,j)*rough_amp(i,j) &
                                  *tidal_vel_amp_t*tidal_vel_amp_t
             enddo
          enddo

      ! update halo regions to compute tidal frictional turbulence to place onto U-cell 
      call mpp_update_domains (eflux_int_tide_bf(:,:), Dom%domain2d)


          ! define the verical distribution function for energy flux, f_int_tide
          ! this uses static rigid lid geopotential vertical coordinate depths.  
          ! this is strictly inaccurate.  see the ocean_vert_tidal.F90 for better way. 
          do j=jsd,jed
             do i=isd,ied
                kmax = Grd%kmt(i,j)
                if (kmax > 0) then
                    do k=1,kmax
                        delz_int_tide=Grd%zw(kmax)-Grd%zt(k)
                        upper_int_tide1=exp(-1.0*(delz_int_tide/zeta_int_tide1))
                        lower_int_tide1=zeta_int_tide1 &
                        *(1.0-exp(-1.0*(Grd%zw(kmax)/zeta_int_tide1)))
                        upper_int_tide2=exp(-1.0*(delz_int_tide/zeta_int_tide2))
                        lower_int_tide2=zeta_int_tide2 &
                        *(1.0-exp(-1.0*(Grd%zw(kmax)/zeta_int_tide2)))
                        f_int_tide(i,j,k) = 0.5*(upper_int_tide1/lower_int_tide1+upper_int_tide2/lower_int_tide2)
                    enddo
                endif
             enddo
          enddo
      
      endif

!-----------------------------------------------------------------------
! error checks and diagnostics setup 
!-----------------------------------------------------------------------

  if (Time_steps%aidif /= 1.0) then
    call mpp_error(FATAL,&
    '==>Error in ocean_vert_kpp_mom4p0: kpp must use aidif=1 for implicit vertical mixing')
  endif

  ! register diagnostics 

  allocate(id_nonlocal(num_prog_tracers))
  allocate(id_nonlocal_on_nrho(num_prog_tracers))
  id_nonlocal=-1
  id_nonlocal_on_nrho=-1
  do n = 1, num_prog_tracers
     if(n==index_temp) then
        id_nonlocal(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_nonlocal_KPP', &
                     Grd%tracer_axes(1:3), Time%model_time,                                         &
                     'cp*rho*dzt*nonlocal tendency from KPP', trim(T_prog(n)%flux_units),           &
                     missing_value=missing_value, range=(/-1.e10,1.e10/))
        id_nonlocal_on_nrho(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_nonlocal_KPP_on_nrho', &
                     Dens%neutralrho_axes(1:3), Time%model_time,                                         &
                     'cp*rho*dzt*nonlocal tendency from KPP binned to neutral density', trim(T_prog(n)%flux_units), &
                     missing_value=missing_value, range=(/-1.e20,1.e20/))
     else
        id_nonlocal(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_nonlocal_KPP', &
                     Grd%tracer_axes(1:3), Time%model_time,                                         &
                     'rho*dzt*nonlocal tendency from KPP', trim(T_prog(n)%flux_units),              &
                     missing_value=missing_value, range=(/-1.e10,1.e10/))
        id_nonlocal_on_nrho(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_nonlocal_KPP_on_nrho', &
                     Dens%neutralrho_axes(1:3), Time%model_time,                                         &
                     'rho*dzt*nonlocal tendency from KPP binned to neutral density', trim(T_prog(n)%flux_units),              &
                     missing_value=missing_value, range=(/-1.e20,1.e20/))
     endif
  enddo

  id_diff_cbt_kpp_t = register_diag_field('ocean_model','diff_cbt_kpp_t',Grd%tracer_axes(1:3),&
       Time%model_time, 'vert diffusivity from kpp for temp', 'm^2/sec',                      &
       missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_diff_cbt_kpp_s = register_diag_field('ocean_model','diff_cbt_kpp_s',Grd%tracer_axes(1:3),&
       Time%model_time, 'vert diffusivity from kpp for salt', 'm^2/sec',                      &
       missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_diff_cbt_int = register_diag_field('ocean_model','diff_cbt_int',Grd%tracer_axes(1:3), &
       Time%model_time, 'vert diffusivity from kpp internal tide mixing', 'm^2/sec',       &
       missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_visc_cbt_int = register_diag_field('ocean_model','visc_cbt_int',Grd%tracer_axes(1:3),&
       Time%model_time, 'vert viscosity from kpp internal tide mixing', 'm^2/sec',        &
       missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_diff_cbt_coast = register_diag_field('ocean_model','diff_cbt_coast',Grd%tracer_axes(1:3),&
       Time%model_time, 'vert diffusivity from kpp coastal tide mixing', 'm^2/sec',           &
       missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_visc_cbt_coast = register_diag_field('ocean_model','visc_cbt_coast',Grd%tracer_axes(1:3),&
       Time%model_time, 'vert viscosity from kpp coastal tide mixing', 'm^2/sec',             &
       missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_hblt           = register_diag_field('ocean_model','hblt',Grd%tracer_axes(1:2), &
       Time%model_time, 'T-cell boundary layer depth from KPP', 'm',                 &
       missing_value = missing_value, range=(/-1.e5,1.e6/),                          &
       standard_name='ocean_mixed_layer_thickness_defined_by_mixing_scheme')

  id_bf_int_tide    = register_diag_field('ocean_model','bf_int_tide',Grd%tracer_axes(1:3),&
       Time%model_time, 'buoyancy frequency', '1/sec',                                     &
       missing_value = missing_value, range=(/0.0,1.e-1/))

  ! static fields 
  id_tidal_vel_amp  = register_static_field('ocean_model','tidal_vel_amp',Grd%tracer_axes(1:2), &
       'M2 tidal speed from OSU tide model', 'm/s', missing_value=-10.0, range=(/-10.0,1.e6/))

  id_tidal_fric_turb  = register_static_field('ocean_model','tidal_fric_turb',Grd%tracer_axes(1:3), &
       'tidal friction', '1/s^2', missing_value=-10.0, range=(/-10.0,1.e6/))

   
  id_rough_amp  = register_static_field('ocean_model','rough_amp',Grd%tracer_axes(1:2), &
       ' roughness amplitude of topography', 'm', missing_value=-10.0, range=(/-10.0,1.e6/))

  id_eflux_int_tide_bf  = register_static_field('ocean_model','eflux_int_tide_bf',Grd%tracer_axes(1:2), &
       'energy flux devided by buoyancy frequency', '(W/m**2)*s', missing_value=-10.0, range=(/-10.0,1.e9/))

  id_f_int_tide  = register_static_field('ocean_model','f_int_tide',Grd%tracer_axes(1:3), &
       'verical distriibution function for energy flux', ' ', missing_value=-10.0, range=(/-10.0,1.e3/))

  call diagnose_2d(Time, Grd, id_tidal_vel_amp, tidal_vel_amp(:,:))
  call diagnose_3d(Time, Grd, id_tidal_fric_turb, tidal_fric_turb(:,:,:))
  call diagnose_2d(Time, Grd, id_rough_amp, rough_amp(:,:))
  call diagnose_2d(Time, Grd, id_eflux_int_tide_bf, eflux_int_tide_bf(:,:))
  call diagnose_3d(Time, Grd, id_f_int_tide, f_int_tide(:,:,:))

 call watermass_diag_init(Time,Dens)


end subroutine ocean_vert_kpp_mom4p0_init
! </SUBROUTINE> NAME="ocean_vert_kpp_mom4p0_init">



!#######################################################################
! <SUBROUTINE NAME="vert_mix_kpp_mom4p0">
!
! <DESCRIPTION>
! This subroutine computes the vertical diffusivity and viscosity according
! to the KPP scheme of Large etal.  In brief, the scheme does the 
! following:
!
! --Compute interior mixing everywhere:                               
!   interior mixing gets computed at all cell interfaces due to constant
!   internal wave background activity ("visc_cbu_iw" and "diff_cbt_iw").
!   Mixing is enhanced in places of static instability (local Ri < 0).
!   Additionally, mixing can be enhanced by contribution from shear 
!   instability which is a function of the local Ri.
!
! --Double diffusion:
!   Interior mixing can be enhanced by double diffusion due to salt
!   fingering and diffusive convection ("double_diffusion=.true.").
!
! --Boundary layer:
!
!   (A) Boundary layer depth:
!       at every gridpoint the depth of the oceanic boundary layer 
!       ("hbl") gets computed by evaluating bulk richardson numbers.
!
!   (B) Boundary layer mixing:
!       within the boundary layer, above hbl, vertical mixing is 
!       determined by turbulent surface fluxes, and interior mixing at
!       the lower boundary, i.e. at hbl.
!
! NOTE: Use smf_bgrid since this uses the primary smf array read in from 
! the coupler in ocean_core/ocean_sbc.F90 when using the FMS coupler.
!
! </DESCRIPTION>
!
subroutine vert_mix_kpp_mom4p0 (aidif, Time, Thickness, Velocity, T_prog, T_diag, Dens, &
                         swflx, sw_frac_zt, pme, river, visc_cbu, diff_cbt, hblt_depth, do_wave)

  real,                            intent(in)    :: aidif
  type(ocean_time_type),           intent(in)    :: Time
  type(ocean_thickness_type),      intent(in)    :: Thickness
  type(ocean_velocity_type),       intent(in)    :: Velocity
  type(ocean_prog_tracer_type),    intent(inout) :: T_prog(:)
  type(ocean_diag_tracer_type),    intent(in)    :: T_diag(:)
  type(ocean_density_type),        intent(in)    :: Dens
  real, dimension(isd:,jsd:),      intent(in)    :: swflx
  real, dimension(isd:,jsd:,:),    intent(in)    :: sw_frac_zt
  real, dimension(isd:,jsd:),      intent(in)    :: pme
  real, dimension(isd:,jsd:),      intent(in)    :: river
  real, dimension(isd:,jsd:),      intent(inout) :: hblt_depth
  real, dimension(isd:,jsd:,:),    intent(inout) :: visc_cbu
  real, dimension(isd:,jsd:,:,:),  intent(inout) :: diff_cbt
  logical,                         intent(in)    :: do_wave

  real, dimension(isd:ied,jsd:jed,nk) :: dbloc1, dbsfc1
  real, dimension(isd:ied,jsd:jed)    :: frazil
  real                                :: smftu, smftv, active_cells
  integer                             :: i, j, k, n, ki
  integer                             :: tau, taum1

  if ( .not. module_is_initialized ) then 
     call mpp_error(FATAL, '==>Error from vert_mix_kpp_mom4p0: module must be initialized')
  endif 

  if(.not. use_this_module) return 

  tau   = Time%tau
  taum1 = Time%taum1

  visc_cbu(:,:,:) = 0.0

  if(index_frazil > 0) then 
    do j = jsd, jed
       do i = isd, ied
          frazil(i,j) = T_diag(index_frazil)%field(i,j,1)
       enddo
    enddo
  else 
    frazil(:,:) = 0.0
  endif 

!---------assign Ustk2
    if (do_wave) then
       do j = jsd, jed
          do i = isd, ied
             Ustk2(i,j) = Velocity%ustoke(i,j)**2 + Velocity%vstoke(i,j)**2
          enddo
       enddo
    endif

!-----------------------------------------------------------------------
!     compute gradient Ri 
!-----------------------------------------------------------------------

  call ri_for_kpp(Time, Thickness, aidif, Velocity, T_prog(index_temp)%field(:,:,:,taum1), &
                  Dens%rho_salinity(:,:,:,taum1), Dens%pressure_at_depth,                  &
                  Dens%rho(:,:,:,tau), Dens%rho(:,:,:,taum1))

!-----------------------------------------------------------------------
!     compute vertical difference of velocity squared
!-----------------------------------------------------------------------

    do k=1,nk
      do j=jsd,jed
        do i=isd,ied
            dVsq(i,j,k) = (Velocity%u(i,j,1,1,tau) - Velocity%u(i,j,k,1,tau))**2   &
                        + (Velocity%u(i,j,1,2,tau) - Velocity%u(i,j,k,2,tau))**2
        enddo
      enddo
    enddo

!-----------------------------------------------------------------------
!     density related quantities
!     --------------------------
!     based on mom equation of state, which computes normalized
!     density  drho{k,kr} for layer k with respect to reference layer
!     kr, i.e. drho{T(k),S(k), tr(kr), sr(kr), zt(kr)}, as the
!     difference of drho=rho{k,kr}-rhor(kr):
!
!     density of surface layer                                   (kg/m3)
!           rho   = drho{T(1),S(1),zt(1)} + 1. + rhor(zt(1))
!     local buoyancy gradient at km interfaces:                  (m/s2)
!           dbloc = g/rho{k+1,k+1} * [ drho{k,k+1}-drho{k+1,k+1} ]
!     buoyancy difference with respect to "zref",i.e. the surface(m/s2)
!           dbsfc = g * [ drho{1,k}/rho{1,k} - drho{k,k}/rho{k,k} ]
!     thermal expansion coefficient without 1/rho factor       (kg/m3/C)
!           talpha= -d(rho{k,k})/d(T(k))
!     salt expansion coefficient without 1/rho factor        (kg/m3/PSU)
!           sbeta = d(rho{k,k})/d(S(k))
!-----------------------------------------------------------------------

        ! compute thermal and haline expansion coefficients (with factor of rho included).
        ! result from density_derivs is d(rho)/d(theta), yet need minus this for kpp   
        do k=1,nk
           do j=jsd,jed
              do i=isd,ied
                 talpha(i,j,k) = -Dens%drhodT(i,j,k)
                 sbeta(i,j,k)  =  Dens%drhodS(i,j,k)
              enddo
           enddo
        enddo

        rhosfc(:,:) = Dens%rho(:,:,1,tau)
        dbsfc(:,:,1) = 0.0

        dbloc1(:,:,:) = density_delta_z(Dens%rho(:,:,:,tau), Dens%rho_salinity(:,:,:,tau),   &
                        T_prog(index_temp)%field(:,:,:,tau), Dens%pressure_at_depth(:,:,:))
        dbsfc1(:,:,:) = density_delta_sfc(Dens%rho(:,:,:,tau), Dens%rho_salinity(:,:,:,tau), &
                        T_prog(index_temp)%field(:,:,:,tau),   Dens%pressure_at_depth(:,:,:))
        do k=2,nk
           do j=jsd,jed
              do i=isd,ied
                 dbloc(i,j,k-1) = -grav * dbloc1(i,j,k-1)/(epsln+Dens%rho(i,j,k,tau))
                 dbsfc(i,j,k)   = -grav * dbsfc1(i,j,k-1)/(epsln+Dens%rho(i,j,k,tau))
              enddo
           enddo
        enddo
        dbloc(:,:,nk) = dbloc(:,:,nk-1)

!-----------------------------------------------------------------------
!     kinematic surface fluxes on the "t-grid" :
!     --------------------------------------------------------
!
!     wusfc = kinematic zonal velocity sfc flux on jp       (m2/s2)
!           = -rho0r*smf_bgrid(i,j,1)
!     wvsfc = kinematic merid velocity                      (m2/s2)
!           = -rho0r*smf_bgrid(i,j,2)
!     wsfc(temp) = kinematic temperature                    (C*m/s)
!                = rho0r*(stf(i,j,temp) - pme *(t(i,j,1,temp)-tpme(temp)) 
!                                       -river*(t(i,j,1,temp)-triver(temp))) 
!     wsfc(salt) = kinematic salinity                       (PSU*m/s)
!                = rho0r*(stf(i,j,salt) - pme  *(t(i,j,1,salt)-tpme(salt)) 
!                                       - river*(t(i,j,1,salt)-triver(salt))) 
!     wtsol = kinematic solar temp                          (C*m/s)
!           = -swflx(i,j)/rho_cp 
!
!     friction velocity, turbulent and radiative sfc buoyancy forcing
!     ---------------------------------------------------------------
!
!     ustar(i) = sqrt(sqrt(wusfc(i)**2 + wvsfc(i)**2))      (m/s)
!     Bo(i)    = grav*(talpha(i,j,1)*wsfc(temp)-sbeta(i,j)*wsfc(salt))/rho(i)
!     Bosol(i) = grav*(talpha(i,j,1)*wtsol(i)                         )/rho(i)
!                Both Bo and Bosol have units               (m2/s3)
!-----------------------------------------------------------------------

      ! stf, pme, and river are mass fluxes and so 
      ! require rho0r to convert to kinematic units.
      ! algebraically we have 
      ! rho0*wsfc = stf - pme*(T(1)-tpme) - runoff*(T(1)-trunoff) - calving*(T(1)-tcalving)
      !           = stf - pme*(T(1)-tpme) - (runoff + calving)*T(1) + runoff*trunoff + calving*tcalving
      !           = stf - pme*(T(1)-tpme) - river*T(1) + runoff_tracer_flux + calving_tracer_flux    
        if(wsfc_combine_runoff_calve) then
            ! older method 
            do n=1,num_prog_tracers
               do j=jsd,jed
                  do i=isd,ied
                     wsfc(n)%wsfc(i,j) = (T_prog(n)%stf(i,j) -                          &
                          pme(i,j)  *(T_prog(n)%field(i,j,1,tau)-T_prog(n)%tpme(i,j)) - &
                          river(i,j)*(T_prog(n)%field(i,j,1,tau)-T_prog(n)%triver(i,j)) &
                          )*rho0r*Grd%tmask(i,j,1)
                  enddo
               enddo
            enddo
        else 
            ! newer method 
            do n=1,num_prog_tracers
               do j=jsd,jed
                  do i=isd,ied
                     wsfc(n)%wsfc(i,j) = (T_prog(n)%stf(i,j)                                    &
                          -pme(i,j)  *(T_prog(n)%field(i,j,1,tau)-T_prog(n)%tpme(i,j))          &
                          -river(i,j)*T_prog(n)%field(i,j,1,tau)                                &
                          +T_prog(n)%runoff_tracer_flux(i,j)+T_prog(n)%calving_tracer_flux(i,j) &
                          )*rho0r*Grd%tmask(i,j,1)
                  enddo
               enddo
            enddo
        endif


      do j=jsc,jec
        do i=isc,iec

          Bo(i,j)    = grav * (talpha(i,j,1) * &
                 (wsfc(index_temp)%wsfc(i,j)+frazil(i,j)/(rho_cp*tracer_timestep))  &
                 -sbeta (i,j,1) * wsfc(index_salt)%wsfc(i,j)) &     
                  / (epsln + rhosfc(i,j))                     
          Bosol(i,j) = grav * talpha(i,j,1) * swflx(i,j)*inv_rho_cp &
                       / (epsln + rhosfc(i,j))

        enddo
      enddo

!-----------------------------------------------------------------------
!     compute interior mixing coefficients everywhere, due to constant 
!     internal wave activity, static instability, and local shear 
!     instability.
!-----------------------------------------------------------------------
      call ri_iwmix(Time, Dens%rho(:,:,:,tau), visc_cbu, diff_cbt)


!-----------------------------------------------------------------------
!     add double diffusion
!-----------------------------------------------------------------------

      if (double_diffusion) then
        call ddmix (Time, T_prog, Dens, diff_cbt)  
      endif

!-----------------------------------------------------------------------
! set seafloor values to zero for blmix 
!-----------------------------------------------------------------------
      do ki = 1,nk-1
        do j = jsc,jec
          do i = isc,iec
            visc_cbu(i,j,ki)    = visc_cbu(i,j,ki)  *Grd%tmask(i,j,min(ki+1,nk))
            diff_cbt(i,j,ki,1)  = diff_cbt(i,j,ki,1)*Grd%tmask(i,j,min(ki+1,nk))
            diff_cbt(i,j,ki,2)  = diff_cbt(i,j,ki,2)*Grd%tmask(i,j,min(ki+1,nk))
          enddo
        enddo
      enddo
!
!-----------------------------------------------------------------------
!     boundary layer mixing coefficients: diagnose new b.l. depth
!-----------------------------------------------------------------------

      call bldepth(Velocity, sw_frac_zt, do_wave) 
 
!-----------------------------------------------------------------------
!     boundary layer diffusivities
!-----------------------------------------------------------------------

      call blmix_kpp(Velocity, diff_cbt, visc_cbu, do_wave)

!-----------------------------------------------------------------------
!     enhance diffusivity at interface kbl - 1
!-----------------------------------------------------------------------

      call enhance(diff_cbt, visc_cbu) 

!-----------------------------------------------------------------------
!     combine interior and b.l. coefficients and nonlocal term
!-----------------------------------------------------------------------

      ! smooth diffusivities with a 5 point filter
      ! to remove 2 delta x noise
      if (smooth_blmc) then
          
          call mpp_update_domains(blmc,Dom%domain2d)

          do k=1,nk-1
             do j=jsc,jec
                do i=isc,iec
                   active_cells = 4.0*Grd%tmask(i,j,k) + &
                        Grd%tmask(i-1,j,k)  +&
                        Grd%tmask(i+1,j,k)  +&
                        Grd%tmask(i,j-1,k)  +&
                        Grd%tmask(i,j+1,k)
                   if (active_cells == 8.0) then
                       wrk1(i,j,k) = & 
                            (4.0*blmc(i,j,k,2)   +&
                                 blmc(i-1,j,k,2) +&
                                 blmc(i+1,j,k,2) +&
                                 blmc(i,j-1,k,2) +&
                                 blmc(i,j+1,k,2)) / active_cells
                       wrk2(i,j,k) =  &
                            (4.0*blmc(i,j,k,3) +&
                              blmc(i-1,j,k,3)  +&
                              blmc(i+1,j,k,3)  +&
                              blmc(i,j-1,k,3)  +&
                              blmc(i,j+1,k,3)) / active_cells
                   else
                       wrk1(i,j,k) = blmc(i,j,k,2)
                       wrk2(i,j,k) = blmc(i,j,k,3)
                   endif
                enddo
             enddo
          enddo
   
          do k=1,nk-1
             do j=jsc,jec
                do i=isc,iec
                   blmc(i,j,k,2) = wrk1(i,j,k)
                   blmc(i,j,k,3) = wrk2(i,j,k)
                enddo
             enddo
          enddo

      endif

      
      do ki=1,nk-1
         do j=jsc,jec
            do i=isc,iec               
               if (ki < kbl(i,j)) then
                   visc_cbu(i,j,ki)   = blmc(i,j,ki,1)
                   diff_cbt(i,j,ki,1) = blmc(i,j,ki,2)
                   diff_cbt(i,j,ki,2) = blmc(i,j,ki,3)
               else
                   ghats(i,j,ki)=0.0
               endif

               diff_cbt(i,j,ki,1) = diff_cbt(i,j,ki,1)*Grd%tmask(i,j,min(ki+1,nk))
               diff_cbt(i,j,ki,2) = diff_cbt(i,j,ki,2)*Grd%tmask(i,j,min(ki+1,nk))               
            enddo
         enddo
      enddo

!     update halo regions to compute spatial avg of viscosity to place onto U-cell 
      call mpp_update_domains (visc_cbu(:,:,:), Dom%domain2d, flags=NUPDATE+EUPDATE)

      
! compute viscosity on "U-grid" by averaging visc_cbu from "T-grid". note: zero out land values

      do ki=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               visc_cbu(i,j,ki)   = .25*Grd%umask(i,j,min(ki+1,nk))* &
                    (visc_cbu(i,j,ki) + visc_cbu(i+1,j,ki) +&
                    visc_cbu(i,j+1,ki) + &
                    visc_cbu(i+1,j+1,ki) )
            enddo
         enddo
             
      enddo
      
      visc_cbu(:,:,nk)   = 0.0
      diff_cbt(:,:,nk,1) = 0.0
      diff_cbt(:,:,nk,2) = 0.0

!-----------------------------------------------------------------------
!      boundary layer depth
!-----------------------------------------------------------------------

       do j=jsc,jec
         do i=isc,iec
              hblt(i,j)       = hbl(i,j) * Grd%tmask(i,j,1)
              hblt_depth(i,j) = hblt(i,j)
         enddo
       enddo

!-----------------------------------------------------------------------
! add non-local contribution to th_tendency term
! note th_tendency has units of (kg/m^3)*(m/s)*tracer 
!-----------------------------------------------------------------------

       wrk1(:,:,:)  = 0.0 ! initialize work array for diagnostic storage

       if (non_local_kpp) then

           do n=1,num_prog_tracers

              if (n==index_salt) then

                  do k=1,1
                     do j=jsc,jec
                        do i=isc,iec
                           wrk1(i,j,k) = rho0*wsfc(n)%wsfc(i,j)*(-diff_cbt(i,j,k,2)*ghats(i,j,k))
                           T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + wrk1(i,j,k)
                        enddo
                     enddo
                  enddo
                  do k=2,nk
                     do j=jsc,jec
                        do i=isc,iec
                           wrk1(i,j,k) = rho0*wsfc(n)%wsfc(i,j)*(diff_cbt(i,j,k-1,2)*ghats(i,j,k-1) - &
                                                                 diff_cbt(i,j,k,2)*ghats(i,j,k))
                           T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + wrk1(i,j,k)
                        enddo
                     enddo
                  enddo

              else 

                  do k=1,1
                     do j=jsc,jec
                        do i=isc,iec
                           wrk1(i,j,k) = rho0*wsfc(n)%wsfc(i,j)*(-diff_cbt(i,j,k,1)*ghats(i,j,k))
                           T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + wrk1(i,j,k)
                        enddo
                     enddo
                  enddo
                  do k=2,nk
                     do j=jsc,jec
                        do i=isc,iec
                           wrk1(i,j,k) =  rho0*wsfc(n)%wsfc(i,j)*(diff_cbt(i,j,k-1,1)*ghats(i,j,k-1) - &
                                                                  diff_cbt(i,j,k,1)*ghats(i,j,k))
                           T_prog(n)%th_tendency(i,j,k) =  T_prog(n)%th_tendency(i,j,k) + wrk1(i,j,k)
                        enddo
                     enddo
                  enddo

              endif   ! endif for n==index_salt 


              ! diagnostic for the nonlocal term
              if (id_nonlocal(n) > 0) then 
                 call diagnose_3d(Time, Grd, id_nonlocal(n),T_prog(n)%conversion*wrk1(:,:,:))
              endif 
              if (id_nonlocal_on_nrho(n) > 0) then
                 call diagnose_3d_rho(Time, Dens, id_nonlocal_on_nrho(n),T_prog(n)%conversion*wrk1)
              endif

              ! save nonlocal term for later diagnostics of 
              ! evolution of locally ref potrho and dianeutral velocity component 
              if(n==index_temp) then 
                  do k=1,nk
                     do j=jsc,jec
                        do i=isc,iec
                           T_prog(index_temp)%wrk1(i,j,k) = wrk1(i,j,k)
                        enddo
                     enddo
                  enddo
              endif
              if(n==index_salt) then 
                  do k=1,nk
                     do j=jsc,jec
                        do i=isc,iec
                           T_prog(index_salt)%wrk1(i,j,k) = wrk1(i,j,k)
                        enddo
                     enddo
                  enddo
              endif
                   

           enddo   ! enddo for n-loop 

           call watermass_diag(Time, T_prog, Dens)


       endif  ! endif for non_local_kpp

!-----------------------------------------------------------------------
!     send mixing related fields resulting just from kpp
!-----------------------------------------------------------------------

       call diagnose_3d(Time, Grd, id_diff_cbt_kpp_t, diff_cbt(:,:,:,1))
       call diagnose_3d(Time, Grd, id_diff_cbt_kpp_s, diff_cbt(:,:,:,2))
       call diagnose_2d(Time, Grd, id_hblt, hblt(:,:))
       call diagnose_3d(Time, Grd, id_bf_int_tide, bf_int_tide(:,:,:))

end subroutine vert_mix_kpp_mom4p0
! </SUBROUTINE> NAME="vert_mix_kpp_mom4p0"


!#######################################################################
! <SUBROUTINE NAME="bldepth">
!
! <DESCRIPTION>
! The oceanic planetray boundary layer depth, hbl, is determined as
! the shallowest depth where the bulk richardson number is
! equal to the critical value, Ricr.
!
! Bulk Richardson numbers are evaluated by computing velocity and
! buoyancy differences between values at zt(kl) and surface
! reference values.
!
! In this configuration, the reference values are equal to the
! values in the surface layer.  
! When using a very fine vertical grid, these values should be 
! computed as the vertical average of velocity and buoyancy from 
! the surface down to epsilon*zt(kl).
!
! When the bulk richardson number at k exceeds Ricr, hbl is
! linearly interpolated between grid levels zt(k) and zt(k-1).
!
! The water column and the surface forcing are diagnosed for 
! stable/ustable forcing conditions, and where hbl is relative 
! to grid points (caseA), so that conditional branches can be 
! avoided in later subroutines.
!
!  model  
!      real zt(1:nk)              = vertical grid (m)                           <BR/>
!      real dzt(1:nk)             = layer thicknesses (m)                       <BR/>  
!
!  input
!      real dbloc(ij_bounds,nk)   = local delta buoyancy         (m/s^2)        <BR/> 
!      real dbsfc(ij_bounds,nk)   = delta buoyancy w/ respect to sfc(m/s)^2     <BR/> 
!      real ustar(ij_bounds)      = surface friction velocity     (m/s)         <BR/>   
!      real Bo(ij_bounds)         = surface turbulent buoyancy forcing(m^2/s^3) <BR/> 
!      real Bosol(ij_bounds)      = radiative buoyancy forcing (m^2/s^3)        <BR/>  
!      real f(ij_bounds)          = Coriolis parameter            (1/s)         <BR/>
!      integer jwtype(ij_bounds)  = Jerlov water type           (1 to 5)        <BR/>   
!
!  output
!      real hbl(ij_bounds)        ! boundary layer depth              (m)       <BR/>  
!      real bfsfc(ij_bounds) !Bo+radiation absorbed to d=hbf*hbl(m^2/s^3)       <BR/> 
!      real stable(ij_bounds)     ! =1 in stable forcing; =0 unstable           <BR/> 
!      real caseA(ij_bounds)      ! =1 in case A, =0 in case B                  <BR/> 
!      integer kbl(ij_bounds)     ! index of first grid level below hbl         <BR/>
! </DESCRIPTION>
!
subroutine bldepth(Velocity, sw_frac_zt, do_wave)

  type(ocean_velocity_type),    intent(in)  :: Velocity
  real, intent(in), dimension(isd:,jsd:,:) :: sw_frac_zt   !3-D array of shortwave fract
  logical, intent(in)                      :: do_wave

  real            :: Ritop         ! numerator of bulk Richardson Number
  real            :: bvsq, Vtsq
  real            :: active_cells, dVsq_avg_tcell
  real            :: hekman, hmonob, hlimit
  
  integer         :: ka, ku, kl, ksave
  integer         :: i, j
  integer         :: iwscale_use_hbl_eq_zt

  real, parameter :: cekman = 0.7  ! constant for Ekman depth
  real, parameter :: cmonob = 1.0  ! constant for Monin-Obukhov depth

! find bulk Richardson number at every grid level until > Ricr
!
! note: the reference depth is -epsilon/2.*zt(k), but the reference
!       u,v,t,s values are simply the surface layer values,
!       and not the averaged values from 0 to 2*ref.depth,
!       which is necessary for very fine grids(top layer < 2m thickness)
! note: max values when Ricr never satisfied are
!       kbl(i)=kmt(i,j) and hbl(i)=zt(i,kmt(i,j))
!
!
!     initialize hbl and kbl to bottomed out values

        do j=jsc,jec
          do i=isc,iec
            Rib(i,j,1) = 0.0
            kbl(i,j)   = MAX(Grd%kmt(i,j),2)
            hbl(i,j)   = Grd%zt(kbl(i,j))
          enddo
        enddo

!       indices for array Rib(i,j,k), the bulk Richardson number.     
       
        ka = 1
        ku = 2

        do kl=2,nk

!       compute bfsfc = sw fraction at hbf * zt
        do j=jsc,jec
         do i=isc,iec
            bfsfc(i,j)  = Bo(i,j)  + Bosol(i,j) * (0.0 - sw_frac_zt(i,j,kl))  ! default assumes sw included in stf. 
                                                                              ! otherwise use (1.0-sw_frac)         
         
            stable(i,j) = 0.5 + SIGN( 0.5, bfsfc(i,j) )
            sigma(i,j)  = stable(i,j) * 1. + (1.-stable(i,j)) * epsilon
          enddo
        enddo

!-----------------------------------------------------------------------
!         compute velocity scales at sigma, for hbl = zt(kl):
!-----------------------------------------------------------------------

          iwscale_use_hbl_eq_zt=1
          call wscale ( iwscale_use_hbl_eq_zt, Grd%zt(kl), Velocity, do_wave)


        do j=jsc,jec
          do i=isc,iec

!-----------------------------------------------------------------------
!           compute the turbulent shear contribution to Rib
!           eqn. (23)
!-----------------------------------------------------------------------

            bvsq =0.5*                                           &
                 ( dbloc(i,j,kl-1) / (Grd%dzw(kl-1))+             &
                   dbloc(i,j,kl  ) / (Grd%dzw(kl)) )
            Vtsq =  Grd%zt(kl) * ws(i,j) * sqrt(abs(bvsq)) * Vtc
 
!-----------------------------------------------------------------------
!           compute bulk Richardson number at new level
!           note: Ritop needs to be zero on land and ocean bottom
!           points so that the following if statement gets triggered
!           correctly. otherwise, hbl might get set to (big) negative
!           values, that might exceed the limit for the "exp" function
!           in "swfrac"
!
!           eqn. (21)
!
!
!           numerator of bulk richardson number on grid levels
!           --------------------------------------------------
!           note: land and ocean bottom values need to be set to zero
!           so that the subroutine "bldepth" works correctly
!-----------------------------------------------------------------------

            Ritop = (Grd%zt(kl)-Grd%zt(1)) * dbsfc(i,j,kl) * Grd%tmask(i,j,kl)

            active_cells   = Grd%umask(i,j,kl) + Grd%umask(i-1,j,kl) + Grd%umask(i,j-1,kl) + Grd%umask(i-1,j-1,kl) + epsln
            dVsq_avg_tcell = (dVsq(i,j,kl) + dVsq(i-1,j,kl) + dVsq(i,j-1,kl) + dVsq(i-1,j-1,kl))/active_cells
            Rib(i,j,ku) = Ritop / ( dVsq_avg_tcell + Vtsq + epsln )

            if((kbl(i,j) == Grd%kmt(i,j)).and.(Rib(i,j,ku) > Ricr)) then

!              linearly interpolate to find hbl where Rib = Ricr

               hbl(i,j) = Grd%zt(kl-1) + (Grd%dzw(kl-1)) * (Ricr - Rib(i,j,ka))  & 
                                     /(Rib(i,j,ku)-Rib(i,j,ka) + epsln)
               kbl(i,j) = kl
            endif

          enddo
        enddo

         ksave = ka
         ka    = ku
         ku    = ksave

      enddo

!-----------------------------------------------------------------------
!     find stability and buoyancy forcing for boundary layer
!-----------------------------------------------------------------------

      do j=jsc,jec
        do i = isc,iec
          ! Linear interpolation of sw_frac_zt to depth of hbl
          sw_frac_hbl(i,j)=(sw_frac_zt(i,j,kbl(i,j)) - sw_frac_zt(i,j,kbl(i,j)-1)) / Grd%dzt(kbl(i,j)) &
              * (hbl(i,j)-Grd%zt(kbl(i,j)))+sw_frac_zt(i,j,kbl(i,j))
          bfsfc(i,j)  = Bo(i,j) + Bosol(i,j) * (0.0 - sw_frac_hbl(i,j))
          stable(i,j) = 0.5 + SIGN( 0.5, bfsfc(i,j) )
          bfsfc(i,j)  = bfsfc(i,j) + stable(i,j) * epsln  ! ensures bfsfc never=0
        enddo
      enddo


!-----------------------------------------------------------------------
!        check hbl limits for hekman or hmonob
!        eqn. (24)
!-----------------------------------------------------------------------

      do j=jsc,jec
        do i = isc,iec
          if (bfsfc(i,j) > 0.0) then
             hekman = cekman * Velocity%ustar(i,j) / (abs(Grd%f(i,j))+epsln)
             hmonob = cmonob * Velocity%ustar(i,j)*Velocity%ustar(i,j)*Velocity%ustar(i,j)     &
                     /vonk / (bfsfc(i,j)+epsln) 
             hlimit = stable(i,j)     * AMIN1(hekman,hmonob) +      &
                     (stable(i,j)-1.) * (Grd%zt(nk))
             hbl(i,j) = AMIN1(hbl(i,j),hlimit)
             hbl(i,j) = AMAX1(hbl(i,j),Grd%zt(1))
          endif
          kbl(i,j) =Grd%kmt(i,j)
        enddo
      enddo

!-----------------------------------------------------------------------
!     find new kbl
!-----------------------------------------------------------------------

      do kl=2,nk
        do j=jsc,jec
          do i = isc,iec
            if((kbl(i,j) == Grd%kmt(i,j)).and.(Grd%zt(kl) > hbl(i,j))) then
              kbl(i,j) = kl
            endif
          enddo
        enddo
      enddo

!-----------------------------------------------------------------------
!     find stability and buoyancy forcing for final hbl values
!-----------------------------------------------------------------------

      do j=jsc,jec
        do i = isc,iec
          ! Linear interpolation of sw_frac_zt to depth of hbl
          sw_frac_hbl(i,j)=(sw_frac_zt(i,j,kbl(i,j)) - sw_frac_zt(i,j,kbl(i,j)-1)) / Grd%dzt(kbl(i,j)) &
              * (hbl(i,j)-Grd%zt(kbl(i,j)))+sw_frac_zt(i,j,kbl(i,j))
          bfsfc(i,j)  = Bo(i,j) + Bosol(i,j) * (0.0 - sw_frac_hbl(i,j))
          stable(i,j) = 0.5 + SIGN( 0.5, bfsfc(i,j) )
          bfsfc(i,j)  = bfsfc(i,j) + stable(i,j) * epsln 
        enddo
      enddo

!-----------------------------------------------------------------------
!     determine caseA and caseB
!     (if hbl is below (deeper than) the mid point of level kbl
!     then caseA=0  else caseA=1)
!-----------------------------------------------------------------------

      do j=jsc,jec
        do i = isc,iec
          caseA(i,j)  = 0.5 + SIGN( 0.5,Grd%zt(kbl(i,j)) - 0.5*Grd%dzt(kbl(i,j)) - hbl(i,j) )
        enddo
      enddo

end subroutine bldepth
! </SUBROUTINE> NAME="bldepth"



!#######################################################################
! <SUBROUTINE NAME="wscale">
!
! <DESCRIPTION>
! Compute turbulent velocity scales.
! Use a 2D-lookup table for wm and ws as functions of ustar and
! zetahat (=vonk*sigma*hbl*bfsfc).
!
! Note: the lookup table is only used for unstable conditions
! (zehat <= 0), in the stable domain wm (=ws) gets computed
! directly.
!
!  model
!
!  input                                                               <BR/>
!      real sigma(ij_bounds)  = normalized depth (d/hbl)               <BR/>
!      real hbl(ij_bounds)    = boundary layer depth (m)               <BR/>  
!      real ustar(ij_bounds)  = surface friction velocity    (m/s)     <BR/>  
!      real bfsfc(ij_bounds)  = total surface buoyancy flux (m^2/s^3)  <BR/>

!  output                                                               <BR/>  
!      real wm(ij_bounds),ws(ij_bounds) ! turbulent velocity scales at sigma

! local                                                                 <BR/>  
!      real zehat           ! = zeta *  ustar**3
!
! </DESCRIPTION>
!
subroutine wscale(iwscale_use_hbl_eq_zt, zt_kl, Velocity, do_wave)

  type(ocean_velocity_type),    intent(in)  :: Velocity
  real,    intent(in) :: zt_kl
  integer, intent(in) :: iwscale_use_hbl_eq_zt
  logical, intent(in) :: do_wave

  real                :: zdiff, udiff, zfrac, ufrac, fzfrac
  real                :: wam, wbm, was, wbs, u3, langmuirfactor, Cw_smyth
  real                :: zehat           ! = zeta *  ustar**3
  integer             :: iz, izp1, ju, jup1
  integer             :: i, j

!-----------------------------------------------------------------------
!     use lookup table for zehat < zmax only; otherwise use
!     stable formulae
!-----------------------------------------------------------------------

      do j=jsc,jec
        do i=isc,iec
          if (iwscale_use_hbl_eq_zt == 1) then
            zehat = vonk * sigma(i,j) * zt_kl * bfsfc(i,j)
          else
            zehat = vonk * sigma(i,j) * hbl(i,j) * bfsfc(i,j)
          end if

         if (zehat <= zmax) then

            zdiff  = zehat-zmin
            iz = int( zdiff/deltaz )
            iz = min( iz , nni )
            iz = max( iz , 0  )
            izp1=iz+1
            
            udiff  = Velocity%ustar(i,j)-umin

            ju = int( min(udiff/deltau,float(nnj)))
            ju = max( ju , 0  )
            jup1=ju+1

            zfrac = zdiff/deltaz - float(iz)
            ufrac = udiff/deltau - float(ju)

            fzfrac= 1.-zfrac
            wam   = (fzfrac)  * wmt(iz,jup1) + zfrac*wmt(izp1,jup1)
            wbm   = (fzfrac)  * wmt(iz,ju  ) + zfrac*wmt(izp1,ju  )
            wm(i,j) = (1.-ufrac)* wbm          + ufrac*wam

            was   = (fzfrac)  * wst(iz,jup1) + zfrac*wst(izp1,jup1)
            wbs   = (fzfrac)  * wst(iz,ju  ) + zfrac*wst(izp1,ju  )
            ws(i,j) = (1.-ufrac)* wbs          + ufrac*was
          else
            u3    = Velocity%ustar(i,j)*Velocity%ustar(i,j)*Velocity%ustar(i,j)
            wm(i,j) = vonk * Velocity%ustar(i,j) * u3 / ( u3 + conc1*zehat + epsln )
            ws(i,j) = wm(i,j)
          endif
        enddo
     enddo

!----------- if do_wave, add Langmuir turbulence enhancement factor

      if (do_wave .and. do_langmuir) then
         do j=jsc,jec
            do i=isc,iec
               Cw_smyth=Cw_0*(Velocity%ustar(i,j)*Velocity%ustar(i,j)*Velocity%ustar(i,j)/ &
                     (Velocity%ustar(i,j)*Velocity%ustar(i,j)*Velocity%ustar(i,j) &
                    + Wstfac* 0.4 *bfsfc(i,j)*hbl(i,j) + epsln))**l_smyth
               langmuirfactor=sqrt(1+Cw_smyth*Ustk2(i,j)/(Velocity%ustar(i,j)*Velocity%ustar(i,j) + epsln))
               langmuirfactor = max(1.0, langmuirfactor)
               langmuirfactor = min(LTmax, langmuirfactor)
               ws(i,j)=ws(i,j)*langmuirfactor
               wm(i,j)=wm(i,j)*langmuirfactor
            enddo
         enddo
      endif

end subroutine wscale
! </SUBROUTINE> NAME="wscale"



!#######################################################################
! <SUBROUTINE NAME="ri_iwmix">
!
! <DESCRIPTION>
! Compute interior viscosity and diffusivity due 
! to shear instability (dependent on a local richardson number),
! to background internal wave activity, and 
! to static instability (local richardson number < 0).
!
!     inputs:
!
!      nk             = number of vertical levels                               <BR/>
!      visc_cbu_iw    = background "visc_cbu" (m**2/sec) due to internal waves  <BR/>
!      diff_cbt_iw    = background "diff_cbt" (m**2/sec) due to internal waves  <BR/>
!      visc_cbu_limit = largest "visc_cbu" in regions of gravitational          <BR/>
!                       instability (m**2/sec)                                  <BR/>
!      diff_cbt_limit = largest "diff_cbt" in regions of gravitational          <BR/>
!                       instability (m**2/sec)                       
!
!     outputs:
!
!      visc_cbu = viscosity coefficient at bottom of "u" cells (m**2/s)         <BR/>   
!      diff_cbt = diffusion coefficient at bottom of "t" cells (m**2/s)         <BR/>  
! </DESCRIPTION>
!
subroutine ri_iwmix(Time, rho, visc_cbu, diff_cbt)

  type(ocean_time_type),          intent(in)    :: Time
  real, dimension(isd:,jsd:,:),   intent(in)    :: rho
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbu
  real, dimension(isd:,jsd:,:,:), intent(inout) :: diff_cbt
  
  real, parameter :: Riinfty = 0.8  ! local Richardson Number limit for shear instability
  real            :: Rigg, ratio, frit, fcont, frit_tide, rigg_tide
  real            :: q_int_tide, gamma_int_tide
  real            :: kv_up, kv_dn
  real            :: kv_visc_int_tide, kv_diff_int_tide
  integer         :: i, j, k, kmax

  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0

!-----------------------------------------------------------------------
!     diffusion and viscosity coefficients on bottom of "T" cells
!-----------------------------------------------------------------------

      do k=1,nk-1
        do j=jsc,jec
          do i=isc,iec
  
!-----------------------------------------------------------------------
!           evaluate function of Ri for shear instability eqn. (28b&c)
!-----------------------------------------------------------------------

            Rigg  = AMAX1( rit(i,j,k) , 0.0)
            ratio = AMIN1( Rigg/Riinfty , 1.0 )
            frit  = (1. - ratio*ratio)
            frit  = frit*frit*frit

!-----------------------------------------------------------------------
!           evaluate function of Ri by Munk-Anderson scheme
!-----------------------------------------------------------------------

            rigg_tide  = AMAX1( rit_tide(i,j,k) , 0.0)
            frit_tide = (1.0 + sigma_tide*rigg_tide)**p_tide   

!-----------------------------------------------------------------------
!           evaluate function of Ri for convection eqn. (28a)
!-----------------------------------------------------------------------

            fcont  = 0.5 * ( abs(rit(i,j,k)) - rit(i,j,k) )
            fcont  = fcont / (AMAX1(fcont,epsln))
     
!-----------------------------------------------------------------------
!           mixing due to internal wave activity and static instability 
!           eqn. (29).  Note: temporarily have visc_cbu on T-point.
!-----------------------------------------------------------------------

            visc_cbu(i,j,k)       = visc_cbu_iw + fcont * visc_con_limit   
            diff_cbt(i,j,k,1)     = diff_cbt_iw + fcont * diff_con_limit
            diff_cbt(i,j,k,2)     = diff_cbt_iw + fcont * diff_con_limit

!-----------------------------------------------------------------------
!           add contribution due to shear instability and coastal tide mixing
!-----------------------------------------------------------------------

            wrk1(i,j,k) = coastal_tidal_flag*diff_cbt_limit*frit_tide
            wrk2(i,j,k) = coastal_tidal_flag*visc_cbu_limit*frit_tide

            diff_cbt(i,j,k,1) = diff_cbt(i,j,k,1)              &
                 + shear_instability_flag*diff_cbt_limit*frit  &
                 + wrk1(i,j,k)
            diff_cbt(i,j,k,2) = diff_cbt(i,j,k,2)              &
                 + shear_instability_flag*diff_cbt_limit*frit  &
                 + wrk1(i,j,k)
            visc_cbu(i,j,k)   = visc_cbu(i,j,k)                &
                 + shear_instability_flag*visc_cbu_limit*frit  &
                 + wrk2(i,j,k)

          enddo
        enddo
      enddo

      ! internal tidal mixing where water depth is deeper than 100 m.
      wrk3(:,:,:) = 0.0
      wrk4(:,:,:) = 0.0
      if (shear_instability .and. int_tidal_mix) then
          do j=jsd,jed
             do i=isd,ied
                kmax = Grd%kmt(i,j)
                if (kmax > 2 .and. Grd%zw(kmax)>100.0) then
                    do k=1,kmax

                       q_int_tide=0.3333333 
                       gamma_int_tide=0.2
                       kv_up=q_int_tide*gamma_int_tide*eflux_int_tide_bf(i,j)*bf_int_tide(i,j,kmax-1)*f_int_tide(i,j,k)
                       kv_dn=rho(i,j,k)*bf_int_tide(i,j,k)*bf_int_tide(i,j,k)+epsln
                       kv_visc_int_tide=AMIN1(kv_up/kv_dn,visc_cbu_limit)
                       kv_diff_int_tide=AMIN1(kv_up/kv_dn,diff_cbt_limit)

                       visc_cbu(i,j,k)   = visc_cbu(i,j,k)   +  kv_visc_int_tide
                       diff_cbt(i,j,k,1) = diff_cbt(i,j,k,1) +  kv_diff_int_tide
                       diff_cbt(i,j,k,2) = diff_cbt(i,j,k,2) +  kv_diff_int_tide

                       wrk3(i,j,k)       = kv_diff_int_tide
                       wrk4(i,j,k)       = kv_visc_int_tide

                    enddo
                endif
             enddo
          enddo
      endif


      call diagnose_3d(Time, Grd, id_diff_cbt_coast, wrk1(:,:,:))
      call diagnose_3d(Time, Grd, id_visc_cbt_coast, wrk2(:,:,:))

      call diagnose_3d(Time, Grd, id_diff_cbt_int, wrk3(:,:,:))
      call diagnose_3d(Time, Grd, id_visc_cbt_coast, wrk4(:,:,:))

  
end subroutine ri_iwmix
! </SUBROUTINE> NAME="ri_iwmix"


!#######################################################################
! <SUBROUTINE NAME="ddmix">
!
! <DESCRIPTION>
! Rrho dependent interior flux parameterization.
! Add double-diffusion diffusivities to Ri-mix values at blending
! interface and below. salt fingering code modified july 2003
! by stephen.griffies based on NCAR CCSM2.x
!
!     inputs: 
!
!      nk     = number of vertical levels                                 <BR/>
!      real talpha(imt,km,jmw)   ! d(rho)/ d(pot.temperature) (kg/m^3/C)  <BR/> 
!      real sbeta(imt,km,jmw)    ! d(rho)/ d(salinity)     (kg/m^3/PSU)  
!
!     outputs:
!
!      diff_cbt = diffusion coefficient at bottom of "t" cells (m**2/s)
!
!
! local
!
!      real alphaDT(imt,km,jmw)   ! alpha * DT  across interfaces          <BR/>   
!      real betaDS(imt,km,jmw)    ! beta  * DS  across interfaces          <BR/>  
!
! </DESCRIPTION>
!
subroutine ddmix (Time, T_prog, Dens, diff_cbt)

type(ocean_time_type),          intent(in)    :: Time
type(ocean_prog_tracer_type),   intent(in)    :: T_prog(:)
type(ocean_density_type),       intent(in)    :: Dens
real, dimension(isd:,jsd:,:,:), intent(inout) :: diff_cbt

real diffdd   ! double diffusion diffusivity scale
real prandtl  ! prandtl number
real Rrho     ! double-diffusive density ratio

real, parameter :: Rrho0               = 1.9    ! limit for double diffusive density ratio
real, parameter :: dsfmax              = 1.e-4  ! (m^2/s) max diffusivity in case of salt fingering
real, parameter :: viscosity_molecular = 1.5e-6 ! (m^2/s)

integer :: i, j, k, ki, tau

tau = Time%tau

!     for double diffusion
!     --------------------
!     temperature and salt contributions of buoyancy gradients
!     on interfaces

    do k=1,nk-1
      do j=jsc,jec
        do i=isc,iec
            alphaDT(i,j,k) = 0.5 * (talpha(i,j,k) + talpha(i,j,k+1) ) &
                             * (T_prog(index_temp)%field(i,j,k,tau) - T_prog(index_temp)%field(i,j,k+1,tau))
            betaDS (i,j,k) = 0.5 * (sbeta (i,j,k) + sbeta(i,j,k+1)  ) &
                             *(Dens%rho_salinity(i,j,k,tau) - Dens%rho_salinity(i,j,k+1,tau))
        enddo
      enddo
    enddo
    do j=jsc,jec
      do i=isc,iec
        alphaDT(i,j,nk) = 0.0
        betaDS (i,j,nk) = 0.0
      enddo
    enddo

    do ki=1,nk
       do j=jsc,jec
          do i=isc,iec

!-----------------------------------------------------------------------
!           salt fingering case
!           eqn. (31)
!-----------------------------------------------------------------------

             if ((alphaDT(i,j,ki) > betaDS(i,j,ki)) .and. &
                 (betaDS (i,j,ki) > 0.         )) then

                 Rrho   = MIN(alphaDT(i,j,ki) / betaDS(i,j,ki), Rrho0)

!                diffdd = dsfmax*(1.0-((Rrho-1)/(Rrho0-1))**2)**pexp2     ! (very old code) 
!                diffdd = 1.0-((Rrho-1)/(Rrho0-1))**2                     ! (less old code)
                 diffdd = 1.0-((Rrho-1.0)/(Rrho0-1.0))                    ! (new code)
                 diffdd = dsfmax*diffdd*diffdd*diffdd

                 diff_cbt(i,j,ki,1) = diff_cbt(i,j,ki,1) + 0.7*diffdd
                 diff_cbt(i,j,ki,2) = diff_cbt(i,j,ki,2) + diffdd

!            diffusive convection eqn. (32)
             else if ( (alphaDT(i,j,ki) < 0.0) .and.  &
                       (betaDS(i,j,ki)  < 0.0) .and.  &
                       (alphaDT(i,j,ki) > betaDS(i,j,ki)) ) then

                 Rrho    = alphaDT(i,j,ki) / betaDS(i,j,ki) 
                 diffdd  = viscosity_molecular*0.909*exp(4.6*exp(-0.54*(1/Rrho-1)))  

!                eqn. (34)
                 prandtl = 0.15*Rrho
                 if (Rrho > 0.5) prandtl = (1.85-0.85/Rrho)*Rrho

                 diff_cbt(i,j,ki,1) = diff_cbt(i,j,ki,1) + diffdd
                 diff_cbt(i,j,ki,2) = diff_cbt(i,j,ki,2) + prandtl*diffdd

             endif

          enddo
       enddo
    enddo

end subroutine ddmix
! </SUBROUTINE> NAME="ddmix"


!#######################################################################
! <SUBROUTINE NAME="blmix_kpp">
!
! <DESCRIPTION>
! Mixing coefficients within boundary layer depend on surface
! forcing and the magnitude and gradient of interior mixing below
! the boundary layer ("matching").
!
! CAUTION: if mixing bottoms out at hbl = zt(nk) then
! fictitious layer at nk+1 is needed with small but finite width 
! dzt(nk+1) (eg. epsln = 1.e-20).  
!
!     inputs:
!
!      real ustar(ij_bounds)    ! surface friction velocity         (m/s)  <BR/>
!      real bfsfc(ij_bounds)    ! surface buoyancy forcing     (m^2/s^3)   <BR/>
!      real hbl(ij_bounds)      ! boundary layer depth              (m)    <BR/>
!      real stable(ij_bounds)   ! = 1 in stable forcing                    <BR/>
!      real caseA(ij_bounds)    ! = 1 in case A                            <BR/>
!      integer kbl(ij_bounds)   ! index of first grid level below hbl
!
!     outputs:
!
!      visc_cbu = viscosity coefficient at bottom of "u" cells (m**2/s)    <BR/>     
!      diff_cbt = diffusion coefficient at bottom of "t" cells (m**2/s)    <BR/>
!
!      real dkm1(ij_bounds,3)    = boundary layer diff_cbt at kbl-1 level  <BR/> 
!      real blmc(ij_bounds,nk,3) = boundary layer mixing coeff.(m**2/s)    <BR/> 
!      real ghats(ij_bounds,nk)  = nonlocal scalar transport               <BR/> 
!
!    local:
!
!      real gat1(ij_bounds,3)                                               <BR/>    
!      real dat1(ij_bounds,3)                                               <BR/> 
!      real sigma(ij_bounds)              = normalized depth (d / hbl)      <BR/> 
!      real ws(ij_bounds), wm(ij_bounds)  = turbulent velocity scales (m/s) 
!
! </DESCRIPTION>
!
subroutine blmix_kpp(Velocity, diff_cbt, visc_cbu, do_wave)

  type(ocean_velocity_type),    intent(in)  :: Velocity
  real, dimension(isd:ied,jsd:jed,nk,2) :: diff_cbt
  real, dimension(isd:ied,jsd:jed,nk)   :: visc_cbu
  logical,intent(in)                    :: do_wave

  real     :: zt_kl_dummy
  real     :: delhat, R, dvdzup, dvdzdn
  real     :: viscp, difsp, diftp, visch, difsh, difth, f1
  real     :: sig, a1, a2, a3, Gm, Gs, Gt

  integer  :: iwscale_use_hbl_eq_zt
  integer  :: i, j, ki
  integer  :: kn, knm1, knp1

!-----------------------------------------------------------------------
!       compute velocity scales at hbl. (recall epsilon=0.1)
!-----------------------------------------------------------------------
        do j = jsc,jec
          do i = isc,iec
            sigma(i,j) = stable(i,j) * 1.0 + (1.-stable(i,j)) * epsilon
          enddo
        enddo

        iwscale_use_hbl_eq_zt = 0
        zt_kl_dummy=0.0

        call wscale (iwscale_use_hbl_eq_zt, zt_kl_dummy, Velocity, do_wave)

      do j=jsc,jec
        do i = isc,iec 
          kn    = ifix(caseA(i,j)+epsln) *(kbl(i,j) -1) +   &
                  (1-ifix(caseA(i,j)+epsln)) * kbl(i,j)
          knm1 = max(kn-1,1)
          knp1 = min(kn+1,nk)

!-----------------------------------------------------------------------
!         find the interior viscosities and derivatives at hbl(i) 
!         eqn. (18)
!-----------------------------------------------------------------------

          delhat = 0.5*Grd%dzt(kn) + Grd%zt(kn) - hbl(i,j)
          R      = 1.0 - delhat / Grd%dzt(kn)
          dvdzup = (visc_cbu(i,j,knm1) - visc_cbu(i,j,kn))/Grd%dzt(kn)
          dvdzdn = (visc_cbu(i,j,kn) - visc_cbu(i,j,knp1))/Grd%dzt(knp1)
          viscp  = 0.5 * ( (1.-R) * (dvdzup + abs(dvdzup))+         &
                               R  * (dvdzdn + abs(dvdzdn)) )

          dvdzup = (diff_cbt(i,j,knm1,2) - diff_cbt(i,j,kn,2))/Grd%dzt(kn)
          dvdzdn = (diff_cbt(i,j,kn,2)   - diff_cbt(i,j,knp1,2))/Grd%dzt(knp1)
          difsp  = 0.5 * ( (1.-R) * (dvdzup + abs(dvdzup))+         &
                               R  * (dvdzdn + abs(dvdzdn)) )

          dvdzup = (diff_cbt(i,j,knm1,1) - diff_cbt(i,j,kn,1))/Grd%dzt(kn)
          dvdzdn = (diff_cbt(i,j,kn,1)   - diff_cbt(i,j,knp1,1))/Grd%dzt(knp1)
          diftp  = 0.5 * ( (1.-R) * (dvdzup + abs(dvdzup))+         &
                               R  * (dvdzdn + abs(dvdzdn)) )

          visch  = visc_cbu(i,j,kn)       + viscp * delhat
          difsh  = diff_cbt(i,j,kn,2) + difsp * delhat
          difth  = diff_cbt(i,j,kn,1)     + diftp * delhat

          f1 = stable(i,j) * conc1 * bfsfc(i,j) / (Velocity%ustar(i,j)**4+epsln) 

          gat1(i,j,1) = visch / (hbl(i,j)+epsln) / (wm(i,j)+epsln)
          dat1(i,j,1) = -viscp / (wm(i,j)+epsln) + f1 * visch
          dat1(i,j,1) = min(dat1(i,j,1),0.) 

          gat1(i,j,2) = difsh  / (hbl(i,j)+epsln) / (ws(i,j)+epsln)
          dat1(i,j,2) = -difsp / (ws(i,j)+epsln) + f1 * difsh 
          dat1(i,j,2) = min(dat1(i,j,2),0.) 
  
          gat1(i,j,3) = difth /  (hbl(i,j)+epsln) / (ws(i,j)+epsln)
          dat1(i,j,3) = -diftp / (ws(i,j)+epsln) + f1 * difth 
          dat1(i,j,3) = min(dat1(i,j,3),0.) 
        enddo
      enddo

      blmc(:,:,:,:) = 0.0

      do ki=1,nk

!-----------------------------------------------------------------------
!         compute turbulent velocity scales on the interfaces
!-----------------------------------------------------------------------

        do j  = jsc,jec
          do i  = isc,iec
            sig     = (Grd%zt(ki) + 0.5 * Grd%dzt(ki)) / (hbl(i,j)+epsln)
            sigma(i,j) = stable(i,j)*sig                          &
                     + (1.-stable(i,j))*AMIN1(sig,epsilon)
          enddo
        enddo

          iwscale_use_hbl_eq_zt=0
          zt_kl_dummy=0.0

          call wscale(iwscale_use_hbl_eq_zt, zt_kl_dummy, Velocity, do_wave)

!-----------------------------------------------------------------------
!         compute the dimensionless shape functions at the interfaces
!         eqn. (11)
!-----------------------------------------------------------------------

          
        do j=jsc,jec
          do i = isc,iec
            if (ki < kbl(i,j)) then
              sig = (Grd%zt(ki) + 0.5 * Grd%dzt(ki)) / (hbl(i,j)+epsln)
              a1 = sig - 2.
              a2 = 3.-2.*sig
              a3 = sig - 1.

              Gm = a1 + a2 * gat1(i,j,1) + a3 * dat1(i,j,1)
                   
              Gs = a1 + a2 * gat1(i,j,2) + a3 * dat1(i,j,2)
                  
              Gt = a1 + a2 * gat1(i,j,3) + a3 * dat1(i,j,3)
                  

!-----------------------------------------------------------------------
!             compute boundary layer diffusivities at the interfaces
!             eqn. (10)
!-----------------------------------------------------------------------

              
              blmc(i,j,ki,1) = hbl(i,j) * wm(i,j) * sig * (1.+sig*Gm) 
              blmc(i,j,ki,2) = hbl(i,j) * ws(i,j) * sig * (1.+sig*Gt) 
              blmc(i,j,ki,3) = hbl(i,j) * ws(i,j) * sig * (1.+sig*Gs) 

!-----------------------------------------------------------------------
!             nonlocal transport term = ghats * <ws>o (eqn. 20)
!             To include Langmuir turbulence effects, multiply ghats
!             by a factor of Lgam (McWilliam & Sullivan 2001)
!-----------------------------------------------------------------------
              if (do_wave .and. do_langmuir) then
                 ghats(i,j,ki) = Lgam * (1.-stable(i,j)) * cg    &
                        / (ws(i,j) * hbl(i,j) + epsln)
              else
                 ghats(i,j,ki) = (1.-stable(i,j)) * cg    &
                        / (ws(i,j) * hbl(i,j) + epsln)
              endif
            endif
          enddo
        enddo
      enddo

     
!-----------------------------------------------------------------------
!     find diffusivities at kbl-1 grid level 
!-----------------------------------------------------------------------

      do j=jsc,jec
        do i= isc,iec
          sig      =  Grd%zt(kbl(i,j)-1)  / (hbl(i,j)+epsln)
          sigma(i,j) =stable(i,j) * sig                  &
                   + (1.-stable(i,j)) * MIN(sig,epsilon)
        enddo

        iwscale_use_hbl_eq_zt=0
        zt_kl_dummy=0.0

        call wscale(iwscale_use_hbl_eq_zt, zt_kl_dummy, Velocity, do_wave)

        do i = isc,iec
          sig = Grd%zt(kbl(i,j)-1) / (hbl(i,j)+epsln)
          a1= sig - 2.
          a2 = 3.-2.*sig
          a3 = sig - 1.
          Gm = a1 + a2 * gat1(i,j,1) + a3 * dat1(i,j,1)
          Gs = a1 + a2 * gat1(i,j,2) + a3 * dat1(i,j,2)
          Gt = a1 + a2 * gat1(i,j,3) + a3 * dat1(i,j,3)
          dkm1(i,j,1) = hbl(i,j) * wm(i,j) * sig * (1. + sig * Gm)
          dkm1(i,j,2) = hbl(i,j) * ws(i,j) * sig * (1. + sig * Gs)
          dkm1(i,j,3) = hbl(i,j) * ws(i,j) * sig * (1. + sig * Gt)
        enddo
      enddo
      
end subroutine blmix_kpp
! </SUBROUTINE> NAME="blmix_kpp"



!#######################################################################
! <SUBROUTINE NAME="enhance">
!
! <DESCRIPTION>
! Enhance the diffusivity at the kbl-.5 interface
!
! input
!      integer kbl(ij_bounds)   =  grid above hbl                      <BR/>
!      real hbl(ij_bounds)      =  boundary layer depth (m)            <BR/>
!      real dkm1(ij_bounds,3)   =  bl diffusivity at kbl-1 grid level  <BR/>
!      real caseA(ij_bounds)    =  1 in caseA, = 0 in case B
!
! input/output
!      real ghats(ij_bounds,nk)  =  nonlocal transport     (s/m**2)     <BR/>
!      modified ghats at kbl(i)-1 interface        
! output
!      real blmc(ij_bounds,nk,3) = enhanced boundary layer mixing coefficient
!
! local
!  real delta                    =  fraction hbl lies beteen zt neighbors
!
! </DESCRIPTION>
subroutine enhance(diff_cbt, visc_cbu)

real, dimension(isd:ied,jsd:jed,nk,2) :: diff_cbt
real, dimension(isd:ied,jsd:jed,nk)   :: visc_cbu

  real    :: delta, dkmp5, dstar
  integer :: i, j, ki

      do ki=1,nk-1
        do j=jsc,jec
          do i = isc,iec

            if(ki == (kbl(i,j) - 1) ) then

              delta = (hbl(i,j)-Grd%zt(ki)) / (Grd%zt(ki+1)-Grd%zt(ki))

              dkmp5 = caseA(i,j) * visc_cbu(i,j,ki)      &
                    + (1.-caseA(i,j)) * blmc(i,j,ki,1)
              dstar = (1.-delta)**2 * dkm1(i,j,1) + delta**2 * dkmp5
              blmc(i,j,ki,1) = (1.-delta) * visc_cbu(i,j,ki)  &
                             + delta * dstar

              ! temperature:
              dkmp5 = caseA(i,j) * diff_cbt(i,j,ki,1)  &
                    + (1.-caseA(i,j)) * blmc(i,j,ki,2)
              dstar = (1.-delta)**2 * dkm1(i,j,3) + delta**2 * dkmp5    
              blmc(i,j,ki,2) = (1.-delta) * diff_cbt(i,j,ki,1)  &
                           + delta * dstar

              ! salinity:   
              dkmp5 = caseA(i,j) * diff_cbt(i,j,ki,2)  &
                    + (1.-caseA(i,j)) * blmc(i,j,ki,3)
              dstar = (1.-delta)**2 * dkm1(i,j,2) + delta**2 * dkmp5
              blmc(i,j,ki,3) = (1.-delta) * diff_cbt(i,j,ki,2)  &
                           + delta * dstar
            
              ghats(i,j,ki) = (1.-caseA(i,j)) * ghats(i,j,ki)

            endif

          enddo
        enddo
      enddo

end subroutine enhance
! </SUBROUTINE> NAME="enhance"


!#######################################################################
! <SUBROUTINE NAME="ri_for_kpp">
!
! <DESCRIPTION>
! Compute Richardson number on tracer and velocity cell bottoms. 
!  rit = richardson number at bottom of T cells <BR/>
!  riu = richardson number at bottom of U cells
! </DESCRIPTION>
!
subroutine ri_for_kpp (Time, Thickness, aidif, Velocity, theta, salinity, &
                       pressure_at_depth, rho, rho_taum1)

  type(ocean_time_type),        intent(in)  :: Time
  type(ocean_thickness_type),   intent(in)  :: Thickness
  real,                         intent(in)  :: aidif
  type(ocean_velocity_type),    intent(in)  :: Velocity
  real, dimension(isd:,jsd:,:), intent(in)  :: theta
  real, dimension(isd:,jsd:,:), intent(in)  :: salinity 
  real, dimension(isd:,jsd:,:), intent(in)  :: pressure_at_depth
  real, dimension(isd:,jsd:,:), intent(in)  :: rho
  real, dimension(isd:,jsd:,:), intent(in)  :: rho_taum1
  
  integer :: i, j, k, tlev, kmax, mr, tau, taum1
  real    :: active_cells, fx, t1, riu_prev, tmp
  real    :: coef1_int_tide, drho_int_tide

  logical :: smooth_richardson_number = .true.
  integer :: num_smoothings = 1 ! for vertical smoothing of Richardson number


  fx   = -0.25*grav*rho0r

  tau   = Time%tau
  taum1 = Time%taum1

  ! compute density difference across bottom of T cells at tau-1

  if (aidif == 1.0) then
    tlev = tau
    wrk1(:,:,:) = density_delta_z(rho(:,:,:), salinity(:,:,:), theta(:,:,:), pressure_at_depth(:,:,:))
  else
    tlev = taum1
    wrk1(:,:,:) = density_delta_z(rho_taum1(:,:,:), salinity(:,:,:), theta(:,:,:), pressure_at_depth(:,:,:))
  endif

  ! Buoyancy frequency for internal tidal mixing at the bottom of t-cell
  ! bf_int_tide, low limit is zero. no negative frequency here.
  if (int_tidal_mix) then
      do k=1,nk-1
         do j=jsd,jed
            do i=isd,ied
               coef1_int_tide=-1.*grav/(rho(i,j,k)+epsln)
               drho_int_tide=AMIN1( wrk1(i,j,k), 0.0)
               bf_int_tide(i,j,k)=SQRT( coef1_int_tide*drho_int_tide/Thickness%dzwt(i,j,k) )
            enddo
         enddo
      enddo
  endif
     


  ! compute richardson numbers on bottom of U cells due to tide
  if(coastal_tidal_mix) then 
      do k=1,nk-1
         do j=jsd,jed-1
            do i=isd,ied-1
               t1 = fx*Thickness%dzwt(i,j,k)
               riu_tide(i,j,k) = t1*Grd%umask(i,j,k+1)                                    &
                    *(wrk1(i,j+1,k) + wrk1(i+1,j+1,k) + wrk1(i,j,k)   + wrk1(i+1,j,k)) /  &
                    ( tidal_fric_turb(i,j,k) + epsln)
            enddo
         enddo
      enddo
  endif

  ! compute richardson numbers on bottom of U cells

  do k=1,nk-1
     do j=jsd,jed-1
        do i=isd,ied-1
           t1 = fx*Thickness%dzwt(i,j,k)
        riu(i,j,k) = t1*Grd%umask(i,j,k+1)*(wrk1(i,j+1,k) + wrk1(i+1,j+1,k) + wrk1(i,j,k)   + wrk1(i+1,j,k)) /&
                ((Velocity%u(i,j,k,1,tlev) - Velocity%u(i,j,k+1,1,tlev))**2 + &
                (Velocity%u(i,j,k,2,tlev) - Velocity%u(i,j,k+1,2,tlev))**2  &
                + epsln)
        enddo
     enddo
  enddo

  if (smooth_richardson_number) then

  ! smooth Richardson number in the vertical using a 1-2-1 filter:

      do mr = 1,num_smoothings
         do j=jsd,jed-1
            do i=isd,ied-1
               riu_prev    =  0.25 * riu(i,j,1)
               kmax = Grd%kmt(i,j)
               if (kmax > 0) then
                   do k=2,kmax-2
                      tmp        =  riu(i,j,k)
                      riu(i,j,k) = riu_prev + 0.5 * riu(i,j,k) + 0.25 * riu(i,j,k+1)
                      riu_prev   =  0.25 * tmp
                   enddo
               endif
            enddo
         enddo
      enddo
  endif

  ! compute richardson numbers on bottom of T cells as average
  ! of four nearest richardson numbers on bottom of U cells.
  ! (do not consider land cells in the average... only active ones)

  do k=1,nk-1
    do j=jsc,jec
      do i=isc,iec
        active_cells = Grd%umask(i,j,k+1) + Grd%umask(i-1,j,k+1) + Grd%umask(i,j-1,k+1) + Grd%umask(i-1,j-1,k+1) + epsln
        rit(i,j,k)   = (riu(i,j,k) + riu(i-1,j,k) + riu(i,j-1,k) + riu(i-1,j-1,k))/active_cells

        rit_tide(i,j,k)   = (riu_tide(i,j,k) + riu_tide(i-1,j,k) + riu_tide(i,j-1,k) + riu_tide(i-1,j-1,k))/active_cells

        ! make sure no static instability exists (one that is not seen
        ! by the Richardson number).  This may happen due to
        ! horizontal averaging used in calculating the Richardson
        ! number.

        if (rit(i,j,k) > 0.0 .and. wrk1(i,j,k) > 0.0) then
          rit(i,j,k) = -10.0
        endif
        if (rit_tide(i,j,k) > 0.0 .and. wrk1(i,j,k) > 0.0) then
          rit_tide(i,j,k) = -10.0
        endif
      enddo
    enddo
  enddo

end subroutine ri_for_kpp
! </SUBROUTINE> NAME="ri_for_kpp"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag_init">
!
! <DESCRIPTION>
! Initialization of watermass diagnostic output files. 
! </DESCRIPTION>
!
subroutine watermass_diag_init(Time, Dens)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens

  integer :: stdoutunit
  stdoutunit=stdout()
  compute_watermass_diag = .false. 


  id_neut_rho_kpp_nloc = register_diag_field ('ocean_model',      & 
    'neut_rho_kpp_nloc',                                          &
    Grd%tracer_axes(1:3), Time%model_time,                        &
    'locally referenced potrho tendency due to KPP nonlocal term',&
    '(kg/m^3)/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_neut_rho_kpp_nloc > 0) compute_watermass_diag=.true.

  id_wdian_rho_kpp_nloc = register_diag_field ('ocean_model',   &
    'wdian_rho_kpp_nloc', Grd%tracer_axes(1:3), Time%model_time,&
    'dianeutral mass transport due to KPP nonlocal term',       &
    'kg/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_wdian_rho_kpp_nloc > 0) compute_watermass_diag=.true.

  id_tform_rho_kpp_nloc = register_diag_field ('ocean_model',               & 
    'tform_rho_kpp_nloc', Grd%tracer_axes(1:3), Time%model_time,            &
    'watermass transform due to KPP nonlocal on levels (pre-layer binning)',&
    'kg/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_tform_rho_kpp_nloc > 0) compute_watermass_diag=.true.

  id_neut_rho_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                    &
    'neut_rho_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,            &
    'update of locally ref potrho from KPP nolocal as binned to neutral density layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_rho_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_rho_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                   &
    'wdian_rho_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,           &
    'dianeutral mass transport due to KPP nonlocal as binned to neutral density layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_rho_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_rho_kpp_nloc_on_nrho = register_diag_field ('ocean_model',             &
    'tform_rho_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,     &
    'watermass transform due to KPP nonlocal as binned to neutral density layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_rho_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.

  id_eta_tend_kpp_nloc= -1          
  id_eta_tend_kpp_nloc= register_diag_field ('ocean_model','eta_tend_kpp_nloc',&
       Grd%tracer_axes(1:2), Time%model_time,                                  &
       'non-Bouss steric sea level tendency from kpp_nloc tendency', 'm/s',    &
       missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_kpp_nloc > 0) compute_watermass_diag=.true.

  id_eta_tend_kpp_nloc_glob= -1          
  id_eta_tend_kpp_nloc_glob= register_diag_field ('ocean_model', 'eta_tend_kpp_nloc_glob',&
       Time%model_time,                                                                   &
       'global mean non-bouss steric sea level tendency from kpp_nloc tendency',          &
       'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_kpp_nloc_glob > 0) compute_watermass_diag=.true.


  id_neut_temp_kpp_nloc = register_diag_field ('ocean_model',                  &
    'neut_temp_kpp_nloc',                                                      &
    Grd%tracer_axes(1:3), Time%model_time,                                     &
    'temp related locally referenced potrho tendency due to KPP nonlocal term',&
    '(kg/m^3)/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_neut_temp_kpp_nloc > 0) compute_watermass_diag=.true.

  id_wdian_temp_kpp_nloc = register_diag_field ('ocean_model',        &
    'wdian_temp_kpp_nloc', Grd%tracer_axes(1:3), Time%model_time,     &
    'temp related dianeutral mass transport due to KPP nonlocal term',&
    'kg/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_wdian_temp_kpp_nloc > 0) compute_watermass_diag=.true.

  id_tform_temp_kpp_nloc = register_diag_field ('ocean_model',                           &  
    'tform_temp_kpp_nloc', Grd%tracer_axes(1:3), Time%model_time,                        &
    'temp related watermass transform due to KPP nonlocal on levels (pre-layer binning)',&
    'kg/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_tform_temp_kpp_nloc > 0) compute_watermass_diag=.true.

  id_neut_temp_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                                &
    'neut_temp_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                        &
    'temp related update of locally ref potrho from KPP nolocal as binned to neutral density layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_temp_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_temp_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                               &
    'wdian_temp_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
    'temp related dianeutral mass transport due to KPP nonlocal as binned to neutral density layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_temp_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_temp_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                         &
    'tform_temp_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                 &
    'temp related watermass transform due to KPP nonlocal as binned to neutral density layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_temp_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.



  id_neut_salt_kpp_nloc = register_diag_field ('ocean_model',                  &
    'neut_salt_kpp_nloc',                                                      &
    Grd%tracer_axes(1:3), Time%model_time,                                     &
    'salt related locally referenced potrho tendency due to KPP nonlocal term',&
    '(kg/m^3)/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_neut_salt_kpp_nloc > 0) compute_watermass_diag=.true.

  id_wdian_salt_kpp_nloc = register_diag_field ('ocean_model',        &
    'wdian_salt_kpp_nloc', Grd%tracer_axes(1:3), Time%model_time,     &
    'salt related dianeutral mass transport due to KPP nonlocal term',&
    'kg/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_wdian_salt_kpp_nloc > 0) compute_watermass_diag=.true.

  id_tform_salt_kpp_nloc = register_diag_field ('ocean_model',                           &  
    'tform_salt_kpp_nloc', Grd%tracer_axes(1:3), Time%model_time,                        &
    'salt related watermass transform due to KPP nonlocal on levels (pre-layer binning)',&
    'kg/sec',missing_value=missing_value, range=(/-1e10,1e10/))
  if(id_tform_salt_kpp_nloc > 0) compute_watermass_diag=.true.

  id_neut_salt_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                                &
    'neut_salt_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                        &
    'salt related update of locally ref potrho from KPP nolocal as binned to neutral density layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_salt_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_salt_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                               &
    'wdian_salt_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
    'salt related dianeutral mass transport due to KPP nonlocal as binned to neutral density layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_salt_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_salt_kpp_nloc_on_nrho = register_diag_field ('ocean_model',                         &
    'tform_salt_kpp_nloc_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                 &
    'salt related watermass transform due to KPP nonlocal as binned to neutral density layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_salt_kpp_nloc_on_nrho > 0) compute_watermass_diag=.true.


  if(compute_watermass_diag) then 
    write(stdoutunit,'(/a/)') &
    '==>Note: running ocean_vert_kpp_mom4p0_mod w/ compute_watermass_diag=.true.'  
  endif 

end subroutine watermass_diag_init
! </SUBROUTINE> NAME="watermass_diag_init"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag">
!
! <DESCRIPTION>
! Diagnose effects from KPP nonlocal on the watermass transformation.
! </DESCRIPTION>
!
subroutine watermass_diag(Time, T_prog, Dens)

  type(ocean_time_type),          intent(in) :: Time
  type(ocean_prog_tracer_type),   intent(in) :: T_prog(:)
  type(ocean_density_type),       intent(in) :: Dens

  integer :: i,j,k,tau
  real, dimension(isd:ied,jsd:jed) :: eta_tend

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_vert_kpp (watermass_diag): module needs initialization ')
  endif 

  if(.not. compute_watermass_diag) return 

  tau = Time%tau


  ! rho diagnostics = sum of temp and salt contributions  
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodT(i,j,k)*T_prog(index_temp)%wrk1(i,j,k) &
                        +Dens%drhodS(i,j,k)*T_prog(index_salt)%wrk1(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
           wrk5(i,j,k) =-wrk1(i,j,k)/(epsln+Dens%rho(i,j,k,tau)**2)  ! for eta_tend 
        enddo
     enddo
  enddo
  call diagnose_3d(Time, Grd, id_neut_rho_kpp_nloc, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_kpp_nloc, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_kpp_nloc, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_kpp_nloc_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_kpp_nloc_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_kpp_nloc_on_nrho, wrk4)

  if(id_eta_tend_kpp_nloc > 0 .or. id_eta_tend_kpp_nloc_glob > 0) then
      eta_tend(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               eta_tend(i,j) = eta_tend(i,j) + wrk5(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_eta_tend_kpp_nloc, eta_tend(:,:))
      call diagnose_sum(Time, Grd, Dom, id_eta_tend_kpp_nloc_glob, eta_tend, cellarea_r)
  endif


  ! temp related contribution  
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodT(i,j,k)*T_prog(index_temp)%wrk1(i,j,k) 
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo
  call diagnose_3d(Time, Grd, id_neut_temp_kpp_nloc, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_kpp_nloc, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_temp_kpp_nloc, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_kpp_nloc_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_kpp_nloc_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_kpp_nloc_on_nrho, wrk4)

  ! salt related contribution  
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodS(i,j,k)*T_prog(index_salt)%wrk1(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo
  call diagnose_3d(Time, Grd, id_neut_salt_kpp_nloc, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_kpp_nloc, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_salt_kpp_nloc, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_kpp_nloc_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_kpp_nloc_on_nrho, wrk3)
  call diagnose_3d_rho(TIme, Dens, id_tform_salt_kpp_nloc_on_nrho, wrk4)

end subroutine watermass_diag
! </SUBROUTINE>  NAME="watermass_diag"


end module ocean_vert_kpp_mom4p0_mod

module microphysics_mod

use fms_mod,                      only :  FATAL, error_mesg,  &
                                          write_version_number, &
                                          mpp_pe
use constants_mod,                only :  cp_air, hlv, hls, tfreeze,  &
                                          rdgas, grav, rvgas
use rotstayn_klein_mp_mod,        only :  rotstayn_klein_microp, &
                                          rotstayn_klein_microp_init,  &
                                          rotstayn_klein_microp_end
use morrison_gettelman_microp_mod, only : morrison_gettelman_microp,  &
                                          morrison_gettelman_microp_init, &
                                          morrison_gettelman_microp_end
use strat_cloud_utilities_mod,    only :  strat_cloud_utilities_init, &
                                          diag_id_type, diag_pt_type, &
                                          strat_nml_type, atmos_state_type,&
                                          cloud_state_type, particles_type,&
                                          strat_constants_type, &
                                          cloud_processes_type, &
                                          precip_state_type
use cldwat2m_micro_mod,           only :  ini_micro, mmicro_pcond,  &
                                          mmicro_end

implicit none
private

!------------------------------------------------------------------------
!---interfaces-----------------------------------------------------------

public  microphysics, microphysics_init, microphysics_end    



!------------------------------------------------------------------------
!---version number-------------------------------------------------------

character(len=128) :: version = '$Id: microphysics.F90,v 20.0 2013/12/13 23:21:57 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'


logical :: module_is_initialized = .false.


CONTAINS




!##########################################################################

subroutine microphysics_init (Nml)

type(strat_nml_type), intent(in) :: Nml

      if (module_is_initialized) return

!-------------------------------------------------------------------------
!    write version number to output file.
!-------------------------------------------------------------------------
      call write_version_number(version, tagname)

!-------------------------------------------------------------------------
!    make sure needed modules have been initialized.
!-------------------------------------------------------------------------
      call strat_cloud_utilities_init
      call rotstayn_klein_microp_init
      call morrison_gettelman_microp_init (Nml%do_pdf_clouds, Nml%qcvar)
      call ini_micro (Nml%qcvar)

      module_is_initialized = .true.

end subroutine microphysics_init


!##########################################################################

subroutine microphysics &         
                    (idim, jdim, kdim, Nml, Constants, N3D, Atmos_state, &
                     Cloud_state, Cloud_processes, Particles, n_diag_4d, &
                     diag_4d, diag_id, diag_pt, n_diag_4d_kp1, diag_4d_kp1,&
                     ST_out, SQ_out, Precip_state, otun, ncall, &
                     qa_upd_0, SA_0, nrefuse, isamp, jsamp, ksamp, &
                     debugo, debugo0, debugo1)    

!------------------------------------------------------------------------
type(strat_constants_type),        intent(inout) :: Constants     
type(atmos_state_type),            intent(inout) :: Atmos_state
type(cloud_state_type),            intent(inout) :: Cloud_state
type(precip_state_type),           intent(inout) :: Precip_state
type(cloud_processes_type),        intent(inout) :: Cloud_processes
type(particles_type),              intent(inout) :: Particles
integer,                           intent(inout) :: nrefuse         
integer,                           intent(in)    :: idim, jdim, kdim, &
                                                    n_diag_4d, otun, ncall,&
                                                    n_diag_4d_kp1, isamp, &
                                                    jsamp, ksamp
type(strat_nml_type),              intent(in)    :: Nml
logical,                           intent(in)    :: debugo, debugo0, debugo1
real, dimension (idim,jdim,kdim),  intent(in)    :: N3D 
 real, dimension(idim,jdim,kdim),  intent(inout) :: ST_out,SQ_out,    &
                                                    qa_upd_0, SA_0   
real, dimension(idim,jdim,kdim,0:n_diag_4d),                &
                                   intent(inout) :: diag_4d
real, dimension(idim,jdim,kdim+1,0:n_diag_4d_kp1),               &
                                   intent(inout) :: diag_4d_kp1
type(diag_id_type),                intent(in)    :: diag_id
type(diag_pt_type),                intent(inout) :: diag_pt

!------------------------------------------------------------------------
!---local variables------------------------------------------------------

      real, dimension(idim,jdim,kdim,4) :: rbar_dust_4bin, ndust_4bin
      real, dimension(idim,jdim,kdim)   :: ST_micro, SQ_micro, SL_micro, &
                                           SI_micro, SN_micro, SNI_micro
      real, dimension(idim,jdim,kdim)   :: D_eros_l, D_eros_i,  &
                                           nerosc, nerosi,    &
                                           dqcdt, dqidt, &
                                           qa_new, &
                                           ssat_disposal, &
                                           ql_new,  qi_new,              &
                                           nctend, nitend, qn_new, qni_new
      real, dimension(idim,jdim,kdim)   :: rho, liqcldf, icecldf, tmp2s
      real, dimension(idim,jdim)        :: m1, m2, scalef
      integer                           :: i,j,k


!------------------------------------------------------------------------
!    call selected microphysics scheme.
!------------------------------------------------------------------------
      if (Constants%do_rk_microphys ) then

!------------------------------------------------------------------------
!    Rotstayn-Klein microphysics
!------------------------------------------------------------------------
        call rotstayn_klein_microp ( &
                         idim, jdim, kdim,  Nml, N3D,     &
                         Constants%overlap, Constants%dtcloud,  &
                         Constants%inv_dtcloud, Atmos_state%pfull,&
                         Atmos_state%deltpg, Atmos_state%airdens,     &
                         Constants%mask_present, Constants%mask, &
                         Atmos_state%esat0, Cloud_state%ql_in,  &
                         Cloud_state%qi_in, Cloud_state%qa_in,   &
                         Cloud_state%ql_mean, Cloud_state%qa_mean, &
                         Cloud_state%qn_mean, Atmos_state%omega,  &
                         Atmos_state%T_in, Atmos_state%U_ca, &
                         Atmos_state%qv_in, Atmos_state%qs,  &
                         Cloud_processes%D_eros, Cloud_processes%dcond_ls, &
                         Cloud_processes% dcond_ls_ice,         &
                         Cloud_processes%qvg, Atmos_state%gamma,   &
                         Cloud_processes%delta_cf, Particles%drop1,    &
                         Particles%concen_dust_sub, Cloud_state%ql_upd,   &
                         Cloud_state%qi_upd, Cloud_state%qn_upd,       & 
                         Cloud_state%qi_mean, Cloud_state%qa_upd,   &
                         Atmos_state%ahuco, n_diag_4d, diag_4d, diag_id, &
                         diag_pt, n_diag_4d_kp1, diag_4d_kp1,  &
                         Constants%limit_conv_cloud_frac, &
                         Cloud_state%SA_out, Cloud_state%SN_out,        & 
                         ST_out, SQ_out, Cloud_state%SL_out,  &
                         Cloud_state%SI_out, Precip_state%rain3d,  &
                         Precip_state%snow3d, Precip_state%snowclr3d,    &
                         Precip_state%surfrain, Precip_state%surfsnow,  &
                         Cloud_processes%f_snow_berg, otun)                 
      else   !if (Constants%do_rk_microphys ) 

!--------------------------------------------------------------------------
!     for morrison-gettelman and NCAR, some additional fields are needed. 
!     for droplet activation Yi's drop1 is used. 
!--------------------------------------------------------------------------
        do k=1,kdim
          do j=1,jdim
            do i=1,idim
              Particles%drop2(i,j,k) = Particles%drop1(i,j,k)*  &
                                          1.e6/Atmos_state%airdens(i,j,k)
              Cloud_processes%dcond_ls_tot(i,j,k) =   &
                               Cloud_processes%dcond_ls(i,j,k) +   &
                                      Cloud_processes%dcond_ls_ice(i,j,k) 
              Atmos_state%tn(i,j,k) = Atmos_state%T_in(i,j,k) +   &
                                                             ST_out(i,j,k)
              Atmos_state%qvn(i,j,k) = Atmos_state%qv_in(i,j,k) + &
                                                              SQ_out(i,j,k)
              if (Constants%tiedtke_macrophysics) then
                D_eros_i(i,j,k) = -Cloud_state%qi_upd(i,j,k)* &
                                        Cloud_processes%D_eros(i,j,k)/ &
                                                     Constants%dtcloud
                D_eros_l(i,j,k) = -Cloud_state%ql_upd(i,j,k)* &
                                        Cloud_processes%D_eros(i,j,k)/ &
                                                     Constants%dtcloud
                if (Cloud_state%ql_upd(i,j,k) >= Nml%qmin) then
                  nerosc(i,j,k) = D_eros_l(i,j,k)/  &
                                      Cloud_state%ql_upd(i,j,k)* &
                               Cloud_state%qn_upd(i,j,k)/MAX(0.0001, &
                                               Cloud_state%qa_upd(i,j,k))
                else
                  nerosc(i,j,k) = 0.
                endif
                if (Cloud_state%qi_upd(i,j,k) >= Nml%qmin) then
                  nerosi(i,j,k) = D_eros_i(i,j,k)/   &
                                          Cloud_state%qi_upd(i,j,k)* &
                               Cloud_state%qni_upd(i,j,k)/MAX(0.0001, &
                                              Cloud_state%qa_upd(i,j,k))
                else
                  nerosi(i,j,k) = 0.
                endif
                if (Cloud_processes%dcond_ls_tot(i,j,k) > 0.) then
                  if (Atmos_state%tn(i,j,k) <= (tfreeze - 40.) ) then
                    dqcdt (i,j,k) = 0.
                    dqidt(i,j,k) = Cloud_processes%dcond_ls_tot(i,j,k)* &
                                                 Constants%inv_dtcloud
                  else
                    dqidt (i,j,k) = 0.
                    dqcdt(i,j,k) = Cloud_processes%dcond_ls_tot(i,j,k)*  &
                                                 Constants%inv_dtcloud
                  endif
                else
                  if (Atmos_state%tn(i,j,k) <= tfreeze) then
                    dqcdt(i,j,k) = MAX(Cloud_processes%dcond_ls_tot(i,j,k),&
                              -Cloud_state%ql_upd(i,j,k))
                    dqidt(i,j,k) = MAX(Cloud_processes%dcond_ls_tot(i,j,k) &
                              - dqcdt(i,j,k), -Cloud_state%qi_upd(i,j,k))
                    dqcdt(i,j,k) = dqcdt(i,j,k)* Constants%inv_dtcloud
                    dqidt(i,j,k) = dqidt(i,j,k)* Constants%inv_dtcloud
                  else
                    dqidt(i,j,k) = 0.
                    dqcdt(i,j,k) = MAX(Cloud_processes%dcond_ls_tot(i,j,k),&
                                           -Cloud_state%ql_upd(i,j,k))* &
                                                 Constants%inv_dtcloud
                  endif
                endif
              else
                dqidt(i,j,k) = 0.
                dqcdt(i,j,k) = 0.
                nerosi(i,j,k) = 0.
                nerosc(i,j,k) = 0.
                D_eros_l(i,j,k) = 0.                             
                D_eros_i(i,j,k) = 0.                             
              endif
            end do
          end do   
        end do   

        if (Constants%do_mg_microphys) then

          do j=1,jdim

!------------------------------------------------------------------------
!    if debugging is activated, output the temp tendency prior to
!    microphysics.
!------------------------------------------------------------------------
            if (debugo) then
              if ( j .eq. jsamp) then
                write(otun, *) " ST samp bef mg ", ST_out(isamp,jsamp,ksamp)
              end if
            endif
!-------------------------------------------------------------------------
!    call morrison-gettelman microphysics package.
!-------------------------------------------------------------------------
            call morrison_gettelman_microp( &
                  Constants%tiedtke_macrophysics, &
                  Constants%total_activation, Constants%dqa_activation, &
                  ncall, j ,idim, jdim, kdim, Nml, &
                  Constants%dtcloud, Atmos_state%pfull(:,j,:),  &
                  Atmos_state%delp(:,j,:),                          &
                  Atmos_state%tn(:,j,:),  Atmos_state%T_in(:,j,:),    &
                  Atmos_state%qvn(:,j,:), Atmos_state%qv_in(:,j,:),  &
                  Cloud_state%ql_upd(:,j,:), Cloud_state%qi_upd(:,j,:), &
                  Cloud_state%qn_upd(:,j,:), Cloud_state%qni_upd(:,j,:), &
                  Cloud_state%qa_upd(:,j,:),  &
                  dqcdt(:,j,:), dqidt(:,j,:), &
                  Particles%drop2(:,j,:), Particles%crystal1(:,j,:), &
                  Particles%rbar_dust(:,j,:), Particles%ndust(:,j,:),    &
                  Cloud_processes%delta_cf(:,j,:),    &
                  Cloud_state%qa_upd(:,j,:), &
                  qa_upd_0(:,j,:), SA_0(:,j,:), D_eros_l(:,j,:),  &
                  nerosc(:,j,:),  D_eros_i(:,j,:), nerosi(:,j,:), &
                  Atmos_state%gamma(:,j,:), &
                  Constants%inv_dtcloud, Cloud_state%qa_in(:,j,:),     &
                  ST_out(:,j,:), SQ_out(:,j,:), ssat_disposal(:,j,:), &
                  ST_micro(:,j,:), SQ_micro(:,j,:),&
                  SL_micro(:,j,:), SI_micro(:,j,:),  &
                  SN_micro(:,j,:), SNI_micro(:,j,:),&
                  Cloud_state%SA_out(:,j,:),  &
                  Precip_state%rain3d, Precip_state%snow3d,  &
                  Precip_state%surfrain(:,j), Precip_state%surfsnow(:,j), &
                  Precip_state%lsc_rain(:,j,:),   &
                  Precip_state%lsc_snow(:,j,:), &
                  Precip_state%lsc_rain_size(:,j,:),   &
                  Precip_state%lsc_snow_size(:,j,:), &
                  Cloud_processes%f_snow_berg(:,j,:), &
                  n_diag_4d, diag_4d, diag_id, &
                  diag_pt, nrefuse, debugo0, debugo1, otun)    

!------------------------------------------------------------------------
!    if debugging is activated, output the temp tendency after microphysics.
!------------------------------------------------------------------------
            IF (debugo) THEN
              if ( j .eq. jsamp) then
                write(otun, *) " ST samp aft mg ", ST_out(isamp,jsamp,ksamp)
              end if
            END IF
          end do   ! j loop

        else if (Constants%do_mg_ncar_microphys) then  !(do_mg_microphys) 
!-------------------------------------------------------------------------
!    use ncar maintained version of microphysics
!-------------------------------------------------------------------------
!  are these the actual bin centers, or arbitrary values ??
          rbar_dust_4bin(:,:,:,1) = 5.0e-6
          rbar_dust_4bin(:,:,:,2) = 10.0e-6
          rbar_dust_4bin(:,:,:,3) = 15.0e-6
          rbar_dust_4bin(:,:,:,4) = 20.0e-6
          ndust_4bin = 0.0
!         ndust_4bin(:,j,:,1) = 0.25*Particles%ndust(:,j,:) 
!         ndust_4bin(:,j,:,2) = 0.25*Particles%ndust(:,j,:) 
!         ndust_4bin(:,j,:,3) = 0.25*Particles%ndust(:,j,:) 
!         ndust_4bin(:,j,:,4) = 0.25*Particles%ndust(:,j,:) 

          

!-------------------------------------------------------------------------
!    call microphysics package as maintained at NCAR.
!-------------------------------------------------------------------------
          do k=1,kdim
            do j=1,jdim
              do i=1,idim
                rho(i,j,k) = Atmos_state%pfull(i,j,k)/   &
                                            (rdgas*Atmos_state%tn(i,j,k))
                liqcldf(i,j,k) = Cloud_state%qa_upd(i,j,k)
                icecldf(i,j,k) = Cloud_state%qa_upd(i,j,k)
              end do
            end do
          end do

          do j=1,jdim
            call mmicro_pcond( &
                   Constants%dqa_activation, &
                   Constants%total_activation, &
                   Constants%tiedtke_macrophysics, &
                   .false., j ,jdim, kdim, idim, idim,  &
                   Constants%dtcloud,    &
                   Atmos_state%tn(:,j,:),     &
                   Atmos_state%qvn(:,j,:),   &
                   Cloud_state%ql_upd(:,j,:), Cloud_state%qi_upd(:,j,:), &
                   Cloud_state%qn_upd(:,j,:), Cloud_state%qni_upd(:,j,:), &
                   Atmos_state%pfull(:,j,:),  &
                   Atmos_state%delp(:,j,:),   &
                   Cloud_state%qa_upd(:,j,:),  &
                   liqcldf(:,j,:)       , icecldf(:,j,:),   & 
                   Cloud_processes%delta_cf(:,j,:), &
                   D_eros_l(:,j,:), nerosc(:,j,:), &
                   D_eros_i(:,j,:), nerosi(:,j,:), &
                   dqcdt(:,j,:), dqidt(:,j,:), &
                   Particles%crystal1(:,j,:)/rho(:,j,:), &
                   Particles%drop2(:,j,:),   &
                   rbar_dust_4bin(:,j,:,:), ndust_4bin(:,j,:,:), &
                   ST_micro(:,j,:), SQ_micro(:,j,:), SL_micro(:,j,:), &
                   SI_micro(:,j,:), SN_micro(:,j,:), SNI_micro(:,j,:), &
                   Precip_state%surfrain(:,j),   &
                   Precip_state%surfsnow(:,j),   &
                   Precip_state%rain3d(:,j,:),   &
                   Precip_state%snow3d(:,j,:),   &
                   Precip_state%lsc_rain(:,j,:),   &
                   Precip_state%lsc_snow(:,j,:), &
                   Precip_state%lsc_rain_size(:,j,:),   &
                   Precip_state%lsc_snow_size(:,j,:), &
                   Cloud_processes%f_snow_berg(:,j,:), &

                   Nml, Cloud_state%qa_in(:,j,:), Atmos_state%gamma(:,j,:),&
                   SA_0(:,j,:), Cloud_state%SA_out(:,j,:),  &

                   ssat_disposal (:,j,:), &
                   n_diag_4d, diag_4d, diag_id, &
                   diag_pt)    
          end do


!-------------------------------------------------------------------------
!    exit with error if no valid microphysics scheme was specified.
!-------------------------------------------------------------------------
        else  
          call error_mesg ('strat_cloud/microphysics', &
              'invalid strat_cloud_nml microphys_scheme option', FATAL)
        endif    

!------ POST MICROPHYSICS ROUTINE CALL


        if (Nml%mass_cons) then
          do j=1,jdim
            do i=1,idim
              m1(i,j) = 0.
              do k=1,kdim
 
                m1(i,j) = m1(i,j) +   &
                   (SQ_micro(i,j,k) + SL_micro(i,j,k) + SI_micro(i,j,k))*  &
                             Constants%dtcloud*Atmos_state%delp(i,j,k)/grav
              end do
              m2(i,j) = 1.e3*Precip_state%surfrain(i,j)*Constants%dtcloud
              if (m2(i,j) .NE. 0.0) THEN
                scalef(i,j) = -m1(i,j)/m2(i,j)
 
                IF ( diag_id%rain_mass_conv > 0   ) &
                     diag_4d(i,j,1,diag_pt%rain_mass_conv) =   &
                       (scalef(i,j)*Precip_state%surfrain(i,j) -    &
                              Precip_state%surfrain(i,j))/Constants%dtcloud
                IF ( diag_id%snow_mass_conv > 0   ) &
                     diag_4d(i,j,1,diag_pt%snow_mass_conv) =   &
                        (scalef(i,j)*Precip_state%surfsnow(i,j) -  &
                              Precip_state%surfsnow(i,j))/Constants%dtcloud
 
                Precip_state%surfrain(i,j) =    &
                                     scalef(i,j)*Precip_state%surfrain(i,j)
                Precip_state%surfsnow(i,j) =    &
                                     scalef(i,j)*Precip_state%surfsnow(i,j)
              end if
            end do
          end do
        end if 

        if (diag_id%neg_rain > 0) &
              diag_4d(:,:,1,diag_pt%neg_rain) = 1.0e3*    &
               (Precip_state%surfrain(:,:) - Precip_state%surfsnow(:,:))* &
                                                        Constants%dtcloud
        if (diag_id%neg_snow > 0) &
             diag_4d(:,:,1,diag_pt%neg_snow) = 1.0e3*    &
                          (Precip_state%surfsnow(:,:))*Constants%dtcloud 

        Precip_state%surfrain = max(     &
           1.e3*(Precip_state%surfrain - Precip_state%surfsnow)*   &
                                                Constants%dtcloud , 0.0) 
        Precip_state%surfsnow = max(    &
              1.e3*Precip_state%surfsnow*Constants%dtcloud, 0.0)

        if (diag_id%neg_rain > 0) &
              diag_4d(:,:,1,diag_pt%neg_rain) =   &
                     -1.0*( (Precip_state%surfrain(:,:))  -   &
                                    diag_4d(:,:,1,diag_pt%neg_rain))/   &
                                                      (Constants%dtcloud) 
        if (diag_id%neg_snow > 0) &
             diag_4d(:,:,1,diag_pt%neg_snow) =   &
                      -1.0*( (Precip_state%surfsnow(:,:))  -   &
                                    diag_4d(:,:,1,diag_pt%neg_snow))/ &
                                                       (Constants%dtcloud) 

        ST_out = ST_out + ST_micro/cp_air*Constants%dtcloud
        SQ_out = SQ_out + SQ_micro*Constants%dtcloud
        Cloud_state%SL_out = Cloud_state%SL_out +   &
                                              SL_micro*Constants%dtcloud
        Cloud_state%SI_out = Cloud_state%SI_out +   &
                                              SI_micro*Constants%dtcloud
        Cloud_state%SN_out = Cloud_state%SN_out +   &
                                              SN_micro*Constants%dtcloud
        Cloud_state%SNI_out = Cloud_state%SNI_out +   &
                                              SNI_micro*Constants%dtcloud

!next time:  Get rid of nctend nitend.  simply update SN_out within the 
! loops below where nitend is updated.
        nctend = 0.
        nitend = 0.


!  tiedtke macrophysics --> cloud area adjustment required due to removing supersaturation 
        if (Constants%tiedtke_macrophysics .and.    &
                                         .not. Nml%do_pdf_clouds) then
          do k=1,kdim
            do j=1,jdim
              do i=1,idim
                rho(i,j,k) = Atmos_state%pfull(i,j,k)/   &
                                        (rdgas*Atmos_state%tn(i,j,k))
                if (Constants%limit_conv_cloud_frac) then
                  tmp2s(i,j,k) = Atmos_state%ahuco(i,j,k)
                else
                  tmp2s(i,j,k) = 0.
                endif
                if (ssat_disposal(i,j,k) == 2.) then
!  ming_activation --> additional aerosol activation proportional to change
!                      in cloud area due to supersaturation removal
                  nitend(i,j,k) = Particles%crystal1(i,j,k)/rho(i,j,k)*  &
                                  (1. - Cloud_state%qa_upd(i,j,k) -  &
                                           tmp2s(i,j,k))/Constants%dtcloud
                  if (diag_id%qnidt_super + diag_id%qni_super_col > 0 ) &
                      diag_4d(i,j,k,diag_pt%qnidt_super ) =    &
                         Particles%crystal1(i,j,k)/rho(i,j,k)*     &
                        (1. - Cloud_state%qa_upd(i,j,k) - tmp2s(i,j,k))/  &
                                                          Constants%dtcloud
                else if (ssat_disposal(i,j,k) == 1.) then
                  nctend(i,j,k) = Particles%drop2(i,j,k)*   &
                                  (1. - Cloud_state%qa_upd(i,j,k) -   &
                                           tmp2s(i,j,k))/Constants%dtcloud
                  if (diag_id%qndt_super + diag_id%qn_super_col > 0 ) &
                      diag_4d(i,j,k,diag_pt%qndt_super ) =    &
                        Particles%drop2(i,j,k)*   &
                        (1. - Cloud_state%qa_upd(i,j,k) - tmp2s(i,j,k))/  &
                                                           Constants%dtcloud
                endif
                if (ssat_disposal(i,j,k) > 0.0) then
                  if (max(diag_id%qadt_super,diag_id%qa_super_col) > 0) then
                    diag_4d(i,j,k,diag_pt%qadt_super ) =   &
                         (1. - Cloud_state%qa_upd(i,j,k) - tmp2s(i,j,k))* &
                                                       Constants%inv_dtcloud
                  end if
                  Cloud_state%SA_out(i,j,k) = Cloud_state%SA_out(i,j,k) + &
                             (1. - Cloud_state%qa_upd(i,j,k) - tmp2s(i,j,k))  
                  Cloud_state%qa_upd(i,j,k) = 1. - tmp2s(i,j,k)     
                endif
              end do
            end do
          end do
        end if 

        Cloud_state%SN_out = Cloud_state%SN_out + nctend*Constants%dtcloud
        Cloud_state%SNI_out = Cloud_state%SNI_out + nitend*Constants%dtcloud

!-----------------------------------------------------------------------
!       Cloud Destruction
!-----------------------------------------------------------------------
        ql_new  = Cloud_state%ql_in  + Cloud_state%SL_out 
        qi_new  = Cloud_state%qi_in  + Cloud_state%SI_out
        qn_new  = Cloud_state%qn_in  + Cloud_state%SN_out         
        qni_new = Cloud_state%qni_in + Cloud_state%SNi_out         
        do k=1,kdim
          do j=1,jdim
            do i=1,idim
              if ((ql_new(i,j,k) <= NMl%qmin  .and.    &
                   qi_new(i,j,k) <= Nml%qmin)   .or.   &
                  (Cloud_state%qa_upd(i,j,k) <= Nml%qmin)) then
                Cloud_state%SL_out(i,j,k) = Cloud_state%SL_out(i,j,k) -  &
                                                              ql_new(i,j,k)
                Cloud_state%SI_out(i,j,k) = Cloud_state%SI_out(i,j,k) -  &
                                                              qi_new(i,j,k)
                Cloud_state%SA_out(i,j,k) = Cloud_state%SA_out(i,j,k) -  &
                                                  Cloud_state%qa_upd(i,j,k)
                ST_out(i,j,k) = ST_out(i,j,k) -    &
                              (hlv*ql_new(i,j,k) + hls*qi_new(i,j,k))/cp_air
                SQ_out(i,j,k) = SQ_out(i,j,k) +    &
                                           (ql_new(i,j,k) + qi_new(i,j,k))
                Cloud_state%SN_out(i,j,k) = Cloud_state%SN_out(i,j,k) -  &
                                                             qn_new(i,j,k)
                Cloud_state%SNi_out(i,j,k) = Cloud_state%SNi_out(i,j,k) -  &
                                                            qni_new(i,j,k)
                if (diag_id%qldt_destr > 0 .or. diag_id%ql_destr_col > 0) &
                    diag_4d(i,j,k,diag_pt%qldt_destr) =    &
                                          - ql_new(i,j,k)/Constants%dtcloud
                if (diag_id%qidt_destr > 0 .or. diag_id%qi_destr_col > 0) &
                    diag_4d(i,j,k,diag_pt%qidt_destr) =    &
                                          - qi_new(i,j,k)/Constants%dtcloud
                if (diag_id%qadt_destr > 0 .or. diag_id%qa_destr_col > 0) &
                    diag_4d(i,j,k,diag_pt%qadt_destr) =     &
                              - Cloud_state%qa_upd(i,j,k)/Constants%dtcloud
                if (diag_id%qndt_destr > 0 .or. diag_id%qn_destr_col > 0) &
                    diag_4d(i,j,k,diag_pt%qndt_destr) =   &
                                        - qn_new(i,j,k)/Constants%dtcloud
                if (diag_id%qnidt_destr + diag_id%qni_destr_col > 0) &
                    diag_4d(i,j,k,diag_pt%qnidt_destr) =   &
                                      - qni_new(i,j,k)/Constants%dtcloud
                if (diag_id%qdt_destr + diag_id%q_destr_col > 0) &
                    diag_4d(i,j,k,diag_pt%qdt_destr) =   &
                         (ql_new(i,j,k) + qi_new(i,j,k))/Constants%dtcloud
              endif
            end do
          end do
        end do

        ql_new  =  Cloud_state%ql_in  + Cloud_state%SL_out 
        qi_new  =  Cloud_state%qi_in  + Cloud_state%SI_out
        qn_new  =  Cloud_state%qn_in  + Cloud_state%SN_out
        qni_new =  Cloud_state%qni_in + Cloud_state%SNI_out
        do k=1,kdim
          do j=1,jdim
            do i=1,idim
              if (abs(ql_new(i,j,k)) .le. Nml%qmin  .and.  &
                 Atmos_state%qv_in(i,j,k) + SQ_out(i,j,k) +   &
                                                 ql_new(i,j,k) > 0.0) then
                Cloud_state%SL_out(i,j,k) =  - Cloud_state%ql_in(i,j,k)
                SQ_out(i,j,k) = SQ_out(i,j,k) + ql_new(i,j,k)
                ST_out(i,j,k) = ST_out(i,j,k) - (hlv*ql_new(i,j,k))/cp_air
                if (diag_id%qdt_cleanup_liquid +    &
                    diag_id%q_cleanup_liquid_col > 0) &
                    diag_4d(i,j,k,diag_pt%qdt_cleanup_liquid) =   &
                                         ql_new(i,j,k)/Constants%dtcloud
                Cloud_state%SN_out(i,j,k) = Cloud_state%SN_out(i,j,k) -   &
                                                             qn_new(i,j,k) 
                if (diag_id%qndt_cleanup + diag_id%qn_cleanup_col > 0) &
                    diag_4d(i,j,k,diag_pt%qndt_cleanup) = - qn_new(i,j,k)/ &
                                                          Constants%dtcloud
              endif
            end do
          end do
        end do

        do k=1,kdim
          do j=1,jdim
            do i=1,idim
              if (abs(qi_new(i,j,k)) .le. Nml%qmin  .and.  &
                  Atmos_state%qv_in(i,j,k) + SQ_out(i,j,k) +   &
                                                qi_new(i,j,k) > 0.0) then
                Cloud_state%SI_out(i,j,k) =  - Cloud_state%qi_in(i,j,k)
                SQ_out(i,j,k) = SQ_out(i,j,k) + qi_new(i,j,k)
                ST_out(i,j,k) = ST_out(i,j,k) - (hls*qi_new(i,j,k))/cp_air
                if (diag_id%qdt_cleanup_ice +    &
                    diag_id%q_cleanup_ice_col > 0) &
                    diag_4d(i,j,k,diag_pt%qdt_cleanup_ice) =   &
                                          qi_new(i,j,k)/Constants%dtcloud
                Cloud_state%SNI_out(i,j,k) = Cloud_state%SNI_out(i,j,k) -  &
                                                             qni_new(i,j,k) 
                if (diag_id%qnidt_cleanup + diag_id%qni_cleanup_col > 0) &
                    diag_4d(i,j,k,diag_pt%qnidt_cleanup) =     &
                                     - qni_new(i,j,k)/Constants%dtcloud
              endif
            end do
          end do
        end do
    
        do k=1,kdim
          do j=1,jdim
            do i=1,idim
              if (diag_id%qnidt_cleanup2 + diag_id%qni_cleanup2_col > 0) &
                  diag_4d(i,j,k,diag_pt%qnidt_cleanup2) =   &
                                               Cloud_state%SNi_out(i,j,k)
              Cloud_state%SNi_out(i,j,k) = MAX(Cloud_state%SNi_out(i,j,k), &
                                              - Cloud_state%qni_in(i,j,k))
              if (diag_id%qnidt_cleanup2 + diag_id%qni_cleanup2_col > 0) &
                  diag_4d(i,j,k,diag_pt%qnidt_cleanup2) =    &
                        (diag_4d(i,j,k,diag_pt%qnidt_cleanup2) -   &
                          Cloud_state%SNi_out(i,j,k))*Constants%inv_dtcloud
            end do
          end do
        end do

        do k=1,kdim
          do j=1,jdim
            do i=1,idim
              if (diag_id%qndt_cleanup2 + diag_id%qn_cleanup2_col > 0) &
                  diag_4d(i,j,k,diag_pt%qndt_cleanup2) =    &
                                                 Cloud_state%SN_out(i,j,k)
              Cloud_state%SN_out(i,j,k) = MAX(Cloud_state%SN_out(i,j,k),  &
                                              - Cloud_state%qn_in(i,j,k))
              if (diag_id%qndt_cleanup2 + diag_id%qn_cleanup2_col > 0) &
                  diag_4d(i,j,k,diag_pt%qndt_cleanup2) =    &
                         (diag_4d(i,j,k,diag_pt%qndt_cleanup2) -   &
                            Cloud_state%SN_out(i,j,k))*Constants%inv_dtcloud
            end do
          end do
        end do

        if (diag_id%qadt_destr + diag_id%qa_destr_col > 0)    &
            diag_4d(:,:,:,diag_pt%qadt_destr) =    &
                   diag_4d(:,:,:,diag_pt%qadt_destr) +    &
                                 Cloud_state%SA_out*Constants%inv_dtcloud

        qa_new = Cloud_state%qa_in + Cloud_state%SA_out
        where ( abs(qa_new) .le. Nml%qmin )
          Cloud_state%SA_out  = -Cloud_state%qa_in
        endwhere

        if (diag_id%qadt_destr + diag_id%qa_destr_col > 0)    &
            diag_4d(:,:,:,diag_pt%qadt_destr) =    &
                   diag_4d(:,:,:,diag_pt%qadt_destr) -     &
                                Cloud_state%SA_out*Constants%inv_dtcloud

        if (diag_id%qadt_limits + diag_id%qa_limits_col > 0)    &
            diag_4d(:,:,:,diag_pt%qadt_limits) = Cloud_state%SA_out(:,:,:)

        Cloud_state%SA_out = MAX(Cloud_state%SA_out,-Cloud_state%qa_in)
        Cloud_state%SA_out = MIN(Cloud_state%SA_out,   &
                                1. - Atmos_state%ahuco - Cloud_state%qa_in)
      endif ! rotstayn
!------------------------------------------------------------------------


end subroutine microphysics


!#######################################################################

subroutine microphysics_end (Nml)

type(strat_nml_type), intent(in) :: Nml

      if (.not. module_is_initialized) return

      call rotstayn_klein_microp_end 
      call morrison_gettelman_microp_end (Nml%do_pdf_clouds)

      module_is_initialized = .false.


end subroutine microphysics_end

!#######################################################################



end module microphysics_mod

module mpp_parameter_mod
#include <fms_platform.h>

  implicit none
  private

  character(len=128), public :: version= &
       '$Id mpp_parameter.F90 $'
  character(len=128), public :: tagname= &
       '$Name$'

  !--- public paramters which is used by mpp_mod and its components. 
  !--- All othere modules should import these parameters from mpp_mod. 
  public :: MAXPES, MPP_VERBOSE, MPP_DEBUG, ALL_PES, ANY_PE, NULL_PE, NOTE, WARNING, FATAL
  public :: MPP_WAIT, MPP_READY, MAX_CLOCKS, MAX_EVENT_TYPES, MAX_EVENTS, MPP_CLOCK_SYNC
  public :: MPP_CLOCK_DETAILED, CLOCK_COMPONENT, CLOCK_SUBCOMPONENT, CLOCK_MODULE_DRIVER
  public :: CLOCK_MODULE, CLOCK_ROUTINE, CLOCK_LOOP, CLOCK_INFRA, MAX_BINS
  public :: EVENT_ALLREDUCE, EVENT_BROADCAST, EVENT_RECV, EVENT_SEND, EVENT_WAIT
  public :: EVENT_ALLTOALL
  public :: DEFAULT_TAG
  public :: COMM_TAG_1,  COMM_TAG_2,  COMM_TAG_3,  COMM_TAG_4
  public :: COMM_TAG_5,  COMM_TAG_6,  COMM_TAG_7,  COMM_TAG_8
  public :: COMM_TAG_9,  COMM_TAG_10, COMM_TAG_11, COMM_TAG_12
  public :: COMM_TAG_13, COMM_TAG_14, COMM_TAG_15, COMM_TAG_16
  public :: COMM_TAG_17, COMM_TAG_18, COMM_TAG_19, COMM_TAG_20
  public :: MPP_FILL_INT,MPP_FILL_DOUBLE

  !--- public paramters which is used by mpp_domains_mod and its components. 
  !--- All othere modules should import these parameters from mpp_domains_mod. 
  public :: GLOBAL_DATA_DOMAIN, CYCLIC_GLOBAL_DOMAIN, BGRID_NE, BGRID_SW, CGRID_NE, CGRID_SW
  public :: DGRID_NE, DGRID_SW, FOLD_WEST_EDGE, FOLD_EAST_EDGE, FOLD_SOUTH_EDGE, FOLD_NORTH_EDGE
  public :: WUPDATE, EUPDATE, SUPDATE, NUPDATE, XUPDATE, YUPDATE, BITWISE_EXACT_SUM, NON_BITWISE_EXACT_SUM
  public :: MPP_DOMAIN_TIME, WEST, EAST, SOUTH, NORTH, SCALAR_BIT, SCALAR_PAIR, BITWISE_EFP_SUM
  public :: NORTH_EAST, SOUTH_EAST, SOUTH_WEST, NORTH_WEST
  public :: AGRID, GLOBAL, CYCLIC, DOMAIN_ID_BASE, CENTER, CORNER
  public :: MAX_DOMAIN_FIELDS, MAX_TILES
  public :: ZERO, NINETY, MINUS_NINETY, ONE_HUNDRED_EIGHTY
  public :: NONBLOCK_UPDATE_TAG, EDGEUPDATE, EDGEONLY

  !--- public paramters which is used by mpp_domains_mod and its components. 
  !--- All othere modules should import these parameters from mpp_io_mod. 
  public :: MPP_WRONLY, MPP_RDONLY, MPP_APPEND, MPP_OVERWR, MPP_ASCII, MPP_IEEE32
  public :: MPP_NATIVE, MPP_NETCDF, MPP_SEQUENTIAL, MPP_DIRECT, MPP_SINGLE, MPP_MULTI
  public :: MPP_DELETE, MPP_COLLECT, NULLUNIT, NULLTIME
  public :: MAX_FILE_SIZE, ROOT_GLOBAL, GLOBAL_ROOT_ONLY

  !--- The following paramters are used by mpp_mod and its components.
  integer, parameter :: MAXPES=2048            !used for dimensioning stuff that might be indexed by pe
  integer, parameter :: MPP_VERBOSE=1, MPP_DEBUG=2
  integer, parameter :: ALL_PES=-1, ANY_PE=-2, NULL_PE=-3
  integer, parameter :: NOTE=0, WARNING=1, FATAL=2
  integer, parameter :: MAX_CLOCKS=400, MAX_EVENT_TYPES=5, MAX_EVENTS=40000
  integer, parameter :: EVENT_ALLREDUCE=1, EVENT_BROADCAST=2, EVENT_RECV=3, EVENT_SEND=4, EVENT_WAIT=5
  integer, parameter :: EVENT_ALLTOALL=6
  integer, parameter :: MPP_CLOCK_SYNC=1, MPP_CLOCK_DETAILED=2
  integer            :: DEFAULT_TAG = 1
  !--- implimented to centralize _FILL_ values for land_model.F90 into mpp_mod
  !------- instead of multiple includes of netcdf.inc and manual assignments
  integer, parameter :: MPP_FILL_INT =-2147483647               !NF_FILL_INT
  real,    parameter :: MPP_FILL_DOUBLE= 9.9692099683868690e+36 !NF_FILL_DOUBLE
  !--- predefined clock granularities, but you can use any integer
  !--- using CLOCK_LOOP and above may distort coarser-grain measurements
  integer, parameter :: CLOCK_COMPONENT=1      !component level, e.g model, exchange
  integer, parameter :: CLOCK_SUBCOMPONENT=11  !top level within a model component, e.g dynamics, physics
  integer, parameter :: CLOCK_MODULE_DRIVER=21 !module driver level, e.g adriver that calls multiple 
                                               !related physics routines
  integer, parameter :: CLOCK_MODULE=31        !module level, e.g main subroutine of a physics module
  integer, parameter :: CLOCK_ROUTINE=41       !level of individual subroutine or function
  integer, parameter :: CLOCK_LOOP=51          !loops or blocks within a routine
  integer, parameter :: CLOCK_INFRA=61         !infrastructure level, e.g halo update
  integer, parameter :: MAX_BINS=20
  integer(LONG_KIND), parameter :: MPP_WAIT=-1, MPP_READY=-2

  !--- The following paramters are used by mpp_domains_mod and its components.
  integer, parameter :: GLOBAL=0, CYCLIC=1
  integer, parameter :: WEST=2, EAST=3, SOUTH=4, NORTH=5, SCALAR_BIT=6, CENTER=7, CORNER=8
  integer, parameter :: SOUTH_WEST=7, SOUTH_EAST=8, NORTH_WEST=9, NORTH_EAST=10
  integer, parameter :: EDGEONLY = 11
  integer, parameter :: SEND=1, RECV=2
  integer, parameter :: GLOBAL_DATA_DOMAIN=2**GLOBAL, CYCLIC_GLOBAL_DOMAIN=2**CYCLIC
  integer, parameter :: AGRID=0, BGRID=1, CGRID=2, DGRID=3
  integer, parameter :: BGRID_NE=BGRID+2**NORTH+2**EAST
  integer, parameter :: BGRID_SW=BGRID+2**SOUTH+2**WEST
  integer, parameter :: CGRID_NE=CGRID+2**NORTH+2**EAST
  integer, parameter :: CGRID_SW=CGRID+2**SOUTH+2**WEST
  integer, parameter :: DGRID_NE=DGRID+2**NORTH+2**EAST
  integer, parameter :: DGRID_SW=DGRID+2**SOUTH+2**WEST
  integer, parameter :: FOLD_WEST_EDGE = 2**WEST, FOLD_EAST_EDGE = 2**EAST
  integer, parameter :: FOLD_SOUTH_EDGE=2**SOUTH, FOLD_NORTH_EDGE=2**NORTH
  integer, parameter :: WUPDATE=2**WEST, EUPDATE=2**EAST, SUPDATE=2**SOUTH, NUPDATE=2**NORTH
  integer, parameter :: XUPDATE=WUPDATE+EUPDATE, YUPDATE=SUPDATE+NUPDATE, SCALAR_PAIR=2**SCALAR_BIT
  integer, parameter :: EDGEUPDATE=2**EDGEONLY
  integer, parameter :: ZERO=0, NINETY=90, MINUS_NINETY=-90, ONE_HUNDRED_EIGHTY=180
  integer, parameter :: NONBLOCK_UPDATE_TAG = 2

! DOMAIN_ID_BASE acts as a counter increment for domains as they are defined. It's used in
! combination with the flag parameter defined above to create a unique identifier for
! each Domain+flags combination. Therefore, the value of any flag must not exceed DOMAIN_ID_BASE.
! integer(LONG_KIND), parameter :: DOMAIN_ID_BASE=INT( 2**(4*LONG_KIND),KIND=LONG_KIND )
  integer(LONG_KIND), parameter :: DOMAIN_ID_BASE=Z'0000000100000000' ! Workaround for 64bit init problem
  integer, parameter :: NON_BITWISE_EXACT_SUM=0
  integer, parameter :: BITWISE_EXACT_SUM=1
  integer, parameter :: BITWISE_EFP_SUM=2
  integer, parameter :: MPP_DOMAIN_TIME=MPP_DEBUG+1
  integer, parameter :: MAX_DOMAIN_FIELDS=100
  integer, parameter :: MAX_TILES=100

  !--- The following paramters are used by mpp_io_mod and its components.
  integer, parameter :: MPP_WRONLY=100, MPP_RDONLY=101, MPP_APPEND=102, MPP_OVERWR=103 !action on open
  integer, parameter :: MPP_ASCII=200,  MPP_IEEE32=201, MPP_NATIVE=202, MPP_NETCDF=203 !format
  integer, parameter :: MPP_SEQUENTIAL=300, MPP_DIRECT=301 !access
  integer, parameter :: MPP_SINGLE=400, MPP_MULTI=401      !threading, fileset
  integer, parameter :: MPP_DELETE=501, MPP_COLLECT=502    !action on close
  integer, parameter :: NULLUNIT=-1                        !returned by PEs not participating in    
                                                           !IO after a collective call with threading
                                                           !equal to MPP_SINGLE
  !--- unique tag used in FMS
  integer, parameter :: COMM_TAG_1  = 1,  COMM_TAG_2  = 2,  COMM_TAG_3  = 3,  COMM_TAG_4  = 4
  integer, parameter :: COMM_TAG_5  = 5,  COMM_TAG_6  = 6,  COMM_TAG_7  = 7,  COMM_TAG_8  = 8
  integer, parameter :: COMM_TAG_9  = 9,  COMM_TAG_10 = 10, COMM_TAG_11 = 11, COMM_TAG_12 = 12
  integer, parameter :: COMM_TAG_13 = 13, COMM_TAG_14 = 14, COMM_TAG_15 = 15, COMM_TAG_16 = 16
  integer, parameter :: COMM_TAG_17 = 17, COMM_TAG_18 = 18, COMM_TAG_19 = 19, COMM_TAG_20 = 20

  integer, parameter :: ROOT_GLOBAL = 9
  integer, parameter :: GLOBAL_ROOT_ONLY = 2**ROOT_GLOBAL 
  real(DOUBLE_KIND), parameter :: NULLTIME=-1.
#ifdef LARGE_FILE
  integer(LONG_KIND), parameter :: MAX_FILE_SIZE = 4294967295
#else
  integer(LONG_KIND), parameter :: MAX_FILE_SIZE = 2147483647
#endif

  !#####################################################################

end module mpp_parameter_mod

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                                   !!
!!                   GNU General Public License                      !!
!!                                                                   !!
!! This file is part of the Flexible Modeling System (FMS).          !!
!!                                                                   !!
!! FMS is free software; you can redistribute it and/or modify       !!
!! it and are expected to follow the terms of the GNU General Public !!
!! License as published by the Free Software Foundation.             !!
!!                                                                   !!
!! FMS is distributed in the hope that it will be useful,            !!
!! but WITHOUT ANY WARRANTY; without even the implied warranty of    !!
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     !!
!! GNU General Public License for more details.                      !!
!!                                                                   !!
!! You should have received a copy of the GNU General Public License !!
!! along with FMS; if not, write to:                                 !!
!!          Free Software Foundation, Inc.                           !!
!!          59 Temple Place, Suite 330                               !!
!!          Boston, MA  02111-1307  USA                              !!
!! or see:                                                           !!
!!          http://www.gnu.org/licenses/gpl.txt                      !!
!!                                                                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module mom_oasis3_interface_mod
!
!<CONTACT EMAIL="Dave.Bi@csiro.au"> Dave Bi (for OASIS3 hooks)
!</CONTACT>
!
!<CONTACT EMAIL="Russell.Fiedler@csiro.au"> Russ Fiedler (for OASIS3 hooks)
!</CONTACT>
!
!<OVERVIEW>
! Interface to OASIS3/PRISM2-5 coupling.  
!</OVERVIEW>
!
!<DESCRIPTION>
! Interface to the OASIS3 

! This module serves as a hook between PRISM2-5/OASIS3 and mom4p1
! Only serial coupling has been tested at this stage (Oct 2009) although there are
! hints for the user for implementing different strategies.
!
! Standard mom surface quantities In Ocean_Ice_Boundary and Ocean_sfc may be passed
!
! The  namelist ocean_oasis3_interface_nml contains the quantities to be passed to and from the ocean 
! </DESCRIPTION>
!
! <NAMELIST NAME="mom_oasis3_interface_nml">
!
!   <DATA NAME="num_fields_in" TYPE="integer" DEFAULT="0">
!    The number of fields to be passed to mom from external sources
!   </DATA>
!   <DATA NAME="num_fields_out" TYPE="integer" DEFAULT="0">
!    The number of fields to be passed from mom to external progams
!   </DATA>
!   <DATA NAME="fields_in" TYPE="character(maxlen=8)" DEFAULT="''">
!    The fields to be passed to mom from external progams. Currently
!    valid names correspond to variables in the Ice_ocean_boundary structure.
!    These names must agree with names in the OASIS namcouple file
!    WARNING! Note truncation of names of ssw flux components and salt_flx.
!   </DATA>
!   <DATA NAME="fields_out" TYPE="character(maxlen=8)" DEFAULT="''">
!    The fields to be passed from mom to external progams. Currently
!    valid names correspond to variables in the Ocean_sfc structure.
!    These names must agree with the 'interpolated' names in the OASIS namcouple file
!   </DATA>
!   <DATA NAME="send_before_ocean_update" TYPE="logical" DEFAULT=".FALSE.">
!    TRUE if coupling strategy requires we send data to coupler BEFORE updating the ocean
!   </DATA>
!   <DATA NAME="send_after_ocean_update" TYPE="logical" DEFAULT=".FALSE.">
!    TRUE if coupling strategy requires we send data to coupler AFTER updating the ocean
!   </DATA>
!
! </NAMELIST>
!
!

use mod_prism

!MOM4 modules: 
use fms_mod,         only: file_exist
use fms_mod,         only: write_version_number, open_namelist_file, close_file, check_nml_error
use mpp_domains_mod, only: mpp_update_domains, domain2d
use mpp_mod,         only: mpp_broadcast, mpp_pe, mpp_npes, mpp_root_pe
use mpp_mod,         only: mpp_error, FATAL, WARNING, NOTE
use mpp_mod,         only: stdlog, stdout
use mpp_domains_mod, only: mpp_get_compute_domain, &
                           mpp_get_data_domain, &
                           mpp_get_global_domain, &
                           mpp_global_field
use mpp_parameter_mod, only: GLOBAL_ROOT_ONLY, XUPDATE, YUPDATE
use ocean_types_mod, only: ice_ocean_boundary_type, &
                           ocean_public_type, &
                           ocean_domain_type
use time_manager_mod, only: time_type

! Timing

  use mpp_mod,                  only: mpp_clock_id
  use mpp_mod,                  only: mpp_clock_begin, mpp_clock_end, MPP_CLOCK_SYNC
  use mpp_mod,                  only: MPP_CLOCK_DETAILED, CLOCK_MODULE

  use auscom_ice_mod, only : il_out 
  use cpl_netcdf_setup_mod

implicit none

public :: mom_prism_init, mom_prism_terminate, coupler_init, from_coupler, into_coupler, &
          write_coupler_restart

public :: iisd, iied, jjsd, jjed, iisc, iiec, jjsc, jjec

private

include "mpif.h" 

!
! OASIS3 variables:
!
integer :: id_component     ! Component ID
integer :: id_partition     ! Local partition ID
integer :: num_total_proc   ! Total number of processes
integer :: num_coupling_proc   ! Number of processes involved in the coupling

logical :: parallel_coupling

integer :: jf
character(len=12) :: choceout
character(len=6) :: chout

!
! Coupling associated variables
!
integer :: ierr
integer :: limt, ljmt, i, j
integer :: step

character(len=6), parameter :: cp_modnam='mom5xx'  ! Component model name same as in namcouple

integer :: imt_global, jmt_global                  ! 2D global layout 
integer :: imt_local, jmt_local                    ! 2D global layout 
integer iisc,iiec,jjsc,jjec
integer iisd,iied,jjsd,jjed

integer, parameter :: max_fields_in=24
integer, parameter :: max_fields_out=10

integer, dimension(max_fields_in)  :: id_var_in  ! ID for fields to be rcvd
integer, dimension(max_fields_out) :: id_var_out ! ID for fields to be sent

character(len=8), dimension(max_fields_in)  :: mom_name_read  ! Standard mom Ice_Ocean_boundary names
character(len=8), dimension(max_fields_out) :: mom_name_write ! Standard mom Ocean_Sfc names


! Namelist variables
integer :: num_fields_in    ! Number of fields to be sent
integer :: num_fields_out   ! Number of fields to be rcvd
character(len=8),dimension(max_fields_out) :: fields_out
character(len=8),dimension(max_fields_in) :: fields_in
logical :: send_before_ocean_update=.FALSE.,       &
           send_after_ocean_update=.FALSE.  ! Control when to pass fields to coupler.

! Work array
real, allocatable,dimension(:,:)  :: vwork

! Timing
integer :: id_oasis_send, id_oasis_recv
integer :: id_oasis_send1, id_oasis_recv1


!global domain
integer isg,ieg,jsg,jeg

!for paralell coupling 
real, allocatable,dimension(:,:)  :: vwork_2
integer, dimension(2) :: pe_layout
integer iiscpl,iiecpl,jjscpl,jjecpl
integer :: sendsubarray, recvsubarray , resizedrecvsubarray
integer, dimension(:), allocatable :: counts, disps
integer, dimension(2) :: starts,sizes,subsizes
integer(kind=mpi_address_kind) :: start, extent
real :: realvalue
integer :: col_comm
integer :: mom4_comm
contains

!-----------------------------------------------------------------------------------
subroutine mom_prism_init(mom4_local_comm)

integer :: mom4_local_comm
!--------------------!

!
! Initialize PRISM.
!

! Initialise MPI

call MPI_INIT(ierr)

call prism_init_comp_proto (id_component, cp_modnam, ierr)

if (ierr /= PRISM_Ok) then 
  call prism_abort_proto(id_component, 'mom4 prism_init','STOP 1')
endif

!
! PRISM attribution of local communicator. 
! 

call prism_get_localcomm_proto(mom4_local_comm, ierr) 

if (ierr /= PRISM_Ok) then
  call prism_abort_proto(id_component, 'mom4 prism_init','STOP 2')
endif

mom4_comm = mom4_local_comm

end subroutine mom_prism_init

!-----------------------------------------------------------------------------------
subroutine coupler_init(Dom, Time, Time_step_coupled, Run_len, dt_cpld)

! In this routine we set up all our arrays and determine which fields are to be passed to and fro.
! Determine the style of coupling
! 
! Time, Time_step_coupled & run_len not used at the moment. They are provided for convenience if the user wishes to
! use them for initialising.

type(domain2d)  :: Dom  
type(time_type),optional :: Time, Time_step_coupled, Run_len
integer,optional         :: dt_cpld

integer, dimension(5) :: il_paral
integer, dimension(2) :: var_num_dims ! see below
integer, dimension(4) :: var_shape  ! see below

!integer isg,ieg,jsg,jeg
integer :: jcol, irow

integer ioun, io_status

integer ifield

logical fmatch 

namelist /mom_oasis3_interface_nml/ num_fields_in, num_fields_out,fields_in,fields_out, &
          send_before_ocean_update, send_after_ocean_update

! all processors read the namelist--

ioun = open_namelist_file()
read  (ioun, mom_oasis3_interface_nml,iostat=io_status)
write (stdout(),'(/)')
write (stdout(), mom_oasis3_interface_nml)
write (stdlog(), mom_oasis3_interface_nml)
ierr = check_nml_error(io_status,'mom_oasis3_interface_nml')
call close_file (ioun)

call mpp_get_compute_domain(Dom,iisc,iiec,jjsc,jjec)
call mpp_get_data_domain(Dom,iisd,iied,jjsd,jjed)
call mpp_get_global_domain(Dom,isg,ieg,jsg,jeg)   

!  Global domain extent

imt_global=ieg-isg+1
jmt_global=jeg-jsg+1

!B: for parallel coupling, the above global layout does NOT make sense...
! Use local domains
!
! Original did all this on the data domain using temp arrays
!limt=iied-iisd+1
!ljmt=jjed-jjsd+1
! Use computational domain directly 

imt_local=iiec-iisc+1
jmt_local=jjec-jjsc+1
  
  pe_layout(1)=imt_global/imt_local
  pe_layout(2)=jmt_global/jmt_local
  


! Can't we get these numbers from elsewhere? Shouldn't be hardwired.  RASF
! It would be better to read in num_coupling_proc and parallel_coupling and perform sanity checking.
! Can we change some of the variable names? It's really hard to figure out what they mean.
! (OASIS3 naming convention problem?).

num_total_proc = mpp_npes()
num_coupling_proc = num_total_proc     !multi-process coupling (real parallel cpl)!

! Type of coupling

if (num_coupling_proc == num_total_proc .and. num_total_proc /= 1) then
  parallel_coupling = .TRUE.
else
  parallel_coupling = .FALSE.
endif


!
!! vwork is the 'coupling' array that directly communicates with oasis3.
!! -- global (if parallel_coupling=.f.) domain or 
!! -- local  (if parallel_coupling=.t.) domain.
!! 
!
if (parallel_coupling) then
  allocate(vwork(iisc:iiec,jjsc:jjec))
else
  allocate(vwork(isg:ieg,jsg:jeg))
endif
  vwork=0.0


  ! Define name (as in namcouple) and declare each field sent/received by oce:
  !ice ==> ocn
  mom_name_read(:)=''

  mom_name_read(1)='u_flux'
  mom_name_read(2)='v_flux'
  mom_name_read(3)='t_flux'
  mom_name_read(4)='q_flux'
  mom_name_read(5)='salt_flx'
  mom_name_read(6)='lw_flux'
  mom_name_read(7)='sw_vdir'
  mom_name_read(8)='sw_vdif'
  mom_name_read(9)='sw_irdir'
  mom_name_read(10)='sw_irdif'
  mom_name_read(11)='lprec'
  mom_name_read(12)='fprec'
  mom_name_read(13)='runof'
  mom_name_read(14)='calving'
  mom_name_read(15)='p'
  mom_name_read(16)='sw_flux'   ! For partitioning shortwave flux
  mom_name_read(17)='aice'   ! Ice fraction
  mom_name_read(18)='mh_flux'   ! Heat flux due to melting
  mom_name_read(19)='wfimelt'  !Water flux due to ice melting
  mom_name_read(20)='wfiform'  !Water flux due to ice forming 
  mom_name_read(21)='co2_io'  !
  mom_name_read(22)='wnd_io'  !
  !20171024: 2 more i2o fields due to land ice discharge into ocean
  mom_name_read(23)='licefw' !water flux (kg/m^2/s)
  mom_name_read(24)='liceht' !heat flux (W/m^2)

  !ocn ==> ice
  mom_name_write(:)=''

  mom_name_write(1)='t_surf'
  mom_name_write(2)='s_surf'
  mom_name_write(3)='u_surf'
  mom_name_write(4)='v_surf'
  mom_name_write(5)='sea_lev'
  mom_name_write(6)='frazil'
  mom_name_write(7)='dssldx'
  mom_name_write(8)='dssldy'
  mom_name_write(9)='co2_o'
  mom_name_write(10)='co2fx_o'


  fmatch = .false.
  do jf = 1,num_fields_in
     do ifield=1,max_fields_in
       if ( trim(mom_name_read(ifield)) ==  trim(fields_in(jf)) ) then
         fmatch = .true.
         exit
       endif
     enddo
     if (.not. fmatch) then
       call mpp_error(FATAL,'coupler_init: Illegal input name' )
     endif
     fmatch = .false.
  enddo

  fmatch = .false.
  do jf = 1,num_fields_out
     do ifield=1,max_fields_in
       if ( trim(mom_name_write(ifield))  ==  trim(fields_out(jf)) ) then
         fmatch = .true.
         exit
       endif
     enddo
     if (.not. fmatch) then 
       call mpp_error(FATAL,'coupler_init: Illegal output name' )
     endif
     fmatch = .false.
  enddo

!DHB
#if defined(DEBUG)
    if (mpp_pe() == mpp_root_pe() .or. parallel_coupling) then
      il_out = 85 + mpp_pe()
      write(chout,'(I6.6)'), il_out
      choceout='oceout'//trim(chout)
      open(il_out,file=choceout,form='formatted')
    endif
#endif


#if defined(DEBUG)
    write(il_out, *) "compute domain:",mpp_pe(), iisc, iiec, jjsc, jjec 
    write(il_out, *) "data domain:",mpp_pe(), iisd, iied, jjsd, jjed 
    write(il_out, *) "global domain:",mpp_pe(), isg, ieg, jsg, jeg 
    write(il_out, *) "global layout nx x ny:",pe_layout(1), pe_layout(2) 
    flush(il_out)
#endif

  il_paral (:) = 0
  if (.not. parallel_coupling) then 
    il_paral ( clim_strategy ) = clim_serial
    il_paral ( clim_offset   ) = 0
    il_paral ( clim_length   ) = imt_global * jmt_global
    send_before_ocean_update = .false.
    send_after_ocean_update = .true.
  else !if( parallel_coupling .and. mpp_pe() < pe_layout(1) ) then

  il_paral ( clim_strategy ) = clim_Box
!every cpu gets coupling
  il_paral ( clim_offset   ) = (ieg-isg+1)*(jjsc-jsg)+(iisc-isg)
  il_paral ( clim_SizeX    ) = iiec-iisc+1
  il_paral ( clim_SizeY    ) = jjec-jjsc+1
  il_paral ( clim_LdX      ) = ieg-isg+1
    send_before_ocean_update = .false.
    send_after_ocean_update = .true.
  
  endif

  !
  !  PRISM coupling fields declaration
  !
  var_num_dims(1)= 2      ! rank of coupling field
  var_num_dims(2)= 1      ! number of bundles in coupling field (always 1)
  var_shape(1)= lbound(vwork,1)       ! min index for the coupling field local dimension
  var_shape(2)= ubound(vwork,1)     ! max index for the coupling field local dim
  var_shape(3)= lbound(vwork,2)       ! min index for the coupling field local dim
  var_shape(4)= ubound(vwork,2)     ! max index for the coupling field local dim


if (mpp_pe() == mpp_root_pe() .or. (parallel_coupling )) then
  !
  ! The following steps need to be done:
  ! -> by the process if mom is monoprocess;
  ! -> only by the master process, if mom is parallel and only 
  !    master process is involved in the coupling;
  ! -> by all processes, if mom is parallel and all processes 
  ! are involved in the coupling.
  !
  ! - Define parallel partitions and allocate coupling fields accordingly: 
  ! (Refer to oasis/psmile/prism/modules/mod_prism_proto.F90 for integer value
  !  of clim_xxxx parameters)
  ! For each coupling field, association of a port to its symbolic name
  !       -Define the parallel decomposition associated to the port of each
  !        field; here no decomposition for all ports.
  !

  call prism_def_partition_proto (id_partition, il_paral, ierr, imt_global*jmt_global)

  !

  do jf=1, num_fields_out
    call prism_def_var_proto (id_var_out(jf),fields_out(jf), id_partition, &
         var_num_dims, PRISM_Out, var_shape, PRISM_Real, ierr)
  enddo


  do jf=1, num_fields_in
    call prism_def_var_proto (id_var_in(jf), fields_in(jf), id_partition, &
         var_num_dims, PRISM_In, var_shape, PRISM_Real, ierr)
  enddo

  !
  !  PRISM end of declaration phase
  !
  call prism_enddef_proto (ierr)
  if (ierr /= PRISM_Ok) then
    call mpp_error(FATAL,'coupler_init: *** problem with prism_enddef_proto! ***' )
  endif

endif   ! 
  id_oasis_recv = mpp_clock_id('oasis_recv', flags=MPP_CLOCK_SYNC,grain=CLOCK_MODULE)
  id_oasis_send = mpp_clock_id('oasis_send', flags=MPP_CLOCK_SYNC,grain=CLOCK_MODULE)
  id_oasis_recv1 = mpp_clock_id('oasis_recv1', grain=CLOCK_MODULE)
  id_oasis_send1 = mpp_clock_id('oasis_send1', grain=CLOCK_MODULE)

end subroutine  coupler_init

!=======================================================================
subroutine into_coupler(step, Ocean_sfc, Time, before_ocean_update)
!------------------------------------------!

use ocean_operators_mod, only : GRAD_BAROTROPIC_P       !GRAD_SURF_sealev
use auscom_ice_mod, only      : auscom_ice_heatflux_new
use auscom_ice_mod, only      : chk_o2i_fields, chk_fields_period, chk_fields_start_time

implicit none

type (ocean_public_type) :: Ocean_sfc
type (time_type),optional         :: Time

integer, intent(in) :: step
logical, intent(in),optional :: before_ocean_update ! Flag to indicate whether
                                           ! we are calling before or after updating the ocean
integer:: jf, ierr, i, j

real, pointer, dimension(:,:) :: vwork_local
real, dimension(iisd:iied,jjsd:jjed) :: vtmp
real, dimension(isg:ieg,jsg:jeg) :: gtmp

  character*80 :: fname='fields_o2i_in_ocn.nc'
  integer :: ncid,currstep,ll,ilout
  data currstep/0/
  save currstep

! Check if  we want to couple at this call.

if ( before_ocean_update .and. (.not. send_before_ocean_update) ) return
if ( (.not. before_ocean_update) .and. (.not. send_after_ocean_update) ) return

  
  if (mpp_pe() == mpp_root_pe()) then
    if (chk_o2i_fields .and. (mod(step, chk_fields_period) == 0) .and. (step >= chk_fields_start_time)) then
        currstep=currstep+1
      if (currstep == 1) then
        call create_ncfile(trim(fname),ncid,imt_global,jmt_global,ll=1,ilout=il_out)
      endif
#if defined(DEBUG)
      write(il_out,*) 'opening file at nstep = ', trim(fname), step
#endif
      call ncheck( nf_open(trim(fname),nf_write,ncid) )
      call write_nc_1Dtime(real(step),currstep,'time',ncid)
    endif
  endif

!20110329: gradient is now calculated in initialize_ocean_sfc to avoid the domain boundary shift!
!!!Ocean_sfc%gradient(:,:,:) = GRAD_BAROTROPIC_P(Ocean_sfc%sea_lev(:,:))
!frazil is actually updated 
call auscom_ice_heatflux_new(Ocean_sfc)

     call mpp_clock_begin(id_oasis_send)
do jf = 1,num_fields_out
     if(jf .ne. 1) call mpp_clock_begin(id_oasis_send1)

! Just point to array. Don't need to copy.
  vtmp(:,:) = 0.0
  coupling_fields_out: select case( trim(fields_out(jf)))
  case('t_surf')
    vtmp(iisd:iied,jjsd:jjed) = Ocean_sfc%t_surf(iisd:iied,jjsd:jjed)
  case('s_surf')
    vtmp(iisd:iied,jjsd:jjed) = Ocean_sfc%s_surf(iisd:iied,jjsd:jjed)
  case('u_surf')
    vtmp(iisd:iied,jjsd:jjed) = Ocean_sfc%u_surf(iisd:iied,jjsd:jjed)
  case('v_surf')
    vtmp(iisd:iied,jjsd:jjed) = Ocean_sfc%v_surf(iisd:iied,jjsd:jjed)
  case('sea_lev')
    vtmp(iisd:iied,jjsd:jjed) = Ocean_sfc%sea_lev(iisd:iied,jjsd:jjed)
  case('frazil')
    vtmp(iisd:iied,jjsd:jjed) = Ocean_sfc%frazil(iisd:iied,jjsd:jjed)
  case('dssldx') 
    vtmp(iisd:iied,jjsd:jjed) = Ocean_sfc%gradient(iisd:iied,jjsd:jjed,1)
  case('dssldy') 
    vtmp(iisd:iied,jjsd:jjed) = Ocean_sfc%gradient(iisd:iied,jjsd:jjed,2)
  case('co2_o') 
    vtmp(iisd:iied,jjsd:jjed) = Ocean_sfc%co2(iisd:iied,jjsd:jjed)
  case('co2fx_o') 
    vtmp(iisd:iied,jjsd:jjed) = Ocean_sfc%co2flux(iisd:iied,jjsd:jjed)
  case DEFAULT
  call mpp_error(FATAL,&
      '==>Error from into_coupler: Unknown quantity.')
  end select coupling_fields_out

  if(.not. parallel_coupling) then  
      call mpp_global_field(Ocean_sfc%domain, vtmp(iisc:iiec,jjsc:jjec), vwork)
  else
      vwork = vtmp
  endif

  if (mpp_pe() == mpp_root_pe() .or. (parallel_coupling )) then

      call prism_put_proto(id_var_out(jf),step,vwork,ierr) 
  
      if (chk_o2i_fields .and. (mod(step, chk_fields_period) == 0) .and. (step >= chk_fields_start_time)) then
        if (parallel_coupling) then 
          call mpp_global_field(Ocean_sfc%domain, vtmp(iisc:iiec,jjsc:jjec), gtmp)
          if( mpp_pe() == mpp_root_pe() )  &
            call write_nc2D(ncid, trim(fields_out(jf)), gtmp, 1, imt_global,jmt_global, &
                        currstep,ilout=il_out)
        else
          if( mpp_pe() == mpp_root_pe() )  &
            call write_nc2D(ncid, trim(fields_out(jf)), vwork, 1, imt_global,jmt_global, &
                        currstep,ilout=il_out)
        endif
    endif

    if (ierr /= prism_ok.and. ierr < prism_sent) then
      call prism_abort_proto(id_component, 'MOM4 into_cpl','stop 1')
    endif

   endif 

     if(jf .ne. 1) call mpp_clock_end(id_oasis_send1)

enddo
     call mpp_clock_end(id_oasis_send)

  if (chk_o2i_fields .and. (mod(step, chk_fields_period) == 0) .and. (step >= chk_fields_start_time) .and. (mpp_pe() == mpp_root_pe())) then
    call ncheck(nf_close(ncid))
  endif

return
end subroutine into_coupler

!-----------------------------------------------------------------------------------
subroutine from_coupler(step,Ocean_sfc,Ice_ocean_boundary, Time)

! This is all highly user dependent. 

use constants_mod, only  : hlv    ! 2.500e6 J/kg
use auscom_ice_mod, only : chk_i2o_fields, chk_fields_period, chk_fields_start_time
implicit none

type (ocean_public_type) :: Ocean_sfc
type (ice_ocean_boundary_type) :: Ice_ocean_boundary
type (time_type),optional         :: Time

real, dimension(isg:ieg,jsg:jeg) :: gtmp

integer, intent(in) :: step

real :: frac_vis_dir=0.5*0.43, frac_vis_dif=0.5*0.43,             &
        frac_nir_dir=0.5*0.57, frac_nir_dif=0.5*0.57 ! shortwave partitioning

  character*80 :: fname = 'fields_i2o_in_ocn.nc'
  integer :: ncid,currstep,ll,ilout
  data currstep/0/
  save currstep

  if (mpp_pe() == mpp_root_pe()) then
    if (chk_i2o_fields .and. (mod(step, chk_fields_period) == 0) .and. (step >= chk_fields_start_time)) then 
        currstep=currstep+1
      if (currstep == 1) then
        call create_ncfile(trim(fname),ncid,imt_global,jmt_global,ll=1,ilout=il_out)
      endif
#if defined(DEBUG)
      write(il_out,*) 'opening file at nstep = ', trim(fname), step
#endif
      call ncheck( nf_open(trim(fname),nf_write,ncid) )
      call write_nc_1Dtime(real(step),currstep,'time',ncid)
    endif
  endif

     call mpp_clock_begin(id_oasis_recv)
do jf =  1, num_fields_in
     if(jf .ne. 1) call mpp_clock_begin(id_oasis_recv1)

  !if (mpp_pe() == mpp_root_pe() .or. (parallel_coupling .and. mpp_pe() < pe_layout(1))) then
  if (mpp_pe() == mpp_root_pe() .or. (parallel_coupling )) then
  call prism_get_proto(id_var_in(jf),step,vwork,ierr)

    if (ierr /= PRISM_Ok.and. ierr < prism_recvd) then
      call prism_abort_proto(id_component, 'MOM4 _get_ ','stop 1')
    endif
  endif

  if ( .not. parallel_coupling) then
    call mpp_broadcast(vwork, imt_global*jmt_global, mpp_root_pe())
  endif

! Handle conversions from raw field to what mom requires
! Sign conventions  & scaling  factors. Partioning of SSW etc.
! Would prefer to select on a generic name for clarity. but OASIS has 8 character limita on fields to be passed

  coupling_fields_in: select case ( trim(fields_in(jf) ))
  case('u_flux')
     Ice_ocean_boundary%u_flux(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('v_flux')
     Ice_ocean_boundary%v_flux(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('lprec')
     Ice_ocean_boundary%lprec(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('salt_flx')
     ! Sign conventions for Ice_ocean_boundary%salt_flux according to component model:
     !  - For MOM, if Ice_ocean_boundary%salt_flux < 0 then there is a transfer
     !    of salt from ice to liquid.
     !  - For CICE, if Ice_ocean_boundary%salt_flux < 0 then there is a
     !    transfer of salt from liquid to ice.
     ! We change the sign on vwork to accord with the MOM sign convention when
     ! filling Ice_ocean_boundary%salt_flux, since Ice_ocean_boundary%salt_flux is
     ! used in MOM to fill its local salt flux array.
     Ice_ocean_boundary%salt_flux(iisc:iiec,jjsc:jjec) =  -vwork(iisc:iiec,jjsc:jjec)
  case('calving')
     Ice_ocean_boundary%calving(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('sw_vdir')
     Ice_ocean_boundary%sw_flux_vis_dir(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('sw_vdif')
     Ice_ocean_boundary%sw_flux_vis_dif(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('sw_irdir')
     Ice_ocean_boundary%sw_flux_nir_dir(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('sw_irdif')
     Ice_ocean_boundary%sw_flux_nir_dif(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('sw_flux')
     Ice_ocean_boundary%sw_flux_vis_dir(iisc:iiec,jjsc:jjec) =  frac_vis_dir*vwork(iisc:iiec,jjsc:jjec)
     Ice_ocean_boundary%sw_flux_vis_dif(iisc:iiec,jjsc:jjec) =  frac_vis_dif*vwork(iisc:iiec,jjsc:jjec)
     Ice_ocean_boundary%sw_flux_nir_dir(iisc:iiec,jjsc:jjec) =  frac_nir_dir*vwork(iisc:iiec,jjsc:jjec)
     Ice_ocean_boundary%sw_flux_nir_dif(iisc:iiec,jjsc:jjec) =  frac_nir_dif*vwork(iisc:iiec,jjsc:jjec)
  case('q_flux')
     Ice_ocean_boundary%q_flux(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)/hlv
  case('t_flux')
     Ice_ocean_boundary%t_flux(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('lw_flux')
     Ice_ocean_boundary%lw_flux(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('runof')
     Ice_ocean_boundary%runoff(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('p')
     Ice_ocean_boundary%p(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('fprec')
     Ice_ocean_boundary%fprec(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('aice')
     Ice_ocean_boundary%aice(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('mh_flux')
     Ice_ocean_boundary%mh_flux(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('wfimelt')
     Ice_ocean_boundary%wfimelt(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('wfiform')
     Ice_ocean_boundary%wfiform(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('co2_io')
     Ice_ocean_boundary%co2(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('wnd_io')
     Ice_ocean_boundary%wnd(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  !20171024: 2 more i2o fields: water and heat fluxes due to land ice discharge into ocean 
  case('licefw')
     Ice_ocean_boundary%licefw(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case('liceht')
     Ice_ocean_boundary%liceht(iisc:iiec,jjsc:jjec) =  vwork(iisc:iiec,jjsc:jjec)
  case DEFAULT
! Probable error. Leave as warning for the moment. RASF
   call mpp_error(WARNING,&
      '==>Warning from from_coupler: Unknown quantity.')
  end select coupling_fields_in

      if (chk_i2o_fields .and. (mod(step, chk_fields_period) == 0) .and. (step >= chk_fields_start_time)) then
        if (parallel_coupling ) then
          call mpp_global_field(Ocean_sfc%domain, vwork(iisc:iiec,jjsc:jjec), gtmp) 
          if( mpp_pe() == mpp_root_pe() )  &
            call write_nc2D(ncid, trim(fields_in(jf)), gtmp, 1, imt_global,jmt_global, &
                          currstep,ilout=il_out)
        else
          if( mpp_pe() == mpp_root_pe() )  &
            call write_nc2D(ncid, trim(fields_in(jf)), vwork, 1, imt_global,jmt_global, &
                          currstep,ilout=il_out)
        endif
      endif

     if(jf .ne. 1) call mpp_clock_end(id_oasis_recv1)
enddo    !jf
     call mpp_clock_end(id_oasis_recv)

  if (chk_i2o_fields .and. (mod(step, chk_fields_period) == 0) .and. (step >= chk_fields_start_time) .and. (mpp_pe() == mpp_root_pe())) then
    call ncheck(nf_close(ncid))
  endif

end subroutine from_coupler

!-----------------------------------------------------------------------------------
subroutine write_coupler_restart(step,Ocean_sfc,write_restart)

use auscom_ice_mod, only      : auscom_ice_heatflux_new

logical, intent(in) :: write_restart
integer, intent(in) :: step
type (ocean_public_type) :: Ocean_sfc

integer :: ncid,ll,ilout
real, dimension(iisd:iied,jjsd:jjed) :: vtmp
real, dimension(isg:ieg,jsg:jeg) :: gtmp
character(len=8) :: fld_ice

if ( write_restart ) then
   if ( mpp_pe() == mpp_root_pe() ) then
     call create_ncfile('o2i.nc', ncid, imt_global,jmt_global, ll=1, ilout=il_out)
     call write_nc_1Dtime(real(step), 1, 'time', ncid)
   endif
   !update frazil
   call auscom_ice_heatflux_new(Ocean_sfc)
   !if (mpp_pe() == mpp_root_pe() .or. (parallel_coupling .and.  mpp_pe() < pe_layout(1)) ) then
   if (mpp_pe() == mpp_root_pe() .or. (parallel_coupling) ) then
      do jf = 1,num_fields_out
        vtmp(:,:) = 0.0
        select case (trim(fields_out(jf)))
          case('t_surf'); vtmp = Ocean_sfc%t_surf(iisd:iied,jjsd:jjed); fld_ice='sst_i'
          case('s_surf'); vtmp = Ocean_sfc%s_surf(iisd:iied,jjsd:jjed); fld_ice='sss_i'
          case('u_surf'); vtmp = Ocean_sfc%u_surf(iisd:iied,jjsd:jjed); fld_ice='ssu_i'
          case('v_surf'); vtmp = Ocean_sfc%v_surf(iisd:iied,jjsd:jjed); fld_ice='ssv_i'
          case('dssldx'); vtmp = Ocean_sfc%gradient(iisd:iied,jjsd:jjed,1); fld_ice='sslx_i'
          case('dssldy'); vtmp = Ocean_sfc%gradient(iisd:iied,jjsd:jjed,2); fld_ice='ssly_i'
          case('frazil'); vtmp = Ocean_sfc%frazil(iisd:iied,jjsd:jjed); fld_ice='pfmice_i'
          case('co2_o'); vtmp = Ocean_sfc%co2(iisd:iied,jjsd:jjed); fld_ice='co2_oi'
          case('co2fx_o'); vtmp = Ocean_sfc%co2flux(iisd:iied,jjsd:jjed); fld_ice='co2fx_oi'
        end select

        if (parallel_coupling) then
          call mpp_global_field(Ocean_sfc%domain, vtmp(iisc:iiec,jjsc:jjec), &
                                gtmp, flags=GLOBAL_ROOT_ONLY+XUPDATE+YUPDATE)
        else
          call mpp_global_field(Ocean_sfc%domain, vtmp(iisc:iiec,jjsc:jjec), &
                                vwork, flags=GLOBAL_ROOT_ONLY+XUPDATE+YUPDATE)
        end if

        if (mpp_pe() == mpp_root_pe()) then
          if (parallel_coupling) then
            call write_nc2D(ncid, trim(fld_ice), gtmp, 2, imt_global,jmt_global, &
                            1,ilout=il_out)
          else
            call write_nc2D(ncid, fld_ice, vwork, 2, imt_global,jmt_global, 1, ilout=il_out)
          end if
        end if
      end do
   end if

   if (mpp_pe() == mpp_root_pe()) call ncheck( nf_close(ncid) )

endif
end subroutine write_coupler_restart

!-----------------------------------------------------------------------------------
subroutine mom_prism_terminate

! PRISM termination
!
! deallocate all coupling associated arrays here ......
! Note: prism won't terminate MPI
!

    call MPI_Barrier(mom4_comm, ierr)


call prism_terminate_proto (ierr)

if (ierr .ne. PRISM_Ok) then
   call mpp_error(FATAL,&
      '==>Error from coupler_termination: Failure in prism_terminate_proto.')

endif

end subroutine mom_prism_terminate

end module mom_oasis3_interface_mod

                  module longwave_tables_mod

! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  Fei Liu
! </CONTACT>
! <REVIEWER EMAIL="ds@gfdl.noaa.gv">
!  Dan Schwarzkopf
! </REVIEWER>
! <OVERVIEW>
!  This code defines longwave radiation tables, it also
!  allocate, compute related parameters based on prescribed
!  tables.
! </OVERVIEW>
! <DESCRIPTION>
! </DESCRIPTION>
!

!    shared modules:

use mpp_mod,               only: input_nml_file
use fms_mod,               only: open_namelist_file, fms_init, &
                                 mpp_pe, mpp_root_pe, stdlog, &
                                 file_exist, write_version_number, &
                                 check_nml_error, error_mesg, &
                                 FATAL, close_file

!  shared radiation package modules:

use rad_utilities_mod,     only: rad_utilities_init,       &  
                                 longwave_tables1_type,  &
                                 longwave_tables2_type,  &
                                 longwave_tables3_type,  &
                                 lw_table_type, Lw_parameters,&
                                 table_alloc, mass_1, temp_1, &
                                 Lw_control
use longwave_params_mod,   only: longwave_params_init, NBLW, NBLX, &
                                 NBLY_RSB, NBLY_CKD

!---------------------------------------------------------------------

implicit none
private

!---------------------------------------------------------------------
!    longwave_tables_mod constructs various tables used in the longwave
!    radiation parameterization.
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module -------------------

character(len=128)  :: version =  '$Id: longwave_tables.F90,v 19.0 2012/01/06 20:18:37 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!---------------------------------------------------------------------
!------    interfaces   ------

public      &
          longwave_tables_init, &
          longwave_tables_end

private      &

!  called from longwave_tables_init:
          idrbtsh2o, id2h2o, table


!---------------------------------------------------------------------
!------  namelist  -----

real       :: dummy = 1.0

namelist / longwave_tables_nml /  &
                                   dummy

!---------------------------------------------------------------------
!---- public data -------


!---------------------------------------------------------------------
!---- private data -------

!--------------------------------------------------------------------
!    define continuum coefficients over special bands, the choices 
!    depend on model architecture. the program gasbnd is used.
!--------------------------------------------------------------------
real, dimension(:), allocatable :: afach4, afan2o
              
real, dimension(:), allocatable :: fbdlo_12001400, fbdhi_12001400
real, dimension(:), allocatable :: dummy_ch4n2o

real, dimension(:), allocatable :: bdlahcn, bdhahcn

real, dimension(:), allocatable :: bfach4, bfan2o             

real, dimension(:), allocatable :: dch4, dn2o, ech4, en2o
real                            :: d171n2o, e171n2o

real, dimension(:), allocatable :: acomb, bcomb, apcm, bpcm, atpcm,  &
                                   btpcm, bdlocm, bdhicm

integer, parameter              :: NTTABH2O   = 28
integer, parameter              :: NUTABH2O   = 181

real, dimension (NBLW)          :: bandlo, bandhi, arndm, brndm, betad
integer, dimension(40)          :: iband
real, dimension(3)              :: ao3cm, bo3cm
real, dimension(2)              :: ab15cm

integer                         :: NBTRG, NBTRGE, NBLY
real                            :: apwd, bpwd, atpwd, btpwd, bdlowd, &
                                   bdhiwd 

logical :: module_is_initialized = .false.   !  module is initialized ?


!---------------------------------------------------------------------
!---------------------------------------------------------------------




                         contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
!#####################################################################

! <SUBROUTINE NAME="longwave_tables_init">
!  <OVERVIEW>
!   Constructor of longwave_tables module
!  </OVERVIEW>
!  <DESCRIPTION>
!   Defines continuum coefficients and random band parameters for longwave
!   gas species.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call longwave_tables_init (Lw_tables, tabsr,   &
!                        tab1, tab2, tab3, tab1w, tab1a, tab2a, tab3a)
!  </TEMPLATE>
!  <IN NAME="Lw_tables" TYPE="lw_table_type">
!   Contains the tables used in longwave radiation
!  </IN>
!  <OUT NAME="tabsr" TYPE="longwave_tables3_type">
!   Contains the tables used in longwave radiation
!  </OUT>
!  <OUT NAME="tab1" TYPE="longwave_tables1_type">
!   Contains the tables used in longwave radiation
!  </OUT>
!  <OUT NAME="tabs2" TYPE="longwave_tables1_type">
!   Contains the tables used in longwave radiation
!  </OUT>
!  <OUT NAME="tab3" TYPE="longwave_tables1_type">
!   Contains the tables used in longwave radiation
!  </OUT>
!  <OUT NAME="tab1w" TYPE="longwave_tables1_type">
!   Contains the tables used in longwave radiation
!  </OUT>
!  <OUT NAME="tab1a" TYPE="longwave_tables2_type">
!   Contains the tables used in longwave radiation
!  </OUT>
!  <OUT NAME="tabs2a" TYPE="longwave_tables2_type">
!   Contains the tables used in longwave radiation
!  </OUT>
!  <OUT NAME="tab3a" TYPE="longwave_tables2_type">
!   Contains the tables used in longwave radiation
!  </OUT>
! </SUBROUTINE>
!
subroutine longwave_tables_init (Lw_tables, tabsr, tab1, tab2, tab3, &
                                 tab1w, tab1a, tab2a, tab3a)

!--------------------------------------------------------------------
!    longwave_tables_init is the constructor for longwave_tables_mod.
!--------------------------------------------------------------------

type(lw_table_type),          intent(inout) :: Lw_tables
type(longwave_tables3_type),  intent(inout) :: tabsr
type (longwave_tables1_type), intent(inout) :: tab1, tab2, tab3, tab1w
type (longwave_tables2_type), intent(inout) :: tab1a, tab2a, tab3a

!---------------------------------------------------------------------
!   intent(inout) variables:
!
!    Lw_tables
!    tabsr
!    tab1
!    tab2
!    tab3
!    tab1w
!    tab1a
!    tab2a
!    tab3a
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables:

!---------------------------------------------------------------------
!    define continuum coefficients over special bands, the choices 
!    depend on model architecture. the program gasbnd is used.
!---------------------------------------------------------------------
      real                          :: apwd_c, bpwd_c, atpwd_c,    &
                                       btpwd_c, bdlowd_c, bdhiwd_c
      real, dimension (NBLY_CKD)    :: acomb_c, bcomb_c, apcm_c,  &
                                       bpcm_c, atpcm_c,   &
                                       btpcm_c, bdlocm_c,  bdhicm_c
      integer                       :: inrad, k
      integer                       :: subb
      integer, dimension(5)         :: no_h2o12001400bands = &
                                        (/ 1, 2, 4, 10, 20 /)
 
!---------------------------------------------------------------------
!    2) 160-560 (as 40 bands). program gasbnd is used with 10 cm-1
!    bandwidth. iband is straightforward mapping.
!---------------------------------------------------------------------
      integer, dimension(40)        :: iband_c
      data iband_c /    &
          1,   2,   3,   4,   5,   6,   7,   8,   9,  10,   &
         11,  12,  13,  14,  15,  16,  17,  18,  19,  20,  &
         21,  22,  23,  24,  25,  26,  27,  28,  29,  30,   &
         31,  32,  33,  34,  35,  36,  37,  38,  39,  40/ 

!----------------------------------------------------------------------
!    define random band parameters for special bands. the choices 
!    depend on model architecture. the program gasbnd is used.
!    2) 160-560 (as 8 bands using combined bands). program gasbnd is
!    used as 40 bands (160-560,10 cm-1 bandwidth) with ifdef icomb
!    on. combined bands defined according to index iband.
!----------------------------------------------------------------------
      real                        ::   apwd_n, bpwd_n, atpwd_n,   &
                                       btpwd_n, bdlowd_n, bdhiwd_n
      real, dimension (NBLY_RSB)  ::   acomb_n, bcomb_n, apcm_n,  &
                                       bpcm_n, atpcm_n, btpcm_n,  &
                                       bdlocm_n,  bdhicm_n
      real, dimension(NBLY_RSB)   ::   dummy_n
      real                        ::   dum
 
      integer, dimension(40)      ::   iband_n
      data iband_n /   &
          2,   1,   2,   2,   1,   2,   1,   3,   2,   2,   &
          3,   2,   2,   4,   2,   4,   2,   3,   3,   2,  &
          4,   3,   4,   3,   7,   5,   6,   7,   6,   5,  &
          7,   6,   7,   8,   6,   6,   8,   8,   8,   8/
 
!---------------------------------------------------------------------
!    miscellaneous variables:
!    unit            io unit number used for namelist file
!    ierr            error code
!    io              error status returned from io operation
!    k4
!    n4
!---------------------------------------------------------------------
      integer    :: unit, ierr, io, logunit


!---------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return
 
!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call rad_utilities_init
      call longwave_params_init

!-----------------------------------------------------------------------
!    read namelist.
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=longwave_tables_nml, iostat=io)
      ierr = check_nml_error(io,"longwave_tables_nml")
#else
!-----------------------------------------------------------------------
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=longwave_tables_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'longwave_tables_nml')
        end do
10      call close_file (unit)
      endif
#endif
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                          write (logunit, nml=longwave_tables_nml)

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      if (trim(Lw_control%linecatalog_form) == 'hitran_1992' ) then
        if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
            trim(Lw_control%continuum_form) == 'ckd2.4' ) then

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
          inrad = open_namelist_file ('INPUT/h2ocoeff_ckd_speccombwidebds_hi92')
          read (inrad,9000) dum
          read (inrad,9000) dum
          read (inrad,9000) apwd_c   ! ckd capphi coeff for 560-800 band
          read (inrad,9000) bpwd_c   ! ckd cappsi coeff for 560-800 band
          read (inrad,9000) atpwd_c  ! ckd capphi coeff for 560-800 band
          read (inrad,9000) btpwd_c  ! ckd cappsi coeff for 560-800 band
          read (inrad,9000) bdlowd_c  ! lo freq of 560-800 band
          read (inrad,9000) bdhiwd_c  ! hi freq of 560-800 band
!  ckd rndm coeff for 40 bands (160-560) and 8 wide bands (560-1400)
          read (inrad,9000) (acomb_c(k),k=1,NBLY_CKD)
          read (inrad,9000) (bcomb_c(k),k=1,NBLY_CKD)
          read (inrad,9000) (apcm_c(k),k=1,NBLY_CKD)
          read (inrad,9000) (bpcm_c(k),k=1,NBLY_CKD)
          read (inrad,9000) (atpcm_c(k),k=1,NBLY_CKD)
          read (inrad,9000) (btpcm_c(k),k=1,NBLY_CKD)
!  ckd lo/hi freq for 40 bands (160-560) and 8 wide bands (560-1400)
          read (inrad,9000) (bdlocm_c(k),k=1,NBLY_CKD)
          read (inrad,9000) (bdhicm_c(k),k=1,NBLY_CKD)

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
        else if (trim(Lw_control%continuum_form) == 'rsb' ) then
          inrad = open_namelist_file ('INPUT/h2ocoeff_rsb_speccombwidebds_hi92')
          read (inrad,9000) dum     
          read (inrad,9000) dum    
          read (inrad,9000) apwd_n   ! rsb capphi coeff for 560-800 band
          read (inrad,9000) bpwd_n   ! rsb cappsi coeff for 560-800 band
          read (inrad,9000) atpwd_n  ! rsb capphi coeff for 560-800 band
          read (inrad,9000) btpwd_n  ! rsb cappsi coeff for 560-800 band
          read (inrad,9000) bdlowd_n ! lo freq of 560-800 band
          read (inrad,9000) bdhiwd_n ! hi freq of 560-800 band
          read (inrad,9000) dum   
!  rsb rndm coeff for 8 comb bands (160-560) and 8 wide bands (560-1400)
          read (inrad,9000) (acomb_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (bcomb_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (apcm_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (bpcm_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (atpcm_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (btpcm_n(k),k=1,NBLY_RSB)
!  rsb lo/hi freq for 8 comb bands (160-560) and 8 wide bands (560-1400)
          read (inrad,9000) (bdlocm_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (bdhicm_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
        endif

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      else if (trim(Lw_control%linecatalog_form) == 'hitran_2000' ) then
        if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
            trim(Lw_control%continuum_form) == 'ckd2.4' ) then
          inrad = open_namelist_file ('INPUT/h2ocoeff_ckd_speccombwidebds_hi00')
          read (inrad,9000) dum
          read (inrad,9000) dum
          read (inrad,9000) apwd_c   ! ckd capphi coeff for 560-800 band
          read (inrad,9000) bpwd_c   ! ckd cappsi coeff for 560-800 band
          read (inrad,9000) atpwd_c  ! ckd capphi coeff for 560-800 band
          read (inrad,9000) btpwd_c  ! ckd cappsi coeff for 560-800 band
          read (inrad,9000) bdlowd_c ! lo freq of 560-800 band
          read (inrad,9000) bdhiwd_c ! hi freq of 560-800 band
!  ckd rndm coeff for 40 bands (160-560) and 8 wide bands (560-1400)
          read (inrad,9000) (acomb_c(k),k=1,NBLY_CKD)
          read (inrad,9000) (bcomb_c(k),k=1,NBLY_CKD)
          read (inrad,9000) (apcm_c(k),k=1,NBLY_CKD)
          read (inrad,9000) (bpcm_c(k),k=1,NBLY_CKD)
          read (inrad,9000) (atpcm_c(k),k=1,NBLY_CKD)
          read (inrad,9000) (btpcm_c(k),k=1,NBLY_CKD)
!  ckd lo/hi freq for 40 bands (160-560) and 8 wide bands (560-1400)
          read (inrad,9000) (bdlocm_c(k),k=1,NBLY_CKD)
          read (inrad,9000) (bdhicm_c(k),k=1,NBLY_CKD)

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
        else if (trim(Lw_control%continuum_form) == 'rsb' ) then
          inrad = open_namelist_file ('INPUT/h2ocoeff_rsb_speccombwidebds_hi00')
          read (inrad,9000) dum     
          read (inrad,9000) dum    
          read (inrad,9000) apwd_n   ! rsb capphi coeff for 560-800 band
          read (inrad,9000) bpwd_n   ! rsb cappsi coeff for 560-800 band
          read (inrad,9000) atpwd_n  ! rsb capphi coeff for 560-800 band
          read (inrad,9000) btpwd_n  ! rsb cappsi coeff for 560-800 band
          read (inrad,9000) bdlowd_n ! lo freq of 560-800 band
          read (inrad,9000) bdhiwd_n ! hi freq of 560-800 band
          read (inrad,9000) dum   
!  rsb rndm coeff for 8 comb bands (160-560) and 8 wide bands (560-1400)
          read (inrad,9000) (acomb_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (bcomb_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (apcm_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (bpcm_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (atpcm_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (btpcm_n(k),k=1,NBLY_RSB)
!  rsb lo/hi freq for 8 comb bands (160-560) and 8 wide bands (560-1400)
          read (inrad,9000) (bdlocm_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (bdhicm_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
        endif
      endif
      call close_file (inrad)

!----------------------------------------------------------------------
!
!---------------------------------------------------------------------
      if (Lw_parameters%NBTRG_iz) then
        NBTRG  = Lw_parameters%NBTRG
      else
        call error_mesg ('longwave_tables_mod', &
                       ' Lw_parameters%NBTRG not yet defined', FATAL) 
      endif
      if (Lw_parameters%NBTRGE_iz) then
        NBTRGE = Lw_parameters%NBTRGE
      else
        call error_mesg ('longwave_tables_mod', &
                       ' Lw_parameters%NBTRGE not yet defined', FATAL)
      endif

!----------------------------------------------------------------------
!
!---------------------------------------------------------------------
      if (NBTRGE > 0) then
        allocate ( fbdlo_12001400 (NBTRGE) )
        allocate ( fbdhi_12001400 (NBTRGE) )
        allocate ( dummy_ch4n2o (NBTRGE) )
      endif
      if (NBTRG  > 0) then
        allocate ( afach4 (NBTRG ) )
        allocate ( afan2o (NBTRG ) )
        allocate ( bdlahcn(NBTRG ) )
        allocate ( bdhahcn(NBTRG ) )
        allocate ( bfach4 (NBTRG ) )
        allocate ( bfan2o (NBTRG ) )
        allocate ( dch4   (NBTRG ) )
        allocate ( dn2o   (NBTRG ) )
        allocate ( ech4   (NBTRG ) )
        allocate ( en2o   (NBTRG ) )
      endif

!----------------------------------------------------------------------
!
!---------------------------------------------------------------------
      if (NBTRGE > 0) then
        if (trim(Lw_control%linecatalog_form) == 'hitran_1992') then
          inrad = open_namelist_file ('INPUT/h2o12001400_hi92_data')
        else if(trim(Lw_control%linecatalog_form) == 'hitran_2000') then
          inrad = open_namelist_file ('INPUT/h2o12001400_hi00_data')
        endif

!----------------------------------------------------------------------
!    read in random coefficients for 1200-1400 freq region, spacing
!    through the data until  those appropriate for NBTRGE h2o bands
!    are reached. note: unless a continuum is inserted beyond 1200
!    cm-1, the band coefficients are independent of continuum type.
!---------------------------------------------------------------------
        do subb = 1,5    ! 5 = no. band divisions in h2o 1200-1400 data
          if (NBTRGE == no_h2o12001400bands(subb)) then

!---------------------------------------------------------------------
!    read and process data for sub-band number from data matching NBTRGE
!    then exit subb loop
!---------------------------------------------------------------------
            read (inrad,2001) (dummy_ch4n2o(k),k=1,NBTRGE)
            read (inrad,2001) (dummy_ch4n2o(k),k=1,NBTRGE)
            read (inrad,2001) (dummy_ch4n2o(k),k=1,NBTRGE)
            read (inrad,2001) (dummy_ch4n2o(k),k=1,NBTRGE)
            read (inrad,2001) (dummy_ch4n2o(k),k=1,NBTRGE)
            read (inrad,2001) (dummy_ch4n2o(k),k=1,NBTRGE)
            read (inrad,2001) (fbdlo_12001400(k),k=1,NBTRGE)
            read (inrad,2001) (fbdhi_12001400(k),k=1,NBTRGE)
            exit
          else if (subb < 5) then 

!---------------------------------------------------------------------
!    read data for sub-band number from  data not matching NBTRGE
!---------------------------------------------------------------------
            read (inrad,2001) (dummy_ch4n2o(k),k=1,  &
                                          no_h2o12001400bands(subb))
            read (inrad,2001) (dummy_ch4n2o(k),k=1,  &
                                          no_h2o12001400bands(subb))
            read (inrad,2001) (dummy_ch4n2o(k),k=1,  &
                                          no_h2o12001400bands(subb))
            read (inrad,2001) (dummy_ch4n2o(k),k=1,  &
                                          no_h2o12001400bands(subb))
            read (inrad,2001) (dummy_ch4n2o(k),k=1,  &
                                          no_h2o12001400bands(subb))
            read (inrad,2001) (dummy_ch4n2o(k),k=1,  &
                                          no_h2o12001400bands(subb))
            read (inrad,2001) (dummy_ch4n2o(k),k=1,  &
                                          no_h2o12001400bands(subb))
            read (inrad,2001) (dummy_ch4n2o(k),k=1,  &
                                          no_h2o12001400bands(subb))
          else

!---------------------------------------------------------------------
!    failure of any sub-band number to match NBTRGE
!---------------------------------------------------------------------
            call error_mesg ('longwave_tables_mod', &
                 'NBTRGE is inconsistent with available data', FATAL)
          endif
        end do
        call close_file(inrad)
      endif

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      if (trim(Lw_control%linecatalog_form) == 'hitran_1992') then
        if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
            trim(Lw_control%continuum_form) == 'ckd2.4' ) then
          NBLY = NBLY_CKD
          call id2h2o ('INPUT/id2h2obdckd2p1')
        else if (trim(Lw_control%continuum_form) == 'rsb' ) then
          NBLY = NBLY_RSB
          call id2h2o ('INPUT/id2h2obdfull')

!----------------------------------------------------------------------
!  read roberts continuum data for self-broadened h2o continuum
!----------------------------------------------------------------------
          call idrbtsh2o
        endif

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      else if (trim(Lw_control%linecatalog_form) == 'hitran_2000' ) then
        if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
            trim(Lw_control%continuum_form) == 'ckd2.4' ) then
          NBLY = NBLY_CKD
          call id2h2o ('INPUT/h2ocoeff_ckd_0_3000_10cm_hi00')
        else if (trim(Lw_control%continuum_form) == 'rsb' ) then
          NBLY = NBLY_RSB
          call id2h2o ('INPUT/h2ocoeff_rsb_0_3000_10cm_hi00')

!----------------------------------------------------------------------
!  read roberts continuum data for self-broadened h2o continuum
!----------------------------------------------------------------------
          call idrbtsh2o
        endif
      endif

      allocate  ( acomb(NBLY))
      allocate  ( bcomb(NBLY))
      allocate  ( apcm (NBLY))
      allocate  ( bpcm (NBLY))
      allocate  ( atpcm(NBLY))
      allocate  ( btpcm(NBLY))
      allocate  (bdlocm(NBLY))
      allocate  (bdhicm(NBLY))

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        apwd = apwd_c
        bpwd = bpwd_c
        atpwd = atpwd_c
        btpwd = btpwd_c
        bdlowd = bdlowd_c
        bdhiwd = bdhiwd_c
        iband = iband_c
        acomb = acomb_c
        bcomb = bcomb_c
        apcm = apcm_c
        bpcm = bpcm_c
        atpcm = atpcm_c
        btpcm = btpcm_c
        bdlocm = bdlocm_c
        bdhicm = bdhicm_c
      else if (trim(Lw_control%continuum_form) == 'rsb' ) then
        apwd = apwd_n
        bpwd = bpwd_n
        atpwd = atpwd_n
        btpwd = btpwd_n
        bdlowd = bdlowd_n
        bdhiwd = bdhiwd_n
        iband = iband_n
        acomb = acomb_n
        bcomb = bcomb_n
        apcm = apcm_n
        bpcm = bpcm_n
        atpcm = atpcm_n
        btpcm = btpcm_n
        bdlocm = bdlocm_n
        bdhicm = bdhicm_n
      endif

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      call table_alloc (tab1 , NTTABH2O, NUTABH2O)
      call table_alloc (tab2 , NTTABH2O, NUTABH2O)
      call table_alloc (tab3 , NTTABH2O, NUTABH2O)
      call table_alloc (tab1w, NTTABH2O, NUTABH2O)
      if (NBTRGE > 0) then
        call table_alloc (tab1a, NTTABH2O, NUTABH2O, NBTRGE)
        call table_alloc (tab2a, NTTABH2O, NUTABH2O, NBTRGE)
        call table_alloc (tab3a, NTTABH2O, NUTABH2O, NBTRGE)
      endif
      call table_alloc (tabsr, NTTABH2O, NBLY    )

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      call table (tabsr, tab1, tab2, tab3, tab1w, &
                  tab1a, tab2a, tab3a )

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      allocate (Lw_tables%bdlocm(NBLY))
      allocate (Lw_tables%bdhicm(NBLY))
      allocate (Lw_tables%iband (40))
      allocate (Lw_tables%bandlo (NBLW))
      allocate (Lw_tables%bandhi (NBLW))
      Lw_tables%bdlocm = bdlocm
      Lw_tables%bdhicm = bdhicm
      Lw_tables%iband  = iband 
      Lw_tables%bandlo = bandlo
      Lw_tables%bandhi = bandhi

!---------------------------------------------------------------------
!    mark the module as initialized.
!---------------------------------------------------------------------
      module_is_initialized = .true.

!---------------------------------------------------------------------
2001  format (5e14.6)
9000  format (5e14.6)

!----------------------------------------------------------------------



end subroutine longwave_tables_init



!#####################################################################


! <SUBROUTINE NAME="longwave_tables_end">
!  <OVERVIEW>
!   Destructor of longwave_tables module
!  </OVERVIEW>
!  <DESCRIPTION>
!   Closes out longwave tables module.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call longwave_tables_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine longwave_tables_end

!--------------------------------------------------------------------
!    longwave_tables_end is the destructor for longwave_tables_mod.
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('longwave_tables_mod', &
             'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!    mark the module as uninitialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.

!---------------------------------------------------------------------

 

end subroutine longwave_tables_end 




!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                    PRIVATE SUBROUTINES
!                                
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!####################################################################
! <SUBROUTINE NAME="idrbtsh2o">
!  <OVERVIEW>
!   Subroutine to read h2o roberts continuum quantities used in longwave
!   radiation
!  </OVERVIEW>
!  <DESCRIPTION>
!   This subroutine reads h2o roberts continuum quantities used in
!   longwave radiation from an INPUT file.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call idrbtsh2o
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine idrbtsh2o

!----------------------------------------------------------------------
!    idrbtsh2o reads h2o roberts continuum quantities used in
!    longwave radiation.
!    author: m. d. schwarzkopf
!    revised: 1/1/96
!    certified:  radiation version 1.0
!----------------------------------------------------------------------

!------------------------------------------------------------------
!  local variables:

      integer   :: inrad  !  unit number for i/o
      integer   :: k      !  do-loop index

!-----------------------------------------------------------------------
!    the following roberts continuum coefficients are computed using the
!    program (gasbnd) over the 0-3000 cm-1 range with 10 cm-1 bandwidth.
!-----------------------------------------------------------------------
      inrad = open_namelist_file ('INPUT/id2h2orbts')
      read (inrad, FMT = '(5e14.6)') (betad(k),k=1,NBLW)
      call close_file (inrad)

!---------------------------------------------------------------------
 
end subroutine idrbtsh2o


!#####################################################################

subroutine id2h2o (filename)

!---------------------------------------------------------------------
!    id2h2o reads h2o random model band parameters used for 
!    longwave radiation
!    references:
!     (1) fels, s. b., and m. d. schwarzkopf, "the simplified exchange
!         approximation: a new method for radiative transfer
!         calculations," journal atmospheric science, 32 (1975),
!         1475-1488.
!    author: m. d. schwarzkopf
!    revised: 1/1/96
!    certified:  radiation version 1.0
!---------------------------------------------------------------------

character(len=*), intent(in)   :: filename

!---------------------------------------------------------------------
!  intent(in) variable:
!
!    filename
!
!---------------------------------------------------------------------

!------------------------------------------------------------------
!  local variables:

      real, dimension (NBLW) :: dummy   ! dummy array

      integer   :: inrad  !  unit number for i/o
      integer   :: k      !  do-loop index

!-----------------------------------------------------------------------
!    the following h2o random band parameters are obtained from the
!    afgl 1992 HITRAN tape. parameters are obtained using an auxi-
!    liary program (gasbnd). values depend on assumptions as to
!    line shape, line strength and width. The inputted values span
!    the 0-3000 cm-1 range, with 10 cm-1 bandwidth. other parameter
!    values used in the program are obtained separately.
!-----------------------------------------------------------------------
      inrad = open_namelist_file (filename)
      read (inrad,9000) (arndm(k),k=1,NBLW)
      read (inrad,9000) (brndm(k),k=1,NBLW)
      read (inrad,9000) (dummy(k),k=1,NBLW)
      read (inrad,9000) (dummy(k),k=1,NBLW)
      read (inrad,9000) (dummy(k),k=1,NBLW)
      read (inrad,9000) (dummy(k),k=1,NBLW)
      read (inrad,9000) (bandlo(k),k=1,NBLW)
      read (inrad,9000) (bandhi(k),k=1,NBLW)
      call close_file (inrad)

!--------------------------------------------------------------------
9000  format(5e14.6)

!--------------------------------------------------------------------


end subroutine id2h2o




!#####################################################################
! <SUBROUTINE NAME="table">
!  <OVERVIEW>
!   Subroutine to compute table entries used in longwave radiation
!  </OVERVIEW>
!  <DESCRIPTION>
!   This subroutine computes the table entries used in longwave radiation
!  </DESCRIPTION>
!  <TEMPLATE>
!   call table  (tabsr, tab1, tab2, tab3, tab1w, tab1a, tab2a, tab3a)
!  </TEMPLATE>
!  <OUT NAME="tabsr" TYPE="longwave_tables3_type">
!   Contains the tables used in longwave radiation
!  </OUT>
!  <OUT NAME="tab1" TYPE="longwave_tables1_type">
!   Contains the tables used in longwave radiation
!  </OUT>
!  <OUT NAME="tabs2" TYPE="longwave_tables1_type">
!   Contains the tables used in longwave radiation
!  </OUT>
!  <OUT NAME="tab3" TYPE="longwave_tables1_type">
!   Contains the tables used in longwave radiation
!  </OUT>
!  <OUT NAME="tab1w" TYPE="longwave_tables1_type">
!   Contains the tables used in longwave radiation
!  </OUT>
!  <OUT NAME="tab1a" TYPE="longwave_tables2_type">
!   Contains the tables used in longwave radiation
!  </OUT>
!  <OUT NAME="tabs2a" TYPE="longwave_tables2_type">
!   Contains the tables used in longwave radiation
!  </OUT>
!  <OUT NAME="tab3a" TYPE="longwave_tables2_type">
!   Contains the tables used in longwave radiation
!  </OUT>
! </SUBROUTINE>
!
subroutine table  (tabsr, tab1, tab2, tab3, tab1w, tab1a, tab2a, tab3a)

!---------------------------------------------------------------------
!    table computes table entries used in longwave radiation.  
!    author: m. d. schwarzkopf
!    revised: 1/1/93
!    certified:  radiation version 1.0
!---------------------------------------------------------------------
 
type(longwave_tables3_type), intent(inout)   :: tabsr
type(longwave_tables1_type), intent(inout)   :: tab1, tab2, tab3, tab1w
type(longwave_tables2_type), intent(inout)   :: tab1a, tab2a, tab3a

!----------------------------------------------------------------------
!  intent(inout) variables:
!
!     tabsr
!     tab1
!     tab2
!     tab3
!     tab1w
!     tab1a
!     tab2a
!     tab3a
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables:

      real, dimension (:,:), allocatable   :: r1a, r2a, s2a, t3a,   &
                                              sum4a, sum6a, sum7a, sum8a
      real, dimension(:,:,:),allocatable   :: suma, sumdbea, sum3a 
      real, dimension (NBLW)               :: alfanb, anb, arotnb,   &
                                              betanb, bnb, centnb, delnb
      real, dimension (30)                 :: cnusb, dnusb
      real, dimension (NTTABH2O,NBLW)      :: dbdtnb, src1nb
      real, dimension (NTTABH2O,NBLX)      :: srcwd        
      real, dimension (NTTABH2O, NUTABH2O) :: sumdbe, sum, sum3, sumwde
      real, dimension (NTTABH2O)           :: ddsc, fortcu, r1, r1wd, &
                                              r2, s2, sc, srcs, sum4, &
                                              sum4wd, sum6, sum7, sum8,&
                                              t3, tfour, x, x1, xtemv
      real, dimension (NUTABH2O)           :: expo, fac, x2, zmass, &
                                              zroot
      integer                              :: n, m, ioffset, itab,   &
                                              jtab, nsubds, nsb,  iter
      real                                 :: zmassincr, cent, del,&
                                              bdlo, bdhi, anu, c1,   &
                                              freq_cutoff

!---------------------------------------------------------------------
!  local variables:
!
!    r1a
!    r2a
!    s2a
!    t3a
!    sum4a
!    sum6a
!    sum7a
!    sum8a
!    suma
!    suma
!    sumdbea
!    sum3a
!    ETC. 

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      if (NBTRGE > 0) then
        allocate ( r1a     (NTTABH2O,NBTRGE) )
        allocate (r2a      (NTTABH2O,NBTRGE) )
        allocate (s2a      (NTTABH2O,NBTRGE) )
        allocate ( t3a     (NTTABH2O,NBTRGE) )
        allocate ( suma    (NTTABH2O,NUTABH2O,NBTRGE) )
        allocate ( sumdbea (NTTABH2O,NUTABH2O,NBTRGE) )
        allocate ( sum3a   (NTTABH2O,NUTABH2O,NBTRGE) )
        allocate ( sum4a   (NTTABH2O,NBTRGE) )
        allocate ( sum6a   (NTTABH2O,NBTRGE) )
        allocate ( sum7a   (NTTABH2O,NBTRGE) )
        allocate (sum8a    (NTTABH2O,NBTRGE) )
      endif

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      if (Lw_parameters%offset_iz) then
        ioffset = Lw_parameters%offset
      else
        call error_mesg ('longwave_tables_mod', &
                 ' Lw_parameters%offset not yet defined', FATAL)
      endif

!--------------------------------------------------------------------- 
!     compute local quantities and ao3, bo3, ab15 for narrow bands.
!---------------------------------------------------------------------
      do n=1,NBLW
        anb   (n) = arndm(n) 
        bnb   (n) = brndm(n) 
        centnb(n) = 0.5E+00*(bandlo(n) + bandhi(n)) 
        delnb (n) = bandhi(n) - bandlo(n)
        betanb(n) = betad(n)
      enddo

!---------------------------------------------------------------------
!    compute a*b and sqrt(a*b) for all 10 cm-1 frequency bands.
!---------------------------------------------------------------------
      do n=1,NBLW
        alfanb(n) = bnb(n)*anb(n) 
        arotnb(n) = SQRT(alfanb(n))
      enddo

!-------------------------------------------------------------------
!   define critical frequency (cutoff for wide band ?? )
!------------------------------------------------------------------
      if (NBTRGE > 0) then
        freq_cutoff = 1400.
      else
        freq_cutoff = 1200.
      endif

!---------------------------------------------------------------------
!    begin table computations here.  compute temperatures and masses
!    for table entries.
!    note: the dimensioning and initialization of xtemv and other
!    arrays with dimension of NTTABH2O=28 imply a restriction of model 
!    temperatures from 100k to 370k.
!    the dimensioning of zmass, zroot and other arrays with 
!    dimension of NUTABH2O=181 imply a restriction of model h2o amounts
!    such that optical paths are between 10**-16 and 10**2, in cgs 
!    units (index 2-181), plus zero (index 1).
!---------------------------------------------------------------------
      zmass(1) = 0.0
      zmass(2) = 10.0E+00**mass_1%min_val
      zmassincr = 10.0E+00**mass_1%tab_inc
 
!---------------------------------------------------------------------
!    the definition of zmassincr as 10**0.1 is slightly different from
!    all previous versions, in which it is 1.258925411E+00. This
!    produces slightly different answers (fluxes differ by 1.0e-6 W/m2).
!---------------------------------------------------------------------
      do jtab=3,NUTABH2O
        zmass(jtab) = zmass(jtab-1)*zmassincr
      enddo
      zroot(1) = 0.0
      do jtab=2,NUTABH2O
        zroot(jtab) = SQRT(zmass(jtab))
      enddo 
      do itab=1,NTTABH2O
        xtemv (itab) = temp_1%min_val + temp_1%tab_inc*(itab-1)
        tfour (itab) = xtemv(itab)**4
        fortcu(itab) = 4.0E+00*xtemv(itab)**3
      enddo
      
!---------------------------------------------------------------------
!    the computation of source, dsrce is needed only for the combined 
!    wide band case.  to obtain them,  the source must be computed 
!    for each of the NBLX wide bands srcwd then combined using iband
!    into source.
!---------------------------------------------------------------------
      do n=1,NBLY
        do itab=1,NTTABH2O
          tabsr%vae  (itab,n) = 0.0E+00
        enddo
      enddo
      do n=1,NBLX
        do itab=1,NTTABH2O
          srcwd(itab,n) = 0.0E+00
        enddo
      enddo

!---------------------------------------------------------------------
!    begin frequency loop.
!---------------------------------------------------------------------
      do n=1,NBLX 
  
!---------------------------------------------------------------------
!     the 160-560 cm-1 region
!---------------------------------------------------------------------
        if (n .LE. 40) then
          cent = centnb(n+16) 
          del  = delnb (n+16) 
          bdlo = bandlo(n+16) 
          bdhi = bandhi(n+16) 
 
!---------------------------------------------------------------------
!      the 560-1200 cm-1 region, and the 2270-2380 cm-1 region
!---------------------------------------------------------------------
        else
          cent = 0.5E+00*(bdlocm(n-32+ioffset) + bdhicm(n-32+ioffset))
          del  = bdhicm(n-32+ioffset) - bdlocm(n-32+ioffset)
          bdlo = bdlocm(n-32+ioffset)
          bdhi = bdhicm(n-32+ioffset)
        endif

!---------------------------------------------------------------------
!    for purposes of accuracy, all evaluations of planck functions
!    are made on 10 cm-1 intervals, then summed into the NBLX wide 
!    bands.  the last subband may be narrower than 10 cm-1.
!---------------------------------------------------------------------
        nsubds = (del - 1.0E-03)/10 + 1
        do nsb=1,nsubds 
          if(nsb .NE. nsubds) then 
            cnusb(nsb) = 10.0E+00*(nsb - 1) + bdlo + 5.0E+00
            dnusb(nsb) = 10.0E+00
          else
            cnusb(nsb) = 0.5E+00*(10.0E+00*(nsb - 1) + bdlo + bdhi)
            dnusb(nsb) = bdhi -  (10.0E+00*(nsb - 1) + bdlo)
          endif 
          c1 = 3.7412E-05*cnusb(nsb)**3

!---------------------------------------------------------------------
!    begin temperature loop.
!---------------------------------------------------------------------
          do itab=1,NTTABH2O
            x    (itab)   = 1.4387E+00*cnusb(nsb)/xtemv(itab)
            x1   (itab)   = EXP(x(itab)) 
            srcs (itab)   = c1/(x1(itab) - 1.0E+00)
            srcwd(itab,n) = srcwd(itab,n) + srcs(itab)*dnusb(nsb)
          enddo
        enddo
      enddo

!---------------------------------------------------------------------
!    the following loops create the combined wide band quantities 
!    source and dsrce.  the first 40 bands map to bands 1 to 8 in
!    source and dsrce for the bands in the case of using the rsb
!    continuum . the first 40 bands map to bands 1 to 40 if the
!    band structure for the ckd continuum is used.
!---------------------------------------------------------------------
      do n=1,40
        do itab=1,NTTABH2O 
          tabsr%vae  (itab,iband(n)) = tabsr%vae(itab,iband(n)) +      &
                                  srcwd(itab,n)
        enddo
      enddo
      do n=9+ioffset,NBLY  
        do itab=1,NTTABH2O
          tabsr%vae  (itab,n) = srcwd(itab,n+32-ioffset)
        enddo
      enddo
      do n=1,NBLY
        do itab=1,NTTABH2O-1 
          tabsr%td(itab,n) = (tabsr%vae(itab+1,n) -   &
                      tabsr%vae(itab,n))*0.1E+00
        enddo
      enddo

!---------------------------------------------------------------------
!    first compute planck functions src1nb and derivatives dbdtnb 
!    for use in table evaluations.  these are different from source,
!    dsrce because different frequency points are used in evaluation,
!    the frequency ranges are different, and the derivative algorithm
!    is different.
!---------------------------------------------------------------------
      do n=1,NBLW 
        cent = centnb(n)
        del  = delnb (n)

!---------------------------------------------------------------------
!    note: at present, the iter loop is only used for iter=2.  the 
!    loop structure is kept so that in the future, we may use a
!    quadrature scheme for the planck function evaluation, rather
!    than use the mid-band frequency.
!---------------------------------------------------------------------
        do iter=2,2
          anu = cent + 0.5E+00*(iter - 2)*del 
          c1  = (3.7412E-05)*anu**3
!---------------------------------------------------------------------
!    temperature loop.
!---------------------------------------------------------------------
          do itab=1,NTTABH2O
            x  (itab)      = 1.4387E+00*anu/xtemv(itab)
            x1 (itab)      = EXP(x(itab))
            sc (itab)      = c1/((x1(itab) - 1.0E+00) + 1.0E-20) 
            sc (itab)      = c1/(x1(itab) - 1.0E+00)
            ddsc(itab)     = sc(itab)/(x1(itab)-1.0E+00)*x1(itab)*  &
                             x(itab)/xtemv(itab)
            src1nb(itab,n) = del*sc (itab)
            dbdtnb(itab,n) = del*ddsc(itab)
          enddo
        enddo
      enddo

!---------------------------------------------------------------------
!    next compute r1, r2, s2, and t3 coefficients used for e3 
!    function when the optical path is less than 10**-4.  in this 
!    case, we assume a different dependence on zmass.  also obtain 
!    r1wd, which is r1 summed over the 160-560 cm-1 range.
!---------------------------------------------------------------------
      do itab=1,NTTABH2O
        sum4  (itab) = 0.0E+00
        sum6  (itab) = 0.0E+00
        sum7  (itab) = 0.0E+00
        sum8  (itab) = 0.0E+00
        sum4wd(itab) = 0.0E+00
      enddo

      if (NBTRGE > 0) then
        sum4a (:,:)    = 0.0E+00
        sum6a (:,:)    = 0.0E+00
        sum7a (:,:)    = 0.0E+00
        sum8a (:,:)    = 0.0E+00
      endif

      do n=1,NBLW 
        cent = centnb(n)
!---------------------------------------------------------------------
!#ifndef ch4n2o
!    perform summations for frequency ranges of 0-560, 1200-2200 cm-1 
!#else   ch4n2o
!    perform summations for frequency ranges of 0-560, 1400-2200 cm-1 
!#endif ch4n2o
!---------------------------------------------------------------------
        if (cent .LT. 5.6E+02 .OR. cent .GT. freq_cutoff .AND.   &
            cent .LE. 2.2E+03) then
          do itab=1,NTTABH2O 
            sum4(itab) = sum4(itab) + src1nb(itab,n)
            sum6(itab) = sum6(itab) + dbdtnb(itab,n)
            sum7(itab) = sum7(itab) + dbdtnb(itab,n)*arotnb(n)
            sum8(itab) = sum8(itab) + dbdtnb(itab,n)*alfanb(n)
          enddo
        endif

        if (NBTRGE > 0) then

!---------------------------------------------------------------------
!    perform summations for frequency range of 1200-1400 cm-1
!    for sum4a, sum6a, sum7a, and sum8a. the computation depends
!    on the value of NBTRGE.
!---------------------------------------------------------------------
          if (cent .GT. 1.2E+03 .AND. cent .LE. 1.4E+03) then
            do m=1,NBTRGE
              if (cent .GT. fbdlo_12001400(m) .AND.   &
                  cent .LE. fbdhi_12001400(m)) then
                sum4a(:,m) = sum4a(:,m) + src1nb(:,n)
                sum6a(:,m) = sum6a(:,m) + dbdtnb(:,n)
                sum7a(:,m) = sum7a(:,m) + dbdtnb(:,n)*arotnb(n)
                sum8a(:,m) = sum8a(:,m) + dbdtnb(:,n)*alfanb(n)
              endif
            enddo
          endif
        endif

!---------------------------------------------------------------------
!    perform summations over 160-560 cm-1 frequency range for e1 
!    calculations sum4wd.
!---------------------------------------------------------------------
        if (cent .GT. 1.6E+02 .AND. cent .LT. 5.6E+02) then
          do itab=1,NTTABH2O 
            sum4wd(itab) = sum4wd(itab) + src1nb(itab,n)
          enddo
        endif 
      enddo

!--------------------------------------------------------------------
!
!--------------------------------------------------------------------
      do itab=1,NTTABH2O
        r1(itab)   = sum4(itab)/tfour (itab)
        r2(itab)   = sum6(itab)/fortcu(itab) 
        s2(itab)   = sum7(itab)/fortcu(itab) 
        t3(itab)   = sum8(itab)/fortcu(itab) 
        r1wd(itab) = sum4wd(itab)/tfour(itab)
      enddo

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      do jtab=1,NUTABH2O
        do itab=1,NTTABH2O
          sum   (itab,jtab) = 0.0E+00 
          sumdbe(itab,jtab) = 0.0E+00
          sum3  (itab,jtab) = 0.0E+00
          sumwde(itab,jtab) = 0.0E+00
        enddo
      enddo
      if (NBTRGE > 0) then
        do m=1,NBTRGE
          r1a(:,m)   = sum4a(:,m)/tfour(:)
          r2a(:,m)   = sum6a(:,m)/fortcu(:)
          s2a(:,m)   = sum7a(:,m)/fortcu(:)
          t3a(:,m)   = sum8a(:,m)/fortcu(:)
        enddo
        suma   (:,:,:) = 0.0E+00 
        sumdbea(:,:,:) = 0.0E+00
        sum3a  (:,:,:) = 0.0E+00
      endif

!---------------------------------------------------------------------
!    frequency loop begins.
!--------------------------------------------------------------------
      do n=1,NBLW 
        cent = centnb(n)

!---------------------------------------------------------------------
!    perform calculations for frequency ranges of 0-560, 
!#ifndef ch4n2o
!    1200-2200 cm-1.
!#else   ch4n2o
!    1400-2200 cm-1.
!#endif  ch4n2o
!---------------------------------------------------------------------
        if (cent .LT. 5.6E+02 .OR. cent .GT. freq_cutoff .AND.    &
            cent .LE. 2.2E+03) then
          do jtab=1,NUTABH2O 
            x2  (jtab) = arotnb(n)*zroot(jtab) 
            expo(jtab) = EXP( - x2(jtab))
          enddo
          do jtab=122,NUTABH2O
            fac(jtab) = (1.0E+00 - (1.0E+00 + x2(jtab))*expo(jtab))/ &
                        (alfanb(n)*zmass(jtab))
          enddo
          do jtab=1,NUTABH2O 
            do itab=1,NTTABH2O
              sum   (itab,jtab) = sum   (itab,jtab) +   &
                                  src1nb(itab,n)*expo(jtab)
              sumdbe(itab,jtab) = sumdbe(itab,jtab) +    &
                                  dbdtnb(itab,n)*expo(jtab)
            enddo
          enddo 
          do jtab=122,NUTABH2O
            do itab=1,NTTABH2O 
              sum3(itab,jtab) = sum3(itab,jtab) +    &
                                dbdtnb(itab,n)*fac(jtab)
            enddo 
          enddo 
        endif

!-------------------------------------------------------------------
!    perform calculations over the frequency range 1200-1400 cm-1. 
!    the calculations depend on the value of NBTRGE.
!-------------------------------------------------------------------
        if (NBTRGE > 0) then 
          if (cent .GT. 1.2E+03 .AND. cent .LE. 1.4E+03) then
            do m=1,NBTRGE
              if (cent .GT. fbdlo_12001400(m) .AND.   &
                  cent .LE. fbdhi_12001400(m)) then
                x2  (:) = arotnb(n)*zroot(:) 
                expo(:) = EXP( - x2(:))
                do jtab=122,NUTABH2O
                  fac(jtab) = (1.0E+00 - (1.0E+00 + x2(jtab))*  &
                               expo(jtab))/(alfanb(n)*zmass(jtab))
                enddo
                do jtab=1,NUTABH2O 
                  suma(:,jtab,m)    = suma(:,jtab,m) +  &
                                      src1nb(:,n)*expo(jtab)
                  sumdbea(:,jtab,m) = sumdbea(:,jtab,m) +   &
                                      dbdtnb(:,n)*expo(jtab)
                enddo
                do jtab=122,NUTABH2O 
                  sum3a(:,jtab,m)   = sum3a(:,jtab,m) +   &
                                      dbdtnb(:,n)*fac(jtab)
                enddo
              endif
            enddo
          endif
        endif

!---------------------------------------------------------------------
!    compute sum over 160-560 cm-1 range for use in e1 calculations
!    sumwde.
!---------------------------------------------------------------------
        if (cent .GT. 1.6E+02 .AND. cent .LT. 5.6E+02) then 
          do jtab=1,NUTABH2O
            do itab=1,NTTABH2O 
              sumwde(itab,jtab) = sumwde(itab,jtab) +     &
                                  src1nb(itab,n)*expo(jtab)
            enddo
          enddo 
        endif 
      enddo

!--------------------------------------------------------------------
!    frequency loop ends
!--------------------------------------------------------------------
      do jtab=1,NUTABH2O
        do itab=1,NTTABH2O
          tab1%vae      (itab,jtab) = sum(itab,jtab)/tfour(itab)
          tab2%vae(itab,jtab) = sumdbe(itab,jtab)/fortcu(itab)
        enddo 
      enddo
      do jtab=122,NUTABH2O
        do itab=1,NTTABH2O
          tab3%vae(itab,jtab) = sum3(itab,jtab)/fortcu(itab)
        enddo
      enddo
      do jtab=1,3
        do itab=1,NTTABH2O
          tab1%vae      (itab,jtab) = r1(itab)
        enddo
      enddo
      do jtab=1,121
        do itab=1,NTTABH2O
          tab3%vae(itab,jtab) = r2(itab)/2.0E+00 -    &
                                s2(itab)*zroot(jtab)/3.0E+00 +   &
                                t3(itab)*zmass(jtab)/8.0E+00
        enddo
      enddo

!---------------------------------------------------------------------
!    compute e1 tables for 160-560 cm-1 bands.
!---------------------------------------------------------------------
      do jtab=1,NUTABH2O
        do itab=1,NTTABH2O
          tab1w%vae      (itab,jtab) = sumwde(itab,jtab)/tfour(itab)
        enddo
      enddo
      do jtab=1,3
        do itab=1,NTTABH2O
          tab1w%vae      (itab,jtab) = r1wd(itab)
        enddo 
      enddo

!---------------------------------------------------------------------
!    initialize all derivative table entries.
!---------------------------------------------------------------------
      do jtab=1,NUTABH2O
        do itab=1,NTTABH2O
          tab1%td (itab,jtab) = 0.0E+00
          tab1w%td(itab,jtab) = 0.0E+00
          tab2%td  (itab,jtab) = 0.0E+00
          tab3%td (itab,jtab) = 0.0E+00
          tab1%md (itab,jtab) = 0.0E+00
          tab1w%md(itab,jtab) = 0.0E+00
          tab2%md  (itab,jtab) = 0.0E+00
          tab3%md (itab,jtab) = 0.0E+00
          tab1%cd (itab,jtab) = 0.0E+00
          tab1w%cd(itab,jtab) = 0.0E+00
          tab2%cd  (itab,jtab) = 0.0E+00
          tab3%cd (itab,jtab) = 0.0E+00
        enddo
      enddo

!---------------------------------------------------------------------
!    compute table entries for temperature derivatives.
!---------------------------------------------------------------------
      do jtab=1,NUTABH2O
        do itab=1,NTTABH2O-1
          tab1%td  (itab,jtab) =    &
          (tab1%vae(itab+1,jtab) - tab1%vae (itab,jtab))/temp_1%tab_inc

          tab1w%td(itab,jtab) =     &
         (tab1w%vae(itab+1,jtab) - tab1w%vae(itab,jtab))/temp_1%tab_inc

          tab2%td  (itab,jtab) =    &
       (tab2%vae  (itab+1,jtab) - tab2%vae  (itab,jtab))/temp_1%tab_inc

          tab3%td (itab,jtab) =     &
         (tab3%vae (itab+1,jtab) - tab3%vae (itab,jtab))/temp_1%tab_inc

        enddo
      enddo

!---------------------------------------------------------------------
!    compute table entries for mass derivatives.
!---------------------------------------------------------------------
      do jtab=2,NUTABH2O-1
        do itab=1,NTTABH2O
          tab1%md (itab,jtab) =   &
     (tab1%vae (itab,jtab+1) - tab1%vae (itab,jtab))/mass_1%tab_inc

          tab1w%md(itab,jtab) =   &
    (tab1w%vae(itab,jtab+1) - tab1w%vae(itab,jtab))/mass_1%tab_inc

          tab2%md  (itab,jtab) =    &
   (tab2%vae  (itab,jtab+1) - tab2%vae  (itab,jtab))/mass_1%tab_inc

          tab3%md (itab,jtab) =    &
   (tab3%vae (itab,jtab+1) - tab3%vae (itab,jtab))/mass_1%tab_inc

        enddo
      enddo

!---------------------------------------------------------------------
!    compute table entries for cross derivatives.
!---------------------------------------------------------------------
      do jtab=2,NUTABH2O-1
        do itab=1,NTTABH2O-1
      tab1%cd (itab,jtab) =    &
             (tab1%vae (itab+1,jtab+1) - tab1%vae (itab+1,jtab) -   &
              tab1%vae (itab  ,jtab+1) + tab1%vae (itab  ,jtab))/   &
             (temp_1%tab_inc*mass_1%tab_inc)

      tab1w%cd(itab,jtab) =    &
             (tab1w%vae(itab+1,jtab+1) - tab1w%vae(itab+1,jtab) -   &
              tab1w%vae(itab  ,jtab+1) + tab1w%vae(itab  ,jtab))/   &
             (temp_1%tab_inc*mass_1%tab_inc)


!!  THIS NEVER USED :
!     tab2%cd  (itab,jtab) =     &
!            (tab2%vae  (itab+1,jtab+1) - tab2%vae  (itab+1,jtab) -   &
!             tab2%vae  (itab  ,jtab+1) + tab2%vae  (itab  ,jtab))/   &
!            (DTTABH2O*DUTABH2O)
!            (temp_1%tab_inc*mass_1%tab_inc)


      tab3%cd (itab,jtab) =     &
             (tab3%vae (itab+1,jtab+1) - tab3%vae (itab+1,jtab) -   &
              tab3%vae (itab  ,jtab+1) + tab3%vae (itab  ,jtab))/   &
             (temp_1%tab_inc*mass_1%tab_inc)

        enddo
      enddo
      if (NBTRGE > 0) then
        do m=1,NBTRGE
          do jtab=1,NUTABH2O
            tab1a%vae      (:,jtab,m) = suma(:,jtab,m)/tfour(:)
            tab2a%vae (:,jtab,m) = sumdbea(:,jtab,m)/fortcu(:) 
          enddo
          do jtab=122,NUTABH2O
            tab3a%vae(:,jtab,m) = sum3a(:,jtab,m)/fortcu(:)
          enddo
          do jtab=1,3
            tab1a%vae      (:,jtab,m) = r1a(:,m)
          enddo
          do jtab=1,121
            tab3a%vae(:,jtab,m) = r2a(:,m)/2.0E+00 -     &
                                  s2a(:,m)*zroot(jtab)/3.0E+00 +   &
                                  t3a(:,m)*zmass(jtab)/8.0E+00
          enddo
        enddo

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
        tab1a%td (1:NTTABH2O,1:NUTABH2O,:) = 0.0E+00
        tab2a%td  (1:NTTABH2O,1:NUTABH2O,:) = 0.0E+00
        tab3a%td (1:NTTABH2O,1:NUTABH2O,:) = 0.0E+00
        tab1a%md (1:NTTABH2O,1:NUTABH2O,:) = 0.0E+00
        tab2a%md  (1:NTTABH2O,1:NUTABH2O,:) = 0.0E+00
        tab3a%md (1:NTTABH2O,1:NUTABH2O,:) = 0.0E+00
        tab1a%cd (1:NTTABH2O,1:NUTABH2O,:) = 0.0E+00
        tab2a%cd (1:NTTABH2O,1:NUTABH2O,:) = 0.0E+00
        tab3a%cd (1:NTTABH2O,1:NUTABH2O,:) = 0.0E+00

        tab1a%td(1:NTTABH2O-1,1:NUTABH2O,:) =    &
                 (tab1a%vae(2:NTTABH2O,1:NUTABH2O,:) -   &
                  tab1a%vae(1:NTTABH2O-1,1:NUTABH2O,:))/temp_1%tab_inc

        tab2a%td (1:NTTABH2O-1,1:NUTABH2O,:) =   &
                (tab2a%vae (2:NTTABH2O,1:NUTABH2O,:) -    &
                 tab2a%vae (1:NTTABH2O-1,1:NUTABH2O,:))/temp_1%tab_inc

        tab3a%td(1:NTTABH2O-1,1:NUTABH2O,:) =    &
                  (tab3a%vae(2:NTTABH2O,1:NUTABH2O,:) -  &
                   tab3a%vae(1:NTTABH2O-1,1:NUTABH2O,:))/temp_1%tab_inc

        tab1a%md(1:NTTABH2O,2:NUTABH2O-1,:) =     &
                  (tab1a%vae(1:NTTABH2O,3:NUTABH2O,:) -   &
                   tab1a%vae(1:NTTABH2O,2:NUTABH2O-1,:))/mass_1%tab_inc

        tab2a%md (1:NTTABH2O,2:NUTABH2O-1,:) =   &
                 (tab2a%vae (1:NTTABH2O,3:NUTABH2O,:) -   &
                  tab2a%vae (1:NTTABH2O,2:NUTABH2O-1,:))/mass_1%tab_inc

        tab3a%md(1:NTTABH2O,2:NUTABH2O-1,:) =     &
                  (tab3a%vae(1:NTTABH2O,3:NUTABH2O,:) -   &
                   tab3a%vae(1:NTTABH2O,2:NUTABH2O-1,:))/mass_1%tab_inc

        tab1a%cd(1:NTTABH2O-1,2:NUTABH2O-1,:) =     &
                        (tab1a%vae(2:NTTABH2O,3:NUTABH2O,:) -    &
                         tab1a%vae(2:NTTABH2O,2:NUTABH2O-1,:)   -  &
                         tab1a%vae(1:NTTABH2O-1,3:NUTABH2O,:)   +  &
                         tab1a%vae(1:NTTABH2O-1,2:NUTABH2O-1,:))/  &
                                         (temp_1%tab_inc*mass_1%tab_inc)

        tab3a%cd(1:NTTABH2O-1,2:NUTABH2O-1,:) =    &
                        (tab3a%vae(2:NTTABH2O,3:NUTABH2O,:) -    &
                         tab3a%vae(2:NTTABH2O,2:NUTABH2O-1,:)   -  &
                         tab3a%vae(1:NTTABH2O-1,3:NUTABH2O,:)   +  &
                         tab3a%vae(1:NTTABH2O-1,2:NUTABH2O-1,:))/  &
                                        (temp_1%tab_inc*mass_1%tab_inc)
     
!---------------------------------------------------------------------
!    deallocate local arrays.
!---------------------------------------------------------------------
        deallocate ( r1a    )
        deallocate (r2a     )
        deallocate (s2a     )
        deallocate ( t3a     )
        deallocate ( suma    )
        deallocate ( sumdbea )
        deallocate ( sum3a   )
        deallocate ( sum4a   )
        deallocate ( sum6a   )
        deallocate ( sum7a   )
        deallocate (sum8a  )
      endif

!-------------------------------------------------------------------


end subroutine table



!####################################################################


                  end module longwave_tables_mod

! ============================================================================
! lake model module
! ============================================================================
module lake_mod

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only : error_mesg, file_exist, read_data, check_nml_error, &
     stdlog, write_version_number, close_file, mpp_pe, mpp_root_pe, FATAL, NOTE
use time_manager_mod,   only: time_type, increment_time, time_type_to_real
use diag_manager_mod,   only: diag_axis_init, register_diag_field,           &
                              register_static_field, send_data
use constants_mod,      only: tfreeze, hlv, hlf, dens_h2o, PI, grav, vonkarm, &
                              rdgas

use land_constants_mod, only : &
     NBANDS
use land_io_mod, only : read_field
use lake_tile_mod, only : &
     lake_tile_type, lake_pars_type, lake_prog_type, read_lake_data_namelist, &
     lake_data_radiation, lake_data_diffusion, &
     lake_data_thermodynamics, &
     max_lev, cpw,clw,csw, lake_width_inside_lake, large_lake_sill_width, &
     lake_specific_width, n_outlet, outlet_face, outlet_i, outlet_j, outlet_width
use land_tile_mod, only : land_tile_type, land_tile_enum_type, &
     first_elmt, tail_elmt, next_elmt, current_tile, operator(/=)
use land_tile_diag_mod, only : register_tiled_static_field, &
     register_tiled_diag_field, send_tile_data, diag_buff_type, &
     send_tile_data_r0d_fptr, add_tiled_static_field_alias
use land_data_mod,      only : land_state_type, lnd
use land_tile_io_mod, only : print_netcdf_error, create_tile_out_file, &
     read_tile_data_r1d_fptr, write_tile_data_r1d_fptr, sync_nc_files, &
     get_input_restart_name
use nf_utils_mod, only : nfu_inq_var, nfu_def_dim, nfu_put_att
use land_debug_mod, only: is_watch_point
use land_utils_mod, only : put_to_tiles_r0d_fptr

implicit none
private

! ==== public interfaces =====================================================
public :: read_lake_namelist
public :: lake_init
public :: lake_end
public :: save_lake_restart

public :: lake_get_sfc_temp
public :: lake_radiation
public :: lake_diffusion
public :: lake_step_1
public :: lake_step_2

public :: large_dyn_small_stat
! =====end of public interfaces ==============================================


! ==== module constants ======================================================
character(len=*), parameter, private   :: &
    module_name = 'lake',&
    version     = '$Id: lake.F90,v 20.0 2013/12/13 23:29:37 fms Exp $',&
    tagname     = '$Name: tikal $'

! ==== module variables ======================================================

!---- namelist ---------------------------------------------------------------
real    :: init_temp            = 288.        ! cold-start lake T
real    :: init_w               = 1000.      ! cold-start w(l)/dz(l)
real    :: init_groundwater     =   0.        ! cold-start gw storage
logical :: use_rh_feedback      = .true.
logical :: make_all_lakes_wide  = .false.
logical :: large_dyn_small_stat = .true.
logical :: relayer_in_step_one  = .false.
logical :: float_ice_to_top     = .false.
logical :: wind_penetrates_ice  = .false.
real    :: min_rat              = 0.4
logical :: do_stratify          = .true.
character(len=16):: albedo_to_use = ''  ! or 'brdf-params'
real    :: K_z_large            = 1.
real    :: K_z_background       = 0.
real    :: K_z_min              = 0.
real    :: K_z_factor           = 1.
real    :: c_drag               = 1.2e-3
real    :: lake_depth_max       = 1.e10
real    :: lake_depth_min       = 1.99
real    :: max_plain_slope      = -1.e10

namelist /lake_nml/ init_temp, init_w,       &
                    init_groundwater, use_rh_feedback, cpw, clw, csw, &
                    make_all_lakes_wide, large_dyn_small_stat, &
                    relayer_in_step_one, float_ice_to_top, &
                    min_rat, do_stratify, albedo_to_use, K_z_large, &
		    K_z_background, K_z_min, K_z_factor, &
		    lake_depth_max, lake_depth_min, max_plain_slope
!---- end of namelist --------------------------------------------------------
real    :: K_z_molec            = 1.4e-7
real    :: tc_molec             = 0.59052 ! dens_h2o*clw*K_z_molec
real    :: tc_molec_ice         = 2.5

logical         :: module_is_initialized =.FALSE.
logical         :: use_brdf
type(time_type) :: time
real            :: delta_time

integer         :: num_l              ! # of water layers
real, allocatable:: zfull (:)    ! diag axis, dimensionless layer number
real, allocatable:: zhalf (:)
real            :: max_rat

! ---- diagnostic field IDs
integer :: id_lwc, id_swc, id_temp, id_ie, id_sn, id_bf, id_hie, id_hsn, id_hbf
integer :: id_evap, id_dz, id_wl, id_ws, id_K_z, id_silld, id_sillw, id_backw
integer :: id_back1
! ==== end of module variables ===============================================

! ==== NetCDF declarations ===================================================
include 'netcdf.inc'
#define __NF_ASRT__(x) call print_netcdf_error((x),module_name,__LINE__)

contains

! ============================================================================
subroutine read_lake_namelist()
  ! ---- local vars
  integer :: unit         ! unit for namelist i/o
  integer :: io           ! i/o status for the namelist
  integer :: ierr         ! error code, returned by i/o routines
  integer :: l

  call read_lake_data_namelist(num_l)

  call write_version_number(version, tagname)
#ifdef INTERNAL_FILE_NML
     read (input_nml_file, nml=lake_nml, iostat=io)
     ierr = check_nml_error(io, 'lake_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file()
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=lake_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'lake_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif
  if (mpp_pe() == mpp_root_pe()) then
     unit=stdlog()
     write(unit, nml=lake_nml)
  endif

  ! ---- set up vertical discretization
  allocate (zhalf(num_l+1), zfull(num_l))
  zhalf(1) = 0
  do l = 1, num_l;   
     zhalf(l+1) = zhalf(l) + 1.
     zfull(l) = 0.5*(zhalf(l+1) + zhalf(l))
  enddo
  
  max_rat = 1. / min_rat
  if (trim(albedo_to_use)=='brdf-params') then
     use_brdf = .true.
  else if (trim(albedo_to_use)=='') then
     use_brdf = .false.
  else
     call error_mesg('lake_init',&
          'option albedo_to_use="'// trim(albedo_to_use)//&
          '" is invalid, use "brdf-params", or nothing ("")',&
          FATAL)
  endif

end subroutine read_lake_namelist


! ============================================================================
! initialize lake model
subroutine lake_init ( id_lon, id_lat )
  integer, intent(in) :: id_lon  ! ID of land longitude (X) axis  
  integer, intent(in) :: id_lat  ! ID of land latitude (Y) axis

  ! ---- local vars 
  integer :: unit         ! unit for various i/o
  type(land_tile_enum_type)     :: te,ce ! last and current tile list elements
  type(land_tile_type), pointer :: tile  ! pointer to current tile
  character(len=256) :: restart_file_name
  logical :: restart_exists
  real, allocatable :: buffer(:,:),bufferc(:,:),buffert(:,:)
  integer i

  module_is_initialized = .TRUE.
  time       = lnd%time
  delta_time = time_type_to_real(lnd%dt_fast)

allocate(buffer (lnd%is:lnd%ie,lnd%js:lnd%je))
allocate(bufferc(lnd%is:lnd%ie,lnd%js:lnd%je))
allocate(buffert(lnd%is:lnd%ie,lnd%js:lnd%je))

IF (LARGE_DYN_SMALL_STAT) THEN

call read_data('INPUT/river_data.nc', 'connected_to_next', bufferc(:,:), lnd%domain)
call put_to_tiles_r0d_fptr(bufferc, lnd%tile_map, lake_connected_to_next_ptr)

call read_data('INPUT/river_data.nc', 'whole_lake_area', buffer(:,:), lnd%domain)
call put_to_tiles_r0d_fptr(buffer, lnd%tile_map, lake_whole_area_ptr)

call read_data('INPUT/river_data.nc', 'lake_depth_sill', buffer(:,:),  lnd%domain)
buffer = min(buffer, lake_depth_max)
buffer = max(buffer, lake_depth_min)
call put_to_tiles_r0d_fptr(buffer,  lnd%tile_map, lake_depth_sill_ptr)

! lake_tau is just used here as a flag for 'large lakes'
! sill width of -1 is a flag saying not to allow transient storage
call read_data('INPUT/river_data.nc', 'lake_tau', buffert(:,:),  lnd%domain)
buffer = -1.
!where (bufferc.gt.0.5) buffer = lake_width_inside_lake
where (bufferc.lt.0.5 .and. buffert.gt.1.) buffer = large_lake_sill_width
if (lake_specific_width) then
    do i = 1, n_outlet
      if(lnd%face.eq.outlet_face(i).and.lnd%is.le.outlet_i(i).and.lnd%ie.ge.outlet_i(i) &
                                 .and.lnd%js.le.outlet_j(i).and.lnd%je.ge.outlet_j(i)) &
        buffer(outlet_i(i),outlet_j(i)) = outlet_width(i)
      enddo
endif
call put_to_tiles_r0d_fptr(buffer, lnd%tile_map, lake_width_sill_ptr)

buffer = 1.e8
if (max_plain_slope.gt.0.) &
   call read_data('INPUT/river_data.nc', 'max_slope_to_next', buffer(:,:), lnd%domain)
call read_data('INPUT/river_data.nc', 'travel', buffert(:,:), lnd%domain)
bufferc = 0.
where (buffer.lt.max_plain_slope .and. buffert.gt.1.5) bufferc = 1.
call put_to_tiles_r0d_fptr(bufferc, lnd%tile_map, lake_backwater_ptr)
bufferc = 0
where (buffer.lt.max_plain_slope .and. buffert.lt.1.5) bufferc = 1.
call put_to_tiles_r0d_fptr(bufferc, lnd%tile_map, lake_backwater_1_ptr)

ELSE
call read_data('INPUT/river_data.nc', 'whole_lake_area', bufferc(:,:), lnd%domain)

call read_data('INPUT/river_data.nc', 'lake_depth_sill', buffer(:,:), lnd%domain)
where (bufferc.eq.0.)                      buffer = 0.
where (bufferc.gt.0..and.bufferc.lt.2.e10) buffer = max(2., 2.5e-4*sqrt(bufferc))
call put_to_tiles_r0d_fptr(buffer,  lnd%tile_map, lake_depth_sill_ptr)
call put_to_tiles_r0d_fptr(bufferc, lnd%tile_map, lake_whole_area_ptr)

buffer = 4. * buffer
where (bufferc.gt.2.e10) buffer = min(buffer, 60.)
call read_data('INPUT/river_data.nc', 'connected_to_next', bufferc(:,:), lnd%domain)
call put_to_tiles_r0d_fptr(bufferc, lnd%tile_map, lake_connected_to_next_ptr)

where (bufferc.gt.0.5) buffer=lake_width_inside_lake
if (make_all_lakes_wide) buffer = lake_width_inside_lake
call put_to_tiles_r0d_fptr(buffer, lnd%tile_map, lake_width_sill_ptr)
ENDIF

deallocate (buffer, bufferc, buffert)

  ! -------- initialize lake state --------
  te = tail_elmt (lnd%tile_map)
  ce = first_elmt(lnd%tile_map)
  do while(ce /= te)
     tile=>current_tile(ce)  ! get pointer to current tile
     ce=next_elmt(ce)        ! advance position to the next tile
     
     if (.not.associated(tile%lake)) cycle
     
     tile%lake%prog%dz = tile%lake%pars%depth_sill/num_l
     if (init_temp.ge.tfreeze) then
        tile%lake%prog%wl = init_w*tile%lake%prog%dz
        tile%lake%prog%ws = 0
     else
        tile%lake%prog%wl = 0
        tile%lake%prog%ws = init_w*tile%lake%prog%dz
     endif
     tile%lake%prog%T             = init_temp
     tile%lake%prog%groundwater   = init_groundwater
     tile%lake%prog%groundwater_T = init_temp
  enddo

  call get_input_restart_name('INPUT/lake.res.nc',restart_exists,restart_file_name)
  if (restart_exists) then
     call error_mesg('lake_init',&
          'reading NetCDF restart "'//trim(restart_file_name)//'"',&
          NOTE)
     __NF_ASRT__(nf_open(restart_file_name,NF_NOWRITE,unit))
     if(nfu_inq_var(unit, 'dz')==NF_NOERR) &
          call read_tile_data_r1d_fptr(unit, 'dz', lake_dz_ptr  )
     call read_tile_data_r1d_fptr(unit, 'temp'         , lake_temp_ptr  )
     call read_tile_data_r1d_fptr(unit, 'wl'           , lake_wl_ptr )
     call read_tile_data_r1d_fptr(unit, 'ws'           , lake_ws_ptr )
     call read_tile_data_r1d_fptr(unit, 'groundwater'  , lake_gw_ptr )
     call read_tile_data_r1d_fptr(unit, 'groundwater_T', lake_gwT_ptr)
     __NF_ASRT__(nf_close(unit))     
  else
     call error_mesg('lake_init',&
          'cold-starting lake',&
          NOTE)
  endif

  call lake_diag_init ( id_lon, id_lat )
  ! ---- static diagnostic section
  call send_tile_data_r0d_fptr(id_sillw, lnd%tile_map, lake_width_sill_ptr)
  call send_tile_data_r0d_fptr(id_silld, lnd%tile_map, lake_depth_sill_ptr)
  call send_tile_data_r0d_fptr(id_backw, lnd%tile_map, lake_backwater_ptr)
  call send_tile_data_r0d_fptr(id_back1, lnd%tile_map, lake_backwater_1_ptr)
end subroutine lake_init


! ============================================================================
subroutine lake_end ()

  deallocate (zfull, zhalf)
  module_is_initialized =.FALSE.

end subroutine lake_end


! ============================================================================
subroutine save_lake_restart (tile_dim_length, timestamp)
  integer, intent(in) :: tile_dim_length ! length of tile dim. in the output file
  character(*), intent(in) :: timestamp ! timestamp to add to the file name

  ! ---- local vars ----------------------------------------------------------
  integer :: unit            ! restart file i/o unit

  call error_mesg('lake_end','writing NetCDF restart',NOTE)
  call create_tile_out_file(unit,'RESTART/'//trim(timestamp)//'lake.res.nc', &
          lnd%coord_glon, lnd%coord_glat, lake_tile_exists, tile_dim_length)

  ! in addition, define vertical coordinate
  if (mpp_pe()==lnd%io_pelist(1)) then
     __NF_ASRT__(nfu_def_dim(unit,'zfull',zfull(1:num_l),'full level','m'))
     __NF_ASRT__(nfu_put_att(unit,'zfull','positive','down'))
  endif
  call sync_nc_files(unit)
  
  ! write out fields
  call write_tile_data_r1d_fptr(unit,'dz'           ,lake_dz_ptr,  'zfull','layer thickness','m')
  call write_tile_data_r1d_fptr(unit,'temp'         ,lake_temp_ptr,'zfull','lake temperature','degrees_K')
  call write_tile_data_r1d_fptr(unit,'wl'           ,lake_wl_ptr  ,'zfull','liquid water content','kg/m2')
  call write_tile_data_r1d_fptr(unit,'ws'           ,lake_ws_ptr  ,'zfull','solid water content','kg/m2')
  call write_tile_data_r1d_fptr(unit,'groundwater'  ,lake_gw_ptr  ,'zfull')
  call write_tile_data_r1d_fptr(unit,'groundwater_T',lake_gwT_ptr ,'zfull')
  
  ! close file
  __NF_ASRT__(nf_close(unit))

end subroutine save_lake_restart


! ============================================================================
subroutine lake_get_sfc_temp(lake, lake_T)
  type(lake_tile_type), intent(in) :: lake
  real, intent(out) :: lake_T

  lake_T = lake%prog(1)%T
end subroutine lake_get_sfc_temp


! ============================================================================
! compute lake-only radiation properties
subroutine lake_radiation ( lake, cosz, &
     lake_refl_dir, lake_refl_dif, lake_refl_lw, lake_emis )
  type(lake_tile_type), intent(in) :: lake
  real, intent(in) :: cosz
  real, intent(out) :: lake_refl_dir(NBANDS), lake_refl_dif(NBANDS), lake_refl_lw, lake_emis

  call lake_data_radiation ( lake, cosz, use_brdf, lake_refl_dir, lake_refl_dif, lake_emis )
  lake_refl_lw = 1 - lake_emis
end subroutine lake_radiation


! ============================================================================
! compute lake-only roughness parameters
subroutine lake_diffusion ( lake, lake_z0s, lake_z0m )
  type(lake_tile_type), intent(in) :: lake
  real, intent(out) :: lake_z0s, lake_z0m

  call lake_data_diffusion ( lake, lake_z0s, lake_z0m )
end subroutine lake_diffusion

! ============================================================================
! update lake properties explicitly for time step.
! integrate lake-heat conduction equation upward from bottom of lake
! to surface, delivering linearization of surface ground heat flux.
subroutine lake_step_1 ( u_star_a, p_surf, latitude, lake, &
                         lake_T, &
                         lake_rh, lake_liq, lake_ice, lake_subl, lake_tf, lake_G0, &
                         lake_DGDT )

  real, intent(in)   :: u_star_a, p_surf, latitude
  type(lake_tile_type), intent(inout) :: lake
  real, intent(out)  :: &
       lake_T, &
       lake_rh, lake_liq, lake_ice, lake_subl, &
       lake_tf, & ! freezing temperature of lake, degK
       lake_G0, &
       lake_DGDT

  ! ---- local vars
  real                  :: bbb, denom, dt_e, tc_dz_eff
  real                  :: z_cum, z_mid, dz_mid, rho_t_mid, k_neutral
  real, dimension(num_l):: aaa, ccc, thermal_cond, heat_capacity, dz_alt, &
                            z_alt, rho_t
  integer               :: l
  real                  :: k_star, N_sq, Ri, u_star, z_liq, z_ice, rho_a
  real                  :: lake_depth, lshc1, lshc2
! ----------------------------------------------------------------------------
! in preparation for implicit energy balance, determine various measures
! of water availability, so that vapor fluxes will not exceed mass limits
! ----------------------------------------------------------------------------

  if(is_watch_point()) then
     write(*,*) 'lake_step_1 checkpoint 1'
     write(*,*) 'mask    ', .true.   
     write(*,*) 'T       ', lake_T
     write(*,*) 'rh      ', lake_rh
     write(*,*) 'liq     ', lake_liq
     write(*,*) 'ice     ', lake_ice
     write(*,*) 'subl    ', lake_subl
     write(*,*) 'G0      ', lake_G0
     write(*,*) 'DGDT    ', lake_DGDT
    do l = 1, num_l
      write(*,'(a,i2.2,100(2x,a,g23.16))') ' level=', l,&
                 ' dz=', lake%prog(l)%dz,&
                 ' T =', lake%prog(l)%T,&
                 ' wl=', lake%prog(l)%wl,&
                 ' ws=', lake%prog(l)%ws, &
                 'K_z=', lake%prog(l)%K_z
      enddo
  endif


  if (relayer_in_step_one) call lake_relayer ( lake )

  lake%prog%K_z = 0.
  lake_T = lake%prog(1)%T
  if (use_rh_feedback) then
      lake_depth = (sum(lake%prog(:)%wl)+sum(lake%prog(:)%ws)) / DENS_H2O
    else
      lake_depth = lake%pars%depth_sill
    endif
  call lake_data_thermodynamics ( lake%pars, lake_depth, lake_rh, &
                                  lake%heat_capacity_dry, thermal_cond )
! Ignore air humidity in converting atmospheric friction velocity to lake value
  rho_a = p_surf/(rdgas*lake_T)
! No momentum transfer through ice cover
  if (lake%prog(1)%ws.le.0. .or. wind_penetrates_ice) then
      u_star = u_star_a*sqrt(rho_a/dens_h2o)
      k_star = 2.79e-5*sqrt(sin(abs(latitude)))*u_star**(-1.84)
      k_star = k_star*(c_drag/1.2e-3)**1.84
    else
      u_star = 0.
      k_star = 1.
    endif
! k_star from B. Henderson-Sellers (1985, Appl. Math. Mod., 9)
!  k_star = 2.79e-5*sqrt(sin(abs(latitude)))*u_star**(-1.84)
  z_cum = 0.
  do l = 1, num_l
    heat_capacity(l) = lake%heat_capacity_dry(l) * lake%prog(l)%dz &
            + clw*lake%prog(l)%wl + csw*lake%prog(l)%ws
    dz_alt(l) = (lake%prog(l)%wl + lake%prog(l)%ws)/dens_h2o
    z_alt(l) = z_cum + 0.5*dz_alt(l)
    z_cum = z_cum + dz_alt(l)
! rho_t from hostetler and bartlein (1990), citing Heggen (1983)
! is a call available in fms?
    rho_t(l) = 1. - 1.9549e-5*abs(lake%prog(l)%T-277.)**1.68
    enddo

  lake_liq  = max(lake%prog(1)%wl, 0.)
  lake_ice  = max(lake%prog(1)%ws, 0.)
  if (lake_ice > 0) then
     lake_subl = 1
  else
     lake_subl = 0
  endif

  if(num_l > 1) then
    if (do_stratify) then
        do l = 1, num_l-1
          if (lake%prog(l)%ws.le.0..and.lake%prog(l+1)%ws.le.0.) then
              dz_mid = z_alt(l+1)-z_alt(l)
              z_mid = 0.5 * (z_alt(l)+z_alt(l+1))
              rho_t_mid = 0.5*(rho_t(l)+rho_t(l+1))
              if (k_star*z_mid .lt. 10.) then
                  k_neutral = vonkarm * u_star * z_mid * exp (-k_star * z_mid)
                else
                  k_neutral = 0.
                endif
              N_sq = (grav / rho_t_mid) * (rho_t(l+1)-rho_t(l)) /dz_mid
              if (N_sq .gt. 0. .and. k_neutral.ne.0.) then
                  ! stability function from B. Henderson-Sellers (1985)
                  Ri = 0.05*(-1. + sqrt(1.+40.*N_sq*(vonkarm*z_mid/u_star)**2 &
                                                   *exp(2.*k_star*z_mid)))
                  lake%prog(l)%K_z = k_neutral / (1. + 37.*Ri*Ri) + K_z_molec
                else if (k_neutral.eq.0.) then
                  lake%prog(l)%K_z = K_z_molec
                else  ! arbitrary constant for unstable mixing
                  lake%prog(l)%K_z = K_z_large
                endif
	      if (lake%pars%depth_sill.gt.2.01) &
	          lake%prog(l)%K_z = K_z_factor &
		   * max(lake%prog(l)%K_z + K_z_background, K_z_min)
              aaa(l+1) = - lake%prog(l)%K_z * delta_time / (dz_alt(l+1)*dz_mid)
              ccc(l)   = - lake%prog(l)%K_z * delta_time / (dz_alt(l  )*dz_mid)
            else
              z_liq = 0.5*(lake%prog(l)%wl+lake%prog(l+1)%wl)/dens_h2o
              z_ice = 0.5*(lake%prog(l)%ws+lake%prog(l+1)%ws)/dens_h2o
              tc_dz_eff = 1. / (z_liq/tc_molec + z_ice/tc_molec_ice)
              aaa(l+1) = - tc_dz_eff * delta_time / heat_capacity(l+1)
              ccc(l)   = - tc_dz_eff * delta_time / heat_capacity(l)
            endif
          enddo
      else
        do l = 1, num_l-1
          tc_dz_eff = 2 / ( dz_alt(l+1)/thermal_cond(l+1) &
             + dz_alt(l)/thermal_cond(l)   )
          aaa(l+1) = - tc_dz_eff * delta_time / heat_capacity(l+1)
          ccc(l)   = - tc_dz_eff * delta_time / heat_capacity(l)
          enddo
      endif

     bbb = 1.0 - aaa(num_l)
     denom = bbb
     dt_e = aaa(num_l)*(lake%prog(num_l)%T - lake%prog(num_l-1)%T) &
               + lake%geothermal_heat_flux * delta_time / heat_capacity(num_l)
     lake%e(num_l-1) = -aaa(num_l)/denom
     lake%f(num_l-1) = dt_e/denom
     do l = num_l-1, 2, -1
        bbb = 1.0 - aaa(l) - ccc(l)
        denom = bbb + ccc(l)*lake%e(l)
        dt_e = - ( ccc(l)*(lake%prog(l+1)%T - lake%prog(l)%T  ) &
                  -aaa(l)*(lake%prog(l)%T   - lake%prog(l-1)%T) )
        lake%e(l-1) = -aaa(l)/denom
        lake%f(l-1) = (dt_e - ccc(l)*lake%f(l))/denom
     end do
     denom = delta_time/(heat_capacity(1) )
     lake_G0    = ccc(1)*(lake%prog(2)%T- lake%prog(1)%T &
          + lake%f(1)) / denom
     lake_DGDT  = (1 - ccc(1)*(1-lake%e(1))) / denom   
  else  ! one-level case
     denom = delta_time/heat_capacity(1)
     lake_G0    = 0.
     lake_DGDT  = 1. / denom
  end if
  
  ! set the freezing temperature of the lake
  lake_tf = tfreeze
  
  if(is_watch_point()) then
     write(*,*) 'lake_step_1 checkpoint 2'
     write(*,*) 'mask    ', .true.   
     write(*,*) 'T       ', lake_T
     write(*,*) 'rh      ', lake_rh
     write(*,*) 'liq     ', lake_liq
     write(*,*) 'ice     ', lake_ice
     write(*,*) 'subl    ', lake_subl
     write(*,*) 'G0      ', lake_G0
     write(*,*) 'DGDT    ', lake_DGDT
    do l = 1, num_l
      write(*,'(a,i2.2,100(2x,a,g23.16))') ' level=', l,&
                 ' dz=', lake%prog(l)%dz,&
                 ' T =', lake%prog(l)%T,&
                 ' wl=', lake%prog(l)%wl,&
                 ' ws=', lake%prog(l)%ws, &
                 'K_z=', lake%prog(l)%K_z
      enddo
  endif

end subroutine lake_step_1


! ============================================================================
! apply boundary flows to lake water and move lake water vertically.
  subroutine lake_step_2 ( lake, diag, lake_subl, snow_lprec, snow_hlprec,  &
                           subs_DT, subs_M_imp, subs_evap, &
                           use_tfreeze_in_grnd_latent, &
                           lake_levap, lake_fevap, lake_melt, &
                           lake_Ttop, lake_Ctop )
  type(lake_tile_type), intent(inout) :: lake
  type(diag_buff_type), intent(inout) :: diag
  real, intent(in) :: &
     lake_subl     !
  real, intent(in) :: &
     snow_lprec, &
     snow_hlprec, &
     subs_DT,       &!
     subs_M_imp,       &! rate of phase change of non-evaporated lake water
     subs_evap
  logical, intent(in) :: use_tfreeze_in_grnd_latent
  real, intent(out) :: &
     lake_levap, lake_fevap, lake_melt, &
     lake_Ttop, lake_Ctop

  ! ---- local vars
  real, dimension(num_l) :: del_t, eee, fff, &
             psi, DThDP, hyd_cond, DKDP, K, DKDPm, DKDPp, grad, &
             dW_l, u_minus, u_plus, DPsi, lake_w_fc
  real, dimension(num_l+1) :: flow
  real, dimension(num_l  ) :: div
  real :: ice_to_move, h_upper, h_lower, h_to_move_up, &
     lprec_eff, hlprec_eff, hcap, dheat, &
     melt_per_deg, melt, lshc1, lshc2
  real, dimension(num_l-1) :: del_z
  real :: jj
  integer :: l

  jj = 1.
  
  if(is_watch_point()) then
    write(*,*) ' ***** lake_step_2 checkpoint 1 ***** '
    write(*,*) 'mask    ', .true.   
    write(*,*) 'subs_evap    ', subs_evap   
    write(*,*) 'snow_lprec   ', snow_lprec  
    write(*,*) 'subs_M_imp   ', subs_M_imp   
    write(*,*) 'theta_s ', lake%pars%w_sat
    do l = 1, num_l
      write(*,'(a,i2.2,100(2x,a,g23.16))') ' level=', l,&
                 ' dz=', lake%prog(l)%dz,&
                 ' T =', lake%prog(l)%T,&
                 ' Th=', (lake%prog(l)%ws &
                         +lake%prog(l)%wl)/(dens_h2o*lake%prog(l)%dz),&
                 ' wl=', lake%prog(l)%wl,&
                 ' ws=', lake%prog(l)%ws,&
                 ' gw=', lake%prog(l)%groundwater
      enddo
  endif

  ! ---- record fluxes ---------
  lake_levap  = subs_evap*(1-lake_subl)
  lake_fevap  = subs_evap*   lake_subl
  lake_melt   = subs_M_imp / delta_time

  ! ---- load surface temp change and perform back substitution --------------
  del_t(1) = subs_DT
  lake%prog(1)%T = lake%prog(1)%T + del_t(1)
  if ( num_l > 1) then
    do l = 1, num_l-1
      del_t(l+1) = lake%e(l) * del_t(l) + lake%f(l)
      lake%prog(l+1)%T = lake%prog(l+1)%T + del_t(l+1)
    end do
  end if

  if(is_watch_point()) then
    write(*,*) ' ***** lake_step_2 checkpoint 2 ***** '
    do l = 1, num_l
       write(*,*) 'level=', l, 'T', lake%prog(l)%T
    enddo
  endif

  ! ---- extract evap from lake and do implicit melt --------------------
  lake%prog(1)%wl = lake%prog(1)%wl - lake_levap*delta_time
  lake%prog(1)%ws = lake%prog(1)%ws - lake_fevap*delta_time
  hcap = lake%heat_capacity_dry(1)*lake%prog(1)%dz &
                     + clw*lake%prog(1)%wl + csw*lake%prog(1)%ws
  ! T adjustment for nonlinear terms (del_T)*(del_W)
  dheat = delta_time*(clw*lake_levap+csw*lake_fevap)*del_T(1)
  ! take out extra heat not claimed in advance for evaporation
  if (use_tfreeze_in_grnd_latent) dheat = dheat &
          - delta_time*((cpw-clw)*lake_levap+(cpw-csw)*lake_fevap) &
                                 *(lake%prog(1)%T-del_T(1)-tfreeze)
  lake%prog(1)%T  = lake%prog(1)%T  + dheat/hcap
  lake%prog(1)%wl = lake%prog(1)%wl + subs_M_imp
  lake%prog(1)%ws = lake%prog(1)%ws - subs_M_imp
  lake%prog(1)%T  = tfreeze + (hcap*(lake%prog(1)%T-tfreeze) ) &
                            / ( hcap + (clw-csw)*subs_M_imp )

  if(is_watch_point()) then
     write(*,*) ' ***** lake_step_2 checkpoint 2.1 ***** '
     do l = 1, num_l
        write(*,*) 'level=', l, 'T', lake%prog(l)%T
     enddo
  endif

  ! ---- remainder of mass fluxes and associated sensible heat fluxes --------
  ! note that only liquid inputs are received by  lake from snow pack. any
  ! snow fall just creates a snow pack on top  of lake, even if lake is not
  ! frozen. but snow pack on top of unfrozen lake will interact thermally,
  ! so that either lake freezes or snow melts and falls in.
    flow=1
    flow(1)  = snow_lprec *delta_time
    do l = 1, num_l
      flow(l+1) = 0
      dW_l(l) = flow(l) - flow(l+1)
      lake%prog(l)%wl = lake%prog(l)%wl + dW_l(l)
    enddo

  if(is_watch_point()) then
     write(*,*) ' ***** lake_step_2 checkpoint 3.3 ***** '
     do l = 1, num_l
        write(*,'(a,i2.2,100(2x,a,g23.16))') ' level=', l,&
             ' wl=', lake%prog(l)%wl,&
             'flow=', flow(l)
     enddo
  endif
  
  hcap = lake%heat_capacity_dry(1)*lake%prog(1)%dz &
                     + clw*(lake%prog(1)%wl-dW_l(1)) + csw*lake%prog(1)%ws
  lake%prog(1)%T = tfreeze + (hcap*(lake%prog(1)%T-tfreeze) +  &
                                 snow_hlprec*delta_time) &
                            / ( hcap + clw*dW_l(1) )

  if(is_watch_point()) then
    write(*,*) ' ***** lake_step_2 checkpoint 3.4 ***** '
    write(*,*) ' tfreeze', tfreeze
    write(*,*) ' snow_hlprec', snow_hlprec
  endif

  do l = 1, num_l
    ! ---- compute explicit melt/freeze --------------------------------------
    hcap = lake%heat_capacity_dry(l)*lake%prog(l)%dz &
             + clw*lake%prog(l)%wl + csw*lake%prog(l)%ws
    melt_per_deg = hcap/hlf
    if (lake%prog(l)%ws>0 .and. lake%prog(l)%T>tfreeze) then
      melt =  min(lake%prog(l)%ws, (lake%prog(l)%T-tfreeze)*melt_per_deg)
    else if (lake%prog(l)%wl>0 .and. lake%prog(l)%T<tfreeze) then
      melt = -min(lake%prog(l)%wl, (tfreeze-lake%prog(l)%T)*melt_per_deg)
    else
      melt = 0
    endif
    lake%prog(l)%wl = lake%prog(l)%wl + melt
    lake%prog(l)%ws = lake%prog(l)%ws - melt
    lake%prog(l)%T = tfreeze &
       + (hcap*(lake%prog(l)%T-tfreeze) - hlf*melt) &
                            / ( hcap + (clw-csw)*melt )
    lake_melt = lake_melt + melt / delta_time
  enddo

  if(is_watch_point()) then
     write(*,*) ' ***** lake_step_2 checkpoint 5 ***** '
     do l = 1, num_l
        write(*,'(a,i2.2,100(2x,a,g23.16))') ' level=', l,&
             ' dz=', lake%prog(l)%dz,&
             ' T =', lake%prog(l)%T,&
             ' Th=', (lake%prog(l)%ws +lake%prog(l)%wl)/(dens_h2o*lake%prog(l)%dz),&
             ' wl=', lake%prog(l)%wl,&
             ' ws=', lake%prog(l)%ws,&
             ' gw=', lake%prog(l)%groundwater
     enddo
  endif

  if (.not.relayer_in_step_one) call lake_relayer ( lake )

  if(is_watch_point()) then
     write(*,*) ' ***** lake_step_2 checkpoint 6 ***** '
     do l = 1, num_l
        write(*,'(a,i2.2,100(2x,a,g23.16))') ' level=', l,&
             ' dz=', lake%prog(l)%dz,&
             ' T =', lake%prog(l)%T,&
             ' Th=', (lake%prog(l)%ws +lake%prog(l)%wl)/(dens_h2o*lake%prog(l)%dz),&
             ' wl=', lake%prog(l)%wl,&
             ' ws=', lake%prog(l)%ws,&
             ' gw=', lake%prog(l)%groundwater
     enddo
  endif

  if (float_ice_to_top) then
      do l = num_l, 2, -1
        if (lake%prog(l)%ws .gt. 0. .and. lake%prog(l-1)%wl .gt. 0.) then
            ice_to_move = min(lake%prog(l)%ws, lake%prog(l-1)%wl)
            h_upper = (clw*lake%prog(l-1)%wl+csw*lake%prog(l-1)%ws)*lake%prog(l-1)%T
            h_lower = (clw*lake%prog(l  )%wl+csw*lake%prog(l  )%ws)*lake%prog(l  )%T
            lake%prog(l-1)%wl = lake%prog(l-1)%wl - ice_to_move
            lake%prog(l-1)%ws = lake%prog(l-1)%ws + ice_to_move
            lake%prog(l  )%wl = lake%prog(l  )%wl + ice_to_move
            lake%prog(l  )%ws = lake%prog(l  )%ws - ice_to_move
            h_to_move_up = ice_to_move*(csw*lake%prog(l)%T-clw*lake%prog(l-1)%T)
            h_upper  = h_upper + h_to_move_up
            h_lower  = h_lower - h_to_move_up
            lake%prog(l-1)%T = h_upper / (clw*lake%prog(l-1)%wl+csw*lake%prog(l-1)%ws)
            lake%prog(l  )%T = h_lower / (clw*lake%prog(l  )%wl+csw*lake%prog(l  )%ws)
          endif
        enddo
    endif

  if(is_watch_point()) then
     write(*,*) ' ***** lake_step_2 checkpoint 7 ***** '
     do l = 1, num_l
        write(*,'(a,i2.2,100(2x,a,g23.16))') ' level=', l,&
             ' dz=', lake%prog(l)%dz,&
             ' T =', lake%prog(l)%T,&
             ' Th=', (lake%prog(l)%ws +lake%prog(l)%wl)/(dens_h2o*lake%prog(l)%dz),&
             ' wl=', lake%prog(l)%wl,&
             ' ws=', lake%prog(l)%ws,&
             ' gw=', lake%prog(l)%groundwater
     enddo
  endif


  lake_Ttop = lake%prog(1)%T
  lake_Ctop = lake%heat_capacity_dry(1)*lake%prog(1)%dz &
       + clw*lake%prog(1)%wl + csw*lake%prog(1)%ws

! ----------------------------------------------------------------------------
! given solution for surface energy balance, write diagnostic output.
!  

  ! ---- increment time
  time = increment_time(time, int(delta_time), 0)

  ! ---- diagnostic section
  call send_tile_data (id_dz,   lake%prog%dz,     diag )
  call send_tile_data (id_temp, lake%prog%T,     diag )
  call send_tile_data (id_wl,  lake%prog(1:num_l)%wl, diag )
  call send_tile_data (id_ws,  lake%prog(1:num_l)%ws, diag )
  call send_tile_data (id_lwc,  lake%prog(1:num_l)%wl/lake%prog(1:num_l)%dz, diag )
  call send_tile_data (id_swc,  lake%prog(1:num_l)%ws/lake%prog(1:num_l)%dz, diag )
  call send_tile_data (id_K_z,  lake%prog(1:num_l)%K_z,        diag )
  call send_tile_data (id_evap, lake_levap+lake_fevap, diag )

end subroutine lake_step_2


! ============================================================================
!
  subroutine lake_relayer ( lake )
  type(lake_tile_type), intent(inout) :: lake

  ! ---- local vars
  integer :: l, l_lowest_thin_layer, l_highest_thick_layer
  real :: new_dz, new_ws, new_wl, new_h, new_T, liq_frac

! now check whether we need to re-layer the lake.
  if ( (lake%prog(1)%wl+lake%prog(1)%ws) &
      /(lake%prog(2)%wl+lake%prog(2)%ws) .gt. max_rat) then
      ! top layer has grown too thick. join two lower layers, and split
      ! top layer into two layers. in special case, just join and
      ! re-split top two layers.
      l_lowest_thin_layer = num_l
      do l = 2, num_l-1
        if (lake%prog(l)%dz.lt.0.99*lake%prog(num_l)%dz) l_lowest_thin_layer = l
        enddo
      if (l_lowest_thin_layer.gt.2) then
          new_dz = lake%prog(l_lowest_thin_layer)%dz &
                  + lake%prog(l_lowest_thin_layer-1)%dz
          new_wl = lake%prog(l_lowest_thin_layer)%wl &
                  + lake%prog(l_lowest_thin_layer-1)%wl
          new_ws = lake%prog(l_lowest_thin_layer)%ws &
                  + lake%prog(l_lowest_thin_layer-1)%ws
          new_h  = ( clw*lake%prog(l_lowest_thin_layer)%wl &
                   + csw*lake%prog(l_lowest_thin_layer)%ws) &
                   *     lake%prog(l_lowest_thin_layer)%T &
                 + ( clw*lake%prog(l_lowest_thin_layer-1)%wl &
                   + csw*lake%prog(l_lowest_thin_layer-1)%ws) &
                   *     lake%prog(l_lowest_thin_layer-1)%T
          new_T = new_h / (clw*new_wl+csw*new_ws)
          lake%prog(l_lowest_thin_layer)%dz = new_dz
          lake%prog(l_lowest_thin_layer)%wl = new_wl
          lake%prog(l_lowest_thin_layer)%ws = new_ws
          lake%prog(l_lowest_thin_layer)%T  = new_T
          do l = l_lowest_thin_layer-1, 3, -1
            lake%prog(l)%dz = lake%prog(l-1)%dz
            lake%prog(l)%wl = lake%prog(l-1)%wl
            lake%prog(l)%ws = lake%prog(l-1)%ws
            lake%prog(l)%T  = lake%prog(l-1)%T
            enddo
          liq_frac = lake%prog(1)%wl / (lake%prog(1)%wl+lake%prog(1)%ws)
          lake%prog(2)%wl =     liq_frac *DENS_H2O*lake%prog(2)%dz
          lake%prog(2)%ws = (1.-liq_frac)*DENS_H2O*lake%prog(2)%dz
          lake%prog(2)%T  = lake%prog(1)%T
          lake%prog(1)%dz = lake%prog(2)%dz
          lake%prog(1)%wl = lake%prog(1)%wl - lake%prog(2)%wl
          lake%prog(1)%ws = lake%prog(1)%ws - lake%prog(2)%ws
        else
          new_wl = lake%prog(1)%wl + lake%prog(2)%wl
          new_ws = lake%prog(1)%ws + lake%prog(2)%ws
          new_h  = ( clw*lake%prog(1)%wl + csw*lake%prog(1)%ws)   &
                                                 * lake%prog(1)%T &
                 + ( clw*lake%prog(2)%wl + csw*lake%prog(2)%ws)    &
                                                 * lake%prog(2)%T
          new_T  = new_h / (clw*new_wl+csw*new_ws)
          liq_frac = new_wl / (new_wl+new_ws)
          lake%prog(2)%dz = lake%prog(3)%dz
          lake%prog(2)%wl =     liq_frac *DENS_H2O*lake%prog(2)%dz
          lake%prog(2)%ws = (1.-liq_frac)*DENS_H2O*lake%prog(2)%dz
          lake%prog(2)%T  = new_T
          lake%prog(1)%dz = lake%prog(2)%dz
          lake%prog(1)%wl = new_wl - lake%prog(2)%wl
          lake%prog(1)%ws = new_ws - lake%prog(2)%ws
          lake%prog(1)%T  = new_T
        endif
    else if(  (lake%prog(1)%wl+lake%prog(1)%ws) &
             /(lake%prog(2)%wl+lake%prog(2)%ws) .lt. min_rat) then
      ! top layer has grown too thin. join with next layer down, and split
      ! a lower layer to maintain number of layers.  in special case, just
      ! join and re-split top two layers.
      l_highest_thick_layer = 2
      do l = num_l, 3, -1
        if (lake%prog(l)%dz.gt.1.01*lake%prog(2)%dz) l_highest_thick_layer = l
        enddo
      new_wl = lake%prog(1)%wl + lake%prog(2)%wl
      new_ws = lake%prog(1)%ws + lake%prog(2)%ws
      new_h  = ( clw*lake%prog(1)%wl + csw*lake%prog(1)%ws)   &
                                             * lake%prog(1)%T &
             + ( clw*lake%prog(2)%wl + csw*lake%prog(2)%ws)    &
                                             * lake%prog(2)%T
      new_T  = new_h / (clw*new_wl+csw*new_ws)
      if (l_highest_thick_layer.gt.2) then
          lake%prog(1)%dz = lake%prog(2)%dz
          lake%prog(1)%wl = new_wl
          lake%prog(1)%ws = new_ws
          lake%prog(1)%T  = new_T
          do l = 2, l_highest_thick_layer-2
            lake%prog(l)%dz = lake%prog(l+1)%dz
            lake%prog(l)%wl = lake%prog(l+1)%wl
            lake%prog(l)%ws = lake%prog(l+1)%ws
            lake%prog(l)%T  = lake%prog(l+1)%T
            enddo
          new_dz = lake%prog(l_highest_thick_layer)%dz / 2.
          new_wl = lake%prog(l_highest_thick_layer)%wl / 2.
          new_ws = lake%prog(l_highest_thick_layer)%ws / 2.
          new_T  = lake%prog(l_highest_thick_layer)%T
          lake%prog(l_highest_thick_layer-1)%dz = new_dz
          lake%prog(l_highest_thick_layer-1)%wl = new_wl
          lake%prog(l_highest_thick_layer-1)%ws = new_ws
          lake%prog(l_highest_thick_layer-1)%T  = new_T
          lake%prog(l_highest_thick_layer)%dz = new_dz
          lake%prog(l_highest_thick_layer)%wl = new_wl
          lake%prog(l_highest_thick_layer)%ws = new_ws
          lake%prog(l_highest_thick_layer)%T  = new_T
        else
          liq_frac = new_wl / (new_wl+new_ws)
          lake%prog(2)%dz = lake%prog(3)%dz / 2.
          lake%prog(2)%wl =     liq_frac *DENS_H2O*lake%prog(2)%dz
          lake%prog(2)%ws = (1.-liq_frac)*DENS_H2O*lake%prog(2)%dz
          lake%prog(2)%T  = new_T
          lake%prog(1)%dz = lake%prog(2)%dz
          lake%prog(1)%wl = new_wl - lake%prog(2)%wl
          lake%prog(1)%ws = new_ws - lake%prog(2)%ws
          lake%prog(1)%T  = new_T          
        endif
    endif
  end subroutine lake_relayer

! ============================================================================
subroutine lake_diag_init ( id_lon, id_lat )
  integer,         intent(in) :: id_lon  ! ID of land longitude (X) axis  
  integer,         intent(in) :: id_lat  ! ID of land longitude (X) axis

  ! ---- local vars
  integer :: axes(3)
  integer :: id_zhalf, id_zfull

  ! define vertical axis
  id_zhalf = diag_axis_init ( &
       'zhalf_lake', zhalf(1:num_l+1), 'meters', 'z', 'half level',  -1, set_name='lake' )
  id_zfull = diag_axis_init ( &
       'zfull_lake', zfull(1:num_l),   'meters', 'z', 'full level',  -1, set_name='lake', &
       edges=id_zhalf )

  ! define array of axis indices
  axes = (/ id_lon, id_lat, id_zfull /)

  ! define static diagnostic fields
  id_sillw = register_tiled_static_field ( module_name, 'lake_width', &
       axes(1:2), 'lake width at outflow', 'm', missing_value=-100.0 )
  id_silld = register_tiled_static_field ( module_name, 'lake_depth', &
       axes(1:2), 'lake depth below sill', 'm', missing_value=-100.0 )
  id_backw = register_tiled_static_field ( module_name, 'backwater', &
       axes(1:2), 'backwater flag', '-', missing_value=-100.0 )
  id_back1 = register_tiled_static_field ( module_name, 'backwater_1', &
       axes(1:2), 'backwater1 flag', '-', missing_value=-100.0 )
  ! define dynamic diagnostic fields
  id_dz  = register_tiled_diag_field ( module_name, 'lake_dz', axes,         &
       Time, 'nominal layer thickness', 'm', missing_value=-100.0 )
  id_wl  = register_tiled_diag_field ( module_name, 'lake_wl', axes,         &
       Time, 'liquid water mass', 'kg/m2', missing_value=-100.0 )
  id_ws  = register_tiled_diag_field ( module_name, 'lake_ws', axes,         &
       Time, 'solid water mass', 'kg/m2', missing_value=-100.0 )
  id_lwc  = register_tiled_diag_field ( module_name, 'lake_liq',  axes,       &
       Time, 'bulk density of liquid water', 'kg/m3',  missing_value=-100.0 )
  id_swc  = register_tiled_diag_field ( module_name, 'lake_ice',  axes,       &
       Time, 'bulk density of solid water', 'kg/m3',  missing_value=-100.0 )
  id_temp  = register_tiled_diag_field ( module_name, 'lake_T',  axes,        &
       Time, 'temperature',            'degK',  missing_value=-100.0 )
  id_K_z  = register_tiled_diag_field ( module_name, 'lake_K_z', axes,         &
       Time, 'vertical diffusivity', 'm2/s', missing_value=-100.0 )
  id_evap  = register_tiled_diag_field ( module_name, 'lake_evap',  axes(1:2),  &
       Time, 'lake evap',            'kg/(m2 s)',  missing_value=-100.0 )
       
  call add_tiled_static_field_alias (id_silld, module_name, 'sill_depth', &
       axes(1:2), 'obsolete, pls use lake_depth (static)','m', &
       missing_value=-100.0 )
  call add_tiled_static_field_alias (id_sillw, module_name, 'sill_width', &
       axes(1:2), 'obsolete, pls use lake_width (static)','m', &
       missing_value=-100.0 )

end subroutine lake_diag_init

! ============================================================================
! tile existence detector: returns a logical value indicating wether component
! model tile exists or not
logical function lake_tile_exists(tile)
   type(land_tile_type), pointer :: tile
   lake_tile_exists = associated(tile%lake)
end function lake_tile_exists


! ============================================================================
! accessor functions: given a pointer to a land tile, they return pointer
! to the desired member of the land tile, of NULL if this member does not
! exist.
subroutine lake_dz_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr(:)
   integer :: n
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%lake)) then
        n = size(tile%lake%prog)
        ptr(1:n) => tile%lake%prog(1:n)%dz
      endif
   endif
end subroutine lake_dz_ptr

subroutine lake_temp_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr(:)
   integer :: n
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%lake)) then
        n = size(tile%lake%prog)
        ptr(1:n) => tile%lake%prog(1:n)%T
      endif
   endif
end subroutine lake_temp_ptr

subroutine lake_wl_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr(:)
   integer :: n
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%lake)) then
        n = size(tile%lake%prog)
        ptr(1:n) => tile%lake%prog(1:n)%wl
      endif
   endif
end subroutine lake_wl_ptr

subroutine lake_ws_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr(:)
   integer :: n
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%lake)) then
        n = size(tile%lake%prog)
        ptr(1:n) => tile%lake%prog(1:n)%ws
      endif
   endif
end subroutine lake_ws_ptr

subroutine lake_gw_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr(:)
   integer :: n
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%lake)) then
        n = size(tile%lake%prog)
        ptr(1:n) => tile%lake%prog(1:n)%groundwater
      endif
   endif
end subroutine lake_gw_ptr

subroutine lake_gwT_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr(:)
   integer :: n
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%lake)) then
        n = size(tile%lake%prog)
        ptr(1:n) => tile%lake%prog(1:n)%groundwater_T
      endif
   endif
end subroutine lake_gwT_ptr

subroutine lake_connected_to_next_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%lake)) ptr=>tile%lake%pars%connected_to_next
   endif
end subroutine lake_connected_to_next_ptr

subroutine lake_depth_sill_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%lake)) ptr=>tile%lake%pars%depth_sill
   endif
end subroutine lake_depth_sill_ptr

subroutine lake_whole_area_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%lake)) ptr=>tile%lake%pars%whole_area
   endif
end subroutine lake_whole_area_ptr

subroutine lake_width_sill_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%lake)) ptr=>tile%lake%pars%width_sill
   endif
end subroutine lake_width_sill_ptr

subroutine lake_backwater_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%lake)) ptr=>tile%lake%pars%backwater
   endif
end subroutine lake_backwater_ptr

subroutine lake_backwater_1_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%lake)) ptr=>tile%lake%pars%backwater_1
   endif
end subroutine lake_backwater_1_ptr

end module lake_mod

module ocean_bihcgrid_friction_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S. M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! This module computes the thickness weighted time tendency for  
! horizontal velocity arising from horizontal biharmonic friction. 
! Friction is formulated for the C-grid here. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes the thickness weighted time tendency for
! horizontal velocity arising from horizontal biharmonic friction. 
! The viscosity used to determine the strength of the tendency 
! can be a general function of space and time as specified by 
! the Smagorinsky approach; a grid-scale dependent
! background viscosity; or other options.  
! The form of the friction operator can be isotropic or 
! anisotropic in the horizontal plane. 
!
! Friction is formulated for the C-grid in this module. 
!
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies and R.W. Hallberg, 2000: 
! Biharmonic friction with a Smagorinsky viscosity for use in large-scale
! eddy-permitting ocean models
! Monthly Weather Review, vol. 128, pages 2935-2946
! </REFERENCE>
!
! <REFERENCE>
! R. D. Smith and J. C. McWilliams, 2003:
! Anisotropic horizontal viscosity for ocean models,
! Ocean Modelling, vol. 5, pages 129-156.
! </REFERENCE>
!
! <REFERENCE>
! Maltrud and Holloway, 2008: Implementing biharmonic neptune in a
! global eddying ocean model, Ocean Modelling, vol. 21, pages 22-34.
! </REFERENCE>
!
! <REFERENCE>
! Deremble, Hogg, Berloff, and Dewar, 2011:
! On the application of no-slip lateral boundary conditions to coarsely
! resolved ocean models, Ocean Modelling. 
! </REFERENCE>
!
! <REFERENCE>
! Griffies: Elements of MOM (2012)
! </REFERENCE>
!
! <NOTE>
! The ocean model can generally run with both Laplacian and biharmonic friction
! enabled at the same time.  Such has been found useful for some simulations. 
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_bihcgrid_friction_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is false.
!  </DATA>
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging by printing checksums.  
!  </DATA> 
!
!  <DATA NAME="k_smag_iso" UNITS="dimensionless" TYPE="real">
!  This is the dimensionless Smagorinsky coefficient used to set the scale 
!  of the Smagorinsky isotropic viscosity. 
!  </DATA> 
!  <DATA NAME="k_smag_aniso" UNITS="dimensionless" TYPE="real">
!  This is the dimensionless Smagorinsky coefficient used to set the scale 
!  of the Smagorinsky anisotropic viscosity. 
!  </DATA> 
!
!  <DATA NAME="vel_micom_iso" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM isotropic viscosity. 
!  </DATA> 
!  <DATA NAME="vel_micom_aniso" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM anisotropic viscosity. 
!  </DATA> 
!
!  <DATA NAME="equatorial_zonal" TYPE="logical">
!  Orient the anisotropic friction within a latitudinal band according to zonal direction. 
!  </DATA> 
!  <DATA NAME="equatorial_zonal_lat" TYPE="real">
!  Latitudinal band to use the zonal friction orientation. 
!  </DATA> 
!  <DATA NAME="equatorial_no_smag" TYPE="logical">
!  Turn smag off within equatorial_zonal_lat region. 
!  </DATA> 
!  <DATA NAME="eq_vel_micom_iso" TYPE="real">
!  Velocity scale that is used for computing the MICOM isotropic viscosity within
!  a user specified equatorial band. 
!  </DATA> 
!  <DATA NAME="eq_vel_micom_aniso" TYPE="real">
!  Velocity scale that is used for computing the MICOM anisotropic viscosity within
!  a user specified equatorial band. 
!  </DATA> 
!  <DATA NAME="eq_lat_micom" TYPE="real">
!  Equatorial latitude band (degrees) within which the MICOM viscosity is set according 
!  to eq_vel_micom_iso and eq_vel_micom_aniso.
!  </DATA> 
!
!  <DATA NAME="neptune" TYPE="logical">
!  Set to true for computing friction relative to Neptune barotropic velocity. 
!  Default neptune=.false. 
!  </DATA> 
!  <DATA NAME="neptune_length_eq" UNITS="m" TYPE="real">
!  Length scale used to compute Neptune velocity at equator.  
!  </DATA> 
!  <DATA NAME="neptune_length_pole" UNITS="m" TYPE="real">
!  Length scale used to compute Neptune velocity at pole. 
!  </DATA> 
!  <DATA NAME="neptune_depth_min" UNITS="m" TYPE="real">
!  Minimum depth scale used for computing Neptune velocity.
!  Default neptune_depth_min=100.0
!  </DATA> 
!  <DATA NAME="neptune_smooth" TYPE="logical">
!  For doing a horizontal 1-2-1 smoothing on the diagnosed  
!  neptune velocity scale. 
!  Default neptune_smooth=.true.
!  </DATA> 
!  <DATA NAME="neptune_smooth_num" TYPE="integer">
!  Number of smoothing passes for neptune velocity.
!  Default neptune_smooth_num=1.
!  </DATA> 
!
!  <DATA NAME="use_side_drag_friction" TYPE="logical">
!  For converting friction at U-cells next to walls into 
!  a drag law, as per Deremble et al. Use cdbot_array
!  from ocean_core/ocean_bbc.F90 to compute drag force. 
!  Default use_side_drag_friction=.false.
!  </DATA> 
!  <DATA NAME="side_drag_friction_scaling" TYPE="real">
!  Dimensionless scaling used for cdbot_array when setting
!  side drag friction. So the effective side dragy coefficient
!  is side_drag_friction_scaling*cdbot_array.  
!  Default side_drag_friction_scaling=1.0.
!  </DATA> 
!  <DATA NAME="side_drag_friction_uvmag_max" UNITS="m/s" TYPE="real">
!  Maximum magnitude of horizontal velocity used to compute the 
!  side drag friction. This parameter can be useful especially
!  for pressure models where the bottom cells can be quite thin 
!  and subject to sporadic large magnitudes.  We do the same thing with 
!  bottom drag calculations. 
!  Default side_drag_friction_uvmag_max=10.0.
!  </DATA> 
!  <DATA NAME="side_drag_friction_max" UNITS="N/m^2" TYPE="real">
!  Maximum magnitude of the side drag induced friction. 
!  This parameter can be useful especially for pressure models 
!  where the bottom cells can be quite thin and subject to sporadic
!  large magnitudes.  We do the same thing with bottom drag calculations
!  in ocean_bbc. Default side_drag_friction_max=1.0.
!  </DATA> 
!
!</NAMELIST>

use constants_mod,    only: pi, radius, epsln, radian
use diag_manager_mod, only: register_diag_field, register_static_field
use fms_mod,          only: open_namelist_file, check_nml_error, write_version_number, close_file
use fms_mod,          only: read_data
use mpp_domains_mod,  only: mpp_update_domains, CGRID_NE
use mpp_domains_mod,  only: mpp_start_update_domains, mpp_complete_update_domains
use mpp_domains_mod,  only: mpp_global_min, mpp_global_max, mpp_global_field, XUPDATE 
use mpp_mod,          only: input_nml_file, mpp_sum, mpp_pe, mpp_error, mpp_max
use mpp_mod,          only: FATAL, NOTE, stdout, stdlog

use ocean_domains_mod,    only: get_local_indices
use ocean_obc_mod,        only: ocean_obc_enhance_visc_back
use ocean_operators_mod,  only: BAY, BAX, BDX_EU, BDY_NU, FDX_U, FDY_U, FMX, FMY
use ocean_operators_mod,  only: FAY, FAX, FDX_NT, FDY_ET, FDX_T, FDY_T 
use ocean_parameters_mod, only: missing_value, onehalf, oneeigth
use ocean_parameters_mod, only: omega_earth, rho0, rho0r
use ocean_types_mod,      only: ocean_time_type, ocean_grid_type
use ocean_types_mod,      only: ocean_domain_type, ocean_adv_vel_type 
use ocean_types_mod,      only: ocean_thickness_type, ocean_velocity_type
use ocean_types_mod,      only: ocean_options_type
use ocean_util_mod,       only: write_timestamp, diagnose_3d, diagnose_3d_u, diagnose_2d, write_chksum_3d
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3, wrk4
use ocean_workspace_mod,  only: wrk1_2d, wrk1_v2d  
use ocean_workspace_mod,  only: wrk1_v, wrk2_v, wrk3_v

implicit none

private

public ocean_bihcgrid_friction_init
public bihcgrid_friction
public bihcgrid_viscosity_check
public bihcgrid_reynolds_check

private compute_neptune_velocity

! length of forward time step  
real :: dtime

! for diagnostics 
integer :: id_aiso                 =-1
integer :: id_aaniso               =-1
integer :: id_aiso_smag            =-1
integer :: id_aaniso_smag          =-1
integer :: id_aiso_back            =-1
integer :: id_aaniso_back          =-1
integer :: id_along_back           =-1
integer :: id_across_back          =-1
integer :: id_aiso_diverge         =-1
integer :: id_sin2theta            =-1
integer :: id_cos2theta            =-1
integer :: id_neptune_bih_u        =-1
integer :: id_neptune_bih_v        =-1
integer :: id_ncar_rescale         =-1
integer :: id_along                =-1
integer :: id_across               =-1
integer :: id_visc_diverge         =-1
integer :: id_visc_crit_bih        =-1
integer :: id_bih_fric_u           =-1
integer :: id_bih_fric_v           =-1
integer :: id_horz_bih_diss        =-1
integer :: id_tmask_next_to_land   =-1
integer :: id_stress_xx_bih        =-1
integer :: id_stress_xy_bih        =-1
integer :: id_stress_yx_bih        =-1

logical :: used

real :: k_smag_iso          = 0.0    ! smag scaling coeff for isotropic viscosity (dimensionless) 
real :: k_smag_aniso        = 0.0    ! smag scaling coeff for anisotripic viscosity (dimensionless) 
real :: vel_micom_iso       = 0.0    ! background scaling velocity for isotropic viscosity (m/sec) 
real :: vel_micom_aniso     = 0.0    ! background scaling velocity for anisotropic viscosity (m/sec) 
real :: eq_vel_micom_iso    = 0.2    ! background scaling velocity (m/sec) within equatorial band for isotropic visc
real :: eq_vel_micom_aniso  = 0.0    ! background scaling velocity (m/sec) within equatorial band for anisotropic visc
real :: eq_lat_micom        = 0.0    ! equatorial latitude band for micom (degrees)
real :: vel_micom_bottom    = 0.01   ! velocity scale for determining viscosity at the bottom 
real :: equatorial_zonal_lat= 0.0    ! latitudinal band for orienting the friction along zonal direction
real :: visc_crit_scale     = 1.0    ! constant for setting the critical viscosity on the instability constraint 
logical :: equatorial_zonal = .false.! zonally orient anisotropic friction w/i equatorial_zonal_lat


! for divergence-based viscosity
real :: visc_diverge_scaling = 0.0  ! dimensionless
real, dimension(:,:),   allocatable :: visc_diverge_factor ! (m^4) for computing visc_diverge
real, dimension(:,:,:), allocatable :: divergence_t        ! array to hold diverge_t 
real, dimension(:,:,:), allocatable :: visc_diverge        ! viscosity based on horz divergence

! for the western boundary scaling of the background viscosity
! nx and ny are number of global points in generalized x and y 
! directions
logical :: ncar_boundary_scaling      = .false.
logical :: ncar_boundary_scaling_read = .false.
real    :: ncar_vconst_4              = 2.e-8
integer :: ncar_vconst_5              = 3  
integer :: ncar_rescale_power         = 1
integer :: nx, ny 


! for neptune scheme  
logical :: neptune              = .false. ! for computing friction relative to barotropic Neptune velocity
logical :: neptune_smooth       = .true.  ! for smoothing diagnosed neptune velocity
integer :: neptune_smooth_num   = 1       ! number of smoothing passes for neptune smoother 
real    :: neptune_length_eq    = 4.2e3   ! (metres; from Maltrud and Holloway)
real    :: neptune_length_pole  = 17.0e3  ! (metres; from Maltrud and Holloway)
real    :: neptune_depth_min    = 100.0   ! (metres; from Maltrud and Holloway)
real    :: neptune_scaling      = 1.0     ! dimensionless scaling used for tuning 

! for side-boundary drag law
logical :: use_side_drag_friction       = .false.
real    :: side_drag_friction_scaling   = 1.0
real    :: side_drag_friction_max       = 1.0
real    :: side_drag_friction_uvmag_max = 10.0
real, dimension(:,:,:), allocatable :: tmask_next_to_land


#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS

real, dimension(isd:ied,jsd:jed,nk)  :: aiso_back      ! minimum allowable isotropic viscosity (m^4/s)
real, dimension(isd:ied,jsd:jed,nk)  :: aaniso_back    ! minimum allowable anisotropic viscosity (m^4/s)
real, dimension(isd:ied,jsd:jed,nk)  :: aiso           ! isotropic viscosity (m^4/s) for stability check
real, dimension(isd:ied,jsd:jed,nk)  :: aiso_xx        ! isotropic viscosity (m^4/s) for stress_xx 
real, dimension(isd:ied,jsd:jed,nk)  :: aiso_xy        ! isotropic viscosity (m^4/s) for stress_xy 
real, dimension(isd:ied,jsd:jed,nk)  :: aaniso_xx      ! anisotropic viscosity (m^4/s) for stress_xx 
real, dimension(isd:ied,jsd:jed,nk)  :: aaniso_xy      ! anisotropic viscosity (m^4/s) for stress_xy 
real, dimension(isd:ied,jsd:jed,nk)  :: horz_ten       ! horizontal rate of deformation (1/s)
real, dimension(isd:ied,jsd:jed,nk)  :: horz_str       ! horizontal rate of strain (1/s)
real, dimension(isd:ied,jsd:jed,nk)  :: sin2theta      ! orientation angle 
real, dimension(isd:ied,jsd:jed,nk)  :: cos2theta      ! orientation angle 
real, dimension(isd:ied,jsd:jed,nk)  :: stress_xx      ! stress tensor component
real, dimension(isd:ied,jsd:jed,nk)  :: stress_xy      ! stress tensor component
real, dimension(isd:ied,jsd:jed,nk)  :: stress_yx      ! stress tensor component
real, dimension(isd:ied,jsd:jed,nk)  :: tmplap1        ! for holding the Laplacian friction 
real, dimension(isd:ied,jsd:jed,nk)  :: tmplap2        ! for holding the Laplacian friction 
real, dimension(isd:ied,jsd:jed,nk)  :: ncar_rescale   ! viscosity scale (cm^2/s) based on NCAR western boundary scaling 


#else

real, dimension(:,:,:),  allocatable  :: aiso_back      ! minimum allowable isotropic viscosity (m^4/s)
real, dimension(:,:,:),  allocatable  :: aaniso_back    ! minimum allowable anisotropic viscosity (m^4/s)
real, dimension(:,:,:),  allocatable  :: aiso           ! isotropic viscosity (m^4/s) for diagnostic 
real, dimension(:,:,:),  allocatable  :: aiso_xx        ! isotropic viscosity (m^4/s) for stress_xx 
real, dimension(:,:,:),  allocatable  :: aiso_xy        ! isotropic viscosity (m^4/s) for stress_xy 
real, dimension(:,:,:),  allocatable  :: aaniso_xx      ! anisotropic viscosity (m^4/s) for stress_xx 
real, dimension(:,:,:),  allocatable  :: aaniso_xy      ! anisotropic viscosity (m^4/s) for stress_xy 
real, dimension(:,:,:),  allocatable  :: horz_ten       ! horizontal rate of tension (1/s)
real, dimension(:,:,:),  allocatable  :: horz_str       ! horizontal rate of strain (1/s)
real, dimension(:,:,:),  allocatable  :: sin2theta      ! orientation angle 
real, dimension(:,:,:),  allocatable  :: cos2theta      ! orientation angle 
real, dimension(:,:,:),  allocatable  :: stress_xx      ! stress tensor component
real, dimension(:,:,:),  allocatable  :: stress_xy      ! stress tensor component
real, dimension(:,:,:),  allocatable  :: stress_yx      ! stress tensor component
real, dimension(:,:,:),  allocatable  :: tmplap1        ! for holding the Laplacian friction 
real, dimension(:,:,:),  allocatable  :: tmplap2        ! for holding the Laplacian friction 
real, dimension(:,:,:),  allocatable  :: ncar_rescale   ! viscosity scale (cm^2/s) based on NCAR western boundary scaling 

#endif

real, dimension(:,:),   allocatable  :: aiso_back_obc     ! (m^4/s) for OBC 
real, dimension(:,:),   allocatable  :: aaniso_back_obc   ! (m^4/s) for OBC 
real, dimension(:,:),   allocatable  :: fsmag_iso         ! (m^4) combination of terms for computing isotropic smag visc
real, dimension(:,:),   allocatable  :: fsmag_aniso       ! (m^4) combination of terms for computing anisotropic smag visc
real, dimension(:,:),   allocatable  :: visc_crit         ! critical value of the viscosity (m^4/sec) for linear stability 
real, dimension(:,:),   allocatable  :: dxu_dyur          ! (dxu/dyu)
real, dimension(:,:),   allocatable  :: dyu_dxur          ! (dyu/dxu)
real, dimension(:,:),   allocatable  :: dxt_dytr          ! (dxt/dyt)
real, dimension(:,:),   allocatable  :: dyt_dxtr          ! (dyt/dxt)
real, dimension(:,:),   allocatable  :: grid_length       ! horizontal grid length (m)
real, dimension(:,:,:), allocatable  :: neptune_velocity  ! barotropic velocity (m/s) from Neptune 

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()

character(len=256) :: version=&
     '=>Using: ocean_bihcgrid_friction.F90 ($Id: ocean_bihcgrid_friction.F90,v 20.0 2013/12/14 00:14:12 fms Exp $)'
character (len=128) :: tagname = &
     '$Name: tikal $'

logical :: use_this_module       = .false.
logical :: debug_this_module     = .false.
logical :: module_is_initialized = .FALSE.
logical :: have_obc              = .FALSE.
logical :: read_aiso_bih_back    = .false.


namelist /ocean_bihcgrid_friction_nml/ use_this_module, debug_this_module,              &
    k_smag_iso, k_smag_aniso,                                                           &
    vel_micom_iso, vel_micom_aniso, eq_vel_micom_iso, eq_vel_micom_aniso, eq_lat_micom, &
    equatorial_zonal, equatorial_zonal_lat,                                             &
    neptune, neptune_length_eq, neptune_length_pole, neptune_depth_min,                 &
    neptune_smooth, neptune_smooth_num,                                                 &
    ncar_boundary_scaling, ncar_rescale_power, ncar_vconst_4, ncar_vconst_5,            &
    ncar_boundary_scaling_read,                                                         &
    use_side_drag_friction, side_drag_friction_scaling,                                 &
    side_drag_friction_uvmag_max, side_drag_friction_max 

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_bihcgrid_friction_init">

! <DESCRIPTION>
! Initialize the lateral biharmonic friction module by 
! registering fields for diagnostic output and performing some 
! numerical checks to see that viscosity is set appropriately.
! </DESCRIPTION>
!
subroutine ocean_bihcgrid_friction_init(Grid, Domain, Time, Ocean_options, d_time, &
                                        obc, use_bihcgrid_friction, debug)
 
  type(ocean_grid_type),    target, intent(in)    :: Grid
  type(ocean_domain_type),  target, intent(in)    :: Domain
  type(ocean_time_type),            intent(in)    :: Time
  type(ocean_options_type),         intent(inout) :: Ocean_options
  real,                             intent(in)    :: d_time
  logical,                          intent(in)    :: obc
  logical,                          intent(inout) :: use_bihcgrid_friction
  logical,                optional, intent(in)    :: debug

  integer :: ioun, io_status, ierr
  integer :: i, j, k
  real :: coeff_iso, coeff_aniso, dxdy

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_bihcgrid_friction_mod (ocean_bihcgrid_friction_init): already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)


  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_bihcgrid_friction_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_bihcgrid_friction_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_bihcgrid_friction_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_bihcgrid_friction_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_bihcgrid_friction_nml)  
  write (stdlogunit,ocean_bihcgrid_friction_nml)

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
#endif

  if(use_this_module) then 
      call mpp_error(NOTE, '==> NOTE: USING ocean_bihcgrid_friction_mod.')
      Ocean_options%horz_bih_friction = 'Used general horizontal biharmonic friction for Cgrid.'
      use_bihcgrid_friction=.true.
  else 
      call mpp_error(NOTE, '==> NOTE: NOT using ocean_bihcgrid_friction_mod.')
      Ocean_options%horz_bih_friction = 'Did NOT use horizontal biharmonic friction for Cgrid.'
      use_bihcgrid_friction=.false.
      return 
  endif

  if (PRESENT(debug) .and. .not. debug_this_module) then 
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') &
    '==>Note: running with debug_this_module=.true. so will print lots of checksums.'  
  endif 

  Grd => Grid
  Dom => Domain
  nx  =  Grd%ni
  ny  =  Grd%nj

  dtime = d_time

  write(stdoutunit,'(a)') ' ' 

  write(stdoutunit,'(/a,f10.2)') &
   '==> Note from ocean_bihcgrid_friction_mod: using forward time step of (secs)', dtime 

  have_obc = obc
  if (have_obc) then 
     write(stdoutunit,'(/a,f10.2)') '==> Note from ocean_bihcgrid_friction_mod: considering obc' 
  endif 

  if (Dom%xhalo > 1 .or. Dom%yhalo > 1) then
    write (stdoutunit,'(/1x,a)') ' ==> NOTE: General biharmonic friction allows xhalo=yhalo=1.'
  endif

  if(neptune) then 
    write(stdoutunit,'(1x,a)') '==> Note: Computing biharmonic friction relative to Neptune'
    write(stdoutunit,'(5x,a,e10.5)') &
    'Equatorial length (m) for computing Neptune velocity is   ',neptune_length_eq 
    write(stdoutunit,'(5x,a,e10.5)') &
    'Polar length (m) for computing Neptune velocity is        ',neptune_length_pole 
    write(stdoutunit,'(5x,a,e10.5)') &
    'Minimum depth scale (m) for computing Neptune velocity is ',neptune_depth_min
  endif 

  if(k_smag_iso > 0.0) then 
     write( stdoutunit,'(a)')' Computing horziontal isotropic biharmonic viscosity via Smagorinsky.'
  endif
  if(k_smag_iso==0.0)  then 
    write( stdoutunit,*)' Setting horzizontal isotropic biharmonic Smagorinsky viscosity to zero.'
  endif 
  if(k_smag_aniso > 0.0) then 
     write( stdoutunit,'(a)')' Computing horzizontal anisotropic biharmonic viscosity via Smagorinsky.'
     write( stdoutunit,'(1x,a)')' ==>WARNING: anisotropic biharmonic Smagorinsky not well tested.'
  endif
  if(k_smag_aniso==0.0) then 
    write( stdoutunit,*)' Setting horzizontal anisotropic biharmonic Smagorinsky viscosity to zero.'
  endif 
  if(vel_micom_iso > 0.0) then 
     write( stdoutunit,'(a)')' Computing background horzizontal biharmonic isotropic viscosity via MICOM.'
  endif
  if(vel_micom_iso==0.0) then 
    write( stdoutunit,*)' Setting background horzizontal biharmonic isotropic viscosity to zero.'
  endif 
  if(vel_micom_aniso > 0.0) then
     write( stdoutunit,'(a)')' Computing background horzizontal anisotropic biharmonic viscosity via MICOM.'
     write( stdoutunit,'(1x,a)')' ==> WARNING: anisotropic biharmonic background viscosity not well tested.'
  endif 
  if(vel_micom_aniso==0.0) then
     write(stdoutunit,'(a)')' Setting background horziontal biharmonic anisotropic viscosity to zero.' 
  endif 
  if(k_smag_aniso > 2.0*k_smag_iso) then
     call mpp_error(FATAL, &
     '==>Error: Smag horizontal bih anisotropic visc too large. Must be < 2*isotropic-visc.')
  endif  
  if(vel_micom_aniso > 2.0*vel_micom_iso) then
    call mpp_error(FATAL, &
     '==>Error: Background bih horz aniso visc too large. Must be < 2.0*background iso visc.')
  endif  
  if(eq_lat_micom > 0) then 
    write( stdoutunit,'(a)')'Setting different background horz bih viscosity w/i equatorial zone.'
  endif 
  if(equatorial_zonal) then
    write( stdoutunit,'(a)') &
    'If using anisotropic biharmonic friction, zonally orient friction w/i latitudinal'
    write( stdoutunit,'(a)') &
    'band of width ',equatorial_zonal_lat,' degrees.'
  endif 


#ifndef MOM_STATIC_ARRAYS
  allocate (aiso_back(isd:ied,jsd:jed,nk))
  allocate (aaniso_back(isd:ied,jsd:jed,nk))
  allocate (aiso(isd:ied,jsd:jed,nk))
  allocate (aiso_xx(isd:ied,jsd:jed,nk))
  allocate (aiso_xy(isd:ied,jsd:jed,nk))
  allocate (aaniso_xx(isd:ied,jsd:jed,nk))
  allocate (aaniso_xy(isd:ied,jsd:jed,nk))
  allocate (horz_ten(isd:ied,jsd:jed,nk))
  allocate (horz_str(isd:ied,jsd:jed,nk))
  allocate (sin2theta(isd:ied,jsd:jed,nk))
  allocate (cos2theta(isd:ied,jsd:jed,nk))
  allocate (stress_xx(isd:ied,jsd:jed,nk))  
  allocate (stress_xy(isd:ied,jsd:jed,nk))  
  allocate (stress_yx(isd:ied,jsd:jed,nk))  
  allocate (tmplap1(isd:ied,jsd:jed,nk))    
  allocate (tmplap2(isd:ied,jsd:jed,nk))    
  allocate (ncar_rescale(isd:ied,jsd:jed,nk))
#endif

  allocate (fsmag_iso(isd:ied,jsd:jed))
  allocate (fsmag_aniso(isd:ied,jsd:jed))
  allocate (visc_crit(isd:ied,jsd:jed))
  allocate (dxu_dyur(isd:ied,jsd:jed))
  allocate (dyu_dxur(isd:ied,jsd:jed))
  allocate (dxt_dytr(isd:ied,jsd:jed))
  allocate (dyt_dxtr(isd:ied,jsd:jed))
  allocate (grid_length(isd:ied,jsd:jed))

  allocate (aiso_back_obc(isd:ied,jsd:jed))
  allocate (aaniso_back_obc(isd:ied,jsd:jed))


  grid_length(:,:)    = Grd%tmask(:,:,1)*2.0*Grd%dxt(:,:)*Grd%dyt(:,:)/(epsln+Grd%dxt(:,:)+Grd%dyt(:,:))
  aiso_back(:,:,:)    = 0.0
  aaniso_back(:,:,:)  = 0.0
  aiso(:,:,:)         = 0.0
  aiso_xx(:,:,:)      = 0.0
  aiso_xy(:,:,:)      = 0.0
  aaniso_xx(:,:,:)    = 0.0
  aaniso_xy(:,:,:)    = 0.0
  horz_ten(:,:,:)     = 0.0
  horz_str(:,:,:)     = 0.0
  sin2theta(:,:,:)    = 0.0
  cos2theta(:,:,:)    = 0.0
  stress_xx(:,:,:)    = 0.0
  stress_xy(:,:,:)    = 0.0
  stress_yx(:,:,:)    = 0.0
  tmplap1(:,:,:)      = 0.0
  tmplap2(:,:,:)      = 0.0
  aiso_back_obc(:,:)  = 0.0
  aaniso_back_obc(:,:)= 0.0


  ! dimensionless ratios used for friction operator 
  dxu_dyur(:,:) = Grd%dxu(:,:)*Grd%dyur(:,:)
  dyu_dxur(:,:) = Grd%dyu(:,:)*Grd%dxur(:,:)
  dxt_dytr(:,:) = Grd%dxt(:,:)*Grd%dytr(:,:)
  dyt_dxtr(:,:) = Grd%dyt(:,:)*Grd%dxtr(:,:)


  ! smag related arrays 
  fsmag_iso(:,:)   = 0.0
  fsmag_aniso(:,:) = 0.0
  coeff_iso        = 0.125*(k_smag_iso/pi)**2
  coeff_aniso      = 0.125*(k_smag_aniso/pi)**2
  fsmag_iso(:,:)   = Grd%umask(:,:,1)*coeff_iso* &
                     ((2.0*Grd%dxu(:,:)*Grd%dyu(:,:))/(epsln + Grd%dxu(:,:) + Grd%dyu(:,:)))**4
  fsmag_aniso(:,:) = Grd%umask(:,:,1)*coeff_aniso* &
                     ((2.0*Grd%dxu(:,:)*Grd%dyu(:,:))/(epsln + Grd%dxu(:,:) + Grd%dyu(:,:)))**4


  aiso_back_obc(:,:)   = 0.0
  aaniso_back_obc(:,:) = 0.0
  do j=jsd,jed
    do i=isd,ied 
      aiso_back_obc(i,j)     = Grd%tmask(i,j,1)*vel_micom_iso* &
                               ((2.0*Grd%dxt(i,j)*Grd%dyt(i,j))/(epsln + Grd%dxt(i,j) + Grd%dyt(i,j)))**3
      aaniso_back_obc(i,j)   = Grd%tmask(i,j,1)*vel_micom_aniso* &
                               ((2.0*Grd%dxt(i,j)*Grd%dyt(i,j))/(epsln + Grd%dxt(i,j) + Grd%dyt(i,j)))**3
      if(abs(Grd%yu(i,j)) < eq_lat_micom) then
        aiso_back_obc(i,j)   = Grd%tmask(i,j,1)*eq_vel_micom_iso* &
                               ((2.0*Grd%dxt(i,j)*Grd%dyt(i,j))/(epsln + Grd%dxt(i,j) + Grd%dyt(i,j)))**3
        aaniso_back_obc(i,j) = Grd%tmask(i,j,1)*eq_vel_micom_aniso* &
                               ((2.0*Grd%dxt(i,j)*Grd%dyt(i,j))/(epsln + Grd%dxt(i,j) + Grd%dyt(i,j)))**3
      endif
    enddo  
  enddo

  aiso_back(:,:,:)    = 0.0
  aaniso_back(:,:,:)  = 0.0
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied 

           aiso_back(i,j,k)     = Grd%tmask(i,j,k)*vel_micom_iso* &
                ((2.0*Grd%dxt(i,j)*Grd%dyt(i,j))/(epsln + Grd%dxt(i,j) + Grd%dyt(i,j)))**3
           aaniso_back(i,j,k)   = Grd%tmask(i,j,k)*vel_micom_aniso* &
                ((2.0*Grd%dxt(i,j)*Grd%dyt(i,j))/(epsln + Grd%dxt(i,j) + Grd%dyt(i,j)))**3

           if(abs(Grd%yt(i,j)) < eq_lat_micom) then
               aiso_back(i,j,k)   = Grd%tmask(i,j,k)*eq_vel_micom_iso* &
                    ((2.0*Grd%dxt(i,j)*Grd%dyt(i,j))/(epsln + Grd%dxt(i,j) + Grd%dyt(i,j)))**3
               aaniso_back(i,j,k) = Grd%tmask(i,j,k)*eq_vel_micom_aniso* &
                    ((2.0*Grd%dxt(i,j)*Grd%dyt(i,j))/(epsln + Grd%dxt(i,j) + Grd%dyt(i,j)))**3
           endif

        enddo
     enddo
  enddo

  ! for computing viscosity based on horizontal divergence 
  allocate (visc_diverge(isd:ied,jsd:jed,nk))
  visc_diverge(:,:,:) = 0.0
  if(visc_diverge_scaling > 0.0) then 
      allocate (visc_diverge_factor(isd:ied,jsd:jed))
      allocate (divergence_t(isd:ied,jsd:jed,nk))
      visc_diverge_factor(:,:)= 0.0
      divergence_t(:,:,:)     = 0.0 
      write(stdoutunit,'(/a,f10.2)') &
       '==> Note from ocean_bihcgrid_friction_mod: using visc_diverge_scaling for viscosity, with a value = ',visc_diverge_scaling 
      do j=jsc,jec
         do i=isc,iec  
            visc_diverge_factor(i,j) = Grd%tmask(i,j,1)*visc_diverge_scaling* &
                                       ((2.0*Grd%dxt(i,j)*Grd%dyt(i,j))/(epsln + Grd%dxt(i,j) + Grd%dyt(i,j)))**4
         enddo
      enddo
      call mpp_update_domains (visc_diverge_factor(:,:),Dom%domain2d)    
  endif


  ! rescale the background viscosities according to NCAR boundary scaling  
  if(ncar_boundary_scaling) then 
      write(stdoutunit,'(a)') ' Note: rescaling background bih viscosities so they are larger in western boundaries.'
      if(ncar_boundary_scaling_read) then 
          call ncar_boundary_scale_read(Time) 
      else 
          call ncar_boundary_scale_create(Time)
      endif
  endif

  if (read_aiso_bih_back) then
      call read_data('INPUT/aiso_bih_back.nc','aiso_bih_back',aiso_back, Dom%domain2d)
  endif  

  ! enhance background viscosity near open boundaries if needed
  if (have_obc) then 
      call ocean_obc_enhance_visc_back(aiso_back_obc, 'bih')
      call ocean_obc_enhance_visc_back(aaniso_back_obc, 'bih')
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               if(aiso_back_obc(i,j)   > aiso_back(i,j,k))   aiso_back(i,j,k)   = aiso_back_obc(i,j)
               if(aaniso_back_obc(i,j) > aaniso_back(i,j,k)) aaniso_back(i,j,k) = aaniso_back_obc(i,j)
            enddo
         enddo
      enddo
  endif

  call compute_neptune_velocity(Time)

  ! critical value of viscosity, above which 2-dim linear stability is not satisfied.
  ! visc_crit taken from equation (18.26) of Griffies book. 
  visc_crit(:,:) = 0.0
  do j=jsc,jec
    do i=isc,iec
      dxdy = 1.0/( 1.0/(Grd%dxt(i,j)*Grd%dxt(i,j)) + 1.0/(Grd%dyt(i,j)*Grd%dyt(i,j)) )
      visc_crit(i,j) =  visc_crit_scale*oneeigth*dxdy**2/(dtime+epsln)
    enddo
  enddo

  if(use_side_drag_friction) then 
     write(stdoutunit,'(a)') '==> Note from ocean_bihcgrid_friction: using side drag friction for cells next to land.'
     allocate (tmask_next_to_land(isd:ied,jsd:jed,nk))
     tmask_next_to_land(:,:,:) = 0.0
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              tmask_next_to_land(i,j,k) = (1.0-Grd%tmask(i+1,j,k)) + (1.0-Grd%tmask(i-1,j,k)) &
                                         +(1.0-Grd%tmask(i,j+1,k)) + (1.0-Grd%tmask(i,j-1,k)) 
              tmask_next_to_land(i,j,k) = Grd%tmask(i,j,k)*min(1.0,tmask_next_to_land(i,j,k))
           enddo
        enddo
     enddo 
     id_tmask_next_to_land = register_static_field('ocean_model', 'tmask_next_to_land_bih',&
            Grd%tracer_axes(1:3),'mask for cells next to land for bihcgrid module',        &
            'dimensionless', missing_value=missing_value, range=(/-10.0,10.0/))
     call diagnose_3d(Time, Grd, id_tmask_next_to_land, tmask_next_to_land(:,:,:))
  endif 

  id_visc_crit_bih = register_static_field ('ocean_model', 'visc_crit_bih',&
                     Grd%tracer_axes(1:2), 'critical viscosity', 'm^4/sec',&
                     missing_value=missing_value, range=(/0.0,1.e20/))
  call diagnose_2d(Time, Grd, id_visc_crit_bih, visc_crit(:,:))


  ! ensure that background viscosities are not too large 
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           if(aiso_back(i,j,k)   > visc_crit(i,j))  aiso_back(i,j,k)   = visc_crit(i,j)
           if(aaniso_back(i,j,k) > visc_crit(i,j))  aaniso_back(i,j,k) = visc_crit(i,j)
        enddo
     enddo
  enddo

  ! ensure viscosities maintain proper relative values so that friction dissipates 
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           if(aaniso_back(i,j,k) >= 2.0*aiso_back(i,j,k) .and. aaniso_back(i,j,k) > 0.0)  then 
               write(stdoutunit,'(a,i4,a,i4,a,i3,a)')'Violating bih iso/aniso constraint at (',i,',',j,')'
               aaniso_back(i,j,k) = 1.9*aiso_back(i,j,k)
           endif
        enddo
     enddo
  enddo

  ! apply T-cell masking to background viscosities; needed in particular 
  ! for the case when read_aiso_back is enabled, to remove any spurious 
  ! missing values.  
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           aiso_back(i,j,k)   = aiso_back(i,j,k)*Grd%tmask(i,j,k)
           aaniso_back(i,j,k) = aaniso_back(i,j,k)*Grd%tmask(i,j,k)
        enddo
     enddo
  enddo


  call mpp_update_domains (aiso_back(:,:,:),   Dom%domain2d)    
  call mpp_update_domains (aaniso_back(:,:,:), Dom%domain2d)    


  ! diagnostic output 
  id_aiso    = register_diag_field ('ocean_model', 'aiso_bih', Grd%tracer_axes(1:3), &
               Time%model_time,'T-cell isotropic bih visc', 'm^4/sec',               &
               missing_value=-10.0, range=(/-10.0,1.e20/),                           &
               standard_name='ocean_momentum_xy_biharmonic_diffusivity')
  id_aaniso  = register_diag_field ('ocean_model', 'aaniso_bih', Grd%tracer_axes(1:3), &
               Time%model_time,'T-cell anisotropic bih visc', 'm^4/sec',               &
               missing_value=missing_value, range=(/-10.0,1.e20/))
  id_aiso_smag = register_diag_field ('ocean_model', 'aiso_bih_smag', Grd%tracer_axes(1:3), &
                 Time%model_time, 'T-cell isotropic bih visc from smag', 'm^4/sec',         &
                 missing_value=missing_value, range=(/-10.0,1.e10/))
  id_aaniso_smag = register_diag_field ('ocean_model', 'aaniso_bih_smag', Grd%tracer_axes(1:3), &
                   Time%model_time, 'T-cell anisotropic bih visc from smag', 'm^4/sec',         &
                   missing_value=missing_value, range=(/-10.0,1.e10/))
  id_along  = register_diag_field ('ocean_model', 'along_bih', Grd%tracer_axes(1:3),   &
              Time%model_time,'T-cell along-stream bih visc', 'm^4/sec',               &
              missing_value=missing_value, range=(/-10.0,1.e20/))
  id_across  = register_diag_field ('ocean_model', 'across_bih', Grd%tracer_axes(1:3), &
               Time%model_time, 'T-cell cross-stream bih visc', 'm^4/sec',             &
               missing_value=missing_value, range=(/-10.0,1.e20/))
  id_visc_diverge = register_diag_field ('ocean_model', 'visc_diverge_bih', Grd%tracer_axes(1:3),    &
               Time%model_time,'T-cell biharmonic visc based on horz_diverge_t gradients', 'm^4/sec',&
               missing_value=-10.0, range=(/-10.0,1.e20/))

  id_sin2theta = register_diag_field ('ocean_model', 'sin2theta_bih', Grd%tracer_axes(1:3),                &
              Time%model_time, 'sin2theta for orientation angle with biharmonic friction', 'dimensionless',&
              missing_value=missing_value, range=(/-10.0,10.0/))
  id_cos2theta = register_diag_field ('ocean_model', 'cos2theta_bih', Grd%tracer_axes(1:3),                &
              Time%model_time, 'cos2theta for orientation angle with biharmonic friction', 'dimensionless',&
              missing_value=missing_value, range=(/-10.0,10.0/))

  id_bih_fric_u = register_diag_field ('ocean_model', 'bih_fric_u', Grd%tracer_axes(1:3), &
                  Time%model_time, 'Thickness and rho wghtd horz bih frict on u-zonal',   &
                  '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1.e20,1.e20/))
  id_bih_fric_v = register_diag_field ('ocean_model', 'bih_fric_v', Grd%tracer_axes(1:3), &
                  Time%model_time, 'Thickness and rho wghtd horz bih frict on v-merid',   &
                  '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1.e20,1.e20/))

  id_horz_bih_diss = register_diag_field ('ocean_model', 'horz_bih_diss', Grd%tracer_axes(1:3),      &
                  Time%model_time, 'Energy dissipation from horizontal biharmonic friction', 'W/m^2',&
                  missing_value=missing_value, range=(/-1.e20,1.e20/))

  id_stress_xx_bih = register_diag_field ('ocean_model', 'stress_xx_bih', Grd%tracer_axes(1:3),   &
                  Time%model_time, 'Stress tensor xx component from biharmonic friction', 'N/m^2',&
                  missing_value=missing_value, range=(/-1.e20,1.e20/))
  id_stress_xy_bih = register_diag_field ('ocean_model', 'stress_xy_bih', Grd%vel_axes_uv(1:3),   &
                  Time%model_time, 'Stress tensor xy component from biharmonic friction', 'N/m^2',&
                  missing_value=missing_value, range=(/-1.e20,1.e20/))
  id_stress_yx_bih = register_diag_field ('ocean_model', 'stress_yx_bih', Grd%vel_axes_uv(1:3),   &
                  Time%model_time, 'Stress tensor xy component from biharmonic friction', 'N/m^2',&
                  missing_value=missing_value, range=(/-1.e20,1.e20/))

  id_aiso_back   = register_static_field('ocean_model', 'aiso_bih_back', Grd%tracer_axes(1:3),   &
                    'U-cell background aiso bih visc', 'm^4/sec',                                &
                    missing_value=missing_value, range=(/-10.0,1.e20/))
  id_aaniso_back = register_static_field('ocean_model', 'aaniso_bih_back', Grd%tracer_axes(1:3), &
                    'U-cell background aaniso bih visc', 'm^4/sec',                              &
                    missing_value=missing_value, range=(/-10.0,1.e20/))
  id_along_back   = register_static_field('ocean_model', 'along_bih_back', Grd%tracer_axes(1:3), &
                    'U-cell background along-stream bih visc', 'm^4/sec',                        &
                    missing_value=missing_value, range=(/-10.0,1.e20/))
  id_across_back = register_static_field('ocean_model', 'across_bih_back', Grd%tracer_axes(1:3), &
                   'U-cell background cross-stream bih visc', 'm^4/sec',                         &
                   missing_value=missing_value, range=(/-10.0,1.e20/))

  call diagnose_3d(Time, Grd, id_aiso_back, aiso_back(:,:,:))
  call diagnose_3d(Time, Grd, id_aaniso_back, aaniso_back(:,:,:))
  if (id_along_back > 0) then 
     call diagnose_3d(Time, Grd, id_along_back, aiso_back(:,:,:)+0.5*aaniso_back(:,:,:))
  endif 
  if (id_across_back > 0) then 
     call diagnose_3d(Time, Grd, id_across_back, aiso_back(:,:,:)-0.5*aaniso_back(:,:,:))
  endif 

end subroutine ocean_bihcgrid_friction_init
! </SUBROUTINE>  NAME="ocean_bihcgrid_friction_init"


!#######################################################################
! <SUBROUTINE NAME="bihcgrid_friction">
!
! <DESCRIPTION>
! This routine computes thickness weighted and density weighted 
! time tendency for horizontal velocity arising from horizontal 
! biharmonic friction.  
!
! The algorithm is derived from a functional approach that ensures
! kinetic energy is consistenty dissipated for all flow configurations. 
! The stencil is far simpler than the B-grid approach. In particular, 
! there are no triads here for the C-grid.  
! 
! Fundamental to the scheme are the rates of horizontal deformation 
! horizontal tension = DT = (dy)(u/dy)_x - (dx)(v/dx)_y             
! horizontal strain  = DS = (dx)(u/dx)_y + (dy)(v/dy)_x             
! Units of the tension and strain are sec^-1.
!
! As shown in Griffies and Hallberg (2000), 
! a biharmonic operator with a nonconstant viscosity is guaranteed to 
! dissipate kinetic energy *only* when using the sqrt of the biharmonic
! viscosity at each of the two stages of the algorithm. 
! The sqrt approach is employed here.  
!
! </DESCRIPTION>
!
subroutine bihcgrid_friction(Time, Thickness, Adv_vel, Velocity, bih_viscosity, energy_analysis_step)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(in)    :: Thickness
  type(ocean_adv_vel_type),   intent(in)    :: Adv_vel
  type(ocean_velocity_type),  intent(inout) :: Velocity
  logical,                    intent(in)    :: energy_analysis_step
  real, dimension(isd:,jsd:), intent(inout) :: bih_viscosity

  real :: deform, delta 
  real :: usqrd, vsqrd, umagr
  real :: uvel, vvel
  real :: uvmag, umag, vmag, velocity_gamma  
  real :: grad_diverge_sq
  real :: term1, term2 
  real :: volume 

  integer :: i, j, k, n
  integer :: taum1, tau
  integer :: stdoutunit, ibl
  stdoutunit=stdout() 

  if(.not. use_this_module) then
      if(energy_analysis_step) then 
          do n=1,2
             do k=1,nk
                do j=jsc,jec
                   do i=isc,iec
                      Velocity%wrkv(i,j,k,n) = 0.0
                   enddo
                enddo
             enddo
          enddo
      endif
    return 
  endif 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_bihcgrid_friction_mod (bihcgrid_friction): module not initialized')
  endif 

  taum1 = Time%taum1
  tau   = Time%tau



  ! divergence_t has units m/s.
  visc_diverge(:,:,:) = 0.0
  if(visc_diverge_scaling > 0.0) then 

     divergence_t(:,:,:) = 0.0
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              divergence_t(i,j,k) = rho0r*Adv_vel%diverge_t(i,j,k)
           enddo
        enddo
     enddo
     call mpp_update_domains (divergence_t(:,:,:), Dom%domain2d)    

     ! ignore offset of u,v 
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              grad_diverge_sq     = ((divergence_t(i+1,j,k)-divergence_t(i,j,k))*Grd%dxter(i,j))**2 &
                                   +((divergence_t(i,j+1,k)-divergence_t(i,j,k))*Grd%dytnr(i,j))**2 
              visc_diverge(i,j,k) = Grd%tmask(i,j,k)*visc_diverge_factor(i,j)*sqrt(grad_diverge_sq)
           enddo
        enddo
     enddo 

  endif 

  !-----------------------------------
  ! Laplacian portion of the algorithm 


  ! store velocity relative to neptune 
  wrk1_v(:,:,:,:) = 0.0
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           wrk1_v(i,j,k,1) = Velocity%u(i,j,k,1,taum1) - neptune_velocity(i,j,1)
           wrk1_v(i,j,k,2) = Velocity%u(i,j,k,2,taum1) - neptune_velocity(i,j,2)
        enddo
     enddo
  enddo

  ! compute the horizontal deformation rates (1/sec)
  ! horz_ten = (dy)(u/dy)_x - (dx)(v/dx)_y 
  !          = located at tracer points 
  ! horz_str = (dx)(u/dx)_y + (dy)(v/dy)_x
  !          = located at corner vorticity points 
  !          = zero at corner points via umask 
  horz_ten(:,:,:) = 0.0
  horz_str(:,:,:) = 0.0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           horz_ten(i,j,k) = dyt_dxtr(i,j)*(wrk1_v(i,j,k,1)  *Grd%dyter(i,j)  -wrk1_v(i-1,j,k,1)*Grd%dyter(i-1,j)) &
                            -dxt_dytr(i,j)*(wrk1_v(i,j,k,2)  *Grd%dxtnr(i,j)  -wrk1_v(i,j-1,k,2)*Grd%dxtnr(i,j-1))
           horz_str(i,j,k) = dxu_dyur(i,j)*(wrk1_v(i,j+1,k,1)*Grd%dxter(i,j+1)-wrk1_v(i,j,k,1)  *Grd%dxter(i,j))   &
                            +dyu_dxur(i,j)*(wrk1_v(i+1,j,k,2)*Grd%dytnr(i+1,j)-wrk1_v(i,j,k,2)  *Grd%dytnr(i,j))
           horz_ten(i,j,k) = horz_ten(i,j,k)*Grd%tmask(i,j,k) 
           horz_str(i,j,k) = horz_str(i,j,k)*Grd%umask(i,j,k) 
        enddo
     enddo
  enddo
  call mpp_update_domains (horz_ten(:,:,:), Dom%domain2d)    
  call mpp_update_domains (horz_str(:,:,:), Dom%domain2d)    


  ! compute viscosities according to Smagorinsky scheme 
  wrk1 = 0.0   ! aiso_xx_smag 
  wrk2 = 0.0   ! aiso_xy_smag   
  wrk3 = 0.0   ! aaniso_xx_smag
  wrk4 = 0.0   ! aaniso_xy_smag
  if(k_smag_iso > 0.0) then 
     do k=1,nk 
        do j=jsc,jec
           do i=isc,iec
              deform      = sqrt(horz_ten(i,j,k)**2 + horz_str(i,j,k)**2)
              wrk1(i,j,k) = fsmag_iso(i,j)*deform
              wrk3(i,j,k) = fsmag_aniso(i,j)*deform

              deform      = sqrt(horz_ten(i,j,k)**2 + horz_str(i+1,j+1,k)**2)
              wrk2(i,j,k) = fsmag_iso(i,j)*deform
              wrk4(i,j,k) = fsmag_aniso(i,j)*deform
           enddo
        enddo
     enddo
  endif 
  ! write diagnostics here since wrk arrays are reused later 
  if(.not. energy_analysis_step) then 
     if (id_aiso_smag > 0) then
        call diagnose_3d(Time, Grd, id_aiso_smag, onehalf*(wrk1(:,:,:)+wrk2(:,:,:)))
     endif 
     if (id_aaniso_smag > 0) then
        call diagnose_3d(Time, Grd, id_aaniso_smag, onehalf*(wrk3(:,:,:)+wrk4(:,:,:)))
     endif  
  endif 

  ! compute the full viscosities with dimension sqrt(m^4/s).
  ! take sqrt to ensure that non-constant biharmonic viscosity dissipates 
  ! (see Section 17.9.2 of Griffies book). 
  do k=1,nk 
     do j=jsc,jec
        do i=isc,iec
           aiso_xx(i,j,k)   = min(visc_crit(i,j), aiso_back(i,j,k)   + wrk1(i,j,k) + visc_diverge(i,j,k))
           aaniso_xx(i,j,k) = min(visc_crit(i,j), aaniso_back(i,j,k) + wrk3(i,j,k) + visc_diverge(i,j,k))
           aiso_xy(i,j,k)   = min(visc_crit(i,j), aiso_back(i,j,k)   + wrk2(i,j,k) + visc_diverge(i,j,k))
           aaniso_xy(i,j,k) = min(visc_crit(i,j), aaniso_back(i,j,k) + wrk4(i,j,k) + visc_diverge(i,j,k))
           aiso(i,j,k)      = aiso_xx(i,j,k)
           aiso_xx(i,j,k)   = sqrt(aiso_xx(i,j,k))
           aaniso_xx(i,j,k) = sqrt(aaniso_xx(i,j,k))
           aiso_xy(i,j,k)   = sqrt(aiso_xy(i,j,k))
           aaniso_xy(i,j,k) = sqrt(aaniso_xy(i,j,k))
        enddo
     enddo
  enddo

  ! compute orientation angle; ignore offset of u,v 
  sin2theta = 0.0  
  cos2theta = 0.0   
  do k=1,nk 
     do j=jsc,jec
        do i=isc,iec
           if(equatorial_zonal .and. abs(Grd%yt(i,j)) <= equatorial_zonal_lat) then
             sin2theta(i,j,k) = 0.0
             cos2theta(i,j,k) = 1.0
           else
             usqrd = wrk1_v(i,j,k,1)**2
             vsqrd = wrk1_v(i,j,k,2)**2
             umagr = 1.0/(epsln + usqrd + vsqrd)
             sin2theta(i,j,k) = 2.0*wrk1_v(i,j,k,1)*wrk1_v(i,j,k,2)*umagr
             cos2theta(i,j,k) = (usqrd-vsqrd)*umagr
           endif
        enddo
     enddo
  enddo


  ! compute the stress tensor components (kg/m^3)*(m^2/s^1.5)
  ! stress_xy(i,j) = 0.5*rho*
  !   [aiso_xy(i,j)*horz_str(i,j) - aaniso_xy(i,j)*cos2theta*0.5*(horz_str(i,j)*cos2theta - horz_ten(i+1,j+1)*sin2theta)]
  ! stress_xx(i,j) = rho*
  !   [aiso_xx(i,j)*horz_ten(i,j) + aaniso_xx(i,j)*sin2theta*0.5*(horz_str(i,j)*cos2theta - horz_ten(i,j)*sin2theta)] 
  ! set rho = rho0 even for non-Boussinesq 
  ! stress_yy = -stress_xx
  ! stress_xy =  stress_yx except for possible differences next to boundaries with partial slip 
  stress_xx(:,:,:) = 0.0
  stress_xy(:,:,:) = 0.0
  stress_yx(:,:,:) = 0.0
  
  ! umask applied to stress_xy corresponds to free-slip side boundaries 
  do k=1,nk 
     do j=jsc,jec
        do i=isc,iec

           ! note use of different indices for horz_ten
           delta = onehalf*(horz_str(i,j,k)*cos2theta(i,j,k)-horz_ten(i+1,j+1,k)*sin2theta(i,j,k))
           stress_xy(i,j,k) = rho0*Grd%umask(i,j,k) &
                              *(aiso_xy(i,j,k)*horz_str(i,j,k) - aaniso_xy(i,j,k)*cos2theta(i,j,k)*delta)
           stress_yx(i,j,k) = stress_xy(i,j,k) 

           delta = onehalf*(horz_str(i,j,k)*cos2theta(i,j,k)-horz_ten(i,j,k)*sin2theta(i,j,k))
           stress_xx(i,j,k) = rho0*grd%tmask(i,j,k) &
                              *(aiso_xx(i,j,k)*horz_ten(i,j,k) + aaniso_xx(i,j,k)*sin2theta(i,j,k)*delta)

        enddo
     enddo
  enddo

  ! need stress components in halos 
  call mpp_update_domains (stress_xx(:,:,:), Dom%domain2d)    
  call mpp_update_domains (stress_xy(:,:,:), Dom%domain2d)    
  call mpp_update_domains (stress_yx(:,:,:), Dom%domain2d)    


  ! compute Laplacian operator with units (kg/m^3)*(m/s^1.5)
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           term1 = Grd%dyter(i,j)*(dyt_dxtr(i+1,j)*stress_xx(i+1,j,k)-dyt_dxtr(i,j)  *stress_xx(i,j,k))  
           term2 = Grd%dxter(i,j)*(dxu_dyur(i,j)  *stress_xy(i,j,k)  -dxu_dyur(i,j-1)*stress_xy(i,j-1,k))  
           tmplap1(i,j,k) = term1 + term2

           term1 = -Grd%dxtnr(i,j)*(dxt_dytr(i,j+1)*stress_xx(i,j+1,k) - dxt_dytr(i,j)  *stress_xx(i,j,k))  
           term2 =  Grd%dytnr(i,j)*(dyu_dxur(i,j)  *stress_yx(i,j,k)   - dyu_dxur(i-1,j)*stress_yx(i-1,j,k))  
           tmplap2(i,j,k) = term1 + term2
        enddo
     enddo
  enddo
  call mpp_update_domains (tmplap1(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (tmplap2(:,:,:), Dom%domain2d, complete=.true. )    


  !-------------------------------------- 
  ! second portion of the algorithm, with velocity replaced by tmplap

  ! store laplacian operator (kg/m^3)*(m/s^1.5)
  wrk1_v(:,:,:,:) = 0.0
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           wrk1_v(i,j,k,1) = tmplap1(i,j,k)
           wrk1_v(i,j,k,2) = tmplap2(i,j,k)
        enddo
     enddo
  enddo

  ! compute the horizontal deformation rates with units (kg/m^3)*(1/s^1.5)
  horz_ten(:,:,:) = 0.0
  horz_str(:,:,:) = 0.0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           horz_ten(i,j,k) = dyt_dxtr(i,j)*(wrk1_v(i,j,k,1)  *Grd%dyter(i,j)  -wrk1_v(i-1,j,k,1)*Grd%dyter(i-1,j)) &
                            -dxt_dytr(i,j)*(wrk1_v(i,j,k,2)  *Grd%dxtnr(i,j)  -wrk1_v(i,j-1,k,2)*Grd%dxtnr(i,j-1))
           horz_str(i,j,k) = dxu_dyur(i,j)*(wrk1_v(i,j+1,k,1)*Grd%dxter(i,j+1)-wrk1_v(i,j,k,1)  *Grd%dxter(i,j))   &
                            +dyu_dxur(i,j)*(wrk1_v(i+1,j,k,2)*Grd%dytnr(i+1,j)-wrk1_v(i,j,k,2)  *Grd%dytnr(i,j))
           horz_ten(i,j,k) = horz_ten(i,j,k)*Grd%tmask(i,j,k) 
           horz_str(i,j,k) = horz_str(i,j,k)*Grd%umask(i,j,k) 
        enddo
     enddo
  enddo
  call mpp_update_domains (horz_ten(:,:,:), Dom%domain2d)    
  call mpp_update_domains (horz_str(:,:,:), Dom%domain2d)    


  ! compute the stress tensor components with units N/m^2 = (kg/m^3)*(m^2/s^2)
  ! umask applied to stress_xy corresponds to free-slip side boundaries 
  stress_xx(:,:,:) = 0.0
  stress_xy(:,:,:) = 0.0
  stress_yx(:,:,:) = 0.0
  
  do k=1,nk 
     do j=jsc,jec
        do i=isc,iec

           delta = onehalf*(horz_str(i,j,k)*cos2theta(i,j,k)-horz_ten(i+1,j+1,k)*sin2theta(i,j,k))
           stress_xy(i,j,k) = Grd%umask(i,j,k) &
                              *(aiso_xy(i,j,k)*horz_str(i,j,k) - aaniso_xy(i,j,k)*cos2theta(i,j,k)*delta)
           stress_yx(i,j,k) = stress_xy(i,j,k) 

           delta = onehalf*(horz_str(i,j,k)*cos2theta(i,j,k)-horz_ten(i,j,k)*sin2theta(i,j,k))
           stress_xx(i,j,k) = grd%tmask(i,j,k) &
                              *(aiso_xx(i,j,k)*horz_ten(i,j,k) + aaniso_xx(i,j,k)*sin2theta(i,j,k)*delta)

        enddo
     enddo
  enddo

   ! side drag law for partial slip on stress_xy and stress_yx (N/m^2)
  wrk2_v(:,:,:,:) = 0.0
  if(use_side_drag_friction) then
     do k=1,nk    
        do j=jsc,jec
           do i=isc,iec
              uvel             = Velocity%u(i,j,k,1,taum1)
              vvel             = Velocity%u(i,j,k,2,taum1)
              uvmag            = sqrt(uvel**2 + vvel**2)
              uvmag            = min(uvmag,side_drag_friction_uvmag_max)
              velocity_gamma   = rho0*side_drag_friction_scaling*Velocity%cdbot_array(i,j)*uvmag
              umag             = abs(uvel)
              vmag             = abs(vvel)
              wrk2_v(i,j,k,1)  = -min(side_drag_friction_max, velocity_gamma*umag)*sign(1.0,uvel)
              wrk2_v(i,j,k,2)  = -min(side_drag_friction_max, velocity_gamma*vmag)*sign(1.0,vvel)
              stress_xy(i,j,k) = stress_xy(i,j,k) + wrk2_v(i,j,k,1)*tmask_next_to_land(i,j,k)   
              stress_yx(i,j,k) = stress_yx(i,j,k) + wrk2_v(i,j,k,2)*tmask_next_to_land(i,j,k)   
           enddo
        enddo
     enddo
  endif 

  ! need stress components in halos 
  call mpp_update_domains (stress_xx(:,:,:), Dom%domain2d)    
  call mpp_update_domains (stress_xy(:,:,:), Dom%domain2d)    
  call mpp_update_domains (stress_yx(:,:,:), Dom%domain2d)    


  ! compute biharmonic operator with units (kg/m^3)*(m/sec^2) = N/m^2.
  ! the factor of dzt ensures proper units, and scales down friction for thin cells.  
  wrk3_v(:,:,:,:) = 0.0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           term1 = Grd%dyter(i,j)*(dyt_dxtr(i+1,j)*stress_xx(i+1,j,k)-dyt_dxtr(i,j)  *stress_xx(i,j,k))  
           term2 = Grd%dxter(i,j)*(dxu_dyur(i,j)  *stress_xy(i,j,k)  -dxu_dyur(i,j-1)*stress_xy(i,j-1,k))  
           wrk3_v(i,j,k,1) = Thickness%dzt(i,j,k)*(term1 + term2)

           term1 = -Grd%dxtnr(i,j)*(dxt_dytr(i,j+1)*stress_xx(i,j+1,k) - dxt_dytr(i,j)  *stress_xx(i,j,k))  
           term2 =  Grd%dytnr(i,j)*(dyu_dxur(i,j)  *stress_yx(i,j,k)   - dyu_dxur(i-1,j)*stress_yx(i-1,j,k))  
           wrk3_v(i,j,k,2) = Thickness%dzt(i,j,k)*(term1 + term2)
        enddo
     enddo
  enddo


  if(energy_analysis_step) then 
      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%wrkv(i,j,k,n) = wrk3_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo
      return 
  endif

  do n=1,2
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              Velocity%accel(i,j,k,n) = Velocity%accel(i,j,k,n) + wrk3_v(i,j,k,n)
           enddo
        enddo
     enddo
  enddo



  ! compute some diagnostics 

  bih_viscosity(:,:) = 0.0
  wrk1_2d(:,:)       = 0.0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1_2d(i,j) = wrk1_2d(i,j) + Thickness%rho_dzt(i,j,k,tau)
           bih_viscosity(i,j) = bih_viscosity(i,j)  &
                              + Grd%tmask(i,j,k)*Thickness%rho_dzt(i,j,k,tau)*aiso_xx(i,j,k)
           aiso_xx(i,j,k)   = aiso_xx(i,j,k)**2
           aiso_xy(i,j,k)   = aiso_xy(i,j,k)**2
           aaniso_xx(i,j,k) = aaniso_xx(i,j,k)**2
           aaniso_xy(i,j,k) = aaniso_xy(i,j,k)**2
        enddo
     enddo
  enddo


  ! for sending back to driver 
  do j=jsc,jec
     do i=isc,iec
        bih_viscosity(i,j) = Grd%tmask(i,j,1)*bih_viscosity(i,j)/(epsln+wrk1_2d(i,j))
     enddo
  enddo
  call mpp_update_domains (bih_viscosity(:,:), Dom%domain2d)    
  
  call diagnose_3d(Time, Grd, id_sin2theta, sin2theta(:,:,:))
  call diagnose_3d(Time, Grd, id_cos2theta, cos2theta(:,:,:))

   if (id_aiso > 0) then 
      wrk1(:,:,:) = onehalf*(aiso_xx(:,:,:)+aiso_xy(:,:,:))      
      call diagnose_3d(Time, Grd, id_aiso, wrk1(:,:,:))
   endif 
   if (id_aaniso > 0) then 
      wrk1(:,:,:) = onehalf*(aaniso_xx(:,:,:)+aaniso_xy(:,:,:))      
      call diagnose_3d(Time, Grd, id_aaniso, wrk1(:,:,:))
   endif 
   if (id_along > 0) then 
      wrk1(:,:,:) = onehalf*(aiso_xx(:,:,:)+aiso_xy(:,:,:) + onehalf*(aaniso_xx(:,:,:)+aaniso_xy(:,:,:)))
      call diagnose_3d(Time, Grd, id_along,  wrk1(:,:,:))
   endif 
   if (id_across > 0) then 
      wrk1(:,:,:) = onehalf*(aiso_xx(:,:,:)+aiso_xy(:,:,:) - onehalf*(aaniso_xx(:,:,:)+aaniso_xy(:,:,:)))
      call diagnose_3d(Time, Grd, id_across,  wrk1(:,:,:))
   endif 

   call diagnose_3d_u(Time, Grd, id_bih_fric_u, wrk3_v(:,:,:,1))
   call diagnose_3d_u(Time, Grd, id_bih_fric_v, wrk3_v(:,:,:,2))

   if (id_horz_bih_diss > 0) then 
      wrk1(:,:,:) = 0.0  
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               volume = Grd%tmask(i,j,k)*Grd%dat(i,j)*Thickness%dzt(i,j,k)
               wrk1(i,j,k) = wrk1(i,j,k) - rho0r*volume*(tmplap1(i,j,k)**2 + tmplap2(i,j,k))**2 
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_horz_bih_diss, wrk1(:,:,:))
   endif 

   call diagnose_3d(Time, Grd, id_stress_xx_bih, stress_xx(:,:,:))
   call diagnose_3d_u(Time, Grd, id_stress_xy_bih, stress_xy(:,:,:))
   call diagnose_3d_u(Time, Grd, id_stress_yx_bih, stress_yx(:,:,:))

   if(debug_this_module) then
      write(stdoutunit,*) ' ' 
      write(stdoutunit,*) 'From ocean_bihcgrid_friction_mod: friction chksums'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('bihcgrid friction(1)', wrk3_v(COMP,:,1)*Grd%tmask(COMP,:))
      call write_chksum_3d('bihcgrid friction(2)', wrk3_v(COMP,:,2)*Grd%tmask(COMP,:))
   endif


end subroutine bihcgrid_friction
! </SUBROUTINE> NAME="bihcgrid_friction"


!#######################################################################
! <SUBROUTINE NAME="ncar_boundary_scale_read">
!
! <DESCRIPTION>
!
! Read in the 3d ncar boundary scaling field and use this to 
! rescale the background viscosities. 
! 
! To use this routine, we need to already have generated the field
! ncar_rescale using the routine ncar_boundary_scale_create.
!
! The advantage of reading ncar_rescale is that we do not need to 
! introduce any global 2d arrays required for ncar_boundary_scale_create.     
! So the idea is to pay the price once by running ncar_boundary_scale_create,
! save ncar_rescale, then read that field in during subsequent runs through 
! ncar_boundary_scale_read.
!
! Here are the steps:
! 1/ run one time with ncar_boundary_scaling_read=.false.
! and ncar_boundary_scaling=.true. 
! Be sure that the field ncar_rescale is saved in diagnostic table.
! To ensure answers agree whether reading ncar_rescale or creating it
! during initialization, it is necessary to save ncar_rescale using the
! double precision option in the diagnostic table (packing=1). 
!
! 2/ extract field ncar_rescale from the diagnostics output
! and place into its own file INPUT/ncar_rescale.nc
! example extraction using ncks:
! ncks -v ncar_rescale 19900101.ocean_month.nc ncar_rescale.nc
!
! 3/ set ncar_boundary_scaling_read=.true. 
! and ncar_boundary_scaling=.true., and now run the model 
! reading in ncar_rescale rather than regenerating
! it during each initialization (which can be a bottleneck 
! for large models on huge processor counts).   
!
! 4/ As a check that all is fine, save ncar_rescale as a diagnostic
! for both the create and the read stage and make sure they agree.  
! Also, all checksums should agree whether reading in ncar_rescale
! or creating it each initialization, so long as the ncar_rescale.nc
! was saved with double precision  (see step 1/ above).
!
! </DESCRIPTION>
!
subroutine ncar_boundary_scale_read(Time)

  type(ocean_time_type), intent(in) :: Time

  integer :: i, j, k
  integer :: stdoutunit 
  stdoutunit=stdout() 

  ncar_rescale(:,:,:) = 0.0

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_bihcgrid_friction_mod (ncar_boundary_scale_read): module must be initialized')
  endif 

  call read_data('INPUT/ncar_rescale.nc','ncar_rescale',ncar_rescale, Dom%domain2d)

  ! rescale the background viscosities 
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           aiso_back(i,j,k)   = aiso_back(i,j,k)  *ncar_rescale(i,j,k)
           aaniso_back(i,j,k) = aaniso_back(i,j,k)*ncar_rescale(i,j,k)
        enddo
     enddo
  enddo

  id_ncar_rescale = register_static_field('ocean_model', 'ncar_rescale', Grd%tracer_axes(1:3),&
                    'rescaling used for the background viscosity', 'dimensionless',           &
                     missing_value=missing_value, range=(/-10.0,1.e10/))
  call diagnose_3d(Time, Grd, id_ncar_rescale, ncar_rescale(:,:,:))

  ! need these viscosities in the halo regions
  call mpp_update_domains (aiso_back(:,:,:),   Dom%domain2d)    
  call mpp_update_domains (aaniso_back(:,:,:), Dom%domain2d)    


end subroutine ncar_boundary_scale_read
! </SUBROUTINE>  NAME="ncar_boundary_scale_read"


!#######################################################################
! <SUBROUTINE NAME="ncar_boundary_scale_create">
!
! <DESCRIPTION>
!
!     Recale the background viscosities to be larger in the western 
!     boundary regions.  The algorithm is taken directly from the 
!     anisotropic_ncar routine in ocean_lapgen_friction.F90.
!
!   NOTE: The nearest western boundary computations are done along the
!         model i-grid lines. Therefore, viscosity based on these are 
!         only approximate in the high Northern Hemisphere when using 
!         generalized coordinates with coordinate pole(s) shifted onto 
!         land. 
!
! </DESCRIPTION>
!
subroutine ncar_boundary_scale_create(Time)

  type(ocean_time_type), intent(in) :: Time

  integer :: i, j, k
  integer :: n, ncount
  integer :: is, ie, ip1, ii
  integer :: index, indexo
  integer, dimension(nx) :: iwp
  integer, dimension(nx) :: nwbp_global

  real, dimension(nx,jsc:jec)       :: dxt_global
  real, dimension(nx,jsc:jec)       :: kmt_global
  real, dimension(isd:ied,jsd:jed)  :: kmt_tmp
  real, dimension(isd:ied,jsd:jed)  :: ncar_rescale2d
  real, dimension(nx)               :: dist_g 

  real :: dist_max
  real :: ncar_rescale_min
  real :: huge=1e20

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_bihcgrid_friction_mod (ncar_velocity_scale): module must be initialized')
  endif 

  if(ncar_boundary_scaling_read) return 

  dist_max         = 1.e10  ! distance for ACC region (cm)
  dxt_global(:,:)  = 0.0
  kmt_global(:,:)  = 0.0
  kmt_tmp(:,:)     = Grd%kmt(:,:)
  ncar_rescale(:,:,:) = 0.0
  ncar_rescale2d(:,:) = 0.0

  call mpp_global_field(Dom%domain2d,kmt_tmp,kmt_global, flags = XUPDATE)  
  call mpp_global_field(Dom%domain2d,Grd%dxt,dxt_global, flags = XUPDATE)

  do k=1,nk
     do j=jsc,jec

        ! determine nearest western boundary
        ncount         = 0
        nwbp_global(:) = 0
        iwp(:)         = 0
        dist_g(:)      = 0.0

        do i=1,Grd%ni
           ip1 = i+1
           if(i==Grd%ni) then 
               if(Grd%cyclic_x) then 
                   ip1=1
               else
                   ip1=i  
               endif
           endif
           if(kmt_global(i,j)<k .and. kmt_global(ip1,j) >= k) then 
               ncount      = ncount+1
               iwp(ncount) = i
           endif
        enddo

        if (ncount > 0) then
            do n=1,ncount-1
               is = iwp(n)
               ie = iwp(n+1)-1
               do i=is,ie
                  nwbp_global(i)=is
               enddo
            enddo
            do i=1,Grd%ni
               if(nwbp_global(i)==0) nwbp_global(i) = iwp(ncount)
            enddo
        endif


        ! determine distance (cm) to nearest western boundary
        do i=1,Grd%ni

           index  = nwbp_global(i)
           indexo = index + ncar_vconst_5
           if ( index .eq. 0) then
               dist_g(i) = dist_max
           elseif ( i .ge. index  .and.  i .le. indexo ) then
               dist_g(i) = 0.0
           elseif ( (i .gt. indexo) ) then
               dist_g(i) = dxt_global(i,j)+dist_g(i-1)
           elseif ( i .lt. index ) then
               if (indexo .le. Grd%ni) then
                   if (i .eq. 1) then
                       dist_g(i) = 0.0
                       do ii=indexo+1,Grd%ni
                          dist_g(i)=dxt_global(ii,j) + dist_g(i)
                       enddo
                       dist_g(i) = dxt_global(i,j)+dist_g(i)
                   else
                       dist_g(i) = dxt_global(i,j)+dist_g(i-1)
                   endif
               else
                   if (i .le. (indexo - Grd%ni)) then
                       dist_g(i) = 0.0
                   else
                       dist_g(i) = dxt_global(i,j)+dist_g(i-1)
                   endif
               endif
           endif

        enddo

        ! convert distance in MOM (m) to POP1.4 (cm)
        dist_g(:) = 100.0*dist_g(:)
        do i=isc,iec
           ncar_rescale(i,j,k) = Grd%tmask(i,j,k)*(1.0+exp(-(ncar_vconst_4*dist_g(i+Dom%ioff))**2))
        enddo

     enddo ! j
  enddo    ! k

  ! the only depth dependence to ncar_rescale arises from absence or presence of 
  ! topography.  so to compute the min ncar_rescale, we only need to look at k=1.  
  ! also, to avoid getting ncar_rescale=0.0 due to land, we set ncar_rescale2d
  ! to a huge number if over land. 
  do j=jsc,jec
     do i=isc,iec
        if(Grd%tmask(i,j,1)== 0.0) then 
           ncar_rescale2d(i,j) = huge
        else 
           ncar_rescale2d(i,j) = ncar_rescale(i,j,1) 
        endif 
     enddo
  enddo
  ncar_rescale_min = mpp_global_min(Dom%domain2d,ncar_rescale2d(:,:))

  ! check for error
  if(ncar_rescale_min==0.0) then
    call mpp_error(FATAL, &
    '==>Error from ocean_bihcgrid_friction_mod(ncar_boundary_scale): ncar_rescale_min=0.  Something wrong')
  else
    write(stdoutunit,'(a,e14.6)') 'From ncar_boundary_scale, minimum ncar_rescale =  ',ncar_rescale_min
  endif 

  ! rescale the background viscosities 
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           ncar_rescale(i,j,k) = (ncar_rescale(i,j,k)/ncar_rescale_min)**ncar_rescale_power
           aiso_back(i,j,k)    = aiso_back(i,j,k)  *ncar_rescale(i,j,k)
           aaniso_back(i,j,k)  = aaniso_back(i,j,k)*ncar_rescale(i,j,k)
        enddo
     enddo
  enddo

  id_ncar_rescale = register_static_field('ocean_model', 'ncar_rescale', Grd%tracer_axes(1:3),&
                    'rescaling used for the background viscosity', 'dimensionless',           &
                     missing_value=missing_value, range=(/-10.0,1.e10/))
  call diagnose_3d(Time, Grd, id_ncar_rescale, ncar_rescale(:,:,:))

  ! need these viscosities in the halo regions
  call mpp_update_domains (aiso_back(:,:,:),   Dom%domain2d)    
  call mpp_update_domains (aaniso_back(:,:,:), Dom%domain2d)    


end subroutine ncar_boundary_scale_create
! </SUBROUTINE>  NAME="ncar_boundary_scale_create"



!#######################################################################
! <SUBROUTINE NAME="bihcgrid_viscosity_check">
!
! <DESCRIPTION>
! Subroutine to perform linear stability check for the biharmonic
! operator given a value for the horizontal biharmonic viscosity.
! </DESCRIPTION>
!
subroutine bihcgrid_viscosity_check

  integer :: num, i, j, k
  integer, save :: unit=6, max_num=3
  real :: fudge

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, '==>Error from ocean_bihcgrid_friction_mod (bihcgrid_viscosity_check): needs initialization')
  endif 

  fudge=1.001  ! to eliminate roundoffs causing aiso=visc_crit+epsln

  write (stdoutunit,'(//60x,a/)') ' Excessive horizontal biharmonic friction summary:'
  write (stdoutunit,'(1x,a/)')'Locations (if any) where viscosity exceeds conservative linear stability constraint'
  num = 0
  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        if (Grd%tmask(i,j,k) > 0.0) then            
          if (aiso(i,j,k) > fudge*visc_crit(i,j) .and. num < max_num ) then
            num = num + 1
            write (unit,9600) 'aiso(',aiso(i,j,k), visc_crit(i,j),i,j,k,Grd%xt(i,j),Grd%yt(i,j),Grd%zt(k),mpp_pe()
          endif
        endif 
      enddo
    enddo
  enddo
  call mpp_sum (num)
  if (num > max_num) write (stdoutunit,*) ' (a max of ',max_num,' violations per pe are listed)'

9600  format(/' Warning: ',a,es16.8,' m^4/s) exceeds max value (',es16.8,') at (i,j,k) = ','(',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.0,'m, pe=',i3,')')


end subroutine bihcgrid_viscosity_check
! </SUBROUTINE> NAME="bihcgrid_viscosity_check"


!#######################################################################
! <SUBROUTINE NAME="bihcgrid_reynolds_check">
!
! <DESCRIPTION>
! Subroutine to compute the biharmonic grid Reynolds number.  Large 
! Reynolds numbers indicate regions where solution may experience 
! some grid noise due to lack of enough horizontal friction. 
! </DESCRIPTION>
!
subroutine bihcgrid_reynolds_check(Time, Velocity)

  type(ocean_time_type),     intent(in) :: Time
  type(ocean_velocity_type), intent(in) :: Velocity

  real :: rame, ramn, reyx, reyy
  real :: reynx0, reyny0, reynx,reyny, reynu,reynv, reynmu,reynmv
  integer :: ireynx,jreynx,kreynx, ireyny,jreyny,kreyny
  integer :: i, j, k, tau
  integer, save :: unit=6

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, '==>Error from ocean_bihcgrid_friction_mod (gen_bih_reynolds_check): nees to be initialized')
  endif 

  if(.not. use_this_module) return 

  tau = Time%tau

  ! look for max grid reynolds numbers using velocities at "tau".

  ireynx=isc; jreynx=jsc; kreynx=1; reynx=0.0
  ireyny=isc; jreyny=jsc; kreyny=1; reyny=0.0
  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        rame = 1.0/(aiso(i,j,k) + epsln)
        ramn = 1.0/(aiso(i,j,k) + epsln)

        reyx = abs(Velocity%u(i,j,k,1,tau)*Grd%dxt(i,j)**3)*rame
        if (reyx > reynx) then
          ireynx = i
          jreynx = j
          kreynx = k
          reynx  = reyx
          reynu  = Velocity%u(i,j,k,1,tau)
          reynmu = 1.0/rame
        endif
        reyy = abs(Velocity%u(i,j,k,2,tau)*Grd%dyt(i,j)**3)*ramn
        if (reyy > reyny) then
          ireyny = i
          jreyny = j
          kreyny = k
          reyny  = reyy
          reynv  = Velocity%u(i,j,k,2,tau)
          reynmv = 1.0/ramn
        endif

      enddo
    enddo
  enddo
  write (stdoutunit,'(/60x,a/)') ' Horizontal biharmonic Reynolds number summary'

  reynx0 = reynx
  reyny0 = reyny
  call mpp_max(reynx)
  call mpp_max(reyny)
  
  if (reynx == reynx0) then
    write (unit,10300) reynx, ireynx, jreynx, kreynx, &
                       Grd%xt(ireynx,jreynx), Grd%yt(ireynx,jreynx), Grd%zt(kreynx), reynu, reynmu
  endif
  
  if (reyny == reyny0) then
    write (unit,10400) reyny, ireyny, jreyny, kreyny, &
                       Grd%xt(ireyny,jreyny), Grd%yt(ireyny,jreyny), Grd%zt(kreyny), reynv, reynmv
  endif

  10300 format (1x,'Maximum zonal Re =',es9.2,' at (i,j,k) = (',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.2,'), U =',es9.2, ', mix =',e9.2)
  10400 format (1x,'Maximum merid Re =',es9.2,' at (i,j,k) = (',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.2,'), V =',es9.2, ', mix =',e9.2)


end subroutine bihcgrid_reynolds_check
! </SUBROUTINE> NAME="bihcgrid_reynolds_check"


!#######################################################################
! <SUBROUTINE NAME="compute_neptune_velocity">
!
! <DESCRIPTION>
! Compute Neptune velocity.  
!
! Method follows that of 
! Maltrud and Holloway, 2008: Implementing biharmonic neptune in a 
! global eddying ocean model, Ocean Modelling, vol. 21, pages 22-34. 
!
! This approach is slightly different than the Eby and Holloway
! method implemented in the laplacian module. There is no fundamental
! reason to favor one versus the other.  We use the Maltrud and 
! Holloway method here sinc they implemented it for biharmonic. 
!
! May 2012
! Stephen.Griffies 
!
! </DESCRIPTION>
!
subroutine compute_neptune_velocity(Time)

  type(ocean_time_type), intent(in) :: Time

  real, dimension(isd:ied,jsd:jed)  :: dhu_dx
  real, dimension(isd:ied,jsd:jed)  :: dhu_dy
  real, dimension(isd:ied,jsd:jed)  :: neptune_length
  real                              :: active_cells_u
  real                              :: active_cells_v
  integer                           :: i,j,k
  integer                           :: num_smooth

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_bihcgrid_friction_mod (compute_neptune_velocity): needs initialization')
  endif 

  allocate (neptune_velocity(isd:ied,jsd:jed,2))
  neptune_velocity = 0.0
  if(.not. neptune) return 

  ! length scale on U-cell point 
  neptune_length(:,:) = 0.0
  do j=jsd,jed
    do i=isd,ied
      neptune_length(i,j) = neptune_scaling                                        &
        *( neptune_length_pole                                                     &
      + 0.5*(neptune_length_eq-neptune_length_pole)*(1.0 + cos(2.0*Grd%phiu(i,j))) &
         )
    enddo
  enddo

  ! gradient of U-cell bottom depth 
  do j=jsc,jec
     do i=isc,iec
        dhu_dx(i,j) = (Grd%hu(i,j)-Grd%hu(i-1,j))*Grd%dxuer(i-1,j)    ! positioned at v(i,j)
        dhu_dy(i,j) = (Grd%hu(i,j)-Grd%hu(i,j-1))*Grd%dyunr(i-1,j)    ! positioned at u(i,j)
     enddo
  enddo

  ! computed neptune velocity 
  do j=jsc,jec
     do i=isc,iec
        neptune_velocity(i,j,1) = -Grd%f(i,j)*neptune_length(i,j)*neptune_length(i,j) &
                                   *dhu_dy(i,j)*Grd%tmasken(i,j,1,1)/(neptune_depth_min+Grd%hu(i,j))
        neptune_velocity(i,j,2) =  Grd%f(i,j)*neptune_length(i,j)*neptune_length(i,j) &
                                   *dhu_dx(i,j)*Grd%tmasken(i,j,1,2)/(neptune_depth_min+Grd%hu(i,j))
     enddo
  enddo
  call mpp_update_domains(neptune_velocity(:,:,1), neptune_velocity(:,:,2),&
                          Dom%domain2d,gridtype=CGRID_NE)


  ! optional smoothing
  if(neptune_smooth) then 
      do num_smooth=1,neptune_smooth_num

         wrk1_v2d(:,:,:) = 0.0
         k=1
         do j=jsc,jec
            do i=isc,iec

               if(Grd%tmask(i,j,k)==1.0) then 

                   active_cells_u = 4.0         +&
                        Grd%tmasken(i-1,j,k,1)  +&
                        Grd%tmasken(i+1,j,k,1)  +&
                        Grd%tmasken(i,j-1,k,1)  +&
                        Grd%tmasken(i,j+1,k,1)

                   active_cells_v = 4.0         +&
                        Grd%tmasken(i-1,j,k,2)  +&
                        Grd%tmasken(i+1,j,k,2)  +&
                        Grd%tmasken(i,j-1,k,2)  +&
                        Grd%tmasken(i,j+1,k,2)

                   if (active_cells_u > 4.0) then
                       wrk1_v2d(i,j,1) =                  &  
                         (4.0*neptune_velocity(i,j,1)    +&
                              neptune_velocity(i-1,j,1)  +&
                              neptune_velocity(i+1,j,1)  +&
                              neptune_velocity(i,j-1,1)  +&
                              neptune_velocity(i,j+1,1)) / active_cells_u
                   else
                       wrk1_v2d(i,j,1) = neptune_velocity(i,j,1)
                   endif 

                   if (active_cells_v > 4.0) then
                       wrk1_v2d(i,j,2) =                    &  
                         (4.0*neptune_velocity(i,j,2)      +&
                              neptune_velocity(i-1,j,2)    +&
                              neptune_velocity(i+1,j,2)    +&
                              neptune_velocity(i,j-1,2)    +&
                              neptune_velocity(i,j+1,2)) / active_cells_v
                   else
                       wrk1_v2d(i,j,2) = neptune_velocity(i,j,2)
                   endif

               endif

            enddo
         enddo

         do j=jsc,jec
            do i=isc,iec
               neptune_velocity(i,j,1) = wrk1_v2d(i,j,1)*Grd%tmasken(i,j,k,1)
               neptune_velocity(i,j,2) = wrk1_v2d(i,j,2)*Grd%tmasken(i,j,k,2)
            enddo
         enddo

         call mpp_update_domains(neptune_velocity(:,:,1), neptune_velocity(:,:,2),&
                                 Dom%domain2d,gridtype=CGRID_NE)

      enddo  ! enddo for number of smoothing iterations 
  endif      ! endif for smooth



  ! diagnostics 
  id_neptune_bih_u = register_static_field('ocean_model', 'neptune_bih_u',                &
                   Grd%tracer_axes(1:2), 'Zonal velocity from neptune biharmonic scheme', &
                   'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  call diagnose_2d(Time, Grd, id_neptune_bih_u, neptune_velocity(:,:,1))

  id_neptune_bih_v = register_static_field('ocean_model', 'neptune_bih_v',                     &
                   Grd%tracer_axes(1:2), 'Meridional velocity from neptune biharmonic scheme', &
                   'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  call diagnose_2d(Time, Grd, id_neptune_bih_v, neptune_velocity(:,:,2))


end subroutine compute_neptune_velocity
! </SUBROUTINE> NAME="compute_neptune_velocity"



end module ocean_bihcgrid_friction_mod
      
      

module ocean_nphysics_mod
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<REVIEWER EMAIL="tim.leslie@gmail.com"> Tim Leslie
!</REVIEWER>
!  
!<OVERVIEW>
!  
! Driver for ocean neutral physics.
!</OVERVIEW>
!
!<DESCRIPTION>
! Driver for ocean neutral physics.
!</DESCRIPTION>
!
!<NAMELIST NAME="ocean_nphysics_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. 
!  Default use_this_module=.false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For printing starting and ending checksums for restarts
!  Default debug_this_module=.false.
!  </DATA> 
!  <DATA NAME="write_a_restart" TYPE="logical">
!  Set true to write a restart.  False setting only for rare 
!  cases where wish to benchmark model without measuring the cost
!  of writing restarts and associated chksums.  
!  Default is write_a_restart=.true. 
!  </DATA> 
!
!  <DATA NAME="use_nphysicsA" TYPE="logical">
!  For using the nphysicsA method of neutral physics, based on that 
!  developed in MOM4.0.  This scheme is more robust and recommended for 
!  general use.  Default use_nphysicsA=.true. 
!  </DATA> 
!  <DATA NAME="use_nphysicsB" TYPE="logical">
!  For using the nphysicsB method of neutral physics.  This method is 
!  experimental, and is not recommended for general use.
!  Default use_nphysicsB=.false. 
!  </DATA> 
!  <DATA NAME="use_nphysicsC" TYPE="logical">
!  For using the nphysicsC method of neutral physics.  This method is 
!  experimental, and is not recommended for general use.  
!  Default use_nphysicsC=.false. 
!  </DATA> 
!
!</NAMELIST>

use constants_mod,    only: epsln, pi
use diag_manager_mod, only: register_diag_field
use fms_mod,          only: FATAL, WARNING, NOTE
use fms_mod,          only: file_exist
use fms_mod,          only: open_namelist_file, check_nml_error, close_file, write_version_number
use mpp_mod,          only: input_nml_file, mpp_error, stdout, stdlog
use mpp_domains_mod,  only: mpp_update_domains

use ocean_domains_mod,       only: get_local_indices
use ocean_nphysics_util_mod, only: ocean_nphysics_util_init
use ocean_nphysicsA_mod,     only: ocean_nphysicsA_init, ocean_nphysicsA_end, nphysicsA
use ocean_nphysicsA_mod,     only: ocean_nphysicsA_restart
use ocean_nphysicsB_mod,     only: ocean_nphysicsB_init, ocean_nphysicsB_end, nphysicsB
use ocean_nphysicsB_mod,     only: ocean_nphysicsB_restart
use ocean_nphysicsC_mod,     only: ocean_nphysicsC_init, ocean_nphysicsC_end, nphysicsC
use ocean_nphysicsC_mod,     only: ocean_nphysicsC_restart
use ocean_parameters_mod,    only: TERRAIN_FOLLOWING, missing_value, onefourth, grav, rho0r
use ocean_types_mod,         only: ocean_grid_type, ocean_domain_type
use ocean_types_mod,         only: ocean_prog_tracer_type, ocean_thickness_type, ocean_density_type
use ocean_types_mod,         only: ocean_time_type, ocean_time_steps_type, ocean_options_type
use ocean_util_mod,          only: write_note, write_warning


implicit none

public ocean_nphysics_init
public ocean_nphysics_end
public neutral_physics 
public ocean_nphysics_restart

private 

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()

logical :: used

logical :: use_nphysicsA     = .true.   
logical :: use_nphysicsB     = .false.   
logical :: use_nphysicsC     = .false.   
logical :: use_this_module   = .false.
logical :: debug_this_module = .false.
logical :: write_a_restart   = .true. 

#include <ocean_memory.h>

character(len=128) :: version=&
     '$Id: ocean_nphysics.F90,v 20.0 2013/12/14 00:14:34 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

character(len=*), parameter :: FILENAME=&
     __FILE__

logical :: module_is_initialized = .FALSE.

namelist /ocean_nphysics_nml/ use_this_module, debug_this_module, write_a_restart, &
                              use_nphysicsA, use_nphysicsB, use_nphysicsC

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_nphysics_init">
!
! <DESCRIPTION>
! Initialize the neutral physics module. 
! </DESCRIPTION>
!
subroutine ocean_nphysics_init(Grid, Domain, Time, Time_steps, Thickness, Dens, T_prog,    &
                               Ocean_options, vert_coordinate_type, vert_coordinate_class, &
                               cmip_units, debug)

  type(ocean_grid_type),        intent(in), target   :: Grid
  type(ocean_domain_type),      intent(in), target   :: Domain
  type(ocean_time_type),        intent(in)           :: Time
  type(ocean_time_steps_type),  intent(in)           :: Time_steps
  type(ocean_thickness_type),   intent(in)           :: Thickness
  type(ocean_density_type),     intent(in)           :: Dens
  type(ocean_prog_tracer_type), intent(inout)        :: T_prog(:)
  type(ocean_options_type),     intent(inout)        :: Ocean_options
  integer,                      intent(in)           :: vert_coordinate_type
  integer,                      intent(in)           :: vert_coordinate_class
  logical,                      intent(in)           :: cmip_units
  logical,                      intent(in), optional :: debug

  integer :: ioun, io_status, ierr  
  integer :: num_schemes 
  real    :: agm_closure_lower_depth
  real    :: agm_closure_upper_depth
  real    :: agm_closure_buoy_freq
  real    :: smax 
  real    :: swidth 
 
  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  
  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_nphysics_mod (ocean_nphysics_init):already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  Dom => Domain
  Grd => Grid

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_nphysics_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_nphysics_nml')
#else
  ioun =  open_namelist_file()
  read (ioun,ocean_nphysics_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_nphysics_nml')
  call close_file (ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_nphysics_nml)  
  write (stdlogunit,ocean_nphysics_nml)

  if(use_this_module) then 
     call write_note(FILENAME,&
     'USING ocean_nphysics_mod.')
    if(vert_coordinate_type==TERRAIN_FOLLOWING) then 
       call mpp_error(WARNING, &
            '==>Warning: ocean_nphysics is NOT supported with TERRRAIN_FOLLOWING vertical coordinates.')
    endif
  else 
     call write_note(FILENAME,&
     'NOT using ocean_nphysics_mod.')
     Ocean_options%neutral_physics = 'Did NOT use neutral physics option.'
     return
  endif 

  if (PRESENT(debug) .and. .not. debug_this_module) then
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
     call write_note(FILENAME,&
     'running ocean_nphysics_mod with debug_this_module=.true.')
  endif

  if(.not. write_a_restart) then
     call write_warning(FILENAME,&
     'NO restart written.')
  endif 

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  nk = Grid%nk
#endif

  call ocean_nphysics_util_init(Grid, Domain, Time, Time_steps, Dens, T_prog,  &
       agm_closure_lower_depth, agm_closure_upper_depth, agm_closure_buoy_freq,&
       smax, swidth, cmip_units, debug)

  num_schemes=0
  if(use_nphysicsA) then 
    num_schemes = num_schemes+1
    call write_note(FILENAME,&
    'USING ocean_nphysicsA.')
    Ocean_options%neutral_physics = 'Used neutral physics with nphysicsA algorithm.'
    call ocean_nphysicsA_init(Grid, Domain, Time, Time_steps, Thickness, Dens, T_prog,&
         vert_coordinate_class, agm_closure_lower_depth, agm_closure_upper_depth,     &
         smax, swidth, cmip_units, debug)

  elseif(use_nphysicsB) then 
    num_schemes = num_schemes+1
    call write_note(FILENAME,&
    'USING ocean_nphysicsB.')
    Ocean_options%neutral_physics = 'Used neutral physics with nphysicsB algorithm.'
    call ocean_nphysicsB_init(Grid, Domain, Time, Time_steps, Thickness, Dens, T_prog,&
         vert_coordinate_class, agm_closure_lower_depth, agm_closure_upper_depth,     &
         smax, swidth, cmip_units, debug)

  elseif(use_nphysicsC) then 
    num_schemes = num_schemes+1
    call write_note(FILENAME,&
    'USING ocean_nphysicsC.')
    Ocean_options%neutral_physics = 'Used neutral physics with nphysicsC algorithm.'
    call ocean_nphysicsC_init(Grid, Domain, Time, Time_steps, Thickness, Dens, T_prog,&
         vert_coordinate_class, agm_closure_lower_depth, agm_closure_upper_depth,     & 
         smax, swidth, cmip_units, debug)
  endif 

  if(num_schemes > 1) then 
     call mpp_error(FATAL,  &
    '==>ocean_nphysics_mod: Can only enable one of the nphysics schemes: A, B, or C.')
  endif
  if(num_schemes==0) then 
     call write_warning(FILENAME,&
     'no nphysics scheme enabled. Choose one of nphysicsA, nphysicsB, or nphysicsC.')
  endif


end subroutine ocean_nphysics_init
! </SUBROUTINE>  NAME="ocean_nphysics_init"


!#######################################################################
! <SUBROUTINE NAME="neutral_physics">
! <DESCRIPTION>
!
! Call the relevant neutral physics scheme.
!
! </DESCRIPTION>
!
!
subroutine neutral_physics (Time, Thickness, Dens, rho, T_prog, &
               gm_diffusivity, surf_blthick, rossby_radius_raw)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_density_type),       intent(in)    :: Dens
  real, dimension(isd:,jsd:,:),   intent(in)    :: rho
  type(ocean_prog_tracer_type),   intent(inout) :: T_prog(:)
  real, dimension(isd:,jsd:),     intent(in)    :: surf_blthick
  real, dimension(isd:,jsd:,:),   intent(inout) :: gm_diffusivity
  real, dimension(isd:,jsd:),     intent(inout) :: rossby_radius_raw

  if (.not. use_this_module) return

  if ( .not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_nphysics (neutral_physics): needs initialization')
  endif 

  if(use_nphysicsA) then 
      call nphysicsA(Time, Thickness, Dens, rho, T_prog, &
           surf_blthick, gm_diffusivity, rossby_radius_raw)
  elseif(use_nphysicsB) then 
      call nphysicsB(Time, Thickness, Dens, rho, T_prog, &
           surf_blthick, gm_diffusivity, rossby_radius_raw)
  elseif(use_nphysicsC) then 
      call nphysicsC(Time, Thickness, Dens, rho, T_prog, &
           surf_blthick, gm_diffusivity, rossby_radius_raw)
  endif

end subroutine neutral_physics
! </SUBROUTINE> NAME="neutral_physics"


!#######################################################################
! <SUBROUTINE NAME="ocean_nphysics_restart">
!
! <DESCRIPTION>
! Write to restart.
! </DESCRIPTION>
!
subroutine ocean_nphysics_restart(time_stamp)
  character(len=*), intent(in), optional :: time_stamp

  if(.not. use_this_module) return

  if(use_nphysicsA) then 
     call ocean_nphysicsA_restart(time_stamp)
  endif 
  if(use_nphysicsB) then 
     call ocean_nphysicsB_restart(time_stamp)
  endif 
  if(use_nphysicsC) then 
     call ocean_nphysicsC_restart(time_stamp)
  endif   

end subroutine ocean_nphysics_restart
! </SUBROUTINE> NAME="ocean_nphysics_restart"



!#######################################################################
! <SUBROUTINE NAME="ocean_nphysics_end">
!
! <DESCRIPTION>
! Write to restart.
! </DESCRIPTION>
!
subroutine ocean_nphysics_end(Time)

  type(ocean_time_type), intent(in) :: Time
  
  if(.not. use_this_module) return

  if (.not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_nphysics (ocean_nphysics_end): needs initialization')
  endif 

  if(.not. write_a_restart) then
     call write_warning(FILENAME,&
     'NO restart written.')
     return 
  endif 

  call ocean_nphysics_restart

  if(use_nphysicsA) then 
     call ocean_nphysicsA_end(Time)
  endif 
  if(use_nphysicsB) then 
     call ocean_nphysicsB_end(Time)
  endif 
  if(use_nphysicsC) then 
     call ocean_nphysicsC_end(Time)
  endif 

end subroutine ocean_nphysics_end
! </SUBROUTINE> NAME="ocean_nphysics_end"


end module ocean_nphysics_mod

module sphum_mod

use constants_mod,      only: rdgas, rvgas
use sat_vapor_pres_mod, only: escomp

implicit none 
private

public :: qscomp

! ==== module constants ======================================================
character(len=*), private, parameter :: &
   version = '$Id: sphum.F90,v 20.0 2013/12/13 23:30:34 fms Exp $', &
   tagname = '$Name: tikal $' ,&
   module_name = 'vegn'
real, parameter :: d622 = rdgas/rvgas
real, parameter :: d378 = 1.0-d622
real, parameter :: del_temp = 0.1 ! temperature increment for q_sat derivative calc.

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

subroutine qscomp(T, p, qsat, DqsatDT )
  real, intent(in) :: T    ! temperature
  real, intent(in) :: p    ! pressure
  real, intent(out):: qsat ! saturated specific humidity
  real, intent(out), optional :: DqsatDT ! deriv of specific humidity w.r.t. T

  real :: esat ! sat. water vapor pressure

  if(120.0<T.and.T<373.0) then
     continue
  else
     write(*,'(a,g23.16)')'temperature out of range',T
  endif
  ! calculate saturated specific humidity
  call escomp(T,esat)
  qsat = d622*esat /(p-d378*esat )

  ! if requested, calculate the derivative of qsat w.r.t. temperature
  if (present(DqsatDT)) then
     call escomp(T+del_temp,esat)
     DqsatDT = (d622*esat/(p-d378*esat)-qsat)/del_temp 
  endif
end subroutine qscomp

end module sphum_mod

module ocean_bih_friction_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! This module calls the appropriate lateral biharmonic friction modules. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module serves as an interface to the chosen lateral 
! biharmonic friction modules.  
!</DESCRIPTION>
!
! <INFO>
!
! <NOTE>
! The model can generally run with both Laplacian and biharmonic friction
! enabled at the same time.  Such has been found useful for some eddying 
! ocean simulations. 
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_bih_friction_nml">
! <DATA NAME="bih_friction_scheme" TYPE="character">
! To determine the biharmonic friction scheme: "const" or "general"
! </DATA> 
!
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging.  
!  </DATA> 
!
!  <DATA NAME="write_a_restart" TYPE="logical">
!  Set true to write a restart.  False setting only for rare 
!  cases where wish to benchmark model without measuring the cost
!  of writing restarts and associated chksums.  
!  Default is write_a_restart=.true. 
!  </DATA> 
!</NAMELIST>

use constants_mod,    only: epsln
use diag_manager_mod, only: register_diag_field
use fms_mod,          only: open_namelist_file, check_nml_error, write_version_number, close_file
use fms_mod,          only: FATAL, WARNING, stdout, stdlog
use fms_mod,          only: file_exist
use fms_io_mod,       only: register_restart_field, save_restart, restore_state
use fms_io_mod,       only: restart_file_type
use mpp_domains_mod,  only: mpp_update_domains
use mpp_mod,          only: input_nml_file, mpp_clock_id, mpp_clock_begin, mpp_clock_end, CLOCK_MODULE
use mpp_mod,          only: mpp_error

use ocean_bihcgrid_friction_mod, only: ocean_bihcgrid_friction_init, bihcgrid_friction
use ocean_bihcgrid_friction_mod, only: bihcgrid_viscosity_check, bihcgrid_reynolds_check
use ocean_bihcst_friction_mod,   only: ocean_bihcst_friction_init, bihcst_friction
use ocean_bihcst_friction_mod,   only: bihcst_viscosity_check, bihcst_reynolds_check
use ocean_bihgen_friction_mod,   only: ocean_bihgen_friction_init, bihgen_friction
use ocean_bihgen_friction_mod,   only: bihgen_viscosity_check, bihgen_reynolds_check
use ocean_domains_mod,           only: get_local_indices
use ocean_operators_mod,         only: BAX, BAY, BDX_EU, BDY_NU, FDX_U, FDY_U, FMX, FMY
use ocean_parameters_mod,        only: missing_value, MOM_BGRID, MOM_CGRID
use ocean_types_mod,             only: ocean_time_type, ocean_grid_type
use ocean_types_mod,             only: ocean_domain_type, ocean_adv_vel_type
use ocean_types_mod,             only: ocean_thickness_type, ocean_velocity_type
use ocean_types_mod,             only: ocean_options_type 
use ocean_util_mod,              only: write_timestamp, diagnose_2d_u, write_chksum_2d

implicit none

private

public ocean_bih_friction_init
public ocean_bih_friction_end
public bih_friction 
public bih_viscosity_check
public bih_reynolds_check
public bih_friction_barotropic
public ocean_bih_friction_restart

! for choosing the mixing scheme
character(len=10) :: bih_friction_scheme='general'  ! 'const' or 'general'
integer           :: MIX_SCHEME         = 2         ! 1=const, 2=general, 3=cgrid 
logical           :: debug_this_module  = .false.

! for deciding whether we are using biharmonic friction 
logical :: use_bihcst_friction  =.false. 
logical :: use_bihgen_friction  =.false. 
logical :: use_bihcgrid_friction=.false. 
logical :: use_this_module      =.false. 

! vertically averaged viscosity on east and north face of U cells (m^4/s)
real, dimension(:,:),   allocatable :: bih_viscosity
real, dimension(:,:),   allocatable :: bih_visc_ceu
real, dimension(:,:),   allocatable :: bih_visc_cnu
real, dimension(:,:,:), allocatable :: del2_vel

! for diagnostics 
integer :: id_bih_viscosity=-1 
logical :: used

! for Bgrid or Cgrid
integer :: horz_grid

! for clocks
integer :: id_clock_bihcst
integer :: id_clock_bihgen
integer :: id_clock_bihcgrid 

! for restart
type(restart_file_type), save :: Bih_restart

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()

integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk

character(len=256) :: version=&
     '=>Using: ocean_bih_friction.f90 ($Id: ocean_bih_friction.F90,v 20.0 2013/12/14 00:14:08 fms Exp $)'
character (len=128) :: tagname = &
     '$Name: tikal $'

logical :: module_is_initialized = .false.
logical :: write_a_restart       = .true.

namelist /ocean_bih_friction_nml/ bih_friction_scheme, debug_this_module, write_a_restart

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_bih_friction_init">
!
! <DESCRIPTION>
! Initialize the horizontal biharmonic friction module.
! </DESCRIPTION>
!
subroutine ocean_bih_friction_init(Grid, Domain, Time, Ocean_options, dtime, obc, hor_grid, debug)

  type(ocean_grid_type),   target, intent(in)    :: Grid
  type(ocean_domain_type), target, intent(in)    :: Domain
  type(ocean_time_type),           intent(in)    :: Time
  type(ocean_options_type),        intent(inout) :: Ocean_options
  real,                            intent(in)    :: dtime
  logical,                         intent(in)    :: obc
  integer,                         intent(in)    :: hor_grid
  logical,               optional, intent(in)    :: debug

  integer :: ioun, io_status, ierr
  integer :: num_methods=0 
  integer :: id_restart

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_bih_friction_mod (ocean_bih_friction_init): already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_bih_friction_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_bih_friction_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_bih_friction_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_bih_friction_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_bih_friction_nml)  
  write (stdlogunit,ocean_bih_friction_nml)

  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk

  Grd => Grid
  Dom => Domain
  horz_grid = hor_grid 

  if (PRESENT(debug) .and. .not. debug_this_module) then 
    debug_this_module = debug
  endif 

  ! for clocks 
  id_clock_bihcst   = mpp_clock_id('(Ocean const   bih frict) ' ,grain=CLOCK_MODULE)
  id_clock_bihgen   = mpp_clock_id('(Ocean general bih frict) ' ,grain=CLOCK_MODULE)
  id_clock_bihcgrid = mpp_clock_id('(Ocean c-grid  bih frict) ' ,grain=CLOCK_MODULE)

  ! vertically averaged vicsosities 
  allocate (bih_viscosity(isd:ied,jsd:jed))
  allocate (bih_visc_ceu(isd:ied,jsd:jed))
  allocate (bih_visc_cnu(isd:ied,jsd:jed))
  allocate (del2_vel(isd:ied,jsd:jed,2))
  bih_viscosity(:,:) = 0.0
  bih_visc_ceu(:,:)  = 0.0
  bih_visc_cnu(:,:)  = 0.0
  del2_vel(:,:,:)    = 0.0

  ! initialize biharmonic friction scheme
  if(bih_friction_scheme == 'const' .and. horz_grid == MOM_BGRID) then 
      num_methods=num_methods+1
      write(stdoutunit,'(a)') &
      '==>Note from ocean_bih_friction_init: constant biharmonic friction scheme for B-grid is used.'
      MIX_SCHEME=1
      call ocean_bihcst_friction_init (Grid, Domain, Time, Ocean_options, dtime, &
                                       obc, use_bihcst_friction, debug_this_module)

  elseif(bih_friction_scheme == 'general' .and. horz_grid == MOM_BGRID) then 
      num_methods=num_methods+1
      write(stdoutunit,'(a)') &
      '==>Note from ocean_bih_friction_init: general biharmonic friction scheme for B-grid is used.'
      MIX_SCHEME=2
      call ocean_bihgen_friction_init (Grid, Domain, Time, Ocean_options, dtime, &
                                       obc, use_bihgen_friction, debug_this_module)

  elseif(horz_grid == MOM_CGRID) then 
      num_methods=num_methods+1
      write(stdoutunit,'(a)') &
      '==>Note from ocean_bih_friction_init: C-grid biharmonic friction scheme is used.'
      MIX_SCHEME=3
      call ocean_bihcgrid_friction_init (Grid, Domain, Time, Ocean_options, dtime, &
                                         obc, use_bihcgrid_friction, debug_this_module)

  endif

  if(num_methods==0) then 
      write(stdoutunit,'(a)') &
      '==>Error: ocean_bih_friction_mod: pick a biharmonic friction scheme.'
      call mpp_error(FATAL,&
      '==>Error: ocean_bih_friction_mod: pick a biharmonic friction scheme.')
  elseif(num_methods>1) then 
      write(stdoutunit,'(a)')&
      '==>Error: ocean_bih_friction_mod: choose only one biharmonic friction scheme.'
      call mpp_error(FATAL,&
      '==>Error: ocean_bih_friction_mod: choose only one biharmonic friction scheme.')
  endif

  ! to determine whether we are doing any biharmonic friction 
  if(use_bihcst_friction .or. use_bihgen_friction .or. use_bihcgrid_friction) then 
     use_this_module = .true. 
  endif 

  if(use_this_module) then 
      id_restart = register_restart_field(Bih_restart, 'ocean_bih_friction.res.nc','bih_viscosity', &
                   bih_viscosity,domain=Dom%domain2d)
      if(.NOT.file_exist('INPUT/ocean_bih_friction.res.nc')) then
          if (.NOT. Time%init) then 
              call mpp_error(FATAL,'Expecting file INPUT/ocean_bih_friction.res.nc to exist.&
                   &This file was not found and Time%init=.false.')
          endif
      else
          call restore_state(Bih_restart)
          call mpp_update_domains(bih_viscosity,Dom%domain2d)
          write (stdoutunit,'(1x,a)') 'bih_viscosity being read from restart.'
          call write_chksum_2d('start bih_viscosity', bih_viscosity(COMP)*Grd%umask(COMP,1))

          bih_visc_ceu(:,:) = BAY(bih_viscosity(:,:))
          bih_visc_cnu(:,:) = BAX(bih_viscosity(:,:))
          call mpp_update_domains (bih_visc_ceu, Dom%domain2d)
          call mpp_update_domains (bih_visc_cnu, Dom%domain2d)
          bih_visc_ceu(:,:) = sqrt(bih_visc_ceu(:,:))
          bih_visc_cnu(:,:) = sqrt(bih_visc_cnu(:,:))

      endif

      if(.not. write_a_restart) then 
          write(stdoutunit,'(a)') '==>Note: running ocean_bih_friction with write_a_restart=.false.'
          write(stdoutunit,'(a)') '   Will NOT write restart file, and so cannot restart the run.'
      endif

  endif

  id_bih_viscosity = register_diag_field ('ocean_model', 'bih_viscosity', Grd%vel_axes_uv(1:2), &
                     Time%model_time,'Vertically averaged biharmonic viscosity',                &
                    'm^4/s',missing_value=missing_value, range=(/-10.0,1.e20/))


end subroutine ocean_bih_friction_init
! </SUBROUTINE>  NAME="ocean_bih_friction_init"


!#######################################################################
! <SUBROUTINE NAME="bih_friction">
!
! <DESCRIPTION>
! Compute the thickness weighted and density weighted accel due to 
! lateral biharmonic friction.  Add this contribution to Velocity%accel. 
! </DESCRIPTION>
!
subroutine bih_friction(Time, Thickness, Adv_vel, Velocity, energy_analysis_step)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(in)    :: Thickness
  type(ocean_adv_vel_type),   intent(in)    :: Adv_vel
  type(ocean_velocity_type),  intent(inout) :: Velocity
  logical,                    intent(in)    :: energy_analysis_step

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_bih_friction_mod (bih_friction): module needs to be initialized')
  endif 

  if(MIX_SCHEME==1) then 
    call mpp_clock_begin(id_clock_bihcst)
    call bihcst_friction(Time, Thickness, Velocity, bih_viscosity, energy_analysis_step)
    call mpp_clock_end(id_clock_bihcst)
  elseif(MIX_SCHEME==2) then 
    call mpp_clock_begin(id_clock_bihgen)
    call bihgen_friction(Time, Thickness, Adv_vel, Velocity, bih_viscosity, energy_analysis_step)
    call mpp_clock_end(id_clock_bihgen)
  elseif(MIX_SCHEME==3) then 
    call mpp_clock_begin(id_clock_bihcgrid)
    call bihcgrid_friction(Time, Thickness, Adv_vel, Velocity, bih_viscosity, energy_analysis_step)
    call mpp_clock_end(id_clock_bihcgrid)
  endif 

  ! vertically averaged viscosity for north and east face of U-cells.
  ! apply the sqrt so to apply bih_viscosity on each iteration 
  ! of the laplacian.
  if(use_this_module) then 
     bih_visc_ceu(:,:) = BAY(bih_viscosity(:,:))
     bih_visc_cnu(:,:) = BAX(bih_viscosity(:,:))
     call mpp_update_domains (bih_visc_ceu, Dom%domain2d)
     call mpp_update_domains (bih_visc_cnu, Dom%domain2d)
     bih_visc_ceu(:,:) = sqrt(bih_visc_ceu(:,:))
     bih_visc_cnu(:,:) = sqrt(bih_visc_cnu(:,:))
  endif 

  call diagnose_2d_u(Time, Grd, id_bih_viscosity, bih_viscosity(:,:))

end subroutine bih_friction
! </SUBROUTINE> NAME="bih_friction"


!#######################################################################
! <SUBROUTINE NAME="bih_viscosity_check">
!
! <DESCRIPTION>
! To check that the viscosity is not too large. 
! </DESCRIPTION>
!
subroutine bih_viscosity_check

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_bih_friction_mod (bih_viscosity_check): needs initialization')
  endif 

  if(MIX_SCHEME==1) then 
    call bihcst_viscosity_check
  elseif(MIX_SCHEME==2) then 
    call bihgen_viscosity_check
  elseif(MIX_SCHEME==3) then 
    call bihcgrid_viscosity_check
  endif 

end subroutine bih_viscosity_check
! </SUBROUTINE> NAME="bih_viscosity_check"


!#######################################################################
! <SUBROUTINE NAME="bih_reynolds_check">
!
! <DESCRIPTION>
! To check that the Reynolds number is not too large. 
! </DESCRIPTION>
!
subroutine bih_reynolds_check(Time, Velocity)

  type(ocean_time_type),     intent(in) :: Time
  type(ocean_velocity_type), intent(in) :: Velocity

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL,&
    '==>Error in ocean_bih_friction_mod (bih_reynolds_check): needs initialization')
  endif 

  if(MIX_SCHEME==1) then 
    call bihcst_reynolds_check(Time, Velocity)
  elseif(MIX_SCHEME==2) then 
    call bihgen_reynolds_check(Time, Velocity)
  elseif(MIX_SCHEME==3) then 
    call bihcgrid_reynolds_check(Time, Velocity)
  endif 

end subroutine bih_reynolds_check
! </SUBROUTINE> NAME="bih_reynolds_check"


!#######################################################################
! <SUBROUTINE NAME="bih_friction_barotropic">
!
! <DESCRIPTION>
!
! This routine computes the biharmonic friction acting on a two-dim
! array.  It uses the two-dimensional vertically averaged viscosity 
! used in the biharmonic friction module.  The intent is to apply this
! 2d operator to the vertically integrated horizontal momentum. We 
! ignore the spherical metric terms in this form of the operator, 
! since we are aiming for a fast smoothing operator to be applied
! during each of the many barotropic time steps.  We also apply 
! just the isotropic portion of the more general anisotropic 
! biharmonic operator.  
!
! This method has only been implemented for Bgrid MOM.  It is 
! rarely used and remains only for legacy.  
!
! </DESCRIPTION>
!
subroutine bih_friction_barotropic(bih_ceu_back, bih_cnu_back, array, friction)

  real, dimension(isd:,jsd:),   intent(in)    :: bih_ceu_back
  real, dimension(isd:,jsd:),   intent(in)    :: bih_cnu_back
  real, dimension(isd:,jsd:,:), intent(in)    :: array
  real, dimension(isd:,jsd:,:), intent(inout) :: friction

  integer :: i, j, n
  real    :: tmp(isd:ied,jsd:jed,2)

  ! first iteration 
  tmp(:,:,:) = 0.0
  do n=1,2
     tmp(:,:,n) =  BDX_EU( (bih_ceu_back(:,:)+bih_visc_ceu(:,:))*FDX_U(array(:,:,n)) ) &
                  +BDY_NU( (bih_cnu_back(:,:)+bih_visc_cnu(:,:))*FDY_U(array(:,:,n)) )  
     do j=jsc,jec
        do i=isc,iec
           del2_vel(i,j,n) = tmp(i,j,n)*Grd%umask(i,j,1)
        enddo
     enddo
  enddo
  call mpp_update_domains (del2_vel(:,:,:), Dom%domain2d)

  ! second iteration 
  tmp(:,:,:) = 0.0
  do n=1,2
     tmp(:,:,n) =  BDX_EU( (bih_ceu_back(:,:)+bih_visc_ceu(:,:))*FDX_U(del2_vel(:,:,n)) ) &
                  +BDY_NU( (bih_cnu_back(:,:)+bih_visc_cnu(:,:))*FDY_U(del2_vel(:,:,n)) )  
     do j=jsc,jec
        do i=isc,iec
           friction(i,j,n) = -tmp(i,j,n)*Grd%umask(i,j,1)
        enddo
     enddo
  enddo

  call mpp_update_domains (friction(:,:,:), Dom%domain2d)


end subroutine bih_friction_barotropic
! </SUBROUTINE> NAME="bi_friction_barotropic"


!#######################################################################
! <SUBROUTINE NAME="ocean_bih_friction_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocean_bih_friction_restart(time_stamp)
  character(len=*),           intent(in), optional :: time_stamp

  if(.not. use_this_module) return

  if (.not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_bih_friction (ocean_bih_friction_end): needs initialization')
  endif 

  call save_restart(Bih_restart, time_stamp)

end subroutine ocean_bih_friction_restart
! </SUBROUTINE> NAME="ocean_bih_friction_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_bih_friction_end">
!
! <DESCRIPTION>
! Write to restart of the vertically averaged viscosity. 
! </DESCRIPTION>
!
subroutine ocean_bih_friction_end(Time)

  type(ocean_time_type), intent(in) :: Time
  
  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return

  if (.not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_bih_friction (ocean_bih_friction_end): needs initialization')
  endif 

  if(.not. write_a_restart) then
    write(stdoutunit,'(/a)') &
    '==>Warning from ocean_bih_friction (ocean_bih_friction_end): NO restart written.'
    call mpp_error(WARNING,&
    '==>Warning from ocean_bih_friction_mod (ocean_bih_friction_end): NO restart written.')
    return
  endif 

  call ocean_bih_friction_restart

  write(stdoutunit,*)' ' 
  write(stdoutunit,*) 'From ocean_bih_friction_end: ending chksum'
  call write_timestamp(Time%model_time)
  call write_chksum_2d('ending bih_viscosity', bih_viscosity(COMP)*Grd%umask(COMP,1))


end subroutine ocean_bih_friction_end
! </SUBROUTINE> NAME="ocean_bih_friction_end"


end module ocean_bih_friction_mod
      
      

                    module aerosol_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  smf
! </REVIEWER>
! <OVERVIEW>
!  Code to initialize/allocate aerosol climatology
! </OVERVIEW>
! <DESCRIPTION>
!  This code initializes prescribed aerosol climatology from input file,
!  allocates necessary memory space and interpolate the aerosol climatology
!  to the model specification. Afterwards the memory space is deallocated,
!  the aerosol climatology information is freed.
! </DESCRIPTION>
!  shared modules:

use time_manager_mod,  only: time_type, time_manager_init, operator(+),&
                             set_date, operator(-), print_date, &
                             assignment(=), &
                             set_time, days_in_month, get_date, &
                             operator(>), operator(/=)
use diag_manager_mod,  only: diag_manager_init, get_base_time, &
                             send_data, register_diag_field,  &
                             register_static_field
use field_manager_mod, only: MODEL_ATMOS
use tracer_manager_mod,only: get_tracer_index,   &
                             get_tracer_names,   &
                             get_tracer_indices, &
                             get_number_tracers, &
                             MAX_TRACER_FIELDS,  &
                             query_method
use mpp_mod,           only: input_nml_file
use fms_mod,           only: open_namelist_file, fms_init, &
                             mpp_pe, mpp_root_pe, stdlog, &
                             file_exist, write_version_number, &
                             check_nml_error, error_mesg, &
                             FATAL, NOTE, WARNING, close_file
use interpolator_mod,  only: interpolate_type, interpolator_init, &
                             interpolator, interpolator_end, &
                             obtain_interpolator_time_slices, &    
                             unset_interpolator_time_flag, &
                             CONSTANT, INTERP_WEIGHTED_P
use mpp_io_mod,        only: mpp_open, mpp_close, MPP_RDONLY,   &
                             MPP_ASCII, MPP_SEQUENTIAL, MPP_MULTI,  &
                             MPP_SINGLE, mpp_io_init
use constants_mod,     only: constants_init, RADIAN, GRAV
use data_override_mod, only: data_override

!  shared radiation package modules:

use   rad_utilities_mod, only  : aerosol_type, rad_utilities_init, &
                                 get_radiative_param,              &
                                 atmos_input_type     

!---------------------------------------------------------------------

implicit none
private

!---------------------------------------------------------------------
!    aersosol_mod provides aerosol information that is needed by a
!    model physics package. the initial use of aerosol_mod was to
!    provide climatological aerosol fields to the model radiation 
!    package for use in calculating radiative fluxes and heating rates; 
!    with the introduction of predicted aerosols as members of the 
!    model's tracer array, aerosol_mod became the mechanism to collect
!    and bundle those tracers which were to be seen as aerosol by the
!    radiation code. the introduction of the treatment of aerosol 
!    impacts on cloud properties (aerosol indirect effect) required that
!    aerosol_mod be modified to provide needed aerosol information to 
!    routines involved with cloud calculation.
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module -------------------

character(len=128) :: version = '$Id: aerosol.F90,v 20.0 2013/12/13 23:18:53 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'


!-----------------------------------------------------------------------
!------  interfaces -------

public          &
        aerosol_init, aerosol_driver, aerosol_end, &
        aerosol_time_vary, aerosol_endts, aerosol_dealloc

!private         &


!---------------------------------------------------------------------
!------  namelist ------

 character(len=32)      ::      &
         aerosol_data_source = 'climatology'
                                   ! source of aerosol data, either
                                   ! 'climatology' file (default) or
                                   ! single column 'input' file or
                                   ! calculate a column for location and
                                   ! time specified ('calculate_column')
                                   ! or 'predicted' (calculated online)
integer, parameter     ::      &
        MAX_DATA_FIELDS = 100     ! maximum number of aerosol species
integer, parameter     ::      &
        MAX_AEROSOL_FAMILIES = 12 ! maximum number of aerosol families
character(len=64)      ::      &
        data_names(MAX_DATA_FIELDS) = '  ' 
                                  ! names of active aerosol species 
character(len=64)      ::      &
        filename = '  '           ! name of netcdf file containing 
                                  ! aerosol species to be activated
character(len=64)      ::      &
      family_names(MAX_AEROSOL_FAMILIES) = '  ' 
                                  ! names of active aerosol families 
logical, dimension(MAX_DATA_FIELDS) :: in_family1 = .false.
                                  ! aerosol n is in family 1 ?
logical, dimension(MAX_DATA_FIELDS) :: in_family2 = .false.
                                  ! aerosol n is in family 2 ?
logical, dimension(MAX_DATA_FIELDS) :: in_family3 = .false.
                                  ! aerosol n is in family 3 ?
logical,dimension(MAX_DATA_FIELDS) :: in_family4 = .false.
                                  ! aerosol n is in family 4 ?
logical, dimension(MAX_DATA_FIELDS) :: in_family5 = .false.
                                  ! aerosol n is in family 5 ?
logical, dimension(MAX_DATA_FIELDS) :: in_family6 = .false.
                                  ! aerosol n is in family 6 ?
logical, dimension(MAX_DATA_FIELDS) :: in_family7 = .false.
                                  ! aerosol n is in family 7 ?
logical, dimension(MAX_DATA_FIELDS) :: in_family8 = .false.
                                  ! aerosol n is in family 8 ?
logical, dimension(MAX_DATA_FIELDS) :: in_family9 = .false.
                                  ! aerosol n is in family 9 ?
logical, dimension(MAX_DATA_FIELDS) :: in_family10 = .false.
                                  ! aerosol n is in family 10 ?
logical, dimension(MAX_DATA_FIELDS) :: in_family11 = .false.
                                  ! aerosol n is in family 11 ?
logical, dimension(MAX_DATA_FIELDS) :: in_family12 = .false.
                                  ! aerosol n is in family 12 ?
logical         :: use_aerosol_timeseries = .false.
                                  ! use a timeseries providing inter-
                                  ! annual aerosol variation ?
logical, dimension(MAX_DATA_FIELDS) :: time_varying_species = .true.
                                  ! this aerosol species is 
                                  ! time-varying  ?
integer, dimension(6,MAX_DATA_FIELDS) :: aerosol_dataset_entry  =  1
                      ! time in aerosol data set corresponding to model
                      ! initial time  (yr, mo, dy, hr, mn, sc)
logical, dimension(MAX_AEROSOL_FAMILIES) ::   &
                                    volc_in_fam_col_opt_depth = .false.
                      ! is the volcanic contribution to column optical
                      ! depth to be included for this family in the
                      ! netcdf output fields ?
real,dimension(2)   :: lonb_col = (/-999., -999./)
                      ! longitudes defining the region to use for column
                      ! data calculation
real,dimension(2)   :: latb_col = (/-999., -999./)
                      ! latitudes defining the region to use for column
                      ! data calculation
integer, dimension(6)  :: time_col = (/0,0,0,0,0,0/)
                      ! time to use for column data calculation


namelist /aerosol_nml/                            &
                           aerosol_data_source,   &
                           lonb_col, latb_col, time_col, &
                           data_names, filename,  &
                           family_names,   &
                           use_aerosol_timeseries, &
                           time_varying_species,  &
                           aerosol_dataset_entry,  &               
                           in_family1, in_family2, in_family3, &
                           in_family4, in_family5, in_family6, &
                           in_family7, in_family8, in_family9, &
                           in_family10, in_family11, in_family12, &
                           volc_in_fam_col_opt_depth
                           

!---------------------------------------------------------------------
!---- public data ----


!---------------------------------------------------------------------
!---- private data ----


!-------------------------------------------------------------------
!    specified_aerosol contains the column input aerosol concentration
!    ratio (kg/m**2).  used when aerosol_data_source = 'input'.
!-------------------------------------------------------------------
real, dimension (:), allocatable     ::  specified_aerosol
 
!---------------------------------------------------------------------
!   the following is an interpolate_type variable containing the
!   information about the aerosol species.
!---------------------------------------------------------------------
type(interpolate_type), dimension(:), allocatable  :: Aerosol_interp

!--------------------------------------------------------------------
!    miscellaneous variables
!--------------------------------------------------------------------
integer  :: id                               ! number of grid points in 
                                             ! x direction (on processor)
integer  :: jd                               ! number of grid points in 
                                             ! y direction (on processor)
logical  :: make_separate_calls=.false.      ! aerosol interpolation
                                             ! to be done one at a 
                                             ! time
type(time_type), dimension(:), allocatable   ::    &
                   Aerosol_time              ! time for which data is
                                             ! obtained from aerosol
                                             ! timeseries
logical  :: do_column_aerosol = .false.      ! using single column aero-
                                             ! sol data ?
logical  :: do_predicted_aerosol = .false.   ! using predicted aerosol fields?
logical  :: do_specified_aerosol = .false.   ! using specified aerosol fields 
                                             ! from a timeseries file?
integer  :: nfields=0                        ! number of active aerosol 
                                             ! species
integer  :: nfamilies=0                      ! number of active aerosol 
                                             ! families
logical  :: module_is_initialized = .false.  ! module has been 
                                             ! initialized  ?

type(time_type) :: Model_init_time  ! initial calendar time for model  
                                    ! [ time_type ]
type(time_type), dimension(:), allocatable ::   &
                   Aerosol_offset   ! difference between model initial
                                    ! time and aerosol timeseries app-
                                    ! lied at model initial time
                                    ! [ time_type ]
type(time_type), dimension(:), allocatable ::   &
                   Aerosol_entry    ! time in aerosol timeseries which
                                    ! is mapped to model initial time
                                    ! [ time_type ]
type(time_type)  ::   &
              Aerosol_column_time   ! time for which aerosol data is
                                    ! extracted from aerosol timeseries
                                    ! in 'calculate_columns' case
                                    ! [ time_type ]
logical, dimension(:), allocatable    ::     &
                   negative_offset 
                                    ! the model initial time is later 
                                    ! than the aerosol_dataset_entry 
                                    ! time  ?
integer , dimension(:), allocatable :: data_out_of_bounds, vert_interp
logical, dimension(:), allocatable :: using_fixed_year_data 
                                    ! are we using a fixed year
                                    !  of data from a timeseries file ?
integer, dimension (MAX_DATA_FIELDS) :: aerosol_tracer_index
                                    ! tracer index for each of the 
                                    ! prognostic tracer to be seen as 
                                    ! aerosols by the radiation package
real, dimension (MAX_DATA_FIELDS)    :: aerosol_tracer_scale_factor
                                    ! scaling factor for each of the 
                                    ! prognostic tracer to be seen as 
                                    ! aerosols by the radiation package
character(len=32), dimension (:),  &
                     allocatable     ::  tracer_names
logical, dimension(:), allocatable   :: being_overridden
                                    ! is a given aerosol field to be over-
                                    ! ridden based on model data_table?
logical                              :: output_override_info = .true.
                                    ! should override info about each 
                                    ! aerosol field be output (will be set 
                                    ! to .false. after first time step)
integer                              :: override_counter = 0
                                    ! used to count calls to aerosol_endts
                                    ! so that output_override_info may be
                                    ! set .false. after physics_up.

#include <netcdf.inc>
 
!---------------------------------------------------------------------
!---------------------------------------------------------------------


                           contains


 
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!---------------------------------------------------------------------
! <SUBROUTINE NAME="aerosol_init">
!  <OVERVIEW>
!   Subroutine to initialize/interpolate prescribed aerosol climatology
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to initialize/interpolate prescribed aerosol climatology
!  </DESCRIPTION>
!  <TEMPLATE>
!   call aerosol_init(lonb, latb, aerosol_names)
!  </TEMPLATE>
!  <IN NAME="lonb" TYPE="real">
!   2d array of model longitudes on cell corners in [radians]
!  </IN>
!  <IN NAME="latb" TYPE="real">
!   2d array of model latitudes on cell corners in [radians]
!  </IN>
!  <IN NAME="aerosol_names" TYPE="character">
!   names of the activated aerosol species
!  </IN>
! </SUBROUTINE>
!
subroutine aerosol_init (lonb, latb, aerosol_names,   &
                         aerosol_family_names)

!-----------------------------------------------------------------------
!    aerosol_init is the constructor for aerosol_mod.
!-----------------------------------------------------------------------

real, dimension(:,:),            intent(in)  :: lonb,latb
character(len=64), dimension(:), pointer     :: aerosol_names
character(len=64), dimension(:), pointer     :: aerosol_family_names

!----------------------------------------------------------------------
!  intent(in) variables:
!
!       lonb           2d array of model longitudes on cell corners 
!                      [ radians ]
!       latb           2d array of model latitudes at cell corners 
!                      [ radians ]
!
!   pointer variables:
!
!       aerosol_names  names of the activated aerosol species
!       aerosol_family_names  names of the activated aerosol families
!
!---------------------------------------------------------------------

!----------------------------------------------------------------------
!  local variables:
      
      character(len=64)  :: data_names_predicted (MAX_DATA_FIELDS) = '  '
                              ! predicted aerosol names to be 
                              ! seen by radiation code
      logical :: flag,rad_forc_online, single_year_file
      character(len=80)       ::tr_rad_name, tr_clim_name
      character(len=80)       :: name,control
      real                    ::tr_rad_scale_factor
      integer   ::   unit, ierr, io, logunit
      integer   ::   ntrace
      integer   ::   n

!---------------------------------------------------------------------
!    local variables:
!
!         unit       io unit number used to read namelist file
!         ierr       error code
!         io         error status returned from io operation
!         n          do-loop index
!
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return
 
!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call mpp_io_init
      call fms_init
      call diag_manager_init
      call rad_utilities_init
      call time_manager_init
      call constants_init

!-----------------------------------------------------------------------
!    read namelist.
!-----------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=aerosol_nml, iostat=io)
      ierr = check_nml_error(io,'aerosol_nml')
#else   
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=aerosol_nml, iostat=io,  &
               end=10)
        ierr = check_nml_error(io,'aerosol_nml')
        end do
10      call close_file (unit)   
      endif                      
#endif
                                  
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                        write (logunit, nml=aerosol_nml)

!---------------------------------------------------------------------
!    define the dimensions of the local processors portion of the grid.
!---------------------------------------------------------------------
      id    = size(lonb,1) - 1
      jd    = size(latb,2) - 1

!---------------------------------------------------------------------
!    case of single input aerosol field. when running standalone code
!    on other than FMS level structure, aerosol_data_source must be 
!    'input'.
!---------------------------------------------------------------------
      if (trim(aerosol_data_source)== 'input') then
        do_column_aerosol = .true.
        call obtain_input_file_data
        nfields = 1
        allocate (aerosol_names(nfields))
        aerosol_names (1) = 'total_aerosol'

!---------------------------------------------------------------------
!    case of predicted aerosols.
!---------------------------------------------------------------------
      else if (trim(aerosol_data_source) == 'predicted') then
        do_predicted_aerosol = .true.

!-----------------------------------------------------------------------
!    count number of activated aerosol species, which will be carried
!    in the model as tracers with an attribute of 'radiative_param'. 
!    define the names associated with these aerosols.
!-----------------------------------------------------------------------
        call get_number_tracers(MODEL_ATMOS, num_tracers= ntrace)
        allocate (tracer_names(ntrace))
        do n = 1, ntrace
          call get_tracer_names(MODEL_ATMOS,n,tracer_names(n))
          flag = query_method ('radiative_param', MODEL_ATMOS, &
                               n, name, control)
          if (flag) then
            call get_radiative_param(name,control,rad_forc_online, &
                                     tr_rad_name, tr_clim_name, &
                                     tr_rad_scale_factor)
            if (rad_forc_online) then
              nfields = nfields +1
              aerosol_tracer_index(nfields) = n
              data_names_predicted(nfields) = trim(tr_rad_name)
!             data_names(nfields)           = trim(tr_clim_name)
              data_names(nfields)           = trim(tr_rad_name)
              aerosol_tracer_scale_factor(nfields) = tr_rad_scale_factor
            endif
          endif
        end do

!----------------------------------------------------------------------
!    allocate and fill pointer arrays to return the names of the activ-
!    ated species and any activated families to the calling routine.
!---------------------------------------------------------------------
        allocate (aerosol_names(nfields))
        aerosol_names(:)        = data_names_predicted(1:nfields)

!----------------------------------------------------------------------
!    allocate and fill an array to indicate whether or not each aerosol 
!    field is  to be overridden.
!---------------------------------------------------------------------
        allocate (being_overridden(nfields))
        being_overridden(:) = .false.

!---------------------------------------------------------------------
!    case of 'climatology' and 'calculate_column' aerosol data source.
!---------------------------------------------------------------------
      else   ! (trim(aerosol_data_source) == 'input')     
        do_specified_aerosol = .true.

!---------------------------------------------------------------------
!    determine how many aerosols in the file are activated.
!--------------------------------------------------------------
        do n=1,MAX_DATA_FIELDS
          if (data_names(n) /= ' '  ) then
            nfields = n
          else
            exit
          endif
        end do
  
!---------------------------------------------------------------------
!    check for case of inconsistent nml specification -- case of re-
!    questing time-varying aerosol for a given aerosol, but indicating
!    that the time series is not to be used. in this case, a note will
!    be written to stdout indicating that the aerosol species will not
!    be time-varying. this is needed because the default nml settings  
!    are defined so as to allow backward compatibility with existing 
!    code and script settings, and lead to this conflict.
!---------------------------------------------------------------------
        do n=1, nfields
          if (.not. use_aerosol_timeseries) then
            if (time_varying_species(n)) then
              call error_mesg ('aerosol_mod', &
                  'inconsistent nml settings -- not using aerosol  &
                  &timeseries but requesting interannual variation of  &
                  & aerosol amount for '  // trim (data_names(n))  // &
                 ' -- this aerosol will NOT exhibit interannual &
                  &variation', NOTE)
              time_varying_species(n) = .false.
            endif
          endif
        end do

!---------------------------------------------------------------------
!    allocate and fill pointer arrays to return the names of the activ-
!    ated species and any activated families to the calling routine.
!--------------------------------------------------------------------
        allocate (aerosol_names(nfields))
        aerosol_names (:) = data_names(1:nfields)

!----------------------------------------------------------------------
!    allocate and initialize module variables.
!----------------------------------------------------------------------
        allocate (Aerosol_offset(nfields), Aerosol_entry(nfields), &
              negative_offset(nfields), using_fixed_year_data(nfields)) 
        Aerosol_offset = set_time (0,0)
        Aerosol_entry = set_time (0,0)
        negative_offset = .false.
        using_fixed_year_data = .false.

!----------------------------------------------------------------------
!    define the model base time  (defined in diag_table) 
!----------------------------------------------------------------------
        Model_init_time = get_base_time()

!----------------------------------------------------------------------
!    define the array using_fixed_year_data. it will be .true. for a 
!    given aerosol species if the nml variable use_aerosol_timeseries 
!    is .true., and the nml variable time_varying_species for that
!    aerosol is .false., or if use_aerosol_timeseries is .false but a 
!    non-default aerosol_dataset_entry has been specified; otherwise it 
!    will be .false..
!----------------------------------------------------------------------
        do n=1,nfields           
          if (use_aerosol_timeseries) then
            if (time_varying_species(n)) then
              using_fixed_year_data(n) = .false.
            else
              using_fixed_year_data(n) = .true.
            endif
  
!---------------------------------------------------------------------
!    if no dataset entry point is supplied when an aerosol timeseries
!    file is being used, define the entry point as the model base time.
!---------------------------------------------------------------------
            if (aerosol_dataset_entry(1,n) == 1 .and. &
                aerosol_dataset_entry(2,n) == 1 .and. &
                aerosol_dataset_entry(3,n) == 1 .and. &
                aerosol_dataset_entry(4,n) == 1 .and. &
                aerosol_dataset_entry(5,n) == 1 .and. &
                aerosol_dataset_entry(6,n) == 1 ) then
              Aerosol_entry(n) = Model_init_time

!----------------------------------------------------------------------
!    if a dataset entry time is defined, compute the offset from model 
!    base time to aerosol_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
            else
              Aerosol_entry(n) = set_date (aerosol_dataset_entry(1,n), &
                                           aerosol_dataset_entry(2,n), &
                                           aerosol_dataset_entry(3,n), &
                                           aerosol_dataset_entry(4,n), &
                                           aerosol_dataset_entry(5,n), &
                                           aerosol_dataset_entry(6,n))
            endif

!----------------------------------------------------------------------
!    indicate that aerosol species n will be defined from the timeseries
!    file, and the relationship of the timeseries to the model calendar.
!--------------------------------------------------------------------
            call error_mesg ( 'aerosol_mod', &
               'PROCESSING AEROSOL TIMESERIES FOR ' // &
               trim(aerosol_names(n)), NOTE)
            call print_date (Aerosol_entry(n) ,   &
                str= ' Data from aerosol timeseries at time: ')
            call print_date (Model_init_time , str=' This data is &
                               &mapped to model time:')

!---------------------------------------------------------------------
!    indicate whether a single year of the aerosol climatology will be
!    repeated throughout the model run, or if the aerosol time behavior
!    will show interannual changes.
!---------------------------------------------------------------------
            if (using_fixed_year_data(n)) then
              call error_mesg ('aerosol_mod', &
                 'This annual cycle will be used every model year &
               & -- no interannual variation for '  &
                                     // trim(aerosol_names(n)), NOTE)
            else
              call error_mesg ('aerosol_mod', &
                      trim(aerosol_names(n)) //   &
                     ' will exhibit interannual variation as defined &
                     & in the climatology file ', NOTE)
            endif
!---------------------------------------------------------------------
!    define the offset between the aerosol timeseries and the model
!    calendar, and whether this is a positive or negative offset.
!--------------------------------------------------------------------
            Aerosol_offset(n) = Aerosol_entry(n) - Model_init_time
            if (Model_init_time > Aerosol_entry(n)) then
              negative_offset(n) = .true.
            else
              negative_offset(n) = .false.
            endif

!---------------------------------------------------------------------
!    if use_aerosol_timeseries is .false., then either data from a 
!    single year defined in a timeseries file is to be used throughout 
!    the model integration, or a non-specific single-year aerosol 
!    climatology file is to be used.
!---------------------------------------------------------------------
          else 

!---------------------------------------------------------------------
!    if no dataset entry has been specified, then a non-specific single
!    year climatology file is being used. set the variable 
!    using_fixed_year_data to be .false.. output a descriptive message
!    to stdout.
!---------------------------------------------------------------------
            if (aerosol_dataset_entry(1,n) == 1 .and. &
                aerosol_dataset_entry(2,n) == 1 .and. &
                aerosol_dataset_entry(3,n) == 1 .and. &
                aerosol_dataset_entry(4,n) == 1 .and. &
                aerosol_dataset_entry(5,n) == 1 .and. &
                aerosol_dataset_entry(6,n) == 1 ) then
              using_fixed_year_data(n) = .false.
              if (mpp_pe() == mpp_root_pe() ) then
                print *, 'Aerosol data for ', trim(aerosol_names(n)),   &
                   ' obtained from single year climatology file '
              endif

!---------------------------------------------------------------------
!    if a year has been specified for the dataset entry, then the data
!    will be coming from an aerosol timeseries file, but the same annual
!    aerosol variation will be used for each model year. set the var-
!    iable using_fixed_year_data to be .true..  define Aerosol_entry as
!    feb 01 of the year given by the first element of nml variable 
!    aerosol_dataset_entry. output a descriptive message to stdout.
!--------------------------------------------------------------------
            else
              using_fixed_year_data(n) = .true.
              Aerosol_entry(n) = set_date (aerosol_dataset_entry(1,n), &
                                           2, 1, 0, 0, 0)
              call error_mesg ('aerosol_mod', &
                  'Aerosol data is defined from a single annual cycle &
                  &for ' // trim(aerosol_names(n)) //   &
                  &' - no interannual variation', NOTE)
              if (mpp_pe() == mpp_root_pe() ) then
                print *, 'Aerosol data for ', trim(aerosol_names(n)),  &
                    ' obtained from aerosol timeseries &
                    &for year:', aerosol_dataset_entry(1,n)
              endif
            endif
          endif
        end do

!-----------------------------------------------------------------------
!    count number of activated aerosol families. allocate a pointer 
!    array to return the names of the activated species to the calling 
!    routine.
!-----------------------------------------------------------------------
!       do n=1,MAX_AEROSOL_FAMILIES
!         if (family_names(n) /= ' '  ) then
!           nfamilies = n
!         else
!           exit
!         endif
!       end do

!-----------------------------------------------------------------------
!    allocate and initialize variables needed for interpolator_mod if 
!    any aerosol species have been activated.
!-----------------------------------------------------------------------
        allocate (data_out_of_bounds(nfields))
        allocate (vert_interp       (nfields))
        data_out_of_bounds = CONSTANT
        vert_interp = INTERP_WEIGHTED_P

!----------------------------------------------------------------------
!    determine if separate calls to interpolator  must be made for 
!    each aerosol species, or if all variables in the file may be
!    interpolated together.  reasons for separate calls include differ-
!    ent data times desired for different aerosols, different vertical
!    interpolation procedures and different treatment of undefined
!    data.
!----------------------------------------------------------------------
          do n=2,nfields
            if (time_varying_species(n) .and.   &
               (.not. time_varying_species(n-1) ) ) then
              make_separate_calls = .true.
              exit
            endif
            if (using_fixed_year_data(n) .and.   &
                (.not. using_fixed_year_data(n-1) ) ) then
              make_separate_calls = .true.
              exit
            endif
            if (Aerosol_entry(n) /= Aerosol_entry(n-1)) then
              make_separate_calls = .true.
              exit
            endif
            if (data_out_of_bounds(n) /= data_out_of_bounds(n-1)) then
              make_separate_calls = .true.
              exit
            endif
            if (vert_interp       (n) /= vert_interp       (n-1)) then
              make_separate_calls = .true.
              exit
            endif
          end do
          if (make_separate_calls) then
            allocate (Aerosol_interp(nfields))  
            allocate (Aerosol_time  (nfields))  
          else
            allocate (Aerosol_interp(1))  
            allocate (Aerosol_time  (1))  
          endif

!----------------------------------------------------------------------
!    determine if the aerosol_data_source is specified as 
!    'calculate_column'. 
!--------------------------------------------------------------------
        if (trim(aerosol_data_source) == 'calculate_column') then

!----------------------------------------------------------------------
!    if the aerosol_data_source is specified as 'calculate_column', then
!    the aerosol fields will be obtained by averaging the aerosol fields
!    in the climatology over a specified latitude-longitude section at
!    a specified calendar time, and this profile will be used in all 
!    model columns. make sure the specified lats / lons / time are 
!    valid.
!-------------------------------------------------------------------
          do n=1,2
            if (lonb_col(n) < 0. .or. lonb_col(n) > 360.) then
              call error_mesg ('aerosol_mod', &
                  ' invalid value for lonb_col', FATAL)
            endif
            if (latb_col(n) < -90. .or. latb_col(n) > 90.) then
              call error_mesg ('aerosol_mod', &
                  ' invalid value for latb_col', FATAL)
            endif
          end do
          if (time_col(1) == 0) then
            call error_mesg ('aerosol_mod', &
                'invalid time specified for time_col', FATAL)
          endif

          if (.not. use_aerosol_timeseries) then
              call error_mesg ('aerosol_mod', &
         'must use_aerosol_timeseries when calculate_column is .true.', FATAL)
          endif 

          if (any(time_varying_species(1:nfields))) then
              call error_mesg ('aerosol_mod', &
                   'aerosol values must be fixed in time when &
                                   &calculate_column is .true.', FATAL)
          endif 


!----------------------------------------------------------------------
!    call interpolator_init to begin processing the aerosol climat-
!    ology file. define the valid time as a time_type, and output
!    informative messages.
!---------------------------------------------------------------------
    if (make_separate_calls) then
              call error_mesg ('aerosol_mod', &
         'make_separate_calls not allowed  for calculate_column', FATAL)
     else       
          call interpolator_init (Aerosol_interp(1)    , filename,  &
                                    spread(lonb_col/RADIAN,2,2),  &
                                    spread(latb_col/RADIAN,1,2),&
                                    data_names(:nfields),   &
                                    data_out_of_bounds=   &
                                                  data_out_of_bounds, &
                                    vert_interp=vert_interp,  &
                                    single_year_file = single_year_file)
     endif
          Aerosol_column_time = set_date (time_col(1), time_col(2), &
                                          time_col(3), time_col(4), &
                                          time_col(5), time_col(6))
          call print_date (Aerosol_column_time,  str= &
              ' Aerosol data used is from aerosol timeseries at time: ')
          if (mpp_pe() == mpp_root_pe() ) then
            print *, 'Aerosol data is averaged over latitudes',  &
                latb_col(1), ' to', latb_col(2), ' and longitudes',&
                lonb_col(1), ' to', lonb_col(2)
          endif

!----------------------------------------------------------------------
!    if 'calculate_column' is .false., then the aerosol fields will have
!    the appropriate horizontal variation. call interpolator_init to
!    begin processing the aerosol climatology file.    
!-------------------------------------------------------------------
        else  ! (calculate_column)
    if (make_separate_calls) then
       do n=1,nfields
          call interpolator_init (Aerosol_interp(n), filename, lonb, &
                                  latb, data_names(n:n     ),   &
                                  data_out_of_bounds=    &
                                                  data_out_of_bounds(n:n), &
                                  vert_interp=vert_interp(n:n), &
                                  single_year_file=single_year_file)
       end do
     else
          call interpolator_init (Aerosol_interp(1), filename, lonb, &
                                  latb, data_names(:nfields),   &
                                  data_out_of_bounds=    &
                                                  data_out_of_bounds, &
                                  vert_interp=vert_interp, &
                                  single_year_file=single_year_file)
     endif
        endif ! (calculate_column)

!--------------------------------------------------------------------
!    check for compatibility of nml options requested and the aerosol
!    data file which was read.
!--------------------------------------------------------------------
        if (single_year_file .and.  use_aerosol_timeseries) then
          call error_mesg ('aerosol_mod', &
               'aerosol input file is single-year, yet interannual &
                &variation of aerosol is requested', FATAL  )
        endif
        do n=1, nfields
          if (.not. use_aerosol_timeseries .and.   &
              .not. using_fixed_year_data(n) .and. &
              .not. single_year_file)  then
            call error_mesg ('aerosol_mod', &
              'aerosol input file contains a time-series, yet nml  &
               &settings indicate that a non-specific single-year &
               &climatology is to be used', FATAL)
          endif
          if (.not. use_aerosol_timeseries .and.   &
              using_fixed_year_data(n) .and. &
              single_year_file)  then
            call error_mesg ('aerosol_mod', &
             'aerosol input file is non-specific single-year file,  &
               &yet nml settings specify that a particular single-year &
               &climatology is to be used', FATAL)
          endif
        end do
      endif  ! ('aerosol_data_source == 'input')

!-----------------------------------------------------------------------
!    count number of activated aerosol families. allocate a pointer 
!    array to return the names of the activated species to the calling 
!    routine.
!-----------------------------------------------------------------------
      do n=1,MAX_AEROSOL_FAMILIES
        if (family_names(n) /= ' '  ) then
          nfamilies = n
        else
          exit
        endif
      end do

!---------------------------------------------------------------------
!    allocate and fill pointer arrays to return the names of any activ-
!    ated families to the calling routine.
!-------------------------------------------------------------------
      allocate (aerosol_family_names(nfamilies))
      aerosol_family_names (:) = family_names(1:nfamilies)

!---------------------------------------------------------------------
!    mark the module as initialized.
!---------------------------------------------------------------------
      module_is_initialized = .true.

!---------------------------------------------------------------------



end subroutine aerosol_init

!############################################################################

subroutine aerosol_time_vary (model_time)

!--------------------------------------------------------------------------- 
!   subroutine aerosol_time_vary makes sure the aerosol interpolate_type 
!   variable has access to the proper time levels of data in the aerosol
!---------------------------------------------------------------------------

type(time_type), intent(in) :: model_time


      integer :: n

!----------------------------------------------------------------------
!    be sure the proper time levels are in memory for the aerosol timeseries.
!----------------------------------------------------------------------
      if ( do_specified_aerosol) then
 
        if (make_separate_calls) then
!--------------------------------------------------------------------
!    if separate calls are required for each aerosol species, loop over
!    the individual species.
!--------------------------------------------------------------------
          do n=1,nfields

!--------------------------------------------------------------------
!    if the data timeseries is to be used for species n, define the
!    time for which data is desired, and then call interpolator to
!    verify the time levels bracketing the desired time are available.
!--------------------------------------------------------------------
            if (use_aerosol_timeseries) then
              if (time_varying_species(n)) then

!----------------------------------------------------------------------
!    define the Aerosol_time for aerosol n and check for the  
!    appropriate time slices.
!----------------------------------------------------------------------
                if (negative_offset(n)) then
                  Aerosol_time(n) = model_time - Aerosol_offset(n)
                else
                  Aerosol_time(n) = model_time + Aerosol_offset(n)
                endif
                call obtain_interpolator_time_slices (Aerosol_interp(n), &
                                                          Aerosol_time(n))     
              else
                call set_aerosol_time (model_time, Aerosol_entry(n), &
                                       Aerosol_time(n))
                call obtain_interpolator_time_slices (Aerosol_interp(n), &
                                                       Aerosol_time(n))     
              endif

!--------------------------------------------------------------------
!    if the data timeseries is not to be used for species n, define the
!    time for which data is desired, and then call interpolator to
!    obtain the data.
!--------------------------------------------------------------------
            else  ! (use_aerosol_timeseries)

!---------------------------------------------------------------------
!    if a fixed year has not been specified, obtain data relevant for
!    the current model year.
!---------------------------------------------------------------------
              if ( .not. using_fixed_year_data(n)) then
                call obtain_interpolator_time_slices (Aerosol_interp(n), &
                                                              model_time)     
                Aerosol_time(n) = model_time

!----------------------------------------------------------------------
!    if a fixed year has been specified, call set_aerosol_time to define
!    the Aerosol_time to be used for aerosol n. call interpolator to 
!    obtain the aerosol values and store the aerosol amounts in 
!    Aerosol%aerosol.
!----------------------------------------------------------------------
              else 
                call set_aerosol_time (model_time, Aerosol_entry(n), &
                                         Aerosol_time(n))
                call obtain_interpolator_time_slices (Aerosol_interp(n), &
                                                          Aerosol_time(n))     
              endif  
            endif ! (use_aerosol_timeseries)
          end do  !(nfields)

        else  ! (make_separate_calls)
           
!--------------------------------------------------------------------
!    if the data timeseries is to be used for species n, define the
!    time for which data is desired.
!--------------------------------------------------------------------
          if (use_aerosol_timeseries) then
            if (negative_offset(1)) then
              Aerosol_time(1) = model_time - Aerosol_offset(1)
            else
              Aerosol_time(1) = model_time + Aerosol_offset(1)
            endif

!--------------------------------------------------------------------
!    if 'calculate_column' is being used,  be sure the needed time slices
!    are in memory.
!--------------------------------------------------------------------
            if (trim(aerosol_data_source) == 'calculate_column') then
              call obtain_interpolator_time_slices (Aerosol_interp(1), &
                                Aerosol_column_time)
            else

!-------------------------------------------------------------------
!    since separate calls are not required, all aerosol species are 
!    either time_varying  or not.  be sure the needed time slices are available.
!--------------------------------------------------------------------
              if (time_varying_species(1)) then
                call obtain_interpolator_time_slices (Aerosol_interp(1), &
                                Aerosol_time(1))
              else
                call set_aerosol_time (model_time, Aerosol_entry(1), &
                                       Aerosol_time(1))
                call obtain_interpolator_time_slices (Aerosol_interp(1), &
                                Aerosol_time(1))
              endif    
            endif  ! (calculate_column)

!--------------------------------------------------------------------
!    if the data timeseries is not to be used for species n, define the
!    time for which data is desired, and verify the presence of the needed
!    bracketing time slices.
!--------------------------------------------------------------------
          else ! (use_aerosol_timeseries)

!---------------------------------------------------------------------
!    if a fixed year has not been specified, obtain data relevant for
!    the current model year. this data comes from a non-specific single-yr
!    climatology file.
!---------------------------------------------------------------------
            if (.not. using_fixed_year_data(1)) then
              call obtain_interpolator_time_slices (Aerosol_interp(1), &
                                  model_time)
              Aerosol_time(1) = model_time

!----------------------------------------------------------------------
!    if a fixed year has been specified, call set_aerosol_time to define
!    the Aerosol_time, then verify the needed time slices are available. 
!----------------------------------------------------------------------
            else
              call set_aerosol_time (model_time, Aerosol_entry(1), &
                                                             Aerosol_time(1))
              call obtain_interpolator_time_slices (Aerosol_interp(1), &
                                                            Aerosol_time(1))
            endif ! (using_fixed_year)
          endif ! (use_aerosol_timeseries)
        endif  ! (make_separate_calls   )
      endif ! (do_column_aerosol)
               
!-------------------------------------------------------------------- 



end subroutine aerosol_time_vary 



!####################################################################

subroutine aerosol_endts

     integer :: n

     if (allocated(Aerosol_interp)) then
       do n=1, size(Aerosol_interp,1)
         call unset_interpolator_time_flag (Aerosol_interp(n))
       end do
     endif
  
     override_counter = override_counter + 1
     if (override_counter == 2) then
       output_override_info = .false.
     endif

end subroutine aerosol_endts



!######################################################################
! <SUBROUTINE NAME="aerosol_driver">
!  <OVERVIEW>
!   Interpolate aerosol verical profile based on prescribed aerosol
!   climatology input and model set up.
!  </OVERVIEW>
!  <TEMPLATE>
!   call aerosol_driver (is, js, model_time, p_half, Aerosol)
!  </TEMPLATE>
!  <INOUT NAME="Aerosol" TYPE="aerosol_type">
!   Aerosol climatology input
!  </INOUT>
!  <IN NAME="model_time" TYPE="time_type">
!   The internal model simulation time, i.e. Jan. 1 1982
!  </IN>
!  <IN NAME="tracer" TYPE="real">
!   4 dimensional array of tracers, last index is the number of all tracers
!  </IN>
!  <IN NAME="p_half" TYPE="real">
!   The array of model layer pressure values
!  </IN>
!  <IN NAME="is" TYPE="integer">
!   The longitude index of model physics window domain
!  </IN>
!  <IN NAME="js" TYPE="integer">
!   The latitude index of model physics window domain
!  </IN>
!  <IN NAME="override_aerosols" TYPE="logical, optional">
!   use offline aerosols via data_override?
!  </IN>
! </SUBROUTINE>
!
subroutine aerosol_driver (is, js, model_time, tracer, &
                           p_half, p_flux, Aerosol, override_aerosols)

!-----------------------------------------------------------------------
!    aerosol_driver returns the names and concentrations of activated 
!    aerosol species at model grid points at the model_time to the 
!    calling routine in aerosol_type variable Aerosol. 
!-----------------------------------------------------------------------

integer,                  intent(in)     :: is,js
type(time_type),          intent(in)     :: model_time
real, dimension(:,:,:,:), intent(in)     :: tracer
real, dimension(:,:,:),   intent(in)  :: p_half, p_flux
type(aerosol_type),       intent(inout)  :: Aerosol
logical, optional,        intent(in)     :: override_aerosols

!--------------------------------------------------------------------
!   intent(in) variables:
!
!       is, js           starting subdomain i,j indices of data in 
!                        the physics_window being integrated
!       model_time       time for which aerosol data is desired
!                        [ time_type ]
!       p_half           model pressure at interface levels 
!                        [ Pa ]
!      
!   intent(inout) variables:
!
!       Aerosol    aerosol_type variable. the following components will
!                  be returned from this routine:
!                   aerosol      concentration of each active aerosol 
!                                species at each model grid point
!                                [ kg / m**2 ]
!                   aerosol_names 
!                                names assigned to each active species
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables:

      real, dimension(1,1, size(p_half,3)-1,    &
                                               nfields) :: aerosol_data
      real, dimension(1,1, size(p_half,3))   :: p_half_col
      real, dimension(id,jd,size(p_half,3)-1) :: aerosol_proc
      integer         :: n, k, j, i, na            ! do-loop index
      integer         :: nn
      logical         :: do_override, used
      integer         :: ie, je

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('aerosol_mod',   &
                         'module has not been initialized',FATAL )
      endif

!---------------------------------------------------------------------
!    allocate an array to hold the activated aerosol names. allocate an
!    array which defines the members of the requested aerosol families.
!    allocate an array to hold the aerosol amounts for each species at
!    each grid point. 
!---------------------------------------------------------------------
      allocate (Aerosol%aerosol_names (nfields))
      allocate (Aerosol%family_members(nfields+1, nfamilies))
      allocate (Aerosol%aerosol(size(p_half,1),  &
                                size(p_half,2), &
                                size(p_half,3) - 1, nfields)) 
      ie = is + size(p_half,1) - 1
      je = js + size(p_half,2) - 1

      if (do_column_aerosol) then
 
!---------------------------------------------------------------------
!    here all aerosol is consolidated into a single variable.
!----------------------------------------------------------------------
        Aerosol%aerosol_names(1) = 'total_aerosol'
        do k=1, size(Aerosol%aerosol,3)
          Aerosol%aerosol(:,:,k,1) = specified_aerosol(k)
        end do
      else 
      
!--------------------------------------------------------------------
!    define an array to hold the activated aerosol names.
!---------------------------------------------------------------------
        Aerosol%aerosol_names = data_names(:nfields) 

!--------------------------------------------------------------------
!    define an array which defines the members of the requested aerosol
!    families.
!---------------------------------------------------------------------
        if (nfamilies > 0) then
          do n=1,nfamilies
            do na = 1, nfields
              select case(n)
                case (1)
                  Aerosol%family_members(na,1) = in_family1(na)
                case (2)
                  Aerosol%family_members(na,2) = in_family2(na)
                case (3)
                  Aerosol%family_members(na,3) = in_family3(na)
                case (4)
                  Aerosol%family_members(na,4) = in_family4(na)
                case (5)
                  Aerosol%family_members(na,5) = in_family5(na)
                case (6)
                  Aerosol%family_members(na,6) = in_family6(na)
                case (7)
                  Aerosol%family_members(na,7) = in_family7(na)
                case (8)
                  Aerosol%family_members(na,8) = in_family8(na)
                case (9)
                  Aerosol%family_members(na,9) = in_family9(na)
                case (10)
                  Aerosol%family_members(na,10) = in_family10(na)
                case (11)
                  Aerosol%family_members(na,11) = in_family11(na)
                case (12)
                  Aerosol%family_members(na,12) = in_family12(na)
                case DEFAULT
              end select
            end do
            if (volc_in_fam_col_opt_depth(n)) then
              Aerosol%family_members(nfields+1,n) = .true.
            else
              Aerosol%family_members(nfields+1,n) = .false.
            endif
          end do
        endif

!----------------------------------------------------------------------
         if ( do_specified_aerosol) then

!--------------------------------------------------------------------
!    if 'calculate_column' is being used, obtain the aerosol values for
!    each column, one at a time, using the pressure profile for that
!    column. this allows each column to see the same aerosol fields,
!    but distributed appropriately for its pressure structure.
!--------------------------------------------------------------------
              if (trim(aerosol_data_source) == 'calculate_column') then
                do j=1, size(p_half,2)
                  do i=1, size(p_half,1)
                    p_half_col(1,1,:) = p_flux(i,j,:)
                    call interpolator (Aerosol_interp(1),&
                                       Aerosol_column_time,  &
                                       p_half_col, aerosol_data, &
                                       Aerosol%aerosol_names(1), 1, 1  )
                    Aerosol%aerosol(i,j,:,:) = aerosol_data(1,1,:,:)
                  end do
                end do
              else

!--------------------------------------------------------------------
!    if separate calls are required for each aerosol species, loop over
!    the individual species.
!--------------------------------------------------------------------
                if (make_separate_calls) then
                  do n=1,nfields                
                    call interpolator (Aerosol_interp(n), Aerosol_time(n),  &
                                     p_flux, &
                                     Aerosol%aerosol(:,:,:,n),    &
                                     Aerosol%aerosol_names(n), is, js)
                  end do  !(nfields)

!----------------------------------------------------------------------
!    if separate calls are not required, use the first aerosol char-
!    acteristics to define Aerosol_time and make a single call to 
!    interpolator. store the aerosol amounts in Aerosol%aerosol.
!----------------------------------------------------------------------
                else      
                  call interpolator (Aerosol_interp(1), Aerosol_time(1),  &
                                    p_flux, &
                                    Aerosol%aerosol,    &
                                    Aerosol%aerosol_names(1), is, js)
                endif      
              endif ! (calculate_column)

!-------------------------------------------------------------------- 
!    for predicted aerosols (obtained from tracer array), assign the 
!    tracer to "Aerosol" if that TRACER has "radiative_param" and 
!    "online", both defined in the field_table. 
! ***********************WARNINGS**************************************
!    the tracers are assumed to be expressed in Mass Mixing Ratio (MMR), 
!    and are converted into mass column for the radiative code.
!    Conversions (e.g. OC -> OM, or SO4 -> (NH4)2SO4 ) can be done
!    via radiative_param attribute scale_factor (in field_table).
!------------------------------------------------------------------ 
        else                  ! (do_specified_aerosol')
          if (present(override_aerosols)) then
            do_override = override_aerosols
          else
            do_override = .false.
          end if

          do nn=1,nfields
            n = aerosol_tracer_index(nn)

            Aerosol%aerosol(:,:,:,nn) = tracer(:,:,:,n)
            if (do_override) then
              call data_override('ATM', TRIM(tracer_names(n))//'_aerosol',&
                                 aerosol_proc, model_time, override=used)
              if (used) then
                if (output_override_info) then
                  call error_mesg ('aerosol_mod', &
                       TRIM(tracer_names(n))//'_aerosol => '// &
                     TRIM(tracer_names(n)) // ' is being overridden', NOTE)
                  being_overridden(nn) = .true.
                endif
                Aerosol%aerosol(:,:,:,nn) = aerosol_proc(is:ie,js:je,:)
              else
                if (output_override_info) then
                  call error_mesg ('aerosol_mod', &
                    TRIM(tracer_names(n))//'_aerosol => '//  &
                       TRIM(tracer_names(n)) // ' not overridden', NOTE)
                else
                  if (being_overridden(nn)) then
                    call error_mesg ('aerosol_mod', &
                       TRIM(tracer_names(n))//'_aerosol => '//  &
                         TRIM(tracer_names(n)) // ' not overridden &
                                      &when override was requested', FATAL)
                  endif
                endif
              endif
            endif

            do k=1,size(Aerosol%aerosol,3)
              do j=1,size(Aerosol%aerosol,2)
                do i=1,size(Aerosol%aerosol,1)
                  Aerosol%aerosol(i,j,k,nn) =    &
                          MAX (0.0, Aerosol%aerosol(i,j,k,nn)) * &
                          aerosol_tracer_scale_factor(nn) * &
                          ( p_half(i,j,k+1)-p_half(i,j,k) )/GRAV
                end do
              end do
            end do
          end do
        endif   ! (do_specified_aerosol')
      endif  ! (do_column_aerosol)

!-------------------------------------------------------------------- 

end subroutine aerosol_driver



!#####################################################################
! <SUBROUTINE NAME="aerosol_end">
!  <OVERVIEW>
!   aerosol_end is the destructor for aerosol_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!   aerosol_end is the destructor for aerosol_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call aerosol_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine aerosol_end

!----------------------------------------------------------------------
!    aerosol_end is the destructor for aerosol_mod.
!----------------------------------------------------------------------

      integer  :: n


!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('aerosol_mod',   &
                         'module has not been initialized',FATAL )
      endif

!---------------------------------------------------------------------
!    call interpolator_end to release the interpolate_type variable 
!    used in this module.
!---------------------------------------------------------------------
      if (do_specified_aerosol) then
          if (nfields > 0) then
            do n=1, size(Aerosol_interp,1)
              call interpolator_end (Aerosol_interp(n))
            end do        
          endif
          deallocate (Aerosol_time)
      endif

      if (allocated (specified_aerosol)) deallocate (specified_aerosol)
      if (allocated (Aerosol_offset   )) deallocate (Aerosol_offset   )
      if (allocated (Aerosol_entry    )) deallocate (Aerosol_entry    )
      if (allocated (negative_offset  )) deallocate (negative_offset  )
      if (allocated (data_out_of_bounds))   &
                                      deallocate (data_out_of_bounds  )
      if (allocated (vert_interp      )) deallocate (vert_interp      ) 
      if (allocated (using_fixed_year_data))  &
                                     deallocate (using_fixed_year_data)

!--------------------------------------------------------------------
!    mark the module as uninitialized.
!--------------------------------------------------------------------
      module_is_initialized = .false.

!---------------------------------------------------------------------



end subroutine aerosol_end


!#####################################################################

subroutine set_aerosol_time (Model_time, Entry, Aerosol_time)

type(time_type), intent(in)   :: Model_time, Entry
type(time_type), intent(out)  :: Aerosol_time

      integer :: mo_yr, yr, mo, dy, hr, mn, sc, dum, dayspmn

      call get_date (Model_time, mo_yr, mo, dy, hr, mn, sc)
      call get_date (Entry, yr, dum,dum,dum,dum,dum)
      if (mo ==2 .and. dy == 29) then
        dayspmn = days_in_month(Entry)
        if (dayspmn /= 29) then
          Aerosol_time = set_date (yr, mo, dy-1, hr, mn, sc)
        else
          Aerosol_time = set_date (yr, mo, dy, hr, mn, sc)
        endif
      else
        Aerosol_time = set_date (yr, mo, dy, hr, mn, sc)
      endif

!--------------------------------------------------------------------


end subroutine set_aerosol_time


!#####################################################################
! <SUBROUTINE NAME="aerosol_dealloc">
!  <OVERVIEW>
!    aerosol_dealloc deallocates the array components of an 
!    aersol_type derived type variable.
!  </OVERVIEW>
!  <DESCRIPTION>
!    aerosol_dealloc deallocates the array components of an 
!    aersol_type derived type variable.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call aerosol_dealloc
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine aerosol_dealloc (Aerosol)

!---------------------------------------------------------------------
!    aerosol_dealloc deallocates the array components of an 
!    aersol_type derived type variable.
!---------------------------------------------------------------------

type(aerosol_type), intent(inout) :: Aerosol

!---------------------------------------------------------------------
!  intent(inout) variables:
! 
!      Aerosol       aerosol_type variable containing information on
!                    the activated aerosol species
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('aerosol_mod',   &
                         'module has not been initialized',FATAL )
      endif

!---------------------------------------------------------------------
!    deallocate the components of the aerosol_type variable.
!---------------------------------------------------------------------
      deallocate (Aerosol%aerosol)
      deallocate (Aerosol%aerosol_names)
      deallocate (Aerosol%family_members)
 
!----------------------------------------------------------------------


end subroutine aerosol_dealloc


!#####################################################################

! <SUBROUTINE NAME="obtain_input_file_data">
!  <OVERVIEW>
!   obtain_input_file_data reads an input file containing a single
!    column aerosol profile. 
!  </OVERVIEW>
!  <DESCRIPTION>
!   obtain_input_file_data reads an input file containing a single
!    column aerosol profile. 
!  </DESCRIPTION>
!  <TEMPLATE>
!   call  obtain_input_file_data
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine obtain_input_file_data 

!---------------------------------------------------------------------
!    obtain_input_file_data reads an input file containing a single
!    column aerosol profile.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

      integer   :: iounit    ! unit to read file on
      integer   :: kmax_file ! number of levels of data in file
      integer   :: k         ! do-loop index
      character(len=31), dimension(200) :: dimnam
      integer(kind=4), dimension(200) :: dimsiz
      integer(kind=4)                 :: ncid, rcode, nvars, ndims, &
                                         ngatts, recdim
      integer    :: i, j
      integer, PARAMETER :: MAXDIMS = 10
      integer(kind=4), dimension(MAXDIMS) :: start, count, vdims
      integer(kind=4)                     :: ivarid, ntp, nvdim, nvs, &
                                             ndsize
      character(len=31)   dummy
      



!-------------------------------------------------------------------
!    determine if a netcdf input data file exists. if so, read the 
!    number of data records in the file.
!---------------------------------------------------------------------
      if (file_exist ( 'INPUT/id1aero.nc') ) then
        ncid = ncopn ('INPUT/id1aero.nc', 0, rcode)
        call ncinq (ncid, ndims, nvars, ngatts, recdim, rcode)
        do i=1,ndims
          call ncdinq (ncid, i, dimnam(i), dimsiz(i), rcode)
          if (dimnam(i) == 'lev') then
            kmax_file = dimsiz(i)
          endif
        end do
             
!-------------------------------------------------------------------
!    allocate space for the input data. read the data set. close the 
!    file upon completion.
!---------------------------------------------------------------------
        allocate (specified_aerosol(kmax_file) )
        ivarid = ncvid(ncid, 'aerosol', rcode)
        call ncvinq (ncid, ivarid, dummy, ntp, nvdim, vdims, nvs, rcode)
        do j=1,nvdim
          call ncdinq (ncid, vdims(j), dummy, ndsize, rcode)
          start(j) = 1
          count(j) = ndsize
        end do
       call ncvgt (ncid, ivarid, start, count, specified_aerosol, rcode)

         call ncclos (ncid, rcode)

!-------------------------------------------------------------------
!    determine if the input data input file exists in ascii format. if 
!    so, read the number of data records in the file.
!---------------------------------------------------------------------
      else if (file_exist ( 'INPUT/id1aero') ) then
        iounit = open_namelist_file ('INPUT/id1aero')
        read (iounit,FMT = '(i4)') kmax_file

!-------------------------------------------------------------------
!    allocate space for the input data. read the data set. close the 
!    file upon completion.
!---------------------------------------------------------------------
         allocate (specified_aerosol(kmax_file) )
         read (iounit,FMT = '(5e18.10)')   &
                          (specified_aerosol(k),k=1,kmax_file)
         call close_file (iounit)

!---------------------------------------------------------------------
!    if file is not present, write an error message.
!---------------------------------------------------------------------
       else
         call error_mesg ( 'aerosol_mod', &
              'desired aerosol input file is not present',FATAL)
       endif

!----------------------------------------------------------------------


end subroutine obtain_input_file_data 


!###################################################################### 



                  end module aerosol_mod 



!=======================================================================



#ifdef test_aerosol

program main

use aerosol_mod
use mpp_mod
use mpp_io_mod
use mpp_domains_mod
use time_manager_mod
use diag_manager_mod
use rad_utilities_mod




implicit none

!-----------------------------------------------------------------------
! ... Local variables
!-----------------------------------------------------------------------
integer, parameter :: NLON=20, NLAT=10,NLEV=8
integer, parameter :: MAX_AERSOL_NAMES = 100
real :: latb(NLON+1,NLAT+1),lonb(NLON+1,NLAT+1),pi,phalf(NLON,NLAT,NLEV+1)
integer :: i,nspecies
type(time_type) :: model_time
character(len=64), dimension(MAX_AEROSOL_NAMES) :: names
type(aerosol_type)  :: Aerosol

pi = 4.*atan(1.)

call mpp_init
call mpp_io_init
call mpp_domains_init
call diag_manager_init
call set_calendar_type(JULIAN)

do i = 1,NLAT+1
   latb(:,i) = -90. + 180.*REAL(i-1)/REAL(NLAT)
end do
do i = 1,NLON+1
   lonb(i,:) = -180. + 360.*REAL(i-1)/REAL(NLON)
end do

latb(:,:) = latb(:,:) * pi/180.
lonb(:,:) = lonb(:,:) * pi/180.

do i = 1,NLEV+1
   phalf(:,:,i) = 101325. * REAL(i-1) / REAL(NLEV)
end do

model_time = set_date(1980,1,1,0,0,0)

call aerosol_init (lonb, latb, names)

call aerosol_driver (1,1,model_time, phalf, Aerosol)

call aerosol_dealloc (Aerosol)

call aerosol_end

call mpp_exit

end program main

#endif

module vert_diff_mod

!=======================================================================
!
!                         VERTICAL DIFFUSION MODULE
!
!      Routines for computing the tendencies due to vertical diffusion
!
!=======================================================================

use   constants_mod, only:  GRAV, RDGAS, RVGAS, CP_AIR

use         fms_mod, only:  error_mesg, FATAL, uppercase, &
                            write_version_number, stdlog, &
                            mpp_pe, mpp_root_pe 

use   field_manager_mod, only: MODEL_ATMOS, MODEL_LAND, MODEL_ICE
use  tracer_manager_mod, only: query_method, get_number_tracers, &
     get_tracer_index, get_tracer_names, NO_TRACER

use mpp_mod, only: mpp_chksum, stdout

implicit none
private


! public interfaces
!=======================================================================
public :: vert_diff_init,          &
          vert_diff_end,           &
          gcm_vert_diff,               &
          gcm_vert_diff_down,          &
          gcm_vert_diff_up,            &
          vert_diff,                   &
          surf_diff_type

!=======================================================================

! form of interfaces
!=======================================================================


type surf_diff_type

  real, pointer, dimension(:,:) :: dtmass  => NULL(),   &
                                   dflux_t => NULL(),   &
                                   delta_t => NULL(),   &
                                   delta_u => NULL(),   &
                                   delta_v => NULL(), &
                                   sst_miz => NULL()
  real, pointer, dimension(:,:,:) :: dflux_tr => NULL(),& ! tracer flux tendency
                                     delta_tr => NULL()   ! tracer tendency
end type surf_diff_type


real,    allocatable, dimension(:,:,:) :: e_global, f_t_global, f_q_global
!-->cjg
real,    allocatable, dimension(:,:,:) :: e_clubb
!<--cjg

! storage compartment for tracer vert. diffusion options, and for f
! coefficient if necessary
type :: tracer_data_type
   real, pointer :: f(:,:,:) => NULL() ! f coefficient field
   logical :: do_vert_diff
!-->cjg: flag for tracers that should be diffused with diff_t_clubb instead of diff_t
!        i.e. all tracers except sphum, liq_wat, ice_wat, cld_amt, liq_drp, ice_num
   logical :: do_clubb_diff
!<--cjg
   logical :: do_surf_exch
end type tracer_data_type
! tracer diffusion options and storage for f coefficients
type(tracer_data_type), allocatable :: tracers(:)

      
logical :: do_conserve_energy = .true.
logical :: use_virtual_temp_vert_diff, do_mcm_plev
integer :: sphum, mix_rat
!-->cjg
integer :: do_clubb
integer :: liq_wat, ice_wat, cld_amt, liq_drp, ice_num
!<--cjg

!--------------------- version number ---------------------------------

character(len=128) :: version = '$Id: vert_diff.F90,v 20.0 2013/12/13 23:22:25 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
logical            :: module_is_initialized = .false.

real, parameter :: d608 = (RVGAS-RDGAS)/RDGAS

contains

!#######################################################################

subroutine vert_diff_init (Tri_surf, idim, jdim, kdim,    &
                               do_conserve_energy_in,         &
                               use_virtual_temp_vert_diff_in, &
                               do_mcm_plev_in, do_clubb_in )  !cjg

 type(surf_diff_type), intent(inout) :: Tri_surf
 integer,              intent(in)    :: idim, jdim, kdim
 logical,              intent(in)    :: do_conserve_energy_in
 logical, optional,    intent(in)    :: use_virtual_temp_vert_diff_in
 logical, optional,    intent(in)    :: do_mcm_plev_in
!-->cjg
 integer, optional,    intent(in)    :: do_clubb_in
!<--cjg

 integer :: ntprog ! number of prognostic tracers in the atmosphere
 character(len=32)  :: tr_name ! tracer name
 character(len=128) :: scheme  ! tracer diffusion scheme
 integer :: n, logunit

    call write_version_number(version, tagname)

! get the number of prognostic tracers
    call get_number_tracers( MODEL_ATMOS, num_prog=ntprog)

! get the tracer number for specific humidity
    sphum = get_tracer_index( MODEL_ATMOS, 'sphum')
    mix_rat=get_tracer_index( MODEL_ATMOS, 'mix_rat')
    if(sphum /= NO_TRACER .and. mix_rat /= NO_TRACER) then
      call error_mesg('gcm_vert_diff_init','sphum and mix_rat cannot both'// &
                      'be present in the field_table at the same time', FATAL)
    endif

    logunit = stdlog()
    if (mpp_pe() == mpp_root_pe()) then
      write (logunit,'(a,i12)') 'Tracer number for specific humidity =',sphum
      write (logunit,'(a,i12)') 'Tracer number for mixing ratio      =',mix_rat
    endif

    if(sphum==NO_TRACER) sphum=mix_rat

!-->cjg
    if (present(do_clubb_in)) then
         do_clubb = do_clubb_in
    else
         do_clubb = 0
    endif

    liq_wat = get_tracer_index( MODEL_ATMOS, 'liq_wat')
    ice_wat = get_tracer_index( MODEL_ATMOS, 'ice_wat')
    cld_amt = get_tracer_index( MODEL_ATMOS, 'cld_amt')
    liq_drp = get_tracer_index( MODEL_ATMOS, 'liq_drp')
    ice_num = get_tracer_index( MODEL_ATMOS, 'ice_num')
!<--cjg

    if(present(use_virtual_temp_vert_diff_in)) then
      use_virtual_temp_vert_diff = use_virtual_temp_vert_diff_in
    else
      use_virtual_temp_vert_diff = .false.
    endif
    if(present(do_mcm_plev_in)) then
      do_mcm_plev = do_mcm_plev_in
    else
      do_mcm_plev = .false.
    endif

 if (.not. module_is_initialized) then

    if (allocated(  e_global ))    deallocate (  e_global )
    if (allocated(f_t_global ))    deallocate (f_t_global )
    if (allocated(f_q_global ))    deallocate (f_q_global )

    allocate(  e_global (idim, jdim, kdim-1)) ;   e_global = 0.0
    allocate(f_t_global (idim, jdim, kdim-1)) ; f_t_global = 0.0 
    allocate(f_q_global (idim, jdim, kdim-1)) ; f_q_global = 0.0

!-->cjg
    if (do_clubb > 0) then
      if (allocated( e_clubb )) deallocate ( e_clubb )
      allocate( e_clubb (idim, jdim, kdim-1)) ; e_clubb = 0.0
    end if
!<--cjg

    module_is_initialized = .true.

 endif

 call alloc_surf_diff_type ( Tri_surf, idim, jdim, ntprog )
 
 do_conserve_energy = do_conserve_energy_in

 ! allocate data storage for tracers
 allocate ( tracers(ntprog) )
 do n = 1,ntprog
    ! skip tracers diffusion if it is turned off in the field table
    tracers(n)%do_vert_diff = .true. 
    if (query_method('diff_vert',MODEL_ATMOS,n,scheme)) then
       tracers(n)%do_vert_diff = (uppercase(scheme) /= 'NONE')
    endif

    !-->cjg: if clubb is activated, any tracer except should use do_clubb_diff
    if (do_clubb > 0 .and. (n/=sphum .and. n/=liq_wat .and. n/=ice_wat .and.   &
                        n/=cld_amt .and. n/=liq_drp .and. n/=ice_num )) then
      tracers(n)%do_vert_diff = .false.
      tracers(n)%do_clubb_diff = .true. 
    else
      tracers(n)%do_clubb_diff = .false. 
    endif
    !<--cjg

    ! do not exchange tracer with surface if it is not present in either land or
    ! ice model
    if (n==sphum) then
       tracers(n)%do_vert_diff = .false.
       tracers(n)%do_surf_exch = .false.
    else
       call get_tracer_names ( MODEL_ATMOS, n, tr_name )
       tracers(n)%do_surf_exch = &
            get_tracer_index ( MODEL_LAND, tr_name ) /= NO_TRACER .or.&
            get_tracer_index ( MODEL_ICE,  tr_name ) /= NO_TRACER
    endif
    ! if tracer goes through surface flux, allocate memory to hold f
    ! between downward and upward sweeps
    if(tracers(n)%do_surf_exch)&
         allocate(tracers(n)%f(idim,jdim,kdim-1))
 enddo

 write(logunit,*)'Tracer vertical diffusion properties:'
 do n = 1,ntprog
    call get_tracer_names(MODEL_ATMOS, n, tr_name)
    write(logunit,100)tr_name,tracers(n)%do_vert_diff,tracers(n)%do_surf_exch
 enddo
100 FORMAT('Tracer :',a32,': do_tr_vert_diff=',L1,' : do_tr_surf_exch=',L1)

end subroutine vert_diff_init

!#######################################################################

subroutine alloc_surf_diff_type ( Tri_surf, idim, jdim, ntprog )

type(surf_diff_type), intent(inout) :: Tri_surf
integer,              intent(in)    :: idim, jdim, ntprog

    allocate( Tri_surf%dtmass    (idim, jdim) ) ; Tri_surf%dtmass  = 0.0
    allocate( Tri_surf%dflux_t   (idim, jdim) ) ; Tri_surf%dflux_t = 0.0
    allocate( Tri_surf%delta_t   (idim, jdim) ) ; Tri_surf%delta_t = 0.0
    allocate( Tri_surf%delta_u   (idim, jdim) ) ; Tri_surf%delta_u = 0.0
    allocate( Tri_surf%delta_v   (idim, jdim) ) ; Tri_surf%delta_v = 0.0
    allocate( Tri_surf%sst_miz   (idim, jdim) ) ; Tri_surf%sst_miz = 280.0 !miz
    allocate( Tri_surf%dflux_tr  (idim, jdim, ntprog) ) ; Tri_surf%dflux_tr = 0.0
    allocate( Tri_surf%delta_tr  (idim, jdim, ntprog) ) ; Tri_surf%delta_tr = 0.0

end subroutine alloc_surf_diff_type

!#######################################################################

subroutine dealloc_surf_diff_type ( Tri_surf )

type(surf_diff_type), intent(inout) :: Tri_surf

      deallocate( Tri_surf%dtmass    )
      deallocate( Tri_surf%dflux_t   )
      deallocate( Tri_surf%delta_t   )
      deallocate( Tri_surf%delta_u   )
      deallocate( Tri_surf%delta_v   )
      deallocate( Tri_surf%sst_miz   )!miz
      deallocate( Tri_surf%dflux_tr  )
      deallocate( Tri_surf%delta_tr  )

end subroutine dealloc_surf_diff_type

!#######################################################################

subroutine vert_diff_end

  integer :: n

  if (module_is_initialized) then

    if (allocated(   e_global ))    deallocate (   e_global)
    if (allocated( f_t_global ))    deallocate ( f_t_global)
    if (allocated( f_q_global ))    deallocate ( f_q_global)

    if(allocated(tracers)) then
       do n = 1,size(tracers(:))
          if ( associated(tracers(n)%f) ) deallocate(tracers(n)%f)
       enddo
       deallocate(tracers)
    endif
  endif
  module_is_initialized = .false.


end subroutine vert_diff_end

!#######################################################################

subroutine gcm_vert_diff_down (is, js, delt,                &
                          u, v, t, q, tr,                   &
                          diff_m, diff_t, p_half, p_full,   &
                          z_full, tau_u, tau_v,             &
                          dtau_du, dtau_dv,                 &
                          dt_u, dt_v, dt_t, dt_q, dt_tr,    &
                          dissipative_heat, Tri_surf,       &
                          diff_t_clubb, kbot                ) !cjg
integer, intent(in)                        :: is, js
real,    intent(in)                        :: delt
real,    intent(in)   , dimension(:,:,:)   :: u, v, t, q,     &
                                              diff_m, diff_t, &
                                              p_half, p_full, &
                                              z_full
real,    intent(in)   , dimension(:,:,:,:) :: tr
real,    intent(in)   , dimension(:,:)     :: dtau_du, dtau_dv
real,    intent(inout), dimension(:,:)     :: tau_u, tau_v
real,    intent(inout), dimension(:,:,:)   :: dt_u, dt_v, dt_t
real,    intent(in),    dimension(:,:,:)   :: dt_q
real,    intent(inout), dimension(:,:,:,:) :: dt_tr
real,    intent(out)  , dimension(:,:,:)   :: dissipative_heat
type(surf_diff_type), intent(inout)        :: Tri_surf

!-->cjg
real,    intent(in)   , dimension(:,:,:), optional :: diff_t_clubb
!<--cjg
integer, intent(in)   , dimension(:,:), optional :: kbot

! ---- local vars
real, dimension(size(u,1),size(u,2),size(u,3)) :: &
     tt, mu, nu, e, a, b, c, g, f_tr
real, dimension(size(u,1),size(u,2)) ::           &
     f_t_delt_n1, f_q_delt_n1, f_tr_delt_n1, flux_tr, dflux_dtr, &
     mu_delt_n, nu_n, e_n1, delta_t_n, delta_q_n, delta_tr_n, &
            delta_u_n, delta_v_n
real    :: gcp
integer :: i, j, n, kb, ie, je, ntr, nlev

!-----------------------------------------------------------------------

  if(.not. module_is_initialized) call error_mesg ('gcm_vert_diff_down in vert_diff_mod',  &
      'the initialization routine gcm_vert_diff_init has not been called', &
       FATAL)

!-->cjg
 if(do_clubb > 0 .and. .not.present(diff_t_clubb)) then
     call error_mesg ('gcm_vert_diff_down in vert_diff_mod',  &
     'diff_t_clubb must be present when do_clubb > 0', FATAL)
 endif
!<--cjg
    
 ie = is + size(t,1) -1
 je = js + size(t,2) -1
 ntr  = size(tr,4)
 nlev = size(mu,3)
 
 gcp       = GRAV/CP_AIR
 tt  = t + z_full*gcp   ! the vertical gradient of tt determines the
                        ! diffusive flux of temperature

 call compute_mu (p_half, mu)
 call compute_nu (diff_m, p_half, p_full, z_full, t, q, nu) 

!  diffuse u-momentum and v_momentum
 call uv_vert_diff (delt, mu, nu, u, v, dtau_du, dtau_dv, tau_u, tau_v,  &
                    dt_u, dt_v, dt_t, delta_u_n, delta_v_n,         &
                    dissipative_heat, kbot)
                            
!  recompute nu for a different diffusivity
 call compute_nu   (diff_t, p_half, p_full, z_full, t, q, nu)

 ! calculate e, the same for all tracers since their diffusivities are 
 ! the same, and mu_delt_n, nu_n, e_n1
 call compute_e (delt, mu, nu, e, a, b, c, g)
 do j = 1,size(mu,2)
 do i = 1,size(mu,1)
    kb = nlev ; if(present(kbot)) kb=kbot(i,j)
    mu_delt_n(i,j) = mu(i,j,kb  )*delt
         nu_n(i,j) = nu(i,j,kb  )
         e_n1(i,j) = e (i,j,kb-1)
 enddo
 enddo

 do n = 1,ntr
    ! calculate f_tr, f_tr_delt_n1, delta_tr_n for this tracer
    if(.not.tracers(n)%do_vert_diff) cycle ! skip non-diffusive tracers
    call explicit_tend (mu, nu, tr(:,:,:,n), dt_tr(:,:,:,n))
    call compute_f (dt_tr(:,:,:,n), b, c, g, f_tr)
    do j = 1,size(mu,2)
    do i = 1,size(mu,1)
       kb = nlev ; if(present(kbot)) kb=kbot(i,j)
       f_tr_delt_n1(i,j) = f_tr (i,j,kb-1)*delt
       delta_tr_n(i,j)   = dt_tr(i,j,kb,n)*delt
    enddo
    enddo

    ! store information needed by flux_exchange module
    Tri_surf%delta_tr(is:ie,js:je,n) = &
         delta_tr_n(:,:) + mu_delt_n(:,:)*nu_n(:,:)*f_tr_delt_n1(:,:)
    Tri_surf%dflux_tr(is:ie,js:je,n) = -nu_n(:,:)*(1.0 - e_n1(:,:))

    if(tracers(n)%do_surf_exch) then
       ! store f for future use on upward sweep
       tracers(n)%f(is:ie,js:je,:) = f_tr(:,:,:)
    else
       ! upward sweep of tridaigonal solver for tracers that do not exchange 
       ! with surface
       flux_tr  (:,:) = 0.0 ! surface flux of tracer
       dflux_dtr(:,:) = 0.0 ! d(sfc flux)/d(tr atm)
       call diff_surface ( &
            mu_delt_n(:,:), nu_n(:,:), e_n1(:,:), f_tr_delt_n1(:,:), &
            dflux_dtr(:,:), flux_tr(:,:), 1.0, delta_tr_n(:,:) )
       call vert_diff_up ( &
            delt, e(:,:,:), f_tr(:,:,:), delta_tr_n(:,:), dt_tr(:,:,:,n), &
            kbot )
    endif
 enddo

! NOTE: actually e used in the tracer calculations above, and e_global
! calculated in the vert_diff_down_2 below are the same, since they only
! depend on mu and nu.

!  downward sweep of tridiagonal solver for temperature and specific humidity
 call vert_diff_down_2                            & 
         (delt, mu, nu, tt, q, dt_t, dt_q,        &  
         e_global             (is:ie,js:je,:),    &
         f_t_global           (is:ie,js:je,:),    &
         f_q_global           (is:ie,js:je,:),    &
         mu_delt_n, nu_n, e_n1, f_t_delt_n1, f_q_delt_n1, &
         delta_t_n, delta_q_n, kbot)

! store information needed by flux_exchange module

    Tri_surf%delta_t (is:ie,js:je) = delta_t_n + mu_delt_n*nu_n*f_t_delt_n1
    Tri_surf%dflux_t (is:ie,js:je) = -nu_n*(1.0 - e_n1)
    if (sphum/=NO_TRACER) then
       Tri_surf%delta_tr (is:ie,js:je,sphum) = delta_q_n + mu_delt_n*nu_n*f_q_delt_n1
       Tri_surf%dflux_tr (is:ie,js:je,sphum) = -nu_n*(1.0 - e_n1)
    endif
    Tri_surf%dtmass  (is:ie,js:je) = mu_delt_n
    Tri_surf%delta_u (is:ie,js:je) = delta_u_n
    Tri_surf%delta_v (is:ie,js:je) = delta_v_n

!--> cjg
 ! Perform diffusion for tracers using diff_t_clubb mixing coefficients
 if (do_clubb > 0) then
   !  recompute nu for a different diffusivity
   call compute_nu   (diff_t_clubb, p_half, p_full, z_full, t, q, nu)
   ! calculate e, the same for all tracers since their diffusivities are 
   ! the same, and mu_delt_n, nu_n, e_n1
   call compute_e (delt, mu, nu, e, a, b, c, g)
   do j = 1,size(mu,2)
   do i = 1,size(mu,1)
      kb = nlev ; if(present(kbot)) kb=kbot(i,j)
      mu_delt_n(i,j) = mu(i,j,kb  )*delt
           nu_n(i,j) = nu(i,j,kb  )
           e_n1(i,j) = e (i,j,kb-1)
   enddo
   enddo

   do n = 1,ntr
      ! calculate f_tr, f_tr_delt_n1, delta_tr_n for this tracer
      if(.not.tracers(n)%do_clubb_diff) cycle ! skip non-diffusive tracers
      call explicit_tend (mu, nu, tr(:,:,:,n), dt_tr(:,:,:,n))
      call compute_f (dt_tr(:,:,:,n), b, c, g, f_tr)
      do j = 1,size(mu,2)
      do i = 1,size(mu,1)
         kb = nlev ; if(present(kbot)) kb=kbot(i,j)
         f_tr_delt_n1(i,j) = f_tr (i,j,kb-1)*delt
         delta_tr_n(i,j)   = dt_tr(i,j,kb,n)*delt
      enddo
      enddo

      ! store information needed by flux_exchange module
      Tri_surf%delta_tr(is:ie,js:je,n) = &
           delta_tr_n(:,:) + mu_delt_n(:,:)*nu_n(:,:)*f_tr_delt_n1(:,:)
      Tri_surf%dflux_tr(is:ie,js:je,n) = -nu_n(:,:)*(1.0 - e_n1(:,:))

      if(tracers(n)%do_surf_exch) then
         ! store f for future use on upward sweep
         tracers(n)%f(is:ie,js:je,:) = f_tr(:,:,:)
      else
       ! upward sweep of tridaigonal solver for tracers that do not exchange 
         ! with surface
         flux_tr  (:,:) = 0.0 ! surface flux of tracer
         dflux_dtr(:,:) = 0.0 ! d(sfc flux)/d(tr atm)
         call diff_surface ( &
              mu_delt_n(:,:), nu_n(:,:), e_n1(:,:), f_tr_delt_n1(:,:), &
              dflux_dtr(:,:), flux_tr(:,:), 1.0, delta_tr_n(:,:) )
         call vert_diff_up ( &
              delt, e(:,:,:), f_tr(:,:,:), delta_tr_n(:,:), dt_tr(:,:,:,n), &
              kbot )
      endif
   enddo

   ! Store e for upward pass
   e_clubb = e

 endif
!<--cjg

!-----------------------------------------------------------------------

end subroutine gcm_vert_diff_down

!#######################################################################

subroutine gcm_vert_diff_up (is, js, delt, Tri_surf, dt_t, dt_q, dt_tr, kbot)

integer, intent(in)                      :: is, js
real,    intent(in)                      :: delt
type(surf_diff_type), intent(in)         :: Tri_surf
real,    intent(out),   dimension(:,:,:) :: dt_t, dt_q
real,    intent(out),   dimension(:,:,:,:) :: dt_tr
integer, intent(in),    dimension(:,:), optional :: kbot

 ! ---- local vars
 integer :: ie, je, n
 real    :: surf_delta_q(size(dt_t,1),size(dt_t,2))

 ie = is + size(dt_t,1) -1
 je = js + size(dt_t,2) -1

! outunit = stdout()
!checksums! write(outunit,'("CHECKSUM::",A32," = ",Z20)')'e_global',mpp_chksum(e_global(is:ie,js:je,:))
!checksums! write(outunit,'("CHECKSUM::",A32," = ",Z20)')'f_t_global',mpp_chksum(f_t_global(is:ie,js:je,:))
!checksums! write(outunit,'("CHECKSUM::",A32," = ",Z20)')'Tri_surf%deta_t',mpp_chksum(Tri_surf%delta_t(is:ie,js:je))

 call vert_diff_up (delt ,                              &
                    e_global          (is:ie,js:je,:) , &
                    f_t_global        (is:ie,js:je,:) , &
                    Tri_surf%delta_t  (is:ie,js:je) ,   &
                    dt_t, kbot )

!checksums! write(outunit,'("CHECKSUM::",A32," = ",Z20)')'dt_t',mpp_chksum(dt_t)

 if(sphum/=NO_TRACER) then
    surf_delta_q = Tri_surf%delta_tr (is:ie,js:je,sphum)
 else
    surf_delta_q = 0.0
 endif

!checksums! write(outunit,'("CHECKSUM::",A32," = ",Z20)')'surf_delta_q',mpp_chksum(surf_delta_q)
!checksums! write(outunit,'("CHECKSUM::",A32," = ",Z20)')'f_q_global',mpp_chksum(f_q_global(is:ie,js:je,:))

 call vert_diff_up (delt ,                              &
                    e_global          (is:ie,js:je,:) , &
                    f_q_global        (is:ie,js:je,:) , &
                    surf_delta_q ,                      &
                    dt_q, kbot )

!checksums! write(outunit,'("CHECKSUM::",A32," = ",Z20)')'dt_q',mpp_chksum(dt_q)

 do n = 1,size(dt_tr,4)
    ! skip tracers if diffusion scheme turned off
    if (tracers(n)%do_vert_diff.and.tracers(n)%do_surf_exch) then
       call vert_diff_up (delt ,                           &
                    e_global           (is:ie,js:je,:) ,   &
                    tracers(n)%f       (is:ie,js:je,:) ,   &
                    Tri_surf%delta_tr  (is:ie,js:je,n) ,   &
                    dt_tr(:,:,:,n), kbot )
!-->cjg
    elseif (tracers(n)%do_clubb_diff.and.tracers(n)%do_surf_exch) then
       call vert_diff_up (delt ,                           &
                    e_clubb            (is:ie,js:je,:) ,   &
                    tracers(n)%f       (is:ie,js:je,:) ,   &
                    Tri_surf%delta_tr  (is:ie,js:je,n) ,   &
                    dt_tr(:,:,:,n), kbot )
!<--cjg
    endif
 enddo

end subroutine gcm_vert_diff_up

!#######################################################################

subroutine gcm_vert_diff (delt, u, v, t, q, tr,                    &
                          diff_m, diff_t, p_half, p_full, z_full,  &
                          dtau_du, dtau_dv, dsens_datmos, devap_datmos, &
                          sens, evap, tau_u, tau_v,                &
                          dt_u, dt_v, dt_t, dt_q, dt_tr,           &
                          dissipative_heat, kbot      )

!  one-step diffusion call for gcm in which there is no implicit dependence of 
!    surface fluxes on surface temperature

real,    intent(in)                          :: delt
real,    intent(in)   , dimension(:,:,:)     :: u, v, t, q, p_half, p_full, &
                                                z_full, diff_m, diff_t
real,    intent(in)   , dimension(:,:,:,:)   :: tr
real,    intent(in)   , dimension(:,:)       :: dtau_du, dtau_dv, dsens_datmos, &
                                                devap_datmos
real,    intent(inout), dimension(:,:)       :: tau_u, tau_v, sens, evap
real,    intent(inout), dimension(:,:,:)     :: dt_u, dt_v, dt_t, dt_q
real,    intent(inout), dimension(:,:,:,:)   :: dt_tr
real,    intent(out)  , dimension(:,:,:)     :: dissipative_heat

integer, intent(in)   , dimension(:,:), optional :: kbot

real, dimension(size(u,1),size(u,2),size(u,3)) :: mu, nu
real, dimension(size(u,1),size(u,2))           :: delta_u_n, delta_v_n


!-----------------------------------------------------------------------

 call compute_mu (p_half, mu)

 call compute_nu (diff_m, p_half, p_full, z_full, t, q, nu) 
 
 call uv_vert_diff (delt, mu, nu, u, v, dtau_du, dtau_dv, tau_u, tau_v, &
                    dt_u, dt_v, dt_t, delta_u_n, delta_v_n,        &
                    dissipative_heat, kbot)
                    
 call compute_nu   (diff_t, p_half, p_full, z_full, t, q, nu)

 call tq_vert_diff (delt, mu, nu, t, q, z_full,  &
                    dsens_datmos, devap_datmos,  &
                    sens, evap, dt_t, dt_q, kbot )

 call tr_vert_diff (delt, mu, nu, tr, dt_tr, kbot )

end subroutine gcm_vert_diff

!#######################################################################

subroutine vert_diff (delt, xi, t, q, diff, p_half, p_full, z_full, &
                      flux, dflux_datmos, factor, dt_xi, kbot)

! one-step diffusion of a single field 

real,    intent(in)                          :: delt
real,    intent(in)   , dimension(:,:,:)     :: xi, t, q, diff, p_half, p_full, z_full
real,    intent(inout), dimension(:,:)       :: flux
real,    intent(in)   , dimension(:,:)       :: dflux_datmos
real,    intent(in)                          :: factor
real,    intent(inout), dimension(:,:,:)     :: dt_xi

integer, intent(in)   , dimension(:,:), optional :: kbot

real, dimension(size(xi,1),size(xi,2),size(xi,3)  ) :: mu, nu
real, dimension(size(xi,1),size(xi,2),size(xi,3)-1) :: e, f

real, dimension(size(xi,1),size(xi,2))  :: mu_delt_n, nu_n, e_n1,  &
                                           f_delt_n1, delta_xi_n

!-----------------------------------------------------------------------

 call compute_mu    (p_half, mu)

 call compute_nu    (diff, p_half, p_full, z_full, t, q, nu) 

 call vert_diff_down &
     (delt, mu, nu, xi, dt_xi, e, f, mu_delt_n, nu_n, e_n1,  &
      f_delt_n1, delta_xi_n, kbot)

 call diff_surface (mu_delt_n, nu_n, e_n1, f_delt_n1,     &
                    dflux_datmos, flux, factor, delta_xi_n)

 call vert_diff_up (delt, e, f, delta_xi_n, dt_xi, kbot)

end subroutine vert_diff


!#######################################################################

subroutine uv_vert_diff (delt, mu, nu, u, v,  &
                         dtau_du, dtau_dv, tau_u, tau_v, dt_u, dt_v, dt_t, &
                          delta_u_n, delta_v_n, dissipative_heat, kbot )

real,    intent(in)                        :: delt
real,    intent(in)   , dimension(:,:,:)   :: u, v, mu, nu
real,    intent(in)   , dimension(:,:)     :: dtau_du, dtau_dv
real,    intent(inout), dimension(:,:)     :: tau_u, tau_v
real,    intent(inout), dimension(:,:,:)   :: dt_u, dt_v, dt_t
real,    intent(out)  , dimension(:,:,:)   :: dissipative_heat
real,    intent(out)  , dimension(:,:)     :: delta_u_n, delta_v_n

! Note (IH) 
!   delta_u_n = dt_u/delt at lowest model level, and similarly
!   for delta_v_n  -- it is convenient to output them separately

integer, intent(in)   , dimension(:,:), optional :: kbot

real, dimension(size(u,1),size(u,2)) :: mu_delt_n, nu_n, e_n1,    &
                                        f_u_delt_n1, f_v_delt_n1
                                        
real, dimension(size(u,1),size(u,2),size(u,3)) :: dt_u_temp, dt_v_temp

real, dimension(size(u,1),size(u,2),size(u,3)-1) :: e, f_u, f_v

real    :: half_delt, cp_inv


!-----------------------------------------------------------------------

 half_delt = 0.5*delt
 cp_inv    = 1.0/CP_AIR
 
 if (do_conserve_energy) then
   dt_u_temp = dt_u
   dt_v_temp = dt_v
 endif
 
 call vert_diff_down_2 &
     (delt, mu, nu, u, v, dt_u, dt_v, e, f_u, f_v, &
      mu_delt_n, nu_n, e_n1, f_u_delt_n1, f_v_delt_n1,  &
      delta_u_n, delta_v_n, kbot)        

 call diff_surface (mu_delt_n, nu_n, e_n1, f_u_delt_n1, &
                    dtau_du, tau_u, 1.0, delta_u_n)
 call diff_surface (mu_delt_n, nu_n, e_n1, f_v_delt_n1, &
                    dtau_dv, tau_v, 1.0, delta_v_n)

 call vert_diff_up (delt, e, f_u, delta_u_n, dt_u, kbot)
 call vert_diff_up (delt, e, f_v, delta_v_n, dt_v, kbot)

 if (do_conserve_energy) then
    dt_u_temp = dt_u - dt_u_temp
    dt_v_temp = dt_v - dt_v_temp
    dissipative_heat = - cp_inv*( (u + half_delt*dt_u_temp)*dt_u_temp &
                                 +(v + half_delt*dt_v_temp)*dt_v_temp )
    dt_t = dt_t + dissipative_heat
 else
    dissipative_heat = 0.0
 endif

!-----------------------------------------------------------------------

end subroutine uv_vert_diff

!#######################################################################

subroutine tq_vert_diff (delt, mu, nu, t, q,  z_full, &
                         dsens_datmos, devap_datmos, sens, evap, &
                         dt_t, dt_q, kbot)
                         

real,    intent(in)                        :: delt
real,    intent(in)   , dimension(:,:,:)   :: t, q, z_full, mu, nu
real,    intent(in)   , dimension(:,:)     :: dsens_datmos, devap_datmos
real,    intent(inout), dimension(:,:)     :: sens, evap
real,    intent(inout), dimension(:,:,:)   :: dt_t, dt_q

integer, intent(in)   , dimension(:,:), optional :: kbot

real, dimension(size(t,1),size(t,2)) :: mu_delt_n, nu_n,          &
                                        e_n1, f_t_delt_n1, f_q_delt_n1, &
                                        delta_t_n, delta_q_n

real, dimension(size(t,1),size(t,2),size(t,3)-1) :: e, f_t, f_q
real, dimension(size(t,1),size(t,2),size(t,3)  ) :: tt

real    :: gcp
!-----------------------------------------------------------------------

 gcp = GRAV/CP_AIR
 tt  = t + z_full*gcp
  
 call vert_diff_down_2 &
     (delt, mu, nu, tt, q, dt_t, dt_q, e, f_t, f_q,    &
      mu_delt_n, nu_n, e_n1, f_t_delt_n1, f_q_delt_n1, &
      delta_t_n, delta_q_n, kbot)


 call diff_surface (mu_delt_n, nu_n, e_n1, f_t_delt_n1,  &
                    dsens_datmos, sens, CP_AIR, delta_t_n)

 call diff_surface (mu_delt_n, nu_n, e_n1, f_q_delt_n1,  &
                    devap_datmos, evap, 1.0, delta_q_n)

 call vert_diff_up (delt, e, f_t, delta_t_n, dt_t, kbot)
 call vert_diff_up (delt, e, f_q, delta_q_n, dt_q, kbot)


!-----------------------------------------------------------------------

end subroutine tq_vert_diff

!#######################################################################

subroutine tr_vert_diff (delt, mu, nu, tr, dt_tr, kbot )

real,    intent(in)                        :: delt
real,    intent(in)   , dimension(:,:,:)   :: mu, nu
real,    intent(in)   , dimension(:,:,:,:) :: tr
real,    intent(inout), dimension(:,:,:,:) :: dt_tr

integer, intent(in)   , dimension(:,:), optional :: kbot

real, dimension(size(tr,1),size(tr,2)) :: mu_delt_n, nu_n, e_n1

real, dimension(size(tr,1),size(tr,2)) :: f_delt_n1, delta_tr_n
real, dimension(size(tr,1),size(tr,2)) :: dflux_dtr, flux
real, dimension(size(tr,1),size(tr,2),size(tr,3)-1) :: ftr
real, dimension(size(tr,1),size(tr,2),size(tr,3)-1) :: etr
real, dimension(size(tr,1),size(tr,2),size(tr,3)) :: a, b, c, g
integer :: i, j, kb, n, ntr, nlev
character(len=128) :: scheme
!-----------------------------------------------------------------------

 ntr  = size(tr,4) ! number of prognostic tracers

 dflux_dtr = 0.0
 call compute_e (delt, mu, nu, etr, a, b, c, g)
 if (present(kbot)) then
   do j=1,size(tr,2)
   do i=1,size(tr,1)
      kb = kbot(i,j)
      mu_delt_n(i,j) =  mu(i,j,kb  )*delt
           nu_n(i,j) =  nu(i,j,kb  )
           e_n1(i,j) = etr(i,j,kb-1)
   enddo
   enddo
 else
   nlev = size(mu,3)
   mu_delt_n(:,:) =  mu(:,:,nlev  )*delt
        nu_n(:,:) =  nu(:,:,nlev  )
        e_n1(:,:) = etr(:,:,nlev-1)
 endif
  
 do n = 1, ntr
   if ( n == sphum .or. n == mix_rat) cycle
   if (query_method('diff_vert',MODEL_ATMOS,n,scheme)) then
     if(uppercase(trim(scheme)) == 'NONE') cycle
   endif
   call explicit_tend (mu, nu, tr(:,:,:,n), dt_tr(:,:,:,n))
   call compute_f (dt_tr(:,:,:,n), b, c, g, ftr)
   if (present(kbot)) then
     do j=1,size(tr,2)
     do i=1,size(tr,1)
       kb = kbot(i,j)
       f_delt_n1(i,j)  =   ftr(i,j,kb-1)*delt
       delta_tr_n(i,j) = dt_tr(i,j,kb,n)*delt
     enddo
     enddo
   else
      f_delt_n1(:,:) =   ftr(:,:,nlev-1)*delt
     delta_tr_n(:,:) = dt_tr(:,:,nlev  ,n)*delt
   endif
   flux = 0.0
   call diff_surface (mu_delt_n, nu_n, e_n1, f_delt_n1, dflux_dtr, flux, 1.0, delta_tr_n)

! If flux needs to be saved then it should be made a module variable.
! vert_diff_init must allocate it and then call assign_tracer_field
! to set a pointer in tracer_manager_mod. It can be allocated as a
! 3 dimensional array with the 3'd index for tracer number.

   call vert_diff_up (delt, etr, ftr, delta_tr_n, dt_tr(:,:,:,n), kbot)
 end do

!-----------------------------------------------------------------------

end subroutine tr_vert_diff

!#######################################################################

subroutine vert_diff_down &
      (delt, mu, nu, tr, dt_tr, e, f, mu_delt_n, nu_n,  &
       e_n1, f_delt_n1, delta_tr_n, kbot)

!-----------------------------------------------------------------------

real,    intent(in)                         :: delt
real,    intent(in)    , dimension(:,:,:)   :: mu, nu
real,    intent(in)    , dimension(:,:,:)   :: tr
real,    intent(inout) , dimension(:,:,:)   :: dt_tr
real,    intent(out)   , dimension(:,:,:)   :: e
real,    intent(out)   , dimension(:,:,:)   :: f
real,    intent(out)   , dimension(:,:)     :: mu_delt_n, nu_n, e_n1
real,    intent(out)   , dimension(:,:)     :: f_delt_n1, delta_tr_n

integer, intent(in),    dimension(:,:), optional :: kbot

real, dimension(size(tr,1),size(tr,2),size(tr,3)) :: a, b, c, g

integer :: i, j, kb, nlev

!-----------------------------------------------------------------------

 call explicit_tend (mu, nu, tr, dt_tr)

 call compute_e  (delt, mu, nu, e, a, b, c, g)

 call compute_f (dt_tr, b, c, g, f)


 if (present(kbot)) then
    do j=1,size(tr,2)
    do i=1,size(tr,1)
        kb = kbot(i,j)
        mu_delt_n(i,j) =  mu(i,j,kb  )*delt
             nu_n(i,j) =  nu(i,j,kb  )
             e_n1(i,j) =   e(i,j,kb-1)
    enddo
    enddo
    do j=1,size(tr,2)
    do i=1,size(tr,1)
        kb = kbot(i,j)
         f_delt_n1(i,j) =     f(i,j,kb-1)*delt
        delta_tr_n(i,j) = dt_tr(i,j,kb  )*delt
    enddo
    enddo
 else
        nlev = size(mu,3)
        mu_delt_n(:,:) =       mu(:,:,nlev  )*delt
             nu_n(:,:) =       nu(:,:,nlev  )
             e_n1(:,:) =        e(:,:,nlev-1)
        f_delt_n1(:,:) =        f(:,:,nlev-1)*delt
       delta_tr_n(:,:) =    dt_tr(:,:,nlev  )*delt
 endif



!-----------------------------------------------------------------------

end subroutine vert_diff_down

!#######################################################################

subroutine vert_diff_down_2 &
      (delt, mu, nu, xi_1, xi_2, dt_xi_1, dt_xi_2, e, f_1, f_2, &
       mu_delt_n, nu_n, e_n1, f_1_delt_n1, f_2_delt_n1,         &
       delta_1_n, delta_2_n, kbot)

!-----------------------------------------------------------------------

real,    intent(in)                       :: delt
real,    intent(in)    , dimension(:,:,:) :: mu, nu, xi_1, xi_2
real,    intent(in)    , dimension(:,:,:) :: dt_xi_1, dt_xi_2
real,    intent(out)   , dimension(:,:,:) :: e, f_1, f_2
real,    intent(out)   , dimension(:,:)   :: mu_delt_n, nu_n, e_n1,    &
                                             f_1_delt_n1, f_2_delt_n1, &
                                             delta_1_n, delta_2_n

integer, intent(in),    dimension(:,:), optional :: kbot

real, dimension(size(xi_1,1),size(xi_1,2),size(xi_1,3)) :: a, b, c, g, &
                                                      dt_xi_11, dt_xi_22

integer :: i, j, kb, nlev

!-----------------------------------------------------------------------

! local copy of input 
  dt_xi_11 = dt_xi_1
  dt_xi_22 = dt_xi_2

 call explicit_tend (mu, nu, xi_1, dt_xi_11)
 call explicit_tend (mu, nu, xi_2, dt_xi_22)

 call compute_e (delt, mu, nu, e, a, b, c, g)

 call compute_f (dt_xi_11, b, c, g, f_1)
 call compute_f (dt_xi_22, b, c, g, f_2)

 if (present(kbot)) then
    do j=1,size(xi_1,2)
    do i=1,size(xi_1,1)
        kb = kbot(i,j)
        mu_delt_n(i,j)  =      mu(i,j,kb  )*delt
             nu_n(i,j)  =      nu(i,j,kb  )
            e_n1(i,j)  =       e(i,j,kb-1)
     f_1_delt_n1(i,j)  =     f_1(i,j,kb-1)*delt
     f_2_delt_n1(i,j)  =     f_2(i,j,kb-1)*delt
        delta_1_n(i,j)  = dt_xi_11(i,j,kb  )*delt
        delta_2_n(i,j)  = dt_xi_22(i,j,kb  )*delt
    enddo
    enddo
 else
        nlev = size(mu,3)
        mu_delt_n(:,:)  =      mu(:,:,nlev  )*delt
             nu_n(:,:)  =      nu(:,:,nlev  )
            e_n1(:,:)  =       e(:,:,nlev-1)
     f_1_delt_n1(:,:)  =     f_1(:,:,nlev-1)*delt
     f_2_delt_n1(:,:)  =     f_2(:,:,nlev-1)*delt
        delta_1_n(:,:)  = dt_xi_11(:,:,nlev  )*delt
        delta_2_n(:,:)  = dt_xi_22(:,:,nlev  )*delt
 endif



!-----------------------------------------------------------------------

end subroutine vert_diff_down_2

!#######################################################################

subroutine diff_surface (mu_delt, nu, e_n1, f_delt_n1,  &
                         dflux_datmos, flux, factor, delta_xi)

!-----------------------------------------------------------------------

real, intent(in)   , dimension(:,:) :: mu_delt, nu, e_n1, f_delt_n1,  &
                                       dflux_datmos
real, intent(inout), dimension(:,:) :: flux, delta_xi
real, intent(in) :: factor

!-----------------------------------------------------------------------

 real, dimension(size(flux,1),size(flux,2)) :: dflux
 real :: fff

 fff = 1.0/factor

 dflux    = - nu*(1.0 - e_n1)
 delta_xi = delta_xi + mu_delt*nu*f_delt_n1

 delta_xi = (delta_xi + mu_delt*flux*fff)/&
                      (1.0 - mu_delt*(dflux + dflux_datmos*fff))  

 flux     = flux + dflux_datmos*delta_xi


!-----------------------------------------------------------------------

end subroutine diff_surface

!#######################################################################

subroutine vert_diff_up (delt, e, f, delta_xi_n, dt_xi, kbot)

!-----------------------------------------------------------------------

real,    intent(in)                      :: delt
real,    intent(in),    dimension(:,:,:) :: e, f
real,    intent(in) ,   dimension(:,:)   :: delta_xi_n
real,    intent(out),   dimension(:,:,:) :: dt_xi
integer, intent(in),    dimension(:,:), optional :: kbot

integer :: i, j, k, kb, nlev
!-----------------------------------------------------------------------

 if (present(kbot)) then
     do j = 1, size(dt_xi,2)
     do i = 1, size(dt_xi,1)
         kb = kbot(i,j)
         dt_xi(i,j,kb) = delta_xi_n(i,j)/delt
         do k = kb -1, 1, -1
           dt_xi(i,j,k) = e(i,j,k)*dt_xi(i,j,k+1) + f(i,j,k)
         end do
     end do
     end do
 else
    nlev = size(dt_xi,3)
    dt_xi(:,:,nlev) = delta_xi_n/delt
    do k = size(dt_xi,3)-1, 1, -1
      dt_xi(:,:,k) = e(:,:,k)*dt_xi(:,:,k+1) + f(:,:,k)
    end do
 endif

!-----------------------------------------------------------------------

end subroutine vert_diff_up

!#######################################################################

subroutine compute_e (delt, mu, nu, e, a, b, c, g)

!-----------------------------------------------------------------------

real,    intent(in)                       :: delt
real,    intent(in)    , dimension(:,:,:) :: mu, nu
real,    intent(out)   , dimension(:,:,:) :: e, a, b, c, g

integer :: k, nlev

!-----------------------------------------------------------------------

 nlev = size(mu,3)

 a(:,:,1:nlev-1) = - mu(:,:,1:nlev-1)*nu(:,:,2:nlev)*delt
 a(:,:,nlev    ) =   0.0
 c(:,:,2:nlev  ) = - mu(:,:,2:nlev  )*nu(:,:,2:nlev)*delt
 c(:,:,1       ) =   0.0

 b = 1.0 - a - c

 e(:,:,1)   =   - a(:,:,1)/b(:,:,1)
 do  k= 2, nlev - 1
    g(:,:,k) = 1.0/(b(:,:,k) + c(:,:,k)*e(:,:,k-1))
    e(:,:,k) = - a(:,:,k)*g(:,:,k)
 enddo

!-----------------------------------------------------------------------

end subroutine compute_e

!#######################################################################

subroutine compute_f (dt_xi, b, c, g, f)

!-----------------------------------------------------------------------
real,    intent(in)    , dimension(:,:,:) :: dt_xi, b, c, g
real,    intent(out)   , dimension(:,:,:) :: f

integer :: k
!-----------------------------------------------------------------------

 f(:,:,1) =   dt_xi(:,:,1)/b(:,:,1)

 do  k = 2, size(b,3)-1
    f(:,:,k) = (dt_xi(:,:,k) - c(:,:,k)*f(:,:,k-1))*g(:,:,k)
 enddo

!-----------------------------------------------------------------------

end subroutine compute_f

!#######################################################################

subroutine explicit_tend (mu, nu, xi, dt_xi)

!-----------------------------------------------------------------------

real,    intent(in)    , dimension(:,:,:) :: mu, nu, xi
real,    intent(inout) , dimension(:,:,:) :: dt_xi

real, dimension(size(xi,1),size(xi,2),size(xi,3)) :: fluxx

integer :: nlev

!-----------------------------------------------------------------------

 nlev = size(mu,3)

 fluxx(:,:,1)      = 0.0
 fluxx(:,:,2:nlev) = nu(:,:,2:nlev)*(xi(:,:,2:nlev) - xi(:,:,1:nlev-1))

 dt_xi(:,:,1:nlev-1) = dt_xi(:,:,1:nlev-1) +  &
    mu(:,:,1:nlev-1)*(fluxx(:,:,2:nlev) - fluxx(:,:,1:nlev-1))
 dt_xi(:,:,nlev)     = dt_xi(:,:,nlev) - mu(:,:,nlev)*fluxx(:,:,nlev)

!-----------------------------------------------------------------------

end subroutine explicit_tend

!#######################################################################

subroutine compute_mu (p_half, mu)

!-----------------------------------------------------------------------
real,    intent(in)    , dimension(:,:,:) :: p_half
real,    intent(out)   , dimension(:,:,:) :: mu

integer :: nlev
!-----------------------------------------------------------------------

nlev = size(mu,3)

mu(:,:,1:nlev) = GRAV / (p_half(:,:,2:nlev+1) -p_half(:,:,1:nlev))

!-----------------------------------------------------------------------

end subroutine compute_mu


!#######################################################################

subroutine compute_nu (diff, p_half, p_full, z_full, t, q, nu)

!-----------------------------------------------------------------------
real,    intent(in)    , dimension(:,:,:) :: diff, p_half, p_full, &
                                             z_full, t, q
real,    intent(out)   , dimension(:,:,:) :: nu

real, dimension(size(t,1),size(t,2),size(t,3)) :: rho_half, tt
integer :: nlev
!-----------------------------------------------------------------------

nlev = size(nu,3)

if ( use_virtual_temp_vert_diff ) then
  tt = t * (1.0 + d608*q)           ! virtual temperature
else
  tt = t ! Take out virtual temperature effect here to mimic supersource
endif

rho_half(:,:,2:nlev) =  &         ! density at half levels
      2.0*p_half(:,:,2:nlev)/(RDGAS*(tt(:,:,2:nlev)+tt(:,:,1:nlev-1)))

if(do_mcm_plev) then
  nu(:,:,2:nlev) = GRAV*rho_half(:,:,2:nlev)*rho_half(:,:,2:nlev)*diff(:,:,2:nlev)/ &
                    (p_full(:,:,2:nlev)-p_full(:,:,1:nlev-1))
else
  nu(:,:,2:nlev) = rho_half(:,:,2:nlev)*diff(:,:,2:nlev) /  &
                    (z_full(:,:,1:nlev-1)-z_full(:,:,2:nlev))
endif
!-----------------------------------------------------------------------

end subroutine compute_nu

!#######################################################################

end module vert_diff_mod

module ocean_vert_pp_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen Griffies 
!</CONTACT>
!
!<OVERVIEW>
! Vertical viscosity and diffusivity according Pacanowski and Philander (1981)
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes vertical viscosity and diffusivity according to 
! Pacanowski and Philander (1981).  This scheme is most effective for 
! studies of the tropical circulation.  It computes the vertical mixing
! coefficient based on the Richardson number.  
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! R.C. Pacanowski and G. Philander 
! Parametrization of vertical mixing in numerical models of the tropical ocean
! Journal of Physical Oceanography (1981) vol 11, pages 1442--1451
! </REFERENCE>
!
! <NOTE>
! This parameterization was designed for equatorial models
! and may not do a good job in mid or high latitudes. Simulations
! in these regions (where vertical shear is small) are improved with
! the addition of solar short wave penetration into the ocean which 
! reduces buoyancy and enhances vertical mixing.
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_vert_pp_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is false. 
!  </DATA> 
!
!  <DATA NAME="wndmix" UNITS="m^2/sec" TYPE="real">
!  Minimum viscosity at bottom of 1st level to simulate 
!  missing high frequency windstress components.
!  </DATA> 
!  <DATA NAME="fricmx" UNITS="m^2/sec" TYPE="real">
!  Maximum mixing
!  </DATA> 
!  <DATA NAME="diff_cbt_back_pp" UNITS="m^2/sec" TYPE="real">
!  Space-time independent background vertical diffusivity 
!  thought to be that arising from internal waves. Note that 
!  if using Bryan-Lewis background diffusivity, then should 
!  set diff_cbt_back_pp=0.0. 
!  </DATA> 
!  <DATA NAME="visc_cbu_back_pp" UNITS="m^2/sec" TYPE="real">
!  Background vertical viscosity
!  </DATA> 
!</NAMELIST>

use constants_mod,       only: pi, epsln
use diag_manager_mod,    only: register_diag_field
use fms_mod,             only: open_namelist_file, check_nml_error, close_file, write_version_number
use fms_mod,             only: FATAL, NOTE, stdout, stdlog
use mpp_mod,             only: input_nml_file, mpp_error

use ocean_density_mod,    only: density_delta_z
use ocean_domains_mod,    only: get_local_indices
use ocean_parameters_mod, only: missing_value, rho0r, grav 
use ocean_parameters_mod, only: MOM_BGRID, MOM_CGRID 
use ocean_types_mod,      only: ocean_grid_type, ocean_domain_type
use ocean_types_mod,      only: ocean_prog_tracer_type
use ocean_types_mod,      only: ocean_velocity_type, ocean_density_type
use ocean_types_mod,      only: ocean_time_steps_type, ocean_time_type, ocean_thickness_type
use ocean_vert_util_mod,  only: ri_for_cgrid 
use ocean_workspace_mod,  only: wrk1, wrk1_v
use ocean_util_mod,       only: diagnose_3d, diagnose_3d_u

implicit none

public ocean_vert_pp_init
public vert_mix_pp
private ri_for_pp

private

real, private, dimension(:,:,:), allocatable :: riu  ! Richardson number at base of U-cells
real, private, dimension(:,:,:), allocatable :: rit  ! Richardson number at base of T-cells

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()

integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk

integer :: index_temp=-1
integer :: index_salt=-1
integer :: num_prog_tracers=-1

! for Bgrid or Cgrid
integer :: horz_grid

character(len=128) :: version = &
     '$Id: ocean_vert_pp.F90,v 20.0 2013/12/14 00:16:50 fms Exp $'

character (len=128) :: tagname = &
     '$Name: tikal $'

! for diagnostics 
integer :: id_diff_cbt_pp= -1
integer :: id_visc_cbt_pp= -1
integer :: id_visc_cbu_pp= -1

logical :: module_is_initialized = .FALSE.

logical :: use_this_module = .false.
real :: fricmx           = 50.0e-4 ! (m^2/s) max vertical mixing coefficient
real :: wndmix           = 10.0e-4 ! (m^2/s) min vertical mixing in level 1 to simulate wind mixing
real :: diff_cbt_back_pp = 1.0e-5  ! (m^2/s) background "diff_cbt"
real :: visc_cbu_back_pp = 1.0e-4  ! (m^2/s) background "visc_cbu"
real :: visc_cbu_limit   = 1.0e2   ! (m^2/s) largest allowable "visc_cbu" (reset below)
real :: diff_cbt_limit   = 1.0e2   ! (m^2/s) largest allowable "diff_cbt" (reset below)

namelist /ocean_vert_pp_nml/ use_this_module, wndmix, fricmx,    &
                             diff_cbt_back_pp, visc_cbu_back_pp, &
                             visc_cbu_limit, diff_cbt_limit                     

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_vert_pp_init">
!
! <DESCRIPTION>
! Initialization for the Pacanowski/Philander vertical mixing scheme
!
! input:
!
!   dzt    = thickness of vertical levels (m)
!
!   nk     = number of vertical levels
!
!   yt     = latitude of grid points (deg)
!
!   nj     = number of latitudes
!
!   error  = logical to signal problems
!
! output:
!
!   wndmix = min value for mixing at surface to simulate high freq
!
!            wind mixing (if absent in forcing). (m^2/sec)
!
!   fricmx = maximum mixing (m^2/sec)
!
!   diff_cbt_back_pp = background "diff_cbt" (m^2/sec)
!
!   visc_cbu_back_pp = background "visc_cbu" (m^2/sec)
!
!   diff_cbt_limit = largest "diff_cbt" (m^2/sec)
!
!   visc_cbu_limit = largest "visc_cbu" (m^2/sec)
!
!   error  = true if some inconsistency was found
!
! </DESCRIPTION>
!
subroutine ocean_vert_pp_init (Grid, Domain, Time, Time_steps, T_prog, hor_grid)

  type(ocean_grid_type),        intent(in), target :: Grid
  type(ocean_domain_type),      intent(in), target :: Domain
  type(ocean_time_type),        intent(in)         :: Time
  type(ocean_time_steps_type),  intent(in)         :: Time_steps
  type(ocean_prog_tracer_type), intent(in)         :: T_prog(:)
  integer,                      intent(in)         :: hor_grid

  real :: dzmin, extlat
  integer :: k, j, ioun, io_status, ierr, n
  
  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_vert_pp_mod: module is already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_vert_pp_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_vert_pp_nml')
#else
  ioun = open_namelist_file()
  read  (ioun, ocean_vert_pp_nml,iostat=io_status)
  ierr = check_nml_error(io_status, 'ocean_vert_pp_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit, ocean_vert_pp_nml)  
  write (stdlogunit, ocean_vert_pp_nml)

  write(stdoutunit,'(/a/)')'==>USING Pacanowski-Philander (pp) vertical mixing scheme.'
  write(stdoutunit,'(/a,f10.2)') &
  '==>Note from ocean_vert_pp_mod: using forward time step for vert-frict of (secs)', Time_steps%dtime_u 
  write(stdoutunit,'(/a,f10.2)') &
  '==>Note from ocean_vert_pp_mod: using forward time step for vert-diff  of (secs)', Time_steps%dtime_t 

  num_prog_tracers = size(T_prog)
  horz_grid        = hor_grid 

  do n = 1, num_prog_tracers
     if (T_prog(n)%name == 'temp') index_temp = n
     if (T_prog(n)%name == 'salt') index_salt = n
  enddo

  if (index_temp < 1 .or. index_salt < 1) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_vert_pp_mod: temp and/or salt not present in tracer array')
  endif 

  Dom => Domain
  Grd => Grid

  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk

  if(use_this_module) then 
    call mpp_error(NOTE, '==>Note: USING ocean_vert_pp_mod')
  else
    call mpp_error(NOTE, '==>Note: NOT using ocean_vert_pp_mod')
    return 
  endif


  allocate (riu(isd:ied,jsd:jed,nk))
  riu(:,:,:)    = 0.0

  allocate (rit(isd:ied,jsd:jed,nk))
  rit(:,:,:)    = 0.0

  dzmin  = 1.e10  ! meters
  do k=1,nk
    dzmin = min(dzmin,Grid%dzt(k))
  enddo
  if (dzmin >= 25.0) then
    write (stdoutunit,'(/,(1x,a))') &
    '==> Warning: "ppmix" may not work well with coarse vertical resolution'
  endif

  extlat = 0.0
  do j=jsc,jec
    extlat = max(abs(Grid%yt(isc,j)),extlat)
  enddo
  if (extlat > 10.0) then
    write (stdoutunit,'(/,(1x,a))')'==> Warning: "ppmix" may not work well outside tropics where '&
  ,'                             vertical shear is small, unless use solar shortwave penetration. '
  endif

  if (Time_steps%aidif < 1.0) then ! Explicit mixing 
    do k=1,nk
      if ((Time_steps%dtime_t*fricmx)/Grid%dzt(k)**2 >= 0.5) then
        write (stdoutunit,'(/,(1x,a))')&
        '==> Error: vertical diffusive criteria exceeded for "fricmx".  use a smaller'&
       ,'            "dtts" and/or  "fricmx" .... or use "aidif=1.0"'
        write (stdoutunit,'(a48,i3)') ' at level =',k
        call mpp_error(FATAL, &
        '==>Error in ocean_vert_pp_mod: vertical diffusive criteria exceeded for "fricmx" ')
      endif
      if ((Time_steps%dtime_t*diff_cbt_limit)/Grid%dzt(k)**2 >= 0.5) then
        write (stdoutunit,'(/,(1x,a))') &
        '==> Error: vertical diffusive criteria exceeded for "diff_cbt_limit". use a smaller'&
        ,'            "dtts" and/or  "diff_cbt_limit" ...or use "aidif=1.0"'
        write (stdoutunit,'(a48,i3)') ' at level =',k
        call mpp_error(FATAL, &
        '==> Error in ocean_vert_pp_mod: vertical diffusive criteria exceeded for "diff_cbt_limit" ')
      endif
    enddo

    if ((Time_steps%dtime_u*fricmx)/dzmin**2 >= 0.5) then
      write (stdoutunit,'(/,(1x,a))') &
       '==> Error: vertical diffusive criteria exceeded for "fricmx". use a smaller'&
      ,'            "dtuv" and/or "fricmx"  ...or use "aidif=1.0"'
      call mpp_error(FATAL, &
      '==> Error in ocean_vert_pp_mod: vertical diffusive criteria exceeded for "fricmx" ')
    endif

    if ((Time_steps%dtime_u*visc_cbu_limit)/dzmin**2 >= 0.5) then
      write (stdoutunit,'(/,(1x,a))') &
      '==> Error: vertical diffusive criteria exceeded for "visc_cbu_limit". use a smaller'&
      ,'            "dtuv" or "visc_cbu_limit"  ...or use "aidif=1.0"'
      call mpp_error(FATAL, &
      '==> Error in ocean_vert_pp_mod: vertical diffusive criteria exceeded for "visc_cbu_limit" ')
    endif
  endif

  id_diff_cbt_pp = register_diag_field('ocean_model','diff_cbt_pp',Grd%tracer_axes_wt(1:3),&
       Time%model_time, 'vert diffusivity from pp', 'm^2/sec',                             &
       missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_visc_cbt_pp = register_diag_field('ocean_model','visc_cbt_pp',Grd%tracer_axes_wt(1:3),&
       Time%model_time, 'vert viscosity from pp', 'm^2/sec',                               &
       missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_visc_cbu_pp = register_diag_field('ocean_model','visc_cbu_pp',Grd%vel_axes_wu(1:3),&
       Time%model_time, 'vert viscosity from pp', 'm^2/sec',                            &
       missing_value = missing_value, range=(/-1.e5,1.e5/))

end subroutine ocean_vert_pp_init
! </SUBROUTINE>  NAME="ocean_vert_pp_init"


!#######################################################################
! <SUBROUTINE NAME="vert_mix_pp">
!
! <DESCRIPTION>
! This subroutine computes the vertical diffusivity and viscosity
! according to the Pacanowski and Philander scheme. Mixing coefficients  
! are space and time dependent. 
!
! inputs:
!
!  nk              = number of vertical levels                             
!  grav            = gravity (m/sec^2)                                     
!  fricmx          = max viscosity (m^2/sec)                               
!  wndmix          = min viscosity at bottom of 1st level to simulate      
!                    missing high frequency windstress components (m^2/sec)
!  visc_cbu_back_pp = background "visc_cbu" (m^2/sec)                      
!  diff_cbt_back_pp = background "diff_cbt" (m^2/sec)                      
!  visc_cbu_limit  = largest "visc_cbu" in regions of gravitational        
!                    instability (m^2/sec)                                 
!  diff_cbt_limit  = largest "diff_cbt" in regions of gravitational        
!                    instability (m^2/sec)                                 
!  riu             = richardson number at bottom of U cells                
!  rit             = richardson number at bottom of T cells                
!
! outputs:
!
!  visc_cbu = viscosity at bottom of U cells (m^2/s)  
!  visc_cbt = viscosity at bottom of T cells (m^2/s)  
!  diff_cbt = diffusion at bottom of T cells (m^2/s) 
!
! </DESCRIPTION>
!
  subroutine vert_mix_pp(Time, Thickness, Velocity, T_prog, Dens, visc_cbu, visc_cbt, diff_cbt)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_velocity_type),      intent(in)    :: Velocity
  type(ocean_prog_tracer_type),   intent(in)    :: T_prog(:)
  type(ocean_density_type),       intent(in)    :: Dens
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbu
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbt
  real, dimension(isd:,jsd:,:,:), intent(inout) :: diff_cbt

  integer :: i, j, k
  integer :: taum1
  real    :: t1, t2, t3

  if(.not. use_this_module) then 
    return 
  endif 

  if ( .not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_vert_pp (vert_mix_pp): module must be initialized')
  endif 

  taum1 = Time%taum1

  ! compute gradient richardson number at base of T cells and U cells

  if(horz_grid == MOM_BGRID) then
     call ri_for_pp (Time, Thickness, Velocity, T_prog(index_temp)%field(:,:,:,taum1), &
                     Dens%rho_salinity(:,:,:,taum1), Dens%pressure_at_depth, Dens%rho(:,:,:,taum1))
  else 
      ! average horizontal C-grid velocity onto T-cell center
      wrk1_v(:,:,:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1_v(i,j,k,1) = Grd%tmask(i,j,k)                                                      &
                    *(Velocity%u(i,j,k,taum1,1)*Grd%dtw(i,j)+Velocity%u(i-1,j,k,taum1,1)*Grd%dte(i,j)) &
                    /(epsln+Grd%dxt(i,j))
               wrk1_v(i,j,k,2) = Grd%tmask(i,j,k)                                                      &
                    *(Velocity%u(i,j,k,taum1,2)*Grd%dts(i,j)+Velocity%u(i,j-1,k,taum1,2)*Grd%dtn(i,j)) &
                    /(epsln+Grd%dyt(i,j))
            enddo
         enddo
      enddo
      call ri_for_cgrid(Time, Thickness%dzwt, Dens%drhodT, Dens%drhodS,          &
           T_prog(index_temp)%field(:,:,:,taum1), Dens%rho_salinity(:,:,:,taum1),&
           wrk1_v(:,:,:,1), wrk1_v(:,:,:,2), rit, riu)
  endif 

  ! viscosity and diffusivity are on bottom of T and U cells.

  do k=1,nk-1
    do j=jsc,jec
      do i=isc,iec
        t1                = 1.0/(1.0 + 5.0*riu(i,j,k))
        visc_cbu(i,j,k)   = fricmx*t1**2 + visc_cbu_back_pp
        t2                = 1.0/(1.0 + 5.0*rit(i,j,k))
        diff_cbt(i,j,k,:) = fricmx*t2**3 + diff_cbt_back_pp 
        t3                = 1.0/(1.0 + 5.0*rit(i,j,k))
        visc_cbt(i,j,k)   = fricmx*t3**2 + visc_cbu_back_pp
      enddo
    enddo
  enddo

  ! limit mixing coeffs on bottom of cells in unstable regions

  do k=1,nk-1
    do j=jsc,jec
      do i=isc,iec
        if (riu(i,j,k) < 0.0) visc_cbu(i,j,k)   = visc_cbu_limit
        if (rit(i,j,k) < 0.0) visc_cbt(i,j,k)   = visc_cbu_limit
        if (rit(i,j,k) < 0.0) diff_cbt(i,j,k,:) = diff_cbt_limit
      enddo
    enddo
  enddo

  ! approximation for high freq wind mixing near the surface
  ! set no flux through bottom of bottom level "nk"

  k = 1
  where (diff_cbt(isc:iec,jsc:jec,k,:) < wndmix) diff_cbt(isc:iec,jsc:jec,k,:) = wndmix
  diff_cbt(isc:iec,jsc:jec,nk,:) = 0.0
  where (visc_cbu(isc:iec,jsc:jec,k) < wndmix) visc_cbu(isc:iec,jsc:jec,k) = wndmix
  visc_cbu(isc:iec,jsc:jec,nk) = 0.0
  where (visc_cbt(isc:iec,jsc:jec,k) < wndmix) visc_cbt(isc:iec,jsc:jec,k) = wndmix
  visc_cbt(isc:iec,jsc:jec,nk) = 0.0

  diff_cbt(isc:iec,jsc:jec,:,2) = diff_cbt(isc:iec,jsc:jec,:,1)

  call diagnose_3d(Time, Grd, id_diff_cbt_pp, diff_cbt(:,:,:,1))
  call diagnose_3d(Time, Grd, id_visc_cbt_pp, visc_cbt(:,:,:))
  call diagnose_3d_u(Time, Grd, id_visc_cbu_pp, visc_cbu(:,:,:))

end subroutine vert_mix_pp
! </SUBROUTINE> NAME="vert_mix_pp"


!#######################################################################
! <SUBROUTINE NAME="ri_for_pp">
!
! <DESCRIPTION>
! Compute richardson number for the pp scheme
! </DESCRIPTION>
!
subroutine ri_for_pp (Time, Thickness, Velocity, theta, salinity, pressure_at_depth, rho_taum1)

  type(ocean_time_type),         intent(in) :: Time
  type(ocean_thickness_type),    intent(in) :: Thickness
  type(ocean_velocity_type),     intent(in) :: Velocity
  real, dimension(isd:,jsd:,:),  intent(in) :: theta
  real, dimension(isd:,jsd:,:),  intent(in) :: salinity
  real, dimension(isd:,jsd:,:),  intent(in) :: pressure_at_depth
  real, dimension(isd:,jsd:,:),  intent(in) :: rho_taum1

  integer :: i, j, k, taum1
  real    :: active_cells, fx, t1

  fx   = -0.25*grav*rho0r

  taum1 = Time%taum1

  ! compute density difference across bottom of T cells at tau-1

  wrk1(:,:,:) = density_delta_z(rho_taum1(:,:,:), salinity(:,:,:), &
                                theta(:,:,:), pressure_at_depth(:,:,:))

  ! compute richardson numbers on bottom of U cells

  do k=1,nk-1
    do j=jsd,jed-1
      do i=isd,ied-1
        t1 = fx*Thickness%dzwt(i,j,k)
        riu(i,j,k) = t1*Grd%umask(i,j,k+1)*(wrk1(i,j+1,k) + wrk1(i+1,j+1,k) + wrk1(i,j,k)   + wrk1(i+1,j,k)) /&
                      ((Velocity%u(i,j,k,1,taum1) - Velocity%u(i,j,k+1,1,taum1))**2 + &
                       (Velocity%u(i,j,k,2,taum1) - Velocity%u(i,j,k+1,2,taum1))**2 + epsln)
      enddo
    enddo
  enddo

  ! compute richardson numbers on bottom of T cells as average
  ! of four nearest richardson numbers on bottom of U cells.
  ! (do not consider land cells in the average... only active ones)

  do k=1,nk-1
    do j=jsc,jec
      do i=isc,iec
        active_cells = Grd%umask(i,j,k+1)   + Grd%umask(i-1,j,k+1) &
                     + Grd%umask(i,j-1,k+1) + Grd%umask(i-1,j-1,k+1) + epsln
        rit(i,j,k)   = (riu(i,j,k) + riu(i-1,j,k) + riu(i,j-1,k) + riu(i-1,j-1,k))/active_cells

        ! make sure no static instability exists (one that is not seen
        ! by the Richardson number).  This may happen due to
        ! horizontal averaging used in calculating the Richardson
        ! number.

        if (rit(i,j,k) > 0.0 .and. wrk1(i,j,k) > 0.0) then
          rit(i,j,k) = -10.0
        endif
      enddo
    enddo
  enddo

end subroutine ri_for_pp
! </SUBROUTINE> NAME="ri_for_pp"


end module ocean_vert_pp_mod

#include <fms_platform.h>
MODULE UW_CONV_MOD

  use           mpp_mod, only : mpp_pe, mpp_root_pe, stdlog
  use      Constants_Mod, ONLY: tfreeze,HLv,HLf,HLs,CP_AIR,GRAV,Kappa,rdgas,rvgas
  use   Diag_Manager_Mod, ONLY: register_diag_field, send_data
  use   Time_Manager_Mod, ONLY: time_type, get_time 
  use           mpp_mod, only : input_nml_file
  use           fms_mod, only : write_version_number, open_namelist_file, check_nml_error,&
                                FILE_EXIST, ERROR_MESG,  &
                                lowercase, &
                                CLOSE_FILE, FATAL
  use  field_manager_mod, only: MODEL_ATMOS
  use  tracer_manager_mod, only: get_tracer_names, query_method, &
                                 get_tracer_index, NO_TRACER
  use  sat_vapor_pres_mod,only : sat_vapor_pres_init
  use atmos_tracer_utilities_mod, only : get_wetdep_param

  use  rad_utilities_mod, only : aerosol_type
  
  use  aer_ccn_act_mod, only :   aer_ccn_act_init
  use  conv_utilities_mod,only :   uw_params_init
  use  conv_utilities_k_mod,only : sd_init_k, sd_copy_k, sd_end_k,  &
                                   ac_init_k, ac_clear_k, ac_end_k, &
                                   pack_sd_k, adi_cloud_k, extend_sd_k,&
                                   exn_init_k, exn_end_k, findt_init_k,&
                                   findt_end_k, &
                                   check_tracer_realizability, &
                                   qt_parcel_k, &
                                   adicloud, sounding, uw_params

  use  conv_plumes_k_mod,only    : cp_init_k, cp_end_k, cp_clear_k, &
                                   ct_init_k, ct_end_k, ct_clear_k, &
                                   cumulus_tend_k, cumulus_plume_k, &
                                   cplume, ctend, cpnlist, cwetdep_type

  use  conv_closures_mod,only    : cclosure_bretherton,   &
                                   cclosure_relaxcbmf, &
                                   cclosure_relaxwfn,  &
                                   cclosure_implicit, cclosure

  use  deep_conv_mod,only        : deepc, cpn_copy, dpconv0, dpconv1, dpconv2

!---------------------------------------------------------------------
  implicit none
  private
!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------

  character(len=128) :: version = '$Id: uw_conv.F90,v 20.0 2013/12/13 23:21:41 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

!---------------------------------------------------------------------
!-------  interfaces --------

  public  :: uw_conv, uw_conv_init, uw_conv_end

  real, parameter :: aday = 1.
  real, parameter :: mv = -999.
  logical         :: module_is_initialized = .false.

  character(len=7) :: mod_name = 'uw_conv'

  !namelist parameters for UW convection scheme
  integer :: iclosure = 0      ! 0: Bretherton UWShCu orginal / -CIN/TKE based
                               ! 1: Emanuel-Rayment: quasiequilibrium PBL
  real    :: rkm_sh   = 16.0   ! fractional lateral mixing rate for shallow
  real    :: cldhgt_max   = 4.e3
  real    :: landfact_m   = 0.0
  integer :: idpchoice = 0  
  logical :: do_deep = .false.
  logical :: do_relaxcape = .false.
  logical :: do_relaxwfn  = .false.
  logical :: do_coldT = .true.
  logical :: do_lands = .false.
  logical :: do_uwcmt = .false.   
  logical :: do_fast  = .false.
  logical :: do_ice   = .true.
  logical :: do_ppen  = .true.
  logical :: do_forcedlifting = .false.
  real    :: atopevap = 0.
  logical :: apply_tendency = .true.
  logical :: prevent_unreasonable = .true.
  real    :: aerol = 1.e-12
  real    :: gama     = 1.0    ! 
  real    :: tkemin   = 1.e-6
  real    :: wmin_ratio = 0.
  logical :: use_online_aerosol = .false.
  logical :: use_sub_seasalt = .true.
  logical :: do_auto_aero = .false.
  logical :: do_rescale   = .false.
  logical :: do_debug     = .false.
!miz
  logical :: do_imposing_cooling_drying = .false.
  real    :: tdt_rate = 0.0             
  real    :: qvdt_rate = 0.0
  real    :: pres_min = 0.0
  real    :: pres_max = 0.0
  logical :: do_imposing_rad_cooling = .false.
  logical :: do_no_uw_conv           = .false.
  real    :: cooling_rate = -1.5 !K/day
  real    :: t_thresh = 207.5    !K
  real    :: t_strato = 200.0    !K
  real    :: tau_rad  = 5.0      !day
!miz
  integer :: cush_choice  = 0
  real    :: pcp_min      = 3e-5
  real    :: pcp_max      = 1.5e-3
  real    :: rh0          = 0.8
  real    :: cush_ref     = 0.
  real    :: pblht0 = 500.
  real    :: tke0 = 1.
  real    :: lofactor0 = 1.
  integer :: lochoice  = 0
  real    :: wrel_min = 1.
  real    :: om_to_oc = 1.67
  real    :: sea_salt_scale = 0.1
  logical :: do_qctflx_zero = .false.
  logical :: do_detran_zero = .false.
  logical :: do_gust_cv     = .false.
  real    :: gustmax        = 3.! maximum gustiness wind (m/s)
  real    :: gustconst      = 10./86400.   ! constant in kg/m2/sec, default =
                                           ! 1 cm/day = 10 mm/day

  NAMELIST / uw_conv_nml / iclosure, rkm_sh, cldhgt_max, &
       do_deep, idpchoice, do_relaxcape, do_relaxwfn, do_coldT, do_lands, do_uwcmt,       &
       do_fast, do_ice, do_ppen, do_forcedlifting, &
       atopevap, apply_tendency, prevent_unreasonable, aerol, gama, tkemin,    &
       wmin_ratio, use_online_aerosol, use_sub_seasalt, landfact_m, pblht0, tke0, lofactor0, lochoice, &
       do_auto_aero, do_rescale, wrel_min, om_to_oc, sea_salt_scale,                  &
       do_debug, cush_choice, pcp_min, pcp_max, cush_ref,   &
       rh0, do_qctflx_zero, do_detran_zero, do_gust_cv, gustmax, gustconst, &
       do_imposing_cooling_drying, tdt_rate, qvdt_rate, pres_min, pres_max, &
       do_imposing_rad_cooling, do_no_uw_conv, cooling_rate, t_thresh, t_strato, tau_rad

  !namelist parameters for UW convective plume
  real    :: rle      = 0.10   ! for critical stopping distance for entrainment
  real    :: rpen     = 5.0    ! for entrainment efficiency
  real    :: rmaxfrac = 0.05   ! maximum allowable updraft fraction
  real    :: wmin     = 0.0    ! maximum allowable updraft fraction
  real    :: rbuoy    = 1.0    ! for nonhydrostatic pressure effects on updraft
  real    :: rdrag    = 1.0 
  real    :: frac_drs = 0.0    ! 
  real    :: bigc     = 0.7    ! for momentum transfer
  real    :: auto_th0 = 0.5e-3 ! threshold for precipitation
  real    :: auto_rate= 1.e-3
  real    :: tcrit    = -45.0  ! critical temperature 
  real    :: deltaqc0 = 0.5e-3 
  logical :: do_pdfpcp= .false.
  logical :: do_pmadjt= .false.
  logical :: do_emmax = .false.
  logical :: do_pnqv  = .false.
  real    :: rad_crit = 14.0   ! critical droplet radius
  real    :: emfrac_max = 1.0
  integer :: mixing_assumption = 0
  integer :: mp_choice = 1
  real    :: Nl_land   = 300.e6
  real    :: Nl_ocean  = 100.e6
  real    :: qi_thresh = 1.e-4
  real    :: r_thresh  = 12.e-6
  logical :: do_pevap = .false.
  real    :: cfrac     = 0.05
  real    :: hcevap    = 0.8
  logical :: do_weffect = .false.
  real    :: weffect    = 0.5
  real    :: peff_l     = 1.0
  real    :: peff_i     = 1.0
  real    :: t00        = 295

  NAMELIST / uw_plume_nml / rle, rpen, rmaxfrac, wmin, rbuoy, rdrag, frac_drs, bigc, &
       auto_th0, auto_rate, tcrit, deltaqc0, do_pdfpcp, do_pmadjt, do_emmax, do_pnqv, rad_crit, emfrac_max, &
       mixing_assumption, mp_choice, Nl_land, Nl_ocean, qi_thresh, r_thresh, do_pevap, cfrac, hcevap, &
       do_weffect, weffect, peff_l, peff_i, t00
  !namelist parameters for UW convective closure
  integer :: igauss   = 1      ! options for cloudbase massflux closure
                               ! 1: cin/gaussian closure, using TKE to compute CIN.
                               ! 2: cin/gaussian closure, using W* to compute CIN.
                               ! 0: cin/tke mapse-style closure; 
  real    :: rkfre    = 0.05   ! vertical velocity variance as fraction of tke
  real    :: tau_sh   = 7200.  ! 
  real    :: wcrit_min= 0.

  NAMELIST / uw_closure_nml / igauss, rkfre, tau_sh, wcrit_min


!========Option for deep convection=======================================
  real    :: rkm_dp1       = 10.
  real    :: rkm_dp2       = 1.
  real    :: cbmf_dp_frac1 = 0.
  real    :: cbmf_dp_frac2 = 1.
  real    :: crh_th_ocean  = 100.
  real    :: crh_th_land   = 100.
  real    :: cape_th       = 0.
  real    :: tau_dp        = 7200.
  real    :: rpen_d        = 5.0
  integer :: mixing_assumption_d = 0
  integer :: norder      = 1
  logical :: do_ppen_d   = .true.
  logical :: do_pevap_d  = .true.
  real    :: cfrac_d     = 0.05
  real    :: hcevap_d    = 0.8
  real    :: dcapedm_th  = 0
  real    :: frac_limit_d = 0.25
  real    :: lofactor_d   = 1.0
  real    :: auto_th0_d   = 1.0e-3
  real    :: tcrit_d      = -120
  logical :: do_forcedlifting_d = .false.
  logical :: do_lod_rkm   = .false.
  logical :: do_lod_cfrac = .false.
  logical :: do_lod_tcrit = .false.

  NAMELIST / deep_conv_nml / rkm_dp1, rkm_dp2, cbmf_dp_frac1, cbmf_dp_frac2, &
                 crh_th_ocean, crh_th_land, do_forcedlifting_d, frac_limit_d, &
                 cape_th, tau_dp, rpen_d, mixing_assumption_d, norder, &
                 do_ppen_d, do_pevap_d, cfrac_d, hcevap_d, lofactor_d, dcapedm_th, &
                 auto_th0_d, tcrit_d, do_lod_rkm, do_lod_cfrac, do_lod_tcrit
!========Option for deep convection=======================================

!------------------------------------------------------------------------

  integer :: nqv, nql, nqi, nqa ,nqn
  logical :: do_qn = .false.    ! use droplet number tracer field ?

  integer :: id_tdt_uwc, id_qdt_uwc, id_prec_uwc, id_snow_uwc,               &
       id_cin_uwc, id_cbmf_uwc, id_tke_uwc, id_plcl_uwc, id_zinv_uwc,  &
       id_cush_uwc, id_pct_uwc, id_pcb_uwc, id_plfc_uwc, id_enth_uwc,  &
       id_qldt_uwc, id_qidt_uwc, id_qadt_uwc, id_qndt_uwc, id_cmf_uwc, id_wu_uwc,   &
       id_fer_uwc,  id_fdr_uwc, id_fdrs_uwc, id_cqa_uwc, id_cql_uwc,   &
       id_cqi_uwc,  id_cqn_uwc, id_hlflx_uwc, id_qtflx_uwc,           &
       id_cape_uwc, id_dcin_uwc, id_dcape_uwc, id_dwfn_uwc, id_crh_uwc,&
       id_ocode_uwc, id_plnb_uwc, id_wrel_uwc, id_ufrc_uwc, id_qtmp_uwc,&
       id_tdt_pevap_uwc, id_qdt_pevap_uwc, id_xhlsrc_uwc, id_xqtsrc_uwc,&
       id_qldet_uwc, id_qidet_uwc, id_qadet_uwc, id_qtdt_uwc, id_dting_uwc, &
       id_cfq_uwc, id_fdp_uwc, id_hmo_uwc, id_hms_uwc, id_abu_uwc, id_peo_uwc, &
       id_tdt_rad_uwc


  integer, allocatable :: id_tracerdt_uwc(:), id_tracerdt_uwc_col(:), &
                          id_tracerdtwet_uwc(:), id_tracerdtwet_uwc_col(:)

!========Option for deep convection=======================================
  integer :: id_tdt_uwd, id_qdt_uwd, id_qtdt_uwd, id_prec_uwd, id_snow_uwd,   &
       id_cbmf_uwd, id_enth_uwd, id_qldt_uwd, id_qidt_uwd,             &
       id_qndt_uwd, id_qadt_uwd, id_cmf_uwd, id_wu_uwd, id_fer_uwd,    &
       id_fdr_uwd, id_fdrs_uwd, id_cqa_uwd, id_cql_uwd, id_cqi_uwd,    &
       id_cqn_uwd, id_hlflx_uwd, id_qtflx_uwd, id_dcin_uwd,            &
       id_dcapedm_uwd, id_dwfn_uwd, id_ocode_uwd,                      &
       id_tdt_pevap_uwd, id_qdt_pevap_uwd, id_rkm_uwd, id_cbu_uwd
!========Option for deep convection=======================================

  type(cwetdep_type), dimension(:), allocatable :: wetdep
  type(uw_params),  save  :: Uw_p
  character(len=32), dimension(:), allocatable   :: tracername 
  character(len=32), dimension(:), allocatable   :: tracer_units 

contains

!#####################################################################
!#####################################################################

  SUBROUTINE UW_CONV_INIT(do_strat, axes, Time, kd, tracers_in_uw)
    logical,         intent(in) :: do_strat
    integer,         intent(in) :: axes(4), kd
    type(time_type), intent(in) :: Time
    logical,         intent(in) :: tracers_in_uw(:)
    
!---------------------------------------------------------------------
!  intent(in) variables:
!
!      tracers_in_uw 
!                   logical array indicating which of the activated 
!                   tracers are to be transported by UW convection
!
!-------------------------------------------------------------------

    integer   :: unit, io
    
    integer   :: ntracers, n, nn, ierr, logunit
    logical   :: flag
    character(len=200) :: text_in_scheme, control
     real :: frac_junk, frac_junk2
 
    ntracers = count(tracers_in_uw)

    call uw_params_init   (Uw_p)

!   Initialize lookup tables needed for findt and exn
!   sat_vapor_pres needs to be initialized if not already done
    call sat_vapor_pres_init     
    call exn_init_k (Uw_p)
    call findt_init_k (Uw_p)

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=uw_closure_nml, iostat=io)
      ierr = check_nml_error(io,'uw_closure_nml')
      read (input_nml_file, nml=uw_conv_nml, iostat=io)
      ierr = check_nml_error(io,'uw_conv_nml')
      read (input_nml_file, nml=uw_plume_nml, iostat=io)
      ierr = check_nml_error(io,'uw_plume_nml')
      read (input_nml_file, nml=deep_conv_nml, iostat=io)
      ierr = check_nml_error(io,'deep_conv_nml')
#else   
    if( FILE_EXIST( 'input.nml' ) ) then
       unit = OPEN_NAMELIST_FILE ()
       io = 1
       do while ( io .ne. 0 )
          READ( unit, nml = uw_closure_nml, iostat = io, end = 10 )
          ierr = check_nml_error(io,'uw_closure_nml')
       end do
10     call close_file ( unit )

       unit = OPEN_NAMELIST_FILE ()
       io = 1
       do while ( io .ne. 0 )
          READ( unit, nml = uw_conv_nml, iostat = io, end = 20 )
          ierr = check_nml_error(io,'uw_conv_nml')
       end do
20     call close_file ( unit )
       
       unit = OPEN_NAMELIST_FILE ()
       io = 1
       do while ( io .ne. 0 )
          READ( unit, nml = uw_plume_nml, iostat = io, end = 30 )
          ierr = check_nml_error(io,'uw_plume_nml')
       end do
30     call close_file ( unit )

!========Option for deep convection=======================================
       unit = OPEN_NAMELIST_FILE ()
       io = 1
       do while ( io .ne. 0 )
          READ( unit, nml = deep_conv_nml, iostat = io, end = 40 )
          ierr = check_nml_error(io,'deep_conv_nml')
       end do
40     call close_file ( unit )
!========Option for deep convection=======================================
    end if
#endif
    call write_version_number(version, tagname)
    logunit = stdlog()
    WRITE( logunit, nml = uw_closure_nml )
    WRITE( logunit, nml = uw_conv_nml )
    WRITE( logunit, nml = uw_plume_nml )
    WRITE( logunit, nml = deep_conv_nml )

    if ( use_online_aerosol ) call aer_ccn_act_init

    nqv = get_tracer_index ( MODEL_ATMOS, 'sphum' )
    nql = get_tracer_index ( MODEL_ATMOS, 'liq_wat' )
    nqi = get_tracer_index ( MODEL_ATMOS, 'ice_wat' )
    nqa = get_tracer_index ( MODEL_ATMOS, 'cld_amt' )
    nqn = get_tracer_index ( MODEL_ATMOS, 'liq_drp' )
    if (nqn /= NO_TRACER) do_qn = .true.
    if (ntracers > 0) then
      allocate ( tracername   (ntracers) )
      allocate ( tracer_units (ntracers) )
      allocate ( wetdep       (ntracers) )
      nn = 1
      do n=1,size(tracers_in_uw(:))
         if (tracers_in_uw(n)) then
             call get_tracer_names (MODEL_ATMOS, n,  &
                                    name = tracername(nn), &
                                    units = tracer_units(nn))
             flag = query_method( 'wet_deposition', MODEL_ATMOS, n, &
                                  text_in_scheme, control )
             call get_wetdep_param( text_in_scheme, control, &
                                    wetdep(nn)%scheme, &
                                    wetdep(nn)%Henry_constant, &
                                    wetdep(nn)%Henry_variable, &
                                    frac_junk, frac_junk2, &
                                    wetdep(nn)%alpha_r, &
                                    wetdep(nn)%alpha_s, &
                                    wetdep(nn)%Lwetdep, &
                                    wetdep(nn)%Lgas, &
                                    wetdep(nn)%Laerosol, &
                                    wetdep(nn)%Lice, &
                                    frac_in_cloud_uw=wetdep(nn)%frac_in_cloud )
             wetdep(nn)%scheme = lowercase( wetdep(nn)%scheme )
             nn = nn + 1
          endif
       end do
    endif

    id_xhlsrc_uwc = register_diag_field (mod_name,'xhlsrc_uwc', axes(1:2), Time, &
         'xhlsrc', 'J/kg' )
    id_xqtsrc_uwc = register_diag_field (mod_name,'xqtsrc_uwc', axes(1:2), Time, &
         'xqtsrc', 'kg/kg' )

    id_tdt_pevap_uwc = register_diag_field ( mod_name, 'tdt_pevap_uwc', axes(1:3), Time, &
         'Temperature tendency due to pevap from uw_conv', 'K/s', missing_value=mv )
    id_qdt_pevap_uwc = register_diag_field ( mod_name, 'qdt_pevap_uwc', axes(1:3), Time, &
         'Spec. humidity tendency due to pevap from uw_conv', 'kg/kg/s', missing_value=mv)

    id_tdt_uwc = register_diag_field ( mod_name, 'tdt_uwc', axes(1:3), Time, &
         'Temperature tendency from uw_conv', 'K/s', missing_value=mv )
    id_qdt_uwc = register_diag_field ( mod_name, 'qdt_uwc', axes(1:3), Time, &
         'Spec. humidity tendency from uw_conv', 'kg/kg/s', missing_value=mv)
    id_cmf_uwc = register_diag_field ( mod_name, 'cmf_uwc', axes(1:3), Time, &
         'Cloud vert. mass flux from uw_conv', 'kg/m2/s', missing_value=mv)
    id_cfq_uwc = register_diag_field ( mod_name, 'cfq_uwc', axes(1:3), Time,   &
         'Convective frequency', 'none', missing_value=mv)
    id_peo_uwc = register_diag_field ( mod_name, 'peo_uwc', axes(1:3), Time,   &
         'Convective precipitation efficiency', 'none', missing_value=mv)
    id_hmo_uwc = register_diag_field ( mod_name, 'hmo_uwc', axes(1:3), Time,   &
         'moist static energy', 'J/kg', missing_value=mv)
    id_hms_uwc = register_diag_field ( mod_name, 'hms_uwc', axes(1:3), Time,   &
         'moist static energy', 'J/kg', missing_value=mv)
    id_abu_uwc = register_diag_field ( mod_name, 'abu_uwc', axes(1:3), Time,   &
         'adiabatic buoyancy', 'K', missing_value=mv)
    id_wu_uwc = register_diag_field ( mod_name, 'wu_uwc', axes(1:3), Time,   &
         'Updraft vert. velocity from uw_conv', 'm/s', missing_value=mv)
    id_fer_uwc = register_diag_field ( mod_name, 'fer_uwc', axes(1:3), Time, &
         'Fractional entrainment rate from uw_conv', '1/Pa', missing_value=mv)
    id_fdr_uwc = register_diag_field ( mod_name, 'fdr_uwc', axes(1:3), Time, &
         'Fractional detrainment rate from uw_conv', '1/Pa', missing_value=mv)
    id_fdrs_uwc = register_diag_field (mod_name,'fdrs_uwc', axes(1:3), Time, &
         'Detrainment rate for sat. air from uw_conv', '1/Pa', missing_value=mv)
    id_cqa_uwc = register_diag_field ( mod_name, 'cqa_uwc', axes(1:3), Time, &
         'Updraft fraction from uw_conv', 'none', missing_value=mv)
    id_cql_uwc = register_diag_field ( mod_name, 'cql_uwc', axes(1:3), Time, &
         'Updraft liquid from uw_conv', 'kg/kg', missing_value=mv)
    id_cqi_uwc = register_diag_field ( mod_name, 'cqi_uwc', axes(1:3), Time, &
         'Updraft ice from uw_conv', 'kg/kg', missing_value=mv)
    id_cqn_uwc = register_diag_field ( mod_name, 'cqn_uwc', axes(1:3), Time, &
         'Updraft liquid drop from uw_conv', '/kg', missing_value=mv)
    id_hlflx_uwc=register_diag_field (mod_name,'hlflx_uwc',axes(1:3),Time, &
         'Liq.wat.pot.temp. flux from uw_conv', 'W/m2', missing_value=mv)
    id_qtflx_uwc = register_diag_field (mod_name,'qtflx_uwc',axes(1:3),Time, &
         'Total water flux from uw_conv', 'W/m2', missing_value=mv)
    id_prec_uwc = register_diag_field (mod_name,'prec_uwc', axes(1:2), Time, &
         'Precipitation rate from uw_conv', 'kg/m2/sec',                     &
         interp_method = "conserve_order1" )
    id_snow_uwc = register_diag_field (mod_name,'snow_uwc', axes(1:2), Time, &
         'Frozen precip. rate from uw_conv', 'kg/m2/sec',                       &
         interp_method = "conserve_order1" )
    id_cin_uwc = register_diag_field ( mod_name, 'cin_uwc', axes(1:2), Time, &
         'CIN from uw_conv', 'm2/s2' )
    id_cape_uwc= register_diag_field ( mod_name,'cape_uwc', axes(1:2), Time, &
         'CAPE from uw_conv', 'm2/s2' )
    id_crh_uwc= register_diag_field ( mod_name,'crh_uwc', axes(1:2), Time, &
         'Column RH from uw_conv', '%' )
    id_cbmf_uwc = register_diag_field (mod_name,'cbmf_uwc', axes(1:2), Time, &
         'Cloud-base mass flux from uw_conv', 'kg/m2/s' )
    id_wrel_uwc = register_diag_field (mod_name,'wrel_uwc', axes(1:2), Time, &
         'Release level vertical velocity from uw_conv', 'm/s' )
    id_ufrc_uwc = register_diag_field (mod_name,'ufrc_uwc', axes(1:2), Time, &
         'Release level updraft fraction from uw_conv', 'none' )
    id_tke_uwc = register_diag_field ( mod_name, 'tke_uwc', axes(1:2), Time, &
         'PBL mean TKE from uw_conv', 'm2/s2' )
    id_plcl_uwc = register_diag_field (mod_name,'plcl_uwc', axes(1:2), Time, &
         'LCL pressure from uw_conv', 'hPa' )
    id_plfc_uwc = register_diag_field (mod_name,'plfc_uwc', axes(1:2), Time, &
         'LFC pressure from uw_conv', 'hPa' )
    id_plnb_uwc = register_diag_field (mod_name,'plnb_uwc', axes(1:2), Time, &
         'LNB pressure from uw_conv', 'hPa' )
    id_zinv_uwc = register_diag_field (mod_name,'zinv_uwc', axes(1:2), Time, &
         'Inversion pressure from uw_conv', 'm' )
    id_pct_uwc = register_diag_field ( mod_name, 'pct_uwc', axes(1:2), Time, &
         'Cloud-top pressure from uw_conv', 'hPa' )
    id_pcb_uwc = register_diag_field ( mod_name, 'pcb_uwc', axes(1:2), Time, &
         'Cloud-base pressure from uw_conv', 'hPa' )
    id_cush_uwc = register_diag_field (mod_name,'cush_uwc', axes(1:2), Time, &
         'Convective scale height from uw_conv', 'm' )
    id_dcin_uwc = register_diag_field (mod_name, 'dcin_uwc', axes(1:2), Time, &
         'dCIN/cbmf from uw_conv', 'm2/s2/(kg/m2/s)' )
    id_dcape_uwc= register_diag_field (mod_name, 'dcape_uwc', axes(1:2), Time, &
         'dCAPE/cbmf from uw_conv', 'm2/s2/(kg/m2/s)' )
    id_dwfn_uwc = register_diag_field (mod_name, 'dwfn_uwc',  axes(1:2), Time, &
         'dwfn/cbmf from uw_conv', '(m2/s2)/(kg/m2/s)' )
    id_enth_uwc = register_diag_field (mod_name,'enth_uwc', axes(1:2), Time, &
         'Column-integrated enthalpy tendency from uw_conv', 'W/m2' )
    id_qtmp_uwc = register_diag_field (mod_name,'qtmp_uwc', axes(1:2), Time, &
         'Column-integrated water tendency from uw_conv', 'kg/m2/s' )
    id_dting_uwc = register_diag_field (mod_name,'dting_uwc', axes(1:2), Time, &
         'Column-integrated heating rate from uw_conv', 'W/m2' )
    id_ocode_uwc = register_diag_field (mod_name,'ocode_uwc', axes(1:2), Time, &
         'Out code from uw_conv', 'none' )
    id_fdp_uwc = register_diag_field ( mod_name, 'fdp_uwc',   axes(1:2), Time,   &
         'Deep convective frequency', 'none', missing_value=mv)
    if ( do_strat ) then
       id_qldt_uwc= register_diag_field (mod_name,'qldt_uwc',axes(1:3),Time, &
            'Liquid water tendency from uw_conv', 'kg/kg/s', missing_value=mv)
       id_qidt_uwc= register_diag_field (mod_name,'qidt_uwc',axes(1:3),Time, &
            'Ice water tendency from uw_conv', 'kg/kg/s', missing_value=mv)
       id_qadt_uwc= register_diag_field (mod_name,'qadt_uwc',axes(1:3),Time, &
            'CLD fraction tendency from uw_conv', '1/s', missing_value=mv )
       id_qndt_uwc= register_diag_field (mod_name,'qndt_uwc',axes(1:3),Time, &
            'Cloud droplet number fraction tendency from uw_conv', '#/kg/s', missing_value=mv )
       id_qldet_uwc = register_diag_field (mod_name,'qldet_uwc',axes(1:3),Time, &
            'ql detrainment', 'kg/kg/s', missing_value=mv)
       id_qidet_uwc = register_diag_field (mod_name,'qidet_uwc',axes(1:3),Time, &
            'qi detrainment', 'kg/kg/s', missing_value=mv)
       id_qadet_uwc = register_diag_field (mod_name,'qadet_uwc',axes(1:3),Time, &
            'qa detrainment', '1/s', missing_value=mv)
       id_qtdt_uwc= register_diag_field (mod_name,'qtdt_uwc',axes(1:3),Time, &
            'Total water tendency from uw_conv', 'kg/kg/s', missing_value=mv)
    end if

    if (do_imposing_rad_cooling) then
       id_tdt_rad_uwc = register_diag_field ( mod_name, 'tdt_rad_uwc', axes(1:3), Time, &
         'Idealized radiative temperature tendency from uw_conv', 'K/s', missing_value=mv )
    end if

!========Option for deep convection=======================================
    if (do_deep) then
       id_tdt_pevap_uwd = register_diag_field ( mod_name, 'tdt_pevap_uwd', axes(1:3), Time, &
            'Temperature tendency due to pevap from deep_conv', 'K/s', missing_value=mv )
       id_qdt_pevap_uwd = register_diag_field ( mod_name, 'qdt_pevap_uwd', axes(1:3), Time, &
            'Spec. humidity tendency due to pevap from deep_conv', 'kg/kg/s', missing_value=mv)

       id_tdt_uwd = register_diag_field ( mod_name, 'tdt_uwd', axes(1:3), Time, &
            'Temperature tendency from deep_conv', 'K/s', missing_value=mv )
       id_qdt_uwd = register_diag_field ( mod_name, 'qdt_uwd', axes(1:3), Time, &
            'Spec. humidity tendency from deep_conv', 'kg/kg/s', missing_value=mv)
       id_qtdt_uwd= register_diag_field ( mod_name, 'qtdt_uwd', axes(1:3), Time, &
            'Total water spec. humidity tendency from deep_conv', 'kg/kg/s', missing_value=mv)
       id_cmf_uwd = register_diag_field ( mod_name, 'cmf_uwd', axes(1:3), Time, &
            'Cloud vert. mass flux from deep_conv', 'kg/m2/s', missing_value=mv)
       id_wu_uwd = register_diag_field ( mod_name, 'wu_uwd', axes(1:3), Time,   &
            'Updraft vert. velocity from deep_conv', 'm/s', missing_value=mv)
       id_cbu_uwd= register_diag_field ( mod_name, 'cbu_uwd', axes(1:3), Time,   &
            'deep plume buoyancy', 'K', missing_value=mv)
       id_fer_uwd = register_diag_field ( mod_name, 'fer_uwd', axes(1:3), Time, &
         'Fractional entrainment rate from deep_conv', '1/Pa', missing_value=mv)
       id_fdr_uwd = register_diag_field ( mod_name, 'fdr_uwd', axes(1:3), Time, &
            'Fractional detrainment rate from deep_conv', '1/Pa', missing_value=mv)
       id_fdrs_uwd = register_diag_field (mod_name,'fdrs_uwd', axes(1:3), Time, &
            'Detrainment rate for sat. air from deep_conv', '1/Pa', missing_value=mv)
       id_cqa_uwd = register_diag_field ( mod_name, 'cqa_uwd', axes(1:3), Time, &
            'Updraft fraction from deep_conv', 'none', missing_value=mv)
       id_cql_uwd = register_diag_field ( mod_name, 'cql_uwd', axes(1:3), Time, &
         'Updraft liquid from deep_conv', 'kg/kg', missing_value=mv)
       id_cqi_uwd = register_diag_field ( mod_name, 'cqi_uwd', axes(1:3), Time, &
            'Updraft ice from deep_conv', 'kg/kg', missing_value=mv)
       id_cqn_uwd = register_diag_field ( mod_name, 'cqn_uwd', axes(1:3), Time, &
            'Updraft liquid drop from deep_conv', '/kg', missing_value=mv)
       id_hlflx_uwd=register_diag_field (mod_name,'hlflx_uwd',axes(1:3),Time, &
            'Liq.wat.pot.temp. flux from deep_conv', 'W/m2', missing_value=mv)
       id_qtflx_uwd = register_diag_field (mod_name,'qtflx_uwd',axes(1:3),Time, &
            'Total water flux from deep_conv', 'W/m2', missing_value=mv)
       id_prec_uwd = register_diag_field (mod_name,'prec_uwd', axes(1:2), Time, &
            'Precipitation rate from deep_conv', 'kg/m2/sec' )
       id_snow_uwd = register_diag_field (mod_name,'snow_uwd', axes(1:2), Time, &
            'Frozen precip. rate from deep_conv', 'kg/m2/sec' )
       id_cbmf_uwd = register_diag_field (mod_name,'cbmf_uwd', axes(1:2), Time, &
            'Cloud-base mass flux from deep_conv', 'kg/m2/s' )
       id_dcapedm_uwd= register_diag_field (mod_name, 'dcapedm_uwd', axes(1:2), Time, &
            'dCAPE/cbmf from deep_conv', 'm2/s2/(kg/m2/s)' )
       id_dwfn_uwd = register_diag_field (mod_name, 'dwfn_uwd',  axes(1:2), Time, &
            'dwfn/cbmf from deep_conv', '(m2/s2)/(kg/m2/s)' )
       id_enth_uwd = register_diag_field (mod_name,'enth_uwd', axes(1:2), Time, &
            'Column-integrated enthalpy tendency from deep_conv', 'K/s' )
       id_ocode_uwd = register_diag_field (mod_name,'ocode_uwd', axes(1:2), Time, &
            'Out code from deep_conv', 'none' )
       id_rkm_uwd = register_diag_field (mod_name,'rkm_uwd', axes(1:2), Time, &
            'rkm for deep_conv', 'none' )
       if ( do_strat ) then
          id_qldt_uwd= register_diag_field (mod_name,'qldt_uwd',axes(1:3),Time, &
               'Liquid water tendency from deep_conv', 'kg/kg/s', missing_value=mv)
          id_qidt_uwd= register_diag_field (mod_name,'qidt_uwd',axes(1:3),Time, &
               'Ice water tendency from deep_conv', 'kg/kg/s', missing_value=mv)
          id_qadt_uwd= register_diag_field (mod_name,'qadt_uwd',axes(1:3),Time, &
               'CLD fraction tendency from deep_conv', '1/s', missing_value=mv )
       end if
    end if
!========Option for deep convection=======================================


    if ( ntracers>0 ) then
      allocate(id_tracerdt_uwc(ntracers), id_tracerdt_uwc_col(ntracers) )
       allocate(id_tracerdtwet_uwc(ntracers), id_tracerdtwet_uwc_col(ntracers))
      do nn = 1,ntracers
         id_tracerdt_uwc(nn) = &
            register_diag_field (mod_name, trim(tracername(nn))//'dt_uwc', &
                                    axes(1:3), Time, &
                                  trim(tracername(nn)) //' tendency from uw_conv', &
                                  trim(tracer_units(nn))//'/s', missing_value=mv)
            id_tracerdt_uwc_col(nn) = &
              register_diag_field (mod_name, trim(tracername(nn))//'dt_uwc_col', &
                                     axes(1:2), Time, &
                                   trim(tracername(nn)) //' column tendency from uw_conv', &
                                   trim(tracer_units(nn))//'*(kg/m2)/s', missing_value=mv)
           id_tracerdtwet_uwc(nn) = &
              register_diag_field (mod_name, trim(tracername(nn))//'dt_uwc_wet', &
                                    axes(1:3), Time, &
                                   trim(tracername(nn)) //' tendency from uw_conv wetdep', &
                                   trim(tracer_units(nn))//'/s', missing_value=mv)
            id_tracerdtwet_uwc_col(nn) = &
              register_diag_field (mod_name, trim(tracername(nn))//'dt_uwc_wet_col', &
                                   axes(1:2), Time, &
                                   trim(tracername(nn)) //' column tendency from uw_conv wetdep', &
                                   trim(tracer_units(nn))//'*(kg/m2)/s', missing_value=mv)
        end do
     end if

    module_is_initialized = .true.

    
  end SUBROUTINE UW_CONV_INIT

!#####################################################################
!#####################################################################

  subroutine uw_conv_end
    call exn_end_k
    call findt_end_k
    module_is_initialized = .FALSE.
  end subroutine uw_conv_end

!#####################################################################
!#####################################################################

  SUBROUTINE uw_conv(is, js, Time, tb, qv, ub, vb, pmid, pint,zmid,  & !input
       zint, q, omega, delt, pblht, ustar, bstar, qstar, land, coldT,& !input
       asol,                                                         & !input
       cush, do_strat,  skip_calculation, max_available_cf,          & !input
       tten, qvten, qlten, qiten, qaten, qnten,                      & !output
       uten, vten, rain, snow,                                       & !output
       cmf, hlflx, qtflx, pflx, liq_pflx, ice_pflx, cldql, cldqi, cldqa,cldqn, cbmfo,  & !output
        tracers, trtend, uw_wetdep)

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!
!     SHALLOW CONVECTION SCHEME
!     Described in Bretherton et. al (MWR, April 2004)
!     For info contact Ming Zhao: ming.zhao
!
!     Inputs: see below
!
!     Outputs: see below
!
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    implicit none

    type(time_type), intent(in)  :: Time
    integer,         intent(in)  :: is, js
    real,            intent(in)  :: delt 

    real, intent(in), dimension(:,:,:)   :: ub,vb !wind profile (m/s)
    real, intent(in), dimension(:,:,:)   :: zint  !height@model interfaces(m)
    real, intent(in), dimension(:,:,:)   :: pint  !pressure@model interfaces(pa)
    real, intent(in), dimension(:,:,:)   :: tb    !temperature profile (K)
    real, intent(in), dimension(:,:,:)   :: qv    !specific humidity profile (kg/kg)
    real, intent(in), dimension(:,:,:,:) :: q     !specific humidity profile (kg/kg)
    real, intent(in), dimension(:,:,:)   :: pmid  !pressure@model mid-levels (pa)
    real, intent(in), dimension(:,:,:)   :: zmid  !height@model mid-levels (m)
    real, intent(in), dimension(:,:,:)   :: omega !omega (Pa/s)
    real, intent(in), dimension(:,:)     :: land  !land fraction
    real, intent(in), dimension(:,:,:)   :: max_available_cf !  largest
                                     ! realizable value for uw cld frac
                                   ! after accounting for deep cld frac
    logical,intent(in), dimension(:,:)   :: skip_calculation ! do not
                                                 ! calculate where .true.
    logical,intent(in)                   :: do_strat !logical flag
    logical,intent(in), dimension(:,:)   :: coldT    !logical flag

    real, intent(in),    dimension(:,:)  :: pblht, ustar, bstar, qstar !pbl height...
    real, intent(inout), dimension(:,:)  :: cush  ! convective scale height (m) 

    type(aerosol_type),  intent (in)     :: asol
   
    real, intent(out), dimension(:,:,:)  :: tten,qvten              ! T,qv tendencies
    real, intent(out), dimension(:,:,:)  :: qlten,qiten,qaten,qnten ! q tendencies
    real, intent(out), dimension(:,:,:)  :: uten,vten               ! u,v tendencies
   
    real, intent(out), dimension(:,:,:)  :: cldql,cldqi,cldqa, cldqn!in-updraft q
    real, intent(out), dimension(:,:,:)  :: cmf    ! mass flux at level above layer (kg/m2/s)
    real, intent(out), dimension(:,:,:)  :: pflx   ! precipitation flux removed from a layer
    real, intent(out), dimension(:,:,:)  :: liq_pflx   ! liq precipitation flux removed from a layer
    real, intent(out), dimension(:,:,:)  :: ice_pflx   ! solid precipitation flux removed from a layer
    real, intent(out), dimension(:,:,:)  :: hlflx ! theta_l flux
    real, intent(out), dimension(:,:,:)  :: qtflx  ! qt  flux
    real, intent(out), dimension(:,:)    :: rain, snow
    real, intent(inout), dimension(:,:)  :: cbmfo  ! cloud-base mass flux
    real, intent(in),  dimension(:,:,:,:)  :: tracers         ! env. tracers
    real, intent(out), dimension(:,:,:,:)  :: trtend          ! calculated tracer tendencies
    real, intent(out), dimension(:,:,:)  :: uw_wetdep       ! calculated wet depostion for tracers

    integer i, j, k, kl, klm, nk, naer, na, n

    real rhos0j
    real hlsrc, thcsrc, qctsrc, tmp, lofactor, crh_th
    real zsrc, psrc, cbmf_shallow, cbmf_old, cbmf_deep, rkm_sh1, rkm_dp, cbmf_dp_frac, dcrh, dcrh0, dpsum
    real, dimension(size(tb,1),size(tb,2)) :: &
         plcl,       &     ! pressure of lifting condensation level (Pa)
         plfc,       &     ! pressure of level of free convection (Pa)
         plnb,       &     ! pressure of level of neutral buoyancy (Pa)
         cino,       &     ! cin (m2/s2)
         capeo,      &     ! cape(m2/s2)
         tkeo,       &     ! tke (m2/s2)
         wrelo,      &     ! release level vertical velocity (m/s)
         ufrco,      &     ! cloud-base updraft fraction
         zinvo,      &     ! surface driven mixed-layer height
         denth,      &     
         dqtmp,      &
         dting,      &
         dcino,      &     ! dcin (m2/s2)
         dcapeo,     &     ! dcape(m2/s2)
         dwfno,      &     ! dwfn(m2/s2)
         ocode,      &
         xhlsrc,     &
         xqtsrc,     &
         crho,       &
         rkm_d,      &
         fdp

    real, dimension(size(tb,1),size(tb,2),size(tb,3)) :: wuo,fero,fdro,fdrso, tten_pevap, qvten_pevap
    real, dimension(size(tb,1),size(tb,2),size(tb,3)) :: qldet, qidet, qadet, cfq, peo, hmo, hms, abu

    real, dimension(size(tb,1),size(tb,2))            :: scale_uw
    real :: qtin, dqt, temp_1

!========Option for deep convection=======================================
    real, dimension(size(tb,1),size(tb,2),size(tb,3)) :: uten_d, vten_d, tten_d, &
         qvten_d, qlten_d, qiten_d, qaten_d, qnten_d, cmf_d, cbu_d, pflx_d, hlflx_d, qtflx_d, qtten_d, &
         wuo_d, fero_d, fdro_d, fdrso_d, cldql_d, cldqi_d, cldqa_d, cldqn_d, tten_pevap_d, qvten_pevap_d
    real, dimension(size(tb,1),size(tb,2)) :: rain_d, snow_d, dcapedm_d, dwfn_d, denth_d, dting_d, dqtmp_d, cbmf_d
!========Option for deep convection=======================================

    real, dimension(size(tb,3)) :: am1, am2, am3, am4, am5, qntmp
    
    real, dimension(size(tb,1),size(tb,2),size(tb,3)) :: pmass    ! layer mass (kg/m2)
    real, dimension(size(tb,1),size(tb,2))            :: tempdiag ! temporary diagnostic variable
    real, dimension(size(tracers,1),size(tracers,2),size(tracers,3),size(tracers,4))  :: trwet 
    ! calculated tracer wet deposition tendencies

    integer imax, jmax, kmax
    integer kd, ntracers
    integer ktop_tmp, kbot_tmp
    real :: tten_intg, qvten_intg
    real, dimension(size(tb,3)) :: tten_tmp, qvten_tmp
    real, dimension(size(tb,1),size(tb,2),size(tb,3)) :: tten_rad
    
    logical used
    type(sounding)          :: sd, sd1
    type(adicloud)          :: ac, ac1
    type(cclosure)          :: cc, cc1
    type(cplume)            :: cp, cp1
    type(ctend)             :: ct, ct1
    type(cpnlist)           :: cpn,dpn
    type(deepc)             :: dpc
    integer ::  ier
    character(len=256) :: ermesg

    kd = size(tracers,3)
    ntracers = size(tracers,4)
    call sd_init_k(kd,ntracers,sd);
    call sd_init_k(kd,ntracers,sd1);
    call ac_init_k(kd,ac);
    call ac_init_k(kd,ac1);
    call cp_init_k(kd,ntracers,cp)
    call cp_init_k(kd,ntracers,cp1)
    call ct_init_k(kd,ntracers,ct)
    call ct_init_k(kd,ntracers,ct1)
    !pack namelist parameters into plume and closure structure
    cpn % do_qctflx_zero = do_qctflx_zero
    cpn % do_detran_zero = do_detran_zero
    cpn % rle       = rle
    cpn % rpen      = rpen
    cpn % rmaxfrac  = rmaxfrac
    cpn % wmin      = wmin
    cpn % rbuoy     = rbuoy
    cpn % rdrag     = rdrag  
    cpn % frac_drs  = frac_drs
    cpn % bigc      = bigc    
    cpn % auto_th0  = auto_th0
    cpn % deltaqc0  = deltaqc0
    cpn % do_pdfpcp = do_pdfpcp
    cpn % do_pmadjt = do_pmadjt
    cpn % do_emmax  = do_emmax
    cpn % do_pnqv   = do_pnqv
    cpn % emfrac_max= emfrac_max
    cpn % auto_rate = auto_rate
    cpn % tcrit     = tcrit  
    cpn % cldhgt_max= cldhgt_max
    cpn % do_ice    = do_ice
    cpn % do_ppen   = do_ppen
    cpn % do_pevap  = do_pevap
    cpn % hcevap    = hcevap
    cpn % cfrac     = cfrac
    cpn % mixing_assumption= mixing_assumption
    cpn % mp_choice = mp_choice
    cpn % Nl_land   = Nl_land
    cpn % Nl_ocean  = Nl_ocean
    cpn % qi_thresh = qi_thresh
    cpn % r_thresh  = r_thresh
    cpn % peff_l    = peff_l
    cpn % peff_i    = peff_i
    cpn % t00       = t00
    cpn % rh0       = rh0
    cpn % do_forcedlifting= do_forcedlifting
    cpn % atopevap  = atopevap
    cpn % wtwmin_ratio = wmin_ratio*wmin_ratio
    cpn % do_auto_aero = do_auto_aero
    cpn % rad_crit = rad_crit
    cpn % wrel_min = wrel_min
    cpn % do_weffect = do_weffect
    cpn % weffect    = weffect
    cpn % use_online_aerosol = use_online_aerosol
    if (ntracers > 0) then
      allocate ( cpn%tracername   (ntracers) )
      allocate ( cpn%tracer_units (ntracers) )
      allocate ( cpn%wetdep       (ntracers) )
      cpn%tracername(:) = tracername(:)
      cpn%tracer_units(:) = tracer_units(:)
      cpn%wetdep(:)%scheme = wetdep(:)%scheme
      cpn%wetdep(:)%Henry_constant = wetdep(:)%Henry_constant
      cpn%wetdep(:)%Henry_variable = wetdep(:)%Henry_variable
      cpn%wetdep(:)%frac_in_cloud = wetdep(:)%frac_in_cloud
      cpn%wetdep(:)%alpha_r = wetdep(:)%alpha_r
      cpn%wetdep(:)%alpha_s = wetdep(:)%alpha_s
      cpn%wetdep(:)%Lwetdep = wetdep(:)%Lwetdep
      cpn%wetdep(:)%Lgas = wetdep(:)%Lgas
      cpn%wetdep(:)%Laerosol = wetdep(:)%Laerosol
      cpn%wetdep(:)%Lice = wetdep(:)%Lice
      allocate ( dpn%tracername   (ntracers) )
      allocate ( dpn%tracer_units (ntracers) )
      allocate ( dpn%wetdep       (ntracers) )
      dpn%tracername(:) = tracername(:)
      dpn%tracer_units(:) = tracer_units(:)
      dpn%wetdep(:)%scheme = wetdep(:)%scheme
      dpn%wetdep(:)%Henry_constant = wetdep(:)%Henry_constant
      dpn%wetdep(:)%Henry_variable = wetdep(:)%Henry_variable
      dpn%wetdep(:)%frac_in_cloud = wetdep(:)%frac_in_cloud
      dpn%wetdep(:)%alpha_r = wetdep(:)%alpha_r
      dpn%wetdep(:)%alpha_s = wetdep(:)%alpha_s
      dpn%wetdep(:)%Lwetdep = wetdep(:)%Lwetdep
      dpn%wetdep(:)%Lgas = wetdep(:)%Lgas
      dpn%wetdep(:)%Laerosol = wetdep(:)%Laerosol
      dpn%wetdep(:)%Lice = wetdep(:)%Lice
    endif
    call cpn_copy(cpn, dpn)

    cc  % igauss    = igauss
    cc  % rkfre     = rkfre
    cc  % rmaxfrac  = rmaxfrac
    cc  % wcrit_min = wcrit_min
    cc  % rbuoy     = rbuoy
    cc  % tau_sh    = tau_sh
!========Option for deep convection=======================================
    dpc % rkm_dp1             = rkm_dp1
    dpc % rkm_dp2             = rkm_dp2
    dpc % cbmf_dp_frac1       = cbmf_dp_frac1
    dpc % cbmf_dp_frac2       = cbmf_dp_frac2
    dpc % crh_th_ocean        = crh_th_ocean
    dpc % crh_th_land         = crh_th_land
    dpc % cape_th             = cape_th
    dpc % tau_dp              = tau_dp
    dpc % mixing_assumption_d = mixing_assumption_d
    dpc % do_ppen_d           = do_ppen_d
    dpc % rpen_d              = rpen_d
    dpc % do_pevap_d          = do_pevap_d
    dpc % cfrac_d             = cfrac_d
    dpc % hcevap_d            = hcevap_d
    dpc % frac_limit_d        = frac_limit_d
    dpc % dcapedm_th          = dcapedm_th
    dpc % do_forcedlifting_d  = do_forcedlifting_d
    dpc % lofactor_d          = lofactor_d
    dpc % auto_th0_d          = auto_th0_d
    dpc % tcrit_d             = tcrit_d
!========Option for deep convection=======================================
    imax  = size( tb, 1 )
    jmax  = size( tb, 2 )
    kmax  = size( tb, 3 )
    sd % kmax=kmax

    kl=kmax-1
    klm=kl-1

   !initialize 3D variables outside the loop

    tten=0.; qvten=0.; qlten=0.; qiten=0.; qaten=0.; qnten=0.;
    uten=0.; vten =0.; rain =0.; snow =0.; plcl =0.; plfc=0.; plnb=0.;  
    cldqa=0.; cldql=0.; cldqi=0.; cldqn=0.;
    hlflx=0.; qtflx=0.; pflx=0.; am1=0.; am2=0.; am3=0.; am4=0.;
    tten_pevap=0.; qvten_pevap=0.;
    ice_pflx = 0. ; liq_pflx = 0.

    cino=0.; capeo=0.; tkeo=0.; wrelo=0.; ufrco=0.; zinvo=0.; wuo=0.; peo=0.; 
    fero=0.; fdro=0.; fdrso=0.; cmf=0.; denth=0.;  dqtmp=0.; ocode=0;
    dcapeo=0.; dcino=0.; dwfno=0.; xhlsrc=0.; xqtsrc=0.; fdp=0.;
    trtend=0.; qldet=0.; qidet=0.; qadet=0.; crho=0.; hmo=0.; hms=0.; abu=0.;
    trwet = 0.
    dting = 0.

    naer = size(asol%aerosol,4)

!========Option for deep convection=======================================
    if (do_deep) then
       tten_d=0.; qvten_d=0.; qlten_d=0.; qiten_d=0.; qaten_d=0.; qnten_d=0.;
       uten_d=0.; vten_d =0.; rain_d =0.; snow_d =0.; qtten_d=0.;
       cldqa_d=0.; cldql_d=0.; cldqi_d=0.; cldqn_d=0.;
       hlflx_d=0.; qtflx_d=0.; pflx_d=0.;
       wuo_d=0.; fero_d=0.; fdro_d=0.; fdrso_d=0.; 
       cmf_d=0.; cbu_d=0.;
       denth_d=0.; dting_d=0.; dqtmp_d=0.; cbmf_d=0.; dcapedm_d=0.; dcino=0.; dwfn_d=0.;
       tten_pevap_d=0.; qvten_pevap_d=0.; rkm_d=0.;
    end if
!========Option for deep convection=======================================

    do j = 1, jmax
       do i=1, imax

         do k=1,kmax
           pmass(i,j,k) = (pint(i,j,k+1) - pint(i,j,k))/GRAV
         enddo
    !relaxation TKE back to 0 with time-scale of disscale
    !tkeavg = ustar(i,j)*bstar(i,j)*disscale 
    !dissipate tke with length-scale of disscale
    !tkeavg=(ustar(i,j)*bstar(i,j)*disscale)**(2./3.)
    !below following Holtslag and Boville 1993

         if (pblht(i,j).lt.0.) then
           temp_1=0.0
         elseif (pblht(i,j).gt.5000.) then
           temp_1=5000.
         else
           temp_1=pblht(i,j)
         endif
         temp_1=ustar(i,j)**3.+0.6*ustar(i,j)*bstar(i,j)*temp_1
         if (temp_1 .gt. 0.) temp_1 = 0.5*temp_1**(2./3.)
         tkeo(i,j) = MAX (tkemin, temp_1)

         if (do_gust_cv) then
           if (cbmfo(i,j)>0) then
             tkeo(i,j) = tkeo(i,j)+(gustmax*sqrt(cbmfo(i,j)/(gustconst + cbmfo(i,j))))**2.
           endif
         endif

         if (skip_calculation(i,j)) then
           ocode(i,j) = 6
           go to 100
         endif
         call clearit(ac, cc, cp, ct, cp1, ct1);

! restrict grid-box area available to shallow convection to that which 
! is not involved with deep convection
          cp%maxcldfrac = minval(max_available_cf(i,j,:))
          cc%maxcldfrac = cp%maxcldfrac

          cc%scaleh = cush(i,j); 
          cush(i,j) = -1.;
          if(cc%scaleh.le.0.0) cc%scaleh=1000.

          am1(:) = 0.; am2(:) = 0.; am3(:) = 0.; am4(:) = 0.; am5(:) = 0.;

          do k=1,kmax
            tmp=1. / (zint(i,j,k)-zint(i,j,k+1)) * 1.0e9 * 1.0e-12
            if(use_online_aerosol) then
              do na = 1,naer
                if(asol%aerosol_names(na) == 'so4' .or. &
                   asol%aerosol_names(na) == 'so4_anthro' .or. &
                   asol%aerosol_names(na) == 'so4_natural') then
                           am1(k)=am1(k)+asol%aerosol(i,j,k,na)*tmp
                else if(asol%aerosol_names(na) == 'omphilic' .or. &
                        asol%aerosol_names(na) == 'omphobic') then
                           am4(k)=am4(k)+asol%aerosol(i,j,k,na)*tmp
                else if(asol%aerosol_names(na) == 'bcphilic' .or. &
                        asol%aerosol_names(na) == 'bcphobic' .or. &
                        asol%aerosol_names(na) == 'dust1' .or. &
                        asol%aerosol_names(na) == 'dust2' .or. &
                        asol%aerosol_names(na) == 'dust3' ) then
                           am2(k)=am2(k)+asol%aerosol(i,j,k,na)*tmp
                else if(asol%aerosol_names(na) == 'seasalt1' .or. &
                        asol%aerosol_names(na) == 'seasalt2') then
                           am3(k)=am3(k)+asol%aerosol(i,j,k,na)*tmp
                else if(asol%aerosol_names(na) == 'seasalt3' .or. &
                        asol%aerosol_names(na) == 'seasalt4' .or. &
                        asol%aerosol_names(na) == 'seasalt5' ) then
                           am5(k)=am5(k)+asol%aerosol(i,j,k,na)*tmp
                end if
              end do
              am2(k)=am2(k)+am3(k)+am4(k)
              if(.not. use_sub_seasalt) am3(k)=am3(k)+am5(k)
            else
              am1(k)= asol%aerosol(i,j,k,2)*tmp
              am2(k)= asol%aerosol(i,j,k,1)*tmp
              am3(k)= sea_salt_scale*asol%aerosol(i,j,k,5)*tmp
              am4(k)= om_to_oc*asol%aerosol(i,j,k,3)*tmp
            endif
          end do

!========Pack column properties into a sounding structure====================

          if (do_qn) then
             qntmp(:)=q(i,j,:,nqn)
          else
             qntmp(:)=0.
          end if
          call pack_sd_k(land(i,j), coldT(i,j), delt, pmid(i,j,:), pint(i,j,:),     &
               zmid(i,j,:), zint(i,j,:), ub(i,j,:), vb(i,j,:), tb(i,j,:),   &
               q(i,j,:,nqv), q(i,j,:,nql), q(i,j,:,nqi), q(i,j,:,nqa), qntmp,       &
               am1(:), am2(:), am3(:), am4(:), tracers(i,j,:,:), sd, Uw_p)

!========Finite volume intepolation==========================================

          call extend_sd_k(sd,  pblht(i,j),do_ice, Uw_p)
          sd%tke = tkeo(i,j)
          zinvo (i,j) = sd%zinv


!========Find source air, and do adiabatic cloud lifting======================

          zsrc  =sd%zs (1)
          psrc  =sd%ps (1)
          thcsrc=sd%thc(1)
          qctsrc=sd%qct(1)
          hlsrc =sd%hl (1)
          rkm_sh1=rkm_sh
          if (do_lands) then
            !wstar   = (ustar(i,j)*bstar(i,j)*pblht(i,j))**(1./3.)
             cpn % auto_th0 = auto_th0 * (1. + landfact_m * sd%land)
             call qt_parcel_k (sd%qs(1), qstar(i,j), pblht(i,j), sd%tke, sd%land, gama, &
                  pblht0, tke0, lofactor0, lochoice, qctsrc, lofactor)
             rkm_sh1 = rkm_sh   * lofactor
          end if

          call adi_cloud_k(zsrc, psrc, hlsrc, thcsrc, qctsrc, sd, Uw_p, do_fast, do_ice, ac)
          ac % usrc = sd%u(sd%ktoppbl)
          ac % vsrc = sd%v(sd%ktoppbl)
          if (ac%plfc.eq.0) ac%plfc=psrc
          if (ac%plnb.eq.0) ac%plnb=psrc
          plcl (i,j) = ac%plcl
          plfc (i,j) = ac%plfc
          plnb (i,j) = ac%plnb
          cino (i,j) = ac%cin
          capeo(i,j) = ac%cape
          xhlsrc(i,j)= ac%hlsrc; 
          xqtsrc(i,j)= ac%qctsrc; 
          crho(i,j)  = sd%crh;
          do k = 1,kmax
             nk = kmax+1-k
             hmo  (i,j,nk) = sd%hm(k);
             hms  (i,j,nk) = sd%hms(k);
             abu  (i,j,nk) = ac%buo(k);
          end do

          if (do_fast) then
!             if (ac%klcl.eq.0 .or. ac%plcl.gt.sd%ps(1) .or. ac%plcl.lt.20000.) then
             if (ac%klcl.eq.0 .or. ac%plcl.eq.sd%ps(1) .or. ac%plcl.lt.20000.) then
                ocode(i,j)=1; goto 100 !cycle;
             end if
             if (ac%plfc.lt.500.) then
                ocode(i,j)=2; goto 100 !cycle;
             end if
          end if

!========Cumulus closure to determine cloud base mass flux===================

          cbmf_old=cbmfo(i,j); cc%cbmf=cbmf_old;

          if (iclosure.eq.0) then
             call cclosure_bretherton(sd%tke, cpn, sd, Uw_p, ac, cc)
          else if (iclosure.eq.1) then
             call cclosure_implicit(sd%tke, cpn, sd, Uw_p, ac, cc, delt, rkm_sh1, &
                  do_coldT, sd1, ac1, cc1, cp, ct, ier, ermesg) 
             if (ier /= 0) then
               call error_mesg ('subroutine uw_conv iclosure=1 ', ermesg, FATAL)
             endif
          else if (iclosure.eq.2) then
             call cclosure_relaxwfn(sd%tke, cpn, sd, Uw_p, ac, cc, cp, ct, delt,  &
                  rkm_sh1, do_coldT, sd1, ac1, cc1, cp1, ct1, ier, ermesg)
             if (ier /= 0) then
               call error_mesg ('subroutine uw_conv iclosure=2 ', ermesg, FATAL)
             endif
          end if

          cbmfo(i,j) = cc%cbmf
          wrelo(i,j) = cc%wrel
          ufrco(i,j) = cc%ufrc

          if (.not.do_fast) then
             if (ac%klcl.eq.0 .or. ac%plcl.eq.sd%ps(1) .or. ac%plcl.lt.20000.) then
!             if (ac%klcl.eq.0 .or. ac%plcl.lt.20000.) then
                ocode(i,j)=1; goto 100 !cycle;
             end if
             if (ac%plfc.lt.500.) then
                ocode(i,j)=2; goto 100 !cycle;
             end if
          end if

          if(cc%cbmf.lt.1.e-6 .or. cc%wrel.eq.0.) then
             ocode(i,j)=3; goto 100 !cycle;
          end if

!========Do shallow cumulus plume calculation================================

          cpn%isdeep=.false.


          cbmf_shallow = cc%cbmf ! - cbmf_deep
          cpn%do_ppen=do_ppen
          cpn%rpen   =rpen
          call cumulus_plume_k(cpn, sd, ac, cp, rkm_sh1, cbmf_shallow, cc%wrel, cc%scaleh, Uw_p, ier, ermesg)
          if (ier /= 0) then
            call error_mesg ('subroutine uw_conv', ermesg, FATAL)
          endif
          if(cp%ltop.lt.cp%krel+2 .or. cp%let.le.cp%krel+1) then
             ocode(i,j)=4; goto 100 !cycle;
          end if
          if(cp%cldhgt.ge.cldhgt_max) then
             ocode(i,j)=5; goto 100 !cycle;
          end if

          if (cpn%isdeep .EQV. .true.) then 
             fdp(i,j) = 1
          else
             fdp(i,j) = 0
          end if

          cush(i,j)=cp%cush


!========Calculate cumulus produced tendencies===============================

          call cumulus_tend_k(cpn, sd, Uw_p, cp, ct, do_coldT)

!========Unpack convective tendencies========================================
          do k = 1,cp%ltop
             nk = kmax+1-k
             uten  (i,j,nk) = ct%uten (k)
             vten  (i,j,nk) = ct%vten (k)
             qlten (i,j,nk) = ct%qlten(k)
             qiten (i,j,nk) = ct%qiten(k)
             qaten (i,j,nk) = ct%qaten(k)
             qnten (i,j,nk) = ct%qnten(k)
             qldet (i,j,nk) = ct%qldet(k)
             qidet (i,j,nk) = ct%qidet(k)
             qadet (i,j,nk) = ct%qadet(k)
             qvten (i,j,nk) = ct%qvten(k)
             pflx  (i,j,nk) = ct%pflx (k)
             ice_pflx(i,j,nk) = cp%ppti(k)
             liq_pflx(i,j,nk) = cp%pptr(k)
             tten  (i,j,nk) = ct%tten (k)
             rhos0j = sd%ps(k)/(rdgas*0.5*(cp%thvbot(k+1)+cp%thvtop(k))*sd%exners(k))
             hlflx(i,j,nk) = ct%hlflx(k)
             qtflx (i,j,nk) = rhos0j*HLv*ct%qctflx(k)
             tten_pevap (i,j,nk) = ct%tevap (k)
             qvten_pevap(i,j,nk) = ct%qevap (k)
             
             cldqa (i,j,nk) = cp%ufrc(k)
             cldql (i,j,nk) = cp%qlu(k)
             cldqi (i,j,nk) = cp%qiu(k)
             cldqn (i,j,nk) = cp%qnu(k)
             cmf   (i,j,nk) = cp%umf(k)
             wuo   (i,j,nk) = cp%wu (k)
             peo   (i,j,nk) = cp%peff(k)
             fero  (i,j,nk) = cp%fer(k)
             fdro  (i,j,nk) = cp%fdr(k)
             fdrso (i,j,nk) = cp%fdrsat(k)*cp%umf(k)
          enddo

! make sure the predicted tracer tendencies do not produce negative
! tracers due to convective tendencies. if necessary, adjust the 
! tendencies.
          call check_tracer_realizability (kmax, size(trtend,4), delt, &
                                           cp%tr, ct%trten, ct%trwet) 
          do k = 1,cp%ltop
             nk = kmax+1-k
             do n = 1, size(trtend,4)
               trtend(i,j,nk,n) = ct%trten(k,n) + ct%trwet(k,n)
               trwet(i,j,nk,n)  = ct%trwet(k,n)
             enddo
          enddo
          snow  (i,j)  = ct%snow
          rain  (i,j)  = ct%rain
          denth (i,j)  = ct%denth
          dqtmp (i,j)  = ct%dqtmp
          dting (i,j)  = ct%dting

!========Option for deep convection=======================================
100       if (do_deep) then
	     cbmf_deep = 0.
	     rkm_dp = 0.
             tmp   = max(min (sd%crh, 1.0), 0.0)
	     crh_th  = sd%land*dpc%crh_th_land+(1.-sd%land)*dpc%crh_th_ocean
	     dcrh  = tmp - crh_th
             dcrh0 = 1.0001-crh_th
	     if (dcrh .gt. 0) then
	        dcrh = dcrh/dcrh0;
	        dcrh = dcrh**norder
	        rkm_dp       = dpc%rkm_dp1      + dcrh * (dpc%rkm_dp2      -dpc%rkm_dp1)
	        cbmf_dp_frac = dpc%cbmf_dp_frac1+ dcrh * (dpc%cbmf_dp_frac2-dpc%cbmf_dp_frac1)
	        cbmf_deep    = 1. !%cbmf_dp_frac * cc%cbmf
                lofactor     = 1. - sd%land * (1. - dpc%lofactor_d)
	        if (do_lod_rkm) then
               	   rkm_dp       = rkm_dp * lofactor
	        elseif (do_lod_cfrac) then
		   dpc % cfrac_d= dpc % cfrac_d * lofactor
	        elseif (do_lod_tcrit) then
             	   dpc % tcrit_d= dpc % tcrit_d * lofactor
 	        end if
	     end if
             rkm_d(i,j) = rkm_dp;

             dpn % do_ppen  = dpc % do_ppen_d
             dpn % do_pevap = dpc % do_pevap_d
             dpn % cfrac    = dpc % cfrac_d
             dpn % hcevap   = dpc % hcevap_d
             dpn % tcrit    = dpc % tcrit_d
             dpn % auto_th0 = dpc % auto_th0_d
             dpn % mixing_assumption = dpc % mixing_assumption_d
             dpn % do_forcedlifting  = dpc % do_forcedlifting_d
             if (idpchoice.eq.0) then
                call  dpconv0(dpc, dpn, Uw_p, sd, ac, cc, cp, ct, do_coldT, do_ice, &
                      rkm_dp, cbmf_deep, cp1, ct1, ocode(i,j), ier, ermesg)
             else if (idpchoice.eq.1) then
                call  dpconv1(dpc, dpn, Uw_p, sd, ac, cc, cp, ct, do_coldT, do_ice, &
                      rkm_dp, cbmf_deep, sd1, ac1, cp1, ct1, ocode(i,j), dcapedm_d(i,j), ier, ermesg)
             else if (idpchoice.eq.2) then
                call  dpconv2(dpc, dpn, Uw_p, sd, ac, cc, cp, ct, do_coldT, do_ice, &
                      rkm_dp, cbmf_deep, sd1, ac1, cp1, ct1, ocode(i,j), ier, ermesg)
             end if
             if (ier /= 0) then
                call error_mesg ('uw_conv calling dpconv', ermesg, FATAL)
             endif
             if(ocode(i,j).ge.6) cycle;
             do k = 1,kmax !cp1%ltop
                nk = kmax+1-k
                uten_d  (i,j,nk) = ct1%uten (k)
                vten_d  (i,j,nk) = ct1%vten (k)
                qlten_d (i,j,nk) = ct1%qlten(k)
                qiten_d (i,j,nk) = ct1%qiten(k)
                qaten_d (i,j,nk) = ct1%qaten(k) 
                qnten_d (i,j,nk) = ct1%qnten(k) 
                qvten_d (i,j,nk) = ct1%qvten(k)
                qtten_d (i,j,nk) = ct1%qctten(k)
                pflx_d  (i,j,nk) = ct1%pflx (k)
                tten_d  (i,j,nk) = ct1%tten (k)
                hlflx_d (i,j,nk) = ct1%hlflx(k) 
                qtflx_d (i,j,nk) = ct1%qctflx(k)
                cldqa_d (i,j,nk) = cp1%ufrc(k)
                cldql_d (i,j,nk) = cp1%qlu(k)
                cldqi_d (i,j,nk) = cp1%qiu(k)
                cldqn_d (i,j,nk) = cp1%qnu(k)
                cmf_d   (i,j,nk) = cp1%umf(k) + cp1%emf(k)
                cbu_d   (i,j,nk) = cp1%buo(k)
                tten_pevap_d (i,j,nk) = ct1%tevap (k)
                qvten_pevap_d(i,j,nk) = ct1%qevap (k)
                wuo_d   (i,j,nk) = cp1%wu (k)
                fero_d  (i,j,nk) = cp1%fer(k)
                fdro_d  (i,j,nk) = cp1%fdr(k) 
                fdrso_d (i,j,nk) = cp1%fdrsat(k)*cp1%fdr(k)*cp1%umf(k)
             enddo
             snow_d  (i,j)  = ct1%snow
             rain_d  (i,j)  = ct1%rain
             cbmf_d  (i,j)  = cbmf_deep
             denth_d (i,j)  = ct1%denth
             dting_d (i,j)  = ct1%dting
             dqtmp_d (i,j)  = ct1%dqtmp
             !dwfn_d  (i,j)  = cc%dwfn

!========Option for deep convection=======================================
            
             uten  (i,j,:) = uten  (i,j,:) + uten_d  (i,j,:)
             vten  (i,j,:) = vten  (i,j,:) + vten_d  (i,j,:)
             qlten (i,j,:) = qlten (i,j,:) + qlten_d (i,j,:)
             qiten (i,j,:) = qiten (i,j,:) + qiten_d (i,j,:)
             qaten (i,j,:) = qaten (i,j,:) + qaten_d (i,j,:) 
             qnten (i,j,:) = qnten (i,j,:) + qnten_d (i,j,:) 
             qvten (i,j,:) = qvten (i,j,:) + qvten_d (i,j,:)
             pflx  (i,j,:) = pflx  (i,j,:) + pflx_d  (i,j,:)
             tten  (i,j,:) = tten  (i,j,:) + tten_d  (i,j,:)
             hlflx (i,j,:) = hlflx (i,j,:) + hlflx_d (i,j,:) 
             qtflx (i,j,:) = qtflx (i,j,:) + qtflx_d (i,j,:)
             cmf   (i,j,:) = cmf   (i,j,:) + cmf_d   (i,j,:)
             tten_pevap (i,j,:)=tten_pevap (i,j,:) + tten_pevap_d (i,j,:) 
             qvten_pevap(i,j,:)=qvten_pevap(i,j,:) + qvten_pevap_d(i,j,:) 
             !wuo   (i,j,:) = wuo   (i,j,:) 
             !fero  (i,j,:) = fero  (i,j,:) 
             !fdro  (i,j,:) = fdro  (i,j,:)  
             !fdrso (i,j,:) = fdrso (i,j,:) 
             !do n = 1, size(trtend,4)
             !   trtend(i,j,:,n) = trtend(i,j,:,n) 
             !enddo
             snow  (i,j)  = snow  (i,j) + snow_d  (i,j)
             rain  (i,j)  = rain  (i,j) + rain_d  (i,j)
             denth (i,j)  = denth (i,j) + denth_d (i,j)
             dting (i,j)  = dting (i,j) + dting_d (i,j)
             dqtmp (i,j)  = dqtmp (i,j) + dqtmp_d (i,j)
             !cbmfo (i,j)  = cc%cbmf
             !dwfno (i,j)  = cc%dwfn
          end if
!========Option for deep convection=======================================
	if (do_no_uw_conv) then
          uten (i,j,:)=0.; vten (i,j,:)=0.; 
          tten (i,j,:)=0.; qvten(i,j,:)=0.; 
          cmf  (i,j,:)=0.; qlten(i,j,:)=0.;
          qiten(i,j,:)=0.; qaten(i,j,:)=0.; 
          qnten(i,j,:)=0.; rain (i,j)  =0.; snow(i,j)=0.;
	endif
	if (do_imposing_rad_cooling) then
           tten_rad (i,j,:)=0;
	   do k = 1,sd%kmax
            nk = kmax+1-k
            if (sd%t(k)>t_thresh) then
               tten_rad (i,j,nk) = cooling_rate/86400.
	    else
               tten_rad (i,j,nk) = (t_strato-sd%t(k))/(tau_rad*86400.)
            end if
           enddo
	end if
	if (do_imposing_cooling_drying) then
           kbot_tmp=1; 
           ktop_tmp=sd%kmax;
	   do k=1,sd%kmax
	      if (sd%p(k)>=7500) then
	      	 ktop_tmp=k
	      end if
	      if (sd%p(k)>=85000) then
	      	 kbot_tmp=k
	      end if
	   enddo
           tten_tmp (:)=0; 
           qvten_tmp(:)=0;
	   do k = kbot_tmp,ktop_tmp
            if (sd%p(k)>pres_min .and. sd%p(k)<=pres_max) then
               tten_tmp (k)=tdt_rate/86400.
	       qvten_tmp(k)=qvdt_rate/86400.
            end if
           enddo
!           tten_intg=0.
!           qvten_intg=0.
!           dpsum =0.
!           do k = kbot_tmp,ktop_tmp
!     	      tten_intg  = tten_intg  + tten_tmp (k)*sd%dp(k)
!	      qvten_intg = qvten_intg + qvten_tmp(k)*sd%dp(k)
!	      dpsum    = dpsum + sd%dp(k)
!	    end do
!           do k = kbot_tmp,ktop_tmp
!             tten_tmp(k) = tten_tmp(k)  - tten_intg / dpsum
!	      qvten_tmp(k)= qvten_tmp(k) - qvten_intg /dpsum
!           end do
           do k = 1,kmax
              nk = kmax+1-k
              tten_rad  (i,j,nk) = tten_rad (i,j,nk) + tten_tmp (k)
           end do
	end if

       enddo
    enddo

    call sd_end_k(sd)
    call sd_end_k(sd1)
    call ac_end_k(ac)
    call ac_end_k(ac1)
    call cp_end_k(cp)
    call cp_end_k(cp1)
    call ct_end_k(ct)
    call ct_end_k(ct1)
    if (_ALLOCATED ( cpn%tracername    ))  deallocate ( cpn%tracername    )
    if (_ALLOCATED ( cpn%tracer_units  ))  deallocate ( cpn%tracer_units  )
    if (_ALLOCATED ( cpn%wetdep        ))  deallocate ( cpn%wetdep        )
    if (_ALLOCATED ( dpn%tracername    ))  deallocate ( dpn%tracername    )
    if (_ALLOCATED ( dpn%tracer_units  ))  deallocate ( dpn%tracer_units  )
    if (_ALLOCATED ( dpn%wetdep        ))  deallocate ( dpn%wetdep        )
    if (.not.do_uwcmt) then
       uten=0.;
       vten=0.;
    end if

    if ( prevent_unreasonable ) then
      scale_uw=HUGE(1.0)
      do k=1,kmax
        do j=1,jmax
          do i=1,imax
            if ((q(i,j,k,nqa) + qaten(i,j,k)*delt) .lt. 0. .and. (qaten(i,j,k).ne.0.)) then
              qaten(i,j,k) = -1.*q(i,j,k,nqa)/delt
            end if
            if ((q(i,j,k,nqa) + qaten(i,j,k)*delt) .gt. 1. .and. (qaten(i,j,k).ne.0.)) then
              qaten(i,j,k)= (1. - q(i,j,k,nqa))/delt
            end if
 
            if ((q(i,j,k,nql) + qlten(i,j,k)*delt) .lt. 0. .and. (qlten(i,j,k).ne.0.)) then
              tten (i,j,k) = tten(i,j,k) -(q(i,j,k,nql)/delt+qlten(i,j,k))*HLv/Cp_Air
              qvten(i,j,k) = qvten(i,j,k)+(q(i,j,k,nql)/delt+qlten(i,j,k))
              qlten(i,j,k) = qlten(i,j,k)-(q(i,j,k,nql)/delt+qlten(i,j,k))
            end if
 
            if ((q(i,j,k,nqi) + qiten(i,j,k)*delt) .lt. 0. .and. (qiten(i,j,k).ne.0.)) then
              tten (i,j,k) = tten(i,j,k) -(q(i,j,k,nqi)/delt+qiten(i,j,k))*HLs/Cp_Air
              qvten(i,j,k) = qvten(i,j,k)+(q(i,j,k,nqi)/delt+qiten(i,j,k))
    
              qiten(i,j,k) = qiten(i,j,k)-(q(i,j,k,nqi)/delt+qiten(i,j,k))
            end if

            if (do_qn) then
              if ((q(i,j,k,nqn) + qnten(i,j,k)*delt) .lt. 0. .and. (qnten(i,j,k).ne.0.)) then
                qnten(i,j,k) = qnten(i,j,k)-(q(i,j,k,nqn)/delt+qnten(i,j,k))
              end if
            endif
    !rescaling to prevent negative specific humidity for each grid point
            if (do_rescale) then
              qtin =  q(i,j,k,nqv)
              dqt  =  qvten(i,j,k) * delt
              if ( dqt.lt.0 .and. qtin+dqt.lt.1.e-10 ) then
                temp_1 = max( 0.0, -(qtin-1.e-10)/dqt )
              else
                temp_1 = 1.0
              endif
    !scaling factor for each column is the minimum value within that column
              scale_uw(i,j) = min( temp_1, scale_uw(i,j))
            endif
          enddo
        enddo
      enddo

!     where ((tracers(:,:,:,:) + trtend(:,:,:,:)*delt) .lt. 0.)
!        trtend(:,:,:,:) = -tracers(:,:,:,:)/delt
!     end where

      if (do_rescale) then
      !scale tendencies
        do k=1,kmax
          do j=1,jmax
            do i=1,imax
              uten (i,j,k)  = scale_uw(i,j) * uten (i,j,k)
              vten (i,j,k)  = scale_uw(i,j) * vten (i,j,k)
              tten (i,j,k)  = scale_uw(i,j) * tten (i,j,k)
              qvten(i,j,k)  = scale_uw(i,j) * qvten(i,j,k)
              qlten(i,j,k)  = scale_uw(i,j) * qlten(i,j,k)
              qiten(i,j,k)  = scale_uw(i,j) * qiten(i,j,k)
              qaten(i,j,k)  = scale_uw(i,j) * qaten(i,j,k)
              if (do_qn) qnten(i,j,k) = scale_uw(i,j) * qnten(i,j,k)
              if (k.eq.kmax) then
                rain(i,j) = scale_uw(i,j) * rain(i,j)
                snow(i,j) = scale_uw(i,j) * snow(i,j)
              endif
            end do
          end do
        end do
      end if
    endif


    do k=1,kmax
      do j=1,jmax
        do i=1,imax
          cfq(i,j,k) = 0
          if (wuo(i,j,k) .gt. 0.) then
            cfq(i,j,k) = 1
          endif
        enddo
      enddo
    enddo

    !diagnostic output
    used = send_data( id_xhlsrc_uwc,       xhlsrc,             Time, is, js)
    used = send_data( id_xqtsrc_uwc,       xqtsrc,             Time, is, js)
    used = send_data( id_tdt_pevap_uwc,    tten_pevap*aday , Time, is, js, 1)
    used = send_data( id_qdt_pevap_uwc,    qvten_pevap*aday, Time, is, js, 1)

    used = send_data( id_tdt_uwc,    tten*aday , Time, is, js, 1)
    used = send_data( id_qdt_uwc,    qvten*aday, Time, is, js, 1)
    used = send_data( id_cmf_uwc,    cmf,          Time, is, js, 1)
    used = send_data( id_cfq_uwc,    cfq,          Time, is, js, 1)
    used = send_data( id_wu_uwc,     wuo,          Time, is, js, 1)
    used = send_data( id_peo_uwc,    peo,          Time, is, js, 1)
    used = send_data( id_fer_uwc,    fero,         Time, is, js, 1)
    used = send_data( id_fdr_uwc,    fdro,         Time, is, js, 1)
    used = send_data( id_fdrs_uwc,   fdrso,        Time, is, js, 1)
    used = send_data( id_cqa_uwc,    cldqa,        Time, is, js, 1)
    used = send_data( id_cql_uwc,    cldql,        Time, is, js, 1)
    used = send_data( id_cqi_uwc,    cldqi,        Time, is, js, 1)
    used = send_data( id_cqn_uwc,    cldqn,        Time, is, js, 1)
    used = send_data( id_hlflx_uwc, hlflx,       Time, is, js, 1)
    used = send_data( id_qtflx_uwc,  qtflx,        Time, is, js, 1)
    used = send_data( id_hmo_uwc,    hmo,          Time, is, js, 1)
    used = send_data( id_hms_uwc,    hms,          Time, is, js, 1)
    used = send_data( id_abu_uwc,    abu,          Time, is, js, 1)
    used = send_data( id_tdt_rad_uwc,tten_rad*aday,Time, is, js, 1)!miz
  
    used = send_data( id_prec_uwc, (rain+snow)*aday, Time, is, js )
    used = send_data( id_snow_uwc, (snow)*aday,      Time, is, js )
    used = send_data( id_cin_uwc,  (cino),             Time, is, js )
    used = send_data( id_cape_uwc, (capeo),            Time, is, js )
    used = send_data( id_crh_uwc,  (crho),             Time, is, js )
    used = send_data( id_tke_uwc,  (tkeo),             Time, is, js )
    used = send_data( id_cbmf_uwc, (cbmfo),            Time, is, js )
    used = send_data( id_wrel_uwc, (wrelo),            Time, is, js )
    used = send_data( id_ufrc_uwc, (ufrco),            Time, is, js )
    used = send_data( id_plcl_uwc, (plcl*0.01),        Time, is, js )
    used = send_data( id_plfc_uwc, (plfc*0.01),        Time, is, js )
    used = send_data( id_plnb_uwc, (plnb*0.01),        Time, is, js )
    used = send_data( id_zinv_uwc, (zinvo),            Time, is, js )
    used = send_data( id_cush_uwc, (cush),             Time, is, js )
    used = send_data( id_dcin_uwc, (dcino),            Time, is, js )
    used = send_data( id_dcape_uwc,(dcapeo),           Time, is, js )
    used = send_data( id_dwfn_uwc, (dwfno),            Time, is, js )
    used = send_data( id_enth_uwc, (denth),            Time, is, js )
    used = send_data( id_qtmp_uwc, (dqtmp),            Time, is, js )
    used = send_data( id_dting_uwc,(dting),            Time, is, js )
    used = send_data( id_ocode_uwc,(ocode),            Time, is, js )
    used = send_data( id_fdp_uwc,  (fdp),              Time, is, js )
   
    if ( do_strat ) then
       used = send_data( id_qldt_uwc, qlten*aday,    Time, is, js, 1)
       used = send_data( id_qidt_uwc, qiten*aday,    Time, is, js, 1)
       used = send_data( id_qadt_uwc, qaten*aday,    Time, is, js, 1)
       used = send_data( id_qndt_uwc, qnten*aday,    Time, is, js, 1)
       used = send_data( id_qldet_uwc,  qldet*aday,  Time, is, js, 1)
       used = send_data( id_qidet_uwc,  qidet*aday,  Time, is, js, 1)
       used = send_data( id_qadet_uwc,  qadet*aday,  Time, is, js, 1)
       used = send_data( id_qtdt_uwc,(qvten+qlten+qiten)*aday,Time, is, js, 1)
    end if

    if ( allocated(id_tracerdt_uwc) ) then
       do n = 1,size(id_tracerdt_uwc)
          used = send_data( id_tracerdt_uwc(n), trtend(:,:,:,n), Time, is, js, 1)
       end do
    end if
    if ( allocated(id_tracerdt_uwc_col) ) then
       do n = 1,size(id_tracerdt_uwc_col)
          if ( id_tracerdt_uwc_col(n) > 0 ) then
            tempdiag = 0.
            do k = 1,kmax
               tempdiag(:,:) = tempdiag(:,:) + trtend(:,:,k,n) * pmass(:,:,k)
            end do
            used = send_data( id_tracerdt_uwc_col(n), tempdiag(:,:), Time, is, js)
          end if
       end do
    end if
    if ( allocated(id_tracerdtwet_uwc) ) then
       do n = 1,size(id_tracerdtwet_uwc)
          used = send_data( id_tracerdtwet_uwc(n), trwet(:,:,:,n), Time, is, js, 1)
       end do
    end if
    if ( allocated(id_tracerdtwet_uwc_col) ) then
       uw_wetdep = 0.
       do n = 1,size(id_tracerdtwet_uwc_col)
          if ( id_tracerdtwet_uwc_col(n) > 0 ) then
             tempdiag = 0.
             do k = 1,kmax
               tempdiag(:,:) = tempdiag(:,:) + trwet(:,:,k,n) * pmass(:,:,k)
            end do
            used = send_data( id_tracerdtwet_uwc_col(n), tempdiag(:,:), Time, is, js)
            uw_wetdep(:,:,n) = tempdiag(:,:)
          end if
       end do
    end if

!========Option for deep convection=======================================
    if (do_deep) then
       used=send_data( id_tdt_pevap_uwd,    tten_pevap_d*aday , Time, is, js, 1)
       used=send_data( id_qdt_pevap_uwd,    qvten_pevap_d*aday, Time, is, js, 1)
       used=send_data( id_tdt_uwd,   tten_d*aday , Time, is, js, 1)
       used=send_data( id_qdt_uwd,   qvten_d*aday, Time, is, js, 1)
       used=send_data( id_qtdt_uwd,  qtten_d*aday, Time, is, js, 1)
       used=send_data( id_cmf_uwd,   cmf_d,          Time, is, js, 1)
       used=send_data( id_cbu_uwd,   cbu_d,          Time, is, js, 1)
       used=send_data( id_wu_uwd,    wuo_d,          Time, is, js, 1)
       used=send_data( id_fer_uwd,   fero_d,         Time, is, js, 1)
       used=send_data( id_fdr_uwd,   fdro_d,         Time, is, js, 1)
       used=send_data( id_fdrs_uwd,  fdrso_d,        Time, is, js, 1)
       used=send_data( id_cqa_uwd,   cldqa_d,        Time, is, js, 1)
       used=send_data( id_cql_uwd,   cldql_d,        Time, is, js, 1)
       used=send_data( id_cqi_uwd,   cldqi_d,        Time, is, js, 1)
       used=send_data( id_cqn_uwd,   cldqn_d,        Time, is, js, 1)
       used=send_data( id_hlflx_uwd, hlflx_d,        Time, is, js, 1)
       used=send_data( id_qtflx_uwd, qtflx_d,        Time, is, js, 1)
      
       used=send_data( id_prec_uwd, (rain_d+snow_d)*aday,Time, is, js )
       used=send_data( id_snow_uwd, (snow_d)*aday,       Time, is, js )
       used=send_data( id_cbmf_uwd, (cbmf_d),              Time, is, js )
       used=send_data( id_dcapedm_uwd,(dcapedm_d),         Time, is, js )
       used=send_data( id_dwfn_uwd, (dwfn_d),              Time, is, js )
       used=send_data( id_enth_uwd, (denth_d),             Time, is, js )
       used=send_data( id_rkm_uwd,  (rkm_d),               Time, is, js )
             
       if ( do_strat ) then
          used=send_data( id_qldt_uwd, qlten_d*aday,     Time, is, js, 1)
          used=send_data( id_qidt_uwd, qiten_d*aday,     Time, is, js, 1)
          used=send_data( id_qadt_uwd, qaten_d*aday,     Time, is, js, 1)
       end if
    end if
!========Option for deep convection=======================================


    if (.not.apply_tendency) then
       uten=0.; vten=0.; tten=0.; qvten=0.; cmf=0.; rain=0.; snow=0.;
       qlten=0.; qiten=0.; qaten=0.; qnten=0.;
    end if
!miz
    if (do_imposing_rad_cooling) then
       	  do j = 1, jmax	   
       	     do i=1, imax	   
	     	tten  (i,j,:) =	tten (i,j,:) + tten_rad (i,j,:)
	     end do
	  end do
    end if	
!miz
    if (do_gust_cv) then
     	  do j = 1, jmax	   
       	     do i=1, imax	   
               cbmfo(i,j) = rain(i,j) + snow(i,j)
             end do
          end do
    end if

  END SUBROUTINE UW_CONV

!#####################################################################
!#####################################################################

  subroutine clearit(ac, cc, cp, ct, cp1, ct1)

    type(adicloud), intent(inout) :: ac
    type(cclosure), intent(inout) :: cc
    type(cplume),   intent(inout) :: cp,cp1
    type(ctend),    intent(inout) :: ct,ct1

    call ac_clear_k(ac); 
    ac%klcl =0;  ac%klfc =0;  ac%klnb =0; 

    cc%wrel=0.; cc%ufrc=0.; cc%scaleh=0.;

    call cp_clear_k(cp);  cp%maxcldfrac =1.;
    call ct_clear_k(ct);
    call cp_clear_k(cp1); cp1%maxcldfrac=1.;
    call ct_clear_k(ct1);

  end subroutine clearit


!#####################################################################

end MODULE UW_CONV_MOD

      module mcm_swnew_mod

      use mcm_swtbls_mod, only: aaa, aab
      Use       Fms_Mod, ONLY: write_version_number, mpp_pe, mpp_root_pe, &
                               error_mesg, FATAL

!implicit none 
private 

      character(len=128) :: version = '$Id: mcm_swnew.F90,v 10.0 2003/10/24 22:00:32 fms Exp $'
      character(len=128) :: tagname = '$Name: tikal $'
      logical            :: module_is_initialized = .false.

public mcm_swnew, mcm_swnew_init, mcm_swnew_end

      contains

      subroutine mcm_swnew( cosz, rco2, rh2o, ro3, pp, &
              cwca, cwcb, coca, cloudy, kthsw, kbhsw, ssolar, pr2, &
              flx, heat, grdflx, ncv, kx, UF, DF)

!          TK Original array parameters:
!              cosz, tauda, rco2, rh2o, ro3, pp, &
!              cwca, cwcb, coca, cloudy, kthsw, kbhsw, solrsw, pr2, &
!              flx, heat, grdflx, ncv, kx)

!     TK Modified from Kerr's re-write of SS shortwave routine
!     swnew.F.  FMS developmental version 5/29/01.

!     This routine performs SS shortwave radiation on a single
!     column (of dimension kx).  For kx use RDPARM_MOD.

!     rh2o and ro3 have been modified to have dimension kx, rather
!     than kx+1.

!     New output arrays UF, DF have been added as needed by FMS.

!     cosz, tauda, solrsw  trio of input variables replaced by
!     cosz and ssolar as in FMS.  Code modified below.


      parameter (nbsw=9)

! TK      real   , intent (in)  :: cosz, tauda, rco2, solrsw
      real   , intent (in)  :: cosz, rco2, Ssolar

! TK      real   , intent (in), dimension(kx+1)      :: rh2o, ro3
      real   , intent (in), dimension(kx)        :: rh2o, ro3
      real   , intent (in), dimension(0:kx)      :: pp
      real   , intent (in), dimension(1:kx+2)    :: cwca, cwcb, coca, cloudy
      real   , intent (in), dimension(1:kx+1)    :: pr2

      integer, intent (in), dimension(1:kx+2)    :: kthsw, kbhsw
      integer, intent (in)                       :: ncv, kx

      real   , intent (out)                      :: grdflx
! TK      real   , intent (out), dimension(1:kx+1)   :: flx, heat
      real   , intent (out), dimension(1:kx+1)   :: flx, heat, UF, DF

      dimension abcff (nbsw)
      dimension absdo3(kx+1)
      dimension absuo3(kx+1)
      dimension aco2  ((kx+1)*2)
      dimension adco2 (kx+1)
      dimension alfa  (nbsw)
      dimension alfat (nbsw,kx+1)
      dimension alfau (nbsw,kx+1)
      dimension ao3   ((kx+1)*2)
      dimension auco2 (kx+1)
      dimension axx   ((kx+1)*2)
      dimension ayy   ((kx+1)*2)
      dimension azz   ((kx+1)*2)
      dimension cca   (nbsw,kx+2)
      dimension ccb   (nbsw,kx+2)
      dimension cr    (nbsw,kx+2)
      dimension cro3  (kx+2)
      dimension ct    (nbsw,kx+2)
      dimension cto3  (kx+2)
      dimension ddrv  (nbsw,kx)
! TK      dimension df    (kx+1)
      dimension dfn   (nbsw,kx+1)
      dimension dpcld (kx)
      dimension dpsw  (kx+1)
      dimension duco2 (kx+1)
      dimension duo3  (kx+1)
      dimension dusw  (kx+1)
      dimension ff    (kx+1)
      dimension ffco2 (kx+1)
      dimension ffo3  (kx+1)
      dimension in    ((kx+1)*2)
      dimension ixx   ((kx+1)*2)
      dimension ppress(kx+1)
      dimension pwts  (nbsw)
      dimension t1    (nbsw,kx+1)
      dimension t2    (nbsw,kx+1)
      dimension tcld  (nbsw,kx+1)
      dimension tclu  (nbsw,kx+1)
      dimension tdh2o (nbsw,kx+1)
      dimension ttd   (nbsw,kx+1)
      dimension ttu   (nbsw,kx+1)
      dimension tuh2o (nbsw,kx+1)
      dimension uco2  ((kx+1)*2)
      dimension ud    (kx+1)
      dimension udco2 (kx+1)
      dimension udo3  (kx+1)
      dimension udrv  (nbsw,kx)
! TK      dimension uf    (kx+1)
      dimension ufn   (nbsw,kx+1)
      dimension uo3   ((kx+1)*2)
      dimension ur    (kx+1)
      dimension urco2 (kx+1)
      dimension uro3  (kx+1)
      dimension vv    (nbsw)
      dimension vvd   (nbsw)
      dimension vvu   (nbsw)

      data abcff/2*4.0e-5,.002,.035,.377,1.95,9.40,44.6,190./
      data pwts/.5000,.1470,.0698,.1443,.0584,.0335,.0225,.0158,.0087/
      data cfco2,cfo3/508.96,466.64/
      data reflo3/1.9/
      data rrayav/0.144/
      data g1/1.020408e-3/

      kp    = kx + 1
      kpx2  = kp*2
      kpx2m = kpx2-1
      nc0   = ncv - 2
      nc1   = nc0 + 1
      nc2   = nc0 + 2
      nc3   = nc0 + 3

      ppress(1:kp) = pp(0:kx)

      do 351 i=1,kp
      ff(i)=1.66
      ffco2(i)=1.66
      ffo3(i)=1.90
351   continue
      do 339 k=1,nc2
      cro3(k)=coca(k)*cloudy(k)
339   continue
      do 334 kk=1,nc2
      cto3(kk)=1.-cro3(kk)
334   continue
      do 335 n=2,nbsw
      do 335 k=1,nc2
      cca(n,k)=cwca(k)
      ccb(n,k)=cwcb(k)
335   continue
      do 336 n=2,nbsw
      do 333 kk=1,nc2
      cr(n,kk)=cca(n,kk)*cloudy(kk)
      ct(n,kk)=cloudy(kk)*(1.-(cca(n,kk)+ccb(n,kk)))+1.-cloudy(kk)
333   continue
336   continue
      do 337 kk=1,nc2
      cr(1,kk)=cro3(kk)
      ct(1,kk)=cto3(kk)
337   continue
!     kbhsw,kthsw are cloud level indices for bottom and top of cloud
!     cr,ct are cloud reflectivity,transmissivity with index 2
!     representing the topmost cloud
!     ***********************************************************
!     calculate initial ozone reflectivity
      rray=0.219/(1.+0.816*cosz)
      rg=cro3(nc2)
      refl=rray+(1.-rray)*(1.-rrayav)*rg/(1.-rg*rrayav)
      cr(1,nc2)=refl
      ltop=kthsw(2)
      secz=1./cosz
      do 2 i=1,kx
2     dpsw(i)=ppress(i+1)-ppress(i)
      do 3 i=1,kx
      duo3(i)=ro3(i)*dpsw(i)*g1
      duco2(i)=rco2*dpsw(i)*g1
3     dusw(i)=rh2o(i)*dpsw(i)*g1
      do 131 i=1,ltop
      ffo3(i)=secz
      ffco2(i)=secz
      ff(i)=secz
131   continue
!     calculate pressure-weighted optical paths in units of g/cm2.
!     pressure weighting is by p**0.5
!     ud is the downward path,ur the upward path,
!     and the calculation is made by taking a path with an angle
!     of (secz) from the top of the atmosphere to the topmost cloud,
!     then using the diffusivity factor (1.66) to the surface and for
!     reflected radiation. the code below reflects this.
      ud(1)=0.
      udco2(1)=0.
      udo3(1)=0.
      do 4 i=2,kp
      ud(i)=ud(i-1)+dusw(i-1)*pr2(i-1)*ff(i)
      udco2(i)=udco2(i-1)+duco2(i-1)*pr2(i-1)*ffco2(i)*cfco2
      udo3(i)=udo3(i-1)+duo3(i-1)*ffo3(i)*cfo3
4     continue
!     udo3,uro3 are in units of cm. cfco2,cfo3 is the conversion
!     factor from gm/cm2 to cm.
      ur(kp)=ud(kp)
      urco2(kp)=udco2(kp)
      uro3(kp)=udo3(kp)
      do 5 i=1,kx
      ur(i)=ud(kp)+1.66*(ud(kp)/ff(kp)-ud(i)/ff(i+1)) &
                +ud(ltop)*(ff(kp)-ff(i+1))/ff(i+1)
      urco2(i)=urco2(kp)+1.66*(udco2(kp)/ffco2(kp)-udco2(i)/ffco2(i+1)) &
         +udco2(ltop)*(ffco2(kp)-ffco2(i+1))/ffco2(i+1)
      uro3(i)=uro3(kp)+reflo3*(udo3(kp)/ffo3(kp)-udo3(i)/ffo3(i+1)) &
           +udo3(ltop)*(ffo3(kp)-ffo3(i+1))/ffo3(i+1)
5     continue
 
!     maximize the size of o3 and co2 path lengths to avoid going
!     off tables

      uo3(1:kp)    = udo3(1:kp)
      uo3(kx+2:kp*2) = uro3(1:kp)

      uco2(1:kp)    = udco2(1:kp)
      uco2(kx+2:kp*2) = urco2(1:kp)

      do 621 k=1,kpx2
       uco2(k) =amin1(uco2(k),998.9)
       uo3(k) =amin1(uo3(k),3.998)
621   continue
 
!     calculate entering flux at the top
      do 6 n=1,nbsw
! TK      dfn(n,1)=solrsw*6.97667e5*cosz*tauda*pwts(n)
! TK      Replace 
      dfn(n,1)=Ssolar*6.97667e5*pwts(n)
6     continue
!     calculate water vapor transmission functions for bands 2-9;
!     t.f. for band 1= t.f for band 2
      do 7 k=1,kp
      do 7 n=2,nbsw
      t1(n,k)=amin1(abcff(n)*ud(k),50.)
      t2(n,k)=amin1(abcff(n)*ur(k),50.)
7     continue
      do 8 n=2,nbsw
      tdh2o(n,1)=1.
8     continue
      do 9 n=2,nbsw
      do 9 k=2,kp
      tdh2o(n,k)=exp(-t1(n,k))
9     continue
      do 10 n=2,nbsw
      tuh2o(n,kp)=tdh2o(n,kp)
10    continue
      do 11 n=2,nbsw
      do 11 k=1,kx
      tuh2o(n,k)=exp(-t2(n,k))
11    continue
      do 12 k=1,kp
      tdh2o(1,k)=tdh2o(2,k)
      tuh2o(1,k)=tuh2o(2,k)
12    continue
!     calculate co2 absorptions . they will be used in bands 2-9.
!     since these occupy 50 percent of the solar spectrum the
!     absorptions will be multiplied by 2.
!     the absorptions are obtained by table lookup in array aab,
!     common block swtabl,and then interpolation.
      do 614 k=1,kpx2
      ixx(k)=uco2(k)+1.
614   continue
      do 615 k=1,kpx2
      axx(k)=uco2(k)-ifix(uco2(k))
615   continue
      call mcm_sif1d ( ixx, kpx2m, ayy, azz )
      do 617 k=1,kpx2
      aco2(k)=ayy(k)+axx(k)*(azz(k)-ayy(k))
617   continue

      adco2(1:kp) = aco2(1:kp)
      auco2(1:kp) = aco2(kx+2:kp*2)

      do 26 k=1,kp
      adco2(k)=2.*adco2(k)
      auco2(k)=2.*auco2(k)
26    continue
!     now calculate ozone absorptions. these will be used in
!     band 1. as this occupies 50 percent of the solar spectrum
!     the ozone absorptions will be multiplied by 2.
!     the ozone absorptions are obtained by table lookup from
!     array aaa, common block swtabl. no interpolation is done.
      do 603 k=1,kpx2
      in(k)=500.*uo3(k)+1
603   continue
      call mcm_sif1 ( in, kpx2m, ao3 )

      absdo3(1:kp) = ao3(1:kp)
      absuo3(1:kp) = ao3(kx+2:kp*2)

      do 33 k=1,kp
      absdo3(k)=2.*absdo3(k)
      absuo3(k)=2.*absuo3(k)
33    continue
!     combine absorptions and transmissions to obtain a
!     transmission function for each of the 9 bands.
      do 41 n=1,nbsw
      ttd(n,1)=1.
41    continue
      do 42 k=2,kp
      ttd(1,k)=tdh2o(1,k)*(1.-absdo3(k))
42    continue
      do 43 k=1,kx
      ttu(1,k)=tuh2o(1,k)*(1.-absuo3(k))
43    continue
      do 44 n=2,nbsw
      do 44 k=2,kp
      ttd(n,k)=tdh2o(n,k)*(1.-adco2(k))
44    continue
      do 45 n=1,nbsw
      ttu(n,kp)=ttd(n,kp)
45    continue
      do 46 n=2,nbsw
      do 46 k=1,kx
      ttu(n,k)=tuh2o(n,k)*(1.-auco2(k))
46    continue
!     the following calculation is for alfat: the ratio between
!     the downward flux at the top of the highest cloud (if
!     present) or the ground to the upward flux at the same
!     level, taking into account multiple reflections from
!     clouds, if present
      do 53 n=1,nbsw
      do 53 nn=1,nc1
      alfat(n,nn)=cr(n,nc3-nn)
53    continue
      do 55 nn=1,nc1
      do 55 n=1,nbsw
      alfau(n,nn)=0.
55    continue
      if ( nc0 .eq. 0 )  go to 58
      do 51 ll=1,nc1
      kt1=kthsw(nc3-ll)
      kt2=kthsw(nc2-ll)
      kt3=kbhsw(nc2-ll)
!     tclu(ll) is transmission function from top of next lower
!     cloud to top of upper cloud. tcld(ll) is t.f. from top
!     of next lower cloud to bottom of upper cloud. ll=1 is
!     the lowest bottom cloud (the ground) ; ll=nc1 is the
!     highest upper cloud. this calculation is used for the
!     alfat calculation only if cloud is present.
      do 52 n=1,nbsw
      tclu(n,ll)=ttd(n,kt1)/ttd(n,kt2)
      tcld(n,ll)=ttd(n,kt1)/ttd(n,kt3)
52    continue
51    continue
      do 56 nn=1,nc0
      do 57 n=1,nbsw
      alfau(n,nn+1)=(cr(n,nc3-nn)+alfau(n,nn))*ct(n,nc2-nn)* &
           ct(n,nc2-nn)*tclu(n,nn)*tclu(n,nn)/ &
           (1.-(cr(n,nc3-nn)+alfau(n,nn))*cr(n,nc2-nn)* &
           tcld(n,nn)*tcld(n,nn))
57    continue
56    continue
58    continue
      do 59 n=1,nbsw
      alfa(n)=alfat(n,nc1)+alfau(n,nc1)
59    continue
!     downward flux above topmost cloud
      do 61 n=1,nbsw
      vv(n)=dfn(n,1)
61    continue
      do 62 n=1,nbsw
      do 62 k=2,ltop
      dfn(n,k)=vv(n)*ttd(n,k)
62    continue
!     upward flux above topmost cloud
      ltopm=ltop-1
      do 63 n=1,nbsw
      ufn(n,ltop)=alfa(n)*dfn(n,ltop)
63    continue
      do 64 n=1,nbsw
      vv(n)=ufn(n,ltop)/ttu(n,ltop)
64    continue
      do 65 n=1,nbsw
      do 65 k=1,ltopm
      ufn(n,k)=vv(n)*ttu(n,k)
65    continue
      if ( nc0 .eq. 0 )  go to 91
!     calculate ufn at cloud tops and dfn at cloud bottoms
      do 71 ll=2,nc1
      do 72 n=1,nbsw
      ufn(n,kthsw(ll+1))=alfau(n,nc3-ll)*dfn(n,kbhsw(ll-1))* &
           tcld(n,nc3-ll)/(tclu(n,nc2-ll)*ct(n,ll))
72    continue
      do 73 n=1,nbsw
      dfn(n,kbhsw(ll))=dfn(n,kbhsw(ll-1))*tcld(n,nc3-ll)*tclu(n,nc2-ll)* &
           ct(n,ll)/tcld(n,nc2-ll)+ufn(n,kthsw(ll+1))*tcld(n,nc2-ll)* &
           cr(n,ll)
73    continue
71    continue
!     now obtain dfn and ufn for levels between the clouds
      do 74 ll=1,nc0
      ltop=kbhsw(ll+1)
      ltopp=ltop+1
      lbot=kthsw(ll+2)
      lbotm=lbot-1
      if (ltop.eq.lbot) go to 74
      do 75 n=1,nbsw
      vvu(n)=ufn(n,lbot)/ttu(n,lbot)
      vvd(n)=dfn(n,ltop)/ttd(n,ltop)
75    continue
      do 76 k=ltop,lbotm
      do 76 n=1,nbsw
      ufn(n,k)=vvu(n)*ttu(n,k)
76    continue
      do 77 k=ltopp,lbot
      do 77 n=1,nbsw
      dfn(n,k)=vvd(n)*ttd(n,k)
77    continue
74    continue
!     now obtain downward and upward fluxes for levels,if any,
!     between the tops and bottoms of clouds. the assumption of
!     constant heating rate in these regions is used.
      do 78 ll=1,nc0
      ltop=kthsw(ll+1)
      lbot=kbhsw(ll+1)
      if((lbot-ltop).le.1) go to 78
      ltopp=ltop+1
      lbotm=lbot-1
      dpcld(ll)=ppress(ltop)-ppress(lbot)
      do 79 n=1,nbsw
      udrv(n,ll)=(ufn(n,ltop)-ufn(n,lbot))/dpcld(ll)
      ddrv(n,ll)=(dfn(n,ltop)-dfn(n,lbot))/dpcld(ll)
79    continue
      do 80 n=1,nbsw
      vvu(n)=ufn(n,ltop)
      vvd(n)=dfn(n,ltop)
80    continue
      do 81 k=ltopp,lbotm
      do 81 n=1,nbsw
      ufn(n,k)=vvu(n)+udrv(n,ll)*(ppress(k)-ppress(ltop))
      dfn(n,k)=vvd(n)+ddrv(n,ll)*(ppress(k)-ppress(ltop))
81    continue
78    continue
91    continue
!     sum over bands
 
      do 14 k=1,kp
      df(k)=0.
      uf(k)=0.
      do 15 n=1,nbsw
      df(k)=df(k)+dfn(n,k)
      uf(k)=uf(k)+ufn(n,k)
15    continue
14    continue
      do 16 k=1,kp
      flx(k)=uf(k)-df(k)
16    continue
! TK REMOVE: cdir$ novector
      do 17 k=1,kx
      heat(k)=8.42668*(flx(k+1)-flx(k))/dpsw(k)
17    continue
! TK REMOVE: cdir$ vector
!     8.42668=g(cgs units)*(no.sec/da)/cp(cgs units)
      grdflx=(1.-refl)*dfn(1,kp)
      do 19 n=2,nbsw
      grdflx=grdflx+ct(1,nc2)*dfn(n,kp)
19    continue
      return
      end subroutine mcm_swnew
! --------------------------------------------
      subroutine mcm_sif1(ndx,len,tgt)
      dimension ndx(1),tgt(1)
      leng=len+1
      do 10 j=1,leng
        jj=ndx(j)
        tgt(j)=aaa(jj)
  10  continue
      return
      end subroutine mcm_sif1
! --------------------------------------------
      subroutine mcm_sif1d(ndx,len,tgt1,tgt2)
      dimension ndx(1),tgt1(1),tgt2(1)
      leng=len+1
      do 10 j=1,leng
        jj=ndx(j)
        tgt1(j)=aab(jj)
        tgt2(j)=aab(jj+1)
  10  continue
      return
      end subroutine mcm_sif1d

! ---------------------------------------------------------------------------------------
      subroutine mcm_swnew_init
!------- write version number and namelist ---------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
      endif

      module_is_initialized = .true.

!---------------------------------------------------------------------

      end subroutine mcm_swnew_init
! ---------------------------------------------------------------------------------------
      subroutine mcm_swnew_end

      module_is_initialized = .false.

!---------------------------------------------------------------------
      end subroutine mcm_swnew_end


      end module mcm_swnew_mod

#include <fms_platform.h>

! ----------------------------------------------------------------
!                   GNU General Public License                        
! This file is a part of MOM.                                                                 
!                                                                      
! MOM is free software; you can redistribute it and/or modify it and  
! are expected to follow the terms of the GNU General Public License  
! as published by the Free Software Foundation; either version 2 of   
! the License, or (at your option) any later version.                 
!                                                                      
! MOM is distributed in the hope that it will be useful, but WITHOUT    
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
! License for more details.                                           
!                                                                      
! For the full text of the GNU General Public License,                
! write to: Free Software Foundation, Inc.,                           
!           675 Mass Ave, Cambridge, MA 02139, USA.                   
! or see:   http://www.gnu.org/licenses/gpl.html                      
!-----------------------------------------------------------------------
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> John P. Dunne
!</REVIEWER>
!
!<OVERVIEW>
! Ocean Carbon Model Intercomparison Study II: Biotic module
!</OVERVIEW>
!
!<DESCRIPTION>
!       Implementation of routines to solve the OCMIP-2 Biotic
!       simulations as outlined in the Biotic-HOWTO documentation,
!       revision 1.7, 1999/10/05.
!</DESCRIPTION>
!
! <INFO>
! <REFERENCE>
! http://www.ipsl.jussieu.fr/OCMIP/phase2/simulations/Biotic/HOWTO-Biotic.html
! </REFERENCE>
!
! <REFERENCE>
! Press, W. H., S. A. Teukosky, W. T. Vetterling, B. P. Flannery, 1992. 
! Numerical Recipes in FORTRAN, Second Edition, Cambridge University Press. 
! </REFERENCE>
!
! <REFERENCE>
! Enting, I.G., T. M. L. Wigley, M. Heimann, 1994. Future Emissions 
! and concentrations of carbon dioxide: key ocean / atmosphere / 
! land analyses, CSIRO Aust. Div. Atmos. Res. Tech. Pap. No. 31, 
! 118 pp.
! </REFERENCE>
! </INFO>
!
!------------------------------------------------------------------
!
!       Module ocean_bgc_restore_mod
!
!       Implementation of routines to solve the OCMIP-2 Biotic
!       simulations as outlined in the Biotic-HOWTO documentation,
!       revision 1.7, 1999/10/05.
!
!------------------------------------------------------------------
!

module  ocean_bgc_restore_mod

use time_manager_mod,         only: time_type
use diag_manager_mod,         only: register_diag_field, diag_axis_init
use field_manager_mod,        only: fm_field_name_len, fm_path_name_len, fm_string_len
use field_manager_mod,        only: fm_get_length, fm_get_value, fm_new_value, fm_get_index
use fms_mod,                  only: field_exist, file_exist
use fms_io_mod,               only: register_restart_field, save_restart, restore_state
use fms_io_mod,               only: restart_file_type
use mpp_mod,                  only: stdout, stdlog, mpp_error, mpp_sum, FATAL
use time_manager_mod,         only: get_date
use time_interp_external_mod, only: time_interp_external, init_external_field
use mpp_domains_mod,          only: domain2d
use constants_mod,            only: WTMCO2, WTMO2

use ocean_tpm_util_mod, only: otpm_set_tracer_package, otpm_set_prog_tracer, otpm_set_diag_tracer
use fm_util_mod,        only: fm_util_check_for_bad_fields, fm_util_set_value
use fm_util_mod,        only: fm_util_get_string, fm_util_get_logical, fm_util_get_integer, fm_util_get_real
use fm_util_mod,        only: fm_util_get_logical_array, fm_util_get_real_array, fm_util_get_string_array
use fm_util_mod,        only: fm_util_start_namelist, fm_util_end_namelist
use coupler_types_mod,  only: ind_alpha, ind_csurf, coupler_2d_bc_type, ind_flux
use ocean_types_mod,    only: ocean_prog_tracer_type, ocean_diag_tracer_type, ocean_grid_type, ocean_time_type
use ocmip2_co2calc_mod, only: ocmip2_co2calc
use ocean_util_mod,     only: diagnose_2d, diagnose_2d_comp, diagnose_3d_comp

implicit none

private

public  :: ocean_bgc_restore_bbc
public  :: ocean_bgc_restore_end
public  :: ocean_bgc_restore_init
public  :: ocean_bgc_restore_flux_init
public  :: ocean_bgc_restore_sbc
public  :: ocean_bgc_restore_source
public  :: ocean_bgc_restore_start
public  :: ocean_bgc_restore_init_sfc
public  :: ocean_bgc_restore_avg_sfc
public  :: ocean_bgc_restore_sum_sfc
public  :: ocean_bgc_restore_zero_sfc
public  :: ocean_bgc_restore_sfc_end
public  :: ocean_bgc_restore_restart


private :: allocate_arrays
private :: locate
private :: set_array


character(len=32), parameter              :: package_name = 'ocean_bgc_restore'
character(len=48), parameter              :: mod_name = 'ocean_bgc_restore_mod'
character(len=48), parameter              :: diag_name = 'ocean_bgc_restore'
character(len=fm_string_len), parameter   :: default_restart_file = 'ocean_bgc_restore.res.nc'
character(len=fm_string_len), parameter   :: default_local_restart_file = 'ocean_bgc_restore_local.res.nc'
character(len=fm_string_len), parameter   :: default_ice_restart_file = 'ice_bgc_restore.res.nc'
character(len=fm_string_len), parameter   :: default_ocean_restart_file = 'ocean_bgc_restore_airsea_flux.res.nc'

! coefficients for O2 saturation
real, parameter :: a_0 = 2.00907
real, parameter :: a_1 = 3.22014
real, parameter :: a_2 = 4.05010
real, parameter :: a_3 = 4.94457
real, parameter :: a_4 = -2.56847e-01
real, parameter :: a_5 = 3.88767
real, parameter :: b_0 = -6.24523e-03
real, parameter :: b_1 = -7.37614e-03
real, parameter :: b_2 = -1.03410e-02
real, parameter :: b_3 = -8.17083e-03
real, parameter :: c_0 = -4.88682e-07

 

!  add_phosphate        : if true, then add sufficient PO4 to keep
!                         the predicted PO4 the same as if no depletion
!                         or changed uptake rate were in effect
type mask_region_type
  real, dimension(:,:,:), pointer       :: mask => NULL()
  real, dimension(:), pointer           :: elon => NULL()
  real, dimension(:), pointer           :: nlat => NULL()
  real, dimension(:), pointer           :: slat => NULL()
  real, dimension(:), pointer           :: wlon => NULL()
  logical                               :: coastal_only
  real                                  :: factor
  logical, dimension(:), pointer        :: t_mask => NULL()
end type mask_region_type

type biotic_type

  real                                  :: bio_tau
  real                                  :: bio_tau_don
  real                                  :: bio_tau_dop
  real                                  :: bio_tau_fix
  real                                  :: bio_tau_ldoc
  real                                  :: bio_tau_nh4
  real                                  :: bio_tau_nitrif_d
  real                                  :: bio_tau_nitrif_s
  real                                  :: c_2_n
  real                                  :: ca_remin_depth
  real                                  :: si_remin_depth
  real                                  :: compensation_depth
  real, _ALLOCATABLE, dimension(:,:)    :: comp_depth_frac  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: alpha  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: csurf  _NULL
  logical                               :: fe_ballast_assoc
  real, _ALLOCATABLE, dimension(:,:,:)  :: fpon  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: fpop  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: fcaco3  _NULL
  real                                  :: fdetL0
  real                                  :: fdetS0
  character(len=fm_string_len)          :: local_restart_file
  real, _ALLOCATABLE, dimension(:,:)    :: flux_caco3  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: flux_pon  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: flux_pop  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: flux_sio2  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: fracl  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: fsio2  _NULL
  real                                  :: gamma_det
  real                                  :: global_wrk_duration = 0.0
  real, _ALLOCATABLE, dimension(:,:)    :: htotal  _NULL
  integer                               :: id_alpha = -1
  integer                               :: id_csurf = -1
  integer                               :: id_fpon = -1
  integer                               :: id_fpop = -1
  integer                               :: id_fcaco3 = -1
  integer                               :: id_flux_caco3 = -1
  integer                               :: id_flux_pon = -1
  integer                               :: id_flux_pop = -1
  integer                               :: id_flux_sio2 = -1
  integer                               :: id_fracl = -1
  integer                               :: id_fsio2 = -1
  integer                               :: id_htotal = -1
  integer                               :: id_jcaco3 = -1
  integer                               :: id_jdenit = -1
  integer                               :: id_jdon = -1
  integer                               :: id_jdop = -1
  integer                               :: id_jfe_ads = -1
  integer                               :: id_jfe_des = -1
  integer                               :: id_jfe_graz = -1
  integer                               :: id_jfe_sink = -1
  integer                               :: id_jldoc = -1
  integer                               :: id_jnh4 = -1
  integer                               :: id_jnh4_graz = -1
  integer                               :: id_jno3 = -1
  integer                               :: id_jo2 = -1
  integer                               :: id_jpo4 = -1
  integer                               :: id_jpo4_graz = -1
  integer                               :: id_jpofe = -1
  integer                               :: id_jpon = -1
  integer                               :: id_jpop = -1
  integer                               :: id_jprod_alk = -1
  integer                               :: id_jprod_fed = -1
  integer                               :: id_jprod_n_fix = -1
  integer                               :: id_jprod_nh4 = -1
  integer                               :: id_jprod_no3 = -1
  integer                               :: id_jprod_n_norm = -1
  integer                               :: id_jprod_p_norm = -1
  integer                               :: id_jprod_p_fix = -1
  integer                               :: id_jprod_po4 = -1
  integer                               :: id_jprod_pofe = -1
  integer                               :: id_jprod_pon = -1
  integer                               :: id_jprod_pop = -1
  integer                               :: id_jprod_sio4 = -1
  integer                               :: id_jsio4 = -1
  integer                               :: id_pco2surf = -1
  integer                               :: id_sfc_flux_co2 = -1
  integer                               :: id_sfc_flux_o2 = -1
  integer                               :: id_sfc_flux_fed = -1
  integer                               :: ind_alk
  integer                               :: ind_dic
  integer                               :: ind_don
  integer                               :: ind_dop
  integer                               :: ind_fed
  integer                               :: ind_fep
  integer                               :: ind_ldoc
  integer                               :: ind_nh4
  integer                               :: ind_no3
  integer                               :: ind_o2
  integer                               :: ind_po4
  integer                               :: ind_sio4
  integer                               :: ind_co2_flux
  integer                               :: ind_o2_flux
  real, _ALLOCATABLE, dimension(:,:,:)  :: jcaco3  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jdenit  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jdon  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jdop  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jfe_ads  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jfe_des  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jfe_graz  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jfe_sink  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jldoc  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jnh4  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jnh4_graz  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jno3  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jo2  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jpo4  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jpo4_graz  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jpofe  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jpon  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jpop  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_alk  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_fed  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_n_fix  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_nh4  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_no3  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_n_norm  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_p_norm  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_p_fix  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_po4  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_pofe  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_pon  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_pop  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_sio4  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jsio4  _NULL
  real                                  :: kappa_eppley
  real                                  :: kappa_remin
  integer                               :: km_c
  real                                  :: kfe_bal
  real                                  :: kfe_des
  real                                  :: kfe_max_prime
  real                                  :: kfe_org
  real                                  :: martin_coeff
  real                                  :: mass_2_n
  real                                  :: n_2_p
  real                                  :: n_2_p_fix
  character(len=fm_field_name_len)      :: name
  real                                  :: o2_min
  real                                  :: o_2_c
  real                                  :: o_2_no3
  real                                  :: o_2_nh4
  real                                  :: o_2_nitrif
  real, _ALLOCATABLE, dimension(:,:)    :: pco2surf  _NULL
  real                                  :: phi_wet
  real                                  :: phi_dry
  real                                  :: phi_don
  real                                  :: phi_dop
  real                                  :: phi_ldoc
  real                                  :: Prodstar
  real, _ALLOCATABLE, dimension(:)      :: r_1plusintzscale_si  _NULL
  real, _ALLOCATABLE, dimension(:)      :: r_1plusintzscale_ca  _NULL
  real, _ALLOCATABLE, dimension(:)      :: r_1plusintzscale_n  _NULL
  real                                  :: r_bio_tau
  real                                  :: r_bio_tau_don
  real                                  :: r_bio_tau_dop
  real                                  :: r_bio_tau_fix
  real                                  :: r_bio_tau_ldoc
  real                                  :: r_bio_tau_nh4
  real                                  :: r_bio_tau_nitrif_d
  real                                  :: r_bio_tau_nitrif_s
  type(mask_region_type)                :: r_bio_tau_prod
  type(mask_region_type)                :: nut_depl
  type(mask_region_type)                :: norm_remin
  type(mask_region_type)                :: no_caco3
  real, _ALLOCATABLE, dimension(:)      :: r_intzscale_n  _NULL
  real                                  :: r_wsink
  logical                               :: remin_density
  logical                               :: remin_lability
  logical                               :: remin_ocmip2
  logical                               :: remin_protection
  logical                               :: remin_simple
  logical                               :: remin_temp
  logical                               :: remin_viscosity
  logical                               :: remin_zoop_resp
  real                                  :: rpcaco3
  real                                  :: rpsio2
  logical                               :: soft_tissue_pump
  real                                  :: stp_alkalinity
  real                                  :: stp_salinity
  real                                  :: stp_temperature
  integer                               :: id_sc_co2 = -1
  integer                               :: id_sc_o2 = -1
  real, _ALLOCATABLE, dimension(:,:)    :: sc_co2  _NULL
  real                                  :: sc_co2_0
  real                                  :: sc_co2_1
  real                                  :: sc_co2_2
  real                                  :: sc_co2_3
  real, _ALLOCATABLE, dimension(:,:)    :: sc_o2  _NULL
  real                                  :: sc_o2_0
  real                                  :: sc_o2_1
  real                                  :: sc_o2_2
  real                                  :: sc_o2_3
  real                                  :: wsink
  real, _ALLOCATABLE, dimension(:)      :: zforg  _NULL

end type biotic_type

logical, public :: do_ocean_bgc_restore

integer                                 :: indsal
integer                                 :: indtemp
integer                                 :: package_index
logical                                 :: module_initialized = .false.

character(len=128) :: version = '$Id: ocean_bgc_restore.F90,v 20.0 2013/12/14 00:09:28 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

! Input parameters:
!
!  htotal_in            = default value for htotal for an initial run
!  htotal_scale_lo      = scaling parameter to chose htotallo
!  htotal_scale_hi      = scaling parameter to chose htotalhi
real                                    :: htotal_in
real, allocatable, dimension(:,:)       :: htotal_scale_hi
real                                    :: htotal_scale_hi_in
real, allocatable, dimension(:,:)       :: htotal_scale_lo
real                                    :: htotal_scale_lo_in

! Calculated parameters (with possible initial input values):
!
!  global_wrk_duration  = total time during calculation of global
!                         variables
character*128                                   :: alk_star_file    
integer                                         :: alk_star_id
character*128                                   :: alk_star_name
real, allocatable, dimension(:,:,:)             :: alk_star_t
integer                                         :: dep_wet_id
character*128                                   :: dep_wet_file    
character*128                                   :: dep_wet_name
real, allocatable, dimension(:,:)               :: dep_wet_t
integer                                         :: dep_dry_id
character*128                                   :: dep_dry_file    
character*128                                   :: dep_dry_name
real, allocatable, dimension(:,:)               :: dep_dry_t
character*128                                   :: fed_star_file    
integer                                         :: fed_star_id
character*128                                   :: fed_star_name
real, allocatable, dimension(:,:,:)             :: fed_star_t
integer                                         :: id_o2_sat
integer                                         :: km_c_max
character*128                                   :: no3_star_file    
integer                                         :: no3_star_id
character*128                                   :: no3_star_name
real, allocatable, dimension(:,:,:)             :: no3_star_t
character*128                                   :: po4_star_file    
integer                                         :: po4_star_id
character*128                                   :: po4_star_name
real, allocatable, dimension(:,:,:)             :: po4_star_t
real, allocatable, dimension(:,:)               :: sc_no_term
character*128                                   :: sio4_star_file    
integer                                         :: sio4_star_id
character*128                                   :: sio4_star_name
real, allocatable, dimension(:,:,:)             :: sio4_star_t
type(biotic_type), allocatable, dimension(:)    :: biotic
integer                                         :: instances
real, allocatable, dimension(:,:)               :: o2_saturation
real, allocatable, dimension(:)                 :: tk
real, allocatable, dimension(:)                 :: ts
real, allocatable, dimension(:)                 :: ts2
real, allocatable, dimension(:)                 :: ts3
real, allocatable, dimension(:)                 :: ts4
real, allocatable, dimension(:)                 :: ts5
real, allocatable, dimension(:)                 :: tt

! for restart
integer                                  :: num_restart = 0
type(restart_file_type), allocatable     :: restart(:)

contains

!#######################################################################
! <SUBROUTINE NAME="allocate_arrays">
!
! <DESCRIPTION>
!     Dynamically allocate arrays
! </DESCRIPTION>
!

subroutine allocate_arrays(isc, iec, jsc, jec, nk, isd, ied, jsd, jed)

integer, intent(in)     :: isc
integer, intent(in)     :: iec
integer, intent(in)     :: jsc
integer, intent(in)     :: jec
integer, intent(in)     :: isd
integer, intent(in)     :: ied
integer, intent(in)     :: jsd
integer, intent(in)     :: jed
integer, intent(in)     :: nk

integer :: i, j, k, l, m, n

allocate( dep_wet_t(isd:ied,jsd:jed) )
allocate( dep_dry_t(isd:ied,jsd:jed) )
allocate( sc_no_term(isc:iec,jsc:jec) )
allocate( htotal_scale_lo(isc:iec,jsc:jec) )
allocate( htotal_scale_hi(isc:iec,jsc:jec) )
allocate( o2_saturation(isc:iec,jsc:jec) )
allocate( tt(isc:iec) )
allocate( tk(isc:iec) )
allocate( ts(isc:iec) )
allocate( ts2(isc:iec) )
allocate( ts3(isc:iec) )
allocate( ts4(isc:iec) )
allocate( ts5(isc:iec) )
!allocate( po4_star_t(isd:ied,jsd:jed,km_c_max) )
!       this should be dimensioned as above, but the time_interp routine
!       requires that the array dimensions match the datasets dimensions
allocate( alk_star_t(isd:ied,jsd:jed,nk) )
allocate( fed_star_t(isd:ied,jsd:jed,nk) )
allocate( no3_star_t(isd:ied,jsd:jed,nk) )
allocate( po4_star_t(isd:ied,jsd:jed,nk) )
allocate( sio4_star_t(isd:ied,jsd:jed,nk) )

! initialize some arrays
dep_wet_t(:,:) = 0.0
dep_dry_t(:,:) = 0.0
sc_no_term(:,:) = 0.0
htotal_scale_lo(:,:) = 0.0
htotal_scale_hi(:,:) = 0.0
o2_saturation(:,:) = 0.0
tt(:) = 0.0
tk(:) = 0.0
ts(:) = 0.0
ts2(:) = 0.0
ts3(:) = 0.0
ts4(:) = 0.0
ts5(:) = 0.0
alk_star_t(:,:,:) = 0.0
fed_star_t(:,:,:) = 0.0
no3_star_t(:,:,:) = 0.0
po4_star_t(:,:,:) = 0.0
sio4_star_t(:,:,:) = 0.0

! allocate biotic array elements
do n = 1, instances

  allocate( biotic(n)%sc_co2(isc:iec,jsc:jec) )
  allocate( biotic(n)%sc_o2(isc:iec,jsc:jec) )
  allocate( biotic(n)%htotal(isc:iec,jsc:jec) )
  allocate( biotic(n)%csurf(isc:iec,jsc:jec) )
  allocate( biotic(n)%alpha(isc:iec,jsc:jec) )
  allocate( biotic(n)%comp_depth_frac(isc:iec,jsc:jec) )
  allocate( biotic(n)%pco2surf(isc:iec,jsc:jec) )
  allocate( biotic(n)%r_1plusintzscale_si(nk) )
  allocate( biotic(n)%r_1plusintzscale_ca(nk) )
  allocate( biotic(n)%r_1plusintzscale_n(nk) )
  allocate( biotic(n)%r_intzscale_n(nk) )
  allocate( biotic(n)%jfe_ads(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jfe_des(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jfe_graz(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jfe_sink(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jnh4(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jnh4_graz(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jno3(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jpo4(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jpo4_graz(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jpofe(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jpon(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jpop(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jprod_alk(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jprod_fed(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jprod_n_fix(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jprod_nh4(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jprod_no3(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jprod_n_norm(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jprod_p_norm(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jprod_p_fix(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jprod_po4(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jprod_pofe(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jprod_pon(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jprod_pop(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jprod_sio4(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jsio4(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jdenit(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jdon(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jdop(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jldoc(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jo2(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jcaco3(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%fpon(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%fpop(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%fracl(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%fsio2(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%fcaco3(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%flux_pon(isc:iec,jsc:jec) )
  allocate( biotic(n)%flux_pop(isc:iec,jsc:jec) )
  allocate( biotic(n)%flux_sio2(isc:iec,jsc:jec) )
  allocate( biotic(n)%flux_caco3(isc:iec,jsc:jec) )
  allocate( biotic(n)%nut_depl%mask(isc:iec,jsc:jec,12) )
  allocate( biotic(n)%no_caco3%mask(isc:iec,jsc:jec,12) )
  allocate( biotic(n)%norm_remin%mask(isc:iec,jsc:jec,12) )
  allocate( biotic(n)%r_bio_tau_prod%mask(isc:iec,jsc:jec,12) )
  allocate( biotic(n)%zforg(nk) )

enddo

! initialize bgc_restore array elements
do n = 1, instances

  do j = jsc, jec
    do i = isc, iec
      biotic(n)%sc_co2(i,j)           = 0.0
      biotic(n)%sc_o2(i,j)            = 0.0
      biotic(n)%alpha(i,j)            = 0.0
      biotic(n)%comp_depth_frac(i,j)  = 0.0
      biotic(n)%pco2surf(i,j)         = 0.0
      biotic(n)%csurf(i,j)            = 0.0
      biotic(n)%htotal(i,j)           = 0.0
      do k = 1, nk
        biotic(n)%jprod_alk(i,j,k)    = 0.0
        biotic(n)%jprod_fed(i,j,k)    = 0.0
        biotic(n)%jprod_n_fix(i,j,k)  = 0.0
        biotic(n)%jprod_nh4(i,j,k)    = 0.0
        biotic(n)%jprod_no3(i,j,k)    = 0.0
        biotic(n)%jprod_n_norm(i,j,k) = 0.0
        biotic(n)%jprod_p_norm(i,j,k) = 0.0
        biotic(n)%jprod_p_fix(i,j,k)  = 0.0
        biotic(n)%jprod_po4(i,j,k)    = 0.0
        biotic(n)%jprod_pofe(i,j,k)   = 0.0
        biotic(n)%jprod_pon(i,j,k)    = 0.0
        biotic(n)%jprod_pop(i,j,k)    = 0.0
        biotic(n)%jprod_sio4(i,j,k)   = 0.0
        biotic(n)%jfe_ads(i,j,k)      = 0.0
        biotic(n)%jfe_des(i,j,k)      = 0.0
        biotic(n)%jfe_graz(i,j,k)     = 0.0
        biotic(n)%jfe_sink(i,j,k)     = 0.0
        biotic(n)%jpo4(i,j,k)         = 0.0
        biotic(n)%jpofe(i,j,k)        = 0.0
        biotic(n)%jpon(i,j,k)         = 0.0
        biotic(n)%jpop(i,j,k)         = 0.0
        biotic(n)%jsio4(i,j,k)        = 0.0
        biotic(n)%jdenit(i,j,k)       = 0.0
        biotic(n)%jdon(i,j,k)         = 0.0
        biotic(n)%jdop(i,j,k)         = 0.0
        biotic(n)%jldoc(i,j,k)        = 0.0
        biotic(n)%jo2(i,j,k)          = 0.0
        biotic(n)%jcaco3(i,j,k)       = 0.0
        biotic(n)%fpon(i,j,k)         = 0.0
        biotic(n)%fpop(i,j,k)         = 0.0
        biotic(n)%fracl(i,j,k)        = 0.0
        biotic(n)%fsio2(i,j,k)        = 0.0
        biotic(n)%fcaco3(i,j,k)       = 0.0
      enddo
    enddo
  enddo

enddo

return
end subroutine  allocate_arrays
! </SUBROUTINE> NAME="allocate_arrays"


!#######################################################################
! <SUBROUTINE NAME="locate">
!
! <DESCRIPTION>
!     After Numerical recipes:
!
!     Given an array XX of length N, and a given value of X, returns a
!     value of J such that X is between XX(J) and XX(J+1).  XX must be
!     monotonic, either increasing or decreasing. J=0 or J=N is
!     returned to indicate that X is out of range.      

!       New features:
!
!       If "period" is specified, then the array, xx, is considered
!       to be periodic with a period of "period". If "x_in" is out
!       of range, then add or subtract "period" once to attempt to 
!       make "x_in" be in range.
!
!       If "nearest" is specified, and true, then return "j" such
!       that it is the element of "xx" which is nearest to the value
!       of "x_in" (where "x_in" may have been modified by the value
!       "period", above). With this option, "j" will be in
!       the range 1 <= j <= n.
! </DESCRIPTION>
!

subroutine locate(xx , n, x_in, j, period, nearest)

integer, intent(in)             :: n
real, intent(in)                :: x_in
real, dimension(n), intent(in)  :: xx
integer, intent(out)            :: j
real, optional, intent(in)      :: period
logical, optional, intent(in)   :: nearest

integer :: jl, ju, jm
real    :: x, xt
logical :: increasing

increasing = xx(1) .lt. xx(n)

if (present(period)) then
  if (increasing) then
    ! increasing array
    if (x_in .lt. xx(1)) then
      ! original value less than start, therefore add period
      xt = x_in + period
      if (xt .gt. xx(n)) then
        ! new value greater than end
        if (abs(x_in - xx(1)) .gt. abs(xt - xx(n))) then
          ! new value closer to end than original value to start
          ! use new value
          x = xt
        else
          ! original value closer to start than new value to end
          ! use original value
          x = x_in
        endif
      else
        ! new value in range
        ! use new value
        x = xt
      endif
    elseif (x_in .gt. xx(n)) then
      ! original value greater than end, therefore subtract period
      xt = x_in - period
      if (xt .lt. xx(1)) then
        ! new value less than start
        if (abs(xt - xx(1)) .lt. abs(x_in - xx(n))) then
          ! new value closer to start than original value to end
          ! use new value
          x = xt
        else
          ! original value closer to end than new value to start
          ! use original value
          x = x_in
        endif
      else
        ! new value in range
        ! use new value
        x = xt
      endif
    else
      ! original value in range
      ! use original value
      x = x_in
    endif
  else
    ! decreasing array
    if (x_in .gt. xx(1)) then
      ! original value greater than start, therefore subtract period
      xt = x_in - period
      if (xt .lt. xx(n)) then
        ! new value less than end
        if (abs(x_in - xx(1)) .gt. abs(xt - xx(n))) then
          ! new value closer to end than original value to start
          ! use new value
          x = xt
        else
          ! original value closer to start than new value to end
          ! use original value
          x = x_in
        endif
      else
        ! new value in range
        ! use new value
        x = xt
      endif
    elseif (x_in .lt. xx(n)) then
      ! original value less than end, therefore add period
      xt = x_in + period
      if (xt .gt. xx(1)) then
        ! new value greater than start
        if (abs(xt - xx(1)) .lt. abs(x_in - xx(n))) then
          ! new value closer to start than original value to end
          ! use new value
          x = xt
        else
          ! original value closer to end than new value to start
          ! use original value
          x = x_in
        endif
      else
        ! new value in range
        ! use new value
        x = xt
      endif
    else
      ! original value in range
      ! use original value
      x = x_in
    endif
  endif
else
   ! no period specified
   ! use original value
  x = x_in
endif

jl = 0
ju = n+1
10 continue
if (ju - jl .gt. 1) then
  jm = (ju + jl) / 2
  if (increasing .eqv. (x .gt. xx(jm))) then
    jl = jm
  else
    ju = jm
  endif
  go to 10
endif
j = jl

if (present(nearest)) then
  if (nearest) then
    if (j .eq. 0) then
      j = 1
    elseif (j .lt. n) then
      if (abs(x - xx(j)) .gt. abs(x - xx(j+1))) then
        j = j + 1
      endif
    endif
  endif
endif

return
end subroutine  locate
! </SUBROUTINE> NAME="locate"


!#######################################################################
! <SUBROUTINE NAME="ocean_bgc_restore_bbc">
!
! <DESCRIPTION>
!     calculate the surface boundary conditions
! </DESCRIPTION>

subroutine ocean_bgc_restore_bbc(isc, iec, jsc, jec, isd, ied, jsd, jed, T_prog, grid_kmt)

integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
type(ocean_prog_tracer_type), intent(inout), dimension(:)       :: T_prog
integer, dimension(isd:,jsd:), intent(in)                       :: grid_kmt

integer  :: i, j, n, kz

!   set the bottom flux of the column for phosphate to reflect a
!   regenerative flux from the sediments where the compensation
!   depth is greater than the bottom depth
do n = 1, instances
  if(biotic(n)%remin_ocmip2) then
    do j = jsc, jec
      do i = isc, iec
        kz = grid_kmt(i,j)
        if (kz .le. biotic(n)%km_c .and. kz .gt. 0) then
          t_prog(biotic(n)%ind_po4)%btf(i,j) =                    &
             t_prog(biotic(n)%ind_po4)%btf(i,j) -               &
             biotic(n)%flux_pop(i,j)
          t_prog(biotic(n)%ind_nh4)%btf(i,j) =                    &
             t_prog(biotic(n)%ind_nh4)%btf(i,j) -               &
             biotic(n)%flux_pon(i,j)
          t_prog(biotic(n)%ind_sio4)%btf(i,j) =                   &
             t_prog(biotic(n)%ind_sio4)%btf(i,j) -              &
             biotic(n)%flux_sio2(i,j)
          t_prog(biotic(n)%ind_o2)%btf(i,j)  =                    &
             t_prog(biotic(n)%ind_o2)%btf(i,j) +                &
             biotic(n)%o_2_nh4 * biotic(n)%flux_pon(i,j)
          t_prog(biotic(n)%ind_dic)%btf(i,j) =                    &
             t_prog(biotic(n)%ind_dic)%btf(i,j) +               &
             biotic(n)%flux_caco3(i,j) - biotic(n)%c_2_n *      &
             biotic(n)%flux_pon(i,j)
          t_prog(biotic(n)%ind_alk)%btf(i,j) =                    &
             t_prog(biotic(n)%ind_alk)%btf(i,j) +               &
             biotic(n)%flux_pon(i,j) - 2.0 * biotic(n)%flux_caco3(i,j)
        endif
      enddo
    enddo
  endif
enddo

return

end subroutine  ocean_bgc_restore_bbc
! </SUBROUTINE> NAME="ocean_bgc_restore_bbc"


!#######################################################################
! <SUBROUTINE NAME="ocean_bgc_restore_end">
!
! <DESCRIPTION>
!     Clean up various BIOTIC quantities for this run.
! </DESCRIPTION>

subroutine ocean_bgc_restore_end(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,    &
     T_prog, T_diag, grid_dat, grid_tmask, mpp_domain2d, rho_dzt, taup1)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
type(ocean_prog_tracer_type), intent(in), dimension(:)  :: T_prog
type(ocean_diag_tracer_type), intent(in), dimension(:)  :: T_diag
integer, intent(in)                                     :: taup1
real, dimension(isd:,jsd:), intent(in)                  :: grid_dat
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask
type(domain2d), intent(in)                              :: mpp_domain2d
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho_dzt

character(len=64), parameter    :: sub_name = 'ocean_bgc_restore_end'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer                                 :: i, j, k, n
integer                                 :: lun
character(len=fm_field_name_len+1)      :: suffix
real                                    :: total_alkalinity
real                                    :: total_ammonia
real                                    :: total_dic
real                                    :: total_don
real                                    :: total_dop
real                                    :: total_fediss
real                                    :: total_fepart
real                                    :: total_ldoc
real                                    :: total_o2
real                                    :: total_nitrate
real                                    :: total_phosphate
real                                    :: total_silicate

  integer :: stdoutunit 
  stdoutunit=stdout() 

!       integrate the total concentrations of some tracers
!       for the end of the run

!       Use taup1 time index for the start of a run, and taup1 time
!       index for the end of a run so that we are integrating the
!       same time level and should therefore get identical results
do n = 1, instances
  total_alkalinity = 0.0
  total_ammonia = 0.0
  total_dic = 0.0
  total_don = 0.0
  total_dop = 0.0
  total_fediss = 0.0
  total_fepart = 0.0
  total_ldoc = 0.0
  total_nitrate = 0.0
  total_o2 = 0.0
  total_phosphate = 0.0
  total_silicate = 0.0
  do k = 1,nk
    do j = jsc, jec
      do i = isc, iec
        total_nitrate = total_nitrate +                         &
             t_prog(biotic(n)%ind_no3)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_ammonia = total_ammonia +                         &
             t_prog(biotic(n)%ind_nh4)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_phosphate = total_phosphate +                     &
             t_prog(biotic(n)%ind_po4)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_fediss = total_fediss +                           &
             t_prog(biotic(n)%ind_fed)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_fepart = total_fepart +                           &
             t_diag(biotic(n)%ind_fep)%field(i,j,k) *           &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_silicate = total_silicate +                       &
             t_prog(biotic(n)%ind_sio4)%field(i,j,k,taup1) *    &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_don = total_don +                                 &
             t_prog(biotic(n)%ind_don)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_dop = total_dop +                                 &
             t_prog(biotic(n)%ind_dop)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_ldoc = total_ldoc +                               &
             t_prog(biotic(n)%ind_ldoc)%field(i,j,k,taup1) *    &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_o2 = total_o2 +                                   &
             t_prog(biotic(n)%ind_o2)%field(i,j,k,taup1) *      &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_dic = total_dic +                                 &
             t_prog(biotic(n)%ind_dic)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_alkalinity = total_alkalinity +                   &
             t_prog(biotic(n)%ind_alk)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo

  call mpp_sum(total_nitrate)
  call mpp_sum(total_ammonia)
  call mpp_sum(total_phosphate)
  call mpp_sum(total_fediss)
  call mpp_sum(total_fepart)
  call mpp_sum(total_silicate)
  call mpp_sum(total_don)
  call mpp_sum(total_dop)
  call mpp_sum(total_ldoc)
  call mpp_sum(total_o2)
  call mpp_sum(total_dic)
  call mpp_sum(total_alkalinity)

  write (stdoutunit,*) '  Instance ', trim(biotic(n)%name)
  write (stdoutunit,                                              &
         '(/'' Total nitrate  = '',es19.12,'' Gmol-N'')')       &
              total_nitrate * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total ammonia  = '',es19.12,'' Gmol-N'')')       &
              total_ammonia * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total phosphate  = '',es19.12,'' Gmol-P'')')     &
              total_phosphate * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total fediss  = '',es19.12,'' Gmol-Fe'')')       &
              total_fediss * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total fepart  = '',es19.12,'' Gmol-Fe'')')       &
              total_fepart * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total silicate  = '',es19.12,'' Gmol-Si'')')     &
              total_silicate * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total DON  = '',es19.12,'' Gmol-C'')')           &
              total_DON * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total DOP  = '',es19.12,'' Gmol-P'')')           &
              total_DOP * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total LDOC  = '',es19.12,'' Gmol-C'')')          &
              total_LDOC * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total O2  = '',es19.12,'' Gmol-O'')')            &
              total_o2 * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total DIC  = '',es19.12,'' Gmol-C'')')           &
              total_dic * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total alkalinity  = '',es19.12,'' Geq'')')       &
              total_alkalinity * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total nitrogen  = '',es19.12,'' Gmol-N'')')      &
              (total_nitrate + total_don) * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total phosphorus  = '',es19.12,'' Gmol-P'')')    &
              (total_phosphate + total_dop) * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total real O2  = '',es19.12,'' Gmol-O'')')       &
              (total_o2 + biotic(n)%o_2_no3 * total_nitrate) * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total Carbon  = '',es19.12,'' Gmol-C'')')        &
              (total_dic + biotic(n)%c_2_n * total_don + total_ldoc) * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total real alkalinity  = '',es19.12,'' Geq'')')  &
              (total_alkalinity + total_nitrate) * 1.0e-09
enddo

! save out additional information for a restart
write(stdoutunit,*)

call ocean_bgc_restore_restart
do n = 1, instances

  write(stdoutunit,*) trim(note_header),                          &
       'Writing additional restart information for instance ',  &
       trim(biotic(n)%name)

  write (stdoutunit,*) trim(note_header),                         &
       'Done writing additional restart information for instance ',&
       trim(biotic(n)%name)

enddo

return
end subroutine  ocean_bgc_restore_end
! </SUBROUTINE> NAME="ocean_bgc_restore_end"

!#######################################################################
! <SUBROUTINE NAME="ocean_bgc_restore_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocean_bgc_restore_restart(time_stamp)
  character(len=*),  intent(in), optional :: time_stamp
  integer :: n

  do n=1, num_restart
     call save_restart(restart(n), time_stamp)
  end do

end subroutine ocean_bgc_restore_restart
! </SUBROUTINE> NAME="ocean_bgc_restore_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_bgc_restore_sbc">
!
! <DESCRIPTION>
!     Calculate the surface boundary conditions
! </DESCRIPTION>
subroutine ocean_bgc_restore_sbc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,    &
     isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                                        &
     T_prog, tau, Time, Grid, ice_ocean_boundary_fluxes)

integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: nk
integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
integer, intent(in)                                             :: isc_bnd
integer, intent(in)                                             :: iec_bnd
integer, intent(in)                                             :: jsc_bnd
integer, intent(in)                                             :: jec_bnd
type(ocean_prog_tracer_type), intent(inout), dimension(:)       :: T_prog
integer, intent(in)                                             :: tau
type(ocean_time_type), intent(in)                               :: Time
type(ocean_grid_type), intent(in)                               :: Grid
type(coupler_2d_bc_type), intent(in)                            :: ice_ocean_boundary_fluxes

integer :: i, j, n
integer :: i_bnd_off
integer :: j_bnd_off
logical :: used

!     calculate interpolated iron deposition
call time_interp_external(dep_dry_id, Time%model_time, dep_dry_t)

! use the surface fluxes from the coupler
! stf is in mol/m^2/s, flux from coupler is positive upwards
i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

do n = 1, instances
  do j = jsc, jec
    do i = isc, iec
      t_prog(biotic(n)%ind_dic)%stf(i,j) =                      &
            -ice_ocean_boundary_fluxes%bc(biotic(n)%ind_co2_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
      t_prog(biotic(n)%ind_o2)%stf(i,j) =                       &
            -ice_ocean_boundary_fluxes%bc(biotic(n)%ind_o2_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
    enddo
  enddo

!     surface iron deposition fluxes from Ginoux et al (JGR, Sources 
!     and distributions of dust aerosols simulated with the GOCART 
!     model, 2001) and converted by Gregg et al (GRL, Ocean primary
!     producion and climate: Global decadal changes, in press) assuming a 2%
!     solubility of Fe in dust.
!          For additional source from extraterrestrial dust after Johnson
!     (GBC, Iron supply and demand in the upper ocean: Is extraterrestrial
!     dust a significant source of bioavailable iron?), add a constant flux
!     of 9.51e-15.
  do j = jsc, jec
    do i = isc, iec
      t_prog(biotic(n)%ind_fed)%stf(i,j) =  dep_dry_t(i,j)
    enddo
  enddo

enddo

! Save variables for diagnostics
do n = 1, instances
   call diagnose_2d(Time, Grid, biotic(n)%id_sfc_flux_co2, t_prog(biotic(n)%ind_dic)%stf(:,:))
   call diagnose_2d(Time, Grid, biotic(n)%id_sfc_flux_o2, t_prog(biotic(n)%ind_o2)%stf(:,:))
   call diagnose_2d(Time, Grid, biotic(n)%id_sfc_flux_fed, t_prog(biotic(n)%ind_fed)%stf(:,:))
enddo

return

end subroutine  ocean_bgc_restore_sbc
! </SUBROUTINE> NAME="ocean_bgc_restore_sbc"


!#######################################################################
! <SUBROUTINE NAME="ocean_bgc_restore_flux_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the ocean-atmosphere gas fluxes
! </DESCRIPTION>

subroutine ocean_bgc_restore_flux_init

use atmos_ocean_fluxes_mod, only: aof_set_coupler_flux

character(len=64), parameter    :: sub_name = 'ocean_bgc_restore_flux_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=256)                                      :: caller_str

  integer :: stdoutunit 
  stdoutunit=stdout() 

  ! First, perform some initialization if this module has not been
  ! initialized because the normal initialization routine will
  ! not have been called as part of the normal ocean model
  ! initialization if this is an Atmosphere pe of a coupled
  ! model running in concurrent mode

if (.not. module_initialized) then 

   ! Initialize the package
  package_index = otpm_set_tracer_package(package_name,            &
       restart_file = default_restart_file,                             &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')

  ! Check whether to use this package
  path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
  instances = fm_get_length(path_to_names)
  if (instances .lt. 0) then
    call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
  endif

  write (stdoutunit,*)
  if (instances .eq. 0) then
    write (stdoutunit,*) trim(note_header), ' No instances'
    do_ocean_bgc_restore = .false.
  else
    if (instances .eq. 1) then
      write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
    else
      write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
    endif
    do_ocean_bgc_restore = .true.
  endif

  module_initialized = .true.

endif

! Return if we don't want to use this package
if (.not. do_ocean_bgc_restore) then
  return
endif

if (.not. allocated(biotic)) then

  ! allocate storage for biotic array
  allocate ( biotic(instances) )

  ! loop over the names, saving them into the biotic array
  do n = 1, instances

    if (fm_get_value(path_to_names, name, index = n)) then
      biotic(n)%name = name
    else
      write (name,*) n
      call mpp_error(FATAL, trim(error_header) //        &
           'Bad field name for index ' // trim(name))
    endif

  enddo

endif

! Set up the ocean-atmosphere gas flux fields
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

  name = biotic(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
  else
    suffix = '_' // name
  endif

  ! Coupler fluxes
  biotic(n)%ind_co2_flux = aof_set_coupler_flux('co2_flux' // suffix,                           &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',                               &
       mol_wt = WTMCO2, param = (/ 9.36e-07, 9.7561e-06 /),                                                      &
       ice_restart_file = default_ice_restart_file,                                             &
       ocean_restart_file = default_ocean_restart_file,                                         &
       caller = caller_str)

  biotic(n)%ind_o2_flux = aof_set_coupler_flux('o2_flux' // suffix,                             &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',                               &
       mol_wt = WTMO2, param = (/ 9.36e-07, 9.7561e-06 /),                                                      &
       ice_restart_file = default_ice_restart_file,                                             &
       ocean_restart_file = default_ocean_restart_file,                                         &
       caller = caller_str)
enddo

return

end subroutine  ocean_bgc_restore_flux_init
!</SUBROUTINE> NAME="ocean_bgc_restore_flux_init"

!#######################################################################
! <SUBROUTINE NAME="ocean_bgc_restore_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the tracer packages
!
!       Save pointers to various "types", such as Grid and Domains.
! </DESCRIPTION>

subroutine ocean_bgc_restore_init

character(len=64), parameter    :: sub_name = 'ocean_bgc_restore_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

real, parameter :: rho_avg = 1024.5
real, parameter :: sperd = 24.0 * 3600.0

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix

character(len=fm_field_name_len+3)                      :: long_suffix
logical, dimension(12)                                  :: t_mask
character(len=256)                                      :: caller_str
character(len=fm_string_len), pointer, dimension(:)     :: good_list

  integer :: stdoutunit 
  stdoutunit=stdout() 

! Initialize the restoring package
package_index = otpm_set_tracer_package(package_name,            &
     restart_file = default_restart_file,                             &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')

! Check whether to use this package
path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
instances = fm_get_length(path_to_names)
if (instances .lt. 0) then
  call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
endif

write (stdoutunit,*)
if (instances .eq. 0) then
  write (stdoutunit,*) trim(note_header), ' No instances'
  do_ocean_bgc_restore = .false.
else
  if (instances .eq. 1) then
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
  else
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
  endif
  do_ocean_bgc_restore = .true.
endif

module_initialized = .true.

! Return if we don't want to use this package,
! after changing the list back
if (.not. do_ocean_bgc_restore) then
  return
endif

! allocate storage for biotic array
allocate ( biotic(instances) )

! loop over the names, saving them into the biotic array
do n = 1, instances
  if (fm_get_value(path_to_names, name, index = n)) then
    biotic(n)%name = name
  else
    write (name,*) n
    call mpp_error(FATAL, trim(error_header) //        &
         'Bad field name for index ' // trim(name))
  endif
enddo


! Set up the field input
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

  name = biotic(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // name
    long_suffix = ' (' // trim(name) // ')'
  endif

  ! NO3
  biotic(n)%ind_no3 = otpm_set_prog_tracer('no3' // suffix, package_name,   &
       longname = 'Nitrate' // trim(long_suffix),                      &
       units = 'mol/kg', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

  ! NH4
  biotic(n)%ind_nh4 = otpm_set_prog_tracer('nh4' // suffix, package_name,   &
       longname = 'Ammonia' // '(' // trim(name) // ')',               &
       units = 'mol/kg', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

  ! PO4
  biotic(n)%ind_po4 = otpm_set_prog_tracer('po4' // suffix, package_name,   &
       longname = 'Phosphate' // trim(long_suffix),             &
       units = 'mol/kg', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

  ! Dissolved Fe (assumed to be all available to phytoplankton)
  biotic(n)%ind_fed = otpm_set_prog_tracer('fed' // suffix, package_name,   &
       longname = 'Dissolved Iron' // '(' // trim(name) // ')',        &
       units = 'mol/kg', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

  ! Fep (Sinking detrital/particulate iron)
  biotic(n)%ind_fep = otpm_set_diag_tracer('fep' // suffix, package_name,   &
       longname = 'Particulate Iron' // '(' // trim(name) // ')',      &
       restart_file = default_restart_file, units = 'mol/kg')

  ! SiO4
  biotic(n)%ind_sio4 = otpm_set_prog_tracer('sio4' // suffix, package_name, &
       longname = 'Silicate' // '(' // trim(name) // ')',              &
       units = 'mol/kg', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

  ! DON
  biotic(n)%ind_don = otpm_set_prog_tracer('don' // suffix, package_name,   &
       longname = 'DON' // '(' // trim(name) // ')',                   &
       units = 'mol/kg', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

  ! DOP
  biotic(n)%ind_dop = otpm_set_prog_tracer('dop' // suffix, package_name,   &
       longname = 'DOP' // '(' // trim(name) // ')',                   &
       units = 'mol/kg', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

  ! LDOC
  biotic(n)%ind_ldoc = otpm_set_prog_tracer('ldoc' // suffix, package_name, &
       longname = 'labile DOC' // '(' // trim(name) // ')',            &
       units = 'mol/kg', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

  ! DIC
  biotic(n)%ind_dic = otpm_set_prog_tracer('dic' // suffix, package_name,   &
       longname = 'DIC' // '(' // trim(name) // ')',                   &
       units = 'mol/kg', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

  ! O2
  biotic(n)%ind_o2 = otpm_set_prog_tracer('o2' // suffix, package_name,     &
       longname = 'Oxygen' // '(' // trim(name) // ')',                &
       units = 'mol/kg', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

  ! ALK (Total carbonate alkalinity)
  biotic(n)%ind_alk = otpm_set_prog_tracer('alk' // suffix, package_name,   &
       longname = 'Alkalinity' // '(' // trim(name) // ')',            &
       units = 'mol/kg', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

enddo

! Process the namelists

! Add the package name to the list of good namelists, to be used
! later for a consistency check

if (fm_new_value('/ocean_mod/GOOD/good_namelists', package_name, append = .true.) .le. 0) then
  call mpp_error(FATAL, trim(error_header) //                           &
       ' Could not add ' // trim(package_name) // ' to "good_namelists" list')
endif

! Set up the *global* namelist
call fm_util_start_namelist(package_name, '*global*', caller = caller_str, no_overwrite = .true., &
     check = .true.)

call fm_util_set_value('dep_dry_file', 'INPUT/fe_dep_bc.nc')
call fm_util_set_value('dep_dry_name', 'fe_dep')
call fm_util_set_value('dep_wet_file', 'INPUT/fe_dep_bc.nc')
call fm_util_set_value('dep_wet_name', 'fe_dep')
call fm_util_set_value('no3_star_file', 'INPUT/no3_star.nc')
call fm_util_set_value('no3_star_name', 'no3_star')
call fm_util_set_value('po4_star_file', 'INPUT/po4_star.nc')
call fm_util_set_value('po4_star_name', 'po4_star')
call fm_util_set_value('sio4_star_file', 'INPUT/sio4_star.nc')
call fm_util_set_value('sio4_star_name', 'sio4_star')
call fm_util_set_value('alk_star_file', 'INPUT/alk_star.nc')
call fm_util_set_value('alk_star_name', 'alk_star')
call fm_util_set_value('fed_star_file', 'INPUT/fed_star.nc')
call fm_util_set_value('fed_star_name', 'fed_star')
call fm_util_set_value('htotal_scale_lo_in', 0.01 )    ! scale
call fm_util_set_value('htotal_scale_hi_in', 100.0)    ! scale
call fm_util_set_value('htotal_in', 1.0e-08)

call fm_util_end_namelist(package_name, '*global*', caller = caller_str, check = .true.)

! Set up the instance namelists

t_mask(:) = .true.

do n = 1, instances

  ! create the instance namelist
  call fm_util_start_namelist(package_name, biotic(n)%name, caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('compensation_depth', 75.0)                  ! m
  call fm_util_set_value('martin_coeff', 0.9)
  call fm_util_set_value('ca_remin_depth', 3500.0)
  call fm_util_set_value('si_remin_depth', 1000.0)
  call fm_util_set_value('soft_tissue_pump', .false.)
  call fm_util_set_value('stp_temperature', 10.0)
  call fm_util_set_value('stp_salinity', 34.7)
  ! alkalinity is in ueq/kg, converted to eq/m^3
  call fm_util_set_value('stp_alkalinity', 2370.0 * 1024.5 * 1.0e-06)
  call fm_util_set_value('local_restart_file', default_local_restart_file)
  call fm_util_set_value('fe_ballast_assoc', .false.)
  call fm_util_set_value('phi_dry', 0.03)
  call fm_util_set_value('phi_wet', 0.03)
  call fm_util_set_value('kfe_org', 0.005/sperd)
  call fm_util_set_value('kfe_bal', 0.005/sperd)
  call fm_util_set_value('kfe_des', 0.0/sperd)
  call fm_util_set_value('kfe_max_prime', 1.0/sperd)
  call fm_util_set_value('mass_2_n', 117.0/16.0*12.0*1.87)
  call fm_util_set_value('n_2_p', 16.0)
  call fm_util_set_value('n_2_p_fix', 40.0)
  call fm_util_set_value('c_2_n', 117.0/16.0)
  call fm_util_set_value('o_2_c', 170.0/16.0)
  call fm_util_set_value('o_2_no3', 255.0/16.0)
  call fm_util_set_value('o_2_nh4', 207.0/16.0)
  call fm_util_set_value('o_2_nitrif', 3.0)
  call fm_util_set_value('o2_min', 4.0 * rho_avg * 1.0e-06)
  call fm_util_set_value('bio_tau', 30.0 * sperd)
  call fm_util_set_value('bio_tau_don', 30.0*365.0*sperd)
  call fm_util_set_value('bio_tau_dop', 30.0*365.0*sperd)
  call fm_util_set_value('bio_tau_fix', 90.0*sperd)
  call fm_util_set_value('bio_tau_ldoc', 0.5*365.0*sperd)
  call fm_util_set_value('bio_tau_nh4', 3.0*sperd)
  call fm_util_set_value('bio_tau_nitrif_d', 10.0*sperd)
  call fm_util_set_value('bio_tau_nitrif_s', 1e20*sperd)
  call fm_util_set_value('kappa_eppley', 0.063)
  call fm_util_set_value('kappa_remin', -0.032)
  call fm_util_set_value('Prodstar', 0.37/1000*16/117/sperd)
  call fm_util_set_value('fdets0', 0.14)
  call fm_util_set_value('fdetl0', 0.74)
  call fm_util_set_value('phi_don', 0.04)
  call fm_util_set_value('phi_dop', 0.04)
  call fm_util_set_value('phi_ldoc', 0.04)
  call fm_util_set_value('gamma_det', 0.0116/sperd)
  call fm_util_set_value('remin_density', .false.)
  call fm_util_set_value('remin_lability', .false.)
  call fm_util_set_value('remin_ocmip2', .false.)
  call fm_util_set_value('remin_protection', .true.)
  call fm_util_set_value('remin_simple', .false.)
  call fm_util_set_value('remin_temp', .false.)
  call fm_util_set_value('remin_viscosity', .false.)
  call fm_util_set_value('remin_zoop_resp', .false.)
  call fm_util_set_value('rpcaco3', 0.070/12*16/117*100)
  call fm_util_set_value('rpsio2', 0.026/12*16/117*60)
  call fm_util_set_value('wsink', 3.0/sperd)
  ! Wanninkhof numbers
  call fm_util_set_value('sc_co2_0', 2068.9)
  call fm_util_set_value('sc_co2_1', -118.63)
  call fm_util_set_value('sc_co2_2', 2.9311)
  call fm_util_set_value('sc_co2_3', -0.027)
  call fm_util_set_value('sc_o2_0', 1929.7)
  call fm_util_set_value('sc_o2_1', -117.46)
  call fm_util_set_value('sc_o2_2', 3.116)
  call fm_util_set_value('sc_o2_3', -0.0306)

  call fm_util_end_namelist(package_name, biotic(n)%name, check = .true., caller = caller_str)

  ! create some sub-namelists
  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+norm_remin',     &
       caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('factor', 0.0)
  call fm_util_set_value('coastal_only', .false.)
  call fm_util_set_value('t_mask', t_mask, size(t_mask))
  call fm_util_set_value('wlon', 0.0, index = 0)
  call fm_util_set_value('elon', 0.0, index = 0)
  call fm_util_set_value('slat', 0.0, index = 0)
  call fm_util_set_value('nlat', 0.0, index = 0)

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+norm_remin', caller = caller_str)

  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+no_caco3',     &
       caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('factor', 0.0)
  call fm_util_set_value('coastal_only', .false.)
  call fm_util_set_value('t_mask', t_mask, size(t_mask))
  call fm_util_set_value('wlon', 0.0, index = 0)
  call fm_util_set_value('elon', 0.0, index = 0)
  call fm_util_set_value('slat', 0.0, index = 0)
  call fm_util_set_value('nlat', 0.0, index = 0)

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+no_caco3', caller = caller_str)

  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+nut_depl',     &
       caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('factor', 0.0)
  call fm_util_set_value('coastal_only', .false.)
  call fm_util_set_value('t_mask', t_mask, size(t_mask))
  call fm_util_set_value('wlon', 0.0, index = 0)
  call fm_util_set_value('elon', 0.0, index = 0)
  call fm_util_set_value('slat', 0.0, index = 0)
  call fm_util_set_value('nlat', 0.0, index = 0)

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+nut_depl', caller = caller_str)

  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+r_bio_tau_prod',     &
       caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('factor', 0.0)
  call fm_util_set_value('coastal_only', .false.)
  call fm_util_set_value('t_mask', t_mask, size(t_mask))
  call fm_util_set_value('wlon', 0.0, index = 0)
  call fm_util_set_value('elon', 0.0, index = 0)
  call fm_util_set_value('slat', 0.0, index = 0)
  call fm_util_set_value('nlat', 0.0, index = 0)

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+r_bio_tau_prod', caller = caller_str)

enddo

!       Check for any errors in the number of fields in the namelists for this package
good_list => fm_util_get_string_array('/ocean_mod/GOOD/namelists/' // trim(package_name) // '/good_values',   &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
if (associated(good_list)) then
  call fm_util_check_for_bad_fields('/ocean_mod/namelists/' // trim(package_name), good_list,       &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')
  deallocate(good_list)
else
  call mpp_error(FATAL,trim(error_header) // ' Empty "' // trim(package_name) // '" list')
endif

return

end subroutine ocean_bgc_restore_init
! </SUBROUTINE> NAME="ocean_bgc_restore_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_bgc_restore_init_sfc">
!
! <DESCRIPTION>
!       Initialize surface fields for flux calculations
!
!       Note: this subroutine should be merged into ocean_bgc_restore_start
! </DESCRIPTION>

subroutine ocean_bgc_restore_init_sfc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,       &
     isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                                        &
     Ocean_fields, T_prog, rho, taum1, model_time, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: iec_bnd
integer, intent(in)                                     :: jsc_bnd
integer, intent(in)                                     :: jec_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho
integer, intent(in)                                     :: taum1
type(time_type), intent(in)                             :: model_time
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer :: i, j, m, n
integer :: i_bnd_off
integer :: j_bnd_off
integer :: nn
integer :: ind

real    :: epsln=1.0e-30

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

do n = 1, instances

   ! CO2 flux
  ind = biotic(n)%ind_co2_flux
  if (.not. field_exist('INPUT/'//trim(ocean_fields%bc(ind)%ocean_restart_file),   &
                        ocean_fields%bc(ind)%field(ind_alpha)%name)) then

    call ocmip2_co2calc(isd, jsd, isc, iec, jsc, jec,         &
         grid_tmask(isd:ied,jsd:jed,1),                                 &
         t_prog(indtemp)%field(isd:ied,jsd:jed,1,taum1),                &
         t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1),                 &
         t_prog(biotic(n)%ind_dic)%field(isd:ied,jsd:jed,1,taum1),      &
         t_prog(biotic(n)%ind_alk)%field(isd:ied,jsd:jed,1,taum1),      &
         t_prog(biotic(n)%ind_po4)%field(isd:ied,jsd:jed,1,taum1),      &
         t_prog(biotic(n)%ind_sio4)%field(isd:ied,jsd:jed,1,taum1),     &
         htotal_scale_lo, htotal_scale_hi, biotic(n)%htotal,            &
         co2star = biotic(n)%csurf, alpha = biotic(n)%alpha,            &
         pco2surf = biotic(n)%pco2surf)

    ! Compute the Schmidt number of CO2 in seawater using the 
    ! formulation presented by Wanninkhof (1992, J. Geophys. Res., 97,
    ! 7373-7382).
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%sc_co2(i,j) =                                                 &
             biotic(n)%sc_co2_0 + t_prog(indtemp)%field(i,j,1,taum1) *          &
             (biotic(n)%sc_co2_1 + t_prog(indtemp)%field(i,j,1,taum1) *         &
              (biotic(n)%sc_co2_2 + t_prog(indtemp)%field(i,j,1,taum1) *        &
               biotic(n)%sc_co2_3)) * grid_tmask(i,j,1)
        sc_no_term(i,j) = sqrt(660.0 / (biotic(n)%sc_co2(i,j) + epsln)) * grid_tmask(i,j,1)
                                              
        ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) = &
             biotic(n)%alpha(i,j) * sc_no_term(i,j) * rho(i,j,1,taum1)
        ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) = &
             biotic(n)%csurf(i,j) * sc_no_term(i,j) * rho(i,j,1,taum1)
      enddo
    enddo

  endif

  ! O2 flux
  ind = biotic(n)%ind_o2_flux
  if (.not. field_exist('INPUT/'//trim(ocean_fields%bc(ind)%ocean_restart_file),    &
                        ocean_fields%bc(ind)%field(ind_alpha)%name)) then

!  Compute the oxygen saturation concentration at 1 atm total
!  pressure in mol/m^3 given the temperature (t, in deg C) and
!  the salinity (s, in permil)
!
!  From Garcia and Gordon (1992), Limnology and Oceonography.
!  The formula used is from page 1310, eq (8).
!
!  *** Note: the "a3*ts^2" term (in the paper) is incorrect. ***
!  *** It shouldn't be there.                                ***
!
!  o2_saturation is defined between T(freezing) <= T <= 40 deg C and
!                                   0 permil <= S <= 42 permil
!
! check value: T = 10 deg C, S = 35 permil,
!              o2_saturation = 0.282015 mol/m^3
    do j = jsc, jec
      do i = isc, iec
        tt(i) = 298.15 - t_prog(indtemp)%field(i,j,1,taum1)
        tk(i) = 273.15 + t_prog(indtemp)%field(i,j,1,taum1)
        ts(i) = log(tt(i) / tk(i))
        ts2(i) = ts(i) * ts(i)
        ts3(i) = ts2(i) * ts(i)
        ts4(i) = ts3(i) * ts(i)
        ts5(i) = ts4(i) * ts(i)
        o2_saturation(i,j) =                                            &
             exp(a_0 + a_1*ts(i) + a_2*ts2(i) +                         &
                 a_3*ts3(i) + a_4*ts4(i) + a_5*ts5(i) +                 &
                 t_prog(indsal)%field(i,j,1,taum1) *                    &
                 (b_0 + b_1*ts(i) + b_2*ts2(i) + b_3*ts3(i) +           &
                  c_0*t_prog(indsal)%field(i,j,1,taum1))) * grid_tmask(i,j,1)
      enddo
    enddo

    ! convert from ml/l to mol/m^3
    do j = jsc, jec
      do i = isc, iec
        o2_saturation(i,j) = o2_saturation(i,j) * (1000.0/22391.6)
      enddo
    enddo

    ! Compute the Schmidt number of O2 in seawater using the 
    ! formulation proposed by Keeling et al. (1998, Global Biogeochem.
    ! Cycles, 12, 141-163).
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%sc_o2(i,j) =                                                  &
             biotic(n)%sc_o2_0 + t_prog(indtemp)%field(i,j,1,taum1) *           &
             (biotic(n)%sc_o2_1 + t_prog(indtemp)%field(i,j,1,taum1) *          &
              (biotic(n)%sc_o2_2 + t_prog(indtemp)%field(i,j,1,taum1) *         &
               biotic(n)%sc_o2_3)) * grid_tmask(i,j,1)
        sc_no_term(i,j) = sqrt(660.0 / (biotic(n)%sc_o2(i,j) + epsln)) * grid_tmask(i,j,1)
        ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =         &
             o2_saturation(i,j) * sc_no_term(i,j)
        ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =         &
             t_prog(biotic(n)%ind_o2)%field(i,j,1,taum1) * sc_no_term(i,j) * rho(i,j,1,taum1)
      enddo
    enddo

  endif
enddo

return

end subroutine ocean_bgc_restore_init_sfc
! </SUBROUTINE> NAME="ocean_bgc_restore_init_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_bgc_restore_sum_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>

subroutine ocean_bgc_restore_sum_sfc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,        &
     isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                                        &
     Ocean_fields, T_prog, rho, taum1, model_time, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: iec_bnd
integer, intent(in)                                     :: jsc_bnd
integer, intent(in)                                     :: jec_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
type(ocean_prog_tracer_type), intent(in), dimension(:)  :: T_prog
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho
integer, intent(in)                                     :: taum1
type(time_type), intent(in)                             :: model_time
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer :: i
integer :: i_bnd_off
integer :: j_bnd_off
integer :: j
integer :: n
integer :: nn
integer :: ind

real    :: epsln=1.0e-30

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

do n = 1, instances

    ind = biotic(n)%ind_co2_flux

    call ocmip2_co2calc(isd, jsd, isc, iec, jsc, jec,         &
         grid_tmask(isd:ied,jsd:jed,1),                                 &
         t_prog(indtemp)%field(isd:ied,jsd:jed,1,taum1),                &
         t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1),                 &
         t_prog(biotic(n)%ind_dic)%field(isd:ied,jsd:jed,1,taum1),      &
         t_prog(biotic(n)%ind_alk)%field(isd:ied,jsd:jed,1,taum1),      &
         t_prog(biotic(n)%ind_po4)%field(isd:ied,jsd:jed,1,taum1),      &
         t_prog(biotic(n)%ind_sio4)%field(isd:ied,jsd:jed,1,taum1),     &
         htotal_scale_lo, htotal_scale_hi, biotic(n)%htotal,            &
         co2star = biotic(n)%csurf, alpha = biotic(n)%alpha,            &
         pco2surf = biotic(n)%pco2surf)

    ! Compute the Schmidt number of CO2 in seawater using the 
    ! formulation presented by Wanninkhof (1992, J. Geophys. Res., 97,
    ! 7373-7382).
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%sc_co2(i,j) =                                                 &
             biotic(n)%sc_co2_0 + t_prog(indtemp)%field(i,j,1,taum1) *          &
             (biotic(n)%sc_co2_1 + t_prog(indtemp)%field(i,j,1,taum1) *         &
              (biotic(n)%sc_co2_2 + t_prog(indtemp)%field(i,j,1,taum1) *        &
               biotic(n)%sc_co2_3)) * grid_tmask(i,j,1)
        sc_no_term(i,j) = sqrt(660.0 / (biotic(n)%sc_co2(i,j) + epsln)) * grid_tmask(i,j,1) 
        ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =         &
             ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +    &
             biotic(n)%alpha(i,j) * sc_no_term(i,j) * rho(i,j,1,taum1)
        ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =         &
             ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +    &
             biotic(n)%csurf(i,j) * sc_no_term(i,j) * rho(i,j,1,taum1)
      enddo
    enddo

    ind = biotic(n)%ind_o2_flux

!  Compute the oxygen saturation concentration at 1 atm total
!  pressure in mol/m^3 given the temperature (t, in deg C) and
!  the salinity (s, in permil)
!
!  From Garcia and Gordon (1992), Limnology and Oceonography.
!  The formula used is from page 1310, eq (8).
!
!  *** Note: the "a3*ts^2" term (in the paper) is incorrect. ***
!  *** It shouldn't be there.                                ***
!
!  o2_saturation is defined between T(freezing) <= T <= 40 deg C and
!                                   0 permil <= S <= 42 permil
!
! check value: T = 10 deg C, S = 35 permil,
!              o2_saturation = 0.282015 mol/m^3
    do j = jsc, jec
      do i = isc, iec
        tt(i) = 298.15 - t_prog(indtemp)%field(i,j,1,taum1)
        tk(i) = 273.15 + t_prog(indtemp)%field(i,j,1,taum1)
        ts(i) = log(tt(i) / tk(i))
        ts2(i) = ts(i) * ts(i)
        ts3(i) = ts2(i) * ts(i)
        ts4(i) = ts3(i) * ts(i)
        ts5(i) = ts4(i) * ts(i)
        o2_saturation(i,j) =                                        &
             exp(a_0 + a_1*ts(i) + a_2*ts2(i) +                     &
                 a_3*ts3(i) + a_4*ts4(i) + a_5*ts5(i) +             &
                 t_prog(indsal)%field(i,j,1,taum1) *                &
                 (b_0 + b_1*ts(i) + b_2*ts2(i) + b_3*ts3(i) +       &
                  c_0*t_prog(indsal)%field(i,j,1,taum1))) * grid_tmask(i,j,1) 
      enddo
    enddo

    ! convert from ml/l to mol/m^3
    do j = jsc, jec
      do i = isc, iec
        o2_saturation(i,j) = o2_saturation(i,j) * (1000.0/22391.6)
      enddo
    enddo

    ! Compute the Schmidt number of O2 in seawater using the 
    ! formulation proposed by Keeling et al. (1998, Global Biogeochem.
    ! Cycles, 12, 141-163).
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%sc_o2(i,j) =                                                  &
             biotic(n)%sc_o2_0 + t_prog(indtemp)%field(i,j,1,taum1) *           &
             (biotic(n)%sc_o2_1 + t_prog(indtemp)%field(i,j,1,taum1) *          &
              (biotic(n)%sc_o2_2 + t_prog(indtemp)%field(i,j,1,taum1) *         &
               biotic(n)%sc_o2_3)) * grid_tmask(i,j,1)
        sc_no_term(i,j) = sqrt(660.0 / (biotic(n)%sc_o2(i,j) + epsln)) * grid_tmask(i,j,1) 
        ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =         &
             ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +    &
             o2_saturation(i,j) * sc_no_term(i,j)
        ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =         &
             ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +    &
             t_prog(biotic(n)%ind_o2)%field(i,j,1,taum1) * sc_no_term(i,j) * rho(i,j,1,taum1)
      enddo
    enddo

enddo

return

end subroutine ocean_bgc_restore_sum_sfc
! </SUBROUTINE> NAME="ocean_bgc_restore_sum_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_bgc_restore_zero_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>

subroutine ocean_bgc_restore_zero_sfc(Ocean_fields)

type(coupler_2d_bc_type), intent(inout) :: Ocean_fields

integer         :: n
integer         :: ind

do n = 1, instances

  ind = biotic(n)%ind_co2_flux

  ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0

  ind = biotic(n)%ind_o2_flux

  ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0

enddo

return

end subroutine ocean_bgc_restore_zero_sfc
! </SUBROUTINE> NAME="ocean_bgc_restore_zero_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_bgc_restore_avg_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>
subroutine ocean_bgc_restore_avg_sfc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,        &
     isc_bnd, iec_bnd, jsc_bnd, jec_bnd, Ocean_fields, Ocean_avg_kount, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: iec_bnd
integer, intent(in)                                     :: jsc_bnd
integer, intent(in)                                     :: jec_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
integer                                                 :: Ocean_avg_kount
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask


integer :: i_bnd_off
integer :: j_bnd_off
integer :: i, j, n
integer :: ind
real    :: divid

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

divid = 1./float(ocean_avg_kount)

do n = 1, instances

  ind = biotic(n)%ind_co2_flux

  do j = jsc, jec
    do i = isc, iec
      if (grid_tmask(i,j,1) == 1.0) then
        ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
        ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
      endif
    enddo
  enddo

  ind = biotic(n)%ind_o2_flux

  do j = jsc, jec
    do i = isc, iec
      if (grid_tmask(i,j,1) == 1.0) then
        ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
        ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
      endif
    enddo
  enddo

enddo

return

end subroutine ocean_bgc_restore_avg_sfc
! </SUBROUTINE> NAME="ocean_bgc_restore_avg_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_bgc_restore_sfc_end">
!
! <DESCRIPTION>
!       Initialize surface fields for flux calculations
! </DESCRIPTION>

subroutine ocean_bgc_restore_sfc_end

end subroutine ocean_bgc_restore_sfc_end
! </SUBROUTINE> NAME="ocean_bgc_restore_sfc_end"


!#######################################################################
! <SUBROUTINE NAME="ocean_bgc_restore_source">
!
! <DESCRIPTION>
!     compute the source terms for the BIOTICs, including boundary
!     conditions (not done in setvbc, to minimize number
!     of hooks required in MOM base code)
! </DESCRIPTION>

subroutine ocean_bgc_restore_source(isc, iec, jsc, jec, nk, isd, ied, jsd, jed, &
     T_prog, T_diag, taum1, model_time, Grid, Time, grid_kmt, rho_dzt, dtts)

integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: nk
integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
type(ocean_prog_tracer_type), intent(inout), dimension(:)       :: T_prog
type(ocean_diag_tracer_type), intent(inout), dimension(:)       :: T_diag
integer, intent(in)                                             :: taum1
type(time_type), intent(in)                                     :: model_time
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time
integer, dimension(isd:,jsd:), intent(in)                       :: grid_kmt
real, dimension(isd:,jsd:,:,:), intent(in)                      :: rho_dzt
real, intent(in)                                                :: dtts

integer :: i, j, k, kmax, n
integer :: ind_no3
integer :: ind_nh4
integer :: ind_po4
integer :: ind_fed
integer :: ind_fep
integer :: ind_sio4
integer :: ind_alk
integer :: ind_ldoc
integer :: ind_don
integer :: ind_dop
integer :: ind_dic
integer :: ind_o2
integer :: km_c
logical :: used
integer :: day
integer :: month
integer :: year
integer :: hour
integer :: minute
integer :: second

real :: jtot
real :: SoverPstar2
real :: expkT
real :: fpon_protected

  integer :: stdoutunit 
  stdoutunit=stdout() 


! get the model month
call get_date(model_time, year, month, day,                &
              hour, minute, second)

! calculate the source terms for BIOTICs

! calculate interpolated NO3_star, PO4_star, SiO4_star and Alk_star
call time_interp_external(no3_star_id, model_time, no3_star_t)
call time_interp_external(po4_star_id, model_time, po4_star_t)
call time_interp_external(fed_star_id, model_time, fed_star_t)
call time_interp_external(sio4_star_id, model_time, sio4_star_t)
call time_interp_external(alk_star_id, model_time, alk_star_t)

! Loop over multiple instances
do n = 1, instances

  ind_no3 = biotic(n)%ind_no3
  ind_nh4 = biotic(n)%ind_nh4
  ind_po4 = biotic(n)%ind_po4
  ind_fed = biotic(n)%ind_fed
  ind_fep = biotic(n)%ind_fep
  ind_sio4 = biotic(n)%ind_sio4
  ind_alk = biotic(n)%ind_alk
  ind_ldoc = biotic(n)%ind_ldoc
  ind_don = biotic(n)%ind_don
  ind_dop = biotic(n)%ind_dop
  ind_dic = biotic(n)%ind_dic
  ind_o2 = biotic(n)%ind_o2
  km_c = biotic(n)%km_c

  ! Production

  ! compute NO3 restoring term and correct for partial
  ! production in the bottom box
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        if (t_prog(ind_no3)%field(i,j,k,taum1) .gt.             &
            no3_star_t(i,j,k) *                                 &
            biotic(n)%nut_depl%mask(i,j,month)) then
          biotic(n)%jprod_no3(i,j,k) =                              &
               (t_prog(ind_no3)%field(i,j,k,taum1) -            &
                no3_star_t(i,j,k) *                             &
                biotic(n)%nut_depl%mask(i,j,month)) *           &
               biotic(n)%r_bio_tau_prod%mask(i,j,month) * Grid%tmask(i,j,k)
        else
          biotic(n)%jprod_no3(i,j,k) = 0.0
        endif
      enddo
    enddo
  enddo

  do j = jsc, jec
    do i = isc, iec
      biotic(n)%jprod_no3(i,j,km_c) = biotic(n)%jprod_no3(i,j,km_c) *   &
           biotic(n)%comp_depth_frac(i,j)
    enddo
  enddo

  ! compute NH4 restoring term and correct for partial
  ! production in the bottom box
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        if (t_prog(ind_nh4)%field(i,j,k,taum1) .gt. 0.0) then
          biotic(n)%jprod_nh4(i,j,k) =                              &
               t_prog(ind_nh4)%field(i,j,k,taum1) *           &
               biotic(n)%r_bio_tau_nh4 * Grid%tmask(i,j,k)
        else
          biotic(n)%jprod_nh4(i,j,k) = 0.0
        endif
      enddo
    enddo
  enddo

  do j = jsc, jec
    do i = isc, iec
      biotic(n)%jprod_nh4(i,j,km_c) = biotic(n)%jprod_nh4(i,j,km_c) *   &
           biotic(n)%comp_depth_frac(i,j)
    enddo
  enddo

  ! compute PO4 restoring term and correct for partial
  ! production in the bottom box
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        if (t_prog(ind_po4)%field(i,j,k,taum1) .gt.             &
            po4_star_t(i,j,k) *                                 &
            biotic(n)%nut_depl%mask(i,j,month)) then
          biotic(n)%jprod_po4(i,j,k) =                              &
               (t_prog(ind_po4)%field(i,j,k,taum1) -            &
                po4_star_t(i,j,k) *                             &
                biotic(n)%nut_depl%mask(i,j,month)) *           &
               biotic(n)%r_bio_tau_prod%mask(i,j,month) * Grid%tmask(i,j,k)
        else
          biotic(n)%jprod_po4(i,j,k) = 0.0
        endif
      enddo
    enddo
  enddo

  do j = jsc, jec
    do i = isc, iec
      biotic(n)%jprod_po4(i,j,km_c) = biotic(n)%jprod_po4(i,j,km_c) *   &
           biotic(n)%comp_depth_frac(i,j)
    enddo
  enddo

  ! compute Fed restoring term and correct for partial
  ! production in the bottom box
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        if (t_prog(ind_fed)%field(i,j,k,taum1) .gt.             &
            fed_star_t(i,j,k) *                                 &
            biotic(n)%nut_depl%mask(i,j,month)) then
          biotic(n)%jprod_fed(i,j,k) =                              &
               (t_prog(ind_fed)%field(i,j,k,taum1) -            &
                fed_star_t(i,j,k) *                             &
                biotic(n)%nut_depl%mask(i,j,month)) *           &
               biotic(n)%r_bio_tau_prod%mask(i,j,month) * Grid%tmask(i,j,k)
        else
          biotic(n)%jprod_fed(i,j,k) = 0.0
        endif
      enddo
    enddo
  enddo

  do j = jsc, jec
    do i = isc, iec 
      biotic(n)%jprod_fed(i,j,km_c) = biotic(n)%jprod_fed(i,j,km_c) *   &
           biotic(n)%comp_depth_frac(i,j)
    enddo
  enddo


  ! compute nitrogen fixation
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
       biotic(n)%jprod_n_norm(i,j,k) = biotic(n)%jprod_nh4(i,j,k) +     &
         biotic(n)%jprod_no3(i,j,k)
       biotic(n)%jprod_p_norm(i,j,k) = biotic(n)%jprod_po4(i,j,k)
       biotic(n)%jprod_p_fix(i,j,k) = 0.0
       biotic(n)%jprod_n_fix(i,j,k) = 0.0
      enddo
    enddo
  enddo

  do j = jsc, jec
    do i = isc, iec
      biotic(n)%jprod_p_norm(i,j,km_c) = biotic(n)%jprod_p_norm(i,j,km_c) *   &
           biotic(n)%comp_depth_frac(i,j)
      biotic(n)%jprod_p_fix(i,j,km_c) = biotic(n)%jprod_p_fix(i,j,km_c) *   &
           biotic(n)%comp_depth_frac(i,j)
      biotic(n)%jprod_n_fix(i,j,km_c) = biotic(n)%jprod_n_fix(i,j,km_c) *   &
           biotic(n)%comp_depth_frac(i,j)
    enddo 
  enddo

  ! compute SiO4 restoring term and correct for partial
  ! production in the bottom box
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
          if (t_prog(ind_sio4)%field(i,j,k,taum1) .gt.          &
              sio4_star_t(i,j,k)) then
            biotic(n)%jprod_sio4(i,j,k) =                       &
                 (t_prog(ind_sio4)%field(i,j,k,taum1) -         &
                  sio4_star_t(i,j,k)) *                         &
                 biotic(n)%r_bio_tau * Grid%tmask(i,j,k)
          else
            biotic(n)%jprod_sio4(i,j,k) = 0.0
        endif
      enddo
    enddo
  enddo

    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jprod_sio4(i,j,km_c) =                        &
             biotic(n)%jprod_sio4(i,j,km_c) *                   &
             biotic(n)%comp_depth_frac(i,j)
      enddo
    enddo

    ! compute Alk restoring term and correct for partial
    ! production in the bottom box
    do k = 1, km_c
      do j = jsc, jec
        do i = isc, iec
          if ((t_prog(ind_alk)%field(i,j,k,taum1) +            &
            t_prog(ind_no3)%field(i,j,k,taum1)) * 35.0 /       &
            (t_prog(indsal)%field(i,j,k,taum1) + 1e-40) .gt.             &
              alk_star_t(i,j,k)) then
            biotic(n)%jprod_alk(i,j,k) =                       &
                 ((t_prog(ind_alk)%field(i,j,k,taum1) +        &
            t_prog(ind_no3)%field(i,j,k,taum1)) * 35.0 /       &
            (t_prog(indsal)%field(i,j,k,taum1) + 1e-40) -         &
                  alk_star_t(i,j,k)) *                         &
                 biotic(n)%r_bio_tau * Grid%tmask(i,j,k)
          else
            biotic(n)%jprod_alk(i,j,k) = 0.0
          endif
        enddo
      enddo
    enddo

    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jprod_alk(i,j,km_c) =                        &
             biotic(n)%jprod_alk(i,j,km_c) *                   &
             biotic(n)%comp_depth_frac(i,j)
      enddo
    enddo

    ! Do not allow production in bottom level
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jprod_no3(i,j,grid_kmt(i,j)) = 0.0
        biotic(n)%jprod_nh4(i,j,grid_kmt(i,j)) = 0.0
        biotic(n)%jprod_po4(i,j,grid_kmt(i,j)) = 0.0
        biotic(n)%jprod_n_norm(i,j,grid_kmt(i,j)) = 0.0
        biotic(n)%jprod_p_norm(i,j,grid_kmt(i,j)) = 0.0
        biotic(n)%jprod_n_fix(i,j,grid_kmt(i,j)) = 0.0
        biotic(n)%jprod_p_fix(i,j,grid_kmt(i,j)) = 0.0
        biotic(n)%jprod_fed(i,j,grid_kmt(i,j)) = 0.0
        biotic(n)%jprod_sio4(i,j,grid_kmt(i,j)) = 0.0
        biotic(n)%jprod_alk(i,j,grid_kmt(i,j)) = 0.0
      enddo
    enddo

  ! Food Web Processing
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        jtot=max(biotic(n)%jprod_n_norm(i,j,k) +                                &
            biotic(n)%jprod_n_fix(i,j,k),1.0e-30)
          expkT = exp(biotic(n)%kappa_eppley * t_prog(indtemp)%field(i,j,k,taum1))
        SoverPstar2=-0.5 + 0.5 * sqrt(1.0 + 4.0 * jtot /                        &
            (expkT * biotic(n)%Prodstar))
        biotic(n)%fracl(i,j,k) = SoverPstar2 / (1.0 + SoverPstar2) *            &
            Grid%tmask(i,j,k)
        biotic(n)%jprod_pon(i,j,k) = max(0.0,jtot * (exp(biotic(n)%kappa_remin *&
             t_prog(indtemp)%field(i,j,k,taum1)) *                              &
            (biotic(n)%fdetl0 * biotic(n)%fracl(i,j,k) + biotic(n)%fdets0 *     &
            (1.0 - biotic(n)%fracl(i,j,k))) - biotic(n)%phi_don)) *             &
            Grid%tmask(i,j,k)
        biotic(n)%jprod_pop(i,j,k) = biotic(n)%jprod_pon(i,j,k) / jtot *        &
            (biotic(n)%jprod_p_norm(i,j,k) + biotic(n)%jprod_p_fix(i,j,k))
        biotic(n)%jprod_pofe(i,j,k) = biotic(n)%jprod_pon(i,j,k) / jtot *       &
            biotic(n)%jprod_fed(i,j,k)
        biotic(n)%jldoc(i,j,k) = jtot * biotic(n)%phi_ldoc * Grid%tmask(i,j,k)
        biotic(n)%jdon(i,j,k) = jtot * biotic(n)%phi_don * Grid%tmask(i,j,k)
        biotic(n)%jdop(i,j,k) = (biotic(n)%jprod_p_norm(i,j,k) +                &
            biotic(n)%jprod_p_fix(i,j,k)) * biotic(n)%phi_dop *                 &
            Grid%tmask(i,j,k)
        biotic(n)%jnh4_graz(i,j,k) = (jtot - biotic(n)%jprod_pon(i,j,k) -       &
            biotic(n)%jdon(i,j,k)) * Grid%tmask(i,j,k)
        biotic(n)%jpo4_graz(i,j,k) = (biotic(n)%jprod_p_norm(i,j,k) +           &
            biotic(n)%jprod_p_fix(i,j,k) - biotic(n)%jprod_pop(i,j,k) -         &
            biotic(n)%jdop(i,j,k)) * Grid%tmask(i,j,k)
        biotic(n)%jfe_graz(i,j,k) = (biotic(n)%jprod_fed(i,j,k)                &
            - biotic(n)%jprod_pofe(i,j,k)) * Grid%tmask(i,j,k)
      enddo
    enddo
  enddo

  ! Accumulate first level of flux
  do j=jsc,jec
    do i=isc,iec
      biotic(n)%fsio2(i,j,1) = biotic(n)%jprod_sio4(i,j,1) *        &
        rho_dzt(i,j,1,taum1) * Grid%tmask(i,j,1)
      biotic(n)%fcaco3(i,j,1) = 0.5 * biotic(n)%jprod_alk(i,j,1) *  &
        rho_dzt(i,j,1,taum1) * Grid%tmask(i,j,1)
      biotic(n)%fpon(i,j,1) = biotic(n)%jprod_pon(i,j,1) *          &
         rho_dzt(i,j,1,taum1) * Grid%tmask(i,j,1)
      biotic(n)%fpop(i,j,1) = biotic(n)%jprod_pop(i,j,1) *          &
         rho_dzt(i,j,1,taum1) * Grid%tmask(i,j,1)
      biotic(n)%jfe_ads(i,j,1)=min(biotic(n)%kfe_max_prime,         &
        (biotic(n)%kfe_org / 2.0 * biotic(n)%fpon(i,j,1) *          &
        biotic(n)%mass_2_n + biotic(n)%kfe_bal / 2.0 *              &
        (biotic(n)%fsio2(i,j,1) * 60.0 + biotic(n)%fcaco3(i,j,1) *  &
        100.0)) * biotic(n)%r_wsink) *                              &
        max(0.0,t_prog(ind_fed)%field(i,j,1,taum1))
      biotic(n)%jfe_des(i,j,1) = biotic(n)%kfe_des *                &
        max(0.0,t_diag(ind_fep)%field(i,j,1))
      biotic(n)%jpon(i,j,1) = 0.0
      biotic(n)%jpop(i,j,1) = 0.0
      biotic(n)%jpofe(i,j,1) = 0.0
      biotic(n)%jsio4(i,j,1) = 0.0
      biotic(n)%jcaco3(i,j,1) = 0.0
    enddo
  enddo

  do k=2,nk-1
    do j=jsc,jec
      do i=isc,iec
        biotic(n)%fsio2(i,j,k) = biotic(n)%fsio2(i,j,k-1) *                    &
          biotic(n)%r_1plusintzscale_si(k) * Grid%tmask(i,j,k)

        ! Calculate regeneration term
        biotic(n)%jsio4(i,j,k) = (biotic(n)%fsio2(i,j,k-1) * Grid%tmask(i,j,k) &
          - biotic(n)%fsio2(i,j,k) * Grid%tmask(i,j,k+1)) / rho_dzt(i,j,k,taum1)

        ! Add production within box to flux
        biotic(n)%fsio2(i,j,k) = biotic(n)%fsio2(i,j,k) +                      &
          biotic(n)%jprod_sio4(i,j,k) *                                        &
          rho_dzt(i,j,k,taum1) * Grid%tmask(i,j,k)
      enddo
    enddo
  enddo

  do k=2,nk-1
    do j=jsc,jec
      do i=isc,iec
        biotic(n)%fcaco3(i,j,k) = biotic(n)%fcaco3(i,j,k-1) *                  &
          biotic(n)%r_1plusintzscale_ca(k) * Grid%tmask(i,j,k)

        ! Calculate regeneration term
        biotic(n)%jcaco3(i,j,k) = (biotic(n)%fcaco3(i,j,k-1) * Grid%tmask(i,j,k) &
          - biotic(n)%fcaco3(i,j,k) * Grid%tmask(i,j,k+1)) / rho_dzt(i,j,k,taum1)

        ! Add production within box to flux
        biotic(n)%fcaco3(i,j,k) = biotic(n)%fcaco3(i,j,k) + 0.5 *              &
          biotic(n)%jprod_alk(i,j,k) *                                         &
          rho_dzt(i,j,k,taum1) * Grid%tmask(i,j,k)
        enddo
      enddo
    enddo

if(biotic(n)%remin_ocmip2) then
  ! OCMIP2 Interior Remineralization Scheme

  ! F(z) = F75 * (z / 75)^-0.9
  do k = 2, km_c
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%fpon(i,j,k) = biotic(n)%fpon(i,j,k-1) +       &
          biotic(n)%jprod_pon(i,j,k) *                          &
          rho_dzt(i,j,k,taum1) * Grid%tmask(i,j,k)
        biotic(n)%fpop(i,j,k) = biotic(n)%fpop(i,j,k-1) +       &
          biotic(n)%jprod_pop(i,j,k) *                          &
          rho_dzt(i,j,k,taum1) * Grid%tmask(i,j,k)
      enddo
    enddo
  enddo

  do j = jsc, jec
    do i = isc, iec
      biotic(n)%flux_pon(i,j) = biotic(n)%fpon(i,j,km_c)
      biotic(n)%flux_pop(i,j) = biotic(n)%fpop(i,j,km_c)
    enddo
  enddo

  do k = km_c, nk
    do j = jsc, jec
      do i = isc, iec
        ! Calculate the flux at the base of each layer below the
        ! compensation depth
        biotic(n)%fpon(i,j,k) = biotic(n)%flux_pon(i,j) *         &
             Grid%tmask(i,j,k) * biotic(n)%zforg(k)
        biotic(n)%fpop(i,j,k) = biotic(n)%flux_pop(i,j) *         &
             Grid%tmask(i,j,k) * biotic(n)%zforg(k)

        ! Calculate regeneration term
        biotic(n)%jpon(i,j,k) = (biotic(n)%fpon(i,j,k-1) * Grid%tmask(i,j,k)   &
          - biotic(n)%fpon(i,j,k) * Grid%tmask(i,j,k+1)) / rho_dzt(i,j,k,taum1)
        biotic(n)%jpop(i,j,k) = (biotic(n)%fpop(i,j,k-1) * Grid%tmask(i,j,k)   &
          - biotic(n)%fpop(i,j,k) * Grid%tmask(i,j,k+1)) / rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo
elseif(biotic(n)%remin_protection) then
  ! Ballast Protection Interior Remineralization Scheme
  ! remin = g * max(0.0 , Forg - rpcaco3 * Fcaco3 - rpsio2 * Fsio2)
  do k=2,nk-1
    do j=jsc,jec
      do i=isc,iec
         ! Remineralization of unprotected organic material and
         ! previously protected particulate organic material
        fpon_protected = biotic(n)%rpsio2 * biotic(n)%fsio2(i,j,k-1) +         &
          biotic(n)%rpcaco3 * biotic(n)%fcaco3(i,j,k-1) + 1.0e-30
        biotic(n)%fpon(i,j,k) = min(biotic(n)%fpon(i,j,k-1),                  &
          ((biotic(n)%fpon(i,j,k-1) + biotic(n)%r_intzscale_n(k) *              &
          fpon_protected) * biotic(n)%r_1plusintzscale_n(k)) -                 &
          (biotic(n)%rpsio2 * (biotic(n)%fsio2(i,j,k-1) -                      &
          biotic(n)%fsio2(i,j,k)) + biotic(n)%rpcaco3 *                        &
          (biotic(n)%fcaco3(i,j,k-1) - biotic(n)%fcaco3(i,j,k))) *             &
          min(biotic(n)%fpon(i,j,k-1),fpon_protected) /                        &
          fpon_protected * biotic(n)%r_1plusintzscale_n(k)) * Grid%tmask(i,j,k)

        ! Apply N change to P assuming equal partitioning between protected,
        ! previously protected and unprotected particulate organic material
        biotic(n)%fpop(i,j,k) = biotic(n)%fpon(i,j,k) /                        &
          max(biotic(n)%fpon(i,j,k-1),1e-30) * biotic(n)%fpop(i,j,k-1)

        ! Calculate regeneration term
        biotic(n)%jpon(i,j,k) = (biotic(n)%fpon(i,j,k-1) * Grid%tmask(i,j,k)   &
          - biotic(n)%fpon(i,j,k) * Grid%tmask(i,j,k+1)) / rho_dzt(i,j,k,taum1)
        biotic(n)%jpop(i,j,k) = (biotic(n)%fpop(i,j,k-1)  * Grid%tmask(i,j,k)  &
          - biotic(n)%fpop(i,j,k) * Grid%tmask(i,j,k+1)) / rho_dzt(i,j,k,taum1)

        ! Add production within box to flux
        biotic(n)%fpon(i,j,k) = biotic(n)%fpon(i,j,k) +                    &
          biotic(n)%jprod_pon(i,j,k) *                                     &
          rho_dzt(i,j,k,taum1) * Grid%tmask(i,j,k)
        biotic(n)%fpop(i,j,k) = biotic(n)%fpop(i,j,k) +                    &
          biotic(n)%jprod_pop(i,j,k) *                                     &
          rho_dzt(i,j,k,taum1) * Grid%tmask(i,j,k)
    enddo
  enddo
  enddo
elseif (biotic(n)%remin_density) then
elseif (biotic(n)%remin_lability) then
elseif (biotic(n)%remin_temp) then
elseif (biotic(n)%remin_viscosity) then
elseif (biotic(n)%remin_zoop_resp) then
endif


! Choose between associating particulate Fe with ballast and organic matter, 
! or just with organic matter
if (biotic(n)%fe_ballast_assoc) then
  do k=2,nk-1
    do j = jsc, jec
      do i = isc, iec
         ! Apply N change to Fe incorporating adsorption and desorption
        biotic(n)%jfe_ads(i,j,k)=min(biotic(n)%kfe_max_prime , (biotic(n)%kfe_org  &
          / 2.0 * (biotic(n)%fpon(i,j,k-1)+biotic(n)%fpon(i,j,k)) *            &
          biotic(n)%mass_2_n + biotic(n)%kfe_bal / 2.0 *                         &
          ((biotic(n)%fsio2(i,j,k-1) + biotic(n)%fsio2(i,j,k)) *               &
          60.0 + (biotic(n)%fcaco3(i,j,k-1) + biotic(n)%fcaco3(i,j,k)) * 100.0))&
          * biotic(n)%r_wsink ) * max(0.0,t_prog(ind_fed)%field(i,j,k,taum1))
        biotic(n)%jfe_des(i,j,k)=biotic(n)%kfe_des *                             &
          max(0.0,t_diag(ind_fep)%field(i,j,k))
        biotic(n)%jpofe(i,j,k) = (biotic(n)%jpon(i,j,k) *                &
          biotic(n)%mass_2_n + biotic(n)%jsio4(i,j,k) * 60.0 +           &
          biotic(n)%jcaco3(i,j,k) * 100.0) /                             &
          max(1.0e-30,biotic(n)%fpon(i,j,k-1) * biotic(n)%mass_2_n +     &
          biotic(n)%fsio2(i,j,k-1) * 60.0 + biotic(n)%fcaco3(i,j,k-1)    &
          * 100.0) * max(0.0,t_diag(ind_fep)%field(i,j,k))               &
          * biotic(n)%wsink *                                            &
          (1.0 - Grid%tmask(i,j,k) + Grid%tmask(i,j,k+1))
      enddo
    enddo
  enddo
else
  do k=2,nk-1
    do j=jsc,jec
      do i=isc,iec
         ! Apply N change to Fe incorporating adsorption and desorption
        biotic(n)%jfe_ads(i,j,k)=min(biotic(n)%kfe_max_prime , (biotic(n)%kfe_org  &
          / 2.0 * (biotic(n)%fpon(i,j,k-1)+biotic(n)%fpon(i,j,k)) *            &
          biotic(n)%mass_2_n + biotic(n)%kfe_bal / 2.0 *                         &
          ((biotic(n)%fsio2(i,j,k-1) + biotic(n)%fsio2(i,j,k)) *               &
          60.0 + (biotic(n)%fcaco3(i,j,k-1) + biotic(n)%fcaco3(i,j,k)) * 100.0))&
          * biotic(n)%r_wsink ) * max(0.0,t_prog(ind_fed)%field(i,j,k,taum1))
        biotic(n)%jfe_des(i,j,k)=biotic(n)%kfe_des *                             &
          max(0.0,t_diag(ind_fep)%field(i,j,k))
        biotic(n)%jpofe(i,j,k) = biotic(n)%jpon(i,j,k) /                 &
          max(1.0e-30,biotic(n)%fpon(i,j,k-1)) *                         &
          max(0.0,t_diag(ind_fep)%field(i,j,k)) * biotic(n)%wsink *       &
          (1.0 - Grid%tmask(i,j,k) + Grid%tmask(i,j,k+1))
        enddo
      enddo
    enddo
  endif


  do j=jsc,jec
    do i=isc,iec
      biotic(n)%fsio2(i,j,nk) = 0.0
      biotic(n)%fcaco3(i,j,nk) = 0.0
      biotic(n)%fpon(i,j,nk) = 0.0
      biotic(n)%fpop(i,j,nk) = 0.0
      biotic(n)%jfe_ads(i,j,nk) = min(biotic(n)%kfe_max_prime ,  &
        (biotic(n)%kfe_org / 2.0 * (biotic(n)%fpon(i,j,nk-1) +   &
        biotic(n)%fpon(i,j,nk)) * biotic(n)%mass_2_n +         &
        biotic(n)%kfe_bal / 2.0 * ((biotic(n)%fsio2(i,j,nk-1) +  &
        biotic(n)%fsio2(i,j,nk)) * 60.0 +                      &
        (biotic(n)%fcaco3(i,j,nk-1) + biotic(n)%fcaco3(i,j,nk))&
        * 100.0)) * biotic(n)%r_wsink ) *                      &
        max(0.0,t_prog(ind_fed)%field(i,j,nk,taum1))
      biotic(n)%jfe_des(i,j,nk)=biotic(n)%kfe_des *              &
        max(0.0,t_diag(ind_fep)%field(i,j,nk))

      ! Calculate regeneration term
      biotic(n)%jsio4(i,j,nk) = (biotic(n)%fsio2(i,j,nk-1) -   &
        biotic(n)%fsio2(i,j,nk)) / rho_dzt(i,j,nk,taum1)
      biotic(n)%jcaco3(i,j,nk) = (biotic(n)%fcaco3(i,j,nk-1) - &
        biotic(n)%fcaco3(i,j,nk)) / rho_dzt(i,j,nk,taum1)
      biotic(n)%jpon(i,j,nk) = (biotic(n)%fpon(i,j,nk-1) -     &
        biotic(n)%fpon(i,j,nk)) / rho_dzt(i,j,nk,taum1)
      biotic(n)%jpop(i,j,nk) = (biotic(n)%fpop(i,j,nk-1) -     &
        biotic(n)%fpop(i,j,nk)) / rho_dzt(i,j,nk,taum1)
      biotic(n)%jpofe(i,j,nk) = 0.0
    enddo
  enddo

    do j = jsc, jec
      do i = isc, iec
      kmax=min(km_c,grid_kmt(i,j))
      biotic(n)%flux_sio2(i,j) = biotic(n)%fsio2(i,j,kmax)
      biotic(n)%flux_caco3(i,j) = biotic(n)%fcaco3(i,j,kmax)
      biotic(n)%flux_pon(i,j) = biotic(n)%fpon(i,j,kmax)
      biotic(n)%flux_pop(i,j) = biotic(n)%fpop(i,j,kmax)
      enddo
    enddo

    do j = jsc, jec
      do i = isc, iec
      biotic(n)%jfe_sink(i,j,1)=                               &
        - max(0.0,t_diag(ind_fep)%field(i,j,1)) *        &
        biotic(n)%wsink / rho_dzt(i,j,1,taum1) * Grid%tmask(i,j,1)
      enddo
    enddo

  do k = 2, nk
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jfe_sink(i,j,k)=                             &
          (max(0.0,t_diag(ind_fep)%field(i,j,k-1)) -     &
          max(0.0,t_diag(ind_fep)%field(i,j,k))) *       &
          biotic(n)%wsink / rho_dzt(i,j,k,taum1) * Grid%tmask(i,j,k)
      enddo
    enddo
  enddo

  ! CALCULATE SOURCE/SINK TERMS FOR EACH TRACER

  ! NO3
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
         biotic(n)%jdenit(i,j,k) = 0.0
        biotic(n)%jno3(i,j,k) =  biotic(n)%r_bio_tau_nitrif_s *             &
        max(0.0,t_prog(ind_nh4)%field(i,j,k,taum1)) -                       &
        biotic(n)%jprod_no3(i,j,k) - biotic(n)%jdenit(i,j,k)
      enddo
    enddo
  enddo

  do k=km_c + 1, nk
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jdenit(i,j,k) = 0.0
        biotic(n)%jno3(i,j,k) = biotic(n)%r_bio_tau_nitrif_d *                &
        max(0.0,t_prog(ind_nh4)%field(i,j,k,taum1)) -                       &
          biotic(n)%jdenit(i,j,k)
      enddo
    enddo
  enddo

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_no3)%th_tendency(i,j,k) = t_prog(ind_no3)%th_tendency(i,j,k) +  &
          biotic(n)%jno3(i,j,k) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  ! NH4
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jnh4(i,j,k) = biotic(n)%jnh4_graz(i,j,k)               &
          - biotic(n)%jprod_nh4(i,j,k)                                   &
          + biotic(n)%r_bio_tau_don * max(0.0,t_prog(ind_don)%field(i,j,k,taum1)) &
          - biotic(n)%r_bio_tau_nitrif_s *                               &
          max(0.0,t_prog(ind_nh4)%field(i,j,k,taum1))                    &
          +(1.0 - biotic(n)%phi_don)*biotic(n)%jpon(i,j,k)  
      enddo
    enddo
  enddo

  do k=km_c + 1, nk
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jnh4(i,j,k) =(1.0 - biotic(n)%phi_don) *               &
          biotic(n)%jpon(i,j,k)                                          &
          + biotic(n)%r_bio_tau_don * max(0.0,t_prog(ind_don)%field(i,j,k,taum1)) &
          - biotic(n)%r_bio_tau_nitrif_d *                               &
          max(0.0,t_prog(ind_nh4)%field(i,j,k,taum1)) 
      enddo
    enddo
  enddo

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_nh4)%th_tendency(i,j,k) = t_prog(ind_nh4)%th_tendency(i,j,k) +  &
          biotic(n)%jnh4(i,j,k) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  ! PO4
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jpo4(i,j,k) = - biotic(n)%jprod_p_norm(i,j,k) -        &
          biotic(n)%jprod_p_fix(i,j,k) + biotic(n)%jpo4_graz(i,j,k) +    &
          biotic(n)%r_bio_tau_dop * max(0.0,t_prog(ind_dop)%field(i,j,k,taum1)) + &
         (1.0 - biotic(n)%phi_dop) * biotic(n)%jpop(i,j,k)
      enddo
    enddo
  enddo

  do k=km_c + 1, nk
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jpo4(i,j,k) =  (1.0 - biotic(n)%phi_dop) *             &
          biotic(n)%jpop(i,j,k) + biotic(n)%r_bio_tau_dop *              &
          max(0.0,t_prog(ind_dop)%field(i,j,k,taum1))
      enddo
    enddo
  enddo

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_po4)%th_tendency(i,j,k) = t_prog(ind_po4)%th_tendency(i,j,k) +  &
             biotic(n)%jpo4(i,j,k) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  ! Fe dissolved
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_fed)%th_tendency(i,j,k) = t_prog(ind_fed)%th_tendency(i,j,k) +  &
             (biotic(n)%jfe_graz(i,j,k) - biotic(n)%jprod_fed(i,j,k)    &
             - biotic(n)%jfe_ads(i,j,k) + biotic(n)%jfe_des(i,j,k) +    &
             biotic(n)%jpofe(i,j,k)) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  do k=km_c + 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_fed)%th_tendency(i,j,k) = t_prog(ind_fed)%th_tendency(i,j,k) + &
          (biotic(n)%jfe_des(i,j,k) - biotic(n)%jfe_ads(i,j,k) +        &
          biotic(n)%jpofe(i,j,k)) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  ! Fe particulate
  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_diag(ind_fep)%field(i,j,k) = t_diag(ind_fep)%field(i,j,k) + &
             (biotic(n)%jprod_pofe(i,j,k) + biotic(n)%jfe_ads(i,j,k) -  &
             biotic(n)%jfe_des(i,j,k) - biotic(n)%jpofe(i,j,k) +        &
             biotic(n)%jfe_sink(i,j,k)) * dtts
      enddo
    enddo
  enddo

  ! LDOC
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jldoc(i,j,k) = biotic(n)%jldoc(i,j,k)                    &
          - biotic(n)%r_bio_tau_ldoc * max(0.0,t_prog(ind_ldoc)%field(i,j,k,taum1))
      enddo
    enddo
  enddo

  do k = km_c + 1, nk
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jldoc(i,j,k) =                                           &
          - biotic(n)%r_bio_tau_ldoc * max(0.0,t_prog(ind_ldoc)%field(i,j,k,taum1))
      enddo
    enddo
  enddo

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_ldoc)%th_tendency(i,j,k) = t_prog(ind_ldoc)%th_tendency(i,j,k) + &
          biotic(n)%jldoc(i,j,k) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  ! DON
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jdon(i,j,k) = biotic(n)%jdon(i,j,k)                      &
        +  biotic(n)%phi_don * biotic(n)%jpon(i,j,k)                       &
          - biotic(n)%r_bio_tau_don * max(0.0,t_prog(ind_don)%field(i,j,k,taum1))
      enddo
    enddo
  enddo

  do k = km_c + 1, nk
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jdon(i,j,k) = biotic(n)%phi_don * biotic(n)%jpon(i,j,k)  &
          - biotic(n)%r_bio_tau_don * max(0.0,t_prog(ind_don)%field(i,j,k,taum1))
      enddo
    enddo
  enddo

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_don)%th_tendency(i,j,k) = t_prog(ind_don)%th_tendency(i,j,k) +      &
          biotic(n)%jdon(i,j,k) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  ! DOP
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jdop(i,j,k) = biotic(n)%jdop(i,j,k)                      &
          +  biotic(n)%phi_dop * biotic(n)%jpop(i,j,k)                     &
          - biotic(n)%r_bio_tau_dop * max(0.0,t_prog(ind_dop)%field(i,j,k,taum1))
      enddo
    enddo
  enddo

  do k = km_c + 1, nk
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jdop(i,j,k) = biotic(n)%phi_dop * biotic(n)%jpop(i,j,k)  &
          - biotic(n)%r_bio_tau_dop * max(0.0,t_prog(ind_dop)%field(i,j,k,taum1))
      enddo
    enddo
  enddo

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_dop)%th_tendency(i,j,k) = t_prog(ind_dop)%th_tendency(i,j,k) +      &
          biotic(n)%jdop(i,j,k) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  ! SiO4
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jsio4(i,j,k) = biotic(n)%jsio4(i,j,k) -                  &
          biotic(n)%jprod_sio4(i,j,k)
      enddo
    enddo
  enddo

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_sio4)%th_tendency(i,j,k) = t_prog(ind_sio4)%th_tendency(i,j,k) +  &
          biotic(n)%jsio4(i,j,k) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  ! ALK
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_alk)%th_tendency(i,j,k) = t_prog(ind_alk)%th_tendency(i,j,k) + &
          (2.0 * biotic(n)%jcaco3(i,j,k) - biotic(n)%jprod_alk(i,j,k)   &
          - biotic(n)%jno3(i,j,k) + biotic(n)%jnh4(i,j,k)) *            &
          rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  do k = km_c + 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_alk)%th_tendency(i,j,k) = t_prog(ind_alk)%th_tendency(i,j,k) + &
          (2.0 * biotic(n)%jcaco3(i,j,k) - biotic(n)%jno3(i,j,k) +      &
          biotic(n)%jnh4(i,j,k)) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  ! O2

  ! O2 production from nitrate, ammonia and nitrogen fixation and
  ! O2 consumption from production of NH4 from non-sinking particles,
  ! and DOM
  do k = 1, km_c
    do j =jsc, jec
      do i = isc, iec
        biotic(n)%jo2(i,j,k) = (biotic(n)%o_2_no3 *                        &
          biotic(n)%jprod_no3(i,j,k)                                       &
          + biotic(n)%o_2_nh4 * (biotic(n)%jprod_nh4(i,j,k) +              &
          biotic(n)%jprod_n_fix(i,j,k))) * Grid%tmask(i,j,k)

        ! If O2 is present
        if (t_prog(ind_o2)%field(i,j,k,taum1) .gt. biotic(n)%o2_min)       &
             then
          biotic(n)%jo2(i,j,k) = biotic(n)%jo2(i,j,k) - biotic(n)%o_2_nh4 *&
            (biotic(n)%jnh4_graz(i,j,k) + biotic(n)%r_bio_tau_don *        &
            max(0.0,t_prog(ind_don)%field(i,j,k,taum1)) + (1.0 - biotic(n)%phi_don) &
            * biotic(n)%jpon(i,j,k)) +                                     &
            biotic(n)%o_2_c * biotic(n)%jldoc(i,j,k) -                     &
            biotic(n)%o_2_nitrif * biotic(n)%r_bio_tau_nitrif_s *          &
            max(0.0,t_prog(ind_nh4)%field(i,j,k,taum1))
        endif
      enddo
    enddo
  enddo

  ! O2 consumption from production of NH4 from sinking particles and DOM
  ! O2 consumption from nitrification
  do k = km_c + 1, nk
    do j = jsc, jec
      do i = isc, iec
      ! If O2 is present
      if (t_prog(ind_o2)%field(i,j,k,taum1) .gt. biotic(n)%o2_min) then
        biotic(n)%jo2(i,j,k) = - biotic(n)%o_2_nh4 *                       &
          ((1.0 - biotic(n)%phi_don) * biotic(n)%jpon(i,j,k) +             &
          biotic(n)%r_bio_tau_don * max(0.0,t_prog(ind_don)%field(i,j,k,taum1))) +  &
            biotic(n)%o_2_c * biotic(n)%jldoc(i,j,k) -                     &
            biotic(n)%o_2_nitrif * biotic(n)%r_bio_tau_nitrif_d *          &
            max(0.0,t_prog(ind_nh4)%field(i,j,k,taum1))
        else
          biotic(n)%jo2(i,j,k) = 0.0
          endif
      enddo
    enddo
  enddo

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_o2)%th_tendency(i,j,k) = t_prog(ind_o2)%th_tendency(i,j,k) + &
          biotic(n)%jo2(i,j,k) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  ! DIC
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_dic)%th_tendency(i,j,k) = t_prog(ind_dic)%th_tendency(i,j,k) + &
          (biotic(n)%c_2_n * (biotic(n)%jno3(i,j,k) +                             &
          biotic(n)%jnh4(i,j,k)) - biotic(n)%jldoc(i,j,k) +                       &
          biotic(n)%jcaco3(i,j,k) - 0.5 * biotic(n)%jprod_alk(i,j,k)) *           &
          rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  do k = km_c + 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_dic)%th_tendency(i,j,k) = t_prog(ind_dic)%th_tendency(i,j,k) + &
          (biotic(n)%c_2_n * (biotic(n)%jno3(i,j,k)                               &
          + biotic(n)%jnh4(i,j,k)) - biotic(n)%jldoc(i,j,k) +                     &
          biotic(n)%jcaco3(i,j,k)) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

enddo

! Save variables for diagnostics
call diagnose_2d_comp(Time, Grid, id_o2_sat, o2_saturation(:,:))
do n = 1, instances
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_sc_co2, biotic(n)%sc_co2(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_sc_o2, biotic(n)%sc_o2(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_alpha, biotic(n)%alpha(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_csurf, biotic(n)%csurf(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_pco2surf, biotic(n)%pco2surf(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_flux_pon, biotic(n)%flux_pon(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_flux_pop, biotic(n)%flux_pop(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_flux_sio2, biotic(n)%flux_sio2(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_flux_caco3, biotic(n)%flux_caco3(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_htotal, biotic(n)%htotal(:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jprod_alk, biotic(n)%jprod_alk(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jprod_fed, biotic(n)%jprod_fed(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jprod_n_fix, biotic(n)%jprod_n_fix(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jprod_no3, biotic(n)%jprod_no3(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jprod_nh4, biotic(n)%jprod_nh4(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jprod_p_fix, biotic(n)%jprod_p_fix(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jprod_po4, biotic(n)%jprod_po4(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jprod_pofe, biotic(n)%jprod_pofe(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jprod_pon, biotic(n)%jprod_pon(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jprod_pop, biotic(n)%jprod_pop(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jprod_sio4,biotic(n)%jprod_sio4(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jcaco3,biotic(n)%jcaco3(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jfe_ads, biotic(n)%jfe_ads(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jfe_des, biotic(n)%jfe_des(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jfe_graz, biotic(n)%jfe_graz(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jfe_sink, biotic(n)%jfe_sink(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jno3, biotic(n)%jno3(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jnh4, biotic(n)%jnh4(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jnh4_graz, biotic(n)%jnh4_graz(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jpo4, biotic(n)%jpo4(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jpo4_graz, biotic(n)%jpo4_graz(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jpofe, biotic(n)%jpofe(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jpon, biotic(n)%jpon(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jpop, biotic(n)%jpop(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jsio4, biotic(n)%jsio4(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jdenit, biotic(n)%jdenit(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jdon, biotic(n)%jdon(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jdop, biotic(n)%jdop(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jldoc, biotic(n)%jldoc(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jo2, biotic(n)%jo2(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_fpon, biotic(n)%fpon(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_fpop, biotic(n)%fpop(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_fracl, biotic(n)%fracl(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_fsio2, biotic(n)%fsio2(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_fcaco3, biotic(n)%fcaco3(:,:,:))
enddo

return

end subroutine  ocean_bgc_restore_source
! </SUBROUTINE> NAME="ocean_bgc_restore_source"


!#######################################################################
! <SUBROUTINE NAME="ocean_bgc_restore_start">
!
! <DESCRIPTION>
! Initialize variables, read in namelists, calculate constants for a given run
! and allocate diagnostic arrays
! </DESCRIPTION>
subroutine ocean_bgc_restore_start(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,  &
     T_prog, T_diag, taup1, model_time, grid_dat, grid_tmask, grid_kmt,         &
     grid_xt, grid_yt, grid_zt, grid_zw, grid_dzt, grid_name, grid_tracer_axes, &
     mpp_domain2d, rho_dzt)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
type(ocean_diag_tracer_type), dimension(:), intent(in)  :: T_diag
integer, intent(in)                                     :: taup1
type(time_type), intent(in)                             :: model_time
real, dimension(isd:,jsd:), intent(in)                  :: grid_dat
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask
integer, dimension(isd:,jsd:), intent(in)               :: grid_kmt
real, dimension(isd:,jsd:), intent(in)                  :: grid_xt
real, dimension(isd:,jsd:), intent(in)                  :: grid_yt
real, dimension(nk), intent(in)                         :: grid_zt
real, dimension(nk), intent(in)                         :: grid_zw
real, dimension(nk), intent(in)                         :: grid_dzt
character(len=*), intent(in)                            :: grid_name
integer, dimension(3), intent(in)                       :: grid_tracer_axes
type(domain2d), intent(in)                              :: mpp_domain2d
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho_dzt

character(len=64), parameter    :: sub_name = 'ocean_bgc_restore_start'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '): '
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '): '

!----------------------------------------------------------------------
!
!       Global values to apply the following inhibitions
!       and depletions
!
!  coastal_only : if true, then only apply the changes in
!                 coastal boxes
!  t_mask_len   : parameter giving the number of elements in
!                 the time mask per year (eg., 12 would
!                 imply monthly)
!  t_mask_array : logical array controlling whether to apply
!                 the following inhibitions and depletions to
!                 each time-period (true means set the masks,
!                 false means use the defaults everywhere)
!  num_reg      : number of regions
!  factor       : factor by which to scale the field
!               : in the selected regions
!  wlon : western longitude of region
!  elon : eastern longitude of region
!  slat : southern latitude of region
!  nlat : northern latitude of region
!  mask(imt,jmt)  : mask array (0.0 - alternate, 1.0 - normal)
!
!       Set up a mask array using wlon,elon,nlat,slat
!       (any box with its lon,lat inside the box bounded by
!       wlon,elon,nlat,slat value in mask set to factor).
!  
!----------------------------------------------------------------------

integer                                         :: done
integer                                         :: i, j, k, l, m, n
character(len=fm_field_name_len)                :: name
character(len=fm_field_name_len+1)              :: suffix
character(len=fm_field_name_len+3)              :: long_suffix
character(len=256)                              :: caller_str
integer                                         :: len_w
integer                                         :: len_e
integer                                         :: len_s
integer                                         :: len_n
real                                            :: total_alkalinity
real                                            :: total_ammonia
real                                            :: total_dic
real                                            :: total_don
real                                            :: total_dop
real                                            :: total_fediss
real                                            :: total_fepart
real                                            :: total_ldoc
real                                            :: total_o2
real                                            :: total_nitrate
real                                            :: total_phosphate
real                                            :: total_silicate
character(len=fm_string_len), allocatable       :: local_restart_file(:)
logical                                         :: fld_exist
integer                                         :: ind
integer                                         :: id_restart

  integer :: stdoutunit 
  stdoutunit=stdout() 

write(stdoutunit,*) 
write(stdoutunit,*) trim(note_header),                     &
                  'Starting ', trim(package_name), ' module'

! Determine indices for temperature and salinity
indtemp = fm_get_index('/ocean_mod/prog_tracers/temp')
if (indtemp .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the temperature index')
endif

indsal = fm_get_index('/ocean_mod/prog_tracers/salt')
if (indsal .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the salinity index')
endif

! dynamically allocate the global BIOTIC arrays
call allocate_arrays(isc, iec, jsc, jec, nk, isd, ied, jsd, jed)

! save the *global* namelist values
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

call fm_util_start_namelist(package_name, '*global*', caller = caller_str)

dep_dry_file       =  fm_util_get_string ('dep_dry_file', scalar = .true.)
dep_dry_name       =  fm_util_get_string ('dep_dry_name', scalar = .true.)
dep_wet_file       =  fm_util_get_string ('dep_wet_file', scalar = .true.)
dep_wet_name       =  fm_util_get_string ('dep_wet_name', scalar = .true.)
no3_star_file      =  fm_util_get_string ('no3_star_file', scalar = .true.)
no3_star_name      =  fm_util_get_string ('no3_star_name', scalar = .true.)
po4_star_file      =  fm_util_get_string ('po4_star_file', scalar = .true.)
po4_star_name      =  fm_util_get_string ('po4_star_name', scalar = .true.)
sio4_star_file     =  fm_util_get_string ('sio4_star_file', scalar = .true.)
sio4_star_name     =  fm_util_get_string ('sio4_star_name', scalar = .true.)
alk_star_file      =  fm_util_get_string ('alk_star_file', scalar = .true.)
alk_star_name      =  fm_util_get_string ('alk_star_name', scalar = .true.)
fed_star_file      =  fm_util_get_string ('fed_star_file', scalar = .true.)
fed_star_name      =  fm_util_get_string ('fed_star_name', scalar = .true.)
htotal_scale_lo_in =  fm_util_get_real   ('htotal_scale_lo_in', scalar = .true.)
htotal_scale_hi_in =  fm_util_get_real   ('htotal_scale_hi_in', scalar = .true.)
htotal_in          =  fm_util_get_real   ('htotal_in', scalar = .true.)

call fm_util_end_namelist(package_name, '*global*', caller = caller_str)

! Open up the Alk file for restoring
alk_star_id = init_external_field(alk_star_file,                &
                                  alk_star_name,                &
                                  domain = mpp_domain2d)
if (alk_star_id .eq. 0) then
  call mpp_error(FATAL,                                         &
       trim(sub_name) //                                        &
       ': Error: could not open alk_star file: ' //             &
       trim(alk_star_file))
endif

! Open up the Fed file for restoring
fed_star_id = init_external_field(fed_star_file,                &
                                  fed_star_name,                &
                                  domain = mpp_domain2d)
if (alk_star_id .eq. 0) then
  call mpp_error(FATAL,                                         &
       trim(sub_name) //                                        &
       ': Error: could not open fed_star file: ' //             &
       trim(fed_star_file))
endif

! Open up the NO3 file for restoring
no3_star_id = init_external_field(no3_star_file,                &
                                  no3_star_name,                &
                                  domain = mpp_domain2d)
if (no3_star_id .eq. 0) then
  call mpp_error(FATAL,                                         &
       trim(sub_name) //                                        &
       ': Error: could not open no3_star file: ' //             &
       trim(no3_star_file))
endif

! Open up the PO4 file for restoring
po4_star_id = init_external_field(po4_star_file,                &
                                  po4_star_name,                &
                                  domain = mpp_domain2d)
if (po4_star_id .eq. 0) then
  call mpp_error(FATAL,                                         &
       trim(sub_name) //                                        &
       ': Error: could not open po4_star file: ' //             &
       trim(po4_star_file))
endif

! Open up the SiO4 file for restoring
sio4_star_id = init_external_field(sio4_star_file,              &
                                  sio4_star_name,               &
                                  domain = mpp_domain2d)
if (sio4_star_id .eq. 0) then
  call mpp_error(FATAL,                                         &
       trim(sub_name) //                                        &
       ': Error: could not open sio4_star file: ' //            &
       trim(sio4_star_file))
endif

! Open up the files for boundary conditions
dep_wet_id = init_external_field(dep_wet_file,          &
                                     dep_wet_name,          &
                                     domain = mpp_domain2d)
if (dep_wet_id .eq. 0) then
  call mpp_error(FATAL, trim(error_header) //                   &
       'Could not open wet deposition file: ' //          &
       trim(dep_wet_file))
endif

dep_dry_id = init_external_field(dep_dry_file,          &
                                     dep_dry_name,          &
                                     domain = mpp_domain2d)
if (dep_dry_id .eq. 0) then
  call mpp_error(FATAL, trim(error_header) //                   &
       'Could not open dry deposition file: ' //          &
       trim(dep_dry_file))
endif

! set default values for htotal_scale bounds
htotal_scale_lo(:,:) = htotal_scale_lo_in
htotal_scale_hi(:,:) = htotal_scale_hi_in


! read in the namelists for each instance
do n = 1, instances

  call fm_util_start_namelist(package_name, biotic(n)%name, caller = caller_str)

  biotic(n)%compensation_depth     = fm_util_get_real   ('compensation_depth', scalar = .true.)
  biotic(n)%martin_coeff           = fm_util_get_real   ('martin_coeff', scalar = .true.)
  biotic(n)%ca_remin_depth         = fm_util_get_real   ('ca_remin_depth', scalar = .true.)
  biotic(n)%si_remin_depth         = fm_util_get_real   ('si_remin_depth', scalar = .true.)
  biotic(n)%soft_tissue_pump       = fm_util_get_logical('soft_tissue_pump', scalar = .true.)
  biotic(n)%stp_temperature        = fm_util_get_real   ('stp_temperature', scalar = .true.)
  biotic(n)%stp_salinity           = fm_util_get_real   ('stp_salinity', scalar = .true.)
  biotic(n)%stp_alkalinity         = fm_util_get_real   ('stp_alkalinity', scalar = .true.)
  biotic(n)%local_restart_file     = fm_util_get_string ('local_restart_file', scalar = .true.)
  biotic(n)%fe_ballast_assoc       = fm_util_get_logical('fe_ballast_assoc', scalar = .true.)
  biotic(n)%phi_dry                = fm_util_get_real   ('phi_dry', scalar = .true.)
  biotic(n)%phi_wet                = fm_util_get_real   ('phi_wet', scalar = .true.)
  biotic(n)%kfe_org                = fm_util_get_real   ('kfe_org', scalar = .true.)
  biotic(n)%kfe_bal                = fm_util_get_real   ('kfe_bal', scalar = .true.)
  biotic(n)%kfe_des                = fm_util_get_real   ('kfe_des', scalar = .true.)
  biotic(n)%kfe_max_prime          = fm_util_get_real   ('kfe_max_prime', scalar = .true.)
  biotic(n)%mass_2_n               = fm_util_get_real   ('mass_2_n', scalar = .true.)
  biotic(n)%n_2_p                  = fm_util_get_real   ('n_2_p', scalar = .true.)
  biotic(n)%n_2_p_fix              = fm_util_get_real   ('n_2_p_fix', scalar = .true.)
  biotic(n)%c_2_n                  = fm_util_get_real   ('c_2_n', scalar = .true.)
  biotic(n)%o_2_c                  = fm_util_get_real   ('o_2_c', scalar = .true.)
  biotic(n)%o_2_no3                = fm_util_get_real   ('o_2_no3', scalar = .true.)
  biotic(n)%o_2_nh4                = fm_util_get_real   ('o_2_nh4', scalar = .true.)
  biotic(n)%o_2_nitrif             = fm_util_get_real   ('o_2_nitrif', scalar = .true.)
  biotic(n)%o2_min                 = fm_util_get_real   ('o2_min', scalar = .true.)
  biotic(n)%bio_tau                = fm_util_get_real   ('bio_tau', scalar = .true.)
  biotic(n)%bio_tau_don            = fm_util_get_real   ('bio_tau_don', scalar = .true.)
  biotic(n)%bio_tau_dop            = fm_util_get_real   ('bio_tau_dop', scalar = .true.)
  biotic(n)%bio_tau_fix            = fm_util_get_real   ('bio_tau_fix', scalar = .true.)
  biotic(n)%bio_tau_ldoc           = fm_util_get_real   ('bio_tau_ldoc', scalar = .true.)
  biotic(n)%bio_tau_nh4            = fm_util_get_real   ('bio_tau_nh4', scalar = .true.)
  biotic(n)%bio_tau_nitrif_d       = fm_util_get_real   ('bio_tau_nitrif_d', scalar = .true.)
  biotic(n)%bio_tau_nitrif_s       = fm_util_get_real   ('bio_tau_nitrif_s', scalar = .true.)
  biotic(n)%kappa_eppley           = fm_util_get_real   ('kappa_eppley', scalar = .true.)
  biotic(n)%kappa_remin            = fm_util_get_real   ('kappa_remin', scalar = .true.)
  biotic(n)%Prodstar               = fm_util_get_real   ('Prodstar', scalar = .true.)
  biotic(n)%fdets0                 = fm_util_get_real   ('fdets0', scalar = .true.)
  biotic(n)%fdetl0                 = fm_util_get_real   ('fdetl0', scalar = .true.)
  biotic(n)%phi_don                = fm_util_get_real   ('phi_don', scalar = .true.)
  biotic(n)%phi_dop                = fm_util_get_real   ('phi_dop', scalar = .true.)
  biotic(n)%phi_ldoc               = fm_util_get_real   ('phi_ldoc', scalar = .true.)
  biotic(n)%gamma_det              = fm_util_get_real   ('gamma_det', scalar = .true.)
  biotic(n)%remin_density          = fm_util_get_logical('remin_density', scalar = .true.)
  biotic(n)%remin_lability         = fm_util_get_logical('remin_lability', scalar = .true.)
  biotic(n)%remin_ocmip2           = fm_util_get_logical('remin_ocmip2', scalar = .true.)
  biotic(n)%remin_protection       = fm_util_get_logical('remin_protection', scalar = .true.)
  biotic(n)%remin_simple           = fm_util_get_logical('remin_simple', scalar = .true.)
  biotic(n)%remin_temp             = fm_util_get_logical('remin_temp', scalar = .true.)
  biotic(n)%remin_viscosity        = fm_util_get_logical('remin_viscosity', scalar = .true.)
  biotic(n)%remin_zoop_resp        = fm_util_get_logical('remin_zoop_resp', scalar = .true.)
  biotic(n)%rpcaco3                = fm_util_get_real   ('rpcaco3', scalar = .true.)
  biotic(n)%rpsio2                 = fm_util_get_real   ('rpsio2', scalar = .true.)
  biotic(n)%wsink                  = fm_util_get_real   ('wsink', scalar = .true.)
  biotic(n)%sc_co2_0               = fm_util_get_real   ('sc_co2_0', scalar = .true.)
  biotic(n)%sc_co2_1               = fm_util_get_real   ('sc_co2_1', scalar = .true.)
  biotic(n)%sc_co2_2               = fm_util_get_real   ('sc_co2_2', scalar = .true.)
  biotic(n)%sc_co2_3               = fm_util_get_real   ('sc_co2_3', scalar = .true.)
  biotic(n)%sc_o2_0                = fm_util_get_real   ('sc_o2_0', scalar = .true.)
  biotic(n)%sc_o2_1                = fm_util_get_real   ('sc_o2_1', scalar = .true.)
  biotic(n)%sc_o2_2                = fm_util_get_real   ('sc_o2_2', scalar = .true.)
  biotic(n)%sc_o2_3                = fm_util_get_real   ('sc_o2_3', scalar = .true.)

  call fm_util_end_namelist(package_name, biotic(n)%name, caller = caller_str)

  biotic(n)%r_bio_tau          = 1.0 / biotic(n)%bio_tau
  biotic(n)%r_bio_tau_don      = 1.0 / biotic(n)%bio_tau_don
  biotic(n)%r_bio_tau_dop      = 1.0 / biotic(n)%bio_tau_dop
  biotic(n)%r_bio_tau_ldoc     = 1.0 / biotic(n)%bio_tau_ldoc
  biotic(n)%r_bio_tau_nh4      = 1.0 / biotic(n)%bio_tau_nh4
  biotic(n)%r_bio_tau_fix      = 1.0 / biotic(n)%bio_tau_fix
  biotic(n)%r_wsink            = 1.0 / biotic(n)%wsink
  biotic(n)%r_bio_tau_nitrif_s = 1.0 / biotic(n)%bio_tau_nitrif_s
  biotic(n)%r_bio_tau_nitrif_d = 1.0 / biotic(n)%bio_tau_nitrif_d

  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+norm_remin', caller = caller_str)

  biotic(n)%norm_remin%factor        =  fm_util_get_real          ('factor', scalar = .true.)
  biotic(n)%norm_remin%coastal_only  =  fm_util_get_logical       ('coastal_only', scalar = .true.)
  biotic(n)%norm_remin%wlon          => fm_util_get_real_array    ('wlon')
  biotic(n)%norm_remin%elon          => fm_util_get_real_array    ('elon')
  biotic(n)%norm_remin%slat          => fm_util_get_real_array    ('slat')
  biotic(n)%norm_remin%nlat          => fm_util_get_real_array    ('nlat')
  biotic(n)%norm_remin%t_mask        => fm_util_get_logical_array ('t_mask')

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+norm_remin', caller = caller_str)

  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+no_caco3', caller = caller_str)

  biotic(n)%no_caco3%factor          =  fm_util_get_real          ('factor', scalar = .true.)
  biotic(n)%no_caco3%coastal_only    =  fm_util_get_logical       ('coastal_only', scalar = .true.)
  biotic(n)%no_caco3%wlon            => fm_util_get_real_array    ('wlon')
  biotic(n)%no_caco3%elon            => fm_util_get_real_array    ('elon')
  biotic(n)%no_caco3%slat            => fm_util_get_real_array    ('slat')
  biotic(n)%no_caco3%nlat            => fm_util_get_real_array    ('nlat')
  biotic(n)%no_caco3%t_mask          => fm_util_get_logical_array ('t_mask')

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+no_caco3', caller = caller_str)

  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+nut_depl', caller = caller_str)

  biotic(n)%nut_depl%factor          =  fm_util_get_real          ('factor', scalar = .true.)
  biotic(n)%nut_depl%coastal_only    =  fm_util_get_logical       ('coastal_only', scalar = .true.)
  biotic(n)%nut_depl%wlon            => fm_util_get_real_array    ('wlon')
  biotic(n)%nut_depl%elon            => fm_util_get_real_array    ('elon')
  biotic(n)%nut_depl%slat            => fm_util_get_real_array    ('slat')
  biotic(n)%nut_depl%nlat            => fm_util_get_real_array    ('nlat')
  biotic(n)%nut_depl%t_mask          => fm_util_get_logical_array ('t_mask')

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+nut_depl', caller = caller_str)

  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+r_bio_tau_prod', caller = caller_str)

  biotic(n)%r_bio_tau_prod%factor       =  fm_util_get_real          ('factor', scalar = .true.)
  biotic(n)%r_bio_tau_prod%coastal_only =  fm_util_get_logical       ('coastal_only', scalar = .true.)
  biotic(n)%r_bio_tau_prod%wlon         => fm_util_get_real_array    ('wlon')
  biotic(n)%r_bio_tau_prod%elon         => fm_util_get_real_array    ('elon')
  biotic(n)%r_bio_tau_prod%slat         => fm_util_get_real_array    ('slat')
  biotic(n)%r_bio_tau_prod%nlat         => fm_util_get_real_array    ('nlat')
  biotic(n)%r_bio_tau_prod%t_mask       => fm_util_get_logical_array ('t_mask')

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+r_bio_tau_prod', caller = caller_str)

enddo


! calculate the index for the box containing the compensation depth
km_c_max = 0
do n = 1, instances
  call locate(grid_zw, nk, biotic(n)%compensation_depth,        &
              biotic(n)%km_c, nearest = .true.)
  if (grid_zw(biotic(n)%km_c) .lt.                              &
      biotic(n)%compensation_depth) then
    biotic(n)%km_c = biotic(n)%km_c + 1
  endif

  write (stdoutunit,*) trim(note_header),                         &
                     'The compensation depth for instance ',    &
                     n, ', ', biotic(n)%compensation_depth,     &
                     ' m, occurs in box ', biotic(n)%km_c ,     &
                     ' between depths ',                        &
                     grid_zw(biotic(n)%km_c-1),                 &
                     ' m and ', grid_zw(biotic(n)%km_c), ' m'
  km_c_max = max(km_c_max, biotic(n)%km_c)
enddo

! read in the norm_remin namelist data
do n = 1, instances

  if (associated(biotic(n)%norm_remin%wlon)) then
    len_w = size(biotic(n)%norm_remin%wlon)
  else
    len_w = 0
  endif
  if (associated(biotic(n)%norm_remin%elon)) then
    len_e = size(biotic(n)%norm_remin%elon)
  else
    len_e = 0
  endif
  if (associated(biotic(n)%norm_remin%slat)) then
    len_s = size(biotic(n)%norm_remin%slat)
  else
    len_s = 0
  endif
  if (associated(biotic(n)%norm_remin%nlat)) then
    len_n = size(biotic(n)%norm_remin%nlat)
  else
    len_n = 0
  endif

  if (len_e .ne. len_w .or. len_w .ne. len_s .or. len_s .ne. len_n) then
    call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal for ' // trim(biotic(n)%name))
  endif

  if (size(biotic(n)%norm_remin%t_mask) .ne. 12) then
    call mpp_error(FATAL, trim(error_header) // ' t_mask size is not 12 for ' // trim(biotic(n)%name))
  endif

  ! set all of the values to the default
  biotic(n)%norm_remin%mask(:,:,:) = 1.0

  if (len_w .gt. 0) then

    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header), 'Process norm_remin array for ', trim(biotic(n)%name)
    write (stdoutunit,*)

    ! set values for this time-level
    done = 0
    do l = 1, 12
      if (biotic(n)%norm_remin%t_mask(l)) then
        if (done .eq. 0) then

          ! set the values via the input values, saving this time index
          ! afterwards
          write (stdoutunit,*) 'Assigning month ', l
          call set_array(biotic(n)%norm_remin%mask(:,:,l),        &
                  isd, ied, jsd, jed, grid_xt, grid_yt, grid_kmt, &
                  len_w, biotic(n)%norm_remin%wlon,               &
                  biotic(n)%norm_remin%elon,                      &
                  biotic(n)%norm_remin%slat,                      &
                  biotic(n)%norm_remin%nlat,                      &
                  biotic(n)%norm_remin%factor, 1.0,               &
                  'Normal remineralization', biotic(n)%norm_remin%coastal_only)
          done = l
        else
          ! Duplicate the values for a previous time-level
          write (stdoutunit,*) 'Duplicating month ', done, ' as ', l
          biotic(n)%norm_remin%mask(:,:,l) = biotic(n)%norm_remin%mask(:,:,done)
        endif
      endif
    enddo
  endif

enddo

! read in the no_caco3 namelist data
do n = 1, instances

  if (associated(biotic(n)%no_caco3%wlon)) then
    len_w = size(biotic(n)%no_caco3%wlon)
  else
    len_w = 0
  endif
  if (associated(biotic(n)%no_caco3%elon)) then
    len_e = size(biotic(n)%no_caco3%elon)
  else
    len_e = 0
  endif
  if (associated(biotic(n)%no_caco3%slat)) then
    len_s = size(biotic(n)%no_caco3%slat)
  else
    len_s = 0
  endif
  if (associated(biotic(n)%no_caco3%nlat)) then
    len_n = size(biotic(n)%no_caco3%nlat)
  else
    len_n = 0
  endif

  if (len_e .ne. len_w .or. len_w .ne. len_s .or. len_s .ne. len_n) then
    call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal for ' // trim(biotic(n)%name))
  endif

  if (size(biotic(n)%no_caco3%t_mask) .ne. 12) then
    call mpp_error(FATAL, trim(error_header) // ' t_mask size is not 12 for ' // trim(biotic(n)%name))
  endif

  ! set all of the values to the default
  biotic(n)%no_caco3%mask(:,:,:) = 1.0

  if (len_w .gt. 0) then

    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header), 'Process no_caco3 array for ', trim(biotic(n)%name)
    write (stdoutunit,*)

    ! set values for this time-level
    done = 0
    do l = 1, 12
      if (biotic(n)%no_caco3%t_mask(l)) then
        if (done .eq. 0) then

          ! set the values via the input values, saving this time index
          ! afterwards
          write (stdoutunit,*) 'Assigning month ', l
          call set_array(biotic(n)%no_caco3%mask(:,:,l),                &
                  isd, ied, jsd, jed, grid_xt, grid_yt, grid_kmt,       &
                  len_w, biotic(n)%no_caco3%wlon,                       &
                  biotic(n)%no_caco3%elon,                              &
                  biotic(n)%no_caco3%slat,                              &
                  biotic(n)%no_caco3%nlat,                              &
                  biotic(n)%no_caco3%factor, 1.0,                       &
                  'Carbonate inhibition', biotic(n)%no_caco3%coastal_only)
          done = l
        else

          ! Duplicate the values for a previous time-level
          write (stdoutunit,*) 'Duplicating month ', done, ' as ', l
          biotic(n)%no_caco3%mask(:,:,l) = biotic(n)%no_caco3%mask(:,:,done)
        endif
      endif
    enddo
  endif

enddo

! read in the nut_depl namelist data
do n = 1, instances

  if (associated(biotic(n)%nut_depl%wlon)) then
    len_w = size(biotic(n)%nut_depl%wlon)
  else
    len_w = 0
  endif
  if (associated(biotic(n)%nut_depl%elon)) then
    len_e = size(biotic(n)%nut_depl%elon)
  else
    len_e = 0
  endif
  if (associated(biotic(n)%nut_depl%slat)) then
    len_s = size(biotic(n)%nut_depl%slat)
  else
    len_s = 0
  endif
  if (associated(biotic(n)%nut_depl%nlat)) then
    len_n = size(biotic(n)%nut_depl%nlat)
  else
    len_n = 0
  endif

  if (len_e .ne. len_w .or. len_w .ne. len_s .or. len_s .ne. len_n) then
    call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal for ' // trim(biotic(n)%name))
  endif

  if (size(biotic(n)%nut_depl%t_mask) .ne. 12) then
    call mpp_error(FATAL, trim(error_header) // ' t_mask size is not 12 for ' // trim(biotic(n)%name))
  endif

  ! set all of the values to the default
  biotic(n)%nut_depl%mask(:,:,:) = 1.0

  if (len_w .gt. 0) then

    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header), 'Process nut_depl array for ', trim(biotic(n)%name)
    write (stdoutunit,*)

    ! set values for this time-level
    done = 0
    do l = 1, 12
      if (biotic(n)%nut_depl%t_mask(l)) then
        if (done .eq. 0) then

           ! set the values via the input values, saving this time index
           ! afterwards
          write (stdoutunit,*) 'Assigning month ', l
          call set_array(biotic(n)%nut_depl%mask(:,:,l),                &
                  isd, ied, jsd, jed, grid_xt, grid_yt, grid_kmt,       &
                  len_w, biotic(n)%nut_depl%wlon,                       &
                  biotic(n)%nut_depl%elon,                              &
                  biotic(n)%nut_depl%slat,                              &
                  biotic(n)%nut_depl%nlat,                              &
                  biotic(n)%nut_depl%factor, 1.0,                       &
                  'Nutrient depletion', biotic(n)%nut_depl%coastal_only)
          done = l
        else

          ! Duplicate the values for a previous time-level
          write (stdoutunit,*) 'Duplicating month ', done, ' as ', l
          biotic(n)%nut_depl%mask(:,:,l) = biotic(n)%nut_depl%mask(:,:,done)
        endif
      endif
    enddo
  endif

enddo

! read in the r_bio_tau_prod namelist data
do n = 1, instances

  if (associated(biotic(n)%r_bio_tau_prod%wlon)) then
    len_w = size(biotic(n)%r_bio_tau_prod%wlon)
  else
    len_w = 0
  endif
  if (associated(biotic(n)%r_bio_tau_prod%elon)) then
    len_e = size(biotic(n)%r_bio_tau_prod%elon)
  else
    len_e = 0
  endif
  if (associated(biotic(n)%r_bio_tau_prod%slat)) then
    len_s = size(biotic(n)%r_bio_tau_prod%slat)
  else
    len_s = 0
  endif
  if (associated(biotic(n)%r_bio_tau_prod%nlat)) then
    len_n = size(biotic(n)%r_bio_tau_prod%nlat)
  else
    len_n = 0
  endif

  if (len_e .ne. len_w .or. len_w .ne. len_s .or. len_s .ne. len_n) then
    call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal for ' // trim(biotic(n)%name))
  endif

  if (size(biotic(n)%r_bio_tau_prod%t_mask) .ne. 12) then
    call mpp_error(FATAL, trim(error_header) // ' t_mask size is not 12 for ' // trim(biotic(n)%name))
  endif

  ! set all of the values to the default
  biotic(n)%r_bio_tau_prod%mask(:,:,:) = 1.0

  if (len_w .gt. 0) then

    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header), 'Process r_bio_tau_prod array for ', trim(biotic(n)%name)
    write (stdoutunit,*)

    ! set values for this time-level
    done = 0
    do l = 1, 12
      if (biotic(n)%r_bio_tau_prod%t_mask(l)) then
        if (done .eq. 0) then

          ! set the values via the input values, saving this time index
          ! afterwards
          write (stdoutunit,*) 'Assigning month ', l
          call set_array(biotic(n)%r_bio_tau_prod%mask(:,:,l),             &
                  isd, ied, jsd, jed, grid_xt, grid_yt, grid_kmt,       &
                  len_w, biotic(n)%r_bio_tau_prod%wlon,                    &
                  biotic(n)%r_bio_tau_prod%elon,                           &
                  biotic(n)%r_bio_tau_prod%slat,                           &
                  biotic(n)%r_bio_tau_prod%nlat,                           &
                  biotic(n)%r_bio_tau_prod%factor, 1.0,                    &
                  'Primary production limitation', biotic(n)%r_bio_tau_prod%coastal_only)
          done = l
        else

          ! Duplicate the values for a previous time-level
          write (stdoutunit,*) 'Duplicating month ', done, ' as ', l
          biotic(n)%r_bio_tau_prod%mask(:,:,l) = biotic(n)%r_bio_tau_prod%mask(:,:,done)
        endif
      endif
    enddo
  endif

enddo

! multiply by the restoring factor
do n = 1, instances
  biotic(n)%r_bio_tau_prod%mask(:,:,:) =                                &
       biotic(n)%r_bio_tau * biotic(n)%r_bio_tau_prod%mask(:,:,:)
enddo

! calculate the index for the box containing the compensation depth
km_c_max = 0
do n = 1, instances
  call locate(grid_zw, nk, biotic(n)%compensation_depth,        &
              biotic(n)%km_c, nearest = .true.)
  if (grid_zw(biotic(n)%km_c) .lt.                              &
      biotic(n)%compensation_depth) then
    biotic(n)%km_c = biotic(n)%km_c + 1
  endif

  write (stdoutunit,*) trim(note_header),                         &
                     'The compensation depth for instance ',    &
                     n, ', ', biotic(n)%compensation_depth,     &
                     ' m, occurs in box ', biotic(n)%km_c ,     &
                     ' between depths ',                        &
                     grid_zw(biotic(n)%km_c-1),                 &
                     ' m and ', grid_zw(biotic(n)%km_c), ' m'
  km_c_max = max(km_c_max, biotic(n)%km_c)
enddo

! read in the norm_remin namelist data
do n = 1, instances
  if (associated(biotic(n)%norm_remin%wlon)) then
    len_w = size(biotic(n)%norm_remin%wlon)
  else
    len_w = 0
  endif
  if (associated(biotic(n)%norm_remin%elon)) then
    len_e = size(biotic(n)%norm_remin%elon)
  else
    len_e = 0
  endif
  if (associated(biotic(n)%norm_remin%slat)) then
    len_s = size(biotic(n)%norm_remin%slat)
  else
    len_s = 0
  endif
  if (associated(biotic(n)%norm_remin%nlat)) then
    len_n = size(biotic(n)%norm_remin%nlat)
  else
    len_n = 0
  endif

  if (len_e .ne. len_w .or. len_w .ne. len_s .or. len_s .ne. len_n) then
    call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal for ' // trim(biotic(n)%name))
  endif

  if (size(biotic(n)%norm_remin%t_mask) .ne. 12) then
    call mpp_error(FATAL, trim(error_header) // ' t_mask size is not 12 for ' // trim(biotic(n)%name))
  endif

  ! set all of the values to the default
  biotic(n)%norm_remin%mask(:,:,:) = 1.0

  if (len_w .gt. 0) then

    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header), 'Process norm_remin array for ', trim(biotic(n)%name)
    write (stdoutunit,*)

    ! set values for this time-level
    done = 0
    do l = 1, 12
      if (biotic(n)%norm_remin%t_mask(l)) then
        if (done .eq. 0) then

          ! set the values via the input values, saving this time index
          ! afterwards
          write (stdoutunit,*) 'Assigning month ', l
          call set_array(biotic(n)%norm_remin%mask(:,:,l),        &
                  isd, ied, jsd, jed, grid_xt, grid_yt, grid_kmt, &
                  len_w, biotic(n)%norm_remin%wlon,               &
                  biotic(n)%norm_remin%elon,                      &
                  biotic(n)%norm_remin%slat,                      &
                  biotic(n)%norm_remin%nlat,                      &
                  biotic(n)%norm_remin%factor, 1.0,               &
                  'Normal remineralization', biotic(n)%norm_remin%coastal_only)
          done = l
        else

          ! Duplicate the values for a previous time-level
          write (stdoutunit,*) 'Duplicating month ', done, ' as ', l
          biotic(n)%norm_remin%mask(:,:,l) = biotic(n)%norm_remin%mask(:,:,done)
        endif
      endif
    enddo
  endif

enddo

! read in the no_caco3 namelist data
do n = 1, instances

  if (associated(biotic(n)%no_caco3%wlon)) then
    len_w = size(biotic(n)%no_caco3%wlon)
  else
    len_w = 0
  endif
  if (associated(biotic(n)%no_caco3%elon)) then
    len_e = size(biotic(n)%no_caco3%elon)
  else
    len_e = 0
  endif
  if (associated(biotic(n)%no_caco3%slat)) then
    len_s = size(biotic(n)%no_caco3%slat)
  else
    len_s = 0
  endif
  if (associated(biotic(n)%no_caco3%nlat)) then
    len_n = size(biotic(n)%no_caco3%nlat)
  else
    len_n = 0
  endif

  if (len_e .ne. len_w .or. len_w .ne. len_s .or. len_s .ne. len_n) then
    call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal for ' // trim(biotic(n)%name))
  endif

  if (size(biotic(n)%no_caco3%t_mask) .ne. 12) then
    call mpp_error(FATAL, trim(error_header) // ' t_mask size is not 12 for ' // trim(biotic(n)%name))
  endif

  ! set all of the values to the default
  biotic(n)%no_caco3%mask(:,:,:) = 1.0

  if (len_w .gt. 0) then

    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header), 'Process no_caco3 array for ', trim(biotic(n)%name)
    write (stdoutunit,*)

    ! set values for this time-level
    done = 0
    do l = 1, 12
      if (biotic(n)%no_caco3%t_mask(l)) then
        if (done .eq. 0) then
          ! set the values via the input values, saving this time index
          ! afterwards
          write (stdoutunit,*) 'Assigning month ', l
          call set_array(biotic(n)%no_caco3%mask(:,:,l),                &
                  isd, ied, jsd, jed, grid_xt, grid_yt, grid_kmt,       &
                  len_w, biotic(n)%no_caco3%wlon,                       &
                  biotic(n)%no_caco3%elon,                              &
                  biotic(n)%no_caco3%slat,                              &
                  biotic(n)%no_caco3%nlat,                              &
                  biotic(n)%no_caco3%factor, 1.0,                       &
                  'Carbonate inhibition', biotic(n)%no_caco3%coastal_only)
          done = l
        else
          ! Duplicate the values for a previous time-level
          write (stdoutunit,*) 'Duplicating month ', done, ' as ', l
          biotic(n)%no_caco3%mask(:,:,l) = biotic(n)%no_caco3%mask(:,:,done)
        endif
      endif
    enddo
  endif

enddo

! read in the nut_depl namelist data
do n = 1, instances
  if (associated(biotic(n)%nut_depl%wlon)) then
    len_w = size(biotic(n)%nut_depl%wlon)
  else
    len_w = 0
  endif
  if (associated(biotic(n)%nut_depl%elon)) then
    len_e = size(biotic(n)%nut_depl%elon)
  else
    len_e = 0
  endif
  if (associated(biotic(n)%nut_depl%slat)) then
    len_s = size(biotic(n)%nut_depl%slat)
  else
    len_s = 0
  endif
  if (associated(biotic(n)%nut_depl%nlat)) then
    len_n = size(biotic(n)%nut_depl%nlat)
  else
    len_n = 0
  endif

  if (len_e .ne. len_w .or. len_w .ne. len_s .or. len_s .ne. len_n) then
    call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal for ' // trim(biotic(n)%name))
  endif

  if (size(biotic(n)%nut_depl%t_mask) .ne. 12) then
    call mpp_error(FATAL, trim(error_header) // ' t_mask size is not 12 for ' // trim(biotic(n)%name))
  endif

  ! set all of the values to the default
  biotic(n)%nut_depl%mask(:,:,:) = 1.0

  if (len_w .gt. 0) then

    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header), 'Process nut_depl array for ', trim(biotic(n)%name)
    write (stdoutunit,*)

    ! set values for this time-level
    done = 0
    do l = 1, 12
      if (biotic(n)%nut_depl%t_mask(l)) then
        if (done .eq. 0) then

          ! set the values via the input values, saving this time index
          ! afterwards
          write (stdoutunit,*) 'Assigning month ', l
          call set_array(biotic(n)%nut_depl%mask(:,:,l),                &
                  isd, ied, jsd, jed, grid_xt, grid_yt, grid_kmt,       &
                  len_w, biotic(n)%nut_depl%wlon,                       &
                  biotic(n)%nut_depl%elon,                              &
                  biotic(n)%nut_depl%slat,                              &
                  biotic(n)%nut_depl%nlat,                              &
                  biotic(n)%nut_depl%factor, 1.0,                       &
                  'Nutrient depletion', biotic(n)%nut_depl%coastal_only)
          done = l
        else
          ! Duplicate the values for a previous time-level
          write (stdoutunit,*) 'Duplicating month ', done, ' as ', l
          biotic(n)%nut_depl%mask(:,:,l) = biotic(n)%nut_depl%mask(:,:,done)
        endif
      endif
    enddo 
  endif

enddo

! read in the r_bio_tau_prod namelist data
do n = 1, instances

  if (associated(biotic(n)%r_bio_tau_prod%wlon)) then
    len_w = size(biotic(n)%r_bio_tau_prod%wlon)
  else
    len_w = 0
  endif
  if (associated(biotic(n)%r_bio_tau_prod%elon)) then
    len_e = size(biotic(n)%r_bio_tau_prod%elon)
  else
    len_e = 0
  endif
  if (associated(biotic(n)%r_bio_tau_prod%slat)) then
    len_s = size(biotic(n)%r_bio_tau_prod%slat)
  else
    len_s = 0
  endif
  if (associated(biotic(n)%r_bio_tau_prod%nlat)) then
    len_n = size(biotic(n)%r_bio_tau_prod%nlat)
  else
    len_n = 0
  endif

  if (len_e .ne. len_w .or. len_w .ne. len_s .or. len_s .ne. len_n) then
    call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal for ' // trim(biotic(n)%name))
  endif

  if (size(biotic(n)%r_bio_tau_prod%t_mask) .ne. 12) then
    call mpp_error(FATAL, trim(error_header) // ' t_mask size is not 12 for ' // trim(biotic(n)%name))
  endif

  ! set all of the values to the default
  biotic(n)%r_bio_tau_prod%mask(:,:,:) = 1.0

  if (len_w .gt. 0) then

    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header), 'Process r_bio_tau_prod array for ', trim(biotic(n)%name)
    write (stdoutunit,*)

    ! set values for this time-level
    done = 0
    do l = 1, 12
      if (biotic(n)%r_bio_tau_prod%t_mask(l)) then
        if (done .eq. 0) then
          ! set the values via the input values, saving this time index
          ! afterwards
          write (stdoutunit,*) 'Assigning month ', l
          call set_array(biotic(n)%r_bio_tau_prod%mask(:,:,l),             &
                  isd, ied, jsd, jed, grid_xt, grid_yt, grid_kmt,       &
                  len_w, biotic(n)%r_bio_tau_prod%wlon,                    &
                  biotic(n)%r_bio_tau_prod%elon,                           &
                  biotic(n)%r_bio_tau_prod%slat,                           &
                  biotic(n)%r_bio_tau_prod%nlat,                           &
                  biotic(n)%r_bio_tau_prod%factor, 1.0,                    &
                  'Primary production limitation', biotic(n)%r_bio_tau_prod%coastal_only)
          done = l
        else
          ! Duplicate the values for a previous time-level
          write (stdoutunit,*) 'Duplicating month ', done, ' as ', l
          biotic(n)%r_bio_tau_prod%mask(:,:,l) = biotic(n)%r_bio_tau_prod%mask(:,:,done)
        endif
      endif
    enddo
  endif

enddo

! multiply by the restoring factor
do n = 1, instances
  biotic(n)%r_bio_tau_prod%mask(:,:,:) =                                &
       biotic(n)%r_bio_tau * biotic(n)%r_bio_tau_prod%mask(:,:,:)
enddo

! initialize special arrays for remineralization
do n = 1, instances
  do k = 1, nk
    biotic(n)%r_intzscale_n(k) = biotic(n)%gamma_det /        &
        biotic(n)%wsink * grid_dzt(k)
    biotic(n)%r_1plusintzscale_n(k) = 1.0 / (1.0 +            &
        biotic(n)%r_intzscale_n(k))
    biotic(n)%r_1plusintzscale_si(k) = 1.0 / (1.0 +           &
        grid_dzt(k) / biotic(n)%si_remin_depth)
    biotic(n)%r_1plusintzscale_ca(k) = 1.0 / (1.0 +           &
        grid_dzt(k) / biotic(n)%ca_remin_depth)
    biotic(n)%zforg(k) = (grid_zw(k) /                        &
          biotic(n)%compensation_depth) ** (-biotic(n)%martin_coeff)
  enddo
enddo

! Read in additional information for a restart.

! We must process all of the instances before restoring any files
! as all fields must be registered before the fields are
! restored, and fields from different instances may be in the
! same file.

! Note that the restart file names here must be different from
! those for the tracer values.

allocate(restart(instances))
allocate(local_restart_file(instances))

write(stdoutunit,*)

do n = 1, instances

   ! Set the suffix for this instance (if instance name is "_",
   ! then use a blank suffix).

  if (biotic(n)%name(1:1) .eq. '_') then
    suffix = ' '
  else
    suffix = '_' // biotic(n)%name
  endif

  ! Check whether we are already using this restart file, if so,
  ! we do not want to duplicate it in the list of restart files
  ! since we only read each restart file once.

  ind = 0
  do l = 1, num_restart
    if (biotic(n)%local_restart_file == local_restart_file(l)) then
      ind = l
      exit
    endif
  end do

  if (ind .eq. 0) then
    num_restart = num_restart + 1
    ind = num_restart
    local_restart_file(ind) = trim(biotic(n)%local_restart_file)
  end if

  ! Check whether the field already exists in the restart file.
  ! If not, then set a default value.

  fld_exist = field_exist('INPUT/' // trim(biotic(n)%local_restart_file), 'htotal' // trim(suffix) )

  if ( fld_exist ) then
    write (stdoutunit,*) trim(note_header),                       &
         'Reading additional information for instance ',        &
         ': Initializing instance ', trim(biotic(n)%name)
  else
    write (stdoutunit,*) trim(note_header),                       &
         'Initializing instance ', trim(biotic(n)%name)
    biotic(n)%htotal(:,:) = htotal_in
  endif

  ! Register the field for restart
  id_restart = register_restart_field(restart(ind), biotic(n)%local_restart_file,       &
                    'htotal' // trim(suffix), biotic(n)%htotal,                         &
                    domain=mpp_domain2d, mandatory=fld_exist )

enddo

! Restore the restart fields if the file exists
do l = 1, num_restart
  if (file_exist('INPUT/' // trim(local_restart_file(l)))) then
    call restore_state(restart(l))
  end if
end do

deallocate(local_restart_file)

! Set up analyses

! register the fields

suffix = '_' // package_name
long_suffix = ' (' // trim(package_name) // ')'

id_o2_sat = register_diag_field(trim(diag_name),                        &
     'o2_saturation' // trim(suffix), grid_tracer_axes(1:2),            &
     model_time, 'O2 saturation' // trim(long_suffix), ' ',             &
     missing_value = -1.0e+10)

do n = 1, instances

  if (biotic(n)%name(1:1) .eq. '_') then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // biotic(n)%name
    long_suffix = ' (' // trim(biotic(n)%name) // ')'
  endif


  biotic(n)%id_sc_co2 = register_diag_field(trim(diag_name),                    &
       'sc_co2' // trim(suffix), grid_tracer_axes(1:2),                         &
       model_time, 'Schmidt number - CO2' // trim(long_suffix), ' ',            &
       missing_value = -1.0e+10)

  biotic(n)%id_sc_o2 = register_diag_field(trim(diag_name),                     &
       'sc_o2' // trim(suffix), grid_tracer_axes(1:2),                          &
       model_time, 'Schmidt number - O2' // trim(long_suffix), ' ',             &
       missing_value = -1.0e+10)

  biotic(n)%id_sfc_flux_co2 = register_diag_field(trim(diag_name),              &
       'sfc_flux_co2' // trim(suffix), grid_tracer_axes(1:2),                   &
       model_time, 'Surface Flux - CO2' // trim(long_suffix), 'mol m^-2 s^-1',  &
       missing_value = -1.0e+10)

  biotic(n)%id_sfc_flux_o2 = register_diag_field(trim(diag_name),               &
       'sfc_flux_o2' // trim(suffix), grid_tracer_axes(1:2),                    &
       model_time, 'Surface Flux - O2' // trim(long_suffix), 'mol m^-2 s^-1',   &
       missing_value = -1.0e+10)

  biotic(n)%id_sfc_flux_fed = register_diag_field(trim(diag_name),              &
       'sfc_flux_fed' // trim(suffix), grid_tracer_axes(1:2),                   &
       model_time, 'Surface Flux - Fed' // trim(long_suffix), 'mol m^-2 s^-1',  &
       missing_value = -1.0e+10)

  biotic(n)%id_alpha = register_diag_field(trim(diag_name),                     &
       'alpha'// trim(suffix), grid_tracer_axes(1:2),                           &
       model_time, 'Alpha CO2' // trim(long_suffix), ' ',                       &
       missing_value = -1.0e+10)

  biotic(n)%id_csurf = register_diag_field(trim(diag_name),                     &
       'csurf'// trim(suffix), grid_tracer_axes(1:2),                           &
       model_time, 'CO2* water' // trim(long_suffix), ' ',                      &
       missing_value = -1.0e+10)

  biotic(n)%id_pco2surf = register_diag_field(trim(diag_name),                  &
       'pco2surf'// trim(suffix), grid_tracer_axes(1:2),                        &
       model_time, 'Oceanic pCO2' // trim(long_suffix), ' ',                    &
       missing_value = -1.0e+10)

  biotic(n)%id_flux_pon = register_diag_field(trim(diag_name),                  &
       'flux_pon'// trim(suffix), grid_tracer_axes(1:2),                        &
       model_time, 'PON flux' // trim(long_suffix), ' ',                        &
       missing_value = -1.0e+10)

  biotic(n)%id_flux_pop = register_diag_field(trim(diag_name),                  &
       'flux_pop'// trim(suffix), grid_tracer_axes(1:2),                        &
       model_time, 'POP flux' // trim(long_suffix), ' ',                        &
       missing_value = -1.0e+10)

  biotic(n)%id_flux_sio2 = register_diag_field(trim(diag_name),                 &
       'flux_sio2'// trim(suffix), grid_tracer_axes(1:2),                       &
       model_time, 'Si flux' // trim(long_suffix), ' ',                         &
       missing_value = -1.0e+10)

  biotic(n)%id_flux_caco3 = register_diag_field(trim(diag_name),                &
       'flux_caco3'// trim(suffix), grid_tracer_axes(1:2),                      &
       model_time, 'CaCO3 flux' // trim(long_suffix), ' ',                      &
       missing_value = -1.0e+10)

  biotic(n)%id_htotal = register_diag_field(trim(diag_name),                    &
       'htotal'// trim(suffix), grid_tracer_axes(1:2),                          &
       model_time, 'H+ ion concentration' // trim(long_suffix), ' ',            &
       missing_value = -1.0e+10)

  biotic(n)%id_jprod_alk = register_diag_field(trim(diag_name),                         &
       'jprod_alk'// trim(suffix), grid_tracer_axes(1:3),                               &
       model_time, 'Restoring alkalinity-based production' // trim(long_suffix), ' ',   &
       missing_value = -1.0e+10)

  biotic(n)%id_jprod_fed = register_diag_field(trim(diag_name),                         &
       'jprod_fed'// trim(suffix), grid_tracer_axes(1:3),                               &
       model_time, 'Restoring iron-based production' // trim(long_suffix), ' ',         &
       missing_value = -1.0e+10)

  biotic(n)%id_jprod_n_fix = register_diag_field(trim(diag_name),                       &
       'jprod_n_fix'// trim(suffix), grid_tracer_axes(1:3),                             &
       model_time, 'Nitrogen fixation' // trim(long_suffix), ' ',                       &
       missing_value = -1.0e+10)

  biotic(n)%id_jprod_no3 = register_diag_field(trim(diag_name),                         &
       'jprod_no3'// trim(suffix), grid_tracer_axes(1:3),                               &
       model_time, 'Restoring NO3-based production' // trim(long_suffix), ' ',          &
       missing_value = -1.0e+10)

  biotic(n)%id_jprod_nh4 = register_diag_field(trim(diag_name),                         &
       'jprod_nh4'// trim(suffix), grid_tracer_axes(1:3),                               &
       model_time, 'NH4-based production' // trim(long_suffix), ' ',                    &
       missing_value = -1.0e+10)

  biotic(n)%id_jprod_p_fix = register_diag_field(trim(diag_name),                       &
       'jprod_p_fix'// trim(suffix), grid_tracer_axes(1:3),                             &
       model_time, 'PO4 in nitrogen fixation' // trim(long_suffix), ' ',                &
       missing_value = -1.0e+10)

  biotic(n)%id_jprod_po4 = register_diag_field(trim(diag_name),                         &
       'jprod_po4'// trim(suffix), grid_tracer_axes(1:3),                               &
       model_time, 'Restoring PO4-based production' // trim(long_suffix), ' ',          &
       missing_value = -1.0e+10)

  biotic(n)%id_jprod_pofe = register_diag_field(trim(diag_name),                        &
       'jprod_pofe'// trim(suffix), grid_tracer_axes(1:3),                              &
       model_time, 'Detrital iron production' // trim(long_suffix), ' ',                &
       missing_value = -1.0e+10)

  biotic(n)%id_jprod_pon = register_diag_field(trim(diag_name),                         &
       'jprod_pon'// trim(suffix), grid_tracer_axes(1:3),                               &
       model_time, 'Detrital nitrogen production' // trim(long_suffix), ' ',            &
       missing_value = -1.0e+10)

  biotic(n)%id_jprod_pop = register_diag_field(trim(diag_name),                         &
       'jprod_pop'// trim(suffix), grid_tracer_axes(1:3),                               &
       model_time, 'Detrital phosphorus production' // trim(long_suffix), ' ',          &
       missing_value = -1.0e+10)

  biotic(n)%id_jprod_sio4 = register_diag_field(trim(diag_name),                        &
       'jprod_sio4'// trim(suffix), grid_tracer_axes(1:3),                              &
       model_time, 'Restoring Si-based production' // trim(long_suffix), ' ',           &
       missing_value = -1.0e+10)

  biotic(n)%id_jcaco3 = register_diag_field(trim(diag_name),                            &
       'jcaco3'// trim(suffix), grid_tracer_axes(1:3),                                  &
       model_time, 'CaCO3 change' // trim(long_suffix), ' ',                            &
       missing_value = -1.0e+10)

  biotic(n)%id_jfe_ads = register_diag_field(trim(diag_name),                           &
       'jfe_ads'// trim(suffix), grid_tracer_axes(1:3),                                 &
       model_time, 'Iron adsorption' // trim(long_suffix), ' ',                         &
       missing_value = -1.0e+10)

  biotic(n)%id_jfe_des = register_diag_field(trim(diag_name),                           &
       'jfe_des'// trim(suffix), grid_tracer_axes(1:3),                                 &
       model_time, 'Iron desorption' // trim(long_suffix), ' ',                         &
       missing_value = -1.0e+10)

  biotic(n)%id_jfe_graz = register_diag_field(trim(diag_name),                          &
       'jfe_graz'// trim(suffix), grid_tracer_axes(1:3),                                &
       model_time, 'Dissolved iron source from grazing' // trim(long_suffix), ' ',      &
       missing_value = -1.0e+10)

  biotic(n)%id_jfe_sink = register_diag_field(trim(diag_name),                          &
       'jfe_sink'// trim(suffix), grid_tracer_axes(1:3),                                &
       model_time, 'Particulate iron sinking' // trim(long_suffix), ' ',                &
       missing_value = -1.0e+10)

  biotic(n)%id_jno3 = register_diag_field(trim(diag_name),                              &
       'jno3'// trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'NO3 source' // trim(long_suffix), ' ',                              &
       missing_value = -1.0e+10)

  biotic(n)%id_jnh4 = register_diag_field(trim(diag_name),                              &
       'jnh4'// trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'NH4 source' // trim(long_suffix), ' ',                              &
       missing_value = -1.0e+10)

  biotic(n)%id_jnh4_graz = register_diag_field(trim(diag_name),                         &
       'jnh4_graz'// trim(suffix), grid_tracer_axes(1:3),                               &
       model_time, 'NH4 source from grazing' // trim(long_suffix), ' ',                 &
       missing_value = -1.0e+10)

  biotic(n)%id_jpo4_graz = register_diag_field(trim(diag_name),                         &
       'jpo4_graz'// trim(suffix), grid_tracer_axes(1:3),                               &
       model_time, 'PO4 source from grazing' // trim(long_suffix), ' ',                 &
       missing_value = -1.0e+10)

  biotic(n)%id_jpo4 = register_diag_field(trim(diag_name),                              &
       'jpo4'// trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'PO4 source' // trim(long_suffix), ' ',                              &
       missing_value = -1.0e+10)

  biotic(n)%id_jpofe = register_diag_field(trim(diag_name),                             &
       'jpofe'// trim(suffix), grid_tracer_axes(1:3),                                   &
       model_time, 'Loss of sinking iron' // trim(long_suffix), ' ',                    &
       missing_value = -1.0e+10)

  biotic(n)%id_jpon = register_diag_field(trim(diag_name),                              &
       'jpon'// trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'Loss of sinking nitrogen' // trim(long_suffix), ' ',                &
       missing_value = -1.0e+10)

  biotic(n)%id_jpop = register_diag_field(trim(diag_name),                              &
       'jpop'// trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'Loss of sinking phosphorus' // trim(long_suffix), ' ',              &
       missing_value = -1.0e+10)

  biotic(n)%id_jsio4 = register_diag_field(trim(diag_name),                             &
       'jsio4'// trim(suffix), grid_tracer_axes(1:3),                                   &
       model_time, 'SiO4 source' // trim(long_suffix), ' ',                             &
       missing_value = -1.0e+10)

  biotic(n)%id_jdenit = register_diag_field(trim(diag_name),                            &
       'jdenit'// trim(suffix), grid_tracer_axes(1:3),                                  &
       model_time, 'Denitrification' // trim(long_suffix), ' ',                         &
       missing_value = -1.0e+10)

  biotic(n)%id_jdon = register_diag_field(trim(diag_name),                              &
       'jdon'// trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'DON source' // trim(long_suffix), ' ',                              &
       missing_value = -1.0e+10)

  biotic(n)%id_jdop = register_diag_field(trim(diag_name),                              &
       'jdop'// trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'DOP source' // trim(long_suffix), ' ',                              &
       missing_value = -1.0e+10)

  biotic(n)%id_jldoc = register_diag_field(trim(diag_name),                             &
       'jldoc'// trim(suffix), grid_tracer_axes(1:3),                                   &
       model_time, 'Labile DOC source' // trim(long_suffix), ' ',                       &
       missing_value = -1.0e+10)

  biotic(n)%id_jo2 = register_diag_field(trim(diag_name),                               &
       'jo2'// trim(suffix), grid_tracer_axes(1:3),                                     &
       model_time, 'O2 source' // trim(long_suffix), ' ',                               &
       missing_value = -1.0e+10)

  biotic(n)%id_fpon = register_diag_field(trim(diag_name),                              &
       'fpon'// trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'PON change' // trim(long_suffix), ' ',                              &
       missing_value = -1.0e+10)

  biotic(n)%id_fpop = register_diag_field(trim(diag_name),                              &
       'fpop'// trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'POP change' // trim(long_suffix), ' ',                              &
       missing_value = -1.0e+10)

  biotic(n)%id_fracl = register_diag_field(trim(diag_name),                             &
       'fracl'// trim(suffix), grid_tracer_axes(1:3),                                   &
       model_time, 'Fraction large phytoplankton' // trim(long_suffix), ' ',            &
       missing_value = -1.0e+10)

  biotic(n)%id_fsio2 = register_diag_field(trim(diag_name),                             &
       'fsio2'// trim(suffix), grid_tracer_axes(1:3),                                   &
       model_time, 'Si change' // trim(long_suffix), ' ',                               &
       missing_value = -1.0e+10)

  biotic(n)%id_fcaco3 = register_diag_field(trim(diag_name),                            &
       'fcaco3'// trim(suffix), grid_tracer_axes(1:3),                                  &
       model_time, 'CaCO3 change' // trim(long_suffix), ' ',                            &
       missing_value = -1.0e+10)

enddo

! integrate the total concentrations of some tracers
! for the start of the run

! Use taup1 time index for the start of a run, and taup1 time
! index for the end of a run so that we are integrating the
! same time level and should therefore get identical results

do n = 1, instances
  total_alkalinity = 0.0
  total_ammonia = 0.0
  total_dic = 0.0
  total_don = 0.0
  total_dop = 0.0
  total_fediss = 0.0
  total_fepart = 0.0
  total_ldoc = 0.0
  total_nitrate = 0.0
  total_o2 = 0.0
  total_phosphate = 0.0
  total_silicate = 0.0
  do k = 1,nk
    do j = jsc, jec
      do i = isc, iec
        total_nitrate = total_nitrate +                         &
             t_prog(biotic(n)%ind_no3)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_ammonia = total_ammonia +                         &
             t_prog(biotic(n)%ind_nh4)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_phosphate = total_phosphate +                     &
             t_prog(biotic(n)%ind_po4)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_fediss = total_fediss +                           &
             t_prog(biotic(n)%ind_fed)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_fepart = total_fepart +                           &
             t_diag(biotic(n)%ind_fep)%field(i,j,k) *           &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_silicate = total_silicate +                       &
             t_prog(biotic(n)%ind_sio4)%field(i,j,k,taup1) *    &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_don = total_don +                                 &
             t_prog(biotic(n)%ind_don)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_dop = total_dop +                                 &
             t_prog(biotic(n)%ind_dop)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_ldoc = total_ldoc +                               &
             t_prog(biotic(n)%ind_ldoc)%field(i,j,k,taup1) *    &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_o2 = total_o2 +                                   &
             t_prog(biotic(n)%ind_o2)%field(i,j,k,taup1) *      &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_dic = total_dic +                                 &
             t_prog(biotic(n)%ind_dic)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_alkalinity = total_alkalinity +                   &
             t_prog(biotic(n)%ind_alk)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo

  call mpp_sum(total_nitrate)
  call mpp_sum(total_ammonia)
  call mpp_sum(total_phosphate)
  call mpp_sum(total_fediss)
  call mpp_sum(total_fepart)
  call mpp_sum(total_silicate)
  call mpp_sum(total_don)
  call mpp_sum(total_dop)
  call mpp_sum(total_ldoc)
  call mpp_sum(total_o2)
  call mpp_sum(total_dic)
  call mpp_sum(total_alkalinity)

  write (stdoutunit,*) '  Instance ', trim(biotic(n)%name)
  write (stdoutunit,                                              &
         '(/'' Total nitrate  = '',es19.12,'' Gmol-N'')')       &
              total_nitrate * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total ammonia  = '',es19.12,'' Gmol-N'')')       &
              total_ammonia * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total phosphate  = '',es19.12,'' Gmol-P'')')     &
              total_phosphate * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total fediss  = '',es19.12,'' Gmol-Fe'')')       &
              total_fediss * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total fepart  = '',es19.12,'' Gmol-Fe'')')       &
              total_fepart * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total silicate  = '',es19.12,'' Gmol-Si'')')     &
              total_silicate * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total DON  = '',es19.12,'' Gmol-C'')')           &
              total_DON * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total DOP  = '',es19.12,'' Gmol-P'')')           &
              total_DOP * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total LDOC  = '',es19.12,'' Gmol-C'')')          &
              total_LDOC * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total O2  = '',es19.12,'' Gmol-O'')')            &
              total_o2 * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total DIC  = '',es19.12,'' Gmol-C'')')           &
              total_dic * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total alkalinity  = '',es19.12,'' Geq'')')       &
              total_alkalinity * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total nitrogen  = '',es19.12,'' Gmol-N'')')      &
              (total_nitrate + total_don) * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total phosphorus  = '',es19.12,'' Gmol-P'')')    &
              (total_phosphate + total_dop) * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total real O2  = '',es19.12,'' Gmol-O'')')       &
              (total_o2 + biotic(n)%o_2_no3 * total_nitrate) * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total Carbon  = '',es19.12,'' Gmol-C'')')        &
              (total_dic + biotic(n)%c_2_n * total_don + total_ldoc) * 1.0e-09
  write (stdoutunit,                                              &
         '(/'' Total real alkalinity  = '',es19.12,'' Geq'')')  &
              (total_alkalinity + total_nitrate) * 1.0e-09
enddo

write(stdoutunit,*)
write(stdoutunit,*) trim(note_header), 'Tracer runs initialized'
write(stdoutunit,*)

return

end subroutine  ocean_bgc_restore_start
! </SUBROUTINE> NAME="ocean_bgc_restore_start"

!#######################################################################
! <SUBROUTINE NAME="set_array">
!
! <DESCRIPTION>
!       Set up an array covering the model domain with a user-specified
!       value, in user-specified regions. There are a given number of
!       2-d regions specified by the values slat, nlat, wlon and elon.
!       The longitudes are for a cyclic domain, and if wlon and elon
!       are on opposite sides of the cut, the correct thing will
!       be done. Elon is considered to be east of wlon, so if elon is
!       less than wlon, then the region east of elon to the cut will be
!       filled, and the region from the cut to wlon will be filled.
!
!       After setting up the array in this routine, it may prove useful
!       to allow fine-tuning the settings via an array in a namelist.
!
!       Arguments:
!         Input:
!      num_regions = number of user-specified regions which will be
!                    filled
!
!             wlon = 1-d array of western (starting) longitudes for the
!                    rectangular regions
!
!             elon = 1-d array of eastern (ending) longitudes for the
!                    rectangular regions
!
!             slat = 1-d array of southern (starting) latitudes for the
!                    rectangular regions
!
!             nlat = 1-d array of northern (ending) latitudes for the
!                    rectangular regions
!
!                       Note: if slat >= nlat, then nothing is done
!                             for that region
!
!        set_value = the value to assign to array in the user-specified
!                    regions
!
!      unset_value = the value to assign to array outside of the
!                    user-specified regions
!
!             name = character variable used in informative messages
!
!     coastal_only = true to limit changes only to coastal points
!                    (i.e., at least one bordering point is land)
!
!         Output:
!
!            array = 2-d array which will contain the set- and unset-
!                    values. The array is assumed to have a border
!                    one unit wide on all edges, ala MOM. A cyclic
!                    boundary condition will be set if requested.
! </DESCRIPTION>
!

subroutine set_array(array, isd, ied, jsd, jed,                 &
                     xt, yt, kmt,                               &
                     num_regions, wlon_in, elon_in, slat, nlat, &
                     set_value, unset_value, name,              &
                     coastal_only)

integer, intent(in)                             :: isd
integer, intent(in)                             :: ied
integer, intent(in)                             :: jsd
integer, intent(in)                             :: jed
integer, intent(in)                             :: num_regions
real, dimension(isd:,jsd:), intent(out)         :: array
logical, intent(in)                             :: coastal_only
real, dimension(num_regions), intent(in)        :: elon_in
integer, dimension(isd:,jsd:), intent(in)       :: kmt
character(len=*), intent(in)                    :: name
real, dimension(num_regions), intent(in)        :: nlat
real, intent(in)                                :: set_value
real, dimension(num_regions), intent(in)        :: slat
real, intent(in)                                :: unset_value
real, dimension(num_regions), intent(in)        :: wlon_in
real, dimension(isd:,jsd:), intent(in)          :: xt
real, dimension(isd:,jsd:), intent(in)          :: yt

character(len=64), parameter    :: sub_name = 'set_array'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer :: i, j, n
real, dimension(:), allocatable :: wlon
real, dimension(:), allocatable :: elon

  integer :: stdoutunit 
  stdoutunit=stdout() 

  ! save the longitudes in case they need to be modified

allocate(wlon(num_regions))
allocate(elon(num_regions))

wlon(:) = wlon_in(:)
elon(:) = elon_in(:)

! loop over the regions, applying changes as necessary

do n = 1, num_regions

  if (nlat(n) .ge. slat(n)) then
    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header),                          &
                       trim(name), ' region: ', n

    ! make sure that all longitudes are in the range [0,360]
    do while (wlon(n) .gt. 360.0)
      wlon(n) = wlon(n) - 360.0
    enddo
    do while (wlon(n) .lt. 0.0)
      wlon(n) = wlon(n) + 360.0
    enddo
    do while (elon(n) .gt. 360.0)
      elon(n) = elon(n) - 360.0
    enddo
    do while (elon(n) .lt. 0.0)
      elon(n) = elon(n) + 360.0
    enddo

    ! if the southern and northern latitudes are the same, then
    ! find the grid box which encompasses them ...

    if (slat(n) .eq. nlat(n)) then

     call mpp_error(FATAL, trim(error_header) //                &
                    'Equal latitudes not supported')

    elseif (wlon(n) .eq. elon(n)) then

     call mpp_error(FATAL, trim(error_header) //                &
                    'Equal longitudes not supported')

    else
       ! ... else find all boxes where the center lies in the
       ! rectangular region
      do j = jsd, jed
        do i = isd, ied
          if (nlat(n) .ge. yt(i,j) .and.                        &
              slat(n) .le. yt(i,j) .and.                        &
              lon_between(xt(i,j), wlon(n), elon(n))) then
            array(i,j) = set_value
          endif
        enddo
      enddo
    endif
  endif
enddo

! if desired only apply mask to coastal regions

if (coastal_only) then
  do j = jsd, jed
    do i = isd, ied
      if (kmt(i,j) .ne. 0 .and.                         &
          array(i,j) .eq. set_value) then

         ! if all the surrounding points are ocean, then this is not
         ! a coastal point, therefore reset the mask

        if (kmt(i-1,j) .ne. 0 .and.                     &
            kmt(i+1,j) .ne. 0 .and.                     &
            kmt(i,j-1) .ne. 0 .and.                     &
            kmt(i,j+1) .ne. 0) then
          array(i,j) = unset_value
        endif
      endif
    enddo
  enddo
endif

! clean up

deallocate(wlon)
deallocate(elon)

return

contains

!
!       Return true if w <= x_in <= e, taking into account the
!       periodicity of longitude.
!
!       x_in    = value to test
!
!       w       = west longitude of boundary
!
!       e       = east longitude of boundary
!

function lon_between(x_in, w, e)

logical :: lon_between

real, intent(in)                :: x_in
real, intent(in)                :: w
real, intent(in)                :: e

real                    :: x

! Save input values so we may modify them safely

x = x_in

! make sure that all longitudes are in the range [0,360]

do while (x .gt. 360.0)
  x = x - 360.0
enddo
do while (x .lt. 0.0)
  x = x + 360.0
enddo
 
if (w .gt. e) then
  lon_between = w .le. x .or. x .le. e
else
  lon_between = w .le. x .and. x .le. e
endif

return

end function  lon_between

end subroutine  set_array
! </SUBROUTINE> NAME="set_array"

end module  ocean_bgc_restore_mod

      module mo_chemdr_mod

      implicit none

      private
      public :: chemdr

!     save

character(len=128), parameter :: version     = '$Id: mo_chemdr.F90,v 19.0 2012/01/06 20:33:18 fms Exp $'
character(len=128), parameter :: tagname     = '$Name: tikal $'
logical                       :: module_is_initialized = .false.

      contains

! <SUBROUTINE NAME="chemdr">
!   <OVERVIEW>
!     Tropospheric chemistry driver
!   </OVERVIEW>
!   <DESCRIPTION>
!     This subroutine calculates chemical production and loss of trace species,
!     using the MOZART chemical mechanism and solver.
!     Species and reactions can be modified using MOZART chemical pre-processor.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call chemdr( vmr, Time, lat, lon, delt, ps, ptop, pmid, pdel, &
!                  zma, zi, cldfr, cwat, tfld, inv_data, sh, &
!                  albedo, coszen, esfact, &
!                  prod_out, loss_out, sulfate, psc, &
!                  do_interactive_h2o, solar_phase, imp_slv_nonconv, plonl,&
!                  prod_ox, loss_ox )
!   </TEMPLATE>
!   <IN NAME="Time" TYPE="time_type">
!     Model time
!   </INOUT>
!   <IN NAME="lat" TYPE="real" DIM="(:)">
!     The latitudes for the local domain.
!   </IN>
!   <IN NAME="lon" TYPE="real" DIM="(:)">
!     The longitudes for the local domain.
!   </IN>
!   <IN NAME="delt" TYPE="real">
!     Model timestep (s)
!   </IN>
!   <IN NAME="pmid" TYPE="real" DIM="(:,:)">
!     Pressure on the model full levels (Pa)
!   </IN>
!   <IN NAME="pdel" TYPE="real" DIM="(:,:)">
!     Pressure thickness of model layers (Pa)
!   </IN>
!   <IN NAME="ps" TYPE="real" DIM="(:)">
!     Model surface pressure (Pa)
!   </IN>
!   <IN NAME="ptop" TYPE="real" DIM="(:)">
!     Pressure at model top (Pa)
!   </IN>
!   <IN NAME="zma" TYPE="real" DIM="(:,:)">
!     Model full level absolute geopotential heights (m)
!   </IN>
!   <IN NAME="zi" TYPE="real" DIM="(:,:)">
!     Model half level absolute geopotential heights (m)
!   </IN>
!   <IN NAME="coszen" TYPE="real" DIM="(:)">
!     Cosine of solar zenith angle
!   </IN>
!   <IN NAME="albedo" TYPE="real" DIM="(:)">
!     Surface albedo
!   </IN>
!   <IN NAME="cldfr" TYPE="real" DIM="(:,:)">
!     Cloud fraction
!   </IN>
!   <IN NAME="cwat" TYPE="real" DIM="(:,:)">
!     Cloud liquid+ice water (kg/kg)
!   </IN>
!   <IN NAME="cwat" TYPE="real" DIM="(:,:)">
!     Cloud liquid+ice water (kg/kg)
!   </IN>
!   <IN NAME="tfld" TYPE="real" DIM="(:,:)">
!     Model temperature (K)
!   </IN>
!   <IN NAME="sh" TYPE="real" DIM="(:,:)">
!     Model specific humidity (kg/kg)
!   </IN>
!   <IN NAME="sulfate" TYPE="real" DIM="(:,:)">
!     Off-line sulfate aerosol volume mixing ratio (mol/mol)
!   </IN>
!   <IN NAME="psc" TYPE="psc_type">
!     Polar stratospheric cloud amounts
!   </IN>
!   <IN NAME="solar_phase" TYPE="real">
!     Solar cycle phase (1=max, 0=min)
!   </IN>
!   <IN NAME="esfact" TYPE="real">
!     Earth-sun distance factor (r_avg/r)^2
!   </IN>
!   <IN NAME="inv_data" TYPE="real" DIM="(:,:,:)">
!     Volume mixing ratios of "invariant" species (mol/mol)
!   </IN>
!   <IN NAME="do_interactive_h2o" TYPE="logical">
!     Include water vapor sources/sinks?
!   </IN>
!   <INOUT NAME="vmr" TYPE="real" DIM="(:,:,:)">
!     Trace species volume mixing ratio (mol/mol)
!   </INOUT>
!   <OUT NAME="prod_out" TYPE="real" DIM="(:,:,:)">
!     Trace species photochemical production rates (mol/mol/s)
!   </OUT>
!   <OUT NAME="loss_out" TYPE="real" DIM="(:,:,:)">
!     Trace species photochemical loss rates (mol/mol/s)
!   </OUT>
!   <OUT NAME="imp_slv_nonconv" TYPE="real" DIM="(:,:)">
!     Flag for implicit solver non-convergence (fraction)
!   </OUT>
!   <OUT NAME="prod_ox" TYPE="real" DIM="(:,:)">
!     output for ox production
!   </OUT>
!   <OUT NAME="loss_ox" TYPE="real" DIM="(:,:)">
!     output for ox loss
!   </OUT>
! prod_ox and loss_ox are added to chemdr. (jmao, 1/1/2011)
! r,phalf, pwt and j_ndx are added for fastjx.(jmao,1/1/2011)
      subroutine chemdr( vmr, &
                         r, &
                         phalf,&
                         pwt , &
                         do_fastjx_photo,&      
                         use_lsc_in_fastjx, &
                         j_ndx, &
                         Time, &
                         lat, lon, &
                         delt, &
                         ps, ptop, pmid, pdel, &
                         zma, zi, &
                         cldfr, cwat, tfld, inv_data, sh, &
                         albedo, coszen, esfact, &
                         prod_out, loss_out, jvals_out, rate_const_out, sulfate, psc, &
                         do_interactive_h2o, solar_phase, imp_slv_nonconv, &
                         plonl, prod_ox, loss_ox, retain_cm3_bugs, &
                         check_convergence )
!-----------------------------------------------------------------------
!     ... Chem_solver advances the volumetric mixing ratio
!         forward one time step via a combination of explicit,
!         ebi, hov, fully implicit, and/or rodas algorithms.
!-----------------------------------------------------------------------

      use chem_mods_mod,    only : indexm, nadv_mass, phtcnt, gascnt, rxntot, clscnt1, clscnt4, clscnt5, &
                                   ncol_abs, grpcnt, nfs, extcnt, hetcnt
      use mo_photo_mod,     only : set_ub_col, setcol, photo, &
                                   sundis
      use mo_exp_sol_mod,   only : exp_sol
      use mo_imp_sol_mod,   only : imp_sol
      use mo_rodas_sol_mod, only : rodas_sol
      use mo_usrrxt_mod,    only : usrrxt
      use mo_setinv_mod,    only : setinv
      use mo_setrxt_mod,    only : setrxt
      use mo_adjrxt_mod,    only : adjrxt
      use mo_phtadj_mod,    only : phtadj
      use mo_setsox_mod,    only : setsox
      use mo_fphoto_mod,    only : fphoto
      use mo_chem_utls_mod, only : inti_mr_xform, adjh2o, negtrc, mmr2vmr, vmr2mmr, &
                                   get_spc_ndx, get_grp_mem_ndx
      use time_manager_mod, only : time_type
      use strat_chem_utilities_mod, only : psc_type

      implicit none

!-----------------------------------------------------------------------
!        ... Dummy arguments
!-----------------------------------------------------------------------
      type(time_type), intent(in) :: Time             ! time
      real,    intent(in) ::  lat(:), lon(:)          ! latitude, longitude
      integer, intent(in) ::  plonl
      real,    intent(in) ::  delt                    ! timestep in seconds
      real, intent(inout) ::  vmr(:,:,:)              ! transported species ( vmr )
      integer, intent(in) ::  j_ndx             
      logical, intent(in) ::  do_fastjx_photo         ! true = use fastjx photo
      logical, intent(in) ::  use_lsc_in_fastjx        ! true = use lsc clouds in fastjx calc
      real, intent(in)    ::  r(:,:,:)                ! the original r species
      real, dimension(:), intent(in) :: &
                              ps, &                   ! surface press ( pascals )
                              ptop, &                 ! model top pressure (pascals)
!                             oro, &                  ! surface orography flag
                              albedo, &               ! surface albedo
                              coszen                  ! cosine of solar zenith angle
!                             tsurf, &                ! surface temperature
!                             phis, &                 ! surf geopot
!                             cldtop                  ! cloud top level ( 1 ... plev )
      real, dimension(:,:), intent(in) :: &
                              pmid, &                 ! midpoint press ( pascals )
                              pdel, &                 ! delta press across midpoints
                              zma, &                  ! abs geopot height at midpoints ( m )
                              cldfr, &                ! cloud fraction
!                             cmfdqr, &               ! dq/dt for convective rainout
!                             nrain, &                ! release of strt precip ( 1/s )
!                             nevapr, &               ! evap precip ( 1/s )
                              cwat, &                 ! total cloud water (kg/kg)
                              tfld, &                 ! midpoint temperature
                              sh, &                   ! specific humidity ( kg/kg )
                              sulfate, &              ! sulfate aerosol
                              phalf,   &              ! pressure at boundaries (Pa)
                              pwt
      type(psc_type), intent(in) :: &
                              psc                     ! polar stratospheric clouds (PSCs)
      real, intent(in) ::     solar_phase, &          ! solar cycle phase (1=max, 0=min)
                              esfact                  ! earth-sun distance factor (r_avg/r)^2
      real, dimension(:,:), intent(in) :: &
                              zi                      ! abs geopot height at interfaces ( m )
      real, dimension(:,:,:), intent(out) :: &
                              prod_out, &             ! chemical production rate
                              loss_out                ! chemical loss rate
      real, dimension(:,:),   intent(out) :: &        
                              prod_ox, &              ! chemical production rate, defined as (nlon,nlev)(jmao,1/1/2011)
                              loss_ox                 ! chemical loss rate(jmao,1/1/2011)      
      real, dimension(:,:,:), intent(out) :: &
                              jvals_out               ! photolysis rates (J-values, s^-1)
      real, dimension(:,:,:), intent(out) :: &
                              rate_const_out          ! kinetic rxn rate constants (cm^3 molec^-1 s^-1 for 2nd order)
      real, dimension(:,:,:), intent(in) :: &
                              inv_data                ! invariant species
      real, dimension(:,:), intent(out) :: &
                              imp_slv_nonconv         ! flag for implicit solver non-convergence (fraction)
      logical, intent(in) ::  do_interactive_h2o      ! include h2o sources/sinks
      logical, intent(in) ::  retain_cm3_bugs        ! retain cm3 bugs ?
      logical, intent(in) ::  check_convergence      ! check convergence of implicit solver solution ?

!-----------------------------------------------------------------------
!             ... Local variables
!-----------------------------------------------------------------------
      integer, parameter :: inst = 1, avrg = 2
      integer  ::  k
      integer  :: i
      integer  :: ox_ndx, o3s_ndx
      integer  :: troplev(plonl)
      real, parameter    :: ztrop_low = 5.  
                                     ! lowest tropopause level allowed (km)
      real, parameter    :: ztrop_high = 20.  
                                    ! highest tropopause level allowed (km)
      real, parameter    :: max_dtdz   = 2.  
                             ! max dt/dz for tropopause level (degrees k/km)
      real     :: dt
      real, dimension(plonl,SIZE(vmr,2))    :: k_loss_ox   
                                       ! Loss rate coefficient of Ox (s-1)
!     integer  ::  ox_ndx, o3_ndx
      integer  ::  so2_ndx, so4_ndx
      real     ::  invariants(plonl,SIZE(vmr,2),max(1,nfs))
      real     ::  col_dens(plonl,SIZE(vmr,2),max(1,ncol_abs))                  ! column densities (molecules/cm^2)
      real     ::  col_delta(plonl,0:SIZE(vmr,2),max(1,ncol_abs))               ! layer column densities (molecules/cm^2)
      real     ::  het_rates(plonl,SIZE(vmr,2),max(1,hetcnt))
      real     ::  extfrc(plonl,SIZE(vmr,2),max(1,extcnt))
      real     ::  reaction_rates(plonl,SIZE(vmr,2),rxntot)
      real, dimension(plonl,SIZE(vmr,2)) :: &
                   h2ovmr, &             ! water vapor volume mixing ratio
                   mbar, &               ! mean wet atmospheric mass ( amu )
                   zmid                  ! midpoint geopotential in km
      real, dimension(plonl,SIZE(zi,2)) :: &
                   zint                  ! interface geopotential in km
      integer :: plev, plevp, plnplv, num_invar
      integer :: nstep

      plev = SIZE(vmr,2)
      plevp = SIZE(zi,2)
      plnplv = plonl*plev
      num_invar = SIZE(invariants,3)
      nstep = 0
      
      
!-----------------------------------------------------------------------      
!        ... Initialize xform between mass and volume mixing ratios
!-----------------------------------------------------------------------      
      call inti_mr_xform( sh, mbar, plonl )
!-----------------------------------------------------------------------      
!        ... Xform from mmr to vmr
!-----------------------------------------------------------------------      
!     call mmr2vmr( vmr, mmr, mbar, plonl )
!-----------------------------------------------------------------------      
!        ... Xform water vapor from mmr to vmr and adjust in stratosphere
!-----------------------------------------------------------------------      
      call adjh2o( h2ovmr, sh, mbar, vmr, do_interactive_h2o, plonl )
!-----------------------------------------------------------------------      
!        ... Xform geopotential height from m to km 
!            and pressure from hPa to mb
!-----------------------------------------------------------------------      
      do k = 1,plev
         zmid(:,k) = 1.e-3 * zma(:,k)
         zint(:,k) = 1.e-3 * zi(:,k)
      end do
      zint(:,plevp) = 1.e-3 * zi(:,plevp)

      if( nfs > 0 ) then
!-----------------------------------------------------------------------      
!        ... Set the "invariants"
!-----------------------------------------------------------------------      
         call setinv( invariants, tfld, h2ovmr, pmid, inv_data, &
                      do_interactive_h2o, plonl )
      end if
      if( ncol_abs > 0 .and. phtcnt > 0 ) then
!-----------------------------------------------------------------------      
!        ... Xform family ox assuming that all ox is o3
!-----------------------------------------------------------------------      
!        ox_ndx = get_spc_ndx( 'OX' )
!        if( ox_ndx > 0 ) then
!           o3_ndx = get_grp_mem_ndx( 'O3' )
!           if( o3_ndx > 0 ) then
!              vmr(:,:,ox_ndx) = mbar(:,:) * mmr(:,:,ox_ndx) / nadv_mass(o3_ndx)
!           end if
!        end if
!-----------------------------------------------------------------------      
!        ... Set the column densities at the upper boundary
!-----------------------------------------------------------------------      
         call set_ub_col( col_delta, vmr, invariants, pdel, ptop, plonl )
      end if
      if( gascnt > 0 ) then
!-----------------------------------------------------------------------      
!       ...  Set rates for "tabular" and user specified reactions
!-----------------------------------------------------------------------      
         call setrxt( reaction_rates, tfld, invariants(:,:,indexm), plonl, plev, plnplv )
!        call sulf_interp( lat, ip, pmid, caldayn, sulfate, plonl )
         call usrrxt( reaction_rates, tfld, invariants, h2ovmr, pmid, &
                      invariants(:,:,indexm), sulfate, psc, vmr, sh, delt, plonl )
!-----------------------------------------------------------------------      
!       ...  Save reaction rate constants for diagnostic output
!-----------------------------------------------------------------------      
         rate_const_out(:,:,:) = reaction_rates(:,:,phtcnt+1:rxntot)
!-----------------------------------------------------------------------      
!       ...  History output for instantaneous reaction rates
!-----------------------------------------------------------------------      
!        do file = 1,moz_file_cnt
!           if( hfile(file)%wrhstts .and. hfile(file)%histout_cnt(9,inst) > 0 ) then
!              do m = 1,hfile(file)%histout_cnt(9,inst)
!                  fldname = hfile(file)%hist_inst(hfile(file)%histout_ind(9,inst)+m-1)
!                  hndx    = hfile(file)%inst_map(hfile(file)%histout_ind(9,inst)+m-1)
!                 call outfld( fldname, reaction_rates(1,1,hndx+phtcnt), plonl, ip, lat, file )
!              end do
!           end if
!-----------------------------------------------------------------------      
!       ...  History output for time averaged reaction rates
!-----------------------------------------------------------------------      
!           do m = 1,hfile(file)%histout_cnt(9,avrg)
!               fldname = hfile(file)%hist_timav(hfile(file)%histout_ind(9,avrg)+m-1)
!               hndx = hfile(file)%timav_map(hfile(file)%histout_ind(9,avrg)+m-1)
!              call outfld( fldname, reaction_rates(1,1,hndx+phtcnt), plonl, ip, lat, file )
!           end do
!        end do
         call adjrxt( reaction_rates, invariants, invariants(:,:,indexm), &
                      plnplv )
      end if
      
      if( phtcnt > 0 ) then
!-----------------------------------------------------------------------
!        ... Compute the photolysis rates
!-----------------------------------------------------------------------      
         if( ncol_abs > 0 ) then
!-----------------------------------------------------------------------      
!             ... Set the column densities
!-----------------------------------------------------------------------      
            call setcol( col_delta, col_dens, pdel, plonl )
         end if
!-----------------------------------------------------------------------      
!             ... Calculate the surface albedo
!-----------------------------------------------------------------------      
!        call srfalb( lat, ip, albs, caldayn, tsurf, plonl )
!-----------------------------------------------------------------------      
!             ... Calculate the photodissociation rates
!-----------------------------------------------------------------------      
         if (.not. do_fastjx_photo) then
           call photo( reaction_rates(:,:,:phtcnt), pmid, pdel, tfld, zmid, &
                     col_dens, &
!                    zen_angle, albs, &
                     coszen, albedo, &
                     cwat, cldfr, &
!                    sunon, sunoff, &
                     esfact, solar_phase, plonl )
         else    
            call fphoto( reaction_rates(:,:,:phtcnt), &
                         pmid, pdel, &
                         tfld, zmid, &
                         col_dens, &
                         coszen, albedo, &
                         j_ndx, &
                         cwat, &
                         cldfr,  &
                         esfact, solar_phase, plonl,&           
                         use_lsc_in_fastjx, &
                         phalf,&
                         zi,&
                         pwt , &
                         sh, &
                         r &            
                          )
         end if

!-----------------------------------------------------------------------      
!       ...  History output for instantaneous photo rates
!-----------------------------------------------------------------------      
!        do file = 1,moz_file_cnt
!           if( hfile(file)%wrhstts .and. hfile(file)%histout_cnt(8,inst) > 0 ) then
!              do m = 1,hfile(file)%histout_cnt(8,inst)
!                 fldname = hfile(file)%hist_inst(hfile(file)%histout_ind(8,inst)+m-1)
!                  hndx    = hfile(file)%inst_map(hfile(file)%histout_ind(8,inst)+m-1)
!                 call outfld( fldname, reaction_rates(1,1,hndx), plonl, ip, lat, file )
!              end do
!           end if
!-----------------------------------------------------------------------      
!       ...  History output for time averaged photo rates
!-----------------------------------------------------------------------      
!           do m = 1,hfile(file)%histout_cnt(8,avrg)
!               fldname = hfile(file)%hist_timav(hfile(file)%histout_ind(8,avrg)+m-1)
!               hndx    = hfile(file)%timav_map(hfile(file)%histout_ind(8,avrg)+m-1)
!              call outfld( fldname, reaction_rates(1,1,hndx), plonl, ip, lat, file )
!           end do
!        end do
!-----------------------------------------------------------------------      
!       ...  Save photolysis rates for diagnostic output
!-----------------------------------------------------------------------      
         jvals_out(:,:,:) = reaction_rates(:,:,:phtcnt)
!-----------------------------------------------------------------------      
!             ... Adjust the photodissociation rates
!-----------------------------------------------------------------------      
         call phtadj( reaction_rates, invariants, invariants(:,:,indexm), &
                      plnplv )
      end if
      if( hetcnt > 0 ) then
!-----------------------------------------------------------------------
!        ... Compute the heterogeneous rates at time = t(n+1)
!-----------------------------------------------------------------------      
!        call sethet( het_rates, pmid, lat, zmid, phis, &
!                     tfld, cmfdqr, nrain, nevapr, delt, &
!                     invariants(1,1,indexm), vmr, plonl )
!-----------------------------------------------------------------------      
!       ...  History output for instantaneous wet removal rates
!-----------------------------------------------------------------------      
!        do file = 1,moz_file_cnt
!           if( hfile(file)%wrhstts .and. hfile(file)%histout_cnt(10,inst) > 0 ) then
!              do m = 1,hfile(file)%histout_cnt(10,inst)
!                 fldname = hfile(file)%hist_inst(hfile(file)%histout_ind(10,inst)+m-1)
!                     hndx    = hfile(file)%inst_map(hfile(file)%histout_ind(10,inst)+m-1)
!                    call outfld( fldname, het_rates(1,1,hndx), plonl, ip, lat, file )
!              end do
!           end if
!-----------------------------------------------------------------------      
!       ...  History output for time averaged wet removal rates
!-----------------------------------------------------------------------      
!           do m = 1,hfile(file)%histout_cnt(10,avrg)
!               fldname = hfile(file)%hist_timav(hfile(file)%histout_ind(10,avrg)+m-1)
!               hndx    = hfile(file)%timav_map(hfile(file)%histout_ind(10,avrg)+m-1)
!              call outfld( fldname, het_rates(1,1,hndx), plonl, ip, lat, file )
!           end do
!        end do
      end if
      if( extcnt > 0 ) then
!-----------------------------------------------------------------------
!        ... Compute the extraneous frcing at time = t(n+1)
!-----------------------------------------------------------------------      
!        call setext( extfrc, lat, ip, zint, cldtop, plonl )
!-----------------------------------------------------------------------      
!       ...  History output for instantaneous external forcing rates
!-----------------------------------------------------------------------      
!        do file = 1,moz_file_cnt
!           if( hfile(file)%wrhstts .and. hfile(file)%histout_cnt(11,inst) > 0 ) then
!              do m = 1,hfile(file)%histout_cnt(11,inst)
!                  fldname = hfile(file)%hist_inst(hfile(file)%histout_ind(11,inst)+m-1)
!                  hndx = hfile(file)%inst_map(hfile(file)%histout_ind(11,inst)+m-1)
!                 call outfld( fldname, extfrc(1,1,hndx), plonl, ip, lat, file )
!              end do
!           end if
!-----------------------------------------------------------------------      
!       ...  History output for time averaged external forcing rates
!-----------------------------------------------------------------------      
!           do m = 1,hfile(file)%histout_cnt(11,avrg)
!               fldname = hfile(file)%hist_timav(hfile(file)%histout_ind(11,avrg)+m-1)
!               hndx    = hfile(file)%timav_map(hfile(file)%histout_ind(11,avrg)+m-1)
!              call outfld( fldname, extfrc(1,1,hndx), plonl, ip, lat, file )
!           end do
!        end do
!        do m = 1,max(1,extcnt)
!           do k = 1,SIZE(vmr,2)
!               extfrc(:,k,m) = extfrc(:,k,m) / invariants(:,k,indexm)
!           end do
!        end do
      end if
      if( grpcnt > 0 ) then
!-----------------------------------------------------------------------
!        ... Set the group ratios
!-----------------------------------------------------------------------      
!        call set_grp_ratios( group_ratios, reaction_rates, vmr, mmr, nas, &
!                              mbar, invariants, plonl )
!-----------------------------------------------------------------------
!             ... Modify the reaction rate of any reaction
!           with group member or proportional reactant(s)
!-----------------------------------------------------------------------
!        call rxt_mod( reaction_rates, het_rates, group_ratios, plnplv )
      end if

!=======================================================================
!        ... Call the class solution algorithms
!=======================================================================
      if( clscnt1 > 0 .and. rxntot > 0 ) then
!-----------------------------------------------------------------------
!        ... Solve for "explicit" species
!-----------------------------------------------------------------------
         call exp_sol( vmr, reaction_rates, &
                       het_rates, extfrc, &
                       nstep, delt, &
!                      invariants(1,1,indexm), &
                       prod_out, loss_out, &
                       plonl, plnplv )
      end if
      if( clscnt4 > 0 .and. rxntot > 0 ) then
!-----------------------------------------------------------------------
!        ... Solve for "Implicit" species
!-----------------------------------------------------------------------
!prod_ox and loss_ox are added to implicit solver. (jmao,1/1/2011)
         call imp_sol( vmr, reaction_rates, &
                       het_rates, extfrc, &
                       nstep, delt, &
!                      invariants(1,1,indexm), &
                       lat, lon, &
                       prod_out, loss_out, check_convergence, &
                       imp_slv_nonconv, &
                       plonl, plnplv, &
                       prod_ox, loss_ox)
      end if
      if( clscnt5 > 0 .and. rxntot > 0 ) then
!-----------------------------------------------------------------------
!        ... Solve for "Rodas" species
!-----------------------------------------------------------------------
         call rodas_sol( vmr, reaction_rates, &
                         het_rates, extfrc, &
                         nstep, delt, &
!                        invariants(1,1,indexm), &
                         plonl, plnplv )
      end if

!-----------------------------------------------------------------------
!       ... Assign O3strat to O3 at and above the tropopause and 
!           let it undergo loss processes below the tropopause
!-----------------------------------------------------------------------
      ox_ndx = get_spc_ndx( 'O3' )
      o3s_ndx = get_spc_ndx( 'O3S' )
      do i = 1,plonl
        do k = plev-1,2,-1
           if (zmid(i,k) < ztrop_low ) then
               cycle
           else if( zmid(i,k) > ztrop_high ) then
               troplev(i)    = k
               exit
           end if
           dt = tfld(i,k) - tfld(i,k-1)
           if( dt < max_dtdz*(zmid(i,k-1) - zmid(i,k)) ) then
              troplev(i)    = k
              exit
           end if
       end do
     end do
     do i = 1,plonl
       do k = 1,plev
         if (k <= troplev(i)) then
            vmr(i,k,o3s_ndx) = vmr(i,k,ox_ndx)
         else
            k_loss_ox(i,k) = loss_ox(i,k) / (max( vmr(i,k,ox_ndx), 1.0e-20     ))
            vmr(i,k,o3s_ndx) = vmr(i,k,o3s_ndx)*exp( -delt*k_loss_ox(i,k) )
         end if
       end do
     end do

!-----------------------------------------------------------------------
!       ... Heterogeneous chemistry
!-----------------------------------------------------------------------
      so2_ndx = get_spc_ndx( 'SO2' )
      so4_ndx = get_spc_ndx( 'SO4' )
      if( so2_ndx > 0 .and. so4_ndx > 0 ) then
         call setsox( pmid, plonl, delt, tfld, sh, &
!                     nrain, nevapr, cmfdqr, &
                      cwat, invariants(:,:,indexm), &
                      vmr, retain_cm3_bugs )
      end if
!-----------------------------------------------------------------------      
!         ... Check for negative values and reset to zero
!-----------------------------------------------------------------------      
!     call negtrc( lat, 'After chemistry ', vmr, plonl )
!-----------------------------------------------------------------------      
!         ... Output instantaneous "wet" advected volume mixing
!-----------------------------------------------------------------------      
!     do file = 1,moz_file_cnt
!        if( hfile(file)%wrhstts .and. hfile(file)%histout_cnt(1,inst) > 0 ) then
!           do m = 1,hfile(file)%histout_cnt(1,inst)
!               fldname = hfile(file)%hist_inst(hfile(file)%histout_ind(1,inst)+m-1)
!               hndx    = hfile(file)%inst_map(hfile(file)%histout_ind(1,inst)+m-1)
!              call outfld( fldname, vmr(1,1,hndx), plonl, ip, lat, file )
!           end do
!        end if
!-----------------------------------------------------------------------      
!         ... Output time averaged "wet" advected volume mixing ratios
!-----------------------------------------------------------------------      
!        do m = 1,hfile(file)%histout_cnt(1,avrg)
!            fldname = hfile(file)%hist_timav(hfile(file)%histout_ind(1,avrg)+m-1)
!            hndx    = hfile(file)%timav_map(hfile(file)%histout_ind(1,avrg)+m-1)
!           call outfld( fldname, vmr(1,1,hndx), plonl, ip, lat, file )
!        end do
!     end do
!-----------------------------------------------------------------------      
!         ... Output instantaneous "wet" non-advected volume mixing
!-----------------------------------------------------------------------      
!     group_write(:moz_file_cnt) = hfile(:moz_file_cnt)%wrhstts .and. &
!                                  hfile(:moz_file_cnt)%histout_cnt(2,inst) > 0
!     if( ANY( group_write(:moz_file_cnt) ) .or. &
!         ANY( hfile(:moz_file_cnt)%histout_cnt(2,avrg) > 0 ) ) then
!        call mak_grp_vmr( vmr, group_ratios(1,1,1), group_vmr(1,1,1), plonl )
!     end if
!     do file = 1,moz_file_cnt
!        if( hfile(file)%wrhstts .and. hfile(file)%histout_cnt(2,inst) > 0 ) then
!           do m = 1,hfile(file)%histout_cnt(2,inst)
!               fldname = hfile(file)%hist_inst(hfile(file)%histout_ind(2,inst)+m-1)
!               hndx    = hfile(file)%inst_map(hfile(file)%histout_ind(2,inst)+m-1)
!              call outfld( fldname, group_vmr(1,1,hndx), plonl, ip, lat, file )
!           end do
!        end if
!-----------------------------------------------------------------------      
!         ... Output time averaged "wet" non-advected volume mixing ratios
!-----------------------------------------------------------------------      
!        do m = 1,hfile(file)%histout_cnt(2,avrg)
!            fldname = hfile(file)%hist_timav(hfile(file)%histout_ind(2,avrg)+m-1)
!            hndx    = hfile(file)%timav_map(hfile(file)%histout_ind(2,avrg)+m-1)
!           call outfld( fldname, group_vmr(1,1,hndx), plonl, ip, lat, file )
!        end do
!     end do
!-----------------------------------------------------------------------      
!         ... Xform from vmr to mmr
!-----------------------------------------------------------------------      
!     call vmr2mmr( vmr, mmr, nas, group_ratios, mbar, plonl )

      end subroutine chemdr
!</SUBROUTINE>

      end module mo_chemdr_mod

module mosaic_mod

! <CONTACT EMAIL="Zhi.Liang@noaa.gov">
!   Zhi Liang
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!    <TT>mosaic_mod</TT> implements some utility routines to read mosaic information.
! </OVERVIEW>

! <DESCRIPTION>
!    <TT>mosaic_mod</TT> implements some utility routines to read mosaic information.
!    The information includes number of tiles and contacts in the mosaic, 
!    mosaic grid resolution of each tile, mosaic contact information, mosaic exchange
!    grid information. Each routine will call a C-version routine to get these information.
! </DESCRIPTION>

use mpp_mod,    only : mpp_error, FATAL, mpp_pe, mpp_root_pe
use mpp_io_mod, only : MPP_MULTI
use fms_io_mod, only : dimension_size, field_exist, read_data, read_compressed
use constants_mod, only : PI, RADIUS

implicit none
private

character(len=*), parameter :: &
     grid_dir  = 'INPUT/'      ! root directory for all grid files

integer, parameter :: &
     MAX_NAME = 256,  & ! max length of the variable names
     MAX_FILE = 1024, & ! max length of the file names
     X_REFINE = 2,    & ! supergrid size/model grid size in x-direction
     Y_REFINE = 2       ! supergrid size/model grid size in y-direction

! --- public interface


public :: get_mosaic_ntiles
public :: get_mosaic_ncontacts
public :: get_mosaic_grid_sizes
public :: get_mosaic_contact
public :: get_mosaic_xgrid_size
public :: get_mosaic_xgrid
public :: calc_mosaic_grid_area
public :: calc_mosaic_grid_great_circle_area
public :: is_inside_polygon

logical :: module_is_initialized = .true.
! version information varaible
 character(len=128) :: version = '$Id$'
 character(len=128) :: tagname = '$Name$'

contains

!#######################################################################

! <SUBROUTINE NAME="mosaic_init">
!   <OVERVIEW>
!     Initialize the mosaic_mod. 
!   </OVERVIEW>
!   <DESCRIPTION>
!     Initialization routine for the mosaic module. It writes the 
!     version information to the log file.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call mosaic_init ( )
!   </TEMPLATE>
subroutine mosaic_init() 

  if (module_is_initialized) return
  module_is_initialized = .TRUE.

!--------- write version number and namelist ------------------
!  call write_version_number (version, tagname)

end subroutine mosaic_init
! </SUBROUTINE>

!#######################################################################
! <FUNCTION NAME="get_mosaic_xgrid_size">
!   <OVERVIEW>
!     return exchange grid size of mosaic xgrid file.
!   </OVERVIEW>
!   <DESCRIPTION>
!     return exchange grid size of mosaic xgrid file.
!   </DESCRIPTION>
!   <TEMPLATE>
!    nxgrid = get_mosaic_xgrid_size(xgrid_file)
!   </TEMPLATE>
!   <IN NAME="xgrid_file" TYPE="character(len=*)">
!     The file that contains exchange grid information.
!   </IN>
  function get_mosaic_xgrid_size(xgrid_file)
    character(len=*), intent(in)          :: xgrid_file
    integer                               :: get_mosaic_xgrid_size

    get_mosaic_xgrid_size = dimension_size(xgrid_file, "ncells", no_domain=.TRUE.)

    return   

  end function get_mosaic_xgrid_size
! </FUNCTION>
!#######################################################################
! <SUBROUTINE NAME="get_mosaic_xgrid">
!   <OVERVIEW>
!     get exchange grid information from mosaic xgrid file.
!   </OVERVIEW>
!   <DESCRIPTION>
!     get exchange grid information from mosaic xgrid file.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call get_mosaic_xgrid(xgrid_file, nxgrid, i1, j1, i2, j2, area)
!   </TEMPLATE>
!   <IN NAME="xgrid_file" TYPE="character(len=*)">
!     The file that contains exchange grid information.
!   </IN>
!   <INOUT NAME="nxgrid" TYPE="integer">
!     number of exchange grid in xgrid_file
!   </INOUT>
!   <INOUT NAME="i1, j1" TYPE="integer, dimension(:)">
!     i and j-index in grid 1 of exchange grid.
!   </INOUT>
!   <INOUT NAME="i2, j2" TYPE="integer, dimension(:)">
!     i and j-index in grid 2 of exchange grid.
!   </INOUT>
!   <INOUT NAME="area" TYPE="real, dimension(:)">
!     area of the exchange grid. The area is scaled to represent unit earth area.
!   </INOUT>
  subroutine get_mosaic_xgrid(xgrid_file, i1, j1, i2, j2, area, ibegin, iend)
    character(len=*), intent(in) :: xgrid_file
    integer,       intent(inout) :: i1(:), j1(:), i2(:), j2(:)
    real,          intent(inout) :: area(:)
    integer, optional, intent(in) :: ibegin, iend

    integer                            :: start(4), nread(4), istart
    real,    dimension(2, size(i1(:))) :: tile1_cell, tile2_cell
    integer                            :: nxgrid, n
    real                               :: garea
    real                               :: get_global_area;

    garea = get_global_area();

    ! When start and nread present, make sure nread(1) is the same as the size of the data
    if(present(ibegin) .and. present(iend)) then
       istart = ibegin
       nxgrid = iend - ibegin + 1
       if(nxgrid .NE. size(i1(:))) call mpp_error(FATAL, "get_mosaic_xgrid: nxgrid .NE. size(i1(:))")
       if(nxgrid .NE. size(j1(:))) call mpp_error(FATAL, "get_mosaic_xgrid: nxgrid .NE. size(j1(:))")
       if(nxgrid .NE. size(i2(:))) call mpp_error(FATAL, "get_mosaic_xgrid: nxgrid .NE. size(i2(:))")
       if(nxgrid .NE. size(j2(:))) call mpp_error(FATAL, "get_mosaic_xgrid: nxgrid .NE. size(j2(:))")
       if(nxgrid .NE. size(area(:))) call mpp_error(FATAL, "get_mosaic_xgrid: nxgrid .NE. size(area(:))")
    else
       istart = 1
       nxgrid = size(i1(:))
    endif

    start  = 1; nread = 1
    start(1) = istart; nread(1) = nxgrid
    call read_compressed(xgrid_file, 'xgrid_area', area, start=start, nread=nread, threading=MPP_MULTI)
    start = 1; nread = 1
    nread(1) = 2
    start(2) = istart; nread(2) = nxgrid
    call read_compressed(xgrid_file, 'tile1_cell', tile1_cell, start=start, nread=nread, threading=MPP_MULTI)
    call read_compressed(xgrid_file, 'tile2_cell', tile2_cell, start=start, nread=nread, threading=MPP_MULTI)

     do n = 1, nxgrid
       i1(n) = tile1_cell(1,n) 
       j1(n) = tile1_cell(2,n)
       i2(n) = tile2_cell(1,n) 
       j2(n) = tile2_cell(2,n)
       area(n) = area(n)/garea
    end do
    
    return

  end subroutine get_mosaic_xgrid
! </SUBROUTINE>

  !###############################################################################
  ! <SUBROUTINE NAME="get_mosaic_ntiles">
  !   <OVERVIEW>
  !     get number of tiles in the mosaic_file.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     get number of tiles in the mosaic_file.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     ntiles = get_mosaic_ntiles( mosaic_file)
  !   </TEMPLATE>
  !   <IN NAME="mosaic_file" TYPE="character(len=*)">
  !     The file that contains mosaic information.
  !   </IN>
  function get_mosaic_ntiles(mosaic_file)
    character(len=*), intent(in) :: mosaic_file
    integer                      :: get_mosaic_ntiles 

    get_mosaic_ntiles = dimension_size(mosaic_file, "ntiles")

    return

  end function get_mosaic_ntiles
! </SUBROUTINE>

  !###############################################################################
  ! <SUBROUTINE NAME="get_mosaic_ncontacts">
  !   <OVERVIEW>
  !     get number of contacts in the mosaic_file.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     get number of contacts in the mosaic_file.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     ntiles = get_mosaic_ncontacts( mosaic_file)
  !   </TEMPLATE>
  !   <IN NAME="mosaic_file" TYPE="character(len=*)">
  !     The file that contains mosaic information.
  !   </IN>
  function get_mosaic_ncontacts( mosaic_file)
    character(len=*), intent(in) :: mosaic_file
    integer                      :: get_mosaic_ncontacts 

    character(len=len_trim(mosaic_file)+1) :: mfile    
    integer                                :: strlen
    integer                                :: read_mosaic_ncontacts

    if(field_exist(mosaic_file, "contacts") ) then
      get_mosaic_ncontacts = dimension_size(mosaic_file, "ncontact", no_domain=.TRUE.)
    else
      get_mosaic_ncontacts = 0
    endif

    return

  end function get_mosaic_ncontacts
! </SUBROUTINE>


  !###############################################################################
  ! <SUBROUTINE NAME="get_mosaic_grid_sizes">
  !   <OVERVIEW>
  !     get grid size of each tile from mosaic_file
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     get grid size of each tile from mosaic_file
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call get_mosaic_grid_sizes(mosaic_file, nx, ny)
  !   </TEMPLATE>
  !   <IN NAME="mosaic_file" TYPE="character(len=*)">
  !     The file that contains mosaic information.
  !   </IN>
  !   <INOUT NAME="nx" TYPE="integer, dimension(:)">
  !     List of grid size in x-direction of each tile.
  !   </INOUT>
  !   <INOUT NAME="ny" TYPE="integer, dimension(:)">
  !     List of grid size in y-direction of each tile.
  !   </INOUT>
  subroutine get_mosaic_grid_sizes( mosaic_file, nx, ny)
    character(len=*),         intent(in) :: mosaic_file
    integer, dimension(:), intent(inout) :: nx, ny

    character(len=MAX_FILE) :: gridfile
    integer                 :: ntiles, n    

    ntiles = get_mosaic_ntiles(mosaic_file)
    if(ntiles .NE. size(nx(:)) .OR. ntiles .NE. size(ny(:)) ) then
      call mpp_error(FATAL, "get_mosaic_grid_sizes: size of nx/ny does not equal to ntiles")
    endif
    do n = 1, ntiles
      call read_data(mosaic_file, 'gridfiles', gridfile, level=n)
      gridfile = grid_dir//trim(gridfile)
      nx(n) = dimension_size(gridfile, "nx")
      ny(n) = dimension_size(gridfile, "ny")
      if(mod(nx(n),x_refine) .NE. 0) call mpp_error(FATAL, "get_mosaic_grid_sizes: nx is not divided by x_refine");
      if(mod(ny(n),y_refine) .NE. 0) call mpp_error(FATAL, "get_mosaic_grid_sizes: ny is not divided by y_refine");
      nx(n) = nx(n)/x_refine;
      ny(n) = ny(n)/y_refine;
    enddo

    return

  end subroutine get_mosaic_grid_sizes
! </SUBROUTINE>

  !###############################################################################
  ! <SUBROUTINE NAME="get_mosaic_contact">
  !   <OVERVIEW>
  !     get contact information from mosaic_file
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     get contact information from mosaic_file
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call get_mosaic_contact(mosaic_file, tile1, tile2, istart1, iend1, jstart1, jend1,
  !                             istart2, iend2, jstart2, jend2)
  !   </TEMPLATE>
  !   <IN NAME="mosaic_file" TYPE="character(len=*)">
  !     The file that contains mosaic information.
  !   </IN>
  !   <INOUT NAME="tile1" TYPE="integer, dimension(:)">
  !     list tile number in tile 1 of each contact.
  !   </INOUT>
  !   <INOUT NAME="tile1" TYPE="integer, dimension(:)">
  !     list tile number in tile 2 of each contact.
  !   </INOUT>
  !   <INOUT NAME="istart1" TYPE="integer, dimension(:)">
  !     list starting i-index in tile 1 of each contact.
  !   </INOUT>
  !   <INOUT NAME="iend1" TYPE="integer, dimension(:)">
  !     list ending i-index in tile 1 of each contact.
  !   </INOUT>
  !   <INOUT NAME="jstart1" TYPE="integer, dimension(:)">
  !     list starting j-index in tile 1 of each contact.
  !   </INOUT>
  !   <INOUT NAME="jend1" TYPE="integer, dimension(:)">
  !     list ending j-index in tile 1 of each contact.
  !   </INOUT>
  !   <INOUT NAME="istart2" TYPE="integer, dimension(:)">
  !     list starting i-index in tile 2 of each contact.
  !   </INOUT>
  !   <INOUT NAME="iend2" TYPE="integer, dimension(:)">
  !     list ending i-index in tile 2 of each contact.
  !   </INOUT>
  !   <INOUT NAME="jstart2" TYPE="integer, dimension(:)">
  !     list starting j-index in tile 2 of each contact.
  !   </INOUT>
  !   <INOUT NAME="jend2" TYPE="integer, dimension(:)">
  !     list ending j-index in tile 2 of each contact.
  !   </INOUT>
  subroutine get_mosaic_contact( mosaic_file, tile1, tile2, istart1, iend1, jstart1, jend1, &
                                   istart2, iend2, jstart2, jend2)
    character(len=*),         intent(in) :: mosaic_file
    integer, dimension(:), intent(inout) :: tile1, tile2
    integer, dimension(:), intent(inout) :: istart1, iend1, jstart1, jend1
    integer, dimension(:), intent(inout) :: istart2, iend2, jstart2, jend2
    character(len=MAX_NAME), allocatable :: gridtiles(:)
    character(len=MAX_NAME)              :: contacts
    character(len=MAX_NAME)              :: strlist(8)
    integer :: ntiles, n, m, ncontacts, nstr, ios
    integer :: i1_type, j1_type, i2_type, j2_type
    logical :: found

    ntiles = get_mosaic_ntiles(mosaic_file)
    allocate(gridtiles(ntiles))    
    do n = 1, ntiles
      call read_data(mosaic_file, 'gridtiles', gridtiles(n), level=n)
    enddo

    ncontacts = get_mosaic_ncontacts(mosaic_file)

    do n = 1, ncontacts
      call read_data(mosaic_file, "contacts", contacts, level=n)
      nstr = parse_string(contacts, ":", strlist)      
      if(nstr .NE. 4) call mpp_error(FATAL, &
         "mosaic_mod(get_mosaic_contact): number of elements in contact seperated by :/:: should be 4")
      found = .false.
      do m = 1, ntiles
        if(trim(gridtiles(m)) == trim(strlist(2)) ) then !found the tile name 
          found = .true.
          tile1(n) = m
          exit
        endif
      enddo
    
      if(.not.found) call mpp_error(FATAL, &
         "mosaic_mod(get_mosaic_contact):the first tile name specified in contact is not found in tile list")

      found = .false.
      do m = 1, ntiles
        if(trim(gridtiles(m)) == trim(strlist(4)) ) then !found the tile name 
          found = .true.
          tile2(n) = m
          exit
        endif
      enddo
    
      if(.not.found) call mpp_error(FATAL, &
         "mosaic_mod(get_mosaic_contact):the second tile name specified in contact is not found in tile list")

      call read_data(mosaic_file, "contact_index", contacts, level=n)
      nstr = parse_string(contacts, ":,", strlist)
      if(nstr .NE. 8) then
        if(mpp_pe()==mpp_root_pe()) then 
          print*, "nstr is ", nstr
          print*, "contacts is ", contacts
          do m = 1, nstr
            print*, "strlist is ", trim(strlist(m))
          enddo
        endif
        call mpp_error(FATAL, &
               "mosaic_mod(get_mosaic_contact): number of elements in contact_index seperated by :/, should be 8")
      endif
      read(strlist(1), *, iostat=ios) istart1(n)
      if(ios .NE. 0) call mpp_error(FATAL, &
         "mosaic_mod(get_mosaic_contact): Error in reading istart1")
      read(strlist(2), *, iostat=ios) iend1(n)
      if(ios .NE. 0) call mpp_error(FATAL, &
         "mosaic_mod(get_mosaic_contact): Error in reading iend1")
      read(strlist(3), *, iostat=ios) jstart1(n)
      if(ios .NE. 0) call mpp_error(FATAL, &
         "mosaic_mod(get_mosaic_contact): Error in reading jstart1")
      read(strlist(4), *, iostat=ios) jend1(n)
      if(ios .NE. 0) call mpp_error(FATAL, &
         "mosaic_mod(get_mosaic_contact): Error in reading jend1")
      read(strlist(5), *, iostat=ios) istart2(n)
      if(ios .NE. 0) call mpp_error(FATAL, &
         "mosaic_mod(get_mosaic_contact): Error in reading istart2")
      read(strlist(6), *, iostat=ios) iend2(n)
      if(ios .NE. 0) call mpp_error(FATAL, &
         "mosaic_mod(get_mosaic_contact): Error in reading iend2")
      read(strlist(7), *, iostat=ios) jstart2(n)
      if(ios .NE. 0) call mpp_error(FATAL, &
         "mosaic_mod(get_mosaic_contact): Error in reading jstart2")
      read(strlist(8), *, iostat=ios) jend2(n)
      if(ios .NE. 0) call mpp_error(FATAL, &
         "mosaic_mod(get_mosaic_contact): Error in reading jend2")

      i1_type = transfer_to_model_index(istart1(n), iend1(n), x_refine)
      j1_type = transfer_to_model_index(jstart1(n), jend1(n), y_refine)
      i2_type = transfer_to_model_index(istart2(n), iend2(n), x_refine)
      j2_type = transfer_to_model_index(jstart2(n), jend2(n), y_refine)

      if( i1_type == 0 .AND. j1_type == 0 ) call mpp_error(FATAL, &
         "mosaic_mod(get_mosaic_contact): istart1==iend1 and jstart1==jend1")
      if( i2_type == 0 .AND. j2_type == 0 ) call mpp_error(FATAL, &
         "mosaic_mod(get_mosaic_contact): istart2==iend2 and jstart2==jend2")
      if( i1_type + j1_type .NE. i2_type + j2_type ) call mpp_error(FATAL, &
         "mosaic_mod(get_mosaic_contact): It is not a line or overlap contact")

   enddo

      deallocate(gridtiles)

  end subroutine get_mosaic_contact
! </SUBROUTINE>


function transfer_to_model_index(istart, iend, refine_ratio)
   integer, intent(inout) :: istart, iend
   integer                :: refine_ratio
   integer                :: transfer_to_model_index
   integer                :: istart_in, iend_in

   istart_in = istart
   iend_in = iend

   if( istart_in == iend_in ) then
      transfer_to_model_index = 0
      istart = (istart_in + 1)/refine_ratio
      iend   = istart
   else 
      transfer_to_model_index = 1
      if( iend_in > istart_in ) then
        istart = istart_in + 1
        iend   = iend_in
      else 
        istart = istart_in
        iend   = iend_in + 1
      endif
      if( mod(istart, refine_ratio) .NE. 0 .OR. mod(iend,refine_ratio) .NE. 0) call mpp_error(FATAL, &
         "mosaic_mod(transfer_to_model_index): mismatch between refine_ratio and istart/iend")
      istart = istart/refine_ratio
      iend = iend/refine_ratio

   endif

   return

end function transfer_to_model_index

  !###############################################################################
  ! <SUBROUTINE NAME="calc_mosaic_grid_area">
  !   <OVERVIEW>
  !     calculate grid cell area.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     calculate the grid cell area. The purpose of this routine is to make 
  !     sure the consistency between model grid area and exchange grid area.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call calc_mosaic_grid_area(lon, lat, area)
  !   </TEMPLATE>
  !   <IN NAME="lon" TYPE="real, dimension(:,:)">
  !     geographical longitude of grid cell vertices.
  !   </IN>
  !   <IN NAME="lat" TYPE="real, dimension(:,:)">
  !     geographical latitude of grid cell vertices.
  !   </IN>
  !   <INOUT NAME="area" TYPE="real, dimension(:,:)">
  !     grid cell area.
  !   </INOUT>
  subroutine calc_mosaic_grid_area(lon, lat, area)
     real, dimension(:,:), intent(in)    :: lon
     real, dimension(:,:), intent(in)    :: lat
     real, dimension(:,:), intent(inout) :: area
     integer                             :: nlon, nlat

     nlon = size(area,1)
     nlat = size(area,2)
     ! make sure size of lon, lat and area are consitency
     if( size(lon,1) .NE. nlon+1 .OR. size(lat,1) .NE. nlon+1 ) &
        call mpp_error(FATAL, "mosaic_mod: size(lon,1) and size(lat,1) should equal to size(area,1)+1")
     if( size(lon,2) .NE. nlat+1 .OR. size(lat,2) .NE. nlat+1 ) &
        call mpp_error(FATAL, "mosaic_mod: size(lon,2) and size(lat,2) should equal to size(area,2)+1")

     call get_grid_area( nlon, nlat, lon, lat, area)

  end subroutine calc_mosaic_grid_area
  ! </SUBROUTINE>

  !###############################################################################
  ! <SUBROUTINE NAME="calc_mosaic_grid_great_circle_area">
  !   <OVERVIEW>
  !     calculate grid cell area using great cirlce algorithm
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     calculate the grid cell area. The purpose of this routine is to make 
  !     sure the consistency between model grid area and exchange grid area.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call calc_mosaic_grid_great_circle_area(lon, lat, area)
  !   </TEMPLATE>
  !   <IN NAME="lon" TYPE="real, dimension(:,:)">
  !     geographical longitude of grid cell vertices.
  !   </IN>
  !   <IN NAME="lat" TYPE="real, dimension(:,:)">
  !     geographical latitude of grid cell vertices.
  !   </IN>
  !   <INOUT NAME="area" TYPE="real, dimension(:,:)">
  !     grid cell area.
  !   </INOUT>
  subroutine calc_mosaic_grid_great_circle_area(lon, lat, area)
     real, dimension(:,:), intent(in)    :: lon
     real, dimension(:,:), intent(in)    :: lat
     real, dimension(:,:), intent(inout) :: area
     integer                             :: nlon, nlat
     

     nlon = size(area,1)
     nlat = size(area,2)
     ! make sure size of lon, lat and area are consitency
     if( size(lon,1) .NE. nlon+1 .OR. size(lat,1) .NE. nlon+1 ) &
        call mpp_error(FATAL, "mosaic_mod: size(lon,1) and size(lat,1) should equal to size(area,1)+1")
     if( size(lon,2) .NE. nlat+1 .OR. size(lat,2) .NE. nlat+1 ) &
        call mpp_error(FATAL, "mosaic_mod: size(lon,2) and size(lat,2) should equal to size(area,2)+1")

     call get_grid_great_circle_area( nlon, nlat, lon, lat, area)

  end subroutine calc_mosaic_grid_great_circle_area
  ! </SUBROUTINE>

  !#####################################################################
  ! This function check if a point (lon1,lat1) is inside a polygon (lon2(:), lat2(:))
  ! lon1, lat1, lon2, lat2 are in radians.
  function is_inside_polygon(lon1, lat1, lon2, lat2 )
     real, intent(in) :: lon1, lat1
     real, intent(in) :: lon2(:), lat2(:)
     logical          :: is_inside_polygon
     real, dimension(size(lon2(:))) :: x2, y2, z2
     integer                        :: npts, isinside
     integer                        :: inside_a_polygon

     npts = size(lon2(:))

     isinside = inside_a_polygon(lon1, lat1, npts, lon2, lat2)
     if(isinside == 1) then
        is_inside_polygon = .TRUE.
     else
        is_inside_polygon = .FALSE.
     endif

     return

  end function is_inside_polygon

  function parse_string(string, set, value)
  character(len=*),  intent(in) :: string
  character(len=*),  intent(in) :: set
  character(len=*), intent(out) :: value(:)
  integer                       :: parse_string
  integer :: nelem, length, first, last

     nelem = size(value(:))
     length = len_trim(string)

     first = 1; last = 0
     parse_string = 0

     do while(first .LE. length)
       parse_string = parse_string + 1
       if(parse_string>nelem) then
         call mpp_error(FATAL, "mosaic_mod(parse_string) : number of element is greater than size(value(:))")
       endif
       last = first - 1 + scan(string(first:length), set)
       if(last == first-1 ) then  ! not found, end of string
         value(parse_string) = string(first:length)
         exit
       else
         if(last <= first) then
           call mpp_error(FATAL, "mosaic_mod(parse_string) : last <= first")
         endif
         value(parse_string) = string(first:(last-1))
         first = last + 1
         ! scan to make sure the next is not the character in the set
         do while (first == last+1)
           last = first - 1 + scan(string(first:length), set)
           if(last == first) then
             first = first+1
           else
             exit
           endif
         end do
       endif
     enddo

     return

  end function parse_string


     
end module mosaic_mod


#ifdef TEST_MOSAIC
program test_mosaic

use mosaic_mod, only : get_mosaic_ntiles, get_mosaic_ncontacts
use mosaic_mod, only : get_mosaic_grid_sizes, get_mosaic_contact

implicit none

integer              :: ntiles, ncontacts, n
integer, allocatable :: tile1(:), tile2(:), nx(:), ny(:)
integer, allocatable :: istart1(:), iend1(:), jstart1(:), jend1(:)
integer, allocatable :: istart2(:), iend2(:), jstart2(:), jend2(:)
character(len=128)   :: mosaic_file = "INPUT/mosaic.nc"

ntiles = get_mosaic_ntiles(mosaic_file)
ncontacts = get_mosaic_ncontacts(mosaic_file)
allocate(nx(ntiles), ny(ntiles))
allocate(tile1(ncontacts), tile2(ncontacts) )
allocate(istart1(ncontacts), iend1(ncontacts), jstart1(ncontacts), jend1(ncontacts) )
allocate(istart2(ncontacts), iend2(ncontacts), jstart2(ncontacts), jend2(ncontacts) )

call get_mosaic_grid_sizes(mosaic_file, nx, ny )
call get_mosaic_contact(mosaic_file, tile1, tile2, istart1, iend1, jstart1, jend1, istart2, iend2, jstart2, jend2)

! print out information

print '(a,i3,a,a)', "****** There is ", ntiles, " tiles in ", trim(mosaic_file)
do n = 1, ntiles
   print '(a,i3,a,i3,a,i3)', " tile = ", n, ", nx = ", nx(n), ", ny = ", ny(n)
end do

print '(a,i3,a,a)', "****** There is ", ncontacts, " contacts in ", trim(mosaic_file)
do n = 1, ncontacts
   print '(a,i3,a,i3,a,i3,a,i4,a,i4,a,i4,a,i4,a,i4,a,i4,a,i4,a,i4)', &
           "contact=", n, ": tile1=", tile1(n), " tile2=", tile2(n),   &
           " is1=", istart1(n), " ie1=", iend1(n),                   &
           " js1=", jstart1(n), " je1=", jend1(n),                   &
           " is2=", istart2(n), " ie2=", iend2(n),                   &
           " js2=", jstart2(n), " je2=", jend2(n)
end do

deallocate(tile1, tile2, nx, ny)
deallocate(istart1, iend1, jstart1, jend1)
deallocate(istart2, iend2, jstart2, jend2)


end program test_mosaic
#endif

module ocean_velocity_mod
#define COMP isc:iec,jsc:jec
!
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
! S.M. Griffies 
! </CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> A. Rosati
!</CONTACT>
!
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
! M.J. Harrison 
! </REVIEWER>
!
!<OVERVIEW>
! Time step the velocity field. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module steps the velocity field forward in time.
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! Durran, Numerical Methods for Wave Equations in Geophysical
! Fluid Dynamics (1999).
! </REFERENCE>
!
! <REFERENCE>
! R.C. Pacanowski and S.M. Griffies, The MOM3 Manual (1999).
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, R.C. Pacanowski, R.M. Schmidt, and V. Balaji
! Tracer Conservation with an Explicit Free Surface Method for 
! Z-coordinate Ocean Models
! Monthly Weather Review (2001) vol 129 pages 1081--1098
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, M.J. Harrison, R.C. Pacanowski, and 
! A. Rosati, A Technical Guide to MOM4 (2004).
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, Fundamentals of Ocean Climate Models (2004).
! Princeton University Press.
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies (2012), Elements of MOM
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_velocity_nml">
!
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging.  
!  </DATA> 
!  <DATA NAME="write_a_restart" TYPE="logical">
!  Set true to write a restart.  False setting only for rare 
!  cases where wish to benchmark model without measuring the cost
!  of writing restarts and associated chksums.  
!  Default is write_a_restart=.true. 
!  </DATA> 
!
!  <DATA NAME="update_velocity_via_uprime" TYPE="logical">
!  When updating the velocity, this method first computes uprime
!  as the updated velocity minus the barotropic pressure gradient.
!  This approach is motivated from the rigid lid approach, in which 
!  the surface pressure was never used to update the barotropic
!  fields.  
!  With the explicit free surface, we have the choice to 
!  update the full velocity field, with the barotropic contributions
!  to the pressure field resulting from a time average in the 
!  external mode algorithm.  This approach is for testing only,
!  and it has been found to be unstable for many cases.  
!
!  update_velocity_via_uprime=.true. uses the older aproach, 
!  in which the udrho,vdrho fields are taken from the external
!  mode module. 
! 
!  update_velocity_via_uprime=.false. only takes the time averaged 
!  pressure from the external mode, and thus updates the full 
!  velocity and so recomputes the udrho,vdrho fields.  
!
!  Default update_velocity_via_uprime=.true.  
!  The case of update_velocity_via_uprime=.false. is for testing only.
!  It is not supported for general use.  
!  </DATA> 
! 
!  <DATA NAME="use_constant_velocity" TYPE="logical">
!  For running with time independent constant velocity.
!  For use with idealized cases. Default=.false. 
!  </DATA> 
!  <DATA NAME="constant_u" TYPE="real" UNITS="meter/sec" >
!  For running with use_constant_velocity. 
!  Set the i-velocity component to this value.  
!  Default constant_u=0.0 
!  </DATA> 
!  <DATA NAME="constant_v" TYPE="real" UNITS="meter/sec" >
!  For running with use_constant_velocity. 
!  Set the j-velocity component to this value.  
!  Default constant_v=0.0 
!  </DATA> 
!
!  <DATA NAME="zero_tendency" TYPE="logical">
!  For debugging. Will freeze the baroclinic velocity  fields. 
!  </DATA> 
!  <DATA NAME="zero_tendency_explicit_a" TYPE="logical">
!  For debugging. Will not use explicit-a part of the tendency. 
!  </DATA> 
!  <DATA NAME="zero_tendency_explicit_b" TYPE="logical">
!  For debugging. Will not use explicit-b part of the tendency. 
!  </DATA> 
!  <DATA NAME="zero_tendency_implicit" TYPE="logical">
!  For debugging. Will not use implicit part of the tendency. 
!  </DATA> 
!
!  <DATA NAME="truncate_velocity" TYPE="logical">
!  Truncate the baroclinic velocity to a maximum value.  Useful for cases where
!  the initial spin-up initiates spuriously large model velocities that would
!  otherwise cause the model to blow-up. Also can be used as a very simple 
!  "polar filter" in cases where have spherical coordinates and wish to avoid 
!  using the traditional polar filters.  
!  </DATA> 
!  <DATA NAME="truncate_velocity_value" UNITS="meter/sec" TYPE="real">
!  Speed above which will truncate the baroclinic velocity
!  </DATA> 
!  <DATA NAME="truncate_velocity_lat" UNITS="dimensionless" TYPE="real">
!  Latitude poleward of which we truncate the velocity. Useful in cases
!  when wish to truncate the velocity only in polar regions. Default is 0.0   
!  </DATA> 
!  <DATA NAME="truncate_verbose" TYPE="logical">
!  For verbose printout 
!  </DATA> 
!
!  <DATA NAME="max_cgint" TYPE="real">
!  Maximum internal gravity wave speed--used for diagnosing conservative
!  estimate of stable time steps.  
!  </DATA>
!
!  <DATA NAME="adams_bashforth_epsilon" UNITS="dimensionless" TYPE="real">
!  Dimensionless parameter for 2nd order Adams-Bashforth implementation of 
!  velocity advection.  Values between 0.5 and 1.0 are recommended.  
!  Value of 0.5 leads to second order accurate, but it is formally 
!  weakly unstable (Durran, Section 2.3.4).
!  </DATA> 
!  <DATA NAME="adams_bashforth_third" TYPE="logical">
!  For a third order treatment of the velocity advection.  
!  This is stable and so needs no temporal dissipation 
!  (Section 2.3.6 of Durran).  This is the model default. 
!  </DATA> 
!
!</NAMELIST>

use constants_mod,    only: epsln
use diag_manager_mod, only: register_diag_field, send_data
use fms_mod,          only: write_version_number, check_nml_error, close_file, open_namelist_file
use fms_mod,          only: file_exist, FATAL, WARNING, NOTE
use fms_io_mod,       only: field_size, restart_file_type, register_restart_field
use fms_io_mod,       only: save_restart, restore_state, reset_field_pointer
use mpp_domains_mod,  only: mpp_update_domains, mpp_global_sum, BGRID_NE, CGRID_NE, BITWISE_EXACT_SUM
use mpp_mod,          only: input_nml_file, mpp_error, mpp_pe, mpp_min, mpp_max, mpp_sum
use mpp_mod,          only: mpp_broadcast, stdout, stdlog
use time_interp_external_mod, only: time_interp_external, init_external_field

use ocean_bih_friction_mod,    only: bih_friction
use ocean_coriolis_mod,        only: coriolis_force_bgrid, coriolis_force_bgrid_implicit, coriolis_force_cgrid
use ocean_domains_mod,         only: get_local_indices
use ocean_form_drag_mod,       only: form_drag_accel
use ocean_lap_friction_mod,    only: lap_friction
use ocean_momentum_source_mod, only: momentum_source
use ocean_obc_mod,             only: ocean_obc_update_boundary
use ocean_operators_mod,       only: DIV_UD
use ocean_parameters_mod,      only: TWO_LEVEL, THREE_LEVEL, DEPTH_BASED
use ocean_parameters_mod,      only: missing_value, rho0r, grav, onehalf 
use ocean_parameters_mod,      only: MOM_BGRID, MOM_CGRID 
use ocean_pressure_mod,        only: pressure_force
use ocean_types_mod,           only: ocean_domain_type, ocean_grid_type, ocean_thickness_type
use ocean_types_mod,           only: ocean_time_type, ocean_time_steps_type
use ocean_types_mod,           only: ocean_density_type, ocean_thickness_type, ocean_velocity_type
use ocean_types_mod,           only: ocean_adv_vel_type, ocean_external_mode_type, ocean_options_type
use ocean_types_mod,           only: ocean_lagrangian_type
use ocean_util_mod,            only: write_timestamp, diagnose_2d, diagnose_3d, diagnose_2d_u, diagnose_3d_u
use ocean_util_mod,            only: write_chksum_2d, write_chksum_3d
use ocean_velocity_advect_mod, only: horz_advection_of_velocity, vert_advection_of_velocity
use ocean_velocity_diag_mod,   only: kinetic_energy, potential_energy 
use ocean_vert_mix_mod,        only: vert_friction_bgrid, vert_friction_implicit_bgrid
use ocean_vert_mix_mod,        only: vert_friction_cgrid, vert_friction_implicit_cgrid
use ocean_workspace_mod,       only: wrk1, wrk2, wrk3, wrk1_v  

implicit none

private

! for diagnostics 
integer :: id_u(2)              =-1
integer :: id_u_on_depth(2)     =-1
integer :: id_usurf(2)          =-1
integer :: id_ubott(2)          =-1
integer :: id_speed             =-1
integer :: id_accel(2)          =-1
integer :: id_converge_rho_ud_t =-1
logical :: used

! for data over ride files
logical :: use_velocity_override  = .false.
integer :: id_velocity_u_override = -1
integer :: id_velocity_v_override = -1

!for restart file
integer                       :: id_restart_u = 0
integer                       :: id_restart_v = 0
integer                       :: id_restart_advu = 0
integer                       :: id_restart_advv = 0
integer                       :: id_restart_coru = 0
integer                       :: id_restart_corv = 0
integer                       :: id_restart_px = 0
integer                       :: id_restart_py = 0
type(restart_file_type), save :: Vel_restart
type(restart_file_type), save :: Adv_restart
type(restart_file_type), save :: Cor_restart

integer :: unit=6

character(len=128) :: &
     version='$Id: ocean_velocity.F90,v 20.0 2013/12/14 00:12:41 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

logical :: have_obc = .false.

#include <ocean_memory.h>

real    :: dtime 
integer :: time_index 
integer :: tendency

! for Bgrid or Cgrid 
integer :: horz_grid 

type(ocean_domain_type), pointer :: Dom =>NULL()
type(ocean_grid_type), pointer   :: Grd =>NULL()

public ocean_velocity_init
public ocean_velocity_end
public ocean_explicit_accel_a
public ocean_explicit_accel_b
public ocean_implicit_accel
public update_ocean_velocity_bgrid
public update_ocean_velocity_cgrid
public ocean_velocity_restart

private ocean_velocity_chksum
private check_gravity_wave_cfl
private velocity_truncate
private remap_s_to_depth

! Adams-Bashforth treatment of velocity advection 
logical :: adams_bashforth_third   = .true.
real    :: adams_bashforth_epsilon = 0.6
real    :: abtau_m0 =  23.0/12.0
real    :: abtau_m1 = -16.0/12.0
real    :: abtau_m2 =  5.0/12.0

logical :: update_velocity_via_uprime = .true. 
logical :: module_is_initialized      = .false.
logical :: zero_tendency              = .false.
logical :: zero_tendency_explicit_a   = .false.
logical :: zero_tendency_explicit_b   = .false.
logical :: zero_tendency_implicit     = .false.
logical :: truncate_velocity          = .false.
logical :: truncate_verbose           = .false.
real    :: truncate_velocity_lat      = 0.0
real    :: truncate_velocity_value    = 1.0

! for idealized constant velocity situations 
logical :: use_constant_velocity = .false.
real    :: constant_u            = 0.0
real    :: constant_v            = 0.0

! for CFL check on gravity waves 
real    :: max_cgint = 2.0   ! speed (m/s) used to compute CFL check for internal gravity waves  
real    :: max_dt_for_cgint  ! maximum time step (s) allowed by CFL to resolve internal gravity waves 

! for debugging 
logical :: debug_this_module = .false.

! for writing restarts 
logical :: write_a_restart   = .true. 

namelist /ocean_velocity_nml/  debug_this_module, write_a_restart, max_cgint,                       &
         zero_tendency, zero_tendency_explicit_a, zero_tendency_explicit_b, zero_tendency_implicit, &
         truncate_velocity, truncate_verbose, truncate_velocity_lat, truncate_velocity_value,       &
         adams_bashforth_third, adams_bashforth_epsilon,                                            &
         use_constant_velocity, constant_u, constant_v,                                             &
         update_velocity_via_uprime 

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_velocity_init">
!
! <DESCRIPTION>
! Initialize terms for the velocity equation. 
! </DESCRIPTION>
!
subroutine ocean_velocity_init (Grid, Domain, Time, Time_steps, Ocean_options, &
                                Velocity, hor_grid, obc, use_blobs, introduce_blobs, &
                                velocity_override, debug)

  type(ocean_grid_type),   target, intent(in)    :: Grid
  type(ocean_domain_type), target, intent(in)    :: Domain
  type(ocean_time_type),           intent(in)    :: Time
  type(ocean_time_steps_type),     intent(in)    :: Time_steps 
  type(ocean_options_type),        intent(inout) :: Ocean_options
  type(ocean_velocity_type),       intent(inout) :: Velocity
  integer,                         intent(in)    :: hor_grid 
  logical,                         intent(in)    :: use_blobs
  logical,                         intent(in)    :: introduce_blobs
  logical,                         intent(in)    :: obc
  logical,                         intent(in)    :: velocity_override
  logical,               optional, intent(in)    :: debug

  integer               :: ioun, io_status, ierr
  integer               :: m, n
  integer               :: taum1, tau, taup1
  integer               :: tau_m0, tau_m1
  integer, dimension(4) :: siz 
  character(len=128)    :: filename
  character(len=128)    :: velfilename

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_velocity_mod (ocean_velocity_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  have_obc  = obc
  tendency  = Time_steps%tendency
  dtime     = Time_steps%dtime_u
  horz_grid = hor_grid 

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_velocity_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_velocity_nml')
#else
  ioun = open_namelist_file()
  read  (ioun, ocean_velocity_nml,iostat=io_status)
  ierr = check_nml_error(io_status, 'ocean_velocity_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit, ocean_velocity_nml)  
  write (stdlogunit, ocean_velocity_nml)

  if (PRESENT(debug) .and. .not. debug_this_module) then 
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') &
    '==>Note: running with debug_this_module=.true. so will print lots of checksums.'  
  endif 

  if(.not. write_a_restart) then 
    write(stdoutunit,'(a)') '==>Note: running ocean_velocity with write_a_restart=.false.'
    write(stdoutunit,'(a)') '   Will NOT write restart file, and so cannot restart the run.'
  endif 

  Dom => Domain
  Grd => Grid
  use_velocity_override = velocity_override


#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk=Grid%nk
  allocate (Velocity%u(isd:ied,jsd:jed,nk,2,3))
  allocate (Velocity%smf(isd:ied,jsd:jed,2))
  allocate (Velocity%smf_bgrid(isd:ied,jsd:jed,2))
  allocate (Velocity%smf_cgrid(isd:ied,jsd:jed,2))
  allocate (Velocity%bmf(isd:ied,jsd:jed,2))
  allocate (Velocity%gamma(isd:ied,jsd:jed))
  allocate (Velocity%langmuirfactor(isd:ied,jsd:jed))
  allocate (Velocity%ustoke(isd:ied,jsd:jed))
  allocate (Velocity%vstoke(isd:ied,jsd:jed))
  allocate (Velocity%wavlen(isd:ied,jsd:jed))
  allocate (Velocity%cdbot_array(isd:ied,jsd:jed))
  allocate (Velocity%rossby_radius(isd:ied,jsd:jed))
  allocate (Velocity%stokes_depth(isd:ied,jsd:jed))
  allocate (Velocity%stokes_drift(isd:ied,jsd:jed,nk,2))
  allocate (Velocity%press_force(isd:ied,jsd:jed,nk,2))
  allocate (Velocity%accel(isd:ied,jsd:jed,nk,2))
  allocate (Velocity%source(isd:ied,jsd:jed,nk,2))
  allocate (Velocity%wrkv(isd:ied,jsd:jed,nk,2))
  allocate (Velocity%advection(isd:ied,jsd:jed,nk,2,3))
  allocate (Velocity%coriolis(isd:ied,jsd:jed,nk,2,3))
  allocate (Velocity%vfrict_impl(isd:ied,jsd:jed,nk,2))
  allocate (Velocity%lap_friction_bt(isd:ied,jsd:jed,2))
  allocate (Velocity%bih_friction_bt(isd:ied,jsd:jed,2))
  allocate (Velocity%current_wave_stress(isd:ied,jsd:jed))
  allocate (Velocity%u10(isd:ied,jsd:jed))
  allocate (Velocity%ustar(isd:ied,jsd:jed))
#endif

  Velocity%smf                 = 0.0
  Velocity%smf_bgrid           = 0.0
  Velocity%smf_cgrid           = 0.0
  Velocity%bmf                 = 0.0
  Velocity%gamma               = 0.0
  Velocity%langmuirfactor      = 1.0
  Velocity%ustoke              = 0.0
  Velocity%vstoke              = 0.0
  Velocity%wavlen              = 1.0 
  Velocity%cdbot_array         = 0.0
  Velocity%rossby_radius       = 1.e5
  Velocity%stokes_depth        = 0.0
  Velocity%stokes_drift        = 0.0
  Velocity%accel               = 0.0
  Velocity%source              = 0.0
  Velocity%wrkv                = 0.0
  Velocity%press_force         = 0.0
  Velocity%advection           = 0.0
  Velocity%coriolis            = 0.0
  Velocity%vfrict_impl         = 0.0
  Velocity%lap_friction_bt     = 0.0
  Velocity%bih_friction_bt     = 0.0
  Velocity%current_wave_stress = 0.0
  Velocity%u10                 = 0.0
  Velocity%ustar                 = 0.0

  ! register fields for diagnostic output

  id_u(1)    = register_diag_field ('ocean_model', 'u', Grd%vel_axes_u(1:3), Time%model_time, &
     'i-current', 'm/sec', missing_value=missing_value, range=(/-10.0,10.0/),                 &
     standard_name='sea_water_x_velocity')
  id_u(2)    = register_diag_field ('ocean_model', 'v', Grd%vel_axes_v(1:3), Time%model_time, &
     'j-current', 'm/sec', missing_value=missing_value, range=(/-10.0,10.0/),                 &
     standard_name='sea_water_y_velocity')

  id_u_on_depth(1) = register_diag_field ('ocean_model', 'u_on_depth', Grd%vel_axes_u_depth(1:3), Time%model_time, &
     'i-current mapped to depth surface', 'm/sec', missing_value=missing_value, range=(/-10.0,10.0/))
  id_u_on_depth(2) = register_diag_field ('ocean_model', 'v_on_depth', Grd%vel_axes_v_depth(1:3), Time%model_time, &
     'j-current mapped to depth surface', 'm/sec', missing_value=missing_value, range=(/-10.0,10.0/))

  id_usurf(1)  = register_diag_field ('ocean_model', 'usurf', Grd%vel_axes_u(1:2), Time%model_time, &
     'i-surface current', 'm/sec', missing_value=missing_value, range=(/-10.0,10.0/))
  id_usurf(2)  = register_diag_field ('ocean_model', 'vsurf', Grd%vel_axes_v(1:2), Time%model_time, &
     'j-surface current', 'm/sec', missing_value=missing_value, range=(/-10.0,10.0/))

  id_ubott(1)  = register_diag_field ('ocean_model', 'ubott', Grd%vel_axes_u(1:2), Time%model_time, &
     'i-bottom current', 'm/sec', missing_value=missing_value, range=(/-10.0,10.0/))
  id_ubott(2)  = register_diag_field ('ocean_model', 'vbott', Grd%vel_axes_v(1:2), Time%model_time, &
     'j-bottom current', 'm/sec', missing_value=missing_value, range=(/-10.0,10.0/))

  id_accel(1) = register_diag_field ('ocean_model', 'accel_u', Grd%vel_axes_u(1:3), Time%model_time, &
     'baroclinic forcing of rho*u', '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1e9,1e9/))

  id_accel(2) = register_diag_field ('ocean_model', 'accel_v', Grd%vel_axes_v(1:3), Time%model_time, &
     'baroclinic forcing of rho*v', '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1e9,1e9/))

  id_converge_rho_ud_t = register_diag_field ('ocean_model', 'converge_rho_ud_t', Grd%tracer_axes(1:2), &
                     Time%model_time,'convergence rho*ud on T cells computed in velocity_mod',          &
                     '(kg/m^3)*(m/s)', missing_value=missing_value, range=(/-10.0,10.0/))

  ! smg: following diags need some work 

  id_speed = register_diag_field ('ocean_model', 'speed', Grd%vel_axes_uv(1:3), Time%model_time, &
     'speed of horizontal current', 'm/sec', missing_value=missing_value, range=(/-10.0,10.0/))


  if (truncate_velocity) then
      write (stdoutunit,'(/a)')&
      '==>Warning: truncate_velocity=.true. Model will truncate baroclinc velocity'
      write (stdoutunit,'(a,f5.3)')&
      '   so that max horz velocity magnitude is (m/s) ',truncate_velocity_value 
      write (stdoutunit,'(a,f8.3)') &
      '   Truncation occurs for regions poleward of the latitude',truncate_velocity_lat 
      write (stdoutunit,'(a)')&
      '   This option may be useful during the spin-up phase of an experiment.'
      write (stdoutunit,'(a/)')&
      '   It is also of use for polar filtering. '
  endif

  if(tendency==THREE_LEVEL) then 
     abtau_m0= 1.0
     abtau_m1= 0.0
     abtau_m2= 0.0
  endif 

  if(tendency==TWO_LEVEL) then 
     write(stdoutunit,'(/a)')'==>Note from ocean_velocity_mod: use of twolevel time_tendency' 
     write(stdoutunit,'(a)') '   necessitates an Adams-Bashforth treatment of velocity advection.'

     if(adams_bashforth_third) then 
       write(stdoutunit,'(/a)')'   Using 3rd order Adams-Bashforth for velocity advection.'
       write(stdoutunit,'(a/)')'   This is the MOM default. '
       abtau_m0= 23.0/12.0
       abtau_m1=-16.0/12.0
       abtau_m2= 5.0/12.0
     else 
       write(stdoutunit,'(/a,f8.3/)')' Using 2nd order Adams-Bashforth with dimensionless AB parameter = ', &
                                     adams_bashforth_epsilon 
       abtau_m0= 1.0 + adams_bashforth_epsilon
       abtau_m1= 0.0 - adams_bashforth_epsilon
       abtau_m2= 0.0
       if(adams_bashforth_epsilon < 0.5 .or. adams_bashforth_epsilon > 1.0) then 
        call mpp_error(FATAL,&
        '==>Error from ocean_velocity_mod: adams_bashforth parameter must be between 0.5 & 1.0')
       endif 
     endif  

  endif 

  if(zero_tendency) then
     call mpp_error(NOTE, &
     '==>zero_tendency=.true. so will not time step the baroclinic velocity field ')
     Ocean_options%baroclinic_tendency = 'Did NOT time step the baroclinic velocity.'
  else
     Ocean_options%baroclinic_tendency = 'Time stepped the baroclinic velocity.'
  endif 
  if(zero_tendency_explicit_a) then
     call mpp_error(NOTE, &
     '==>zero_tendency_explicit_a=.true. so will not include explicit_a velocity tendency ')
  endif 
  if(zero_tendency_explicit_b) then
     call mpp_error(NOTE, &
     '==>zero_tendency_explicit_b=.true. so will not include explicit_b velocity tendency ')
  endif 
  if(zero_tendency_implicit) then
     call mpp_error(NOTE, &
     '==>zero_tendency_implicit=.true. so will not include implicit part of the velocity tendency ')
  endif 

  if(update_velocity_via_uprime) then 
     call mpp_error(NOTE, &
     '==>update_velocity_via_uprime=.true., so keep udrho from external mode solver.')
  else
     call mpp_error(WARNING, &
     '==>update_velocity_via_uprime=.false., so recompute udrho after updating full velocity. For testing only!')
  endif 
  if(horz_grid == MOM_CGRID .and. .not. update_velocity_via_uprime) then 
     call mpp_error(WARNING, &
     '==>update_velocity_via_uprime=.false. is not supported for Cgrid.  Resetting update_velocity_via_uprime to true.')
  endif 

  if(use_velocity_override) then
      
      call mpp_error(NOTE, &
           '==>use_velocity_override=.true. so will over-ride prognosed (u,v)-velocity with values from a file.')
      write(stdoutunit,'(a)') '==>ocean_velocity_mod: override applied to (u,v)-velocity.'
      
      filename = 'INPUT/velocity_u_override.nc'
      if (file_exist(trim(filename))) then
          id_velocity_u_override = init_external_field(filename, "u", domain=Dom%domain2d)
      endif
      if (id_velocity_u_override == -1) then 
          call mpp_error(FATAL,'==>Error in ocean_velocity_mod: failed to find u field in INPUT/velocity_u_override.nc') 
      endif     
      
      filename = 'INPUT/velocity_v_override.nc'
      if (file_exist(trim(filename))) then
          id_velocity_v_override = init_external_field(filename, "v", domain=Dom%domain2d)
      endif 
      if (id_velocity_v_override == -1) then 
          call mpp_error(FATAL,'==>Error in ocean_velocity_mod: failed to find v field in INPUT/velocity_v_override.nc') 
      endif

      Ocean_options%override_velocity = 'Used velocity override for (u,v) and (udrho,vdrho) fields.' 

  else

      Ocean_options%override_velocity = 'Did NOT use velocity override'
      
  endif 

  if(use_constant_velocity) then 
     call mpp_error(NOTE, &
     '==>use_constant_velocity=.true. so will hold the velocity to a constant.')
     zero_tendency=.true.
     Ocean_options%baroclinic_tendency = 'Did NOT time step velocity; kept it = constant.'
     write(stdoutunit,'(a,f6.2,a,f6.2,a)') &
     '==>Note from ocean_velocity_init: velocity fixed at (u,v)(m/s) = (',constant_u,',',constant_v,')'
  endif 

  call check_gravity_wave_cfl()
  
  taum1 = Time%taum1
  tau   = Time%tau
  taup1 = Time%taup1

  tau_m1 = Time%tau_m1
  tau_m0 = Time%tau_m0

  ! initialize to small but nonzero velocity 
  do m=1,3 
     do n=1,2  
        Velocity%u(:,:,:,n,m) = epsln*Grd%umask(:,:,:)
     enddo
  enddo

  if(use_constant_velocity) then 
      do m=1,3 
         Velocity%u(:,:,:,1,m) = constant_u*Grd%umask(:,:,:)
         Velocity%u(:,:,:,2,m) = constant_v*Grd%umask(:,:,:)
      enddo
  endif

  filename = 'ocean_velocity.res.nc'
  velfilename = filename
  if(tendency==THREE_LEVEL) then
     id_restart_u = register_restart_field(Vel_restart, filename,'u',Velocity%u(:,:,:,1,tau), &
          Velocity%u(:,:,:,1,taup1), Dom%domain2d)
     id_restart_v = register_restart_field(Vel_restart, filename,'v',Velocity%u(:,:,:,2,tau), &
          Velocity%u(:,:,:,2,taup1), Dom%domain2d )
  elseif (tendency==TWO_LEVEL) then
     id_restart_u = register_restart_field(Vel_restart, filename,'u',Velocity%u(:,:,:,1,taup1), &
          Dom%domain2d )
     id_restart_v = register_restart_field(Vel_restart, filename,'v',Velocity%u(:,:,:,2,taup1), &
          Dom%domain2d )
     if (use_blobs .and. .not. introduce_blobs) then
        id_restart_px = register_restart_field(Vel_restart, filename,'pressurex',Velocity%press_force(:,:,:,1),&
             Dom%domain2d )
        id_restart_py = register_restart_field(Vel_restart, filename,'pressurey',Velocity%press_force(:,:,:,2),&
             Dom%domain2d )        
     endif
     filename = 'ocean_velocity_advection.res.nc'
     id_restart_advu = register_restart_field(Adv_restart, filename,'advectionu',Velocity%advection(:,:,:,1,tau_m1),&
          Velocity%advection(:,:,:,1,tau_m0), Dom%domain2d )
     id_restart_advv = register_restart_field(Adv_restart, filename,'advectionv',Velocity%advection(:,:,:,2,tau_m1),&
          Velocity%advection(:,:,:,2,tau_m0), Dom%domain2d )
  end if

  if(horz_grid == MOM_CGRID) then 
     filename = 'ocean_velocity_coriolis.res.nc'
     id_restart_coru = register_restart_field(Cor_restart, filename,'coriolisu',Velocity%coriolis(:,:,:,1,tau_m1),&
          Velocity%coriolis(:,:,:,1,tau_m0), Dom%domain2d )
     id_restart_corv = register_restart_field(Cor_restart, filename,'coriolisv',Velocity%coriolis(:,:,:,2,tau_m1),&
          Velocity%coriolis(:,:,:,2,tau_m0), Dom%domain2d )
  endif 


  filename = 'INPUT/ocean_velocity.res.nc'
  if (file_exist(trim(filename))) then 

      !--- read restart file data by calling restore_state
      call restore_state(Vel_restart)

      if(tendency==THREE_LEVEL) then

          write (stdoutunit,'(a)') '  Reading THREE_LEVEL restart for velocity from INPUT/ocean_velocity.res.nc'
          write (stdoutunit,'(a)') '  Expecting two time records for each restart field.'
          call mpp_update_domains(Velocity%u(:,:,:,1,tau), Velocity%u(:,:,:,2,tau),&
               Dom%domain2d,gridtype=BGRID_NE)
          call mpp_update_domains(Velocity%u(:,:,:,1,taup1), Velocity%u(:,:,:,2,taup1),&
               Dom%domain2d,gridtype=BGRID_NE)

          if(have_obc) then
            call ocean_obc_update_boundary(Velocity%u(:,:,:,1,taup1), 'M','n')
            call ocean_obc_update_boundary(Velocity%u(:,:,:,2,taup1), 'M','t')
            call ocean_obc_update_boundary(Velocity%u(:,:,:,1,taup1), 'Z','t')
            call ocean_obc_update_boundary(Velocity%u(:,:,:,2,taup1), 'Z','n')
            call ocean_obc_update_boundary(Velocity%u(:,:,:,1,tau), 'M','n')
            call ocean_obc_update_boundary(Velocity%u(:,:,:,2,tau), 'M','t')
            call ocean_obc_update_boundary(Velocity%u(:,:,:,1,tau), 'Z','t')
            call ocean_obc_update_boundary(Velocity%u(:,:,:,2,tau), 'Z','n')
          endif

      elseif (tendency==TWO_LEVEL) then

          write (stdoutunit,'(/a)') '  Reading TWO_LEVEL restart for velocity from INPUT/ocean_velocity.res.nc'
          write (stdoutunit,'(a)')  '  Expecting only one time record for each restart field.'

          call field_size(filename,'u', siz)
          if (siz(4) > 1) then
            write(stdoutunit,'(/a)') &
            '==>ERROR: Attempt to read ocean_velocity.res.nc from a 3-level time scheme (2 time records)'
            write(stdoutunit,'(a)')  &
            '          when running MOM with 2-level timestepping (only need 1 time record in restart).'
            write(stdoutunit,'(a)')  &
            '          Reduce restart file to a single time record in order to avoid confusion.'
            call mpp_error(FATAL,  &
            'Reading 3-time lev ocean_velocity.res.nc (w/ 2 time records) while using 2-lev (needs only 1 record)')
          endif

          if(horz_grid == MOM_BGRID) then 
             call mpp_update_domains(Velocity%u(:,:,:,1,taup1), Velocity%u(:,:,:,2,taup1),&
                  Dom%domain2d,gridtype=BGRID_NE)
             if(use_blobs .and. .not. introduce_blobs) then
                call mpp_update_domains(Velocity%press_force(:,:,:,1), Velocity%press_force(:,:,:,2),&
                  Dom%domain2d,gridtype=BGRID_NE)
             elseif(use_blobs .and. introduce_blobs) then
                ! If we are introducing blobs, pressurex and pressurey will not have been in the
                ! restart file, but, they will be written to the restart file at the end of this run.
                id_restart_px = register_restart_field(Vel_restart, velfilename,'pressurex',&
                     Velocity%press_force(:,:,:,1),Dom%domain2d )
                id_restart_py = register_restart_field(Vel_restart, velfilename,'pressurey',&
                     Velocity%press_force(:,:,:,2),Dom%domain2d )        
             endif
          else 
             call mpp_update_domains(Velocity%u(:,:,:,1,taup1), Velocity%u(:,:,:,2,taup1),&
                  Dom%domain2d,gridtype=CGRID_NE)
             if(use_blobs .and. .not. introduce_blobs) then
                call mpp_update_domains(Velocity%press_force(:,:,:,1), Velocity%press_force(:,:,:,2),&
                  Dom%domain2d,gridtype=CGRID_NE)
             elseif(use_blobs .and. introduce_blobs) then
                ! If we are introducing blobs, pressurex and pressurey will not have been in the
                ! restart file, but, they will be written to the restart file at the end of this run.
                id_restart_px = register_restart_field(Vel_restart, velfilename,'pressurex',&
                     Velocity%press_force(:,:,:,1),Dom%domain2d )
                id_restart_py = register_restart_field(Vel_restart, velfilename,'pressurey',&
                     Velocity%press_force(:,:,:,2),Dom%domain2d )        
             endif
          endif 


          write (stdoutunit,'(a)') '  Finished reading restart for velocity field'

          if(.not. Time%init) then  
              write (stdoutunit,'(/a)') '  Reading TWO_LEVEL restart from INPUT/ocean_velocity_advection.res.nc'
              write (stdoutunit,'(a)')  '  Expecting two time records for the advection velocity fields.'
              call restore_state(Adv_restart)
              write (stdoutunit,'(a)') '  Finished reading restart for velocity advection operator'

              call mpp_update_domains(Velocity%advection(:,:,:,1,tau_m1),Dom%domain2d)
              call mpp_update_domains(Velocity%advection(:,:,:,1,tau_m0),Dom%domain2d)
              call mpp_update_domains(Velocity%advection(:,:,:,2,tau_m1),Dom%domain2d)
              call mpp_update_domains(Velocity%advection(:,:,:,2,tau_m0),Dom%domain2d)

          endif

          if(have_obc) then
            call ocean_obc_update_boundary(Velocity%u(:,:,:,1,taup1), 'M','n')
            call ocean_obc_update_boundary(Velocity%u(:,:,:,2,taup1), 'M','t')
            call ocean_obc_update_boundary(Velocity%u(:,:,:,1,taup1), 'Z','t')
            call ocean_obc_update_boundary(Velocity%u(:,:,:,2,taup1), 'Z','n')
         endif
      endif

 else

     if (Time%init) then
          call mpp_error(NOTE,&
         '==> From ocean_velocity_mod: Initializing velocity to zero since Time%init=.true. &
          &and did not find INPUT/ocean_velocity.res.nc.')
     endif 

     if (.NOT. Time%init) then
          call mpp_error(FATAL,&
         '==> Error from ocean_velocity_mod: Expecting INPUT/ocean_velocity.res.nc to exist.&
          &This file was not found and Time%init=.false.')
     endif 

 endif

 ! Coriolis force saved for Cgrid 
 if(horz_grid == MOM_CGRID) then 

    filename = 'INPUT/ocean_velocity_coriolis.res.nc'
    if (file_exist(trim(filename))) then 

        !--- read restart file data by calling restore_state
        write (stdoutunit,'(/a)') '  Reading Coriolis restart from INPUT/ocean_velocity_coriolis.res.nc'
        write (stdoutunit,'(a)')  '  Expecting two time records for the Coriolis force.'
        call restore_state(Cor_restart)
        write (stdoutunit,'(a)') '  Finished reading restart for Coriolis force.'

        call mpp_update_domains(Velocity%coriolis(:,:,:,1,tau_m1),Dom%domain2d)
        call mpp_update_domains(Velocity%coriolis(:,:,:,1,tau_m0),Dom%domain2d)
        call mpp_update_domains(Velocity%coriolis(:,:,:,2,tau_m1),Dom%domain2d)
        call mpp_update_domains(Velocity%coriolis(:,:,:,2,tau_m0),Dom%domain2d)

    else 

       if (Time%init) then
          call mpp_error(NOTE,&
         '==> From ocean_velocity_mod: Initializing Coriolis to zero since Time%init=.true. &
          &and did not find INPUT/ocean_velocity_coriolis.res.nc.')
       endif 
       if (.NOT. Time%init) then
            call mpp_error(FATAL,&
           '==> Error from ocean_velocity_mod: Expecting INPUT/ocean_velocity_coriolis.res.nc to exist.&
            &This file was not found and Time%init=.false.')
       endif 

    endif 

 endif 

     write(stdoutunit,*)' ' 
     write(stdoutunit,*) '===Initial velocity checksums ==>'
     call write_timestamp(Time%model_time)
 if(tendency==THREE_LEVEL) then 
     write(stdoutunit,*) 'From ocean_velocity_mod: initial velocity chksum (tau)'
     call ocean_velocity_chksum(Velocity, tau, write_advection=.false.)
     write(stdoutunit,*) 'From ocean_velocity_mod: initial velocity chksum (taup1)'
     call ocean_velocity_chksum(Velocity, taup1, write_advection=.false.)
 else
     write(stdoutunit,*) 'From ocean_velocity_mod: initial velocity chksum (taup1)'
     call ocean_velocity_chksum(Velocity, taup1, write_advection=.true.)
 endif

end subroutine ocean_velocity_init
! </SUBROUTINE> NAME="ocean_velocity_init"



!#######################################################################
! <SUBROUTINE NAME="check_gravity_wave_cfl">
!
! <DESCRIPTION>
! Check CFL for internal gravity waves. 
! </DESCRIPTION>
!
 subroutine check_gravity_wave_cfl()

    logical :: cfl_error=.false.
    real    :: gridsp, dtcg, max_dt_for_cgint0
    real    :: cfl_grid_factor, dtuv
    integer :: i, j, icg, jcg
    integer :: stdlogunit
    stdlogunit=stdlog()
   
   ! estimate the maximum timestep allowable for resolving internal gravity waves
    if(tendency==TWO_LEVEL)   then 
       cfl_grid_factor=1.0
       dtuv = dtime 
    elseif(tendency==THREE_LEVEL) then
       cfl_grid_factor=0.5
       dtuv = 0.5*dtime
    endif 
    icg = isc; jcg = jsc; gridsp = 1.0e20; max_dt_for_cgint = 1.0e6
    do j=jsc,jec
       do i=isc,iec
          if (Grd%kmu(i,j) > 0) then
              gridsp = 1.0/(Grd%dxu(i,j)*Grd%dxu(i,j)) + 1.0/(Grd%dyu(i,j)*Grd%dyu(i,j))
              gridsp = sqrt(1.0/gridsp) 
              dtcg = cfl_grid_factor*gridsp/(epsln+max_cgint)                       
              if (dtcg < max_dt_for_cgint) then
                  max_dt_for_cgint = dtcg; icg  = i; jcg  = j
              endif
          endif
       enddo
    enddo
    max_dt_for_cgint = nint(max_dt_for_cgint)
    max_dt_for_cgint = max_dt_for_cgint + 1.e-12*mpp_pe() ! to separate redundancies
    max_dt_for_cgint0 = max_dt_for_cgint
    call mpp_min (max_dt_for_cgint)

    ! show the most unstable location for baroclinic gravity waves
    if (max_dt_for_cgint == max_dt_for_cgint0 .and. nint(dtuv) > 0) then
        if (dtuv <= max_dt_for_cgint) then
            write (unit,'(/a,i4,a,i4,a,f9.2,a,f9.2,a)') &
            ' Baroclinic time step stability most nearly violated at U-cell (i,j) = (',&
                 icg+Dom%ioff,',',jcg+Dom%joff,'), (lon,lat) = (',Grd%xu(icg,jcg),',',Grd%yu(icg,jcg),').'
            write(unit,'(a,i6)')    '         The number of kmu-levels  at this point is ',Grd%kmu(icg,jcg) 
            write(unit,'(a,e12.6)') '         The dxu grid distance (m) at this point is ',Grd%dxu(icg,jcg) 
            write(unit,'(a,e12.6)') '         The dyu grid distance (m) at this point is ',Grd%dyu(icg,jcg) 
            cfl_error=.false.
        else
            write (unit,'(/a,i4,a,i4,a,f9.2,a,f9.2,a)') &
            '==>Error: Baroclinic time step stability violated at U-cell (i,j) = (',&
                 icg+Dom%ioff,',',jcg+Dom%joff,'), (lon,lat) = (',Grd%xu(icg,jcg),',',Grd%yu(icg,jcg),').'
            write(unit,'(a,i6)')    '         The number of kmu-levels  at this point is ',Grd%kmu(icg,jcg) 
            write(unit,'(a,e12.6)') '         The dxu grid distance (m) at this point is ',Grd%dxu(icg,jcg) 
            write(unit,'(a,e12.6)') '         The dyu grid distance (m) at this point is ',Grd%dyu(icg,jcg) 
            cfl_error=.true.
        endif
        write (unit,'(a,f5.2,a/a,f6.0,a,f6.0,a)')&
             '         Due to a specified maximum baroclinic gravity wave speed of ',max_cgint,' m/s.',&
             '         "dtuv" must be less than ',max_dt_for_cgint,' sec. "dtuv" = ', dtuv,' sec.'
        if(cfl_error) then  
          call mpp_error(FATAL, &
          '==>Error: time step instability detected for baroclinic gravity waves in ocean_model_mod')
        endif 
        write (stdlogunit,'(/a/)') &
        ' Note: A more appropriate maximum baroclinic gravity wave speed can be specified via namelist.'
    endif
    max_dt_for_cgint = nint(max_dt_for_cgint)
    
  end subroutine check_gravity_wave_cfl
! </SUBROUTINE> NAME="check_gravity_wave_cfl"


 
!#######################################################################
! <SUBROUTINE NAME="ocean_explicit_accel_a">
!
! <DESCRIPTION>
!
! Time explicit contributions to thickness weighted and density 
! weighted acceleration.
! 
! Omit here the Coriolis force and vertical friction. 
! They are omitted in order to facilitate the construction of the 
! vertically integrated forcing of the barotropic dynamics.  
! They will be added later in ocean_explicit_accel_b. 
!
! </DESCRIPTION>
!
subroutine ocean_explicit_accel_a(Velocity, Time, Adv_vel, Thickness, Dens, &
                                  L_system, rho, pme, river, upme, uriver)

  type(ocean_velocity_type),      intent(inout) :: Velocity
  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_adv_vel_type),       intent(in)    :: Adv_vel
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_density_type),       intent(in)    :: Dens
  type(ocean_lagrangian_type),    intent(inout) :: L_system
  real, dimension(isd:,jsd:,:),   intent(in)    :: rho
  real, dimension(isd:,jsd:),     intent(in)    :: pme
  real, dimension(isd:,jsd:),     intent(in)    :: river
  real, dimension(isd:,jsd:,:),   intent(in)    :: upme
  real, dimension(isd:,jsd:,:),   intent(in)    :: uriver 

  integer :: i, j, k, n
  integer :: taum1, tau, taup1
  integer :: tau_m0, tau_m1, tau_m2

  integer :: stdoutunit 
  stdoutunit=stdout() 

  taum1 = Time%taum1
  tau   = Time%tau
  taup1 = Time%taup1

  tau_m2 = Time%tau_m2
  tau_m1 = Time%tau_m1
  tau_m0 = Time%tau_m0

  ! initialize to zero 
  do n=1,2
     do k=1,nk
        do j=jsd,jed
           do i=isd,ied
              Velocity%accel(i,j,k,n)            = 0.0 
              Velocity%source(i,j,k,n)           = 0.0 
              Velocity%press_force(i,j,k,n)      = 0.0 
              Velocity%advection(i,j,k,n,tau_m0) = 0.0 
              Velocity%coriolis(i,j,k,n,tau_m0)  = 0.0 
           enddo
        enddo
     enddo
  enddo
  
  if (.not. zero_tendency .and. .not. zero_tendency_explicit_a) then 

      ! fill Velocity%advection(tau_m0) 
      call horz_advection_of_velocity(Time, Thickness, Adv_vel, Velocity, energy_analysis_step=.false.)       
      call vert_advection_of_velocity(Time, Adv_vel, Velocity, &
                                      pme, river, upme, uriver, energy_analysis_step=.false.)       

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%accel(i,j,k,n) = -abtau_m0*Velocity%advection(i,j,k,n,tau_m0) & 
                                            -abtau_m1*Velocity%advection(i,j,k,n,tau_m1) & 
                                            -abtau_m2*Velocity%advection(i,j,k,n,tau_m2)  
               enddo
            enddo
         enddo
      enddo

      ! include contribution from horizontal pressure gradient 
      call pressure_force(Time, Thickness, Dens, Velocity, L_system, rho(:,:,:)) 
      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%accel(i,j,k,n) = Velocity%accel(i,j,k,n) + Velocity%press_force(i,j,k,n) 
               enddo
            enddo
         enddo
      enddo

      ! compute horizontal friction and add to Velocity%accel 
      call lap_friction(Time, Thickness, Adv_vel, Velocity, energy_analysis_step=.false.)
      call bih_friction(Time, Thickness, Adv_vel, Velocity, energy_analysis_step=.false.)

      ! compute momentum source/sinks and add to Velocity%accel 
      call momentum_source(Time, Thickness, Velocity, energy_analysis_step=.false.)

      ! compute parameterized form drag and add to Velocity%accel 
      call form_drag_accel(Time, Thickness, Velocity, energy_analysis_step=.false.)

  endif

  if (debug_this_module) then
      write(stdoutunit,*) ' ' 
      write(stdoutunit,*) 'From ocean_velocity_mod: acceleration chksums'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('explicit accel_a(1)', Velocity%accel(COMP,:,1))
      call write_chksum_3d('explicit accel_a(2)', Velocity%accel(COMP,:,2))
  endif

end subroutine ocean_explicit_accel_a
! </SUBROUTINE> NAME="ocean_explicit_accel_a"

 
!#######################################################################
! <SUBROUTINE NAME="ocean_explicit_accel_b">
!
! <DESCRIPTION>
!
! Add the contributions from the Coriolis force, computed explicitly 
! in time, and those from explicit vertical friction.  Add these to
! the thickness weighted and density weighted acceleration. 
!
! Note: no visc_cbu_form_drag is included here, since it must
! be handled via implicit vertical friction to maintain stability
! for general cases. 
!
! </DESCRIPTION>
!
subroutine ocean_explicit_accel_b(visc_cbu, visc_cbt, Time, Thickness, Adv_vel, Velocity)

  real, dimension(isd:,jsd:,:),   intent(in)    :: visc_cbu
  real, dimension(isd:,jsd:,:),   intent(in)    :: visc_cbt
  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_adv_vel_type),       intent(in)    :: Adv_vel
  type(ocean_velocity_type),      intent(inout) :: Velocity
  
  integer :: stdoutunit 
  integer :: tau_m0, tau_m1, tau_m2

  tau_m2 = Time%tau_m2
  tau_m1 = Time%tau_m1
  tau_m0 = Time%tau_m0
  stdoutunit=stdout() 

  if (.not. zero_tendency .and. .not. zero_tendency_explicit_b) then 

      if(horz_grid == MOM_BGRID) then    
         call vert_friction_bgrid(Time, Thickness, Velocity, visc_cbu, energy_analysis_step=.false.)
         call coriolis_force_bgrid(Time, Thickness, Velocity, energy_analysis_step=.false.)
      else 
         call vert_friction_cgrid(Time, Thickness, Velocity, visc_cbt, energy_analysis_step=.false.)
         call coriolis_force_cgrid(Time, Adv_vel, Velocity, abtau_m0, abtau_m1, abtau_m2, &
                                   energy_analysis_step=.false.)
      endif 

      if (debug_this_module) then
          write(stdoutunit,*) ' ' 
          write(stdoutunit,*) 'From ocean_velocity_mod: explicit acceleration chksums'
          call write_timestamp(Time%model_time)
          call write_chksum_3d('accel_b(1)', Velocity%accel(COMP,:,1))
          call write_chksum_3d('accel_b(2)', Velocity%accel(COMP,:,2))
      endif

  endif


end subroutine ocean_explicit_accel_b
! </SUBROUTINE> NAME="ocean_explicit_accel_b"


!#######################################################################
! <SUBROUTINE NAME="ocean_implicit_accel">
!
! <DESCRIPTION>
!
! Add the time implicit contributions from the Coriolis force
! and vertical friction. Add these to the thickness weighted 
! and density weighted acceleration. 
!
! Note the contribution from visc_cbu_form_drag is used for 
! implicit vertical friction. 
!
! Note there is no time implicit Coriolis for Cgrid.
!
! </DESCRIPTION>
!
subroutine ocean_implicit_accel(visc_cbu, visc_cbt, visc_cbu_form_drag, Time, Thickness, Adv_vel, Velocity)

  real, dimension(isd:,jsd:,:),   intent(in)    :: visc_cbu
  real, dimension(isd:,jsd:,:),   intent(in)    :: visc_cbt
  real, dimension(isd:,jsd:,:,:), intent(in)    :: visc_cbu_form_drag
  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_adv_vel_type),       intent(in)    :: Adv_vel
  type(ocean_velocity_type),      intent(inout) :: Velocity
  
  integer :: stdoutunit 
  stdoutunit=stdout() 

  if (.not. zero_tendency .and. .not. zero_tendency_implicit) then 

      if(horz_grid == MOM_BGRID) then    
         call vert_friction_implicit_bgrid(visc_cbu, visc_cbu_form_drag, Time, Thickness, Velocity)
         call coriolis_force_bgrid_implicit(Time, Velocity) 
      else 
         call vert_friction_implicit_cgrid(visc_cbt, visc_cbu_form_drag, Time, Thickness, Adv_vel, Velocity)
      endif 

      if (debug_this_module) then
          write(stdoutunit,*) ' ' 
          write(stdoutunit,*) 'From ocean_velocity_mod: acceleration chksums after implicit update'
          call write_timestamp(Time%model_time)
          call write_chksum_3d('accel(1)', Velocity%accel(COMP,:,1))
          call write_chksum_3d('accel(2)', Velocity%accel(COMP,:,2))
      endif
  endif

  ! since implicit_accel is the last piece of accel computed, it is 
  ! time to now output the full acceleration to diagnostics manager. 
  if(horz_grid == MOM_BGRID) then 
     call diagnose_3d_u(Time, Grd, id_accel(1), Velocity%accel(:,:,:,1))
     call diagnose_3d_u(Time, Grd, id_accel(2), Velocity%accel(:,:,:,2))
  else
     call diagnose_3d(Time, Grd, id_accel(1), Velocity%accel(:,:,:,1))
     call diagnose_3d(Time, Grd, id_accel(2), Velocity%accel(:,:,:,2))
  endif


end subroutine ocean_implicit_accel
! </SUBROUTINE> NAME="ocean_implicit_accel"


!#######################################################################
! <SUBROUTINE NAME="update_ocean_velocity_bgrid">
!
! <DESCRIPTION>
! Update velocity components.
! There are two general methods available.
! 
! 1/ update baroclinic velocity; then add (udrho,vdrho) from external 
! mode algorithm to get the full velocity field.  This method is 
! analogous to the older approach with the rigid lid. 
!
! 2/ update the full velocity, so there is no need to introduce the 
! intermediate step with the baroclinic velocity.  To remain stable,
! we must use the time filtered barotropic pressure gradient.  
! We then diagnose the vertically integrated horizontal momentum
! (udrho,vdrho) and its convergence, since these fields are needed
! elsewhere.  
! 
! </DESCRIPTION>
!
subroutine update_ocean_velocity_bgrid(Time, Thickness, barotropic_split, &
                                       vert_coordinate_class, Ext_mode, Velocity)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  integer,                        intent(in)    :: barotropic_split
  integer,                        intent(in)    :: vert_coordinate_class
  type(ocean_external_mode_type), intent(inout) :: Ext_mode
  type(ocean_velocity_type),      intent(inout) :: Velocity

  real, dimension(isd:ied,jsd:jed) :: tmp
  real, dimension(isd:ied,jsd:jed) :: tmpu
  real, dimension(isd:ied,jsd:jed) :: tmpv
  integer :: i, j, k, kbot, n
  integer :: taum1, tau, taup1

  integer :: stdoutunit 
  stdoutunit=stdout() 

  taum1 = Time%taum1
  tau   = Time%tau
  taup1 = Time%taup1
  tmp   = 0.0

  if (barotropic_split > 1 .and. update_velocity_via_uprime) then  

      do n=1,2

         ! compute uprime 
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%u(i,j,k,n,taup1) = Thickness%rho_dzur(i,j,k)           &
                       *(Thickness%rho_dzu(i,j,k,taum1)*Velocity%u(i,j,k,n,taum1) &
                       +dtime*Velocity%accel(i,j,k,n)*Grd%umask(i,j,k) )                
               enddo
            enddo
         enddo

         ! sum uprime*rho_dzu
         tmp=0.0
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec  
                  tmp(i,j) = tmp(i,j) &
                       +Velocity%u(i,j,k,n,taup1)*Thickness%rho_dzu(i,j,k,taup1)*Grd%umask(i,j,k)
               enddo
            enddo
         enddo

         ! (vertical mean) - (value from barotropic integration) 
         do j=jsc,jec
            do i=isc,iec  
               tmp(i,j) = Grd%umask(i,j,1)*(tmp(i,j)-Ext_mode%udrho(i,j,n,taup1)) &
                    /(Thickness%mass_u(i,j,taup1)+epsln) 
            enddo
         enddo

         ! replace vertical mean with value from barotropic integration to update velocity 
         do k=1,nk 
            do j=jsc,jec
               do i=isc,iec  
                  Velocity%u(i,j,k,n,taup1) = (Velocity%u(i,j,k,n,taup1)-tmp(i,j))*Grd%umask(i,j,k) 
               enddo
            enddo
         enddo

      enddo  ! finish the n=1,2 do-loop 


  ! update full velocity directly with the full pressure gradient.  
  ! barotropic contribution to pressure gradient is time averaged
  ! if barotropic_split>1.  Unless dtuv is very small, this approach
  ! can be rather unstable.  User beware! 
  else  

      do n=1,2

         if(vert_coordinate_class==DEPTH_BASED) then 

             ! include gradient of surface pressure 
             do k=1,nk 
                do j=jsc,jec
                   do i=isc,iec 
                      Velocity%u(i,j,k,n,taup1) =                                                    &
                      (Thickness%rho_dzu(i,j,k,taum1)*Velocity%u(i,j,k,n,taum1)                      &
                      +dtime*(Velocity%accel(i,j,k,n)                                                &
                      -rho0r*Thickness%rho_dzu(i,j,k,tau)*Ext_mode%grad_ps(i,j,n)*Grd%umask(i,j,k))) &
                      *Thickness%rho_dzur(i,j,k)
                   enddo
                enddo
             enddo

         else 
  
            ! include gradient of bottom pressure
             do k=1,nk 
                do j=jsc,jec
                   do i=isc,iec 
                      Velocity%u(i,j,k,n,taup1) =                                                        &
                      (Thickness%rho_dzu(i,j,k,taum1)*Velocity%u(i,j,k,n,taum1)                          &
                      +dtime*(Velocity%accel(i,j,k,n)                                                    &
                      -rho0r*Thickness%rho_dzu(i,j,k,tau)*Ext_mode%grad_anompb(i,j,n)*Grd%umask(i,j,k))) &
                      *Thickness%rho_dzur(i,j,k)
                   enddo
                enddo
             enddo

         endif

         ! diagnose vertically integrated horizontal momentum 
         Ext_mode%udrho(:,:,n,taup1) = 0.0
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Ext_mode%udrho(i,j,n,taup1) = Ext_mode%udrho(i,j,n,taup1) &
                       +Velocity%u(i,j,k,n,taup1)*Thickness%rho_dzu(i,j,k,taup1)
               enddo
            enddo
         enddo

      enddo  ! end for n=1,2

      ! fill halos for vertically integrated horizontal momentum
      if(horz_grid == MOM_BGRID) then 
         call mpp_update_domains (Ext_mode%udrho(:,:,1,taup1),Ext_mode%udrho(:,:,2,taup1), &
                                  Dom%domain2d, gridtype=BGRID_NE)
      else 
         call mpp_update_domains (Ext_mode%udrho(:,:,1,taup1),Ext_mode%udrho(:,:,2,taup1), &
                                  Dom%domain2d, gridtype=CGRID_NE)
      endif 

      ! construct convergence of udrho at (tau+1)
      Ext_mode%conv_rho_ud_t(:,:,taup1) = -DIV_UD(Ext_mode%udrho(:,:,:,taup1),1,1)
      call mpp_update_domains (Ext_mode%conv_rho_ud_t(:,:,taup1), Dom%domain2d)

  endif   ! endif for splitting or uprime method 


  ! override update of velocity in the case of zero tendency 
  if(zero_tendency) then 
     Velocity%u(isc:iec,jsc:jec,:,:,taup1) = Velocity%u(isc:iec,jsc:jec,:,:,tau)
  endif 

  ! override update of u-velocity with value from a file 
  if(use_velocity_override .and. id_velocity_u_override > 0) then 
     wrk1(:,:,:) = 0.0
     call time_interp_external(id_velocity_u_override, Time%model_time, wrk1)
     Velocity%u(isc:iec,jsc:jec,:,1,taup1) = wrk1(isc:iec,jsc:jec,:)*Grd%umask(isc:iec,jsc:jec,:)
  endif 

  ! override update of v-velocity with value from a file 
  if(use_velocity_override .and. id_velocity_v_override > 0) then 
     wrk1(:,:,:) = 0.0
     call time_interp_external(id_velocity_v_override, Time%model_time, wrk1)
     Velocity%u(isc:iec,jsc:jec,:,2,taup1) = wrk1(isc:iec,jsc:jec,:)*Grd%umask(isc:iec,jsc:jec,:)
  endif 


  ! for debugging 
  do n=1,2

     if(truncate_velocity) then 
         call velocity_truncate(n, taup1, Velocity)
     endif

     if (debug_this_module .and. n==2) then        
         write(stdoutunit,*) ' ' 
         write(stdoutunit,*) 'From update_ocean_velocity at the u-prime step'
         call write_timestamp(Time%model_time)
         call write_chksum_3d('accel(1)', Velocity%accel(COMP,:,1))
         call write_chksum_3d('accel(2)', Velocity%accel(COMP,:,2))
         call write_chksum_3d('rho_dzu(taup1)', Thickness%rho_dzu(COMP,:,taup1))
         call write_chksum_3d('rho_dzu(taum1)', Thickness%rho_dzu(COMP,:,taum1))
         call write_chksum_3d('rho_dzur', Thickness%rho_dzur(COMP,:))
         call write_chksum_2d('udrho(1)', Ext_mode%udrho(COMP,1,taup1))
         call write_chksum_2d('udrho(2)', Ext_mode%udrho(COMP,2,taup1))
         call write_chksum_2d('mass_u', Thickness%mass_u(COMP,taup1))
         call ocean_velocity_chksum(Velocity, taum1, write_advection=.false.)
         call ocean_velocity_chksum(Velocity, taup1, write_advection=.false.)
     endif

  enddo


  !--- update velocity at the global halo points to make the gradient 0 across boundary
  if(have_obc) then
     call ocean_obc_update_boundary(Velocity%u(:,:,:,1,taup1), 'M','n')
     call ocean_obc_update_boundary(Velocity%u(:,:,:,2,taup1), 'M','t')
     call ocean_obc_update_boundary(Velocity%u(:,:,:,1,taup1), 'Z','t')
     call ocean_obc_update_boundary(Velocity%u(:,:,:,2,taup1), 'Z','n')
  endif

  if (debug_this_module) then        
     write(stdoutunit,*) ' ' 
     write(stdoutunit,*) 'From update_ocean_velocity: velocity(taup1) chksum'
     call write_timestamp(Time%model_time)
     call ocean_velocity_chksum(Velocity, taup1, write_advection=.false.)
  endif

  ! send diagnostics to diagnostics manager 
  call diagnose_3d_u(Time, Grd, id_u(1), Velocity%u(:,:,:,1,tau))
  call diagnose_3d_u(Time, Grd, id_u(2), Velocity%u(:,:,:,2,tau))

  call diagnose_2d_u(Time, Grd, id_usurf(1), Velocity%u(:,:,1,1,tau))
  call diagnose_2d_u(Time, Grd, id_usurf(2), Velocity%u(:,:,1,2,tau))

  call diagnose_2d(Time, Grd, id_converge_rho_ud_t, Ext_mode%conv_rho_ud_t(:,:,tau))

  if(id_speed > 0) then 
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               wrk1(i,j,k) = sqrt(Velocity%u(i,j,k,1,tau)**2 + Velocity%u(i,j,k,2,tau)**2)
            enddo
         enddo
      enddo
      call diagnose_3d_u(Time, Grd, id_speed, wrk1(:,:,:))
  endif

  if(id_ubott(1) > 0 .or. id_ubott(2) > 0) then 
      tmpu = 0.0 ; tmpv = 0.0
      do j=jsd,jed
         do i=isd,ied
            kbot = Grd%kmu(i,j)
            if(kbot > 1) then 
                tmpu(i,j) = Velocity%u(i,j,kbot,1,tau)
                tmpv(i,j) = Velocity%u(i,j,kbot,2,tau)
            endif
         enddo
      enddo
      call diagnose_2d_u(Time, Grd, id_ubott(1), tmpu(:,:))
      call diagnose_2d_u(Time, Grd, id_ubott(2), tmpv(:,:))
  endif

  if(id_u_on_depth(1) > 0) then 
    call remap_s_to_depth(Thickness, Time, Velocity%u(:,:,:,1,tau), 1)
  endif 
  if(id_u_on_depth(2) > 0) then 
    call remap_s_to_depth(Thickness, Time, Velocity%u(:,:,:,2,tau), 2)
  endif 


end subroutine update_ocean_velocity_bgrid
! </SUBROUTINE> NAME="update_ocean_velocity_bgrid"


!#######################################################################
! <SUBROUTINE NAME="update_ocean_velocity_cgrid">
!
! <DESCRIPTION>
! Update velocity components, assuming Cgrid layout.
!
! Also assume splitting, so update baroclinic velocity; 
! then add (udrho,vdrho) from external mode algorithm to get the
! full velocity field.  This method is 
! analogous to the older approach with the rigid lid. 
!
! As we have already called update_ucell_thickness, the array
! rho_dzten has been udpated to taup1.  We use Adv_vel to obtain 
! the tau value of (u,v)*rho_dzten, since Adv_vel has been computed
! at the start of the time stepping using (u,v)(tau).
!
! </DESCRIPTION>
!
subroutine update_ocean_velocity_cgrid(Time, Thickness, Adv_vel, Ext_mode, Velocity)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_adv_vel_type),       intent(in)    :: Adv_vel
  type(ocean_external_mode_type), intent(inout) :: Ext_mode
  type(ocean_velocity_type),      intent(inout) :: Velocity

  real, dimension(isd:ied,jsd:jed) :: tmp
  real, dimension(isd:ied,jsd:jed) :: tmpu
  real, dimension(isd:ied,jsd:jed) :: tmpv
  real :: rho_dz_vel_tau
  integer :: i, j, k, kbot, n
  integer :: taum1, tau, taup1

  integer :: stdoutunit 
  stdoutunit=stdout() 

  taum1 = Time%taum1
  tau   = Time%tau
  taup1 = Time%taup1
  tmp   = 0.0

  do n=1,2

     ! compute uprime 
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              rho_dz_vel_tau = (2-n)*Adv_vel%uhrho_et(i,j,k)*Grd%dxte_dxtr(i,j)*Grd%dyte_dytr(i,j) &
                              +(n-1)*Adv_vel%vhrho_nt(i,j,k)*Grd%dxtn_dxtr(i,j)*Grd%dytn_dytr(i,j)
              Velocity%u(i,j,k,n,taup1) = Grd%tmasken(i,j,k,n)*(rho_dz_vel_tau + dtime*Velocity%accel(i,j,k,n)*Grd%tmasken(i,j,k,n)) &
                                          /(epsln + Thickness%rho_dzten(i,j,k,n))                
           enddo
        enddo
     enddo

     ! sum uprime*rho_dzten
     tmp=0.0
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec  
              tmp(i,j) = tmp(i,j) + Velocity%u(i,j,k,n,taup1)*Thickness%rho_dzten(i,j,k,n)*Grd%tmasken(i,j,k,n)
           enddo
        enddo
     enddo

     ! (vertical mean) - (value from barotropic integration) 
     do j=jsc,jec
        do i=isc,iec  
           tmp(i,j) = Grd%tmasken(i,j,1,n)*(tmp(i,j)-Ext_mode%udrho(i,j,n,taup1))/(Thickness%mass_en(i,j,n)+epsln) 
        enddo
     enddo

     ! replace vertical mean with value from barotropic integration to update velocity 
     do k=1,nk 
        do j=jsc,jec
           do i=isc,iec  
              Velocity%u(i,j,k,n,taup1) = (Velocity%u(i,j,k,n,taup1)-tmp(i,j))*Grd%tmasken(i,j,k,n) 
           enddo
        enddo
     enddo

  enddo  ! finish the n=1,2 do-loop 


  ! override update of velocity in the case of zero tendency 
  if(zero_tendency) then 
     Velocity%u(isc:iec,jsc:jec,:,:,taup1) = Velocity%u(isc:iec,jsc:jec,:,:,tau)
  endif 

  ! override update of u-velocity with value from a file 
  if(use_velocity_override .and. id_velocity_u_override > 0) then 
     wrk1(:,:,:) = 0.0
     call time_interp_external(id_velocity_u_override, Time%model_time, wrk1)
     Velocity%u(isc:iec,jsc:jec,:,1,taup1) = wrk1(isc:iec,jsc:jec,:)*Grd%tmasken(isc:iec,jsc:jec,:,1)
  endif 

  ! override update of v-velocity with value from a file 
  if(use_velocity_override .and. id_velocity_v_override > 0) then 
     wrk1(:,:,:) = 0.0
     call time_interp_external(id_velocity_v_override, Time%model_time, wrk1)
     Velocity%u(isc:iec,jsc:jec,:,2,taup1) = wrk1(isc:iec,jsc:jec,:)*Grd%tmasken(isc:iec,jsc:jec,:,2)
  endif 


  ! for debugging 
  do n=1,2

     if(truncate_velocity) then 
         call velocity_truncate(n, taup1, Velocity)
     endif

     if (debug_this_module .and. n==2) then        
         write(stdoutunit,*) ' ' 
         write(stdoutunit,*) 'From update_ocean_velocity at the u-prime step'
         call write_timestamp(Time%model_time)
         call write_chksum_3d('accel(1)', Velocity%accel(COMP,:,1))
         call write_chksum_3d('accel(2)', Velocity%accel(COMP,:,2))
         call write_chksum_3d('rho_dzten(1)', Thickness%rho_dzten(COMP,:,1))
         call write_chksum_3d('rho_dzten(2)', Thickness%rho_dzten(COMP,:,2))
         call write_chksum_2d('udrho(1)', Ext_mode%udrho(COMP,1,taup1))
         call write_chksum_2d('udrho(2)', Ext_mode%udrho(COMP,2,taup1))
         call write_chksum_2d('mass_en(1)', Thickness%mass_en(COMP,1))
         call write_chksum_2d('mass_en(2)', Thickness%mass_en(COMP,2))
         call ocean_velocity_chksum(Velocity, taum1, write_advection=.false.)
         call ocean_velocity_chksum(Velocity, taup1, write_advection=.false.)
     endif

  enddo


  !--- update velocity at the global halo points to make the gradient 0 across boundary
  if(have_obc) then
     call ocean_obc_update_boundary(Velocity%u(:,:,:,1,taup1), 'M','n')
     call ocean_obc_update_boundary(Velocity%u(:,:,:,2,taup1), 'M','t')
     call ocean_obc_update_boundary(Velocity%u(:,:,:,1,taup1), 'Z','t')
     call ocean_obc_update_boundary(Velocity%u(:,:,:,2,taup1), 'Z','n')
  endif

  if (debug_this_module) then        
     write(stdoutunit,*) ' ' 
     write(stdoutunit,*) 'From update_ocean_velocity: velocity(taup1) chksum'
     call write_timestamp(Time%model_time)
     call ocean_velocity_chksum(Velocity, taup1, write_advection=.false.)
  endif

  ! send diagnostics to diagnostics manager 
  if (id_u(1) > 0) used = send_data (id_u(1), Velocity%u(:,:,:,1,tau), &
                       Time%model_time, rmask=Grd%mask(:,:,:),         &
                       is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)

  if (id_u(2) > 0) used = send_data (id_u(2), Velocity%u(:,:,:,2,tau), &
                       Time%model_time, rmask=Grd%mask(:,:,:),         &
                       is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)

  if (id_usurf(1) > 0) used = send_data (id_usurf(1), Velocity%u(:,:,1,1,tau), &
                           Time%model_time, rmask=Grd%mask(:,:,1),             &
                           is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)

  if (id_usurf(2) > 0) used = send_data (id_usurf(2), Velocity%u(:,:,1,2,tau), &
                           Time%model_time, rmask=Grd%mask(:,:,1),             &
                           is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)

  call diagnose_2d(Time, Grd, id_converge_rho_ud_t, Ext_mode%conv_rho_ud_t(:,:,tau))

  if(id_speed > 0) then 
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               wrk1(i,j,k) = sqrt(Velocity%u(i,j,k,1,tau)**2 + Velocity%u(i,j,k,2,tau)**2)
            enddo
         enddo
      enddo
      used = send_data (id_speed, wrk1(:,:,:),       &
             Time%model_time, rmask=Grd%mask(:,:,:), &
             is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
  endif

  if(id_ubott(1) > 0 .or. id_ubott(2) > 0) then 
      tmpu = 0.0 ; tmpv = 0.0
      do j=jsd,jed
         do i=isd,ied
            kbot = Grd%kmu(i,j)
            if(kbot > 1) then 
                tmpu(i,j) = Velocity%u(i,j,kbot,1,tau)
                tmpv(i,j) = Velocity%u(i,j,kbot,2,tau)
            endif
         enddo
      enddo
      if (id_ubott(1) > 0) used = send_data (id_ubott(1), tmpu(:,:),      &
                                  Time%model_time, rmask=Grd%mask(:,:,1), &
                                  is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
      if (id_ubott(2) > 0) used = send_data (id_ubott(2), tmpv(:,:),      &
                                  Time%model_time, rmask=Grd%mask(:,:,1), &
                                  is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
  endif

  if(id_u_on_depth(1) > 0) then 
    call remap_s_to_depth(Thickness, Time, Velocity%u(:,:,:,1,tau), 1)
  endif 
  if(id_u_on_depth(2) > 0) then 
    call remap_s_to_depth(Thickness, Time, Velocity%u(:,:,:,2,tau), 2)
  endif 


end subroutine update_ocean_velocity_cgrid
! </SUBROUTINE> NAME="update_ocean_velocity_cgrid"


!#######################################################################
! <SUBROUTINE NAME="ocean_velocity_restart">
! <DESCRIPTION>
!
!  Write out restart files registered through register_restart_file
!
! </DESCRIPTION>
subroutine ocean_velocity_restart(Time, Velocity, use_blobs, time_stamp)

   type(ocean_time_type),     intent(in)           :: Time
   type(ocean_velocity_type), intent(in)           :: Velocity
   logical,                   intent(in)           :: use_blobs
   character(len=*),          intent(in), optional :: time_stamp

   integer :: tau, taup1, tau_m1, tau_m0

   tau    = Time%tau
   taup1  = Time%taup1

   tau_m1 = Time%tau_m1
   tau_m0 = Time%tau_m0

   ! resetting the pointer to data
   if(tendency == THREE_LEVEL) then
      call reset_field_pointer(Vel_restart, id_restart_u, Velocity%u(:,:,:,1,tau), Velocity%u(:,:,:,1,taup1) )
      call reset_field_pointer(Vel_restart, id_restart_v, Velocity%u(:,:,:,2,tau), Velocity%u(:,:,:,2,taup1) )
   elseif (tendency==TWO_LEVEL) then
      call reset_field_pointer(Vel_restart, id_restart_u, Velocity%u(:,:,:,1,taup1) )
      call reset_field_pointer(Vel_restart, id_restart_v, Velocity%u(:,:,:,2,taup1) )
      if (use_blobs) then
         call reset_field_pointer(Vel_restart, id_restart_px, Velocity%press_force(:,:,:,1) )
         call reset_field_pointer(Vel_restart, id_restart_py, Velocity%press_force(:,:,:,2) )
      endif
   end if
   call save_restart(Vel_restart, time_stamp)

   if(tendency==TWO_LEVEL) then
      call reset_field_pointer(Adv_restart, id_restart_advu, Velocity%advection(:,:,:,1,tau_m1), &
           Velocity%advection(:,:,:,1,tau_m0) )
      call reset_field_pointer(Adv_restart, id_restart_advv, Velocity%advection(:,:,:,2,tau_m1), &
           Velocity%advection(:,:,:,2,tau_m0) )
      call save_restart(Adv_restart, time_stamp)
   end if

   if(horz_grid == MOM_CGRID) then 
      call reset_field_pointer(Cor_restart, id_restart_coru, Velocity%coriolis(:,:,:,1,tau_m1), &
           Velocity%coriolis(:,:,:,1,tau_m0) )
      call reset_field_pointer(Cor_restart, id_restart_corv, Velocity%coriolis(:,:,:,2,tau_m1), &
           Velocity%coriolis(:,:,:,2,tau_m0) )
      call save_restart(Cor_restart, time_stamp)
   endif 


end subroutine ocean_velocity_restart
! </SUBROUTINE> NAME="ocean_velocity_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_velocity_end">
!
! <DESCRIPTION>
!
! Write velocity field to a restart 
!
! </DESCRIPTION>
subroutine ocean_velocity_end(Time, Velocity, use_blobs)

  type(ocean_time_type),     intent(in)  :: Time
  type(ocean_velocity_type), intent(in)  :: Velocity
  logical,                   intent(in)  :: use_blobs
  
  integer :: tau, taup1
  integer :: tau_m0, tau_m1
  
  integer :: stdoutunit 
  stdoutunit=stdout() 

  tau    = Time%tau
  taup1  = Time%taup1

  tau_m1 = Time%tau_m1
  tau_m0 = Time%tau_m0

  call ocean_velocity_restart(Time, Velocity, use_blobs)

  if(tendency==THREE_LEVEL) then 
      write(stdoutunit,*)' ' 
      write(stdoutunit,*) 'From ocean_velocity_mod: ending velocity chksum (tau)'
      call write_timestamp(Time%model_time)
      call ocean_velocity_chksum(Velocity, tau, write_advection=.false.)
      write(stdoutunit,*)' ' 
      call write_timestamp(Time%model_time)
      write(stdoutunit,*) 'From ocean_velocity_mod: ending velocity chksum (taup1)'
      call ocean_velocity_chksum(Velocity, taup1, write_advection=.false.)
  elseif(tendency==TWO_LEVEL) then 
      write(stdoutunit,*)' ' 
      write(stdoutunit,*) 'From ocean_velocity_mod: ending velocity chksum (taup1)'
      call write_timestamp(Time%model_time)
      call ocean_velocity_chksum(Velocity, taup1, write_advection=.true.)
  endif
  
  return

end subroutine ocean_velocity_end
! </SUBROUTINE> NAME="ocean_velocity_end"


!#######################################################################
! <SUBROUTINE NAME="velocity_truncate">
!
! <DESCRIPTION>
! Truncate velocity so that either component 
! has magnitude no larger than nml specified value. 
!
! </DESCRIPTION>
subroutine velocity_truncate(n, taup1, Velocity)

  integer, intent(in)                      :: n
  integer, intent(in)                      :: taup1
  type(ocean_velocity_type), intent(inout) :: Velocity

  logical :: velocity_truncated 
  integer :: i,j,k

  integer :: stdoutunit 
  stdoutunit=stdout() 

  velocity_truncated = .false. 
  wrk1 = 0.0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           if (      abs(Grd%yu(i,j)) >= truncate_velocity_lat  &
                .and. abs(Velocity%u(i,j,k,n,taup1)) > truncate_velocity_value) then
               wrk1(i,j,k)               = Velocity%u(i,j,k,n,taup1)
               Velocity%u(i,j,k,n,taup1) = sign(truncate_velocity_value,Velocity%u(i,j,k,n,taup1))
               velocity_truncated        = .true.  
           endif
        enddo
     enddo
  enddo

  if(truncate_verbose .and. velocity_truncated) then 
      write(stdoutunit,'(/a)') ' Summary of baroclinic velocity truncation points'
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               if (abs(wrk1(i,j,k)) > 0.0) then 
                   write(stdoutunit,'(a,i1,a,i3,a,i3,a,i3,a,e12.3,a,f12.3,a,f12.3,a,i4)') &
                        'Truncated b/c velocity('                                            &
                        ,n,': ',i+Dom%ioff,',',j+Dom%joff,',',k,') = ',wrk1(i,j,k)           &
                        ,' (m/s) at (lon,lat,klev) = ',Grd%xu(i,j), ',', Grd%yu(i,j), ',', Grd%kmu(i,j)
               endif
            enddo
         enddo
      enddo
  endif

end subroutine velocity_truncate
! </SUBROUTINE> NAME="velocity_truncate"


!#######################################################################
! <SUBROUTINE NAME="ocean_velocity_chksum">
!
! <DESCRIPTION>
! Compute checksum for velocity components 
! </DESCRIPTION>
subroutine ocean_velocity_chksum(Velocity, index, write_advection)
 
  type(ocean_velocity_type), intent(in)           :: Velocity
  integer,                   intent(in)           :: index
  logical,                   intent(in), optional :: write_advection

  logical :: writeadvection

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. write_a_restart) then
     write(stdoutunit,'(/a)') '==>Warning from ocean_velocity_mod (ocean_velocity_end): NO restart written.'
     call mpp_error(WARNING,'==>Warning from ocean_velocity_mod (ocean_velocity_end): NO restart written.')
     return
  endif 

  if (PRESENT(write_advection)) then 
    writeadvection = write_advection
  else 
    writeadvection = .true.
  endif 

  call write_chksum_3d('Zonal velocity', Velocity%u(COMP,:,1,index)*Grd%tmasken(COMP,:,1))
  call write_chksum_3d('Meridional velocity', Velocity%u(COMP,:,2,index)*Grd%tmasken(COMP,:,2))

  if(tendency==TWO_LEVEL .and. writeadvection) then 
     call write_chksum_3d('Advection of u', Velocity%advection(COMP,:,1,index)*Grd%tmasken(COMP,:,1))
     call write_chksum_3d('Advection of v', Velocity%advection(COMP,:,2,index)*Grd%tmasken(COMP,:,2))
  endif 

  if(horz_grid == MOM_CGRID) then 
     call write_chksum_3d('x-Coriolis', Velocity%coriolis(COMP,:,1,index)*Grd%tmasken(COMP,:,1))
     call write_chksum_3d('y-Coriolis', Velocity%coriolis(COMP,:,2,index)*Grd%tmasken(COMP,:,2))
  endif 

  return
  
end subroutine ocean_velocity_chksum
! </SUBROUTINE> NAME="ocean_velocity_chksum"



!#######################################################################
! <SUBROUTINE NAME="remap_s_to_depth">
! <DESCRIPTION>
!
! Remap in the vertical from s-coordinate to depth and then send to 
! diagnostic manager.  
!
! This routine is mostly of use for terrain following vertical 
! coordinates, which generally deviate a lot from depth or pressure
! coordinates.  The zstar and pstar coordinates are very similar 
! to z or pressure, so there is no need to do the remapping for 
! purposes of visualization. 
!
! The routine needs to be made more general and faster.  
! It also has been found to be problematic, so it is NOT 
! recommended. It remains here as a template for a better algorithm. 
! Remapping methods in Ferret are much better.  
!
! Use rho_dzu weighting to account for nonBoussinesq.  
!
! Author: Stephen.Griffies
!
! </DESCRIPTION>
!
subroutine remap_s_to_depth(Thickness, Time, array_in, nvelocity)

  type(ocean_thickness_type), intent(in)      :: Thickness
  type(ocean_time_type), intent(in)           :: Time
  real, intent(in),    dimension(isd:,jsd:,:) :: array_in
  integer, intent(in)                         :: nvelocity

  integer :: i, j, k, kk, tau

  tau  = Time%tau
  wrk1 = 0.0
  wrk2 = 0.0
  wrk3 = 0.0

  k=1
  do kk=1,nk
     do j=jsd,jed
        do i=isd,ied
           if(Thickness%depth_zu(i,j,kk) < Grd%zw(k)) then 
              wrk1(i,j,k) = wrk1(i,j,k) + array_in(i,j,kk)*Thickness%rho_dzu(i,j,kk,tau)
              wrk2(i,j,k) = wrk2(i,j,k) + Thickness%rho_dzu(i,j,kk,tau)
           endif 
        enddo
     enddo
  enddo

  do k=1,nk-1
     do kk=1,nk
        do j=jsd,jed
           do i=isd,ied
              if(Grd%zw(k) <= Thickness%depth_zu(i,j,kk) .and. Thickness%depth_zu(i,j,kk) < Grd%zw(k+1)) then 
                 wrk1(i,j,k+1) = wrk1(i,j,k+1) + array_in(i,j,kk)*Thickness%rho_dzu(i,j,kk,tau)
                 wrk2(i,j,k+1) = wrk2(i,j,k+1) + Thickness%rho_dzu(i,j,kk,tau)
              endif
           enddo
        enddo
     enddo
  enddo

  k=nk
  do kk=1,nk
     do j=jsd,jed
        do i=isd,ied
           if(Thickness%depth_zu(i,j,kk) > Grd%zw(k) ) then 
               wrk1(i,j,k) = wrk1(i,j,k) + array_in(i,j,kk)*Thickness%rho_dzu(i,j,kk,tau)
               wrk2(i,j,k) = wrk2(i,j,k) + Thickness%rho_dzu(i,j,kk,tau)
           endif
        enddo
     enddo
  enddo

  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           wrk3(i,j,k) = Grd%umask_depth(i,j,k)*wrk1(i,j,k)/(wrk2(i,j,k)+epsln)
        enddo
     enddo
  enddo

  call diagnose_3d_u(Time, Grd, id_u_on_depth(nvelocity), wrk3(:,:,:))


end subroutine remap_s_to_depth
! </SUBROUTINE>  NAME="remap_s_to_depth"


end module ocean_velocity_mod

! -*- f90 -*-
module oda_core_ecda_mod
  ! FMS Shared modules
  use fms_mod, only : file_exist, read_data
  use fms_mod, only : open_namelist_file, check_nml_error, close_file
  use fms_mod, only : error_mesg, FATAL, NOTE
#ifdef INTERNAL_FILE_NML
  USE mpp_mod, ONLY: input_nml_file
#endif
  use mpp_mod, only : mpp_sum, stdout, stdlog, mpp_sync_self
  use mpp_mod, only : mpp_pe, mpp_root_pe
  use mpp_io_mod, only : mpp_open, mpp_close, MPP_ASCII, MPP_RDONLY, MPP_MULTI, MPP_SINGLE, MPP_NETCDF
  use mpp_io_mod, only : mpp_get_atts, mpp_get_info, mpp_get_fields, mpp_read, axistype, fieldtype, mpp_get_axes
  use mpp_io_mod, only : mpp_get_axis_data, mpp_get_field_name
  use mpp_domains_mod, only : mpp_get_compute_domain, mpp_get_data_domain
  use mpp_domains_mod, only : domain2d, mpp_get_global_domain, mpp_update_domains
  use mpp_domains_mod, only : mpp_global_field
  use mpp_memutils_mod, only : mpp_print_memuse_stats
  use time_manager_mod, only : time_type, set_time, set_date, get_date, get_time
  use time_manager_mod, only : operator( <= ), operator( - ), operator( > ), operator ( < )
  use get_cal_time_mod, only : get_cal_time
  use axis_utils_mod, only : frac_index  
  use horiz_interp_type_mod, only: horiz_interp_type
  use horiz_interp_bilinear_mod, only : horiz_interp_bilinear_new
  use constants_mod, only : DEG_TO_RAD

  ! ODA_tools modules
  use oda_types_mod, only : ocean_profile_type, ocn_obs_flag_type, grid_type, obs_clim_type
  use oda_types_mod, only : DROP_PROFILER, MOORING, SATELLITE, DRIFTER, SHIP, TEMP_ID, SALT_ID, MISSING_VALUE
  use oda_types_mod, only : UNKNOWN, TAO
  use xbt_adjust, only : xbt_drop_rate_adjust
  
  implicit none

  private

  public :: copy_obs, oda_core_init, open_profile_dataset, &
       get_obs, get_obs_woa05t, get_obs_woa05s, get_obs_sst, get_obs_suv, &
       get_obs_eta, open_profile_dataset_sst, ocn_obs, ssh_td, max_profiles

  ! Parameters
  integer, parameter :: PROFILE_FILE = 1
  integer, parameter :: SFC_FILE = 2

  ! oda_core_nml variables
  real :: max_misfit = 5.0 !< used to inflate observation errors where the difference from the first guess is large
  real :: ass_start_lat = -87.0 !< set obs domain
  real :: ass_end_lat = 87.0 !< set obs domain
  integer :: max_profiles = 50000
  namelist /oda_core_nml/ max_misfit, ass_start_lat, ass_end_lat, max_profiles

  ! Shared ocean_obs_nml namelist variables
  real :: eta_obs_start_lat = -80.0 !< set obs domain
  real :: eta_obs_end_lat = 85.0 !< set obs domain
  real :: sst_obs_start_lat = -82.0 !< set obs domain
  real :: sst_obs_end_lat = 89.0 !< set obs domain

  integer :: max_prflvs = 200 ! for vd test

  type(ocean_profile_type), target, dimension(:), allocatable :: profiles  

  integer :: num_profiles, no_sst, no_prf, no_temp, no_salt, no_suv, no_eta ! total number of observations 
  integer :: no_woa05

  integer :: isc, iec, jsc, jec, isd, ied, jsd, jed  ! indices for local domain on model grid
  integer :: isg, ieg, jsg, jeg
  integer :: isd_filt, ied_filt, jsd_filt, jed_filt
  integer :: isd_flt0, ied_flt0, jsd_flt0, jed_flt0
  integer :: nk

  real, dimension(:,:), allocatable, save :: mask_tao

  ! sst obs grid information
  real, allocatable :: woa05_lon(:), woa05_lat(:), woa05_z(:)
  real, allocatable :: sst_lon(:), sst_lat(:), obs_sst(:,:)
  real, allocatable, save :: obs_woa05t(:,:,:), obs_woa05s(:,:,:)
  integer ::  nlon, nlat, nlev
  integer ::  nlon_woa, nlat_woa, nlev_woa
  
  ! time window for DROP, MOORING and SATELLITE data respectively

  type(time_type) , dimension(0:100), public :: time_window

  type(grid_type), pointer :: Grd

  type(horiz_interp_type), save :: Interp

  real, allocatable, dimension(:, :) :: x_grid, y_grid, x_grid_uv, y_grid_uv
  real :: lon_out(1, 1), lat_out(1, 1)

  type(ocn_obs_flag_type) :: ocn_obs

  integer :: ssh_td

    type obs_entry_type
       character(len=128) :: filename
       character(len=16)  :: file_type
    end type obs_entry_type

 
contains

  subroutine init_observations(time_s, time_e, filt_domain, localize)  
    type(time_type), intent(in) :: time_s, time_e
    type(domain2d), intent(in) :: filt_domain
    logical, intent(in), optional :: localize

    integer, parameter :: SUV_ID = 4, ETA_ID = 5, WOAT_ID = 11, WOAS_ID = 12

    ! ocean_obs_nml variables
    integer :: mooring_window = 5
    integer :: satellite_window = 10 
    integer :: drop_window = 30
    integer :: drifter_window = 30
    integer :: ship_window = 30
    integer :: unknown_window = 30

    logical :: prfs_obs, salt_obs, sst_obs, eta_obs, suv_obs
    logical :: temp_obs_argo, salt_obs_argo, temp_obs_gtspp
    logical :: temp_obs_woa05, salt_obs_woa05
    integer :: eta_obs_td = 10
    integer :: max_files = 30 
    integer :: max_files_argo = 10 
    integer :: max_files_gtspp = 10 
    namelist /ocean_obs_nml/ mooring_window, satellite_window, drop_window,&
         & drifter_window, ship_window, unknown_window,&
         & prfs_obs, salt_obs, sst_obs, eta_obs, suv_obs,&
         & temp_obs_argo, salt_obs_argo, temp_obs_gtspp,&
         & temp_obs_woa05, salt_obs_woa05, eta_obs_td,&
         & sst_obs_start_lat, sst_obs_end_lat, eta_obs_start_lat, eta_obs_end_lat,&
         & max_files, max_files_argo, max_files_gtspp

    integer :: i, j, n, obs_variable
    integer :: ioun, io_status, ierr
    integer :: stdout_unit, stdlog_unit
    integer :: nfiles, nrecs, unit
    integer :: nfiles_argo, nrecs_argo, unit_argo
    integer :: nfiles_gtspp, nrecs_gtspp, unit_gtspp
    integer, dimension(:), allocatable :: filetype
    integer, dimension(:), allocatable :: filetype_argo
    integer, dimension(:), allocatable :: filetype_gtspp

    character(len=128) :: input_files_woa05t, input_files_woa05s
    character(len=256) :: record
    character(len=128), dimension(:), allocatable :: input_files
    character(len=128), dimension(:), allocatable :: input_files_argo
    character(len=128), dimension(:), allocatable :: input_files_gtspp

    type(obs_entry_type) :: tbl_entry

    stdout_unit = stdout()
    stdlog_unit = stdlog()

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, ocean_obs_nml, iostat=io_status)
#else
    ioun = open_namelist_file()
    read(UNIT=ioun, NML=ocean_obs_nml, IOSTAT=io_status)
    ierr = check_nml_error(io_status,'ocean_obs_nml')
    call close_file(ioun)    
#endif
    write (UNIT=stdlog_unit, NML=ocean_obs_nml)

    ! Allocate filetype* and input_files* variables
    allocate(filetype(max_files), input_files(max_files))
    allocate(filetype_argo(max_files_argo), input_files_argo(max_files_argo))
    allocate(filetype_gtspp(max_files_gtspp), input_files_gtspp(max_files_gtspp))

    filetype = -1
    filetype_argo = -1
    filetype_gtspp = -1
    input_files = ''
    input_files_argo = ''
    input_files_gtspp = ''

    if ( prfs_obs .or. salt_obs .or. temp_obs_argo .or. temp_obs_gtspp .or. salt_obs_argo ) then
       ocn_obs%use_prf_as_obs = .true.
    end if
    ocn_obs%use_sst_as_obs = sst_obs
    ocn_obs%use_ssh_as_obs = eta_obs
    ocn_obs%use_suv_as_obs = suv_obs
    ocn_obs%use_woa05_t = temp_obs_woa05
    ocn_obs%use_woa05_s = salt_obs_woa05
    ssh_td = eta_obs_td

    ! time window for DROP, MOORING and SATELLITE data respectively
    ! will be available from namelist
    time_window(:) = set_time(0,unknown_window)
    time_window(DROP_PROFILER:DROP_PROFILER+9) = set_time(0,drop_window)
    time_window(MOORING:MOORING+9) = set_time(0,mooring_window)
    time_window(SATELLITE:SATELLITE+9) = set_time(0,satellite_window)
    time_window(DRIFTER:DRIFTER+9) = set_time(0,drifter_window)
    time_window(SHIP:SHIP+9) = set_time(0,ship_window)
    
    nfiles = 0
    nrecs=0
    call mpp_open(unit, 'ocean_obs_table', action=MPP_RDONLY)
    read_obs: do while ( nfiles <= max_files )
       read (UNIT=unit, FMT='(A)', IOSTAT=io_status) record
       if ( io_status < 0 ) then
          exit read_obs
       else if ( io_status > 0 ) then
          cycle read_obs
       else
          nrecs = nrecs + 1
          if ( record(1:1) == '#' ) cycle read_obs
          read ( UNIT=record, FMT=*, IOSTAT=io_status ) tbl_entry
          if ( io_status < 0 ) then
             exit read_obs
          else if ( io_status > 0 ) then
             cycle read_obs
          else
             nfiles = nfiles + 1       
             input_files(nfiles) = tbl_entry%filename
             select case ( trim(tbl_entry%file_type) )
             case ('profiles')
                filetype(nfiles) = PROFILE_FILE
             case ('sfc')
                filetype(nfiles) = SFC_FILE
             case default
                call error_mesg('oda_core_mod::init_observations', 'error in obs_table entry format', FATAL)
             end select
          end if
       end if
    end do read_obs
    if ( nfiles > max_files ) then
       call error_mesg('oda_core_mod::init_observations', 'number of obs files exceeds max_files parameter', FATAL)
    end if
    CALL mpp_close(unit)
    
    nfiles_argo = 0
    nrecs_argo = 0
    call mpp_open(unit_argo, 'ocean_obs_argo_table', action=MPP_RDONLY)
    read_obs_argo: do while ( nfiles_argo <= max_files_argo )
       read (UNIT=unit_argo, FMT='(A)', IOSTAT=io_status) record
       if ( io_status < 0 ) then
          exit read_obs_argo
       else if ( io_status > 0 ) then
          cycle read_obs_argo
       else 
          nrecs_argo = nrecs_argo + 1
          if ( record(1:1) == '#' ) cycle read_obs_argo
          read (UNIT=record, FMT=*, IOSTAT=io_status) tbl_entry
          if ( io_status < 0 ) then
             exit read_obs_argo
          else if ( io_status > 0 ) then
             cycle read_obs_argo
          else 
             nfiles_argo = nfiles_argo + 1       
             input_files_argo(nfiles_argo) = tbl_entry%filename
             select case ( trim(tbl_entry%file_type) )
             case ('profiles')
                filetype_argo(nfiles_argo) = PROFILE_FILE
             case ('sfc')
                filetype_argo(nfiles_argo) = SFC_FILE
             case default
                call error_mesg('oda_core_mod::init_observations', 'error in obs_table entry format for argo', FATAL)
             end select
          end if
       end if
    end do read_obs_argo
    if ( nfiles_argo > max_files_argo ) then
       call error_mesg('oda_core_mod::init_observations', 'number of obs files exceeds max_files_argo parameter', FATAL)
    end if
    call mpp_close(unit_argo)

    nfiles_gtspp = 0
    nrecs_gtspp = 0
    call mpp_open(unit_gtspp, 'ocean_obs_gtspp_table', action=MPP_RDONLY)
    read_obs_gtspp: do while ( nfiles_gtspp <= max_files_gtspp )
       read (UNIT=unit_gtspp, FMT='(A)', IOSTAT=io_status) record
       if ( io_status < 0 ) then
          exit read_obs_gtspp
       else if ( io_status > 0 ) then
          cycle read_obs_gtspp
       else
          nrecs_gtspp = nrecs_gtspp + 1
          if ( record(1:1) == '#' ) cycle read_obs_gtspp
          read (UNIT=record, FMT=*, IOSTAT=io_status) tbl_entry
          if ( io_status < 0 ) then
             exit read_obs_gtspp
          else if ( io_status > 0 ) then
             cycle read_obs_gtspp
          else
             nfiles_gtspp = nfiles_gtspp + 1       
             input_files_gtspp(nfiles_gtspp) = tbl_entry%filename
             select case ( trim(tbl_entry%file_type) )
             case ('profiles')
                filetype_gtspp(nfiles_gtspp) = PROFILE_FILE
             case ('sfc')
                filetype_gtspp(nfiles_gtspp) = SFC_FILE
             case default
                call error_mesg('oda_core_mod::init_observations', 'error in obs_table entry format for gtspp', FATAL)
             end select
          end if
       end if
    end do read_obs_gtspp
    if ( nfiles_gtspp > max_files_gtspp ) then
       call error_mesg('oda_core_mod::init_observations', 'number of obs files exceeds max_files_gtspp parameter', FATAL)
    end if
    CALL mpp_close(unit_gtspp)

    num_profiles = 0
    no_prf = 0
    no_sst = 0
    no_temp = 0
    no_salt = 0
    no_suv = 0
    no_eta = 0
    no_woa05 = 0

    ! get local indices for Model grid
    allocate(x_grid(isg:ieg,jsg:jeg), x_grid_uv(isg:ieg,jsg:jeg))
    allocate(y_grid(isg:ieg,jsg:jeg), y_grid_uv(isg:ieg,jsg:jeg))

    call mpp_global_field(filt_domain, Grd%x(:,:), x_grid(:,:))
    call mpp_global_field(filt_domain, Grd%y(:,:), y_grid(:,:))

    ! Allocate profiles
    allocate(profiles(max_profiles))

    do j=jsg, jeg
       do i=isg, ieg
          if ( x_grid(i,j) .lt. 80.0 ) x_grid(i,j) = x_grid(i,j) + 360.0
       end do
    end do

    ! uv grid may not be precise, need to be carefully checked
    x_grid_uv(:,:) = x_grid(:,:) + 0.5
    do j=jsg, jeg-1
       do i=isg, ieg
          y_grid_uv(i,j) = y_grid(i,j) + 0.5*(y_grid(i,j+1)-y_grid(i,j))
       end do
    end do
    do i=isg, ieg
       y_grid_uv(i,jeg) = 90.0
    end do

    if ( prfs_obs ) then
       obs_variable = TEMP_ID
       if ( mpp_pe() == mpp_root_pe() ) then
          write (UNIT=stdout_unit, FMT='("TEMP_ID = ",I5)') TEMP_ID
       end if
       do n=1, nfiles
          select case ( filetype(n) )
          case (PROFILE_FILE)
             call open_profile_dataset(trim(input_files(n)), time_s, time_e, obs_variable, localize)           
          case default
             call error_mesg('oda_core_mod::init_observations', 'filetype not currently supported for prfs_obs', FATAL)
          end select
       end do
    end if

    if ( salt_obs ) then
       obs_variable = SALT_ID
       if ( mpp_pe() == mpp_root_pe() ) then
          write (UNIT=stdout_unit, FMT='("SALT_ID = ",I5)') SALT_ID
       end if
       do n=1, nfiles
          select case ( filetype(n) )
          case (PROFILE_FILE)
             call open_profile_dataset(trim(input_files(n)), time_s, time_e, obs_variable, localize)
          case default
             call error_mesg('oda_core_mod::init_observations', 'filetype not currently supported for salt_obs', FATAL)
          end select
       end do
    end if

    if ( temp_obs_gtspp ) then
       obs_variable = TEMP_ID
       if ( mpp_pe() == mpp_root_pe() ) then
          write (UNIT=stdout_unit, FMT='("TEMP_ID = ",I5)') TEMP_ID
       end if
       do n=1, nfiles_gtspp
          if ( mpp_pe() == mpp_root_pe() ) then
             write (UNIT=stdout_unit, FMT='("f_typ_gtspp = ",I8)') filetype_gtspp(n)
             write (UNIT=stdout_unit, FMT='("i_f_gtspp = ",A)') input_files_gtspp(n)
          end if
          select case ( filetype_gtspp(n) )
          case (PROFILE_FILE)
             call open_profile_dataset_gtspp()
          case default
             call error_mesg('oda_core_mod::init_observations', 'filetype_gtspp not currently supported', FATAL)
          end select
       end do
    end if

    if ( temp_obs_argo ) then
       obs_variable = TEMP_ID
       if ( mpp_pe() == mpp_root_pe() ) then
          write (UNIT=stdout_unit, FMT='("TEMP_ID = ",I5)') TEMP_ID
       end if
       do n=1, nfiles_argo
          if ( mpp_pe() == mpp_root_pe() ) then
             write (UNIT=stdout_unit, FMT='("f_typ_argo = ",I8)') filetype_argo(n)
             write (UNIT=stdout_unit, FMT='("i_f_argo = ",A)') input_files_argo(n)
          end if
          select case ( filetype_argo(n) )
          case (PROFILE_FILE)
             call open_profile_dataset_argo(trim(input_files_argo(n)), time_s, time_e, obs_variable, localize)
          case default
             call error_mesg('oda_core_mod::init_observations', 'filetype_argo not currently supported', FATAL)
          end select
       end do
    end if

    if ( salt_obs_argo ) then
       obs_variable = SALT_ID
       if ( mpp_pe() == mpp_root_pe() ) then
          write (UNIT=stdout_unit, FMT='("SALT_ID = ",I5)') SALT_ID
       end if
       do n=1, nfiles_argo
          select case ( filetype_argo(n) )
          case (PROFILE_FILE)
             call open_profile_dataset_argo(trim(input_files_argo(n)), time_s, time_e, obs_variable, localize)
          case default
             call error_mesg('oda_core_mod::init_observations', 'filetype_argo not currently supported', FATAL)
          end select
       end do
    end if

    if ( temp_obs_woa05 ) then
       obs_variable = WOAT_ID
       if ( mpp_pe() == mpp_root_pe() ) then
          write (UNIT=stdout_unit, FMT='("WOAT_ID = ",I5)') WOAT_ID
       end if
       input_files_woa05t = "INPUT/woa05_temp.nc"
       call open_profile_dataset_woa05t(trim(input_files_woa05t), obs_variable, localize)
    end if

    if ( salt_obs_woa05 ) then
       obs_variable = WOAS_ID
       if ( mpp_pe() == mpp_root_pe() ) then
          write (UNIT=stdout_unit, FMT='("WOAS_ID = ",I5)') WOAS_ID
       end if
       input_files_woa05s = "INPUT/woa05_salt.nc"
       call open_profile_dataset_woa05s(trim(input_files_woa05s), obs_variable, localize)
    end if

    if ( sst_obs ) then
       obs_variable = TEMP_ID
       if ( mpp_pe() == mpp_root_pe() ) then
          write (UNIT=stdout_unit, FMT='("TEMP_ID for sst = ",I5)') TEMP_ID
       end if
       nfiles = 1
       nrecs = 0
       input_files(nfiles) = "INPUT/sst_daily.nc"
       filetype(nfiles) = PROFILE_FILE
!!$       call open_profile_dataset_sst(trim(input_files(nfiles)), obs_variable, localize)
    end if

    if ( eta_obs ) then
       obs_variable = ETA_ID
       nfiles = 1
       nrecs = 0
       input_files(nfiles) = "INPUT/ocean.19760101-20001231.eta_t.nc"
       filetype(nfiles) = PROFILE_FILE
       call open_profile_dataset_eta(trim(input_files(nfiles)), obs_variable, localize)
    end if

    if ( suv_obs ) then
       obs_variable = SUV_ID
       nfiles = 1
       nrecs = 0
       input_files(nfiles) = "INPUT/sfc_current.197601-200012.nc"
       filetype(nfiles) = PROFILE_FILE
       call open_profile_dataset_suv(trim(input_files(nfiles)), obs_variable, localize)
    end if

    ! Deallocate before exiting routine
    deallocate(filetype, input_files)
    deallocate(filetype_argo, input_files_argo)
    deallocate(filetype_gtspp, input_files_gtspp)
  end subroutine init_observations

  subroutine open_profile_dataset(filename, time_start, time_end, obs_variable, localize)  
    character(len=*), intent(in) :: filename
    type(time_type), intent(in) :: time_start, time_end
    integer, intent(in) :: obs_variable
    logical, intent(in), optional :: localize

    integer, parameter :: MAX_LEVELS = 1000
    integer, parameter :: MAX_LNKS = 500

    real :: lon, lat, time, profile_error, rlink, flag_t, flag_s, fix_depth
    real :: ri0, rj0
    real, dimension(MAX_LEVELS) :: depth, data, t_flag, s_flag
    real, dimension(MAX_LNKS, MAX_LEVELS) :: data_bfr, depth_bfr, t_flag_bfr, s_flag_bfr

    integer :: unit, ndim, nvar, natt, nstation
    integer :: stdout_unit
    integer :: inst_type, var_id
    integer :: num_levs, k, kk, i, i0, j0, k0, nlevs, a, nn, ii, nlinks
    integer :: nprof_in_filt_domain
    integer :: bad_point, bad_point_g, out_bound_point

    logical :: data_is_local, localize_data, cont
    logical :: data_in_period
    logical :: prof_in_filt_domain
    logical, dimension(MAX_LEVELS) :: flag
    logical, dimension(MAX_LNKS, MAX_LEVELS) :: flag_bfr

    character(len=32) :: fldname, axisname, anal_fldname, time_units
    character(len=138) :: emsg_local

    type(time_type) :: profile_time
    type(axistype), pointer :: depth_axis, station_axis
    type(axistype), allocatable, dimension(:), target :: axes
    type(fieldtype), allocatable, dimension(:), target :: fields
    type(fieldtype), pointer :: field_lon, field_lat, field_flag, field_time, field_depth, field_data
    type(fieldtype), pointer :: field_error, field_link, field_t_flag, field_s_flag, field_fix_depth ! snz drop rate

    ! NOTE: fields are restricted to be in separate files

    if ( PRESENT(localize) ) then
       localize_data = localize
    else
       localize_data = .true.
    end if

    nprof_in_filt_domain = 0
    stdout_unit = stdout()

    anal_fldname = 'none'
    var_id=-1
    if ( obs_variable == TEMP_ID ) then
       anal_fldname = 'temp'
       var_id = TEMP_ID
    else if ( obs_variable == SALT_ID ) then
       anal_fldname = 'salt'
       var_id = SALT_ID
    end if

!    call mpp_print_memuse_stats('open_profile_dataset Start')

    call mpp_open(unit, filename, form=MPP_NETCDF, fileset=MPP_SINGLE, threading=MPP_MULTI, action=MPP_RDONLY)
    call mpp_get_info(unit, ndim, nvar, natt, nstation)

    if ( mpp_pe() .eq. mpp_root_pe() ) then
       write (UNIT=stdout_unit, FMT='("Opened profile dataset: ",A)') trim(filename)
    end if

    ! get axis information
    allocate(axes(ndim))
    call mpp_get_axes(unit, axes)
    do i=1, ndim
       call mpp_get_atts(axes(i), name=axisname)
       select case ( trim(axisname) )
       case ('depth_index')
          depth_axis => axes(i)
       case ('station_index')
          station_axis => axes(i)
       end select
    end do

    ! get field information
    allocate(fields(nvar))
    call mpp_get_fields(unit, fields)
    do i=1, nvar
       call mpp_get_atts(fields(i), name=fldname)
       if( var_id .eq. TEMP_ID ) then
          select case (trim(fldname))
          case ('longitude')
             field_lon => fields(i)
          case ('latitude')
             field_lat => fields(i)
          case ('profile_flag') 
             field_flag => fields(i)
          case ('time')
             field_time => fields(i)
          case ('temp')
             field_data => fields(i)
          case ('depth')
             field_depth => fields(i)
          case ('link')
             field_link => fields(i)
          case ('temp_error')
             field_error => fields(i)
          case ('temp_flag')
             field_t_flag => fields(i)
          case ('fix_depth') ! snz drop rate
             field_fix_depth => fields(i)
          end select
       else if( var_id .eq. SALT_ID ) then
          select case (trim(fldname))
          case ('longitude')
             field_lon => fields(i)
          case ('latitude')
             field_lat => fields(i)
          case ('profile_flag_s') 
             field_flag => fields(i)
          case ('time')
             field_time => fields(i)
          case ('salt')
             field_data => fields(i)
          case ('depth')
             field_depth => fields(i)
          case ('link')
             field_link => fields(i)
          case ('salt_error')
             field_error => fields(i)
          case ('salt_flag')
             field_s_flag => fields(i)
          case ('fix_depth') ! snz drop rate
             field_fix_depth => fields(i)
          end select
       end if
    end do

    call mpp_get_atts(depth_axis, len=nlevs)

    if ( nlevs > MAX_LEVELS ) then 
       call error_mesg('oda_core_mod::open_profile_dataset', 'increase parameter MAX_LEVELS', FATAL)
    else if (nlevs < 1) then
       call error_mesg('oda_core_mod::open_profile_dataset', 'Value of nlevs is less than 1.', FATAL)
    end if

    if ( .NOT.ASSOCIATED(field_data) ) then
       call error_mesg('oda_core_mod::open_profile_dataset',&
            & 'profile dataset not used because data not needed for Analysis', NOTE)
       return
    end if

    write(UNIT=stdout_unit, FMT='("There are ",I8," records in this dataset.")') nstation
    write(UNIT=stdout_unit, FMT='("Searching for profiles . . .")')
    
    call mpp_get_atts(field_time, units=time_units)

    bad_point = 0
    out_bound_point = 0

    i = 1
    cont = .true.
    
    do while ( cont )
       prof_in_filt_domain = .false.
       depth = missing_value  ! snz add
       data = missing_value   ! snz add

       call mpp_read(unit, field_lon, lon, tindex=i)
       call mpp_read(unit, field_lat, lat, tindex=i)
       call mpp_read(unit, field_time, time, tindex=i)
       call mpp_read(unit, field_depth, depth(1:nlevs), tindex=i)
       call mpp_read(unit, field_data, data(1:nlevs), tindex=i)
       call mpp_read(unit, field_error, profile_error, tindex=i)
       call mpp_read(unit, field_fix_depth, fix_depth, tindex=i) ! snz drop rate
       if ( var_id == TEMP_ID ) then
          call mpp_read(unit, field_t_flag, t_flag(1:nlevs), tindex=i)
          call mpp_read(unit, field_flag, flag_t, tindex=i)
       else if ( var_id == SALT_ID ) then
          call mpp_read(unit, field_s_flag, s_flag(1:nlevs), tindex=i)
          call mpp_read(unit, field_flag, flag_s, tindex=i)
       end if
       call mpp_read(unit, field_link, rlink, tindex=i)

       inst_type = 20 ! snz change one line
!!$       inst_type = DRIFTER + ARGO

       data_is_local = .false.
       data_in_period = .false.

       if ( lon .lt. 0.0 ) lon = lon + 360.0
       if ( lon .gt. 360.0 ) lon = lon - 360.0
       if ( lon .lt. 80.0 ) lon = lon + 360.0 

       if ( lat > ass_start_lat .and. lat < ass_end_lat ) data_is_local = .true.

       profile_time = get_cal_time(time, time_units, 'julian')
       if ( profile_time > time_start .and. profile_time < time_end ) data_in_period = .true.
       if ( (data_in_period .and. data_is_local) .and. (.NOT.localize_data) ) then ! localize

          if (isd_filt < 1 .and. ied_filt > ieg) then
             ! filter domain is a full x band
             if (lon >= x_grid(1,jsd_flt0) .and. lon <= x_grid(ieg-1,jsd_flt0) .and.&
                  lat >= y_grid(1,jsd_flt0) .and. lat <= y_grid(ieg-1,jsd_flt0)) then
                prof_in_filt_domain = .true.
             end if
          else if (isd_filt >= 1 .and. ied_filt <= ieg) then
             ! Interior filter domain
            if (lon >= x_grid(isd_filt,jsd_flt0) .and. lon <= x_grid(ied_filt-1,jsd_flt0) .and.&
               & lat >= y_grid(isd_filt,jsd_flt0) .and. lat <=  y_grid(ied_filt-1,jed_flt0-1)) then
                prof_in_filt_domain = .true.
            end if
          else if (isd_filt < 1 .and. ied_filt <= ieg) then
             ! lhs filter domain
             isd_flt0 = isd_filt + ieg
             if ((lon >= x_grid(1,jsd_flt0) .and. lon <= x_grid(ied_filt-1,jsd_flt0) .and.&
                  & lat >= y_grid(1,jsd_flt0) .and. lat <=  y_grid(ied_filt-1,jed_flt0-1)).or.&
                  & (lon >= x_grid(isd_flt0,jsd_flt0) .and. lon <= x_grid(ieg-1,jsd_flt0) .and.&
                  & lat >= y_grid(isd_flt0,jsd_flt0) .and. lat <=  y_grid(ieg-1,jed_flt0-1))) then
                prof_in_filt_domain = .true.
             end if
          else if (isd_filt >= 1 .and. ied_filt > ieg) then
             ! rhs filter domain
             ied_flt0 = ied_filt - ieg
             if ( lon >= x_grid(isd_filt,jsd_flt0) .and. lon <= x_grid(ieg-1,jsd_flt0) .and.&
                  & lat >= y_grid(isd_filt,jsd_flt0) .and. lat <=  y_grid(ieg-1,jed_flt0-1) ) then
                prof_in_filt_domain = .true.
             end if
             if (ied_flt0-1 > 1) then
                if ( lon >= x_grid(1,jsd_flt0) .and. lon <= x_grid(ied_flt0-1,jsd_flt0) .and.&
                     & lat >= y_grid(1,jsd_flt0) .and. lat <=  y_grid(ied_flt0-1,jed_flt0-1) ) then
                   prof_in_filt_domain = .true.
                end if
             end if
          end if

          if ( var_id == TEMP_ID .and. flag_t == 0.0 ) then
             num_profiles = num_profiles + 1
             no_temp = no_temp + 1
             no_prf = no_prf + 1
          end if
          if ( var_id == SALT_ID .and. flag_s == 0.0 ) then 
             num_profiles = num_profiles + 1
             no_salt = no_salt + 1
             no_prf = no_prf + 1
          end if

          if ( num_profiles > max_profiles ) then
             call error_mesg('oda_core_mod::open_profile_dataset',&
                  & 'maximum number of profiles exceeded, increase max_profiles in oda_core_nml', FATAL)
          end if

          num_levs = 0
          do k=1, MAX_LEVELS
             flag(k) = .true.

             if ( depth(k) > 2000.0 ) depth(k) = missing_value  ! snz add for rdat-hybn

             if ( var_id == TEMP_ID ) then
                if ( data(k) .eq. missing_value .or.&
                     & depth(k) .eq. missing_value .or. t_flag(k) .ne. 0.0 ) then
                   flag(k) = .false.
                else
                   num_levs = num_levs + 1
                end if
             else if ( var_id == SALT_ID ) then
                if ( data(k) .eq. missing_value .or.&
                     & depth(k) .eq. missing_value .or. s_flag(k) .ne. 0.0 ) then
                   flag(k) = .false.
                else
                   num_levs = num_levs+1
                end if
             end if
          end do

          ! large profile are stored externally in separate records
          ! read linked records and combine profile
          ii = i + 1
          nlinks = 0
          do while ( rlink > 0.0 )
             nlinks = nlinks + 1

             if ( nlinks > MAX_LNKS ) then
                write (emsg_local, '("nlinks (",I6,") > MAX_LNKS (",I6,")")')&
                     & nlinks, MAX_LNKS
                call error_mesg('oda_core_mod::open_profile_dataset',&
                     & trim(emsg_local)//' in file "'//trim(filename)//&
                     & '".  Increase parameter MAX_LNKS', FATAL)
             end if

             depth_bfr(nlinks,:) = missing_value
             data_bfr(nlinks,:) = missing_value
             call mpp_read(unit, field_depth, depth_bfr(nlinks,1:nlevs), tindex=ii)
             call mpp_read(unit, field_data, data_bfr(nlinks,1:nlevs), tindex=ii)
             if ( var_id == TEMP_ID ) then 
                call mpp_read(unit, field_t_flag, t_flag_bfr(nlinks,1:nlevs), tindex=ii)
             else if ( var_id == SALT_ID ) then
                call mpp_read(unit, field_s_flag, s_flag_bfr(nlinks,1:nlevs), tindex=ii)
             end if
             call mpp_read(unit, field_link, rlink, tindex=ii)
             ii = ii + 1
          end do
          i = ii ! set record counter to start of next profile

          if ( nlinks > 0 ) then
             do nn=1, nlinks
                do k=1, MAX_LEVELS
                   flag_bfr(nn,k) = .true.

                   if ( depth_bfr(nn,k) > 2000.0 ) depth_bfr(nn,k) = missing_value  ! snz add for rdat-hybn

                   if ( var_id == TEMP_ID ) then
                      if ( data_bfr(nn,k) .eq. missing_value .or.&
                           & depth_bfr(nn,k) .eq. missing_value .or.&
                           & t_flag_bfr(nn,k) .ne. 0.0 ) then
                         flag_bfr(nn,k) = .false.
                      else
                         num_levs = num_levs+1
                      end if
                   else if (var_id == SALT_ID) then
                      if ( data_bfr(nn,k) .eq. missing_value .or.&
                           & depth_bfr(nn,k) .eq. missing_value .or.&
                           & s_flag_bfr(nn,k) .ne. 0.0 ) then
                         flag_bfr(nn,k) = .false.
                      else
                         num_levs = num_levs+1
                      end if
                   end if
                end do
             end do
          end if

          ! mh2 asks to change from [if (num_levs == 0) cycle]
          if ( num_levs == 0 ) then
             if ( i .gt. nstation ) cont = .false.
             cycle
          end if

          if ( num_profiles > 0 .and. prof_in_filt_domain ) then ! snz - 05 Nov 2012

             allocate(profiles(num_profiles)%depth(num_levs))
             allocate(profiles(num_profiles)%data(num_levs))
             allocate(profiles(num_profiles)%flag(num_levs))
             profiles(num_profiles)%variable = var_id
             if ( inst_type < 1 ) inst_type = UNKNOWN
             profiles(num_profiles)%inst_type = inst_type
             profiles(num_profiles)%levels = num_levs
             profiles(num_profiles)%lat = lat
             profiles(num_profiles)%lon = lon
!             allocate(profiles(num_profiles)%ms(num_levs))
!             allocate(profiles(num_profiles)%ms_inv(num_levs))           
!             profiles(num_profiles)%ms(:) = 0.5
             kk = 1
             do k=1, MAX_LEVELS
                if ( flag(k) ) then
                   if ( kk > profiles(num_profiles)%levels ) then
                      call error_mesg('oda_core_mod::open_profile_dataset',&
                           & 'Loop value "kk" is greater than profile levels', FATAL)
                   end if
                   profiles(num_profiles)%depth(kk) = depth(k)
                   profiles(num_profiles)%data(kk) = data(k)
!                   profiles(num_profiles)%ms_inv(kk) = 1./profiles(num_profiles)%ms(kk)                  
                   kk = kk + 1
                end if
             end do

             do nn=1, nlinks
                do k=1, MAX_LEVELS
                   if ( flag_bfr(nn,k) ) then
                      if ( kk > profiles(num_profiles)%levels ) then
                         call error_mesg('oda_core_mod::open_profile_dataset',&
                              & 'Loop value "kk" is greater than profile levels (bfr loop)', FATAL)
                      end if
                      profiles(num_profiles)%depth(kk) = depth_bfr(nn,k)
                      profiles(num_profiles)%data(kk) = data_bfr(nn,k)
!                      profiles(num_profiles)%ms_inv(kk) = 1./profiles(num_profiles)%ms(kk)
                      kk = kk + 1
                   end if
                end do
             end do
           
             profiles(num_profiles)%time = profile_time
           
             ! calculate interpolation coefficients (make sure to account for grid offsets here!)
             if ( lat < 65.0 ) then ! regular grids
                ri0 = frac_index(lon, x_grid(:,1))
                rj0 = frac_index(lat, y_grid(90,:))
                i0 = floor(ri0)
                j0 = floor(rj0)
                if ( i0 > ieg .or. j0 > jeg ) then
                   write (UNIT=emsg_local, FMT='("i0 = ",I8,", j0 = ",I8)') mpp_pe(), i0, j0
                   call error_mesg('oda_core_mod::open_profile_dataset',&
                        & 'For regular grids, either i0 > ieg or j0 > jeg.  '//trim(emsg_local), FATAL)
                end if
                if ( isd_filt >= 1 .and. ied_filt <= ieg ) then
                  if ( i0 < isd_filt .or. i0 > ied_filt .or. j0 < jsd_filt .or. j0 > jed_filt ) then
                     write (UNIT=emsg_local, FMT='("pe,i0,j0= ",3I8,"isd_filt,ied_filt,jsd_filt,jed_filt= ",4I8)')&
                          & mpp_pe(), i0, j0, isd_filt,ied_filt,jsd_filt,jed_filt
                     call error_mesg('oda_core_mod::open_profile_dataset',&
                          & 'i0,j0 out of bounds in prfs01. '//trim(emsg_local), FATAL)
                  end if
                end if
                if ( isd_filt < 1 .and. i0 > ied_filt-1 .and. i0 < isd_filt + ieg ) then
                   write (UNIT=emsg_local, FMT='("pe,i0,j0= ",3I8,"isd_filt,ied_filt,jsd_filt,jed_filt= ",4I8)')&
                        & mpp_pe(), i0, j0, isd_filt,ied_filt,jsd_filt,jed_filt
                   call error_mesg('oda_core_mod::open_profile_dataset',&
                        & 'i0,j0 out of bounds in prfs02. '//trim(emsg_local), FATAL)
                end if
                if ( ied_filt > ieg .and. i0 > ied_filt-ieg-1 .and. ied_filt < isd_filt ) then
                   write (UNIT=emsg_local, FMT='("pe,i0,j0= ",3I8,"isd_filt,ied_filt,jsd_filt,jed_filt= ",4I8)')&
                        & mpp_pe(), i0, j0, isd_filt,ied_filt,jsd_filt,jed_filt
                   call error_mesg('oda_core_mod::open_profile_dataset',&
                        & 'i0,j0 out of bounds in prfs03. '//trim(emsg_local), FATAL)
                end if
                Profiles(num_profiles)%i_index = ri0
                Profiles(num_profiles)%j_index = rj0
             else ! tripolar grids
                lon_out(1,1) = (lon-360.0)*DEG_TO_RAD
                lat_out(1,1) = lat*DEG_TO_RAD
                call horiz_interp_bilinear_new (Interp, (x_grid-360.0)*DEG_TO_RAD, y_grid*DEG_TO_RAD,&
                     & lon_out, lat_out, new_search=.true., no_crash_when_not_found=.true.)

                if ( Interp%i_lon(1,1,1) == -999. ) bad_point = bad_point + 1
                if ( Interp%wti(1,1,2) < 1.0 ) then
                   i0 = Interp%i_lon(1,1,1)
                else
                   i0 = Interp%i_lon(1,1,2)
                end if
                if ( Interp%wtj(1,1,2) < 1.0 ) then
                   j0 = Interp%j_lat(1,1,1)
                else
                   j0 = Interp%j_lat(1,1,2)
                end if
                if ( i0 > ieg .or. j0 > jeg ) then
                   write (UNIT=emsg_local, FMT='("i0 = ",I6,", j0 = ",I6)') mpp_pe(), i0, j0
                   call error_mesg('oda_core_mod::open_profile_dataset',&
                        & 'For tripolar grids, either i0 > ieg or j0 > jeg', FATAL)
                end if
                if( i0 < isd_filt .or. i0 > ied_filt .or. j0 < jsd_filt .or. j0 > jed_filt ) then
!!$                   print*,'prfs.pe,i0,j0= ',mpp_pe(), i0, j0,&
!!$                        & 'isd_filt,ied_filt,jsd_filt,jed_filt= ',isd_filt,ied_filt,jsd_filt,jed_filt
!!$                   print*,'pe,lon,lat=',mpp_pe(),lon,lat,'x_grid(i0+-1)',x_grid(i0-1:i0+1,j0),&
!!$                        & 'y_grid(i0,j0+-1)=',y_grid(i0,j0-1:j0+1)
!!$                   print*,'lono11,lato11=',x_grid(i0,j0),y_grid(i0,j0),'lono21,lato21=',x_grid(i0+1,j0),y_grid(i0+1,j0)
!!$                   print*,'lono12,lato12=',x_grid(i0,j0+1),y_grid(i0,j0+1),'lono22,lato22=',x_grid(i0+1,j0+1),y_grid(i0+1,j0+1)
!!$                   print*,'lonm11,latm11=',x_grid(isd_filt,jsd_filt),y_grid(isd_filt,jsd_filt),&
!!$                        & 'lonm21,latm21=',x_grid(ied_filt,jsd_filt),y_grid(ied_filt,jsd_filt)
!!$                   print*,'lonm12,latm12=',x_grid(isd_filt,jed_filt),y_grid(isd_filt,jed_filt),&
!!$                        & 'lonm22,latm22=',x_grid(ied_filt,jed_filt),y_grid(ied_filt,jed_filt)
!!$                   print*,'wti(1:2)=',Interp%wti(1,1,:),'wtj(1:2)=',Interp%wtj(1,1,:)

                   out_bound_point = out_bound_point + 1
                end if
                if ( Interp%wti(1,1,2) < 1.0 ) then
                   Profiles(num_profiles)%i_index =Interp%i_lon(1,1,1) + Interp%wti(1,1,2)
                else
                   Profiles(num_profiles)%i_index =Interp%i_lon(1,1,2)
                end if
                if (Interp%wtj(1,1,2) < 1.0) then
                   Profiles(num_profiles)%j_index =Interp%j_lat(1,1,1) + Interp%wtj(1,1,2)
                else
                   Profiles(num_profiles)%j_index =Interp%j_lat(1,1,2)
                end if
             end if ! grids

             Profiles(num_profiles)%accepted = .true.

             if ( var_id == TEMP_ID .and. flag_t /= 0.0 ) Profiles(num_profiles)%accepted = .false.
             if ( var_id == SALT_ID .and. flag_s /= 0.0 ) Profiles(num_profiles)%accepted = .false.

             if (i0 < 1 .or. j0 < 1) then
                Profiles(num_profiles)%accepted = .false.
             end if
             if( i0 < isd_filt .or. i0 >= ied_filt .or. j0 < jsd_filt .or. j0 >= jed_filt ) then
                Profiles(num_profiles)%accepted = .false.
             end if

             if ( Profiles(num_profiles)%accepted ) then ! here
                if ( i0 /= ieg .and. j0 /= jeg ) then
                   if (Grd%mask(i0,j0,1) == 0.0 .or.&
                        & Grd%mask(i0+1,j0,1) == 0.0 .or.&
                        & Grd%mask(i0,j0+1,1) == 0.0 .or.&
                        & Grd%mask(i0+1,j0+1,1) == 0.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                else if ( i0 == ieg .and. j0 /= jeg ) then
                   if (Grd%mask(i0,j0,1) == 0.0 .or.&
                        & Grd%mask(1,j0,1) == 0.0 .or.&
                        & Grd%mask(i0,j0+1,1) == 0.0 .or.&
                        & Grd%mask(1,j0+1,1) == 0.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                else if ( i0 /= ieg .and. j0 == jeg ) then
                   if ( Grd%mask(i0,j0,1) == 0.0 .or. Grd%mask(i0+1,j0,1) == 0.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                else
                   if ( Grd%mask(i0,j0,1) == 0.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                end if
             end if ! here

             if ( Profiles(num_profiles)%accepted .and.&
                  & Profiles(num_profiles)%inst_type == MOORING+TAO ) then
                if ( allocated(mask_tao) ) then
                   if ( mask_tao(i0,j0) < 1.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                      write (UNIT=stdout_unit,&
                           & FMT='("Rejecting tao mooring at (lat,lon) = (",F10.5,",",F10.5,") based on user-specified mask.")')&
                           & Profiles(num_profiles)%lat,&
                           & Profiles(num_profiles)%lon
                   end if
                end if
             end if

             if ( Profiles(num_profiles)%accepted ) then ! accepted
                Profiles(num_profiles)%flag(:) = .true.
                allocate(Profiles(num_profiles)%k_index(Profiles(num_profiles)%levels))
                do k=1, Profiles(num_profiles)%levels
                   if (Profiles(num_profiles)%depth(k) < Grd%z(1)) then
                     Profiles(num_profiles)%k_index(k) = 1.0
                   else
                     Profiles(num_profiles)%k_index(k) = frac_index(Profiles(num_profiles)%depth(k), (/0.,Grd%z(:)/))! - 1 snz modify to v3.2 JAN3012
                   end if
                   if ( Profiles(num_profiles)%k_index(k) < 1.0 ) then
                      if ( Profiles(num_profiles)%depth(k) < 0.0 ) then
                         Profiles(num_profiles)%k_index(k) = 0.0
                      else if ( Profiles(num_profiles)%depth(k) > Grd%z(size(Grd%z,1)) ) then
                         Profiles(num_profiles)%k_index(k) = real(nk)
                      end if
                   else
                      Profiles(num_profiles)%k_index(k) = Profiles(num_profiles)%k_index(k) - 1.0
                   end if
                   if ( Profiles(num_profiles)%k_index(k) > real(nk) ) then
                      call error_mesg('oda_core_mod::open_profile_dataset', 'Profile k_index is greater than nk', FATAL)
                   else if ( Profiles(num_profiles)%k_index(k) < 0.0 ) then
                      call error_mesg('oda_core_mod::open_profile_dataset', 'Profile k_index is less than 0', FATAL)
                   end if
                   k0 = floor(Profiles(num_profiles)%k_index(k))

                   IF ( k0 >= 1 ) THEN ! snz add
                      if ( Profiles(num_profiles)%flag(k) ) then ! flag
                         if ( i0 /= ieg .and. j0 /= jeg ) then
                            if ( Grd%mask(i0,j0,k0) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0,k0) == 0.0 .or.&
                                 & Grd%mask(i0,j0+1,k0) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0+1,k0) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else if ( i0 == ieg .and. j0 /= jeg ) then
                            if ( Grd%mask(i0,j0,k0) == 0.0 .or.&
                                 & Grd%mask(1,j0,k0) == 0.0 .or.&
                                 & Grd%mask(i0,j0+1,k0) == 0.0 .or.&
                                 & Grd%mask(1,j0+1,k0) == 0.0) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else if ( i0 /= ieg .and. j0 == jeg ) then
                            if ( Grd%mask(i0,j0,k0) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0,k0) == 0.0) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else
                            if ( Grd%mask(i0,j0,k0) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         end if

                         if ( i0 /= ieg .and. j0 /= jeg) then
                            if ( Grd%mask(i0,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0,j0+1,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0+1,k0+1) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else if ( i0 == ieg .and. j0 /= jeg ) then
                            if ( Grd%mask(i0,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(1,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0,j0+1,k0+1) == 0.0 .or.&
                                 & Grd%mask(1,j0+1,k0+1) == 0.0) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else if ( i0 /= ieg .and. j0 == jeg ) then
                            if ( Grd%mask(i0,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0,k0+1) == 0.0) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else
                            if ( Grd%mask(i0,j0,k0+1) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         end if
                        
                         if ( abs(Profiles(num_profiles)%data(k)) > 1.e4 &
                              & .or. abs(Profiles(num_profiles)%depth(k)) > 1.e4 ) then
                            Profiles(num_profiles)%flag(k) = .false.
                         end if
                      end if ! flag
                   end if ! snz add
                end do
             end if ! accepted         
          endif ! 05 Nov 2012
       else ! localize
          i = i+1
       end if ! localize

       if ( var_id == TEMP_ID .and. num_profiles > 0 ) call xbt_drop_rate_adjust(Profiles(num_profiles))

       if ( i .gt. nstation ) cont = .false.
    end do

    a = nprof_in_filt_domain
    bad_point_g = bad_point
    call mpp_sum(a)
    call mpp_sum(bad_point_g)
    call mpp_sum(out_bound_point)

    if ( no_prf /= num_profiles ) then
       write(UNIT=stdout_unit, FMT='("PE: ",I6," no_prf = ",I8,", num_profiles = ",I8)') mpp_pe(), no_prf, num_profiles
    end if
    if ( var_id == TEMP_ID ) then
       write(UNIT=stdout_unit, FMT='("A grand total of ",I8," temp prfs within global domain")') no_temp
       write(UNIT=stdout_unit, FMT='("The total of bad_point temp ",I8," within global domain")') bad_point_g
       write(UNIT=stdout_unit, FMT='("The total out_bound_point temp ",I8)') out_bound_point
    else if ( var_id == SALT_ID ) then
       write(UNIT=stdout_unit, FMT='("A grand total of ",I8," salt prfs within global domain")') no_salt
       write(UNIT=stdout_unit, FMT='("The total of bad_point salt",I8," within global domain")') bad_point_g
       write(UNIT=stdout_unit, FMT='("A grand total of ",I8," prfs within global domain")') no_prf
       write(UNIT=stdout_unit, FMT='("A grand total of ",I8," prfs within current PEs computer domain")') a
       write(UNIT=stdout_unit, FMT='("The total out_bound_point salt ",I8)') out_bound_point
    end if

    call mpp_sync_self()
    call mpp_close(unit)
    deallocate(axes)
    deallocate(fields)

!    call mpp_print_memuse_stats('open_profile_dataset End')

  end subroutine open_profile_dataset

  subroutine open_profile_dataset_gtspp()
    return
  end subroutine open_profile_dataset_gtspp

  subroutine open_profile_dataset_argo(filename, time_start, time_end, obs_variable, localize)  
    character(len=*), intent(in) :: filename
    type(time_type), intent(in) :: time_start, time_end
    integer, intent(in) :: obs_variable
    logical, intent(in), optional :: localize

    integer, parameter :: MAX_LEVELS = 1000
    integer, parameter :: MAX_LNKS = 500

    real :: lon, lat, time, rlink, prf_type
    real :: ri0, rj0
    real, dimension(MAX_LEVELS) :: depth, data
    real, dimension(MAX_LNKS, MAX_LEVELS) :: data_bfr, depth_bfr

    integer :: unit, ndim, nvar, natt, nstation
    integer :: stdout_unit
    integer :: inst_type, var_id
    integer :: num_levs, k, kk, i, i0, j0, k0, nlevs, a, nn, ii, nlinks
    integer :: nprof_in_filt_domain, out_bound_point

    character(len=32) :: fldname, axisname, anal_fldname, time_units
    character(len=128) :: emsg_local

    logical :: data_is_local, localize_data, cont
    logical :: data_in_period
    logical :: prof_in_filt_domain
    logical, dimension(MAX_LEVELS) :: flag 
    logical, dimension(MAX_LNKS, MAX_LEVELS) :: flag_bfr

    type(time_type) :: profile_time
    type(axistype), pointer :: depth_axis, station_axis
    type(axistype), allocatable, dimension(:), target :: axes
    type(fieldtype), allocatable, dimension(:), target :: fields
    type(fieldtype), pointer :: field_lon, field_lat, field_flag, field_time
    type(fieldtype), pointer :: field_depth, field_data, field_link, field_var_type

    ! NOTE: fields are restricted to be in separate files

    stdout_unit = stdout()

    if ( PRESENT(localize) ) then
       localize_data = localize
    else
       localize_data = .true.
    end if

    nprof_in_filt_domain = 0

    anal_fldname = 'none'
    var_id=-1
    if ( obs_variable == TEMP_ID ) then
       anal_fldname = 'temp'
       var_id = TEMP_ID
    else if ( obs_variable == SALT_ID ) then
       anal_fldname = 'salt'
       var_id = SALT_ID
    end if

!    call mpp_print_memuse_stats('open_profile_dataset_argo Start')

    call mpp_open(unit, filename, form=MPP_NETCDF, fileset=MPP_SINGLE, threading=MPP_MULTI, action=MPP_RDONLY)
    call mpp_get_info(unit, ndim, nvar, natt, nstation)

    write (UNIT=stdout_unit, FMT='("Opened profile dataset: ",A)') trim(filename)

    ! get axis information

    allocate(axes(ndim))
    call mpp_get_axes(unit, axes)
    do i=1, ndim
       call mpp_get_atts(axes(i), name=axisname)
       select case (trim(axisname))
       case ('depth_index')
          depth_axis => axes(i)
       case ('station_index')
          station_axis => axes(i)
       end select
    end do

    ! get field information
    allocate(fields(nvar))
    call mpp_get_fields(unit, fields)
    do i=1, nvar
       call mpp_get_atts(fields(i), name=fldname)
       if( var_id .eq. TEMP_ID ) then
          select case (trim(fldname))
          case ('longitude')
             field_lon => fields(i)
          case ('latitude')
             field_lat => fields(i)
          case ('dens_flag') 
             field_flag => fields(i)
          case ('time')
             field_time => fields(i)
          case ('temp')
             field_data => fields(i)
          case ('depth')
             field_depth => fields(i)
          case ('link')
             field_link => fields(i)
          case ('var_type')
             field_var_type => fields(i)
          end select
       else if( var_id .eq. SALT_ID ) then
          select case (trim(fldname))
          case ('longitude')
             field_lon => fields(i)
          case ('latitude')
             field_lat => fields(i)
          case ('dens_flag') 
             field_flag => fields(i)
          case ('time')
             field_time => fields(i)
          case ('salt')
             field_data => fields(i)
          case ('depth')
             field_depth => fields(i)
          case ('link')
             field_link => fields(i)
          case ('var_type')
             field_var_type => fields(i)
          end select
       end if
    end do

    call mpp_get_atts(depth_axis, len=nlevs)

    if ( nlevs > MAX_LEVELS ) then 
       call error_mesg('oda_core_mod::open_profile_dataset_argo', 'increase parameter MAX_LEVELS', FATAL)
    else if (nlevs < 1) then
       call error_mesg('oda_core_mod::open_profile_dataset_argo', 'nlevs less than 1.', FATAL)
    end if

    if ( .NOT.ASSOCIATED(field_data) ) then
       call error_mesg('oda_core_mod::open_profile_dataset_argo',&
            & 'profile dataset not used because data not needed for Analysis', NOTE)
       return
    end if

    write (UNIT=stdout_unit, FMT='("There are ",I8," records in this dataset")') nstation
    write (UNIT=stdout_unit, FMT='("Searching for profiles . . .")')
    
    call mpp_get_atts(field_time, units=time_units)

    out_bound_point = 0

    i=1
    cont=.true.
    
    do while (cont)
       prof_in_filt_domain = .false.
       depth = missing_value  ! snz add
       data = missing_value   ! snz add

       call mpp_read(unit, field_lon, lon, tindex=i)
       call mpp_read(unit, field_lat, lat, tindex=i)
       call mpp_read(unit, field_time, time, tindex=i)
       call mpp_read(unit, field_depth, depth(1:nlevs), tindex=i)
       call mpp_read(unit, field_data, data(1:nlevs), tindex=i)
       call mpp_read(unit, field_var_type, prf_type, tindex=i)
       call mpp_read(unit, field_link, rlink, tindex=i)

!!$       inst_type = DRIFTER + ARGO
       inst_type = 20 ! snz change one line
       data_is_local = .false.
       data_in_period = .false.

       if ( lon .lt. 0.0 ) lon = lon + 360.0
       if ( lon .gt. 360.0 ) lon = lon - 360.0
       if ( lon .lt. 80.0 ) lon = lon + 360.0 

       if ( lat > ass_start_lat .and. lat < ass_end_lat ) data_is_local = .true.

       profile_time = get_cal_time(time, time_units, 'NOLEAP')
       if ( profile_time > time_start .and. profile_time < time_end ) data_in_period = .true.
       if ( (data_in_period .and. data_is_local) .and. (.NOT.localize_data) ) then

          if (isd_filt < 1 .and. ied_filt > ieg) then
             ! filter domain is a full x band
             if (lon >= x_grid(1,jsd_flt0) .and. lon <= x_grid(ieg-1,jsd_flt0) .and.&
                  lat >= y_grid(1,jsd_flt0) .and. lat <= y_grid(ieg-1,jsd_flt0)) then
                prof_in_filt_domain = .true.
             end if
          else if (isd_filt >= 1 .and. ied_filt <= ieg) then
             ! Interior filter domain
            if (lon >= x_grid(isd_filt,jsd_flt0) .and. lon <= x_grid(ied_filt-1,jsd_flt0) .and.&
               & lat >= y_grid(isd_filt,jsd_flt0) .and. lat <=  y_grid(ied_filt-1,jed_flt0-1)) then
                prof_in_filt_domain = .true.
            end if
          else if (isd_filt < 1 .and. ied_filt <= ieg) then
             ! lhs filter domain
             isd_flt0 = isd_filt + ieg
             if ((lon >= x_grid(1,jsd_flt0) .and. lon <= x_grid(ied_filt-1,jsd_flt0) .and.&
                  & lat >= y_grid(1,jsd_flt0) .and. lat <=  y_grid(ied_filt-1,jed_flt0-1)).or.&
                  & (lon >= x_grid(isd_flt0,jsd_flt0) .and. lon <= x_grid(ieg-1,jsd_flt0) .and.&
                  & lat >= y_grid(isd_flt0,jsd_flt0) .and. lat <=  y_grid(ieg-1,jed_flt0-1))) then
                prof_in_filt_domain = .true.
             end if
          else if (isd_filt >= 1 .and. ied_filt > ieg) then
             ! rhs filter domain
             ied_flt0 = ied_filt - ieg
             if ( lon >= x_grid(isd_filt,jsd_flt0) .and. lon <= x_grid(ieg-1,jsd_flt0) .and.&
                  & lat >= y_grid(isd_filt,jsd_flt0) .and. lat <=  y_grid(ieg-1,jed_flt0-1) ) then
                prof_in_filt_domain = .true.
             end if
             if (ied_flt0-1 > 1) then
                if ( lon >= x_grid(1,jsd_flt0) .and. lon <= x_grid(ied_flt0-1,jsd_flt0) .and.&
                     & lat >= y_grid(1,jsd_flt0) .and. lat <=  y_grid(ied_flt0-1,jed_flt0-1) ) then
                   prof_in_filt_domain = .true.
                end if
             end if
          end if

          if ( var_id == TEMP_ID ) then
             num_profiles = num_profiles + 1
             no_temp = no_temp + 1
             no_prf = no_prf + 1
          else if ( var_id == SALT_ID .and. prf_type == 2.0 ) then
             num_profiles =num_profiles + 1
             no_salt = no_salt + 1
             no_prf = no_prf + 1
          end if

          if ( num_profiles > max_profiles ) then
             call error_mesg('oda_core_mod::open_profile_dataset_argo',&
                  & 'maximum number of profiles exceeded, increase max_profiles in oda_core_nml', FATAL)
          end if

          num_levs = 0
          do k=1, MAX_LEVELS
             flag(k) = .true.
             if ( depth(k) > 2000.0 ) depth(k) = missing_value  ! snz add for rdat-hybn
             if ( var_id == TEMP_ID ) then
                if ( data(k) .eq. missing_value .or. depth(k) .eq. missing_value ) then
                   flag(k) = .false.
                else
                   num_levs = num_levs+1
                end if
             else if ( var_id == SALT_ID ) then
                if ( data(k) .eq. missing_value .or. depth(k) .eq. missing_value ) then
                   flag(k) = .false.
                else
                   num_levs = num_levs+1
                end if
             end if
          end do

          ! large profile are stored externally in separate records
          ! read linked records and combine profile
          ii=i+1
          nlinks = 0
          do while ( rlink > 0.0 )
             nlinks = nlinks + 1

             if ( nlinks > MAX_LNKS ) then
                write (emsg_local, '("nlinks (",I6,") > MAX_LNKS (",I6,")")')&
                     & nlinks, MAX_LNKS
                call error_mesg('oda_core_mod::open_profile_dataset_argo',&
                     & trim(emsg_local)//' in file "'//trim(filename)//&
                     & '".  Increase parameter MAX_LNKS', FATAL)
             end if

             depth_bfr(nlinks,:) = missing_value
             data_bfr(nlinks,:) = missing_value
             call mpp_read(unit,field_depth,depth_bfr(nlinks,1:nlevs),tindex=ii)
             call mpp_read(unit,field_data,data_bfr(nlinks,1:nlevs),tindex=ii)
             call mpp_read(unit,field_link,rlink,tindex=ii)
             ii=ii+1
          end do
          i=ii ! set record counter to start of next profile

          if ( nlinks > 0 ) then
             do nn=1, nlinks
                do k=1, MAX_LEVELS
                   flag_bfr(nn,k) = .true.

                   if ( depth_bfr(nn,k) > 2000.0 ) depth_bfr(nn,k) = missing_value  ! snz add for rdat-hybn

                   if ( var_id == TEMP_ID ) then
                      if ( data_bfr(nn,k) .eq. missing_value .or. depth_bfr(nn,k) .eq. missing_value ) then
                         flag_bfr(nn,k) = .false.
                      else
                         num_levs = num_levs+1
                      end if
                   else if ( var_id == SALT_ID ) then
                      if ( data_bfr(nn,k) .eq. missing_value .or. depth_bfr(nn,k) .eq. missing_value ) then
                         flag_bfr(nn,k) = .false.
                      else
                         num_levs = num_levs+1
                      end if
                   end if
                end do
             end do
          end if

          ! mh2 asks to change from [if (num_levs == 0) cycle]
          if ( num_levs == 0 ) then
             if ( i .gt. nstation ) cont = .false.
             cycle
          end if

          if (nprof_in_filt_domain > 0 .and. prof_in_filt_domain) then ! snz 05 Nov 2012

          allocate(profiles(num_profiles)%depth(num_levs))
          allocate(profiles(num_profiles)%data(num_levs))
          allocate(profiles(num_profiles)%flag(num_levs))
          profiles(num_profiles)%variable = var_id
          if ( inst_type < 1 ) inst_type = UNKNOWN
          profiles(num_profiles)%inst_type = inst_type
          profiles(num_profiles)%levels = num_levs
          profiles(num_profiles)%lat = lat
          profiles(num_profiles)%lon = lon
!          allocate(profiles(num_profiles)%ms(num_levs))
!          allocate(profiles(num_profiles)%ms_inv(num_levs))           
!          profiles(num_profiles)%ms(:) = 0.5

          kk= 1
          do k=1, MAX_LEVELS
             if ( flag(k) ) then
                if ( kk > profiles(num_profiles)%levels ) then
                   call error_mesg('oda_core_mod::open_profile_dataset_argo',&
                        & 'Loop variable "kk" is greater than profile levels', FATAL)
                end if
                profiles(num_profiles)%depth(kk) = depth(k)
                profiles(num_profiles)%data(kk) = data(k)
!                profiles(num_profiles)%ms_inv(kk) = 1./profiles(num_profiles)%ms(kk)                  
                kk = kk + 1
             end if
          end do

          do nn=1, nlinks
             do k=1, MAX_LEVELS
                if ( flag_bfr(nn,k) ) then
                   if ( kk > profiles(num_profiles)%levels ) then
                      call error_mesg('oda_core_mod::open_profile_dataset_argo',&
                           & 'Loop variable "kk" is greater than profile levels (bfr loop)', FATAL)
                   end if
                   profiles(num_profiles)%depth(kk) = depth_bfr(nn,k)
                   profiles(num_profiles)%data(kk) = data_bfr(nn,k)
!                   profiles(num_profiles)%ms_inv(kk) = 1./profiles(num_profiles)%ms(kk)
                   kk = kk + 1
                end if
             end do
          end do
           
          profiles(num_profiles)%time = profile_time
           
! snz uses the following to test excluding the coast area salt profiles
!          if (profiles(num_profiles)%variable == SALT_ID .and. &
!              profiles(num_profiles)%depth(num_levs) < 900.0) profiles(num_profiles)%accepted = .false.

          ! calculate interpolation coefficients (make sure to account for grid offsets here!)
          ! note that this only works for lat/lon grids
          if ( lat < 65.0 ) then ! regular grids
             ri0 = frac_index(lon, x_grid(:,1))
             rj0 = frac_index(lat, y_grid(90,:))
             i0 = floor(ri0)
             j0 = floor(rj0)
             if ( i0 > ieg .or. j0 > jeg ) then
                write (UNIT=emsg_local, FMT='("i0 = ",I6,", j0 = ",I6)') mpp_pe(), i0, j0
                call error_mesg('oda_core_mod::open_profile_dataset_argo',&
                     & 'For regular grids, either i0 > ieg or j0 > jeg.  '//trim(emsg_local), FATAL)
             end if
             if ( isd_filt >= 1 .and. ied_filt <= ieg ) then
               if ( i0 < isd_filt .or. i0 > ied_filt .or. j0 < jsd_filt .or. j0 > jed_filt ) then
                  write (UNIT=emsg_local, FMT='("pe,i0,j0= ",3I8,"isd_filt,ied_filt,jsd_filt,jed_filt= ",4I8)')&
                       & mpp_pe(), i0, j0, isd_filt,ied_filt,jsd_filt,jed_filt
                  call error_mesg('oda_core_mod::open_profile_dataset',&
                       & 'i0,j0 out of bounds in argo01. '//trim(emsg_local), FATAL)
               end if
             end if
             if ( isd_filt < 1 .and. i0 > ied_filt-1 .and. i0 < isd_filt + ieg ) then
                write (UNIT=emsg_local, FMT='("pe,i0,j0= ",3I8,"isd_filt,ied_filt,jsd_filt,jed_filt= ",4I8)')&
                     & mpp_pe(), i0, j0, isd_filt,ied_filt,jsd_filt,jed_filt
                call error_mesg('oda_core_mod::open_profile_dataset',&
                     & 'i0,j0 out of bounds in argo02. '//trim(emsg_local), FATAL)
             end if
             if ( ied_filt > ieg .and. i0 > ied_filt-ieg-1 .and. ied_filt < isd_filt ) then
                write (UNIT=emsg_local, FMT='("pe,i0,j0= ",3I8,"isd_filt,ied_filt,jsd_filt,jed_filt= ",4I8)')&
                     & mpp_pe(), i0, j0, isd_filt,ied_filt,jsd_filt,jed_filt
                call error_mesg('oda_core_mod::open_profile_dataset',&
                     & 'i0,j0 out of bounds in argo03. '//trim(emsg_local), FATAL)
             end if
             Profiles(num_profiles)%i_index = ri0
             Profiles(num_profiles)%j_index = rj0
          else ! tripolar grids
             lon_out(1,1) = lon*DEG_TO_RAD
             lat_out(1,1) = lat*DEG_TO_RAD
             call horiz_interp_bilinear_new (Interp, x_grid*DEG_TO_RAD, y_grid*DEG_TO_RAD, lon_out, lat_out)
             if(Interp%wti(1,1,2) < 1.0) then
                i0 = Interp%i_lon(1,1,1)
             else
                i0 = Interp%i_lon(1,1,2)
             end if
             if ( Interp%wtj(1,1,2) < 1.0 ) then
                j0 = Interp%j_lat(1,1,1)
             else
                j0 = Interp%j_lat(1,1,2)
             end if
             if ( i0 > ieg .or. j0 > jeg ) then
                write (UNIT=emsg_local, FMT='("i0 = ",I6,", j0 = ",I6)') mpp_pe(), i0, j0
                call error_mesg('oda_core_mod::open_profile_dataset_argo',&
                     & 'For tirpolar grids, either i0 > ieg or j0 > jeg.  '//trim(emsg_local), FATAL)
             end if
             if ( i0 < isd_filt .or. i0 > ied_filt .or. j0 < jsd_filt .or. j0 > jed_filt ) then
!!$                print*,'argo.pe,i0,j0= ',mpp_pe(), i0, j0,&
!!$                     & 'isd_filt,ied_filt,jsd_filt,jed_filt= ',isd_filt,ied_filt,jsd_filt,jed_filt
!!$                print*,'pe,lon,lat=',mpp_pe(),lon,lat,'x_grid(i0+-1)',x_grid(i0-1:i0+1,j0),&
!!$                     & 'y_grid(i0,j0+-1)=',y_grid(i0,j0-1:j0+1)
!!$                print*,'lono11,lato11=',x_grid(i0,j0),y_grid(i0,j0),'lono21,lato21=',x_grid(i0+1,j0),y_grid(i0+1,j0)
!!$                print*,'lono12,lato12=',x_grid(i0,j0+1),y_grid(i0,j0+1),'lono22,lato22=',x_grid(i0+1,j0+1),y_grid(i0+1,j0+1)
!!$                print*,'lonm11,latm11=',x_grid(isd_filt,jsd_filt),y_grid(isd_filt,jsd_filt),&
!!$                     & 'lonm21,latm21=',x_grid(ied_filt,jsd_filt),y_grid(ied_filt,jsd_filt)
!!$                print*,'lonm12,latm12=',x_grid(isd_filt,jed_filt),y_grid(isd_filt,jed_filt),&
!!$                     & 'lonm22,latm22=',x_grid(ied_filt,jed_filt),y_grid(ied_filt,jed_filt)
!!$                print*,'wti(1:2)=',Interp%wti(1,1,:),'wtj(1:2)=',Interp%wtj(1,1,:)

                out_bound_point = out_bound_point + 1
             end if
             if ( Interp%wti(1,1,2) < 1.0 ) then
                Profiles(num_profiles)%i_index =Interp%i_lon(1,1,1) + Interp%wti(1,1,2)
             else
                Profiles(num_profiles)%i_index =Interp%i_lon(1,1,2)
             end if
             if ( Interp%wtj(1,1,2) < 1.0 ) then
                Profiles(num_profiles)%j_index =Interp%j_lat(1,1,1) + Interp%wtj(1,1,2)
             else
                Profiles(num_profiles)%j_index =Interp%j_lat(1,1,2)
             end if
          end if ! grids

           Profiles(num_profiles)%accepted = .true.
           if ( i0 < 1 .or. j0 < 1 ) then
              Profiles(num_profiles)%accepted = .false.
           end if
           if ( i0 < isd_filt .or. i0 >= ied_filt .or. j0 < jsd_filt .or. j0 >= jed_filt ) then
              Profiles(num_profiles)%accepted = .false.
           end if

           if ( Profiles(num_profiles)%accepted ) then ! here
              if ( i0 /= ieg .and. j0 /= jeg ) then
                 if ( Grd%mask(i0,j0,1) == 0.0 .or.&
                      & Grd%mask(i0+1,j0,1) == 0.0 .or.&
                      & Grd%mask(i0,j0+1,1) == 0.0 .or.&
                      & Grd%mask(i0+1,j0+1,1) == 0.0) then
                    Profiles(num_profiles)%accepted = .false.
                 end if
              else if ( i0 == ieg .and. j0 /= jeg ) then
                 if (Grd%mask(i0,j0,1) == 0.0 .or.&
                      & Grd%mask(1,j0,1) == 0.0 .or.&
                      & Grd%mask(i0,j0+1,1) == 0.0 .or.&
                      & Grd%mask(1,j0+1,1) == 0.0) then
                    Profiles(num_profiles)%accepted = .false.
                 end if
              else if ( i0 /= ieg .and. j0 == jeg ) then
                 if (Grd%mask(i0,j0,1) == 0.0 .or.&
                      & Grd%mask(i0+1,j0,1) == 0.0) then
                    Profiles(num_profiles)%accepted = .false.
                 end if
              else
                 if ( Grd%mask(i0,j0,1) == 0.0 ) then
                    Profiles(num_profiles)%accepted = .false.
                 end if
              end if
           end if ! here

           if ( Profiles(num_profiles)%accepted .and. Profiles(num_profiles)%inst_type == MOORING+TAO) then
              if ( allocated(mask_tao) ) then
                 if ( mask_tao(i0,j0) < 1.0 ) then
                    Profiles(num_profiles)%accepted = .false.
                    write (UNIT=stdout_unit,&
                         & FMT='("Rejecting tao mooring at (lat,lon) = (",F10.5,",",F10.5,") based on user-specified mask.")')&
                         & Profiles(num_profiles)%lat,&
                         & Profiles(num_profiles)%lon
                 end if
              end if
           end if

           if ( Profiles(num_profiles)%accepted ) then
              Profiles(num_profiles)%flag(:) = .true.
              allocate(Profiles(num_profiles)%k_index(Profiles(num_profiles)%levels))
              do k=1, Profiles(num_profiles)%levels
                 if (Profiles(num_profiles)%depth(k) < Grd%z(1)) then
                   Profiles(num_profiles)%k_index(k) = 1.0
                 else
                   Profiles(num_profiles)%k_index(k) = frac_index(Profiles(num_profiles)%depth(k), (/0.,Grd%z(:)/))! - 1 snz modify to v3.2 JAN3012
                 end if
                 if ( Profiles(num_profiles)%k_index(k) < 1 ) then
                    if ( Profiles(num_profiles)%depth(k) < 0 ) then
                       Profiles(num_profiles)%k_index(k) = 0
                    else if ( Profiles(num_profiles)%depth(k) > Grd%z(size(Grd%z,1)) ) then
                       Profiles(num_profiles)%k_index(k) = nk
                    end if
                 else
                    Profiles(num_profiles)%k_index(k) = Profiles(num_profiles)%k_index(k) - 1
                 end if
                 if ( Profiles(num_profiles)%k_index(k) > nk ) then 
                    call error_mesg('oda_core_mod::open_profile_dataset_argo', 'Profile k_index is greater than nk', FATAL)
                 else if ( Profiles(num_profiles)%k_index(k) < 0 ) then
                    call error_mesg('oda_core_mod::open_profile_dataset_argo', 'Profile k_index is less than 0', FATAL)
                 end if
                 k0 = floor(Profiles(num_profiles)%k_index(k))

                 if ( k0 >= 1 ) then ! snz add
                    if ( Profiles(num_profiles)%flag(k) ) then ! flag
                       if ( i0 /= ieg .and. j0 /= jeg ) then
                          if ( Grd%mask(i0,j0,k0) == 0.0 .or.&
                               & Grd%mask(i0+1,j0,k0) == 0.0 .or.&
                               & Grd%mask(i0,j0+1,k0) == 0.0 .or.&
                               & Grd%mask(i0+1,j0+1,k0) == 0.0 ) then
                             Profiles(num_profiles)%flag(k) = .false.
                          end if
                       else if ( i0 == ieg .and. j0 /= jeg ) then
                          if ( Grd%mask(i0,j0,k0) == 0.0 .or.&
                               & Grd%mask(1,j0,k0) == 0.0 .or.&
                               & Grd%mask(i0,j0+1,k0) == 0.0 .or.&
                               & Grd%mask(1,j0+1,k0) == 0.0 ) then 
                             Profiles(num_profiles)%flag(k) = .false.
                          end if
                       else if ( i0 /= ieg .and. j0 == jeg ) then
                          if ( Grd%mask(i0,j0,k0) == 0.0 .or.&
                               & Grd%mask(i0+1,j0,k0) == 0.0 ) then 
                             Profiles(num_profiles)%flag(k) = .false.
                          end if
                       else 
                          if ( Grd%mask(i0,j0,k0) == 0.0 ) then 
                             Profiles(num_profiles)%flag(k) = .false.
                          end if
                       end if

                       if ( i0 /= ieg .and. j0 /= jeg ) then
                          if ( Grd%mask(i0,j0,k0+1) == 0.0 .or.&
                               & Grd%mask(i0+1,j0,k0+1) == 0.0 .or.&
                               & Grd%mask(i0,j0+1,k0+1) == 0.0 .or.&
                               & Grd%mask(i0+1,j0+1,k0+1) == 0.0 ) then
                             Profiles(num_profiles)%flag(k) = .false.
                          end if
                       else if ( i0 == ieg .and. j0 /= jeg ) then
                          if ( Grd%mask(i0,j0,k0+1) == 0.0 .or.&
                               & Grd%mask(1,j0,k0+1) == 0.0 .or.&
                               & Grd%mask(i0,j0+1,k0+1) == 0.0 .or.&
                               & Grd%mask(1,j0+1,k0+1) == 0.0) then
                             Profiles(num_profiles)%flag(k) = .false.
                          end if
                       else if ( i0 /= ieg .and. j0 == jeg ) then
                          if ( Grd%mask(i0,j0,k0+1) == 0.0 .or.&
                               & Grd%mask(i0+1,j0,k0+1) == 0.0 ) then
                             Profiles(num_profiles)%flag(k) = .false.
                          end if
                       else
                          if ( Grd%mask(i0,j0,k0+1) == 0.0 ) then 
                             Profiles(num_profiles)%flag(k) = .false.
                          end if
                       end if

                       if ( abs(Profiles(num_profiles)%data(k)) > 1.e4 &
                            & .or. abs(Profiles(num_profiles)%depth(k)) > 1.e4 ) then
                          Profiles(num_profiles)%flag(k) = .false.
                       end if
                    end if ! flag
                 end if ! snz add
              end do
           end if  ! accepted 

           end if ! 05 Nov 2012

        else ! localize
           i = i+1
        end if ! localize

        if ( i .gt. nstation ) cont = .false.
     end do

     a = nprof_in_filt_domain
     call mpp_sum(a)
     call mpp_sum(out_bound_point)

    if ( no_prf /= num_profiles ) then
       write(UNIT=stdout_unit, FMT='("PE: ",I6," no_prf = ",I8,", num_profiles = ",I8)') mpp_pe(), no_prf, num_profiles
    end if
    if ( var_id == TEMP_ID ) then
       write(UNIT=stdout_unit, FMT='("A grand total of ",I8," argo temp prfs within global domain")') no_temp
       write(UNIT=stdout_unit, FMT='("A total out of bound points",I8," argo temp within global domain")') out_bound_point
    else if ( var_id == SALT_ID ) then
       write(UNIT=stdout_unit, FMT='("A grand total of ",I8," argo salt prfs within global domain")') no_salt
       write(UNIT=stdout_unit, FMT='("A grand total of ",I8," argo prfs within global domain")') no_prf
       write(UNIT=stdout_unit, FMT='("A grand total of ",I8," argo prfs within current PEs computer domain")') a
       write(UNIT=stdout_unit, FMT='("A total out of bound points",I8," argo salt within global domain")') out_bound_point
    end if

    call mpp_sync_self()
    call mpp_close(unit)
    deallocate(axes)
    deallocate(fields)

!    call mpp_print_memuse_stats('open_profile_dataset_argo End')

  end subroutine open_profile_dataset_argo

  ! get profiles and sfc
  ! obs relevant to current analysis interval
  subroutine get_obs(model_time, Prof, nprof)
    type(time_type), intent(in) :: model_time
    type(ocean_profile_type), dimension(:), intent(inout) :: Prof
    integer, intent(inout) :: nprof

    integer :: i, k, kk, k_interval
    integer :: yr, mon, day, hr, min, sec
    integer :: stdout_unit

    type(time_type) :: tdiff

    nprof = 0
    stdout_unit = stdout()

    write (UNIT=stdout_unit, FMT='("Gathering profiles for current analysis time")')
    call get_date(model_time, yr, mon, day, hr, min, sec)
    write (UNIT=stdout_unit, FMT='("Current YYYY/MM/DD = ",I4,"/",I2,"/",I2)') yr, mon, day

    do i=1, no_prf
       if ( Profiles(i)%time <= model_time ) then
          tdiff = model_time - Profiles(i)%time
       else
          tdiff = Profiles(i)%time - model_time
       end if

       ! no tdiff criteria for monthly mean data like
       ! but tdiff criteria has to be set for daily data
       if ( tdiff <= time_window(Profiles(i)%inst_type) .and. Profiles(i)%accepted ) then
          ! for single profile test

          nprof = nprof + 1
          if ( nprof > size(Prof,1) ) then
             call error_mesg('oda_core_mod::get_obs',&
                  & 'Passed in array "Prof" is smaller than number of profiles, increase size of Prof before call.',&
                  & FATAL)
          end if
          call copy_obs(Profiles(i:i), Prof(nprof:nprof))

          Prof(nprof)%tdiff = tdiff
          
          ! snz add the following few lines for increasing deep water data
          if ( Prof(nprof)%levels > max_prflvs ) then
             k_interval = (Prof(nprof)%levels-max_prflvs+50)/50 + 1
             kk = max_prflvs - 50
             do k=max_prflvs-50+1, Prof(nprof)%levels, k_interval
                kk = kk + 1
                Prof(nprof)%depth(kk) = Prof(nprof)%depth(k)
                Prof(nprof)%k_index(kk) = Prof(nprof)%k_index(k)
                Prof(nprof)%data(kk) = Prof(nprof)%data(k)
                Prof(nprof)%flag(kk) = Prof(nprof)%flag(k)
             end do
             Prof(nprof)%levels = kk
          end if
          ! snz end the adding lines
       end if
    end do

    write (UNIT=stdout_unit,&
         & FMT='("A total of ",I8," profiles are being used for the current analysis step.")') nprof

    return
  end subroutine get_obs

  subroutine oda_core_init(Domain, Grid, time_s, time_e, filt_domain, localize)
    type(domain2d), intent(inout) :: Domain
    type(grid_type), target, intent(in) :: Grid
    logical, intent(in), optional :: localize
    type(time_type), intent(in) :: time_s, time_e
    type(domain2d), intent(in) :: filt_domain

    integer :: ioun, ierr, io_status
    integer :: stdlog_unit

    stdlog_unit = stdlog()

    ! Read in the namelist file
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, oda_core_nml, iostat=io_status)
#else
    ioun = open_namelist_file()
    read(ioun, NML=oda_core_nml, IOSTAT=io_status)
    ierr = check_nml_error(io_status, 'oda_core_nml')
    call close_file(ioun)
#endif

    write(stdlog_unit, NML=oda_core_nml)

    Grd => Grid
    
    call mpp_get_compute_domain(Domain, isc, iec, jsc, jec)
    call mpp_get_data_domain(Domain, isd, ied, jsd, jed)
    call mpp_get_global_domain(Domain, isg, ieg, jsg, jeg)
    call mpp_get_data_domain(filt_domain, isd_filt, ied_filt, jsd_filt, jed_filt)

    jsd_flt0 = jsd_filt
    jed_flt0 = jed_filt
    if (jsd_filt < 1) jsd_flt0 = 1
    if (jed_filt > jeg) jed_flt0 = jeg

    nk = size(Grid%z)

    call init_observations(time_s, time_e, filt_domain, localize)
  end subroutine oda_core_init
    
  subroutine copy_obs(obs_in, obs_out)
    type(ocean_profile_type), dimension(:), intent(in) :: obs_in
    type(ocean_profile_type), dimension(:), intent(inout) :: obs_out

    integer :: n

    if ( size(obs_in) .ne. size(obs_out) ) then
       call error_mesg('oda_core_mod::copy_obs', 'Size of in and out obs variables are not equal.', FATAL)
    end if

    do n=1, size(obs_in)
       Obs_out(n)%variable = Obs_in(n)%variable
       Obs_out(n)%inst_type = Obs_in(n)%inst_type
       Obs_out(n)%levels = Obs_in(n)%levels
       Obs_out(n)%lon = Obs_in(n)%lon
       Obs_out(n)%lat = Obs_in(n)%lat
       Obs_out(n)%accepted = Obs_in(n)%accepted
       if ( associated(Obs_out(n)%depth) ) then
          deallocate(Obs_out(n)%depth)
          nullify(Obs_out(n)%depth)
       end if
       allocate(Obs_out(n)%depth(Obs_in(n)%levels))
       Obs_out(n)%depth(:) = Obs_in(n)%depth(:)
       if ( associated(Obs_out(n)%data) ) then
          deallocate(Obs_out(n)%data)
          nullify(Obs_out(n)%data)
       end if
       allocate(Obs_out(n)%data(Obs_in(n)%levels))
       Obs_out(n)%data(:) = Obs_in(n)%data(:)
       if ( associated(Obs_out(n)%flag) ) then
          deallocate(Obs_out(n)%flag)
          nullify(Obs_out(n)%flag)
       end if
       allocate(Obs_out(n)%flag(Obs_in(n)%levels))
       Obs_out(n)%flag(:) = Obs_in(n)%flag(:)          
       Obs_out(n)%time = Obs_in(n)%time
       Obs_out(n)%yyyy = Obs_in(n)%yyyy
       Obs_out(n)%mmdd = Obs_in(n)%mmdd
       Obs_out(n)%i_index = Obs_in(n)%i_index
       Obs_out(n)%j_index = Obs_in(n)%j_index
       if ( associated(Obs_out(n)%k_index) ) then
          deallocate(Obs_out(n)%k_index)
          nullify(Obs_out(n)%k_index)
       end if
       allocate(Obs_out(n)%k_index(Obs_in(n)%levels))          
       Obs_out(n)%k_index = Obs_in(n)%k_index

!       if ( associated(Obs_out(n)%ms) ) then
!          deallocate(Obs_out(n)%ms)
!          nullify(Obs_out(n)%ms)
!       end if
!       allocate(Obs_out(n)%ms(Obs_in(n)%levels))          
!       Obs_out(n)%ms = Obs_in(n)%ms
!       if ( associated(Obs_out(n)%ms_inv) ) then
!          deallocate(Obs_out(n)%ms_inv)
!          nullify(Obs_out(n)%ms_inv)
!       end if
!       allocate(Obs_out(n)%ms_inv(Obs_in(n)%levels))          
!       Obs_out(n)%ms_inv = 1./Obs_in(n)%ms    

       Obs_out(n)%tdiff = Obs_in(n)%tdiff
       if ( associated(Obs_out(n)%Forward_model%wgt) ) then
          deallocate(Obs_out(n)%Forward_model%wgt)
          nullify(Obs_out(n)%Forward_model%wgt)
       end if
    end do
  end subroutine copy_obs

  subroutine open_profile_dataset_sst(filename, obs_variable, localize)  
    character(len=*), intent(in) :: filename
    integer, intent(in) :: obs_variable
    logical, intent(in), optional :: localize

    integer, parameter :: MAX_LEVELS = 1

    real :: lon, lat, rms_err
    real :: ri0, rj0
    real, dimension(MAX_LEVELS) :: depth, data

    integer :: unit, ndim, nvar, natt, ntime
    integer :: var_id, inst_type
    integer :: num_levs, k, kk, i, j, i0, j0
    integer :: stdout_unit

    logical :: data_is_local, localize_data
    logical, dimension(MAX_LEVELS) :: flag

    character(len=32) :: axisname, anal_fldname
    character(len=128) :: emsg_local

    type(axistype), dimension(:), allocatable, target :: axes
    type(axistype), pointer :: lon_axis, lat_axis

    if ( PRESENT(localize) ) then
       localize_data = localize
    else
       localize_data = .true.
    end if

    stdout_unit = stdout()

    anal_fldname = 'temp'
    var_id = obs_variable

    call mpp_open(unit, trim(filename), MPP_RDONLY, MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE)
    call mpp_get_info(unit, ndim, nvar, natt, ntime)
    allocate(axes(ndim))
    call mpp_get_axes(unit, axes)

    do i=1, ndim
       call mpp_get_atts(axes(i),name=axisname)
       select case (trim(axisname))
!!$       case ('GRIDLON_T') ! cm2 grids
!!$       case ('gridlon_t') ! cm2 grids
       case ('XT_OCEAN') ! cm2.5 grids
!!$       case ('lon') ! after 2008
          lon_axis => axes(i)
!!$       case ('GRIDLAT_T') ! cm2 grids
!!$       case ('gridlat_t') ! cm2 grids
       case ('YT_OCEAN') ! cm2 grids
!!$       case ('lat') ! for after 2008
          lat_axis => axes(i)
       end select
    end do

    call mpp_get_atts(lon_axis,len=nlon)
    call mpp_get_atts(lat_axis,len=nlat)
    if ( nlon /= 1440 .or. nlat /= 1070 ) then ! after 2008
       write (UNIT=emsg_local, FMT='("sst obs dim is not same as in file. nlon = ",I5,", nlat = ",I5)') nlon, nlat
       call error_mesg('oda_core_mod::open_profile_dataset_sst', trim(emsg_local), FATAL)
    end if

    ! idealized
    do j=1, nlat
       do i=1, nlon
          lon = x_grid(i,j)
          lat = y_grid(i,j)
          rms_err = 0.5
          inst_type = 20
          data_is_local = .true.

          if ( lon .lt. 0.0 ) lon = lon + 360.0
          if ( lon .gt. 360.0 ) lon = lon - 360.0
          if ( lon .lt. 80.0 ) lon = lon + 360.0

          if ( lat < sst_obs_start_lat .or. lat > sst_obs_end_lat ) data_is_local = .false. ! at the final test

          if ( Grd%mask(i,j,1) == 0 ) data_is_local = .false.

          if ( abs(lat) < 40.0 ) then
             if ( i/4*4 /= i .or. j/4*4 /= j ) data_is_local = .false.
          else if ( abs(lat) < 60.0 ) then
             if ( i/8*8 /= i .or. j/6*6 /= j ) data_is_local = .false.
          else
             if ( i/16*16 /= i .or. j/8*8 /= j ) data_is_local = .false.
          end if

          if ( data_is_local .and. (.NOT.localize_data) ) then
             if ( lat < 60.0 ) then ! regular grids
                ri0 = frac_index(lon, x_grid(:,nlat/2))
                rj0 = frac_index(lat, y_grid(nlon/4,:))
                i0 = floor(ri0)
                j0 = floor(rj0)
             else ! tripolar grids
                lon_out(1,1) = lon*DEG_TO_RAD
                lat_out(1,1) = lat*DEG_TO_RAD
                call horiz_interp_bilinear_new (Interp, x_grid*DEG_TO_RAD, y_grid*DEG_TO_RAD, lon_out, lat_out)
                if ( Interp%wti(1,1,2) < 1.0 ) then
                   i0 = Interp%i_lon(1,1,1)
                else
                   i0 = Interp%i_lon(1,1,2)
                end if
                if ( Interp%wtj(1,1,2) < 1.0 ) then
                   j0 = Interp%j_lat(1,1,1)
                else
                   j0 = Interp%j_lat(1,1,2)
                end if

                if ( i0 > ieg .or. j0 > jeg ) then
                   write (UNIT=emsg_local, FMT='("i0 = ",I8,", j0 = ",I8)') i0, j0
                   call error_mesg('oda_core_mod::open_profile_dataset_sst',&
                        & 'For tripolar grids, either i0 > ieg or j0 > jeg.  '//trim(emsg_local), FATAL)
                end if
             end if

             if ( i0 /= ieg .and. j0 /= jeg ) then ! exclude SSTs at ieg and jeg
                if ( Grd%mask(i0,j0,1) /= 0.0 .and. Grd%mask(i0+1,j0,1) /= 0.0 .and.&
                     & Grd%mask(i0,j0+1,1) /= 0.0 .and. Grd%mask(i0+1,j0+1,1) /= 0.0 ) then
                   no_sst = no_sst+1
                   num_profiles=num_profiles+1

                   if ( num_profiles > max_profiles ) then
                      call error_mesg('oda_core_mod::open_profile_dataset_sst',&
                           & 'Maximum number of profiles exceeded, increase max_profiles in oda_core_nml', FATAL)
                   end if

                   num_levs = 0
                   flag = .false.
                   do k=1, 1
                      flag(k) = .true.
                      data(k) = 0.0
                      depth(k) = 0.0
                      num_levs = num_levs + 1
                   end do
                   if ( num_levs == 0 ) cycle
                   allocate(profiles(num_profiles)%depth(num_levs))
                   allocate(profiles(num_profiles)%data(num_levs))
                   allocate(profiles(num_profiles)%flag(num_levs))
                   allocate(profiles(num_profiles)%ms(num_levs))
                   allocate(profiles(num_profiles)%ms_inv(num_levs))
                   profiles(num_profiles)%variable = var_id
                   profiles(num_profiles)%inst_type = inst_type
                   profiles(num_profiles)%levels = num_levs
                   profiles(num_profiles)%lat = lat
                   profiles(num_profiles)%lon = lon

                   kk = 1
                   do k=1, 1
                      if ( flag(k) ) then
                         profiles(num_profiles)%depth(kk) = depth(k)
                         profiles(num_profiles)%data(kk) = data(k)
                         profiles(num_profiles)%ms(kk) = 1.0
                         profiles(num_profiles)%ms_inv(kk) = 1.0
                         kk=kk+1
                      end if
                   end do

                   ! calculate interpolation coefficients (make sure to account for grid offsets here!)
                   if ( lat < 60.0 ) then ! for regular grids
                      Profiles(num_profiles)%i_index = ri0
                      Profiles(num_profiles)%j_index = rj0
                   else ! for tripolar grids
                      lon_out(1,1) = lon*DEG_TO_RAD
                      lat_out(1,1) = lat*DEG_TO_RAD
                      call horiz_interp_bilinear_new (Interp, x_grid*DEG_TO_RAD, y_grid*DEG_TO_RAD, lon_out, lat_out)
                      if ( Interp%wti(1,1,2) < 1.0 ) then
                         Profiles(num_profiles)%i_index =Interp%i_lon(1,1,1) + Interp%wti(1,1,2)
                      else
                         Profiles(num_profiles)%i_index =Interp%i_lon(1,1,2)
                      end if
                      if ( Interp%wtj(1,1,2) < 1.0 ) then
                         Profiles(num_profiles)%j_index =Interp%j_lat(1,1,1) + Interp%wtj(1,1,2)
                      else
                         Profiles(num_profiles)%j_index =Interp%j_lat(1,1,2)
                      end if
                   end if

                   Profiles(num_profiles)%accepted = .true.
                   if ( i0 < 1 .or. j0 < 1 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                   if ( Profiles(num_profiles)%accepted ) then
                      if ( Grd%mask(i0,j0,1) == 0.0 .or.&
                           & Grd%mask(i0+1,j0,1) == 0.0 .or.&
                           & Grd%mask(i0,j0+1,1) == 0.0 .or.&
                           & Grd%mask(i0+1,j0+1,1) == 0.0 ) then
                         Profiles(num_profiles)%accepted = .false.
                      end if
                   end if
                   if ( Profiles(num_profiles)%accepted ) then
                      Profiles(num_profiles)%flag(:) = .true.
                      allocate(Profiles(num_profiles)%k_index(Profiles(num_profiles)%levels))
                      do k=1, Profiles(num_profiles)%levels
                         Profiles(num_profiles)%k_index(k) = frac_index(depth(k), (/0.,Grd%z(:)/)) - 1
                         !::sdu:: Do we need the same out-of-range check here?
                      end do
                   end if
                end if ! exclude SSTs at ieg and jeg
             end if
          end if
       end do
    end do

    call mpp_close(unit)
    deallocate(axes)
    write (UNIT=stdout_unit, FMT='("A grand total of ",I8," sst points within global domain")') no_sst
    write (UNIT=stdout_unit, FMT='("A final total @sst of ",I8," prfs within global domain")') num_profiles
  end subroutine open_profile_dataset_sst

  subroutine open_profile_dataset_woa05t(filename, obs_variable, localize)  
    character(len=*), intent(in) :: filename
    integer, intent(in) :: obs_variable
    logical, intent(in), optional :: localize

    integer, parameter :: MAX_LEVELS = 24

    real :: lon, lat, rms_err
    real :: ri0, rj0
    real, dimension(MAX_LEVELS) :: depth, data

    integer :: unit, ndim, nvar, natt, ntime
    integer :: var_id, inst_type
    integer :: num_levs, k, kk, i, j, i0, j0, k0
    integer :: stdout_unit, istat
    integer :: out_bound_point

    logical :: data_is_local, localize_data
    logical :: prof_in_filt_domain
    logical, dimension(MAX_LEVELS) :: flag

    character(len=32) :: axisname, anal_fldname
    character(len=128) :: emsg_local

    type(axistype), dimension(:), allocatable, target :: axes
    type(axistype), pointer :: lon_axis, lat_axis, z_axis, t_axis

    if ( PRESENT(localize) ) then
       localize_data = localize
    else
       localize_data = .true.
    end if

    stdout_unit = stdout()
    anal_fldname = 'temp'
    var_id = obs_variable

!    call mpp_print_memuse_stats('open_profile_dataset_woa05t Start')

    call mpp_open(unit, trim(filename), MPP_RDONLY, MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE)

    write (UNIT=stdout_unit, FMT='("Opened profile woa05t dataset: ",A)') trim(filename)

    call mpp_get_info(unit, ndim, nvar, natt, ntime)
    allocate(axes(ndim))
    call mpp_get_axes(unit,axes)
    do i=1, ndim
       call mpp_get_atts(axes(i), name=axisname)
       select case (trim(axisname))
       case ('lon')
          lon_axis => axes(i)
       case ('lat')
          lat_axis => axes(i)
       case ('depth')
          z_axis => axes(i)
       end select
    end do

    call mpp_get_atts(lon_axis, len=nlon_woa)
    call mpp_get_atts(lat_axis, len=nlat_woa)
    call mpp_get_atts(z_axis, len=nlev_woa)

    if ( nlon_woa /= 360 .or. nlat_woa /= 180 ) then
       write (UNIT=emsg_local, FMT='("woa05 obs dim is not same as in file. nlon_woa = ",I8,", nlat_woa = ",I8)') nlon_woa, nlat_woa
       call error_mesg('oda_core_mod::open_profile_dataset_woa05t', trim(emsg_local), FATAL)
    end if

    allocate(woa05_lon(nlon_woa), woa05_lat(nlat_woa), woa05_z(nlev_woa))

    call mpp_get_axis_data(lon_axis, woa05_lon)
    call mpp_get_axis_data(lat_axis, woa05_lat)
    call mpp_get_axis_data(z_axis, woa05_z)

    out_bound_point = 0
    ! idealized
    do j=1, nlat_woa
       do i=1, nlon_woa
          lon = woa05_lon(i)
          lat = woa05_lat(j)
          rms_err = 5
          inst_type = 20
          data_is_local = .true.
          prof_in_filt_domain = .false.

          if ( lon .lt. 0.0 ) lon = lon + 360.0
          if ( lon .gt. 360.0 ) lon = lon - 360.0
          if ( lon .lt. 80.0 ) lon = lon + 360.0

          if ( lat < -80.0 .or. lat > 80.0 ) data_is_local = .false.
          if ( abs(lat) < 20.0 .and. (mod(i,2) /= 0 .or. mod(j,2) /= 0) ) data_is_local = .false.
          if ( abs(lat) >= 20.0 .and. (mod(i,4) /= 0 .or. mod(j,4) /= 0) ) data_is_local = .false.
          if ( abs(lat) >= 60.0 .and. (mod(i,6) /= 0 .or. mod(j,6) /= 0) ) data_is_local = .false.

          if (isd_filt < 1 .and. ied_filt > ieg) then
             ! filter domain is a full x band
             if (lon >= x_grid(1,jsd_flt0) .and. lon <= x_grid(ieg-1,jsd_flt0) .and.&
                  lat >= y_grid(1,jsd_flt0) .and. lat <= y_grid(ieg-1,jsd_flt0)) then
                prof_in_filt_domain = .true.
             end if
          else if (isd_filt >= 1 .and. ied_filt <= ieg) then
             ! Interior filter domain
            if (lon >= x_grid(isd_filt,jsd_flt0) .and. lon <= x_grid(ied_filt-1,jsd_flt0) .and.&
               & lat >= y_grid(isd_filt,jsd_flt0) .and. lat <=  y_grid(ied_filt-1,jed_flt0-1)) then
                prof_in_filt_domain = .true.
            end if
          else if (isd_filt < 1 .and. ied_filt <= ieg) then
             ! lhs filter domain
             isd_flt0 = isd_filt + ieg
             if ((lon >= x_grid(1,jsd_flt0) .and. lon <= x_grid(ied_filt-1,jsd_flt0) .and.&
                  & lat >= y_grid(1,jsd_flt0) .and. lat <=  y_grid(ied_filt-1,jed_flt0-1)).or.&
                  & (lon >= x_grid(isd_flt0,jsd_flt0) .and. lon <= x_grid(ieg-1,jsd_flt0) .and.&
                  & lat >= y_grid(isd_flt0,jsd_flt0) .and. lat <=  y_grid(ieg-1,jed_flt0-1))) then
                prof_in_filt_domain = .true.
             end if
          else if (isd_filt >= 1 .and. ied_filt > ieg) then
             ! rhs filter domain
             ied_flt0 = ied_filt - ieg
             if ( lon >= x_grid(isd_filt,jsd_flt0) .and. lon <= x_grid(ieg-1,jsd_flt0) .and.&
                  & lat >= y_grid(isd_filt,jsd_flt0) .and. lat <=  y_grid(ieg-1,jed_flt0-1) ) then
                prof_in_filt_domain = .true.
             end if
             if (ied_flt0-1 > 1) then
                if ( lon >= x_grid(1,jsd_flt0) .and. lon <= x_grid(ied_flt0-1,jsd_flt0) .and.&
                     & lat >= y_grid(1,jsd_flt0) .and. lat <=  y_grid(ied_flt0-1,jed_flt0-1) ) then
                   prof_in_filt_domain = .true.
                end if
             end if
          end if

          if ( data_is_local .and. (.NOT.localize_data) ) then ! global index

            no_woa05 = no_woa05 + 1
            num_profiles = num_profiles + 1
             if ( num_profiles > max_profiles ) then
                call error_mesg('oda_core_mod::open_profile_dataset_woa05t',&
                     & 'Maximum number of profiles exceeded, increase max_profiles in oda_core_nml', FATAL)
             end if

            num_levs = 0
            flag = .false.
            do k=1, nlev
              flag(k) = .true.
              data(k) = 0.0
              depth(k) = woa05_z(k)
              num_levs = num_levs+1
            end do
            if ( num_levs == 0 ) cycle

            if ( prof_in_filt_domain ) then ! localize

             allocate(profiles(num_profiles)%depth(num_levs))
             allocate(profiles(num_profiles)%data(num_levs))
             allocate(profiles(num_profiles)%flag(num_levs))
!             allocate(profiles(num_profiles)%ms(num_levs))
!             allocate(profiles(num_profiles)%ms_inv(num_levs))
             profiles(num_profiles)%variable = var_id
             profiles(num_profiles)%inst_type = inst_type
             profiles(num_profiles)%levels = num_levs
             profiles(num_profiles)%lat = lat
             profiles(num_profiles)%lon = lon
             
             kk = 1
             do k=1, nlev
                if ( flag(k) ) then
                   profiles(num_profiles)%depth(kk) = depth(k)
                   profiles(num_profiles)%data(kk) = data(k)
!                   profiles(num_profiles)%ms(kk) = 1.0
!                   profiles(num_profiles)%ms_inv(kk) = 1.0
                   kk = kk + 1
                end if
             end do

             ! calculate interpolation coefficients (make sure to account for grid offsets here!)
             if ( lat < 65.0 ) then ! regular grids
                ri0 = frac_index(lon, x_grid(:,1))
                rj0 = frac_index(lat, y_grid(90,:))
                i0 = floor(ri0)
                j0 = floor(rj0)
                if ( i0 > ieg .or. j0 > jeg ) then
                   write (UNIT=emsg_local, FMT='("i0 = ",I8,", j0 = ",I8)') i0, j0
                   call error_mesg('oda_core_mod::open_profile_dataset_woa05t',&
                        & 'For regular grids, either i0 > ieg or j0 > jeg.  '//trim(emsg_local), FATAL)
                end if
                if ( isd_filt >= 1 .and. ied_filt <= ieg ) then
                  if ( i0 < isd_filt .or. i0 > ied_filt .or. j0 < jsd_filt .or. j0 > jed_filt ) then
                     write (UNIT=emsg_local, FMT='("pe,i0,j0= ",3I8,"isd_filt,ied_filt,jsd_filt,jed_filt= ",4I8)')&
                          & mpp_pe(), i0, j0, isd_filt,ied_filt,jsd_filt,jed_filt
                     call error_mesg('oda_core_mod::open_profile_dataset',&
                          & 'i0,j0 out of bounds in woat01. '//trim(emsg_local), FATAL)
                  end if
                end if
                if ( isd_filt < 1 .and. i0 > ied_filt-1 .and. i0 < isd_filt + ieg ) then
                   write (UNIT=emsg_local, FMT='("pe,i0,j0= ",3I8,"isd_filt,ied_filt,jsd_filt,jed_filt= ",4I8)')&
                        & mpp_pe(), i0, j0, isd_filt,ied_filt,jsd_filt,jed_filt
                   call error_mesg('oda_core_mod::open_profile_dataset',&
                        & 'i0,j0 out of bounds in woat02. '//trim(emsg_local), FATAL)
                end if
                if ( ied_filt > ieg .and. i0 > ied_filt-ieg-1 .and. ied_filt < isd_filt ) then
                   write (UNIT=emsg_local, FMT='("pe,i0,j0= ",3I8,"isd_filt,ied_filt,jsd_filt,jed_filt= ",4I8)')&
                        & mpp_pe(), i0, j0, isd_filt,ied_filt,jsd_filt,jed_filt
                   call error_mesg('oda_core_mod::open_profile_dataset',&
                        & 'i0,j0 out of bounds in woat03. '//trim(emsg_local), FATAL)
                end if
                Profiles(num_profiles)%i_index = ri0
                Profiles(num_profiles)%j_index = rj0 
             else ! tripolar grids
                lon_out(1,1) = lon*DEG_TO_RAD
                lat_out(1,1) = lat*DEG_TO_RAD
                call horiz_interp_bilinear_new (Interp, x_grid*DEG_TO_RAD, y_grid*DEG_TO_RAD, lon_out, lat_out)
                if ( Interp%wti(1,1,2) < 1.0 ) then
                   i0 = Interp%i_lon(1,1,1)
                else
                   i0 = Interp%i_lon(1,1,2)
                end if
                if ( Interp%wtj(1,1,2) < 1.0 ) then
                   j0 = Interp%j_lat(1,1,1)
                else
                   j0 = Interp%j_lat(1,1,2)
                end if
                if ( i0 > ieg .or. j0 > jeg ) then
                   write (UNIT=emsg_local, FMT='("i0 = ",I8,", j0 = ",I8)') i0, j0
                   call error_mesg('oda_core_mod::open_profile_dataset_woa05t',&
                        & 'For tripolar grids, either i0 > ieg or j0 > jeg.  '//trim(emsg_local), FATAL)
                end if
                if ( i0 < isd_filt .or. i0 > ied_filt .or. j0 < jsd_filt .or. j0 > jed_filt ) then
                   write (UNIT=stdout_unit, FMT='("woat.pe,i0,j0= ",3I8,"isd_filt,ied_filt,jsd_filt,jed_filt= ",4I8)')&
                        & mpp_pe(),i0, j0,isd_filt,ied_filt,jsd_filt,jed_filt
                   out_bound_point = out_bound_point + 1
                end if
                if ( Interp%wti(1,1,2) < 1.0 ) then
                   Profiles(num_profiles)%i_index =Interp%i_lon(1,1,1) + Interp%wti(1,1,2)
                else
                   Profiles(num_profiles)%i_index =Interp%i_lon(1,1,2)
                end if
                if ( Interp%wtj(1,1,2) < 1.0 ) then
                   Profiles(num_profiles)%j_index =Interp%j_lat(1,1,1) + Interp%wtj(1,1,2)
                else
                   Profiles(num_profiles)%j_index =Interp%j_lat(1,1,2)
                end if
             end if ! grids
           
             Profiles(num_profiles)%accepted = .true.
             if ( i0 < 1 .or. j0 < 1 ) then
                Profiles(num_profiles)%accepted = .false.
             end if
             if ( i0 < isd_filt .or. i0 >= ied_filt .or. j0 < jsd_filt .or. j0 >= jed_filt ) then
                Profiles(num_profiles)%accepted = .false.
             end if

             if ( Profiles(num_profiles)%accepted ) then ! here
                if ( i0 /= ieg .and. j0 /= jeg ) then
                   if ( Grd%mask(i0,j0,1) == 0.0 .or.&
                        & Grd%mask(i0+1,j0,1) == 0.0 .or.&
                        & Grd%mask(i0,j0+1,1) == 0.0 .or.&
                        & Grd%mask(i0+1,j0+1,1) == 0.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                else if ( i0 == ieg .and. j0 /= jeg ) then
                   if ( Grd%mask(i0,j0,1) == 0.0 .or.&
                        & Grd%mask(1,j0,1) == 0.0 .or.&
                        & Grd%mask(i0,j0+1,1) == 0.0 .or.&
                        & Grd%mask(1,j0+1,1) == 0.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                else if ( i0 /= ieg .and. j0 == jeg ) then
                   if ( Grd%mask(i0,j0,1) == 0.0 .or.&
                        & Grd%mask(i0+1,j0,1) == 0.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                else
                   if ( Grd%mask(i0,j0,1) == 0.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                end if
             end if ! here
             
             if ( Profiles(num_profiles)%accepted ) then ! accepted
                Profiles(num_profiles)%flag(:) = .true.
                allocate(Profiles(num_profiles)%k_index(Profiles(num_profiles)%levels))
                do k=1, Profiles(num_profiles)%levels
                   if (depth(k) < Grd%z(1)) then
                     Profiles(num_profiles)%k_index(k) = 0.0
                   else
                     Profiles(num_profiles)%k_index(k) = frac_index(depth(k), (/0.,Grd%z(:)/)) - 1.0 ! snz modify to v3.2 JAN3012
                   end if
                   if ( Profiles(num_profiles)%k_index(k) > nk ) then
                      call error_mesg('oda_core_mod::open_profile_dataset_woa05t',&
                           & 'Profile k_index is greater than nk', FATAL)
                   end if
                   k0 = floor(Profiles(num_profiles)%k_index(k))
                   
                   if ( k0 >= 1 ) then ! snz add
                      if ( Profiles(num_profiles)%flag(k) ) then ! flag
                         if ( i0 /= ieg .and. j0 /= jeg ) then
                            if ( Grd%mask(i0,j0,k0) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0,k0) == 0.0 .or.&
                                 & Grd%mask(i0,j0+1,k0) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0+1,k0) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else if ( i0 == ieg .and. j0 /= jeg ) then
                            if ( Grd%mask(i0,j0,k0) == 0.0 .or.&
                                 & Grd%mask(1,j0,k0) == 0.0 .or.&
                                 & Grd%mask(i0,j0+1,k0) == 0.0 .or.&
                                 & Grd%mask(1,j0+1,k0) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else if ( i0 /= ieg .and. j0 == jeg ) then
                            if ( Grd%mask(i0,j0,k0) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0,k0) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else
                            if ( Grd%mask(i0,j0,k0) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         end if
                         
                         if ( i0 /= ieg .and. j0 /= jeg ) then
                            if ( Grd%mask(i0,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0,j0+1,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0+1,k0+1) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else if ( i0 == ieg .and. j0 /= jeg ) then
                            if ( Grd%mask(i0,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(1,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0,j0+1,k0+1) == 0.0 .or.&
                                 & Grd%mask(1,j0+1,k0+1) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else if ( i0 /= ieg .and. j0 == jeg ) then
                            if ( Grd%mask(i0,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0,k0+1) == 0.0) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else
                            if ( Grd%mask(i0,j0,k0+1) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         end if
                         
                         if ( abs(Profiles(num_profiles)%data(k)) > 1.e4 &
                              & .or. abs(Profiles(num_profiles)%depth(k)) > 1.e4 ) then
                            Profiles(num_profiles)%flag(k) = .false.
                         end if
                      end if ! flag
                   end if ! snz add
                end do
             end if ! accepted
           end if ! localize
         end if ! global index
       end do
    end do

    call mpp_close(unit)
    deallocate(axes)
    write (UNIT=stdout_unit, FMT='("A grand total of ",I8," woa05t points within global domain")') no_woa05
    write (UNIT=stdout_unit, FMT='("A final total @woa05t of ",I8," prfs within global domain")') num_profiles

!    call mpp_print_memuse_stats('open_profile_dataset_woa05t End')

  end subroutine open_profile_dataset_woa05t

  subroutine open_profile_dataset_woa05s(filename, obs_variable, localize)  
    character(len=*), intent(in) :: filename
    integer, intent(in) :: obs_variable
    logical, intent(in), optional :: localize

    integer, parameter :: MAX_LEVELS = 24

    real :: lon, lat, rms_err
    real :: ri0, rj0
    real, dimension(MAX_LEVELS) :: depth, data

    integer :: unit, ndim, nvar, natt, ntime
    integer :: var_id, inst_type
    integer :: num_levs, k, kk, i, j, i0, j0, k0
    integer :: stdout_unit
    integer :: out_bound_point

    logical :: data_is_local, localize_data
    logical :: prof_in_filt_domain
    logical, dimension(MAX_LEVELS) :: flag

    character(len=32) :: axisname, anal_fldname
    character(len=128) :: emsg_local

    type(axistype), dimension(:), allocatable, target :: axes
    type(axistype), pointer :: lon_axis, lat_axis, z_axis

    if ( present(localize) ) then
       localize_data = localize
    else
       localize_data = .true.
    end if

    stdout_unit = stdout()

    anal_fldname = 'salt'
    var_id = obs_variable

!    call mpp_print_memuse_stats('open_profile_dataset_woa05s Start')

    call mpp_open(unit, trim(filename), MPP_RDONLY, MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE)

    write (UNIT=stdout_unit, FMT='("Opened profile woa05s dataset: ",A)') trim(filename)

    call mpp_get_info(unit, ndim, nvar, natt, ntime)
    allocate(axes(ndim))
    call mpp_get_axes(unit, axes)
    do i=1, ndim
       call mpp_get_atts(axes(i), name=axisname)
       select case ( trim(axisname) )
       case ('lon')
          lon_axis => axes(i)
       case ('lat')
          lat_axis => axes(i)
       case ('depth')
          z_axis => axes(i)
       end select
    end do
    call mpp_get_atts(lon_axis, len=nlon_woa)
    call mpp_get_atts(lat_axis, len=nlat_woa)
    call mpp_get_atts(z_axis, len=nlev_woa)
    if ( nlon_woa /= 360 .or. nlat_woa /= 180 ) then
       write (UNIT=emsg_local, FMT='("woa05 obs dim is not same as in file nlon_woa = ",I8,", nlat_woa = ",I8)') nlon_woa, nlat_woa
       call error_mesg('oda_core_mod::open_profile_dataset_woa05s', trim(emsg_local), FATAL)
    end if

    out_bound_point = 0
    ! idealized
    do j=1, nlat_woa
       do i=1, nlon_woa
          lon = woa05_lon(i)
          lat = woa05_lat(j)
          rms_err = 5
          inst_type = 20
          data_is_local = .true.
          prof_in_filt_domain = .false.

          if ( lon .lt. 0.0 ) lon = lon + 360.0
          if ( lon .gt. 360.0 ) lon = lon - 360.0
          if ( lon .lt. 80.0 ) lon = lon + 360.0

          if ( lat < -80.0 .or. lat > 80.0 ) data_is_local = .false.
          if ( abs(lat) < 20.0 .and. (mod(i,2) /= 0 .or. mod(j,2) /= 0) ) data_is_local = .false.
          if ( abs(lat) >= 20.0 .and. (mod(i,4) /= 0 .or. mod(j,4) /= 0) ) data_is_local = .false.
          if ( abs(lat) >= 60.0 .and. (mod(i,6) /= 0 .or. mod(j,6) /= 0) ) data_is_local = .false.

          if (isd_filt < 1 .and. ied_filt > ieg) then
             ! filter domain is a full x band
             if (lon >= x_grid(1,jsd_flt0) .and. lon <= x_grid(ieg-1,jsd_flt0) .and.&
                  lat >= y_grid(1,jsd_flt0) .and. lat <= y_grid(ieg-1,jsd_flt0)) then
                prof_in_filt_domain = .true.
             end if
          else if (isd_filt >= 1 .and. ied_filt <= ieg) then
             ! Interior filter domain
            if (lon >= x_grid(isd_filt,jsd_flt0) .and. lon <= x_grid(ied_filt-1,jsd_flt0) .and.&
               & lat >= y_grid(isd_filt,jsd_flt0) .and. lat <=  y_grid(ied_filt-1,jed_flt0-1)) then
                prof_in_filt_domain = .true.
            end if
          else if (isd_filt < 1 .and. ied_filt <= ieg) then
             ! lhs filter domain
             isd_flt0 = isd_filt + ieg
             if ((lon >= x_grid(1,jsd_flt0) .and. lon <= x_grid(ied_filt-1,jsd_flt0) .and.&
                  & lat >= y_grid(1,jsd_flt0) .and. lat <=  y_grid(ied_filt-1,jed_flt0-1)).or.&
                  & (lon >= x_grid(isd_flt0,jsd_flt0) .and. lon <= x_grid(ieg-1,jsd_flt0) .and.&
                  & lat >= y_grid(isd_flt0,jsd_flt0) .and. lat <=  y_grid(ieg-1,jed_flt0-1))) then
                prof_in_filt_domain = .true.
             end if
          else if (isd_filt >= 1 .and. ied_filt > ieg) then
             ! rhs filter domain
             ied_flt0 = ied_filt - ieg
             if ( lon >= x_grid(isd_filt,jsd_flt0) .and. lon <= x_grid(ieg-1,jsd_flt0) .and.&
                  & lat >= y_grid(isd_filt,jsd_flt0) .and. lat <=  y_grid(ieg-1,jed_flt0-1) ) then
                prof_in_filt_domain = .true.
             end if
             if (ied_flt0-1 > 1) then
                if ( lon >= x_grid(1,jsd_flt0) .and. lon <= x_grid(ied_flt0-1,jsd_flt0) .and.&
                     & lat >= y_grid(1,jsd_flt0) .and. lat <=  y_grid(ied_flt0-1,jed_flt0-1) ) then
                   prof_in_filt_domain = .true.
                end if
             end if
          end if

          if ( data_is_local .and. (.NOT.localize_data) ) then ! global index

            no_woa05 = no_woa05 + 1
            num_profiles=num_profiles + 1
             if ( num_profiles > max_profiles ) then
                call error_mesg('oda_core_mod::open_profile_dataset_woa05s',&
                     & 'Maximum number of profiles exceeded, increase max_profiles in oda_core_nml.', FATAL)
             end if

            num_levs = 0
            flag = .false.
            do k=1, nlev_woa
              flag(k) = .true.
              data(k) = 0.0
              depth(k) = woa05_z(k)
              num_levs = num_levs + 1
            end do
            if ( num_levs == 0 ) cycle

           if ( prof_in_filt_domain ) then ! localize

             allocate(profiles(num_profiles)%depth(num_levs))
             allocate(profiles(num_profiles)%data(num_levs))
             allocate(profiles(num_profiles)%flag(num_levs))
!             allocate(profiles(num_profiles)%ms(num_levs))
!             allocate(profiles(num_profiles)%ms_inv(num_levs))
             profiles(num_profiles)%variable = var_id
             profiles(num_profiles)%inst_type = inst_type
             profiles(num_profiles)%levels = num_levs
             profiles(num_profiles)%lat = lat
             profiles(num_profiles)%lon = lon

             kk = 1
             do k=1, nlev_woa
                if ( flag(k) ) then
                   profiles(num_profiles)%depth(kk) = depth(k)
                   profiles(num_profiles)%data(kk) = data(k)
!                   profiles(num_profiles)%ms(kk) = 1.0
!                   profiles(num_profiles)%ms_inv(kk) = 1.0
                   kk = kk + 1
                end if
             end do

             ! calculate interpolation coefficients (make sure to account for grid offsets here!)
             if ( lat < 65.0 ) then ! regular grids
                ri0 = frac_index(lon, x_grid(:,1))
                rj0 = frac_index(lat, y_grid(90,:))
                i0 = floor(ri0)
                j0 = floor(rj0)
                if ( i0 > ieg .or. j0 > jeg ) then
                   write (UNIT=emsg_local, FMT='("i0 = ",I8,", j0 = ",I8)') i0, j0
                   call error_mesg('oda_core_mod::open_profile_dataset_woa05s',&
                        & 'For regular grids, either i0 > ieg or j0 > jeg.  '//trim(emsg_local), FATAL)
                end if
                if ( isd_filt >= 1 .and. ied_filt <= ieg ) then
                  if ( i0 < isd_filt .or. i0 > ied_filt .or. j0 < jsd_filt .or. j0 > jed_filt ) then
                     write (UNIT=emsg_local, FMT='("pe,i0,j0= ",3I8,"isd_filt,ied_filt,jsd_filt,jed_filt= ",4I8)')&
                          & mpp_pe(), i0, j0, isd_filt,ied_filt,jsd_filt,jed_filt
                     call error_mesg('oda_core_mod::open_profile_dataset',&
                          & 'i0,j0 out of bounds in woas01. '//trim(emsg_local), FATAL)
                  end if
                end if
                if ( isd_filt < 1 .and. i0 > ied_filt-1 .and. i0 < isd_filt + ieg ) then
                   write (UNIT=emsg_local, FMT='("pe,i0,j0= ",3I8,"isd_filt,ied_filt,jsd_filt,jed_filt= ",4I8)')&
                        & mpp_pe(), i0, j0, isd_filt,ied_filt,jsd_filt,jed_filt
                   call error_mesg('oda_core_mod::open_profile_dataset',&
                        & 'i0,j0 out of bounds in woas02. '//trim(emsg_local), FATAL)
                end if
                if ( ied_filt > ieg .and. i0 > ied_filt-ieg-1 .and. ied_filt < isd_filt ) then
                   write (UNIT=emsg_local, FMT='("pe,i0,j0= ",3I8,"isd_filt,ied_filt,jsd_filt,jed_filt= ",4I8)')&
                        & mpp_pe(), i0, j0, isd_filt,ied_filt,jsd_filt,jed_filt
                   call error_mesg('oda_core_mod::open_profile_dataset',&
                        & 'i0,j0 out of bounds in woas03. '//trim(emsg_local), FATAL)
                end if
                Profiles(num_profiles)%i_index = ri0
                Profiles(num_profiles)%j_index = rj0 
             else ! tripolar grids
                lon_out(1,1) = lon*DEG_TO_RAD
                lat_out(1,1) = lat*DEG_TO_RAD
                call horiz_interp_bilinear_new (Interp, x_grid*DEG_TO_RAD, y_grid*DEG_TO_RAD, lon_out, lat_out)
                if ( Interp%wti(1,1,2) < 1.0 ) then
                   i0 = Interp%i_lon(1,1,1)
                else
                   i0 = Interp%i_lon(1,1,2)
                end if
                if ( Interp%wtj(1,1,2) < 1.0 ) then
                   j0 = Interp%j_lat(1,1,1)
                else
                   j0 = Interp%j_lat(1,1,2)
                end if
                if ( i0 > ieg .or. j0 > jeg ) then
                   write (UNIT=emsg_local, FMT='("i0 = ",I8,", j0 = ",I8)') i0, j0
                   call error_mesg('oda_core_mod::open_profile_dataset_woa05s',&
                        & 'For tripolar grids, either i0 > ieg or j0 > jeg.  '//trim(emsg_local), FATAL)
                end if
                if ( i0 < isd_filt .or. i0 > ied_filt .or. j0 < jsd_filt .or. j0 > jed_filt ) then
                   write (UNIT=stdout_unit, FMT='("woas.pe,i0,j0= ",3I8,"isd_filt,ied_filt,jsd_filt,jed_filt= ",4I8)')&
                        & mpp_pe(),i0, j0,isd_filt,ied_filt,jsd_filt,jed_filt
                   out_bound_point = out_bound_point + 1
                end if
                if ( Interp%wti(1,1,2) < 1.0 ) then
                   Profiles(num_profiles)%i_index =Interp%i_lon(1,1,1) + Interp%wti(1,1,2)
                else
                   Profiles(num_profiles)%i_index =Interp%i_lon(1,1,2)
                end if
                if ( Interp%wtj(1,1,2) < 1.0 ) then
                   Profiles(num_profiles)%j_index =Interp%j_lat(1,1,1) + Interp%wtj(1,1,2)
                else
                   Profiles(num_profiles)%j_index =Interp%j_lat(1,1,2)
                end if
             end if ! grids
           
             Profiles(num_profiles)%accepted = .true.
             if ( i0 < 1 .or. j0 < 1 ) then
                Profiles(num_profiles)%accepted = .false.
             end if
             if ( i0 < isd_filt .or. i0 >= ied_filt .or. j0 < jsd_filt .or. j0 >= jed_filt ) then
                Profiles(num_profiles)%accepted = .false.
             end if

             if ( Profiles(num_profiles)%accepted ) then ! here
                if ( i0 /= ieg .and. j0 /= jeg ) then
                   if ( Grd%mask(i0,j0,1) == 0.0 .or.&
                        & Grd%mask(i0+1,j0,1) == 0.0 .or.&
                        & Grd%mask(i0,j0+1,1) == 0.0 .or.&
                        & Grd%mask(i0+1,j0+1,1) == 0.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                else if ( i0 == ieg .and. j0 /= jeg ) then
                   if ( Grd%mask(i0,j0,1) == 0.0 .or.&
                        & Grd%mask(1,j0,1) == 0.0 .or.&
                        & Grd%mask(i0,j0+1,1) == 0.0 .or.&
                        & Grd%mask(1,j0+1,1) == 0.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                else if ( i0 /= ieg .and. j0 == jeg ) then
                   if ( Grd%mask(i0,j0,1) == 0.0 .or.&
                        & Grd%mask(i0+1,j0,1) == 0.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                else
                   if ( Grd%mask(i0,j0,1) == 0.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                end if
             end if ! here

             if ( Profiles(num_profiles)%accepted ) then ! accepted
                Profiles(num_profiles)%flag(:) = .true.
                allocate(Profiles(num_profiles)%k_index(Profiles(num_profiles)%levels))
                do k=1, Profiles(num_profiles)%levels
                   if (depth(k) < Grd%z(1)) then
                     Profiles(num_profiles)%k_index(k) = 0.0
                   else
                     Profiles(num_profiles)%k_index(k) = frac_index(depth(k), (/0.,Grd%z(:)/)) - 1.0 ! snz modify to v3.2 JAN3012
                   end if
                   if ( Profiles(num_profiles)%k_index(k) > nk ) then
                      call error_mesg('oda_core_mod::open_profile_dataset_woa05s',&
                           & 'Profile k_index is greater than nk', FATAL)
                   end if
                   k0 = floor(Profiles(num_profiles)%k_index(k))

                   if ( k0 >= 1 ) then ! snz add
                      if ( Profiles(num_profiles)%flag(k) ) then ! flag
                         if ( i0 /= ieg .and. j0 /= jeg ) then
                            if ( Grd%mask(i0,j0,k0) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0,k0) == 0.0 .or.&
                                 & Grd%mask(i0,j0+1,k0) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0+1,k0) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else if ( i0 == ieg .and. j0 /= jeg ) then
                            if ( Grd%mask(i0,j0,k0) == 0.0 .or.&
                                 & Grd%mask(1,j0,k0) == 0.0 .or.&
                                 & Grd%mask(i0,j0+1,k0) == 0.0 .or.&
                                 & Grd%mask(1,j0+1,k0) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else if ( i0 /= ieg .and. j0 == jeg ) then
                            if ( Grd%mask(i0,j0,k0) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0,k0) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else
                            if ( Grd%mask(i0,j0,k0) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         end if

                         if ( i0 /= ieg .and. j0 /= jeg ) then
                            if ( Grd%mask(i0,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0,j0+1,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0+1,k0+1) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         elseif ( i0 == ieg .and. j0 /= jeg ) then
                            if ( Grd%mask(i0,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(1,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0,j0+1,k0+1) == 0.0 .or.&
                                 & Grd%mask(1,j0+1,k0+1) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else if ( i0 /= ieg .and. j0 == jeg ) then
                            if ( Grd%mask(i0,j0,k0+1) == 0.0 .or.&
                                 & Grd%mask(i0+1,j0,k0+1) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         else
                            if ( Grd%mask(i0,j0,k0+1) == 0.0 ) then
                               Profiles(num_profiles)%flag(k) = .false.
                            end if
                         end if

                         if ( abs(Profiles(num_profiles)%data(k)) > 1.e4 &
                              & .or. abs(Profiles(num_profiles)%depth(k)) > 1.e4 ) then
                            Profiles(num_profiles)%flag(k) = .false.
                         end if
                      end if ! flag
                   end if ! snz add
                end do
             end if ! accepted
           end if ! localize
         end if ! global index
       end do
    end do

    call mpp_close(unit)
    deallocate(axes)
    write (UNIT=stdout_unit, FMT='("A grand total of ",I8," woa05s points within global domain")') no_woa05
    write (UNIT=stdout_unit, FMT='("A final total @woa05s of ",I8," prfs within global domain")') num_profiles

!    call mpp_print_memuse_stats('open_profile_dataset_woa05s Ens')

  end subroutine open_profile_dataset_woa05s

  subroutine get_obs_sst(model_time, Prof, nprof, no_prf0, sst_climo, Filter_domain)
    type(time_type), intent(in) :: model_time
    type(ocean_profile_type), dimension(:), intent(inout) :: Prof
    integer, intent(inout) :: nprof
    integer, intent(in) :: no_prf0
    type(obs_clim_type), intent(inout) :: sst_climo
    type(domain2d), intent(in) :: Filter_domain

    integer :: i0, j0, i, days, seconds, days1, seconds1
    integer :: unit, ndim, nvar, natt, ntime, time_idx
    integer :: iy0, in0, id0, ih0, im0, is0, i_m
    integer :: stdout_unit, istat
    integer, dimension(12) :: n_days
    integer, save :: year_on_first_read = 0 !< Year on first read of file during
                                            !! module run
    character(len=128) :: sst_filename, emsg_local

    type(fieldtype), dimension(:), allocatable :: fields
    type(time_type) :: tdiff, sst_time0, time1

    n_days  = (/31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/)

    nprof = 0

    stdout_unit = stdout()

    call get_time(model_time, seconds, days)
    call get_date(model_time, iy0, in0, id0, ih0, im0, is0)
    if ( year_on_first_read == 0 ) then
       year_on_first_read = iy0
    end if
    time1=set_date(year_on_first_read, 1, 1, 0, 0, 0)
    call get_time(time1, seconds1, days1)
    time_idx = days-days1+1

    ! daily data 

    if ( mpp_pe() == mpp_root_pe() ) then
       write (UNIT=stdout_unit, FMT='("time_idx = ",I8)') time_idx
    end if

    sst_filename = "INPUT/sst_daily.nc"

    call mpp_open(unit, trim(sst_filename), MPP_RDONLY, MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE)
    call mpp_get_info(unit, ndim, nvar, natt, ntime)

    allocate(fields(nvar), STAT=istat)
    if ( istat .ne. 0 ) then 
       call error_mesg('oda_core_mod::get_obs_sst', 'Unable to allocate fields', FATAL)
    end if

    call mpp_get_fields(unit, fields)
    do i=1, nvar
       select case ( mpp_get_field_name(fields(i)) )
       case ('SST1') ! for AVHRR daily SST
          call mpp_read(unit, fields(i), Filter_domain, sst_climo%sst_obs, tindex=time_idx)
       end select
    end do

    ! get profiles and sst
    ! obs relevant to current analysis interval
    sst_time0 = set_date(iy0, in0, id0, ih0, im0, is0)

    if ( no_sst > 1 ) then

    do i=no_prf+no_woa05+1, no_prf+no_woa05+no_sst
       Profiles(i)%time = sst_time0

       tdiff = model_time - Profiles(i)%time

       i0 = floor(Profiles(i)%i_index)
       if ( i0 < 1 .or. i0 > 1440 ) then
          write (UNIT=emsg_local, FMT='("Profiles(",I8,")%lon = ",I4,", i0 = ",I8)') i, Profiles(i)%lon, i0
          call error_mesg('oda_core_mod::get_obs_sst',&
               & 'Profile longitude index outside range [1,1440].  '//trim(emsg_local), FATAL)
       end if

       j0 = floor(Profiles(i)%j_index)
       if ( j0 < 1 .or. j0 > 1070 ) then
          write (UNIT=emsg_local, FMT='("Profiles(",I8,")%lat = ",I4,", j0 = ",I8)') i, Profiles(i)%lon, j0
          call error_mesg('oda_core_mod::get_obs_sst',&
               & 'Profile latitude index outside range [1,1070].  '//trim(emsg_local), FATAL)
       end if

       if ( Profiles(i)%accepted ) then
          nprof = nprof + 1
          if ( nprof > size(Prof,1) ) then 
             call error_mesg('oda_core_mod::get_obs_sst',&
                  & 'Passed in array "Prof" is smaller than number of profiles, increase size of Prof before call.',&
                  & FATAL)
          end if

          call copy_obs(Profiles(i:i), Prof(no_prf0+nprof:no_prf0+nprof))

          Prof(nprof+no_prf0)%tdiff = tdiff
       end if
    end do

    end if ! for no_sst > 1

    if ( mpp_pe() == mpp_root_pe() ) then
       write (UNIT=stdout_unit, FMT='("no of sst records: ",I8)') nprof
    end if

    deallocate(fields)
    call mpp_close(unit)
  end subroutine get_obs_sst

  subroutine get_obs_woa05t(model_time, Prof, nprof, no_prf0)
    type(time_type), intent(in) :: model_time
    type(ocean_profile_type), dimension(:), intent(inout) :: Prof
    integer, intent(inout) :: nprof
    integer, intent(in) :: no_prf0

    real :: ri0, rj0, lon_woa05

    integer :: i0, j0
    integer :: i, k, unit, time_idx
    integer :: iy0, in0, id0, ih0, im0, is0
    integer :: ndim, nvar, natt, ntime
    integer :: stdout_unit, istat

    character(len=32) :: axisname
    character(len=128) :: woa05t_filename

    type(fieldtype), dimension(:), allocatable :: fields
    type(time_type) :: tdiff, woa05_time0

    nprof = 0
    stdout_unit = stdout()

    call get_date(model_time, iy0, in0, id0, ih0, im0, is0)

    time_idx = in0

    ! daily data 
    woa05t_filename = "INPUT/woa05_temp.nc"
    
    call mpp_open(unit, trim(woa05t_filename), MPP_RDONLY, MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE)
    call mpp_get_info(unit, ndim, nvar, natt, ntime)

    allocate(fields(nvar), STAT=istat)
    if ( istat .ne. 0 ) then 
       call error_mesg('oda_core_mod::get_obs_woa05t', 'Unable to allocate fields', FATAL)
    end if

    call mpp_get_fields(unit, fields)

    allocate(obs_woa05t(nlon_woa,nlat_woa,nlev_woa))

    do i=1, nvar
       select case ( mpp_get_field_name(fields(i)) )
       case ('t0112an1')
          call mpp_read(unit, fields(i), obs_woa05t, tindex=time_idx)
       end select
    end do

    woa05_time0 = set_date(iy0, in0, id0, ih0, im0, is0)

    do i=no_prf+1, no_prf+no_woa05/2
       Profiles(i)%time = woa05_time0

       tdiff = model_time - Profiles(i)%time

       lon_woa05 = Profiles(i)%lon
       if ( lon_woa05 < 0.0 ) lon_woa05 = lon_woa05 + 360.0
       if ( lon_woa05 > 360.0 ) lon_woa05 = lon_woa05 - 360.0
       ri0 = frac_index(lon_woa05, woa05_lon)
       i0 = floor(ri0)
       if ( i0 < 1 ) i0 = 1
       if ( i0 > nlon_woa ) i0 = nlon_woa

       rj0 = frac_index(Profiles(i)%lat, woa05_lat)
       j0 = floor(rj0)
       if(j0 < 1 ) j0 = 1
       if(j0 > nlat_woa) j0 = nlat_woa

       if ( Profiles(i)%accepted ) then
          nprof = nprof + 1
          if ( nprof > size(Prof,1) ) then
             call error_mesg('oda_core_mod::get_obs_woa05t',&
                  & 'Passed in array "Prof" is smaller than number of profiles, increase size of Prof before call.',&
                  & FATAL)
          end if
          Profiles(i)%data(1:nlev_woa) = obs_woa05t(i0,j0,1:nlev_woa)
          do k=1, nlev_woa
             if ( abs(Profiles(i)%data(k)) > 1.e3 .or.&
                  & abs(Profiles(i)%depth(k)) > 1.e5 ) then
                Profiles(i)%flag(k) = .false.
             end if
          end do
          call copy_obs(Profiles(i:i), Prof(no_prf0+nprof:no_prf0+nprof))
          Prof(no_prf0+nprof)%tdiff = tdiff
       end if
    end do

    if ( mpp_pe() == mpp_root_pe() ) then
       write (UNIT=stdout_unit, FMT='("no of woa05t records: ",I8)') nprof
    end if

    deallocate(fields, obs_woa05t)
    call mpp_close(unit)
  end subroutine get_obs_woa05t

  subroutine get_obs_woa05s(model_time, Prof, nprof, no_prf0)
    type(time_type), intent(in) :: model_time
    type(ocean_profile_type), dimension(:), intent(inout) :: Prof
    integer, intent(inout) :: nprof
    integer, intent(in) :: no_prf0

    real :: ri0, rj0, lon_woa05

    integer :: i0, j0
    integer :: i, k, unit, time_idx
    integer :: iy0, in0, id0, ih0, im0, is0
    integer :: ndim, nvar, natt, ntime
    integer :: stdout_unit, istat

    character(len=128) :: woa05s_filename

    type(fieldtype), dimension(:), allocatable :: fields
    type(time_type) :: tdiff, woa05_time0

    nprof = 0
    stdout_unit = stdout()

    call get_date(model_time, iy0,in0,id0,ih0,im0,is0)

    time_idx = in0

    ! climatological data 
    woa05s_filename = "INPUT/woa05_salt.nc"

    call mpp_open(unit, trim(woa05s_filename), MPP_RDONLY, MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE)
    call mpp_get_info(unit, ndim, nvar, natt, ntime)

    allocate(fields(nvar), STAT=istat)
    if ( istat .ne. 0 ) then 
       call error_mesg('oda_core_mod::get_obs_woa05s', 'Unable to allocate fields', FATAL)
    end if

    call mpp_get_fields(unit, fields)

    allocate(obs_woa05s(nlon_woa,nlat_woa,nlev_woa))

    do i=1, nvar
       select case ( mpp_get_field_name(fields(i)) )
       case ('s0112an1')
          call mpp_read(unit, fields(i), obs_woa05s, tindex=time_idx)
       end select
    end do

    woa05_time0 = set_date(iy0, in0, id0, ih0, im0, is0)

    do i=no_prf+no_woa05/2+1, no_prf+no_woa05
       Profiles(i)%time = woa05_time0

       tdiff = model_time - Profiles(i)%time

       lon_woa05 = Profiles(i)%lon
       if ( lon_woa05 < 0.0 ) lon_woa05 = lon_woa05 + 360.0
       if ( lon_woa05 > 360.0 ) lon_woa05 = lon_woa05 - 360.0
       ri0 = frac_index(lon_woa05, woa05_lon)
       i0 = floor(ri0)
       if ( i0 < 1 ) i0 = 1
       if ( i0 > nlon_woa ) i0 = nlon_woa

       rj0 = frac_index(Profiles(i)%lat, woa05_lat)
       j0 = floor(rj0)
       if ( j0 < 1 ) j0 = 1
       if ( j0 > nlat_woa ) j0 = nlat_woa

       if ( Profiles(i)%accepted ) then
          nprof = nprof + 1
          if ( nprof > size(Prof,1) ) then
             call error_mesg('oda_core_mod::get_obs_woa05s',&
                  & 'Passed in array "Prof" is smaller than number of profiles, increase size of Prof before call',&
                  & FATAL)
          end if
          Profiles(i)%data(1:nlev_woa) = obs_woa05s(i0,j0,1:nlev_woa)
          do k=1, nlev_woa
             if ( abs(Profiles(i)%data(k)) > 1.e3 .or.&
                  & abs(Profiles(i)%depth(k)) > 1.e5 ) then
                Profiles(i)%flag(k) = .false.
             end if
          end do
          call copy_obs(Profiles(i:i),Prof(no_prf0+nprof:no_prf0+nprof))
          Prof(no_prf0+nprof)%tdiff = tdiff
       end if
    end do

    if ( mpp_pe() == mpp_root_pe() ) then
       write (UNIT=stdout_unit, FMT='("no of woa05t records: ",I8)') nprof
    end if

    deallocate(fields, obs_woa05s)
    call mpp_close(unit)
  end subroutine get_obs_woa05s

  subroutine open_profile_dataset_eta(filename, obs_variable, localize)  
    character(len=*), intent(in) :: filename
    integer, intent(in) :: obs_variable
    logical, intent(in), optional :: localize

    integer, parameter :: MAX_LEVELS = 1000

    real :: lon, lat, rms_err
    real :: ri0, rj0
    real, dimension(MAX_LEVELS) :: depth, data

    integer :: inst_type, var_id
    integer :: num_levs, k, kk, i, j, i0, j0
    integer :: stdout_unit

    logical :: data_is_local, localize_data
    logical, dimension(MAX_LEVELS) :: flag

    character(len=32) :: anal_fldname

    if ( PRESENT(localize) ) then
       localize_data = localize
    else
       localize_data = .true.
    end if

    stdout_unit = stdout()

    anal_fldname = 'eta'
    var_id = obs_variable

    !snz idealized
    do j=1, size(x_grid, dim=1)
       do i=1, size(x_grid, dim=2)
          lon = x_grid(i,j)
          lat = y_grid(i,j)
          rms_err = 0.5

          inst_type = 20
          data_is_local = .true.

          if ( lon .lt. 0.0 ) lon = lon + 360.0
          if ( lon .gt. 360.0 ) lon = lon - 360.0
          if ( lon .lt. 80.0 ) lon = lon + 360.0 

          if ( lat < eta_obs_start_lat .or. lat > eta_obs_end_lat ) data_is_local = .false.
          if ( abs(lat) < 20.0 .and.&
               & (mod(floor(lon),2) /= 0 .or. mod(floor(lat),2) /= 0) ) data_is_local = .false.
          if ( (abs(lat) >= 20.0 .and. abs(lat) < 40.0) .and.&
               & (mod(floor(lon),4) /= 0 .or. mod(floor(lat),4) /= 0) ) data_is_local = .false.
          if ( (abs(lat) >= 40.0) .and.&
               & (mod(floor(lon),6) /= 0 .or. mod(floor(lat),6) /= 0) ) data_is_local = .false.

          if ( data_is_local .and. (.NOT.localize_data) ) then
             ri0 = frac_index(lon, x_grid(:,1))
             rj0 = frac_index(lat, y_grid(90,:))
             i0 = floor(ri0)
             j0 = floor(rj0)
             if ( Grd%mask(i0,j0,1) /= 0.0 .and. Grd%mask(i0+1,j0,1) /= 0.0 .and.&
                  & Grd%mask(i0,j0+1,1) /= 0.0 .and. Grd%mask(i0+1,j0+1,1) /= 0.0 ) then
                no_eta = no_eta+1
                num_profiles=num_profiles+1
                if ( num_profiles > max_profiles ) then
                   call error_mesg('oda_core_mod::open_profile_dataset_eta',&
                        & 'Maximum number of profiles exceeded, increase max_profiles in oda_core_nml.', FATAL)
                end if


                num_levs = 0
                flag = .false.
                do k=1, 1
                   flag(k) = .true.
                   data(k) = 0.0
                   depth(k) = 0.0
                   num_levs = num_levs+1
                end do
                if ( num_levs == 0 ) cycle
                allocate(profiles(num_profiles)%depth(num_levs))
                allocate(profiles(num_profiles)%data(num_levs))
                allocate(profiles(num_profiles)%flag(num_levs))
                allocate(profiles(num_profiles)%ms(num_levs))
                allocate(profiles(num_profiles)%ms_inv(num_levs))
                profiles(num_profiles)%variable = var_id
                profiles(num_profiles)%inst_type = inst_type
                profiles(num_profiles)%levels = num_levs
                profiles(num_profiles)%lat = lat
                profiles(num_profiles)%lon = lon
                kk = 1
                do k=1, 1
                   if ( flag(k) ) then
                      profiles(num_profiles)%depth(kk) = depth(k)
                      profiles(num_profiles)%data(kk) = data(k)
                      profiles(num_profiles)%ms(kk) = 1.0
                      profiles(num_profiles)%ms_inv(kk) = 1.0
                      kk = kk + 1
                   end if
                end do
           
                ! calculate interpolation coefficients (make sure to account for grid offsets here!)
                Profiles(num_profiles)%i_index = ri0
                Profiles(num_profiles)%j_index = rj0           
                Profiles(num_profiles)%accepted = .true.
                if ( i0 < 1 .or. j0 < 1 ) then
                   Profiles(num_profiles)%accepted = .false.
                end if
                if ( Profiles(num_profiles)%accepted ) then
                   if ( Grd%mask(i0,j0,1) == 0.0 .or.&
                        & Grd%mask(i0+1,j0,1) == 0.0 .or.&
                        & Grd%mask(i0,j0+1,1) == 0.0 .or.&
                        & Grd%mask(i0+1,j0+1,1) == 0.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                end if
                if ( Profiles(num_profiles)%accepted ) then
                   Profiles(num_profiles)%flag(:) = .true.
                   allocate(Profiles(num_profiles)%k_index(Profiles(num_profiles)%levels))
                   do k=1, Profiles(num_profiles)%levels
                      if (depth(k) < Grd%z(1)) then
                        Profiles(num_profiles)%k_index(k) = 0.0
                      else
                        Profiles(num_profiles)%k_index(k) = frac_index(depth(k), (/0.,Grd%z(:)/)) - 1
                      end if
                      if ( Profiles(num_profiles)%k_index(k) < 1.0 ) Profiles(num_profiles)%flag(k) = .false.
                   end do
                end if
             end if
          end if
       end do
    end do

    write (UNIT=stdout_unit, FMT='("A grand total of ",I8," eta points within global domain")') no_eta
    write (UNIT=stdout_unit, FMT='("A final total @eta of ",I8," prfs within global domain")') num_profiles
  end subroutine open_profile_dataset_eta

  subroutine open_profile_dataset_suv(filename, obs_variable, localize)  
    character(len=*), intent(in) :: filename
    integer, intent(in) :: obs_variable
    logical, intent(in), optional :: localize

    integer, parameter :: MAX_LEVELS = 1000

    real :: ri0, rj0
    real :: lon, lat, rms_err
    real, dimension(MAX_LEVELS) :: depth, data

    integer :: inst_type, var_id
    integer :: num_levs, k, kk, i, j, i0, j0
    integer :: stdout_unit

    logical :: data_is_local, localize_data
    logical, dimension(MAX_LEVELS) :: flag

    character(len=32) :: anal_fldname

    if ( PRESENT(localize) ) then
       localize_data = localize
    else
       localize_data = .true.
    end if

    stdout_unit = stdout()

    anal_fldname = 'suv'
    var_id = obs_variable

    !snz idealized
    do j=1, size(x_grid_uv,dim=1)
       do i=1, size(x_grid_uv,dim=2)
          lon = x_grid_uv(i,j)
          lat = y_grid_uv(i,j)
          rms_err = 0.5

          inst_type = 20
          data_is_local = .true.

          if ( lon .lt. 0.0 ) lon = lon + 360.0
          if ( lon .gt. 360.0 ) lon = lon - 360.0
          if ( lon .lt. 80.0 ) lon = lon + 360.0 

          if ( lat < -40.0 .or. lat > 40.0 ) data_is_local = .false.
          if ( abs(lat) < 20.0 .and.&
               & (mod(floor(lon),2) /= 0 .or. mod(floor(lat),2) /= 0) ) data_is_local = .false.
          if ( (abs(lat) >= 20.0 .and. abs(lat) < 40.0) .and.&
               & (mod(floor(lon),4) /= 0 .or. mod(floor(lat),4) /= 0) ) data_is_local = .false.
          if ( (abs(lat) >= 40.0) .and.&
               & (mod(floor(lon),6) /= 0 .or. mod(floor(lat),6) /= 0) ) data_is_local = .false.

          if ( data_is_local .and. (.NOT.localize_data) ) then
             ri0 = frac_index(lon, x_grid_uv(:,1))
             rj0 = frac_index(lat, y_grid_uv(90,:))
             i0 = floor(ri0)
             j0 = floor(rj0)
             if ( Grd%mask(i0,j0,1) /= 0.0 .and. Grd%mask(i0+1,j0,1) /= 0.0 .and.&
                  & Grd%mask(i0,j0+1,1) /= 0.0 .and. Grd%mask(i0+1,j0+1,1) /= 0.0 ) then
                no_suv = no_suv+1
                num_profiles = num_profiles + 1
                if ( num_profiles > max_profiles ) then
                   call error_mesg('oda_core_mod::open_profile_dataset_suv',&
                        & 'Maximum number of profiles exceeded, increase max_profiles in oda_core_nml.', FATAL)
                end if


                num_levs = 0
                flag = .false.
                do k=1, 2
                   flag(k) = .true.
                   data(k) = 0.0
                   depth(k) = 0.0
                   num_levs = num_levs + 1
                end do
                if ( num_levs == 0 ) cycle
                allocate(profiles(num_profiles)%depth(num_levs))
                allocate(profiles(num_profiles)%data(num_levs))
                allocate(profiles(num_profiles)%flag(num_levs))
                allocate(profiles(num_profiles)%ms(num_levs))
                allocate(profiles(num_profiles)%ms_inv(num_levs))
                profiles(num_profiles)%variable = var_id
                profiles(num_profiles)%inst_type = inst_type
                profiles(num_profiles)%levels = num_levs
                profiles(num_profiles)%lat = lat
                profiles(num_profiles)%lon = lon
                kk = 1
                do k=1, 2
                   if ( flag(k) ) then
                      profiles(num_profiles)%depth(kk) = depth(k)
                      profiles(num_profiles)%data(kk) = data(k)
                      profiles(num_profiles)%ms(kk) = 1.0
                      profiles(num_profiles)%ms_inv(kk) = 1.0
                      kk = kk + 1
                   end if
                end do
           
                ! calculate interpolation coefficients (make sure to account for grid offsets here!)
                Profiles(num_profiles)%i_index = ri0
                Profiles(num_profiles)%j_index = rj0           
                Profiles(num_profiles)%accepted = .true.
                if ( i0 < 1 .or. j0 < 1 ) then
                   Profiles(num_profiles)%accepted = .false.
                end if
                if ( Profiles(num_profiles)%accepted ) then
                   if ( Grd%mask(i0,j0,1) == 0.0 .or.&
                        & Grd%mask(i0+1,j0,1) == 0.0 .or.&
                        & Grd%mask(i0,j0+1,1) == 0.0 .or.&
                        & Grd%mask(i0+1,j0+1,1) == 0.0 ) then
                      Profiles(num_profiles)%accepted = .false.
                   end if
                end if
                if ( Profiles(num_profiles)%accepted ) then
                   Profiles(num_profiles)%flag(:) = .true.
                   allocate(Profiles(num_profiles)%k_index(Profiles(num_profiles)%levels))
                   do k=1, Profiles(num_profiles)%levels
                      if (depth(k) < Grd%z(1)) then
                        Profiles(num_profiles)%k_index(k) = 0.0
                      else
                        Profiles(num_profiles)%k_index(k) = frac_index(depth(k), (/0.,Grd%z(:)/)) - 1.0 ! snz modify to v3.2 JAN3012
                      end if
                      if ( Profiles(num_profiles)%k_index(k) < 1.0 ) Profiles(num_profiles)%flag(k) = .false.
                   end do
                end if
             end if
          end if
       end do
    end do

    write (UNIT=stdout_unit, FMT='("A grand total of ",I8," suv points within global domain")') no_suv
    write (UNIT=stdout_unit, FMT='("A final total @suv of ",I8," prfs within global domain")') num_profiles
  end subroutine open_profile_dataset_suv

  subroutine get_obs_suv(model_time, Prof, nprof, no_prf0)
    type(time_type), intent(in) :: model_time
    type(ocean_profile_type), dimension(:), intent(inout) :: Prof
    integer, intent(inout) :: nprof
    integer, intent(in) :: no_prf0   

    ! get sst data and put into profiles
    ! only current day                 

    real :: sfc_lon, sfc_lat, ri0, rj0
    real, dimension(1440,1070,1) :: sfc_u, sfc_v

    integer :: i, k, i_m, i0, j0
    integer :: unit, time_idx, ndim, nvar, natt, ntime 
    integer :: iy0, in0, id0, ih0, im0, is0
    integer :: stdout_unit, istat
    integer, dimension(12) :: n_days

    character(len=80) :: sfc_filename
    character(len=256) :: emsg_local

    type(fieldtype), dimension(:), allocatable :: fields
    type(time_type) :: tdiff, sfc_time0

    n_days  = (/31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/)
    nprof = 0
    stdout_unit = stdout()

    call get_date(model_time, iy0, in0, id0, ih0, im0, is0)
                                                                                 
    !monthly    
!!$    time_idx = (iy0-1984)*12+in0
    ! daily    
    if ( in0 == 1 ) then
       time_idx = (iy0-1984)*365 + id0
    else
       time_idx = 0
       do i_m=1, in0-1
          time_idx = time_idx + (iy0-1984)*365 + n_days(i_m)
       end do
       time_idx = time_idx + id0
    end if

    if ( mpp_pe() == mpp_root_pe() ) then
       write (UNIT=stdout_unit, FMT='("time_idx = ",I8)') time_idx
    end if

    sfc_time0 = set_date(iy0, in0, id0, ih0, im0, is0)

    sfc_filename = "INPUT/sfc_current.198401-198412.nc"

    call mpp_open(unit, trim(sfc_filename), MPP_RDONLY, MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE)
    call mpp_get_info(unit, ndim, nvar, natt, ntime)
    
    allocate(fields(nvar), STAT=istat)
    if ( istat .ne. 0 ) then 
       call error_mesg('oda_core_mod::get_obs_sst', 'Unable to allocate fields', FATAL)
    end if

    call mpp_get_fields(unit, fields)
    do i=1, nvar
       select case ( mpp_get_field_name(fields(i)) )
       case ('U_SFC')
          call mpp_read(unit, fields(i), sfc_u, tindex=time_idx)
       case ('V_SFC')
          call mpp_read(unit, fields(i), sfc_v, tindex=time_idx)
       end select
    end do
    
    do i=no_prf+no_sst+no_eta+1, no_prf+no_sst+no_eta+no_suv
       Profiles(i)%time = sfc_time0

       tdiff = model_time - Profiles(i)%time

       sfc_lon = Profiles(i)%lon     
       ri0 = frac_index(sfc_lon, x_grid_uv(:,1))
       i0 = floor(ri0)
       if ( i0 < 1 .or. i0 > 1440 ) then  
          write (UNIT=emsg_local, FMT='("Profiles(",I8,")%lon = ",I4,", i0 = ",I8)') i, Profiles(i)%lon, i0
          call error_mesg('oda_core_mod::get_obs_suv',&
               & 'Profile longitude index outside range [1,1440].  '//trim(emsg_local), FATAL)
       end if
                 
       sfc_lat = Profiles(i)%lat
       rj0 = frac_index(sfc_lat, y_grid_uv(90,:))
       j0 = floor(rj0)
       if ( j0 < 1 .or. j0 > 1070 ) then
          write (UNIT=emsg_local, FMT='("Profiles(",I8,")%lat = ",I4,", j0 = ",I8)') i, Profiles(i)%lon, j0
          call error_mesg('oda_core_mod::get_obs_suv',&
               & 'Profile latitude index outside range [1,1070].  '//trim(emsg_local), FATAL)
       end if

       if ( Profiles(i)%accepted ) then 
          nprof = nprof + 1
          if ( nprof > size(Prof,1) ) then 
             call error_mesg('oda_core_mod::get_obs_suv',&
                  & 'Passed in array "Prof" is smaller than number of profiles, increase size of Prof before call',&
                  & FATAL)
          end if
          Profiles(i)%data(1) = sfc_u(i0,j0,1)
          Profiles(i)%data(2) = sfc_v(i0,j0,1)

          call copy_obs(Profiles(i:i),Prof(nprof+no_prf0:nprof+no_prf0))

          Prof(nprof+no_prf0)%tdiff = tdiff  
       end if
    end do

    deallocate(fields)
    call mpp_close(unit)
  end subroutine get_obs_suv

  subroutine get_obs_eta(model_time, Prof, nprof, no_prf0)
    type(time_type), intent(in) :: model_time
    type(ocean_profile_type), dimension(:), intent(inout) :: Prof
    integer, intent(inout) :: nprof
    integer, intent(in) :: no_prf0   

    ! get sst data and put into profiles
    ! only current day                 

    real :: eta_lon, eta_lat, ri0, rj0
    real, dimension(1440,1070) :: eta_t

    integer :: i, i0, j0, i_m
    integer :: iy0, in0, id0, ih0, im0, is0
    integer :: unit, time_idx, ndim, nvar, natt, ntime
    integer :: stdout_unit, istat
    integer, dimension(12) :: n_days

    character(len=80) :: eta_filename
    character(len=256) :: emsg_local
    
    type(fieldtype), dimension(:), allocatable :: fields
    type(time_type) :: tdiff, sfc_time0

    n_days  = (/31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/)
    nprof = 0
    stdout_unit = stdout()

    call get_date(model_time, iy0, in0, id0, ih0, im0, is0)

    !monthly    
!!$    time_idx = (iy0-1984)*12+in0
    ! daily    
    if ( in0 == 1 ) then
       time_idx = (iy0-1976)*365 + id0 - 1
    else
       time_idx = 0
       do i_m=1, in0-1
          time_idx = time_idx + n_days(i_m)
       end do
       time_idx = (iy0-1976)*365 + time_idx + id0 - 1
    end if

    if ( mpp_pe() == mpp_root_pe() ) then
       write (UNIT=stdout_unit, FMT='("time_idx = ",I8)') time_idx
    end if

    sfc_time0 = set_date(iy0, in0, id0, ih0, im0, is0)

    eta_filename='INPUT/ocean.19760101-20001231.eta_t.nc'

    call mpp_open(unit, trim(eta_filename), MPP_RDONLY, MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE)
    call mpp_get_info(unit, ndim, nvar, natt, ntime)
    
    allocate(fields(nvar), STAT=istat)
    if ( istat .ne. 0 ) then 
       call error_mesg('oda_core_mod::get_obs_sst', 'Unable to allocate fields', FATAL)
    end if

    call mpp_get_fields(unit, fields)
    do i=1, nvar
       select case ( mpp_get_field_name(fields(i)) )
       case ('eta_t')
          call mpp_read(unit, fields(i), eta_t, tindex=time_idx)
       end select
    end do

    do i=no_prf+no_sst+1, no_prf+no_sst+no_eta
       Profiles(i)%time = sfc_time0

       tdiff = model_time - Profiles(i)%time

       eta_lon = Profiles(i)%lon
       ri0 = frac_index(eta_lon, x_grid(:,1))
       i0 = floor(ri0)
       if ( i0 < 1 .or. i0 > 1440 ) then  
          write (UNIT=emsg_local, FMT='("Profiles(",I8,")%lon = ",I4,", i0 = ",I8)') i, Profiles(i)%lon, i0
          call error_mesg('oda_core_mod::get_obs_eta',&
               & 'Profile longitude index outside range [1,1440].  '//trim(emsg_local), FATAL)
       end if
                 
       eta_lat = Profiles(i)%lat
       rj0 = frac_index(eta_lat, y_grid(90,:))
       j0 = floor(rj0)
       if ( j0 < 1 .or. j0 > 1070 ) then
          write (UNIT=emsg_local, FMT='("Profiles(",I8,")%lat = ",I4,", j0 = ",I8)') i, Profiles(i)%lon, j0
          call error_mesg('oda_core_mod::get_obs_suv',&
               & 'Profile latitude index outside range [1,1070].  '//trim(emsg_local), FATAL)
       end if

       if ( Profiles(i)%accepted ) then 
          if ( eta_t(i0,j0) > -9.9 ) then !!! excluding missing values
             nprof = nprof + 1              
             if ( nprof > size(Prof,1) ) then 
                call error_mesg('oda_core_mod::get_obs_eta',&
                     & 'Passed in array "Prof" is smaller than number of profiles, increase size of Prof before call.',&
                     & FATAL)
             end if
             Profiles(i)%data(1) = eta_t(i0,j0)

             call copy_obs(Profiles(i:i),Prof(nprof+no_prf0:nprof+no_prf0))

             Prof(nprof+no_prf0)%tdiff = tdiff  
          end if
       end if
    end do

    deallocate(fields)
    call mpp_close(unit)
  end subroutine get_obs_eta
end module oda_core_ecda_mod

module ocean_tempsalt_mod
!
!<CONTACT EMAIL="Russell.Fiedler@csiro.au"> R.A.S. Fiedler
!</CONTACT>
!
!<CONTACT EMAIL="David.Jackett@csiro.au"> David Jackett 
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! Setup the temperature and salinity tracer fields.  
! Convert between potential temperature and conservative temperature.
!</OVERVIEW>
!
!<DESCRIPTION>
!
! This routine sets up the temperature and salinity tracer fields.  
! It also performs a converstion between potential temperature and 
! conservative temperature, with the conversion valid over most 
! large-scale oceanographically relevant ranges.  
!
! 0psu <= salinity <= 40 psu
!
! -3C <= theta <= 40C    (theta=conservative temperature or potential temperature) 
!
! 0dbar <= pressure <= 8000dbar
!
!  Input variables are the following:
!
!  salinity
!
!  potential temperature (theta) in deg C
!  OR
!  conservative temperature (theta) in deg C
!
! </DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! Feistel (2003)
! A new extended Gibbs thermodynamic potential of seawater
! Progress in Oceanography. vol 58, pages 43-114.
! </REFERENCE>
!
! <REFERENCE>
! Jackett, McDougall, Feistel, Wright, and Griffies (2005)
! Algorithms for density, potential temperature,
! conservative temperature, and freezing temperature of
! seawater. Journal of Atmospheric and Oceanic 
! Technology, 2005 submitted.
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_tempsalt_nml">
!
!  <DATA NAME="teos10"  TYPE="logical">
!  For choosing whether to use the TEOS-10 equation of state.
!  This usage requires conservative temperature as the temperature variable,
!  and two salinity variables: Preformed Salinity and Absolute Salinity
!  anomaly. Default teos10=.false. 
!  </DATA>
!
!  <DATA NAME="do_fafmip_heat"  TYPE="logical">
!  Set to true to initialize the CMIP6/FAFMIP heat fields.  
!  Default do_fafmip_heat=.false. 
!  </DATA>
!
!  <DATA NAME="temperature_variable" TYPE="character">
!  For choosing the temperature variable used in the model.
!  Choices are 'conservative_temp' and 'potential_temp'.
!  Since conservative temperature is more accurate, it is the default. 
!  </DATA>
!
!  <DATA NAME="pottemp_equal_contemp" TYPE="logical">
!  For certain idealized cases where the difference between potential
!  temperature and conservative temperature is irrelevant. Default=.false. 
!  </DATA>
!
!  <DATA NAME="pottemp_2nd_iteration" TYPE="logical">
!  For taking extra iteration in computation of potential temperature
!  from conservative temperature and salinity. Default is true.  
!  </DATA>
!
!  <DATA NAME="reinit_ts_with_ideal" TYPE="logical">
!  For setting up an ideal temperature and salinity profile
!  that is generated in the model. This profile can be 
!  generated after the model has already been running, hence
!  the name "reinit" for "reinitialize."
!  </DATA>
!  <DATA NAME="reinit_ts_with_ideal_efold" UNITS="metre" TYPE="real">
!  For setting efolding of reinitialized temp and salinity profile. 
!  Default reinit_ts_with_ideal_efold=1000.
!  </DATA> 
!  <DATA NAME="reinit_ts_with_ideal_tvalue" UNITS="C" TYPE="real">
!  For setting the reinitialized temperature value using the 
!  ideal profile. Default reinit_ts_with_ideal_tvalue = 10.0
!  </DATA> 
!  <DATA NAME="reinit_ts_with_ideal_svalue" UNITS="psu" TYPE="real">
!  For setting the reinitialized temperature value using the 
!  ideal profile. Default reinit_ts_with_ideal_svalue = 30.0
!  </DATA> 
!
!  <DATA NAME="t_min" UNITS="deg C" TYPE="real">
!  Minimum potential/conservative temperature below which we gracefully bring down the model. 
!  </DATA> 
!  <DATA NAME="t_max" UNITS="deg C" TYPE="real">
!  Maximum potential/conservative temperature above which we gracefully bring down the model.  
!  </DATA> 
!  <DATA NAME="s_min" UNITS="ppt" TYPE="real">
!  Minimum salinity below which we gracefully bring down the model. 
!  </DATA> 
!  <DATA NAME="s_max" UNITS="ppt" TYPE="real">
!  Maximum salinity below which we gracefully bring down the model. 
!  </DATA> 
!
!  <DATA NAME="t_min_limit" UNITS="deg C" TYPE="real">
!  Minimum potential/conservative temperature below which will employ upwind advection 
!  instead of quicker, and horizontal diffusion instead of neutral physics. 
!  </DATA> 
!  <DATA NAME="t_max_limit" UNITS="deg C" TYPE="real">
!  Maximum potential/conservative temperature above which will employ upwind advection 
!  instead of quicker, and horizontal diffusion instead of neutral physics. 
!  </DATA> 
!  <DATA NAME="s_min_limit" UNITS="psu" TYPE="real">
!  Minimum salinity below which will employ upwind advection instead
!  of quicker, and horizontal diffusion instead of neutral physics.  
!  </DATA> 
!  <DATA NAME="s_max_limit" UNITS="psu" TYPE="real">
!  Maximum salinity below which will employ upwind advection instead
!  of quicker, and horizontal diffusion instead of neutral physics.  
!  </DATA> 
!
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging the module.
!  </DATA>
!
!</NAMELIST>

use constants_mod,        only: kelvin
use fms_mod,              only: write_version_number, mpp_error, FATAL, WARNING
use fms_mod,              only: open_namelist_file, check_nml_error, close_file
use mpp_mod,              only: input_nml_file, stdout, stdlog
use mpp_mod,              only: mpp_clock_id, mpp_clock_begin, mpp_clock_end
use mpp_mod,              only: CLOCK_COMPONENT, CLOCK_SUBCOMPONENT, CLOCK_MODULE

use ocean_domains_mod,    only: get_local_indices
use ocean_parameters_mod, only: cp_ocean, CP_OCEAN_PRETEOS10, CP_OCEAN_TEOS10 
use ocean_tpm_util_mod,   only: otpm_set_prog_tracer, otpm_set_diag_tracer
use ocean_types_mod,      only: ocean_domain_type, ocean_grid_type, ocean_prog_tracer_type
use ocean_types_mod,      only: ocean_time_type, ocean_options_type, ocean_thickness_type
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3

implicit none

private

#include <ocean_memory.h>

type(ocean_domain_type), pointer :: Dom =>NULL()
type(ocean_grid_type), pointer   :: Grd =>NULL()

character(len=128) :: version=&
       '$Id: ocean_tempsalt.F90,v 20.0 2013/12/14 00:17:14 fms Exp $'
character (len=128) :: tagname = &
       '$Name: tikal $'

private dentropy_dtheta
interface dentropy_dtheta
  module procedure dentropy_dtheta_field
  module procedure dentropy_dtheta_level
  module procedure dentropy_dtheta_point
end interface 

public ocean_tempsalt_init
public ocean_tempsalt_ideal_reinit
public contemp_from_pottemp
public pottemp_from_contemp
public tempsalt_check_range

! interfaces for contemp_from_pottemp
interface contemp_from_pottemp
   module procedure contemp_from_pottemp_field
   module procedure contemp_from_pottemp_level
   module procedure contemp_from_pottemp_point
end interface

! interfaces for pottemp_from_contemp
interface pottemp_from_contemp
   module procedure pottemp_from_contemp_field
   module procedure pottemp_from_contemp_level
   module procedure pottemp_from_contemp_point
end interface

! useful constants 
real,parameter :: one_over_40=2.5e-2   
real,parameter :: one_over_1600=6.25e-4   
real,parameter :: sfact=35./35.16504

! for diagnostics 
integer :: id_contemp=-1
integer :: id_pottemp=-1
logical :: used 

! for timing clocks 
integer :: id_clock_c2p_1
integer :: id_clock_c2p_2
integer :: id_clock_c2p_3

! preTEOS10 coefficients for computing contemp to pottemp
real ::  a0,  a1,  a2,  a3,  a4,  a5    
real ::  b0,  b1,  b2,  b3              

! preTEOS10 coefficients for computing pottemp to contemp
real ::  c0,  c1,  c2,  c3,  c4,  c5    
real ::  c6,  c7,  c8,  c9, c10, c11    
real :: c12, c13, c14, c15, c16, c17    
real :: c18, c19, c20, c21, c22, c23    

! TEOS10 coefficients for computing contemp from pottemp 
real ::  sfac
real ::  v0,  v1,  v2,  v3,  v4,  v5    
real ::  v6,  v7,  v8,  v9, v10, v11    
real :: v12, v13, v14, v15, v16, v17    
real :: v18, v19, v20, v21, v22, v23    
real :: v24, v25, v26, v27, v28, v29    

! preTEOS10 coefficients for computing d(entropy)/d(pottemp)
real ::  f0,  f1,  f2,  f3,  f4,  f5, f6    
real ::  f7,  f8,  f9, f10, f11, f12, f13    

! TEOS10 polynomial coefficients for computing d(entropy)/d(pottemp) 
real ::  g1,  g2,  g3,  g4,  g5, g6    
real ::  h1,  h2,  h3,  h4,  h5, h6    
real ::  h7,  h8,  h9, h10, h11, h12

! for testing the conversion between pottemp and contemp 
real :: t_test= 20.0               ! deg C
real :: s_test= 20.0               ! psu
real :: ct_ref= 20.4527496128276   ! deg C
real :: pt_ref= 19.55627910604363  ! deg C 

! conversion factor for salinity  (preformed -> absolute)
real :: Fdelta

logical :: module_is_initialized = .FALSE.

logical :: reinit_ts_with_ideal        = .false. 
real    :: reinit_ts_with_ideal_efold  = 1000.0 
real    :: reinit_ts_with_ideal_tvalue = 10.0
real    :: reinit_ts_with_ideal_svalue = 30.0
 
! set min/max temp and salinity range, outside 
! of which the model will be brought down.
real :: t_min=-5.0
real :: t_max=40.0
real :: s_min=0.0
real :: s_max=70.0

! min/max temp and salinity beyond which employ upwind 
! advection if set limit_tracer_range_quick=.true.
! (set in ocean_tracer_advect_nml) and/or 
! horizontal diffusion if neutral_physics_limit=.true. 
! (set in ocean_nphysicsA_nml, ocean_nphysicsB_nml, or ocean_nphysicsC_nml)
! or remove submesoscale fluxes if submeso_flux_limit=.true.
! (set in ocean_submesoscale_nml)
real :: t_min_limit=-2.0
real :: t_max_limit=32.0
real :: s_min_limit=1.0
real :: s_max_limit=42.0

logical :: debug_this_module     = .false.
logical :: pottemp_2nd_iteration = .true.    
logical :: pottemp_equal_contemp = .false.
logical :: teos10                = .false.
logical :: do_fafmip_heat        = .false.

character(len=32) :: temperature_variable='conservative_temp'  ! "conservative_temp" or "potential_temp"          

namelist /ocean_tempsalt_nml/ debug_this_module, temperature_variable, pottemp_2nd_iteration,     &
                              pottemp_equal_contemp,                                              &
                              t_min,       t_max,       s_min,       s_max,                       &
                              t_min_limit, t_max_limit, s_min_limit, s_max_limit,                 &
                              reinit_ts_with_ideal, reinit_ts_with_ideal_efold,                   &
                              reinit_ts_with_ideal_tvalue, reinit_ts_with_ideal_svalue,           &
                              teos10, do_fafmip_heat 
                
contains


!#######################################################################
! <SUBROUTINE NAME="ocean_tempsalt_init">
!
! <DESCRIPTION>
! Initialize the temperature/salinity module.
! </DESCRIPTION>
!
subroutine ocean_tempsalt_init(Domain, Grid, Ocean_options, itemp, isalt, i_redist_heat, debug)

  type(ocean_domain_type),    intent(in), target   :: Domain
  type(ocean_grid_type),      intent(in), target   :: Grid
  type(ocean_options_type),   intent(inout)        :: Ocean_options
  integer,                    intent(inout)        :: itemp
  integer,                    intent(inout)        :: isalt
  integer,                    intent(inout)        :: i_redist_heat
  logical,                    intent(in), optional :: debug

  integer           :: ioun, io_status, ierr
  integer           :: index_temp       =-1
  integer           :: index_salt       =-1  
  integer           :: index_diag_temp  =-1
  integer           :: index_Fdelta     =-1
  integer           :: index_added_heat =-1
  integer           :: index_redist_heat=-1
  character(len=32) :: longname_temperature 
  real              :: test_value, diff_test

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then
      call mpp_error(FATAL, '==>Error in ocean_tempsalt_mod (ocean_tempsalt_init): module initialized.')
  endif

  module_is_initialized = .TRUE.

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
#endif

  Dom => Domain
  Grd => Grid

  call write_version_number(version, tagname)

  ! provide for namelist override of defaults
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_tempsalt_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_tempsalt_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_tempsalt_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status, 'ocean_tempsalt_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_tempsalt_nml)
  write (stdlogunit,ocean_tempsalt_nml)

  if (PRESENT(debug) .and. .not. debug_this_module) then
      debug_this_module = debug
  endif
  if(debug_this_module) then 
      write(stdoutunit,'(a)') '==>Note: running ocean_tempsalt with debug_this_module=.true.'  
  endif

  ! check for consistent use of heat capacity according to teos10 or preteos10 
  if(teos10) then 
      if(cp_ocean==CP_OCEAN_PRETEOS10) then 
          call mpp_error(FATAL,  '==>Error in ocean_tempsalt_mod: Must have' //  &
               ' cp_ocean = CP_OCEAN_TEOS10 with TEOS10 equation of state.' //   &
               ' Make code change inside ocean_parameters.F90 and recompile.')
      endif
  else
      if(cp_ocean==CP_OCEAN_TEOS10) then 
          call mpp_error(WARNING,  '==>Warning in ocean_tempsalt_mod: Using ' //          &
               ' cp_ocean = cp_ocean_teos10, yet not using TEOS10 equation of state.' //  &
               ' You may use earlier CP_OCEAN_PRETEOS10 value by changing ocean_parameters.F90')
      endif
  endif


  if(temperature_variable/='conservative_temp' .and. teos10 ) then
     call mpp_error(FATAL,  '==>Error in ocean_tempsalt_mod: Must have' //  &
     ' prognostic temperature variable = conservative_temp when using TEOS10')
  endif
  if(temperature_variable=='conservative_temp') then
     write(stdoutunit,'(a)') '==>Note from ocean_tempsalt_mod: MOM prognostic temp = conservative temperature.' 
     write(stdoutunit,'(a/)')'                                 MOM diagnostic temp = potential temperature.' 
     longname_temperature = 'Conservative temperature'
     Ocean_options%temperature_variable = 'Prognostic temperature variable is conservative temperature.'
  elseif(temperature_variable=='potential_temp') then 
     write(stdoutunit,'(a)') '==>Note from ocean_tempsalt_mod: MOM prognostic temp = potential temperature.' 
     write(stdoutunit,'(a/)')'                                 MOM diagnostic temp = conservative temperature.' 
     longname_temperature = 'Potential temperature'
     Ocean_options%temperature_variable = 'Prognostic temperature variable is potential temperature.'
  else 
     write(stdoutunit,'(/a/)')'==>Error in ocean_tempsalt_mod: prognostic temperature variable remains unchosen.' 
     call mpp_error(FATAL,  '==>Error in ocean_tempsalt_mod: prognostic temperature variable remains unchosen.')
  endif 

  if(pottemp_equal_contemp) then 
     write(stdoutunit,'(a)') '==>Note from ocean_tempsalt_mod: setting potential temp = conservative temp.' 
     write(stdoutunit,'(a)') '   This setting is useful for simulations where the difference is irrelevant.'
  endif 


  ! initialize temperature and salinity

  index_temp = otpm_set_prog_tracer('temp', 'required',                                    &
       caller='ocean_tempsalt_mod/ocean_tempsalt_init',                                    &
       longname=longname_temperature, units='deg_C',                                       &
       conversion=cp_ocean, offset=kelvin, min_tracer=t_min, max_tracer=t_max,             &
       min_range=-10.0, max_range=500.0, flux_units='Watts/m^2', min_flux_range=-1.0e+16,  &
       max_flux_range=1.0e+16, min_tracer_limit=t_min_limit, max_tracer_limit=t_max_limit, &
       psom_limit=.false.,ppm_hlimiter=2,ppm_vlimiter=2,mdt_scheme=1,                      &
       restart_file='ocean_temp_salt.res.nc' )
  itemp = index_temp

  if ( teos10 ) then
  index_salt = otpm_set_prog_tracer('salt', 'required',                                      &
       caller='ocean_tempsalt_mod/ocean_tempsalt_init',                                      &
       longname='Preformed Salinity', units='g/kg',                                          &
       conversion=0.001, min_tracer=s_min, max_tracer=s_max,                                 &
       min_range=-10.0, max_range=100.0, flux_units='kg/(sec*m^2)', min_flux_range=-1.0e+05, &
       max_flux_range=1.0e+05, min_tracer_limit=s_min_limit, max_tracer_limit=s_max_limit,   &
       psom_limit=.false.,ppm_hlimiter=2,ppm_vlimiter=2,mdt_scheme=1,                        &
       restart_file='ocean_temp_salt.res.nc' )
  isalt = index_salt 
  index_Fdelta = otpm_set_prog_tracer('fdelta', 'required',                                &
       caller='ocean_tempsalt_mod/ocean_tempsalt_init',                                    &
       longname='Salinity conversion factor', units='none',                                &
       conversion=1.0, min_tracer=s_min, max_tracer=s_max,                                 &
       min_range=-1.0, max_range=1.0, flux_units='kg/(sec*m^2)', min_flux_range=-1.0e+04,  &
       max_flux_range=1.0e+04, min_tracer_limit=s_min_limit, max_tracer_limit=s_max_limit, &
       psom_limit=.false.,ppm_hlimiter=2,ppm_vlimiter=2,mdt_scheme=1,                      &
       restart_file='ocean_Fdelta.res.nc' )
  else
  index_salt = otpm_set_prog_tracer('salt', 'required',                                      &
       caller='ocean_tempsalt_mod/ocean_tempsalt_init',                                      &
       longname='Practical Salinity', units='psu',                                           &
       conversion=0.001, min_tracer=s_min, max_tracer=s_max,                                 &
       min_range=-10.0, max_range=100.0, flux_units='kg/(sec*m^2)', min_flux_range=-1.0e+05, &
       max_flux_range=1.0e+05, min_tracer_limit=s_min_limit, max_tracer_limit=s_max_limit,   &
       psom_limit=.false.,ppm_hlimiter=2,ppm_vlimiter=2,mdt_scheme=1,                        &
       restart_file='ocean_temp_salt.res.nc' )
  isalt = index_salt 
  endif

  if(temperature_variable=='conservative_temp') then
      index_diag_temp = otpm_set_diag_tracer('pot_temp',                                     &
           caller='ocean_tempsalt_mod/ocean_tempsalt_init',                                  &
           longname='Potential temperature', units='deg_C',                                  &
           conversion=cp_ocean, offset=kelvin, min_tracer=t_min, max_tracer=t_max,           &
           min_range=-10.0, max_range=500.0, const_init_tracer=.true.,const_init_value=0.0,  &
           restart_file='ocean_pot_temp.res.nc' )
  elseif(temperature_variable=='potential_temp') then
      index_diag_temp = otpm_set_diag_tracer('con_temp',                                     &
           caller='ocean_tempsalt_mod/ocean_tempsalt_init',                                  &
           longname='Conservative temperature', units='deg_C',                               &
           conversion=cp_ocean, offset=kelvin, min_tracer=t_min, max_tracer=t_max,           &
           min_range=-10.0, max_range=500.0, const_init_tracer=.true.,const_init_value=0.0,  &
           restart_file='ocean_con_temp.res.nc' )
  endif

  i_redist_heat = -1   
  if(do_fafmip_heat) then
    Ocean_options%fafmip_heat = 'Included the two CMIP6/FAFMIP prognostic temperature tracers.'
    write(stdoutunit,'(a)') '==>Note from ocean_tempsalt_mod: Initializing FAFMIP temperature fields.' 

    index_added_heat = otpm_set_prog_tracer('added_heat', 'required',                        &
         caller='ocean_tempsalt_mod/ocean_tempsalt_init',                                    &
         longname='added_heat', units='deg_C',                                               &
         conversion=cp_ocean, offset=kelvin, min_tracer=t_min, max_tracer=t_max,             &
         min_range=-10.0, max_range=500.0, flux_units='Watts/m^2', min_flux_range=-1.0e+16,  &
         max_flux_range=1.0e+16, min_tracer_limit=t_min_limit, max_tracer_limit=t_max_limit, &
         psom_limit=.false.,ppm_hlimiter=2,ppm_vlimiter=2,mdt_scheme=1,                      &
         restart_file='ocean_added_heat.res.nc' )

    index_redist_heat = otpm_set_prog_tracer('redist_heat', 'required',                      &
         caller='ocean_tempsalt_mod/ocean_tempsalt_init',                                    &
         longname='redist_heat', units='deg_C',                                              &
         conversion=cp_ocean, offset=kelvin, min_tracer=t_min, max_tracer=t_max,             &
         min_range=-10.0, max_range=500.0, flux_units='Watts/m^2', min_flux_range=-1.0e+16,  &
         max_flux_range=1.0e+16, min_tracer_limit=t_min_limit, max_tracer_limit=t_max_limit, &
         psom_limit=.false.,ppm_hlimiter=2,ppm_vlimiter=2,mdt_scheme=1,                      &
         restart_file='ocean_redist_heat.res.nc' )
    i_redist_heat = index_redist_heat

  else
    Ocean_options%fafmip_heat = 'Did NOT include CMIP6/FAFMIP prognostic temperature tracers.'
    write(stdoutunit,'(a)') '==>Note from ocean_tempsalt_mod: NOT Initializing FAFMIP temperature fields.' 
  endif 


  if(reinit_ts_with_ideal) then 
      write(stdoutunit,'(a)') '==>Note: reinitializing ocean_tempsalt with ideal internally generated profile.'
  endif 

  ! polynomial coefficients for conservative temp and potential temp 
  
  a0 = -1.446013646344788e-2
  a1 = -3.305308995852924e-3
  a2 =  1.062415929128982e-4
  a3 =  9.477566673794488e-1
  a4 =  2.166591947736613e-3
  a5 =  3.828842955039902e-3

  b0 =  1.000000000000000e+0
  b1 =  6.506097115635800e-4
  b2 =  3.830289486850898e-3
  b3 =  1.247811760368034e-6


  if (teos10) then
     sfac = 9.95306702338459d-01
  else 
     sfac = 1.0
  endif 


  ! TEOS10 coefficients for CT from PT and salinity 
  v0  =  2.50509288068125d-04    ! v0=1/cp_ocean 
  v1 =  61.01362420681071d0 
  v2 = 168776.46138048015d0 
  v3 = -2735.2785605119625d0 
  v4 = 2574.2164453821433d0
  v5 = -1536.6644434977543d0 
  v6 = 545.7340497931629d0
  v7 = -50.91091728474331d0 
  v8 = -18.30489878927802d0

  v9 = 268.5520265845071d0 
  v10 = -12019.028203559312d0
  v11 = 3734.858026725145d0 
  v12 = -2046.7671145057618d0
  v13 = 465.28655623826234d0 
  v14 = -0.6370820302376359d0 
  v15 = -10.650848542359153d0
  v16 = 937.2099110620707d0 
  v17 = 588.1802812170108d0
  v18 = 248.39476522971285d0 
  v19 = -3.871557904936333d0
  v20 = -2.6268019854268356d0
  v21 = -1687.914374187449d0 
  v22 = 246.9598888781377d0
  v23 = 123.59576582457964d0 
  v24 = -48.5891069025409d0
  v25 = 936.3206544460336d0
  v26 = -942.7827304544439d0 
  v27 = 369.4389437509002d0
  v28 = -33.83664947895248d0 
  v29 = -9.987880382780322d0

  ! preTEOS10 coefficients for CT from PT and salinity
  c0  =  2.50494524832013e-4    ! c0=1/cp_ocean 
  c1  =  61.013624165232955
  c2  =  168776.46138048015
  c3  = -2735.2785605119643
  c4  =  2574.2164453821442
  c5  = -1536.6644434977545
  c6  =  545.734049793163
  c7  = -50.910917284743334                
  c8  = -18.30489878927802                
  c9  =  416.31512917743896
  c10 =  937.9793807560891                
  c11 = -3140.435779506947
  c12 =  2975.170149976973
  c13 = -1760.137081144729
  c14 =  414.5655751783703               
  c15 =  2167.72082596016               
  c16 = -1224.5772800562902
  c17 =  326.3074029273967
  c18 =  50.6703824689518                
  c19 = -12694.10018182362
  c20 =  4405.71847182968
  c21 = -2132.9690185026416
  c22 =  303.91071982808035               
  c23 =  69.74975368852  


  ! TEOS10 coefficients for computing d(entropy)/d(pottemp) 
  g1 =  -24715.571866078
  g2 = 4420.4472249096725
  g3 = -1778.231237203896
  g4 = 1160.5182516851419
  g5 = -569.531539542516 
  g6 = 128.13429152494615

  h1 = 1760.062705994408 
  h2 = -86.1329351956084
  h3 = -137.1145018408982 
  h4 = 296.20061691375236
  h5 = -205.67709290374563 
  h6 = 49.9394019139016
  h7 = -60.136422517125 
  h8 = 10.50720794170734
  h9 = -1351.605895580406 
  h10 = 1097.1125373015109
  h11 = -433.20648175062206 
  h12 = 63.905091254154904

  ! preTEOS10 coefficients for computing d(entropy)/d(pottemp) 
  f0  =  24715.571866078
  f1  = -1858.920033948178
  f2  =  317.440355256842
  f3  = -405.1392883572282
  f4  =  202.6815298758072
  f5  =  1562.563716288858
  f6  = -1165.8752731900836
  f7  =  348.7487684426
  f8  = -4420.4472249096725
  f9  =  1778.231237203896
  f10 = -1160.5182516851419
  f11 =  569.531539542516
  f12 =  128.13429152494615
  f13 =  6.2500000000000000e-4

 
  if(debug_this_module .and. .not. pottemp_equal_contemp) then 
      write (stdoutunit,'(/a/)') 'TEMPERATURE TEST VALUES'
      if(teos10) then
         ct_ref = 2.04566805754950e+01
         pt_ref = 1.95524819680081e+01
      endif
      test_value = contemp_from_pottemp(20.0,20.0)
      diff_test  = abs(test_value-ct_ref)
      write (stdoutunit,'(a,f6.2,a,f6.2,/a,e22.16,/a,e22.16,/a,e22.16)') &
           's_test(psu) = ',s_test,', pottemp_test(C) = ',t_test,      &
           'contemp_from_pottemp(C)       = ',test_value,              &
           'reference value               = ',ct_ref,                  &
           'abs difference between values = ',diff_test

      test_value = pottemp_from_contemp(20.0,20.0)
      diff_test  = abs(test_value-pt_ref)
      write (stdoutunit,'(/a,f6.2,a,f6.2,/a,e22.16,/a,e22.16,/a,e22.16)') &
           's_test(psu) = ',s_test,', contemp_test(C) = ',t_test,       &
           'pottemp_from_contemp(C)       = ',test_value,               &
           'reference value               = ',pt_ref,                   &
           'abs difference between values = ',diff_test
  endif

  ! clocks 
  id_clock_c2p_1  = mpp_clock_id('(Ocean CT2PT: 1) '  ,grain=CLOCK_MODULE)
  id_clock_c2p_2  = mpp_clock_id('(Ocean CT2PT: 2) '  ,grain=CLOCK_MODULE)
  id_clock_c2p_3  = mpp_clock_id('(Ocean CT2PT: 3) '  ,grain=CLOCK_MODULE)

  
end subroutine ocean_tempsalt_init
! </SUBROUTINE> NAME="ocean_tempsalt_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_tempsalt_ideal_reinit">
!
! <DESCRIPTION>
! Reinitialize the temperature/salinity fields with internally generated
! idealized profile.
!
! This routine can be called at any time within a model integration.  
! The main application is to allow for there to be a nontrivial 
! Thickness established, and then to reinitialize the temperature 
! and salinity to be functions of the depth_st array.  When 
! s=zstar, this approach will produce a flat initialization in 
! zstar space, but nontrivial initialization in depth space.  
!
! User can customize a profile.  
!
! One example given here assumes profile is a function of depth_st,
! with the assumption that s=geopotential OR s=zstar.  
! To use this approach with pressure coordinate, need to alter the 
! reinit_ts_with_ideal_efold value, since depth_st is in MKS, not dbar. 
!
! </DESCRIPTION>
!
subroutine ocean_tempsalt_ideal_reinit(Thickness, index_temp, index_salt, T_prog)

  type(ocean_thickness_type),   intent(in)    :: Thickness
  integer,                      intent(in)    :: index_temp
  integer,                      intent(in)    :: index_salt
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)

  integer :: i,j,k,n

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. reinit_ts_with_ideal) return 

  write(stdoutunit,'(/a/)') &
  '==>From ocean_tempsalt_ideal_reinit: reinitializing temp/salinity with ideal profile.'

  do n=1,3
     do k=1,nk
        do j=jsd,jed
           do i=isd,ied
              T_prog(index_temp)%field(i,j,k,n) = Grd%tmask(i,j,k) &
              *reinit_ts_with_ideal_tvalue*exp(-Thickness%depth_st(i,j,k)/reinit_ts_with_ideal_efold)   
              T_prog(index_salt)%field(i,j,k,n) = Grd%tmask(i,j,k) & 
              *reinit_ts_with_ideal_svalue*exp(-Thickness%depth_st(i,j,k)/reinit_ts_with_ideal_efold)    
           enddo
        enddo
     enddo
  enddo


end subroutine ocean_tempsalt_ideal_reinit
! </SUBROUTINE> NAME="ocean_tempsalt_ideal_reinit"



!#######################################################################
! <FUNCTION NAME="contemp_from_pottemp_field">
!
! <DESCRIPTION>
!
! Compute conservative temperature for all grid points. 
! Input is potential temperature (C) and salinity(psu or g/kg).
!
! contemp = potential_enthalpy(s,theta)/cp_ocean
!
! </DESCRIPTION>
!
function contemp_from_pottemp_field (salinity, theta)

  real, dimension(isd:,jsd:,:), intent(in) :: salinity
  real, dimension(isd:,jsd:,:), intent(in) :: theta
  real, dimension(isd:ied,jsd:jed,nk)      :: contemp_from_pottemp_field

  integer :: i, j, k
  real    :: t1, s1, sp5

  if ( .not. module_is_initialized ) then
      call mpp_error(FATAL, '==>Error in ocean_tempsalt_mod (contemp_from_pottemp_field): module not initialized')
  endif

  if(pottemp_equal_contemp) then  
     contemp_from_pottemp_field = theta 
     return 
  endif 

  if (teos10) then

      do k=1,nk
         do j=jsd,jed
            do i=isd,ied

               t1  = one_over_40*theta(i,j,k)
               s1  = one_over_40*sfac*salinity(i,j,k)
               sp5 = sqrt(s1)

               contemp_from_pottemp_field(i,j,k) =                                  &
                    v0*(v1+t1*(v2+t1*(v3+t1*(v4+t1*(v5+t1*(v6+t1*(v7+v8*t1))))))  + &
                    s1*(v9+t1*(v10+t1*(v11+t1*(v12+t1*(v13+t1*(v14+t1*v15)))))    + &
                    sp5*(v16+t1*(v17+t1*(v18+t1*(v19+t1*v20)))                    + &
                    sp5*(v21+sp5*(v22+sp5*(v23+sp5*v24))                          + &
                    t1*(v25+t1*(v26+t1*(v27+t1*(v28+t1*v29))))))))


            enddo
         enddo
      enddo

  else   ! preTEOS10 

      do k=1,nk
         do j=jsd,jed
            do i=isd,ied

               t1  = one_over_40*theta(i,j,k)
               s1  = one_over_40*salinity(i,j,k)
               sp5 = sqrt(s1)                                       

               contemp_from_pottemp_field(i,j,k) =                                  &
                    c0*(c1+t1*(c2+t1*(c3+t1*(c4+t1*(c5+t1*(c6+(c7+c8*t1)*t1)))))  + &  
                    s1*(c9+sp5*(c10+sp5*(c11+sp5*(c12+sp5*(c13+sp5*c14)))+t1*(c15 + &
                    t1*(c16+t1*(c17+c18*t1))))+t1*(c19+t1*(c20+t1*(c21+t1*(c22+c23*t1))))))

            enddo
         enddo
      enddo

  endif

end function contemp_from_pottemp_field
! </FUNCTION> NAME="contemp_from_pottemp_field"


!#######################################################################
! <FUNCTION NAME="contemp_from_pottemp_level">
!
! <DESCRIPTION>
!
! Compute conservative temperature for one k-level.
! Input is potential temperature (C) and salinity(psu or g/kg).
!
! contemp = potential_enthalpy(s,theta)/cp_ocean
!
! </DESCRIPTION>
!
function contemp_from_pottemp_level(salinity, theta)

  real, dimension(isd:,jsd:), intent(in) :: salinity
  real, dimension(isd:,jsd:), intent(in) :: theta
  real, dimension(isd:ied,jsd:jed)       :: contemp_from_pottemp_level

  integer :: i, j
  real    :: t1, s1, sp5

  if ( .not. module_is_initialized ) then
      call mpp_error(FATAL, '==>Error in ocean_tempsalt_mod (contemp_from_pottemp_level): module not initialized')
  endif

  if(pottemp_equal_contemp) then  
     contemp_from_pottemp_level = theta 
     return 
  endif 

  if (teos10) then

      do j=jsd,jed
         do i=isd,ied

            t1  = one_over_40*theta(i,j)
            s1  = one_over_40*sfac*salinity(i,j)
            sp5 = sqrt(s1)

            contemp_from_pottemp_level(i,j) =                                    &
                 v0*(v1+t1*(v2+t1*(v3+t1*(v4+t1*(v5+t1*(v6+t1*(v7+v8*t1))))))  + &
                 s1*(v9+t1*(v10+t1*(v11+t1*(v12+t1*(v13+t1*(v14+t1*v15)))))    + &
                 sp5*(v16+t1*(v17+t1*(v18+t1*(v19+t1*v20)))                    + &
                 sp5*(v21+sp5*(v22+sp5*(v23+sp5*v24))                          + &
                 t1*(v25+t1*(v26+t1*(v27+t1*(v28+t1*v29))))))))

         enddo
      enddo

  else

      do j=jsd,jed
         do i=isd,ied

            t1  = one_over_40*theta(i,j)
            s1  = one_over_40*salinity(i,j)
            sp5 = sqrt(s1)

            contemp_from_pottemp_level(i,j) =                                      &
                 c0*(c1+t1*(c2+t1*(c3+t1*(c4+t1*(c5+t1*(c6+(c7+c8*t1)*t1)))))    + &  
                 s1*(c9+sp5*(c10+sp5*(c11+sp5*(c12+sp5*(c13+sp5*c14)))+t1*(c15   + &
                 t1*(c16+t1*(c17+c18*t1))))+t1*(c19+t1*(c20+t1*(c21+t1*(c22+c23*t1))))))


         enddo
      enddo

  endif

end function contemp_from_pottemp_level
! </FUNCTION> NAME="contemp_from_pottemp_level"


!#######################################################################
! <FUNCTION NAME="contemp_from_pottemp_point">
!
! <DESCRIPTION>
!
! Compute conservative temperature for one grid point.
! Input is potential temperature (C) and salinity(psu or g/kg).
!
! contemp = potential_enthalpy(s,theta)/cp_ocean
!
! </DESCRIPTION>
!
function contemp_from_pottemp_point(salinity, theta)

  real, intent(in) :: salinity
  real, intent(in) :: theta
  real             :: contemp_from_pottemp_point

  real :: t1,s1,sp5

  if ( .not. module_is_initialized ) then
      call mpp_error(FATAL, '==>Error in ocean_tempsalt_mod (contemp_from_pottemp_point): module not initialized')
  endif

  if(pottemp_equal_contemp) then  
     contemp_from_pottemp_point = theta 
     return 
  endif 

  t1  = one_over_40*theta
  s1  = one_over_40*sfac*salinity
  sp5 = sqrt(s1)

  if (teos10) then

     contemp_from_pottemp_point =                                          &
          v0*(v1+t1*(v2+t1*(v3+t1*(v4+t1*(v5+t1*(v6+t1*(v7+v8*t1))))))  +  &
              s1*(v9+t1*(v10+t1*(v11+t1*(v12+t1*(v13+t1*(v14+t1*v15)))))+  &
                  sp5*(v16+t1*(v17+t1*(v18+t1*(v19+t1*v20)))            +  &
                       sp5*(v21+sp5*(v22+sp5*(v23+sp5*v24))             +  &
                       t1*(v25+t1*(v26+t1*(v27+t1*(v28+t1*v29))))))))
  else

     contemp_from_pottemp_point =                                          &
          c0*(c1+t1*(c2+t1*(c3+t1*(c4+t1*(c5+t1*(c6+(c7+c8*t1)*t1)))))   + &  
          s1*(c9+sp5*(c10+sp5*(c11+sp5*(c12+sp5*(c13+sp5*c14)))+t1*(c15  + &
          t1*(c16+t1*(c17+c18*t1))))+t1*(c19+t1*(c20+t1*(c21+t1*(c22+c23*t1))))))
  endif


end function contemp_from_pottemp_point
! </FUNCTION> NAME="contemp_from_pottemp_point"


!#######################################################################
! <FUNCTION NAME="pottemp_from_contemp_field">
!
! <DESCRIPTION>
!
! Compute potential temperature from conservative temperature 
! for all grid points. Perform one extra iteration to get 
! precision to near computer precision.  
!
! Input is salinity (psu) and conservative temperature (C).
!
! Use wrk1, wrk2, and wrk3 so to not take 3-d arrays from stack. 
! 
! </DESCRIPTION>
!
function pottemp_from_contemp_field (salinity, ct)

  real, dimension(isd:,jsd:,:), intent(in) :: salinity
  real, dimension(isd:,jsd:,:), intent(in) :: ct
  real, dimension(isd:ied,jsd:jed,nk)      :: pottemp_from_contemp_field

  integer :: i, j, k
  real    :: a5ct, b3ct, ct_factor
  real    :: th0_num, rec_th0_den

  if ( .not. module_is_initialized ) then
      call mpp_error(FATAL, '==>Error in ocean_tempsalt_mod (pottemp_from_contemp_field): module not initialized')
  endif

  if(pottemp_equal_contemp) then
     pottemp_from_contemp_field = ct
     return 
  endif 

  call mpp_clock_begin(id_clock_c2p_1)
  ! first estimate (let wrk1=th0 and wrk2=dth_dct) 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           a5ct        = a5*ct(i,j,k)
           b3ct        = b3*ct(i,j,k)
           ct_factor   = a3 + a4*salinity(i,j,k) + a5ct
           th0_num     = a0 + salinity(i,j,k)*(a1+a2*salinity(i,j,k)) + ct(i,j,k)*ct_factor
           rec_th0_den = 1.0 / ( b0 + b1*salinity(i,j,k) + ct(i,j,k)*(b2+b3ct) )
           wrk1(i,j,k) = th0_num*rec_th0_den
           wrk2(i,j,k) = ( ct_factor + a5ct - (b2+b3ct+b3ct)*wrk1(i,j,k) )*rec_th0_den        
        enddo
     enddo
  enddo
  call mpp_clock_end(id_clock_c2p_1)

  if(pottemp_2nd_iteration) then 

      ! TEOS-10 (via McDougall & Barker)uses a modified NR scheme. 
      ! The first iteration only adds half the increment 
      ! but then calculates a derivative here before performing a full update. 
      if (teos10) then

         wrk3                       = contemp_from_pottemp(salinity,wrk1) - ct  !CT_diff
         pottemp_from_contemp_field = wrk1 - 0.5* wrk3*wrk2                     ! ptm
         wrk2 = cp_ocean/((pottemp_from_contemp_field + kelvin )*dentropy_dtheta(salinity,pottemp_from_contemp_field)) !1/dCT_dpt

         pottemp_from_contemp_field = wrk1 - wrk3*wrk2                          ! pt_tmp end of first iteration.
         pottemp_from_contemp_field = pottemp_from_contemp_field -              &
             (contemp_from_pottemp(salinity,pottemp_from_contemp_field) - ct)*wrk2
      else

      ! second estimate to get precision to roundoff (let wrk3=ct0)
      wrk3                       = contemp_from_pottemp(salinity,wrk1)  
      pottemp_from_contemp_field = wrk1 - (wrk3-ct)*wrk2
      wrk2                       = cp_ocean &
           /( (pottemp_from_contemp_field + kelvin) * dentropy_dtheta(salinity,pottemp_from_contemp_field) )
      pottemp_from_contemp_field =  pottemp_from_contemp_field  &
           - (contemp_from_pottemp(salinity,pottemp_from_contemp_field) - ct)*wrk2
      endif

  else 

      pottemp_from_contemp_field = wrk1

  endif


end function pottemp_from_contemp_field
! </FUNCTION> NAME="pottemp_from_contemp_field"


!#######################################################################
! <FUNCTION NAME="pottemp_from_contemp_level">
!
! <DESCRIPTION>
!
! Compute potential temperature from conservative temperature 
! over a k-level. Perform one extra iteration to get 
! precision to near computer precision.
!
! Input is salinity (psu) and conservative temperature (C).
!
! </DESCRIPTION>
!
function pottemp_from_contemp_level(salinity, ct)

  real, dimension(isd:,jsd:), intent(in) :: salinity
  real, dimension(isd:,jsd:), intent(in) :: ct
  real, dimension(isd:ied,jsd:jed)       :: pottemp_from_contemp_level

  real,dimension(isd:ied,jsd:jed) :: th0
  real,dimension(isd:ied,jsd:jed) :: ct0
  real,dimension(isd:ied,jsd:jed) :: dth_dct
  real,dimension(isd:ied,jsd:jed) :: pt_tmp

  integer :: i, j
  real    :: a5ct, b3ct,ct_factor
  real    :: th0_num, rec_th0_den

  if ( .not. module_is_initialized ) then
      call mpp_error(FATAL, '==>Error in ocean_tempsalt_mod (ct_from_pt_level): module must be initialized')
  endif

  if(pottemp_equal_contemp) then
     pottemp_from_contemp_level = ct
     return 
  endif 

  do j=jsd,jed
     do i=isd,ied
        a5ct         = a5*ct(i,j)
        b3ct         = b3*ct(i,j)
        ct_factor    = a3 + a4*salinity(i,j) + a5ct
        th0_num      = a0 + salinity(i,j)*(a1+a2*salinity(i,j)) + ct(i,j)*ct_factor
        rec_th0_den  = 1.0 / ( b0+b1*salinity(i,j) + ct(i,j)*(b2+b3ct) )
        th0(i,j)     = th0_num*rec_th0_den
        dth_dct(i,j) = ( ct_factor + a5ct - (b2+b3ct+b3ct)*th0(i,j) )*rec_th0_den        
     enddo
  enddo

  ! second estimate to get precision to roundoff
  if(pottemp_2nd_iteration) then 

      !TEOS-10 (via McDougall & Barker) uses a modified NR scheme. 
      ! The first iteration only adds half the increment 
      ! but then calculates a derivative here before performing a full update. 
      if (teos10) then 
         ct0(:,:)                   = contemp_from_pottemp(salinity,th0)   
         pt_tmp = th0 - 0.5*(ct0-ct)*dth_dct                               ! 1/2 iteration
         dth_dct                    = cp_ocean &
           /( (pt_tmp + kelvin) * dentropy_dtheta(salinity,pt_tmp) )       ! Derivative at half iteration.
         pt_tmp = th0 - (ct0-ct)*dth_dct                                   ! full iteration
         pottemp_from_contemp_level = pt_tmp - (contemp_from_pottemp(salinity,pt_tmp) - ct)*dth_dct
      else
        ct0(:,:)                   = contemp_from_pottemp(salinity,th0)
        pottemp_from_contemp_level = th0 - (ct0-ct)*dth_dct
        dth_dct                    = cp_ocean &
           /( (pottemp_from_contemp_level + kelvin) * dentropy_dtheta(salinity,pottemp_from_contemp_level) )
        pottemp_from_contemp_level = pottemp_from_contemp_level &
           -(contemp_from_pottemp(salinity,pottemp_from_contemp_level) - ct)*dth_dct
      endif

  else 

      pottemp_from_contemp_level = th0

  endif

end function pottemp_from_contemp_level
! </FUNCTION> NAME="pottemp_from_contemp_level"


!#######################################################################
! <FUNCTION NAME="pottemp_from_contemp_point">
!
! <DESCRIPTION>
!
! Compute potential temperature from conservative temperature at a point.
! Perform one extra iteration to get precision to near computer precision.
!
! Input is salinity (psu) and conservative temperature (C).
!
! </DESCRIPTION>
!
function pottemp_from_contemp_point(salinity, ct)

  real, intent(in) :: salinity
  real, intent(in) :: ct
  real             :: pottemp_from_contemp_point

  real    :: a5ct, b3ct,ct_factor
  real    :: s1,th0_num,rec_th0_den
  real    :: th0, ct0, dth_dct, pt_tmp

  if ( .not. module_is_initialized ) then
      call mpp_error(FATAL, '==>Error in ocean_tempsalt_mod (ct_from_pt_point): module must be initialized')
  endif

  if(pottemp_equal_contemp) then
     pottemp_from_contemp_point = ct
     return 
  endif 


  s1          = salinity * sfact
  a5ct        = a5*ct
  b3ct        = b3*ct
  ct_factor   = a3 + a4*s1 + a5ct
  th0_num     = a0 + s1*(a1+a2*s1) + ct*ct_factor
  rec_th0_den = 1.0 / ( b0 + b1*s1 + ct*(b2+b3ct) )
  th0         = th0_num*rec_th0_den
  dth_dct     = ( ct_factor + a5ct - (b2+b3ct+b3ct)*th0 )*rec_th0_den

  ! second estimate to get precision to roundoff
  if(pottemp_2nd_iteration) then 

      !TEOS-10 Modified NR scheme according to McDougall & Barker.
      if (teos10) then
         ct0                        = contemp_from_pottemp(salinity,th0)
         pt_tmp                     = th0 - 0.5*(ct0-ct)*dth_dct
         dth_dct                    = cp_ocean /( (pt_tmp + kelvin) * dentropy_dtheta(salinity,pt_tmp) )
         pt_tmp                     = th0 - (ct0-ct)*dth_dct
         pottemp_from_contemp_point = pt_tmp -(contemp_from_pottemp(salinity,pt_tmp) - ct)*dth_dct
      else
         ct0                        = contemp_from_pottemp(salinity,th0)
         pottemp_from_contemp_point = th0 - (ct0-ct)*dth_dct
         dth_dct                    = cp_ocean &
           /( (pottemp_from_contemp_point + kelvin) * dentropy_dtheta(salinity,pottemp_from_contemp_point) )
         pottemp_from_contemp_point = pottemp_from_contemp_point &
           -(contemp_from_pottemp(salinity,pottemp_from_contemp_point) - ct)*dth_dct
      endif

  else 

      pottemp_from_contemp_point = th0

  endif


end function pottemp_from_contemp_point
! </FUNCTION> NAME="pottemp_from_contemp_point"



!#######################################################################
! <FUNCTION NAME="dentropy_dtheta_field">
!
! <DESCRIPTION>
!
!   d(entropy)/d(pottemp) at each grid point from twice differentiating 
!   the Gibbs potential in Feistel (2003), Prog. Ocean. 58, 43-114.
!   (pressure=0 since use potential temperature) 
!
!   salinity        : salinity (psu)
!   theta           : potential temperature (deg C, ITS-90)
!   dentropy_dtheta : d(entropy)/d(pottemp) J/(kg degC^2)
!
!   check value: dentropy_dtheta(35,20) = 13.63256369213874
!
! </DESCRIPTION>
!
function dentropy_dtheta_field(salinity,theta)

  real, dimension(isd:,jsd:,:), intent(in) :: salinity
  real, dimension(isd:,jsd:,:), intent(in) :: theta 
  real, dimension(isd:ied,jsd:jed,nk)      :: dentropy_dtheta_field

  integer :: i,j,k 
  real    :: x2, x, y, de_dt 

  if (teos10) then

     do k=1,nk
        do j=jsd,jed
           do i=isd,ied

              x2 = one_over_40*salinity(i,j,k)
              x  = sqrt(x2)
              y  = one_over_40*theta(i,j,k)
              de_dt= g1 + y*(g2 + y*(g3 + y*(g4+y*(g5+y*g6))))          + &
                   x2*(h1+x*(h2+x*(h3+y*(h4+y*(h5+y*h6))) + y*(h7+y*h8))+ &
                       y*(h9+y*(h10+y*(h11 +y*h12))))
              dentropy_dtheta_field(i,j,k) = (-one_over_1600)*de_dt
           enddo
        enddo
     enddo

  else

     do k=1,nk
        do j=jsd,jed
           do i=isd,ied

              x2 = one_over_40*salinity(i,j,k)
              x  = sqrt(x2)
              y  = one_over_40*theta(i,j,k)

              de_dt = f0 + x2*(f1 + x*(f2 + y*(f3  + f4*y)) + y*(f5 + y*(f6 + f7*y))) &
                         +  y*(f8 + y*(f9 + y*(f10 + (f11 - f12*y)*y)))

              dentropy_dtheta_field(i,j,k) = f13*de_dt

           enddo
        enddo
     enddo

  endif

end function dentropy_dtheta_field
! </FUNCTION> NAME="dentropy_dtheta_field"


!#######################################################################
! <FUNCTION NAME="dentropy_dtheta_level">
!
! <DESCRIPTION>
!
!   d(entropy)/d(pottemp) at k-level from twice differentiating 
!   the Gibbs potential in Feistel (2003), Prog. Ocean. 58, 43-114.
!   (pressure=0 since use potential temperature) 
!
!   salinity        : salinity (psu)
!   theta           : potential temperature (deg C, ITS-90)
!   dentropy_dtheta : d(entropy)/d(pottemp) J/(kg degC^2)
!
!   check value: dentropy_dtheta(35,20) = 13.63256369213874
!
! </DESCRIPTION>
!
function dentropy_dtheta_level(salinity,theta)

  real, dimension(isd:,jsd:), intent(in) :: salinity
  real, dimension(isd:,jsd:), intent(in) :: theta 
  real, dimension(isd:ied,jsd:jed)       :: dentropy_dtheta_level

  integer :: i,j 
  real    :: x2, x, y, de_dt 

  if (teos10) then

     do j=jsd,jed
        do i=isd,ied

           x2 = one_over_40*salinity(i,j)
           x  = sqrt(x2)
           y  = one_over_40*theta(i,j)
           de_dt= g1 + y*(g2 + y*(g3 + y*(g4+y*(g5+y*g6))))          + &
                x2*(h1+x*(h2+x*(h3+y*(h4+y*(h5+y*h6))) + y*(h7+y*h8))+ &
                    y*(h9+y*(h10+y*(h11 +y*h12))))
           dentropy_dtheta_level = (-one_over_1600)*de_dt
        enddo
     enddo


  else


     do j=jsd,jed
        do i=isd,ied
   
           x2 = one_over_40*salinity(i,j)
           x  = sqrt(x2)
           y  = one_over_40*theta(i,j)

           de_dt = f0 + x2*(f1 + x*(f2 + y*(f3  + f4*y)) + y*(f5 + y*(f6 + f7*y))) &
                      +  y*(f8 + y*(f9 + y*(f10 + (f11 - f12*y)*y)))
   
           dentropy_dtheta_level(i,j) = f13*de_dt

        enddo
     enddo

   endif

end function dentropy_dtheta_level
! </FUNCTION> NAME="dentropy_dtheta_level"


!#######################################################################
! <FUNCTION NAME="dentropy_dtheta_point">
!
! <DESCRIPTION>
!
!   d(entropy)/d(pottemp) at an (i,j,k) point from twice differentiating 
!   the Gibbs potential in Feistel (2003), Prog. Ocean. 58, 43-114.
!   (pressure=0 since use potential temperature) 
!
!   salinity        : salinity (psu)
!   theta           : potential temperature (deg C, ITS-90)
!   dentropy_dtheta : d(entropy)/d(pottemp) J/(kg degC^2)
!
!   check value: dentropy_dtheta(35,20) = 13.63256369213874
!
! </DESCRIPTION>
!
function dentropy_dtheta_point(salinity,theta)

  real, intent(in) :: salinity
  real, intent(in) :: theta 

  real :: dentropy_dtheta_point
  real :: x2, x, y, de_dt 

  x2 = one_over_40*sfac*salinity
  x  = sqrt(x2)
  y  = one_over_40*theta

  if (teos10) then
    de_dt= g1 + y*(g2 + y*(g3 + y*(g4+y*(g5+y*g6))))              + &
            x2*(h1+x*(h2+x*(h3+y*(h4+y*(h5+y*h6))) + y*(h7+y*h8)) + &
                 y*(h9+y*(h10+y*(h11 +y*h12))))
    dentropy_dtheta_point = (-one_over_1600)*de_dt
  else
     de_dt = f0 + x2*(f1 + x*(f2 + y*(f3  + f4*y)) + y*(f5 + y*(f6 + f7*y))) &
             +  y*(f8 + y*(f9 + y*(f10 + (f11 - f12*y)*y)))
     dentropy_dtheta_point = f13*de_dt
  endif 

end function dentropy_dtheta_point
! </FUNCTION> NAME="dentropy_dtheta_point"


!#######################################################################
! <SUBROUTINE NAME="tempsalt_check_range">
!
! <DESCRIPTION>
!
!   Check to see that temperature and salinity are within preset
!   range. If outside of the range, then bring the model down.
!
!   This check is particularly useful to ensure that the equation
!   of state is evaluated with physically sensible values of temp
!   and salinity.  
!
! </DESCRIPTION>
!
subroutine tempsalt_check_range(salinity,theta,depth)

  real, dimension(isd:,jsd:,:), intent(in) :: salinity
  real, dimension(isd:,jsd:,:), intent(in) :: theta 
  real, dimension(isd:,jsd:,:), intent(in) :: depth
  integer :: i,j,k
  
  character(len=512) :: err_msg

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           if(salinity(i,j,k) < s_min .or. salinity(i,j,k) > s_max) then
               write(err_msg,'(a,es22.12,a,i4,a1,i4,a1,i3,a,f10.4,a,f10.4,a,f10.4,a)')      &
               ' Error: salinity out of range with value ', salinity(i,j,k),                &
               ' at (i,j,k) = (',i+Dom%ioff,',',j+Dom%joff,',',k,                           &
               '),  (lon,lat,dpt) = (',Grd%xt(i,j),',',                                     &
               Grd%yt(i,j),',', depth(i,j,k),' m)'
               call mpp_error(FATAL, trim(err_msg))
           endif 
           if(theta(i,j,k) < t_min .or. theta(i,j,k) > t_max) then
               write(err_msg,'(a,es22.12,a,i4,a1,i4,a1,i3,a,f10.4,a,f10.4,a,f10.4,a)')      &
               ' Error: temperature out of range with value ', theta(i,j,k),                &
               ' at (i,j,k) = (',i+Dom%ioff,',',j+Dom%joff,',',k,                           &
               '),  (lon,lat,dpt) = (',Grd%xt(i,j),',',                                     &
               Grd%yt(i,j),',', depth(i,j,k),' m)'
               call mpp_error(FATAL, trim(err_msg))
           endif
        enddo
     enddo
  enddo


end subroutine tempsalt_check_range
! </SUBROUTINE> NAME="tempsalt_check_range"



end module ocean_tempsalt_mod

!VERSION NUMBER:
!  $Id: donner_utilities_k.F90,v 19.0 2012/01/06 20:08:36 fms Exp $

!module donner_utilities_inter_mod

!#include "donner_utilities_interfaces.h"

!end module donner_utilities_inter_mod



!module donner_types_mod

!#include "donner_types.h"

!end module donner_types_inter_mod


!#####################################################################

subroutine don_u_set_column_integral_k   &
         (nk, x_in, ptop, pbot, int_value, p_in, intgl_in, intgl_out, &
          x_out, ermesg, error)

!--------------------------------------------------------------------
!    subroutine don_u_set_column_integral_k modifies the input
!    profile x_in of size nk with column integral intgl_in to produce an
!    output profile x_out, also of size nk, whose column integral 
!    intgl_out has the specified value int_value. 
!    the integral constraint is satisfied by defining a constant cont-
!    ribution to the column integral between pbot and ptop, which 
!    balances the contribution from the rest of the profile. currently
!    the x_in profile has non-zero values only above ptop; if x_in has
!    non-zero values below ptop, the algorithm must be changed in order
!    to work properly.
!    NOTE: currently pbot is by default the surface pressure. this needs
!    to be generalized.
!    any error message is returned in ermesg.
!    "Verav notes 1/7/04" (available from Leo Donner) explain this 
!    routine in more detail, especially the procedures used to enforce 
!    the integral constraint.
!--------------------------------------------------------------------

implicit none

integer,               intent(in)    ::  nk
real, dimension(nk),   intent(in)    ::  x_in
real,                  intent(in)    ::  ptop, pbot, int_value        
real, dimension(nk+1), intent(in)    ::  p_in
real,                  intent(out)   ::  intgl_in, intgl_out
real, dimension(nk),   intent(out)   ::  x_out
character(len=*),      intent(out)   ::  ermesg
integer,               intent(out)   ::  error

!--------------------------------------------------------------------
!  intent(in) variables:
!  
!     nk        size of input profile
!     x_in      profile on lo-res model grid whose column integral 
!               is adjusted
!     ptop      pressure at top of region where integrand is 
!               adjusted [ Pa ] 
!     pbot      pressure at bottom of region where integrand is
!               adjusted[ Pa ]
!     int_value value desired for column integral of output field
!     p_in      lo-res model interface pressure levels [ Pa ]
!
!  intent(out) variables:
!
!     intgl_in  column integral of input field x_in [ units of x_in ]
!     intgl_out column integral of output field x_out [ units of x_in ]
!     x_out     vertical profile of x_in, after adjustment of values
!               at levels between pbot and ptop to produce column 
!               integral with value of int_value 
!     ermesg    error message, if error is encountered
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

     real    :: int_above !  contribution to column integral from layers
                          !  fully above adjustment region
     real    :: int_needed_below 
                          !  integrand contribution from the adjustment
                          !  layer that is required to balance the 
                          !  remainder of the profile
     real    :: int_below !  contribution to column integral after 
                          !  adjustment that comes from layers fully 
                          !  within the adjustment layer
     integer :: k         !  do-loop index


!----------------------------------------------------------------------
!    initialize the error message character string.
!----------------------------------------------------------------------
      ermesg = '  ' ; error = 0

!----------------------------------------------------------------------
!    obtain the total column integrand (column) and the partial integ-
!    rand from layers completely above the adjustment layer (int_above) 
!    of the input quantity (x_in). 
!----------------------------------------------------------------------
      intgl_in = 0.
      int_above = 0.
      do k=1,nk              
        intgl_in = intgl_in + x_in(k)*(p_in(k) - p_in(k+1))
        if (p_in(k) <= ptop)  then
          int_above = int_above + x_in(k)*(p_in(k) - p_in(k+1))
        endif
      end do

!----------------------------------------------------------------------
!    define the value of the integrand needed from the adjustment layer
!    (int_needed_below). it is the negative of the column sum divided 
!    by the total delta p between pbot and ptop.
!----------------------------------------------------------------------
      int_needed_below = int_value - intgl_in/(pbot - ptop)

!----------------------------------------------------------------------
!    begin loop assigning new value to output variable in layers
!    completely or partially in the adjustment layer.
!----------------------------------------------------------------------
      do k=1,nk              

!---------------------------------------------------------------------
!    case of layer being completely in adjustment layer. define the 
!    output variable value as int_needed_below.
!---------------------------------------------------------------------
        if (p_in(k+1) >= ptop) then
          x_out(k) = int_needed_below
         
!---------------------------------------------------------------------
!    case of layer straddling top of adjustment layer.
!---------------------------------------------------------------------
        else if (p_in(k+1) < ptop )  then

!----------------------------------------------------------------------
!    define the amount of the needed adjustment layer value that has 
!    been assigned to the layers fully in the adjustment layer 
!    (int_below).
!----------------------------------------------------------------------
          int_below = int_needed_below*(pbot - p_in(k))

!----------------------------------------------------------------------
!    define the portion of the column sum which must be assigned to 
!    this layer straddling the top of the adjustment layer in order
!    to obtain a value of int_value for the column integral; ie, that 
!    which is needed to balance the contributions from above (int_above)
!    and from below (int_below) this layer.
!----------------------------------------------------------------------
          x_out(k) = (int_value -int_above - int_below)/  &
                                                  (p_in(k) - p_in(k+1)) 

!---------------------------------------------------------------------
!    case of layer completely above adjustment layer. define the output
!    field as equal to the input field at this and all higher levels; 
!    then exit the loop. 
!---------------------------------------------------------------------
          x_out(k+1:) = x_in(k+1:)
          exit
        endif
      end do

!---------------------------------------------------------------------
!    recalculate the column sum of the conservative quantity. it should
!    now be of order machine roundoff. return value to calling routine.
!---------------------------------------------------------------------
      intgl_out = 0.
      do k=1,nk              
        intgl_out = intgl_out + x_out(k)*(p_in(k) - p_in(k+1))
      end do

!----------------------------------------------------------------------


end subroutine don_u_set_column_integral_k

!#####################################################################

subroutine don_u_map_hires_c_to_lores_c_k   &
         (n_gcm, n_clo, x_clo, p_clo, ptop, p_gcm, x_gcm, intgl_clo,  &
          intgl_gcm, ermesg, error)

!--------------------------------------------------------------------
!    subroutine don_u_map_hires_c_to_lores_c_k maps the vertical
!    profile between cloud base and and a specified upper pressure level
!    (ptop) of a variable (x_clo) of size n_clo on the cloud-model 
!    vertical grid (p_clo) to a GCM vertical grid (p_gcm) of size 
!    n_gcm. the output profile is x_gcm.
!    vertical integrals on the cloud grid (intgl_clo) and on the 
!    GCM grid (intgl_gcm) are also returned, so that the profile 
!    mapping may be shown to be conservative.
!    any error message is returned in ermesg.
!    "Verav notes 1/7/04" (available from Leo Donner) explain this 
!    routine in more detail. 
!    The routine can handle grid thicknesses of arbitrary size for
!    both the cloud grid and GCM grid. there is no restriction as
!    to the relative sizes of the grids.
!--------------------------------------------------------------------
!    GCM grid:
!     
!     -------------- p_gcm(n_gcm+1)
!     -------------- x_gcm(n_gcm)
!     -------------- p_gcm(n_gcm-1)
!           ...
!     -------------- p_gcm(k+1)
!     -------------- p_gcm(k)
!     -------------- p_gcm(k-1)
!           ...
!     -------------- p_gcm(2)
!     -------------- x_gcm(1)
!     -------------- p_gcm(1)
!
!     Cloud-Model grid:
!
!     -------------- p_clo(n_clo)=pcloha(n_clo) (cloud top)
!     -------------- p_cloha(n_clo-1)
!     -------------- p_clo(n_clo-1)
!           ...   
!     -------------- p_clo(k2)
!     -------------- p_cloha(k2-1)
!     -------------- p_clo(k2-1)
!           ...
!     -------------- p_clo(2)
!     -------------- p_cloha(1)
!     -------------- p_clo(1)  (cloud base)
!--------------------------------------------------------------------   


implicit none

integer,                  intent(in)  :: n_gcm, n_clo
real, dimension(n_clo),   intent(in)  :: x_clo, p_clo
real,                     intent(in)  :: ptop
real, dimension(n_gcm+1), intent(in)  :: p_gcm
real, dimension(n_gcm),   intent(out) :: x_gcm
real,                     intent(out) :: intgl_clo, intgl_gcm
character(len=*),         intent(out) :: ermesg
integer,                  intent(out) :: error

!--------------------------------------------------------------------
!   intent(in) variables:
!
!        n_gcm        number of layers in GCM 
!        n_clo        number of layers in cloud model
!        x_clo        vertical profile of variable on cloud-model grid
!        p_clo        cloud-model pressure profile
!        ptop         pressure denoting top of region of interest [ Pa ]
!        p_gcm        pressure half levels in GCM [ Pa ]
!
!    intent(out) variables:
!
!        x_gcm        vertical profile of variable on GCM vertical grid
!        intgl_clo    vertical integral of variable on cloud-model grid
!        intgl_gcm    vertical integral of variable on GCM grid
!        ermesg       error message, if error is encountered
!
!---------------------------------------------------------------------

!----------------------------------------------------------------------
!  local variables:

      real, dimension(n_clo)  ::  pcloha
      real                    ::  rint, p_upper, p_lower, ptopa 
      integer                 ::  k2start
      integer                 ::  k, k2

!----------------------------------------------------------------------
!  local variables:
!
!     pcloha           pressures at mid-layers in cloud grid [ Pa ]
!     rint             accumulates pressure-weighted sum of input 
!                      variable over the cloud-model layers which over-
!                      lap a given GCM grid layer
!     p_upper          pressure at upper limit (farthest from ground) 
!                      of the current sub-layer [ Pa ]
!     p_lower          pressure at lower limit (closest to ground) of
!                      the current sub-layer [ Pa ]
!     ptopa            uppermost (farthest from ground) pressure value 
!                      on cloud grid
!     k2start          cloud-model vertical index of lowest cloud-model
!                      layer overlapping the current or next gcm layer
!     k, k2            do-loop indices
!
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!    initialize the error message character string.
!----------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!--------------------------------------------------------------------
!    define the lowest k index of the cloud model which overlaps the
!    first gcm layer (k2start). initialize the integral over pressure 
!    of the output field on the gcm grid (intgl_gcm). define the lowest
!    pressure at which the fields will have non-zero values as the 
!    pressure at the top of the cloud model (ptopa). define the 
!    bottommost pressure at which cloud is present (p_lower) as the 
!    pressure at cloud base.
!--------------------------------------------------------------------

      k2start  = 1
      intgl_gcm = 0.
      ptopa = MAX (p_clo(n_clo), ptop)
      p_lower = p_clo(1) 

!--------------------------------------------------------------------
!    define the interface pressures on the cloud grid. cloud base is 
!    defined to be at the midpoint of a cloud layer.
!--------------------------------------------------------------------
      do k2=1,n_clo-1
        pcloha(k2) = 0.5*(p_clo(k2) + p_clo(k2+1))
      end do
      pcloha(n_clo) = p_clo(n_clo)

!--------------------------------------------------------------------
!    march upward through gcm model layers until cloud base is found. 
!    calculate the output profile on the gcm grid. 
!--------------------------------------------------------------------
      do k=1,n_gcm

!--------------------------------------------------------------------
!    check if this gcm layer has any overlap with the cloud. if it does,
!    initialize the output field in this layer to be 0.0.
!--------------------------------------------------------------------
        if (p_gcm(k) > ptopa .and. p_lower > p_gcm(k+1)) then
          rint = 0.

!--------------------------------------------------------------------
!    march through the cloud model layers which overlap this gcm
!    layer.
!--------------------------------------------------------------------
          do k2=k2start,n_clo-1

!---------------------------------------------------------------------
!    define the topmost pressure in this gcm layer for which the 
!    current cloud model layer value will apply (p_upper). it will be 
!    the larger of the cloud top pressure, the pressure at the top of
!    the gcm layer, or the pressure at the top interface of the current
!    cloud layer.
!---------------------------------------------------------------------
            p_upper = MAX (ptopa, p_gcm(k+1), pcloha(k2))

!---------------------------------------------------------------------
!    define the contribution to the current gcm layer from this cloud 
!    layer, weighted by the pressure depth over which it applies.     
!---------------------------------------------------------------------
            rint = rint + x_clo(k2)*(p_lower - p_upper)

!--------------------------------------------------------------------
!    define the pressure at the bottom of the next layer to be 
!    processed as the pressure at the top of the current layer. if 
!    either the next gcm layer or cloud top has been reached, save the 
!    cloud model layer index and exit this loop. otherwise, there are
!    additional cloud model layer(s) contributing to the integral at
!    this GCM level. Cycle through the loop, adding the remaining
!    contributions.
!--------------------------------------------------------------------
            p_lower = p_upper
            if (p_upper /= pcloha(k2)) then
              k2start = k2
              exit
            endif
          end do

!--------------------------------------------------------------------
!    define the output variable at this gcm level and add the contrib-
!    ution to the integral from this layer to the integrand.
!--------------------------------------------------------------------
          x_gcm(k) = rint/(p_gcm(k) - p_gcm(k+1))
          intgl_gcm = intgl_gcm + rint

!---------------------------------------------------------------------
!    if this gcm layer does not overlap the cloud, define its value to
!    be 0.0.
!---------------------------------------------------------------------
        else
          x_gcm(k) = 0.
        endif   
      end do

!--------------------------------------------------------------------
!    evaluate integral over pressure at cloud-model resolution.
!--------------------------------------------------------------------
      p_upper = max (pcloha(1), ptopa)
      intgl_clo = x_clo(1)*(p_clo(1) - p_upper)
      do k2=1,n_clo 
        p_upper = max (pcloha(k2+1), ptopa)
        intgl_clo = intgl_clo + x_clo(k2+1)*(pcloha(k2) - p_upper)
        if (pcloha(k2+1) <= ptopa) exit
      end do

!--------------------------------------------------------------------


end subroutine don_u_map_hires_c_to_lores_c_k



!#####################################################################

subroutine don_u_compare_integrals_k    &
         (hi_res_intgl, lo_res_intgl, diag_unit, ermesg, error)

!---------------------------------------------------------------------
!    subroutine don_u_compare_integrals_k determines if two 
!    input vertical integrals, computed on different grids may be 
!    considered equal, after allowing for the roundoff differences 
!    inherent in their calculation.
!    any error message is returned in ermesg.
!---------------------------------------------------------------------

implicit none

real,               intent(in)  :: hi_res_intgl, lo_res_intgl
integer,            intent(in)  :: diag_unit 
character(len=*),   intent(out) :: ermesg
integer,            intent(out) :: error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!        hi_res_intgl    integral calculated on higher resolution 
!                        vertical grid
!        lo_res_intgl    integral calculated on lower resolution 
!                        vertical grid
!        diag_unit       unit number of column diagnostics file to 
!                        which output message is written
!
!   intent(out) variables:
!
!        ermesg          error message, if error is encountered
!
!----------------------------------------------------------------------
      
!---------------------------------------------------------------------
!   local variables:

      integer    :: inteq  ! flag indicating status of integral equality

!----------------------------------------------------------------------
!    initialize the error message character string.
!----------------------------------------------------------------------
      ermesg = '  ' ; error = 0

!---------------------------------------------------------------------
!    call don_u_integrals_are_equal_k to determine the 
!    equality of hi_res_intgl and lo_res_intgl. the return flag inteq
!    will be 0 if the integrals may be considered equal. if it is 
!    non-zero, then it may indicate that the mapping of vertical 
!    integrals between the hi- and lo-resolution grids should be exam-
!    ined, or that the roundoff in the offending integral may simply be 
!    slightly larger than the current tolerance, perhaps due to the 
!    nature of the integral.
!---------------------------------------------------------------------
      call don_u_integrals_are_equal_k    &
                      (hi_res_intgl, lo_res_intgl, ermesg, error, inteq)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!-----------------------------------------------------------------------
!    output a warning message to the column diagnostics output file if
!    the integral equality test produces suspicious results.
!-----------------------------------------------------------------------
      if (inteq /= 0) then
        write (diag_unit, '(a)')  &
           'WARNING: cloud model and ls model intgls differ &
                     &non-trivially  -- perhaps significantally ?'
      endif

!---------------------------------------------------------------------


end subroutine don_u_compare_integrals_k 


!######################################################################

subroutine don_u_apply_integral_source_k      &
         (nk, x_in, ptop, pbot, src, p_in, i_in, i_out, x_out, ermesg, error)

!----------------------------------------------------------------------
!    subroutine don_u_apply_integral_source_k adds a specified
!    value src to the input field x_in of size nk on a pressure grid 
!    p_in between pressure levels pbot and ptop, resulting in a change 
!    of column integral of the field from i_in to i_out, and producing 
!    the output field x_out.
!    NOTE: currently pbot is by default the surface pressure. this needs
!    to be generalized.
!    any error message is returned in ermesg.
!----------------------------------------------------------------------

implicit none

integer,               intent(in)    :: nk
real, dimension(nk),   intent(in)    :: x_in
real,                  intent(in)    :: ptop, pbot, src
real, dimension(nk+1), intent(in)    :: p_in
real,                  intent(out)   :: i_in, i_out
real, dimension(nk),   intent(out)   :: x_out
character(len=*),      intent(out)   :: ermesg
integer,               intent(out)   :: error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      nk        size of input profile
!      x_in      variable to which the integral source src is to
!                be applied [ units of x_in ]
!      ptop      topmost pressure at which src is applied [ Pa ] 
!      pbot      bottommost pressure at which src is applied [ Pa ] 
!      src       integral source to be applied to variable x_in
!      p_in      interface pressure levels of grid of x_in [ Pa ]
!
!   intent(out) variables:
!
!      i_in      column integral of input variable x_in 
!                [ units of x_in * Pa ]
!      i_out     column integral of output variable x_out
!                [ units of x_in * Pa ]
!      x_out     variable field after the source integral is applied
!                [ units of x_in ]
!      ermesg    error message, if error is encountered
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:
!
      integer   :: k      ! do_loop index

!----------------------------------------------------------------------
!    initialize the error message character string.
!----------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!---------------------------------------------------------------------
!    compute the column integral (i_in) of the input field x_in.
!---------------------------------------------------------------------
      i_in = 0.
      do k=1,nk              
        i_in = i_in + x_in(k)*(p_in(k) - p_in(k+1))
      end do

!----------------------------------------------------------------------
!    apply the integral source src to each layer in the specified 
!    region. for layers fully included, add src to the existing value. 
!    for the layer containing the top of the specified region, add the 
!    value of src appropriately pressure-weighted. NOTE: this source WAS
!    applied ONLY to the layer straddling the top of the region; it was
!    not applied below cloud base. I HAVE MODIFIED THIS CODE SO THAT THE
!    VALUE IS APPLIED FROM SFC TO TOP OF SPECIFIED REGION (CLOUD BASE)
!    IS THIS CORRECT AND WHAT WAS INTENDED ?? 
!----------------------------------------------------------------------
      do k=1,nk              
        if (p_in(k+1) >= ptop ) then                   
          x_out(k) = x_in(k) + src
        else if (p_in(k+1) < ptop .and. p_in(k) > ptop)  then
          x_out(k) = x_in(k) + (src/(p_in(k) - p_in(k+1))*  &
                                           (p_in(k) - ptop))
          x_out(k+1:) = x_in(k+1:)
          exit
        endif
      end do

!---------------------------------------------------------------------
!    compute the column integral (i_out) of the output field x_out.
!---------------------------------------------------------------------
      i_out = 0.
      do k=1,nk              
        i_out = i_out + x_out(k)*(p_in(k) - p_in(k+1))
      end do

!--------------------------------------------------------------------



end subroutine don_u_apply_integral_source_k


!#####################################################################

subroutine don_u_integrals_are_equal_k    &
         (x, y, ermesg, error, inteq)

!--------------------------------------------------------------------
!    subroutine don_u_integrals_are_equal_k determines if two 
!    integrals x and y are within a roundoff tolerance eps_i of one 
!    another. it computes the difference x - y, and returns inteq, which
!    is given a value of -10 if (x - y) < -eps_i, a value of 10 if 
!    (x - y) > eps_i, and a value of 0 if ABS (x - y) < eps_i. 
!    any error message is returned in ermesg.
!--------------------------------------------------------------------

implicit none

real,               intent(in)   :: x, y
character(len=*),   intent(out)  :: ermesg
integer,            intent(out)  :: error, inteq

!---------------------------------------------------------------------
!   intent (in) variables:
!
!          x        first variable
!          y        second variable
!
!   intent(out) variables:
!
!          ermesg    error message, if error is encountered
!          inteq      ==   0 if x = y, within a tolerance of eps_i
!                     ==  10 if x > y by at least eps_i
!                     == -10 if x < y by at least eps_i
!
!---------------------------------------------------------------------
      
real, PARAMETER  :: eps_i = 1.0e-12 ! roundoff tolerance for equality of
                                    ! two vertical integrals; if the 
                                    ! magnitude of the numerical differ-
                                    ! ence between two integrals is 
                                    ! smaller than eps_i, they are 
                                    ! assumed equal by function 
                                    ! integrals_are_equal.

!----------------------------------------------------------------------
!    initialize the error message character string.
!----------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!--------------------------------------------------------------------
!    if the integral values are "large", then compare the ratio of
!    integral difference to integral value to the tolerance eps_i, 
!    since the difference itself could be much larger than the toler-
!    ance and still be roundoff. 
!--------------------------------------------------------------------
      if (ABS(x) > 1.0) then

!--------------------------------------------------------------------
!    define integrals_are_equal dependent on the relationship between 
!    (x - y) and eps_i.
!--------------------------------------------------------------------
        if ( (x - y)/ ABS(x) > eps_i) then
          inteq = 10
        else if ( (x - y)/ABS(x) < -eps_i) then
          inteq = -10
        else
          inteq = 0
        endif

!--------------------------------------------------------------------
!    if the integral values are "small", simply compare their difference
!    to the tolerance, since as the integral magnitudes approach zero,
!    the ratio of difference / magnitude could become quite large and 
!    still only represent roundoff error. 
!--------------------------------------------------------------------
      else

!--------------------------------------------------------------------
!    define integrals_are_equal dependent on the relationship between 
!    (x - y) and eps_i.
!--------------------------------------------------------------------
        if ( (x - y) > eps_i) then
          inteq = 10
        else if ( (x - y) < -eps_i) then
          inteq = -10
        else
          inteq = 0
        endif
      endif

!-------------------------------------------------------------------


end subroutine don_u_integrals_are_equal_k





!#####################################################################



!######################################################################

subroutine don_u_map_hires_i_to_lores_c_k    &
         (n_lo, intgl_hi, pbot, ptop, p_lo, x_lo, ermesg, error)

!------------------------------------------------------------------
!    subroutine don_u_map_hires_i_to_lores_c_k assigns
!    an integral quantity defined on a high-res grid (intgl_hi), valid 
!    over a specified pressure depth (pbot, ptop), to the elements of an 
!    array (x_lo) of size n_lo on a lower resolution grid (p_lo).
!    any error message is returned in ermesg.
!------------------------------------------------------------------

implicit none

integer,                  intent(in)     :: n_lo
real,                     intent(in)     :: intgl_hi, pbot, ptop
real, dimension(n_lo+1),  intent(in)     :: p_lo
real, dimension(n_lo),    intent(out)    :: x_lo
character(len=*),         intent(out)    :: ermesg
integer,                  intent(out)    :: error

!------------------------------------------------------------------
!   intent(in) variables:
!
!       n_lo       size of output profile x_lo
!       intgl_hi   input integral from hi-res model
!                  [ units of intgl_hi ]
!       pbot       pressure at bottom of integral's extent [ Pa ]
!       ptop       pressure at top of integral's extent  [ Pa ]
!       p_lo       lo-res model interface pressure levels [ Pa ]
!
!   intent(out) variables:
!
!       x_lo       values of integrand at lo-res model levels
!                  [ units of intgl_hi ]
!       ermesg     error message, if error is encountered
!
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!   local variables:
!
      integer :: k    ! do-loop index

!----------------------------------------------------------------------
!    initialize the error message character string.
!----------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!---------------------------------------------------------------------
!    verify that the specified pressure limits are reasonable. if not,
!    define an error message and return.
!---------------------------------------------------------------------
      if ( pbot < ptop ) then
        ermesg = ' input pressure pbot is less than input pressure ptop'
        error = 1
        return
      endif

!---------------------------------------------------------------------
!    assign the proper value to each large-scale model level.
!---------------------------------------------------------------------
      do k=1,n_lo            

!---------------------------------------------------------------------
!    case of bottom of lo-res model layer being within the integral's 
!    specified region.
!---------------------------------------------------------------------
        if (pbot > p_lo(k))  then 

!---------------------------------------------------------------------
!    case of top of lo-res model layer being above the integral's
!    specfied topmost pressure. in such case all lo-res model levels 
!    above are assigned values of 0.0 and the loop exited.
!---------------------------------------------------------------------
          if (ptop >= p_lo(k))  then
            x_lo(k:) = 0.
            exit

!---------------------------------------------------------------------
!    case of lo-res model layer being completely within the integral's
!    specified region.
!---------------------------------------------------------------------
          else if ( ptop <  p_lo(k+1) )  then 
            x_lo(k) = intgl_hi

!---------------------------------------------------------------------
!    case of lo-res model layer extending above the top of the integ-
!    ral's specified region. in such case, only the portion of the
!    integral contained within the appropriate pressure fraction of
!    the lo-res model layer is assigned to the output field.
!---------------------------------------------------------------------
          else
            x_lo(k) = intgl_hi*(p_lo(k) - ptop)/(p_lo(k) - p_lo(k+1))
          endif

!---------------------------------------------------------------------
!    case of bottom of lo-res model layer being below the integral's
!    specified region.
!---------------------------------------------------------------------
        else

!---------------------------------------------------------------------
!    case of top of lo-res model layer being below the integral's
!    specified region. in this case, lo-res model layer is completely
!    outside the integral's range and is assigned a value of 0.0.
!---------------------------------------------------------------------
          if (pbot <= p_lo(k+1)) then
            x_lo(k) = 0.

!---------------------------------------------------------------------
!    case of bottom of lo-res model layer being below and top of lo-res
!    model layer being above integral's specified region. in such case,
!    only the portion of the integral contained within the appropriate 
!    pressure fraction of the lo-res model layer is assigned to the 
!    output field. values at levels above this are assigned values of
!    0.0 and the loop exited.
!---------------------------------------------------------------------
          else if (ptop >  p_lo(k+1))  then
            x_lo(k) = intgl_hi*(pbot - ptop)/(p_lo(k) - p_lo(k+1))
            x_lo(k+1:) = 0.
            exit

!---------------------------------------------------------------------
!    case of bottom of lo-res model layer being below bottom of 
!    integral's specified region and top of lo-res model layer being
!    below top of integral's specified region. in such case, only the 
!    portion of the integral contained within the appropriate pressure 
!    fraction of the lo-res model layer is assigned to the output field.
!---------------------------------------------------------------------
          else if (ptop <= p_lo(k+1) )  then
            x_lo(k) = intgl_hi*(pbot - p_lo(k+1))/(p_lo(k) - p_lo(k+1))
          endif
        endif
      end do

!--------------------------------------------------------------------



end subroutine don_u_map_hires_i_to_lores_c_k



!######################################################################


subroutine don_u_numbers_are_equal_k                    &
         (x, y, ermesg, error, numeq)

!--------------------------------------------------------------------
!    subroutine don_u_numbers_are_equal_k determines if two 
!    numbers x and y are within a roundoff tolerance eps_n of one 
!    another. it computes the difference x - y, and returns a value numeq
!    which is -10 if (x - y) < -eps_n, 10 if (x - y) > eps_n, and 0 if 
!    ABS (x - y) < eps_n. 
!    any error message is returned in ermesg.
!--------------------------------------------------------------------

implicit none

real,               intent(in)  :: x, y
character(len=*),   intent(out) :: ermesg
integer,            intent(out) :: error, numeq

!---------------------------------------------------------------------
!   intent (in) variables:
!
!          x       first variable
!          y       second variable
!
!   intent (out) variables:
!
!          ermesg  error message, if error is encountered
!          numeq   ==   0 if x = y, within a tolerance of eps_n
!                  ==  10 if x > y by at least eps_n
!                  == -10 if x < y by at least eps_n
!
!---------------------------------------------------------------------
      
real, PARAMETER  :: eps_n = 1.0e-13 ! roundoff tolerance for equality 
                                    ! of two real numbers; if the mag-
                                    ! nitude of the numerical difference
                                    ! between two numbers is smaller than
                                    ! eps_n, they are assumed equal by 
                                    ! function numbers_are_equal.


!----------------------------------------------------------------------
!    initialize the error message character string.
!----------------------------------------------------------------------
      ermesg = '  ' ; error = 0

!--------------------------------------------------------------------
!    define numbers_are_equal based on the relationship between 
!    (x - y) and eps_n.
!--------------------------------------------------------------------
      if ( (x - y) > eps_n) then
        numeq = 10
      else if ( (x - y) < -eps_n) then
        numeq = -10
      else
        numeq = 0
      endif

!-------------------------------------------------------------------


end subroutine don_u_numbers_are_equal_k


!#####################################################################




!interface donner_utilities_map_lo_res_col_to_hi_res_col_k

!     subroutine donner_utilities_lo1d_to_hi1d_k     
!     subroutine donner_utilities_lo1d_to_hi0d_linear_k 
!     subroutine donner_utilities_lo1d_to_hi0d_log_k    

!end interface donner_utilities_map_lo_res_col_to_hi_res_col_k

subroutine don_u_lo1d_to_hi1d_k     &
         (n_lo, n_hi, x_lo, p_lo, p_hi, x_hi, ermesg, error)                

!------------------------------------------------------------------
!    subroutine don_u_lo1d_to_hi1d_k interpolates the input 
!    field x_lo of size n_lo on pressure grid p_lo to produce an output 
!    field x_hi of size n_hi on a pressure grid p_hi. 
!    NOTE: vertical index 1 is closest to the ground in all arrays
!    used here.
!    any error message is returned in ermesg.
!------------------------------------------------------------------
 
implicit none

integer,                  intent(in)    :: n_lo, n_hi
real, dimension(n_lo),    intent(in)    :: x_lo
real, dimension(n_lo+1),  intent(in)    :: p_lo
real, dimension(n_hi),    intent(in)    :: p_hi
real, dimension(n_hi),    intent(out)   :: x_hi
character(len=*),         intent(out)   :: ermesg
integer,                  intent(out)   :: error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!     n_lo          size of lo-res profile
!     n_hi          size of hi-res profile
!     x_lo          field to be interpolated on lo-res pressure grid
!                   [ units of x_lo ]
!     p_lo          lo-res pressure grid [ Pa ]
!     p_hi          hi-res pressure grid [ Pa ]
!     
!  intent(out) variables:
!
!     x_hi          value of field at pressure p_hi
!                   [ units of x_lo ]
!     ermesg        error message, if error is encountered
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:

      integer :: kkstart            !  k index at which to start search
                                    !  for input field value
      integer :: k, kk              !  do-loop indices

!----------------------------------------------------------------------
!    initialize the error message character string.
!----------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!--------------------------------------------------------------------
!    define the k index in the low resolution grid (index 1 nearest
!    surface) at which to begin searching for the cape model pressure 
!    value.
!--------------------------------------------------------------------
      kkstart = 1

!-------------------------------------------------------------------
!    for each pressure level of the high resolution grid, find the low 
!    resolution pressure levels that bracket it. when found, use linear
!    interpolation to define the field value at the high resolution grid
!    pressure level. if it is beyond either end of the low resolution
!    grid, obtain a value at the high resolution pressure value by 
!    extrapolating the gradient at the low level grid boundary.
!----------------------------------------------------------------------
      do k=1,n_hi           

!--------------------------------------------------------------------
!    if the requested hi-res model pressure is greater than the lowest 
!    lo-res model pressure, obtain the field value at the hi-res pres-
!    sure by extrapolating the lo-res model gradient.
!---------------------------------------------------------------------
        if (p_hi(k) > p_lo(1)) then
          x_hi(k) = x_lo(1) + (p_hi(k) - p_lo(1))* &
                          ((x_lo(2) - x_lo(1))/(p_lo(2) - p_lo(1)))

!---------------------------------------------------------------------
!    if the requested hi-res model pressure is less than the highest 
!    lo-res model pressure, obtain the field value at the hi-res pres-
!    sure by extrapolating the lo-res model gradient.
!---------------------------------------------------------------------
        else if (p_hi(k) < p_lo(n_lo)) then
            x_hi(k) =  x_lo(n_lo) + (p_hi(k) - p_lo(n_lo))*   &
                            ((x_lo(n_lo) - x_lo(n_lo-1))/  &
                             (p_lo(n_lo) - p_lo(n_lo-1)))

!---------------------------------------------------------------------
!    if the requested hi-res model pressure level lies within the bounds
!    of the lo-res model pressure profile, march through the  lo-res
!    profile until the desired hi-res model pressure is reached. define
!    the hi-res field value by interpolating to the hi-res model pres-
!    sure. define the lo-res model starting level index to be used in
!    the search for the next desired hi-res pressure (kkstart), and 
!    exit the vertical loop.
!---------------------------------------------------------------------
        else
          do kk=kkstart,n_lo-1
            if (p_hi(k) >= p_lo(kk+1)) then
              x_hi(k) = x_lo(kk+1) + (p_hi(k) - p_lo(kk+1))* &
                             ((x_lo(kk+1) - x_lo(kk))/  &
                              (p_lo(kk+1) - p_lo(kk)))
              kkstart = kk
              exit
            endif
          end do
        endif
      end do

!---------------------------------------------------------------------


end subroutine don_u_lo1d_to_hi1d_k  


!#####################################################################

subroutine don_u_lo1d_to_hi0d_linear_k  &
         (n_lo, x_lo, p_lo, p_hi, x_hi, ermesg, error)


!--------------------------------------------------------------------
!    subroutine lo1d_to_hi0d linearly interpolates within the 1d input 
!    field x_lo on 1d pressure grid p_lo to determine a scalar output 
!    variable x_hi at pressure p_hi. 
!    NOTE: vertical index 1 is closest to the ground in all arrays
!    used here.
!------------------------------------------------------------------

integer,                 intent(in)    :: n_lo
real, dimension(n_lo),   intent(in)    :: x_lo
real, dimension(n_lo+1), intent(in)    ::  p_lo
real,                    intent(in)    :: p_hi
real,                    intent(out)   :: x_hi
character(len=*),        intent(out)   :: ermesg
integer,                 intent(out)   :: error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!     x_lo          field to be interpolated on lo-res pressure grid
!                   [ units of x_lo ]
!     p_lo          lo-res pressure grid [ Pa ]
!     p_hi          hi-res pressure grid [ Pa ]
!     
!  intent(out) variables:
!
!     x_hi          value of field at pressure p_hi
!                   [ units of x_lo ]
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:

      real, dimension (1)          :: x_hi_1d, p_hi_1d
      integer                      :: n_hi


!--------------------------------------------------------------------
!   local variables:
!    
!          x_hi_1d    1d array containing the output field x_hi
!          p_hi_1d    1d array containing the input field p_hi
!          ermesg     character string containing any error message
!                     generated in the kernel subroutines accessed from
!                     here
!          n_lo       vertical size of lo_res model profile           
!          n_hi       vertical size of array containing output profile  
!
!---------------------------------------------------------------------

      ermesg = ' ' ; error = 0

!----------------------------------------------------------------------
!    define the dimensions of input and output arrays. 
!----------------------------------------------------------------------
      n_hi = 1

!---------------------------------------------------------------------
!    define an array containing the hi-res pressure at which a variable
!    value is desired.
!---------------------------------------------------------------------
      p_hi_1d(1) = p_hi

!--------------------------------------------------------------------
!    call don_u_lo1d_to_hi1d_k to obtain the desired field 
!    value.
!--------------------------------------------------------------------
      call don_u_lo1d_to_hi1d_k     & 
           (n_lo, n_hi, x_lo, p_lo, p_hi_1d, x_hi_1d, ermesg, error)

!---------------------------------------------------------------------
!    check to be sure no errors were encountered in the kernel routine. 
!---------------------------------------------------------------------
      if (error /= 0 ) return

!--------------------------------------------------------------------
!    move the returned value from the output array to the scalar output 
!    argument to be returned to the calling routine.
!--------------------------------------------------------------------
       x_hi = x_hi_1d(1)        

!--------------------------------------------------------------------


end subroutine don_u_lo1d_to_hi0d_linear_k


!#####################################################################

subroutine don_u_lo1d_to_hi0d_log_k     &
         (n_lo, x_lo, sig_lo, ps, p_hi, x_hi, ermesg, error)

!--------------------------------------------------------------------
!    subroutine don_u_lo1d_to_hi0d_log_k uses logarithmic 
!    interpolation to define the scalar output variable x_hi at pressure
!    p_hi from the input profile x_lo of size n_lo on sigma grid sig_lo 
!    (with associated surface pressure ps).
!    NOTE: vertical index 1 is closest to the ground in all arrays
!    used here.
!    any error message is returned in ermesg.
!------------------------------------------------------------------

implicit none

integer,               intent(in)   :: n_lo
real, dimension(n_lo), intent(in)   :: x_lo, sig_lo 
real,                  intent(in)   :: ps
real,                  intent(in)   :: p_hi
real,                  intent(out)  :: x_hi     
character(len=*),      intent(out)  :: ermesg
integer,               intent(out)  :: error

!--------------------------------------------------------------------
!   intent(in) variables:
!
!     n_lo     size of input profile on lo-res grid
!     x_lo     field to be interpolated [ units of x_lo ]
!     sig_lo   sigma profile defining the specified grid [ fraction ]
!     ps       surface pressure defining the specified grid [ Pa ]
!     p_hi     pressure whose location on the specified grid is desired 
!              [ Pa ]
!
!   intent(out) variables:
!
!     x_hi     output variable value at pressure p_hi [ units of x_lo ] 
!     ermesg   error message, if error is encountered
!
!----------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:

      integer  :: indx  ! nearest vertical grid index on specified grid 
                        ! surfaceward of the desired pressure
      real     :: displ ! logarithmic displacement of desired pressure 
                        ! from the indx grid level
      integer  :: k     ! do-loop index

!----------------------------------------------------------------------
!    initialize the error message character string.
!----------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!--------------------------------------------------------------------
!    define an initial value for indx which can be checked to verify
!    if the search was successful.
!--------------------------------------------------------------------
      indx = 0

!--------------------------------------------------------------------
!    march through the vertical grid until the desired pressure is 
!    bracketed. define the lower index (indx) and calculate the logar-
!    ithmic displacement of the desired pressure between the two sur-
!    rounding grid levels.
!--------------------------------------------------------------------
      do k=1,n_lo-1
        if ((ps*sig_lo(k) >= p_hi) .and.   &
            (ps*sig_lo(k+1) <= p_hi) ) then 
          indx = k
          displ = alog(p_hi/(ps*sig_lo(k)))/alog(sig_lo(k+1)/sig_lo(k)) 
          x_hi = x_lo(indx) + (x_lo(indx+1) - x_lo(indx))*displ
          exit
        endif
      end do

!---------------------------------------------------------------------
!    if pressure was outside the limits of the input profile, write 
!    error message.
!---------------------------------------------------------------------
      if (indx == 0) then
        ermesg = 'unable to bracket the input pressure within the input &
                                           &pressure profile'
        error = 1
        return
      endif

!--------------------------------------------------------------------


end subroutine don_u_lo1d_to_hi0d_log_k

!#####################################################################

subroutine don_u_process_monitor_k (variable, i,j,nlev_lsm, Monitor)
 
use donner_types_mod, only : donner_monitor_type, MAXVAL, MAXMAG, &
                             MINMAG, MINVAL

implicit none

real, dimension(nlev_lsm),  intent(in)    :: variable
integer,                    intent(in)    :: i, j, nlev_lsm
type(donner_monitor_type),  intent(inout) :: Monitor

 
      integer :: k

      select case (Monitor%limit_type)
        case (MAXMAG)              
          do k=1,nlev_lsm 
            if (abs(variable(k)) > Monitor%threshold) then
              Monitor%hits(i,j,k) = Monitor%hits(i,j,k) + 1.0
            endif 
            if (abs(variable(k)) > Monitor%extrema(i,j,k))  then
              Monitor%extrema(i,j,k) = abs(variable(k)) 
            endif 
          end do
        case (MINMAG)              
          do k=1,nlev_lsm 
            if (abs(variable(k)) < Monitor%threshold) then
              Monitor%hits(i,j,k) = Monitor%hits(i,j,k) + 1.0
            endif 
            if (abs(variable(k)) < Monitor%extrema(i,j,k))  then
              Monitor%extrema(i,j,k) = abs(variable(k)) 
            endif 
          end do
        case (MAXVAL)              
          do k=1,nlev_lsm 
            if (variable(k) > Monitor%threshold) then
              Monitor%hits(i,j,k) = Monitor%hits(i,j,k) + 1.0
            endif 
            if (variable(k) > Monitor%extrema(i,j,k))  then
              Monitor%extrema(i,j,k) = variable(k) 
            endif 
          end do
        case (MINVAL)              
          do k=1,nlev_lsm 
            if (variable(k) < Monitor%threshold) then
              Monitor%hits(i,j,k) = Monitor%hits(i,j,k) + 1.0
            endif 
            if (variable(k) < Monitor%extrema(i,j,k))  then
              Monitor%extrema(i,j,k) = variable(k)
            endif 
          end do
      end select

end subroutine don_u_process_monitor_k


!######################################################################

subroutine find_tropopause (nlev, temp, pfull, ptrop, itrop)

integer,                intent(in) :: nlev
real, dimension (nlev), intent(in) :: temp, pfull
real,                   intent(out) :: ptrop
integer,                intent(out) :: itrop

!---------------------------------------------------------------------
!    find lowest temperature in the column between 50 and 400 hPa. the 
!    corresponding pressure is returned as the tropopause pressure.
!    temp and pfull have index 1 closest to the ground.
!---------------------------------------------------------------------

     real      :: ttrop
     integer   :: k


     ttrop = 400.0
     itrop = 1
     ptrop = 1.0

     do k=nlev,1,-1  
       if (pfull(k) < 400.e+02) then
         if (pfull(k) > 50.e+02 .and. temp(k) < ttrop) then 
           ttrop = temp(k)
           itrop = k
           ptrop = pfull(k)
         endif
       else
         exit
       endif
     end do

!---------------------------------------------------------------------
     
end subroutine find_tropopause 


!######################################################################

subroutine define_arat_erat (option, kpar, eratb, erat0, erat_min, &
                             erat_max, erat, arat)

integer, intent(in) :: option, kpar
real, dimension(kpar), intent(in) :: eratb
real, intent(in) :: erat0, erat_min, erat_max
real, dimension(kpar), intent(out) :: erat, arat

     integer :: i
     real    :: x 
     real, dimension(kpar) :: eratb_loc

     if (option == 1) then
 
       do i=1,kpar
! eq (5):
         arat(i) = (exp(-eratb(i)/erat0) - exp(-eratb(i+1)/erat0))  /  &
                   (exp(-eratb(1)/erat0) - exp(-eratb(kpar+1)/erat0)) 
! eq (6):
         erat(i) = 0.5*(eratb(i+1) + eratb(i))   
       end do

     else if (option == 2) then
 
       eratb_loc(1) = erat_min
       do i=2,kpar+1
! eq (7):
         x = exp(-eratb_loc(i-1)/erat0) -     &
              (exp(-erat_min/erat0) - exp(-erat_max/erat0))/kpar
         eratb_loc(i) = -erat0*log(x)    
       end do
       do i=1,kpar
! eq (5):
         arat(i) =    &
            (exp(-eratb_loc(i)/erat0) - exp(-eratb_loc(i+1)/erat0))/ &
            (exp(-eratb_loc(1)/erat0) - exp(-eratb_loc(kpar+1)/erat0)) 
! eq (6):
         erat(i) = 0.5*(eratb_loc(i+1) + eratb_loc(i)) 
       end do
 
     end if



end subroutine define_arat_erat 


!######################################################################

!VERSION NUMBER:
!  $Id: donner_rad_k.F90,v 16.0 2008/07/30 22:07:00 fms Exp $

!module donner_rad_inter_mod

!#include "donner_rad_interfaces.h"

!end module donner_rad_inter_mod


!###################################################################

subroutine don_r_donner_rad_driver_k   &
         (isize, jsize, nlev_lsm, Param, Col_diag, Initialized,   &
          pfull, temp, land, exit_flag, Don_conv, Don_rad, Nml, ermesg, error)

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------

use donner_types_mod, only : donner_param_type, donner_nml_type, &
                             donner_initialized_type, donner_conv_type,&
                             donner_column_diag_type, donner_rad_type

implicit none

!----------------------------------------------------------------------
integer,                               intent(in)    :: isize, jsize,   &
                                                        nlev_lsm
type(donner_param_type),               intent(in)    :: Param
type(donner_column_diag_type),         intent(in)    :: Col_diag
type(donner_initialized_type),         intent(in)    :: Initialized
real, dimension(isize,jsize,nlev_lsm), intent(in)    :: pfull, temp
real, dimension(isize,jsize),          intent(in)    :: land
logical, dimension(isize,jsize),       intent(in)    :: exit_flag
type(donner_conv_type),                intent(inout) :: Don_conv
type(donner_rad_type),                 intent(inout) :: Don_rad
type(donner_nml_type),                 intent(inout) :: Nml       
character(len=*),                      intent(out)   :: ermesg
integer,                               intent(out)   :: error

      ermesg= ' ' ; error = 0

!---------------------------------------------------------------------
!    call define_ice_size to define the ice particle size distribution 
!    within the anvil (Don_conv%dgeice).
!---------------------------------------------------------------------
      call don_r_define_ice_size_k    &
           (isize, jsize, nlev_lsm, Param, Col_diag, pfull, &
            Don_conv%xice, Don_conv%przm, Don_conv%prztm,    &
            Don_conv%dgeice, ermesg, error)

!---------------------------------------------------------------------
!    call define_cell_liquid_size to compute the cell liquid effective
!    droplet diameter (Don_conv%cell_liquid_eff_diam) and the number of
!    cell droplets (Don_rad%cell_droplet_number).
!---------------------------------------------------------------------
      call don_r_define_cell_liquid_size_k   &
           (isize, jsize, nlev_lsm, Param, Nml, Col_diag, pfull, temp, &
            Don_conv%cuql, Don_conv%cual, land, exit_flag,    &
            Don_conv%cell_liquid_eff_diam, Don_rad%cell_droplet_number,&
            ermesg, error)
 
!---------------------------------------------------------------------
!    since liquid is not allowed in anvil currently, set the droplet
!    number there to be 0.0.
!---------------------------------------------------------------------
      Don_rad%meso_droplet_number = 0.0

!---------------------------------------------------------------------
!    save  variables needed by the radiation package.
!---------------------------------------------------------------------
      call don_r_donner_deep_sum_k  &
           (isize, jsize, nlev_lsm, Param, Nml, Initialized, &
            Don_conv%xliq, Don_conv%xice, Don_conv%cual,  &
            Don_conv%ampta1, Don_conv%cuql, Don_conv%cuqi, &
            Don_conv%dgeice, Don_conv%cell_liquid_eff_diam, &
            Don_rad, ermesg, error)

!--------------------------------------------------------------------


end subroutine don_r_donner_rad_driver_k

!######################################################################

subroutine don_r_define_ice_size_k    &
         (isize, jsize, nlev_lsm, Param, Col_diag, pfull, xice, przm, &
          prztm, dgeice, ermesg, error)
  
!----------------------------------------------------------------------
!    subroutine define_ice_size obtains the effective ice crystal size 
!    profile (dgeice).
!----------------------------------------------------------------------

use donner_types_mod, only : donner_param_type, donner_column_diag_type

implicit none

!----------------------------------------------------------------------
integer,                               intent(in)  :: isize, jsize,  &
                                                      nlev_lsm
type(donner_param_type),               intent(in)  :: Param
type(donner_column_diag_type),         intent(in)  :: Col_diag
real, dimension(isize,jsize,nlev_lsm), intent(in)  :: pfull, xice
real, dimension(isize,jsize),          intent(in)  :: przm, prztm
real, dimension(isize,jsize,nlev_lsm), intent(out) :: dgeice
character(len=*),                      intent(out) :: ermesg
integer,                               intent(out) :: error
            
!---------------------------------------------------------------------
!   intent(in) variables:
!
!     pfull          pressure at model full levels [ Pa ]
!     xice           mesoscale ice content [ kg(ice) / kg(air ]
!     przm           pressure at anvil base [ Pa ]
!     prztm          pressure at anvil top [ Pa ]
!
!   intent(out) variables:
!
!     dgeice         effective ice crystal size [ microns ]
!
!----------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:
  
      integer :: i, j, k        ! do-loop indices

      ermesg = ' ' ; error = 0

!---------------------------------------------------------------------
!    call subroutine andge to assign effective sizes (dgeice) to the 
!    ice in the model layers of the anvil.
!    make sure the ice size is within the limits acceptable to the 
!    radiative properties parameterizations.
!---------------------------------------------------------------------
      do k=1,nlev_lsm                           
        do j=1,jsize
          do i=1,isize
            if (xice(i,j,k) > 0.0) then
              call don_r_andge_k   &
                   (i, j, Param, Col_diag, pfull(i,j,k), przm(i,j),  &
                    prztm(i,j), dgeice(i,j,k), ermesg, error)
            else
              dgeice(i,j,k) = 0.
            endif
          end do
        end do
      end do

!---------------------------------------------------------------------


end subroutine don_r_define_ice_size_k


!######################################################################

subroutine don_r_andge_k   &
         (i, j, Param, Col_diag, press, pzm, pztm, dgeicer, ermesg, error)
  
!---------------------------------------------------------------------
!    subroutine andge defines the generalized effective ice crystal size
!    for the mesoscale anvil layers.
!---------------------------------------------------------------------

use donner_types_mod, only : donner_param_type, donner_column_diag_type

implicit none

!---------------------------------------------------------------------
integer,                       intent(in)  :: i,j 
type(donner_param_type),       intent(in)  :: Param
type(donner_column_diag_type), intent(in)  :: Col_diag
real,                          intent(in)  :: press, pzm, pztm       
real,                          intent(out) :: dgeicer    
character(len=*),              intent(out) :: ermesg
integer,                       intent(out) :: error
 
!---------------------------------------------------------------------
!   intent(in) variables:
!
!     i, j      physics window indices of the current column
!     press     pressure at model full levels [ Pa ]
!     pzm       pressure at base of mesoscale anvil [ Pa ]
!     pztm      pressure at top of mesoscale anvil [ Pa ]
!
!   intent(out) variables:
! 
!     dgeicer   generalized effective size of ice crystals in anvil 
!               defined as in Fu (1996, J. Clim.). [ microns ]
!
!----------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:

      real     :: znor    ! normalized distance from anvil base
                          ! [ dimensionless ]
      integer  :: k, n    ! do-loop indices

      ermesg = ' ' ; error = 0

!-------------------------------------------------------------------
!    be sure that anvil base has higher pressure than anvil top. 
!-------------------------------------------------------------------
      if (pzm < pztm) then
        ermesg = ' andge: pzm is < pztm'
        error = 1
        return
      endif

!-------------------------------------------------------------------
!    define the relative displacement of the current pressure between
!    the anvil top and bottom. avoid calculation if anvil depth is 0.0
!    (implying a one-layer thick anvil).
!-------------------------------------------------------------------
      if (pzm == pztm) then
        znor = 0.5
      else
        znor = (pzm - press)/(pzm - pztm)
      endif

!--------------------------------------------------------------------
!    define the value of dgeice at the appropriate relative displacement
!    from anvil base (dgeicer).
!--------------------------------------------------------------------
      do k=2,Param%anvil_levels
        if ((znor >= Param%relht(k-1)) .and.   &
            (znor <= Param%relht(k))) then
          dgeicer = Param%dgeice(k-1) + ((znor - Param%relht(k-1))*  &
                   (Param%dgeice(k) - Param%dgeice(k-1))/  &
                   (Param%relht(k) - Param%relht(k-1)))
          exit
        endif
      end do

!---------------------------------------------------------------------
!   if in diagnostics column, output relevant variables related to the 
!   effective ice size calculation.
!---------------------------------------------------------------------
      if (Col_diag%in_diagnostics_window) then
        do n=1,Col_diag%ncols_in_window
          if (j == Col_diag%j_dc(n) .and. i == Col_diag%i_dc(n)) then
            write (Col_diag%unit_dc(n), '(a, e22.12)')  'znor= ',znor
            write (Col_diag%unit_dc(n), '(a, 2e22.12)') &
                            'relhts= ',Param%relht(k-1),Param%relht(k)
            write (Col_diag%unit_dc(n), '(a, e22.12)') &
                             'dgeicer= ',dgeicer
          endif
        end do
      endif

!--------------------------------------------------------------------


end subroutine don_r_andge_k


!###################################################################

subroutine don_r_define_cell_liquid_size_k   &
         (isize, jsize, nlev_lsm, Param, Nml, Col_diag, pfull, temp, &
          cuql, cual, land, exit_flag, cell_liquid_eff_diam,  &
          cell_droplet_number, ermesg, error)

!--------------------------------------------------------------------
!    subroutine define_cell_liquid_size calculates the effective radii 
!    of liquid cloud drops in cumulus clouds following the prescription
!    of Bower et al (JAS, 1994).
!---------------------------------------------------------------------

use donner_types_mod, only : donner_param_type, donner_nml_type, &
                             donner_column_diag_type

implicit none

!---------------------------------------------------------------------
integer,                         intent(in)  :: isize, jsize, nlev_lsm
type(donner_param_type),         intent(in)  :: Param
type(donner_nml_type),           intent(in)  :: Nml

type(donner_column_diag_type),   intent(in)  :: Col_diag
real, dimension(isize,jsize,nlev_lsm),                 &
                                 intent(in)  :: pfull, temp, cuql, cual
real, dimension(isize,jsize),    intent(in)  :: land
logical,dimension(isize,jsize),  intent(in)  :: exit_flag
real, dimension(isize,jsize,nlev_lsm),                  &
                                 intent(out) :: cell_liquid_eff_diam, &
                                                cell_droplet_number
character(len=*),                intent(out) :: ermesg
integer,                         intent(out) :: error
   
!--------------------------------------------------------------------
!   intent(in) variables:
!
!     pfull          pressure at model full levels [ Pa ]
!     temp           temperature at model full levels [ deg K ]
!     cuql           cell liquid content [ kg(h2o) / kg(air) ]
!     land           fraction of land in grid box [ fraction ]
!     cell_liquid_eff_diam
!                    effective diameter of liquid cloud drops 
!                    [ microns ]
!     cell_droplet_number
!                    droplet number in cells [ # / kg(air) ]
!
!------------------------------------------------------------------
! local variables
  
      real, dimension (isize,jsize) ::   &
                                cell_pbase, temp_cell_pbase, &
                                cell_land_ref_delp, cell_ocean_ref_delp
                                       
      real, dimension (isize,jsize,nlev_lsm)          ::   &
                               cell_delp, cell_liquid_eff_diam_land,  &
                               cell_liquid_eff_diam_ocean, &
                               cell_droplet_number_land,   &
                               cell_droplet_number_ocean
      integer   :: i, j, k, n

!------------------------------------------------------------------
! local variables
!
!        cell_pbase                      pressure at cloud base [ Pa ]
!        temp_cell_pbase                 temperature at cloud base
!                                        [ deg K ]
!        cell_land_ref_delp              pressure difference between
!                                        cloud base and a point 
!                                        delz_land meters above cloud 
!                                        base
!        cell_ocean_ref_delp             pressure difference between
!                                        cloud base and a point 
!                                        delz_ocean meters above cloud 
!                                        base
!        cell_delp                       pressure difference between 
!                                        level k and the pressure at
!                                        cloud base (lowest level with
!                                        liquid condensate) [ Pa ]
!        cell_liquid_eff_diam_land       droplet effective diameter when
!                                        over a land surface
!                                        [ microns ]
!        cell_liquid_eff_diam_ocean      droplet effective diameter when
!                                        over an ocean surface 
!                                        [ microns ]
!        cell_droplet_number_land
!        cell_droplet_number_ocean
!        i,j,k,n                         do-loop indices
!
!-------------------------------------------------------------------

      ermesg= ' ' ; error = 0

!--------------------------------------------------------------------
!    define the pressure (cell_pbase) and temperature (temp_cell_pbase)
!    at the cell cloud base (lowest level with liquid water present).
!--------------------------------------------------------------------
      cell_pbase = pfull(:,:,1)
      temp_cell_pbase = temp(:,:,1)
      do j=1,jsize
        do i=1,isize
          do k=nlev_lsm,1,-1
            if (cuql(i,j,k) >= 1.0e-11 )  then
              cell_pbase(i,j) = pfull(i,j,k)
              temp_cell_pbase(i,j) = temp(i,j,k)
              exit
            endif
          end do
        end do
      end do

!---------------------------------------------------------------------
!    define the pressure distance between the cell cloud base and each
!    model pressure level.
!---------------------------------------------------------------------
      do k=1,nlev_lsm             
        cell_delp(:,:,k) = cell_pbase(:,:) - pfull(:,:,k)
      end do

!--------------------------------------------------------------------
!    define the pressure distance between the cell cloud base and points
!    delz_land meters and delz_ocean meters above cloud base. between
!    cloud base and this distance above cloud base, cloud drop size 
!    will be computed; for greater distances above cloud base, the 
!    appropriate drop radii existing as parameters in this module will
!    be used.
!--------------------------------------------------------------------
      cell_land_ref_delp =      &
               cell_pbase*(1.0 - EXP( -(Param%delz_land*Param%grav/   &
                                       (Param%rdgas*temp_cell_pbase))))
      cell_ocean_ref_delp =      &
               cell_pbase*(1.0 - EXP( -(Param%delz_ocean*Param%grav/  &
                                       (Param%rdgas*temp_cell_pbase))))

!---------------------------------------------------------------------
!    if in a diagnostics column, output the vertical profiles of cloud 
!    liquid (cuql), cloud base separation (cell_delp) and pressure 
!    (pfull), along with the column values of land and ocean reference
!    pressure deltas, cell cloud base and land fraction.
!---------------------------------------------------------------------
      if (Col_diag%in_diagnostics_window) then
        do n=1,Col_diag%ncols_in_window
          do j=1,jsize
            do i=1,isize
              if (j == Col_diag%j_dc(n) .and. i == Col_diag%i_dc(n)) then
                if (.not. exit_flag(i,j)) then
                  do k=1,nlev_lsm             
                    if (cuql(i,j,k) > 0.0) then
                      write (Col_diag%unit_dc(n), '(a, e22.12)') &
                           ' Don_conv%cuql', cuql(i,j,k)
                      write (Col_diag%unit_dc(n), '(a, e22.12)') & 
                           ' cell_delp', cell_delp(i,j,k)
                      write (Col_diag%unit_dc(n), '(a, e22.12)') & 
                              ' pfull',  pfull(i,j,k)
                    endif
                  end do
                  write (Col_diag%unit_dc(n), '(a, e22.12)') &
                      ' cell_land_ref_delp',  cell_land_ref_delp(i,j)
                  write (Col_diag%unit_dc(n), '(a, e22.12)') &
                      ' cell_ocean_ref_delp', cell_ocean_ref_delp(i,j)
                  write (Col_diag%unit_dc(n), '(a, e22.12)') &
                                  ' land', land(i,j)
                  write (Col_diag%unit_dc(n), '(a, e22.12)') &
                                 ' cell_pbase', cell_pbase(i,j)
                endif
              endif
            end do
          end do
        end do
      endif

!--------------------------------------------------------------------
!    compute the drop diameters for the land and ocean portions of the 
!    grid box, when liquid water is present.
!--------------------------------------------------------------------
      do k=1,nlev_lsm             
        do j=1,jsize
          do i=1,isize
            if (cuql(i,j,k) >= 1.0e-11 .and. &
                cual(i,j,k) > 0.0) then

!---------------------------------------------------------------------
!    if land is present in the box and the box is more than delz_land 
!    meters from cloud base, define the cloud drop diameter as the
!    value of r_conv_land.
!---------------------------------------------------------------------
              if (land(i,j) > 0.0) then
                if (cell_delp(i,j,k) >= cell_land_ref_delp(i,j)) then 
                  cell_liquid_eff_diam_land(i,j,k) =      &
                                                  2.0*Param%r_conv_land
                  cell_droplet_number_land(i,j,k) =  3.0*cuql(i,j,k)/  &
                                     (4.0*Param%pie*Param%dens_h2o*    &
                                         (Param%r_conv_land*1.0e-06)**3)
                  cell_droplet_number_land(i,j,k) =  &
                       cell_droplet_number_land(i,j,k)*pfull(i,j,k)/&
                          (Param%rdgas*temp(i,j,k))

!---------------------------------------------------------------------
!    if the box is less than delz_land meters from cloud base, calculate
!    the cloud drop diameter.
!---------------------------------------------------------------------
                else
                  cell_liquid_eff_diam_land(i,j,k) = 2.0*(1.0e6)*  &
                                 (3.0*(pfull(i,j,k)/    &
                            (Param%rdgas*temp(i,j,k)))*cuql(i,j,k)/   &
                     (4*Param%pie*Param%dens_h2o*Param%n_land))**(1./3.) 
                  cell_droplet_number_land(i,j,k) = Param%n_land/  &
                                (pfull(i,j,k)/(Param%rdgas*temp(i,j,k)))
                endif
              else
                cell_liquid_eff_diam_land(i,j,k) = 0.0
                cell_droplet_number_land(i,j,k) = 0.0
              endif

!---------------------------------------------------------------------
!    if any fraction of the grid box is over the ocean and the grid
!    point is more than delz_ocean above cloud base, define the 
!    effective cloud drop diameter for that portion of the box in terms
!    of r_conv_ocean.
!---------------------------------------------------------------------
              if (land(i,j) < 1.0) then
                if (cell_delp(i,j,k) >= cell_ocean_ref_delp(i,j)) then 
                  cell_liquid_eff_diam_ocean(i,j,k) =     &
                                                 2.0*Param%r_conv_ocean
                  cell_droplet_number_ocean(i,j,k) =  3.0*cuql(i,j,k)/ &
                                   (4.0*Param%pie*Param%dens_h2o*    &
                                       (Param%r_conv_ocean*1.0e-06)**3)
                  cell_droplet_number_ocean(i,j,k) =  &
                        cell_droplet_number_ocean(i,j,k)*pfull(i,j,k)/&
                              (Param%rdgas*temp(i,j,k))
                else
                  cell_liquid_eff_diam_ocean(i,j,k) = 2.0*(1.0e6)*  &
                         (3.0*(pfull(i,j,k)/     &
                               (Param%rdgas*temp(i,j,k)))*cuql(i,j,k)/  &
                    (4*Param%pie*Param%DENS_H2O*Param%n_ocean))**(1./3.)
                  cell_droplet_number_ocean(i,j,k) = Param%n_ocean/  &
                               (pfull(i,j,k)/(Param%rdgas*temp(i,j,k)))
                endif
              else
                cell_liquid_eff_diam_ocean(i,j,k) = 0.0
                cell_droplet_number_ocean(i,j,k) = 0.0
              endif

!---------------------------------------------------------------------
!    define the effective diameter for the grid box as the weighted av-
!    erage of the diameters over the land and ocean portions of the box.
!---------------------------------------------------------------------
              cell_liquid_eff_diam(i,j,k) =                    &
                       land(i,j) *cell_liquid_eff_diam_land(i,j,k)   + &
                (1.0 - land(i,j))*cell_liquid_eff_diam_ocean(i,j,k) 
              cell_droplet_number (i,j,k) =                    &
                       land(i,j) *cell_droplet_number_land(i,j,k)   + &
                (1.0 - land(i,j))*cell_droplet_number_ocean(i,j,k) 

!---------------------------------------------------------------------
!    when there is no liquid in the box, set the effective diameter to
!    10 microns.
!---------------------------------------------------------------------
            else
              cell_liquid_eff_diam(i,j,k) = 10.0
              cell_droplet_number(i,j,k) = 0.
            endif  ! (cuql > 1.0e-11)
          end do
        end do
      end do

!--------------------------------------------------------------------
!    limit the liquid droplet sizes to be between 8.401 and 33.199
!    microns, the limits for which the slingo parameterization for
!    radiative properties of cloud drops is applicable.
!--------------------------------------------------------------------
      if (Nml%use_memphis_size_limits) then
        cell_liquid_eff_diam = MAX(8.401, cell_liquid_eff_diam)
        cell_liquid_eff_diam = MIN(33.199, cell_liquid_eff_diam)
      endif

!--------------------------------------------------------------------
!    if this is a diagnostics column, output the grid box effective
!    size, as well as the over land and over ocean values which were
!    used to define it.
!--------------------------------------------------------------------
      if (Col_diag%in_diagnostics_window) then
        do n=1,Col_diag%ncols_in_window
          do j=1,jsize
            do i=1,isize
              if (j == Col_diag%j_dc(n) .and. i == Col_diag%i_dc(n)) then
                do k=1,nlev_lsm            
                  if (cuql(i,j,k) > 0.0) then
                    write (Col_diag%unit_dc(n), '(a, i5    )') &
                         'k', k
                    write (Col_diag%unit_dc(n), '(a, e22.12)') &
                            ' cell_liquid_eff_diam',  &
                                 cell_liquid_eff_diam(i,j,k)
                    write (Col_diag%unit_dc(n), '(a, e22.12)') &
                            ' cell_liquid_eff_diam_land',  &
                                 cell_liquid_eff_diam_land(i,j,k)
                    write (Col_diag%unit_dc(n), '(a, e22.12)') &
                           ' cell_liquid_eff_diam_ocean',  &
                                 cell_liquid_eff_diam_ocean(i,j,k)
                    write (Col_diag%unit_dc(n), '(a, e22.12)') &
                            ' cell_droplet_number',  &
                                 cell_droplet_number (i,j,k)
                    write (Col_diag%unit_dc(n), '(a, e22.12)') &
                            ' cell_droplet_number_land',  &
                                 cell_droplet_number_land(i,j,k)
                    write (Col_diag%unit_dc(n), '(a, e22.12)') &
                           ' cell_droplet_number_ocean',  &
                                 cell_droplet_number_ocean(i,j,k)
                    write (Col_diag%unit_dc(n), '(a, e22.12)') &
                           ' cuql     ',  &
                                 cuql     (i,j,k)
                    write (Col_diag%unit_dc(n), '(a, e22.12)') &
                           ' cual     ',  &
                                    cual     (i,j,k)
                  endif
                end do
              endif
            end do
          end do
        end do
      endif

!--------------------------------------------------------------------


end subroutine don_r_define_cell_liquid_size_k


!#####################################################################

subroutine don_r_donner_deep_sum_k  &
         (isize, jsize, nlev_lsm, Param, Nml, Initialized, xliq, &
          xice, cual, ampta1, cuql, cuqi, dgeice,   &
          cell_liquid_eff_diam, Don_rad, ermesg, error)

!------------------------------------------------------------------
!    subroutine donner_deep_sum stores the cloud amount and particle 
!    size fields for the convective cells and the mesoscale anvil clouds
!    associated with the donner_deep convection parameterization. 
!------------------------------------------------------------------

use donner_types_mod, only : donner_param_type, donner_nml_type, &
                             donner_initialized_type, donner_rad_type

implicit none

!------------------------------------------------------------------
integer,                      intent(in)    :: isize, jsize, nlev_lsm
type(donner_param_type),      intent(in)    :: Param
type(donner_nml_type),        intent(in)    :: Nml      
type(donner_initialized_type),                     &
                              intent(in)    :: Initialized
real, dimension(isize,jsize,nlev_lsm),              &
                              intent(in)    :: xliq, xice, cual, cuql, &
                                               cuqi, dgeice,  &
                                               cell_liquid_eff_diam
real, dimension(isize,jsize), intent(in)    :: ampta1
type(donner_rad_type),        intent(inout) :: Don_rad
character(len=*),             intent(out)   :: ermesg
integer,                      intent(out)   :: error
                                                            
!------------------------------------------------------------------
!   intent(in) variables:
!
!     is, ie        first and last values of i index values of points 
!                   in this physics window (processor coordinates)
!     js, je        first and last values of j index values of points 
!                   in this physics window (processor coordinates)
!     xliq          mesoscale liquid water content [ kg(h2o) / kg(air) ]
!     xice          mesoscale ice content [ kg(h2o) / kg(air) ]
!     cual          cloud fractional area of convective system
!                   (vclouds plus anvil) [ fraction ]
!     ampta1        mesoscale cloud fraction (anvil) [ fraction ]
!     cuql          cell liquid water content [ kg(h2o) / kg(air) ]
!     cuqi          cell ice content [ kg(h2o) / kg(air) ]
!     cell_liquid_eff_diam
!                   cell liquid droplet effective diameter [ microns ]
!     dgeice        ice crystal generalized effective size [ microns ]
!
!--------------------------------------------------------------------


!--------------------------------------------------------------------
!   local variables:

      real, dimension(isize, jsize, nlev_lsm)  ::   meso_area
      integer :: i, j, k

!--------------------------------------------------------------------
!   local variables:
!
!        meso_area      fractional area of anvil [ fraction ]
!        i,j,k          do-loop indices
!
!--------------------------------------------------------------------

       ermesg= ' ' ; error = 0

!--------------------------------------------------------------------
!    if the cloud data from donner_deep_mod that is to be passed to
!    the radiation package is to be time-averaged, increment the counter
!    of the number of time levels that are included in the sum. if the
!    data is not time averaged, set the counter to 1.
!--------------------------------------------------------------------
      if (Nml%do_average) then
        Don_rad%nsum(:,:) = Don_rad%nsum(:,:) + 1
      else
        Don_rad%nsum(:,:) = 1
      endif
 
!--------------------------------------------------------------------
!    define mesoscale anvil area at each level.
!--------------------------------------------------------------------
      do k=1,nlev_lsm            
        do j=1,jsize
          do i=1,isize
            if (xice(i,j,k) == 0.0) then
              meso_area(i,j,k) = 0.0
            else
             meso_area(i,j,k) = MAX (0.0, ampta1(i,j))
            endif
            if (xliq(i,j,k) /= 0.0) then
              ermesg = ' liquid water present in anvil -- not&
                                           & currently allowed'
              error = 1
              return
            endif
          end do
        end do
      end do

!----------------------------------------------------------------------
!    define the mesoscale anvil properties needed by the radiation 
!    package (cloud fraction, liquid amount, ice amount, liquid droplet 
!    size, ice effective size) for the case where the fields are to 
!    be time-averaged.
!----------------------------------------------------------------------
      if (Nml%do_average) then
        Don_rad%meso_cloud_frac(:,:,:) =         &
                        Don_rad%meso_cloud_frac(:,:,:) + meso_area(:,:,:)
        Don_rad%meso_liquid_amt(:,:,:) = &
                             Don_rad%meso_liquid_amt(:,:,:) + xliq(:,:,:)
        Don_rad%meso_ice_amt(:,:,:)         =   &
                                Don_rad%meso_ice_amt(:,:,:) + xice(:,:,:)
        Don_rad%meso_liquid_size(:,:,:) = &
                                    Don_rad%meso_liquid_size(:,:,:) + &
                                          Nml%meso_liquid_eff_diam_input
        Don_rad%meso_ice_size(:,:,:) = &
                         Don_rad%meso_ice_size(:,:,:) + dgeice(:,:,:)

!----------------------------------------------------------------------
!    define the mesoscale anvil properties needed by the radiation 
!    package (cloud fraction, liquid amount, ice amount, liquid droplet
!    size, ice effective size) for the case where the fields are 
!    not time-averaged.
!----------------------------------------------------------------------
      else
        Don_rad%meso_cloud_frac(:,:,:)  = meso_area(:,:,:)
        Don_rad%meso_liquid_amt(:,:,:)  = xliq(:,:,:)
        Don_rad%meso_ice_amt(:,:,:)     = xice(:,:,:)
        Don_rad%meso_liquid_size(:,:,:) = Nml%meso_liquid_eff_diam_input
        Don_rad%meso_ice_size(:,:,:)    = dgeice(:,:,:)
      endif

!----------------------------------------------------------------------
!    define the cell properties needed by the radiation package (cloud 
!    fraction, liquid amount, ice amount, liquid droplet size, ice eff- 
!    ective size) for the case where the fields are to be time-averaged.
!----------------------------------------------------------------------
      if (Nml%do_average) then
        Don_rad%cell_cloud_frac(:,:,:) = &
                       Don_rad%cell_cloud_frac(:,:,:) + &
                             MAX (0.0, cual(:,:,:) - meso_area(:,:,:) )
        Don_rad%cell_liquid_amt(:,:,:) = &
                   Don_rad%cell_liquid_amt(:,:,:) + cuql(:,:,:)
        Don_rad%cell_ice_amt(:,:,:) = &
                            Don_rad%cell_ice_amt(:,:,:) + cuqi(:,:,:)

!----------------------------------------------------------------------
!     cell liquid size may be either specified via a namelist variable
!     or defined based on the bower parameterization.
!----------------------------------------------------------------------
        if (Initialized%do_input_cell_liquid_size) then
          Don_rad%cell_liquid_size(:,:,:) = &
                              Don_rad%cell_liquid_size(:,:,:) +      &
                                           Nml%cell_liquid_eff_diam_input
        else if (Initialized%do_bower_cell_liquid_size) then
          Don_rad%cell_liquid_size(:,:,:) = &
                 Don_rad%cell_liquid_size(:,:,:) + cell_liquid_eff_diam
        endif

!----------------------------------------------------------------------
!     cell ice size may be either specified using a default value or
!     an input value supplied via the namelist.
!----------------------------------------------------------------------
        if (Initialized%do_default_cell_ice_size) then
          Don_rad%cell_ice_size(:,:,:) = &
                                Don_rad%cell_ice_size(:,:,:) +    &
                                          Param%cell_ice_geneff_diam_def
        else if (Initialized%do_input_cell_ice_size) then
          Don_rad%cell_ice_size(:,:,:) = &
                              Don_rad%cell_ice_size(:,:,:) +      &
                                           Nml%cell_ice_geneff_diam_input
        endif

!----------------------------------------------------------------------
!    define the cell properties needed by the radiation package (cloud 
!    fraction, liquid amount, ice amount, liquid droplet size, ice eff- 
!    ective size) for the case where the fields are not time-averaged.
!----------------------------------------------------------------------
      else
        Don_rad%cell_cloud_frac(:,:,:) = &
                             MAX (0.0, cual(:,:,:) - meso_area(:,:,:) )
        Don_rad%cell_liquid_amt(:,:,:) = cuql(:,:,:)
        Don_rad%cell_ice_amt(:,:,:)    = cuqi(:,:,:)

!----------------------------------------------------------------------
!     cell liquid size may be either specified via a namelist variable
!     or defined based on the bower parameterization.
!----------------------------------------------------------------------
        if (Initialized%do_input_cell_liquid_size) then
          Don_rad%cell_liquid_size(:,:,:) =       &
                                          Nml%cell_liquid_eff_diam_input
        else if (Initialized%do_bower_cell_liquid_size) then
          Don_rad%cell_liquid_size(:,:,:) = cell_liquid_eff_diam
        endif

!----------------------------------------------------------------------
!     cell ice size may be either specified using a default value or
!     an input value supplied via the namelist.
!----------------------------------------------------------------------
        if (Initialized%do_default_cell_ice_size) then
          Don_rad%cell_ice_size(:,:,:)  = Param%cell_ice_geneff_diam_def
        else if (Initialized%do_input_cell_ice_size) then
          Don_rad%cell_ice_size(:,:,:) = Nml%cell_ice_geneff_diam_input
        endif
      endif

!--------------------------------------------------------------------


end subroutine don_r_donner_deep_sum_k

               module column_diagnostics_mod



use mpp_io_mod,             only:  mpp_io_init, mpp_open, MPP_ASCII, &
                                   MPP_OVERWR, MPP_SEQUENTIAL,   &
                                   MPP_MULTI, mpp_close
use fms_mod,                only:  fms_init, mpp_pe, mpp_root_pe, &
                                   file_exist, check_nml_error, &
                                   error_mesg, FATAL, NOTE, WARNING, &
                                   close_file, open_namelist_file, &
                                   stdlog, write_version_number
use time_manager_mod,       only:  time_manager_init, month_name, &
                                   get_date, time_type
use constants_mod,          only:  constants_init, PI, RADIAN
use mpp_mod,                only:  input_nml_file

!-------------------------------------------------------------------

implicit none
private

!---------------------------------------------------------------------
!       module to locate and mark desired diagnostic columns         
!
!
!--------------------------------------------------------------------
  



!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------


character(len=128)  :: version =  '$Id$'
character(len=128)  :: tag     =  '$Name$'



!---------------------------------------------------------------------
!-------  interfaces --------

public    column_diagnostics_init,  &
          initialize_diagnostic_columns,  &
          column_diagnostics_header,   &
          close_column_diagnostics_units


!private 


!--------------------------------------------------------------------
!----    namelist -----

real          :: crit_xdistance = 4.0   
                 ! model grid points must be within crit_xdistance in 
                 ! longitude of the requested diagnostics point 
                 ! coordinates in order to be flagged as the desired
                 ! point 
                 ! [ degrees ]
real          :: crit_ydistance = 4.0   
                 ! model grid points must be within crit_ydistance in 
                 ! latitude of the requested diagnostics point 
                 ! coordinates in order to be flagged as the desired
                 ! point 
                 ! [ degrees ]

namelist / column_diagnostics_nml /              &
                                      crit_xdistance, &
                                      crit_ydistance

!--------------------------------------------------------------------
!-------- public data  -----


!--------------------------------------------------------------------
!------ private data ------


logical    :: module_is_initialized = .false.

!-------------------------------------------------------------------
!-------------------------------------------------------------------



                        contains



!####################################################################

subroutine column_diagnostics_init 

!--------------------------------------------------------------------
!    column_diagnostics_init is the constructor for 
!    column_diagnostics_mod.
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!    local variables:
!
      integer    :: unit, ierr, io

!--------------------------------------------------------------------
!   local variables:
!
!       unit       unit number for nml file
!       ierr       error return flag
!       io         error return code
!
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!    if routine has already been executed, return.
!--------------------------------------------------------------------
      if (module_is_initialized) return

!---------------------------------------------------------------------
!    verify that all modules used by this module have been initialized.
!----------------------------------------------------------------------
      call mpp_io_init
      call fms_init
      call time_manager_init
      call constants_init
 
!---------------------------------------------------------------------
!    read namelist.
!---------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, column_diagnostics_nml, iostat=io)
      ierr = check_nml_error (io, 'column_diagnostics_nml')
#else
      if (file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read (unit, nml=column_diagnostics_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'column_diagnostics_nml')
        enddo
10      call close_file (unit)
      endif
#endif 
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number (version, tag)
      if (mpp_pe() == mpp_root_pe())    then
                    unit = stdlog()
                    write (unit, nml=column_diagnostics_nml)
      endif
!--------------------------------------------------------------------
      module_is_initialized = .true.


end subroutine column_diagnostics_init 



!####################################################################


subroutine initialize_diagnostic_columns     &
                   (module, num_diag_pts_latlon, num_diag_pts_ij,  &
                    global_i , global_j , global_lat_latlon,   &
                    global_lon_latlon, lonb_in, latb_in,  &
                    do_column_diagnostics,  &
                    diag_lon, diag_lat, diag_i, diag_j, diag_units)

!---------------------------------------------------------------------
!    initialize_diagnostic_columns returns the (i, j, lat, lon) coord-
!    inates of any diagnostic columns that are located on the current
!    processor.
!----------------------------------------------------------------------

!---------------------------------------------------------------------
character(len=*),      intent(in)    :: module
integer,               intent(in)    :: num_diag_pts_latlon,  &
                                        num_diag_pts_ij
integer, dimension(:), intent(in)    :: global_i, global_j   
real   , dimension(:), intent(in)    :: global_lat_latlon,    &
                                        global_lon_latlon 
real,    dimension(:,:), intent(in)  :: lonb_in, latb_in
logical, dimension(:,:), intent(out) :: do_column_diagnostics
integer, dimension(:), intent(inout) :: diag_i, diag_j        
real   , dimension(:), intent(out)   :: diag_lat, diag_lon
integer, dimension(:), intent(out)   :: diag_units
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    intent(in) variables:
!
!       module                module calling this subroutine
!       num_diag_pts_latlon   number of diagnostic columns specified
!                             by lat-lon  coordinates
!       num_diag_pts_ij       number of diagnostic columns specified
!                             by global (i,j) coordinates
!       global_i              specified global i coordinates
!       global_j              specified global j coordinates
!       global_lat_latlon     specified global lat coordinates
!       global_lon_latlon     specified global lon coordinates
!
!    intent(out) variables:
!
!       do_column_diagnostics is a diagnostic column in this jrow ?
!       diag_i                processor i indices of diagnstic columns
!       diag_j                processor j indices of diagnstic columns
!       diag_lat              latitudes of diagnostic columns 
!                             [ degrees ]
!       diag_lon              longitudes of diagnostic columns 
!                             [ degrees ]
!       diag_units            unit number for each diagnostic column
!
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!    local variables:

      real, dimension(size(diag_i,1))     :: global_lat, global_lon
      real, dimension(size(latb_in,1)-1, size(latb_in,2)-1) ::  &
                                  distance, distance_x, distance_y, &
                                   distance_x2, distance2
      real, dimension(size(latb_in,1), size(latb_in,2)) :: latb_deg
      real, dimension(size(lonb_in,1), size(lonb_in,2)) :: lonb_deg
      real       :: dellat, dellon
      real       :: latb_max, latb_min, lonb_max, lonb_min

      integer            ::  num_diag_pts
      integer            ::  i, j, nn
      real               ::  ref_lat
      real               ::  current_distance
      character(len=8)   ::  char
      character(len=32)  ::  filename
      logical            ::  allow_ij_input
      logical            ::  open_file        

!--------------------------------------------------------------------
!    local variables:
!
!       global_lat      latitudes for all diagnostic columns [ degrees ]
!       global_lon      longitudes for all diagnostic columns 
!                       [ degrees ]
!       num_diag_pts    total number of diagnostic columns
!       i, j, nn        do loop indices
!       char            character string for diaganostic column index
!       filename        filename for output file for diagnostic column 
!
!---------------------------------------------------------------------

      if (.not. module_is_initialized) call column_diagnostics_init

!--------------------------------------------------------------------
!    save the input lat and lon fields. define the delta of latitude
!    and longitude.
!--------------------------------------------------------------------
      latb_deg = latb_in*RADIAN
      lonb_deg = lonb_in*RADIAN
      dellat = latb_in(1,2) - latb_in(1,1)
      dellon = lonb_in(2,1) - lonb_in(1,1)
      latb_max = MAXVAL (latb_deg(:,:))
      latb_min = MINVAL (latb_deg(:,:))
      lonb_max = MAXVAL (lonb_deg(:,:))
      lonb_min = MINVAL (lonb_deg(:,:))
      if (lonb_min < 10.0 .or. lonb_max > 350.) then
        lonb_min = 0.
        lonb_max = 360.0
      endif

      allow_ij_input = .true.
      ref_lat = latb_in(1,1)
      do i =2,size(latb_in,1)
        if (latb_in(i,1) /= ref_lat) then
          allow_ij_input = .false.
          exit
        endif
      end do

      if ( .not. allow_ij_input .and. num_diag_pts_ij /= 0) then
        call error_mesg ('column_diagnostics_mod', &
        'cannot specify column diagnostics column with (i,j) &
           &coordinates when using cubed sphere -- must specify &
                                    & lat/lon coordinates', FATAL)
      endif

!----------------------------------------------------------------------
!    initialize column_diagnostics flag and diag unit numbers. define 
!    total number of diagnostic columns.
!----------------------------------------------------------------------
      do_column_diagnostics = .false.
      diag_units(:) = -1
      diag_i(:) = -99
      diag_j(:) = -99
      diag_lat(:) = -999.
      diag_lon(:) = -999.
      num_diag_pts = size(diag_i(:))

!--------------------------------------------------------------------
!    define an array of lat-lon values for all diagnostic columns.
!--------------------------------------------------------------------
      do nn = 1, num_diag_pts_latlon
        global_lat(nn) = global_lat_latlon(nn)
        global_lon(nn) = global_lon_latlon(nn)
      end do

      do nn = 1, num_diag_pts_ij
        global_lat(nn+num_diag_pts_latlon) =    &
                         ((-0.5*acos(-1.0) + 0.5*dellat) + &
                         (global_j (nn)-1) *dellat)*RADIAN
        global_lon(nn+num_diag_pts_latlon) = (0.5*dellon +     &
                          (global_i (nn)-1)*dellon)*RADIAN
      end do   

!----------------------------------------------------------------------
!    loop over all diagnostic points to check for their presence on 
!    this processor.
!----------------------------------------------------------------------
      do nn=1,num_diag_pts
        open_file = .false.

!----------------------------------------------------------------------
!    verify that the values of lat and lon are valid.
!----------------------------------------------------------------------
        if (global_lon(nn) >= 0. .and. global_lon(nn) <= 360.0) then
        else
          call error_mesg ('column_diagnostics_mod', &
               ' invalid longitude', FATAL)
        endif
        if (global_lat(nn) >= -90.0 .and. global_lat(nn) <= 90.0) then 
        else
          call error_mesg ('column_diagnostics_mod', &
               ' invalid latitude', FATAL)
        endif

!--------------------------------------------------------------------
!    if the desired diagnostics column is within the current 
!    processor's domain, define the total and coordinate distances from
!    each of the processor's grid points to the diagnostics point. 
!--------------------------------------------------------------------

        if (global_lat(nn) .ge. latb_min .and.  &
            global_lat(nn) .le. latb_max) then
          if (global_lon(nn) .ge. lonb_min     .and.&
              global_lon(nn) .le. lonb_max)  then
            do j=1,size(latb_deg,2) - 1
              do i=1,size(lonb_deg,1) - 1
                distance_y(i,j) = ABS(global_lat(nn) - latb_deg(i,j))
                distance_x(i,j) = ABS(global_lon(nn) - lonb_deg(i,j))
                distance_x2(i,j) = ABS((global_lon(nn)-360.) -  &
                                                       lonb_deg(i,j))
                distance(i,j) = (global_lat(nn) - latb_deg(i,j))**2 + &
                                (global_lon(nn) - lonb_deg(i,j))**2
                distance2(i,j) = (global_lat(nn) - latb_deg(i,j))**2 + &
                                 ((global_lon(nn)-360.) -    &
                                                   lonb_deg(i,j))**2
              end do
            end do

!--------------------------------------------------------------------
!    find the grid point on the processor that is within the specified
!    critical distance and also closest to the requested diagnostics 
!    column. save the (i,j) coordinates and (lon,lat) of this model
!    grid point. set a flag indicating that a disgnostics file should
!    be opened on this processor for this diagnostic point.
!--------------------------------------------------------------------
            current_distance = distance(1,1)
            do j=1,size(latb_deg,2) - 1
              do i=1,size(lonb_deg,1) - 1
                if (distance_x(i,j) <= crit_xdistance .and. &
                    distance_y(i,j) <= crit_ydistance ) then  
                  if (distance(i,j) < current_distance) then
                    current_distance = distance(i,j)
                    do_column_diagnostics(i,j) = .true.
                    diag_j(nn) = j
                    diag_i(nn) = i
                    diag_lon(nn) = lonb_deg(i,j)
                    diag_lat(nn) = latb_deg(i,j)
                    open_file = .true.
                  endif
                endif

!---------------------------------------------------------------------
!    check needed because of the 0.0 / 360.0 longitude periodicity.
!---------------------------------------------------------------------
                if (distance_x2(i,j) <= crit_xdistance .and. &
                    distance_y(i,j) <= crit_ydistance ) then  
                  if (distance2(i,j) < current_distance) then
                    current_distance = distance2(i,j)
                    do_column_diagnostics(i,j) = .true.
                    diag_j(nn) = j
                    diag_i(nn) = i
                    diag_lon(nn) = lonb_deg(i,j)
                    diag_lat(nn) = latb_deg(i,j)
                    open_file = .true.
                  endif
                endif
              end do
            end do

!--------------------------------------------------------------------
!    if the point has been found on this processor, open a diagnostics
!    file. 
!--------------------------------------------------------------------
            if (open_file) then
              write (char, '(i2)') nn
              filename = trim(module) // '_point' //    &
                         trim(adjustl(char)) // '.out'
              call mpp_open (diag_units(nn), filename, &
                             form=MPP_ASCII, &
                             action=MPP_OVERWR,  &
                             access=MPP_SEQUENTIAL,  &
                             threading=MPP_MULTI, nohdrs=.true.)
            endif  ! (open_file)
          endif
        endif
      end do

!---------------------------------------------------------------------


end subroutine initialize_diagnostic_columns




!####################################################################

subroutine column_diagnostics_header     &
                              (module, diag_unit, Time, nn, diag_lon, &
                               diag_lat, diag_i, diag_j)

!--------------------------------------------------------------------
!    column_diagnostics_header writes out information concerning
!    time and location of following data into the column_diagnostics
!    output file.
!--------------------------------------------------------------------

!--------------------------------------------------------------------
character(len=*),      intent(in)  :: module
type(time_type),       intent(in)  :: Time 
integer,               intent(in)  :: diag_unit
integer,               intent(in)  :: nn
real,    dimension(:), intent(in)  :: diag_lon, diag_lat
integer, dimension(:), intent(in)  :: diag_i, diag_j         

!--------------------------------------------------------------------
!    intent(in) variables
!
!       module     module name calling this subroutine
!       Time       current model time [ time_type ]
!       diag_unit  unit number for column_diagnostics output
!       nn         index of diagnostic column currently active
!       diag_lon   longitude of current diagnostic column [ degrees ]
!       diag_lat   latitude of current diagnostic column [ degrees ]
!       diag_i     i coordinate of current diagnostic column
!       diag_j     j coordinate of current diagnostic column
!
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!     local variables:

      integer           :: year, month, day, hour, minute, second 
      character(len=8)  :: mon
      character(len=64) :: header

!--------------------------------------------------------------------
!     local variables:
!    
!       year, month, day, hour, minute, seconds   
!                      integers defining the current time
!       mon            character string for the current month
!       header         title for the output 
!        
!--------------------------------------------------------------------

      if (.not. module_is_initialized) call column_diagnostics_init

!--------------------------------------------------------------------
!    convert the time type to a date and time for printing. convert 
!    month to a character string.
!--------------------------------------------------------------------
      call get_date (Time, year, month, day, hour, minute, second)
      mon = month_name(month)

!---------------------------------------------------------------------
!    write timestamp and column location information to the diagnostic
!    columns output unit.
!---------------------------------------------------------------------
      write (diag_unit,'(a)')  ' '
      write (diag_unit,'(a)')  ' '
      write (diag_unit,'(a)')   &
              '======================================================'
      write (diag_unit,'(a)')  ' '
      header = '               PRINTING ' // module // '  DIAGNOSTICS' 
      write (diag_unit,'(a)')  header                          
      write (diag_unit,'(a)')  ' '
      write (diag_unit,'(a, i6,2x, a,i4,i4,i4,i4)')  ' time stamp:',  &
                                           year, trim(mon), day, &
                                           hour, minute, second
      write (diag_unit,'(a, i4)')      &
            ' DIAGNOSTIC POINT COORDINATES, point #', nn
      write (diag_unit,'(a)')  ' '
      write (diag_unit,'(a,f8.3,a,f8.3)') ' longitude = ',    &
                   diag_lon(nn), ' latitude  = ', diag_lat(nn)
      write (diag_unit,'(a, i6, a,i6,a,i6)')    &
                               ' on processor # ', mpp_pe(),   &
                               ' :   processor i =', diag_i(nn),     &
                               ' ,   processor j =', diag_j(nn)
      write (diag_unit,'(a)')  ' '

!---------------------------------------------------------------------



end subroutine column_diagnostics_header



!######################################################################

subroutine close_column_diagnostics_units (diag_units)

!---------------------------------------------------------------------
!    close_column_diagnostics_units closes any open column_diagnostics
!    files associated with the calling module.
!----------------------------------------------------------------------

!----------------------------------------------------------------------
integer, dimension(:), intent(in)  :: diag_units
!----------------------------------------------------------------------

!--------------------------------------------------------------------
!    intent(in) variable:
!
!      diag_units    array of column diagnostic unit numbers
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!    local variable

      integer   :: nn    ! do loop index

!--------------------------------------------------------------------
!    close the unit associated with each diagnostic column.
!--------------------------------------------------------------------
      do nn=1, size(diag_units(:))
        if (diag_units(nn) /= -1) then
          call mpp_close (diag_units(nn))
        endif
      end do

!---------------------------------------------------------------------


end subroutine close_column_diagnostics_units


!#####################################################################




               end module column_diagnostics_mod

                 module cloud_spec_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  ds
! </REVIEWER>
! <OVERVIEW>
!    cloud_spec_mod defines the variables that are used in a partic-
!    ular cloud parameterization to specify the cloud location, cloud
!    type and cloud magnitude for the active cloud parameterization(s).
! </OVERVIEW>
! <DESCRIPTION>
!    if microphysically-based radiative properties are desired, then
!    cloud_spec_mod also provides the microphysical parameters used in
!    determining the radiative properties, either from the cloud scheme
!    itself if they are present, or from a prescribed formula based on
!    prescribed water paths for high, middle and low clouds.
! </DESCRIPTION>

!   shared modules:

use time_manager_mod,         only: time_type, time_manager_init, &
                                    set_time, operator (+)
use mpp_mod,                  only: input_nml_file
use fms_mod,                  only: open_namelist_file, mpp_pe, &
                                    mpp_root_pe, stdlog,  fms_init, &
                                    write_version_number, file_exist, & 
                                    check_nml_error, error_mesg,   &
                                    FATAL, NOTE, close_file
use tracer_manager_mod,       only:         &
!                                   tracer_manager_init,  &
                                    get_tracer_index, NO_TRACER
use field_manager_mod,        only:       &
                                    field_manager_init, &
                                    MODEL_ATMOS
use data_override_mod,        only: data_override
use random_numbers_mod,    only:  randomNumberStream,   &
                                  initializeRandomNumberStream, &
                                  getRandomNumbers,             &
                                  constructSeed
use cloud_generator_mod,   only:  cloud_generator_init, &
                                  cloud_generator_end
use constants_mod,         only : radian, RDGAS

! shared radiation package modules:

use rad_utilities_mod,        only: rad_utilities_init, &
                                    cld_specification_type, &
                                    atmos_input_type, &
                                    surface_type, &
                                    Rad_control, &
                                    microphysics_type,  &         
                                    Cldrad_control
use esfsw_parameters_mod,     only: esfsw_parameters_init, Solar_spect

! interface modules to various cloud parameterizations:

use strat_clouds_W_mod,       only: strat_clouds_W_init,   &
                                    strat_clouds_amt, strat_clouds_W_end
use diag_clouds_W_mod,        only: diag_clouds_W_init,   &
                                    diag_clouds_amt, &
                                    diag_clouds_W_end
use zetac_clouds_W_mod,       only: zetac_clouds_W_init,   &
                                    zetac_clouds_amt, &
                                    zetac_clouds_W_end
use specified_clouds_W_mod,   only: specified_clouds_W_init, &
                                    specified_clouds_amt, &
                                    specified_clouds_W_end
use rh_based_clouds_mod,      only: rh_based_clouds_init,  &
                                    rh_clouds_amt, &
                                    rh_based_clouds_end
use donner_deep_clouds_W_mod, only: donner_deep_clouds_W_init, &
                                    donner_deep_clouds_amt, &
                                    donner_deep_clouds_W_end
use uw_clouds_W_mod,          only: uw_clouds_W_init, &
                                    uw_clouds_amt, &
                                    uw_clouds_W_end
use mgrp_prscr_clds_mod,      only: mgrp_prscr_clds_init, &
                                    prscr_clds_amt,  & 
                                    mgrp_prscr_clds_end 
use standalone_clouds_mod,    only: standalone_clouds_init, &
                                    standalone_clouds_amt, &
                                    standalone_clouds_end
                                 
!--------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!    cloud_spec_mod defines the variables that are used in a partic-
!    ular cloud parameterization to specify the cloud location, cloud
!    type and cloud magnitude for the active cloud parameterization(s).
!    if microphysically-based radiative properties are desired, then
!    cloud_spec_mod also provides the microphysical parameters used in
!    determining the radiative properties, either from the cloud scheme
!    itself if they are present, or from a prescribed formula based on
!    prescribed water paths for high, middle and low clouds.
!--------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module --------------------------

character(len=128)  :: version =  '$Id: cloud_spec.F90,v 20.0 2013/12/13 23:19:01 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!---------------------------------------------------------------------
!-------  interfaces --------

public          &
         cloud_spec_init, cloud_spec,    &
         cloud_spec_dealloc, cloud_spec_end

private    &

!  called from cloud_spec:
         initialize_cldamts, microphys_presc_conc,  &
         combine_cloud_properties


!---------------------------------------------------------------------
!-------- namelist  ---------

character(len=16)  ::      &
              cloud_type_form = '     ' ! cloud parameterization being 
                                        ! used; either 'strat', 'rh', 
                                        ! 'deep',  'stratdeep', 'zonal',
                                        ! 'obs', 'prescribed', 'diag', 
                                        ! 'none', 'specified', 'zetac'
                                        ! 'specified_strat', 'stratuw',
                                        ! 'stratdeepuw', 'uw', 'deepuw
                                        ! or 'not_sea_esf'       
real :: wtr_cld_reff=10.                ! assumed cloud drop efective
                                        ! radius [ microns ]  
real :: ice_cld_reff=50.                ! assumed ice cloud effective
                                        ! size [ microns ]
real :: rain_reff=250.                  ! assumed rain drop effective
                                        ! radius [ microns ]
character(len=16) :: overlap_type = 'random'    
                                        ! cloud overlap assumption; 
                                        ! allowable values are 'random'
                                        ! or 'max-random'  
logical :: doing_data_override=.false.
logical :: do_fu2007 = .false.
logical :: do_rain   = .false. !sjl
logical :: do_snow   = .false. !miz
logical :: do_graupel  = .false. !sjl
logical :: force_use_of_temp_for_seed = .false.  
                                        ! if true, when using stochastic 
                                        ! clouds, force the seed to use 
                                        ! top-model-level temps as input to
                                        ! random number generator
                                        ! (needed for some 
                                        ! specialized applications)
logical :: ignore_donner_cells = .false.! when set to .true., the effects 
                                        ! of donner cell clouds in the
                                        ! radiation code are ignored
logical :: do_legacy_seed_generation = .false.
                                        ! setting this variable to .true.
                                        ! (not recommended except to
                                        ! reproduce previous results) will
                                        ! activate the seed generation
                                        ! scheme used previously (through
                                        ! the siena code). this scheme may
                                        ! exhibit flaws at hi-res or when
                                        ! time is held fixed in the 
                                        ! radiation calculation. 

namelist /cloud_spec_nml / cloud_type_form, wtr_cld_reff,   &
                           ice_cld_reff, rain_reff, overlap_type, &
                           doing_data_override, do_fu2007,    &
                           do_rain, do_snow, do_graupel, &
                           do_legacy_seed_generation, &
                           force_use_of_temp_for_seed, ignore_donner_cells

!----------------------------------------------------------------------
!----  public data -------


!----------------------------------------------------------------------
!----  private data -------

!--------------------------------------------------------------------
!    assumed water paths.
!--------------------------------------------------------------------
real   ::  lwpath_hi  = 6.313929   ! assumed water path for high clouds
                                   ! [ grams / m**2 ]
real   ::  lwpath_mid = 18.94179   ! assumed water path for middle 
                                   ! clouds [ grams / m**2 ]
real   ::  lwpath_low = 75.76714   ! assumed water path for low clouds
                                   ! [ grams / m**2 ]

!---------------------------------------------------------------------
!    logical  flags.

logical :: module_is_initialized = .false.   ! module initialized ?

!---------------------------------------------------------------------
!    time-step related constants.

integer :: num_pts       !  number of grid columns processed so far that
                         !  have cloud data present (used to identify
                         !  module coldstart condition)
integer :: tot_pts       !  total number of grid columns in the 
                         !  processor's domain

!---------------------------------------------------------------------
!     indices for cloud tracers

integer :: nql           ! tracer index for liquid water
integer :: nqi           ! tracer index for ice water
integer :: nqa           ! tracer index for cloud area
integer :: nqn           ! tracer index for cloud droplet number
integer :: nqni          ! tracer index for ice crystal number
integer :: nqr, nqs, nqg ! tracer index for rainwat, snowwat and graupel           

!----------------------------------------------------------------------
!   variables needed for random number seed:
!----------------------------------------------------------------------
real, dimension(:,:), allocatable  :: lats, lons ! lat and lon of columns
                                               ! in this processor's
                                               ! domain [ degrees ]

!---------------------------------------------------------------------
!     miscellaneous variables:

integer :: num_slingo_bands  ! number of radiative bands over which 
                             ! cloud optical depth is calculated in the
                             ! gordon diag_cloud parameterization
integer :: id, jd, kmax

!----------------------------------------------------------------------
!----------------------------------------------------------------------



                         contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!#####################################################################
! <SUBROUTINE NAME="cloud_spec_init">
!  <OVERVIEW>
!   Contructor of cloud_spec_package module
!  </OVERVIEW>
!  <DESCRIPTION>
!   Contructor of cloud_spec_package module
!  </DESCRIPTION>
!  <TEMPLATE>
!   call cloud_spec_init ( pref, lonb, latb, axes, Time)
!  </TEMPLATE>
!  <IN NAME="pref" TYPE="real">
!   reference pressure levels containing two reference pressure profiles 
!                 for use in defining transmission functions [ Pa ]
!  </IN>
!  <IN NAME="lonb" TYPE="real">
!   the longitude array of the model grid box corners
!  </IN>
!  <IN NAME="latb" TYPE="real">
!   the latitude array of the model grid box corners
!  </IN>
!  <IN NAME="axes" TYPE="real">
!   diagnostic variable axes for netcdf files
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!   current time [ time_type(days, seconds) ]
!  </IN>
! </SUBROUTINE>
! 
subroutine cloud_spec_init (pref, lonb, latb, axes, Time,  &
                            cloud_type_form_out)

!---------------------------------------------------------------------
!    cloud_spec_init is the constructor for cloud_spec_mod.
!---------------------------------------------------------------------

real, dimension(:,:),     intent(in)   ::  pref        
real, dimension(:,:),     intent(in)   ::  lonb, latb
integer, dimension(4),    intent(in)   ::  axes
type(time_type),          intent(in)   ::  Time
character(len=16),        intent(out)  ::  cloud_type_form_out

!-------------------------------------------------------------------
!    intent(in) variables:
!
!       pref      array containing two reference pressure profiles 
!                 for use in defining transmission functions [ Pa ]
!       lonb      array of model longitudes at cell corners [ radians ]
!       latb      array of model latitudes at cell corners [radians]
!       axes      diagnostic variable axes
!       Time      current time [time_type(days, seconds)]
!
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!   local variables:
 
      integer   ::   unit, ierr, io, logunit
      integer   ::   ndum, i, j, ii, jj
      

!--------------------------------------------------------------------
!   local variables:
!
!      unit     io unit for reading nml file and writing logfile
!      ierr     error code
!      io       error status returned from io operation  
!      ndum     dummy argument needed for call to field_manager_init
!
!--------------------------------------------------------------------
 
!---------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return

!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call time_manager_init
      call rad_utilities_init
      call field_manager_init (ndum)
      call esfsw_parameters_init
!  not yet compliant:
!     call tracer_manager_init  ! not public
 
!---------------------------------------------------------------------
!    read namelist.
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=cloud_spec_nml, iostat=io)
      ierr = check_nml_error(io,"cloud_spec_nml")
#else
!---------------------------------------------------------------------
      if (file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read (unit, nml=cloud_spec_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'cloud_spec_nml')
        enddo
10      call close_file (unit)
      endif
#endif

!----------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
           write (logunit, nml=cloud_spec_nml)

      id = size(lonb,1) - 1
      jd = size(latb,2) - 1
      kmax = size(pref,1) - 1

!-----------------------------------------------------------------------
!    define output field.
!-----------------------------------------------------------------------
      cloud_type_form_out = cloud_type_form

!--------------------------------------------------------------------
!    verify a valid type of cloud overlap. set logical variables
!    based on the namelist value.
!--------------------------------------------------------------------
      if (trim(overlap_type) == 'random') then
        Cldrad_control%do_random_overlap = .true.
      else if (trim(overlap_type) == 'max-random') then
        Cldrad_control%do_max_random_overlap = .true.
      else
        call error_mesg ('cloud_spec_mod',  &
         ' invalid specification of overlap_type', FATAL)
      endif

!-------------------------------------------------------------------
!    set the variables indicating that the above control variables have
!    been set.
!--------------------------------------------------------------------
      Cldrad_control%do_random_overlap_iz = .true.
      Cldrad_control%do_max_random_overlap_iz = .true.

!--------------------------------------------------------------------
!    if the sea-esf radiation package is not being used, then 
!    cloud_type_form will have been set to 'not_sea_esf'. in such a
!    case, the clouds will be specified internally within the 
!    radiation_driver_mod, so simply return.
!--------------------------------------------------------------------
      if (trim(cloud_type_form) == 'not_sea_esf')  return
        
!-------------------------------------------------------------------
!    verify that the nml variable cloud_type_form specifies a valid
!    cloud parameterization. set the appropriate logical control
!    variable(s) to .true.. call the constructor modules for the
!    specific cloud scheme(s) requested.
!-------------------------------------------------------------------
      if (trim(cloud_type_form) == 'strat')  then

!-------------------------------------------------------------------
!    cloud fractions, heights are predicted by the model based on klein 
!    parameterization. strat is an acceptable option both for standalone
!    and gcm applications.
!-------------------------------------------------------------------
        Cldrad_control%do_strat_clouds = .true.
        call strat_clouds_W_init(latb, lonb)

      else if (trim(cloud_type_form) == 'specified_strat')  then
        Cldrad_control%do_specified_strat_clouds = .true.
        Cldrad_control%do_strat_clouds = .true.
        call strat_clouds_W_init(latb, lonb)
        call standalone_clouds_init (pref, lonb, latb)

!-------------------------------------------------------------------
!    cloud fractions, heights are diagnosed based on model relative 
!    humidity.
!-------------------------------------------------------------------
          else if (trim(cloud_type_form)  == 'rh')   then
            Cldrad_control%do_rh_clouds = .true.
            call rh_based_clouds_init 

!-------------------------------------------------------------------
!    cloud fractions, heights are predicted by the donner deep cloud 
!    (cell cloud, anvil cloud) scheme.
!-------------------------------------------------------------------
          else if (trim(cloud_type_form) == 'deep')  then
            Cldrad_control%do_donner_deep_clouds = .true.
            call donner_deep_clouds_W_init (pref, lonb, latb,   &
                                            axes, Time)
!RSH 3/6/13: The following call added to allow stochastic clouds to be 
!            run for this case. Ultimately, the do_stochastic_clouds nml 
!            variable should be moved to cloud_spec_nml.
            call strat_clouds_W_init(latb, lonb)

!------------------------------------------------------------------
!    cloud fractions, heights are provided by the uw_conv shallow
!    convection scheme  
!-------------------------------------------------------------------
          else if (trim(cloud_type_form) == 'uw')  then
            Cldrad_control%do_uw_clouds = .true.
            call uw_clouds_W_init (pref, lonb, latb,   &
                                             axes, Time)
!RSH 3/6/13: The following call added to allow stochastic clouds to be 
!            run for this case. Ultimately, the do_stochastic_clouds nml 
!            variable should be moved to cloud_spec_nml.
            call strat_clouds_W_init(latb, lonb)

!-------------------------------------------------------------------
!    cloud fractions, heights are a combination of the donner
!    deep cloud (cell cloud, anvil cloud) and klein large-scale cloud
!    parameterizations.
!-------------------------------------------------------------------
          else if (trim(cloud_type_form) == 'stratdeep')  then
            Cldrad_control%do_strat_clouds = .true.
            Cldrad_control%do_donner_deep_clouds = .true.
            call strat_clouds_W_init(latb, lonb)
            call donner_deep_clouds_W_init (pref, lonb, latb,   &
                                            axes, Time)

!-------------------------------------------------------------------
!    cloud fractions, heights are provided by the donner deep convection
!    (cell cloud, anvil cloud) and uw_conv shallow convection
!    cloud parameterizations.
!-------------------------------------------------------------------
         else if (trim(cloud_type_form) == 'deepuw')  then
           Cldrad_control%do_donner_deep_clouds = .true.
           Cldrad_control%do_uw_clouds = .true.
           call donner_deep_clouds_W_init (pref, lonb, latb,   &
                                             axes, Time)
           call uw_clouds_W_init (pref, lonb, latb,   &
                                            axes, Time)
!RSH 3/6/13: The following call added to allow stochastic clouds to be 
!            run for this case. Ultimately, the do_stochastic_clouds nml 
!            variable should be moved to cloud_spec_nml.
            call strat_clouds_W_init(latb, lonb)

!-------------------------------------------------------------------
!    cloud fractions, heights are provided by the klein large-scale
!    and uw_conv shallow convection cloud parameterizations.
!-------------------------------------------------------------------
        else if (trim(cloud_type_form) == 'stratuw')  then
          Cldrad_control%do_strat_clouds = .true.
          Cldrad_control%do_uw_clouds = .true.
          call strat_clouds_W_init(latb, lonb)
          call uw_clouds_W_init (pref, lonb, latb,   &
                                             axes, Time)

!-------------------------------------------------------------------
!    cloud fractions, heights are provided by the klein large-scale
!    the donner deep convection (cell cloud, anvil cloud) and the
!    uw_conv shallow convection cloud parameterizations.
!-------------------------------------------------------------------
       else if (trim(cloud_type_form) == 'stratdeepuw')  then
         Cldrad_control%do_strat_clouds = .true.
         Cldrad_control%do_donner_deep_clouds = .true.
         Cldrad_control%do_uw_clouds = .true.
         call strat_clouds_W_init(latb, lonb)
         call donner_deep_clouds_W_init (pref, lonb, latb,   &
                                            axes, Time)
         call uw_clouds_W_init (pref, lonb, latb,   &
                                            axes, Time)

!---------------------------------------------------------------
!    cloud fractions, heights are prescribed as zonally uniform using
!    the original fms specification.
!-------------------------------------------------------------------
          else if (trim(cloud_type_form) == 'zonal')  then
            Cldrad_control%do_zonal_clouds = .true.
            call specified_clouds_W_init (lonb, latb)

!-------------------------------------------------------------------
!    cloud fractions, heights are based on observed data set.
!-------------------------------------------------------------------
          else if (trim(cloud_type_form) == 'obs')  then
            Cldrad_control%do_obs_clouds = .true.
            call specified_clouds_W_init (lonb, latb)

!-------------------------------------------------------------------
!    cloud fractions, heights are prescribed as zonally invariant, using
!    the formulation from skyhi, with the ability to use a prescribed
!    microphysics. WILL ONLY WORK WITH REGULAR LAT/LON GRID
!-------------------------------------------------------------------
          else if (trim(cloud_type_form)  == 'prescribed')  then
            Cldrad_control%do_mgroup_prescribed = .true.
            call mgrp_prscr_clds_init (pref, latb(1,:))

!-------------------------------------------------------------------
!    model is run with gordon diagnostic clouds.
!-------------------------------------------------------------------
          else if (trim(cloud_type_form)  == 'diag')  then
            Cldrad_control%do_diag_clouds = .true.
            call diag_clouds_W_init (num_slingo_bands)

!-------------------------------------------------------------------
!    model is run with zetac clouds.
!-------------------------------------------------------------------
          else if (trim(cloud_type_form)  == 'zetac')  then
            Cldrad_control%do_zetac_clouds = .true.
            call zetac_clouds_W_init 
 
!-------------------------------------------------------------------
!    model is run without clouds.
!-------------------------------------------------------------------
          else if (trim(cloud_type_form) == 'none')  then
            Cldrad_control%do_no_clouds = .true.

!-------------------------------------------------------------------
!    model is run with specified clouds and cloud properties.
!-------------------------------------------------------------------
          else if (trim(cloud_type_form)  == 'specified')  then
            Cldrad_control%do_specified_clouds = .true.
            call standalone_clouds_init (pref, lonb, latb)

!-------------------------------------------------------------------
!    failure message if none of the above options was chosen.
!-------------------------------------------------------------------
          else
            call error_mesg ('cloud_spec_mod',  &
              'invalid cloud_type_form specified', FATAL)
      endif  ! (strat)

!--------------------------------------------------------------------
!    define the dimensions of the model subdomain assigned to the 
!    processor.
!--------------------------------------------------------------------
      tot_pts = (size(latb,2)-1)*(size(lonb,1)-1)

!--------------------------------------------------------------------
!    determine if the current run is cold-starting this module. if a 
!    restart file is present, then this is not a coldstart. in that case
!    set num_pts to tot_pts so that if cloud data is not available an 
!    error message can be generated. if this is a coldstart, cloud data
!    will not be available until num_pts equals or exceeds tot_pts, so
!    continue processing without issuing an error message. 
!--------------------------------------------------------------------
      if (file_exist ('INPUT/tracer_cld_amt.res') .or.  &
          file_exist ('INPUT/strat_cloud.res') ) then
        num_pts = tot_pts
      else
        num_pts = 0
      endif

!---------------------------------------------------------------------
!    obtain the tracer indices for the strat_cloud variables when
!    running gcm.
!---------------------------------------------------------------------
        if (Cldrad_control%do_strat_clouds .or.  &
            Cldrad_control%do_zetac_clouds) then
          nql = get_tracer_index ( MODEL_ATMOS, 'liq_wat' )
          nqi = get_tracer_index ( MODEL_ATMOS, 'ice_wat' )
          nqa = get_tracer_index ( MODEL_ATMOS, 'cld_amt' )

          if (do_rain) then !sjl
             nqr = get_tracer_index ( MODEL_ATMOS, 'rainwat' )
             if (nqr < 0 ) call error_mesg ('cloud_spec_mod', &
                'rainwat tracer not found, but do_rain is true', FATAL)
          end if
          if (do_snow) then !miz
             nqs = get_tracer_index ( MODEL_ATMOS, 'snowwat' )
             if (nqs < 0 ) call error_mesg ('cloud_spec_mod', &
                'snowwat tracer not found, but do_snow is true', FATAL)
          end if
          if (do_graupel) then !sjl
             nqg = get_tracer_index ( MODEL_ATMOS, 'graupel' )
             if (nqg < 0 ) call error_mesg ('cloud_spec_mod', &
                'graupel tracer not found, but do_graupel is true', FATAL)
          end if

          if (mpp_pe() == mpp_root_pe()) &
            write (logunit,'(a,3i4)') 'Stratiform cloud tracer ind&
                &ices: nql,nqi,nqa =',nql,nqi,nqa
          if (min(nql,nqi,nqa) <= 0)   &
             call error_mesg ('cloud_spec_mod', &
             'stratiform cloud tracer(s) not found', FATAL)
          if (nql == nqi .or. nqa == nqi .or. nql == nqa)   &
              call error_mesg ('cloud_spec_mod',  &
            'tracers indices cannot be the same (i.e., nql=nqi=nqa).', &
                                                              FATAL)
          nqn = get_tracer_index ( MODEL_ATMOS, 'liq_drp' )
          if (nqn /= NO_TRACER)  then
            Cldrad_control%do_liq_num = .true.
          else
            Cldrad_control%do_liq_num = .false.
          endif
          nqni = get_tracer_index ( MODEL_ATMOS, 'ice_num' )
          if (nqni /= NO_TRACER)  then
            Cldrad_control%do_ice_num = .true.
          else
            Cldrad_control%do_ice_num = .false.
          endif
        else
          Cldrad_control%do_liq_num = .false.
          Cldrad_control%do_ice_num = .false.
        endif

        Cldrad_control%do_liq_num_iz = .true.
        Cldrad_control%do_ice_num_iz = .true.

!---------------------------------------------------------------------
!    define the variables indicating that the cloud parameterization
!    control variables have been defined.
!---------------------------------------------------------------------
      Cldrad_control%do_rh_clouds_iz = .true.
      Cldrad_control%do_strat_clouds_iz = .true.
      Cldrad_control%do_zonal_clouds_iz = .true.
      Cldrad_control%do_mgroup_prescribed_iz = .true.
      Cldrad_control%do_obs_clouds_iz = .true.
      Cldrad_control%do_no_clouds_iz = .true.
      Cldrad_control%do_diag_clouds_iz = .true.
      Cldrad_control%do_specified_clouds_iz = .true.
      Cldrad_control%do_specified_strat_clouds_iz = .true.
      Cldrad_control%do_donner_deep_clouds_iz = .true.
      Cldrad_control%do_uw_clouds_iz = .true.
      Cldrad_control%do_zetac_clouds_iz = .true.
      Cldrad_control%do_stochastic_clouds_iz = .true.
 
!--------------------------------------------------------------------
!    if stochastic clouds is active, allocate and define arrays holding
!    the processor's latitudes and longitudes. be sure that the
!    cloud_generator module has been initialized.
!--------------------------------------------------------------------
      if (Cldrad_control%do_stochastic_clouds_iz) then
        if (Cldrad_control%do_stochastic_clouds) then
          allocate (lats(size(latb,1),size(latb,2)))
          allocate (lons(size(lonb,1), size(lonb,2)))
          lats(:,:) = latb(:,:)*radian
          lons(:,:) = lonb(:,:)*radian
          call cloud_generator_init

!---------------------------------------------------------------------
!     determine the source of the random number seed generator to be used
!     for the stochastic cloud generation. the legacy scheme may fail to
!     provide spacially unique seeds at hi-res (above c48) or if the time
!     provided the radiation package does not monotonically advance (as in
!     some specialized sensitivity / assessment studies). 
!---------------------------------------------------------------------
          if (do_legacy_seed_generation) then
!---------------------------------------------------------------------
!     if it is desired to force the use of the temperature-based
!     random number seed (as is used when time is not always advancing
!     as seen by the radiation package, or when model resolution is
!     less than 1 degree), set the logical control variable in 
!     Cldrad_control to so indicate. 
!---------------------------------------------------------------------
            if ( force_use_of_temp_for_seed) then
              Cldrad_control%use_temp_for_seed = .true.
              Cldrad_control%use_temp_for_seed_iz = .true.
              call error_mesg ('cloud_spec_init', &
                 'Will use temp as basis for stochastic cloud seed; &
                    &force_use_of_temp_for_seed is set true', NOTE)
            else
              call error_mesg ('cloud_spec_init', &
               ' If model resolution is above c48, it is &
               &HIGHLY RECOMMENDED that you set cloud_spec_nml variable &
               &force_use_of_temp_for_seed to true to assure &
               &reproducibility across pe count and domain layout', NOTE)
              call error_mesg ('cloud_spec_init', &
               'No action is needed at or below c48 resolution.', NOTE)
            endif

!---------------------------------------------------------------------
!     if the latitude and longitude of adjacent points on a pe have the 
!     same integral values (NINT), set the logical control variable in 
!     Cldrad_control to use the model temperature at the top level as the 
!     random number seed to provide spacial uniqueness at the points on the
!     processor. 
!     Note that for model resolutions of ~ 1 degree, some pes may use
!     lat and lon, while others use temperature, and that this may change
!     as the domain decomposition or npes used for the problem are changed.
!     Therefore it is  HIGHLY RECOMMENDED that for  resolutions above c48  
!     that nml variable force_use_of_temp_for_seed be set to .true.; 
!     it may remain the default value of .false. for lower resolution runs
!     or to preserve legacy results, or if reproducibility over npes or 
!     layout is not essential. 
!---------------------------------------------------------------------
            if (.not. Cldrad_control%use_temp_for_seed) then
  jLoop:      do j=1,jd
                do i=1,id
                  do jj=j+1,jd+1
                    do ii=i+1,id+1
                      if (NINT(lats(ii,jj)) == NINT(lats(i,j))) then
                        if (NINT(lons(ii,jj)) == NINT(lons(i,j))) then    
                          Cldrad_control%use_temp_for_seed = .true.
                          Cldrad_control%use_temp_for_seed_iz = .true.
                          call error_mesg ('cloud_spec_init', &
                           'Found grid point within 1 degree of  &
                             &another',NOTE)
                          call error_mesg ('cloud_spec_init', &
                            'if reproducibility across npes and layout is &
                           &desired, you must set cloud_spec_nml variable &
                           &force_use_of_temp_for_seed to true., and &
                           &restart the model.', NOTE)
                          exit jLoop
                        endif
                      endif
                    end do
                  end do
                end do
              end do jLoop
            endif

!-------------------------------------------------------------------------
!    set seed generation source to be the temperature field (current 
!    default).
!-------------------------------------------------------------------------
          else
            Cldrad_control%use_temp_for_seed = .true.
            Cldrad_control%use_temp_for_seed_iz = .true.
          endif
        endif

      else
        call error_mesg ('microphys_rad_mod', &
         ' attempt to use Cldrad_control%do_stochastic_clouds before &
                                                &it is defined', FATAL)
      endif
 
!--------------------------------------------------------------------
!    include do_fu2007 in the cloudrad_control_type variable for use
!    in other modules.
!--------------------------------------------------------------------
      Cldrad_control%using_fu2007 = do_fu2007
      Cldrad_control%using_fu2007_iz = .true.     

!---------------------------------------------------------------------
!    mark the module initialized.
!---------------------------------------------------------------------
      module_is_initialized = .true.

!-------------------------------------------------------------------



end subroutine cloud_spec_init



!######################################################################
! <SUBROUTINE NAME="cloud_spec">
!  <OVERVIEW>
!    cloud_radiative_properties defines the cloud radiative properties 
!    appropriate for the radiation options that are active.
!  </OVERVIEW>
!  <DESCRIPTION>
!    cloud_radiative_properties defines the cloud radiative properties 
!    appropriate for the radiation options that are active.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call cloud_spec (is, ie, js, je, lat, z_half, z_full, Rad_time,
!                       Atmos_input, &
!                       Surface, Cld_spec, Lsc_microphys,  &
!                       Meso_microphys, Cell_microphys, lsc_area_in, &
!                       lsc_liquid_in, lsc_ice_in, lsc_droplet_number_in        , r)
!  </TEMPLATE>
!  <IN NAME="is,ie,js,je" TYPE="integer">
!   starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="Rad_time" TYPE="time_type">
!   time at which radiation calculation is to apply
!  </IN>
!  <INOUT NAME="Atmos_input" TYPE="atmos_input_type">
!    atmospheric input fields on model grid,
!  </INOUT>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
!   cloud specification properties on model grid,
!  </INOUT>
!  <INOUT NAME="Lsc_microphys" TYPE="microphysics_type">
!   microphysical specification for large-scale 
!                        clouds
!  </INOUT>
!  <INOUT NAME="Meso_microphys" TYPE="microphysics_type">
!   microphysical specification for meso-scale 
!                        clouds assciated with donner convection
!  </INOUT>
!  <INOUT NAME="Cell_microphys" TYPE="microphysics_type">
!   microphysical specification for convective cell
!                        clouds associated with donner convection
!  </INOUT>
!  <INOUT NAME="Shallow_microphys" TYPE="microphysics_type">
!   microphysical specification for 
!                        clouds associated with uw shallow convection
!  </INOUT>
!  <INOUT NAME="Surface" TYPE="Surface">
!   Surface boundary condition to radiation package
!  </INOUT>
!  <IN NAME="lsc_liquid_in" TYPE="real">
!   OPTIONAL: lsc cloud water mixing ratio  present when running 
!    standalone columns or sa_gcm
!  </IN>
!  <IN NAME="lsc_ice_in" TYPE="real">
!   OPTIONAL: cloud ice mixing ratio  present when running 
!    standalone columns or sa_gcm
!  </IN>
!  <IN NAME="lsc_area_in" TYPE="real">
!   OPTIONAL: fractional cloud area, present when running 
!                        standalone columns or sa_gcm
!  </IN>
!  <IN NAME="r" TYPE="real">
!   OPTIONAL: model tracer fields on the current time step
!  </IN>
! </SUBROUTINE>
!
subroutine cloud_spec (is, ie, js, je, lat, z_half, z_full, Rad_time, &
                       Atmos_input, Surface, Cld_spec, Lsc_microphys, &
                       Meso_microphys, Cell_microphys,  &
                       Shallow_microphys, lsc_area_in, lsc_liquid_in, &
                       lsc_ice_in, lsc_droplet_number_in,   &
                       lsc_ice_number_in,   &
                       lsc_snow_in, lsc_rain_in,   &
                       lsc_snow_size_in,  lsc_rain_size_in,  r,  &
                       shallow_cloud_area, shallow_liquid, shallow_ice,&
                       shallow_droplet_number, &
                       shallow_ice_number, &
                       cell_cld_frac, cell_liq_amt, cell_liq_size, &
                       cell_ice_amt, cell_ice_size, &
                       cell_droplet_number, &
                       meso_cld_frac, meso_liq_amt, meso_liq_size, &
                       meso_ice_amt, meso_ice_size,  &
                       meso_droplet_number, nsum_out)

!----------------------------------------------------------------------
!    cloud_spec specifies the cloud field seen by the radiation package.
!----------------------------------------------------------------------


!----------------------------------------------------------------------
integer,                      intent(in)             :: is, ie, js, je
real, dimension(:,:),         intent(in)             :: lat
real, dimension(:,:,:),       intent(in)             :: z_half, z_full
type(time_type),              intent(in)             :: Rad_time
type(atmos_input_type),       intent(inout)          :: Atmos_input
type(surface_type),           intent(inout)          :: Surface       
type(cld_specification_type), intent(inout)          :: Cld_spec    
type(microphysics_type),      intent(inout)          :: Lsc_microphys, &
                                                        Meso_microphys,&
                                                        Cell_microphys,&
                                                     Shallow_microphys
real, dimension(:,:,:),       intent(in), optional ::  &
                                      lsc_liquid_in, lsc_ice_in, &
                                      lsc_droplet_number_in, lsc_area_in, &
                                      lsc_ice_number_in
real, dimension(:,:,:),       intent(in), optional ::   &
                                      lsc_snow_in, lsc_rain_in,  &
                                      lsc_snow_size_in,  lsc_rain_size_in
real, dimension(:,:,:,:),     intent(in),   optional :: r
real, dimension(:,:,:),       intent(inout),optional :: &
                      shallow_cloud_area, shallow_liquid, shallow_ice,&
                        shallow_droplet_number, &
                           cell_cld_frac, cell_liq_amt, cell_liq_size, &
                           cell_ice_amt, cell_ice_size, &
                           cell_droplet_number, &
                           meso_cld_frac, meso_liq_amt, meso_liq_size, &
                           meso_ice_amt, meso_ice_size, &
                           meso_droplet_number,  &
                           shallow_ice_number
integer, dimension(:,:),      intent(inout), optional:: nsum_out

!-------------------------------------------------------------------
 
!---------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je       starting/ending subdomain i,j indices of data 
!                        in the physics_window being integrated
!      lat               latitude of model points  [ radians ]
!      z_half            height asl at half levels [ m ]
!      z_full            height asl at full levels [ m ]
!      Rad_time          time at which radiation calculation is to apply
!                        [ time_type (days, seconds) ] 
!
!   intent(inout) variables:
!
!      Atmos_input       atmospheric input fields on model grid,
!                        [ atmos_input_type ] 
!      Surface           variables defining the surface albedo and land
!                        fraction
!                        [ surface_type ]
!      Cld_spec          variables on the model grid which define all or
!                        some of the following, dependent on the 
!                        specific cloud parameterization: cloud optical 
!                        paths, particle sizes, cloud fractions, cloud 
!                        thickness, number of clouds in a column, 
!                        and /or cloud type (high/mid/low, ice/liq or 
!                        random/max overlap)
!                        [ cld_specification_type ]
!      Lsc_microphys     variables describing the microphysical proper-
!                        ties of the large-scale clouds
!                        [ microphysics_type ]
!      Meso_microphys    variables describing the microphysical proper-
!                        ties of the meso-scale clouds
!                        [ microphysics_type ]
!      Cell_microphys    variables describing the microphysical proper-
!                        ties of the convective cell-scale clouds
!                        [ microphysics_type ]
!
!   intent(in), optional variables:
!
!      lsc_liquid_in     cloud water mixing ratio (or specific humidity 
!                        ????), present when running standalone columns
!                        or sa_gcm
!                        [ non-dimensional ]
!      lsc_ice_in        cloud ice mixing ratio (or specific humidity 
!                         ????), present when running standalone columns
!                        or sa_gcm
!                        [ non-dimensional ]
!      lsc_area_in       fractional cloud area, present when running 
!                        standalone columns or sa_gcm
!                        [ non-dimensional ]
!      r                 model tracer fields on the current time step
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      integer   :: ix, jx, kx
      integer   :: ierr
      logical   :: override
      type(time_type) :: Data_time
      real, dimension (size (Atmos_input%deltaz,1), &
                       size (Atmos_input%deltaz,2), &
                       size (Atmos_input%deltaz,3)) :: rho

!---------------------------------------------------------------------
!   local variables:
!
!        ix      number of grid points in x direction (on processor)
!        jx      number of grid points in y direction (on processor)
!        kx      number of model layers
!        rho     atmospheric density [ kg / m**3 ]
!        ierr
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    check for the presence of optional input arguments.
!---------------------------------------------------------------------
      ierr = 1
      if (present(lsc_liquid_in) .and.   &
          present(lsc_ice_in) .and. &
          present(lsc_area_in)) then
        ierr = 0
        if (Cldrad_control%do_liq_num) then
          if (.not. present(lsc_droplet_number_in) ) then
            call error_mesg ('cloud_spec_mod', &
               'must input lsc_droplet_number_in when  &
                                   &using do_liq_num', FATAL)
          endif
        endif
      else
        if (present (r)) then
          ierr = 0
        else
          call error_mesg ('cloud_spec_mod', &
              'must input either r or lsc_liquid_in and  &
              &lsc_ice_in when using predicted cloud microphysics', &
                                                               FATAL)
        endif
      endif

      if (Cldrad_control%do_uw_clouds) then
        if ( present (shallow_cloud_area) .and. &
             present (shallow_liquid) .and.  &
             present (shallow_ice)  .and.  &
             present (shallow_droplet_number) .and. &
             present (shallow_ice_number) ) then
        else
          call error_mesg ('cloud_spec_mod',  &
           'optional argument(s) required when shallow clouds &
                                           &are active is missing', FATAL)
        endif
      endif

      if (Cldrad_control%do_donner_deep_clouds) then
        if ( present (cell_cld_frac) .and. &
             present (cell_liq_amt) .and.  &
             present (cell_liq_size)  .and.  &
             present (cell_ice_amt) .and. &
             present (cell_ice_size) .and.  &
             present (cell_droplet_number) .and. &
             present (meso_cld_frac) .and. &
             present (meso_liq_amt) .and.  &
             present (meso_liq_size)  .and.  &
             present (meso_ice_amt) .and. &
             present (meso_ice_size) .and.  &
             present (meso_droplet_number) .and. &
             present (nsum_out) ) then
        else
          call error_mesg ('cloud_spec_mod',  &
           'optional argument(s) required when donner clouds &
                                           &are active is missing', FATAL)
        endif
      endif

!----------------------------------------------------------------------
!    define model dimensions.
!----------------------------------------------------------------------
      ix = size(Atmos_input%deltaz,1)
      jx = size(Atmos_input%deltaz,2)
      kx = size(Atmos_input%deltaz,3)

!----------------------------------------------------------------------
!    call initialize_cldamts to allocate and initialize the arrays
!    contained in the structures used to specify the cloud amounts, 
!    types and locations and the microphysical parameters.
!----------------------------------------------------------------------
      call initialize_cldamts (ix, jx, kx, Lsc_microphys,   &
                               Meso_microphys, Cell_microphys, &
                               Shallow_microphys, Cld_spec)

!---------------------------------------------------------------------
!    define the cloud_water, cloud_ice and cloud_area components of 
!    Cld_spec.
!---------------------------------------------------------------------
      if (present (lsc_ice_in) .and. &
          present (lsc_liquid_in) ) then
        Cld_spec%cloud_ice   = lsc_ice_in
        Cld_spec%cloud_water = lsc_liquid_in
        if (Cldrad_control%do_liq_num) then
          if (present(lsc_droplet_number_in)) then
             Cld_spec%cloud_droplet (:,:,:) = lsc_droplet_number_in
          endif
        endif
        if (Cldrad_control%do_ice_num) then
          if (present(lsc_ice_number_in)) then
            Cld_spec%cloud_ice_num (:,:,:) = lsc_ice_number_in
          end if
        endif
      endif
      if (present (lsc_area_in)  )then
        Cld_spec%cloud_area = lsc_area_in
      endif
      if (present (lsc_snow_in)  )then
        Cld_spec%snow = lsc_snow_in
      endif
      if (present (lsc_rain_in)  )then
        Cld_spec%rain = lsc_rain_in
      endif
      if (present (lsc_snow_size_in)  )then
        Cld_spec%snow_size = lsc_snow_size_in
      endif
      if (present (lsc_rain_size_in)  )then
        Cld_spec%rain_size = lsc_rain_size_in
      endif

!----------------------------------------------------------------------
!    if a cloud scheme is activated (in contrast to running without any
!    clouds), call the appropriate subroutine to define the cloud
!    location, type, amount or whatever other arrays the particular 
!    parameterization uses to specify its clouds. if the model is being
!    run with do_no_clouds = .true., exit from this routine, leaving
!    the cloud specification variables as they were initialized (to a
!    condition of no clouds).
!---------------------------------------------------------------------
      if (.not. Cldrad_control%do_no_clouds) then

!---------------------------------------------------------------------
!    when running in standalone columns mode, call standalone_clouds_amt
!    to obtain the cloud specification variables. 
!---------------------------------------------------------------------
        if (Cldrad_control%do_specified_clouds .or. &
            Cldrad_control%do_specified_strat_clouds )   then

          call standalone_clouds_amt (is, ie, js, je, lat,     &
                                      Atmos_input%press, Cld_spec)

!---------------------------------------------------------------------
!    if the rh diagnostic cloud scheme is active, call rh_clouds_amt
!    to define the needed cloud specification variables.
!---------------------------------------------------------------------
        else if (Cldrad_control%do_rh_clouds) then
          call rh_clouds_amt (is, ie, js, je, Atmos_input%press, lat,  &
                              Cld_spec)

!---------------------------------------------------------------------
!    if either zonal clouds or obs clouds is active, call 
!    specified_clouds_amt to obtain the needed cloud specification
!    variables.
!---------------------------------------------------------------------
        else if (Cldrad_control%do_zonal_clouds .or. &
                 Cldrad_control%do_obs_clouds) then
          call specified_clouds_amt (is, ie, js, je, Rad_time, lat,    &
                                     Atmos_input%pflux, Cld_spec)

!---------------------------------------------------------------------
!    if mgrp_prscr_clds is active, call prscr_clds_amt to obtain the 
!    needed cloud specification variables.
!---------------------------------------------------------------------
        else if (Cldrad_control%do_mgroup_prescribed) then
          call prscr_clds_amt (is, ie, js, je, Cld_spec)

!----------------------------------------------------------------------
!    if gordon diagnostic clouds are active, call diag_clouds_amt to 
!    obtain the needed cloud specification variables.
!---------------------------------------------------------------------
        else if (Cldrad_control%do_diag_clouds) then
          call diag_clouds_amt (is, ie, js, je, lat, Atmos_input%pflux,&
                                Atmos_input%press, Rad_time, Cld_spec, &
                                Lsc_microphys)

!----------------------------------------------------------------------
!    if zetac clouds are active, call zetac_clouds_amt to 
!    obtain the needed cloud specification variables.
!---------------------------------------------------------------------
        else if (Cldrad_control%do_zetac_clouds) then
          if (present (r)) then
            Cld_spec%cloud_water(:,:,:) = r(:,:,:,nql)
            Cld_spec%cloud_ice  (:,:,:) = r(:,:,:,nqi)
            Cld_spec%cloud_area (:,:,:) = r(:,:,:,nqa)
!           ierr = 0
!         else
!           call error_mesg ('cloud_spec_mod', &
!             ' must pass tracer array r when using zetac clouds', &
!                                                             FATAL)
          endif
          call zetac_clouds_amt (is, ie, js, je, z_half, z_full, &
                                 Surface%land, Atmos_input%phalf, &
                                 Atmos_input%deltaz, Cld_spec, &
                                 Lsc_microphys)

        endif ! (do_rh_clouds)
!--------------------------------------------------------------------
!    if klein prognostic clouds are active, call strat_clouds_amt to 
!    obtain the needed cloud specification variables.
!--------------------------------------------------------------------
        if (Cldrad_control%do_strat_clouds) then

!---------------------------------------------------------------------
!    if the gcm is being executed, call strat_cloud_avg to obtain the
!    appropriate (either instantaneous or time-averaged) values of
!    cloud water, cloud ice and cloud fraction. if the sa_gcm or the
!    standalone columns mode is being executed with the strat cloud
!    option, then values for the cloud water, cloud ice and when needed
!    cloud area have been input as optional arguments to this sub-
!    routine.
!---------------------------------------------------------------------
          if(present(lsc_liquid_in)) then
            if (Cld_spec%cloud_area(1,1,1) == -99.) then
              if (present (r)) then
                Cld_spec%cloud_water(:,:,:) = r(:,:,:,nql)
                Cld_spec%cloud_ice  (:,:,:) = r(:,:,:,nqi)
                Cld_spec%cloud_area (:,:,:) = r(:,:,:,nqa)
                if (Cldrad_control%do_liq_num) then
                  Cld_spec%cloud_droplet (:,:,:) = r(:,:,:,nqn)
                endif
              else
                call error_mesg ('cloud_spec_mod', &
                   'lsc_area_in, etc not present in restart file (flag &
                    &has been set), and r array is not passed to &
                                 &cloud_spec; cannot proceed', FATAL)
              endif
            endif
          else  ! (present (lsc_liquid_in))
            if (present (r)) then
              Cld_spec%cloud_water(:,:,:) = r(:,:,:,nql)
              Cld_spec%cloud_ice  (:,:,:) = r(:,:,:,nqi)
              Cld_spec%cloud_area (:,:,:) = r(:,:,:,nqa)
              if (Cldrad_control%do_liq_num) then
                Cld_spec%cloud_droplet (:,:,:) = r(:,:,:,nqn)
              endif
            else
              call error_mesg ('cloud_spec_mod', &
                  'neither lsc_area_in, etc nor r array &
                 &has been passed to cloud_spec; cannot proceed', FATAL)
            endif
          endif ! (present(lsc_liquid_in))

          if(present(lsc_ice_number_in)) then
            if (Cld_spec%cloud_ice_num(1,1,1) == -99.) then
              if (present (r)) then
                if (Cldrad_control%do_ice_num) then
                  Cld_spec%cloud_ice_num (:,:,:) = r(:,:,:,nqni)
                endif
              else
                call error_mesg ('cloud_spec_mod', &
                   'lsc_ice_number_in not present in restart file (flag &
                    &has been set), and r array is not passed to &
                                 &cloud_spec; cannot proceed', FATAL)
              endif
            endif
          else  ! (present (lsc_ice_number_in))
            if (Cldrad_control%do_ice_num) then
              if (present (r)) then
                Cld_spec%cloud_ice_num (:,:,:) = r(:,:,:,nqni)
              else
                call error_mesg ('cloud_spec_mod', &
                  'neither lsc_ice_number_in nor r array &
                 &has been passed to cloud_spec; cannot proceed', FATAL)
              endif
            endif
          endif ! (present(lsc_ice_number_in))

          if (present(r)) then
            if (do_rain) then !sjl
              Cld_spec%cloud_water(:,:,:) = Cld_spec%cloud_water(:,:,:)+r(:,:,:,nqr)
            end if
            if (do_snow) then !miz
              Cld_spec%cloud_ice(:,:,:) = Cld_spec%cloud_ice(:,:,:)+r(:,:,:,nqs)
            end if
            if (do_graupel) then !SJL
              Cld_spec%cloud_ice(:,:,:) = Cld_spec%cloud_ice(:,:,:)+r(:,:,:,nqg)
            end if
          endif  

!---------------------------------------------------------------------
!    if the cloud input data is to be overriden, define the time slice
!    of data which is to be used. allocate storage for the cloud data.
!---------------------------------------------------------------------
          if (doing_data_override) then
            Data_time = Rad_time +    &
                          set_time (Rad_control%rad_time_step, 0)
 
!---------------------------------------------------------------------
!    call data_override to retrieve the processor subdomain's cloud
!    water data from the override file. if the process fails, write
!    an error message; if it succeeds move the data for the current 
!    physics window, into the appropriate Cld_spec% array.
!---------------------------------------------------------------------
            call data_override ('ATM', 'qlnew', Cld_spec%cloud_water,   &
                                Data_time, override=override,           &
                                is_in=is, ie_in=ie, js_in=js, je_in=je)
            if ( .not. override) then
              call error_mesg ('radiation_driver_mod', &
                'ql => cloud_water not overridden successfully', FATAL)
            endif

!---------------------------------------------------------------------
!    call data_override to retrieve the processor subdomain's cloud
!    ice data from the override file. if the process fails, write
!    an error message; if it succeeds move the data for the current 
!    physics window, into the appropriate Cld_spec% array.
!---------------------------------------------------------------------
            call data_override ('ATM', 'qinew', Cld_spec%cloud_ice,   &
                                Data_time, override=override,         &
                                is_in=is, ie_in=ie, js_in=js, je_in=je)
            if ( .not. override) then
              call error_mesg ('radiation_driver_mod', &
                'qi => cloud_ice   not overridden successfully', FATAL)
            endif

!---------------------------------------------------------------------
!    call data_override to retrieve the processor subdomain's cloud
!    fraction data from the override file. if the process fails, write
!    an error message; if it succeeds move the data for the current
!    physics window, into the appropriate Cld_spec% array.
!---------------------------------------------------------------------
            call data_override ('ATM', 'qanew', Cld_spec%cloud_area,   &
                                Data_time, override=override,         &
                                is_in=is, ie_in=ie, js_in=js, je_in=je)
            if ( .not. override) then
              call error_mesg ('radiation_driver_mod', &
               'qa => cloud_area not overridden successfully', FATAL)
            endif
            ierr = 0
          endif ! (doing_override)

!---------------------------------------------------------------------
!    if values for the cloud variables have been successfully obtained,
!    call strat_clouds_amt to define the appropriate cloud specification
!    variables.
!---------------------------------------------------------------------
          if (ierr == 0) then
            call strat_clouds_amt (is, ie, js, je, Rad_time, &
                                   Atmos_input%pflux,  &
                                   Atmos_input%press,   &
                                   Atmos_input%cloudtemp, &
                                   Atmos_input%cloudvapor(:,:,:)/  &
                                   (1.0+Atmos_input%cloudvapor(:,:,:)), &
                                   Surface%land,&
                                   Cld_spec, Lsc_microphys)

!----------------------------------------------------------------------
!    if ierr is non-zero, then cloud data was not successfully obtained.
!    if this is not the coldstart step, write an error message and 
!    stop execution.
!----------------------------------------------------------------------
          else 
            if (num_pts >= tot_pts) then
              call error_mesg ('cloud_spec_mod',  &
                     'no strat cloud data available; ierr /= 0', FATAL)

!----------------------------------------------------------------------
!    if this is the coldstart step, retain the input values corres-
!    ponding to no clouds, increment the points counter, and continue. 
!----------------------------------------------------------------------
            else
              num_pts = num_pts + size(Atmos_input%press,1)*   &
                                  size(Atmos_input%press,2)
            endif
          endif
        endif ! (do_strat_clouds)

!--------------------------------------------------------------------
!    since donner_deep_clouds may be active along with strat clouds, 
!    the associated properties are determined outside of the above loop.
!    these properties are placed in Cell_microphys and Meso_microphys.
!----------------------------------------------------------------------
        if (Cldrad_control%do_donner_deep_clouds) then
          call donner_deep_clouds_amt (is, ie, js, je,  &
                           cell_cld_frac, cell_liq_amt, cell_liq_size, &
                           cell_ice_amt, cell_ice_size, &
                           cell_droplet_number, &
                           meso_cld_frac, meso_liq_amt, meso_liq_size, &
                           meso_ice_amt, meso_ice_size,  &
                           meso_droplet_number,  nsum_out, &
                           Cell_microphys, Meso_microphys)

!---------------------------------------------------------------------
!    convert the cloud and ice amounts from kg(h2o) / kg(air) to 
!    g(h2o) / m**3, as required for use in the microphys_rad routines
!    which compute cloud radiative properties.
!---------------------------------------------------------------------
          rho(:,:,:) = Atmos_input%press(:,:,1:kx)/  &
                       (RDGAS*Atmos_input%temp(:,:,1:kx))
          Cell_microphys%conc_drop = 1.0e03*rho*Cell_microphys%conc_drop
          Cell_microphys%conc_ice  = 1.0e03*rho*Cell_microphys%conc_ice 
          Meso_microphys%conc_drop = 1.0e03*rho*Meso_microphys%conc_drop
          Meso_microphys%conc_ice  = 1.0e03*rho*Meso_microphys%conc_ice 
        endif

!--------------------------------------------------------------------
!    since uw_clouds may be active along with strat clouds and / or 
!    donner deep clouds, the associated properties are determined 
!    outside of the above loop. these properties are placed in  
!    Shallow_microphys.
!----------------------------------------------------------------------
         if (Cldrad_control%do_uw_clouds) then
           call uw_clouds_amt (is, ie, js, je,  &
                            shallow_cloud_area, shallow_liquid, &
                            shallow_ice, shallow_droplet_number, &
                            shallow_ice_number,  &
                            Surface%land, Atmos_input%press,  &
                            Atmos_input%cloudtemp, Shallow_microphys)
        endif

!---------------------------------------------------------------------
!    obtain the microphysical properties (sizes and concentrations) if
!    a prescribed microphysics scheme is active. 
!---------------------------------------------------------------------
        if (Cldrad_control%do_presc_cld_microphys) then
          call microphys_presc_conc (is, ie, js, je,   &
                                     Atmos_input%clouddeltaz,   &
                                     Atmos_input%cloudtemp, &
                                     Cld_spec, Lsc_microphys)
        endif

!---------------------------------------------------------------------
!    call combine_cloud_properties to combine (if necessary) the cloud 
!    properties from multiple cloud types (large-scale, donner deep,
!    uw shallow) into a single set for use by the radiation package. 
!    this is only needed when microphysically-based properties are 
!    present, and when either strat clouds, donner deep and / or uw
!    shallow clouds is activated.
!---------------------------------------------------------------------
        if ( .not. Cldrad_control%do_specified_strat_clouds ) then
          if (Cldrad_control%do_sw_micro  .or.    &
              Cldrad_control%do_lw_micro) then
            if (Cldrad_control%do_strat_clouds .or.    &
                Cldrad_control%do_uw_clouds .or.    &
                Cldrad_control%do_donner_deep_clouds) then
              call combine_cloud_properties ( is, js,  &
                                             Atmos_input%temp(:,:,1), &
                                             Rad_time, &
                                             Lsc_microphys,    &
                                             Meso_microphys,   &
                                             Cell_microphys,   &
                                             Shallow_microphys, &
                                             Cld_spec)
            endif
          endif
        endif
      endif  !  (.not. do_no_clouds)

!--------------------------------------------------------------------
!    if microphysics is active and strat_clouds is not, define the water
!    paths (in units of kg / m**2).  if strat_clouds is active, these 
!    values will have already been defined. when microphysics is active,
!    define the effective sizes for the liquid and ice particles.
!--------------------------------------------------------------------
      if (Cldrad_control%do_lw_micro .or.    &
          Cldrad_control%do_sw_micro)  then
        if (.not. Cldrad_control%do_strat_clouds .and.   &
            .not. Cldrad_control%do_zetac_clouds ) then
          Cld_spec%lwp = 1.0E-03*Lsc_microphys%conc_drop(:,:,:)* &
                         Atmos_input%clouddeltaz(:,:,:)
          Cld_spec%iwp = 1.0E-03*Lsc_microphys%conc_ice(:,:,:)*  &
                         Atmos_input%clouddeltaz(:,:,:)
        endif
        Cld_spec%reff_liq_micro = Lsc_microphys%size_drop
        Cld_spec%reff_ice_micro = Lsc_microphys%size_ice
      endif

!---------------------------------------------------------------------


end subroutine cloud_spec    



!######################################################################
! <SUBROUTINE NAME="cloud_spec_dealloc">
!  <OVERVIEW>
!    cloud_spec_dealloc deallocates the component arrays of the 
!    cld_specification_type structure Cld_spec and the microphysics_type
!    structures Lsc_microphys, Meso_microphys, Cell_microphys and
!    Shallow_microphys.
!  </OVERVIEW>
!  <DESCRIPTION>
!    cloud_spec_dealloc deallocates the component arrays of the 
!    cld_specification_type structure Cld_spec and the microphysics_type
!    structures Lsc_microphys, Meso_microphys, Cell_microphys and
!    Shallow_microphys.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call cloud_spec_dealloc (Cld_spec, Lsc_microphys, Meso_microphys,&
!                               Cell_microphys, Shallow_microphys)
!  </TEMPLATE>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
!   cloud specification properties on model grid,
!  </INOUT>
!  <INOUT NAME="Lsc_microphys" TYPE="microphysics_type">
!   microphysical specification for large-scale 
!                        clouds
!  </INOUT>
!  <INOUT NAME="Meso_microphys" TYPE="microphysics_type">
!   microphysical specification for meso-scale 
!                        clouds assciated with donner convection
!  </INOUT>
!  <INOUT NAME="Cell_microphys" TYPE="microphysics_type">
!   microphysical specification for convective cell
!                        clouds associated with donner convection
!  </INOUT>
!  <INOUT NAME="Shallow_microphys" TYPE="microphysics_type">
!   microphysical specification for 
!                        clouds associated with uw shallow convection
!  </INOUT>
! </SUBROUTINE>
! 
subroutine cloud_spec_dealloc (Cld_spec, Lsc_microphys, Meso_microphys,&
                               Cell_microphys, Shallow_microphys)

!---------------------------------------------------------------------
!    cloud_spec_dealloc deallocates the component arrays of the 
!    cld_specification_type structure Cld_spec and the microphysics_type
!    structures Lsc_microphys, Meso_microphys, Cell_microphys and
!    Shallow_microphys.
!----------------------------------------------------------------------

type(cld_specification_type), intent(inout) :: Cld_spec
type(microphysics_type),      intent(inout) :: Lsc_microphys,   &
                                               Meso_microphys, &
                                               Cell_microphys, &
                                               Shallow_microphys


!----------------------------------------------------------------------
!    deallocate the array elements of Cld_spec.
!----------------------------------------------------------------------
      deallocate (Cld_spec%camtsw         )  
      deallocate (Cld_spec%cmxolw         )
      deallocate (Cld_spec%crndlw         )
      deallocate (Cld_spec%ncldsw         )
      deallocate (Cld_spec%nmxolw         )
      deallocate (Cld_spec%nrndlw         )
      if (Cldrad_control%do_stochastic_clouds) then
        deallocate (Cld_spec%camtsw_band    )
        deallocate (Cld_spec%ncldsw_band    )
        deallocate (Cld_spec%cld_thickness_sw_band  )
        deallocate (Cld_spec%lwp_sw_band            )
        deallocate (Cld_spec%iwp_sw_band            )
        deallocate (Cld_spec%reff_liq_sw_band       )
        deallocate (Cld_spec%reff_ice_sw_band       )
        deallocate (Cld_spec%stoch_cloud_type       )
      endif
      if (Cldrad_control%do_stochastic_clouds) then
        deallocate (Cld_spec%crndlw_band    )
        deallocate (Cld_spec%nrndlw_band    )
        deallocate (Cld_spec%cld_thickness_lw_band  )
        deallocate (Cld_spec%lwp_lw_band            )
        deallocate (Cld_spec%iwp_lw_band            )
        deallocate (Cld_spec%reff_liq_lw_band       )
        deallocate (Cld_spec%reff_ice_lw_band       )
      endif
      deallocate (Cld_spec%tau            )
      deallocate (Cld_spec%lwp            )
      deallocate (Cld_spec%iwp            )
      deallocate (Cld_spec%reff_liq       )
      deallocate (Cld_spec%reff_ice       )
      deallocate (Cld_spec%reff_liq_lim   )
      deallocate (Cld_spec%reff_ice_lim   )
      deallocate (Cld_spec%reff_liq_micro )
      deallocate (Cld_spec%reff_ice_micro )
      deallocate (Cld_spec%liq_frac       )
      deallocate (Cld_spec%cld_thickness  )
      deallocate (Cld_spec%hi_cloud       )
      deallocate (Cld_spec%mid_cloud      )
      deallocate (Cld_spec%low_cloud      )
      deallocate (Cld_spec%ice_cloud      )
      deallocate (Cld_spec%cloud_water    )
      deallocate (Cld_spec%cloud_ice      )
      deallocate (Cld_spec%cloud_area     )
      deallocate (Cld_spec%cloud_droplet  )
      deallocate (Cld_spec%cloud_ice_num  )
      deallocate (Cld_spec%snow           )
      deallocate (Cld_spec%rain           )
      deallocate (Cld_spec%snow_size      )
      deallocate (Cld_spec%rain_size      )

!--------------------------------------------------------------------
!    deallocate the elements of Lsc_microphys.
!---------------------------------------------------------------------
      deallocate (Lsc_microphys%conc_drop   )
      deallocate (Lsc_microphys%conc_ice    )
      deallocate (Lsc_microphys%conc_rain   )
      deallocate (Lsc_microphys%conc_snow   )
      deallocate (Lsc_microphys%size_drop   )
      deallocate (Lsc_microphys%size_ice    )
      deallocate (Lsc_microphys%size_rain   )
      deallocate (Lsc_microphys%size_snow   )
      deallocate (Lsc_microphys%cldamt      )
      deallocate (Lsc_microphys%droplet_number )
      deallocate (Lsc_microphys%ice_number  )
      if (Cldrad_control%do_stochastic_clouds) then
        nullify (Lsc_microphys%lw_stoch_conc_drop   )
        nullify (Lsc_microphys%lw_stoch_conc_ice    )
        nullify (Lsc_microphys%lw_stoch_size_drop   )
        nullify (Lsc_microphys%lw_stoch_size_ice    )
        nullify (Lsc_microphys%lw_stoch_cldamt      )
        nullify (Lsc_microphys%lw_stoch_droplet_number)
        nullify (Lsc_microphys%lw_stoch_ice_number  )

        nullify (Lsc_microphys%sw_stoch_conc_drop   )
        nullify (Lsc_microphys%sw_stoch_conc_ice    )
        nullify (Lsc_microphys%sw_stoch_size_drop   )
        nullify (Lsc_microphys%sw_stoch_size_ice    )
        nullify (Lsc_microphys%sw_stoch_cldamt      )
        nullify (Lsc_microphys%sw_stoch_droplet_number)
        nullify (Lsc_microphys%sw_stoch_ice_number  )

        deallocate (Lsc_microphys%stoch_conc_drop   )
        deallocate (Lsc_microphys%stoch_conc_ice    )
        deallocate (Lsc_microphys%stoch_size_drop   )
        deallocate (Lsc_microphys%stoch_size_ice    )
        deallocate (Lsc_microphys%stoch_cldamt      )
        deallocate (Lsc_microphys%stoch_droplet_number )
        deallocate (Lsc_microphys%stoch_ice_number  )
      endif

!--------------------------------------------------------------------
!    deallocate the elements of Cell_microphys.
!---------------------------------------------------------------------
      if (Cldrad_control%do_donner_deep_clouds) then
        deallocate (Cell_microphys%conc_drop   )
        deallocate (Cell_microphys%conc_ice    )
        deallocate (Cell_microphys%conc_rain   )
        deallocate (Cell_microphys%conc_snow   )
        deallocate (Cell_microphys%size_drop   )
        deallocate (Cell_microphys%size_ice    )
        deallocate (Cell_microphys%size_rain   )
        deallocate (Cell_microphys%size_snow   )
        deallocate (Cell_microphys%cldamt      )
        deallocate (Cell_microphys%droplet_number )

!--------------------------------------------------------------------
!    deallocate the elements of Meso_microphys.
!---------------------------------------------------------------------
        deallocate (Meso_microphys%conc_drop   )
        deallocate (Meso_microphys%conc_ice    )
        deallocate (Meso_microphys%conc_rain   )
        deallocate (Meso_microphys%conc_snow   )
        deallocate (Meso_microphys%size_drop   )
        deallocate (Meso_microphys%size_ice    )
        deallocate (Meso_microphys%size_rain   )
        deallocate (Meso_microphys%size_snow   )
        deallocate (Meso_microphys%cldamt      )
        deallocate (Meso_microphys%droplet_number )
      endif

!--------------------------------------------------------------------
!    deallocate the elements of Shallow_microphys.
!---------------------------------------------------------------------
      if (Cldrad_control%do_uw_clouds) then
        deallocate (Shallow_microphys%conc_drop   )
        deallocate (Shallow_microphys%conc_ice    )
        deallocate (Shallow_microphys%conc_rain   )
        deallocate (Shallow_microphys%conc_snow   )
        deallocate (Shallow_microphys%size_drop   )
        deallocate (Shallow_microphys%size_ice    )
        deallocate (Shallow_microphys%size_rain   )
        deallocate (Shallow_microphys%size_snow   )
        deallocate (Shallow_microphys%cldamt      )
        deallocate (Shallow_microphys%droplet_number )
      endif

!---------------------------------------------------------------------


end subroutine cloud_spec_dealloc 



!#####################################################################

subroutine cloud_spec_end

!---------------------------------------------------------------------
!    cloud_spec_end is the destructor for cloud_spec_mod.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!    close the modules that were initialized by this module.
!--------------------------------------------------------------------
      if (.not. Cldrad_control%do_no_clouds) then

!-------------------------------------------------------------------
!    mgroup prescribed clouds.
!-------------------------------------------------------------------
        if (Cldrad_control%do_mgroup_prescribed) then
          call mgrp_prscr_clds_end 

!-------------------------------------------------------------------
!    rh-based diagnostic clouds.
!-------------------------------------------------------------------
        else if (Cldrad_control%do_rh_clouds) then
          call rh_based_clouds_end 

!-------------------------------------------------------------------
!    zonal or observed clouds.
!-------------------------------------------------------------------
        else if (Cldrad_control%do_zonal_clouds .or.  &
                 Cldrad_control%do_obs_clouds)  then
          call specified_clouds_W_end             

!-------------------------------------------------------------------
!    klein predicted clouds. if this option is active, donner_deep 
!    clouds may also be active. additionally, this may also have been
!    activated when running in standalone columns mode, in which case
!    standalone_clouds_end must be called.
!-------------------------------------------------------------------
        else if (Cldrad_control%do_strat_clouds) then
          if (Cldrad_control%do_specified_strat_clouds .or. &
              Cldrad_control%do_specified_clouds ) then 
            call standalone_clouds_end
          endif

!-------------------------------------------------------------------
!    gordon diagnostic clouds.
!-------------------------------------------------------------------
        else if (Cldrad_control%do_diag_clouds) then
          call diag_clouds_W_end

!-------------------------------------------------------------------
!    zetac clouds.
!-------------------------------------------------------------------
        else if (Cldrad_control%do_zetac_clouds) then
          call zetac_clouds_W_end

!-------------------------------------------------------------------
!    standalone specified clouds.
!-------------------------------------------------------------------
        else if (Cldrad_control%do_specified_clouds) then
          call standalone_clouds_end
        endif

!------------------------------------------------------------------
!    cloud types which may coexist must be processed outside of if loop
!------------------------------------------------------------------
        if (Cldrad_control%do_strat_clouds) then
          call strat_clouds_W_end
        endif
        if (Cldrad_control%do_donner_deep_clouds) then
          call donner_deep_clouds_W_end
        endif
        if (Cldrad_control%do_uw_clouds) then
          call uw_clouds_W_end
        endif
      endif  ! (not do_no_clouds)

!--------------------------------------------------------------------
!    mark the module as no longer initialized.
!--------------------------------------------------------------------
      module_is_initialized = .false.

!--------------------------------------------------------------------



end subroutine cloud_spec_end



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                    PRIVATE SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




!#####################################################################
! <SUBROUTINE NAME="initialize_cldamts">
!  <OVERVIEW>
!    initialize_cldamts allocates and initializes the array components 
!    of the structures used to specify the model cloud and microphysics
!    fields.
!  </OVERVIEW>
!  <DESCRIPTION>
!    initialize_cldamts allocates and initializes the array components 
!    of the structures used to specify the model cloud and microphysics
!    fields.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call initialize_cldamts (ix, jx, kx, Lsc_microphys,    &
!                               Meso_microphys, Cell_microphys, Cld_spec)
!  </TEMPLATE>
!  <IN NAME="ix, jx, kx" TYPE="integer">
!       ix             size of i dimension of physics window
!       jx             size of j dimension of physics window
!       kx             size of k dimension of physics window
!  </IN>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
!   cloud specification properties on model grid,
!  </INOUT>
!  <INOUT NAME="Lsc_microphys" TYPE="microphysics_type">
!   microphysical specification for large-scale 
!                        clouds
!  </INOUT>
!  <INOUT NAME="Meso_microphys" TYPE="microphysics_type">
!   microphysical specification for meso-scale 
!                        clouds assciated with donner convection
!  </INOUT>
!  <INOUT NAME="Cell_microphys" TYPE="microphysics_type">
!   microphysical specification for convective cell
!                        clouds associated with donner convection
!  </INOUT>
!  <INOUT NAME="Shallow_microphys" TYPE="microphysics_type">
!   microphysical specification for 
!                        clouds associated with uw shallow convection
!  </INOUT>
! </SUBROUTINE>
! 
subroutine initialize_cldamts (ix, jx, kx, Lsc_microphys,    &
                               Meso_microphys, Cell_microphys,  &
                               Shallow_microphys, Cld_spec)

!---------------------------------------------------------------------
!    initialize_cldamts allocates and initializes the array components 
!    of the structures used to specify the model cloud and microphysics
!    fields.
!---------------------------------------------------------------------

integer,                      intent(in)     :: ix, jx, kx
type(microphysics_type),      intent(inout)  :: Lsc_microphys,   &
                                                Meso_microphys, &
                                                Cell_microphys, &
                                                Shallow_microphys
type(cld_specification_type), intent(inout)  :: Cld_spec

!----------------------------------------------------------------------
!    intent(in) variables:
! 
!       ix             size of i dimension of physics window
!       jx             size of j dimension of physics window
!       kx             size of k dimension of physics window
!
!    intent(inout) variables:
!
!       Lsc_microphys  microphysical specification for large-scale 
!                      clouds
!                      [ microphysics_type ]
!       Meso_microphys microphysical specification for meso-scale 
!                      clouds assciated with donner convection
!                      [ microphysics_type ]
!       Cell_microphys microphysical specification for convective cell
!                      clouds associated with donner convection
!                      [ microphysics_type ]
!       Shallow_microphys 
!                      microphysical specification for 
!                      clouds associated with uw shallow convection
!                      [ microphysics_type ]
!
!            the following elements are components of these  
!            microphysics_type variables which are allocated and
!            initialized here:
!
!            %conc_ice   ice particle concentration [ g / m**3 ]
!            %conc_drop  cloud droplet concentration [ g / m**3 ]
!            %conc_rain  rain drop concentration [ g / m**3 ]
!            %conc_snow  snow concentration [ g / m**3 ]
!            %size_ice   effective ice crystal diameter [ microns ]
!            %size_drop  effective cloud drop diameter [ microns ]
!            %size_rain  effective rain drop diameter [ microns ]
!            %size_snow  effective snow flake diameter [ microns ]
!            %cldamt     total cloud fraction (crystal + droplet)
!                        [ dimensionless ]
!            %lw_stoch_conc_ice
!                        ice particle concentration as a function of
!                        lw parameterization band [ g / m**3 ]
!            %lw_stoch_conc_drop
!                        cloud droplet concentration as a function of
!                        lw parameterization band [ g / m**3 ]
!            %lw_stoch_size_ice
!                        effective ice crystal diameter as a function
!                        of lw parameterization band [ microns ]
!            %lw_stoch_size_drop
!                        effective cloud drop diameter as a function of
!                        lw parameterization band [ microns ]
!            %lw_stoch_cldamt
!                        total cloud fraction (crystal + droplet) as a
!                        function of lw parameterization band
!                        [ dimensionless ]
!            %sw_stoch_conc_ice
!                        ice particle concentration as a function of
!                        sw parameterization band [ g / m**3 ]
!            %sw_stoch_conc_drop
!                        cloud droplet concentration as a function of
!                        sw parameterization band [ g / m**3 ]
!            %sw_stoch_size_ice
!                        effective ice crystal diameter as a function
!                        of sw parameterization band [ microns ]
!            %sw_stoch_size_drop
!                        effective cloud drop diameter as a function of
!                        sw parameterization band [ microns ]
!            %sw_stoch_cldamt
!                        total cloud fraction (crystal + droplet) as a
!                        function of sw parameterization band
!                        [ dimensionless ]
!
!       Cld_spec       variables on the model grid which define all or
!                      some of the following, dependent on the specific
!                      cloud parameterization: cloud optical paths, 
!                      particle sizes, cloud fractions, cloud thickness,
!                      number of clouds in a column, and /or cloud type 
!                      (high/mid/low, ice/liq or random/max overlap)
!                      [ cld_specification_type ]
!
!            the following elements are components of this  
!            cld_specification_type variable which is allocated and
!            initialized here:
!
!            %cmxolw         amount of maximally overlapped longwave 
!                            clouds [ dimensionless ]
!            %crndlw         amount of randomly overlapped longwave 
!                            clouds [ dimensionless ]
!            %nmxolw         number of maximally overlapped longwave 
!                            clouds in each grid column.
!            %nrndlw         number of maximally overlapped longwave 
!                            clouds in each grid column.
!            %camtsw         shortwave cloud amount. the sum of the max-
!                            imally overlapped and randomly overlapped 
!                            longwave cloud amounts. [ dimensionless ]
!            %ncldsw         number of shortwave clouds in each grid 
!                            column.
!            %camtsw_band    shortwave cloud amount. the sum of the max-
!                            imally overlapped and randomly overlapped
!                            longwave cloud amounts, differing with sw
!                            parameterization band. [ dimensionless ]
!            %crndlw_band    amount of randomly overlapped longwave
!                            clouds, differing with lw parameterization
!                            band [ dimensionless ]
!            %hi_cloud       logical mask for high clouds 
!            %mid_cloud      logical mask for middle clouds
!            %low_cloud      logical mask for low clouds
!            %ice_cloud      logical mask for ice clouds
!            %iwp            ice water path  [ kg / m**2 ]
!            %lwp            liquid water path [ kg / m**2 ]
!            %reff_liq       effective cloud drop radius  used with
!                            bulk cloud physics scheme [ microns ]
!            %reff_ice       effective ice crystal radius used with
!                            bulk cloud physics scheme [ microns ]
!            %reff_liq_micro effective cloud drop radius used with 
!                            microphysically based scheme [ microns ]
!            %reff_ice_micro effective ice crystal radius used with
!                            microphysically based scheme [ microns ]
!            %tau            extinction optical path  [ dimensionless ]
!            %liq_frac       fraction of cloud in a box which is liquid
!                            [ dimensionless ]
!            %cld_thickness  number of model layers contained in cloud  
!            %cloud_water    liquid cloud content [ kg liq / kg air ]
!            %cloud_ice      ice cloud content [ kg ice / kg air ]
!            %cloud_area     saturated volume fraction [ dimensionless ]
!
!---------------------------------------------------------------------

      integer  :: n

!---------------------------------------------------------------------
!    allocate the arrays defining the microphysical parameters of the 
!    large-scale cloud scheme, including any precipitation fields and
!    the total cloud fraction. concentrations and fractions are init-
!    ialized to 0.0, and the effective sizes are set to small numbers to
!    avoid potential divides by zero.
!---------------------------------------------------------------------
      allocate (Lsc_microphys%conc_drop  (ix, jx, kx) )
      allocate (Lsc_microphys%conc_ice   (ix, jx, kx) )
      allocate (Lsc_microphys%conc_rain  (ix, jx, kx) )
      allocate (Lsc_microphys%conc_snow  (ix, jx, kx) )
      allocate (Lsc_microphys%size_drop  (ix, jx, kx) )
      allocate (Lsc_microphys%size_ice   (ix, jx, kx) )
      allocate (Lsc_microphys%size_rain  (ix, jx, kx) )
      allocate (Lsc_microphys%size_snow  (ix, jx, kx) )
      allocate (Lsc_microphys%cldamt     (ix, jx, kx) )
      allocate (Lsc_microphys%droplet_number (ix, jx, kx) )
       allocate (Lsc_microphys%ice_number (ix, jx, kx) )
      Lsc_microphys%conc_drop(:,:,:) = 0.
      Lsc_microphys%conc_ice(:,:,:)  = 0.
      Lsc_microphys%conc_rain(:,:,:) = 0.
      Lsc_microphys%conc_snow(:,:,:) = 0.
      Lsc_microphys%size_drop(:,:,:) = 1.0e-20 
      Lsc_microphys%size_ice(:,:,:)  = 1.0e-20 
      Lsc_microphys%size_rain(:,:,:) = 1.0e-20        
      Lsc_microphys%size_snow(:,:,:) = 1.0e-20 
      Lsc_microphys%cldamt(:,:,:)    = 0.0
      Lsc_microphys%droplet_number(:,:,:)    = 0.0
      Lsc_microphys%ice_number(:,:,:)= 0.0
      if (Cldrad_control%do_stochastic_clouds) then
        allocate (Lsc_microphys%stoch_conc_drop  &
                                  (ix, jx, kx, Cldrad_control%nlwcldb + Solar_spect%nbands) )
        allocate (Lsc_microphys%stoch_conc_ice &
                                  (ix, jx, kx, cldrad_control%nlwcldb + Solar_spect%nbands) )
        allocate (Lsc_microphys%stoch_size_drop  &
                                  (ix, jx, kx, cldrad_control%nlwcldb + Solar_spect%nbands) )
        allocate (Lsc_microphys%stoch_size_ice   &
                                  (ix, jx, kx, cldrad_control%nlwcldb + Solar_spect%nbands) )
        allocate (Lsc_microphys%stoch_cldamt  &
                                  (ix, jx, kx, cldrad_control%nlwcldb + Solar_spect%nbands) )
        allocate (Lsc_microphys%stoch_droplet_number  &
                                  (ix, jx, kx, cldrad_control%nlwcldb + Solar_spect%nbands) )
        allocate (Lsc_microphys%stoch_ice_number  &
                                  (ix, jx, kx, cldrad_control%nlwcldb + Solar_spect%nbands) )
  
        Lsc_microphys%lw_stoch_conc_drop => Lsc_microphys%stoch_conc_drop(:, :, :, 1:Cldrad_control%nlwcldb)
        Lsc_microphys%sw_stoch_conc_drop => Lsc_microphys%stoch_conc_drop(:, :, :, Cldrad_control%nlwcldb+1:)
        Lsc_microphys%lw_stoch_conc_ice  => Lsc_microphys%stoch_conc_ice (:, :, :, 1:Cldrad_control%nlwcldb)
        Lsc_microphys%sw_stoch_conc_ice  => Lsc_microphys%stoch_conc_ice (:, :, :, Cldrad_control%nlwcldb+1:)
        Lsc_microphys%lw_stoch_size_drop => Lsc_microphys%stoch_size_drop(:, :, :, 1:Cldrad_control%nlwcldb)
        Lsc_microphys%sw_stoch_size_drop => Lsc_microphys%stoch_size_drop(:, :, :, Cldrad_control%nlwcldb+1:)
        Lsc_microphys%lw_stoch_size_ice  => Lsc_microphys%stoch_size_ice (:, :, :, 1:Cldrad_control%nlwcldb)
        Lsc_microphys%sw_stoch_size_ice  => Lsc_microphys%stoch_size_ice (:, :, :, Cldrad_control%nlwcldb+1:)
        Lsc_microphys%lw_stoch_cldamt    => Lsc_microphys%stoch_cldamt   (:, :, :, 1:Cldrad_control%nlwcldb)
        Lsc_microphys%sw_stoch_cldamt    => Lsc_microphys%stoch_cldamt   (:, :, :, Cldrad_control%nlwcldb+1:)
        Lsc_microphys%lw_stoch_droplet_number    => Lsc_microphys%stoch_droplet_number   (:, :, :, 1:Cldrad_control%nlwcldb)
        Lsc_microphys%sw_stoch_droplet_number    => Lsc_microphys%stoch_droplet_number   (:, :, :, Cldrad_control%nlwcldb+1:)
        Lsc_microphys%lw_stoch_ice_number    => Lsc_microphys%stoch_ice_number   (:, :, :, 1:Cldrad_control%nlwcldb)
        Lsc_microphys%sw_stoch_ice_number    => Lsc_microphys%stoch_ice_number   (:, :, :, Cldrad_control%nlwcldb+1:)

       do n=1,Cldrad_control%nlwcldb + Solar_spect%nbands
        Lsc_microphys%stoch_conc_drop(:,:,:,n) = 0.
        Lsc_microphys%stoch_conc_ice(:,:,:,n)  = 0.
        Lsc_microphys%stoch_size_drop(:,:,:,n) = 1.0e-20
        Lsc_microphys%stoch_size_ice(:,:,:,n)  = 1.0e-20
        Lsc_microphys%stoch_cldamt(:,:,:,n)    = 0.0
        Lsc_microphys%stoch_droplet_number(:,:,:,n) = 0.0
        Lsc_microphys%stoch_ice_number(:,:,:,n)= 0.0
       end do
      endif

!---------------------------------------------------------------------
!    allocate the arrays defining the microphysical parameters of the 
!    meso-scale cloud scheme, including any precipitation fields and
!    the total cloud fraction. concentrations and fractions are init-
!    ialized to 0.0, and the effective sizes are set to small numbers to
!    avoid potential divides by zero.
!---------------------------------------------------------------------
      if (Cldrad_control%do_donner_deep_clouds) then
      allocate (Meso_microphys%conc_drop  (ix, jx, kx) )
      allocate (Meso_microphys%conc_ice   (ix, jx, kx) )
      allocate (Meso_microphys%conc_rain  (ix, jx, kx) )
      allocate (Meso_microphys%conc_snow  (ix, jx, kx) )
      allocate (Meso_microphys%size_drop  (ix, jx, kx) )
      allocate (Meso_microphys%size_ice   (ix, jx, kx) )
      allocate (Meso_microphys%size_rain  (ix, jx, kx) )
      allocate (Meso_microphys%size_snow  (ix, jx, kx) )
      allocate (Meso_microphys%cldamt     (ix, jx, kx) )
      allocate (Meso_microphys%droplet_number   (ix, jx, kx) )
      Meso_microphys%conc_drop = 0.
      Meso_microphys%conc_ice  = 0.
      Meso_microphys%conc_rain = 0.
      Meso_microphys%conc_snow = 0.
      Meso_microphys%size_drop = 1.0e-20 
      Meso_microphys%size_ice  = 1.0e-20  
      Meso_microphys%size_rain = 1.0e-20                            
      Meso_microphys%size_snow = 1.0e-20 
      Meso_microphys%cldamt    = 0.0                               
      Meso_microphys%droplet_number   = 0.0                               
      endif

!---------------------------------------------------------------------
!    allocate the arrays defining the microphysical parameters of the 
!    cell-scale cloud scheme, including any precipitation fields and
!    the total cloud fraction. concentrations and fractions are init-
!    ialized to 0.0, and the effective sizes are set to small numbers to
!    avoid potential divides by zero.
!---------------------------------------------------------------------
      if (Cldrad_control%do_donner_deep_clouds) then
      allocate (Cell_microphys%conc_drop  (ix, jx, kx) )
      allocate (Cell_microphys%conc_ice   (ix, jx, kx) )
      allocate (Cell_microphys%conc_rain  (ix, jx, kx) )
      allocate (Cell_microphys%conc_snow  (ix, jx, kx) )
      allocate (Cell_microphys%size_drop  (ix, jx, kx) )
      allocate (Cell_microphys%size_ice   (ix, jx, kx) )
      allocate (Cell_microphys%size_rain  (ix, jx, kx) )
      allocate (Cell_microphys%size_snow  (ix, jx, kx) )
      allocate (Cell_microphys%cldamt     (ix, jx, kx) )
      allocate (Cell_microphys%droplet_number  (ix, jx, kx) )
      Cell_microphys%conc_drop = 0.
      Cell_microphys%conc_ice  = 0.
      Cell_microphys%conc_rain = 0.
      Cell_microphys%conc_snow = 0.
      Cell_microphys%size_drop = 1.0e-20 
      Cell_microphys%size_ice  = 1.0e-20  
      Cell_microphys%size_rain = 1.0e-20                          
      Cell_microphys%size_snow = 1.0e-20 
      Cell_microphys%cldamt     = 0.
      Cell_microphys%droplet_number    = 0.
      endif

!---------------------------------------------------------------------
!    allocate the arrays defining the microphysical parameters of the 
!    clouds of the shallow convection scheme, including any precip-
!    itation fields and the total cloud fraction. concentrations and 
!    fractions are initialized to 0.0, and the effective sizes are set 
!    to small numbers to avoid potential divides by zero.
!---------------------------------------------------------------------
      if (Cldrad_control%do_uw_clouds) then
        allocate (Shallow_microphys%conc_drop  (ix, jx, kx) )
        allocate (Shallow_microphys%conc_ice   (ix, jx, kx) )
        allocate (Shallow_microphys%conc_rain  (ix, jx, kx) )
        allocate (Shallow_microphys%conc_snow  (ix, jx, kx) )
        allocate (Shallow_microphys%size_drop  (ix, jx, kx) )
        allocate (Shallow_microphys%size_ice   (ix, jx, kx) )
        allocate (Shallow_microphys%size_rain  (ix, jx, kx) )
        allocate (Shallow_microphys%size_snow  (ix, jx, kx) )
        allocate (Shallow_microphys%cldamt     (ix, jx, kx) )
        allocate (Shallow_microphys%droplet_number  (ix, jx, kx) )
        Shallow_microphys%conc_drop = 0.
       Shallow_microphys%conc_ice  = 0.
       Shallow_microphys%conc_rain = 0.
       Shallow_microphys%conc_snow = 0.
       Shallow_microphys%size_drop = 1.0e-20
       Shallow_microphys%size_ice  = 1.0e-20
       Shallow_microphys%size_rain = 1.0e-20
       Shallow_microphys%size_snow = 1.0e-20
       Shallow_microphys%cldamt    = 0.0
       Shallow_microphys%droplet_number    = 0.
     endif

!---------------------------------------------------------------------
!    allocate arrays to hold the cloud fractions seen by the shortwave
!    and the random and maximum overlap fractions seen by the longwave
!    radiation, and then the number of each of these types of cloud in
!    each column. initialize the cloud fractions and number of clouds
!    to zero.
!---------------------------------------------------------------------
      allocate ( Cld_spec%camtsw (ix, jx, kx ) )
      allocate ( Cld_spec%cmxolw (ix, jx, kx ) )
      allocate ( Cld_spec%crndlw (ix, jx, kx ) )
      allocate ( Cld_spec%ncldsw (ix, jx     ) )
      allocate ( Cld_spec%nmxolw (ix, jx     ) )
      allocate ( Cld_spec%nrndlw (ix, jx     ) )
      Cld_spec%cmxolw(:,:,:) = 0.0E+00
      Cld_spec%crndlw(:,:,:) = 0.0E+00
      Cld_spec%camtsw(:,:,:) = 0.0E+00
      Cld_spec%nmxolw (:,:)  = 0
      Cld_spec%nrndlw (:,:)  = 0
      Cld_spec%ncldsw (:,:)  = 0
      if (Cldrad_control%do_stochastic_clouds) then
        allocate ( Cld_spec%camtsw_band    &
                                 (ix, jx, kx, Solar_spect%nbands) )
        allocate ( Cld_spec%ncldsw_band    &
                                 (ix, jx, Solar_spect%nbands) )
        allocate (Cld_spec%cld_thickness_sw_band & 
                                 (ix, jx, kx, Solar_spect%nbands) )
        allocate (Cld_spec%iwp_sw_band    &
                                 (ix, jx, kx, Solar_spect%nbands) )
        allocate (Cld_spec%lwp_sw_band   &
                                 (ix, jx, kx, Solar_spect%nbands) )
        allocate (Cld_spec%reff_liq_sw_band   &  
                                 (ix, jx, kx, Solar_spect%nbands) )
        allocate (Cld_spec%reff_ice_sw_band   &   
                                 (ix, jx, kx, Solar_spect%nbands) )
        do n=1,Solar_spect%nbands
        Cld_spec%camtsw_band(:,:,:,n) = 0.0E+00
        Cld_spec%ncldsw_band(:,:,n) = 0
        Cld_spec%cld_thickness_sw_band(:,:,:,n) = 0              
        Cld_spec%lwp_sw_band(:,:,:,n)   = 0.0
        Cld_spec%iwp_sw_band(:,:,:,n)   = 0.0
        Cld_spec%reff_liq_sw_band(:,:,:,n)      = 10.0
        Cld_spec%reff_ice_sw_band(:,:,:,n)      = 30.0
        end do
        allocate ( Cld_spec%crndlw_band    &
                                 (ix, jx, kx, Cldrad_control%nlwcldb) )
        allocate ( Cld_spec%nrndlw_band    &
                                 (ix, jx, Cldrad_control%nlwcldb) )
        allocate (Cld_spec%cld_thickness_lw_band & 
                                 (ix, jx, kx, Cldrad_control%nlwcldb) )
        allocate (Cld_spec%iwp_lw_band    &
                                 (ix, jx, kx, Cldrad_control%nlwcldb) )
        allocate (Cld_spec%lwp_lw_band   &
                                 (ix, jx, kx, Cldrad_control%nlwcldb) )
        allocate (Cld_spec%reff_liq_lw_band   &  
                                 (ix, jx, kx, Cldrad_control%nlwcldb) )
        allocate (Cld_spec%reff_ice_lw_band   &   
                                 (ix, jx, kx, Cldrad_control%nlwcldb) )
        do n=1, Cldrad_control%nlwcldb
        Cld_spec%crndlw_band(:,:,:,n) = 0.0E+00
        Cld_spec%nrndlw_band(:,:,n) = 0
        Cld_spec%cld_thickness_lw_band(:,:,:,n) = 0              
        Cld_spec%lwp_lw_band(:,:,:,n)   = 0.0
        Cld_spec%iwp_lw_band(:,:,:,n)   = 0.0
        Cld_spec%reff_liq_lw_band(:,:,:,n)      = 10.0
        Cld_spec%reff_ice_lw_band (:,:,:,n)     = 30.0
        end do
        allocate (Cld_spec%stoch_cloud_type   &
            (ix, jx, kx, Solar_spect%nbands + Cldrad_control%nlwcldb) )
        Cld_spec%stoch_cloud_type = 0
      endif

!--------------------------------------------------------------------
!    allocate and initialize various arrays that are used by one or
!    another cloud scheme to specify the cloud locations and amounts.
!    initialization provides values consistent with the absence of
!    cloud, with the exception of the particle size fields which are
!    set to small, non-zero values.
!---------------------------------------------------------------------
      allocate (Cld_spec%hi_cloud       (ix, jx, kx) )
      allocate (Cld_spec%mid_cloud      (ix, jx, kx) )
      allocate (Cld_spec%low_cloud      (ix, jx, kx) )
      allocate (Cld_spec%ice_cloud      (ix, jx, kx) )
      allocate (Cld_spec%iwp            (ix, jx, kx) )
      allocate (Cld_spec%lwp            (ix, jx, kx) )
      allocate (Cld_spec%reff_liq       (ix, jx, kx) )
      allocate (Cld_spec%reff_ice       (ix, jx, kx) )
      allocate (Cld_spec%reff_liq_lim   (ix, jx, kx) )
      allocate (Cld_spec%reff_ice_lim   (ix, jx, kx) )
      allocate (Cld_spec%reff_liq_micro (ix, jx, kx) )
      allocate (Cld_spec%reff_ice_micro (ix, jx, kx) )
      allocate (Cld_spec%tau            (ix, jx, kx, num_slingo_bands) )
      allocate (Cld_spec%liq_frac       (ix, jx, kx) )
      allocate (Cld_spec%cld_thickness  (ix, jx, kx) )
      allocate (Cld_spec%cloud_water    (ix,jx,kx) )
      allocate (Cld_spec%cloud_ice      (ix,jx,kx)   )
      allocate (Cld_spec%cloud_area     (ix,jx,kx)  )
      allocate (Cld_spec%cloud_droplet  (ix,jx,kx)  )
      allocate (Cld_spec%cloud_ice_num  (ix,jx,kx)  )
      allocate (Cld_spec%snow           (ix,jx,kx)  )
      allocate (Cld_spec%rain           (ix,jx,kx)  )
      allocate (Cld_spec%snow_size      (ix,jx,kx)  )
      allocate (Cld_spec%rain_size      (ix,jx,kx)  )

      Cld_spec%hi_cloud (:,:,:)     = .false.
      Cld_spec%mid_cloud(:,:,:)     = .false.
      Cld_spec%low_cloud(:,:,:)     = .false.
      Cld_spec%ice_cloud(:,:,:)     = .false.
      Cld_spec%lwp(:,:,:)    = 0.0
      Cld_spec%iwp(:,:,:)    = 0.0
      Cld_spec%reff_liq(:,:,:)      = 10.0
      Cld_spec%reff_ice(:,:,:)      = 30.0
      Cld_spec%reff_liq_lim(:,:,:)      = 10.0
      Cld_spec%reff_ice_lim(:,:,:)      = 30.0
      Cld_spec%reff_liq_micro(:,:,:) = 10.0
      Cld_spec%reff_ice_micro(:,:,:) = 30.0
      Cld_spec%liq_frac(:,:,:)      = 0.0
      Cld_spec%cld_thickness(:,:,:) = 0              
      Cld_spec%cloud_water(:,:,:)   = 0.
      Cld_spec%cloud_ice(:,:,:)     = 0.
      Cld_spec%cloud_area(:,:,:)    = 0.
      Cld_spec%cloud_droplet(:,:,:)    = 0.
      Cld_spec%cloud_ice_num(:,:,:) = 0.
      Cld_spec%snow(:,:,:)          = 0.
      Cld_spec%rain(:,:,:)          = 0.
      Cld_spec%snow_size(:,:,:)     = 0.
      Cld_spec%rain_size(:,:,:)     = 0.
      do n=1, num_slingo_bands
      Cld_spec%tau(:,:,:,n)  = 0.0
      end do

!---------------------------------------------------------------------



end subroutine initialize_cldamts              



!###################################################################
! <SUBROUTINE NAME="combine_cloud_properties">
!  <OVERVIEW>
!    combine_cloud_properties produces cloud specification property 
!    arrays for the total cloud field in each grid box, using as input 
!    the specification of the component cloud types that may be present
!    (large-scale, mesoscale and cell-scale).
!  </OVERVIEW>
!  <DESCRIPTION>
!    combine_cloud_properties produces cloud specification property 
!    arrays for the total cloud field in each grid box, using as input 
!    the specification of the component cloud types that may be present
!    (large-scale, mesoscale and cell-scale).
!  </DESCRIPTION>
!  <TEMPLATE>
!   call combine_cloud_properties (Lsc_microphys, Meso_microphys,  &
!                                     Cell_microphys, Cld_spec)
!  </TEMPLATE>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
!   cloud specification properties on model grid,
!  </INOUT>
!  <IN NAME="Lsc_microphys" TYPE="microphysics_type">
!   microphysical specification for large-scale 
!                        clouds
!  </IN>
!  <IN NAME="Meso_microphys" TYPE="microphysics_type">
!   microphysical specification for meso-scale 
!                        clouds assciated with donner convection
!  </IN>
!  <IN NAME="Cell_microphys" TYPE="microphysics_type">
!   microphysical specification for convective cell
!                        clouds associated with donner convection
!  </IN>
!  </IN>
!  <IN NAME="Shallow_microphys" TYPE="microphysics_type">
!   microphysical specification for 
!                        clouds associated with uw shallow convection
!  </IN>
! </SUBROUTINE>
! 
subroutine combine_cloud_properties (is, js, temp, Rad_time, &
                                     Lsc_microphys, Meso_microphys,  &
                                     Cell_microphys, Shallow_microphys,&
                                     Cld_spec)

!----------------------------------------------------------------------
!    combine_cloud_properties produces cloud specification property 
!    arrays for the total cloud field in each grid box, using as input 
!    the specification of the component cloud types that may be present
!    (large-scale, donner mesoscale and cell-scale, uw shallow).
!----------------------------------------------------------------------

integer, intent(in)  :: is, js
real, dimension(:,:), intent(in) :: temp
type(time_type), intent(in) :: Rad_time
type(microphysics_type),        intent(in)    :: Lsc_microphys, &
                                                 Meso_microphys, &
                                                 Cell_microphys, &
                                                 Shallow_microphys
type(cld_specification_type), intent(inout)   :: Cld_spec

!----------------------------------------------------------------------
!   intent(in) variables:
!
!       Lsc_microphys  microphysical specification for large-scale 
!                      clouds
!                      [ microphysics_type ]
!       Meso_microphys microphysical specification for meso-scale 
!                      clouds assciated with donner convection
!                      [ microphysics_type ]
!       Cell_microphys microphysical specification for convective cell
!                      clouds associated with donner convection
!                      [ microphysics_type ]
!       Shallow_microphys 
!                      microphysical specification for 
!                      clouds associated with uw shallow convection
!                      [ microphysics_type ]
!
!    intent(inout) variables:
!
!       Cld_spec       variables on the model grid which define all or
!                      some of the following, dependent on the specific
!                      cloud parameterization: cloud optical paths, 
!                      particle sizes, cloud fractions, cloud thickness,
!                      number of clouds in a column, and /or cloud type 
!                      (high/mid/low, ice/liq or random/max overlap)
!                      [ cld_specification_type ]
!
!---------------------------------------------------------------------

!-----------------------------------------------------------------------
!    variables for folding Donner cloud properties into stochastic
!    cloud arrays
!------------------------------------------------------------------
      type(randomNumberStream),   &
                    dimension(size(Lsc_microphys%cldamt,1),   &
                              size(Lsc_microphys%cldamt,2)) :: streams
      real, &            
                    dimension(size(Lsc_microphys%cldamt,1),   &
                              size(Lsc_microphys%cldamt,2),   &       
                              size(Lsc_microphys%cldamt,3),   &       
                              size(Lsc_microphys%stoch_cldamt, 4))  :: &
                                                     randomNumbers
      real    :: seedwts(8) = (/3000.,1000.,300.,100.,30.,10.,3.,1./)
      integer :: nn, nsubcols

      integer :: i, j, k, n

!---------------------------------------------------------------------
!    total-cloud specification properties need be defined only when
!    strat_cloud, donner_deep and/or uw shallow clouds are active.
!---------------------------------------------------------------------
      if (Cldrad_control%do_strat_clouds .and.    &
          Cldrad_control%do_uw_clouds .and.   &
          Cldrad_control%do_donner_deep_clouds) then

!----------------------------------------------------------------------
!    if strat_cloud, donner_deep and uw shallow are all active, define 
!    the random overlap cloud fraction as the sum of the fractions of 
!    the large-scale, donner meso-scale and cell-scale, and the
!    uw shallow clouds.
!---------------------------------------------------------------------
       Cld_spec%crndlw = Lsc_microphys%cldamt +   &
                         Cell_microphys%cldamt +  &
                       Meso_microphys%cldamt + Shallow_microphys%cldamt
     else if (Cldrad_control%do_strat_clouds .and.    &
          Cldrad_control%do_donner_deep_clouds) then


!----------------------------------------------------------------------
!    if strat_cloud and donner_deep are both active, define the random
!    overlap cloud fraction as the sum of the fractions of the large-
!    scale, meso-scale and cell-scale clouds.
!---------------------------------------------------------------------
        Cld_spec%crndlw = Lsc_microphys%cldamt +    &
                          Cell_microphys%cldamt + Meso_microphys%cldamt

       else if (Cldrad_control%do_strat_clouds .and.    &
           Cldrad_control%do_uw_clouds) then

!----------------------------------------------------------------------
!    if strat_cloud and uw_shallow  are both active, define the random
!    overlap cloud fraction as the sum of the fractions of the large-
!    scale and uw shallow clouds.
!---------------------------------------------------------------------
         Cld_spec%crndlw = Lsc_microphys%cldamt +    &
                           Shallow_microphys%cldamt

    else if (Cldrad_control%do_uw_clouds .and.    &
             Cldrad_control%do_donner_deep_clouds) then
 
!----------------------------------------------------------------------
!    if strat_cloud and donner_deep are both active, define the random
!    overlap cloud fraction as the sum of the fractions of the large-
!    scale, meso-scale and cell-scale clouds.
!---------------------------------------------------------------------
         Cld_spec%crndlw = Shallow_microphys%cldamt +    &
                          Cell_microphys%cldamt + Meso_microphys%cldamt

!------------------------------------------------------------------
!    if strat cloud is activated but donner_deep is not, define the 
!    total-cloud amount to be the large scale cloud amount.
!----------------------------------------------------------------------
      else if (Cldrad_control%do_strat_clouds) then
        Cld_spec%crndlw = Lsc_microphys%cldamt

!---------------------------------------------------------------------
!    if donner_deep is active but strat cloud is not, then the mesoscale
!    and cell-scale cloud amounts are combined to define the total
!    random-overlap cloud fraction.
!----------------------------------------------------------------------
      else if (Cldrad_control%do_donner_deep_clouds) then
        Cld_spec%crndlw = Cell_microphys%cldamt + Meso_microphys%cldamt
      else if (Cldrad_control%do_uw_clouds) then
        Cld_spec%crndlw = Shallow_microphys%cldamt
      endif

!---------------------------------------------------------------------
!    randomly-overlapped clouds are being assumed for donner_deep and 
!    strat cloud module clouds. set the max overlap cloud fraction to 
!    zero, be certain that the random overlap fraction is .le. 1. after
!    the summing of the component cloud fractions, and define the total
!    cloud fraction to be used by the sw code.
!---------------------------------------------------------------------
      Cld_spec%cmxolw = 0.0
      Cld_spec%crndlw = MIN (Cld_spec%crndlw, 1.00)
      Cld_spec%camtsw = Cld_spec%crndlw

!--------------------------------------------------------------------
!    if stochastic clouds are being used, define the cloud type to be 
!    seen by the radiation code in each stochastic subcolumn.
!--------------------------------------------------------------------
      if (Cldrad_control%do_stochastic_clouds) then

!--------------------------------------------------------------------
!   assign either a 1 or a 0 to each subcolumn indicating whether
!   lsc cloud is present or not. 
!--------------------------------------------------------------------
        nsubcols = Solar_spect%nbands + Cldrad_control%nlwcldb
        do n=1,nsubcols
          if ( n > Solar_spect%nbands) then
            nn = n - Solar_spect%nbands    
          else
            nn = n + Cldrad_control%nlwcldb    
          endif
          do k=1,size(Lsc_microphys%cldamt,3) ! Levels
            do j=1,size(Lsc_microphys%cldamt,2) ! Lons
              do i=1,size(Lsc_microphys%cldamt,1) ! Lats
                if (Lsc_microphys%stoch_cldamt(i,j,k,nn) > 0.) then
 
!----------------------------------------------------------------------
!    fill it in with the large-scale cloud values.
!----------------------------------------------------------------------
                  Cld_spec%stoch_cloud_type(i,j,k,n) = 1 
               else
                  Cld_spec%stoch_cloud_type(i,j,k,n) = 0  
               endif
             end do
            end do
          end do
        end do

!----------------------------------------------------------------------
!    compare the cell and meso-scale cloud amounts to a random number, 
!    and replace the large-scale cloud and clear sky assignment in each 
!    subcolumn with an assignment of cell or meso-scale clouds when the 
!    number is less than the cloud fraction. use the maximum overlap 
!    assumption. treat the random number as the location with the PDF 
!    of total water. cells are at the top of the PDF; then meso-scale 
!    anvils, then large-scale clouds and clear sky.
!------------------------------------------------------------
        if (Cldrad_control%do_donner_deep_clouds) then     
          if (Cldrad_control%use_temp_for_seed) then
            do j=1,size(Lsc_microphys%cldamt,2)
              do i=1,size(Lsc_microphys%cldamt,1)
                streams(i,j) = &
                  initializeRandomNumberStream (                      &
                    ishftc(nint(temp(i,j)*seedwts),1))
              end do
            end do
          else
            do j=1,size(Lsc_microphys%cldamt,2)
              do i=1,size(Lsc_microphys%cldamt,1)
                streams(i,j) = &
                  initializeRandomNumberStream (                      &
                    constructSeed(nint(lons(is+i-1,js+j-1)),           &
                                  nint(lats(is+i-1,js+j-1)), Rad_time, &
                                  perm = 1))
              end do
            end do
          endif
 
!----------------------------------------------------------------------
!    get the random numbers to do both sw and lw at oncer.
!----------------------------------------------------------------------
          do j=1,size(Lsc_microphys%cldamt,2) ! Lons
            do i=1,size(Lsc_microphys%cldamt,1) ! Lats
              call getRandomNumbers (streams(i,j),    &
                                                randomNumbers(i,j,1,:))
            end do
          end do
 
!----------------------------------------------------------------------
!    here is maximum overlap. we use a 3D arrary for the random numbers
!    for flexibility.
!----------------------------------------------------------------------
          do k=2,size(Lsc_microphys%cldamt,3)
            randomNumbers(:,:,k,:) = randomNumbers(:,:,1,:)
          end do
 
!----------------------------------------------------------------------
!    assign cloud types, band by band
!----------------------------------------------------------------------
    IF (ignore_donner_cells) then
          do n=1,nsubcols    
            do k=1,size(Lsc_microphys%cldamt,3) ! Levels
              do j=1,size(Lsc_microphys%cldamt,2) ! Lons
                do i=1,size(Lsc_microphys%cldamt,1) ! Lats
                  if (randomNumbers(i,j,k,n) >    &
                           (1. -  Meso_microphys%cldamt(i, j, k))) then
 
!----------------------------------------------------------------------
!    it's a meso-scale.
!----------------------------------------------------------------------
                    Cld_spec%stoch_cloud_type(i,j,k,n) = 2 
                  endif
                end do
              end do
            end do
          end do
    ELSE
          do n=1,nsubcols    
            do k=1,size(Lsc_microphys%cldamt,3) ! Levels
              do j=1,size(Lsc_microphys%cldamt,2) ! Lons
                do i=1,size(Lsc_microphys%cldamt,1) ! Lats
                  if (randomNumbers(i,j,k,n) >     &
                            (1. - Cell_microphys%cldamt(i,j,k))) then

!----------------------------------------------------------------------
!    it's a cell.
!----------------------------------------------------------------------
                    Cld_spec%stoch_cloud_type(i,j,k,n) = 3  
                  else if (randomNumbers(i,j,k,n) >    &
                           (1. - Cell_microphys%cldamt(i, j, k) - &
                                  Meso_microphys%cldamt(i, j, k))) then
 
!----------------------------------------------------------------------
!    it's a meso-scale.
!----------------------------------------------------------------------
                    Cld_spec%stoch_cloud_type(i,j,k,n) = 2 
                  endif
                end do
              end do
            end do
          end do
    ENDIF
        endif

!----------------------------------------------------------------------
!    compare the uw shallow cloud amount to a random number, and replace
!    the donner cloud, large-scale cloud or clear sky previously 
!    assigned in each subcolumn with an assignment of uw shallow cloud 
!    when the number is less than the cloud fraction. use the maximum 
!    overlap assumption. treat the random number as the location with 
!    the PDF of total water. uw shallow clouds are at the top of this 
!    PDF, then large-scale clouds and clear sky.
!------------------------------------------------------------
        if (Cldrad_control%do_uw_clouds) then     
          if (Cldrad_control%use_temp_for_seed) then
            do j=1,size(Lsc_microphys%cldamt,2)
              do i=1,size(Lsc_microphys%cldamt,1)
                streams(i,j) = &
                  initializeRandomNumberStream (                      &
                    ishftc(nint(temp(i,j)*seedwts),2))
              end do
            end do
          else
            do j=1,size(Lsc_microphys%cldamt,2)
              do i=1,size(Lsc_microphys%cldamt,1)
                streams(i,j) = &
                  initializeRandomNumberStream (                      &
                    constructSeed(nint(lons(is+i-1,js+j-1)),           &
                                  nint(lats(is+i-1,js+j-1)), Rad_time, &
                                  perm = 2))
              end do
            end do
          endif
 
!----------------------------------------------------------------------
!    get the random numbers to do both sw and lw at oncer.
!----------------------------------------------------------------------
          do j=1,size(Lsc_microphys%cldamt,2) ! Lons
            do i=1,size(Lsc_microphys%cldamt,1) ! Lats
              call getRandomNumbers (streams(i,j),    &
                                                randomNumbers(i,j,1,:))
            end do
          end do
 
!----------------------------------------------------------------------
!    here is maximum overlap. we use a 3D arrary for the random numbers
!    for flexibility.
!----------------------------------------------------------------------
          do k=2,size(Lsc_microphys%cldamt,3)
            randomNumbers(:,:,k,:) = randomNumbers(:,:,1,:)
          end do
 
!----------------------------------------------------------------------
!    assign cloud type, band by band
!----------------------------------------------------------------------
          do n=1,nsubcols
            do k=1,size(Lsc_microphys%cldamt,3) ! Levels
              do j=1,size(Lsc_microphys%cldamt,2) ! Lons
                do i=1,size(Lsc_microphys%cldamt,1) ! Lats
                  if (randomNumbers(i,j,k,n) >     &
                            (1. - Shallow_microphys%cldamt(i,j,k))) then

!----------------------------------------------------------------------
!    it's a uw shallow.
!----------------------------------------------------------------------
                    Cld_spec%stoch_cloud_type(i,j,k,n) = 4  
                  endif
                end do
              end do
            end do
          end do
        endif

!---------------------------------------------------------------------
!     define the cloud amount in each stochastic subcolumn to be either
!     1.0 if cloud is present, or 0.0 if no cloud exists.
!---------------------------------------------------------------------
        do n=1,Solar_spect%nbands
          do k=1,size(Lsc_microphys%cldamt,3) ! Levels
            do j=1,size(Lsc_microphys%cldamt,2) ! Lons
              do i=1,size(Lsc_microphys%cldamt,1) ! Lats
                if (Cld_spec%stoch_cloud_type(i,j,k,n) /= 0) then  
                  Cld_spec%camtsw_band(i,j,k,n) = 1.0
                else
                  Cld_spec%camtsw_band(i,j,k,n) = 0.0
                endif
              end do
            end do
          end do
        end do
        
        do n=1,Cldrad_control%nlwcldb
          nn = Solar_spect%nbands + n
          do k=1,size(Lsc_microphys%cldamt,3) ! Levels
            do j=1,size(Lsc_microphys%cldamt,2) ! Lons
              do i=1,size(Lsc_microphys%cldamt,1) ! Lats
                if (Cld_spec%stoch_cloud_type(i,j,k,nn) /= 0) then  
                  Cld_spec%crndlw_band(i,j,k,n) = 1.0
                else
                  Cld_spec%crndlw_band(i,j,k,n) = 0.0
                endif
              end do
            end do
          end do
        end do
      endif  ! (do_stochastic)


!#####################################################################


end subroutine combine_cloud_properties 



!###################################################################
! <SUBROUTINE NAME="microphs_presc_conc">
!  <OVERVIEW>
!   Subroutine to determine water droplet and ice crystal based on
!   prescribed microphysics model.
!  </OVERVIEW>
!  <DESCRIPTION>
!   This subroutine uses prescribed microphysics model to determine
!   concentrations of water droplets and ice crystals. 
!  </DESCRIPTION>
!  <TEMPLATE>
!   call microphys_presc_conc (is, ie, js, je, deltaz, temp,      &
!                                 Cld_spec, Lsc_microphys)
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!   starting indice of the x dimension in the physics domain
!  </IN>
!  <IN NAME="ie" TYPE="integer">
!   ending indice of the x dimension in the physics domain
!  </IN>
!  <IN NAME="js" TYPE="integer">
!   starting indice of the y dimension in the physics domain
!  </IN>
!  <IN NAME="je" TYPE="integer">
!   ending indice of the y dimension in the physics domain 
!  </IN>
!  <IN NAME="deltaz" TYPE="real">
!   Height of each pressure layers.
!  </IN>
!  <IN NAME="temp" TYPE="real">
!   Temperatures of pressure levels
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!   cloud specification properties on model grid,
!  </IN>
!  <INOUT NAME="Lsc_microphys" TYPE="microphysics_type">
!   microphysical specification for large-scale 
!                        clouds
!  </INOUT>
! </SUBROUTINE>
!
subroutine microphys_presc_conc (is, ie, js, je, deltaz, temp,      &
                                 Cld_spec, Lsc_microphys)

!---------------------------------------------------------------------
!    microphys_presc_conc defines microphysical properties based on the
!    assumption of specified total water paths for high, middle and low 
!    clouds.
!---------------------------------------------------------------------

integer,                      intent(in)     :: is, ie, js, je
real, dimension(:,:,:),       intent(in)     :: deltaz, temp  
type(cld_specification_type), intent(in)     :: Cld_spec
type(microphysics_type),      intent(inout)  :: Lsc_microphys

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je    starting/ending subdomain i,j indices of data in 
!                     the physics_window being integrated
!      deltaz         model vertical grid separation that is to be used
!                     for cloud calculations
!                     [meters]
!      temp           temperature at model levels (1:nlev) that is to
!                     be used in cloud calculations
!                     [ deg K ]
!      Cld_spec       cld_specification_type structure, contains var-
!                     iables defining the cloud distribution
!
!   intent(inout) variables:
!
!      Lsc_microphys  microphysics_type structure, contains variables
!                     describing the microphysical properties of the
!                     large-scale clouds
!
!---------------------------------------------------------------------

!----------------------------------------------------------------------
! local variables:                                                  
!---------------------------------------------------------------------

      real,    dimension(size(temp,1), size(temp,2), size(temp,3)) :: &
                                                       conc

      integer, dimension(size(temp,1), size(temp,2)) :: &
                                                       nhi_clouds, &
                                                       nmid_clouds, &
                                                       nlow_clouds

      integer  :: i,j,k

!--------------------------------------------------------------------
!  local variables:
!
!      conc             droplet concentration  [ g / m**3 ]
!      nhi_clouds       number of layers with high clouds
!      nmid_clouds      number of layers with middle clouds
!      nlow_clouds      number of layers with low clouds
!      i,j,k            do-loop indices
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
!!! RSH NOTE:
!
!    THE FOLLOWING treatment of diag_cloud_mod is here as an INITIAL 
!    IMPLEMENTATION to allow compilation and model execution, and 
!    provide "reasonable ?? " values.
! 
!    Code developed but NOT YET ADDED HERE reflects a later approach. 
!    That code is available under the fez release, and will be added to
!    the repository when upgrades to the cloud-radiation modules are 
!    completed.
!
!    obtain drop and ice size and concentrations, consistent with 
!    the diag_cloud scheme. As a test case, the following is a simple 
!    specification of constant concentration and size in all boxes 
!    defined as cloudy, attempting to come close to the prescribed 
!    values used for other cloud schemes. assume ice cld thickness 
!    = 2.0 km; then conc_ice=10.0E-03 => iwp = 20 g/m^2, similar to that
!    prescribed in microphys_presc_conc. assume water cld thickness 
!    = 3.5 km; then conc_drop = 20E-03 => lwp = 70 g / m^2, similar to 
!    that prescribed in microphys_presc_conc.  use sizes as used in 
!    microphys_presc_conc (50 and 20 microns). when done, radiative 
!    boundary fluxes are "similar" to non-microphysical results
!    for test case done here, and shows reasonable sensitivity to
!    variations in concentrations.
!    AGAIN, THIS IS AN INITIAL IMPLEMENTATION FOR TESTING ONLY !!!!
!
!!! RSH
!^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

!---------------------------------------------------------------------

      if (Cldrad_control%do_diag_clouds) then
!---------------------------------------------------------------------
!    define concentrations and sizes of ice at those points which have
!    condensate and which were previously determined to be ice points
!    (Cld_spec%ice_cloud), and define concentrations and sizes of
!    liquid droplets at those points with condensate that had been 
!    determined to support liquid clouds.
!---------------------------------------------------------------------
        do k=1,size(Cld_spec%camtsw,3)
          do j=1,size(Cld_spec%camtsw,2)
            do i=1,size(Cld_spec%camtsw,1)
              if (Cld_spec%camtsw(i,j,k) > 0.0) then
                if (Cld_spec%ice_cloud(i,j,k)) then
                  Lsc_microphys%conc_ice(i,j,k) = 10.0E-03  
                  Lsc_microphys%size_ice(i,j,k) = 50.     
                else
                  Lsc_microphys%conc_drop(i,j,k) = 20.0E-03
                  Lsc_microphys%size_drop(i,j,k) = 20.
                endif
              endif
            end do
          end do
        end do
!----------------------------------------------------------------------
!    for the non-diag_cloud_mod cases, assume that the water path is 
!    preset at fixed values (lwpath_hi, _mid, _low) for "high", "mid", 
!    "low" clouds. the lwpath in each cloud layer within "hi", "mid" 
!    "low" pressure intervals is that lwpath_... divided by the number 
!    of clouds present in that pressure interval.
!----------------------------------------------------------------------
      else

!----------------------------------------------------------------------
!    define the number of high, middle, low clouds according to
!    Wetherald's criterion.
!----------------------------------------------------------------------
        do j=1,size(Cld_spec%camtsw,2)
          do i=1,size(Cld_spec%camtsw,1)
            nhi_clouds(i,j)  = 0
            nmid_clouds(i,j) = 0
            nlow_clouds(i,j) = 0
            do k=1,size(Cld_spec%camtsw,3)
              if (Cld_spec%hi_cloud(i,j,k)) &
                               nhi_clouds(i,j)  =  nhi_clouds(i,j)  + 1
              if (Cld_spec%mid_cloud(i,j,k)) &
                               nmid_clouds(i,j) =  nmid_clouds(i,j) + 1
              if (Cld_spec%low_cloud(i,j,k))  &
                               nlow_clouds(i,j) =  nlow_clouds(i,j) + 1
            end do
          end do
        end do

!----------------------------------------------------------------------
!    compute the water substance concentration in each layer 
!    (as water path / layer geometric path).
!----------------------------------------------------------------------
        conc(:,:,:) = 0.0E+00
        do j=1,size(Cld_spec%camtsw,2)
          do i=1,size(Cld_spec%camtsw,1)
            do k=1,size(Cld_spec%camtsw,3)
              if (Cld_spec%hi_cloud(i,j,k)) then
                conc(i,j,k) = lwpath_hi/   &
                              (nhi_clouds(i,j)*deltaz(i,j,k))
              endif
              if (Cld_spec%mid_cloud(i,j,k)) then
                conc(i,j,k) = lwpath_mid/    &
                              (nmid_clouds(i,j)*deltaz(i,j,k))
              endif
              if (Cld_spec%low_cloud(i,j,k)) then
                conc(i,j,k) = lwpath_low    /                   &
                              (nlow_clouds(i,j)*deltaz(i,j,k))
              endif
            end do
          end do
        end do

!----------------------------------------------------------------------
!    split conc into conc_ice and conc_drop, depending on temperature
!    criterion (T < 273.16). assume that rain and / or snow are not
!    present.
!----------------------------------------------------------------------
        do k=1,size(Cld_spec%camtsw,3)
          do j=1,size(Cld_spec%camtsw,2)
            do i=1,size(Cld_spec%camtsw,1)
              if (temp(i,j,k) .LT. 273.16) then
                Lsc_microphys%conc_ice(i,j,k) = conc(i,j,k)
              else
                Lsc_microphys%conc_drop(i,j,k) = conc(i,j,k)
              endif
            end do
          end do
        end do

!----------------------------------------------------------------------
!    define sizes of microphysical species, using namelist values. note
!    that namelist drop and rain sizes are radii, so multiply by 2 to 
!    produce diameter, as desired for the %size_ arrays.
!----------------------------------------------------------------------
        Lsc_microphys%size_drop(:,:,:) = 2.0*wtr_cld_reff
        Lsc_microphys%size_rain(:,:,:) = 2.0*rain_reff
        Lsc_microphys%size_ice (:,:,:) = ice_cld_reff
      endif ! (do_diag_clouds)

!--------------------------------------------------------------------


end subroutine microphys_presc_conc


!#################################################################



                       end module cloud_spec_mod

module spectral_initialize_fields_mod

use              fms_mod, only: mpp_pe, mpp_root_pe, write_version_number

use        constants_mod, only: rdgas

use       transforms_mod, only: trans_grid_to_spherical, trans_spherical_to_grid, vor_div_from_uv_grid, &
                                uv_grid_from_vor_div, get_grid_domain, get_spec_domain, area_weighted_global_mean

implicit none
private

public :: spectral_initialize_fields

character(len=128), parameter :: version = &
'$Id: spectral_initialize_fields.F90,v 17.0 2009/07/21 03:00:42 fms Exp $'

character(len=128), parameter :: tagname = &
'$Name: tikal $'

contains

!-------------------------------------------------------------------------------------------------
subroutine spectral_initialize_fields(reference_sea_level_press, triang_trunc, initial_temperature, &
                        surf_geopotential, ln_ps, vors, divs, ts, psg, ug, vg, tg, vorg, divg)

real,    intent(in) :: reference_sea_level_press
logical, intent(in) :: triang_trunc
real,    intent(in) :: initial_temperature

real,    intent(in),  dimension(:,:    ) :: surf_geopotential
complex, intent(out), dimension(:,:    ) :: ln_ps
complex, intent(out), dimension(:,:,:  ) :: vors, divs, ts
real,    intent(out), dimension(:,:    ) :: psg
real,    intent(out), dimension(:,:,:  ) :: ug, vg, tg
real,    intent(out), dimension(:,:,:  ) :: vorg, divg

real, allocatable, dimension(:,:) :: ln_psg

real :: initial_sea_level_press, global_mean_psg
real :: initial_perturbation   = 1.e-7

integer :: ms, me, ns, ne, is, ie, js, je, num_levels

call write_version_number(version, tagname)

num_levels = size(ug,3)
call get_grid_domain(is, ie, js, je)
call get_spec_domain(ms, me, ns, ne)
allocate(ln_psg(is:ie, js:je))

initial_sea_level_press = reference_sea_level_press  

ug      = 0.
vg      = 0.
tg      = 0.
psg     = 0.
vorg    = 0.
divg    = 0.

vors  = (0.,0.)
divs  = (0.,0.)
ts    = (0.,0.)
ln_ps = (0.,0.)

tg     = initial_temperature
ln_psg = log(initial_sea_level_press) - surf_geopotential/(rdgas*initial_temperature)
psg    = exp(ln_psg)

! initial vorticity perturbation used in benchmark code
if(ms <= 1 .and. me >= 1 .and. ns <= 3 .and. ne >= 3) then
  vors(2-ms,4-ns,num_levels  ) = initial_perturbation
  vors(2-ms,4-ns,num_levels-1) = initial_perturbation
  vors(2-ms,4-ns,num_levels-2) = initial_perturbation
endif
if(ms <= 5 .and. me >= 5 .and. ns <= 3 .and. ne >= 3) then
  vors(6-ms,4-ns,num_levels  ) = initial_perturbation
  vors(6-ms,4-ns,num_levels-1) = initial_perturbation
  vors(6-ms,4-ns,num_levels-2) = initial_perturbation
endif
if(ms <= 1 .and. me >= 1 .and. ns <= 2 .and. ne >= 2) then
  vors(2-ms,3-ns,num_levels  ) = initial_perturbation
  vors(2-ms,3-ns,num_levels-1) = initial_perturbation
  vors(2-ms,3-ns,num_levels-2) = initial_perturbation
endif
if(ms <= 5 .and. me >= 5 .and. ns <= 2 .and. ne >= 2) then
  vors(6-ms,3-ns,num_levels  ) = initial_perturbation
  vors(6-ms,3-ns,num_levels-1) = initial_perturbation
  vors(6-ms,3-ns,num_levels-2) = initial_perturbation
endif
call uv_grid_from_vor_div(vors, divs, ug, vg)

!  initial spectral fields (and spectrally-filtered) grid fields

call trans_grid_to_spherical(tg, ts)
call trans_spherical_to_grid(ts, tg)

call trans_grid_to_spherical(ln_psg, ln_ps)
call trans_spherical_to_grid(ln_ps,  ln_psg)
psg = exp(ln_psg)

call vor_div_from_uv_grid(ug, vg, vors, divs, triang=triang_trunc)
call uv_grid_from_vor_div(vors, divs, ug, vg)
call trans_spherical_to_grid(vors, vorg)
call trans_spherical_to_grid(divs, divg)

!  compute and print mean surface pressure
global_mean_psg = area_weighted_global_mean(psg)
if(mpp_pe() == mpp_root_pe()) then
  print '("mean surface pressure=",f9.4," mb")',.01*global_mean_psg
endif

return
end subroutine spectral_initialize_fields
!================================================================================

end module spectral_initialize_fields_mod

module every_step_diagnostics_mod

use              fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, write_version_number

use     time_manager_mod, only: time_type

use    field_manager_mod, only: MODEL_ATMOS

use   tracer_manager_mod, only: get_number_tracers, get_tracer_names

use     diag_manager_mod, only: diag_axis_init, register_diag_field, register_static_field, send_data

use press_and_geopot_mod, only: pressure_variables

use       transforms_mod, only: grid_domain, get_deg_lon, get_deg_lat, get_grid_domain

!===============================================================================================
implicit none
private
!===============================================================================================

public :: every_step_diagnostics_init, every_step_diagnostics, every_step_diagnostics_end

!===============================================================================================

character(len=128), parameter :: version = '$Id: every_step_diagnostics.F90,v 13.0 2006/03/28 21:17:44 fms Exp $'
character(len=128), parameter :: tagname = '$Name: tikal $'

integer :: id_ps, id_u, id_v, id_t, num_levels, num_tracers
integer, allocatable, dimension(:) :: id_tr

logical :: module_is_initialized = .false.

integer :: two_dt_id_ps, two_dt_id_u, two_dt_id_v, two_dt_id_t
integer, allocatable, dimension(:) :: two_dt_id_tr
integer :: iwt, num_time_steps

real, allocatable, dimension(:,:)     :: two_dt_ps
real, allocatable, dimension(:,:,:)   :: two_dt_u, two_dt_v, two_dt_t
real, allocatable, dimension(:,:,:,:) :: two_dt_tr

integer :: is, ie, js, je

type(time_type) :: Time_save ! every_step_diagnostics_end needs time because it is a required argument of send_data,
                             ! even though the fields are static. When Time is not available to every_step_diagnostics_end
                             ! it uses Time_save instead.
!===============================================================================================

contains

!===============================================================================================

subroutine every_step_diagnostics_init(Time, lon_max, lat_max, num_levels_in, reference_sea_level_press)

type(time_type), intent(in) :: Time
integer, intent(in) :: lon_max, lat_max, num_levels_in
real, intent(in) :: reference_sea_level_press

integer, dimension(2) :: axes_2d
integer, dimension(3) :: axes_3d
integer :: id_lon, id_lat, id_pfull, ntr
real, dimension(2) :: vrange,trange
character(len=128) :: tname, longname, units
character(len=16) :: mod_name = 'dynamics_every'
real, dimension(lon_max) :: lon
real, dimension(lat_max) :: lat
real, dimension(num_levels_in)   :: p_full, ln_p_full
real, dimension(num_levels_in+1) :: p_half, ln_p_half

call write_version_number(version, tagname)

call get_deg_lon(lon)
call get_deg_lat(lat)
id_lon = diag_axis_init('lon_every', lon, 'degrees_E', 'x', 'longitude', set_name=mod_name, Domain2=grid_domain)
id_lat = diag_axis_init('lat_every', lat, 'degrees_N', 'y', 'latitude',  set_name=mod_name, Domain2=grid_domain)
call pressure_variables(p_half, ln_p_half, p_full, ln_p_full, reference_sea_level_press)
p_full = .01*p_full
id_pfull = diag_axis_init('pfull_every', p_full, 'hPa', 'z', 'approx full pressure level', direction=-1, set_name=mod_name)

vrange = (/ -400., 400. /)
trange = (/  100., 400. /)
axes_2d = (/ id_lon, id_lat /)
axes_3d = (/ id_lon, id_lat, id_pfull /)

id_ps = register_diag_field(mod_name, 'ps_every', axes_2d, Time, 'surface pressure', 'pascals')
id_u  = register_diag_field(mod_name, 'u_every',  axes_3d, Time, 'zonal wind component', 'm/sec', range=vrange)
id_v  = register_diag_field(mod_name, 'v_every',  axes_3d, Time, 'meridional wind component', 'm/sec', range=vrange)
id_t  = register_diag_field(mod_name, 't_every',  axes_3d, Time, 'temperature', 'deg_k', range=trange)

call get_number_tracers(MODEL_ATMOS, num_prog=num_tracers)
allocate(id_tr(num_tracers))
do ntr=1,num_tracers
  call get_tracer_names(MODEL_ATMOS, ntr, tname, longname, units)
  id_tr(ntr) = register_diag_field(mod_name, trim(tname)//'_every', axes_3d, Time, longname, units)
enddo

call get_grid_domain(is, ie, js, je)
num_levels = num_levels_in
allocate(two_dt_ps(is:ie, js:je))
allocate(two_dt_u (is:ie, js:je, num_levels))
allocate(two_dt_v (is:ie, js:je, num_levels))
allocate(two_dt_t (is:ie, js:je, num_levels))
allocate(two_dt_tr(is:ie, js:je, num_levels, num_tracers))
allocate(two_dt_id_tr(num_tracers))

two_dt_ps = 0.
two_dt_u  = 0.
two_dt_v  = 0.
two_dt_t  = 0.
two_dt_tr = 0.

two_dt_id_ps = register_static_field(mod_name, '2dt_ps', axes_2d, 'Amplitude of 2*dt wave in surface pressure', 'pascals')
two_dt_id_u  = register_static_field(mod_name, '2dt_u',  axes_3d, 'Amplitude of 2*dt wave in zonal wind', 'm/sec')
two_dt_id_v  = register_static_field(mod_name, '2dt_v',  axes_3d, 'Amplitude of 2*dt wave in meridional wind', 'm/sec')
two_dt_id_t  = register_static_field(mod_name, '2dt_t',  axes_3d, 'Amplitude of 2*dt wave in temperature', 'deg_k')
do ntr=1,num_tracers
  call get_tracer_names(MODEL_ATMOS, ntr, tname, longname, units)
  two_dt_id_tr(ntr) = &
       register_static_field(mod_name, '2dt_'//trim(tname), axes_3d, 'Amplitude of 2*dt wave in '//longname, units)
enddo
iwt = 1
num_time_steps = 0

module_is_initialized = .true.

return
end subroutine every_step_diagnostics_init
!===================================================================================
subroutine every_step_diagnostics(Time, p_surf, u_grid, v_grid, t_grid, tr_grid, time_level)

type(time_type), intent(in) :: Time
real, intent(in), dimension(is:, js:)          :: p_surf
real, intent(in), dimension(is:, js:, :)       :: u_grid, v_grid, t_grid
real, intent(in), dimension(is:, js:, :, :, :) :: tr_grid
integer, intent(in) :: time_level

logical :: used
integer :: i, j, k, ntr
character(len=8) :: err_msg_1, err_msg_2

if(.not.module_is_initialized) then
  call error_mesg('every_step_diagnostics','module is not initialized', FATAL)
endif

Time_save = Time

if(id_ps > 0) used = send_data(id_ps, p_surf, Time)
if(id_u  > 0) used = send_data(id_u,  u_grid, Time)
if(id_v  > 0) used = send_data(id_v,  v_grid, Time)
if(id_t  > 0) used = send_data(id_t,  t_grid, Time)

if(size(tr_grid,5) /= num_tracers) then
  write(err_msg_1,'(i8)') size(tr_grid,5)
  write(err_msg_2,'(i8)') num_tracers
  call error_mesg('every_step_diagnostics','size(tracers)='//err_msg_1//' Should be='//err_msg_2, FATAL)
endif
do ntr=1,num_tracers
  if(id_tr(ntr) > 0) used = send_data(id_tr(ntr), tr_grid(:,:,:,time_level,ntr), Time)
enddo

if(two_dt_id_ps > 0) then
  do j=js,je
    do i=is,ie
      two_dt_ps(i,j) = two_dt_ps(i,j) + iwt*p_surf(i,j)
    enddo
  enddo
endif
if(two_dt_id_u  > 0) then
  do k=1,num_levels
    do j=js,je
      do i=is,ie
        two_dt_u(i,j,k) = two_dt_u(i,j,k) + iwt*u_grid(i,j,k)
      enddo
    enddo
  enddo
endif
if(two_dt_id_v  > 0) then
  do k=1,num_levels
    do j=js,je
      do i=is,ie
        two_dt_v(i,j,k) = two_dt_v(i,j,k) + iwt*v_grid(i,j,k)
      enddo
    enddo
  enddo
endif
if(two_dt_id_t  > 0) then
  do k=1,num_levels
    do j=js,je
      do i=is,ie
        two_dt_t(i,j,k) = two_dt_t(i,j,k) + iwt*t_grid(i,j,k)
      enddo
    enddo
  enddo
endif
do ntr=1,num_tracers
  if(two_dt_id_tr(ntr) > 0) then
    do k=1,num_levels
      do j=js,je
        do i=is,ie
          two_dt_tr(i,j,k,ntr) = two_dt_tr(i,j,k,ntr) + iwt*tr_grid(i,j,k,time_level,ntr)
        enddo
      enddo
    enddo
  endif
enddo

iwt = -1*iwt
num_time_steps = num_time_steps + 1

return
end subroutine every_step_diagnostics
!===================================================================================
subroutine every_step_diagnostics_end(Time_in)
type(time_type), intent(in), optional :: Time_in
logical :: used
integer :: ntr
type(time_type) :: Time

if(.not.module_is_initialized) return

if(present(Time_in)) then
  Time = Time_in
else
  Time = Time_save
endif

two_dt_ps = two_dt_ps / num_time_steps
two_dt_u  = two_dt_u  / num_time_steps
two_dt_v  = two_dt_v  / num_time_steps
two_dt_t  = two_dt_t  / num_time_steps
two_dt_tr = two_dt_tr / num_time_steps

if(two_dt_id_ps > 0) used = send_data(two_dt_id_ps, two_dt_ps, Time)
if(two_dt_id_u  > 0) used = send_data(two_dt_id_u,  two_dt_u,  Time)
if(two_dt_id_v  > 0) used = send_data(two_dt_id_v,  two_dt_v,  Time)
if(two_dt_id_t  > 0) used = send_data(two_dt_id_t,  two_dt_t,  Time)
do ntr=1,num_tracers
  if(two_dt_id_tr(ntr) > 0) used = send_data(two_dt_id_tr(ntr), two_dt_tr(:,:,:,ntr), Time)
enddo

deallocate(id_tr, two_dt_id_tr)
deallocate(two_dt_ps, two_dt_u, two_dt_v, two_dt_t, two_dt_tr)
module_is_initialized = .false.

return
end subroutine every_step_diagnostics_end
!===================================================================================

end module every_step_diagnostics_mod

!----------------------------------------------------------------
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Niki Zadeh 
! </CONTACT>
! 
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> William Cooke
! </REVIEWER>
!
! <OVERVIEW>
! This module drives the generic version of tracers TOPAZ and CFC.
! </OVERVIEW>
!----------------------------------------------------------------
#include <fms_platform.h>
module ocean_generic_mod

  use ocean_tpm_util_mod, only: otpm_set_tracer_package, otpm_set_prog_tracer, otpm_set_diag_tracer

  use ocean_types_mod,    only: ocean_thickness_type, ocean_public_type
  use ocean_types_mod,    only: ocean_time_type
  use ocean_types_mod,    only: ocean_grid_type, ocean_domain_type
  use ocean_types_mod,    only: ocean_prog_tracer_type, ocean_diag_tracer_type
  use ocean_types_mod,    only: ocean_density_type
  use ocean_types_mod,    only: ocean_velocity_type
  use ocean_parameters_mod,      only: rho0

  use mpp_mod,            only: stdout, mpp_error, FATAL, NOTE, WARNING
  use mpp_mod,            only: mpp_clock_id, mpp_clock_begin, mpp_clock_end, CLOCK_ROUTINE

  use field_manager_mod, only: fm_get_index,fm_string_len, fm_new_value
  use generic_tracer, only: generic_tracer_init, generic_tracer_source, generic_tracer_update_from_bottom
  use generic_tracer, only: generic_tracer_coupler_get, generic_tracer_coupler_set, generic_tracer_register_diag
  use generic_tracer, only: generic_tracer_end, generic_tracer_get_list, do_generic_tracer, generic_tracer_register
  use generic_tracer, only: generic_tracer_coupler_zero, generic_tracer_vertdiff_G, generic_tracer_vertdiff_M
  use generic_tracer, only: generic_tracer_diag

  use g_tracer_utils,   only: g_tracer_get_name,g_tracer_get_alias,g_tracer_set_values,g_tracer_get_common
  use g_tracer_utils,   only: g_tracer_get_next,g_tracer_type,g_tracer_is_prog,g_tracer_flux_init
  use g_tracer_utils,   only: g_tracer_send_diag,g_tracer_get_values,g_tracer_get_pointer
  use g_tracer_utils,   only: g_tracer_set_pointer

  use coupler_types_mod, only: coupler_2d_bc_type

  implicit none ; private

  logical :: module_initialized = .false.
  ! identification numbers for mpp clocks
  integer :: id_clock_gt_vertdiff
  integer :: id_clock_gt_source,id_clock_gt_btm,id_clock_gt_diag
  integer :: id_clock_gt_get_vals,id_clock_gt_set_vals,id_clock_gt_sum_sfc_setval

  public do_generic_tracer
  public ocean_generic_sum_sfc
  public ocean_generic_zero_sfc
  public ocean_generic_sbc
  public ocean_generic_init
  public ocean_generic_flux_init
  public ocean_generic_column_physics
  public ocean_generic_end
  public ocean_generic_get_field
  public ocean_generic_get_field_pointer
  public ocean_generic_set_pointer

  interface ocean_generic_get_field
     module procedure ocean_generic_get_field_3D
     module procedure ocean_generic_get_field_4D
  end interface

  interface ocean_generic_set_pointer
     module procedure ocean_generic_set_pointer_3D
     module procedure ocean_generic_set_pointer_4D
  end interface

contains

!ALL PE subroutine on Ocean!  Due to otpm design the fluxes should be initialized like this on ALL PE's!
  subroutine ocean_generic_flux_init

    integer :: ind
    character(len=fm_string_len)   :: g_tracer_name,longname, package,units,old_package
    real :: const_init_value
    character(len=fm_string_len), parameter :: sub_name = 'ocean_generic_flux_init'
    type(g_tracer_type), pointer :: g_tracer_list,g_tracer,g_tracer_next

    if (.not. module_initialized) then 
       call generic_tracer_register
    endif

    if(.not. do_generic_tracer) return 

    call generic_tracer_get_list(g_tracer_list)
    if(.NOT. associated(g_tracer_list)) then
       call mpp_error(WARNING, trim(sub_name)// ": No generic tracer in the list.")
       return
    endif

    g_tracer=>g_tracer_list  
    do

       call g_tracer_flux_init(g_tracer)
    
       !traverse the linked list till hit NULL
       call g_tracer_get_next(g_tracer, g_tracer_next)
       if(.NOT. associated(g_tracer_next)) exit
       g_tracer=>g_tracer_next  

    enddo
    
  end subroutine ocean_generic_flux_init

  ! <SUBROUTINE NAME="ocean_generic_init">
  !  <OVERVIEW>
  !   Initialize: Add the generic tracers
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   This subroutine:
  !     Initializes the generic tracer packages and adds their tracers to the list
  !     Adds the tracers in the list of generic tracers to the set of MOM tracers 
  !     (i.e., make them elements of T_prog or T_diag)
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call ocean_generic_init(Domain,Grid,Time) 
  !  </TEMPLATE>
  ! </SUBROUTINE>
  subroutine ocean_generic_init(Domain,Grid,Time)
    type(ocean_domain_type),     intent(in)     :: Domain
    type(ocean_grid_type),       intent(in)     :: Grid
    type(ocean_time_type),       intent(in)     :: Time


    character(len=fm_string_len), parameter :: sub_name = 'ocean_generic_init'
    character(len=fm_string_len)   :: g_tracer_name,longname, package,units,old_package,restart_file
    type(g_tracer_type), pointer :: g_tracer_list,g_tracer,g_tracer_next
    real :: const_init_value
    integer :: ntau, ind, length


    if (module_initialized) return 

    !Register all the generic tracers used and create the list of them. 
    !This can be called by ALL PE's. No array fields allocated.
    call generic_tracer_register

    ntau=3 !for MOM
    !!nnz: The following requires Grid%tmask to be TARGET which it is not.
    !So I cannot pass a pointer to this array
    !  grid_tmask => Grid%tmask 

    call generic_tracer_init(Domain%isc,Domain%iec,Domain%jsc,Domain%jec,&
         Domain%isd,Domain%ied,Domain%jsd,Domain%jed,Grid%nk,ntau,&
         Grid%tracer_axes,Grid%tmask,Grid%kmt,Time%model_time)

    ! Register generic tracer modules diagnostics

    call generic_tracer_register_diag()

    !
    !Add the tracers in the list to tpm control and mark them as type='generic'
    !
    !Get the tracer list
    call generic_tracer_get_list(g_tracer_list)
    if(.NOT. associated(g_tracer_list)) then
       call mpp_error(NOTE, trim(sub_name)// ": No generic tracer in the list.")
       return
    endif

    !For each tracer name get its T_prog index and set its field
    old_package=''

    g_tracer=>g_tracer_list  
    do
       call g_tracer_get_alias(g_tracer,g_tracer_name)
       call g_tracer_get_values(g_tracer,g_tracer_name,'longname',longname)
       call g_tracer_get_values(g_tracer,g_tracer_name,'ocean_restart_file',restart_file)
       call g_tracer_get_values(g_tracer,g_tracer_name,'package', package)
       call g_tracer_get_values(g_tracer,g_tracer_name,'units',   units)
       call g_tracer_get_values(g_tracer,g_tracer_name,'const_init_value', const_init_value )

       !The following is a otpm hack. 
       !I can't find any other way to shut off otpm from complaining about the new namelists
       !added in field_table. 
       !otpm is severly restricting developers to add new fields to the field_table for ocea_mod

       if(package .ne. old_package) then

          if (fm_new_value('/ocean_mod/GOOD/good_namelists', package, append = .true.) .le. 0) then
             call mpp_error(FATAL, trim(sub_name) //                           &
                  ' Could not add ' // trim(package) // ' to "good_namelists" list')
          endif

          ind=otpm_set_tracer_package(package, restart_file=restart_file)
          old_package=package
       endif

       !Tell otpm about the generic_tracers so that they can be added to T_prog and T_diag.

       if(g_tracer_is_prog(g_tracer)) then
          if(const_init_value .ne. 0.0) then
             ind=otpm_set_prog_tracer(g_tracer_name, package, longname = longname, &
                  restart_file=restart_file,&
                  units =units, type='generic', const_init_tracer=.true.,const_init_value=const_init_value)       
          else
             ind=otpm_set_prog_tracer(g_tracer_name, package, longname = longname, &
                  restart_file=restart_file,&
                  units =units, type='generic')
          endif
       else
          if(const_init_value .ne. 0.0) then
             ind=otpm_set_diag_tracer(g_tracer_name, package, longname = longname, &
                  restart_file=restart_file,&
                  units =units, type='generic', const_init_tracer=.true.,const_init_value=const_init_value)       
          else
             ind=otpm_set_diag_tracer(g_tracer_name, package, longname = longname, &
                  restart_file=restart_file,&
                  units =units, type='generic')
          endif
       endif


       !traverse the linked list till hit NULL
       call g_tracer_get_next(g_tracer, g_tracer_next)
       if(.NOT. associated(g_tracer_next)) exit
       g_tracer=>g_tracer_next  

    enddo

    ! set clock ids
    id_clock_gt_vertdiff         = mpp_clock_id('(Ocean generic tracer: vertdiff) '     ,grain=CLOCK_ROUTINE)
    id_clock_gt_source           = mpp_clock_id('(Ocean generic tracer: source) '       ,grain=CLOCK_ROUTINE)
    id_clock_gt_btm              = mpp_clock_id('(Ocean generic tracer: bottom up) '    ,grain=CLOCK_ROUTINE)
    id_clock_gt_diag             = mpp_clock_id('(Ocean generic tracer: diag) '         ,grain=CLOCK_ROUTINE)
    id_clock_gt_set_vals         = mpp_clock_id('(Ocean generic tracer: set_values) '   ,grain=CLOCK_ROUTINE)
    id_clock_gt_get_vals         = mpp_clock_id('(Ocean generic tracer: get_values) '   ,grain=CLOCK_ROUTINE)
    id_clock_gt_sum_sfc_setval   = mpp_clock_id('(Ocean generic tracer: sumsfcsetv) '   ,grain=CLOCK_ROUTINE)  

    !---tpm remnant ends.
    module_initialized = .true.


  end subroutine ocean_generic_init

  ! <SUBROUTINE NAME="ocean_generic_zero_sfc">
  !  <OVERVIEW>
  !   zero out the coupler values for all generic tracers
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   This is need since MOM coupler values are acumulated and then divided by time ocean steps.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call ocean_generic_zero_sfc(IOB_struc)
  !  </TEMPLATE>
  ! </SUBROUTINE>

  subroutine ocean_generic_zero_sfc(IOB_struc)
    type(coupler_2d_bc_type), intent(inout) :: IOB_struc

    call generic_tracer_coupler_zero(IOB_struc)

  end subroutine ocean_generic_zero_sfc


  ! <SUBROUTINE NAME="ocean_generic_sum_sfc">
  !  <OVERVIEW>
  !   Calculate the surface state and set coupler values 
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   This subroutine calculates the surface state and set coupler values for 
  !   those generic tracers that havd flux exchange with atmosphere.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call ocean_generic_sum_sfc(Disd,Djsd, Ocean, T_prog, Dens, Time ) 
  !  </TEMPLATE>
  ! </SUBROUTINE>
  subroutine ocean_generic_sum_sfc(Disd,Djsd, Ocean, T_prog, Dens, Time )
    integer,                  intent(in)                    :: Disd,Djsd
    type(ocean_public_type), intent(inout)                  :: Ocean
    type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
    type(ocean_time_type), intent(in)                       :: Time
    type(ocean_density_type), intent(in)                    :: Dens

    type(g_tracer_type), pointer    :: g_tracer_list,g_tracer,g_tracer_next
    integer                           :: g_tracer_index
    integer :: indtemp,indsal
    character(len=fm_string_len)      :: g_tracer_name
    character(len=fm_string_len), parameter :: sub_name = 'ocean_generic_sum_sfc'

    indtemp=-1
    indsal=-1

    indtemp = fm_get_index('/ocean_mod/prog_tracers/temp')
    if (indtemp .le. 0) then
       call mpp_error(FATAL,trim(sub_name) // ' Could not get the temperature index')
    endif

    indsal = fm_get_index('/ocean_mod/prog_tracers/salt')
    if (indsal .le. 0) then
       call mpp_error(FATAL,trim(sub_name) // ' Could not get the salinity index')
    endif

    !Get the tracer list
    call generic_tracer_get_list(g_tracer_list)
    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    call generic_tracer_coupler_set(Ocean%fields,&
         ST=T_prog(indtemp)%field(:,:,1,Time%taum1),&
         SS=T_prog(indsal)%field(:,:,1,Time%taum1),&
         rho=Dens%rho,& !nnz: required for MOM
         ilb=Disd, jlb=Djsd,&
         tau=Time%taum1)


    !Send diagnostics
    call g_tracer_send_diag(g_tracer_list, Time%model_time, Time%tau)

  end subroutine ocean_generic_sum_sfc

  ! <SUBROUTINE NAME="ocean_generic_sbc">
  !  <OVERVIEW>
  !   Get the coupler values 
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   This subroutine gets coupler values for 
  !   those generic tracers that have flux exchange with atmosphere.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call ocean_generic_sbc(Ice_ocean_boundary_fluxes,Disd,Djsd, T_prog )
  !  </TEMPLATE>
  ! </SUBROUTINE>
  subroutine ocean_generic_sbc(Ice_ocean_boundary_fluxes,Disd,Djsd, T_prog, runoff )
    type(coupler_2d_bc_type), intent(in)                            :: Ice_ocean_boundary_fluxes
    integer,                  intent(in)                            :: Disd,Djsd
    type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
    real, intent(in), dimension(Disd:,Djsd:)                        :: runoff

    type(g_tracer_type), pointer    :: g_tracer_list,g_tracer,g_tracer_next
    integer                           :: g_tracer_index
    character(len=fm_string_len)      :: g_tracer_name
    character(len=fm_string_len), parameter :: sub_name = 'update_generic_tracer_sbc'

    !Extract the tracer surface fields from coupler 
    call generic_tracer_coupler_get(Ice_ocean_boundary_fluxes)

    !Update T_prog fields from generic tracer fields
    !
    !Get the tracer list
    call generic_tracer_get_list(g_tracer_list)
    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")
    !For each tracer name get its T_prog index and get its flux fields
    g_tracer=>g_tracer_list  
    do
       if(g_tracer_is_prog(g_tracer)) then
          call g_tracer_get_alias(g_tracer,g_tracer_name)
          g_tracer_index = fm_get_index(trim('/ocean_mod/prog_tracers/'//g_tracer_name))
          if (g_tracer_index .le. 0) &
               call mpp_error(FATAL,trim(sub_name) // ' Could not get the index for '//g_tracer_name)

          if (_ALLOCATED(g_tracer%stf) )&
               call g_tracer_get_values(g_tracer,g_tracer_name,'stf',   T_prog(g_tracer_index)%stf,   Disd,Djsd)

          if (_ALLOCATED(g_tracer%btf) )&
               call g_tracer_get_values(g_tracer,g_tracer_name,'btf',   T_prog(g_tracer_index)%btf,   Disd,Djsd)

          !If the tracer has runoff fill in the T_prog(n)%trunoff and  T_prog(n)%runoff_tracer_flux
          if(_ALLOCATED(g_tracer%trunoff)) then
             !Fill in T_prog(n)%trunoff

             call g_tracer_get_values(g_tracer,g_tracer_name,'trunoff',T_prog(g_tracer_index)%trunoff,Disd,Djsd)

             !Fill in T_prog(n)%runoff_tracer_flux
             T_prog(g_tracer_index)%runoff_tracer_flux = T_prog(g_tracer_index)%trunoff * runoff

             !Set g_tracer%runoff_tracer_flux
             call g_tracer_set_values(g_tracer,g_tracer_name,'runoff_tracer_flux',T_prog(g_tracer_index)%runoff_tracer_flux,Disd,Djsd)
             !
             !Fill in T_prog(n)%triver in MOM
             !Note: This is done so that MOM can apply the river fluxes through setting either
             !        the runoff and calving fluxes (when discharge_combine_runoff_calve=.false.) 
             !      or
             !        the total river concentration (when discharge_combine_runoff_calve=.true.)
             !
             !Assume zero calving flux for the generic tracers.
             !T_prog(g_tracer_index)%tcalving = 0 !MOM default
             T_prog(g_tracer_index)%triver = T_prog(g_tracer_index)%trunoff 
             
          endif
       
       endif

       !traverse the linked list till hit NULL
       call g_tracer_get_next(g_tracer, g_tracer_next)
       if(.NOT. associated(g_tracer_next)) exit
       g_tracer=>g_tracer_next  

    enddo
  end subroutine ocean_generic_sbc

  ! <SUBROUTINE NAME="ocean_generic_column_physics">
  !  <OVERVIEW>
  !   Column physics for generic tracers.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   This subroutine:
  !       Update generic tracer concentration fields from sources and sinks.
  !       Vertically diffuse generic tracer concentration fields.
  !       Update generic tracers from bottom and their bottom reservoir.  
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call ocean_generic_column_physics(Thickness, hblt_depth, Time, Grid, dtts, Disd,Djsd, T_prog, T_diag,&
  !                                     sw_pen,opacity, diff_cbt, river, Velocity )
  !  </TEMPLATE>
  ! </SUBROUTINE>
  subroutine ocean_generic_column_physics(Thickness, hblt_depth, Time, Grid, dtts, Disd,Djsd, T_prog, T_diag,&
       sw_pen,opacity, diff_cbt, Velocity)
    integer,                  intent(in)                            :: Disd,Djsd
    type(ocean_grid_type), intent(in)                               :: Grid
    type(ocean_time_type), intent(in)                               :: Time
    type(ocean_thickness_type), intent(in)                          :: Thickness
    type(ocean_Velocity_type), intent(in)                           :: Velocity
    real, intent(in), dimension(Disd:,Djsd:)                        :: hblt_depth,sw_pen
    real, intent(in), dimension(Disd:,Djsd:,:)                      :: opacity
    real, intent(in), dimension(Disd:,Djsd:,:,:)                    :: diff_cbt
    real, intent(in)                                                :: dtts
    type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
    type(ocean_diag_tracer_type), dimension(:), intent(inout)       :: T_diag

    type(g_tracer_type), pointer    :: g_tracer_list,g_tracer,g_tracer_next
    integer                           :: g_tracer_index
    integer :: indtemp,indsal
    integer :: isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,nbands,i,j,k
    real, dimension(:),       Allocatable :: max_wavelength_band
    real, dimension(:,:,:),   Allocatable :: sw_pen_band
    real, dimension(:,:,:,:), Allocatable :: opacity_band
    logical, save                         :: initialize_tau_level = .true.

    character(len=fm_string_len)      :: g_tracer_name
    character(len=fm_string_len), parameter :: sub_name = 'ocean_generic_column_physics'

    !
    !Update the fields of the generic tracers from T_prog
    !
    !This step is not needed any more since generic tracers %field points to and reuse the corresponding MOM arrays.
    !
    !Update from sources
    indtemp=-1
    indsal=-1

    indtemp = fm_get_index('/ocean_mod/prog_tracers/temp')
    if (indtemp .le. 0) then 
       call mpp_error(FATAL,trim(sub_name) // ' Could not get the temperature index')
    endif

    indsal = fm_get_index('/ocean_mod/prog_tracers/salt')
    if (indsal .le. 0) then  
       call mpp_error(FATAL,trim(sub_name) // ' Could not get the salinity index')
    endif

    call g_tracer_get_common(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau)

    !For MOM opacity and sw_pen have 1 band only.
    nbands=1
    allocate(max_wavelength_band(nbands)); max_wavelength_band =0.0
    allocate( sw_pen_band(nbands,isd:ied, jsd:jed));    
    allocate(opacity_band(nbands,isd:ied, jsd:jed,nk)); 

    do j = jsc, jec ; do i = isc, iec  
       sw_pen_band(1,i,j)   = sw_pen(i,j)
       do k = 1, nk 
          opacity_band(1,i,j,k)= opacity(i,j,k)
       enddo
    enddo; enddo
       
    call mpp_clock_begin(id_clock_gt_source)
    
    call generic_tracer_source(T_prog(indtemp)%field(:,:,:,Time%taup1),&
         T_prog(indsal)%field(:,:,:,Time%taup1), Thickness%rho_dzt(:,:,:,Time%taup1), Thickness%dzt,&
         hblt_depth, Disd, Djsd, Time%taup1,dtts,Grid%dat, Time%model_time,&
         nbands, max_wavelength_band, sw_pen_band, opacity_band, Grid%ht, Velocity%current_wave_stress(:,:))

    call mpp_clock_end(id_clock_gt_source)
    deallocate(max_wavelength_band,sw_pen_band,opacity_band)

    ! Explicit Vertical Diffusion

    call mpp_clock_begin(id_clock_gt_vertdiff)

    call generic_tracer_vertdiff_M(Thickness%rho_dzt(:,:,:,Time%taup1), Thickness%dzwt, diff_cbt(:,:,:,1),&
         dtts, rho0, Time%taup1)

    call mpp_clock_end(id_clock_gt_vertdiff)

    ! Update bottom fields after vertical processes
    call mpp_clock_begin(id_clock_gt_btm)
    call generic_tracer_update_from_bottom(dtts, Time%taup1, Time%model_time)
    call mpp_clock_end(id_clock_gt_btm)

    !
    ! Finish up generic tracers
    !
    call mpp_clock_begin(id_clock_gt_diag)
    call generic_tracer_diag(Disd, Djsd, Time%tau, Time%taup1, dtts, Time%model_time, Thickness%dzt,  &
         Thickness%rho_dzt(:,:,:,Time%tau), Thickness%rho_dzt(:,:,:,Time%taup1))
    call mpp_clock_end(id_clock_gt_diag)

    !!nnz: the following is necessary if generic tracers are allocated by MOM
    !
    !Update T_prog fields from generic tracer fields
    !This step is not needed for %fields any more since generic tracers %field points to and reuse the corresponding MOM arrays.
    !
    !Get the tracer list
    call generic_tracer_get_list(g_tracer_list)
    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")
    g_tracer=>g_tracer_list  
    call mpp_clock_begin(id_clock_gt_get_vals)
    do
       call g_tracer_get_alias(g_tracer,g_tracer_name)
       if(g_tracer_is_prog(g_tracer)) then
          g_tracer_index = fm_get_index(trim('/ocean_mod/prog_tracers/'//g_tracer_name))
          if (g_tracer_index .le. 0) &
               call mpp_error(FATAL,trim(sub_name) // ' Could not get the index for '//g_tracer_name)

          if (_ALLOCATED(g_tracer%btf) )&
               call g_tracer_get_values(g_tracer,g_tracer_name,'btf',   T_prog(g_tracer_index)%btf,   Disd,Djsd)
       endif

       !traverse the linked list till hit NULL
       call g_tracer_get_next(g_tracer, g_tracer_next)
       if(.NOT. associated(g_tracer_next)) exit
       g_tracer=>g_tracer_next  

    enddo
    call mpp_clock_end(id_clock_gt_get_vals)

  end subroutine ocean_generic_column_physics

  subroutine ocean_generic_get_field_pointer(name, field)
    character(len=*),         intent(in)    :: name    
    real, dimension(:,:,:), pointer :: field
    type(g_tracer_type), pointer      :: g_tracer_list

    call generic_tracer_get_list(g_tracer_list)
    call g_tracer_get_pointer(g_tracer_list,name,'field', field )
    
  end subroutine ocean_generic_get_field_pointer

  subroutine ocean_generic_get_field_4D(name, field)
    character(len=*),         intent(in)    :: name    
    real, dimension(:,:,:,:), intent(inout) :: field
    type(g_tracer_type), pointer      :: g_tracer_list
    real, dimension(:,:,:,:), pointer :: ptr

    call generic_tracer_get_list(g_tracer_list)
    call g_tracer_get_pointer(g_tracer_list,name,'field', ptr )
    field = ptr
  end subroutine ocean_generic_get_field_4D

  subroutine ocean_generic_get_field_3D(name, field)
    character(len=*),         intent(in)    :: name    
    real, dimension(:,:,:), intent(inout) :: field
    real, dimension(:,:,:), pointer :: ptr
    type(g_tracer_type), pointer    :: g_tracer_list

    call generic_tracer_get_list(g_tracer_list)
    call g_tracer_get_pointer(g_tracer_list,name,'field', ptr )
    field = ptr
    
  end subroutine ocean_generic_get_field_3D

  subroutine ocean_generic_set_pointer_4d(name, member, field, ilb, jlb)
    character(len=fm_string_len), parameter :: sub_name = 'ocean_generic_set_pointer_4d'
    character(len=*),                       intent(in)  :: name
    character(len=*),                       intent(in)  :: member
    real, dimension(ilb:,jlb:,:,:), target, intent(in)  :: field
    integer,                                intent(in)  :: ilb
    integer,                                intent(in)  :: jlb
    type(g_tracer_type), pointer      :: g_tracer_list

    call generic_tracer_get_list(g_tracer_list)
    if (associated(g_tracer_list)) then
      call g_tracer_set_pointer(g_tracer_list, name, member, field, ilb, jlb)
    else
      call mpp_error(NOTE, trim(sub_name)// ": No generic tracer in the list. No generic tracers?")
    endif
  end subroutine ocean_generic_set_pointer_4d

  subroutine ocean_generic_set_pointer_3d(name, member, field, ilb, jlb)
    character(len=fm_string_len), parameter :: sub_name = 'ocean_generic_set_pointer_3d'
    character(len=*),                     intent(in)    :: name
    character(len=*),                     intent(in)  :: member
    real, dimension(ilb:,jlb:,:), target, intent(in)    :: field
    integer,                              intent(in)    :: ilb
    integer,                              intent(in)    :: jlb
    type(g_tracer_type), pointer      :: g_tracer_list

    call generic_tracer_get_list(g_tracer_list)
    if (associated(g_tracer_list)) then
      call g_tracer_set_pointer(g_tracer_list, name, member, field, ilb, jlb)
    else
      call mpp_error(NOTE, trim(sub_name)// ": No generic tracer in the list. No generic tracers?")
    endif
  end subroutine ocean_generic_set_pointer_3d

  ! <SUBROUTINE NAME="ocean_generic_end">
  !  <OVERVIEW>
  !   Ends the generic tracer module
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !  Call the end for generic tracer module and deallocate all temp arrays 
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call ocean_generic_end
  !  </TEMPLATE>
  ! </SUBROUTINE>

  subroutine ocean_generic_end
    call generic_tracer_end
  end subroutine ocean_generic_end


end module ocean_generic_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: modis_simulator.F90,v 20.0 2013/12/13 23:15:56 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) 2009-2010, Regents of the Unversity of Colorado
!   Author: Robert Pincus, Cooperative Institute for Research in the Environmental Sciences
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!

!
! History:
!   May 2009 - Robert Pincus - Initial version
!   June 2009 - Steve Platnick and Robert Pincus - Simple radiative transfer for size retrievals
!   August 2009 - Robert Pincus - Consistency and bug fixes suggested by Rick Hemler (GFDL) 
!   November 2009 - Robert Pincus - Bux fixes and speed-ups after experience with Rick Hemler using AM2 (GFDL) 
!   January 2010 - Robert Pincus - Added high, middle, low cloud fractions 
!

!
! Notes on using the MODIS simulator: 
!  *) You may provide either layer-by-layer values of optical thickness at 0.67 and 2.1 microns, or 
!     optical thickness at 0.67 microns and ice- and liquid-water contents (in consistent units of 
!     your choosing)
!  *) Required input also includes the optical thickness and cloud top pressure 
!     derived from the ISCCP simulator run with parameter top_height = 1. 
!  *) Cloud particle sizes are specified as radii, measured in meters, though within the module we 
!     use units of microns. Where particle sizes are outside the bounds used in the MODIS retrieval
!     libraries (parameters re_water_min, re_ice_min, etc.) the simulator returns missing values (re_fill)

!
! When error conditions are encountered this code calls the function complain_and_die, supplied at the 
!   bottom of this module. Users probably want to replace this with something more graceful. 
!
module mod_modis_sim
  USE MOD_COSP_TYPES, only: R_UNDEF
#ifdef COSP_GFDL
  use fms_mod, only : error_mesg, FATAL
#endif
  implicit none
  ! ------------------------------
  ! Algorithmic parameters
  !
 
  real, parameter :: ice_density          = 0.93               ! liquid density is 1.  
  !
  ! Retrieval parameters
  !
  real, parameter :: min_OpticalThickness = 0.3,             & ! Minimum detectable optical thickness
                     CO2Slicing_PressureLimit = 700. * 100., & ! Cloud with higher pressures use thermal methods, units Pa
                     CO2Slicing_TauLimit = 1.,               & ! How deep into the cloud does CO2 slicing see? 
                     phase_TauLimit      = 1.,               & ! How deep into the cloud does the phase detection see?
                     size_TauLimit       = 2.,               & ! Depth of the re retreivals
                     phaseDiscrimination_Threshold = 0.7       ! What fraction of total extincton needs to be 
                                                               !  in a single category to make phase discrim. work? 
  real,    parameter :: re_fill= -999.
  integer, parameter :: phaseIsNone = 0, phaseIsLiquid = 1, phaseIsIce = 2, phaseIsUndetermined = 3
  
  logical, parameter :: useSimpleReScheme = .false. 
  !
  ! These are the limits of the libraries for the MODIS collection 5 algorithms 
  !   They are also the limits used in the fits for g and w0
  !
  real,    parameter :: re_water_min= 4., re_water_max= 30., re_ice_min= 5., re_ice_max= 90.
  integer, parameter :: num_trial_res = 15             ! increase to make the linear pseudo-retrieval of size more accurate
  logical, parameter :: use_two_re_iterations = .false. ! do two retrieval iterations? 
  
  !
  ! Precompute near-IR optical params vs size for retrieval scheme
  !
  integer, private :: i 
  real, dimension(num_trial_res), parameter :: & 
        trial_re_w = re_water_min + (re_water_max - re_water_min)/(num_trial_res-1) * (/ (i - 1, i = 1, num_trial_res) /), &
        trial_re_i = re_ice_min   + (re_ice_max -   re_ice_min)  /(num_trial_res-1) * (/ (i - 1, i = 1, num_trial_res) /)
  
  ! Can't initialze these during compilation, but do in before looping columns in retrievals
  real, dimension(num_trial_res) ::  g_w, g_i, w0_w, w0_i
  ! ------------------------------
  ! Bin boundaries for the joint optical thickness/cloud top pressure histogram
  !
  integer, parameter :: numTauHistogramBins = 6, numPressureHistogramBins = 7

  real, private :: dummy_real 
  real, dimension(numTauHistogramBins + 1),      parameter :: &
    tauHistogramBoundaries = (/ min_OpticalThickness, 1.3, 3.6, 9.4, 23., 60., huge(dummy_real) /) 
  real, dimension(numPressureHistogramBins + 1), parameter :: & ! Units Pa 
    pressureHistogramBoundaries = (/ 0., 18000., 31000., 44000., 56000., 68000., 80000., huge(dummy_real) /) 
  real, parameter :: highCloudPressureLimit = 440. * 100., lowCloudPressureLimit = 680.  * 100.
  !
  ! For output - nominal bin centers and  bin boundaries. On output pressure bins are highest to lowest. 
  !
  integer, private :: k, l
  real, parameter, dimension(2, numTauHistogramBins) ::   &
    nominalTauHistogramBoundaries =                       &
        reshape(source = (/ tauHistogramBoundaries(1),    &
                            ((tauHistogramBoundaries(k), l = 1, 2), k = 2, numTauHistogramBins), &
                            100000. /),                    &
                shape = (/2,  numTauHistogramBins /) )
  real, parameter, dimension(numTauHistogramBins) ::                    &
    nominalTauHistogramCenters = (nominalTauHistogramBoundaries(1, :) + &
                                  nominalTauHistogramBoundaries(2, :) ) / 2.
  
  real, parameter, dimension(2, numPressureHistogramBins) :: &
    nominalPressureHistogramBoundaries =                     &
        reshape(source = (/ 100000.,                         &
                            ((pressureHistogramBoundaries(k), l = 1, 2), k = numPressureHistogramBins, 2, -1), &
                            0.  /), &
                shape = (/2,  numPressureHistogramBins /) )
  real, parameter, dimension(numPressureHistogramBins) ::                         &
    nominalPressureHistogramCenters = (nominalPressureHistogramBoundaries(1, :) + &
                                       nominalPressureHistogramBoundaries(2, :) ) / 2.
  ! ------------------------------
  ! There are two ways to call the MODIS simulator: 
  !  1) Provide total optical thickness and liquid/ice water content and we'll partition tau in 
  !     subroutine modis_L2_simulator_oneTau, or 
  !  2) Provide ice and liquid optical depths in each layer
  !
  interface modis_L2_simulator
    module procedure modis_L2_simulator_oneTau, modis_L2_simulator_twoTaus
  end interface 
contains
  !------------------------------------------------------------------------------------------------
  ! MODIS simulator using specified liquid and ice optical thickness in each layer 
  !
  !   Note: this simulator operates on all points; to match MODIS itself night-time 
  !     points should be excluded
  !
  !   Note: the simulator requires as input the optical thickness and cloud top pressure 
  !     derived from the ISCCP simulator run with parameter top_height = 1. 
  !     If cloud top pressure is higher than about 700 mb, MODIS can't use CO2 slicing 
  !     and reverts to a thermal algorithm much like ISCCP's. Rather than replicate that 
  !     alogrithm in this simulator we simply report the values from the ISCCP simulator. 
  !
  subroutine modis_L2_simulator_twoTaus(                                       &
                                temp, pressureLayers, pressureLevels,          &
                                liquid_opticalThickness, ice_opticalThickness, &
                                waterSize, iceSize,                            & 
                                isccpTau, isccpCloudTopPressure,               &
                                retrievedPhase, retrievedCloudTopPressure, retrievedTau, retrievedSize)

    ! Grid-mean quantities at layer centers, starting at the model top
    !   dimension nLayers
    real, dimension(:),    intent(in ) :: temp,           & ! Temperature, K
                                          pressureLayers, & ! Pressure, Pa
                                          pressureLevels    ! Pressure at layer edges, Pa (dimension nLayers + 1) 
    ! Sub-column quantities
    !   dimension  nSubcols, nLayers
    real, dimension(:, :), intent(in ) :: liquid_opticalThickness, & ! Layer optical thickness @ 0.67 microns due to liquid
                                          ice_opticalThickness       ! ditto, due to ice
    real, dimension(:, :), intent(in ) :: waterSize,        & ! Cloud drop effective radius, microns
                                          iceSize             ! Cloud ice effective radius, microns
                                          
    ! Cloud properties retrieved from ISCCP using top_height = 1
    !    dimension nSubcols
    real, dimension(:),    intent(in ) :: isccpTau, &           ! Column-integrated optical thickness 
                                          isccpCloudTopPressure ! ISCCP-retrieved cloud top pressure (Pa) 

    ! Properties retrieved by MODIS
    !   dimension nSubcols
    integer, dimension(:), intent(out) :: retrievedPhase               ! liquid/ice/other - integer, defined in module header
    real,    dimension(:), intent(out) :: retrievedCloudTopPressure, & ! units of pressureLayers
                                          retrievedTau,              & ! unitless
                                          retrievedSize                ! microns 
    ! ---------------------------------------------------
    ! Local variables
    logical, dimension(size(retrievedTau))                     :: cloudMask
    real,    dimension(size(waterSize, 1), size(waterSize, 2)) :: tauLiquidFraction, tauTotal
    real    :: integratedLiquidFraction
    integer :: i, nSubcols, nLevels

    ! ---------------------------------------------------
    nSubcols = size(liquid_opticalThickness, 1)
    nLevels  = size(liquid_opticalThickness, 2) 
 
    !
    ! Initial error checks 
    !   
    if(any((/ size(ice_opticalThickness, 1), size(waterSize, 1), size(iceSize, 1), &
              size(isccpTau), size(isccpCloudTopPressure),              &
              size(retrievedPhase), size(retrievedCloudTopPressure),    &
              size(retrievedTau), size(retrievedSize) /) /= nSubcols )) &
       call complain_and_die("Differing number of subcolumns in one or more arrays") 
    
    if(any((/ size(ice_opticalThickness, 2), size(waterSize, 2), size(iceSize, 2),      &
              size(temp), size(pressureLayers), size(pressureLevels)-1 /) /= nLevels )) &
       call complain_and_die("Differing number of levels in one or more arrays") 
       
       
    if(any( (/ any(temp <= 0.), any(pressureLayers <= 0.),  &
               any(liquid_opticalThickness < 0.),           &
               any(ice_opticalThickness < 0.),              &
               any(waterSize < 0.), any(iceSize < 0.) /) )) &
       call complain_and_die("Input values out of bounds") 
             
    ! ---------------------------------------------------
    !
    ! Compute the total optical thickness and the proportion due to liquid in each cell
    !
    where(liquid_opticalThickness(:, :) + ice_opticalThickness(:, :) > 0.) 
      tauLiquidFraction(:, :) = liquid_opticalThickness(:, :)/(liquid_opticalThickness(:, :) + ice_opticalThickness(:, :))
    elsewhere
      tauLiquidFraction(:, :) = 0. 
    end  where 
    tauTotal(:, :) = liquid_opticalThickness(:, :) + ice_opticalThickness(:, :) 
    
    !
    ! Optical depth retrieval 
    !   This is simply a sum over the optical thickness in each layer 
    !   It should agree with the ISCCP values after min values have been excluded 
    !
    retrievedTau(:) = sum(tauTotal(:, :), dim = 2)

    !
    ! Cloud detection - does optical thickness exceed detection threshold? 
    !
    cloudMask = retrievedTau(:) >= min_OpticalThickness
    
    !
    ! Initialize initial estimates for size retrievals
    !
    if(any(cloudMask) .and. .not. useSimpleReScheme) then 
      g_w(:)  = get_g_nir(  phaseIsLiquid, trial_re_w(:))
      w0_w(:) = get_ssa_nir(phaseIsLiquid, trial_re_w(:))
      g_i(:)  = get_g_nir(  phaseIsIce,    trial_re_i(:))
      w0_i(:) = get_ssa_nir(phaseIsIce,    trial_re_i(:))
    end if 
    
    do i = 1, nSubCols
      if(cloudMask(i)) then 
        !
        ! Cloud top pressure determination 
        !   MODIS uses CO2 slicing for clouds with tops above about 700 mb and thermal methods for clouds
        !   lower than that. 
        !  For CO2 slicing we report the optical-depth weighted pressure, integrating to a specified 
        !    optical depth
        ! This assumes linear variation in p between levels. Linear in ln(p) is probably better, 
        !   though we'd need to deal with the lowest pressure gracefully. 
        !
        retrievedCloudTopPressure(i) = cloud_top_pressure((/ 0., tauTotal(i, :) /), &
                                                          pressureLevels,           &
                                                          CO2Slicing_TauLimit)  
        
        
        !
        ! Phase determination - determine fraction of total tau that's liquid 
        ! When ice and water contribute about equally to the extinction we can't tell 
        !   what the phase is 
        !
        integratedLiquidFraction = weight_by_extinction(tauTotal(i, :),          &
                                                        tauLiquidFraction(i, :), &
                                                        phase_TauLimit)
        if(integratedLiquidFraction >= phaseDiscrimination_Threshold) then 
          retrievedPhase(i) = phaseIsLiquid
        else if (integratedLiquidFraction <= 1.- phaseDiscrimination_Threshold) then 
          retrievedPhase(i) = phaseIsIce
        else 
          retrievedPhase(i) = phaseIsUndetermined
        end if 
        
        !
        ! Size determination 
        !
        if(useSimpleReScheme) then 
          !   This is the extinction-weighted size considering only the phase we've chosen 
          !
          if(retrievedPhase(i) == phaseIsIce) then 
            retrievedSize(i) = weight_by_extinction(ice_opticalThickness(i, :),  &
                                                    iceSize(i, :), &
                                                    (1. - integratedLiquidFraction) * size_TauLimit)
  
          else if(retrievedPhase(i) == phaseIsLiquid) then 
            retrievedSize(i) = weight_by_extinction(liquid_opticalThickness(i, :), &
                                                    waterSize(i, :), &
                                                    integratedLiquidFraction * size_TauLimit)
  
          else
            retrievedSize(i) = 0. 
          end if 
        else
          retrievedSize(i) = 1.0e-06*retrieve_re(retrievedPhase(i), retrievedTau(i), &
                         obs_Refl_nir = compute_nir_reflectance(liquid_opticalThickness(i, :), waterSize(i, :)*1.0e6, & 
                         ice_opticalThickness(i, :),      iceSize(i, :)*1.0e6))
        end if 
      else 
        !
        ! Values when we don't think there's a cloud. 
        !
        retrievedCloudTopPressure(i) = R_UNDEF 
        retrievedPhase(i) = phaseIsNone
        retrievedSize(i) = R_UNDEF 
        retrievedTau(i) = R_UNDEF 
      end if
    end do
    where((retrievedSize(:) < 0.).and.(retrievedSize(:) /= R_UNDEF)) retrievedSize(:) = 1.0e-06*re_fill

    ! We use the ISCCP-derived CTP for low clouds, since the ISCCP simulator ICARUS 
    !   mimics what MODIS does to first order. 
    !   Of course, ISCCP cloud top pressures are in mb. 
    !   
    where(cloudMask(:) .and. retrievedCloudTopPressure(:) > CO2Slicing_PressureLimit) &
      retrievedCloudTopPressure(:) = isccpCloudTopPressure * 100. 
    
  end subroutine modis_L2_simulator_twoTaus
  !------------------------------------------------------------------------------------------------
  !
  ! MODIS simulator: provide a single optical thickness and the cloud ice and liquid contents; 
  !   we'll partition this into ice and liquid optical thickness and call the full MODIS simulator 
  ! 
  subroutine modis_L2_simulator_oneTau(                                         &
                                temp, pressureLayers, pressureLevels,           &
                                opticalThickness, cloudWater, cloudIce,         &
                                waterSize, iceSize,                             & 
                                isccpTau, isccpCloudTopPressure,                &
                                retrievedPhase, retrievedCloudTopPressure, retrievedTau, retrievedSize)
    ! Grid-mean quantities at layer centers, 
    !   dimension nLayers
    real, dimension(:),    intent(in ) :: temp,           & ! Temperature, K
                                          pressureLayers, & ! Pressure, Pa
                                          pressureLevels    ! Pressure at layer edges, Pa (dimension nLayers + 1) 
    ! Sub-column quantities
    !   dimension nLayers, nSubcols
    real, dimension(:, :), intent(in ) :: opticalThickness, & ! Layer optical thickness @ 0.67 microns
                                          cloudWater,       & ! Cloud water content, arbitrary units
                                          cloudIce            ! Cloud water content, same units as cloudWater
    real, dimension(:, :), intent(in ) :: waterSize,        & ! Cloud drop effective radius, microns
                                          iceSize             ! Cloud ice effective radius, microns

    ! Cloud properties retrieved from ISCCP using top_height = 1
    !    dimension nSubcols
    
    real, dimension(:),    intent(in ) :: isccpTau, &           ! Column-integrated optical thickness 
                                          isccpCloudTopPressure ! ISCCP-retrieved cloud top pressure (Pa) 

    ! Properties retrieved by MODIS
    !   dimension nSubcols
    integer, dimension(:), intent(out) :: retrievedPhase               ! liquid/ice/other - integer
    real,    dimension(:), intent(out) :: retrievedCloudTopPressure, & ! units of pressureLayers
                                          retrievedTau,              & ! unitless
                                          retrievedSize                ! microns (or whatever units 
                                                                       !   waterSize and iceSize are supplied in)
    ! ---------------------------------------------------
    ! Local variables
    real, dimension(size(opticalThickness, 1), size(opticalThickness, 2)) :: & 
           liquid_opticalThickness, ice_opticalThickness, tauLiquidFraction
    
    ! ---------------------------------------------------
    
    where(cloudIce(:, :) <= 0.) 
      tauLiquidFraction(:, :) = 1. 
    elsewhere
      where (cloudWater(:, :) <= 0.) 
        tauLiquidFraction(:, :) = 0. 
      elsewhere 
        ! 
        ! Geometic optics limit - tau as LWP/re  (proportional to LWC/re) 
        !
        tauLiquidFraction(:, :) = (cloudWater(:, :)/waterSize(:, :)) / &
                                  (cloudWater(:, :)/waterSize(:, :) + cloudIce(:, :)/(ice_density * iceSize(:, :)) ) 
      end where
    end where
    liquid_opticalThickness(:, :) = tauLiquidFraction(:, :) * opticalThickness(:, :) 
    ice_opticalThickness   (:, :) = opticalThickness(:, :) - liquid_opticalThickness(:, :)
    
    call modis_L2_simulator_twoTaus(temp, pressureLayers, pressureLevels,          &
                                    liquid_opticalThickness, ice_opticalThickness, &
                                    waterSize, iceSize,                            & 
                                    isccpTau, isccpCloudTopPressure,               &
                                    retrievedPhase, retrievedCloudTopPressure, retrievedTau, retrievedSize)
                                
  end subroutine modis_L2_simulator_oneTau
  !------------------------------------------------------------------------------------------------
  subroutine modis_L3_simulator(phase, cloud_top_pressure, optical_thickness, particle_size,            &
       Cloud_Fraction_Total_Mean,       Cloud_Fraction_Water_Mean,       Cloud_Fraction_Ice_Mean,       &
       Cloud_Fraction_High_Mean,        Cloud_Fraction_Mid_Mean,         Cloud_Fraction_Low_Mean,       &
       Optical_Thickness_Total_Mean,    Optical_Thickness_Water_Mean,    Optical_Thickness_Ice_Mean,    &
       Optical_Thickness_Total_MeanLog10, Optical_Thickness_Water_MeanLog10, Optical_Thickness_Ice_MeanLog10, &
                                        Cloud_Particle_Size_Water_Mean,  Cloud_Particle_Size_Ice_Mean,  &
       Cloud_Top_Pressure_Total_Mean,                                                                   &
                                        Liquid_Water_Path_Mean,          Ice_Water_Path_Mean,           &    
       Optical_Thickness_vs_Cloud_Top_Pressure)
    !
    ! Inputs; dimension nPoints, nSubcols
    !
    integer, dimension(:, :),   intent(in)  :: phase
    real,    dimension(:, :),   intent(in)  :: cloud_top_pressure, optical_thickness, particle_size
    !
    ! Outputs; dimension nPoints
    !
    real,    dimension(:),      intent(out) :: &
       Cloud_Fraction_Total_Mean,       Cloud_Fraction_Water_Mean,       Cloud_Fraction_Ice_Mean,       &
       Cloud_Fraction_High_Mean,        Cloud_Fraction_Mid_Mean,         Cloud_Fraction_Low_Mean,       &
       Optical_Thickness_Total_Mean,    Optical_Thickness_Water_Mean,    Optical_Thickness_Ice_Mean,    &
       Optical_Thickness_Total_MeanLog10, Optical_Thickness_Water_MeanLog10, Optical_Thickness_Ice_MeanLog10, &
                                        Cloud_Particle_Size_Water_Mean,  Cloud_Particle_Size_Ice_Mean,  &
       Cloud_Top_Pressure_Total_Mean,                                                                   &
                                        Liquid_Water_Path_Mean,          Ice_Water_Path_Mean
    ! tau/ctp histogram; dimensions nPoints, numTauHistogramBins , numPressureHistogramBins 
    real,    dimension(:, :, :), intent(out) :: Optical_Thickness_vs_Cloud_Top_Pressure
    ! ---------------------------
    ! Local variables
    !
    real, parameter :: LWP_conversion = 2./3. * 1000. ! MKS units  
    integer :: i, j
    integer :: nPoints, nSubcols 
    logical, dimension(size(phase, 1), size(phase, 2)) :: &
      cloudMask, waterCloudMask, iceCloudMask, validRetrievalMask
    logical, dimension(size(phase, 1), size(phase, 2), numTauHistogramBins     ) :: tauMask
    logical, dimension(size(phase, 1), size(phase, 2), numPressureHistogramBins) :: pressureMask
    ! ---------------------------
    
    nPoints  = size(phase, 1) 
    nSubcols = size(phase, 2) 
    !
    ! Array conformance checks
    !
    if(any( (/ size(cloud_top_pressure, 1), size(optical_thickness, 1), size(particle_size, 1),                                &
               size(Cloud_Fraction_Total_Mean),       size(Cloud_Fraction_Water_Mean),       size(Cloud_Fraction_Ice_Mean),    &
               size(Cloud_Fraction_High_Mean),        size(Cloud_Fraction_Mid_Mean),         size(Cloud_Fraction_Low_Mean),    &
               size(Optical_Thickness_Total_Mean),    size(Optical_Thickness_Water_Mean),    size(Optical_Thickness_Ice_Mean), &
               size(Optical_Thickness_Total_MeanLog10), size(Optical_Thickness_Water_MeanLog10), &
               size(Optical_Thickness_Ice_MeanLog10),   size(Cloud_Particle_Size_Water_Mean),    &
               size(Cloud_Particle_Size_Ice_Mean),      size(Cloud_Top_Pressure_Total_Mean),     &
               size(Liquid_Water_Path_Mean),          size(Ice_Water_Path_Mean) /) /= nPoints))  &
      call complain_and_die("Some L3 arrays have wrong number of grid points") 
    if(any( (/ size(cloud_top_pressure, 2), size(optical_thickness, 2), size(particle_size, 2) /)  /= nSubcols)) &
      call complain_and_die("Some L3 arrays have wrong number of subcolumns") 
    
    
    !
    ! Include only those pixels with successful retrievals in the statistics 
    !
    validRetrievalMask(:, :) = particle_size(:, :) > 0.
    cloudMask      = phase(:, :) /= phaseIsNone   .and. validRetrievalMask(:, :)
    waterCloudMask = phase(:, :) == phaseIsLiquid .and. validRetrievalMask(:, :)
    iceCloudMask   = phase(:, :) == phaseIsIce    .and. validRetrievalMask(:, :)
    !
    ! Use these as pixel counts at first 
    !
    Cloud_Fraction_Total_Mean(:) = real(count(cloudMask,      dim = 2))
    Cloud_Fraction_Water_Mean(:) = real(count(waterCloudMask, dim = 2))
    Cloud_Fraction_Ice_Mean(:)   = real(count(iceCloudMask,   dim = 2))
    
    Cloud_Fraction_High_Mean(:) = real(count(cloudMask .and. cloud_top_pressure <= highCloudPressureLimit, dim = 2)) 
    Cloud_Fraction_Low_Mean(:)  = real(count(cloudMask .and. cloud_top_pressure >  lowCloudPressureLimit,  dim = 2)) 
    Cloud_Fraction_Mid_Mean(:)  = Cloud_Fraction_Total_Mean(:) - Cloud_Fraction_High_Mean(:) - Cloud_Fraction_Low_Mean(:)
    
    !
    ! Don't want to divide by 0, even though the sums will be 0 where the pixel counts are 0. 
    !
    where (Cloud_Fraction_Total_Mean == 0) Cloud_Fraction_Total_Mean = -1. 
    where (Cloud_Fraction_Water_Mean == 0) Cloud_Fraction_Water_Mean = -1.
    where (Cloud_Fraction_Ice_Mean   == 0) Cloud_Fraction_Ice_Mean   = -1.
    
#ifdef COSP_GFDL
    Optical_Thickness_Total_Mean = 0.0
    Optical_Thickness_Water_Mean = 0.0
    Optical_Thickness_Ice_Mean   = 0.0
    Optical_Thickness_Total_MeanLog10 = 0.0
    Optical_Thickness_Water_MeanLog10 = 0.0
    Optical_Thickness_Ice_MeanLog10  = 0.0
    Cloud_Particle_Size_Water_Mean = 0.0
    Cloud_Particle_Size_Ice_Mean   = 0.0
    Cloud_Top_Pressure_Total_Mean = 0.0
    Liquid_Water_Path_Mean = 0.0
    Ice_Water_Path_Mean    = 0.0

    do j = 1, size(optical_thickness,2)
      do i = 1, size(optical_thickness,1)
        if (cloudMask(i,j)) then
          Optical_Thickness_Total_Mean(i)      = Optical_Thickness_Total_Mean(i)      + optical_thickness(i,j)
          Optical_Thickness_Total_MeanLog10(i) = Optical_Thickness_Total_MeanLog10(i) + log10(optical_thickness(i,j))
          Cloud_Top_Pressure_Total_Mean(i)   = Cloud_Top_Pressure_Total_Mean(i)   + cloud_top_pressure(i,j)
        endif
        if (waterCloudMask(i,j)) then
          Optical_Thickness_Water_Mean(i)      = Optical_Thickness_Water_Mean(i)      + optical_thickness(i,j)
          Optical_Thickness_Water_MeanLog10(i) = Optical_Thickness_Water_MeanLog10(i) + log10(optical_thickness(i,j))
          Cloud_Particle_Size_Water_Mean(i)    = Cloud_Particle_Size_Water_Mean(i)    + particle_size(i,j)
          Liquid_Water_Path_Mean(i)            = Liquid_Water_Path_Mean(i)            + &
                                                 LWP_conversion * particle_size(i,j) * optical_thickness(i,j)
        endif
        if (iceCloudMask(i,j)) then
          Optical_Thickness_Ice_Mean(i)        = Optical_Thickness_Ice_Mean     (i)   + optical_thickness(i,j)
          Optical_Thickness_Ice_MeanLog10(i)   = Optical_Thickness_Ice_MeanLog10(i)   + log10(optical_thickness(i,j))
          Cloud_Particle_Size_Ice_Mean(i)      = Cloud_Particle_Size_Ice_Mean(i)      + particle_size(i,j)
          Ice_Water_Path_Mean(i)               = Ice_Water_Path_Mean(i)               + &
                                                 LWP_conversion * ice_density * particle_size(i,j) * optical_thickness(i,j)
       endif
      enddo
    enddo
    Optical_Thickness_Total_Mean(:)      = Optical_Thickness_Total_Mean(:)      / Cloud_Fraction_Total_Mean(:)
    Optical_Thickness_Water_Mean(:)      = Optical_Thickness_Water_Mean(:)      / Cloud_Fraction_Water_Mean(:)
    Optical_Thickness_Ice_Mean(:)        = Optical_Thickness_Ice_Mean(:)        / Cloud_Fraction_Ice_Mean(:)

    Optical_Thickness_Total_MeanLog10(:) = Optical_Thickness_Total_MeanLog10(:) / Cloud_Fraction_Total_Mean(:)
    Optical_Thickness_Water_MeanLog10(:) = Optical_Thickness_Water_MeanLog10(:) / Cloud_Fraction_Water_Mean(:)
    Optical_Thickness_Ice_MeanLog10(:)   = Optical_Thickness_Ice_MeanLog10(:)   / Cloud_Fraction_Ice_Mean(:)

    Cloud_Particle_Size_Water_Mean(:)    = Cloud_Particle_Size_Water_Mean(:)    / Cloud_Fraction_Water_Mean(:)
    Cloud_Particle_Size_Ice_Mean(:)      = Cloud_Particle_Size_Ice_Mean(:)      / Cloud_Fraction_Ice_Mean(:)

    Cloud_Top_Pressure_Total_Mean(:)     = Cloud_Top_Pressure_Total_Mean(:)     / max(1, count(cloudMask, dim = 2))
 
    Liquid_Water_Path_Mean(:)            = Liquid_Water_Path_Mean(:)            / Cloud_Fraction_Water_Mean(:)
    Ice_Water_Path_Mean(:)               = Ice_Water_Path_Mean(:)               / Cloud_Fraction_Ice_Mean(:)

#else   
    Optical_Thickness_Total_Mean = sum(optical_thickness, mask = cloudMask,      dim = 2) / Cloud_Fraction_Total_Mean(:) 
    Optical_Thickness_Water_Mean = sum(optical_thickness, mask = waterCloudMask, dim = 2) / Cloud_Fraction_Water_Mean(:)
    Optical_Thickness_Ice_Mean   = sum(optical_thickness, mask = iceCloudMask,   dim = 2) / Cloud_Fraction_Ice_Mean(:)
   
    Optical_Thickness_Total_MeanLog10 = sum(log10(optical_thickness), mask = cloudMask,      dim = 2) / Cloud_Fraction_Total_Mean(:)
    Optical_Thickness_Water_MeanLog10 = sum(log10(optical_thickness), mask = waterCloudMask, dim = 2) / Cloud_Fraction_Water_Mean(:)
    Optical_Thickness_Ice_MeanLog10   = sum(log10(optical_thickness), mask = iceCloudMask,   dim = 2) / Cloud_Fraction_Ice_Mean(:)
   
    Cloud_Particle_Size_Water_Mean = sum(particle_size, mask = waterCloudMask, dim = 2) / Cloud_Fraction_Water_Mean(:)
    Cloud_Particle_Size_Ice_Mean   = sum(particle_size, mask = iceCloudMask,   dim = 2) / Cloud_Fraction_Ice_Mean(:)
    
    Cloud_Top_Pressure_Total_Mean = sum(cloud_top_pressure, mask = cloudMask, dim = 2) / max(1, count(cloudMask, dim = 2))
    
    Liquid_Water_Path_Mean = LWP_conversion &
                             * sum(particle_size * optical_thickness, mask = waterCloudMask, dim = 2) &
                             / Cloud_Fraction_Water_Mean(:)
    Ice_Water_Path_Mean    = LWP_conversion * ice_density &
                             * sum(particle_size * optical_thickness, mask = iceCloudMask,   dim = 2) &
                             / Cloud_Fraction_Ice_Mean(:)
#endif

    !
    ! Normalize pixel counts to fraction
    !   The first three cloud fractions have been set to -1 in cloud-free areas, so set those places to 0.
    ! 
    Cloud_Fraction_Total_Mean(:) = max(0., Cloud_Fraction_Total_Mean(:)/nSubcols)
    Cloud_Fraction_Water_Mean(:) = max(0., Cloud_Fraction_Water_Mean(:)/nSubcols)
    Cloud_Fraction_Ice_Mean(:)   = max(0., Cloud_Fraction_Ice_Mean(:)  /nSubcols)
    
    Cloud_Fraction_High_Mean(:)  = Cloud_Fraction_High_Mean(:) /nSubcols
    Cloud_Fraction_Mid_Mean(:)   = Cloud_Fraction_Mid_Mean(:)  /nSubcols
    Cloud_Fraction_Low_Mean(:)   = Cloud_Fraction_Low_Mean(:)  /nSubcols
    
    ! ----
    ! Joint histogram 
    ! 
    do i = 1, numTauHistogramBins 
      where(cloudMask(:, :)) 
        tauMask(:, :, i) = optical_thickness(:, :) >= tauHistogramBoundaries(i) .and. &
                           optical_thickness(:, :) <  tauHistogramBoundaries(i+1)
      elsewhere
        tauMask(:, :, i) = .false.
      end where
    end do 

    do i = 1, numPressureHistogramBins 
      where(cloudMask(:, :)) 
        pressureMask(:, :, i) = cloud_top_pressure(:, :) >= pressureHistogramBoundaries(i) .and. &
                                cloud_top_pressure(:, :) <  pressureHistogramBoundaries(i+1)
      elsewhere
        pressureMask(:, :, i) = .false.
      end where
    end do 
    
    do i = 1, numPressureHistogramBins
      do j = 1, numTauHistogramBins
        Optical_Thickness_vs_Cloud_Top_Pressure(:, j, i) = & 
          real(count(tauMask(:, :, j) .and. pressureMask(:, :, i), dim = 2)) / real(nSubcols)
      end do 
    end do 
    
  end subroutine modis_L3_simulator
  !------------------------------------------------------------------------------------------------
  function cloud_top_pressure(tauIncrement, pressure, tauLimit) 
    real, dimension(:), intent(in) :: tauIncrement, pressure
    real,               intent(in) :: tauLimit
    real                           :: cloud_top_pressure
    !
    ! Find the extinction-weighted pressure. Assume that pressure varies linearly between 
    !   layers and use the trapezoidal rule.
    !
    
    real :: deltaX, totalTau, totalProduct
    integer :: i 
    
    totalTau = 0.; totalProduct = 0. 
    do i = 2, size(tauIncrement)
      if(totalTau + tauIncrement(i) > tauLimit) then 
        deltaX = tauLimit - totalTau
        totalTau = totalTau + deltaX
        !
        ! Result for trapezoidal rule when you take less than a full step
        !   tauIncrement is a layer-integrated value
        !
        totalProduct = totalProduct           &
                     + pressure(i-1) * deltaX &
                     + (pressure(i) - pressure(i-1)) * deltaX**2/(2. * tauIncrement(i)) 
      else
        totalTau =     totalTau     + tauIncrement(i) 
        totalProduct = totalProduct + tauIncrement(i) * (pressure(i) + pressure(i-1)) / 2.
      end if 
      if(totalTau >= tauLimit) exit
    end do 
    cloud_top_pressure = totalProduct/totalTau
  end function cloud_top_pressure
  !------------------------------------------------------------------------------------------------
  function weight_by_extinction(tauIncrement, f, tauLimit) 
    real, dimension(:), intent(in) :: tauIncrement, f
    real,               intent(in) :: tauLimit
    real                           :: weight_by_extinction
    !
    ! Find the extinction-weighted value of f(tau), assuming constant f within each layer
    !
    
    real    :: deltaX, totalTau, totalProduct
    integer :: i 
    
    totalTau = 0.; totalProduct = 0. 
    do i = 1, size(tauIncrement)
      if(totalTau + tauIncrement(i) > tauLimit) then 
        deltaX       = tauLimit - totalTau
        totalTau     = totalTau     + deltaX
        totalProduct = totalProduct + deltaX * f(i) 
      else
        totalTau     = totalTau     + tauIncrement(i) 
        totalProduct = totalProduct + tauIncrement(i) * f(i) 
      end if 
      if(totalTau >= tauLimit) exit
    end do 
    weight_by_extinction = totalProduct/totalTau
  end function weight_by_extinction
  !------------------------------------------------------------------------------------------------
  pure function compute_nir_reflectance(water_tau, water_size, ice_tau, ice_size) 
    real, dimension(:), intent(in) :: water_tau, water_size, ice_tau, ice_size
    real                           :: compute_nir_reflectance
    
    real, dimension(size(water_tau)) :: water_g, water_w0, ice_g, ice_w0, &
                                        tau, g, w0
#ifdef COSP_GFDL
    integer                          :: cnt_tau
#endif
    !----------------------------------------
    water_g(:)  = get_g_nir(  phaseIsLiquid, water_size) 
    water_w0(:) = get_ssa_nir(phaseIsLiquid, water_size) 
    ice_g(:)    = get_g_nir(  phaseIsIce,    ice_size) 
    ice_w0(:)   = get_ssa_nir(phaseIsIce,    ice_size) 
    !
    ! Combine ice and water optical properties
    !
    g(:) = 0; w0(:) = 0. 
    tau(:) = ice_tau(:) + water_tau(:) 
    where (tau(:) > 0) 
      g(:)  = (water_tau(:) * water_g(:)                + ice_tau(:) * ice_g(:)            ) / & 
              tau(:) 
      w0(:) = (water_tau(:) * water_g(:) * water_w0(:)  + ice_tau(:) * ice_g(:) * ice_w0(:)) / &
              (g(:) * tau(:))
    end where
    
#ifdef COSP_GFDL
    cnt_tau = count(tau(:) > 0.0)
    compute_nir_reflectance = compute_toa_reflectace(tau, g, w0, cnt_tau)
#else
    compute_nir_reflectance = compute_toa_reflectace(tau, g, w0)
#endif
  end function compute_nir_reflectance
  !------------------------------------------------------------------------------------------------
  ! Retreivals
  !------------------------------------------------------------------------------------------------
  elemental function retrieve_re (phase, tau, obs_Refl_nir)
      integer, intent(in) :: phase
      real,    intent(in) :: tau, obs_Refl_nir
      real                :: retrieve_re
      !
      ! Finds the re that produces the minimum mis-match between predicted and observed reflectance in 
      !   MODIS band 7 (near IR)
      ! Uses 
      !  fits for asymmetry parameter g(re) and single scattering albedo w0(re) based on MODIS tables 
      !  two-stream for layer reflectance and transmittance as a function of optical thickness tau, g, and w0
      !  adding-doubling for total reflectance 
      !  
      !
      !
      ! Local variables
      !
      real, parameter :: min_distance_to_boundary = 0.01
      real    :: re_min, re_max, delta_re
      integer :: i 
      
      real, dimension(num_trial_res) :: trial_re, g, w0, predicted_Refl_nir
      ! --------------------------
    
    if(any(phase == (/ phaseIsLiquid, phaseIsUndetermined, phaseIsIce /))) then 
      if (phase == phaseIsLiquid .OR. phase == phaseIsUndetermined) then
        re_min = re_water_min
        re_max = re_water_max
        trial_re(:) = trial_re_w
        g(:)   = g_w(:) 
        w0(:)  = w0_w(:)
      else
        re_min = re_ice_min
        re_max = re_ice_max
        trial_re(:) = trial_re_i
        g(:)   = g_i(:) 
        w0(:)  = w0_i(:)
      end if
      !
      ! 1st attempt at index: w/coarse re resolution
      !
      predicted_Refl_nir(:) = two_stream_reflectance(tau, g(:), w0(:))
      retrieve_re = interpolate_to_min(trial_re(:), predicted_Refl_nir(:), obs_Refl_nir) 
      !
      ! If first retrieval works, can try 2nd iteration using greater re resolution 
      !
      if(use_two_re_iterations .and. retrieve_re > 0.) then
        re_min = retrieve_re - delta_re
        re_max = retrieve_re + delta_re
        delta_re = (re_max - re_min)/real(num_trial_res-1)
  
        trial_re(:) = re_min + delta_re * (/ (i - 1, i = 1, num_trial_res) /) 
        g(:)  = get_g_nir(  phase, trial_re(:))
        w0(:) = get_ssa_nir(phase, trial_re(:))
        predicted_Refl_nir(:) = two_stream_reflectance(tau, g(:), w0(:))
        retrieve_re = interpolate_to_min(trial_re(:), predicted_Refl_nir(:), obs_Refl_nir) 
      end if
    else 
      retrieve_re = re_fill
    end if 
    
  end function retrieve_re
  ! --------------------------------------------
  pure function interpolate_to_min(x, y, yobs)
    real, dimension(:), intent(in) :: x, y 
    real,               intent(in) :: yobs
    real                           :: interpolate_to_min
    ! 
    ! Given a set of values of y as y(x), find the value of x that minimizes abs(y - yobs)
    !   y must be monotonic in x
    !
    real, dimension(size(x)) :: diff
    integer                  :: nPoints, minDiffLoc, lowerBound, upperBound
    ! ---------------------------------
    nPoints = size(y)
    diff(:) = y(:) - yobs
    minDiffLoc = minloc(abs(diff), dim = 1) 
    
    if(minDiffLoc == 1) then 
      lowerBound = minDiffLoc
      upperBound = minDiffLoc + 1
    else if(minDiffLoc == nPoints) then
      lowerBound = minDiffLoc - 1
      upperBound = minDiffLoc
    else
      if(diff(minDiffLoc-1) * diff(minDiffLoc) < 0) then
        lowerBound = minDiffLoc-1
        upperBound = minDiffLoc
      else 
        lowerBound = minDiffLoc
        upperBound = minDiffLoc + 1
      end if 
    end if 
    
    if(diff(lowerBound) * diff(upperBound) < 0) then     
      !
      ! Interpolate the root position linearly if we bracket the root
      !
      interpolate_to_min = x(upperBound) - & 
                           diff(upperBound) * (x(upperBound) - x(lowerBound)) / (diff(upperBound) - diff(lowerBound))
    else 
      interpolate_to_min = re_fill
    end if 
    

  end function interpolate_to_min
  ! --------------------------------------------
  ! Optical properties
  ! --------------------------------------------
  elemental function get_g_nir (phase, re)
    !
    ! Polynomial fit for asummetry parameter g in MODIS band 7 (near IR) as a function 
    !   of size for ice and water
    ! Fits from Steve Platnick
    !

    integer, intent(in) :: phase
    real,    intent(in) :: re
    real :: get_g_nir 
    
    real, dimension(3), parameter :: ice_coefficients   = (/ 0.7432,  4.5563e-3, -2.8697e-5 /), & 
                               small_water_coefficients = (/ 0.8027, -1.0496e-2,  1.7071e-3 /), & 
                                 big_water_coefficients = (/ 0.7931,  5.3087e-3, -7.4995e-5 /) 
    
    ! approx. fits from MODIS Collection 5 LUT scattering calculations
    if(phase == phaseIsLiquid) then
      if(re < 8.) then 
        get_g_nir = fit_to_quadratic(re, small_water_coefficients)
        if(re < re_water_min) get_g_nir = fit_to_quadratic(re_water_min, small_water_coefficients)
      else
        get_g_nir = fit_to_quadratic(re,   big_water_coefficients)
        if(re > re_water_max) get_g_nir = fit_to_quadratic(re_water_max, big_water_coefficients)
      end if 
    else
      get_g_nir = fit_to_quadratic(re, ice_coefficients)
      if(re < re_ice_min) get_g_nir = fit_to_quadratic(re_ice_min, ice_coefficients)
      if(re > re_ice_max) get_g_nir = fit_to_quadratic(re_ice_max, ice_coefficients)
    end if 
    
  end function get_g_nir

  ! --------------------------------------------
    elemental function get_ssa_nir (phase, re)
        integer, intent(in) :: phase
        real,    intent(in) :: re
        real                :: get_ssa_nir
        !
        ! Polynomial fit for single scattering albedo in MODIS band 7 (near IR) as a function 
        !   of size for ice and water
        ! Fits from Steve Platnick
        !
        
        real, dimension(4), parameter :: ice_coefficients   = (/ 0.9994, -4.5199e-3, 3.9370e-5, -1.5235e-7 /)
        real, dimension(3), parameter :: water_coefficients = (/ 1.0008, -2.5626e-3, 1.6024e-5 /) 
        
        ! approx. fits from MODIS Collection 5 LUT scattering calculations
        if(phase == phaseIsLiquid) then
          get_ssa_nir = fit_to_quadratic(re, water_coefficients)
          if(re < re_water_min) get_ssa_nir = fit_to_quadratic(re_water_min, water_coefficients)
          if(re > re_water_max) get_ssa_nir = fit_to_quadratic(re_water_max, water_coefficients)
        else
          get_ssa_nir = fit_to_cubic(re, ice_coefficients)
          if(re < re_ice_min) get_ssa_nir = fit_to_cubic(re_ice_min, ice_coefficients)
          if(re > re_ice_max) get_ssa_nir = fit_to_cubic(re_ice_max, ice_coefficients)
        end if 

    end function get_ssa_nir
   ! --------------------------------------------
  pure function fit_to_cubic(x, coefficients) 
    real,               intent(in) :: x
    real, dimension(:), intent(in) :: coefficients
    real                           :: fit_to_cubic
    
    
    fit_to_cubic = coefficients(1) + x * (coefficients(2) + x * (coefficients(3) + x * coefficients(4)))
 end function fit_to_cubic
   ! --------------------------------------------
  pure function fit_to_quadratic(x, coefficients) 
    real,               intent(in) :: x
    real, dimension(:), intent(in) :: coefficients
    real                           :: fit_to_quadratic
    
    
    fit_to_quadratic = coefficients(1) + x * (coefficients(2) + x * (coefficients(3)))
 end function fit_to_quadratic
  ! --------------------------------------------
  ! Radiative transfer
  ! --------------------------------------------
#ifdef COSP_GFDL
  pure function compute_toa_reflectace(tau, g, w0, cnt_tau)
#else
  pure function compute_toa_reflectace(tau, g, w0)
#endif
    real, dimension(:), intent(in) :: tau, g, w0
#ifdef COSP_GFDL
    integer,            intent(in) :: cnt_tau
#endif
    real                           :: compute_toa_reflectace
    
    logical, dimension(size(tau))         :: cloudMask
#ifdef COSP_GFDL
   integer, dimension(cnt_tau) :: cloudIndicies
    real,    dimension(cnt_tau) :: Refl,     Trans
#else
    integer, dimension(count(tau(:) > 0)) :: cloudIndicies
    real,    dimension(count(tau(:) > 0)) :: Refl,     Trans
#endif
    real                                  :: Refl_tot, Trans_tot
    integer                               :: i
    ! ---------------------------------------
    !
    ! This wrapper reports reflectance only and strips out non-cloudy elements from the calculation
    !
    cloudMask = tau(:) > 0. 
    cloudIndicies = pack((/ (i, i = 1, size(tau)) /), mask = cloudMask) 
    do i = 1, size(cloudIndicies)
      call two_stream(tau(cloudIndicies(i)), g(cloudIndicies(i)), w0(cloudIndicies(i)), Refl(i), Trans(i))
    end do 
                    
    call adding_doubling(Refl(:), Trans(:), Refl_tot, Trans_tot)  
    
    compute_toa_reflectace = Refl_tot
    
  end function compute_toa_reflectace
  ! --------------------------------------------
  pure subroutine two_stream(tauint, gint, w0int, ref, tra) 
    real, intent(in)  :: tauint, gint, w0int
    real, intent(out) :: ref, tra
    !
    ! Compute reflectance in a single layer using the two stream approximation 
    !   The code itself is from Lazaros Oreopoulos via Steve Platnick 
    !
    ! ------------------------
    ! Local variables 
    !   for delta Eddington code
    !   xmu, gamma3, and gamma4 only used for collimated beam approximation (i.e., beam=1)
    integer, parameter :: beam = 2
    real,    parameter :: xmu = 0.866, minConservativeW0 = 0.9999999
    real :: tau, w0, g, f, gamma1, gamma2, gamma3, gamma4, &
            rh, a1, a2, rk, r1, r2, r3, r4, r5, t1, t2, t3, t4, t5, beta, e1, e2, ef1, ef2, den, th
    !
    ! Compute reflectance and transmittance in a single layer using the two stream approximation 
    !   The code itself is from Lazaros Oreopoulos via Steve Platnick 
    !
    f   = gint**2
    tau = (1 - w0int * f) * tauint
    w0  = (1 - f) * w0int / (1 - w0int * f)
    g   = (gint - f) / (1 - f)

    ! delta-Eddington (Joseph et al. 1976)
    gamma1 =  (7 - w0* (4 + 3 * g)) / 4.0
    gamma2 = -(1 - w0* (4 - 3 * g)) / 4.0
    gamma3 =  (2 - 3*g*xmu) / 4.0
    gamma4 =   1 - gamma3

    if (w0int > minConservativeW0) then
      ! Conservative scattering
      if (beam == 1) then
          rh = (gamma1*tau+(gamma3-gamma1*xmu)*(1-exp(-tau/xmu)))
          ref = rh / (1 + gamma1 * tau)
          tra = 1 - ref       
      else if(beam == 2) then
          ref = gamma1*tau/(1 + gamma1*tau)
          tra = 1 - ref
      endif
    else
      ! Non-conservative scattering
      a1 = gamma1 * gamma4 + gamma2 * gamma3
      a2 = gamma1 * gamma3 + gamma2 * gamma4

      rk = sqrt(gamma1**2 - gamma2**2)
      
      r1 = (1 - rk * xmu) * (a2 + rk * gamma3)
      r2 = (1 + rk * xmu) * (a2 - rk * gamma3)
      r3 = 2 * rk *(gamma3 - a2 * xmu)
      r4 = (1 - (rk * xmu)**2) * (rk + gamma1)
      r5 = (1 - (rk * xmu)**2) * (rk - gamma1)
      
      t1 = (1 + rk * xmu) * (a1 + rk * gamma4)
      t2 = (1 - rk * xmu) * (a1 - rk * gamma4)
      t3 = 2 * rk * (gamma4 + a1 * xmu)
      t4 = r4
      t5 = r5

      beta = -r5 / r4         
      
      e1 = min(rk * tau, 500.) 
      e2 = min(tau / xmu, 500.) 
      
      if (beam == 1) then
         den = r4 * exp(e1) + r5 * exp(-e1)
         ref  = w0*(r1*exp(e1)-r2*exp(-e1)-r3*exp(-e2))/den
         den = t4 * exp(e1) + t5 * exp(-e1)
         th  = exp(-e2)
         tra = th-th*w0*(t1*exp(e1)-t2*exp(-e1)-t3*exp(e2))/den
      elseif (beam == 2) then
         ef1 = exp(-e1)
         ef2 = exp(-2*e1)
         ref = (gamma2*(1-ef2))/((rk+gamma1)*(1-beta*ef2))
         tra = (2*rk*ef1)/((rk+gamma1)*(1-beta*ef2))
      endif
    end if
  end subroutine two_stream
  ! --------------------------------------------------
  elemental function two_stream_reflectance(tauint, gint, w0int) 
    real, intent(in) :: tauint, gint, w0int
    real             :: two_stream_reflectance
    !
    ! Compute reflectance in a single layer using the two stream approximation 
    !   The code itself is from Lazaros Oreopoulos via Steve Platnick 
    !
    ! ------------------------
    ! Local variables 
    !   for delta Eddington code
    !   xmu, gamma3, and gamma4 only used for collimated beam approximation (i.e., beam=1)
    integer, parameter :: beam = 2
    real,    parameter :: xmu = 0.866, minConservativeW0 = 0.9999999
    real :: tau, w0, g, f, gamma1, gamma2, gamma3, gamma4, &
            rh, a1, a2, rk, r1, r2, r3, r4, r5, t1, t2, t3, t4, t5, beta, e1, e2, ef1, ef2, den
    ! ------------------------


    f   = gint**2
    tau = (1 - w0int * f) * tauint
    w0  = (1 - f) * w0int / (1 - w0int * f)
    g   = (gint - f) / (1 - f)

    ! delta-Eddington (Joseph et al. 1976)
    gamma1 =  (7 - w0* (4 + 3 * g)) / 4.0
    gamma2 = -(1 - w0* (4 - 3 * g)) / 4.0
    gamma3 =  (2 - 3*g*xmu) / 4.0
    gamma4 =   1 - gamma3

    if (w0int > minConservativeW0) then
      ! Conservative scattering
      if (beam == 1) then
          rh = (gamma1*tau+(gamma3-gamma1*xmu)*(1-exp(-tau/xmu)))
          two_stream_reflectance = rh / (1 + gamma1 * tau)
      elseif (beam == 2) then
          two_stream_reflectance = gamma1*tau/(1 + gamma1*tau)
      endif
        
    else    !

        ! Non-conservative scattering
         a1 = gamma1 * gamma4 + gamma2 * gamma3
         a2 = gamma1 * gamma3 + gamma2 * gamma4

         rk = sqrt(gamma1**2 - gamma2**2)
         
         r1 = (1 - rk * xmu) * (a2 + rk * gamma3)
         r2 = (1 + rk * xmu) * (a2 - rk * gamma3)
         r3 = 2 * rk *(gamma3 - a2 * xmu)
         r4 = (1 - (rk * xmu)**2) * (rk + gamma1)
         r5 = (1 - (rk * xmu)**2) * (rk - gamma1)
         
         t1 = (1 + rk * xmu) * (a1 + rk * gamma4)
         t2 = (1 - rk * xmu) * (a1 - rk * gamma4)
         t3 = 2 * rk * (gamma4 + a1 * xmu)
         t4 = r4
         t5 = r5

         beta = -r5 / r4         
         
         e1 = min(rk * tau, 500.) 
         e2 = min(tau / xmu, 500.) 
         
         if (beam == 1) then
           den = r4 * exp(e1) + r5 * exp(-e1)
           two_stream_reflectance  = w0*(r1*exp(e1)-r2*exp(-e1)-r3*exp(-e2))/den
         elseif (beam == 2) then
           ef1 = exp(-e1)
           ef2 = exp(-2*e1)
           two_stream_reflectance = (gamma2*(1-ef2))/((rk+gamma1)*(1-beta*ef2))
         endif
           
      end if
  end function two_stream_reflectance 
  ! --------------------------------------------
    pure subroutine adding_doubling (Refl, Tran, Refl_tot, Tran_tot)      
      real,    dimension(:), intent(in)  :: Refl,     Tran
      real,                  intent(out) :: Refl_tot, Tran_tot
      !
      ! Use adding/doubling formulas to compute total reflectance and transmittance from layer values
      !
      
      integer :: i
      real, dimension(size(Refl)) :: Refl_cumulative, Tran_cumulative
      
      Refl_cumulative(1) = Refl(1); Tran_cumulative(1) = Tran(1)    
      
      do i=2, size(Refl)
          ! place (add) previous combined layer(s) reflectance on top of layer i, w/black surface (or ignoring surface):
          Refl_cumulative(i) = Refl_cumulative(i-1) + Refl(i)*(Tran_cumulative(i-1)**2)/(1 - Refl_cumulative(i-1) * Refl(i))
          Tran_cumulative(i) = (Tran_cumulative(i-1)*Tran(i)) / (1 - Refl_cumulative(i-1) * Refl(i))
      end do
      
      Refl_tot = Refl_cumulative(size(Refl))
      Tran_tot = Tran_cumulative(size(Refl))

    end subroutine adding_doubling
  ! --------------------------------------------------
  subroutine complain_and_die(message) 
    character(len = *), intent(in) :: message
    
#ifdef COSP_GFDL
    call error_mesg ('mod_modis_sim', trim(message), FATAL)
#else
    write(6, *) "Failure in MODIS simulator" 
    write(6, *)  trim(message) 
    flush(6)
    stop
#endif
  end subroutine complain_and_die
  !------------------------------------------------------------------------------------------------
end module mod_modis_sim

module mpp_data_mod
#include <fms_platform.h>

#if defined(use_libMPI) && defined(sgi_mipspro)
  use mpi
#endif

  use mpp_parameter_mod, only : MAXPES

  implicit none
  private

  character(len=128), public :: version= &
       '$Id mpp_data.F90 $'
  character(len=128), public :: tagname= &
       '$Name$'

#if defined(use_libSMA) || defined(use_MPI_SMA)
#include <mpp/shmem.fh>
#endif

#if defined(use_libMPI) && !defined(sgi_mipspro)
#include <mpif.h>  
!sgi_mipspro gets this from 'use mpi'
#endif

  !--- public data is used by mpp_mod
  public :: stat, mpp_stack, ptr_stack, status, ptr_status, sync, ptr_sync  
  public :: mpp_from_pe, ptr_from, remote_data_loc, ptr_remote

  !--- public data which is used by mpp_domains_mod. 
  !--- All othere modules should import these parameters from mpp_domains_mod. 
  public :: mpp_domains_stack, ptr_domains_stack
  public :: mpp_domains_stack_nonblock, ptr_domains_stack_nonblock

  !-------------------------------------------------------------------------------!
  ! The following data included in the .inc file are diffrent for sma or mpi case !
  !-------------------------------------------------------------------------------!

#ifdef use_libSMA
#include <mpp_data_sma.inc>
#else
#ifdef use_libMPI
#include <mpp_data_mpi.inc>
#else
#include <mpp_data_nocomm.inc>
#endif
#endif

end module mpp_data_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: cosp_utils.F90,v 20.0 2013/12/13 23:15:54 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

!
! History:
! Jul 2007 - A. Bodas-Salcedo - Initial version
!

MODULE MOD_COSP_UTILS
  USE MOD_COSP_CONSTANTS
  IMPLICIT NONE

  INTERFACE Z_TO_DBZ
    MODULE PROCEDURE Z_TO_DBZ_2D,Z_TO_DBZ_3D,Z_TO_DBZ_4D
  END INTERFACE

  INTERFACE COSP_CHECK_INPUT
    MODULE PROCEDURE COSP_CHECK_INPUT_1D,COSP_CHECK_INPUT_2D,COSP_CHECK_INPUT_3D
  END INTERFACE
#ifdef COSP_GFDL
  INTERFACE flip_vert_index
    MODULE PROCEDURE flip_vert_index_2d, flip_vert_index_3d, &
                                                      flip_vert_index_4d
  END INTERFACE
#endif
CONTAINS

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------------- SUBROUTINE COSP_PRECIP_MXRATIO --------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_PRECIP_MXRATIO(Npoints,Nlevels,Ncolumns,p,T,prec_frac,prec_type, &
                          n_ax,n_bx,alpha_x,c_x,d_x,g_x,a_x,b_x,gamma1,gamma2,gamma3,gamma4, &
                          flux,mxratio,reff)

    ! Input arguments, (IN)
    integer,intent(in) :: Npoints,Nlevels,Ncolumns
    real,intent(in),dimension(Npoints,Nlevels) :: p,T,flux
    real,intent(in),dimension(Npoints,Ncolumns,Nlevels) :: prec_frac
    real,intent(in) :: n_ax,n_bx,alpha_x,c_x,d_x,g_x,a_x,b_x,gamma1,gamma2,gamma3,gamma4,prec_type
    ! Input arguments, (OUT)
    real,intent(out),dimension(Npoints,Ncolumns,Nlevels) :: mxratio
    real,intent(inout),dimension(Npoints,Ncolumns,Nlevels) :: reff
    ! Local variables
    integer :: i,j,k
    real :: sigma,one_over_xip1,xi,rho0,rho,lambda_x,gamma_4_3_2,delta
    
    mxratio = 0.0

    if (n_ax >= 0.0) then ! N_ax is used to control which hydrometeors need to be computed
        xi      = d_x/(alpha_x + b_x - n_bx + 1.0)
        rho0    = 1.29
        sigma   = (gamma2/(gamma1*c_x))*(n_ax*a_x*gamma2)**xi
        one_over_xip1 = 1.0/(xi + 1.0)
        gamma_4_3_2 = 0.5*gamma4/gamma3
        delta = (alpha_x + b_x + d_x - n_bx + 1.0)
        
        do k=1,Nlevels
            do j=1,Ncolumns
                do i=1,Npoints
                    if ((prec_frac(i,j,k)==prec_type).or.(prec_frac(i,j,k)==3.)) then
                        rho = p(i,k)/(287.05*T(i,k))
                        mxratio(i,j,k)=(flux(i,k)*((rho/rho0)**g_x)*sigma)**one_over_xip1
                        mxratio(i,j,k)=mxratio(i,j,k)/rho
                        ! Compute effective radius
                        if ((reff(i,j,k) <= 0.0).and.(flux(i,k) /= 0.0)) then
                           lambda_x = (a_x*c_x*((rho0/rho)**g_x)*n_ax*gamma1/flux(i,k))**(1./delta)
                           reff(i,j,k) = gamma_4_3_2/lambda_x
                        endif
                    endif
                enddo
            enddo
        enddo
    endif
END SUBROUTINE COSP_PRECIP_MXRATIO


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------------- SUBROUTINE ZERO_INT -------------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ELEMENTAL SUBROUTINE ZERO_INT(x,y01,y02,y03,y04,y05,y06,y07,y08,y09,y10, &
                                 y11,y12,y13,y14,y15,y16,y17,y18,y19,y20, &
                                 y21,y22,y23,y24,y25,y26,y27,y28,y29,y30)

  integer,intent(inout) :: x
  integer,intent(inout),optional :: y01,y02,y03,y04,y05,y06,y07,y08,y09,y10, &
                                    y11,y12,y13,y14,y15,y16,y17,y18,y19,y20, &
                                    y21,y22,y23,y24,y25,y26,y27,y28,y29,y30
  x = 0
  if (present(y01)) y01 = 0
  if (present(y02)) y02 = 0
  if (present(y03)) y03 = 0
  if (present(y04)) y04 = 0
  if (present(y05)) y05 = 0
  if (present(y06)) y06 = 0
  if (present(y07)) y07 = 0
  if (present(y08)) y08 = 0
  if (present(y09)) y09 = 0
  if (present(y10)) y10 = 0
  if (present(y11)) y11 = 0
  if (present(y12)) y12 = 0
  if (present(y13)) y13 = 0
  if (present(y14)) y14 = 0
  if (present(y15)) y15 = 0
  if (present(y16)) y16 = 0
  if (present(y17)) y17 = 0
  if (present(y18)) y18 = 0
  if (present(y19)) y19 = 0
  if (present(y20)) y20 = 0
  if (present(y21)) y21 = 0
  if (present(y22)) y22 = 0
  if (present(y23)) y23 = 0
  if (present(y24)) y24 = 0
  if (present(y25)) y25 = 0
  if (present(y26)) y26 = 0
  if (present(y27)) y27 = 0
  if (present(y28)) y28 = 0
  if (present(y29)) y29 = 0
  if (present(y30)) y30 = 0
END SUBROUTINE  ZERO_INT

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------------- SUBROUTINE ZERO_REAL ------------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ELEMENTAL SUBROUTINE ZERO_REAL(x,y01,y02,y03,y04,y05,y06,y07,y08,y09,y10, &
                                 y11,y12,y13,y14,y15,y16,y17,y18,y19,y20, &
                                 y21,y22,y23,y24,y25,y26,y27,y28,y29,y30)

  real,intent(inout) :: x
  real,intent(inout),optional :: y01,y02,y03,y04,y05,y06,y07,y08,y09,y10, &
                                 y11,y12,y13,y14,y15,y16,y17,y18,y19,y20, &
                                 y21,y22,y23,y24,y25,y26,y27,y28,y29,y30
  x = 0.0
  if (present(y01)) y01 = 0.0
  if (present(y02)) y02 = 0.0
  if (present(y03)) y03 = 0.0
  if (present(y04)) y04 = 0.0
  if (present(y05)) y05 = 0.0
  if (present(y06)) y06 = 0.0
  if (present(y07)) y07 = 0.0
  if (present(y08)) y08 = 0.0
  if (present(y09)) y09 = 0.0
  if (present(y10)) y10 = 0.0
  if (present(y11)) y11 = 0.0
  if (present(y12)) y12 = 0.0
  if (present(y13)) y13 = 0.0
  if (present(y14)) y14 = 0.0
  if (present(y15)) y15 = 0.0
  if (present(y16)) y16 = 0.0
  if (present(y17)) y17 = 0.0
  if (present(y18)) y18 = 0.0
  if (present(y19)) y19 = 0.0
  if (present(y20)) y20 = 0.0
  if (present(y21)) y21 = 0.0
  if (present(y22)) y22 = 0.0
  if (present(y23)) y23 = 0.0
  if (present(y24)) y24 = 0.0
  if (present(y25)) y25 = 0.0
  if (present(y26)) y26 = 0.0
  if (present(y27)) y27 = 0.0
  if (present(y28)) y28 = 0.0
  if (present(y29)) y29 = 0.0
  if (present(y30)) y30 = 0.0
END SUBROUTINE  ZERO_REAL

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!--------------------- SUBROUTINE Z_TO_DBZ_2D --------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE Z_TO_DBZ_2D(mdi,z)
    real,intent(in) :: mdi
    real,dimension(:,:),intent(inout) :: z
    ! Reflectivity Z:
    ! Input in [m3]
    ! Output in dBZ, with Z in [mm6 m-3]
    
    ! 1.e18 to convert from [m3] to [mm6 m-3]
    z = 1.e18*z
    where (z > 1.0e-6) ! Limit to -60 dBZ
      z = 10.0*log10(z)
    elsewhere
      z = mdi
    end where  
  END SUBROUTINE Z_TO_DBZ_2D
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!--------------------- SUBROUTINE Z_TO_DBZ_3D --------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE Z_TO_DBZ_3D(mdi,z)
    real,intent(in) :: mdi
    real,dimension(:,:,:),intent(inout) :: z
    ! Reflectivity Z:
    ! Input in [m3]
    ! Output in dBZ, with Z in [mm6 m-3]
    
    ! 1.e18 to convert from [m3] to [mm6 m-3]
    z = 1.e18*z
    where (z > 1.0e-6) ! Limit to -60 dBZ
      z = 10.0*log10(z)
    elsewhere
      z = mdi
    end where  
  END SUBROUTINE Z_TO_DBZ_3D
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!--------------------- SUBROUTINE Z_TO_DBZ_4D --------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE Z_TO_DBZ_4D(mdi,z)
    real,intent(in) :: mdi
    real,dimension(:,:,:,:),intent(inout) :: z
    ! Reflectivity Z:
    ! Input in [m3]
    ! Output in dBZ, with Z in [mm6 m-3]
    
    ! 1.e18 to convert from [m3] to [mm6 m-3]
    z = 1.e18*z
    where (z > 1.0e-6) ! Limit to -60 dBZ
      z = 10.0*log10(z)
    elsewhere
      z = mdi
    end where  
  END SUBROUTINE Z_TO_DBZ_4D

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINES COSP_CHECK_INPUT_1D ---------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE COSP_CHECK_INPUT_1D(vname,x,min_val,max_val)
    character(len=*) :: vname
    real,intent(inout) :: x(:)
    real,intent(in),optional :: min_val,max_val
    logical :: l_min,l_max
    character(len=128) :: pro_name='COSP_CHECK_INPUT_1D'
    
    l_min=.false.
    l_max=.false.
    
    if (present(min_val)) then
!       if (x < min_val) x = min_val
      if (any(x < min_val)) then 
      l_min = .true.
        where (x < min_val)
          x = min_val
        end where
      endif
    endif    
    if (present(max_val)) then
!       if (x > max_val) x = max_val
      if (any(x > max_val)) then 
        l_max = .true.
        where (x > max_val)
          x = max_val
        end where  
      endif    
    endif    
    
    if (l_min) print *,'----- WARNING: '//trim(pro_name)//': minimum value of '//trim(vname)//' set to: ',min_val
    if (l_max) print *,'----- WARNING: '//trim(pro_name)//': maximum value of '//trim(vname)//' set to: ',max_val
  END SUBROUTINE COSP_CHECK_INPUT_1D
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINES COSP_CHECK_INPUT_2D ---------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE COSP_CHECK_INPUT_2D(vname,x,min_val,max_val)
    character(len=*) :: vname
    real,intent(inout) :: x(:,:)
    real,intent(in),optional :: min_val,max_val
    logical :: l_min,l_max
    character(len=128) :: pro_name='COSP_CHECK_INPUT_2D'
    
    l_min=.false.
    l_max=.false.
    
    if (present(min_val)) then
!       if (x < min_val) x = min_val
      if (any(x < min_val)) then 
      l_min = .true.
        where (x < min_val)
          x = min_val
        end where
      endif
    endif    
    if (present(max_val)) then
!       if (x > max_val) x = max_val
      if (any(x > max_val)) then 
        l_max = .true.
        where (x > max_val)
          x = max_val
        end where  
      endif    
    endif    
    
    if (l_min) print *,'----- WARNING: '//trim(pro_name)//': minimum value of '//trim(vname)//' set to: ',min_val
    if (l_max) print *,'----- WARNING: '//trim(pro_name)//': maximum value of '//trim(vname)//' set to: ',max_val
  END SUBROUTINE COSP_CHECK_INPUT_2D
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINES COSP_CHECK_INPUT_3D ---------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE COSP_CHECK_INPUT_3D(vname,x,min_val,max_val)
    character(len=*) :: vname
    real,intent(inout) :: x(:,:,:)
    real,intent(in),optional :: min_val,max_val
    logical :: l_min,l_max
    character(len=128) :: pro_name='COSP_CHECK_INPUT_3D'
    
    l_min=.false.
    l_max=.false.
    
    if (present(min_val)) then
!       if (x < min_val) x = min_val
      if (any(x < min_val)) then 
      l_min = .true.
        where (x < min_val)
          x = min_val
        end where
      endif
    endif    
    if (present(max_val)) then
!       if (x > max_val) x = max_val
      if (any(x > max_val)) then 
        l_max = .true.
        where (x > max_val)
          x = max_val
        end where  
      endif    
    endif    
    
    if (l_min) print *,'----- WARNING: '//trim(pro_name)//': minimum value of '//trim(vname)//' set to: ',min_val
    if (l_max) print *,'----- WARNING: '//trim(pro_name)//': maximum value of '//trim(vname)//' set to: ',max_val
  END SUBROUTINE COSP_CHECK_INPUT_3D

#ifdef COSP_GFDL

!########################################################################

subroutine flip_vert_index_2D (in, dim,out)
  real,dimension(:,:), intent(in) :: in
  integer, intent(in)   :: dim
  real,dimension(:,:), intent(out) :: out
 
  integer k, kinv

  do k=1,dim
    kinv = dim - k +1
    out(:,k) = in(:,kinv)
  end do

end subroutine flip_vert_index_2D



!#####################################################################

subroutine flip_vert_index_3D (in, dim,out)
  real,dimension(:,:,:), intent(in) :: in
  integer, intent(in)   :: dim
  real,dimension(:,:,:), intent(out) :: out

  integer k, kinv

  do k=1,dim
    kinv = dim - k +1
    out(:,:,k) = in(:,:,kinv)
  end do

end subroutine flip_vert_index_3D

!#####################################################################

subroutine flip_vert_index_4D (in, dim,out)
  real,dimension(:,:,:,:), intent(in) :: in
  integer, intent(in)   :: dim
  real,dimension(:,:,:,:), intent(out) :: out

  integer k, kinv

  do k=1,dim
    kinv = dim - k +1
    out(:,:,:,k) = in(:,:,:,kinv)
  end do

end subroutine flip_vert_index_4D

#endif

!###################################################################

END MODULE MOD_COSP_UTILS

#include "cosp_defs.H"
#ifdef COSP_GFDL
 
!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: cosp_io.F90,v 20.0 2013/12/13 23:15:43 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

!
! History:
! Jul 2008 - A. Bodas-Salcedo - Initial version
! Oct 2008 - S. Bony - In nc_write_cosp_1d and nc_write_cosp_2d :
!                      the label of layered cloud fractions was wrong -> corrected
!                      (before: low was actually mid, mid was high, high was total,
!                      total was low)
! Sep 2009 - A. Bodas-Salcedo - CMIP5 variable names implemented
!

!#include "cosp_defs.h" 
#ifndef COSP_GFDL
#include "cosp_defs.h" 
#endif
MODULE MOD_COSP_IO
  USE MOD_COSP_CONSTANTS
  USE MOD_COSP_TYPES
#ifndef COSP_GFDL
  USE cmor_users_functions
#endif
  USE netcdf
  use MOD_COSP_Modis_Simulator
#ifdef COSP_GFDL
  use mpp_mod, only: input_nml_file
  use fms_mod, only: open_namelist_file, open_file, close_file,   &
                     file_exist, mpp_pe, mpp_root_pe,   &
                     error_mesg, FATAL, &
                     check_nml_error, write_version_number, stdlog
#endif
  
  IMPLICIT NONE
  
#ifdef COSP_GFDL
!---------------------------------------------------------------------
!----------- version number for this module --------------------------
character(len=128)  :: version =  '$Id: cosp_io.F90,v 20.0 2013/12/13 23:15:43 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'
#endif

  ! Types to be used as arrays of pointers
  TYPE var1d
     character(len=16) :: name
     character(len=16) :: units
     integer :: dimsid(3)
     integer :: dimssz(2)
     real,pointer,dimension(:) :: pntr
  END TYPE
  TYPE var2d
     character(len=16) :: name
     character(len=16) :: units
     integer :: dimsid(4)
     integer :: dimssz(3)
     real,pointer,dimension(:,:) :: pntr
  END TYPE
  TYPE var3d
     character(len=16) :: name
     character(len=16) :: units
     integer :: dimsid(5)
     integer :: dimssz(4)
     real,pointer,dimension(:,:,:) :: pntr
  END TYPE
CONTAINS

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINE CONSTRUCT_VAR1D --------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_VAR1D(name,dimsid,dimssz,pntr,y,units)
     ! Input arguments
     character(len=*),intent(in) :: name
     integer,intent(in) :: dimsid(3)
     integer,intent(in) :: dimssz(2)
     real,dimension(:),target,intent(in) :: pntr
     type(var1d),intent(out) :: y
     character(len=*),optional,intent(in) :: units
     
     y%name =  name
     if (present(units)) y%units   =  units
     y%dimsid =  dimsid
     y%dimssz =  dimssz
     y%pntr => pntr
  
  END SUBROUTINE CONSTRUCT_VAR1D
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINE CONSTRUCT_VAR2D --------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_VAR2D(name,dimsid,dimssz,pntr,y,units)
     ! Input arguments
     character(len=*),intent(in) :: name
     integer,intent(in) :: dimsid(4)
     integer,intent(in) :: dimssz(3)
     real,dimension(:,:),target,intent(in) :: pntr
     type(var2d),intent(out) :: y
     character(len=*),optional,intent(in) :: units
     
     y%name =  name
     if (present(units)) y%units   =  units
     y%dimsid =  dimsid
     y%dimssz =  dimssz
     y%pntr => pntr
  
  END SUBROUTINE CONSTRUCT_VAR2D
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINE CONSTRUCT_VAR3D --------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_VAR3D(name,dimsid,dimssz,pntr,y,units)
     ! Input arguments
     character(len=*),intent(in) :: name
     integer,intent(in) :: dimsid(5)
     integer,intent(in) :: dimssz(4)
     real,dimension(:,:,:),target,intent(in) :: pntr
     type(var3d),intent(out) :: y
     character(len=*),optional,intent(in) :: units
     
     y%name =  name
     if (present(units)) y%units   =  units
     y%dimsid =  dimsid
     y%dimssz =  dimssz
     y%pntr => pntr
  
  END SUBROUTINE CONSTRUCT_VAR3D

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINE MAP_POINT_TO_LL---------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE MAP_POINT_TO_LL(Nx,Ny,geomode,x1,x2,x3,x4,y2,y3,y4,y5)
     ! Input arguments
     integer,intent(in) :: Nx,Ny,geomode
     real,intent(in),optional :: x1(:),x2(:,:),x3(:,:,:), &
                                 x4(:,:,:,:)
     real,intent(out),optional :: y2(:,:),y3(:,:,:), &
                                  y4(:,:,:,:),y5(:,:,:,:,:)
     ! Local variables
     integer :: Npoints
     integer :: px(Nx*Ny),py(Nx*Ny)
     integer :: i,j,k,l,m
     integer :: Ni,Nj,Nk,Nl
     integer :: Mi,Mj,Mk,Ml,Mm
     character(len=128) :: proname='MAP_POINT_TO_LL'

     Npoints = Nx*Ny
     
     px=0
     py=0
     ! Obtain pointers to do the mapping
     if (geomode == 2) then ! (lon,lat) mode
      do j=1,Ny
        do i=1,Nx
            k = (j-1)*Nx+i
            px(k) = i  
            py(k) = j  
        enddo
      enddo
     else if (geomode == 3) then ! (lon,lat) mode
      do j=1,Nx
        do i=1,Ny
            k = (j-1)*Ny+i
            px(k) = j
            py(k) = i  
        enddo
      enddo
     else
#ifdef COSP_GFDL
       call error_mesg ('cosp_io:map_point_to_ll',  &
                    ' -- '//trim(proname)//': geomode not supported, ', &
                                                             FATAL)
#else
       print *, ' -- '//trim(proname)//': geomode not supported, ',geomode
       stop
#endif
     endif

     if (present(x1).and.present(y2)) then
        Ni = size(x1,1)
        Mi = size(y2,1)
        Mj = size(y2,2)
        if (Mi*Mj /= Ni) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_point_to_ll',  &
           ' -- '//trim(proname)//': Nlon*Nlat /= Npoints (opt 1)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nlon*Nlat /= Npoints (opt 1)'
          stop
#endif
        endif
        do i=1,Npoints
          y2(px(i),py(i)) = x1(i)
        enddo
     else if (present(x2).and.present(y3)) then
        Ni = size(x2,1)
        Nj = size(x2,2)
        Mi = size(y3,1)
        Mj = size(y3,2)
        Mk = size(y3,3)
        if (Mi*Mj /= Ni) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_point_to_ll',  &
           ' -- '//trim(proname)//': Nlon*Nlat /= Npoints (opt 2)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nlon*Nlat /= Npoints (opt 2)'
          stop
#endif
        endif
        if (Nj /= Mk) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_point_to_ll',  &
           ' -- '//trim(proname)//': Nj /= Mk (opt 2)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nj /= Mk (opt 2)'
          stop
#endif
        endif
        do k=1,Mk
         do i=1,Npoints
            y3(px(i),py(i),k) = x2(i,k)
         enddo
        enddo
     else if (present(x3).and.present(y4)) then
        Ni = size(x3,1)
        Nj = size(x3,2)
        Nk = size(x3,3)
        Mi = size(y4,1)
        Mj = size(y4,2)
        Mk = size(y4,3)
        Ml = size(y4,4)
        if (Mi*Mj /= Ni) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_point_to_ll',  &
           ' -- '//trim(proname)//': Nlon*Nlat /= Npoints (opt 3)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nlon*Nlat /= Npoints (opt 3)'
          stop
#endif 
        endif
        if (Nj /= Mk) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_point_to_ll',  &
           ' -- '//trim(proname)//': Nj /= Mk (opt 3)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nj /= Mk (opt 3)'
          stop
#endif
        endif
        if (Nk /= Ml) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_point_to_ll',  &
                   ' -- '//trim(proname)//': Nk /= Ml (opt 3)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nk /= Ml (opt 3)'
          stop
#endif
        endif
        do l=1,Ml
         do k=1,Mk
          do i=1,Npoints
            y4(px(i),py(i),k,l) = x3(i,k,l)
          enddo
         enddo
        enddo
     else if (present(x4).and.present(y5)) then
        Ni = size(x4,1)
        Nj = size(x4,2)
        Nk = size(x4,3)
        Nl = size(x4,4)
        Mi = size(y5,1)
        Mj = size(y5,2)
        Mk = size(y5,3)
        Ml = size(y5,4)
        Mm = size(y5,5)
        if (Mi*Mj /= Ni) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_point_to_ll',  &
                 ' -- '//trim(proname)//': Nlon*Nlat /= Npoints (opt 4)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nlon*Nlat /= Npoints (opt 4)'
          stop
#endif
        endif
        if (Nj /= Mk) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_point_to_ll',  &
                   ' -- '//trim(proname)//': Nj /= Mk (opt 4)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nj /= Mk (opt 4)'
          stop
#endif
        endif
        if (Nk /= Ml) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_point_to_ll',  &
                   ' -- '//trim(proname)//': Nk /= Ml (opt 4)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nk /= Ml (opt 4)'
          stop
#endif
        endif
        if (Nl /= Mm) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_point_to_ll',  &
                   ' -- '//trim(proname)//': Nl /= Mm (opt 4)', &
                                                             FATAL)
#else
          print *, ' -- '//trim(proname)//': Nl /= Mm (opt 4)'
          stop
#endif
        endif
        do m=1,Mm
         do l=1,Ml
          do k=1,Mk
            do i=1,Npoints
                y5(px(i),py(i),k,l,m) = x4(i,k,l,m)
            enddo
          enddo
         enddo
        enddo
     else
#ifdef COSP_GFDL
        call error_mesg ('cosp_io:map_point_to_ll',  &
                 ' -- '//trim(proname)//': wrong option', &
                                                            FATAL)
#else
        print *, ' -- '//trim(proname)//': wrong option'
        stop
#endif
     endif

     
  END SUBROUTINE MAP_POINT_TO_LL

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINE MAP_LL_TO_POINT---------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE MAP_LL_TO_POINT(Nx,Ny,Np,x2,x3,x4,x5,y1,y2,y3,y4)
     ! Input arguments
     integer,intent(in) :: Nx,Ny,Np
     real,intent(in),optional :: x2(:,:),x3(:,:,:), &
                                 x4(:,:,:,:),x5(:,:,:,:,:)
     real,intent(out),optional :: y1(:),y2(:,:),y3(:,:,:), &
                                 y4(:,:,:,:)
     ! Local variables
     integer :: px(Nx*Ny),py(Nx*Ny)
     integer :: i,j,k,l,m
     integer :: Ni,Nj,Nk,Nl,Nm
     integer :: Mi,Mj,Mk,Ml
     character(len=128) :: proname='MAP_LL_TO_POINT'
     
     px=0
     py=0
     if (Nx*Ny < Np) then
#ifdef COSP_GFDL
       call error_mesg ('cosp_io:map_ll_to_point',  &
                ' -- '//trim(proname)//': Nx*Ny < Np', &
                                                            FATAL)
#else
       print *, ' -- '//trim(proname)//': Nx*Ny < Np'
       stop
#endif
     endif
     do j=1,Ny
       do i=1,Nx
          k = (j-1)*Nx+i
          px(k) = i  
          py(k) = j  
       enddo
     enddo
     
     if (present(x2).and.present(y1)) then
        Ni = size(x2,1)
        Nj = size(x2,2)
        Mi = size(y1,1)
        if (Ni*Nj < Mi) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_ll_to_point',  &
                ' -- '//trim(proname)//': Nlon*Nlat < Npoints (opt 1)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nlon*Nlat < Npoints (opt 1)'
          stop
#endif
        endif
        do j=1,Np
          y1(j) = x2(px(j),py(j))
        enddo
     else if (present(x3).and.present(y2)) then
        Ni = size(x3,1)
        Nj = size(x3,2)
        Nk = size(x3,3)
        Mi = size(y2,1)
        Mj = size(y2,2)
        if (Ni*Nj < Mi) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_ll_to_point',  &
             ' -- '//trim(proname)//': Nlon*Nlat < Npoints (opt 2)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nlon*Nlat < Npoints (opt 2)'
          stop
#endif
        endif
        if (Nk /= Mj) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_ll_to_point',  &
                   ' -- '//trim(proname)//': Nk /= Mj (opt 2)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nk /= Mj (opt 2)'
          stop
#endif
        endif
        do k=1,Nk
          do j=1,Np
            y2(j,k) = x3(px(j),py(j),k)
          enddo
        enddo
     else if (present(x4).and.present(y3)) then
        Ni = size(x4,1)
        Nj = size(x4,2)
        Nk = size(x4,3)
        Nl = size(x4,4)
        Mi = size(y3,1)
        Mj = size(y3,2)
        Mk = size(y3,3)
        if (Ni*Nj < Mi) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_ll_to_point',  &
              ' -- '//trim(proname)//': Nlon*Nlat < Npoints (opt 3)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nlon*Nlat < Npoints (opt 3)'
          stop
#endif
        endif
        if (Nk /= Mj) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_ll_to_point',  &
                   ' -- '//trim(proname)//': Nk /= Mj (opt 3)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nk /= Mj (opt 3)'
          stop
#endif
        endif
        if (Nl /= Mk) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_ll_to_point',  &
                   ' -- '//trim(proname)//': Nl /= Mk (opt 3)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nl /= Mk (opt 3)'
          stop
#endif
        endif
        do l=1,Nl
         do k=1,Nk
          do j=1,Np
            y3(j,k,l) = x4(px(j),py(j),k,l)
          enddo
         enddo
        enddo
     else if (present(x5).and.present(y4)) then
        Ni = size(x5,1)
        Nj = size(x5,2)
        Nk = size(x5,3)
        Nl = size(x5,4)
        Nm = size(x5,5)
        Mi = size(y4,1)
        Mj = size(y4,2)
        Mk = size(y4,3)
        Ml = size(y4,4)
        if (Ni*Nj < Mi) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_ll_to_point',  &
               ' -- '//trim(proname)//': Nlon*Nlat < Npoints (opt 4)', &
                                                             FATAL)
#else
          print *, ' -- '//trim(proname)//': Nlon*Nlat < Npoints (opt 4)'
          stop
#endif
        endif
        if (Nk /= Mj) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_ll_to_point',  &
                   ' -- '//trim(proname)//': Nk /= Mj (opt 4)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nk /= Mj (opt 4)'
          stop
#endif
        endif
        if (Nl /= Mk) then
#ifdef COSP_GFDL
          call error_mesg ('cosp_io:map_ll_to_point',  &
                   ' -- '//trim(proname)//': Nl /= Mk (opt 4)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nl /= Mk (opt 4)'
          stop
#endif
        endif
        if (Nm /= Ml) then
#ifdef COSP_GFDL
           call error_mesg ('cosp_io:map_ll_to_point',  &
                   ' -- '//trim(proname)//': Nm /= Ml (opt 4)', &
                                                            FATAL)
#else
          print *, ' -- '//trim(proname)//': Nm /= Ml (opt 4)'
          stop
#endif
        endif
        do m=1,Nm
         do l=1,Nl
          do k=1,Nk
           do j=1,Np
            y4(j,k,l,m) = x5(px(j),py(j),k,l,m)
           enddo
          enddo
         enddo
        enddo
     else
#ifdef COSP_GFDL
        call error_mesg ('cosp_io:map_ll_to_point',  &
                 ' -- '//trim(proname)//': wrong option', &
                                                            FATAL)
#else
        print *, ' -- '//trim(proname)//': wrong option'
        stop
#endif
     endif
  
  END SUBROUTINE MAP_LL_TO_POINT
  
#ifndef COSP_GFDL
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINE NC_READ_INPUT_FILE -----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE NC_READ_INPUT_FILE(fname,Npnts,Nl,Nhydro,lon,lat,p,ph,z,zh,T,qv,rh,tca,cca, &
            mr_lsliq,mr_lsice,mr_ccliq,mr_ccice,fl_lsrain,fl_lssnow,fl_lsgrpl, &
            fl_ccrain,fl_ccsnow,Reff,dtau_s,dtau_c,dem_s,dem_c,skt,landmask,sfc_height, &
            mr_ozone,u_wind,v_wind,sunlit,emsfc_lw,mode,Nlon,Nlat,verbosity)
    
    !Arguments
    character(len=512),intent(in) :: fname ! File name
    integer,intent(in) :: Npnts,Nl,Nhydro
    real,dimension(Npnts),intent(out) :: lon,lat
    real,dimension(Npnts,Nl),target,intent(out) :: p,ph,z,zh,T,qv,rh,tca,cca, &
                  mr_lsliq,mr_lsice,mr_ccliq,mr_ccice,fl_lsrain,fl_lssnow,fl_lsgrpl, &
                  fl_ccrain,fl_ccsnow,dtau_s,dtau_c,dem_s,dem_c,mr_ozone
    real,dimension(Npnts,Nl,Nhydro),intent(out) :: Reff
    real,dimension(Npnts),intent(out) :: skt,landmask,sfc_height,u_wind,v_wind,sunlit
    real,intent(out) :: emsfc_lw
    integer,intent(out) :: mode,Nlon,Nlat
    integer,optional :: verbosity
        
    !Local variables
    integer :: Npoints,Nlevels,i,j,k
    character(len=128) :: vname
    integer,parameter :: NMAX_DIM=5
    integer :: vrank,vdimid(NMAX_DIM)
    character(len=256) :: dimname(NMAX_DIM) ! 256 hardcoded, instead of MAXNCNAM. This works for NetCDF 3 and 4.
    integer :: ncid,vid,ndims,nvars,ngatts,recdim,dimsize(NMAX_DIM)
    integer :: errst
    logical :: Llat,Llon,Lpoint
    integer :: Na,Nb,Nc,Nd,Ne
    real,dimension(Npnts) :: ll
    integer,dimension(:),allocatable :: plon,plat
    real,allocatable :: x1(:),x2(:,:),x3(:,:,:),x4(:,:,:,:),x5(:,:,:,:,:) ! Temporary arrays
    character(len=64) :: routine_name='NC_READ_INPUT_FILE'
    character(len=128) :: errmsg,straux
    
    mode = 0
    Nlon = 0
    Nlat = 0
    
    Npoints = Npnts
    Nlevels = Nl
    
    ! Open file
    errst = nf90_open(fname, nf90_nowrite, ncid)
    if (errst /= 0) then
      errmsg="Couldn't open "//trim(fname)
      call cosp_error(routine_name,errmsg)
    endif
    
    ! Get information about dimensions. Curtain mode or lat/lon mode?
    Llat  =.false.
    Llon  =.false.
    Lpoint=.false.
    errst = nf90_inquire(ncid, ndims, nvars, ngatts, recdim)
    if (errst /= 0) then
      errmsg="Error in  nf90_inquire"
      call cosp_error(routine_name,errmsg,errcode=errst)
    endif
    do i = 1,ndims
       errst = nf90_Inquire_Dimension(ncid,i,name=dimname(i),len=dimsize(i))
       if (errst /= 0) then
         write(straux, *)  i
         errmsg="Error in nf90_Inquire_Dimension, i: "//trim(straux)
         call cosp_error(routine_name,errmsg)
       endif
       if ((trim(dimname(i)).eq.'level').and.(Nlevels > dimsize(i))) then
         errmsg='Number of levels selected is greater than in input file '//trim(fname)
         call cosp_error(routine_name,errmsg)
       endif
       if (trim(dimname(i)).eq.'point') then
         Lpoint = .true.
         if (Npnts > dimsize(i)) then
           errmsg='Number of points selected is greater than in input file '//trim(fname)
           call cosp_error(routine_name,errmsg)
         endif
       endif
       if (trim(dimname(i)).eq.'lon') then
         Llon = .true.
         Nlon = dimsize(i)
       endif
       if (trim(dimname(i)).eq.'lat') then
         Llat = .true.
         Nlat = dimsize(i)
       endif
    enddo

    ! Get lon and lat
    if (Llon.and.Llat) then ! 2D mode
        if ((Npnts) > Nlon*Nlat) Npoints=Nlon*Nlat
        lon = R_UNDEF
        lat = R_UNDEF
        mode = 2 ! Don't know yet if (lon,lat) or (lat,lon) at this point
    else if (Lpoint) then ! 1D mode
        Nlon = Npoints
        Nlat = Npoints
        mode = 1
    else
        errmsg= trim(fname)//' file contains wrong dimensions'
        call cosp_error(routine_name,errmsg)
    endif
    errst = nf90_inq_varid(ncid, 'lon', vid)
    if (errst /= 0) then
        errmsg="Error in nf90_inq_varid, var: lon"
        call cosp_error(routine_name,errmsg,errcode=errst)
    endif
    errst = nf90_get_var(ncid, vid, lon, start = (/1/), count = (/Nlon/))
    if (errst /= 0) then
        errmsg="Error in nf90_get_var, var: lon"
        call cosp_error(routine_name,errmsg,errcode=errst)
    endif
    errst = nf90_inq_varid(ncid, 'lat', vid)
    if (errst /= 0) then
        errmsg="Error in nf90_inq_varid, var: lat"
        call cosp_error(routine_name,errmsg,errcode=errst)
    endif
    errst = nf90_get_var(ncid, vid, lat, start = (/1/), count = (/Nlat/))
    if (errst /= 0) then
        errmsg="Error in nf90_get_var, var: lat"
        call cosp_error(routine_name,errmsg,errcode=errst)
    endif
    
    ! Get all variables
    do vid = 1,nvars
       vdimid=0
       errst = nf90_Inquire_Variable(ncid, vid, name=vname, ndims=vrank, dimids=vdimid)
       if (errst /= 0) then
         write(straux, *)  vid
         errmsg='Error in nf90_Inquire_Variable, vid '//trim(straux)
         call cosp_error(routine_name,errmsg,errcode=errst)
       endif
       ! Read in into temporary array of correct shape
       if (present(verbosity).and.(verbosity == 1)) print *, 'Reading '//trim(vname)//' ...'
       if (vrank == 1) then
          Na = dimsize(vdimid(1))
          allocate(x1(Na))
          errst = nf90_get_var(ncid, vid, x1, start=(/1/), count=(/Na/))
       endif
       if (vrank == 2) then
          Na = dimsize(vdimid(1))
          Nb = dimsize(vdimid(2))
          allocate(x2(Na,Nb))
          errst = nf90_get_var(ncid, vid, x2, start=(/1,1/), count=(/Na,Nb/))
       endif
       if (vrank == 3) then
          Na = dimsize(vdimid(1))
          Nb = dimsize(vdimid(2))
          Nc = dimsize(vdimid(3))
          allocate(x3(Na,Nb,Nc))
          errst = nf90_get_var(ncid, vid, x3, start=(/1,1,1/), count=(/Na,Nb,Nc/))
          if ((mode == 2).or.(mode == 3)) then
            if ((Na == Nlon).and.(Nb == Nlat)) then
              mode = 2
            else if ((Na == Nlat).and.(Nb == Nlon)) then
              mode = 3
            else
              errmsg='Wrong mode for variable '//trim(vname)
              call cosp_error(routine_name,errmsg)
            endif
          endif
       endif
       if (vrank == 4) then
          Na = dimsize(vdimid(1))
          Nb = dimsize(vdimid(2))
          Nc = dimsize(vdimid(3))
          Nd = dimsize(vdimid(4))
          allocate(x4(Na,Nb,Nc,Nd))
          errst = nf90_get_var(ncid, vid, x4, start=(/1,1,1,1/), count=(/Na,Nb,Nc,Nd/))
       endif
       if (vrank == 5) then
          Na = dimsize(vdimid(1))
          Nb = dimsize(vdimid(2))
          Nc = dimsize(vdimid(3))
          Nd = dimsize(vdimid(4))
          Ne = dimsize(vdimid(5))
          allocate(x5(Na,Nb,Nc,Nd,Ne))
          errst = nf90_get_var(ncid, vid, x5, start=(/1,1,1,1,1/), count=(/Na,Nb,Nc,Nd,Ne/))
       endif
       if (errst /= 0) then
          write(straux, *)  vid
          errmsg='Error in nf90_get_var, vid '//trim(straux)
          call cosp_error(routine_name,errmsg,errcode=errst)
       endif
       ! Map to the right input argument
       select case (trim(vname))
       case ('pfull')
         if (Lpoint) then
           p(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=p)
         endif
       case ('phalf')
         if (Lpoint) then
           ph(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=ph)
         endif
       case ('height')
         if (Lpoint) then
           z(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=z)
         endif
       case ('height_half')
         if (Lpoint) then
           zh(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=zh)
         endif
       case ('T_abs')
         if (Lpoint) then
           T(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=T)
         endif
       case ('qv')
         if (Lpoint) then
           qv(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=qv)
         endif
       case ('rh')
         if (Lpoint) then
           rh(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=rh)
         endif
       case ('tca')
         if (Lpoint) then
           tca(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=tca)
         endif
         tca = tca
       case ('cca')
         if (Lpoint) then
           cca(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=cca)
         endif
         cca = cca
       case ('mr_lsliq')
         if (Lpoint) then
           mr_lsliq(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_lsliq)
         endif
       case ('mr_lsice')
         if (Lpoint) then
           mr_lsice(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_lsice)
         endif
       case ('mr_ccliq')
         if (Lpoint) then
           mr_ccliq(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_ccliq)
         endif
       case ('mr_ccice')
         if (Lpoint) then
           mr_ccice(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_ccice)
         endif
       case ('fl_lsrain')
         if (Lpoint) then
           fl_lsrain(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_lsrain)
         endif
       case ('fl_lssnow')
         if (Lpoint) then
           fl_lssnow(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_lssnow)
         endif
       case ('fl_lsgrpl')
         if (Lpoint) then
           fl_lsgrpl(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_lsgrpl)
         endif
       case ('fl_ccrain')
         if (Lpoint) then
           fl_ccrain(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_ccrain)
         endif
       case ('fl_ccsnow')
         if (Lpoint) then
           fl_ccsnow(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_ccsnow)
         endif
       case ('dtau_s')
         if (Lpoint) then
           dtau_s(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=dtau_s)
         endif
       case ('dtau_c')
         if (Lpoint) then
           dtau_c(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=dtau_c)
         endif
       case ('dem_s')
         if (Lpoint) then
           dem_s(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=dem_s)
         endif
       case ('dem_c')
         if (Lpoint) then
           dem_c(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=dem_c)
         endif
       case ('Reff')
         if (Lpoint) then
           Reff(1:Npoints,:,:) = x3(1:Npoints,1:Nlevels,:)
         else
           call map_ll_to_point(Na,Nb,Npoints,x4=x4,y3=Reff)
         endif
       case ('skt')
         if (Lpoint) then
           skt(1:Npoints) = x1(1:Npoints)
         else
           call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=skt)
         endif
       case ('landmask')
         if (Lpoint) then
           landmask(1:Npoints) = x1(1:Npoints)
         else
           call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=landmask)
         endif
       case ('orography')
         if (Lpoint) then
           sfc_height(1:Npoints) = x1(1:Npoints)
         else
           call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=sfc_height)
         endif
       case ('mr_ozone')
         if (Lpoint) then
           mr_ozone(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_ozone)
         endif
       case ('u_wind')
         if (Lpoint) then
           u_wind(1:Npoints) = x1(1:Npoints)
         else
           call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=u_wind)
         endif
       case ('v_wind')
         if (Lpoint) then
           v_wind(1:Npoints) = x1(1:Npoints)
         else
           call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=v_wind)
         endif
       case ('sunlit')
         if (Lpoint) then
           sunlit(1:Npoints) = x1(1:Npoints)
         else
           call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=sunlit)
         endif
       end select
!        select case (trim(vname))
!        case ('pfull')
!          if (Lpoint) then
!            p(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=p)
!          endif
!        case ('phalf')
!          if (Lpoint) then
!            ph(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=ph)
!          endif
!        case ('zfull')
!          if (Lpoint) then
!            z(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=z)
!          endif
!        case ('zhalf')
!          if (Lpoint) then
!            zh(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=zh)
!          endif
!        case ('ta')
!          if (Lpoint) then
!            T(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=T)
!          endif
!        case ('hus')
!          if (Lpoint) then
!            qv(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=qv)
!          endif
!        case ('hur')
!          if (Lpoint) then
!            rh(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=rh)
!          endif
!        case ('cl')
!          if (Lpoint) then
!            tca(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=tca)
!          endif
!          tca = tca/100.0
!        case ('clc')
!          if (Lpoint) then
!            cca(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=cca)
!          endif
!          cca = cca/100.0
!        case ('clws')
!          if (Lpoint) then
!            mr_lsliq(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_lsliq)
!          endif
!        case ('clis')
!          if (Lpoint) then
!            mr_lsice(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_lsice)
!          endif
!        case ('clwc')
!          if (Lpoint) then
!            mr_ccliq(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_ccliq)
!          endif
!        case ('clic')
!          if (Lpoint) then
!            mr_ccice(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_ccice)
!          endif
!        case ('prsprof')
!          if (Lpoint) then
!            fl_lsrain(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_lsrain)
!          endif
!        case ('prsns')
!          if (Lpoint) then
!            fl_lssnow(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_lssnow)
!          endif
!        case ('grplprof')
!          if (Lpoint) then
!            fl_lsgrpl(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_lsgrpl)
!          endif
!        case ('prcprof')
!          if (Lpoint) then
!            fl_ccrain(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_ccrain)
!          endif
!        case ('prsnc')
!          if (Lpoint) then
!            fl_ccsnow(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_ccsnow)
!          endif
!        case ('dtaus')
!          if (Lpoint) then
!            dtau_s(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=dtau_s)
!          endif
!        case ('dtauc')
!          if (Lpoint) then
!            dtau_c(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=dtau_c)
!          endif
!        case ('dems')
!          if (Lpoint) then
!            dem_s(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=dem_s)
!          endif
!        case ('demc')
!          if (Lpoint) then
!            dem_c(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=dem_c)
!          endif
!        case ('reff')
!          if (Lpoint) then
!            Reff(1:Npoints,:,:) = x3(1:Npoints,1:Nlevels,:)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x4=x4,y3=Reff)
!          endif
!        case ('ts')
!          if (Lpoint) then
!            skt(1:Npoints) = x1(1:Npoints)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=skt)
!          endif
!        case ('landmask')
!          if (Lpoint) then
!            landmask(1:Npoints) = x1(1:Npoints)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=landmask)
!          endif
!        case ('orog')
!          if (Lpoint) then
!            sfc_height(1:Npoints) = x1(1:Npoints)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=sfc_height)
!          endif
!        case ('mrozone')
!          if (Lpoint) then
!            mr_ozone(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_ozone)
!          endif
!        case ('uas')
!          if (Lpoint) then
!            u_wind(1:Npoints) = x1(1:Npoints)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=u_wind)
!          endif
!        case ('vas')
!          if (Lpoint) then
!            v_wind(1:Npoints) = x1(1:Npoints)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=v_wind)
!          endif
!        case ('sunlit')
!          if (Lpoint) then
!            sunlit(1:Npoints) = x1(1:Npoints)
!          else
!            call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=sunlit)
!          endif
!        end select
       ! Free memory
       if (vrank == 1) deallocate(x1)
       if (vrank == 2) deallocate(x2)
       if (vrank == 3) deallocate(x3)
       if (vrank == 4) deallocate(x4)
       if (vrank == 5) deallocate(x5)
    enddo
       
    ! SFC emissivity
    errst = nf90_inq_varid(ncid, 'emsfc_lw', vid)
    if (errst /= 0) then
        errmsg='Error in nf90_inq_varid, var: emsfc_lw'
        call cosp_error(routine_name,errmsg,errcode=errst)
    endif
    errst = nf90_get_var(ncid, vid, emsfc_lw)
    if (errst /= 0) then
        errmsg='Error in nf90_get_var, var: emsfc_lw'
        call cosp_error(routine_name,errmsg,errcode=errst)
    endif

    
    ! Fill in the lat/lon vectors with the right values for 2D modes
    ! This might be helpful if the inputs are 2D (gridded) and 
    ! you want outputs in 1D mode
    allocate(plon(Npoints),plat(Npoints))
    if (mode == 2) then !(lon,lat)
      ll = lat
      do j=1,Nb
        do i=1,Na
          k = (j-1)*Na + i
          plon(k) = i  
          plat(k) = j
        enddo
      enddo
      lon(1:Npoints) = lon(plon(1:Npoints))
      lat(1:Npoints) = ll(plat(1:Npoints))
    else if (mode == 3) then !(lat,lon)
      ll = lon
      do j=1,Nb
        do i=1,Na
          k = (j-1)*Na + i
          lon(k) = ll(j)
          lat(k) = lat(i)
        enddo
      enddo
      lon(1:Npoints) = ll(plon(1:Npoints))
      lat(1:Npoints) = lat(plat(1:Npoints))
    endif
    deallocate(plon,plat)
    
    ! Close file
    errst = nf90_close(ncid)
    if (errst /= 0) then
        errmsg='Error in nf90_close'
        call cosp_error(routine_name,errmsg,errcode=errst)
    endif

  END SUBROUTINE NC_READ_INPUT_FILE
#endif

#ifndef COSP_GFDL
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!--------------- SUBROUTINE NC_WRITE_COSP_1D ---------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#ifdef RTTOV
  SUBROUTINE NC_WRITE_COSP_1D(cmor_nl,wmode,cfg,vgrid,gb,sg,sgradar,sglidar,isccp,misr,modis,rttov,stradar,stlidar)
#else
  SUBROUTINE NC_WRITE_COSP_1D(cmor_nl,wmode,cfg,vgrid,gb,sg,sgradar,sglidar,isccp,misr,modis,stradar,stlidar)
#endif
   ! Input arguments
   character(len=*),intent(in) :: cmor_nl
   character(len=*) :: wmode ! Writing mode 'replace' or 'append'
   type(cosp_config),intent(in) :: cfg
   type(cosp_vgrid),intent(in) :: vgrid
   type(cosp_gridbox),intent(in) :: gb
   type(cosp_subgrid),intent(in) :: sg
   type(cosp_sgradar),intent(in) :: sgradar ! Subgrid radar
   type(cosp_sglidar),intent(in) :: sglidar ! Subgrid lidar
   type(cosp_isccp),intent(in)   :: isccp   ! ISCCP outputs
   type(cosp_misr),intent(in)    :: misr    ! MISR outputs
   type(cosp_modis),intent(in)   :: modis   ! MODIS outputs
#ifdef RTTOV 
   type(cosp_rttov),intent(in)   :: rttov   ! RTTOV outputs 
#endif
   type(cosp_radarstats),intent(in) :: stradar ! Summary statistics from radar simulator
   type(cosp_lidarstats),intent(inout) :: stlidar ! Summary statistics from lidar simulator
   !--- Local variables ---
   integer,parameter :: n3d = 8
#ifdef RTTOV
   integer,parameter :: n2d = 7
#else
   integer,parameter :: n2d = 6
#endif
   integer,parameter :: n1d = 29
   integer :: error_flag,i,j, nc_action
   logical :: lfound
   character(len=512) :: inpath,outpath,start_date,model_id,experiment_id,institution,institute_id,source,calendar, &
                 contact,history,comment,table,parent_experiment_id,parent_experiment_rip,forcing
   character(len=2056) :: references
   double precision :: branch_time
   integer :: initialization_method,physics_version
   integer :: realization,Npoints,Ncolumns,Nlevels,Nlvgrid,maxtsteps,Nchannels
   namelist/CMOR/inpath,outpath,start_date,model_id,experiment_id,branch_time,parent_experiment_id,parent_experiment_rip, &
              forcing,institution,institute_id,source,calendar,realization,initialization_method,physics_version, &
              contact,history,comment,references,table,maxtsteps
   real,dimension(:),allocatable :: profile_ax,column_ax,dbze_ax,channel_ax
   real,dimension(:,:),allocatable :: dbze_bounds,vgrid_bounds,mgrid_bounds,sratio_bounds
   integer :: profile_axid,column_axid,height_axid,dbze_axid,height_mlev_axid,sratio_axid, &
              tau_axid,pressure2_axid,time_axid,sza_axid,MISR_CTH_axid,channel_axid
   integer :: grid_id, latvar_id, lonvar_id, blatvar_id, blonvar_id
   integer :: var3d_id(n3d),var2d_id(n2d),var1d_id(n1d)
   type(var1d) :: v1d(n1d)
   type(var2d) :: v2d(n2d)
   type(var3d) :: v3d(n3d)
   integer :: d2(2),d3(3),d4(4),d5(5)
   logical,dimension(n1d) :: lout1d = .false.
   logical,dimension(n2d) :: lout2d = .false.
   logical,dimension(n3d) :: lout3d = .false.
   double precision :: tbnds(2,1)
   character(len=64) :: pro_name = 'NC_WRITE_COSP_1D'

   ! Initialise values of axis ids that may not be used
   height_mlev_axid = 0
   column_axid      = 0
   channel_axid     = 0
   tau_axid         = 0
   pressure2_axid   = 0
   misr_cth_axid    = 0

   Npoints   = gb%Npoints
   Ncolumns  = gb%Ncolumns
   Nlevels   = gb%Nlevels
   Nchannels = gb%Nchan
   Nlvgrid   = vgrid%Nlvgrid
   
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Allocate memory and initialise
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   tbnds(:,1) = gb%time_bnds
   allocate(profile_ax(Npoints),column_ax(Ncolumns),dbze_ax(DBZE_BINS), &
            dbze_bounds(2,DBZE_BINS),vgrid_bounds(2,Nlvgrid),mgrid_bounds(2,Nlevels), &
            sratio_bounds(2,SR_BINS), channel_ax(Nchannels))
   ! Profile
   do i=1,Npoints
     profile_ax(i) = i
   enddo
   ! Column
   do i=1,Ncolumns
     column_ax(i) = i
   enddo
   ! Channels
   channel_ax = float(gb%ichan)
   ! Radar Ze
   do i=1,DBZE_BINS
     dbze_ax(i) = CFAD_ZE_MIN + CFAD_ZE_WIDTH*(i - 0.5)
   enddo
   do i=1,DBZE_BINS
     dbze_bounds(1,i) = CFAD_ZE_MIN + CFAD_ZE_WIDTH*(i - 1)
     dbze_bounds(2,i) = CFAD_ZE_MIN + CFAD_ZE_WIDTH*i
   enddo
   ! Height of model levels
   do i=1,Nlevels
     mgrid_bounds(1,i) = vgrid%mzl(i)
     mgrid_bounds(2,i) = vgrid%mzu(i)
   enddo
   ! Height of std grid
   do i=1,Nlvgrid
     vgrid_bounds(1,i) = vgrid%zl(i)
     vgrid_bounds(2,i) = vgrid%zu(i)
   enddo
   ! Lidar scattering ratio bounds (They are output by cosp_cfad_sr->diag_lidar in lmd_ipsl_stats.f90)
   sratio_bounds(2,:)         = stlidar%srbval(:) ! srbval contains the upper limits from lmd_ipsl_stats.f90
   sratio_bounds(1,2:SR_BINS) = stlidar%srbval(1:SR_BINS-1)
   sratio_bounds(1,1)         = 0.0
   sratio_bounds(2,SR_BINS)   = 1.e5 ! This matches with Chepfer et al., JGR, 2009. However, it is not consistent 
                                     ! with the upper limit in lmd_ipsl_stats.f90, which is LIDAR_UNDEF-1=998.999
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Read namelist with information for CMOR output file
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   open(10,file=cmor_nl,status='old')
   read(10,nml=cmor)
   close(10)

   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Specify path for tables and set up other CMOR options
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#ifdef USE_CMOR1
   error_flag = cmor_setup(inpath=trim(inpath),netcdf_file_action=trim(wmode))
#else
   nc_action = CMOR_APPEND_3
   if (trim(wmode) == 'replace') nc_action = CMOR_REPLACE_3
   error_flag = cmor_setup(inpath=trim(inpath),netcdf_file_action=nc_action,create_subdirectories=0)
#endif

   print *, '---------------Define dataset'
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Define dataset as output from COSP, and other model details
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#ifdef USE_CMOR1
   error_flag = cmor_dataset(outpath=trim(outpath),experiment_id=trim(experiment_id),institution=trim(institution), &
                    source=trim(source),calendar=trim(calendar),realization=realization,contact=trim(contact), &
                    history=trim(history),comment=trim(comment),references=trim(references))
#else
   error_flag = cmor_dataset(outpath=trim(outpath),experiment_id=trim(experiment_id),institution=trim(institution), &
                    source=trim(source),calendar=trim(calendar),realization=realization,contact=trim(contact), &
                    history=trim(history),comment=trim(comment),references=trim(references),model_id=trim(model_id), &
                    branch_time=branch_time,parent_experiment_id=trim(parent_experiment_id),forcing=trim(forcing), &
                    institute_id=trim(institute_id),parent_experiment_rip=trim(parent_experiment_rip), &
                    initialization_method=initialization_method,physics_version=physics_version)
   error_flag = cmor_set_cur_dataset_attribute('cosp_version',trim(COSP_VERSION))
#endif
   
   print *, '---------------Define axis'
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Define axis
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   profile_axid = cmor_axis(table=table, table_entry='location', units='1', length=Npoints, coord_vals=profile_ax)
   height_axid  = cmor_axis(table=table, table_entry='alt40', units='m', length=Nlvgrid, &
                                                       coord_vals=vgrid%z,cell_bounds=vgrid_bounds)
   dbze_axid    = cmor_axis(table=table, table_entry='dbze', units='dBZ', length=DBZE_BINS, &  ! '10 lg(re 1.e-18 m3)'
                            coord_vals=dbze_ax,cell_bounds=dbze_bounds)
   sratio_axid  = cmor_axis(table=table, table_entry='scatratio', units='1', length=SR_BINS, &
                            coord_vals=(sratio_bounds(1,:)+sratio_bounds(2,:))/2.0,cell_bounds=sratio_bounds)
   sza_axid  = cmor_axis(table=table, table_entry='sza5', units='degree', length=PARASOL_NREFL, coord_vals=PARASOL_SZA)
   time_axid  = cmor_axis(table=table, table_entry='time1', units='days since '//trim(start_date), length=maxtsteps)
   if ((trim(table) /= 'CMIP5_cf3hr').and.(trim(table) /= 'TAMIP_3hr_curt')) then
        column_axid  = cmor_axis(table=table, table_entry='column', units='1', length=Ncolumns, coord_vals=column_ax)
        channel_axid = cmor_axis(table=table, table_entry='channel', units='1', length=Nchannels, coord_vals=channel_ax)
        height_mlev_axid  = cmor_axis(table=table, table_entry='alevel', &
                                      units='1', length=Nlevels, coord_vals=vgrid%mz,cell_bounds=mgrid_bounds)
        tau_axid     = cmor_axis(table=table, table_entry='tau', units='1', length=7, &
                                    coord_vals=ISCCP_TAU,cell_bounds=ISCCP_TAU_BNDS)
        pressure2_axid = cmor_axis(table=table, table_entry='plev7', units='Pa', length=7, &
                                    coord_vals=ISCCP_PC,cell_bounds=ISCCP_PC_BNDS)
        MISR_CTH_axid = cmor_axis(table=table, table_entry='cth16', units='m', length=MISR_N_CTH, &
                                    coord_vals=MISR_CTH,cell_bounds=MISR_CTH_BNDS)
   endif
                            
   print *, '---------------Define grid'
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Define grid
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   grid_id = cmor_grid((/profile_axid, time_axid/))
   latvar_id = cmor_time_varying_grid_coordinate(grid_id,'latitude','degrees_north',R_UNDEF)
   lonvar_id = cmor_time_varying_grid_coordinate(grid_id,'longitude','degrees_east' ,R_UNDEF)
   if (grid_id > 0) then
        print *,  '*********** Error, grid_id: ', grid_id
        stop
   endif
   
   print *, '---------------Fill in var info'
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Fill in variable info and associate pointers
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! 1D variables
   d3 = (/grid_id,0,0/)
   d2 = (/Npoints,0/)
   call construct_var1d('cllcalipso', d3, d2, stlidar%cldlayer(:,1),v1d(1),units='%') ! correction sb
   call construct_var1d('clmcalipso', d3, d2, stlidar%cldlayer(:,2),v1d(2),units='%') ! correction sb
   call construct_var1d('clhcalipso', d3, d2, stlidar%cldlayer(:,3),v1d(3),units='%') ! correction sb
   call construct_var1d('cltcalipso', d3, d2, stlidar%cldlayer(:,4),v1d(4),units='%') ! correction sb
   call construct_var1d('cltlidarradar', d3, d2, stradar%radar_lidar_tcc,v1d(5),units='%')
   call construct_var1d('cltisccp', d3, d2, isccp%totalcldarea,v1d(6),units='%')
   call construct_var1d('pctisccp', d3, d2, isccp%meanptop,v1d(7),units='Pa')
   call construct_var1d('tauisccp', d3, d2, isccp%meantaucld,v1d(8),units='1')
   call construct_var1d('albisccp', d3, d2, isccp%meanalbedocld,v1d(9),units='1')
   call construct_var1d('meantbisccp', d3, d2, isccp%meantb,v1d(10),units='K')
   call construct_var1d('meantbclrisccp', d3, d2, isccp%meantbclr,v1d(11),units='K')
   call construct_var1d('cltmodis', d3, d2, modis%Cloud_Fraction_Total_Mean,v1d(12),units='%')
   call construct_var1d('clwmodis', d3, d2, modis%Cloud_Fraction_Water_Mean,v1d(13),units='%')
   call construct_var1d('climodis', d3, d2, modis%Cloud_Fraction_Ice_Mean,  v1d(14),units='%')
   call construct_var1d('clhmodis', d3, d2, modis%Cloud_Fraction_High_Mean,v1d(15),units='%')
   call construct_var1d('clmmodis', d3, d2, modis%Cloud_Fraction_Mid_Mean,v1d(16),units='%')
   call construct_var1d('cllmodis', d3, d2, modis%Cloud_Fraction_Low_Mean,  v1d(17),units='%')
   call construct_var1d('tautmodis', d3, d2, modis%Optical_Thickness_Total_Mean,v1d(18),units='1')
   call construct_var1d('tauwmodis', d3, d2, modis%Optical_Thickness_Water_Mean,v1d(19),units='1')
   call construct_var1d('tauimodis', d3, d2, modis%Optical_Thickness_Ice_Mean,v1d(20),units='1')
   call construct_var1d('tautlogmodis', d3, d2, modis%Optical_Thickness_Total_LogMean,v1d(21),units='1')
   call construct_var1d('tauwlogmodis', d3, d2, modis%Optical_Thickness_Water_LogMean,v1d(22),units='1')
   call construct_var1d('tauilogmodis', d3, d2, modis%Optical_Thickness_Ice_LogMean,v1d(23),units='1')
   call construct_var1d('reffclwmodis', d3, d2, modis%Cloud_Particle_Size_Water_Mean,v1d(24),units='m')
   call construct_var1d('reffclimodis', d3, d2, modis%Cloud_Particle_Size_Ice_Mean,  v1d(25),units='m')
   call construct_var1d('pctmodis', d3, d2, modis%Cloud_Top_Pressure_Total_Mean, v1d(26),units='Pa')
   call construct_var1d('lwpmodis', d3, d2, modis%Liquid_Water_Path_Mean, v1d(27),units='kg m-2')
   call construct_var1d('iwpmodis', d3, d2, modis%Ice_Water_Path_Mean,    v1d(28),units='kg m-2')
   call construct_var1d('toffset', d3, d2, gb%toffset,    v1d(29),units='day')
   ! 2D variables
   d4 = (/grid_id,height_axid,0,0/)
   d3 = (/Npoints,Nlvgrid,0/)
   call construct_var2d('clcalipso', d4, d3, stlidar%lidarcld,v2d(1),units='%')
   call construct_var2d('clcalipso2',  d4, d3, stradar%lidar_only_freq_cloud,v2d(2),units='%')
   d4 = (/grid_id,height_mlev_axid,0,0/)
   d3 = (/Npoints,Nlevels,0/)
   ! reshape   d4 = (/profile_axid,height_mlev_axid,time_axid,0/)
   call construct_var2d('lidarBetaMol532', d4, d3, sglidar%beta_mol,v2d(3),units='m-1 sr-1')
   d4 = (/grid_id,column_axid,0,0/)
   ! reshape d4 = (/profile_axid,column_axid,time_axid,0/)
   d3 = (/Npoints,Ncolumns,0/)
   call construct_var2d('boxtauisccp', d4, d3, isccp%boxtau,v2d(4),units='1')
   call construct_var2d('boxptopisccp', d4, d3, isccp%boxptop,v2d(5),units='Pa')
   d4 = (/grid_id,sza_axid,0,0/)
   d3 = (/Npoints,PARASOL_NREFL,0/)
   call construct_var2d('parasolRefl', d4, d3, stlidar%parasolrefl,v2d(6),units='1')
#ifdef RTTOV 
   !reshape d4 = (/profile_axid,channel_axid,time_axid,0/) 
   d4 = (/grid_id,channel_axid,0,0/) 
   d3 = (/Npoints,Nchannels,0/) 
   call construct_var2d('tbrttov', d4, d3, rttov%tbs,v2d(7),units='K') 
#endif

   ! 3D variables
   ! reshape d5 = (/profile_axid,column_axid,height_mlev_axid,time_axid,0/)
   d5 = (/grid_id,column_axid,height_mlev_axid,0,0/)
   d4 = (/Npoints,Ncolumns,Nlevels,0/)
   call construct_var3d('dbze94', d5, d4, sgradar%Ze_tot,v3d(1),units='1')
   call construct_var3d('atb532', d5, d4, sglidar%beta_tot,v3d(2),units='m-1 sr-1')
   call construct_var3d('fracout', d5, d4, sg%frac_out,v3d(3),units='1')
   ! reshape d5 = (/profile_axid,dbze_axid,height_axid,time_axid,0/)
   d5 = (/grid_id,dbze_axid,height_axid,0,0/)
   d4 = (/Npoints,DBZE_BINS,Nlvgrid,0/)
   call construct_var3d('cfadDbze94', d5, d4, stradar%cfad_ze,v3d(4),units='1')
   ! reshape d5 = (/profile_axid,sratio_axid,height_axid,time_axid,0/)
   d5 = (/grid_id,sratio_axid,height_axid,0,0/)
   d4 = (/Npoints,SR_BINS,Nlvgrid,0/)
   call construct_var3d('cfadLidarsr532', d5, d4, stlidar%cfad_sr,v3d(5),units='1')
   ! reshape d5 = (/profile_axid,tau_axid,pressure2_axid,time_axid,0/)
   d5 = (/grid_id,tau_axid,pressure2_axid,0,0/)
   d4 = (/Npoints,7,7,0/)
   call construct_var3d('clisccp', d5, d4, isccp%fq_isccp,v3d(6),units='%')
   call construct_var3d('clmodis', d5, d4, modis%Optical_Thickness_vs_Cloud_Top_Pressure, v3d(7), units='%')
   ! reshape d5 = (/profile_axid,tau_axid,MISR_CTH_axid,time_axid,0/)
   d5 = (/grid_id,tau_axid,MISR_CTH_axid,0,0/)
   d4 = (/Npoints,7,MISR_N_CTH,0/)
   call construct_var3d('clMISR', d5, d4, misr%fq_MISR,v3d(8),units='%')
  
   print *, '---------------Find list'
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Find list of outputs to be written
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   do i=1,N_OUT_LIST
     lfound = .false.
     if (trim(cfg%out_list(i)) /= '') then
        do j=1,n1d
          if (trim(v1d(j)%name) == trim(cfg%out_list(i))) then
            lout1d(j) = .true.
            lfound = .true.
            exit
          endif
        enddo
        if (.not.lfound) then
          do j=1,n2d
            if (trim(v2d(j)%name) == trim(cfg%out_list(i))) then
                lout2d(j) = .true.
                lfound = .true.
                exit
            endif
          enddo
        endif
        if (.not.lfound) then
          do j=1,n3d
            if (trim(v3d(j)%name) == trim(cfg%out_list(i))) then
                lout3d(j) = .true.
                lfound = .true.
                exit
            endif
          enddo
        endif
     endif
   enddo
   
   print *, '---------------Define variables'
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Define variables. Fill in dimensions table first if needed
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! 1D variables
   do i=1,n1d
     if (lout1d(i)) var1d_id(i) = cmor_variable(table=table, table_entry=v1d(i)%name, units=v1d(i)%units, &
                                 axis_ids=v1d(i)%dimsid(1:1), missing_value=R_UNDEF)
   enddo
   ! 2D variables
   do i=1,n2d
     if (lout2d(i)) var2d_id(i) = cmor_variable(table=table, table_entry=v2d(i)%name, units=v2d(i)%units, &
                                 axis_ids=v2d(i)%dimsid(1:2), missing_value=R_UNDEF)
   enddo
   ! 3D variables
   do i=1,n3d
     if (lout3d(i)) then 
          var3d_id(i) = cmor_variable(table=trim(table), table_entry=v3d(i)%name, units=v3d(i)%units, &
                                  axis_ids=v3d(i)%dimsid(1:3), missing_value=R_UNDEF)
     endif
   enddo
   
   print *, '---------------Write variables'
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Write variables to file
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! 1D variables
   do i=1,n1d
      if (lout1d(i)) then
        error_flag = cmor_write(var_id=var1d_id(i), data=v1d(i)%pntr, &
                           ntimes_passed=1,time_vals=(/gb%time/),time_bnds=tbnds)
        if (error_flag < 0) then
           print *,  trim(pro_name)//': Error writing '//trim(v1d(i)%name)
           stop
        endif
        error_flag = cmor_write(var_id=lonvar_id, data=gb%longitude,store_with=var1d_id(i), &
                           ntimes_passed=1,time_vals=(/gb%time/))
        if (error_flag < 0) then
           print *,  trim(pro_name)//': Error writing lon for '//trim(v1d(i)%name)
           stop
        endif
        error_flag = cmor_write(var_id=latvar_id, data=gb%latitude,store_with=var1d_id(i), &
                           ntimes_passed=1,time_vals=(/gb%time/))
        if (error_flag < 0) then
           print *,  trim(pro_name)//': Error writing lat for '//trim(v1d(i)%name)
           stop
        endif
      endif
   enddo
   ! 2D variables
   do i=1,n2d
      if (lout2d(i)) then
        error_flag = cmor_write(var_id=var2d_id(i), data=v2d(i)%pntr, &
                           ntimes_passed=1,time_vals=(/gb%time/),time_bnds=tbnds)
        if (error_flag < 0) then
           print *,  trim(pro_name)//': Error writing '//trim(v2d(i)%name)
           stop
        endif
        error_flag = cmor_write(var_id=lonvar_id, data=gb%longitude,store_with=var2d_id(i), &
                           ntimes_passed=1,time_vals=(/gb%time/))
        if (error_flag < 0) then
           print *,  trim(pro_name)//': Error writing lon for '//trim(v2d(i)%name)
           stop
        endif
        error_flag = cmor_write(var_id=latvar_id, data=gb%latitude,store_with=var2d_id(i), &
                           ntimes_passed=1,time_vals=(/gb%time/))
        if (error_flag < 0) then
           print *,  trim(pro_name)//': Error writing lat for '//trim(v2d(i)%name)
           stop
        endif
      endif
   enddo
   ! 3D variables
   do i=1,n3d
      if (lout3d(i)) then
        error_flag = cmor_write(var_id=var3d_id(i), data=v3d(i)%pntr, &
                           ntimes_passed=1,time_vals=(/gb%time/),time_bnds=tbnds)
        if (error_flag < 0) then
           print *,  trim(pro_name)//': Error writing '//trim(v3d(i)%name)
           stop
        endif
        error_flag = cmor_write(var_id=lonvar_id, data=gb%longitude,store_with=var3d_id(i), &
                           ntimes_passed=1,time_vals=(/gb%time/))
        if (error_flag < 0) then
           print *,  trim(pro_name)//': Error writing lon for '//trim(v3d(i)%name)
           stop
        endif
        error_flag = cmor_write(var_id=latvar_id, data=gb%latitude,store_with=var3d_id(i), &
                           ntimes_passed=1,time_vals=(/gb%time/))
        if (error_flag < 0) then
           print *,  trim(pro_name)//': Error writing lat for '//trim(v3d(i)%name)
           stop
        endif
      endif
   enddo
   
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Close files
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   error_flag = cmor_close()
   
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Deallocate memory
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   deallocate(profile_ax,column_ax,dbze_ax,dbze_bounds,sratio_bounds, &
             vgrid_bounds,mgrid_bounds,channel_ax)
   
  END SUBROUTINE NC_WRITE_COSP_1D

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!--------------- SUBROUTINE NC_WRITE_COSP_2D ---------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#ifdef RTTOV
  SUBROUTINE NC_WRITE_COSP_2D(cmor_nl,wmode,cfg,vgrid,gb,sg,sgradar,sglidar,isccp,misr,modis,rttov, &
                              stradar,stlidar,geomode,Nlon,Nlat)
#else
  SUBROUTINE NC_WRITE_COSP_2D(cmor_nl,wmode,cfg,vgrid,gb,sg,sgradar,sglidar,isccp,misr,modis, &
                              stradar,stlidar,geomode,Nlon,Nlat)
#endif
   ! Input arguments
   character(len=*),intent(in) :: cmor_nl
   character(len=*)  :: wmode ! Writing mode 'replace' or 'append'
   type(cosp_config),intent(in) :: cfg
   type(cosp_vgrid),intent(in) :: vgrid
   type(cosp_gridbox),intent(in) :: gb
   type(cosp_subgrid),intent(in) :: sg
   type(cosp_sgradar),intent(in) :: sgradar ! Subgrid radar
   type(cosp_sglidar),intent(in) :: sglidar ! Subgrid lidar
   type(cosp_isccp),intent(in)   :: isccp   ! ISCCP outputs
   type(cosp_misr),intent(in)    :: misr    ! MISR outputs
   type(cosp_modis),intent(in)   :: modis   ! MODIS outputs
#ifdef RTTOV
   type(cosp_rttov),intent(in)   :: rttov   ! RTTOV outputs
#endif
   type(cosp_radarstats),intent(in) :: stradar ! Summary statistics from radar simulator
   type(cosp_lidarstats),intent(in) :: stlidar ! Summary statistics from lidar simulator
   integer,intent(in) :: geomode,Nlon,Nlat
   !--- Local variables ---
   integer,parameter :: n3d = 8
#ifdef RTTOV 
   integer,parameter :: n2d = 7 
#else 
   integer,parameter :: n2d = 6 
#endif
   integer,parameter :: n1d = 28
   integer :: error_flag,i,j,Npoints,Ncolumns,Nlevels,Nlvgrid,maxtsteps,Nchannels
   logical :: lfound
   real :: lon_ax(Nlon),lat_ax(Nlat)
   character(len=512) :: inpath,outpath,start_date,model_id,experiment_id,institution,institute_id,source,calendar, &
                 contact,history,comment,table,parent_experiment_id,parent_experiment_rip,forcing
   character(len=2056) :: references
   integer :: realization, nc_action,initialization_method,physics_version
   double precision :: branch_time
   namelist/CMOR/inpath,outpath,start_date,model_id,experiment_id,branch_time,parent_experiment_id,parent_experiment_rip, &
              forcing,institution,institute_id,source,calendar,realization,initialization_method,physics_version, &
              contact,history,comment,references,table,maxtsteps
   real,dimension(:),allocatable :: column_ax,dbze_ax,channel_ax
   real,dimension(:,:),allocatable :: dbze_bounds,vgrid_bounds,sratio_bounds, &
                                      lon_bounds,lat_bounds,mgrid_bounds
   integer :: column_axid,height_axid,dbze_axid,height_mlev_axid,sratio_axid, &
              tau_axid,pressure2_axid,lon_axid,lat_axid,time_axid,sza_axid,MISR_CTH_axid, &
              channel_axid
   integer :: var3d_id(n3d),var2d_id(n2d),var1d_id(n1d)   
   type(var1d) :: v1d(n1d)
   type(var2d) :: v2d(n2d)
   type(var3d) :: v3d(n3d)
   integer :: d2(2),d3(3),d4(4),d5(5)
   logical,dimension(n1d) :: lout1d = .false.
   logical,dimension(n2d) :: lout2d = .false.
   logical,dimension(n3d) :: lout3d = .false.
   real,allocatable :: y2(:,:),y3(:,:,:),y4(:,:,:,:)
   double precision :: tbnds(2,1)
   character(len=64) :: pro_name = 'NC_WRITE_COSP_2D'
   
   Npoints   = gb%Npoints
   Ncolumns  = gb%Ncolumns
   Nlevels   = gb%Nlevels
   Nchannels = gb%Nchan
   Nlvgrid   = vgrid%Nlvgrid

   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Safety checks
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   if (Npoints > Nlon*Nlat) then
      Npoints = Nlon*Nlat
      print *, ' -- '//trim(pro_name)//' Warning: Npoints > Nlon*Nlat'
   endif
   if (Npoints < Nlon*Nlat) then
      print *, ' -- '//trim(pro_name)//': only Npoints >= Nlon*Nlat is supported'
      stop
   endif
   
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Allocate memory and compute axes and bounds
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   tbnds(:,1) = gb%time_bnds
   allocate(column_ax(Ncolumns),dbze_ax(DBZE_BINS),channel_ax(Nchannels), &
            dbze_bounds(2,DBZE_BINS),vgrid_bounds(2,Nlvgrid),mgrid_bounds(2,Nlevels),sratio_bounds(2,SR_BINS), &
            lon_bounds(2,Nlon),lat_bounds(2,Nlat))
   ! Column
   do i=1,gb%Ncolumns
     column_ax(i) = i
   enddo
   ! Channels
   channel_ax = float(gb%ichan)
   ! Radar Ze
   do i=1,DBZE_BINS
     dbze_ax(i) = CFAD_ZE_MIN + CFAD_ZE_WIDTH*(i - 0.5)
   enddo
   do i=1,DBZE_BINS
     dbze_bounds(1,i) = CFAD_ZE_MIN + CFAD_ZE_WIDTH*(i - 1)
     dbze_bounds(2,i) = CFAD_ZE_MIN + CFAD_ZE_WIDTH*i
   enddo
   ! Height of model levels
   do i=1,Nlevels
     mgrid_bounds(1,i) = vgrid%mzl(i)
     mgrid_bounds(2,i) = vgrid%mzu(i)
   enddo
   ! Height of std grid
   do i=1,Nlvgrid
     vgrid_bounds(1,i) = vgrid%zl(i)
     vgrid_bounds(2,i) = vgrid%zu(i)
   enddo
   ! Lidar scattering ratio bounds (They are output by cosp_cfad_sr->diag_lidar in lmd_ipsl_stats.f90)
   sratio_bounds(2,:)         = stlidar%srbval(:) ! srbval contains the upper limits from lmd_ipsl_stats.f90
   sratio_bounds(1,2:SR_BINS) = stlidar%srbval(1:SR_BINS-1)
   sratio_bounds(1,1)         = 0.0
   sratio_bounds(2,SR_BINS)   = 1.e5 ! This matches with Chepfer et al., JGR, 2009. However, it is not consistent 
                                     ! with the upper limit in lmd_ipsl_stats.f90, which is LIDAR_UNDEF-1=998.999
   ! Lat lon axes
   if (geomode == 2) then
      lon_ax = gb%longitude(1:Nlon)
      lat_ax = gb%latitude(1:Npoints:Nlon)
   else if (geomode == 3) then
      lon_ax = gb%longitude(1:Npoints:Nlat)
      lat_ax = gb%latitude(1:Nlat)
   else if (geomode == 4) then
      lon_ax = gb%longitude(1:Nlon)
      lat_ax = gb%latitude(1:Nlat)
   endif
   lon_bounds(1,2:Nlon) = (lon_ax(1:Nlon-1) + lon_ax(2:Nlon))/2.0
   lon_bounds(1,1) = lon_ax(1) - (lon_bounds(1,2) - lon_ax(1))
   lon_bounds(2,1:Nlon-1) = lon_bounds(1,2:Nlon)
   lon_bounds(2,Nlon) = lon_ax(Nlon) + (lon_ax(Nlon) - lon_bounds(2,Nlon-1))
   lat_bounds(1,2:Nlat) = (lat_ax(1:Nlat-1) + lat_ax(2:Nlat))/2.0
   lat_bounds(1,1) = lat_ax(1) - (lat_bounds(1,2) - lat_ax(1))
   lat_bounds(2,1:Nlat-1) = lat_bounds(1,2:Nlat)
   lat_bounds(2,Nlat) = lat_ax(Nlat) + (lat_ax(Nlat) - lat_bounds(2,Nlat-1))

   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Read namelist with information for CMOR output file
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   open(10,file=cmor_nl,status='old')
   read(10,nml=cmor)
   close(10)
   
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Specify path for tables and set up other CMOR options
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#ifdef USE_CMOR1
   error_flag = cmor_setup(inpath=trim(inpath),netcdf_file_action=trim(wmode))
#else
   nc_action = CMOR_APPEND_3
   if (trim(wmode) == 'replace') nc_action = CMOR_REPLACE_3
   error_flag = cmor_setup(inpath=trim(inpath),netcdf_file_action=nc_action,create_subdirectories=0)
#endif
      
   
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Define dataset as output from COSP, and other model details
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#ifdef USE_CMOR1
   error_flag = cmor_dataset(outpath=trim(outpath),experiment_id=trim(experiment_id),institution=trim(institution), &
                    source=trim(source),calendar=trim(calendar),realization=realization,contact=trim(contact), &
                    history=trim(history),comment=trim(comment),references=trim(references))
#else
   error_flag = cmor_dataset(outpath=trim(outpath),experiment_id=trim(experiment_id),institution=trim(institution), &
                    source=trim(source),calendar=trim(calendar),realization=realization,contact=trim(contact), &
                    history=trim(history),comment=trim(comment),references=trim(references),model_id=trim(model_id), &
                    branch_time=branch_time,parent_experiment_id=trim(parent_experiment_id),forcing=trim(forcing), &
                    institute_id=trim(institute_id),parent_experiment_rip=trim(parent_experiment_rip), &
                    initialization_method=initialization_method,physics_version=physics_version)
   error_flag = cmor_set_cur_dataset_attribute('cosp_version',trim(COSP_VERSION))
#endif
   
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Define axis
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   lon_axid     = cmor_axis(table=table, table_entry='longitude', units='degrees_east', length=Nlon, coord_vals=lon_ax, &
                        cell_bounds = lon_bounds)
   lat_axid     = cmor_axis(table=table, table_entry='latitude', units='degrees_north', length=Nlat, coord_vals=lat_ax, &
                        cell_bounds = lat_bounds)
   column_axid  = cmor_axis(table=table, table_entry='column', units='1', length=Ncolumns, coord_vals=column_ax)
   channel_axid = cmor_axis(table=table, table_entry='channel', units='1', length=Nchannels, coord_vals=channel_ax)
   height_axid  = cmor_axis(table=table, table_entry='alt40', units='m', length=Nlvgrid, &
                                                       coord_vals=vgrid%z,cell_bounds=vgrid_bounds)
   dbze_axid    = cmor_axis(table=table, table_entry='dbze', units='dBZ', length=DBZE_BINS, &
                            coord_vals=dbze_ax,cell_bounds=dbze_bounds)
   height_mlev_axid  = cmor_axis(table=table, table_entry='alevel', units='1', length=Nlevels, &
                                                       coord_vals=vgrid%mz,cell_bounds=mgrid_bounds)
   sratio_axid  = cmor_axis(table=table, table_entry='scatratio', units='1', length=SR_BINS, &
                            coord_vals=(sratio_bounds(1,:)+sratio_bounds(2,:))/2.0,cell_bounds=sratio_bounds)
   tau_axid     = cmor_axis(table=table, table_entry='tau', units='1', length=7, &
                            coord_vals=ISCCP_TAU,cell_bounds=ISCCP_TAU_BNDS)
   pressure2_axid = cmor_axis(table=table, table_entry='plev7', units='Pa', length=7, &
                            coord_vals=ISCCP_PC,cell_bounds=ISCCP_PC_BNDS)
   sza_axid   = cmor_axis(table=table, table_entry='sza5', units='degree', length=PARASOL_NREFL, coord_vals=PARASOL_SZA)
   MISR_CTH_axid = cmor_axis(table=table, table_entry='cth16', units='m', length=MISR_N_CTH, &
                            coord_vals=MISR_CTH,cell_bounds=MISR_CTH_BNDS)
   time_axid  = cmor_axis(table=table, table_entry='time1', units='days since '//trim(start_date), length=maxtsteps)
   
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Fill in variable info and associate pointers
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! 1D variables
   d3 = (/lon_axid,lat_axid,time_axid/)
   d2 = (/Nlon,Nlat/)
   call construct_var1d('cllcalipso',     d3, d2, stlidar%cldlayer(:,1),v1d(1),units='%') ! correction sb
   call construct_var1d('clmcalipso',     d3, d2, stlidar%cldlayer(:,2),v1d(2),units='%') ! correction sb
   call construct_var1d('clhcalipso',     d3, d2, stlidar%cldlayer(:,3),v1d(3),units='%') ! correction sb
   call construct_var1d('cltcalipso',     d3, d2, stlidar%cldlayer(:,4),v1d(4),units='%') ! correction sb
   call construct_var1d('cltlidarradar',  d3, d2, stradar%radar_lidar_tcc,v1d(5),units='%')
   call construct_var1d('cltisccp',       d3, d2, isccp%totalcldarea,v1d(6),units='%')
   call construct_var1d('pctisccp',       d3, d2, isccp%meanptop,v1d(7),units='Pa')
   call construct_var1d('tauisccp',       d3, d2, isccp%meantaucld,v1d(8),units='1')
   call construct_var1d('albisccp',       d3, d2, isccp%meanalbedocld,v1d(9),units='1')
   call construct_var1d('meantbisccp',    d3, d2, isccp%meantb,v1d(10),units='K')
   call construct_var1d('meantbclrisccp', d3, d2, isccp%meantbclr,v1d(11),units='K')
   call construct_var1d('cltmodis', d3, d2, modis%Cloud_Fraction_Total_Mean,v1d(12),units='%')
   call construct_var1d('clwmodis', d3, d2, modis%Cloud_Fraction_Water_Mean,v1d(13),units='%')
   call construct_var1d('climodis', d3, d2, modis%Cloud_Fraction_Ice_Mean,  v1d(14),units='%')
   call construct_var1d('clhmodis', d3, d2, modis%Cloud_Fraction_High_Mean,v1d(15),units='%')
   call construct_var1d('clmmodis', d3, d2, modis%Cloud_Fraction_Mid_Mean,v1d(16),units='%')
   call construct_var1d('cllmodis', d3, d2, modis%Cloud_Fraction_Low_Mean,  v1d(17),units='%')
   call construct_var1d('tautmodis', d3, d2, modis%Optical_Thickness_Total_Mean,v1d(18),units='1')
   call construct_var1d('tauwmodis', d3, d2, modis%Optical_Thickness_Water_Mean,v1d(19),units='1')
   call construct_var1d('tauimodis', d3, d2, modis%Optical_Thickness_Ice_Mean,v1d(20),units='1')
   call construct_var1d('tautlogmodis', d3, d2, modis%Optical_Thickness_Total_LogMean,v1d(21),units='1')
   call construct_var1d('tauwlogmodis', d3, d2, modis%Optical_Thickness_Water_LogMean,v1d(22),units='1')
   call construct_var1d('tauilogmodis', d3, d2, modis%Optical_Thickness_Ice_LogMean,v1d(23),units='1')
   call construct_var1d('reffclwmodis', d3, d2, modis%Cloud_Particle_Size_Water_Mean,v1d(24),units='m')
   call construct_var1d('reffclimodis', d3, d2, modis%Cloud_Particle_Size_Ice_Mean,  v1d(25),units='m')
   call construct_var1d('pctmodis', d3, d2, modis%Cloud_Top_Pressure_Total_Mean, v1d(26),units='Pa')
   call construct_var1d('lwpmodis', d3, d2, modis%Liquid_Water_Path_Mean, v1d(27),units='kg m-2')
   call construct_var1d('iwpmodis', d3, d2, modis%Ice_Water_Path_Mean,    v1d(28),units='kg m-2')
   ! 2D variables
   d4 = (/lon_axid,lat_axid,height_axid,time_axid/)
   d3 = (/Nlon,Nlat,Nlvgrid/)
   call construct_var2d('clcalipso',  d4, d3, stlidar%lidarcld,v2d(1),units='%')
   call construct_var2d('clcalipso2', d4, d3, stradar%lidar_only_freq_cloud,v2d(2),units='%')
   d4 = (/lon_axid,lat_axid,height_mlev_axid,time_axid/)
   d3 = (/Nlon,Nlat,Nlevels/)
   call construct_var2d('lidarBetaMol532', d4, d3, sglidar%beta_mol,v2d(3),units='m-1 sr-1')
   d4 = (/lon_axid,lat_axid,column_axid,time_axid/)
   d3 = (/Nlon,Nlat,Ncolumns/)
   call construct_var2d('boxtauisccp',  d4, d3, isccp%boxtau,v2d(4),units='1')
   call construct_var2d('boxptopisccp', d4, d3, isccp%boxptop,v2d(5),units='Pa')
   d4 = (/lon_axid,lat_axid,sza_axid,time_axid/)
   d3 = (/Nlon,Nlat,PARASOL_NREFL/)
   call construct_var2d('parasolRefl', d4, d3, stlidar%parasolrefl,v2d(6),units='1')
#ifdef RTTOV 
   d4 = (/lon_axid,lat_axid,channel_axid,time_axid/) 
   d3 = (/Nlon,Nlat,Nchannels/) 
   call construct_var2d('tbrttov', d4, d3, rttov%tbs,v2d(7),units='K') 
#endif

   ! 3D variables
   d5 = (/lon_axid,lat_axid,column_axid,height_mlev_axid,time_axid/)
   d4 = (/Nlon,Nlat,Ncolumns,Nlevels/)
   call construct_var3d('dbze94', d5, d4, sgradar%Ze_tot,v3d(1),units='1')
   call construct_var3d('atb532', d5, d4, sglidar%beta_tot,v3d(2),units='m-1 sr-1')
   call construct_var3d('fracout', d5, d4, sg%frac_out,v3d(3),units='1')
   d5 = (/lon_axid,lat_axid,dbze_axid,height_axid,time_axid/)
   d4 = (/Nlon,Nlat,DBZE_BINS,Nlvgrid/)
   call construct_var3d('cfadDbze94', d5, d4, stradar%cfad_ze,v3d(4),units='1')
   d5 = (/lon_axid,lat_axid,sratio_axid,height_axid,time_axid/)
   d4 = (/Nlon,Nlat,SR_BINS,Nlvgrid/)
   call construct_var3d('cfadLidarsr532', d5, d4, stlidar%cfad_sr,v3d(5),units='1')
   d5 = (/lon_axid,lat_axid,tau_axid,pressure2_axid,time_axid/)
   d4 = (/Nlon,Nlat,7,7/)
   call construct_var3d('clisccp', d5, d4, isccp%fq_isccp,v3d(6),units='%')
   call construct_var3d('clmodis', d5, d4, modis%Optical_Thickness_vs_Cloud_Top_Pressure, v3d(7), units='%')
!    call construct_var3d('clmodis',                                                   &
!                         (/lon_axid, lat_axid, modis_tau_axid, modis_p_axid, time_axid/), &
!                         (/Nlon, Nlat, numModisTauBins, numModisPressureBins/), & 
!                         modis%Optical_Thickness_vs_Cloud_Top_Pressure, v3d(7), units='%')
   d5 = (/lon_axid,lat_axid,tau_axid,MISR_CTH_axid,time_axid/)
   d4 = (/Nlon,Nlat,7,MISR_N_CTH/)
   call construct_var3d('clMISR', d5, d4, misr%fq_MISR,v3d(8),units='%')
      
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Find list of outputs to be written
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   do i=1,N_OUT_LIST
     lfound = .false.
     if (trim(cfg%out_list(i)) /= '') then
        do j=1,n1d
          if (trim(v1d(j)%name) == trim(cfg%out_list(i))) then
            lout1d(j) = .true.
            lfound = .true.
            exit
          endif
        enddo
        if (.not.lfound) then
          do j=1,n2d
            if (trim(v2d(j)%name) == trim(cfg%out_list(i))) then
                lout2d(j) = .true.
                lfound = .true.
                exit
            endif
          enddo
        endif
        if (.not.lfound) then
          do j=1,n3d
            if (trim(v3d(j)%name) == trim(cfg%out_list(i))) then
                lout3d(j) = .true.
                lfound = .true.
                exit
            endif
          enddo
        endif
     endif
   enddo
   
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Define variables. Fill in dimensions table first if needed
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! 1D variables
   do i=1,n1d
     if (lout1d(i)) var1d_id(i) = cmor_variable(table=table, table_entry=v1d(i)%name, units=v1d(i)%units, &
                                 axis_ids=v1d(i)%dimsid, missing_value=R_UNDEF)
   enddo
   ! 2D variables
   do i=1,n2d
     if (lout2d(i)) var2d_id(i) = cmor_variable(table=table, table_entry=v2d(i)%name, units=v2d(i)%units, &
                                 axis_ids=v2d(i)%dimsid, missing_value=R_UNDEF)
   enddo
   ! 3D variables
   do i=1,n3d
     if (lout3d(i)) var3d_id(i) = cmor_variable(table=table, table_entry=v3d(i)%name, units=v3d(i)%units, &
                                  axis_ids=v3d(i)%dimsid, missing_value=R_UNDEF)
   enddo
   
   
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Write variables to file
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! 1D variables (2D output)
   do i=1,n1d
      if (lout1d(i)) then
        allocate(y2(v1d(i)%dimssz(1),v1d(i)%dimssz(2)))
        call map_point_to_ll(Nlon,Nlat,geomode,x1=v1d(i)%pntr,y2=y2) ! Regridding
        error_flag = cmor_write(var_id=var1d_id(i), data=y2, &
                           ntimes_passed=1,time_vals=(/gb%time/),time_bnds=tbnds)
        if (error_flag < 0) then
           print *,  trim(pro_name)//': Error writing '//trim(v1d(i)%name)
           stop
        endif
        deallocate(y2)
      endif
   enddo
   ! 2D variables (3D output)
   do i=1,n2d
      if (lout2d(i)) then
        allocate(y3(v2d(i)%dimssz(1),v2d(i)%dimssz(2),v2d(i)%dimssz(3)))
        call map_point_to_ll(Nlon,Nlat,geomode,x2=v2d(i)%pntr,y3=y3) ! Regridding
        error_flag = cmor_write(var_id=var2d_id(i), data=y3, &
                           ntimes_passed=1,time_vals=(/gb%time/),time_bnds=tbnds)
        if (error_flag < 0) then
           print *,  trim(pro_name)//': Error writing '//trim(v2d(i)%name)
           stop
        endif
        deallocate(y3)
      endif
   enddo
   ! 3D variables (4D output)
   do i=1,n3d
      if (lout3d(i)) then
        allocate(y4(v3d(i)%dimssz(1),v3d(i)%dimssz(2),v3d(i)%dimssz(3),v3d(i)%dimssz(4)))
        call map_point_to_ll(Nlon,Nlat,geomode,x3=v3d(i)%pntr,y4=y4) ! Regridding
        error_flag = cmor_write(var_id=var3d_id(i), data=y4, &
                           ntimes_passed=1,time_vals=(/gb%time/),time_bnds=tbnds)
        if (error_flag < 0) then
           print *,  trim(pro_name)//': Error writing '//trim(v3d(i)%name)
           stop
        endif
        deallocate(y4)
      endif
   enddo
   
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Close files
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   error_flag = cmor_close()
   
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   ! Deallocate memory
   !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   deallocate(column_ax,dbze_ax,channel_ax,dbze_bounds,sratio_bounds, &
             vgrid_bounds,mgrid_bounds,lon_bounds,lat_bounds)
   
  END SUBROUTINE NC_WRITE_COSP_2D
#endif

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!--------------- SUBROUTINE READ_COSP_OUTPUT_NL -------------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 SUBROUTINE READ_COSP_OUTPUT_NL(cosp_nl,cfg)
  character(len=*),intent(in) :: cosp_nl
  type(cosp_config),intent(out) :: cfg
  ! Local variables
  integer :: i
  logical :: Lradar_sim,Llidar_sim,Lisccp_sim,Lmodis_sim,Lmisr_sim,Lrttov_sim, &
             Lalbisccp,Latb532,Lboxptopisccp,Lboxtauisccp,LcfadDbze94, &
             LcfadLidarsr532,Lclcalipso2,Lclcalipso,Lclhcalipso,Lclisccp,Lcllcalipso, &
             Lclmcalipso,Lcltcalipso,Lcltlidarradar,Lpctisccp,Ldbze94,Ltauisccp,Lcltisccp, &
             Ltoffset,LparasolRefl,LclMISR,Lmeantbisccp,Lmeantbclrisccp, &
             Lfracout,LlidarBetaMol532,Ltbrttov, &
             Lcltmodis,Lclwmodis,Lclimodis,Lclhmodis,Lclmmodis,Lcllmodis,Ltautmodis,Ltauwmodis,Ltauimodis,Ltautlogmodis, &
             Ltauwlogmodis,Ltauilogmodis,Lreffclwmodis,Lreffclimodis,Lpctmodis,Llwpmodis, &
             Liwpmodis,Lclmodis

  namelist/COSP_OUTPUT/Lradar_sim,Llidar_sim,Lisccp_sim,Lmodis_sim,Lmisr_sim,Lrttov_sim, &
             Lalbisccp,Latb532,Lboxptopisccp,Lboxtauisccp,LcfadDbze94, &
             LcfadLidarsr532,Lclcalipso2,Lclcalipso,Lclhcalipso,Lclisccp, &
             Lcllcalipso,Lclmcalipso,Lcltcalipso,Lcltlidarradar,Lpctisccp,Ldbze94,Ltauisccp, &
             Lcltisccp,Ltoffset,LparasolRefl,LclMISR,Lmeantbisccp,Lmeantbclrisccp, &
             Lfracout,LlidarBetaMol532,Ltbrttov, &
             Lcltmodis,Lclwmodis,Lclimodis,Lclhmodis,Lclmmodis,Lcllmodis,Ltautmodis,Ltauwmodis,Ltauimodis,Ltautlogmodis, &
             Ltauwlogmodis,Ltauilogmodis,Lreffclwmodis,Lreffclimodis,Lpctmodis,Llwpmodis, &
             Liwpmodis,Lclmodis
#ifdef COSP_GFDL
  integer :: unit, io, ierr, logunit
#endif

  do i=1,N_OUT_LIST
    cfg%out_list(i)=''
  enddo
#ifdef COSP_GFDL
!---------------------------------------------------------------------
!    read namelist.
#ifdef INTERNAL_FILE_NML
   read (input_nml_file, nml=cosp_output, iostat=io)
   ierr = check_nml_error(io,"cosp_output")
#else
!---------------------------------------------------------------------
    if ( file_exist('input.nml')) then
     unit =  open_namelist_file ()
     ierr=1; do while (ierr /= 0)
     read  (unit, nml=cosp_output, iostat=io, end=10)
     ierr = check_nml_error(io,'cosp_output')
     enddo
10      call close_file (unit)
   endif
#endif
!---------------------------------------------------------------------
!    write namelist to logfile.
!---------------------------------------------------------------------
     call write_version_number(version, tagname)
     logunit = stdlog()
     if (mpp_pe() == mpp_root_pe() )    &
                        write (logunit, nml=cosp_output)


#else
  open(10,file=cosp_nl,status='old')
  read(10,nml=cosp_output)
  close(10)
#endif
  
  ! Deal with dependencies
  if (.not.Lradar_sim) then
    LcfadDbze94   = .false.
    Lclcalipso2    = .false.
    Lcltlidarradar = .false. ! Needs radar & lidar
    Ldbze94        = .false.
    Lclcalipso2    = .false. ! Needs radar & lidar
  endif
  if (.not.Llidar_sim) then
    Latb532 = .false.
    LcfadLidarsr532 = .false.
    Lclcalipso2      = .false. ! Needs radar & lidar
    Lclcalipso       = .false.
    Lclhcalipso      = .false.
    Lcllcalipso      = .false.
    Lclmcalipso      = .false.
    Lcltcalipso      = .false.
    Lcltlidarradar   = .false.
    LparasolRefl    = .false.
    LlidarBetaMol532 = .false.
    Lcltlidarradar = .false. ! Needs radar & lidar
  endif
  if (.not.Lisccp_sim) then
    Lalbisccp       = .false.
    Lboxptopisccp   = .false.
    Lboxtauisccp    = .false.
    Lclisccp        = .false.
    Lpctisccp       = .false.
    Ltauisccp       = .false.
    Lcltisccp       = .false.
    Lmeantbisccp    = .false.
    Lmeantbclrisccp = .false.
  endif
  if (.not.Lmisr_sim) then
    LclMISR = .false.
  endif
  if (.not.Lrttov_sim) then
    Ltbrttov = .false.
  endif
  if ((.not.Lradar_sim).and.(.not.Llidar_sim).and. &
      (.not.Lisccp_sim).and.(.not.Lmisr_sim)) then
    Lfracout = .false.
  endif
  if (.not.Lmodis_sim) then
    Lcltmodis=.false.
    Lclwmodis=.false.
    Lclimodis=.false.
    Lclhmodis=.false.
    Lclmmodis=.false.
    Lcllmodis=.false.
    Ltautmodis=.false.
    Ltauwmodis=.false.
    Ltauimodis=.false.
    Ltautlogmodis=.false.
    Ltauwlogmodis=.false.
    Ltauilogmodis=.false.
    Lreffclwmodis=.false.
    Lreffclimodis=.false.
    Lpctmodis=.false.
    Llwpmodis=.false.
    Liwpmodis=.false.
    Lclmodis=.false.
  endif
  if (Lmodis_sim) Lisccp_sim = .true.
  
  cfg%Lstats = .false.
  if ((Lradar_sim).or.(Llidar_sim).or.(Lisccp_sim)) cfg%Lstats = .true.
  
  ! Copy instrument flags to cfg structure
  cfg%Lradar_sim = Lradar_sim
  cfg%Llidar_sim = Llidar_sim
  cfg%Lisccp_sim = Lisccp_sim
  cfg%Lmodis_sim = Lmodis_sim
  cfg%Lmisr_sim  = Lmisr_sim
  cfg%Lrttov_sim = Lrttov_sim
  
  ! Flag to control output to file
  cfg%Lwrite_output = .false.
  if (cfg%Lstats.or.cfg%Lmisr_sim.or.cfg%Lrttov_sim) then
    cfg%Lwrite_output = .true.
  endif
  
  ! Output diagnostics
  i = 1
  if (Lalbisccp)        cfg%out_list(i) = 'albisccp'
  i = i+1
  if (Latb532)          cfg%out_list(i) = 'atb532'
  i = i+1
  if (Lboxptopisccp)    cfg%out_list(i) = 'boxptopisccp'
  i = i+1
  if (Lboxtauisccp)     cfg%out_list(i) = 'boxtauisccp'
  i = i+1
  if (LcfadDbze94)      cfg%out_list(i) = 'cfadDbze94'
  i = i+1
  if (LcfadLidarsr532)  cfg%out_list(i) = 'cfadLidarsr532'
  i = i+1
  if (Lclcalipso2)      cfg%out_list(i) = 'clcalipso2'
  i = i+1
  if (Lclcalipso)       cfg%out_list(i) = 'clcalipso'
  i = i+1
  if (Lclhcalipso)      cfg%out_list(i) = 'clhcalipso'
  i = i+1
  if (Lclisccp)         cfg%out_list(i) = 'clisccp'
  i = i+1
  if (Lcllcalipso)      cfg%out_list(i) = 'cllcalipso'
  i = i+1
  if (Lclmcalipso)      cfg%out_list(i) = 'clmcalipso'
  i = i+1
  if (Lcltcalipso)      cfg%out_list(i) = 'cltcalipso'
  i = i+1
  if (Lcltlidarradar)   cfg%out_list(i) = 'cltlidarradar'
  i = i+1
  if (Lpctisccp)        cfg%out_list(i) = 'pctisccp'
  i = i+1
  if (Ldbze94)          cfg%out_list(i) = 'dbze94'
  i = i+1
  if (Ltauisccp)        cfg%out_list(i) = 'tauisccp'
  i = i+1
  if (Lcltisccp)        cfg%out_list(i) = 'cltisccp'
  i = i+1
  if (Ltoffset)         cfg%out_list(i) = 'toffset'
  i = i+1
  if (LparasolRefl)     cfg%out_list(i) = 'parasolRefl'
  i = i+1
  if (LclMISR)          cfg%out_list(i) = 'clMISR'
  i = i+1
  if (Lmeantbisccp)     cfg%out_list(i) = 'meantbisccp'
  i = i+1
  if (Lmeantbclrisccp)  cfg%out_list(i) = 'meantbclrisccp'
  i = i+1
  if (Lfracout)         cfg%out_list(i) = 'fracout'
  i = i+1
  if (LlidarBetaMol532) cfg%out_list(i) = 'lidarBetaMol532'
  i = i+1
  if (Ltbrttov)         cfg%out_list(i) = 'tbrttov'
  i = i+1
  if (Lcltmodis)        cfg%out_list(i) = 'cltmodis'
  i = i+1
  if (Lclwmodis)        cfg%out_list(i) = 'clwmodis'
  i = i+1
  if (Lclimodis)        cfg%out_list(i) = 'climodis'
  i = i+1
  if (Lclhmodis)        cfg%out_list(i) = 'clhmodis'
  i = i+1
  if (Lclmmodis)        cfg%out_list(i) = 'clmmodis'
  i = i+1
  if (Lcllmodis)        cfg%out_list(i) = 'cllmodis'
  i = i+1
  if (Ltautmodis)       cfg%out_list(i) = 'tautmodis'
  i = i+1
  if (Ltauwmodis)       cfg%out_list(i) = 'tauwmodis'
  i = i+1
  if (Ltauimodis)       cfg%out_list(i) = 'tauimodis'
  i = i+1
  if (Ltautlogmodis)    cfg%out_list(i) = 'tautlogmodis'
  i = i+1
  if (Ltauwlogmodis)    cfg%out_list(i) = 'tauwlogmodis'
  i = i+1
  if (Ltauilogmodis)    cfg%out_list(i) = 'tauilogmodis'
  i = i+1
  if (Lreffclwmodis)    cfg%out_list(i) = 'reffclwmodis'
  i = i+1
  if (Lreffclimodis)    cfg%out_list(i) = 'reffclimodis'
  i = i+1
  if (Lpctmodis)        cfg%out_list(i) = 'pctmodis'
  i = i+1
  if (Llwpmodis)        cfg%out_list(i) = 'lwpmodis'
  i = i+1
  if (Liwpmodis)        cfg%out_list(i) = 'iwpmodis'
  i = i+1
  if (Lclmodis)         cfg%out_list(i) = 'clmodis'
    
  if (i /= N_OUT_LIST) then
#ifdef COSP_GFDL
       call error_mesg ('cosp_io:read_cosp_output_nl',  &
              'COSP_IO: wrong number of output diagnostics', &
                                                            FATAL)
#else
     print *, 'COSP_IO: wrong number of output diagnostics'
     stop
#endif
  endif

  ! Copy diagnostic flags to cfg structure
  ! ISCCP simulator  
  cfg%Lalbisccp = Lalbisccp
  cfg%Latb532 = Latb532
  cfg%Lboxptopisccp = Lboxptopisccp
  cfg%Lboxtauisccp = Lboxtauisccp
  cfg%Lmeantbisccp = Lmeantbisccp
  cfg%Lmeantbclrisccp = Lmeantbclrisccp
  cfg%Lclisccp = Lclisccp
  cfg%Lpctisccp = Lpctisccp
  cfg%Ltauisccp = Ltauisccp
  cfg%Lcltisccp = Lcltisccp
  ! CloudSat simulator  
  cfg%Ldbze94 = Ldbze94
  cfg%LcfadDbze94 = LcfadDbze94
  ! CALIPSO/PARASOL simulator  
  cfg%LcfadLidarsr532 = LcfadLidarsr532
  cfg%Lclcalipso2 = Lclcalipso2
  cfg%Lclcalipso = Lclcalipso
  cfg%Lclhcalipso = Lclhcalipso
  cfg%Lcllcalipso = Lcllcalipso
  cfg%Lclmcalipso = Lclmcalipso
  cfg%Lcltcalipso = Lcltcalipso
  cfg%Lcltlidarradar = Lcltlidarradar
  cfg%LparasolRefl = LparasolRefl
  ! MISR simulator  
  cfg%LclMISR = LclMISR
  ! Other
  cfg%Ltoffset = Ltoffset
  cfg%Lfracout = Lfracout
  cfg%LlidarBetaMol532 = LlidarBetaMol532
  ! RTTOV
  cfg%Ltbrttov = Ltbrttov
  ! MODIS simulator  
  cfg%Lcltmodis=Lcltmodis
  cfg%Lclwmodis=Lclwmodis
  cfg%Lclimodis=Lclimodis
  cfg%Lclhmodis=Lclhmodis
  cfg%Lclmmodis=Lclmmodis
  cfg%Lcllmodis=Lcllmodis
  cfg%Ltautmodis=Ltautmodis
  cfg%Ltauwmodis=Ltauwmodis
  cfg%Ltauimodis=Ltauimodis
  cfg%Ltautlogmodis=Ltautlogmodis
  cfg%Ltauwlogmodis=Ltauwlogmodis
  cfg%Ltauilogmodis=Ltauilogmodis
  cfg%Lreffclwmodis=Lreffclwmodis
  cfg%Lreffclimodis=Lreffclimodis
  cfg%Lpctmodis=Lpctmodis
  cfg%Llwpmodis=Llwpmodis
  cfg%Liwpmodis=Liwpmodis
  cfg%Lclmodis=Lclmodis
 END SUBROUTINE READ_COSP_OUTPUT_NL

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!--------------- SUBROUTINE ERROR_CONTROL ------------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE COSP_ERROR(routine_name,message,errcode) 
    character(len = *), intent(in) :: routine_name
    character(len = *), intent(in) :: message
    integer,optional :: errcode
    
    write(6, *) " ********** Failure in ", trim(routine_name)
    write(6, *) " ********** ", trim(message)
    if (present(errcode)) write(6, *) " ********** errcode: ", errcode
    flush(6)
    stop
  END SUBROUTINE COSP_ERROR
    
END MODULE MOD_COSP_IO

                 module strat_clouds_W_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  sak
! </REVIEWER>
! <OVERVIEW>
!    strat_clouds_W_mod obtains the cloud specification variables
!    for the klein strat cloud parameterization from cloud_rad_mod
!    and makes them available to the radiation package.
! </OVERVIEW>
! <DESCRIPTION>
! </DESCRIPTION>

!   shared modules:

use constants_mod,          only: radian
use time_manager_mod,       only: time_type, time_manager_init
use mpp_mod,                only: input_nml_file
use fms_mod,                only: open_namelist_file, mpp_pe, &
                                  mpp_root_pe, stdlog,  fms_init, &
                                  write_version_number, file_exist, &
                                  check_nml_error, error_mesg,   &
                                  FATAL, close_file

!   shared radiation package modules:

use rad_utilities_mod,      only: rad_utilities_init, &
                                  cldrad_properties_type,  &
                                  cld_specification_type, &
                                  solar_spectrum_type, &
                                  microphysics_type, Cldrad_control
use esfsw_parameters_mod,   only: Solar_spect, esfsw_parameters_init

!   cloud parameterization module:

use cloud_rad_mod,          only: cloud_rad_init, cloud_summary3, &
                                  lw_emissivity, sw_optical_properties, &
                                  snow_and_rain

!    stochastic cloud generator module
use random_numbers_mod,     only: randomNumberStream,           &
                                  initializeRandomNumberStream, &
                                  constructSeed
use cloud_generator_mod,    only: cloud_generator_init, &
                                  generate_stochastic_clouds,&
                                  cloud_generator_end
!--------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!    strat_clouds_W_mod obtains the cloud specification variables
!    for the klein strat cloud parameterization from cloud_rad_mod
!    and makes them available to the radiation package.
!--------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module --------------------------

character(len=128)  :: version =  '$Id: strat_clouds_W.F90,v 19.0 2012/01/06 20:24:43 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!---------------------------------------------------------------------
!-------  interfaces --------

public          &
          strat_clouds_W_init, strat_clouds_amt, obtain_bulk_lw_strat, &
          obtain_bulk_sw_strat, strat_clouds_W_end

!---------------------------------------------------------------------
!-------- namelist  ---------

logical   :: do_stochastic_clouds = .false.
integer   :: seedperm = 0
logical   :: one_generator_call = .false.


namelist /strat_clouds_W_nml /                      &
                                do_stochastic_clouds, seedperm, &
                                one_generator_call


!----------------------------------------------------------------------
!----  public data -------


!----------------------------------------------------------------------
!----  private data -------


logical                               :: module_is_initialized = .false.  ! module is initialized ?
real,    dimension(:,:),    allocatable :: lats, lons  ! lats and lons in this processor window (degrees)
!----------------------------------------------------------------------
!----------------------------------------------------------------------



                              contains 



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!#####################################################################
! <SUBROUTINE NAME="strat_clouds_W_init">
!  <OVERVIEW>
!    strat_clouds_W_init is the constructor for strat_clouds_W_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    strat_clouds_W_init is the constructor for strat_clouds_W_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call strat_clouds_W_init
!  </TEMPLATE>
! </SUBROUTINE>
!  
subroutine strat_clouds_W_init(latb, lonb)
  real, dimension(:,:), intent( in) :: latb, lonb
!---------------------------------------------------------------------
!    strat_clouds_W_init is the constructor for strat_clouds_W_mod.
!---------------------------------------------------------------------
!       lonb      2d array of model longitudes on cell corners [ radians ]
!       latb      2d array of model latitudes at cell corners [radians]


!----------------------------------------------------------------------
!   local variables:

      integer   ::   unit, ierr, io, logunit

!--------------------------------------------------------------------
!   local variables:
!
!      unit     io unit for reading nml file and writing logfile
!      ierr     error code
!      io       error status returned from io operation  
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return

!---------------------------------------------------------------------
!    Save copies of lat and lon values for this window
!---------------------------------------------------------------------
      allocate(lats(size(latb,1),size(latb,2)), lons(size(lonb,1),size(lonb,2)))
      lats(:,:) = latb(:,:) * radian
      lons(:,:) = lonb(:,:) * radian
!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call time_manager_init
      call rad_utilities_init
      call esfsw_parameters_init
      call cloud_rad_init

!---------------------------------------------------------------------
!    read namelist.         
!---------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
   read (input_nml_file, nml=strat_clouds_W_nml, iostat=io)
   ierr = check_nml_error(io,'strat_clouds_W_nml')
#else
      if (file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read (unit, nml=strat_clouds_W_nml, iostat=io, end=10) 
        ierr = check_nml_error (io, 'strat_clouds_W_nml')
        enddo                       
10      call close_file (unit)      
      endif                         
#endif
                                    
!----------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                 write (logunit, nml=strat_clouds_W_nml)

!--------------------------------------------------------------------
!    save the flags indicating whether stochastic clouds are to be
!    used.
!--------------------------------------------------------------------
      Cldrad_control%do_stochastic_clouds = do_stochastic_clouds
      Cldrad_control%do_stochastic_clouds_iz = .true.
      if (do_stochastic_clouds) &
                 call cloud_generator_init

!---------------------------------------------------------------------
!    mark the module as initialized.
!---------------------------------------------------------------------
      module_is_initialized = .true.

!----------------------------------------------------------------------

end subroutine strat_clouds_W_init



!######################################################################
! <SUBROUTINE NAME="strat_clouds_amt">
!  <OVERVIEW>
!    strat_clouds_amt defines the location, amount (cloud fraction), 
!    and number of clouds present on the model grid, in addition to
!    liquid and ice-water paths, cloud thickness, and effective drop 
!    and crystal sizes. 
!  </OVERVIEW>
!  <DESCRIPTION>
!    strat_clouds_amt defines the location, amount (cloud fraction), 
!    and number of clouds present on the model grid, in addition to
!    liquid and ice-water paths, cloud thickness, and effective drop 
!    and crystal sizes. if a microphysically-based cloud parameter-
!    ization is being used, particle sizes and concentrations are also
!    provided.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call strat_clouds_amt (is, ie, js, je, Rad_time, pflux, press, 
!                          temp, qv, land, Cld_spec, Lsc_microphys)
!  </TEMPLATE>
!  <IN NAME="is, ie, js, je" TYPE="integer">
!   starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="Rad_time" TYPE="time_type">
!   time at which radiation calculation is to apply
!  </IN>
!  <IN NAME="pflux" TYPE="real">
!   pressure values at flux levels (average of pressure values at
!   model grid points
!  </IN>
!  <IN NAME="press" TYPE="real">
!   pressure values at model grid points. surface 
!                   pressure is stored at index value nlev+1
!  </IN>
!  <IN NAME="temp" TYPE="real">
!    temperature at model levels (1:nlev), to be used
!                   in cloud calculations
!  </IN>
!  <IN NAME="qv" TYPE="real">
!    water vapor specific humidity at model levels (1:nlev), to be used
!                   in cloud calculations
!  </IN>
!  <IN NAME="land" TYPE="real">
!   fraction of grid box covered by land
!  </IN>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
!   cld_specification_type variable containing the 
!                   cloud specification input fields needed by the 
!                   radiation package
!  </INOUT>
!  <INOUT NAME="Lsc_microphys" TYPE="microphys_type">
!   microphysics_type variable containing the size,
!                   concentration and fraction of the four condensate 
!                   types (cloud drop, cloud ice, rain, snow) in the 
!                   grid box, present when microphysically-based
!                   cloud radiation properties are desired.
!  </INOUT>
! </SUBROUTINE>
!
subroutine strat_clouds_amt (is, ie, js, je, Rad_time, pflux, &
                             press, temp, qv, &
                             land, Cld_spec, Lsc_microphys)

!---------------------------------------------------------------------
!    strat_clouds_amt defines the location, amount (cloud fraction), 
!    and number of clouds present on the model grid, in addition to
!    liquid and ice-water paths, cloud thickness, and effective drop 
!    and crystal sizes. if a microphysically-based cloud parameter-
!    ization is being used, particle sizes and concentrations are also
!    provided.
!----------------------------------------------------------------------

integer,                      intent(in)        :: is, ie, js, je
type(time_type),              intent(in)        :: Rad_time
real,    dimension(:,:,:),    intent(in)        :: pflux, press, temp, qv
real,    dimension(:,:),      intent(in)        :: land
type(cld_specification_type), intent(inout)     :: Cld_spec      
type(microphysics_type),      intent(inout)     :: Lsc_microphys

!----------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      Rad_time     time type variable containing radiation time
!      pflux        average of pressure at adjacent model levels
!                   [ (kg /( m s^2) ] 
!      press        pressure at model levels (1:nlev), surface 
!                   pressure is stored at index value nlev+1
!                   [ (kg /( m s^2) ]
!      temp         temperature at model levels (1:nlev), to be used
!                   in cloud calculations
!                   [ deg K ]
!      qv           water vapor specific humidity at model levels
!                   (1:nlev), to be used in cloud calculations
!      land         fraction of grid box covered by land
!                   [ non-dimensional ]
!
!   intent(inout), optional variables:
!
!      Cld_spec     cld_specification_type variable containing the 
!                   cloud specification input fields needed by the 
!                   radiation package
!
!               the following elements of Cld_spec are defined here:
!
!                  %cmxolw  fraction of maximally overlapped clouds
!                           seen by the longwave radiation 
!                           [ dimensionless ]
!                  %crndlw  fraction of randomly overlapped clouds
!                           seen by the longwave radiation 
!                           [ dimensionless ]
!                  %camtsw  cloud fraction seen by the shortwave
!                           radiation; the sum of the maximally
!                           overlapped and randomly overlapped 
!                           longwave cloud fractions  [ dimensionless ]
!                  %nmxolw  number of maximally overlapped longwave 
!                           clouds in each grid column.
!                  %nrndlw  number of randomly overlapped longwave 
!                           clouds in each grid column.
!                  %ncldsw  number of clouds seen by the shortwave
!                           radiation in each grid column.
!                  %cloud_thickness
!                           number of model layers over which the cloud
!                           in this grid box extends
!                  %lwp     liquid water path 
!                           [ kg / m^2 ]
!                  %iwp     ice water path
!                           [ kg / m^2 ]
!                  %reff_liq
!                           effective drop radius [ microns ]
!                  %reff_ice
!                           effective ice particle size [ microns ]
!
!      Lsc_microphys
!                   microphysics_type variable containing the size,
!                   concentration and fraction of the four condensate 
!                   types (cloud drop, cloud ice, rain, snow) in the 
!                   grid box, present when microphysically-based
!                   cloud radiation properties are desired.
!
!               the following components of this variable are output 
!               from this routine when microphysically-based properties
!               are desired:
!
!                  %conc_ice  ice particle concentration [ g /m^3 ]
!                  %conc_drop cloud droplet concentration [ g /m^3 ]
!                  %size_ice  ice particle effective diameter 
!                  [ microns ]
!                  %size_drop cloud droplet effective diameter
!                  [ microns ]
!
!----------------------------------------------------------------------

!-------------------------------------------------------------------
!    local variables

      real, dimension (size(pflux,1), size(pflux,2),  &
                       size(pflux,3)-1) ::      cldamt

      real, dimension (size(pflux,1), size(pflux,2),  &
                       size(pflux,3)-1, Cldrad_control%nlwcldb) :: &
                         ql_stoch_lw2, qi_stoch_lw2, qa_stoch_lw2, &
                         qn_stoch_lw2, qni_stoch_lw2

      real, dimension (size(pflux,1), size(pflux,2),  &
                       size(pflux,3)-1, Solar_spect%nbands) :: &
                         ql_stoch_sw2, qi_stoch_sw2, qa_stoch_sw2, &
                         qn_stoch_sw2, qni_stoch_sw2

      real, dimension (size(pflux,1), size(pflux,2),                 &
                       size(pflux,3)-1,                              &
                       Cldrad_control%nlwcldb + Solar_spect%nbands), &
             target :: ql_stoch, qi_stoch, qa_stoch, qn_stoch, qni_stoch
 
      real, dimension(:, :, :, :), pointer :: &
                  ql_stoch_lw, qi_stoch_lw, qa_stoch_lw, qn_stoch_lw, &
                  ql_stoch_sw, qi_stoch_sw, qa_stoch_sw, qn_stoch_sw, &
                  qni_stoch_lw, qni_stoch_sw
      
!      integer, dimension(size(Cld_spec%cld_thickness_lw_band, 1), &
!                         size(Cld_spec%cld_thickness_lw_band, 2), &
!                         size(Cld_spec%cld_thickness_lw_band, 3), &
      integer, dimension(size(temp, 1), size(temp, 2), size(temp, 3), &
          Cldrad_control%nlwcldb + Solar_spect%nbands) ::         &
                        cld_thickness

      integer, dimension (size(pflux,1), size(pflux,2), &
                          size(pflux,3)-1) ::   ktop, kbtm

      integer, dimension (size(pflux,1), size(pflux,2)) :: &
                                                 ncldlvls

      type(randomNumberStream), &
                dimension(size(pflux,1), size(pflux,2)) :: streams
      integer     ::    kx 
      integer     ::    i, j, k, kc, nb
      real        ::   seedwts(8) = (/3000.,1000.,300.,100.,30.,10.,3.,1./)

!-------------------------------------------------------------------
!    local variables:
!
!       cldamt          cloud fraction, in cloud-space when microphysics
!                       not being used, in model-space when microphysics
!                       is active 
!                       [ dimensionless ]
!       lwp             cloud liquid water path in cloud-space 
!                       [ kg condensate / m^2 ]
!       iwp             cloud ice path, in cloud-space 
!                       [ kg condensate / m^2 ]
!       reff_liq        effective radius for liquid clouds, 
!                       in cloud-space [ microns ]
!       reff_ice        effective particle size for ice clouds 
!                       in cloud-space [ microns ]
!       ktop            index of the model level which is cloud top
!       kbtm            index of the model level which is cloud base
!       ncldlvls        number of layers with cloud in a column
!       kx              number of model layers
!       i,j,k,kc        do-loop indices  
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('strat_clouds_W_mod',   &
             'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!    define the number of model layers.
!---------------------------------------------------------------------
      kx = size (press,3) - 1

!----------------------------------------------------------------------
!    compute the cloud specification properties under the assumption
!    of random cloud overlap.
!----------------------------------------------------------------------
      if (Cldrad_control%do_random_overlap) then

!----------------------------------------------------------------------
!    if microphysically-based radiative properties are needed, call
!    cloud_summary3 with the Lsc_microphys% optional arguments.
!----------------------------------------------------------------------
        if (Cldrad_control%do_pred_cld_microphys .or. &
            Cldrad_control%do_presc_cld_microphys) then

!--------------------------------------------------------------------
!    call cloud_summary3 with the full cloud field, regardless of 
!    whether or not stochastic clouds are active.
!    the full cloud field is assumed random overlap when stochastic
!    clouds are activated.
!--------------------------------------------------------------------
            where (Cld_spec%cloud_area(:,:,:) > 0.0) 
              Cld_spec%cld_thickness(:,:,:) = 1
            end where
          call cloud_summary3 (is, js, land,   &
                               Cldrad_control%using_fu2007, &
                               Cld_spec%cloud_water, &
                               Cld_spec%cloud_ice, Cld_spec%cloud_area,&
                               Cld_spec%cloud_droplet, &       
                               Cld_spec%cloud_ice_num, &
                               press(:,:,1:kx), pflux, temp, ncldlvls, &
                               cldamt, Cld_spec%lwp, Cld_spec%iwp,   &
                               Cld_spec%reff_liq, Cld_spec%reff_ice, &
                               conc_drop= Lsc_microphys%conc_drop, &
                               conc_ice = Lsc_microphys%conc_ice, &
                               size_drop =Lsc_microphys%size_drop,   &
                               size_ice = Lsc_microphys%size_ice, &
                         droplet_number = Lsc_microphys%droplet_number, &
                            ice_number = Lsc_microphys%ice_number )
 

          call snow_and_rain(Cld_spec%cloud_area, press(:,:,1:kx),  &
                             pflux, temp,  cldamt, Cld_spec%snow,  &
                             Cld_spec%rain, Cld_spec%snow_size,  &
                             Cld_spec%rain_size,   &
                             Lsc_microphys%conc_rain,   &
                             Lsc_microphys%conc_snow,   &
                             Lsc_microphys%size_rain,   &
                             Lsc_microphys%size_snow )


          cldamt = MIN (cldamt, 1.0)
          if (.not. Cldrad_control%do_specified_strat_clouds) then
            Cld_spec%ncldsw        = ncldlvls
            Cld_spec%nrndlw        = ncldlvls         
            Cld_spec%camtsw        = cldamt           
            Cld_spec%crndlw        = cldamt
            Lsc_microphys%cldamt   = cldamt            
          endif

!---------------------------------------------------------------------
!    if using stochastic clouds for either sw or lw, Initialize the random number streams, 
!       one per grid cell, with unique and replicable integer based 
!       on grid location and model date/time
!---------------------------------------------------------------------
          if (do_stochastic_clouds) then
            if (Cldrad_control%use_temp_for_seed) then
              do j = 1, size(Cld_spec%cloud_water, 2)
                do i = 1, size(Cld_spec%cloud_water, 1)
                  streams(i, j) =   &
                           initializeRandomNumberStream(  &
                               ishftc(nint(temp(i,j,1)*seedwts),seedperm))

                end do
              end do
             else
            do j = 1, size(Cld_spec%cloud_water, 2)
              do i = 1, size(Cld_spec%cloud_water, 1)
                streams(i, j) =   &
                         initializeRandomNumberStream(  &
                            constructSeed(nint(lons(is + i - 1, js + j - 1)), &
                                          nint(lats(is + i - 1, js + j - 1)), &
                                                    Rad_time, seedperm))
              end do
            end do
           endif

            if (one_generator_call) then
!---------------------------------------------------------------------
!    then generate all the subcolumns at once and divide them into 
!    those needed  for the sw and lw bands.
!    call routine to obtain  band-dependent values of ql, qi and qa. 
!---------------------------------------------------------------------
              call generate_stochastic_clouds (        &
                      streams,                &
                      Cld_spec%cloud_water,   &
                      Cld_spec%cloud_ice,     &
                      Cld_spec%cloud_area,    &
                      Cld_spec%cloud_droplet, &
                      Cld_spec%cloud_ice_num, &
                      pFull = press(:, :, :kx),&
                      pHalf = pflux, &
                      temperature = temp(:, :, :kx),        &
                      qv= qv(:, :, :kx), &
                      cld_thickness = cld_thickness, &
                      ql_stoch = ql_stoch, &
                      qi_stoch = qi_stoch, &
                      qa_stoch = qa_stoch, &
                      qn_stoch = qn_stoch, &
                      qni_stoch = qni_stoch )

          ql_stoch_lw => ql_stoch(:, :, :, 1:Cldrad_control%nlwcldb)
          qi_stoch_lw => qi_stoch(:, :, :, 1:Cldrad_control%nlwcldb)
          qa_stoch_lw => qa_stoch(:, :, :, 1:Cldrad_control%nlwcldb)
          qn_stoch_lw => qn_stoch(:, :, :, 1:Cldrad_control%nlwcldb)
          qni_stoch_lw => qni_stoch(:, :, :, 1:Cldrad_control%nlwcldb)
          Cld_spec%cld_thickness_lw_band = &
                       cld_thickness(:, :, :, 1:Cldrad_control%nlwcldb)

          ql_stoch_sw => ql_stoch(:, :, :, Cldrad_control%nlwcldb +1:)
          qi_stoch_sw => qi_stoch(:, :, :, Cldrad_control%nlwcldb +1:)
          qa_stoch_sw => qa_stoch(:, :, :, Cldrad_control%nlwcldb +1:)
          qn_stoch_sw => qn_stoch(:, :, :, Cldrad_control%nlwcldb +1:)
          qni_stoch_sw => qni_stoch(:, :, :, Cldrad_control%nlwcldb +1:)
          Cld_spec%cld_thickness_sw_band = &
                     cld_thickness(:, :, :, Cldrad_control%nlwcldb +1:)

!---------------------------------------------------------------------
!    call cloud_summary3 for each lw band, using the band-dependent
!    cloud inputs, to obtain band-dependent values of liquid and ice
!    size and concentration.
!---------------------------------------------------------------------
            do nb=1,Cldrad_control%nlwcldb
              call cloud_summary3 (          &
                is, js, land, &
                Cldrad_control%using_fu2007, &
                ql_stoch_lw(:,:,:,nb),&
                qi_stoch_lw(:,:,:,nb), qa_stoch_lw(:,:,:,nb),&
                qn_stoch_lw(:,:,:,nb), &
                qni_stoch_lw(:,:,:,nb),&
                press(:,:,1:kx), pflux, temp, ncldlvls, &
                cldamt, Cld_spec%lwp_lw_band(:,:,:,nb),&
                Cld_spec%iwp_lw_band(:,:,:,nb),   &
                Cld_spec%reff_liq_lw_band(:,:,:,nb), &
                Cld_spec%reff_ice_lw_band(:,:,:,nb), &
                conc_drop= Lsc_microphys%lw_stoch_conc_drop(:,:,:,nb), &
                conc_ice = Lsc_microphys%lw_stoch_conc_ice(:,:,:,nb), &
                size_drop =Lsc_microphys%lw_stoch_size_drop(:,:,:,nb), &
                size_ice = Lsc_microphys%lw_stoch_size_ice(:,:,:,nb), &
       droplet_number = Lsc_microphys%lw_stoch_droplet_number(:,:,:,nb), &
          ice_number =  Lsc_microphys%lw_stoch_ice_number(:,:,:,nb) )
              
              !now that the vertical cloud fraction has been used to
              !properly calculate the in-cloud particle size, rescale
              !the concentrations and cloud amounts to that the cloud
              !amount is unity in any partially cloudy sub-column. 
              !
              !This is necessary so that the radiation code will not
              !do cloud fraction weights of cloudy and clear sky fluxes.
              !
              !The rescaling of the concentrations is necessary so that the
              !total optical depth of the layer is constant.  Note that this
              !works because cloud extinction is linear in the concentration
              Lsc_microphys%lw_stoch_conc_drop(:,:,:,nb) = &
                   Lsc_microphys%lw_stoch_conc_drop(:,:,:,nb) * cldamt(:,:,:)     
              Lsc_microphys%lw_stoch_conc_ice(:,:,:,nb) = &
                   Lsc_microphys%lw_stoch_conc_ice(:,:,:,nb) * cldamt(:,:,:)
              where (cldamt .gt. 0.) cldamt = 1.                  
               
              if (.not. Cldrad_control%do_specified_strat_clouds) then
                Cld_spec%nrndlw_band(:,:,nb) = ncldlvls(:,:)
                Lsc_microphys%lw_stoch_cldamt(:,:,:,nb) = cldamt
              endif
            end do

!---------------------------------------------------------------------
!    call cloud_summary3 for each sw band, using the band-dependent
!    cloud inputs, to obtain band-dependent values of liquid and ice
!    size and concentration.
!---------------------------------------------------------------------
          do nb=1,size(Lsc_microphys%sw_stoch_conc_ice,4)
            call cloud_summary3 (                            &
              is, js, land,  &
              Cldrad_control%using_fu2007, &
              ql_stoch_sw(:,:,:,nb), &
              qi_stoch_sw(:,:,:,nb), qa_stoch_sw(:,:,:,nb),&
              qn_stoch_sw(:,:,:,nb), &
              qni_stoch_sw(:,:,:,nb), &
              press(:,:,1:kx), pflux, temp, ncldlvls, &
              cldamt, Cld_spec%lwp_sw_band(:,:,:,nb), &
              Cld_spec%iwp_sw_band(:,:,:,nb),   &
              Cld_spec%reff_liq_sw_band(:,:,:,nb), &
              Cld_spec%reff_ice_sw_band(:,:,:,nb), &
              conc_drop= Lsc_microphys%sw_stoch_conc_drop(:,:,:,nb), &
              conc_ice = Lsc_microphys%sw_stoch_conc_ice(:,:,:,nb), &
              size_drop =Lsc_microphys%sw_stoch_size_drop(:,:,:,nb), &
              size_ice = Lsc_microphys%sw_stoch_size_ice(:,:,:,nb), &
       droplet_number = Lsc_microphys%sw_stoch_droplet_number(:,:,:,nb), &
         ice_number = Lsc_microphys%sw_stoch_ice_number(:,:,:,nb) )

         !now that the vertical cloud fraction has been used to
         !properly calculate the in-cloud particle size, rescale
         !the concentrations and cloud amounts to that the cloud
         !amount is unity in any partially cloudy sub-column. 
         !
         !This is necessary so that the radiation code will not
         !do cloud fraction weights of cloudy and clear sky fluxes.
         !
         !The rescaling of the concentrations is necessary so that         the
         !total optical depth of the layer is constant.  Note that         this
         !works because cloud extinction is linear in the concentra        tion
            Lsc_microphys%sw_stoch_conc_drop(:,:,:,nb) = &
             Lsc_microphys%sw_stoch_conc_drop(:,:,:,nb) * cldamt(:,:,:)
            Lsc_microphys%sw_stoch_conc_ice(:,:,:,nb) = &
             Lsc_microphys%sw_stoch_conc_ice(:,:,:,nb) * cldamt(:,:,:)
             where (cldamt .gt. 0.) cldamt = 1.

             if (.not. Cldrad_control%do_specified_strat_clouds) then
               Cld_spec%ncldsw_band(:,:,nb) = ncldlvls(:,:)
               Lsc_microphys%sw_stoch_cldamt(:,:,:,nb) = cldamt
             endif
           end do
 
        else  ! (one_call)
!---------------------------------------------------------------------
!    call routine to obtain lw band-dependent values of ql, qi and qa. 
!---------------------------------------------------------------------
            call generate_stochastic_clouds (        &
                     streams,                &
                     Cld_spec%cloud_water,   &
                     Cld_spec%cloud_ice,     &
                     Cld_spec%cloud_area,    &
                     Cld_spec%cloud_droplet, &
                     Cld_spec%cloud_ice_num, &
                     pFull    = press(:, :, :kx),     &
                     pHalf    = pflux,&
                     temperature = temp(:, :, :kx),   &
                     qv = qv(:,:, :kx),   &
                     cld_thickness = Cld_spec%cld_thickness_lw_band, &
                     ql_stoch = ql_stoch_lw2, &
                     qi_stoch = qi_stoch_lw2, &
                     qa_stoch = qa_stoch_lw2, &
                     qn_stoch = qn_stoch_lw2, &
                     qni_stoch = qni_stoch_lw2 ) 

!---------------------------------------------------------------------
!    call routine to obtain sw band-dependent values of ql, qi and qa. 
!---------------------------------------------------------------------
            call generate_stochastic_clouds (        &
                     streams,                &
                     Cld_spec%cloud_water,   &
                     Cld_spec%cloud_ice,     &
                     Cld_spec%cloud_area,    &
                     Cld_spec%cloud_droplet, &
                     Cld_spec%cloud_ice_num, &
                     pFull    = press(:, :, :kx),     &
                     pHalf    = pflux,&
                     temperature = temp(:, :, :kx),   &
                     qv = qv(:,:, :kx),   &
                     cld_thickness = Cld_spec%cld_thickness_sw_band, &
                     ql_stoch = ql_stoch_sw2, &
                     qi_stoch = qi_stoch_sw2, &
                     qa_stoch = qa_stoch_sw2, &
                     qn_stoch = qn_stoch_sw2, &
                     qni_stoch = qni_stoch_sw2 )

!---------------------------------------------------------------------
!    call cloud_summary3 for each lw band, using the band-dependent
!    cloud inputs, to obtain band-dependent values of liquid and ice
!    size and concentration.
!---------------------------------------------------------------------
            do nb=1,Cldrad_control%nlwcldb
              call cloud_summary3 (          &
                is, js, land,  &
                Cldrad_control%using_fu2007, &
                ql_stoch_lw2(:,:,:,nb),&
                qi_stoch_lw2(:,:,:,nb), qa_stoch_lw2(:,:,:,nb),&
                qn_stoch_lw2(:,:,:,nb), &
                qni_stoch_lw2(:,:,:,nb), &
                press(:,:,1:kx), pflux, temp, ncldlvls, &
                cldamt, Cld_spec%lwp_lw_band(:,:,:,nb),&
                Cld_spec%iwp_lw_band(:,:,:,nb),   &
                Cld_spec%reff_liq_lw_band(:,:,:,nb), &
                Cld_spec%reff_ice_lw_band(:,:,:,nb), &
                conc_drop= Lsc_microphys%lw_stoch_conc_drop(:,:,:,nb), &
                conc_ice = Lsc_microphys%lw_stoch_conc_ice(:,:,:,nb), &
                size_drop =Lsc_microphys%lw_stoch_size_drop(:,:,:,nb), &
                size_ice = Lsc_microphys%lw_stoch_size_ice(:,:,:,nb), &
       droplet_number = Lsc_microphys%lw_stoch_droplet_number(:,:,:,nb), &
         ice_number =   Lsc_microphys%lw_stoch_ice_number(:,:,:,nb) )
              
              !now that the vertical cloud fraction has been used to
              !properly calculate the in-cloud particle size, rescale
              !the concentrations and cloud amounts to that the cloud
              !amount is unity in any partially cloudy sub-column. 
              !
              !This is necessary so that the radiation code will not
              !do cloud fraction weights of cloudy and clear sky fluxes.
              !
              !The rescaling of the concentrations is necessary so that the
              !total optical depth of the layer is constant.  Note that this
              !works because cloud extinction is linear in the concentration
              Lsc_microphys%lw_stoch_conc_drop(:,:,:,nb) = &
                   Lsc_microphys%lw_stoch_conc_drop(:,:,:,nb) * cldamt(:,:,:)     
              Lsc_microphys%lw_stoch_conc_ice(:,:,:,nb) = &
                   Lsc_microphys%lw_stoch_conc_ice(:,:,:,nb) * cldamt(:,:,:)
              where (cldamt .gt. 0.) cldamt = 1.                  
               
              if (.not. Cldrad_control%do_specified_strat_clouds) then
                Cld_spec%nrndlw_band(:,:,nb) = ncldlvls(:,:)
                Lsc_microphys%lw_stoch_cldamt(:,:,:,nb) = cldamt
              endif
            end do

!---------------------------------------------------------------------
!    call cloud_summary3 for each sw band, using the band-dependent
!    cloud inputs, to obtain band-dependent values of liquid and ice
!    size and concentration.
!---------------------------------------------------------------------
            do nb=1,size(Lsc_microphys%sw_stoch_conc_ice,4)
              call cloud_summary3 (                            &
                is, js, land, &
                Cldrad_control%using_fu2007, &
                ql_stoch_sw2(:,:,:,nb), &
                qi_stoch_sw2(:,:,:,nb), qa_stoch_sw2(:,:,:,nb),&
                qn_stoch_sw2(:,:,:,nb), &
                qni_stoch_sw2(:,:,:,nb), &
                press(:,:,1:kx), pflux, temp, ncldlvls, &
                cldamt, Cld_spec%lwp_sw_band(:,:,:,nb), &
                Cld_spec%iwp_sw_band(:,:,:,nb),   &
                Cld_spec%reff_liq_sw_band(:,:,:,nb), &
                Cld_spec%reff_ice_sw_band(:,:,:,nb), &
                conc_drop= Lsc_microphys%sw_stoch_conc_drop(:,:,:,nb), &
                conc_ice = Lsc_microphys%sw_stoch_conc_ice(:,:,:,nb), &
                size_drop =Lsc_microphys%sw_stoch_size_drop(:,:,:,nb), &
                size_ice = Lsc_microphys%sw_stoch_size_ice(:,:,:,nb), &
       droplet_number = Lsc_microphys%sw_stoch_droplet_number(:,:,:,nb), &
         ice_number =  Lsc_microphys%sw_stoch_ice_number(:,:,:,nb))
              
              !now that the vertical cloud fraction has been used to
              !properly calculate the in-cloud particle size, rescale
              !the concentrations and cloud amounts to that the cloud
              !amount is unity in any partially cloudy sub-column. 
              !
              !This is necessary so that the radiation code will not
              !do cloud fraction weights of cloudy and clear sky fluxes.
              !
              !The rescaling of the concentrations is necessary so that the
              !total optical depth of the layer is constant.  Note that this
              !works because cloud extinction is linear in the concentration
              Lsc_microphys%sw_stoch_conc_drop(:,:,:,nb) = &
                   Lsc_microphys%sw_stoch_conc_drop(:,:,:,nb) * cldamt(:,:,:)     
              Lsc_microphys%sw_stoch_conc_ice(:,:,:,nb) = &
                   Lsc_microphys%sw_stoch_conc_ice(:,:,:,nb) * cldamt(:,:,:)
              where (cldamt .gt. 0.) cldamt = 1.                  
               
              if (.not. Cldrad_control%do_specified_strat_clouds) then
                Cld_spec%ncldsw_band(:,:,nb) = ncldlvls(:,:)
                Lsc_microphys%sw_stoch_cldamt(:,:,:,nb) = cldamt
              endif
            end do
         endif ! (one_generator_call)
       endif  ! (do_stochastic_clouds)

!---------------------------------------------------------------------
!    if microphysically-based radiative properties are not needed, call
!    cloud_summary3 without the Lsc_microphys% optional arguments.
!----------------------------------------------------------------------
        else  ! (not micro)

!--------------------------------------------------------------------
!    define the cloud thickness to be 1 at those points with cloud
!    present.
!---------------------------------------------------------------------
          where (Cld_spec%cloud_area(:,:,:) > 0.0) 
            Cld_spec%cld_thickness(:,:,:) = 1
          end where
          call cloud_summary3 (is, js, land,  &
                               Cldrad_control%using_fu2007, &      
                               Cld_spec%cloud_water, &
                               Cld_spec%cloud_ice, Cld_spec%cloud_area,&
                               Cld_spec%cloud_droplet, &
                               Cld_spec%cloud_ice_num, &
                               press(:,:,1:kx), pflux, temp, ncldlvls, &
                               cldamt, Cld_spec%lwp,   &
                               Cld_spec%iwp, Cld_spec%reff_liq,   &
                               Cld_spec%reff_ice)
             cldamt = MIN (cldamt, 1.0)
          if (.not. Cldrad_control%do_specified_strat_clouds) then
            Cld_spec%ncldsw        = ncldlvls
            Cld_spec%nrndlw        = ncldlvls         
            Cld_spec%camtsw        = cldamt           
            Cld_spec%crndlw        = cldamt
            Lsc_microphys%cldamt   = cldamt            
          endif
        endif

!----------------------------------------------------------------------
!    in gcm or sa_gcm mode, all clouds are assumed to be randomly 
!    overlapped. in columns mode, no change is made to the specified 
!    input characteristics.
!----------------------------------------------------------------------
        if (.not. Cldrad_control%do_specified_strat_clouds) then
          Cld_spec%nmxolw        = 0 
          Cld_spec%cmxolw        = 0.0E+00
        endif

!---------------------------------------------------------------------
!    define cloud specification properties when max-random overlap is
!    assumed. in this case cloud in adjacent layers is assumed to be
!    part of the same cloud.
!---------------------------------------------------------------------
      else if (Cldrad_control%do_max_random_overlap) then  

!----------------------------------------------------------------------
!    microphysically-based radiative properties are not implemented
!    with the max-random overlap assumption.
!----------------------------------------------------------------------
        if (Cldrad_control%do_pred_cld_microphys .or. &
            Cldrad_control%do_presc_cld_microphys) then
          call error_mesg ('strat_clouds_W_mod', &
               'must use random overlap cloud assumption with strat '//&
              'clouds when microphysics are desired', FATAL)

!---------------------------------------------------------------------
!    if microphysically-based radiative properties are not needed, call
!    cloud_summary3 without the Lsc_microphys% optional arguments.
!----------------------------------------------------------------------
        else
          call cloud_summary3 (is, js, land,  &
                               Cldrad_control%using_fu2007, &    
                               Cld_spec%cloud_water, &
                               Cld_spec%cloud_ice, Cld_spec%cloud_area,&
                               Cld_spec%cloud_droplet, &
                               Cld_spec%cloud_ice_num, &
                               press(:,:,1:kx), pflux, temp, ncldlvls, &
                               Cld_spec%camtsw, Cld_spec%lwp,   &
                               Cld_spec%iwp, Cld_spec%reff_liq,   &
                               Cld_spec%reff_ice,  &
                               ktop=ktop, kbot=kbtm)

!---------------------------------------------------------------------
!    when only bulk properties are returned, they are in cloud space,
!    and must be converted to physical space before being stored in 
!    Cld_spec. random overlap and max overlap properties are assigned 
!    according to the cloud thickness - multi layer clouds are assumed 
!    to be max overlap.
!-------------------------------------------------------------------
          do j=1, size(press,2)
            do i=1, size(press,1)
              Cld_spec%ncldsw(i,j) = ncldlvls(i,j)
              do kc=1, Cld_spec%ncldsw(i,j)         
                do k=ktop(i,j,kc), kbtm(i,j,kc)
                  if (ktop(i,j,kc) == kbtm(i,j,kc)) then
                    Cld_spec%crndlw(i,j,k) = Cld_spec%camtsw(i,j,k)
                    Cld_spec%cmxolw(i,j,k) = 0.0             
                    Cld_spec%cld_thickness(i,j,k) = 1
                  else
                    Cld_spec%cmxolw(i,j,k) = Cld_spec%camtsw(i,j,k)
                    Cld_spec%crndlw(i,j,k) = 0.0
                    Cld_spec%cld_thickness(i,j,k) = kbtm(i,j,kc) -    &
                                                    ktop(i,j,kc) + 1
                  endif
                end do
                if (ktop(i,j,kc) == kbtm(i,j,kc)) then
                  Cld_spec%nrndlw(i,j) = Cld_spec%nrndlw(i,j) + 1
                else
                  Cld_spec%nmxolw(i,j) = Cld_spec%nmxolw(i,j) + 1
                endif
              end do
            end do
          end do
        endif ! (do_pred_micro or do_presc_micro)
      endif ! (do_random_overlap)

!---------------------------------------------------------------------



end subroutine strat_clouds_amt  



!#####################################################################
! <SUBROUTINE NAME="obtain_bulk_lw_strat">
!  <OVERVIEW>
!   obtain_bulk_lw_strat defines bulk longwave cloud radiative 
!    properties for the klein strat cloud scheme. 
!  </OVERVIEW>
!  <DESCRIPTION>
!   obtain_bulk_lw_strat defines bulk longwave cloud radiative 
!    properties for the klein strat cloud scheme.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call obtain_bulk_lw_strat (is, ie, js, je, Cld_spec, Cldrad_props)
!  </TEMPLATE>
!  <IN NAME="is, ie, js, je" TYPE="integer">
!   starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!   cld_specification_type variable containing the 
!                   cloud specification input fields needed by the 
!                   radiation package
!  </IN>
!  <INOUT NAME="cldrad_properties" TYPE="microphys_type">
!   cloud radiative properties on model grid
!  </INOUT>
! </SUBROUTINE>
!
subroutine obtain_bulk_lw_strat (is, ie, js, je, Cld_spec, Cldrad_props)

!---------------------------------------------------------------------
!    obtain_bulk_lw_strat defines bulk longwave cloud radiative 
!    properties for the klein strat cloud scheme.
!---------------------------------------------------------------------

integer,                      intent(in)    :: is, ie, js, je
type(cld_specification_type), intent(in)    :: Cld_spec
type(cldrad_properties_type), intent(inout) :: Cldrad_props

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      Cld_spec     cloud specification arrays defining the 
!                   location, water paths and effective particle
!                   sizes of clouds that are present, provides 
!                   input to this subroutine
!                   [ cld_specification_type ]
!
!   intent(inout) variables:
!
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output 
!               from this routine:
!
!                    %emrndlw   longwave cloud emissivity for 
!                               randomly overlapped clouds
!                               in each of the longwave
!                               frequency bands  [ dimensionless ]
!                    %emmxolw   longwave cloud emissivity for 
!                               maximally overlapped clouds
!                               in each of the longwave 
!                               frequency bands  [ dimensionless ]
!
!---------------------------------------------------------------------
 
!-------------------------------------------------------------------
!   local variables:

      real, dimension (size(Cld_spec%lwp,1), size(Cld_spec%lwp,2),  &
                       size(Cld_spec%lwp,3)) :: emcld

      integer       :: max_cld
      integer       :: i, j, k

!-------------------------------------------------------------------
!   local variables:
!
!         emcld      longwave cloud emissivity [ dimensionless ]
!         max_cld    maximum number of clouds in any column in the
!                    window
!         i,j,k      do-loop indices
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('strat_clouds_W_mod',   &
             'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!   find maximum number of clouds in any column in the window.
!---------------------------------------------------------------------
      max_cld = MAXVAL(Cld_spec%ncldsw(:,:))

!---------------------------------------------------------------------
!    if cloud is present in the window, call lw_emissivity to compute 
!    the longwave emissivity. otherwise, leave the emissivity arrays 
!    with their previously initialized values.
!---------------------------------------------------------------------
      if (max_cld > 0) then
!---------------------------------------------------------------------
!    call lw_emissivity to obtain the longwave cloud emissivity.
!---------------------------------------------------------------------
        call lw_emissivity (is, js, Cld_spec%lwp, Cld_spec%iwp,  &
                         Cld_spec%reff_liq_lim, Cld_spec%reff_ice_lim,&
                            Cld_spec%ncldsw, emcld)

!---------------------------------------------------------------------
!    define both the random and max overlap cloud emissivities to be
!    that value returned from lw_emissivity.
!-------------------------------------------------------------------
        do k=1,size(Cld_spec%lwp,3)
          do j=1,size(Cld_spec%lwp,2)
            do i=1,size(Cld_spec%lwp,1)
              Cldrad_props%emrndlw(i,j,k,:,1) = emcld(i,j,k)
              Cldrad_props%emmxolw(i,j,k,:,1) = emcld(i,j,k)
            end do
          end do
        end do
      endif

!--------------------------------------------------------------------


end subroutine obtain_bulk_lw_strat



!#####################################################################
! <SUBROUTINE NAME="obtain_bulk_sw_strat">
!  <OVERVIEW>
!   obtain_bulk_lw_strat defines bulk shortwave cloud radiative 
!    properties for the klein strat cloud scheme. 
!  </OVERVIEW>
!  <DESCRIPTION>
!   obtain_bulk_lw_strat defines bulk shortwave cloud radiative 
!    properties for the klein strat cloud scheme.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call obtain_bulk_sw_strat (is, ie, js, je, cosz, Cld_spec, Cldrad_props)
!  </TEMPLATE>
!  <IN NAME="is, ie, js, je" TYPE="integer">
!   starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="cosz" TYPE="real">
!   cosine of the solar zenith angle
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!   cld_specification_type variable containing the 
!                   cloud specification input fields needed by the 
!                   radiation package
!  </IN>
!  <INOUT NAME="cldrad_properties" TYPE="microphys_type">
!   cloud radiative properties on model grid
!  </INOUT>
! </SUBROUTINE>
!
subroutine obtain_bulk_sw_strat (is, ie, js, je, cosz, Cld_spec,   &
                                 Cldrad_props)

!---------------------------------------------------------------------
!    obtain_bulk_sw_strat defines bulk shortwave cloud radiative 
!    properties for the klein strat cloud scheme.
!---------------------------------------------------------------------
 
integer,                      intent(in)    ::  is, ie, js, je
real, dimension(:,:),         intent(in)    ::  cosz
type(cld_specification_type), intent(in)    ::  Cld_spec
type(cldrad_properties_type), intent(inout) ::  Cldrad_props
 
!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      cosz         cosine of the zenith angle  [ dimensionless ]
!      Cld_spec     cloud specification arrays defining the 
!                   location, amount and type (hi, middle, lo)
!                   of clouds that are present, provides input 
!                   to this subroutine
!                   [ cld_specification_type ]
!
!   intent(inout) variables:
!
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output 
!               from this routine:
!
!                    %cirabsw   absorptivity of clouds in the 
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cirrfsw   reflectivity of clouds in the 
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cvisrfsw  reflectivity of clouds in the 
!                               visible frequency band
!                               [ dimensionless ]
!
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!   local variables:

      integer   :: max_cld

!---------------------------------------------------------------------  
!   local variables:
!
!          max_cld    maximum number of clouds in any column in the
!                     window
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('strat_clouds_W_mod',   &
             'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!   find maximum number of clouds in any column in the window.
!---------------------------------------------------------------------
      max_cld  = MAXVAL(Cld_spec%ncldsw(:,:))

!---------------------------------------------------------------------
!    if cloud is present in the window, call sw_optical_properties to 
!    compute cloud optical properties and then radiative properties. 
!    otherwise, leave the arrays with their previously initialized 
!    values.
!---------------------------------------------------------------------
      if (max_cld > 0) then
        call sw_optical_properties (Cld_spec%ncldsw, Cld_spec%lwp,   &
                                  Cld_spec%iwp, Cld_spec%reff_liq_lim, &
                                    Cld_spec%reff_ice_lim, cosz,   &
                                    Cldrad_props%cvisrfsw, &
                                    Cldrad_props%cirrfsw,  &
                                    Cldrad_props%cirabsw)
      endif   

!-------------------------------------------------------------------


end subroutine obtain_bulk_sw_strat

!####################################################################
! <SUBROUTINE NAME="strat_clouds_W_end">
!  <OVERVIEW>
!    strat_clouds_W_end is the destructor for strat_clouds_W_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    strat_clouds_W_end is the destructor for strat_clouds_W_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call strat_clouds_W_end
!  </TEMPLATE>
! </SUBROUTINE>
subroutine strat_clouds_W_end
       
!----------------------------------------------------------------------
!    strat_clouds_W_end is the destructor for strat_clouds_W_mod.
!----------------------------------------------------------------------
        
!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('strat_clouds_W_mod',   &
             'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
! close cloud_generator
!---------------------------------------------------------------------
      deallocate (lats, lons)
      if (do_stochastic_clouds) &
                call cloud_generator_end()

!---------------------------------------------------------------------
!    mark the module as not initialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.
       
!--------------------------------------------------------------------
 
 
end subroutine strat_clouds_W_end



!#################################################################




                    end module strat_clouds_W_mod

                         Module FSrad_Mod

!-----------------------------------------------------------------------
!-------------------- PUBLIC Radiation routines ------------------------

      Use        MCM_LW_Mod, ONLY: MCM_LW_Rad
      Use MCM_SW_Driver_Mod, ONLY: mcm_shortwave_driver

      Use   ShortWave_Mod, ONLY: SWRad
      Use    LongWave_Mod, ONLY: LWRad, Rad_DeAlloc
      Use      RdParm_Mod, ONLY: RdParm_Init
      Use    Rad_Diag_Mod, ONLY: Radiag
      Use    CO2_Data_Mod, ONLY: CO2_Data

      Use         Fms_Mod, ONLY: mpp_pe, mpp_root_pe, write_version_number, &
                                 error_mesg, FATAL
      Use   Constants_Mod, ONLY: stefan

      implicit none
      private

      public  FSrad, RdParm_Init, CO2_Data, fsrad_init, fsrad_end
!-----------------------------------------------------------------------

      character(len=128) :: version = '$Id: fsrad.F90,v 14.0 2007/03/15 22:03:19 fms Exp $'
      character(len=128) :: tagname = '$Name: tikal $'
      logical            :: module_is_initialized = .false.

      real, parameter :: Day_Length=86400.
      real, parameter :: RATco2MW=1.519449738
      real, parameter :: PerSec=1./Day_Length

!-----------------------------------------------------------------------

CONTAINS

!#######################################################################

      Subroutine FSrad (ip,jp,Press,Temp,Rh2o,Qo3,              &
                        phalf,do_mcm_radiation,             &
                        Nclds,KtopSW,KbtmSW,Ktop,Kbtm,CldAmt,   &
                        EmCld,CUVRF,CIRRF,CIRAB,Albedo,RVco2,   &
                        CosZ,Solar,                             &
                        SWin,SWout,OLR,SWupS,SWdnS,LWupS,LWdnS, &
                        TdtSW,TdtLW, Ksfc,Psfc)

!-----------------------------------------------------------------------
Integer, Intent(IN)                    :: ip,jp
   Real, Intent(IN), Dimension(:,:,:)  :: Press,Temp,Rh2o,Qo3
   Real, Intent(IN), Dimension(:,:,:)  :: phalf
Logical, Intent(IN)                    :: do_mcm_radiation
Integer, Intent(IN), Dimension(:,:)    :: Nclds
Integer, Intent(IN), Dimension(:,:,:)  :: KtopSW,KbtmSW,Ktop,Kbtm
   Real, Intent(IN), Dimension(:,:,:)  :: CldAmt,EmCld,CUVRF,CIRRF,CIRAB
   Real, Intent(IN), Dimension(:,:)    :: Albedo,CosZ,Solar
   Real, Intent(IN)                    :: RVco2

   Real, Intent(OUT), Dimension(:,:)   :: SWin,SWout,OLR,SWupS,SWdnS,  &
                                                       LWupS,LWdnS
   Real, Intent(OUT), Dimension(:,:,:) :: TdtSW,TdtLW

Integer, Intent(IN), Dimension(:,:), Optional :: Ksfc
   Real, Intent(IN), Dimension(:,:), Optional :: Psfc
!-----------------------------------------------------------------------
   Real, Dimension(Size(Rh2o,1),Size(Rh2o,2),Size(Rh2o,3)+1) ::  &
                                    FSW,DFSW,UFSW
   Real, Dimension(Size(Rh2o,1),Size(Rh2o,2)) :: SSolar,GrnFlux,TopFlux
   Real  Rco2
Logical  SunUp
Integer  i,j,IX,JX,KX
!-----------------------------------------------------------------------


      IX=Size(Rh2o,1)
      JX=Size(Rh2o,2)
      KX=Size(Rh2o,3)

      SunUp=.false.
      Do j=1,JX
      Do i=1,IX
         If (CosZ(i,j) > 0.0) Then
            SunUp=.true.
            EXIT
         EndIf
      EndDo
      EndDo

!-----------------------------------------------------------------------
!----- convert solar constant from W/m2 to ly/min ------

      SSolar = Solar * (6./4186.)

!-----------------------------------------------------------------------
!----------------------- Shortwave Radiation ---------------------------

      If (SunUp) Then
         Rco2=RVco2*RATco2MW

        if ( do_mcm_radiation ) then
         Call mcm_shortwave_driver &
                    (Nclds, KtopSW, KbtmSW, Press, Rh2o, Qo3, CldAmt, &
                     CUVRF, CIRRF, CIRAB, Rco2, CosZ, SSolar,         &
                     Albedo, FSW, DFSW, UFSW, TdtSW, phalf )
        else
         Call SWRad (Nclds, KtopSW, KbtmSW, Press, Rh2o, Qo3, CldAmt, &
                     CUVRF, CIRRF, CIRAB, Rco2, CosZ, SSolar,         &
                     Albedo, FSW, DFSW, UFSW, TdtSW, Ksfc, Psfc       )
        endif

      Else
         FSW=0.0; DFSW=0.0; UFSW=0.0; TdtSW=0.0
      EndIf


!-----------------------------------------------------------------------
!----------------------- Longwave Radiation ----------------------------

      if ( do_mcm_radiation ) then
        Call MCM_LW_Rad (Ktop, Kbtm, Nclds, EmCld, Press, Temp, Rh2o, Qo3,&
                    CldAmt, RVco2, TdtLW, GrnFlux, TopFlux, phalf )
      else
        Call LWRad (Ktop, Kbtm, Nclds, EmCld, Press, Temp, Rh2o, Qo3,  &
                    CldAmt, RVco2, TdtLW, GrnFlux, TopFlux, Ksfc, Psfc )
      endif

!-----------------------------------------------------------------------
!----------------------- Radiation Diagnostics -------------------------
      If (ip > 0 .and. jp > 0) Then
         Call Radiag (Press,Temp,Rh2o,Rco2,Qo3,CldAmt,Ktop,Kbtm,Nclds, &
                      TdtLW,GrnFlux,  FSW,DFSW,UFSW,TdtSW,  &
                      KtopSW,KbtmSW,EmCld,CUVRF,CIRRF,CIRAB,  &
                      Albedo,CosZ,SSolar,   ip,jp)
      EndIf
!-----------------------------------------------------------------------
      if(.not.do_mcm_radiation ) then
        Call Rad_DeAlloc
      endif
!-----------------------------------------------------------------------
!    **** Output fluxes at the top and bottom of atmosphere ****
!            **** convert ergs/cm2/s to watts/m2 ****

!  --- TOA ---
          SWin (:,:)=DFSW(:,:,1)  *1.E-3
          SWout(:,:)=UFSW(:,:,1)  *1.E-3
          OLR  (:,:)=TopFlux(:,:) *1.E-3

!  --- SFC ---
   If (Present(Ksfc) .and. Present(Psfc)) Then
       Do j=1,JX
       Do i=1,IX
          SWupS(i,j)=UFSW(i,j,Ksfc(i,j)+1)*1.E-3
          SWdnS(i,j)=DFSW(i,j,Ksfc(i,j)+1)*1.E-3
          LWupS(i,j)=stefan*Temp(i,j,Ksfc(i,j)+1)**4
       EndDo
       EndDo
   Else
          SWupS(:,:)=UFSW(:,:,KX+1)*1.E-3
          SWdnS(:,:)=DFSW(:,:,KX+1)*1.E-3
          LWupS(:,:)=stefan*Temp(:,:,KX+1)**4
   EndIf
          LWdnS(:,:)=LWupS(:,:)-GrnFlux(:,:)*1.E-3


!-----------------------------------------------------------------------

      TdtSW=TdtSW*PerSec
      TdtLW=TdtLW*PerSec

!-----------------------------------------------------------------------

      End Subroutine FSrad

!#######################################################################

      Subroutine fsrad_init
!------- write version number and namelist ---------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
      endif

      module_is_initialized = .true.

!---------------------------------------------------------------------

      End Subroutine fsrad_init

!#######################################################################

      Subroutine fsrad_end

      module_is_initialized = .false.
!---------------------------------------------------------------------

      End Subroutine fsrad_end

!#######################################################################



                     End Module FSrad_Mod

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                                   !!
!!                   GNU General Public License                      !!
!!                                                                   !!
!! This file is part of the Flexible Modeling System (FMS).          !!
!!                                                                   !!
!! FMS is free software; you can redistribute it and/or modify       !!
!! it and are expected to follow the terms of the GNU General Public !!
!! License as published by the Free Software Foundation.             !!
!!                                                                   !!
!! FMS is distributed in the hope that it will be useful,            !!
!! but WITHOUT ANY WARRANTY; without even the implied warranty of    !!
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     !!
!! GNU General Public License for more details.                      !!
!!                                                                   !!
!! You should have received a copy of the GNU General Public License !!
!! along with FMS; if not, write to:                                 !!
!!          Free Software Foundation, Inc.                           !!
!!          59 Temple Place, Suite 330                               !!
!!          Boston, MA  02111-1307  USA                              !!
!! or see:                                                           !!
!!          http://www.gnu.org/licenses/gpl.txt                      !!
!!                                                                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! A SEA ICE MODEL for coupling through the GFDL exchange grid;  this module    !
! manages fluxes, diagnostics, and ice timesteps; sea ice dynamics and         !
! thermodynamics are performed in ice_[dyn|thm].f90 - Mike Winton (Michael.Winton)!
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
module ice_model_mod

  use mpp_mod,          only: mpp_clock_begin, mpp_clock_end
  use mpp_domains_mod,  only: mpp_update_domains, BGRID_NE, CGRID_NE
  use fms_mod,          only: error_mesg
  use diag_manager_mod, only: send_data
  use time_manager_mod, only: time_type, operator(+), get_date, get_time
  use time_manager_mod, only: operator(-), set_date
  use astronomy_mod,    only: universal_time, orbital_time, diurnal_solar, daily_mean_solar
  use coupler_types_mod,only: coupler_2d_bc_type, coupler_3d_bc_type
  use constants_mod,    only: hlv, hlf, Tfreeze, grav, STEFAN
  use ocean_albedo_mod, only: compute_ocean_albedo            ! ice sets ocean surface
  use ocean_rough_mod,  only: compute_ocean_roughness         ! properties over water
  use ice_type_mod,     only: ice_data_type, ice_model_init, ice_model_end, hlim,&
                              mom_rough_ice, heat_rough_ice, atmos_winds, kmelt, &
                              slab_ice, spec_ice, ice_bulk_salin, id_cn, id_hi,  &
                              id_hs, id_t1, id_t2, id_ts, id_sh, id_lh, id_sw,   &
                              id_swdn, id_lw, id_lwdn, id_snofl, id_rain,        &
                              id_runoff_hflx, id_calving_hflx,                   &
                              id_runoff, id_calving, id_evap, id_saltf, id_tmelt,&
                              id_mi, id_bmelt, id_bheat, id_frazil, id_alb,      &
                              id_xprt, id_lsrc, id_lsnk, id_bsnk, id_strna,      &
                              id_sigi, id_sigii, id_stren, id_ui, id_vi, id_fax, &
                              id_fay, id_fix, id_fiy, id_fcx, id_fcy, id_fwx,    &
                              id_fwy, id_sn2ic,  id_ext, id_slp, id_sst, id_sss, &
                              id_ssh, id_uo, id_vo, id_e2m, id_qflim, id_qfres,  &
                              id_ix_trans, id_iy_trans,                          &
                              do_ice_restore, do_ice_limit, max_ice_limit,       &
                              ice_restore_timescale, do_init, h2o, heat,         &
                              conservation_check, slp2ocean, iceClock, verbose,  &
                              iceClock1, iceClock2, iceClock3, &
                              iceClock4, iceClock5, iceClock6, &
                              iceClock7, iceClock8, iceClock9, &
                              iceClocka, iceClockb, iceClockc, &
                              id_sw_vis, id_sw_dir, id_sw_dif, id_sw_vis_dir,    &
                              id_sw_vis_dif, id_sw_nir_dir, id_sw_nir_dif,       &
                              cm2_bugs, ice_stock_pe, do_icebergs, ice_model_restart, &
                              add_diurnal_sw, id_mib, ice_data_type_chksum,      &
                              id_ustar, id_vstar, channel_viscosity, smag_ocn,   &
                              ssh_gravity, chan_cfl_limit, id_vocean, id_uocean, &
                              id_vchan, id_uchan, id_wnd
  use ice_type_mod,     only: do_sun_angle_for_alb,              &
			      id_alb_vis_dir, id_alb_vis_dif,    &
	                      id_alb_nir_dir, id_alb_nir_dif

  use ice_grid_mod,     only: uv_to_t, t_to_uv, vel_t_to_uv, cut_check, tripolar_grid
  use ice_grid_mod,     only: Domain, isc, iec, jsc, jec, isd, ied, jsd, jed, im, jm, km
  use ice_grid_mod,     only: ice_advect, ice_avg, all_avg, ice_line, slab_ice_advect
  use ice_grid_mod,     only: geo_lon, geo_lat, cell_area, sin_rot, cos_rot, latitude
  use ice_spec_mod,     only: get_sea_surface
  use ice_grid_mod,     only: dte, dtn, dxv, dyv, dxt, dyt, dt_adv, wett
  use ice_grid_mod,     only: reproduce_siena_201303
  !
  ! the following two modules are the work horses of the sea ice model
  !
  use ice_thm_mod,      only: ice_optics, ice_thm_param, ice3lay_temp, ice3lay_resize
  use ice_thm_mod,      only: thm_pack, thm_unpack, DI, DS, MU_TS, TFI, e_to_melt
  use ice_dyn_mod,      only: ice_dynamics, ice_dyn_param, strain_angle, ice_strength, sigI, sigII
  use ice_bergs,        only: icebergs_run, icebergs_incr_mass

  implicit none
  private

  public :: ice_data_type, ocean_ice_boundary_type, atmos_ice_boundary_type, land_ice_boundary_type
  public :: ice_model_init, ice_model_end, ice_bottom_to_ice_top, update_ice_model_fast, ice_stock_pe, cell_area
  public :: update_ice_model_slow, update_ice_model_slow_up, update_ice_model_slow_dn ! for new coupler
  public :: ice_model_restart  ! for intermediate restart
  public :: ocn_ice_bnd_type_chksum, atm_ice_bnd_type_chksum, &
            lnd_ice_bnd_type_chksum, ice_data_type_chksum

  interface update_ice_model_fast ! overload to support old interface
     module procedure update_ice_model_fast_new
     !  module procedure update_ice_model_fast_old !Balaji: no need to expose old interface
  end interface
  !
  ! the following three types are for data exchange with the new coupler
  ! they are defined here but declared in coupler_main and allocated in flux_init
  !
  type :: ocean_ice_boundary_type
     real, dimension(:,:),   pointer :: u         =>NULL()
     real, dimension(:,:),   pointer :: v         =>NULL()
     real, dimension(:,:),   pointer :: t         =>NULL()
     real, dimension(:,:),   pointer :: s         =>NULL()
     real, dimension(:,:),   pointer :: frazil    =>NULL()
     real, dimension(:,:),   pointer :: sea_level =>NULL()
     real, dimension(:,:,:), pointer :: data      =>NULL() ! collective field for "named" fields above
     integer                         :: xtype              ! REGRID, REDIST or DIRECT used by coupler
     type(coupler_2d_bc_type)        :: fields     ! array of fields used for additional tracers
  end type 

  type :: atmos_ice_boundary_type 
     real, dimension(:,:,:), pointer :: u_flux  =>NULL()
     real, dimension(:,:,:), pointer :: v_flux  =>NULL()
     real, dimension(:,:,:), pointer :: u_star  =>NULL()
     real, dimension(:,:,:), pointer :: t_flux  =>NULL()
     real, dimension(:,:,:), pointer :: q_flux  =>NULL()
     real, dimension(:,:,:), pointer :: lw_flux =>NULL()
     real, dimension(:,:,:), pointer :: sw_flux_vis_dir =>NULL()
     real, dimension(:,:,:), pointer :: sw_flux_vis_dif =>NULL()
     real, dimension(:,:,:), pointer :: sw_flux_nir_dir =>NULL()
     real, dimension(:,:,:), pointer :: sw_flux_nir_dif =>NULL()
     real, dimension(:,:,:), pointer :: lprec   =>NULL()
     real, dimension(:,:,:), pointer :: fprec   =>NULL()
     real, dimension(:,:,:), pointer :: dhdt    =>NULL()
     real, dimension(:,:,:), pointer :: dedt    =>NULL()
     real, dimension(:,:,:), pointer :: drdt    =>NULL()
     real, dimension(:,:,:), pointer :: coszen  =>NULL()
     real, dimension(:,:,:), pointer :: coszen_radwt =>NULL()
     real, dimension(:,:,:), pointer :: p       =>NULL()
     real, dimension(:,:,:), pointer :: data    =>NULL()
     integer                         :: xtype
     type(coupler_3d_bc_type)        :: fluxes     ! array of fluxes used for additional tracers
  end type

  type :: land_ice_boundary_type
     real, dimension(:,:),   pointer :: runoff  =>NULL()
     real, dimension(:,:),   pointer :: calving =>NULL()
     real, dimension(:,:),   pointer :: runoff_hflx  =>NULL()
     real, dimension(:,:),   pointer :: calving_hflx =>NULL()
     real, dimension(:,:,:), pointer :: data    =>NULL() ! collective field for "named" fields above
     integer                         :: xtype            ! REGRID, REDIST or DIRECT used by coupler
  end type

  real, parameter :: T_sw_freeze = Tfreeze-1.8 ! seawater freezing temperature (K)
  logical :: first_time = .true.               ! first time ice_bottom_to_ice_top

contains

  !#######################################################################
  !
  ! new coupler interface to provide ocean surface data to atmosphere
  !
  subroutine update_ice_model_slow_up ( Ocean_boundary, Ice )
    type(ocean_ice_boundary_type), intent(inout) :: Ocean_boundary
    type (ice_data_type),          intent(inout) :: Ice

    call mpp_clock_begin(iceClock)
    call mpp_clock_begin(iceClock1)
    call ice_bottom_to_ice_top (Ice, Ocean_boundary%t, Ocean_boundary%u, Ocean_boundary%v,        &
                                Ocean_boundary%frazil, Ocean_boundary, Ocean_boundary%s, Ocean_boundary%sea_level  )
    call mpp_clock_end(iceClock1)
    call mpp_clock_end(iceClock)

  end subroutine update_ice_model_slow_up
  !
  ! new coupler interface to do slow ice processes:  dynamics, transport, mass
  !
  subroutine update_ice_model_slow_dn ( Atmos_boundary, Land_boundary, Ice )
    type(atmos_ice_boundary_type), intent(inout) :: Atmos_boundary
    type(land_ice_boundary_type),  intent(inout) :: Land_boundary
    type (ice_data_type),          intent(inout) :: Ice

    call mpp_clock_begin(iceClock)
    call mpp_clock_begin(iceClock2)
    call update_ice_model_slow (Ice, Land_boundary%runoff, Land_boundary%calving, Land_boundary%runoff_hflx, Land_boundary%calving_hflx, Atmos_boundary%p )
    call mpp_clock_end(iceClock2)
    call mpp_clock_end(iceClock)

  end subroutine update_ice_model_slow_dn

  subroutine update_ice_model_fast_new ( Atmos_boundary, Ice )
    type(atmos_ice_boundary_type), intent(inout) :: Atmos_boundary
    type (ice_data_type),          intent(inout) :: Ice

    call mpp_clock_begin(iceClock)
    call mpp_clock_begin(iceClock3)
    call update_ice_model_fast_old (Ice, Atmos_boundary%fluxes,  &
                                         Atmos_boundary%u_flux,  &
                                         Atmos_boundary%v_flux,  &
                                         Atmos_boundary%u_star,  &
                                         Atmos_boundary%sw_flux_nir_dir, &
                                         Atmos_boundary%sw_flux_nir_dif, &
                                         Atmos_boundary%sw_flux_vis_dir, &
                                         Atmos_boundary%sw_flux_vis_dif, &
                                         Atmos_boundary%lw_flux, &
                                         Atmos_boundary%t_flux,  &
                                         Atmos_boundary%q_flux,  &
                                         Atmos_boundary%dhdt,    &
                                         Atmos_boundary%dedt,    &
                                         Atmos_boundary%drdt,    &
                                         Atmos_boundary%lprec,   &
                                         Atmos_boundary%fprec,   &
                                         Atmos_boundary%coszen,  &
                                         Atmos_boundary%coszen_radwt,  &
                                         Atmos_boundary%p        )
    call mpp_clock_end(iceClock3)
    call mpp_clock_end(iceClock)

  end subroutine update_ice_model_fast_new

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! zero_top_quantities - zero fluxes to begin summing in ice fast physics       !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine zero_top_quantities ( Ice )
    type (ice_data_type), intent(inout)  :: Ice

    integer :: i, j, k, n, m

    Ice % avg_kount = 0

    do k = 1, km
       do j = jsd, jed
          do i = isd, ied
             Ice % flux_u_top(i,j,k)  = 0.0
             Ice % flux_v_top(i,j,k)  = 0.0
          enddo
       enddo
    enddo

    do k = 1, km
       do j = jsc, jec
          do i = isc, iec
             Ice % flux_t_top(i,j,k)          = 0.0
             Ice % flux_q_top(i,j,k)          = 0.0
             Ice % flux_lw_top(i,j,k)         = 0.0
             Ice % flux_lh_top(i,j,k)         = 0.0
             Ice % flux_sw_nir_dir_top(i,j,k) = 0.0
             Ice % flux_sw_nir_dif_top(i,j,k) = 0.0
             Ice % flux_sw_vis_dir_top(i,j,k) = 0.0
             Ice % flux_sw_vis_dif_top(i,j,k) = 0.0
             Ice % lprec_top(i,j,k)           = 0.0
             Ice % fprec_top(i,j,k)           = 0.0
             do n = 1, Ice%ocean_fluxes_top%num_bcs  !{
               do m = 1, Ice%ocean_fluxes_top%bc(n)%num_fields  !{
                 Ice%ocean_fluxes_top%bc(n)%field(m)%values(i,j,k) = 0.0
               enddo  !} m
             enddo  !} n
          enddo
       enddo
    enddo

    do j = jsc, jec
       do i = isc, iec
          Ice % lwdn(i,j)        = 0.0
          Ice % swdn(i,j)        = 0.0
       enddo
    enddo

    return

  end subroutine zero_top_quantities

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! sum_top_quantities - sum fluxes for later use by ice/ocean slow physics      !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine sum_top_quantities ( Ice, Atmos_boundary_fluxes, flux_u,  flux_v, flux_t,  flux_q, &
         flux_sw_nir_dir, flux_sw_nir_dif, flux_sw_vis_dir, flux_sw_vis_dif,&
         flux_lw, lprec,   fprec, flux_lh )
    type (ice_data_type),            intent(inout)  :: Ice
    type(coupler_3d_bc_type),        intent(inout)  :: Atmos_boundary_fluxes
    real, intent(in), dimension(isc:iec,jsc:jec,km) :: flux_u,  flux_v, flux_t, flux_q
    real, intent(in), dimension(isc:iec,jsc:jec,km) :: flux_lw, lprec, fprec, flux_lh
    real, intent(in), dimension(isc:iec,jsc:jec,km) :: flux_sw_nir_dir
    real, intent(in), dimension(isc:iec,jsc:jec,km) :: flux_sw_nir_dif
    real, intent(in), dimension(isc:iec,jsc:jec,km) :: flux_sw_vis_dir
    real, intent(in), dimension(isc:iec,jsc:jec,km) :: flux_sw_vis_dif
    real,dimension(isc:iec,jsc:jec)                 :: tmp
    integer                                         :: i, j, k, m, n

    if (Ice % avg_kount == 0) call zero_top_quantities (Ice)

    do k = 1, km
       do j = jsc, jec
          do i = isc, iec
             Ice % flux_u_top(i,j,k)  = Ice % flux_u_top(i,j,k)  + flux_u(i,j,k)
             Ice % flux_v_top(i,j,k)  = Ice % flux_v_top(i,j,k)  + flux_v(i,j,k)
             Ice % flux_t_top(i,j,k)  = Ice % flux_t_top(i,j,k)  + flux_t(i,j,k)
             Ice % flux_q_top(i,j,k)  = Ice % flux_q_top(i,j,k)  + flux_q(i,j,k)
             Ice % flux_sw_nir_dir_top(i,j,k) = Ice % flux_sw_nir_dir_top(i,j,k) + flux_sw_nir_dir(i,j,k)
             Ice % flux_sw_nir_dif_top(i,j,k) = Ice % flux_sw_nir_dif_top(i,j,k) + flux_sw_nir_dif(i,j,k)
             Ice % flux_sw_vis_dir_top(i,j,k) = Ice % flux_sw_vis_dir_top(i,j,k) + flux_sw_vis_dir(i,j,k)
             Ice % flux_sw_vis_dif_top(i,j,k) = Ice % flux_sw_vis_dif_top(i,j,k) + flux_sw_vis_dif(i,j,k)
             Ice % flux_lw_top(i,j,k) = Ice % flux_lw_top(i,j,k) + flux_lw(i,j,k)
             Ice % lprec_top(i,j,k)   = Ice % lprec_top(i,j,k)   + lprec(i,j,k)
             Ice % fprec_top(i,j,k)   = Ice % fprec_top(i,j,k)   + fprec(i,j,k)
             Ice % flux_lh_top(i,j,k) = Ice % flux_lh_top(i,j,k) + flux_lh(i,j,k)
          enddo
       enddo
    enddo

    do n = 1, Ice%ocean_fluxes_top%num_bcs  !{
       do m = 1, Ice%ocean_fluxes_top%bc(n)%num_fields  !{
          do k = 1, km
             do j = jsc, jec
                do i = isc, iec
                   Ice%ocean_fluxes_top%bc(n)%field(m)%values(i,j,k) = Ice%ocean_fluxes_top%bc(n)%field(m)%values(i,j,k) +     &
                        Atmos_boundary_fluxes%bc(n)%field(m)%values(i,j,k)
                enddo  !} m
             enddo  !} n
          enddo
       enddo
    enddo

    if (id_lwdn > 0) then
       tmp = all_avg(flux_lw+STEFAN*Ice%t_surf**4, Ice%part_size(isc:iec,jsc:jec,:))
       do j = jsc, jec
          do i = isc, iec
             if(Ice%mask(i,j) ) Ice%lwdn(i,j) = Ice%lwdn(i,j) + tmp(i,j)
          enddo
       enddo
    endif

    if (id_swdn > 0) then
       tmp = all_avg(flux_sw_vis_dir/(1-Ice%albedo_vis_dir)+flux_sw_vis_dif/(1-Ice%albedo_vis_dif)+ &
             flux_sw_nir_dir/(1-Ice%albedo_nir_dir)+flux_sw_nir_dif/(1-Ice%albedo_nir_dif), &
             Ice%part_size(isc:iec,jsc:jec,:) )
       do j = jsc, jec
          do i = isc, iec
             if(Ice%mask(i,j) ) Ice%swdn(i,j) = Ice%swdn(i,j) + tmp(i,j)
          enddo
       enddo
    endif

    Ice % avg_kount = Ice % avg_kount + 1

  end subroutine sum_top_quantities

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! avg_top_quantities - time average fluxes for ice and ocean slow physics      !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine avg_top_quantities ( Ice )
    type (ice_data_type), intent(inout)  :: Ice

    real    :: u, v, divid
    integer :: i, j, k, m, n
    logical :: sent
    !
    ! compute average fluxes
    !
    if (Ice % avg_kount == 0) call error_mesg ('avg_top_quantities', &
         'no ocean model fluxes have been averaged', 3)

    divid = 1./float(Ice%avg_kount)

    do k=1,km
       do j = jsc, jec
          do i = isc, iec
             u                       = Ice % flux_u_top(i,j,k)  * divid
             v                       = Ice % flux_v_top(i,j,k)  * divid
             Ice % flux_u_top(i,j,k) = u*cos_rot(i,j)-v*sin_rot(i,j) ! rotate stress from lat/lon
             Ice % flux_v_top(i,j,k) = v*cos_rot(i,j)+u*sin_rot(i,j) ! to ocean coordinates
          end do
       end do
    end do

    if (atmos_winds) then ! put wind stress on u,v points and change sign to +down
       call mpp_update_domains(Ice % flux_u_top, Ice % flux_v_top, Domain  )
       do k=1,km
          call vel_t_to_uv( -Ice%flux_u_top(:,:,k),-Ice%flux_v_top(:,:,k), &
               Ice%flux_u_top_bgrid(isc:iec,jsc:jec,k), Ice%flux_v_top_bgrid(isc:iec,jsc:jec,k) )
       end do
    else
       if(reproduce_siena_201303) then
          Ice%flux_u_top_bgrid(isc:iec,jsc:jec,:) = Ice%flux_u_top(isc:iec,jsc:jec,:)
          Ice%flux_v_top_bgrid(isc:iec,jsc:jec,:) = Ice%flux_v_top(isc:iec,jsc:jec,:)
       else
          call mpp_update_domains(Ice % flux_u_top, Ice % flux_v_top, Domain  )
          do k=1,km
             call vel_t_to_uv( Ice%flux_u_top(:,:,k),Ice%flux_v_top(:,:,k), &
                  Ice%flux_u_top_bgrid(isc:iec,jsc:jec,k), Ice%flux_v_top_bgrid(isc:iec,jsc:jec,k) )
          end do
       endif
    endif

    do k = 1, km
       do j = jsc, jec
          do i = isc, iec
             Ice % flux_t_top(i,j,k)  = Ice % flux_t_top(i,j,k)  * divid
             Ice % flux_q_top(i,j,k)  = Ice % flux_q_top(i,j,k)  * divid
             Ice % flux_sw_nir_dir_top(i,j,k) = Ice % flux_sw_nir_dir_top(i,j,k) * divid
             Ice % flux_sw_nir_dif_top(i,j,k) = Ice % flux_sw_nir_dif_top(i,j,k) * divid
             Ice % flux_sw_vis_dir_top(i,j,k) = Ice % flux_sw_vis_dir_top(i,j,k) * divid
             Ice % flux_sw_vis_dif_top(i,j,k) = Ice % flux_sw_vis_dif_top(i,j,k) * divid
             Ice % flux_lw_top(i,j,k) = Ice % flux_lw_top(i,j,k) * divid
             Ice % fprec_top(i,j,k)   = Ice % fprec_top(i,j,k)   * divid
             Ice % lprec_top(i,j,k)   = Ice % lprec_top(i,j,k)   * divid
             Ice % flux_lh_top(i,j,k) = Ice % flux_lh_top(i,j,k) * divid
             do n = 1, Ice%ocean_fluxes_top%num_bcs  !{
               do m = 1, Ice%ocean_fluxes_top%bc(n)%num_fields  !{
                 Ice%ocean_fluxes_top%bc(n)%field(m)%values(i,j,k) = Ice%ocean_fluxes_top%bc(n)%field(m)%values(i,j,k) * divid
               enddo  !} m
             enddo  !} n
          enddo
       enddo
    enddo

    do j = jsc, jec
       do i = isc, iec
          Ice % lwdn(i,j) = Ice % lwdn(i,j)* divid
          Ice % swdn(i,j) = Ice % swdn(i,j)* divid
       enddo
    enddo
    !
    ! Flux diagnostics
    !
    if (id_sh>0) sent = send_data(id_sh, all_avg(Ice%flux_t_top,Ice%part_size(isc:iec,jsc:jec,:)),     &
         Ice%Time, mask=Ice%mask)
    if (id_lh>0) sent = send_data(id_lh, all_avg(Ice%flux_lh_top,Ice%part_size(isc:iec,jsc:jec,:)),    &
         Ice%Time, mask=Ice%mask)
    if (id_evap>0) sent = send_data(id_evap, all_avg(Ice%flux_q_top,Ice%part_size(isc:iec,jsc:jec,:)), &
         Ice%Time, mask=Ice%mask)
    if (id_sw>0) sent = send_data(id_sw, all_avg(Ice%flux_sw_vis_dir_top+Ice%flux_sw_vis_dif_top+ &
                        Ice%flux_sw_nir_dir_top+Ice%flux_sw_nir_dif_top,Ice%part_size(isc:iec,jsc:jec,:)), &
                        Ice%Time, mask=Ice%mask)
    if (id_lw>0) sent = send_data(id_lw, all_avg(Ice%flux_lw_top,Ice%part_size(isc:iec,jsc:jec,:)),    &
         Ice%Time, mask=Ice%mask)
    if (id_snofl>0) sent = send_data(id_snofl, all_avg(Ice%fprec_top,Ice%part_size(isc:iec,jsc:jec,:)),&
         Ice%Time, mask=Ice%mask)
    if (id_rain>0) sent = send_data(id_rain, all_avg(Ice%lprec_top,Ice%part_size(isc:iec,jsc:jec,:)),  &
         Ice%Time, mask=Ice%mask)
    if (id_lwdn>0) sent = send_data(id_lwdn, Ice%lwdn, Ice%Time, mask=Ice%mask)
    if (id_swdn>0) sent = send_data(id_swdn, Ice%swdn, Ice%Time, mask=Ice%mask)
    if (id_sw_vis>0) sent = send_data(id_sw_vis, all_avg(Ice%flux_sw_vis_dif_top+Ice%flux_sw_vis_dir_top, &
                            Ice%part_size(isc:iec,jsc:jec,:)), Ice%Time, mask=Ice%mask)
    if (id_sw_nir_dir>0) sent = send_data(id_sw_nir_dir, all_avg(Ice%flux_sw_nir_dir_top,Ice%part_size(isc:iec,jsc:jec,:)),    &
         Ice%Time, mask=Ice%mask)
    if (id_sw_nir_dif>0) sent = send_data(id_sw_nir_dif, all_avg(Ice%flux_sw_nir_dif_top,Ice%part_size(isc:iec,jsc:jec,:)),    &
         Ice%Time, mask=Ice%mask)
    if (id_sw_vis_dir>0) sent = send_data(id_sw_vis_dir, all_avg(Ice%flux_sw_vis_dir_top,Ice%part_size(isc:iec,jsc:jec,:)),    &
         Ice%Time, mask=Ice%mask)
    if (id_sw_vis_dif>0) sent = send_data(id_sw_vis_dif, all_avg(Ice%flux_sw_vis_dif_top,Ice%part_size(isc:iec,jsc:jec,:)),    &
         Ice%Time, mask=Ice%mask)

    !
    ! set count to zero and fluxes will be zeroed before the next sum
    !
    Ice % avg_kount = 0

  end subroutine avg_top_quantities

  subroutine ice_top_to_ice_bottom (Ice, part_size, part_size_uv)
    type (ice_data_type), intent(inout) :: Ice
    real, dimension (:,:,:), intent(in) :: part_size, part_size_uv
    integer                             :: m, n

    Ice % flux_u  = all_avg( Ice % flux_u_top_bgrid(isc:iec,jsc:jec,:) , part_size_uv )
    Ice % flux_v  = all_avg( Ice % flux_v_top_bgrid(isc:iec,jsc:jec,:) , part_size_uv )
    Ice % flux_t  = all_avg( Ice % flux_t_top , part_size )
    Ice % flux_q  = all_avg( Ice % flux_q_top , part_size )
    Ice % flux_sw_nir_dir = all_avg( Ice % flux_sw_nir_dir_top, part_size )
    Ice % flux_sw_nir_dif = all_avg( Ice % flux_sw_nir_dif_top, part_size )
    Ice % flux_sw_vis_dir = all_avg( Ice % flux_sw_vis_dir_top, part_size )
    Ice % flux_sw_vis_dif = all_avg( Ice % flux_sw_vis_dif_top, part_size )
    Ice % flux_lw = all_avg( Ice % flux_lw_top, part_size )
    Ice % fprec   = all_avg( Ice % fprec_top  , part_size )
    Ice % lprec   = all_avg( Ice % lprec_top  , part_size )
    Ice % flux_lh = all_avg( Ice % flux_lh_top, part_size )
    do n = 1, Ice%ocean_fluxes%num_bcs  !{
      do m = 1, Ice%ocean_fluxes%bc(n)%num_fields  !{
        Ice%ocean_fluxes%bc(n)%field(m)%values =                &
             all_avg(Ice%ocean_fluxes_top%bc(n)%field(m)%values, part_size)
      enddo  !} m
    enddo  !} n

  end subroutine ice_top_to_ice_bottom

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! ice_bottom_to_ice_top - prepare surface state for atmosphere fast physics    !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine ice_bottom_to_ice_top (Ice, t_surf_ice_bot, u_surf_ice_bot, v_surf_ice_bot, &
                                    frazil_ice_bot, Ocean_ice_boundary, s_surf_ice_bot, sea_lev_ice_bot )
    type (ice_data_type),                    intent(inout) :: Ice
    real, dimension(isc:iec,jsc:jec),           intent(in) :: t_surf_ice_bot, u_surf_ice_bot
    real, dimension(isc:iec,jsc:jec),           intent(in) :: v_surf_ice_bot, frazil_ice_bot
    type(ocean_ice_boundary_type),           intent(inout) :: Ocean_ice_boundary
    real, dimension(isc:iec,jsc:jec), intent(in), optional :: s_surf_ice_bot, sea_lev_ice_bot

    real, dimension(isc:iec,jsc:jec) :: sst, tmp
    real                             :: u, v
    integer                          :: i, j, k, m, n
    logical                          :: sent
    real, parameter                  :: LI = hlf

    !
    ! pass ocean state through ice on first partition
    !
    if (.not. spec_ice) & ! otherwise, already set by update_ice_model_slow
         Ice%t_surf(:,:,1) = t_surf_ice_bot

    if (do_init) then
       call get_sea_surface(Ice%Time, Ice%t_surf(:,:,1), Ice%part_size(isc:iec,jsc:jec,1:2), &
            Ice%h_ice    (isc:iec,jsc:jec,2  ) )
       call mpp_update_domains(Ice%part_size(:,:,1:2), Domain ) ! these two updates cannot be combined
       call mpp_update_domains(Ice%h_ice(:,:,2), Domain )       ! these two updates cannot be combined
       Ice%part_size_uv(:,:,1) = 1.0
       do k=2,km
          call t_to_uv(Ice%part_size(:,:,k),Ice%part_size_uv(:,:,k))
       enddo
       do k=2,km
          do j=jsc,jec
             do i=isc,iec
                Ice%part_size_uv (i,j,1) = Ice%part_size_uv(i,j,1)-Ice%part_size_uv (i,j,k)
             enddo
          end do
       end do
       do_init = .false.
    end if

    if (first_time .and. conservation_check) then
       h2o    = 0.0
       h2o(1) = sum(cell_area*all_avg(DI*Ice%h_ice(isc:iec,jsc:jec,:)+   &
                DS*Ice%h_snow(isc:iec,jsc:jec,:),Ice%part_size(isc:iec,jsc:jec,:)))
       heat   = 0.0

       do k=2,km
          do j=jsc,jec
             do i=isc,iec
                if ((Ice%part_size(i,j,k)>0.0.and.Ice%h_ice(i,j,k)>0.0)) then
                   if (slab_ice) then
                      heat(1) = heat(1) - cell_area(i,j) * Ice%part_size(i,j,k) * Ice%h_ice(i,j,2)*DI*LI
                   else
                      heat(1) = heat(1) - cell_area(i,j) * Ice%part_size(i,j,k) *        &
                                e_to_melt(Ice%h_snow(i,j,k), Ice%h_ice(i,j,k)/2,         &
                                Ice%t_ice1(i,j,k), Ice%h_ice(i,j,k)/2, Ice%t_ice2(i,j,k))
                   end if
                end if
             end do
          end do
       end do
       first_time = .false.;
    end if
    sst = Ice%t_surf(:,:,1)

    if (present(s_surf_ice_bot)) then
       do j = jsc, jec
          do i = isc, iec     
             Ice%s_surf(i,j) = s_surf_ice_bot(i,j)
          enddo
       enddo
    else
       do j = jsc, jec
          do i = isc, iec  
             Ice%s_surf(i,j) = 0.0
          enddo
       enddo
    end if

    do j = jsc,jec
       do i = isc,iec
          Ice%frazil(i,j) = frazil_ice_bot(i,j)
       enddo
    enddo

!       transfer the ocean state for extra tracer fluxes
!

    do n = 1, Ocean_ice_boundary%fields%num_bcs  !{
      do m = 1, Ocean_ice_boundary%fields%bc(n)%num_fields  !{
        Ice%ocean_fields%bc(n)%field(m)%values(:,:,1) = Ocean_ice_boundary%fields%bc(n)%field(m)%values
      enddo  !} m
    enddo  !} n

    if (present(sea_lev_ice_bot)) then
       do j = jsc, jec
          do i = isc, iec  
             Ice%sea_lev(i,j) = sea_lev_ice_bot(i,j)
          enddo
       enddo
    else
       do j = jsc, jec
          do i = isc, iec
             Ice%sea_lev(i,j) = 0.0
          enddo
       enddo
    end if

    call mpp_update_domains(Ice%sea_lev, Domain)

    do k = 2, km
       do j = jsc,jec
          do i = isc,iec  
             Ice % tmelt(i,j,k)   = 0.0
             Ice % bmelt(i,j,k)   = 0.0
          enddo
       enddo
    enddo

    tmp = ice_avg(Ice%h_ice(isc:iec,jsc:jec,:),Ice%part_size(isc:iec,jsc:jec,:) )

    do j = jsc, jec
       do i = isc, iec
          if( tmp(i,j) > 0.0) then
             Ice%bheat(i,j) = kmelt*(sst(i,j)-Tfreeze+MU_TS*Ice%s_surf(i,j))
          else
             Ice%bheat(i,j) = 0.0
          endif
       enddo
    enddo

    do j = jsc, jec
       do i = isc, iec
          Ice%ice_mask(i,j,1) = .false.
       enddo
    enddo

    do k = 2, km
       do j = jsc, jec
          do i = isc, iec
             if(Ice%h_ice(i,j,k) > 0.0) then
                Ice%ice_mask(i,j,k) = .true.
             else
                Ice%ice_mask(i,j,k) = .false.
             endif
          enddo
       enddo
    enddo

    do k=2,km
       do j=jsc, jec
          do i=isc, iec
             if (Ice%ice_mask(i,j,k)) then
                call ice_optics(Ice%albedo(i,j,k), Ice%pen(i,j,k), Ice%trn(i,j,k), &
                     Ice%h_snow(i,j,k), Ice%h_ice(i,j,k), &
                     Ice%t_surf(i,j,k)-Tfreeze, -MU_TS*Ice%s_surf(i,j) )
             end if
          end do
       end do
    end do

!!! THIS NEEDS TO BE DEFINED PROPERLY -- ARE THEY NEEDED ON RESTART ??
!!!  FOR NOW, simply set all values to that of Ice%albedo, In general,
!! the ability to read from restart file and initialize when none
!! present should be incorporated above.
    if (cm2_bugs) then
       do k = 1, km 
          do j = jsc, jec
             do i = isc, iec
                Ice%albedo_vis_dir(i,j,k) = Ice%albedo(i,j,k)
                Ice%albedo_nir_dir(i,j,k) = Ice%albedo(i,j,k)
                Ice%albedo_vis_dif(i,j,k) = Ice%albedo(i,j,k)
                Ice%albedo_nir_dif(i,j,k) = Ice%albedo(i,j,k)
             enddo
          enddo
       enddo
    else
       do k = 2, km 
          do j = jsc, jec
             do i = isc, iec
                Ice%albedo_vis_dir(i,j,k) = Ice%albedo(i,j,k)
                Ice%albedo_nir_dir(i,j,k) = Ice%albedo(i,j,k)
                Ice%albedo_vis_dif(i,j,k) = Ice%albedo(i,j,k)
                Ice%albedo_nir_dif(i,j,k) = Ice%albedo(i,j,k)
             enddo
          enddo
       enddo
    end if

    do j = jsc, jec
       do i = isc, iec
          Ice%u_ocn(i,j) = u_surf_ice_bot(i,j) ! need under-ice current
          Ice%v_ocn(i,j) = v_surf_ice_bot(i,j) ! for water drag term
       enddo
    enddo

    if(reproduce_siena_201303) then
       call mpp_update_domains(Ice%u_ocn, Ice%v_ocn, Domain)
    else
       call mpp_update_domains(Ice%u_ocn, Ice%v_ocn, Domain, gridtype=BGRID_NE)
    endif

    ! put ocean and ice velocities into Ice%u_surf/v_surf on t-cells
    call uv_to_t(Ice%u_ocn, Ice%u_surf(:,:,1))
    call uv_to_t(Ice%v_ocn, Ice%v_surf(:,:,1))

    call uv_to_t(Ice%u_ice, Ice%u_surf(:,:,2))
    call uv_to_t(Ice%v_ice, Ice%v_surf(:,:,2))

    do k=1,2
       do j = jsc, jec
          do i = isc, iec
             u = Ice % u_surf(i,j,k)
             v = Ice % v_surf(i,j,k)
             Ice % u_surf(i,j,k) =  u*cos_rot(i,j)+v*sin_rot(i,j) ! rotate velocity from ocean
             if (cm2_bugs) then
                Ice % v_surf(i,j,k) =  -v*cos_rot(i,j)+u*sin_rot(i,j) ! coord. to lat/lon coord.
             else
                Ice % v_surf(i,j,k) =  v*cos_rot(i,j)-u*sin_rot(i,j) ! coord. to lat/lon coord.
             endif
          end do
       end do
    end do

    do k=3,km
       do j = jsc, jec
          do i = isc, iec
             Ice%u_surf(i,j,k) = Ice%u_surf(i,j,2)  ! same ice flow on all ice partitions
             Ice%v_surf(i,j,k) = Ice%v_surf(i,j,2)  !
          end do
       end do
    end do
    !
    ! Pre-timestep diagnostics
    !
    if (id_sst>0) sent = send_data(id_sst, sst-Tfreeze, Ice%Time, mask=Ice%mask)
    if (id_sss>0) sent = send_data(id_sss, Ice%s_surf , Ice%Time, mask=Ice%mask)
    if (id_ssh>0) sent = send_data(id_ssh, Ice%sea_lev(isc:iec,jsc:jec), Ice%Time, mask=Ice%mask)
    if (id_uo >0) sent = send_data(id_uo , Ice%u_ocn(isc:iec,jsc:jec)  , Ice%Time, mask=Ice%mask)
    if (id_vo >0) sent = send_data(id_vo , Ice%v_ocn(isc:iec,jsc:jec)  , Ice%Time, mask=Ice%mask)
    if (id_bheat>0) sent = send_data(id_bheat, Ice%bheat, Ice%Time, mask=Ice%mask)

  end subroutine ice_bottom_to_ice_top

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! update_ice_model_fast - records fluxes (in Ice) and calculates ice temp. on  !
  !                         (fast) atmospheric timestep (see coupler_main.f90)   !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine update_ice_model_fast_old (Ice, Atmos_boundary_fluxes, flux_u,  flux_v, u_star, &
       flux_sw_nir_dir, flux_sw_nir_dif, flux_sw_vis_dir, flux_sw_vis_dif,&
       flux_lw, flux_t, flux_q, dhdt, dedt, drdt, lprec, fprec, coszen, coszen_radwt, p_surf )

    type (ice_data_type),             intent(inout) :: Ice
    type(coupler_3d_bc_type),         intent(inout) :: Atmos_boundary_fluxes
    real, dimension(isc:iec,jsc:jec,km), intent(in) :: flux_u,  flux_v  ! surface stress (+ up)
    real, dimension(isc:iec,jsc:jec,km), intent(in) :: u_star           ! friction velocity (for ocean roughness)
    real, dimension(isc:iec,jsc:jec,km), intent(in) :: flux_lw          ! net longwave radiation (+ down)
    real, dimension(isc:iec,jsc:jec,km), intent(in) :: flux_t           ! sensible heat flux (+ up)
    real, dimension(isc:iec,jsc:jec,km), intent(in) :: flux_q           ! specific humidity flux (+up)
    real, dimension(isc:iec,jsc:jec,km), intent(in) :: flux_sw_nir_dir ! net near IR direct shortwave radiation (+ down)
    real, dimension(isc:iec,jsc:jec,km), intent(in) :: flux_sw_nir_dif ! net near IR diffuse shortwave radiation (+ down)
    real, dimension(isc:iec,jsc:jec,km), intent(in) :: flux_sw_vis_dir ! net visible direct shortwave radiation (+ down)
    real, dimension(isc:iec,jsc:jec,km), intent(in) :: flux_sw_vis_dif ! net visible diffuse shortwave radiation (+ down)
    real, dimension(isc:iec,jsc:jec,km), intent(in) :: dhdt, dedt, drdt ! d(flux)/d(surf_temp) (+ up)
    real, dimension(isc:iec,jsc:jec,km), intent(in) :: lprec, fprec     ! liquid & frozen precip. rate [kg/(m^2*sec)](+ down)
    real, dimension(isc:iec,jsc:jec,km), intent(in) :: coszen           ! cosine of the zenith angle
    real, dimension(isc:iec,jsc:jec,km), intent(in) :: coszen_radwt     ! cosine of the zenith angle, radiation weighted
    real, dimension(isc:iec,jsc:jec,km), intent(in), optional :: p_surf

    real, dimension(isc:iec,jsc:jec,km) :: flux_t_new, flux_q_new, flux_lh_new, flux_lw_new
    real, dimension(isc:iec,jsc:jec,km) :: flux_sw_nir_dir_new
    real, dimension(isc:iec,jsc:jec,km) :: flux_sw_nir_dif_new
    real, dimension(isc:iec,jsc:jec,km) :: flux_sw_vis_dir_new
    real, dimension(isc:iec,jsc:jec,km) :: flux_sw_vis_dif_new
    real, dimension(isc:iec,jsc:jec,km) :: flux_u_new, flux_v_new, lprec_new, fprec_new
    integer                             :: dy, sc, i, j, k
    real                                :: dt_fast, ts_new, dts, hf, hfd, latent
    logical                             :: sent
    real                                :: gmt, time_since_ae, cosz, rrsun, fracday, fracday_dt_ice, fracday_day
    real, dimension(isc:iec,jsc:jec)    :: diurnal_factor
    real                                :: rad, cosz_day, cosz_dt_ice, rrsun_day, rrsun_dt_ice
    type (time_type)                    :: Dt_ice
    real, dimension(isc:iec,jsc:jec)    :: cosz_alb

    if (id_alb>0) sent = send_data(id_alb, all_avg(Ice%albedo,Ice%part_size(isc:iec,jsc:jec,:)), &
         Ice%Time, mask=Ice%mask)
    !
    ! set up local copies of fluxes for modification
    !
    do k = 1, km
       do j = jsc, jec
          do i = isc, iec
             flux_u_new(i,j,k)  = flux_u(i,j,k)
             flux_v_new(i,j,k)  = flux_v(i,j,k)
             flux_t_new(i,j,k)  = flux_t(i,j,k)
             flux_q_new(i,j,k)  = flux_q(i,j,k)
             flux_lh_new(i,j,k) = hlv*flux_q(i,j,k)
             flux_lw_new(i,j,k) = flux_lw(i,j,k)
             flux_sw_nir_dir_new(i,j,k) = flux_sw_nir_dir(i,j,k)
             flux_sw_nir_dif_new(i,j,k) = flux_sw_nir_dif(i,j,k)
             flux_sw_vis_dir_new(i,j,k) = flux_sw_vis_dir(i,j,k)
             flux_sw_vis_dif_new(i,j,k) = flux_sw_vis_dif(i,j,k)
             lprec_new(i,j,k)   = lprec(i,j,k)
             fprec_new(i,j,k)   = fprec(i,j,k)
          enddo
       enddo
    enddo
    if (add_diurnal_sw .or. do_sun_angle_for_alb) then
!---------------------------------------------------------------------
!    extract time of day (gmt) from time_type variable time with
!    function universal_time.
!---------------------------------------------------------------------
      gmt = universal_time(Ice%Time)
!---------------------------------------------------------------------
!    extract the time of year relative to the northern hemisphere
!    autumnal equinox (time_since_ae) from time_type variable 
!    time using the function orbital_time.
!---------------------------------------------------------------------
      time_since_ae = orbital_time(Ice%Time)
!--------------------------------------------------------------------
!    call diurnal_solar_2d to calculate astronomy fields
!    convert geo_lon and geo_lat to radians
!    Per Rick Hemler:
!      call daily_mean_solar to get cosz (over a day)
!      call diurnal_solar with dtime=Dt_ice to get cosz over Dt_ice
!      diurnal_factor = cosz_dt_ice*fracday_dt_ice*rrsun_dt_ice/cosz_day*fracday_day*rrsun_day
!--------------------------------------------------------------------
      rad = acos(-1.)/180.
      Dt_ice = Ice%Time_step_fast
    endif
    if (add_diurnal_sw) then
      do j = jsc, jec
        do i = isc, iec
          call diurnal_solar(geo_lat(i,j)*rad, geo_lon(i,j)*rad, Ice%time, cosz=cosz_dt_ice,     &
                             fracday=fracday_dt_ice, rrsun=rrsun_dt_ice, dt_time=Dt_ice)
          call daily_mean_solar (geo_lat(i,j)*rad, time_since_ae, cosz_day, fracday_day, rrsun_day)
          diurnal_factor(i,j) = cosz_dt_ice*fracday_dt_ice*rrsun_dt_ice /   &
                                       max(1e-30, cosz_day*fracday_day*rrsun_day)
        enddo
      enddo

      do k = 1, km
        do j = jsc, jec
          do i = isc, iec
            flux_sw_nir_dir_new(i,j,k) = flux_sw_nir_dir(i,j,k) * diurnal_factor(i,j)
            flux_sw_nir_dif_new(i,j,k) = flux_sw_nir_dif(i,j,k) * diurnal_factor(i,j)
            flux_sw_vis_dir_new(i,j,k) = flux_sw_vis_dir(i,j,k) * diurnal_factor(i,j)
            flux_sw_vis_dif_new(i,j,k) = flux_sw_vis_dif(i,j,k) * diurnal_factor(i,j)
          enddo
        enddo
      enddo
    endif

    Ice%p_surf = 0.0
    if (present(p_surf)) &
      Ice%p_surf = all_avg(p_surf,Ice%part_size(isc:iec,jsc:jec,:))

    !
    ! implicit update of ice surface temperature
    !
    call get_time(Ice%Time_step_fast,sc,dy); dt_fast = 864e2*dy+sc

    do k = 2, km
       do j = jsc, jec
          do i=isc, iec
             if (Ice%ice_mask(i,j,k)) then
                if (Ice%h_snow(i,j,k)>0.0 .or. slab_ice) then
                   flux_lh_new(i,j,k) = flux_lh_new(i,j,k) + hlf*flux_q(i,j,k)
                   latent             = hlv+hlf
                else
                   flux_lh_new(i,j,k) = flux_lh_new(i,j,k)+hlf*flux_q(i,j,k)*(1-TFI/Ice%t_ice1(i,j,k))
                   latent             = hlv+hlf*(1-TFI/Ice%t_ice1(i,j,k))
                end if
                hfd = dhdt(i,j,k) + dedt(i,j,k)*latent + drdt(i,j,k)
                hf  = flux_t(i,j,k) + flux_q(i,j,k)*latent - flux_lw(i,j,k)                  &
                      - (1-Ice%pen(i,j,k))* (flux_sw_vis_dir(i,j,k)+flux_sw_vis_dif(i,j,k)+  &
                        flux_sw_nir_dir(i,j,k)+flux_sw_nir_dif(i,j,k))                       &
                      - hfd*(Ice%t_surf(i,j,k)-Tfreeze)
                call ice3lay_temp(Ice%h_snow(i,j,k), Ice%h_ice(i,j,k), Ice%t_ice1(i,j,k),    &
                                  Ice%t_ice2(i,j,k), ts_new, hf, hfd, Ice%pen(i,j,k)*        &
                                  (1-Ice%trn(i,j,k))*(flux_sw_vis_dir(i,j,k)+                &
                                  flux_sw_vis_dif(i,j,k)+flux_sw_nir_dir(i,j,k)+             &
                                  flux_sw_nir_dif(i,j,k)), -MU_TS*Ice%s_surf(i,j),           &
                                  Ice%bheat(i,j), dt_fast, Ice%tmelt(i,j,k), Ice%bmelt(i,j,k))
                dts                = ts_new-(Ice%t_surf(i,j,k)-Tfreeze)
                Ice%t_surf(i,j,k)  = Ice%t_surf(i,j,k)  + dts
                flux_t_new(i,j,k)  = flux_t_new(i,j,k)  + dts * dhdt(i,j,k)
                flux_q_new(i,j,k)  = flux_q_new(i,j,k)  + dts * dedt(i,j,k)
                flux_lh_new(i,j,k) = flux_lh_new(i,j,k) + dts * dedt(i,j,k) * latent
                flux_lw_new(i,j,k) = flux_lw_new(i,j,k) - dts * drdt(i,j,k)
             end if
          end do
       end do
    end do

    call compute_ocean_roughness (Ice%mask, u_star(:,:,1), Ice%rough_mom(:,:,1), &
                                  Ice%rough_heat(:,:,1), Ice%rough_moist(:,:,1)  )

    if(cm2_bugs) then
       call compute_ocean_albedo (Ice%mask, coszen(:,:,1), Ice%albedo(:,:,1), latitude )
       Ice%albedo_vis_dir(:,:,1) = Ice%albedo(:,:,1)
       Ice%albedo_nir_dir(:,:,1) = Ice%albedo(:,:,1)
       Ice%albedo_vis_dif(:,:,1) = Ice%albedo(:,:,1)
       Ice%albedo_nir_dif(:,:,1) = Ice%albedo(:,:,1)
    elseif (do_sun_angle_for_alb) then
      call diurnal_solar(geo_lat*rad, geo_lon*rad, Ice%time, cosz=cosz_alb,	&
			     fracday=diurnal_factor, rrsun=rrsun_dt_ice, dt_time=Dt_ice)  !diurnal_factor as dummy
      call compute_ocean_albedo (Ice%mask, cosz_alb(:,:), Ice%albedo_vis_dir(:,:,1),&
                                   Ice%albedo_vis_dif(:,:,1), Ice%albedo_nir_dir(:,:,1),&
                                   Ice%albedo_nir_dif(:,:,1), latitude )
    else
      call compute_ocean_albedo (Ice%mask, coszen(:,:,1), Ice%albedo_vis_dir(:,:,1),&
                                 Ice%albedo_vis_dif(:,:,1), Ice%albedo_nir_dir(:,:,1),&
                                 Ice%albedo_nir_dif(:,:,1), latitude, coszen_radwt(:,:,1) )
    endif

    if (id_alb_vis_dir>0) sent = send_data(id_alb_vis_dir, all_avg(Ice%albedo_vis_dir,Ice%part_size(isc:iec,jsc:jec,:)), &
         Ice%Time, mask=Ice%mask)
    if (id_alb_vis_dif>0) sent = send_data(id_alb_vis_dif, all_avg(Ice%albedo_vis_dif,Ice%part_size(isc:iec,jsc:jec,:)), &
         Ice%Time, mask=Ice%mask)
    if (id_alb_nir_dir>0) sent = send_data(id_alb_nir_dir, all_avg(Ice%albedo_nir_dir,Ice%part_size(isc:iec,jsc:jec,:)), &
         Ice%Time, mask=Ice%mask)
    if (id_alb_nir_dif>0) sent = send_data(id_alb_nir_dif, all_avg(Ice%albedo_nir_dif,Ice%part_size(isc:iec,jsc:jec,:)), &
         Ice%Time, mask=Ice%mask)

    call sum_top_quantities ( Ice, Atmos_boundary_fluxes, flux_u_new,  flux_v_new, flux_t_new, &
      flux_q_new, flux_sw_nir_dir_new, flux_sw_nir_dif_new, flux_sw_vis_dir_new,               &
      flux_sw_vis_dif_new, flux_lw_new, lprec_new,   fprec_new,  flux_lh_new )

    Ice%Time = Ice%Time + Ice%Time_step_fast ! advance time

  end subroutine update_ice_model_fast_old

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! update_ice_model_slow - do ice dynamics, transport, and mass changes         !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine update_ice_model_slow (Ice, runoff, calving, &
                                         runoff_hflx, calving_hflx, p_surf)

    type (ice_data_type),             intent(inout)        :: Ice
    real, dimension(isc:iec,jsc:jec), intent(in), optional :: runoff, calving
    real, dimension(isc:iec,jsc:jec), intent(in), optional :: runoff_hflx, calving_hflx
    real, dimension(:,:,:),           intent(in), optional :: p_surf ! obsolete

    real, dimension(isc:iec,jsc:jec)      :: fx_ice, fy_ice
    real, dimension(isc:iec,jsc:jec)      :: fx_cor, fy_cor
    real, dimension(isc:iec,jsc:jec)      :: fx_wat, fy_wat
    real, dimension(isc:iec,jsc:jec)      :: hi_change, h2o_change, bsnk, x
    real, dimension(isc:iec,jsc:jec,2:km) :: snow_to_ice
    real, dimension(isc:iec,jsc:jec,km)   :: part_save, part_save_uv
    real, dimension(isc:iec,jsc:jec)      :: dum1, Obs_h_ice ! for qflux calculation
    real, dimension(isc:iec,jsc:jec,2)    :: Obs_cn_ice      ! partition 2 = ice concentration
    real, dimension(isd:ied,jsd:jed)      :: tmp1, tmp2
    real, dimension(2:km)                 :: e2m
    integer                               :: i, j, k, l, sc, dy, iyr, imon, iday, ihr, imin, isec
    real                                  :: dt_slow, heat_to_ocn, h2o_to_ocn, h2o_from_ocn, sn2ic, bablt
    real                                  :: heat_limit_ice, heat_res_ice
    real                                  :: tot_heat, heating, tot_frazil
    logical                               :: sent
    real, parameter                       :: LI = hlf

    call get_time(Ice%Time_step_slow,sc,dy); dt_slow = 864e2*dy+sc
    !
    ! Fluxes
    !
    if (present( runoff)) then ! save liquid runoff for ocean
       do j = jsc, jec
          do i = isc, iec
             Ice % runoff(i,j)  = runoff(i,j)
          enddo
       enddo
       if (id_runoff>0) &
            sent = send_data( id_runoff, Ice%runoff, Ice%Time, mask=Ice%mask )
    else
       do j = jsc, jec
          do i = isc, iec
             Ice % runoff(i,j) = 0.0
          enddo
       enddo
    endif

    if (present(calving)) then ! save frozen runoff for ocean
       do j = jsc, jec
          do i = isc, iec
             Ice % calving(i,j) = calving(i,j)
          enddo
       enddo
       if (id_calving>0) &
            sent = send_data(id_calving, Ice%calving, Ice%Time, mask=Ice%mask )
    else
       do j = jsc, jec
          do i = isc, iec
             Ice % calving(i,j) = 0.0
          enddo
       enddo
    endif

    if (present( runoff_hflx)) then ! save liquid runoff hflx for ocean
       do j = jsc, jec
          do i = isc, iec
             Ice % runoff_hflx(i,j)  = runoff_hflx(i,j)
          enddo
       enddo
       if (id_runoff_hflx>0) &
            sent = send_data( id_runoff_hflx, Ice%runoff_hflx, Ice%Time, mask=Ice%mask )
    else
       do j = jsc, jec
          do i = isc, iec
             Ice % runoff_hflx(i,j) = 0.0
          enddo
       enddo
    endif

    if (present(calving_hflx)) then ! save frozen runoff hflx for ocean
       do j = jsc, jec
          do i = isc, iec
             Ice % calving_hflx(i,j) = calving_hflx(i,j)
          enddo
       enddo
       if (id_calving_hflx>0) &
            sent = send_data(id_calving_hflx, Ice%calving_hflx, Ice%Time, mask=Ice%mask )
    else
       do j = jsc, jec
          do i = isc, iec
             Ice % calving_hflx(i,j) = 0.0
          enddo
       enddo
    endif

    !TOM> assume that open water area is not up to date:
    call mpp_clock_end(iceClock)
    call mpp_clock_end(iceClock2)
    tmp1=1.-max(1.-sum(Ice%part_size(:,:,2:km),dim=3),0.0)
    tmp2=ice_avg(Ice%h_ice,Ice%part_size)
    ! Calve off icebergs and integrate forward iceberg trajectories
    if (do_icebergs) call icebergs_run( Ice%icebergs,Ice%Time,                 &
                      Ice%calving, Ice%u_ocn, Ice%v_ocn, Ice%u_ice, Ice%v_ice, &
                      Ice%flux_u, Ice%flux_v, Ice%sea_lev, Ice%t_surf(:,:,1),  &
                      Ice%calving_hflx, tmp1, tmp2)
    call mpp_clock_begin(iceClock2)
    call mpp_clock_begin(iceClock)

    call avg_top_quantities(Ice) ! average fluxes from update_ice_model_fast

    do k = 1, km
       do j = jsc, jec
          do i = isc, iec
             part_save(i,j,k)    = Ice%part_size(i,j,k)
             part_save_uv(i,j,k) = Ice%part_size_uv(i,j,k)
          enddo
       enddo
    enddo
    !
    ! conservation checks: top fluxes
    !
    call mpp_clock_begin(iceClock7)
    if (conservation_check) then
       h2o(2) = h2o(2)+dt_slow*sum(cell_area*(Ice%runoff+Ice%calving                                  &
               +all_avg(Ice%lprec_top+Ice%fprec_top-Ice%flux_q_top,Ice%part_size(isc:iec,jsc:jec,:))),&
                cell_area > 0 )
       heat(2) = heat(2)+dt_slow*sum(cell_area*(                              &
                 all_avg(Ice%flux_sw_vis_dir_top+Ice%flux_sw_vis_dif_top      &
                +Ice%flux_sw_nir_dir_top+Ice%flux_sw_nir_dif_top,             &
                 Ice%part_size(isc:iec,jsc:jec,:))                            &
                +all_avg(Ice%flux_lw_top, Ice%part_size(isc:iec,jsc:jec,:))   &
                -all_avg(Ice%flux_t_top , Ice%part_size(isc:iec,jsc:jec,:))   &
                -all_avg(Ice%flux_lh_top, Ice%part_size(isc:iec,jsc:jec,:))   &
                -LI*(all_avg(Ice%fprec_top,Ice%part_size(isc:iec,jsc:jec,:))  &
                +Ice%calving)), cell_area > 0 )
       tot_frazil = sum(cell_area*Ice%frazil)
    end if
    call mpp_clock_end(iceClock7)

    ! Dynamics
    !

    call mpp_clock_begin(iceClock4)
    tmp1 = ice_avg(Ice%h_snow,Ice%part_size)
    tmp2 = ice_avg(Ice%h_ice,Ice%part_size)

    call mpp_clock_begin(iceClocka)
    if(reproduce_siena_201303) then
       call ice_dynamics(1-Ice%part_size(:,:,1), tmp1, tmp2, Ice%u_ice, Ice%v_ice,                      &
                         Ice%sig11, Ice%sig22, Ice%sig12, Ice%u_ocn, Ice%v_ocn,                         &
                         ice_avg(Ice%flux_u_top_bgrid(isc:iec,jsc:jec,:),Ice%part_size(isc:iec,jsc:jec,:) ),  &
                         ice_avg(Ice%flux_v_top_bgrid(isc:iec,jsc:jec,:),Ice%part_size(isc:iec,jsc:jec,:) ),  &
                         Ice%sea_lev, fx_wat, fy_wat, fx_ice, fy_ice, fx_cor, fy_cor)
    else
       call ice_dynamics(1-Ice%part_size(:,:,1), tmp1, tmp2, Ice%u_ice, Ice%v_ice,                      &
                         Ice%sig11, Ice%sig22, Ice%sig12, Ice%u_ocn, Ice%v_ocn,                         &
                         ice_avg(Ice%flux_u_top_bgrid(isc:iec,jsc:jec,:),Ice%part_size_uv(isc:iec,jsc:jec,:) ),  &
                         ice_avg(Ice%flux_v_top_bgrid(isc:iec,jsc:jec,:),Ice%part_size_uv(isc:iec,jsc:jec,:) ),  &
                         Ice%sea_lev, fx_wat, fy_wat, fx_ice, fy_ice, fx_cor, fy_cor)
    endif
    call mpp_clock_end(iceClocka)

    call mpp_clock_begin(iceClockb)
    if(reproduce_siena_201303) then
       call mpp_update_domains(Ice%u_ice, Ice%v_ice, Domain)
       if(tripolar_grid) then
          call cut_check('u_ice', Ice%u_ice) ! these calls fix round off differences
          call cut_check('v_ice', Ice%v_ice) ! in northernmost velocities over the fold
          call mpp_update_domains(Ice%u_ice, Ice%v_ice, Domain)
       endif
    else
       call mpp_update_domains(Ice%u_ice, Ice%v_ice, Domain, gridtype=BGRID_NE)
    endif
    call mpp_clock_end(iceClockb)

    call mpp_clock_begin(iceClockc)
    !
    ! Dynamics diagnostics
    !
    if (id_fax>0) &
         sent = send_data(id_fax, all_avg(Ice%flux_u_top_bgrid(isc:iec,jsc:jec,:),Ice%part_size_uv), Ice%Time)
    if (id_fay>0) &
         sent = send_data(id_fay, all_avg(Ice%flux_v_top_bgrid(isc:iec,jsc:jec,:),Ice%part_size_uv), Ice%Time)
    if (id_fix>0) sent = send_data(id_fix, fx_ice, Ice%Time)
    if (id_fiy>0) sent = send_data(id_fiy, fy_ice, Ice%Time)
    if (id_fcx>0) sent = send_data(id_fcx, fx_cor, Ice%Time)
    if (id_fcy>0) sent = send_data(id_fcy, fy_cor, Ice%Time)
    if (id_fwx>0) sent = send_data(id_fwx, -fx_wat, Ice%Time) ! water force on ice
    if (id_fwy>0) sent = send_data(id_fwy, -fy_wat, Ice%Time) ! ...= -ice on water

    if (id_strna>0) &
         sent = send_data(id_strna, strain_angle(Ice%u_ice,Ice%v_ice), Ice%Time, mask=Ice%mask)
    if (id_sigi>0)  sent = send_data(id_sigi, sigI(ice_avg(Ice%h_ice(isc:iec,jsc:jec,:),          &
                    Ice%part_size(isc:iec,jsc:jec,:)),1-Ice%part_size(isc:iec,jsc:jec,1),         &
                    Ice%sig11(isc:iec,jsc:jec),Ice%sig22(isc:iec,jsc:jec),Ice%sig12(isc:iec,jsc:jec)), &
                    Ice%Time, mask=Ice%mask)
    if (id_sigii>0) sent = send_data(id_sigii, sigII(ice_avg(Ice%h_ice(isc:iec,jsc:jec,:),        &
                    Ice%part_size(isc:iec,jsc:jec,:)),1-Ice%part_size(isc:iec,jsc:jec,1),         &
                    Ice%sig11(isc:iec,jsc:jec),Ice%sig22(isc:iec,jsc:jec),Ice%sig12(isc:iec,jsc:jec)), &
                    Ice%Time, mask=Ice%mask)
    if (id_stren>0) sent = send_data(id_stren, ice_strength(ice_avg(Ice%h_ice(isc:iec,jsc:jec,:), &
                    Ice%part_size(isc:iec,jsc:jec,:)), 1-Ice%part_size(isc:iec,jsc:jec,1)), Ice%Time, mask=Ice%mask)

    if (id_ui>0) sent = send_data(id_ui, Ice%u_ice(isc:iec,jsc:jec), Ice%Time)
    if (id_vi>0) sent = send_data(id_vi, Ice%v_ice(isc:iec,jsc:jec), Ice%Time)

    do k=2,km
       do j = jsc, jec
          do i = isc, iec
             Ice%flux_u_top_bgrid(i,j,k) = fx_wat(i,j)  ! stress of ice on ocean
             Ice%flux_v_top_bgrid(i,j,k) = fy_wat(i,j)  !
          enddo
       enddo
    end do
    call mpp_clock_end(iceClockc)
    call mpp_clock_end(iceClock4)

    !
    ! Thermodynamics
    !
    call mpp_clock_begin(iceClock5)
    if (id_frazil>0) sent = send_data(id_frazil, Ice%frazil/dt_slow,  Ice%Time, mask=Ice%mask)
    snow_to_ice = 0
    bsnk        = 0

    hi_change  = all_avg(Ice%h_ice(isc:iec,jsc:jec,:), Ice%part_size(isc:iec,jsc:jec,:))
    h2o_change = all_avg(DS*Ice%h_snow(isc:iec,jsc:jec,:)+DI*Ice%h_ice(isc:iec,jsc:jec,:),Ice%part_size(isc:iec,jsc:jec,:))

    ! get observed ice thickness for ice restoring, if calculating qflux
    if (do_ice_restore) &
         call get_sea_surface(Ice%Time, dum1, Obs_cn_ice, Obs_h_ice)
    do k=2,km
       do j=jsc, jec
          do i=isc, iec 
             if (cell_area(i,j) > 0 .and.Ice%h_ice(i,j,k) > 0) then
                ! reshape the ice based on fluxes

                h2o_from_ocn = 0.0; h2o_to_ocn = 0.0; heat_to_ocn = 0.0
                call ice3lay_resize(Ice%h_snow(i,j,k), Ice%h_ice(i,j,k),               &
                                    Ice%t_ice1(i,j,k), Ice%t_ice2(i,j,k),              &
                                    Ice%fprec_top(i,j,k) *dt_slow, 0.0,                &
                                    Ice%flux_q_top(i,j,k)*dt_slow,                     &
                                    Ice%tmelt (i,j,k), Ice%bmelt(i,j,k),               &
                                    -MU_TS*Ice%s_surf(i,j),                            &
                                    heat_to_ocn, h2o_to_ocn, h2o_from_ocn,             &
                                    snow_to_ice(i,j,k), bablt                          )

                ! modify above-ice to under-ice fluxes for passing to ocean
                Ice%flux_q_top (i,j,k) = h2o_from_ocn/dt_slow ! no ice, evaporation left
                Ice%flux_lh_top(i,j,k) = hlv*Ice%flux_q_top(i,j,k)
                Ice%flux_lw_top(i,j,k) = 0.0
                Ice%flux_t_top (i,j,k) = Ice%bheat(i,j)-heat_to_ocn/dt_slow
                Ice%flux_sw_vis_dif_top(i,j,k) = (Ice%flux_sw_vis_dir_top(i,j,k)+      &
                      Ice%flux_sw_vis_dif_top(i,j,k)+Ice%flux_sw_nir_dir_top(i,j,k)+   &
                      Ice%flux_sw_nir_dif_top(i,j,k))*Ice%pen(i,j,k)*Ice%trn(i,j,k)
                Ice%flux_sw_nir_dir_top(i,j,k) = 0.0
                Ice%flux_sw_nir_dif_top(i,j,k) = 0.0
                Ice%flux_sw_vis_dir_top(i,j,k) = 0.0
                Ice%fprec_top  (i,j,k) = 0.0
                Ice%lprec_top  (i,j,k) = Ice%lprec_top(i,j,k) + h2o_to_ocn/dt_slow

                bsnk(i,j) = bsnk(i,j) - Ice%part_size(i,j,k)*bablt ! bot. melt. ablation

             end if
             !
             ! absorb frazil in thinest ice partition available
             !
             if (Ice%frazil(i,j)>0.and.Ice%part_size(i,j,1)+Ice%part_size(i,j,k)>0) then
                Ice%h_snow   (i,j,k) = Ice%h_snow   (i,j,k) * Ice%part_size(i,j,k)
                Ice%h_ice    (i,j,k) = Ice%h_ice    (i,j,k) * Ice%part_size(i,j,k)
                Ice%t_surf   (i,j,k) = (Ice%t_surf(i,j,k)    *Ice%part_size(i,j,k) &
                                     + (Tfreeze-MU_TS*Ice%s_surf(i,j))*Ice%part_size(i,j,1))
                Ice%part_size(i,j,k) = Ice%part_size(i,j,k) + Ice%part_size(i,j,1)
                Ice%part_size(i,j,1) = 0.0
                Ice%h_snow   (i,j,k) = Ice%h_snow   (i,j,k) / Ice%part_size(i,j,k)
                Ice%h_ice    (i,j,k) = Ice%h_ice    (i,j,k) / Ice%part_size(i,j,k)
                Ice%t_surf   (i,j,k) = Ice%t_surf   (i,j,k) / Ice%part_size(i,j,k)

                call ice3lay_resize(Ice%h_snow(i,j,k), Ice%h_ice (i,j,k),                &
                                    Ice%t_ice1(i,j,k), Ice%t_ice2(i,j,k), 0.0,           &
                                    Ice%frazil(i,j)/Ice%part_size(i,j,k), 0.0, 0.0, 0.0, &
                                    -MU_TS*Ice%s_surf(i,j),                              &
                                    heat_to_ocn, h2o_to_ocn, h2o_from_ocn, sn2ic)
                Ice%frazil(i,j) = 0.0;
                !
                ! spread frazil salinification over all partitions
                !
                Ice%lprec_top  (i,j,:) = Ice%lprec_top(i,j,:) + h2o_to_ocn*Ice%part_size(i,j,k)/dt_slow
             end if

          end do  ! i-loop
       end do   ! j-loop
    end do   ! k-loop
    call mpp_clock_end(iceClock5)

    !
    ! Calculate QFLUX's from (1) restoring to obs and (2) limiting total ice.
    !
    call mpp_clock_begin(iceClock6)
    if (do_ice_restore .or. do_ice_limit) then
       do j = jsc, jec
          do i = isc, iec
             Ice % qflx_lim_ice(i,j) = 0.0
             Ice % qflx_res_ice(i,j) = 0.0
          enddo
       enddo

       do j=jsc, jec
          do i=isc, iec
             heat_res_ice   = 0.0
             heat_limit_ice = 0.0
             !
             ! calculate enthalpy
             !
             if (slab_ice) then
                e2m(2) = Ice%h_ice(i,j,2)*DI*LI
             else
                do k=2,km
                   if ((Ice%part_size(i,j,k)>0.0.and.Ice%h_ice(i,j,k)>0.0)) then
                      e2m(k) = e_to_melt(Ice%h_snow(i,j,k), Ice%h_ice(i,j,k)/2, &
                               Ice%t_ice1(i,j,k), Ice%h_ice(i,j,k)/2,           &
                               Ice%t_ice2(i,j,k)) * Ice%part_size(i,j,k)
                   else
                      e2m(k) = 0.0
                   end if
                end do
             end if
             !
             ! calculate heat needed to constrain ice enthalpy
             !
             if (do_ice_restore) then
                ! TK Mod: restore to observed enthalpy (no change for slab, but for
                !         sis ice, results in restoring toward thickness * concentration      

                ! TK Mod for test 10/18/02
                !   Concentration is 1.0 where there is ice for slab case.
                !   The input field Obs_cn_ice may have values less than 1,
                !     so put in if test...

                if (slab_ice) then
                   heat_res_ice = -(LI*DI*Obs_h_ice(i,j)-sum(e2m)) &
                                  *dt_slow/(86400*ice_restore_timescale)
                else                   
                   heat_res_ice = -(LI*DI*Obs_h_ice(i,j)*Obs_cn_ice(i,j,2)-sum(e2m)) &
                                  *dt_slow/(86400*ice_restore_timescale)
                end if

                !        heat_res_ice = -(LI*DI*Obs_h_ice(i,j)-sum(e2m)) &
                !                        *dt_slow/(86400*ice_restore_timescale)

             end if

             if (do_ice_limit .and. (sum(e2m) > max_ice_limit*DI*LI)) then
                heat_limit_ice = sum(e2m)-LI*DI*max_ice_limit
                ! should we "heat_ice_res = 0.0" ?
             end if

             !
             ! apply constraining heat to ice
             !
             tot_heat = heat_res_ice+heat_limit_ice
             if (slab_ice) Ice%h_ice (i,j,2) = Ice%h_ice (i,j,2) - tot_heat/(DI*LI)

             if (.not. slab_ice .and. (tot_heat>0.0)) then  ! add like ocean-ice heat
                do k=2,km
                   if (e2m(k) > 0.0) then
                      heating = tot_heat/sum(Ice%part_size(i,j,k:km))
                      if (heating*Ice%part_size(i,j,k) > e2m(k)) then ! cat. melts away
                         Ice%h_ice (i,j,k) = 0.0
                         Ice%h_snow(i,j,k) = 0.0
                         tot_heat = tot_heat - e2m(k)
                      else
                         h2o_from_ocn = 0.0; h2o_to_ocn = 0.0; heat_to_ocn = 0.0
                         call ice3lay_resize(Ice%h_snow(i,j,k), Ice%h_ice(i,j,k),   &
                                             Ice%t_ice1(i,j,k), Ice%t_ice2(i,j,k),  &
                                             0.0, 0.0, 0.0, 0.0, heating,           &
                                             -MU_TS*Ice%s_surf(i,j),                &
                                             heat_to_ocn, h2o_to_ocn, h2o_from_ocn, &
                                             snow_to_ice(i,j,k), bablt              )
                         tot_heat = tot_heat - heating*Ice%part_size(i,j,k)
                      end if
                   end if
                end do
             end if

             tot_heat = heat_res_ice+heat_limit_ice
             if (.not. slab_ice .and. (tot_heat<0.0)) then ! add like frazil
                do k=2,km
                   if (Ice%part_size(i,j,1)+Ice%part_size(i,j,k)>0) exit
                end do
                ! k is thinnest ice partition that can recieve frazil
                Ice%h_snow   (i,j,k) = Ice%h_snow   (i,j,k) * Ice%part_size(i,j,k)
                Ice%h_ice    (i,j,k) = Ice%h_ice    (i,j,k) * Ice%part_size(i,j,k)
                Ice%t_surf   (i,j,k) = (Ice%t_surf(i,j,k)    *Ice%part_size(i,j,k) &
                                     +(Tfreeze-MU_TS*Ice%s_surf(i,j))*Ice%part_size(i,j,1))
                Ice%part_size(i,j,k) = Ice%part_size(i,j,k) + Ice%part_size(i,j,1)
                Ice%part_size(i,j,1) = 0.0
                Ice%h_snow   (i,j,k) = Ice%h_snow   (i,j,k) / Ice%part_size(i,j,k)
                Ice%h_ice    (i,j,k) = Ice%h_ice    (i,j,k) / Ice%part_size(i,j,k)
                Ice%t_surf   (i,j,k) = Ice%t_surf   (i,j,k) / Ice%part_size(i,j,k)

                call ice3lay_resize(Ice%h_snow(i,j,k), Ice%h_ice (i,j,k),          &
                                    Ice%t_ice1(i,j,k), Ice%t_ice2(i,j,k), 0.0,     &
                                    -tot_heat/Ice%part_size(i,j,k), 0.0, 0.0, 0.0, &
                                    -MU_TS*Ice%s_surf(i,j),                        &
                                    heat_to_ocn, h2o_to_ocn, h2o_from_ocn, sn2ic)
             end if

             ! Convert constraining heat from energy (J/m^2) to flux (W/m^2)
             Ice%qflx_lim_ice(i,j) = heat_limit_ice / dt_slow
             Ice%qflx_res_ice(i,j) = heat_res_ice / dt_slow
             !
             ! Check for energy conservation
             !
             if (slab_ice) then
                e2m(2) = e2m(2) - Ice%h_ice(i,j,2)*DI*LI
             else
                do k=2,km
                   if (Ice%part_size(i,j,k)>0.0.and.Ice%h_ice(i,j,k)>0.0)                &
                        e2m(k) = e2m(k)-e_to_melt(Ice%h_snow(i,j,k), Ice%h_ice(i,j,k)/2, &
                                 Ice%t_ice1(i,j,k), Ice%h_ice(i,j,k)/2,                  &
                                 Ice%t_ice2(i,j,k)) * Ice%part_size(i,j,k)
                end do
             end if
             !     if (abs(sum(e2m) - heat_res_ice - heat_limit_ice)>DI*LI*1e-3) &
                  !       print *, 'QFLUX conservation error at', i, j, 'heat2ice=',  &
             !                 tot_heat, 'melted=', sum(e2m), 'h*part_size=',    &
                  !                 Ice%h_ice(i,j,:)*Ice%part_size(i,j,:)

          end do
       end do
    end if
    call mpp_clock_end(iceClock6)
    !
    ! Salt fluxes to ocean
    !
    call mpp_clock_begin(iceClock8)
    hi_change  = all_avg(Ice%h_ice(isc:iec,jsc:jec,:), Ice%part_size(isc:iec,jsc:jec,:))-hi_change
    Ice%flux_salt = ice_bulk_salin*DI*hi_change/dt_slow
    if (id_saltf>0)  sent = send_data(id_saltf, Ice%flux_salt, Ice%Time, mask=Ice%mask)

    h2o_change = all_avg(DS*Ice%h_snow(isc:iec,jsc:jec,:)+DI*Ice%h_ice(isc:iec,jsc:jec,:), &
                 Ice%part_size(isc:iec,jsc:jec,:))-h2o_change

    if (id_lsnk>0) then
       x = h2o_change*864e2*365/dt_slow
       do j = jsc, jec
          do i = isc, iec
             if(x(i,j)>0.0) x(i,j) = 0.0
          enddo
       enddo
       sent = send_data(id_lsnk, x, Ice%Time, mask=Ice%mask)
    end if
    if (id_lsrc>0) then
       x = h2o_change*864e2*365/dt_slow
       do j = jsc, jec
          do i = isc, iec
             if(x(i,j)<0.0) x(i,j) = 0.0
          enddo
       enddo
       sent = send_data(id_lsrc,  x, Ice%Time, mask=Ice%mask)
    end if
    if (id_bsnk>0)  sent = send_data(id_bsnk, bsnk*864e2*365/dt_slow, Ice%Time, mask=Ice%mask)
    if (id_tmelt>0) sent = send_data(id_tmelt, ice_avg(Ice%tmelt,Ice%part_size(isc:iec,jsc:jec,:))/dt_slow,   &
                           Ice%Time, mask=Ice%mask)
    if (id_bmelt>0) sent = send_data(id_bmelt, ice_avg(Ice%bmelt,Ice%part_size(isc:iec,jsc:jec,:))/dt_slow,   &
                           Ice%Time, mask=Ice%mask)
    if (id_sn2ic>0) sent = send_data(id_sn2ic, all_avg(snow_to_ice,Ice%part_size(isc:iec,jsc:jec,:))/dt_slow, &
                           Ice%Time, mask=Ice%mask                     )
    if (id_qflim>0) sent = send_data(id_qflim, Ice%qflx_lim_ice, Ice%Time, mask=Ice%mask)
    if (id_qfres>0) sent = send_data(id_qfres, Ice%qflx_res_ice, Ice%Time, mask=Ice%mask)
    !
    ! Ice transport ... all ocean fluxes have been calculated by now
    !
    h2o_change = all_avg(DS*Ice%h_snow(isc:iec,jsc:jec,:)+DI*Ice%h_ice(isc:iec,jsc:jec,:),Ice%part_size(isc:iec,jsc:jec,:))
    call transport(Ice)

    x = all_avg(DS*Ice%h_snow(isc:iec,jsc:jec,:)+DI*Ice%h_ice(isc:iec,jsc:jec,:),Ice%part_size(isc:iec,jsc:jec,:))
    if (id_mi>0) sent = send_data(id_mi, x, Ice%Time, mask = Ice%mask)
    
    do j = jsc, jec
       do i = isc, iec
         Ice%mi(i,j) = x(i,j) 
       enddo
    enddo

    if (do_icebergs) call icebergs_incr_mass(Ice%icebergs, x) ! Add icebergs mass in kg/m^2
    if (id_mib>0) sent = send_data(id_mib, x, Ice%Time, mask = Ice%mask) ! Diagnose total mass
    if (id_slp>0) sent = send_data(id_slp, Ice%p_surf, Ice%Time, mask=Ice%mask)
    do j = jsc, jec
       do i = isc, iec
          if (slp2ocean) then
            Ice%p_surf(i,j) = Ice%p_surf(i,j)-1e5
          else
            Ice%p_surf(i,j) = 0.0
          endif
          Ice%p_surf(i,j) = Ice%p_surf(i,j) + grav*x(i,j)
       enddo
    enddo
    h2o_change = x-h2o_change

    if (spec_ice) then                  ! over-write changes with specifications
         call get_sea_surface(Ice%Time, Ice%t_surf(:,:,1), Ice%part_size(isc:iec,jsc:jec,:), Ice%h_ice (isc:iec,jsc:jec,2))
         call mpp_update_domains(Ice%part_size, Domain)
    endif
    do j = jsd, jed
       do i = isd, ied
          Ice%part_size   (i,j,1) = 1.0
       enddo
    enddo

    do j = jsc, jec
       do i = isc, iec
          Ice%part_size_uv(i,j,1) = 1.0
       enddo
    enddo

    do k=2,km
       do j = jsd, jed
          do i = isd, ied
             Ice%part_size(i,j,1) = Ice%part_size   (i,j,1) - Ice%part_size   (i,j,k)
          enddo
       enddo
    enddo
    do k=2,km
       call t_to_uv(Ice%part_size(:,:,k),Ice%part_size_uv(:,:,k))
       Ice%part_size_uv(:,:,1) = Ice%part_size_uv(:,:,1) - Ice%part_size_uv(:,:,k)
    end do
    call mpp_clock_end(iceClock8)
    !
    ! Thermodynamics diagnostics
    !
    call mpp_clock_begin(iceClock9)
    if (id_cn>0) sent = send_data(id_cn, Ice%part_size(isc:iec,jsc:jec,2:km), Ice%Time, mask=spread(Ice%mask,3,km-1)       )

    ! TK Mod: 10/18/02
    !  if (id_obs_cn>0) sent = send_data(id_obs_cn, Obs_cn_ice(:,:,2), Ice%Time, &
         !                                       mask=Ice%mask       )

    if (id_ext>0) sent = send_data(id_ext, ext(Ice%part_size(isc:iec,jsc:jec,1)), Ice%Time, mask=Ice%mask)
    if (id_wnd>0) sent = send_data(id_wnd, Ice%wnd(isc:iec,jsc:jec,1), Ice%Time, mask=Ice%mask)

    if (id_hs>0) sent  = send_data(id_hs, ice_avg(Ice%h_snow(isc:iec,jsc:jec,:),Ice%part_size(isc:iec,jsc:jec,:)), &
                         Ice%Time, mask=Ice%mask)
    if (id_hi>0) sent  = send_data(id_hi, ice_avg(Ice%h_ice(isc:iec,jsc:jec,:) ,Ice%part_size(isc:iec,jsc:jec,:)), &
                         Ice%Time, mask=Ice%mask)

    ! TK Mod: 10/18/02: (commented out...does not compile yet... add later
    !  if (id_obs_hi>0) &
         !    sent = send_data(id_obs_hi, ice_avg(Obs_h_ice,Ice%part_size), Ice%Time, &
    !                     mask=Ice%mask)

    if (id_ts>0) sent = send_data(id_ts, ice_avg(Ice%t_surf-Tfreeze,Ice%part_size(isc:iec,jsc:jec,:)), Ice%Time, mask=Ice%mask)
    if (id_t1>0) sent = send_data(id_t1, ice_avg(Ice%t_ice1(isc:iec,jsc:jec,:),Ice%part_size(isc:iec,jsc:jec,:)), &
                 Ice%Time, mask=Ice%mask)
    if (id_t2>0) sent = send_data(id_t2, ice_avg(Ice%t_ice2(isc:iec,jsc:jec,:),Ice%part_size(isc:iec,jsc:jec,:)), &
                 Ice%Time, mask=Ice%mask)
    if (id_xprt>0) sent = send_data(id_xprt,  h2o_change*864e2*365/dt_slow, Ice%Time, mask=Ice%mask)
    if (id_e2m>0) then
       x = 0.0
       do k = 2, km
          do j = jsc, jec
             do i=isc, iec
                if (Ice%h_ice(i,j,k)>0.0)                                                 &
                     x(i,j) = x(i,j) + Ice%part_size(i,j,k)*e_to_melt(Ice%h_snow(i,j,k),  &
                              Ice%h_ice(i,j,k)/2, Ice%t_ice1(i,j,k), Ice%h_ice(i,j,k)/2, Ice%t_ice2(i,j,k) )
             end do
          end do
       end do
       sent = send_data(id_e2m,  x, Ice%Time, mask=Ice%mask)
    end if

    call ice_top_to_ice_bottom(Ice, part_save, part_save_uv)
    !
    ! conservation checks:  bottom fluxes and final
    !
    if (conservation_check) then
       h2o(3)  = h2o(3) + dt_slow*sum(cell_area *(Ice%lprec+Ice%fprec-Ice%flux_q+Ice%runoff+Ice%calving),&
                 cell_area > 0 )
       heat(3) = heat(3) + tot_frazil + dt_slow*sum(cell_area*(Ice%flux_sw_vis_dir+Ice%flux_sw_vis_dif+  &
                 Ice%flux_sw_nir_dir+Ice%flux_sw_nir_dif+Ice%flux_lw- &
                 Ice%flux_t-Ice%flux_lh -LI*(Ice%fprec+Ice%calving)), cell_area > 0 )
       h2o(4)  = sum(cell_area*all_avg(DI*Ice%h_ice(isc:iec,jsc:jec,:)+ &
                 DS*Ice%h_snow(isc:iec,jsc:jec,:),Ice%part_size(isc:iec,jsc:jec,:)))
       heat(4) = 0.0

       do k=2,km
          do j=jsc, jec
             do i=isc, iec
                if ((Ice%part_size(i,j,k)>0.0.and.Ice%h_ice(i,j,k)>0.0)) then
                   if (slab_ice) then
                      heat(4) = heat(4) - cell_area(i,j) * Ice%part_size(i,j,k)*Ice%h_ice(i,j,2)*DI*LI
                   else
                      heat(4) = heat(4) - cell_area(i,j) * Ice%part_size(i,j,k)*e_to_melt(Ice%h_snow(i,j,k), &
                                Ice%h_ice(i,j,k)/2, Ice%t_ice1(i,j,k), Ice%h_ice(i,j,k)/2, Ice%t_ice2(i,j,k))
                   end if
                end if
             end do
          end do
       end do
    end if

    call get_date(Ice%Time, iyr, imon, iday, ihr, imin, isec)
    call get_time(Ice%Time-set_date(iyr,1,1,0,0,0),isec,iday)
    if(verbose)  call ice_line(iyr, iday+1, isec, Ice%part_size(isc:iec,jsc:jec,:), &
               Ice%t_surf(:,:,1)-Tfreeze) 

    do j=jsc, jec
       do i=isc, iec 
          if (Ice%mask(i,j).and.(abs(sum(Ice%part_size(i,j,:))-1.0)>1e-2)) &
               print *,'ICE%PART_SIZE=',Ice%part_size(i,j,:), 'DOES NOT SUM TO 1 AT', &
               geo_lon(i,j), geo_lat(i,j)
       end do
    end do
    call mpp_clock_end(iceClock9)


  end subroutine update_ice_model_slow

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! ice_redistribute - a simple ice redistribution scheme from Igor Polyakov     !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine ice_redistribute(cn, hs, hi, t1, t2)
!!$    real, intent(inout), dimension(2:km  )           :: cn, hs, hi, t1, t2
    real, intent(inout), dimension(2:)           :: cn, hs, hi, t1, t2

    real    :: cw                                 ! open water concentration
    integer :: k

    cw = 1-sum(cn)
    if (cw<0) cn(2) = cw + cn(2) ! open water has been eliminated by convergence

    do k=2,km-1
       if (cn(k)<0) then
          cn(k+1) = cn(k+1)+cn(k); cn(k) = 0 ! pass concentration deficit up to
          hs(k+1) = hs(k+1)+hs(k); hs(k) = 0 ! next thicker category
          hi(k+1) = hi(k+1)+hi(k); hi(k) = 0
          t1(k+1) = t1(k+1)+t1(k); t1(k) = 0 ! NOTE:  here between the thm_pack and
          t2(k+1) = t2(k+1)+t2(k); t2(k) = 0 ! thm_unpack calls, all quantities are
       endif                                ! extensive, so we add instead of
    end do                                 ! averaging

    do k=2,km-1
       if (hi(k)>hlim(k)*cn(k)) then
          cn(k+1) = cn(k+1)+cn(k); cn(k) = 0 ! upper thickness limit exceeded
          hs(k+1) = hs(k+1)+hs(k); hs(k) = 0 ! move ice up to next thicker category
          hi(k+1) = hi(k+1)+hi(k); hi(k) = 0
          t1(k+1) = t1(k+1)+t1(k); t1(k) = 0
          t2(k+1) = t2(k+1)+t2(k); t2(k) = 0
       endif
    end do

    do k=km,3,-1
       if (hi(k)<hlim(k-1)*cn(k)) then
          cn(k-1) = cn(k-1)+cn(k); cn(k) = 0  ! lower thickness limit exceeded;
          hs(k-1) = hs(k-1)+hs(k); hs(k) = 0  ! move ice down to thinner category
          hi(k-1) = hi(k-1)+hi(k); hi(k) = 0
          t1(k-1) = t1(k-1)+t1(k); t1(k) = 0
          t2(k-1) = t2(k-1)+t2(k); t2(k) = 0
       endif
    end do

  end subroutine ice_redistribute

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! transport - do ice transport and thickness class redistribution              !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine transport (Ice)
    type (ice_data_type), intent(inout) :: Ice
    integer :: i, j, k
    logical :: sent
    real, dimension(size(Ice%t_surf,1),size(Ice%t_surf,2)) :: uf0, uf, vf0, vf
    real, dimension(isd:ied,jsd:jed) :: uc, vc ! Local variables, C-grid transporting velocities
    real, dimension(isd:ied,jsd:jed) :: tmp1 ! Local variables, 2D ice concentration
    real, dimension(isd:ied,jsd:jed) :: ustar, vstar ! Local variables, C-grid transporting velocities
    real, dimension(isd:ied,jsd:jed) :: ustaro, vstaro, ustarv, vstarv ! Local variables, C-grid transporting velocities
    real :: u_visc, u_ocn, cnn, grad_eta ! Variables for channel parameterization

    if (slab_ice) then
       call slab_ice_advect(Ice%u_ice, Ice%v_ice, Ice%h_ice(:,:,2), 4.0)
       call mpp_update_domains(Ice%h_ice(:,:,2), Domain)
       do j = jsd, jed
          do i = isd, ied
             if(Ice%h_ice(i,j,2) > 0.0) then
                Ice%part_size(i,j,2) = 1.0
             else 
                Ice%part_size(i,j,2) = 0.0
             endif
          enddo
       enddo
       return;
    end if

    call thm_pack(Ice%part_size(isc:iec,jsc:jec,2:km), Ice%h_snow(isc:iec,jsc:jec,:), Ice%h_ice(isc:iec,jsc:jec,:), &
                  Ice%t_ice1(isc:iec,jsc:jec,:), Ice%t_ice2(isc:iec,jsc:jec,:) )

    call mpp_update_domains(Ice%part_size, Domain) ! cannot be combined with updates below
    call mpp_update_domains(Ice%h_snow, Domain, complete=.false.)
    call mpp_update_domains(Ice%h_ice, Domain, complete=.false.)
    call mpp_update_domains(Ice%t_ice1, Domain, complete=.false.)
    call mpp_update_domains(Ice%t_ice2, Domain, complete=.true.)

    ! Move transporting flow to the C-grid (from the B-grid)
    ! Note: this block of code was moved here from within s/r ice_advect
    ! where the same calculations and mpp_updates were repeated for each
    ! class and variable. -AJA
    uc = 0.0; vc = 0.0
    do j = jsc, jec
      do i = isc, iec
        uc(i,j) = 0.5 * ( Ice%u_ice(i,j-1) + Ice%u_ice(i,j) )
        vc(i,j) = 0.5 * ( Ice%v_ice(i-1,j) + Ice%v_ice(i,j) )
      enddo
    enddo
    if (channel_viscosity>0.) then
    ! This block of code is a parameterization of either (or both)
    ! i) the pressure driven oceanic flow in a narrow channel, or
    ! ii) pressure driven flow of ice itself.
    ! The latter is a speculative but both are missing due to
    ! masking of velocities to zero in a single-cell wide channel.
      tmp1=1.-max(1.-sum(Ice%part_size(:,:,2:km),dim=3),0.0)
      ustar(:,:)=0.; vstar(:,:)=0.
      ustaro(:,:)=0.; vstaro(:,:)=0.
      ustarv(:,:)=0.; vstarv(:,:)=0.
      do j = jsc, jec
        do i = isc, iec
          if (Ice%u_ice(i,j).ne.0..and.Ice%vmask(i,j)==0.) stop 'Ooops' ! Debug new vmask
          if (Ice%v_ice(i,j).ne.0..and.Ice%vmask(i,j)==0.) stop 'Ooops' ! Debug new vmask
          if (uc(i,j)==0. & ! this is a redundant test due to following line
             .and. Ice%vmask(i,j)+Ice%vmask(i,j-1)==0. &  ! =0 => no vels
             .and. wett(i,j)*wett(i+1,j)>0.) then ! >0 => open for transport
               grad_eta=(Ice%sea_lev(i+1,j)-Ice%sea_lev(i,j))    & ! delta_i eta
                        /(0.5*(dxv(i,j)+dxv(i,j-1)))               ! /dx
               u_visc=-ssh_gravity*((dte(i,j)*dte(i,j))/(12.*channel_viscosity)) & ! -g*dy^2/(12*visc)
                        *grad_eta                                                  ! d/dx eta
               u_ocn=sqrt( ssh_gravity*dte(i,j)*abs(grad_eta)/(36.*smag_ocn) ) ! Magnitude of ocean current
               u_ocn=sign(u_ocn, -grad_eta) ! Direct down the ssh gradient
               cnn=max(tmp1(i,j),tmp1(i+1,j))**2. ! Use the larger concentration
               uc(i,j)=cnn*u_visc+(1.-cnn)*u_ocn
               ! Limit flow to be stable for fully divergent flow
               if (uc(i,j)>0.) then
                 uc(i,j)=min( uc(i,j), chan_cfl_limit*dxt(i,j)/dt_adv)
               else
                 uc(i,j)=max( uc(i,j),(-1*chan_cfl_limit)*dxt(i+1,j)/dt_adv)
               endif
               if (id_ustar>0) ustar(i,j)=uc(i,j)
               if (id_uocean>0) ustaro(i,j)=u_ocn
               if (id_uchan>0) ustarv(i,j)=u_visc
          endif
          if (vc(i,j)==0. & ! this is a redundant test due to following line
             .and. Ice%vmask(i,j)+Ice%vmask(i-1,j)==0. &  ! =0 => no vels
             .and. wett(i,j)*wett(i,j+1)>0.) then ! >0 => open for transport
               grad_eta=(Ice%sea_lev(i,j+1)-Ice%sea_lev(i,j))    & ! delta_i eta
                        /(0.5*(dyv(i,j)+dyv(i,j-1)))               ! /dy
               u_visc=-ssh_gravity*((dtn(i,j)*dtn(i,j))/(12.*channel_viscosity)) & ! -g*dy^2/(12*visc)
                        *grad_eta                                                  ! d/dx eta
               u_ocn=sqrt( ssh_gravity*dtn(i,j)*abs(grad_eta)/(36.*smag_ocn) ) ! Magnitude of ocean current
               u_ocn=sign(u_ocn, -grad_eta) ! Direct down the ssh gradient
               cnn=max(tmp1(i,j),tmp1(i,j+1))**2. ! Use the larger concentration
               vc(i,j)=cnn*u_visc+(1.-cnn)*u_ocn
               ! Limit flow to be stable for fully divergent flow
               if (vc(i,j)>0.) then
                 vc(i,j)=min( vc(i,j), chan_cfl_limit*dyt(i,j)/dt_adv)
               else
                 vc(i,j)=max( vc(i,j),(-1*chan_cfl_limit)*dyt(i,j+1)/dt_adv)
               endif
               if (id_vstar>0) vstar(i,j)=vc(i,j)
               if (id_vocean>0) vstaro(i,j)=u_ocn
               if (id_vchan>0) vstarv(i,j)=u_visc
          endif
        enddo
      enddo
    endif

    if(reproduce_siena_201303) then
       call mpp_update_domains(uc, vc, Domain)
    else
       call mpp_update_domains(uc, vc, Domain, gridtype=CGRID_NE)
    endif

    uf = 0.0; vf = 0.0
    do k=2,km
       call ice_advect(uc, vc, Ice%part_size(:,:,k))
       call ice_advect(uc, vc, Ice%h_snow   (:,:,k), uf0, vf0)
       uf = uf + DS*uf0; vf = vf + DS*vf0
       call ice_advect(uc, vc, Ice%h_ice    (:,:,k), uf0, vf0)
       uf = uf + DI*uf0; vf = vf + DI*vf0
       call ice_advect(uc, vc, Ice%t_ice1   (:,:,k))
       call ice_advect(uc, vc, Ice%t_ice2   (:,:,k))
    end do
    sent = send_data(id_ix_trans,  uf, Ice%Time)
    sent = send_data(id_iy_trans,  vf, Ice%Time)

    do j=jsc, jec
       do i=isc, iec
          if (sum(Ice%h_ice(i,j,:))>0)                                  &
               call ice_redistribute(Ice%part_size(i,j,2:km),              &
               Ice%h_snow(i,j,:), Ice%h_ice (i,j,:), &
               Ice%t_ice1(i,j,:), Ice%t_ice2(i,j,:))
          do k=2,km
             if (Ice%part_size(i,j,k)<1e-10) then
                Ice%h_ice (i,j,k) = 0           ! thm_unpack will zero other quantities
                Ice%t_surf(i,j,k) = Tfreeze-MU_TS*Ice%s_surf(i,j)
             end if
          end do
       end do
    end do

    call thm_unpack(Ice%part_size(isc:iec,jsc:jec,2:km), Ice%h_snow(isc:iec,jsc:jec,:), Ice%h_ice(isc:iec,jsc:jec,:), &
                    Ice%t_ice1(isc:iec,jsc:jec,:), Ice%t_ice2(isc:iec,jsc:jec,:) )

    call mpp_update_domains(Ice%part_size, Domain) ! cannot be combined with the two updates below
    call mpp_update_domains(Ice%h_snow, Domain, complete=.false.)
    call mpp_update_domains(Ice%h_ice, Domain, complete=.true.)

    if (id_ustar >0) sent = send_data(id_ustar , ustar(isc:iec,jsc:jec) , Ice%Time)
    if (id_vstar >0) sent = send_data(id_vstar , vstar(isc:iec,jsc:jec) , Ice%Time)
    if (id_vocean>0) sent = send_data(id_vocean, vstaro(isc:iec,jsc:jec) , Ice%Time)
    if (id_uocean>0) sent = send_data(id_uocean, ustaro(isc:iec,jsc:jec) , Ice%Time)
    if (id_vchan>0)  sent = send_data(id_vchan,  vstarv(isc:iec,jsc:jec) , Ice%Time)
    if (id_uchan>0)  sent = send_data(id_uchan,  ustarv(isc:iec,jsc:jec) , Ice%Time)

    return

  end subroutine transport

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! ext - modeled ice is one if ice cover >= 0.15 otherwise zero                 !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  function ext(cw)
    real, dimension(isc:,jsc:), intent(in) :: cw
    real,  dimension(isc:iec,jsc:jec)      :: ext
    integer :: i, j 

    do j = jsc, jec
       do i = isc, iec
          if(cw(i,j) < 0.85) then
             ext(i,j) = 1
          else
             ext(i,j) = 0
          endif
       enddo
    enddo

    return
  end function ext

subroutine ocn_ice_bnd_type_chksum(id, timestep, bnd_type)
  use fms_mod,                 only: stdout
  use mpp_mod,                 only: mpp_chksum

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(ocean_ice_boundary_type), intent(in) :: bnd_type
 integer ::   n, m, outunit

    outunit = stdout()
    write(outunit,*) 'BEGIN CHECKSUM(ocean_ice_boundary_type):: ', id, timestep
    write(outunit,100) 'ocn_ice_bnd_type%u        ',mpp_chksum(bnd_type%u        )
    write(outunit,100) 'ocn_ice_bnd_type%v        ',mpp_chksum(bnd_type%v        )
    write(outunit,100) 'ocn_ice_bnd_type%t        ',mpp_chksum(bnd_type%t        )
    write(outunit,100) 'ocn_ice_bnd_type%s        ',mpp_chksum(bnd_type%s        )
    write(outunit,100) 'ocn_ice_bnd_type%frazil   ',mpp_chksum(bnd_type%frazil   )
    write(outunit,100) 'ocn_ice_bnd_type%sea_level',mpp_chksum(bnd_type%sea_level)
!    write(outunit,100) 'ocn_ice_bnd_type%data     ',mpp_chksum(bnd_type%data     )
100 FORMAT("CHECKSUM::",A32," = ",Z20)

    do n = 1, bnd_type%fields%num_bcs  !{
       do m = 1, bnd_type%fields%bc(n)%num_fields  !{
          write(outunit,101) 'oibt%',trim(bnd_type%fields%bc(n)%name), &
               trim(bnd_type%fields%bc(n)%field(m)%name), &
               mpp_chksum(bnd_type%fields%bc(n)%field(m)%values)
       enddo  !} m
    enddo  !} n
101 FORMAT("CHECKSUM::",A16,a,'%',a," = ",Z20)

end subroutine ocn_ice_bnd_type_chksum

subroutine atm_ice_bnd_type_chksum(id, timestep, bnd_type)
  use fms_mod,                 only: stdout
  use mpp_mod,                 only: mpp_chksum

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(atmos_ice_boundary_type), intent(in) :: bnd_type
 integer ::   n, outunit

    outunit = stdout()
    write(outunit,*) 'BEGIN CHECKSUM(atmos_ice_boundary_type):: ', id, timestep
    write(outunit,100) 'atm_ice_bnd_type%u_flux          ',mpp_chksum(bnd_type%u_flux)          
    write(outunit,100) 'atm_ice_bnd_type%v_flux          ',mpp_chksum(bnd_type%v_flux)
    write(outunit,100) 'atm_ice_bnd_type%u_star          ',mpp_chksum(bnd_type%u_star)
    write(outunit,100) 'atm_ice_bnd_type%t_flux          ',mpp_chksum(bnd_type%t_flux)
    write(outunit,100) 'atm_ice_bnd_type%q_flux          ',mpp_chksum(bnd_type%q_flux)
    write(outunit,100) 'atm_ice_bnd_type%lw_flux         ',mpp_chksum(bnd_type%lw_flux)
    write(outunit,100) 'atm_ice_bnd_type%sw_flux_vis_dir ',mpp_chksum(bnd_type%sw_flux_vis_dir)
    write(outunit,100) 'atm_ice_bnd_type%sw_flux_vis_dif ',mpp_chksum(bnd_type%sw_flux_vis_dif)
    write(outunit,100) 'atm_ice_bnd_type%sw_flux_nir_dir ',mpp_chksum(bnd_type%sw_flux_nir_dir)
    write(outunit,100) 'atm_ice_bnd_type%sw_flux_nir_dif ',mpp_chksum(bnd_type%sw_flux_nir_dif)
    write(outunit,100) 'atm_ice_bnd_type%lprec           ',mpp_chksum(bnd_type%lprec)
    write(outunit,100) 'atm_ice_bnd_type%fprec           ',mpp_chksum(bnd_type%fprec)
    write(outunit,100) 'atm_ice_bnd_type%dhdt            ',mpp_chksum(bnd_type%dhdt)
    write(outunit,100) 'atm_ice_bnd_type%dedt            ',mpp_chksum(bnd_type%dedt)
    write(outunit,100) 'atm_ice_bnd_type%drdt            ',mpp_chksum(bnd_type%drdt)
    write(outunit,100) 'atm_ice_bnd_type%coszen          ',mpp_chksum(bnd_type%coszen)
    write(outunit,100) 'atm_ice_bnd_type%coszen_radwt    ',mpp_chksum(bnd_type%coszen_radwt)
    write(outunit,100) 'atm_ice_bnd_type%p               ',mpp_chksum(bnd_type%p)
!    write(outunit,100) 'atm_ice_bnd_type%data            ',mpp_chksum(bnd_type%data)
100 FORMAT("CHECKSUM::",A32," = ",Z20)
end subroutine atm_ice_bnd_type_chksum

subroutine lnd_ice_bnd_type_chksum(id, timestep, bnd_type)
  use fms_mod,                 only: stdout
  use mpp_mod,                 only: mpp_chksum

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(land_ice_boundary_type), intent(in) :: bnd_type
 integer ::   n, outunit

    outunit = stdout()
    write(outunit,*) 'BEGIN CHECKSUM(land_ice_boundary_type):: ', id, timestep
    write(outunit,100) 'lnd_ice_bnd_type%runoff  ',mpp_chksum(bnd_type%runoff)
    write(outunit,100) 'lnd_ice_bnd_type%calving ',mpp_chksum(bnd_type%calving)
!    write(outunit,100) 'lnd_ice_bnd_type%data    ',mpp_chksum(bnd_type%data)
100 FORMAT("CHECKSUM::",A32," = ",Z20)
end subroutine lnd_ice_bnd_type_chksum

end module ice_model_mod

!-----------------------------------------------------------------------
! Copyright 2011 NOAA Geophysical Fluid Dynamics Lab, Princeton, NJ
! This program is distributed under the terms of the GNU General Public
! License. See the file COPYING contained in this directory
!
!  This program averages variables stored in netCDF format over the time axis
!-----------------------------------------------------------------------

program time_average

use  netcdf
implicit none

integer, parameter  :: MAX_FILES = 200
integer, parameter  :: MAX_ATT_NAME = 256
integer, parameter  :: header_buffer_val = 16384
integer, parameter  :: BSIZE = 65536
integer            ::  blksz = BSIZE  ! blksz must be writable for nf__create

!-----------------------------------------------------------------------
character(len=2048) :: file_names(MAX_FILES), file_name_out
logical :: use_end_time = .true.
logical :: verbose = .false.
logical :: add_cell_methods = .false.
logical :: skip_tavg_errors = .false.
logical :: suppress_warnings = .false.
real    :: frac_valid_data = 0.

namelist /input/   file_names, file_name_out, use_end_time, verbose, &
                   add_cell_methods, skip_tavg_errors, frac_valid_data, &
                   suppress_warnings
!-----------------------------------------------------------------------
! data structure for storing information about individual variables
 type variable_type
   character(len=NF90_MAX_NAME) :: name, avg_info
   integer :: ndim, natt, xtype, varid_out, shape(4), axes(NF90_MAX_VAR_DIMS)
   logical :: static, do_missval, do_avg, use_data_wt, skip, uses_tod
   real(8)        :: tavg(3)
   real           :: missval, data_wt_max
   real, pointer  :: data_sum(:,:,:,:), data_wt(:,:,:,:)
 end type

   type(variable_type), allocatable :: Vars(:)

   ! default precision (32/64-bit) real variables
   real, allocatable :: ddata(:,:,:,:)
   real    :: half = 0.50
   real    :: small = 1.e-6
   real    :: data_wt_min
   ! double precision (64-bit) time variables
   real(8) :: tavg(3), time
   real(8) :: time_bounds(3), last_time, time_out, climo_time

   integer :: ncid_in, ncid_out, numvars, numdims, numatts
   integer :: istat, ifile, itime, ivar, idim, nvar, ndim, natt, dimlen, varid,      &
              i, ix, jy, kz, numtime, recdim, varid_recdim, varid_in, attnum, dimid, &
              nvar_out, nv_dimid, nc, nca, ncu, dimid_tod, mt
   integer :: max_shape(4), shape(4), tid(0:3), avgid(3), start(5)
   integer :: axes(NF90_MAX_VAR_DIMS), dimids_out(NF90_MAX_VAR_DIMS)
   logical :: do_avg, first, time_bounds_present, do_time_bounds, add_time_bounds, &
              do_climo_avg, change_bounds_to_climo, climo_bounds_present, do_period_out

   character(len=NF90_MAX_NAME) :: name, name_recdim, attname, version, name_time_bounds
   character(len=NF90_MAX_NAME) :: tavg_info_string, period_in, period_out
   character(len=NF90_MAX_NAME) :: time_att_units, time_units
   character(len=NF90_MAX_NAME) :: cell_methods, cell_methods_tavg, name_bnds
   character(len=NF90_MAX_NAME) :: tavg_names(3) = (/'average_T1','average_T2','average_DT'/)
   character(len=NF90_MAX_NAME) :: tavg_long_names(3) = (/'Start time for average period', &
                                                          'End time for average period  ', &
                                                          'Length of average period     '/)
   integer :: in_format, cmode

!-----------------------------------------------------------------------

  ! initialize blank input strings
    do ifile = 1,MAX_FILES
       do i=1,len(file_names); file_names(ifile)(i:i) = ' '; enddo
    enddo
       do i=1,len(file_name_out); file_name_out(i:i) = ' '; enddo

  ! create version string (may replace with CVS $Id: time_average.f90,v 20.0 2013/12/14 00:30:08 fms Exp $)
    version = 'FMS time averaging, version 3.0'
    if (precision(ddata) == precision(time)) then
        version = trim(version)//', precision=double'
    else
        version = trim(version)//', precision=float'
    endif

  ! read namelist
    read  (*,input,end=1,err=1)
 1  continue
    if (verbose) then
       ! write (*,input)
       write (*,'(a,a)') 'NetCDF Version = ', NF90_INQ_LIBVERS()
    endif
       

  ! error checks
    if (file_names(1)(1:1) == ' ')  &
              call error_handler ('No input file names specified')
    if (file_name_out(1:1) == ' ')  &
              call error_handler ('No output file name specified')

  ! string used for time_avg_info attribute
  ! all input file strings must match this
    tavg_info_string = trim(tavg_names(1))//','//trim(tavg_names(2))//','//trim(tavg_names(3))
!-----------------------------------------------------------------------
!----------------- Loop through input files ----------------------------
!-----------------------------------------------------------------------
      
 do ifile = 1, MAX_FILES
      if ( file_names(ifile)(1:1) == ' ' ) exit
      if (verbose) print *, 'Processing file ',trim(file_names(ifile))

    !--- opening input files ---
     blksz = BSIZE  ! reset since this may have been altered by nf90_open
     istat = NF90_OPEN (trim(file_names(ifile)), NF90_NOWRITE, ncid_in, chunksize=blksz)
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)

    !--- get global info for this file ---
     istat = NF90_INQUIRE (ncid_in, nDimensions=ndim, nVariables=nvar, nAttributes=natt, unlimitedDimId=recdim, formatNum=in_format)
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)
    !--- get information related to the record (time) dimension ----
     istat = NF90_INQUIRE_DIMENSION (ncid_in, recdim, name_recdim, numtime)
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)
     istat = NF90_INQ_VARID (ncid_in, name_recdim, varid_recdim)
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)

     if (verbose) then
         write (*,*) '    ncid=', ncid_in
         write (*,101) ndim, nvar, natt, trim(name_recdim), recdim, numtime
     101 format (4x,'ndim=',i3,4x,'nvar=',i3,4x,'natt=',i2, &
               /,4x,'recdim: name=',a,4x,'id=',i2,4x,'length=',i5)
     endif

     ! get units of record dimension
     do i=1,NF90_MAX_NAME; time_att_units(i:i) = ' '; enddo
     do i=1,NF90_MAX_NAME; time_units    (i:i) = ' '; enddo
     istat = NF90_GET_ATT (ncid_in, varid_recdim, 'units', time_att_units)
     ! extract time units from time axis units attribute
     nca = len_trim(time_att_units)
     ncu = index(time_att_units(1:nca),' ')-1  ! use first word only
     time_units = time_att_units(1:ncu)

  if (ifile == 1) then
     ! get time axis bounds attribute if it is present
     do i=1,NF90_MAX_NAME; name_time_bounds(i:i) = ' '; enddo
     istat = NF90_GET_ATT (ncid_in, varid_recdim, 'bounds', name_time_bounds)
     time_bounds_present = .false.
     if (name_time_bounds(1:1) .ne. ' ') then
         istat = NF90_INQ_VARID (ncid_in, trim(name_time_bounds), varid)
         if (istat == NF90_NOERR) time_bounds_present = .true.
     endif
     do_time_bounds = time_bounds_present
     ! or check for climatological bounds attribute
     if (.not.time_bounds_present) then
        do i=1,NF90_MAX_NAME; name_time_bounds(i:i) = ' '; enddo
        istat = NF90_GET_ATT (ncid_in, varid_recdim, 'climatology', name_time_bounds)
        climo_bounds_present = name_time_bounds(1:1) .ne. ' '
        do_time_bounds = climo_bounds_present
     endif
     ! replace null character at end of string with space (bug fix)
     nc = len_trim(name_time_bounds)
     if (iachar(name_time_bounds(nc:nc))==0) name_time_bounds(nc:nc)=' '
     if (verbose) then
         print *, 'time_bounds_present=',time_bounds_present
         print *, 'climo_bounds_present=',climo_bounds_present
         print *, 'name_time_bounds=',trim(name_time_bounds)
     endif
  endif

    !--- contiguous time average or climatological time average? ---
     if (ifile == 1) then
         if (numtime > 1) then
             call check_for_climo_avg ( ncid_in, name_recdim, time_units, numtime, &
                                        do_climo_avg, period_in, period_out,       &
                                        name_time_bounds, tavg_names(1:2)          )
             if (do_climo_avg) climo_time = 0.0
         else
             do_climo_avg = .false.
         endif
         ! is the time bounds attribute changing from "bounds" to "climatology"?
         if (time_bounds_present .and. do_climo_avg) then
             change_bounds_to_climo = .true.
         else
             change_bounds_to_climo = .false.
         endif
     endif

!print *, 'do_climo_avg,change_bounds_to_climo=',do_climo_avg,change_bounds_to_climo
!print *, 'add_cell_methods,time_bounds_present=',add_cell_methods,time_bounds_present

    !--- add CF convention for time bounds and cell methods? ----
     if (add_cell_methods .and. .not.time_bounds_present .and. .not.climo_bounds_present) then
         do_time_bounds  = .true.
         add_time_bounds = .true.
         if (verbose) then
             write (*,*) 'Adding CF convention for time averaging.'
         endif
         nvar_out = nvar+1
         ! note: will add axis called "nv", this axis can not exist
         istat = NF90_INQ_DIMID (ncid_in, 'nv', dimid)
         if (istat == NF90_NOERR) call error_handler &
                        ('Dimension "nv" already exists, can not create')
     else
         add_time_bounds = .false.
         nvar_out = nvar
     endif

    !--- time average info (assume the same name use by all variables) ---
    !--- should work for FMS generated files, but need to make this more robust ---
     do_avg = .true.
     do i = 1, 3
          istat = NF90_INQ_VARID (ncid_in, tavg_names(i), avgid(i))
          if (istat /= NF90_NOERR) then
              do_avg = .false.
              exit
          endif
     enddo

    !--- allocate array space when doing first file ---
     if (ifile == 1) then
         allocate (Vars(nvar_out))
         numdims = ndim
         numvars = nvar
         numatts = natt
         Vars(:)%use_data_wt = .false.
         Vars(:)%skip        = .false.
         Vars(:)%do_avg      = .false.
         Vars(:)%do_missval  = .false.
         Vars(:)%uses_tod    = .false. 
         max_shape = 1
         do i=1,NF90_MAX_NAME
           Vars(:)%name(i:i)=' '
           Vars(:)%avg_info(i:i)=' '
         enddo

!print *, trim(Vars(nvar_out)%name),': use_data_wt,do_missval=',Vars(nvar_out)%use_data_wt,Vars(nvar_out)%do_missval

         istat = NF90_INQ_DIMID(ncid_in, "time_of_day_24", dimid_tod)
         if (istat /= NF90_NOERR) dimid_tod = -1

        !--- compute variable/axis lengths ---
        !--- loop thru variables (in first file) ---
         do ivar = 1, nvar
            istat = NF90_INQUIRE_VARIABLE (ncid_in, ivar, name=Vars(ivar)%name, &
                                           xtype=Vars(ivar)%xtype, ndims=Vars(ivar)%ndim, &
                                           dimids=Vars(ivar)%axes, natts=Vars(ivar)%natt)
            if (istat /= NF90_NOERR) call error_handler (ncode=istat)

            ! Check if var uses new time_of_day axis. 
            do idim = 1,Vars(ivar)%ndim
               if (Vars(ivar)%axes(idim) .eq. dimid_tod) then
                  Vars(ivar)%uses_tod = .true.
               endif
            enddo

            call init_variable_type  ( ncid_in, ivar, Vars(ivar) )
            call alloc_variable_type ( numtime, Vars(ivar) )
            if (verbose) then
               write (*,33) trim(Vars(ivar)%name),Vars(ivar)%skip,Vars(ivar)%shape
            33 format ('name=',a,2x,'skip=',l5,2x,'shape=',4i3)
            endif
         enddo

         ! add time bounds variable
         if (add_time_bounds) then
            ivar = nvar+1
            if (do_climo_avg) then
                name_time_bounds = 'climatology_bounds'
            else
                name_time_bounds = trim(name_recdim)//'_bounds'
            endif
            Vars(ivar)%name  = name_time_bounds
!print *, trim(Vars(ivar)%name),': use_data_wt,do_missval=',Vars(ivar)%use_data_wt,Vars(ivar)%do_missval
            Vars(ivar)%xtype = NF90_REAL8
            Vars(ivar)%ndim  = 1
            Vars(ivar)%axes(1:2) = (/numdims+1,recdim/)
            Vars(ivar)%natt  = 0
            Vars(ivar)%static = .false.
            Vars(ivar)%shape  = (/2,1,1,1/)
            call alloc_variable_type ( numtime, Vars(ivar) )
         endif
        !--- done variable loop (for first file) ----
        !--------------------------------------------

        !--- array for reading/writing of netcdf fields ---
         allocate (ddata(max_shape(1),max_shape(2),max_shape(3),max_shape(4)))

     else
        !--- check subsequent files to make sure that number of variables is the same ----
        !--- will check variable names below ---
         if (nvar /= numvars) call error_handler ('Input netcdf files &
                            &do not have the same number of variables')
     endif

     if (verbose) then
         write (*,*) '  time_bounds_present=',time_bounds_present
         write (*,*) '  add_time_bounds=',add_time_bounds
         write (*,*) '  do_climo_avg=',do_climo_avg
         write (*,*) '  name_time_bounds=',trim(name_time_bounds)
     endif

   !-------------------------------------------------------------
   !---------------- OUTPUT FILE INITIALIZATION -----------------

     if (ifile == 1) then
       if (in_format==NF90_FORMAT_NETCDF4) then
          cmode = NF90_NETCDF4
       elseif (in_format==NF90_FORMAT_NETCDF4_CLASSIC) then
          cmode=IOR(NF90_NETCDF4,NF90_CLASSIC_MODEL)
       elseif (in_format==NF90_FORMAT_64BIT) then
          cmode=IOR(NF90_CLOBBER,NF90_64BIT_OFFSET)
       elseif (in_format==NF90_FORMAT_CLASSIC) then
          cmode=IOR(NF90_CLOBBER,NF90_CLASSIC_MODEL)
       else
          call error_handler ('Unknown netCDF format')
       endif
       ! create file
         blksz = BSIZE  ! reset since this may have been altered by nf90_open
         istat = NF90_CREATE (trim(file_name_out), cmode, ncid_out, chunksize=blksz)
         if (istat /= NF90_NOERR) call error_handler ('creating output file', ncode=istat)

       ! copy global attributes
         do attnum = 1, numatts
            ! get name
            istat = NF90_INQ_ATTNAME (ncid_in, NF90_GLOBAL, attnum, attname)
            if (istat /= NF90_NOERR) call error_handler (ncode=istat)
            ! change global filename attribute
            if (trim(attname) == 'filename') then
                istat = NF90_PUT_ATT (ncid_out, NF90_GLOBAL, 'filename', trim(file_name_out))
                if (istat /= NF90_NOERR) call error_handler (ncode=istat)
            else if (trim(attname) == 'time_averaging') then
                cycle ! skip (create new attribute later)
            else if (trim(attname) == 'comment') then
                cycle ! skip (create new attribute later)
            else
                ! copy all others
                istat = NF90_COPY_ATT (ncid_in, NF90_GLOBAL, attname, ncid_out, NF90_GLOBAL)
                if (istat /= NF90_NOERR) call error_handler ('copying global attributes', &
                                                              ncode=istat)
            endif
         enddo
         ! add attribute
         istat = NF90_PUT_ATT (ncid_out, NF90_GLOBAL, 'comment', trim(version))
         if (istat /= NF90_NOERR) call error_handler (ncode=istat)

       ! copy dimensions
         do idim = 1, numdims
            istat = NF90_INQUIRE_DIMENSION (ncid_in, idim, name, dimlen)
            if (istat /= NF90_NOERR) call error_handler (ncode=istat)
            if (idim == recdim) then
                istat = NF90_DEF_DIM (ncid_out, name, NF90_UNLIMITED, dimid)
                if (istat /= NF90_NOERR) call error_handler (ncode=istat)
            else    
                istat = NF90_DEF_DIM (ncid_out, name, dimlen, dimid)
                if (istat /= NF90_NOERR) call error_handler (ncode=istat)
            endif   
            ! mapping between input and output dimension ids
            dimids_out(idim) = dimid
         enddo   

       ! add axis for time bounds variable
         if (add_time_bounds) then
             istat = NF90_DEF_DIM (ncid_out, 'nv', 2, nv_dimid)
             if (istat /= NF90_NOERR) call error_handler (ncode=istat)
             dimids_out(numdims+1) = dimid
         endif

       ! copy variables
         do ivar = 1, numvars
            if (Vars(ivar)%skip) cycle
            ndim = Vars(ivar)%ndim
            if (.not.Vars(ivar)%static) ndim = ndim+1
            ! remap input dimensions to output dimensions
            do idim = 1, ndim
              axes(idim) = dimids_out(Vars(ivar)%axes(idim))
            enddo
            ! define output variable
            if (trim(Vars(ivar)%name) == trim(name_time_bounds) .and. change_bounds_to_climo) then
                istat = NF90_DEF_VAR (ncid_out, 'climatology_bounds', Vars(ivar)%xtype, &
                                      axes(1:ndim), Vars(ivar)%varid_out)
            else
                istat = NF90_DEF_VAR (ncid_out, Vars(ivar)%name, Vars(ivar)%xtype, &
                                      axes(1:ndim), Vars(ivar)%varid_out)
            endif
            if (istat /= NF90_NOERR) call error_handler &
                           ('defining output variable '//trim(Vars(ivar)%name), ncode=istat)
            if (verbose) write (*,*) 'Defining output variable: '//trim(Vars(ivar)%name)
            ! copy variable attributes
            do i=1,NF90_MAX_NAME; cell_methods(i:i) = ' '; enddo
            do i=1,NF90_MAX_NAME; name_bnds   (i:i) = ' '; enddo
            do attnum = 1, Vars(ivar)%natt 
               istat = NF90_INQ_ATTNAME (ncid_in, ivar, attnum, attname)
               if (istat /= NF90_NOERR) call error_handler (ncode=istat)
               if (trim(attname) == 'time_avg_info') then
                  !istat = NF90_PUT_ATT (ncid_out, Vars(ivar)%varid_out, attname, &
                  !     trim(avg_name)//'_T1,'//trim(avg_name)//'_T2,'//trim(avg_name)//'_DT')
                  !if (istat /= NF90_NOERR) call error_handler &
                  !   ('creating attribute time_avg_info for variable '//trim(Vars(ivar)%name), &
                  !        ncode=istat)
               else if (trim(attname) == 'cell_methods' .and. .not.Vars(ivar)%static) then
                   istat = NF90_GET_ATT (ncid_in, ivar, 'cell_methods', cell_methods)
                   if (istat /= NF90_NOERR) call error_handler  &
                             ('getting cell_methods'//trim(Vars(ivar)%name), ncode=istat)
               else if (trim(Vars(ivar)%name) == trim(name_recdim) .and. &
                        trim(attname) == 'bounds' .and. do_climo_avg) then
                   ! change bounds to climatology
                   istat = NF90_PUT_ATT (ncid_out, Vars(ivar)%varid_out, 'climatology', 'climatology_bounds')
                   if (istat /= NF90_NOERR) call error_handler (ncode=istat)
               else
                   istat = NF90_COPY_ATT (ncid_in, ivar, attname, ncid_out, Vars(ivar)%varid_out)
                   if (istat /= NF90_NOERR) call error_handler &
                        ('copying attribute for variable '//trim(Vars(ivar)%name), ncode=istat)
               endif
            enddo   
            !--- when necessary create time average attributes for all variables ---
            if (Vars(ivar)%static) cycle
            if (trim(Vars(ivar)%name) == trim(name_time_bounds)) cycle
            if (trim(Vars(ivar)%name) == trim(name_recdim))      cycle
            ! CF convention
            cell_methods_tavg = trim(name_recdim)//': mean'
            do_period_out = .false.
            if (do_climo_avg) do_period_out = .true.
            if (index(trim(lowercase(cell_methods)),trim(name_recdim)//': point') > 0) do_period_out = .true.
            if (do_period_out) cell_methods_tavg = trim(cell_methods_tavg)//' over '//trim(period_out)
            if (do_time_bounds) then
               if (index(trim(lowercase(cell_methods)),trim(lowercase(cell_methods_tavg))) == 0) then
                   if (len_trim(cell_methods) > 0 .and. do_period_out .and. &
                       index(trim(lowercase(cell_methods)),'within') == 0) then
                       cell_methods = trim(cell_methods)//' within '//trim(period_in)
                   else if (len_trim(cell_methods) == 0 .and. Vars(ivar)%do_avg .and. do_period_out) then
                       cell_methods = trim(name_recdim)//': mean within '//trim(period_in)
                   endif
                   cell_methods = trim(cell_methods)//' '//trim(cell_methods_tavg)
               endif
              !if (trim(lowercase(cell_methods_tavg)) /= trim(lowercase(cell_methods))) then
              !    cell_methods = trim(cell_methods)//' '//trim(cell_methods_tavg)
              !endif
               istat = NF90_PUT_ATT (ncid_out, Vars(ivar)%varid_out, &
                                     'cell_methods', trim(cell_methods))
               if (istat /= NF90_NOERR) call error_handler ('creating attribute '// &
                   'cell_methods for variable '//trim(Vars(ivar)%name), ncode=istat)
            endif
            ! FMS time avg info
            istat = NF90_PUT_ATT (ncid_out, Vars(ivar)%varid_out, &
                                  'time_avg_info', trim(tavg_info_string))
            if (istat /= NF90_NOERR) call error_handler ('creating attribute '// &
                    'time_avg_info for variable '//trim(Vars(ivar)%name), ncode=istat)
               
         enddo   

        ! extract time units from time axis units attribute
         nca = len_trim(time_att_units)
         ncu = index(time_att_units(1:nca),' ')-1  ! use first word only

        ! more metadata needed when adding time bounds variable
         if (add_time_bounds) then
             ! add attribute to time axis
             ivar = varid_recdim
             if (do_climo_avg) then
                 istat = NF90_PUT_ATT (ncid_out, Vars(ivar)%varid_out, 'climatology', &
                                       'climatology_bounds')
             else
                 istat = NF90_PUT_ATT (ncid_out, Vars(ivar)%varid_out, 'bounds', &
                                       trim(Vars(ivar)%name)//'_bounds')
             endif
             if (istat /= NF90_NOERR) call error_handler (ncode=istat)

             ! add time bounds variable if necessary
             ivar = nvar+1
             istat = NF90_DEF_VAR (ncid_out, Vars(ivar)%name, Vars(ivar)%xtype, &
                                      (/nv_dimid,recdim/), Vars(ivar)%varid_out)
             if (verbose) write (*,*) 'Defining output variable: '//trim(Vars(ivar)%name)
             if (istat /= NF90_NOERR) call error_handler &
                       ('defining output variable '//trim(Vars(ivar)%name), ncode=istat)
             ! plus attributes
             istat = NF90_PUT_ATT (ncid_out, Vars(ivar)%varid_out, 'long_name', &
                                      trim(name_recdim)//' axis boundaries')
             if (istat /= NF90_NOERR) call error_handler (ncode=istat)
             if (ncu > 0) then
               istat = NF90_PUT_ATT (ncid_out, Vars(ivar)%varid_out, 'units', time_att_units(1:ncu))
               if (istat /= NF90_NOERR) call error_handler (ncode=istat)
             endif
         endif

        ! define FMS time average variables (applies to all variables in the output file)
         do i = 1, 3
            istat = NF90_DEF_VAR (ncid_out, trim(tavg_names(i)), NF90_REAL8, (/recdim/), tid(i))
            if (istat /= NF90_NOERR) call error_handler ('defining time_avg_info variables', ncode=istat)
            ! attributes (long_name and units)
            istat = NF90_PUT_ATT (ncid_out, tid(i), 'long_name', trim(tavg_long_names(i)))
            if (istat /= NF90_NOERR) call error_handler (ncode=istat)
            nc = nca
            if (i == 3) nc = ncu
            if (nc > 0) then
               istat = NF90_PUT_ATT (ncid_out, tid(i), 'units', time_att_units(1:nc))
               if (istat /= NF90_NOERR) call error_handler (ncode=istat)
            endif
         enddo

        ! end of defining metadata for output file
         istat = NF90_ENDDEF (ncid_out,header_buffer_val,4,0,4)
         if (istat /= NF90_NOERR) call error_handler (ncode=istat)

     endif

   !------------ END OF OUTPUT FILE INITIALIZATION --------------
   !-------------------------------------------------------------

    !---- zero out sums -----
     do ivar = 1, nvar
        Vars(ivar)%data_sum = 0.0
        Vars(ivar)%tavg(3)  = 0.0
        if (Vars(ivar)%use_data_wt) then
            Vars(ivar)%data_wt  = 0.0
            Vars(ivar)%data_wt_max = 0.
        else
            Vars(ivar)%data_wt_max = 0.
        endif
     enddo

    !--- this will not really be used ---
    !  initialize to avoid divid by zero
     if (nvar_out == nvar+1) then
        ivar = nvar_out
        Vars(ivar)%data_sum = 0.0
        Vars(ivar)%tavg(3)  = 0.0
        Vars(ivar)%data_wt  = 0.0
        Vars(ivar)%data_wt_max = 1.
     endif

!-----------------------------------------------------------------------
!-------------------- Loop through time axis ---------------------------
!-----------------------------------------------------------------------

     do itime = 0, numtime

      ! get time coordinate value
        if (itime > 0) then
            istat =  NF90_GET_VAR (ncid_in, varid_recdim, time, start=(/itime/))
            if (istat /= NF90_NOERR) call error_handler ('getting time coord value', ncode=istat)
        endif
!-----------------------------------------------------------------------
!-------------------- Loop through variables ---------------------------
!-----------------------------------------------------------------------

     do ivar = 1, nvar

      !--- skip certain fields ---
        if (.not.Vars(ivar)%static .and. itime == 0) cycle
        if (     Vars(ivar)%static .and. itime  > 0) cycle
        if (     Vars(ivar)%skip                   ) cycle

      !--- get variable data and check dimensions ----
      !  use name from first file to get variable id
         istat = NF90_INQ_VARID (ncid_in, Vars(ivar)%name, varid )
         if (istat /= NF90_NOERR) call error_handler ('variable '//trim(Vars(ivar)%name)// &
                                ' not found in file '//trim(file_names(ifile)), ncode=istat)
         istat = NF90_INQUIRE_VARIABLE (ncid_in, varid, ndims=ndim, dimids=axes)
         if (istat /= NF90_NOERR) call error_handler (ncode=istat)
         ! determine shape
         shape = 1
         do idim = 1, ndim
            if (axes(idim) == recdim) cycle
            istat = NF90_INQUIRE_DIMENSION (ncid_in, axes(idim), len=shape(idim))
            if (istat /= NF90_NOERR) call error_handler (ncode=istat)
         enddo
         ! check shape (must match shape from first file)
         if (count(shape /= Vars(ivar)%shape) > 0) call error_handler &
                  ('inconsistent shape between files for variable '//trim(Vars(ivar)%name))

       ! setup variable size and start indices
         start = 1
         if (.not.Vars(ivar)%static) start(Vars(ivar)%ndim+1) = itime
         ix = Vars(ivar)%shape(1);  jy = Vars(ivar)%shape(2);  kz = Vars(ivar)%shape(3)
         mt = Vars(ivar)%shape(4)

       !--- read variable ---
         select case (Vars(ivar)%ndim)
            case(0)
               istat = NF90_GET_VAR (ncid_in, varid, ddata(1,1,1,1), start(1:1))
               if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
            case(1)
               istat = NF90_GET_VAR (ncid_in, varid, ddata(1:ix,1,1,1), start(1:2))
               if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
            case(2)
               istat = NF90_GET_VAR (ncid_in, varid, ddata(1:ix,1:jy,1,1), start(1:3))
               if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
            case(3)
               istat = NF90_GET_VAR (ncid_in, varid, ddata(1:ix,1:jy,1:kz,1), start(1:4))
               if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
            case(4)
               istat = NF90_GET_VAR (ncid_in, varid, ddata(1:ix,1:jy,1:kz,1:mt), start(1:5))
               if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
         end select

       !--- read time average info (probably the same for many variables) ---
       !    should do this only once
         if (Vars(ivar)%do_avg) then
             do i = 1, 3
                istat = NF90_GET_VAR (ncid_in, avgid(i), tavg(i), (/itime/))
                if (istat /= NF90_NOERR) call error_handler &
                        ('reading time avg info for '//trim(Vars(ivar)%name), ncode=istat)
             enddo
             if (do_climo_avg .and. itime == numtime) then
                 ! use midpoint of last time interval for climatological time
                 if (change_bounds_to_climo) then
                    climo_time = 0.5*(tavg(1)+tavg(2))
                 else
                 ! use last time if already climo time
                    climo_time = time
                 endif
             endif
         else
             tavg(3) = 1.  ! dummy value when no time average
         endif

       !--- keep track of time averaging info: begin, end, and delta times ---
         if (itime > 0) then
            if (Vars(ivar)%do_avg) then
               if (itime == 1)       Vars(ivar)%tavg(1) = tavg(1)   ! begin time
               if (itime == numtime) Vars(ivar)%tavg(2) = tavg(2)   ! end time
               Vars(ivar)%tavg(3)  = Vars(ivar)%tavg(3) + tavg(3)   ! total time avg length
            else
              !----- no time average info -----
              !    assume equal avg intervals
              !    this will only work if numtime > 1
               if (itime == 1)      Vars(ivar)%tavg(1) = time
               if (itime == 2) then
                   Vars(ivar)%tavg(3) = time-Vars(ivar)%tavg(1)
                   Vars(ivar)%tavg(1) = Vars(ivar)%tavg(1)-Vars(ivar)%tavg(3)
                   Vars(ivar)%tavg(3) = Vars(ivar)%tavg(3)*real(numtime)
               endif
               if (itime == numtime) Vars(ivar)%tavg(2) = time
               if (numtime == 1    ) Vars(ivar)%tavg(3) = 1.0 ! avoid divid by zero
            endif
         endif

        !---------- SUM FIELDS ----------

         if (Vars(ivar)%use_data_wt) then
           if (Vars(ivar)%do_missval) then
              where (ddata(1:ix,1:jy,1:kz,1:mt) .ne. Vars(ivar)%missval)
                Vars(ivar)%data_sum = Vars(ivar)%data_sum+tavg(3)*ddata(1:ix,1:jy,1:kz,1:mt)
                Vars(ivar)%data_wt  = Vars(ivar)%data_wt +tavg(3)
              endwhere
           else
                Vars(ivar)%data_sum = Vars(ivar)%data_sum+tavg(3)*ddata(1:ix,1:jy,1:kz,1:mt)
                Vars(ivar)%data_wt  = Vars(ivar)%data_wt +tavg(3)
           endif
           Vars(ivar)%data_wt_max = Vars(ivar)%data_wt_max+tavg(3)
         else
           if (numtime == 1) then
                Vars(ivar)%data_sum = ddata(1:ix,1:jy,1:kz,1:mt)
           else
                Vars(ivar)%data_sum = Vars(ivar)%data_sum+tavg(3)*ddata(1:ix,1:jy,1:kz,1:mt)
                Vars(ivar)%data_wt_max = Vars(ivar)%data_wt_max+tavg(3)
           endif
         endif

!-----------------------------------------------------------------------
     enddo    ! variable loop
!-----------------------------------------------------------------------
     enddo    ! time loop
!-----------------------------------------------------------------------

!--- check length of average ---
!--- must be the same for all fields ---

     ! find the first avg field
     first = .true.
     do ivar = 1, nvar
        if (Vars(ivar)%do_avg) then
           time_bounds(1:3) = Vars(ivar)%tavg(1:3)
           first = .false.
           exit
        endif
     enddo

     ! check time bounds for all variable
     do ivar = 1, nvar
       if (Vars(ivar)%static) cycle
       if (Vars(ivar)%skip  ) cycle
       if (trim(Vars(ivar)%name) == trim(name_time_bounds)) cycle
       if (trim(Vars(ivar)%name) == trim(name_recdim))      cycle
       if (first) then
          ! in case all vars are do_avg=F
          time_bounds(1:3) = Vars(ivar)%tavg(1:3)
          first = .false.
       else
          if (count(time_bounds /= Vars(ivar)%tavg) > 0) then
              if (.not.Vars(ivar)%do_avg .and. skip_tavg_errors) then
                  if (.not.suppress_warnings) write (*,98) trim(Vars(ivar)%name)
               98 format ('WARNING: average information does not agree for variable ',a)
              else
                  print *, 'time_bounds for file=',time_bounds
                  print *, 'tavg for var=',Vars(ivar)%tavg
                  call error_handler &
                    ('average information does not agree for variable '//trim(Vars(ivar)%name))
              endif
          endif
       endif
     enddo

     ! save last time value from the input file
     last_time = time

!=======================================================================
!------------------------ OUTPUT SECTION -------------------------------
!=======================================================================

  !---- write variables with no time axis ----
   if (ifile == 1) then
      do ivar = 1, nvar_out
         if (.not.Vars(ivar)%static) cycle
         if (     Vars(ivar)%skip)   cycle

         select case (Vars(ivar)%ndim)
            case(0)
               istat = NF90_PUT_VAR (ncid_out, Vars(ivar)%varid_out, Vars(ivar)%data_sum(1,1,1,1))
               if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
            case(1)
               istat = NF90_PUT_VAR (ncid_out, Vars(ivar)%varid_out, Vars(ivar)%data_sum(:,1,1,1))
               if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
            case(2)
               istat = NF90_PUT_VAR (ncid_out, Vars(ivar)%varid_out, Vars(ivar)%data_sum(:,:,1,1))
               if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
            case(3)
               istat = NF90_PUT_VAR (ncid_out, Vars(ivar)%varid_out, Vars(ivar)%data_sum(:,:,:,1))
               if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
            case(4)
               istat = NF90_PUT_VAR (ncid_out, Vars(ivar)%varid_out, Vars(ivar)%data_sum(:,:,:,:))
               if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
         end select
      enddo
   endif

  !---- output time coordinate value ----

    if (use_end_time) then
        time_out = last_time
    else
        time_out = 0.5*(time_bounds(1)+time_bounds(2))
        if (do_climo_avg) time_out = climo_time
    endif

    if (verbose) then
      print '(a,4f15.3)', 'time_out,time_bounds=',time_out,time_bounds
    endif

  !----- OUTPUT TIME AVERAGES FOR STATIC FIELDS ------

   do ivar = 1, nvar_out
      if (Vars(ivar)%static) cycle    ! process only non-static fields
      if (Vars(ivar)%skip)   cycle

    ! size of this variable
      ix = Vars(ivar)%shape(1);  jy = Vars(ivar)%shape(2);  kz = Vars(ivar)%shape(3)
      mt = Vars(ivar)%shape(4)

    ! compute time average
    ! divid by data weight when appropriate
    ! insert missing value where needed
      if (Vars(ivar)%use_data_wt) then
          data_wt_min = max(min(frac_valid_data,1.-small),0.)*Vars(ivar)%data_wt_max
          if (Vars(ivar)%do_missval) then
             where (Vars(ivar)%data_wt > data_wt_min)
                ddata(1:ix,1:jy,1:kz,1:mt) = Vars(ivar)%data_sum/Vars(ivar)%data_wt
             elsewhere
                ddata(1:ix,1:jy,1:kz,1:mt) = Vars(ivar)%missval
             endwhere
          else
             ! this where loop should always be true
             where (Vars(ivar)%data_wt > data_wt_min)
                ddata(1:ix,1:jy,1:kz,1:mt) = Vars(ivar)%data_sum/Vars(ivar)%data_wt
             endwhere
          endif
      else
          if (numtime == 1) then
             ddata(1:ix,1:jy,1:kz,1:mt) = Vars(ivar)%data_sum
          else
             ddata(1:ix,1:jy,1:kz,1:mt) = Vars(ivar)%data_sum/Vars(ivar)%data_wt_max
          endif
      endif

    ! correct non-float data for truncation error
      if (Vars(ivar)%xtype /= NF90_REAL8 .and. Vars(ivar)%xtype /= NF90_REAL4) then
          if (Vars(ivar)%do_missval) then
              where (ddata(1:ix,1:jy,1:kz,1:mt) /= Vars(ivar)%missval) &
                ddata(1:ix,1:jy,1:kz,1:mt) = ddata(1:ix,1:jy,1:kz,1:mt) + sign(half,ddata(1:ix,1:jy,1:kz,1:mt))
          else
                ddata(1:ix,1:jy,1:kz,1:mt) = ddata(1:ix,1:jy,1:kz,1:mt) + sign(half,ddata(1:ix,1:jy,1:kz,1:mt))
          endif
      endif

    ! starting index in output file for this time
      start = 1
      if (.not.Vars(ivar)%static) start(Vars(ivar)%ndim+1) = ifile

    !**** special processing for variable "time_bounds" ****
      if (trim(Vars(ivar)%name) == trim(name_time_bounds)) then
          istat = NF90_PUT_VAR (ncid_out, Vars(ivar)%varid_out, time_bounds(1:2), start(1:2))
          if (istat /= NF90_NOERR) call error_handler ('var= '//trim(Vars(ivar)%name), ncode=istat)
          cycle
      endif

    !**** special processing for record dimension ****
      if (trim(Vars(ivar)%name) == trim(name_recdim)) then
          istat = NF90_PUT_VAR (ncid_out, Vars(ivar)%varid_out, time_out, start(1:1))
          if (istat /= NF90_NOERR) call error_handler ('writing time coord', ncode=istat)
          cycle
      endif

    !---- write data to output file ----
      select case (Vars(ivar)%ndim)
         case(0)
            istat = NF90_PUT_VAR (ncid_out, Vars(ivar)%varid_out, ddata(1,1,1,1), start(1:1))
            if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
         case(1)
            istat = NF90_PUT_VAR (ncid_out, Vars(ivar)%varid_out, ddata(1:ix,1,1,1), start(1:2))
            if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
         case(2)
            istat = NF90_PUT_VAR (ncid_out, Vars(ivar)%varid_out, ddata(1:ix,1:jy,1,1), start(1:3))
            if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
         case(3)
            istat = NF90_PUT_VAR (ncid_out, Vars(ivar)%varid_out, ddata(1:ix,1:jy,1:kz,1), start(1:4))
            if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
         case(4)
            istat = NF90_PUT_VAR (ncid_out, Vars(ivar)%varid_out, ddata(1:ix,1:jy,1:kz,1:mt), start(1:5))
            if (istat /= NF90_NOERR) call error_handler &
                                        ('var= '//trim(Vars(ivar)%name), ncode=istat)
      end select

   enddo ! end of output variable loop

   ! write time average info (probably do only once)
     do i = 1, 3
        istat = NF90_PUT_VAR (ncid_out, tid(i), time_bounds(i), (/ifile/))
        if (istat /= NF90_NOERR) call error_handler ('writing time avg info', ncode=istat)
     enddo

   ! close input file
     istat = NF90_CLOSE (ncid_in)
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)

 enddo 
!---------------- end of input file (ifile) loop --------------------

! close output file
  istat = NF90_CLOSE (ncid_out)
  if (istat /= NF90_NOERR) call error_handler (ncode=istat)

contains
!#######################################################################

 subroutine error_handler (string, ncode)
 character(len=*), intent(in), optional :: string
 integer         , intent(in), optional :: ncode
 character(len=80) :: errstrg
   if (present(ncode))  then
       print *, 'NETCDF ERROR in program time_average'
   else
       print *, 'ERROR in program time_average'
   endif
   if (present(string)) print *, trim(string)
   if (present(ncode))  then
       errstrg = NF90_STRERROR (ncode)
       print *, trim(errstrg)
   endif
   call abort ()
!  stop 111
!  call error_mesg ('program time_average', string, FATAL)
 end subroutine error_handler

!#######################################################################

! change string to all lower case

 function lowercase (cs) 
 character(len=*), intent(in) :: cs
 character(len=len(cs))       :: lowercase 
 character :: ca(len(cs)) 

 integer, parameter :: co=iachar('a')-iachar('A') ! case offset
    
    ca = transfer(cs,"x",len(cs)) 
    where (ca >= "A" .and. ca <= "Z") ca = achar(iachar(ca)+co) 
    lowercase = transfer(ca,cs) 
    
 end function lowercase

!#######################################################################

 subroutine init_variable_type ( ncid, varid, Var )
 integer            , intent(in)    :: ncid, varid
 type(variable_type), intent(inout) :: Var

 integer :: idim, nc, istat, i
 logical :: do_fillval
 real    :: fillval

    ! will not allow fields with more than five dimensions
    if (Var%ndim > 5) call error_handler &
                ('input field ('//trim(Var%name)//') has more than 5 axes')

    ! skip all fields stored as 1-byte data
    if (Var%xtype == NF90_CHAR .or. Var%xtype == NF90_INT1) then
        Var%skip = .true.
        write (*,100) trim(Var%name), '(data type not supported)'
    100 format (4x,'Skipping field=',a,4x,a)
        return
    endif

   !--- variable has a time axis (non-static) ---
    if (Var%axes(Var%ndim) == recdim) then ! assume last dimension is time
        Var%static = .false.
        Var%ndim = Var%ndim - 1
        ! skip certain fields that only have record dimension
        if (Var%ndim == 0) then
            nc = len_trim(Var%name)
            if (Var%name(nc-2:nc) == '_T1' .or. &
                Var%name(nc-2:nc) == '_T2' .or. &
                Var%name(nc-2:nc) == '_DT' .or. &
                Var%name(nc-6:nc) == '_NITEMS') Var%skip = .true.
            ! skip record dimension field
         !!!if (Var%axes(1) == recdim) Var%skip = .true.
        endif
        if (Var%skip) then
            if (verbose) write (*,100) trim(Var%name), ' '
            return
        endif
   !--- variable does not have a time axis (static) ---
    else
        Var%static = .true.
    endif

    ! check compilation precision for double precision variables
    ! skip for time_bounds and record dimension
    if (Var%xtype == NF90_REAL8) then
        if (trim(Var%name).ne.trim(name_time_bounds) .and. &
            trim(Var%name).ne.trim(name_recdim)) then
                if (precision(ddata) < precision(time)) then
                    if (.not.suppress_warnings) write (*,90) trim(Var%name)
                90  format ('WARNING: double precision field ',a, &
                            ' will be averaged using lower precision')
                    endif
        endif
    endif

   !--- compute variable size/shape ---
    shape(1:4) = 1
    do idim = 1, Var%ndim
       istat = NF90_INQUIRE_DIMENSION (ncid, Var%axes(idim), len=shape(idim))
       if (istat /= NF90_NOERR) call error_handler (ncode=istat)
    enddo
    Var%shape = shape

   !--- check shape of "time_bounds" ---
    if (trim(Var%name) == trim(name_time_bounds)) then
        if (Var%ndim > 1 .or. Var%shape(1) /= 2) then
            if (.not.suppress_warnings) write (*,95) 
         95 format ('WARNING: wrong dimensions for time_bounds ... skipping')
            Var%skip = .true.
            return
        endif
    endif

   !--- change the name of the time bounds for climatology bounds ----
   !if (trim(Var%name) == trim(name_time_bounds)) then
   !    if (change_bounds_to_climo) then
   !        do i=1,NF90_MAX_NAME; name_time_bounds(i:i) = ' '; enddo
   !        do i=1,NF90_MAX_NAME; Var%name        (i:i) = ' '; enddo
   !        name_time_bounds = 'climatology_bounds'
   !        Var%name         = 'climatology_bounds'
   !    endif
   !endif

   !--- save the maximum size ---
    do idim = 1, Var%ndim
       max_shape(idim) = max( max_shape(idim), shape(idim) )
    enddo

   !--- get missing value if present ---
    Var%do_missval = .false.
    istat = NF90_GET_ATT (ncid, varid, 'missing_value', Var%missval)
    if (istat == NF90_NOERR) Var%do_missval = .true.
   !--- also check for fill value ---
    do_fillval = .false.
    istat = NF90_GET_ATT (ncid, varid, '_FillValue', fillval)
    if (istat == NF90_NOERR) do_fillval = .true.
   !--- use fill value when missing value not present ---
    if (.not.Var%do_missval .and. do_fillval) then
        Var%do_missval = do_fillval
        Var%missval    = fillval
    endif

   !--- get time average info for non-static variables ----
    Var%do_avg = .false.
    if (.not.Var%static) then
        istat = NF90_GET_ATT (ncid, varid, 'time_avg_info', Var%avg_info)
        if (istat == NF90_NOERR) then
            nc = len_trim(tavg_info_string)
           !if (trim(Var%avg_info) /= trim(tavg_info_string)) then
            if (Var%avg_info(1:nc) /= tavg_info_string(1:nc)) then
                if (.not.suppress_warnings) write (*,96) trim(Var%name),trim(tavg_info_string), &
                                                         trim(Var%name),trim(Var%avg_info)
             96 format ('WARNING: time average information string does not match, var=',a, &
                      /,'         (time_avg_info=',a,', ',a,' has value=',a,')' )
            endif
            Var%do_avg = .true.
        endif
    endif

 end subroutine init_variable_type

!#######################################################################

 subroutine check_for_climo_avg ( ncid, tname, tunits, ntimes,  &
                                  climo, period_in, period_out, &
                                  tbnds_name, tavg_names )
 integer,          intent(in)  :: ncid
 character(len=*), intent(in)  :: tname, tunits
 integer,          intent(in)  :: ntimes
 logical,          intent(out) :: climo
 character(len=*), intent(out) :: period_in, period_out
 character(len=*), intent(in), optional :: tbnds_name, tavg_names(2)
 real(8) :: tbnds(2,2), times(2), dt(2)
 integer :: varid(2), i, istat, nc
 logical :: tbnds_present, tavgs_present

 ! read the time bounds for the two time periods

  tbnds_present = .false.
  if (present(tbnds_name)) then
      if (tbnds_name(1:1) .ne. ' ') tbnds_present = .true.
  endif
  tavgs_present = .false.
  if (present(tavg_names)) then
      if (tavg_names(1)(1:1) .ne. ' ' .and. tavg_names(2)(1:1) .ne. ' ')  then
          tavgs_present = .true.
          do i = 1, 2
             istat = NF90_INQ_VARID ( ncid, trim(tavg_names(i)), varid(i) )
             if (istat /= NF90_NOERR) then
                 tavgs_present = .false.
                 exit
             endif
          enddo
      endif
  endif

  if (tbnds_present) then
      istat = NF90_INQ_VARID ( ncid, trim(tbnds_name), varid(1) )
      if (istat /= NF90_NOERR) call error_handler ('error getting varid for time bounds', ncode=istat)
      istat = NF90_GET_VAR ( ncid, varid(1), tbnds )
      if (istat /= NF90_NOERR) call error_handler ('error getting data for time bounds', ncode=istat)

  else if (tavgs_present) then
      do i = 1, 2
         istat = NF90_GET_VAR ( ncid, varid(i), tbnds(i,:) )
         if (istat /= NF90_NOERR) call error_handler (ncode=istat)
      enddo
  else
      tbnds = 0.0
  endif

! if the time bounds are contiguous this is not a climatological average

  climo = .false.
  if (tbnds_present .or. tavgs_present) then
     if (tbnds(2,1) == tbnds(1,2)) then
        climo = .false.
     else
        climo = .true.
     endif
  endif

! get the first two time axis values
  
  if (ntimes >= 2) then
     istat = NF90_INQ_VARID ( ncid, trim(tname), varid(1) )
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)
     istat = NF90_GET_VAR ( ncid, varid(1), times ) 
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)
     dt = times(2)-times(1)
  else
     if (.not.tbnds_present .and. .not.tavgs_present) then
         call error_handler ('cannot average when only one time level')
     endif
  endif

! convert time units to days

  if (trim(tunits) == 'days') then
  else if (trim(tunits) == 'hours') then
       tbnds = tbnds/24.
  else if (trim(tunits) == 'minutes') then
       tbnds = tbnds/1440.
  else if (trim(tunits) == 'seconds') then
       tbnds = tbnds/86400.
  else
     !call error_handler ('invalid units')
      tbnds = 0.
  endif

! determine the "within average period"
! this is the length of the input period

  if (tbnds_present .or. tavgs_present) then
      dt(1) = tbnds(2,1)-tbnds(1,1)
  else
      dt(1) = times(2)-times(1)
      dt(2) = ntimes*dt(1) ! estimate total length of average
  endif

! choose days, months, years
  if (dt(1) > 27. .and. dt(1) < 300.) then
      period_in = 'months'
  else if (dt(1) < 1.01) then
      period_in = 'days'
  else if (dt(1) > 359.) then
      period_in = 'years'
  else
      period_in = ' ' ! unknown
  endif

! determine the "over average period"
! this is the time between input values when climatology
! this is the averaging time when not climatology

  if (tbnds_present .or. tavgs_present) then
      if (climo) then
          dt(2) = tbnds(1,2)-tbnds(1,1)
      else
          dt(2) = ntimes*(times(2)-times(1)) ! estimate total length of average
      endif
  endif

! choose days, months, years
  if (dt(2) > 27. .and. dt(2) < 300.) then
      period_out = 'months'
  else if (dt(1) < 1.01) then
      period_out = 'days'
  else if (dt(2) > 359.) then
      period_out = 'years'
  else
      period_out = ' ' ! unknown
  endif
      

 end subroutine check_for_climo_avg

!#######################################################################

 subroutine alloc_variable_type ( ntime, Var )
 integer            , intent(in)    :: ntime
 type(variable_type), intent(inout) :: Var

   !--- allocate space for data (and data wt when necessary) ---
    allocate (Var%data_sum(shape(1),shape(2),shape(3),shape(4)))
    if (.not.Var%use_data_wt) then
       if (ntime > 1 .and. Var%do_missval .and. .not.Var%static) then
           allocate (Var%data_wt(shape(1),shape(2),shape(3),shape(4)))
           Var%use_data_wt = .true.
       endif
    endif

    if (verbose) then  ! global variable
        write (*,102) trim(Var%name), Var%static, &
                      Var%use_data_wt, Var%ndim, Var%shape
        if (Var%do_missval) write (*,103) Var%missval
        if (Var%do_avg)   write (*,104) Var%do_avg
    102 format (4x,'Field=',a,4x,'static=',L1,4x,'use_data_wt=',L1, &
              /,10x,'ndim=',i1,4x,'shape=',3i4)
    103 format (10x,'missing value=',g15.7)
    104 format (10x,'time averaged=',L1)
    endif

 end subroutine alloc_variable_type

!#######################################################################

end program time_average

module ocean_bih_tracer_mod
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Thickness weighted and density weighted time tendency
! for tracer from biharmonic tracer mixing. 
!</OVERVIEW>
!
!<DESCRIPTION>
! There are two main options for computing the fluxes.
!
! (1) The lateral fluxes can be aligned with the z-coordinate surfaces,
! in which case the fluxes must be approximated if (i) we use non-geopotential
! vertical coordinates, (ii) next to partial bottom step topography.
! This form of the diffusion is not recommended since it can lead to 
! the creation of spurious extrema.  
!
! (2) The lateral fluxes can be aligned surfaces of constant vertical 
! coordinate. In this case the fluxes are no longer strictly "horizontal."
! Howerver, the operator is simpler and it ensures that no suprious
! extrema are created. It is for this reason that the simpler operator
! is preferred.   
!  
! The diffusivity used to determine the strength of the tendency can be 
! a general function of space yet it is constant in time.  A namelist 
! option exists that determines this diffusivity as a local function 
! of the grid spacing. 
!</DESCRIPTION>
!
!<NAMELIST NAME="ocean_bih_tracer_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module
!  </DATA> 
!  <DATA NAME="horz_z_diffuse" TYPE="logical">
!  To compute fluxes along surfaces of constant depth.
!  This operation must necessarily be approximate for the two 
!  cases (i) non-geopotential vertical coordinates, (2)
!  next to partial bottom step topography.  There are cases where
!  use of this operator can lead to spurious creation of extrema
!  due to truncation errors associated with the "slope" term.
!  The option to use horz_z_diffuse=.true. is maintained for 
!  legacy purposes alone.  
!  </DATA> 
!  <DATA NAME="horz_s_diffuse" TYPE="logical">
!  To compute diffusion along surfaces of constant vertical s-coordinate. 
!  </DATA> 
!  <DATA NAME="abih" UNITS="m^4/sec" TYPE="real">
!  This is the value for the space-time constant biharmonic diffusivity. 
!  </DATA> 
!  <DATA NAME="tracer_mix_micom" TYPE="logical">
!  If .true., then the diffusivity is set according to a velocity scale times
!  the cube of the grid spacing. It is based on an approach recommended by 
!  Eric Chassignet that is used in the Miami Isopycnal Model.  
!  </DATA> 
!  <DATA NAME="vel_micom" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM diffusivity. 
!  </DATA> 
!
!  <DATA NAME="read_diffusivity_mask" TYPE="logical">
!  Allows for reading of a mask that to apply diffusivity
!  only in selected regions.  
!  Default read_diffusivity_mask=.false. 
!  </DATA> 
!</NAMELIST>

use constants_mod,    only: epsln
use diag_manager_mod, only: register_diag_field, register_static_field
use fms_mod,          only: FATAL, NOTE, stdout, stdlog, read_data
use fms_mod,          only: write_version_number, open_namelist_file, close_file, check_nml_error
use mpp_domains_mod,  only: mpp_update_domains, CGRID_NE
use mpp_mod,          only: input_nml_file, mpp_error

use ocean_domains_mod,    only: get_local_indices, set_ocean_domain
use ocean_operators_mod,  only: FMX, FMY, BDX_ET, BDY_NT
use ocean_operators_mod,  only: FDX_ZT, FDY_ZT, FDX_T, FDY_T
use ocean_obc_mod,        only: store_ocean_obc_tracer_flux, ocean_obc_enhance_diff_back
use ocean_parameters_mod, only: missing_value
use ocean_types_mod,      only: ocean_grid_type, ocean_domain_type, ocean_time_type
use ocean_types_mod,      only: ocean_thickness_type, ocean_prog_tracer_type, ocean_options_type
use ocean_workspace_mod,  only: wrk1 
use ocean_util_mod,       only: diagnose_3d


implicit none

private

public ocean_bih_tracer_init
public bih_tracer
private del2_tracer

real ::    abih      = 0.0e10        ! constant horz biharmonic mixing coefficient for tracers
real ::    vel_micom = 0.0           ! constant velocity scale (m/s) for setting micom diffusivity  
logical :: tracer_mix_micom =.false. ! for spatial dependent diffusivity 

real, dimension(:,:,:), allocatable :: diff_cet         ! diffusivity for eastern face of T cell (m^4/s)
real, dimension(:,:,:), allocatable :: diff_cnt         ! diffusivity for northern face of T cell (m^4/s)
real, dimension(:,:,:), allocatable :: del2_tracer      ! Laplacian operator acting on tracers
real, dimension(:,:,:), allocatable :: diffusivity_mask ! 3d mask to selectively apply diffusion 

! for diagnostics 
logical :: used
integer, dimension(:), allocatable  :: id_xflux_diff
integer, dimension(:), allocatable  :: id_yflux_diff
integer, dimension(:), allocatable  :: id_h_diffuse
integer                             :: id_ah_biharmonic

character(len=128) :: version=&
     '=>Using: /bih/ocean_bih_tracer.F90 ($Id: ocean_bih_tracer.F90,v 20.0 2013/12/14 00:14:10 fms Exp $)'
character (len=128) :: tagname = &
     '$Name: tikal $'

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_domain_type), save    :: Dom_flux

real, dimension(:,:,:), allocatable :: fx, fy
integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk
integer :: num_prog_tracers      = 0

logical :: use_this_module       = .false.
logical :: horz_z_diffuse        = .false.
logical :: horz_s_diffuse        = .true.
logical :: module_is_initialized = .FALSE.
logical :: read_diffusivity_mask = .false.
logical :: have_obc=.false.

namelist /ocean_bih_tracer_nml/ use_this_module, abih, tracer_mix_micom, vel_micom, &
                                read_diffusivity_mask, horz_z_diffuse, horz_s_diffuse

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_bih_tracer_init">
!
! <DESCRIPTION>
! Initialize the biharmonic tracer mixing module by 
! registering fields for diagnostic output and performing some 
! numerical checks to see that diffusivity is set appropriately.
! </DESCRIPTION>
!
subroutine ocean_bih_tracer_init(Grid, Domain, Time, T_prog, Ocean_options, dtime, obc, tmask_sigma)

  type(ocean_grid_type),        intent(in), target   :: Grid
  type(ocean_domain_type),      intent(in), target   :: Domain
  type(ocean_time_type),        intent(in)           :: Time
  type(ocean_prog_tracer_type), intent(inout)        :: T_prog(:)
  type(ocean_options_type),     intent(inout)        :: Ocean_options
  real,                         intent(in)           :: dtime
  logical,                      intent(in)           :: obc
  real,                         intent(in), optional :: tmask_sigma(Domain%isc:Domain%iec,Domain%jsc:Domain%jec)

  real    :: dxdymn, ah_crit
  integer :: ioun, io_status, ierr
  integer :: i, j, k, n, num
 
  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, '==>Error in ocean_bih_tracer_mod (ocean_bih_tracer_init): already initialized')
  endif 

  module_is_initialized = .TRUE.

  have_obc = obc

  num_prog_tracers = size(T_prog(:))

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_bih_tracer_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_bih_tracer_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_bih_tracer_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status, 'ocean_bih_tracer_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_bih_tracer_nml)  
  write (stdlogunit,ocean_bih_tracer_nml)

  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk

  if(use_this_module) then 
      write(stdoutunit,*)'==>Note from ocean_bih_tracer_mod: Using this module.'
      Ocean_options%horz_bih_tracer = 'Used horizontal biharmonic tracer mixing option.'
 else
      write(stdoutunit,*)'==>Note from ocean_bih_tracer_mod: NOT using this module.'
      Ocean_options%horz_bih_tracer = 'Did NOT use horizontal biharmonic tracer mixing.'
      return 
  endif

  if(abih > 0 .or. (tracer_mix_micom .and. vel_micom > 0)) then 
      write (stdoutunit,'(1x,a)') ' ==>WARNING: biharmonic tracer mixing contributes to unphysically'
      write (stdoutunit,'(7x,a)') 'large diapycnal mixing. Such may be damaging for longer simulations.'
      write (stdoutunit,'(7x,a)') 'It is recommended that one instead uses neutral physics.'
  endif

  if(horz_z_diffuse) then 
      write(stdoutunit,*)'==>Warning: Computing biharmonic tracer mixing along constant geoptoential surfaces.'
      write(stdoutunit,*)'   This operator can create spurious extrema where s-surfaces deviate from z-surfaces.'
      write(stdoutunit,*)'   For this reason, the alternative horz_s_diffuse=.true. is recommended.'
  endif

  if(horz_s_diffuse) then 
      write(stdoutunit,*)'==>Note: Computing biharmonic tracer mixing along constant s-surfaces.'
  endif

  if(horz_s_diffuse .and. horz_z_diffuse) then 
      write(stdoutunit,*)'==>Error from ocean_bih_tracer_mod: use only one of horz_s_diffuse and horz_z_diffuse.'
      write(stdoutunit,*)'   Presently, both are set true and this is not allowed. '
      call mpp_error(FATAL,'==>Error ocean_bih_tracer_mod: use only one of horz_s_diffuse and horz_z_diffuse.')
  endif

  if(.not. horz_s_diffuse .and. .not. horz_z_diffuse) then 
      write(stdoutunit,*)'==>Warning from ocean_bih_tracer_mod: use_this_module=.true.'
      write(stdoutunit,*)'   However, both horz_s_diffuse and horz_z_diffuse are .false.'
      write(stdoutunit,*)'   So will not produce any lateral biharmonic tracer mixing.'
  endif


  write(stdoutunit,'(/a,f10.2)')'==> Note from ocean_bih_tracer_mod: using forward time step (secs)', dtime 

  Dom => Domain
  Grd => Grid
  
  call set_ocean_domain(Dom_flux, Grid, name='horz diff flux', maskmap=Dom%maskmap)

  allocate (diff_cet(isd:ied,jsd:jed,nk))
  allocate (diff_cnt(isd:ied,jsd:jed,nk))
  allocate (del2_tracer(isd:ied,jsd:jed,nk))
  allocate (fx(isd:ied,jsd:jed,nk))
  allocate (fy(isd:ied,jsd:jed,nk))  
  
  diff_cet    = abih
  diff_cnt    = abih
  del2_tracer = 0.0
  fx          = 0.0
  fy          = 0.0
  
  ! Micom background diffusivity
  ! Space scale set by grid size
  ! Velocity scale input via namelist 
  if(tracer_mix_micom) then
    do k=1,nk
      diff_cet(:,:,k) = vel_micom*(2.0*Grd%dxt(:,:)*Grd%dyte(:,:)/(Grd%dxt(:,:)+Grd%dyte(:,:)))**3
      diff_cnt(:,:,k) = vel_micom*(2.0*Grd%dxtn(:,:)*Grd%dyt(:,:)/(Grd%dxtn(:,:)+Grd%dyt(:,:)))**3
    enddo
    do j=jsc,jec
      write (stdoutunit,'(a,i4,a,e14.7,a)') ' MICOM biharmonic diffusivity at (isc,',j,',1) = ',diff_cet(isc,j,1),' m^4/s'
    enddo
  endif 

  ! enhance background diffusion near open boundaries if needed
  if (have_obc) call ocean_obc_enhance_diff_back(diff_cet, diff_cnt, 'bih')
  
  if(PRESENT(tmask_sigma)) then 
     do j=jsc,jec
        do i=isc,iec
           if(tmask_sigma(i,j) > 0.0) then   
              k = Grd%kmt(i,j)
              diff_cet(i,j,k) = diff_cet(i,j,k)*(1.0-tmask_sigma(i,j))
              diff_cnt(i,j,k) = diff_cnt(i,j,k)*(1.0-tmask_sigma(i,j))
           endif
        enddo
     enddo
  endif
  
  ! apply diffusivity in selected regions 
  if(read_diffusivity_mask) then 
      allocate (diffusivity_mask(isd:ied,jsd:jed,nk))
      call read_data('INPUT/tracer_diffusivity_mask.nc','diffusivity_mask', diffusivity_mask, Domain%domain2d)
      write (stdoutunit,*) '==>ocean_bih_tracer_mod: Completed read of 3d tracer diffusivity mask.'
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               diff_cet(i,j,k) = diff_cet(i,j,k)*diffusivity_mask(i,j,k)
               diff_cnt(i,j,k) = diff_cnt(i,j,k)*diffusivity_mask(i,j,k)
            enddo
         enddo
      enddo
  endif

  call mpp_update_domains (diff_cet(:,:,:), Dom%domain2d)
  call mpp_update_domains (diff_cnt(:,:,:), Dom%domain2d)

  if (dtime /= 0.0) then
    num = 0
    do j=jsc,jec
      do i=isc,iec
        dxdymn = (2.0/(1.0/(Grd%dxt(i,j))**2 + 1.0/Grd%dyt(i,j)**2))**2
        ah_crit = 0.0625*dxdymn/dtime
        if (diff_cet(i,j,1)*Grd%tmask(i,j,1) > ah_crit .and. num <= 10 .and. i == isc) then
          num = num + 1
          if (num == 1) write (stdoutunit,'(/,(1x,a))')&
          '==> Warning: horz diffusive criteria exceeded for "ah". use a smaller "dtts", "ah". Show first 10 violations' 
          write (stdoutunit,'(a,i4,a,i4,a,f6.2,a,f6.2,a,2(e14.7,a))') ' at (i,j)= (',i,',',j,'), (lon,lat)= (', &
                Grd%xt(i,j),',',Grd%yt(i,j), '),  "ah" = ', diff_cet(i,j,1),' m^4/s. the critical value =',ah_crit,' m^4/s'
        endif
      enddo
    enddo
  endif

  ! register for diagnostics manager 
  allocate (id_xflux_diff(num_prog_tracers))
  allocate (id_yflux_diff(num_prog_tracers))
  allocate (id_h_diffuse(num_prog_tracers))
  id_xflux_diff=-1
  id_yflux_diff=-1
  id_h_diffuse =-1

  do n=1, num_prog_tracers

     if (trim(T_prog(n)%name) == 'temp') then
         id_xflux_diff(n) = register_diag_field ('ocean_model',          &
              trim(T_prog(n)%name)//'_xflux_diff', Grd%tracer_axes(1:3), &
              Time%model_time, 'i-diffusive heat flux', 'Watts',         &
              missing_value=missing_value, range=(/-1.e16,1.e16/))
         id_yflux_diff(n) = register_diag_field ('ocean_model',          &
              trim(T_prog(n)%name)//'_yflux_diff', Grd%tracer_axes(1:3), &
              Time%model_time, 'j-diffusive heat flux', 'Watts',         &
              missing_value=missing_value, range=(/-1.e16,1.e16/))         
         id_h_diffuse(n) = register_diag_field ('ocean_model',          &
              trim(T_prog(n)%name)//'_h_diffuse', Grd%tracer_axes(1:3), &
              Time%model_time, 'horz-diffusion heating', 'Watts/m^2',   &
              missing_value=missing_value, range=(/-1.e16,1.e16/))         
     else
         id_xflux_diff(n) = register_diag_field ('ocean_model',                       &
         trim(T_prog(n)%name)//'_xflux_diff', Grd%tracer_axes(1:3),                   &
              Time%model_time, 'i-diffusive flux of '//trim(T_prog(n)%name), 'kg/sec',&
              missing_value=missing_value, range=(/-1.e10,1.e10/))
         id_yflux_diff(n) = register_diag_field ('ocean_model',                       &
         trim(T_prog(n)%name)//'_yflux_diff', Grd%tracer_axes(1:3),                   &
              Time%model_time, 'j-diffusive flux of '//trim(T_prog(n)%name), 'kg/sec',&
              missing_value=missing_value, range=(/-1.e10,1.e10/))         
         id_h_diffuse(n) = register_diag_field ('ocean_model',                            &
         trim(T_prog(n)%name)//'_h_diffuse', Grd%tracer_axes(1:3),                        &
              Time%model_time, 'horz-diffusion of '//trim(T_prog(n)%name), 'kg/(m^2*sec)',&
              missing_value=missing_value, range=(/-1.e10,1.e10/))         
     endif

  enddo

  id_ah_biharmonic = register_static_field ('ocean_model', 'ah_biharmonic',&
                     Grd%tracer_axes(1:3),'static biharmonic diffusivity', &
                     'm^4/sec', missing_value=missing_value, range=(/-10.0,1.e20/))
  call diagnose_3d(Time, Grd, id_ah_biharmonic, diff_cet(:,:,:))


end subroutine ocean_bih_tracer_init
! </SUBROUTINE>  NAME="ocean_bih_tracer_init"


!#######################################################################
! <SUBROUTINE NAME="bih_tracer">
!
! <DESCRIPTION>
! This function computes the thickness weighted and density weighted
! time tendency for tracer from biharmonic mixing. 
! </DESCRIPTION>
!
subroutine bih_tracer (Time, Thickness, Tracer, ntracer, diag_flag)

  type(ocean_time_type),        intent(in)           :: Time
  type(ocean_thickness_type),   intent(in)           :: Thickness
  type(ocean_prog_tracer_type), intent(inout)        :: Tracer
  integer,                      intent(in)           :: ntracer
  logical,                      intent(in), optional :: diag_flag 
  logical :: send_diagnostics 

  real, dimension(isd:ied,jsd:jed,2)  :: tracr
  integer                             :: i, j, k
  integer                             :: tau, taum1
 
  if(.not. use_this_module) return 

  ! assume send_diagnostics=.true., unless diag_flag says it is false.
  if (PRESENT(diag_flag)) then 
    send_diagnostics = diag_flag
  else 
    send_diagnostics = .true.
  endif 

  ! fx = flux component through "eastern"  face of T-cells at level k
  ! fy = flux component through "northern" face of T-cells at level k
  ! tracr(:,:,1) = tracer at level k-1
  ! tracr(:,:,2) = tracer at level k

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, '==>Error in ocean_bih_tracer_mod (bih_tracer): needs initialization')
  endif 

  taum1 = Time%taum1
  tau   = Time%tau

  call delsq_tracer (Thickness, Tracer%field(:,:,:,taum1), tau)
  if(Dom%xhalo==1 .and. Dom%yhalo==1) call mpp_update_domains (del2_tracer, Dom%domain2d)

  if(horz_z_diffuse) then 
      tracr(:,:,1) = -del2_tracer(:,:,1)
      do k=1,nk
         tracr(:,:,2) = -del2_tracer(:,:,k)
         fx(:,:,k)    = diff_cet(:,:,k)*FDX_ZT(tracr(:,:,1:2),k)*FMX(Thickness%rho_dzt(:,:,k,tau)*Grd%tmask(:,:,k))
         fy(:,:,k)    = diff_cnt(:,:,k)*FDY_ZT(tracr(:,:,1:2),k)*FMY(Thickness%rho_dzt(:,:,k,tau)*Grd%tmask(:,:,k))
         tracr(:,:,1) = tracr(:,:,2)
      enddo
  elseif(horz_s_diffuse) then 
      do k=1,nk
         fx(:,:,k) = -diff_cet(:,:,k)*FDX_T(del2_tracer(:,:,k))*FMX(Thickness%rho_dzt(:,:,k,tau)*Grd%tmask(:,:,k))
         fy(:,:,k) = -diff_cnt(:,:,k)*FDY_T(del2_tracer(:,:,k))*FMY(Thickness%rho_dzt(:,:,k,tau)*Grd%tmask(:,:,k))
      enddo
  endif

  !  set redundancies for tripolar
  if(Grd%tripolar) call mpp_update_domains(fx, fy, Dom_flux%domain2d, gridtype=CGRID_NE)

  do k=1,nk
     wrk1(:,:,k) = (BDX_ET(fx(:,:,k)) + BDY_NT(fy(:,:,k)))
     do j=jsc,jec
        do i=isc,iec
           Tracer%th_tendency(i,j,k) = Tracer%th_tendency(i,j,k) + Grd%tmask(i,j,k)*wrk1(i,j,k)
        enddo
     enddo
  enddo

  ! send fluxes to diag_manager 
  ! absence of minus sign relative to laplacian due to minus sign used for biharmonic.
  if(send_diagnostics) then 

      if (id_xflux_diff(ntracer) > 0) then
          do k=1,nk
            fx(:,:,k) = fx(:,:,k)*Grd%dyte(:,:)
          enddo
          call diagnose_3d(Time, Grd, id_xflux_diff(ntracer), fx(:,:,:)*Tracer%conversion)
      endif
      if (id_yflux_diff(ntracer) > 0) then
          do k=1,nk
            fy(:,:,k) = fy(:,:,k)*Grd%dxtn(:,:)
          enddo
          call diagnose_3d(Time, Grd, id_yflux_diff(ntracer), fy(:,:,:)*Tracer%conversion)
      endif
      if (id_h_diffuse(ntracer) > 0) then
         call diagnose_3d(Time, Grd, id_h_diffuse(ntracer), wrk1(:,:,:)*Tracer%conversion)
      endif

  endif

  if (have_obc) then 
     call store_ocean_obc_tracer_flux(Time, Tracer, -1.0*fx, ntracer, 'z', 'dif')
     call store_ocean_obc_tracer_flux(Time, Tracer, -1.0*fy, ntracer, 'm', 'dif')
  endif
  
end subroutine bih_tracer
! </SUBROUTINE> NAME="bih_tracer"


!#######################################################################
! <SUBROUTINE NAME="delsq_tracer">
!
! <DESCRIPTION>
! Subroutine computes the laplacian operator acting on tracer with unit 
! diffusivity. Units of del2_tracer are tracer/length^2
! </DESCRIPTION>
!
subroutine delsq_tracer (Thickness, tracer, index)

  type(ocean_thickness_type),   intent(in) :: Thickness
  real, dimension(isd:,jsd:,:), intent(in) :: tracer
  integer,                      intent(in) :: index

  real, dimension(isd:ied,jsd:jed)   :: fe, fn
  real, dimension(isd:ied,jsd:jed,2) :: tracr
  integer :: k

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, '==>Error in ocean_bih_tracer_mod (delsq_tracer): module needs to be initialized')
  endif 


  ! fe = Diffusive flux across east face of T cells. Use unit diffusivity
  ! fn = Diffusive flux across north face of T cells. Use unit diffusivity

  if(horz_z_diffuse) then 
      tracr(:,:,1) = tracer(:,:,1)
      do k=1,nk
         tracr(:,:,2) = tracer(:,:,k)
         fe(:,:) = FDX_ZT(tracr(:,:,1:2),k)*FMX(Thickness%rho_dzt(:,:,k,index)*Grd%tmask(:,:,k))
         fn(:,:) = FDY_ZT(tracr(:,:,1:2),k)*FMY(Thickness%rho_dzt(:,:,k,index)*Grd%tmask(:,:,k))
         del2_tracer(:,:,k) = Grd%tmask(:,:,k)*(BDX_ET(fe(:,:)) + BDY_NT(fn(:,:)))/Thickness%rho_dzt(:,:,k,index)
         tracr(:,:,1) = tracr(:,:,2)
      enddo
  elseif(horz_s_diffuse) then
      do k=1,nk
         fe(:,:) = FDX_T(tracer(:,:,k))*FMX(Thickness%rho_dzt(:,:,k,index)*Grd%tmask(:,:,k))
         fn(:,:) = FDY_T(tracer(:,:,k))*FMY(Thickness%rho_dzt(:,:,k,index)*Grd%tmask(:,:,k))
         del2_tracer(:,:,k) = Grd%tmask(:,:,k)*(BDX_ET(fe(:,:)) + BDY_NT(fn(:,:)))/Thickness%rho_dzt(:,:,k,index)
      enddo
  endif


end subroutine delsq_tracer
! </SUBROUTINE> NAME="delsq_tracer"


end module ocean_bih_tracer_mod
      
      

! Parallelized utility routine for computing
! max of an input scalar
!
      subroutine getmax( psize, pmax )

#ifdef SPMD
      use mod_comm, only : mp_reduce_max
#endif

      implicit none

      integer psize
      real pmax(psize)

#ifdef SPMD
      call mp_reduce_max(psize, pmax)
#endif

      return
      end

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: prec_scops.F,v 20.0 2013/12/13 23:16:08 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2
 
#endif

! (c) 2008, Lawrence Livermore National Security Limited Liability Corporation.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list 
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Lawrence Livermore National Security Limited Liability Corporation 
!       nor the names of its contributors may be used to endorse or promote products derived from 
!       this software without specific prior written permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
      
      subroutine prec_scops(npoints,nlev,ncol,ls_p_rate,cv_p_rate,
     &                      frac_out,prec_frac)


      implicit none

      INTEGER npoints       !  number of model points in the horizontal
      INTEGER nlev          !  number of model levels in column
      INTEGER ncol          !  number of subcolumns

      INTEGER i,j,ilev,ibox,cv_col
      
      REAL ls_p_rate(npoints,nlev),cv_p_rate(npoints,nlev)

      REAL frac_out(npoints,ncol,nlev) ! boxes gridbox divided up into
                              ! Equivalent of BOX in original version, but
                              ! indexed by column then row, rather than
                              ! by row then column
                              !TOA to SURFACE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      REAL prec_frac(npoints,ncol,nlev) ! 0 -> clear sky
                                        ! 1 -> LS precipitation
                                        ! 2 -> CONV precipitation
                    ! 3 -> both
                                        !TOA to SURFACE!!!!!!!!!!!!!!!!!!
                    
      INTEGER flag_ls, flag_cv
      INTEGER frac_out_ls(npoints,ncol),frac_out_cv(npoints,ncol) !flag variables for 
                       ! stratiform cloud and convective cloud in the vertical column

      cv_col = 0.05*ncol
      if (cv_col .eq. 0) cv_col=1
 
      do ilev=1,nlev
        do ibox=1,ncol
          do j=1,npoints 
            prec_frac(j,ibox,ilev) = 0
          enddo
        enddo
      enddo
      
      do j=1,npoints
       do ibox=1,ncol
        frac_out_ls(j,ibox)=0
        frac_out_cv(j,ibox)=0
        flag_ls=0
        flag_cv=0
        do ilev=1,nlev
          if (frac_out(j,ibox,ilev) .eq. 1) then 
            flag_ls=1
          endif
          if (frac_out(j,ibox,ilev) .eq. 2) then 
            flag_cv=1
          endif
        enddo !loop over nlev
        if (flag_ls .eq. 1) then
           frac_out_ls(j,ibox)=1
        endif
        if (flag_cv .eq. 1) then
           frac_out_cv(j,ibox)=1
        endif
       enddo  ! loop over ncol
      enddo ! loop over npoints

!      initialize the top layer      
       do j=1,npoints
        flag_ls=0
        flag_cv=0
    
        if (ls_p_rate(j,1) .gt. 0.) then 
            do ibox=1,ncol ! possibility ONE
                if (frac_out(j,ibox,1) .eq. 1) then 
                    prec_frac(j,ibox,1) = 1
                    flag_ls=1
                endif
            enddo ! loop over ncol
            if (flag_ls .eq. 0) then ! possibility THREE
                do ibox=1,ncol
                    if (frac_out(j,ibox,2) .eq. 1) then 
                        prec_frac(j,ibox,1) = 1
                        flag_ls=1
                    endif
                enddo ! loop over ncol
            endif
        if (flag_ls .eq. 0) then ! possibility Four
        do ibox=1,ncol
        if (frac_out_ls(j,ibox) .eq. 1) then 
            prec_frac(j,ibox,1) = 1
            flag_ls=1
        endif
        enddo ! loop over ncol
        endif
        if (flag_ls .eq. 0) then ! possibility Five
        do ibox=1,ncol
    !     prec_frac(j,1:ncol,1) = 1
        prec_frac(j,ibox,1) = 1
        enddo ! loop over ncol
            endif
        endif
       ! There is large scale precipitation
     
        if (cv_p_rate(j,1) .gt. 0.) then 
         do ibox=1,ncol ! possibility ONE
          if (frac_out(j,ibox,1) .eq. 2) then 
           if (prec_frac(j,ibox,1) .eq. 0) then
        prec_frac(j,ibox,1) = 2
       else
        prec_frac(j,ibox,1) = 3
       endif
       flag_cv=1
      endif
        enddo ! loop over ncol
        if (flag_cv .eq. 0) then ! possibility THREE
        do ibox=1,ncol
        if (frac_out(j,ibox,2) .eq. 2) then 
                if (prec_frac(j,ibox,1) .eq. 0) then
            prec_frac(j,ibox,1) = 2
            else
            prec_frac(j,ibox,1) = 3
            endif
            flag_cv=1
        endif
        enddo ! loop over ncol
        endif
        if (flag_cv .eq. 0) then ! possibility Four
        do ibox=1,ncol
        if (frac_out_cv(j,ibox) .eq. 1) then 
                if (prec_frac(j,ibox,1) .eq. 0) then
            prec_frac(j,ibox,1) = 2
            else
            prec_frac(j,ibox,1) = 3
            endif
            flag_cv=1
        endif
        enddo ! loop over ncol
        endif
        if (flag_cv .eq. 0) then  ! possibility Five
        do ibox=1,cv_col
                if (prec_frac(j,ibox,1) .eq. 0) then
            prec_frac(j,ibox,1) = 2
            else
            prec_frac(j,ibox,1) = 3
            endif 
        enddo !loop over cv_col
            endif 
        endif 
        ! There is convective precipitation
        
        enddo ! loop over npoints
!      end of initializing the top layer

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!     working on the levels from top to surface
      do ilev=2,nlev
       do j=1,npoints
        flag_ls=0
        flag_cv=0
    
        if (ls_p_rate(j,ilev) .gt. 0.) then 
         do ibox=1,ncol ! possibility ONE&TWO
          if ((frac_out(j,ibox,ilev) .eq. 1) .or. 
     &       ((prec_frac(j,ibox,ilev-1) .eq. 1) 
     &       .or. (prec_frac(j,ibox,ilev-1) .eq. 3))) then 
           prec_frac(j,ibox,ilev) = 1
           flag_ls=1
          endif
        enddo ! loop over ncol
        if ((flag_ls .eq. 0) .and. (ilev .lt. nlev)) then ! possibility THREE
        do ibox=1,ncol
        if (frac_out(j,ibox,ilev+1) .eq. 1) then 
            prec_frac(j,ibox,ilev) = 1
            flag_ls=1
        endif
        enddo ! loop over ncol
        endif
        if (flag_ls .eq. 0) then ! possibility Four
        do ibox=1,ncol
        if (frac_out_ls(j,ibox) .eq. 1) then 
            prec_frac(j,ibox,ilev) = 1
            flag_ls=1
        endif
        enddo ! loop over ncol
        endif
        if (flag_ls .eq. 0) then ! possibility Five
        do ibox=1,ncol
!     prec_frac(j,1:ncol,ilev) = 1
        prec_frac(j,ibox,ilev) = 1
        enddo ! loop over ncol
         endif
      endif ! There is large scale precipitation
    
        if (cv_p_rate(j,ilev) .gt. 0.) then 
         do ibox=1,ncol ! possibility ONE&TWO
          if ((frac_out(j,ibox,ilev) .eq. 2) .or. 
     &       ((prec_frac(j,ibox,ilev-1) .eq. 2) 
     &       .or. (prec_frac(j,ibox,ilev-1) .eq. 3))) then 
            if (prec_frac(j,ibox,ilev) .eq. 0) then
         prec_frac(j,ibox,ilev) = 2
        else
         prec_frac(j,ibox,ilev) = 3
        endif 
        flag_cv=1
        endif
       enddo ! loop over ncol
        if ((flag_cv .eq. 0) .and. (ilev .lt. nlev)) then ! possibility THREE
        do ibox=1,ncol
        if (frac_out(j,ibox,ilev+1) .eq. 2) then 
                if (prec_frac(j,ibox,ilev) .eq. 0) then
            prec_frac(j,ibox,ilev) = 2
            else
            prec_frac(j,ibox,ilev) = 3
            endif
            flag_cv=1
        endif
        enddo ! loop over ncol
        endif
        if (flag_cv .eq. 0) then ! possibility Four
        do ibox=1,ncol
        if (frac_out_cv(j,ibox) .eq. 1) then 
                if (prec_frac(j,ibox,ilev) .eq. 0) then
            prec_frac(j,ibox,ilev) = 2
            else
            prec_frac(j,ibox,ilev) = 3
            endif
            flag_cv=1
        endif
        enddo ! loop over ncol
        endif
        if (flag_cv .eq. 0) then  ! possibility Five 
        do ibox=1,cv_col
                if (prec_frac(j,ibox,ilev) .eq. 0) then
            prec_frac(j,ibox,ilev) = 2
            else
            prec_frac(j,ibox,ilev) = 3
            endif 
        enddo !loop over cv_col 
            endif 
        endif ! There is convective precipitation
    
        enddo ! loop over npoints
        enddo ! loop over nlev

      end

program create_grid
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Zhi Liang </CONTACT>
  !
  ! <OVERVIEW>
  !   This program works together with program make_xgrids, runoff_regrid to 
  !   remap runoff data from a spherical grid onto any grid. This program can 
  !   generate a spherical grid netcdf file that can be used to generate exchange 
  !   grid grid_spec.nc with the destination grid file ( ocean grid file). 
  !   
  ! </OVERVIEW>

  !<DESCRIPTION>
  ! This program expects to get grid data from a netcdf file, which is specfied
  ! by the namelist variable "src_data". The name of the runoff field is specified 
  ! by the namelist variable "src_fld_name". The output file is a netcdf file with
  ! name "atmos_grid.nc". 
  !</DESCRIPTION>
  !

  implicit none

#include "netcdf.inc"

  !--- namelist interface ----------------------------------------------
  !<NAMELIST NAME="runoff_regrid_nml">
  ! <DATA NAME="src_data" TYPE="character(len=128)" >
  !  Name of input file containing runoff data.
  ! </DATA>
  ! <DATA NAME="src_fld_name" TYPE="character(len=128),dimension(2)" >
  !  Name of runoff field.
  ! </DATA>
  !</NAMELIST>


  character(len=128) :: src_fld_name = 'runoff'      ! name of the runoff field
  character(len=128) :: src_data     = 'src_data.nc' ! name of the runoff source data file

  namelist /create_grid_nml/ src_fld_name, src_data

  !--- version information ---------------------------------------------
  character(len=128)   :: version= '$ID$'
  character(len=128)   :: tagname= '$Name: tikal $'

  !--- other variables -------------------------------------------------
  real,    allocatable :: lon(:), lat(:)
  integer              :: ni, nj
  integer              :: stdout = 6 

  !--- initialize routine 
  call create_grid_init()

  !--- read source data file to get longitude and latitude -------------
  call read_src_data()

  !--- generate the simple latlon atmosphere grid
  !--- the source data should be a simple latlon grid
  call generate_grid()

contains

  !#######################################################################
  !--- initialization routine : read namelist
  subroutine create_grid_init
    integer :: unit=7, iostat
    logical :: opened

    !--- read namelist 
    do 
       inquire( unit, opened = opened )
       if( .not. opened ) exit
       unit = unit + 1
       if( unit.EQ.100 )call error_handler( 'Error: unable to locate unit number.' )
    enddo

    open (unit, file='input.nml', iostat = iostat )
    if(iostat .ne. 0) call error_handler('error in open input.nml file')

    read (unit, create_grid_nml, iostat=iostat)
    if(iostat .ne. 0) call error_handler('error in while reading create_grid_nml ')

    close(unit)

    !--- write out namelist and version information
    write( stdout,'(/a)' )'create_grid '//trim(version)//trim(tagname)
    write( stdout, create_grid_nml)

  end subroutine create_grid_init

  !#######################################################################
  !--- read the longitude and latitude from src_data
  subroutine read_src_data

    integer           :: dims(4)
    integer           :: rcode, ncid, nvar, id_runoff, i
    character(len=64) :: lon_name, lat_name, name

    rcode = nf_open(trim(src_data), NF_NOWRITE, ncid)
    call error_handler('error in opening file '//trim(src_data), rcode)

    rcode = nf_inq_nvars(ncid, nvar)
    call error_handler('error in inquring nvars', rcode)  

    rcode = nf_inq_varid(ncid, trim(src_fld_name), id_runoff )
    call error_handler('error in inquring variable id', rcode)

    rcode = nf_inq_vardimid(ncid, id_runoff, dims)
    call error_handler('error in inquring dimension id', rcode)

    rcode = nf_inq_dimlen(ncid, dims(1), ni)
    call error_handler('error in inquring dimension length ni', rcode)

    rcode = nf_inq_dimlen(ncid, dims(2), nj)
    call error_handler('error in inquring dimension length nj', rcode)

    allocate(lon(ni), lat(nj) )

    rcode = nf_inq_dimname(ncid, dims(1), lon_name)
    call error_handler('error in inquring lon_name', rcode)

    rcode = nf_inq_dimname(ncid, dims(2), lat_name)
    call error_handler('error in inquring lat_name', rcode)

    do i = 1, nvar
       rcode = nf_inq_varname(ncid,i,name)
       if(trim(name) == trim(lon_name)) then
          rcode = nf_get_var_double(ncid,i,lon)
       else if(trim(name) == trim(lat_name)) then
          rcode = nf_get_var_double(ncid,i,lat)
       endif
    enddo

  end subroutine read_src_data

  !#####################################################################
  !--- generate the spherical grid
  subroutine generate_grid

    integer           :: i, j, rcode, ncid, start(4), nwrite(4), dims(3), id_vertex 
    integer           :: id_x_t, id_y_t, id_x_vert_t, id_y_vert_t, id_grid_x_t, id_grid_y_t
    real, allocatable :: x_t(:,:), y_t(:,:), x_vert_t(:,:,:), y_vert_t(:,:,:)
    real, allocatable :: lonb(:), latb(:)
    integer            ::fsize = 65536, inital = 0


    allocate(x_t(ni, nj), x_vert_t(ni, nj,4) )
    allocate(y_t(ni, nj), y_vert_t(ni, nj,4) )
    allocate(lonb(ni+1), latb(nj+1))

    do i = 1, ni
       x_t(i,:) = lon(i)
    enddo

    do j = 1, nj
       y_t(:,j) = lat(j)
    enddo

    lonb(1) = (3.0*lon(1) - lon(2))*0.5
    lonb(ni+1) = (3.0*lon(ni) - lon(ni-1))*0.5
    do i = 2, ni
       lonb(i) = 0.5*(lon(i-1) + lon(i))
    enddo

    latb(1) = (3.0*lat(1) - lat(2)) * 0.5
    latb(nj+1) = (3.0*lat(nj) - lat(nj-1)) *0.5
    do j = 2, nj
       latb(j) = 0.5*(lat(j-1) + lat(j))
    enddo

    do i = 1, ni
       x_vert_t(i,:,1) = lonb(i)
       x_vert_t(i,:,2) = lonb(i+1)
       x_vert_t(i,:,3) = lonb(i+1)
       x_vert_t(i,:,4) = lonb(i)
    enddo

    do j = 1, nj
       y_vert_t(:,j,1) = latb(j)
       y_vert_t(:,j,2) = latb(j)
       y_vert_t(:,j,3) = latb(j+1)
       y_vert_t(:,j,4) = latb(j+1)
    enddo

#ifdef use_netCDF3
    rcode = NF__CREATE('atmos_grid.nc', NF_CLOBBER, inital, fsize, ncid)
#else  
    rcode = NF__CREATE('atmos_grid.nc', IOR(NF_NETCDF4,NF_CLASSIC_MODEL), inital, fsize, ncid )
#endif
    call error_handler('error in create file atmos_grid.nc', rcode)
    rcode = nf_def_dim(ncid, 'grid_x_T', ni, dims(1))
    call error_handler('error in defining x dimension', rcode)
    rcode = nf_def_dim(ncid, 'grid_y_T', nj, dims(2))
    call error_handler('error in defining y dimension', rcode)
    rcode = nf_def_dim(ncid, 'vertex',      4, dims(3))
    call error_handler('error in defining vertex dimension', rcode)
    rcode = nf_def_var(ncid, 'grid_x_T', NF_FLOAT, 1, dims(1), id_grid_x_t)
    call error_handler('error in defining axis grid_x_T', rcode)
    rcode = nf_def_var(ncid, 'grid_y_T', NF_FLOAT, 1, dims(2), id_grid_y_t)
    call error_handler('error in defining axis grid_y_T', rcode)
    rcode = nf_def_var(ncid, 'vertex',   NF_FLOAT, 1, dims(3), id_vertex)
    call error_handler('error in defining axis vertex', rcode)
    rcode = nf_def_var(ncid, 'x_T', NF_DOUBLE, 2, dims(1:2), id_x_t)
    call error_handler('error in defining field x_T', rcode)
    rcode = nf_def_var(ncid, 'y_T', NF_DOUBLE, 2, dims(1:2), id_y_t)
    call error_handler('error in defining field y_T', rcode)
    rcode = nf_def_var(ncid, 'x_vert_T', NF_DOUBLE, 3, dims(1:3), id_x_vert_t)
    call error_handler('error in defining field x_vert_T', rcode)
    rcode = nf_def_var(ncid, 'y_vert_T', NF_DOUBLE, 3, dims(1:3), id_y_vert_t)
    call error_handler('error in defining field y_vert_T', rcode)
    rcode = nf_enddef(ncid)

    start = 1; nwrite = 1
    nwrite(1) = ni
    rcode = nf_put_vara_double(ncid, id_grid_x_t, start, nwrite, lon)
    call error_handler('error in putting the data for axis grid_x_T', rcode)
    nwrite(1) = nj
    rcode = nf_put_vara_double(ncid, id_grid_y_t, start, nwrite, lat)
    call error_handler('error in putting the data for axis grid_y_T', rcode)
    nwrite(1) = ni; nwrite(2) = nj
    rcode = nf_put_vara_double(ncid, id_x_t, start, nwrite, x_t)
    call error_handler('error in putting the data for field x_T', rcode)
    rcode = nf_put_vara_double(ncid, id_y_t, start, nwrite, y_t) 
    call error_handler('error in putting the data for field y_T', rcode)
    nwrite(3) = 4   
    rcode = nf_put_vara_double(ncid, id_x_vert_t, start, nwrite, x_vert_t)
    call error_handler('error in putting the data for field x_vert_T', rcode)
    rcode = nf_put_vara_double(ncid, id_y_vert_t, start, nwrite, y_vert_t)
    call error_handler('error in put the data for field y_vert_T', rcode)
    rcode = nf_close(ncid)

    deallocate(x_t, y_t, x_vert_t, y_vert_t, lonb, latb, lon, lat)

  end subroutine generate_grid


  !#####################################################################
  ! error handling routine.
  subroutine error_handler(mesg, status)
    character(len=*),  intent(in) :: mesg
    integer, optional, intent(in) :: status
    character(len=128) :: msg

    if(present(status)) then
       if(status == 0) return
       write(msg,*) mesg, ', status code is ', status
    else
       write(msg,*) mesg
    endif

    write(stdout,*) msg

    call ABORT()

  end subroutine error_handler

  !#######################################################################

end program create_grid

                        MODULE RDPARM_MOD

!-----------------------------------------------------------------------
!
!   PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE: 
!   ----------------------------------------------------------------- 
!
!          IMAX   =  NO. POINTS ALONG THE LAT. CIRCLE USED IN CALCS.
!          JMAX   =  NO. POINTS ALONG THE MERIDIONAL AXIS
!          LMAX   =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL 
!
!      *** NOTE: THE USER NORMALLY WILL MODIFY ONLY THE
!                IMAX AND LMAX VARIABLES 
!
!          NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE 
!                      BANDTA FOR DEFINITION
!          NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS 
!          NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE
!                      BDCOMB FOR DEFINITION
!          INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
!          NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS. 
!
!          NB,KO2 ARE SHORTWAVE PARAMETERS; OTHER QUANTITIES ARE
!                    DERIVED FROM THE ABOVE PARAMETERS. 
!
!-----------------------------------------------------------------------

      Use       Fms_Mod, ONLY: write_version_number, mpp_pe, mpp_root_pe, &
                               error_mesg, FATAL

implicit none
private


!!!!  INTEGER, PUBLIC, SAVE :: IMAX,JMAX,LMAX
      INTEGER, PUBLIC, SAVE :: LMAX=0
      INTEGER, PUBLIC, SAVE :: LP1,LP2,LP3,LM1,LM2,LM3
      INTEGER, PUBLIC, SAVE :: LL,LLP1,LLP2,LLP3,LLM1,LLM2,LLM3
      INTEGER, PUBLIC, SAVE :: LP1M,LP1M1,LP1V,LP121,LL3P
      INTEGER, PUBLIC, SAVE :: LP1I,LLP1I,LL3PI

      INTEGER, PUBLIC, PARAMETER :: NBLW=163,NBLX=47,NBLY=15,NBLM=NBLY-1
      INTEGER, PUBLIC, PARAMETER :: NB=9,NB1=NB-1
      INTEGER, PUBLIC, PARAMETER :: INLTE=3,INLTEP=INLTE+1
      INTEGER, PUBLIC, PARAMETER :: NNLTE=56
      INTEGER, PARAMETER :: KO2=12,KO21=KO2+1,KO2M=KO2-1

      character(len=128) :: version = '$Id: rdparm.F90,v 10.0 2003/10/24 22:00:32 fms Exp $'
      character(len=128) :: tagname = '$Name: tikal $'
      logical            :: module_is_initialized = .false.

public RDPARM_INIT, RDPARM_END

      CONTAINS

!#######################################################################

      SUBROUTINE RDPARM_INIT (KDIM)

      IMPLICIT NONE
      INTEGER,INTENT(IN) :: KDIM

         LMAX=KDIM

         LP1=LMAX+1; LP2=LMAX+2; LP3=LMAX+3 
         LM1=LMAX-1; LM2=LMAX-2; LM3=LMAX-3 
         LL=2*LMAX; LLP1=LL+1; LLP2=LL+2; LLP3=LL+3
         LLM1=LL-1; LLM2=LL-2; LLM3=LL-3 
         LP1M=LP1*LP1; LP1M1=LP1M-1 
         LP1V=LP1*(1+2*LMAX/2)
         LP121=LP1*NBLY
         LL3P=3*LMAX+2

!!!!  Not Used ?????
!!!!     LP1I=IMAX*LP1; LLP1I=IMAX*LLP1; LL3PI=IMAX*LL3P 
!------- write version number and namelist ---------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
      endif

      module_is_initialized = .true.

      END SUBROUTINE RDPARM_INIT

!#######################################################################
      SUBROUTINE RDPARM_END

      module_is_initialized = .false.

!---------------------------------------------------------------------
      END SUBROUTINE RDPARM_END

!#######################################################################

                        END MODULE RDPARM_MOD

module ocean_form_drag_mod
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! Compute form drag as per Greatbatch and Lamb (1990) and/or 
! Aiki etal (2004).
!</OVERVIEW>
!
!<DESCRIPTION>
! Compute thickness weighted and density weighted tendency
! [velocity*(kg/m^3)*meter/sec] for velocity associated with 
! parameterized form drag.  Code employs the methods described
! in Greatbatch and Lamb (1990) as well as Aiki etal (2004).
!
! This scheme has not been updated for C-grid specific layout.
! However, there is little reason to expect that shifting the 
! viscosity by 1/2 grid point will make sense physically for this
! scheme.  Indeed, one does not expect this scheme to be relevant
! near boundaries anyhow.  So use for both Bgrid and Cgrid should
! be reasonable, though with the caveat that differences will appear
! near boundaries.  
!
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! Greatbatch and Lamb, 1990: On parameterizing vertical mixing of 
! momentum in non eddy-resolving ocean models.  Journal of 
! Physical Oceanography. vol. 20, pages 1634-1637.
! </REFERENCE>
!
! <REFERENCE>
! Greatbatch, 1998: Exploring the relationship betwen eddy-induced 
! transport velocity, vertical momentum transfer, and the isopycnal 
! flux of potential vorticity.  Journal of Physical Oceanography,
! vol. 28, pages 422-432.
! </REFERENCE>
!
! <REFERENCE>
! Aiki, Jacobson, and Yamagata, 2004: Parameterizing ocean eddy transports
! from surface to bottom. Geophysical Research Letters, vol. 31.  
! </REFERENCE>
!
! <REFERENCE>
! Ferreira and Marshall, 2006: Formulation and implementation of 
! a residual-mean ocean circulation model. Ocean Modelling,
! vol. 13, pages 86--107.
! </REFERENCE>
!
! <REFERENCE>
! Danabosaglu and Marshall, 2007: Effects of vertical variations of thickness
! diffusivity in an ocean general circulation model.
! Ocean Modelling, vol. 18, pages 122-141.
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_form_drag_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  Needs to be true in order to use this scheme. Default is false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging.
!  </DATA> 
!  <DATA NAME="verbose_init" TYPE="logical">
!  For verbose initialization information.
!  </DATA> 
!
!  <DATA NAME="use_form_drag_gbatch" TYPE="logical">
!  For using the Greatbatch form drag approach, which places  
!  the contributions from "GM" into the momentum equation.
!
!  use_form_drag_gbatch, is the traditional transformed
!  Eulerian mean approach as per Greatbatch and Lamb (1990)
!  and Greatbatch (1998). In this approach, we modify 
!  visc_cbu so that the the "GM-effects" occur through 
!  vertical viscosity.  
!
!  Since thise scheme is experimental, it is not recommended
!  for general use, so we set default 
!  use_form_drag_gbatch=.false.  
!  </DATA> 
!
!  <DATA NAME="form_drag_gbatch_surf_layer" TYPE="logical">
!  Logical to enable the use of a diabatic layer over which the 
!  eddy-induce velocity is assumed to be constant with depth. 
!  Default form_drag_gbatch_surf_layer=.false. 
!  </DATA> 
!  <DATA NAME="ksurf_blayer_min" TYPE="integer">
!  Minimum number of vertical grid points in the surface turbulent 
!  boundary layer for use with form_drag_gbatch_surf_layer=.true.
!  Default ksurf_blayer_min=3. 
!  </DATA> 
!
!  <DATA NAME="form_drag_gbatch_alpha_f2" TYPE="logical">
!  For use of a vertical viscosity with the form_drag_gbatch that is 
!  equal to visc = form_drag_gbatch_alpha * f^2.  This form of the 
!  vertical viscosity is used by Ferreira and Marshall, 2006.
!  Default form_drag_gbatch_alpha_f2=.false.
!  </DATA> 
!  <DATA NAME="form_drag_gbatch_alpha" TYPE="real"  UNITS="m^2*sec">
!  For use of a vertical viscosity with the form_drag_gbatch that is 
!  equal to visc = form_drag_gbatch_alpha * f^2. 
!  Default form_drag_gbatch_alpha=3e8
!  </DATA> 
!
!  <DATA NAME="form_drag_gbatch_f2overN2" TYPE="logical">
!  To compute vertical viscosity according to visc=kappa*(f/N)**2
!  with kappa=gm-diffusivity, f=Coriolis, and N=buoyancy frequency.
!  This is the form suggested by Greatbatch and Lamb (1990).
!  Default form_drag_gbatch_f2overN2=.false.
!  </DATA> 
!
!  <DATA NAME="form_drag_gbatch_f2overNb2" TYPE="logical">
!  To compute vertical viscosity according to visc=kappa*(f/Nb)**2
!  with kappa=gm-diffusivity, f=Coriolis, and Nb=buoyancy frequency
!  just below the diabatic mixed layer. This is the form suggested 
!  by Danabasoglu and Marshall (2007).
!  Default form_drag_gbatch_f2overNb2=.false.
!  </DATA> 
!
!  <DATA NAME="form_drag_gbatch_f2overNo2" TYPE="logical">
!  To compute vertical viscosity according to visc=kappa*(f/No)**2
!  with kappa=gm-diffusivity, f=Coriolis, and No=constant buoyancy
!  frequency set via namelist. 
!  Default form_drag_gbatch_f2overNo2=.false.
!  </DATA> 
!  <DATA NAME="form_drag_gbatch_No" TYPE="real"  UNITS="sec^-1">
!  To compute vertical viscosity according to visc=kappa*(f/No)**2
!  with kappa=gm-diffusivity, f=Coriolis, and No=constant buoyancy
!  frequency.  Default form_drag_gbatch_No=5e-3
!  </DATA> 
!
!  <DATA NAME="form_drag_gbatch_smooth_N2" TYPE="logical">
!  For vertically smoothing the squared buoyancy frequency for 
!  use in computing the vertical viscosity in the form drag 
!  approach. Default form_drag_gbatch_smooth_N2=.false.
!  </DATA> 
!  <DATA NAME="num_121_passes" TYPE="integer">
!  Number of 1-2-1 passes for vertically smoothing the squared
!  buoyancy frequency. Default num_121_passes=1.
!  </DATA> 
!
!  <DATA NAME="visc_cbu_form_drag_max" TYPE="real" UNITS="m^2/sec">
!  Maximum vertical viscosity used for the form drag contribution 
!  to vertical friction from the Greatbatch TEM approach. 
!  Default visc_cbu_form_drag_max=1m^2/sec. 
!  </DATA> 
!  <DATA NAME="vel_form_drag_max" TYPE="real" UNITS="m/sec">
!  For diagnostic purpuses, maximum form drag eddy induced velocity.
!  Default vel_form_drag_max=1m/sec. 
!  </DATA> 
!  <DATA NAME="N_squared_min" TYPE="real" UNITS="1/sec">
!  Minimum sequared buoyancy frequency (N^2) for use in computing 
!  the vertical viscosity from the Greatbatch form drag scheme. 
!  Default N_squared_min=1e-10.
!  </DATA> 
!
!  <DATA NAME="use_form_drag_aiki" TYPE="logical">
!  For using the Aiki form drag approach.
!  </DATA> 
!
!  <DATA NAME="cprime_aiki" TYPE="real"  UNITS="dimensionless">
!  Dimensionless parameters from the Aiki etal scheme. 
!  Default cprime_aiki=0.3. 
!  </DATA> 
!  <DATA NAME="form_drag_aiki_scale_by_gm" TYPE="logical">
! Compute a dimensionless scale function proportional to 
! the GM-diffusivity, for use with the Aiki etal form 
! drag scheme. Default form_drag_aiki_scale_by_gm=.false.
!  </DATA> 
!
!  <DATA NAME="form_drag_aiki_bottom_layer" TYPE="logical">
!  For implementing the Aiki form drag just in a selected number of 
!  bottom layers.  Will still insist that the scheme conserves 
!  momentum, as a form drag scheme should do.  
!  Default form_drag_aiki_bottom_layer=.false. 
!  </DATA> 
!  <DATA NAME="form_drag_aiki_bottom_klevels" TYPE="integer">
!  Number of klevels above the bottom that we choose to close the 
!  Aiki form drag scheme.  Default form_drag_aiki_bottom_klevels=3.
!  This should ideally be less than the minimum number of klevels 
!  in the model.
!  </DATA> 
!  <DATA NAME="form_drag_aiki_scale_by_gradH" TYPE="logical">
!  For scaling the coefficient used by the form drag scheme with 
!  the bottom slope.  
!  </DATA> 
!  <DATA NAME="form_drag_aiki_gradH_power" TYPE="real">
!  For scaling the coefficient used by the form drag scheme with 
!  the bottom slope raised to the power "form_drag_aiki_gradH_power".
!  </DATA> 
!  <DATA NAME="form_drag_aiki_gradH_max" TYPE="logical">
!  For scaling setting the maximum of the bottom slope
!  for use with scaling the form drag coefficient. 
!  Default form_drag_aiki_gradH_max=.05
!  </DATA> 
!
!</NAMELIST>

use constants_mod,     only: epsln
use diag_manager_mod,  only: register_diag_field, register_static_field
use fms_mod,           only: stdout, stdlog, FATAL, WARNING, NOTE
use fms_mod,           only: write_version_number, open_namelist_file, check_nml_error, close_file
use mpp_mod,           only: input_nml_file, mpp_error
use mpp_domains_mod,   only: mpp_global_max, mpp_update_domains

use ocean_domains_mod,    only: get_local_indices
use ocean_parameters_mod, only: missing_value, onefourth 
use ocean_parameters_mod, only: rho0r, onehalf, grav
use ocean_types_mod,      only: ocean_domain_type, ocean_grid_type
use ocean_types_mod,      only: ocean_thickness_type, ocean_time_type
use ocean_types_mod,      only: ocean_velocity_type, ocean_options_type
use ocean_types_mod,      only: ocean_density_type, ocean_time_steps_type
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3 
use ocean_workspace_mod,  only: wrk1_v, wrk2_v, wrk3_v
use ocean_workspace_mod,  only: wrk1_v2d, wrk2_v2d
use ocean_workspace_mod,  only: wrk1_2d, wrk2_2d, wrk3_2d, wrk4_2d
use ocean_util_mod,       only: diagnose_2d_u, diagnose_3d_u

implicit none

private 

public compute_visc_form_drag
public form_drag_accel
public ocean_form_drag_init

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

real, dimension(:,:),   allocatable :: gradH_scale     ! (dimensionless) scaling according to grad of topog
real, dimension(:,:,:), allocatable :: agm_diffusivity ! (m^2/sec) GM diffusivity 
real, dimension(:,:,:), allocatable :: N_squared       ! (m^2/sec) GM diffusivity 

! for diagnostics 
logical :: used
integer :: id_form_drag_aiki_gradH_scale=-1
integer :: id_form_drag_aiki_u          =-1
integer :: id_form_drag_aiki_v          =-1
integer :: id_form_drag_aiki_power      =-1
integer :: id_form_drag_aiki_coeff      =-1

integer :: id_visc_cbu_form_drag_u    =-1
integer :: id_visc_cbu_form_drag_v    =-1
integer :: id_form_drag_velocity_u    =-1
integer :: id_form_drag_velocity_v    =-1
integer :: id_form_drag_velocity_fu   =-1
integer :: id_form_drag_velocity_fv   =-1
integer :: id_N_squared               =-1
integer :: id_f2overN2                =-1
integer :: id_f2overNb2               =-1
integer :: id_ksurf_blayer_form_drag  =-1
integer :: id_surface_blayer_form_drag=-1


character(len=128) :: version=&
       '$Id: ocean_form_drag.F90,v 20.0 2013/12/14 00:16:34 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk 

real :: onepcprime_aiki2_r
real :: cprime_aiki2

! nml for Aiki form drag scheme 
logical :: use_form_drag_aiki            =.false.
logical :: form_drag_aiki_bottom_layer   =.false.
logical :: form_drag_aiki_scale_by_gradH =.false.
real    :: form_drag_aiki_gradH_max      = 0.05 
real    :: form_drag_aiki_gradH_power    = 1.0
integer :: form_drag_aiki_bottom_klevels = 3
real    :: cprime_aiki                   = 0.3

! nml for Gbatch form drag scheme 
logical :: use_form_drag_gbatch        =.false.
logical :: form_drag_gbatch_surf_layer =.false.
logical :: form_drag_gbatch_alpha_f2   =.false.
logical :: form_drag_gbatch_f2overN2   =.false.
logical :: form_drag_gbatch_f2overNb2  =.false.
logical :: form_drag_gbatch_f2overNo2  =.false.
logical :: form_drag_gbatch_smooth_N2  =.false.
logical :: form_drag_aiki_scale_by_gm  =.false.

integer :: num_121_passes   = 1 
integer :: ksurf_blayer_min = 3

real    :: form_drag_gbatch_alpha     = 3e8  
real    :: form_drag_gbatch_No        = 5e-3
real    :: visc_cbu_form_drag_max     = 1.0
real    :: vel_form_drag_max          = 1.0
real    :: N_squared_min              = 1e-10
real    :: agm_form_drag              = 600.0
real    :: agm_r                      = 0.0016666667

logical :: verbose_init                  = .true.
logical :: use_this_module               = .false.
logical :: debug_this_module             = .false.
logical :: module_is_initialized         = .FALSE.

namelist /ocean_form_drag_nml/ verbose_init, use_this_module, debug_this_module,   &
                  use_form_drag_aiki, cprime_aiki, form_drag_aiki_bottom_layer,    & 
                  form_drag_aiki_bottom_klevels, form_drag_aiki_scale_by_gradH,    &
                  form_drag_aiki_gradH_max, form_drag_aiki_gradH_power,            &
                  form_drag_aiki_scale_by_gm,                                      &
                  use_form_drag_gbatch, visc_cbu_form_drag_max, vel_form_drag_max, &
                  N_squared_min, agm_form_drag,                                    &
                  form_drag_gbatch_surf_layer, ksurf_blayer_min,                   &
                  form_drag_gbatch_alpha_f2, form_drag_gbatch_alpha,               &
                  form_drag_gbatch_f2overN2, form_drag_gbatch_f2overNb2,           &
                  form_drag_gbatch_smooth_N2, num_121_passes,                      &
                  form_drag_gbatch_f2overNo2, form_drag_gbatch_No

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_form_drag_init">
!
! <DESCRIPTION>
! Initial set up for parameterized pressure form drag.
! </DESCRIPTION>
!
subroutine ocean_form_drag_init(Grid, Domain, Time, Time_steps, Ocean_options, debug)

  type(ocean_grid_type),       intent(in), target   :: Grid
  type(ocean_domain_type),     intent(in), target   :: Domain
  type(ocean_time_type),       intent(in)           :: Time
  type(ocean_time_steps_type), intent(in)           :: Time_steps
  type(ocean_options_type),    intent(inout)        :: Ocean_options
  logical,                     intent(in), optional :: debug

  integer :: io_status, ioun, ierr
  integer :: i,j
  integer :: num_visc_schemes 

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if (module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_form_drag_mod (ocean_form_drag_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  nk = Grid%nk

  Dom => Domain
  Grd => Grid

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_form_drag_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_form_drag_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_form_drag_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_form_drag_nml')
  call close_file (ioun)
#endif
  write (stdlogunit,ocean_form_drag_nml)
  write (stdoutunit,'(/)') 
  write (stdoutunit,ocean_form_drag_nml)

  ! this array needs allocation even if not using module 
  allocate (agm_diffusivity(isd:ied,jsd:jed,nk))
  agm_diffusivity=0.0


  if(use_this_module) then 
      if(use_form_drag_gbatch .and. use_form_drag_aiki) then 
         Ocean_options%form_drag = 'Used form drag from BOTH Gbatch and Aiki: experimental, so beware.'
         write(stdoutunit,'(a)') &
          '==>Note: ocean_form_drag_mod using BOTH Gbatch and Aiki schemes: experimental, so beware!'  
         write(stdoutunit,'(a)') &
         '==>Note: May choose to set "use_gm_skew=.false." in ocean_neutral_physics to avoid double counting.'
      endif 
      if(use_form_drag_gbatch .and. .not. use_form_drag_aiki) then 
         Ocean_options%form_drag = 'Used form drag from Greatbatch: experimental, so beware.'
         write(stdoutunit,'(a)')  &
         '==>Note: ocean_form_drag_mod using Greatbatch scheme: experimental, so beware'  
         write(stdoutunit,'(a)') &
         '==>Note: May choose to set "use_gm_skew=.false." in ocean_neutral_physics to avoid double counting.'
      endif 
      if(.not. use_form_drag_gbatch .and. use_form_drag_aiki) then 
         Ocean_options%form_drag = 'Used form drag from Aiki etal: experimental, so beware.'
         write(stdoutunit,'(a)')  &
         '==>Note: ocean_form_drag_mod using Aiki scheme: experimental, so beware'  
         write(stdoutunit,'(a)') &
         '==>Note: May choose to set "use_gm_skew=.false." in ocean_neutral_physics to avoid double counting.'
      endif 
      if(.not. use_form_drag_gbatch .and. .not. use_form_drag_aiki) then 
         write(stdoutunit,'(a)')  &
         '==>Note: ocean_form_drag_mod: use_this_module=.true. but use_form_drag_gbatch=.false. &use_form_drag_aiki=.false.'  
         Ocean_options%form_drag = 'Did NOT use parameterized form drag.'
      endif 
  else 
      call mpp_error(NOTE, '==>Note from ocean_form_drag_mod: NOT USING this module')
      Ocean_options%form_drag = 'Did NOT use parameterized form drag.'
      return
  endif

  if (PRESENT(debug) .and. .not. debug_this_module) then
      debug_this_module = debug
  endif 
  if(debug_this_module) then 
     write(stdoutunit,'(a)') '==>Note: running ocean_form_drag_mod with debug_this_module=.true.'  
  endif 

  if(Time_steps%aidif /= 1.0) then 
      call mpp_error(FATAL, &
        '==>Error from ocean_form_drag_mod: aidif=1.0 required to handle form drag implicitly.')
  endif


  if(use_form_drag_gbatch) then 
      num_visc_schemes = 0

      if(form_drag_gbatch_alpha_f2) then 
          write(stdoutunit,'(1x,a)')    &
           '==> Note from ocean_form_drag_mod: Vertical viscosity for TEM method is set to constant*f^2'
          num_visc_schemes = 1 + num_visc_schemes
      endif
      if(form_drag_gbatch_f2overN2) then 
          write(stdoutunit,'(1x,a)')    &
           '==> Note from ocean_form_drag_mod: Vertical viscosity for TEM method is set to kappa*(f/N)^2'
          num_visc_schemes = 1 + num_visc_schemes
      endif
      if(form_drag_gbatch_f2overNb2) then 
          write(stdoutunit,'(1x,a)')    &
           '==> Note from ocean_form_drag_mod: Vertical viscosity for TEM method is set to kappa*(f/Nb)^2'
          num_visc_schemes = 1 + num_visc_schemes
      endif
      if(form_drag_gbatch_f2overNo2) then 
          write(stdoutunit,'(1x,a)')    &
           '==> Note from ocean_form_drag_mod: Vertical viscosity for TEM method is set to kappa*(f/No)^2'
          num_visc_schemes = 1 + num_visc_schemes
      endif

      if (num_visc_schemes == 0) then 
          call mpp_error(WARNING, &
           '==>Warning from ocean_form_drag_init: no method chosen for vertical viscosity. Gbatch form drag will do nothing.')
      endif
      if (num_visc_schemes > 1) then 
          call mpp_error(FATAL, &
           '==>Error from ocean_form_drag_init: can choose just one method to compute vertical viscosity')
      endif

      if(form_drag_gbatch_surf_layer) then 
          write(stdoutunit,'(1x,a)')    &
           '==> Note from ocean_form_drag_mod: Vertical viscosity for TEM method modified in surf turb layer'
      endif

  endif

  ! commonly used constants for Aiki scheme 
  onepcprime_aiki2_r = 1.0/(1.0 + cprime_aiki*cprime_aiki)
  cprime_aiki2       = cprime_aiki*cprime_aiki

  ! squared buoyancy frequency 
  allocate (N_squared(isd:ied,jsd:jed,nk))
  N_squared = 0.0

  ! scaling proportional to bottom topog gradient 
  allocate (gradH_scale(isd:ied,jsd:jed))
  gradH_scale(:,:) = 1.0
  if(form_drag_aiki_scale_by_gradH) then 
      do j=jsd,jed
         do i=isd,ied
            gradH_scale(i,j) = &
            (Grd%gradH(i,j)/(epsln+form_drag_aiki_gradH_max))**form_drag_aiki_gradH_power
            gradH_scale(i,j) = min(gradH_scale(i,j),1.0) 
         enddo
      enddo
  endif


  ! Aiki related diagnostics 
  id_form_drag_aiki_gradH_scale = register_static_field ('ocean_model', 'form_drag_aiki_gradH_scale', &
                   Grd%vel_axes_uv(1:2), 'Topography scaling for Aiki form drag', 'dimensionless',    &
                    missing_value=missing_value, range=(/-1e6,1e6/))
  call diagnose_2d_u(Time, Grd, id_form_drag_aiki_gradH_scale, gradH_scale(:,:))

  id_form_drag_aiki_u = register_diag_field ('ocean_model', 'form_drag_aiki_u', &
                   Grd%vel_axes_u(1:3), Time%model_time,                        &
                   'Aiki i-component form stress', 'N/m2',                      &
                    missing_value=missing_value, range=(/-1e6,1e6/))

  id_form_drag_aiki_v = register_diag_field ('ocean_model', 'form_drag_aiki_v', &
                   Grd%vel_axes_v(1:3), Time%model_time,                        &
                   'Aiki j-component form stress', 'N/m2',                      &
                   missing_value=missing_value, range=(/-1e6,1e6/))

  id_form_drag_aiki_power = register_diag_field ('ocean_model', 'form_drag_aiki_power', &
                       Grd%vel_axes_uv(1:3), Time%model_time,                           &
                       'Power sink from Aiki form drag', 'Watt',                        &
                       missing_value=missing_value, range=(/-1e16,1e16/))

  id_form_drag_aiki_coeff= register_diag_field ('ocean_model', 'form_drag_aiki_coeff', &
                           Grd%vel_axes_wu(1:3), Time%model_time,                      &
                           'dimensionless form scaling coefficient for Aiki scheme',   &
                           'dimensionless', missing_value=missing_value, range=(/-10.0,1e6/))


  ! Greatbatch related diagnostics 
  id_N_squared = register_diag_field ('ocean_model', 'N_sqrd_gbatch', Grd%vel_axes_wu(1:3), &
               Time%model_time, 'N^2 on T-cell bottom for Gbatch form drag', 'sec^-2',      &
               missing_value=missing_value, range=(/-1.e2,1e8/))

  id_f2overN2 = register_diag_field ('ocean_model', 'f2overN2', Grd%vel_axes_wu(1:3), &
               Time%model_time, '(f/N)**2 on U-cell bottom', 'dimensionless',         &
               missing_value=missing_value, range=(/-1.0,1e6/))

  id_f2overNb2= register_diag_field ('ocean_model', 'f2overNb2', Grd%vel_axes_wu(1:2),    &
               Time%model_time, '(f/N)**2 on U-cell at base of surf mixed layer', 'sec^2',&
               missing_value=missing_value, range=(/-1.0,1e6/))

  id_visc_cbu_form_drag_u= register_diag_field ('ocean_model', 'visc_cbu_form_drag_u', &
                 Grd%vel_axes_u(1:3), Time%model_time,                                 &
                 'vertical viscosity from form drag on u-velocity component', 'm^2/s', &
                 missing_value=missing_value, range=(/-10.0,1e6/),                     &
                 standard_name='ocean_vertical_momentum_diffusivity_due_to_form_drag')

  id_visc_cbu_form_drag_v= register_diag_field ('ocean_model', 'visc_cbu_form_drag_v', &
                 Grd%vel_axes_v(1:3), Time%model_time,                                 &
                 'vertical viscosity from form drag on v-velocity component', 'm^2/s', &
                 missing_value=missing_value, range=(/-10.0,1e6/))

  id_form_drag_velocity_u= register_diag_field ('ocean_model', 'form_drag_velocity_u', &
                 Grd%vel_axes_u(1:3), Time%model_time,                                 &
                 'eddy induced i-velocity from Gbatch form drag', 'm/s',               &
                 missing_value=missing_value, range=(/-10.0,10.0/))

  id_form_drag_velocity_v= register_diag_field ('ocean_model', 'form_drag_velocity_v', &
                 Grd%vel_axes_v(1:3), Time%model_time,                                 &
                 'eddy induced j-velocity from Gbatch form drag', 'm/s',               &
                 missing_value=missing_value, range=(/-10.0,10.0/))

  id_form_drag_velocity_fu= register_diag_field ('ocean_model', 'form_drag_velocity_fu', &
                 Grd%vel_axes_uv(1:3), Time%model_time,                                  &
                 'f * eddy induced i-velocity from Gbatch form drag', 'm/s',             &
                 missing_value=missing_value, range=(/-10.0,10.0/))

  id_form_drag_velocity_fv= register_diag_field ('ocean_model', 'form_drag_velocity_fv', &
                 Grd%vel_axes_uv(1:3), Time%model_time,                                  &
                 'f * eddy induced j-velocity from Gbatch form drag', 'm/s',             &
                 missing_value=missing_value, range=(/-10.0,10.0/))

  id_ksurf_blayer_form_drag= register_diag_field ('ocean_model', 'ksurf_blayer_form_drag', &
                 Grd%vel_axes_uv(1:2), Time%model_time,                                    &
                 'k-index at the base of the boundary layer for GBatch form drag',         &
                 'unitless', missing_value=missing_value, range=(/-10.0,1e10/))

  id_surface_blayer_form_drag= register_diag_field ('ocean_model', 'surface_blayer_form_drag', &
                 Grd%vel_axes_uv(1:2), Time%model_time,                                        &
                 'U-cell depth of surface boundary layer used in Gbatch form drag',            &
                 'm', missing_value=missing_value, range=(/-10.0,1e10/))


end subroutine ocean_form_drag_init
! </SUBROUTINE> NAME="ocean_form_drag_init"



!#######################################################################
! <SUBROUTINE NAME="compute_visc_form_drag">
! <DESCRIPTION>
! Compute vertical viscosity arising from parameterized 
! form drag according to the methods from the Greatbatch TEM approach.
! 
! Follow the method of Ferreira and Marshall (2006) 
! for transitioning through the diabatic surface mixed layer. 
! We take the surf_blthick from mixed layer schemes (e.g., KPP), and use 
! this to define the region where the eddy induced velocity has 
! zero vertical shear.  Note that we do not introduce an additional
! transitional layer.  
!
! There are four methods to compute the vertical viscosity within
! the interior, with one required to be chosen:
! 1/ form_drag_gbatch_f2overN2
!    visc = kappa*(f/N)^2, with kappa=gm-diffusivity
! 2/ form_drag_gbatch_f2overNb2
!    visc = kappa*(f/Nb)^2, with Nb=buoyancy freq just below surface mixed layer
! 3/ form_drag_gbatch_f2overNo2
!    visc = kappa*(f/No)^2, with No=constant buoyancy freq 
! 4/ form_drag_gbatch_alpha_f2
!    visc = alpha*f^2, with alpha = constant (units of m^2*sec)
!
! </DESCRIPTION>
!
!
subroutine compute_visc_form_drag(Time, Thickness, Velocity, Dens, &
                                  gm_diffusivity, surface_blt, visc_cbu_form_drag)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_velocity_type),      intent(in)    :: Velocity
  type(ocean_density_type),       intent(in)    :: Dens
  real, dimension(isd:,jsd:,:),   intent(in)    :: gm_diffusivity 
  real, dimension(isd:,jsd:),     intent(in)    :: surface_blt
  real, dimension(isd:,jsd:,:,:), intent(inout) :: visc_cbu_form_drag

  integer :: i,j,k,kb,m,n,tau,kbot
  integer :: ksurf_blayer(isd:ied,jsd:jed)
  real    :: surface_blayerT(isd:ied,jsd:jed)
  real    :: surface_blayerU(isd:ied,jsd:jed)
  real    :: N_squaredU, sign_switch
  real    :: tmp,N2_prev, No_r
  logical :: below_surf_blayer

  if(.not. use_this_module .or. .not. use_form_drag_gbatch) then
    visc_cbu_form_drag(:,:,:,:) = 0.0
    agm_diffusivity(:,:,:)      = gm_diffusivity(:,:,:)
    return
  endif 

  tau = Time%tau

  wrk1(:,:,:)                 = 0.0
  wrk2(:,:,:)                 = 0.0
  wrk3_v(:,:,:,:)             = 0.0
  visc_cbu_form_drag(:,:,:,:) = 0.0
  No_r                        = 1.0/(epsln+form_drag_gbatch_No)
  agm_diffusivity(:,:,:)      = gm_diffusivity(:,:,:)

  ! compute N^2 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           N_squared(i,j,k) = -grav*rho0r*Dens%drhodz_zt(i,j,k)
        enddo
     enddo
  enddo
  if(form_drag_gbatch_smooth_N2) then
      do m=1,num_121_passes
         do j=jsd,jed
            do i=isd,ied
               N2_prev = onefourth*N_squared(i,j,1)
               kbot=Grd%kmt(i,j)
               if(kbot>1) then
                   do k=2,kbot-2
                      tmp = N_squared(i,j,k)
                      N_squared(i,j,k) = N2_prev + onehalf*N_squared(i,j,k) &
                                        + onefourth*N_squared(i,j,k+1)
                      N2_prev = onefourth*tmp
                   enddo
               endif
            enddo
         enddo
      enddo
  endif

  ! squared buoyancy frequency on U-cell
  do k=1,nk-1
     do j=jsc,jec
        do i=isc,iec
           if(Grd%umask(i,j,k) > 0.0) then 
               N_squaredU  = onefourth*(N_squared(i,j,k)   + N_squared(i+1,j,k)  &
                                      + N_squared(i,j+1,k) + N_squared(i+1,j+1,k))
               wrk2(i,j,k) = abs(N_squaredU) 
               wrk1(i,j,k) = Grd%f(i,j)**2/(wrk2(i,j,k) + N_squared_min)
           endif
        enddo
     enddo
  enddo


  ! viscosity from Greatbatch and Lamb (1990) 
  if(form_drag_gbatch_f2overN2) then
      do k=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               if(Grd%umask(i,j,k) > 0.0) then 
                   wrk3_v(i,j,k,1) = Grd%umask(i,j,k+1) &
                        *min(visc_cbu_form_drag_max,wrk1(i,j,k)*agm_diffusivity(i,j,k))
                   wrk3_v(i,j,k,2) = wrk3_v(i,j,k,1)
                   visc_cbu_form_drag(i,j,k,1) = wrk3_v(i,j,k,1) 
                   visc_cbu_form_drag(i,j,k,2) = wrk3_v(i,j,k,2) 
               endif
            enddo
         enddo
      enddo
  endif

  ! viscosity from Greatbatch and Lamb (1990) with constant N 
  if(form_drag_gbatch_f2overNo2) then
      do k=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               if(Grd%umask(i,j,k) > 0.0) then 
                   wrk3_v(i,j,k,1) = Grd%umask(i,j,k+1) &
                    *min(visc_cbu_form_drag_max,agm_diffusivity(i,j,k)*(No_r*Grd%f(i,j))**2)
                   wrk3_v(i,j,k,2) = wrk3_v(i,j,k,1)
                   visc_cbu_form_drag(i,j,k,1) = wrk3_v(i,j,k,1) 
                   visc_cbu_form_drag(i,j,k,2) = wrk3_v(i,j,k,2) 
               endif
            enddo
         enddo
      enddo
  endif

  ! viscosity from Ferreira and Marshall (2006)
  if(form_drag_gbatch_alpha_f2) then 
      do k=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               if(Grd%umask(i,j,k) > 0.0) then 
                   visc_cbu_form_drag(i,j,k,1) = form_drag_gbatch_alpha*Grd%f(i,j)**2
                   visc_cbu_form_drag(i,j,k,2) = form_drag_gbatch_alpha*Grd%f(i,j)**2
               endif
            enddo
         enddo
      enddo
  endif

  ! determine some properties of the surface diabatic layer 
  if(form_drag_gbatch_surf_layer .or. form_drag_gbatch_f2overNb2) then

      ksurf_blayer(:,:)    = 1
      surface_blayerT(:,:) = 0.0
      surface_blayerU(:,:) = 0.0
      wrk4_2d(:,:)         = 0.0

      ! compute boundary layer depth on U-cell 
      do j=jsc,jec
         do i=isc,iec
            surface_blayerT(i,j) = surface_blt(i,j)
         enddo
      enddo
      call mpp_update_domains (surface_blayerT(:,:), Dom%domain2d)
      surface_blayerU(:,:) = 0.0
      do j=jsc,jec
         do i=isc,iec
            surface_blayerU(i,j) = onefourth*Grd%umask(i,j,k)      &
                 *(surface_blayerT(i,j)  +surface_blayerT(i+1,j)   &
                  +surface_blayerT(i,j+1)+surface_blayerT(i+1,j+1))
         enddo
      enddo

      ! compute k-level at or just below surface boundary layer. 
      ! initialize ksurf_blayer to 1 rather than 0, to avoid 
      ! accessing the zeroth element of an array.   
      wrk3_2d(:,:) = 0.0
      do j=jsc,jec
         do i=isc,iec

            kb               = Grd%kmt(i,j)
            below_surf_blayer= .false.
            ksurf_blayer(i,j)= ksurf_blayer_min
            ksurf_blayer_loop: do k=ksurf_blayer_min,kb-1
               if(Thickness%depth_zwu(i,j,k) >= surface_blayerU(i,j) &
                  .and. .not. below_surf_blayer) then 
                   ksurf_blayer(i,j) = k
                   below_surf_blayer = .true. 
                   exit ksurf_blayer_loop
               endif
            enddo ksurf_blayer_loop

            ! for cases where blayer reaches to the bottom.
            ! need to give ksurf_blayer one above the bottom so 
            ! to be able to compute a nonzero vertical shear. 
            if(.not. below_surf_blayer) then
                ksurf_blayer(i,j) = max(kb-1,ksurf_blayer_min)
            endif

            ! need a real field to send to diagnostic manager
            wrk3_2d(i,j) = float(ksurf_blayer(i,j))

            ! for the form_drag_gbatch_f2overNb2 scheme, save 
            ! (f/Nb)**2, where Nb=buoyancy frequency one level beneath 
            ! diabatic mixed layer. 
            k = min(nk,1+ksurf_blayer(i,j))
            wrk4_2d(i,j) = Grd%f(i,j)**2/(wrk2(i,j,k) + N_squared_min)

         enddo
      enddo

  endif

  ! viscosity from Danabasoglu and Marshall (2007)
  if(form_drag_gbatch_f2overNb2) then
      do k=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               if(Grd%umask(i,j,k) > 0.0) then 
                   wrk3_v(i,j,k,1) = Grd%umask(i,j,k+1) &
                        *min(visc_cbu_form_drag_max,wrk4_2d(i,j)*agm_diffusivity(i,j,k))
                   wrk3_v(i,j,k,2) = wrk3_v(i,j,k,1)
                   visc_cbu_form_drag(i,j,k,1) = wrk3_v(i,j,k,1) 
                   visc_cbu_form_drag(i,j,k,2) = wrk3_v(i,j,k,2) 
               endif
            enddo
         enddo
      enddo
  endif 


  ! modify viscosity in surface boundary layer 
  if(form_drag_gbatch_surf_layer) then

      do n=1,2
         do j=jsc,jec
            do i=isc,iec

               ! compute vertical shear at blayer base
               k               = ksurf_blayer(i,j)
               wrk1_v2d(i,j,n) = Grd%umask(i,j,k+1) &
                    *(Velocity%u(i,j,k,n,tau)-Velocity%u(i,j,k+1,n,tau))/Thickness%dzwu(i,j,k) 

               ! modify the vertical viscosity inside blayer.
               ! use linear tapering function, going to zero as approach ocean top.  
               do k=1,ksurf_blayer(i,j)
                  if(surface_blayerU(i,j) > 0.0) then 
                      wrk3_v(i,j,k,n) = wrk3_v(i,j,ksurf_blayer(i,j),n)                       &
                           *(Thickness%depth_zwu(i,j,k)/surface_blayerU(i,j))*wrk1_v2d(i,j,n) &
                           *Thickness%dzwu(i,j,k)/(Velocity%u(i,j,k,n,tau)-Velocity%u(i,j,k+1,n,tau)+epsln)
                      wrk3_v(i,j,k,n) = Grd%umask(i,j,k+1)*min(visc_cbu_form_drag_max,abs(wrk3_v(i,j,k,n)))
                      visc_cbu_form_drag(i,j,k,n) = wrk3_v(i,j,k,n)
                  endif
               enddo

            enddo
         enddo
      enddo

  endif

  ! send some diagnostics 
  call diagnose_3d_u(Time, Grd, id_N_squared, N_squared(:,:,:))
  call diagnose_2d_u(Time, Grd, id_ksurf_blayer_form_drag, wrk3_2d(:,:))
  call diagnose_2d_u(Time, Grd, id_surface_blayer_form_drag, surface_blayerU(:,:))
  call diagnose_3d_u(Time, Grd, id_f2overN2, wrk1(:,:,:))
  call diagnose_2d_u(Time, Grd, id_f2overNb2, wrk4_2d(:,:))
  call diagnose_3d_u(Time, Grd, id_visc_cbu_form_drag_u, visc_cbu_form_drag(:,:,:,1))
  call diagnose_3d_u(Time, Grd, id_visc_cbu_form_drag_v, visc_cbu_form_drag(:,:,:,2))

  ! diagnose the eddy induced velocity 
  if(id_form_drag_velocity_u  > 0 .or. id_form_drag_velocity_v  > 0 .or. &
     id_form_drag_velocity_fu > 0 .or. id_form_drag_velocity_fv > 0) then 

      wrk1_v(:,:,:,:) = 0.0
      wrk2_v(:,:,:,:) = 0.0
      wrk1_2d(:,:)    = 0.0
      wrk2_2d(:,:)    = 0.0

      do n=1,2

         sign_switch = (-1.0)**(n-1) 

         do j=jsc,jec
            do i=isc,iec
               wrk1_2d(i,j) = 0.0
            enddo
         enddo

         do k=1,nk-1
            do j=jsc,jec
               do i=isc,iec
                  wrk2_2d(i,j) =  Grd%umask(i,j,k+1)*wrk3_v(i,j,k,n)        &
                       *(Velocity%u(i,j,k,n,tau)-Velocity%u(i,j,k+1,n,tau)) &
                       /Thickness%dzwu(i,j,k)
                  wrk2_v(i,j,k,n) = sign_switch*Grd%umask(i,j,k)*(wrk1_2d(i,j)-wrk2_2d(i,j)) &
                       /Thickness%dzu(i,j,k)
                  wrk1_v(i,j,k,n) = wrk2_v(i,j,k,n)/(Grd%f(i,j)+epsln)
                  wrk1_2d(i,j)    = wrk2_2d(i,j)
               enddo
            enddo
         enddo
         do j=jsc,jec
            do i=isc,iec
               wrk2_v(i,j,nk,n) = sign_switch*Grd%umask(i,j,nk)*wrk1_2d(i,j) &
                    /Thickness%dzu(i,j,k)
               wrk1_v(i,j,nk,n) = wrk2_v(i,j,nk,n)/(Grd%f(i,j)+epsln)
            enddo
         enddo
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  if(abs(wrk1_v(i,j,k,n)) > vel_form_drag_max) then 
                      wrk1_v(i,j,k,n) = vel_form_drag_max*sign(1.0,wrk1_v(i,j,k,n))
                  endif
               enddo
            enddo
         enddo

      enddo
      
      call diagnose_3d_u(Time, Grd, id_form_drag_velocity_fu, wrk2_v(:,:,:,1))
      call diagnose_3d_u(Time, Grd, id_form_drag_velocity_fv, wrk2_v(:,:,:,2))
      call diagnose_3d_u(Time, Grd, id_form_drag_velocity_u, wrk1_v(:,:,:,1))
      call diagnose_3d_u(Time, Grd, id_form_drag_velocity_v, wrk1_v(:,:,:,2))

  endif


end subroutine compute_visc_form_drag
! </SUBROUTINE> NAME="compute_visc_form_drag"



!#######################################################################
! <SUBROUTINE NAME="form_drag_accel">
!
! <DESCRIPTION>
!  Compute the rho*dz weighted acceleration from the Aiki etal 
!  form drag scheme.   
! </DESCRIPTION>
!
subroutine form_drag_accel(Time, Thickness, Velocity, energy_analysis_step)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(in)    :: Thickness
  type(ocean_velocity_type),  intent(inout) :: Velocity
  logical,                    intent(in)    :: energy_analysis_step 

  integer :: i,j,k,n
  integer :: tau, taum1
  integer :: kmu
  real    :: agm_ucell, agm_max, agm_max_r

  if(.not. use_this_module .or. .not. use_form_drag_aiki) then
      if(energy_analysis_step) then 
          do n=1,2
             do k=1,nk
                do j=jsc,jec
                   do i=isc,iec
                      Velocity%wrkv(i,j,k,n) = 0.0
                   enddo
                enddo
             enddo
          enddo
      endif
    return 
  endif 


  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_form_drag_mod (form_drag_accel): module needs to be initialized')
  endif 

  taum1 = Time%taum1
  tau   = Time%tau
  wrk1  = 1.0

  ! Compute a dimensionless scale function proportional to GM-diffusivity
  if(form_drag_aiki_scale_by_gm) then 
      agm_max   = mpp_global_max(Dom%domain2d, agm_diffusivity(:,:,1))
      if(agm_max > 0.0) then  
          agm_max_r = 1.0/agm_max
          do k=1,nk
             do j=jsc,jec
                do i=isc,iec
                   agm_ucell = onefourth*Grd%umask(i,j,k)                   &
                        *(agm_diffusivity(i,j,k)  +agm_diffusivity(i+1,j,k) &
                         +agm_diffusivity(i,j+1,k)+agm_diffusivity(i+1,j+1,k))
                   wrk1(i,j,k) = agm_ucell*agm_r
                enddo
             enddo
          enddo
      endif
  endif

  wrk1_2d(:,:)    = 0.0
  wrk2_2d(:,:)    = 0.0
  wrk1_v2d(:,:,:) = 0.0
  wrk2_v2d(:,:,:) = 0.0
  wrk1_v(:,:,:,:) = 0.0

  ! pre-calculate some 2d coefficients and the inverse mass per area of a column 
  do j=jsc,jec
     do i=isc,iec
        wrk1_v2d(i,j,1) = abs(Grd%f(i,j))*cprime_aiki*onepcprime_aiki2_r
        wrk1_v2d(i,j,2) = Grd%f(i,j)*cprime_aiki2*onepcprime_aiki2_r
        if(Grd%umask(i,j,1) > 0.0) then 
          wrk1_2d(i,j) = 1.0/Thickness%mass_u(i,j,tau)
        endif 
     enddo
  enddo

  ! vertical integral of equation (11) in Aiki etal paper. 
  ! NOTE: wrk1 is a dimensionless coefficient which 
  ! scales the drag according to GM-diffusivity (from ocean_nphysics_mod)
  ! or slope of the topography (default)
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           kmu = Grd%kmu(i,j)
           if(k <= kmu) then  
               wrk1_v(i,j,k,1) = -wrk1_v2d(i,j,1)*(Velocity%u(i,j,k,1,tau)-Velocity%u(i,j,kmu,1,tau)) &
                                 -wrk1_v2d(i,j,2)*(Velocity%u(i,j,k,2,tau)-Velocity%u(i,j,kmu,2,tau)) 
               wrk1_v(i,j,k,2) = -wrk1_v2d(i,j,1)*(Velocity%u(i,j,k,2,tau)-Velocity%u(i,j,kmu,2,tau)) &
                                 +wrk1_v2d(i,j,2)*(Velocity%u(i,j,k,1,tau)-Velocity%u(i,j,kmu,1,tau)) 
               wrk1_v(i,j,k,1) =  wrk1_v(i,j,k,1)*wrk1(i,j,k)*gradH_scale(i,j)
               wrk1_v(i,j,k,2) =  wrk1_v(i,j,k,2)*wrk1(i,j,k)*gradH_scale(i,j)
           endif
        enddo
     enddo
  enddo

  if(form_drag_aiki_bottom_layer) then 

      ! zero those levels not used 
      do j=jsc,jec
         do i=isc,iec
            do k=1,Grd%kmu(i,j)-(form_drag_aiki_bottom_klevels-1)
               wrk1_v(i,j,k,1) = 0.0
               wrk1_v(i,j,k,2) = 0.0
            enddo
         enddo
      enddo

      ! mass per area in the retained levels 
      wrk1_2d(:,:) = 0.0 
      do j=jsc,jec
         do i=isc,iec
            do k=(Grd%kmu(i,j)-form_drag_aiki_bottom_klevels),Grd%kmu(i,j)
               wrk1_2d(i,j) = wrk1_2d(i,j) + Thickness%rho_dzu(i,j,k,tau)  
            enddo
         enddo
      enddo

      do j=jsc,jec
         do i=isc,iec
            if(wrk1_2d(i,j) > 0.0) then 
                wrk1_2d(i,j) = 1.0/wrk1_2d(i,j)
            endif
         enddo
      enddo

  endif


  do n=1,2
     
     ! vertical integral 
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              wrk2_v2d(i,j,n) = wrk2_v2d(i,j,n) + Thickness%rho_dzu(i,j,k,tau)*wrk1_v(i,j,k,n) 
           enddo
        enddo
     enddo

     ! divide by mass per area of the column 
     do j=jsc,jec
        do i=isc,iec
           wrk2_v2d(i,j,n) = wrk2_v2d(i,j,n)*wrk1_2d(i,j)
        enddo
     enddo

  enddo


  ! ensure SGS form drag has zero vertical integral  
  if(form_drag_aiki_bottom_layer) then 

      ! compute form drag which has zero vertical integral over retained levels 
      do n=1,2
         do j=jsc,jec
            do i=isc,iec
               do k=(Grd%kmu(i,j)-form_drag_aiki_bottom_klevels),Grd%kmu(i,j)
                  wrk1_v(i,j,k,n) = Thickness%rho_dzu(i,j,k,tau)*(wrk1_v(i,j,k,n) - wrk2_v2d(i,j,n))
               enddo
            enddo
         enddo
      enddo

  else 

      ! compute form drag which has zero vertical integral over full column
      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  wrk1_v(i,j,k,n) = Thickness%rho_dzu(i,j,k,tau)*(wrk1_v(i,j,k,n) - wrk2_v2d(i,j,n))
               enddo
            enddo
         enddo
      enddo

  endif

  ! energetic analysis 
  if(energy_analysis_step) then 
      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%wrkv(i,j,k,n) = wrk1_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo

  ! add to acceleration 
  else 
      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%accel(i,j,k,n) = Velocity%accel(i,j,k,n) + wrk1_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo

      call diagnose_3d_u(Time, Grd, id_form_drag_aiki_u, wrk1_v(isc:iec,jsc:jec,:,1))
      call diagnose_3d_u(Time, Grd, id_form_drag_aiki_v, wrk1_v(isc:iec,jsc:jec,:,2))
      if (id_form_drag_aiki_power > 0) then 
          wrk2(:,:,:) = 0.0
          do n=1,2
             do k=1,nk
                do j=jsc,jec
                   do i=isc,iec
                      wrk2(i,j,k) = wrk2(i,j,k) + Velocity%u(i,j,k,n,tau)*wrk1_v(i,j,k,n)*Grd%dau(i,j)
                   enddo
                enddo
             enddo
          enddo
          call diagnose_3d_u(Time, Grd, id_form_drag_aiki_power, wrk2(isc:iec,jsc:jec,:))
      endif

      if (id_form_drag_aiki_coeff > 0) then
          do k=1,nk
             do j=jsc,jec
                do i=isc,iec
                   wrk2(i,j,k) = wrk1(i,j,k)*gradH_scale(i,j)
                enddo
             enddo
          enddo
          call diagnose_3d_u(Time, Grd, id_form_drag_aiki_coeff, wrk2(:,:,:))
      endif


  endif  ! endif for energy_analysis_step


end subroutine form_drag_accel
! </SUBROUTINE> NAME="form_drag_accel"



end module ocean_form_drag_mod
      
      

module constants_mod

! <CONTACT EMAIL="Bruce.Wyman@noaa.gov">
!   Bruce Wyman
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!    Defines useful constants for Earth.
! </OVERVIEW>

! <DESCRIPTION>
!   Constants are defined as real parameters.
!   Constants are accessed through the "use" statement.
! </DESCRIPTION>

implicit none
private

character(len=128) :: version='$Id$'
character(len=128) :: tagname='$Name$'
!dummy variable to use in HUGE initializations
real :: realnumber

!------------ physical constants ---------------
! <DATA NAME="RADIUS" UNITS="m" TYPE="real" DEFAULT="6371.e3">
!   radius of the earth
! </DATA>
! <DATA NAME="OMEGA" UNITS="1/s" TYPE="real" DEFAULT="7.292e-5">
!   rotation rate of the planet (earth)
! </DATA>
! <DATA NAME="GRAV" UNITS="m/s^2" TYPE="real" DEFAULT="9.80">
!   acceleration due to gravity
! </DATA>
! <DATA NAME="RDGAS" UNITS="J/kg/deg" TYPE="real" DEFAULT="287.04">
!   gas constant for dry air
! </DATA>
! <DATA NAME="KAPPA" TYPE="real" DEFAULT="2./7.">
!   RDGAS / CP_AIR
! </DATA>
! <DATA NAME="CP_AIR" UNITS="J/kg/deg" TYPE="real" DEFAULT="RDGAS/KAPPA">
!   specific heat capacity of dry air at constant pressure
! </DATA>
! <DATA NAME="CP_OCEAN" UNITS="J/kg/deg" TYPE="real" DEFAULT="3989.24495292815">
!   specific heat capacity taken from McDougall (2002) "Potential Enthalpy ..."
! </DATA>
! <DATA NAME="RHO0" UNITS="kg/m^3" TYPE="real" DEFAULT="1.035e3">
!   average density of sea water
! </DATA>
! <DATA NAME="RHO0R" UNITS="m^3/kg" TYPE="real" DEFAULT="1.0/RHO0">
!   reciprocal of average density of sea water
! </DATA>
! <DATA NAME="RHO_CP" UNITS="J/m^3/deg" TYPE="real" DEFAULT="RHO0*CP_OCEAN">
!   (kg/m^3)*(cal/kg/deg C)(joules/cal) = (joules/m^3/deg C)
! </DATA>

real, public, parameter :: RADIUS = 6371.0e3   
real, public, parameter :: OMEGA  = 7.292e-5 
real, public, parameter :: GRAV   = 9.80    
real, public, parameter :: RDGAS  = 287.04 
real, public, parameter :: KAPPA  = 2./7.  
real, public, parameter :: CP_AIR = RDGAS/KAPPA 
real, public, parameter :: CP_OCEAN = 3989.24495292815
real, public, parameter :: RHO0    = 1.035e3
real, public, parameter :: RHO0R   = 1.0/RHO0
real, public, parameter :: RHO_CP  = RHO0*CP_OCEAN

!------------ water vapor constants ---------------
! <DATA NAME="ES0" TYPE="real" DEFAULT="1.0">
!   Humidity factor. Controls the humidity content of the atmosphere through 
!   the Saturation Vapour Pressure expression when using DO_SIMPLE.
! </DATA>
! <DATA NAME="RVGAS" UNITS="J/kg/deg" TYPE="real" DEFAULT="461.50">
!   gas constant for water vapor
! </DATA>
! <DATA NAME="CP_VAPOR" UNITS="J/kg/deg" TYPE="real" DEFAULT="4.0*RVGAS">
!   specific heat capacity of water vapor at constant pressure
! </DATA>
! <DATA NAME="DENS_H2O" UNITS="kg/m^3" TYPE="real" DEFAULT="1000.">
!   density of liquid water
! </DATA>
! <DATA NAME="HLV" UNITS="J/kg" TYPE="real" DEFAULT="2.500e6">
!   latent heat of evaporation
! </DATA>
! <DATA NAME="HLF" UNITS="J/kg" TYPE="real" DEFAULT="3.34e5">
!   latent heat of fusion
! </DATA>
! <DATA NAME="HLS" UNITS="J/kg" TYPE="real" DEFAULT="2.834e6">
!   latent heat of sublimation
! </DATA>
! <DATA NAME="TFREEZE" UNITS="degK" TYPE="real" DEFAULT="273.16">
!   temp where fresh water freezes
! </DATA>

real, public, parameter :: ES0 = 1.0 
real, public, parameter :: RVGAS = 461.50 
real, public, parameter :: CP_VAPOR = 4.0*RVGAS
real, public, parameter :: DENS_H2O = 1000. 
real, public, parameter :: HLV = 2.500e6   
real, public, parameter :: HLF = 3.34e5   
real, public, parameter :: HLS = HLV + HLF
real, public, parameter :: TFREEZE = 273.16    

!-------------- radiation constants -----------------

! <DATA NAME="WTMAIR" UNITS="AMU" TYPE="real" DEFAULT="2.896440E+01">
!  molecular weight of air 
! </DATA>
! <DATA NAME="WTMH2O" UNITS="AMU" TYPE="real" DEFAULT="1.801534E+01">
!  molecular weight of water
! </DATA>
! <DATA NAME="WTMOZONE" UNITS="AMU" TYPE="real" DEFAULT="4.799820E+01">
!   molecular weight of ozone
! </DATA>
! <DATA NAME="WTMC" UNITS="AMU" TYPE="real" DEFAULT="1.200000+01">
!   molecular weight of carbon 
! <DATA NAME="WTMCO2" UNITS="AMU" TYPE="real" DEFAULT="4.400995+01">
!   molecular weight of carbon dioxide
! <DATA NAME="WTMO2" UNITS="AMU" TYPE="real" DEFAULT="3.19988+01">
!   molecular weight of molecular oxygen
! <DATA NAME="WTMCFC11" UNITS="AMU" TYPE="real" DEFAULT="1.373681+02">
!   molecular weight of CFC-11 (CCl3F)
! <DATA NAME="WTMCFC12" UNITS="AMU" TYPE="real" DEFAULT="1.209135+02">
!   molecular weight of CFC-21 (CCl2F2)
! </DATA>
! <DATA NAME="DIFFAC" TYPE="real" DEFAULT="1.660000E+00">
! diffusivity factor
! </DATA>
! <DATA NAME="SECONDS_PER_DAY" UNITS="seconds" TYPE="real" DEFAULT="8.640000E+04">
! seconds in a day
! </DATA>
! <DATA NAME="AVOGNO" UNITS="atoms/mole" TYPE="real" DEFAULT="6.023000E+23">
!  Avogadro's number 
! </DATA>
! <DATA NAME="PSTD" UNITS="dynes/cm^2" TYPE="real" DEFAULT="1.013250E+06">
!  mean sea level pressure
! </DATA>
! <DATA NAME="PSTD_MKS" UNITS="Newtons/m^2" TYPE="real" DEFAULT="101325.0">
!  mean sea level pressure
! </DATA>

real, public, parameter :: WTMAIR = 2.896440E+01
real, public, parameter :: WTMH2O = WTMAIR*(RDGAS/RVGAS) !pjp OK to change value because not used yet.
!real, public, parameter :: WTMO3  = 47.99820E+01
real, public, parameter :: WTMOZONE =  47.99820
real, public, parameter :: WTMC     =  12.00000
real, public, parameter :: WTMCO2   =  44.00995
real, public, parameter :: WTMO2    =  31.9988
real, public, parameter :: WTMCFC11 = 137.3681
real, public, parameter :: WTMCFC12 = 120.9135
real, public, parameter :: DIFFAC = 1.660000E+00
real, public, parameter :: SECONDS_PER_DAY  = 8.640000E+04, SECONDS_PER_HOUR = 3600., SECONDS_PER_MINUTE=60.
real, public, parameter :: AVOGNO = 6.023000E+23
real, public, parameter :: PSTD   = 1.013250E+06
real, public, parameter :: PSTD_MKS    = 101325.0
!real, public, parameter :: REARTH  = 6.356766E+08 !pjp Not used anywhere. 

! <DATA NAME="RADCON" UNITS="deg sec/(cm day)" TYPE="real" DEFAULT="((1.0E+02*GRAV)/(1.0E+04*CP_AIR))*SECONDS_PER_DAY">
!  factor used to convert flux divergence to heating rate in degrees per day
! </DATA>
! <DATA NAME="RADCON_MKS" UNITS="deg sec/(m day)" TYPE="real" DEFAULT="(GRAV/CP_AIR)*SECONDS_PER_DAY">
!  factor used to convert flux divergence to heating rate in degrees per day
! </DATA>
! <DATA NAME="O2MIXRAT" TYPE="real" DEFAULT="2.0953E-01">
! mixing ratio of molecular oxygen in air
! </DATA>
! <DATA NAME="RHOAIR" UNITS="kg/m^3" TYPE="real" DEFAULT="1.292269">
!  reference atmospheric density
! </DATA>
! <DATA NAME="ALOGMIN" TYPE="real" DEFAULT="-50.0">
!  minimum value allowed as argument to log function
! </DATA>

real, public, parameter :: RADCON = ((1.0E+02*GRAV)/(1.0E+04*CP_AIR))*SECONDS_PER_DAY
real, public, parameter :: RADCON_MKS  = (GRAV/CP_AIR)*SECONDS_PER_DAY
real, public, parameter :: O2MIXRAT    = 2.0953E-01
real, public, parameter :: RHOAIR      = 1.292269
real, public, parameter :: ALOGMIN     = -50.0

!------------ miscellaneous constants ---------------
! <DATA NAME="STEFAN" UNITS="W/m^2/deg^4" TYPE="real" DEFAULT="5.6734e-8">
!   Stefan-Boltzmann constant
! </DATA>
! <DATA NAME="VONKARM"  TYPE="real" DEFAULT="0.40">
!   Von Karman constant
! </DATA>
! <DATA NAME="PI" TYPE="real" DEFAULT="3.14159265358979323846">
!    ratio of circle circumference to diameter
! </DATA>
! <DATA NAME="RAD_TO_DEG"  TYPE="real" DEFAULT="180.0/PI">
!   degrees per radian
! </DATA>
! <DATA NAME="DEG_TO_RAD"  TYPE="real" DEFAULT="PI/180.0">
!   radians per degree
! </DATA>
! <DATA NAME="RADIAN"  TYPE="real" DEFAULT="180.0/PI">
!   equal to RAD_TO_DEG. Named RADIAN for backward compatability.
! </DATA>
! <DATA NAME="C2DBARS" UNITS="dbars" TYPE="real" DEFAULT="1.e-4">
!   converts rho*g*z (in mks) to dbars: 1dbar = 10^4 (kg/m^3)(m/s^2)m
! </DATA>
! <DATA NAME="KELVIN" TYPE="real" DEFAULT="273.15">
!   degrees Kelvin at zero Celsius
! </DATA>
! <DATA NAME="EPSLN" TYPE="real" DEFAULT="1.0e-40">
!   a small number to prevent divide by zero exceptions
! </DATA>

real, public, parameter :: STEFAN  = 5.6734e-8 
real, public, parameter :: VONKARM = 0.40     
real, public, parameter :: PI      = 3.14159265358979323846
real, public, parameter :: RAD_TO_DEG=180./PI
real, public, parameter :: DEG_TO_RAD=PI/180.
real, public, parameter :: RADIAN  = RAD_TO_DEG
real, public, parameter :: C2DBARS = 1.e-4
real, public, parameter :: KELVIN  = 273.15
real, public, parameter :: EPSLN   = 1.0e-40
!-----------------------------------------------------------------------
! version and tagname published
! so that write_version_number can be called for constants_mod by fms_init
public :: version, tagname
!-----------------------------------------------------------------------
public :: constants_init

contains

subroutine constants_init

! dummy routine.
    !if (mpp_pe() == mpp_root_pe()) then
       write(*,*) version
       write(*,*) tagname
    !end if
end subroutine constants_init

end module constants_mod

! <INFO>

!   <FUTURE>               
!   1.  Renaming of constants.
!   </FUTURE>               
!   <FUTURE>               
!   2.  Additional constants.
!   </FUTURE>
!   <NOTE>
!    Constants have been declared as type REAL, PARAMETER.
!
!    The value a constant can not be changed in a users program.
!    New constants can be defined in terms of values from the
!    constants module using a parameter statement.<br><br>
!
!    The name given to a particular constant may be changed.<br><br>
!
!    Constants can be used on the right side on an assignment statement
!    (their value can not be reassigned). 
!
!
!<TESTPROGRAM NAME="EXAMPLE">
!<PRE>
!    use constants_mod, only:  TFREEZE, grav_new => GRAV
!    real, parameter :: grav_inv = 1.0 / grav_new
!    tempc(:,:,:) = tempk(:,:,:) - TFREEZE
!    geopotential(:,:) = height(:,:) * grav_new
!</PRE>
!</TESTPROGRAM>
!   </NOTE>

! </INFO>

module random_numbers_mod 
  ! Generic module to wrap random number generators. 
  !   The module defines a type that identifies the particular stream of random 
  !   numbers, and has procedures for initializing it and getting real numbers 
  !   in the range 0 to 1. 
  ! This version uses the Mersenne Twister to generate random numbers on [0, 1]. 
  !
  use MersenneTwister_mod, only: randomNumberSequence, & ! The random number engine.
                                 new_RandomNumberSequence, getRandomReal 
  use time_manager_mod, only: time_type, get_date
  implicit none
  private
  
  type randomNumberStream
    type(randomNumberSequence) :: theNumbers
  end type randomNumberStream
  
  interface getRandomNumbers
    module procedure getRandomNumber_Scalar, getRandomNumber_1D, getRandomNumber_2D
  end interface getRandomNumbers
  
  interface initializeRandomNumberStream
    module procedure initializeRandomNumberStream_S, initializeRandomNumberStream_V
  end interface initializeRandomNumberStream

  public :: randomNumberStream,                             &
            initializeRandomNumberStream, getRandomNumbers, &
            constructSeed
contains
  ! ---------------------------------------------------------
  ! Initialization
  ! ---------------------------------------------------------
  function initializeRandomNumberStream_S(seed) result(new) 
    integer, intent( in)     :: seed
    type(randomNumberStream) :: new
    
    new%theNumbers = new_RandomNumberSequence(seed)
    
  end function initializeRandomNumberStream_S
  ! ---------------------------------------------------------
  function initializeRandomNumberStream_V(seed) result(new) 
    integer, dimension(:), intent( in) :: seed
    type(randomNumberStream)           :: new
    
    new%theNumbers = new_RandomNumberSequence(seed)
    
  end function initializeRandomNumberStream_V
  ! ---------------------------------------------------------
  ! Procedures for drawing random numbers
  ! ---------------------------------------------------------
  subroutine getRandomNumber_Scalar(stream, number)
    type(randomNumberStream), intent(inout) :: stream
    real,                     intent(  out) :: number
    
    number = getRandomReal(stream%theNumbers)
  end subroutine getRandomNumber_Scalar
  ! ---------------------------------------------------------
  subroutine getRandomNumber_1D(stream, numbers)
    type(randomNumberStream), intent(inout) :: stream
    real, dimension(:),       intent(  out) :: numbers
    
    ! Local variables
    integer :: i
    
    do i = 1, size(numbers)
      numbers(i) = getRandomReal(stream%theNumbers)
    end do
  end subroutine getRandomNumber_1D
  ! ---------------------------------------------------------
  subroutine getRandomNumber_2D(stream, numbers)
    type(randomNumberStream), intent(inout) :: stream
    real, dimension(:, :),    intent(  out) :: numbers
    
    ! Local variables
    integer :: i
    
    do i = 1, size(numbers, 2)
      call getRandomNumber_1D(stream, numbers(:, i))
    end do
  end subroutine getRandomNumber_2D
  ! ---------------------------------------------------------
  ! Constructs a unique seed from grid cell index and model date/time
  !   The perm is supplied we generate a different seed by 
  !   circularly shifting the bits of the seed - this is useful 
  !   if we want to create more than one seed for a given 
  !   column and model date/time. 
  !   Note that abs(perm) must be <= the number of bits used 
  !   to represent the default integer (likely 32) 
  ! ---------------------------------------------------------
  function constructSeed(i, j, time, perm) result(seed)
    integer,           intent( in)  :: i, j
    type(time_type),   intent( in) :: time
    integer, optional, intent( in) :: perm
    integer, dimension(8) :: seed
    
    ! Local variables
    integer :: year, month, day, hour, minute, second
    
    
    call get_date(time, year, month, day, hour, minute, second)
    seed = (/ i, j, year, month, day, hour, minute, second /)
    if(present(perm)) seed = ishftc(seed, perm)
  end function constructSeed
end module random_numbers_mod

module pv_module

  use fv_pack,      only: u_ghosted, cose, rcap, one_by_dy,   &
                          one_by_dx, f_d, acosp

#ifdef SPMD
  use mod_comm, only: gid, mp_send3d, mp_recv3d
#endif

  use fv_arrays_mod, only: fv_array_check, fv_array_sync, jsp, jep, ksp, kep
  implicit none

public vort_d,  pv_entropy

contains

  subroutine vort_d(im, jm, km, jfirst, jlast, u, v, vort, ng_s, ng_d)

! Computes relative vorticity on the D grid using circulation theorem

! !INPUT PARAMETERS:
    integer im, jm, km                   ! Horizontal dimensions
    integer jfirst, jlast                ! Latitude strip
    integer ng_s, ng_d

    real:: u(im,jfirst-ng_d:jlast+ng_s,km) 
    real:: v(im,jfirst-ng_d:jlast+ng_d,km) 

! !OUTPUT PARAMETERS:
    real, intent(out):: vort(im,jfirst:jlast,km)

! local
    real fx(im,jfirst-ng_d:jlast+ng_d)
! Geometric arrays
    real cy(jfirst:jlast)

    integer i, j, k,  js2g0, jn2g0
    real c1, c2

    call fv_array_check( LOC(u) )
    call fv_array_check( LOC(v) )
    call fv_array_check( LOC(vort) )

#ifdef SPMD
    call fv_array_sync()
    if ( .not. u_ghosted ) then
        call mp_send3d(gid-1, gid+1, im, jm, km, &
             1, im, jfirst-ng_d, jlast+ng_s, 1, km, &
             1, im, jfirst, jfirst, 1, km, u)
        call mp_recv3d(gid+1, im, jm, km, &
             1, im, jfirst-ng_d, jlast+ng_s, 1, km, &
             1, im, jlast+1, jlast+1, 1, km, u)
        u_ghosted = .true.
    endif
    call fv_array_sync()
#endif

    js2g0 = max(2,jfirst)
    jn2g0 = min(jm-1,jlast)

!$omp  parallel do                  &
!$omp  default(shared)              &
!$omp  private(i,j,k, fx, c1, c2, cy)

    do k=ksp,kep

       do j=js2g0,min(jlast+1,jm)
          do i=1,im
             fx(i,j) = u(i,j,k)*cose(j)
          enddo
       enddo

       do j=js2g0,jn2g0
          cy(j) =  one_by_dy * acosp(j)
          do i=1,im-1
             vort(i,j,k) = ( fx(i,j) - fx(i,j+1) ) * cy(j) +      &
                  ( v(i+1,j,k) - v(i,j,k) ) * one_by_dx(j)
          enddo
          i = im
          vort(i,j,k) = ( fx(i,j) - fx(i,j+1) ) * cy(j)    +      &
               ( v(1,j,k) - v(i,j,k) ) * one_by_dx(j)
       enddo

! Vort at poles computed by circulation theorem

       if ( jfirst == 1 ) then
           c1 = -SUM(fx(1:im,2))*one_by_dy*rcap
           do i=1,im
              vort(i,1,k) = c1
           enddo
       endif

       if ( jlast == jm )  then
           c2 = SUM(fx(1:im,jm))*one_by_dy*rcap
           do i=1,im
              vort(i,jm,k) = c2
           enddo
       endif
    enddo
    call fv_array_sync()

  end subroutine vort_d


  subroutine pv_entropy(im, jm, km, jfirst, jlast, vort, pt, pkz, delp, ng, grav)
#ifdef use_shared_pointers
   use fv_arrays_mod, only: fv_stack_push
#endif

! !INPUT PARAMETERS:
   integer, intent(in):: im, jm, km               ! Horizontal dimensions
   integer, intent(in):: jfirst, jlast            ! Latitude strip
   integer, intent(in):: ng
   real, intent(in):: grav
   real, intent(in):: pt(im,jfirst-ng:jlast+ng,km) 
   real, intent(in):: pkz(im,jfirst:jlast,km) 
   real, intent(in):: delp(im,jfirst:jlast,km)

! vort is relative vorticity as input. Becomes PV on output
      real, intent(inout):: vort(im,jfirst:jlast,km) 

! !DESCRIPTION:
!        EPV = 1/r * (vort+f_d) * d(S)/dz; where S is a conservative scalar
!        r the fluid density, and S is chosen to be the entropy here: S = log(pt)
!        pt == potential temperature.
! Computation are performed assuming the input is on "x-y-z" Cartesian coordinate.
! The approximation made here is that the relative vorticity computed on constant
! z-surface is not that different from the hybrid sigma-p coordinate.
! See page 39, Pedlosky 1979: Geophysical Fluid Dynamics
!
! The follwoing simplified form is strictly correct only if vort is computed on 
! constant z surfaces. In addition hydrostatic approximation is made.
!        EPV = - GRAV * (vort+f_d) / del(p) * del(pt) / pt 
! where del() is the vertical difference operator.
!
! programmer: S.-J. Lin, sjl
!
!EOP
!---------------------------------------------------------------------
!BOC
      real w3d(im,jfirst:jlast,km) 
      real te(im,jm,km+1), t2(im,km), delp2(im,km)
      real te2(im,km+1)
      integer i, j, k
#ifdef use_shared_pointers
      pointer( p_w3d, w3d )
      pointer( p_te, te )
      call fv_stack_push( p_w3d, im*km*(jlast-jfirst+1) )
      call fv_stack_push( p_te,  im*jm*(km+1)           )
#endif
      call fv_array_check( LOC(pt) )
      call fv_array_check( LOC(pkz) )
      call fv_array_check( LOC(delp) )
      call fv_array_check( LOC(vort) )

#ifdef SW_DYN
        do j=jsp,jep !jfirst,jlast
          do i=1,im
#ifndef USE_LIMA
            vort(i,j,1) = grav * (vort(i,j,1)+f_d(i,j)) / delp(i,j,1)
#else
            vort(i,j,1) = grav * (vort(i,j,1)+f_d(j)) / delp(i,j,1)
#endif
          enddo
        enddo
        call fv_array_sync()
#else
! Compute PT at layer edges.

!$omp  parallel do                 &
!$omp  default(shared)             &
!$omp  private(i,j,k,t2,delp2,te2)

     do j=jsp,jep !jfirst,jlast

        do k=1,km
          do i=1,im
               t2(i,k) = pt(i,j,k) / pkz(i,j,k)
              w3d(i,j,k) = t2(i,k)
            delp2(i,k) = delp(i,j,k)
          enddo
        enddo

        call ppme(t2, te2, delp2, im, km)

        do k=1,km+1
           do i=1,im
              te(i,j,k) = te2(i,k)
           enddo
        enddo
     enddo
     call fv_array_sync()

!$omp  parallel do                  &
!$omp  default(shared)              &
!$omp  private(i,j,k)

     do k=ksp,kep !1,km
        do j=jfirst,jlast
          do i=1,im
! Entropy is the thermodynamic variable in the following form
#ifndef USE_LIMA
            vort(i,j,k) = (vort(i,j,k)+f_d(i,j)) * ( te(i,j,k)-te(i,j,k+1) )  &
                          / ( w3d(i,j,k)*delp(i,j,k) )  * grav
#else
            vort(i,j,k) = (vort(i,j,k)+f_d(j)) * ( te(i,j,k)-te(i,j,k+1) )  &
                          / ( w3d(i,j,k)*delp(i,j,k) )  * grav
#endif
          enddo
        enddo
     enddo
     call fv_array_sync()
#endif

  end subroutine pv_entropy


  subroutine ppme(p,qe,delp,im,km)

  integer, intent(in):: im, km
  real, intent(in)::    p(im,km)
  real, intent(in):: delp(im,km)
  real, intent(out)::qe(im,km+1)

! local arrays.
      real dc(im,km),delq(im,km), a6(im,km)
      real c1, c2, c3, tmp, qmax, qmin
      real a1, a2, s1, s2, s3, s4, ss3, s32, s34, s42
      real a3, b2, sc, dm, d1, d2, f1, f2, f3, f4
      real qm, dq
      integer i, k, km1

      km1 = km - 1

      do 500 k=2,km
      do 500 i=1,im
500   a6(i,k) = delp(i,k-1) + delp(i,k)

      do 1000 k=1,km1
      do 1000 i=1,im
      delq(i,k) = p(i,k+1) - p(i,k)
1000  continue

      do 1220 k=2,km1
      do 1220 i=1,im
      c1 = (delp(i,k-1)+0.5*delp(i,k))/a6(i,k+1)
      c2 = (delp(i,k+1)+0.5*delp(i,k))/a6(i,k)
      tmp = delp(i,k)*(c1*delq(i,k) + c2*delq(i,k-1)) /    &
                                    (a6(i,k)+delp(i,k+1))
      qmax = max(p(i,k-1),p(i,k),p(i,k+1)) - p(i,k)
      qmin = p(i,k) - min(p(i,k-1),p(i,k),p(i,k+1))
      dc(i,k) = sign(min(abs(tmp),qmax,qmin), tmp)
1220  continue

!****6***0*********0*********0*********0*********0*********0**********72
! 4th order interpolation of the provisional cell edge value
!****6***0*********0*********0*********0*********0*********0**********72

   do k=3,km1
      do i=1,im
         c1 = delq(i,k-1)*delp(i,k-1) / a6(i,k)
         a1 = a6(i,k-1) / (a6(i,k) + delp(i,k-1))
         a2 = a6(i,k+1) / (a6(i,k) + delp(i,k))
         qe(i,k) = p(i,k-1) + c1 + 2./(a6(i,k-1)+a6(i,k+1)) *        &
                   ( delp(i,k)*(c1*(a1 - a2)+a2*dc(i,k-1)) -         &
                                delp(i,k-1)*a1*dc(i,k  ) )
      enddo
   enddo

! three-cell parabolic subgrid distribution at model top

   do i=1,im
! three-cell PP-distribution
! Compute a,b, and c of q = aP**2 + bP + c using cell averages and delp
! a3 = a / 3
! b2 = b / 2
      s1 = delp(i,1)
      s2 = delp(i,2) + s1
!
      s3 = delp(i,2) + delp(i,3)
      s4 = s3 + delp(i,4)
      ss3 =  s3 + s1
      s32 = s3*s3
      s42 = s4*s4
      s34 = s3*s4
! model top
      a3 = (delq(i,2) - delq(i,1)*s3/s2) / (s3*ss3)
!
      if(abs(a3) .gt. 1.e-14) then
         b2 =  delq(i,1)/s2 - a3*(s1+s2)
         sc = -b2/(3.*a3)
         if(sc .lt. 0. .or. sc .gt. s1) then
             qe(i,1) = p(i,1) - s1*(a3*s1 + b2)
         else
             qe(i,1) = p(i,1) - delq(i,1)*s1/s2
         endif
      else
! Linear
         qe(i,1) = p(i,1) - delq(i,1)*s1/s2
      endif
      dc(i,1) = p(i,1) - qe(i,1)
! compute coef. for the off-centered area preserving cubic poly.
      dm = delp(i,1) / (s34*ss3*(delp(i,2)+s3)*(s4+delp(i,1)))
      f1 = delp(i,2)*s34 / ( s2*ss3*(s4+delp(i,1)) )
      f2 = (delp(i,2)+s3) * (ss3*(delp(i,2)*s3+s34+delp(i,2)*s4)   &
            + s42*(delp(i,2)+s3+s32/s2))
      f3 = -delp(i,2)*( ss3*(s32*(s3+s4)/(s4-delp(i,2))            &
            + (delp(i,2)*s3+s34+delp(i,2)*s4))                     &
            + s42*(delp(i,2)+s3) )
      f4 = ss3*delp(i,2)*s32*(delp(i,2)+s3) / (s4-delp(i,2))
      qe(i,2) = f1*p(i,1)+(f2*p(i,2)+f3*p(i,3)+f4*p(i,4))*dm
   enddo

! Bottom
! Area preserving cubic with 2nd deriv. = 0 at the surface
   do i=1,im
      d1 = delp(i,km)
      d2 = delp(i,km1)
      qm = (d2*p(i,km)+d1*p(i,km1)) / (d1+d2)
      dq = 2.*(p(i,km1)-p(i,km)) / (d1+d2)
      c1 = (qe(i,km1)-qm-d2*dq) / (d2*(2.*d2*d2+d1*(d2+3.*d1)))
      c3 = dq - 2.0*c1*(d2*(5.*d1+d2)-3.*d1**2)
      qe(i,km  ) = qm - c1*d1*d2*(d2+3.*d1)
      qe(i,km+1) = d1*(8.*c1*d1**2-c3) + qe(i,km)
   enddo

  end subroutine ppme

end module pv_module

      module MO_PHOTO_MOD
!----------------------------------------------------------------------
!        ... Photolysis interp table and related arrays
!----------------------------------------------------------------------
      use fms_mod,          only : mpp_clock_begin, mpp_clock_id, &
                                   mpp_clock_end, CLOCK_MODULE
      use mpp_mod,          only : mpp_error, FATAL
      use mpp_io_mod,       only : mpp_open, MPP_RDONLY, MPP_ASCII,MPP_MULTI, &
                                   MPP_SINGLE, mpp_close
      use time_manager_mod, only : time_type, get_date
      use constants_mod,    only : PI

      implicit none

      private
      public :: prate_init, photo, set_ub_col, setcol, sundis

      save

      integer, parameter :: jdim     = 40
      integer, parameter :: altdim   = 46
      integer, parameter :: zangdim  = 11
      integer, parameter :: o3ratdim = 7
      integer, parameter :: albdim   = 4
      integer, parameter :: t500dim  = 3
      integer, parameter :: t200dim  = 2
      integer, parameter :: tabdim   = jdim*altdim*zangdim*o3ratdim*albdim*t500dim*t200dim

      integer ::  offset(7)
      integer ::  indexer(jdim)
      integer ::  jno_ndx, jpooh_ndx, jc2h5ooh_ndx, jc3h7ooh_ndx, jrooh_ndx, &
                  jch3co3h_ndx, jmpan_ndx, jmacr_a_ndx, jmacr_b_ndx, jonitr_ndx, &
                  jxooh_ndx, jisopooh_ndx, jglyald_ndx, jhyac_ndx, jch3ooh_ndx, &
                  jh2o2_ndx, jpan_ndx, jch3cho_ndx, jho2no2_ndx, &
                  jn2o5_ndx, jo3p_ndx, jno2_ndx, jno3_ndx, &
                  jclono2_ndx, jhocl_ndx, jcl2o2_ndx, jbrono2_ndx, jhobr_ndx, &
                  jbrcl_ndx, jbro_ndx, jcl2_ndx, jh2o_ndx, jn2o_ndx, jhno3_ndx
      integer ::  ox_ndx, o3_ndx
      real    ::  ajl(jdim,altdim,zangdim,o3ratdim,albdim,t500dim,t200dim) = 0., &
                  ajl_solarmin(jdim,altdim,zangdim,o3ratdim,albdim,t500dim,t200dim) = 0.
!RSH  real    ::  ajl2(2,2,2,2,2,2)
      real    ::  vo3(0:80), vo3_solarmin(0:80)
      real    ::  delvo3(0:79)
      real    ::  delz(altdim-1)
      real    ::  delang(zangdim-1)
      real    ::  delv(o3ratdim-1)
      real    ::  delalb(albdim-1)
      real    ::  delt500(t500dim-1)
      real    ::  delt200(t200dim-1)

      real, parameter :: zz(altdim) = &
        (/  0.,  1.,  2.,  3.,  4.,  5.,  6.,  8., 10., 12., 14., 16., 18., 20., 22., &
           24., 26., 28., 30., 32., 34., 36., 38., 40., 42., 44., 46., 48., 50., 52., &
           54., 56., 58., 60., 62., 64., 66., 68., 70., 72., 74., 76., 78., 80., 82., &
           85. /)
      real, parameter :: vcos(zangdim) = &
        (/ -0.07, -0.05, -0.01, 0.01, 0.05, 0.1, 0.2,   0.4,   0.6,  0.8,  1.0 /)
      real, parameter :: xv3(o3ratdim) = (/ .5, .75, 1., 1.25, 1.5, 2., 5. /)
      real, parameter :: albev(albdim) = (/ .05, .2, .5, 1. /)
      real, parameter :: t500(t500dim) = (/ 228., 248., 268. /)
      real, parameter :: t200(t200dim) = (/ 205., 225. /)
      real, parameter :: coszen_min = vcos(1)


      integer, parameter :: &
         TAB_NDX_JO2        = 1,  TAB_NDX_JO1D       = 2, &
         TAB_NDX_JO3P       = 3,  TAB_NDX_JNO2       = 4, &
         TAB_NDX_JNO3       = 5,  TAB_NDX_JN2O5      = 6, &
         TAB_NDX_JN2O5_225  = 7,  TAB_NDX_JN2O5_250  = 8, &
         TAB_NDX_JN2O5_300  = 9,  TAB_NDX_JN2O       = 10, &
         TAB_NDX_JN2O_200   = 11, TAB_NDX_JN2O_250   = 12, &
         TAB_NDX_JN2O_300   = 13, TAB_NDX_JH2O2      = 14, &
         TAB_NDX_JHNO3      = 15, TAB_NDX_JHNO3_200  = 16, &
         TAB_NDX_JHNO3_250  = 17, TAB_NDX_JHNO3_300  = 18, &
         TAB_NDX_JHO2NO2    = 19, TAB_NDX_JCH2Oa     = 20, &
         TAB_NDX_JCH2Ob     = 21, TAB_NDX_JCH3CHO    = 22, &
         TAB_NDX_JMGLY      = 23, TAB_NDX_JACET      = 24, &
         TAB_NDX_JCH3OOH    = 25, TAB_NDX_JPAN       = 26, &
         TAB_NDX_JCLONO2    = 27, TAB_NDX_JCLONO2_200= 28, &
         TAB_NDX_JCLONO2_250= 29, TAB_NDX_JCLONO2_300= 30, &
         TAB_NDX_JBRONO2    = 31, TAB_NDX_JCL2       = 32, &
         TAB_NDX_JMVK       = 33, TAB_NDX_JMACRa     = 34, &
         TAB_NDX_JCL2O2     = 35, TAB_NDX_JHYAC      = 36, &
         TAB_NDX_JHOBR      = 37, TAB_NDX_JBR2       = 38, &
         TAB_NDX_JHOCL      = 39, TAB_NDX_JBRCL      = 40

      logical :: use_tdep_jvals, use_solar_cycle
      real    :: o3_column_top, jno_scale_factor

character(len=128), parameter :: version     = '$Id: mo_photo.F90,v 19.0 2012/01/06 20:34:00 fms Exp $'
character(len=128), parameter :: tagname     = '$Name: tikal $'
logical                       :: module_is_initialized = .false.
integer                       :: photo_clock

      CONTAINS
      
! <SUBROUTINE NAME="prate_init">
!   <OVERVIEW>
!     Initialize photolysis rate lookup table calculation
!   </OVERVIEW>
!   <DESCRIPTION>
!     This subroutine initializes the calculation of photolysis rates
!     from the TUV lookup table
!   </DESCRIPTION>
!   <TEMPLATE>
!     call prate_init( filename, filename_solarmin, lpath, mspath, use_tdep_jvals_in )
!   </TEMPLATE>
!   <IN NAME="filename" TYPE="character(len=*)">
!     Filename for ASCII lookup table file (if solar cycle used, this is the filename
!     for solar maximum conditions).
!   </IN>
!   <IN NAME="filename_solarmin" TYPE="character(len=*)">
!     Filename for ASCII lookup table file for solar minimum conditions
!     (if solar cycle used)
!   </IN>
!   <IN NAME="lpath" TYPE="character(len=*)">
!     Local directory path for input files
!   </IN>
!   <IN NAME="mspath" TYPE="character(len=*)">
!     Remote directory path for input files (not used)
!   </IN>
!   <IN NAME="use_tdep_jvals_in" TYPE="logical">
!     Does the j-value lookup table contain temperature-dependent photolysis rates?
!   </IN>
!   <IN NAME="o3_column_top_in" TYPE="real">
!     Ozone column above model top (DU)
!   </IN>
!   <IN NAME="jno_scale_factor_in" TYPE="real">
!     Scale factor for NO photolysis rate (jNO)
!   </IN>
      subroutine prate_init( filename, filename_solarmin, lpath, mspath, &
                             use_tdep_jvals_in, o3_column_top_in,  &
                             jno_scale_factor_in, retain_cm3_bugs )
!----------------------------------------------------------------------
!     ... Read in the photorate tables and arrays
!         Results are "returned" via the common block photo_tables
!          This is for the new, expanded chemistry (11/21/94)
!----------------------------------------------------------------------
        
      use mo_chem_utls_mod,  only : get_spc_ndx, get_rxt_ndx
      implicit none

!----------------------------------------------------------------------
!        ... Dummy args
!----------------------------------------------------------------------
      character(len=*), intent(in) :: filename, filename_solarmin, lpath, mspath
      logical,          intent(in) :: use_tdep_jvals_in
      real,             intent(in) :: o3_column_top_in, &
                                      jno_scale_factor_in
      logical,          intent(in) :: retain_cm3_bugs

!----------------------------------------------------------------------
!        ... Local variables
!----------------------------------------------------------------------
      integer    :: it500, it200, izen, ialb, idob
      integer    :: ios
      integer    :: unit
!     integer    :: retval
!     logical    :: cosb
!     real       :: temp(tabdim)
      character(len=128) :: msg

!     unit = navu()
!----------------------------------------------------------------------
!        ... Only masternode gets photorate table
!----------------------------------------------------------------------
!     if( masternode ) then
!        retval = ATTACH( TRIM(lpath) // TRIM( filename ), &
!                         TRIM( mspath ) // TRIM( filename ), &
!                         unit, &
!                         .false., &                 ! non binary dataset
!                         cosb )
!        if( retval /= 0 ) then
!           write(*,*) 'PRATE_INIT: Failure opening file ',TRIM(lpath) // TRIM( filename )
!           write(*,*) 'Error code = ',retval
!           call ENDRUN
!        end if
!        CLOSE( unit )
!     end if
#ifdef USE_MPI
!----------------------------------------------------------------------
!        ... All compute nodes wait for masternode to acquire file
!----------------------------------------------------------------------
!     call MPI_BARRIER( mpi_comm_comp, ios )
!     if( ios /= MPI_SUCCESS ) then
!        write(*,*) 'PRATE_INIT: Mpi barrier failed; error = ',ios
!        call ENDRUN
!     end if
#endif
!----------------------------------------------------------------------
!        ... all compute nodes open file
!----------------------------------------------------------------------
!     OPEN( unit   = unit, &
!           file   = TRIM(lpath) // TRIM(filename), &
!           status = 'old', &
!           form   = 'formatted', &
!           recl   = 4500, &
!          iostat = ios )
!     if( ios /= 0 ) then
!----------------------------------------------------------------------
!        ... Open error exit
!----------------------------------------------------------------------
!        write(6,'('' PRATE_INIT : Error ('',i5,'') opening file '',a)') &
!           ios, TRIM(lpath) // TRIM(filename)
!        call ENDRUN
!     end if

!----------------------------------------------------------------------
!            ... open file using mpp_open
!----------------------------------------------------------------------

      call mpp_open( unit, trim(lpath)//trim(filename), MPP_RDONLY, MPP_ASCII, &
                     threading = MPP_MULTI, fileset = MPP_SINGLE, &
                     recl = 4500)

!----------------------------------------------------------------------
!        ... Readin the reference o3 column and photorate table
!----------------------------------------------------------------------
      read(unit,*,iostat=ios) vo3
      if( ios /= 0 ) then
         msg = ' PRATE_INIT: Failed to read o3 column'
         call ENDRUN(msg)
      end if

      do it500 = 1,t500dim
         do it200 = 1,t200dim
            do izen = 1,zangdim
               do ialb = 1,albdim
                  do idob = 1,o3ratdim
                     read(unit,*,iostat=ios) ajl(:,:,izen,idob,ialb,it500,it200)
                     if( ios /= 0 ) then
                        msg = ' PRATE_INIT: Failed to read photo table; error = '//char(ios)
                        call ENDRUN(msg)
                     end if
                  end do
               end do
            end do
         end do
      end do

!----------------------------------------------------------------------
!        ... Set module variables
!----------------------------------------------------------------------
      delz(:altdim-1) = 1. / (zz(2:altdim) - zz(:altdim-1))
      delvo3(0:79) = vo3(1:80) - vo3(0:79)
      delang(:zangdim-1)  = 1. / (vcos(2:zangdim) - vcos(:zangdim-1))
      delv(:o3ratdim-1)   = 1. / (xv3(2:o3ratdim) - xv3(:o3ratdim-1))
      delalb(:albdim-1)   = 1. / (albev(2:albdim) - albev(:albdim-1))
      delt500(:t500dim-1) = 1. / (t500(2:t500dim) - t500(:t500dim-1))
      delt200(:t200dim-1) = 1. / (t200(2:t200dim) - t200(:t200dim-1))

      offset(1) = jdim
      offset(2) = offset(1)*altdim
      offset(3) = offset(2)*zangdim
      offset(4) = offset(3)*o3ratdim
      offset(5) = offset(4)*albdim
      offset(6) = offset(5)*t500dim
      offset(7) = SUM( offset(1:6) )

!     close( unit )
      call mpp_close( unit )

!-----------------------------------------------------------------
!           ... check whether using solar cycle
!-----------------------------------------------------------------
      if (filename_solarmin == '' .or. filename_solarmin == filename) then
         use_solar_cycle = .false.
      else
         use_solar_cycle = .true.

!----------------------------------------------------------------------
!            ... open file using mpp_open
!----------------------------------------------------------------------
         call mpp_open( unit, trim(lpath)//trim(filename_solarmin), MPP_RDONLY, MPP_ASCII, &
                        threading = MPP_MULTI, fileset = MPP_SINGLE, &
                        recl = 4500)

!----------------------------------------------------------------------
!        ... Readin the reference o3 column and photorate table 
!            for solar minimum
!----------------------------------------------------------------------
         read(unit,*,iostat=ios) vo3_solarmin
         if( ios /= 0 ) then
            msg = ' PRATE_INIT: Failed to read solarmin o3 column'
            call ENDRUN(msg)
         end if

         do it500 = 1,t500dim
         do it200 = 1,t200dim
         do izen = 1,zangdim
         do ialb = 1,albdim
         do idob = 1,o3ratdim
            read(unit,*,iostat=ios) ajl_solarmin(:,:,izen,idob,ialb,it500,it200)
            if( ios /= 0 ) then
               msg = ' PRATE_INIT: Failed to read solarmin photo table; error = '//char(ios)
               call ENDRUN(msg)
            end if
         end do
         end do
         end do
         end do
         end do
         call mpp_close( unit )
      end if

!-----------------------------------------------------------------
!           ... setup mapping array, indexer, from table to model
!-----------------------------------------------------------------
      indexer(TAB_NDX_JO2)      = get_rxt_ndx( 'jo2' )
      indexer(TAB_NDX_JO1D)     = get_rxt_ndx( 'jo1d' )
      indexer(TAB_NDX_JO3P)     = get_rxt_ndx( 'jo3p' )
      indexer(TAB_NDX_JNO2)     = get_rxt_ndx( 'jno2' )
      indexer(TAB_NDX_JNO3)     = get_rxt_ndx( 'jno3' )
      indexer(TAB_NDX_JN2O5)    = get_rxt_ndx( 'jn2o5' )
      indexer(TAB_NDX_JN2O5_225)= 0
      indexer(TAB_NDX_JN2O5_250)= 0
      indexer(TAB_NDX_JN2O5_300)= 0
      indexer(TAB_NDX_JN2O)     = get_rxt_ndx( 'jn2o' )
      indexer(TAB_NDX_JN2O_200) = 0
      indexer(TAB_NDX_JN2O_250) = 0
      indexer(TAB_NDX_JN2O_300) = 0
      indexer(TAB_NDX_JH2O2)    = get_rxt_ndx( 'jh2o2' )
      indexer(TAB_NDX_JHNO3)    = get_rxt_ndx( 'jhno3' )
      indexer(TAB_NDX_JHNO3_200)= 0
      indexer(TAB_NDX_JHNO3_250)= 0
      indexer(TAB_NDX_JHNO3_300)= 0
      indexer(TAB_NDX_JHO2NO2)  = get_rxt_ndx( 'jho2no2' )
      indexer(TAB_NDX_JCH2Oa)   = get_rxt_ndx( 'jch2o_a' )
      indexer(TAB_NDX_JCH2Ob)   = get_rxt_ndx( 'jch2o_b' )
      indexer(TAB_NDX_JCH3CHO)  = get_rxt_ndx( 'jch3cho' )
      indexer(TAB_NDX_JMGLY)    = get_rxt_ndx( 'jmgly' )
      indexer(TAB_NDX_JACET)    = get_rxt_ndx( 'jacet' )
      indexer(TAB_NDX_JCH3OOH)  = get_rxt_ndx( 'jch3ooh' )
      indexer(TAB_NDX_JPAN)     = get_rxt_ndx( 'jpan' )
      indexer(TAB_NDX_JCLONO2)  = get_rxt_ndx( 'jclono2' )
      indexer(TAB_NDX_JCLONO2_200)=0
      indexer(TAB_NDX_JCLONO2_250)=0
      indexer(TAB_NDX_JCLONO2_300)=0
      indexer(TAB_NDX_JBRONO2)  = get_rxt_ndx( 'jbrono2' )
      indexer(TAB_NDX_JCL2)     = get_rxt_ndx( 'jcl2' )
      indexer(TAB_NDX_JMVK)     = get_rxt_ndx( 'jmvk' )
      indexer(TAB_NDX_JMACRa)   = get_rxt_ndx( 'jmacr_a' )
      indexer(TAB_NDX_JCL2O2)   = get_rxt_ndx( 'jcl2o2' )
      indexer(TAB_NDX_JHYAC)    = get_rxt_ndx( 'jhyac' )
      indexer(TAB_NDX_JHOBR)    = get_rxt_ndx( 'jhobr' )
      indexer(TAB_NDX_JBR2)     = get_rxt_ndx( 'jbr2' )
      indexer(TAB_NDX_JHOCL)    = get_rxt_ndx( 'jhocl' )
      indexer(TAB_NDX_JBRCL)    = get_rxt_ndx( 'jbrcl' )

      jno_ndx      = get_rxt_ndx( 'jno' )
      jpooh_ndx    = get_rxt_ndx( 'jpooh' )
      jc2h5ooh_ndx = get_rxt_ndx( 'jc2h5ooh' )
      jc3h7ooh_ndx = get_rxt_ndx( 'jc3h7ooh' )
      jrooh_ndx    = get_rxt_ndx( 'jrooh' )
      jch3co3h_ndx = get_rxt_ndx( 'jch3co3h' )
      jmpan_ndx    = get_rxt_ndx( 'jmpan' )
      jmacr_a_ndx  = get_rxt_ndx( 'jmacr_a' )
      jmacr_b_ndx  = get_rxt_ndx( 'jmacr_b' )
      jonitr_ndx   = get_rxt_ndx( 'jonitr' )
      jxooh_ndx    = get_rxt_ndx( 'jxooh' )
      jisopooh_ndx = get_rxt_ndx( 'jisopooh' )
      jglyald_ndx  = get_rxt_ndx( 'jglyald' )
      jhyac_ndx    = get_rxt_ndx( 'jhyac' )
      jch3ooh_ndx  = get_rxt_ndx( 'jch3ooh' )
      jh2o2_ndx    = get_rxt_ndx( 'jh2o2' )
      jpan_ndx     = get_rxt_ndx( 'jpan' )
      jch3cho_ndx  = get_rxt_ndx( 'jch3cho' )
      jho2no2_ndx  = get_rxt_ndx( 'jho2no2' )
      jn2o5_ndx    = get_rxt_ndx( 'jn2o5' )
      jo3p_ndx     = get_rxt_ndx( 'jo3p' )
      jno2_ndx     = get_rxt_ndx( 'jno2' )
      jno3_ndx     = get_rxt_ndx( 'jno3' )
      jclono2_ndx  = get_rxt_ndx( 'jclono2' )
      jhocl_ndx    = get_rxt_ndx( 'jhocl' )
      jcl2o2_ndx   = get_rxt_ndx( 'jcl2o2' )
      jbrono2_ndx  = get_rxt_ndx( 'jbrono2' )
      jhobr_ndx    = get_rxt_ndx( 'jhobr' )
      jbrcl_ndx    = get_rxt_ndx( 'jbrcl' )
      jbro_ndx     = get_rxt_ndx( 'jbro' )
      jcl2_ndx     = get_rxt_ndx( 'jcl2' )
      jh2o_ndx     = get_rxt_ndx( 'jh2o' )
      jn2o_ndx     = get_rxt_ndx( 'jn2o' )
      jhno3_ndx    = get_rxt_ndx( 'jhno3' )

!      ox_ndx = get_spc_ndx( 'OX' )
!     for ox budget (jmao,1/7/2011)
   if (retain_cm3_bugs) then
      ox_ndx = get_spc_ndx( 'OX' )
      o3_ndx = get_spc_ndx( 'O3' )
   else
      ox_ndx = get_spc_ndx( 'O3' )
      o3_ndx = get_spc_ndx( 'O3' )
   endif

      use_tdep_jvals   = use_tdep_jvals_in
      o3_column_top    = o3_column_top_in
      jno_scale_factor = jno_scale_factor_in

      photo_clock = mpp_clock_id ('Tropchem:Photo', grain=CLOCK_MODULE)

      end subroutine prate_init
! </SUBROUTINE>


! <SUBROUTINE NAME="PHOTO">
!   <OVERVIEW>
!     Calculate photolysis rates
!   </OVERVIEW>
!   <DESCRIPTION>
!     Calculate photolysis rates from the TUV lookup table
!   </DESCRIPTION>
!   <TEMPLATE>
!     call PHOTO( photos, pmid, pdel, temper, zmid, col_dens, coszen,  & 
!                 srf_alb, lwc, clouds, esfact, solar_phase, plonl )
!   </TEMPLATE>
!   <IN NAME="photos" TYPE="real" DIM="(:,:,:)">
!     Photodissociation rates (s^-1)
!   </IN>
!   <IN NAME="pmid" TYPE="real" DIM="(:,:)">
!     Full level pressures (Pa)
!   </IN>
!   <IN NAME="pdel" TYPE="real" DIM="(:,:)">
!     Half level (interface) pressures (Pa)
!   </IN>
!   <IN NAME="temper" TYPE="real" DIM="(:,:)">
!     Full level temperatures (K)
!   </IN>
!   <IN NAME="zmid" TYPE="real" DIM="(:,:)">
!     Full level absolute geopotential altitudes (km)
!   </IN>
!   <IN NAME="col_dens" TYPE="real" DIM="(:,:,:)">
!     Column densities
!   </IN>
!   <IN NAME="coszen" TYPE="real" DIM="(:)">
!     Cosine of solar zenith angle
!   </IN>
!   <IN NAME="srf_alb" TYPE="real" DIM="(:)">
!     Surface albedo
!   </IN>
!   <IN NAME="lwc" TYPE="real" DIM="(:,:)">
!     Cloud liquid water content (kg/kg)
!   </IN>
!   <IN NAME="clouds" TYPE="real" DIM="(:,:)">
!     Cloud fraction
!   </IN>
!   <IN NAME="esfact" TYPE="real">
!     Earth-sun distance factor
!   </IN>
!   <IN NAME="solar_phase" TYPE="real">
!     Solar cycle phase (1=max, 0=min)
!   </IN>
!   <IN NAME="plonl" TYPE="integer">
!     Size of longitude dimension
!   </IN>
      subroutine PHOTO( photos, pmid, pdel, temper, zmid, &
                        col_dens, &
                        coszen,  & 
                        srf_alb, lwc, clouds, &
                        esfact, solar_phase, &
                        plonl )

      use CHEM_MODS_MOD, only : ncol_abs, phtcnt
!     use M_RXT_ID_MOD

      implicit none

!-----------------------------------------------------------------
!           ... Dummy arguments
!-----------------------------------------------------------------
      integer, intent(in) :: plonl
      real, intent(in) ::   esfact, &                 ! earth sun distance factor
                            solar_phase               ! solar cycle phase (1=max, 0=min)
      real, intent(in) ::   col_dens(:,:,:), &        ! column densities
                            coszen(:), &              ! solar zenith angle
                            srf_alb(:), &             ! surface albedo
                            lwc(:,:), &               ! liquid water content (mass mr)
                            clouds(:,:), &            ! cloud fraction
                            pmid(:,:), &              ! midpoint pressure in pascals
                            pdel(:,:), &              ! del pressure about midpoint in pascals
                            zmid(:,:), &              ! midpoint height
                            temper(:,:)               ! midpoint temperature
      real, intent(out) ::  photos(:,:,:)             ! photodissociation rates

!-----------------------------------------------------------------
!            ... Local variables
!-----------------------------------------------------------------
      integer  ::  i, k, m                 ! indicies
      integer  ::  plev
      logical  ::  zagtz(size(coszen))     ! zenith angle > 0 flag array
      real     ::  t500, t200              ! 500 & 200 mb temperatures
      real, dimension(size(zmid,2)) :: &
                   fac1, &                ! work space for J(no) calc
                   fac2, &                ! work space for J(no) calc
                   colo3, &               ! vertical o3 column density
                   zarg, &                ! vertical height array
                   pline, &               ! vertical pressure array
                   tline, &               ! vertical temperature array
                   cld_line, &            ! vertical cloud array
                   lwc_line, &            ! vertical lwc array
                   eff_alb, &             ! effective albedo from cloud modifications
                   cld_mult               ! clould multiplier
      real, dimension(plonl,size(zmid,2)) :: &
                   tmp, &                        ! wrk array
                   tmp_jch3ooh, &                ! wrk array
                   tmp_jpan, &                   ! wrk array
                   tmp_jh2o2, &                  ! wrk array
                   tmp_jch3cho, &                ! wrk array
                   tmp_jmacr_a, &                ! wrk array
                   tmp_jn2o_200, &               ! wrk array
                   tmp_jn2o_250, &               ! wrk array
                   tmp_jn2o_300, &               ! wrk array
                   tmp_jn2o5_225, &              ! wrk array
                   tmp_jn2o5_250, &              ! wrk array
                   tmp_jn2o5_300, &              ! wrk array
                   tmp_jhno3_200, &              ! wrk array
                   tmp_jhno3_250, &              ! wrk array
                   tmp_jhno3_300, &              ! wrk array
                   tmp_jclono2_200, &            ! wrk array
                   tmp_jclono2_250, &            ! wrk array
                   tmp_jclono2_300, &            ! wrk array
                   wgt200, wgt225, wgt250, wgt300, &     ! wrk array
                   tmp_jno
      real    ::   prates(jdim,size(zmid,2))        ! photorates matrix

      call mpp_clock_begin (photo_clock)
      plev = SIZE(zmid,2)
!-----------------------------------------------------------------
!        ... Zero all photorates
!-----------------------------------------------------------------
      do m = 1,max(1,phtcnt)
         do k = 1,plev
            photos(:,k,m) = 0.
         end do
      end do
      do k = 1,plev
         tmp_jch3ooh(:,k)     = 0.
         tmp_jpan(:,k)        = 0.
         tmp_jh2o2(:,k)       = 0.
         tmp_jch3cho(:,k)     = 0.
         tmp_jmacr_a(:,k)     = 0.
         tmp_jno(:,k)         = 0.
         tmp_jn2o_200(:,k)    = 0.
         tmp_jn2o_250(:,k)    = 0.
         tmp_jn2o_300(:,k)    = 0.
         tmp_jn2o5_225(:,k)   = 0.
         tmp_jn2o5_250(:,k)   = 0.
         tmp_jn2o5_300(:,k)   = 0.
         tmp_jhno3_200(:,k)   = 0.
         tmp_jhno3_250(:,k)   = 0.
         tmp_jhno3_300(:,k)   = 0.
         tmp_jclono2_200(:,k) = 0.
         tmp_jclono2_250(:,k) = 0.
         tmp_jclono2_300(:,k) = 0.
      end do
      zagtz(:) = coszen(:) >= coszen_min

      do i = 1,plonl
         if( zagtz(i) ) then
!           secant = 1. / coszen(i)
!           if( secant <= 50. ) then
!           if( coszen(i) >= coszen_min ) then
            zarg(:)     = zmid(i,:)
            colo3(:)    = col_dens(i,:,1)
            pline(:)    = pmid(i,:)
            fac1(:)     = pdel(i,:)
            tline(:)    = temper(i,:)
            lwc_line(:) = lwc(i,:)
            cld_line(:) = clouds(i,:)
            call cloud_mod( coszen(i), cld_line, lwc_line, fac1, srf_alb(i), &
                            eff_alb, cld_mult )
            call T_INT( pline, tline, t500, t200 )
            call PHOTO_INTERP( zarg, coszen(i), colo3, eff_alb, t500, &
                               t200, solar_phase, prates )
            do m = 1,jdim
               if( indexer(m) > 0 ) then
                  photos(i,:,indexer(m)) = esfact *prates(m,:) * cld_mult(:)
               else
                  select case( m )
                     case( TAB_NDX_JCH3OOH )
                        tmp_jch3ooh(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JH2O2 )
                        tmp_jh2o2(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JCH3CHO )
                        tmp_jch3cho(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JPAN )
                        tmp_jpan(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JMACRa )
                        tmp_jmacr_a(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JN2O_200 )
                        tmp_jn2o_200(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JN2O_250 )
                        tmp_jn2o_250(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JN2O_300 )
                        tmp_jn2o_300(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JN2O5_225 )
                        tmp_jn2o5_225(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JN2O5_250 )
                        tmp_jn2o5_250(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JN2O5_300 )
                        tmp_jn2o5_300(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JHNO3_200 )
                        tmp_jhno3_200(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JHNO3_250 )
                        tmp_jhno3_250(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JHNO3_300 )
                        tmp_jhno3_300(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JCLONO2_200 )
                        tmp_jclono2_200(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JCLONO2_250 )
                        tmp_jclono2_250(i,:) = esfact *prates(m,:) * cld_mult(:)
                     case( TAB_NDX_JCLONO2_300 )
                        tmp_jclono2_300(i,:) = esfact *prates(m,:) * cld_mult(:)
                  end select
               end if
            end do
!-----------------------------------------------------------------
!        ... Calculate J(no) from formula
!-----------------------------------------------------------------
            if (coszen(i) > 0. ) then
               fac1(:) = 1.e-8  * (col_dens(i,:,2)/coszen(i))**.38
               fac2(:) = 5.e-19 * col_dens(i,:,1) / coszen(i)
               if( jno_ndx > 0 ) then
                  photos(i,:,jno_ndx) = 4.5e-6 * esfact * exp( -(fac1(:) + fac2(:)) ) &
                                               * cld_mult(:) * jno_scale_factor
               else
                  tmp_jno(i,:) = 4.5e-6 * esfact * exp( -(fac1(:) + fac2(:)) ) &
                                        * cld_mult(:) * jno_scale_factor
               end if
            end if
!-----------------------------------------------------------------
!        ... ho2no2 near-IR photolysis
!-----------------------------------------------------------------
            if (jho2no2_ndx > 0) then
               photos(i,:,jho2no2_ndx) = photos(i, :, jho2no2_ndx) + &
                    1.e-5 * esfact * cld_mult(:)
            endif
!        end if
         end if
      end do

!-----------------------------------------------------------------
!        ... Set J(pooh) from J(ch3ooh)
!                J(c2h5ooh) from J(ch3ooh)
!                J(c3h7ooh) from J(ch3ooh)
!                J(rooh) from J(ch3ooh)
!                J(ch3coooh) = .28 * J(h2o2)
!                J(mpan) from J(pan)
!                J(macr_a) and J(macr_b) = 1/2 * J(macr_total)
!               J(onitr) from j(ch3cho)
!               J(xooh) from J(ch3ooh)
!               J(isopooh) from J(ch3ooh)
!                J(glyald) = 3 * J(ch3cho)
!               J(hyac) from J(ch3cho)
!-----------------------------------------------------------------
      if( jch3ooh_ndx > 0 ) then
         tmp(:,:) = photos(:,:,jch3ooh_ndx)
      else
         tmp(:,:) = tmp_jch3ooh(:,:)
      end if
      if( jpooh_ndx > 0 ) then
         photos(:,:,jpooh_ndx)    = tmp(:,:)
      end if
      if( jc2h5ooh_ndx > 0 ) then
         photos(:,:,jc2h5ooh_ndx) = tmp(:,:)
      end if
      if( jc3h7ooh_ndx > 0 ) then
         photos(:,:,jc3h7ooh_ndx) = tmp(:,:)
      end if
      if( jrooh_ndx > 0 ) then
         photos(:,:,jrooh_ndx)    = tmp(:,:)
      end if
      if( jxooh_ndx > 0 ) then
        photos(:,:,jxooh_ndx)    = tmp(:,:)
      end if
      if( jisopooh_ndx > 0 ) then
         photos(:,:,jisopooh_ndx) = tmp(:,:)
      end if
      if( jch3co3h_ndx > 0 ) then
         if( jh2o2_ndx > 0 ) then
            photos(:,:,jch3co3h_ndx) = .28 * photos(:,:,jh2o2_ndx)
         else
            photos(:,:,jch3co3h_ndx) = .28 * tmp_jh2o2(:,:)
         end if
      end if
      if( jmpan_ndx > 0 ) then
         if( jpan_ndx > 0 ) then
            photos(:,:,jmpan_ndx)    = photos(:,:,jpan_ndx)
         else
            photos(:,:,jmpan_ndx)    = tmp_jpan(:,:)
         end if
      end if
      if( jmacr_a_ndx > 0 ) then
         photos(:,:,jmacr_a_ndx)  = .5 * photos(:,:,jmacr_a_ndx)
      end if
      if( jmacr_b_ndx > 0 ) then
         if( jmacr_a_ndx > 0 ) then
            photos(:,:,jmacr_b_ndx)  = photos(:,:,jmacr_a_ndx)
         else
            photos(:,:,jmacr_b_ndx)  = .5 * tmp_jmacr_a(:,:)
         end if
      end if
      if( jonitr_ndx > 0 ) then
         if( jch3cho_ndx > 0 ) then
            photos(:,:,jonitr_ndx)   = photos(:,:,jch3cho_ndx)
         else
            photos(:,:,jonitr_ndx)   = tmp_jch3cho(:,:)
         end if
      end if
      if( jglyald_ndx > 0 ) then
         if( jch3cho_ndx > 0 ) then
            photos(:,:,jglyald_ndx)  = 3. * photos(:,:,jch3cho_ndx)
         else
            photos(:,:,jglyald_ndx)   = 3. *tmp_jch3cho(:,:)
         end if
      end if
      if( jh2o_ndx > 0 ) then
         if( jno_ndx > 0 ) then
            photos(:,:,jh2o_ndx) = 0.1*photos(:,:,jno_ndx)
         else
            photos(:,:,jh2o_ndx) = 0.1*tmp_jno(:,:)
         end if
      end if
      if( jn2o_ndx > 0 .and. use_tdep_jvals ) then
         wgt200(:,:)  = MIN( 1.,MAX( 0.,(250.-temper(:,:))/50. ) )
         wgt300(:,:)  = MIN( 1.,MAX( 0.,(temper(:,:)-250.)/50. ) )
         wgt250(:,:)  = 1. - wgt200(:,:) - wgt300(:,:)
         photos(:,:,jn2o_ndx)    = wgt200(:,:)*tmp_jn2o_200(:,:) + &
                                   wgt250(:,:)*tmp_jn2o_250(:,:) + &
                                   wgt300(:,:)*tmp_jn2o_300(:,:)
      end if
      if( jn2o5_ndx > 0 .and. use_tdep_jvals ) then
         wgt225(:,:)  = MIN( 1.,MAX( 0.,(250.-temper(:,:))/25. ) )
         wgt300(:,:)  = MIN( 1.,MAX( 0.,(temper(:,:)-250.)/50. ) )
         wgt250(:,:)  = 1. - wgt225(:,:) - wgt300(:,:)
         photos(:,:,jn2o5_ndx)   = wgt225(:,:)*tmp_jn2o5_225(:,:) + &
                                   wgt250(:,:)*tmp_jn2o5_250(:,:) + &
                                   wgt300(:,:)*tmp_jn2o5_300(:,:)
      end if
      if( jhno3_ndx > 0 .and. use_tdep_jvals ) then
         wgt200(:,:)  = MIN( 1.,MAX( 0.,(250.-temper(:,:))/50. ) )
         wgt300(:,:)  = MIN( 1.,MAX( 0.,(temper(:,:)-250.)/50. ) )
         wgt250(:,:)  = 1. - wgt200(:,:) - wgt300(:,:)
         photos(:,:,jhno3_ndx)   = wgt200(:,:)*tmp_jhno3_200(:,:) + &
                                   wgt250(:,:)*tmp_jhno3_250(:,:) + &
                                   wgt300(:,:)*tmp_jhno3_300(:,:)
      end if
      if( jclono2_ndx > 0 .and. use_tdep_jvals ) then
         wgt200(:,:)  = MIN( 1.,MAX( 0.,(250.-temper(:,:))/50. ) )
         wgt300(:,:)  = MIN( 1.,MAX( 0.,(temper(:,:)-250.)/50. ) )
         wgt250(:,:)  = 1. - wgt200(:,:) - wgt300(:,:)
         photos(:,:,jclono2_ndx) = wgt200(:,:)*tmp_jclono2_200(:,:) + &
                                   wgt250(:,:)*tmp_jclono2_250(:,:) + &
                                   wgt300(:,:)*tmp_jclono2_300(:,:)
      end if

      call mpp_clock_end   (photo_clock)
      end subroutine PHOTO
! </SUBROUTINE>

      subroutine cloud_mod( coszen, clouds, lwc, delp, srf_alb, &
                            eff_alb, cld_mult )
!-----------------------------------------------------------------------
!         ... Cloud alteration factors for photorates and albedo
!-----------------------------------------------------------------------


      implicit none

      real, parameter :: gi = 1./9.80616

!-----------------------------------------------------------------------
!         ... Dummy arguments
!-----------------------------------------------------------------------
      real, intent(in)    ::  coszen             ! cosine of zenith angle
      real, intent(in)    ::  srf_alb            ! surface albedo
      real, intent(in)    ::  clouds(:)          ! cloud fraction
      real, intent(in)    ::  lwc(:)             ! liquid water content (mass mr)
      real, intent(in)    ::  delp(:)            ! del press about midpoint in pascals
      real, intent(out)   ::  eff_alb(:)         ! effective albedo
      real, intent(out)   ::  cld_mult(:)        ! photolysis mult factor

!-----------------------------------------------------------------------
!         ... Local variables
!-----------------------------------------------------------------------
      integer :: k
      integer :: plev, plevm
      real    :: coschi
      real    :: del_lwp(SIZE(clouds,1))
      real    :: del_tau(SIZE(clouds,1))
      real    :: above_tau(SIZE(clouds,1))
      real    :: below_tau(SIZE(clouds,1))
      real    :: above_cld(SIZE(clouds,1))
      real    :: below_cld(SIZE(clouds,1))
      real    :: above_tra(SIZE(clouds,1))
      real    :: below_tra(SIZE(clouds,1))
      real    :: fac1(SIZE(clouds,1))
      real    :: fac2(SIZE(clouds,1))
      
      plev = SIZE(clouds,1)
      plevm = plev-1
!---------------------------------------------------------
!        ... Modify lwc for cloud fraction and form
!            liquid water path for each layer
!---------------------------------------------------------
      where( clouds(:) /= 0. )
         del_lwp(:) = gi * lwc(:) * delp(:) * 1.e3 / clouds(:)
      elsewhere
         del_lwp(:) = 0.
      endwhere
!---------------------------------------------------------
!            ... Form tau for each model layer
!---------------------------------------------------------
      where( clouds(:) /= 0. )
         del_tau(:) = del_lwp(:) *.155 * clouds(:)**1.5
      elsewhere
         del_tau(:) = 0.
      end where
!---------------------------------------------------------
!            ... Form integrated tau from top down
!---------------------------------------------------------
      above_tau(1) = 0.
      do k = 1,plevm
         above_tau(k+1) = del_tau(k) + above_tau(k)
      end do
!---------------------------------------------------------
!            ... Form integrated tau from bottom up
!---------------------------------------------------------
      below_tau(plev) = 0.
      do k = plevm,1,-1
         below_tau(k) = del_tau(k+1) + below_tau(k+1)
      end do
!---------------------------------------------------------
!        ... Form vertically averaged cloud cover above and below
!---------------------------------------------------------
      above_cld(1) = 0.
      do k = 1,plevm
         above_cld(k+1) = clouds(k) * del_tau(k) + above_cld(k)
      end do
      do k = 2,plev
         if( above_tau(k) /= 0. ) then
            above_cld(k) = above_cld(k) / above_tau(k)
         else
            above_cld(k) = above_cld(k-1)
         end if
      end do
      below_cld(plev) = 0.
      do k = plevm,1,-1
         below_cld(k) = clouds(k+1) * del_tau(k+1) + below_cld(k+1)
      end do
      do k = plevm,1,-1
         if( below_tau(k) /= 0. ) then
            below_cld(k) = below_cld(k) / below_tau(k)
         else
            below_cld(k) = below_cld(k+1)
         end if
      end do
!---------------------------------------------------------
!        ... Modify above_tau and below_tau via jfm
!---------------------------------------------------------
      where( above_cld(2:plev) /= 0. )
         above_tau(2:plev) = above_tau(2:plev) / above_cld(2:plev)
      end where
      where( below_cld(:plevm) /= 0. )
         below_tau(:plevm) = below_tau(:plevm) / below_cld(:plevm)
      end where
      where( above_tau(2:plev) < 5. )
            above_cld(2:plev) = 0.
      end where
      where( below_tau(:plevm) < 5. )
         below_cld(:plevm) = 0.
      end where
!---------------------------------------------------------
!        ... Form transmission factors
!---------------------------------------------------------
      above_tra(:) = 11.905 / (9.524 + above_tau(:))
      below_tra(:) = 11.905 / (9.524 + below_tau(:))
!---------------------------------------------------------
!        ... Form effective albedo
!---------------------------------------------------------
      where( below_cld(:) /= 0. )
         eff_alb(:) = srf_alb + below_cld(:) * (1. - below_tra(:)) &
                                             * (1. - srf_alb)
      elsewhere
         eff_alb(:) = srf_alb
      end where
      coschi = max( coszen,.5 )
      where( del_lwp(:)*.155 < 5. )
         fac1(:) = 0.
      elsewhere
         fac1(:) = 1.4 * coschi - 1.
      end where
      fac2(:)     = MIN( 0.,1.6*coschi*above_tra(:) - 1. )
      cld_mult(:) = 1. + fac1(:) * clouds(:) + fac2(:) * above_cld(:)
      cld_mult(:) = MAX( .05,cld_mult(:) )

      end subroutine cloud_mod

      subroutine T_INT( p, t, t500, t200 )
!----------------------------------------------------------------
!        ... Interpolate for temperature on 500 and 200mb surfaces
!----------------------------------------------------------------


      implicit none

!----------------------------------------------------------------
!        ... Dummy args
!----------------------------------------------------------------
      real, intent(in)  ::  p(:)              ! pressure in pascals
      real, intent(in)  ::  t(:)              ! temperature on grid
      real, intent(out) ::  t500, t200        ! temp at 500 and 200mb

!----------------------------------------------------------------
!        ... Local variables
!----------------------------------------------------------------
      integer :: k, k1
      real    :: delp
      integer :: plev, plevp, plevm
      
      plev = SIZE(p)
      plevp = plev+1
      plevm = plev-1

      if( p(plev) < 500.e2 ) then
         t500 = t(plev)
         k1 = plevp
      else
         do k = plevm,1,-1
            if( p(k) < 500.e2 ) then
               k1 = k
               exit
            end if
         end do
         delp = LOG( 500.e2/p(k) ) / LOG( p(k+1)/p(k) )
         t500 = t(k) + delp * (t(k+1) - t(k))
      end if
      do k = k1-1,1,-1
         if( p(k) < 200.e2 ) then
            exit
         end if
      end do
      delp = LOG( 200.e2/p(k) ) / LOG( p(k+1)/p(k) )
      t200 = t(k) + delp * (t(k+1) - t(k))

      end subroutine T_INT

      subroutine PHOTO_INTERP( zin, cin, vin, albin, t500in, &
                               t200in, solar_phase, ajout )
!----------------------------------------------------------------------
!           ... Loglinear interpolation for the photodissociation rates
!            Note: this subroutine computes photorates for a vertical
!                  column at a given longitude and latitude
!           This routine uses a six parameter table via a Taylor
!           series expansion. 
!           Stacy Walters, Sep 30, 1996.  Changed code to strictly limit
!           the 200mb and 500mb temperature interpolation to the table
!           endpoints; i.e. no extrapolation beyond the table is allowed.
!----------------------------------------------------------------------


      implicit none

!----------------------------------------------------------------------
!        ... Dummy arguments
!----------------------------------------------------------------------
      real, intent(in)  ::   zin(:), &              ! geo height of midpoints
                             cin, &                 ! cosine solar zenith angle
                             vin(:), &              ! o3 column density
                             albin(:), &            ! surface albedo
                             t500in, &              ! temp on 500mb surface
                             t200in, &              ! temp on 200mb surface
                             solar_phase            ! phase of solar cycle (1=max, 0=min)
      real, intent(out) ::   ajout(:,:)             ! photodissociation rates

!----------------------------------------------------------------------
!        ... Local variables
!----------------------------------------------------------------------
      integer  ::  plev
      integer  ::  iz, is, iv, ial, nn, it500, it200
      integer  ::  izp1, isp1, ivp1, ialp1, it500p1, it200p1
      integer  ::  i, k
      integer  ::  izl
      integer, dimension(SIZE(zin)) :: altind, ratind, albind
      real     ::  wght0
      real     ::  v3std
      real     ::  dels(6)
      real, dimension(SIZE(zin)) :: v3rat
      real     :: ajout_tmp
!RSH ADD HERE:
      real    ::  ajl2(2,2,2,2,2,2)
      
      plev = SIZE(zin)

!----------------------------------------------------------------------
!        ... Find the zenith angle index ( same for all levels )
!----------------------------------------------------------------------
      do is = 1,zangdim
         if( vcos(is) > cin ) then
            exit
         end if
      end do
      is       = MAX( MIN( is,zangdim ) - 1,1 )
      isp1     = is + 1
      dels(2)  = MIN( 1.,MAX( 0.,(cin - vcos(is)) * delang(is) ) )
      if (dels(2) > 0.5) then
         dels(2) = 1. - dels(2)
         isp1 = is
         is   = isp1 + 1
      end if

!----------------------------------------------------------------------
!        ... Find the 500mb temp index ( same for all levels )
!----------------------------------------------------------------------
      do it500 = 1,t500dim
         if( t500(it500) > t500in ) then
            exit
         end if
      end do
      it500    = MAX( MIN( it500,t500dim ) - 1,1 )
      it500p1  = it500 + 1
      dels(5)  = MIN( 1.,MAX( 0.,(t500in - t500(it500)) * delt500(it500) ) )
      if (dels(5) > 0.5) then
         dels(5) = 1. - dels(5)
         it500p1  = it500
         it500    = it500p1 + 1
      end if

!----------------------------------------------------------------------
!        ... Find the 200mb temp index ( same for all levels )
!----------------------------------------------------------------------
      it200 = 1
      it200p1 = 2
      dels(6)  = MIN( 1.,MAX( 0.,(t200in - t200(it200)) * delt200(it200) )) 
      if (dels(6) > 0.5) then
         dels(6) = 1. - dels(6)
         it200    = 2
         it200p1  = 1
      end if

      izl = 1
      do k = plev,1,-1
!----------------------------------------------------------------------
!        ... Find albedo indicies
!----------------------------------------------------------------------
         do ial = 1,albdim
            if( albev(ial) > albin(k) ) then
               exit
            end if
         end do
         albind(k) = MAX( MIN( ial,albdim ) - 1,1 )
!----------------------------------------------------------------------
!        ... Find level indicies
!----------------------------------------------------------------------
         do iz = izl,altdim
            if( zz(iz) > zin(k) ) then
               izl = iz
               exit
            end if
         end do
         altind(k) = MAX( MIN( iz,altdim ) - 1,1 )
!----------------------------------------------------------------------
!        ... Find "o3 ratio" indicies
!----------------------------------------------------------------------
         i        = MAX( MIN( 79,INT( zin(k) ) ),0 )
         v3std    = vo3(i) + (zin(k) - REAL(i)) * delvo3(i)
         v3rat(k) = vin(k) / v3std
         do iv = 1,o3ratdim
            if( xv3(iv) > v3rat(k) ) then
               exit
            end if
         end do
         ratind(k) = MAX( MIN( iv,o3ratdim ) - 1,1 )
      end do
Vert_loop : &
      do k = 1,plev
!----------------------------------------------------------------------
!        ... Interval deltas and primary weight
!----------------------------------------------------------------------
         iz    = altind(k)
         izp1  = iz + 1
         dels(1)  = MIN( 1.,MAX( 0.,(zin(k) - zz(iz)) * delz(iz) ) )
         if (dels(1) > 0.5) then
            dels(1) = 1. - dels(1)
            izp1 = iz
            iz   = izp1 + 1
         end if
         iv    = ratind(k)
         ivp1  = iv + 1
         dels(3)  = MIN( 1.,MAX( 0.,(v3rat(k) - xv3(iv)) * delv(iv) ) )
         if (dels(3) > 0.5) then
            dels(3) = 1. - dels(3)
            ivp1 = iv
            iv   = ivp1 + 1
         end if
         ial   = albind(k)
         ialp1 = ial + 1
         dels(4)  = MIN( 1.,MAX( 0.,(albin(k) - albev(ial)) * delalb(ial) ) )
         if (dels(4) > 0.5) then
            dels(4) = 1. - dels(4)
            ialp1 = ial
            ial   = ialp1 + 1
         end if
         wght0    = 1. - SUM( dels )
Rate_loop : &
         do nn = 1,jdim
            ajout(nn,k) = wght0     * ajl(nn,iz,is,iv,ial,it500,it200) &
                          + dels(1) * ajl(nn,izp1,is,iv,ial,it500,it200) &
                          + dels(2) * ajl(nn,iz,isp1,iv,ial,it500,it200) &
                          + dels(3) * ajl(nn,iz,is,ivp1,ial,it500,it200) &
                          + dels(4) * ajl(nn,iz,is,iv,ialp1,it500,it200) &
                          + dels(5) * ajl(nn,iz,is,iv,ial,it500p1,it200) &
                          + dels(6) * ajl(nn,iz,is,iv,ial,it500,it200p1)
            ajl2(:,:,:,:,:,:) = ajl(nn,(/iz,izp1/),(/is,isp1/),(/iv,ivp1/),(/ial,ialp1/), &
                                    (/it500,it500p1/),(/it200,it200p1/))
            ajout(nn,k) = MAX( MIN( ajout(nn,k), MAXVAL(ajl2) ), MINVAL(ajl2) )
            ajout(nn,k) = EXP( ajout(nn,k) )
         end do Rate_loop
         if (use_solar_cycle .and. solar_phase /= 1.) then
            do nn = 1,jdim
               ajout_tmp = wght0     * ajl_solarmin(nn,iz,is,iv,ial,it500,it200) &
                           + dels(1) * ajl_solarmin(nn,izp1,is,iv,ial,it500,it200) &
                           + dels(2) * ajl_solarmin(nn,iz,isp1,iv,ial,it500,it200) &
                           + dels(3) * ajl_solarmin(nn,iz,is,ivp1,ial,it500,it200) &
                           + dels(4) * ajl_solarmin(nn,iz,is,iv,ialp1,it500,it200) &
                           + dels(5) * ajl_solarmin(nn,iz,is,iv,ial,it500p1,it200) &
                           + dels(6) * ajl_solarmin(nn,iz,is,iv,ial,it500,it200p1)
               ajl2(:,:,:,:,:,:) = ajl_solarmin(nn,(/iz,izp1/),(/is,isp1/),(/iv,ivp1/),(/ial,ialp1/), &
                                                (/it500,it500p1/),(/it200,it200p1/))
               ajout_tmp = MAX( MIN( ajout_tmp, MAXVAL(ajl2) ), MINVAL(ajl2) )
               ajout_tmp = EXP( ajout_tmp )
               ajout(nn,k) = ajout(nn,k) + (ajout_tmp-ajout(nn,k)) * (1.-solar_phase)
               ajout(nn,k) = MAX(ajout(nn,k),0.)
            end do
         end if
      end do Vert_loop

      end subroutine PHOTO_INTERP

      subroutine set_ub_col( col_delta, vmr, invariants, pdel, ptop, plonl )
!---------------------------------------------------------------
!        ... Set the column densities at the upper boundary
!---------------------------------------------------------------

      use CHEM_MODS_MOD, only : ncol_abs

      implicit none

!---------------------------------------------------------------
!        ... Dummy args
!---------------------------------------------------------------
      integer, intent(in) ::  plonl
      real, intent(out)   ::  col_delta(:,0:,:)  ! /cm**2
      real, intent(in)    ::  vmr(:,:,:), &               ! xported species vmr
                              invariants(:,:,:), &        ! invariant species
                              pdel(:,:), &                ! pressure thickness of model layers (Pa)
                              ptop(:)                     ! model top pressure (Pa)

!---------------------------------------------------------------
!        NOTE: xfactor = 10.*R/(K*g) in cgs units.
!              The factor 10. is to convert pdel
!              from pascals to dyne/cm**2.
!---------------------------------------------------------------
      real, parameter :: pa_to_dyncm2 = 10. !unit = (dyn/cm2)/pa
      real, parameter :: mw_air = 28.9644   !g/mole
      real, parameter :: grav = 981.         !cm/s2
      real, parameter :: navo = 6.023e23   ! molec/mole
      real, parameter :: xfactor = pa_to_dyncm2 * navo /(grav * mw_air)
      integer :: k, spc_ndx
      integer :: plev
      
      plev = SIZE(invariants,2)

!---------------------------------------------------------------
!        ... Assign column density at the upper boundary
!            The first column is O3 and the second is O2.
!            Add O3 column above top of model.
!---------------------------------------------------------------
      spc_ndx = ox_ndx
      if( spc_ndx < 1 ) then
         spc_ndx = o3_ndx
      end if
      if( spc_ndx > 0 ) then
         col_delta(:,0,1) = 2.687e16*o3_column_top
         do k = 1,plev
            col_delta(:,k,1) = xfactor * pdel(:,k) * vmr(:,k,spc_ndx) ! O3
         end do
      end if
!     col_delta(:,0,2) = 2.8e22
      col_delta(:,0,2) = xfactor * ptop(:) * invariants(:,plev,3)/invariants(:,plev,1)
      do k = 1,plev
         col_delta(:,k,2) = xfactor * pdel(:,k) * invariants(:,k,3)/invariants(:,k,1) ! O2
      end do

      end subroutine set_ub_col

      subroutine setcol( col_delta, col_dens, pdel, plonl )
!---------------------------------------------------------------
!             ... Set the column densities
!---------------------------------------------------------------

      use CHEM_MODS_MOD, only : ncol_abs

      implicit none

!---------------------------------------------------------------
!             ... Dummy arguments
!---------------------------------------------------------------
      integer, intent(in) :: plonl
!     real, intent(in)  ::   vmr(plonl,plev,pcnstm1)           ! xported species vmr
      real, intent(in)  ::   pdel(:,:)                         ! delta about midpoints
      real, intent(in)  ::   col_delta(:,0:,:)                 ! layer column densities (molecules/cm^2)
      real, intent(out) ::   col_dens(:,:,:)                   ! column densities ( /cm**2 )

!---------------------------------------------------------------
!        The local variables
!---------------------------------------------------------------
      integer  ::   k, km1      ! alt indicies
      integer  ::   spc_ndx
      integer  ::   plev
      
!---------------------------------------------------------------
!        NOTE: xfactor = 10.*R/(K*g) in cgs units.
!              The factor 10. is to convert pdel
!              from pascals to dyne/cm**2.
!---------------------------------------------------------------
!     real, parameter :: xfactor = 2.8704e21/(9.80616*1.38044)

      plev = SIZE(pdel,2)

!---------------------------------------------------------------
!           ... Compute column densities down to the
!           current eta index in the calling routine.
!           The first column is O3 and the second is O2.
!---------------------------------------------------------------
      spc_ndx = ox_ndx
      if( spc_ndx < 1 ) then
         spc_ndx = o3_ndx
      end if
      if( spc_ndx > 0 ) then
         col_dens(:,1,1) = col_delta(:,0,1) + .5 * col_delta(:,1,1)
         do k = 2,plev
            km1 = k - 1
            col_dens(:,k,1) = col_dens(:,km1,1) + .5 * (col_delta(:,km1,1) + col_delta(:,k,1))
         end do
      end if
      col_dens(:,1,2) = col_delta(:,0,2) + .5 * col_delta(:,1,2)
      do k = 2,plev
         km1 = k - 1
         col_dens(:,k,2) = col_dens(:,km1,2) + .5 * (col_delta(:,km1,2) + col_delta(:,k,2))
      end do

      end subroutine SETCOL


      real function SUNDIS( Time )
!-----------------------------------------------------------------------------
!=  PURPOSE:                                                                 =*
!=  Calculate Earth-Sun distance variation for a given date.  Based on       =*
!=  Fourier coefficients originally from:  Spencer, J.W., 1971, Fourier      =*
!=  series representation of the position of the sun, Search, 2:172          =*
!-----------------------------------------------------------------------------*
!=  PARAMETERS:                                                              =*
!=  IDATE  - INTEGER, specification of the date, from YYMMDD              (I)=*
!=  ESRM2  - REAL, variation of the Earth-sun distance                    (O)=*
!=           ESRM2 = (average e/s dist)^2 / (e/s dist on day IDATE)^2        =*
!-----------------------------------------------------------------------------*
!=  EDIT HISTORY:                                                            =*
!=  01/95  Changed computation of trig function values                       =*
!-----------------------------------------------------------------------------*
!= This program is free software;  you can redistribute it and/or modify     =*
!= it under the terms of the GNU General Public License as published by the  =*
!= Free Software Foundation;  either version 2 of the license, or (at your   =*
!= option) any later version.                                                =*
!= The TUV package is distributed in the hope that it will be useful, but    =*
!= WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHANTIBI-  =*
!= LITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public     =*
!= License for more details.                                                 =*
!= To obtain a copy of the GNU General Public License, write to:             =*
!= Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.   =*
!-----------------------------------------------------------------------------*
!= To contact the authors, please mail to:                                   =*
!= Sasha Madronich, NCAR/ACD, P.O.Box 3000, Boulder, CO, 80307-3000, USA  or =*
!= send email to:  sasha@ucar.edu                                            =*
!-----------------------------------------------------------------------------*
!= Copyright (C) 1994,95,96  University Corporation for Atmospheric Research =*
!-----------------------------------------------------------------------------


      implicit none

!-----------------------------------------------------------------------------
!        ... Dummy arguments
!-----------------------------------------------------------------------------
      type(time_type), intent(in) :: Time             ! time

!-----------------------------------------------------------------------------
!        ... Local variables
!-----------------------------------------------------------------------------
      integer :: iyear, imonth, iday, ihour, iminute, isecond
      integer :: mday, month, jday
      integer, save :: imn(12) = (/ 31,28,31,30,31,30,31,31,30,31,30,31 /)
      real    :: dayn, thet0
      real    :: sinth, costh, sin2th, cos2th
      character(len=128) :: msg
      
!-----------------------------------------------------------------------------
!         ... Parse date to find day number (Julian day)
!-----------------------------------------------------------------------------
      call get_date( Time, iyear, imonth, iday, ihour, iminute, isecond )
      if( imonth > 12 ) then
         write(msg,*) 'Month in date exceeds 12, month = ',imonth
         call endrun(msg)
      end if

      if( MOD(iyear,4) == 0 ) then
         imn(2) = 29
      else
         imn(2) = 28
      end if

      if( iday > imn(imonth) ) then
         write(msg,*) 'Day in date exceeds days in month, day = ',iday,', month = ',imonth
         call endrun(msg)
      end if

      mday = 0
      do month = 1,imonth-1
         mday = mday + imn(month)                     
      end do
      jday = mday + iday
      dayn = REAL(jday - 1) + .5

!-----------------------------------------------------------------------------
!         ... Define angular day number and compute esrm2:
!-----------------------------------------------------------------------------
      thet0 = 2.*PI*dayn/365.

!-----------------------------------------------------------------------------
!         ... Calculate SIN(2*thet0), COS(2*thet0) 
!-----------------------------------------------------------------------------
      sinth   = SIN( thet0 )
      costh   = COS( thet0 )
      sin2th  = 2.*sinth*costh
      cos2th  = costh*costh - sinth*sinth
      SUNDIS  = 1.000110 + .034221*costh  +  .001280*sinth + .000719*cos2th +  .000077*sin2th

      end function SUNDIS


      subroutine endrun(msg)

      character(len=128), intent(in) :: msg
      call mpp_error(FATAL, msg)
      
      end subroutine endrun        

      end module MO_PHOTO_MOD

module ocean_sponges_eta_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov.au"> Paul Sandery
!</CONTACT>
!
!<OVERVIEW>
! Weighted eta tendency [meter*meter/sec] from sponges.
!</OVERVIEW>
!
!<DESCRIPTION>
!
! This module applies sponge to eta. The sponges
! can occur at any location and with any distribution in the domain, and
! with any time step and damping rate.  Sponges occur where positive
! inverse restore times occur in the field passed to sponge_init.  An
! array of eta tendencies due to the sponges is augmented through a
! call to sponge_eta_source.  The array of eta tendencies must be
! reset to zero between calls.
!
! Different damping rates can be specified by making
! calls to register_sponge_rate - no sponges are applied to fields for
! which uniformly zero inverse damping rates are set with a call to
! register_sponge_rate.  The value towards which a field is damped is
! set with calls to register_sponge_field; successive calls are used to
! set up linear interpolation of this restore rate.
!
! Sponge data and damping coefficients are 2 dimensional. 
!
! The user is responsible for providing (and registering) the data on
! the model grid of values towards which the etas are being driven.
!
!</DESCRIPTION>
!
!<NAMELIST NAME="ocean_sponges_eta_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  For using this module.  Default use_this_module=.false.
!  </DATA> 
!
!  <DATA NAME="damp_coeff_3d" TYPE="logical">
!  For case when damping coefficients are full 3d field of values.
!  Default damp_coeff_3d=.false., which means damping coeffs are 
!  2d horizontal array.   
!  </DATA> 
!
!</NAMELIST>
!
use diag_manager_mod,         only: register_diag_field
use fms_mod,                  only: write_version_number, open_namelist_file, close_file
use fms_mod,                  only: file_exist
use fms_mod,                  only: open_namelist_file, check_nml_error, close_file
use fms_mod,                  only: read_data, lowercase, FATAL, WARNING, stdout, stdlog
use mpp_mod,                  only: input_nml_file, mpp_sum, mpp_error, mpp_max
use mpp_domains_mod,          only: mpp_global_sum
use time_interp_external_mod, only: init_external_field, time_interp_external
use time_manager_mod,         only: time_type, set_date, get_time
use time_manager_mod,         only: operator( + ), operator( - ), operator( // )
use time_manager_mod,         only: operator( > ), operator( == ), operator( <= )

use ocean_domains_mod,        only: get_local_indices
use ocean_parameters_mod,     only: missing_value, rho0 
use ocean_types_mod,          only: ocean_domain_type, ocean_grid_type, ocean_options_type
use ocean_types_mod,          only: ocean_time_type, ocean_External_mode_type
use ocean_workspace_mod,      only: wrk1_2d, wrk2_2d
use ocean_util_mod,           only: diagnose_2d

implicit none

private

#include <ocean_memory.h>

type ocean_sponge_type
   integer :: id                                             ! time_interp_external index
   character(len=32) :: name                                 ! eta name corresponding to sponge
   real, dimension(:,:)  , pointer :: damp_coeff2d => NULL() ! 2d inverse damping rate (eta units/ sec)
end type ocean_sponge_type

type(ocean_sponge_type), allocatable, dimension(:) :: Sponge
type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

public ocean_sponges_eta_init
public sponge_eta_source

character(len=126)  :: version = '$Id: ocean_sponges_eta.F90,v 20.0 2013/12/14 00:16:22 fms Exp $'
character (len=128) :: tagname = '$Name: tikal $'

! for diagnostics 
logical :: used
integer, dimension(:), allocatable :: id_sponge_tend
logical :: module_is_initialized = .false.
logical :: use_this_module       = .false. 

! Adaptive restoring
real    :: athresh               = 0.5
real    :: npower                = 1.0
real    :: sdiffo                = 0.5
real    :: lambda                = 0.0083
real    :: taumin                = 720
logical :: use_adaptive_restore  = .false.
logical :: use_sponge_after_init = .false.
logical :: use_normalising       = .false.
logical :: use_hard_thump        = .false.
integer :: days_to_restore       = 1
integer :: secs_to_restore       = 0

integer :: secs_restore
integer :: initial_day, initial_secs

namelist /ocean_sponges_eta_nml/ use_this_module 
namelist /ocean_sponges_eta_ofam_nml/ &
    use_adaptive_restore, use_sponge_after_init, use_normalising, &
    use_hard_thump, athresh, taumin, lambda, npower, days_to_restore, &
    secs_to_restore

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_sponges_eta_init">
!
! <DESCRIPTION>
! This subroutine is intended to be used to initialize the sponges.
! Everything in this subroutine is a user prototype, and should be replacable.
! </DESCRIPTION>
!
subroutine ocean_sponges_eta_init(Grid, Domain, Time, dtime, Ocean_options)

  type(ocean_grid_type),          intent(in), target :: Grid
  type(ocean_domain_type),        intent(in), target :: Domain
  type(ocean_time_type),          intent(in)         :: Time
  real,                           intent(in)         :: dtime
  type(ocean_options_type),       intent(inout)      :: Ocean_options

  integer :: i, j
  integer :: ioun, io_status, ierr
  integer :: secs, days
  real    :: dtimer

  character(len=128) :: name

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_sponges_eta_mod (ocean_sponges_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.

  allocate( Sponge(1) )

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
  read(input_nml_file, nml=ocean_sponges_eta_nml, iostat=io_status)
  ierr = check_nml_error(io_status, 'ocean_sponges_eta_nml')
  read(input_nml_file, nml=ocean_sponges_eta_ofam_nml, iostat=io_status)
  ierr = check_nml_error(io_status, 'ocean_sponges_eta_ofam_nml')
#else
  ioun =  open_namelist_file()
  read(ioun, ocean_sponges_eta_nml, IOSTAT=io_status)
  ierr = check_nml_error(io_status, 'ocean_sponges_eta_nml')
  rewind(ioun)
  read(ioun, ocean_sponges_eta_ofam_nml, IOSTAT=io_status)
  ierr = check_nml_error(io_status, 'ocean_sponges_eta_nml')
  call close_file (ioun)
#endif
  write (stdlogunit, ocean_sponges_eta_nml)
  write (stdoutunit, '(/)')
  write (stdoutunit, ocean_sponges_eta_nml)

  write (stdlogunit, ocean_sponges_eta_ofam_nml)
  write (stdoutunit, '(/)')
  write (stdoutunit, ocean_sponges_eta_ofam_nml)

  Dom => Domain
  Grd => Grid

#ifndef MOM_STATIC_ARRAYS    
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
#endif

  Sponge(1)%id = -1
  dtimer = 1.0/dtime

  if(use_this_module) then
      write(stdoutunit,*)'==>Note from ocean_sponges_eta_mod: Using this module.'
      Ocean_options%ocean_sponges_eta= 'Used ocean eta sponges.'
  else
      write(stdoutunit,*)'==>Note from ocean_sponges_eta_mod: NOT using this module.'
      Ocean_options%ocean_sponges_eta= 'Did NOT use ocean eta sponges.'
      return
  endif

  ! Set up some initial times
  call get_time(Time%model_time, secs, days)
  initial_day = days
  initial_secs = secs

  !read damping rates for eta
  if (use_adaptive_restore) then
     allocate(Sponge(1)%damp_coeff2d(isd:ied, jsd:jed))
     Sponge(1)%damp_coeff2d(:,:) = 0.0
  else
     name = 'INPUT/eta_sponge_coeff.nc'
     if (file_exist(name)) then
        write(stdoutunit,*) '==> Using sponge damping times specified from file ',name
        allocate(Sponge(1)%damp_coeff2d(isd:ied,jsd:jed))
        Sponge(1)%damp_coeff2d(:,:) = 0.0
        call read_data(name,'coeff',Sponge(1)%damp_coeff2d,domain=Dom%domain2d,timelevel=1)

           do j=jsc,jec
              do i=isc,iec
                 if(Grd%tmask(i,j,1) == 0.0) then
                     Sponge(1)%damp_coeff2d(i,j) = 0.0
                 endif
              enddo
           enddo


        ! modify damping rates to allow restoring to be solved implicitly
        ! note: test values between zero and 4.0e-8 revert to damping rates defined above
           do j=jsc,jec
              do i=isc,iec
                 if (dtime*Sponge(1)%damp_coeff2d(i,j) > 4.0e-8) then
                     if (dtime*Sponge(1)%damp_coeff2d(i,j) > 37.0) then
                         Sponge(1)%damp_coeff2d(i,j) = dtimer
                     else
                         Sponge(1)%damp_coeff2d(i,j) = (1.0 - exp(-dtime*Sponge(1)%damp_coeff2d(i,j))) * dtimer
                     endif
                 else if (dtime*Sponge(1)%damp_coeff2d(i,j) <= 0.0) then
                     Sponge(1)%damp_coeff2d(i,j) = 0.0
                 endif
              enddo
           enddo

     endif  ! endif for fileexist 'INPUT/eta_sponge_coeff.nc'
  endif


  name = 'INPUT/eta_sponge.nc'
  if(file_exist(trim(name))) then
     Sponge(1)%id = init_external_field(name,'eta_t',domain=Domain%domain2d)
     if (Sponge(1)%id < 1) then
        if ( use_adaptive_restore ) then
          call mpp_error(FATAL,&
             '==>Error: in ocean_sponges_eta_mod: adaptive restoring is specified but sponge values are not')
        else
          call mpp_error(FATAL,&
             '==>Error: in ocean_sponges_eta_mod: damping rates are specified but sponge values are not')
        endif
     endif
     write(stdoutunit,*) '==> Using increment data specified from file '//trim(name)
  else
     write(stdoutunit,*) '==> '//trim(name)//' not found.  Increment not being applied '
  endif

  allocate (id_sponge_tend(1)) 
  id_sponge_tend = -1

  id_sponge_tend = register_diag_field ('ocean_model', 'eta_t_sponge_tend', &
     Grd%tracer_axes(1:2), Time%model_time, 'eta_t tendency due to sponge', &
     'm/s', missing_value=missing_value, range=(/-1.e10,1.e10/))


end subroutine ocean_sponges_eta_init
! </SUBROUTINE> NAME="ocean_sponges_init"


!#######################################################################
! <SUBROUTINE NAME="sponge_eta_source">
!
! <DESCRIPTION>
! This subroutine calculates thickness weighted and density weighted
! time tendencies due to damping by sponges or damping through adaptive
! restoring.
! </DESCRIPTION>
!
subroutine sponge_eta_source(Time, Ext_mode)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_external_mode_type), intent(inout) :: Ext_mode

  integer :: taum1, tau
  integer :: i, j
   
  real    :: sdiff, sum_val, adaptive_coeff
  integer :: secs, days, numsecs

  logical :: do_adaptive_restore = .false.  ! Only restore in specified time period.
  logical :: do_normal_restore = .false.    ! Only restore in specified time period.
  logical, save :: first_pass = .true.
  real, save :: num_surface_wet_cells

  if(.not. use_this_module) return 

  taum1 = Time%taum1
  tau   = Time%tau
  wrk1_2d = 0.0
  wrk2_2d = 0.0

  if (use_adaptive_restore) then
    if (first_pass) then
        num_surface_wet_cells = mpp_global_sum(Dom%domain2d, Grd%tmask(:,:,1))
    end if

    secs_restore = days_to_restore * 86400 + secs_to_restore
    sdiff = 0.0
    call get_time(Time%model_time, secs, days)
    numsecs = (days - initial_day) * 86400 + secs - initial_secs

    do_adaptive_restore = (numsecs < secs_restore)
    do_normal_restore = (.not. do_adaptive_restore) .and. use_sponge_after_init
  else
    do_normal_restore = .true.
  end if

  if (Sponge(1)%id > 0) then

    call time_interp_external(Sponge(1)%id, Time%model_time, wrk1_2d)

    if (do_adaptive_restore) then
        if (first_pass) then
           if (use_hard_thump) then
              do j = jsd, jed
                 do i = isd, ied
                       Ext_mode%eta_t(i, j, taum1) = wrk1_2d(i, j)
                       Ext_mode%eta_t(i, j, tau) = wrk1_2d(i, j)
                 end do
              end do
           end if

           wrk2_2d = abs(Ext_mode%eta_t(:,:,taum1) - wrk1_2d(:,:)) &
                     * Grd%tmask(:,:,1)
           sum_val = sum(wrk2_2d(isc:iec, jsc:jec))

           call mpp_sum(sum_val)
           sdiffo = sum_val / num_surface_wet_cells
           write (stdout(), *) 'mean eta_diff', sdiffo

           if (.not. use_normalising) then
              sdiffo = 1.0
           else
             sdiffo = maxval(wrk2_2d)
             call mpp_max(sdiffo)
             sdiffo = 1.01 * sdiffo
           end if

           first_pass = .false.
        end if

        ! Calculate idealised forcing tendency timescale for each timestep and
        ! array element
        do j = jsd, jed
           do i = isd, ied
              sdiff = abs(Ext_mode%eta_t(i, j, taum1) - wrk1_2d(i, j))
              sdiff = max(sdiff, 1e-9) !minimum tolerance
              adaptive_coeff = 1. / (taumin - (lambda * real(secs_restore)) &
                                     / (((sdiff / sdiffo)**npower) &
                                        * log(1 - athresh)))
              wrk2_2d(i,j) =  adaptive_coeff &
                              * (wrk1_2d(i, j) - Ext_mode%eta_t(i, j, taum1))
           end do
        end do

    else if (do_normal_restore) then
        do j = jsc, jec
           do i = isc, iec
              wrk2_2d(i,j) = Sponge(1)%damp_coeff2d(i, j) &
                             * (wrk1_2d(i, j) - Ext_mode%eta_t(i, j, taum1))
           end do
        end do
    end if

    do j = jsc, jec
        do i = isc, iec
            Ext_mode%source(i,j) = Ext_mode%source(i,j) + rho0 * wrk2_2d(i,j)
        end do
    end do
  end if

  call diagnose_2d(Time, Grd, id_sponge_tend(1), wrk2_2d(:,:))

  return

end subroutine sponge_eta_source
! </SUBROUTINE> NAME="sponge_eta_source"


end module ocean_sponges_eta_mod

#include <fms_platform.h>

! ============================================================================
! an "umbrella" module for all land-related modules
! ============================================================================

module land_model_mod

! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Christopher Milly
! </CONTACT> 

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Elena Shevliakova
! </REVIEWER>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Sergey Malyshev
! </REVIEWER>

! <OVERVIEW>
!   This module contains calls to the sub-models to calculate quantities
!   on the fast and slow time scales and update the boundary conditions and
!   tiling structure where necessary.
! </OVERVIEW>

! <DESCRIPTION>
!   The sub-models (soil and vegetation) are first called in top-bottom order
!   to evaluate the derivatives. Then they are called in bottom-top order to
!   finish the implicit calculations. On the upward pass, they have a chance
!   to update boundary values returned to the atmosphere. These calls are done
!   on the fast time scale to calculate the fluxes.
!
!   On the slow time scale, the land is updated and the boundary conditions
!   may be updated. The land boundary data is updated on the fast time scale 
!   without updating the tiling structure. The land boundary data for the
!   atmosphere is updated on the slow time scale and changes the tiling
!   structure, if necessary, as well as the albedo, drag coefficient and such.
!
!   The diagnostic horizontal axes for the land grid is initialized. All 
!   sub-models use them instead of creating their own. Also, NetCDF library 
!   messages are printed out, including file names and line numbers.
! </DESCRIPTION>


  ! things from other modules which are used in the interface part
  ! of the land module
  use time_manager_mod, only: time_type

  use mpp_domains_mod,  only: domain1D, domain2d, mpp_get_layout, mpp_define_layout, &
                              mpp_define_domains, mpp_get_compute_domain,            &
                              CYCLIC_GLOBAL_DOMAIN, mpp_get_compute_domains,         &
                              mpp_get_domain_components, mpp_get_pelist,             &
                              mpp_define_mosaic
  use mpp_domains_mod,  only: NULL_DOMAIN2D

  use fms_mod,          only: write_version_number, error_mesg, FATAL, NOTE, &
                              mpp_pe, mpp_npes, mpp_root_pe, &
                              mpp_clock_id, mpp_clock_begin, mpp_clock_end, &
                              clock_flag_default, CLOCK_COMPONENT, file_exist, &
                              field_size, read_data, field_exist, get_mosaic_tile_grid, &
                              set_domain, nullify_domain

  use vegetation_mod,   only: vegetation_type, vegetation_init, vegetation_end,       &
                              update_vegetation_fast_down, update_vegetation_fast_up, &
                              update_vegetation_slow, update_vegetation_bnd_fast,     &
                              update_vegetation_bnd_slow, vegetation_stock_pe

  use soil_mod,         only: soil_type, soil_init, soil_end, update_soil_fast, &
                              update_soil_slow, update_soil_bnd_fast,           &
                              update_soil_bnd_slow, soil_stock_pe

  use land_types_mod,   only: land_data_type, allocate_boundary_data, &
                              atmos_land_boundary_type, deallocate_boundary_data, &
                              land_data_type_chksum, atm_lnd_bnd_type_chksum 

  use numerics_mod,     only: is_latlon

  use constants_mod,   only:  radius, hlf, hlv, tfreeze, pi 

  use diag_manager_mod, only: diag_axis_init, register_diag_field, send_data

  use field_manager_mod,  only: MODEL_LAND
  use tracer_manager_mod, only: register_tracers, get_tracer_index, NO_TRACER

  use mosaic_mod,         only: get_mosaic_ntiles, calc_mosaic_grid_area, &
                                get_mosaic_xgrid_size, get_mosaic_xgrid

implicit none
private


! ==== public interfaces =====================================================
public land_model_init          ! initialize the land model
public land_model_end           ! finish land model calculations
public land_model_restart       ! dummy routines
public update_land_model_fast   ! fast time-scale update of the land
public update_land_model_slow   ! slow time-scale update of the land

public Lnd_stock_pe             ! calculate and return total amount of requested quantitiy per PE
public land_data_type_chksum, atm_lnd_bnd_type_chksum
! ==== end of public interfaces ==============================================

! ==== public data type =====================================================
public land_type, land_data_type, atmos_land_boundary_type

! ==== generic interfaces ====================================================
! <INTERFACE NAME="land_model_init">
!   <OVERVIEW>
!     Initializes the state of the land model.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Initializes the land state in three ways. 1) The grid description file may
!      be used as an input. The land grid boundaries and area of land are read from
!      a grid description file. 2) A logical land mask may be used to calculate the
!      area of the grid cells where the mask is true and calls init_land_with_area.
!      Naturally, in this case there are no partly covered land cells -- every cell
!      is either land or ocean. 3) The land state may be initialized from the land area
!      for each of the grid points.
!   </DESCRIPTION>
interface land_model_init
   module procedure init_land_with_area
   module procedure init_land_with_xgrid
end interface
! </INTERFACE>


! <TYPE NAME="land_type">
!   <DESCRIPTION>
!     The type describing the state of the land model. It is private to this
!     module and is basically a remnant of the previous design. There is only one
!     variable of this type, called "theLand", which is used in the model to
!     hold the data.
!     Strictly speaking, this type is not necessary, but there is no harm in
!     having it and it is possible to image a situation where a single entity
!     describing the land-surface model state would be useful.
!   </DESCRIPTION>
type land_type

   private  ! it's an opaque type: all data members are private
   
!   <DATA NAME="domain" TYPE="domain2d" DIM="2">
!     Domain of calculations
!   </DATA>
!   <DATA NAME="is" TYPE="integer">
!     Domain bound
!   </DATA>
!   <DATA NAME="ie" TYPE="integer">
!     Domain bound
!   </DATA>
!   <DATA NAME="js" TYPE="integer">
!     Domain bound
!   </DATA>
!   <DATA NAME="je" TYPE="integer">
!     Domain bound
!   </DATA>
!   <DATA NAME="n_tiles" TYPE="integer">
!     Domain bound
!   </DATA>
   type(domain2d)         :: domain     ! domain of calculations
   integer :: is,ie,js,je,n_tiles       ! domain bounds, for convenience

!   <DATA NAME="soil" TYPE="soil_type">
!     Soil component data
!   </DATA>
!   <DATA NAME="vegetation" TYPE="vegetation_type">
!     Vegetation component data
!   </DATA>
   type(soil_type)        :: soil       ! soil component data
   type(vegetation_type)  :: vegetation ! vegetation component data

   ! the values below is just a quick fix to start running Land with original
   ! exchange grid, since it assumes something like that to be present. It also 
   ! assumes the number of tiles to be fixed.
   !   Of course, in general case there is no such thing as "latitude/longitude"
   ! boundaries of the cell, since cell boundaries do not have to be parallel
   ! to the lat/lon coordinate axes

!   <DATA NAME="blon" TYPE="real, pointer" DIM="2">
!     Longitude domain corners
!   </DATA>
!   <DATA NAME="blat" TYPE="real, pointer" DIM="2">
!     Latitude domain corners
!   </DATA>
!   <DATA NAME="mask" TYPE="logical, pointer" DIM="2">
!     Land mask, true where there is land
!   </DATA>
   real, _ALLOCATABLE          :: blon(:,:) _NULL  ! longitude corners of our domain
   real, _ALLOCATABLE          :: blat(:,:) _NULL  ! latitude corners of our domain 
   logical, _ALLOCATABLE       :: mask(:,:) _NULL  ! land mask (true where ther is some land)

end type land_type
! </TYPE>


! ==== some names, for information only ======================================
logical                       :: module_is_initialized = .FALSE.
character(len=*),   parameter :: module_name = 'land_mod'
character(len=128), parameter :: version     = '$Id: land_model.F90,v 19.0 2012/01/06 20:38:57 fms Exp $'
character(len=128), parameter :: tagname     = '$Name: tikal $'


! ==== local module variables ================================================
integer                 :: n_tiles = 1  ! number of tiles
type(land_type),save    :: theLand  ! internal state of the model
integer :: landClock
integer :: isphum ! number of specific humidity in the tracer array, or NO_TRACER

integer :: id_lprec = -1, id_fprec = -1, id_lwnet = -1, id_swdown = -1, id_t_surf = -1, id_wind = -1
integer :: id_qflux = -1, id_dedq = -1, id_q_ca = -1, id_evap_surf = -1

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-


! <SUBROUTINE NAME="init_land_with_xgrid" INTERFACE="land_model_init">
!   <OVERVIEW>
!     Initializes the land model
!   </OVERVIEW>
!   <DESCRIPTION>
!     The state of the land model is initialized using the grid description
!     file as an input. This routine reads land grid corners and area of
!     land from a grid description file.
!   </DESCRIPTION>
!   <PUBLICROUTINE INTERFACE="land_model_init">
subroutine init_land_with_xgrid &
     (atmos2land, bnd, time_init, time, dt_fast, dt_slow, &
#ifdef LAND_GRID_FROM_ATMOS
      glonb, glatb, &
#endif
      atmos_domain)

  type(atmos_land_boundary_type), intent(inout) :: atmos2land ! land boundary data
  type(land_data_type), intent(inout) :: bnd ! land boundary data
  type(time_type), intent(in)    :: time_init ! initial time of simulation (?)
  type(time_type), intent(in)    :: time      ! current time
  type(time_type), intent(in)    :: dt_fast   ! fast time step
  type(time_type), intent(in)    :: dt_slow   ! slow time step
#ifdef LAND_GRID_FROM_ATMOS
  real,            intent(in)    :: glonb(:,:), glatb(:,:)
  type(domain2d),  intent(in), target :: atmos_domain ! domain of computations
#else
  type(domain2d),  intent(in), optional :: atmos_domain ! domain of computations
#endif
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
#ifndef LAND_GRID_FROM_ATMOS
  real, allocatable :: glonb(:,:)   ! lon corners of global grid
  real, allocatable :: glatb(:,:)   ! lat corners of global grid
#endif
  real, allocatable :: glon(:,:)    ! lon centers of global grid
  real, allocatable :: glat(:,:)    ! lat centers of global grid
  real, allocatable :: gfrac    (:,:) ! fraction of land in cells
  real, allocatable :: gcellarea(:,:) ! area of land cells
  real, allocatable :: tmpx(:,:), tmpy(:,:)
  real, allocatable :: tmp_latb(:), tmp_lat(:)
  real, allocatable :: geo_lonv(:,:)
  real, allocatable :: geo_latv(:,:)
  real, allocatable :: xgrid_area(:)
  integer, allocatable :: i1(:), j1(:)
  integer, allocatable :: i2(:), j2(:)

  integer :: nlonb, nlatb  ! number of the cell bounds in lon and lat directions
  integer :: nlon,  nlat   ! number of cells in lon and lat directions
  integer :: siz(4)        ! used to store field size
  integer,save :: ntiles=1 ! number of tiles in land mosaic, should be 1 or 6.
  integer :: nfile_axl     ! number of atmosXland exchange grid file. Can be more than one.
  integer :: nxgrid        ! number of exchange grid cell.
  integer :: i, j, n, m, tile, ind, digit

  character(len=256) :: grid_file   = "INPUT/grid_spec.nc"
  character(len=256) :: tile_file
  character(len=256) :: land_mosaic   ! land mosaic file
  character(len=256) :: axl_file      ! atmosXland exchange grid file

  ! [1] get land grid corners and area of land from the grid description file
  ! open grid description file
  ! for mosaic grid, grid area will be calculated based on exchange grid and grid cell.
  
#ifndef LAND_GRID_FROM_ATMOS
  write(*,*) 'SP1 grid_file', grid_file
  if( field_exist(grid_file, 'AREA_LND') ) then
     call field_size( grid_file, 'AREA_LND', siz)
     nlon = siz(1)
     nlat = siz(2)
     nlonb = nlon + 1
     nlatb = nlat + 1
     ! allocate data for longitude and latitude bounds
     allocate( glonb(nlonb,nlatb), glatb(nlonb,nlatb), glon(nlon,nlat), glat(nlon,nlat),&
               gcellarea(nlon,nlat), gfrac(nlon,nlat), tmp_lat(nlat), tmp_latb(nlatb) )
     ! read coordinates of grid cell vertices
     call read_data(grid_file, "xbl", glonb(:,1), no_domain=.true.)
     call read_data(grid_file, "ybl", tmp_latb, no_domain=.true.)
     do j = 2, nlatb
        glonb(:,j) = glonb(:,1)
     enddo
     do i = 1, nlonb
        glatb(i,:) = tmp_latb(:)
     enddo

     ! read coordinates of grid cell centers
     call read_data(grid_file, "xtl", glon(:,1), no_domain=.true.)
     call read_data(grid_file, "ytl", tmp_lat(:), no_domain=.true.)
     do j = 2, nlat
        glon(:,j) = glon(:,1)
     enddo
     do i = 1, nlon
        glat(i,:) = tmp_lat(:)
     enddo

     ! read land area, land cell area and calculate the fractional land coverage 
     call read_data(grid_file, "AREA_LND_CELL", gcellarea, no_domain=.true.)
     call read_data(grid_file, "AREA_LND",      gfrac,     no_domain=.true.)
     ! calculate land fraction
     gfrac     = gfrac/gcellarea
     ! convert relative area to absolute value, m2
     gcellarea = gcellarea*4*pi*radius**2
  else if( field_exist(grid_file, 'lnd_mosaic_file') ) then ! read from mosaic file
     call read_data(grid_file, "lnd_mosaic_file", land_mosaic)     
     land_mosaic = "INPUT/"//trim(land_mosaic)
     ntiles = get_mosaic_ntiles(land_mosaic)
     tile = 1
     if (ntiles .EQ. 1) then ! lat-lon case
        call read_data (land_mosaic, "gridfiles", tile_file)
        tile_file = 'INPUT/'//trim(tile_file)
     else if (ntiles .EQ. 6) then ! cubed-sphere case
        if (present(atmos_domain)) then
           ! assumes the atmos domain has 6 tiles (probably need to check)
           call get_mosaic_tile_grid (tile_file, land_mosaic, atmos_domain)
        else
           if (mod(mpp_npes(),ntiles) .NE. 0) call error_mesg('land_model_init', &
                       'Number of processors must be a multiple of 6', FATAL)
           tile = ntiles*mpp_pe()/mpp_npes() + 1  ! assumption
           call read_data (land_mosaic, "gridfiles", tile_file, level=tile)
           tile_file = 'INPUT/'//trim(tile_file)
        endif
     else
        call error_mesg('land_model_init',  &
           ' ntiles should be 1 or 6 for land mosaic, contact developer', FATAL)
     endif
     call field_size(tile_file, "x", siz)
     if( mod(siz(1)-1,2) .NE. 0) call error_mesg("land_model_init", "size(x,1) - 1 should be divided by 2", FATAL);
     if( mod(siz(2)-1,2) .NE. 0) call error_mesg("land_model_init", "size(x,2) - 1 should be divided by 2", FATAL);
     nlon = (siz(1)-1)/2
     nlat = (siz(2)-1)/2
     nlonb = nlon + 1
     nlatb = nlat + 1
     allocate( glonb(nlonb,nlatb), glatb(nlonb,nlatb), glon(nlon,nlat), glat(nlon,nlat),&
               gcellarea(nlon,nlat), gfrac(nlon,nlat) )
     !--- read the grid information on supergrid.
     allocate( tmpx(2*nlon+1, 2*nlat+1), tmpy(2*nlon+1, 2*nlat+1) )
     call read_data(tile_file, "x", tmpx, no_domain=.TRUE.)
     call read_data(tile_file, "y", tmpy, no_domain=.TRUE.)
     !--- make sure the grid is regular lat-lon grid.

     do j = 1, nlatb
     do i = 1, nlonb
        glonb(i,j) = tmpx(2*i-1,2*j-1)
        glatb(i,j) = tmpy(2*i-1,2*j-1)
     end do     
     end do     
     do j = 1, nlat
     do i = 1, nlon
        glon(i,j) = tmpx(2*i,2*j)
        glat(i,j) = tmpy(2*i,2*j)
     end do     
     end do     
     !--- land_cell_area will be calculated using the same way to calculate the area of xgrid.
     allocate(geo_lonv(nlonb,nlatb), geo_latv(nlonb,nlatb))
     do j = 1, nlatb
        do i = 1, nlonb
           geo_lonv(i,j) = glonb(i,j)*pi/180.0
           geo_latv(i,j) = glatb(i,j)*pi/180.0
        end do
     end do

     call calc_mosaic_grid_area(geo_lonv, geo_latv, gcellarea)
     deallocate(tmpx, tmpy, geo_lonv, geo_latv)

     !--- land area will be calculated based on exchange grid area.
     call field_size(grid_file, "aXl_file", siz)
     nfile_axl = siz(2)
     gfrac = 0
     do n = 1, nfile_axl
        call read_data(grid_file, "aXl_file", axl_file, level=n)
        if(ntiles .EQ. 6) then
          ind = index(axl_file, "land_mosaic_tile")
          if(ind ==0) call error_mesg('land_model_init', &
              'string land_mosaic_tile should contains in the field aXl_file in file '//trim(grid_file), FATAL )
          ind = ind + 16
          digit = ichar(axl_file(ind:ind)) - ichar('0')
          if( digit > 9 .OR. digit < 1) call error_mesg('land_model_init', &
              'The character following land_mosaic_tile in field aXl_file of file ' &
              //trim(grid_file)//' should be a positive integer', FATAL)
          if( tile .NE. digit ) cycle
        endif
        axl_file = 'INPUT/'//trim(axl_file)
        nxgrid = get_mosaic_xgrid_size(axl_file)
        allocate(i1(nxgrid), j1(nxgrid), i2(nxgrid), j2(nxgrid), xgrid_area(nxgrid))
        write(*,*) 'SP2 aXl_file', aXl_file
        ! sigh. get_mosaic_xgrid() eventually invokes read_compressed_2d,
        ! which insists on having a current_domain set. atmos_fv_physics sets
        ! its domain sometime before this land model init is invoked,
        ! but that appears somehow inapropriate.
        ! atmos_aeolus does not invoke set_domain at all, so that this
        ! get_mosaic_xgrid crashes without current domain set.
        call set_domain(NULL_DOMAIN2D)
        call get_mosaic_xgrid(aXl_file, i1, j1, i2, j2, xgrid_area)
        write(*,*) 'SP2 finished aXl_file', aXl_file
        do m = 1, nxgrid
           i = i2(m); j = j2(m)
           gfrac(i,j) = gfrac(i,j) + xgrid_area(m)
        end do
        deallocate(i1, j1, i2, j2, xgrid_area)
     end do     
     gfrac = gfrac*4*PI*RADIUS*RADIUS/gcellarea
  else
     call error_mesg('land_model_init','both AREA_LND and lnd_mosaic_file do not exist in file '//trim(grid_file),FATAL)
  end if

  ! [2] convert lon and lat coordinates from degrees to radian
  glonb = glonb*pi/180.0
  glatb = glatb*pi/180.0
  glon  = glon*pi/180.0
  glat  = glat*pi/180.0

#else

! initialize grid info from input arguments
  nlonb = size(glonb,1)
  nlatb = size(glonb,2)
  nlon = nlonb-1
  nlat = nlatb-1
  allocate( glon(nlon,nlat), glat(nlon,nlat),&
            gcellarea(nlon,nlat), gfrac(nlon,nlat) )

! approximate coordinates of grid cell centers
  glon = (glonb(1:nlon,1:nlat)+glonb(2:nlon+1,1:nlat)+glonb(1:nlon,2:nlat+1)+glonb(2:nlon+1,2:nlat+1))/4.
  glat = (glatb(1:nlon,1:nlat)+glatb(2:nlon+1,1:nlat)+glatb(1:nlon,2:nlat+1)+glatb(2:nlon+1,2:nlat+1))/4.

! read land fraction from file (land=1)
! otherwise initialize with no land
  if (file_exist('INPUT/land_mask.nc')) then
     call read_data ('INPUT/land_mask.nc', 'land_mask', gfrac, no_domain=.true.) !, atmos_domain)
     where (gfrac > 0.5)
        gfrac = 1.0
     elsewhere
        gfrac = 0.0
     endwhere
  else
     gfrac = 0.0 ! aqua-planet
  endif

! uniform area
  gcellarea = 1./real(6*(nlonb-1)*(nlatb-1))
  ! convert relative area to absolute value, m2
  gcellarea = gcellarea*4*pi*radius**2

#endif

  ! [3] initialize the land model using the global grid we just obtained
  call init_land_with_area &
       ( atmos2land, bnd, glonb, glatb, gcellarea, gfrac, time, dt_fast, dt_slow, &
       atmos_domain, glon=glon, glat=glat, numtiles=ntiles )

  ! [4] deallocate memory that we are not going to use any more
#ifndef LAND_GRID_FROM_ATMOS
  deallocate ( glonb, glatb, glon, glat, gfrac, gcellarea )
#else
  deallocate ( glon, glat, gfrac, gcellarea )
#endif

!   <NOTE>
!     Theoretically, the grid description file can specify any regular
!     rectangular grid for land, not just lon/lat grid. Therefore the variables
!     "xbl" and "ybl" in NetCDF grid spec file are not necessarily lon and lat
!     boundaries of the grid.
!     However, at this time the module land_properties assumes that grid _is_
!     lon/lat and therefore the entire module also have to assume that the
!     land grid is lon/lat. lon/lat grid is also assumed for the diagnostics, 
!     but this is probably not so critical. 
!   </NOTE>
!Balaji: looks like this is the only public procedure under land_model_init
!        called from coupler_init
  landClock = mpp_clock_id( 'Land', flags=clock_flag_default, grain=CLOCK_COMPONENT )
!should also initialize subcomponent clocks for veg, hydro, etc. here
end subroutine init_land_with_xgrid
! </SUBROUTINE>


! <SUBROUTINE NAME="init_land_with_area" INTERFACE="land_model_init">
!   <OVERVIEW>
!     Initializes the land model
!   </OVERVIEW>
!   <DESCRIPTION>
!     Initializes the land state using land area for each of the grid points.
!   </DESCRIPTION>
!   <PUBLICROUTINE INTERFACE="land_model_init">
subroutine init_land_with_area &
     ( atmos2land, bnd, gblon, gblat, gcellarea, gfrac, time, dt_fast, dt_slow, domain, &
     glon, glat, numtiles )

  type(atmos_land_boundary_type), intent(inout) :: atmos2land ! land boundary data
  type(land_data_type), intent(inout) :: bnd        ! state to update
  real,              intent(in) :: gblon(:,:)! lon corners of the grid cells
  real,              intent(in) :: gblat(:,:)! lat corners of the grid cells
  real,              intent(in) :: gcellarea(:,:) ! full area of the grid cells
  real,              intent(in) :: gfrac(:,:)     ! fraction of land in the grid cell
  type(time_type),   intent(in) :: time    ! current time
  type(time_type),   intent(in) :: dt_fast ! fast time step
  type(time_type),   intent(in) :: dt_slow ! slow time step
  type(domain2d),    intent(in), optional :: domain  ! domain of computations
  real,              intent(in), optional :: glon(:,:), glat(:,:) ! centers
  integer,           intent(in), optional :: numtiles
                          ! of the grid cells
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer :: layout(2) ! layout of our domains
  integer :: nlon, nlat
  integer :: is,ie,js,je,k
  integer :: id_lon, id_lat  ! IDs of land diagnostic axes
  integer :: ntrace, ntprog, ntdiag, ntfamily ! numbers of tracers
  integer :: ntiles ! number of tiles for land mosaic

  module_is_initialized = .TRUE.

  ! write the version and tagname to the logfile
  call write_version_number(version, tagname)

! initialize tracers
#ifdef LAND_BND_TRACERS
  ! register land model tracers and find specific humidity
  call register_tracers ( MODEL_LAND, ntrace, ntprog, ntdiag, ntfamily )
  isphum = get_tracer_index ( MODEL_LAND, 'sphum' )
  if (isphum==NO_TRACER) then
     call error_mesg('land_model_init','no required "sphum" tracer',FATAL)
  endif
#else
  isphum = NO_TRACER
#endif

  ! get the size of the global grid
  nlon = size(gfrac, 1)
  nlat = size(gfrac, 2)
  ! number of land mosaic tiles
  ntiles = 1
  if (present(numtiles)) ntiles = numtiles
  if (mod(mpp_npes(),ntiles) .NE. 0) call error_mesg('land_model_init', &
      'Number of processors must be a multiple of number of mosaic tiles', FATAL)
  ! get the processor layout information, either from upper-layer module
  ! decomposition, or define according to the grid size
  if(present(domain)) then
     call mpp_get_layout (domain, layout)
  else
     call mpp_define_layout &
          ((/1,nlon, 1,nlat/),mpp_npes()/ntiles,layout)
  endif

  ! create our computation domain according to obtained processor layout 
  if (ntiles .EQ. 1) then
     call mpp_define_domains ( &
          (/1,nlon, 1, nlat/),           &  ! global grid size
          layout,                        &  ! layout for our domains
          theLand%domain,                &  ! domain to define
          xflags = CYCLIC_GLOBAL_DOMAIN, name = 'LAND MODEL' )
  else if (ntiles .EQ. 6) then
     call define_cube_mosaic ( theLand%domain, nlon, nlat, layout )
  else
     call error_mesg('land_model_init',  &
        'number of mosaic tiles should be 1 or 6', FATAL)
  endif

  ! get the size of our computation domain
  call mpp_get_compute_domain ( theLand%domain, is,ie,js,je )

  theLand%is=is; theLand%ie=ie; theLand%js=js; theLand%je=je
  theLand%n_tiles=n_tiles

  ! NOTE: the piece of code from here to the end of the subroutine should
  ! probably be revised to accommodate tiling structure. The problem is that
  ! it is theoretically possible that the soil and vegetation have different
  ! tiling, or there may be an additional sub-model with yet different tiling. 
  ! It is case it is not quite clear what does the "land tile" mean -- it may 
  ! be the tile of the uppermost land sub-model (since this is what atmosphere 
  ! sees) or it may be decart product of all the sub-model tiling structures, 
  ! just to name two possibilities.

  ! allocate fractional area for soil

  ! allocate storage for the boundary data 
  call allocate_boundary_data ( atmos2land, bnd, theLand%domain, n_tiles, ntprog )

  ! set up boundary values that we know already
  bnd % domain = theLand % domain
  do k = 1, size(bnd%tile_size,3)
     where (gfrac(is:ie,js:je)>0)
        bnd % tile_size (:,:,k) = 1.0/n_tiles
        bnd % mask      (:,:,k) = .true.
     elsewhere
        bnd % tile_size (:,:,k) = 0.0
        bnd % mask      (:,:,k) = .false.
     endwhere
  enddo

  ! init grid variables: this is a quick fix since it is not yet
  ! clear how to initialize land properties with arbitrary grid
  allocate(theLand%blon(is:ie+1,js:je+1), theLand%blat(is:ie+1,js:je+1), theLand%mask(is:ie,js:je))
  theLand%blon(:,:)   = gblon(is:ie+1,js:je+1)
  theLand%blat(:,:)   = gblat(is:ie+1,js:je+1)
  theLand%mask(:,:)   = any( bnd % mask, DIM=3 )

  ! initialize land diagnostics -- create diagnostic axes to be used by all
  ! diagnostic routine in submodules
  call init_land_diag ( time, gblon, gblat, theLand%domain, id_lon, id_lat, &
       glon=glon, glat=glat )
  bnd%axes = (/id_lon, id_lat/)

  ! initialize all submodules
  call soil_init ( theLand%soil, gblon, gblat, gcellarea, gfrac, &
       time, dt_fast, dt_slow, theLand%domain, bnd % tile_size, bnd % mask, &
       id_lon, id_lat )

  call vegetation_init ( &
       theLand%vegetation, gblon, gblat, gcellarea, gfrac, &
       time, dt_fast, dt_slow, theLand%domain, bnd % tile_size, bnd % mask, &
       id_lon, id_lat )

  ! update boundary conditions 
  call update_land_bnd_slow ( bnd )
  call update_land_bnd_fast ( bnd )

!   <NOTE>
!     NOTE: we assume every sub-model has the same domain layout and is on
!     the same grid, so we do not need to do general-case flux exchange
!     between them.
!   </NOTE>

end subroutine init_land_with_area
! </SUBROUTINE>



! <SUBROUTINE NAME="land_model_end">

!   <OVERVIEW>
!     Destructs the land model.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Destructs the land model and its sub-models. Deallocates the arrays
!     and the boundary exchange data 
!   </DESCRIPTION>

!   <TEMPLATE>
!     call land_model_end ( bnd )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine land_model_end ( atmos2land, bnd )
  type(atmos_land_boundary_type), intent(inout) :: atmos2land
  type(land_data_type), intent(inout) :: bnd        ! state to update
!   </PUBLICROUTINE>

  module_is_initialized = .FALSE.
  call soil_end ( theLand%soil )
  call vegetation_end ( theLand%vegetation )

  ! deallocate variables
  deallocate ( theLand%blon, theLand%blat, theLand%mask )

  ! deallocate boundary exchange data
  call deallocate_boundary_data ( atmos2land, bnd )
  
end subroutine land_model_end
! </SUBROUTINE>

subroutine land_model_restart(timestamp)
  character(*), intent(in), optional :: timestamp ! timestamp to add to the file name

    call error_mesg ('land_model_restart in land_model_mod', &
                     'intermediate restart capability is not implemented for this model', FATAL)

end subroutine land_model_restart

! <SUBROUTINE NAME="update_land_model_fast">

!   <OVERVIEW>
!     Updates the state of the land model on the fast time scale.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Updates the state of the land model on the fast time scale. To implement
!     implicit calculation scheme, first the land sub-models are called in
!     top-bottom general order to evaluate the derivatives; then they are
!     called in bottom-top order to finish implicit calculations. On the
!     upward pass they have a chance to update boundary values returned to
!     the atmosphere. After calculations, update the boundary conditions
!     visible to the atmosphere.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call update_land_model_fast( atmos2land, bnd )
!   </TEMPLATE>

!   <PUBLICROUTINE INTERFACE="">
subroutine update_land_model_fast ( atmos2land, bnd )

  type(atmos_land_boundary_type), intent(inout)    :: atmos2land ! quantities exchanged between
                                                              ! the atmosphere and the land
  type(land_data_type),  intent(inout) :: bnd ! state to update
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  real, dimension(theLand%is:theLand%ie, theLand%js:theLand%je, theLand%n_tiles) :: &
       q_flux, dedt     ! slm Mar 19 2002 
  integer :: used

  call mpp_clock_begin(landClock)
  call set_domain (theLand%domain)

  ! write out input data
  if (id_lprec > 0) used = send_data(id_lprec, atmos2land%lprec(:,:,1), theLand%soil%Time)
  if (id_fprec > 0) used = send_data(id_fprec, atmos2land%fprec(:,:,1), theLand%soil%Time)
  if (id_t_surf > 0) used = send_data(id_t_surf, bnd%t_surf(:,:,1), theLand%soil%Time)
  if (id_swdown > 0) used = send_data(id_swdown, atmos2land%sw_flux(:,:,1), theLand%soil%Time)
  ! possibly we need to use the sum of sw_flux_down_total_dir and sw_flux_down_total_dif
  ! instead to get total downwelling sw, not net
  if (id_lwnet > 0) used = send_data(id_lwnet, atmos2land%lw_flux(:,:,1), theLand%soil%Time)
  if (id_wind > 0) used = send_data(id_wind, atmos2land%wind(:,:,1), theLand%soil%Time)
#ifdef LAND_BND_TRACERS
  if (id_qflux > 0) used = send_data(id_qflux, atmos2land%tr_flux(:,:,1,isphum), theLand%soil%Time)
  if (id_dedq > 0) used = send_data(id_dedq, atmos2land%dfdtr(:,:,1,isphum), theLand%soil%Time)
#else
  if (id_qflux > 0) used = send_data(id_qflux, atmos2land%q_flux(:,:,1), theLand%soil%Time)
  if (id_dedq > 0) used = send_data(id_dedq, atmos2land%ddedq(:,:,1), theLand%soil%Time)
#endif
  if (id_q_ca > 0) used = send_data(id_q_ca, bnd%tr(:,:,1,isphum), theLand%soil%Time)

  call update_vegetation_fast_down (      &
       theLand%vegetation, theLand%soil,  &
#ifdef LAND_BND_TRACERS
       atmos2land%tr_flux(:,:,:,isphum),  &
       atmos2land%dfdtr(:,:,:,isphum),    &
#else
       atmos2land%q_flux,                 &
       atmos2land%dedq,                   &
#endif
       atmos2land%drag_q,                 &
       atmos2land%p_surf,                 &
       q_flux,  &
       dedt     )
  
  call update_soil_fast ( theLand%soil, &
       atmos2land%sw_flux, &
       atmos2land%lw_flux, &
       atmos2land%t_flux,  &
       q_flux,             &
       atmos2land%dhdt,    &
       dedt,               &
       atmos2land%drdt,    &
       atmos2land%lprec,   &
       atmos2land%fprec    )
  
  call update_vegetation_fast_up (        &
       theLand%vegetation, theLand%soil,  &
       atmos2land%drag_q,                 &
#ifdef LAND_BND_TRACERS
       atmos2land%tr_flux(:,:,:,isphum),  &
       atmos2land%dfdtr(:,:,:,isphum)     )
#else
       atmos2land%q_flux,                 &
       atmos2land%dedq                    )
#endif
  ! after calculations, update boundary conditions visible to the atmosphere
  call update_land_bnd_fast ( bnd )

  if (id_evap_surf > 0) used = send_data(id_evap_surf, q_flux(:,:,1), theLand%soil%Time)

  call nullify_domain()
  call mpp_clock_end(landClock)
end subroutine update_land_model_fast
! </SUBROUTINE>



! <SUBROUTINE NAME="update_land_model_slow">
!   <OVERVIEW>
!     Updates the state of the land model on the slow time scale.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Updates land, and boundary conditions if
!     necessary, on the slow time scale. 
!   </DESCRIPTION>
!   <TEMPLATE>
!     call update_land_model_slow( bnd )
!   </TEMPLATE>
!   <PUBLICROUTINE>
subroutine update_land_model_slow ( atmos2land, bnd )
  type(atmos_land_boundary_type), intent(inout) :: atmos2land
  type(land_data_type), intent(inout) :: bnd        ! state to update
!   </PUBLICROUTINE>

  call mpp_clock_begin(landClock)
  call set_domain (theLand%domain)
  call update_vegetation_slow(theLand%vegetation)
  call update_soil_slow(theLand%soil, theLand%blon, theLand%blat)

  ! update boundary conditions on slow time-scale, if necessary
  call update_land_bnd_slow ( bnd )
  call nullify_domain()
  call mpp_clock_end(landClock)

end subroutine update_land_model_slow
! </SUBROUTINE>


! <SUBROUTINE NAME="update_land_bnd_fast">
!   <OVERVIEW>
!     Updates land boundary data.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Updates land boundary data (the ones that atmosphere sees) on the
!     fast time scale. This routine does not update the tiling structure
!     because it is assumed that the tiling does not change on fast time
!     scale.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call update_land_bnd_fast ( bnd )
!   </TEMPLATE>
!   <PUBLICROUTINE>
subroutine update_land_bnd_fast ( bnd )

  type(land_data_type), intent(inout) :: bnd        ! state to update
!   </PUBLICROUTINE>

  call update_soil_bnd_fast ( theLand%soil, bnd )
  call update_vegetation_bnd_fast ( theLand%vegetation, bnd )

end subroutine update_land_bnd_fast
! </SUBROUTINE>


! <SUBROUTINE NAME="update_land_bnd_slow">
!   <OVERVIEW>
!     Updates the land boundary data for the atmosphere on the slow time scale.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Updates the land boundary data for the atmosphere on the slow time scale.
!     This subroutine is responsible for changing of the tiling structure, if
!     necessary, as well as for changing albedo, drag coefficients and such.     
!   </DESCRIPTION>
!   <TEMPLATE>
!     call update_land_bnd_slow ( bnd )
!   </TEMPLATE>
!   <PUBLICROUTINE>
subroutine update_land_bnd_slow ( bnd )

  type(land_data_type), intent(inout) :: bnd        ! state to update
!   </PUBLICROUTINE>

  call update_soil_bnd_slow ( theLand%soil, bnd )
  call update_vegetation_bnd_slow ( theLand%vegetation, bnd )

end subroutine update_land_bnd_slow
!   <NOTE>
!     If the tiling structure has been modified, then probably the
!     distribution of other boundary values, such as temperature and
!     surface humidity, should be modified too, not yet clear how.
!   </NOTE>
! </SUBROUTINE>

! ============================================================================
! calculate and return total amount of requested quantitiy per PE
subroutine Lnd_stock_pe(bnd,index,value)
  type(land_data_type), intent(in)  :: bnd
  integer             , intent(in)  :: index ! ID of the stock to calculate
  real                , intent(out) :: value ! calculated value of the stock

  real :: soil_value, vegn_value

  if(bnd%pe) then
    call       soil_stock_pe(theLand%soil,       index, soil_value)
    call vegetation_stock_pe(theLand%vegetation, index, vegn_value)
    value = soil_value+vegn_value
  else
    value = 0.0
  endif

end subroutine Lnd_stock_pe


! <SUBROUTINE NAME="init_land_diag">
!   <OVERVIEW>
!     Initializes the horizontal axes for the land grid.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Initialize the horizontal axes for the land grid so that all
!     submodules use them, instead of creating their own.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call init_land_diag(glonb, glatb, domain, id_lon, id_lat)
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine init_land_diag(time, glonb, glatb, domain, id_lon, id_lat, glon, glat)

  type(time_type), intent(in):: time
  real, intent(in)           :: glonb(:,:), glatb(:,:) ! longitude and latitude corners of grid
                                                       ! cells, specified for the global grid
                                                       ! (not only domain)
  type(domain2d), intent(in) :: domain ! the domain of operations
  integer, intent(out)       :: id_lon, id_lat         ! IDs of respective diag. manager axes
  real, intent(in),optional  :: glon(:,:), glat(:,:)   ! coordinates of grid cell centers
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer :: id_lonb, id_latb ! IDs for cell boundaries
  integer :: nlon, nlat       ! sizes of respective axes, just for convenience
  real    :: rad2deg          ! conversion factor radian -> degrees
  real    :: lon(size(glonb,1)-1), lat(size(glatb,2)-1)
  integer :: i, j
  integer :: axes(2)

  rad2deg = 180./pi
  nlon = size(glonb,1)-1
  nlat = size(glatb,2)-1

  if (is_latlon(glonb,glatb)) then

 !----- lat/lon grid -----

     if(present(glon)) then
        lon = glon(:,1)
     else
        lon = (glonb(1:nlon,1)+glonb(2:nlon+1,1))/2
     endif
     if(present(glat)) then
        lat = glat(1,:)
     else
        lat = (glatb(1,1:nlat)+glatb(1,2:nlat+1))/2
     endif

     ! define longitude axes and its edges
     id_lonb = diag_axis_init ( &
          'lonb', glonb(:,1)*rad2deg, 'degrees_E', 'X', 'longitude edges', &
          set_name='land', domain2=domain )
     id_lon  = diag_axis_init (                                                &
          'lon', lon(:)*rad2deg, 'degrees_E', 'X',  &
          'longitude', set_name='land',  edges=id_lonb, domain2=domain )

     ! define latitude axes and its edges
     id_latb = diag_axis_init ( &
          'latb', glatb(1,:)*rad2deg, 'degrees_N', 'Y', 'latitude edges',  &
          set_name='land',  domain2=domain   )
     id_lat = diag_axis_init (                                                &
          'lat', lat(:)*rad2deg, 'degrees_N', 'Y', &
          'latitude', set_name='land', edges=id_latb, domain2=domain   )

!----- cubed sphere grid -----

  else
     do i = 1, nlon
       lon(i) = real(i)
     enddo
     do j = 1, nlat
       lat(j) = real(j)
     enddo

     id_lon = diag_axis_init ( 'grid_xt', lon, 'degrees_E', 'X', &
            'T-cell longitude', set_name='land',  domain2=domain )
     id_lat = diag_axis_init ( 'grid_yt', lat, 'degrees_N', 'Y', &
             'T-cell latitude', set_name='land',  domain2=domain )

  endif

  axes = (/ id_lon, id_lat /)
  id_lprec = register_diag_field ( module_name, 'lprec',  axes, &
       time, 'liquid precipitation rate (input)',  'kg/(m2 s)', missing_value=-100.0 )
  id_fprec = register_diag_field ( module_name, 'fprec',  axes, &
       time, 'frozen precipitation rate (input)',  'kg/(m2 s)', missing_value=-100.0 )
  id_lwnet  = register_diag_field ( module_name, 'lwnet',  axes,      &
       time, 'net longwave radiative flux (input)', 'W/m2', missing_value=-999.0 )
  id_swdown = register_diag_field ( module_name, 'swdown',  axes,      &
       time, 'downwelling shortwave radiative flux (input)', 'W/m2', missing_value=-999.0 )
  id_t_surf = register_diag_field ( module_name, 't_surf', axes, &
       time, 'surface temperature (input then updated by lad. sigh.)', 'degK', missing_value=-999.0 )
  id_wind = register_diag_field ( module_name, 'wind', axes, &
       time, 'wind speed (input)', 'm/s', missing_value=-999.0 )
  id_qflux = register_diag_field ( module_name, 'qflux', axes, &
       time, 'water vapor flux near surface (input)', 'kg/(m^2 s)', missing_value=-999.0 )
  id_dedq = register_diag_field ( module_name, 'dedq', axes, &
       time, 'Moisture flux humidity sensitivity (input)', 'kg/m^2/s', missing_value=-999.0 )
  id_q_ca = register_diag_field ( module_name, 'q_ca', axes, &
       time, 'surface/canopy humidity (land_lad state)', 'kg/kg', missing_value=-999.0 )
  id_evap_surf = register_diag_field( module_name, 'evap_surf', axes, &
       time, 'evaporation at surface (land_lad internal)', 'kg/(m^2 s)',  missing_value=-999.0 )

end subroutine init_land_diag
! </SUBROUTINE>

! <SUBROUTINE NAME="define_cube_mosaic">
subroutine define_cube_mosaic ( Domain, nx, ny, layout )
type(domain2d), intent(inout) :: Domain
integer, intent(in) :: nx, ny, layout(2)
integer, parameter :: ntiles = 6, num_contact = 12, ng = 0
integer :: global_indices(4,ntiles), layout_2d(2,ntiles)
integer :: pe_start(ntiles), pe_end(ntiles)
integer :: east(4), west(4), north(4), south(4)
integer :: tile1(num_contact), tile2(num_contact),  &
           index1(num_contact,4), index2(num_contact,4)
integer :: n

    do n = 1, ntiles
       global_indices(:,n) = (/ 1, nx, 1, ny /)
       layout_2d     (:,n) = layout
       pe_start        (n) = (n-1)*layout(1)*layout(2)
       pe_end          (n) =     n*layout(1)*layout(2) - 1
    enddo

  ! istart, iend, jstart, jend for each face
    west =  (/  1,  1,  1, ny /)
    east =  (/ nx, nx,  1, ny /)
    south = (/  1, nx,  1,  1 /)
    north = (/  1, nx, ny, ny /)

  ! define the 12 contact lines bewteen the faces
    tile1( 1) = 1; index1( 1,:) = east;   tile2( 1) = 2; index2( 1,:) = west
    tile1( 2) = 1; index1( 2,:) = north;  tile2( 2) = 3; index2( 2,:) = west
    tile1( 3) = 1; index1( 3,:) = west;   tile2( 3) = 5; index2( 3,:) = north
    tile1( 4) = 1; index1( 4,:) = south;  tile2( 4) = 6; index2( 4,:) = north
    tile1( 5) = 2; index1( 5,:) = north;  tile2( 5) = 3; index2( 5,:) = south
    tile1( 6) = 2; index1( 6,:) = east;   tile2( 6) = 4; index2( 6,:) = south
    tile1( 7) = 2; index1( 7,:) = south;  tile2( 7) = 6; index2( 7,:) = east
    tile1( 8) = 3; index1( 8,:) = east;   tile2( 8) = 4; index2( 8,:) = west
    tile1( 9) = 3; index1( 9,:) = north;  tile2( 9) = 5; index2( 9,:) = west
    tile1(10) = 4; index1(10,:) = north;  tile2(10) = 5; index2(10,:) = south
    tile1(11) = 4; index1(11,:) = east;   tile2(11) = 6; index2(11,:) = south
    tile1(12) = 5; index1(12,:) = east;   tile2(12) = 6; index2(12,:) = west

  ! create the domain2d variable
    call mpp_define_mosaic ( global_indices, layout_2d, Domain,                  &
                             ntiles, num_contact, tile1, tile2,                  &
                             index1(:,1), index1(:,2), index1(:,3), index1(:,4), &
                             index2(:,1), index2(:,2), index2(:,3), index2(:,4), &
                             pe_start=pe_start, pe_end=pe_end, symmetry=.true.,  &
                             shalo = ng, nhalo = ng, whalo = ng, ehalo = ng,     &
                             name = "Land Model Cubic-Grid" )

end subroutine define_cube_mosaic
! </SUBROUTINE>

! <DIAGFIELDS>
!   <NETCDF NAME="lonb" UNITS="degrees_E">
!     Longitude cell boundaries
!   </NETCDF>
!   <NETCDF NAME="lon" UNITS="degrees_E">
!     Diagnostic manager longitude axis
!   </NETCDF>
!   <NETCDF NAME="latb" UNITS="degrees_N">
!     Latitude cell boundaries
!   </NETCDF>
!   <NETCDF NAME="lat" UNITS="degrees_N">
!     Diagnostic manager latitude axis
!   </NETCDF>
! </DIAGFIELDS>

end module land_model_mod
   

             module fms_donner_mod

use time_manager_mod,       only: time_type, set_time, &
                                  set_date, get_time,   &
                                  get_calendar_type, &
                                  operator(-), &
                                  operator(>=), operator (<)
use diag_manager_mod,       only: register_diag_field, send_data, &
                                  diag_axis_init
use field_manager_mod,      only: MODEL_ATMOS, field_manager_init, &
                                  fm_query_method, get_field_info, &
                                  parse
use tracer_manager_mod,     only: get_tracer_names,get_number_tracers, &
                                  get_tracer_indices, &
!++lwh
                                  query_method
use atmos_tracer_utilities_mod, only : get_wetdep_param
use  sat_vapor_pres_mod,only : sat_vapor_pres_init
!--lwh
use fms_mod,                only: mpp_pe, mpp_root_pe,  &
                                  file_exist,  check_nml_error,  &
                                  error_mesg, FATAL, WARNING, NOTE,  &
                                  close_file, open_namelist_file,    &
                                  stdout, stdlog, write_version_number,  &
                                  field_size, &
                                  read_data, write_data, lowercase
use fms_io_mod,             only: register_restart_field, restart_file_type, &
                                  save_restart, restore_state, get_mosaic_tile_file
use mpp_mod,                only: input_nml_file
use mpp_io_mod,             only: mpp_open, mpp_close, fieldtype,  &
                                  mpp_read_meta, mpp_get_info, &
                                  mpp_get_fields, mpp_read, &
                                  MPP_NETCDF, MPP_SINGLE,   &
                                  MPP_SEQUENTIAL, MPP_RDONLY, MPP_NATIVE, &
                                  mpp_get_field_name
use constants_mod,          only: DENS_H2O, RDGAS, GRAV, CP_AIR,  &
                                  pie=>PI, KAPPA, RVGAS, &
                                  SECONDS_PER_DAY, HLV, HLF, HLS, KELVIN
use column_diagnostics_mod, only: initialize_diagnostic_columns, &
                                  column_diagnostics_header, &
                                  close_column_diagnostics_units
use donner_types_mod,       only: donner_initialized_type, &
                                  donner_save_type, donner_rad_type, &
                                  donner_nml_type, donner_param_type, &
                                  donner_budgets_type, &
                                  donner_column_diag_type, &
                                  MAXMAG, MAXVAL, MINMAG, MINVAL, &
                                  DET_MASS_FLUX, MASS_FLUX,  &
                                  CELL_UPWARD_MASS_FLUX, TEMP_FORCING, &
                                  MOIST_FORCING, PRECIP,  FREEZING, &
                                  RADON_TEND, &
                                  donner_conv_type, donner_cape_type, &
                                  donner_cem_type

implicit none
private

!--------------------------------------------------------------------
!        donner_deep_mod diagnoses the location and computes the 
!        effects of deep convection on the model atmosphere
!--------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------


character(len=128)  :: version =  '$Id: fms_donner.F90,v 20.0 2013/12/13 23:17:30 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!--------------------------------------------------------------------
!---interfaces------

public   &
        fms_donner_process_nml,                             &
        fms_donner_process_tracers, &
        fms_donner_activate_diagnostics, fms_donner_read_restart, &
        fms_donner_col_diag, fms_donner_write_restart, &
        fms_donner_column_control, &
        fms_sat_vapor_pres, &
        fms_get_pe_number,  fms_error_mesg,  fms_constants, & 
        fms_close_col_diag_units, &
        fms_deallocate_variables, &
        fms_donner_deep_netcdf, fms_donner_process_monitors

private   &
!  module subroutines called by donner_deep_init:
        register_fields, read_restart_nc,  &
        process_coldstart,&
!  module subroutines called by donner_deep:
        donner_deep_netcdf, donner_column_control,     &
!  module subroutines called from donner_deep_end:
        write_restart


!---------------------------------------------------------------------
!---namelist----

# include "donner_nml.h"

!--------------------------------------------------------------------
!--- public data ----------




!--------------------------------------------------------------------
!----private data-----------

!--- for restart file
type(restart_file_type), pointer, save :: Don_restart => NULL()
type(restart_file_type), pointer, save :: Til_restart => NULL()
logical                                :: in_different_file = .false.
!---------------------------------------------------------------------
!  parameters stored in the donner_param derived type variable to facili-
!  tate passage to kernel subroutines:
!


!--------------------------------------------------------------------
!   list of native mode restart versions usable by this module:
!
!   NOTE: none of the earlier versions of restart files can be used to
!         initiate an experiment with this code version due to a change 
!         in the calculation algorithm. experiments begun with this code
!         must be coldstarted, or use a native mode restart file gener-
!         ated by an experiment using this code version (restart version
!         #8), or a netcdf restart file.
!          
!   version 8 has the lag temp, vapor and pressure fields needed to cal-
!             culate the lag time value of cape. tempbl and ratpbl
!             removed. 
!
!   version 9 is reserved for the native mode restart file version cor-
!             responding to the current netcdf restart file. it is up to 
!             the user to generate the code needed to read and write this
!             version, if needed, using the subroutines read_restart and 
!             write_restart that are provided as starting points, since 
!             only netcdf restarts are currently supported.
!
!   version 10 contains donner_humidity_factor rather than 
!             donner_humidity_ratio, a change necessitated by the intro-
!             duction of the uw_conv shallow convection scheme.

integer, dimension(3)  :: restart_versions = (/ 8, 9, 10 /)


!--------------------------------------------------------------------
!   variables associated with netcdf diagnostic output from this module:
!
!   id_xxxx         indices associated with each potential netcdf 
!                   diagnostic field:
!   missing value   value used by netcdf routines if data not present
!   mod_name        module name associated with these diagnostics; used
!                   to connect these diagnostics to the diag_table
!

integer    :: id_leff
integer    :: id_cemetf_deep, id_ceefc_deep, id_cecon_deep, &
              id_cemfc_deep, id_cememf_deep, id_cememf_mod_deep, &
              id_cual_deep, id_fre_deep, id_elt_deep, &
              id_cmus_deep, id_ecds_deep, id_eces_deep, &
              id_emds_deep, id_emes_deep, id_qmes_deep,&
              id_wmps_deep, id_wmms_deep, id_tmes_deep,&
              id_dmeml_deep, id_uceml_deep, id_umeml_deep, &
              id_xice_deep,  id_dgeice_deep, id_dgeliq_deep,  &
              id_xliq_deep,    &
              id_cuqi_deep, id_cuql_deep, &
              id_plcl_deep, id_plfc_deep, id_plzb_deep, &
              id_xcape_deep, id_coin_deep,  &
              id_dcape_deep, id_qint_deep, id_a1_deep, &
              id_amax_deep, id_amos_deep, &
              id_tprea1_deep, id_ampta1_deep, &
              id_omint_deep, id_rcoa1_deep, id_detmfl_deep
integer                  :: id_pfull_cem, id_phalf_cem, &
                            id_zfull_cem, id_zhalf_cem, &
                            id_temp_cem, id_mixing_ratio_cem
integer, dimension(:), allocatable :: id_cpre_cem, id_pb_cem, id_ptma_cem, &
                            id_h1_cem, id_qlw_cem, id_cfi_cem, &
                            id_wv_cem, id_rcl_cem
integer                  :: id_a1_cem, id_cual_cem, id_tfrc_cem, &
                            id_mpre_cem

integer, dimension(:), allocatable :: id_qtren1, id_qtmes1, &
                                      id_wtp1, id_qtceme, &
                                      id_total_wet_dep, &
                                      id_meso_wet_dep, id_cell_wet_dep
integer, dimension(:), allocatable :: id_qtren1_col, id_qtmes1_col, &
                                      id_wtp1_col, id_qtceme_col, &
                                      id_total_wet_dep_col, &
                                      id_meso_wet_dep_col,   &
                                      id_cell_wet_dep_col
integer, dimension(:), allocatable :: id_extremes, id_hits

integer, dimension(:), allocatable    :: id_water_budget, &
                                         id_ci_water_budget        
integer, dimension(:), allocatable    :: id_enthalpy_budget,   &
                                         id_ci_enthalpy_budget
integer, dimension (:,:), allocatable ::            &
                                         id_precip_budget, &
                                         id_ci_precip_budget

integer   :: id_ci_prcp_heat_liq_cell, id_ci_prcp_heat_frz_cell, &
             id_ci_prcp_heat_liq_meso, id_ci_prcp_heat_frz_meso, &
             id_ci_prcp_heat_total, id_ci_prcp_total

real              :: missing_value = -999.
character(len=16) :: mod_name = 'donner_deep'
integer           :: donner_axes(5)

!--------------------------------------------------------------------
!   variables for column diagnostics option
!
!   arrays containing information for all requested diagnostic columns
!   (1:num_diag_pts):
!    col_diag_unit         unit numbers for each column's output file 
!    col_diag_lon          each column's longitude 
!                          [ degrees, 0 < lon < 360 ]
!    col_diag_lat          each column's latitude 
!                          [degrees, -90 < lat < 90 ]
!    col_diag_j            each column's j index (processor coordinates)
!    col_diag_i            each column's i index (processor coordinates) 
!
!    Time_col_diagnostics  time in model simulation at which to activate
!                          column diagnostics 
!

integer, dimension(:), allocatable :: col_diag_unit
real   , dimension(:), allocatable :: col_diag_lon, col_diag_lat   
integer, dimension(:), allocatable :: col_diag_j, col_diag_i        
type(time_type)                    :: Time_col_diagnostics  


!-----------------------------------------------------------------------
!   miscellaneous variables
!


!-----------------------------------------------------------------------
!-----------------------------------------------------------------------


                          contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                   PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!#####################################################################

subroutine fms_donner_process_nml  (Nml, kpar)

!---------------------------------------------------------------------
!    fms_donner_process_nml processes the donner_deep_nml file. 
!---------------------------------------------------------------------

!--------------------------------------------------------------------
type(donner_nml_type), intent(inout)    :: Nml
integer,               intent(in)       :: kpar

!---------------------------------------------------------------------
!  intent(in) variables:
!
!
!-------------------------------------------------------------------

!-------------------------------------------------------------------
!  local variables:

      integer                             :: unit, ierr, io, logunit
  
!-------------------------------------------------------------------
!  local variables:
!
!     unit                   unit number for nml file
!     ierr                   error return flag
!     io                     error return code
!                         
!-------------------------------------------------------------------

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    1. READ NAMELIST AND WRITE IT TO LOG FILE.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!---------------------------------------------------------------------
!    read namelist.
!---------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=donner_deep_nml, iostat=io)
      ierr = check_nml_error(io,'donner_deep_nml')
#else   
      if (file_exist('input.nml')) then
        unit =  open_namelist_file ()
        ierr=1; do while (ierr /= 0)
        read (unit, nml=donner_deep_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'donner_deep_nml')
        enddo
10      call close_file (unit)
      endif
#endif

!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() )    &
                                 write (logunit, nml=donner_deep_nml)

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    8. STORE THE NAMELIST VARIABLES THAT NEED TO BE MADE AVAILABLE 
!       OUTSIDE OF THIS MODULE INTO THE DONNER_NML_TYPE VARIABLE.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

      Nml%parcel_launch_level         = parcel_launch_level
      Nml%allow_mesoscale_circulation = allow_mesoscale_circulation
      Nml%do_hires_cape_for_closure =   do_hires_cape_for_closure
      Nml%do_donner_cape              = do_donner_cape    !miz
      Nml%do_donner_plume             = do_donner_plume   !miz
      Nml%do_donner_closure           = do_donner_closure !miz
      Nml%do_dcape                    = do_dcape          !miz
      Nml%do_lands                    = do_lands          !miz
      Nml%tau                         = tau               !miz
      Nml%cape0                       = cape0             !miz
      Nml%rhavg0                      = rhavg0            !miz
      Nml%plev0                       = plev0             !miz
      Nml%do_rh_trig                  = do_rh_trig        !miz
      Nml%do_capetau_land             = do_capetau_land   !miz
      Nml%pblht0                      = pblht0            !miz
      Nml%tke0                        = tke0              !miz
      Nml%lofactor0                   = lofactor0         !miz
      Nml%deephgt0                    = deephgt0          !miz
      Nml%lochoice                    = lochoice          !miz
      Nml%deep_closure                = deep_closure      !miz
      Nml%gama                        = gama              !miz
      Nml%do_ice                      = do_ice            !miz
      Nml%atopevap                    = atopevap          !miz
      Nml%do_donner_lscloud           = do_donner_lscloud !miz
      Nml%auto_rate                   = auto_rate         !miz
      Nml%auto_th                     = auto_th           !miz
      Nml%frac                        = frac              !miz
      Nml%ttend_max                   = ttend_max         !miz
      Nml%mesofactor                  = mesofactor        !miz
      Nml%use_llift_criteria          = use_llift_criteria
      Nml%use_pdeep_cv                = use_pdeep_cv
      Nml%entrainment_constant_source = entrainment_constant_source
      Nml%donner_deep_freq            = donner_deep_freq             
      Nml%model_levels_in_sfcbl       = model_levels_in_sfcbl        
      Nml%cell_liquid_size_type       = cell_liquid_size_type 
      Nml%cell_ice_size_type          = cell_ice_size_type
      Nml%cell_liquid_eff_diam_input  = cell_liquid_eff_diam_input
      Nml%cell_ice_geneff_diam_input  = cell_ice_geneff_diam_input
      Nml%meso_liquid_eff_diam_input  = meso_liquid_eff_diam_input
      Nml%do_average                  = do_average
      Nml%use_memphis_size_limits     = use_memphis_size_limits
      Nml%wmin_ratio                  = wmin_ratio
      Nml%do_freezing_for_cape         = do_freezing_for_cape
      Nml%tfre_for_cape               = tfre_for_cape
      Nml%dfre_for_cape               = dfre_for_cape
      Nml%rmuz_for_cape               = rmuz_for_cape
      Nml%do_freezing_for_closure     = do_freezing_for_closure
      Nml%tfre_for_closure            = tfre_for_closure
      Nml%dfre_for_closure            = dfre_for_closure
      Nml%rmuz_for_closure            = rmuz_for_closure
      Nml%do_budget_analysis          = do_budget_analysis
      Nml%frc_internal_enthalpy_conserv =  &
                                 frc_internal_enthalpy_conserv
      Nml%do_ensemble_diagnostics     = do_ensemble_diagnostics
      Nml%limit_pztm_to_tropo = limit_pztm_to_tropo
      Nml%entrainment_scheme_for_closure =    &
                                       entrainment_scheme_for_closure
      Nml%modify_closure_plume_condensate =   &
                                       modify_closure_plume_condensate
      Nml%closure_plume_condensate = closure_plume_condensate

     Nml%evap_in_downdrafts = evap_in_downdrafts
     Nml%evap_in_environ  = evap_in_environ
     Nml%entrained_into_meso = entrained_into_meso
     Nml%anvil_precip_efficiency = anvil_precip_efficiency
     Nml%meso_down_evap_fraction = meso_down_evap_fraction
     Nml%meso_up_evap_fraction = meso_up_evap_fraction
     Nml%cdeep_cv = cdeep_cv

     allocate (Nml%arat(kpar))
     allocate (Nml%ensemble_entrain_factors_gate(kpar)) 

     if ( arat_erat_option /= 0 ) then
 
       call define_arat_erat (arat_erat_option, kpar, eratb, erat0, &
                              erat_min, erat_max, erat, arat)
       if (mpp_pe() == mpp_root_pe() ) then
         print *,'donner_deep_nml: redefined arat and erat using &
                        &arat_erat_option == ', arat_erat_option
         print *,'donner_deep_nml: arat = ',arat
         print *,'donner_deep_nml: erat = ',erat
       end if
     endif

     Nml%arat = arat
     Nml%ensemble_entrain_factors_gate = erat

end subroutine fms_donner_process_nml


!#####################################################################

subroutine fms_donner_process_tracers (Initialized, tracers_in_donner,&
                                       Don_save)

type(donner_initialized_type),   intent(inout) :: Initialized
logical, dimension(:),          intent(in) :: tracers_in_donner
type(donner_save_type), intent(inout)      :: Don_save



        integer :: nn, n
      logical                             :: flag
      character(len=200)                  :: method_name, method_control
      real                                :: frac_junk, frac_junk2

        Initialized%do_donner_tracer = .true.
        nn = 1
        do n=1,size(tracers_in_donner(:))
          if (tracers_in_donner(n)) then
            call get_tracer_names (MODEL_ATMOS, n,  &
                                   name = Don_save%tracername(nn), &
                                   units = Don_save%tracer_units(nn))
!++lwh
            Initialized%wetdep(nn)%units = Don_save%tracer_units(nn)
            flag = query_method( 'wet_deposition', MODEL_ATMOS, n, &
                                 method_name, method_control )
            call get_wetdep_param( method_name, method_control, &
                                   Initialized%wetdep(nn)%scheme, &
                                   Initialized%wetdep(nn)%Henry_constant, &
                                   Initialized%wetdep(nn)%Henry_variable, &
                                   frac_junk, frac_junk2, &
                                   Initialized%wetdep(nn)%alpha_r, &
                                   Initialized%wetdep(nn)%alpha_s , &
                                   Initialized%wetdep(nn)%Lwetdep, &
                                   Initialized%wetdep(nn)%Lgas, &
                                   Initialized%wetdep(nn)%Laerosol, &
                                   Initialized%wetdep(nn)%Lice, &
                                   frac_in_cloud_donner=Initialized%wetdep(nn)%frac_in_cloud)
            Initialized%wetdep(nn)%scheme = lowercase( Initialized%wetdep(nn)%scheme )
!-lwh
            nn = nn + 1
          endif
        end do

end subroutine fms_donner_process_tracers




!#####################################################################

subroutine fms_donner_activate_diagnostics (secs, days, axes, &
                             Don_save, Nml, n_water_budget, &
                             n_enthalpy_budget, n_precip_paths, &
                             n_precip_types, nlev_hires, kpar)

integer, intent(in) :: secs, days, n_water_budget, &
                             n_enthalpy_budget, n_precip_paths, &
                             n_precip_types, nlev_hires, kpar
                      
integer,         dimension(4),   intent(in)   :: axes
type(donner_save_type), intent(inout) :: Don_save
type(donner_nml_type), intent(inout) :: Nml       

      type(time_type)    :: Time

      Time = set_time (secs, days)

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    4. INITIALIZE THE NETCDF OUTPUT VARIABLES.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!--------------------------------------------------------------------
!    activate the netcdf diagnostic fields.
!-------------------------------------------------------------------
      call register_fields (Time, axes, Don_save, Nml, &
                              n_water_budget, &
                             n_enthalpy_budget, n_precip_paths, &
                             n_precip_types, nlev_hires, kpar)


end subroutine fms_donner_activate_diagnostics 


!#####################################################################

subroutine fms_donner_read_restart (Initialized, ntracers,   &
                                    secs, days, Don_save, Nml)

type(donner_initialized_type), intent(inout) :: Initialized
type(donner_save_type), intent(inout) :: Don_save
type(donner_nml_type), intent(inout) :: Nml     
integer, intent(in) :: secs, days, ntracers

      type(time_type) :: Time
integer :: outunit

     Time = set_time (secs, days)

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    5. PROCESS THE RESTART FILE.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!--------------------------------------------------------------------
!    if a netcdf restart file is present, call read_restart_nc to read 
!    it.
!--------------------------------------------------------------------
      !--- register restart field to be ready to be written out.
      call fms_donner_register_restart('donner_deep.res.nc', Initialized, ntracers, Don_save, Nml)

      if (file_exist ('INPUT/donner_deep.res.nc') ) then
       Initialized%coldstart= .false.
!        call read_restart_nc (ntracers, Initialized,Nml, Don_save)
       call restore_state(Don_restart)
       if (in_different_file) call restore_state(Til_restart)

!--------------------------------------------------------------------
!    if a native mode restart file is present, call read_restart 
!    to read it.
!--------------------------------------------------------------------
      else if (file_exist ('INPUT/donner_deep.res') ) then
        Initialized%coldstart= .false.
        call error_mesg ( 'fms_donner_mod', 'Native restart capability has been removed.', &
                                         FATAL)
!--------------------------------------------------------------------
!    if no restart file is present, call subroutine process_coldstart
!    to define the needed variables.
!--------------------------------------------------------------------
      else
        call process_coldstart (Time, Initialized, Nml, Don_save)
      endif


end subroutine fms_donner_read_restart 


!#####################################################################

subroutine fms_donner_col_diag (lonb, latb, Col_diag, pref) 

real, dimension(:,:), intent(in) :: lonb, latb
type(donner_column_diag_type), intent(inout) :: Col_diag
real, dimension(:), intent(in) :: pref

    logical, dimension(size(latb,1)-1, size(latb,2)-1) ::    &
                                                  do_column_diagnostics
    integer :: k, n

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    6. INITIALIZE VARIABLES NEEDED FOR COLUMN_DIAGNOSTICS_MOD OUTPUT.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!---------------------------------------------------------------------
!    define the total number of columns for which diagnostics
!    are desired.
!---------------------------------------------------------------------
      Col_diag%num_diag_pts = num_diag_pts_ij + num_diag_pts_latlon

!---------------------------------------------------------------------
!    initialize the value of the k index associated with diagnostics
!    cutoff.
!---------------------------------------------------------------------
      Col_diag%kstart = -99

!---------------------------------------------------------------------
!    if any diagnostics are requested, perform various consistency
!    checks.
!---------------------------------------------------------------------
      if (Col_diag%num_diag_pts > 0) then

!---------------------------------------------------------------------
!    check that array dimensions are sufficiently large for the number 
!    of columns requested.
!---------------------------------------------------------------------
        if (Col_diag%num_diag_pts > MAX_PTS) then
          call error_mesg ('donner_deep_mod', 'donner_deep_init: &
         &must reset MAX_PTS or reduce number of diagnostic points', &
                                                           FATAL)  
        endif

!---------------------------------------------------------------------
!    check that the specified time at which diagnostics are to be 
!    activated has been specified.
!---------------------------------------------------------------------
        do n=1,3
          if (diagnostics_start_time(n) == 0) then
            call error_mesg ('donner_deep_mod', 'donner_deep_init:&
             &year, month and/or day invalidly specified for column '//&
                  'diagnostics starting time', FATAL)
          endif
        end do

!---------------------------------------------------------------------
!    define a time_type variable indicating the requested time to begin
!    outputting diagnostics.
!---------------------------------------------------------------------
        Time_col_diagnostics = set_date (diagnostics_start_time(1), &
                                         diagnostics_start_time(2), &   
                                         diagnostics_start_time(3), &   
                                         diagnostics_start_time(4), &   
                                         diagnostics_start_time(5), &   
                                         diagnostics_start_time(6) )    

!---------------------------------------------------------------------
!    allocate space for the arrays used to specify the diagnostics 
!    columns and the output units. initialize the arrays with bogus
!    values.
!---------------------------------------------------------------------
        allocate (col_diag_unit    (Col_diag%num_diag_pts) )
        allocate (col_diag_lon     (Col_diag%num_diag_pts) )
        allocate (col_diag_lat     (Col_diag%num_diag_pts) )
        allocate (col_diag_i       (Col_diag%num_diag_pts) )
        allocate (col_diag_j       (Col_diag%num_diag_pts) )
        col_diag_unit  = -1
        col_diag_lon   = -1.0
        col_diag_lat   = -1.0
        col_diag_i     = -1
        col_diag_j     = -1

!---------------------------------------------------------------------
!    call initialize_diagnostic_columns to determine the locations 
!    (i,j,lat and lon) of any diagnostic columns in this processor's
!    space and to open output files for the diagnostics.
!---------------------------------------------------------------------
        call initialize_diagnostic_columns   &
                     (mod_name, num_diag_pts_latlon, num_diag_pts_ij, &
                      i_coords_gl, j_coords_gl, lat_coords_gl, &
                      lon_coords_gl, lonb(:,:), latb(:,:),  &
                      do_column_diagnostics, &
                      col_diag_lon, col_diag_lat, col_diag_i,  &
                      col_diag_j, col_diag_unit)

!---------------------------------------------------------------------
!    verify that requested pressure cutoff for column diagnostics output
!    is valid. define the model k index which corresponds (kstart).
!---------------------------------------------------------------------
        do k=1,size(pref(:))
          if (pref(k) >= diagnostics_pressure_cutoff) then
            Col_diag%kstart = k
            exit
          endif
        end do

!----------------------------------------------------------------------
!    if the specified pressure is larger than any pressure level in the
!    model grid, write an error message.
!----------------------------------------------------------------------
        if (Col_diag%kstart == -99) then
          call error_mesg ( 'donner_deep_mod', 'donner_deep_init: &
           &diagnostics_pressure_cutoff is higher than pressure at '//&
                                     'any model level', FATAL)
        endif

!----------------------------------------------------------------------
!   if column diagnostics is not requested, define the components of
!   Col_diag that will be needed.
!----------------------------------------------------------------------
      else
        Col_diag%in_diagnostics_window = .false.
        Col_diag%ncols_in_window = 0
      endif

!----------------------------------------------------------------------
!    allocate space for the array elements of the donner_column_diag_type
!    variable Col_diag. These arrays remain for the life of the job and
!    will be defined for each physics window as it is entered.
!----------------------------------------------------------------------
      allocate (Col_diag%i_dc(Col_diag%num_diag_pts))
      allocate (Col_diag%j_dc(Col_diag%num_diag_pts))
      allocate (Col_diag%unit_dc(Col_diag%num_diag_pts))
      allocate (Col_diag%igl_dc(Col_diag%num_diag_pts))
      allocate (Col_diag%jgl_dc(Col_diag%num_diag_pts))


end subroutine fms_donner_col_diag 




!#####################################################################
! <SUBROUTINE NAME="fms_donner_write_restart">
!
! <DESCRIPTION>
! write out restart file.
! Arguments: 
!   timestamp (optional, intent(in)) : A character string that represents the model time, 
!                                      used for writing restart. timestamp will append to
!                                      the any restart file name as a prefix. 
! </DESCRIPTION>
!
subroutine fms_donner_write_restart (Initialized, timestamp)
  type(donner_initialized_type), intent(in) :: Initialized
  character(len=*), intent(in), optional :: timestamp

!-------------------------------------------------------------------
!    call subroutine to write restart file. NOTE: only the netcdf 
!    restart file is currently supported.
!-------------------------------------------------------------------
      if (mpp_pe() == mpp_root_pe() ) then
        if (.not. (write_reduced_restart_file) ) then
          call error_mesg ('donner_deep_mod', 'write_restart_nc: &
            &Writing FULL netCDF formatted restart file as requested: &
                 &RESTART/donner_deep.res.nc', NOTE)
        else
          if (Initialized%conv_alarm >= Initialized%physics_dt)  then
            call error_mesg ('donner_deep_mod', 'write_restart_nc: &
            &Writing FULL netCDF formatted restart file; it is needed &
             &to allow seamless restart because next step is not a &
             &donner calculation step: RESTART/donner_deep.res.nc', NOTE)
          else
            call error_mesg ('donner_deep_mod', 'write_restart_nc: &
              &Writing REDUCED netCDF formatted restart file as  &
                &requested: RESTART/donner_deep.res.nc', NOTE)
          endif
        endif
      endif
      call save_restart(Don_restart, timestamp)
      if(in_different_file) call save_restart(Til_restart, timestamp)

end subroutine fms_donner_write_restart 


!#####################################################################

subroutine fms_get_pe_number (me, root_pe)

integer, intent(out) :: me, root_pe

    me = mpp_pe()
    root_pe = mpp_root_pe()

end subroutine fms_get_pe_number



!#####################################################################

subroutine fms_close_col_diag_units


      call close_column_diagnostics_units (col_diag_unit)


end subroutine fms_close_col_diag_units 


!#####################################################################

subroutine fms_deallocate_variables (Col_diag)

type(donner_column_diag_type), intent(inout) :: Col_diag

      if (Col_diag%num_diag_pts > 0) then
        deallocate (Col_diag%i_dc    )
        deallocate (Col_diag%j_dc    ) 
        deallocate (Col_diag%unit_dc )
        deallocate (Col_diag%igl_dc  )
        deallocate (Col_diag%jgl_dc  )
      endif

      if (allocated(col_diag_unit)) then
        deallocate (col_diag_unit  )
        deallocate (col_diag_lon   )
        deallocate (col_diag_lat   )
        deallocate (col_diag_i     )
        deallocate (col_diag_j     )
      endif
     
      if (allocated (id_qtren1)) then
        deallocate (id_qtren1)
        deallocate (id_qtmes1)
        deallocate (id_wtp1  )
        deallocate (id_qtceme)
        deallocate (id_total_wet_dep)
        deallocate (id_meso_wet_dep)
        deallocate (id_cell_wet_dep)
        deallocate (id_qtren1_col)
        deallocate (id_qtmes1_col)
        deallocate (id_wtp1_col  )
        deallocate (id_qtceme_col)
        deallocate (id_total_wet_dep_col)
        deallocate (id_meso_wet_dep_col)
        deallocate (id_cell_wet_dep_col)
      endif


      if (allocated (id_extremes)) then
        deallocate (id_extremes)
        deallocate (id_hits)
      endif


end subroutine fms_deallocate_variables



!#####################################################################

subroutine fms_sat_vapor_pres


      call sat_vapor_pres_init


end subroutine fms_sat_vapor_pres


!#####################################################################

subroutine fms_error_mesg (ermesg)

character(len=*), intent(in) :: ermesg


      call error_mesg ('donner_deep_mod', ermesg, FATAL)



end subroutine fms_error_mesg 


!######################################################################

subroutine fms_donner_deep_netcdf (is, ie, js, je, Nml, secs, days, &
                               Param, Initialized, Don_conv, Don_cape,&
                               Don_cem,parcel_rise, pmass, total_precip, &
                               Don_budgets, &
                               temperature_forcing, moisture_forcing)  

!---------------------------------------------------------------------
!    subroutine donner_deep_netcdf sends the fields requested in the
!    diag_table to diag_manager_mod so that they may be appropriately
!    processed for output.
!---------------------------------------------------------------------

integer,                intent(in) :: is, ie, js, je
integer,                intent(in) :: secs, days
type(donner_nml_type), intent(in) :: Nml   
type(donner_param_type), intent(in) :: Param 
type(donner_initialized_type), intent(inout) :: Initialized
type(donner_conv_type), intent(in) :: Don_conv
type(donner_budgets_type), intent(in) :: Don_budgets
type(donner_cape_type), intent(in) :: Don_cape
type(donner_cem_type),  intent(in) :: Don_cem
real, dimension(:,:,:), intent(in) :: pmass, temperature_forcing,&
                                      moisture_forcing
real, dimension(:,:),   intent(in) :: parcel_rise, total_precip

!---------------------------------------------------------------------
!   intent(in) variables:
!
!     is, ie         first and last values of i index values of points 
!                    in this physics window (processor coordinates)
!     js, je         first and last values of j index values of points 
!                    in this physics window (processor coordinates)
!     Time           current time (time_type)
!     Don_conv       donner_convection_type derived type variable con-
!                    taining diagnostics describing the nature of the 
!                    convection produced by the donner parameterization
!     Don_cape       donner_cape type derived type variable containing
!                    diagnostics related to the cape calculation assoc-
!                    iated with the donner convection parameterization
!     Don_cem        donner_cem_type derived type variable containing
!                    Donner cumulus ensemble member diagnostics
!     temperature_forcing  
!                    temperature tendency due to donner convection
!                    [ deg K / sec ]
!     moisture_forcing  
!                    vapor mixing ratio tendency due to donner 
!                    convection [ kg(h2o) / (kg(dry air) sec ) ]
!     pmass          mass per unit area within the grid box
!                    [ kg (air) / (m**2) ]
!     parcel_rise    accumulated vertical displacement of a near-surface
!                    parcel as a result of the lowest model level omega 
!                    field [ Pa ]
!     total_precip   total precipitation rate produced by the
!                    donner parameterization [ mm / day ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      type(time_type)  :: Time

      Time = set_time (secs, days)

      call donner_deep_netcdf (is, ie, js, je, Nml, Time,  Param, &
                               Initialized, Don_conv, Don_cape,&
                               Don_cem,parcel_rise, pmass, total_precip, &
                               Don_budgets, &
                               temperature_forcing, moisture_forcing)  


!----------------------------------------------------------------------


end subroutine fms_donner_deep_netcdf



!###################################################################

subroutine fms_donner_process_monitors (idf, jdf, nlev,  &
                              ntracers, axes, secs, days, Initialized,&
                              Don_save)

integer, intent(in)  :: idf, jdf, nlev, ntracers, secs, days
integer, dimension(4), intent(in) :: axes
type(donner_save_type), intent(inout) :: Don_save
type(donner_initialized_type), intent(inout) :: Initialized


   type(time_type)  :: Time

    Time = set_time (secs,days)

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    9. SET UP CODE TO MONITOR SELECTED OUTPUT VARIABLES.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

       call process_monitors (idf, jdf, nlev, ntracers, axes, Time, &
                              Initialized, Don_save)


end subroutine fms_donner_process_monitors

!###################################################################

subroutine fms_donner_column_control (is, ie, js, je, secs, days, Col_diag)          

!---------------------------------------------------------------------
!    subroutine fms_donner_column_control returns the number, location
!    (processor and window indices) and output units associated with 
!    any diagnostic columns requested within the current physics window.
!---------------------------------------------------------------------

integer,                       intent(in)   :: is, ie, js, je
integer,                       intent(in) :: secs, days
type(donner_column_diag_type), intent(inout) :: Col_diag


     type(time_type)                             :: Time

      Time = set_time(secs, days)

      call donner_column_control (is, ie, js, je, Time, Col_diag)                


end subroutine fms_donner_column_control 


!####################################################################


subroutine fms_constants (Param)

type(donner_param_type), intent(inout)  :: Param


!----------------------------------------------------------------------
!    define the components of Param that come from constants_mod. see 
!    donner_types.h for their definitions.
!----------------------------------------------------------------------
      Param%dens_h2o        = DENS_H2O
      Param%rdgas           = RDGAS
      Param%grav            = GRAV
      Param%cp_air          = CP_AIR  
      Param%pie             = PIE
      Param%kappa           = KAPPA
      Param%rvgas           = RVGAS
      Param%seconds_per_day = SECONDS_PER_DAY
      Param%hlv             = HLV
      Param%hlf             = HLF
      Param%hls             = HLS
      Param%kelvin          = KELVIN

!----------------------------------------------------------------------

end subroutine fms_constants 

!####################################################################





!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                   PRIVATE SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!      1. ROUTINES CALLED BY DONNER_DEEP_INIT
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!#####################################################################
 
subroutine register_fields (Time, axes, Don_save, Nml, &
                              n_water_budget, &
                             n_enthalpy_budget, n_precip_paths, &
                             n_precip_types, nlev_hires, kpar)

!----------------------------------------------------------------------
!    subroutine register_fields registers all of the potential diagnos-
!    tics written by this module with diag_manager_mod.
!----------------------------------------------------------------------

type(time_type),               intent(in)   :: Time
integer, intent(in) :: n_water_budget, &
                             n_enthalpy_budget, n_precip_paths, &
                             n_precip_types, nlev_hires, kpar
integer,         dimension(4), intent(in)   :: axes
type(donner_save_type), intent(inout) :: Don_save
type(donner_nml_type), intent(inout) :: Nml       

!----------------------------------------------------------------------
!   intent(in) variables:
!
!      Time         current time [ time_type ]
!      axes         data axes for diagnostics
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      integer  :: ntracers     ! number of tracers transported by the
                               ! donner deep convection parameterization
      integer :: nn            ! do-loop index
      integer :: ncem          ! number of cumulus ensemble members in
                               ! the donner deep convection parameter-
                               ! ization
      character(len=2) :: chvers ! character representation of cumulus 
                                 ! ensemble  member number

!  define a variable for telling "register_fields" to put output on
!  "half-levels" (Reference:  Chris Golaz's subroutine "diag_field_init"
!  in /home/cjg/FMS/nalanda/nnew3/m45_am2p14_nnew3/src/atmos_param/
!                                 moist_processes/moist_processes.F90)
 
      integer, dimension(3) :: half = (/1,2,4/)
      integer, dimension(3) :: cldindices = (/1,2,5/)
      integer               :: id_cldmodel
      real                  :: cldvindx(NLEV_HIRES)
      integer               :: k

      ncem = kpar

!---------------------------------------------------------------------  
!    define the axes for the donner cloud model.
!---------------------------------------------------------------------
      donner_axes(1:4) = axes(1:4)     
      if (Nml%do_donner_plume) then
        do k=1, NLEV_HIRES
          cldvindx(k) = real(k)
        end do
        id_cldmodel = diag_axis_init('cldvindx', cldvindx, 'level#', &
                                     'z', 'cld model vertical index', &
                                     set_name=mod_name )
        donner_axes(5) = id_cldmodel
      endif

!----------------------------------------------------------------------
!    define the number of tracers that are to be transported by the 
!    donner deep convection parameterization.
!-------------------------------------------------------------------
      ntracers = size(Don_save%tracername(:))

!---------------------------------------------------------------------
!    register the various diagnostic fields.
!---------------------------------------------------------------------

    if (Nml%do_budget_analysis) then
      allocate (id_water_budget (n_water_budget))
      allocate (id_ci_water_budget (n_water_budget))
      allocate (id_enthalpy_budget (n_enthalpy_budget))
      allocate (id_ci_enthalpy_budget (n_enthalpy_budget))
      allocate (id_precip_budget (n_precip_paths, n_precip_types))
      allocate (id_ci_precip_budget (n_precip_paths, n_precip_types))
      id_water_budget(1)    = register_diag_field    &
            (mod_name, 'vapor_net_tend', axes(1:3),   &
             Time, 'net water vapor tendency', &
             'g(h2o) / kg(air) / day',    &
             missing_value=missing_value)
      
      id_water_budget(2)    = register_diag_field    &
            (mod_name, 'vapor_cell_dynam', axes(1:3),   &
             Time, 'vapor tendency due to cell dynamics', &
             ' g(h2o) / kg(air) / day', &
             missing_value=missing_value)
      
      id_water_budget(3)    = register_diag_field    &
            (mod_name, 'vapor_meso_depo', axes(1:3),   &
             Time, 'vapor tendency from mesoscale deposition', &
             ' g(h2o) / kg(air) / day', &
             missing_value=missing_value)
      
      id_water_budget(4)    = register_diag_field    &
            (mod_name, 'vapor_meso_cd', axes(1:3),   &
             Time, 'vapor tendency from mesoscale condensation',  &
             ' g(h2o) / kg(air) / day', &
             missing_value=missing_value)
      
      id_water_budget(5)    = register_diag_field    &
            (mod_name, 'vapor_cell_evap', axes(1:3),   &
             Time, 'vapor tendency from cell evaporation',  &
             ' g(h2o) / kg(air) / day', &
             missing_value=missing_value)
      
      id_water_budget(6)    = register_diag_field    &
            (mod_name, 'vapor_cell_meso_trans', axes(1:3),   &
             Time, 'vapor tendency from cell to mesoscale transfer',  &
             ' g(h2o) / kg(air) / day', &
             missing_value=missing_value)
      
      id_water_budget(7)    = register_diag_field    &
            (mod_name, 'vapor_meso_evap', axes(1:3),   &
             Time, 'vapor tendency from mesoscale evaporation', &
             ' g(h2o) / kg(air) / day', &
             missing_value=missing_value)
      
      id_water_budget(8)    = register_diag_field    &
            (mod_name, 'vapor_meso_dynam_up', axes(1:3),   &
             Time, 'vapor tendency from mesoscale updrafts',  &
             ' g(h2o) / kg(air) / day', &
             missing_value=missing_value)
      
      id_water_budget(9)    = register_diag_field    &
            (mod_name, 'vapor_meso_dynam_dn',  axes(1:3),   &
             Time, 'vapor tendency from mesoscale downdrafts',  &
             ' g(h2o) / kg(air) / day', &
             missing_value=missing_value)
      
      id_enthalpy_budget(1)    = register_diag_field    &
            (mod_name, 'enth_net_tend', axes(1:3),   &
             Time, 'net temp tendency', 'deg K  /day',    &
             missing_value=missing_value)

      id_enthalpy_budget(2)    = register_diag_field    &
            (mod_name, 'enth_cell_dynam', axes(1:3),   &
             Time, 'temp tendency due to cell dynamics', &
             'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(3)    = register_diag_field    &
            (mod_name, 'enth_meso_depo_liq', axes(1:3), Time, &
             'temp tendency from mesoscale deposition on liquid&
                    & condensate',  'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(4)    = register_diag_field    &
            (mod_name, 'enth_meso_cd_liq', axes(1:3), Time, &
             ' temp tendency from mesoscale liquid condensation', &
             'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(5)    = register_diag_field    &
            (mod_name, 'enth_cell_evap_liq', axes(1:3),   &
             Time, 'temp tendency from evap of liquid condensate', &
             'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(6)    = register_diag_field    &
            (mod_name, 'enth_meso_evap_liq_up', axes(1:3),   &
             Time, 'temp tendency from evaporation of liquid &
              &condensate in mesoscale updrafts',  &
             'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(7)    = register_diag_field    &
            (mod_name, 'enth_meso_evap_liq_dn', axes(1:3),   &
             Time, 'temp tendency from evaporation of liquid &
              &condensate in mesoscale downdrafts',  &
             'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(8)    = register_diag_field    &
            (mod_name, 'enth_meso_depo_ice', axes(1:3),   &
             Time, ' temp tendency from mesoscale deposition on &
              &ice condensate',  'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(9)    = register_diag_field    &
            (mod_name, 'enth_meso_cd_ice', axes(1:3),   &
             Time, 'temp tendency from mesoscale ice condensation', &
             'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(10)    = register_diag_field    &
            (mod_name, 'enth_cell_evap_ice', axes(1:3),   &
             Time, 'temp tendency from evap of ice condensate', &
             'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(11)    = register_diag_field    &
            (mod_name, 'enth_meso_evap_ice_up', axes(1:3),   &
             Time, 'temp tendency from evaporation of ice condensate &
              &in mesoscale updrafts',  'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(12)    = register_diag_field    &
            (mod_name, 'enth_meso_evap_ice_dn', axes(1:3),   &
             Time, 'temp tendency from evaporation of ice &
               &condensate in mesoscale downdrafts',  'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(13)    = register_diag_field    &
            (mod_name, 'enth_meso_freeze', axes(1:3),   &
             Time, 'temp tendency from the freezing of liquid &
              &condensate when it enters the mesoscale circulation',  &
             'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(14)    = register_diag_field    &
            (mod_name, 'enth_cell_freeze', axes(1:3),   &
             Time, 'temp tendency from the freezing of liquid &
                &cell condensate',  'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(15)    = register_diag_field    &
            (mod_name, 'enth_cell_precip_melt', axes(1:3),   &
             Time, 'temp tendency from the melting of cell frozen &
             &liquid and ice that is precipitating out', 'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(16)    = register_diag_field    &
            (mod_name, 'enth_meso_melt', axes(1:3), Time, &
             'temp tendency from melting bogus frozen condensate',  &
             'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(17)    = register_diag_field    &
            (mod_name, 'enth_meso_precip_melt', axes(1:3),   &
             Time, 'temp tendency from the melting of frozen &
               &mesoscale precipitation',  'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(18)    = register_diag_field    &
            (mod_name, 'enth_meso_dynam_up', axes(1:3),   &
             Time, 'temp tendency from mesoscale updraft', &
             'deg K / day', &
             missing_value=missing_value)

      id_enthalpy_budget(19)    = register_diag_field    &
            (mod_name, 'enth_meso_dynam_dn', axes(1:3),   &
             Time, 'temp tendency from mesoscale downdraft', &
             'deg K / day', &
             missing_value=missing_value)

      id_precip_budget(1,1)    = register_diag_field    &
            (mod_name, 'precip_cell_liq', axes(1:3),   &
             Time, 'precip from cell liquid condensate', &
              'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_precip_budget(2,1)    = register_diag_field    &
            (mod_name, 'precip_cell_liq_frz', axes(1:3),   &
             Time, 'precip from cell liquid condensate which froze', &
              'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_precip_budget(3,1)    = register_diag_field    &
            (mod_name, 'precip_cell_liq_frz_melt', axes(1:3), Time, &
              'precip from cell liquid condensate which froze &
               &and remelted', 'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_precip_budget(4,1)    = register_diag_field    &
            (mod_name, 'precip_cell_ice', axes(1:3),   &
             Time, 'precip from cell ice condensate', &
              'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_precip_budget(5,1)    = register_diag_field    &
            (mod_name, 'precip_cell_ice_melt', axes(1:3),   &
             Time, 'precip from cell ice condensate which melted', &
              'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_precip_budget(1,2)    = register_diag_field    &
            (mod_name, 'precip_trans_liq', axes(1:3),   &
             Time, 'precip from cell liquid transferred to meso', &
              'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_precip_budget(2,2)    = register_diag_field    &
            (mod_name, 'precip_trans_liq_frz', axes(1:3),   &
             Time, 'precip from cell liquid transferred to meso &
              &which froze', 'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_precip_budget(3,2)    = register_diag_field    &
            (mod_name, 'precip_trans_liq_frz_melt', axes(1:3), Time, &
             'precip from cell liquid transferred to meso which &
              &froze and remelted', 'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_precip_budget(4,2)    = register_diag_field    &
            (mod_name, 'precip_trans_ice', axes(1:3),   &
             Time, 'precip from cell ice transferred to meso', &
              'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_precip_budget(5,2)    = register_diag_field    &
            (mod_name, 'precip_trans_ice_melt', axes(1:3),   &
             Time, 'precip from cell ice transferred to meso &
              &which melted', 'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_precip_budget(1,3)    = register_diag_field    &
            (mod_name, 'precip_meso_liq', axes(1:3),   &
             Time, 'precip from meso liq condensate', &
              'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_precip_budget(2,3)    = register_diag_field    &
            (mod_name, 'precip_meso_liq_frz', axes(1:3),   &
             Time, 'precip from meso liq  condensate which froze', &
              'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_precip_budget(3,3)    = register_diag_field    &
            (mod_name, 'precip_meso_liq_frz_melt', axes(1:3), Time, &
            'precip from meso condensate liq which froze and &
             &remelted', 'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_precip_budget(4,3)    = register_diag_field    &
            (mod_name, 'precip_meso_ice', axes(1:3),   &
             Time, 'precip from meso ice condensate', &
              'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_precip_budget(5,3)    = register_diag_field    &
            (mod_name, 'precip_meso_ice_melt', axes(1:3),   &
             Time, 'precip from meso ice condensate which melted', &
              'kg(h2o) / kg(air) / day', &
             missing_value=missing_value)

      id_ci_precip_budget(1,1)    = register_diag_field    &
            (mod_name, 'ci_precip_cell_liq', axes(1:2),   &
             Time, 'col intg precip from cell liquid condensate', &
             'mm / day', &
             missing_value=missing_value)

      id_ci_precip_budget(2,1)    = register_diag_field    &
            (mod_name, 'ci_precip_cell_liq_frz', axes(1:2),   &
             Time, 'col intg precip from cell liquid condensate &
             &which froze',  'mm / day', &
             missing_value=missing_value)

      id_ci_precip_budget(3,1)    = register_diag_field    &
            (mod_name, 'ci_precip_cell_liq_frz_melt', axes(1:2), Time, &
             'col intg precip from cell liquid condensate which &
              &froze and remelted',  'mm / day', &
             missing_value=missing_value)

      id_ci_precip_budget(4,1)    = register_diag_field    &
            (mod_name, 'ci_precip_cell_ice', axes(1:2),   &
             Time, 'col intg precip from cell ice condensate', &
             'mm / day', &
             missing_value=missing_value)

      id_ci_precip_budget(5,1)    = register_diag_field    &
            (mod_name, 'ci_precip_cell_ice_melt', axes(1:2),   &
             Time, 'col intg precip from cell ice condensate &
             &which melted',  'mm / day', &
             missing_value=missing_value)

      id_ci_precip_budget(1,2)    = register_diag_field    &
            (mod_name, 'ci_precip_trans_liq', axes(1:2),   &
             Time, 'col intg precip from cell liquid transferred &
             &to meso',  'mm / day', &
             missing_value=missing_value)

      id_ci_precip_budget(2,2)    = register_diag_field    &
            (mod_name, 'ci_precip_trans_liq_frz', axes(1:2),   &
             Time, 'col intg precip from cell liquid transferred &
              &to meso  which froze', 'mm / day', &
             missing_value=missing_value)

      id_ci_precip_budget(3,2)    = register_diag_field    &
            (mod_name, 'ci_precip_trans_liq_frz_melt', axes(1:2), &
             Time, 'col intg precip from cell liquid transferred &
             &to meso which froze and remelted', 'mm / day', &
             missing_value=missing_value)

      id_ci_precip_budget(4,2)    = register_diag_field    &
            (mod_name, 'ci_precip_trans_ice', axes(1:2),   &
             Time, 'col intg precip from cell ice transferred &
              &to meso', 'mm / day', &
             missing_value=missing_value)

      id_ci_precip_budget(5,2)    = register_diag_field    &
            (mod_name, 'ci_precip_trans_ice_melt', axes(1:2),   &
             Time, 'col intg precip from cell ice transferred to &
             &meso which melted', 'mm / day', &
             missing_value=missing_value)

      id_ci_precip_budget(1,3)    = register_diag_field    &
            (mod_name, 'ci_precip_meso_liq', axes(1:2),   &
             Time, 'col intg precip from meso liq condensate', &
             'mm / day', &
             missing_value=missing_value)

      id_ci_precip_budget(2,3)    = register_diag_field    &
            (mod_name, 'ci_precip_meso_liq_frz', axes(1:2),   &
             Time, 'col intg precip from meso liq  condensate &
             &which froze',  'mm / day', &
             missing_value=missing_value)

      id_ci_precip_budget(3,3)    = register_diag_field    &
            (mod_name, 'ci_precip_meso_liq_frz_melt', axes(1:2), Time, &
             'col intg precip from meso condensate liq which froze &
               &and remelted', 'mm / day', &
             missing_value=missing_value)

      id_ci_precip_budget(4,3)    = register_diag_field    &
            (mod_name, 'ci_precip_meso_ice', axes(1:2),   &
             Time, 'col intg precip from meso ice condensate', &
             'mm / day', &
             missing_value=missing_value)

      id_ci_precip_budget(5,3)    = register_diag_field    &
            (mod_name, 'ci_precip_meso_ice_melt', axes(1:2),   &
             Time, 'col intg precip from meso ice condensate &
              &which melted', 'mm / day', &
             missing_value=missing_value)

      id_ci_water_budget(1)    = register_diag_field    &
            (mod_name, 'ci_vapor_net_tend', axes(1:2),   &
             Time, 'col intg net water vapor tendency', 'mm / day',    &
             missing_value=missing_value)
      
      id_ci_water_budget(2)    = register_diag_field    &
            (mod_name, 'ci_vapor_cell_dynam', axes(1:2),   &
             Time, 'col intg vapor tendency due to cell dynamics', &
              'mm / day',    &
             missing_value=missing_value)
      
      id_ci_water_budget(3)    = register_diag_field    &
            (mod_name, 'ci_vapor_meso_depo', axes(1:2),   &
             Time, 'col intg vapor tendency from mesoscale deposition',&
              'mm / day',    &
             missing_value=missing_value)
      
      id_ci_water_budget(4)    = register_diag_field    &
            (mod_name, 'ci_vapor_meso_cd', axes(1:2),   &
             Time, 'col intg vapor tendency from mesoscale &
              &condensation',  'mm / day',    &
             missing_value=missing_value)
      
      id_ci_water_budget(5)    = register_diag_field    &
            (mod_name, 'ci_vapor_cell_evap', axes(1:2),   &
             Time, 'col intg vapor tendency from cell evaporation', &
              'mm / day', missing_value=missing_value)
      
      id_ci_water_budget(6)    = register_diag_field    &
            (mod_name, 'ci_vapor_cell_meso_trans', axes(1:2),   &
             Time, 'col intg vapor tendency from cell to mesoscale &
              &transfer',  'mm / day',    &
             missing_value=missing_value)
      
      id_ci_water_budget(7)    = register_diag_field    &
            (mod_name, 'ci_vapor_meso_evap', axes(1:2),   &
             Time, 'col intg vapor tendency from mesoscale &
              &evaporation', 'mm / day',    &
             missing_value=missing_value)
      
      id_ci_water_budget(8)    = register_diag_field    &
            (mod_name, 'ci_vapor_meso_dynam_up', axes(1:2),   &
             Time, 'col intg vapor tendency from mesoscale updrafts',  &
              'mm / day',    &
             missing_value=missing_value)
      
      id_ci_water_budget(9)    = register_diag_field    &
            (mod_name, 'ci_vapor_meso_dynam_dn',  axes(1:2),   &
             Time, 'col intg vapor tendency from mesoscale downdrafts',&
              'mm / day',    &
             missing_value=missing_value)
      
      id_ci_enthalpy_budget(1)    = register_diag_field    &
            (mod_name, 'ci_enth_net_tend', axes(1:2),   &
             Time, 'col intg net enthalpy tendency', 'J/m**2 / day',   &
             missing_value=missing_value)

      id_ci_enthalpy_budget(2)    = register_diag_field    &
            (mod_name, 'ci_enth_cell_dynam', axes(1:2),   &
             Time, 'col intg enthalpy tendency due to cell dynamics', &
              'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(3)    = register_diag_field    &
            (mod_name, 'ci_enth_meso_depo_liq', axes(1:2),   &
             Time, 'col intg enthalpy tendency from mesoscale &
             &deposition on liquid condensate',  'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(4)    = register_diag_field    &
            (mod_name, 'ci_enth_meso_cd_liq', axes(1:2),   &
             Time, 'col intg enthalpy tendency from mesoscale &
             &liquid condensation', 'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(5)    = register_diag_field    &
            (mod_name, 'ci_enth_cell_evap_liq', axes(1:2),   &
             Time, 'col intg enthalpy tendency from evap of liquid &
             &condensate',  'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(6)    = register_diag_field    &
            (mod_name, 'ci_enth_meso_evap_liq_up', axes(1:2),   &
             Time, 'col intg enthalpy tendency from evaporation of &
             &liquid condensate in mesoscale updrafts',  &
             'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(7)    = register_diag_field    &
            (mod_name, 'ci_enth_meso_evap_liq_dn', axes(1:2),   &
             Time, 'col intg enthalpy tendency from evaporation &
             &of liquid condensate in mesoscale downdrafts',  &
              'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(8)    = register_diag_field    &
            (mod_name, 'ci_enth_meso_depo_ice', axes(1:2),   &
             Time, 'col intg enthalpy tendency from mesoscale &
              &deposition on ice condensate',  &
              'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(9)    = register_diag_field    &
            (mod_name, 'ci_enth_meso_cd_ice', axes(1:2),   &
             Time, 'col intg enthalpy tendency from mesoscale ice &
             &condensation', 'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(10)    = register_diag_field    &
            (mod_name, 'ci_enth_cell_evap_ice', axes(1:2),   &
             Time, 'col intg enthalpy tendency from evap of ice &
              &condensate', 'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(11)    = register_diag_field    &
            (mod_name, 'ci_enth_meso_evap_ice_up', axes(1:2),   &
             Time, 'col intg enthalpy tendency from evaporation of &
             &ice condensate in mesoscale updrafts',  'J/m**2 / day',  &
             missing_value=missing_value)

      id_ci_enthalpy_budget(12)    = register_diag_field    &
            (mod_name, 'ci_enth_meso_evap_ice_dn', axes(1:2),   &
             Time, 'col intg enthalpy tendency from evaporation of &
             &ice condensate in mesoscale downdrafts',  &
              'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(13)    = register_diag_field    &
            (mod_name, 'ci_enth_meso_freeze', axes(1:2),   &
             Time, 'col intg enthalpy tendency from the freezing of &
             &liquid condensate when it enters the mesoscale &
             &circulation',  'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(14)    = register_diag_field    &
            (mod_name, 'ci_enth_cell_freeze', axes(1:2),   &
             Time, 'col intg enthalpy tendency from the freezing of &
             &liquid cell condensate', 'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(15)    = register_diag_field    &
            (mod_name, 'ci_enth_cell_precip_melt', axes(1:2),   &
             Time, 'col intg enthalpy tendency from the melting of &
             &cell frozen liquid and ice that is precipitating out',  &
              'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(16)    = register_diag_field    &
            (mod_name, 'ci_enth_meso_melt', axes(1:2),   &
             Time, 'col intg enthalpy tendency from melting bogus &
              &frozen condensate',  'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(17)    = register_diag_field    &
            (mod_name, 'ci_enth_meso_precip_melt', axes(1:2),   &
             Time, 'col intg enthalpy tendency from the melting of &
              &frozen mesoscale precipitation',  &
              'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(18)    = register_diag_field    &
            (mod_name, 'ci_enth_meso_dynam_up', axes(1:2),   &
             Time, 'col intg enthalpy tendency from mesoscale updraft',&
              'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_enthalpy_budget(19)    = register_diag_field    &
            (mod_name, 'ci_enth_meso_dynam_dn', axes(1:2),   &
             Time, 'col intg enthalpy tendency from mesoscale &
             &downdraft',  'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_prcp_heat_frz_cell =  register_diag_field & 
            (mod_name, 'ci_prcp_heat_frz_cell', axes(1:2),   &
             Time, 'col intg heat removed by frozen cell precip', &
              'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_prcp_heat_liq_cell =  register_diag_field & 
            (mod_name, 'ci_prcp_heat_liq_cell', axes(1:2),   &
             Time, 'col intg heat removed by liquid cell precip', &
              'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_prcp_heat_frz_meso =  register_diag_field & 
            (mod_name, 'ci_prcp_heat_frz_meso', axes(1:2),   &
             Time, 'col intg heat removed by frozen meso precip', &
              'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_prcp_heat_liq_meso =  register_diag_field & 
            (mod_name, 'ci_prcp_heat_liq_meso', axes(1:2),   &
             Time, 'col intg heat removed by liquid meso precip', &
              'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_prcp_heat_total =  register_diag_field & 
            (mod_name, 'ci_prcp_heat_total', axes(1:2),   &
             Time, 'col intg total heat removed by precip', &
              'J/m**2 / day',    &
             missing_value=missing_value)

      id_ci_prcp_total =  register_diag_field & 
            (mod_name, 'ci_prcp_total', axes(1:2),   &
             Time, 'col intg total precip', &
              'mm / day',    &
             missing_value=missing_value)

    endif

      id_leff          = register_diag_field    &
            (mod_name, 'leff_don', axes(1:2),   &
             Time, 'effective latent heat with donner precip ',  &
             'J/kg(h2o)',  missing_value=missing_value)

!    heating rate:
      id_cemetf_deep = register_diag_field    &
            (mod_name, 'cemetf_deep', axes(1:3),   &
             Time, 'heating rate, c + m ', 'K/s',   &
             missing_value=missing_value)

!    cell entropy flux convergence:
      id_ceefc_deep = register_diag_field   &
            (mod_name, 'ceefc_deep', axes(1:3),   &
             Time, 'cell entrpy flx cnvrgnc', 'K/s',   &
             missing_value=missing_value)

!    cell condensation / evaporation:
      id_cecon_deep = register_diag_field      &
            (mod_name, 'cecon_deep', axes(1:3),   &
             Time, 'cell cond/evap ', 'K/s',   &
             missing_value=missing_value)

!    cell moisture flux convergence:
      id_cemfc_deep = register_diag_field       &
            (mod_name, 'cemfc_deep', axes(1:3),   &
             Time, 'cell moist flx cnvgnc', 'kg(h2o)/kg/s',   &
             missing_value=missing_value)

!    moistening rate:
      id_cememf_deep = register_diag_field        &
            (mod_name, 'cememf_deep', axes(1:3),   &
             Time, 'moistening rate, c + m ', 'kg(h2o)/kg/s',   &
             missing_value=missing_value)

!    moistening rate after adjustment for negative vapor mixing ratio:
      id_cememf_mod_deep = register_diag_field       &
            (mod_name, 'cememf_mod_deep', axes(1:3),&
             Time, 'mod cememf due to negative q ', 'kg(h2o)/kg/s',   &
             missing_value=missing_value)

!    cell + mesoscale cloud fraction:
      id_cual_deep = register_diag_field      &
            (mod_name, 'cual_deep', axes(1:3),   &
             Time, 'c + m cld frac ', 'percent',   &
             missing_value=missing_value)

!    heating rate due to freezing:
      id_fre_deep = register_diag_field     &
            (mod_name, 'fre_deep', axes(1:3),   &
             Time, 'freezing ', 'K/sec',   &
             missing_value=missing_value)

!    heating rate due to melting:
      id_elt_deep = register_diag_field         &
            (mod_name, 'elt_deep', axes(1:3),   &
             Time, 'melting', 'K/sec',   &
             missing_value=missing_value)

!    deposition in mesoscale updraft:
      id_cmus_deep = register_diag_field        &
            (mod_name, 'cmus_deep', axes(1:3),   &
             Time, 'meso-up deposition', 'kg(h2o)/kg/sec)',   &
             missing_value=missing_value)

!    evaporation in convective downdraft:
      id_ecds_deep = register_diag_field    &
            (mod_name, 'ecds_deep', axes(1:3),   &
             Time, 'convective dwndrft evap ', 'kg(h2o)/kg/sec', &
             missing_value=missing_value)

!    evaporation / sublimation in convective updraft:
      id_eces_deep = register_diag_field       &
            (mod_name, 'eces_deep', axes(1:3),   &
             Time, 'convective updrft evap/subl ', 'kg(h2o)/kg/sec',  &
             missing_value=missing_value)

!    sublimation in mesoscale downdraft:
      id_emds_deep = register_diag_field     &
            (mod_name, 'emds_deep', axes(1:3),   &
             Time, 'meso-dwn subl ', 'kg(h2o)/kg/sec',   &
             missing_value=missing_value)

!    sublimation in mesoscale updraft:
      id_emes_deep = register_diag_field        &
            (mod_name, 'emes_deep', axes(1:3),   &
             Time, 'meso-up subl ', 'kg(h2o)/kg/sec',   &
             missing_value=missing_value)

!    mesoscale moisture flux convergence:
      id_qmes_deep = register_diag_field     &
             (mod_name, 'qmes_deep', axes(1:3),   &
              Time, 'meso moist flux conv', 'kg(h2o)/kg/sec',   &
              missing_value=missing_value)

!    transfer of vapor from cells to mesoscale:
      id_wmps_deep = register_diag_field      &
             (mod_name, 'wmps_deep', axes(1:3),   &
              Time, 'meso redistrib of vapor from cells',  &
              'kg(h2o)/kg/sec', missing_value=missing_value)

!    deposition of vapor from cells to mesoscale:
      id_wmms_deep = register_diag_field         &
             (mod_name, 'wmms_deep', axes(1:3),   &
              Time, 'meso depo of vapor from cells',    &
              'kg(h2o)/kg/sec',  missing_value=missing_value)

!    mesoscale entropy flux convergesnce:
      id_tmes_deep = register_diag_field         &
            (mod_name, 'tmes_deep', axes(1:3),   &
             Time, 'meso entropy flux conv',  'K/sec',   &
              missing_value=missing_value)
 
!    mass flux in mesoscale downdrafts:    
      id_dmeml_deep = register_diag_field      &
            (mod_name, 'dmeml_deep', axes(1:3), &  
             Time, 'mass flux meso dwndrfts', 'kg/((m**2) s)',   &
             missing_value=missing_value)

!    mass flux in cell updrafts:
      id_uceml_deep = register_diag_field     &
            (mod_name, 'uceml_deep', axes(1:3), &
             Time, 'mass flux cell updrfts', 'kg/((m**2) s)',   &
             missing_value=missing_value)

!    mass flux in mesoscale updrafts:
      id_umeml_deep = register_diag_field       &
            (mod_name, 'umeml_deep', axes(1:3), &
             Time, 'mass flux meso updrfts', 'kg/((m**2) s)',   &
             missing_value=missing_value)

!    mesoscale ice mass mixing ratio:
      id_xice_deep = register_diag_field     &
            (mod_name, 'xice_deep', axes(1:3),  &
             Time, 'meso ice mass mixing ratio ', 'kg(ice)/kg',   &
             missing_value=missing_value)

!    mesoscale liquid mass mixing ratio:
      id_xliq_deep = register_diag_field       &
            (mod_name, 'xliq_deep', axes(1:3),  &
             Time, 'meso liq mass mixing ratio ', 'kg(liq)/kg',   &
             missing_value=missing_value)

!    detrained mass flux:
      id_detmfl_deep = register_diag_field       &
            (mod_name, 'detmfl_deep', axes(1:3),  &
             Time, 'detrained mass flux ', 'kg/((m**2) s)',   &
             missing_value=missing_value)

!---------------------------------------------------------------------
!    if tracers are being transported by donner_deep_mod, allocate diag-
!    nostic indices for each tracer and register their diagnostics.
!---------------------------------------------------------------------
      if (ntracers > 0) then
        allocate (id_qtren1 (ntracers))
        allocate (id_qtmes1 (ntracers))
        allocate (id_wtp1   (ntracers))
        allocate (id_qtceme (ntracers))
        allocate (id_total_wet_dep (ntracers))
        allocate (id_meso_wet_dep (ntracers))
        allocate (id_cell_wet_dep (ntracers))
        allocate (id_qtren1_col (ntracers))
        allocate (id_qtmes1_col (ntracers))
        allocate (id_wtp1_col   (ntracers))
        allocate (id_qtceme_col (ntracers))
        allocate (id_total_wet_dep_col (ntracers))
        allocate (id_meso_wet_dep_col (ntracers))
        allocate (id_cell_wet_dep_col (ntracers))
        do nn=1,ntracers

!    tracer tendency due to cells:
          id_qtren1(nn) = register_diag_field     &
                (mod_name, trim(Don_save%tracername(nn)) // '_qtren1',  &
                 axes(1:3), Time,  &
                 trim(Don_save%tracername(nn)) // ' cell tendency ', &
                 trim(Don_save%tracer_units(nn))//'/s', &
                 missing_value=missing_value)

!    tracer tendency due to mesoscale circulation:
          id_qtmes1(nn) = register_diag_field    &
                (mod_name, trim(Don_save%tracername(nn)) // '_qtmes1', &
                 axes(1:3), Time,   &
                 trim(Don_save%tracername(nn)) //' mesoscale tendency',&
                 trim(Don_save%tracer_units(nn))//'/s', &
                 missing_value=missing_value)

!    tracer tendency due to mesoscale redistribution:
          id_wtp1(nn) = register_diag_field         &
                (mod_name, trim(Don_save%tracername(nn)) // '_wtp1',  &
                 axes(1:3), Time,  &
                 trim(Don_save%tracername(nn)) //' mesoscale redist',&
                 trim(Don_save%tracer_units(nn))//'/s', &
                 missing_value=missing_value)

 !    tracer tendency due to deep convective wet deposition:
          id_total_wet_dep(nn) = register_diag_field         &
              (mod_name, trim(Don_save%tracername(nn)) // '_totwdep',  &
                 axes(1:3), Time,  &
                 trim(Don_save%tracername(nn)) //' deep conv wet depo',&
                 trim(Don_save%tracer_units(nn))//'/s', &
                 missing_value=missing_value)

!    tracer tendency due to wet deposition in mesoscale updrafts:
         id_meso_wet_dep(nn) = register_diag_field         &
                 (mod_name, trim(Don_save%tracername(nn)) // '_mwdep', &
                  axes(1:3), Time,   &
                 trim(Don_save%tracername(nn)) //' mesoscale wet depo',&
                 trim(Don_save%tracer_units(nn))//'/s', &
                 missing_value=missing_value)

!    tracer tendency due to wet deposition in cells:
          id_cell_wet_dep(nn) = register_diag_field         &
                (mod_name, trim(Don_save%tracername(nn)) // '_cwdep', &
                 axes(1:3), Time,  &
                 trim(Don_save%tracername(nn)) //' cell wet depo',&
                 trim(Don_save%tracer_units(nn))//'/s', &
                 missing_value=missing_value)

!    total tracer tendency:
          id_qtceme(nn) = register_diag_field     &
                (mod_name, trim(Don_save%tracername(nn)) // '_qtceme', &
                 axes(1:3), Time,  &
                 trim(Don_save%tracername(nn)) // ' total tendency ',&
                 trim(Don_save%tracer_units(nn))//'/s', &
                 missing_value=missing_value)

!    column-integrated tracer tendency due to cells:
          id_qtren1_col(nn) = register_diag_field      &
                (mod_name,       &
                 trim(Don_save%tracername(nn)) // '_qtren1_col',  &
                 axes(1:2), Time,  & 
                 'column integrated ' //trim(Don_save%tracername(nn)) //&
                 ' cell tendency ', &
                 trim(Don_save%tracer_units(nn)) // '* kg/(m**2 s) ', &
                 missing_value=missing_value)

!    column-integrated tracer tendency due to mesoscale circulation:
          id_qtmes1_col(nn) = register_diag_field    &
                (mod_name,          &
                 trim(Don_save%tracername(nn)) // '_qtmes1_col',  &
                 axes(1:2), Time,   &
                 'column integrated ' //trim(Don_save%tracername(nn)) //&
                 ' mesoscale tendency',&
                trim(Don_save%tracer_units(nn)) // '* kg/(m**2 s) ', &
                 missing_value=missing_value)

!    column-integrated tracer tendency due to mesoscale redistribution:
          id_wtp1_col(nn) = register_diag_field     &
                (mod_name,  &
                 trim(Don_save%tracername(nn)) // '_wtp1_col',   &
                 axes(1:2), Time,  &
                 'column integrated '//trim(Don_save%tracername(nn)) // &
                 ' mesoscale redist',&
               trim(Don_save%tracer_units(nn)) // '* kg/(m**2 s) ', &
                missing_value=missing_value)

!    column-integrated tracer tendency due to deep convective wet 
!    deposition: 
          id_total_wet_dep_col(nn) = register_diag_field     &
                 (mod_name,  &
                  trim(Don_save%tracername(nn)) // '_totwdep_col',   &
                  axes(1:2), Time,  &
                'column integrated '//trim(Don_save%tracername(nn)) // &
                ' deep convective wet depo',&
                 trim(Don_save%tracer_units(nn)) // '* kg/(m**2 s) ', &
                 missing_value=missing_value)

!    column-integrated tracer tendency due to mesocscale updraft  wet 
!    deposition: 
          id_meso_wet_dep_col(nn) = register_diag_field     &
                (mod_name,  &
                  trim(Don_save%tracername(nn)) // '_mwdep_col',   &
                  axes(1:2), Time,  &
                'column integrated '//trim(Don_save%tracername(nn)) // &
                 ' meso updraft wet depo',&
                  trim(Don_save%tracer_units(nn)) // '* kg/(m**2 s) ', &
                 missing_value=missing_value)

!    column-integrated tracer tendency due to wet deposition in cells:
          id_cell_wet_dep_col(nn) = register_diag_field     &
                (mod_name,  &
                 trim(Don_save%tracername(nn)) // '_cwdep_col',   &
                  axes(1:2), Time,  &
                'column integrated '//trim(Don_save%tracername(nn)) // &
                  ' cell wet depo',&
                 trim(Don_save%tracer_units(nn)) // '* kg/(m**2 s) ', &
                  missing_value=missing_value)

!    column-integrated total tracer tendency:
          id_qtceme_col(nn) = register_diag_field     &
                (mod_name,  &
                 trim(Don_save%tracername(nn)) // '_qtceme_col',  &
                 axes(1:2), Time,  &
                 'column integrated ' //trim(Don_save%tracername(nn)) //&
                 ' total tendency ', &
                  trim(Don_save%tracer_units(nn)) // '* kg/(m**2 s) ', &
                 missing_value=missing_value)
        end do
      endif

!    mesoscale ice generalized effective size:
      id_dgeice_deep = register_diag_field    &
            (mod_name, 'dgeice_deep', axes(1:3), &
             Time, 'meso ice gen eff size ', 'micrometers',   &
             missing_value=missing_value)

!    cell ice mixing ratio:
      id_cuqi_deep = register_diag_field         &
            (mod_name, 'cuqi_deep', axes(1:3),  &
             Time, 'cell ice ', 'kg(H2O)/kg',   &
             missing_value=missing_value)

!    cell liquid mixing ratio:
      id_cuql_deep = register_diag_field     &
            (mod_name, 'cuql_deep', axes(1:3),  &
             Time, 'cell liquid ', 'kg(H2O)/kg',   &
             missing_value=missing_value)

!    cell liquid generalized effective size:
      id_dgeliq_deep = register_diag_field    &
            (mod_name, 'dgeliq_deep', axes(1:3), &
             Time, 'cell liq gen eff size ', 'micrometers',   &
             missing_value=missing_value)

!    pressure at lifting condensation level:
      id_plcl_deep = register_diag_field       &
            (mod_name, 'plcl_deep', axes(1:2),   &
             Time, 'pressure at lcl ', 'Pa ',   &
             missing_value=missing_value)

!    pressure at level of free convection:
      id_plfc_deep = register_diag_field     &
            (mod_name, 'plfc_deep', axes(1:2),   &
             Time, 'pressure at lfc ', 'Pa ',   &
             missing_value=missing_value)

!    pressure at level of zero buoyancy:  
      id_plzb_deep = register_diag_field      &
            (mod_name, 'plzb_deep', axes(1:2),   &
             Time, 'pressure at lzb ', 'Pa ',   &
             missing_value=missing_value)

!    convective available potential energy (cape):
      id_xcape_deep = register_diag_field      &
            (mod_name, 'xcape_deep', axes(1:2),  &
             Time, 'cape', 'J/kg',   &
             missing_value=missing_value)

!    convective inhibition:
      id_coin_deep = register_diag_field      &
            (mod_name, 'coin_deep', axes(1:2),   &
             Time, 'convective inhibition ', 'J/kg',   &
             missing_value=missing_value)

!    time tendency of cape:
      id_dcape_deep = register_diag_field      &
            (mod_name, 'dcape_deep', axes(1:2), &
             Time, 'time tendency of cape ', 'J/kg/sec',   &
             missing_value=missing_value)

!    column integrated water vapor:
      id_qint_deep = register_diag_field    &
            (mod_name, 'qint_deep', axes(1:2),   &
             Time, 'column moisture ', 'kg(h2o)/m**2',   &
             missing_value=missing_value)

!    fractional area of cumulus ensemble member:
      id_a1_deep = register_diag_field           &
            (mod_name, 'a1_deep', axes(1:2),   &
             Time, 'fractional area of cu subensemble ', 'percent',   &
             missing_value=missing_value)

!    fractional area of largest cumulus ensemble member:
      id_amax_deep = register_diag_field      &
            (mod_name, 'amax_deep', axes(1:2),   &
             Time, 'fractional area of largest cu subensemble ',  &
             'percent',  missing_value=missing_value)

!    upper limit onfractional area based on moisture constraint:
      id_amos_deep = register_diag_field      &
            (mod_name, 'amos_deep', axes(1:2),   &
             Time, 'uppr lmt on frac area from moisture', 'percent', &
             missing_value=missing_value)

!    area-weighted total precipitation:
      id_tprea1_deep = register_diag_field         &
            (mod_name, 'tprea1_deep', axes(1:2), &
             Time, 'area wtd total precip ', 'mm/day',   &
             missing_value=missing_value)

!    mesoscale cloud fraction:
      id_ampta1_deep = register_diag_field       &
            (mod_name, 'ampta1_deep', axes(1:2), &
             Time, 'meso cld frac', 'percent',   &
             missing_value=missing_value)

!    accumulated low-level vertical displacement:
      id_omint_deep = register_diag_field      &
            (mod_name, 'omint_deep', axes(1:2), &
             Time, 'accumulated low-lvl displ', 'Pa ',   &
             missing_value=missing_value)

!    area-weighted convective precipitation:
      id_rcoa1_deep = register_diag_field     &
            (mod_name, 'rcoa1_deep', axes(1:2),  &
             Time, 'area wtd cnvctv precip ', 'mm/day',   &
             missing_value=missing_value)

!----------------------------------------------------------------------

    if (do_ensemble_diagnostics) then
!
      allocate ( id_cpre_cem(ncem))
      allocate ( id_pb_cem(ncem))
      allocate ( id_ptma_cem(ncem))
      allocate ( id_h1_cem(ncem))
      allocate ( id_qlw_cem(ncem))
      allocate ( id_cfi_cem(ncem))
      allocate ( id_wv_cem(ncem))
      allocate ( id_rcl_cem(ncem))
!  Donner cumulus ensemble member diagnostics
!
!    GCM model pressure field on full levels:
      id_pfull_cem = register_diag_field  &
            (mod_name, 'p_full', axes(1:3), &
             Time, 'GCM model pressure on full levels (lo-res)', 'Pa', &
             missing_value=missing_value)

!    GCM model pressure field on half levels:
      id_phalf_cem = register_diag_field  &
            (mod_name, 'p_half', axes(half), &
             Time, 'GCM model pressure on half levels (lo-res)', 'Pa', &
             missing_value=missing_value)

!    GCM model height field on full levels:
      id_zfull_cem = register_diag_field  &
            (mod_name, 'z_full', axes(1:3), &
             Time, 'GCM model height on full levels (lo-res)', 'm', &
             missing_value=missing_value)

!    GCM model height field on half levels:
      id_zhalf_cem = register_diag_field  &
            (mod_name, 'z_half', axes(half), &
             Time, 'GCM model height on half levels (lo-res)', 'm', &
             missing_value=missing_value)

!    GCM model temperature field on full levels:
      id_temp_cem = register_diag_field  &
            (mod_name, 'temp', axes(1:3), &
             Time, 'GCM model temperature on full levels (lo-res)', 'K', &
             missing_value=missing_value)

!    GCM model mixing ratio field on full levels:
      id_mixing_ratio_cem = register_diag_field  &
            (mod_name, 'mixing_ratio', axes(1:3), &
             Time, 'GCM model mixing ratio on full levels (lo-res)', &
             'kg(h2o)/kg(dry air)', &
             missing_value=missing_value)

      do nn=1,ncem

        if( nn <= 9 )then
          write( chvers, '(i1)' ) nn
        else if( nn <= 99 )then
          write( chvers, '(i2)' ) nn
        else
          print *, 'Error in subroutine register_fields:'
          print *, '  number of specified cumulus ensemble members = ',ncem
          print *, '  is more than current limit of 99.'
!          stop
        call error_mesg ('fms_donner_mod', 'register_fields: & 
         &Error in subroutine register_fields : number of specified &
         &cumulus ensemble members is more than current limit of 99.',&
                                                                  FATAL) 
        endif

!    area-weighted convective precipitation rate:
        id_cpre_cem(nn) = register_diag_field  &
            (mod_name, 'cpre_cem'//TRIM(chvers), axes(1:2), &
             Time, 'area wtd cnvctv precip rate - member '//TRIM(chvers), &
             'mm/day', &
             missing_value=missing_value)

!    pressure at cloud base:
        id_pb_cem(nn) = register_diag_field  &
            (mod_name, 'pb_cem'//TRIM(chvers), axes(1:2), &
             Time, 'pressure at cloud base - member '//TRIM(chvers), &
             'Pa', &
             missing_value=missing_value)

!    pressure at cloud top:
        id_ptma_cem(nn) = register_diag_field  &
            (mod_name, 'ptma_cem'//TRIM(chvers), axes(1:2), &
             Time, 'pressure at cloud top - member '//TRIM(chvers), &
             'Pa', &
             missing_value=missing_value)

!    condensation rate profile on lo-res grid:
        id_h1_cem(nn) = register_diag_field  &
            (mod_name, 'h1_cem'//TRIM(chvers), axes(1:3), &
             Time, 'condensation rate profile - member '//TRIM(chvers), &
             'kg(h2o)/(kg(dry air) sec)', &
             missing_value=missing_value)
        
! IF LOOP HERE:
       if (.not. do_donner_plume) then
!    cloud water profile on lo-res grid:
        id_qlw_cem(nn) = register_diag_field  &
            (mod_name, 'qlw_cem'//TRIM(chvers), axes(1:3), &
             Time, 'cloud water profile - member '//TRIM(chvers), &
            'kg(h2o)/kg(air)', &
             missing_value=missing_value)

!    fraction of condensate that is ice on lo-res grid:
        id_cfi_cem(nn) = register_diag_field  &
            (mod_name, 'cfi_cem'//TRIM(chvers), axes(1:3), &
             Time, 'condensate ice fraction - member '//TRIM(chvers), &
             'fraction', &
             missing_value=missing_value)

!    vertical velocity profile in plume on lo-res grid:
        id_wv_cem(nn) = register_diag_field  &
            (mod_name, 'wv_cem'//TRIM(chvers), axes(1:3), &
             Time, 'plume vertical velocity - member '//TRIM(chvers), &
             'm / s', &
             missing_value=missing_value)

!    cloud radius profile in plume on lo-res grid:
        id_rcl_cem(nn) = register_diag_field  &
            (mod_name, 'rcl_cem'//TRIM(chvers), axes(1:3), &
             Time, 'plume cloud radius - member '//TRIM(chvers), &
             'm', &
             missing_value=missing_value)

        else
!    cloud water profile on hi-res grid:
        id_qlw_cem(nn) = register_diag_field  &
            (mod_name, 'qlw_cem'//TRIM(chvers), donner_axes(cldindices), &
             Time, 'cloud water profile - member '//TRIM(chvers), &
            'kg(h2o)/kg(air)', &
             missing_value=missing_value)

!    fraction of condensate that is ice on hi-res grid:
        id_cfi_cem(nn) = register_diag_field  &
            (mod_name, 'cfi_cem'//TRIM(chvers), donner_axes(cldindices), &
             Time, 'condensate ice fraction - member '//TRIM(chvers), &
             'fraction', &
             missing_value=missing_value)

!    vertical velocity profile in plume on hi-res grid:
        id_wv_cem(nn) = register_diag_field  &
            (mod_name, 'wv_cem'//TRIM(chvers), donner_axes(cldindices), &
             Time, 'plume vertical velocity - member '//TRIM(chvers), &
             'm / s', &
             missing_value=missing_value)

!    cloud radius profile in plume on hi-res grid:
        id_rcl_cem(nn) = register_diag_field  &
            (mod_name, 'rcl_cem'//TRIM(chvers), donner_axes(cldindices), &
             Time, 'plume cloud radius - member '//TRIM(chvers), &
             'm', &
             missing_value=missing_value)

        endif
      enddo

!    area-weighted mesoscale precipitation rate:
        id_mpre_cem = register_diag_field  &
            (mod_name, 'mpre_cem', axes(1:2), &
             Time, 'area wtd mesoscale precip rate ', &
             'mm/day', &
             missing_value=missing_value)

!    fractional area sum:
      id_a1_cem = register_diag_field  &
            (mod_name, 'a1_cem', axes(1:2), &
             Time, 'fractional area sum', 'fraction', &
             missing_value=missing_value)

!    cloud fraction, cells+meso, normalized by a(1,p_b) on lo-res grid:
      id_cual_cem = register_diag_field  &
            (mod_name, 'cual_cem', axes(1:3), &
             Time, 'cloud fraction, cells+meso, normalized by a(1,p_b)', &
             'fraction', &
             missing_value=missing_value)

!    time tendency of temperature due to deep convection on lo-res grid:
      id_tfrc_cem = register_diag_field  &
            (mod_name, 'tfrc_cem', axes(1:3), &
             Time, 'temperature tendency due to deep convection (lo-res)', &
             'K/sec', missing_value=missing_value)

    endif ! (do_ensemble_diagnostics)

end subroutine register_fields 

!#####################################################################

subroutine process_coldstart (Time, Initialized, Nml, Don_save)

!-----------------------------------------------------------------------
!    subroutine process_coldstart provides initialization that is needed
!    when the job is a donner_deep coldstart, or if the user-supplied 
!    restart file is not usable for a restart with the current code 
!    version.
!-----------------------------------------------------------------------

type(time_type), intent(in) :: Time
type(donner_initialized_type), intent(inout) :: Initialized
type(donner_save_type), intent(inout) :: Don_save
type(donner_nml_type), intent(inout) :: Nml     

!---------------------------------------------------------------------
!   intent(in) variables:
!
!        Time      current time [ time_type, secs and days ]
!
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!   local variables:

      integer  :: days, secs   ! components of current time

!---------------------------------------------------------------------
!    set the coldstart flag to .true.. set the time until the first cal-
!    culation call to donner_deep_mod, donner_deep calculation calls will
!    be every donner_deep_freq seconds after the start of the day.
!---------------------------------------------------------------------
      Initialized%coldstart = .true.
      call get_time (Time, secs, days)
      if (secs == 0) then    ! i.e., 00Z
        Initialized%conv_alarm = Nml%donner_deep_freq
      else 
        Initialized%conv_alarm = Nml%donner_deep_freq -   &
                                 MOD (secs, Nml%donner_deep_freq)
      endif

!----------------------------------------------------------------------
!    initialize the variables which must be returned from donner_deep_mod
!    on the first step when coldstarting.
!----------------------------------------------------------------------
      Don_save%cemetf            = 0.
      Don_save%cememf            = 0.
      Don_save%tracer_tends      = 0.
      Don_save%mass_flux         = 0.
      Don_save%mflux_up          = 0.
      Don_save%cell_up_mass_flux = 0.
      Don_save%det_mass_flux     = 0.
      Don_save%dql_strat         = 0.
      Don_save%dqi_strat         = 0.
      Don_save%dqa_strat         = 0.
      Don_save%humidity_area     = 0.
      Don_save%humidity_factor   = 0.
      Don_save%tprea1            = 0.
      Don_save%parcel_disp       = 0.

!----------------------------------------------------------------------


end subroutine process_coldstart

!#####################################################################
! register restart field to be written to restart file.
subroutine fms_donner_register_restart(fname, Initialized, ntracers, Don_save, Nml)
  character(len=*),                 intent(in) :: fname
  type(donner_initialized_type), intent(inout) :: Initialized
  integer,                          intent(in) :: ntracers
  type(donner_save_type),        intent(inout) :: Don_save
  type(donner_nml_type),         intent(inout) :: Nml
  character(len=64)                            :: fname2
  integer :: id_restart, n

   call get_mosaic_tile_file(fname, fname2, .false. ) 
   allocate(Don_restart)
   if(trim(fname2) == trim(fname)) then
      Til_restart => Don_restart
      in_different_file = .false.
   else
      in_different_file = .true.
      allocate(Til_restart)
   endif

   id_restart = register_restart_field(Don_restart, fname, 'conv_alarm', Initialized%conv_alarm, no_domain = .true.)
   id_restart = register_restart_field(Don_restart, fname, 'donner_deep_freq', Nml%donner_deep_freq, no_domain = .true.)

   if (.not. (write_reduced_restart_file) .or. &
        Initialized%conv_alarm >  Initialized%physics_dt)  then
      id_restart = register_restart_field(Til_restart, fname, 'cemetf', Don_save%cemetf)
      id_restart = register_restart_field(Til_restart, fname, 'cememf', Don_save%cememf)
      id_restart = register_restart_field(Til_restart, fname, 'mass_flux', Don_save%mass_flux)
      id_restart = register_restart_field(Til_restart, fname, 'cell_up_mass_flux', Don_save%cell_up_mass_flux)
      id_restart = register_restart_field(Til_restart, fname, 'det_mass_flux', Don_save%det_mass_flux)
      id_restart = register_restart_field(Til_restart, fname, 'dql_strat', Don_save%dql_strat)
      id_restart = register_restart_field(Til_restart, fname, 'dqi_strat', Don_save%dqi_strat)
      id_restart = register_restart_field(Til_restart, fname, 'dqa_strat', Don_save%dqa_strat)
      id_restart = register_restart_field(Til_restart, fname, 'tprea1', Don_save%tprea1)
      id_restart = register_restart_field(Til_restart, fname, 'humidity_area', Don_save%humidity_area)
      id_restart = register_restart_field(Til_restart, fname, 'humidity_factor', Don_save%humidity_factor)
      if (Initialized%do_donner_tracer) then
         do n=1,ntracers
            id_restart = register_restart_field(Til_restart, fname, 'tracer_tends_'// trim(Don_save%tracername(n)), &
                 Don_save%tracer_tends(:,:,:,n))
         end do
      endif
   endif
   id_restart = register_restart_field(Til_restart, fname, 'parcel_disp', Don_save%parcel_disp)
   id_restart = register_restart_field(Til_restart, fname, 'lag_temp', Don_save%lag_temp)
   id_restart = register_restart_field(Til_restart, fname, 'lag_vapor', Don_save%lag_vapor)
   id_restart = register_restart_field(Til_restart, fname, 'lag_press', Don_save%lag_press)

end subroutine fms_donner_register_restart


!#####################################################################
! <SUBROUTINE NAME="read_restart_nc">
!  <OVERVIEW>
!    read_restart_nc reads a netcdf restart file containing donner_deep
!    restart information.
!  </OVERVIEW>
!  <DESCRIPTION>
!    read_restart_nc reads a netcdf restart file containing donner_deep
!    restart information.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call read_restart_nc
!  </TEMPLATE>
! </SUBROUTINE>
!


subroutine read_restart_nc (ntracers, Initialized, Nml, Don_save)

!-----------------------------------------------------------------------
!    subroutine read_restart_nc reads a netcdf restart file to obtain 
!    the variables needed upon experiment restart. 
!-----------------------------------------------------------------------

integer, intent(in) :: ntracers
type(donner_initialized_type), intent(inout) :: Initialized
type(donner_save_type), intent(inout) :: Don_save
type(donner_nml_type), intent(inout) :: Nml     

!----------------------------------------------------------------------
!   intent(in) variables:
!
!      ntracers    number of tracers being transported by the
!                  donner deep convection parameterization in this job
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      logical,         dimension(ntracers)  :: success
      integer,         dimension(:), allocatable :: ntindices
      type(fieldtype), dimension(:), allocatable :: tracer_fields

      character(len=64)     :: fname2='INPUT/donner_deep.res.tile1'
      character(len=64)     :: fname='INPUT/donner_deep.res.nc'
      character(len=128)    :: tname
      integer               :: ndim, natt, nvar, ntime
      integer               :: old_freq
      integer               :: n_alltracers, iuic
      logical               :: is_tracer_in_restart_file
      integer, dimension(4) :: siz
      logical               :: field_found, field_found2, &
                               field_found4
      integer               :: it, jn, nn

!---------------------------------------------------------------------
!   local variables:
!
!        success          logical indicating if needed data for tracer n 
!                         was obtained from restart file
!        ntindices        array of all tracer indices
!        tracer_fields    field_type variable containing information on
!                         all restart file variables
!        fname2           restart file name without ".nc" appended, 
!                         needed as argument in call to mpp_open
!        fname            restart file name
!        tname            contains successive variable names from 
!                         restart file
!        ndim             number of dimensions in restart file
!        natt             number of attributes in restart file
!        nvar             number of variables in restart file
!        ntime            number of time levels in restart file
!        old_freq         donner_deep_freq as read from restart file;
!                         value used during previous job
!        n_alltracers     number of tracers registered with 
!                         tracer_manager_mod
!        iuic             unit number assigned to restart file
!        is_tracer_in_restart_file  
!                         should we stop searching the restart file 
!                         for the current tracer name because it has 
!                         been found ?
!        siz              sizes (each dimension) of netcdf variable 
!        field_found      is the requested variable in the restart file ?
!                         if it is not, then this is a reduced restart
!                         file
!        field_found2     is the requested variable in the restart file ?
!                         if it is not, then Don_save%det_mass_flux and
!                         Don_save%cell_up_mass_flux must be initialized
!        it, jn, nn       do-loop indices
!
!----------------------------------------------------------------------

!--------------------------------------------------------------------
!    output a message indicating entrance into this routine.
!--------------------------------------------------------------------
      if (mpp_pe() == mpp_root_pe() ) then
        call error_mesg ('donner_deep_mod',  'read_restart_nc:&
             &Reading netCDF formatted restart file: &
                                 &INPUT/donner_deep.res.nc', NOTE)
      endif

!-------------------------------------------------------------------
!    read the values of conv_alarm when the restart file was written and
!    the frequency of calculating donner deep convection effects in the
!    job which wrote the file.
!-------------------------------------------------------------------
      call read_data(fname, 'conv_alarm', Initialized%conv_alarm,   &
                                                       no_domain=.true.)
      call read_data(fname, 'donner_deep_freq', old_freq,   &
                                                       no_domain=.true.)
  
!----------------------------------------------------------------------
!    call field_size to determine if variable cemetf is present in the
!    restart file.
!----------------------------------------------------------------------
      call field_size(fname, 'cemetf', siz, field_found=field_found)

!---------------------------------------------------------------------
!    if the frequency of calculating deep convection has changed, 
!    redefine the time remaining until the next calculation.
!---------------------------------------------------------------------
      if (Nml%donner_deep_freq /= old_freq) then
        Initialized%conv_alarm = Initialized%conv_alarm - old_freq +  &
                                 Nml%donner_deep_freq
        if (mpp_pe() == mpp_root_pe()) then
          call error_mesg ('donner_deep_mod', 'read_restart_nc:  &
                   &donner_deep time step has changed', NOTE)
        endif

!----------------------------------------------------------------------
!    if cemetf is not present, then this is a reduced restart file. it 
!    is not safe to change the frequency of calculating donner 
!    effects when reading a reduced restart file, so a fatal error is
!    generated.
!----------------------------------------------------------------------
        if (.not. field_found) then
          call error_mesg ('donner_deep_mod', 'read_restart_nc: &
           & cannot use reduced restart file and change donner_deep_freq&
           & within experiment and guarantee restart reproducibility', &
                                                                  FATAL)
        endif
      endif  !(donner_deep_freq /= old_freq)

!---------------------------------------------------------------------
!    read the restart data that is present in a full restart but absent
!    in a reduced restart.
!---------------------------------------------------------------------
      if (field_found) then
        call read_data (fname, 'cemetf',  Don_save%cemetf)
        call read_data (fname, 'cememf',  Don_save%cememf)            
        call read_data (fname, 'mass_flux', Don_save%mass_flux)
        call read_data (fname, 'dql_strat', Don_save%dql_strat)
        call read_data (fname, 'dqi_strat', Don_save%dqi_strat)
        call read_data (fname, 'dqa_strat', Don_save%dqa_strat)
        call read_data (fname, 'tprea1', Don_save%tprea1)       
        call read_data (fname, 'humidity_area', Don_save%humidity_area) 

!---------------------------------------------------------------------
!  determine if humidity_factor is in file. if it is, read the values 
!  into Don_Save%humidity_factor. if it is not (it is an older file), 
!  it is only required if donner_deep will not be called on the first 
!  step of this job.
!  if that is the case, stop with a fatal error; otherwise, continue on,
!  since humidity_factor will be calculated before it is used.
!---------------------------------------------------------------------
        call field_size(fname, 'humidity_factor', siz,   &
                                              field_found=field_found4)
        if (field_found4) then
          call read_data (fname, 'humidity_factor',  &
                                              Don_save%humidity_factor)
        else if (Initialized%conv_alarm > 0.0) then
          call error_mesg ('donner_deep_mod', &
             'cannot restart with this restart file unless donner_deep &
                &calculated on first step', FATAL)
        endif

!----------------------------------------------------------------------
!    determine if det_mass_flux is present in the file.
!----------------------------------------------------------------------
        call field_size(fname, 'det_mass_flux', siz,    &
                                               field_found=field_found2)

!----------------------------------------------------------------------
!    if it is present, then read det_mass_flux and cell_up_mass_flux.
!----------------------------------------------------------------------
        if (field_found2) then
          call read_data (fname, 'det_mass_flux', Don_save%det_mass_flux)
          call read_data (fname, 'cell_up_mass_flux',    &
                                              Don_save%cell_up_mass_flux)

!----------------------------------------------------------------------
!    if it is not present (an earlier version of this file), set 
!    det_mass_flux and cell_up_mass_flux to default values.
!----------------------------------------------------------------------
        else
          Don_save%det_mass_flux     = 0.0
          Don_save%cell_up_mass_flux = 0.0
        endif

!------------------------------------------------------------------
!    if tracers are to be transported, see if tendencies are available
!    in the restart file.
!------------------------------------------------------------------
        if (Initialized%do_donner_tracer) then

!---------------------------------------------------------------------
!    initialize a logical array indicating whether the data for each
!    tracer is available.
!---------------------------------------------------------------------
          success = .false.

!---------------------------------------------------------------------
!    open the restart file with mpp_open so that the unit number is 
!    available. obtain needed file characteristics by calling 
!    mpp_read_meta and  mpp_get_info. 
!---------------------------------------------------------------------
          call mpp_open(iuic, fname2, &
               action=MPP_RDONLY, form=MPP_NETCDF, threading=MPP_SINGLE )
          call mpp_read_meta (iuic)
          call mpp_get_info (iuic, ndim, nvar, natt, ntime)

!---------------------------------------------------------------------
!    obtain information on the file variables by calling mpp_get_fields.
!    it is returned in a field_type variable tracer_fields; the specific
!    information needed is the variable name.
!---------------------------------------------------------------------
          allocate (tracer_fields(nvar))
          if (mpp_pe() == mpp_root_pe()) then
            call mpp_get_fields (iuic, tracer_fields)
          endif

!---------------------------------------------------------------------
!    call get_number_tracers to determine how many tracers are registered
!    with tracer manager. allocate an array to hold their tracer indices.
!    call get_tracer_indices to retrieve the tracer indices. 
!---------------------------------------------------------------------
          call get_number_tracers (MODEL_ATMOS, num_tracers=n_alltracers)
          allocate (ntindices(n_alltracers))
          call get_tracer_indices (MODEL_ATMOS, ind=ntindices)

!----------------------------------------------------------------------
!    loop over the tracers, obtaining their names via a call to
!    get_tracer_names. bypass those tracers known to not be transported
!    by donner convection.
!----------------------------------------------------------------------
          do it=1,n_alltracers
            call get_tracer_names (MODEL_ATMOS, ntindices(it), tname)
            if (tname == "sphum"  ) cycle
            if (tname == "liq_wat") cycle
            if (tname == "ice_wat") cycle
            if (tname == "cld_amt") cycle

!--------------------------------------------------------------------
!    initialize a logical indicating whether this tracer is in the 
!    restart file.
!--------------------------------------------------------------------
            is_tracer_in_restart_file = .FALSE.

!---------------------------------------------------------------------
!    loop over the variables in the restart file to determine if the
!    current tracer's time tendency field is present.
!---------------------------------------------------------------------
            do jn=1,nvar 
              if (lowercase (trim(mpp_get_field_name(tracer_fields(jn)))) ==   &
                  lowercase ('tracer_tends_' // trim(tname)) ) then 

!---------------------------------------------------------------------
!    if tracer tendency is in restart file, write a message. set the 
!    logical flag indicating such to .true..
!---------------------------------------------------------------------
                if (mpp_pe() == mpp_root_pe() )  then
                  print *,'tracer_tends_' // trim(tname), ' found!'
                endif
                is_tracer_in_restart_file = .TRUE.

!---------------------------------------------------------------------
!    loop over the tracers being transported by donner convection in this
!    job to determine if this tracer is one of those being transported.
!    determine the tracer index in tracername array corresponding to 
!    this tracer.
!---------------------------------------------------------------------
                do nn=1,ntracers
                  if (lowercase( 'tracer_tends_' // trim(tname) ) == &
                      'tracer_tends_' // Don_save%tracername(nn) )  then
                  
!---------------------------------------------------------------------
!    if data for this tracer is needed, read data into proper section of
!    array tracer_tends. set the logical flag for this tracer indicating 
!    successful retrieval. exit this loop.
!---------------------------------------------------------------------
                    call read_data (fname,   &
                                  'tracer_tends_' // trim(tname),   &
                                   Don_save%tracer_tends(:,:,:,nn))
                    success(nn) = .true.
                    exit
                  endif 
                end do  ! (nn)
              endif

!---------------------------------------------------------------------
!    if desired tracer has been found, stop searching the restart file
!    variables for this tracer and cycle to begin searching the restart
!    file for the next field_table tracer.
!---------------------------------------------------------------------
              if (is_tracer_in_restart_file) exit
            end do !  (jn)
          end do ! (it)

!---------------------------------------------------------------------
!    initialize the time tendencies to 0.0 for any tracers that are to
!    be transported and whose time tendencies were not found on the 
!    restart file.  enter a message in the output file.
!---------------------------------------------------------------------
          do nn=1,ntracers
            if (success(nn) ) then
            else
              call error_mesg ('donner_deep_mod', 'read_restart_nc: &
                  &did not find tracer restart data for ' //  &
                  trim(Don_save%tracername(nn)) //  &
                  '; am initializing tendency to 0.0', NOTE)
              Don_save%tracer_tends(:,:,:,nn) = 0.0
            endif   
          end do

!----------------------------------------------------------------------
!    deallocate local variables.
!----------------------------------------------------------------------
          deallocate (ntindices)
          deallocate (tracer_fields)
        endif  ! (do_donner_tracer)
      endif  ! (field_found)

!---------------------------------------------------------------------
!    read the restart data that is present in both full and reduced
!    restart files.
!---------------------------------------------------------------------
      call read_data (fname, 'parcel_disp', Don_save%parcel_disp)
      call read_data (fname, 'lag_temp',    Don_save%lag_temp)     
      call read_data (fname, 'lag_vapor',   Don_save%lag_vapor)     
      call read_data (fname, 'lag_press',   Don_save%lag_press)     

!---------------------------------------------------------------------




end subroutine read_restart_nc



!#####################################################################

subroutine process_monitors (idf, jdf, nlev, ntracers, axes, Time, &
                              Initialized, Don_save)

integer,                       intent(in)  :: idf, jdf, nlev, ntracers
integer,         dimension(4), intent(in)  :: axes
type(time_type),               intent(in)  :: Time
type(donner_initialized_type), intent(inout) :: Initialized
type(donner_save_type), intent(inout) :: Don_save

!-------------------------------------------------------------------
!  local variables:

      integer             :: n, nx, nc
      logical             :: flag, success
      integer             :: nfields, model, num_methods
      character(len=200)  :: method_name, field_type, method_control,&
                             field_name, list_name
      character(len=32)   :: path_name = '/atmos_mod/don_deep_monitor/'

!---------------------------------------------------------------------
!    determine if and how many output variables are to be monitored. 
!    set a flag indicating if monitoring is activated.
!---------------------------------------------------------------------
      call field_manager_init (nfields)
      nx = 0
      do n=1,nfields
        call get_field_info (n, field_type, field_name, model, &
                             num_methods)
        if (trim(field_type) == 'don_deep_monitor') then
          nx = nx + 1
        endif
      end do
      if (nx > 0) then
        Initialized%monitor_output = .true.
      else
        Initialized%monitor_output = .false.
      endif

!---------------------------------------------------------------------
!    allocate arrays needed for each monitored variable. 
!---------------------------------------------------------------------
      if (Initialized%monitor_output) then
        allocate (Initialized%Don_monitor(nx))
        allocate (id_extremes(nx))
        allocate (id_hits(nx))

!---------------------------------------------------------------------
!    read the field_table to determine the nature of the monitors
!    requested.
!---------------------------------------------------------------------
        nx = 1
        do n = 1,nfields
          call get_field_info (n, field_type, field_name, model, &
                               num_methods)

!---------------------------------------------------------------------
!    define the list name used by field_manager_mod to point to 
!    monitored variables.
!---------------------------------------------------------------------
          if (trim(field_type) == 'don_deep_monitor') then
            list_name = trim(path_name) // trim(field_name) // '/'

!--------------------------------------------------------------------
!    place name of field in don_monitor_type variable.
!--------------------------------------------------------------------
            Initialized%Don_monitor(nx)%name = trim(field_name)

!--------------------------------------------------------------------
!    map the field name to the list of acceptable field names. store
!    the index of this field name in the don_monitor_type variable.
!    note that any tracer variables need to have 'tr_' as the first
!    three characters in their name to allow proper processing. store
!    the appropriate tracer index for any tracer arrays.
!--------------------------------------------------------------------
            if (trim(field_name(1:3)) == 'tr_') then
              select case (trim(field_name(4:9)))
                case ('rn_ten')
                  Initialized%Don_monitor(nx)%index = RADON_TEND
                  success = .false.
                  do nc=1,ntracers
                    if (trim(Don_save%tracername(nc)) == 'radon') then
                      Initialized%Don_monitor(nx)%tracer_index = nc
                      success = .true.
                      exit
                    endif
                  end do
                  if (.not. success) then
                    call error_mesg ('donner_deep_mod', &
                     'not able to find "radon" tracer index', FATAL)
                  endif
                case default
                  call error_mesg ('donner_deep_mod', &
                 'tracer variable name in field_table don_deep_monitor &
                                             &type is invalid', FATAL)
              end select

!---------------------------------------------------------------------
!    for non-tracer variables, set the tracer index to an arbitrary 
!    value.
!---------------------------------------------------------------------
            else
              Initialized%Don_monitor(nx)%tracer_index = 0
              select case (trim(field_name(1:6)))
                case ('det_ma')
                  Initialized%Don_monitor(nx)%index = DET_MASS_FLUX
                case ('mass_f')
                  Initialized%Don_monitor(nx)%index = MASS_FLUX
                case ('cell_u')
                  Initialized%Don_monitor(nx)%index =   &
                                                  CELL_UPWARD_MASS_FLUX
                case ('temp_f')
                  Initialized%Don_monitor(nx)%index = TEMP_FORCING
                case ('moistu')
                  Initialized%Don_monitor(nx)%index = MOIST_FORCING
                case ('precip')
                  Initialized%Don_monitor(nx)%index = PRECIP
                case ('freeze')
                  Initialized%Don_monitor(nx)%index = FREEZING
                case default
                  call error_mesg ('donner_deep_mod', &
                      'variable name in field_table don_deep_monitor &
                                              &type is invalid', FATAL)
              end select
            endif

!---------------------------------------------------------------------
!    read the units for this variable from the field_table entry.
!    if the units method is missing, set units to be 'missing'.
!---------------------------------------------------------------------
            flag = fm_query_method (trim(list_name) //  'units',    &
                                    method_name, method_control)
            if (flag) then
              Initialized%Don_monitor(nx)%units = trim(method_name)
            else
              Initialized%Don_monitor(nx)%units = 'missing'
            endif

!---------------------------------------------------------------------
!    determine the type of limit being imposed for this variable from 
!    the field_table entry.
!---------------------------------------------------------------------
            flag = fm_query_method (trim(list_name) // 'limit_type',  &
                                    method_name, method_control)

!----------------------------------------------------------------------
!    include the limit_type for this variable in its don_monitor type
!    variable.
!    register diagnostics associated with the monitored output fields
!    (extreme values and number of times threshold was exceeeded).
!----------------------------------------------------------------------
            if ( flag) then
              if (trim(method_name) == 'maxmag') then
                Initialized%Don_monitor(nx)%initial_value = 0.0
                Initialized%Don_monitor(nx)%limit_type =   MAXMAG
                id_extremes(nx) = register_diag_field (mod_name,   &
                  'maxmag_'// trim(Initialized%Don_monitor(nx)%name),  &
                   axes(1:3),  Time,  'maxmag values of ' // &
                            trim(Initialized%Don_monitor(nx)%name),  &
                   Initialized%Don_monitor(nx)%units,   &
                   mask_variant = .true., missing_value=missing_value)
                id_hits(nx) = register_diag_field (mod_name,   &
                  'num_maxmag_'// &
                              trim(Initialized%Don_monitor(nx)%name) , &
                   axes(1:3),  Time,    &
                   '# of times that magnitude of '&
                     // trim(Initialized%Don_monitor(nx)%name) //  &
                 ' > ' // trim(method_control(2:)) // ' ' // &
                    trim(Initialized%Don_monitor(nx)%units) ,  &
                   'number', mask_variant = .true., & 
                   missing_value=missing_value)
              else if (trim(method_name) == 'minmag') then
                Initialized%Don_monitor(nx)%initial_value = 1.0e30
                Initialized%Don_monitor(nx)%limit_type =   MINMAG
                id_extremes(nx) = register_diag_field (mod_name,   &
                  'minmag_'// trim(Initialized%Don_monitor(nx)%name),  &
                   axes(1:3),  Time,  'minmag values of ' // &
                            trim(Initialized%Don_monitor(nx)%name),  &
                   Initialized%Don_monitor(nx)%units,   &
                   mask_variant = .true., missing_value=missing_value)
                id_hits(nx) = register_diag_field (mod_name,   &
                  'num_minmag_'//     &
                             trim(Initialized%Don_monitor(nx)%name) , &
                  axes(1:3),  Time,    &
                   '# of times that magnitude of '&
                     // trim(Initialized%Don_monitor(nx)%name) //  &
                ' < ' // trim(method_control(2:)) // ' ' // &
                    trim(Initialized%Don_monitor(nx)%units) ,  &
                  'number', mask_variant = .true., & 
                  missing_value=missing_value)
              else if (trim(method_name) == 'minval') then
                Initialized%Don_monitor(nx)%initial_value = 1.0e30
                Initialized%Don_monitor(nx)%limit_type =   MINVAL
                id_extremes(nx) = register_diag_field (mod_name,   &
                  'minval_'// trim(Initialized%Don_monitor(nx)%name),  &
                   axes(1:3),  Time,  'minimum values of ' // &
                            trim(Initialized%Don_monitor(nx)%name),  &
                  Initialized%Don_monitor(nx)%units,   &
                  mask_variant = .true., missing_value=missing_value)
                id_hits(nx) = register_diag_field (mod_name,   &
                  'num_minval_'//   &
                             trim(Initialized%Don_monitor(nx)%name) , &
                   axes(1:3),  Time,    &
                   '# of times that value of '&
                     // trim(Initialized%Don_monitor(nx)%name) //  &
                ' < ' // trim(method_control(2:)) // ' ' // &
                    trim(Initialized%Don_monitor(nx)%units) ,  &
                  'number', mask_variant = .true., & 
                  missing_value=missing_value)
              else if (trim(method_name) == 'maxval') then
                Initialized%Don_monitor(nx)%initial_value = -1.0e30
                Initialized%Don_monitor(nx)%limit_type = MAXVAL 
                id_extremes(nx) = register_diag_field (mod_name,   &
                  'maxval_'// trim(Initialized%Don_monitor(nx)%name),  &
                  axes(1:3),  Time,  'maximum values of ' // &
                            trim(Initialized%Don_monitor(nx)%name),  &
                  Initialized%Don_monitor(nx)%units,  &
                  mask_variant = .true., missing_value=missing_value)
                id_hits(nx) = register_diag_field (mod_name,   &
                  'num_maxval_'//    &
                             trim(Initialized%Don_monitor(nx)%name) , &
                  axes(1:3),  Time,    &
                   '# of times that value of '&
                     // trim(Initialized%Don_monitor(nx)%name) //  &
                    ' > ' // trim(method_control(2:)) // ' ' // &
                    trim(Initialized%Don_monitor(nx)%units) ,  &
                  'number', mask_variant = .true., & 
                  missing_value=missing_value)
              else
                call error_mesg ('donner_deep_mod', &
                    'invalid limit_type for monitored variable', FATAL)
              endif

!----------------------------------------------------------------------
!    if limit_type not in field_table, set it to look for maximum
!    magnitude.
!----------------------------------------------------------------------
            else
              Initialized%Don_monitor(nx)%initial_value = 0.0
              Initialized%Don_monitor(nx)%limit_type =   MAXMAG
              id_extremes(nx) = register_diag_field (mod_name,   &
                  'maxmag_'// trim(Initialized%Don_monitor(nx)%name),  &
                   axes(1:3),  Time,  'maxmag values of ' // &
                            trim(Initialized%Don_monitor(nx)%name),  &
                   Initialized%Don_monitor(nx)%units,   &
                   mask_variant = .true., missing_value=missing_value)
              id_hits(nx) = register_diag_field (mod_name,   &
                  'num_maxmag_'// &
                              trim(Initialized%Don_monitor(nx)%name) , &
                   axes(1:3),  Time,    &
                   '# of times that magnitude of '&
                     // trim(Initialized%Don_monitor(nx)%name) //  &
                ' > ' // trim(method_control(2:)) // ' ' // &
                    trim(Initialized%Don_monitor(nx)%units) ,  &
                   'number', mask_variant = .true., & 
                   missing_value=missing_value)
            endif

!----------------------------------------------------------------------
!    obtain the magnitude of the limit being monitored for this 
!    variable from the field_table. 
!----------------------------------------------------------------------
            flag = parse (method_control, 'value',   &
                            Initialized%Don_monitor(nx)%threshold ) > 0

!----------------------------------------------------------------------
!    if no limit_type and / or value has been given, the
!    field will be flagged for magnitudes  > 0.0, i.e., if deep 
!    convection has affected the point.
!----------------------------------------------------------------------
            if ( .not. flag) then
              Initialized%Don_monitor(nx)%threshold = 0.0
            endif

!-------------------------------------------------------------------
!    allocate and initialize arrays to hold the extrema and a count of 
!    times the threshold was exceeded at each point.
!-------------------------------------------------------------------
            allocate (Initialized%Don_monitor(nx)%extrema(idf,jdf,nlev))
            Initialized%Don_monitor(nx)%extrema(:,:,:) =  &
                         Initialized%Don_monitor(nx)%initial_value
            allocate (Initialized%Don_monitor(nx)%hits(idf,jdf,nlev))
            Initialized%Don_monitor(nx)%hits(:,:,:) = 0.0
            nx = nx + 1
          endif
        end do
      endif 

end subroutine process_monitors



!#####################################################################


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!      2. ROUTINES CALLED BY DONNER_DEEP
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!#######################################################################

subroutine donner_column_control (is, ie, js, je, Time, Col_diag)                

!---------------------------------------------------------------------
!    subroutine donner_column_control returns the number, location
!    (processor and window indices) and output units associated with 
!    any diagnostic columns requested within the current physics window.
!---------------------------------------------------------------------

integer,                       intent(in)   :: is, ie, js, je
type(time_type),               intent(in)   :: Time
type (donner_column_diag_type), intent(inout) :: Col_diag

!---------------------------------------------------------------------
!   intent(in) variables:
!
!     is, ie         first and last values of i index values of points
!                    in this physics window (processor coordinates)
!     js, je         first and last values of j index values of points
!                    in this physics window (processor coordinates)
!     Time           current model time [ time_type, days, seconds ]
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      integer  :: isize      !   i-dimension of physics window
      integer  :: jsize      !   j-dimension of physics window
      integer  :: nn, j, i   !   do-loop indices

!--------------------------------------------------------------------
!    define the sizes of the current physics window's horizontal
!    dimensions.
!--------------------------------------------------------------------
      isize = ie - is + 1
      jsize = je - js + 1

!-------------------------------------------------------------------
!    initialize the output variables.
!-------------------------------------------------------------------
      Col_diag%i_dc(:) = -99
      Col_diag%j_dc(:) = -99
      Col_diag%unit_dc(:) = -1
      Col_diag%jgl_dc(:) = -99
      Col_diag%igl_dc(:) = -99
      Col_diag%ncols_in_window = 0

!--------------------------------------------------------------------
!    if any requested diagnostic columns are present within the current
!    physics window, and if it is at or past the time to start output-
!    ting column diagnostics, save the relevant variables describing
!    those diagnostic columns in arrays to be returned to the calling
!    routine. call column_diagnostics_header to write the file header
!    for the diagnostic columns in this window. 
!--------------------------------------------------------------------
      if (Col_diag%num_diag_pts > 0) then
        if (Time >= Time_col_diagnostics) then
          do nn=1,Col_diag%num_diag_pts
            do j=1,jsize      
              if (js + j - 1 == col_diag_j(nn)) then
                do i=1,isize       
                  if (is + i - 1 == col_diag_i(nn)) then
                    Col_diag%ncols_in_window =   &
                                           Col_diag%ncols_in_window + 1
                    Col_diag%i_dc(Col_diag%ncols_in_window) = i
                    Col_diag%j_dc(Col_diag%ncols_in_window) = j
                    Col_diag%igl_dc(COl_diag%ncols_in_window) =  &
                                                          col_diag_i(nn)
                    Col_diag%jgl_dc(Col_diag%ncols_in_window) =   &
                                                           col_diag_j(nn)
                    Col_diag%unit_dc(Col_diag%ncols_in_window) =   &
                                                        col_diag_unit(nn)
                    call column_diagnostics_header &
                            (mod_name, col_diag_unit(nn), Time, nn,  &
                             col_diag_lon, col_diag_lat, col_diag_i,  &
                             col_diag_j)
                  endif
                end do  ! (i loop)
              endif
            end do  ! (j loop) 
          end do  ! (num_diag_pts loop)
        endif  ! (Time >= starting time)
      endif ! (num_diag_pts > 0)

!---------------------------------------------------------------------

end subroutine donner_column_control



!######################################################################

subroutine donner_deep_netcdf (is, ie, js, je, Nml, Time,  Param, &
                               Initialized, Don_conv, Don_cape,&
                               Don_cem,parcel_rise, pmass, total_precip, &
                               Don_budgets, &
                               temperature_forcing, moisture_forcing)  

!---------------------------------------------------------------------
!    subroutine donner_deep_netcdf sends the fields requested in the
!    diag_table to diag_manager_mod so that they may be appropriately
!    processed for output.
!---------------------------------------------------------------------

integer,                intent(in) :: is, ie, js, je
type(time_type),        intent(in) :: Time
type(donner_param_type), intent(in) :: Param
type(donner_initialized_type), intent(inout) :: Initialized
type(donner_nml_type), intent(in) :: Nml   
type(donner_conv_type), intent(in) :: Don_conv
type(donner_budgets_type), intent(in) :: Don_budgets
type(donner_cape_type), intent(in) :: Don_cape
type(donner_cem_type),  intent(in) :: Don_cem
real, dimension(:,:,:), intent(in) :: pmass, temperature_forcing,&
                                      moisture_forcing
real, dimension(:,:),   intent(in) :: parcel_rise, total_precip

!---------------------------------------------------------------------
!   intent(in) variables:
!
!     is, ie         first and last values of i index values of points 
!                    in this physics window (processor coordinates)
!     js, je         first and last values of j index values of points 
!                    in this physics window (processor coordinates)
!     Time           current time (time_type)
!     Don_conv       donner_convection_type derived type variable con-
!                    taining diagnostics describing the nature of the 
!                    convection produced by the donner parameterization
!     Don_cape       donner_cape type derived type variable containing
!                    diagnostics related to the cape calculation assoc-
!                    iated with the donner convection parameterization
!     Don_cem        donner_cem_type derived type variable containing
!                    Donner cumulus ensemble member diagnostics
!     temperature_forcing  
!                    temperature tendency due to donner convection
!                    [ deg K / sec ]
!     moisture_forcing  
!                    vapor mixing ratio tendency due to donner 
!                    convection [ kg(h2o) / (kg(dry air) sec ) ]
!     pmass          mass per unit area within the grid box
!                    [ kg (air) / (m**2) ]
!     parcel_rise    accumulated vertical displacement of a near-surface
!                    parcel as a result of the lowest model level omega 
!                    field [ Pa ]
!     total_precip   total precipitation rate produced by the
!                    donner parameterization [ mm / day ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      real, dimension (ie-is+1, je-js+1)  :: tempdiag, tempdiag2, tempdiag3  
                           ! array used to hold various data fields being
                           ! sent to diag_manager_mod
      logical :: used      ! logical indicating data has been received 
                           ! by diag_manager_mod 
      integer :: nlev      ! number of large-scale model layers
      integer :: ntr       ! number of tracers transported by the
                           ! donner deep convection parameterization
      integer :: k, n, nn  ! do-loop indices
      integer :: ncem      ! number of cumulus ensemble members in the
                           ! donner deep convection parameterization

!----------------------------------------------------------------------
!    define the number of model layers (nlev) and number of transported
!    tracers (ntr).
!----------------------------------------------------------------------
      nlev = size (pmass,3)
      ntr  = size (Don_conv%qtren1,4)

!----------------------------------------------------------------------
!    define the number of cumulus ensemble members in the
!    donner deep convection parameterization.
!----------------------------------------------------------------------
      ncem = size (Don_cem%cell_precip,3)

!---------------------------------------------------------------------
!    send the 3D convective output variables to diag_manager_mod.
!!   NOTE: effective with code mod lima_donnermod3_rsh (7-19-05) the
!!         temperature and moisture forcing fields passed to diag_manager
!!         (id_cemetf_deep, id_cememf_deep) are the total convective
!!         forcings calculated by the donner parameterization. Previous
!!         code versions run in models in which strat_cloud_mod was 
!!         activated output the forcing fields less the terms related to 
!!         the flux convergence of the large-scale condensate and the 
!!         mesoscale detrainment.
!---------------------------------------------------------------------

!   total convective temperature forcing:
      used = send_data (id_cemetf_deep, Don_conv%conv_temp_forcing,  &
                        Time, is, js, 1)

!   cell entropy flux convergence:
      used = send_data (id_ceefc_deep, Don_conv%ceefc, Time, is, js, 1)

!   cell condensation / evaporation:
      used = send_data (id_cecon_deep, Don_conv%cecon, Time, is, js, 1)

!   cell moisture flux convergence:
      used = send_data (id_cemfc_deep, Don_conv%cemfc, Time, is, js, 1)

!   total convective moistening forcing:
      used = send_data (id_cememf_deep, Don_conv%conv_moist_forcing,  &
                        Time, is, js, 1)

!   total convective moistening rate after adjustnment for negative 
!   vapor mixing ratio:
      used = send_data (id_cememf_mod_deep, Don_conv%cememf_mod,   &
                        Time, is, js, 1)

!   cell + mesoscale cloud fraction:
      used = send_data (id_cual_deep, Don_conv%cual, Time, is, js, 1)

!   heating rate due to freezing:
      used = send_data (id_fre_deep, Don_conv%fre, Time, is, js, 1)

!   heating rate due to melting:
      used = send_data (id_elt_deep, Don_conv%elt, Time, is, js, 1)

!   deposition in mesoscale updraft:
      used = send_data (id_cmus_deep, Don_conv%cmus, Time, is, js, 1)

!   evaporation in convective downdrafts:
      used = send_data (id_ecds_deep, Don_conv%ecds, Time, is, js, 1)

!   evaporation / sublimation in convective updrafts:
      used = send_data (id_eces_deep, Don_conv%eces, Time, is, js, 1)

!   sublimation in mesoscale downdrafts:
      used = send_data (id_emds_deep, Don_conv%emds, Time, is, js, 1)

!   sublimation in mesoscale updrafts:
      used = send_data (id_emes_deep, Don_conv%emes, Time, is, js, 1)

!   mesoscale moisture flux convergence:
      used = send_data (id_qmes_deep, Don_conv%mrmes, Time, is, js, 1)

!   transfer of vapor from cells to mesoscale:
      used = send_data (id_wmps_deep, Don_conv%wmps, Time, is, js, 1)

!   deposition of vapor from cells to mesoscale:
      used = send_data (id_wmms_deep, Don_conv%wmms, Time, is, js, 1)

!   mesoscale entropy flux convergence:
      used = send_data (id_tmes_deep, Don_conv%tmes, Time, is, js, 1)

!   mass flux in mesoscale downdrafts:
      used = send_data (id_dmeml_deep, Don_conv%dmeml, Time, is, js, 1)

!   mass flux in cell updrafts:
      used = send_data (id_uceml_deep, Don_conv%uceml, Time, is, js, 1)

!   detrained mass flux:
      used = send_data (id_detmfl_deep, Don_conv%detmfl, Time, is, js, 1)

!   mass flux in mesoscale updrafts:
      used = send_data (id_umeml_deep, Don_conv%umeml, Time, is, js, 1)

!   mesoscale ice mixing ratio:
      used = send_data (id_xice_deep, Don_conv%xice, Time, is, js, 1)

!   mesoscale liquid mass mixing ratio
      used = send_data (id_xliq_deep, Don_conv%xliq, Time, is, js, 1)

!   mesoscale ice generalized effective size:
      used = send_data (id_dgeice_deep, Don_conv%dgeice,      &
                        Time, is, js, 1)

!   cell ice mixing ratio:
      used = send_data (id_cuqi_deep, Don_conv%cuqi, Time, is, js, 1)

!   cell liquid mixing ratio:
      used = send_data (id_cuql_deep, Don_conv%cuql, Time, is, js, 1)

!   cell liquid generalized effective size:
      used = send_data (id_dgeliq_deep, Don_conv%cell_liquid_eff_diam, &
                        Time, is, js, 1)

     if (Nml%do_budget_analysis) then
       do n=1,Don_budgets%N_WATER_BUDGET
         if (id_water_budget(n) > 0) then
            used = send_data (id_water_budget(n), &
                              Don_budgets%water_budget(:,:,:,n), &
                              Time, is, js, 1)
         endif
       end do
       do n=1,Don_budgets%N_PRECIP_TYPES
         do nn=1,Don_budgets%N_PRECIP_PATHS
           if (id_precip_budget(nn,n) > 0) then
             used = send_data (id_precip_budget(nn,n), &
                               Don_budgets%precip_budget(:,:,:,nn,n), &
                               Time, is, js, 1)
           endif
         end do
       end do
       do n=1,Don_budgets%N_ENTHALPY_BUDGET
         if (id_enthalpy_budget(n) > 0) then
           used = send_data (id_enthalpy_budget(n),   &
                             Don_budgets%enthalpy_budget(:,:,:,n), &
                             Time, is, js, 1)
         endif
       end do
       do n=1,Don_budgets%N_WATER_BUDGET
         tempdiag(:,:) = 0.
         do k=1,nlev
           tempdiag(:,:) = tempdiag(:,:) + &
                           Don_budgets%water_budget(:,:,k,n)* &
                                                     pmass(:,:,k)/1000.
         end do
         if (id_ci_water_budget(n) > 0) then
           used = send_data (id_ci_water_budget(n), tempdiag, &
                             Time, is, js)
         endif
       end do
       tempdiag3(:,:) = 0.
       do n=1,Don_budgets%N_PRECIP_TYPES
         do nn=1,Don_budgets%N_PRECIP_PATHS
           tempdiag(:,:) = 0.
           do k=1,nlev
             tempdiag(:,:) = tempdiag(:,:) + &
                             Don_budgets%precip_budget(:,:,k,nn,n)* &
                                                           pmass(:,:,k)
           end do
           if (id_ci_precip_budget(nn,n) > 0) then
             used = send_data (id_ci_precip_budget(nn,n), tempdiag, &
                               Time, is, js)
           endif
           tempdiag3(:,:) = tempdiag3(:,:) + tempdiag(:,:)
         end do
       end do
       do n=1,Don_budgets%N_ENTHALPY_BUDGET
         tempdiag(:,:) = 0.
         do k=1,nlev
           tempdiag(:,:) = tempdiag(:,:) +  &
                           Don_budgets%enthalpy_budget(:,:,k,n)* &
                                                    pmass(:,:,k)*CP_AIR
         end do
         if (id_ci_enthalpy_budget(n) > 0) then
           used = send_data (id_ci_enthalpy_budget(n), tempdiag, &
                             Time, is, js)
         endif
       end do
           
        
       tempdiag2(:,:) = 0.
       tempdiag(:,:) = 0.
       do k=1,nlev
         tempdiag(:,:) = tempdiag(:,:) +  &
                         (Don_budgets%precip_budget(:,:,k,2,1) +  &
                          Don_budgets%precip_budget(:,:,k,4,1))* &
                                                 Param%hls*pmass(:,:,k)
       end do
       if (id_ci_prcp_heat_frz_cell > 0) then
         used = send_data (id_ci_prcp_heat_frz_cell, tempdiag, &
                           Time, is, js)
       endif
       tempdiag2 = tempdiag2 + tempdiag
           
       tempdiag(:,:) = 0.
       do k=1,nlev
         tempdiag(:,:) = tempdiag(:,:) +  &
                         (Don_budgets%precip_budget(:,:,k,1,1) +   &
                          Don_budgets%precip_budget(:,:,k,3,1) + &
                          Don_budgets%precip_budget(:,:,k,5,1))* &
                                                 Param%hlv*pmass(:,:,k)
       end do
       if (id_ci_prcp_heat_liq_cell > 0) then
         used = send_data (id_ci_prcp_heat_liq_cell, tempdiag, &
                           Time, is, js)
       endif
       tempdiag2 = tempdiag2 + tempdiag
           
       tempdiag(:,:) = 0.
       do k=1,nlev
         tempdiag(:,:) = tempdiag(:,:) +  &
                         (Don_budgets%precip_budget(:,:,k,2,2) + &
                          Don_budgets%precip_budget(:,:,k,4,2) + &
                          Don_budgets%precip_budget(:,:,k,2,3) + &
                          Don_budgets%precip_budget(:,:,k,4,3))* &
                                                 Param%hls*pmass(:,:,k)
       end do
       if (id_ci_prcp_heat_frz_meso > 0) then
         used = send_data (id_ci_prcp_heat_frz_meso, tempdiag, &
                           Time, is, js)
       endif
       tempdiag2 = tempdiag2 + tempdiag
           
       tempdiag(:,:) = 0.
       do k=1,nlev
         tempdiag(:,:) = tempdiag(:,:) +  &
                         (Don_budgets%precip_budget(:,:,k,1,2) +   &
                          Don_budgets%precip_budget(:,:,k,3,2) +  &
                          Don_budgets%precip_budget(:,:,k,5,2) + &
                          Don_budgets%precip_budget(:,:,k,1,3) +   &
                          Don_budgets%precip_budget(:,:,k,3,3) +  &
                          Don_budgets%precip_budget(:,:,k,5,3))* &
                                                  Param%hlv*pmass(:,:,k)
       end do
       if (id_ci_prcp_heat_liq_meso > 0) then
         used = send_data (id_ci_prcp_heat_liq_meso, tempdiag, &
                           Time, is, js)
       endif
       tempdiag2 = tempdiag2 + tempdiag
       if ( id_ci_prcp_heat_total > 0) then
         used = send_data (id_ci_prcp_heat_total, tempdiag2, &
                           Time, is, js)
       endif
       if (id_ci_prcp_total > 0) then
         used = send_data (id_ci_prcp_total, tempdiag3, &
                           Time, is, js)
       endif
       if ( id_leff > 0) then
         used = send_data(id_leff, tempdiag2/(tempdiag3+1.0e-40), &
                           Time, is, js)
       endif
           
     endif

!--------------------------------------------------------------------
!    send the tracer-related arrays to diag_manager_mod.
!--------------------------------------------------------------------
      do n=1,ntr    

!   tracer tendency due to cells:
        if (id_qtren1(n) > 0) then
        used = send_data (id_qtren1(n), Don_conv%qtren1(:,:,:,n), &
                          Time, is, js, 1)
        endif

!   tracer tendency due to mesoscale:
         if (id_qtmes1(n) > 0) then
        used = send_data (id_qtmes1(n), Don_conv%qtmes1(:,:,:,n),   &
                          Time, is, js, 1)
        endif

!   tracer tendency due to mesoscale redistribution:
        if (id_wtp1(n) > 0) then
        used = send_data (id_wtp1(n), Don_conv%wtp1(:,:,:,n),     &
                          Time, is, js, 1)
        endif

!   tracer tendency due to deep convective wet deposition:
       if (id_total_wet_dep(n) > 0) then
     used = send_data (id_total_wet_dep(n), Don_conv%wetdept(:,:,:,n), &
                            Time, is, js, 1)
        endif
!   tracer tendency due to wet deposition in mesoscale updrafts:
       if ( id_meso_wet_dep(n) > 0) then
     used = send_data (id_meso_wet_dep(n), Don_conv%wetdepm(:,:,:,n), &
                            Time, is, js, 1)
      endif
 
!   tracer tendency due to wet deposition in cells:
      if (id_cell_wet_dep(n) > 0) then
     used = send_data (id_cell_wet_dep(n), Don_conv%wetdepc(:,:,:,n), &
                           Time, is, js, 1)
      endif

!   total tracer tendency:
      if (id_qtceme(n) > 0) then
        used = send_data (id_qtceme(n), Don_conv%qtceme(:,:,:,n), &
                          Time, is, js, 1)
      endif

!---------------------------------------------------------------------
!    define the column-integrated tracer tendency due to convective
!    cells, in units of kg (tracer) / (m**2 sec). send it to 
!    diag_manager_mod.
!---------------------------------------------------------------------
        tempdiag = 0.0
        do k=1,nlev
          tempdiag(:,:) = tempdiag(:,:) + Don_conv%qtren1(:,:,k,n)* &
                          pmass(:,:,k)
        end do
        if (id_qtren1_col(n) > 0) then
        used = send_data (id_qtren1_col(n), tempdiag, Time, is, js)
        endif

!---------------------------------------------------------------------
!    define the column-integrated tracer tendency due to mesoscale circ-
!    ulation, in units of kg (tracer) / (m**2 sec). send it to 
!    diag_manager_mod.
!---------------------------------------------------------------------
        tempdiag = 0.0
        do k=1,nlev
          tempdiag(:,:) = tempdiag(:,:) + Don_conv%qtmes1(:,:,k,n)* &
                          pmass(:,:,k)
        end do
        if (id_qtmes1_col(n) > 0) then
        used = send_data (id_qtmes1_col(n), tempdiag, Time, is, js)
        endif

!---------------------------------------------------------------------
!    define the column-integrated tracer redistribution due to meso-
!    scale circulation, in units of kg (tracer) / (m**2 sec). send it 
!    to diag_manager_mod.
!---------------------------------------------------------------------
        tempdiag = 0.0
        do k=1,nlev
          tempdiag(:,:) = tempdiag(:,:) + Don_conv%wtp1(:,:,k,n)*   &
                          pmass(:,:,k)
        end do
        if (id_wtp1_col(n) > 0) then
        used = send_data (id_wtp1_col(n), tempdiag, Time, is, js)
        endif

!---------------------------------------------------------------------
!    define the column-integrated tracer change due to wet deposition in
!    deep convection (cells and mesoscale) in units of kg (tracer) / 
!    (m**2 sec). send it to diag_manager_mod.
!---------------------------------------------------------------------
        tempdiag = 0.0
        do k=1,nlev
          tempdiag(:,:) = tempdiag(:,:) + Don_conv%wetdept(:,:,k,n)*   &
                          pmass(:,:,k)
        end do
        if (id_total_wet_dep_col(n) > 0) then
        used = send_data (id_total_wet_dep_col(n), tempdiag, Time,  &
                                                                 is, js)
        endif

!---------------------------------------------------------------------
!    define the column-integrated tracer change due to wet deposition in
!    mesoscale updrafts, in units of kg (tracer) / (m**2 sec). send it 
!    to diag_manager_mod.
!---------------------------------------------------------------------
       tempdiag = 0.0
       do k=1,nlev
         tempdiag(:,:) = tempdiag(:,:) + Don_conv%wetdepm(:,:,k,n)*   &
                         pmass(:,:,k)
       end do
       if (id_meso_wet_dep_col(n) > 0) then
       used = send_data (id_meso_wet_dep_col(n), tempdiag, Time,  &
                                                                 is, js)
       endif

!---------------------------------------------------------------------
!    define the column-integrated tracer change due to wet deposition 
!    by convective cells, in units of kg (tracer) / (m**2 sec). send it 
!    to diag_manager_mod.
!---------------------------------------------------------------------
       tempdiag = 0.0
       do k=1,nlev
         tempdiag(:,:) = tempdiag(:,:) + Don_conv%wetdepc(:,:,k,n)*   &
                         pmass(:,:,k)
       end do
        if (id_cell_wet_dep_col(n) > 0) then
       used = send_data (id_cell_wet_dep_col(n), tempdiag, Time,  &
                                                                 is, js)
        endif

!-----------------------------------------------------------------
!    define the column-integrated total tracer tendency, in units of 
!    kg (tracer) / (m**2 sec). send it to diag_manager_mod.
!---------------------------------------------------------------------
        tempdiag = 0.0
        do k=1,nlev
          tempdiag(:,:) = tempdiag(:,:) + Don_conv%qtceme(:,:,k,n)* &
                          pmass(:,:,k)
        end do
         if (id_qtceme_col(n) > 0) then
        used = send_data (id_qtceme_col(n), tempdiag, Time, is, js)
        endif
      end do

!---------------------------------------------------------------------
!    send the 2D convection-related diagnostics to diag_manager_mod.
!---------------------------------------------------------------------

!   pressure at lifting condensation level:
       if (id_plcl_deep > 0) then
      used = send_data (id_plcl_deep, Don_cape%plcl, Time, is, js)
       endif

!   pressure at level of free convection:
       if (id_plfc_deep > 0) then
      used = send_data (id_plfc_deep, Don_cape%plfc, Time, is, js)
       endif

!   pressure at level of zero buoyancy:
       if (id_plzb_deep > 0) then
      used = send_data (id_plzb_deep, Don_cape%plzb, Time, is, js)
       endif

!   convective available potential energy:
      if (id_xcape_deep > 0) then
      used = send_data (id_xcape_deep, Don_cape%xcape_lag, Time, is, js)
       endif

!   convective inhibition:
      if (id_coin_deep > 0) then
      used = send_data (id_coin_deep, Don_cape%coin, Time, is, js)
       endif

!   time tendency of cape:
      if (id_dcape_deep > 0) then
      used = send_data (id_dcape_deep, Don_conv%dcape, Time, is, js)
       endif

!   column integrated water vapor:
      if (id_qint_deep > 0) then
      used = send_data (id_qint_deep, Don_cape%qint_lag, Time, is, js)
       endif

!   fractional area of cumulus ensemble members:
      if (id_a1_deep > 0) then
      used = send_data (id_a1_deep, Don_conv%a1, Time, is, js)
       endif

!   fractional area of largest cumulus ensemble member:
      if (id_amax_deep > 0) then
      used = send_data (id_amax_deep, Don_conv%amax, Time, is, js)
       endif

!   upper limit of fractional area based on moisture constraint:
      if (id_amos_deep > 0) then
      used = send_data (id_amos_deep, Don_conv%amos, Time, is, js)
       endif

!   area-weighted total precipitation:
      if (id_tprea1_deep > 0) then
      used = send_data (id_tprea1_deep, total_precip, Time, is, js)
       endif

!   mesoscale cloud fraction:
       if (id_ampta1_deep > 0) then
      used = send_data (id_ampta1_deep, Don_conv%ampta1, Time, is, js)
       endif

!   accumulated low-level parcel displacement:
       if (id_omint_deep > 0) then
         used = send_data (id_omint_deep, parcel_rise, Time, is, js)
       endif

!   area weighted convective precipitation:
       if (id_rcoa1_deep > 0) then
      used = send_data (id_rcoa1_deep, Don_conv%cell_precip,    &
                        Time, is, js)
       endif

   if (Nml%do_ensemble_diagnostics) then

!---------------------------------------------------------------------
!  Donner cumulus ensemble member diagnostics
!---------------------------------------------------------------------

!    GCM model pressure field on full levels:
      used = send_data (id_pfull_cem, Don_cem%pfull, &
                        Time, is, js, 1)

!    GCM model pressure field on half levels:
      used = send_data (id_phalf_cem, Don_cem%phalf, &
                        Time, is, js, 1)

!    GCM model height field on full levels:
      used = send_data (id_zfull_cem, Don_cem%zfull, &
                        Time, is, js, 1)

!    GCM model height field on half levels:
      used = send_data (id_zhalf_cem, Don_cem%zhalf, &
                        Time, is, js, 1)

!    GCM model temperature field on full levels:
      used = send_data (id_temp_cem, Don_cem%temp, &
                        Time, is, js, 1)

!    GCM model mixing ratio field on full levels:
      used = send_data (id_mixing_ratio_cem, Don_cem%mixing_ratio, &
                        Time, is, js, 1)

      do n=1,ncem     ! ensemble member number

!    area-weighted convective precipitation rate:
        used = send_data (id_cpre_cem(n), Don_cem%cell_precip(:,:,n), &
                          Time, is, js)

!    pressure at cloud base:
        used = send_data (id_pb_cem(n), Don_cem%pb(:,:,n), &
                          Time, is, js)

!    pressure at cloud top:
        used = send_data (id_ptma_cem(n), Don_cem%ptma(:,:,n), &
                          Time, is, js)

!    condensation rate profile on lo-res grid:
        used = send_data (id_h1_cem(n), Don_cem%h1(:,:,:,n), &
                          Time, is, js, 1)

!    cloud water profile on lo- or hi-res grid:
        used = send_data (id_qlw_cem(n), Don_cem%qlw(:,:,:,n), &
                          Time, is, js, 1)

!    fraction of condensate that is ice on lo- or hi-res grid:
        used = send_data (id_cfi_cem(n), Don_cem%cfracice(:,:,:,n), &
                          Time, is, js, 1)

!    plume vertical velocity profile on lo- or hi-res grid:
        used = send_data (id_wv_cem(n), Don_cem%wv(:,:,:,n), &
                          Time, is, js, 1)

!    plume cloud radius profile on lo- or hi-res grid:
        used = send_data (id_rcl_cem(n), Don_cem%rcl(:,:,:,n), &
                          Time, is, js, 1)
      enddo

!    fractional area sum:
      used = send_data (id_a1_cem, Don_cem%a1, &
                        Time, is, js)

!    area-weighted mesoscale precipitation rate:
        used = send_data (id_mpre_cem, Don_cem%meso_precip, &
                          Time, is, js)

!    cloud fraction, cells+meso, normalized by a(1,p_b) on lo-res grid:
      used = send_data (id_cual_cem, Don_cem%cual, &
                        Time, is, js, 1)

!    time tendency of temperature due to deep convection on lo-res grid:
      used = send_data (id_tfrc_cem, Don_cem%temperature_forcing, &
                        Time, is, js, 1)
   endif  ! (do_ensemble_diagnostics)

!----------------------------------------------------------------------
!    send diagnostics associated with the monitored output fields.
!----------------------------------------------------------------------
      if (Initialized%monitor_output) then
        do n=1,size(Initialized%Don_monitor,1)
          if (id_extremes(n) > 0) then
            used = send_data (id_extremes(n),   &
                    Initialized%Don_monitor(n)%extrema(is:ie,js:je,:), &
                    Time, is, js,1, mask =    &
                  Initialized%Don_monitor(n)%extrema(is:ie,js:je,:) /= &
                              Initialized%Don_monitor(n)%initial_value )
          endif
          if (id_hits(n) > 0) then
            used = send_data (id_hits(n),  &
                       Initialized%Don_monitor(n)%hits(is:ie,js:je,:), &
                       Time, is, js,1, mask =   &
                 Initialized%Don_monitor(n)%extrema(is:ie,js:je,:) /= &
                              Initialized%Don_monitor(n)%initial_value )
          endif
        end do
      endif

!----------------------------------------------------------------------


end subroutine donner_deep_netcdf


!######################################################################


!#####################################################################

subroutine write_restart (ntracers, Don_save, Initialized, Nml)          

!--------------------------------------------------------------------
!    subroutine write_restart is a template to be used if a native mode
!    restart file MUST be generated. currently, if a native mode file is
!    requested, a netcdf file will be witten instead, and an informative
!    message provided.
!--------------------------------------------------------------------
 
integer, intent(in) :: ntracers
type(donner_initialized_type), intent(inout) :: Initialized
type(donner_save_type), intent(inout) :: Don_save
type(donner_nml_type), intent(inout) :: Nml     

!----------------------------------------------------------------------
!   intent(in) variables:
!
!     ntracers               number of tracers to be transported by
!                            the donner deep convection parameterization
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

!     integer :: unit          ! unit number for restart file
!     integer :: n             ! do-loop index

!-------------------------------------------------------------------
!    currently code is provided only for writing netcdf restart files.
!    if a non-netcdf restart file has been requested, this routine will 
!    issue a message, and then call the routine to write the netcdf file.
!    if the user is insistent on a native mode restart file, the code to
!    read and write such files (subroutines write_restart and 
!    read_restart_file) must be updated to be compatible with  the cur-
!    rent versions of write_restart_nc and read_restart_nc, and the 
!    code immediately below eliminated. the commented code below repres-
!    ents a starting point for the write_restart routine; it is not 
!    kept up-to-date as far as the variables which must be written.
!-------------------------------------------------------------------
      call error_mesg ('donner_deep_mod', 'write_restart: &
          &writing a netcdf restart despite request for native &
           &format (not currently supported); if you must have native &
           &mode, then you must update the source code and remove &
                                               &this if loop.', NOTE)
!      call write_restart_nc (ntracers, Don_save, Initialized, Nml) 

!-------------------------------------------------------------------
!    open unit for restart file.
!-------------------------------------------------------------------
!      unit = open_restart_file ('RESTART/donner_deep.res', 'write')

!-------------------------------------------------------------------
!    file writing is currently single-threaded. write out restart
!    version, time remaining until next call to donner_deep_mod and
!    the frequency of calculating donner_deep convection.
!-------------------------------------------------------------------
!     if (mpp_pe() == mpp_root_pe()) then
!       write (unit) restart_versions(size(restart_versions(:)))
!       write (unit) Initialized%conv_alarm, donner_deep_freq
!     endif

!-------------------------------------------------------------------
!    write out the donner_deep restart variables.
!    cemetf    - heating rate due to donner_deep
!    cememf    - moistening rate due to donner_deep
!    xcape_lag - cape value which will be used on next step in
!                calculation od dcape/dt
!-------------------------------------------------------------------
!     call write_data (unit, Don_save%cemetf)
!     call write_data (unit, Don_save%cememf)
      
!--------------------------------------------------------------------
!    the following variables are needed when a prognostic cloud scheme
!    is being used. they are always present in the restart file, having
!    been initialized to zero, if prognostic clouds are not active.
!--------------------------------------------------------------------
!     call write_data (unit, Don_save%mass_flux)
!     call write_data (unit, Don_save%dql_strat )
!     call write_data (unit, Don_save%dqi_strat )
!     call write_data (unit, Don_save%dqa_strat )

!----------------------------------------------------------------------
!    
!-------------------------------------------------------------------
!    write out more donner_deep restart variables.
!    qint_lag   - column integrated water vapor mixing ratio
!    parcel_disp  - time-integrated low-level vertical displacement
!    tprea1     - precipitation due to donner_deep_mod
!----------------------------------------------------------------------
!     call write_data (unit, Don_save%parcel_disp)
!     call write_data (unit, Don_save%tprea1)
!     call write_data (unit, Don_save%lag_temp)
!     call write_data (unit, Don_save%lag_vapor)
!     call write_data (unit, Don_save%lag_press)
!     call write_data (unit, Don_save%humidity_area)
!     call write_data (unit, Don_save%humidity_ratio)

!---------------------------------------------------------------------
!    write out the number of tracers that are being transported by
!    donner_deep_mod.
!---------------------------------------------------------------------
!     if (mpp_pe() == mpp_root_pe()) then
!       write (unit) ntracers
!     endif

!----------------------------------------------------------------------
!    if tracers are being transported, write out their names and 
!    current time tendencies.
!----------------------------------------------------------------------
!     if (Initialized%do_donner_tracer) then
!       do n=1,ntracers
!         if (mpp_pe() == mpp_root_pe()) then
!           write (unit) Don_save%tracername(n)         
!         endif
!         call write_data(unit, Don_save%tracer_tends(:,:,:,n))
!       end do
!     endif

!-------------------------------------------------------------------
!    close restart file unit.
!------------------------------------------------------------------
!     call close_file (unit)

!---------------------------------------------------------------------


end subroutine write_restart




!######################################################################





!######################################################################



                     end module fms_donner_mod

module interpolator_mod
!
! Purpose: Module to interpolate climatology data to model grid.
!
! author: William Cooke William.Cooke
!
#include <fms_platform.h>

use mpp_mod,           only : mpp_error, &
                              FATAL,     &
                              mpp_pe,    &
                              mpp_init,  &
                              mpp_exit,  &
                              mpp_npes,  &
                              WARNING,   &
                              NOTE
use mpp_io_mod,        only : mpp_open,          &
                              mpp_close,         &
                              mpp_get_times,     &
                              mpp_get_atts,      &
                              mpp_get_info,      &
                              mpp_read,          &
                              mpp_get_axes,      &
                              mpp_get_axis_data, &
                              mpp_get_fields,    &
                              fieldtype,         &
                              atttype,           &
                              axistype,          &
                              MPP_RDONLY,        &
                              MPP_NETCDF,        &
                              MPP_MULTI,         &
                              MPP_APPEND,        &
                              MPP_SINGLE
use mpp_domains_mod,   only : mpp_domains_init,      &
                              mpp_update_domains,    &
                              mpp_define_domains,    &
                              mpp_global_field,      &
                              domain2d,              &
                              mpp_define_layout,     &
                              mpp_get_compute_domain
use diag_manager_mod,  only : diag_manager_init, get_base_time, &
                              register_diag_field, send_data, &
                              diag_axis_init
use fms_mod,           only : lowercase, write_version_number, &
                              fms_init, &
                              file_exist, mpp_root_pe, stdlog
use horiz_interp_mod,  only : horiz_interp_type, &
                              horiz_interp_new,  &
                              horiz_interp_init, &
                              assignment(=), &
                              horiz_interp,      &
                              horiz_interp_del
use time_manager_mod,  only : time_type,   &
                              set_time,    &
                              set_date,    &
                              get_date,    &
                              get_calendar_type, &
                              JULIAN, NOLEAP, &
                              get_date_julian, set_date_no_leap, &
                              set_date_julian, get_date_no_leap, &
                              print_date, &
                              operator(+), &
                              operator(-), &
                              operator(*), &
                              operator(>), &
                              operator(<), &
                              assignment(=), &
                              decrement_time
use time_interp_mod,   only : time_interp, YEAR
use constants_mod,     only : grav, PI

implicit none
private 

public interpolator_init, &
       interpolator,      &
       interpolate_type_eq, &
       obtain_interpolator_time_slices, &
       unset_interpolator_time_flag, &
       interpolator_end,  &
       init_clim_diag,    &
       query_interpolator,&
       read_data

interface interpolator
   module procedure interpolator_4D
   module procedure interpolator_3D
   module procedure interpolator_2D
   module procedure interpolator_4D_no_time_axis
   module procedure interpolator_3D_no_time_axis
   module procedure interpolator_2D_no_time_axis
end interface 

interface assignment(=)
   module procedure interpolate_type_eq
end interface

interface interp_weighted_scalar
   module procedure interp_weighted_scalar_1D
   module procedure interp_weighted_scalar_2D
end interface interp_weighted_scalar
character(len=128) :: version = &
'$Id: interpolator.F90,v 20.0 2013/12/13 23:23:41 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
logical            :: module_is_initialized = .false.
logical            :: clim_diag_initialized = .false.

type, public  :: interpolate_type
private
!Redundant data between fields
!All climatology data
real, pointer            :: lat(:) =>NULL()
real, pointer            :: lon(:) =>NULL()
real, pointer            :: latb(:) =>NULL()
real, pointer            :: lonb(:) =>NULL()
real, pointer            :: levs(:) =>NULL()
real, pointer            :: halflevs(:) =>NULL()
type(horiz_interp_type)  :: interph
type(time_type), pointer :: time_slice(:) =>NULL() ! An array of the times within the climatology.
integer                  :: unit          ! Unit number on which file is being read.
character(len=64)        :: file_name     ! Climatology filename
integer                  :: TIME_FLAG     ! Linear or seaonal interpolation?
integer                  :: level_type    ! Pressure or Sigma level
integer                  :: is,ie,js,je
integer                  :: vertical_indices ! direction of vertical 
                                              ! data axis
logical                  :: climatological_year ! Is data for year = 0000?

!Field specific data  for nfields
type(fieldtype),   pointer :: field_type(:) =>NULL()   ! NetCDF field type
character(len=64), pointer :: field_name(:) =>NULL()   ! name of this field
integer,           pointer :: time_init(:,:) =>NULL()  ! second index is the number of time_slices being kept. 2 or ntime.
integer,           pointer :: mr(:) =>NULL()           ! Flag for conversion of climatology to mixing ratio. 
integer,           pointer :: out_of_bounds(:) =>NULL()! Flag for when surface pressure is out of bounds.
!++lwh
integer,           pointer :: vert_interp(:) =>NULL()  ! Flag for type of vertical interpolation.
!--lwh
real,              pointer :: data(:,:,:,:,:) =>NULL() ! (nlatmod,nlonmod,nlevclim,size(time_init,2),nfields)

real,              pointer :: pmon_pyear(:,:,:,:) =>NULL()
real,              pointer :: pmon_nyear(:,:,:,:) =>NULL()
real,              pointer :: nmon_nyear(:,:,:,:) =>NULL()
real,              pointer :: nmon_pyear(:,:,:,:) =>NULL()
!integer                    :: indexm, indexp, climatology
integer,dimension(:),  pointer :: indexm =>NULL() 
integer,dimension(:),  pointer :: indexp =>NULL()
integer,dimension(:),  pointer :: climatology =>NULL() 

type(time_type), pointer :: clim_times(:,:) => NULL()
logical :: separate_time_vary_calc
real :: tweight, tweight1, tweight2, tweight3
integer :: itaum, itaup
end type interpolate_type


integer :: ndim, nvar,natt,ntime
integer :: nlat,nlatb,nlon,nlonb,nlev,nlevh
integer ::          len, ntime_in, num_fields
type(axistype), allocatable :: axes(:)
type(axistype),save          :: time_axis
type(fieldtype), allocatable :: varfields(:)

! pletzer real, allocatable :: time_in(:)
! sjs real, allocatable :: climdata(:,:,:), climdata2(:,:,:)

character(len=32) :: name, units       
integer           :: sense

integer, parameter :: max_diag_fields = 30

! flags to indicate direction of vertical axis in  data file
integer, parameter :: INCREASING_DOWNWARD = 1, INCREASING_UPWARD = -1
!++lwh
! Flags to indicate whether the time interpolation should be linear or some other scheme for seasonal data.
! NOTIME indicates that data file has no time axis.
integer, parameter :: LINEAR = 1, SEASONAL = 2, BILINEAR = 3, NOTIME = 4

! Flags to indicate where climatology pressure levels are pressure or sigma levels
integer, parameter :: PRESSURE = 1, SIGMA = 2 

! Flags to indicate whether the climatology units are mixing ratio (kg/kg) or column integral (kg/m2).
! Vertical interpolation scheme requires mixing ratio at this time.
integer, parameter :: NO_CONV = 1, KG_M2 = 2 

! Flags to indicate what to do when the model surface pressure exceeds the  climatology surface pressure level.
integer, parameter, public :: CONSTANT = 1, ZERO = 2 

! Flags to indicate the type of vertical interpolation
integer, parameter, public :: INTERP_WEIGHTED_P = 10, INTERP_LINEAR_P = 20, INTERP_LOG_P = 30
!--lwh

integer :: num_clim_diag = 0
character(len=64) :: climo_diag_name(max_diag_fields)
integer :: climo_diag_id(max_diag_fields), hinterp_id(max_diag_fields)
real ::  missing_value = -1.e10
! sjs integer :: itaum, itaup

#ifdef NO_QUAD_PRECISION
! 64-bit precision (kind=8)
 integer, parameter:: f_p = selected_real_kind(15)
#else
! Higher precision (kind=16) for grid geometrical factors:
 integer, parameter:: f_p = selected_real_kind(20)
#endif

logical :: read_all_on_init = .false.
integer :: verbose = 0  
logical :: conservative_interp = .true.

namelist /interpolator_nml/    &
                             read_all_on_init, verbose, conservative_interp

contains

!#####################################################################

subroutine interpolate_type_eq (Out, In)

type(interpolate_type), intent(in) :: In
type(interpolate_type), intent(inout) :: Out


     if (associated(In%lat))      Out%lat      =>  In%lat
     if (associated(In%lon))      Out%lon      =>  In%lon
     if (associated(In%latb))     Out%latb     =>  In%latb
     if (associated(In%lonb))     Out%lonb     =>  In%lonb
     if (associated(In%levs))     Out%levs     =>  In%levs
     if (associated(In%halflevs)) Out%halflevs =>  In%halflevs

     Out%interph = In%interph
     if (associated(In%time_slice)) Out%time_slice =>  In%time_slice
     Out%unit = In%unit
     Out%file_name = In%file_name
     Out%time_flag = In%time_flag
     Out%level_type = In%level_type
     Out%is = In%is
     Out%ie = In%ie
     Out%js = In%js
     Out%je = In%je
     Out%vertical_indices = In%vertical_indices
     Out%climatological_year = In%climatological_year
     Out%field_type => In%field_type
     if (associated(In%field_name   )) Out%field_name    =>  In%field_name
     if (associated(In%time_init    )) Out%time_init     =>  In%time_init 
     if (associated(In%mr           )) Out%mr            =>  In%mr         
     if (associated(In%out_of_bounds)) Out%out_of_bounds =>  In%out_of_bounds
     if (associated(In%vert_interp  )) Out%vert_interp   =>  In%vert_interp  
     if (associated(In%data         )) Out%data          =>  In%data  
     if (associated(In%pmon_pyear   )) Out%pmon_pyear    =>  In%pmon_pyear
     if (associated(In%pmon_nyear   )) Out%pmon_nyear    =>  In%pmon_nyear
     if (associated(In%nmon_nyear   )) Out%nmon_nyear    =>  In%nmon_nyear
     if (associated(In%nmon_pyear   )) Out%nmon_pyear    =>  In%nmon_pyear
     if (associated(In%indexm       )) Out%indexm        =>  In%indexm    
     if (associated(In%indexp       )) Out%indexp        =>  In%indexp    
     if (associated(In%climatology  )) Out%climatology   =>  In%climatology
     if (associated(In%clim_times   )) Out%clim_times    =>  In%clim_times
      Out%separate_time_vary_calc = In%separate_time_vary_calc
      Out%tweight = In%tweight
      Out%tweight1 = In%tweight1
      Out%tweight2 = In%tweight2
      Out%tweight3 = In%tweight3
      Out%itaum = In%itaum
      Out%itaup = In%itaup



end subroutine interpolate_type_eq 



 
!#######################################################################
!
subroutine interpolator_init( clim_type, file_name, lonb_mod, latb_mod, &
                              data_names, data_out_of_bounds,           &
                              vert_interp, clim_units, single_year_file)
type(interpolate_type), intent(inout) :: clim_type
character(len=*), intent(in)            :: file_name
real            , intent(in)            :: lonb_mod(:,:), latb_mod(:,:)
character(len=*), intent(in) , optional :: data_names(:)
!++lwh
integer         , intent(in)            :: data_out_of_bounds(:) 
integer         , intent(in), optional  :: vert_interp(:) 
!--lwh
character(len=*), intent(out), optional :: clim_units(:)
logical,          intent(out), optional :: single_year_file
!
! INTENT IN
!  file_name  :: Climatology filename
!  lonb_mod   :: The corners of the model grid-box longitudes.
!  latb_mod   :: The corners of the model grid_box latitudes.
!  data_names :: A list of the names of components within the climatology file which you wish to read.
!  data_out_of_bounds :: A list of the flags that are to be used in determining what to do if the pressure levels in the model
!                        go out of bounds from those of the climatology.
!  vert_interp:: Flag to determine type of vertical interpolation
!
! INTENT OUT
!  clim_type  :: An interpolate type containing the necessary file and field data to be passed to the interpolator routine.
!  clim_units :: A list of the units for the components listed in data_names.
!

integer                      :: unit
character(len=64)            :: src_file
!++lwh
real                         :: dlat, dlon
!--lwh
type(time_type)              :: base_time
logical                      :: NAME_PRESENT
real                         :: dtr,tpi
integer                      :: fileday, filemon, fileyr, filehr, filemin,filesec, m,m1
character(len= 20)           :: fileunits
real, dimension(:), allocatable  :: alpha
integer   :: j, i
logical :: non_monthly
character(len=24) :: file_calendar
integer :: model_calendar
integer :: yr, mo, dy, hr, mn, sc
integer :: n
type(time_type) :: Julian_time, Noleap_time
real, allocatable :: time_in(:)
real, allocatable, save :: agrid_mod(:,:,:)
integer :: nx, ny
integer :: io, ierr

if (.not. module_is_initialized) then
  call fms_init
  call diag_manager_init
  call horiz_interp_init
endif

clim_type%separate_time_vary_calc = .false.

tpi = 2.0*PI ! 4.*acos(0.)
dtr = tpi/360.

num_fields = 0

!--------------------------------------------------------------------
! open source file containing fields to be interpolated
!--------------------------------------------------------------------
src_file = 'INPUT/'//trim(file_name)

if(file_exist(trim(src_file))) then
   call mpp_open( unit, trim(src_file), action=MPP_RDONLY, &
                  form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE )
else
!Climatology file doesn't exist, so exit
   call mpp_error(FATAL,'Interpolator_init : Data file '//trim(src_file)//' does not exist')
endif

!Find the number of variables (nvar) in this file
call mpp_get_info(unit, ndim, nvar, natt, ntime)
clim_type%unit      = unit
clim_type%file_name = trim(file_name)

num_fields = nvar
if(present(data_names)) num_fields= size(data_names(:))

! -------------------------------------------------------------------
! Allocate space for the number of axes in the data file.
! -------------------------------------------------------------------
allocate(axes(ndim))
call mpp_get_axes(unit, axes, time_axis)

nlon=0 ! Number of longitudes (center-points) in the climatology.
nlat=0 ! Number of latitudes (center-points) in the climatology.
nlev=0 ! Number of levels (center-points) in the climatology.
nlatb=0 ! Number of longitudes (boundaries) in the climatology.
nlonb=0 ! Number of latitudes (boundaries) in the climatology.
nlevh=0 ! Number of levels (boundaries) in the climatology.

clim_type%level_type = 0 ! Default value

!++lwh
! -------------------------------------------------------------------
! For 2-D fields, set a default value of nlev=nlevh=1
! -------------------------------------------------------------------
nlev = 1
nlevh = 1
!--lwh
        clim_type%vertical_indices = 0  ! initial value

do i = 1, ndim
  call mpp_get_atts(axes(i), name=name,len=len,units=units,  &
                    calendar=file_calendar, sense=sense)
  select case(name)
    case('lat')
      nlat=len
      allocate(clim_type%lat(nlat))
      call mpp_get_axis_data(axes(i),clim_type%lat)
      select case(units(1:6))
        case('degree')
          clim_type%lat = clim_type%lat*dtr
        case('radian')
        case default  
          call mpp_error(FATAL, "interpolator_init : Units for lat not recognised in file "//file_name)
      end select
    case('lon')
      nlon=len
      allocate(clim_type%lon(nlon))
      call mpp_get_axis_data(axes(i),clim_type%lon)
      select case(units(1:6))
        case('degree')
          clim_type%lon = clim_type%lon*dtr
        case('radian')
        case default  
          call mpp_error(FATAL, "interpolator_init : Units for lon not recognised in file "//file_name)
      end select
    case('latb')
      nlatb=len
      allocate(clim_type%latb(nlatb))
      call mpp_get_axis_data(axes(i),clim_type%latb)
      select case(units(1:6))
        case('degree')
          clim_type%latb = clim_type%latb*dtr
        case('radian')
        case default  
          call mpp_error(FATAL, "interpolator_init : Units for latb not recognised in file "//file_name)
      end select
    case('lonb')
      nlonb=len
      allocate(clim_type%lonb(nlonb))
      call mpp_get_axis_data(axes(i),clim_type%lonb)
      select case(units(1:6))
        case('degree')
          clim_type%lonb = clim_type%lonb*dtr
        case('radian')
        case default  
          call mpp_error(FATAL, "interpolator_init : Units for lonb not recognised in file "//file_name)
      end select
    case('pfull')
      nlev=len
      allocate(clim_type%levs(nlev))
      call mpp_get_axis_data(axes(i),clim_type%levs)
      clim_type%level_type = PRESSURE
  ! Convert to Pa
      if( chomp(units) == "mb" .or. chomp(units) == "hPa") then
         clim_type%levs = clim_type%levs * 100.
      end if
! define the direction of the vertical data axis
! switch index order if necessary so that indx 1 is at lowest pressure,
! index nlev at highest pressure.
      if( sense == 1 ) then
        clim_type%vertical_indices = INCREASING_UPWARD
          allocate (alpha(nlev))
          do n = 1, nlev
          alpha(n) = clim_type%levs(nlev-n+1)
          end do
          do n = 1, nlev
          clim_type%levs(n) = alpha(n)
          end do
          deallocate (alpha)
      else 
        clim_type%vertical_indices = INCREASING_DOWNWARD
      endif
      
    case('phalf')
      nlevh=len
      allocate(clim_type%halflevs(nlevh))
      call mpp_get_axis_data(axes(i),clim_type%halflevs)
      clim_type%level_type = PRESSURE
  ! Convert to Pa
      if( chomp(units) == "mb" .or. chomp(units) == "hPa") then
         clim_type%halflevs = clim_type%halflevs * 100.
      end if
! define the direction of the vertical data axis
! switch index order if necessary so that indx 1 is at lowest pressure,
! index nlev at highest pressure.
      if( sense == 1 ) then
        clim_type%vertical_indices = INCREASING_UPWARD
          allocate (alpha(nlevh))
          do n = 1, nlevh
          alpha(n) = clim_type%halflevs(nlevh-n+1)
          end do
          do n = 1, nlevh
          clim_type%halflevs(n) = alpha(n)
          end do
          deallocate (alpha)
      else 
        clim_type%vertical_indices = INCREASING_DOWNWARD
      endif
    case('sigma_full')
      nlev=len
      allocate(clim_type%levs(nlev))
      call mpp_get_axis_data(axes(i),clim_type%levs)
      clim_type%level_type = SIGMA
    case('sigma_half')
      nlevh=len
      allocate(clim_type%halflevs(nlevh))
      call mpp_get_axis_data(axes(i),clim_type%halflevs)
      clim_type%level_type = SIGMA
  
    case('time')
      model_calendar = get_calendar_type() 
      fileday = 0
      filemon = 0
      fileyr = 0
      filehr = 0
      filemin= 0
      filesec = 0
      select case(units(:3))
        case('day')
          fileunits = units(12:) !Assuming "days since YYYY-MM-DD HH:MM:SS"
          read(fileunits(1:4)  , *)  fileyr
          read(fileunits(6:7)  , *)  filemon
          read(fileunits(9:10) , *)  fileday
          read(fileunits(12:13), *)  filehr
          read(fileunits(15:16), *)  filemin
          read(fileunits(18:19), *)  filesec
        case('mon')
          fileunits = units(14:) !Assuming "months since YYYY-MM-DD HH:MM:SS"
          read(fileunits(1:4)  , *)  fileyr
          read(fileunits(6:7)  , *)  filemon
          read(fileunits(9:10) , *)  fileday
          read(fileunits(12:13), *)  filehr
          read(fileunits(15:16), *)  filemin
          read(fileunits(18:19), *)  filesec
        case default
          call mpp_error(FATAL,'Interpolator_init : Time units not recognised in file '//file_name)
      end select

       clim_type%climatological_year = (fileyr == 0)

      if (.not. clim_type%climatological_year) then

!----------------------------------------------------------------------
!    if file date has a non-zero year in the base time, determine that
!    base_time based on the netcdf info.
!----------------------------------------------------------------------
        if ( (model_calendar == JULIAN .and.   &
              trim(file_calendar) == 'julian')  .or. &
              (model_calendar == NOLEAP .and.   &
               trim(file_calendar) == 'noleap') )  then
          call mpp_error (NOTE, 'interpolator_mod: Model and file&
                    & calendars are the same for file ' //   &
                    & trim(file_name) // '; no calendar conversion  &
                    &needed')
          base_time = set_date (fileyr, filemon, fileday, filehr, &
                                filemin,filesec)
        else if ( (model_calendar == JULIAN .and.   &
                   trim(file_calendar) == 'noleap')) then  
          call mpp_error (NOTE, 'interpolator_mod: Using julian &
                            &model calendar and noleap file calendar&
                            & for file ' // trim(file_name) //   &
                            &'; calendar conversion needed')
          base_time = set_date_no_leap (fileyr, filemon, fileday,  &
                                        filehr, filemin, filesec)
        else if ( (model_calendar == NOLEAP .and.   &
                   trim(file_calendar) == 'julian')) then  
          call mpp_error (NOTE, 'interpolator_mod: Using noleap &
                            &model calendar and julian file calendar&
                            & for file ' // trim(file_name) //  &
                            &'; calendar conversion needed')
          base_time = set_date_julian (fileyr, filemon, fileday,  &
                                       filehr, filemin, filesec)
        else
          call mpp_error (FATAL , 'interpolator_mod: Model and file&
               & calendars ( ' // trim(file_calendar) // ' ) differ  &
               &for file ' // trim(file_name) // ';  this calendar  &
               &conversion not currently available')
        endif

      else

!! if the year is specified as '0000', then the file is intended to 
!! apply to all years -- the time variables within the file refer to
!! the displacement from the start of each year to the time of the
!! associated data. Time interpolation is to be done with interface 
!! time_interp_list, with the optional argument modtime=YEAR. base_time
!! is set to an arbitrary value here; it's only use will be as a 
!! timestamp for optionally generated diagnostics.

        base_time = get_base_time ()
      endif


      ntime_in = 1
      if (ntime > 0) then
        allocate(time_in(ntime), clim_type%time_slice(ntime))
        allocate(clim_type%clim_times(12,(ntime+11)/12))
        time_in = 0.0
        clim_type%time_slice = set_time(0,0) + base_time
        clim_type%clim_times = set_time(0,0) + base_time
        call mpp_get_times(clim_type%unit, time_in)
        ntime_in = ntime
! determine whether the data is a continuous set of monthly values or
! a series of annual cycles spread throughout the period of data
        non_monthly = .false.
        do n = 1, ntime-1
!  Assume that the times in the data file correspond to days only.
          if (time_in(n+1) > (time_in(n) + 32)) then
            non_monthly = .true.
            exit
          endif
        end do
        if (clim_type%climatological_year) then
          call mpp_error (NOTE, 'interpolator_mod :'  // &
          trim(file_name) // ' is a year-independent climatology file') 
        else
          call mpp_error (NOTE, 'interpolator_mod :' // &
            trim(file_name) // ' is a timeseries file') 
        endif

        do n = 1, ntime
!Assume that the times in the data file correspond to days only.
            

          if (clim_type%climatological_year) then
!! RSH NOTE:
!! for this case, do not add base_time. time_slice will be sent to
!! time_interp_list with the optional argument modtime=YEAR, so that
!! the time that is needed in time_slice is the displacement into the
!! year, not the displacement from a base_time.
            clim_type%time_slice(n) = &
                set_time(INT( ( time_in(n) - INT(time_in(n)) ) * 86400 ),INT(time_in(n)))
          else

!--------------------------------------------------------------------
!    if fileyr /= 0 (i.e., climatological_year=F),
!    then define the times associated with each time-
!    slice. if calendar conversion between data file and model calendar
!    is needed, do it so that data from the file is associated with the
!    same calendar time in the model. here the time_slice needs to 
!    include the base_time; values will be generated relative to the 
!    "real" time.
!--------------------------------------------------------------------
            if ( (model_calendar == JULIAN .and.   &
                  trim(file_calendar) == 'julian')  .or. &
                 (model_calendar == NOLEAP .and.   &
                  trim(file_calendar) == 'noleap') )  then

!---------------------------------------------------------------------
!    no calendar conversion needed.
!---------------------------------------------------------------------
              clim_type%time_slice(n) = &
                 set_time(INT( ( time_in(n) - INT(time_in(n)) ) * 86400 ),INT(time_in(n)))  &
                  + base_time

!---------------------------------------------------------------------
!    convert file times from noleap to julian.
!---------------------------------------------------------------------
            else if ( (model_calendar == JULIAN .and.   &
                       trim(file_calendar) == 'noleap')) then  
              Noleap_time = set_time (0, INT(time_in(n))) + base_time
              call get_date_no_leap (Noleap_time, yr, mo, dy, hr,  &
                                     mn, sc)
              clim_type%time_slice(n) = set_date_julian (yr, mo, dy,  &
                                                         hr, mn, sc)
              if (n == 1) then
                call print_date (clim_type%time_slice(1), &
                        str= 'for file ' // trim(file_name) // ', the &
                              &first time slice is mapped to :')
              endif
              if (n == ntime) then
                call print_date (clim_type%time_slice(ntime), &
                         str= 'for file ' // trim(file_name) // ', the &
                               &last time slice is mapped to:')
              endif
  

!---------------------------------------------------------------------
!    convert file times from julian to noleap.
!---------------------------------------------------------------------
            else if ( (model_calendar == NOLEAP .and.   &
                       trim(file_calendar) == 'julian')) then  
              Julian_time = set_time (0, INT(time_in(n))) + base_time
              call get_date_julian (Julian_time, yr, mo, dy, hr, mn, sc)
              clim_type%time_slice(n) = set_date_no_leap (yr, mo, dy, &
                                                          hr, mn, sc)
              if (n == 1) then
                call print_date (clim_type%time_slice(1), &
                         str= 'for file ' // trim(file_name) // ', the &
                               &first time slice is mapped to :')
              endif
              if (n == ntime) then
                call print_date (clim_type%time_slice(ntime), &
                         str= 'for file ' // trim(file_name) // ', the &
                               &last time slice is mapped to:')
              endif

!---------------------------------------------------------------------
!    any other calendar combinations would have caused a fatal error 
!    above.
!---------------------------------------------------------------------
            endif
          endif

          m = (n-1)/12 +1 ; m1 = n- (m-1)*12
          clim_type%clim_times(m1,m) = clim_type%time_slice(n)
        enddo
      else
        allocate(time_in(1), clim_type%time_slice(1))
        allocate(clim_type%clim_times(1,1))
        time_in = 0.0
        clim_type%time_slice = set_time(0,0) + base_time
        clim_type%clim_times(1,1) = set_time(0,0) + base_time
      endif
      deallocate(time_in)
  end select ! case(name)
enddo


! -------------------------------------------------------------------
! For 2-D fields, allocate levs and halflevs here
!  code is still needed for case when only halflevs are in data file.
! -------------------------------------------------------------------
    if( .not. associated(clim_type%levs) ) then
        allocate( clim_type%levs(nlev) )
        clim_type%levs = 0.0        
    endif  
    if( .not. associated(clim_type%halflevs) )  then
        allocate( clim_type%halflevs(nlev+1) )
        clim_type%halflevs(1) = 0.0
        if (clim_type%level_type == PRESSURE) then
          clim_type%halflevs(nlev+1) = 1013.25* 100.0   ! MKS
        else if (clim_type%level_type == SIGMA   ) then
          clim_type%halflevs(nlev+1) = 1.0
        endif
        do n=2,nlev
           clim_type%halflevs(n) = 0.5*(clim_type%levs(n) + &
                                         clim_type%levs(n-1))
        end do
    endif
deallocate(axes)


! In the case where only the midpoints of the longitudes are defined we force the definition
! of the boundaries to be half-way between the midpoints.
if (.not. associated(clim_type%lon) .and. .not. associated(clim_type%lonb)) &
   call mpp_error(FATAL,'Interpolator_init : There appears to be no longitude axis in file '//file_name)

if (.not. associated(clim_type%lonb) ) then

  if (size(clim_type%lon(:)) /= 1) then
    allocate(clim_type%lonb(size(clim_type%lon(:))+1))
    dlon = (clim_type%lon(2)-clim_type%lon(1))/2.0
    clim_type%lonb(1) = clim_type%lon(1) - dlon
    clim_type%lonb(2:) = clim_type%lon(1:) + dlon
  else

!! this is the case for zonal mean data, lon = 1, lonb not present 
!! in file.

    allocate(clim_type%lonb(2))
    clim_type%lonb(1) = -360.*dtr
    clim_type%lonb(2) = 360.0*dtr
    clim_type%lon(1) = 0.0
  endif    
endif

!clim_type%lonb=clim_type%lonb*dtr 
! This assumes the lonb are in degrees in the NetCDF file!

if (.not. associated(clim_type%lat) .and. .not. associated(clim_type%latb)) &
   call mpp_error(FATAL,'Interpolator_init : There appears to be no latitude axis in file '//file_name)
! In the case where only the grid midpoints of the latitudes are defined we force the 
! definition of the boundaries to be half-way between the midpoints.
if (.not. associated(clim_type%latb) ) then
   allocate(clim_type%latb(nlat+1))
   dlat = (clim_type%lat(2)-clim_type%lat(1)) * 0.5
!  clim_type%latb(1) = min( 90., max(-90., clim_type%lat(1) - dlat) )
   clim_type%latb(1) = min( PI/2., max(-PI/2., clim_type%lat(1) - dlat) )
   clim_type%latb(2:nlat) = ( clim_type%lat(1:nlat-1) + clim_type%lat(2:nlat) ) * 0.5
   dlat = ( clim_type%lat(nlat) - clim_type%lat(nlat-1) ) * 0.5
!  clim_type%latb(nlat+1) = min( 90., max(-90., clim_type%lat(nlat) + dlat) )
   clim_type%latb(nlat+1) = min( PI/2., max(-PI/2., clim_type%lat(nlat) + dlat) )
endif
!clim_type%latb=clim_type%latb*dtr

!Assume that the horizontal interpolation within a file is the same for each variable.

 if (conservative_interp) then
    call horiz_interp_new (clim_type%interph, &
                        clim_type%lonb, clim_type%latb, &
                        lonb_mod, latb_mod)
 else
    
    call mpp_error(NOTE, "Using Bilinear interpolation")

    !!! DEBUG CODE
    if (.not. allocated(agrid_mod)) then
       nx = size(lonb_mod,1)-1
       ny = size(latb_mod,2)-1
       allocate(agrid_mod(nx,ny,2))
       do j=1,ny
       do i=1,nx
          call cell_center2((/lonb_mod(i,j),latb_mod(i,j)/), & 
               (/lonb_mod(i+1,j),latb_mod(i+1,j)/), & 
               (/lonb_mod(i,j+1),latb_mod(i,j+1)/), & 
               (/lonb_mod(i+1,j+1),latb_mod(i+1,j+1)/),  agrid_mod(i,j,:))          
       enddo
       enddo
    endif

    !!! END DEBUG CODE

    call horiz_interp_new (clim_type%interph, &
                        clim_type%lonb, clim_type%latb, &
                        agrid_mod(:,:,1), agrid_mod(:,:,2), interp_method="bilinear")    
 endif

!--------------------------------------------------------------------
!  allocate the variable clim_type%data . This will be the climatology 
!  data horizontally interpolated, so it will be on the model horizontal
!  grid, but it will still be on the climatology vertical grid.
!--------------------------------------------------------------------

select case(ntime)
 case (13:)
! This may  be data that does not have a continous time-line
! i.e. IPCC data where decadal data is present but we wish to retain 
! the seasonal nature of the data.
!! RSH: the following test will not always work; instead use the
!! RSH: non-monthly variable to test on.
!RSHlast_time = clim_type%time_slice(1) + ( ntime -1 ) * &
!RSH        ( clim_type%time_slice(2) - clim_type%time_slice(1) )

!RSHif ( last_time < clim_type%time_slice(ntime)) then

 if (non_monthly) then
! We have a broken time-line. e.g. We have monthly data but only for years ending in 0. 1960,1970 etc.
!   allocate(clim_type%data(size(lonb_mod(:))-1, size(latb_mod(:))-1, nlev, 2, num_fields))
   allocate(clim_type%pmon_pyear(size(lonb_mod,1)-1, size(latb_mod,2)-1, nlev, num_fields))
   allocate(clim_type%pmon_nyear(size(lonb_mod,1)-1, size(latb_mod,2)-1, nlev, num_fields))
   allocate(clim_type%nmon_nyear(size(lonb_mod,1)-1, size(latb_mod,2)-1, nlev, num_fields))
   allocate(clim_type%nmon_pyear(size(lonb_mod,1)-1, size(latb_mod,2)-1, nlev, num_fields))
   clim_type%pmon_pyear = 0.0
   clim_type%pmon_nyear = 0.0
   clim_type%nmon_nyear = 0.0
   clim_type%nmon_pyear = 0.0
   clim_type%TIME_FLAG = BILINEAR
else
! We have a continuous time-line so treat as for 5-12 timelevels as below.
   if ( .not. read_all_on_init) then
   allocate(clim_type%data(size(lonb_mod,1)-1, size(latb_mod,2)-1, nlev, 2, num_fields))
   else
   allocate(clim_type%data(size(lonb_mod,1)-1, size(latb_mod,2)-1, nlev, &
               ntime, num_fields))
   endif
   clim_type%data = 0.0
   clim_type%TIME_FLAG = LINEAR
endif


!++lwh
 case (1:12)
!--lwh
! We have more than 4 timelevels 
! Assume we have monthly or higher time resolution datasets (climatology or time series)
! So we only need to read 2 datasets and apply linear temporal interpolation.
   if ( .not. read_all_on_init) then
   allocate(clim_type%data(size(lonb_mod,1)-1, size(latb_mod,2)-1, nlev, 2, num_fields))
   else
   allocate(clim_type%data(size(lonb_mod,1)-1, size(latb_mod,2)-1, nlev, &
               ntime, num_fields))
   endif
   clim_type%data = 0.0
   clim_type%TIME_FLAG = LINEAR
!++lwh
!case (1:4) 
! Assume we have seasonal data and read in all the data.
! We can apply sine curves to these data.
 
!  allocate(clim_type%data(size(lonb_mod,1)-1, size(latb_mod,2)-1, nlev, ntime, num_fields))
!  clim_type%data = 0.0
!  clim_type%TIME_FLAG = SEASONAL
!--lwh
! case (default)
 case(:0)
   clim_type%TIME_FLAG = NOTIME
   allocate(clim_type%data(size(lonb_mod,1)-1, size(latb_mod,2)-1, nlev, 1, num_fields))
end select


!------------------------------------------------------------------
!    Allocate space for the single time level of the climatology on its 
!    grid size.
!----------------------------------------------------------------------

   if(clim_type%TIME_FLAG .eq. LINEAR ) then
   allocate(clim_type%time_init(num_fields,2))
   else
   allocate(clim_type%time_init(num_fields,ntime))
   endif
   allocate (clim_type%indexm(num_fields),   &
             clim_type%indexp(num_fields),   &
             clim_type%climatology(num_fields))
   clim_type%time_init(:,:) = 0
   clim_type%indexm(:)      = 0
   clim_type%indexp(:)      = 0
   clim_type%climatology(:) = 0
   

allocate(clim_type%field_name(num_fields))
allocate(clim_type%field_type(num_fields))
allocate(clim_type%mr(num_fields))
allocate(clim_type%out_of_bounds(num_fields))
clim_type%out_of_bounds(:)=0
allocate(clim_type%vert_interp(num_fields))
clim_type%vert_interp(:)=0
!--------------------------------------------------------------------
!Allocate the space for the fields within the climatology data file.
allocate(varfields(nvar))
!--------------------------------------------------------------------
! Get the variable names out of the file.
call mpp_get_fields(clim_type%unit, varfields)

if(present(data_names)) then

!++lwh
   if ( size(data_out_of_bounds(:)) /= size(data_names(:)) .and. size(data_out_of_bounds(:)) /= 1 ) &
      call mpp_error(FATAL,'interpolator_init : The size of the data_out_of_bounds array must be 1&
                            & or size(data_names)')
   if (present(vert_interp)) then
      if( size(vert_interp(:)) /= size(data_names(:)) .and. size(vert_interp(:)) /= 1 ) &
      call mpp_error(FATAL,'interpolator_init : The size of the vert_interp array must be 1&
                            & or size(data_names)')
   endif
! Only read the fields named in data_names
   do j=1,size(data_names(:))
      NAME_PRESENT = .FALSE.
      do i=1,nvar
         call mpp_get_atts(varfields(i),name=name,ndim=ndim,units=units)
         if( name == data_names(j) ) then
            units=chomp(units)
            if (mpp_pe() == 0 ) write(*,*) 'Initializing src field : ',trim(name)
            clim_type%field_name(j) = name
            clim_type%field_type(j) = varfields(i)
            clim_type%mr(j)         = check_climo_units(units)
            NAME_PRESENT = .TRUE.
            if (present(clim_units)) clim_units(j) = units
            clim_type%out_of_bounds(j) = data_out_of_bounds( MIN(j,SIZE(data_out_of_bounds(:))) )
            if( clim_type%out_of_bounds(j) /= CONSTANT .and. &
                clim_type%out_of_bounds(j) /= ZERO ) &
               call mpp_error(FATAL,"Interpolator_init: data_out_of_bounds must be&
                                    & set to ZERO or CONSTANT")               
            if( present(vert_interp) ) then
               clim_type%vert_interp(j) = vert_interp( MIN(j,SIZE(vert_interp(:))) )
               if( clim_type%vert_interp(j) /= INTERP_WEIGHTED_P .and. &
                   clim_type%vert_interp(j) /= INTERP_LINEAR_P ) &
                  call mpp_error(FATAL,"Interpolator_init: vert_interp must be&
                                       & set to INTERP_WEIGHTED_P or INTERP_LINEAR_P")
            else
               clim_type%vert_interp(j) = INTERP_WEIGHTED_P
            end if
         endif
      enddo
      if(.not. NAME_PRESENT) &
         call mpp_error(FATAL,'interpolator_init : Check names of fields being passed. ' &
                              //trim(data_names(j))//' does not exist.')
   enddo
else

   if ( size(data_out_of_bounds(:)) /= nvar .and. size(data_out_of_bounds(:)) /= 1 ) &
      call mpp_error(FATAL,'interpolator_init : The size of the out of bounds array must be 1&
                           & or the number of fields in the climatology dataset')
   if ( present(vert_interp) ) then
      if (size(vert_interp(:)) /= nvar .and. size(vert_interp(:)) /= 1 ) & 
      call mpp_error(FATAL,'interpolator_init : The size of the vert_interp array must be 1&
                           & or the number of fields in the climatology dataset')
   endif

! Read all the fields within the climatology data file.
   do i=1,nvar
      call mpp_get_atts(varfields(i),name=name,ndim=ndim,units=units)
         if (mpp_pe() ==0 ) write(*,*) 'Initializing src field : ',trim(name)
         clim_type%field_name(i) = lowercase(trim(name))
         clim_type%field_type(i) = varfields(i)
         clim_type%mr(i)         = check_climo_units(units)
         if (present(clim_units)) clim_units(i) = units
         clim_type%out_of_bounds(i) = data_out_of_bounds( MIN(i,SIZE(data_out_of_bounds(:))) )
         if( clim_type%out_of_bounds(i) /= CONSTANT .and. &
             clim_type%out_of_bounds(i) /= ZERO ) &
            call mpp_error(FATAL,"Interpolator_init: data_out_of_bounds must be&
                                 & set to ZERO or CONSTANT")
         if( present(vert_interp) ) then
            clim_type%vert_interp(i) = vert_interp( MIN(i,SIZE(vert_interp(:))) )
            if( clim_type%vert_interp(i) /= INTERP_WEIGHTED_P .and. &
                clim_type%vert_interp(i) /= INTERP_LINEAR_P ) &
               call mpp_error(FATAL,"Interpolator_init: vert_interp must be&
                                    & set to INTERP_WEIGHTED_P or INTERP_LINEAR_P")
         else
            clim_type%vert_interp(i) = INTERP_WEIGHTED_P
         end if
   end do
!--lwh
endif

deallocate(varfields)


if( clim_type%TIME_FLAG .eq. SEASONAL ) then
! Read all the data at this point.
   do i=1,num_fields
      do n = 1, ntime
         call read_data( clim_type, clim_type%field_type(i), &
                         clim_type%data(:,:,:,n,i), n, i, base_time )
      enddo
   enddo
endif

if( clim_type%TIME_FLAG .eq. LINEAR  .and. read_all_on_init) then
! Read all the data at this point.
   do i=1,num_fields
      do n = 1, ntime
         call read_data( clim_type, clim_type%field_type(i), &
                         clim_type%data(:,:,:,n,i), n, i, base_time )
      enddo
   enddo

   call mpp_close (unit)
endif

if( clim_type%TIME_FLAG .eq. NOTIME ) then
! Read all the data at this point.
   do i=1,num_fields
     call read_data_no_time_axis( clim_type, clim_type%field_type(i), &
                                  clim_type%data(:,:,:,1,i), i )
   enddo
   call mpp_close (unit)
endif

if (present (single_year_file)) then
  single_year_file = clim_type%climatological_year
endif

module_is_initialized = .true.

call write_version_number(version, tagname)

end subroutine interpolator_init

 subroutine cell_center2(q1, q2, q3, q4, e2)
      real , intent(in ) :: q1(2), q2(2), q3(2), q4(2)
      real , intent(out) :: e2(2)
! Local
      real p1(3), p2(3), p3(3), p4(3)
      real ec(3)
      real dd
      integer k

      call latlon2xyz(q1, p1)
      call latlon2xyz(q2, p2)
      call latlon2xyz(q3, p3)
      call latlon2xyz(q4, p4)

      do k=1,3
         ec(k) = p1(k) + p2(k) + p3(k) + p4(k)
      enddo
      dd = sqrt( ec(1)**2 + ec(2)**2 + ec(3)**2 )

      do k=1,3
         ec(k) = ec(k) / dd
      enddo

      call cart_to_latlon(1, ec, e2(1), e2(2))

 end subroutine cell_center2

 subroutine cart_to_latlon(np, q, xs, ys)
! vector version of cart_to_latlon1
  integer, intent(in):: np
  real, intent(inout):: q(3,np)
  real, intent(inout):: xs(np), ys(np)
! local
  real, parameter:: esl=1.e-10
  real (f_p):: p(3)
  real (f_p):: dist, lat, lon
  integer i,k

  do i=1,np
     do k=1,3
        p(k) = q(k,i)
     enddo
     dist = sqrt(p(1)**2 + p(2)**2 + p(3)**2)
     do k=1,3
        p(k) = p(k) / dist
     enddo

     if ( (abs(p(1))+abs(p(2)))  < esl ) then
          lon = 0.
     else
          lon = atan2( p(2), p(1) )   ! range [-pi,pi]
     endif

     if ( lon < 0.) lon = 2.*pi + lon
     lat = asin(p(3))
     
     xs(i) = lon
     ys(i) = lat
! q Normalized:
     do k=1,3
        q(k,i) = p(k)
     enddo
  enddo

 end  subroutine cart_to_latlon

 subroutine latlon2xyz(p, e)
!
! Routine to map (lon, lat) to (x,y,z)
!
 real, intent(in) :: p(2)
 real, intent(out):: e(3)

 integer n
 real (f_p):: q(2)
 real (f_p):: e1, e2, e3

    do n=1,2
       q(n) = p(n)
    enddo

    e1 = cos(q(2)) * cos(q(1))
    e2 = cos(q(2)) * sin(q(1))
    e3 = sin(q(2))
!-----------------------------------
! Truncate to the desired precision:
!-----------------------------------
    e(1) = e1
    e(2) = e2
    e(3) = e3

 end subroutine latlon2xyz

!
!#######################################################################
!
function check_climo_units(units)
! Function to check the units that the climatology data is using. 
! This is needed to allow for conversion of datasets to mixing ratios which is what the 
! vertical interpolation scheme requires
! The default is to assume no conversion is needed.
! If the units are those of a column burden (kg/m2) then conversion to mixing ratio is flagged.
!
character(len=*), intent(in) :: units

integer :: check_climo_units

check_climo_units = NO_CONV
select case(chomp(units))
  case('kg/m2', 'kg/m^2', 'kg/m**2', 'kg m^-2', 'kg m**-2')
     check_climo_units = KG_M2  
  case('molecules/cm2/s', 'molecule/cm2/s', 'molec/cm2/s')
     check_climo_units = KG_M2  
  case('kg/m2/s')
     check_climo_units = KG_M2  
end select

end function check_climo_units
!
!#######################################################################
!
subroutine init_clim_diag(clim_type, mod_axes, init_time)
!
! Routine to register diagnostic fields for the climatology file. 
! This routine calculates the domain decompostion of the climatology fields 
! for later export through send_data.
! The ids created here are for column burdens that will diagnose the vertical interpolation routine.
! climo_diag_id : 'module_name = climo' is intended for use with the model vertical resolution.
! hinterp_id    : 'module_name = 'hinterp' is intended for use with the climatology vertical resolution.

! INTENT INOUT :
!    clim_type : The interpolate type containing the names of the fields in the climatology file.
!
! INTENT IN    :
!   mod_axes   : The axes of the model.
!   init_time  : The model initialization time.
!
type(interpolate_type), intent(inout)  :: clim_type
integer               , intent(in)     :: mod_axes(:)
type(time_type)       , intent(in)     :: init_time

integer :: axes(2),nxd,nyd,ndivs,i
type(domain2d) :: domain
integer :: domain_layout(2), iscomp, iecomp,jscomp,jecomp


if (.not. module_is_initialized .or. .not. associated(clim_type%lon)) &
   call mpp_error(FATAL, "init_clim_diag : You must call interpolator_init before calling init_clim_diag")


ndivs = mpp_npes()
nxd = size(clim_type%lon(:))
nyd = size(clim_type%lat(:))

! Define the domain decomposition of the climatology file. This may be (probably is) different from the model domain.
call mpp_define_layout ((/1,nxd,1,nyd/), ndivs, domain_layout)
call mpp_define_domains((/1,nxd,1,nyd/),domain_layout, domain,xhalo=0,yhalo=0)  
call mpp_get_compute_domain (domain, iscomp, iecomp, jscomp, jecomp)
   axes(1) = diag_axis_init(clim_type%file_name(1:5)//'x',clim_type%lon,units='degrees',cart_name='x',domain2=domain)
   axes(2) = diag_axis_init(clim_type%file_name(1:5)//'y',clim_type%lat,units='degrees',cart_name='y',domain2=domain)
clim_type%is = iscomp
clim_type%ie = iecomp
clim_type%js = jscomp
clim_type%je = jecomp

!init_time = set_date(1980,1,1,0,0,0)

if ((num_clim_diag + size(clim_type%field_name(:))) .gt. max_diag_fields )  &
   call mpp_error(FATAL, "init_clim_diag : Trying to set up too many diagnostic fields for the climatology data")
do i=1,size(clim_type%field_name(:))
climo_diag_name(i+num_clim_diag) = clim_type%field_name(i)
climo_diag_id(i+num_clim_diag) =  register_diag_field('climo',clim_type%field_name(i),axes(1:2),init_time,&
                                'climo_'//clim_type%field_name(i), 'kg/kg', missing_value)
hinterp_id(i+num_clim_diag) =  register_diag_field('hinterp',clim_type%field_name(i),mod_axes(1:2),init_time,&
                                'interp_'//clim_type%field_name(i),'kg/kg' , missing_value)
enddo
! Total number of climatology diagnostics (num_clim_diag). This can be from multiple climatology fields with different spatial axes. 
! It is simply a holder for the diagnostic indices.
num_clim_diag = num_clim_diag+size(clim_type%field_name(:))

clim_diag_initialized = .true.

end subroutine init_clim_diag



!----------------------------------------------------------------------------

subroutine obtain_interpolator_time_slices (clim_type, Time)

!  Makes sure that appropriate time slices are available for interpolation 
!  on this time step
!
! INTENT INOUT
!   clim_type   : The interpolate type previously defined by a call to interpolator_init
!
! INTENT IN
!   Time        : The model time that you wish to interpolate to.

type(interpolate_type), intent(inout)  :: clim_type
type(time_type)       , intent(in)  :: Time

integer :: taum, taup
integer :: modyear, modmonth, modday, modhour, modminute, modsecond
integer :: climyear, climmonth, climday, climhour, climminute, climsecond
integer :: year1, month1, day, hour, minute, second
integer :: climatology, m
type(time_type) :: t_prev, t_next
type(time_type), dimension(2) :: month
integer :: indexm, indexp, yearm, yearp
integer :: i, n
character(len=256) :: err_msg

    if (clim_type%climatological_year) then
       !++lwh
       if (size(clim_type%time_slice) > 1) then
          call time_interp(Time, clim_type%time_slice, clim_type%tweight, taum, taup, modtime=YEAR, err_msg=err_msg )
          if(err_msg /= '') then
             call mpp_error(FATAL,'interpolator_timeslice 1: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
          endif
       else
          taum = 1
          taup = 1
          clim_type%tweight = 0.
       end if
       !--lwh
    else
       call time_interp(Time, clim_type%time_slice, clim_type%tweight, taum, taup, err_msg=err_msg )
       if(err_msg /= '') then
          call mpp_error(FATAL,'interpolator_timeslice 2: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
       endif
    endif

    if(clim_type%TIME_FLAG .eq. BILINEAR ) then
      ! Check if delta-time is greater than delta of first two climatology time-slices.
      if ( (Time - clim_type%time_slice(taum) ) > ( clim_type%time_slice(2)- clim_type%time_slice(1) ) .or. &
           (clim_type%time_slice(taup)  - Time) > ( clim_type%time_slice(2)- clim_type%time_slice(1) ) ) then
      ! The difference between the model time and the last climatology time-slice previous to the model time.
      ! We need 2 time levels.
        clim_type%itaum=0
        clim_type%itaup=0
      ! Assume this is monthly data. So we need to get the data applicable to the model date but substitute 
      ! the climatology year into the appropriate place.

     
      ! We need to get the previous months data for the climatology year before 
      ! and after the model year.
        call get_date(Time, modyear, modmonth, modday, modhour, modminute, modsecond)
        call get_date(clim_type%time_slice(taum), climyear, climmonth, climday, climhour, climminute, climsecond)

        climatology = 1
        do m = 1, size(clim_type%clim_times(:,:),2)
          !Assume here that a climatology is for 1 year and consists of 12 months starting in January.
          call get_date(clim_type%clim_times(1,m), year1, month1, day, hour, minute, second)
          if (year1 == climyear) climatology = m 
        enddo
        do m = 1,12
          !Find which month we are trying to look at and set clim_date[mp] to the dates spanning that.
          call get_date(clim_type%clim_times(m,climatology), year1, month1, day, hour, minute, second)
          if ( month1 == modmonth ) then
!RSHBUGFX   if ( modday <= day ) then 
            if ( modday <  day ) then 
              indexm = m-1 ; indexp = m
            else
              indexm = m ; indexp = m+1
            endif
          endif
        
        enddo
        if ( indexm == 0 ) then 
          indexm = 12
          yearm = modyear - 1
        else
          yearm = modyear
        endif
          call get_date(clim_type%time_slice(indexm+(climatology-1)*12), &
                        climyear, climmonth, climday, climhour, climminute, climsecond)
          month(1) = set_date(yearm, indexm, climday, climhour, climminute, climsecond)
        if ( indexp == 13 ) then
          indexp = 1
          yearp = modyear + 1
        else
          yearp = modyear
        endif
          call get_date(clim_type%time_slice(indexp+(climatology-1)*12), &
                        climyear, climmonth, climday, climhour, climminute, climsecond)
          month(2) = set_date(yearp, indexp, climday, climhour, climminute, climsecond)
        
        call time_interp(Time, month, clim_type%tweight3, taum, taup, err_msg=err_msg ) ! tweight3 is the time weight between the months.
        if(err_msg /= '') then
          call mpp_error(FATAL,'interpolator_timeslice 3: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
        endif

        month(1) = clim_type%time_slice(indexm+(climatology-1)*12)
        month(2) = clim_type%time_slice(indexm+climatology*12)
        call get_date(month(1), climyear, climmonth, climday, climhour, climminute, climsecond)
        t_prev = set_date(yearm, climmonth, climday, climhour, climminute, climsecond)
        call time_interp(t_prev, month, clim_type%tweight1, taum, taup, err_msg=err_msg ) !tweight1 is the time weight between the climatology years.
        if(err_msg /= '') then
           call mpp_error(FATAL,'interpolator_timeslice 4: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
        endif

        month(1) = clim_type%time_slice(indexp+(climatology-1)*12)
        month(2) = clim_type%time_slice(indexp+climatology*12)
        call get_date(month(1), climyear, climmonth, climday, climhour, climminute, climsecond)
        t_next = set_date(yearp, climmonth, climday, climhour, climminute, climsecond)
        call time_interp(t_next, month, clim_type%tweight2, taum, taup, err_msg=err_msg ) !tweight1 is the time weight between the climatology years.
        if(err_msg /= '') then
           call mpp_error(FATAL,'interpolator_timeslice 5: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
        endif

        if (indexm == clim_type%indexm(1) .and.  &
            indexp == clim_type%indexp(1) .and. &
            climatology == clim_type%climatology(1)) then
        else
          clim_type%indexm(:) = indexm
          clim_type%indexp(:) = indexp
          clim_type%climatology(:) = climatology
          do i=1, size(clim_type%field_name(:))
            call read_data(clim_type,clim_type%field_type(i),  &
             clim_type%pmon_pyear(:,:,:,i),   &
             clim_type%indexm(i)+(clim_type%climatology(i)-1)*12,i,Time)
! Read the data for the next month in the previous climatology.
            call read_data(clim_type,clim_type%field_type(i),  &
             clim_type%nmon_pyear(:,:,:,i),   &
             clim_type%indexp(i)+(clim_type%climatology(i)-1)*12,i,Time)
            call read_data(clim_type,clim_type%field_type(i),  &
              clim_type%pmon_nyear(:,:,:,i),  &
              clim_type%indexm(i)+clim_type%climatology(i)*12,i,Time)
            call read_data(clim_type,clim_type%field_type(i),  &
              clim_type%nmon_nyear(:,:,:,i),  &
              clim_type%indexp(i)+clim_type%climatology(i)*12,i,Time)
          end do
        endif



      else ! We are within a climatology data set
        

        do i=1, size(clim_type%field_name(:))
          if (taum /= clim_type%time_init(i,1) .or. &
              taup /= clim_type%time_init(i,2) ) then
 
     
            call read_data(clim_type,clim_type%field_type(i),   &
                           clim_type%pmon_pyear(:,:,:,i), taum,i,Time)
! Read the data for the next month in the previous climatology.
            call read_data(clim_type,clim_type%field_type(i),   &
                           clim_type%nmon_pyear(:,:,:,i), taup,i,Time)
            clim_type%time_init(i,1) = taum
            clim_type%time_init(i,2) = taup
          endif
        end do

!       clim_type%pmon_nyear = 0.0
!       clim_type%nmon_nyear = 0.0

! set to zero so when next return to bilinear section will be sure to
! have proper data (relevant when running fixed_year case for more than
! one year in a single job)
          clim_type%indexm(:) = 0       
          clim_type%indexp(:) = 0        
          clim_type%climatology(:) = 0             


!       clim_type%tweight3 = 0.0 ! This makes [pn]mon_nyear irrelevant. Set them to 0 to test.
        clim_type%tweight1 = 0.0 
        clim_type%tweight2 = 0.0 
        clim_type%tweight3 = clim_type%tweight                                          
      endif
    endif   !(BILINEAR)

    if(clim_type%TIME_FLAG .eq. LINEAR  .and.   &
        (.not. read_all_on_init) ) then
! We need 2 time levels. Check we have the correct data.
      clim_type%itaum=0
      clim_type%itaup=0
      do n=1,size(clim_type%time_init,2)
        if (clim_type%time_init(1,n) .eq. taum ) clim_type%itaum = n
        if (clim_type%time_init(1,n) .eq. taup ) clim_type%itaup = n
      enddo

      if (clim_type%itaum.eq.0 .and. clim_type%itaup.eq.0) then
!Neither time is set so we need to read 2 time slices.
!Set up 
! field(:,:,:,1) as the previous time slice.
! field(:,:,:,2) as the next time slice.
    do i=1, size(clim_type%field_name(:))
    call read_data(clim_type,clim_type%field_type(i), clim_type%data(:,:,:,1,i), taum,i,Time)
          clim_type%time_init(i,1) = taum
          clim_type%itaum = 1
    call read_data(clim_type,clim_type%field_type(i), clim_type%data(:,:,:,2,i), taup,i,Time)
          clim_type%time_init(i,2) = taup
          clim_type%itaup = 2
    end do
      endif ! clim_type%itaum.eq.clim_type%itaup.eq.0
      if (clim_type%itaum.eq.0 .and. clim_type%itaup.ne.0) then
! Can't think of a situation where we would have the next time level but not the previous.
 call mpp_error(FATAL,'interpolator_timeslice : No data from the previous climatology time &
                         & but we have the next time. How did this happen?')
      endif
      if (clim_type%itaum.ne.0 .and. clim_type%itaup.eq.0) then
!We have the previous time step but not the next time step data
        clim_type%itaup = 1
        if (clim_type%itaum .eq. 1 ) clim_type%itaup = 2
    do i=1, size(clim_type%field_name(:))
        call read_data(clim_type,clim_type%field_type(i), clim_type%data(:,:,:,clim_type%itaup,i), taup,i, Time)
        clim_type%time_init(i,clim_type%itaup)=taup
     end do
      endif


    endif! TIME_FLAG

    clim_type%separate_time_vary_calc = .true.

!-------------------------------------------------------------------


end subroutine obtain_interpolator_time_slices 


!#####################################################################

subroutine unset_interpolator_time_flag (clim_type)

type(interpolate_type), intent(inout) :: clim_type


      clim_type%separate_time_vary_calc = .false.


end subroutine unset_interpolator_time_flag 



!#####################################################################

!---------------------------------------------------------------------

subroutine interpolator_4D(clim_type, Time, phalf, interp_data,  &
                           field_name, is,js, clim_units)
!
! Return 4-D field interpolated to model grid and time
!
! INTENT INOUT
!   clim_type   : The interpolate type previously defined by a call to interpolator_init
!
! INTENT IN
!   field_name  : The name of a field that you wish to interpolate.
!                 all variables within this interpolate_type variable
!                 will be interpolated on this call. field_name may
!                 be any one of the variables.
!   Time        : The model time that you wish to interpolate to.
!   phalf       : The half level model pressure field.
!   is, js      : The indices of the physics window.
!
! INTENT OUT
!   interp_data : The model fields with the interpolated climatology data.
!   clim_units  : The units of field_name
!
type(interpolate_type), intent(inout)  :: clim_type
character(len=*)      , intent(in)  :: field_name
type(time_type)       , intent(in)  :: Time
real, dimension(:,:,:), intent(in)  :: phalf
real, dimension(:,:,:,:), intent(out) :: interp_data
integer               , intent(in) , optional :: is,js
character(len=*)      , intent(out), optional :: clim_units
integer :: taum, taup, ilon
real :: hinterp_data(size(interp_data,1),size(interp_data,2),size(clim_type%levs(:)),size(clim_type%field_name(:)))
real :: p_fact(size(interp_data,1),size(interp_data,2))
real :: col_data(size(interp_data,1),size(interp_data,2),   &
                           size(clim_type%field_name(:)))
real :: pclim(size(clim_type%halflevs(:)))
integer :: istart,iend,jstart,jend
logical :: result, found
logical :: found_field=.false.
integer :: modyear, modmonth, modday, modhour, modminute, modsecond
integer :: climyear, climmonth, climday, climhour, climminute, climsecond
integer :: year1, month1, day, hour, minute, second
integer :: climatology, m
type(time_type) :: t_prev, t_next
type(time_type), dimension(2) :: month
integer :: indexm, indexp, yearm, yearp
integer :: i, j, k, n
character(len=256) :: err_msg

if (.not. module_is_initialized .or. .not. associated(clim_type%lon)) &
   call mpp_error(FATAL, "interpolator_4D : You must call interpolator_init before calling interpolator")

   do n=2,size(clim_type%field_name(:))
     if (clim_type%vert_interp(n) /= clim_type%vert_interp(n-1) .or. &
      clim_type%out_of_bounds(n) /= clim_type%out_of_bounds(n-1)) then
       if (mpp_pe() == mpp_root_pe() ) then
         print *, 'processing file ' // trim(clim_type%file_name)
       endif
       call mpp_error (FATAL, 'interpolator_mod: &
               &cannot use 4D interface to interpolator for this file')
     endif
   end do
     



istart = 1
if (present(is)) istart = is
iend = istart - 1 + size(interp_data,1)

jstart = 1
if (present(js)) jstart = js
jend = jstart - 1 + size(interp_data,2)

  do i= 1,size(clim_type%field_name(:))
!!++lwh
   if ( field_name == clim_type%field_name(i) ) then
!--lwh
    found_field=.true.
    exit 
 endif
end do
   i = 1

    if(present(clim_units)) then
      call mpp_get_atts(clim_type%field_type(i),units=clim_units)
      clim_units = chomp(clim_units)
    endif




!----------------------------------------------------------------------
!   skip the time interpolation portion of this routine if subroutine
!   obtain_interpolator_time_slices has already been called on this
!   stewp for this interpolate_type variable.
!----------------------------------------------------------------------

if ( .not. clim_type%separate_time_vary_calc) then     
!   print *, 'TIME INTERPOLATION NOT SEPARATED 4d--',  &
!                                trim(clim_type%file_name), mpp_pe()

    if (clim_type%climatological_year) then
!++lwh
       if (size(clim_type%time_slice) > 1) then
          call time_interp(Time, clim_type%time_slice, clim_type%tweight, taum, taup, modtime=YEAR, err_msg=err_msg )
          if(err_msg /= '') then
             call mpp_error(FATAL,'interpolator_4D 1: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
          endif
       else
          taum = 1
          taup = 1
          clim_type%tweight = 0.
       end if
!--lwh
    else
       call time_interp(Time, clim_type%time_slice, clim_type%tweight, taum, taup, err_msg=err_msg )
       if(err_msg /= '') then
          call mpp_error(FATAL,'interpolator_4D 2: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
       endif
    endif

    if(clim_type%TIME_FLAG .eq. BILINEAR ) then
      ! Check if delta-time is greater than delta of first two climatology time-slices.
      if ( (Time - clim_type%time_slice(taum) ) > ( clim_type%time_slice(2)- clim_type%time_slice(1) ) .or. &
           (clim_type%time_slice(taup)  - Time) > ( clim_type%time_slice(2)- clim_type%time_slice(1) ) ) then
      ! The difference between the model time and the last climatology time-slice previous to the model time.
      ! We need 2 time levels.
        clim_type%itaum=0
        clim_type%itaup=0
      ! Assume this is monthly data. So we need to get the data applicable to the model date but substitute 
      ! the climatology year into the appropriate place.

     
      ! We need to get the previous months data for the climatology year before 
      ! and after the model year.
        call get_date(Time, modyear, modmonth, modday, modhour, modminute, modsecond)
        call get_date(clim_type%time_slice(taum), climyear, climmonth, climday, climhour, climminute, climsecond)

        climatology = 1
        do m = 1, size(clim_type%clim_times(:,:),2)
          !Assume here that a climatology is for 1 year and consists of 12 months starting in January.
          call get_date(clim_type%clim_times(1,m), year1, month1, day, hour, minute, second)
          if (year1 == climyear) climatology = m 
        enddo
        do m = 1,12
          !Find which month we are trying to look at and set clim_date[mp] to the dates spanning that.
          call get_date(clim_type%clim_times(m,climatology), year1, month1, day, hour, minute, second)
          if ( month1 == modmonth ) then
!RSHBUGFX   if ( modday <= day ) then 
            if ( modday <  day ) then 
              indexm = m-1 ; indexp = m
            else
              indexm = m ; indexp = m+1
            endif
          endif
        
        enddo
        if ( indexm == 0 ) then 
          indexm = 12
          yearm = modyear - 1
        else
          yearm = modyear
        endif
          call get_date(clim_type%time_slice(indexm+(climatology-1)*12), &
                        climyear, climmonth, climday, climhour, climminute, climsecond)
          month(1) = set_date(yearm, indexm, climday, climhour, climminute, climsecond)
        if ( indexp == 13 ) then
          indexp = 1
          yearp = modyear + 1
        else
          yearp = modyear
        endif
          call get_date(clim_type%time_slice(indexp+(climatology-1)*12), &
                        climyear, climmonth, climday, climhour, climminute, climsecond)
          month(2) = set_date(yearp, indexp, climday, climhour, climminute, climsecond)
        
        call time_interp(Time, month, clim_type%tweight3, taum, taup, err_msg=err_msg ) ! tweight3 is the time weight between the months.
        if(err_msg /= '') then
           call mpp_error(FATAL,'interpolator_4D 3: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
        endif    

        month(1) = clim_type%time_slice(indexm+(climatology-1)*12)
        month(2) = clim_type%time_slice(indexm+climatology*12)
        call get_date(month(1), climyear, climmonth, climday, climhour, climminute, climsecond)
        t_prev = set_date(yearm, climmonth, climday, climhour, climminute, climsecond)
        call time_interp(t_prev, month, clim_type%tweight1, taum, taup, err_msg=err_msg ) !tweight1 is the time weight between the climatology years.
        if(err_msg /= '') then
           call mpp_error(FATAL,'interpolator_4D 4: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
        endif    
        month(1) = clim_type%time_slice(indexp+(climatology-1)*12)
        month(2) = clim_type%time_slice(indexp+climatology*12)
        call get_date(month(1), climyear, climmonth, climday, climhour, climminute, climsecond)
        t_next = set_date(yearp, climmonth, climday, climhour, climminute, climsecond)
        call time_interp(t_next, month, clim_type%tweight2, taum, taup, err_msg=err_msg ) !tweight1 is the time weight between the climatology years.
        if(err_msg /= '') then
           call mpp_error(FATAL,'interpolator_4D 5: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
        endif    

        if (indexm == clim_type%indexm(1) .and.  &
            indexp == clim_type%indexp(1) .and. &
            climatology == clim_type%climatology(1)) then
        else
          clim_type%indexm(:) = indexm
          clim_type%indexp(:) = indexp
          clim_type%climatology(:) = climatology
          do i=1, size(clim_type%field_name(:))
            call read_data(clim_type,clim_type%field_type(i),  &
             clim_type%pmon_pyear(:,:,:,i),   &
             clim_type%indexm(i)+(clim_type%climatology(i)-1)*12,i,Time)
! Read the data for the next month in the previous climatology.
            call read_data(clim_type,clim_type%field_type(i),  &
             clim_type%nmon_pyear(:,:,:,i),   &
             clim_type%indexp(i)+(clim_type%climatology(i)-1)*12,i,Time)
            call read_data(clim_type,clim_type%field_type(i),  &
              clim_type%pmon_nyear(:,:,:,i),  &
              clim_type%indexm(i)+clim_type%climatology(i)*12,i,Time)
            call read_data(clim_type,clim_type%field_type(i),  &
              clim_type%nmon_nyear(:,:,:,i),  &
              clim_type%indexp(i)+clim_type%climatology(i)*12,i,Time)
          end do
        endif



      else ! We are within a climatology data set
        

        do i=1, size(clim_type%field_name(:))
          if (taum /= clim_type%time_init(i,1) .or. &
              taup /= clim_type%time_init(i,2) ) then
 
     
            call read_data(clim_type,clim_type%field_type(i),   &
                           clim_type%pmon_pyear(:,:,:,i), taum,i,Time)
! Read the data for the next month in the previous climatology.
            call read_data(clim_type,clim_type%field_type(i),   &
                           clim_type%nmon_pyear(:,:,:,i), taup,i,Time)
            clim_type%time_init(i,1) = taum
            clim_type%time_init(i,2) = taup
          endif
        end do

!       clim_type%pmon_nyear = 0.0
!       clim_type%nmon_nyear = 0.0

! set to zero so when next return to bilinear section will be sure to
! have proper data (relevant when running fixed_year case for more than
! one year in a single job)
          clim_type%indexm(:) = 0       
          clim_type%indexp(:) = 0        
          clim_type%climatology(:) = 0             


!       clim_type%tweight3 = 0.0 ! This makes [pn]mon_nyear irrelevant. Set them to 0 to test.
        clim_type%tweight1 = 0.0 
        clim_type%tweight2 = 0.0 
        clim_type%tweight3 = clim_type%tweight                                          
      endif
    endif   !(BILINEAR)

    if(clim_type%TIME_FLAG .eq. LINEAR  .and.   &
        (.not. read_all_on_init) ) then
! We need 2 time levels. Check we have the correct data.
      clim_type%itaum=0
      clim_type%itaup=0
      do n=1,size(clim_type%time_init,2)
        if (clim_type%time_init(1,n) .eq. taum ) clim_type%itaum = n
        if (clim_type%time_init(1,n) .eq. taup ) clim_type%itaup = n
      enddo

      if (clim_type%itaum.eq.0 .and. clim_type%itaup.eq.0) then
!Neither time is set so we need to read 2 time slices.
!Set up 
! field(:,:,:,1) as the previous time slice.
! field(:,:,:,2) as the next time slice.
    do i=1, size(clim_type%field_name(:))
    call read_data(clim_type,clim_type%field_type(i), clim_type%data(:,:,:,1,i), taum,i,Time)
          clim_type%time_init(i,1) = taum
          clim_type%itaum = 1
    call read_data(clim_type,clim_type%field_type(i), clim_type%data(:,:,:,2,i), taup,i,Time)
          clim_type%time_init(i,2) = taup
          clim_type%itaup = 2
    end do
      endif ! clim_type%itaum.eq.clim_type%itaup.eq.0
      if (clim_type%itaum.eq.0 .and. clim_type%itaup.ne.0) then
! Can't think of a situation where we would have the next time level but not the previous.
 call mpp_error(FATAL,'interpolator_3D : No data from the previous climatology time &
                         & but we have the next time. How did this happen?')
      endif
      if (clim_type%itaum.ne.0 .and. clim_type%itaup.eq.0) then
!We have the previous time step but not the next time step data
        clim_type%itaup = 1
        if (clim_type%itaum .eq. 1 ) clim_type%itaup = 2
    do i=1, size(clim_type%field_name(:))
        call read_data(clim_type,clim_type%field_type(i), clim_type%data(:,:,:,clim_type%itaup,i), taup,i, Time)
        clim_type%time_init(i,clim_type%itaup)=taup
     end do
      endif


    endif! TIME_FLAG


endif ! (.not. separate_time_vary_calc)


select case(clim_type%TIME_FLAG)
  case (LINEAR)
    do n=1, size(clim_type%field_name(:))
      hinterp_data(:,:,:,n) = (1-clim_type%tweight)*  &
                clim_type%data(istart:iend,jstart:jend,:,clim_type%itaum,n)  +  &
                                 clim_type%tweight*   &
                clim_type%data(istart:iend,jstart:jend,:,clim_type%itaup,n)
    end do
! case (SEASONAL)
! Do sine fit to data at this point
  case (BILINEAR)
    do n=1, size(clim_type%field_name(:))
      hinterp_data(:,:,:,n) = (1-clim_type%tweight1)*(1-clim_type%tweight3)*   &
                   clim_type%pmon_pyear(istart:iend,jstart:jend,:,n) + &
                              (1-clim_type%tweight2)*clim_type%tweight3*    &
                   clim_type%nmon_pyear(istart:iend,jstart:jend,:,n) + &
                               clim_type%tweight1* (1-clim_type%tweight3)*  &
                   clim_type%pmon_nyear(istart:iend,jstart:jend,:,n) + &
                               clim_type%tweight2* clim_type%tweight3*   &
                   clim_type%nmon_nyear(istart:iend,jstart:jend,:,n)
    
    end do

end select
    
select case(clim_type%level_type)
  case(PRESSURE)
    p_fact = 1.0
  case(SIGMA)
    p_fact = maxval(phalf,3)! max pressure in the column !(:,:,size(phalf,3))
end select

col_data(:,:,:)=0.0
     do i= 1, size(clim_type%field_name(:))

select case(clim_type%mr(i))
  case(NO_CONV)
    do k = 1,size(hinterp_data,3)
   col_data(:,:,i) = col_data(:,:,i) + hinterp_data(:,:,k,i)* &
      (clim_type%halflevs(k+1)-clim_type%halflevs(k))/grav
    enddo
    
  case(KG_M2)
    do k = 1,size(hinterp_data,3)
       col_data(:,:,i) = col_data(:,:,i) + hinterp_data(:,:,k,i)
       hinterp_data(:,:,k,i) = hinterp_data(:,:,k,i)/ &
         ((clim_type%halflevs(k+1)-clim_type%halflevs(k))*p_fact)
    enddo
end select
    enddo

     do i= 1, size(clim_type%field_name(:))
found = .false.
do j = 1,size(climo_diag_name(:))
  if (climo_diag_name(j) .eq. clim_type%field_name(i)) then
    found = .true.
    exit
  endif
enddo

if (found) then
  if (hinterp_id(j) > 0 ) then
       result = send_data(hinterp_id(j),col_data(:,:,i),Time)
  endif
endif

  end do

   i = 1

!++lwh
do j = 1, size(phalf,2)
   do ilon=1,size(phalf,1)
      pclim = p_fact(ilon,j)*clim_type%halflevs
      if ( maxval(phalf(ilon,j,:)) > maxval(pclim) ) then
         if (verbose > 3) then
         call mpp_error(NOTE,"Interpolator: model surface pressure&
                             & is greater than climatology surface pressure for "&
                             // trim(clim_type%file_name))
         endif
         select case(clim_type%out_of_bounds(i))
            case(CONSTANT)
               pclim( maxloc(pclim) ) = maxval( phalf(ilon,j,:) )
!           case(ZERO)
!              pclim( maxloc(pclim)) = 0
         end select
      endif
      if ( minval(phalf(ilon,j,:)) < minval(pclim) ) then
         if (verbose > 3) then
         call mpp_error(NOTE,"Interpolator: model top pressure&
                             & is less than climatology top pressure for "&
                             // trim(clim_type%file_name))
         endif
         select case(clim_type%out_of_bounds(i))
            case(CONSTANT)
               pclim( minloc(pclim) ) = minval( phalf(ilon,j,:) )
!           case(ZERO)
!              pclim( maxloc(pclim)) = 0
         end select
      endif
      select case(clim_type%vert_interp(i))
         case(INTERP_WEIGHTED_P)
            call interp_weighted_scalar(pclim, phalf(ilon,j,:),hinterp_data(ilon,j,:,:),interp_data(ilon,j,:,:))
         case(INTERP_LINEAR_P)
          do n=1, size(clim_type%field_name(:))
            call interp_linear(pclim, phalf(ilon,j,:),hinterp_data(ilon,j,:,n),interp_data(ilon,j,:,n))
          end do
!        case(INTERP_LOG)
      end select
   enddo
enddo

!--lwh
     do i= 1, size(clim_type%field_name(:))

select case(clim_type%mr(i))
  case(KG_M2)
    do k = 1,size(interp_data,3)
       interp_data(:,:,k,i) = interp_data(:,:,k,i)*(phalf(:,:,k+1)-phalf(:,:,k))
    enddo
end select

     end do

if( .not. found_field) then !field name is not in interpolator file.ERROR.
  call mpp_error(FATAL,"Interpolator: the field name is not contained in this &
                   &intepolate_type: "//trim(field_name))
endif
end subroutine interpolator_4D
!
!#######################################################################
!#######################################################################
!
subroutine interpolator_3D(clim_type, Time, phalf, interp_data,field_name, is,js, clim_units)
!
! Return 3-D field interpolated to model grid and time
!
! INTENT INOUT
!   clim_type   : The interpolate type previously defined by a call to interpolator_init
!
! INTENT IN
!   field_name  : The name of the field that you wish to interpolate.
!   Time        : The model time that you wish to interpolate to.
!   phalf       : The half level model pressure field.
!   is, js      : The indices of the physics window.
!
! INTENT OUT
!   interp_data : The model field with the interpolated climatology data.
!   clim_units  : The units of field_name
!
type(interpolate_type), intent(inout)  :: clim_type
character(len=*)      , intent(in)  :: field_name
type(time_type)       , intent(in)  :: Time
real, dimension(:,:,:), intent(in)  :: phalf
real, dimension(:,:,:), intent(out) :: interp_data
integer               , intent(in) , optional :: is,js
character(len=*)      , intent(out), optional :: clim_units
integer :: taum, taup, ilon
real :: hinterp_data(size(interp_data,1),size(interp_data,2),size(clim_type%levs(:)))
real :: p_fact(size(interp_data,1),size(interp_data,2))
real :: col_data(size(interp_data,1),size(interp_data,2))
real :: pclim(size(clim_type%halflevs(:)))
integer :: istart,iend,jstart,jend
logical :: result, found
logical :: found_field=.false.
integer :: modyear, modmonth, modday, modhour, modminute, modsecond
integer :: climyear, climmonth, climday, climhour, climminute, climsecond
integer :: year1, month1, day, hour, minute, second
integer :: climatology, m
type(time_type) :: t_prev, t_next
type(time_type), dimension(2) :: month
integer :: indexm, indexp, yearm, yearp
integer :: i, j, k, n
character(len=256) :: err_msg



if (.not. module_is_initialized .or. .not. associated(clim_type%lon)) &
   call mpp_error(FATAL, "interpolator_3D : You must call interpolator_init before calling interpolator")

istart = 1
if (present(is)) istart = is
iend = istart - 1 + size(interp_data,1)

jstart = 1
if (present(js)) jstart = js
jend = jstart - 1 + size(interp_data,2)

do i= 1,size(clim_type%field_name(:))
!++lwh
  if ( field_name == clim_type%field_name(i) ) then
!--lwh
    found_field=.true.
    if(present(clim_units)) then
      call mpp_get_atts(clim_type%field_type(i),units=clim_units)
      clim_units = chomp(clim_units)
    endif

!----------------------------------------------------------------------
!   skip the time interpolation portion of this routine if subroutine
!   obtain_interpolator_time_slices has already been called on this
!   stewp for this interpolate_type variable.
!----------------------------------------------------------------------


if ( .not. clim_type%separate_time_vary_calc) then     
!   print *, 'TIME INTERPOLATION NOT SEPARATED 3d--',  &
!                                trim(clim_type%file_name), mpp_pe()
    if (clim_type%climatological_year) then
!++lwh
       if (size(clim_type%time_slice) > 1) then
          call time_interp(Time, clim_type%time_slice, clim_type%tweight, taum, taup, modtime=YEAR, err_msg=err_msg )
          if(err_msg /= '') then
             call mpp_error(FATAL,'interpolator_3D 1: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
          endif
       else
          taum = 1
          taup = 1
          clim_type%tweight = 0.
       end if
!--lwh
    else
       call time_interp(Time, clim_type%time_slice, clim_type%tweight, taum, taup, err_msg=err_msg )
       if(err_msg /= '') then
          call mpp_error(FATAL,'interpolator_3D 2: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
       endif
    endif

!   if(clim_type%TIME_FLAG .ne. LINEAR ) then
    if(clim_type%TIME_FLAG .ne. LINEAR .or. read_all_on_init ) then
      clim_type%itaum=taum
      clim_type%itaup=taup
    endif

    if(clim_type%TIME_FLAG .eq. BILINEAR ) then
      ! Check if delta-time is greater than delta of first two climatology time-slices.
      if ( (Time - clim_type%time_slice(taum) ) > ( clim_type%time_slice(2)- clim_type%time_slice(1) ) .or. &
           (clim_type%time_slice(taup)  - Time) > ( clim_type%time_slice(2)- clim_type%time_slice(1) ) ) then
      ! The difference between the model time and the last climatology time-slice previous to the model time.
      ! We need 2 time levels.
        clim_type%itaum=0
        clim_type%itaup=0
      ! Assume this is monthly data. So we need to get the data applicable to the model date but substitute 
      ! the climatology year into the appropriate place.

     
      ! We need to get the previous months data for the climatology year before 
      ! and after the model year.
        call get_date(Time, modyear, modmonth, modday, modhour, modminute, modsecond)
        call get_date(clim_type%time_slice(taum), climyear, climmonth, climday, climhour, climminute, climsecond)

        climatology = 1
        do m = 1, size(clim_type%clim_times(:,:),2)
          !Assume here that a climatology is for 1 year and consists of 12 months starting in January.
          call get_date(clim_type%clim_times(1,m), year1, month1, day, hour, minute, second)
          if (year1 == climyear) climatology = m 
        enddo
        do m = 1,12
          !Find which month we are trying to look at and set clim_date[mp] to the dates spanning that.
          call get_date(clim_type%clim_times(m,climatology), year1, month1, day, hour, minute, second)
          if ( month1 == modmonth ) then
!RSHBUGFX   if ( modday <= day ) then 
            if ( modday <  day ) then 
              indexm = m-1 ; indexp = m
            else
              indexm = m ; indexp = m+1
            endif
          endif
        
        enddo
        if ( indexm == 0 ) then 
          indexm = 12
          yearm = modyear - 1
        else
          yearm = modyear
        endif
        call get_date(clim_type%time_slice(indexm+(climatology-1)*12), &
                      climyear, climmonth, climday, climhour, climminute, climsecond)
        month(1) = set_date(yearm, indexm, climday, climhour, climminute, climsecond)
        if ( indexp == 13 ) then
          indexp = 1
          yearp = modyear + 1
        else
          yearp = modyear
        endif
        call get_date(clim_type%time_slice(indexp+(climatology-1)*12), &
                      climyear, climmonth, climday, climhour, climminute, climsecond)
        month(2) = set_date(yearp, indexp, climday, climhour, climminute, climsecond)
        
        call time_interp(Time, month, clim_type%tweight3, taum, taup, err_msg=err_msg ) ! tweight3 is the time weight between the months.
        if(err_msg /= '') then
           call mpp_error(FATAL,'interpolator_3D 3: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
        endif    

        month(1) = clim_type%time_slice(indexm+(climatology-1)*12)
        month(2) = clim_type%time_slice(indexm+climatology*12)
        call get_date(month(1), climyear, climmonth, climday, climhour, climminute, climsecond)
        t_prev = set_date(yearm, climmonth, climday, climhour, climminute, climsecond)
        call time_interp(t_prev, month, clim_type%tweight1, taum, taup, err_msg=err_msg ) !tweight1 is the time weight between the climatology years.
        if(err_msg /= '') then
           call mpp_error(FATAL,'interpolator_3D 4: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
        endif    

        month(1) = clim_type%time_slice(indexp+(climatology-1)*12)
        month(2) = clim_type%time_slice(indexp+climatology*12)
        call get_date(month(1), climyear, climmonth, climday, climhour, climminute, climsecond)
        t_next = set_date(yearp, climmonth, climday, climhour, climminute, climsecond)
        call time_interp(t_next, month, clim_type%tweight2, taum, taup, err_msg=err_msg ) !tweight1 is the time weight between the climatology years.
        if(err_msg /= '') then
           call mpp_error(FATAL,'interpolator_3D 5: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
        endif    


        if (indexm == clim_type%indexm(i) .and.  &
          indexp == clim_type%indexp(i) .and. &
          climatology == clim_type%climatology(i)) then
        else
          clim_type%indexm(i) = indexm
          clim_type%indexp(i) = indexp
          clim_type%climatology(i) = climatology
          call read_data(clim_type,clim_type%field_type(i),  &
            clim_type%pmon_pyear(:,:,:,i),  &
            clim_type%indexm(i)+(clim_type%climatology(i)-1)*12,i,Time)
! Read the data for the next month in the previous climatology.
          call read_data(clim_type,clim_type%field_type(i),  &
            clim_type%nmon_pyear(:,:,:,i),   &
            clim_type%indexp(i)+(clim_type%climatology(i)-1)*12,i,Time)
          call read_data(clim_type,clim_type%field_type(i),   &
            clim_type%pmon_nyear(:,:,:,i),  &
            clim_type%indexm(i)+clim_type%climatology(i)*12,i,Time)
          call read_data(clim_type,clim_type%field_type(i),  &
            clim_type%nmon_nyear(:,:,:,i),  &
            clim_type%indexp(i)+clim_type%climatology(i)*12,i,Time)
        endif




      else ! We are within a climatology data set
        
        if (taum /= clim_type%time_init(i,1) .or. &
            taup /= clim_type%time_init(i,2) ) then
 
          call read_data(clim_type,clim_type%field_type(i), clim_type%pmon_pyear(:,:,:,i), taum,i,Time)
! Read the data for the next month in the previous climatology.
          call read_data(clim_type,clim_type%field_type(i), clim_type%nmon_pyear(:,:,:,i), taup,i,Time)
!RSHbug   clim_type%pmon_nyear = 0.0
!RSHbug   clim_type%nmon_nyear = 0.0

!         clim_type%pmon_nyear(:,:,:,i) = 0.0
!         clim_type%nmon_nyear(:,:,:,i) = 0.0

! set to zero so when next return to bilinear section will be sure to
! have proper data (relevant when running fixed_year case for more than
! one year in a single job)
          clim_type%indexm(i) = 0       
          clim_type%indexp(i) = 0        
          clim_type%climatology(i) = 0             


          clim_type%time_init(i,1) = taum
          clim_type%time_init(i,2) = taup
        endif
!       clim_type%tweight3 = 0.0 ! This makes [pn]mon_nyear irrelevant. Set them to 0 to test.
        clim_type%tweight1 = 0.0 ; clim_type%tweight2 = 0.0
        clim_type%tweight3 = clim_type%tweight                                          
      endif

    endif ! (BILINEAR)


    if(clim_type%TIME_FLAG .eq. LINEAR  .and.   &
        (.not. read_all_on_init) ) then
! We need 2 time levels. Check we have the correct data.
      clim_type%itaum=0
      clim_type%itaup=0
      do n=1,size(clim_type%time_init,2)
        if (clim_type%time_init(i,n) .eq. taum ) clim_type%itaum = n
        if (clim_type%time_init(i,n) .eq. taup ) clim_type%itaup = n
      enddo

      if (clim_type%itaum.eq.0 .and. clim_type%itaup.eq.0) then
!Neither time is set so we need to read 2 time slices.
!Set up 
! field(:,:,:,1) as the previous time slice.
! field(:,:,:,2) as the next time slice.
    call read_data(clim_type,clim_type%field_type(i), clim_type%data(:,:,:,1,i), taum,i,Time)
          clim_type%time_init(i,1) = taum
          clim_type%itaum = 1
    call read_data(clim_type,clim_type%field_type(i), clim_type%data(:,:,:,2,i), taup,i,Time)
          clim_type%time_init(i,2) = taup
          clim_type%itaup = 2
      endif ! clim_type%itaum.eq.clim_type%itaup.eq.0
      if (clim_type%itaum.eq.0 .and. clim_type%itaup.ne.0) then
! Can't think of a situation where we would have the next time level but not the previous.
 call mpp_error(FATAL,'interpolator_3D : No data from the previous climatology time &
                         & but we have the next time. How did this happen?')
      endif
      if (clim_type%itaum.ne.0 .and. clim_type%itaup.eq.0) then
!We have the previous time step but not the next time step data
        clim_type%itaup = 1
        if (clim_type%itaum .eq. 1 ) clim_type%itaup = 2
        call read_data(clim_type,clim_type%field_type(i), clim_type%data(:,:,:,clim_type%itaup,i), taup,i, Time)
        clim_type%time_init(i,clim_type%itaup)=taup
      endif


    endif! TIME_FLAG

    endif   !( .not. clim_type%separate_time_vary_calc) 
select case(clim_type%TIME_FLAG)
  case (LINEAR)
    hinterp_data = (1-clim_type%tweight) * clim_type%data(istart:iend,jstart:jend,:,clim_type%itaum,i) + &
                       clim_type%tweight * clim_type%data(istart:iend,jstart:jend,:,clim_type%itaup,i)
! case (SEASONAL)
! Do sine fit to data at this point
  case (BILINEAR)
    hinterp_data = &
    (1-clim_type%tweight1)  * (1-clim_type%tweight3) * clim_type%pmon_pyear(istart:iend,jstart:jend,:,i) + &
    (1-clim_type%tweight2)  *    clim_type%tweight3  * clim_type%nmon_pyear(istart:iend,jstart:jend,:,i) + &
         clim_type%tweight1 * (1-clim_type%tweight3) * clim_type%pmon_nyear(istart:iend,jstart:jend,:,i) + &
         clim_type%tweight2 *     clim_type%tweight3 * clim_type%nmon_nyear(istart:iend,jstart:jend,:,i)
    


end select

select case(clim_type%level_type)
  case(PRESSURE)
    p_fact = 1.0
  case(SIGMA)
    p_fact = maxval(phalf,3)! max pressure in the column !(:,:,size(phalf,3))
end select

col_data(:,:)=0.0
select case(clim_type%mr(i))
  case(NO_CONV)
    do k = 1,size(hinterp_data,3)
   col_data(:,:) = col_data(:,:) + hinterp_data(:,:,k)* &
      (clim_type%halflevs(k+1)-clim_type%halflevs(k))/grav
    enddo
    
  case(KG_M2)
    do k = 1,size(hinterp_data,3)
       col_data(:,:) = col_data(:,:) + hinterp_data(:,:,k)
       hinterp_data(:,:,k) = hinterp_data(:,:,k)/ &
         ((clim_type%halflevs(k+1)-clim_type%halflevs(k))*p_fact)
    enddo
end select

found = .false.
do j = 1,size(climo_diag_name(:))
  if (climo_diag_name(j) .eq. clim_type%field_name(i)) then
    found = .true.
    exit
  endif
enddo

if (found) then
  if (hinterp_id(j) > 0 ) then
       result = send_data(hinterp_id(j),col_data,Time)
  endif
endif


!++lwh
do j = 1, size(phalf,2)
   do ilon=1,size(phalf,1)
      pclim = p_fact(ilon,j)*clim_type%halflevs
      if ( maxval(phalf(ilon,j,:)) > maxval(pclim) ) then
         if (verbose > 3) then
         call mpp_error(NOTE,"Interpolator: model surface pressure&
                             & is greater than climatology surface pressure for "&
                             // trim(clim_type%file_name))
         endif
         select case(clim_type%out_of_bounds(i))
            case(CONSTANT)
               pclim( maxloc(pclim) ) = maxval( phalf(ilon,j,:) )
!           case(ZERO)
!              pclim( maxloc(pclim)) = 0
         end select
      endif
      if ( minval(phalf(ilon,j,:)) < minval(pclim) ) then
         if (verbose > 3) then
         call mpp_error(NOTE,"Interpolator: model top pressure&
                             & is less than climatology top pressure for "&
                             // trim(clim_type%file_name))
         endif
         select case(clim_type%out_of_bounds(i))
            case(CONSTANT)
               pclim( minloc(pclim) ) = minval( phalf(ilon,j,:) )
!           case(ZERO)
!              pclim( maxloc(pclim)) = 0
         end select
      endif
      select case(clim_type%vert_interp(i))
         case(INTERP_WEIGHTED_P)
            call interp_weighted_scalar(pclim, phalf(ilon,j,:),hinterp_data(ilon,j,:),interp_data(ilon,j,:))
         case(INTERP_LINEAR_P)
            call interp_linear(pclim, phalf(ilon,j,:),hinterp_data(ilon,j,:),interp_data(ilon,j,:))
!        case(INTERP_LOG)
      end select
   enddo
enddo

!--lwh

select case(clim_type%mr(i))
  case(KG_M2)
    do k = 1,size(interp_data,3)
       interp_data(:,:,k) = interp_data(:,:,k)*(phalf(:,:,k+1)-phalf(:,:,k))
    enddo
end select

  endif !field_name
enddo !End of i loop
if( .not. found_field) then !field name is not in interpolator file.ERROR.
  call mpp_error(FATAL,"Interpolator: the field name is not contained in this &
                   &intepolate_type: "//trim(field_name))
endif
end subroutine interpolator_3D
!
!#######################################################################
!
!++lwh
subroutine interpolator_2D(clim_type, Time, interp_data, field_name, is, js, clim_units)
!
! Return 2-D field interpolated to model grid and time
!
!
! INTENT INOUT
!   clim_type   : The interpolate type previously defined by a call to interpolator_init
!
! INTENT IN
!   field_name  : The name of the field that you wish to interpolate.
!   Time        : The model time that you wish to interpolate to.
!   is, js      : The indices of the physics window.
!
! INTENT OUT
!   interp_data : The model field with the interpolated climatology data.
!   clim_units  : The units of field_name
!
type(interpolate_type), intent(inout)  :: clim_type
character(len=*)      , intent(in)     :: field_name
type(time_type)       , intent(in)     :: Time
real, dimension(:,:),   intent(out)    :: interp_data
integer               , intent(in) , optional :: is,js
character(len=*)      , intent(out), optional :: clim_units
integer :: taum, taup
real :: hinterp_data(size(interp_data,1),size(interp_data,2),size(clim_type%levs(:)))
integer :: istart,iend,jstart,jend
logical :: result, found
logical :: found_field=.false.
integer :: modyear, modmonth, modday, modhour, modminute, modsecond
integer :: climyear, climmonth, climday, climhour, climminute, climsecond
integer :: year1, month1, day, hour, minute, second
integer :: climatology, m
type(time_type) :: t_prev, t_next
type(time_type), dimension(2) :: month
integer :: indexm, indexp, yearm, yearp
integer :: j, i, n
character(len=256) :: err_msg

if (.not. module_is_initialized .or. .not. associated(clim_type%lon)) &
   call mpp_error(FATAL, "interpolator_2D : You must call interpolator_init before calling interpolator")

istart = 1
if (present(is)) istart = is
iend = istart - 1 + size(interp_data,1)

jstart = 1
if (present(js)) jstart = js
jend = jstart - 1 + size(interp_data,2)

do i= 1,size(clim_type%field_name(:))
!++lwh
  if ( field_name == clim_type%field_name(i) ) then
!--lwh

    found_field=.true.

    if(present(clim_units)) then
      call mpp_get_atts(clim_type%field_type(i),units=clim_units)
      clim_units = chomp(clim_units)
    endif


!----------------------------------------------------------------------
!   skip the time interpolation portion of this routine if subroutine
!   obtain_interpolator_time_slices has already been called on this
!   stewp for this interpolate_type variable.
!----------------------------------------------------------------------

if ( .not. clim_type%separate_time_vary_calc) then     
!   print *, 'TIME INTERPOLATION NOT SEPARATED 2d--',  &
!                                   trim(clim_type%file_name), mpp_pe()
    if (clim_type%climatological_year) then
!++lwh
       if (size(clim_type%time_slice) > 1) then
          call time_interp(Time, clim_type%time_slice, clim_type%tweight, taum, taup, modtime=YEAR, err_msg=err_msg )
          if(err_msg /= '') then
             call mpp_error(FATAL,'interpolator_2D 1: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
          endif
       else
          taum = 1
          taup = 1
          clim_type%tweight = 0.
       end if
!--lwh
    else
       call time_interp(Time, clim_type%time_slice, clim_type%tweight, taum, taup, err_msg=err_msg )
       if(err_msg /= '') then
          call mpp_error(FATAL,'interpolator_2D 2: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
       endif
    endif

! If the climatology file has seasonal, a split time-line or has all the data 
! read in then enter this loop.
! 
    if(clim_type%TIME_FLAG .ne. LINEAR .or. read_all_on_init) then
      clim_type%itaum=taum
      clim_type%itaup=taup
    endif

!    if(clim_type%TIME_FLAG .eq. BILINEAR ) then
!      ! Check if delta-time is greater than delta of first two climatology time-slices.
!      if ( (Time - clim_type%time_slice(taum) ) > ( clim_type%time_slice(2)- clim_type%time_slice(1) ) .or. &
!           (clim_type%time_slice(taup)  - Time) > ( clim_type%time_slice(2)- clim_type%time_slice(1) ) ) then
!      ! The difference between the model time and the last climatology time-slice previous to the model time.
!      ! We need 2 time levels. Check we have the correct data.
!        itaum=0
!        itaup=0
!      ! Assume this is monthly data. So we need to get the data applicable to the model date but substitute 
!      ! the climatology year into the appropriate place.
!      
!        call get_date(Time, modyear, modmonth, modday, modhour, modminute, modsecond)
!        call get_date(clim_type%time_slice(taum), climyear, climmonth, climday, climhour, climminute, climsecond)
!        clim_datem = set_date(climyear, modmonth, modday, modhour, modminute, modsecond)
!        call time_interp(clim_datem, clim_type%time_slice, tweight1, taum1, taup1 )
!
!
!        call get_date(clim_type%time_slice(taup), climyear, climmonth, climday, climhour, climminute, climsecond)
!        clim_datep = set_date(climyear, modmonth, modday, modhour, modminute, modsecond)
!
!
!      endif
!
!    endif
    if(clim_type%TIME_FLAG .eq. BILINEAR ) then
      ! Check if delta-time is greater than delta of first two climatology time-slices.
      if ( (Time - clim_type%time_slice(taum) ) > ( clim_type%time_slice(2)- clim_type%time_slice(1) ) .or. &
           (clim_type%time_slice(taup)  - Time) > ( clim_type%time_slice(2)- clim_type%time_slice(1) ) ) then
      ! The difference between the model time and the last climatology time-slice previous to the model time.
      ! We need 2 time levels.
        clim_type%itaum=0
        clim_type%itaup=0
      ! Assume this is monthly data. So we need to get the data applicable to the model date but substitute 
      ! the climatology year into the appropriate place.

     
      ! We need to get the previous months data for the climatology year before 
      ! and after the model year.
        call get_date(Time, modyear, modmonth, modday, modhour, modminute, modsecond)
        call get_date(clim_type%time_slice(taum), climyear, climmonth, climday, climhour, climminute, climsecond)

        climatology = 1
        do m = 1, size(clim_type%clim_times(:,:),2)
          !Assume here that a climatology is for 1 year and consists of 12 months starting in January.
          call get_date(clim_type%clim_times(1,m), year1, month1, day, hour, minute, second)
          if (year1 == climyear) climatology = m 
        enddo
        do m = 1,12
          !Find which month we are trying to look at and set clim_date[mp] to the dates spanning that.
          call get_date(clim_type%clim_times(m,climatology), year1, month1, day, hour, minute, second)
          if ( month1 == modmonth ) then
!RSHBUGFX   if ( modday <= day ) then 
            if ( modday <  day ) then 
              indexm = m-1 ; indexp = m
            else
              indexm = m ; indexp = m+1
            endif
          endif
        
        enddo
        if ( indexm == 0 ) then 
          indexm = 12
          yearm = modyear - 1
        else
          yearm = modyear
        endif
        call get_date(clim_type%time_slice(indexm+(climatology-1)*12), &
                      climyear, climmonth, climday, climhour, climminute, climsecond)
        month(1) = set_date(yearm, indexm, climday, climhour, climminute, climsecond)
        if ( indexp == 13 ) then
          indexp = 1
          yearp = modyear + 1
        else
          yearp = modyear
        endif
        call get_date(clim_type%time_slice(indexp+(climatology-1)*12), &
                      climyear, climmonth, climday, climhour, climminute, climsecond)
        month(2) = set_date(yearp, indexp, climday, climhour, climminute, climsecond)
        
        call time_interp(Time, month, clim_type%tweight3, taum, taup, err_msg=err_msg ) ! tweight3 is the time weight between the months.
        if(err_msg /= '') then
           call mpp_error(FATAL,'interpolator_2D 3: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
        endif    

        month(1) = clim_type%time_slice(indexm+(climatology-1)*12)
        month(2) = clim_type%time_slice(indexm+climatology*12)
        call get_date(month(1), climyear, climmonth, climday, climhour, climminute, climsecond)
        t_prev = set_date(yearm, climmonth, climday, climhour, climminute, climsecond)
        call time_interp(t_prev, month, clim_type%tweight1, taum, taup, err_msg=err_msg ) !tweight1 is the time weight between the climatology years.
        if(err_msg /= '') then
           call mpp_error(FATAL,'interpolator_2D 4: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
        endif    

        month(1) = clim_type%time_slice(indexp+(climatology-1)*12)
        month(2) = clim_type%time_slice(indexp+climatology*12)
        call get_date(month(1), climyear, climmonth, climday, climhour, climminute, climsecond)
        t_next = set_date(yearp, climmonth, climday, climhour, climminute, climsecond)
        call time_interp(t_next, month, clim_type%tweight2, taum, taup, err_msg=err_msg ) !tweight1 is the time weight between the climatology years.
        if(err_msg /= '') then
           call mpp_error(FATAL,'interpolator_2D 5: '//trim(err_msg)//' file='//trim(clim_type%file_name), FATAL)
        endif    


        if (indexm == clim_type%indexm(i) .and.  &
          indexp == clim_type%indexp(i) .and. &
          climatology == clim_type%climatology(i)) then
        else
          clim_type%indexm(i) = indexm
          clim_type%indexp(i) = indexp
          clim_type%climatology(i) = climatology
          call read_data(clim_type,clim_type%field_type(i),  &
            clim_type%pmon_pyear(:,:,:,i),  &
            clim_type%indexm(i)+(clim_type%climatology(i)-1)*12,i,Time)
! Read the data for the next month in the previous climatology.
          call read_data(clim_type,clim_type%field_type(i),  &
            clim_type%nmon_pyear(:,:,:,i),   &
            clim_type%indexp(i)+(clim_type%climatology(i)-1)*12,i,Time)
          call read_data(clim_type,clim_type%field_type(i),   &
            clim_type%pmon_nyear(:,:,:,i),  &
            clim_type%indexm(i)+clim_type%climatology(i)*12,i,Time)
          call read_data(clim_type,clim_type%field_type(i),  &
            clim_type%nmon_nyear(:,:,:,i),  &
            clim_type%indexp(i)+clim_type%climatology(i)*12,i,Time)
        endif




      else ! We are within a climatology data set
        
        if (taum /= clim_type%time_init(i,1) .or. &
            taup /= clim_type%time_init(i,2) ) then
 
          call read_data(clim_type,clim_type%field_type(i), clim_type%pmon_pyear(:,:,:,i), taum,i,Time)
! Read the data for the next month in the previous climatology.
          call read_data(clim_type,clim_type%field_type(i), clim_type%nmon_pyear(:,:,:,i), taup,i,Time)
!RSHbug   clim_type%pmon_nyear = 0.0
!RSHbug   clim_type%nmon_nyear = 0.0

!         clim_type%pmon_nyear(:,:,:,i) = 0.0
!         clim_type%nmon_nyear(:,:,:,i) = 0.0

! set to zero so when next return to bilinear section will be sure to
! have proper data (relevant when running fixed_year case for more than
! one year in a single job)
          clim_type%indexm(i) = 0       
          clim_type%indexp(i) = 0        
          clim_type%climatology(i) = 0             


          clim_type%time_init(i,1) = taum
          clim_type%time_init(i,2) = taup
        endif
!       clim_type%tweight3 = 0.0 ! This makes [pn]mon_nyear irrelevant. Set them to 0 to test.
        clim_type%tweight1 = 0.0 ; clim_type%tweight2 = 0.0
        clim_type%tweight3 = clim_type%tweight                                          
      endif

    endif ! (BILINEAR)

    if(clim_type%TIME_FLAG .eq. LINEAR .and. &
        (.not. read_all_on_init) ) then
! We need 2 time levels. Check we have the correct data.
      clim_type%itaum=0
      clim_type%itaup=0
      do n=1,size(clim_type%time_init,2)
        if (clim_type%time_init(i,n) .eq. taum ) clim_type%itaum = n
        if (clim_type%time_init(i,n) .eq. taup ) clim_type%itaup = n
      enddo

      if (clim_type%itaum.eq.0 .and. clim_type%itaup.eq.0) then
      !Neither time is set so we need to read 2 time slices.
      !Set up 
      ! field(:,:,:,1) as the previous time slice.
      ! field(:,:,:,2) as the next time slice.
        call read_data(clim_type,clim_type%field_type(i), clim_type%data(:,:,:,1,i), taum,i,Time)
          clim_type%time_init(i,1) = taum
          clim_type%itaum = 1
        call read_data(clim_type,clim_type%field_type(i), clim_type%data(:,:,:,2,i), taup,i,Time)
          clim_type%time_init(i,2) = taup
          clim_type%itaup = 2
      endif ! clim_type%itaum.eq.clim_type%itaup.eq.0
      if (clim_type%itaum.eq.0 .and. clim_type%itaup.ne.0) then
      ! Can't think of a situation where we would have the next time level but not the previous.
        call mpp_error(FATAL,'interpolator_2D : No data from the previous climatology time but we have&
                            & the next time. How did this happen?')
      endif
      if (clim_type%itaum.ne.0 .and. clim_type%itaup.eq.0) then
      !We have the previous time step but not the next time step data
        clim_type%itaup = 1
        if (clim_type%itaum .eq. 1 ) clim_type%itaup = 2
        call read_data(clim_type,clim_type%field_type(i), clim_type%data(:,:,:,clim_type%itaup,i), taup,i, Time)
        clim_type%time_init(i,clim_type%itaup)=taup
      endif
    endif! TIME_FLAG .eq. LINEAR .and. (.not. read_all_on_init)

  endif ! (.not. separate_time_vary_calc)



select case(clim_type%TIME_FLAG)
  case (LINEAR)
    hinterp_data = (1-clim_type%tweight)*clim_type%data(istart:iend,jstart:jend,:,clim_type%itaum,i) &
                     + clim_type%tweight*clim_type%data(istart:iend,jstart:jend,:,clim_type%itaup,i)
! case (SEASONAL)
! Do sine fit to data at this point
  case (BILINEAR)
    hinterp_data = &
    (1-clim_type%tweight1)  * (1-clim_type%tweight3) * clim_type%pmon_pyear(istart:iend,jstart:jend,:,i) + &
    (1-clim_type%tweight2)  *    clim_type%tweight3  * clim_type%nmon_pyear(istart:iend,jstart:jend,:,i) + &
         clim_type%tweight1 * (1-clim_type%tweight3) * clim_type%pmon_nyear(istart:iend,jstart:jend,:,i) + &
         clim_type%tweight2 *     clim_type%tweight3 * clim_type%nmon_nyear(istart:iend,jstart:jend,:,i)

end select

found = .false.
do j = 1,size(climo_diag_name(:))
  if (climo_diag_name(j) .eq. clim_type%field_name(i)) then
    found = .true.
    exit
  endif
enddo

if (found) then
  if (hinterp_id(j) > 0 ) then
       result = send_data(hinterp_id(j),hinterp_data,Time)
  endif
endif

  interp_data(:,:) = hinterp_data(:,:,1)

  endif !field_name
enddo !End of i loop

if( .not. found_field) then !field name is not in interpolator file.ERROR.
  call mpp_error(FATAL,"Interpolator: the field name is not contained in this &
                   &intepolate_type: "//trim(field_name))
endif
end subroutine interpolator_2D
!--lwh
!
!#######################################################################

subroutine interpolator_4D_no_time_axis(clim_type, phalf, interp_data, field_name, is,js, clim_units)

! Return 4-D field interpolated to model grid

! INTENT INOUT
!   clim_type   : The interpolate type previously defined by a call to interpolator_init

! INTENT IN
!   field_name  : The name of a field that you wish to interpolate.
!                 all variables within this interpolate_type variable
!                 will be interpolated on this call. field_name may
!                 be any one of the variables.
!   phalf       : The half level model pressure field.
!   is, js      : The indices of the physics window.

! INTENT OUT
!   interp_data : The model fields
!   clim_units  : The units of field_name

type(interpolate_type), intent(inout)  :: clim_type
character(len=*)      , intent(in)  :: field_name
real, dimension(:,:,:), intent(in)  :: phalf
real, dimension(:,:,:,:), intent(out) :: interp_data
integer               , intent(in) , optional :: is,js
character(len=*)      , intent(out), optional :: clim_units
integer :: ilon
real :: hinterp_data(size(interp_data,1),size(interp_data,2),size(clim_type%levs(:)),size(clim_type%field_name(:)))
real :: p_fact(size(interp_data,1),size(interp_data,2))
real :: pclim(size(clim_type%halflevs(:)))
integer :: istart,iend,jstart,jend
logical :: result
logical :: found_field=.false.
integer :: i, j, k, n

if (.not. module_is_initialized .or. .not. associated(clim_type%lon)) &
   call mpp_error(FATAL, "interpolator_4D_no_time_axis : You must call interpolator_init before calling interpolator")

do n=2,size(clim_type%field_name(:))
  if (clim_type%vert_interp(n) /= clim_type%vert_interp(n-1) .or. &
   clim_type%out_of_bounds(n) /= clim_type%out_of_bounds(n-1)) then
    if (mpp_pe() == mpp_root_pe() ) then
      print *, 'processing file ' // trim(clim_type%file_name)
    endif
    call mpp_error (FATAL, 'interpolator_mod: &
            &cannot use 4D interface to interpolator for this file')
  endif
end do

istart = 1
if (present(is)) istart = is
iend = istart - 1 + size(interp_data,1)

jstart = 1
if (present(js)) jstart = js
jend = jstart - 1 + size(interp_data,2)

do i= 1,size(clim_type%field_name(:))
  if ( field_name == clim_type%field_name(i) ) then
    found_field=.true.
    exit 
  endif
end do
i = 1

if(present(clim_units)) then
  call mpp_get_atts(clim_type%field_type(i),units=clim_units)
  clim_units = chomp(clim_units)
endif

do n=1, size(clim_type%field_name(:))
  hinterp_data(:,:,:,n) = clim_type%data(istart:iend,jstart:jend,:,1,n)
end do
    
select case(clim_type%level_type)
  case(PRESSURE)
    p_fact = 1.0
  case(SIGMA)
    p_fact = maxval(phalf,3)! max pressure in the column !(:,:,size(phalf,3))
end select

    do i= 1, size(clim_type%field_name(:))
      select case(clim_type%mr(i))
      case(KG_M2)
        do k = 1,size(hinterp_data,3)
          hinterp_data(:,:,k,i) = hinterp_data(:,:,k,i)/((clim_type%halflevs(k+1)-clim_type%halflevs(k))*p_fact)
        enddo
      end select
    enddo

   i = 1

do j = 1, size(phalf,2)
   do ilon=1,size(phalf,1)
      pclim = p_fact(ilon,j)*clim_type%halflevs
      if ( maxval(phalf(ilon,j,:)) > maxval(pclim) ) then
         if (verbose > 3) then
         call mpp_error(NOTE,"Interpolator: model surface pressure&
                             & is greater than surface pressure of input data for "&
                             // trim(clim_type%file_name))
         endif
         select case(clim_type%out_of_bounds(i))
            case(CONSTANT)
               pclim( maxloc(pclim) ) = maxval( phalf(ilon,j,:) )
         end select
      endif
      if ( minval(phalf(ilon,j,:)) < minval(pclim) ) then
         if (verbose > 3) then
         call mpp_error(NOTE,"Interpolator: model top pressure&
                             & is less than top pressure of input data for "&
                             // trim(clim_type%file_name))
         endif
         select case(clim_type%out_of_bounds(i))
            case(CONSTANT)
               pclim( minloc(pclim) ) = minval( phalf(ilon,j,:) )
         end select
      endif
      select case(clim_type%vert_interp(i))
         case(INTERP_WEIGHTED_P)
            call interp_weighted_scalar(pclim, phalf(ilon,j,:),hinterp_data(ilon,j,:,:),interp_data(ilon,j,:,:))
         case(INTERP_LINEAR_P)
          do n=1, size(clim_type%field_name(:))
            call interp_linear(pclim, phalf(ilon,j,:),hinterp_data(ilon,j,:,n),interp_data(ilon,j,:,n))
          end do
      end select
   enddo
enddo

     do i= 1, size(clim_type%field_name(:))

select case(clim_type%mr(i))
  case(KG_M2)
    do k = 1,size(interp_data,3)
       interp_data(:,:,k,i) = interp_data(:,:,k,i)*(phalf(:,:,k+1)-phalf(:,:,k))
    enddo
end select

     end do

if( .not. found_field) then !field name is not in interpolator file.ERROR.
  call mpp_error(FATAL,"Interpolator: the field name is not contained in this &
                   &intepolate_type: "//trim(field_name))
endif
end subroutine interpolator_4D_no_time_axis

!#######################################################################

subroutine interpolator_3D_no_time_axis(clim_type, phalf, interp_data, field_name, is,js, clim_units)

! Return 3-D field interpolated to model grid

! INTENT INOUT
!   clim_type   : The interpolate type previously defined by a call to interpolator_init

! INTENT IN
!   field_name  : The name of the field that you wish to interpolate.
!   phalf       : The half level model pressure field.
!   is, js      : The indices of the physics window.

! INTENT OUT
!   interp_data : The model field with the interpolated climatology data.
!   clim_units  : The units of field_name

type(interpolate_type), intent(inout)  :: clim_type
character(len=*)      , intent(in)  :: field_name
real, dimension(:,:,:), intent(in)  :: phalf
real, dimension(:,:,:), intent(out) :: interp_data
integer               , intent(in) , optional :: is,js
character(len=*)      , intent(out), optional :: clim_units
real :: tweight, tweight1, tweight2, tweight3
integer :: taum, taup, ilon
real :: hinterp_data(size(interp_data,1),size(interp_data,2),size(clim_type%levs(:)))
real :: p_fact(size(interp_data,1),size(interp_data,2))
real :: pclim(size(clim_type%halflevs(:)))
integer :: istart,iend,jstart,jend
logical :: result
logical :: found_field=.false.
integer :: i, j, k, n

if (.not. module_is_initialized .or. .not. associated(clim_type%lon)) &
   call mpp_error(FATAL, "interpolator_3D_no_time_axis : You must call interpolator_init before calling interpolator")

istart = 1
if (present(is)) istart = is
iend = istart - 1 + size(interp_data,1)

jstart = 1
if (present(js)) jstart = js
jend = jstart - 1 + size(interp_data,2)

do i= 1,size(clim_type%field_name(:))
  if ( field_name == clim_type%field_name(i) ) then
    found_field=.true.
    if(present(clim_units)) then
      call mpp_get_atts(clim_type%field_type(i),units=clim_units)
      clim_units = chomp(clim_units)
    endif

    hinterp_data = clim_type%data(istart:iend,jstart:jend,:,1,i)

select case(clim_type%level_type)
  case(PRESSURE)
    p_fact = 1.0
  case(SIGMA)
    p_fact = maxval(phalf,3)! max pressure in the column !(:,:,size(phalf,3))
end select

select case(clim_type%mr(i))
  case(KG_M2)
    do k = 1,size(hinterp_data,3)
       hinterp_data(:,:,k) = hinterp_data(:,:,k)/((clim_type%halflevs(k+1)-clim_type%halflevs(k))*p_fact)
    enddo
end select

do j = 1, size(phalf,2)
   do ilon=1,size(phalf,1)
      pclim = p_fact(ilon,j)*clim_type%halflevs
      if ( maxval(phalf(ilon,j,:)) > maxval(pclim) ) then
         if (verbose > 3) then
         call mpp_error(NOTE,"Interpolator: model surface pressure&
                             & is greater than climatology surface pressure for "&
                             // trim(clim_type%file_name))
         endif
         select case(clim_type%out_of_bounds(i))
            case(CONSTANT)
               pclim( maxloc(pclim) ) = maxval( phalf(ilon,j,:) )
         end select
      endif
      if ( minval(phalf(ilon,j,:)) < minval(pclim) ) then
         if (verbose > 3) then
         call mpp_error(NOTE,"Interpolator: model top pressure&
                             & is less than climatology top pressure for "&
                             // trim(clim_type%file_name))
         endif
         select case(clim_type%out_of_bounds(i))
            case(CONSTANT)
               pclim( minloc(pclim) ) = minval( phalf(ilon,j,:) )
         end select
      endif
      select case(clim_type%vert_interp(i))
         case(INTERP_WEIGHTED_P)
            call interp_weighted_scalar(pclim, phalf(ilon,j,:),hinterp_data(ilon,j,:),interp_data(ilon,j,:))
         case(INTERP_LINEAR_P)
            call interp_linear(pclim, phalf(ilon,j,:),hinterp_data(ilon,j,:),interp_data(ilon,j,:))
      end select
   enddo
enddo

select case(clim_type%mr(i))
  case(KG_M2)
    do k = 1,size(interp_data,3)
       interp_data(:,:,k) = interp_data(:,:,k)*(phalf(:,:,k+1)-phalf(:,:,k))
    enddo
end select

  endif !field_name
enddo !End of i loop
if( .not. found_field) then !field name is not in interpolator file.ERROR.
  call mpp_error(FATAL,"Interpolator: the field name is not contained in this &
                   &intepolate_type: "//trim(field_name))
endif
end subroutine interpolator_3D_no_time_axis

!#######################################################################

subroutine interpolator_2D_no_time_axis(clim_type, interp_data, field_name, is, js, clim_units)

! Return 2-D field interpolated to model grid

! INTENT INOUT
!   clim_type   : The interpolate type previously defined by a call to interpolator_init

! INTENT IN
!   field_name  : The name of the field that you wish to interpolate.
!   is, js      : The indices of the physics window.

! INTENT OUT
!   interp_data : The model field with the interpolated climatology data.
!   clim_units  : The units of field_name

type(interpolate_type), intent(inout)  :: clim_type
character(len=*)      , intent(in)     :: field_name
real, dimension(:,:),   intent(out)    :: interp_data
integer               , intent(in) , optional :: is,js
character(len=*)      , intent(out), optional :: clim_units
real :: tweight, tweight1, tweight2, tweight3
integer :: taum, taup, ilon
real :: hinterp_data(size(interp_data,1),size(interp_data,2),size(clim_type%levs(:)))
real :: p_fact(size(interp_data,1),size(interp_data,2))
integer :: istart,iend,jstart,jend
logical :: result
logical :: found_field=.false.
integer :: j, k, i, n

if (.not. module_is_initialized .or. .not. associated(clim_type%lon)) &
   call mpp_error(FATAL, "interpolator_2D_no_time_axis : You must call interpolator_init before calling interpolator")

istart = 1
if (present(is)) istart = is
iend = istart - 1 + size(interp_data,1)

jstart = 1
if (present(js)) jstart = js
jend = jstart - 1 + size(interp_data,2)

do i= 1,size(clim_type%field_name(:))
  if ( field_name == clim_type%field_name(i) ) then

    found_field=.true.

    if(present(clim_units)) then
      call mpp_get_atts(clim_type%field_type(i),units=clim_units)
      clim_units = chomp(clim_units)
    endif

    hinterp_data = clim_type%data(istart:iend,jstart:jend,:,1,i)

    interp_data(:,:) = hinterp_data(:,:,1)

  endif !field_name
enddo !End of i loop

if( .not. found_field) then !field name is not in interpolator file.ERROR.
  call mpp_error(FATAL,"Interpolator: the field name is not contained in this &
                   &intepolate_type: "//trim(field_name))
endif

end subroutine interpolator_2D_no_time_axis

!#######################################################################
!
subroutine interpolator_end(clim_type)
! Subroutine to deallocate the interpolate type clim_type.
!
! INTENT INOUT
!  clim_type : allocate type whose components will be deallocated.
!
type(interpolate_type), intent(inout) :: clim_type
integer :: logunit

logunit=stdlog()
if ( mpp_pe() == mpp_root_pe() ) then
   write (logunit,'(/,(a))') 'Exiting interpolator, have a nice day ...'
end if

if (associated (clim_type%lat     )) deallocate(clim_type%lat)
if (associated (clim_type%lon     )) deallocate(clim_type%lon)
if (associated (clim_type%latb    )) deallocate(clim_type%latb)
if (associated (clim_type%lonb    )) deallocate(clim_type%lonb)
if (associated (clim_type%levs    )) deallocate(clim_type%levs)
if (associated (clim_type%halflevs)) deallocate(clim_type%halflevs) 
call horiz_interp_del(clim_type%interph)
if (associated (clim_type%time_slice)) deallocate(clim_type%time_slice)
if (associated (clim_type%field_type)) deallocate(clim_type%field_type)
if (associated (clim_type%field_name)) deallocate(clim_type%field_name)
if (associated (clim_type%time_init )) deallocate(clim_type%time_init)
if (associated (clim_type%mr        )) deallocate(clim_type%mr)
if (associated (clim_type%data)) then
  deallocate(clim_type%data)
endif
if (associated (clim_type%pmon_pyear)) then
  deallocate(clim_type%pmon_pyear)
  deallocate(clim_type%pmon_nyear)
  deallocate(clim_type%nmon_nyear)
  deallocate(clim_type%nmon_pyear)
endif

!! RSH mod   
if(  .not. (clim_type%TIME_FLAG .eq. LINEAR  .and.    &
!     read_all_on_init)) .or. clim_type%TIME_FLAG .eq. BILINEAR  ) then
      read_all_on_init)  ) then
 call mpp_close(clim_type%unit)
endif


module_is_initialized = .false.

end subroutine interpolator_end
!
!#######################################################################
!
subroutine read_data(clim_type,src_field, hdata, nt,i, Time)
!
!  INTENT IN
!    clim_type : The interpolate type which contains the data 
!    src_field : The field type 
!    nt        : The index of the time slice of the climatology that you wish to read.
!    i         : The index of the field name that you are trying to read. (optional)
!    Time      : The model time. Used for diagnostic purposes only. (optional)
!
!  INTENT OUT
!
!    hdata     : The horizontally interpolated climatology field. This 
!                field will still be on the climatology vertical grid.
!
type(interpolate_type)   , intent(in)  :: clim_type
type(fieldtype)          , intent(in)  :: src_field
integer                  , intent(in)  :: nt
real                     , intent(out) :: hdata(:,:,:)
integer        , optional, intent(in)  :: i
type(time_type), optional, intent(in)  :: Time

integer   :: k, km
! sjs
real, allocatable :: climdata(:,:,:), climdata2(:,:,:)

      allocate(climdata(size(clim_type%lon(:)),size(clim_type%lat(:)), &
                        size(clim_type%levs(:))))

      call mpp_read(clim_type%unit,src_field, climdata,nt)

!  if vertical index increases upward, flip the data so that lowest
!  pressure level data is at index 1, rather than the highest pressure
!  level data. the indices themselves were previously flipped.
      if (clim_type%vertical_indices == INCREASING_UPWARD) then
        allocate(climdata2(size(clim_type%lon(:)),   &
                           size(clim_type%lat(:)), &
                           size(clim_type%levs(:))))
        km = size(clim_type%levs(:))
        do k=1, km                      
          climdata2(:,:,k) = climdata(:,:,km+1-k)
        end do
        climdata = climdata2
        deallocate (climdata2)
      endif

      call horiz_interp(clim_type%interph, climdata, hdata)
      if (clim_diag_initialized) &
        call diag_read_data(clim_type,climdata,i, Time)
      deallocate(climdata)


end subroutine read_data

!#######################################################################

subroutine read_data_no_time_axis(clim_type,src_field, hdata, i)

!  INTENT IN
!    clim_type : The interpolate type which contains the data 
!    src_field : The field type 
!    i         : The index of the field name that you are trying to read. (optional)

!  INTENT OUT

!    hdata     : The horizontally interpolated climatology field. This 
!                field will still be on the climatology vertical grid.

type(interpolate_type)   , intent(in)  :: clim_type
type(fieldtype)          , intent(in)  :: src_field
real                     , intent(out) :: hdata(:,:,:)
integer        , optional, intent(in)  :: i

integer   :: k, km
! sjs
real, allocatable :: climdata(:,:,:), climdata2(:,:,:)

      allocate(climdata(size(clim_type%lon(:)),size(clim_type%lat(:)), size(clim_type%levs(:))))

      call mpp_read(clim_type%unit,src_field, climdata)

!  if vertical index increases upward, flip the data so that lowest
!  pressure level data is at index 1, rather than the highest pressure
!  level data. the indices themselves were previously flipped.
      if (clim_type%vertical_indices == INCREASING_UPWARD) then
        allocate(climdata2(size(clim_type%lon(:)),   &
                           size(clim_type%lat(:)), &
                           size(clim_type%levs(:))))
        km = size(clim_type%levs(:))
        do k=1, km                      
          climdata2(:,:,k) = climdata(:,:,km+1-k)
        end do
        climdata = climdata2
        deallocate (climdata2)
      endif

      call horiz_interp(clim_type%interph, climdata, hdata)
      deallocate(climdata)

end subroutine read_data_no_time_axis

!#######################################################################
!
subroutine diag_read_data(clim_type,model_data, i, Time)
!
! A routine to diagnose the data read in by read_data
!
!  INTENT IN
!    clim_type  : The interpolate type.
!    model_data : The data read in from file that is being diagnosed.
!    i          : The index of the field name that you are diagnosing.
!    Time       : The model time
!
type(interpolate_type), intent(in) :: clim_type
real                  , intent(in) :: model_data(:,:,:)
integer               , intent(in) :: i
type(time_type)       , intent(in) :: Time

integer :: j,k
real :: col_data(size(model_data,1),size(model_data,2))
logical :: result, found


found = .false.
do j = 1,size(climo_diag_name(:))
  if (climo_diag_name(j) .eq. clim_type%field_name(i)) then
      found = .true.
      exit
  endif
enddo

if(found) then
  if(climo_diag_id(j)>0) then
  col_data(:,:)=0.0
    do k=1,size(model_data,3)
      col_data(:,:) = col_data(:,:) + &
        model_data(:,:,k)* &
        (clim_type%halflevs(k+1)-clim_type%halflevs(k))/grav
    enddo
    result = send_data(climo_diag_id(j),col_data(clim_type%is:clim_type%ie,clim_type%js:clim_type%je),Time)
  endif
endif

end subroutine diag_read_data
!
!#######################################################################
!
!++lwh
subroutine query_interpolator( clim_type, nfields, field_names )
!
! Query an interpolate_type variable to find the number of fields and field names. 
!
type(interpolate_type), intent(in)                    :: clim_type
integer, intent(out), optional                        :: nfields
character(len=*), dimension(:), intent(out), optional :: field_names

if( present( nfields ) )     nfields     = SIZE( clim_type%field_name(:) )
if( present( field_names ) ) field_names = clim_type%field_name

end subroutine query_interpolator
!--lwh
!
!#######################################################################
!
function chomp(string)
!
! A function to remove CHAR(0) from the end of strings read from NetCDF files.
!
character(len=*), intent(in) :: string
character(len=64) :: chomp

integer :: len

len = len_trim(string)
if (string(len:len) == CHAR(0)) len = len -1

chomp = string(:len)

end function chomp
!
!#################################################################
!
 subroutine interp_weighted_scalar_2D (grdin, grdout, datin, datout )
real, intent(in),  dimension(:) :: grdin, grdout
real, intent(in),  dimension(:,:) :: datin
real, intent(out), dimension(:,:) :: datout

integer :: j, k, n

if (size(grdin(:)).ne. (size(datin,1)+1)) &
 call mpp_error(FATAL,'interp_weighted_scalar : input data and pressure do not have the same number of levels')
if (size(grdout(:)).ne. (size(datout,1 )+1)) &
 call mpp_error(FATAL,'interp_weighted_scalar : output data and pressure do not have the same number of levels')

  do k = 1, size(datout,1 )
   datout(k,:) = 0.0

     do j = 1, size(datin,1 )

        if ( grdin(j)   <= grdout(k) .and. &
             grdin(j+1) >= grdout(k) .and. &
             grdin(j+1) <= grdout(k+1) ) then

          do n= 1, size(datin,2)
           datout(k,n) = datout(k,n) + datin(j,n)*(grdin(j+1)-grdout(k))
          end do

        else if ( grdin(j)   >= grdout(k)   .and. &
                  grdin(j)   <= grdout(k+1) .and. &
                  grdin(j+1) >= grdout(k+1) ) then

          do n= 1, size(datin,2)
           datout(k,n) = datout(k,n) + datin(j,n)*(grdout(k+1)-grdin(j))
          end do

        else if ( grdin(j)   >= grdout(k)   .and. &
                  grdin(j+1) <= grdout(k+1) ) then

          do n= 1, size(datin,2)
           datout(k,n) = datout(k,n) + datin(j,n)*(grdin(j+1)-grdin(j))
          end do

        else if ( grdin(j)   <= grdout(k)   .and. &
                  grdin(j+1) >= grdout(k+1) ) then

          do n= 1, size(datin,2)
          datout(k,n) = datout(k,n) + datin(j,n)*(grdout(k+1)-grdout(k))

          end do
        endif

     enddo

     do n= 1, size(datin,2)
       datout(k,n) = datout(k,n)/(grdout(k+1)-grdout(k))
     end do

  enddo

end subroutine interp_weighted_scalar_2D


!---------------------------------------------------------------------
 
 subroutine interp_weighted_scalar_1D (grdin, grdout, datin, datout )
real, intent(in),  dimension(:) :: grdin, grdout, datin
real, intent(out), dimension(:) :: datout

integer :: j, k

if (size(grdin(:)).ne. (size(datin(:))+1)) &
 call mpp_error(FATAL,'interp_weighted_scalar : input data and pressure do not have the same number of levels')
if (size(grdout(:)).ne. (size(datout(:))+1)) &
 call  mpp_error(FATAL,'interp_weighted_scalar : output data and pressure do not have the same number of levels')

  do k = 1, size(datout(:))
   datout(k) = 0.0

     do j = 1, size(datin(:))

        if ( grdin(j)   <= grdout(k) .and. &
             grdin(j+1) >= grdout(k) .and. &
             grdin(j+1) <= grdout(k+1) ) then

           datout(k) = datout(k) + datin(j)*(grdin(j+1)-grdout(k))

        else if ( grdin(j)   >= grdout(k)   .and. &
                  grdin(j)   <= grdout(k+1) .and. &
                  grdin(j+1) >= grdout(k+1) ) then

           datout(k) = datout(k) + datin(j)*(grdout(k+1)-grdin(j))

        else if ( grdin(j)   >= grdout(k)   .and. &
                  grdin(j+1) <= grdout(k+1) ) then

           datout(k) = datout(k) + datin(j)*(grdin(j+1)-grdin(j))

        else if ( grdin(j)   <= grdout(k)   .and. &
                  grdin(j+1) >= grdout(k+1) ) then

           datout(k) = datout(k) + datin(j)*(grdout(k+1)-grdout(k))

        endif

     enddo

     datout(k) = datout(k)/(grdout(k+1)-grdout(k))

  enddo

end subroutine interp_weighted_scalar_1D
!
!#################################################################
!
subroutine interp_linear ( grdin, grdout, datin, datout )
real, intent(in),  dimension(:) :: grdin, grdout, datin
real, intent(out), dimension(:) :: datout

integer :: j, k, n
real    :: wt


if (size(grdin(:)).ne. (size(datin(:))+1)) &
 call mpp_error(FATAL,'interp_linear : input data and pressure do not have the same number of levels')
if (size(grdout(:)).ne. (size(datout(:))+1)) &
 call mpp_error(FATAL,'interp_linear : output data and pressure do not have the same number of levels')


  n = size(grdin(:))

  do k= 1, size(datout(:))

   ! ascending grid values
     if (grdin(1) < grdin(n)) then
         do j = 2, size(grdin(:))-1
           if (grdout(k) <= grdin(j)) exit
         enddo
   ! descending grid values
     else
         do j = size(grdin(:)), 3, -1
           if (grdout(k) <= grdin(j-1)) exit
         enddo
     endif

   ! linear interpolation
     wt = (grdout(k)-grdin(j-1)) / (grdin(j)-grdin(j-1))
!print '(a,2i3,4f6.1)', 'k,j=',k,j,grdout(k),grdin(j-1),grdin(j),wt
   ! constant value extrapolation
   ! wt = min(max(wt,0.),1.)

     datout(k) = (1.-wt)*datin(j-1) + wt*datin(j)
     
  enddo

end subroutine interp_linear
!
!########################################################################

end module interpolator_mod
!
!#######################################################################
!
#ifdef test_interp
program test

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#endif

use mpp_mod
use mpp_io_mod
use mpp_domains_mod
use fms_mod
use time_manager_mod
use diag_manager_mod!, only : diag_axis_init, file_exist, MPP_NPES, &
                    !  MPP_PE, REGISTER_DIAG_FIELD, SEND_DATA, SET_DATE,&
                    !  SET_TIME

use interpolator_mod
!use sulfate_mod
!use ozone_mod
use constants_mod, only : grav, constants_init, PI
use time_interp_mod, only : time_interp_init

implicit none
integer, parameter :: nsteps_per_day = 8, ndays = 16
real, parameter :: delt = 1.0/nsteps_per_day
! integer, parameter :: nxd = 144, nyd = 90, ntsteps = 240, two_delt = 2*delt
integer, parameter :: nxd = 20, nyd = 40, ntsteps = nsteps_per_day*ndays, two_delt = 2*delt
integer :: delt_days, delt_secs
integer, parameter :: max_fields = 20 ! maximum number of fields to be interpolated

integer :: i,k,n,level
integer :: unit, io_status
integer :: ndivs
integer :: jscomp, jecomp, iscomp, iecomp, isd,ied,jsd,jed
integer :: numfields, domain_layout(2)
integer :: num_nbrs, nbins,axes(3), interp_diagnostic_id
integer :: column_diagnostic_id1, column_diagnostic_id(max_fields)

real ::  missing_value = -1.e10

character(len=1) :: dest_grid
character(len=128) :: src_file, file_out, title, units, colaer
logical :: vector_field=.false., result

type(axistype), allocatable, dimension(:)  :: axes_out, axes_src
type(axistype) :: time_axis
type(fieldtype), allocatable, dimension(:) :: fields
type(fieldtype) :: dest_field(max_fields), src_field(max_fields), field_geolon_t, &
     field_geolat_t, field_geolon_c, field_geolat_c
type(atttype), allocatable, dimension(:) :: global_atts
type(domain2d) :: domain
type(time_type) :: model_time

type(interpolate_type) :: o3, aerosol

real, dimension(:,:), allocatable :: col_data
real, dimension(:,:,:), allocatable :: model_data, p_half, p_full
real, dimension(:), allocatable :: latb_mod(:,:),lonb_mod(:,:),lon_mod(:),lat_mod(:)
real :: dx,dy
real :: dtr,tpi
real :: p_bot,p_top,lambda
character(len=64) :: names(13)
data names(:) /"so4_anthro","so4_natural","organic_carbon","black_carbon","sea_salt",&
"anthro_dust_0.2","anthro_dust_0.8","anthro_dust_2.0","anthro_dust_8.0",&
"natural_dust_0.2","natural_dust_0.8","natural_dust_2.0","natural_dust_8.0"/

integer :: out_of_bounds(1)
data out_of_bounds / CONSTANT/!, CONSTANT/!, CONSTANT, CONSTANT, CONSTANT, CONSTANT, CONSTANT, CONSTANT, CONSTANT, &
!ZERO, ZERO, ZERO, ZERO /

namelist /interpolator_nml/ src_file

! initialize communication modules

delt_days = INT(delt)
delt_secs = INT(delt*86400.0) - delt_days*86400.0

write(*,*) delt, delt_days,delt_secs

call mpp_init
call mpp_io_init
call mpp_domains_init
call set_calendar_type(JULIAN)
call diag_manager_init
call constants_init
call time_interp_init

level = 18
tpi = 2.0*PI !4.*acos(0.)
dtr = tpi/360.

src_file = 'src_file'  ! input file containing fields to be interpolated


model_time = set_date(1979,12,1,0,0,0)

!if (numfields.ne.2.and.vector_field) call mpp_error(FATAL,'2 components of vector field not specified')
!if (numfields.gt.1.and..not.vector_field) call mpp_error(FATAL,'only 1 scalar at a time')
!if (numfields .gt. max_fields) call mpp_error(FATAL,'max num fields exceeded')

!--------------------------------------------------------------------
! namelist input
!--------------------------------------------------------------------

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=interpolator_nml, iostat=io)
  ierr = check_nml_error(io, 'interpolator_nml')
#else
  call mpp_open(unit, 'input.nml',  action=MPP_RDONLY, form=MPP_ASCII)
  read  (unit, interpolator_nml,iostat=io_status)
  if (io_status .gt. 0) then
    call mpp_error(FATAL,'=>Error reading interpolator_nml')
  endif
call mpp_close(unit)
#endif

! decompose model grid points
! mapping can get expensive so we distribute the task at this level

ndivs = mpp_npes()

call mpp_define_layout ((/1,nxd,1,nyd/), ndivs, domain_layout)
call mpp_define_domains((/1,nxd,1,nyd/),domain_layout, domain,xhalo=0,yhalo=0)  
call mpp_get_data_domain(domain,isd,ied,jsd,jed)
call mpp_get_compute_domain (domain, iscomp, iecomp, jscomp, jecomp)

allocate(lonb_mod(nxd+1,nyd+1),lon_mod(nxd))
allocate(latb_mod(nxd+1,nyd+1),lat_mod(nyd))
allocate(col_data(isd:ied,jsd:jed)) ; col_data = 0.0
allocate(p_half(isd:ied,jsd:jed,level+1),p_full(isd:ied,jsd:jed,level))
p_top = 1.0
p_bot = 101325.0 !Model level in Pa
lambda = -1.0*log(p_top/p_bot)/(level+1)

p_half(:,:,level+1) = p_bot
do i=level,1,-1
  p_half(:,:,i)=p_half(:,:,i+1)*exp(-1.0*lambda)
enddo
do i=1,level
  p_full(:,:,i)=(p_half(:,:,i+1)+p_half(:,:,i))/2.0
enddo

allocate(model_data(isd:ied,jsd:jed,level))

dx = 360./nxd
dy = 180./nyd
do i = 1,nxd+1
  lonb_mod(i,:) = (i-1)*dx 
enddo
do i = 1,nyd+1
  latb_mod(:,i) = -90. + (i-1)*dy 
enddo
do i=1,nxd
  lon_mod(i)=(lonb_mod(i+1,1)+lonb_mod(i,1))/2.0
enddo
do i=1,nyd
  lat_mod(i)=(latb_mod(1,i+1)+latb_mod(1,i))/2.0
enddo

lonb_mod = lonb_mod * dtr
latb_mod = latb_mod * dtr

   axes(1) = diag_axis_init('x',lon_mod,units='degrees',cart_name='x',domain2=domain)
   axes(2) = diag_axis_init('y',lat_mod,units='degrees',cart_name='y',domain2=domain)
   axes(3) = diag_axis_init('z',p_full(isd,jsd,:),units='mb',cart_name='z')

interp_diagnostic_id =  register_diag_field('interp','ozone',axes(1:3),model_time,&
                                'interpolated_ozone_clim', 'kg/kg', missing_value)      
column_diagnostic_id1 =  register_diag_field('interp','colozone',axes(1:2),model_time,&
                                'column_ozone_clim', 'kg/m2', missing_value)      

do i=1,size(names(:))
colaer = 'col'//trim(names(i))
column_diagnostic_id(i) =  register_diag_field('interp',colaer,axes(1:2),model_time,&
                                'column_aerosol_clim', 'kg/m2', missing_value)      
enddo


call ozone_init(o3,lonb_mod(isd:ied+1,jsd:jed+1), latb_mod(isd:ied+1,jsd:jed+1), axes, model_time, &
                data_out_of_bounds=out_of_bounds)
call init_clim_diag(o3, axes, model_time)
call sulfate_init(aerosol,lonb_mod(isd:ied+1,jsd:jed+1), latb_mod(isd:ied+1,jsd:jed+1), names, &
                data_out_of_bounds=(/CONSTANT/) )
call init_clim_diag(aerosol, axes, model_time)

do n=1,ntsteps
  if( mpp_pe() == mpp_root_pe() ) write(*,*) n

  call get_ozone(o3,model_time,p_half,model_data)

  if(interp_diagnostic_id>0) &
       result = send_data(interp_diagnostic_id,&
            model_data(iscomp:iecomp,jscomp:jecomp,:),model_time)

  if(column_diagnostic_id1>0) then

    col_data(iscomp:iecomp,jscomp:jecomp)=0.0
    do k=1,level
       col_data(iscomp:iecomp,jscomp:jecomp)= col_data(iscomp:iecomp,jscomp:jecomp)+ &
          model_data(iscomp:iecomp,jscomp:jecomp,k)* &
          (p_half(iscomp:iecomp,jscomp:jecomp,k+1)-p_half(iscomp:iecomp,jscomp:jecomp,k))/grav
    enddo
       result = send_data(column_diagnostic_id1,col_data(:,:),model_time)
  endif



  do i=1,size(names(:))

call get_anthro_sulfate(aerosol,model_time,p_half,names(i),model_data,clim_units=units)

    if(column_diagnostic_id(i)>0) then

      col_data(iscomp:iecomp,jscomp:jecomp)=0.0
      do k=1,level
        if (trim(units) .eq. 'kg/m^2') then
           col_data(iscomp:iecomp,jscomp:jecomp)= col_data(iscomp:iecomp,jscomp:jecomp)+ &
              model_data(iscomp:iecomp,jscomp:jecomp,k)
        else
           col_data(iscomp:iecomp,jscomp:jecomp)= col_data(iscomp:iecomp,jscomp:jecomp)+ &
              model_data(iscomp:iecomp,jscomp:jecomp,k)* &
              (p_half(iscomp:iecomp,jscomp:jecomp,k+1)-p_half(iscomp:iecomp,jscomp:jecomp,k))/grav
        endif
      enddo
      result = send_data(column_diagnostic_id(i),&
      col_data(iscomp:iecomp,jscomp:jecomp),model_time)
    endif

  enddo

   model_time = model_time + set_time(delt_secs,delt_days)      

   if (n.eq. ntsteps) call diag_manager_end(model_time)

enddo

call interpolator_end(aerosol)
call interpolator_end(o3)

deallocate(lonb_mod, lon_mod, latb_mod,lat_mod, col_data, p_half, p_full, model_data)

call mpp_exit

contains
!
!#######################################################################
!
subroutine sulfate_init(aerosol,lonb, latb, names, data_out_of_bounds, vert_interp, units)
type(interpolate_type), intent(inout)         :: aerosol
real,                   intent(in)            :: lonb(:,:),latb(:,:)
character(len=64),      intent(in)            :: names(:)
integer,                intent(in)            :: data_out_of_bounds(:) 
integer,                intent(in), optional  :: vert_interp(:)
character(len=*),       intent(out),optional  :: units(:)

if (.not. file_exist("INPUT/aerosol.climatology.nc") ) return
call interpolator_init( aerosol, "aerosol.climatology.nc", lonb, latb, &
                        data_names=names, data_out_of_bounds=data_out_of_bounds, &
                        vert_interp=vert_interp, clim_units=units )

end subroutine sulfate_init
!
!#######################################################################
!
subroutine get_anthro_sulfate( sulfate, model_time, p_half, name, model_data, is, js, clim_units )
type(interpolate_type), intent(inout) :: sulfate
type(time_type), intent(in) :: model_time
real, intent(in)           :: p_half(:,:,:)
character(len=*), intent(in) :: name
character(len=*), intent(out), optional :: clim_units
real, intent(out) :: model_data(:,:,:)
integer, intent(in), optional :: is,js

call interpolator( sulfate, model_time, p_half, model_data, name, is, js, clim_units)

end subroutine get_anthro_sulfate
!
!#######################################################################
!
subroutine ozone_init( o3, lonb, latb, axes, model_time, data_out_of_bounds, vert_interp )
real,                  intent(in)           :: lonb(:,:),latb(:,:)
integer,               intent(in)           :: axes(:)
type(time_type),       intent(in)           :: model_time
type(interpolate_type),intent(inout)        :: o3
integer,               intent(in)           :: data_out_of_bounds(:)
integer,               intent(in), optional :: vert_interp(:)

if (.not. file_exist("INPUT/o3.climatology.nc") ) return
call interpolator_init( o3, "o3.climatology.nc", lonb, latb, &
                        data_out_of_bounds=data_out_of_bounds, vert_interp=vert_interp )

end subroutine ozone_init
!
!#######################################################################
!
subroutine get_ozone( o3, model_time, p_half, model_data, is, js )
type(interpolate_type),intent(inout) :: o3
type(time_type), intent(in) :: model_time
real, intent(in)           :: p_half(:,:,:)
real, intent(out) :: model_data(:,:,:)
integer, intent(in), optional :: is,js

call interpolator( o3, model_time, p_half, model_data, "ozone", is, js)

end subroutine get_ozone

end program test

#endif

module ic_from_external_file_mod

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use               fms_mod, only: error_mesg, FATAL, field_size, stdlog, file_exist, field_exist, &
                                 write_version_number, close_file, check_nml_error, read_data

use        transforms_mod, only: get_grid_boundaries, get_deg_lon, get_deg_lat, trans_grid_to_spherical, &
                                 trans_spherical_to_grid, grid_domain, spectral_domain, get_grid_domain, &
                                 get_spec_domain, get_lat_max, get_lon_max, vor_div_from_uv_grid, uv_grid_from_vor_div

use       tracer_type_mod, only: tracer_type

use     field_manager_mod, only: MODEL_ATMOS

use    tracer_manager_mod, only: get_number_tracers

implicit none
private

character(len=128), parameter :: version = &
'$Id: ic_from_external_file.F90,v 19.0 2012/01/06 20:35:31 fms Exp $'

character(len=128), parameter :: tagname = &
'$Name: tikal $'

public :: ic_from_external_file

character(len=128) :: file_name = 'INPUT/init_cond.nc'
character(len=128) :: u_name    = 'u'
character(len=128) :: v_name    = 'v'
character(len=128) :: t_name    = 't'
character(len=128) :: ps_name   = 'ps'

namelist / ic_from_external_file_nml / file_name, u_name, v_name, t_name, ps_name

contains

!=========================================================================================================================

subroutine ic_from_external_file(triang_trunc, tracer_attributes, vors, divs, ts, ln_ps, ug, &
                                 vg, tg, psg, vorg, divg, grid_tracers)

logical, intent(in) :: triang_trunc
type(tracer_type),intent(inout), dimension(:) :: tracer_attributes
complex, intent(out), dimension(:,:,:)   :: vors, divs, ts
complex, intent(out), dimension(:,:  )   :: ln_ps
real,    intent(out), dimension(:,:,:)   :: ug, vg, tg
real,    intent(out), dimension(:,:  )   :: psg
real,    intent(out), dimension(:,:,:)   :: vorg, divg
real,    intent(out), dimension(:,:,:,:) :: grid_tracers

integer :: unit, ierr, io, lon_max, lat_max, siz(4), num_tracers, ntr
character(len=128) :: tr_name, mesg1, mesg2
real, dimension(size(psg,1), size(psg,2)) :: ln_psg

!-------------------------------------------------------------------------------
! Read the namelist
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ic_from_external_file_nml, iostat=io)
    ierr = check_nml_error(io, 'ic_from_external_file_nml')
#else
    unit = open_namelist_file()
    ierr=1
    do while (ierr /= 0)
      read(unit, nml=ic_from_external_file_nml, iostat=io, end=20)
      ierr = check_nml_error (io, 'ic_from_external_file_nml')
    enddo
20  call close_file (unit)
#endif
call write_version_number(version, tagname)
write (stdlog(), nml=ic_from_external_file_nml)

!-------------------------------------------------------------------------------
! Error checks
if(.not.file_exist(file_name)) then
  call error_mesg('ic_from_external_file',trim(file_name)//' does not exist', FATAL)
endif
if( .not.field_exist(file_name,u_name) .or. .not.field_exist(file_name,v_name)  .or. &
    .not.field_exist(file_name,t_name) .or. .not.field_exist(file_name,ps_name)) then
  call error_mesg('ic_from_external_file','One or more of '//trim(u_name)//', '// &
      trim(v_name)//', '//trim(t_name)//', '//trim(ps_name)// &
      ' does not exist in '//trim(file_name), FATAL)
endif 
call field_size(file_name, u_name, siz) ! Checking the size of just one field should suffice.
call get_lon_max(lon_max)
call get_lat_max(lat_max)

if(any(siz(1:3) /= (/lon_max,lat_max,size(ug,3)/))) then
  write(mesg1,'(3i5)') siz(1:3) 
  write(mesg2,'(3i5)') (/lon_max,lat_max,size(ug,3)/)
  call error_mesg('ic_from_external_file',trim(u_name)//' in file '//trim(file_name)//' has wrong dimensions'// &
  ' Its shape is '//trim(mesg1)//'  Should be '//trim(mesg2), FATAL)
endif

!-------------------------------------------------------------------------------
! Read the initial state

call read_data(file_name, u_name,   ug, domain=grid_domain)
call read_data(file_name, v_name,   vg, domain=grid_domain)
call read_data(file_name, t_name,   tg, domain=grid_domain)
call read_data(file_name, ps_name, psg, domain=grid_domain)

! Read the initial tracers
call get_number_tracers(MODEL_ATMOS, num_prog=num_tracers)
do ntr=1,num_tracers
  tr_name = trim(tracer_attributes(ntr)%name)
  if(.not.field_exist(file_name,tr_name)) then
    call error_mesg('ic_from_external_file', &
                    trim(tr_name)//' is listed in field_table but does not exist in '//trim(file_name),FATAL)
  endif
  call read_data(file_name, tr_name, grid_tracers(:,:,:,ntr), domain=grid_domain)
enddo

!-------------------------------------------------------------------------------
! initial spectral fields (and spectrally-filtered) grid fields

call trans_grid_to_spherical(tg, ts)
call trans_spherical_to_grid(ts, tg)

ln_psg = alog(psg)
call trans_grid_to_spherical(ln_psg, ln_ps)
call trans_spherical_to_grid(ln_ps,  ln_psg)
psg = exp(ln_psg)

call vor_div_from_uv_grid(ug, vg, vors, divs, triang=triang_trunc)
call uv_grid_from_vor_div(vors, divs, ug, vg)
call trans_spherical_to_grid(vors, vorg)
call trans_spherical_to_grid(divs, divg)

return
end subroutine ic_from_external_file

!================================================================================

end module ic_from_external_file_mod

! ============================================================================
! 
! ============================================================================
module land_types_mod

! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Christopher Milly
! </CONTACT> 

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Elena Shevliakova
! </REVIEWER>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Sergey Malyshev
! </REVIEWER>

! <OVERVIEW>
!   Initializes land data types and allocates boundary data.
! </OVERVIEW>

! <DESCRIPTION>
!   This module defines two derived types. atmos_land_boundary_type represents
!   data passed from the atmosphere to the surface and the derivatives of the
!   fluxes. Data describing the land is land_data_type. This module contains
!   routines for initializing land type data and allocating and deallocating
!   data for the specified domain and number of tiles.
! </DESCRIPTION>

  use mpp_domains_mod, only : domain2d, mpp_get_compute_domain
  use fms_mod, only : write_version_number, stdout
  use mpp_mod,                 only: mpp_chksum

implicit none
private

! ==== public interfaces =====================================================
public :: land_types_init
public :: atmos_land_boundary_type
public :: land_data_type

public :: allocate_boundary_data
public :: deallocate_boundary_data
public :: land_data_type_chksum, atm_lnd_bnd_type_chksum
! ==== end of public interfaces ==============================================

! <TYPE NAME="atmos_land_boundary_type">
type :: atmos_land_boundary_type
!   <DESCRIPTION>
!     Data passed from the atmosphere to the surface and derivatives
!     of the fluxes. This data is provided by the flux_exchange.
!   </DESCRIPTION>

!   <DATA NAME="t_flux" UNITS="W/m2" TYPE="real, pointer" DIM="3">
!     Sensible heat flux
!   </DATA>

!   <DATA NAME="q_flux" UNITS="kg/m2/s" TYPE="real, pointer" DIM="3">
!     Water vapor flux
!   </DATA>

!   <DATA NAME="lw_flux" UNITS="W/m2" TYPE="real, pointer" DIM="3">
!     Net longwave flux
!   </DATA>

!   <DATA NAME="sw_flux" UNITS="W/m2" TYPE="real, pointer" DIM="3">
!     Net shortwave flux
!   </DATA>

!   <DATA NAME="sw_flux_down_vis_dir" UNITS="W/m2" TYPE="real, pointer" DIM="3">
!     Downward visible band direct shortwave flux
!   </DATA>

!   <DATA NAME="sw_flux_down_total_dir" UNITS="W/m2" TYPE="real, pointer" DIM="3">
!     Total direct downward shortwave flux
!   </DATA>

!   <DATA NAME="sw_flux_down_vis_dif" UNITS="W/m2" TYPE="real, pointer" DIM="3">
!     Downward visible diffuse shortwave flux
!   </DATA>

!   <DATA NAME="sw_flux_down_total_diff" UNITS="W/m2" TYPE="real, pointer" DIM="3">
!     Total downward diffuse shortwave flux
!   </DATA>
 
!   <DATA NAME="lprec" UNITS="kg/m2/s" TYPE="real, pointer" DIM="3">
!     Liquid precipitation
!   </DATA>

!   <DATA NAME="fprec" UNITS="kg/m2/s" TYPE="real, pointer" DIM="3">
!     Solid precipitation (snowfall)
!   </DATA>

!   <DATA NAME="tprec" UNITS="deg K" TYPE="real, pointer" DIM="3">
!     Temperature of precipitation
!   </DATA>

   ! data passed from the atmosphere to the surface
   real, dimension(:,:,:), pointer :: &
        t_flux =>NULL(),  &
        lw_flux =>NULL(), &
        lwdn_flux => NULL(), &   ! downward longwave radiation flux, W/m2
        sw_flux =>NULL(), &
        sw_flux_down_vis_dir =>NULL(), &
        sw_flux_down_total_dir =>NULL(), &
        sw_flux_down_vis_dif =>NULL(), &
        sw_flux_down_total_dif =>NULL(), &
        lprec =>NULL(),   &
        fprec =>NULL(),   &
        tprec =>NULL()

!   <DATA NAME="dhdt" UNITS="W/m2/K" TYPE="real, pointer" DIM="3">
!     Derivative of sensible heat over land surface temperature
!   </DATA>

!   <DATA NAME="dedt" UNITS="kg/m2/s/K" TYPE="real, pointer" DIM="3">
!     Derivative of evaporation over land surface temperature 
!   </DATA>

!   <DATA NAME="dedq" UNITS="kg/m2/s" TYPE="real, pointer" DIM="3">
!      Derivative of evaporation over near-surface specific humidity
!   </DATA>

!   <DATA NAME="drdt" UNITS="W/m2/K" TYPE="real, pointer" DIM="3">
!     Derivative of LW radiation over land surface temperature
!   </DATA>

   ! derivatives of the fluxes
   real, dimension(:,:,:), pointer :: &
        dhdt =>NULL(),    &
        drdt =>NULL()

!   <DATA NAME="drag_q" UNITS="m/s" TYPE="real, pointer" DIM="3">
!     Product of drag coefficient for water vapor by wind
!   </DATA>

!   <DATA NAME="p_surf" UNITS="N/m2" TYPE="real, pointer" DIM="3">
!     Surface pressure
!   </DATA>

   real, dimension(:,:,:), pointer :: &
        cd_m => NULL(),      &   ! drag coefficient for momentum, dimensionless
        cd_t => NULL(),      &   ! drag coefficient for tracers, dimensionless
        ustar => NULL(),     &   ! turbulent wind scale, m/s
        bstar => NULL(),     &   ! turbulent bouyancy scale, m/s
        wind => NULL(),      &   ! abs wind speed at the bottom of the atmos, m/s
        z_bot => NULL(),     &   ! height of the bottom atmos. layer above surface, m
        drag_q =>NULL(),     &   ! product of cd_q by wind
        p_surf =>NULL()          ! surface pressure

#ifdef LAND_BND_TRACERS
   real, dimension(:,:,:,:), pointer :: & ! (lon, lat, tile,tracer)
        tr_flux => NULL(),   &   ! tracer flux, including water vapor flux
        dfdtr   => NULL()        ! tendency, including evap over surface specific humidity
#else
   real, dimension(:,:,:), pointer :: & ! (lon, lat, tile)
        q_flux => NULL(),    &   ! water vapor flux
        dedt => NULL(),      &   ! evap over surface temperature (assuming saturation @ surf.)
        dedq => NULL()           ! evap over surface specufuc humidity
#endif 


!   <DATA NAME="xtype" TYPE="integer">
!     REGRID, REDIST or DIRECT
!   </DATA>

   integer :: xtype             !REGRID, REDIST or DIRECT

end type atmos_land_boundary_type
! </TYPE>

! <TYPE NAME="land_data_type">
!   <DESCRIPTION>
!     Data describing the land.
!   </DESCRIPTION>
type :: land_data_type

!   <DATA NAME="domain" TYPE="domain2d" DIM="2">
!     The computational domain
!   </DATA>

   type(domain2d) :: domain  ! our computation domain

!   <DATA NAME="tile_size" TYPE="real, pointer" DIM="3">
!     Fractional coverage of cell by tile, dimensionless
!   </DATA>

!   <DATA NAME="t_surf" UNITS="K" TYPE="real, pointer" DIM="3">
!     Ground surface temperature
!   </DATA>

!   <DATA NAME="t_ca" UNITS="K" TYPE="real, pointer" DIM="3">
!     Canopy air temperature
!   </DATA>

!   <DATA NAME="q_ca" UNITS="kg/kg" TYPE="real, pointer" DIM="3">
!     Canopy air specific humidity
!   </DATA>

!   <DATA NAME="albedo" TYPE="real, pointer" DIM="3">
!     Snow-adjusted land albedo
!   </DATA>

!   <DATA NAME="albedo_vis_dir" TYPE="real, pointer" DIM="3">
!     Snow-adjusted land albedo for direct visible
!   </DATA>
 
!   <DATA NAME="albedo_nir_dir" TYPE="real, pointer" DIM="3">
!     Snow-adjusted land albedo for direct nir
!   </DATA>

!   <DATA NAME="albedo_vis_dif" TYPE="real, pointer" DIM="3">
!     Snow-adjusted land albedo for diffuse visible
!   </DATA>

!   <DATA NAME="albedo_nir_dif" TYPE="real, pointer" DIM="3">
!     Snow-adjusted land albedo for diffuse nir
!   </DATA>

!   <DATA NAME="rough_mom" UNITS="m" TYPE="real, pointer" DIM="3">
!     Momentum roughness length
!   </DATA>

!   <DATA NAME="rough_heat" UNITS="m" TYPE="real, pointer" DIM="3">
!     Roughness length for tracers (heat and water)
!   </DATA>

!   <DATA NAME="rough_scale" UNITS="m" TYPE="real, pointer" DIM="3">
!     Roughness length for topographic momentum drag coefficient scaling
!   </DATA>
   real, pointer, dimension(:,:,:)   :: &  ! (lon, lat, tile)
        tile_size =>NULL(),       & ! fractional coverage of cell by tile, dimensionless
        t_surf =>NULL(),          & ! ground surface temperature, degK
        t_ca =>NULL(),            & ! canopy air temperature, degK
        albedo =>NULL(),          & ! snow-adjusted land albedo
        albedo_vis_dir =>NULL(),  & ! albedo for direct visible-band radiation
        albedo_nir_dir =>NULL(),  & ! albedo for direct nir-band radiation 
        albedo_vis_dif =>NULL(),  & ! albedo for diffuse visible-band radiation 
        albedo_nir_dif =>NULL(),  & ! albedo for diffuse nir-band radiation
        rough_mom =>NULL(),       & ! momentum roughness length, m
        rough_heat =>NULL(),      & ! roughness length for tracers (heat and water), m
        rough_scale =>NULL()        ! roughness length for drag scaling

#ifdef LAND_BND_TRACERS
   real, pointer, dimension(:,:,:,:)   :: &  ! (lon, lat, tile, tracer)
        tr   => NULL()               ! tracers, including canopy air specific humidity, kg/kg
#else
   real, pointer, dimension(:,:,:)   :: &  ! (lon, lat, tile)
        q_ca => NULL()               ! canopy air specific humidity, kg/kg
#endif


!   <DATA NAME="discharge" UNITS="kg/m2/s" TYPE="real, pointer" DIM="2">
!     Outflow of fresh water from river mouths into the ocean (per unit area
!     of the ocean part of the grid cell)
!   </DATA>

!   <DATA NAME="discharge_heat" UNITS="W/m2" TYPE="real, pointer" DIM="2">
!     Sensible heat of discharge  (0 C datum)
!   </DATA>

!   <DATA NAME="discharge_snow" UNITS="kg/m2/s" TYPE="real, pointer" DIM="2">
!     Snow analogue of discharge
!   </DATA>

!   <DATA NAME="discharge_snow_heat" UNITS="W/m2" TYPE="real, pointer" DIM="2">
!     Sensible heat of discharge_snow  (0 C datum)
!   </DATA>

   real, pointer, dimension(:,:) :: &  ! (lon, lat)
        discharge           => NULL(),  & ! flux from surface drainage network out of land model
        discharge_heat      => NULL(),  & ! sensible heat of discharge (0 C datum)
        discharge_snow      => NULL(),  & ! snow analogue of discharge
        discharge_snow_heat => NULL()     ! sensible heat of discharge_snow (0 C datum)

!   <DATA NAME="mask" TYPE="logical, pointer" DIM="3">
!     Land mask; true if land
!   </DATA>

   logical, pointer, dimension(:,:,:):: &
        mask =>NULL()        ! true if land

!   <DATA NAME="maskmap" TYPE="logical, pointer" DIM="2">
!     A pointer to an array indicating which logical processors are actually used for
!     the ocean code. The other logical processors would be all land points and
!     are not assigned to actual processors. This need not be assigned if all logical
!     processors are used. This variable is dummy and need not to be set, 
!     but it is needed to pass compilation.
!   </DATA>

   logical, pointer, dimension(:,:) :: maskmap =>NULL()  ! A pointer to an array indicating which
                                                         ! logical processors are actually used for
                                                         ! the ocean code. 

!   <DATA NAME="axes(2)" TYPE="integer" DIM="2">
!     Axes IDs for diagnostics
!   </DATA>

   integer :: axes(2)      ! axes IDs for diagnostics  
   logical :: pe

   integer, pointer, dimension(:) :: pelist

end type land_data_type
! </TYPE>

logical :: module_is_initialized =.FALSE.
character(len=128) :: version = '$Id: land_types.F90,v 20.0 2013/12/13 23:28:40 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'


contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-


! ============================================================================

! <SUBROUTINE NAME="land_types_init">

!   <OVERVIEW>
!     Initializes the land types.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Initializes the land types module and writes the CVS version
!     and tagname
!   </DESCRIPTION>

!   <TEMPLATE>
!     call land_types_init()
!   </TEMPLATE>

!   <PUBLICROUTINE INTERFACE="">
subroutine land_types_init()
!   </PUBLICROUTINE>

  module_is_initialized =.TRUE. 
  call write_version_number(version, tagname)

end subroutine land_types_init
! </SUBROUTINE>


! <SUBROUTINE NAME="allocate_boundary_data">

!   <OVERVIEW>
!     Allocates the boundary data.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Allocates data for the specified domain and number of tiles.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call allocate_boundary_data (bnd, domain, n_tiles)
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine allocate_boundary_data (a2l, bnd, domain, n_tiles, n_tracers)
  type(atmos_land_boundary_type), intent(inout) :: a2l
  type(land_data_type), intent(inout) :: bnd     ! data to allocate
  type(domain2d),       intent(in)  :: domain  ! domain to allocate for
  integer,              intent(in)  :: n_tiles ! number of tiles
  integer,              intent(in)  :: n_tracers ! number of tracers
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer :: is,ie,js,je ! boundaries of the domain

  ! get the size of our computation domain
  call mpp_get_compute_domain ( domain, is,ie,js,je )

  ! allocate data according to the domain boundaries
  allocate ( &
       bnd % tile_size  (is:ie,js:je,n_tiles), & 
       bnd % t_surf     (is:ie,js:je,n_tiles), &
       bnd % t_ca       (is:ie,js:je,n_tiles), &
       bnd % albedo     (is:ie,js:je,n_tiles), & 
       bnd % albedo_vis_dir (is:ie,js:je,n_tiles), &
       bnd % albedo_nir_dir (is:ie,js:je,n_tiles), &
       bnd % albedo_vis_dif (is:ie,js:je,n_tiles), &
       bnd % albedo_nir_dif (is:ie,js:je,n_tiles), &
       bnd % rough_mom  (is:ie,js:je,n_tiles), & 
       bnd % rough_heat (is:ie,js:je,n_tiles), & 
       bnd % rough_scale(is:ie,js:je,n_tiles), & 

       bnd % discharge             (is:ie,js:je),   & 
       bnd % discharge_heat        (is:ie,js:je),   & 
       bnd % discharge_snow        (is:ie,js:je),   &
       bnd % discharge_snow_heat   (is:ie,js:je),   &

       bnd % mask       (is:ie,js:je,n_tiles) &
       )
#ifdef LAND_BND_TRACERS
  allocate( bnd % tr  (is:ie,js:je,n_tiles,n_tracers) )
#else
  allocate( bnd % q_ca(is:ie,js:je,n_tiles) )
#endif  

  allocate( a2l % t_flux  (is:ie,js:je,n_tiles) )
  allocate( a2l % lw_flux (is:ie,js:je,n_tiles) )
  allocate( a2l % sw_flux (is:ie,js:je,n_tiles) )
  allocate( a2l % lprec   (is:ie,js:je,n_tiles) )
  allocate( a2l % fprec   (is:ie,js:je,n_tiles) )
  allocate( a2l % tprec   (is:ie,js:je,n_tiles) )
  allocate( a2l % dhdt    (is:ie,js:je,n_tiles) )
  allocate( a2l % drdt    (is:ie,js:je,n_tiles) )
  allocate( a2l % drag_q  (is:ie,js:je,n_tiles) )
  allocate( a2l % p_surf  (is:ie,js:je,n_tiles) )
  allocate( a2l % sw_flux_down_vis_dir   (is:ie,js:je,n_tiles) )
  allocate( a2l % sw_flux_down_total_dir (is:ie,js:je,n_tiles) )
  allocate( a2l % sw_flux_down_vis_dif   (is:ie,js:je,n_tiles) )
  allocate( a2l % sw_flux_down_total_dif (is:ie,js:je,n_tiles) )

  allocate( a2l % wind    (is:ie,js:je,n_tiles) )

#ifdef LAND_BND_TRACERS
  allocate( a2l % tr_flux(is:ie,js:je,n_tiles,n_tracers) )
  allocate( a2l % dfdtr(is:ie,js:je,n_tiles,n_tracers) )
#else
  allocate( a2l % q_flux(is:ie,js:je,n_tiles) )
  allocate( a2l % dedt(is:ie,js:je,n_tiles) )
  allocate( a2l % dedq(is:ie,js:je,n_tiles) )
#endif

! set up initial values (discharge_heat and discharge_snow_heat are set to zero and never change)
  bnd % discharge_heat      = 0.0
  bnd % discharge_snow_heat = 0.0

end subroutine allocate_boundary_data
! </SUBROUTINE>


! <SUBROUTINE NAME="deallocate_boundary_data">

!   <OVERVIEW>
!     Deallocates the boundary data.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Deallocates the boundary data.
!     
!   </DESCRIPTION>

!   <TEMPLATE>
!     call deallocate_boundary_data ( bnd )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine deallocate_boundary_data ( a2l, bnd )
  type(atmos_land_boundary_type), intent(inout) :: a2l
  type(land_data_type), intent(inout) :: bnd  ! data to deallocate
!   </PUBLICROUTINE>

  deallocate ( &
       bnd % tile_size  , & 
       bnd % t_surf     , &
       bnd % t_ca       , &
       bnd % albedo     , & 
       bnd % albedo_vis_dir , &
       bnd % albedo_nir_dir , &
       bnd % albedo_vis_dif , &
       bnd % albedo_nir_dif , &
       bnd % rough_mom  , & 
       bnd % rough_heat , & 
       bnd % rough_scale, &

       bnd % discharge      ,      & 
       bnd % discharge_heat ,      & 
       bnd % discharge_snow ,      &
       bnd % discharge_snow_heat , &

       bnd % mask        &
       )
#ifdef LAND_BND_TRACERS
  if(associated( bnd%tr ))             deallocate( bnd%tr )
#else
  if(associated( bnd%q_ca ))           deallocate( bnd%q_ca )
#endif

  deallocate( a2l % t_flux   )
  deallocate( a2l % lw_flux  )
  deallocate( a2l % sw_flux  )
  deallocate( a2l % lprec    )
  deallocate( a2l % fprec    )
  deallocate( a2l % tprec    )
  deallocate( a2l % dhdt     )
  deallocate( a2l % drdt     )
  deallocate( a2l % drag_q   )
  deallocate( a2l % p_surf   )
  deallocate( a2l % sw_flux_down_vis_dir    )
  deallocate( a2l % sw_flux_down_total_dir  )
  deallocate( a2l % sw_flux_down_vis_dif    )
  deallocate( a2l % sw_flux_down_total_dif  )

  deallocate( a2l % wind     )

#ifdef LAND_BND_TRACERS
  deallocate( a2l % tr_flux )
  deallocate( a2l % dfdtr )
#else
  deallocate( a2l % q_flux )
  deallocate( a2l % dedt )
  deallocate( a2l % dedq )
#endif

end subroutine deallocate_boundary_data
! </SUBROUTINE>

subroutine atm_lnd_bnd_type_chksum(id, timestep, albt)

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(atmos_land_boundary_type), intent(in) :: albt
    integer ::   n, outunit
    
    outunit = stdout()

    write(outunit,*) "BEGIN CHECKSUM(atmos_land_boundary_type):: ", id, timestep
    write(outunit,100) 'albt%t_flux                ', mpp_chksum( albt%t_flux)
    write(outunit,100) 'albt%lw_flux               ', mpp_chksum( albt%lw_flux)
    if ( associated(albt%lwdn_flux) ) write(outunit,100) 'albt%lwdn_flux             ', mpp_chksum( albt%lwdn_flux)
    write(outunit,100) 'albt%sw_flux               ', mpp_chksum( albt%sw_flux)
    write(outunit,100) 'albt%sw_flux_down_vis_dir  ', mpp_chksum( albt%sw_flux_down_vis_dir)
    write(outunit,100) 'albt%sw_flux_down_total_dir', mpp_chksum( albt%sw_flux_down_total_dir)
    write(outunit,100) 'albt%sw_flux_down_vis_dif  ', mpp_chksum( albt%sw_flux_down_vis_dif)
    write(outunit,100) 'albt%sw_flux_down_total_dif', mpp_chksum( albt%sw_flux_down_total_dif)
    write(outunit,100) 'albt%lprec                 ', mpp_chksum( albt%lprec)
    write(outunit,100) 'albt%fprec                 ', mpp_chksum( albt%fprec)
    write(outunit,100) 'albt%tprec                 ', mpp_chksum( albt%tprec)
    write(outunit,100) 'albt%dhdt                  ', mpp_chksum( albt%dhdt)
    write(outunit,100) 'albt%drdt                  ', mpp_chksum( albt%drdt)
    if ( associated(albt%cd_m) )  write(outunit,100) 'albt%cd_m                  ', mpp_chksum( albt%cd_m)
    if ( associated(albt%cd_t) )  write(outunit,100) 'albt%cd_t                  ', mpp_chksum( albt%cd_t)
    if ( associated(albt%ustar) ) write(outunit,100) 'albt%ustar                 ', mpp_chksum( albt%ustar)
    if ( associated(albt%bstar) ) write(outunit,100) 'albt%bstar                 ', mpp_chksum( albt%bstar)
    if ( associated(albt%wind) )  write(outunit,100) 'albt%wind                  ', mpp_chksum( albt%wind)
    if ( associated(albt%z_bot) ) write(outunit,100) 'albt%z_bot                 ', mpp_chksum( albt%z_bot)
    write(outunit,100) 'albt%drag_q                ', mpp_chksum( albt%drag_q)
    write(outunit,100) 'albt%p_surf                ', mpp_chksum( albt%p_surf)
#ifdef LAND_BND_TRACERS
    do n = 1,size(albt%tr_flux,4)
    write(outunit,100) 'albt%tr_flux               ', mpp_chksum( albt%tr_flux(:,:,:,n))
    enddo
    do n = 1,size(albt%dfdtr,4)
    write(outunit,100) 'albt%dfdtr                 ', mpp_chksum( albt%dfdtr(:,:,:,n))
    enddo
#else
    write(outunit,100) 'albt%q_flux                ', mpp_chksum( albt%q_flux)
    write(outunit,100) 'albt%dedt                  ', mpp_chksum( albt%dedt)
    write(outunit,100) 'albt%dedq                  ', mpp_chksum( albt%dedq)
#endif 

100 FORMAT("   CHECKSUM::",A32," = ",Z20)

end subroutine atm_lnd_bnd_type_chksum

subroutine land_data_type_chksum(id, timestep, land)

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(land_data_type), intent(in) :: land
    integer ::   n, outunit
    
    outunit = stdout()

    write(outunit,*) "BEGIN CHECKSUM(land_type):: ", id, timestep
    write(outunit,100) 'land%tile_size         ',mpp_chksum(land%tile_size)
    write(outunit,100) 'land%t_surf            ',mpp_chksum(land%t_surf)
    write(outunit,100) 'land%t_ca              ',mpp_chksum(land%t_ca)
    write(outunit,100) 'land%albedo            ',mpp_chksum(land%albedo)
    write(outunit,100) 'land%albedo_vis_dir    ',mpp_chksum(land%albedo_vis_dir)
    write(outunit,100) 'land%albedo_nir_dir    ',mpp_chksum(land%albedo_nir_dir)
    write(outunit,100) 'land%albedo_vis_dif    ',mpp_chksum(land%albedo_vis_dif)
    write(outunit,100) 'land%albedo_nir_dif    ',mpp_chksum(land%albedo_nir_dif)
    write(outunit,100) 'land%rough_mom         ',mpp_chksum(land%rough_mom)
    write(outunit,100) 'land%rough_heat        ',mpp_chksum(land%rough_heat)
    write(outunit,100) 'land%rough_scale       ',mpp_chksum(land%rough_scale)

#ifdef LAND_BND_TRACERS
    do n = 1, size(land%tr,4)
    write(outunit,100) 'land%tr                ',mpp_chksum(land%tr(:,:,:,n))
    enddo
#else
    write(outunit,100) 'land%q_ca              ',mpp_chksum(land%q_ca)
#endif
    write(outunit,100) 'land%discharge         ',mpp_chksum(land%discharge)
    write(outunit,100) 'land%discharge_snow    ',mpp_chksum(land%discharge_snow)


100 FORMAT("   CHECKSUM::",A32," = ",Z20)
end subroutine land_data_type_chksum


end module land_types_mod

! ============================================================================
! updates carbon pools and rates on the fast time scale
! ============================================================================
module vegn_dynamics_mod

#include "../shared/debug.inc"

use fms_mod, only: write_version_number, error_mesg, FATAL
use time_manager_mod, only: time_type

use land_constants_mod, only : seconds_per_year, mol_C
use land_tile_diag_mod, only : &
     register_tiled_diag_field, send_tile_data, diag_buff_type
use vegn_data_mod, only : spdata, &
     CMPT_VLEAF, CMPT_SAPWOOD, CMPT_ROOT, CMPT_WOOD, CMPT_LEAF, LEAF_ON, LEAF_OFF, &
     fsc_liv, fsc_wood, K1, K2, soil_carbon_depth_scale, C2B, agf_bs, &
     l_fract
use vegn_tile_mod, only: vegn_tile_type
use soil_tile_mod, only: soil_tile_type, soil_ave_temp, soil_theta
use vegn_cohort_mod, only : vegn_cohort_type, height_from_biomass, lai_from_biomass, &
     update_biomass_pools, update_bio_living_fraction, update_species

use land_debug_mod, only : is_watch_point

implicit none
private

! ==== public interfaces =====================================================
public :: vegn_dynamics_init

public :: vegn_carbon_int   ! fast time-scale integrator of carbon balance
public :: vegn_growth       ! slow time-scale redistributor of accumulated carbon
public :: vegn_daily_npp    ! updates values of daily-average npp
public :: vegn_phenology    !
public :: vegn_biogeography !
! ==== end of public interfaces ==============================================

! ==== module constants ======================================================
character(len=*), private, parameter :: &
   version = '$Id: vegn_dynamics.F90,v 20.0 2013/12/13 23:31:10 fms Exp $', &
   tagname = '$Name: tikal $' ,&
   module_name = 'vegn'

real, parameter :: GROWTH_RESP=0.333  ! fraction of npp lost as growth respiration
integer, parameter :: USE_AVE_T_AND_THETA=1, USE_LAYER_T_AND_THETA=2 ! soil decomposition options


! ==== module data ===========================================================
real    :: dt_fast_yr ! fast (physical) time step, yr (year is defined as 365 days)
integer :: soil_decomp_to_use=0

! diagnostic field IDs
integer :: id_npp, id_nep, id_gpp, id_fsc, id_ssc, id_rsoil, &
    id_rsoil_fast, id_rsoil_slow, id_resp, id_resl, id_resr, id_resg, id_asoil, &
    id_soilt, id_theta, id_litter


contains

! ============================================================================
subroutine vegn_dynamics_init(id_lon, id_lat, time, delta_time, soil_decomp_option)
  integer        , intent(in) :: id_lon ! ID of land longitude (X) axis 
  integer        , intent(in) :: id_lat ! ID of land latitude (Y) axis
  type(time_type), intent(in) :: time       ! initial time for diagnostic fields
  real           , intent(in) :: delta_time ! fast time step, s
  character(*)   , intent(in) :: soil_decomp_option

  call write_version_number(version, tagname)

  ! set up global variables
  dt_fast_yr = delta_time/seconds_per_year

  ! parse soil decomposition option
  select case (soil_decomp_option)
  case('use_ave_t_and_theta')
    soil_decomp_to_use = USE_AVE_T_AND_THETA
  case('use_layer_t_and_theta')
    soil_decomp_to_use = USE_LAYER_T_AND_THETA
  case default
    call error_mesg('vegn_dynamics_init', &
        '"'//trim(soil_decomp_option)//'" is an invalid option for soil_decomp_option', FATAL)
  end select


  ! register diagnostic fields
  id_gpp = register_tiled_diag_field ( module_name, 'gpp',  &
       (/id_lon,id_lat/), time, 'gross primary productivity', 'kg C/(m2 year)', &
       missing_value=-100.0 )
  id_npp = register_tiled_diag_field ( module_name, 'npp',  &
       (/id_lon,id_lat/), time, 'net primary productivity', 'kg C/(m2 year)', &
       missing_value=-100.0 )
  id_nep = register_tiled_diag_field ( module_name, 'nep',  &
       (/id_lon,id_lat/), time, 'net ecosystem productivity', 'kg C/(m2 year)', &
       missing_value=-100.0 )
  id_litter = register_tiled_diag_field (module_name, 'litter', (/id_lon,id_lat/), &
       time, 'litter productivity', 'kg C/(m2 year)', missing_value=-100.0)
  ! TODO: remove fsc and ssc from either soil or vegn modules (or at least deprecate
  !       one of them)
  id_fsc = register_tiled_diag_field ( module_name, 'fsc',  &
       (/id_lon,id_lat/), time, 'total fast soil carbon', 'kg C/m2', &
       missing_value=-100.0 )
  id_ssc = register_tiled_diag_field ( module_name, 'ssc',  &
       (/id_lon,id_lat/), time, 'total slow soil carbon', 'kg C/m2', &
       missing_value=-100.0 )
  id_resp = register_tiled_diag_field ( module_name, 'resp', (/id_lon,id_lat/), &
       time, 'respiration', 'kg C/(m2 year)', missing_value=-100.0 )
  id_resl = register_tiled_diag_field ( module_name, 'resl', (/id_lon,id_lat/), &
       time, 'leaf respiration', 'kg C/(m2 year)', missing_value=-100.0 )
  id_resr = register_tiled_diag_field ( module_name, 'resr', (/id_lon,id_lat/), &
       time, 'root respiration', 'kg C/(m2 year)', missing_value=-100.0 )
  id_resg = register_tiled_diag_field ( module_name, 'resg', (/id_lon,id_lat/), &
       time, 'growth respiration', 'kg C/(m2 year)', missing_value=-100.0 )
  id_rsoil = register_tiled_diag_field ( module_name, 'rsoil',  &
       (/id_lon,id_lat/), time, 'soil respiration', 'kg C/(m2 year)', &
       missing_value=-100.0 )
  id_rsoil_fast = register_tiled_diag_field ( module_name, 'rsoil_fast',  &
       (/id_lon,id_lat/), time, 'total fast soil carbon respiration', 'kg C/(m2 year)', &
       missing_value=-100.0 )
  id_rsoil_slow = register_tiled_diag_field ( module_name, 'rsoil_slow',  &
       (/id_lon,id_lat/), time, 'total slow soil carbon respiration', 'kg C/(m2 year)', &
       missing_value=-100.0 )
  id_asoil = register_tiled_diag_field ( module_name, 'asoil', &
       (/id_lon,id_lat/), time, 'aerobic activity modifier', &
       missing_value=-100.0 )
  id_soilt = register_tiled_diag_field ( module_name, 'tsoil_av',  &
       (/id_lon,id_lat/), time, 'average soil temperature for carbon decomposition', 'degK', &
       missing_value=-100.0 )
  id_theta = register_tiled_diag_field ( module_name, 'theta',  &
       (/id_lon,id_lat/), time, 'average soil wetness for carbon decomposition', 'm3/m3', &
       missing_value=-100.0 )
end subroutine vegn_dynamics_init


! ============================================================================
subroutine vegn_carbon_int(vegn, soil, soilt, theta, diag)
  type(vegn_tile_type), intent(inout) :: vegn
  type(soil_tile_type), intent(inout) :: soil
  real, intent(in) :: soilt ! average temperature of soil for soil carbon decomposition, deg K
  real, intent(in) :: theta ! average soil wetness, unitless
  type(diag_buff_type), intent(inout) :: diag
  
  ! TODO: possibly move soil-related calculations from calling procedure here,
  !       now that we have soil passed as an argument

  type(vegn_cohort_type), pointer :: cc
  real :: resp, resl, resr, resg ! respiration terms accumulated for all cohorts 
  real :: cgain, closs ! carbon gain and loss accumulated for entire tile 
  real :: md_alive, md_wood;
  real :: gpp ! gross primary productivity per tile
  integer :: sp ! shorthand for current cohort specie
  integer :: i

  if(is_watch_point()) then
     write(*,*)'#### vegn_carbon_int ####'
     __DEBUG2__(soilt,theta)
  endif

  !  update plant carbon
  vegn%npp = 0
  resp = 0 ; resl = 0 ; resr = 0 ; resg = 0 ; gpp = 0
  cgain = 0 ; closs = 0
  do i = 1, vegn%n_cohorts   
     cc => vegn%cohorts(i)
     sp = cc%species

     call eddy_npp(cc,soilt);
     ! npp2 is for diagnostics and comparison
     cc%npp2 = cc%miami_npp;  ! treat miami npp as above+below npp
     
     cc%carbon_gain = cc%carbon_gain + cc%npp*dt_fast_yr;
     
     ! check if leaves/roots are present and need to be accounted in maintanence
     if(cc%status == LEAF_ON) then
        md_alive = (cc%Pl * spdata(sp)%alpha(CMPT_LEAF) + &
                    cc%Pr * spdata(sp)%alpha(CMPT_ROOT))* &
              cc%bliving*dt_fast_yr;    
     else
        md_alive = 0
     endif
     
     ! compute branch and coarse wood losses for tree types
     md_wood =0;
     if (sp > 1) then
        md_wood = 0.6 *cc%bwood * spdata(sp)%alpha(CMPT_WOOD)*dt_fast_yr;
     endif
        
     cc%md = md_alive + cc%Psw_alphasw * cc%bliving * dt_fast_yr;
     cc%bwood_gain = cc%bwood_gain + cc%Psw_alphasw * cc%bliving * dt_fast_yr;
     cc%bwood_gain = cc%bwood_gain - md_wood;
     if (cc%bwood_gain < 0.0) cc%bwood_gain=0.0; ! potential non-conservation ?
     cc%carbon_gain = cc%carbon_gain - cc%md;
     cc%carbon_loss = cc%carbon_loss + cc%md; ! used in diagnostics only

     ! add md from leaf and root pools to fast soil carbon
     soil%fast_soil_C(1) = soil%fast_soil_C(1) +    fsc_liv *md_alive +    fsc_wood *md_wood;
     soil%slow_soil_C(1) = soil%slow_soil_C(1) + (1-fsc_liv)*md_alive + (1-fsc_wood)*md_wood;

     ! for budget tracking
!/*     cp->fsc_in(1)+= data->fsc_liv*md_alive+data->fsc_wood*md_wood; */
!/*     cp->ssc_in(1)+= (1.- data->fsc_liv)*md_alive+(1-data->fsc_wood)*md_wood; */
     soil%fsc_in(1)  = soil%fsc_in(1) + 1*md_alive+0*md_wood;
     soil%ssc_in(1)  = soil%ssc_in(1) + (1.- 1)*md_alive+(1-0)*md_wood;

     vegn%veg_in  = vegn%veg_in  + cc%npp*dt_fast_yr;
     vegn%veg_out = vegn%veg_out + md_alive+md_wood;

     if(is_watch_point()) then
        __DEBUG4__(cc%bl, cc%br, cc%bsw, cc%bwood)
        __DEBUG3__(cc%An_op, cc%An_cl, cc%lai)
        __DEBUG1__(cc%species)
        __DEBUG2__(cc%npp, cc%gpp)
        __DEBUG4__(cc%resp, cc%resl, cc%resr, cc%resg)
        __DEBUG2__(cc%carbon_gain, cc%carbon_loss)
        __DEBUG1__(cc%bwood_gain)
     endif
     ! accumulate tile-level NPP and GPP
     vegn%npp = vegn%npp + cc%npp
     gpp = gpp + cc%gpp 
     ! accumulate respiration terms for tile-level reporting
     resp = resp + cc%resp ; resl = resl + cc%resl
     resr = resr + cc%resr ; resg = resg + cc%resg
     ! accumulate gain/loss terms for tile-level reporting
     cgain = cgain + cc%carbon_gain
     closs = closs + cc%carbon_loss
  enddo

  ! update soil carbon
  call Dsdt(vegn, soil, diag, soilt, theta)

  ! NEP is equal to NNP minus soil respiration
  vegn%nep = vegn%npp - vegn%rh

  call update_soil_pools(vegn, soil)
  vegn%age = vegn%age + dt_fast_yr;


  ! ---- diagnostic section
  call send_tile_data(id_gpp,gpp,diag)
  call send_tile_data(id_npp,vegn%npp,diag)
  call send_tile_data(id_nep,vegn%nep,diag)
  call send_tile_data(id_litter,vegn%litter,diag)
  call send_tile_data(id_resp, resp, diag)
  call send_tile_data(id_resl, resl, diag)
  call send_tile_data(id_resr, resr, diag)
  call send_tile_data(id_resg, resg, diag)
  call send_tile_data(id_soilt,soilt,diag)
  call send_tile_data(id_theta,theta,diag)
  
end subroutine vegn_carbon_int


! ============================================================================
! updates cohort biomass pools, LAI, SAI, and height using accumulated 
! carbon_gain and bwood_gain
subroutine vegn_growth (vegn)
  type(vegn_tile_type), intent(inout) :: vegn

  ! ---- local vars
  type(vegn_cohort_type), pointer :: cc    ! current cohort
  integer :: i

  do i = 1, vegn%n_cohorts   
     cc => vegn%cohorts(i)

     cc%bwood   = cc%bwood   + cc%bwood_gain
     cc%bliving = cc%bliving + cc%carbon_gain
     
     if(cc%bliving < 0) then
        cc%bwood    = cc%bwood+cc%bliving
        cc%bliving  = 0
        if (cc%bwood < 0) &
             cc%bwood = 0 ! in principle, that's not conserving carbon
     endif
     
     call update_biomass_pools(cc)
     cc%root_density = (cc%br + &
            (cc%bsw+cc%bwood+cc%blv)*(1-agf_bs))*C2B
     cc%Wl_max = spdata(cc%species)%cmc_lai*cc%lai
     cc%Ws_max = spdata(cc%species)%csc_lai*cc%lai
     
     ! reset carbon acculmulation terms
     cc%carbon_gain = 0
     cc%carbon_loss = 0
     cc%bwood_gain  = 0
     if (cc%status == LEAF_ON) then
        cc%leaf_age = cc%leaf_age + 1.0
        ! limit the maximum leaf age by the leaf time span (reciprocal of leaf 
        ! turnover rate alpha) for given species. alpha is in 1/year, factor of
        ! 365 converts the result to days.
        if (spdata(cc%species)%alpha(CMPT_LEAF) > 0) &
             cc%leaf_age = min(cc%leaf_age,365.0/spdata(cc%species)%alpha(CMPT_LEAF))
     endif
  end do

end subroutine vegn_growth


! ============================================================================
subroutine Dsdt(vegn, soil, diag, soilt, theta)
  type(vegn_tile_type), intent(inout) :: vegn
  type(soil_tile_type), intent(inout) :: soil
  type(diag_buff_type), intent(inout) :: diag
  real                , intent(in)    :: soilt ! average soil temperature, deg K 
  real                , intent(in)    :: theta ! average soil moisture

  real :: fast_C_loss(size(soil%fast_soil_C))
  real :: slow_C_loss(size(soil%slow_soil_C))
  real :: A          (size(soil%slow_soil_C)) ! decomp rate reduction due to moisture and temperature
  
  select case (soil_decomp_to_use)
  case(USE_AVE_T_AND_THETA)
      A(:) = A_function(soilt, theta)
  case(USE_LAYER_T_AND_THETA)
      A(:) = A_function(soil%prog(:)%T, soil_theta(soil))
  case default
    call error_mesg('Dsdt','The value of soil_decomp_to_use is invalid. This should never happen. See developer.',FATAL)
  end select
  
  fast_C_loss = soil%fast_soil_C(:)*A*K1*dt_fast_yr;
  slow_C_loss = soil%slow_soil_C(:)*A*K2*dt_fast_yr;
  
  soil%fast_soil_C = soil%fast_soil_C - fast_C_loss;
  soil%slow_soil_C = soil%slow_soil_C - slow_C_loss;

  ! for budget check
  vegn%fsc_out = vegn%fsc_out + sum(fast_C_loss(:));
  vegn%ssc_out = vegn%ssc_out + sum(slow_C_loss(:));

  ! loss of C to atmosphere and leaching
  vegn%rh = sum(fast_C_loss(:)+slow_C_loss(:))/dt_fast_yr;

  ! accumulate decomposition rate reduction for the soil carbon restart output
  soil%asoil_in(:) = soil%asoil_in(:) + A(:)
  ! TODO: arithmetic averaging of A doesn't seem correct; we need to invent something better,
  !       e.g. weight it with the carbon loss, or something like that

  ! ---- diagnostic section
  if (id_fsc>0)         call send_tile_data(id_fsc, sum(soil%fast_soil_C(:)), diag)
  if (id_ssc>0)         call send_tile_data(id_ssc, sum(soil%slow_soil_C(:)), diag)
  if (id_rsoil_fast>0)  call send_tile_data(id_rsoil_fast, sum(fast_C_loss(:))/dt_fast_yr, diag)
  if (id_rsoil_slow>0)  call send_tile_data(id_rsoil_slow, sum(slow_C_loss(:))/dt_fast_yr, diag)
  call send_tile_data(id_rsoil, vegn%rh, diag)
  ! TODO: arithmetic averaging of A doesn't seem correct; we need to invent something better,
  !       e.g. weight it with the carbon loss, or something like that
  if (id_asoil>0) call send_tile_data(id_asoil, sum(A(:))/size(A(:)), diag)

end subroutine Dsdt


! ============================================================================
! The combined reduction in decomposition rate as a funciton of TEMP and MOIST
! Based on CENTURY Parton et al 1993 GBC 7(4):785-809 and Bolker's copy of
! CENTURY code
elemental function A_function(soilt, theta) result(A)
  real :: A                 ! return value, resulting reduction in decomposition rate
  real, intent(in) :: soilt ! effective temperature for soil carbon decomposition
  real, intent(in) :: theta 

  real :: soil_temp; ! temperature of the soil, deg C
  real :: Td; ! rate multiplier due to temp
  real :: Wd; ! rate reduction due to mositure

  ! coefficeints and terms used in temperaturex term
  real :: Topt,Tmax,t1,t2,tshl,tshr;

  soil_temp = soilt-273.16;

  ! EFFECT OF TEMPERATURE
  ! from Bolker's century code
  Tmax=45.0;
  if (soil_temp > Tmax) soil_temp = Tmax;
  Topt=35.0;
  tshr=0.2; tshl=2.63;
  t1=(Tmax-soil_temp)/(Tmax-Topt);
  t2=exp((tshr/tshl)*(1.-t1**tshl));
  Td=t1**tshr*t2;

  if (soil_temp > -10) Td=Td+0.05;
  if (Td > 1.) Td=1.;

  ! EFFECT OF MOISTURE
  ! Linn and Doran, 1984, Soil Sci. Amer. J. 48:1267-1272
  ! This differs from the Century Wd
  ! was modified by slm/ens based on the figures from the above paper 
  !     (not the reported function)

  if(theta <= 0.3) then
     Wd = 0.2;
  else if(theta <= 0.6) then
     Wd = 0.2+0.8*(theta-0.3)/0.3;
  else 
     Wd = exp(2.3*(0.6-theta));
  endif

  A = (Td*Wd); ! the combined (multiplicative) effect of temp and water
               ! on decomposition rates
end function A_function


! ============================================================================
subroutine eddy_npp(cc, tsoil)
  type(vegn_cohort_type), intent(inout) :: cc
  real, intent(in) :: tsoil

  call plant_respiration(cc,tsoil);

  cc%gpp = (cc%An_op - cc%An_cl)*mol_C*cc%lai;
  cc%npp = cc%gpp - cc%resp;

!  if(cc%npp_previous_day > -0.00001/2500.0) then
  if(cc%npp_previous_day > 0) then
     cc%resg = GROWTH_RESP*cc%npp_previous_day;
     cc%npp  = cc%npp  - GROWTH_RESP*cc%npp_previous_day;
     cc%resp = cc%resp + GROWTH_RESP*cc%npp_previous_day;
  else
     cc%resg = 0;
  endif

  ! update, accumulate
  cc%npp_previous_day_tmp = cc%npp_previous_day_tmp + cc%npp; 
end subroutine eddy_npp


! ============================================================================
subroutine plant_respiration(cc, tsoil)
  type(vegn_cohort_type), intent(inout) :: cc
  real, intent(in) :: tsoil
  
  real :: tf,tfs;
  real :: r_leaf, r_vleaf, r_stem, r_root
  
  integer :: sp ! shorthand for cohort species
  sp = cc%species

  tf = exp(3000.0*(1.0/288.16-1.0/cc%prog%Tv));
  tf = tf / ( &
            (1.0+exp(0.4*(5.0-cc%prog%Tv+273.16)))*&
            (1.0+exp(0.4*(cc%prog%Tv - 273.16-45.0)))&
            )

  tfs = exp(3000.0*(1.0/288.16-1.0/tsoil));
  tfs = tfs / ( &
              (1.0+exp(0.4*(5.0-tsoil+273.16)))* &
              (1.0+exp(0.4*(tsoil - 273.16-45.0)))&
              )

  r_leaf = -mol_C*cc%An_cl*cc%lai;
  r_vleaf = spdata(sp)%beta(CMPT_VLEAF)   * cc%blv*tf;
  r_stem  = spdata(sp)%beta(CMPT_SAPWOOD) * cc%bsw*tf;
  r_root  = spdata(sp)%beta(CMPT_ROOT)    * cc%br*tfs;
  
  cc%resp = r_leaf + r_vleaf + r_stem + r_root;
  cc%resl = r_leaf;
  cc%resr = r_root;
end subroutine plant_respiration


! ============================================================================
! calculates prev. day average NPP from accumualted values
subroutine vegn_daily_npp(vegn)
  type(vegn_tile_type), intent(inout) :: vegn

  integer :: n_fast_step;
  integer :: i
  type(vegn_cohort_type), pointer :: cc

  n_fast_step = 1.0/365.0/dt_fast_yr;
  do i = 1, vegn%n_cohorts   
     cc => vegn%cohorts(i)
     vegn%cohorts(i)%npp_previous_day=vegn%cohorts(i)%npp_previous_day_tmp/n_fast_step;
     vegn%cohorts(i)%npp_previous_day_tmp=0.0
  enddo
end subroutine vegn_daily_npp


! =============================================================================
subroutine vegn_phenology(vegn, soil)
  type(vegn_tile_type), intent(inout) :: vegn
  type(soil_tile_type), intent(inout) :: soil
  ! TODO: possibly move soil-related calculations from calling procedure here,
  !       now that we have soil passed as an argument

  ! ---- local vars
  type(vegn_cohort_type), pointer :: cc
  real :: leaf_litter,root_litter;    
  real :: theta_crit; ! critical ratio of average soil water to sat. water
  real :: psi_stress_crit ! critical soil-water-stress index
  real :: wilt ! ratio of wilting to saturated water content
  integer :: i
  
  wilt = soil%w_wilt(1)/soil%pars%vwc_sat
  vegn%litter = 0

  do i = 1,vegn%n_cohorts   
     cc => vegn%cohorts(i)
     
     if(is_watch_point())then
        write(*,*)'####### vegn_phenology #######'
        __DEBUG4__(vegn%theta_av_phen, wilt, spdata(cc%species)%cnst_crit_phen, spdata(cc%species)%fact_crit_phen)
	__DEBUG2__(vegn%psist_av, spdata(cc%species)%psi_stress_crit_phen)
        __DEBUG1__(cc%species)
        __DEBUG2__(vegn%tc_av,spdata(cc%species)%tc_crit)
     endif
     ! if drought-deciduous or cold-deciduous species
     ! temp=10 degrees C gives good growing season pattern        
     ! spp=0 is c3 grass,1 c3 grass,2 deciduous, 3 evergreen
     ! assumption is that no difference between drought and cold deciduous
     cc%status = LEAF_ON; ! set status to indicate no leaf drop
      
     if(cc%species < 4 )then! deciduous species
        ! actually either fact_crit_phen or cnst_crit_phen is zero, enforced
        ! by logic in the vegn_data.F90
        theta_crit = spdata(cc%species)%cnst_crit_phen &
              + wilt*spdata(cc%species)%fact_crit_phen
        theta_crit = max(0.0,min(1.0, theta_crit))
	psi_stress_crit = spdata(cc%species)%psi_stress_crit_phen
        if (      (psi_stress_crit <= 0. .and. vegn%theta_av_phen < theta_crit) &
	     .or. (psi_stress_crit  > 0. .and. vegn%psist_av > psi_stress_crit) &
             .or. (vegn%tc_av < spdata(cc%species)%tc_crit) ) then
           cc%status = LEAF_OFF; ! set status to indicate leaf drop 
           cc%leaf_age = 0;
           
           leaf_litter = (1.0-l_fract)*cc%bl;
           root_litter = (1.0-l_fract)*cc%br;
           
           ! add to patch litter flux terms
           vegn%litter = vegn%litter + leaf_litter + root_litter;
           
           soil%fast_soil_C(1) = soil%fast_soil_C(1) +    fsc_liv *(leaf_litter+root_litter);
           soil%slow_soil_C(1) = soil%slow_soil_C(1) + (1-fsc_liv)*(leaf_litter+root_litter);
	     
           ! soil%fsc_in(1)+=data->fsc_liv*(leaf_litter+root_litter);
           ! soil%ssc_in(1)+=(1.0-data->fsc_liv)*(leaf_litter+root_litter);
           soil%fsc_in(1)  = soil%fsc_in(1)  + leaf_litter+root_litter;
           vegn%veg_out = vegn%veg_out + leaf_litter+root_litter;
           
           cc%blv = cc%blv + l_fract*(cc%bl+cc%br);
           cc%bl  = 0.0;
           cc%br  = 0.0;
           cc%lai = 0.0;
           
           ! update state
           cc%bliving = cc%blv + cc%br + cc%bl + cc%bsw;
           cc%b = cc%bliving + cc%bwood ;
           call update_bio_living_fraction(cc);   
        endif
     endif
  enddo
end subroutine vegn_phenology


! =============================================================================
subroutine vegn_biogeography(vegn)
  type(vegn_tile_type), intent(inout) :: vegn

  ! ---- local vars
  integer :: i

  do i = 1, vegn%n_cohorts   
     call update_species(vegn%cohorts(i), vegn%t_ann, vegn%t_cold, &
          vegn%p_ann*seconds_per_year, vegn%ncm, vegn%landuse)
  enddo
end subroutine

! =============================================================================
! The stuff below comes from she_update.c -- it looks like it belongs here, 
! since it is essentially a part of the carbon integration (update_patch_fast
! is only called immediately after carbon_int in lm3v)
! =============================================================================


! =============================================================================
subroutine update_soil_pools(vegn, soil)
  type(vegn_tile_type), intent(inout) :: vegn
  type(soil_tile_type), intent(inout) :: soil
  
  ! ---- local vars
  real :: delta;

  ! update fsc input rate so that intermediate fsc pool is never
  ! depleted below zero; on the other hand the pool can be only 
  ! depleted, never increased
  vegn%fsc_rate = MAX( 0.0, MIN(vegn%fsc_rate, vegn%fsc_pool/dt_fast_yr));
  delta = vegn%fsc_rate*dt_fast_yr;
  soil%fast_soil_C(1) = soil%fast_soil_C(1) + delta;
  vegn%fsc_pool       = vegn%fsc_pool       - delta;

  ! update ssc input rate so that intermediate ssc pool is never
  ! depleted below zero; on the other hand the pool can be only 
  ! depleted, never increased
  vegn%ssc_rate = MAX(0.0, MIN(vegn%ssc_rate, vegn%ssc_pool/dt_fast_yr));
  delta = vegn%ssc_rate*dt_fast_yr;
  soil%slow_soil_C(1) = soil%slow_soil_C(1) + delta;
  vegn%ssc_pool       = vegn%ssc_pool       - delta;
end subroutine update_soil_pools



end module vegn_dynamics_mod

module land_tile_diag_mod

use mpp_mod,            only : mpp_sum
use time_manager_mod,   only : time_type
use diag_axis_mod,      only : get_axis_length
use diag_manager_mod,   only : register_diag_field, register_static_field, &
     send_data
use diag_util_mod,      only : log_diag_field_info
use fms_mod,            only : write_version_number, error_mesg, string, FATAL

use land_tile_selectors_mod, only : tile_selectors_init, tile_selectors_end, &
     tile_selector_type, register_tile_selector, selector_suffix, &
     get_n_selectors, get_selector
use land_tile_mod,      only : land_tile_type, diag_buff_type, &
     land_tile_list_type, first_elmt, tail_elmt, next_elmt, get_elmt_indices, &
     land_tile_enum_type, operator(/=), current_tile, &
     tile_is_selected
use land_data_mod,      only : lnd
use tile_diag_buff_mod, only : diag_buff_type, realloc_diag_buff

implicit none
private


! ==== public interface ======================================================
public :: tile_diag_init
public :: tile_diag_end

public :: diag_buff_type

public :: register_tiled_diag_field
public :: register_tiled_static_field
public :: add_tiled_diag_field_alias
public :: add_tiled_static_field_alias
public :: send_tile_data
public :: send_tile_data_r0d_fptr, send_tile_data_r1d_fptr
public :: send_tile_data_i0d_fptr

public :: dump_tile_diag_fields

! codes of tile aggregaton operations
public :: OP_AVERAGE, OP_SUM

interface send_tile_data
   module procedure send_tile_data_0d
   module procedure send_tile_data_1d
end interface
! ==== end of public interface ===============================================


! ==== module constants ======================================================
character(len=*), parameter :: &
     module_name = 'lan_tile_diag_mod', &
     version     = '$Id: land_tile_diag.F90,v 20.0 2013/12/13 23:29:55 fms Exp $', &
     tagname     = '$Name: tikal $'

integer, parameter :: INIT_FIELDS_SIZE     = 1     ! initial size of the fields array
integer, parameter :: BASE_TILED_FIELD_ID  = 65536 ! base value for tiled field 
! ids, to distinguish them from regular diagnostic fields. All IDs of tiled
! (that is, registered by register_*tiled_field functions are larger than 
! BASE_TILED_FIELD_ID)
integer, parameter :: MIN_DIAG_BUFFER_SIZE = 1     ! min size of the per-tile diagnostic buffer
! operations used for tile data aggregation
integer, parameter :: OP_AVERAGE = 0 ! weighted average of tile values
integer, parameter :: OP_SUM     = 1 ! sum of all tile values


! ==== derived types =========================================================
type :: tiled_diag_field_type
   integer, pointer :: ids(:) => NULL()
   integer :: offset ! offset of the field data in the buffer
   integer :: size   ! size of the field data in the per-tile buffers
   integer :: op     ! aggregation operation
   logical :: static ! if true, the diag field is static
   integer :: n_sends! number of data points sent to the field since last dump
   integer :: alias = 0 ! ID of the first alias in the chain
   character(32) :: module,name ! for debugging purposes only
end type tiled_diag_field_type


! ==== module data ===========================================================
logical :: module_is_initialized = .false.

! list of registered fields
type(tiled_diag_field_type), pointer :: fields(:) => NULL()
integer :: n_fields       = 0 ! current number of diag fields
integer :: current_offset = 1 ! current total size of the diag fields per tile



contains



! ============================================================================
subroutine tile_diag_init()

  if (module_is_initialized) return

  module_is_initialized = .true.
  call write_version_number(version, tagname)

  ! initialize diag selectors
  call tile_selectors_init()
  call register_tile_selector('')

  ! initailze global data
  allocate(fields(INIT_FIELDS_SIZE))
  n_fields       = 0
  current_offset = 1

end subroutine tile_diag_init



! ============================================================================
subroutine tile_diag_end()

  integer :: i

  ! deallocate global data
  do i = 1, n_fields
     deallocate(fields(i)%ids)
  end do
  deallocate(fields)

  ! destroy selectors
  call tile_selectors_end()

  module_is_initialized = .false.

end subroutine tile_diag_end


! ============================================================================
function register_tiled_diag_field(module_name, field_name, axes, init_time, &
     long_name, units, missing_value, range, op) result (id)

  integer :: id

  character(len=*), intent(in) :: module_name
  character(len=*), intent(in) :: field_name
  integer,          intent(in) :: axes(:)
  type(time_type),  intent(in) :: init_time
  character(len=*), intent(in), optional :: long_name
  character(len=*), intent(in), optional :: units
  real,             intent(in), optional :: missing_value
  real,             intent(in), optional :: range(2)
  integer,          intent(in), optional :: op ! aggregation operation code
  
  id = reg_field(.false., module_name, field_name, init_time, axes, long_name, &
         units, missing_value, range, op=op)

end function

! ============================================================================
function register_tiled_static_field(module_name, field_name, axes, &
     long_name, units, missing_value, range, require, op) result (id)

  integer :: id

  character(len=*), intent(in) :: module_name
  character(len=*), intent(in) :: field_name
  integer,          intent(in) :: axes(:)
  character(len=*), intent(in), optional :: long_name
  character(len=*), intent(in), optional :: units
  real,             intent(in), optional :: missing_value
  real,             intent(in), optional :: range(2)
  logical,          intent(in), optional :: require
  integer,          intent(in), optional :: op ! aggregation operation code
  
  ! --- local vars
  type(time_type) :: init_time

  id = reg_field(.true., module_name, field_name, init_time, axes, long_name, &
         units, missing_value, range, require, op)

end function


! ============================================================================
subroutine add_tiled_static_field_alias(id0, module_name, field_name, axes, &
     long_name, units, missing_value, range, op)
  integer,          intent(inout) :: id0 ! id of the original diag field on input;
   ! if negative then it may be replaced with the alias id on output
  character(len=*), intent(in) :: module_name
  character(len=*), intent(in) :: field_name
  integer,          intent(in) :: axes(:)
  character(len=*), intent(in), optional :: long_name
  character(len=*), intent(in), optional :: units
  real,             intent(in), optional :: missing_value
  real,             intent(in), optional :: range(2)
  integer,          intent(in), optional :: op ! aggregation operation code

  ! --- local vars
  type(time_type) :: init_time

  call reg_field_alias(id0, .true., module_name, field_name, axes, init_time, &
     long_name, units, missing_value, range, op)
end subroutine


! ============================================================================
subroutine add_tiled_diag_field_alias(id0, module_name, field_name, axes, init_time, &
     long_name, units, missing_value, range, op)
  integer,          intent(inout) :: id0 ! id of the original diag field on input;
   ! if negative then it may be replaced with the alias id on output
  character(len=*), intent(in) :: module_name
  character(len=*), intent(in) :: field_name
  integer,          intent(in) :: axes(:)
  type(time_type),  intent(in) :: init_time
  character(len=*), intent(in), optional :: long_name
  character(len=*), intent(in), optional :: units
  real,             intent(in), optional :: missing_value
  real,             intent(in), optional :: range(2)
  integer,          intent(in), optional :: op ! aggregation operation code

  call reg_field_alias(id0, .false., module_name, field_name, axes, init_time, &
     long_name, units, missing_value, range, op)
end subroutine

! ============================================================================
subroutine reg_field_alias(id0, static, module_name, field_name, axes, init_time, &
     long_name, units, missing_value, range, op)


  integer,          intent(inout) :: id0 ! id of the original diag field on input;
  logical,          intent(in) :: static
   ! if negative then it may be replaced with the alias id on output
  character(len=*), intent(in) :: module_name
  character(len=*), intent(in) :: field_name
  integer,          intent(in) :: axes(:)
  type(time_type),  intent(in) :: init_time
  character(len=*), intent(in), optional :: long_name
  character(len=*), intent(in), optional :: units
  real,             intent(in), optional :: missing_value
  real,             intent(in), optional :: range(2)
  integer,          intent(in), optional :: op ! aggregation operation code
  
  ! local vars
  integer :: id1
  integer :: ifld0, ifld1
  
  if (id0>0) then
    ifld0 = id0-BASE_TILED_FIELD_ID
    if (ifld0<1.or.ifld0>n_fields) &
       call error_mesg(module_name, 'incorrect index ifld0 '//string(ifld0)//&
                    ' in definition of tiled diag field alias "'//&
                    trim(module_name)//'/'//trim(field_name)//'"', FATAL)
    id1 = reg_field(static, module_name, field_name, init_time, axes, long_name, &
          units, missing_value, range, op=op, offset=fields(ifld0)%offset)
    if (id1>0) then
      ifld1 = id1-BASE_TILED_FIELD_ID
      ! check that sizes of the fields are identical
      if (fields(ifld0)%size/=fields(ifld1)%size) &
         call error_mesg(module_name, 'sizes of diag field "'//           &
           trim(fields(ifld0)%module)//'/'//trim(fields(ifld0)%name)//    &
           '" and its alias "'//trim(module_name)//'/'//trim(field_name)//&
           '" are not the same', FATAL)
      ! check that "static" status of the fields is the same
      if(fields(ifld0)%static.and..not.fields(ifld1)%static) &
         call error_mesg(module_name,                                     &
           'attempt to register non-static alias"'//                      &
           trim(module_name)//'/'//trim(field_name)//                     &
           '" of static field "'//                                        &
           trim(fields(ifld0)%module)//'/'//trim(fields(ifld0)%name)//'"',&
           FATAL)
      if(.not.fields(ifld0)%static.and.fields(ifld1)%static) &
         call error_mesg(module_name,                                     &
           'attempt to register static alias"'//                          &
           trim(module_name)//'/'//trim(field_name)//                     &
           '" of non-static field "'//                                    &
           trim(fields(ifld0)%module)//'/'//trim(fields(ifld0)%name)//'"',&
           FATAL)

      ! copy alias field from the original into the alias, to preserve the chain
      fields(ifld1)%alias = fields(ifld0)%alias
      ! update alias field in the head of alias chain
      fields(ifld0)%alias = ifld1
    endif
  else
    ! the "main" field has not been registered, so simply redister the alias
    ! as a diag field
    id0 = reg_field(static, module_name, field_name, init_time, axes, long_name, &
          units, missing_value, range, op=op)
  endif
end subroutine

! ============================================================================
! provides unified interface for registering a diagnostic field with full set
! of selectors
function reg_field(static, module_name, field_name, init_time, axes, &
     long_name, units, missing_value, range, require, op, offset) result(id)
 
  integer :: id

  logical,          intent(in) :: static
  character(len=*), intent(in) :: module_name
  character(len=*), intent(in) :: field_name
  integer,          intent(in) :: axes(:)
  type(time_type),  intent(in) :: init_time
  character(len=*), intent(in), optional :: long_name
  character(len=*), intent(in), optional :: units
  real,             intent(in), optional :: missing_value
  real,             intent(in), optional :: range(2)
  logical,          intent(in), optional :: require
  integer,          intent(in), optional :: op
  integer,          intent(in), optional :: offset

  ! ---- local vars
  integer, pointer :: diag_ids(:) ! ids returned by FMS diag manager for each selector
  integer :: i
  integer :: isel    ! selector iterator
  integer :: n_selectors ! number of registered diagnostic tile selectors
  type(tiled_diag_field_type), pointer :: new_fields(:)
  type(tile_selector_type) :: sel
  ! ---- global vars: n_fields, fields, current_offset -- all used and updated

  ! log diagnostic field information
  call log_diag_field_info ( module_name, trim(field_name), axes, long_name, units,&
                             missing_value, range, dynamic=.not.static )
  ! go through all possible selectors and try to register a diagnostic field 
  ! with the name derived from field name and selector; if any of the 
  ! registrations succeeds, return a tiled field id, otherwise return 0.
  ! Note that by design one of the selectors have empty name and selects all
  ! the tiles.
  id = 0
  n_selectors = get_n_selectors()
  allocate(diag_ids(n_selectors))
  
  do isel = 1, n_selectors
     ! try to register field+selector pair with FMS diagnostics manager
     sel = get_selector(isel)
     diag_ids(isel) = reg_field_set(static, sel, module_name, field_name, axes, &
          init_time, long_name, units, missing_value, range, require)

  enddo
  
  if(any(diag_ids>0)) then
     ! if any of the field+selector pairs was found for this field, an entry
     ! must be added to the table of tile diagnostic fields

     ! if there is not enough slots in the field table to add another one,
     ! allocate more space
     if(n_fields>=size(fields)) then
        allocate(new_fields(max(2*n_fields,1)))
        new_fields(1:n_fields) = fields(1:n_fields)
        deallocate(fields)
        fields => new_fields
     endif
     ! add the current field to the field table
     n_fields = n_fields+1
     id       = n_fields
     ! set the array of FMS diagnostic field IDs for each selector
     fields(id)%ids => diag_ids
     ! set the field offset in the diagnostic buffers
     if (present(offset)) then
        fields(id)%offset = offset
     else
        fields(id)%offset = current_offset
     endif  
     ! calculate field size per tile and increment current offset to
     ! reserve space in per-tile buffers. We assume that the first two axes 
     ! are horizontal coordinates, so their size is not taken into account
     fields(id)%size = 1
     do i = 3, size(axes(:))
        fields(id)%size = fields(id)%size * get_axis_length(axes(i))
     enddo
     ! if offset is present in the list of the arguments, it means that we don't
     ! want to increase the current_offset -- this is an alias field
     if (.not.present(offset)) &
        current_offset = current_offset + fields(id)%size
     ! store the code of the requested tile aggregation operation
     if(present(op)) then
        fields(id)%op = op
     else
        fields(id)%op = OP_AVERAGE
     endif
     ! store the static field flag
     fields(id)%static = static
     ! zero out the number of data points ent to the field
     fields(id)%n_sends = 0
     ! store the name of the field -- for now, only to be able to see what it is 
     ! in the debugger
     fields(id)%module=module_name 
     fields(id)%name=field_name
     ! increment the field id by some (large) number to distinguish it from the 
     ! IDs of regular FMS diagnostic fields
     id = id + BASE_TILED_FIELD_ID
  else
     deallocate(diag_ids)
  endif

end function


! ============================================================================
! provides unified interface for registering a diagnostic field with a given
! selector, whether static or time-dependent
function reg_field_set(static, sel, module_name, field_name, axes, init_time, &
     long_name, units, missing_value, range, require) result (id)

  integer :: id 

  logical,          intent(in) :: static
  type(tile_selector_type), intent(in) :: sel
  character(len=*), intent(in) :: module_name
  character(len=*), intent(in) :: field_name
  integer,          intent(in) :: axes(:)
  type(time_type),  intent(in) :: init_time
  character(len=*), intent(in), optional :: long_name
  character(len=*), intent(in), optional :: units
  real,             intent(in), optional :: missing_value
  real,             intent(in), optional :: range(2)
  logical,          intent(in), optional :: require

  character(len=128) :: fname
  character(len=128) :: lname

  ! form field name as concatenation of name of the field and selector suffix
  fname = trim(field_name)//trim(selector_suffix(sel))
  ! form long name as concatenation of specified long name (if present) and
  ! selector long name
  lname = ''
  if(present(long_name)) lname=long_name
  if(trim(sel%long_name)/='') &
     lname = trim(lname)//' ('//trim(sel%long_name)//')'

  ! try registering diagnostic field with FMS diagnostic manager.
  if (static) then
     id = register_static_field ( module_name, fname,   &
          axes, lname, units, missing_value, range, require, do_not_log=.TRUE. )
  else
     id = register_diag_field ( module_name,  fname,   &
          axes, init_time, lname, units, missing_value, range, &
          mask_variant=.true., do_not_log=.TRUE. )
  endif

end function


! ============================================================================
subroutine send_tile_data_0d(id, x, buffer)
  integer, intent(in) :: id
  real   , intent(in) :: x
  type(diag_buff_type), intent(inout) :: buffer
  
  integer :: idx, i

  if (id <= 0) return

  ! reallocate diagnostic buffer according to the current number and size of 
  ! tiled diag fields
  call realloc_diag_buff(buffer,current_offset)

  ! calculate offset for the current diagnostic field in the buffer
  i = id - BASE_TILED_FIELD_ID 
  idx = fields(i)%offset
  
  ! store the diagnostic data
  buffer%data(idx) = x
  buffer%mask(idx) = .TRUE.

  ! increment sent data counter
  fields(i)%n_sends = fields(i)%n_sends + 1
  ! increment sent data counter in all aliases
  do while(fields(i)%alias>0)
    i=fields(i)%alias
    fields(i)%n_sends = fields(i)%n_sends + 1
  enddo
end subroutine

! ============================================================================
subroutine send_tile_data_1d(id, x, buffer)
  integer, intent(in) :: id
  real   , intent(in) :: x(:)
  type(diag_buff_type), intent(inout) :: buffer

  integer :: is, ie, i
  if (id <= 0) return

  ! reallocate diagnostic buffer according to the current number and size of 
  ! tiled diag fields
  call realloc_diag_buff(buffer, current_offset)
  
  ! calculate offset for the current diagnostic field in the buffer
  i = id - BASE_TILED_FIELD_ID ! index in the array of fields
  is = fields(i)%offset ; ie = is+fields(i)%size-1

  ! store the data
  buffer%data(is:ie) = x(:)
  buffer%mask(is:ie) = .TRUE.

  ! increment sent data counter
  fields(i)%n_sends = fields(i)%n_sends + 1
  ! increment sent data counter in all aliases
  do while(fields(i)%alias>0)
    i=fields(i)%alias
    fields(i)%n_sends = fields(i)%n_sends + 1
  enddo
end subroutine

! NOTE: 2-d fields can be handled similarly to 1-d with reshape

! ============================================================================
subroutine send_tile_data_r0d_fptr(id, tile_map, fptr)
  integer, intent(in) :: id
  type(land_tile_list_type), intent(inout) :: tile_map(:,:)
  ! subroutine returning the pointer to the tile data
  interface
     subroutine fptr(tile, ptr)
       use land_tile_mod, only : land_tile_type
       type(land_tile_type), pointer :: tile ! input
       real                , pointer :: ptr  ! returned pointer to the data
     end subroutine fptr 
  end interface

  type(land_tile_enum_type)     :: te,ce   ! tail and current tile list elements
  type(land_tile_type), pointer :: tileptr ! pointer to tile   
  real                , pointer :: ptr     ! pointer to the data element within a tile

  if(id <= 0) return
  ce = first_elmt( tile_map )
  te = tail_elmt ( tile_map )
  do while(ce /= te)
     tileptr => current_tile(ce)
     call fptr(tileptr,ptr)
     if(associated(ptr)) call send_tile_data(id,ptr,tileptr%diag)
     ce=next_elmt(ce)
  enddo
end subroutine


! ============================================================================
subroutine send_tile_data_r1d_fptr(id, tile_map, fptr)
  integer, intent(in) :: id
  type(land_tile_list_type), intent(inout) :: tile_map(:,:)
  ! subroutine returning the pointer to the tile data
  interface
     subroutine fptr(tile, ptr)
       use land_tile_mod, only : land_tile_type
       type(land_tile_type), pointer :: tile ! input
       real                , pointer :: ptr(:)  ! returned pointer to the data
     end subroutine fptr 
  end interface

  type(land_tile_enum_type)     :: te,ce   ! tail and current tile list elements
  type(land_tile_type), pointer :: tileptr ! pointer to tile   
  real                , pointer :: ptr(:)     ! pointer to the data element within a tile

  if(id <= 0) return
  ce = first_elmt( tile_map )
  te = tail_elmt ( tile_map )
  do while(ce /= te)
     tileptr => current_tile(ce)
     call fptr(tileptr,ptr)
     if(associated(ptr)) call send_tile_data(id,ptr,tileptr%diag)
     ce=next_elmt(ce)
  enddo
end subroutine


! ============================================================================
subroutine send_tile_data_i0d_fptr(id, tile_map, fptr)
  integer, intent(in) :: id
  type(land_tile_list_type), intent(inout) :: tile_map(:,:)
  ! subroutine returning the pointer to the tile data
  interface
     subroutine fptr(tile, ptr)
       use land_tile_mod, only : land_tile_type
       type(land_tile_type), pointer :: tile ! input
       integer             , pointer :: ptr  ! returned pointer to the data
     end subroutine fptr 
  end interface

  type(land_tile_enum_type)     :: te,ce   ! tail and current tile list elements
  type(land_tile_type), pointer :: tileptr ! pointer to tile   
  integer             , pointer :: ptr     ! pointer to the data element within a tile

  if(id <= 0) return
  ce = first_elmt( tile_map )
  te = tail_elmt ( tile_map )
  do while(ce /= te)
     tileptr => current_tile(ce)
     call fptr(tileptr,ptr)
     if(associated(ptr)) call send_tile_data(id,real(ptr),tileptr%diag)
     ce=next_elmt(ce)
  enddo
end subroutine


! ============================================================================
subroutine dump_tile_diag_fields(tiles, time)
  type(land_tile_list_type), intent(in) :: tiles(:,:) ! 
  type(time_type)          , intent(in) :: time       ! current time

  ! ---- local vars
  integer :: ifld ! field number
  integer :: isel ! selector number
  type(land_tile_enum_type)     :: ce, te
  type(land_tile_type), pointer :: tile
  integer :: total_n_sends(n_fields)
  ! ---- local static variables -- saved between calls
  logical :: first_dump = .TRUE.

  total_n_sends(:) = fields(1:n_fields)%n_sends
  call mpp_sum(total_n_sends, n_fields, pelist=lnd%pelist)

!$OMP parallel do schedule(dynamic) default(shared) private(ifld,isel)
  do ifld = 1, n_fields
     if (total_n_sends(ifld) == 0) cycle ! no data to send 
     do isel = 1, get_n_selectors()
        if (fields(ifld)%ids(isel) <= 0) cycle
        call dump_diag_field_with_sel ( fields(ifld)%ids(isel), tiles, &
             fields(ifld), get_selector(isel), time )
     enddo
  enddo
  ! zero out the number of data points sent to the field 
  fields(1:n_fields)%n_sends=0

  ! all the data are sent to the output, so set the data presence tag to FALSE 
  ! in all diag buffers in preparation for the next time step
  ce = first_elmt(tiles)
  te = tail_elmt (tiles)
  do while(ce /= te)
    tile => current_tile(ce)       ! get the pointer to the current tile
    tile%diag%mask(:) = .FALSE.
    ce = next_elmt(ce)            ! move to the next position
  enddo
  ! reset the first_dump flag
  first_dump = .FALSE.

end subroutine

! ============================================================================
subroutine dump_diag_field_with_sel(id, tiles, field, sel, time)
  integer :: id
  type(land_tile_list_type),   intent(in) :: tiles(:,:)
  type(tiled_diag_field_type), intent(in) :: field
  type(tile_selector_type)   , intent(in) :: sel
  type(time_type)            , intent(in) :: time ! current time
   
  ! ---- local vars
  integer :: i,j ! iterators
  integer :: is,ie,js,je,ks,ke ! array boundaries
  logical :: used ! value returned from send_data (ignored)
  real, allocatable :: buffer(:,:,:), weight(:,:,:)
  type(land_tile_enum_type)     :: ce, te
  type(land_tile_type), pointer :: tile
  
  ! calculate array boundaries
  is = lbound(tiles,1); ie = ubound(tiles,1)
  js = lbound(tiles,2); je = ubound(tiles,2)
  ks = field%offset   ; ke = field%offset + field%size - 1
  
  ! allocate and initialize temporary buffers
  allocate(buffer(is:ie,js:je,ks:ke), weight(is:ie,js:je,ks:ke))
  buffer(:,:,:) = 0.0
  weight(:,:,:) = 0.0
  
  ! accumulate data
  ce = first_elmt(tiles, is=is, js=js)
  te = tail_elmt (tiles)
  do while(ce /= te)
    tile => current_tile(ce)      ! get the pointer to current tile
    call get_elmt_indices(ce,i,j) ! get the indices of current tile
    ce = next_elmt(ce)           ! move to the next position
    
    if ( size(tile%diag%data) < ke )       cycle ! do nothing if there is no data in the buffer
    if ( .not.tile_is_selected(tile,sel) ) cycle ! do nothing if tile is not selected
    select case (field%op)
    case (OP_AVERAGE)
       where(tile%diag%mask(ks:ke)) 
          buffer(i,j,:) = buffer(i,j,:) + tile%diag%data(ks:ke)*tile%frac
          weight(i,j,:) = weight(i,j,:) + tile%frac
       end where
    case (OP_SUM)
       where(tile%diag%mask(ks:ke)) 
          buffer(i,j,:) = buffer(i,j,:) + tile%diag%data(ks:ke)
          weight(i,j,:) = 1
       end where
    end select
  enddo

  ! normalize accumulated data
  where (weight>0) buffer=buffer/weight
  
  ! send diag field
  used = send_data ( id, buffer, time, mask=weight>0 )   

  ! clean up temporary data
  deallocate(buffer,weight)

end subroutine


end module land_tile_diag_mod

!FDOC_TAG_GFDL
                module original_fms_rad_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   
! </CONTACT>
! <REVIEWER EMAIL="">
!   
! </REVIEWER>
! <OVERVIEW>
!   
! </OVERVIEW>
! <DESCRIPTION>
!   
! </DESCRIPTION>
!


!-----------------------------------------------------------------------
!                 radiation interface module 
!-----------------------------------------------------------------------

use           mcm_lw_mod, only: mcm_lw_init

use    mcm_sw_driver_mod, only: mcm_sw_driver_init

use            fsrad_mod, only: rdparm_init, fsrad, co2_data

use           clouds_mod, only: clouds, clouds_init, clouds_end

use     time_manager_mod, only: time_type

use              mpp_mod, only: input_nml_file
use              fms_mod, only: fms_init, FATAL, &
                                close_file, &
                                open_namelist_file,    &
                                check_nml_error, file_exist,       &
                                error_mesg, &
                                mpp_pe, mpp_root_pe, &
                                write_version_number

use    rad_utilities_mod, only: rad_utilities_init, &
                                radiative_gases_type, &
                                cldrad_properties_type, &
                                cld_specification_type, &
                                astronomy_type, &
                                atmos_input_type, &
                                surface_type, &
                                Sw_control, &
                                rad_output_type, &
                                fsrad_output_type

implicit none 
private 

!----------- public interfaces in this module -----------------------

public    original_fms_rad_init, original_fms_rad_end, original_fms_rad

!-----------------------------------------------------------------------
!------------ version number for this module ---------------------------
character(len=128) :: version = '$Id: original_fms_rad.F90,v 19.0 2012/01/06 20:20:49 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!   ---- list of restart versions readable by this module ----
!   (sorry, but restart version 1 will not be readable by this module)
      integer, dimension(2) :: restart_versions = (/ 2, 3 /)
!-----------------------------------------------------------------------

     logical :: module_is_initialized = .false.

!-----------------------------------------------------------------------
!   the following code converts rvco2, the volume mixing ratio of co2
!   (used by lwrad) into rco2, the mass mixing ratio (used by swrad).

!   real, parameter :: ratco2mw=1.519449738  ! unused variable (pjp)

!   real, parameter :: rvco2 = 3.3e-4        ! unused variable (pjp)
!   real, parameter :: rco2 = rvco2*ratco2mw ! unused variable (pjp)


!--------- flags -------------------------------------------------------

    logical ::  do_rad
    logical ::  use_rad_date

!-----------------------------------------------------------------------
!  ------- allocatable global data saved by this module -------
!
!   tdt_rad      = radiative (sw + lw) heating rate
!   flux_sw_surf = net (down-up) sw flux at surface
!   flux_lw_surf = downward lw flux at surface
!   coszen_angle = cosine of the zenith angle 
!                  (used for the last radiation calculation)

    type(rad_output_type),save          ::  Rad_output
    real, allocatable, dimension(:,:)   ::  solar_save

!   real, allocatable, dimension(:,:,:) :: tdt_rad
!   real, allocatable, dimension(:,:)   :: flux_sw_surf, &
!                                          flux_lw_surf, &
!                                          coszen_angle, &
!                                          solar_save, &
!                                          fracday

!-----------------------------------------------------------------------
!   ------------------- time step constant --------------------------
!
!   rad_alarm     = time interval until the next radiation calculation
!                   (integer in seconds)
!   rad_time_step = radiation time step (integer in seconds)
!   total_pts = number of grid boxes to be processed every time step
!               (note: all grid boxes must be processed every time step)
!   num_pts   = counter for current number of grid boxes processed
!             (when num_pts=0 or num_pts=total_pts certain things happen)

           integer :: num_pts, total_pts
!          integer :: rad_alarm, rad_time_step, old_time_step
           integer :: rad_alarm, rad_time_step

!-----------------------------------------------------------------------
!------- private allocatable array for time averaged input data --------

      real, allocatable, dimension(:,:,:)   :: psum, tsum, qsum
      real, allocatable, dimension(:,:)     :: asum, csum, ssum,   &
                                               fsum, rrsum
   integer, allocatable, dimension(:,:)     :: nsum
      real, allocatable, dimension(:,:,:)   :: gas_component_sum
      real, allocatable, dimension(:,:,:,:) :: cld_component_sum

!-----------------------------------------------------------------------
!-------------------- namelist -----------------------------------------
!
!   dt_rad  =  radiative time step in seconds
!
!   offset  =  offset for radiative time step (in seconds) 
!              note if offset=1 radition will be done on the first
!              time step after t=0, dt_rad, 2*dt_rad, etc.
!              for now do not change this value

!! the following not needed as of 11-13-01 :
! NOTE:  when reading vers = 1 sea_esf_rad.resfile, offset MUST be < the
!        model timestep
!! end of not needed
!
!   solar_constant = solar constant in watts/m2
!
!   rad_date       = fixed date (year,month,day,hour,min,sec)
!                    for radiation (solar info, ozone, clouds)
!
!   co2std = standard co2 vol. mixing ratio (either 300 or 330 ppmv)
!
!   ratio  = co2 vol. mixing ratio in units of the standard vol.
!            mixing ratio (must lie between 0.5 and 4.0)
!   rsd (repeat same day) : call radiation for the specified rad_date,
!                           running through the diurnal cycle

!  integer :: dt_rad=43200, offset=1
!  logical ::                                         &
!             do_clear_sky_diag=.false., do_average=.false., &
!      do_average_gases = .false., do_average_clouds=.false.
!  logical :: rsd=.false.
!!!   real :: solar_constant = 1.96  !(1367.44w/m2)
      real :: solar_constant = 1365.
!  integer, dimension(6) :: rad_date = (/ 0, 0, 0, 0, 0, 0 /)
      logical :: do_mcm_radiation=.false.
      real :: co2std = 330., ratio = 1.0
!     integer :: jpt = -35, ipt = -35
       real :: lat_diag = -1000.
       real :: long_diag = -1000.
!     logical :: calc_hemi_integrals = .false.
!     logical :: renormalize_sw_fluxes=.false.
!     logical :: do_bounds_chk        =.false.

! character(len=24) :: zenith_spec = '      '
!  character(len=16)    :: rad_step_physics='default'

!logical         :: all_column_radiation = .true.
!logical         :: all_level_radiation = .true.
!integer         :: topmost_radiation_level=-99

namelist /original_fms_rad_nml/ &
!                               offset, do_average, &
!                               do_average_gases, do_average_clouds, &
!                               do_clear_sky_diag,          &
!                               zenith_spec,  &
!                               rad_step_physics, &
!                               calc_hemi_integrals, &
                                lat_diag, long_diag, &
!                               renormalize_sw_fluxes, &
!                               solar_constant, rad_date,   &
                                solar_constant,             &
!                               co2std, ratio, jpt, ipt, &
                                co2std, ratio, &
!                               do_bounds_chk, &
!  all_level_radiation, &
!  topmost_radiation_level, &
!  all_column_radiation, &
!                               rsd
                                do_mcm_radiation

!-----------------------------------------------------------------------
!-------------------- diagnostics fields -------------------------------

integer :: id_alb_sfc, id_coszen

integer, dimension(2) :: id_tdt_sw,   id_tdt_lw,  &
                         id_swdn_toa, id_swup_toa, id_olr, &
                         id_swup_sfc, id_swdn_sfc,         &
                         id_lwup_sfc, id_lwdn_sfc

!character(len=9), parameter :: mod_name = 'radiation'
character(len=16), parameter :: mod_name = 'radiation'

real :: missing_value = -999.
logical  :: do_sea_esf_rad
logical  :: do_clear_sky_pass

!-------------------------------------------------------------------- 
!   list of restart versions readable by this module ----
!-------------------------------------------------------------------- 
integer, dimension(2) :: restart_versions_sea = (/ 2, 3 /)

!--------------------------------------------------------------------
!   tdt_rad = the current radiative (sw + lw) heating rate
!--------------------------------------------------------------------

!---------------------------------------------------------------------
! diagnostics field informations 
!---------------------------------------------------------------------
integer ::             id_cosz, id_fracday 

logical   :: do_diurnal, do_annual, do_daily_mean

integer            ::  id, jd, kmin, kmax
integer            ::  ipgl, jpgl
integer            ::  vers
integer            ::  ksrad, kerad ! vertical indices on radiation grid
                                    ! ksrad ==1

integer            ::  ks, ke ! vertical indices in model grid coords
                              !  ks is topmost_radiation_level
integer            ::  iomsgs
real               ::  rh2o_lower_limit_orig=3.0E-06
real               ::  rh2o_lower_limit_seaesf=2.0E-07
real               ::  rh2o_lower_limit

     integer :: israd, ierad, jsrad, jerad

!---------------------------------------------------------------------
!---------------------------------------------------------------------

                         contains

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!####################################################################

! <SUBROUTINE NAME="original_fms_rad_init">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call original_fms_rad_init
!  </TEMPLATE>
! </SUBROUTINE>
!
   subroutine original_fms_rad_init ( lonb, latb, pref, axes, Time , &
!      co2std, ratio, kmax,  &
!                     kmax,  &
                      kmax)
!      lat_diag, long_diag, ipgl, jpgl)
!                           ipgl, jpgl)

!-----------------------------------------------------------------------
           integer, intent(in)  :: kmax
!   real, intent(in) :: co2std, ratio
           real, intent(in), dimension(:,:) :: lonb, latb
           real, intent(in), dimension(:,:) :: pref
        integer, intent(in), dimension(4)   :: axes
type(time_type), intent(in)                 :: Time
!real, intent(inout) :: lat_diag, long_diag
!integer, intent(out) :: ipgl, jpgl
!-----------------------------------------------------------------------
      integer :: unit, io, ierr


!     character(len=4) :: chvers

      real, dimension(size (lonb,1)-1) :: idiff
      real, dimension(size (latb,2)-1) :: jdiff
      integer :: i, j, minindx
      real  :: mindiff
      integer :: id, jd

      if(module_is_initialized) return
      call fms_init
      call rad_utilities_init

!---------------------------------------------------------------------
!    read namelist.
!---------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=original_fms_rad_nml, iostat=io)
      ierr = check_nml_error(io,'original_fms_rad_nml')
#else   
      if ( file_exist('input.nml')) then
        unit = open_namelist_file ()
        ierr=1; do while (ierr /= 0)
          read  (unit, nml=original_fms_rad_nml, iostat=io, end=10)
          ierr = check_nml_error(io,'original_fms_rad_nml')
        enddo
  10    call close_file (unit)
      endif
#endif

!---------------------------------------------------------------------
!    write namelist to logfile.
!---------------------------------------------------------------------
      if ( mpp_pe() == mpp_root_pe() ) then
        call write_version_number(version, tagname)
        write (unit, nml=original_fms_rad_nml)
      endif


    jd = size(latb,2)-1
    id = size(lonb,1)-1
    
!--------------------------------------------------------------------
!  define location of radiation diagnostics column, if present
!--------------------------------------------------------------------

     if (lat_diag /= -1000. .and. long_diag /= -1000.) then
       if ( (lat_diag < -90. .or. lat_diag > 90.) .or.  &
           (long_diag <    0. .or. long_diag > 360.) ) then 
          call error_mesg ('original_fms_rad_mod', & 
       ' bad values specified for lat_diag or long_diag', FATAL) 
       endif
       
!      jd = size(latb,2)-1
!      id = size(lonb,1) - 1
       lat_diag = lat_diag*4.0*atan(1.0)/180.0
       long_diag = long_diag*4.0*atan(1.0)/180.0
       if (  (lat_diag >= latb(1,1) .and. lat_diag <= latb(1,jd+1))   .and. &
          (long_diag >= lonb(1,1) .and. long_diag <= lonb(id+1,1))  ) then
         do j=1,jd
           jdiff(j) = abs ( 0.5*(latb(1,j)+latb(1,j+1)) - lat_diag)  
         end do
          mindiff = 10.0
          minindx = 1
         do j=1,jd
          if (jdiff(j) .lt. mindiff) then
            mindiff = jdiff(j)
            minindx = j
          endif 
          end do
          jpgl = minindx
         do i=1,id
           idiff(i) = abs ( 0.5*(lonb(i,1)+lonb(i+1,1)) - long_diag)  
         end do
          mindiff = 10.0
          minindx = 1
         do i=1,id
          if (idiff(i) .lt. mindiff) then
            mindiff = idiff(i)
            minindx = i
          endif 
          end do
          ipgl = minindx
         else
            jpgl = 0  
            ipgl = 0  
         endif
         else
            jpgl = 0  
            ipgl = 0  
         endif

!        print *,  get_my_pe() , ipgl, jpgl

!-----------------------------------------------------------------------

         call rdparm_init (kmax)

         if(do_mcm_radiation) then
           call mcm_lw_init (id,jd,kmax)
           call mcm_sw_driver_init(kmax)
         else
           call co2_data (co2std, ratio, pref)
         endif

         call clouds_init ( lonb, latb, axes, Time )

         module_is_initialized = .true.

   end subroutine original_fms_rad_init

!#######################################################################

! <SUBROUTINE NAME="original_fms_rad_end">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call original_fms_rad_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine original_fms_rad_end

!   --- terminate other modules ---

if(.not.module_is_initialized) return
 
     call clouds_end

!-----------------------------------------------------------------------
module_is_initialized = .false.

end subroutine original_fms_rad_end
      
!###################################################################

!subroutine original_fms_rad (is, ie, js, je, kerad, ipgl, jpgl,   &
!subroutine original_fms_rad (lat_in, lon_in, is, ie, js, je, kerad,   &
!subroutine original_fms_rad (is, ie, js, je, kerad, lat_in, lon_in, &
! <SUBROUTINE NAME="original_fms_rad">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call original_fms_rad (is, ie, js, je, phalf, lat_in, lon_in, &
!                do_clear_sky_pass, &
!                Rad_time, Time_diag, Atmos_input, &
!                Surface, &
!                Astro, Rad_gases, Cldrad_props, Cld_spec, &
!                Fsrad_output, mask, kbot) 
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <IN NAME="phalf" TYPE="real">
! 
!  </IN>
!  <IN NAME="lat_in" TYPE="real">
! 
!  </IN>
!  <IN NAME="lon_in" TYPE="real">
! 
!  </IN>
!  <IN NAME="do_clear_sky_pass" TYPE="logical">
! 
!  </IN>
!  <IN NAME="Rad_time" TYPE="time_type">
! 
!  </IN>
!  <IN NAME="Time_diag" TYPE="time_type">
! 
!  </IN>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
! 
!  </IN>
!  <IN NAME="Surface" TYPE="surface_type">
! 
!  </IN>
!  <IN NAME="Astro" TYPE="astronomy_type">
! 
!  </IN>
!  <IN NAME="Rad_gases" TYPE="radiative_gases_type">
! 
!  </IN>
!  <IN NAME="Cldrad_props" TYPE="cldrad_properties_type">
! 
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
! 
!  </IN>
!  <INOUT NAME="Fsrad_output" TYPE="fsrad_output_type">
! 
!  </INOUT>
!  <IN NAME="mask" TYPE="real">
! 
!  </IN>
!  <IN NAME="kbot" TYPE="integer">
! 
!  </IN>
! </SUBROUTINE>
!
subroutine original_fms_rad (is, ie, js, je, phalf, lat_in, lon_in, &
                             do_clear_sky_pass, &
                             Rad_time, Time_diag, Atmos_input, &
                             Surface, &
                             Astro, Rad_gases, Cldrad_props, Cld_spec, &
                             Fsrad_output, mask, kbot) 

!--------------------------------------------------------------------
!integer, intent(in) :: is, ie, js, je, kerad, ipgl, jpgl
!integer, intent(in) :: is, ie, js, je, kerad              
integer, intent(in) :: is, ie, js, je
real, intent(in), dimension(:,:,:) :: phalf
real, dimension(:,:), intent(in) :: lat_in, lon_in
type(time_type), intent(in) :: Rad_time, Time_diag
logical, intent(in) :: do_clear_sky_pass
type(atmos_input_type), intent(in) :: Atmos_input
type(surface_type), intent(in) :: Surface
type(astronomy_type), intent(in) :: Astro        
type(radiative_gases_type), intent(in) :: Rad_gases
type(cldrad_properties_type), intent(in) :: Cldrad_props
type(cld_specification_type), intent(in) :: Cld_spec
type(fsrad_output_type), intent(inout)  :: Fsrad_output
real, dimension(:,:,:), intent(in), optional :: mask
integer, dimension(:,:), intent(in), optional  :: kbot
!--------------------------------------------------------------------
!-----------------------------------------------------------------------
! local variables

!    real,dimension(size( lat_in,1),size( lat_in,2), ke+1     )   ::   &
!                    press_in, temp_in, pflux_in, tflux_in, &
!      real, dimension(ie-is+1, je-js+1, kerad+1) :: &
      real, dimension(ie-is+1, je-js+1, size(Atmos_input%press,3)) :: &
                    cldamt,emcld, cuvrf,cirrf, cirab

!    real,dimension(size( lat_in,1),size( lat_in,2), ke               )   ::  &
!                   rh2o_in,  deltaz_in, cloud_water_in, cloud_ice_in,&
!                   q,qo3

!    real,dimension(size( lat_in,1),size( lat_in,2)     )   ::  &
!                      land_in, tsfc, asfc_in, psfc 
!     real, dimension(ie-is+1, je-js+1, kerad+1) :: temp, press, &
     real, dimension(ie-is+1, je-js+1, size(Atmos_input%press,3)) :: temp, press, &
                                                pflux, tflux

!    real, dimension(ie-is+1, je-js+1, kerad+1) :: temp, press, &
!                                               pflux, tflux
!    real, dimension(ie-is+1, je-js+1, kerad  ) :: rh2o        , &
     real, dimension(ie-is+1, je-js+1, size(Atmos_input%press,3)-1  ) :: rh2o        , &
                                                   q, qo3
!    integer,dimension(size(temp_in,1),size(temp_in,2), size(temp_in,3) ) ::  &
!  integer, dimension(ie-is+1, je-js+1, kerad+1  ) :: &
   integer, dimension(ie-is+1, je-js+1, size(Atmos_input%press,3)  ) :: &
                    ktop,kbtm, ktopsw, kbtmsw

!    integer,dimension(size(temp_in,1),size(temp_in,2))   :: nclds
      integer, dimension(ie-is+1, je-js+1 ) ::   nclds

     integer ::                   ip, jp
     logical :: no_clouds



     real :: rrsun

      real, dimension(ie-is+1, je-js+1) :: &
!               lat, lon, land, asfc, cosz, fracday, solar, &
                          land, asfc, cosz, fracday, solar, &
!23             lat ,lon ,land, asfc, cosz, fracday, solar, &
                 psfc, tsfc
!     real, dimension(ie-is+1, je-js+1, kerad  ) :: &
!     real, dimension(ie-is+1, je-js+1, size(Atmos_input%press,3)  ) :: &
!                             cloud_water, cloud_ice, deltaz, qo3_in, &
!                       qo3_out          

      integer :: ierad, jerad, kerad
      real :: rvco2

           ierad = ie - is + 1
           jerad = je -js + 1
           kerad = size(Atmos_input%press,3) - 1
!   print *, get_my_pe(), is, ie, js, je, kerad, do_clear_sky_pass
!   print *, 'lat', get_my_pe(), lat_in
!   print *, 'lon', get_my_pe(), lon_in
!   print *, 'ipgl,jpgl', get_my_pe(), ipgl, jpgl
!--------------------------------------------------------------------
!    define variables on the radiation grid which will be passed into
!    the radiation routines.
!---------------------------------------------------------------------
               press = Atmos_input%press
               temp  = Atmos_input%temp 
               rh2o  = Atmos_input%rh2o 
               asfc  = Surface%asfc
               psfc  = Atmos_input%psfc 
               tsfc  = Atmos_input%tsfc 
               pflux = Atmos_input%pflux
               tflux = Atmos_input%tflux
!              deltaz = Atmos_input%deltaz
               land  = Surface%land
!              cloud_water = Atmos_input%cloud_water
!              cloud_ice = Atmos_input%cloud_ice

!-------------------------------------------------------------------
!    make mods necessary for use with original fms radiation code:
!    1) the value expected for cosz in the diurnally-varying case is the
!    product of cosz and fracday; and 2) the solar constant is included 
!    in the solar array, in contrast to the sea-esf radiation, where it 
!    is resident in the shortwave module and is applied in that module.
!--------------------------------------------------------------------
!              cosz = Astro%cosz
!              if (Astro%do_diurnal) then
               if (Sw_control%do_diurnal) then
                 cosz = Astro%cosz*Astro%fracday
               else
                 cosz = Astro%cosz
               endif
               fracday = Astro%fracday
!       solar = Astro%solar
               solar = Astro%solar*solar_constant
               rrsun = Astro%rrsun

               qo3 = Rad_gases%qo3
               rvco2 = Rad_gases%rrvco2
     
        allocate (Fsrad_output%tdtsw    ( ierad, jerad, kerad) )
        allocate (Fsrad_output%tdtlw    ( ierad, jerad, kerad) )
        allocate (Fsrad_output%swdns    ( ierad, jerad       ) )
        allocate (Fsrad_output%swups    ( ierad, jerad       ) )
        allocate (Fsrad_output%lwdns    ( ierad, jerad       ) )
        allocate (Fsrad_output%lwups    ( ierad, jerad       ) )
        allocate (Fsrad_output%swin     ( ierad, jerad       ) )
        allocate (Fsrad_output%swout    ( ierad, jerad       ) )
        allocate (Fsrad_output%olr      ( ierad, jerad       ) )

        Fsrad_output%tdtsw   = 0.
        Fsrad_output%tdtlw  = 0.
        Fsrad_output%swdns   = 0.
        Fsrad_output%swups  = 0.
        Fsrad_output%lwdns   = 0.
        Fsrad_output%lwups   = 0.
        Fsrad_output%swin     = 0.
        Fsrad_output%swout  = 0.
        Fsrad_output%olr     = 0.
     if (do_clear_sky_pass) then
        allocate (Fsrad_output%tdtsw_clr( ierad, jerad, kerad) )
        allocate (Fsrad_output%tdtlw_clr( ierad, jerad, kerad) )
        allocate (Fsrad_output%swdns_clr( ierad, jerad       ) )
        allocate (Fsrad_output%swups_clr( ierad, jerad       ) )
        allocate (Fsrad_output%lwdns_clr( ierad, jerad       ) )
        allocate (Fsrad_output%lwups_clr( ierad, jerad       ) )
        allocate (Fsrad_output%swin_clr ( ierad, jerad       ) )
        allocate (Fsrad_output%swout_clr( ierad, jerad       ) )
        allocate (Fsrad_output%olr_clr  ( ierad, jerad       ) )

        Fsrad_output%tdtsw_clr = 0.
        Fsrad_output%tdtlw_clr =0.
        Fsrad_output%swdns_clr = 0.
        Fsrad_output%swups_clr = 0.
        Fsrad_output%lwdns_clr = 0.
        Fsrad_output%lwups_clr = 0.
        Fsrad_output%swin_clr  = 0.
        Fsrad_output%swout_clr = 0.
        Fsrad_output%olr_clr   = 0.
     endif

!----------------------------------------------------------------------
!   determine if radiation diagnostics column is present in current 
!   physics window. if so, determine its coordinates in the 
!   physics_window space. if not present, set ip and jp to 0.
!----------------------------------------------------------------------
!        call define_diag_column (is, ie, js, je, ipgl, jpgl, lat,   &
        call define_diag_column (is, ie, js, je,             lat_in,   &
                                 lon_in, ip, jp)
       
!-----------------------------------------------------------------------
!--------------- loop for clear sky diagnostics option -----------------

      if (do_clear_sky_pass) then
        no_clouds = .true.
!  redefine values to be input to clouds to be the time-averaged ones
!  now available, when that option is selected.
!  this change MAY affect isccp diagnostics from strat_cloud_mod.

     q = rh2o/(1.+rh2o)

!      call clouds (is,js, no_clouds, Rad_time, Time_diag, lat, land, tsfc, &
      call clouds (is,js, no_clouds, Rad_time, Time_diag, lat_in, land, tsfc, &
!                   press(:,:,1:kmax), pflux, temp(:,:,1:kmax), q,  &
                    press(:,:,1:kerad), pflux, temp(:,:,1:kerad), q,  &
                            cosz ,nclds, ktopsw, kbtmsw, ktop, kbtm,   &
                    cldamt, cuvrf, cirrf, cirab, emcld, mask, kbot)
!-----------------------------------------------------------------------
!----------------------------- radiation -------------------------------

     if (present(kbot)) then
!        call fsrad (ip,jp,press,temp,rh2o,Rad_gases%qo3,  &
         call fsrad (ip,jp,press,temp,rh2o,          qo3,  &
                     phalf,do_mcm_radiation,               &
                     nclds,ktopsw,kbtmsw,ktop,kbtm,cldamt,  &
                     emcld,cuvrf,cirrf,cirab,asfc,rvco2,  &
                            cosz ,          solar,                            &
                     Fsrad_output%swin_clr,Fsrad_output%swout_clr, &
                     Fsrad_output%olr_clr,Fsrad_output%swups_clr, &
                     Fsrad_output%swdns_clr,Fsrad_output%lwups_clr, &
                     Fsrad_output%lwdns_clr,  &
                     Fsrad_output%tdtsw_clr,Fsrad_output%tdtlw_clr, &
                     kbot,psfc)
     else
!        call fsrad (ip,jp,press,temp,rh2o,Rad_gases%qo3,  &
         call fsrad (ip,jp,press,temp,rh2o,          qo3,  &
                     phalf,do_mcm_radiation,               &
                     nclds,ktopsw,kbtmsw,ktop,kbtm,cldamt,  &
                     emcld,cuvrf,cirrf,cirab,asfc,rvco2,  &
                  cosz ,solar,                            &
                     Fsrad_output%swin_clr,Fsrad_output%swout_clr, &
                     Fsrad_output%olr_clr,Fsrad_output%swups_clr, &
                     Fsrad_output%swdns_clr,Fsrad_output%lwups_clr, &
                     Fsrad_output%lwdns_clr,  &
                     Fsrad_output%tdtsw_clr,Fsrad_output%tdtlw_clr )
     endif

  endif  ! (do_clear_sky_pass)

        no_clouds = .false.

!  redefine values to be input to clouds to be the time-averaged ones
!  now available, when that option is selected.
!  this change MAY affect isccp diagnostics from strat_cloud_mod.

     q = rh2o/(1.+rh2o)

!     call clouds (is,js, no_clouds, Rad_time, Time_diag, lat, land, tsfc, &
      call clouds (is,js, no_clouds, Rad_time, Time_diag, lat_in, land, tsfc, &
!                   press(:,:,1:kmax), pflux, temp(:,:,1:kmax), q,  &
                    press(:,:,1:kerad), pflux, temp(:,:,1:kerad), q,  &
                            cosz ,nclds, ktopsw, kbtmsw, ktop, kbtm,   &
                    cldamt, cuvrf, cirrf, cirab, emcld, mask, kbot)
 
!-----------------------------------------------------------------------
!----------------------------- radiation -------------------------------

     if (present(kbot)) then
!        call fsrad (ip,jp,press,temp,rh2o,Rad_gases%qo3,  &
         call fsrad (ip,jp,press,temp,rh2o,          qo3,  &
                     phalf,do_mcm_radiation,               &
                     nclds,ktopsw,kbtmsw,ktop,kbtm,cldamt,  &
                     emcld,cuvrf,cirrf,cirab,asfc,rvco2,  &
                  cosz ,solar,                            &
                     Fsrad_output%swin,Fsrad_output%swout, &
                     Fsrad_output%olr,Fsrad_output%swups, &
                     Fsrad_output%swdns,Fsrad_output%lwups, &
                     Fsrad_output%lwdns,  &
                     Fsrad_output%tdtsw,Fsrad_output%tdtlw, kbot,psfc)
     else
!        call fsrad (ip,jp,press,temp,rh2o,Rad_gases%qo3,  &
         call fsrad (ip,jp,press,temp,rh2o,          qo3,  &
                     phalf,do_mcm_radiation,               &
                     nclds,ktopsw,kbtmsw,ktop,kbtm,cldamt,  &
                     emcld,cuvrf,cirrf,cirab,asfc,rvco2,  &
                            cosz ,solar,                            &
                     Fsrad_output%swin,Fsrad_output%swout, &
                     Fsrad_output%olr,Fsrad_output%swups, &
                     Fsrad_output%swdns,Fsrad_output%lwups, &
                     Fsrad_output%lwdns,  &
                     Fsrad_output%tdtsw,Fsrad_output%tdtlw)
     endif

     if (do_clear_sky_pass) then
       Fsrad_output%npass = 2
      else

       Fsrad_output%npass = 1
      endif

!---------------------------------------------------------------------

end subroutine original_fms_rad

!#####################################################################

!subroutine define_diag_column (is, ie, js, je, ipgl, jpgl, lat,  &
! <SUBROUTINE NAME="define_diag_column">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call define_diag_column (is, ie, js, je,             lat,  &
!                lon, ip, jp) 
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <IN NAME="lat" TYPE="real">
! 
!  </IN>
!  <IN NAME="lon" TYPE="real">
! 
!  </IN>
!  <OUT NAME="ip" TYPE="integer">
! 
!  </OUT>
!  <OUT NAME="jp" TYPE="integer">
! 
!  </OUT>
! </SUBROUTINE>
!
subroutine define_diag_column (is, ie, js, je,             lat,  &
                               lon, ip, jp) 

!--------------------------------------------------------------------
!integer, intent(in) :: is, ie, js, je, ipgl, jpgl
integer, intent(in) :: is, ie, js, je
real, dimension(:,:), intent(in) :: lat, lon
integer, intent(out) :: ip, jp
!---------------------------------------------------------------------

!----------------------------------------------------------------------
!   determine if radiation diagnostics column is present in current 
!   physics window. if so, determine its coordinates in the 
!   physics_window space. if not present, set ip and jp to 0.
!----------------------------------------------------------------------
       
     if (jpgl == 0 .and. ipgl == 0) then
       ip = 0
       jp = 0
     else
       if  (   (is <= ipgl .and. ie >= ipgl) .and.   &
               (js <= jpgl .and. je >= jpgl) ) then
          ip = ipgl - is + 1
          jp = jpgl - js + 1
          print *, 'long and lat of point for radiation diagnostics', &
                    lon(ip,jp)*45./atan(1.0), lat(ip,jp)*45./atan(1.0)      
        else
          ip = 0
          jp = 0
        endif
      endif

end subroutine define_diag_column 

!######################################################################
      
                 end module original_fms_rad_mod

module fv_diagnostics

! Programmer: sjl, Oct 30, 2003

 use diag_manager_mod, only: diag_axis_init, register_diag_field, &
                             register_static_field, send_data
 use constants_mod,    only: GRAV, cp_air, rdgas, kappa, WTMAIR, WTMCO2
 use time_manager_mod, only: time_type, get_date, get_time
 use fms_mod,          only: error_mesg, FATAL, stdlog, write_version_number
 use mpp_domains_mod,  only: mpp_define_domains,  mpp_domains_init, domain2D

! use fv_pack,          only: nlon, mlat, nlev, beglat, endlat, u, v, pt, delp, q,    &
!                             omga, peln, pe, ua, va, phis, ptop, ak, bk, ks, ncnst,  &
!                             ng_d, ng_s, ps, pk, pkz, lon, lat, lonb, latb,          &
!                             age_tracer, age_time, fv_domain,  print_freq,           &
!                             drymadj, tracer_mass,                              &
!                             master, get_eta_level, nt_phys, do_fms_tracer_manager
 use fv_pack,          only: nlon, mlat, beglon, endlon, beglat, endlat, &
      ptop, ak, bk, ks, ng_d, ng_s, lon, lat, lonb, latb,          &
      age_tracer, age_time, fv_domain,  print_freq,  drymadj, tracer_mass, &
      master, get_eta_level, nt_phys, do_fms_tracer_manager, area
#ifdef MARS_GCM
 use fv_pack,       only:   p_ref
 use fv_phys_mod,   only:   mars_mass_budget
#endif MARS_GCM

! --- tracer manager ---
 use tracer_manager_mod, only : get_tracer_names, get_number_tracers
 use field_manager_mod, only  : MODEL_ATMOS      
 use mpp_mod, only: mpp_sync
 use fv_arrays_mod, only: fv_stack_push, fv_array_sync, fv_print_chksums
 use pmaxmin_mod, only: pmaxmin, pmaxming


 implicit none

 integer, save ::  id_ps,   id_ua,   id_va,   id_wa,  id_ta,   id_pt,   &
                   id_divg, id_vort, id_hght, id_pv,  id_usus, id_tsts, &
                   id_vsts, id_usvs, id_h500, id_slp, id_p5km, id_aoa,  &
                   id_dnflux, id_upflux, id_area
 integer, allocatable :: id_tracer(:), id_tracer_tend(:)
! 2008/04/09  jgj: add tracer dry mass and volume mixing ratios
 integer, allocatable :: id_tracer_dmmr(:)
 integer, allocatable :: id_tracer_dvmr(:)


 real       :: missing_value = -1.e10
 real, save :: ginv
 logical used
 type(time_type) :: fv_time
 real, allocatable, save :: phalf(:)
 save fv_time

 !-----------------------------------------------------------------------
  character(len=128) :: version = '$Id: fv_diagnostics.F90,v 17.0 2009/07/21 02:53:23 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

contains

  subroutine fv_diag_init(axes, Time)
#include "fv_arrays.h" 
! FV dynamics specific diagnostics

    type(time_type), intent(in) :: Time
    integer :: id_lonb, id_lon, id_latb, id_lat, id_phalf, id_pfull
    integer :: id_bk, id_pk, id_zsurf
    character(len=8) :: mod_name = 'dynamics'
    integer, intent(out) :: axes(4)
    logical used
    integer i, j
    integer :: log_unit
    real zsurf(nlon,beglat:endlat)
    real pfull(nlev)
    real qmin, qmax

    real :: vrange(2), trange(2), arange(2), slprange(2)

! tracers
    character(len=128)   :: tname
    character(len=256)   :: tlongname, tunits
    integer              :: ntprog
#include "fv_point.inc"

    log_unit = stdlog()

    call fv_print_chksums( 'Entering  fv_diag_init' )
! valid range for some fields

    vrange = (/ -330.,  350. /)  ! winds
#ifdef MARS_GCM
    trange = (/  50.,  350. /)  ! temperature
#else
    trange = (/  100.,  350. /)  ! temperature
#endif 
    arange = (/    0.,   20. /)  ! age-of-air
    slprange = (/800.,  1200./)  ! sea-level-pressure

    ginv = 1./GRAV
    fv_time = Time

    allocate ( phalf(nlev+1) )

#ifdef MARS_GCM
    call get_eta_level(nlev, p_ref, pfull, phalf, 0.01) 
#else
    call get_eta_level(nlev, 1.E5, pfull, phalf, 0.01) 
#endif 

    id_lonb=diag_axis_init('lonb', lonb, 'degrees_E', 'x', 'longitude edges', &
         set_name=mod_name , Domain2=fv_domain )
    id_lon =diag_axis_init('lon',  lon,  'degrees_E', 'x', 'longitude',       &
         set_name=mod_name, edges=id_lonb, Domain2=fv_domain )

    id_latb=diag_axis_init('latb', latb, 'degrees_N', 'y', 'latitude edges',  &
         set_name=mod_name, Domain2=fv_domain )
    id_lat =diag_axis_init('lat',  lat,  'degrees_N', 'y', 'latitude',        &
         set_name=mod_name, edges=id_latb, Domain2=fv_domain)

    id_phalf = diag_axis_init('phalf', phalf, 'mb', 'z', &
         'ref half pressure level', direction=-1, set_name=mod_name )
    id_pfull = diag_axis_init('pfull', pfull, 'mb', 'z', &
         'ref full pressure level', direction=-1, set_name=mod_name, &
         edges=id_phalf)

    axes(1) = id_lon
    axes(2) = id_lat
    axes(3) = id_pfull
    axes(4) = id_phalf

!---- register static fields -------

    id_bk    = register_static_field ( mod_name, 'bk', (/id_phalf/), &
         'vertical coordinate sigma value', 'none' )

    id_pk    = register_static_field ( mod_name, 'pk', (/id_phalf/), &
         'pressure part of the hybrid coordinate', 'pascal' )

    id_area =  register_static_field ( mod_name, 'area', axes(1:2), &
         & 'cell area elements', 'm^2')
    if( id_area > 0 ) &
         &  used = send_data( id_area, area(beglon:endlon,beglat:endlat), Time )

    do j=beglat,endlat
       do i=1,nlon
          zsurf(i,j) = ginv * phis(i,j) 
       enddo
    enddo

    id_zsurf = register_static_field ( mod_name, 'zsurf', axes(1:2),   &
         'surface height', 'm' )

!--- Send static data

    if ( id_bk > 0 )    used = send_data ( id_bk,    bk, Time )
    if ( id_pk > 0 )    used = send_data ( id_pk,    ak, Time )
    if ( id_zsurf > 0 ) &
         used = send_data( id_zsurf, zsurf(beglon:endlon,beglat:endlat), Time )

!     if ( master ) then
!     do i=1,nlev+1
!        write(6,*) i, ak(i), bk(i)
!     enddo
!     endif
!--------------------------------------------------------------
! Register main prognostic fields: ps, (u,v), t, omega (dp/dt)
!--------------------------------------------------------------

    id_ps = register_diag_field ( mod_name, 'ps', axes(1:2), Time,        &
         'surface pressure', 'Pa', missing_value=missing_value )
    id_ua = register_diag_field ( mod_name, 'ucomp', axes(1:3), Time,        &
         'zonal wind', 'm/sec', missing_value=missing_value, range=vrange )
    id_va = register_diag_field ( mod_name, 'vcomp', axes(1:3), Time,        &
         'meridional wind', 'm/sec', missing_value=missing_value, range=vrange)
    id_wa = register_diag_field ( mod_name, 'omega', axes(1:3), Time,        &
         'omega', 'pa/sec', missing_value=missing_value )
    id_dnflux = register_diag_field (mod_name, 'dnflux', axes(1:3), Time, &
         'downward mass flux', 'pa/sec', missing_value=missing_value )
    id_upflux = register_diag_field (mod_name, 'upflux', axes(1:3), Time, &
         'upward mass flux', 'pa/sec', missing_value=missing_value )

    id_ta = register_diag_field ( mod_name, 'temp', axes(1:3), Time,        &
         'temperature', 'deg_K', missing_value=missing_value, range=trange )

    id_pt = register_diag_field ( mod_name, 'pt_dry', axes(1:3), Time,        &
         'dry poten temperature', 'deg_K', missing_value=missing_value )

!------------------
! Register tracers
!------------------

    allocate(id_tracer(max(ncnst, nt_phys)))
    id_tracer(:) = 0

! 2008/04/09  jgj: add tracer dry mass and volume mixing ratios
    allocate(id_tracer_dmmr(max(ncnst, nt_phys)))
    id_tracer_dmmr(:) = 0
    allocate(id_tracer_dvmr(max(ncnst, nt_phys)))
    id_tracer_dvmr(:) = 0

    if(.NOT. do_fms_tracer_manager) then !{

! no field table 

        id_tracer(1) = register_diag_field ( mod_name, 'sphum', axes(1:3), &
             Time, 'sphum', 'mass/air_mass', &
             missing_value=missing_value )
        id_tracer(2) = register_diag_field ( mod_name, 'liq_wat', axes(1:3), &
             Time, 'cloud liquid water', 'mass/air_mass', &
             missing_value=missing_value )
        id_tracer(3) = register_diag_field ( mod_name, 'ice_wat', axes(1:3), &
             Time, 'cloud ice water', 'mass/air_mass',&
             missing_value=missing_value )
        id_tracer(4) = register_diag_field ( mod_name, 'cld_amt', axes(1:3), &
             Time, 'cloud craction', '%', &
             missing_value=missing_value )

    else !}{

! do_fms_traces == .TRUE.

#ifdef MARS_GCM
        do i= 1, ncnst
#else
        do i = 1, nt_phys
           call get_tracer_names ( MODEL_ATMOS, i, tname, tlongname, tunits )
           id_tracer(i) = register_diag_field ( mod_name, trim(tname),  &
                axes(1:3), Time, trim(tlongname), &
                trim(tunits), missing_value=missing_value)
           if (master) then
               if (id_tracer(i) > 0) then
                   write(log_unit,'(a,a,a,a)') &
                        & 'Diagnostics available for tracer ',tname, &
                        ' in module ', mod_name
               end if
           endif
        enddo
! for higher tracer number we take the default missing values from FMS
        do i = nt_phys+1, ncnst
#endif MARS_GCM
           call get_tracer_names ( MODEL_ATMOS, i, tname, tlongname, tunits )
           id_tracer(i) = register_diag_field ( mod_name, trim(tname),  &
                axes(1:3), Time, trim(tlongname),           &
                trim(tunits), missing_value=missing_value)
           if (master) then
               if (id_tracer(i) > 0) then
                   write(log_unit,'(a,a,a,a)') &
                        & 'Diagnostics available for tracer ',trim(tname), &
                        ' in module ', trim(mod_name)
               end if
           endif
        enddo

!-------
#ifdef MARS_GCM

#else
! jgj: add co2 tracer dry mass and volume mixing ratios
        do i = nt_phys+1, ncnst
           call get_tracer_names ( MODEL_ATMOS, i, tname, tlongname, tunits )
           if (trim(tname).eq.'co2') then
             id_tracer_dmmr(i) = register_diag_field ( mod_name, trim(tname)//'_dmmr',  &
                axes(1:3), Time, trim(tlongname)//" (dry mmr)",           &
                trim(tunits), missing_value=missing_value)
             id_tracer_dvmr(i) = register_diag_field ( mod_name, trim(tname)//'_dvmr',  &
                axes(1:3), Time, trim(tlongname)//" (dry vmr)",           &
                'mol/mol', missing_value=missing_value)
             if (master) then
                if (id_tracer_dmmr(i) > 0) then
                   write(log_unit,'(a,a,a,a)') &
                        & 'Diagnostics available for co2 dry mmr ',trim(tname)//'_dmmr', &
                        ' in module ', trim(mod_name)
                end if
                if (id_tracer_dvmr(i) > 0) then
                   write(log_unit,'(a,a,a,a)') &
                        & 'Diagnostics available for co2 dry vmr ',trim(tname)//'_dvmr', &
                        ' in module ', trim(mod_name)
                end if
             endif
           endif
        enddo
#endif 
!-------

    endif !}

!----------------------
! Divergence on C grid
!----------------------
! Computed inside fvcore/trac2d()
    id_divg = register_diag_field ( mod_name, 'divg', axes(1:3), Time,        &
         'divergence', '1/sec', missing_value=missing_value )

!----------------------
! Vorticity on D grid
!----------------------
    id_vort = register_diag_field ( mod_name, 'vort', axes(1:3), Time,        &
         'vorticity', '1/sec', missing_value=missing_value )

!--------------------------
! Ertel Potential Vorticity
!--------------------------
    id_pv = register_diag_field ( mod_name, 'pv', axes(1:3), Time,        &
         'potential vorticity', '1/sec', missing_value=missing_value )

!-------------------
! Age_of_air tracer
!-------------------
    id_aoa = register_diag_field ( mod_name, 'aoa', axes(1:3), Time,    &
         'age_of_air tracer', 'sec', missing_value=missing_value,   &
         range=arange )

!---------------------------
! Height at model half level
!---------------------------
    id_hght = register_diag_field ( mod_name, 'hght', &
         (/id_lon,id_lat,id_phalf/), &
         Time, 'height', 'm', missing_value=missing_value )

!--------------
! 500 mb Height
!--------------
    id_h500 = register_diag_field ( mod_name, 'h500', axes(1:2),  Time,   &
         '500-mb hght', 'm', missing_value=missing_value )
!-------------------
! Sea-level-pressure
!-------------------
    id_slp = register_diag_field ( mod_name, 'slp', axes(1:2),  Time,   &
         'sea-level pressure', 'mb', missing_value=missing_value,  &
         range=slprange )

!-------------------
! 5-km pressure
!-------------------
! This is analogous to 500-mb height. This shows the actual highs and lows
! at the 5-km physical height.
    id_p5km = register_diag_field ( mod_name, 'p5km', axes(1:2),  Time,   &
         'pressure at 5 km', 'mb', missing_value=missing_value )
!------------------
! 2nd moment stats:
!------------------

! u-wind variance
    id_usus = register_diag_field ( mod_name, 'usus', axes(1:3), Time, &
         'u-wind variance', '(m/sec)**2', missing_value=missing_value )

! temperature variance
    id_tsts = register_diag_field ( mod_name, 'tsts', axes(1:3), Time, &
         'temperature variance', 'K**2', missing_value=missing_value )

! eddy momentum transport
    id_usvs = register_diag_field ( mod_name, 'usvs', axes(1:3), Time, &
         'eddy momentum transport', '(m/sec)**2', missing_value=missing_value )

! eddy heat transport
    id_vsts = register_diag_field ( mod_name, 'vsts', axes(1:3), Time, &
         'eddy heat transport', '(m/sec)*K', missing_value=missing_value )

    ! make sure all send_data completed before one thread exits the routine
    call fv_array_sync()

    call fv_print_chksums( 'Exiting  fv_diag_init' )
  end subroutine fv_diag_init

!=================================================


 subroutine fv_diag( Time, im, jm, km, jfirst, jlast, nq, zvir, dt_atmos, hs_phys)

   use pv_module,   only: vort_d, pv_entropy
#include "fv_arrays.h"
!INPUT PARAMETERS:
      type(time_type), intent(in) :: Time
      integer, intent(in):: im         ! dimension in east-west
      integer, intent(in):: jm         ! dimension in North-South
      integer, intent(in):: km         ! number of Lagrangian layers
      integer, intent(in):: jfirst     ! starting latitude index for MPI
      integer, intent(in):: jlast      ! ending latitude index for MPI
      integer, intent(in):: nq         ! number of tracers
      real, intent(in):: zvir
      real, intent(in):: dt_atmos     ! model time step in seconds
      logical, intent(in):: hs_phys

      integer, parameter:: kmax = 100
      real height(kmax)
      real  log_p(kmax)
      real qmax, qmin, fac

      real gg
      real gmean
      real ztop
      integer  i, j, k, ic
      integer  yr, mon, dd, hr, mn, days, seconds
      logical::  prt_minmax
      real p0
! Local:
      real :: a2(im,jfirst:jlast)     ! work array for x-y diag
      real :: ax(jfirst:jlast,km)     ! work array for zonal means
!      real, allocatable:: xx(:,:,:)   ! work array for 2nd moments
!      real, allocatable:: us(:,:,:)
!      real, allocatable:: vs(:,:,:)
!      real, allocatable:: wz(:,:,:)
      real :: xx(im,jfirst:jlast,km)
      real :: us(im,jfirst:jlast,km)
      real :: vs(im,jfirst:jlast,km)
      real :: wz(im,jfirst:jlast,km+1)

! 2008/04/09  jgj: add tracer dry vmr to compare to obs
      real :: co2_dmmr(im,jfirst:jlast,km)
      real :: co2_dvmr(im,jfirst:jlast,km)
! tracers
    character(len=128)   :: tname
    character(len=256)   :: tlongname, tunits

#ifdef use_shared_pointers
      pointer( p_a2, a2 )
      pointer( p_ax, ax )
      pointer( p_xx, xx )
      pointer( p_us, us )
      pointer( p_vs, vs )
      pointer( p_wz, wz )
!jgj
      pointer( p_co2_dmmr, co2_dmmr )
      pointer( p_co2_dvmr, co2_dvmr )
#include "fv_point.inc"

      call fv_stack_push( p_a2, im*(jlast-jfirst+1)        )
      call fv_stack_push( p_ax, (jlast-jfirst+1)*km        )
      call fv_stack_push( p_xx, im*(jlast-jfirst+1)*km     )
      call fv_stack_push( p_us, im*(jlast-jfirst+1)*km     )
      call fv_stack_push( p_vs, im*(jlast-jfirst+1)*km     )
      call fv_stack_push( p_wz, im*(jlast-jfirst+1)*(km+1) )
!jgj
      call fv_stack_push( p_co2_dmmr, im*(jlast-jfirst+1)*km     )
      call fv_stack_push( p_co2_dvmr, im*(jlast-jfirst+1)*km     )
#endif
      fv_time = Time

! fv_time used within fvcore for diagnostics purpose
      if ( hs_phys ) then
         call get_time (fv_time, seconds,  days)
         if( print_freq == 0 ) then
                 prt_minmax = .false.
         elseif( print_freq < 0 ) then
                 prt_minmax = .true.
         else
                 prt_minmax = mod(seconds, 3600*print_freq) == 0
         endif
      else
         call get_date(fv_time, yr, mon, dd, hr, mn, seconds)
         if( print_freq == 0 ) then
                 prt_minmax = .false.
         elseif( print_freq < 0 ) then
                 prt_minmax = .true.
         else
                 prt_minmax = mod(hr, print_freq) == 0 .and. mn==0 .and. seconds==0
         endif
      endif


      if( prt_minmax ) then
        if ( master ) then
             if ( hs_phys ) then
             write(*,*) Days, seconds
             else
             write(*,*) yr, mon, dd, hr, mn, seconds
             endif
        endif
             call pmaxmin('PS', ps, qmin, qmax, im*(jlast-jfirst+1),  1, 0.01)

#ifdef MARS_GCM
       call mars_mass_budget( im, jm, km, jfirst, jlast, ng_d, ps, delp, nq, q, mars_sfc_budg ) 

#else
! Check dry air mass:
             call drymadj(im, jm, km, jfirst, jlast, ng_d, .true., kappa,   &
                          ptop,  ps, delp, pe, pk, peln, pkz, nq,           &
                          q, .false.)  
#endif MARS_GCM
             call pmaxmin('U', ua, qmin, qmax, im*(jlast-jfirst+1), km, 1.)
             call pmaxmin('V', va, qmin, qmax, im*(jlast-jfirst+1), km, 1.)
    endif

    if (id_ps > 0) used = send_data ( id_ps, ps(beglon:endlon,beglat:endlat), Time )

    if ( id_ua > 0 .or. id_va > 0 ) then

         if (id_ua > 0) used = send_data ( id_ua, ua(beglon:endlon,beglat:endlat,:), Time )
         if (id_va > 0) used = send_data ( id_va, va(beglon:endlon,beglat:endlat,:), Time )

    endif

! Send vertical velocity (pa/s)
    if (id_wa > 0)  used = send_data ( id_wa, omga(beglon:endlon,beglat:endlat,:), Time )
    ! The following sync call is required to ensure that send_data completes before 
    ! array omga is touched by another thread. 
    if( id_vort>0 .or. id_pv>0 .or. id_ta>0 .or. id_pt>0 ) call fv_array_sync()
    if( prt_minmax .and. km>1 ) then
        call pmaxmin('W', omga, qmin, qmax, im*(jlast-jfirst+1), km, 1.)
    endif

!    if ( id_usus>0 .or. id_usvs>0 .or. id_vsts>0 .or. id_tsts>0 ) then
!           allocate ( xx(im,jfirst:jlast,km) )
!           allocate ( us(im,jfirst:jlast,km) )
!           allocate ( vs(im,jfirst:jlast,km) )
!    endif

!----------------------------------------------------------------
! Note: wind variances computed from A grid winds are weaker than 
!       native D grid due to two-grid averaging (from D to A)
!----------------------------------------------------------------

    if ( id_usus > 0 .or. id_usvs > 0 ) then
!$omp parallel do default(shared)                     &
!$omp private(i, j, k)
      do k=ksp,kep
         call zsmean( ua(1,jfirst,k), im, jfirst, jlast,        &
                      ax(jfirst,k),   us(1,jfirst,k), xx(1,jfirst,k) )
      enddo
      call fv_array_sync()
      if ( id_usus > 0 ) used = send_data ( id_usus, xx(beglon:endlon,beglat:endlat,:), Time )
      ! The following sync call is required to ensure that send_data completes before 
      ! array xx is touched by another thread. 
      if( id_usvs>0 .or. id_tsts>0 .or. id_vsts>0 ) call fv_array_sync()
    endif

    if ( id_usvs > 0 .or. id_vsts > 0 ) then
!$omp parallel do default(shared)                     &
!$omp private(i, j, k)
      do k=ksp,kep
         call zsmean( va(1,jfirst,k), im, jfirst, jlast,        &
                      ax(jfirst,k),   vs(1,jfirst,k)   )
         if ( id_usvs > 0 ) then
         do j=jfirst,jlast
            do i=1,im
               xx(i,j,k) = us(i,j,k) * vs(i,j,k)
            enddo
         enddo
         endif
      enddo
      call fv_array_sync()
      if ( id_usvs > 0 ) used = send_data ( id_usvs, xx(beglon:endlon,beglat:endlat,:), Time )
      ! The following sync call is required to ensure that send_data completes before 
      ! array xx is touched by another thread. 
      if( id_tsts>0 .or. id_vsts>0 ) call fv_array_sync()
    endif


    if ( id_vort > 0 .or. id_pv > 0 ) then
         call vort_d(im, jm, km, jfirst, jlast, u, v, omga, ng_s, ng_d)
         if ( id_vort > 0 ) used = send_data ( id_vort, omga(beglon:endlon,beglat:endlat,:), Time )             
         ! The following sync call is required to ensure that send_data completes before 
         ! array omga is touched by another thread. 
         if( id_pv>0 .or. id_ta>0 .or. id_pt>0 ) call fv_array_sync()
    endif


! Potential Vorticity

    if ( id_pv > 0 ) then
         ! Note: this is expensive computation. don't do it too often
         call pv_entropy(im, jm, km, jfirst, jlast, omga, pt, pkz, delp, ng_d, grav)
         used = send_data ( id_pv, omga(beglon:endlon,beglat:endlat,:), Time )
         ! The following sync call is required to ensure that send_data completes before 
         ! array omga is touched by another thread. 
         if( id_ta>0 .or. id_pt>0 ) call fv_array_sync()
    endif

    if ( id_ta > 0 .or. id_tsts > 0 .or. id_vsts > 0 ) then
!$omp parallel do default(shared)                     &
!$omp private(i, j, k)
      do k=ksp,kep
          do j=jfirst,jlast
            do i=1,im
              omga(i,j,k) = pt(i,j,k)
            enddo
          enddo
          if ( id_tsts > 0 ) then
               call zsmean( omga(1,jfirst,k), im, jfirst, jlast,        &
                            ax(jfirst,k),   us(1,jfirst,k), xx(1,jfirst,k) )
          endif
      enddo    ! end parallel k-loop
      call fv_array_sync()
      if ( id_ta > 0)   used = send_data ( id_ta,   omga(beglon:endlon,beglat:endlat,:), Time )
      ! The following sync call is required to ensure that send_data completes before 
      ! array omga is touched by another thread. 
      if( id_pt>0 ) call fv_array_sync()
      if ( id_tsts > 0) used = send_data ( id_tsts, xx(beglon:endlon,beglat:endlat,:), Time )
      ! The following sync call is required to ensure that send_data completes before 
      ! array xx is touched by another thread. 
      if( id_vsts>0 ) call fv_array_sync()
      if( prt_minmax ) then
         call pmaxmin('T', omga, qmin, qmax, im*(jlast-jfirst+1), km, 1.)
         if(qmax > 360.) call error_mesg('fv_diagnostics:','too warm', FATAL)
#ifdef MARS_GCM
         if(qmin < 50.) call error_mesg('fv_diagnostics:','too cold', FATAL)
#else
         if(qmin < 100.) call error_mesg('fv_diagnostics:','too cold', FATAL)
#endif 
      endif

    endif

    if ( id_pt > 0 ) then
       p0 = (1.E5) ** kappa  
!$omp parallel do default(shared)                     &
!$omp private(i, j, k)
      do k=ksp,kep
          do j=jfirst,jlast
            do i=1,im
              omga(i,j,k) = pt(i,j,k)/pkz(i,j,k) * p0
            enddo
          enddo
      enddo    ! end parallel k-loop
      call fv_array_sync()
      used = send_data ( id_pt, omga(beglon:endlon,beglat:endlat,:), Time )
      call fv_array_sync()
    endif


    if ( id_vsts > 0 ) then

!$omp parallel do default(shared)                     &
!$omp private(i, j, k)
      do k=ksp,kep
         do j=jfirst,jlast
            do i=1,im
               xx(i,j,k) = vs(i,j,k) * us(i,j,k)
            enddo
         enddo
      enddo
      call fv_array_sync()
      used = send_data ( id_vsts, xx(beglon:endlon,beglat:endlat,:), Time )
      ! The following sync call is required to ensure that send_data completes before 
      ! array xx is touched by another thread. 
      call fv_array_sync()
    endif

    if ( id_hght > 0 .or. id_h500 > 0  .or. id_slp > 0 .or.    &
         id_p5km > 0  )   then

#ifdef SW_DYN
      gg  = ginv
#else
      gg  = rdgas * ginv
#endif

!      allocate ( wz(im,jfirst:jlast,km+1) )
      call fv_array_sync() !next loops are parallel over j

!$omp parallel do default(shared) private(i,j,k)
      do j=jsp,jep

! Compute height at layer edges
         do i=1,im
            wz(i,j,km+1) = phis(i,j) * ginv
         enddo

         do k=km,1,-1
            do i=1,im
#ifdef SW_DYN
               wz(i,j,k) = wz(i,j,k+1) + gg*(pk(i,j,k+1)-pk(i,j,k))
#else
               wz(i,j,k) = wz(i,j,k+1) + gg*pt(i,j,k)*(1.+zvir*q(i,j,k,1))   &
                    *(peln(i,k+1,j)-peln(i,k,j))
#endif
            enddo
         enddo
      end do
      call fv_array_sync()

      if(id_hght > 0) used = send_data ( id_hght, wz(beglon:endlon,beglat:endlat,:), Time )

!     call pmaxmin('Ztop', wz(1,jfirst,1), qmin, qmax, im, (jlast-jfirst+1), 0.001)
!     ztop = gmean(im, jm, jfirst, jlast, wz(1,jfirst,1)) * 0.001
!     if( master ) write(6,*) 'Mean model top height (km) =', ztop 

! Compute 5-km pressure
      if(id_p5km > 0) then
         height(1) = 5.E3
         call get_pressure_given_height(im, jfirst, jlast, km, wz, 1, height(1),   &
                                        pt(1,beglat, nlev), a2, 0.01)
         used = send_data ( id_p5km, a2(beglon:endlon,beglat:endlat), Time )
         ! The following sync call is required to ensure that send_data completes before 
         ! array a2 is touched by another thread. 
         if( id_slp>0 .or. id_h500>0 ) call fv_array_sync()
      endif

! Cumpute SLP (pressure at height=0)
      if(id_slp > 0) then
         height(1) = 0.
         call get_pressure_given_height(im, jfirst, jlast, km, wz, 1, height(1),   &
                                        pt(1,beglat, nlev), a2, 0.01)
         if( prt_minmax )   &
             call pmaxmin('SLP', a2, qmin, qmax, im*(jlast-jfirst+1),  1, 1.)
         used = send_data ( id_slp, a2(beglon:endlon,beglat:endlat), Time )
         ! The following sync call is required to ensure that send_data completes before 
         ! array a2 is touched by another thread. 
         if( id_h500>0 ) call fv_array_sync()
      endif

! Compute H500
      if(id_h500 > 0) then
         log_p(1) = log( 50000. )
         call get_height_given_pressure(im, jfirst, jlast, km, wz, 1, log_p, a2)
         used = send_data ( id_h500, a2(beglon:endlon,beglat:endlat), Time )
      endif

!      deallocate ( wz )
    endif

!----------------
! Output tracers:
!----------------

    if( nq /= 0 ) then
        do ic=1, nq
          if (id_tracer(ic) > 0) &
               & used = send_data (id_tracer(ic), q(beglon:endlon,beglat:endlat,1:km,ic), Time )
          if( prt_minmax ) then 
             call pmaxming('Q', q(1,jfirst-ng_d,1,ic), im, jm, km,  &
                  jfirst, jlast, ng_d, ng_d, 1.0)
          endif
        enddo
#ifdef MARS_GCM


#else
!-------
! jgj: per SJ email (jul 17 2008): q_dry = q_moist/(1-sphum)
! mass mixing ratio: q_dry = mass_tracer/mass_dryair = mass_tracer/(mass_air - mass_water) ~ q_moist/(1-sphum)
! co2_mmr = (wco2/wair) * co2_vmr
! Note: There is a check in fv_pack.F90 that ensures that tracer number one is sphum

        do ic = nt_phys+1, ncnst
          call get_tracer_names ( MODEL_ATMOS, ic, tname, tlongname, tunits )
          if (id_tracer_dmmr(ic) > 0 .and. trim(tname).eq.'co2') then
          call fv_array_sync() !next loops are parallel over j
!$omp parallel do default(shared) private(i,j,k)
            do k=1,km     
              do j=jsp,jep
                do i=1,im
                  co2_dmmr(i,j,k) = q(i,j,k,ic)/(1.0-q(i,j,k,1))
                enddo
              enddo
            enddo
            call fv_array_sync()
            used = send_data (id_tracer_dmmr(ic), co2_dmmr(beglon:endlon,beglat:endlat,1:km), Time )
      ! The following sync call is required to ensure that send_data completes before 
      ! array co2_dmmr is touched by another thread. 
            call fv_array_sync()
            if( prt_minmax ) then 
               call pmaxming('co2_dmmr', co2_dmmr(1,jfirst-ng_d,1), im, jm, km,  &
                    jfirst, jlast, ng_d, ng_d, 1.0)
            endif
          endif

!! use dry vmr to compare to obs
          if (id_tracer_dvmr(ic) > 0 .and. trim(tname).eq.'co2') then
          call fv_array_sync() !next loops are parallel over j
!$omp parallel do default(shared) private(i,j,k)
            do k=1,km     
              do j=jsp,jep
                do i=1,im
                  co2_dvmr(i,j,k) = (q(i,j,k,ic)/(1.0-q(i,j,k,1))) * WTMAIR/WTMCO2   ! to compare to obs
                enddo
              enddo
            enddo
            call fv_array_sync()
            used = send_data (id_tracer_dvmr(ic), co2_dvmr(beglon:endlon,beglat:endlat,1:km), Time )
      ! The following sync call is required to ensure that send_data completes before 
      ! array co2_dmmr is touched by another thread. 
            call fv_array_sync()
            if( prt_minmax ) then 
               call pmaxming('co2_dvmr', co2_dvmr(1,jfirst-ng_d,1), im, jm, km,  &
                    jfirst, jlast, ng_d, ng_d, 1.0)
            endif
          endif
        enddo
#endif 
!-------

! Check tracer mass. Unit:
!       if( prt_minmax )        &
!           call tracer_mass(im, jm, km, jfirst, jlast, ng_d, nq, q, delp)

        if ( age_tracer ) then
! Assuming age tracer is the last tracer
             call age_of_air(im, jm, km, jfirst, jlast, ng_d, age_time,   &
                             dt_atmos, peln, delp, q(1,jfirst-ng_d,1,nq), &
                             prt_minmax)
        endif

    endif

!    if ( id_usus>0 .or. id_usvs>0 .or. id_vsts>0 .or. id_tsts>0 ) then
!         deallocate ( xx )
!         deallocate ( us )
!         deallocate ( vs )
!    endif
 
    ! make sure all send_data completed before one thread exits the routine
    call fv_array_sync()

 end subroutine fv_diag

 subroutine get_pressure_given_height(im, jfirst, jlast, km, wz, kd, height, &
      ts, a2, fac)
#include "fv_arrays.h"

 integer,  intent(in):: im, jfirst, jlast, km
 integer,  intent(in):: kd           ! vertical dimension of the ouput height
 real, intent(in):: wz(im,jfirst:jlast,km+1)
 real, intent(in):: ts(im,jfirst:jlast)
 real, intent(in):: height(kd)   ! must be monotonically decreasing with increasing k
 real, optional, intent(in):: fac
 real, intent(out):: a2(im,jfirst:jlast,kd)      ! pressure (pa)

! local:
 integer n, i,j,k
 real ptmp, tm
 integer ii, mcount
#include "fv_point.inc"

 call fv_array_check( LOC(wz) )
 call fv_array_check( LOC(ts) )
 call fv_array_check( LOC(a2) )


 do n=1,kd

!$omp parallel do private(ii,i,j,k, ptmp, tm, mcount)
    do j=jsp,jep

       do 1000 i=1,im

         if ( height(n) >= wz(i,j,km+1) ) then
!---------------------
! Search from top down
!---------------------
          do k=1,km
             if( height(n) < wz(i,j,k) .and. height(n) >= wz(i,j,k+1) ) then
! Found it!
                 ptmp = peln(i,k,j) + (peln(i,k+1,j)-peln(i,k,j)) *   &
                       (wz(i,j,k)-height(n)) / (wz(i,j,k)-wz(i,j,k+1))
                 a2(i,j,n) = exp(ptmp)
                 go to 500
             endif
          enddo

         else

! Method: use a mean tm based on zonal mean with height < local height
             tm = 0.
             mcount = 0
          do ii=1,im
             if (wz(ii,j,km+1) < wz(i,j,km+1) .and. wz(ii,j,km+1) > (height(n)+0.1)) then
! adding 0.1 to exclude most ocean points
! This algorithm works very well except the S pole.
             mcount = mcount + 1
             tm = tm + ts(ii,j)
             endif
          enddo
             if ( mcount > im/10 + 1 ) then
                tm = rdgas*ginv * tm / real(mcount)
             else
! Assuming 6.5 deg/km lapse rate
                tm = rdgas*ginv*(ts(i,j) + 3.25E-3*(wz(i,j,km)-height(n)))
             endif
          a2(i,j,n) = exp( peln(i,km+1,j) + (wz(i,j,km+1) - height(n))/tm )
         endif
500      if ( present(fac) ) a2(i,j,n) = fac * a2(i,j,n)
1000   continue
    enddo
 enddo
 call fv_array_sync()

 end subroutine get_pressure_given_height


 subroutine get_height_given_pressure(im, jfirst, jlast, km, wz, kd, log_p, a2)

#include "fv_arrays.h"
 integer,  intent(in):: im, jfirst, jlast, km
 integer,  intent(in):: kd           ! vertical dimension of the ouput height
 real, intent(in):: log_p(kd)    ! must be monotonically decreasing with increasing k
                                     ! log (p)
 real, intent(in):: wz(im,jfirst:jlast,km+1)

 real, intent(out):: a2(im,jfirst:jlast,kd)      ! height (m)

! local:
 integer n, i,j,k
#include "fv_point.inc"

 call fv_array_check( LOC(wz) )
 call fv_array_check( LOC(a2) )

 do n=1,kd

!$omp parallel do private(i,j,k)
    do j=jsp,jep
       do 1000 i=1,im
          do k=1,km
             if( log_p(n) <= peln(i,k+1,j) .and. log_p(n) >= peln(i,k,j) ) then
! Found it!
                 a2(i,j,n) = wz(i,j,k)  +  (wz(i,j,k+1) - wz(i,j,k)) *   &
                       (log_p(n)-peln(i,k,j)) / (peln(i,k+1,j)-peln(i,k,j) )
                 go to 1000
             endif
          enddo
                 a2(i,j,n) = missing_value
1000   continue
    enddo
 enddo
 call fv_array_sync()

 end subroutine get_height_given_pressure


 subroutine zsmean(a2, im, js, je, ux, us, usus)
 integer im, js, je
 real, intent(in) :: a2(im,js:je)
 real, intent(out):: ux(js:je)          ! zonal mean
 real, intent(out):: us(im,js:je)       ! departure from ux
 real, optional, intent(out):: usus(im,js:je)       ! us ** 2

! local
 integer i, j
 real  rim

      rim = 1. / im

      do j=js,je
            ux(j) = a2(1,j)
         do i=2,im
            ux(j) = ux(j) + a2(i,j)
         enddo
            ux(j) = ux(j) * rim

        do i=1,im
            us(i,j) = a2(i,j) - ux(j)
        enddo
        if ( present(usus) ) then
           do i=1,im
              usus(i,j) = us(i,j) ** 2
           enddo
        endif
      enddo
 end subroutine zsmean

 subroutine age_of_air(im, jm, km, jfirst, jlast, ng, atime, dt,   &
      peln, delp, q, print_max)
   use fv_arrays_mod, only: fv_array_check, isp, iep, jsp, jep, ksp, kep


 integer im
 integer jm
 integer km
 integer jfirst
 integer jlast  
 integer ng
 logical, intent(in):: print_max

! q is the age tracer
! Need to be converted to mixing ratio (mass of tracer / dry_air-mass)
! Ignore this inconsistency for now.

  real, intent(in):: delp(im,jfirst:jlast,km)
  real, intent(in):: peln(im,km+1,jfirst:jlast)
  real, intent(inout):: atime        ! accumulated time since init
  real, intent(in):: dt
  real, intent(inout):: q(im,jfirst-ng:jlast+ng,km)

! Local
  integer i, j, k
  real p_source      ! source level (pa)
  real ascale, ra, ryear
  real tiny, pfull
  real rim, qsum, qmin, qmax
  real age(im,jfirst:jlast,km)
  parameter ( tiny = 1.e-6 )
  parameter ( p_source = 75000. )
  parameter ( ascale = 5.e-6 / 60. )
  parameter ( ra = 1./ascale )
  parameter (ryear = 1./(365.*24.*3600) )

  rim = 1./float(im)
  atime = atime + dt

  call fv_array_check( LOC(delp) )
  call fv_array_check( LOC(peln) )
  call fv_array_check( LOC(q) )

!$omp parallel do private(i, j, k, qsum, pfull)
  do k=ksp,kep
     do j=jfirst, jlast
        do i=1,im
           pfull = delp(i,j,k) / (peln(i,k+1,j)-peln(i,k,j))
           if( atime < tiny ) then
               q(i,j,k) = 0.
           elseif( pfull >= p_source ) then
               q(i,j,k) = ascale * atime
           endif
        enddo
        if(id_aoa > 0 ) then
            do i=1,im
               age(i,j,k) =  max(0., (atime - ra*q(i,j,k))) * ryear
            enddo
        endif
     enddo
  enddo
  call fv_array_sync()

  if(id_aoa > 0 ) then
     used = send_data (id_aoa, age(beglon:endlon,beglat:endlat,:), fv_time)
     if(print_max )         &
        call pmaxmin('Age-of-Air (yr)', age, qmin, qmax, im*(jlast-jfirst+1), km, 1.)
  endif

  ! make sure all send_data completed before one thread exits the routine
  call fv_array_sync()

 end subroutine age_of_air

end module fv_diagnostics

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                                   !!
!!                   GNU General Public License                      !!
!!                                                                   !!
!! This file is part of the Flexible Modeling System (FMS).          !!
!!                                                                   !!
!! FMS is free software; you can redistribute it and/or modify       !!
!! it and are expected to follow the terms of the GNU General Public !!
!! License as published by the Free Software Foundation.             !!
!!                                                                   !!
!! FMS is distributed in the hope that it will be useful,            !!
!! but WITHOUT ANY WARRANTY; without even the implied warranty of    !!
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     !!
!! GNU General Public License for more details.                      !!
!!                                                                   !!
!! You should have received a copy of the GNU General Public License !!
!! along with FMS; if not, write to:                                 !!
!!          Free Software Foundation, Inc.                           !!
!!          59 Temple Place, Suite 330                               !!
!!          Boston, MA  02111-1307  USA                              !!
!! or see:                                                           !!
!!          http://www.gnu.org/licenses/gpl.txt                      !!
!!                                                                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module hgrid_mod
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">Z. Liang </CONTACT>
  ! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">S. M. Griffies</REVIEWER>


  !<OVERVIEW>
  ! <TT>hgrid_mod</TT> Generate horizontal grid. The horizontal grid can be conventional lon-lat 
  ! spherical grid or a reprojected rotated tripolar grid (R. Murray, "Explicit generation of 
  ! orthogonal grids for ocean models", 1996, J.Comp.Phys., v. 126, p. 251-273.). 
  !</OVERVIEW>

  !<DESCRIPTION>
  ! There are four subgrids, labeled T (for tracer), C (corner of T), N (north of T) and E (east of T). 
  ! The following schematic describes the grid cell notation.
  !
  !
  !<PRE>
  !                          Ni,j
  !               +----------+-----------+Ci,j
  !               |                      |     
  !               |                      |
  !               |                      |
  !               +          +Ti,j       +Ei,j
  !               |                      |
  !               |                      |
  !               +----------+-----------+
  !
  !                          
  !</PRE>
  !
  ! The grid_spec file would contains all of the following information on each subgrid. 
  ! The following example is for T subgrid. Repeated for E, C, and N subgrids.
  !
  !
  !<PRE>
  !   x_T, y_T           = Geographic location of T-cell center
  !   x_vert_T, y_vert_T = Geographic location of T-cell vertices(each cell has 4 vertices)
  !   area_T             = area of T-cell
  !   angle_T            = Angle clockwise between logical and geographic east of T-cell
  !   ds_00_02_T         = Length of western face of T-cell
  !   ds_20_22_T         = Length of eastern face of T-cell
  !   ds_02_22_T         = Length of northern face of T-cell
  !   ds_00_20_T         = Length of southern face of T-cell
  !   ds_00_01_T         = Distance from southwest corner to western face center of T-cell
  !   ds_01_02_T         = Distance from northwest corner to western face center of T-cell
  !   ds_02_12_T         = Distance from northwest corner to northern face center of T-cell
  !   ds_12_22_T         = Distance from northeast corner to northern face center of T-cell
  !   ds_21_22_T         = Distance from northeast corner to eastern face center of T-cell
  !   ds_20_21_T         = Distance from southeast corner to eastern face center of T-cell
  !   ds_10_20_T         = Distance from southeast corner to southern face center of T-cell
  !   ds_00_10_T         = Distance from southwest corner to southern face center of T-cell
  !   ds_01_11_T         = Distance from center to western face of T-cell
  !   ds_11_12_T         = Distance from center to northern face of T-cell
  !   ds_11_21_T         = Distance from center to eastern face of T-cell
  !   ds_10_11_T         = Distance from center to southern face of T-cell
  !   ds_01_21_T         = width of T-cell
  !   ds_10_12_T         = height of T-cell
  !
  !  Distances between points are described in the following schematics (for T-cell).
  !   
  !
  !
  !               +<----ds_02_12_T---->+<----ds_12_22_T---->+
  !               ^                    ^                    ^
  !               |                    |                    |
  !               |                    |                    |
  !          ds_01_02_T           ds_11_12_T           ds_21_22_T
  !               |                    |                    |
  !               |                    |                    |
  !               v                    v                    v
  !               +<----ds_01_11_T---->+<----ds_11_21_T---->+
  !               ^                    ^                    ^
  !               |                    |                    |
  !               |                    |                    |
  !          ds_00_01_T           ds_10_11_T           ds_20_21_T
  !               |                    |                    |
  !               |                    |                    |
  !               v                    v                    v
  !               +<----ds_00_10_T---->+<----ds_10_20_T---->+
  !
  !
  !
  !               <-------------- ds_02_22_T---------------->
  !             ^ +--------------------+--------------------+ ^
  !             | |                    ^                    | |
  !             | |                    |                    | |
  !             | |                    |                    | |
  !             | |                    |                    | |
  !             | |                    |                    | |
  !     ds_00_02_T|<-------------------+--ds_01_21_T------->| ds_20_22_T              
  !             | |                    |                    | |
  !             | |               ds_10_12_T                | |
  !             | |                    |                    | |
  !             | |                    |                    | |
  !             | |                    |                    | | 
  !             | |                    v                    | |
  !             v +--------------------+--------------------+ v
  !               <-------------- ds_00_20_T---------------->
  !
  !
  !   The other three subgrids (E, N, C subgrids) have similiar name but replacing T.
  !
  ! Axis specifications involve specifying the number of regions for varying
  ! resolution, the bondaries of said regions and the nominal resolution in 
  ! the respective regions.  
  !
  ! For instance, for longitude axis specification:
  !
  !        dx_lon(1) = 4                         dx_lon(2) = 6
  ! |<----|----|----|----|----|----|------|------|------|------|------|------>|
  ! |                              |                                          |
  ! x_lon(1)                    x_lon(2)                                   x_lon(3)
  !
  ! Grid cells are constructed such that
  ! 
  ! dxt(i) = 0.5*(dxu(i-1)+dxu(i))
  !
  !</PRE>
  !
  !</DESCRIPTION>

  use mpp_mod,         only : mpp_pe, mpp_root_pe, mpp_npes, mpp_error, mpp_chksum, FATAL, NOTE
  use mpp_mod,         only : uppercase, lowercase
  use mpp_io_mod,      only : MPP_RDONLY, MPP_ASCII, MPP_MULTI, MPP_SINGLE, MPP_NETCDF   
  use mpp_io_mod,      only : mpp_write_meta, mpp_write, mpp_read, mpp_open, mpp_close 
  use mpp_io_mod,      only : mpp_get_id, mpp_get_info, axistype, fieldtype
  use mpp_io_mod,      only : mpp_get_atts, mpp_get_axes, mpp_get_fields, mpp_get_axis_data
  use mpp_domains_mod, only : domain2d, mpp_get_compute_domain, mpp_get_data_domain
  use mpp_domains_mod, only : mpp_define_domains, mpp_global_field 
  use fms_mod,         only : write_version_number, open_namelist_file, file_exist
  use fms_mod,         only : close_file, check_nml_error, stdout, string
  use constants_mod,   only : radius, pi, RADIAN, epsln
  use axis_utils_mod,  only : nearest_index, lon_in_range, get_axis_cart
  use grids_type_mod,  only : hgrid_data_type, cell_type 
  use grids_util_mod,  only : make_axis, gcell, get_file_unit, write_field_meta 
  use grids_util_mod,  only : write_field_data, set_grid
  implicit none
  private

  integer, parameter :: maxlen=10000,maxbounds=1000

  !------ namelist interface ---------------------------------------------
  !------ specify a spherical grid resolution in latitude, longitude, and depth
  !-----------------------------------------------------------------------
  integer                    :: nxlons = 0     
  integer                    :: nylats = 0     
  real, dimension(maxbounds) :: x_lon, dx_lon, y_lat, dy_lat
  logical                    :: square_grid=.false. 
  logical                    :: extend_square_grid=.false.
  logical                    :: cyclic_x=.true.
  logical                    :: cyclic_y=.false.
  logical                    :: tripolar_grid = .false. 
  real                       :: lat_join = 65.0         ! requested latitude for rotated grid
  logical                    :: read_my_grid = .false.
  character(len=128)         :: my_grid_file = 'my_hgrid'
  logical                    :: debug = .false.
  logical                    :: f_plane             = .false.
  logical                    :: beta_plane          = .false.
  logical                    :: simple_cartesian    = .false.
  real                       :: simple_cartesian_dx = 0
  real                       :: simple_cartesian_dy = 0
  real                       :: f_plane_latitude  =  30.0
  character(len=24) :: lon_axis_t   = 'GRID_X_T'
  character(len=24) :: lat_axis_t   = 'GRID_Y_T'
  character(len=24) :: lon_axis_u   = 'none'
  character(len=24) :: lat_axis_u   = 'none'

  !<NAMELIST NAME="hgrid_nml">
  ! <DATA NAME="nxlons" TYPE="integer">
  ! number of zonal regions for varying resolution
  ! </DATA>
  ! <DATA NAME="nylats" TYPE="integer">
  ! number of latitude regions for varying resolution
  ! </DATA>
  ! <DATA NAME="x_lon" TYPE="real" DIM="(nxlons)" UNITS="degrees">
  ! boundaries for defining zonal regions of varying resolution. When tripolar_grid 
  ! is .true., x_lon also defines the longitude of the two new poles. 
  ! lon_start = x_lon(1) and lon_end = x_lon(nxlons) are longitude of the two new 
  ! poles. In this case, the program will ignore the value x_lon(2:nxlons-1)
  ! and set grid resolution to dx_lon(1). When tripolar_grid is true, you
  ! need to be careful about your choice of x_lon, because there might be ocean
  ! at the grid singularity. The recommended choice of x_lon is x_lon = -280,80,
  ! this will put the singularity over land.
  ! </DATA>
  ! <DATA NAME="dx_lon" TYPE="real" DIM="(nxlons)" UNITS="degrees">
  ! nominal resolution of zonal regions
  ! </DATA>
  ! <DATA NAME="cyclic_x" TYPE="logical">
  ! True if grid is connected in i-direction 
  ! </DATA>
  ! <DATA NAME="cyclic_y" TYPE="logical">
  ! True if grid is connected in j-direction 
  ! </DATA>
  ! <DATA NAME="y_lat" TYPE="real" DIM="(nylats)" UNITS="degrees">
  ! boundaries for defining meridional regions of varying resolution
  ! </DATA>
  ! <DATA NAME="dy_lat" TYPE="real" DIM="(nxlons)" UNITS="degrees">
  ! nominal resolution of meridional regions
  ! </DATA>
  !<DATA NAME="tripolar_grid" TYPE="logical">
  ! convert portion of spherical grid north of lat_join to a bipolar rotated grid
  !</DATA>
  !<DATA NAME="square_grid" TYPE="logical">
  ! latitudinal grid spacing matches convergence of meridians
  !</DATA>
  !<DATA NAME="extend_square_grid" TYPE="logical">
  ! extend square grid to poles
  !</DATA>
  !<DATA NAME="lat_join" TYPE="real">
  ! requested latitude for joining spherical and rotated bipolar grid
  !</DATA>
  !<DATA NAME="read_my_grid" TYPE="logical">
  ! read ASCII grid information for supplying user-defined grids. 
  !</DATA>
  !<DATA NAME="my_grid_file" TYPE="character(len=128)">
  ! Name of ASCII user grid file
  !</DATA>
  !<DATA NAME="f_plane" TYPE="logical">
  !  For setting geometric fractors according to f-plane. 
  !</DATA> 
  !<DATA NAME="beta_plane" TYPE="logical">
  !  For setting geometric fractors according to beta plane. 
  !</DATA> 
  !<DATA NAME="f_plane_latitude" TYPE="real">
  !  Central latitude to define f_plane and beta_plane.
  !</DATA> 
  !<DATA NAME="simple_cartesian" TYPE="logical">
  !  For setting simple cartesian grid. When set true, simple_cartesian_dx 
  !  and simple_cartesian_dy need to be set. The grid box length in x-direction 
  !  will be uniform to be simple_cartesian_dx. The grid box length in y-direction 
  !  will be uniform to be simple_cartesian_dy.
  !</DATA> 
  !<DATA NAME="simple_cartesian_dx" TYPE="real">
  !  uniform grid length in x-direction ( units is meter).
  !</DATA> 
  !<DATA NAME="debug" TYPE="logical">
  !  uniform grid length in y-direction ( units is meter).
  !</DATA>
  !</NAMELIST>

  namelist /hgrid_nml/ nxlons, nylats, x_lon, dx_lon, y_lat, dy_lat, square_grid,      &
       extend_square_grid, cyclic_x, cyclic_y, tripolar_grid, lat_join, read_my_grid,  &
       my_grid_file, debug, f_plane, beta_plane, f_plane_latitude,                     &
       lon_axis_t, lat_axis_t, lon_axis_u, lat_axis_u, simple_cartesian,               &
       simple_cartesian_dx, simple_cartesian_dy

  !-----------------------------------------------------------------------
  !--------private data---------------------------------------------------
  integer                         :: ni                         ! number of grid cells in zonal direction
  integer                         :: nj                         ! number of grid cells in meridional direction
  integer                         :: isc, iec, jsc, jec         ! compute domain
  integer                         :: isd, ied, jsd, jed         ! data domain
  real, dimension(:), allocatable :: xt0, xu0, yt0, yu0
  real                            :: x_period = 0.0             ! period in i-direction
  real                            :: y_period = 0.0             ! period in j-direction
  real                            :: lon_start=0.0, lon_end=0.0 ! beginning and ending longitudes for tripolar grid
  real                            :: lon_bpeq, lon_bpnp, lon_bpsp, lam0, rp
  real                            :: D2R, hpi, tpi
  logical                         :: module_is_initialized = .false.
  type(domain2d),save             :: Domain

  !---------version information-------------------------------------------
  character(len=128) :: version = '$Id: hgrid.f90,v 14.0 2007/03/15 22:46:29 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $' 

  !---------public interface----------------------------------------------
  public :: generate_hgrid, hgrid_init, hgrid_end, write_hgrid_global_meta
  public :: write_hgrid_field_meta, write_hgrid_data

contains

  !#######################################################################
  ! <SUBROUTINE NAME="hgrid_init" >
  !   <OVERVIEW>
  !    Initialization routine.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !    Read namelist, write out version and namelist informaiton, generate longitude
  !     and latitude resolution.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call hgrid_init ( )
  !   </TEMPLATE>
  ! </SUBROUTINE>

  subroutine hgrid_init 

    !--- local variables -------------------------------------------------
    integer                     :: i, j, pe, unit, ierr, io, npes
    integer                     :: ndim, nvar, natt, ntime, len
    character(len=128)          :: txt, name
    real, allocatable           :: data2d(:,:), data3d(:,:,:)
    type(axistype), allocatable :: axes(:)
    type(fieldtype),allocatable :: flds(:)
    logical                     :: found_x_t, found_y_t, found_x_vert_t, found_y_vert_t
    logical                     :: found_x_u, found_y_u

    D2R = PI/180.
    hpi = PI*0.5
    tpi = PI*2.0

    x_lon(:)    = 0.0
    dx_lon(:)   = 0.0
    y_lat(:)    = 0.0
    dy_lat(:)   = 0.0

    !---- read namelist --------------------------------------------------
    unit = open_namelist_file ( )
    ierr=1
    do while (ierr /= 0)
       read  (unit, nml=hgrid_nml, iostat=io, end=10)
       ierr = check_nml_error(io,'hgrid_nml')  ! also initializes nml error codes
    enddo
10  call close_file (unit)

    !--- write version info and namelist to logfile ----------------------

    call write_version_number(version, tagname)
    write (stdout(), nml=hgrid_nml)

    module_is_initialized = .true.

    ! --- namelist check -----------------------------------------------
    if(.not. read_my_grid) then
       if(nxlons .lt. 2 .or. nylats .lt. 2) call mpp_error(FATAL, &
            'hgrid_mod: nml "nxlons"= '//trim(string(nxlons))//' and "nylats"= '// &
             trim(string(nylats))//' should be no less than 2')
       if (nxlons .gt. maxbounds )  &
            call mpp_error(FATAL,'hgrid_mod: nml "nxlons"= '//trim(string(nxlons))// &
              ' is greater than "maxbounds"= '//trim(string(maxbounds)) )
       if (nylats .gt. maxbounds )  &
            call mpp_error(FATAL,'hgrid_mod: nml "nylats"= '//trim(string(nylats))// &
              ' is greater than "maxbounds"= '//trim(string(maxbounds)) )
       if ( y_lat(nylats) - y_lat(1) > 180.0) write(stdout(),*)   &
            "=>Warning: Latitudinal domain width exceeds 180 deg.", &
            "Restricting last bounds to ",dy_lat(nylats) +180.0

       !--- if cyclic condition, set the period
       if(cyclic_x) then
          x_period = x_lon(nxlons) - x_lon(1)
          if(abs(x_period - 360) < epsln ) x_period = 360.0
          write(stdout(),*) "x-boundary is cyclic with period = ", x_period
          if(dx_lon(nxlons) .NE. dx_lon(1)) call mpp_error(FATAL, &
               'hgrid_mod: dx_lon(1) must equal dx_lon(last), modify nml "dx_lon" ' )
       end if
       if(cyclic_y) then
          y_period = y_lat(nylats) - y_lat(1)
          write(stdout(),*) "y-boundary is cyclic with period = ", y_period
          if(dy_lat(nylats) .NE. dy_lat(1)) call mpp_error(FATAL, &
               'hgrid_mod: dy_lat(1) must equal dy_lat(last), modify nml "dy_lat" ' )
       end if

       !--- for tripolar grid, nxlons should be 2.
       if(tripolar_grid) then
          !--- tripolar grid can not be cyclic_y
          if(cyclic_y) call mpp_error(FATAL, "hgrid_mod:nml cyclic_y and tripolar can not both be true")
          if(nxlons .NE. 2) call mpp_error(FATAL, "hgrid_mod: nml nxlons should be set to 2 for tripolar grid")
          !-- for tripolar grid, the period should be 360.
          if( x_period .NE. 360.0 ) call mpp_error(FATAL, &
               "hgrid_mod: for tripolar grid, period in i-direction should be 360")
          if(x_lon(1) .ne. -280 .and. x_lon(2) .ne. 80 ) then
             write(stdout(),*) ' '
             write(stdout(),*)' WARNING from hgrid_mod: the grid is tripolar grid, but ', &
                  'the longitude of the two poles are not -280 and 80, you might ', &
                  'put the singularity over ocean with your choice of longitude of ', &
                  'the two poles: ', x_lon(1), ', ', x_lon(2)
             write(stdout(),*) ' '
          endif
          if ( y_lat(nylats) < 90.) call mpp_error(FATAL, &
             "hgrid_mod: the last latitude bound is less than 90 degree and is tripolar grid")

          if(dx_lon(1) .NE. dx_lon(2)) call mpp_error(FATAL,  &
               'hgrid_mod: dx_lon(1) should equal dx_lon(2) for tripolar grid ')
          if(mod(x_period,dx_lon(1)) .ne. 0) call mpp_error(FATAL,  &
               'hgrid_mod: non-integral number of longitude cells. modify nml "dx_lon" ')
       end if

       !--- at most one of f_plane and beta_plane can be true
       if(f_plane .and. beta_plane) call mpp_error(FATAL, "hgrid_mod: f_plane and beta_plane can not both be true")
       if(f_plane .or. beta_plane) then
          if(f_plane_latitude > 90 .or. f_plane_latitude < -90.) call mpp_error(FATAL, &
                "hgrid_mod: nml f_plane_latitude should be between -90 and 90.")
          if(f_plane_latitude>y_lat(nylats) .or. f_plane_latitude<y_lat(1)) then
              write(stdout(),*)" Warning from hgrid_mod: nml f_plane_latitude is not inside the latitude range of the grid"
          end if
          write(stdout(),*)" setting geometric factor according to f-plane with f_plane_latitude = ", f_plane_latitude
          !--- for f_plane or beta_plane, can not be tripolar grid.
          if(tripolar_grid) call mpp_error(FATAL, "hgrid_mod: for f_plane or beta_plane, can not be tripolar grid.")
       end if
    end if

    !--- when simple_cartesian is set to true, f_plane, beta_plane and tripolar_grid all should be false
    if(simple_cartesian) then
       if(f_plane .or. beta_plane .or. tripolar_grid) call mpp_error(FATAL,  &
           "hgrid_mod: when simple_cartesian is set to true, _plane, beta_plane and tripolar_grid all should be false")
       if(simple_cartesian_dx == 0 .or. simple_cartesian_dy == 0 ) call mpp_error(FATAL,  &
           "hgrid_mod: both imple_cartesian_dx and simple_cartesian_dy need to be set")
    end if

    allocate (xt0(0:maxlen), xu0(0:maxlen), yt0(0:maxlen), yu0(0:maxlen))

    if (read_my_grid) then

       if (tripolar_grid) call mpp_error(FATAL,&
               'hgrid_mod: nml "read_my_grid"= true contradicts with nml "tripolar_grid"=true')
       if (f_plane .or. beta_plane ) call mpp_error(FATAL,&
               'hgrid_mod: nml "read_my_grid"= true contradicts with nml "f_plane"/"beta_plane" =true')
       !
       ! read grid information from an ASCII file.
       ! this is an alternative to namelist grid specification.
       ! For instance, to generate an R30 ocean grid.
       ! we are expecting t-cell centers and uv-cell centers (upper right).
       ! 
       ni=0;nj=0
       if(.not. file_exist(trim(my_grid_file))) &
            call mpp_error(FATAL,'hgrid_mod: file '//trim(my_grid_file)//' does not exist')
       !--- my_grid_file can be in netcdf format or ascii format. The grid should be 
       !--- spherical grid.
       len = len_trim(my_grid_file)
       if(my_grid_file(len-2:len) == '.nc') then
          call mpp_open(unit,trim(my_grid_file),action=MPP_RDONLY,form=MPP_NETCDF,threading=MPP_MULTI,fileset=MPP_SINGLE)
          call mpp_get_info(unit, ndim, nvar, natt, ntime)
          allocate(axes(ndim))
          call mpp_get_axes(unit, axes)
          found_x_t = .false.; found_x_vert_t = .false.
          found_y_t = .false.; found_y_vert_t = .false.
          found_x_u = .false.; found_y_u = .false.
          do i=1, ndim
             call mpp_get_atts(axes(i),name=name,len=len)  
             if (trim(lowercase(name)) .eq. trim(lowercase(lat_axis_t))) then
               found_y_t = .true.
               nj = len
               call mpp_get_axis_data(axes(i), yt0(1:nj) )
             endif  
             if (trim(lowercase(name)) .eq. trim(lowercase(lon_axis_t))) then
               found_x_t = .true.
               ni = len
               call mpp_get_axis_data(axes(i), xt0(1:ni) )
             endif  
             if (trim(lowercase(name)) .eq. trim(lowercase(lat_axis_u))) then
               found_y_u = .true.
               nj = len
               call mpp_get_axis_data(axes(i), yu0(1:nj) )
               yu0(0) = 2.0*yu0(1)-yu0(2)
             endif  
             if (trim(lowercase(name)) .eq. trim(lowercase(lon_axis_u))) then
               found_x_u = .true.
               ni = len
               call mpp_get_axis_data(axes(i), xu0(1:ni) )
               xu0(0) = 2.0*xu0(1)-xu0(2)
             endif  
          enddo
          if (ni == 0 .or. nj == 0 ) &
             call mpp_error(FATAL,'Error reading grid size from grid file '//trim(my_grid_file) )
          allocate(flds(nvar))
          call mpp_get_fields(unit, flds)
          do i=1, nvar
             call mpp_get_atts(flds(i),name=name)
             select case(trim(uppercase(name)))
             case('X_T')
                found_x_t = .true.
                allocate(data2d(ni,nj))
                call mpp_read(unit,flds(i), data2d(:,:))
                xt0(1:ni) = data2d(1:ni,1)
                deallocate(data2d)
             case('Y_T')
                found_y_t = .true.
                allocate(data2d(ni,nj))
                call mpp_read(unit,flds(i), data2d(:,:))
                yt0(1:nj) = data2d(1,1:nj)
                deallocate(data2d)
             case('X_U')
                found_x_u = .true.
                allocate(data2d(ni,nj))
                call mpp_read(unit,flds(i), data2d(:,:))
                xu0(1:ni) = data2d(1:ni,1)
                xu0(0) = 2.0*xu0(1)-xu0(2)
                deallocate(data2d)
             case('Y_U')
                found_y_u = .true.
                allocate(data2d(ni,nj))
                call mpp_read(unit,flds(i), data2d(:,:))
                yu0(1:nj) = data2d(1,1:nj)
                yu0(0) = 2.0*yu0(1)-yu0(2)
                deallocate(data2d)
             case('X_VERT_T')
                found_x_vert_t = .true.
                allocate(data3d(ni,nj,4))
                call mpp_read(unit,flds(i), data3d)
                xu0(0)    = data3d(1,1,1)
                xu0(1:ni) = data3d(1:ni,1,3)
                deallocate(data3d)
             case('Y_VERT_T')
                found_y_vert_t = .true.
                allocate(data3d(ni,nj,4))
                call mpp_read(unit,flds(i), data3d)
                yu0(0)    = data3d(1,1,1)
                yu0(1:nj) = data3d(1,1:nj,3)
                deallocate(data3d)
             end select
          enddo
          if(.not. found_x_t) call mpp_error(FATAL,'field x_T does not exist in file '//trim(my_grid_file) )
          if(.not. found_y_t) call mpp_error(FATAL,'field y_T does not exist in file '//trim(my_grid_file) )
          if(.not. found_x_vert_t .and. .not. found_x_u) call mpp_error(FATAL, &
             'neither field x_vert_U nor field x_U do not exist in file '//trim(my_grid_file) )
          if(.not. found_y_vert_t .and. .not. found_y_u) call mpp_error(FATAL, &
             'neither field y_vert_U nor field y_U do not exist in file '//trim(my_grid_file) )
          if(found_x_vert_t .and. found_x_u) call mpp_error(FATAL, &
             'field x_vert_U and field x_U exist in file '//trim(my_grid_file) )
          if(found_y_vert_t .and. found_y_u) call mpp_error(FATAL, &
             'field y_vert_U adn field y_U exist in file '//trim(my_grid_file) )
          deallocate(axes, flds)
       else
          call mpp_open(unit,trim(my_grid_file),action=MPP_RDONLY,form=MPP_ASCII,threading=MPP_MULTI,fileset=MPP_SINGLE)
          read(unit,*) txt ! header line (ignored) 
          read(unit,*) ni
          read(unit,*) xt0(1:ni)
          read(unit,*) txt ! header line (ignored) 
          read(unit,*) nj
          read(unit,*) yt0(1:nj)     
          read(unit,*) txt ! header line (ignored) 
          read(unit,*) 
          read(unit,*) xu0(0:ni)
          read(unit,*) txt ! header line (ignored) 
          read(unit,*) 
          read(unit,*) yu0(0:nj)     
          call mpp_close(unit)

          if (ni == 0 .or. nj == 0 ) call mpp_error(FATAL,'error reading my_grid file')
       endif
       if (cyclic_x) then  
          x_period = xu0(ni) - xu0(0)
          xt0(0) = xt0(ni)-x_period
          xt0(ni+1) = xt0(1)+x_period
          xu0(ni+1) = xu0(0)+x_period
       else
          xt0(0) = 2.0*xt0(1)-xt0(2)
          xt0(ni+1) = 2.0*xt0(ni)-xt0(ni-1)
          xu0(ni+1) = 2.0*xu0(ni)-xu0(ni-1)
       endif
       if (cyclic_y) then  
          y_period    = yu0(nj) - yu0(0)
          yt0(0)    = yt0(nj)-y_period
          yt0(nj+1) = yt0(1)+y_period
          yu0(nj+1) = yu0(0)+y_period
       else
          yt0(0) = 2.0*yt0(1)-yt0(2)
          yt0(nj+1) = 2.0*yt0(nj)-yt0(nj-1)
          yu0(nj+1) = 2.0*yu0(nj)-yu0(nj-1)
       end if
    else
       write (stdout(),'(//,36x,a,/)') 'H G R I D   G E N E R A T I O N'

       ! Tile full longitudinal domain with i=1,ni cells. 

       write (stdout(),'(/a)')'Generating longitudinal resolution for the computational domain:'
       call make_axis('X',maxlen, nxlons,x_lon,dx_lon,xu0,xt0,ni,square_grid, extend_square_grid)
       write (stdout(),'(/a)')'Generating latitudinal resolution for the computational domain:'
       call make_axis('Y',maxlen, nylats,y_lat,dy_lat,yu0,yt0,nj,square_grid, extend_square_grid )
    endif

    ! Print all grid coordinates

    write (stdout(),'(//,40x,a,//,a,g14.7,a/,a,g14.7,a/,a,g14.7,a/)') &
         ' Grid Point Coordinate details: ',' The western edge of the T-cell at i=1 is at:',&
         xu0(0),' (deg) longitude',' The southern edge of the T-cell at j=1 is at:',yu0(0),'(deg) latitude'

    write (stdout(),'(a,i4,a,g14.7,a/)') ' The eastern edge of the T-cell at i=',ni,' is at:',&
         xu0(ni),' (deg) longitude',' The northern edge of the T-cell at j=',nj,' is at:',&
         yu0(nj),' (deg) latitude'

    write (stdout(),'(/,a,g14.7,a/,a,g14.7,a/,a,g14.7,a/)') ' The western edge of the C-cell at i=1 is at:', xt0(1),&
         '(deg) longitude',' The southern edge of the C cell at j=1 is at:', yt0(1),&
         '(deg) latitude'

    write (stdout(),'(a,i4,a,g14.7,a/)') ' The eastern edge of the C-cell at i=',ni,' is at:',&
         xt0(ni+1),'(deg) longitude',' The northern edge of the C-cell at j=',nj,' is at:',&
         yt0(nj+1),'(deg) latitude'

    write (stdout(),9105) nj
    write (stdout(),9001) (yt0(j),j=1,nj)
    write (stdout(),9106) nj
    write (stdout(),9001) (yu0(j),j=1,nj)
    write (stdout(),9107) ni
    write (stdout(),9001) (xt0(i),i=1,ni)
    write (stdout(),9108) ni
    write (stdout(),9001) (xu0(i),i=1,ni)
    write (stdout(),'(/)')
    ! Compute a grid checksum
    if(debug) then     
       pe = mpp_pe()
       write (stdout(),*) 'Grid checksum = ',mpp_chksum(xt0(1:ni),(/pe/)) + mpp_chksum(yt0(1:nj),(/pe/)) + &
            mpp_chksum(xu0(1:ni),(/pe/)) + mpp_chksum(yu0(1:nj),(/pe/)) 
       write (stdout(),'(/)')
    endif

    !--- domain decomposition --------------------------------------------
    npes = mpp_npes()
    call mpp_define_domains((/1,ni,1,nj/),(/1,npes/), Domain, xhalo=1, yhalo=1)
    call mpp_get_compute_domain(Domain, isc, iec, jsc, jec)
    call mpp_get_data_domain(Domain, isd, ied, jsd, jed)

    return

9001 format (1x,10f10.4)
9002 format (1x,10f10.2)
9101 format (/,  a,i4,' in units of ',a,' as follows:')
9105 format (/,' Latitude of T points (deg): yt(j) j=1,',i4)
9106 format (/,' Latitude of C points (deg): yu(j) j=1,',i4)
9107 format (/,' Longitude of T points (deg): xt(i) i=1,',i4)
9108 format (/,' Longitude of C points (deg): xu(i) i=1,',i4)

  end subroutine hgrid_init

  !#######################################################################
  ! <SUBROUTINE NAME="generate_hgrid" >
  !   <OVERVIEW>
  !    Generate horizontal grid.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !    Define geographical locations of center and vertices of 
  !    T, C, E, N-cell and also calculate the area, orientation, cell size, face lengths, 
  !    half face lengths and center to face size of each T, E, C, N cell.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call generate_hgrid (Hgrid)
  !   </TEMPLATE>
  !   <INOUT NAME="Hgrid" TYPE="hgrid_data_type">
  !     A derived-type variable that contains horizontal grid information.
  !   </INOUT>
  ! </SUBROUTINE>
  subroutine generate_hgrid (Hgrid)
    type(hgrid_data_type), intent(inout) :: Hgrid
    integer :: i, j

    Hgrid%ni            = ni
    Hgrid%nj            = nj
    Hgrid%Domain        = Domain
    Hgrid%tripolar_grid = tripolar_grid
    Hgrid%cyclic_x      = cyclic_x
    Hgrid%cyclic_y      = cyclic_y

    call allocate_hgrid(Hgrid)

    do j=0,nj+1
       Hgrid%T%x(0:ni+1,j) = xt0(0:ni+1)
    enddo
    do i=0,ni+1
       Hgrid%T%y(i,0:nj+1) = yt0(0:nj+1)
       if (Hgrid%T%y(i,nj+1) .gt. 90.) then
          Hgrid%T%y(i,nj+1) = 180.-Hgrid%T%y(i,nj+1)
       endif
    enddo
    do j=0,nj+1
       Hgrid%C%x(0:ni+1,j) = xu0(0:ni+1)
    enddo
    do i=0,ni+1
       Hgrid%C%y(i,0:nj+1) = yu0(0:nj+1)
       if (Hgrid%C%y(i,nj+1) .gt. 90.) then
          Hgrid%C%y(i,nj+1) = 180.-Hgrid%C%y(i,nj+1)     
       endif
    enddo

    Hgrid%E%x(:,:) = Hgrid%C%x(:,:)
    Hgrid%E%y(:,:) = Hgrid%T%y(:,:)
    Hgrid%N%x(:,:) = Hgrid%T%x(:,:)
    Hgrid%N%y(:,:) = Hgrid%C%y(:,:)  

    ! write spherical grid information to Hgrid (center of T,C,E and N-cell) and 
    ! set up the variables to calculate the half length of each cell. 
    if(f_plane .or. beta_plane) then
       call f_plane_grid_init(Hgrid)
    else if(simple_cartesian) then
       call simple_cartesian_grid_init(Hgrid)
    else
       call spherical_grid_init(Hgrid)
    end if

    !--- call set_grid for setting up io
    call set_grid(xt0(1:ni), yt0(1:nj), xu0(1:ni),yu0(1:nj))

    ! if tripolar_grid, then overload all the grid information above the lat_join,
    ! and the variables to calculate half length of cell.
    if (tripolar_grid) call tripolar_grid_init(Hgrid)

    ! write grid information of vertices of each cell to the Hgrid.
    call define_vertices(Hgrid)

    if(debug) then
       call cell_chksum(Hgrid%T, 'T')
       call cell_chksum(Hgrid%E, 'E')
       call cell_chksum(Hgrid%N, 'N')
       call cell_chksum(Hgrid%C, 'C')
    endif

    return

  end subroutine generate_hgrid

  !#######################################################################
  ! <SUBROUTINE NAME="write_hgrid_data">
  !   <OVERVIEW>
  !     write the Hgrid data to netcdf file
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     call write_hgrid_data (unit,Hgrid)
  !   </TEMPLATE>
  !   <IN NAME="unit" TYPE="integer" >
  !     The unit corresponding the output netcdf file. Always is returned by mpp_open.
  !   </IN>
  !   <IN NAME="Hgrid" TYPE="hgrid_data_type">
  !     A derived-type variable that contains horizontal grid information.
  !   </IN>
  ! </SUBROUTINE>

  subroutine write_hgrid_data (file,Hgrid)
    character(len=*),      intent(in) :: file
    type(hgrid_data_type), intent(in) :: Hgrid

    !--- write out Hgrid T-cell data -------------------------------
    call write_cell_data(file, Hgrid%T, 'T') 

    !--- write out Hgrid E-cell data -------------------------------
    call write_cell_data(file, Hgrid%E, 'E') 

    !--- write out Hgrid N-cell data -------------------------------
    call write_cell_data(file, Hgrid%N, 'N') 

    !--- write out Hgrid C-cell data -------------------------------
    call write_cell_data(file, Hgrid%C, 'C') 

    return

  end subroutine write_hgrid_data

  !#####################################################################

  subroutine write_hgrid_global_meta(file)
    character(len=*), intent(in) :: file
    integer                      :: unit

    if(mpp_pe() .ne. mpp_root_pe() ) return

    unit = get_file_unit(file)

    call mpp_write_meta(unit,'xname', cval='longitude')
    call mpp_write_meta(unit,'yname', cval='latitude')
    call mpp_write_meta(unit,'vertex_convention', cval='SWCCW')

    if (tripolar_grid) then
       call mpp_write_meta(unit,'join_lat',rval=lat_join)
       call mpp_write_meta(unit, 'y_boundary_type',cval='fold_north_edge')
    else if(cyclic_y) then
       call mpp_write_meta(unit, 'y_boundary_type',cval='cyclic')
    else
       call mpp_write_meta(unit,'y_boundary_type',cval='solid_walls')
    endif

    if (cyclic_x) then
       call mpp_write_meta(unit,'x_boundary_type',cval='cyclic')
    else
       call mpp_write_meta(unit,'x_boundary_type',cval='solid_walls')
    endif

    if(f_plane) call mpp_write_meta(unit,'f_plane', cval='y')
    if(beta_plane) call mpp_write_meta(unit,'beta_plane', cval='y')
    if(f_plane .or. beta_plane) call mpp_write_meta(unit,'f_plane_latitude',rval=f_plane_latitude)

  end subroutine write_hgrid_global_meta

  !#######################################################################
  ! <SUBROUTINE NAME="write_hgrid_meta">

  !   <OVERVIEW>
  !     Write out horizontal grid meta data.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     call write_hgrid_meta(unit, Hgrid, axis_x, axis_y)
  !   </TEMPLATE>
  !   <IN NAME="unit" TYPE="integer" >
  !     The unit corresponding the output netcdf file. Always is returned by mpp_open.
  !   </IN>
  !   <IN NAME="Hgrid" TYPE="hgrid_data_type">
  !     A derived-type variable that contains horizontal grid information.
  !   </IN>
  !   <OUT NAME="axis_x, axis_y" TYPE="type(axistype), optional">
  !     axis of T-cell center
  !   </OUT>
  ! </SUBROUTINE>

  subroutine write_hgrid_field_meta(file)
    character(len=*), intent(in) :: file

    if(mpp_pe() .ne. mpp_root_pe() ) return

    !--- write out T-cell field meta --------------------------------
    call write_cell_meta(file, 'T' )

    !--- write out E-cell field meta --------------------------------
    call write_cell_meta(file, 'E' )

    !--- write out N-cell field meta --------------------------------
    call write_cell_meta(file, 'N' )

    !--- write out C-cell field meta --------------------------------
    call write_cell_meta(file, 'C' )

    return

  end subroutine write_hgrid_field_meta

  !#######################################################################
  ! <SUBROUTINE NAME="hgrid_end">

  !   <OVERVIEW>
  !     Destruction routine.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Deallocates memory used by "hgrid_data_type" variables.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call hgrid_end ( Hgrid )
  !   </TEMPLATE>
  !   <INOUT NAME="Hgrid" TYPE="hgrid_data_type">
  !     A derived-type variable that contains horizontal grid information.
  !   </INOUT>
  ! </SUBROUTINE>

  subroutine hgrid_end(Hgrid)

    type(hgrid_data_type), intent(inout) :: Hgrid
    !--- release memory of module variables ------------------------------

    deallocate(xt0, xu0, yt0, yu0)
    !--- release memory of Hgrid T-cell data -------------------------------
    call deallocate_hgrid_cell(Hgrid%T)

    !--- release memory of Hgrid E-cell data -------------------------------
    call deallocate_hgrid_cell(Hgrid%E)

    !--- release memory of Hgrid N-cell data -------------------------------
    call deallocate_hgrid_cell(Hgrid%N)

    !--- release memory of Hgrid C-cell data -------------------------------
    call deallocate_hgrid_cell(Hgrid%C)

    module_is_initialized = .false.

    return

  end subroutine hgrid_end

  !#######################################################################
  !allocate memory to the hgrid data type
  subroutine allocate_hgrid(Hgrid)
    type(hgrid_data_type), intent(inout) :: Hgrid

    !--- allocate memory to Hgrid T-cell data variables ------------ 
    call allocate_hgrid_cell(Hgrid%T)
    !--- allocate memory to Hgrid E-cell data variables ------------ 
    call allocate_hgrid_cell(Hgrid%E)
    !--- allocate memory to Hgrid N-cell data variables ------------ 
    call allocate_hgrid_cell(Hgrid%N)
    !--- allocate memory to Hgrid C-cell data variables ------------ 
    call allocate_hgrid_cell(Hgrid%C)

    return
  end subroutine allocate_hgrid

  !#######################################################################
  !--- generate spherical grid
  subroutine spherical_grid_init(Hgrid)

    type(hgrid_data_type), intent(inout) :: Hgrid

    !---------------------------------------------------------------------
    !--- calculate face length, half length area and rotation angle of T-cell
    call spherical_cell_length_area(Hgrid%T, Hgrid%T%x(isc:iec,jsc:jec), Hgrid%T%y(isc:iec,jsc:jec),             &
         Hgrid%E%x(isd:iec,jsc:jec), Hgrid%E%y(isd:iec,jsc:jec), Hgrid%N%x(isc:iec,jsd:jec),     &
         Hgrid%N%y(isc:iec,jsd:jec), Hgrid%C%x(isd:iec,jsd:jec), Hgrid%C%y(isd:iec,jsd:jec)  )

    !---------------------------------------------------------------------
    !--- calculate face length, half length, area and rotation angle of E-cell

    call spherical_cell_length_area(Hgrid%E, Hgrid%E%x(isc:iec,jsc:jec), Hgrid%E%y(isc:iec,jsc:jec),             &
         Hgrid%T%x(isc:ied,jsc:jec), Hgrid%T%y(isc:ied,jsc:jec), Hgrid%C%x(isc:iec,jsd:jec),     &
         Hgrid%C%y(isc:iec,jsd:jec), Hgrid%N%x(isc:ied,jsd:jec), Hgrid%C%y(isc:ied,jsd:jec)  )

    !---------------------------------------------------------------------
    !--- calculate face length, half length, area and rotation angle of N-cell
    call spherical_cell_length_area(Hgrid%N, Hgrid%N%x(isc:iec,jsc:jec), Hgrid%N%y(isc:iec,jsc:jec),             &
         Hgrid%C%x(isd:iec,jsc:jec), Hgrid%C%y(isd:iec,jsc:jec), Hgrid%T%x(isc:iec,jsc:jed),     &
         Hgrid%T%y(isc:iec,jsc:jed), Hgrid%E%x(isd:iec,jsc:jed), Hgrid%E%y(isd:iec,jsc:jed)  )

    !---------------------------------------------------------------------
    !--- calculate face length, half length, area and rotation angle of C-cell
    call spherical_cell_length_area(Hgrid%C, Hgrid%C%x(isc:iec,jsc:jec), Hgrid%C%y(isc:iec,jsc:jec),             &
         Hgrid%N%x(isc:ied,jsc:jec), Hgrid%N%y(isc:ied,jsc:jec), Hgrid%E%x(isc:iec,jsc:jed),     &
         Hgrid%E%y(isc:iec,jsc:jed), Hgrid%T%x(isc:ied,jsc:jed), Hgrid%T%y(isc:ied,jsc:jed)  )

    !--- for spherical grid, rotation angle always is 0 ------------------
    Hgrid%T%angle = 0.0
    Hgrid%E%angle = 0.0
    Hgrid%N%angle = 0.0
    Hgrid%C%angle = 0.0  

    return
  end subroutine spherical_grid_init


  !#######################################################################
  !--- generate f_plane/beta_plane grid
  subroutine f_plane_grid_init(Hgrid)
    type(hgrid_data_type), intent(inout) :: Hgrid

    !---------------------------------------------------------------------
    !--- calculate face length, half length area and rotation angle of T-cell
    call f_plane_cell_length_area(Hgrid%T, Hgrid%T%x(isc:iec,jsc:jec), Hgrid%T%y(isc:iec,jsc:jec),   &
         Hgrid%E%x(isd:iec,jsc:jec), Hgrid%E%y(isd:iec,jsc:jec), Hgrid%N%x(isc:iec,jsd:jec),         &
         Hgrid%N%y(isc:iec,jsd:jec), Hgrid%C%x(isd:iec,jsd:jec), Hgrid%C%y(isd:iec,jsd:jec)  )

    !---------------------------------------------------------------------
    !--- calculate face length, half length, area and rotation angle of E-cell

    call f_plane_cell_length_area(Hgrid%E, Hgrid%E%x(isc:iec,jsc:jec), Hgrid%E%y(isc:iec,jsc:jec),   &
         Hgrid%T%x(isc:ied,jsc:jec), Hgrid%T%y(isc:ied,jsc:jec), Hgrid%C%x(isc:iec,jsd:jec),         &
         Hgrid%C%y(isc:iec,jsd:jec), Hgrid%N%x(isc:ied,jsd:jec), Hgrid%C%y(isc:ied,jsd:jec)  )

    !---------------------------------------------------------------------
    !--- calculate face length, half length, area and rotation angle of N-cell
    call f_plane_cell_length_area(Hgrid%N, Hgrid%N%x(isc:iec,jsc:jec), Hgrid%N%y(isc:iec,jsc:jec),   &
         Hgrid%C%x(isd:iec,jsc:jec), Hgrid%C%y(isd:iec,jsc:jec), Hgrid%T%x(isc:iec,jsc:jed),         &
         Hgrid%T%y(isc:iec,jsc:jed), Hgrid%E%x(isd:iec,jsc:jed), Hgrid%E%y(isd:iec,jsc:jed)  )

    !---------------------------------------------------------------------
    !--- calculate face length, half length, area and rotation angle of C-cell
    call f_plane_cell_length_area(Hgrid%C, Hgrid%C%x(isc:iec,jsc:jec), Hgrid%C%y(isc:iec,jsc:jec),   &
         Hgrid%N%x(isc:ied,jsc:jec), Hgrid%N%y(isc:ied,jsc:jec), Hgrid%E%x(isc:iec,jsc:jed),         &
         Hgrid%E%y(isc:iec,jsc:jed), Hgrid%T%x(isc:ied,jsc:jed), Hgrid%T%y(isc:ied,jsc:jed)  )

    !--- for spherical grid, rotation angle always is 0 ------------------
    Hgrid%T%angle = 0.0
    Hgrid%E%angle = 0.0
    Hgrid%N%angle = 0.0
    Hgrid%C%angle = 0.0  

    return
  end subroutine f_plane_grid_init

 !#######################################################################
  !--- generate simple cartesian grid
  subroutine simple_cartesian_grid_init(Hgrid)
    type(hgrid_data_type), intent(inout) :: Hgrid

    !---------------------------------------------------------------------
    !--- calculate face length, half length area and rotation angle of T-cell
    call cartesian_cell_length_area(Hgrid%T)

    !---------------------------------------------------------------------
    !--- calculate face length, half length, area and rotation angle of E-cell

    call cartesian_cell_length_area(Hgrid%E)

    !---------------------------------------------------------------------
    !--- calculate face length, half length, area and rotation angle of N-cell
    call cartesian_cell_length_area(Hgrid%N)

    !---------------------------------------------------------------------
    !--- calculate face length, half length, area and rotation angle of C-cell
    call cartesian_cell_length_area(Hgrid%C)

    !--- for spherical grid, rotation angle always is 0 ------------------
    Hgrid%T%angle = 0.0
    Hgrid%E%angle = 0.0
    Hgrid%N%angle = 0.0
    Hgrid%C%angle = 0.0  

    return
  end subroutine simple_cartesian_grid_init


  !#######################################################################
  !--- generate tripolar grid
  subroutine tripolar_grid_init(Hgrid)

    type(hgrid_data_type), intent(inout) :: Hgrid

    !--- local variables--------------------------------------------------
    integer :: i, j
    real :: lon_last, lat_join_old
    !---------------------------------------------------------------------
    lon_start = x_lon(1)
    lon_end   = x_lon(2)
    ! recompute join latitude based on nearest spherical latitude
    lat_join_old = lat_join
    lat_join = Hgrid%C%y(1,nearest_index(lat_join, yu0(1:nj)))
    lon_bpeq = lon_start + 90.
    lon_bpnp = lon_start 
    lon_bpsp = lon_start+180.

    if(lat_join_old .ne. lat_join) then
       write(stdout(),*) 'NOTE: Change join latitude from ', lat_join_old, 'to ', lat_join
    endif

    !---------------------------------------------------------------------
    ! Transform from bipolar grid coordinates (bp_lon, bp_lat) to
    ! geographic coordinates (geolon_t, geolat_t) following R. Murray,
    ! "Explicit generation of orthogonal grids for ocean models",
    ! 1996, J.Comp.Phys., v. 126, p. 251-273.  All equation
    ! numbers refer to the Murray paper.
    !---------------------------------------------------------------------
    lam0 = mod(lon_bpeq*D2R + tpi,tpi)
    rp   = tan((hpi-lat_join*D2R)/2.)             ! eqn. 2

    !--- update T-cell length at bi-polar region ---------------------------
    call update_cell_length(Hgrid%T, Hgrid%T%y(1,jsc:jec), Hgrid%T%x(isc:iec,jsc:jec), Hgrid%T%y(isc:iec,jsc:jec), &
         Hgrid%E%x(isd:iec,jsc:jec), Hgrid%E%y(isd:iec,jsc:jec), Hgrid%N%x(isc:iec,jsd:jec),                       &
         Hgrid%N%y(isc:iec,jsd:jec), Hgrid%C%x(isd:iec,jsd:jec), Hgrid%C%y(isd:iec,jsd:jec)  )

    !--- update E-cell length at bi-polar region ---------------------------
    call update_cell_length(Hgrid%E, Hgrid%T%y(1,jsc:jec), Hgrid%E%x(isc:iec,jsc:jec), Hgrid%E%y(isc:iec,jsc:jec), &
         Hgrid%T%x(isc:ied,jsc:jec), Hgrid%T%y(isc:ied,jsc:jec), Hgrid%C%x(isc:iec,jsd:jec),                       &
         Hgrid%C%y(isc:iec,jsd:jec), Hgrid%N%x(isc:ied,jsd:jec), Hgrid%C%y(isc:ied,jsd:jec)  )

    !--- update N-cell length at bi-polar region ---------------------------
    call update_cell_length(Hgrid%N, Hgrid%T%y(1,jsc:jec), Hgrid%N%x(isc:iec,jsc:jec), Hgrid%N%y(isc:iec,jsc:jec), &
         Hgrid%C%x(isd:iec,jsc:jec), Hgrid%C%y(isd:iec,jsc:jec), Hgrid%T%x(isc:iec,jsc:jed),                       &
         Hgrid%T%y(isc:iec,jsc:jed), Hgrid%E%x(isd:iec,jsc:jed), Hgrid%E%y(isd:iec,jsc:jed)  )

    !--- update C-cell length at bi-polar region ---------------------------
    call update_cell_length(Hgrid%C, Hgrid%T%y(1,jsc:jec), Hgrid%C%x(isc:iec,jsc:jec), Hgrid%C%y(isc:iec,jsc:jec), &
         Hgrid%N%x(isc:ied,jsc:jec), Hgrid%N%y(isc:ied,jsc:jec), Hgrid%E%x(isc:iec,jsc:jed),                       &
         Hgrid%E%y(isc:iec,jsc:jed), Hgrid%T%x(isc:ied,jsc:jed), Hgrid%T%y(isc:ied,jsc:jed)  )

    !--- update the length of north to make sure the last grid box is folded.
    call update_north_length(Hgrid)

    ! define corner locations
    do j=0,nj+1
       do i=0,ni+1
          lon_last = Hgrid%C%x(max(i-1,0),j)
          if (Hgrid%T%y(i,min(nj+1,j+1)) >= lat_join) then
             call tp_trans(Hgrid%C%x(i,j),Hgrid%C%y(i,j),lon_last) 
             ! geographical position of bipolar points
          end if
       end do
    end do

    ! define tracer, east and north locations
    do j=0,nj+1
       do i=0,ni+1
          lon_last = Hgrid%T%x(max(i-1,0),j)
          if (Hgrid%T%y(1,j) >= lat_join) then
             call tp_trans(Hgrid%T%x(i,j),Hgrid%T%y(i,j), lon_last) 
          end if
       end do
    end do

    ! define tracer locations
    do j=0,nj+1
       do i=0,ni+1
          lon_last = Hgrid%E%x(max(i-1,0),j)
          if (Hgrid%T%y(1,j) >= lat_join) then
             call tp_trans(Hgrid%E%x(i,j),Hgrid%E%y(i,j), lon_last) 
          end if
       end do
    end do

    ! define north locations
    do j=0,nj+1
       do i=0,ni+1
          lon_last = Hgrid%N%x(max(i-1,0),j)
          if (Hgrid%T%y(1,min(nj+1,j+1)) >= lat_join) then
             call tp_trans(Hgrid%N%x(i,j),Hgrid%N%y(i,j), lon_last) 
          end if
       end do
    end do

    !--- update T-cell area at tripolar region ---------------------------
    call update_cell_area(Hgrid%T,  Hgrid%T%y(1,jsc:jec),                                           &
         Hgrid%T%x(isc:iec,jsc:jec), Hgrid%T%y(isc:iec,jsc:jec), Hgrid%E%x(isd:iec,jsc:jec), Hgrid%E%y(isd:iec,jsc:jec),   &
         Hgrid%N%x(isc:iec,jsd:jec), Hgrid%N%y(isc:iec,jsd:jec), Hgrid%C%x(isd:iec,jsd:jec), Hgrid%C%y(isd:iec,jsd:jec)  )

    !--- update E-cell area at bi-polar region ---------------------------
    call update_cell_area(Hgrid%E,  Hgrid%T%y(1,jsc:jec),                                               &
         Hgrid%E%x(isc:iec,jsc:jec), Hgrid%E%y(isc:iec,jsc:jec), Hgrid%T%x(isc:ied,jsc:jec), Hgrid%T%y(isc:ied,jsc:jec),   &
         Hgrid%C%x(isc:iec,jsd:jec), Hgrid%C%y(isc:iec,jsd:jec), Hgrid%N%x(isc:ied,jsd:jec), Hgrid%N%y(isc:ied,jsd:jec)  )

    !--- update N-cell area at bi-polar region ---------------------------
    call update_cell_area(Hgrid%N,  Hgrid%T%y(1,jsc:jec),                                                  &
         Hgrid%N%x(isc:iec,jsc:jec), Hgrid%N%y(isc:iec,jsc:jec), Hgrid%C%x(isd:iec,jsc:jec), Hgrid%C%y(isd:iec,jsc:jec),    &
         Hgrid%T%x(isc:iec,jsc:jed), Hgrid%T%y(isc:iec,jsc:jed), Hgrid%E%x(isd:iec,jsc:jed), Hgrid%E%y(isd:iec,jsc:jed) )

    !--- update C-cell area at bi-polar region ---------------------------
    call update_cell_area(Hgrid%C,  Hgrid%T%y(1,jsc:jec),                                                    &
         Hgrid%C%x(isc:iec,jsc:jec), Hgrid%C%y(isc:iec,jsc:jec), Hgrid%N%x(isc:ied,jsc:jec), Hgrid%N%y(isc:ied,jsc:jec),    &
         Hgrid%E%x(isc:iec,jsc:jed), Hgrid%E%y(isc:iec,jsc:jed), Hgrid%T%x(isc:ied,jsc:jed), Hgrid%T%y(isc:ied,jsc:jed) )  

    !--- update rotation angle of T-cell -----------------------------
    call update_cell_angle(Hgrid%T%angle, Hgrid%T%y(isc:iec,jsc:jec), &
         Hgrid%E%x(isd:iec,jsc:jec), Hgrid%E%y(isd:iec,jsc:jec) )

    !--- update rotation angle of E-cell -----------------------------
    call update_cell_angle(Hgrid%E%angle, Hgrid%E%y(isc:iec,jsc:jec), &
         Hgrid%T%x(isc:ied,jsc:jec), Hgrid%T%y(isc:ied,jsc:jec) )

    !--- update rotation angle of N-cell -----------------------------
    call update_cell_angle(Hgrid%N%angle, Hgrid%N%y(isc:iec,jsc:jec), &
         Hgrid%C%x(isd:iec,jsc:jec), Hgrid%C%y(isd:iec,jsc:jec) )

    !--- update rotation angle of C-cell -----------------------------
    call update_cell_angle(Hgrid%C%angle, Hgrid%C%y(isc:iec,jsc:jec), &
         Hgrid%N%x(isc:ied,jsc:jec), Hgrid%N%y(isc:ied,jsc:jec) ) 
    return

  end subroutine tripolar_grid_init

  !#######################################################################
  !--- define vertices for each cell
  subroutine define_vertices(Hgrid)

    type(hgrid_data_type), intent(inout) :: Hgrid

    !--- define vertices of T-cell
    call define_cell_vertices(Hgrid%T, Hgrid%C, 0, 0)
    !--- define vertices of E-cell
    call define_cell_vertices(Hgrid%E, Hgrid%N, 1, 0)
    !--- define vertices of N-cell
    call define_cell_vertices(Hgrid%N, Hgrid%E, 0, 1)
    !--- define vertices of C-cell
    call define_cell_vertices(Hgrid%C, Hgrid%T, 1, 1)

    return
  end subroutine define_vertices

  !#######################################################################
  !--- memory allocation
  subroutine allocate_hgrid_cell(cell)

    type(cell_type), intent(inout) :: cell

    allocate(cell%x(0:ni+1,0:nj+1), cell%y(0:ni+1,0:nj+1),  &
         cell%x_vert(isc:iec,jsc:jec,4),  cell%y_vert(isc:iec,jsc:jec,4),   &
         cell%area(isc:iec,jsc:jec),      cell%angle(isc:iec,jsc:jec),      &
         cell%ds_00_02(isc:iec,jsc:jec),  cell%ds_20_22(isc:iec,jsc:jec),   &
         cell%ds_02_22(isc:iec,jsc:jec),  cell%ds_00_20(isc:iec,jsc:jec),   &
         cell%ds_00_01(isc:iec,jsc:jec),  cell%ds_01_02(isc:iec,jsc:jec),   & 
         cell%ds_02_12(isc:iec,jsc:jec),  cell%ds_12_22(isc:iec,jsc:jec),   &
         cell%ds_21_22(isc:iec,jsc:jec),  cell%ds_20_21(isc:iec,jsc:jec),   &
         cell%ds_10_20(isc:iec,jsc:jec),  cell%ds_00_10(isc:iec,jsc:jec),   &
         cell%ds_01_11(isc:iec,jsc:jec),  cell%ds_11_12(isc:iec,jsc:jec),   &
         cell%ds_11_21(isc:iec,jsc:jec),  cell%ds_10_11(isc:iec,jsc:jec),   &
         cell%ds_01_21(isc:iec,jsc:jec),  cell%ds_10_12(isc:iec,jsc:jec) )
    return

  end subroutine allocate_hgrid_cell

  !#######################################################################
  !--- release memory
  subroutine deallocate_hgrid_cell(cell)
    type(cell_type), intent(inout) :: cell

    deallocate(cell%x, cell%y, cell%x_vert, cell%y_vert, cell%area, cell%angle, &
         cell%ds_00_02, cell%ds_20_22, cell%ds_02_22, cell%ds_00_20,      &
         cell%ds_00_01, cell%ds_01_02, cell%ds_02_12, cell%ds_12_22,      &
         cell%ds_21_22, cell%ds_20_21, cell%ds_10_20, cell%ds_00_10,      &
         cell%ds_01_11, cell%ds_11_12, cell%ds_11_21, cell%ds_10_11,      &
         cell%ds_01_21,  cell%ds_10_12 ) 
    return

  end subroutine deallocate_hgrid_cell

  !#######################################################################
  !--- write meta data 
  subroutine write_cell_meta(file, cell_id )

    character(len=*), intent(in) :: file
    character(len=1), intent(in) :: cell_id
    character(len=1)             :: x_pos, y_pos

    select case(cell_id)
    case('T')
       x_pos='T'; y_pos='T'
    case('E')
       x_pos='C'; y_pos='T'
    case('N')
       x_pos='T'; y_pos='C'
    case('C')
       x_pos='C'; y_pos='C'
    end select

    call write_field_meta(file, 'x_'//cell_id, 'degree_east',  &
         'Geographic longitude of '//cell_id//'_cell centers', 2, x_pos, y_pos)
    call write_field_meta(file, 'y_'//cell_id, 'degree_north',  &
         'Geographic latitude of '//cell_id//'_cell centers', 2, x_pos, y_pos)
    call write_field_meta(file,  'x_vert_'//cell_id,'degree_east', 'Geographic longitude of ' &
         //cell_id//'_cell vertices begin southwest counterclockwise', 3, x_pos, y_pos)
    call write_field_meta(file,  'y_vert_'//cell_id,'degree_north', 'Geographic latitude of ' &
         //cell_id //'_cell vertices begin southwest counterclockwise', 3, x_pos, y_pos)
    call write_field_meta(file,  'area_'//cell_id, 'm2','Area of '//cell_id//'_cell ',2,x_pos, y_pos)
    call write_field_meta(file,  'angle_'//cell_id, 'degree','Angle clockwise between logical ' &
         //'and geographic east of '// cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file,  'ds_00_02_'//cell_id, 'm',  &
         'Length of western face of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_20_22_'//cell_id, 'm',  &
         'Length of eastern face of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_02_22_'//cell_id, 'm',  &
         'Length of northern face of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_00_20_'//cell_id, 'm',  &
         'Length of southern face of '//cell_id//'_cell', 2,x_pos, y_pos)  
    call write_field_meta(file, 'ds_00_01_'//cell_id, 'm',  &
         'Distance from southwest corner to western face center of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_01_02_'//cell_id, 'm',  &
         'Distance from northwest corner to western face center of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_02_12_'//cell_id, 'm',  &
         'Distance from northwest corner to northern face center of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_12_22_'//cell_id, 'm',  &
         'Distance from northeast corner to northern face center of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_21_22_'//cell_id, 'm',  &
         'Distance from northeast corner to eastern face center of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_20_21_'//cell_id, 'm',  &
         'Distance from southeast corner to eastern face center of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_10_20_'//cell_id, 'm',  &
         'Distance from southeast corner to southern face center of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_00_10_'//cell_id, 'm',  &
         'Distance from southwest corner to southern face center of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_01_11_'//cell_id, 'm',  &
         'Distance from center to western face of '//cell_id//'_cell', 2, x_pos, y_pos)
    call write_field_meta(file, 'ds_11_12_'//cell_id, 'm',  &
         'Distance from center to northern face of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_11_21_'//cell_id, 'm',  &
         'Distance from center to eastern face of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_10_11_'//cell_id, 'm',  &
         'Distance from center to southern face of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_01_21_'//cell_id, 'm', 'width of '//cell_id//'_cell', 2,x_pos, y_pos)
    call write_field_meta(file, 'ds_10_12_'//cell_id, 'm','height of '//cell_id//'_cell', 2,x_pos, y_pos)
    return

  end subroutine write_cell_meta

  !#######################################################################
  !--- write out data
  subroutine write_cell_data(file, cell, cell_id)

    character(len=*), intent(in) :: file
    type(cell_type),  intent(in) :: cell
    character(len=1), intent(in) :: cell_id
    real, allocatable :: tmp_2d(:,:), tmp_3d(:,:,:)

    allocate(tmp_2d(ni,nj), tmp_3d(ni,nj,4))

    !--- write out center of cell
    tmp_2d = cell%x(1:ni,1:nj)
    call write_field_data(file, 'x_'//cell_id, tmp_2d)
    tmp_2d = cell%y(1:ni,1:nj)
    call write_field_data(file, 'y_'//cell_id, tmp_2d)  

    !--- write out vertices cell 
    call mpp_global_field(Domain, cell%x_vert, tmp_3d)
    call write_field_data(file, 'x_vert_'//cell_id, tmp_3d)
    call mpp_global_field(Domain, cell%y_vert, tmp_3d)
    call write_field_data(file, 'y_vert_'//cell_id, tmp_3d)

    !--- write out area of cell 
    call mpp_global_field(Domain, cell%area, tmp_2d)
    call write_field_data(file, 'area_'//cell_id, tmp_2d)

    !--- write out angle between i-unit and x-unit vector of cell 
    call mpp_global_field(Domain, cell%angle, tmp_2d)
    call write_field_data(file, 'angle_'//cell_id, tmp_2d)

    !--- write out half and face length of cell
    call mpp_global_field(Domain, cell%ds_00_02, tmp_2d) 
    call write_field_data(file, 'ds_00_02_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_20_22, tmp_2d) 
    call write_field_data(file, 'ds_20_22_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_02_22, tmp_2d) 
    call write_field_data(file, 'ds_02_22_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_00_20, tmp_2d) 
    call write_field_data(file, 'ds_00_20_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_00_01, tmp_2d) 
    call write_field_data(file, 'ds_00_01_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_01_02, tmp_2d) 
    call write_field_data(file, 'ds_01_02_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_02_12, tmp_2d) 
    call write_field_data(file, 'ds_02_12_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_12_22, tmp_2d) 
    call write_field_data(file, 'ds_12_22_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_21_22, tmp_2d) 
    call write_field_data(file, 'ds_21_22_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_20_21, tmp_2d) 
    call write_field_data(file, 'ds_20_21_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_10_20, tmp_2d) 
    call write_field_data(file, 'ds_10_20_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_00_10, tmp_2d) 
    call write_field_data(file, 'ds_00_10_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_01_11, tmp_2d) 
    call write_field_data(file, 'ds_01_11_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_11_12, tmp_2d) 
    call write_field_data(file, 'ds_11_12_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_11_21, tmp_2d) 
    call write_field_data(file, 'ds_11_21_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_10_11, tmp_2d) 
    call write_field_data(file, 'ds_10_11_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_01_21, tmp_2d) 
    call write_field_data(file, 'ds_01_21_'//cell_id, tmp_2d)
    call mpp_global_field(Domain, cell%ds_10_12, tmp_2d) 
    call write_field_data(file, 'ds_10_12_'//cell_id, tmp_2d)

    deallocate(tmp_2d, tmp_3d)

    return

  end subroutine write_cell_data

  !#######################################################################
  !--- define cell vertices
  subroutine define_cell_vertices(cell_out, cell_in, ioff, joff )
    type(cell_type), intent(inout) :: cell_out
    type(cell_type),   intent(in)  :: cell_in
    integer,           intent(in)  :: ioff, joff

    cell_out%x_vert(isc:iec,jsc:jec,1) = cell_in%x(isc-1+ioff:iec-1+ioff, jsc-1+joff:jec-1+joff )
    cell_out%x_vert(isc:iec,jsc:jec,2) = cell_in%x(isc+ioff  :iec+ioff,   jsc-1+joff:jec-1+joff )
    cell_out%x_vert(isc:iec,jsc:jec,3) = cell_in%x(isc+ioff  :iec+ioff,   jsc+joff  :jec+joff   )
    cell_out%x_vert(isc:iec,jsc:jec,4) = cell_in%x(isc-1+ioff:iec-1+ioff, jsc+joff  :jec+joff   )
    cell_out%y_vert(isc:iec,jsc:jec,1) = cell_in%y(isc-1+ioff:iec-1+ioff, jsc-1+joff:jec-1+joff )
    cell_out%y_vert(isc:iec,jsc:jec,2) = cell_in%y(isc+ioff  :iec+ioff,   jsc-1+joff:jec-1+joff )
    cell_out%y_vert(isc:iec,jsc:jec,3) = cell_in%y(isc+ioff  :iec+ioff,   jsc+joff  :jec+joff   )
    cell_out%y_vert(isc:iec,jsc:jec,4) = cell_in%y(isc-1+ioff:iec-1+ioff, jsc+joff  :jec+joff   )

    return

  end subroutine define_cell_vertices

  !#######################################################################
  !--- distance (in degrees) between points on lat. circle
  function lat_dist(x1,x2) 
    real :: x1, x2, lat_dist

    lat_dist=min(mod(x1-x2+720,360.),mod(x2-x1+720,360.))

  end function lat_dist

  !#######################################################################
  !--- find bipolar grid longitude given geo. coordinates
  function bp_lam(x,y)
    real :: x, y, bp_lam
    !  bp_lam = ((90-y)/(90-lat_join))*90
    ! invert eqn. 5 with phic=0 to place point at specified geo. lat
    bp_lam = 2.*atan(tan((hpi-y*D2R)/2)/rp)/D2R
    if (lat_dist(x,lon_bpeq)<90.) bp_lam = -bp_lam
  end function bp_lam

  !#######################################################################
  !--- find bipolar grid latitude given geo. coordinates
  function bp_phi(x,y) ! find bipolar grid latitude given geo. coordinates
    real :: x, y, bp_phi

    if (lat_dist(x,lon_bpsp)<90.) then
       bp_phi = (-90+lat_dist(x,lon_bpsp))
    else
       bp_phi = ( 90-lat_dist(x,lon_bpnp))
    end if
  end function bp_phi

  !#######################################################################
  !--- calculate tripolar grid
  subroutine tp_trans(lon,lat,lon_ref)

    real, intent(inout) :: lon, lat
    real,    intent(in) :: lon_ref

    real :: lamc, phic, lams, chic, phis

    lamc = bp_lam(lon,lat)*D2R
    phic = bp_phi(lon,lat)*D2R


    if (abs(lat-90.) < 1.e-4) then
       if (phic > 0) then
          lon=lon_in_range(lon_start,lon_ref)
       else
          lon=lon_start+180.
       endif
       chic = acos(cos(lamc)*cos(phic))                          ! eqn. 6
       phis = pi/2-2*atan(rp*tan(chic/2))                        ! eqn. 5
       lat = phis/D2R
       return
    endif

    if (abs(lamc) < 1.e-4 .and. abs(phic) < 1.e-4) then
       lat=90.;lon=lon_ref
    else
       lams = mod(lam0+pi+pi/2-atan2(sin(lamc),tan(phic)),2*pi)  ! eqn. 5
       chic = acos(cos(lamc)*cos(phic))                          ! eqn. 6
       phis = pi/2-2*atan(rp*tan(chic/2))                        ! eqn. 5
       lon = lams/D2R
       lon = lon_in_range(lon,lon_ref) 
       lat = phis/D2R
    endif

    return

  end subroutine tp_trans

  !#######################################################################
  !--- distant on the earth
  function dist(a, b, met1, met2)

    real, intent(in) :: a, b, met1, met2
    real             :: dist

    dist = abs(a-b)/radian*(met1+met2)/2.

  end function dist

  !#######################################################################
  !--- distance between spherical grid on the earth
  function spherical_dist(x1,y1,x2,y2)
    real, intent(in) :: x1, y1, x2, y2
    real             :: spherical_dist, h1, h2

    spherical_dist = 0.0
    if(x1 == x2) then
       h1 = radius
       h2 = radius
       spherical_dist = dist(y1,y2,h1,h2)
    else if(y1 == y2) then
       h1 = radius * cos(y1/RADIAN)
       h2 = radius * cos(y2/RADIAN) 
       spherical_dist = dist(x1,x2,h1,h2)
    else 
       call mpp_error(FATAL,'hgrid_mod: This is not rectangular grid')
    endif
    return

  end function spherical_dist

 !#######################################################################
  !--- distance between cartesian grid on the earth
  function cartesian_dist(x1,y1,x2,y2)
    real, intent(in) :: x1, y1, x2, y2
    real             :: cartesian_dist

    cartesian_dist = 0.0
    if(x1 == x2) then
       cartesian_dist = abs(y2-y1)/radian*radius
    else if(y1 == y2) then
       cartesian_dist = abs(x2-x1)/radian*radius*cos(f_plane_latitude*D2R)
    else 
       call mpp_error(FATAL,'hgrid_mod( from cartesian_dist): This is not rectangular grid')
    endif
    return

  end function cartesian_dist

  !#######################################################################
  !--- distance of bipolar grids
  function bipolar_dist(x1,y1,x2,y2,num_div)
    real,     intent(in) :: x1, y1, x2, y2
    integer, intent(out) :: num_div
    real                 :: bipolar_dist

    real, allocatable, dimension(:) :: x, y, h1, h2 , bp_lon, bp_lat, metric 
    real :: chic
    integer :: n
    !--- right now suppose each line is divied into one segment ----------
    !--- higher order approximation will be implemented later ------------
    num_div = 1

    allocate(x(num_div+1),y(num_div+1), h1(num_div+1), h2(num_div+1), &
         bp_lon(num_div+1), bp_lat(num_div+1), metric(num_div+1) )
    do n = 1, num_div+1
       x(n) = x1 + real(n-1)*(x2-x1)/real(num_div)
       y(n) = y1 + real(n-1)*(y2-y1)/real(num_div)
    enddo

    !--- get the bipolar grid and metric term ----------------------------
    do n =1, num_div+1
       bp_lon(n) = bp_lam(x(n),y(n)) ! longitude (degrees) in bipolar grid system
       bp_lat(n) = bp_phi(x(n),y(n)) ! latitude (degrees) in bipolar grid system
       h1(n) = radius*cos(bp_lat(n)*D2R)
       h2(n) = radius
       metric(n) = 1.0
       if (abs(y(n)-90.0) < 1.e-4 .or. abs(bp_lon(n)*D2R) .ge. 1.e-4 .or. abs(bp_lat(n)*D2R) .ge. 1.e-4) then
          chic = acos(cos(bp_lon(n)*D2R)*cos(bp_lat(n)*D2R))  ! eqn. 6
          metric(n) = rp*(1/cos(chic/2)**2)/(1+(rp**2)*(tan(chic/2)**2)) ! eq 3
       endif
    enddo

    !--- then calculate the distance -------------------------------------
    bipolar_dist = 0.0
    do n = 1, num_div
       if(x1 == x2) then
          bipolar_dist = bipolar_dist+dist(bp_lon(n),bp_lon(n+1),metric(n)*h1(n),metric(n+1)*h1(n+1))
       else if(y1 == y2) then
          bipolar_dist = bipolar_dist+dist(bp_lat(n),bp_lat(n+1),metric(n)*h2(n),metric(n+1)*h2(n+1))
       endif
    enddo

    deallocate(x, y, h1, h2, bp_lon, bp_lat, metric)

    return

  end function bipolar_dist

  !#######################################################################
  !--- rectangular grid box area
  function spherical_box_area(x1,y1,x2,y2,x3,y3,x4,y4)

    real, intent(in) :: x1, y1, x2, y2, x3, y3, x4, y4
    real :: spherical_box_area

    real, dimension(4) :: x_vert,y_vert
    integer :: i, ip, n
    real    :: lat1, lat2, dx

    x_vert(1) = x1; y_vert(1) = y1
    x_vert(2) = x2; y_vert(2) = y2
    x_vert(3) = x3; y_vert(3) = y3
    x_vert(4) = x4; y_vert(4) = y4

    spherical_box_area = 0.0
    n = size(x_vert)
    do i = 1, n
       ip = i+1
       if(ip .gt. n) ip = ip - n
       dx = x_vert(ip) - x_vert(i)
       if(cyclic_x) then
          if(dx > x_period/2) dx = dx - x_period
          if(dx < -x_period/2) dx = dx + x_period
       end if
       dx = dx*D2R
       if(dx==0.0) cycle
       lat1 = y_vert(ip)*D2R
       lat2 = y_vert(i)*D2R

       if (lat1 == lat2) then ! cheap area calculation along latitude 
          spherical_box_area = spherical_box_area - dx*sin(lat1)
       else
          spherical_box_area = spherical_box_area - dx*(sin(lat1)+sin(lat2))/2   !  TRAPEZOID_RULE
       endif
    enddo

    spherical_box_area = spherical_box_area * radius * radius

    return

  end function spherical_box_area

  !#######################################################################
  !--- rectangular grid box area for cartesian grid
  function cartesian_box_area(x1,y1,x2,y2)

    real, intent(in) :: x1, y1, x2, y2
    real :: cartesian_box_area

    real    :: dx, dy

    dx = x2-x1
    if(cyclic_x) then
       if(dx > x_period/2)  dx = dx - x_period
       if(dx < -x_period/2) dx = dx + x_period
    end if
    dx = dx * D2R

    dy = y2-y1
    if(cyclic_y) then
       if(dy > y_period/2)  dy = dy - y_period
       if(dy < -y_period/2) dy = dy + y_period
    end if
    dy = dy * D2R
    cartesian_box_area = dx*dy*cos(f_plane_latitude*D2R)*radius*radius

    return

  end function cartesian_box_area

  !#######################################################################
  !--- bipolar grid area
  function bipolar_area(x1,y1,x2,y2,x3,y3,x4,y4 )
    real, intent(in)    :: x1,y1,x2,y2,x3,y3,x4,y4

    real :: bipolar_area

    real, dimension(8) :: x,y
    integer :: i, ip, n
    real    :: lat1, lat2, dx

    x(1) = x1; y(1) = y1
    x(2) = x2; y(2) = y2
    x(3) = x3; y(3) = y3
    x(4) = x4; y(4) = y4

    !--- first fix the longitude at the pole -----------------------------
    call lon_fix(x, y, 4, n, 180.)

    !--- calculate the area ----------------------------------------------  
    bipolar_area = 0.0

    do i = 1, n
       ip = i+1
       if(ip .gt. n) ip = 1
       dx = (x(ip) - x(i))*D2R
       lat1 = y(ip)*D2R
       lat2 = y(i)*D2R
       if(dx==0.0) cycle
       if(dx > pi)  dx = dx - tpi
       if(dx < -pi) dx = dx + tpi

       if (lat1 == lat2) then ! cheap area calculation along latitude 
          bipolar_area = bipolar_area - dx*sin(lat1)
       else
          bipolar_area = bipolar_area - dx*(sin(lat1)+sin(lat2))/2   !  TRAPEZOID_RULE
       endif
    enddo

    bipolar_area = bipolar_area * radius * radius

  end function bipolar_area

  !#######################################################################
  !calculate face length and half length of each cell for spherical grid.
  subroutine spherical_cell_length_area(cell, x, y, x_e, y_e, x_n, y_n, x_c, y_c)
    type(cell_type),                intent(inout) :: cell
    real, dimension(isc:iec,jsc:jec), intent(in)  :: x, y     ! center of the cell.
    real, dimension(isd:iec,jsc:jec), intent(in)  :: x_e, y_e ! east of the cell.
    real, dimension(isc:iec,jsd:jec), intent(in)  :: x_n, y_n ! north of the cell.
    real, dimension(isd:iec,jsd:jec), intent(in)  :: x_c, y_c ! four vertices of cell

    integer :: i, j
    real :: area1, area2, area3, area4

    do j = jsc,jec
       do i = isc,iec
          !--- define half length ------------------------------------------- 
          cell%ds_00_01(i,j) = spherical_dist(x_e(i-1,j), y_e(i-1,j), x_c(i-1,j-1), y_c(i-1,j-1) )
          cell%ds_01_02(i,j) = spherical_dist(x_c(i-1,j), y_c(i-1,j), x_e(i-1,j),   y_e(i-1,j)   )
          cell%ds_02_12(i,j) = spherical_dist(x_n(i,j),   y_n(i,j),   x_c(i-1,j),   y_c(i-1,j)   )
          cell%ds_12_22(i,j) = spherical_dist(x_c(i,j),   y_c(i,j),   x_n(i,j),     y_n(i,j)     )
          cell%ds_21_22(i,j) = spherical_dist(x_c(i,j),   y_c(i,j),   x_e(i,j),     y_e(i,j)     )
          cell%ds_20_21(i,j) = spherical_dist(x_e(i,j),   y_e(i,j),   x_c(i,j-1),   y_c(i,j-1)   )
          cell%ds_10_20(i,j) = spherical_dist(x_c(i,j-1), y_c(i,j-1), x_n(i,j-1),   y_n(i,j-1)   )
          cell%ds_00_10(i,j) = spherical_dist(x_n(i,j-1), y_n(i,j-1), x_c(i-1,j-1), y_c(i-1,j-1) )
          cell%ds_01_11(i,j) = spherical_dist(x(i,j),     y(i,j),     x_e(i-1,j),   y_e(i-1,j)   )
          cell%ds_11_12(i,j) = spherical_dist(x_n(i,j),   y_n(i,j),   x(i,j),       y(i,j)       )
          cell%ds_11_21(i,j) = spherical_dist(x_e(i,j),   y_e(i,j),   x(i,j),       y(i,j)       )
          cell%ds_10_11(i,j) = spherical_dist(x(i,j),     y(i,j),     x_n(i,j-1),   y_n(i,j-1)   )  
          !--- define full length -------------------------------------------
          cell%ds_00_02(i,j) = cell%ds_00_01(i,j) + cell%ds_01_02(i,j)
          cell%ds_20_22(i,j) = cell%ds_20_21(i,j) + cell%ds_21_22(i,j)
          cell%ds_00_20(i,j) = cell%ds_00_10(i,j) + cell%ds_10_20(i,j)
          cell%ds_02_22(i,j) = cell%ds_02_12(i,j) + cell%ds_12_22(i,j)
          cell%ds_01_21(i,j) = cell%ds_01_11(i,j) + cell%ds_11_21(i,j)
          cell%ds_10_12(i,j) = cell%ds_10_11(i,j) + cell%ds_11_12(i,j)
       enddo
    enddo

    !--- we divided the cell into four parts and the area of the cell ----
    !--- is the sum of areas of the four parts ---------------------------
    do j=jsc,jec
       do i=isc,iec
          area1 = spherical_box_area(x_c(i-1,j-1), y_c(i-1,j-1), x_n(i,j-1), y_n(i,j-1), &
               x(i,j), y(i,j), x_e(i-1,j), y_e(i-1,j)  )
          area2 = spherical_box_area(x_n(i,j-1), y_n(i,j-1), x_c(i,j-1), y_c(i,j-1), &
               x_e(i,j), y_e(i,j), x(i,j), y(i,j)  )
          area3 = spherical_box_area(x(i,j), y(i,j), x_e(i,j), y_e(i,j), &
               x_c(i,j), y_c(i,j), x_n(i,j), y_n(i,j)  )
          area4 = spherical_box_area(x_e(i-1,j), y_e(i-1,j), x(i,j), y(i,j), &
               x_n(i,j), y_n(i,j), x_c(i-1,j), y_c(i-1,j) )
          cell%area(i,j) = area1+area2+area3+area4
       enddo
    enddo

    return

  end subroutine spherical_cell_length_area

  !#######################################################################
  !calculate face length and half length of each cell for f_plane/beta_plane grid.
  subroutine f_plane_cell_length_area(cell, x, y, x_e, y_e, x_n, y_n, x_c, y_c)
    type(cell_type),                intent(inout) :: cell
    real, dimension(isc:iec,jsc:jec), intent(in)  :: x, y     ! center of the cell.
    real, dimension(isd:iec,jsc:jec), intent(in)  :: x_e, y_e ! east of the cell.
    real, dimension(isc:iec,jsd:jec), intent(in)  :: x_n, y_n ! north of the cell.
    real, dimension(isd:iec,jsd:jec), intent(in)  :: x_c, y_c ! four vertices of cell

    integer :: i, j

    do j = jsc,jec
       do i = isc,iec
          !--- define half length ------------------------------------------- 
          cell%ds_00_01(i,j) = cartesian_dist(x_e(i-1,j), y_e(i-1,j), x_c(i-1,j-1), y_c(i-1,j-1) )
          cell%ds_01_02(i,j) = cartesian_dist(x_c(i-1,j), y_c(i-1,j), x_e(i-1,j),   y_e(i-1,j)   )
          cell%ds_02_12(i,j) = cartesian_dist(x_n(i,j),   y_n(i,j),   x_c(i-1,j),   y_c(i-1,j)   )
          cell%ds_12_22(i,j) = cartesian_dist(x_c(i,j),   y_c(i,j),   x_n(i,j),     y_n(i,j)     )
          cell%ds_21_22(i,j) = cartesian_dist(x_c(i,j),   y_c(i,j),   x_e(i,j),     y_e(i,j)     )
          cell%ds_20_21(i,j) = cartesian_dist(x_e(i,j),   y_e(i,j),   x_c(i,j-1),   y_c(i,j-1)   )
          cell%ds_10_20(i,j) = cartesian_dist(x_c(i,j-1), y_c(i,j-1), x_n(i,j-1),   y_n(i,j-1)   )
          cell%ds_00_10(i,j) = cartesian_dist(x_n(i,j-1), y_n(i,j-1), x_c(i-1,j-1), y_c(i-1,j-1) )
          cell%ds_01_11(i,j) = cartesian_dist(x(i,j),     y(i,j),     x_e(i-1,j),   y_e(i-1,j)   )
          cell%ds_11_12(i,j) = cartesian_dist(x_n(i,j),   y_n(i,j),   x(i,j),       y(i,j)       )
          cell%ds_11_21(i,j) = cartesian_dist(x_e(i,j),   y_e(i,j),   x(i,j),       y(i,j)       )
          cell%ds_10_11(i,j) = cartesian_dist(x(i,j),     y(i,j),     x_n(i,j-1),   y_n(i,j-1)   )  
          !--- define full length -------------------------------------------
          cell%ds_00_02(i,j) = cell%ds_00_01(i,j) + cell%ds_01_02(i,j)
          cell%ds_20_22(i,j) = cell%ds_20_21(i,j) + cell%ds_21_22(i,j)
          cell%ds_00_20(i,j) = cell%ds_00_10(i,j) + cell%ds_10_20(i,j)
          cell%ds_02_22(i,j) = cell%ds_02_12(i,j) + cell%ds_12_22(i,j)
          cell%ds_01_21(i,j) = cell%ds_01_11(i,j) + cell%ds_11_21(i,j)
          cell%ds_10_12(i,j) = cell%ds_10_11(i,j) + cell%ds_11_12(i,j)
       enddo
    enddo

    !--- we divided the cell into four parts and the area of the cell ----
    !--- is the sum of areas of the four parts ---------------------------
    do j=jsc,jec
       do i=isc,iec
          cell%area(i,j) = cartesian_box_area(x_c(i-1,j-1), y_c(i-1,j-1), x_c(i,j), y_c(i,j))
       enddo
    enddo

    return

  end subroutine f_plane_cell_length_area

  !#######################################################################
  !calculate face length and half length of each cell for cartesian grid.
  subroutine cartesian_cell_length_area(cell)
    type(cell_type),                intent(inout) :: cell

    integer :: i, j

    do j = jsc,jec
       do i = isc,iec
          !--- define half length ------------------------------------------- 
          cell%ds_00_01(i,j) = 0.5*simple_cartesian_dy
          cell%ds_01_02(i,j) = 0.5*simple_cartesian_dy
          cell%ds_02_12(i,j) = 0.5*simple_cartesian_dx
          cell%ds_12_22(i,j) = 0.5*simple_cartesian_dx
          cell%ds_21_22(i,j) = 0.5*simple_cartesian_dy
          cell%ds_20_21(i,j) = 0.5*simple_cartesian_dy
          cell%ds_10_20(i,j) = 0.5*simple_cartesian_dx
          cell%ds_00_10(i,j) = 0.5*simple_cartesian_dx
          cell%ds_01_11(i,j) = 0.5*simple_cartesian_dx
          cell%ds_11_12(i,j) = 0.5*simple_cartesian_dy
          cell%ds_11_21(i,j) = 0.5*simple_cartesian_dx
          cell%ds_10_11(i,j) = 0.5*simple_cartesian_dy
          !--- define full length -------------------------------------------
          cell%ds_00_02(i,j) = simple_cartesian_dy
          cell%ds_20_22(i,j) = simple_cartesian_dy
          cell%ds_00_20(i,j) = simple_cartesian_dx
          cell%ds_02_22(i,j) = simple_cartesian_dx
          cell%ds_01_21(i,j) = simple_cartesian_dx
          cell%ds_10_12(i,j) = simple_cartesian_dy
       enddo
    enddo

    !--- we divided the cell into four parts and the area of the cell ----
    !--- is the sum of areas of the four parts ---------------------------
    do j=jsc,jec
       do i=isc,iec
          cell%area(i,j) = simple_cartesian_dx * simple_cartesian_dy
       enddo
    enddo

    return

  end subroutine cartesian_cell_length_area

  !#######################################################################
  !--- calculate tripolar grid distance
  subroutine update_cell_length(cell, lat, x, y, x_e, y_e, x_n, y_n, x_c, y_c)
    type(cell_type),        intent(inout) :: cell
    real, dimension(jsc:jec),         intent(in)  :: lat
    real, dimension(isc:iec,jsc:jec), intent(in)  :: x, y     ! center of the cell.
    real, dimension(isd:iec,jsc:jec), intent(in)  :: x_e, y_e ! east of the cell.
    real, dimension(isc:iec,jsd:jec), intent(in)  :: x_n, y_n ! north of the cell.
    real, dimension(isd:iec,jsd:jec), intent(in)  :: x_c, y_c ! four vertices of cell

    integer :: i, j
    integer, allocatable :: num_div(:,:,:)

    allocate(num_div(ni,nj,12))

    !---update length-----------------------------------------------------
    do j = jsc,jec
       do i = isc,iec
          if(lat(j) .ge. lat_join) then
             !--- define half length ----------------------------------------
             cell%ds_00_01(i,j) = bipolar_dist(x_e(i-1,j),y_e(i-1,j),x_c(i-1,j-1),y_c(i-1,j-1), num_div(i,j,8) )
             cell%ds_01_02(i,j) = bipolar_dist(x_c(i-1,j), y_c(i-1,j), x_e(i-1,j), y_e(i-1,j), num_div(i,j,7))
             cell%ds_02_12(i,j) = bipolar_dist(x_n(i,j), y_n(i,j), x_c(i-1,j), y_c(i-1,j), num_div(i,j,6))
             cell%ds_12_22(i,j) = bipolar_dist(x_c(i,j), y_c(i,j), x_n(i,j), y_n(i,j), num_div(i,j,5))
             cell%ds_21_22(i,j) = bipolar_dist(x_c(i,j), y_c(i,j), x_e(i,j), y_e(i,j), num_div(i,j,4))
             cell%ds_20_21(i,j) = bipolar_dist(x_e(i,j), y_e(i,j), x_c(i,j-1), y_c(i,j-1), num_div(i,j,3))
             cell%ds_10_20(i,j) = bipolar_dist(x_c(i,j-1), y_c(i,j-1), x_n(i,j-1), y_n(i,j-1), num_div(i,j,2))
             cell%ds_00_10(i,j) = bipolar_dist(x_n(i,j-1), y_n(i,j-1), x_c(i-1,j-1), y_c(i-1,j-1), num_div(i,j,1))
             cell%ds_01_11(i,j) = bipolar_dist(x(i,j), y(i,j), x_e(i-1,j), y_e(i-1,j), num_div(i,j,12))
             cell%ds_11_12(i,j) = bipolar_dist(x_n(i,j), y_n(i,j), x(i,j), y(i,j), num_div(i,j,11) )
             cell%ds_11_21(i,j) = bipolar_dist(x(i,j), y(i,j),x_e(i,j), y_e(i,j), num_div(i,j,10) )
             cell%ds_10_11(i,j) = bipolar_dist(x(i,j), y(i,j), x_n(i,j-1), y_n(i,j-1) , num_div(i,j,9)) 
             !--- define full length ----------------------------------------
             cell%ds_00_02(i,j) = cell%ds_00_01(i,j) + cell%ds_01_02(i,j)
             cell%ds_20_22(i,j) = cell%ds_20_21(i,j) + cell%ds_21_22(i,j)
             cell%ds_02_22(i,j) = cell%ds_02_12(i,j) + cell%ds_12_22(i,j)
             cell%ds_00_20(i,j) = cell%ds_00_10(i,j) + cell%ds_10_20(i,j)
             cell%ds_01_21(i,j) = cell%ds_01_11(i,j) + cell%ds_11_21(i,j)
             cell%ds_10_12(i,j) = cell%ds_10_11(i,j) + cell%ds_11_12(i,j)
          endif
       enddo
    enddo

    deallocate(num_div)

    return

  end subroutine update_cell_length

  !#######################################################################
  !--- calculate tripolar grid area
  subroutine update_cell_area(cell, lat, x, y, x_e, y_e, x_n, y_n, x_c, y_c)
    type(cell_type),                intent(inout) :: cell
    real, dimension(jsc:jec),         intent(in)  :: lat
    real, dimension(isc:iec,jsc:jec), intent(in)  :: x, y     ! center of the cell.
    real, dimension(isd:iec,jsc:jec), intent(in)  :: x_e, y_e ! east of the cell.
    real, dimension(isc:iec,jsd:jec), intent(in)  :: x_n, y_n ! north of the cell.
    real, dimension(isd:iec,jsd:jec), intent(in)  :: x_c, y_c ! four vertices of cell

    integer :: i, j
    real :: area1, area2, area3, area4

    !--- update area -----------------------------------------------------
    do j = jsc,jec
       do i = isc,iec
          if(lat(j) .ge. lat_join) then
             area1 = bipolar_area(x_c(i-1,j-1), y_c(i-1,j-1), x_n(i,j-1), y_n(i,j-1), &
                  x(i,j), y(i,j), x_e(i-1,j), y_e(i-1,j)   )
             area2 = bipolar_area(x_n(i,j-1), y_n(i,j-1), x_c(i,j-1), y_c(i,j-1), &
                  x_e(i,j), y_e(i,j), x(i,j), y(i,j) )
             area3 = bipolar_area(x(i,j), y(i,j), x_e(i,j), y_e(i,j),          &
                  x_c(i,j), y_c(i,j), x_n(i,j), y_n(i,j)  )
             area4 = bipolar_area(x_e(i-1,j), y_e(i-1,j), x(i,j), y(i,j),         &
                  x_n(i,j), y_n(i,j), x_c(i-1,j), y_c(i-1,j) )
             if(area1 .lt. 0 .or. area2 .lt. 0 .or. area3 .lt. 0 .or. area4 .lt. 0) then
                area1 = abs(area1); area2 = abs(area2) 
                area3 = abs(area3); area4 = abs(area4)
             endif
             cell%area(i,j) = area1+area2+area3+area4
          endif
       enddo
    enddo

  end subroutine update_cell_area

  !#######################################################################
  !--- update length at the folded region, for this reason, 
  !--- the domain layout always is (1,npes). in this case
  !--- isc = 1, iec = ni
  subroutine update_north_length(Hgrid)
    type(hgrid_data_type), intent(inout) :: Hgrid

    integer :: i

    if(jec == nj) then

       do i = 1, ni/2
          !--- update most northern T-cell length ---------------------------
          Hgrid%T%ds_02_22(i,nj) = Hgrid%T%ds_02_22(ni-i+1,nj)
          Hgrid%T%ds_02_12(i,nj) = Hgrid%T%ds_12_22(ni-i+1,nj)
          Hgrid%T%ds_12_22(i,nj) = Hgrid%T%ds_02_12(ni-i+1,nj)
          !--- update most southern E-cell length ---------------------------
          Hgrid%E%ds_02_22(i,nj) = Hgrid%E%ds_02_22(ni-i,nj)
          Hgrid%E%ds_02_12(i,nj) = Hgrid%E%ds_12_22(ni-i,nj)
          Hgrid%E%ds_12_22(i,nj) = Hgrid%E%ds_02_12(ni-i,nj)
          !--- update most southern N-cell length ---------------------------
          Hgrid%N%ds_02_22(i,nj) = Hgrid%N%ds_00_20(ni-i+1,nj)
          Hgrid%N%ds_00_20(i,nj) = Hgrid%N%ds_02_22(ni-i+1,nj)
          Hgrid%N%ds_00_02(i,nj) = Hgrid%N%ds_20_22(ni-i+1,nj)
          Hgrid%N%ds_20_22(i,nj) = Hgrid%N%ds_00_02(ni-i+1,nj)
          Hgrid%N%ds_02_12(i,nj) = Hgrid%N%ds_10_20(ni-i+1,nj)
          Hgrid%N%ds_12_22(i,nj) = Hgrid%N%ds_00_10(ni-i+1,nj)
          Hgrid%N%ds_00_10(i,nj) = Hgrid%N%ds_12_22(ni-i+1,nj)
          Hgrid%N%ds_10_20(i,nj) = Hgrid%N%ds_02_12(ni-i+1,nj)
          Hgrid%N%ds_00_01(i,nj) = Hgrid%N%ds_21_22(ni-i+1,nj)
          Hgrid%N%ds_01_02(i,nj) = Hgrid%N%ds_20_21(ni-i+1,nj)
          Hgrid%N%ds_20_21(i,nj) = Hgrid%N%ds_01_02(ni-i+1,nj)
          Hgrid%N%ds_21_22(i,nj) = Hgrid%N%ds_00_01(ni-i+1,nj)
          Hgrid%N%ds_01_11(i,nj) = Hgrid%N%ds_11_21(ni-i+1,nj)
          Hgrid%N%ds_11_12(i,nj) = Hgrid%N%ds_10_11(ni-i+1,nj)
          Hgrid%N%ds_11_21(i,nj) = Hgrid%N%ds_01_11(ni-i+1,nj)
          Hgrid%N%ds_10_11(i,nj) = Hgrid%N%ds_11_12(ni-i+1,nj)
          Hgrid%N%ds_01_21(i,nj) = Hgrid%N%ds_01_21(ni-i+1,nj)
          Hgrid%N%ds_10_12(i,nj) = Hgrid%N%ds_10_12(ni-i+1,nj)
          !--- update most southern C-cell length ---------------------------
          Hgrid%C%ds_02_22(i,nj) = Hgrid%C%ds_00_20(ni-i,nj)
          Hgrid%C%ds_00_20(i,nj) = Hgrid%C%ds_02_22(ni-i,nj)
          Hgrid%C%ds_00_02(i,nj) = Hgrid%C%ds_20_22(ni-i,nj)
          Hgrid%C%ds_20_22(i,nj) = Hgrid%C%ds_00_02(ni-i,nj)
          Hgrid%C%ds_02_12(i,nj) = Hgrid%C%ds_10_20(ni-i,nj)
          Hgrid%C%ds_12_22(i,nj) = Hgrid%C%ds_00_10(ni-i,nj)
          Hgrid%C%ds_00_10(i,nj) = Hgrid%C%ds_12_22(ni-i,nj)
          Hgrid%C%ds_10_20(i,nj) = Hgrid%C%ds_02_12(ni-i,nj)
          Hgrid%C%ds_00_01(i,nj) = Hgrid%C%ds_21_22(ni-i,nj)
          Hgrid%C%ds_01_02(i,nj) = Hgrid%C%ds_20_21(ni-i,nj)
          Hgrid%C%ds_20_21(i,nj) = Hgrid%C%ds_01_02(ni-i,nj)
          Hgrid%C%ds_21_22(i,nj) = Hgrid%C%ds_00_01(ni-i,nj)
          Hgrid%C%ds_01_11(i,nj) = Hgrid%C%ds_11_21(ni-i,nj)
          Hgrid%C%ds_11_12(i,nj) = Hgrid%C%ds_10_11(ni-i,nj)
          Hgrid%C%ds_11_21(i,nj) = Hgrid%C%ds_01_11(ni-i,nj)
          Hgrid%C%ds_10_11(i,nj) = Hgrid%C%ds_11_12(ni-i,nj)
          Hgrid%C%ds_01_21(i,nj) = Hgrid%C%ds_01_21(ni-i,nj)
          Hgrid%C%ds_10_12(i,nj) = Hgrid%C%ds_10_12(ni-i,nj)
       enddo

    endif

    return

  end subroutine update_north_length

  !#######################################################################
  !calculate the rotation angle of the cell
  subroutine update_cell_angle(angle, lat, lone, late)
    real, dimension(isc:iec,jsc:jec), intent(in)    :: lat
    real, dimension(isc:ied,jsc:jec), intent(in)    :: lone, late
    real, dimension(isc:iec,jsc:jec), intent(inout) :: angle
    integer :: i, j
    real    :: lon_scale

    do j = jsc,jec
       do i = isc,iec
          lon_scale = cos(lat(i,j)*D2R)
          angle(i,j) = (atan2(late(i+1,j) - late(i,j), (lone(i+1,j) - lone(i,j))*lon_scale))/D2R
       enddo
    enddo

    return
  end subroutine update_cell_angle

  !#######################################################################
  !--- write out chksum
  subroutine cell_chksum(cell, id)
    type(cell_type), intent(in) :: cell
    character(len=1), intent(in) :: id

    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_x_'//id//' = ', mpp_chksum(cell%x(isc:iec,jsc:jec))
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_y_'//id//' = ', mpp_chksum(cell%y(isc:iec,jsc:jec))
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_x_vert_'//id//'= ', mpp_chksum(cell%x_vert)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_y_vert_'//id//'= ', mpp_chksum(cell%y_vert)  
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_area_'//id//' = ',  mpp_chksum(cell%area)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_angle_'//id//' = ', mpp_chksum(cell%angle)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_00_02_'//id//' = ', mpp_chksum(cell%ds_00_02)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_20_22_'//id//' = ', mpp_chksum(cell%ds_20_22)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_02_22_'//id//' = ', mpp_chksum(cell%ds_02_22)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_00_20_'//id//' = ', mpp_chksum(cell%ds_00_20)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_01_21_'//id//' = ', mpp_chksum(cell%ds_01_21)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_10_12_'//id//' = ', mpp_chksum(cell%ds_10_12)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_00_01_'//id//' = ', mpp_chksum(cell%ds_00_01)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_01_02_'//id//' = ', mpp_chksum(cell%ds_01_02)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_02_12_'//id//' = ', mpp_chksum(cell%ds_02_12)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_12_22_'//id//' = ', mpp_chksum(cell%ds_12_22)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_21_22_'//id//' = ', mpp_chksum(cell%ds_21_22)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_20_21_'//id//' = ', mpp_chksum(cell%ds_20_21)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_10_20_'//id//' = ', mpp_chksum(cell%ds_10_20)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_00_10_'//id//' = ', mpp_chksum(cell%ds_00_10)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_01_11_'//id//' = ', mpp_chksum(cell%ds_01_11)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_11_12_'//id//' = ', mpp_chksum(cell%ds_11_12)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_11_21_'//id//' = ', mpp_chksum(cell%ds_11_21)
    write (stdout(),'(/(a,I20/))')'hgrid chksum: chksum_ds_10_11_'//id//' = ', mpp_chksum(cell%ds_10_11)

  end subroutine cell_chksum

  !#######################################################################
  !--- fix longitude at pole.
  subroutine lon_fix(x,y,n_in,n_out,tlon)
    real, dimension(:), intent(inout) :: x, y
    integer,               intent(in) :: n_in
    integer,              intent(out) :: n_out
    real,                  intent(in) :: tlon

    integer :: i, ip, im
    real :: dx, x_sum

    n_out = n_in
    i = 1
    do
       if(i .gt. n_out) exit

       if(abs(y(i)) .eq. 90.) then
          im= i - 1
          if(im .le. 0) im = im + n_out
          ip = i + 1
          if(ip .gt. n_out) ip = ip - n_out
          !--- all pole points must be paired ----------------------------
          if(y(im) .eq. y(i) .and. y(ip) .eq. y(i) ) then
             call vtx_delete(x,y, n_out, i)
             i = i - 1
          else if(y(im) .ne. y(i) .and. y(ip) .ne. y(i) ) then
             call vtx_insert(x,y,n_out,i)
             i = i + 1
          endif
       endif
       i = i + 1
    enddo

    !--- first of pole pair has longitude of previous vertex -------------
    !--- second of pole pair has longitude of subsequent vertex ----------
    do i = 1, n_out
       if(abs(y(i)) .eq. 90.) then
          im= i - 1
          if(im .le. 0) im = im + n_out
          ip = i + 1
          if(ip .gt. n_out) ip = ip - n_out

          if(y(im) .ne. y(i)) x(i) = x(im)
          if(y(ip) .ne. y(i)) x(i) = x(ip)
       endif
    enddo

    if(n_out == 0) return

    x_sum = x(1)
    do i = 2, n_out
       dx = x(i) - x(i-1)
       if(dx < -180) then
          dx = dx + 360
       else if (dx >  180) then
          dx = dx - 360
       endif
       x(i) = x(i-1) + dx
       x_sum = x_sum + x(i)
    enddo

    dx = x_sum/real(n_out) - tlon
    if (dx < -180.) then
       do i = 1, n_out
          x(i) = x(i) + 360.
       enddo
    else if (dx > 180.) then
       do i = 1, n_out
          x(i) = x(i) - 360.
       enddo
    endif

    return

  end subroutine lon_fix

  !#######################################################################
  ! delete vertex
  subroutine vtx_delete(x,y, n, n_del)
    real, dimension(:), intent(inout) :: x,y
    integer,            intent(inout) :: n
    integer,            intent(in)    :: n_del

    integer :: i

    do i = n_del, n-1
       x(i) = x(i+1)
       y(i) = y(i+1)
    enddo
    n = n -1

    return 

  end subroutine vtx_delete

  !#######################################################################
  ! insert vertex
  subroutine vtx_insert(x,y, n, n_ins)
    real, dimension(:), intent(inout) :: x,y
    integer,            intent(inout) :: n
    integer,            intent(in)    :: n_ins

    integer :: i

    do i = n, n_ins, -1
       x(i+1) = x(i)
       y(i+1) = y(i)
    enddo
    n = n + 1

    return 

  end subroutine vtx_insert

  !#######################################################################

end module hgrid_mod

module ocean_riverspread_mod
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! Spread runoff or calving horizontally over a region determined 
! by a table. Also provide option to spread river runoff or calving
! through a diffusive operation. 
!</OVERVIEW>
!
!<DESCRIPTION>
! At some coastal ocean gridpoints, the runoff or calving flux contribution to 
! (p-e+r) may be very large because of local insertion to ocean. Therefore, 
! we may choose to spread the large river runoff over neighboring pairs
! of gridpoints. Annual mean river runoff greater than 0.05 m/day is 
! considered to be very large.
! This module allows one to spread the river using two options. 
! A/ by specifying river spreading table points
! B/ by performing a series of diffusion operations.
!</DESCRIPTION>
!
! <INFO>
!
! <NOTE>
! Spreading in a 2D lat-long field is implemented in the following manner:
!
! A/ Table driven spreadging
! 
! If the spreading region lives within the halo region
! (i.e., within same local_domain), 
! then no added mpp communication required. However, more generally 
! the spreading region can extend beyond the existing halo region.
! In this case, spread_domain
! is defined so that its halos incorporate the maximum separation 
! of spreading points.  New tracer and grid arrays
! are defined over this extended spread_domain.  This added domain
! size will come at some computational cost, so it is advantageous
! to choose the spreading region carefully.
!
! B/ Laplacian diffusion spreading
!
! Apply Laplacian operator to the river runoff/calving array to spread
! the river water abroad from the river mouth. 
!
! </NOTE>
!
! <NOTE>
! The current implementation of table driven spreading has not 
! been tested for a spreading region that is separated by either 
! a zonal cyclic condition or across the tripolar fold.  
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_riverspread_nml">
!
!  <DATA NAME="use_this_module"  TYPE="logical">
!  Must be true to enable this module.  Default=.false.
!  </DATA>
!  <DATA NAME="debug_this_module"  TYPE="logical">
!  For debugging. Default=.false.
!  </DATA>
!
!  <DATA NAME="riverspread_diffusion"  TYPE="logical">
!  For spreading river water via a Laplacian diffusion operation.
!  Default=.false.
!  </DATA>
!  <DATA NAME="riverspread_diffusion_passes"  TYPE="integer">
!  Number of diffusion passes applied to the runoff/calving array. 
!  Default riverspread_diffusion_passes = 0.
!  </DATA>
!  <DATA NAME="vel_micom_smooth" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM Laplacian mixing 
!  coefficient used in the Laplacian smoothing of river water. 
!  Default vel_micom_smooth=0.2.
!  </DATA>
!
!</NAMELIST>
!
use field_manager_mod,   only: MODEL_OCEAN, find_field_index, get_field_methods
use field_manager_mod,   only: method_type, get_field_info, parse
use fms_mod,             only: write_version_number, open_namelist_file, check_nml_error, close_file
use fms_mod,             only: stdout, stdlog, FATAL, NOTE
use mpp_domains_mod,     only: domain2D, mpp_update_domains, mpp_define_domains
use mpp_domains_mod,     only: cyclic_global_domain, global_data_domain
use mpp_mod,             only: input_nml_file, mpp_error

use ocean_domains_mod,   only: get_local_indices
use ocean_operators_mod, only: LAP_T
use ocean_types_mod,     only: ocean_domain_type, ocean_grid_type, ocean_options_type

implicit none

private 

public ocean_riverspread_init
public spread_river_horz
private on_comp_domain
private on_data_domain
private riverspread_laplacian

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

real, dimension(:,:), allocatable :: smooth_lap      !2D array of diffusivities (m^2/sec) for spreading 

! Variables set inside subroutine ocean_riverspread_init
! See comments in ocean_riverspread_init for description
integer, dimension(:),   allocatable :: ispread, jspread
integer, dimension(:),   allocatable :: is, ie
integer, dimension(:),   allocatable :: js, je
integer, dimension(:),   allocatable :: halon     ! halo size for each spreading region
integer                              :: nspread=0 ! number of spreading regions

! Variables calculated from user input
integer                              :: spread_halo     ! halo size needed to perform spreading
type(ocean_domain_type), save        :: Spread_domain   ! domain for spreading 

! variables defined with halos given by spread_halo
real, dimension(:,:), allocatable    :: field_spreadx  ! 
real, dimension(:,:), allocatable    :: xtx            ! zonal position of tracer points (degrees)
real, dimension(:,:), allocatable    :: ytx            ! meridional position of tracer points (degrees)
real, dimension(:,:), allocatable    :: datx           ! area of tracer cell (m^2)
real, dimension(:,:), allocatable    :: tmaskx         !

integer                              :: unit=6         ! processor zero writes to unit 6

logical, dimension(:), allocatable   :: error_spread   ! for checking that all spread points are OK.  

character(len=256) :: version=&
       '$Id: ocean_riverspread.F90,v 20.0 2013/12/14 00:16:12 fms Exp $)'
character (len=128) :: tagname = &
     '$Name: tikal $'

integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk
real    :: dtime 

logical :: use_this_module              = .false.
logical :: debug_this_module            = .false.
logical :: module_is_initialized        = .FALSE.
logical :: riverspread_diffusion        = .false.
integer :: riverspread_diffusion_passes = 0
real    :: vel_micom_smooth             = 0.2      ! m/sec for smoothing 


namelist /ocean_riverspread_nml/ use_this_module, debug_this_module, &
          riverspread_diffusion, riverspread_diffusion_passes, vel_micom_smooth         

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_riverspread_init">
!
! <DESCRIPTION>
!    Initial set up for spreading of tracers 
!
!  A/ Table drive approach 
!    (i,j) locations of points to be spread are set in data
!    statements.
!
!    Checks are performed to ensure that the spreading
!    grid locations are valid according to model configuration.
!
!    A summary of the locations of spreading points is written out.
!
!    User specified inputs in "USER INPUT" section:
!
!    ispread and jspread = user specified i,j grid locations of data for spreading.
!
!    is, ie, js, je = user specified i,j grid locations of 
!                     the corners of the spreading regions.
!                     is and ie are the east and west coord of each region,
!                     js and je are the south and north coord of each region. 
!
! B/ Laplacian approach requires minimal setup 
!
! </DESCRIPTION>
!
subroutine ocean_riverspread_init(Grid, Domain, Ocean_options, dtime_t)

  type(ocean_grid_type),    intent(in), target :: Grid
  type(ocean_domain_type),  intent(in), target :: Domain
  type(ocean_options_type), intent(inout)      :: Ocean_options
  real,                     intent(in)         :: dtime_t 

  type(method_type), allocatable, dimension(:) :: spread_methods

  character(len=32) :: fld_type, fld_name
  integer           :: i, n, model
  integer           :: io_status, ioun, ierr
  integer           :: isp, jsp
  integer           :: nsp, imax, imin, spread_halo_test
  integer           :: parse_ok

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then  
    call mpp_error(FATAL, &
    '==>Error in ocean_riverspread_mod (ocean_riverspread_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  nk = Grid%nk

  Dom => Domain
  Grd => Grid
  dtime = dtime_t 

  n = find_field_index(MODEL_OCEAN,'riverspread')
  if (n < 1) then 
      write(stdoutunit,*)' '
      write(stdoutunit,*) &
      '==>Warning: ocean_riverspread_init: n<1 for riverspread table. Will NOT use table for ocean_riverspread.'  
  endif

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_riverspread_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_riverspread_nml')
#else
  ioun =  open_namelist_file()
  read (ioun,ocean_riverspread_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_riverspread_nml')
  call close_file (ioun)
#endif
  write (stdlogunit,ocean_riverspread_nml)
  write (stdoutunit,'(/)') 
  write (stdoutunit,ocean_riverspread_nml)

  if(use_this_module) then 
      call mpp_error(NOTE,&
      '==>From ocean_riverspread_mod: Using riverspread module to mix river water into the ocean.')
      Ocean_options%riverspread = 'Used riverspread to horizontally spread river water away from land.'
  else
      call mpp_error(NOTE,&
      '==>From ocean_riverspread_mod: NOT using riverspread module, yet there are n > 0 riverspread points.')
      Ocean_options%riverspread = 'Did NOT use riverspread module.'
      return
  endif

  if(n < 1 .and. .not. riverspread_diffusion) then 
      write(stdoutunit,*)' '
      Ocean_options%riverspread = 'Did NOT use riverspread module.'
      return
  endif

  if(riverspread_diffusion .and. riverspread_diffusion_passes > 0) then 
      write(stdoutunit,*) &
      '==>Note: ocean_riverspread_init: will diffusively spread river water using Laplacian.'   
      Ocean_options%riverspread = 'Used riverspread to horizontally spread river water via a Laplacian.'
  endif

  if(n >= 1 .and. riverspread_diffusion .and. riverspread_diffusion_passes > 0) then 
      write(stdoutunit,*)' '
      write(stdoutunit,*) &
      '==>Warning: ocean_riverspread_init: using BOTH riverspread table and Laplacian. Is this what you wish?'  
      Ocean_options%riverspread = 'Used riverspread table AND Laplacian smoother to spread river water.'
  endif

  allocate (smooth_lap(isd:ied,jsd:jed))
  smooth_lap(:,:) = Grd%tmask(:,:,1)*vel_micom_smooth*2.0*Grd%dxt(:,:)*Grd%dyt(:,:)/(Grd%dxt(:,:)+Grd%dyt(:,:))

  if(n < 1) return 

  call get_field_info(n,fld_type,fld_name,model,nspread)

  if(nspread == 0) then 
     call mpp_error(NOTE,&
     '==>Warning in ocean_riverspread_mod: No river spreading points chosen in riverspread table.')
     Ocean_options%riverspread = 'Did NOT use riverspread module.'
     return
  endif 

  if(Grd%tripolar) then 
    call mpp_error(NOTE,&
    '==>Warning in ocean_riverspread_mod: river table spreading not implemented for points across bipolar fold.')
  endif

  allocate(spread_methods(nspread))

  allocate (ispread(nspread))
  ispread(:) = 0
  allocate (jspread(nspread))
  jspread(:) = 0
  allocate (is(nspread), ie(nspread))
  is(:) = 0; ie(:) = 0
  allocate (js(nspread), je(nspread))
  js(:) = 0; je = 0
  allocate (error_spread(nspread))
  error_spread(:) = .false.
  allocate (halon(nspread))
  halon(:) = 0

  call get_field_methods(n,spread_methods)
  do i=1, nspread
     parse_ok = parse(spread_methods(i)%method_control,'iloc',ispread(i))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error in ocean_riverspread_mod: spread table entry "iloc" error')
     parse_ok = parse(spread_methods(i)%method_control,'jloc',jspread(i))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error in ocean_riverspread_mod: spread table entry "jloc" error')
     parse_ok = parse(spread_methods(i)%method_control,'is',is(i))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error in ocean_riverspread_mod: spread table entry "is" error')
     parse_ok = parse(spread_methods(i)%method_control,'ie',ie(i))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error in ocean_riverspread_mod: spread table entry "ie" error')
     parse_ok = parse(spread_methods(i)%method_control,'js',js(i))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error in ocean_riverspread_mod: spread table entry "js" error')
     parse_ok = parse(spread_methods(i)%method_control,'je',je(i))
     if (parse_ok == 0) call mpp_error(FATAL,'==>Error in ocean_riverspread_mod: spread table entry "je" error')
  enddo

  spread_halo = 1
  do nsp=1,nspread

    ! check for invalid spreading grid locations
    if (ispread(nsp) < 1 .or. ispread(nsp) > Grd%ni) then
        write(unit,991) nsp, ispread(nsp)
        error_spread(nsp) = .true.
     endif
     if (jspread(nsp) < 1 .or. jspread(nsp) > Grd%nj ) then
        write(unit,992) nsp, jspread(nsp)
        error_spread(nsp) = .true.
     endif

   ! determine size for spread_halo
   if(Grd%cyclic_x) then 
     imax = max(is(nsp),ie(nsp))
     imin = min(is(nsp),ie(nsp))
     spread_halo_test = min( abs(imax-imin), abs(imax-Grd%ni-imin)) 
   else 
     spread_halo_test = abs(is(nsp)-ie(nsp))
   endif 
   if (spread_halo_test > spread_halo ) spread_halo = spread_halo_test

   spread_halo_test = abs(js(nsp)-je(nsp))
   if (spread_halo_test > spread_halo ) spread_halo = spread_halo_test
   halon(nsp) = spread_halo_test

  enddo  ! end of do-loop nsp=1,nspread

  if(spread_halo > Dom%xhalo .or. spread_halo > Dom%yhalo ) then 
    write(stdoutunit,*)'Defining extra tracer arrays for "riverspread_domain". Halo for spreading = ', spread_halo
    write(stdoutunit,*)'Halos for the spreading regions = ', halon
  endif 

  ! define arrays and spread_domain
  if(spread_halo <=Dom%xhalo .and. spread_halo <= Dom%yhalo) then 

     write(stdoutunit,*)'Local computational domain is large enough for chosen points in river spreading,'

     allocate (datx(isd:ied,jsd:jed))
     allocate (xtx(isd:ied,jsd:jed))
     allocate (ytx(isd:ied,jsd:jed))
     allocate (tmaskx(isd:ied,jsd:jed))
     xtx(:,:)    = Grd%xt(:,:)
     ytx(:,:)    = Grd%yt(:,:)
     datx(:,:)   = Grd%dat(:,:)
     tmaskx(:,:) = Grd%tmask(:,:,1)

     allocate (field_spreadx(isd:ied,jsd:jed))
     field_spreadx(:,:) = 0.0
  endif 

  if(spread_halo > Dom%xhalo .or. spread_halo > Dom%yhalo) then 
     write(stdoutunit,*)'The model local computational domain has a halo = ',Dom%xhalo, Dom%yhalo
     write(stdoutunit,*)'This is smaller than the halo required for river spreading.'
     write(stdoutunit,*)'For spreading, will define a new domain type with halo = ', spread_halo

     call mpp_define_domains((/1,Grid%ni,1,Grid%nj/),Domain%layout,Spread_domain%domain2d, maskmap=Domain%maskmap,&
           xflags = CYCLIC_GLOBAL_DOMAIN, xhalo = spread_halo, yhalo = spread_halo, name='spread',&
           x_cyclic_offset = Domain%x_cyclic_offset, y_cyclic_offset = Domain%y_cyclic_offset)

     ! time independent arrays defined over the spread_domain region 
     allocate (datx(isc-spread_halo:iec+spread_halo,jsc-spread_halo:jec+spread_halo))
     allocate (xtx(isc-spread_halo:iec+spread_halo,jsc-spread_halo:jec+spread_halo))
     allocate (ytx(isc-spread_halo:iec+spread_halo,jsc-spread_halo:jec+spread_halo))
     allocate (tmaskx(isc-spread_halo:iec+spread_halo,jsc-spread_halo:jec+spread_halo))
     datx(:,:)   = 0.0
     xtx(:,:)    = 0.0
     ytx(:,:)    = 0.0
     tmaskx(:,:) = 0.0

     datx(isc:iec,jsc:jec)    = Grd%dat(isc:iec,jsc:jec)
     xtx(isc:iec,jsc:jec)     = Grd%xt(isc:iec,jsc:jec)
     ytx(isc:iec,jsc:jec)     = Grd%yt(isc:iec,jsc:jec)
     tmaskx(isc:iec,jsc:jec)  = grd%tmask(isc:iec,jsc:jec,1)
     call mpp_update_domains (datx(:,:), Spread_domain%domain2d)
     call mpp_update_domains (xtx(:,:), Spread_domain%domain2d)
     call mpp_update_domains (ytx(:,:), Spread_domain%domain2d)
     call mpp_update_domains (tmaskx(:,:), Spread_domain%domain2d)

     ! time dependent arrays defined over the spread_domain region 
     allocate (field_spreadx(isc-spread_halo:iec+spread_halo,jsc-spread_halo:jec+spread_halo))
     field_spreadx(:,:) = 0.0

  endif


  do nsp=1,nspread

    isp = ispread(nsp)-Dom%ioff
    jsp = jspread(nsp)-Dom%joff

    ! check for attempts to spread land rather than sea
     if(on_comp_domain(nsp)) then 
        if (Grd%kmt(isp,jsp) == 0) then
           write (unit,192) ispread(nsp),jspread(nsp),Grd%kmt(isp,jsp)
           error_spread(nsp)=.true.
        endif
     endif

     ! write out summary information for this spreading point
     if(on_comp_domain(nsp)) then
       write(unit,191) nsp, ispread(nsp), jspread(nsp) &
          ,xtx(isp,jsp), ytx(isp,jsp) &
          ,is(nsp),ie(nsp),js(nsp),je(nsp)
     endif

  enddo

  ! bring model down if problems with spreading points  
  do nsp=1,nspread
    if(error_spread(nsp)) then
      call mpp_error(FATAL,&
      '==>Error in ocean_riverspread_mod: problem in river spread initialization.')
    endif
  enddo

191 format(/' ===== from ocean_riverspread_init ====='/                            &
       ' for spreading location number',i3,/                                       &
       ' spread (i,j) gridpoint (',i4,',',i4,') [long=',f8.3,' lat=',f8.3,']',/    &
       ' over (is, ie, js, je)= ', 4i6)
192 format(/'=>Error: problem with spreading:',/,                                  &
       ' land point requested'/                                                    &
       '      at ispread(',i4,'), jspread(',i4,'),', ' kmt = ',i4,/)
991 format(/'=>Error: problem with spreading:',/,                                  &
       ' out of bounds i grid location requested'/                                 &
       '      ispread(',i4,') was set incorrectly set to = ',i8,/)
992 format(/'=>Error: problem with spreading:',/,                                  &
       ' out of bounds j-row grid location requested'/                             &
       '      jspread(',i4,') was set incorrectly set to = ',i8,/)


end subroutine ocean_riverspread_init
! </SUBROUTINE> NAME="ocean_riverspread_init"


!#######################################################################
! <SUBROUTINE NAME="spread_river_horz">
!
! <DESCRIPTION>
! Provide conservative spreading of river runoff field. 
! </DESCRIPTION>
!
subroutine spread_river_horz (field_spread)

  real, intent(inout), dimension(isd:,jsd:) :: field_spread

  real    :: spread, wtsum
  integer :: i, j, nsp

  if(.not. use_this_module) return 

  if(riverspread_diffusion) then 
    call riverspread_laplacian(field_spread)
  endif 

  if(nspread == 0) then 
     return
  endif 

  if(spread_halo > Dom%xhalo .or. spread_halo > Dom%yhalo) then 

    field_spreadx(isc:iec,jsc:jec) = field_spread(isc:iec,jsc:jec)
    call mpp_update_domains (field_spreadx(:,:), Spread_domain%domain2d)

    do nsp=1,nspread 

      if(at_least_one_in_spread_domain(nsp)) then  

           if(debug_this_module) then 
             write(unit,'(a,i3,a,i3,a,8i5)') '=>in spread_river_horz: spreading region= ', nsp, &
                                         ' halo= ', halon(nsp), ' region (is, ie, js, je)= ',   &
                                         is(nsp),ie(nsp),js(nsp),je(nsp),                       &
                                         is(nsp)-Dom%ioff, ie(nsp)-Dom%ioff, js(nsp)-Dom%joff, je(nsp)-Dom%joff
           endif 
 
           spread = 0.0; wtsum  = 0.0
           do j=js(nsp)-Dom%joff,je(nsp)-Dom%joff
             do i=is(nsp)-Dom%ioff,ie(nsp)-Dom%ioff
               spread = spread + field_spreadx(i,j) * datx(i,j) * tmaskx(i,j)
               wtsum = wtsum + datx(i,j) * tmaskx(i,j)
             enddo
           enddo

           if (wtsum > 0.0) then
             spread = spread / wtsum
           else
             write(unit,'(a,2i6)') '=>ERROR: spreading = 0 at i,j=', ispread(nsp), jspread(nsp)
             call mpp_error(FATAL,'==>Error: Problem in spread_river_horz.')
           endif

           do j=js(nsp)-Dom%joff,je(nsp)-Dom%joff
             do i=is(nsp)-Dom%ioff,ie(nsp)-Dom%ioff
               field_spreadx(i,j) = spread * tmaskx(i,j)
             enddo
           enddo
           do j=jsc,jec
             do i=isc,iec
               field_spread(i,j) = field_spreadx(i,j)
             enddo
           enddo

      endif ! end of at_least_one_in_spread_domain(nsp) if-test 

    enddo  ! end of the nspread do-loop 

  endif ! end of spread_halo > halo if-test 

  if(spread_halo <= Dom%xhalo .and. spread_halo <= Dom%yhalo) then 

    do nsp=1,nspread 

      if(at_least_one_in_spread_domain(nsp)) then  
  
           if(debug_this_module) then 
             write(unit,'(a,i3,a,i3,a,8i5)') '=>in spread_river_horz, compute spreading for region= ', nsp, &
                                         ' halo= ', halon(nsp), ' region (is, ie, js, je)= ',               &
                                           is(nsp),ie(nsp),js(nsp),je(nsp),                                 &
                                           is(nsp)-Dom%ioff, ie(nsp)-Dom%ioff, js(nsp)-Dom%joff, je(nsp)-Dom%joff
           endif 

           spread = 0.0; wtsum  = 0.0
           do j=js(nsp)-Dom%joff,je(nsp)-Dom%joff
             do i=is(nsp)-Dom%ioff,ie(nsp)-Dom%ioff
               spread = spread + field_spread(i,j) * Grd%dat(i,j) * Grd%tmask(i,j,1)
               wtsum = wtsum + Grd%dat(i,j) * Grd%tmask(i,j,1)
             enddo
           enddo

           if (wtsum > 0.0) then
             spread = spread / wtsum
           else
             write(unit,'(a,2i6)') '=>ERROR: spreading = 0 at i,j=', ispread(nsp), jspread(nsp)
             call mpp_error(FATAL,'==>Error: Problem in spread_river_horz.')
           endif

           do j=js(nsp)-Dom%joff,je(nsp)-Dom%joff
             do i=is(nsp)-Dom%ioff,ie(nsp)-Dom%ioff
               field_spread(i,j) = spread *Grd%tmask(i,j,1)
             enddo
           enddo

      endif ! end of at_least_one_in_spread_domain(nsp) if-test 

    enddo  ! end of the nspread do-loop 

  endif ! end of spread_halo <= halo if-test 

end subroutine spread_river_horz
! </SUBROUTINE> NAME="spread_river_horz"


!#######################################################################
! <SUBROUTINE NAME="riverspread_laplacian">
!
! <DESCRIPTION>
! Provide conservative spreading of river runoff field using a 
! Laplacian operator.   
! </DESCRIPTION>
!
subroutine riverspread_laplacian (field_spread)

  real, intent(inout), dimension(isd:,jsd:) :: field_spread
  integer :: n

  if(riverspread_diffusion_passes < 1) return  
 
  do n=1,riverspread_diffusion_passes
     call mpp_update_domains(field_spread(:,:), Dom%domain2d) 
     field_spread(:,:) = field_spread(:,:) + dtime*LAP_T(field_spread(:,:),smooth_lap(:,:))
  enddo
  call mpp_update_domains(field_spread(:,:), Dom%domain2d) 


end subroutine riverspread_laplacian
! </SUBROUTINE> NAME="riverspread_laplacian"


!#######################################################################
! <FUNCTION NAME="at_least_one_in_spread_domain">
!
! <DESCRIPTION>
! Function to see if at least one of the points in the spreading region
! is within the computational domain for the processor. 
! </DESCRIPTION>
!
! <IN NAME="nsp" TYPE="integer">
! Integer labeling the particular spreading region
! </IN>
!
function at_least_one_in_spread_domain(nsp)

  integer, intent(in) :: nsp
  logical :: in_domain, at_least_one_in_spread_domain

  if(isc-halon(nsp)+Dom%ioff <= is(nsp) .and. ie(nsp) <= iec+halon(nsp)+Dom%ioff .and. &
     jsc-halon(nsp)+Dom%joff <= js(nsp) .and. je(nsp) <= jec+halon(nsp)+Dom%joff) then
     in_domain = .true.
  else 
     in_domain = .false.  
  endif

  at_least_one_in_spread_domain = .false.
  if(in_domain) at_least_one_in_spread_domain = .true.


end function at_least_one_in_spread_domain 
! </FUNCTION> NAME="at_least_one_in_spread_domain"


!#######################################################################
! <FUNCTION NAME="on_comp_domain">
!
! <DESCRIPTION>
! Determine if the point is in comp-domain for the processor
! </DESCRIPTION>
!
function on_comp_domain(nsp)

  integer, intent(in)  :: nsp
  logical :: on_comp_domain

  if(isc+Dom%ioff <= ispread(nsp) .and. ispread(nsp) <= iec+Dom%ioff .and. &
     jsc+Dom%joff <= jspread(nsp) .and. jspread(nsp) <= jec+Dom%joff) then
     on_comp_domain = .true.
  else 
     on_comp_domain = .false.  
  endif

end function on_comp_domain
! </FUNCTION> NAME="on_comp_domain"


!#######################################################################
! <FUNCTION NAME="on_data_domain">
!
! <DESCRIPTION>
! Determine if the point is in data-domain for the processor
! </DESCRIPTION>
!
function on_data_domain(nsp)

  integer, intent(in)  :: nsp
  logical :: on_data_domain

  if(isd+Dom%ioff <= ispread(nsp) .and. ispread(nsp) <= ied+Dom%ioff .and. &
     jsd+Dom%joff <= jspread(nsp) .and. jspread(nsp) <= jed+Dom%joff) then
     on_data_domain = .true.
  else 
     on_data_domain = .false.  
  endif

end function on_data_domain
! </FUNCTION> NAME="on_data_domain"


end module ocean_riverspread_mod

module transforms_mod

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, write_version_number, stdlog, close_file, check_nml_error

use mpp_mod, only: mpp_chksum, mpp_error, mpp_npes, mpp_sum, mpp_sync, mpp_sync_self, mpp_transmit

use mpp_domains_mod, only: mpp_get_compute_domain, mpp_get_compute_domains, mpp_get_domain_components, mpp_get_layout, &
                           mpp_get_pelist, mpp_update_domains, domain1D, XUPDATE, mpp_global_field

use spec_mpp_mod,  only: spec_mpp_init, spec_mpp_end, get_grid_domain, get_spec_domain, &
                         grid_domain, spectral_domain, global_spectral_domain, atmosphere_domain

use constants_mod, only: pi


use spherical_fourier_mod, only: spherical_fourier_init, spherical_fourier_end, &
                                 trans_spherical_to_fourier, trans_fourier_to_spherical, &
                                 get_south_to_north, &
                                 get_sin_lat, get_cos_lat, get_cosm_lat, get_cosm2_lat, &
                                 get_deg_lat, get_wts_lat, &
                                 spherical_init, spherical_end, &
                                 compute_lon_deriv_cos, compute_lat_deriv_cos, &
                                 compute_laplacian, compute_vor, compute_div, &
                                 get_spherical_wave, get_fourier_wave, &
                                 get_eigen_laplacian, compute_gradient_cos, &
                                 compute_ucos_vcos, compute_vor_div, &
                                 triangular_truncation, rhomboidal_truncation, &
                                 compute_legendre, compute_gaussian


use grid_fourier_mod, only: grid_fourier_init, grid_fourier_end, trans_grid_to_fourier, &
                            trans_fourier_to_grid, get_lon_max, get_longitude_origin, get_deg_lon

!---------------------------------------------------------------------------
! This module is initialized by transforms_init
!
! The partial re-initializations required when one changes either the
!   the number of longitudes in the transform grid
!   is provided by reset_num_lon_in_transform
!
! Fields are transformed from the transform grid to spherical harmonics
!   and back by trans_spherical_to_grid and trans_grid_to_spherical
!
! The two utilities, divide_by_cos and divide_by_cos2, provide convenient 
!   ways of dividing grid fields by cos(lat) and cos(lat)**2, 
!   as is often required when transforming to and fro in different contexts,
!   without having to compute or retrieve the gaussian latitudes explicitly.  
!
! trans_filter transforms a grid field to the spectral domain, multiplies
!   by a filter in the spectral domain, and then transforms back
!
!---------------------------------------------------------------------------

implicit none
private

interface trans_spherical_to_grid
   module procedure trans_spherical_to_grid_3d,  &
                    trans_spherical_to_grid_2d
end interface

interface trans_grid_to_spherical
   module procedure trans_grid_to_spherical_3d,  &
                    trans_grid_to_spherical_2d
end interface

interface trans_filter
   module procedure trans_filter_3d,  &
                    trans_filter_2d
end interface

interface divide_by_cos
   module procedure divide_by_cos_3d,  &
                    divide_by_cos_2d
end interface

interface divide_by_cos2
   module procedure divide_by_cos2_3d,  &
                    divide_by_cos2_2d
end interface

interface uv_grid_from_vor_div
   module procedure uv_grid_from_vor_div_2d,  &
                    uv_grid_from_vor_div_3d
end interface

interface vor_div_from_uv_grid
   module procedure vor_div_from_uv_grid_2d,  &
                    vor_div_from_uv_grid_3d
end interface

interface horizontal_advection
   module procedure horizontal_advection_2d,  &
                    horizontal_advection_3d
end interface

character(len=128), parameter :: version=&
'$Id: transforms.F90,v 19.0 2012/01/06 20:36:20 fms Exp $'

character(len=128), parameter :: tagname=&
'$Name: tikal $'

! ---------------------------------------------------

!  public interfaces defined in this module

public :: transforms_init
public :: transforms_end
public :: transforms_are_initialized
public :: reset_num_lon_in_transform
public :: trans_spherical_to_grid
public :: trans_grid_to_spherical
public :: divide_by_cos
public :: divide_by_cos2
public :: trans_filter
public :: get_lat_max
public :: get_triang_trunc
public :: get_num_fourier
public :: get_fourier_inc
public :: get_num_spherical
public :: get_grid_boundaries
public :: vor_div_from_uv_grid
public :: uv_grid_from_vor_div
public :: horizontal_advection
public :: area_weighted_global_mean

! ---------------------------------------------------

!  public interfaces carried forward from used modules

! From spherical_fourier_mod
public :: spherical_fourier_init, spherical_fourier_end
public :: trans_spherical_to_fourier, trans_fourier_to_spherical
public :: get_south_to_north
public :: get_sin_lat, get_cos_lat, get_cosm_lat, get_cosm2_lat
public :: get_deg_lat, get_wts_lat

! From grid_fourier_mod
public :: grid_fourier_init, grid_fourier_end
public :: trans_grid_to_fourier, trans_fourier_to_grid
public :: get_lon_max, get_deg_lon, get_longitude_origin

! From spherical_mod
public :: spherical_init, spherical_end
public :: compute_lon_deriv_cos, compute_lat_deriv_cos
public :: compute_laplacian, compute_vor, compute_div
public :: get_spherical_wave, get_fourier_wave
public :: get_eigen_laplacian, compute_gradient_cos
public :: compute_ucos_vcos, compute_vor_div
public :: triangular_truncation, rhomboidal_truncation

public :: compute_legendre, compute_gaussian

! From spec_mpp_mod
public :: spec_mpp_init, get_grid_domain, get_spec_domain
public :: grid_domain,  spectral_domain,  global_spectral_domain
public :: atmosphere_domain

! ---------------------------------------------------

!  The next six variables are initialized to zero so
!  as to allow a check that the user has supplied them.
integer :: lat_max=0
integer :: num_lon=0
integer :: num_fourier=0
integer :: fourier_inc=0
integer :: num_spherical=0

logical :: south_to_north_local
logical :: triang_trunc_local
real :: longitude_origin_local

integer :: trunc_fourier
logical :: module_is_initialized = .false.

integer :: npes
integer, dimension(2) :: grid_layout, spectral_layout
integer :: xmaxsize, ymaxsize   !used for dimensioning in transpose routines
logical :: debug=.FALSE.
integer :: ms, me, ns, ne, is, ie, js, je

real, allocatable, dimension(:) :: lat_boundaries_global, lon_boundaries_global
real :: global_sum_of_wts

logical :: check_fourier_imag=.false.
namelist / transforms_nml / check_fourier_imag

contains

!---------------------------------------------------------------------------
subroutine transforms_init(radius,            &
                           lat_max_in,        &
                           num_lon_in,        &
                           num_fourier_in,    &
                           fourier_inc_in,    &
                           num_spherical_in,  &
                           south_to_north,    &
                           triang_trunc,      &
                           longitude_origin)
!---------------------------------------------------------------------------

real,    intent(in) :: radius
integer, intent(in) :: lat_max_in
integer, intent(in) :: num_lon_in
integer, intent(in) :: num_fourier_in
integer, intent(in) :: fourier_inc_in
integer, intent(in) :: num_spherical_in

logical, intent(in), optional :: south_to_north, triang_trunc
real,    intent(in), optional :: longitude_origin
integer :: namelist_unit, ierr, io

real, allocatable :: wts_lat(:)
real :: sum_wts, del_lon
integer :: i, j

if(module_is_initialized) return

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=transforms_nml, iostat=io)
    ierr = check_nml_error(io, 'transforms_nml')
#else
    namelist_unit = open_namelist_file()
    ierr=1
    do while (ierr /= 0)
      read(namelist_unit, nml=transforms_nml, iostat=io, end=20)
      ierr = check_nml_error (io, 'transforms_nml')
    enddo
20  call close_file (namelist_unit)
#endif

call write_version_number(version, tagname)
if(mpp_pe() == mpp_root_pe()) write (stdlog(), nml=transforms_nml)

npes = mpp_npes()

!  make local copies of input

lat_max       = lat_max_in
num_lon       = num_lon_in
num_fourier   = num_fourier_in
fourier_inc   = fourier_inc_in
num_spherical = num_spherical_in

if(present(south_to_north)) then
  south_to_north_local = south_to_north
else
  south_to_north_local = .true.
end if

if(present(triang_trunc)) then
  triang_trunc_local = triang_trunc
else
  triang_trunc_local = .true.
end if

if(present(longitude_origin)) then
  longitude_origin_local = longitude_origin
else
  longitude_origin_local = 0.0
end if

call spec_mpp_init( num_fourier, num_spherical, num_lon, lat_max )
call get_grid_domain(is, ie, js, je)
call get_spec_domain(ms, me, ns, ne)
   
! initialize spherical_fourier (which initializes spherical)
call spherical_fourier_init(radius, lat_max, num_fourier, fourier_inc, num_spherical, &
                            south_to_north=south_to_north_local)   

trunc_fourier = num_fourier

call grid_fourier_init(num_lon, fourier_inc, &
     check=check_fourier_imag, longitude_origin=longitude_origin_local)

allocate( wts_lat(lat_max) )
call get_wts_lat(wts_lat)
allocate( lon_boundaries_global(num_lon+1) )
allocate( lat_boundaries_global(lat_max+1) )
lat_boundaries_global(1) = -.5*pi
sum_wts = 0.
do j=1,lat_max-1
  sum_wts = sum_wts + wts_lat(j)
  lat_boundaries_global(j+1) = asin(sum_wts-1.)
end do
lat_boundaries_global(lat_max+1) = .5*pi
if (.not. south_to_north_local) then
  lat_boundaries_global(:) = -lat_boundaries_global(:)
end if
del_lon = 2*pi/num_lon
do i=1,num_lon+1
  lon_boundaries_global(i) = longitude_origin_local + (i-1.5)*del_lon
end do

global_sum_of_wts = sum(wts_lat)

call mpp_get_layout( grid_domain, grid_layout )
call mpp_get_layout( spectral_domain, spectral_layout )
call mpp_get_compute_domain( spectral_domain, xmax_size=xmaxsize )
call mpp_get_compute_domain( grid_domain, ymax_size=ymaxsize )
module_is_initialized = .true.

return
end subroutine transforms_init

!--------------------------------------------------------------------------------------------------------------
logical function transforms_are_initialized()
!--------------------------------------------------------------------------------------------------------------

transforms_are_initialized = module_is_initialized
return

end function transforms_are_initialized

!--------------------------------------------------------------------------------------------------------------
subroutine reset_num_lon_in_transform(num_lon_in, trunc_fourier_in, longitude_origin)
!--------------------------------------------------------------------------------------------------------------

integer, intent(in) :: num_lon_in
integer, intent(in) :: trunc_fourier_in
real,    intent(in), optional    :: longitude_origin

num_lon = num_lon_in
trunc_fourier = trunc_fourier_in

if(present(longitude_origin)) then
  longitude_origin_local = longitude_origin
else
  longitude_origin_local = 0.0
end if

if(trunc_fourier > num_fourier) then
  call error_mesg('reset_num_lon_in_transform','trunc_fourier > num_fourier', FATAL)
end if

call grid_fourier_init(num_lon, fourier_inc, &
      check=check_fourier_imag, longitude_origin=longitude_origin_local)
if( npes.GT.1 )call abort()     !need to think about this still

return
end subroutine reset_num_lon_in_transform

!--------------------------------------------------------------------------
 subroutine trans_spherical_to_grid_3d(spherical, grid)
!--------------------------------------------------------------------------

complex, intent (in), dimension (ms:,ns:,:) :: spherical
real, intent(out), dimension (is:,:,:) :: grid
real, dimension(num_lon,size(grid,2),size(grid,3)) :: grid_xglobal

integer(kind=kind(spherical)) :: c1, c2, c3

complex, dimension (0:num_lon/2,          js:je, size(grid,3)) :: fourier_g
complex, dimension (ms:me, je-js+1, size(grid,3), grid_layout(2)) :: fourier_s
logical :: grid_x_is_global, spectral_y_is_global
type(domain1D) :: spectral_domain_y
integer, allocatable :: pelist(:)

if(.not.module_is_initialized) then
  call error_mesg('trans_spherical_to_grid','transforms module is not initialized', FATAL)
end if

if( size(grid,1).ne.ie-is+1 )&
     call mpp_error( FATAL, 'TRANS_SPHERICAL_TO_GRID: size(grid,1).ne.ie-is+1.' )

if( size(grid,2).ne.je-js+1 )&
     call mpp_error( FATAL, 'TRANS_SPHERICAL_TO_GRID: size(grid,2).ne.je-js+1.' )

if( size(spherical,1).ne.me-ms+1 )&
     call mpp_error( FATAL, 'TRANS_SPHERICAL_TO_GRID: size(spherical,1).ne.me-ms+1.' )

if( size(spherical,2).ne.ne-ns+1 )&
     call mpp_error( FATAL, 'TRANS_SPHERICAL_TO_GRID: size(spherical,2).ne.ne-ns+1.' )

if( size(spherical,3).ne.size(grid,3) )&
     call mpp_error( FATAL, 'TRANS_SPHERICAL_TO_GRID: size(spherical,3).ne.size(grid,3.' )

call trans_spherical_to_fourier( spherical, fourier_s )
call mpp_get_compute_domain( spectral_domain, y_is_global=spectral_y_is_global )
if( .NOT.spectral_y_is_global )then
    allocate( pelist(spectral_layout(2)) )
    call mpp_get_domain_components( spectral_domain, y=spectral_domain_y )
    call mpp_get_pelist( spectral_domain_y, pelist )
    call mpp_sum( fourier_s          , size(fourier_s(:,:,:,:)), pelist )
end if

call reverse_transpose_fourier( fourier_s, fourier_g )

fourier_g(trunc_fourier+1:num_lon/2,:,:) = cmplx(0.,0.)
call mpp_get_compute_domain( grid_domain, x_is_global=grid_x_is_global )
if( .NOT.grid_x_is_global )then
    grid_xglobal = trans_fourier_to_grid(fourier_g)
    grid(is:ie,:,:) = grid_xglobal(is:ie,:,:)
else
    grid = trans_fourier_to_grid(fourier_g)
endif

if( debug )then
    c1 = mpp_chksum(spherical)
    c2 = mpp_chksum(fourier_g)
    c3 = mpp_chksum(grid)
    write(  0,'(a,i2,3z18,28i4)' )'S2G: ', mpp_pe(), c1, c2, c3, lbound(spherical), ubound(spherical), &
         lbound(fourier_s), ubound(fourier_s), lbound(fourier_g), ubound(fourier_g), lbound(grid), ubound(grid)
end if

return
end subroutine trans_spherical_to_grid_3d

!--------------------------------------------------------------------------
 subroutine trans_spherical_to_grid_2d(spherical, grid)
!--------------------------------------------------------------------------

complex, intent (in), dimension (:,:)  ::  spherical
real, intent(out), dimension (:,:) :: grid

real, dimension (size(grid,1), size(grid,2), 1) :: grid_3d
complex, dimension(size(spherical,1), size(spherical,2), 1) :: spherical_3d

spherical_3d(:,:,1) = spherical(:,:)
call trans_spherical_to_grid_3d(spherical_3d, grid_3d)
grid(:,:) = grid_3d(:,:,1)

return
end subroutine trans_spherical_to_grid_2d

!-------------------------------------------------------------------------
subroutine trans_grid_to_spherical_3d(grid, spherical, do_truncation)
!-------------------------------------------------------------------------

real, intent(in), dimension (is:,:,:) :: grid
logical, intent(in), optional :: do_truncation
complex, intent(inout), dimension (ms:,ns:,:) :: spherical
real, dimension(num_lon,size(grid,2),size(grid,3)) :: grid_xglobal

logical :: do_truncation_local, grid_x_is_global
complex, dimension (0:num_lon/2,          js:je, size(grid,3)) :: fourier_g
complex, dimension (ms:me, je-js+1, size(grid,3), grid_layout(2)) :: fourier_s

integer(kind=kind(spherical)) :: c1, c2, c3

if(.not.module_is_initialized) then
  call error_mesg('trans_grid_to_spherical','transforms module is not initialized', FATAL)
end if

if( size(grid,1).ne.ie-is+1 )&
     call mpp_error( FATAL, 'TRANSFORMS: size(grid,1).ne.ie-is+1.' )

if( size(grid,2).ne.je-js+1 )&
     call mpp_error( FATAL, 'TRANSFORMS: size(grid,2).ne.je-js+1.' )

if( size(spherical,1).ne.me-ms+1 )&
     call mpp_error( FATAL, 'TRANSFORMS: size(spherical,1).ne.me-ms+1.' )

if( size(spherical,2).ne.ne-ns+1 )&
     call mpp_error( FATAL, 'TRANSFORMS: size(spherical,2).ne.ne-ns+1.' )

if( size(spherical,3).ne.size(grid,3) )&
     call mpp_error( FATAL, 'TRANSFORMS: size(spherical,3).ne.size(grid,3).' )

if(present(do_truncation)) then
  do_truncation_local = do_truncation
else
  do_truncation_local = .true.
end if

call mpp_get_compute_domain( grid_domain, x_is_global=grid_x_is_global )
if( .NOT.grid_x_is_global )then
    grid_xglobal(is:ie,:,:) = grid(is:ie,:,:)
    call mpp_update_domains( grid_xglobal, grid_domain, XUPDATE )
    fourier_g = trans_grid_to_fourier(grid_xglobal)
else
    fourier_g = trans_grid_to_fourier(grid)
endif

if( trunc_fourier.lt.me )fourier_g(trunc_fourier+1:me,:,:) = cmplx(0.,0.)

call transpose_fourier( fourier_g, fourier_s )
call trans_fourier_to_spherical(fourier_s, spherical)

if(do_truncation_local) then
  if(triang_trunc_local) then
    call triangular_truncation(spherical)
  else
    call rhomboidal_truncation(spherical)
  end if
end if

if( debug )then
    c1 = mpp_chksum(spherical)
    c2 = mpp_chksum(fourier_g)
    c3 = mpp_chksum(grid)
    write(  0,'(a,i2,3z18,28i4)' )'G2S: ', mpp_pe(), c1, c2, c3, lbound(spherical), ubound(spherical), &
         lbound(fourier_s), ubound(fourier_s), lbound(fourier_g), ubound(fourier_g), lbound(grid), ubound(grid)
    call mpp_error( FATAL )
end if

return
end subroutine trans_grid_to_spherical_3d

!-------------------------------------------------------------------------
subroutine trans_grid_to_spherical_2d(grid, spherical, do_truncation)
!-------------------------------------------------------------------------

real,    intent(in), dimension (:,:) :: grid
logical, intent(in), optional :: do_truncation
complex, intent(inout), dimension (:,:) :: spherical

real, dimension (size(grid,1), size(grid,2), 1) :: grid_3d
complex, dimension (size(spherical,1), size(spherical,2), 1) :: spherical_3d

grid_3d(:,:,1) = grid(:,:)
spherical_3d(:,:,1) = cmplx(0.0,0.0)
call trans_grid_to_spherical_3d(grid_3d, spherical_3d, do_truncation)
spherical(:,:) = spherical_3d(:,:,1)

return
end subroutine trans_grid_to_spherical_2d

!-------------------------------------------------------------------------
subroutine trans_filter_3d(grid, filter)
!-------------------------------------------------------------------------

real, intent(inout), dimension (:,:,:) :: grid
real, intent(in), optional, dimension (:,:) :: filter

complex, dimension (ms:me, ns:ne, size(grid,3)) :: spherical
integer :: k

if(.not.module_is_initialized) then
  call error_mesg('trans_filter','transforms module is not initialized', FATAL)
end if

call trans_grid_to_spherical(grid, spherical)

if(present(filter)) then
  do k=1, size(grid,3)
    spherical(ms:me,ns:ne,k) = spherical(ms:me,ns:ne,k)*filter
  end do
end if

call trans_spherical_to_grid(spherical, grid)

return

end subroutine trans_filter_3d

!-------------------------------------------------------------------------
subroutine trans_filter_2d(grid, filter)
!-------------------------------------------------------------------------

real, intent(inout), dimension (:,:) :: grid
real, intent(in), optional, dimension (:,:) :: filter

real, dimension(size(grid,1),size(grid,2),1) :: grid_3d

grid_3d(:,:,1) = grid
call trans_filter_3d(grid_3d, filter)
grid = grid_3d(:,:,1)

return
end subroutine trans_filter_2d

!-------------------------------------------------------------------------
subroutine divide_by_cos_3d(grid)
!-------------------------------------------------------------------------

real, intent (inout), dimension(:,:,:) :: grid

real, dimension(size(grid,2)) :: cosm_lat
integer :: i,j,k

if(.not.module_is_initialized) then
  call error_mesg('divide_by_cos','transforms module is not initialized', FATAL)
end if

call get_cosm_lat(cosm_lat)

do k=1,size(grid,3)
  do j=1,size(grid,2)
    do i=1,size(grid,1)
      grid(i,j,k)=grid(i,j,k)*cosm_lat(j)
    end do
  end do
end do

return
end subroutine divide_by_cos_3d

!-------------------------------------------------------------------------
subroutine divide_by_cos2_3d(grid)
!-------------------------------------------------------------------------

real, intent (inout), dimension(:,:,:) :: grid

real, dimension(size(grid,2)) :: cosm2_lat
integer :: i,j,k

if(.not.module_is_initialized) then
  call error_mesg('divide_by_cos2','transforms module is not initialized', FATAL)
end if

call get_cosm2_lat(cosm2_lat)

do k=1,size(grid,3)
  do j=1,size(grid,2)
    do i=1,size(grid,1)
      grid(i,j,k)=grid(i,j,k)*cosm2_lat(j)
    end do
  end do
end do

return
end subroutine divide_by_cos2_3d

!-------------------------------------------------------------------------
subroutine divide_by_cos_2d(grid)
!-------------------------------------------------------------------------

real, intent (inout), dimension(:,:) :: grid

real, dimension(size(grid,1),size(grid,2),1) :: grid_3d

grid_3d(:,:,1) = grid(:,:)
call divide_by_cos_3d(grid_3d)
grid(:,:) = grid_3d(:,:,1)

return
end subroutine divide_by_cos_2d

!-------------------------------------------------------------------------
subroutine divide_by_cos2_2d(grid)
!-------------------------------------------------------------------------

real, intent (inout), dimension(:,:) :: grid

real, dimension(size(grid,1),size(grid,2),1) :: grid_3d

grid_3d(:,:,1) = grid(:,:)
call divide_by_cos2_3d(grid_3d)
grid(:,:) = grid_3d(:,:,1)

return
end subroutine divide_by_cos2_2d

!-------------------------------------------------------------------------
subroutine uv_grid_from_vor_div_2d(vor_spec, div_spec, u_grid, v_grid)
!-------------------------------------------------------------------------

complex, intent(in) , dimension(:,:) :: vor_spec, div_spec
real,    intent(out), dimension(:,:) :: u_grid, v_grid

complex, dimension(size(vor_spec,1), size(vor_spec,2), 1) :: vor_spec_3d, div_spec_3d
real,    dimension(size(u_grid,  1), size(u_grid,  2), 1) ::   u_grid_3d,   v_grid_3d

vor_spec_3d(:,:,1) = vor_spec
div_spec_3d(:,:,1) = div_spec
call uv_grid_from_vor_div_3d(vor_spec_3d, div_spec_3d, u_grid_3d, v_grid_3d)
u_grid = u_grid_3d(:,:,1)
v_grid = v_grid_3d(:,:,1)

return
end subroutine uv_grid_from_vor_div_2d

!-------------------------------------------------------------------------
subroutine uv_grid_from_vor_div_3d(vor_spec, div_spec, u_grid, v_grid)
!-------------------------------------------------------------------------

complex, intent(in) , dimension(:,:,:) :: vor_spec, div_spec
real,    intent(out), dimension(:,:,:) :: u_grid, v_grid

complex , dimension(size(vor_spec,1), size(vor_spec,2), size(vor_spec,3)) :: dx_spec, dy_spec

if(.not.module_is_initialized) then
  call error_mesg('uv_grid_from_vor_div','transforms module is not initialized', FATAL)
end if

call compute_ucos_vcos          (vor_spec, div_spec, dx_spec, dy_spec)
call trans_spherical_to_grid    (dx_spec , u_grid)
call trans_spherical_to_grid    (dy_spec , v_grid)
call divide_by_cos              (u_grid)
call divide_by_cos              (v_grid)

return
end subroutine uv_grid_from_vor_div_3d

!-------------------------------------------------------------------------
subroutine vor_div_from_uv_grid_2d(u_grid, v_grid, vor_spec, div_spec, triang)
!-------------------------------------------------------------------------

real,    intent(in),    dimension(:,:) :: u_grid, v_grid
complex, intent(out  ), dimension(:,:) :: vor_spec, div_spec
logical, intent(in), optional :: triang

complex, dimension(size(vor_spec,1), size(vor_spec,2), 1) :: vor_spec_3d, div_spec_3d
real,    dimension(size(u_grid,  1), size(u_grid,  2), 1) ::   u_grid_3d,   v_grid_3d

u_grid_3d(:,:,1) = u_grid
v_grid_3d(:,:,1) = v_grid
call vor_div_from_uv_grid_3d(u_grid_3d, v_grid_3d, vor_spec_3d, div_spec_3d, triang)
vor_spec = vor_spec_3d(:,:,1)
div_spec = div_spec_3d(:,:,1)

return
end subroutine vor_div_from_uv_grid_2d

!-------------------------------------------------------------------------
subroutine vor_div_from_uv_grid_3d(u_grid, v_grid, vor_spec, div_spec, triang)
!-------------------------------------------------------------------------

real,    intent(in),  dimension(:,:,:) :: u_grid, v_grid
complex, intent(out), dimension(:,:,:) :: vor_spec, div_spec
logical, intent(in), optional :: triang

complex, dimension(size(vor_spec,1), size(vor_spec,2), size(vor_spec,3)) :: dx_spec, dy_spec
real   , dimension(size(u_grid  ,1), size(u_grid  ,2), size(u_grid  ,3)) :: grid_tmp

logical :: do_triang

if(.not.module_is_initialized) then
  call error_mesg('vor_div_from_uv_grid','transforms module is not initialized', FATAL)
end if

if(present(triang)) then
  do_triang = triang
else
  do_triang = .true.
endif

grid_tmp = u_grid
call divide_by_cos(grid_tmp)
call trans_grid_to_spherical(grid_tmp, dx_spec, do_truncation=.false.)

grid_tmp = v_grid
call divide_by_cos(grid_tmp)
call trans_grid_to_spherical(grid_tmp, dy_spec, do_truncation=.false.)

call compute_vor_div(dx_spec, dy_spec, vor_spec, div_spec)

if(do_triang) then
  call triangular_truncation(vor_spec)
  call triangular_truncation(div_spec)
else
  call rhomboidal_truncation(vor_spec)
  call rhomboidal_truncation(div_spec)
endif

return
end subroutine vor_div_from_uv_grid_3d

!-------------------------------------------------------------------------
subroutine horizontal_advection_2d(field_spec, u_grid, v_grid, tendency)
!-------------------------------------------------------------------------

complex, intent(in),    dimension(:,:) :: field_spec
real,    intent(in),    dimension(:,:) :: u_grid, v_grid
real,    intent(inout), dimension(:,:) :: tendency

complex, dimension(size(field_spec,1), size(field_spec,2), 1) :: field_spec_3d
real,    dimension(size(u_grid,    1), size(u_grid,    2), 1) :: u_grid_3d, v_grid_3d
real,    dimension(size(u_grid,    1), size(u_grid,    2), 1) :: tendency_3d

field_spec_3d(:,:,1) = field_spec
u_grid_3d(:,:,1) = u_grid
v_grid_3d(:,:,1) = v_grid
tendency_3d(:,:,1) = tendency
call horizontal_advection_3d(field_spec_3d, u_grid_3d, v_grid_3d, tendency_3d)
tendency = tendency_3d(:,:,1)

return
end subroutine horizontal_advection_2d

!-------------------------------------------------------------------------
subroutine horizontal_advection_3d(field_spec, u_grid, v_grid, tendency)
!-------------------------------------------------------------------------

complex, intent(in),    dimension(:,:,:) :: field_spec
real,    intent(in),    dimension(:,:,:) :: u_grid, v_grid
real,    intent(inout), dimension(:,:,:) :: tendency

real,    dimension(size(u_grid,    1), size(u_grid,    2), size(u_grid,    3)) :: dx_grid, dy_grid 
complex, dimension(size(field_spec,1), size(field_spec,2), size(field_spec,3)) :: dx_spec, dy_spec 

if(.not.module_is_initialized) then
  call error_mesg('horizontal_advection','transforms module is not initialized', FATAL)
end if

call compute_gradient_cos(field_spec, dx_spec, dy_spec)
call trans_spherical_to_grid(dx_spec, dx_grid)
call trans_spherical_to_grid(dy_spec, dy_grid)

call divide_by_cos(dx_grid)
call divide_by_cos(dy_grid)
tendency = tendency - u_grid*dx_grid - v_grid*dy_grid

return
end subroutine horizontal_advection_3d

!-------------------------------------------------------------------------
subroutine get_lat_max(lat_max_out)
!-------------------------------------------------------------------------

integer, intent(out) :: lat_max_out

if(.not.module_is_initialized) then
  call error_mesg('get_lat_max','transforms module is not initialized', FATAL)
end if

lat_max_out = lat_max

return
end subroutine get_lat_max

!-------------------------------------------------------------------------
subroutine get_triang_trunc(triang_trunc_out)
!-------------------------------------------------------------------------

logical, intent(out) :: triang_trunc_out

if(.not.module_is_initialized) then
  call error_mesg('get_triang_trunc','transforms module is not initialized', FATAL)
end if

triang_trunc_out = triang_trunc_local

return
end subroutine get_triang_trunc

!-------------------------------------------------------------------------
subroutine get_num_fourier(num_fourier_out)
!-------------------------------------------------------------------------

integer, intent(out) :: num_fourier_out

if(.not.module_is_initialized) then
  call error_mesg('get_num_fourier','transforms module is not initialized', FATAL)
end if
    
num_fourier_out = num_fourier

return
end subroutine get_num_fourier

!-------------------------------------------------------------------------
subroutine get_fourier_inc(fourier_inc_out)
!-------------------------------------------------------------------------

integer, intent(out) :: fourier_inc_out

if(.not.module_is_initialized) then
  call error_mesg('get_fourier_inc','transforms module is not initialized', FATAL)
end if
    
fourier_inc_out = fourier_inc

return
end subroutine get_fourier_inc

!-------------------------------------------------------------------------
subroutine get_num_spherical(num_spherical_out)
!-------------------------------------------------------------------------

integer, intent(out) :: num_spherical_out

if(.not.module_is_initialized) then
  call error_mesg('get_num_spherical','transforms module is not initialized', FATAL)
end if
    
num_spherical_out = num_spherical

return
end subroutine get_num_spherical

!-------------------------------------------------------------------------
subroutine get_grid_boundaries(lon_boundaries, lat_boundaries,global)
!-------------------------------------------------------------------------

  real, intent(out), dimension(:) :: lon_boundaries, lat_boundaries
  logical,intent(in),optional :: global

  logical :: global_tmp
  character(len=3) :: chtmp1, chtmp2

  if(.not.module_is_initialized) then
     call error_mesg('get_grid_boundaries','transforms module is not initialized', FATAL)
  end if

  if (present(global)) then
     global_tmp = global
  else
     global_tmp = .false.
  endif

  if (.not. global_tmp) then
     if(size(lon_boundaries,1) /= ie-is+2) then
        write(chtmp1,'(i3)') size(lon_boundaries,1)
        write(chtmp2,'(i3)') ie-is+2
        call error_mesg('get_grid_boundaries','size(lon_boundaries) is incorrect. size(lon_boundaries)=' &
                       & //chtmp1//'  Should be'//chtmp2, FATAL)
     endif

     if(size(lat_boundaries,1) /= je-js+2) then
        write(chtmp1,'(i3)') size(lat_boundaries,1)
        write(chtmp2,'(i3)') je-js+2
        call error_mesg('get_grid_boundaries','size(lat_boundaries) is incorrect. size(lat_boundaries)=' &
                       & //chtmp1//'  Should be'//chtmp2, FATAL)
     endif

  else !global call
     if(size(lon_boundaries,1) /= num_lon+1) then
        write(chtmp1,'(i3)') size(lon_boundaries,1)
        write(chtmp2,'(i3)') num_lon+1
        call error_mesg('get_grid_boundaries','size(lon_boundaries) is incorrect. size(lon_boundaries)=' &
                       & //chtmp1//'  Should be'//chtmp2, FATAL)
     endif

     if(size(lat_boundaries,1) /= lat_max+1) then
        write(chtmp1,'(i3)') size(lat_boundaries,1)
        write(chtmp2,'(i3)') lat_max+1
        call error_mesg('get_grid_boundaries','size(lat_boundaries) is incorrect. size(lat_boundaries)=' &
                       & //chtmp1//'  Should be'//chtmp2, FATAL)
     endif
  endif

  if (global_tmp) then
     lon_boundaries = lon_boundaries_global
     lat_boundaries = lat_boundaries_global
  else
     lon_boundaries = lon_boundaries_global(is:ie+1)
     lat_boundaries = lat_boundaries_global(js:je+1)
  endif
  return
end subroutine get_grid_boundaries

!-------------------------------------------------------------------------
subroutine reverse_transpose_fourier( fourier_s, fourier_g )
!-------------------------------------------------------------------------
  complex, intent(in)  :: fourier_s(:,:,:,0:)
  complex, intent(out) :: fourier_g(0:,:,:)
  complex, dimension(xmaxsize*ymaxsize*size(fourier_s,3)) :: get_data
  integer :: i,j,k, jj, jp, jm, pp, pm, nput, nget, jpos
  type(domain1D) :: spectral_domain_x, grid_domain_y
  integer, dimension(0:grid_layout(2)-1) :: pelist, ygridsize, xspecsize, xsbegin, xsend

  if(.not.module_is_initialized) then
    call error_mesg('reverse_transpose_fourier','transforms module is not initialized', FATAL)
  end if

  call mpp_get_domain_components( grid_domain, y=grid_domain_y )
  call mpp_get_domain_components( spectral_domain, x=spectral_domain_x )
  call mpp_get_pelist( grid_domain_y, pelist, jpos )
  call mpp_get_compute_domains( grid_domain_y, size=ygridsize )
  call mpp_get_compute_domains( spectral_domain_x, xsbegin, xsend, xspecsize )
  nput = size(fourier_s,1)*size(fourier_s,2)*size(fourier_s,3)
  fourier_g(ms:me,:,:) = fourier_s(:,:,:,jpos)
  do jj = 1,grid_layout(2)-1
     jp = mod(jpos+jj,grid_layout(2))
     jm = mod(jpos-jj+grid_layout(2),grid_layout(2))
     pp = pelist(jp)
     pm = pelist(jm)
     nget = xspecsize(jm)*ygridsize(jm)*size(fourier_s,3)
     ! Force use of "scalar", integer pointer mpp interface
     call mpp_transmit( put_data=fourier_s(1,1,1,jp), plen=nput, to_pe=pp, &
                        get_data=get_data(1), glen=nget, from_pe=pm )
     nget = 0
     do k = 1,size(fourier_g,3)
        do j = 1,size(fourier_g,2)
           do i = xsbegin(jm),xsend(jm)
              nget = nget + 1
              fourier_g(i,j,k) = get_data(nget)
           end do
        end do
     end do
  end do
  call mpp_sync()
  return
end subroutine reverse_transpose_fourier

!-------------------------------------------------------------------------
subroutine transpose_fourier( fourier_g, fourier_s )
!-------------------------------------------------------------------------
  complex, intent(in)   :: fourier_g(0:,:,:)
  complex, intent(out)  :: fourier_s(:,:,:,0:)
  complex, dimension(xmaxsize*ymaxsize*size(fourier_s,3)) :: put_data
  integer :: i,j,k, ii, ip, im, pp, pm, nput, nget, ipos, jp
  type(domain1D) :: spectral_domain_x, grid_domain_y
  integer, dimension(0:spectral_layout(1)-1) :: pelist, ygridsize, xspecsize, xsbegin, xsend

  if(.not.module_is_initialized) then
    call error_mesg('transpose_fourier','transforms module is not initialized', FATAL)
  end if

  call mpp_get_domain_components( grid_domain, y=grid_domain_y )
  call mpp_get_domain_components( spectral_domain, x=spectral_domain_x )
  call mpp_get_compute_domains( grid_domain_y, size=ygridsize )
  call mpp_get_compute_domains( spectral_domain_x, xsbegin, xsend, xspecsize )
  nget = size(fourier_s,1)*size(fourier_s,2)*size(fourier_s,3)
  call mpp_get_pelist( grid_domain_y, pelist, jp )
  fourier_s(:,:,:,jp) = fourier_g(ms:me,:,:)
  call mpp_get_pelist( spectral_domain_x, pelist, ipos )
  do ii = 1,spectral_layout(1)-1
     ip = mod(ipos+ii,spectral_layout(1))
     im = mod(ipos-ii+spectral_layout(1),spectral_layout(1))
     pp = pelist(ip)
     pm = pelist(im)
     nput = 0
     call mpp_sync_self()
     do k = 1,size(fourier_g,3)
        do j = 1,size(fourier_g,2)
           do i = xsbegin(ip),xsend(ip)
              nput = nput + 1
              put_data(nput) = fourier_g(i,j,k)
           end do
        end do
     end do
     ! Force use of "scalar", integer pointer mpp interface
     call mpp_transmit( put_data=put_data(1), plen=nput, to_pe=pp, &
                        get_data=fourier_s(1,1,1,im), glen=nget, from_pe=pm )
  end do
  call mpp_sync()
  return
end subroutine transpose_fourier

!-------------------------------------------------------------------------
function area_weighted_global_mean(field)
!-------------------------------------------------------------------------
real :: area_weighted_global_mean
real, intent(in), dimension(:,:) :: field
real, dimension(size(field,2))   :: wts_lat
real, dimension(size(field,1), size(field,2)) :: weighted_field_local
real, dimension(num_lon, lat_max) :: weighted_field_global
integer :: j

call get_wts_lat(wts_lat)
do j=1,size(field,2)
  weighted_field_local(:,j) = wts_lat(j)*field(:,j)
enddo

call mpp_global_field(grid_domain, weighted_field_local, weighted_field_global)
area_weighted_global_mean = sum(weighted_field_global)/(global_sum_of_wts*num_lon)

return
end function area_weighted_global_mean

!-------------------------------------------------------------------------
subroutine transforms_end
!-------------------------------------------------------------------------

if(.not.module_is_initialized) return

deallocate(lon_boundaries_global, lat_boundaries_global)
call grid_fourier_end
call spherical_fourier_end
call spec_mpp_end
module_is_initialized = .false.

return
end subroutine transforms_end
!-------------------------------------------------------------------------

end module transforms_mod

                     module shortwave_driver_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
!
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  smf
! </REVIEWER>
! 
!
! <OVERVIEW>
!  Code to carry out shortwave calculation.
! </OVERVIEW>
! <DESCRIPTION>
!  This code initializes, prepares, and ends shortwave radiation calculation.
!  This code is called by sea_esf_rad.f90 and calls shortwave subroutines
!  to do shortwave flux calculation.
! </DESCRIPTION>
!

!   shared modules:

use mpp_mod,              only: input_nml_file
use fms_mod,              only: open_namelist_file, fms_init, &
                                mpp_pe, mpp_root_pe, stdlog, &
                                file_exist, write_version_number, &
                                check_nml_error, error_mesg, &
                                FATAL, close_file

!   shared radiation package modules:
 
use rad_utilities_mod,    only: rad_utilities_init, Rad_control,  &
                                cldrad_properties_type, &
                                cld_specification_type, Sw_control, &
                                Cldrad_control, &
                                radiative_gases_type,   &
                                aerosol_diagnostics_type, &
                                aerosol_type, aerosol_properties_type,&
                                atmos_input_type, surface_type, &
                                astronomy_type, sw_output_type, &
                                assignment(=), cld_space_properties_type
use esfsw_parameters_mod, only: esfsw_parameters_init

!  radiation package modules:

use lhsw_driver_mod,      only: lhsw_driver_init, swrad
use esfsw_driver_mod,     only: esfsw_driver_init, swresf,   &
                                esfsw_driver_end

!-------------------------------------------------------------------

implicit none
private

!------------------------------------------------------------------
!    shortwave_driver_mod is the driver for shortwave radiation 
!    component of the sea_esf_rad radiation package.
!-----------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module  -------------------------

character(len=128)  :: version =  '$Id: shortwave_driver.F90,v 19.0 2012/01/06 20:24:07 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!---------------------------------------------------------------------
!-------  interfaces --------

public        &
          shortwave_driver_init , shortwave_driver,    & 
          shortwave_driver_end


private       &

!   called from shortwave_driver:
          shortwave_driver_alloc


!---------------------------------------------------------------------
!-------- namelist  ---------

character(len=16)   :: swform = '    '
logical             :: do_cmip_diagnostics = .false.
logical             :: calculate_volcanic_sw_heating = .false.
  
 
namelist / shortwave_driver_nml /             &
                                     do_cmip_diagnostics, &
                                     calculate_volcanic_sw_heating, &
                                     swform

!---------------------------------------------------------------------
!------- public data ------


!---------------------------------------------------------------------
!------- private data ------

logical :: module_is_initialized = .false.  ! module initialized ?


!-------------------------------------------------------------------
!-------------------------------------------------------------------



                         contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!                                
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

! <SUBROUTINE NAME="shortwave_driver_init">
!  <OVERVIEW>
!   Code that initializes shortwave radiation calculation.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Initialize utilities and radiation utilities if necessary. They
!   should have been initialized in the radiation initialiation subroutine
!   in the sea_esf_rad.f90. The code then reads in input.nml namelist
!   and logs input parameters to logfile. It uses lhsw or esfsw package
!   depends on namelist parameter. Initializes apropriate shortwave
!   package subroutines and set up the initialize parameter.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call shortwave_driver_init (latb, pref)
!  </TEMPLATE>
!  <IN NAME="latb" TYPE="real">
!   2d array of model latitudes at cell corners [radians]
!  </IN>
!  <IN NAME="pref" TYPE="real">
!   An array containing two reference pressure profiles [pascals]
!  </IN>
! </SUBROUTINE>
subroutine shortwave_driver_init (latb, pref)

!---------------------------------------------------------------------
!    shortwave_driver_init is the constructor for shortwave_driver_mod.
!---------------------------------------------------------------------

!---------------------------------------------------------------------
real, dimension(:,:), intent(in) :: latb
real, dimension(:,:), intent(in) :: pref
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  intent(in) variables:
!
!       latb      2d array of model latitudes at cell corners 
!                 [ radians ]
!                                
!       pref      array containing two reference pressure profiles 
!                 [ Pa ]
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

      integer   :: unit, io, ierr, logunit

!---------------------------------------------------------------------
!  local variables:
!
!        unit            io unit number used for namelist file
!        ierr            error code
!        io              error status returned from io operation
!                                
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!    if routine has already been executed, exit.
!-------------------------------------------------------------------
      if (module_is_initialized) return

!-------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!-------------------------------------------------------------------
      call fms_init
      call rad_utilities_init

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=shortwave_driver_nml, iostat=io)
      ierr = check_nml_error(io,"shortwave_driver_nml")
#else
!-----------------------------------------------------------------------
!    read namelist.
!-----------------------------------------------------------------------
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=shortwave_driver_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'shortwave_driver_nml')
        end do
10      call close_file (unit)
      endif
#endif
 
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                       write (logunit, nml=shortwave_driver_nml)

!--------------------------------------------------------------------
!    define logicals specifying the sw package in use as an element
!    of a shortwave_control_type variable usable by other radiation-
!    related modules. initialize the modules associated with the chosen
!    sw package.
!---------------------------------------------------------------------
      if (trim(swform) == 'lhsw') then
        Sw_control%do_lhsw  = .true.
        call lhsw_driver_init (pref)
        Cldrad_control%do_ica_calcs_iz = .true.
      else if (trim(swform) == 'esfsw99') then
        Sw_control%do_esfsw = .true.
        call esfsw_parameters_init
        call esfsw_driver_init
      else
        call error_mesg ( 'shortwave_driver_mod',   &
        'improper specification of desired shortwave parameterization',&
                                                               FATAL)
      endif

!---------------------------------------------------------------------
!    mark the just-defined logicals as defined.
!---------------------------------------------------------------------
      Sw_control%do_lhsw_iz  = .true.
      Sw_control%do_esfsw_iz = .true.

!---------------------------------------------------------------------
!    save the logical indicating the need to generate cmip aerosol
!    diagnostics and mark it as initialized.
!---------------------------------------------------------------------
      Sw_control%do_cmip_diagnostics = do_cmip_diagnostics
      Sw_control%do_cmip_diagnostics_iz = .true.             

!     if (calculate_volcanic_sw_heating) then
!       if (Rad_control%volcanic_sw_aerosols_iz) then
!         if (Rad_control%volcanic_sw_aerosols) then
!         else
!           call error_mesg ('shortwave_driver_mod', &
!            'cannot calculate volcanic sw heating when wolcanic sw &
!                            &aerosols are not activated', FATAL)
!         endif
!       else
!           call error_mesg ('shortwave_driver_mod', &
!            'Rad_control%volcanic_sw_aerosols not yet defined', FATAL)
!       endif
!     endif

!-------------------------------------------------------------------
!    set flag indicating successful initialization of module.
!-------------------------------------------------------------------
      module_is_initialized = .true.

!--------------------------------------------------------------------


end subroutine shortwave_driver_init



!###########################################################
! <SUBROUTINE NAME="shortwave_driver">
!  <OVERVIEW>
!   Code that deploys shortwave radiation calculation
!  </OVERVIEW>
!  <DESCRIPTION>
!    shortwave_driver initializes shortwave radiation output variables, 
!    determines if shortwave radiation is present in the current physics
!    window, selects one of the available shortwave parameterizations,
!    executes it, and returns the output fields to sea_esf_rad_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!    call shortwave_driver (is, ie, js, je, Atmos_input, Surface, Astro, &
!                           Rad_gases, Cldrad_props, Cld_spec, Sw_output, &
!                           Cldspace_rad) 
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!    starting subdomain i indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="ie" TYPE="integer">
!    ending subdomain i indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="js" TYPE="integer">
!    starting subdomain j indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="je" TYPE="integer">
!    ending subdomain j indices of data in 
!                   the physics_window being integrated
!  </IN>
!   <IN NAME="Atmos_input" TYPE="atmos_input_type">
!     Atmos_input_type variable containing the atmospheric
!     input fields on the radiation grid 
!   </IN>
!   <IN NAME="Astro" TYPE="astronomy_type">
!     Astronomy_type variable containing the astronomical
!     input fields on the radiation grid  
!   </IN>
!   <IN NAME="Aerosol" TYPE="aerosol_type">
!    Aerosol input data of shortwave radiation calculation
!   </IN>
!   <IN NAME="Aerosol_props" TYPE="aerosol_properties_type">
!    Aerosol radiative property input data 
!   </IN>
!   <IN NAME="Rad_gases" TYPE="radiative_gases_type">
!     Radiative_gases_type variable containing the radiative 
!     gas input fields on the radiation grid 
!   </IN>
!   <IN NAME="Cldrad_props" TYPE="cldrad_properties_type">
!     The cloud radiative property input fields on the
!     radiation grid
!   </IN>
!   <INOUT NAME="Sw_output" TYPE="sw_output_type">
!     The shortwave radiation calculation result
!   </INOUT>
!   <INOUT NAME="Cldspace_rad" TYPE="cld_space_properties_type">
!     Optional cloud radiative forcing output used in lacis-hansen
!     formulation.
!   </INOUT>
!   <IN NAME="Surface" TYPE="surface_type">
!    Surface data as boundary condition to radiation
!   </IN>
!   <IN NAME="Cld_spec" TYPE="cld_specification_type">
!    Cloud specification data as initial condition to radiation
!   </IN>
! </SUBROUTINE>
subroutine shortwave_driver (is, ie, js, je, Atmos_input, Surface,  &
                             Astro, Aerosol, Aerosol_props, Rad_gases, &
                             Cldrad_props,  Cld_spec, Sw_output,      &
                             Cldspace_rad, Aerosol_diags, r) 

!---------------------------------------------------------------------
!    shortwave_driver initializes shortwave radiation output variables, 
!    determines if shortwave radiation is present in the current physics
!    window, selects one of the available shortwave parameterizations,
!    executes it, and returns the output fields to sea_esf_rad_mod.
!---------------------------------------------------------------------

integer,                         intent(in)    :: is, ie, js, je
type(atmos_input_type),          intent(in)    :: Atmos_input     
type(surface_type),              intent(in)    :: Surface     
type(astronomy_type),            intent(in)    :: Astro           
type(radiative_gases_type),      intent(in)    :: Rad_gases   
type(aerosol_type),              intent(in)    :: Aerosol     
type(aerosol_properties_type),   intent(inout) :: Aerosol_props
type(cldrad_properties_type),    intent(in)    :: Cldrad_props
type(cld_specification_type),    intent(in)    :: Cld_spec
type(sw_output_type), dimension(:), intent(inout) :: Sw_output
type(cld_space_properties_type), intent(inout) :: Cldspace_rad
type(aerosol_diagnostics_type), intent(inout)  :: Aerosol_diags
real, dimension(:,:,:,:),        intent(inout) :: r

!--------------------------------------------------------------------
!  intent(in) variables:
!
!      is,ie,js,je    starting/ending subdomain i,j indices of data in 
!                     the physics_window being integrated
!      Atmos_input    atmos_input_type variable containing the atmos-
!                     pheric input fields needed by the radiation 
!                     package
!      Surface        surface_type variable containing the surface input
!                     fields needed by the radiation package
!      Astro          astronomy_type variable containing the astronom-
!                     ical input fields needed by the radiation package
!      Rad_gases      radiative_gases_type variable containing the radi-
!                     ative gas input fields needed by the radiation 
!                     package
!      Aerosol        aerosol_type variable containing the aerosol input
!                     data needed by the radiation package
!      Aerosol_props  aerosol_properties_type variable containing the
!                     aerosol radiative properties input data needed by
!                     the radiation package
!      Cldrad_props   cldrad_properties_type variable containing the 
!                     cloud radiative property input fields needed by 
!                     the radiation package
!      Cld_spec       cld_specification_type variable containing the 
!                     cloud specification input fields needed by the 
!                     radiation package
!
!   intent(out) variables:
!
!      Sw_output      sw_output_type variable containing shortwave 
!                     radiation output data 
!      Cldspace_rad   cld_space_properties_type variable containing the
!                     sw output fields obtained from the lacis-hansen
!                     shortwave parameterization 
!
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!  local variables:

      type(sw_output_type) :: Sw_output_ad, Sw_output_std
      logical  :: skipswrad
      logical  :: with_clouds
      logical  :: calc_includes_aerosols
      integer  :: naerosol_optical
      integer  :: i, j       
      integer  :: ix, jx, kx

!---------------------------------------------------------------------
!   local variables:
!
!      skipswrad    bypass calling sw package because sun is not 
!                   shining any where in current physics window ?
!      with_clouds  are clouds to be considered in determining
!                   the sw fluxes and heating rates ?
!      ix,jx,kx     dimensions of current physics window
!      i,j          do-loop indices
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('shortwave_driver_mod',   &
             'module has not been initialized', FATAL )
      endif

!----------------------------------------------------------------------
!    call shortwave_driver_alloc to initialize shortwave fluxes and 
!    heating rates.
!--------------------------------------------------------------------
      ix = ie - is + 1
      jx = je - js + 1
      kx = size (Atmos_input%press,3) - 1
!**************************************
      ! This is a temporary fix! Sw_output needs to be allocated at a higher level!
      ! Constructor and destructor for sw_output_type needs to be provided through
      ! rad_utilities
!**************************************
      call shortwave_driver_alloc (ix, jx, kx, Sw_output(1)) 
      call shortwave_driver_alloc (ix, jx, kx, Sw_output_std) 
      if (Rad_control%do_swaerosol_forcing) then
        call shortwave_driver_alloc (ix, jx, kx, Sw_output_ad)
        call shortwave_driver_alloc (ix, jx, kx, Sw_output(Rad_control%indx_swaf)) 
      endif

!--------------------------------------------------------------------
!    determine when the no-sun case exists at all points within the 
!    physics window and bypass the sw radiation calculations for that 
!    window. for do_annual_mean or do_daily_mean, only one cosz in a
!    model row need be tested, since all points in i have the same 
!    zenith angle.
!--------------------------------------------------------------------
      skipswrad = .true.
      do j=1,jx        
        if ( Astro%cosz(1,j) > 0.0 ) skipswrad = .false.
        if (Sw_control%do_diurnal) then
          do i = 2,ix         
            if (Astro%cosz(i,j) > 0.0 )  then
              skipswrad = .false.
              exit
            endif
          end do
        endif
      end do

!--------------------------------------------------------------------
!    for aerosol optical depth diagnostics, swresf must be called
!    on all radiation steps.
!--------------------------------------------------------------------
      if (do_cmip_diagnostics)  skipswrad = .false.

!--------------------------------------------------------------------
!    if the sun is shining nowhere in the physics window allocate
!    output fields which will be needed later, set them to a flag
!    value and return.
!--------------------------------------------------------------------
      if (skipswrad)  then
        allocate ( Cldspace_rad%camtswkc(ie-is+1, je-js+1, 1 ))
        allocate ( Cldspace_rad%cirabswkc(ie-is+1, je-js+1, 1 ))
        allocate ( Cldspace_rad%cirrfswkc(ie-is+1, je-js+1, 1 ))
        allocate ( Cldspace_rad%cvisrfswkc(ie-is+1, je-js+1, 1 ))
        allocate ( Cldspace_rad%ktopswkc(ie-is+1, je-js+1,  1 ))
        allocate ( Cldspace_rad%kbtmswkc(ie-is+1, je-js+1,  1 ))
        Cldspace_rad%camtswkc = -99.0
        Cldspace_rad%cirabswkc = -99.0
        Cldspace_rad%cirrfswkc = -99.0
        Cldspace_rad%cvisrfswkc = -99.0
        Cldspace_rad%ktopswkc = -99.0
        Cldspace_rad%kbtmswkc = -99.0

!---------------------------------------------------------------------
!    calculate shortwave radiative forcing and fluxes using the 
!    exponential-sum-fit parameterization.
!---------------------------------------------------------------------
      else if (Sw_control%do_esfsw) then

!---------------------------------------------------------------------
!    if volcanic sw heating calculation desired, set up to call swresf
!    twice.
!---------------------------------------------------------------------
        if (calculate_volcanic_sw_heating ) then  
          if (Rad_control%volcanic_sw_aerosols) then
          else
            call error_mesg ('shortwave_driver_mod', &
             'cannot calculate volcanic sw heating when volcanic sw &
                             &aerosols are not activated', FATAL)
          endif

!----------------------------------------------------------------------
!    call swresf without including volcanic aerosol effects. save the 
!    heating rate as Aerosol_diags%sw_heating_vlcno.
!----------------------------------------------------------------------
          if (Sw_control%do_swaerosol) then
            naerosol_optical = size (Aerosol_props%aerextband,2)
          else
            naerosol_optical = 0  
          endif 
          call swresf (is, ie, js, je, Atmos_input, Surface, Rad_gases,&
                       Aerosol, Aerosol_props, Astro, Cldrad_props,  &
                       Cld_spec, .false., Sw_output_std, Aerosol_diags, r, &
!                      Sw_control%do_swaerosol)
                       Sw_control%do_swaerosol, naerosol_optical)
          Aerosol_diags%sw_heating_vlcno = Sw_output_std%hsw 

!----------------------------------------------------------------------
!    reinitialize the sw outputs for the "real" call.
!----------------------------------------------------------------------
          Sw_output_std%fsw   (:,:,:,:) = 0.0
          Sw_output_std%dfsw  (:,:,:,:) = 0.0
          Sw_output_std%ufsw  (:,:,:,:) = 0.0
          Sw_output_std%hsw   (:,:,:,:) = 0.0
          Sw_output_std%dfsw_dir_sfc = 0.0
          Sw_output_std%ufsw_dir_sfc = 0.0
          Sw_output_std%dfsw_dif_sfc  = 0.0
          Sw_output_std%ufsw_dif_sfc = 0.0
          Sw_output_std%dfsw_vis_sfc = 0.
          Sw_output_std%ufsw_vis_sfc = 0.
          Sw_output_std%dfsw_vis_sfc_dir = 0.
          Sw_output_std%ufsw_vis_sfc_dir = 0.
          Sw_output_std%dfsw_vis_sfc_dif = 0.
          Sw_output_std%ufsw_vis_sfc_dif = 0.
          Sw_output_std%swdn_special  (:,:,:,:) = 0.0
          Sw_output_std%swup_special  (:,:,:,:) = 0.0
          Sw_output_std%bdy_flx(:,:,:,:) = 0.0
      if (Rad_control%do_totcld_forcing) then
          Sw_output_std%fswcf (:,:,:,:) = 0.0
          Sw_output_std%dfswcf(:,:,:,:) = 0.0
          Sw_output_std%ufswcf(:,:,:,:) = 0.0
          Sw_output_std%hswcf (:,:,:,:) = 0.0
          Sw_output_std%dfsw_dir_sfc_clr = 0.             
          Sw_output_std%dfsw_dif_sfc_clr = 0.           
          Sw_output_std%dfsw_vis_sfc_clr = 0.
          Sw_output_std%swdn_special_clr  (:,:,:,:) = 0.0
          Sw_output_std%swup_special_clr  (:,:,:,:) = 0.0
          Sw_output_std%bdy_flx_clr(:,:,:,:) = 0.0
      endif
          if (Sw_control%do_swaerosol) then
            naerosol_optical = size (Aerosol_props%aerextband,2)
          else
            naerosol_optical = 0  
          endif 
          call swresf (is, ie, js, je, Atmos_input, Surface, Rad_gases,&
                       Aerosol, Aerosol_props, Astro, Cldrad_props,  &
                       Cld_spec, Rad_control%volcanic_sw_aerosols, &
                       Sw_output_std, Aerosol_diags, r, &
                       Sw_control%do_swaerosol, naerosol_optical)

!----------------------------------------------------------------------
!    define the difference in heating rates betweenthe case with 
!    volcanic aerosol and the case without. save in 
!    Aerosol_diags%sw_heating_vlcno.
!----------------------------------------------------------------------
          Aerosol_diags%sw_heating_vlcno = Sw_output_std%hsw  -   &
                                         Aerosol_diags%sw_heating_vlcno
          Sw_output(1) = Sw_output_std

!----------------------------------------------------------------------
!    if volcanic heating calculation not desired, simply call swresf.
!----------------------------------------------------------------------
        else
 
          if (Rad_control%do_swaerosol_forcing) then
            if (Sw_control%do_swaerosol) then
              calc_includes_aerosols = .false.
            else
              calc_includes_aerosols = .true.
            endif

!-----------------------------------------------------------------------
!    call swresf with aerosols (if model is being run without) or without
!    aerosols (if model is being run with). save the radiation fluxes 
!    in Sw_output_ad (which does not feed back into the model), but 
!    which may be used to define the aerosol forcing.
!-----------------------------------------------------------------------
          if (calc_includes_aerosols) then
            naerosol_optical = size (Aerosol_props%aerextband,2)
          else
            naerosol_optical = 0  
          endif 
           call swresf (is, ie, js, je, Atmos_input, Surface, Rad_gases,&
                        Aerosol, Aerosol_props, Astro, Cldrad_props,  &
                        Cld_spec, Rad_control%volcanic_sw_aerosols, &
                        Sw_output_ad, Aerosol_diags, r,   &
                        calc_includes_aerosols, naerosol_optical)  
            Sw_output(Rad_control%indx_swaf) = Sw_output_ad
         endif
 
!----------------------------------------------------------------------
!    standard call, where radiation output feeds back into the model.
!----------------------------------------------------------------------
          if (Sw_control%do_swaerosol) then
            naerosol_optical = size (Aerosol_props%aerextband,2)
          else
            naerosol_optical = 0  
          endif 
          call swresf (is, ie, js, je, Atmos_input, Surface, Rad_gases,&
                       Aerosol, Aerosol_props, Astro, Cldrad_props,  &
                       Cld_spec, Rad_control%volcanic_sw_aerosols, &
                       Sw_output_std, Aerosol_diags, r,  &
                       Sw_control%do_swaerosol, naerosol_optical)
            Sw_output(1) = Sw_output_std
        endif

!---------------------------------------------------------------------
!    calculate shortwave radiative forcing and fluxes using the 
!    lacis-hansen parameterization.
!---------------------------------------------------------------------
      else if (Sw_control%do_lhsw) then
        with_clouds = .true.
        call swrad (is, ie, js, je, Astro, with_clouds, Atmos_input, &
                    Surface, Rad_gases, Cldrad_props, Cld_spec,  &
                    Sw_output_std, Cldspace_rad)
        Sw_output(1) = Sw_output_std

!!  FOR NOW, total sw fluxes, which have been determined using the
!!  direct beam albedoes, will be assigned to the _dir arrays, and 
!!  the _dif arrays will remain zero. Likewise, it is assumed that all
!!  of the flux is contained in the nir part of the spectrum, so that
!!  the _vis arrays remain as initialized, at values of 0.0. If a 
!   better asssignment is available and desired, it should be implem-
!!  ented.
!!   I do not know whether direct and diffuse are even definable within 
!!  lhsw, but since this is a dead parameterization, it is unlikely
!   that making the partitioning is worthwhile.

!! NOTE THAT IT IS NOT INTENDED THAT THE LAND MODEL BE RUN WITH LHSW
!! RADIATION, so the only aim here is that the total flux be retrievable
!! within the land model, so that the previous results are obtained,
!! when all 4 albedoes have the same value.


!      Sw_output%ufsw_dir = Sw_output%ufsw
!      Sw_output%dfsw_dir = Sw_output%dfsw

!---------------------------------------------------------------------
!    lacis-hansen requires a second call to produce the cloud-free
!    fluxes.
!---------------------------------------------------------------------
        if (Rad_control%do_totcld_forcing) then
          with_clouds = .false.
          call swrad (is, ie, js, je, Astro, with_clouds, Atmos_input, &
                      Surface, Rad_gases, Cldrad_props, Cld_spec,  &
                      Sw_output_std, Cldspace_rad)  
        endif
        Sw_output(1) = Sw_output_std
      endif  


      call shortwave_driver_dealloc (Sw_output_std)
      if (Rad_control%do_swaerosol_forcing) then
        call shortwave_driver_dealloc (Sw_output_ad)
      endif
!--------------------------------------------------------------------


end subroutine shortwave_driver



!###################################################################
! <SUBROUTINE NAME="shortwave_driver_end">
!  <OVERVIEW>
!   Code that ends shortwave radiation calculation
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine that simply reset shortwave_driver_initialized to false
!  </DESCRIPTION>
!  <TEMPLATE>
!   call shortwave_driver_end
!  </TEMPLATE>
! </SUBROUTINE>
subroutine shortwave_driver_end

!---------------------------------------------------------------------
!    shortwave_driver_end is the destructor for shortwave_driver_mod.
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('shortwave_driver_mod',   &
             'module has not been initialized', FATAL )
      endif

!--------------------------------------------------------------------
!    close out the modules initialized by this module.
!--------------------------------------------------------------------
      if (Sw_control%do_esfsw) then
        call esfsw_driver_end
      endif

!---------------------------------------------------------------------
!    mark the module as uninitialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.

!-------------------------------------------------------------------

end subroutine shortwave_driver_end



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                    PRIVATE SUBROUTINES
!                                
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!###################################################################
! <SUBROUTINE NAME="shortwave_driver_alloc">
!  <OVERVIEW>
!   Code that allocates and initializes shortwave output variables
!  </OVERVIEW>
!  <DESCRIPTION>
!   Shortwave_driver_alloc allocates and initializes the components
!   of the sw_output_type variable Sw_output, which is used to hold
!   output data from shortwave_driver_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call shortwave_driver_alloc (ix, jx, kx, Sw_output)
!  </TEMPLATE>
!  <IN NAME="ix" TYPE="integer">
!   x dimention of the radiation grid where shortwave output is desired
!  </IN>
!  <IN NAME="jx" TYPE="integer">
!   y dimention of the radiation grid where shortwave output is desired
!  </IN>
!  <IN NAME="kx" TYPE="integer">
!   z dimention of the radiation grid where shortwave output is desired
!  </IN>
!  <INOUT NAME="Sw_output" TYPE="sw_output_type">
!   shortwave radiation output variable
!  </INOUT>
! </SUBROUTINE>
!
subroutine shortwave_driver_alloc (ix, jx, kx, Sw_output) 

!--------------------------------------------------------------------
!    shortwave_driver_alloc allocates and initializes the components
!    of the sw_output_type variable Sw_output, which is used to hold
!    output data from shortwave_driver_mod.
!--------------------------------------------------------------------

integer,              intent(in)     ::  ix, jx, kx 
type(sw_output_type), intent(inout)  ::  Sw_output 

!-------------------------------------------------------------------
!  intent(in) variables:
!
!    ix, jx, kx   dimensions of the radiation grid on which output 
!                 will be produced
!
!  intent(inout) variables:
!
!      Sw_output  sw_output_type variable containing shortwave 
!                 radiation output data 
!
!--------------------------------------------------------------------

      integer :: nzens

      nzens = Rad_control%nzens

!--------------------------------------------------------------------
!    allocate and initialize fields to contain net(up-down) sw flux 
!    (fsw), upward sw flux (ufsw), downward sw flux(dfsw) at flux 
!    levels and sw heating in model layers (hsw).
!--------------------------------------------------------------------
      allocate (Sw_output%fsw  (ix, jx, kx+1, nzens) )
      allocate (Sw_output%ufsw (ix, jx, kx+1, nzens) )
      allocate (Sw_output%dfsw (ix, jx, kx+1, nzens) )
      allocate (Sw_output%hsw  (ix, jx, kx  , nzens) )
      allocate (Sw_output%dfsw_dir_sfc (ix, jx, nzens) )
      allocate (Sw_output%ufsw_dir_sfc (ix, jx, nzens) )
      allocate (Sw_output%ufsw_dif_sfc (ix, jx, nzens) )
      allocate (Sw_output%dfsw_dif_sfc (ix, jx, nzens) )
      allocate (Sw_output%dfsw_vis_sfc (ix, jx, nzens  ) )
      allocate (Sw_output%ufsw_vis_sfc (ix, jx, nzens  ) )
      allocate (Sw_output%dfsw_vis_sfc_dir (ix, jx, nzens  ) )
      allocate (Sw_output%ufsw_vis_sfc_dir (ix, jx, nzens  ) )
      allocate (Sw_output%dfsw_vis_sfc_dif (ix, jx, nzens  ) )
      allocate (Sw_output%ufsw_vis_sfc_dif (ix, jx, nzens  ) )
      allocate (Sw_output%swdn_special   &
                            (ix, jx, Rad_control%mx_spec_levs,nzens) )
      allocate (Sw_output%swup_special   &
                            (ix, jx, Rad_control%mx_spec_levs,nzens) )
      allocate (Sw_output%bdy_flx        &
                                 (ix, jx, 4, nzens) )

      Sw_output%fsw   (:,:,:,:) = 0.0
      Sw_output%dfsw  (:,:,:,:) = 0.0
      Sw_output%ufsw  (:,:,:,:) = 0.0
      Sw_output%hsw   (:,:,:,:) = 0.0
      Sw_output%dfsw_dir_sfc = 0.0
      Sw_output%ufsw_dir_sfc = 0.0
      Sw_output%dfsw_dif_sfc  = 0.0
      Sw_output%ufsw_dif_sfc = 0.0
      Sw_output%dfsw_vis_sfc = 0.
      Sw_output%ufsw_vis_sfc = 0.
      Sw_output%dfsw_vis_sfc_dir = 0.
      Sw_output%ufsw_vis_sfc_dir = 0.
      Sw_output%dfsw_vis_sfc_dif = 0.
      Sw_output%ufsw_vis_sfc_dif = 0.
      Sw_output%swdn_special  (:,:,:,:) = 0.0
      Sw_output%swup_special  (:,:,:,:) = 0.0
      Sw_output%bdy_flx(:,:,:,:) = 0.0       

!---------------------------------------------------------------------
!    if the cloud-free values are desired, allocate and initialize 
!    arrays for the fluxes and heating rate in the absence of clouds.
!----------------------------------------------------------------------
      if (Rad_control%do_totcld_forcing) then
        allocate (Sw_output%fswcf  (ix, jx, kx+1,nzens) )
        allocate (Sw_output%dfswcf (ix, jx, kx+1,nzens) )
        allocate (Sw_output%ufswcf (ix, jx, kx+1,nzens) )
        allocate (Sw_output%hswcf  (ix, jx, kx,nzens  ) )
        allocate (Sw_output%dfsw_dir_sfc_clr (ix, jx,nzens) )
        allocate (Sw_output%dfsw_dif_sfc_clr (ix, jx,nzens) )
        allocate (Sw_output%dfsw_vis_sfc_clr (ix, jx,nzens  ) )
        allocate (Sw_output%swdn_special_clr    &
                            (ix, jx, Rad_control%mx_spec_levs,nzens) )
        allocate (Sw_output%swup_special_clr   &
                            (ix, jx, Rad_control%mx_spec_levs,nzens) )
        allocate (Sw_output%bdy_flx_clr        &
                                 (ix, jx, 4,nzens) )

        Sw_output%fswcf (:,:,:,:) = 0.0
        Sw_output%dfswcf(:,:,:,:) = 0.0
        Sw_output%ufswcf(:,:,:,:) = 0.0
        Sw_output%hswcf (:,:,:,:) = 0.0
        Sw_output%dfsw_dir_sfc_clr = 0.0
        Sw_output%dfsw_dif_sfc_clr  = 0.0
        Sw_output%dfsw_vis_sfc_clr = 0.
        Sw_output%swdn_special_clr  (:,:,:,:) = 0.0
        Sw_output%swup_special_clr  (:,:,:,:) = 0.0
        Sw_output%bdy_flx_clr (:,:,:,:) = 0.0
      endif

!--------------------------------------------------------------------

end  subroutine shortwave_driver_alloc


!###################################################################
! <SUBROUTINE NAME="shortwave_driver_alloc">
!  <OVERVIEW>
!   Code that allocates and initializes shortwave output variables
!  </OVERVIEW>
!  <DESCRIPTION>
!   Shortwave_driver_alloc allocates and initializes the components
!   of the sw_output_type variable Sw_output, which is used to hold
!   output data from shortwave_driver_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call shortwave_driver_alloc (ix, jx, kx, Sw_output)
!  </TEMPLATE>
!  <IN NAME="ix" TYPE="integer">
!   x dimention of the radiation grid where shortwave output is desired
!  </IN>
!  <IN NAME="jx" TYPE="integer">
!   y dimention of the radiation grid where shortwave output is desired
!  </IN>
!  <IN NAME="kx" TYPE="integer">
!   z dimention of the radiation grid where shortwave output is desired
!  </IN>
!  <INOUT NAME="Sw_output" TYPE="sw_output_type">
!   shortwave radiation output variable
!  </INOUT>
! </SUBROUTINE>
!
subroutine shortwave_driver_dealloc (Sw_output)

!--------------------------------------------------------------------
!    shortwave_driver_dealloc deallocates the components
!    of the sw_output_type variable Sw_output, which is used to hold
!    output data from shortwave_driver_mod.
!--------------------------------------------------------------------

type(sw_output_type), intent(inout)  ::  Sw_output

!-------------------------------------------------------------------
!  intent(inout) variables:
!
!      Sw_output  sw_output_type variable containing shortwave 
!                 radiation output data 
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!    deallocate fields to contain net(up-down) sw flux 
!    (fsw), upward sw flux (ufsw), downward sw flux(dfsw) at flux 
!    levels and sw heating in model layers (hsw).
!--------------------------------------------------------------------
      deallocate (Sw_output%fsw)
      deallocate (Sw_output%ufsw)
      deallocate (Sw_output%dfsw)
      deallocate (Sw_output%hsw)
      deallocate (Sw_output%dfsw_dir_sfc)
      deallocate (Sw_output%ufsw_dir_sfc)
      deallocate (Sw_output%ufsw_dif_sfc)
      deallocate (Sw_output%dfsw_dif_sfc)
      deallocate (Sw_output%dfsw_vis_sfc)
      deallocate (Sw_output%ufsw_vis_sfc)
      deallocate (Sw_output%dfsw_vis_sfc_dir)
      deallocate (Sw_output%ufsw_vis_sfc_dir)
      deallocate (Sw_output%dfsw_vis_sfc_dif)
      deallocate (Sw_output%ufsw_vis_sfc_dif)
      deallocate (Sw_output%swdn_special)
      deallocate (Sw_output%swup_special)
      deallocate (Sw_output%bdy_flx)
!---------------------------------------------------------------------
!    if the cloud-free values are desired, allocate and initialize 
!    arrays for the fluxes and heating rate in the absence of clouds.
!----------------------------------------------------------------------
      if (Rad_control%do_totcld_forcing) then
        deallocate (Sw_output%fswcf)
        deallocate (Sw_output%dfswcf)
        deallocate (Sw_output%ufswcf)
        deallocate (Sw_output%hswcf)
        deallocate (Sw_output%dfsw_dir_sfc_clr)
        deallocate (Sw_output%dfsw_dif_sfc_clr)
        deallocate (Sw_output%dfsw_vis_sfc_clr)
        deallocate (Sw_output%swdn_special_clr)
        deallocate (Sw_output%swup_special_clr)
        deallocate (Sw_output%bdy_flx_clr)
      endif

!--------------------------------------------------------------------

end  subroutine shortwave_driver_dealloc



!####################################################################


                end module shortwave_driver_mod

                       module ozone_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  ds
! </REVIEWER>
! <OVERVIEW>
!  This code supplies mass mixing ratios of ozone (g/g) to the 
!  sea_esf_rad radiation_package (and the original_fms_rad package).
! </OVERVIEW>
! <DESCRIPTION>
!  This code supplies mass mixing ratios of ozone (g/g) to the 
!  sea_esf_rad radiation_package (and the original_fms_rad package).
!   Recent changes allow provision for predicted ozone to be considered. 
!   This is a field passed in the tracer array, r 
! </DESCRIPTION>
!   shared modules:

use mpp_mod,             only: input_nml_file
use fms_mod,             only: open_namelist_file, file_exist,    &
                               check_nml_error, error_mesg,  &
                               fms_init, stdlog, &
                               write_version_number, FATAL, NOTE, &
                               WARNING, mpp_pe, mpp_root_pe, close_file
use fms_io_mod,          only: read_data
use time_manager_mod,    only: time_type,  &
                               time_manager_init, operator(+), &
                               set_date, operator(-), print_date, &
                               set_time, operator(>), get_date, days_in_month
use diag_manager_mod,    only: diag_manager_init, get_base_time
use time_interp_mod,     only: fraction_of_year, &
                               time_interp_init  
use constants_mod,       only: constants_init, radian
use interpolator_mod,    only: interpolate_type, interpolator_init, &
                               obtain_interpolator_time_slices, &
                               unset_interpolator_time_flag, &
                               interpolator, interpolator_end, &
                               CONSTANT, INTERP_WEIGHTED_P

!-------------------------------

use tracer_manager_mod,  only: get_tracer_index, NO_TRACER
use field_manager_mod,   only: MODEL_ATMOS

!---------------------------------

!   shared radiation package modules:

use rad_utilities_mod,   only:  rad_utilities_init,   &
                                radiative_gases_type,  &
                                atmos_input_type

!---------------------------------------------------------------------

implicit none
private

!-------------------------------------------------------------------
!    ozone_mod supplies mass mixing ratios of ozone [ g/g ] to the 
!    model radiation package.
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module -------------------

character(len=128)  :: version =  '$Id: ozone.F90,v 19.0 2012/01/06 20:21:21 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!---------------------------------------------------------------------
!-------  interfaces --------

public       &
        ozone_init, ozone_time_vary, ozone_driver, ozone_endts, &
        ozone_end
private         &

!   called from ozone_init:
        obtain_input_file_data, &
        obtain_gfdl_zonal_ozone_data, &
        obtain_clim_zonal_ozone_data, &

!   called from ozone_driver:
        gfdl_zonal_ozone, &
        get_clim_ozone

interface gfdl_zonal_ozone
    module procedure geto3_2d, geto3_3d
end interface


!---------------------------------------------------------------------
!-------- namelist  ---------

character(len=24)  ::   basic_ozone_type = 'clim_zonal'     
                      ! label for ozone type, currently unused      
                      ! 'clim_zonal' or 'time_varying' or 'fixed_year'
character(len=32)  :: filename = 'o3.trend.nc'
                      ! name of file which contains the ozone data 
integer, parameter :: MAX_DATA_FIELDS = 1
character(len=32)  :: data_name(MAX_DATA_FIELDS) = 'ozone_1990'
                      ! name of variable in the data file to be used
character(len=24)  ::   ozone_data_source = 'fortuin_kelder' 
                      ! source for the ozone data being used, either 
                      ! 'input', 'gfdl_zonal_ozone', 'calculate_column'
                      ! for the date and location specified,
                      ! or externally-derived datasets:
                      ! 'fortuin_kelder', 'mozart_moztop_fk',
                      ! 'mozart_trop_fk'
character(len=24)  ::   clim_base_year = '1990'
                      ! year with which the ozone data set is assoc-
                      ! iated, used with fortuin_kelder( either '1979',
                      ! '1990' or '1997'), or mozart datasets
                      ! (presently either '1850' or '1860' or '1990')
character(len=24)  ::   trans_data_type = 'linear'
                      ! time interpolation method to be used if trans-
                      ! ient ozone is activated, not yet available
character(len=24)  ::   gfdl_zonal_ozone_type = 'seasonally_varying'
                      ! if gfdl_zonal_ozone is active, the time behavior
                      ! of ozone to use; either 'winter', 'summer', 
                      ! 'spring', 'autumn', annual_mean' or
                      ! 'seasonally_varying'
logical            ::   do_mcm_o3_clim = .false.
                      ! treat ozone as in the manabe climate model ?
integer, dimension(6) ::       &
                        ozone_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
                      ! time in ozone data set corresponding to model
                      ! initial time  (yr, mo, dy, hr, mn, sc)
real,dimension(2)  :: lonb_col = (/-999., -999./)
                      ! longitudes defining the region to use for column
                      ! data calculation
real,dimension(2)  :: latb_col = (/-999., -999./)
                      ! latitudes defining the region to use for column
                      ! data calculation
integer, dimension(6) :: time_col = (/0,0,0,0,0,0/)
                      ! time to use for column calculation
logical      ::  do_coupled_stratozone = .false. ! include the coupled
                                                 ! stratospheric ozone effects?


namelist /ozone_nml/             &
                       basic_ozone_type, &
                       ozone_data_source, &
                       lonb_col, latb_col, time_col, &
                       clim_base_year, &
                       trans_data_type, &
                       data_name, &
                       filename, &
                       gfdl_zonal_ozone_type, &
                       ozone_dataset_entry, &
                       do_mcm_o3_clim, &
                       do_coupled_stratozone

!---------------------------------------------------------------------
!------- public data ------


!---------------------------------------------------------------------
!------- private data ------


!-------------------------------------------------------------------
!    qqo3 contains the column input ozone mass mixing ratio (g/g).
!    used when ozone_data_source = 'input'.
!-------------------------------------------------------------------
real, dimension (:), allocatable     ::  qqo3

!-------------------------------------------------------------------
!    o3data contains the zonal ozone mass mixing ratio (10**6 g/g)
!    at 19 specified latitudes, 81 specified pressures and up to 4
!    specified times. rstd contains the zonal ozone mass mixing ratio 
!    (10**6 g/g) at 19 specified latitudes, 81 specified pressures and 
!    at the currently specified time. ph is the array defining the 
!    interface levels in the zonal ozone data set. used when
!    ozone_data_source = 'gfdl_zonal_ozone'.
!-------------------------------------------------------------------
real, dimension (82)        ::    ph
real, dimension (19,81,4)   ::    o3data
real, dimension (19,81)     ::    rstd

!----------------------------------------------------------------------
!    O3 is an interpolate_type variable containing the relevant 
!    information about the ozone data set. used when
!    ozone_data_source = 'fortuin_kelder', 'mozart_moztop_fk',
!    'mozart_trop_fk', and others in the future.
!---------------------------------------------------------------------- 
type(interpolate_type),save         ::  O3_interp 

!---------------------------------------------------------------------
!    miscellaneous variables:

integer     ::  iseason=-1 ! flag indicating type of gfdl_zonal_ozone 
                           ! time variation to use
real        ::  current_fyear=-1.0  
                           ! flag to force interpolation on initial call
                           ! (used with gfdl_zonal_ozone)
logical     ::  do_gfdl_zonal_ozone=.false.
                           ! using gfdl zonal ozone data set ?
logical     ::  do_clim_zonal_ozone=.false.
                           ! using clim zonal ozone data set ?
logical     ::  do_column_input_ozone=.false.
                           ! using ozone column input data set ?
logical     ::  do_predicted_ozone=.false.
                           ! using predicted ozone ?
logical     ::  module_is_initialized=.false.  ! module initialized ?

type(time_type) :: Model_init_time  ! initial calendar time for model  
                                    ! [ time_type ]
type(time_type) :: Ozone_offset     ! difference between model initial
                                    ! time and ozone timeseries app-
                                    ! lied at model initial time
                                    ! [ time_type ]
type(time_type) :: Ozone_entry      ! time in ozone timeseries which
                                    ! is mapped to model initial time
                                    ! [ time_type ]
type(time_type) :: Ozone_time       ! time for which ozone profile is 
                                    ! valid
type(time_type) :: Ozone_column_time
                                    ! time for which ozone data is extr
                                    ! acted from the ozone timeseries
                                    ! in the 'calculate_columns' case
                                    ! [ time_type ]
logical    :: negative_offset = .false.
                            !  the model initial time is later than
                            !  the ozone_dataset_entry time  ?


include 'netcdf.inc'


!-------------------------------------------------------------------
!-------------------------------------------------------------------



                          contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!                                
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! <SUBROUTINE NAME="ozone_init">
!  <OVERVIEW>
!   ozone_init is the constructor for ozone_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!   ozone_init is the constructor for ozone_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call ozone_init (latb, lonb)
!  </TEMPLATE>
!  <IN NAME="latb" TYPE="real">
!   2d array of model latitudes at cell corners [radians]
!  </IN>
!  <IN NAME="lonb" TYPE="real">
!   2d array of model longitudes at cell corners [radians]
!  </IN>
! </SUBROUTINE>
!
subroutine ozone_init (latb, lonb)

!---------------------------------------------------------------------
!    ozone_init is the constructor for ozone_mod.
!---------------------------------------------------------------------

!---------------------------------------------------------------------
real, dimension(:,:),   intent(in) :: latb, lonb
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  intent(in) variables:
!
!       latb      2d array of model latitudes at cell corners 
!                 [ radians ]
!       lonb      2d array of model longitudes at cell corners 
!                 [ radians ]
!
!-----------------------------------------------------------------

!-----------------------------------------------------------------
!  local variables:

       integer           ::  unit, ierr, io, logunit
       integer           ::  n, no3

!---------------------------------------------------------------------
!  local variables:
!
!         unit       io unit number 
!         ierr       error code
!         io         error status returned from io operation
!
!---------------------------------------------------------------------
 

!-------------------------------------------------------------------
!    if routine has already been executed, exit.
!-------------------------------------------------------------------
      if (module_is_initialized) return

!-------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!-------------------------------------------------------------------
      call fms_init
      call rad_utilities_init
      call time_manager_init   
      call diag_manager_init   
      call time_interp_init   
      call constants_init
 
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=ozone_nml, iostat=io)
      ierr = check_nml_error(io,"ozone_nml")
#else
!-----------------------------------------------------------------------
!    read namelist.
!-----------------------------------------------------------------------
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=ozone_nml, iostat=io, end=10)
        ierr = check_nml_error(io, 'ozone_nml')
        end do
10      call close_file (unit)
      endif
#endif
 
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                        write (logunit, nml=ozone_nml)

!---------------------------------------------------------------------
!    check for a valid value of clim_base_year.
!---------------------------------------------------------------------
      if (trim(basic_ozone_type) == 'clim_zonal' ) then 
        if (trim(clim_base_year)  == '1990' .or.        &
            trim(clim_base_year)  == '1979' .or.        &
            trim(clim_base_year)  == '1850' .or.        &
            trim(clim_base_year)  == '1860' .or.        &
            trim(clim_base_year)  == '1997')            then
        else
          call error_mesg ('ozone_mod', &
              ' clim_base_year must be 1990, 1979, 1850, 1860 &
                                        &or 1997 at present', FATAL)
        endif
        Ozone_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *,   &
           'Ozone data is obtained from a clim_zonal ozone file &
             &for year ', trim(clim_base_year)
        endif

!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the ozone timeseries 
!    files are to be used.                                
!---------------------------------------------------------------------
      else if (trim(basic_ozone_type) == 'time_varying') then
        Model_init_time = get_base_time()
 
!---------------------------------------------------------------------
!    if a dataset entry point is not supplied, use the model base time 
!    as the entry point.
!---------------------------------------------------------------------
        if (ozone_dataset_entry(1) == 1 .and. &
            ozone_dataset_entry(2) == 1 .and. &
            ozone_dataset_entry(3) == 1 .and. &
            ozone_dataset_entry(4) == 0 .and. &
            ozone_dataset_entry(5) == 0 .and. &
            ozone_dataset_entry(6) == 0 ) then
          Ozone_entry = Model_init_time
 
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to ozone_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        else
          Ozone_entry  = set_date (ozone_dataset_entry(1), &
                                   ozone_dataset_entry(2), &
                                   ozone_dataset_entry(3), &
                                   ozone_dataset_entry(4), &
                                   ozone_dataset_entry(5), &
                                   ozone_dataset_entry(6))
        endif
        call print_date (Ozone_entry , str='Data from ozone timeseries &
                                           &at time:')
        call print_date (Model_init_time , str='This data is mapped to &
                                                &model time:')
        Ozone_offset = Ozone_entry - Model_init_time
 
        if (Model_init_time > Ozone_entry) then
          negative_offset = .true.
        else
          negative_offset = .false.
        endif
      else if (trim(basic_ozone_type) == 'fixed_year') then
        if (ozone_dataset_entry(1) == 1 .and. &
            ozone_dataset_entry(2) == 1 .and. &
            ozone_dataset_entry(3) == 1 .and. &
            ozone_dataset_entry(4) == 0 .and. &
            ozone_dataset_entry(5) == 0 .and. &
            ozone_dataset_entry(6) == 0 ) then
           call error_mesg ('ozone_mod', &
            'must set ozone_dataset_entry when using  &
                                  &fixed_year ozone', FATAL)
        endif

!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to ozone_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        Ozone_entry  = set_date (ozone_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('ozone_mod', &
           'Ozone data is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'Ozone data obtained from ozone timeseries &
                    &for year:', ozone_dataset_entry(1)
        endif

!------------------------------------------------------------------
!    use predicted ozone
!-----------------------------------------------------------------
      else if (trim(basic_ozone_type) == 'predicted_ozone' ) then
        do_predicted_ozone = .true.
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'Using predicted ozone '
        endif
        no3= get_tracer_index(MODEL_ATMOS,'O3')
        if (no3 == NO_TRACER) &
          call error_mesg ('ozone_mod', &
            'Using predicted ozone but O3 tracer not present in field_table', FATAL)

      else
        call error_mesg ('ozone_mod', &
          'invalid specification of basic_ozone_type', FATAL)
      endif

!------------------------------------------------------------------
!    obtain the desired ozone data set based on the value of namelist
!    variable 'ozone_data_source'. set a logical flag to true to 
!    indicate the desired ozone data source. 
!-----------------------------------------------------------------
      if (trim(ozone_data_source) == 'input' ) then
        do_column_input_ozone = .true.
        call obtain_input_file_data 

      else if (trim(ozone_data_source) == 'gfdl_zonal_ozone' ) then
        do_gfdl_zonal_ozone = .true.
        if (trim(gfdl_zonal_ozone_type)      == 'winter' ) then
          iseason = 1   
        else if (trim(gfdl_zonal_ozone_type) == 'spring' ) then
          iseason = 2   
        else if (trim(gfdl_zonal_ozone_type) == 'summer' ) then
          iseason = 3   
        else if (trim(gfdl_zonal_ozone_type) == 'autumn' ) then
          iseason = 4   
        else if (trim(gfdl_zonal_ozone_type) == 'annual_mean' ) then
          iseason = 0   
        else if (trim(gfdl_zonal_ozone_type) ==    &
                                            'seasonally_varying' ) then
          iseason = 5   
        else
          call error_mesg ( 'ozone_mod', &
                    'improper specification of nml variable  '//&
                                     'gfdl_zonal_ozone_type', FATAL)
        endif
        call obtain_gfdl_zonal_ozone_data (iseason)

      else if (trim(ozone_data_source) == 'fortuin_kelder' ) then
        do_clim_zonal_ozone = .true.
        call obtain_clim_zonal_ozone_data (lonb, latb)

      else if (trim(ozone_data_source) == 'mozart_moztop_fk' ) then
        do_clim_zonal_ozone = .true.
        call obtain_clim_zonal_ozone_data (lonb, latb)

      else if (trim(ozone_data_source) == 'mozart_trop_fk' ) then
        do_clim_zonal_ozone = .true.
        call obtain_clim_zonal_ozone_data (lonb, latb)

      else if (trim(ozone_data_source) == 'calculate_column' ) then
        do_clim_zonal_ozone = .true.
        do n=1,2
          if (lonb_col(n) < 0. .or. lonb_col(n) > 360.) then
            call error_mesg ('ozone_mod', &
                   ' invalid value for lonb_col', FATAL)
          endif
          if (latb_col(n) < -90. .or. latb_col(n) > 90.) then
            call error_mesg ('ozone_mod', &
                ' invalid value for latb_col', FATAL)
          endif
        end do
        if (time_col(1) == 0) then
          call error_mesg ('ozone_mod', &
                'invalid time specified for time_col', FATAL)
        endif
        call interpolator_init (O3_interp, filename,  &
                                spread(lonb_col/RADIAN,2,2),  &
                                spread(latb_col/RADIAN,1,2),&
                                data_out_of_bounds=  (/CONSTANT/), &
                                data_names = data_name, &
                                vert_interp=(/INTERP_WEIGHTED_P/) )
        Ozone_column_time = set_date (time_col(1), time_col(2), &
                                      time_col(3), time_col(4), &
                                      time_col(5), time_col(6))
        call print_date (Ozone_column_time,   &
            str= ' Ozone data used is from ozone timeseries at time: ')
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'Ozone data is averaged over latitudes',  &
                  latb_col(1), ' to', latb_col(2), ' and longitudes',&
                  lonb_col(1), ' to', lonb_col(2)
        endif

      else if (trim(basic_ozone_type) == 'predicted_ozone' ) then
        call error_mesg ('ozone_mod', &
          'Using predicted ozone: no input data set is necessary ', NOTE)

      else
        call error_mesg ( 'ozone_mod',    &
               ' ozone_data_source is not an acceptable value.', FATAL)
      endif

!---------------------------------------------------------------------
!    mark the module as initialized.
!---------------------------------------------------------------------
      module_is_initialized = .true.
    


end subroutine ozone_init


!#################################################################### 
 
subroutine ozone_time_vary (model_time)
 
!----------------------------------------------------------------------
!     subroutine ozone_time_vary calculates time-dependent, 
!     space-independent variables needed by this module.
!---------------------------------------------------------------------

type(time_type),    intent(in)   :: model_time
 
!----------------------------------------------------------------------
!
!   local variables
 
      integer         :: yr, mo, dy, hr, mn, sc, dum
      integer         :: dayspmn, mo_yr

      if (do_clim_zonal_ozone) then


       if(trim(basic_ozone_type) == 'time_varying') then
!--------------------------------------------------------------------
!    define the time in the ozone data set from which data is to be 
!    taken. if ozone is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
       if (negative_offset) then
         Ozone_time = model_time - Ozone_offset
       else
         Ozone_time = model_time + Ozone_offset
       endif
     else if(trim(basic_ozone_type) == 'fixed_year') then
       call get_date (Ozone_entry, yr, dum,dum,dum,dum,dum)
       call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
       if (mo ==2 .and. dy == 29) then
         dayspmn = days_in_month(Ozone_entry)
         if (dayspmn /= 29) then
           Ozone_time = set_date (yr, mo, dy-1, hr, mn, sc)
         else
           Ozone_time = set_date (yr, mo, dy, hr, mn, sc)
         endif
       else
         Ozone_time = set_date (yr, mo, dy, hr, mn, sc)
       endif
     else if(trim(basic_ozone_type) == 'clim_zonal') then
       Ozone_time = model_time
    endif

!--------------------------------------------------------------------
!    if 'calculate_column' is being used, obtain the ozone values for
!    each column, one at a time, using the pressure profile for that
!    column. this allows each column to see the same ozone fields,
!    but distributed appropriately for its pressure structure.
!--------------------------------------------------------------------
   if (trim(ozone_data_source) == 'calculate_column') then
     call obtain_interpolator_time_slices (O3_interp, Ozone_column_time)
   else
     call obtain_interpolator_time_slices (O3_interp, Ozone_time)
   endif

!----------------------------------------------------------------------

     endif
 
end subroutine ozone_time_vary



!######################################################################

subroutine ozone_endts


     call unset_interpolator_time_flag (O3_interp)


end subroutine ozone_endts




!######################################################################
! <SUBROUTINE NAME="ozone_driver">
!  <OVERVIEW>
!    ozone_driver obtains the current ozone distributions and returns 
!   them in Rad_gases%qo3.
!  </OVERVIEW>
!  <DESCRIPTION>
!   ozone_driver obtains the current ozone distributions and returns 
!   them in Rad_gases%qo3.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call ozone_driver (is, ie, js, je, lat, Rad_time, Atmos_input, &
!                      Rad_gases )
!  </TEMPLATE>
!  <IN NAME="is,ie,js,je" TYPE="integer">
!   starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="lat" TYPE="real">
!   latitude of model points  [ radians ]
!  </IN>
!  <IN NAME="Rad_time" TYPE="time_type">
!   time at which the climatologically-determined,
!                   time-varying ozone field should apply
!  </IN>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
!   atmos_input_type variable containing the atmospheric
!   input fields needed by the radiation package
!  </IN> 
!  <INOUT NAME="Rad_gases" TYPE="radiative_gases_type">
!   radiative_gases_type variable which will return
!                   the ozone mass mixing ratio (g/g) to the calling
!                   routine
!  </INOUT>
! </SUBROUTINE>
!

subroutine ozone_driver (is, ie, js, je, lat, Rad_time, Atmos_input, &
                         r, Rad_gases )
 
!--------------------------------------------------------------------
!   ozone_driver obtains the current ozone distributions and returns 
!   them in Rad_gases%qo3.
!--------------------------------------------------------------------

integer,                    intent(in)    :: is, ie, js, je
real, dimension(:,:),       intent(in)    :: lat
type(time_type),            intent(in)    :: Rad_time
type(atmos_input_type),     intent(in)    :: Atmos_input
real, dimension(:,:,:,:),   intent(in)    :: r
type(radiative_gases_type), intent(inout) :: Rad_gases

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      lat          latitude of model points  [ radians ]
!      Rad_time     time at which the climatologically-determined,
!                   time-varying ozone field should apply
!                   [ time_type (days, seconds) ] 
!      Atmos_input  atmos_input_type variable containing the atmospheric
!                   input fields needed by the radiation package
!
!   intent(out) variables:
!
!      Rad_gases    radiative_gases_type variable which will return
!                   the ozone mass mixing ratio [ g/g ] to the calling
!                   routine
!
!-----------------------------------------------------------------

!-----------------------------------------------------------------
!  local variables:
!
!      phaf         pressure at model interface levels, normalized
!                   by the mean sea level pressure (101325 N/m**2).
!                   if mcm ozone scheme is used, this variable is
!                   defined differently. [ Pa ]
!      kmax         number of model layers
!      k            do-loop index
!
!---------------------------------------------------------------------
      real, dimension (size(Atmos_input%press,1), &
                       size(Atmos_input%press,2), &
                       size(Atmos_input%press,3))    :: phaf

      integer   ::   kmax
      integer   ::   k, j, i   !  do-loop indices
      integer   ::   noy

!--------------------------------------------------------------------
      if ( .not. module_is_initialized)    & 
        call error_mesg ('ozone_mod',  &         
           'module has not been initialized', FATAL)

!---------------------------------------------------------------------
!    define the number of model layers.
!---------------------------------------------------------------------
      kmax = size (Rad_gases%qo3,3) 

!-----------------------------------------------------------------------
!    if column input ozone is being used, be certain the input column
!    has the same number of levels as the model grid. broadcast the
!    column data over the entire horizontal domain.
!-----------------------------------------------------------------------
      if (do_column_input_ozone) then 
        if (size(qqo3(:)) /= kmax) then
           call error_mesg ('ozone_mod', &
             'size of ozone profile in input file does not match '//&
                                              'model grid.', FATAL)
         endif
         do k=1,kmax
           Rad_gases%qo3(:,:,k) = qqo3(k)
         end do
!---------------------------------------------------------------------
!    if a specified ozone column is not being used, define the 
!    normalized pressure to be used to assign the ozone values. this
!    formulation varies between mcm and the fms models.
!---------------------------------------------------------------------
      else 
        do k=1,kmax+1
          if (do_mcm_o3_clim) then
            phaf(:,:,k) = 100000.*Atmos_input%phalf(:,:,k)/  &
                          Atmos_input%phalf(:,:,kmax+1)
          else
            phaf(:,:,k) = (Atmos_input%pflux(:,:,k))
!           phaf(:,:,k) = (Atmos_input%pflux(:,:,k))*101325./   &
!                         (Atmos_input%pflux(:,:,kmax +1))
          endif
        end do

!---------------------------------------------------------------------
!    if gfdl_zonal_ozone has been activated, call gfdl_zonal_ozone
!    to obtain the values of ozone at model grid points at the desired
!    time Rad_time.
!---------------------------------------------------------------------
        if (do_gfdl_zonal_ozone) then
          call gfdl_zonal_ozone (Rad_time, lat, phaf, Rad_gases%qo3)

!---------------------------------------------------------------------
!    if clim_zonal_ozone has been activated, call clim_zonal_ozone
!    to obtain the values of ozone at model grid points at the desired
!    time Rad_time.
!---------------------------------------------------------------------
        else if (do_clim_zonal_ozone) then
          call get_clim_ozone (is, js, Rad_time, phaf, Rad_gases%qo3)



!---------------------------------------------------------------------
!    if do_predicted_ozone has been activated, set ozone to the appropriate
!    prognostic tracer field;  here defined by tracer name 'O3'
!---------------------------------------------------------------------
        else if ( do_predicted_ozone ) then 

          noy= get_tracer_index(MODEL_ATMOS,'O3')

          do k= 1,kmax
            do j= 1,je-js+1    
              do i= 1,ie-is+1    
!                Rad_gases%qo3(i,j,k) =  r(i,j,k,noy) * 48./29.0 
                 Rad_gases%qo3(i,j,k) =  MAX(r(i,j,k,noy),1.e-20) * 48./29.
             end do
            end do
          end do

        endif
      endif

!--------------------------------------------------------------------




end subroutine ozone_driver



!#####################################################################
! <SUBROUTINE NAME="ozone_end">
!  <OVERVIEW>
!   ozone_end is the destructor for ozone_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!   ozone_end is the destructor for ozone_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call ozone_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine ozone_end

!---------------------------------------------------------------------
!    ozone_end is the destructor for ozone_mod.
!---------------------------------------------------------------------
     
!---------------------------------------------------------------------
!    deallocate any module variables that have been allocated.
!---------------------------------------------------------------------
      if (do_column_input_ozone) then
        deallocate (qqo3)
      endif

!---------------------------------------------------------------------
!    call interpolator_end to close out the O3_interp interpolate_type
!    variable.
!---------------------------------------------------------------------
      if (do_clim_zonal_ozone) then
        call interpolator_end (O3_interp)
      endif

!---------------------------------------------------------------------
!    mark the module as uninitialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.



end subroutine ozone_end




!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PRIVATE SUBROUTINES
!                                
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



!######################################################################
! <SUBROUTINE NAME="obtain_input_file_data">
!  <OVERVIEW>
!   obtain_input_file_data reads an input file containing a single
!    column ozone profile. 
!  </OVERVIEW>
!  <DESCRIPTION>
!   obtain_input_file_data reads an input file containing a single
!    column ozone profile. 
!  </DESCRIPTION>
!  <TEMPLATE>
!   call  obtain_input_file_data
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine obtain_input_file_data 

!---------------------------------------------------------------------
!    obtain_input_file_data reads an input file containing a single
!    column ozone profile.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

      integer   :: iounit    ! unit to read file on
      integer   :: kmax_file ! number of levels of data in file
      integer   :: k         ! do-loop index
      character(len=31), dimension(200) :: dimnam
      integer(kind=4), dimension(200) :: dimsiz
      integer(kind=4)                 :: ncid, rcode, nvars, ndims, &
                                         ngatts, recdim
      integer    :: i, j
      integer, PARAMETER :: MAXDIMS = 10
      integer(kind=4), dimension(MAXDIMS) :: start, count, vdims
      integer(kind=4)                     :: ivarid, ntp, nvdim, nvs, &
                                             ndsize
      character(len=31) ::  dummy


!-------------------------------------------------------------------
!    determine if a netcdf input data file exists. if so, read the
!    number of data records in the file.
!---------------------------------------------------------------------
      if (file_exist ( 'INPUT/id1o3.nc') ) then
        ncid = ncopn ('INPUT/id1o3.nc', 0, rcode)
        call ncinq (ncid, ndims, nvars, ngatts, recdim, rcode)
        do i=1,ndims
          call ncdinq (ncid, i, dimnam(i), dimsiz(i), rcode)
          if (dimnam(i) == 'lev') then
            kmax_file = dimsiz(i)
          endif
        end do

!-------------------------------------------------------------------
!    allocate space for the input data. read the data set. close the
!    file upon completion.
!---------------------------------------------------------------------
        allocate (qqo3(kmax_file) )
        ivarid = ncvid(ncid, 'ozone', rcode)
        call ncvinq (ncid, ivarid, dummy, ntp, nvdim, vdims, nvs, rcode)
        do j=1,nvdim
          call ncdinq (ncid, vdims(j), dummy, ndsize, rcode)
          start(j) = 1
          count(j) = ndsize
        end do
        call ncvgt (ncid, ivarid, start, count, qqo3, rcode)
        call ncclos (ncid, rcode)

!-------------------------------------------------------------------
!    determine if the input data input file exists in ascii format.
!    if so, read the number of data records in the file.
!---------------------------------------------------------------------
      else if (file_exist ( 'INPUT/id1o3') ) then
        iounit = open_namelist_file ('INPUT/id1o3')
        read (iounit,FMT = '(i4)') kmax_file

!-------------------------------------------------------------------
!    allocate space for the input data. read the data set. close the 
!    file upon completion.
!---------------------------------------------------------------------
         allocate (qqo3(kmax_file) )
         read (iounit,FMT = '(5e18.10)') (qqo3(k),k=1,kmax_file)
         call close_file (iounit)

!---------------------------------------------------------------------
!    if file is not present, write an error message.
!---------------------------------------------------------------------
       else
         call error_mesg ( 'ozone_mod', &
              'desired ozone input file is not present',FATAL)
       endif

!----------------------------------------------------------------------


end subroutine obtain_input_file_data 




!######################################################################
! <SUBROUTINE NAME="obtain_gfdl_zonal_ozone_data">
!  <OVERVIEW>
!   obtain_gfdl_zonal_ozone_data generates data at the appropriate time
!    from the basic fms_zonal_ozone input data set, allowing the use of
!    annual mean, fixed seasonal, or seasonally-varying ozone distrib-
!    utions.
!  </OVERVIEW>
!  <DESCRIPTION>
!   obtain_gfdl_zonal_ozone_data generates data at the appropriate time
!    from the basic fms_zonal_ozone input data set, allowing the use of
!    annual mean, fixed seasonal, or seasonally-varying ozone distrib-
!    utions.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call  obtain_gfdl_zonal_ozone_data (season)
!  </TEMPLATE>
!  <IN NAME="season" TYPE="integer">
!   scalar integer between 0-5, where 1-4 uses fixed
!                      data (1=winter, 2=spring, etc.), season=0 is 
!                      annual mean ozone, and season=5 is seasonally
!                      varying ozone
!  </IN> 
! </SUBROUTINE>
!
subroutine obtain_gfdl_zonal_ozone_data (season)

!---------------------------------------------------------------------
!    obtain_gfdl_zonal_ozone_data retrieves ozone data as requested
!    from the gfdl_zonal_ozone input data set. data corresponding to
!    annual mean, fixed seasonal, or seasonally-varying ozone distrib-
!    utions may be obtained.
!---------------------------------------------------------------------

integer, intent(in) :: season

!--------------------------------------------------------------------
!  intent(in) variables:
!
!      season          scalar integer between 0-5, where 1-4 uses fixed
!                      data (1=winter, 2=spring, etc.), season=0 is 
!                      annual mean ozone, and season=5 is seasonally
!                      varying ozone
!
!---------------------------------------------------------------------

!-----------------------------------------------------------------------
!  local variables:

      real, dimension (10,41)             ::  ro31, ro32
      real, dimension (19,41)             ::  duo3n
      real, dimension (19,81,4)           ::  data4
      real, dimension (82)                ::  ph3
      real, dimension (10,25)             ::  o3hi
      real, dimension (10,16)             :: o3lo1, o3lo2, o3lo3, o3lo4

      real                      ::  pref = 101325. 
      character(len=48)         ::  err_string 
      integer                   ::  iounit   
      integer                   ::  j, k, kk, n  

!-----------------------------------------------------------------------
!  local variables:
! 
!     ro31, ro32       ozone values for the proper time, at 41 standard
!                      levels and 10 standard latitudes (index 1 = 
!                      equator, index 10= pole, 10 deg resolution)
!     duo3n            array of ozone at proper time, at 41 standard 
!                      levels, over 19 global latitudes (10 deg 
!                      resolution), index 1 = north pole, index 10=
!                      equator, index 19 = south pole)
!     data4            array of ozone at proper time, at 81 levels, over
!                      19 global latitudes (10 deg resolution). if 
!                      seasonally-varying ozone is desired, there are
!                      4 such arrays, to which harmonic interpolation
!                      will be applied.
!     ph3              sigma levels at which zonal ozone data set data
!                      exists
!     o3hi             array containing ozone data at 25 high layers in
!                      which mixing ratios are invariant with season
!     o3lo1            array containing ozone data at 16 lower layers
!                      valid for nh spring, latitudinal indices from
!                      equator to pole
!     o3lo2            array containing ozone data at 16 lower layers
!                      valid for nh fall, latitudinal indices from
!                      equator to pole
!     o3lo3            array containing ozone data at 16 lower layers
!                      valid for nh winter, latitudinal indices from
!                      equator to pole
!     o3lo4            array containing ozone data at 16 lower layers
!                      valid for nh summer, latitudinal indices from
!                      equator to pole
!     pref             assumed surface pressure value used to convert 
!                      ph3 from sigma to pressure
!     err_string       part of error message if generated
!     iounit           unit number used to read input data file
!     j,k,kk,n         do-loop indices
!     
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure that the input argument is valid.
!---------------------------------------------------------------------
      if (season < 0 .or. season > 5) then
        write (err_string,9001) season
 9001   format ('invalid value of season=',i10)
        call error_mesg ('ozone_mod', err_string, FATAL)
      endif

!---------------------------------------------------------------------
!    save input argument as a module variable.
!---------------------------------------------------------------------
      iseason = season

!---------------------------------------------------------------------
!    determine if the zonal ozone input data file exists. if so, 
!    open the file and read the data set.  close the file upon 
!    completion. if it is not present, write an error message.
!---------------------------------------------------------------------
      if (file_exist ( 'INPUT/zonal_ozone_data.nc')) then
        if(mpp_pe() == mpp_root_pe()) &
             call error_mesg('ozone_mod','Reading netCDF input data: zonal_ozone_data.nc',NOTE)
        call read_data('INPUT/zonal_ozone_data.nc', 'ph3', ph3, no_domain=.true.)
        call read_data('INPUT/zonal_ozone_data.nc', 'o3hi', o3hi, no_domain=.true.)
        call read_data('INPUT/zonal_ozone_data.nc', 'o3lo1', o3lo1, no_domain=.true.)
        call read_data('INPUT/zonal_ozone_data.nc', 'o3lo2', o3lo2, no_domain=.true.)
        call read_data('INPUT/zonal_ozone_data.nc', 'o3lo3', o3lo3, no_domain=.true.)
        call read_data('INPUT/zonal_ozone_data.nc', 'o3lo4', o3lo4, no_domain=.true.)
      else if (file_exist ( 'INPUT/zonal_ozone_data') ) then
        call error_mesg('ozone_mod','Reading native input data zonal_ozone_data no longer supported',FATAL)
      else
        call error_mesg ( 'ozone_mod', &
                'zonal_ozone_data data file is not present',FATAL)
      endif

!---------------------------------------------------------------------
!    define standard pressure interfaces (ph).
!---------------------------------------------------------------------
      ph(:) = ph3(:)*pref

!-----------------------------------------------------------------------
!    define the seasonally-invariant elements of arrays ro31, ro32 from
!    the values in o3hi.
!---------------------------------------------------------------------
      do k=1,25
         ro31(:,k) = o3hi(:,k)
         ro32(:,k) = o3hi(:,k)
      end do

!---------------------------------------------------------------------
!    define the ozone values at the lower levels to be seasonally
!    varying. northern hemisphere seasons are used to define the
!    indices, with n = 1 being winter, going to n = 4 being fall.
!--------------------------------------------------------------------
      do n=1,4

!---------------------------------------------------------------------
!    for nh spring or fall, obtain the o3lo1 and o3lo2 data (ro31 and 
!    ro32). 
!----------------------------------------------------------------------
        if (n == 2 .or. n == 4) then
          do k=26,41
            ro31(:,k) = o3lo1(:,k-25)
            ro32(:,k) = o3lo2(:,k-25)
          end do
        endif

!---------------------------------------------------------------------
!    for nh winter or summer, obtain the o3lo3 and o3lo4 data (ro31 and
!    ro32). 
!----------------------------------------------------------------------
        if (n == 1 .or. n == 3) then
          do k=26,41
            ro31(:,k) = o3lo3(:,k-25)
            ro32(:,k) = o3lo4(:,k-25)
          end do
        endif

!---------------------------------------------------------------------
!    define ozone values for both hemispheres -- indices 1->9 = nh,
!    index 10 = equator, indices 11-19 = sh. for nh spring (n=2)
!    and nh winter (n=1), nh values are contained in ro31, in
!    reverse latitudinal order. sh values are contained in ro32, going
!    from equator to south pole.
!----------------------------------------------------------------------
        if (n == 2 .or. n == 1) then
          do k=1,41
            do j=1,10
              duo3n(j  ,k) = ro31(11-j,k)
              duo3n(j+9,k) = ro32(j   ,k)
            end do
            duo3n(10 ,k) = 0.50*(ro31(1,k) + ro32(1,k))
          end do

!---------------------------------------------------------------------
!    for nh summer (n=3) and nh fall (n=4), nh values are 
!    contained in ro32, in reverse latitudinal order. sh values are 
!    contained in ro31, going from equator to south pole.
!---------------------------------------------------------------------
        else if(n == 4 .or. n == 3) then
          do k=1,41
            do j=1,10
              duo3n(j  ,k) = ro32(11-j,k)
              duo3n(j+9,k) = ro31(j   ,k)
            end do
            duo3n(10 ,k) = 0.50*(ro31(1,k) + ro32(1,k))
          end do
        endif

!-----------------------------------------------------------------------
!    vertical interp between original data using bessels half-point 
!    interpolation formula.
!-----------------------------------------------------------------------
        do kk=4,78,2
          k = kk/2
          o3data(:,kk,n) = 0.50*(duo3n(:,k) + duo3n(:,k+1)) -  &
                           (duo3n(:,k+2) - duo3n(:,k+1) -   &
                            duo3n(:,k) + duo3n(:,k-1))/16.
        end do
        o3data(:, 2,n) = 0.50*(duo3n(:,2) + duo3n(:,1))
        o3data(:,80,n) = 0.50*(duo3n(:,41) + duo3n(:,40))

!---------------------------------------------------------------------
!    put intermediate (unchanged) data into new array.                
!---------------------------------------------------------------------
        do kk=1,81,2
          k = (kk + 1)/2
          o3data(:,kk,n) = duo3n(:,k)
        end do
      end do  ! n loop

!-----------------------------------------------------------------------
!    prepare seasonal interpolation.
!-----------------------------------------------------------------------
      if (iseason == 5) then
        data4(:,:,1) = 0.25*(o3data(:,:,1) + o3data(:,:,2)  &
                           + o3data(:,:,3) + o3data(:,:,4))
        data4(:,:,2) = 0.50*(o3data(:,:,2) - o3data(:,:,4))
        data4(:,:,3) = 0.50*(o3data(:,:,1) - o3data(:,:,3))
        data4(:,:,4) = 0.25*(o3data(:,:,1) - o3data(:,:,2)  &
                           + o3data(:,:,3) - o3data(:,:,4))
        o3data(:,:,1) = data4(:,:,1)
        o3data(:,:,2) = data4(:,:,2)
        o3data(:,:,3) = data4(:,:,3)
        o3data(:,:,4) = data4(:,:,4)
      endif

!-----------------------------------------------------------------------
!    prepare annual mean data. store it into o3data with index 1. reset
!    the o3data index to be 1 so that this overwritten field will be
!    retrieved.
!-----------------------------------------------------------------------
      if (iseason == 0) then
        data4(:,:,1) = 0.25*(o3data(:,:,1) + o3data(:,:,2)  &
                           + o3data(:,:,3) + o3data(:,:,4))
        o3data(:,:,1) = data4(:,:,1)
        iseason = 1
      endif

!---------------------------------------------------------------------



end subroutine obtain_gfdl_zonal_ozone_data




!######################################################################
! <SUBROUTINE NAME="obtain_clim_zonal_ozone_data">
!  <OVERVIEW>
!   obtain_clim_zonal_ozone_data provides the necessary information 
!    to interpolator_mod so that the appropriate clim_ozone data may
!    be obtained later on when needed.
!  </OVERVIEW>
!  <DESCRIPTION>
!   obtain_clim_zonal_ozone_data provides the necessary information 
!    to interpolator_mod so that the appropriate clim_ozone data may
!    be obtained later on when needed.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call  obtain_clim_zonal_ozone_data (lonb, latb) 
!  </TEMPLATE>
!  <IN NAME="lonb, latb" TYPE="real">
!       lonb      2d array of model longitudes at cell corners [radians]
!       latb      2d array of model latitudes at cell corners [radians]
!  </IN> 
! </SUBROUTINE>
!
subroutine obtain_clim_zonal_ozone_data (lonb, latb)

!----------------------------------------------------------------------
!    obtain_clim_zonal_ozone_data calls interpolator_init to supply
!    the necessary information to interpolator_mod to allow the appro-
!    priate clim_zonal_ozone data to be obtained later when needed.
!---------------------------------------------------------------------

real, dimension(:,:), intent(in) :: lonb, latb

!---------------------------------------------------------------------
!  intent(in) variables:
!
!       lonb      2d array of model longitudes at cell corners [radians]
!       latb      2d array of model latitudes at cell corners [radians]
!
!-----------------------------------------------------------------

!---------------------------------------------------------------------
!    call interpolator_init to initialize an interp_type variable
!    O3_interp which will be used to retrieve interpolated ozone
!    data when requested.
!---------------------------------------------------------------------
        call interpolator_init (O3_interp, filename, lonb, &
                                latb, data_out_of_bounds=(/CONSTANT/), &
                                data_names = data_name, &
                                vert_interp=(/INTERP_WEIGHTED_P/) )


!----------------------------------------------------------------------


end subroutine obtain_clim_zonal_ozone_data



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                    INTERFACE GFDL_ZONAL_OZONE
!
!
! call gfdl_zonal_ozone (Rad_time, lat, phaf, ozone)
!
!  separate routines exist within this interface for 3d and 2d
!  array input and output:
!
!  real, dimension(:,:),    intent(in)  :: lat
!  real, dimension(:,:,:),  intent(in)  :: phalf
!  real, dimension(:,:,:),  intent(out) :: ozone
! OR
!  real, dimension(:),    intent(in)    :: lat
!  real, dimension(:,:),  intent(in)    :: phalf
!  real, dimension(:,:),  intent(out)   :: ozone
!
!--------------------------------------------------------------------
!
!  intent(in) variables:
!
!      Time         current model time [ time_type (days, seconds) ] 
!      lat          latitude of model points  [ radians ]
!      phalf        pressure at model layer interfaces [ Pa ]
!
!  intent(out) variables:
!
!      ozone        ozone mass mixing ratio at model levels [ g / g ]
!
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!#######################################################################
! <SUBROUTINE NAME="geto3_3d">
!  <OVERVIEW>
!   geto3_3d retrieves an (i,j,k) array of ozone mass mixing ratio 
!    (g / g ) valid at the specified time to be returned to the 
!    calling routine.
!  </OVERVIEW>
!  <DESCRIPTION>
!   geto3_3d retrieves an (i,j,k) array of ozone mass mixing ratio 
!    (g / g ) valid at the specified time to be returned to the 
!    calling routine.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call geto3_3d (Time, lat, phalf, ozone)
!  </TEMPLATE>
!  <IN NAME="Time" TYPE="time_type">
!   current model time [ time_type (days, seconds) ]
!  </IN>
!  <IN NAME="lat" TYPE="real">
!   latitude of model points  [ radians ]
!  </IN>
!  <IN NAME="phalf" TYPE="real">
!   pressure at model layer interfaces [ kg / (m s^2) ]
!  </IN>
!  <OUT NAME="ozone" TYPE="real">
!   ozone mass mixing ratio at model levels [ g / g ]
!  </OUT>  
! </SUBROUTINE>
!
subroutine geto3_3d (Time, lat, phalf, ozone)

!---------------------------------------------------------------------
!    geto3_3d retrieves an (i,j,k) array of ozone mass mixing ratio 
!    [ g / g ] valid at the specified time to be returned to the 
!    calling routine.
!---------------------------------------------------------------------

type(time_type),         intent(in)  :: Time
real, dimension(:,:),    intent(in)  :: lat
real, dimension(:,:,:),  intent(in)  :: phalf
real, dimension(:,:,:),  intent(out) :: ozone

!---------------------------------------------------------------------
!  local variables:
!
!      rlag         time lag of  valid time of seasonal ozone data from 
!                   start of calendar year [ years ]
!      profile      ozone profile in model grid column
!      dp           pressure difference between data layer interfaces
!      dp1, dp2, dp3, dp4          
!                   pressure differences used to assign data set layer
!                   ozone to the proper model layer
!      o3col        total ozone in a model pressure layer
!      rang         angular position of specified time from start of
!                   ozone year
!      rsin1        argument for harmonic interpolation
!      rcos1        argument for harmonic interpolation
!      rcos2        argument for harmonic interpolation
!      phd          model latitude, guaranteed to be between -90 and +90
!                   degrees
!      th           relative latitudinal distance of model grid point
!                   from nearest lower data set index, normalized by
!                   data set resolution 
!      fyear        fraction of the year which has passed at the 
!                   specified time
!      j1           nearest lower latitude index in data set to the
!                   model latitude
!      j2           j1 + 1; data from index j1 and j2 will be inter-
!                   polated to the model grid point
!
!------------------------------------------------------------------
      real                :: rlag
      real, dimension(81) :: profile, dp, dp1, dp2, dp3, dp4, o3col
      real                :: rang, rsin1, rcos1, rcos2, phd, th, fyear
      integer             :: j1,j2

      integer             :: i,j,k,l  ! various indices

!--------------------------------------------------------------------
!    when seasonally-varying ozone is desired, perform a harmonic time 
!    interpolation to obtain values at the specified time.
!--------------------------------------------------------------------
      if (iseason == 5) then
        if (do_mcm_o3_clim) then
          rlag = 12.6875/365.
        else
          rlag = 1./24.
        endif
        fyear = fraction_of_year (time)
        if (fyear /= current_fyear) then
          rang = 4.0*acos(0.0)*(fyear-rlag)
          rsin1 = sin(rang)
          rcos1 = cos(rang)
          rcos2 = cos(2.0*rang)
          rstd(:,:) = o3data(:,:,1) + rsin1*o3data(:,:,2) +  &
                      rcos1*o3data(:,:,3) + rcos2*o3data(:,:,4)
          current_fyear = fyear
        endif
!---------------------------------------------------------------------
!    otherwise, no interpolation is needed, use the specified seasonal 
!    data. if annual mean value has been specified, that data will be
!    at iseason = 1.
!---------------------------------------------------------------------
      else
        rstd(:,:) = o3data(:,:,iseason)
      endif

!---------------------------------------------------------------------
!    define the pressure increments of the standard data levels.
!---------------------------------------------------------------------
      do l=1,81
         dp (l) = ph(l+1) - ph(l)
      end do

!---------------------------------------------------------------------
!    perform horizontal interpolation into the data set. profile is
!    the vertical ozone data at the grid point.
!---------------------------------------------------------------------
      do j=1,size(lat,2)
        do i=1,size(lat,1)
          phd = max(min(lat(i,j)*radian, 90.), -90.)
          j1 = 10.000 - phd*0.10
          j1 = max(min(j1, 18), 1)
          j2 = j1 + 1
          th = (10-j1) - phd*0.10
          profile(:) = rstd(j1,:) + th*(rstd(j2,:) - rstd(j1,:))

!---------------------------------------------------------------------
!    now interpolate in the vertical to produce values at model
!    levels. calculate layer-mean ozone mixing ratio from data set for 
!    each model layer.
!---------------------------------------------------------------------
          do k=1,size(ozone,3)

!---------------------------------------------------------------------
!    calculate sums over data set layers to get model layer 
!    ozone. the mcm ozone data is obtained in a somewhat
!    different manner.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!    mcm algorithm.
!--------------------------------------------------------------------
            if (do_mcm_o3_clim) then
              ozone(i,j,k) = 0.0
              do l=1,81
                if ((ph(l+1) >= phalf(i,j,k)) .and.   &
                    (ph(l) <= phalf(i,j,k+1))) then
                  if ((ph(l+1) < phalf(i,j,k+1)) .and.    &
                      (ph(l) < phalf(i,j,k)))   then
                    ozone(i,j,k) = ozone(i,j,k) + profile(l)*   &
                                   (ph(l+1) - phalf(i,j,k))
                  endif
                  if ((ph(l+1) < phalf(i,j,k+1)) .and.    &
                      (ph(l) >= phalf(i,j,k)))   then  
                    ozone(i,j,k) = ozone(i,j,k) + profile(l)*    &
                                   (ph(l+1) - ph(l))
                  endif
                  if ((ph(l+1) > phalf(i,j,k+1)) .and.    &
                      (ph(l) > phalf(i,j,k)))  then 
                    ozone(i,j,k) = ozone(i,j,k) + profile(l)*   &
                                   (phalf(i,j,k+1) - ph(l))
                  endif
                endif
              end do

!---------------------------------------------------------------------
!    fms algorithm.
!---------------------------------------------------------------------
            else 
              do l=1,81
                dp1(l) = ph(l+1) - phalf(i,j,k)
                dp2(l) = phalf(i,j,k+1) - ph(l)
                dp3(l) = ph(l+1) - phalf(i,j,k+1)
                dp4(l) = ph(l) - phalf(i,j,k)
              end do
              where (dp1(:) < 0.0) dp1(:)=0.0
              where (dp2(:) < 0.0) dp2(:)=0.0
              do l=1,81
                o3col(l) = 0.0
                if ( dp3(l) < 0.0 ) then
                  if ( dp4(l) < 0.0 ) then
                    o3col(l) = profile(l)*dp1(l)
                  else
                    o3col(l) = profile(l)*dp(l)
                  endif
                else
                  if ( dp4(l) < 0.0 ) then
                    o3col(l) = profile(l)*    &
                               (phalf(i,j,k+1) - phalf(i,j,k))
                  else
                    o3col(l) = profile(l)*dp2(l)
                  endif
                endif
              end do
              ozone(i,j,k) = sum(o3col(:))
            endif ! do_mcm_o3_clim if block

!---------------------------------------------------------------------
!    normalize by the model pressure depth to produce a mass 
!    mixing ratio.
!---------------------------------------------------------------------
            ozone(i,j,k) = ozone(i,j,k)/(phalf(i,j,k+1)-phalf(i,j,k))

!---------------------------------------------------------------------
!    code to cover case when surface pressure is greater than pref.
!---------------------------------------------------------------------
            if (.not.do_mcm_o3_clim .and. ph(82) < phalf(i,j,k+1)) then
              ozone(i,j,k) = profile(81)
            endif

!----------------------------------------------------------------------
!    code to cover case when model resolution is so fine that no value
!    of ph(l) in the ozone data array falls betwen phalf(k+1) and
!    phalf(k).   procedure is to simply grab the nearest value from
!    rdata (or profile in the fms code).
!----------------------------------------------------------------------
            if (do_mcm_o3_clim) then
              if (ozone(i,j,k) <= 0.0) then
                do l=1,81
                  if (ph(l) < phalf(i,j,k) .and.     &
                      ph(l+1) > phalf(i,j,k+1) ) then
                    ozone(i,j,k) = profile(l)
                  endif
                end do
              endif
            endif 
          end do ! k loop
        end do   ! i loop
      end do     ! j loop

!---------------------------------------------------------------------
!    convert units from micrograms/gram to kg/kg.
!---------------------------------------------------------------------
      ozone(:,:,:) = ozone(:,:,:)*1.e-6

!-----------------------------------------------------------------------



end subroutine geto3_3d




!#######################################################################
! <SUBROUTINE NAME="geto3_2d">
!  <OVERVIEW>
!   geto3_2d retrieves an (i,k) array of ozone mass mixing ratio 
!    (g / g ) valid at the specified time to be returned to the 
!    calling routine.
!  </OVERVIEW>
!  <DESCRIPTION>
!   geto3_2d retrieves an (i,k) array of ozone mass mixing ratio 
!    (g / g ) valid at the specified time to be returned to the 
!    calling routine.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call  geto3_2d(Time, lat, phalf, ozone)
!  </TEMPLATE>
!  <IN NAME="Time" TYPE="time_type">
!   current model time [ time_type (days, seconds) ]
!  </IN>
!  <IN NAME="lat" TYPE="real">
!   latitude of model points  [ radians ]
!  </IN>
!  <IN NAME="phalf" TYPE="real">
!   pressure at model layer interfaces [ kg / (m s^2) ]
!  </IN>
!  <OUT NAME="ozone" TYPE="real">
!   ozone mass mixing ratio at model levels [ g / g ]
!  </OUT>  
! </SUBROUTINE>
!
subroutine geto3_2d (Time, lat, phalf, ozone)

!---------------------------------------------------------------------
!    geto3_2d retrieves an (i,k) array of ozone mass mixing ratio 
!    [ g / g ] valid at the specified time to be returned to the 
!    calling routine.
!---------------------------------------------------------------------

type(time_type),       intent(in)  :: Time
real, dimension(:),    intent(in)  :: lat
real, dimension(:,:),  intent(in)  :: phalf
real, dimension(:,:),  intent(out) :: ozone

!---------------------------------------------------------------------
!  local variables:
!
!      lat3         2d equivalent of lat
!      phalf3       3d equivalent of phalf
!      ozone3       3d equivalent of ozone
!
!--------------------------------------------------------------------

      real,dimension (size(lat,1),1)                  :: lat3
      real,dimension (size(phalf,1),1, size(phalf,2)) :: phalf3
      real,dimension (size(ozone,1),1, size(ozone,2)) :: ozone3

!---------------------------------------------------------------------
!    add an extra dummy dimension to the input variables.
!---------------------------------------------------------------------
      lat3(:,1)     = lat(:)
      phalf3(:,1,:) = phalf(:,:)

!---------------------------------------------------------------------
!    call the 3d interface of this procedure.
!---------------------------------------------------------------------
      call geto3_3d (time, lat3, phalf3, ozone3)

!---------------------------------------------------------------------
!    remove the extra dummy dimension from the output variables.
!---------------------------------------------------------------------
      ozone(:,:) = ozone3(:,1,:)

!--------------------------------------------------------------------


end subroutine geto3_2d


 
 
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                END INTERFACE GFDL_ZONAL_OZONE
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




!#######################################################################
! <SUBROUTINE NAME="get_clim_ozone">
!  <OVERVIEW>
!   get_clim_ozone retrieves the clim_ozone field at the desired place 
!    and time from the o3.climatology.nc file by accessing 
!    interpolator_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!   get_clim_ozone retrieves the clim_ozone field at the desired place 
!    and time from the o3.climatology.nc file by accessing 
!    interpolator_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call  get_clim_ozone (is, js, model_time, p_half, model_data)
!  </TEMPLATE>
!  <IN NAME="model_time" TYPE="time_type">
!   time at which the climatologically-determined,
!                   time-varying ozone field should apply
!  </IN>
!  <IN NAME="p_half" TYPE="real">
!   pressure at model layer interfaces [ kg / (m s^2) ]
!  </IN>
!  <OUT NAME="model_data" TYPE="real">
!   output field containing ozone field at desired time
!  </OUT>  
!  <IN NAME="is, js" TYPE="integer">
!   OPTIONAL: starting subdomain i,j indices of data in 
!                   the physics_window being integrated
!  </IN>
! </SUBROUTINE>
!
subroutine get_clim_ozone (is, js, model_time, p_half, model_data)

!--------------------------------------------------------------------
!    get_clim_ozone retrieves the clim_ozone field for the requested
!    points at the desired time from the clim ozone data file by
!    accessing interpolator_mod.
!---------------------------------------------------------------------

integer,                intent(in)      :: is,js
type(time_type),        intent(in)      :: model_time
real, dimension(:,:,:), intent(in)      :: p_half
real, dimension(:,:,:), intent(out)     :: model_data

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      is,js        starting subdomain i,j indices of data in 
!                   the physics_window being integrated
!      model_time   time at which the climatologically-determined,
!                   time-varying ozone field should apply
!                   [ time_type (days, seconds) ] 
!      p_half       pressure at model interface levels
!                   [ Pa ]
!
!   intent(out) variables:
!
!      model_data   output field containing ozone field at desired time
!                   [ g / g ]
!
!
!----------------------------------------------------------------------
!
!   local variables
 
      real, dimension(1,1, size(p_half,3)-1) :: ozone_data
      real, dimension(1,1, size(p_half,3)) :: p_half_col
      integer         :: i, j

!--------------------------------------------------------------------
!    if 'calculate_column' is being used, obtain the ozone values for
!    each column, one at a time, using the pressure profile for that
!    column. this allows each column to see the same ozone fields,
!    but distributed appropriately for its pressure structure.
!--------------------------------------------------------------------
     if (trim(ozone_data_source) == 'calculate_column') then
       do j=1, size(p_half,2)
         do i=1, size(p_half,1)
           p_half_col(1,1,:) = p_half(i,j,:)
           call interpolator (O3_interp, Ozone_column_time,  &
                              p_half_col, ozone_data, &
!                             trim(data_name(1)), is, js)
                              trim(data_name(1)), 1, 1  )
           model_data(i,j,:) = ozone_data(1,1,:)
         end do
       end do
     else

!--------------------------------------------------------------------
!    call interpolator to obtain data at the specified grid points and 
!    specified time.
!--------------------------------------------------------------------
      
      call interpolator (O3_interp, Ozone_time, p_half, model_data,  &
                         trim(data_name(1)), is, js)
     endif 

!----------------------------------------------------------------------


end subroutine get_clim_ozone



!#####################################################################



                       end module ozone_mod

! ============================================================================
! module numerics: a collection of useful general-purpose routines
! ============================================================================
#define __ERROR__(message) \
call my_error(mod_name,message,FATAL,__FILE__,__LINE__)
#define __NOTE__(message) \
call my_error(mod_name,message,NOTE,__FILE__,__LINE__)
#define __ASSERT__(x, message) \
if(.NOT.(x))call my_error(mod_name,message,FATAL,__FILE__,__LINE__)




module numerics_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Christopher Milly
! </CONTACT> 

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Elena Shevliakova
! </REVIEWER>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Sergey Malyshev
! </REVIEWER>

! <OVERVIEW>
!   A collection of useful general-purpose numerical routines, including
!   a bisect function and linear interpolation routines.
! </OVERVIEW>

  ! thing we use repeatedly inside the module
  use fms_mod, only: error_mesg, FATAL, NOTE, write_version_number
  use constants_mod, only : PI
implicit none
private

! ==== public interfaces =====================================================
public :: bisect    ! finds a position of point in array of bounds
public :: lin_int   ! linear interpolation
public :: numerics_init
public :: is_latlon, expand_cell
! ==== end of public interfaces ==============================================

! <INTERFACE NAME="lin_int">

!   <OVERVIEW>
!     Linear interpolation.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Linear interpolation. 
!   </DESCRIPTION>

interface lin_int
   module procedure lin_int0
   module procedure lin_int1
   module procedure lin_int2
   module procedure lin_int1m
   module procedure lin_int2m
end interface
! </INTERFACE>

logical :: module_is_initialized =.FALSE.
! module constants
character(len=*), parameter :: mod_name = "Numerics_mod"
character(len=128) :: version = '$Id: numerics.F90,v 15.0 2007/08/14 04:00:08 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

contains


! ============================================================================

! <SUBROUTINE NAME="numerics_init">

!   <OVERVIEW>
!     Initializes the numerics module.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Initializes the numerics module.
!   </DESCRIPTION>

subroutine numerics_init()

  module_is_initialized =.TRUE. 
  call write_version_number(version, tagname)

end subroutine numerics_init
! </SUBROUTINE>


! <FUNCTION NAME="bisect">

!   <OVERVIEW>
!     Finds a position of point in array of bounds.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Finds a position of point in array of bounds. Returns i, so that x is
!     between xx(i) and xx(i+1).
!   </DESCRIPTION>

!   <TEMPLATE>
!     value=bisect( xx, x1, periodic )
!   </TEMPLATE>

!   <PUBLICROUTINE>

function bisect(xx, x1, periodic)

  real, intent(in)              :: xx(:)     ! array of boundaries
  real, intent(in)              :: x1        ! point to locate
  logical, intent(in), optional :: periodic  ! if present and true, the data
                                             ! domain is assumed to be periodic

!   </PUBLICROUTINE>

  ! ---- result type ---------------------------------------------------
  integer bisect

  ! ---- local vars ----------------------------------------------------
  real    :: x              ! duplicate of input value
  integer :: low, high, mid
  integer :: n              ! size of the input array
  logical :: ascending      ! if true, the coordinates are in ascending order

  n = size(xx(:))
  x = x1

  ! bring the point inside bounds of the periodic domain
  if (present(periodic)) then
     if(periodic) then
       __ASSERT__(xx(n)-xx(1)/=0,"periodic bisect: period equal to zero")
       x = modulo(x-min(xx(1),xx(n)),abs(xx(n)-xx(1)))+min(xx(1),xx(n))
    endif
  endif

!   <ERROR MSG="Periodic bisect: period equal to zero" STATUS="FATAL">
!     Period is equal to zero, [ (xx(n)-xx(1)) / = 0 ]
!   </ERROR>

  ! find the coordinates
  if (x >= xx(1).and.x<=xx(n)) then
     low = 1; high = n
     ascending = xx(n) > xx(1)
     do while (high-low > 1)
        mid = (low+high)/2
        if (ascending.eqv.xx(mid) <= x) then
           low = mid
        else
           high = mid
        endif
     enddo
     bisect = low
  else
     bisect = -1
  endif

end function bisect
! </FUNCTION>


! <SUBROUTINE NAME="lin_int0" INTERFACE="lin_int">

!   <OVERVIEW>
!     Linearly interpolates 1-D data.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Linearly interpolates 1-D data.
!   </DESCRIPTION>

!   <PUBLICROUTINE INTERFACE="lin_int">
subroutine lin_int0(data, xx, x, res)

  real, intent(in) :: data(:)    ! data to interpolate
  real, intent(in) :: xx(:)      ! coord. corresponding to data
  real, intent(in) :: x          ! coord to interpolate to
  real, intent(inout) :: res     ! result of interpolation
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer :: i1, i2
  real    :: f1, f2

  ! find where is our time point and calculate weights
  i1 = bisect(xx,x)
  i2 = i1+1
  __ASSERT__(i1>0.AND.i1<size(xx(:)),"Coordinate is out of range")

  f2 = (x-xx(i1))/(xx(i2)-xx(i1))
  f1 = 1.0-f2

  ! update the result
  res = data(i1)*f1+data(i2)*f2

end subroutine lin_int0
! </SUBROUTINE>


! <SUBROUTINE NAME="lin_int1" INTERFACE="lin_int">

!   <OVERVIEW>
!     Linearly interpolates 1-D data.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Linearly interpolates 1-D data.
!     
!   </DESCRIPTION>

!   <PUBLICROUTINE INTERFACE="lin_int">
subroutine lin_int1(data, xx, x, res)

  real, intent(in) :: data(:,:)    ! data to interpolate
  real, intent(in) :: xx(:)        ! coord. corresponding to data
  real, intent(in) :: x            ! coord to interpolate to
  real, intent(inout) :: res(:)    ! result of interpolation
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer :: i1, i2
  real    :: f1, f2

  ! find where is our time point and calculate weights
  i1 = bisect(xx,x)
  i2 = i1+1

!   <ERROR MSG="Coordinate is out of range" STATUS="FATAL">
!     Coordinate corresponding to data is out of range.
!   </ERROR>

  __ASSERT__(i1>0.AND.i1<size(xx(:)),"Coordinate is out of range")

  f2 = (x-xx(i1))/(xx(i2)-xx(i1))
  f1 = 1.0-f2

  ! update the result
  res = data(:,i1)*f1+data(:,i2)*f2

end subroutine lin_int1
! </SUBROUTINE>



! <SUBROUTINE NAME="lin_int2" INTERFACE="lin_int">

!   <OVERVIEW>
!     Interpolates prescribed over time.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Interpolates prescribed over time.
!   </DESCRIPTION>

!   <PUBLICROUTINE INTERFACE="lin_int">
subroutine lin_int2(data, tt, t, res)

  real, intent(in) :: data(:,:,:)  ! data to interpolate
  real, intent(in) :: tt(:)        ! time moments corresponding to data points
  real, intent(in) :: t            ! time to interpolate to
  real, intent(inout) :: res(:,:)  ! result
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer :: i1, i2
  real    :: f1, f2

  ! find where is our time point and calculate weights
  i1 = bisect(tt,t); i2 = i1+1
  __ASSERT__(i1>0.AND.i1<size(tt(:)),"Coordinate is out of range")

!   <ERROR MSG="Coordinate is out of range" STATUS="FATAL">
!     Time moments corresponding to data points is out of range.
!   </ERROR>

  f2 = (t-tt(i1))/(tt(i2)-tt(i1))
  f1 = 1-f2

  ! update the result
  res = data(:,:,i1)*f1+data(:,:,i2)*f2

end subroutine lin_int2
! </SUBROUTINE>


! <SUBROUTINE NAME="lin_int1m" INTERFACE="lin_int">

!   <OVERVIEW>
!     Linearly interpolates 1-D data.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Linearly interpolates 1-D data.
!   </DESCRIPTION>

!   <PUBLICROUTINE INTERFACE="lin_int">
subroutine lin_int1m(data, xx, x, res, mask)

  real, intent(in) :: data(:,:)    ! data to interpolate
  real, intent(in) :: xx(:)        ! coord. corresponding to data
  real, intent(in) :: x            ! coord to interpolate to
  real, intent(inout) :: res(:)    ! result of interpolation
  logical, intent(in) :: mask(:)   ! valid data mask
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer :: i1, i2
  real    :: f1, f2

  ! find where is our time point and calculate weights
  i1 = bisect(xx,x)
  i2 = i1+1
  __ASSERT__(i1>0.AND.i1<size(xx(:)),"Coordinate is out of range")

!   <ERROR MSG="Coordinate is out of range" STATUS="FATAL">
!     Coordinate corresponding to data is out of range.
!   </ERROR>

  f2 = (x-xx(i1))/(xx(i2)-xx(i1))
  f1 = 1.0-f2

  ! finally, update the result
  where (mask) 
     res = data(:,i1)*f1+data(:,i2)*f2
  endwhere

end subroutine lin_int1m
! </SUBROUTINE>

! <SUBROUTINE NAME="lin_int2m" INTERFACE="lin_int">

!   <OVERVIEW>
!     Interpolates prescribed over time.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Interpolates prescribed over time.
!   </DESCRIPTION>

!   <PUBLICROUTINE INTERFACE="lin_int">
subroutine lin_int2m(data, tt, t, res, mask)

  real, intent(in) :: data(:,:,:)  ! data to interpolate
  real, intent(in) :: tt(:)        ! time moments corresponding to data points
  real, intent(in) :: t            ! time to interpolate to
  real, intent(inout) :: res(:,:)  ! result
  logical, intent(in) :: mask(:,:) ! interpolation mask
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer :: i1, i2
  real    :: f1, f2

  ! find where is our time point and calculate weights
  i1 = bisect(tt,t); i2 = i1+1
  __ASSERT__(i1>0.AND.i1<size(tt(:)),"Coordinate is out of range")

!   <ERROR MSG="Coordinate is out of range" STATUS="FATAL">
!     Time moments corresponding to data points is out of range.
!   </ERROR>

  f2 = (t-tt(i1))/(tt(i2)-tt(i1))
  f1 = 1-f2

  ! update the result
  where (mask) 
     res = data(:,:,i1)*f1+data(:,:,i2)*f2
  endwhere
end subroutine lin_int2m
! </SUBROUTINE>

!######################################################################
!   Routines added to deal with cubed sphere geometry
!######################################################################

function is_latlon ( lon, lat )
real, intent(in) :: lon(:,:), lat(:,:)

! Determines if the latitude/longitude values form a
! regular lat/lon grid (or something else).
!

logical :: is_latlon
integer :: i, j 

  is_latlon = .true.

  do j = 2, size(lon,2)
  do i = 1, size(lon,1)
     if (lon(i,j) .ne. lon(i,1)) then
        is_latlon = .false. 
        return  
     endif   
  enddo
  enddo

  do j = 1, size(lat,2)
  do i = 2, size(lat,1)
     if (lat(i,j) .ne. lat(1,j)) then
        is_latlon = .false. 
        return  
     endif   
  enddo
  enddo

end function is_latlon

!=================================================

 subroutine expand_cell(lon, lat, fac)
! Util for land model (for BW)
!
!        4----3
!        |  . |
!        1----2
!
      real, intent(inout):: lon(2,2), lat(2,2)
      real, intent(in):: fac    ! expansion factor: outside: > 1
                                ! fac = 1: qq1 returns q1
                                ! fac = 0: qq1_4 retruns the center position
! Local
      real qq1(3), qq2(3), qq3(3), qq4(3)
      real p1(3), p2(3), p3(3), p4(3)
      real ec(3)
      real dd, d1, d2, d3, d4
      integer k

! Transform to (x,y,z)
      call latlon2xyz((/lon(1,1),lat(1,1)/), p1)
      call latlon2xyz((/lon(2,1),lat(2,1)/), p2)
      call latlon2xyz((/lon(1,2),lat(1,2)/), p3)
      call latlon2xyz((/lon(2,2),lat(2,2)/), p4)

! Get center position:
      do k=1,3
         ec(k) = p1(k) + p2(k) + p3(k) + p4(k)
      enddo
      dd = sqrt( ec(1)**2 + ec(2)**2 + ec(3)**2 )

      do k=1,3
         ec(k) = ec(k) / dd   ! cell center position
      enddo

! Perform the "extrapolation" to outside if fac > 1
      do k=1,3
         qq1(k) = ec(k) + fac*(p1(k)-ec(k))
         qq2(k) = ec(k) + fac*(p2(k)-ec(k))
         qq3(k) = ec(k) + fac*(p3(k)-ec(k))
         qq4(k) = ec(k) + fac*(p4(k)-ec(k))
      enddo

!--------------------------------------------------------
! Force the points to be on the sphere via normalization
!--------------------------------------------------------
      d1 = sqrt( qq1(1)**2 + qq1(2)**2 + qq1(3)**2 )
      d2 = sqrt( qq2(1)**2 + qq2(2)**2 + qq2(3)**2 )
      d3 = sqrt( qq3(1)**2 + qq3(2)**2 + qq3(3)**2 )
      d4 = sqrt( qq4(1)**2 + qq4(2)**2 + qq4(3)**2 )
      do k=1,3
         qq1(k) = qq1(k) / d1
         qq2(k) = qq2(k) / d2
         qq3(k) = qq3(k) / d3
         qq4(k) = qq4(k) / d4
      enddo

!----------------------------------------
! Transform back to lat-lon coordinates:
!----------------------------------------

      call cart_to_latlon1(qq1, lon(1,1), lat(1,1))
      call cart_to_latlon1(qq2, lon(2,1), lat(2,1))
      call cart_to_latlon1(qq3, lon(1,2), lat(1,2))
      call cart_to_latlon1(qq4, lon(2,2), lat(2,2))

 end subroutine expand_cell

!=================================================

 subroutine latlon2xyz(p, e)
!
! Routine to map (lon, lat) to (x,y,z)
!
 real, intent(in) :: p(2)
 real, intent(out):: e(3)

 integer n
 real :: q(2)
 real :: e1, e2, e3

    do n=1,2
       q(n) = p(n)
    enddo

    e1 = cos(q(2)) * cos(q(1))
    e2 = cos(q(2)) * sin(q(1))
    e3 = sin(q(2))
!-----------------------------------
! Truncate to the desired precision:
!-----------------------------------
    e(1) = e1
    e(2) = e2
    e(3) = e3

 end subroutine latlon2xyz

!=================================================

 subroutine cart_to_latlon1(q, xs, ys)
  real, intent(inout):: q(3)
  real, intent(inout):: xs, ys
! local
  real, parameter:: esl=1.e-10
  real :: p(3)
  real :: pi, dist, lat, lon
  integer :: k

  pi = 4.*atan(1.)

     do k=1,3
        p(k) = q(k)
     enddo
     dist = sqrt(p(1)**2 + p(2)**2 + p(3)**2)
     do k=1,3
        p(k) = p(k) / dist
     enddo

     if ( (abs(p(1))+abs(p(2)))  < esl ) then
          lon = 0.
     else
          lon = atan2( p(2), p(1) )   ! range [-pi,pi]
     endif

     if ( lon < 0.) lon = 2.*pi + lon
     lat = asin(p(3))
     
     xs = lon
     ys = lat
! q Normalized:
     do k=1,3
        q(k) = p(k)
     enddo

 end  subroutine cart_to_latlon1

!######################################################################

! <SUBROUTINE NAME="my_error">

!   <OVERVIEW>
!     Reports error, including file name and line.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Reports error, including file name and line.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call my_error(mod_name, message, mode, file, line)
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine my_error(mod_name, message, mode, file, line)

  character(len=*), intent(in) :: mod_name
  character(len=*), intent(in) :: message
  integer,          intent(in) :: mode
  character(len=*), intent(in) :: file
  integer,          intent(in) :: line
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  character(len=512) :: mesg
  write(mesg,'("File ",a," Line ",i4.4," :: ",a)')&
       file, line, trim(message)
  call error_mesg(mod_name, mesg, mode)

end subroutine
! </SUBROUTINE>

end module numerics_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: load_hydrometeor_classes.F90,v 20.0 2013/12/13 23:16:46 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

  subroutine load_hydrometeor_classes(Nprmts_max,dist_prmts_hydro,hp,nhclass)
  use radar_simulator_types
  implicit none
  
! Purpose:
!   Loads the hydrometeor classes to be used in calculations
!   Part of QuickBeam v1.03 by John Haynes
!   http://reef.atmos.colostate.edu/haynes/radarsim
!
! Inputs:  
!   [dist_prmts_hydro]   from data in hydrometeor class input 
!
! Outputs:
!   [hp]            structure that define hydrometeor types
!
! Modified:
!   08/23/2006  placed into subroutine form (Roger Marchand)
   
! ----- INPUT -----
  integer, intent(in) :: nhclass,Nprmts_max
  real,dimension(Nprmts_max,nhclass), intent(in) :: dist_prmts_hydro
! ----- OUTPUTS -----  
  type(class_param), intent(out) :: hp
  
! ----- INTERNAL -----  
  integer :: i
     
    hp%rho(:) = -1

    do i = 1,nhclass,1
    hp%dtype(i) = dist_prmts_hydro(1,i)
    hp%col(i) = dist_prmts_hydro(2,i)
    hp%phase(i) = dist_prmts_hydro(3,i)
    hp%cp(i) = dist_prmts_hydro(4,i)
    hp%dmin(i) = dist_prmts_hydro(5,i)
    hp%dmax(i) = dist_prmts_hydro(6,i)
    hp%apm(i) = dist_prmts_hydro(7,i)
    hp%bpm(i) = dist_prmts_hydro(8,i)
    hp%rho(i) = dist_prmts_hydro(9,i)
    hp%p1(i) = dist_prmts_hydro(10,i)
    hp%p2(i) = dist_prmts_hydro(11,i)
    hp%p3(i) = dist_prmts_hydro(12,i)
    enddo
        
!   // setup scaling arrays
    hp%fc = -999.
    hp%scaled = .false.  
    hp%z_flag = .false.
    hp%rho_eff = -999.
    hp%ifc = -9
    hp%idd = -9
   
  
  end subroutine load_hydrometeor_classes

! $Id$
!
! nf95 -r8 -g -I ~/regression/ia64/23-Jun-2005/CM2.1U_Control-1990_E1.k32pe/include/ -D_TEST_DRIFTERS -D_F95 quicksort.F90 drifters_core.F90

#include <fms_platform.h>

module drifters_core_mod
  use quicksort_mod, only: qksrt_quicksort

  implicit none
  private

  public :: drifters_core_type, drifters_core_new, drifters_core_del
  public :: drifters_core_remove_and_add, drifters_core_set_positions, assignment(=)
#ifdef _TEST_DRIFTERS_CORE
  public :: drifters_core_print, drifters_core_resize
#endif

  ! Globals
  integer, parameter, private   :: MAX_STR_LEN = 128
  character(MAX_STR_LEN), parameter, private :: version = '$Id$'

  type drifters_core_type
     ! Be sure to update drifters_core_new, drifters_core_del and drifters_core_copy_new
     ! when adding members
     integer*8 :: it   ! time index
     integer :: nd     ! number of dimensions
     integer :: np     ! number of particles (drifters)
     integer :: npdim  ! max number of particles (drifters)
     integer, _ALLOCATABLE :: ids(:)_NULL  ! particle id number
     real   , _ALLOCATABLE :: positions(:,:)   _NULL
  end type drifters_core_type

  interface assignment(=)
     module procedure drifters_core_copy_new
  end interface

contains

!###############################################################################
  subroutine drifters_core_new(self, nd, npdim, ermesg)
    type(drifters_core_type)        :: self
    integer, intent(in)       :: nd
    integer, intent(in)       :: npdim
    character(*), intent(out) :: ermesg
    integer ier, iflag, i
    ermesg = ''
    ier    = 0

    call drifters_core_del(self, ermesg)

    allocate(self%positions(nd, npdim), stat=iflag)
    if(iflag/=0) ier = ier + 1
    self%positions   = 0.

    allocate(self%ids(npdim), stat=iflag)
    if(iflag/=0) ier = ier + 1
    self%ids         = (/(i, i=1,npdim)/)

    self%nd    = nd
    self%npdim = npdim

    if(ier/=0) ermesg = 'drifters::ERROR in drifters_core_new'
  end subroutine drifters_core_new

 !###############################################################################
 subroutine drifters_core_del(self, ermesg)
    type(drifters_core_type)        :: self
    character(*), intent(out) :: ermesg
    integer ier, iflag
    ermesg = ''
    ier    = 0
    self%it  = 0
    self%nd  = 0
    self%np  = 0
    iflag = 0
    if(_ALLOCATED(self%positions)) deallocate(self%positions, stat=iflag)
    if(iflag/=0) ier = ier + 1
    if(_ALLOCATED(self%ids)) deallocate(self%ids, stat=iflag)
    if(iflag/=0) ier = ier + 1
    
    if(ier/=0) ermesg = 'drifters::ERROR in drifters_core_del'
  end subroutine drifters_core_del

 !###############################################################################
 subroutine drifters_core_copy_new(new_instance, old_instance)

    type(drifters_core_type), intent(inout)   :: new_instance
    type(drifters_core_type), intent(in)      :: old_instance

    character(len=MAX_STR_LEN) :: ermesg

    ermesg = ''
    call drifters_core_del(new_instance, ermesg)
    if(ermesg/='') return
    ! this should provide the right behavior for both pointers and allocatables
    new_instance%it         = old_instance%it
    new_instance%nd         = old_instance%nd
    new_instance%np         = old_instance%np
    new_instance%npdim      = old_instance%npdim
    allocate(new_instance%ids( size(old_instance%ids) ))
    new_instance%ids        = old_instance%ids
    allocate(new_instance%positions( size(old_instance%positions,1), &
         &                           size(old_instance%positions,2) ))
    new_instance%positions  = old_instance%positions
   
 end subroutine drifters_core_copy_new
 !###############################################################################
  subroutine drifters_core_resize(self, npdim, ermesg)
    type(drifters_core_type)        :: self
    integer, intent(in)        :: npdim ! new max value
    character(*), intent(out) :: ermesg
    integer ier, iflag, i

    real   , allocatable :: positions(:,:)
    integer, allocatable :: ids(:)

    ermesg = ''
    ier    = 0
    if(npdim <= self%npdim) return

    ! temps
    allocate(positions(self%nd, self%np), stat=iflag)
    allocate(               ids(self%np), stat=iflag)
    
    positions    = self%positions(:, 1:self%np)
    ids          = self%ids(1:self%np)

    deallocate(self%positions, stat=iflag)
    deallocate(self%ids      , stat=iflag)

    allocate(self%positions(self%nd, npdim), stat=iflag)
    allocate(self%ids(npdim), stat=iflag)
    self%positions = 0.0
    ! default id numbers
    self%ids       = (/ (i, i=1,npdim) /)
    self%positions(:, 1:self%np) = positions
    self%npdim = npdim
    
    if(ier/=0) ermesg = 'drifters::ERROR in drifters_core_resize'
  end subroutine drifters_core_resize

!###############################################################################
  subroutine drifters_core_set_positions(self, positions, ermesg)
    type(drifters_core_type)        :: self
    real, intent(in)           :: positions(:,:)
    character(*), intent(out)  :: ermesg
    integer ier !, iflag
    ermesg = ''
    ier = 0
    self%np = min(self%npdim, size(positions, 2))
    self%positions(:,1:self%np) = positions(:,1:self%np)
    self%it                = self%it + 1
    if(ier/=0) ermesg = 'drifters::ERROR in drifters_core_set_positions'
  end subroutine drifters_core_set_positions

!###############################################################################
  subroutine drifters_core_set_ids(self, ids, ermesg)
    type(drifters_core_type)        :: self
    integer, intent(in)        :: ids(:)
    character(*), intent(out)  :: ermesg
    integer ier, np !, iflag
    ermesg = ''
    ier = 0
    np = min(self%npdim, size(ids))
    self%ids(1:np) = ids(1:np)
    if(ier/=0) ermesg = 'drifters::ERROR in drifters_core_set_ids'
  end subroutine drifters_core_set_ids

!###############################################################################
subroutine drifters_core_remove_and_add(self, indices_to_remove_in, &
     & ids_to_add, positions_to_add, &
     & ermesg)
    type(drifters_core_type)        :: self
    integer, intent(in   )     :: indices_to_remove_in(:)
    integer, intent(in   )     :: ids_to_add(:)
    real   , intent(in   )     :: positions_to_add(:,:)
    character(*), intent(out)  :: ermesg
    integer ier, np_add, np_remove, i, j, n_diff !, iflag
    integer indices_to_remove(size(indices_to_remove_in))
    ermesg = ''
    ier = 0

    ! copy, required so we can have indices_to_remove_in intent(in)    
    indices_to_remove = indices_to_remove_in
    np_remove = size(indices_to_remove)
    np_add    = size(ids_to_add, 1)
    n_diff = np_add - np_remove

    ! cannot remove more than there are elements
    if(self%np + n_diff < 0) then
       ermesg = 'drifters::ERROR attempting to remove more elements than there are elements in drifters_core_remove_and_add'
       return
    endif
    
    ! check for overflow, and resize if necessary
    if(self%np + n_diff > self%npdim)  &
         & call drifters_core_resize(self, int(1.2*(self%np + n_diff))+1, ermesg)

    do i = 1, min(np_add, np_remove)
       j = indices_to_remove(i)
       self%ids(j)            = ids_to_add(i)
       self%positions(:,j)    = positions_to_add(:,i)
    enddo
    
    if(n_diff > 0) then
       ! all the particles to remove were removed and replaced. Just need to append
       ! remaining particles to end of list
       self%ids(         self%np+1:self%np+n_diff)   = ids_to_add(        np_remove+1:np_add)
       self%positions(:, self%np+1:self%np+n_diff)   = positions_to_add(:,np_remove+1:np_add)

       self%np = self%np + n_diff

    else if(n_diff < 0) then
       ! all the particles were added by filling in holes left by particles that 
       ! were previously removed. Now remove remaining particles, starting from the end,  
       ! by replacing the missing particle with a copy from the end.
       
       ! sort remaining indices in ascending order
       call qksrt_quicksort(size(indices_to_remove), indices_to_remove, np_add+1, np_remove)

       do i = np_remove, np_add+1, -1
          if(self%np <= 0) exit
          j = indices_to_remove(i)
          self%ids      (  j)    = self%ids      (  self%np)
          self%positions(:,j)    = self%positions(:,self%np)
          self%np = self%np - 1
       enddo
    endif
       
    if(ier/=0) ermesg = 'drifters::ERROR in drifters_core_remove_and_add'
  end subroutine drifters_core_remove_and_add
  
!###############################################################################
  subroutine drifters_core_print(self, ermesg)
    type(drifters_core_type)        :: self
    character(*), intent(out) :: ermesg
    integer j
    ermesg = ''

    print '(a,i10,a,i6,a,i6,a,i4,a,i4,a,i4)','it=',self%it,  &
         & ' np=', self%np, ' npdim=', self%npdim
        
    print *,'ids and positions:'
    do j = 1, self%np
       print *,self%ids(j), self%positions(:,j)
    enddo    
       
  end subroutine drifters_core_print


end module drifters_core_mod
!###############################################################################
!###############################################################################

#ifdef _TEST_DRIFTERS_CORE
program test
  use drifters_core_mod
  implicit none
  type(drifters_core_type) :: drf
  integer :: ier, nd, npdim, i, j, np
  character(128) :: ermesg
  integer :: npa
  real   , allocatable :: positions(:,:), positions_to_add(:,:)

  ! c-tor/d-tor tests
  nd    = 3
  npdim = 2
  call drifters_core_new(drf, nd, npdim, ermesg)
  if(ermesg/='') print *,ermesg
  call drifters_core_del(drf, ermesg)
  if(ermesg/='') print *,ermesg
  call drifters_core_new(drf, nd, npdim, ermesg)
  if(ermesg/='') print *,ermesg

  call drifters_core_print(drf, ermesg)

  npdim = 10
  call drifters_core_resize(drf, npdim, ermesg)
  if(ermesg/='') print *,ermesg
  call drifters_core_print(drf, ermesg)

  np = 7
  allocate(positions(nd,np))
  positions(1,:) = (/0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0/) ! x
  positions(2,:) = (/0.1, 1.1, 2.1, 3.1, 4.1, 5.1, 6.1/) ! y
  positions(3,:) = (/0.2, 1.2, 2.2, 3.2, 4.2, 5.2, 6.2/) ! z
  call drifters_core_set_positions(drf, positions, ermesg)
  if(ermesg/='') print *,ermesg
  call drifters_core_print(drf, ermesg)

  ! remove more particles than are added
  npa = 2
  allocate(positions_to_add(nd,npa))
  positions_to_add(1,:) = (/100.0, 200.0/)
  positions_to_add(2,:) = (/100.1, 200.1/)
  positions_to_add(3,:) = (/100.2, 200.2/)
  call drifters_core_remove_and_add(drf, (/2, 6, 1/), &
     & (/ 1001, 1002 /), &
     & positions_to_add, &
     & ermesg)
  if(ermesg/='') print *,ermesg
  call drifters_core_print(drf, ermesg)
  deallocate(positions_to_add)

  ! add more particles than are removed
  npa = 3
  allocate(positions_to_add(nd,npa))
  positions_to_add(1,:) = (/1000.0, 2000.0, 3000.0/)
  positions_to_add(2,:) = (/1000.1, 2000.1, 3000.1/)
  positions_to_add(3,:) = (/1000.2, 2000.2, 3000.2/)
  call drifters_core_remove_and_add(drf, (/3,1/), &
     & (/ 1003, 1004, 1005 /), &
     & positions_to_add,  &
     & ermesg)
  if(ermesg/='') print *,ermesg
  call drifters_core_print(drf, ermesg)
  deallocate(positions_to_add)
  
  ! add particles requiring resizing
  npa = 10
  allocate(positions_to_add(nd,npa))
  positions_to_add(1,:) = (/100.0, 200.0, 300.0, 400.0, 500.0, 600.0, 700.0, 800.0, 900.0, 10000.0/)
  positions_to_add(2,:) = (/100.1, 200.1, 300.1, 400.1, 500.1, 600.1, 700.1, 800.1, 900.1, 10000.1/)
  positions_to_add(3,:) = (/100.2, 200.2, 300.2, 400.2, 500.2, 600.2, 700.2, 800.2, 900.2, 10000.2/)
  call drifters_core_remove_and_add(drf, (/3,1,5,2/), &
     & (/ (1010+i, i=1,npa) /), &
     & positions_to_add,  &
     & ermesg)
  if(ermesg/='') print *,ermesg
  call drifters_core_print(drf, ermesg)
  deallocate(positions_to_add)

!!$  call test_circle(ier)
!!$  !call test_3d(ier)
!!$
!!$  if(ier/=0) then
!!$     print *,'Test unit failed ier=', ier
!!$  else
!!$     print *,'Sucessful test ier=', ier
!!$  end if

end program test


#endif

module block_control_mod
#include <fms_platform.h>

use mpp_mod,         only: mpp_error, NOTE, FATAL
use mpp_domains_mod, only: mpp_compute_extent

 public block_control_type
 type block_control_type
   integer :: nx_block, ny_block
   integer :: nblks
   integer :: isc, iec, jsc, jec
   integer :: npz
   integer, dimension(:), _ALLOCATABLE :: ibs _NULL, &
                                          ibe _NULL, &
                                          jbs _NULL, &
                                          jbe _NULL
 end type block_control_type

public :: define_blocks

contains

!----------------------------------------------------------------------
! set up "blocks" used for OpenMP threading of column-based
! calculations using rad_n[x/y]xblock from coupler_nml
!---------------------------------------------------------------------
  subroutine define_blocks (component, Block, isc, iec, jsc, jec, kpts, &
                            nx_block, ny_block, message)
    character(len=*),         intent(in)    :: component
    type(block_control_type), intent(inout) :: Block
    integer,                  intent(in)    :: isc, iec, jsc, jec, kpts
    integer,                  intent(in)    :: nx_block, ny_block
    logical,                  intent(inout) :: message
!--- local variables
    integer :: blocks
    integer, dimension(nx_block) :: i1, i2
    integer, dimension(ny_block) :: j1, j2
    character(len=132) :: text
    integer :: i, j, nblks

    if (message) then
      if ((mod(iec-isc+1,nx_block) .ne. 0) .or. (mod(jec-jsc+1,ny_block) .ne. 0)) then
        write( text,'(a,a,2i4,a,2i4,a)' ) trim(component),'define_blocks: domain (',&
             (iec-isc+1), (jec-jsc+1),') is not an even divisor with definition (',&
             nx_block, ny_block,') - blocks will not be uniform'
        call mpp_error( NOTE, trim(text) )
      endif
      message = .false.
    endif

!--- set up blocks
    if (iec-isc+1 .lt. nx_block) &
        call mpp_error(FATAL, 'block_control: number of '//trim(component)//' nxblocks .gt. &
                             &number of elements in MPI-domain size')
    if (jec-jsc+1 .lt. ny_block) &
        call mpp_error(FATAL, 'block_control: number of '//trim(component)//' nyblocks .gt. &
                             &number of elements in MPI-domain size')
    call mpp_compute_extent(isc,iec,nx_block,i1,i2)
    call mpp_compute_extent(jsc,jec,ny_block,j1,j2)

    nblks = nx_block*ny_block
    Block%isc = isc
    Block%iec = iec
    Block%jsc = jsc
    Block%jec = jec
    Block%npz = kpts
    Block%nx_block = nx_block
    Block%ny_block = ny_block
    Block%nblks = nblks

    if (.not._ALLOCATED(Block%ibs)) &
         allocate (Block%ibs(nblks), &
                   Block%ibe(nblks), &
                   Block%jbs(nblks), &
                   Block%jbe(nblks))

    blocks=0
    do j = 1, ny_block
      do i = 1, nx_block
        blocks = blocks + 1
        Block%ibs(blocks) = i1(i)
        Block%jbs(blocks) = j1(j)
        Block%ibe(blocks) = i2(i)
        Block%jbe(blocks) = j2(j)
      enddo
    enddo

  end subroutine define_blocks

end module block_control_mod

module tridiagonal_mod

! <CONTACT EMAIL="Isaac.Held@noaa.gov">
!    Isaac Held 
! </CONTACT>
! <CONTACT EMAIL="Bruce.Wyman@noaa.gov">
!    Bruce Wyman
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!   Solves the tridiagonal system of equations.
! </OVERVIEW>
! <DESCRIPTION>
!     The following schematic represents the system of equations solved,
!     where X is the solution.
! <PRE> 
!     | B(1)  A(1)   0     0                .......            0    |  |X(1)|   |D(1)|
!     | C(2)  B(2)  A(2)   0                .......            0    |  |X(2)|   |D(2)|
!     |  0    C(3)  B(3)  A(3)  0           .......            0    |  | .. |   | .. |
!     |  ..........................................                 |  | .. | = | .. |
!     |  ..........................................                 |  | .. |   | .. |
!     |                                  C(N-2) B(N-2) A(N-2)  0    |  | .. |   | .. |
!     |                                    0    C(N-1) B(N-1) A(N-1)|  | .. |   | .. |
!     |                                    0      0    C(N)   B(N)  |  |X(N)|   |D(N)|
! 
! </PRE>
!  To solve this system 
! <PRE>
!   call tri_invert(X,D,A,B,C)
!
!       real, intent(out), dimension(:,:,:) :: X
!       real, intent(in),  dimension(:,:,:) :: D
!       real, optional,    dimension(:,:,:) :: A,B,C
! </PRE>
! For simplicity (?), A and C are assumed to be dimensioned the same size 
! as B, D, and X, although any input values for A(N) and C(1) are ignored.
! (some checks are needed here)
!
! If A is not present, it is assumed that the matrix (A,B.C) has not been changed 
! since the last call to tri_invert.
!
! To release memory, 
! <PRE>
!    call close_tridiagonal
! </PRE>
! The following module variables are used to retain the relevant information
! if one recalls tri_invert without changing (A,B,C)


! </DESCRIPTION>

!--------------------------------------------------------------------------
real,    private, allocatable, dimension(:,:,:) :: e,g,cc
real,    private, allocatable, dimension(:,:)   :: bb
logical, private :: init_tridiagonal = .false.
!--------------------------------------------------------------------------

contains

!--------------------------------------------------------------------------

! <SUBROUTINE NAME="tri_invert">

!   <OVERVIEW>
!     Sets up and solves the tridiagonal system of equations.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Sets up and solves the tridiagonal system of equations.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call tri_invert ( x,d,a,b,c)
!   </TEMPLATE>

!   <IN NAME="d" TYPE="real" DIM="(:,:,:)">
!     The right-hand side term, see the schematic above.
!   </IN>
!   <OUT NAME="x" TYPE="real" DIM="(:,:,:)">
!     The solution to the tridiagonal system of equations.
!   </OUT>
!   <INOUT NAME="a,b,c" TYPE="real" DIM="(:,:,:)">
!     The left-hand-side terms (matrix), see the schematic above.
!             If A is not present, it is assumed that the matrix (A,B.C)
!             has not been changed since the last call to tri_invert.
!   </INOUT>

!   <NOTE>
!      For simplicity, A and C are assumed to be dimensioned the same size
!      as B, D, and X, although any input values for A(N) and C(1) are ignored.
!      There are no checks to make sure the sizes agree.
!   </NOTE>
!   <NOTE>
!      The value of A(N) is modified on output, and B and C are unchanged.
!   </NOTE>

subroutine tri_invert(x,d,a,b,c)

implicit none

real, intent(out), dimension(:,:,:) :: x
real, intent(in),  dimension(:,:,:) :: d
real, optional,    dimension(:,:,:) :: a,b,c

real, dimension(size(x,1),size(x,2),size(x,3)) :: f
integer :: k

if(present(a)) then
  init_tridiagonal = .true.

  if(allocated(e))     deallocate(e)
  if(allocated(g))     deallocate(g)
  if(allocated(bb))    deallocate(bb)
  if(allocated(cc))    deallocate(cc)
  allocate(e (size(x,1),size(x,2),size(x,3)))
  allocate(g (size(x,1),size(x,2),size(x,3)))
  allocate(bb(size(x,1),size(x,2)))
  allocate(cc(size(x,1),size(x,2),size(x,3)))
  
  e(:,:,1) = - a(:,:,1)/b(:,:,1)
  a(:,:,size(x,3)) = 0.0

  do  k= 2,size(x,3)
    g(:,:,k) = 1.0/(b(:,:,k)+c(:,:,k)*e(:,:,k-1))
    e(:,:,k) = - a(:,:,k)*g(:,:,k)
  end do
  cc = c
  bb = 1.0/b(:,:,1)

end if

! if(.not.init_tridiagonal) error

f(:,:,1) =  d(:,:,1)*bb
do k= 2, size(x,3)
  f(:,:,k) = (d(:,:,k) - cc(:,:,k)*f(:,:,k-1))*g(:,:,k)
end do

x(:,:,size(x,3)) = f(:,:,size(x,3))
do k = size(x,3)-1,1,-1
  x(:,:,k) = e(:,:,k)*x(:,:,k+1)+f(:,:,k)
end do

return
end subroutine tri_invert
! </SUBROUTINE>

!-----------------------------------------------------------------

! <SUBROUTINE NAME="close_tridiagonal">

!   <OVERVIEW>
!     Releases memory used by the solver.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Releases memory used by the solver.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call close_tridiagonal
!   </TEMPLATE>

!   <NOTE>
!     There are no arguments to this routine.
!   </NOTE>

subroutine close_tridiagonal

implicit none

deallocate(e)
deallocate(g)
deallocate(bb)
deallocate(cc)

return
end subroutine close_tridiagonal
! </SUBROUTINE>

!----------------------------------------------------------------



end module tridiagonal_mod

! <INFO>

!   <BUG>
!     Optional arguments A,B,C have no intent declaration,
!     so the default intent is inout. The value of A(N) is modified
!     on output, and B and C are unchanged.                  
!   </BUG>
!   <NOTE>
!       The following private allocatable arrays save the relevant information
!  if one recalls tri_invert without changing (A,B,C):
!  <PRE>
!        allocate ( e  (size(x,1), size(x,2), size(x,3)) )
!        allocate ( g  (size(x,1), size(x,2), size(x,3)) )
!        allocate ( cc (size(x,1), size(x,2), size(x,3)) )
!        allocate ( bb (size(x,1), size(x,2)) )
! </PRE>
!  This storage is deallocated when close_tridiagonal is called.
!   </NOTE>
!   <FUTURE>
!     Maybe a cleaner version?
!   </FUTURE>

! </INFO>

module ocean_blob_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="m.bates@student.unsw.edu.au"> Michael L. Bates
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! This is the main "driver" module for the Lagrangian blob scheme.  This
! module calls other modules that contain the individual parameterisations.
!
! Please note that the preprocessor option MOM_STATIC_ARRAYS is NOT
! supported.  This is because to run a model where the memeory statically
! allocated without the blob framework will incur a large, unnecessary
! increase in memory requirements.
!</OVERVIEW>
!
!<DESCRIPTION>
! This module is the top-level module of the Lagrangian blob framework.
! It calls routines to form blobs, to integrate their properties, to
! transfer them from one dynamic regime to another, and also calculates
! the L system contribution towards grid cell thickness.
!
! This module also handles some framework wide variables, mostly
! associated with system wide diagnostics and the system wide accounting
! required to ensure the Eulerian model and the Lagrangian model can coexist.
!
! It should be noted that many of the parameterisations are not mutually
! exclusive.  As such, care should be excercised when creating namelists
! for experiments.
!</DESCRIPTION>
!
!<INFO>
!
! <REFERENCE>
! S.M. Griffies, Elements of MOM4p1 (2009)
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
!</INFO>
!<NAMELIST NAME="ocean_blob_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module.
!  Default is use_this_module=.false.
!  </DATA>
!
!  <DATA NAME="debug_this_module" TYPE="logical">
!  Writes additional diagnostic data to fms.out.  This
!  also controls debug output for the other related blob
!  modules.
!  Default is debug_this_module=.false.
!  </DATA>
!
!  <DATA NAME="really_debug" TYPE="logical">
!  Be careful what you wish for, this outputs A LOT of
!  diagnostics to standard out!
!  Default is debug_this_module=.false.
!  </DATA>
!
!  <DATA NAME="do_bitwise_exact_sum" TYPE="logical">
!  When global sum outputs are done there is additional
!  computational expense to ensure that they are bitwise
!  the same across an arbitrary number of processors.
!  However, for debugging purposes, it can be useful
!  for global sums to be the same.  Note, that this differs
!  from bitwise_reproduction in that it do_bitwise_exact_sum
!  only applies to the mpp_global_sum diagnostic.
!  Note that this flag controls the output for all associated
!  blob modules.
!  Default is do_bitwise_exact_sum=.false.
!  </DATA>
!
!  <DATA NAME="bitwise_reproduction" TYPE="logical">
!  There is additional cost involved in ensuring that
!  results are reproducable across an arbitrary number of
!  processors and across restarts.
!  Bitwise reproduction is a very memory intensive operation and should
!  only be used for debugging.  For bitwise_reproduction=.true. We need
!  to process blobs and their histories in the same relative order
!  regardless of domain decomposition and restarts. To do so, we save the
!  "history" of each blob subcycle is saved to a number of arrays (which
!  can be a very memory intensive process) and process them in order.
!  Note that this flag controls reproducability for all associated
!  blob modules.
!  Bitwise reproducibility is only possible with the appropriate
!  compiler flags AND when the simulation is run on hardware that is
!  capable of producing bitwise reproduction.
!  Default is bitwise_reproduction=.false.
!  </DATA>
!
!  <DATA NAME="blob_small_mass" UNITS="kg" TYPE="real">
!  Will delete blobs of mass less than blob_small_mass.
!  Note that this variable is for all associated blob
!  modules.  The deletion of blobs is a conservative
!  action, any mass/tracer fields that are nonzero
!  have the remaining properties transferred back to the
!  Eulerian system.  So, in principle, blob_small_mass
!  can actually be a relatively large number, and the
!  model will remain conservative.  It has been found in
!  certain test cases (with very low tracer values) that
!  setting blob_small_mass to be very small (i.e. <1e2)
!  that roundoff error can cause non-trivial errors.  So,
!  it is recommended that blob_small_mass be no smaller than
!  than 1e3 kg (which is approximately 1.0m**3 -- a very small
!  blob!)
!  Default is blob_small_mass=1.e3
!  </DATA>
!
!  <DATA NAME="mass_prop_thickness" UNITS="dimensionless" TYPE="real">
!  Sets the maximum proportion of a grid cell that the
!  Lagrangian system may occupy.  This is actually calculated
!  separately (and therefore must be satisfied separately) for
!  the uppper and lower portions of a grid cell.
!  Default is blob_small_mass=0.7
!  </DATA>
!
!</NAMELIST>
!
use constants_mod,   only: epsln
use diag_manager_mod,only: register_diag_field, send_data
use fms_mod,         only: open_namelist_file, check_nml_error, file_exist
use fms_mod,         only: write_version_number, close_file, stderr
use fms_mod,         only: mpp_error, FATAL, WARNING, stdout, stdlog
use fms_io_mod,      only: register_restart_field, save_restart
use fms_io_mod,      only: restore_state, restart_file_type
use mpp_domains_mod, only: mpp_update_domains, BGRID_NE
use mpp_domains_mod, only: mpp_get_neighbor_pe, NORTH, SOUTH, EAST, WEST
use mpp_domains_mod, only: NORTH_EAST, NORTH_WEST, SOUTH_EAST, SOUTH_WEST
use mpp_domains_mod, only: BITWISE_EXACT_SUM, NON_BITWISE_EXACT_SUM
use mpp_mod,         only: mpp_pe, mpp_sum, CLOCK_ROUTINE, NULL_PE
use mpp_mod,         only: mpp_clock_id, mpp_clock_begin, mpp_clock_end

use ocean_blob_diag_mod,           only: blob_diag_init, blob_diag, blob_diag_end
use ocean_blob_dynamic_bottom_mod, only: blob_dynamic_bottom_init, blob_dynamic_bottom_update
use ocean_blob_dynamic_bottom_mod, only: transfer_free_to_bottom, dynamic_bottom_form_new
use ocean_blob_dynamic_bottom_mod, only: blob_dynamic_bottom_end
use ocean_blob_dynamic_free_mod,   only: blob_dynamic_free_init, blob_dynamic_free_implicit
use ocean_blob_dynamic_free_mod,   only: blob_dynamic_free_update, transfer_bottom_to_free
use ocean_blob_dynamic_free_mod,   only: blob_dynamic_free_end
use ocean_blob_static_free_mod,    only: blob_static_free_init, blob_static_free
use ocean_blob_static_free_mod,    only: blob_static_free_end
use ocean_blob_static_bottom_mod,  only: blob_static_bottom_init, blob_overflow_like
use ocean_blob_static_bottom_mod,  only: blob_static_bottom_end
use ocean_blob_util_mod,           only: inq_var, get_int, get_double, def_var
use ocean_blob_util_mod,           only: blob_util_init, E_and_L_totals, blob_util_end
use ocean_blob_util_mod,           only: blob_chksum, blob_delete, put_att, put_double
use ocean_blob_util_mod,           only: put_int, insert_blob, lagrangian_system_chksum
use ocean_blob_util_mod,           only: write_blobs, kill_blob, free_blob_memory
use ocean_blob_util_mod,           only: allocate_interaction_memory
use ocean_density_mod,             only: density, compute_buoyfreq
use ocean_domains_mod,             only: set_ocean_domain
use ocean_parameters_mod,          only: grav, rho0, rho0r, DEPTH_BASED, GEOPOTENTIAL, ZSIGMA
use ocean_parameters_mod,          only: PRESSURE, PSIGMA, ZSTAR, PSTAR
use ocean_types_mod,               only: ocean_time_type, ocean_grid_type, blob_diag_type
use ocean_types_mod,               only: ocean_domain_type, ocean_options_type
use ocean_types_mod,               only: ocean_density_type, ocean_lagrangian_type
use ocean_types_mod,               only: ocean_prog_tracer_type, ocean_thickness_type
use ocean_types_mod,               only: ocean_blob_type, blob_grid_type, ocean_adv_vel_type
use ocean_types_mod,               only: ocean_external_mode_type, ocean_velocity_type
use ocean_util_mod,                only: write_timestamp, diagnose_3d, write_chksum_2d, write_chksum_3d, write_chksum_3d_int
use ocean_workspace_mod,           only: wrk1

implicit none

include 'netcdf.inc'

private

! set up the various module specific types

! set module types
type(ocean_grid_type),   pointer :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_blob_type),   pointer :: head_dynamic_free => NULL()
type(ocean_blob_type),   pointer :: head_dynamic_bott => NULL()
type(ocean_blob_type),   pointer :: head_static_free  => NULL()
type(ocean_blob_type),   pointer :: head_static_bott  => NULL()
type(blob_grid_type),    pointer :: Info

! The special blob domain type for the extended halo
type(ocean_domain_type), save :: Blob_domain

! general module variables
integer :: num_prog_tracers=0
integer :: index_temp=-1
integer :: index_salt=-1
integer :: vert_coordinate       ! tye type of vertical coordinate
integer :: vert_coordinate_class ! the class of vertical coordinate
integer :: global_sum_flag
integer :: isd,ied,jsd,jed
integer :: isc,iec,jsc,jec
integer :: isg,ieg,jsg,jeg
integer :: isbd, iebd, jsbd, jebd
integer :: nk
logical :: blob_diagnostics, use_dyn_fre, use_dyn_bot
real    :: free_minstep, bott_minstep
integer :: free_total_ns, bott_total_ns
integer, parameter :: file_format_major_version=0
integer, parameter :: file_format_minor_version=1
integer, allocatable, dimension(:,:,:) :: blob_counter
real,    allocatable, dimension(:,:)   :: datdtimer

!for restart
type(restart_file_type), save :: gridded_restart

! CVS stuff
character(len=128)  :: version = '$$'
character (len=128) :: tagname = '$Name: tikal $'

! initialisation
logical :: module_is_initialized=.false.
logical :: use_this_module

! identification numbers for mpp clocks
integer :: id_clock_static_bottom
integer :: id_clock_static_free
integer :: id_clock_dyn_free_implicit
integer :: id_clock_dyn_free_update
integer :: id_clock_dyn_bott_update
integer :: id_clock_tsfr_f2b
integer :: id_clock_dyn_bott_new

! gridded diagnostic fields
real, allocatable, dimension(:,:,:) :: mass_in
real, allocatable, dimension(:,:,:) :: mass_out

! identification for gridded diagnostic fields
integer, allocatable, dimension(:) :: id_tend_blob
integer, allocatable, dimension(:) :: id_entrainment
integer, allocatable, dimension(:) :: id_detrainment
integer, allocatable, dimension(:) :: id_new
integer, allocatable, dimension(:) :: id_dstry
integer :: id_prop_cell_mass
integer :: id_mass_in
integer :: id_mass_out
integer :: id_dstryd
integer :: id_grounded
integer :: id_surfaced
integer :: id_detraind
integer :: id_nblob_free
integer :: id_nblob_bott

logical :: used

! set the public subroutines
public ocean_blob_init
public ocean_blob_update
public update_L_thickness
public calculate_rhoT
public ocean_blob_implicit
public ocean_blob_diagnose_depth
public ocean_blob_end
public init_blob_thickness
public adjust_L_thickness
public write_all_blobs
public ocean_blob_cell_update

! namelist variables and default values
logical :: debug_this_module   =.false.  ! extra output for debugging
logical :: really_debug        =.false.  ! lots of extra output for debuugging
logical :: do_bitwise_exact_sum=.false.  ! bitwise exact sums for global sums?
logical :: bitwise_reproduction=.false.  ! bitwise reproduction of results
real    :: blob_small_mass     = 1.0e3   ! minimum mass for a blob to exist (kg)
real    :: max_prop_thickness  = 0.7     ! maximum proportion of a grid cell that the L system may occupy (non-dimensional)

namelist /ocean_blob_nml/ blob_small_mass, debug_this_module, really_debug, &
                          do_bitwise_exact_sum, bitwise_reproduction,       &
                          max_prop_thickness

contains


!######################################################################
! <SUBROUTINE NAME="ocean_blob_init">
!
! <DESCRIPTION>
! Initialises the Lagrangian blob module by setting up module wide
! variables and calling initialisation scripts for the related modules,
! as well as the Lagrangian system itself.
!
! Infrastructure for communicating between PE's, interpolation of E
! system variables to a blob, communicating model wide namelist values
! and variables to other modules and picking up restarts is all done.
! </DESCRIPTION>
!
subroutine ocean_blob_init (Grid, Domain, Time, T_prog, Dens, Thickness,   &
                            L_system, Ext_mode, EL_diag, Ocean_options,    &
                            dtimein, ver_coordinate_class, ver_coordinate, &
                            use_blobs, introduce_blobs)

  type(ocean_grid_type),          intent(in), target :: Grid
  type(ocean_domain_type),        intent(in), target :: Domain
  type(ocean_time_type),          intent(in)         :: Time
  type(ocean_prog_tracer_type),   intent(inout)      :: T_prog(:)
  type(ocean_density_type),       intent(inout)      :: Dens
  type(ocean_thickness_type),     intent(inout)      :: Thickness
  type(ocean_lagrangian_type),    intent(inout)      :: L_system
  type(ocean_external_mode_type), intent(in)         :: Ext_mode
  type(blob_diag_type),           intent(inout)      :: EL_diag(0:)
  type(ocean_options_type),       intent(inout)      :: Ocean_options
  real,                           intent(in)         :: dtimein
  integer,                        intent(in)         :: ver_coordinate_class
  integer,                        intent(in)         :: ver_coordinate
  logical,                        intent(in)         :: use_blobs
  logical,                        intent(in)         :: introduce_blobs

  integer :: nfstatus
  integer :: m, n, i, j, k
  integer :: ioun, ierr, io_status
  integer :: stdoutunit,stdlogunit,stderrunit
  integer :: taup1

  stdoutunit=stdout(); stdlogunit=stdlog() ; stderrunit=stderr()

  taup1 = Time%taup1

  if ( module_is_initialized ) then
    call mpp_error(FATAL,&
    '==>Error in ocean_blob_mod (ocean_blob_init): module already '&
    //'initialized')
  endif

  ! provide for namelist over-ride of default values
  ioun =  open_namelist_file()
  read (ioun,ocean_blob_nml,IOSTAT=io_status)
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_blob_nml)
  write (stdlogunit,ocean_blob_nml)
  ierr = check_nml_error(io_status,'ocean_blob_nml')
  call close_file (ioun)

  module_is_initialized = .true.

  use_this_module = use_blobs

  if (.not. use_this_module) then
     write(stdoutunit,'(a)') &
          '==>Note: NOT using the Lagrangian buoyancy blobs scheme.'
     Ocean_options%lagrangian_blobs = 'Did NOT use Lagrangian blobs.'
     return
  endif

#ifdef MOM_STATIC_ARRAYS
  write(stderrunit,'(2a)') '==>Error: MOM_STATIC_ARRAYS preprocessor option chosen with use_blobs=.true.', &
       'use_blobs=.true. is not supported with static array allocation'
  call mpp_error(FATAL, &
     '==>Error: MOM_STATIC_ARRAYS preprocessor option chosen with use_blobs=.true. ')

#endif

  if (introduce_blobs .and. Time%init) then
     call mpp_error(WARNING,&
          'introduce_blobs=.TRUE. and Time%init=.TRUE.: introduce_blobs is only for introducing blobs '//&
          'to an existing run. introduce_blobs should usually be .FALSE. if starting from initial '//&
          'conditions.')
  endif
  if (bitwise_reproduction) then
     write(stdoutunit,'(a,2(/,a))')                                                                 &
          '==>Note: bitwise_reproduction=.true. in ocean_blob_nml',                                 &
          '   This is a VERY memory intensive condition.  YOU WILL PROBABLY RUN OUT OF MEMORY!',    &
          '   Unless you require bitwise reproducability for debugging purposes, it is STRONGLY '// &
          'recommended that you set bitwise_reproduction=.false.'
     call mpp_error(WARNING, &
         'bitwise_reproduction=.true., adds heaps to model cost; it is meant only for debugging.')
  endif

  Grd => Grid
  Dom => Domain

  isd=Dom%isd; ied=Dom%ied; jsd=Dom%jsd; jed=Dom%jed
  isc=Dom%isc; iec=Dom%iec; jsc=Dom%jsc; jec=Dom%jec
  isg=Dom%isg; ieg=Dom%ieg; jsg=Dom%jsg; jeg=Dom%jeg
  nk = Grd%nk

  ! For the dynamic blobs, we need to have a halo of size 2
  ! to be able to do the interpolation is implemented here
  call set_ocean_domain(Blob_domain, Grid, xhalo=2, yhalo=2, &
                        name='blobs', maskmap=Dom%maskmap)
  isbd=Blob_domain%isd; iebd=Blob_domain%ied
  jsbd=Blob_domain%jsd; jebd=Blob_domain%jed

  ! Allocate memory to an Information type
  allocate(Info)
  call mpp_get_neighbor_pe(Dom%domain2d, NORTH,      Info%pe_N)
  call mpp_get_neighbor_pe(Dom%domain2d, SOUTH,      Info%pe_S)
  call mpp_get_neighbor_pe(Dom%domain2d, EAST,       Info%pe_E)
  call mpp_get_neighbor_pe(Dom%domain2d, WEST,       Info%pe_W)
  call mpp_get_neighbor_pe(Dom%domain2d, NORTH_EAST, Info%pe_NE)
  call mpp_get_neighbor_pe(Dom%domain2d, NORTH_WEST, Info%pe_NW)
  call mpp_get_neighbor_pe(Dom%domain2d, SOUTH_EAST, Info%pe_SE)
  call mpp_get_neighbor_pe(Dom%domain2d, SOUTH_WEST, Info%pe_SW)
  Info%pe_this = mpp_pe()
  Info%nk_nj = nk*Grd%nj

  ! Variables required for interpolation
  allocate(Info%it(9))
  allocate(Info%jt(9))
  allocate(Info%iu(4))
  allocate(Info%ju(4))
  !1: (i,j), 2: (i+1,j), 3: (i+1,j+1) 4: (i,j+1), 5: (i-1,j+1)
  !          6: (i-1,j), 7: (i-1,j-1), 8:(i,j-1), 9: (i+1,j-1)
  m=1; Info%it(m)= 0; Info%jt(m)= 0
  m=2; Info%it(m)= 1; Info%jt(m)= 0
  m=3; Info%it(m)= 1; Info%jt(m)= 1
  m=4; Info%it(m)= 0; Info%jt(m)= 1
  m=5; Info%it(m)=-1; Info%jt(m)= 1
  m=6; Info%it(m)=-1; Info%jt(m)= 0
  m=7; Info%it(m)=-1; Info%jt(m)=-1
  m=8; Info%it(m)= 0; Info%jt(m)=-1
  m=9; Info%it(m)= 1; Info%jt(m)=-1

  !1: (i,j), 2: (i-1,j), 3: (i-1,j-1), 4:(i,j-1)
  m=1; Info%iu(m)= 0; Info%ju(m)= 0
  m=2; Info%iu(m)=-1; Info%ju(m)= 0
  m=3; Info%iu(m)=-1; Info%ju(m)=-1
  m=4; Info%iu(m)= 0; Info%ju(m)=-1

  allocate(Info%ht(isbd:iebd,jsbd:jebd,2))
  allocate(Info%hu(isbd:iebd,jsbd:jebd,2))
  Info%ht(isc:iec,jsc:jec,1) = Grd%h1t(isc:iec,jsc:jec)
  Info%ht(isc:iec,jsc:jec,2) = Grd%h2t(isc:iec,jsc:jec)
  Info%hu(isc:iec,jsc:jec,1) = Grd%h1u(isc:iec,jsc:jec)
  Info%hu(isc:iec,jsc:jec,2) = Grd%h2u(isc:iec,jsc:jec)
  call mpp_update_domains(Info%ht(:,:,1), Blob_domain%domain2d, complete=.false.)
  call mpp_update_domains(Info%ht(:,:,2), Blob_domain%domain2d, complete=.false.)
  call mpp_update_domains(Info%hu(:,:,1), Blob_domain%domain2d, complete=.false.)
  call mpp_update_domains(Info%hu(:,:,2), Blob_domain%domain2d, complete=.true.)

  ! Arrays that are needed for the horizontal interpolation scheme
  ! to handle solid wall boundaries
  allocate(Info%tidx(0:9,isbd:iebd,jsbd:jebd))
  allocate(Info%uidx(0:4,isbd:iebd,jsbd:jebd))
  ! Index 0 of the first dimension says how many of the surrounding
  ! cells are used in the interpolation.  9 cells for T grid variables
  ! and 4 cells for U grid variables.
  Info%tidx(0,:,:) = 9
  Info%uidx(0,:,:) = 4

  ! The rest of the dimension lists the index of which cells participate
  ! as described below.
  ! Info%tidx:
  !1: (i,j), 2: (i+1,j), 3: (i+1,j+1) 4: (i,j+1), 5: (i-1,j+1)
  !          6: (i-1,j), 7: (i-1,j-1), 8:(i,j-1), 9: (i+1,j-1)
  ! Info%uidx:
  !1: (i,j), 2: (i-1,j), 3: (i-1,j-1), 4:(i,j-1)
  do m=1,4
     Info%tidx(m,:,:) = m
     Info%uidx(m,:,:) = m
  enddo
  do m=5,9
     Info%tidx(m,:,:) = m
  enddo

  ! Now for the exceptions at solid boundaries
  ! We pad the rest of the first dimension with zeros
  ! for values that are unused.

  ! Firstly, do the edges of the compute domain
  if (Info%pe_E==NULL_PE) then
     Info%uidx(0,iec,:) = 2
     Info%tidx(0,iec,:) = 6

     Info%uidx(1,  iec,:) = 2
     Info%uidx(2,  iec,:) = 3
     Info%uidx(3:4,iec,:) = 0

     Info%tidx(1,  iec,:) = 1
     Info%tidx(2,  iec,:) = 4
     Info%tidx(3,  iec,:) = 5
     Info%tidx(4,  iec,:) = 6
     Info%tidx(5,  iec,:) = 7
     Info%tidx(6,  iec,:) = 8
     Info%tidx(7:9,iec,:) = 0
  endif
  if (Info%pe_N==NULL_PE) then
     Info%uidx(0,:,jec) = 2
     Info%tidx(0,:,jec) = 6

     Info%uidx(1,  :,jec) = 3
     Info%uidx(2,  :,jec) = 4
     Info%uidx(3:4,:,jec) = 0

     Info%tidx(1,  :,jec) = 1
     Info%tidx(2,  :,jec) = 2
     Info%tidx(3,  :,jec) = 6
     Info%tidx(4,  :,jec) = 7
     Info%tidx(5,  :,jec) = 8
     Info%tidx(6,  :,jec) = 9
     Info%tidx(7:9,:,jec) = 0
  endif
  if (Info%pe_W==NULL_PE) then
     Info%uidx(0,isc,:) = 2
     Info%tidx(0,isc,:) = 6

     Info%uidx(1,  isc,:) = 1
     Info%uidx(2,  isc,:) = 4
     Info%uidx(3:4,isc,:) = 0

     Info%tidx(1,  isc,:) = 1
     Info%tidx(2,  isc,:) = 2
     Info%tidx(3,  isc,:) = 3
     Info%tidx(4,  isc,:) = 4
     Info%tidx(5,  isc,:) = 8
     Info%tidx(6,  isc,:) = 9
     Info%tidx(7:9,isc,:) = 0
  endif
  if (Info%pe_S==NULL_PE) then
     Info%uidx(0,:,jsc) = 2
     Info%tidx(0,:,jsc) = 6

     Info%uidx(1,  :,jsc) = 1
     Info%uidx(2,  :,jsc) = 2
     Info%uidx(3:4,:,jsc) = 0

     Info%tidx(1,  :,jsc) = 1
     Info%tidx(2,  :,jsc) = 2
     Info%tidx(3,  :,jsc) = 3
     Info%tidx(4,  :,jsc) = 4
     Info%tidx(5,  :,jsc) = 5
     Info%tidx(6,  :,jsc) = 6
     Info%tidx(7:9,:,jsc) = 0
  endif

  ! Then, do the corners
  if (Info%pe_N==NULL_PE .and. Info%pe_E==NULL_PE) then
     Info%uidx(0,iec,jec) = 1
     Info%tidx(0,iec,jec) = 4

     Info%uidx(1,  iec,jec) = 3
     Info%uidx(2:4,iec,jec) = 0

     Info%tidx(1,  iec,jec) = 1
     Info%tidx(2,  iec,jec) = 6
     Info%tidx(3,  iec,jec) = 7
     Info%tidx(4,  iec,jec) = 8
     Info%tidx(5:9,iec,jec) = 0
  endif
  if (Info%pe_N==NULL_PE .and. Info%pe_W==NULL_PE) then
     Info%uidx(0,isc,jec) = 1
     Info%tidx(0,isc,jec) = 4

     Info%uidx(1,  isc,jec) = 4
     Info%uidx(2:4,isc,jec) = 0

     Info%tidx(1,  isc,jec) = 1
     Info%tidx(2,  isc,jec) = 2
     Info%tidx(3,  isc,jec) = 8
     Info%tidx(4,  isc,jec) = 9
     Info%tidx(5:9,isc,jec) = 0
  endif
  if (Info%pe_S==NULL_PE .and. Info%pe_W==NULL_PE) then
     Info%uidx(0,isc,jsc) = 1
     Info%tidx(0,isc,jsc) = 4

     Info%uidx(1,  isc,jsc) = 1
     Info%uidx(2:4,isc,jsc) = 0

     Info%tidx(1,  isc,jsc) = 1
     Info%tidx(2,  isc,jsc) = 2
     Info%tidx(3,  isc,jsc) = 3
     Info%tidx(4,  isc,jsc) = 4
     Info%tidx(5:9,isc,jsc) = 0
  endif
  if (Info%pe_S==NULL_PE .and. Info%pe_E==NULL_PE) then
     Info%uidx(0,iec,jsc) = 1
     Info%tidx(0,iec,jsc) = 4

     Info%uidx(1,  iec,jsc) = 2
     Info%uidx(2:4,iec,jsc) = 0

     Info%tidx(1,  iec,jsc) = 1
     Info%tidx(2,  iec,jsc) = 4
     Info%tidx(3,  iec,jsc) = 5
     Info%tidx(4,  isc,jsc) = 6
     Info%tidx(5:9,iec,jsc) = 0
  endif

  ! Then, zero out the halos that are solid boundaries
  if (Info%pe_E==NULL_PE) then
     Info%uidx(:,ied:iebd,jsc:jec) = 0
     Info%tidx(:,ied:iebd,jsc:jec) = 0
  endif
  if (Info%pe_N==NULL_PE) then
     Info%uidx(:,isc:iec,jed:jebd) = 0
     Info%tidx(:,isc:iec,jed:jebd) = 0
  endif
  if (Info%pe_W==NULL_PE) then
     Info%uidx(:,isbd:isd,jsc:jec) = 0
     Info%tidx(:,isbd:isd,jsc:jec) = 0
  endif
  if (Info%pe_S==NULL_PE) then
     Info%uidx(:,isc:iec,jsbd:jsd) = 0
     Info%tidx(:,isc:iec,jsbd:jsd) = 0
  endif
  if (Info%pe_NE==NULL_PE) then
     Info%uidx(:,ied:iebd,jed:jebd) = 0
     Info%tidx(:,ied:iebd,jed:jebd) = 0
  endif
  if (Info%pe_NW==NULL_PE) then
     Info%uidx(:,isbd:isd,jed:jebd) = 0
     Info%tidx(:,isbd:isd,jed:jebd) = 0
  endif
  if (Info%pe_SW==NULL_PE) then
     Info%uidx(:,isbd:isd,jsbd:jsd) = 0
     Info%tidx(:,isbd:isd,jsbd:jsd) = 0
  endif
  if (Info%pe_SE==NULL_PE) then
     Info%uidx(:,ied:iebd,jsbd:jsd) = 0
     Info%tidx(:,ied:iebd,jsbd:jsd) = 0
  endif

  allocate(L_system%rho_dztup(isd:ied,jsd:jed,nk))
  allocate(L_system%rho_dztlo(isd:ied,jsd:jed,nk))
  allocate(L_system%conv_blob(isd:ied,jsd:jed,nk))

  L_system%rho_dztup(:,:,:) = 0.0
  L_system%rho_dztlo(:,:,:) = 0.0
  L_system%conv_blob(:,:,:) = 0.0

  allocate( datdtimer(isd:ied,jsd:jed) )
  datdtimer(:,:) = 1.0/(Grd%dat(:,:)*dtimein)

  num_prog_tracers  = size(T_prog(:))
  do n=1,num_prog_tracers
     if (T_prog(n)%name == 'temp') index_temp = n
     if (T_prog(n)%name == 'salt') index_salt = n
  enddo

  if (index_temp == -1 .or. index_salt == -1) then
     call mpp_error(FATAL, &
     '==>Error: temp and/or salt not identified in call to '&
     //'ocean_blobs_init')
  endif

  vert_coordinate       = ver_coordinate
  vert_coordinate_class = ver_coordinate_class

  if (vert_coordinate == GEOPOTENTIAL) then
     call mpp_error(FATAL, &
          '==>Error: blobs module has not had geopotential coordinates implemented fully: ocean_blobs_init')
  endif
  if (vert_coordinate == ZSIGMA) then
     call mpp_error(FATAL, &
          '==>Error: blobs module has not had zsigma coordinates implemented: ocean_blobs_init')
  endif
  if (vert_coordinate == PSIGMA) then
     call mpp_error(FATAL, &
          '==>Error: blobs module has not had psigma coordinates implemented: ocean_blobs_init')
  endif
  id_clock_static_bottom     = mpp_clock_id('(Ocean blob: static bottom)           ', grain=CLOCK_ROUTINE)
  id_clock_static_free       = mpp_clock_id('(Ocean blob: static free)             ', grain=CLOCK_ROUTINE)
  id_clock_dyn_free_implicit = mpp_clock_id('(Ocean blob: implicit dynamic free )  ', grain=CLOCK_ROUTINE)
  id_clock_dyn_free_update   = mpp_clock_id('(Ocean blob: update dynamic free )    ', grain=CLOCK_ROUTINE)
  id_clock_dyn_bott_update   = mpp_clock_id('(Ocean blob: update dynamic bottom )  ', grain=CLOCK_ROUTINE)
  id_clock_tsfr_f2b          = mpp_clock_id('(Ocean blob: transfer free to bottom )', grain=CLOCK_ROUTINE)
  id_clock_dyn_bott_new      = mpp_clock_id('(Ocean blob: form new dynamic bottom )', grain=CLOCK_ROUTINE)

  if(debug_this_module) then
     write(stdoutunit,'(a)') &
          '  ==>Note: running ocean_blobs_mod with debug_this_module=.true.'
  endif
  if(really_debug) then
     write(stdoutunit,'(a,/,a)') &
          '  ==>Note: running ocean_blobs_mod with really_debug=.true.',&
          '           Expect LOTS of output!!'
  endif

  if (do_bitwise_exact_sum) then
     global_sum_flag = BITWISE_EXACT_SUM
  else
     global_sum_flag = NON_BITWISE_EXACT_SUM
     if (debug_this_module) then
        write(stdoutunit,'(a)') &
             '==>Note: running ocean_blobs_mod with bitwise_flag=.false. '&
             //'Global sums used for diagnostics will not agree bitwise.'
     endif
  endif

  write(stdoutunit,'(a)') &
       '==>Note: Using the Lagrangian buoyancy blobs scheme.'
  Ocean_options%lagrangian_blobs = 'Did use Lagrangian blobs.'

  call write_version_number(version, tagname)

  ! Register diagnostic fields
  allocate(id_tend_blob(num_prog_tracers))
  do n=1,num_prog_tracers
     if (n==index_temp) then
        id_tend_blob(n) = register_diag_field('ocean_model', 'heat_LtoE', Grd%tracer_axes(1:3), &
             Time%model_time, 'heat transferred from the L to E systems', 'J')
     else
        id_tend_blob(n) = register_diag_field('ocean_model', trim(T_prog(n)%name)//'_LtoE', Grd%tracer_axes(1:3), &
             Time%model_time, trim(T_prog(n)%name)//' transferred from the L to E systems', 'kg')
     endif
  enddo
  id_prop_cell_mass = register_diag_field('ocean_model', 'prop_cell_mass', Grd%tracer_axes(1:3), &
       Time%model_time, 'proportion of grid cell mass taken by L system', 'dimensionless')
  id_mass_in  = register_diag_field('ocean_model', 'mass_in', Grd%tracer_axes(1:3), &
       Time%model_time, 'blob mass entering a grid cell', 'kg')
  id_mass_out = register_diag_field('ocean_model', 'mass_out', Grd%tracer_axes(1:3), &
       Time%model_time, 'blob mass exiting a grid cell', 'kg')
  id_dstryd   = register_diag_field('ocean_model', 'dstryd_blobs', Time%model_time, &
       'blobs destroyed because dztL>dztT', 'number of blobs')
  id_grounded = register_diag_field('ocean_model', 'grounded_blobs', Time%model_time, &
       'blobs destroyed due to grounding', 'number of blobs')
  id_surfaced = register_diag_field('ocean_model', 'surfaced_blobs', Time%model_time, &
       'blobs destroyed due to surfacing', 'number of blobs')
  id_detraind = register_diag_field('ocean_model', 'detrained_blobs', Time%model_time, &
       'blobs detrained to a small mass', 'number of blobs')
  id_nblob_free = register_diag_field('ocean_model', 'nblob_free', Time%model_time, &
       'number of dynamic free blobs')
  id_nblob_bott = register_diag_field('ocean_model', 'nblob_bott', Time%model_time, &
       'number of dynamic bottom blobs')

  ! Diagnostic arrays for mass convergence and divergence
  allocate(mass_in( isd:ied,jsd:jed,1:nk))
  allocate(mass_out(isd:ied,jsd:jed,1:nk))

  ! Diagnostic structure for transfer of properties between E and L systems
  allocate(id_entrainment(0:num_prog_tracers))
  allocate(id_detrainment(0:num_prog_tracers))
  allocate(id_new(        0:num_prog_tracers))
  allocate(id_dstry(      0:num_prog_tracers))

  !The 0 is for mass
  do n=0,num_prog_tracers
     ! Allocate the arrays
     allocate(EL_diag(n)%entrainment(isd:ied,jsd:jed,1:nk))
     allocate(EL_diag(n)%detrainment(isd:ied,jsd:jed,1:nk))
     allocate(EL_diag(n)%new(        isd:ied,jsd:jed,1:nk))
     allocate(EL_diag(n)%dstry(      isd:ied,jsd:jed,1:nk))

     EL_diag(n)%entrainment(:,:,:) = 0.0
     EL_diag(n)%detrainment(:,:,:) = 0.0
     EL_diag(n)%new(:,:,:)         = 0.0
     EL_diag(n)%dstry(:,:,:)       = 0.0

     if (n==0) then
        id_entrainment(n) = register_diag_field('ocean_model', 'blob_mass_ent',   Grd%tracer_axes(1:3), &
             Time%model_time, 'Mass transferred from the E system to the L system due to entrainment by blobs', 'kg')
        id_detrainment(n) = register_diag_field('ocean_model', 'blob_mass_det',   Grd%tracer_axes(1:3), &
             Time%model_time, 'Mass transferred from the L system to the E system due to detrainment by blobs', 'kg')
        id_new(n)         = register_diag_field('ocean_model', 'blob_mass_new',   Grd%tracer_axes(1:3), &
             Time%model_time, 'Mass transferred from the E system to the L system due to blob formation',       'kg')
        id_dstry(n)       = register_diag_field('ocean_model', 'blob_mass_dstry', Grd%tracer_axes(1:3), &
             Time%model_time, 'Mass transferred from the L system to the E system due to blob destruction',     'kg')
     elseif (n==index_temp) then
        id_entrainment(n) = register_diag_field('ocean_model', 'blob_heat_ent',   Grd%tracer_axes(1:3), &
             Time%model_time, 'Heat transferred from the E system to the L system due to entrainment by blobs', 'J')
        id_detrainment(n) = register_diag_field('ocean_model', 'blob_heat_det',   Grd%tracer_axes(1:3), &
             Time%model_time, 'Heat transferred from the L system to the E system due to detrainment by blobs', 'J')
        id_new(n)         = register_diag_field('ocean_model', 'blob_heat_new',   Grd%tracer_axes(1:3), &
             Time%model_time, 'Heat transferred from the E system to the L system due to blob formation',       'J')
        id_dstry(n)       = register_diag_field('ocean_model', 'blob_heat_dstry', Grd%tracer_axes(1:3), &
             Time%model_time, 'Heat transferred from the L system to the E system due to blob destruction',     'J')
     else
        id_entrainment(n) = register_diag_field('ocean_model', 'blob_'//trim(T_prog(n)%name)//'_ent',   Grd%tracer_axes(1:3), &
             Time%model_time, trim(T_prog(n)%name)//' transferred from the E system to the L system due to entrainment by blobs', 'kg')
        id_detrainment(n) = register_diag_field('ocean_model', 'blob_'//trim(T_prog(n)%name)//'_det',   Grd%tracer_axes(1:3), &
             Time%model_time, trim(T_prog(n)%name)//' transferred from the L system to the E system due to detrainment by blobs', 'kg')
        id_new(n)         = register_diag_field('ocean_model', 'blob_'//trim(T_prog(n)%name)//'_new',   Grd%tracer_axes(1:3), &
             Time%model_time, trim(T_prog(n)%name)//' transferred from the E system to the L system due to blob formation',       'kg')
        id_dstry(n)       = register_diag_field('ocean_model', 'blob_'//trim(T_prog(n)%name)//'_dstry', Grd%tracer_axes(1:3), &
             Time%model_time, trim(T_prog(n)%name)//' transferred from the L system to the E system due to blob destruction',     'kg')
     endif
  enddo

  ! Initialise the related blob modules, which actually run the various
  ! available parameterisations
  call blob_util_init(Grd, Dom, Info, Blob_domain, global_sum_flag, num_prog_tracers,&
                      index_temp, index_salt, blob_small_mass, dtimein,              &
                      bitwise_reproduction, vert_coordinate_class, vert_coordinate,  &
                      debug_this_module, really_debug)

  ! Initialise the diagnostics
  call blob_diag_init(T_prog(:), Grd, Dom, num_prog_tracers, dtimein, index_temp, &
                      vert_coordinate_class, blob_diagnostics)

  call blob_static_free_init(Grd, Dom, num_prog_tracers, index_temp, index_salt)

  call blob_static_bottom_init(Grd, Dom, Info, num_prog_tracers, index_temp, index_salt, dtimein)

  call blob_dynamic_bottom_init(Time, Grd, Dom, Blob_domain, Info,                        &
                                debug_this_module,really_debug, bitwise_reproduction,     &
                                num_prog_tracers, index_temp, index_salt, dtimein,        &
                                vert_coordinate_class, vert_coordinate, blob_diagnostics, &
                                bott_minstep, bott_total_ns, blob_small_mass, use_dyn_bot)

  call blob_dynamic_free_init(Grd, Dom, Time, T_prog(:), Blob_domain, Info, debug_this_module,  &
                              really_debug, bitwise_reproduction, num_prog_tracers, index_temp, &
                              index_salt, dtimein,vert_coordinate_class, vert_coordinate,       &
                              blob_diagnostics, free_minstep, free_total_ns, blob_small_mass, use_dyn_fre)

  ! Read in the restart files
  call readrestart

  call init_blob_thickness(Time, Thickness, T_prog(:), L_system)

  ! Calculate the total (combined L and E) tracer
  do n=1,num_prog_tracers
     do k=1,nk
        do j=jsd,jed
           do i=isd,ied
              T_prog(n)%fieldT(i,j,k) = T_prog(n)%field(i,j,k,taup1)*Thickness%rho_dzt(i,j,k,taup1) &
                                        + T_prog(n)%sum_blob(i,j,k,taup1)*Grd%datr(i,j)
              T_prog(n)%fieldT(i,j,k) = T_prog(n)%fieldT(i,j,k)/Thickness%rho_dztT(i,j,k,taup1)
           enddo
        enddo
     enddo
     call mpp_update_domains(T_prog(n)%fieldT(:,:,:), Dom%domain2d, complete=T_prog(n)%complete)
  enddo

  ! Compute the buoyancy frequency based on the full system
  call compute_buoyfreq(Time, Thickness, T_prog(index_salt)%fieldT(:,:,:), &
                        T_prog(index_temp)%fieldT(:,:,:), Dens, use_blobs)

  if (debug_this_module) then
     write(stdoutunit,'(/a)') 'From ocean_blobs_init: debug blob chksums'
     call write_timestamp(Time%model_time)
     call write_chksum_3d('Dens%rhoT', Grd%tmask(COMP,:)*Dens%rhoT(COMP,:))
     do n=1,num_prog_tracers
        call write_chksum_3d(trim(T_prog(n)%name)//' fieldT', Grd%tmask(COMP,:)*T_prog(n)%fieldT(COMP,:))
     enddo
     call blob_chksum(T_prog(:), head_static_free, head_static_bott, &
          head_dynamic_free, head_dynamic_bott, blob_counter)
     call lagrangian_system_chksum(L_system)

     if (really_debug) call write_all_blobs('taup1')
  endif


contains


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine for checking netcdf read errors          !
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine nferror(description)
    character(len=*) :: description
    if (nfstatus /= NF_NOERR) then
       write (stdoutunit, *) ' '
       write (stdoutunit, *) 'ocean_blob_util_mod, blob_util_init: problem '//trim(description)
       write (stdoutunit, *) 'error code =', nfstatus
       if (nfstatus==NF_EEDGE)        write(stdoutunit, *) '==>Start+count exceeds dimension bound'
       if (nfstatus==NF_EINVALCOORDS) write(stdoutunit, *) '==>Index exceeds dimension bound'
       if (nfstatus==NF_ENOTVAR)      write(stdoutunit, *) '==>Variable not found'

       call mpp_error(FATAL, 'ocean_blob_mod, ocean_blob_init: problem '//trim(description))
    endif
  end subroutine nferror

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that reads the restart files for blobs   !
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine readrestart

    type(ocean_blob_type), pointer        :: blob
    integer, allocatable, dimension(:)    :: tracerid
    integer, dimension(1)                 :: id_restart
    character(len=128) :: filename
    integer :: ierr, ncid, dimid, nblobs_in_file
    integer :: latid, lonid, geodepthid, massid, uid, vid, wid, stid
    integer :: dragid, entid, ageid, heightid
    integer :: hashid, numberid, typeid, iid, jid, kid
    integer :: stepid, h1id, h2id, nstepsid, mstepsid, densityid
    integer :: n, m, i, j, k, type, nblobs, fileno
    logical :: found_restart, distributed, next_file_exists

    ! We have two restart files, and we need to read them in separately.
    ! The first is to read in the gridded data.  The second is to read
    ! in the blobs and distribute them amongst the processors.

    ! Allocate memory to the blob counter
    allocate(blob_counter(isc:iec,jsc:jec,nk))
    blob_counter(:,:,:)    = 0

    ! Read in the gridded data
    filename = 'ocean_blobs_gridded.res.nc'
    id_restart(1) = register_restart_field(gridded_restart, filename, 'blob_counter', &
                                           blob_counter(:,:,:), domain=Dom%domain2d)

    if (.not. introduce_blobs) then
       if(file_exist('INPUT/'//trim(filename))) then
          write(stdoutunit, '(/a)') 'Reading in some gridded blobs data from '//trim(filename)
          call restore_state( gridded_restart, id_restart(1) )

       else
          if (.NOT.Time%init) then
             call mpp_error(FATAL,&
                  'Expecting file '//trim(filename)//' to exist.&
                  &This file was not found and Time%init=.false.')
          endif
       endif

       ! Open the blob file and read in the blob attributes.
       filename = 'INPUT/ocean_blobs.res.nc'
       inquire(file=trim(filename),exist=found_restart)
       if (found_restart) then
          distributed=.false.
          next_file_exists=.true.
       else
          write(filename(1:29), '("INPUT/ocean_blobs.res.nc.", I4.4)') 0
          inquire(file=trim(filename),exist=found_restart)
          if (found_restart) then
             distributed=.true.
             next_file_exists=.true.
          else
             if (.NOT.Time%init) then
                call mpp_error(FATAL,&
                     'Expecting file '//trim(filename)//' or similar to exist.&
                     &This file was not found and Time%init=.false.')
             endif
          endif
       endif

       fileno=0
       nblobs=0

       do while (next_file_exists)
          write(stdoutunit, '(/,a,/)') 'Reading in blobs restart from '//trim(filename)

          ierr = nf_open(trim(filename), NF_NOWRITE, ncid)
          if (ierr .ne. NF_NOERR) write(stderrunit,'(a)') 'blobs, readrestart: nf_open failed'

          ierr = nf_inq_unlimdim(ncid, dimid)
          if (ierr .ne. NF_NOERR) write(stderrunit,'(a)') 'blobs, readrestart: nf_inq_unlimdim failed'

          ierr = nf_inq_dimlen(ncid, dimid, nblobs_in_file)
          if (ierr .ne. NF_NOERR) write(stderrunit,*) 'blobs, readrestart: nf_inq_dimlen failed'

          iid        = inq_var(ncid, 'i')
          jid        = inq_var(ncid, 'j')
          kid        = inq_var(ncid, 'k')
          latid      = inq_var(ncid, 'lat')
          lonid      = inq_var(ncid, 'lon')
          geodepthid = inq_var(ncid, 'geodepth')
          stid       = inq_var(ncid, 'st')
          massid     = inq_var(ncid, 'mass')
          densityid  = inq_var(ncid, 'density')
          uid        = inq_var(ncid, 'u')
          vid        = inq_var(ncid, 'v')
          wid        = inq_var(ncid, 'w')
          entid      = inq_var(ncid, 'ent')
          dragid     = inq_var(ncid, 'drag')
          ageid      = inq_var(ncid, 'age')
          heightid   = inq_var(ncid, 'height')
          h1id       = inq_var(ncid, 'h1')
          h2id       = inq_var(ncid, 'h2')
          stepid     = inq_var(ncid, 'step')
          hashid     = inq_var(ncid, 'hash')
          numberid   = inq_var(ncid, 'number')
          typeid     = inq_var(ncid, 'type')
          nstepsid   = inq_var(ncid, 'nsteps')
          mstepsid   = inq_var(ncid, 'model_steps')
          if (fileno==0) allocate(tracerid(num_prog_tracers))
          do n=1, num_prog_tracers
             if (n==index_temp) then
                tracerid(n) = inq_var(ncid, 'heat')
             else
                tracerid(n) = inq_var(ncid, trim(T_prog(n)%name))
             endif
          enddo

          ! Cycle through the blobs.  Ignore empty entries and blobs that are not
          ! in this compute domain.  If a blob is on this compute domain, then
          ! we read in the saved data, and derive other data (such as field,
          ! grid cell etc.).  Then, we put it into the linked list.
          do m=1,nblobs_in_file
             ! get horizontal coordinate information of the blobs and type information
             type = get_int(ncid, typeid, m)
             i = get_int(ncid, iid, m)
             j = get_int(ncid, jid, m)

             ! if type==0, it is an empty entry, so we just ignore it
             if(type /= 0) then
                ! Check if we are in the compute domain. If we are not,
                ! then ignore the blob.  If we are, then read in the
                ! blob's data.
                if (isc<=i .and. i<=iec .and. jsc<=j .and. j<=jec) then
                   nblobs = nblobs + 1
                   allocate(blob)
                   blob%lon         = get_double(ncid, lonid,      m)
                   blob%lat         = get_double(ncid, latid,      m)
                   blob%geodepth    = get_double(ncid, geodepthid, m)
                   blob%st          = get_double(ncid, stid,       m)
                   blob%mass        = get_double(ncid, massid,     m)
                   blob%density     = get_double(ncid, densityid,  m)
                   blob%v(1)        = get_double(ncid, uid,        m)
                   blob%v(2)        = get_double(ncid, vid,        m)
                   blob%v(3)        = get_double(ncid, wid,        m)
                   blob%ent         = get_double(ncid, entid,      m)
                   blob%drag        = get_double(ncid, dragid,     m)
                   blob%age         = get_double(ncid, ageid,      m)
                   blob%height      = get_double(ncid, heightid,   m)
                   blob%h1          = get_double(ncid, h1id,       m)
                   blob%h2          = get_double(ncid, h2id,       m)
                   blob%step        = get_double(ncid, stepid,     m)
                   blob%hash        = get_int(ncid,    hashid,     m)
                   blob%number      = get_int(ncid,    numberid,   m)
                   blob%nsteps      = get_int(ncid,    nstepsid,   m)
                   blob%model_steps = get_int(ncid,    mstepsid,   m)
                   blob%k           = get_int(ncid,    kid,        m)
                   blob%i           = i
                   blob%j           = j
                   allocate(blob%tracer(num_prog_tracers))
                   allocate(blob%field(num_prog_tracers))
                   do n=1,num_prog_tracers
                      blob%tracer(n) = get_double(ncid, tracerid(n), m)
                      blob%field(n)  = blob%tracer(n) / blob%mass
                   enddo

                   i = blob%i
                   j = blob%j
                   k = blob%k

                   ! new blobs were created implicitly in time, and thus, their
                   ! properties belong to the next time step and have not been
                   ! taken into account in diagnostics
                   if(blob%new) then
                      EL_diag(0)%new(i,j,k) = EL_diag(0)%new(i,j,k) + blob%mass
                      do n=1,num_prog_tracers
                         EL_diag(n)%new(i,j,k) = EL_diag(n)%new(i,j,k) + blob%tracer(n)
                      enddo
                   endif

                   blob%depth = blob%geodepth + Ext_mode%eta_t(i,j,taup1)
                   blob%new   = .false.

                   blob%densityr = 1./blob%density

                   if (vert_coordinate_class == DEPTH_BASED) then
                      blob%volume = blob%mass * rho0r
                   else
                      blob%volume = blob%mass * blob%densityr
                   endif

                   ! Insert the blob into its correct place in the linked
                   ! Give an error if the type is unrecognised. type==1 is
                   ! a static free blob and type==2 is a static bottom blob,
                   ! type==3 is a dynamic free blob and type==4 is a dynamic
                   ! bottom blob.  type==0 means that it is an empty entry.
                   if (type==1) then
                      call insert_blob(blob, head_static_free)
                   elseif(type==2) then
                      call insert_blob(blob, head_static_bott)
                   elseif(type==3) then
                      call allocate_interaction_memory(blob, free_total_ns)
                      call insert_blob(blob, head_dynamic_free)
                   elseif(type==4) then
                      call allocate_interaction_memory(blob, bott_total_ns)
                      call insert_blob(blob, head_dynamic_bott)
                   else
                      write(stdoutunit,'(a)') &
                           'blob, readrestart, blob is of unidentified type'
                      call mpp_error(FATAL, &
                           'blob, readrestart, blob is of unidentified type')
                   endif

                   nullify(blob)
                endif !on this pe
             endif !type == 0
          enddo !n=1,nblobs_in_file

          if (distributed) then
             fileno=fileno+1
             write(filename(1:29), '("INPUT/ocean_blobs.res.nc.", I4.4)') fileno
             inquire(file=trim(filename),exist=found_restart)
             if (.not. found_restart) next_file_exists=.false.
          else
             next_file_exists=.false.
          endif

       enddo

       print('(a22,i3,a3,i10)'),  'number of blobs on PE ',Info%pe_this,' =',nblobs
       call mpp_sum(nblobs)
       write(stdoutunit,'(a,i10)') 'global number of blobs     =', nblobs

    endif

  end subroutine readrestart

end subroutine ocean_blob_init
! </SUBROUTINE>  NAME="ocean_blob_init"


!######################################################################
! <SUBROUTINE NAME="init_blob_thickness">
!
! <DESCRIPTION>
! Initialises the L_system thickness, based on the existing blobs
! </DESCRIPTION>
!
subroutine init_blob_thickness(Time, Thickness, T_prog, L_system)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(inout) :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_lagrangian_type),  intent(inout) :: L_system

  type(ocean_blob_type), pointer :: this
  real    :: dzt, rho_dzt
  integer :: i,j,k,n,taup1
  integer :: stdoutunit

  if (.not. use_this_module) return

  stdoutunit = stdout()
  taup1 = Time%taup1

     this=>head_dynamic_free

     if(associated(this)) then
        freecycle: do
           ! for convenience
           i  = this%i - Dom%ioff
           j  = this%j - Dom%joff
           k  = this%k

           ! We use the EOS density regardless of the coordinates, since
           ! the value of rho_dzt for the L-system is used for the
           ! calculation of hydrostatic pressure.
           dzt     = Grd%datr(i,j)*this%volume
           rho_dzt = dzt*this%density
           if (vert_coordinate_class==DEPTH_BASED) then
              if (this%st>-Thickness%depth_st(i,j,k)) then
                 L_system%rho_dztup(i,j,k) = L_system%rho_dztup(i,j,k) + rho_dzt
              else
                 L_system%rho_dztlo(i,j,k) = L_system%rho_dztlo(i,j,k) + rho_dzt
              endif
           else !PRESSURE_BASED
              if (this%st<Thickness%depth_st(i,j,k)) then
                 L_system%rho_dztup(i,j,k) = L_system%rho_dztup(i,j,k) + rho_dzt
              else
                 L_system%rho_dztlo(i,j,k) = L_system%rho_dztlo(i,j,k) + rho_dzt
              endif
           endif
           ! Note, we do not need to initialise the L system thickness, as this is already
           ! done in the thickness module from restarts

           ! The gridded tracer data
           do n=1,num_prog_tracers
              T_prog(n)%sum_blob(i,j,k,taup1) = T_prog(n)%sum_blob(i,j,k,taup1) + this%tracer(n)
           enddo

           this=>this%next
           if(.not.associated(this)) exit freecycle
        enddo freecycle
     endif

     this=>head_dynamic_bott
     if(associated(this)) then
        bottcycle: do
           ! for convenience
           i  = this%i - Dom%ioff
           j  = this%j - Dom%joff
           k  = this%k

           ! We use the EOS density regardless of the coordinates, since
           ! the value of rho_dzt for the L-system is used for the
           ! calculation of hydrostatic pressure.  Bottom blobs only
           ! contribute to the lower half of the grid cell thickness.
           rho_dzt = Grd%datr(i,j)*this%volume*this%density
           L_system%rho_dztlo(i,j,k) = L_system%rho_dztlo(i,j,k) + rho_dzt*0.5
           L_system%rho_dztup(i,j,k) = L_system%rho_dztup(i,j,k) + rho_dzt*0.5

           ! Note, we do not need to initialise the L system thickness, as this is already
           ! done in the thickness module from restarts

           ! The gridded tracer data
           do n=1,num_prog_tracers
              T_prog(n)%sum_blob(i,j,k,taup1) = T_prog(n)%sum_blob(i,j,k,taup1) + this%tracer(n)
           enddo

           this=>this%next
           if(.not.associated(this)) exit bottcycle
        enddo bottcycle
     endif

     call mpp_update_domains(L_system%rho_dztlo(:,:,:), Dom%domain2d, complete=.false.)
     call mpp_update_domains(L_system%rho_dztup(:,:,:), Dom%domain2d, complete=.false.)
     do n=1,num_prog_tracers
        call mpp_update_domains(T_prog(n)%sum_blob(:,:,:,taup1), Dom%domain2d, complete=T_prog(n)%complete)
     enddo

end subroutine init_blob_thickness
! </SUBROUTINE>  NAME="init_blob_thickness"


!#######################################################################
! <SUBROUTINE NAME="ocean_blob_update">
!
! <DESCRIPTION>
! Updates the Lagrangian blobs by calling routines that run during the
! explicit in time part of the time step.
! </DESCRIPTION>
!
subroutine ocean_blob_update(Time, Thickness, T_prog, Dens, Ext_mode, Adv_vel, Velocity, L_system, EL_diag)
  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(inout) :: Thickness
  type(ocean_prog_tracer_type),   intent(inout) :: T_prog(:)
  type(ocean_density_type),       intent(in)    :: Dens
  type(ocean_external_mode_type), intent(inout) :: Ext_mode
  type(ocean_adv_vel_type),       intent(inout) :: Adv_vel
  type(ocean_velocity_type),      intent(in)    :: Velocity
  type(ocean_lagrangian_type),    intent(inout) :: L_system
  type(blob_diag_type),           intent(inout) :: EL_diag(0:)

  type(ocean_blob_type), pointer :: this=>NULL()
  type(ocean_blob_type), pointer :: head=>NULL()
  type(ocean_blob_type), pointer :: free2bott=>NULL()
  type(ocean_blob_type), pointer :: bott2free=>NULL()
  integer :: tau, taup1
  integer :: k, i, j, n, p, s
  integer :: ngrounded, nsurfaced, nblob, ndetraind
  real, dimension(num_prog_tracers,isd:ied,jsd:jed,nk) :: tend_blob
  real, dimension(isd:ied,jsd:jed)                     :: blob_source
  real, dimension(isbd:iebd,jsbd:jebd,nk,2)            :: press_grad, u
  real, dimension(isbd:iebd,jsbd:jebd,nk)              :: rho
  real, dimension(isbd:iebd,jsbd:jebd,0:nk)            :: w

  if (.not. use_this_module) return

  tau   = Time%tau
  taup1 = Time%taup1

  if (.not. module_is_initialized ) then
     call mpp_error(FATAL, &
          '==>Error in ocean_blob_mod (Lagrangian blob model): module '&
          //' needs to be initialized')
  endif

  ! Note, that in order to help reduce roundoff error, we add the blob mass to
  ! conv_blob in the blob modules.  Then, at the end of ocean_blob_cell_update, we
  ! divide by (dat*dtime)
  Ext_mode%conv_blob(:,:)   = 0.0
  L_system%conv_blob(:,:,:) = 0.0
  blob_source(:,:)          = 0.0
  tend_blob(:,:,:,:)        = 0.0

  ! For diagnostics
  mass_in(:,:,:)  = 0.0
  mass_out(:,:,:) = 0.0
  ngrounded = 0
  nsurfaced = 0
  ndetraind = 0

  ! We need to mpp_update these variables for the dynamic blobs if we wish to maintain
  ! bitwise reproduction across processors.
  press_grad(:,:,:,:) = 0.0
  u(:,:,:,:)          = 0.0
  rho(:,:,:)          = 0.0
  w(:,:,:)            = 0.0

  if (Grd%tripolar) then
     do k=1,nk
        press_grad(isc:iec,jsc:jec,k,1) = Grd%cos_rot(isc:iec,jsc:jec) * Velocity%press_force(isc:iec,jsc:jec,k,1) + &
                                          Grd%sin_rot(isc:iec,jsc:jec) * Velocity%press_force(isc:iec,jsc:jec,k,2)
        press_grad(isc:iec,jsc:jec,k,2) = Grd%sin_rot(isc:iec,jsc:jec) * Velocity%press_force(isc:iec,jsc:jec,k,1) + &
                                          Grd%cos_rot(isc:iec,jsc:jec) * Velocity%press_force(isc:iec,jsc:jec,k,2)

        u(isc:iec,jsc:jec,k,1) = Grd%cos_rot(isc:iec,jsc:jec) * Velocity%u(isc:iec,jsc:jec,k,1,tau) + &
                                 Grd%sin_rot(isc:iec,jsc:jec) * Velocity%u(isc:iec,jsc:jec,k,2,tau)
        u(isc:iec,jsc:jec,k,2) = Grd%sin_rot(isc:iec,jsc:jec) * Velocity%u(isc:iec,jsc:jec,k,1,tau) + &
                                 Grd%cos_rot(isc:iec,jsc:jec) * Velocity%u(isc:iec,jsc:jec,k,2,tau)
     enddo
  else
     press_grad(isc:iec,jsc:jec,1:nk,1:2) = Velocity%press_force(isc:iec,jsc:jec,1:nk,1:2)
     u(         isc:iec,jsc:jec,1:nk,1:2) = Velocity%u(          isc:iec,jsc:jec,1:nk,1:2,tau)
  endif

  rho(isc:iec,jsc:jec,1:nk) = Dens%rho(isc:iec,jsc:jec,1:nk,tau)

  w(isc:iec,jsc:jec,0)    = Ext_mode%deta_dt(isc:iec,jsc:jec)
  w(isc:iec,jsc:jec,1:nk) = rho0r*Adv_vel%wrho_bt(isc:iec,jsc:jec,1:nk)

  call mpp_update_domains(press_grad(:,:,:,1), press_grad(:,:,:,2),Blob_domain%domain2d,gridtype=BGRID_NE, complete=.false.)
  call mpp_update_domains(u(:,:,:,1), u(:,:,:,2),                  Blob_domain%domain2d,gridtype=BGRID_NE, complete=.true.)
  call mpp_update_domains(rho(:,:,:), Blob_domain%domain2d)
  call mpp_update_domains(w(:,:,:),   Blob_domain%domain2d)

  if (id_nblob_free>0) then
     nblob = 0
     this=>head_dynamic_free
     do while(associated(this))
        nblob = nblob + 1
        this=>this%next
     enddo
     call mpp_sum(nblob)
     used = send_data(id_nblob_free, real(nblob), Time%model_time)
  endif

  if (id_nblob_bott>0) then
     nblob = 0
     this=>head_dynamic_bott
     do while(associated(this))
        nblob = nblob + 1
        this=>this%next
     enddo
 call mpp_sum(nblob)
     used = send_data(id_nblob_bott, real(nblob), Time%model_time)
  endif

  ! call the explicit in time parts of the parameterisations
  ! Static bottom blobs
  call mpp_clock_begin(id_clock_static_bottom)
  call blob_overflow_like(Time, Thickness, T_prog(:), Dens, head_static_bott, blob_counter)
  call mpp_clock_end(id_clock_static_bottom)

  ! Dynamic free blobs
  call mpp_clock_begin(id_clock_dyn_free_update)
  call blob_dynamic_free_update(Time, Thickness, T_prog(:), Ext_mode, Dens, L_system, &
                                tend_blob, blob_source, press_grad, u, w, rho,        &
                                head_dynamic_free, free2bott, mass_in, mass_out,      &
                                EL_diag(:), ngrounded, nsurfaced, ndetraind)
  call mpp_clock_end(id_clock_dyn_free_update)

  ! Dynamic bottom blobs
  call mpp_clock_begin(id_clock_dyn_bott_update)
  call blob_dynamic_bottom_update(head_dynamic_bott, bott2free, Time, Dens, Thickness, &
                                  T_prog, Ext_mode, L_system, tend_blob, blob_source,  &
                                  u, rho, mass_in, mass_out, EL_diag(:), ngrounded, ndetraind)
  call mpp_clock_end(id_clock_dyn_bott_update)

  call mpp_sum(ngrounded)
  call mpp_sum(nsurfaced)
  call mpp_sum(ndetraind)
  if (id_grounded>0) used = send_data(id_grounded, real(ngrounded), Time%model_time)
  if (id_surfaced>0) used = send_data(id_surfaced, real(nsurfaced), Time%model_time)
  if (id_detraind>0) used = send_data(id_detraind, real(ndetraind), Time%model_time)

  if (debug_this_module .and. bitwise_reproduction) then
     call entrainment_checksum(Time, head_dynamic_free, head_dynamic_bott, free2bott, bott2free)
  endif

  ! Bitwise reproduction is a very memory intensive operation and should only be used
  ! for debugging.  For bitwise_reproduction=.true. we need to process blobs and their
  ! histories in the same relative order regardless of domain decomposition and restarts.
  ! To do so, we save the "history" of each blob subcycle to a number of arrays (which
  ! can be a very memory intensive process) and process them in order.  When we set
  ! bitwise_reproduction=.false. we process the blob histories "in situ" without regard
  ! to order and thus obviate the need for the history arrays and consequently greatly
  ! reduce the memory requirements of the Lagrangian model.
  if (bitwise_reproduction) then
     ! Accumulate the mass transferred between the E and L
     ! systems as a result of entrainment and detrainment.
     ! Also, calculate the divergence as a result of the blobs.
     do p=3,6
        if(p==3) head=>head_dynamic_free
        if(p==4) head=>head_dynamic_bott
        if(p==5) head=>free2bott
        if(p==6) head=>bott2free
        if (associated(head)) then
           this=>head

           blobcycle: do
              i=this%di(0)
              j=this%dj(0)
              k=this%dk(0)

              if (isc<= i .and. i<=iec .and. jsc<= j .and. j<=jec) then

                 Ext_mode%conv_blob(i,j)   = Ext_mode%conv_blob(i,j)   - this%mass_out(0)
                 L_system%conv_blob(i,j,k) = L_system%conv_blob(i,j,k) - this%mass_out(0)

                 mass_out(i,j,k) = mass_out(i,j,k) + this%mass_out(0)
              endif

              if (this%nfrac_steps>0) then
                 do s=1,this%nfrac_steps
                    i=this%di(s)
                    j=this%dj(s)
                    k=this%dk(s)

                    if (isc<= i .and. i<=iec .and. jsc<= j .and. j<=jec) then

                       Ext_mode%conv_blob(i,j)   = Ext_mode%conv_blob(i,j)   - this%mass_out(s)
                       Ext_mode%conv_blob(i,j)   = Ext_mode%conv_blob(i,j)   + this%mass_in(s)

                       L_system%conv_blob(i,j,k) = L_system%conv_blob(i,j,k) - this%mass_out(s)
                       L_system%conv_blob(i,j,k) = L_system%conv_blob(i,j,k) + this%mass_in(s)

                       mass_out(i,j,k) = mass_out(i,j,k) + this%mass_out(s)
                       mass_in(i,j,k)  = mass_in(i,j,k)  + this%mass_in(s)

                       blob_source(i,j) = blob_source(i,j) - this%entrainment(s,0) - this%detrainment(s,0)
                       EL_diag(0)%entrainment(i,j,k) = EL_diag(0)%entrainment(i,j,k) + this%entrainment(s,0)
                       EL_diag(0)%detrainment(i,j,k) = EL_diag(0)%detrainment(i,j,k) - this%detrainment(s,0)

                       do n=1,num_prog_tracers
                          tend_blob(n,i,j,k) = tend_blob(n,i,j,k) - this%entrainment(s,n) - this%detrainment(s,n)
                          EL_diag(n)%entrainment(i,j,k) = EL_diag(n)%entrainment(i,j,k) + this%entrainment(s,n)
                          EL_diag(n)%detrainment(i,j,k) = EL_diag(n)%detrainment(i,j,k) - this%detrainment(s,n)
                       enddo
                    endif
                 enddo
              endif

              ! dmass and dtracer are for when a blob is destroyed (e.g. grounded, penetrated free surface)
              ! So, they should take the last recorded value of (i,j,k)
              i=this%i
              j=this%j
              k=this%k
              if (isc<= i .and. i<=iec .and. jsc<= j .and. j<=jec) then
                 blob_source(i,j)   = blob_source(i,j) - this%dmass
                 EL_diag(0)%dstry(i,j,k) = EL_diag(0)%dstry(i,j,k) - this%dmass
                 do n=1,num_prog_tracers
                    tend_blob(n,i,j,k) = tend_blob(n,i,j,k) - this%dtracer(n)
                    EL_diag(n)%dstry(i,j,k) = EL_diag(n)%dstry(i,j,k) - this%dtracer(n)
                 enddo
              endif
              this=>this%next
              if (.not. associated(this)) exit blobcycle
           enddo blobcycle
        endif
     enddo!p
  endif

  ! Trasfer blobs between lists:
  ! Free blobs that have interacted with topography.
  call mpp_clock_begin(id_clock_tsfr_f2b)
  call transfer_free_to_bottom(Time, Thickness, T_prog, free2bott, head_dynamic_bott, &
                               use_dyn_fre, EL_diag(:))
  call mpp_clock_end(id_clock_tsfr_f2b)

  ! Bottom blobs that have separated.
  call mpp_clock_begin(id_clock_tsfr_f2b)
  call transfer_bottom_to_free(Time, Thickness, T_prog(:), Dens, bott2free, &
                               head_dynamic_free, use_dyn_bot, EL_diag(:))
  call mpp_clock_end(id_clock_tsfr_f2b)

  ! Remove all blobs from dynamic free and bottom lists that have a small mass
  call blob_delete(Time, Thickness, T_prog(:), head_dynamic_free)
  call blob_delete(Time, Thickness, T_prog(:), head_dynamic_bott)

  ! Form new blobs as a result of the on-shelf/off-shelf creation condition
  call mpp_clock_begin(id_clock_dyn_bott_new)
  call dynamic_bottom_form_new(Time, Dens, T_prog, Thickness, Ext_mode, L_system, tend_blob, &
                               Blob_counter, u, mass_out, mass_in, head_dynamic_bott, EL_diag(:))
  call mpp_clock_end(id_clock_dyn_bott_new)

  ! We only finalise the horizontal (depth integrated) blob convergence.
  ! As we have yet to find the position of the vertical coordinate system
  ! for taup1, we do not yet know what the final cell a blob lies in.
  do j=jsd,jed
     do i=isd,ied
        Ext_mode%conv_blob(i,j) = Ext_mode%conv_blob(i,j)*datdtimer(i,j)
     enddo
  enddo
  call mpp_update_domains(Ext_mode%conv_blob(:,:), Dom%domain2d)

  Thickness%blob_source(:,:) = Thickness%blob_source(:,:) + blob_source(:,:)*datdtimer(:,:)
  do n=1,num_prog_tracers
     do k=1,nk
        T_prog(n)%tend_blob(:,:,k) = T_prog(n)%tend_blob(:,:,k) + tend_blob(n,:,:,k)*datdtimer(:,:)
     enddo
     call mpp_update_domains(T_prog(n)%tend_blob(:,:,:), Dom%domain2d, complete=T_prog(n)%complete)
  enddo

end subroutine ocean_blob_update
! </SUBROUTINE>  NAME="ocean_blob_update"

!#######################################################################
! <SUBROUTINE NAME="ocean_blob_cell_update">
!
! <DESCRIPTION>
!
! For bottom blobs, it diagnoses the blobs vertical position in the
! models native vertical coordinate.
!
! For free blobs, it searches for the vertical grid cell that a free
! blob resides in.
!
! We require the information regarding the vertical grid cell that a
! blob resides in prior to the calculation of total grid cell thickness
! and prior to the calculation of the vertical advection velocity.
!
! In order to figure out which grid cell the blob is in, we need to
! employ different strategies for different coordinate system (see notes
! for details).
!
! For any blobs that penetrate the free surface (which is unlikely, but
! not impossible) we immediately kill them, returning their properties
! to the surface grid cell of the (i,j) column that they belong to.
!
! We recalculate a blobs density and volume for taup1, based on the pressure
! at the centre of the grid cell that it resides in.
!
! </DESCRIPTION>
!
subroutine ocean_blob_cell_update(Time, Thickness, Dens, T_prog, Ext_mode, L_system, EL_diag)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(inout) :: Thickness
  type(ocean_prog_tracer_type),   intent(inout) :: T_prog(:)
  type(ocean_density_type),       intent(in)    :: Dens
  type(ocean_external_mode_type), intent(inout) :: Ext_mode
  type(ocean_lagrangian_type),    intent(inout) :: L_system
  type(blob_diag_type),           intent(inout) :: EL_diag(0:)

  type(ocean_blob_type), pointer :: this=>NULL()
  integer :: i,j,k,n,old_k,km1,tau,taup1
  integer :: stdoutunit,thru_surface
  real :: zwt_k, zwt_km1, dz, p

  tau   = Time%tau
  taup1 = Time%taup1

  thru_surface = 0

  this=>head_dynamic_bott
  if(associated(this)) then
     bottcycle: do
        i = this%i
        j = this%j
        k = this%k
        if (vert_coordinate==ZSTAR) then
           ! From table 6.1 of Griffies (2009): zstar = H(z-eta)/(H+eta)
           ! Here z=-this%geodepth
           this%st = Grd%ht(i,j) * ( -this%geodepth-Ext_mode%eta_t(i,j,taup1) )&
                                  / ( Grd%ht(i,j)+Ext_mode%eta_t(i,j,taup1))

        elseif(vert_coordinate==PRESSURE) then
           ! From table 6.2 of Griffies (2009): p
           ! Here p = p(k) + dz/dzt_dst
           ! where dz is the difference in depth between the blob and the grid cell centre
           dz = this%geodepth - Thickness%depth_zt(i,j,k)
           this%st = Dens%pressure_at_depth(i,j,k) + dz/Thickness%dzt_dst(i,j,k)

        elseif(vert_coordinate==PSTAR) then
           ! From table 6.2 of Griffies (2009): pstar = pb0(p-p_a)/(p_b-p_a)
           ! Here p = p(k) + dz/dzt_dst
           ! where dz is the difference in depth between the blob and the grid cell centre
           dz = this%geodepth - Thickness%depth_zt(i,j,k)
           p  = Dens%pressure_at_depth(i,j,k) + dz/Thickness%dzt_dst(i,j,k)
           this%st = Thickness%pbot0(i,j) * ( p - Ext_mode%patm_t(i,j,taup1) )  &
                                           /( Ext_mode%pbot_t(i,j,taup1) - Ext_mode%patm_t(i,j,taup1) )

        endif

        this => this%next
        if (.not. associated(this)) exit bottcycle
     enddo bottcycle
  endif


  this=>head_dynamic_free
  if(associated(this)) then
     blobcycle: do

        i = this%i
        j = this%j
        old_k = this%k
        ! We calculate the depth using eta_t(taup1) in ocean_blob_diagnose_depth.
        ! It is only done here for debugging purposes (to make sure that intermediate
        ! checksums remain consistent).
        this%depth = this%geodepth + Ext_mode%eta_t(i,j,tau)

        if (vert_coordinate==ZSTAR) then
           ! From table 6.1 of Griffies (2009): zstar = H(z-eta)/(H+eta)
           ! Here z=-this%geodepth
           this%st = Grd%ht(i,j) * ( -this%geodepth-Ext_mode%eta_t(i,j,taup1) )&
                                  / ( Grd%ht(i,j)+Ext_mode%eta_t(i,j,taup1))

           ! Note: -H<=zstar<=0 (table 6.1 of Griffies, 2009) and st=zstar
           k=1
           if (this%st>0.) then
              ! the blob has penetrated the free surface, so kill the blob
              thru_surface=thru_surface+1
              EL_diag(0)%dstry(i,j,k) = EL_diag(0)%dstry(i,j,k) + this%mass
              do n=1,num_prog_tracers
                 EL_diag(n)%dstry(i,j,k) = EL_diag(n)%dstry(i,j,k) + this%tracer(n)
              enddo
              call kill_blob(Thickness, T_prog, this, i, j, k)
              this=>this%next
              if(.not. associated(this)) exit blobcycle
              cycle blobcycle
           else ! the blob is at or below the surface.
              call find_depth()
           endif

        else !vert_coordinate==PSTAR .or. PRESSURE
           ! Note: p_a<=p<=p_b; 0<=pstar<=p_b^0
           k=Grd%kmt(i,j)
           zwt_k = -Grd%ht(i,j)
           if (-this%geodepth<zwt_k) then
              ! the blob has penetrated the bottom surface.  Raise a warning.
              this%geodepth = -zwt_k
           else
              press_cycle: do
                 km1=k-1
                 zwt_km1 = zwt_k + Thickness%dzt_dst(i,j,k)*Thickness%dst(i,j,k)
                 if (zwt_k <= -this%geodepth .and. -this%geodepth < zwt_km1) then
                    exit press_cycle
                 endif
                 k=km1
                 zwt_k=zwt_km1
                 if (k==0) then
                    ! the blob has penetrated the free surface, so kill the blob
                    thru_surface=thru_surface+1
                    EL_diag(0)%dstry(i,j,1) = EL_diag(0)%dstry(i,j,1) + this%mass
                    do n=1,num_prog_tracers
                       EL_diag(n)%dstry(i,j,1) = EL_diag(n)%dstry(i,j,1) + this%tracer(n)
                    enddo
                    call kill_blob(Thickness, T_prog, this, i, j, 1)
                    this=>this%next
                    if(.not. associated(this)) exit blobcycle
                    cycle blobcycle
                 endif
              enddo press_cycle
           endif
           ! Calculate the st of the blob for later use (in update_L_thickness and adjust_L_thickness)
           this%st = Thickness%depth_swt(i,j,k) - (zwt_k + this%geodepth)/Thickness%dzt_dst(i,j,k)
        endif

        this%k = k

        ! If the blob is in fact in a different cell, we take this into account with the
        ! calculate of divergence.
        if (old_k/=k) then
           L_system%conv_blob(i,j,old_k) = L_system%conv_blob(i,j,old_k) - this%mass
           L_system%conv_blob(i,j,k)     = L_system%conv_blob(i,j,k)     + this%mass

           ! Diagnostics
           mass_in( i,j,k)     = mass_in( i,j,k)     + this%mass
           mass_out(i,j,old_k) = mass_out(i,j,old_k) + this%mass
        endif

        if (this%mass>blob_small_mass) then
           ! Update some of the blob variables if they wont give silly numbers
           ! Blobs with mass<blob_small_mass may be required only for their history, so
           ! updating their properties is not important as they will be erased from
           ! memory soon enough.
           do n=1,num_prog_tracers
              this%field(n) = this%tracer(n)/this%mass
           enddo
           this%density  = density(this%field(index_salt), &
                                   this%field(index_temp), &
                                   Dens%pressure_at_depth(i,j,k))
           this%densityr = 1./this%density
           if (vert_coordinate_class == DEPTH_BASED) then
              this%volume = this%mass * rho0r
           else
              this%volume = this%mass * this%densityr
           endif
        endif

        this => this%next
        if (.not. associated(this)) exit blobcycle
     enddo blobcycle
  endif !associated(this)

  ! We may now complete the calculation of blob divergence.
  do k=1,nk
     L_system%conv_blob(:,:,k) = L_system%conv_blob(:,:,k)*datdtimer(:,:)
  enddo
  call mpp_update_domains(Thickness%blob_source(:,:), Dom%domain2d)
  call mpp_update_domains(L_system%conv_blob(:,:,:),  Dom%domain2d, complete=.false.)
  do n=1,num_prog_tracers
     call mpp_update_domains(T_prog(n)%tend_blob(:,:,:), Dom%domain2d, complete=T_prog(n)%complete)
  enddo

  ! Diagnostics
  call diagnose_3d(Time, Grd, id_mass_in,  mass_in(:,:,:))
  call diagnose_3d(Time, Grd, id_mass_out, mass_out(:,:,:))

  if (debug_this_module) then
     stdoutunit = stdout()
     call mpp_sum(thru_surface)
     write(stdoutunit, *) 'Free blobs destroyed from reaching surface =', thru_surface
     write(stdoutunit, '(a)') ' '
     call write_timestamp(Time%model_time)
     write(stdoutunit, *) 'Intermediate Blob Checksums (taup1) after explicit update'
     call blob_chksum(T_prog(:), head_static_free, head_static_bott, &
                      head_dynamic_free, head_dynamic_bott, blob_counter)
     call write_chksum_2d('Ext_mode%conv_blob', Ext_mode%conv_blob(COMP))
     call write_chksum_3d('L_system%conv_blob', L_system%conv_blob(COMP,:))
     if (vert_coordinate_class==DEPTH_BASED) then
        call write_chksum_2d('Ext_mode%eta_t(taup1)', Ext_mode%eta_t(COMP,taup1))
     else
        call write_chksum_2d('Ext_mode%eta_t(tau)', Ext_mode%eta_t(COMP,tau))
        call write_chksum_3d('Thickness%dst', Thickness%dzt_dst(COMP,:))
        call write_chksum_3d('Thickness%dzt_dst', Thickness%dzt_dst(COMP,:))
     endif
     call write_chksum_2d('Thickness%blob_source', Thickness%blob_source(COMP))
     call write_chksum_3d('T_prog(temp)%tend_blob', T_prog(index_temp)%tend_blob(COMP,:))
     call write_chksum_3d('T_prog(salt)%tend_blob', T_prog(index_salt)%tend_blob(COMP,:))

     if (really_debug) call write_all_blobs('tau')
  endif

  call blob_delete(Time, Thickness, T_prog(:), head_dynamic_free)

contains

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that finds the k cell that a blob resides!
! in.  If a blob penetrates the bottom boundary, we raise an error.    !
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine find_depth()
    if (this%st<-Thickness%depth_swt(i,j,1)) then
       k=2
       depth_cycle: do
          if ( -Thickness%depth_swt(i,j,k)<=this%st .and. this%st<-Thickness%depth_swt(i,j,k-1)) then
             exit depth_cycle
          endif
          k=k+1
       enddo depth_cycle
    endif

  end subroutine find_depth

end subroutine ocean_blob_cell_update
! </SUBROUTINE>  NAME="ocean_blob_cell_update"

!#######################################################################
! <SUBROUTINE NAME="update_L_thickness">
!
! <DESCRIPTION>
! Calculates the contribution to thickness of all the blobs for the
! L system arrays in the Thickness strcture.
!
! The mass per unit area from the blobs is also calculated for the
! upper and lower part of each grid cell and stored in the L_system
! structure.  The calculate of mass per unit area is required for
! pressure calculations.
!
! We note that in DEPTH_BASED models, the value for density used is
! rho0, while it is the actual density in PRESSURE_BASED models. For
! the L_system mass per unit area, the actual density is used for
! all supported coordinates.
! </DESCRIPTION>
!
subroutine update_L_thickness(Time, Thickness, T_prog, L_system, EL_diag)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(inout) :: Thickness
  type(ocean_prog_tracer_type),   intent(inout) :: T_prog(:)
  type(ocean_lagrangian_type),    intent(inout) :: L_system
  type(blob_diag_type),           intent(inout) :: EL_diag(0:)

  type(ocean_blob_type), pointer :: this=>NULL()
  integer :: i,j,k,n
  integer :: tau,taup1
  integer :: total_blobs, dstryd_blobs, diag_dstryd_blobs
  integer :: stdoutunit
  logical :: up
  real :: dzt, rho_dzt, th_rho_dzt, max_dzt, max_dzt_lo, max_dzt_up 
  real :: new_dzt, new_dzt_lo, new_dzt_up

  if (.not. use_this_module) return

  tau   = Time%tau
  taup1 = Time%taup1

  ! We find the blob's position in coordinate space and then use that to
  ! find which vertical grid cell it resides in at taup1.

  do n=1,num_prog_tracers
     T_prog(n)%sum_blob(:,:,:,taup1) = 0.0
  enddo
  Thickness%rho_dztL(:,:,:,taup1) = 0.0
  Thickness%dztupL(:,:,:) = 0.0
  Thickness%dztloL(:,:,:) = 0.0
  L_system%rho_dztup(:,:,:) = 0.0
  L_system%rho_dztlo(:,:,:) = 0.0

  ! We have two kinds of rho_dzt that we save.  One is for the pressure calculation,
  ! the other is for the thickness.  For the pressure calculation, we need to use
  ! the actual density, regardless of whether it is DEPTH_BASED or PRESSURE_BASED.
  ! The second type is for thickness calculations.  For calculation of thickness, it
  ! does depend on the type of vertical coordinate as to whether we use the reference
  ! density, or the actual density.

  this=>head_dynamic_free
  total_blobs  = 0
  dstryd_blobs = 0

  if(associated(this)) then
     freecycle: do
        total_blobs = total_blobs + 1

        i = this%i - Dom%ioff
        j = this%j - Dom%joff
        k = this%k

        ! Calculate this blobs contribution to thickness and mass per unit area
        dzt     = Grd%datr(i,j)*this%volume
        rho_dzt = dzt*this%density

        if (vert_coordinate_class==DEPTH_BASED) then
           ! For the Thickness structure, we use a reference density
           th_rho_dzt = dzt*rho0
           if (this%st>-Thickness%depth_st(i,j,k)) then
              up=.true.
           else
              up=.false.
           endif

        else !vert_coordinate_class==PRESSURE_BASED
           th_rho_dzt = rho_dzt
           if (this%st<Thickness%depth_st(i,j,k)) then
              up=.true.
           else
              up=.false.
           endif

        endif

        ! If the contribution to thickness from all the blobs in a grid cell exceeds
        ! the total thickness of the cell, we kill the blob and return all its
        ! properties to the E system so that we do not have a negative E system
        ! thickness.
        if (up) then
           new_dzt = Thickness%dztupL(i,j,k)+dzt
           max_dzt = max_prop_thickness*Thickness%dztupT(i,j,k)
           if (new_dzt > max_dzt) then
              EL_diag(0)%dstry(i,j,k) = EL_diag(0)%dstry(i,j,k) + this%mass
              do n=1,num_prog_tracers
                 EL_diag(n)%dstry(i,j,k) = EL_diag(n)%dstry(i,j,k) + this%tracer(n)
              enddo
              call kill_blob(Thickness,T_prog(:),this,i,j,k)
              dstryd_blobs = dstryd_blobs + 1
              this=>this%next
              if(.not.associated(this)) exit freecycle
              cycle freecycle
           endif
           Thickness%dztupL(i,j,k)   = new_dzt
           L_system%rho_dztup(i,j,k) = L_system%rho_dztup(i,j,k) + rho_dzt
        else
           new_dzt = Thickness%dztloL(i,j,k)+dzt
           max_dzt = max_prop_thickness*Thickness%dztloT(i,j,k)
           if (new_dzt > max_dzt) then
              EL_diag(0)%dstry(i,j,k) = EL_diag(0)%dstry(i,j,k) + this%mass
              do n=1,num_prog_tracers
                 EL_diag(n)%dstry(i,j,k) = EL_diag(n)%dstry(i,j,k) + this%tracer(n)
              enddo
              call kill_blob(Thickness,T_prog(:),this,i,j,k)
              dstryd_blobs = dstryd_blobs + 1
              this=>this%next
              if(.not.associated(this)) exit freecycle
              cycle freecycle
           endif
           Thickness%dztloL(i,j,k)   = new_dzt
           L_system%rho_dztlo(i,j,k) = L_system%rho_dztlo(i,j,k) + rho_dzt
        endif

        Thickness%rho_dztL(i,j,k,taup1) = Thickness%rho_dztL(i,j,k,taup1) + th_rho_dzt

        ! Accumulate the blob tracer content in a cell
        do n=1,num_prog_tracers
           T_prog(n)%sum_blob(i,j,k,taup1) = T_prog(n)%sum_blob(i,j,k,taup1) + this%tracer(n)
        enddo

        this=>this%next
        if(.not.associated(this)) exit freecycle
     enddo freecycle
  endif
  nullify(this)

  diag_dstryd_blobs = dstryd_blobs

  if (debug_this_module) then
     stdoutunit = stdout()
     call mpp_sum(total_blobs); call mpp_sum(dstryd_blobs)
     write(stdoutunit, *) ' '
     write(stdoutunit, *) 'Statistics from ocean_blob_mod: update_L_thickness'
     write(stdoutunit, *) 'Total dynamic free blobs          =', total_blobs
     write(stdoutunit, *) 'Blobs destroyed because dztL>dztT =', dstryd_blobs
  endif

  total_blobs  = 0
  dstryd_blobs = 0

  this=>head_dynamic_bott
  if (associated(this)) then
     bottcycle: do
        total_blobs = total_blobs + 1

        i = this%i - Dom%ioff
        j = this%j - Dom%joff
        k = this%k

        ! Calculate this blobs contribution to thickness and mass per unit area
        dzt     = Grd%datr(i,j)*this%volume
        rho_dzt = dzt*this%density

        if (vert_coordinate_class==DEPTH_BASED) then
           ! For the Thickness structure, we use a reference density
           th_rho_dzt = dzt*rho0
        else !vert_coordinate_class==PRESSURE_BASED
           th_rho_dzt = rho_dzt
        endif

        ! Bottom blobs now contribute to the lower and upper half of the cell
        new_dzt_lo = Thickness%dztloL(i,j,k)+dzt*0.5
        new_dzt_up = Thickness%dztupL(i,j,k)+dzt*0.5
        max_dzt_lo = max_prop_thickness*Thickness%dztloT(i,j,k)
        max_dzt_up = max_prop_thickness*Thickness%dztupT(i,j,k)

        if ((new_dzt_lo > max_dzt_lo) .or. (new_dzt_up > max_dzt_up)) then
           EL_diag(0)%dstry(i,j,k) = EL_diag(0)%dstry(i,j,k) + this%mass
           do n=1,num_prog_tracers
              EL_diag(n)%dstry(i,j,k) = EL_diag(n)%dstry(i,j,k) + this%tracer(n)
           enddo
           call kill_blob(Thickness,T_prog(:),this,i,j,k)
           dstryd_blobs = dstryd_blobs + 1
           this=>this%next
           if(.not.associated(this)) exit bottcycle
           cycle bottcycle
        endif
        Thickness%dztloL(i,j,k)         = new_dzt_lo
        Thickness%dztupL(i,j,k)         = new_dzt_up
        L_system%rho_dztlo(i,j,k)       = L_system%rho_dztlo(i,j,k) + rho_dzt*0.5
        L_system%rho_dztup(i,j,k)       = L_system%rho_dztup(i,j,k) + rho_dzt*0.5
        Thickness%rho_dztL(i,j,k,taup1) = Thickness%rho_dztL(i,j,k,taup1) + th_rho_dzt

        do n=1,num_prog_tracers
           T_prog(n)%sum_blob(i,j,k,taup1) = T_prog(n)%sum_blob(i,j,k,taup1) + this%tracer(n)
        enddo

        this=>this%next
        if(.not.associated(this)) exit bottcycle
     enddo bottcycle
  endif

  diag_dstryd_blobs = diag_dstryd_blobs + dstryd_blobs
  if (debug_this_module) then
     stdoutunit = stdout()
     call mpp_sum(total_blobs); call mpp_sum(dstryd_blobs)
     write(stdoutunit, *) 'Total dynamic bottom blobs        =', total_blobs
     write(stdoutunit, *) 'Blobs destroyed because dztL>dztT =', dstryd_blobs
  endif

  call mpp_update_domains(L_system%rho_dztup(:,:,:),       Dom%domain2d, complete=.false.)
  call mpp_update_domains(L_system%rho_dztlo(:,:,:),       Dom%domain2d, complete=.false.)
  call mpp_update_domains(Thickness%rho_dztL(:,:,:,taup1), Dom%domain2d, complete=.false.)
  call mpp_update_domains(Thickness%dztupL(:,:,:),         Dom%domain2d, complete=.false.)
  call mpp_update_domains(Thickness%dztloL(:,:,:),         Dom%domain2d, complete=.false.)
  do n=1,num_prog_tracers
     call mpp_update_domains(T_prog(n)%sum_blob(:,:,:,taup1), Dom%domain2d, complete=T_prog(n)%complete)
  enddo

  Thickness%dztL(:,:,:) = Thickness%dztloL(:,:,:) + Thickness%dztupL(:,:,:)

  Thickness%dzwtL(:,:,0)      = Thickness%dztupL(:,:,1)
  Thickness%dzwtL(:,:,1:nk-1) = Thickness%dztupL(:,:,2:nk) + Thickness%dztloL(:,:,1:nk-1)
  Thickness%dzwtL(:,:,nk)     = Thickness%dztloL(:,:,nk)

  call blob_delete(Time, Thickness, T_prog(:),head_static_free)
  call blob_delete(Time, Thickness, T_prog(:),head_static_bott)
  call blob_delete(Time, Thickness, T_prog(:),head_dynamic_free)
  call blob_delete(Time, Thickness, T_prog(:),head_dynamic_bott)

  call mpp_sum(diag_dstryd_blobs)
  if (id_dstryd>0) used = send_data(id_dstryd, real(diag_dstryd_blobs), Time%model_time)

end subroutine update_L_thickness
! </SUBROUTINE>  NAME="update_L_thickness"


!#######################################################################
! <SUBROUTINE NAME="calculate_rhoT">
!
! <DESCRIPTION>
! Calculates the density of the combined E and L systems.
!
! It needs to be done here so that the blobs are taken into account.
!
! </DESCRIPTION>
!
subroutine calculate_rhoT(Time, Dens, Thickness)
  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_density_type),   intent(inout) :: Dens
  type(ocean_thickness_type), intent(in)    :: Thickness

  real, dimension(isd:ied,jsd:jed,nk) :: rho_dzt
  type(ocean_blob_type), pointer :: this
  integer :: taup1,i,j,k,p

  if (.not. use_this_module) return

  taup1 = Time%taup1

  rho_dzt(:,:,:) = Dens%rho(:,:,:,taup1)*Thickness%dzt(:,:,:)

  do p=3,4
     if (p==3) this=>head_dynamic_free
     if (p==4) this=>head_dynamic_bott

     do while (associated(this))
        i=this%i
        j=this%j
        k=this%k

        rho_dzt(i,j,k) = rho_dzt(i,j,k) + this%mass*Grd%datr(i,j)

        this=>this%next
     enddo
  enddo

  call mpp_update_domains(rho_dzt(:,:,:), Dom%domain2d)

  ! Update rhoT to time taup1
  Dens%rhoT(:,:,:) = rho_dzt(:,:,:)/Thickness%dztT(:,:,:,taup1)

end subroutine calculate_rhoT
! </SUBROUTINE>  NAME="calculate_rhoT"


!#######################################################################
! <SUBROUTINE NAME="ocean_blob_implicit">
!
! <DESCRIPTION>
! Updates the Lagrangian blobs by calling routines that run during the
! implicit in time part of the time step.
! </DESCRIPTION>
!
subroutine ocean_blob_implicit(Time, Thickness, T_prog, Dens, Adv_vel, &
                               Velocity, EL_diag)
  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(inout) :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_adv_vel_type),     intent(in)    :: Adv_vel
  type(ocean_velocity_type),    intent(in)    :: Velocity
  type(blob_diag_type),         intent(inout) :: EL_diag(0:)

  integer :: n,taup1

  taup1 = Time%taup1

  if (.not. use_this_module) return
  if (.not. module_is_initialized ) then
     call mpp_error(FATAL, &
          '==>Error in ocean_blob_mod (Lagrangian blob model): module '&
          //' needs to be initialized')
  endif

  ! run the static open ocean convection scheme
  call mpp_clock_begin(id_clock_static_free)
  call blob_static_free(Time, Thickness, T_prog, Dens, head_static_free)
  call mpp_clock_end(id_clock_static_free)

  ! create new blobs arising from vertical instabilities
  call mpp_clock_begin(id_clock_dyn_free_update)
  if (use_dyn_fre) then
     call blob_dynamic_free_implicit(Time, Thickness, T_prog(:), Dens, Adv_vel, &
                                     Velocity, head_dynamic_free, blob_counter, &
                                     EL_diag(:))
  endif
  call mpp_clock_end(id_clock_dyn_free_update)

  if (id_prop_cell_mass>0) then
     wrk1(:,:,:) = Thickness%rho_dztL(:,:,:,taup1)/Thickness%rho_dztT(:,:,:,taup1)
     call diagnose_3d(Time, Grd, id_prop_cell_mass, wrk1(:,:,:))
  endif

  do n=0,num_prog_tracers
     call diagnose_3d(Time, Grd, id_entrainment(n), EL_diag(n)%entrainment(:,:,:))
     call diagnose_3d(Time, Grd, id_detrainment(n), EL_diag(n)%detrainment(:,:,:))
     call diagnose_3d(Time, Grd, id_new(n), EL_diag(n)%new(:,:,:))
     call diagnose_3d(Time, Grd, id_dstry(n), EL_diag(n)%dstry(:,:,:))
  enddo

end subroutine ocean_blob_implicit
! </SUBROUTINE>  NAME="ocean_blob_implicit"

!######################################################################
! <SUBROUTINE NAME="adjust_L_thickness">
!
! <DESCRIPTION>
! blob_thickness is called after new blobs are formed implicitly in
! time.  blob_thickness provides the same function as
! update_L_thickness, with a couple of subtle differences.
!
! At the point that this routine is called, we:
! 1/ Know the vertical position of an "old" blob relative to the geoid
!    and in the Eulerian model's native vertical coordinate.  We do
!    not know a blobs depth relative to the sea surface.
! 2/ Know the vertical position relative to the sea surface for "new"
!    blobs, but we do not know its position relative to the geoid or in
!    the Euerlian model's native vertical coordinate.
!
! So, blob_thickness uses the logical new, which is part of the blob
! derived type, to distinguish between new blobs and old blobs. New
! blobs have their position (upper or lower part of a grid cell)
! calculated using the depth relative to the sea surface height, while
! blobs that are not new have their position calculated using the
! Eulerian models native coordinate.
!
! The accumulation of thickness and mass per unit area are done in the
! same was as is done in update_L_thickness.
! </DESCRIPTION>
!
subroutine adjust_L_thickness(Time, Thickness, T_prog, L_system)

  type(ocean_time_type),                  intent(in)    :: Time
  type(ocean_thickness_type),             intent(inout) :: Thickness
  type(ocean_prog_tracer_type),           intent(inout) :: T_prog(:)
  type(ocean_lagrangian_type),            intent(inout) :: L_system

  type(ocean_blob_type), pointer :: this=>NULL()
  character(len=128) :: tname
  integer :: i,j,k,n
  integer :: taup1
  integer :: stdoutunit
  real    :: rho_dzt

  if (.not. use_this_module) return

  taup1 = Time%taup1

  Thickness%dztupL(:,:,:) = 0.0
  Thickness%dztloL(:,:,:) = 0.0
  do n=1,num_prog_tracers
     T_prog(n)%sum_blob(:,:,:,taup1) = 0.0
  enddo
  Thickness%rho_dztL(:,:,:,taup1) = 0.0
  L_system%rho_dztup(:,:,:) = 0.0
  L_system%rho_dztlo(:,:,:) = 0.0

  this=>head_dynamic_free
  if(associated(this)) then
     freecycle: do
        ! for convenience
        i  = this%i - Dom%ioff
        j  = this%j - Dom%joff
        k  = this%k

        ! We have two kinds of rho_dzt that we save.  One is for the pressure calculation,
        ! the other is for the thickness.  For the pressure calculation, we need to use
        ! the actual density, regardless of whether it is DEPTH_BASED or PRESSURE_BASED.
        ! The second type is for thickness calculations.  For calculation of thickness, it
        ! does depend on the type of vertical coordinate as to whether we use the reference
        ! density, or the actual density.

        ! This is for pressure calculations
        rho_dzt = Grd%datr(i,j)*this%volume*this%density

        ! For new blobs, we do not know what their vertical position in
        ! coordiante space is, but, we do know their depth.  For old blobs
        ! we do not know their depth, but we know their position in coordinate
        ! space.
        if (this%new) then
           if (Thickness%depth_zt(i,j,k)<=this%depth) then
              Thickness%dztloL(i,j,k)   = Thickness%dztloL(i,j,k)   + Grd%datr(i,j)*this%volume
              L_system%rho_dztlo(i,j,k) = L_system%rho_dztlo(i,j,k) + rho_dzt
           else
              Thickness%dztupL(i,j,k)   = Thickness%dztupL(i,j,k)   + Grd%datr(i,j)*this%volume
              L_system%rho_dztup(i,j,k) = L_system%rho_dztup(i,j,k) + rho_dzt
           endif
           ! This is for thickness calculations
           if(vert_coordinate_class == DEPTH_BASED)then
              Thickness%rho_dztL(i,j,k,taup1) = Thickness%rho_dztL(i,j,k,taup1) + Grd%datr(i,j)*this%volume*rho0
           else
              Thickness%rho_dztL(i,j,k,taup1) = Thickness%rho_dztL(i,j,k,taup1) + rho_dzt
           endif
        else!not a new blob
           if (vert_coordinate_class==DEPTH_BASED) then
              if (this%st>-Thickness%depth_st(i,j,k)) then
                 Thickness%dztupL(i,j,k)   = Thickness%dztupL(i,j,k)   + Grd%datr(i,j)*this%volume
                 L_system%rho_dztup(i,j,k) = L_system%rho_dztup(i,j,k) + rho_dzt
              else
                 Thickness%dztloL(i,j,k)   = Thickness%dztloL(i,j,k)   + Grd%datr(i,j)*this%volume
                 L_system%rho_dztlo(i,j,k) = L_system%rho_dztlo(i,j,k) + rho_dzt
              endif
              Thickness%rho_dztL(i,j,k,taup1) = Thickness%rho_dztL(i,j,k,taup1) + Grd%datr(i,j)*this%volume*rho0
           else !vert_coordinate_class==PRESSURE_BASED
              if (this%st<Thickness%depth_st(i,j,k)) then
                 Thickness%dztupL(i,j,k)   = Thickness%dztupL(i,j,k)   + Grd%datr(i,j)*this%volume
                 L_system%rho_dztup(i,j,k) = L_system%rho_dztup(i,j,k) + rho_dzt
              else
                 Thickness%dztloL(i,j,k)   = Thickness%dztloL(i,j,k)   + Grd%datr(i,j)*this%volume
                 L_system%rho_dztlo(i,j,k) = L_system%rho_dztlo(i,j,k) + rho_dzt
              endif
              Thickness%rho_dztL(i,j,k,taup1) = Thickness%rho_dztL(i,j,k,taup1) + rho_dzt
           endif
        endif !new blob

        do n=1,num_prog_tracers
           T_prog(n)%sum_blob(i,j,k,taup1) = T_prog(n)%sum_blob(i,j,k,taup1) + this%tracer(n)
        enddo

        this=>this%next
        if(.not.associated(this)) exit freecycle
     enddo freecycle
  endif

  this=>head_dynamic_bott
  if (associated(this)) then
     bottcycle: do
        ! for convenience
        i  = this%i - Dom%ioff
        j  = this%j - Dom%joff
        k  = this%k

        ! This is for pressure calculations
        rho_dzt = Grd%datr(i,j)*this%volume*this%density

        ! Bottom blobs only contribute to the lower half of the bottom cell.
        L_system%rho_dztlo(i,j,k) = L_system%rho_dztlo(i,j,k) + rho_dzt*0.5
        L_system%rho_dztup(i,j,k) = L_system%rho_dztup(i,j,k) + rho_dzt*0.5

        ! This is for thickness calculations
        if(vert_coordinate_class == DEPTH_BASED)then
           Thickness%rho_dztL(i,j,k,taup1) = Thickness%rho_dztL(i,j,k,taup1) + Grd%datr(i,j)*this%volume*rho0
        else
           Thickness%rho_dztL(i,j,k,taup1) = Thickness%rho_dztL(i,j,k,taup1) + rho_dzt
        endif
        Thickness%dztloL(i,j,k) = Thickness%dztloL(i,j,k) + Grd%datr(i,j)*this%volume*0.5
        Thickness%dztupL(i,j,k) = Thickness%dztupL(i,j,k) + Grd%datr(i,j)*this%volume*0.5

        do n=1,num_prog_tracers
           T_prog(n)%sum_blob(i,j,k,taup1) = T_prog(n)%sum_blob(i,j,k,taup1) + this%tracer(n)
        enddo

        this=>this%next
        if(.not.associated(this)) exit bottcycle
     enddo bottcycle
  endif

  call mpp_update_domains(L_system%rho_dztup(:,:,:),       Dom%domain2d, complete=.false.)
  call mpp_update_domains(L_system%rho_dztlo(:,:,:),       Dom%domain2d, complete=.false.)
  call mpp_update_domains(Thickness%rho_dztL(:,:,:,taup1), Dom%domain2d, complete=.false.)
  call mpp_update_domains(Thickness%dztupL(:,:,:),         Dom%domain2d, complete=.false.)
  call mpp_update_domains(Thickness%dztloL(:,:,:),         Dom%domain2d, complete=.false.)
  do n=1,num_prog_tracers
     call mpp_update_domains(T_prog(n)%sum_blob(:,:,:,taup1), Dom%domain2d, complete=T_prog(n)%complete)
  enddo

  Thickness%dztL(:,:,:)       = Thickness%dztloL(:,:,:) + Thickness%dztupL(:,:,:)
  Thickness%dzwtL(:,:,0)      = Thickness%dztupL(:,:,1)
  Thickness%dzwtL(:,:,1:nk-1) = Thickness%dztupL(:,:,2:nk) + Thickness%dztloL(:,:,1:nk-1)
  Thickness%dzwtL(:,:,nk)     = Thickness%dztloL(:,:,nk)

  if (debug_this_module) then
     stdoutunit = stdout()
     write(stdoutunit, '(/,a)')  &
        'Lagrangian Tracer and Mass Checksums (taup1)'
     call write_timestamp(Time%model_time)
     call write_chksum_3d('blob convergence', L_system%conv_blob(COMP,:))
     do n=1,num_prog_tracers
        tname = trim(T_prog(n)%name)//' tend'
        call write_chksum_3d(tname(1:17), T_prog(n)%tend_blob(COMP,:))
     enddo
     call write_chksum_2d('mass', Grd%dat(COMP)*sum(Thickness%rho_dztL(COMP,:,taup1),3))
     do n=1,num_prog_tracers
        tname = trim(T_prog(n)%name)
        call write_chksum_3d(tname(1:18), T_prog(n)%sum_blob(COMP,:,taup1))
     enddo
     write(stdoutunit, '(a,/)') 'end Lagrangian Tracer and Mass Checksums'
  endif

end subroutine adjust_L_thickness
! </SUBROUTINE>  NAME="adjust_L_thickness"


!#######################################################################
! <SUBROUTINE NAME="ocean_blob_diagnose_depth">
! <DESCRIPTION>
! When blobs are created implicitly in time, the sea surface height has
! not been calcualted in pressure based models (but depth has).  However,
! the prognostic variable for blobs is the geodepth and not the depth.  So,
! for a new blob, we set the depth when it is formed and then calculate
! the geodepth here.  For existing blobs, we diagnose the depth using
! eta_t and geodepth.
!
! We note that in GEOPOTENTIAL coordinates, depth and geodepth are
! equivalent, and so we set them to be equivalent for the blobs too.
! </DESCRIPTION>
!
subroutine ocean_blob_diagnose_depth(Time, T_prog, Ext_mode, L_system)
  type(ocean_prog_tracer_type),    intent(in) :: T_prog(:)
  type(ocean_time_type),           intent(in) :: Time
  type(ocean_external_mode_type),  intent(in) :: Ext_mode
  type(ocean_lagrangian_type),     intent(in) :: L_system

  type(ocean_blob_type), pointer :: this => NULL()
  integer :: i,j,k,p
  integer :: taup1
  integer :: stdoutunit

  if (.not. use_this_module) return
  stdoutunit = stdout()

  taup1 = Time%taup1
  do p=1,4
     if(p==1) this=>head_static_free
     if(p==2) this=>head_static_bott
     if(p==3) this=>head_dynamic_free
     if(p==4) this=>head_dynamic_bott
     if(associated(this)) then
        geoblobcycle: do
           i = this%i - Dom%ioff
           j = this%j - Dom%joff
           k = this%k
           if (this%new) then
              this%geodepth = this%depth - Ext_mode%eta_t(i,j,taup1)
              this%new = .false.
           else
              this%depth = this%geodepth + Ext_mode%eta_t(i,j,taup1)
           endif
           this=>this%next
           if(.not.associated(this)) exit geoblobcycle
        enddo geoblobcycle
     endif
     nullify(this)
  enddo

  call blob_diag(Time, head_static_free,  T_prog(:), 1)
  call blob_diag(Time, head_static_bott,  T_prog(:), 2)
  call blob_diag(Time, head_dynamic_free, T_prog(:), 3)
  call blob_diag(Time, head_dynamic_bott, T_prog(:), 4)

  if (debug_this_module) then
     call write_timestamp(Time%model_time)
     write(stdoutunit, '(/,a)') 'Blob Checksums (taup1)'
     call blob_chksum(T_prog(:), head_static_free, head_static_bott, &
                      head_dynamic_free, head_dynamic_bott, blob_counter)
     write(stdoutunit, '(/,a)') 'Lagrangian System Checksums (taup1)'
     call lagrangian_system_chksum(L_system)

     if (really_debug) call write_all_blobs('taup1')
  endif

end subroutine ocean_blob_diagnose_depth
! </SUBROUTINE>  NAME="ocean_blob_diagnose_depth"

!######################################################################
! <SUBROUTINE NAME="ocean_blob_end">
!
! <DESCRIPTION>
! Writes restarts and do checksums for the blobs at the end of a run.
! </DESCRIPTION>
!
subroutine ocean_blob_end(Time, T_prog, L_system, time_stamp)

  type(ocean_time_type),          intent(in)           :: Time
  type(ocean_prog_tracer_type),   intent(in)           :: T_prog(:)
  type(ocean_lagrangian_type),    intent(inout)        :: L_system
  character(len=*),               intent(in), optional :: time_stamp

  integer :: taup1
  integer :: stdoutunit,stderrunit

  if (.not. use_this_module) return
  stdoutunit = stdout() ; stderrunit = stderr()
  taup1 = Time%taup1

  write(stdoutunit,'(/a)') 'From ocean_blobs_mod: ending blob chksums'
  call write_timestamp(Time%model_time)
  call blob_chksum(T_prog(:), head_static_free, head_static_bott, &
                   head_dynamic_free, head_dynamic_bott, blob_counter)

  call writerestart

  if (really_debug) call write_all_blobs('taup1')

  call deallocateblobs

  call blob_static_free_end()
  call blob_static_bottom_end()
  call blob_dynamic_free_end()
  call blob_dynamic_bottom_end()
  call blob_util_end()
  call blob_diag_end(T_prog(:))

  nullify(Info)
  nullify(Dom)
  nullify(Grd)

  call write_timestamp(Time%model_time)
  call lagrangian_system_chksum(L_system)

  write(stdoutunit,'(/a)') 'Completed end of Lagrangian Blobs'

contains

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that write a blob restart at the end of
! a model run
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   subroutine writerestart

     type(ocean_blob_type), pointer :: this=>NULL()
     integer, allocatable, dimension(:) :: tracerid
     integer           :: latid, lonid, geodepthid, massid, uid, vid, wid, stid
     integer           :: hashid, numberid, typeid, iid, jid, kid
     integer           :: stepid, h1id, h2id, nstepsid, mstepsid
     integer           :: densityid, entid, dragid, ageid, heightid
     integer           :: mret, ncid, m_dim, n, m, p
     character(len=31) :: filename

     ! There are two restart files for the blobs.  1/ for gridded data required
     ! by the blobs (e.g. blob_counter) 2/ for the blobs themselves

     ! first, the gridded file
     call save_restart(gridded_restart, time_stamp)

     ! second, the blobs themselves
     write(filename(1:31),'("RESTART/ocean_blobs.res.nc.", I4.4)') mpp_pe()
     if (debug_this_module) write(stdoutunit, '(2a)') 'creating blob restart file:', filename

     mret = nf_create(filename, NF_CLOBBER, ncid)
     if (mret .ne. NF_NOERR) write(stderrunit,'(a)') 'blobs, writerestart: nf_create failed'

     ! Register dimensions
     mret = nf_def_dim(ncid, 'blob', NF_UNLIMITED, m_dim)
     if (mret .ne. NF_NOERR) write(stderrunit,'(a)') 'blobs, writerestart: nf_def_dim failed'

     ! Register variables
     latid       = def_var(ncid, 'lat',         NF_DOUBLE, m_dim)
     lonid       = def_var(ncid, 'lon',         NF_DOUBLE, m_dim)
     geodepthid  = def_var(ncid, 'geodepth',    NF_DOUBLE, m_dim)
     stid        = def_var(ncid, 'st',          NF_DOUBLE, m_dim)
     massid      = def_var(ncid, 'mass',        NF_DOUBLE, m_dim)
     densityid   = def_var(ncid, 'density',     NF_DOUBLE, m_dim)
     uid         = def_var(ncid, 'u',           NF_DOUBLE, m_dim)
     vid         = def_var(ncid, 'v',           NF_DOUBLE, m_dim)
     wid         = def_var(ncid, 'w',           NF_DOUBLE, m_dim)
     entid       = def_var(ncid, 'ent',         NF_DOUBLE, m_dim)
     dragid      = def_var(ncid, 'drag',        NF_DOUBLE, m_dim)
     ageid       = def_var(ncid, 'age',         NF_DOUBLE, m_dim)
     heightid    = def_var(ncid, 'height',      NF_DOUBLE, m_dim)
     h1id        = def_var(ncid, 'h1',          NF_DOUBLE, m_dim)
     h2id        = def_var(ncid, 'h2',          NF_DOUBLE, m_dim)
     stepid      = def_var(ncid, 'step',        NF_DOUBLE, m_dim)
     hashid      = def_var(ncid, 'hash',        NF_INT,    m_dim)
     numberid    = def_var(ncid, 'number',      NF_INT,    m_dim)
     nstepsid    = def_var(ncid, 'nsteps',      NF_INT,    m_dim)
     mstepsid    = def_var(ncid, 'model_steps', NF_INT,    m_dim)
     iid         = def_var(ncid, 'i',           NF_INT,    m_dim)
     jid         = def_var(ncid, 'j',           NF_INT,    m_dim)
     kid         = def_var(ncid, 'k',           NF_INT,    m_dim)
     typeid      = def_var(ncid, 'type',        NF_INT,    m_dim)
     allocate(tracerid(num_prog_tracers))
     do n=1,num_prog_tracers
        if (n==index_temp) then
           tracerid(n) = def_var(ncid, 'heat', NF_DOUBLE, m_dim)
        else
           tracerid(n) = def_var(ncid, trim(T_prog(n)%name), NF_DOUBLE, m_dim)
        endif
     enddo

     call put_att(ncid, latid,      'long_name', 'latitude')
     call put_att(ncid, latid,      'units',     'degrees_N')
     call put_att(ncid, lonid,      'long_name', 'longitude')
     call put_att(ncid, lonid,      'units',     'degrees_E')
     call put_att(ncid, geodepthid, 'long_name', 'depth_from_z=0')
     call put_att(ncid, geodepthid, 'units',     'm')
     call put_att(ncid, stid,       'long_name', 'vertical position')
     if (vert_coordinate_class == DEPTH_BASED) then
        call put_att(ncid, stid,       'units',     'm')
     else
        call put_att(ncid, stid,       'units',     'N/m^2')
     endif
     call put_att(ncid, massid,     'long_name', 'mass')
     call put_att(ncid, massid,     'units',     'kg')
     call put_att(ncid, densityid,  'long_name', 'density')
     call put_att(ncid, densityid,  'units',     'kg/m^3')
     call put_att(ncid, uid,        'long_name', 'zonal_velocity')
     call put_att(ncid, uid,        'units',     'm/s')
     call put_att(ncid, vid,        'long_name', 'meridional_velocity')
     call put_att(ncid, vid,        'units',     'm/s')
     call put_att(ncid, wid,        'long_name', 'vertical_velocity')
     call put_att(ncid, wid,        'units',     'm/s')
     call put_att(ncid, entid,      'long_name', 'entrainment_velocity')
     call put_att(ncid, entid,      'units',     'm/s')
     call put_att(ncid, dragid,     'long_name', 'coefficient of drag (free blobs only)')
     call put_att(ncid, dragid,     'units',     '1/s')
     call put_att(ncid, ageid,      'long_name', 'age of blob')
     call put_att(ncid, ageid,      'units',     's')
     call put_att(ncid, heightid,   'long_name', 'blob height')
     call put_att(ncid, heightid,   'units',     'm')
     call put_att(ncid, h1id,       'long_name', 'stretching_function1')
     call put_att(ncid, h1id,       'units',     'none')
     call put_att(ncid, h2id,       'long_name', 'stretching_function2')
     call put_att(ncid, h2id,       'units',     'none')
     call put_att(ncid, stepid,     'long_name', 'blob_step_size')
     call put_att(ncid, stepid,     'units',     'seconds')
     call put_att(ncid, hashid,     'long_name', 'gridcell_identify')
     call put_att(ncid, hashid,     'units',     'none')
     call put_att(ncid, numberid,   'long_name', 'gridcell_counter')
     call put_att(ncid, numberid,   'units',     'none')
     call put_att(ncid, nstepsid,   'long_name', 'total_blob_steps')
     call put_att(ncid, nstepsid,   'units',     'none')
     call put_att(ncid, mstepsid,   'long_name', 'total_E_model_steps')
     call put_att(ncid, mstepsid,   'units',     'none')
     call put_att(ncid, iid,        'long_name', 'logical zonal cell index')
     call put_att(ncid, iid,        'units',     'none')
     call put_att(ncid, jid,        'long_name', 'logical meridional cell index')
     call put_att(ncid, jid,        'units',     'none')
     call put_att(ncid, kid,        'long_name', 'logical vertical cell index')
     call put_att(ncid, kid,        'units',     'none')
     call put_att(ncid, typeid,     'long_name', 'blob_type')
     call put_att(ncid, typeid,     'units',     'none')
     do n=1,num_prog_tracers
        if (n==index_temp) then
           call put_att(ncid, tracerid(n), 'long_name', 'heat_content')
           call put_att(ncid, tracerid(n), 'units',     'J')
        elseif (T_prog(n)%name(1:3)=='age') then
           call put_att(ncid, tracerid(n), 'long_name', trim(T_prog(n)%name)//'_content')
           call put_att(ncid, tracerid(n), 'units',     'kg/1e18')
        else
           call put_att(ncid, tracerid(n), 'long_name', trim(T_prog(n)%name)//'_content')
           call put_att(ncid, tracerid(n), 'units',     'kg')
        endif
     enddo

     mret = nf_put_att_int(ncid, NF_GLOBAL, 'file_format_major_version', NF_INT, 1, file_format_major_version)
     mret = nf_put_att_int(ncid, NF_GLOBAL, 'file_format_minor_version', NF_INT, 2, file_format_minor_version)

     ! End define mode
     mret = nf_enddef(ncid)

     m = 0
     do p=1,4
        ! We need to be able to distinguish between the four types of blobs
        ! when we restart.  So, we alot each a type.  type==1 is a static free
        ! blob and type==2 is a static bottom blob, type==3 is a dynamic free
        ! blob and type==4 is a dynamic bottom blob.  type==0 means that it is
        ! an empty entry.
        nullify(this)
        if(p==1 .and. associated(head_static_free))  this=>head_static_free
        if(p==2 .and. associated(head_static_bott))  this=>head_static_bott
        if(p==3 .and. associated(head_dynamic_free)) this=>head_dynamic_free
        if(p==4 .and. associated(head_dynamic_bott)) this=>head_dynamic_bott

        if (associated(this)) then
           fullcycle: do

              m = m+1
              call put_double(ncid, latid,      m, this%lat)
              call put_double(ncid, lonid,      m, this%lon)
              call put_double(ncid, geodepthid, m, this%geodepth)
              call put_double(ncid, stid,       m, this%st)
              call put_double(ncid, massid,     m, this%mass)
              call put_double(ncid, densityid,  m, this%density)
              call put_double(ncid, uid,        m, this%v(1))
              call put_double(ncid, vid,        m, this%v(2))
              call put_double(ncid, wid,        m, this%v(3))
              call put_double(ncid, entid,      m, this%ent)
              call put_double(ncid, dragid,     m, this%drag)
              call put_double(ncid, ageid,      m, this%age)
              call put_double(ncid, heightid,   m, this%height)
              call put_double(ncid, h1id,       m, this%h1)
              call put_double(ncid, h2id,       m, this%h2)
              call put_double(ncid, stepid,     m, this%step)
              call put_int(   ncid, hashid,     m, this%hash)
              call put_int(   ncid, numberid,   m, this%number)
              call put_int(   ncid, nstepsid,   m, this%nsteps)
              call put_int(   ncid, mstepsid,   m, this%model_steps)
              call put_int(   ncid, typeid,     m, p)
              call put_int(   ncid, iid,        m, this%i)
              call put_int(   ncid, jid,        m, this%j)
              call put_int(   ncid, kid,        m, this%k)
              do n=1,num_prog_tracers
                 call put_double(ncid, tracerid(n), m, this%tracer(n))
              enddo

              this=>this%next
              if(.not. associated(this)) exit fullcycle
           enddo fullcycle
        endif
     enddo

     if (m==0) then
        call put_double(ncid, latid,      1, 0.0)
        call put_double(ncid, lonid,      1, 0.0)
        call put_double(ncid, geodepthid, 1, 0.0)
        call put_double(ncid, massid,     1, 0.0)
        call put_double(ncid, densityid,  1, 0.0)
        call put_double(ncid, uid,        1, 0.0)
        call put_double(ncid, vid,        1, 0.0)
        call put_double(ncid, wid,        1, 0.0)
        call put_double(ncid, entid,      1, 0.0)
        call put_double(ncid, dragid,     1, 0.0)
        call put_double(ncid, ageid,      1, 0.0)
        call put_double(ncid, heightid,   1, 0.0)
        call put_double(ncid, h1id,       1, 0.0)
        call put_double(ncid, h2id,       1, 0.0)
        call put_double(ncid, stepid,     1, 0.0)
        call put_int(   ncid, hashid,     1, 0)
        call put_int(   ncid, numberid,   1, 0)
        call put_int(   ncid, nstepsid,   1, 0)
        call put_int(   ncid, mstepsid,   1, 0)
        call put_int(   ncid, typeid,     1, 0)
        call put_int(   ncid, iid,        1, 0)
        call put_int(   ncid, jid,        1, 0)
        call put_int(   ncid, kid,        1, 0)
        do n=1,num_prog_tracers
           call put_double(ncid, tracerid(n), 1, 0.0)
        enddo
     endif

     ! Finish up the blobs restart
     mret = nf_close(ncid)
     if (mret .ne. NF_NOERR) write(stderrunit,'(a)') 'blobs, writerestart: nf_close failed'
     deallocate(tracerid)

     print('(a22,i3,a3,i10)'),  'number of blobs on PE ',Info%pe_this,' =',m
     call mpp_sum(m)
     write(stdoutunit,'(a,i10)') 'global number of blobs     =', m

   end subroutine writerestart

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that empties the blob lists at the end
! of a model run
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine deallocateblobs

    type(ocean_blob_type), pointer :: this=>NULL()
    type(ocean_blob_type), pointer :: next=>NULL()
    type(ocean_blob_type), pointer :: head=>NULL()
    integer :: p

    do p=1,4
       if(p==1) head=>head_static_free
       if(p==2) head=>head_static_bott
       if(p==3) head=>head_dynamic_free
       if(p==4) head=>head_dynamic_bott

       this=>head
       if (associated(this)) then
          freecycle: do
             next=>this%next
             call free_blob_memory(this)
             this=>next
             if (.not. associated(this)) exit freecycle
          enddo freecycle
          nullify(head)
       endif
    enddo

   end subroutine deallocateblobs

end subroutine ocean_blob_end
! </SUBROUTINE>  NAME="ocean_blob_end"

!######################################################################
! <SUBROUTINE NAME="write_all_blobs">
!
! <DESCRIPTION>
! A convenient subroutine for debugging that dumps blob details from
! every list
! </DESCRIPTION>
!
subroutine write_all_blobs(time)
  character(len=*), intent(in) :: time

  call write_blobs(head_static_free,  'static free',    time)
  call write_blobs(head_static_bott,  'static bottom',  time)
  call write_blobs(head_dynamic_free, 'dynamic free',   time)
  call write_blobs(head_dynamic_bott, 'dynamic bottom', time)

end subroutine write_all_blobs
! </SUBROUTINE>  NAME="write_all_blobs"


!######################################################################
! <SUBROUTINE NAME="entrainment_checksum">
!
! <DESCRIPTION>
! Do the entrainment checksums
! </DESCRIPTION>
!
subroutine entrainment_checksum(Time, hfree, hbott, f2b, b2f)
  type(ocean_time_type), intent(in) :: Time
  type(ocean_blob_type), pointer    :: hfree
  type(ocean_blob_type), pointer    :: hbott
  type(ocean_blob_type), pointer    :: f2b
  type(ocean_blob_type), pointer    :: b2f

  type(ocean_blob_type), pointer :: this=>NULL()
  integer, dimension(isd:ied,jsd:jed,nk) :: di, dj, dk
  real, dimension(isd:ied,jsd:jed,nk) :: dmass, in, out
  real, dimension(isd:ied,jsd:jed,nk,num_prog_tracers) :: dtracer
  integer :: i,j,k,p,s,n
  integer :: stdoutunit

  stdoutunit = stdout()

  if (really_debug) then
     do p=3,6
        write(stdoutunit, *) ' '
        if(p==3) then
           this=>hfree
           write(stdoutunit, *) 'Entrainment, detrainment and converence details for the Dynamic Free Blobs'
        elseif(p==4) then
           this=>hbott
           write(stdoutunit, *) 'Entrainment, detrainment and converence details for the Dynamic Bottom Blobs'
        elseif(p==5) then
           this=>f2b
           write(stdoutunit, *) 'Entrainment, detrainment and converence details for the Dynamic Free Blobs transferring to Bottom'
        elseif(p==6) then
           this=>b2f
           write(stdoutunit, *) 'Entrainment, detrainment and converence details for the Dynamic Bottom Blobs transferring to Free'
        endif
        write(stdoutunit, '(2(a10,x),3(a1,a3),a1,x,a4,x,5(x,a21))') 'hash','number',&
             '(','i',',','j',',','k',')','s', &
             'dmass','dheat','dsalt',         &
             'convergence','divergence'
        if (associated(this)) then
           blobcycle0: do
              i=this%di(s)
              j=this%dj(s)
              k=this%dk(s)
              print ('(2(i10,x),3(a1,i3),a1,x,4x,x,4(x,21x),(x,es21.14))'), this%hash, this%number, &
                   '(',i,',',j,',',k,')', 0, &
                   this%mass_out(s)
              if (this%nfrac_steps>0) then
                 do s=1,this%nfrac_steps
                    i=this%di(s)
                    j=this%dj(s)
                    k=this%dk(s)
                    print ('(2(i10,x),3(a1,i3),a1,x,i4,x,5(x,es21.14))'), this%hash, this%number, &
                         '(',i,',',j,',',k,')', s, &
                         this%entrainment(s,0)+this%detrainment(s,0), &
                         this%entrainment(s,index_temp)+this%detrainment(s,index_temp), &
                         this%entrainment(s,index_salt)+this%detrainment(s,index_salt),&
                         this%mass_in(s), this%mass_out(s)
                 enddo
              endif
              this=>this%next
              if (.not. associated(this)) exit blobcycle0
           enddo blobcycle0
        endif
     enddo
     write(stdoutunit, *) 'end of list'
  endif

  write(stdoutunit, *) ' '
  write(stdoutunit, *) 'Entrainment and convergence checksums for ocean_blob_mod'
  call write_timestamp(Time%model_time)
  do p=3,6
     if(p==3) then
        this=>hfree
        write(stdoutunit, *) '==>Checksum for dynamic free blobs'
     elseif(p==4) then
        this=>hbott
        write(stdoutunit, *) '==>Checksum for dynamic bottom blobs'
     elseif(p==5) then
        this=>f2b
        write(stdoutunit, *) '==>Checksum for dynamic free blobs interacting with bottom'
     elseif(p==6) then
        this=>b2f
        write(stdoutunit, *) '==>Checksum for dynamic bottom blobs separating from bottom'
     endif

     di(:,:,:)    = 0
     dj(:,:,:)    = 0
     dk(:,:,:)    = 0
     dmass(:,:,:) = 0.0
     in(:,:,:)    = 0.0
     out(:,:,:)   = 0.0
     dtracer(:,:,:,:) = 0.0

     if (associated(this)) then
        blobcycle: do
           i=this%di(0)
           j=this%dj(0)
           k=this%dk(0)

           if (isc<= i .and. i<=iec .and.&
               jsc<= j .and. j<=jec) then

              di(i,j,k) = di(i,j,k) + i
              dj(i,j,k) = dj(i,j,k) + j
              dk(i,j,k) = dk(i,j,k) + k

              out(i,j,k) = out(i,j,k) + this%mass_out(0)
           endif

           if (this%nfrac_steps>0) then
              do s=1,this%nfrac_steps
                 i=this%di(s)
                 j=this%dj(s)
                 k=this%dk(s)

                 if (isc<= i .and. i<=iec .and.&
                     jsc<= j .and. j<=jec) then

                    di(i,j,k) = di(i,j,k) + i
                    dj(i,j,k) = dj(i,j,k) + j
                    dk(i,j,k) = dk(i,j,k) + k

                    dmass(i,j,k) = dmass(i,j,k) + this%entrainment(s,0) + this%detrainment(s,0)

                    in(i,j,k)  = in(i,j,k) + this%mass_in(s)
                    out(i,j,k) = out(i,j,k) + this%mass_out(s)
                    do n=1,num_prog_tracers
                       dtracer(i,j,k,n) = dtracer(i,j,k,n) + this%entrainment(s,n) + this%detrainment(s,n)
                    enddo
                 endif
              enddo
              i=this%di(this%nfrac_steps)
              j=this%dj(this%nfrac_steps)
              k=this%dk(this%nfrac_steps)
              if (isc<= i .and. i<=iec .and.&
                  jsc<= j .and. j<=jec) then
                 dmass(i,j,k) = dmass(i,j,k) + this%dmass
                 do n=1,num_prog_tracers
                    dtracer(i,j,k,n) = dtracer(i,j,k,n) + this%dtracer(n)
                 enddo
              endif
              if (isc<= i .and. i<=iec .and. jsc<= j .and. j<=jec) in(i,j,k)  = in(i,j,k) + this%mass_in(this%nfrac_steps)
           endif

           this=>this%next
           if (.not. associated(this)) exit blobcycle
        enddo blobcycle
     endif
     call write_chksum_3d_int('zonal index (i)', di(COMP,:))
     call write_chksum_3d_int('meridional index (j)', dj(COMP,:))
     call write_chksum_3d_int('vertical index (k)', dk(COMP,:))
     call write_chksum_3d('mass entrainment/detrainment', dmass(COMP,:))
     call write_chksum_3d('mass convergence', in(COMP,:))
     call write_chksum_3d('mass divergence', out(COMP,:))
     call write_chksum_3d('salt entrainment/detrainment', dtracer(COMP,:,index_salt))
     call write_chksum_3d('temp entrainment/detrainment', dtracer(COMP,:,index_temp))
  enddo
  write(stdoutunit, *) 'End checksums'

end subroutine entrainment_checksum
! </SUBROUTINE>  NAME="entrainment_checksum"

end module ocean_blob_mod
! Ninja comment

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: Calculate c3 from steady-state Richardson number\label{sec:c3}
!
! !INTERFACE:
   REALTYPE function compute_cpsi3(c1,c2,Ri)
!
! !DESCRIPTION:
! Numerically computes $c_{\psi 3}$ for two-equation models from  given
! steady-state Richardson-number $Ri_{st}$ and parameters
! $c_{\psi 1}$ and $c_{\psi 2}$ according to \eq{Ri_st}.
! A Newton-iteration is used to solve the resulting
! implicit non-linear equation.
!
! !USES:
   use turbulence, only:           an,as,cmue1,cmue2
   use turbulence, only:           cm0,cm0_fix,Prandtl0_fix
   use turbulence, only:           turb_method,stab_method
   use turbulence, only:           Constant
   use turbulence, only:           MunkAnderson
   use turbulence, only:           SchumGerz
   use turbulence, only:           EiflerSchrimpf
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)            :: c1,c2,Ri
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard, Lars Umlauf
!
! $Log: compute_cpsi3.F90,v $
! Revision 20.0  2013/12/14 00:13:35  fms
! Merged revision 1.1.2.1 onto trunk
!
! Revision 1.1.2.1  2012/05/15 16:00:53  smg
! initial cvs ci for these modules to mom5.
! AUTHOR:Griffies
! REVIEWERS:
! TEST STATUS:
! CHANGES PUBLIC INTERFACES?
! CHANGES ANSWERS?
!
! Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
! updated to the gotm-2012.03.09 CVS tag.
! AUTHOR:Martin Schmidt
! REVIEWERS:Griffies
! TEST STATUS:
! CHANGES PUBLIC INTERFACES?
! CHANGES ANSWERS?
!
! Revision 1.3  2010-09-17 12:53:52  jorn
! extensive code clean-up to ensure proper initialization and clean-up of all variables
!
! Revision 1.2  2007-01-06 11:49:15  kbk
! namelist file extension changed .inp --> .nml
!
! Revision 1.1  2005/06/27 10:54:33  kbk
! new files needed
!
!
!EOP
!-----------------------------------------------------------------------
! !LOCAL VARIABLES:
     integer                       :: i
     integer,parameter             :: imax=100
     REALTYPE                      :: fc,fp,step,ann
     REALTYPE,parameter            :: e=1.e-8
!
!-----------------------------------------------------------------------
!BOC
   ann=5.
   do i=0,imax
      an(1)=ann
      as(1)=an(1)/Ri
      if (turb_method.eq.2) then
         select case(stab_method)
            case(Constant)
               cmue1=cm0_fix
               cmue2=cm0_fix/Prandtl0_fix
            case(MunkAnderson)
               call cmue_ma(2)
            case(SchumGerz)
               call cmue_sg(2)
            case(EiflerSchrimpf)
               call cmue_rf(2)
         end select
      else
         call cmue_d(2)
      end if
      fc=cmue1(1)*an(1)/Ri-cmue2(1)*an(1)-cm0**(-3)
      an(1)=ann+e
      as(1)=an(1)/Ri
      if (turb_method.eq.2) then
         select case(stab_method)
            case(Constant)
               cmue1=cm0_fix
               cmue2=cm0_fix/Prandtl0_fix
            case(MunkAnderson)
               call cmue_ma(2)
            case(SchumGerz)
               call cmue_sg(2)
            case(EiflerSchrimpf)
               call cmue_rf(2)
         end select
      else
         call cmue_d(2)
      end if
      fp=cmue1(1)*an(1)/Ri-cmue2(1)*an(1)-cm0**(-3)
      step=-fc/((fp-fc)/e)
      ann=ann+0.5*step
      if (abs(step).gt.100.) then
         STDERR 'Method for calculating c3 does not converge.'
         STDERR 'Probably, the prescribed steady-state Richardson number'
         STDERR 'is outside the range of the chosen stability function.'
         STDERR 'Please change gotmturb.nml accordingly.'
         STDERR 'If the problem persists, then use another'
         STDERR 'stability function or Algebraic Stress Model.'
         STDERR 'Program aborts now in turbulence.F90.'
         stop
      endif
      if (abs(step).lt.1.e-10) goto 111
   end do
111   an(1)=ann
   as(1)=an(1)/Ri
   if (turb_method.eq.2) then
      select case(stab_method)
         case(Constant)
            cmue1=cm0_fix
            cmue2=cm0_fix/Prandtl0_fix
         case(MunkAnderson)
            call cmue_ma(2)
         case(SchumGerz)
            call cmue_sg(2)
         case(EiflerSchrimpf)
            call cmue_rf(2)
      end select
   else
      call cmue_d(2)
   end if

   compute_cpsi3 = c2+(c1-c2)/Ri*cmue1(1)/cmue2(1)

   return
   end function compute_cpsi3

!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: kpp: the KPP-turbulence model \label{sec:kpp}
!
! !INTERFACE:
   module kpp
!
! !DESCRIPTION:
! This implentation of the KPP turbulence parameterisation is based on the
! publications of \cite{Largeetal94} and \cite{Durskietal2004}.
! The general expression for the turbulent fluxes used in the KPP model is identical to
! that suggested in \eq{fluxes}. It assumes that the turbulent flux is the sum of a
! down-gradient flux and a non-local contribution,
! \begin{equation}
!   \label{kppFluxes}
!   \mean{w'\phi'} = - \nu_t^\phi  \partder{\mean{\phi}}{z}  + \tilde{\Gamma}_\phi
!  \comma
! \end{equation}
! where the super- or subscript $\phi$ is a placeholder for the symbols $m$, $h$, and $s$, indicating
! whether a quantity relates to momentum, heat, or salinity (or any other tracer), respectively.
! Note that turbulence parameters due to salinity stratification are updated only if the
! pre-processor macro {\tt KPP\_SALINITY} has been defined in {\tt cppdefs.h}.
!
! In the notation of the KPP model, the non-local flux is expressed as
! \begin{equation}
!   \label{kppNonlocal}
!   \tilde{\Gamma}_\phi = \nu_t^\phi \gamma_\phi
!  \comma
! \end{equation}
! where independent models are valid for $\nu_t^\phi$ and $\gamma_\phi$.
! The KPP model assumes that the turbulent diffusivity, $\nu_t^\phi$, inside the surface or
! bottom boundary layer is determined by a relation of the form
! \begin{equation}
!   \label{Kx}
!   \nu_t^\phi = h w_\phi(\sigma) G(\sigma)
!  \comma
! \end{equation}
! where $h$ denotes the thickness of the boundary layer, computed according
! to the algorithm discussed below.
! The non-dimensional boundary layer coordinate $\sigma$ is defined according to
! \begin{equation}
!   \label{defSigma}
!   \sigma = \dfrac{d}{h}
!  \comma
! \end{equation}
! where $d$ is the distance from the free surface (or the bottom boundary).
! The velocity scale, $w_\phi$, in \eq{Kx} is computed as described in \sect{sec:wscale}. The
! dimensionless shape function $G$ is a cubic polynomial,
! \begin{equation}
!   \label{GsigmaA}
!   G(\sigma) = a_0 + a_1 \sigma + a_2 \sigma^2 + a_3 \sigma^3
! \point
! \end{equation}
! Physical arguments discussed in \cite{Largeetal94} require  $a_0=0$, $a_1=1$. The remaining
! two parameters $a_2$ and $a_3$ may be re-expressed in terms of the value of $G$ and its
! derivative, $G'$,  at the edge of the boundary layer, $\sigma=1$.
! Then, \eq{GsigmaA} can be re-expressed as
! \begin{equation}
!   \label{GsigmaB}
!   G(\sigma) = \sigma \Big[
!   1 + \sigma \Big(
!     \left( \sigma - 2 \right)
!   + \left( 3 - 2 \sigma  \right) G(1)
!   + \left( \sigma - 1 \right) G'(1)
!   \Big) \Big]
! \end{equation}
! Apart from the boundary layer diffusivities, the KPP model also computes "interior"
! diffusivities, here denoted by $\nu_{ti}^{\phi}$. The function $G$ and its derivative
! can be evaluted from the requirement that, at the edge of the boundary layer, the
! boundary layer diffusivity and its
! derivative correspond exactly to the interior diffusivity and its derivative,
! respectively.
!
! Continuity of the boundary and interior diffusivites is obviously insured, see
! \eq{Kx}, if we require that
! \begin{equation}
!   \label{GOfOne}
!   G(1) = \dfrac{1}{h w_\phi(1)} \nu_{ti}^\phi(z_{bl})
!  \comma
! \end{equation}
! where $z_{bl}$ denotes the vertical coordinate of the surface (or bottom) boundary layer.
!
! A condition for the continuity of the derivatives of $\nu_t^\phi$ and $\nu_{ti}^\phi$
! can be obtained by carrying out the derivative with respect to $z$ of \eq{Kx}, and
! setting it equal to the $z$-derivative of $\nu_{ti}^\phi$. For the surface layer
! this results in
! \begin{equation}
!   \label{GPrimeOfOne}
!   G'(1) = - \dfrac{G(1)}{w(1)} \partder{w}{\sigma} \Big|_{\sigma=1}
!           - \dfrac{1}{w(1)} \partder{\nu_{ti}^\phi}{z} \Big|_{z=z_{bl}}
! \comma
! \end{equation}
! where we used the relation
! \begin{equation}
!   \label{Dsigma}
!   \partder{}{z} = - \frac{1}{h} \partder{}{\sigma}
! \comma
! \end{equation}
! if the motion of the free surface is ignored.
!
! The derivative of $w_\phi$ appearing in \eq{GPrimeOfOne} can be evaluted with
! the help of the formulae given in \sect{sec:wscale}. As discussed in \sect{sec:wscale},
! at $\sigma=1$, the derivative of $w_\phi$ is different from zero only for stably
! stratified flows. Then, the non-dimensional function $\Phi_\phi$ appearing
! in \eq{wscale} is given by \eq{PhiStable}, and it is easy to show that
! \begin{equation}
!   \label{dWdS}
!     \partder{w}{\sigma} \Big|_{\sigma=1} =
!    - 5 h w_\phi(1) \dfrac{B_f}{u_*^4}
! \comma
! \end{equation}
! valid for both, bottom and surface boundary layers.
! Note that in the original publication of \cite{Largeetal94}, erroneously,
! there appears an additional factor $\kappa$ in this relation.
!
! With the help of \eq{dWdS}, one can re-write \eq{GPrimeOfOne} as
! \begin{equation}
!   \label{GPrimeOfOneB}
!   G'(1) = \dfrac{B_f}{u_*^4} \nu_{ti}^\phi \Big|_{z=z_{bl}}
!           - \dfrac{1}{w(1)} \partder{\nu_{ti}^\phi}{z} \Big|_{z=z_{bl}}
! \comma
! \end{equation}
! valid only for the surface boundary layer. For the bottom boundary layer,
! the minus sign in \eq{Dsigma} disappears, with the consequence that
! the minus sign in \eq{GPrimeOfOneB} has to be replaced by a plus. Note that
! if the pre-processor macro {\tt KPP\_CLIP\_GS} is defined in {\tt cppdef.h},
! the slope of  $G$ is set to zero for negative slopes. For stably stratified
! flows with a stabilizing buoyancy flux, this limiter breaks the continuity of
! the first derivatives.
!
! The non-local transport term defined in \eq{kppNonlocal} is computed
! as described in \cite{Largeetal94}, if the pre-processor macro
! {\tt NONLOCAL} is defined. Otherwise, non-local transport is ignored.

! The position of the surface boundary layer depth, $z_{bl}$, corresponds
! to the position where the bulk Richardson number,
! \begin{equation}
!   \label{Rib}
!   Ri_b = \dfrac{(B_r - B(z_{bl})) d}
!                {\magn{\V U_r - \V U(z_{bl})}^2 + V_t^2(z_{bl})}
! \comma
! \end{equation}
! defined by \cite{Largeetal94}, reaches the critical value $Ri_c$.
! The subscript "r" in \eq{Rib} denotes a certain reference value of the buoyancy
! and velocity close to the surface. The choice of this reference value is
! not unique, and several possibilities have been implemented in numerical
! models. Presently, GOTM uses the uppermost grid point as the reference value.
! The bulk Richardson-number is then computed at the grid faces by linear
! interpolation of quantities defined at the centers (if
! ${\tt KPP\_TWOPOINT\_REF}$ is defined) or by simply identifying the
! neighbouring center-value with the value at the face.
! The "turbulent velocity shear", $V_t$, is computed as described
! by \cite{Largeetal94}. The value of $z_{bl}$ is then found from
! \eq{Rib} by linear interpolation.
!
! To check the boundary layer limit according to the condition
! \begin{equation}
!   \label{RiConditionA}
!   Ri_b(z_{bl})
!   = \dfrac{Ri_\text{top}(z_{bl})}{Ri_\text{bot}(z_{bl})} = Ri_c
! \comma
! \end{equation}
! two methods have been implemented in GOTM. The first method simply evaluates
! \eq{RiConditionA} with a linear interpolation scheme.
! The second method is activated if the pre-processor
! macro ${\tt KPP\_IP\_FC}$ is defined. Then, the condition \eq{RiConditionA}
! is reformulated as
! \begin{equation}
!   \label{RiConditionB}
!   F_c(z_{bl}) = Ri_\text{top}(z_{bl})  - Ri_c Ri_\text{bot}(z_{bl}) = 0
! \point
! \end{equation}
! The position where the function $F_c$ changes sign is computed
! from linear interpolation.  This method has been suggested in the ROMS
! code as the numerically more stable alternative.
! Clearly, all approaches are grid-depending, a difficulty that cannot
! be overcome with the KPP model.
!
! Finally, provided {\tt clip\_mld=.true.} in {\tt kpp.nml}, the boundary layer is cut
! if it exceeds the Ekman or the Monin-Obukhov length scale, see \cite{Largeetal94}.
!
! !USES:

  use turbulence,   only: num,nuh,nus
  use turbulence,   only: gamu,gamv,gamh,gams
  use turbulence,   only: Rig
  use turbulence,   only: kappa

#ifdef EXTRA_OUTPUT
  use turbulence,   only: turb1,turb2,turb3,turb4,turb5
#endif

  !use eqstate

  IMPLICIT NONE

  private

! !PUBLIC MEMBER FUNCTIONS:
!
  public init_kpp, do_kpp, clean_kpp

! !PUBLIC DATA MEMBERS:
!
! z-position of surface boundary layer depth
  REALTYPE, public                 :: zsbl

! z-position of bottom boundary layer depth
  REALTYPE, public                 :: zbbl


! !DEFINED PARAMETERS:
!
!  non-dimensional extent of the surface layer (epsilon=0.1)
   REALTYPE, parameter :: epsilon = 0.1

!  critical gradient Richardson number below which turbulent
!  mixing occurs (Ri0=0.7)
   REALTYPE, parameter :: Ri0     = 0.7

!  value of double-diffusive density ratio where mixing goes
!  to zero in salt fingering (Rrho0=1.9)
   REALTYPE, parameter :: Rrho0    = 1.9

!  buoancy frequency (1/s2) limit for convection (bvfcon=-2.0E-5)
   REALTYPE, parameter :: bvfcon  = -2.0E-5

!  scaling factor for double diffusion of temperature in salt
!  fingering case (fdd=0.7)
   REALTYPE, parameter :: fdd     = 0.7

!  maximum interior convective viscosity and diffusivity
!  due to shear instability (nu0c=0.01)
   REALTYPE, parameter :: nu0c    = 0.01

!  maximum interior viscosity (m2/s) due to shear
!  instability (nu0m=10.0E-4)
   REALTYPE, parameter :: nu0m    = 10.0E-4

!  maximum interior diffusivity (m2/s) due to shear
!  instability (nu0s=10.0E-4)
   REALTYPE, parameter :: nu0s    = 10.0E-4

!  scaling factor for double diffusion in salt fingering (nu=1.5E-6)
   REALTYPE, parameter :: nu      = 1.5E-6

!  scaling factor for double diffusion in salt fingering (nuf=10.0E-4)
   REALTYPE, parameter :: nuf     = 10.0E-4

!  interior viscosity (m2/s) due to wave breaking (nuwm=1.0E-5)
   REALTYPE, parameter :: nuwm    = 1.0E-5

!  interior diffusivity (m2/s) due to wave breaking (nuwm=1.0E-6)
   REALTYPE, parameter :: nuws    = 1.0E-6

!  double diffusion constant for salinity in diffusive
!  convection case (sdd1=0.15)
   REALTYPE, parameter :: sdd1    = 0.15

!  double diffusion constant for salinity in diffusive convection
!  (sdd2=1.85)
   REALTYPE, parameter :: sdd2    = 1.85

!  double diffusion constant for salinity in diffusive convection
!  (sdd3=0.85)
   REALTYPE, parameter :: sdd3    = 0.85

!  double diffusion constant for temperature in diffusive convection
!  (tdd1=0.909)
   REALTYPE, parameter :: tdd1    = 0.909

!  double diffusion constant for temperature in diffusive convection
!  (tdd2=4.6)
   REALTYPE, parameter :: tdd2    = 4.6

!  double diffusion constant for temperature in diffusive convection case
!  (tdd3=0.54).
   REALTYPE, parameter :: tdd3    = 0.54

!  proportionality coefficient parameterizing nonlocal  transport
!  (Cstar=10.0)
   REALTYPE, parameter :: Cstar   = 10.0

!  ratio of interior Brunt-Vaisala frequency to that
!  at entrainment depth (Cv=1.5-1.6)
   REALTYPE, parameter :: Cv      = 1.6

!  ratio of entrainment flux to surface buoyancy flux (betaT=-0.2)
   REALTYPE, parameter :: betaT   = -0.2

!  constant for computation of Ekman scale (cekman=0.7)
   REALTYPE, parameter :: cekman  = 0.7

!  constant for computation of Monin-Obukhov scale (cmonob  = 1.0)
   REALTYPE, parameter :: cmonob  = 1.0

!  coefficient of flux profile for momentum in their
!  1/3 power law regimes (am=1.26)
   REALTYPE, parameter :: am      = 1.257

!  coefficient of flux profile for momentum in their
!  1/3 power law regimes (as=-28.86)
   REALTYPE, parameter :: as      = -28.86

!  coefficient of flux profile for momentum in their
!  1/3 power law regimes (cm=8.38)
   REALTYPE, parameter :: cm      = 8.38

!  coefficient of flux profile for momentum in their
!  1/3 power law regimes (cs=98.96)
   REALTYPE, parameter :: cs      = 98.96

!  maximum stability parameter "zeta" value of the 1/3
!  power law regime of flux profile for momentum (zetam=-0.2)
   REALTYPE, parameter :: zetam   = -0.2

!  maximum stability parameter "zeta" value of the 1/3
!  power law regime of flux profile for tracers (zetas=-1.0)
   REALTYPE, parameter :: zetas   = -1.0

! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: kpp.F90,v $
!  Revision 20.0  2013/12/14 00:13:46  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.2.346.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.6  2011-04-05 14:53:31  jorn
!  removed reference to eqstate from kpp
!
!  Revision 1.5  2010-09-17 12:53:52  jorn
!  extensive code clean-up to ensure proper initialization and clean-up of all variables
!
!  Revision 1.4  2007-01-06 11:49:15  kbk
!  namelist file extension changed .inp --> .nml
!
!  Revision 1.3  2005/11/15 11:35:02  lars
!  documentation finish for print
!
!  Revision 1.2  2005/07/21 10:20:00  lars
!  polished documentation
!
!  Revision 1.1  2005/06/27 10:54:33  kbk
!  new files needed
!

! !LOCAL VARIABLES:
!
!  proportionality coefficient for
!  parameterizing non-local transport
   REALTYPE                              ::    Cg

!  coefficient from computation of
!  turbulent shear velocity
   REALTYPE                              ::    Vtc

!  acceleration of gravity
   REALTYPE                              ::    g

!  reference density
   REALTYPE                              ::    rho_0

!  g/rho_0
   REALTYPE                              ::    gorho0

!  critical bulk Richardson number
   REALTYPE                              ::    Ric

!  compute surface and bottom BBL
   logical                               ::    kpp_sbl,kpp_bbl

!  compute internal mixing
   logical                               ::    kpp_interior

!  use clipping of MLD at Ekman and Monin-Oboukhov scale
   logical                               ::    clip_mld

!  positions of grid faces and centers
   REALTYPE, dimension(:), allocatable   ::    z_w,z_r

!  distance between centers
   REALTYPE, dimension(:), allocatable   ::    h_r

   integer                               ::    ksblOld
   REALTYPE                              ::    zsblOld

!
!
!EOP
!-----------------------------------------------------------------------

   contains

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Initialise the KPP module
!
! !INTERFACE:
   subroutine init_kpp(namlst,fn,nlev,h0,h,kpp_g,kpp_rho_0)
!
! !DESCRIPTION:
! This routine first reads the namelist {\tt kpp}, which has to be contained
! in a file with filename specified by the string {\tt fn} (typically called
! {\tt kpp.nml}). Since the {\tt kpp} module uses fields defined in the
! {\tt turbulence} module, it has to allocate dynamic memory for them.
! Apart from this, this routine reports the model settings and initialises a
! number of parameters needed later in the time loop.
!
! If you call the GOTM KPP routines from a three-dimensional model, make sure
! that this function is called \emph{after} the call to {\tt init\_turbulence()}.
! Also make sure that you pass the correct arguments.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  namelist reference
   integer,          intent(in)        :: namlst

!  filename containing namelist
   character(len=*), intent(in)        :: fn

!  number of grid cells
   integer,          intent(in)        :: nlev

!  bathymetry (m)
   REALTYPE,         intent(in)        :: h0

!  size of grid cells (m)
   REALTYPE,         intent(in)        :: h(0:nlev)

!  acceleration of gravity (m/s^2)
   REALTYPE,         intent(in)        :: kpp_g

!  reference density (kg/m^3)
   REALTYPE,         intent(in)        :: kpp_rho_0

! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
   integer                             :: k
   integer                             :: rc

   namelist /kpp/                      kpp_sbl,kpp_bbl,kpp_interior,    &
                                       clip_mld,Ric
!
!-----------------------------------------------------------------------
!BOC

   LEVEL1 'init_kpp...'

   ! read the variables from the namelist file
   open(namlst,file=fn,status='old',action='read',err=80)

   LEVEL2 'reading kpp namelist...'

   read(namlst,nml=kpp,err=81)
   close (namlst)

   LEVEL2 'done.'

!  allocate memory for variables defined in other modules
!
   allocate(num(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (num)'
   num = _ZERO_

   allocate(nuh(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (nuh)'
   nuh = _ZERO_

   allocate(nus(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (nus)'
   nus = _ZERO_

   allocate(gamu(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (gamu)'
   gamu = _ZERO_

   allocate(gamv(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (gamv)'
   gamv = _ZERO_

   allocate(gamh(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (gamh)'
   gamh = _ZERO_

   allocate(gams(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (gams)'
   gams = _ZERO_

   allocate(Rig(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (Rig)'
   Rig = _ZERO_

   allocate(z_w(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (z_w)'
   z_w = _ZERO_

   allocate(z_r(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (z_r)'
   z_r = _ZERO_

   allocate(h_r(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (h_r)'
   h_r = _ZERO_

# ifdef EXTRA_OUTPUT

   allocate(turb1(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (turb1)'
   turb1 = _ZERO_

   allocate(turb2(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (turb2)'
   turb2 = _ZERO_

   allocate(turb3(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (turb3)'
   turb3 = _ZERO_

   allocate(turb4(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (turb4)'
   turb4 = _ZERO_

   allocate(turb5(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (turb5)'
   turb5 = _ZERO_

# endif


!  report model parameters

   LEVEL2 '--------------------------------------------------------'
   LEVEL3 'You are using the KPP turbulence model          '
   LEVEL3 'with the following specifications:                      '
   LEVEL3 '                                                        '
   if (kpp_interior) then
      LEVEL3 'Interior mixing algorithm                  - active -   '
# ifdef KPP_SHEAR
      LEVEL4 'KPP shear instability mixing           - active -   '
# else
      LEVEL4 'KPP shear instability mixing       - not active -   '
# endif
# ifdef KPP_INTERNAL_WAVE
      LEVEL4 'KPP internal wave mixing               - active -   '
# else
      LEVEL4 'KPP internal wave mixing           - not active -   '
# endif
# ifdef KPP_CONVEC
      LEVEL4 'KPP convective instability mixing      - active -   '
# else
      LEVEL4 'KPP convective instability mixing  - not active -   '
# endif
# ifdef KPP_DDMIX
      LEVEL4 'KPP double diffusive mixing            - active -   '
# else
      LEVEL4 'KPP double diffusive mixing        - not active -   '
# endif
   else
      LEVEL3 'Interior mixing algorithm              - not active -   '
   endif

   if (kpp_sbl) then
      LEVEL3 'Surface layer mixing algorithm             - active -   '
      if (clip_mld) then
         LEVEL4 'Clipping at Ekman/Oboukhov scale       - active -   '
      else
         LEVEL4 'Clipping at Ekman/Oboukhov scale   - not active -   '
      endif
# ifdef KPP_SALINITY
      LEVEL4 'Compute salinity fluxes                - active -   '
# else
      LEVEL4 'Compute salinity fluxes            - not active -   '
# endif
# ifdef NONLOCAL
      LEVEL4 'Nonlocal fluxes                        - active -   '
# else
      LEVEL4 'Nonlocal fluxes                    - not active -   '
# endif
# ifdef KPP_TWOPOINT_REF
      LEVEL4 'Ri_b from 2-point interpolation        - active -   '
# else
      LEVEL4 'Ri_b from 2-point interpolation    - not active -   '
# endif
# ifdef KPP_IP_FC
      LEVEL4 'F_c =0 criterion for SL-depth          - active -   '
# else
      LEVEL4 'Ri_b - Ri_c =0 criterion for SL-depth  - active -   '
# endif
# ifdef KPP_CLIP_GS
      LEVEL4 'Clipping G''(sigma) for matching        - active -   '
# else
      LEVEL4 'Clipping G''(sigma) for matching    - not active -   '
# endif

      LEVEL4 'Ri_c  = ', Ric

   else
      LEVEL3 'Surface layer mixing algorithm         - not active -   '
   endif

   if (kpp_bbl) then
      LEVEL3 'Bottom layer mixing algorithm              - active -   '
      LEVEL4 '(Same parameters as surface layer mixing)'

   else
      LEVEL3 'Bottom layer mixing algorithm          - not active -   '
   endif

   LEVEL2 '--------------------------------------------------------'



!  pre-compute coefficient for turbulent shear velocity
   Vtc=Cv*sqrt(-betaT)/(sqrt(cs*epsilon)*Ric*kappa*kappa)


!  pre-compute proportionality coefficient for
!  boundary layer non-local transport
   Cg=Cstar*kappa*(cs*kappa*epsilon)**(1.0/3.0)


!  set acceleration of gravity and reference density
   g        = kpp_g
   rho_0    = kpp_rho_0
   gorho0   = g/rho_0

   LEVEL1 'done.'

   return

80 FATAL 'I could not open "kpp.nml"'
   stop 'init_kpp'
81 FATAL 'I could not read "kpp" namelist'
   stop 'init_kpp'

 end subroutine init_kpp
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Loop over the KPP-algorithm
!
! !INTERFACE:
   subroutine do_kpp(nlev,h0,h,rho,u,v,NN,NNT,NNS,SS,u_taus,u_taub,  &
                     tFlux,btFlux,sFlux,bsFlux,tRad,bRad,f)
!
! !DESCRIPTION:
! Here, the time step for the KPP model is managed. If {\tt kpp\_interior=.true.}
! in {\tt kpp.nml}, the mixing algorithm for the computation of the interior
! diffusivities is called first. This algorithm is described in \sect{sec:kppInterior}.
! Then, if {\tt kpp\_sbl=.true.} and {\tt kpp\_bbl=.true.}, the algorithms
! for the surface and bottom boundary layer are called. They are described in
! \sect{sec:kppSurface} and \sect{sec:kppBottom}, respectively.
!
! If this routine is called from a three-dimensional code, it is essential to
! pass the correct arguments. The first 3 parameters relate to the numerical
! grid, discussed in \sect{SectionNumericsMean}. Note that {\tt h0} denotes
! the local bathymetry, i.e.\ the positive distance between the reference level
! $z=0$ and the bottom.

! The next three parameters denote the potential density, $\rho$,
! and the two mean velocity components, $U$ and $V$. The buoyancy frequency, $N^2$,
! and the different contributions to it, $N_\Theta^2$ and $N_S^2$, have to be computed
! from the potential density as discussed in \sect{sec:stratification}. The shear frequency,
! $M^2$, is defined in \eq{MSquared}. The vertical discretisation does not necessarly
! have to follow \eq{shearsquared}, since in the KPP model no TKE equation is solved
! and thus energy conservation is not an issue. All three-dimensional fields have to
! be interpolated "in a smart way" to the water column defined by GOTM. The corresponding
! interpolation schemes may be quite different for the different staggered grids,
! finite volume, and finite element approaches used in the horizontal. Therefore,
! we cannot offer a general recipe here.

! The bottom friction velocity is computed as described in \sect{sec:friction}. If this
! parameter is passed from a three-dimensional code, it has to be insured that the parameter
! $r$ in \eq{uStar} is computed consistently, see \eq{rParam}.
!
! All fluxes without exception are counted positive, if they enter the water body.
! Note that for consistency, the equations of state in GOTM cannot
! be used if the KPP routines are called from a 3-D model. Therefore,
! it is necessary to pass the temperature and salinity fluxes, as well as the
! corresponding buoyancy fluxes. The same applies
! to the radiative fluxes. The user is responsible for
! performing the flux conversions in the correct way. To get an idea
! have a look at \sect{sec:convertFluxes}.
!
! The last argument is the Coriolis parameter, $f$. It is only used for clippling the mixing
! depth at the Ekman depth.
!
!
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
!  number of grid cells
   integer                                       :: nlev

!  bathymetry (m)
   REALTYPE                                      :: h0

!  thickness of grid cells (m)
   REALTYPE                                      :: h(0:nlev)

!  potential density at grid centers (kg/m^3)
   REALTYPE                                      :: rho(0:nlev)

!  velocity components at grid centers (m/s)
   REALTYPE                                      :: u(0:nlev),v(0:nlev)

!  square of buoyancy frequency (1/s^2)
   REALTYPE                                      :: NN(0:nlev)

!  square of buoyancy frequency caused by
!  temperature and salinity stratification
   REALTYPE                                      :: NNT(0:nlev),NNS(0:nlev)

!  square of shear frequency (1/s^2)
   REALTYPE                                      :: SS(0:nlev)

!  surface and bottom friction velocities (m/s)
   REALTYPE                                      :: u_taus,u_taub

!  surface temperature flux (K m/s) and
!  salinity flux (psu m/s) (negative for loss)
   REALTYPE                                      :: tFlux,sFlux

!  surface buoyancy fluxes (m^2/s^3) due to
!  heat and salinity fluxes
   REALTYPE                                      :: btFlux,bsFlux

!  radiative flux [ I(z)/(rho Cp) ] (K m/s)
!  and associated buoyancy flux (m^2/s^3)
   REALTYPE                                      :: tRad(0:nlev),bRad(0:nlev)

!  Coriolis parameter (rad/s)
   REALTYPE                                      :: f


! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
   REALTYPE                            :: cff
   integer                             :: k

!
!-----------------------------------------------------------------------
!BOC
!
!-----------------------------------------------------------------------
! Update model grid
!-----------------------------------------------------------------------

!  Compute distance between centers (between rho-points)
!  Note that h is the distance between faces (between w-points)
   do k=1,nlev-1
      h_r(k) = 0.5*(h(k)+ h(k+1))
   enddo

!  Compute position of interfaces (w-points)
   z_w(0) = - h0
   do k=1,nlev
      z_w(k) = z_w(k-1) + h(k)
   enddo

!  Compute position of centers (rho-points)
   z_r(1) = - h0 + 0.5*h(1)
   do k=2,nlev
      z_r(k) = z_r(k-1) + h_r(k-1)
   enddo



!-----------------------------------------------------------------------
! compute interior mixing
!-----------------------------------------------------------------------

   if (kpp_interior) then
      call interior(nlev,NN,NNT,NNS,SS)
   else
      num = _ZERO_
      nuh = _ZERO_
      nus = _ZERO_
   endif


!-----------------------------------------------------------------------
! compute surface boundary layer mixing
!-----------------------------------------------------------------------

   if (kpp_sbl) then
      call surface_layer(nlev,h0,h,rho,u,v,NN,u_taus,u_taub,            &
                         tFlux,btFlux,sFlux,bsFlux,tRad,bRad,f)
   endif

!-----------------------------------------------------------------------
! compute bottom boundary layer mixing
!-----------------------------------------------------------------------

   if (kpp_bbl) then
      call bottom_layer(nlev,h0,h,rho,u,v,NN,u_taus,u_taub,             &
                        _ZERO_,_ZERO_,_ZERO_,_ZERO_,tRad,bRad,f)
   endif



 end subroutine do_kpp
!EOC



!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Compute interior fluxes \label{sec:kppInterior}
!
! !INTERFACE:
   subroutine interior(nlev,NN,NNT,NNS,SS)
!
! !DESCRIPTION:
! Here, the interior diffusivities (defined as the diffusivities outside the
! surface and bottom boundary layers) are computed. The algorithms are identical
! to those suggested by \cite{Largeetal94}. For numerical efficiency, the
! algorithms for different physical processes are active only if certain
! pre-processor macros are defined in {\tt cppdefs.h}.
! \begin{itemize}
!  \item The shear instability algorithm is active if the macro
!        {\tt KPP\_SHEAR} is defined.
!  \item The internal wave algorithm is active if the macro
!        {\tt KPP\_INTERNAL\_WAVE} is defined.
!  \item The convective instability algorithm is active if the macro
!        {\tt KPP\_CONVEC} is defined.
!  \item The double-diffusion algorithm is active if the macro
!        {\tt KPP\_DDMIX} is defined. Note that in this case, the
!        macro {\tt SALINITY} has to be defined as well.
! \end{itemize}

!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of grid cells
   integer                                       :: nlev

!  square of buoyancy frequency (1/s^2)
   REALTYPE                                      :: NN(0:nlev)

!  square of buoyancy frequencies caused by
!  temperature and salinity stratification
   REALTYPE                                      :: NNT(0:nlev),NNS(0:nlev)

!  square of shear frequency (1/s^2)
   REALTYPE                                      :: SS(0:nlev)


! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
   REALTYPE , parameter       :: eps=1.0E-14

   integer                    :: i
   REALTYPE                   :: cff,shear2
   REALTYPE                   :: nu_sx,nu_sxc
   REALTYPE                   :: iwm,iws
   REALTYPE                   :: drhoT,drhoS,Rrho,nu_dds,nu_ddt

!
!-----------------------------------------------------------------------
!BOC
!
!-----------------------------------------------------------------------
! Compute gradient Richardson number
!-----------------------------------------------------------------------
!
   do i=1,nlev-1
      Rig(i) = NN(i)/(SS(i) + eps)
   enddo

   Rig(0)    = _ZERO_
   Rig(nlev) = _ZERO_
!
!-----------------------------------------------------------------------
!  Compute "interior" viscosities and diffusivities everywhere as
!  the superposition of three processes: local Richardson number
!  instability due to resolved vertical shear, internal wave
!  breaking, and double diffusion.
!-----------------------------------------------------------------------
!
   do i=1,nlev-1
!
!     Smooth gradient Richardson number
      Rig(i)=0.25*Rig(i-1) + 0.50*Rig(i) + 0.25*Rig(i+1)
!
!     Compute interior diffusivity due to shear instability mixing.
# ifdef KPP_SHEAR
      cff=min(_ONE_,max(_ZERO_,Rig(i))/Ri0)
      nu_sx  = _ONE_-cff*cff
      nu_sx  = nu_sx*nu_sx*nu_sx
!
!     The shear mixing should be also a function of the actual magnitude
!     of the shear, see Polzin (1996, JPO, 1409-1425).
      shear2 = SS(i)
      cff    = shear2*shear2/(shear2*shear2+16.0E-10)
      nu_sx  = cff*nu_sx
# else KPP_SHEAR
      nu_sx=_ZERO_
# endif KPP_SHEAR

#ifdef KPP_INTERNAL_WAVE
!
!      Compute interior diffusivity due to wave breaking
!
!      Version A, see Gargett and Holloway (1984)
!      cff  =  _ONE_/sqrt(max(NN(i),1.0d-7))
!      iwm  =  1.0E-6*cff
!      iws  =  1.0E-7*cff

!     Version B, see Large et al. (1994)
      iwm  =  nuwm
      iws  =  nuws
#else
      iwm  =  _ZERO_
      iws  =  _ZERO_
#endif KPP_INTERNAL_WAVE


# ifdef KPP_CONVEC
!     Compute interior convective diffusivity due to static instability
!     mixing
      cff    =  max(NN(i),bvfcon)
      cff    =  min(_ONE_,(bvfcon-cff)/bvfcon)
      nu_sxc =  _ONE_-cff*cff
      nu_sxc =  nu_sxc*nu_sxc*nu_sxc
# else KPP_CONVEC
      nu_sxc =  _ZERO_
# endif KPP_CONVEC
!
!     Sum contributions due to internal wave breaking, shear instability
!     and convective diffusivity due to shear instability.
      num(i)=iwm+nu0m*nu_sx+nu0c*nu_sxc
      nuh(i)=iws+nu0s*nu_sx+nu0c*nu_sxc
      nus(i)=nuh(i)
!
# ifdef KPP_DDMIX
!
!-----------------------------------------------------------------------
!  Compute double-diffusive mixing.  It can occur when vertical
!  gradient of density is stable but the vertical gradient of
!  salinity (salt figering) or temperature (diffusive convection)
!  is unstable.
!-----------------------------------------------------------------------
!
!     Compute double-diffusive density ratio, Rrho.
      drhoT = NNT(i)
      drhoS = NNS(i)
      Rrho= - drhoT/drhoS
!
!
!     Salt fingering case.
      if ((Rrho.gt._ONE_).and.(drhoS.gt._ZERO_)) then
!
!        Compute interior diffusivity for double diffusive mixing of
!        salinity.  Upper bound "Rrho" by "Rrho0"; (Rrho0=1.9, nuf=0.001).
         Rrho=min(Rrho,Rrho0)
         nu_dds=_ONE_-((Rrho-_ONE_)/(Rrho0-_ONE_))**2.0
         nu_dds=nuf*nu_dds*nu_dds*nu_dds
!
!        Compute interior diffusivity for double diffusive mixing
!        of temperature (fdd=0.7).
         nu_ddt=fdd*nu_dds
!
!
!     Diffusive convection case.
      elseif ((_ZERO_.lt.Rrho).and.(Rrho.lt._ONE_).and.(drhoS.lt._ZERO_)) then
!
!        Compute interior diffusivity for double diffusive mixing of
!        temperature (Marmorino and Caldwell, 1976); (nu=1.5e-6,
!        tdd1=0.909, tdd2=4.6, tdd3=0.54).
         nu_ddt=nu*tdd1*exp(tdd2*exp(-tdd3*((_ONE_/Rrho)-_ONE_)))

!        Compute interior diffusivity for double diffusive mixing
!        of salinity (sdd1=0.15, sdd2=1.85, sdd3=0.85).
!
         if (Rrho.lt.0.5) then
            nu_dds=nu_ddt*sdd1*Rrho
         else
            nu_dds=nu_ddt*(sdd2*Rrho-sdd3)
         endif
      else
         nu_ddt=_ZERO_
         nu_dds=_ZERO_
      endif
!
!     Add double diffusion contribution to temperature and salinity
!     mixing coefficients.
      nuh(i)=nuh(i)  + nu_ddt
      nus(i)=nuh(i)  + nu_dds

# endif KPP_DDMIX

   enddo ! loop over interior points

 end subroutine interior
!EOC


!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Compute turbulence in the surface layer \label{sec:kppSurface}
!
! !INTERFACE:
   subroutine surface_layer(nlev,h0,h,rho,u,v,NN,u_taus,u_taub,       &
                            tFlux,btFlux,sFlux,bsFlux,tRad,bRad,f)
!
! !DESCRIPTION:
! In this routine all computations related to turbulence in the surface layer
! are performed. The algorithms are described in \sect{sec:kpp}. Note that these
! algorithms are affected by some pre-processor macros defined in {\tt cppdefs.inp},
! and by the parameters set in {\tt kpp.nml}, see \sect{sec:kpp}.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
!  number of grid cells
   integer                                       :: nlev

!  bathymetry (m)
   REALTYPE                                      :: h0

!  thickness of grid cells (m)
   REALTYPE                                      :: h(0:nlev)

!  potential density at grid centers (kg/m^3)
   REALTYPE                                      :: rho(0:nlev)

!  velocity components at grid centers (m/s)
   REALTYPE                                      :: u(0:nlev),v(0:nlev)

!  square of buoyancy frequency (1/s^2)
   REALTYPE                                      :: NN(0:nlev)

!  surface and bottom friction velocities (m/s)
   REALTYPE                                      :: u_taus,u_taub

!  surface temperature flux (K m/s) and
!  salinity flux (sal m/s) (negative for loss)
   REALTYPE                                      :: tFlux,sFlux

!  surface buoyancy fluxes (m^2/s^3) due to
!  heat and salinity fluxes
   REALTYPE                                      :: btFlux,bsFlux

!  radiative flux [ I(z)/(rho Cp) ] (K m/s)
!  and associated buoyancy flux (m^2/s^3)
   REALTYPE                                      :: tRad(0:nlev),bRad(0:nlev)

!  Coriolis parameter (rad/s)
   REALTYPE                                      :: f


!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
   REALTYPE, parameter          :: eps      = 1.0E-10

   integer                      :: k,ksbl

   REALTYPE                     :: Bo
   REALTYPE                     :: Bfsfc
   REALTYPE                     :: tRadSrf,tRadSbl
   REALTYPE                     :: bRadSrf,bRadSbl
   REALTYPE                     :: Gm1
   REALTYPE                     :: Gt1
   REALTYPE                     :: Gs1
   REALTYPE                     :: dGm1dS
   REALTYPE                     :: dGt1dS
   REALTYPE                     :: dGs1dS
   REALTYPE                     :: f1
   REALTYPE                     :: sl_dpth,sl_z
   REALTYPE                     :: swdk
   REALTYPE                     :: wm
   REALTYPE                     :: ws
   REALTYPE                     :: zgrid,depth

   REALTYPE                     :: Gm, Gt, Gs, K_bl, Ribot, Ritop, Rk, Rref
   REALTYPE                     :: Uk, Uref, Ustarb, Vk, Vref
   REALTYPE                     :: dR,dU,dV
   REALTYPE                     :: a1, a2, a3
   REALTYPE                     :: cff,cff_up,cff_dn
   REALTYPE                     :: c1,c2,c3
   REALTYPE                     :: dK_bl, hekman, hmonob, sigma, zbl

   REALTYPE, dimension (0:nlev) :: Bflux
   REALTYPE, dimension (0:nlev) :: FC


!-----------------------------------------------------------------------
!BOC
!
!
!-----------------------------------------------------------------------
!  Get approximation of surface layer depth using "epsilon" and
!  boundary layer depth from previous time step.
!-----------------------------------------------------------------------
!
   sl_dpth = epsilon*(z_w(nlev)-zsbl)
   sl_z    = epsilon*zsbl
!
!-----------------------------------------------------------------------
!  Compute total buoyancy flux at W-points.
!  Bo is negative, if heat is lost or salinity is gained (convection).
!  It does not include the short wave radiative flux at the surface.
!-----------------------------------------------------------------------
!
    tRadSrf   =   tRad(nlev)
    bRadSrf   =   bRad(nlev)

!  surface buoyancy flux (negative for buoyancy loss)
   Bo         = btFlux + bsFlux

!  include effect of short wave radiation
!  prepare non-local fluxes
   do k = 0,nlev
      Bflux(k)  = Bo  + ( bRadSrf - bRad(k) )
# ifdef NONLOCAL
      cff       = _ONE_-(0.5+sign(0.5d0,Bflux(k)))
      gamh(k)   =  -cff*( tFlux + tRadSrf - tRad(k) )
#  ifdef KPP_SALINITY
      gams(k)   =  -cff*sFlux
#  endif
# endif

   enddo

!-----------------------------------------------------------------------
!  Compute potential density and velocity components surface reference
!  values.
!-----------------------------------------------------------------------

!  simply use uppermost value
   Rref = rho(nlev)
   Uref =   u(nlev)
   Vref =   v(nlev)


!-----------------------------------------------------------------------
!  Compute critical function, FC, for bulk Richardson number
!-----------------------------------------------------------------------

   FC(0   ) = _ZERO_
   FC(nlev) = _ZERO_

   do k=nlev-1,2,-1

      depth=z_w(nlev)-z_w(k)

      if (Bflux(k).lt._ZERO_) then
         sigma=min(sl_dpth,depth)
      else
         sigma=depth
      endif

      call wscale (Bflux(k),u_taus,sigma,wm,ws)


#ifdef KPP_TWOPOINT_REF

!     interpolate reference value at grid face "k"
!     from values at grid centers

      cff = _ONE_/h_r(k)

      dR  = cff*( rho(k+1) - rho(k) )
      dU  = cff*( u  (k+1) - u  (k) )
      dV  = cff*( v  (k+1) - v  (k) )

      cff = _ONE_/2.0

      Rk  = rho(k) + h(k)*cff*dR
      Uk  =   u(k) + h(k)*cff*dU
      Vk  =   v(k) + h(k)*cff*dV

#else
!     identify reference value at grid face "k"
!     with value at center above

      Rk = rho(k+1)
      Uk =   u(k+1)
      Vk =   v(k+1)

!!$      c1 =  0.6
!!$      c2 =  0.2
!!$      c3 =  0.2
!!$
!!$      Rk = c1*rho(k+1) + c2*rho(k) + c3*rho(k-1)
!!$      Uk = c1*  u(k+1) + c2*  u(k) + c3*  u(k-1)
!!$      Vk = c1*  v(k+1) + c2*  v(k) + c3*  v(k-1)
#endif

!     compute numerator and denominator of Ri_b
      Ritop = -gorho0*(Rref-Rk)*depth

      Ribot = (Uref-Uk)**2+(Vref-Vk)**2 +                               &
              Vtc*depth*ws*sqrt(abs(NN(k)))

# ifdef KPP_IP_FC
      FC(k) = Ritop-Ric*Ribot
# else
      FC(k) = Ritop/(Ribot+eps)
# endif

   enddo  ! inner grid faces



!-----------------------------------------------------------------------
! Linearly interpolate to find "zsbl" where Rib/Ric=1.
!-----------------------------------------------------------------------

   ksbl = 1         ! ksbl is index of cell containing zsbl
   zsbl = z_w(0)

# ifdef KPP_IP_FC
!  look for position of vanishing F_crit
   do k=nlev,2,-1
      if ((ksbl.eq.1).and.(FC(k-1).gt._ZERO_)) then
         zsbl = (z_w(k)*FC(k-1)-z_w(k-1)*FC(k))/(FC(k-1)-FC(k))
         ksbl = k
      endif
   enddo
# else
!  look for position of vanishing Ri_b
   do k=nlev,2,-1
      if ((ksbl.eq.1).and.((FC(k).lt.Ric).and.(FC(k-1).ge.Ric))) then
         zsbl = ((FC(k-1)-Ric)*z_w(k) -                                 &
                         (FC(k)-Ric)*z_w(k-1))/(FC(k-1)-FC(k))
         ksbl = k
      endif
   enddo
# endif



!-----------------------------------------------------------------------
!  Compute total buoyancy flux at surface boundary layer depth
!-----------------------------------------------------------------------

!  interpolate from interface values to zsbl
   bRadSbl = ( bRad(ksbl-1)*(z_w(ksbl)-zsbl) +                                &
               bRad(ksbl  )*(zsbl-z_w(ksbl-1) ) )/ h(ksbl)

   Bfsfc   = Bo + (bRadSrf - bRadsbl)


!-----------------------------------------------------------------------
!  Limit boundary layer depth by Ekman and Monin-Obukhov depths
!  (under neutral and stable conditions)
!-----------------------------------------------------------------------

   if (clip_mld) then
      if ((u_taus.gt._ZERO_).and.(Bfsfc.gt._ZERO_)) then
         hekman = cekman*u_taus/max(abs(f),eps)
         hmonob = cmonob*u_taus*u_taus*u_taus/max(kappa*Bfsfc,eps)
         zsbl   = (z_w(nlev)-min(hekman,hmonob,z_w(nlev)-zsbl))
      endif
   endif


   zsbl = min(zsbl,z_w(nlev))
   zsbl = max(zsbl,z_w(0   ))

!  find new boundary layer index "ksbl".
   ksbl=1
   do k=nlev,2,-1
      if ((ksbl.eq.1).and.(z_w(k-1).lt.zsbl)) then
         ksbl = k
      endif
   enddo


!-----------------------------------------------------------------------
!  Compute total buoyancy flux at surface boundary layer depth
!-----------------------------------------------------------------------


   bRadSbl = ( bRad(ksbl-1)*(z_w(ksbl)-zsbl) +                          &
               bRad(ksbl  )*(zsbl-z_w(ksbl-1) ) )/ h(ksbl)


   Bfsfc   = Bo + (bRadSrf - bRadSbl)

!-----------------------------------------------------------------------
!  Compute tubulent velocity scales (wm,ws) at "zsbl".
!-----------------------------------------------------------------------

   zbl     = z_w(nlev)-zsbl
   sl_dpth = epsilon*zbl

   if (Bfsfc.gt._ZERO_) then
      cff  = _ONE_
   else
      cff  = epsilon
   endif

   sigma=cff*(z_w(nlev)-zsbl)

   call wscale (Bfsfc,u_taus,sigma,wm,ws)


!-----------------------------------------------------------------------
!  Compute nondimensional shape function Gx(sigma) in terms of the
!  interior diffusivities at sigma=1 (Gm1, Gs1, Gt1) and its vertical
!  derivative evaluated "zsbl" via interpolation.
!-----------------------------------------------------------------------

!   original code with kappa-bug
!   f1 = 5.0*max(_ZERO_,Bfsfc)*kappa/(u_taus*u_taus*u_taus*u_taus+eps)

!  new code code without kappa-bug
   f1 = 5.0*max(_ZERO_,Bfsfc)/(u_taus*u_taus*u_taus*u_taus+eps)

   if (zsbl.gt.z_w(1)) then
      ! if boundary layer does not touch lowest grid box

!     abbreviation for "ksbl"
      k      = ksbl
      cff    = _ONE_/h(k)
      cff_dn = cff*(zsbl-z_w(k-1))
      cff_up = cff*(z_w(k)-zsbl  )

!  Compute nondimensional shape function for viscosity "Gm1" and its
!  vertical derivative "dGm1dS" evaluated at "zsbl".

      K_bl   = cff_dn*num(k)+cff_up*num(k-1)
      dK_bl  = cff*(num(k)-num(k-1))
      Gm1    = K_bl/(zbl*wm+eps)

# ifdef KPP_CLIP_GS
      dGm1dS = min(_ZERO_,-dK_bl/(wm+eps)-K_bl*f1)
# else
      dGm1dS = -dK_bl/(wm+eps) + K_bl*f1
# endif

!  Compute nondimensional shape function for diffusion of temperature
!  "Gt1" and its vertical derivative "dGt1dS" evaluated at "zsbl".
!
      K_bl   = cff_dn*nuh(k)+cff_up*nuh(k-1)
      dK_bl  = cff*(nuh(k)-nuh(k-1))
      Gt1    = K_bl/(zbl*ws+eps)

# ifdef KPP_CLIP_GS
      dGt1dS = min(_ZERO_,-dK_bl/(ws+eps)-K_bl*f1)
# else
      dGt1dS = -dK_bl/(ws+eps) + K_bl*f1
# endif

# ifdef KPP_SALINITY
!
!  Compute nondimensional shape function for diffusion of salinity
!  "Gs1" and its vertical derivative "dGs1dS" evaluated at "zsbl".
!
      K_bl   = cff_dn*nus(k)+cff_up*nus(k-1)
      dK_bl  = cff*(nus(k)-nus(k-1))
      Gs1    = K_bl/(zbl*ws+eps)

# ifdef KPP_CLIP_GS
      dGs1dS = min(_ZERO_,-dK_bl/(ws+eps)-K_bl*f1)
# else
      dGs1dS = -dK_bl/(ws+eps) + K_bl*f1
# endif

# endif


   else
!     If the surface boundary layer extends to the bottom, assume that
!     the neutral boundary layer similarity theory holds at the bottom.
!
      dK_bl  = kappa*u_taub
      K_bl   = dK_bl*(zsbl-z_w(0))

!     Compute nondimensional bottom shape function for diffusion of
!     momentum

      Gm1    = K_bl/(zbl*wm+eps)

# ifdef KPP_CLIP_GS
      dGm1dS = min(_ZERO_,-dK_bl/(wm+eps)-K_bl*f1)
# else
      dGm1dS = -dK_bl/(wm+eps) + K_bl*f1
# endif


!     Compute nondimensional bottom shape function for diffusion of
!     temperature.

      Gt1    = K_bl/(zbl*ws+eps)

# ifdef KPP_CLIP_GS
      dGs1dS = min(_ZERO_,-dK_bl/(ws+eps)-K_bl*f1)
# else
      dGs1dS = -dK_bl/(ws+eps) + K_bl*f1
# endif

!     Compute nondimensional bottom shape function for diffusion of
!     salinity.
# ifdef KPP_SALINITY
      Gs1    = Gt1
      dGs1dS = dGt1dS
# endif

   endif
!
!-----------------------------------------------------------------------
!  Compute surface boundary layer mixing coefficients
!-----------------------------------------------------------------------
!
!  loop over the inner interfaces
!  (the outermost are not needed)
   do k=1,nlev-1

      if (k.ge.ksbl) then    ! interface above cell containing zsbl

!        Compute turbulent velocity scales at vertical W-points.
         depth=z_w(nlev)-z_w(k)
         if (Bflux(k).lt._ZERO_) then
            sigma=min(sl_dpth,depth)
         else
            sigma=depth
         endif

         call wscale(Bflux(k),u_taus,sigma,wm, ws)
!
!        Set polynomial coefficients for shape function.
         sigma = depth/(zbl+eps)

         a1    = sigma-2.0
         a2    = 3.0-2.0*sigma
         a3    = sigma-1.0
!
!        Compute nondimesional shape functions.
         Gm = a1+a2*Gm1+a3*dGm1dS
         Gt = a1+a2*Gt1+a3*dGt1dS
# ifdef KPP_SALINITY
         Gs = a1+a2*Gs1+a3*dGs1dS
# endif

!        Compute boundary layer mixing coefficients, combine them
!        with interior mixing coefficients.
         num(k) = depth*wm*(_ONE_+sigma*Gm)
         nuh(k) = depth*ws*(_ONE_+sigma*Gt)
# ifdef KPP_SALINITY
         nus(k) = depth*ws*(_ONE_+sigma*Gs)
# endif
# ifdef NONLOCAL
!        Compute boundary layer nonlocal transport (m/s2).
         cff      = Cg*(_ONE_-(0.5+sign(0.5d0,Bflux(k))))/(zbl*ws+eps)
         gamh(k) = cff*nuh(k)*gamh(k)
#  ifdef KPP_SALINITY
         gams(k) = cff*nus(k)*gams(k)
#  endif
# endif


!     Set non-local transport terms to zero outside boundary  layer.
      else
# ifdef NONLOCAL
         gamh(k) = _ZERO_
#  ifdef KPP_SALINITY
         gams(k) = _ZERO_
#  endif
# endif
      endif


   enddo

!     not non-local fluxes at top and bottom
      gamh(0   ) = _ZERO_
      gams(0   ) = _ZERO_
      gamh(nlev) = _ZERO_
      gams(nlev) = _ZERO_


 end subroutine surface_layer
!EOC




!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Compute turbulence in the bottom layer \label{sec:kppBottom}
!
! !INTERFACE:
   subroutine bottom_layer(nlev,h0,h,rho,u,v,NN,u_taus,u_taub, &
                            tFlux,btFlux,sFlux,bsFlux,tRad,bRad,f)
!
! !DESCRIPTION:
! In this routine all computations related to turbulence in the bottom layer
! are performed. The algorithms are described in \sect{sec:kpp}. Note that these
! algorithms are affected by some pre-processor macros defined in {\tt cppdefs.inp},
! and by the parameters set in {\tt kpp.nml}, see \sect{sec:kpp}.

! The computation of the bulk Richardson number is slightly different from the
! surface boundary layer, since for the bottom boundary layer this quantity
! is defined as,
! \begin{equation}
!   \label{RibBottom}
!   Ri_b = \dfrac{(B(z_{bl})-B_r) d}
!                {\magn{\V U(z_{bl})-\V U_r}^2 + V_t^2(z_{bl})}
! \comma
! \end{equation}
! where $z_{bl}$ denotes the position of the edge of the bottom boundary layer.
!
! Also different from the surface layer computations is the absence of non-local
! fluxes.

! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of grid cells
   integer                                       :: nlev

!  bathymetry (m)
   REALTYPE                                      :: h0

!  thickness of grid cells (m)
   REALTYPE                                      :: h(0:nlev)

!  potential density at grid centers (kg/m^3)
   REALTYPE                                      :: rho(0:nlev)

!  velocity components at grid centers (m/s)
   REALTYPE                                      :: u(0:nlev),v(0:nlev)

!  square of buoyancy frequency (1/s^2)
   REALTYPE                                      :: NN(0:nlev)

!  surface and bottom friction velocities (m/s)
   REALTYPE                                      :: u_taus,u_taub

!  bottom temperature flux (K m/s) and
!  salinity flux (sal m/s) (negative for loss)
   REALTYPE                                      :: tFlux,sFlux

!  bottom buoyancy fluxes (m^2/s^3) due to
!  heat and salinity fluxes
   REALTYPE                                      :: btFlux,bsFlux

!  radiative flux [ I(z)/(rho Cp) ] (K m/s)
!  and associated buoyancy flux (m^2/s^3)
   REALTYPE                                      :: tRad(0:nlev),bRad(0:nlev)

!  Coriolis parameter (rad/s)
   REALTYPE                                      :: f

!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
   REALTYPE, parameter          :: eps      = 1.0E-10

   integer                      :: k,kbbl

   REALTYPE                     :: Bo
   REALTYPE                     :: Bfbot
   REALTYPE                     :: tRadBot,tRadBbl
   REALTYPE                     :: bRadBot,bRadBbl
   REALTYPE                     :: Gm1
   REALTYPE                     :: Gt1
   REALTYPE                     :: Gs1
   REALTYPE                     :: dGm1dS
   REALTYPE                     :: dGt1dS
   REALTYPE                     :: dGs1dS
   REALTYPE                     :: f1
   REALTYPE                     :: bl_dpth,bl_z
   REALTYPE                     :: swdk
   REALTYPE                     :: wm
   REALTYPE                     :: ws
   REALTYPE                     :: zgrid,depth

   REALTYPE                     :: Gm, Gt, Gs, K_bl, Ribot, Ritop, Rk, Rref
   REALTYPE                     :: Uk, Uref, Ustarb, Vk, Vref
   REALTYPE                     :: dR,dU,dV
   REALTYPE                     :: a1, a2, a3
   REALTYPE                     :: cff,cff_up, cff_dn
   REALTYPE                     :: dK_bl, hekman, hmonob, sigma, zbl

   REALTYPE, dimension (0:nlev) :: Bflux
   REALTYPE, dimension (0:nlev) :: FC


!-----------------------------------------------------------------------
!BOC
!
!
!-----------------------------------------------------------------------
!  Get approximation of bottom layer depth using "epsilon" and
!  boundary layer depth from previous time step.
!-----------------------------------------------------------------------
!
   bl_dpth = epsilon*(zbbl-z_w(0))
   bl_z    = epsilon*zbbl

!-----------------------------------------------------------------------
!  Compute total buoyancy flux (m2/s3) at W-points.
!-----------------------------------------------------------------------
!
    tRadBot   =   tRad(0)
    bRadBot   =   bRad(0)

!  bottom buoyancy flux
!  (negative for buoyancy gain)
   Bo         = - (btFlux + bsFlux)

!  include effect of short-wave radiation
   do k = 0,nlev
      Bflux(k)  = Bo + ( bRad(k) - bRadBot )
   enddo


!-----------------------------------------------------------------------
!  Compute potential density and velocity components bottom reference
!  values.
!-----------------------------------------------------------------------


!  simply use lowest value
   Rref = rho(1)
   Uref =   u(1)
   Vref =   v(1)


!-----------------------------------------------------------------------
!  Compute critical function, FC, for bulk Richardson number
!-----------------------------------------------------------------------

   FC(0   ) = _ZERO_
   FC(nlev) = _ZERO_

   do k=1,nlev-1

      depth=z_w(k)-z_w(0)

      if (Bflux(k).lt._ZERO_) then
         sigma=min(bl_dpth,depth)
      else
         sigma=depth
      endif

      call wscale (Bflux(k),u_taub,sigma,wm,ws)



#ifdef KPP_TWOPOINT_REF

!     interpolate reference value at grid face "k"
!     from values at grid centers

      cff = _ONE_/h_r(k)

      dR  = cff*( rho(k+1) - rho(k) )
      dU  = cff*( u  (k+1) - u  (k) )
      dV  = cff*( v  (k+1) - v  (k) )

      cff = _ONE_/2.0

      Rk  = rho(k) + h(k)*cff*dR
      Uk  =   u(k) + h(k)*cff*dU
      Vk  =   v(k) + h(k)*cff*dV

#else
!     identify reference value at grid face "k"
!     with value at center below
      Rk  = rho(k)
      Uk  =   u(k)
      Vk  =   v(k)
#endif

!     compute numerator and denominator of Ri_b
      Ritop = -gorho0*(Rk-Rref)*depth
      Ribot = (Uk-Uref)**2+(Vk-Vref)**2 +                              &
              Vtc*depth*ws*sqrt(abs(NN(k)) )

# ifdef KPP_IP_FC
      FC(k)=Ritop-Ric*Ribot
# else
      FC(k)=Ritop/(Ribot+eps)
# endif

   enddo ! inner grid faces



!-----------------------------------------------------------------------
! Linearly interpolate to find "zbbl" where Rib/Ric=1.
!-----------------------------------------------------------------------

   kbbl = nlev           ! kbbl is  index of cell containing zbbl
   zbbl = z_w(nlev)

# ifdef KPP_IP_FC
!  look for position of vanishing F_crit
   do k=1,nlev-1
      if ((kbbl.eq.nlev).and.(FC(k).gt._ZERO_)) then
         zbbl = (z_w(k)*FC(k-1)-z_w(k-1)*FC(k))/(FC(k-1)-FC(k))
         kbbl = k
      endif
   enddo
# else
!  look for position of vanishing Ri_b
   do k=1,nlev-1
      if ((kbbl.eq.nlev).and.((FC(k-1).lt.Ric).and.(FC(k).ge.Ric))) then
         zbbl = ( (Ric  -  FC(k-1) )*z_w(k  ) +                         &
                  (FC(k) - Ric     )*z_w(k-1) )/(FC(k)-FC(k-1))
         kbbl = k
      endif
   enddo
# endif


!-----------------------------------------------------------------------
!  Limit boundary layer thickness by Ekman scale
!-----------------------------------------------------------------------

   if (clip_mld) then
      if (u_taub.gt._ZERO_) then
         hekman = cekman*u_taub/max(abs(f),eps)
         zbbl   = min(z_w(0)+hekman,zbbl)
      endif
   endif

   zbbl = min(zbbl,z_w(nlev))
   zbbl = max(zbbl,z_w(0   ))

!  find new boundary layer index "kbbl".
   kbbl=nlev
   do k=1,nlev-1
      if ((kbbl.eq.nlev).and.(z_w(k).gt.zbbl)) then
         kbbl = k
      endif
   enddo

!-----------------------------------------------------------------------
!  Compute total buoyancy flux at bottom boundary layer depth
!-----------------------------------------------------------------------

   bRadBbl = ( bRad(kbbl-1)*(z_w(kbbl)-zbbl)  +                         &
               bRad(kbbl  )*(zbbl-z_w(kbbl-1) ) )/ h(kbbl)

   Bfbot   = Bo + (bRadBbl-bRadBot)


!-----------------------------------------------------------------------
!  Compute tubulent velocity scales (wm,ws) at "zbbl".
!-----------------------------------------------------------------------

   zbl     = zbbl-z_w(0)
   bl_dpth = epsilon*zbl

   if (Bfbot.gt._ZERO_) then
      cff  = _ONE_
   else
      cff  = epsilon
   endif

   sigma=cff*zbl

   call wscale (Bfbot,u_taub,sigma,wm,ws)


!-----------------------------------------------------------------------
!  Compute nondimensional shape function Gx(sigma) in terms of the
!  interior diffusivities at sigma=1 (Gm1, Gs1, Gt1) and its vertical
!  derivative evaluated "zbbl" via interpolation.
!-----------------------------------------------------------------------

!  original code with kappa-bug
!   f1 = 5.0*max(_ZERO_,Bfbot)*kappa/(u_taub*u_taub*u_taub*u_taub+eps)

!   new code without kappa-bug
   f1 = 5.0*max(_ZERO_,Bfbot)/(u_taub*u_taub*u_taub*u_taub+eps)

   k      = kbbl
   cff    = _ONE_/h(k)
   cff_dn = cff*(zbbl-z_w(k-1))
   cff_up = cff*(z_w(k)-zbbl  )

!  Compute nondimensional shape function for viscosity "Gm1" and its
!  vertical derivative "dGm1dS" evaluated at "zbbl".

   K_bl   =  cff_dn*num(k)+cff_up*num(k-1)
   dK_bl  =  cff*(num(k)-num(k-1))
   Gm1    =  K_bl/(zbl*wm+eps)

# ifdef KPP_CLIP_GS
   dGm1dS = min(_ZERO_,dK_bl/(wm+eps)+K_bl*f1)
# else
   dGm1dS = dK_bl/(wm+eps) + K_bl*f1
# endif

!
!  Compute nondimensional shape function for diffusion of temperature
!  "Gt1" and its vertical derivative "dGt1dS" evaluated at "zbbl".
!
   K_bl   =  cff_dn*nuh(k)+cff_up*nuh(k-1)
   dK_bl  =  cff*(nuh(k)-nuh(k-1))
   Gt1    =   K_bl/(zbl*ws+eps)


# ifdef KPP_CLIP_GS
   dGt1dS = min(_ZERO_,dK_bl/(ws+eps)+K_bl*f1)
# else
   dGt1dS = dK_bl/(ws+eps) + K_bl*f1
# endif

# ifdef KPP_SALINITY
!
!  Compute nondimensional shape function for diffusion of salinity
!  "Gs1" and its vertical derivative "dGs1dS" evaluated at "zbbl".
!
   K_bl   =  cff_dn*nus(k)+cff_up*nus(k-1)
   dK_bl  =  cff*(nus(k)-nus(k-1))
   Gs1    =   K_bl/(zbl*ws+eps)

# ifdef KPP_CLIP_GS
   dGs1dS = min(_ZERO_,dK_bl/(ws+eps)+K_bl*f1)
# else
   dGs1dS = dK_bl/(ws+eps) + K_bl*f1
# endif

# endif

!
!-----------------------------------------------------------------------
!  Compute bottom boundary layer mixing coefficients
!-----------------------------------------------------------------------
!
!  loop over the inner interfaces
!  (the outermost are not needed)
   do k=1,nlev-1

      if (k.lt.kbbl) then

!        Compute turbulent velocity scales at vertical W-points.
         depth=z_w(k)-z_w(0)
         if (Bflux(k).lt._ZERO_) then
            sigma=min(bl_dpth,depth)
         else
            sigma=depth
         endif

         call wscale(Bflux(k),u_taub,sigma,wm, ws)
!
!        Set polynomial coefficients for shape function.
         sigma = depth/(zbl+eps)

         a1    = sigma-2.0
         a2    = 3.0-2.0*sigma
         a3    = sigma-1.0
!
!        Compute nondimesional shape functions.

         Gm = a1+a2*Gm1+a3*dGm1dS
         Gt = a1+a2*Gt1+a3*dGt1dS
# ifdef KPP_SALINITY
         Gs = a1+a2*Gs1+a3*dGs1dS
# endif
!
!        Compute boundary layer mixing coefficients, combine them
!        with interior mixing coefficients.
         num(k) = depth*wm*(_ONE_+sigma*Gm)
         nuh(k) = depth*ws*(_ONE_+sigma*Gt)
# ifdef KPP_SALINITY
         nus(k) = depth*ws*(_ONE_+sigma*Gs)
# endif

      endif
   enddo



 end subroutine bottom_layer
!EOC


!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Compute the velocity scale\label{sec:wscale}
!
! !INTERFACE:
   subroutine wscale(Bfsfc,u_taus,d,wm,ws)
!
! !DESCRIPTION:
!  This routine computes the turbulent velocity scale for momentum
!  and tracer as a function of the turbulent friction velocity, $u_*$,
!  the "limited" distance, $d_\text{lim}$, and the total buoyancy
!  flux, $B_f$, according to
!  \begin{equation}
!    \label{wscale}
!     w_\phi = \dfrac{\kappa u_*}{\Phi_\phi (\zeta)}
!     \point
!  \end{equation}
! In this equation, $\Phi_\phi$ is a non-dimensional function of the
! stability parameter $\zeta=d_\text{lim}/L$, using the Monin-Obukhov
! length,
!  \begin{equation}
!    \label{MOLength}
!     L = \dfrac{u_*^3}{\kappa B_f}
!     \point
!  \end{equation}
! In stable situations, $B_f \ge 0$, the length scale $d_\text{lim}$ is just the distance
! from the surface or bottom, $d$. Then, the non-dimensional function is of the form
! \begin{equation}
!   \label{PhiStable}
!   \Phi_\phi = 1 + \zeta
! \comma
! \end{equation}
! and identical for momentum, heat, and tracers.
!
! In unstable situations, $B_f < 0$, the scale $d_\text{lim}$ corresponds
! to the distance from surface or bottom only until it reaches the end of
! the surface (or bottom) layer at $d=\epsilon h$. Then it stays constant
! at this maximum value.
!
! The different functional forms of $\Phi_\phi(\zeta)$ for unstable flows
! are discussed in \cite{Largeetal94}.


! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  buoyancy flux (m^2/s^3)
   REALTYPE, intent(in)                :: Bfsfc

!  friction velocity (m/s)
   REALTYPE, intent(in)                :: u_taus

!  (limited) distance (m)
   REALTYPE, intent(in)                :: d
!
! !OUTPUT PARAMETERS:

!  velocity scale (m/s)
!  for momentum and tracer
   REALTYPE, intent(out)               :: wm, ws
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
   REALTYPE, parameter                 :: eps = 1.0E-20
   REALTYPE, parameter                 :: r3  = 1.0/3.0

   REALTYPE                            :: u_taus3, zetahat, zetapar
!
!-----------------------------------------------------------------------
!BOC
!
!  pre-compute some quantities for faster execution
   u_taus3=u_taus*u_taus*u_taus
   zetahat=kappa*d*Bfsfc
   zetapar=zetahat/(u_taus3+eps)

   if (zetahat.ge._ZERO_) then
!     stable or neutral water column
      wm=kappa*u_taus/(_ONE_+5.0*zetapar)
      ws=wm
   else
!     instable water column
      if (zetapar.gt.zetam) then
         wm=kappa*u_taus*(_ONE_-16.0*zetapar)**0.25
      else
         wm=kappa*(am*u_taus3-cm*zetahat)**r3
      endif
      if (zetapar.gt.zetas) then
         ws=kappa*u_taus*(_ONE_-16.0*zetapar)**0.5
      else
         ws=kappa*(as*u_taus3-cs*zetahat)**r3
      endif
   endif

 end subroutine wscale
!EOC

! !IROUTINE: Clean up the kpp module
!
! !INTERFACE:
   subroutine clean_kpp()
!
! !DESCRIPTION:
!  De-allocate all memory allocated in init\_kpp().
!
! !USES:
   IMPLICIT NONE
!
! !REVISION HISTORY:
!  Original author(s): Jorn Bruggeman
!
!EOP
!-----------------------------------------------------------------------
!BOC
   LEVEL1 'clean_kpp'

   LEVEL2 'de-allocating KPP memory ...'
   if (allocated(num)) deallocate(num)
   if (allocated(nuh)) deallocate(nuh)
   if (allocated(nus)) deallocate(nus)
   if (allocated(gamu)) deallocate(gamu)
   if (allocated(gamv)) deallocate(gamv)
   if (allocated(gamh)) deallocate(gamh)
   if (allocated(gams)) deallocate(gams)
   if (allocated(Rig)) deallocate(Rig)
   if (allocated(z_w)) deallocate(z_w)
   if (allocated(z_r)) deallocate(z_r)
   if (allocated(h_r)) deallocate(h_r)

# ifdef EXTRA_OUTPUT

   if (allocated(turb1)) deallocate(turb1)
   if (allocated(turb2)) deallocate(turb2)
   if (allocated(turb3)) deallocate(turb3)
   if (allocated(turb4)) deallocate(turb4)
   if (allocated(turb5)) deallocate(turb5)

# endif

   return
   end subroutine clean_kpp

!-----------------------------------------------------------------------


!-----------------------------------------------------------------------

 end module kpp

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

                 module zetac_clouds_W_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  sak
! </REVIEWER>
! <OVERVIEW>
!    zetac_clouds_W_mod obtains the cloud specification variables
!    for the zetac cloud parameterization from microphys_cloud_mod
!    and makes them available to the radiation package.
! </OVERVIEW>
! <DESCRIPTION>
! </DESCRIPTION>

!   shared modules:
use mpp_mod,                only: input_nml_file
use fms_mod,                only: open_namelist_file, mpp_pe, &
                                  mpp_root_pe, stdlog,  fms_init, &
                                  write_version_number, file_exist, &
                                  check_nml_error, error_mesg,   &
                                  FATAL, close_file
use constants_mod,          only: GRAV, constants_init

!   shared radiation package modules:

use rad_utilities_mod,      only: rad_utilities_init, &
                                  cld_specification_type, &
                                  microphysics_type

!   cloud parameterization module:

use microphys_cloud_mod,     only: microphys_cloud_init, microphys_cloud

!--------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!    zetac_clouds_W_mod obtains the cloud specification variables
!    for the zetac cloud parameterization from microphys_cloud_mod
!    and makes them available to the radiation package.
!--------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module --------------------------

character(len=128)  :: version =  '$Id: zetac_clouds_W.F90,v 19.0 2012/01/06 20:25:17 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!---------------------------------------------------------------------
!-------  interfaces --------

public          &
          zetac_clouds_W_init, zetac_clouds_amt, zetac_clouds_W_end

!---------------------------------------------------------------------
!-------- namelist  ---------

integer   :: dummy = 0


namelist /zetac_clouds_W_nml /                      &
                                 dummy


!----------------------------------------------------------------------
!----  public data -------


!----------------------------------------------------------------------
!----  private data -------


logical :: module_is_initialized = .false.  ! module is initialized ?


!----------------------------------------------------------------------
!----------------------------------------------------------------------



                              contains 



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!#####################################################################
! <SUBROUTINE NAME="zetac_clouds_W_init">
!  <OVERVIEW>
!    zetac_clouds_W_init is the constructor for zetac_clouds_W_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    zetac_clouds_W_init is the constructor for zetac_clouds_W_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call zetac_clouds_W_init
!  </TEMPLATE>
! </SUBROUTINE>
!  
subroutine zetac_clouds_W_init 

!---------------------------------------------------------------------
!    zetac_clouds_W_init is the constructor for zetac_clouds_W_mod.
!---------------------------------------------------------------------

!----------------------------------------------------------------------
!   local variables:

      integer   ::   unit, ierr, io, logunit

!--------------------------------------------------------------------
!   local variables:
!
!      unit     io unit for reading nml file and writing logfile
!      ierr     error code
!      io       error status returned from io operation  
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return

!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call rad_utilities_init
      call constants_init
      call microphys_cloud_init

!---------------------------------------------------------------------
!    read namelist.         
!---------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=zetac_clouds_W_nml, iostat=io)
      ierr = check_nml_error(io,"zetac_clouds_W_nml")
#else
      if (file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read (unit, nml=zetac_clouds_W_nml, iostat=io, end=10) 
        ierr = check_nml_error (io, 'zetac_clouds_W_nml')
        enddo                       
10      call close_file (unit)      
      endif                         
#endif

!----------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                 write (logunit, nml=zetac_clouds_W_nml)

!---------------------------------------------------------------------
!    mark the module as initialized.
!---------------------------------------------------------------------
      module_is_initialized = .true.

!----------------------------------------------------------------------


end subroutine zetac_clouds_W_init



!######################################################################
! <SUBROUTINE NAME="zetac_clouds_amt">
!  <OVERVIEW>
!    zetac_clouds_amt defines the location, amount (cloud fraction), 
!    and number of clouds present on the model grid, in addition to
!    liquid and ice-water paths, cloud thickness, and effective drop 
!    and crystal sizes. 
!  </OVERVIEW>
!  <DESCRIPTION>
!    zetac_clouds_amt defines the location, amount (cloud fraction), 
!    and number of clouds present on the model grid, in addition to
!    liquid and ice-water paths, cloud thickness, and effective drop 
!    and crystal sizes. if a microphysically-based cloud parameter-
!    ization is being used, particle sizes and concentrations are also
!    provided.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call zetac_clouds_amt (is, ie, js, je, z_half, z_full, land, &
!                             phalf, deltaz, Cld_spec, Lsc_microphys)
!  </TEMPLATE>
!  <IN NAME="is, ie, js, je" TYPE="integer">
!   starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
!  </IN>
!  <IN NAME="pflux" TYPE="real">
!   pressure values at flux levels (average of pressure values at
!   model grid points
!  </IN>
!  <IN NAME="press" TYPE="real">
!   pressure values at model grid points. surface 
!                   pressure is stored at index value nlev+1
!  </IN>
!  <IN NAME="temp" TYPE="real">
!    temperature at model levels (1:nlev), to be used
!                   in cloud calculations
!  </IN>
!  <IN NAME="land" TYPE="real">
!   fraction of grid box covered by land
!  </IN>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
!   cld_specification_type variable containing the 
!                   cloud specification input fields needed by the 
!                   radiation package
!  </INOUT>
!  <INOUT NAME="Lsc_microphys" TYPE="microphys_type">
!   microphysics_type variable containing the size,
!                   concentration and fraction of the four condensate 
!                   types (cloud drop, cloud ice, rain, snow) in the 
!                   grid box, present when microphysically-based
!                   cloud radiation properties are desired.
!  </INOUT>
! </SUBROUTINE>
!
subroutine zetac_clouds_amt (is, ie, js, je, z_half, z_full, land, &
                             phalf, deltaz,  &
                             Cld_spec, Lsc_microphys)

!---------------------------------------------------------------------
!    zetac_clouds_amt defines the location, amount (cloud fraction), 
!    and number of clouds present on the model grid, in addition to
!    liquid and ice-water paths, cloud thickness, and effective drop 
!    and crystal sizes. if a microphysically-based cloud parameter-
!    ization is being used, particle sizes and concentrations are also
!    provided.
!----------------------------------------------------------------------

integer,                      intent(in)        :: is, ie, js, je
real,    dimension(:,:,:),    intent(in)        :: z_half, z_full, &
                                                   phalf, deltaz
real,    dimension(:,:),      intent(in)        :: land
type(cld_specification_type), intent(inout)     :: Cld_spec      
type(microphysics_type),      intent(inout)     :: Lsc_microphys

!----------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      pflux        average of pressure at adjacent model levels
!                   [ (kg /( m s^2) ] 
!      press        pressure at model levels (1:nlev), surface 
!                   pressure is stored at index value nlev+1
!                   [ (kg /( m s^2) ]
!      temp         temperature at model levels (1:nlev), to be used
!                   in cloud calculations
!                   [ deg K ]
!      land         fraction of grid box covered by land
!                   [ non-dimensional ]
!
!   intent(inout), optional variables:
!
!      Cld_spec     cld_specification_type variable containing the 
!                   cloud specification input fields needed by the 
!                   radiation package
!
!               the following elements of Cld_spec are defined here:
!
!                  %cmxolw  fraction of maximally overlapped clouds
!                           seen by the longwave radiation 
!                           [ dimensionless ]
!                  %crndlw  fraction of randomly overlapped clouds
!                           seen by the longwave radiation 
!                           [ dimensionless ]
!                  %camtsw  cloud fraction seen by the shortwave
!                           radiation; the sum of the maximally
!                           overlapped and randomly overlapped 
!                           longwave cloud fractions  [ dimensionless ]
!                  %nmxolw  number of maximally overlapped longwave 
!                           clouds in each grid column.
!                  %nrndlw  number of randomly overlapped longwave 
!                           clouds in each grid column.
!                  %ncldsw  number of clouds seen by the shortwave
!                           radiation in each grid column.
!                  %cloud_thickness
!                           number of model layers over which the cloud
!                           in this grid box extends
!                  %lwp     liquid water path 
!                           [ kg / m^2 ]
!                  %iwp     ice water path
!                           [ kg / m^2 ]
!                  %reff_liq
!                           effective drop radius [ microns ]
!                  %reff_ice
!                           effective ice particle size [ microns ]
!
!      Lsc_microphys
!                   microphysics_type variable containing the size,
!                   concentration and fraction of the four condensate 
!                   types (cloud drop, cloud ice, rain, snow) in the 
!                   grid box, present when microphysically-based
!                   cloud radiation properties are desired.
!
!               the following components of this variable are output 
!               from this routine when microphysically-based properties
!               are desired:
!
!                  %conc_ice  ice particle concentration [ g /m^3 ]
!                  %conc_drop cloud droplet concentration [ g /m^3 ]
!                  %size_ice  ice particle effective diameter 
!                  [ microns ]
!                  %size_drop cloud droplet effective diameter
!                  [ microns ]
!
!----------------------------------------------------------------------

!-------------------------------------------------------------------
!    local variables

      integer :: idim, jdim, kdim
      integer :: i, j
      real, dimension (size(z_full,1), size(z_full,2),   &
                       size(z_full,3)) ::    deltap, diam_ice, diam_liq

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('zetac_clouds_W_mod',   &
             'module has not been initialized', FATAL )
      endif


      idim = size (z_full,1)
      jdim = size (z_full,2)
      kdim = size (z_full,3)

      where ( Cld_spec%cloud_area > 0.0 ) 
        Cld_spec%cld_thickness = 1
      elsewhere
        Cld_spec%cld_thickness = 0
      endwhere         
 
      do i=1,idim
        do j=1,jdim
          Cld_spec%ncldsw(i,j) = sum( Cld_spec%cld_thickness(i,j,:) )
        enddo
      enddo

      Cld_spec%nrndlw = Cld_spec%ncldsw
      Cld_spec%nmxolw = 0 
      Cld_spec%camtsw = Cld_spec%cloud_area  
      Cld_spec%crndlw = Cld_spec%cloud_area
      Cld_spec%cmxolw = 0.0

      deltap = phalf(:,:,2:kdim+1)  - phalf(:,:,1:kdim)

      Cld_spec%lwp = deltap/GRAV*Cld_spec%cloud_water
      Cld_spec%iwp = deltap/GRAV*Cld_spec%cloud_ice

      call microphys_cloud (z_half, z_full, diam_liq, diam_ice)

      Lsc_microphys%size_drop = diam_liq
      Lsc_microphys%size_ice  = diam_ice
      Lsc_microphys%conc_drop = Cld_spec%lwp*1.0e3/deltaz
      Lsc_microphys%conc_ice  = Cld_spec%iwp*1.0e3/deltaz
      Lsc_microphys%cldamt    = Cld_spec%cloud_area 


!---------------------------------------------------------------------



end subroutine zetac_clouds_amt  




!####################################################################
! <SUBROUTINE NAME="zetac_clouds_W_end">
!  <OVERVIEW>
!    zetac_clouds_W_end is the destructor for zetac_clouds_W_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    zetac_clouds_W_end is the destructor for zetac_clouds_W_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call zetac_clouds_W_end
!  </TEMPLATE>
! </SUBROUTINE>
subroutine zetac_clouds_W_end
       
!----------------------------------------------------------------------
!    zetac_clouds_W_end is the destructor for zetac_clouds_W_mod.
!----------------------------------------------------------------------
        
!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('zetac_clouds_W_mod',   &
             'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!    mark the module as not initialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.
       
!--------------------------------------------------------------------
 
 
end subroutine zetac_clouds_W_end



!#################################################################




                    end module zetac_clouds_W_mod

module nc_cond_mod

use mpp_mod,                   only : input_nml_file
use  fms_mod,                  only : FATAL, error_mesg, mpp_pe, &
                                      mpp_root_pe, open_namelist_file, &
                                      check_nml_error, close_file,  &
                                      write_version_number, file_exist, &
                                      stdlog
use constants_mod,             only : grav,tfreeze, cp_air, hlv, hls, &
                                      rvgas
use beta_dist_mod,             only : incomplete_beta, beta_dist_init, &
                                      beta_dist_end
use strat_cloud_utilities_mod, only : strat_cloud_utilities_init, &
                                      diag_id_type, diag_pt_type, &
                                      strat_nml_type, atmos_state_type,&
                                      cloud_state_type, particles_type,&
                                      strat_constants_type, &
                                      cloud_processes_type
use polysvp_mod,               only : polysvp_init, polysvp_end,  &
                                      compute_qs_x1

implicit none
private 

!-----------------------------------------------------------------------
!---interfaces----------------------------------------------------------
public  nc_cond, nc_cond_init, nc_cond_end
private nc_cond_nopdf_nosuper, nc_cond_nopdf_super, nc_cond_pdf, &
        ppm2m_sak, kmppm_sak, steepz_sak

!-----------------------------------------------------------------------
!---version number------------------------------------------------------

Character(len=128) :: Version = '$Id: nc_cond.F90,v 20.0 2013/12/13 23:22:01 fms Exp $'
Character(len=128) :: Tagname = '$Name: tikal $'

!-----------------------------------------------------------------------
!---namelist------------------------------------------------------------

logical :: add_ahuco = .true.              ! include convective cloud area
                                           ! in grid box when determining 
                                           ! grid box mean relative 
                                           ! humidity required to allow
                                           ! large-scale condensation
logical :: use_qabar = .true.              ! use time-mean cloud area 
                                           ! during the timestep in
                                           ! calculating cloud processes;
                                           ! otherwise use cloud area at
                                           ! end of step
logical :: rk_repartition_first = .false.  ! repartition the condensation 
                                           ! between liquid and ice
                                           ! based on bergeron relation
                                           ! before computing microphysics?
logical :: do_aero_eros = .false.          ! enhance cloud erosion based
                                           ! on number of droplets
real    :: ae_lb = 0.8                     ! used in aero_eros calculation
real    :: ae_ub = 1.2                     ! used in aero_eros calculation
real    :: ae_N_lb = 0.                    ! used in aero_eros calculation
real    :: ae_N_ub = 150.                  ! used in aero_eros calculation

namelist / nc_cond_nml /  add_ahuco, use_qabar, rk_repartition_first, &
                          do_aero_eros, ae_lb, ae_ub, ae_N_lb, ae_N_ub
 
!------------------------------------------------------------------------
logical     :: module_is_initialized = .false.


CONTAINS

!#######################################################################

SUBROUTINE nc_cond_init( do_pdf_clouds )

!-----------------------------------------------------------------------
LOGICAL, INTENT(IN ) :: do_pdf_clouds
 
!-----------------------------------------------------------------------
!---local variables-----------------------------------------------------

      integer :: unit, io, ierr, logunit

!-----------------------------------------------------------------------
      if (module_is_initialized) return

!-------------------------------------------------------------------------
!    process namelist.
!-------------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=nc_cond_nml, iostat=io)
      ierr = check_nml_error(io,'nc_cond_nml')
#else
      if ( file_exist('input.nml')) then
        unit = open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=nc_cond_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'nc_cond_nml')
        enddo
10      call close_file (unit)
      endif
#endif

!-------------------------------------------------------------------------
!    write version and namelist to standard log.
!-------------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if ( mpp_pe() == mpp_root_pe() ) &
                        write ( logunit, nml=nc_cond_nml )

!------------------------------------------------------------------------
!    be sure needed modules are initialized.
!------------------------------------------------------------------------
      call strat_cloud_utilities_init
      call polysvp_init
      if (do_pdf_clouds) then
        call beta_dist_init
      endif

!-----------------------------------------------------------------------
      module_is_initialized = .true.


END SUBROUTINE nc_cond_init



!########################################################################

SUBROUTINE nc_cond (idim, jdim, kdim, Nml, Constants, Atmos_state,  &
                    Cloud_state, ST, SQ, Cloud_processes, Particles,  &
                    n_diag_4d, diag_4d, diag_id, diag_pt, otun)        

!------------------------------------------------------------------------
INTEGER,                         INTENT(IN )   :: idim, jdim, kdim 
type(strat_nml_type),            intent(in)    :: Nml
type(atmos_state_type),          intent(inout) :: Atmos_state
type(cloud_state_type),          intent(inout) :: Cloud_state
type(cloud_processes_type),      intent(inout) :: Cloud_processes
type(particles_type),            intent(inout) :: Particles
type(strat_constants_type),      intent(inout) :: Constants  
REAL, dimension(idim,jdim,kdim), INTENT(IN )   :: ST, SQ
INTEGER,                         INTENT(IN )   :: n_diag_4d
REAL, dimension(idim,jdim,kdim,0:n_diag_4d),    &
                                 INTENT(INOUT) :: diag_4d
TYPE(diag_id_type),              intent(in)    :: diag_id
TYPE(diag_pt_type),              intent(in)    :: diag_pt 
INTEGER,                         INTENT(IN)    :: otun

!------------------------------------------------------------------------
!----local variables---------------------------------------
!------------------------------------------------------------------------
!       SA             cloud area tendency
!       U00p           critical relative humidity fraction which may be 
!                      a function of pressure 
!       U00pr          gridbox mean rh needed for condensation, after
!                      accounting for convective cloud area
!       liq_frac       fraction of condensation which is liquid
!       ice_frac       fraction of condensation which is frozen
!       erosion_scale  cloud erosion scale
!       edum           factor used in aero_eros calculation
!       dum            ratio of bergeron to condensation tendencies
!       D2_dts         tendency due to bergeron process
!       A_plus_B_s     sum of vapor diffusion factor and thermal conduct-
!                      ivity factor
!       mdum           factor used in aero_eros calculation
!       bdum           factor used in aero_eros calculation
!       i,j,k          do-loop indices
!-------------------------------------------------------------------------

      real, dimension(idim, jdim,kdim) :: SA, U00p, U00pr, liq_frac, &
                                          ice_frac, erosion_scale, edum
      real                             :: dum, D2_dts, A_plus_B_s, mdum, &
                                          bdum
      INTEGER                          :: i,j,k


!-----------------------------------------------------------------------
!    define a local copy of the current cloud area tendency.
!-----------------------------------------------------------------------
      SA = Cloud_state%SA_out

!------------------------------------------------------------------------
!    process the non-convective condensation for pdf clouds. 
!                                                                      !
!                NON-CONVECTIVE CONDENSATION                          !
!                                                                      !
!                STATISTICAL CLOUD FRACTION                            !
!                                                                      !
!------------------------------------------------------------------------
      if (Nml%do_pdf_clouds) then
        call nc_cond_pdf (idim, jdim, kdim, Nml, Constants, Atmos_state, &
                          Cloud_state, ST, SQ, Cloud_processes, &
                          Particles, n_diag_4d, diag_4d, diag_id,  &
                          diag_pt, otun, SA)

      else

!------------------------------------------------------------------------
!    process the non-convective condensation for non-pdf clouds. some
!    additional calculations are needed.
!
!                 NON-CONVECTIVE CONDENSATION                          
!                                                                     
!                  TIEDTKE (1993) CLOUD FRACTION                    
!                                                                    
!       ANALYTIC INTEGRATION OF SATURATED VOLUME FRACTION EQUATION     
!
!       Do non-convective condensation following Tiedtke, pages 3044-5.
!       In this formulation stratiform clouds are only formed/destroyed 
!       when there is upward or downward motion to support/destroy it. 
!-------------------------------------------------------------------------

!-----------------------------------------------------------------------
!    calculate aerosol erosion term which optionally may be used.
!-----------------------------------------------------------------------
        if (do_aero_eros ) then 
          mdum = (ae_ub - ae_lb)/(ae_N_ub - ae_N_lb)
          bdum = ae_lb - mdum*ae_N_lb
          edum = mdum*Particles%drop1 + bdum 
        else
          edum = 1.
        endif

!------------------------------------------------------------------------
!    compute pressure dependent critical relative humidity for onset of
!    condensation (U00p) following ECMWF formula if desired. otherwise,
!    it is given by the nml variable u00.
!------------------------------------------------------------------------
        U00p = Nml%U00
        if (Nml%u00_profile) then
          DO k=1,kdim
            where (Atmos_state%pfull(:,:,k).gt.   &
                          0.8*Atmos_state%phalf(:,:,KDIM+1)) 
              U00p(:,:,k) = Nml%U00 + (1.-Nml%U00)* &
                         (((Atmos_state%pfull(:,:,k) -   &
                            (0.8*Atmos_state%phalf(:,:,KDIM+1)))/  &
                               (0.2*Atmos_state%phalf(:,:,KDIM+1)) )**2.)
            end where
          END DO
        endif       

!------------------------------------------------------------------------
!    modify u00p to account for humidity in convective system.  see 
!    "Tiedtke u00 adjustment" notes, 10/22/02 -- ljd
!    u00p = critical rh for condensation in the grid box, accounting for 
!    the fact that ahuco of the box is saturated (has convective cloud) 
!    better written : ahuco*100% + (1-ahuco)*u00p = gridboxmean rh
!------------------------------------------------------------------------
        IF (add_ahuco) THEN
          u00pr = u00p + (1. - u00p)*Atmos_state%ahuco
          u00p = u00pr
        END IF

!-----------------------------------------------------------------------
!    Theory for eros_scale
!
!    If eros_choice equals false, then a single erosion time scale
!    is used in all conditions (eros_scale).  If eros_choice equals
!    true then it is assumed that the timescale for turbulent 
!    evaporation is a function of the conditions in the grid box.  
!    Specifically, if the flow is highly turbulent then the scale is 
!    short, and eros_scale is large.  Likewise if convection is 
!    occurring, then it is assumed that the erosion term is larger 
!    than backround conditions. 
!
!    Here are the typical values for the timescales and the 
!    switches used (subject to changes via namelist):
!
!         Mixing type      eros_scale (sec-1)          Indicator
!       ----------------   ------------------     --------------------
!
!       Background            1.e-06              always present
!       Convective layers     5.e-06              Mc > Mc_thresh
!       Turbulent  layers     5.e-05              diff_t > diff_thresh
!
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!    define array with background erosion scale.
!-----------------------------------------------------------------------
        erosion_scale = Nml%eros_scale
       
!-----------------------------------------------------------------------
!    Do enhanced erosion in convective or turbulent layers?
!
!                   IMPORTANT NOTE
!                
!    note that convection is considered first, so that if turbulence and 
!    convection occur in the same layer, the erosion rate for turbulence 
!    is selected.                
!-----------------------------------------------------------------------
        if (Nml%eros_choice) then
          do k=1,kdim
            do j=1,jdim
              do i=1,idim

!-----------------------------------------------------------------------
!    Enhanced erosion in convective layers
!-----------------------------------------------------------------------
                if (Atmos_state%Mc(i,j,k) .gt. Nml%mc_thresh) then
                  erosion_scale(i,j,k) = Nml%eros_scale_c
                endif
                if ((Atmos_state%diff_t(i,j,K) .gt.Nml%diff_thresh) .or.&
                    (Atmos_state%diff_t(i,j,min(k+1,KDIM)) .gt.  &
                                                   Nml%diff_thresh) ) then
                  erosion_scale(i,j,K) = Nml%eros_scale_t
                endif 
              END DO
            END DO
          END DO
        end if   !(eros_choice)        

!------------------------------------------------------------------------
!    enhance erosion scale if that option has been selected.
!------------------------------------------------------------------------
        IF (do_aero_eros) erosion_scale = edum*erosion_scale

!------------------------------------------------------------------------
!     determine condensation for different supersaturation assumptions.
!------------------------------------------------------------------------
        IF (Nml%super_ice_opt .LT. 1 ) THEN

!------------------------------------------------------------------------
!    if supersaturation is not to be allowed call subroutine 
!    nc_cond_nopdf_nosuper to calculate the condensation.
!------------------------------------------------------------------------
          call nc_cond_nopdf_nosuper (    &
                       idim, jdim, kdim, Nml, Constants, Atmos_state,   &
                       Cloud_state, ST, SQ, Cloud_processes, Particles,  &
                       n_diag_4d, diag_4d, diag_id, diag_pt, otun, edum, &
                       SA, U00p, erosion_scale)
        else

!------------------------------------------------------------------------
!    if supersaturation is to be allowed call subroutine 
!    nc_cond_nopdf_super to calculate the condensation.
!------------------------------------------------------------------------
          call nc_cond_nopdf_super  (     &
                     idim, jdim, kdim, Nml, Constants, Atmos_state,  &
                     Cloud_state, ST, SQ, Cloud_processes, Particles,  &
                     n_diag_4d, diag_4d, diag_id, diag_pt, otun, edum,  &
                     SA, U00p, erosion_scale)
        endif
      endif

!-----------------------------------------------------------------------
!    the next step is the apportionment on the non-convective condensation !    between liquid and ice phases. Following the suggestion of Rostayn
!    (2000), all condensation at temperatures greater than -40C is in 
!    liquid form as ice nuclei are generally limited in the atmosphere.
!    The droplets may subsequently be converted to ice by the 
!    Bergeron-Findeison mechanism.  
!
!    one problem with this formulation is that the proper saturation vapor 
!    pressure is not used for cold clouds as it should be liquid saturation
!    in the case of first forming liquid, but change to ice saturation as 
!    the cloud glaciates.  The current use of ice saturation beneath -20C 
!    thus crudely mimics the result that nearly all stratiform clouds are
!    glaciated for temperatures less than -15C.
!
!    in the case of large-scale evaporation (dcond_ls<0.), it is assumed 
!    that cloud liquid will evaporate faster than cloud ice because if 
!    both are present in the same volume the saturation vapor pressure over
!    the droplet is higher than that over the ice crystal.
!
!    the fraction of large-scale condensation that is liquid is stored in 
!    the temporary variable liq_frac.
!-----------------------------------------------------------------------
      liq_frac = 1.
      ice_frac = 0.

!-----------------------------------------------------------------------
!    for cases of cloud condensation where temperatures are less than -40C 
!    create only ice,
!-----------------------------------------------------------------------
      where (Cloud_processes%dcond_ls .ge. 0. .and.   &
                                Atmos_state%T_in .lt. tfreeze - 40.)
        liq_frac = 0.
        ice_frac = 1.
      endwhere

!-----------------------------------------------------------------------
!    for cases of cloud evaporation of mixed phase clouds, set liquid 
!    evaporation to preferentially occur first.
!-----------------------------------------------------------------------
      where ((Cloud_processes%dcond_ls .lt. 0.) .and.   &
                     (Cloud_state%ql_upd .gt. Nml%qmin)  .and.        &
                            (Cloud_state%qi_upd .gt. Nml%qmin))   
        liq_frac = min(-1.*Cloud_processes%dcond_ls, Cloud_state%ql_upd)/ &
                   max(-1.*Cloud_processes%dcond_ls, Nml%qmin)
        ice_frac = 1. - liq_frac
      end where

!-----------------------------------------------------------------------
!    do evaporation of pure ice cloud.
!-----------------------------------------------------------------------
      where ( (Cloud_processes%dcond_ls .lt. 0.) .and.   &
                 (Cloud_state%ql_upd .le. Nml%qmin)  .and.            &
                          (Cloud_state%qi_upd .gt. Nml%qmin) )
        liq_frac = 0.
        ice_frac = 1.
      end where
        
!-----------------------------------------------------------------------
!    calculate partitioning among liquid and ice to dcond_ls.    
!-----------------------------------------------------------------------
      Cloud_processes%dcond_ls_ice = ice_frac*Cloud_processes%dcond_ls
      Cloud_processes%dcond_ls     = liq_frac*Cloud_processes%dcond_ls   

!------------------------------------------------------------------------
!    output debug diagnostics, if desired.
!------------------------------------------------------------------------
      if (Nml%debugo) then
        write( otun,*) " dcond_ls ",    &
                 Cloud_processes%dcond_ls(Nml%isamp,Nml%jsamp,Nml%ksamp)
        write( otun,*) " D_eros ",   &
                  Cloud_processes%D_eros(Nml%isamp,Nml%jsamp,Nml%ksamp)
        write( otun,*) " qa_upd ",  &
                   Cloud_state%qa_upd(Nml%isamp,Nml%jsamp,Nml%ksamp)
      end if

!-------------------------------------------------------------------------
!    if  desired, re-partition dcond_ls based on Bergeron process 
!    calculation. ?????
!-------------------------------------------------------------------------
      IF (rk_repartition_first) THEN
        DO k = 1,kdim
          DO j = 1,jdim
            DO i=1,idim
              Cloud_processes%dcond_ls_tot(i,j,k) =  &
                    Cloud_processes%dcond_ls(i,j,k) +   &
                               Cloud_processes%dcond_ls_ice(i,j,k)
              A_plus_B_s =   &
                ( (hlv/0.024/Atmos_state%T_in(i,j,k))*   &
                             ((hlv/rvgas/Atmos_state%T_in(i,j,k))-1.) ) + &
                (rvgas*Atmos_state%T_in(i,j,k)*Atmos_state%pfull(i,j,k)/ &
                                         2.21/Atmos_state%esat0(i,j,k))
              if ( (Atmos_state%T_in(i,j,k) < tfreeze)    &
                  .and. (CLoud_state%ql_upd(i,j,k) + max  &
                      (Cloud_processes%dcond_ls(i,j,k), 0.) > Nml%qmin) &
                  .and. (CLoud_state%qa_upd(i,j,k) .gt. Nml%qmin))  then 
                D2_dts =  Constants%dtcloud*Cloud_state%qa_upd(i,j,k)* &
                              ((Nml%cfact*1000.*exp((12.96*0.0125*   &
                          (tfreeze - Atmos_state%T_in(i,j,k))) - 0.639)/  &
                                Atmos_state%airdens(i,j,k))**(2./3.))* &
                         7.8* ((max(CLoud_state%qi_upd(i,j,k)/  &
                 Cloud_state%qa_upd(i,j,k),1.E-12*Nml%cfact*1000.*   &
                       exp((12.96*0.0125*(tfreeze -   &
                                      Atmos_state%T_in(i,j,k)))-0.639)   &
                      /Atmos_state%airdens(i,j,k)))**(1./3.))*0.0125*  &
                     (tfreeze - Atmos_state%T_in(i,j,k))/((700.**(1./3.))*&
                       A_plus_B_s)
!note:
!!                      A_plus_B_s*(ql_upd(i,k) + max(dcond_ls(i,k)  ,0.)))
              else
                D2_dts = 0.0        
              end if
              if (Cloud_processes%dcond_ls_tot(i,j,k).ne.0.) then
                dum = D2_dts/Cloud_processes%dcond_ls_tot(i,j,k)
              endif
              dum = max(dum, 0.)
              dum = min(dum, 1.)
              Cloud_processes%dcond_ls_ice(i,j,k) =   &
                                  dum*Cloud_processes%dcond_ls_tot(i,j,k)
              Cloud_processes%dcond_ls(i,j,k) =   &
                           (1. - dum)*Cloud_processes%dcond_ls_tot(i,j,k)
            END DO
          END DO
        END DO
      END IF
 
!-----------------------------------------------------------------------
!    save a diagnostic if desired.
!-----------------------------------------------------------------------
      if ( diag_id%delta_cf > 0 ) then
        diag_4d(:,:,:,diag_pt%delta_cf) = Cloud_processes%delta_cf
      end if

!-----------------------------------------------------------------------
!    the next step is to compute semi-implicit qa,ql,qi which are used in 
!    many of the formulas below.  this gives a somewhat implicitness to the
!    scheme. in this calculation an estimate is made of what the cloud 
!    fields would be in the absence of cloud microphysics and cloud 
!    erosion.
!
!    in the case of the Tiedtke cloud scheme, the mean cloud condensate is 
!    incremented if large-scale condensation is occurring. For cloud 
!    fraction, the value from the analytic integration above is used.
!
!    for the statistical cloud scheme these are set equal to the values 
!    diagnosed from the beta-distribution apart from the corrections for 
!    mixed phase clouds.
!-----------------------------------------------------------------------
      Cloud_state%qa_mean(:,:,:) = Cloud_state%qa_upd(:,:,:)

      if (.not. Nml%do_pdf_clouds) then
        Cloud_state%ql_mean(:,:,:) = Cloud_state%ql_upd(:,:,:) +  &
                             max(Cloud_Processes%dcond_ls(:,:,:)    ,0.)
        Cloud_state%qi_mean(:,:,:) = Cloud_state%qi_upd(:,:,:) +  &
                             max(Cloud_Processes%dcond_ls_ice(:,:,:),0.)
      else
        Cloud_state%ql_mean(:,:,:) = max(Cloud_state%ql_upd(:,:,:) + &
                          Cloud_processes%dcond_ls(:,:,:), Nml%qmin)
        Cloud_state%qi_mean(:,:,:) = max(Cloud_state%qi_upd(:,:,:) + &
                          Cloud_processes%dcond_ls_ice(:,:,:), Nml%qmin) 
      end if

!-----------------------------------------------------------------------
!    compute diagnostics for cloud fraction.
!-----------------------------------------------------------------------
      if (diag_id%aall > 0)   &
                diag_4d(:,:,:,diag_pt%aall) = Cloud_state%qa_mean(:,:,:)
      if (diag_id%aliq > 0 .or. diag_id%rvolume > 0) then
        where (Cloud_State%ql_mean(:,:,:) .gt. Nml%qmin) &
                diag_4d(:,:,:,diag_pt%aliq) = Cloud_state%qa_mean(:,:,:)
      end if
      if (diag_id%aice > 0 .or. diag_id%vfall > 0) then
        where (Cloud_state%qi_mean(:,:,:) .gt. Nml%qmin)  &
                 diag_4d(:,:,:,diag_pt%aice) = Cloud_state%qa_mean(:,:,:)
      end if              

      if (diag_id%dcond > 0 )   &
           diag_4d(:,:,:,diag_pt%dcond) = Cloud_processes%dcond_ls(:,:,:)

!----------------------------------------------------------------------
!    return new value of cloud area tendency to permanent location.
!----------------------------------------------------------------------
      Cloud_state%SA_out = SA

!----------------------------------------------------------------------!


END SUBROUTINE nc_cond



!########################################################################

SUBROUTINE nc_cond_end( do_pdf_clouds )

LOGICAL, INTENT(IN ) :: do_pdf_clouds

      module_is_initialized = .false.
      call polysvp_end
      if ( do_pdf_clouds ) then
        call beta_dist_end
      end if

END SUBROUTINE nc_cond_end



!########################################################################

SUBROUTINE nc_cond_nopdf_nosuper (idim, jdim, kdim, Nml, Constants, &
                                  Atmos_state, Cloud_state, ST, SQ, &
                                  Cloud_processes, Particles, &
                                  n_diag_4d, diag_4d, diag_id, diag_pt, &
                                  otun, edum, SA, U00p, erosion_scale)  

!------------------------------------------------------------------------
INTEGER,                         INTENT(IN )   :: idim, jdim, kdim      
type(strat_nml_type),            intent(in)    :: Nml
type(strat_constants_type),      intent(inout) :: Constants  
type(atmos_state_type),          intent(inout) :: Atmos_state
type(cloud_state_type),          intent(inout) :: Cloud_state
type(cloud_processes_type),      intent(inout) :: Cloud_processes
type(particles_type),            intent(inout) :: Particles
REAL, dimension(idim,jdim,kdim), INTENT(IN)    :: ST, SQ, edum, U00p,  &
                                                  erosion_scale
REAL, dimension(idim,jdim,kdim), INTENT(INOUT) :: SA
INTEGER,                         INTENT(IN )   :: n_diag_4d
REAL, dimension(idim, jdim, kdim, 0:n_diag_4d),   &
                                 INTENT(INOUT) :: diag_4d
TYPE(diag_id_type),              intent(in)    :: diag_id
TYPE(diag_pt_type),              intent(in)    :: diag_pt
INTEGER,                         INTENT(IN )   :: otun

!-------------------------------------------------------------------------
!----local variables-----------------------------------------------------

!-------------------------------------------------------------------------
!       dqs_ls         change in qs due to large 
!                      scale processes
!       A_dt           product of A and dtcloud in     dimensionless in 
!                      in the analytic integration     qa integration
!                      of the qa equation, or C and
!                      dtcloud in the analytic         kg condensate/
!                      integration of the ql and qi    kg air in ql or 
!                      equations.                      qi integration
!
!       B_dt           product of B and dtcloud in     dimensionless in
!                      in the analytic integration     qa, ql, and qi
!                      of the qa equation, or D and    integration
!                      dtcloud in the analytic         
!                      integration of the ql and qi    
!                      equations.                      
!
!       qa0            value of cloud fraction or      dimensionless or
!                      cloud condensate at the         kg condensate /
!                      initial time                    kg air
!        
!       qa1            value of cloud fraction or      dimensionless or
!                      cloud condensate at the final   kg condensate /
!                      time                            kg air
!
!       qaeq           equilibrium value of cloud      dimensionless or
!                      fraction or cloud condensate    kg condensate /
!                      that the analytic integration   kg air
!                      approaches                   
!       qabar          mean value of cloud fraction    dimensionless or
!                      or cloud condensate over the    kg condensate /
!                      t0 to t0 + dtcloud interval     kg air
!
!------------------------------------------------------------------------
     
      real, dimension(idim, jdim,kdim)   :: dqs_ls
      real, dimension(idim, jdim,kdim)   :: A_dt, B_dt
      real, dimension(idim, jdim,kdim)   :: qa1, qa0, qabar
      real, dimension(idim, jdim,kdim)   :: qaeq
      real, dimension(idim, jdim,kdim)   :: tmp1
      REAL                               :: eslt, qvs, qs_d, qvi, esit, ul
      REAL                               :: ttmp, qtmp, qs_t, dqsdT1,  &
                                            qvmax, esat0, gamma1,  &
                                            tmp1s, qs_l, qs_i
      INTEGER                            :: ns, id
      INTEGER                            :: i,j,k

!-----------------------------------------------------------------------
!
!       The first step is to compute the change in qs due to large-
!       scale processes, dqs_ls.   In Tiedtke, it has contributions from 
!       large-scale uplift, convection induced compensating subsidence,
!       turbulence cooling and radiative cooling.  dqs_ls has the form:
!
!               (((omega+ grav*Mc)/airdens/cp)+radturbten)*dqsdT*dtcloud
!   (6) dqs_ls= --------------------------------------------------------
!                  1.  +   ( qa +  (da_ls/2.) ) * gamma
!
!       Here da_ls is the increase in cloud fraction due to non-
!       convective processes.  Because this increase is also a function
!       of dqs_ls, a quadratic equation must be solved for dqs_ls in
!       the case that da_ls is not equal to zero.
!
!------------------------------------------------------------------------
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            dqs_ls(i,j,k) = ((                    &
                     (Atmos_state%omega(i,j,k) +   &
                                   grav*Atmos_State%Mc(i,j,k))/&
                                Atmos_state%airdens(i,j,k)/cp_air) +   &
                         Atmos_state%radturbten2(i,j,k))* &
                               Constants%dtcloud*Atmos_state%dqsdT(i,j,k)
            if (dqs_ls(i,j,k) .le. 0. .and.    &
                       Atmos_state%U_ca(i,j,k) .ge. U00p(i,j,k) .and.   &
                                Cloud_state%qa_upd(i,j,k) .lt. 1.)  then
              tmp1(i,j,k) = sqrt( (1. + Cloud_state%qa_upd(i,j,k)*  &
                                       Atmos_state%gamma(i,j,k))**2. -  &
                                  (1. - Cloud_state%qa_upd(i,j,k))*  &
                                     (1. - Cloud_state%qa_upd(i,j,k))*&
                                 Atmos_state%gamma(i,j,k)*dqs_ls(i,j,k)/&
                                          Atmos_state%qs(i,j,k)/      &
                    max(1.-Atmos_state%U_ca(i,j,k),Nml%qmin) ) -   &
                        (1. + Cloud_state%qa_upd(i,j,k)*  &
                                               Atmos_state%gamma(i,j,k))
              tmp1(i,j,k) = -1.*tmp1(i,j,k)/((1. -   &
                                       Cloud_state%qa_upd(i,j,k))*   &
                               (1. - Cloud_state%qa_upd(i,j,k))*  &
                                            Atmos_state%gamma(i,j,k)/&
                                Atmos_state%qs(i,j,k)/   &
                            max(1. - Atmos_state%U_ca(i,j,k),Nml%qmin)/2.)
              dqs_ls(i,j,k) = min(tmp1(i,j,k),dqs_ls(i,j,k)/(1. +   &
                              0.5*(1. + Cloud_State%qa_upd(i,j,k))*  &
                                             Atmos_state%gamma(i,j,k)))
            else
              dqs_ls(i,j,k) = dqs_ls(i,j,k)/(1. +   &
                   Cloud_state%qa_upd(i,j,k)*Atmos_state%gamma(i,j,k))
            endif
          end do
        end do
      end do

!------------------------------------------------------------------------
!       The next step is to compute the change in saturated volume
!       fraction due to non-convective condensation, da_ls.   This 
!       occurs in two conditions:
!
!       (a)  dqs_ls < 0. and U00 < U < 1., where U00 is the threshold
!            relative humidity for non-convective condensation. Note 
!            that if U is greater than or equal to 1., ideally qa = 1,
!            and da_ls = 0.  However this may not be the case for 
!            numerical reasons so this must be assured after analytic 
!            integration of the qa equation.
!
!            For these cases the change in saturated volume fraction is:
!
!   (7)      da_ls = - (1.-qa)*(1.-qa)*dqs_ls/2./qs/(1.-U)
!
!            This formula arises from the assumption that vapor is uni-
!            formly distributed in the range [qv_clr - (qs - qv_clr),qs]
!            where qv_clr is the amount of vapor in the unsaturated 
!            volume and is given from the following equation:
!
!   (8)      qv  =   qa * qs      +   (1.-qa) * qv_clr
!          
!            Implicit in equation (7) is the following assumption:
!            As qsat changes, the distribution of qv+ql+qi 
!            remains constant.  That is as qsat rises, portions where
!            qv+ql+qi > qsat+dqsat remain saturated.  This can only
!            occur if it is assumed that ql+qi evaporate-sublimate or
!            condense-deposit to keep qv = qsat. 
!
!       (b)  dqs_ls > 0.  Ideally some portion of the cloud should
!            evaporate however this is not accounted for at present.
!            
!------------------------------------------------------------------------
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            if ((dqs_ls(i,j,k) .le. 0. .and.    &
                      Atmos_state%U_ca(i,j,k) .ge. U00p(i,j,k)) .and. &
                  (Cloud_state%qa_upd(i,j,k) +  &
                                Atmos_state%ahuco(i,j,k) .le. 1.))   then
              Cloud_processes%da_ls(i,j,k) =    &
                      -0.5*(1. - Cloud_state%qa_upd(i,j,k) -  &
                                            Atmos_state%ahuco(i,j,k))*  &
                      (1. - Cloud_state%qa_upd(i,j,k) -    &
                               Atmos_state%ahuco(i,j,k) )*dqs_ls(i,j,k)/&
                                           Atmos_state%qs(i,j,k) /  &
                                  max(1.-Atmos_state%U_ca(i,j,k),Nml%qmin)
            else
              Cloud_processes%da_ls(i,j,k) = 0.
            endif
          end do
        end do
      end do

!------------------------------------------------------------------------
!       Turbulent erosion of clouds
!
!       As in Tiedtke (1993) this is calculated using the eros_scale
!       parameter as:
!
!   (9) dql/dt    =  - qa * eros_scale * (qs - qv) * (ql/ ql+qi )
!
!  (10) dqi/dt    =  - qa * eros_scale * (qs - qv) * (qi/ ql+qi )
!
!  (11) dqa/dt    =  - qa * eros_scale * (qs - qv) * (qa/ ql+qi )
!
!       for which the erosion sink term (B in equation 13) is
!
!  (12) B = qa * eros_scale * (qs - qv) / (ql + qi)  
!
!------------------------------------------------------------------------
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            if (Cloud_state%ql_upd(i,j,k) .gt. Nml%qmin .or.   &
                        Cloud_state%qi_upd (i,j,k).gt. Nml%qmin) then
              Cloud_processes%D_eros(i,j,k) =   &
                    Cloud_state%qa_upd(i,j,k) * erosion_scale(i,j,k) *   &
                     Constants%dtcloud * Atmos_state%qs(i,j,k) *      &
                      (1.-Atmos_state%U_ca(i,j,k)) /   &
                   (Cloud_state%qi_upd(i,j,k) + CLoud_state%ql_upd(i,j,k))

              if (Atmos_state%pfull(i,j,k) .gt. 400.e02) then
                Cloud_processes%D_eros(i,j,k) =  &
                     Cloud_processes%D_eros(i,j,k) + Nml%efact*  &
                                      Cloud_processes%D_eros(i,j,k)* &
                          ((Atmos_state%pfull(i,j,kdim) -   &
                                            Atmos_state%pfull(i,j,k))/  &
                                (Atmos_state%pfull(i,j,kdim) - 400.e02))
              else
                Cloud_processes%D_eros(i,j,k)=  &
                      Cloud_processes%D_eros(i,j,k) +  &
                                 Nml%efact*CLoud_processes%D_eros(i,j,k)

              endif
            else
              Cloud_processes%D_eros(i,j,k) = 0.
            endif
          END DO    
        END DO    
      END DO    

!------------------------------------------------------------------------
!       The next step is to analytically integrate the saturated volume
!       fraction equation.  This follows the Tiedtke approach
!
!       The qa equation is written in the form:
!
!  (13) dqa/dt    =   (1.-qa) * A   -  qa * B 
!
!       Note that over the physics time step, A, B are assumed to be 
!       constants.
!
!       Defining qa(t) = qa0 and qa(t+dtcloud) = qa1, the analytic
!       solution of the above equation is:
!
!  (14) qa1 = qaeq -  (qaeq - qa0) * exp (-(A+B)*dtcloud)
! 
!       where qaeq is the equilibrium cloud fraction that is approached
!       with an time scale of 1/(A+B),
!
!  (15) qaeq  =  A/(A+B)
!
!
!       To diagnose the magnitude of each of the right hand terms of
!       (13) integrated over the time step, define the average cloud
!       fraction in the interval t to t + dtcloud qabar as:
!
!  (16) qabar  = qaeq - [ (qa1-qa0) / ( dtcloud * (A+B) ) ]
! 
!       from which the magnitudes of the A and B terms integrated
!       over the time step are:
!
!       A * (1-qabar)    and    -B * (qabar)
!
!       Additional notes on this analytic integration:
!
!       1.   For large-scale cloud formation or destruction from 
!            the dqs_ls term the contributions to A or B are defined
!            from:
!
!  (19)      A_ls * (1. - qa) = da_ls / dtcloud      if da_ls >= 0.
! 
!  (20)      B_ls * qa        = da_ls / dtcloud      if da_ls < 0.
!
!
!       3.   Qa goes to zero only in the case of ql and qi less than or
!            equal to Nml%qmin; see 'cloud destruction code' near the end of 
!            this loop over levels.
!------------------------------------------------------------------------
        
!------------------------------------------------------------------------
!    compute A_dt; This is assigned to the large-scale source term
!    following (18). Reset B_dt.
!------------------------------------------------------------------------
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            A_dt(i,j,k) = Cloud_processes%da_ls(i,j,k)/   &
                              max((1.-Cloud_state%qa_upd(i,j,k)), Nml%qmin)
            B_dt(i,j,k) = Cloud_processes%D_eros(i,j,k)
  
!------------------------------------------------------------------------
!    do analytic integration.      
!------------------------------------------------------------------------
            if ( (A_dt(i,j,k) .gt. Nml%Dmin) .or.   &
                 (B_dt(i,j,k) .gt. Nml%Dmin) )  then
              qa0(i,j,k) = Cloud_state%qa_upd(i,j,k)
              qaeq(i,j,k) = A_dt(i,j,k)/(A_dt(i,j,k)  + B_dt(i,j,k))
              qa1(i,j,k) = qaeq(i,j,k) - (qaeq(i,j,k) - qa0(i,j,k)) * &
                                      exp ( -1.*(A_dt(i,j,k)+B_dt(i,j,k)) )
              qabar(i,j,k) = qaeq(i,j,k) - ((qa1(i,j,k) - qa0(i,j,k))/  &
                                               (A_dt(i,j,k) + B_dt(i,j,k)))
            else
              qa0(i,j,k)   = Cloud_state%qa_upd(i,j,k)
              qaeq(i,j,k)  = qa0(i,j,k)
              qa1(i,j,k)   = qa0(i,j,k)   
              qabar(i,j,k) = qa0(i,j,k)  
            endif 
          END DO    
        END DO    
      END DO    

      do k=1,kdim
        do j=1,jdim
          do i=1,idim
!------------------------------------------------------------------------
!    save some diagnostics.
!------------------------------------------------------------------------
!           if ( (A_dt(i,j,k) .gt. Nml%Dmin) .or.   &
            if ( (A_dt(i,j,k) .gt. Nml%Dmin) .and.   &
                 (B_dt(i,j,k) .gt. Nml%Dmin) )  then
      if (diag_id%qadt_lsform + diag_id%qa_lsform_col > 0) then
      diag_4d(i,j,k,diag_pt%qadt_lsform) =  A_dt(i,j,k)*(1.-qabar(i,j,k))     *  &                                            
                                                 Constants%inv_dtcloud
      end if
      if ( diag_id%qadt_eros + diag_id%qa_eros_col > 0 ) then
        diag_4d(i,j,k,diag_pt%qadt_eros)  = ((qa1(i,j,k) - qa0(i,j,k))*  &
                                          Constants%inv_dtcloud )- &
                            diag_4d(i,j,k,diag_pt%qadt_lsform)                                           
                               
      end if

          else if (A_dt(i,j,k) .gt. Nml%Dmin) then
             if (diag_id%qadt_lsform + diag_id%qa_lsform_col > 0) then
 
        diag_4d(i,j,k,diag_pt%qadt_lsform) = (qa1(i,j,k) - qa0(i,j,k))*  &
                                                Constants%inv_dtcloud
              end if 
          else if (B_dt(i,j,k) .gt. Nml%Dmin)  then
              if ( diag_id%qadt_eros + diag_id%qa_eros_col > 0 ) then
            diag_4d(i,j,k,diag_pt%qadt_eros)  = (qa1(i,j,k) - qa0(i,j,k))*&
                                                Constants%inv_dtcloud
              end if 
          endif

          END DO    
        END DO    
      END DO    
      if (diag_id%qadt_ahuco + diag_id%qa_ahuco_col > 0) then
        diag_4d(:,:,:,diag_pt%qadt_ahuco) =   &
                                      qa1(:,:,:)
      end if

!------------------------------------------------------------------------
!    limit cloud area to be no more than that which is not being
!    taken by convective clouds
!------------------------------------------------------------------------
      if (Constants%limit_conv_cloud_frac) then
        qa1 = MIN(qa1, 1.0 -Atmos_state%ahuco)
      endif
                 
      if (diag_id%qadt_ahuco + diag_id%qa_ahuco_col > 0) then
        diag_4d(:,:,:,diag_pt%qadt_ahuco) =    &
                  (qa1(:,:,:) - diag_4d(:,:,:,diag_pt%qadt_ahuco))* & 
                                             Constants%inv_dtcloud 
      end if

!------------------------------------------------------------------------
!    set total tendency term and update cloud fraction    
!------------------------------------------------------------------------


      SA = (SA + qa1) - qa0




      Cloud_state%qa_upd = qa1
        

!------------------------------------------------------------------------
!       The next step is to calculate the change in condensate
!       due to non-convective condensation, dcond_ls. Note that this is
!       not the final change but is used only to apportion condensate
!       change between phases. According to Tiedtke 1993 this takes the
!       form:
!
!  (21) dcond_ls = -1. * (qa +  0.5*da_ls) * dqs_ls
!
!       Here the 0.5*da_ls represents using a midpoint cloud fraction.
!       This is accomplished by using the variable qabar.
!
!       Also, save term needed when predicted droplets is active (tmp5).
!------------------------------------------------------------------------
      IF (use_qabar) THEN
        Cloud_processes%dcond_ls = -1.*qabar*dqs_ls
        Cloud_processes%delta_cf = A_dt*(1.-qabar)
      ELSE
        Cloud_processes%dcond_ls = -1.*Cloud_state%qa_upd*dqs_ls   
        Cloud_processes%delta_cf = A_dt*(1.-Cloud_state%qa_upd)
      END IF      

!-----------------------------------------------------------------------


end subroutine nc_cond_nopdf_nosuper 


!########################################################################

SUBROUTINE nc_cond_nopdf_super (idim, jdim, kdim, Nml, Constants, &
                                Atmos_state, Cloud_state, ST,SQ, & 
                                Cloud_processes, Particles, &
                                n_diag_4d, diag_4d, diag_id, diag_pt, &
                                otun, edum, SA, U00p, erosion_scale) 

!------------------------------------------------------------------------
INTEGER,                            INTENT(IN )   :: idim, jdim, kdim  
type(strat_nml_type),               intent(in)    :: Nml
type(atmos_state_type),             intent(inout) :: Atmos_state
type(cloud_state_type),             intent(inout) :: Cloud_state
type(cloud_processes_type),         intent(inout) :: Cloud_processes
type(particles_type),               intent(inout) :: Particles
type(strat_constants_type),         intent(inout) :: Constants  
REAL, dimension(idim,jdim,kdim),    INTENT(IN )   :: ST, SQ, edum, U00p,&
!                                                    tmp2
                                                     erosion_scale
REAL, dimension(idim,jdim,kdim),    INTENT(INout ):: SA
INTEGER,                            INTENT(IN )   :: n_diag_4d
REAL, dimension(idim, jdim, kdim, 0:n_diag_4d),    &
                                    INTENT(INOUT ):: diag_4d
TYPE(diag_id_type),                 intent(in)    :: diag_id
TYPE(diag_pt_type),                 intent(in)    :: diag_pt
INTEGER,                            INTENT(IN )   :: otun

!-------------------------------------------------------------------------
!-----local variables-----------------------------------------------------
 
!       A_dt           product of A and dtcloud in     dimensionless in 
!                      in the analytic integration     qa integration
!                      of the qa equation, or C and
!                      dtcloud in the analytic         kg condensate/
!                      integration of the ql and qi    kg air in ql or 
!                      equations.                      qi integration
!
!       B_dt           product of B and dtcloud in     dimensionless in
!                      in the analytic integration     qa, ql, and qi
!                      of the qa equation, or D and    integration
!                      dtcloud in the analytic         
!                      integration of the ql and qi    
!                      equations.                      
!
!       qa0            value of cloud fraction or      dimensionless or
!                      cloud condensate at the         kg condensate /
!                      initial time                    kg air
!        
!       qa1            value of cloud fraction or      dimensionless or
!                      cloud condensate at the final   kg condensate /
!                      time                            kg air
!
!       qaeq           equilibrium value of cloud      dimensionless or
!                      fraction or cloud condensate    kg condensate /
!                      that the analytic integration   kg air
!                      approaches                   
!       qabar          mean value of cloud fraction    dimensionless or
!                      or cloud condensate over the    kg condensate /
!                      t0 to t0 + dtcloud interval     kg air
!       qve            Tiedtke environmenmtal 
!                      humidity
!
!------------------------------------------------------------------------
      real, dimension(idim, jdim,kdim) :: deltpg, dqs_ls, drhcqs_ls, dum,&
                                          qve 
      real, dimension(idim, jdim,kdim) :: A_dt, B_dt, qa1, qa0,  &
                                          qabar, qaeq, qa_t, tmp0, tmp1, &
                                          drhcqsdT, beta, ttmp, qtmp,  &
                                          qs_t, qs_l, qs_i, dqsdT1, gamma1
      real, dimension(idim,jdim)       :: qagtmp,qcgtmp,qvgtmp
      REAL                             :: eslt, qvs, qs_d, qvi, esit, ul
      REAL                             :: qvmax, esat0, tmp1s            
      INTEGER                          :: ns, id
      INTEGER                          :: i,j,k

!------------------------------------------------------------------------
!       The first step is to compute the change in qs due to large-
!       scale processes, dqs_ls.   In Tiedtke, it has contributions from 
!       large-scale uplift, convection induced compensating subsidence,
!       turbulence cooling and radiative cooling.  dqs_ls has the form:
!
!               (((omega+ grav*Mc)/airdens/cp)+radturbten)*dqsdT*dtcloud
!   (6) dqs_ls= --------------------------------------------------------
!                  1.  +   ( qa +  (da_ls/2.) ) * gamma
!
!       Here da_ls is the increase in cloud fraction due to non-
!       convective processes.  Because this increase is also a function
!       of dqs_ls, a quadratic equation must be solved for dqs_ls in
!       the case that da_ls is not equal to zero.
!------------------------------------------------------------------------
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            if (Atmos_state%T_in(i,j,k) .GE. tfreeze  - 40. ) then 
              drhcqsdT(i,j,k) =  hlv*Atmos_state%qsl(i,j,k)/  &
                                        (rvgas*Atmos_state%T_in(i,j,k)**2)
              beta(i,j,k) = drhcqsdT(i,j,k) * hlv /cp_air
            else
              drhcqsdT(i,j,k)  =  Atmos_state%rh_crit(i,j,k)*hls*  &
                                  Atmos_state%qsi(i,j,k)/  &
                                    (rvgas*Atmos_state%T_in(i,j,k)**2) +  &
                                    Particles%hom(i,j,k)*  &
                                   Atmos_state%qsi(i,j,k)*  &
                                     ( 2.*0.0073*(Atmos_state%T_in(i,j,k) -&
                                                   tfreeze      ) + 1.466)
              beta(i,j,k) = drhcqsdT(i,j,k) * hls/ cp_air
            endif 
          end do
        end do
      end do

!------------------------------------------------------------------------
!    first calculate environmental specific humidity based on old cloud 
!    fraction. take into account ahuco.
!------------------------------------------------------------------------
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            qa_t(i,j,k) =  MAX(MIN(Cloud_State%qa_upd(i,j,k) +  &
                                      Atmos_state%ahuco(i,j,k), 1.),0.)
            qve(i,j,k) =  (Atmos_state%qv_in(i,j,k) - qa_t(i,j,k)*  &
                            Atmos_state%qs(i,j,k) ) /   &
                                       MAX((1. - qa_t(i,j,k) ), Nml%qmin)
            dum(i,j,k) = (((Atmos_state%omega(i,j,k) + grav*  &
                             Atmos_state%Mc(i,j,k))/ &
                                 Atmos_state%airdens(i,j,k)/cp_air) + &
                                   Atmos_State%radturbten2(i,j,k))* &
                                                         Constants%dtcloud
            dqs_ls(i,j,k) = dum(i,j,k) * Atmos_state%dqsdT(i,j,k)
            drhcqs_ls(i,j,k) = dum(i,j,k) *drhcqsdT(i,j,k)
          end do
        end do
      end do

 !------------------------------------------------------------------------
 !       The next step is to compute the change in saturated volume
 !       fraction due to non-convective condensation, da_ls.   This 
 !       occurs in two conditions:
 !
 !       (a)  dqs_ls < 0. and U00 < U < 1., where U00 is the threshold
 !            relative humidity for non-convective condensation. Note 
 !            that if U is greater than or equal to 1., ideally qa = 1,
 !            and da_ls = 0.  However this may not be the case for 
 !            numerical reasons so this must be assured after analytic 
 !            integration of the qa equation.
 !
 !            For these cases the change in saturated volume fraction is:
 !
 !   (7)      da_ls = - (1.-qa)*(1.-qa)*dqs_ls/2./qs/(1.-U)
 !
 !            This formula arises from the assumption that vapor is uni-
 !            formly distributed in the range [qv_clr - (qs - qv_clr),qs]
 !            where qv_clr is the amount of vapor in the unsaturated 
 !            volume and is given from the following equation:
 !
 !   (8)      qv  =   qa * qs      +   (1.-qa) * qv_clr
 !          
 !            Implicit in equation (7) is the following assumption:
 !            As qsat changes, the distribution of qv+ql+qi 
 !            remains constant.  That is as qsat rises, portions where
 !            qv+ql+qi > qsat+dqsat remain saturated.  This can only
 !            occur if it is assumed that ql+qi evaporate-sublimate or
 !            condense-deposit to keep qv = qsat. 
 !
 !       (b)  dqs_ls > 0.  Ideally some portion of the cloud should
 !            evaporate however this is not accounted for at present.
 !----------------------------------------------------------------------- 
      where (dqs_ls .le. 0. .and.    &
                  qve .ge. U00p*Atmos_state%rh_crit_min*Atmos_state%qs &
                                                       .and. qa_t .lt. 1.)
        tmp0 =  (1 + Atmos_state%gamma*qa_t)*drhcqs_ls - beta*qa_t* &
                                                                    dqs_ls
        tmp1 = SQRT( (1.+qa_t*Atmos_state%gamma)**2. - (1.-qa_t)* &
                         beta * tmp0 /MAX( (  Atmos_state%rh_crit *  &
                          Atmos_state%qs - qve ), Nml%qmin ) ) -  &
                                            (1.+qa_t*Atmos_State%gamma) 
        tmp1 = -1.*tmp1/((1. - qa_t)*beta/(2.*MAX(   &
                   (Atmos_state%rh_crit*Atmos_State%qs - qve),  &
                                                              Nml%qmin )) )
        drhcqs_ls = min(tmp1, tmp0 / MAX(1.+ Atmos_state%gamma*qa_t +&
                                         beta*0.5*(1. - qa_t), Nml%qmin))
        Cloud_processes%da_ls = -0.5*(1. - qa_t)*drhcqs_ls/   &
             MAX( Atmos_state%rh_crit*Atmos_state%qs - qve, Nml%qmin)
        dqs_ls = (dqs_ls - Atmos_state%gamma*0.5*  &
                  Cloud_processes%da_ls*drhcqs_ls)/   &
                                          (1. + qa_t*Atmos_state%gamma)
      elsewhere
        drhcqs_ls = 0.
        Cloud_processes%da_ls = 0.
        dqs_ls = dqs_ls/(1. + qa_t*Atmos_state%gamma)
      endwhere

!------------------------------------------------------------------------
!       Turbulent erosion of clouds
!
!       As in Tiedtke (1993) this is calculated using the eros_scale
!       parameter as:
!
!   (9) dql/dt    =  - qa * eros_scale * (qs - qv) * (ql/ ql+qi )
!
!  (10) dqi/dt    =  - qa * eros_scale * (qs - qv) * (qi/ ql+qi )
!
!  (11) dqa/dt    =  - qa * eros_scale * (qs - qv) * (qa/ ql+qi )
!
!       for which the erosion sink term (B in equation 13) is
!
!  (12) B = qa * eros_scale * (qs - qv) / (ql + qi)  
!
!------------------------------------------------------------------------
      DO k=1,kdim
        DO j=1,jdim
          DO i=1,idim
            if (Cloud_state%ql_upd(i,j,k) .gt. Nml%qmin .or. &
                           Cloud_state%qi_upd (i,j,k).gt. Nml%qmin) then
              Cloud_processes%D_eros(i,j,k) =    &
                        Cloud_state%qa_upd(i,j,k)*erosion_scale(i,j,k)*   &
                                                 Constants%dtcloud*    &
                   (MAX(Atmos_state%qs(i,j,k) - Atmos_state%qv_in(i,j,k),&
                         0.)/(1. + Atmos_state%gamma(i,j,k)) ) /      &
                    (Cloud_state%qi_upd(i,j,k) +  &
                                             Cloud_state%ql_upd(i,j,k))

              if (Atmos_state%pfull(i,j,k) .gt. 400.e02) then
                Cloud_processes%D_eros(i,j,k) =   &
                     Cloud_processes%D_eros(i,j,k) + Nml%efact*  &
                                Cloud_processes%D_eros(i,j,k)*  &
                    ((Atmos_state%pfull(i,j,kdim) -     &
                                       Atmos_state%pfull(i,j,k))/  &
                                (Atmos_state%pfull(i,j,kdim) - 400.e02))

              else
                Cloud_processes%D_eros(i,j,k) =  &
                     Cloud_processes%D_eros(i,j,k) + Nml%efact*  &
                                          Cloud_processes%D_eros(i,j,k)
              endif
            else
              Cloud_processes%D_eros(i,j,k) = 0.
            endif
          END DO    
        END DO    
      END DO    

!------------------------------------------------------------------------ 
!       The next step is to analytically integrate the saturated volume
!       fraction equation.  This follows the Tiedtke approach
!
!       The qa equation is written in the form:
!
!  (13) dqa/dt    =   (1.-qa) * A   -  qa * B 
!
!       Note that over the physics time step, A, B are assumed to be 
!       constants.
!
!       Defining qa(t) = qa0 and qa(t+dtcloud) = qa1, the analytic
!       solution of the above equation is:
!
!  (14) qa1 = qaeq -  (qaeq - qa0) * exp (-(A+B)*dtcloud)
! 
!       where qaeq is the equilibrium cloud fraction that is approached
!       with an time scale of 1/(A+B),
!
!  (15) qaeq  =  A/(A+B)
!
!
!       To diagnose the magnitude of each of the right hand terms of
!       (13) integrated over the time step, define the average cloud
!       fraction in the interval t to t + dtcloud qabar as:
!
!  (16) qabar  = qaeq - [ (qa1-qa0) / ( dtcloud * (A+B) ) ]
! 
!       from which the magnitudes of the A and B terms integrated
!       over the time step are:
!
!       A * (1-qabar)    and    -B * (qabar)
!
!       Additional notes on this analytic integration:
!
!       1.   For large-scale cloud formation or destruction from 
!            the dqs_ls term the contributions to A or B are defined
!            from:
!
!  (19)      A_ls * (1. - qa) = da_ls / dtcloud      if da_ls >= 0.
! 
!  (20)      B_ls * qa        = da_ls / dtcloud      if da_ls < 0.
!
!
!       3.   Qa goes to zero only in the case of ql and qi less than or
!            equal to Nml%qmin; see 'cloud destruction code' near the end of 
!            this loop over levels.
!------------------------------------------------------------------------
        
!-------------------------------------------------------------------------
!    compute A_dt; This is assigned to the large-scale source term
!    following (18). Reset B_dt.
!-------------------------------------------------------------------------
   
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            A_dt(i,j,k) = Cloud_processes%da_ls(i,j,k)/   &
                                            max((1.-qa_t(i,j,k)),Nml%qmin)
            B_dt(i,j,k) = Cloud_processes%D_eros(i,j,k)
            if ( (A_dt(i,j,k) .gt. Nml%Dmin) .or.   &
                                      (B_dt(i,j,k) .gt. Nml%Dmin) ) then 
              qa0(i,j,k)   = Cloud_state%qa_upd(i,j,k)
              qaeq(i,j,k)  =                                     &
                                 A_dt(i,j,k)/(A_dt(i,j,k) + B_dt(i,j,k))
              qa1(i,j,k)  = qaeq(i,j,k) - (qaeq(i,j,k) - qa0(i,j,k))* &
                                     exp(-1.*(A_dt(i,j,k) + B_dt(i,j,k)) )
              qabar(i,j,k) = qaeq(i,j,k) - ((qa1(i,j,k) - qa0(i,j,k))/  &
                                         (A_dt(i,j,k) + B_dt(i,j,k)))
            else
              qa0(i,j,k)   = Cloud_state%qa_upd(i,j,k)
              qaeq(i,j,k)  = qa0(i,j,k)   
              qa1(i,j,k)   = qa0(i,j,k)   
              qabar(i,j,k) = qa0(i,j,k)  
            endif
          end do
        end do
      end do

!-------------------------------------------------------------------------
!    output some diagnostics.
!-------------------------------------------------------------------------
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            if ( (A_dt(i,j,k) .gt. Nml%Dmin) .and.   &
                 (B_dt(i,j,k) .gt. Nml%Dmin) )  then
      if (diag_id%qadt_lsform + diag_id%qa_lsform_col > 0) then
        diag_4d(i,j,k,diag_pt%qadt_lsform) =  A_dt(i,j,k)*(1. - qabar(i,j,k))*  &
                                                     Constants%inv_dtcloud
      end if
      if ( diag_id%qadt_eros + diag_id%qa_eros_col > 0 ) then
        diag_4d(i,j,k,diag_pt%qadt_eros)  = ((qa1(i,j,k) - qa0(i,j,k))*  &
                                          Constants%inv_dtcloud )- &
                            diag_4d(i,j,k,diag_pt%qadt_lsform)                                           
      end if

          else if (A_dt(i,j,k) .gt. Nml%Dmin) then
             if (diag_id%qadt_lsform + diag_id%qa_lsform_col > 0) then
 
        diag_4d(i,j,k,diag_pt%qadt_lsform) = (qa1(i,j,k) - qa0(i,j,k))*  &
                                                Constants%inv_dtcloud
              end if 
          else if (B_dt(i,j,k) .gt. Nml%Dmin)  then
              if ( diag_id%qadt_eros + diag_id%qa_eros_col > 0 ) then
            diag_4d(i,j,k,diag_pt%qadt_eros)  = (qa1(i,j,k) - qa0(i,j,k))*&
                                                Constants%inv_dtcloud
              end if 
                  endif
        end do
        end do
        end do

!-------------------------------------------------------------------------
!    limit cloud area to be no more than that which is not being
!    taken by convective clouds.
!-------------------------------------------------------------------------
      if ( diag_id%qadt_ahuco + diag_id%qa_ahuco_col > 0 ) then
        diag_4d(:,:,:,diag_pt%qadt_ahuco)  = qa1
      end if

      if (Constants%limit_conv_cloud_frac) then
        qa1 = MIN(qa1, 1.0 - Atmos_state%ahuco)
      endif

      if ( diag_id%qadt_ahuco + diag_id%qa_ahuco_col > 0 ) then
        diag_4d(:,:,:,diag_pt%qadt_ahuco)  =   &
                  (qa1(:,:,:) - diag_4d(:,:,:,diag_pt%qadt_ahuco))* & 
                                             Constants%inv_dtcloud 
      end if
                 
!-------------------------------------------------------------------------
!    set total tendency term and update cloud fraction.    
!-------------------------------------------------------------------------
      SA = (SA + qa1) - qa0
      Cloud_state%qa_upd = qa1
      Cloud_processes%delta_cf = MAX(qa1 - qa0 , 0.)

!-------------------------------------------------------------------------
!       The next step is to calculate the change in condensate
!       due to non-convective condensation, dcond_ls. Note that this is
!       not the final change but is used only to apportion condensate
!       change between phases. According to Tiedtke 1993 this takes the
!       form:
!
!  (21) dcond_ls = -1. * (qa +  0.5*da_ls) * dqs_ls
!
!       Here the 0.5*da_ls represents using a midpoint cloud fraction.
!       This is accomplished by using the variable qabar.

!cms but qabar is not limited to area outside  conv. clouds ...
  !!      dcond_ls = -1. * MIN(qabar, 1.- ahuco)  * dqs_ls
!-----------------------------------------------------------------------
      Cloud_processes%dcond_ls = -1.*qa_t*dqs_ls -    &
           0.5*MAX(MIN(Cloud_processes%da_ls, 1. - qa_t),0.)*drhcqs_ls 

!-----------------------------------------------------------------------
!     compute qs and condensation using updated temps and vapor.
!-----------------------------------------------------------------------
      ttmp=Atmos_state%T_in + ST        
      qtmp= Atmos_state%qv_in + SQ         
      CALL compute_qs_x1 (idim, jdim, kdim, ttmp, Atmos_state%pfull, &
                             qs_t, qs_l, qs_i, dqsdT1, gamma1 )
      DO k=1,kdim
        do j=1,jdim
          DO i=1, idim
             !see Tompkins et al., 2007
            qvmax = qs_t(i,j,k)*(qa_t(i,j,k) + (1. -  qa_t(i,j,k))*  &
                                             Atmos_state%rh_crit(i,j,k) )
            tmp1s =  max(0., (qtmp(i,j,k) - qvmax) )/(1. + gamma1(i,j,k))
            ! limit 
            IF (Cloud_processes%dcond_ls(i,j,k) .GT. 0. .OR.    &
                                                    tmp1s .GT. 0. )  THEN
              Cloud_processes%dcond_ls(i,j,k) =   &
                          MAX(Cloud_processes%dcond_ls(i,j,k), tmp1s) 
            ELSE
            !don't evaporate into saturated grid cells
            !CHECK
              if ( qve(i,j,k) .lt. qs_t(i,j,k)) then
                tmp1s =  max(0.,( qs_t(i,j,k) - qtmp(i,j,k) ))/   &
                               (1. + gamma1(i,j,k)) ! evap .le. qs - qtmp
                Cloud_processes%dcond_ls(i,j,k) = MAX( -1.*tmp1s,  &
                                         Cloud_processes%dcond_ls(i,j,k))
              end if
            END IF
          END DO
        END DO
      END DO

!------------------------------------------------------------------------                                 


end SUBROUTINE nc_cond_nopdf_super 


!#########################################################################

SUBROUTINE nc_cond_pdf (idim, jdim, kdim, Nml, Constants, Atmos_state,  &
                        Cloud_state, ST, SQ, Cloud_processes, Particles, &
                        n_diag_4d, diag_4d, diag_id, diag_pt, otun, SA)  

!----------------------------------------------------------------------!
!                                                                      !
!                                                                      !
!                                                                      !
!                 NON-CONVECTIVE CONDENSATION                          !
!                                                                      !
!                                                                      !
!                                                                      !
!                         METHOD 2                                     !
!                                                                      !
!                                                                      !
!                STATISTICAL CLOUD FRACTION                            !
!                                                                      !
!                                                                      !
!-----------------------------------------------------------------------
INTEGER,                           INTENT(IN )   :: idim, jdim, kdim     
type(strat_nml_type),              intent(in)    :: Nml
type(atmos_state_type),            intent(inout) :: Atmos_state
type(cloud_state_type),            intent(inout) :: Cloud_state
type(cloud_processes_type),        intent(inout) :: Cloud_processes
type(particles_type),              intent(inout) :: Particles
type(strat_constants_type),        intent(inout) :: Constants  
REAL, dimension(idim,jdim,kdim),   INTENT(IN )   :: ST, SQ
REAL, dimension(idim,jdim,kdim),   INTENT(INout) :: SA
INTEGER,                           INTENT(IN )   :: n_diag_4d
REAL, dimension( idim, jdim, kdim, 0:n_diag_4d ),         &
                                   INTENT(INOUT )::  diag_4d
TYPE(diag_id_type),                intent(in)    :: diag_id
TYPE(diag_pt_type),                intent(in)    :: diag_pt
INTEGER,                           INTENT(IN )   :: otun

!-----------------------------------------------------------------------
!-----local variables---------------------------------------------------
 
!-----------------------------------------------------------------------
!                STATISTICAL CLOUD SCHEME VARIABLES
!
!
!       qcg            equilibrium value of cloud      kg condensate /
!                      condensate that PDF clouds      kg air
!                      wants           
!
!       qag            equilibrium value of cloud      dimensionless 
!                      fraction for statistical 
!                      cloud scheme           
!
!       qs_norm        the difference between the      dimensionless
!                      saturation specific humidity    
!                      and qtmin normalized by deltaQ
!
!       icbp           the value of the incomplete     dimensionless
!                      beta function evaluated with
!                      x=qs_norm, p=betaP, and q=betaP
!
!       icbp1          the value of the incomplete     dimensionless
!                      beta function evaluated with                  
!                      x=qs_norm, p=betaP+1, and 
!                      q=betaP
!
!       qtbar          total water specific humidity   kg water /
!                      which is equal to the sum of    kg air
!                      liquid water, ice water, and
!                      water vapor
!
!       deltaQ         the width of the total water    kg water /
!                      subgrid distribution (= qtmax   kg air
!                      minus qtmin)
!
!       qtmin          the minimum value to the total  kg water /
!                      sub-grid scale distribution     kg air
!
      real, dimension(idim, jdim,kdim)   :: qa1, qa0, qabar, qcg, qag,  &
                                            qa_t, tmp0, tmp1, tmp2
      real, dimension(4,idim, jdim,kdim) :: qta4,qtqsa4
      real, dimension(idim,jdim)         :: qagtmp, qcgtmp, qvgtmp, qtbar,&
                                            deltaQ, qtmin, qs_norm     
      real                               :: icbp, icbp1, pnorm, eslt, qvs,&
                                            qs_d, qvi, esit, ul, ttmp,  &
                                            qtmp, qs_t, dqsdT1, qvmax, &
                                            esat0, gamma1, tmp1s,  &
                                            qs_l, qs_i
      INTEGER                            :: ns, id
      INTEGER                            :: i,j,k

 
!-----------------------------------------------------------------------
!       a sub-vertical grid scale distribution is going to be needed.  
!       do ppm fits.
!-----------------------------------------------------------------------
      IF (Nml%pdf_org) THEN
        qta4(1,:,:,:) = max(Nml%qmin, Atmos_state%qv_in +  &
                                     Cloud_state%ql_in + Cloud_state%qi_in)
      ELSE
        qta4(1,:,:,:) = max(Nml%qmin,Atmos_State%qv_in + SQ +  &
                             Cloud_state%ql_upd + Cloud_state%qi_upd)
      END IF

      qtqsa4(1,:,:,:) = qta4(1,:,:,:) - Atmos_state%qs
        
      if (Nml%nsublevels .gt. 1) then
        do j=1,jdim
          call ppm2m_sak (qta4(:,:,j,:), Atmos_state%delp(:,:,:), kdim,&
                          Nml%kmap, 1, idim, 0, Nml%kord)
          call ppm2m_sak (qtqsa4(:,:,j,:), Atmos_state%delp(:,:,:),   &
                          kdim, Nml%kmap, 1, idim, 0, Nml%kord)
        end do
      else
        qta4(2,:,:,:) = qta4(1,:,:,:)
        qta4(3,:,:,:) = qta4(1,:,:,:)
        qta4(4,:,:,:) = 0.
        qtqsa4(2,:,:,:) = qtqsa4(1,:,:,:)
        qtqsa4(3,:,:,:) = qtqsa4(1,:,:,:)
        qtqsa4(4,:,:,:) = 0.   
      end if

      qcg(:,:,:) = 0.
      Cloud_processes%qvg(:,:,:) = 0.
      qag(:,:,:) = 0.
       
!-----------------------------------------------------------------------
!    set Tiedtke erosion term to zero.
!-----------------------------------------------------------------------
      Cloud_processes%D_eros = 0.
        
!-----------------------------------------------------------------------
!    compute pdf cloud fraction and condensate
! 
!    Note that the SYMMETRIC beta distribution is used here.
!
!
!    Initialize grid-box mean values of cloud fraction (qag),
!    cloud condensate(qcg), and clear sky water vapor (qvg)
!-----------------------------------------------------------------------
     ks_loop: DO k=1,kdim
       !! qcg(:,k) = 0.
        ! qvg(:,k) = 0.
        !!qag (:,k)= 0.
        
        !Create loop over sub-levels within a grid box
   
        sublevel_loop: do ns = 1, Nml%nsublevels
        
             !calculate normalized vertical level
             ! 0. = top of gridbox
             ! 1. = bottom of gridbox
        
             pnorm =  (real(ns) - 0.5 )/real(Nml%nsublevels)
        
             !First step is to calculating the minimum (qtmin)
             !of the total water distribution and 
             !the width of the qt distribution (deltaQ)
             !
             !For diagnostic variance this is set to (1.-qthalfwidth)*qtbar
             !and 2*qthalfwidth*qtbar, respectively, where qtbar is the
             !mean total water in the grid box.        
             !
             !

             qtbar = qta4(2,:,:,k) + pnorm*((qta4(3,:,:,k) -   &
                                qta4(2,:,:,k)) + qta4(4,:,:,k)*(1-pnorm) )
             
             qtbar  = max(Nml%qmin ,qtbar )
             deltaQ  = 2.*Nml%qthalfwidth *qtbar
             qtmin = (1.-Nml%qthalfwidth )*qtbar 
        
             !From this the variable normalized saturation specific
             !humidity qs_norm is calculated.
             !
             !  qs_norm = (qs(Tl) - qtmin)/(qtmax-qtmin)
             !
             !          = 0.5  - (qtbar - qs(Tl))/deltaQ
             !
             !Note that if qs_norm > 1., the grid box is fully clear.
             !If qs_norm < 0., the grid box is fully cloudy.
        
             qs_norm = qtqsa4(2,:,:,k)+  &
                       pnorm*( (qtqsa4(3,:,:,k)-qtqsa4(2,:,:,k)) + &
                       qtqsa4(4,:,:,k)*(1-pnorm) )
      
             qs_norm = 0.5 - ( qs_norm/deltaQ )
             
             !Calculation of cloud fraction (qagtmp), cloud condensate 
             !(qcgtmp), and water vapor in clear air part of the grid 
             !box (qvgtmp)
             !
             !Formulas (from Tompkins, and personal derivations):
             !
             !  Define icbp  = incomplete_beta(qs_norm,p,q)
             !         icbp1 = incomplete_beta(qs_norm,p+1,q)
             !
             !  qagtmp = 1. - icbp
             !
             !  qcgtmp = aThermo * {  (qtbar-qtmin)*(1.-icbp1) - 
             !                       qs_norm*deltaQ*(1.-icbp ) }
             !
             !
             !  qvgtmp = qtmin + (p/(p+q))*(icbp1/icbp)*deltaQ
             !
             !  
             ! where aThermo = 1./(1.+(L/cp)*dqsdT)
             !
             ! note that in the qvg formula below the factor of 0.5
             ! is equal to (p/(p+q)).
             !

             do j=1,jdim
             
             do id = 1,idim
        
             if (qs_norm(id,j).le.1.) then
                 
                 icbp = incomplete_beta(max(0.,qs_norm(id,j)), &
                                      p = Nml%betaP    , q = Nml%betaP)
                 icbp1= incomplete_beta(max(0.,qs_norm(id,j)), &
                                      p = Nml%betaP + 1, q = Nml%betaP)
                 qagtmp(id,j) = 1.-icbp
                 qcgtmp(id,j) = (qtbar(id,j)-qtmin(id,j))*(1.-icbp1)&
                               - qs_norm(id,j)*deltaQ(id,j)*(1.-icbp)    
                 qcgtmp(id,j) = qcgtmp(id,j)/   &
                                          (1.+Atmos_state%gamma(id,j,k))
                 qvgtmp(id,j) = qtmin(id,j) + &
                               0.5*(icbp1/max(icbp,Nml%qmin))*deltaQ(id,j)
             
                 !bound very very small cloud fractions which may
                 !cause negative cloud condensates due to roundoff 
                 !errors or similar errors in the beta table lookup.
                 if((qagtmp(id,j).lt.0.).or.(qcgtmp(id,j).le.0.))then
                      qagtmp(id,j) = 0.
                      qcgtmp(id,j) = 0.
                      qvgtmp(id,j) = qtbar(id,j)
                 end if
                 
             else             
                 qagtmp(id,j) = 0.
                 qcgtmp(id,j) = 0.
                 qvgtmp(id,j) = qtbar(id,j)             
             end if
             
             enddo
             enddo
              
             !sum vertically
             !
             !note special averaging of clear-sky water vapor
             !this is weighting clear-sky relative humidity by the 
             !clear-sky fraction
         
             qag(:,:,k) = qag(:,:,k) + qagtmp
             qcg(:,:,k) = qcg(:,:,k) + qcgtmp
             Cloud_processes%qvg(:,:,k) =    &
                     Cloud_processes%qvg(:,:,k)+ &
                               (1.-qagtmp)*min(max(qvgtmp/max(Nml%qmin, &
                                   (qtbar+((qs_norm-0.5)*deltaQ))),0.),1.)
             
        enddo sublevel_loop!for number of sublevels loop
        


        !compute grid-box average cloud fraction, cloud condensate
        !and water vapor
        
        if (Nml%nsublevels.gt.1) then
             qag (:,:,k)= qag(:,:,k) / real(Nml%nsublevels)
             qcg(:,:,k) = qcg(:,:,k) / real(Nml%nsublevels)
             
             !note special averaging of clear-sky water vapor
            
             do j = 1,jdim
             do id = 1,idim
                  if ((1.-qag(id,j,k)).gt.Nml%qmin) then
                    Cloud_processes%qvg(id,j,k) =  &
                       Cloud_processes%qvg(id,j,k)/real(Nml%nsublevels)/&
                                                        (1.-qag(id,j,k))
                    Cloud_processes%qvg(id,j,k) =  &
                              Cloud_processes%qvg(id,j,k)*   &
                                                 Atmos_state%qs(id,j,k)
                  else
                    Cloud_processes%qvg(id,j,k) =   &
                                                Atmos_state%qs(id,j,k)
                  end if
             enddo
             enddo
          
             
        else
             ! for nsublevels = 1, qag and qcg already hold their
             ! final values
             Cloud_processes%qvg(:,:,k) = qvgtmp
        end if
     
       
   END DO ks_loop
        
        !do adjustment of cloud fraction
        qa0 = Cloud_state%qa_in
        qa1 = qag

        !set total tendency term and update cloud fraction    
        SA   = (SA   + qa1) - qa0
!       Cloud_state%SA3d   = (Cloud_state%SA3d   + qa1) - qa0
        Cloud_state%qa_upd     = qa1


      if (diag_id%qadt_lsform + diag_id%qa_lsform_col > 0) then
          diag_4d(:,:,:,diag_pt%qadt_lsform ) =  max(qa1 - qa0, 0.)*  &
                                                     Constants%inv_dtcloud 
        end if
        if ( diag_id%qadt_lsdiss + diag_id%qa_lsdiss_col > 0 ) then
          diag_4d(:,:,:,diag_pt%qadt_lsdiss ) =  max(qa0 - qa1, 0.)* &
                                                      Constants%inv_dtcloud
         end if
        !define da_ls and tmp5 needed when do_liq_num = .true. (cjg)
        Cloud_processes%da_ls = max(qa1-qa0,0.)
        Cloud_processes%delta_cf = max(qa1-qa0,0.)

        !compute large-scale condensation / evaporation
        Cloud_processes%dcond_ls = qcg -    &
                              (Cloud_state%ql_upd + Cloud_state%qi_upd)



   IF ( .NOT. Nml%pdf_org ) THEN
   !!!! INVESTIGATE!!!
   !make sure super/subsat is not created here
   ! this is different from the original PDF assumption
   !  (as is saturation adjustment) 

     Cloud_processes%dcond_ls = MAX( ((Atmos_state%qv_in + SQ -  &
                Atmos_State%qs)/(1.+Atmos_state%gamma)),    &
                                               Cloud_processes%dcond_ls)
       
      
   END IF

!------------------------------------------------------------------------
 


end SUBROUTINE nc_cond_pdf 


!########################################################################


!----------------------------------------------------------------------- 
!BOP
! !ROUTINE:  ppm2m_sak --- Piecewise parabolic method for fields
!
! !INTERFACE:
 subroutine ppm2m_sak(a4, delp, km, kmap, i1, i2, iv, kord)

!implicit none

! !INPUT PARAMETERS:
 integer, intent(in):: iv      ! iv =-1: winds
                               ! iv = 0: positive definite scalars
                               ! iv = 1: others
 integer, intent(in):: i1      ! Starting longitude
 integer, intent(in):: i2      ! Finishing longitude
 integer, intent(in):: km      ! vertical dimension
 integer, intent(in):: kmap    ! partial remap to start
 integer, intent(in):: kord    ! Order (or more accurately method no.):
                               ! 
 real, intent(in):: delp(i1:i2,km)     ! layer pressure thickness

! !INPUT/OUTPUT PARAMETERS:
 real, intent(inout):: a4(4,i1:i2,km)  ! Interpolated values

! !DESCRIPTION:
!
!   Perform the piecewise parabolic method 
! 
! !REVISION HISTORY: 
!   ??.??.??    Lin        Creation
!   02.04.04    Sawyer     Newest release from FVGCM
! 
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
! local arrays:
      real   dc(i1:i2,km)
      real   h2(i1:i2,km)
      real delq(i1:i2,km)
      real  df2(i1:i2,km)
      real   d4(i1:i2,km)

! local scalars:
      integer i, k, km1, lmt
      integer it
      real fac
      real a1, a2, c1, c2, c3, d1, d2
      real qmax, qmin, cmax, cmin
      real qm, dq, tmp
      real qmp, pmp
      real lac

      km1 = km - 1
       it = i2 - i1 + 1

      do k=max(2,kmap-2),km
         do i=i1,i2
            delq(i,k-1) =   a4(1,i,k) - a4(1,i,k-1)
              d4(i,k  ) = delp(i,k-1) + delp(i,k)
         enddo
      enddo
 
      do k=max(2,kmap-2),km1
         do i=i1,i2
            c1  = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
            c2  = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
            tmp = delp(i,k)*(c1*delq(i,k) + c2*delq(i,k-1)) /      &
                                    (d4(i,k)+delp(i,k+1))
            qmax = max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1)) - a4(1,i,k)
            qmin = a4(1,i,k) - min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))
             dc(i,k) = sign(min(abs(tmp),qmax,qmin), tmp)
            df2(i,k) = tmp
         enddo
      enddo

!-----------------------------------------------------------
! 4th order interpolation of the provisional cell edge value
!-----------------------------------------------------------

      do k=max(3,kmap), km1
      do i=i1,i2
        c1 = delq(i,k-1)*delp(i,k-1) / d4(i,k)
        a1 = d4(i,k-1) / (d4(i,k) + delp(i,k-1))
        a2 = d4(i,k+1) / (d4(i,k) + delp(i,k))
        a4(2,i,k) = a4(1,i,k-1) + c1 + 2./(d4(i,k-1)+d4(i,k+1)) *    &
                  ( delp(i,k)*(c1*(a1 - a2)+a2*dc(i,k-1)) -          &
                                delp(i,k-1)*a1*dc(i,k  ) )
      enddo
      enddo

      if(km>8 .and. kord>3) call steepz_sak(i1, i2, km, kmap, a4, df2, dc, delq, delp, d4)

! Area preserving cubic with 2nd deriv. = 0 at the boundaries
! Top
      if ( kmap <= 2 ) then
      do i=i1,i2
         d1 = delp(i,1)
         d2 = delp(i,2)
         qm = (d2*a4(1,i,1)+d1*a4(1,i,2)) / (d1+d2)
         dq = 2.*(a4(1,i,2)-a4(1,i,1)) / (d1+d2)
         c1 = 4.*(a4(2,i,3)-qm-d2*dq) / ( d2*(2.*d2*d2+d1*(d2+3.*d1)) )
         c3 = dq - 0.5*c1*(d2* (5.*d1+d2)-3.*d1**2)
         a4(2,i,2) = qm - 0.25*c1*d1*d2*(d2+3.*d1)
         a4(2,i,1) = d1*(2.*c1*d1**2-c3) + a4(2,i,2)
         dc(i,1) =  a4(1,i,1) - a4(2,i,1)
! No over- and undershoot condition
         cmax = max(a4(1,i,1), a4(1,i,2))
         cmin = min(a4(1,i,1), a4(1,i,2))
         a4(2,i,2) = max(cmin,a4(2,i,2))
         a4(2,i,2) = min(cmax,a4(2,i,2))
      enddo
      endif

! Bottom
! Area preserving cubic with 2nd deriv. = 0 at the surface
      do i=i1,i2
         d1 = delp(i,km)
         d2 = delp(i,km1)
         qm = (d2*a4(1,i,km)+d1*a4(1,i,km1)) / (d1+d2)
         dq = 2.*(a4(1,i,km1)-a4(1,i,km)) / (d1+d2)
         c1 = (a4(2,i,km1)-qm-d2*dq) / (d2*(2.*d2*d2+d1*(d2+3.*d1)))
         c3 = dq - 2.0*c1*(d2*(5.*d1+d2)-3.*d1**2)
         a4(2,i,km) = qm - c1*d1*d2*(d2+3.*d1)
         a4(3,i,km) = d1*(8.*c1*d1**2-c3) + a4(2,i,km)
         dc(i,km) = a4(3,i,km) -  a4(1,i,km)
! No over- and under-shoot condition
         cmax = max(a4(1,i,km), a4(1,i,km1))
         cmin = min(a4(1,i,km), a4(1,i,km1))
         a4(2,i,km) = max(cmin,a4(2,i,km))
         a4(2,i,km) = min(cmax,a4(2,i,km))
      enddo

      do k=max(1,kmap),km1
         do i=i1,i2
            a4(3,i,k) = a4(2,i,k+1)
         enddo
      enddo

! Enforce monotonicity of the "slope" within the top layer
      if ( kmap <= 2 ) then
      do i=i1,i2
         if ( a4(2,i,1) * a4(1,i,1) <= 0. ) then 
              a4(2,i,1) = 0.
                dc(i,1) = a4(1,i,1)
         endif
         if ( dc(i,1) * (a4(2,i,2) - a4(1,i,1)) <= 0. ) then
! Setting DC==0 will force piecewise constant distribution after
! calling kmppm_sak
              dc(i,1) = 0.
         endif
      enddo
      endif

! Enforce constraint on the "slope" at the surface

      do i=i1,i2
         if( a4(3,i,km) * a4(1,i,km) <= 0. ) then
!            a4(3,i,km) = 0.
!              dc(i,km) =  -a4(1,i,km)
               dc(i,km) = 0.
         endif
         if( dc(i,km) * (a4(1,i,km) - a4(2,i,km)) <= 0. ) then
             dc(i,km) = 0.
         endif
      enddo
 
!-----------------------------------------------------------
! f(s) = AL + s*[(AR-AL) + A6*(1-s)]         ( 0 <= s  <= 1 )
!-----------------------------------------------------------
! Top 2 and bottom 2 layers always use monotonic mapping
      if ( kmap <= 2 ) then
      do k=1,2
         do i=i1,i2
            a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
         enddo
            call kmppm_sak(dc(i1,k), a4(1,i1,k), it, 0)
      enddo
      endif

      if(kord >= 7) then
!-----------------------
! Huynh's 2nd constraint
!-----------------------
      do k=max(2,kmap-1), km1
         do i=i1,i2
! Method#1
!           h2(i,k) = delq(i,k) - delq(i,k-1)
! Method#2
!           h2(i,k) = 2.*(dc(i,k+1)/delp(i,k+1) - dc(i,k-1)/delp(i,k-1))
!    &               / ( delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)) )
!    &               * delp(i,k)**2
! Method#3
            h2(i,k) = dc(i,k+1) - dc(i,k-1)
         enddo
      enddo

      if( kord == 7 ) then
         fac = 1.5           ! original quasi-monotone
      else
         fac = 0.125         ! full monotone
      endif

      do k=max(3,kmap), km-2
        do i=i1,i2
! Right edges
!        qmp   = a4(1,i,k) + 2.0*delq(i,k-1)
!        lac   = a4(1,i,k) + fac*h2(i,k-1) + 0.5*delq(i,k-1)
!
         pmp   = 2.*dc(i,k)
         qmp   = a4(1,i,k) + pmp
         lac   = a4(1,i,k) + fac*h2(i,k-1) + dc(i,k)
         qmin  = min(a4(1,i,k), qmp, lac)
         qmax  = max(a4(1,i,k), qmp, lac)
         a4(3,i,k) = min(max(a4(3,i,k), qmin), qmax)
! Left  edges
!        qmp   = a4(1,i,k) - 2.0*delq(i,k)
!        lac   = a4(1,i,k) + fac*h2(i,k+1) - 0.5*delq(i,k)
!
         qmp   = a4(1,i,k) - pmp
         lac   = a4(1,i,k) + fac*h2(i,k+1) - dc(i,k)
         qmin  = min(a4(1,i,k), qmp, lac)
         qmax  = max(a4(1,i,k), qmp, lac)
         a4(2,i,k) = min(max(a4(2,i,k), qmin), qmax)
! Recompute A6
         a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
        enddo
! Additional constraint to ensure positivity when kord=7
         if (iv == 0 .and. kord == 7) then
             call kmppm_sak(dc(i1,k), a4(1,i1,k), it, 2)
         endif
      enddo

      else
 
         lmt = kord - 3
         lmt = max(0, lmt)
         if (iv == 0) lmt = min(2, lmt)

      do k=max(3,kmap), km-2
      if( kord /= 4) then
         do i=i1,i2
            a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
         enddo
      endif
         call kmppm_sak(dc(i1,k), a4(1,i1,k), it, lmt)
      enddo
      endif

      do k=km1,km
         do i=i1,i2
            a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
         enddo
         call kmppm_sak(dc(i1,k), a4(1,i1,k), it, 0)
      enddo
!EOC
 end subroutine ppm2m_sak
!-----------------------------------------------------------------------


!----------------------------------------------------------------------- 
!BOP
! !ROUTINE:  kmppm_sak --- Perform piecewise parabolic method in vertical
!
! !INTERFACE:
 subroutine kmppm_sak(dm, a4, itot, lmt)

!implicit none

! !INPUT PARAMETERS:
      real, intent(in):: dm(*)     ! the linear slope
      integer, intent(in) :: itot      ! Total Longitudes
      integer, intent(in) :: lmt       ! 0: Standard PPM constraint
                                       ! 1: Improved full monotonicity constraint (Lin)
                                       ! 2: Positive definite constraint
                                       ! 3: do nothing (return immediately)
! !INPUT/OUTPUT PARAMETERS:
      real, intent(inout) :: a4(4,*)   ! PPM array
                                           ! AA <-- a4(1,i)
                                           ! AL <-- a4(2,i)
                                           ! AR <-- a4(3,i)
                                           ! A6 <-- a4(4,i)

! !DESCRIPTION:
!
! !REVISION HISTORY: 
!    00.04.24   Lin       Last modification
!    01.03.26   Sawyer    Added ProTeX documentation
!    02.04.04   Sawyer    Incorporated newest FVGCM version
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:

      real, parameter:: r12 = 1./12.
      real qmp
      real da1, da2, a6da
      real fmin
      integer i

! Developer: S.-J. Lin, NASA-GSFC
! Last modified: Apr 24, 2000

      if ( lmt == 3 ) return

      if(lmt == 0) then
! Standard PPM constraint
      do i=1,itot
      if(dm(i) == 0.) then
         a4(2,i) = a4(1,i)
         a4(3,i) = a4(1,i)
         a4(4,i) = 0.
      else
         da1  = a4(3,i) - a4(2,i)
         da2  = da1**2
         a6da = a4(4,i)*da1
         if(a6da < -da2) then
            a4(4,i) = 3.*(a4(2,i)-a4(1,i))
            a4(3,i) = a4(2,i) - a4(4,i)
         elseif(a6da > da2) then
            a4(4,i) = 3.*(a4(3,i)-a4(1,i))
            a4(2,i) = a4(3,i) - a4(4,i)
         endif
      endif
      enddo

      elseif (lmt == 1) then

! Improved full monotonicity constraint (Lin 2003)
! Note: no need to provide first guess of A6 <-- a4(4,i)
      do i=1, itot
           qmp = 2.*dm(i)
         a4(2,i) = a4(1,i)-sign(min(abs(qmp),abs(a4(2,i)-a4(1,i))), qmp)
         a4(3,i) = a4(1,i)+sign(min(abs(qmp),abs(a4(3,i)-a4(1,i))), qmp)
         a4(4,i) = 3.*( 2.*a4(1,i) - (a4(2,i)+a4(3,i)) )
      enddo

      elseif (lmt == 2) then

! Positive definite constraint
      do i=1,itot
      if( abs(a4(3,i)-a4(2,i)) < -a4(4,i) ) then
      fmin = a4(1,i)+0.25*(a4(3,i)-a4(2,i))**2/a4(4,i)+a4(4,i)*r12
         if( fmin < 0. ) then
         if(a4(1,i)<a4(3,i) .and. a4(1,i)<a4(2,i)) then
            a4(3,i) = a4(1,i)
            a4(2,i) = a4(1,i)
            a4(4,i) = 0.
         elseif(a4(3,i) > a4(2,i)) then
            a4(4,i) = 3.*(a4(2,i)-a4(1,i))
            a4(3,i) = a4(2,i) - a4(4,i)
         else
            a4(4,i) = 3.*(a4(3,i)-a4(1,i))
            a4(2,i) = a4(3,i) - a4(4,i)
         endif
         endif
      endif
      enddo

      endif

!EOC
 end subroutine kmppm_sak
!-----------------------------------------------------------------------

!----------------------------------------------------------------------- 
!BOP
! !ROUTINE:  steepz_sak --- Calculate attributes for PPM
!
! !INTERFACE:
 subroutine steepz_sak(i1, i2, km, kmap, a4, df2, dm, dq, dp, d4)

!  implicit none

! !INPUT PARAMETERS:
      integer, intent(in) :: km                   ! Total levels
      integer, intent(in) :: kmap                 ! 
      integer, intent(in) :: i1                   ! Starting longitude
      integer, intent(in) :: i2                   ! Finishing longitude
      real, intent(in) ::  dp(i1:i2,km)       ! grid size
      real, intent(in) ::  dq(i1:i2,km)       ! backward diff of q
      real, intent(in) ::  d4(i1:i2,km)       ! backward sum:  dp(k)+ dp(k-1) 
      real, intent(in) :: df2(i1:i2,km)       ! first guess mismatch
      real, intent(in) ::  dm(i1:i2,km)       ! monotonic mismatch

! !INPUT/OUTPUT PARAMETERS:
      real, intent(inout) ::  a4(4,i1:i2,km)  ! first guess/steepened

!
! !DESCRIPTION:
!   This is complicated stuff related to the Piecewise Parabolic Method
!   and I need to read the Collela/Woodward paper before documenting
!   thoroughly.
!
! !REVISION HISTORY: 
!   ??.??.??    Lin?       Creation
!   01.03.26    Sawyer     Added ProTeX documentation
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer i, k
      real alfa(i1:i2,km)
      real    f(i1:i2,km)
      real  rat(i1:i2,km)
      real  dg2

! Compute ratio of dq/dp
      do k=max(2,kmap-1),km
         do i=i1,i2
            rat(i,k) = dq(i,k-1) / d4(i,k)
         enddo
      enddo

! Compute F
      do k=max(2,kmap-1),km-1
         do i=i1,i2
            f(i,k) =   (rat(i,k+1) - rat(i,k))                          &
                     / ( dp(i,k-1)+dp(i,k)+dp(i,k+1) )
         enddo
      enddo

      do k=max(3,kmap),km-2
         do i=i1,i2
         if(f(i,k+1)*f(i,k-1)<0. .and. df2(i,k)/=0.) then
            dg2 = (f(i,k+1)-f(i,k-1))*((dp(i,k+1)-dp(i,k-1))**2          &
                   + d4(i,k)*d4(i,k+1) )
            alfa(i,k) = max(0., min(0.5, -0.1875*dg2/df2(i,k))) 
         else
            alfa(i,k) = 0.
         endif
         enddo
      enddo

      do k=max(4,kmap+1),km-2
         do i=i1,i2
            a4(2,i,k) = (1.-alfa(i,k-1)-alfa(i,k)) * a4(2,i,k) +         &
                        alfa(i,k-1)*(a4(1,i,k)-dm(i,k))    +             &
                        alfa(i,k)*(a4(1,i,k-1)+dm(i,k-1))
         enddo
      enddo

!EOC
 end subroutine steepz_sak
!----------------------------------------------------------------------- 




!#######################################################################


end module nc_cond_mod

module tracer_type_mod

implicit none
private

public :: tracer_type
public :: tracer_type_version, tracer_type_tagname

character(len=128) :: tracer_type_version = '$Id: tracer_type.F90,v 11.0 2004/09/28 19:30:05 fms Exp $'
character(len=128) :: tracer_type_tagname = '$Name: tikal $'

type tracer_type
  character(len=32) :: name, numerical_representation, advect_horiz, advect_vert, hole_filling
  real :: robert_coeff
end type

end module tracer_type_mod

module coupler_types_mod  !{
!-----------------------------------------------------------------------
!                   GNU General Public License                        
! This file is a part of MOM.                                                                 
!                                                                      
! MOM is free software; you can redistribute it and/or modify it and  
! are expected to follow the terms of the GNU General Public License  
! as published by the Free Software Foundation; either version 2 of   
! the License, or (at your option) any later version.                 
!                                                                      
! MOM is distributed in the hope that it will be useful, but WITHOUT    
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
! License for more details.                                           
!                                                                      
! For the full text of the GNU General Public License,                
! write to: Free Software Foundation, Inc.,                           
!           675 Mass Ave, Cambridge, MA 02139, USA.                   
! or see:   http://www.gnu.org/licenses/gpl.html                      
!-----------------------------------------------------------------------
!
!<CONTACT EMAIL="Richard.Slater@noaa.gov">
! Richard D. Slater 
!</CONTACT>
!
! <REVIEWER EMAIL="John.Dunne@noaa.gov">
! John Dunne
! </REVIEWER>
!
!<OVERVIEW>
! This module contains type declarations for the coupler.
!</OVERVIEW>
!
!<DESCRIPTION>
! This module contains type declarations for the coupler.
!</DESCRIPTION>
!

!
! /coupler_mod/
!              types/
!                    air_sea_gas_flux_generic/
!                         implementation/
!                                        ocmip2/
!                                                    num_parameters = 2
!                         num_flags = 0
!                         use_atm_pressure = t
!                         use_10m_wind_speed = t
!                         pass_through_ice = f
!                         atm/
!                             name/
!                                  pcair, u10, psurf
!                             long_name/
!                                       'Atmospheric concentration'
!                                       'Wind speed at 10 m'
!                                       'Surface atmospheric pressure'
!                             units/
!                                   'mol/mol', 'm/s', 'Pa'
!                         ice/
!                             name/
!                                  alpha, csurf, sc_no
!                             long_name/
!                                       'Solubility from atmosphere'
!                                       'Surface concentration from ocean'
!                                       'Schmidt number'
!                             units/
!                                   'mol/m^3/atm', 'mol/m^3', 'dimensionless'
!                         flux/
!                              name/
!                                   flux, deltap, kw
!                              long_name/
!                                        'Surface gas flux'
!                                        'ocean-air delta pressure'
!                                        'piston velocity'
!                              units/
!                                    'mol/m^2/s', 'uatm', 'm/s'
!                    air_sea_gas_flux/
!                         implementation/
!                                        ocmip2/
!                                                    num_parameters = 2
!                                        ocmip2_data/
!                                                    num_parameters = 2
!                                        linear/
!                                                    num_parameters = 3
!                         num_flags = 0
!                         use_atm_pressure = t
!                         use_10m_wind_speed = t
!                         pass_through_ice = f
!                         atm/
!                             name/
!                                  pcair, u10, psurf
!                             long_name/
!                                       'Atmospheric concentration'
!                                       'Wind speed at 10 m'
!                                       'Surface atmospheric pressure'
!                             units/
!                                   'mol/mol', 'm/s', 'Pa'
!                         ice/
!                             name/
!                                  alpha, csurf
!                             long_name/
!                                       'Solubility from atmosphere'
!                                       'Surface concentration from ocean'
!                             units/
!                                   'mol/m^3/atm', 'mol/m^3'
!                         flux/
!                              name/
!                                   flux
!                              long_name/
!                                        'Surface gas flux'
!                              units/
!                                    'mol/m^2/s'
!                    air_sea_deposition/
!                         implementation/
!                                        dry/
!                                            num_parameters = 1
!                                        wet/
!                                            num_parameters = 1
!                         num_flags = 0
!                         use_atm_pressure = f
!                         use_10m_wind_speed = f
!                         pass_through_ice = t
!                         atm/
!                             name/
!                                  depostion
!                             long_name/
!                                       'Atmospheric deposition'
!                             units/
!                                   'kg/m^2/s'
!                         ice/
!                             name/
!                             long_name/
!                             units/
!                         flux/
!                              name/
!                                   flux
!                              long_name/
!                                        'Surface deposition'
!                              units/
!                                    'mol/m^2/s'
!                    land_sea_runoff/
!                         implementation/
!                                        river/
!                                              num_parameters = 1
!                         num_flags = 0
!                         use_atm_pressure = f
!                         use_10m_wind_speed = f
!                         pass_through_ice = t
!                         atm/                  ! really land (perhaps should change this?)
!                             name/
!                                  runoff
!                             long_name/
!                                       'Concentration in land runoff'
!                             units/
!                                   'kg/m^3'
!                         ice/
!                             name/
!                             long_name/
!                             units/
!                         flux/
!                              name/
!                                   flux
!                              long_name/
!                                        'Concentration in land runoff'
!                              units/
!                                    'mol/m^3'
!

use field_manager_mod, only: fm_field_name_len, fm_string_len, fm_dump_list

implicit none
!
!-----------------------------------------------------------------------
  character(len=128) :: version = '$Id$'
  character(len=128) :: tag = '$Name$'
!-----------------------------------------------------------------------
real, parameter :: bound_tol = 1e-7

private

!
!----------------------------------------------------------------------
!
!       Public routines
!
!----------------------------------------------------------------------
!

public  coupler_types_init
public  coupler_type_copy
public  coupler_type_copy_1d_2d
public  coupler_type_copy_1d_3d

!
!----------------------------------------------------------------------
!
!       Private routines
!
!----------------------------------------------------------------------
!

!
!----------------------------------------------------------------------
!
!       Public parameters
!
!----------------------------------------------------------------------
!

!
!----------------------------------------------------------------------
!
!       Private parameters
!
!----------------------------------------------------------------------
!

character(len=48), parameter                    :: mod_name = 'coupler_types_mod'

!
!----------------------------------------------------------------------
!
!       Public types
!
!----------------------------------------------------------------------
!

!
!       3-d fields
!

type, public    :: coupler_3d_values_type
  character(len=fm_field_name_len)                      :: name = ' '
  real, pointer, dimension(:,:,:)                       :: values => NULL()
  logical                                               :: mean = .true.
  logical                                               :: override = .false.
  integer                                               :: id_diag = 0
  character(len=fm_string_len)                          :: long_name = ' '
  character(len=fm_string_len)                          :: units = ' '
end type coupler_3d_values_type

type, public    :: coupler_3d_field_type  !{
  character(len=fm_field_name_len)                      :: name = ' '
  integer                                               :: num_fields = 0
  type(coupler_3d_values_type), pointer, dimension(:)   :: field => NULL()
  character(len=fm_string_len)                          :: flux_type = ' '
  character(len=fm_string_len)                          :: implementation = ' '
  real, pointer, dimension(:)                           :: param => NULL()
  logical, pointer, dimension(:)                        :: flag => NULL()
  integer                                               :: atm_tr_index = 0
  character(len=fm_string_len)                          :: ice_restart_file = ' '
  character(len=fm_string_len)                          :: ocean_restart_file = ' '
  logical                                               :: use_atm_pressure
  logical                                               :: use_10m_wind_speed
  logical                                               :: pass_through_ice
  real                                                  :: mol_wt = 0.0
end type coupler_3d_field_type

type, public    :: coupler_3d_bc_type  !{
  integer                                               :: num_bcs = 0
  type(coupler_3d_field_type), pointer, dimension(:)    :: bc => NULL()
end type coupler_3d_bc_type

!
!       2-d fields
!

type, public    :: coupler_2d_values_type
  character(len=fm_field_name_len)                      :: name = ' '
  real, pointer, dimension(:,:)                         :: values => NULL()
  logical                                               :: mean = .true.
  logical                                               :: override = .false.
  integer                                               :: id_diag = 0
  character(len=fm_string_len)                          :: long_name = ' '
  character(len=fm_string_len)                          :: units = ' '
end type coupler_2d_values_type

type, public    :: coupler_2d_field_type  !{
  character(len=fm_field_name_len)                      :: name = ' '
  integer                                               :: num_fields = 0
  type(coupler_2d_values_type), pointer, dimension(:)   :: field => NULL()
  character(len=fm_string_len)                          :: flux_type = ' '
  character(len=fm_string_len)                          :: implementation = ' '
  real, pointer, dimension(:)                           :: param => NULL()
  logical, pointer, dimension(:)                        :: flag => NULL()
  integer                                               :: atm_tr_index = 0
  character(len=fm_string_len)                          :: ice_restart_file = ' '
  character(len=fm_string_len)                          :: ocean_restart_file = ' '
  logical                                               :: use_atm_pressure
  logical                                               :: use_10m_wind_speed
  logical                                               :: pass_through_ice
  real                                                  :: mol_wt = 0.0
end type coupler_2d_field_type

type, public    :: coupler_2d_bc_type  !{
  integer                                               :: num_bcs = 0
  type(coupler_2d_field_type), pointer, dimension(:)    :: bc => NULL()
end type coupler_2d_bc_type

!
!       1-d fields
!

type, public    :: coupler_1d_values_type
  character(len=fm_field_name_len)                      :: name = ' '
  real, pointer, dimension(:)                           :: values => NULL()
  logical                                               :: mean = .true.
  logical                                               :: override = .false.
  integer                                               :: id_diag = 0
  character(len=fm_string_len)                          :: long_name = ' '
  character(len=fm_string_len)                          :: units = ' '
end type coupler_1d_values_type

type, public    :: coupler_1d_field_type  !{
  character(len=fm_field_name_len)                      :: name = ' '
  integer                                               :: num_fields = 0
  type(coupler_1d_values_type), pointer, dimension(:)   :: field => NULL()
  character(len=fm_string_len)                          :: flux_type = ' '
  character(len=fm_string_len)                          :: implementation = ' '
  real, pointer, dimension(:)                           :: param => NULL()
  logical, pointer, dimension(:)                        :: flag => NULL()
  integer                                               :: atm_tr_index = 0
  character(len=fm_string_len)                          :: ice_restart_file = ' '
  character(len=fm_string_len)                          :: ocean_restart_file = ' '
  logical                                               :: use_atm_pressure
  logical                                               :: use_10m_wind_speed
  logical                                               :: pass_through_ice
  real                                                  :: mol_wt = 0.0
end type coupler_1d_field_type

type, public    :: coupler_1d_bc_type  !{
  integer                                               :: num_bcs = 0
  type(coupler_1d_field_type), pointer, dimension(:)    :: bc => NULL()
end type coupler_1d_bc_type

!
!----------------------------------------------------------------------
!
!       Private types
!
!----------------------------------------------------------------------
!

!
!----------------------------------------------------------------------
!
!       Public variables
!
!----------------------------------------------------------------------
!

integer, public :: ind_u10
integer, public :: ind_psurf
integer, public :: ind_pcair
integer, public :: ind_csurf
integer, public :: ind_alpha
integer, public :: ind_sc_no
integer, public :: ind_flux
integer, public :: ind_deltap
integer, public :: ind_kw
integer, public :: ind_deposition
integer, public :: ind_runoff

!
!----------------------------------------------------------------------
!
!       Private variables
!
!----------------------------------------------------------------------
!

logical, save   :: module_is_initialized = .false.

!
!----------------------------------------------------------------------
!
!        Interface definitions for overloaded routines
!
!----------------------------------------------------------------------
!

interface  coupler_type_copy  !{
  module procedure  coupler_type_copy_1d_2d
  module procedure  coupler_type_copy_1d_3d
end interface  coupler_type_copy  !}

!
!-----------------------------------------------------------------------
!
!       Subroutine and function definitions
!
!-----------------------------------------------------------------------
!

contains


!#######################################################################
! <SUBROUTINE NAME="coupler_types_init">
!  <OVERVIEW>
!   Initialize the coupler types
!  </OVERVIEW>
!  <DESCRIPTION>
!   Initialize the coupler types
!  </DESCRIPTION>
!  <TEMPLATE>
!   call coupler_tpyes_init
!  </TEMPLATE>
!

subroutine coupler_types_init

!
!-----------------------------------------------------------------------
!     modules
!-----------------------------------------------------------------------
!

use mpp_mod,           only: stdout, mpp_error, FATAL
use fm_util_mod,       only: fm_util_set_value, fm_util_set_no_overwrite
use fm_util_mod,       only: fm_util_set_caller, fm_util_reset_no_overwrite
use fm_util_mod,       only: fm_util_reset_caller
use field_manager_mod, only: fm_new_list, fm_change_list

implicit none

!
!-----------------------------------------------------------------------
!     arguments
!-----------------------------------------------------------------------
!

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

character(len=64), parameter    :: sub_name = 'coupler_types_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!-----------------------------------------------------------------------
!     local variables
!-----------------------------------------------------------------------
!

integer                 :: field_index, outunit
character(len=128)      :: error_msg

!
! =====================================================================
!     begin executable code
! =====================================================================
!

!
!       Return if already intialized
!

if (module_is_initialized) then  !{
  return
endif  !}

!
!       Set other defaults for the fm_util_set_value routines
!

call fm_util_set_no_overwrite(.true.)
call fm_util_set_caller(sub_name)

!
!       Be sure that the various lists and fields are defined in the field manager tree
!

if (fm_new_list('/coupler_mod') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "coupler_mod" list')
endif  !}

if (fm_new_list('/coupler_mod/GOOD') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "GOOD" list')
endif  !}
call fm_util_set_value('/coupler_mod/GOOD/good_coupler_mod_list', 'GOOD', append = .true.)

if (fm_new_list('/coupler_mod/fluxes') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "/coupler_mod/fluxes" list')
endif  !}
call fm_util_set_value('/coupler_mod/GOOD/good_coupler_mod_list', 'fluxes', append = .true.)

if (fm_new_list('/coupler_mod/types') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "/coupler_mod/types" list')
endif  !}
call fm_util_set_value('/coupler_mod/GOOD/good_coupler_mod_list', 'types', append = .true.)

!
!       change to the "/coupler_mod/types" list
!

if (.not. fm_change_list('/coupler_mod/types')) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not change to "/coupler_mod/types"')
endif  !}

!
!       Define the air_sea_gas_flux_generic type
!

!       add the new type

if (fm_new_list('air_sea_gas_flux_generic') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_gas_flux_generic" list')
endif  !}

!       add the implementation list

if (fm_new_list('air_sea_gas_flux_generic/implementation') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_gas_flux_generic/implementation" list')
endif  !}

!       add the names of the different implementations

if (fm_new_list('air_sea_gas_flux_generic/implementation/ocmip2') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_gas_flux_generic/implementation/ocmip2" list')
endif  !}
call fm_util_set_value('air_sea_gas_flux_generic/implementation/ocmip2/num_parameters', 2)

!       add some scalar quantaties

call fm_util_set_value('air_sea_gas_flux_generic/num_flags', 0)
call fm_util_set_value('air_sea_gas_flux_generic/use_atm_pressure', .true.)
call fm_util_set_value('air_sea_gas_flux_generic/use_10m_wind_speed', .true.)
call fm_util_set_value('air_sea_gas_flux_generic/pass_through_ice', .false.)

!       add required fields that will come from the atmosphere model

if (fm_new_list('air_sea_gas_flux_generic/atm') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_gas_flux_generic/atm" list')
endif  !}

field_index = 0

field_index = field_index + 1
ind_pcair = field_index
call fm_util_set_value('air_sea_gas_flux_generic/atm/name',      'pcair',                     index = ind_pcair)
call fm_util_set_value('air_sea_gas_flux_generic/atm/long_name', 'Atmospheric concentration', index = ind_pcair)
call fm_util_set_value('air_sea_gas_flux_generic/atm/units',     'mol/mol',                   index = ind_pcair)

field_index = field_index + 1
ind_u10 = field_index
call fm_util_set_value('air_sea_gas_flux_generic/atm/name',      'u10',                index = ind_u10)
call fm_util_set_value('air_sea_gas_flux_generic/atm/long_name', 'Wind speed at 10 m', index = ind_u10)
call fm_util_set_value('air_sea_gas_flux_generic/atm/units',     'm/s',                index = ind_u10)

field_index = field_index + 1
ind_psurf = field_index
call fm_util_set_value('air_sea_gas_flux_generic/atm/name',      'psurf',                        index = ind_psurf)
call fm_util_set_value('air_sea_gas_flux_generic/atm/long_name', 'Surface atmospheric pressure', index = ind_psurf)
call fm_util_set_value('air_sea_gas_flux_generic/atm/units',     'Pa',                           index = ind_psurf)

!       add required fields that will come from the ice model

if (fm_new_list('air_sea_gas_flux_generic/ice') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_gas_flux_generic/ice" list')
endif  !}

field_index = 0

field_index = field_index + 1
ind_alpha = field_index
call fm_util_set_value('air_sea_gas_flux_generic/ice/name',      'alpha',                                                index = ind_alpha)
call fm_util_set_value('air_sea_gas_flux_generic/ice/long_name', 'Solubility w.r.t. atmosphere', index = ind_alpha)
call fm_util_set_value('air_sea_gas_flux_generic/ice/units',     'mol/m^3/atm',                                          index = ind_alpha)

field_index = field_index + 1
ind_csurf = field_index
call fm_util_set_value('air_sea_gas_flux_generic/ice/name',      'csurf',                                         index = ind_csurf)
call fm_util_set_value('air_sea_gas_flux_generic/ice/long_name', 'Ocean concentration', index = ind_csurf)
call fm_util_set_value('air_sea_gas_flux_generic/ice/units',     'mol/m^3',                                       index = ind_csurf)

field_index = field_index + 1
ind_sc_no = field_index
call fm_util_set_value('air_sea_gas_flux_generic/ice/name',      'sc_no',                                         index = ind_sc_no)
call fm_util_set_value('air_sea_gas_flux_generic/ice/long_name', 'Schmidt number', index = ind_sc_no)
call fm_util_set_value('air_sea_gas_flux_generic/ice/units',     'dimensionless',                                       index = ind_sc_no)

!       add the flux output field(s)

if (fm_new_list('air_sea_gas_flux_generic/flux') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_gas_flux_generic/flux" list')
endif  !}

field_index = 0

field_index = field_index + 1
ind_flux = field_index
call fm_util_set_value('air_sea_gas_flux_generic/flux/name',      'flux',         index = ind_flux)
call fm_util_set_value('air_sea_gas_flux_generic/flux/long_name', 'Surface flux', index = ind_flux)
call fm_util_set_value('air_sea_gas_flux_generic/flux/units',     'mol/m^2/s',    index = ind_flux)

field_index = field_index + 1
ind_deltap = field_index
call fm_util_set_value('air_sea_gas_flux_generic/flux/name',      'deltap',         index = ind_deltap)
call fm_util_set_value('air_sea_gas_flux_generic/flux/long_name', 'Ocean-air delta pressure', index = ind_deltap)
call fm_util_set_value('air_sea_gas_flux_generic/flux/units',     'uatm',    index = ind_deltap)

field_index = field_index + 1
ind_kw = field_index
call fm_util_set_value('air_sea_gas_flux_generic/flux/name',      'kw',         index = ind_kw)
call fm_util_set_value('air_sea_gas_flux_generic/flux/long_name', 'Piston velocity', index = ind_kw)
call fm_util_set_value('air_sea_gas_flux_generic/flux/units',     'm/s',    index = ind_kw)

!
!       Define the air_sea_gas_flux type
!

!       add the new type

if (fm_new_list('air_sea_gas_flux') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_gas_flux" list')
endif  !}

!       add the implementation list

if (fm_new_list('air_sea_gas_flux/implementation') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_gas_flux/implementation" list')
endif  !}

!       add the names of the different implementations

if (fm_new_list('air_sea_gas_flux/implementation/ocmip2') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_gas_flux/implementation/ocmip2" list')
endif  !}
call fm_util_set_value('air_sea_gas_flux/implementation/ocmip2/num_parameters', 2)
if (fm_new_list('air_sea_gas_flux/implementation/ocmip2_data') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_gas_flux/implementation/ocmip2_data" list')
endif  !}
call fm_util_set_value('air_sea_gas_flux/implementation/ocmip2_data/num_parameters', 2)
if (fm_new_list('air_sea_gas_flux/implementation/linear') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_gas_flux/implementation/linear" list')
endif  !}
call fm_util_set_value('air_sea_gas_flux/implementation/linear/num_parameters', 3)

!       add some scalar quantaties

call fm_util_set_value('air_sea_gas_flux/num_flags', 0)
call fm_util_set_value('air_sea_gas_flux/use_atm_pressure', .true.)
call fm_util_set_value('air_sea_gas_flux/use_10m_wind_speed', .true.)
call fm_util_set_value('air_sea_gas_flux/pass_through_ice', .false.)

!       add required fields that will come from the atmosphere model

if (fm_new_list('air_sea_gas_flux/atm') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_gas_flux/atm" list')
endif  !}

field_index = 0

field_index = field_index + 1
ind_pcair = field_index
call fm_util_set_value('air_sea_gas_flux/atm/name',      'pcair',                     index = ind_pcair)
call fm_util_set_value('air_sea_gas_flux/atm/long_name', 'Atmospheric concentration', index = ind_pcair)
call fm_util_set_value('air_sea_gas_flux/atm/units',     'mol/mol',                   index = ind_pcair)

field_index = field_index + 1
ind_u10 = field_index
call fm_util_set_value('air_sea_gas_flux/atm/name',      'u10',                index = ind_u10)
call fm_util_set_value('air_sea_gas_flux/atm/long_name', 'Wind speed at 10 m', index = ind_u10)
call fm_util_set_value('air_sea_gas_flux/atm/units',     'm/s',                index = ind_u10)

field_index = field_index + 1
ind_psurf = field_index
call fm_util_set_value('air_sea_gas_flux/atm/name',      'psurf',                        index = ind_psurf)
call fm_util_set_value('air_sea_gas_flux/atm/long_name', 'Surface atmospheric pressure', index = ind_psurf)
call fm_util_set_value('air_sea_gas_flux/atm/units',     'Pa',                           index = ind_psurf)

!       add required fields that will come from the ice model

if (fm_new_list('air_sea_gas_flux/ice') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_gas_flux/ice" list')
endif  !}

field_index = 0

field_index = field_index + 1
ind_alpha = field_index
call fm_util_set_value('air_sea_gas_flux/ice/name',      'alpha',                                                index = ind_alpha)
call fm_util_set_value('air_sea_gas_flux/ice/long_name', 'Solubility from atmosphere times Schmidt number term', index = ind_alpha)
call fm_util_set_value('air_sea_gas_flux/ice/units',     'mol/m^3/atm',                                          index = ind_alpha)

field_index = field_index + 1
ind_csurf = field_index
call fm_util_set_value('air_sea_gas_flux/ice/name',      'csurf',                                         index = ind_csurf)
call fm_util_set_value('air_sea_gas_flux/ice/long_name', 'Ocean concentration times Schmidt number term', index = ind_csurf)
call fm_util_set_value('air_sea_gas_flux/ice/units',     'mol/m^3',                                       index = ind_csurf)

!       add the flux output field(s)

if (fm_new_list('air_sea_gas_flux/flux') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_gas_flux/flux" list')
endif  !}

field_index = 0

field_index = field_index + 1
ind_flux = field_index
call fm_util_set_value('air_sea_gas_flux/flux/name',      'flux',         index = ind_flux)
call fm_util_set_value('air_sea_gas_flux/flux/long_name', 'Surface flux', index = ind_flux)
call fm_util_set_value('air_sea_gas_flux/flux/units',     'mol/m^2/s',    index = ind_flux)

!
!       Define the air_sea_deposition type
!

!       add the new type

if (fm_new_list('air_sea_deposition') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_deposition" list')
endif  !}

!       add the implementation list

if (fm_new_list('air_sea_deposition/implementation') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_deposition/implementation" list')
endif  !}

!       add the names of the different implementations

if (fm_new_list('air_sea_deposition/implementation/dry') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_deposition/implementation/dry" list')
endif  !}
call fm_util_set_value('air_sea_deposition/implementation/dry/num_parameters', 1)
if (fm_new_list('air_sea_deposition/implementation/wet') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_deposition/implementation/wet" list')
endif  !}
call fm_util_set_value('air_sea_deposition/implementation/wet/num_parameters', 1)

!       add some scalar quantaties

call fm_util_set_value('air_sea_deposition/num_flags', 0)
call fm_util_set_value('air_sea_deposition/use_atm_pressure', .false.)
call fm_util_set_value('air_sea_deposition/use_10m_wind_speed', .false.)
call fm_util_set_value('air_sea_deposition/pass_through_ice', .true.)

!       add required fields that will come from the atmosphere model

if (fm_new_list('air_sea_deposition/atm') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_deposition/atm" list')
endif  !}

field_index = 0

field_index = field_index + 1
ind_deposition = field_index
call fm_util_set_value('air_sea_deposition/atm/name',      'deposition',             index = ind_deposition)
call fm_util_set_value('air_sea_deposition/atm/long_name', 'Atmospheric deposition', index = ind_deposition)
call fm_util_set_value('air_sea_deposition/atm/units',     'kg/m^2/s',               index = ind_deposition)

!       add required fields that will come from the ice model

if (fm_new_list('air_sea_deposition/ice') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_deposition/ice" list')
endif  !}

field_index = 0

call fm_util_set_value('air_sea_deposition/ice/name',      ' ', index = 0)
call fm_util_set_value('air_sea_deposition/ice/long_name', ' ', index = 0)
call fm_util_set_value('air_sea_deposition/ice/units',     ' ', index = 0)

!       add the flux output field(s)

if (fm_new_list('air_sea_deposition/flux') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "air_sea_deposition/flux" list')
endif  !}

field_index = 0

field_index = field_index + 1
ind_flux = field_index
call fm_util_set_value('air_sea_deposition/flux/name',      'flux',               index = ind_flux)
call fm_util_set_value('air_sea_deposition/flux/long_name', 'Surface deposition', index = ind_flux)
call fm_util_set_value('air_sea_deposition/flux/units',     'mol/m^2/s',          index = ind_flux)

!
!       Define the land_sea_runoff type
!

!       add the new type

if (fm_new_list('land_sea_runoff') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "land_sea_runoff" list')
endif  !}

!       add the implementation list

if (fm_new_list('land_sea_runoff/implementation') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "land_sea_runoff/implementation" list')
endif  !}

!       add the names of the different implementations

if (fm_new_list('land_sea_runoff/implementation/river') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "land_sea_runoff/implementation/river" list')
endif  !}
call fm_util_set_value('land_sea_runoff/implementation/river/num_parameters', 1)

!       add some scalar quantaties

call fm_util_set_value('land_sea_runoff/num_flags', 0)
call fm_util_set_value('land_sea_runoff/use_atm_pressure', .false.)
call fm_util_set_value('land_sea_runoff/use_10m_wind_speed', .false.)
call fm_util_set_value('land_sea_runoff/pass_through_ice', .true.)

!       add required fields that will come from the land model (the array name is still called "atm")

if (fm_new_list('land_sea_runoff/atm') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "land_sea_runoff/atm" list')
endif  !}

field_index = 0

field_index = field_index + 1
ind_runoff = field_index
call fm_util_set_value('land_sea_runoff/atm/name',      'runoff',                       index = ind_runoff)
call fm_util_set_value('land_sea_runoff/atm/long_name', 'Concentration in land runoff', index = ind_runoff)
call fm_util_set_value('land_sea_runoff/atm/units',     'mol/m^3',                      index = ind_runoff)

!       add required fields that will come from the ice model

if (fm_new_list('land_sea_runoff/ice') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "land_sea_runoff/ice" list')
endif  !}

field_index = 0

call fm_util_set_value('land_sea_runoff/ice/name',      ' ', index = 0)
call fm_util_set_value('land_sea_runoff/ice/long_name', ' ', index = 0)
call fm_util_set_value('land_sea_runoff/ice/units',     ' ', index = 0)

!       add the flux output field(s)

if (fm_new_list('land_sea_runoff/flux') .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "land_sea_runoff/flux" list')
endif  !}

field_index = 0

field_index = field_index + 1
ind_flux = field_index
call fm_util_set_value('land_sea_runoff/flux/name',      'flux',                         index = ind_flux)
call fm_util_set_value('land_sea_runoff/flux/long_name', 'Concentration in land runoff', index = ind_flux)
call fm_util_set_value('land_sea_runoff/flux/units',     'mol/m^3',                      index = ind_flux)

!
!       change back to root list
!

if (.not. fm_change_list('/')) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not change to "/"')
endif  !}

!
!       Reset the defaults for the fm_util_set_value calls
!

call fm_util_reset_no_overwrite
call fm_util_reset_caller

module_is_initialized = .true.

!
!       Dump the coupler_mod types list
!
outunit = stdout()
write (outunit,*)
write (outunit,*) 'Dumping coupler_mod/types tree'
if (.not. fm_dump_list('/coupler_mod/types', recursive = .true.)) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Problem dumping /coupler_mod/types tree')
endif  !}

return

end subroutine  coupler_types_init  !}
! </SUBROUTINE> NAME="coupler_types_init"



!#######################################################################
! <SUBROUTINE NAME="coupler_type_copy_1d_2d">
!  <OVERVIEW>
!   Copy fields from one coupler type to another.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Copy fields from one coupler type to another.
!   Specific version for generic coupler_type_copy.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call coupler_type_copy(var_in, var_out, is, ie, js, je,     &
!        diag_name, axes, time, suffix = 'something')
!		
!  </TEMPLATE>
!  <IN NAME="var_in" TYPE="coupler_1d_bc_type">
!   variable to copy information from
!  </IN>
!  <IN NAME="var_out" TYPE="coupler_2d_bc_type">
!   variable to copy information to
!  </IN>
!  <IN NAME="is" TYPE="integer">
!   lower bound of first dimension
!  </IN>
!  <IN NAME="ie" TYPE="integer">
!   upper bound of first dimension
!  </IN>
!  <IN NAME="js" TYPE="integer">
!   lower bound of second dimension
!  </IN>
!  <IN NAME="je" TYPE="integer">
!   upper bound of second dimension
!  </IN>
!  <IN NAME="diag_name" TYPE="character">
!   name for diagnostic file--if blank, then don't register the fields
!  </IN>
!  <IN NAME="axes" TYPE="integer">
!   array of axes identifiers for diagnostic variable registration
!  </IN>
!  <IN NAME="time" TYPE="time_type">
!   model time variable for registering diagnostic field
!  </IN>
!  <IN NAME="suffix" TYPE="character">
!   optional suffix to make the name identifier unique
!  </IN>
!

subroutine coupler_type_copy_1d_2d(var_in, var_out, is, ie, js, je,     &
     diag_name, axes, time, suffix)  !{

!
!-----------------------------------------------------------------------
!     modules
!-----------------------------------------------------------------------
!

use time_manager_mod, only: time_type
use diag_manager_mod, only: register_diag_field
use mpp_mod,          only: mpp_error, FATAL

implicit none

!
!-----------------------------------------------------------------------
!     arguments
!-----------------------------------------------------------------------
!

type(coupler_1d_bc_type), intent(in)    :: var_in
type(coupler_2d_bc_type), intent(inout) :: var_out
integer, intent(in)                     :: is
integer, intent(in)                     :: ie
integer, intent(in)                     :: js
integer, intent(in)                     :: je
character(len=*), intent(in)            :: diag_name
integer, dimension(:), intent(in)       :: axes
type(time_type), intent(in)             :: time
character(len=*), intent(in), optional  :: suffix
 
!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

character(len=64), parameter    :: sub_name = 'coupler_type_copy_1d_2d'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!-----------------------------------------------------------------------
!     local variables
!-----------------------------------------------------------------------
!

character(len=128)      :: error_msg
integer                 :: m
integer                 :: n

!
! =====================================================================
!     begin executable code
! =====================================================================
!

!
!       Error if output fields is not zero
!

if (var_out%num_bcs .ne. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Number of output fields is non-zero')
endif  !}
  
var_out%num_bcs = var_in%num_bcs

!
!       Return if no input fields
!

if (var_in%num_bcs .ne. 0) then  !{
  if (associated(var_out%bc)) then  !{
    call mpp_error(FATAL, trim(error_header) // ' var_out%bc already associated')
  endif  !}
  allocate ( var_out%bc(var_out%num_bcs) )
  do n = 1, var_out%num_bcs  !{
    var_out%bc(n)%name = var_in%bc(n)%name
    var_out%bc(n)%atm_tr_index = var_in%bc(n)%atm_tr_index
    var_out%bc(n)%ice_restart_file = var_in%bc(n)%ice_restart_file
    var_out%bc(n)%ocean_restart_file = var_in%bc(n)%ocean_restart_file
    var_out%bc(n)%use_atm_pressure = var_in%bc(n)%use_atm_pressure
    var_out%bc(n)%use_10m_wind_speed = var_in%bc(n)%use_10m_wind_speed
    var_out%bc(n)%pass_through_ice = var_in%bc(n)%pass_through_ice
    var_out%bc(n)%mol_wt = var_in%bc(n)%mol_wt
    var_out%bc(n)%num_fields = var_in%bc(n)%num_fields
    if (associated(var_out%bc(n)%field)) then  !{
      write (error_msg, *) trim(error_header), ' var_out%bc(', n, ')%field already associated'
      call mpp_error(FATAL, trim(error_msg))
    endif  !}
    allocate ( var_out%bc(n)%field(var_out%bc(n)%num_fields) )
    do m = 1, var_out%bc(n)%num_fields  !{
      if (present(suffix)) then  !{
        var_out%bc(n)%field(m)%name = trim(var_in%bc(n)%field(m)%name) // trim(suffix)
      else  !}{
        var_out%bc(n)%field(m)%name = var_in%bc(n)%field(m)%name
      endif  !}
      var_out%bc(n)%field(m)%long_name = var_in%bc(n)%field(m)%long_name
      var_out%bc(n)%field(m)%units = var_in%bc(n)%field(m)%units
      var_out%bc(n)%field(m)%mean = var_in%bc(n)%field(m)%mean
      if (associated(var_out%bc(n)%field(m)%values)) then  !{
        write (error_msg, *) trim(error_header), ' var_out%bc(', n, ')%field(', m, ')%values already associated'
        call mpp_error(FATAL, trim(error_msg))
      endif  !}
      allocate ( var_out%bc(n)%field(m)%values(is:ie,js:je) )
      var_out%bc(n)%field(m)%values = 0.0
      if (diag_name .ne. ' ') then  !{
        if (size(axes) .lt. 2) then  !{
          call mpp_error(FATAL, trim(error_header) // ' axes less than 2 elements')
        endif  !}
        var_out%bc(n)%field(m)%id_diag = register_diag_field(diag_name,                &
             var_out%bc(n)%field(m)%name, axes(1:2), Time,                             &
             var_out%bc(n)%field(m)%long_name, var_out%bc(n)%field(m)%units )
      endif  !}
    enddo  !} m
  enddo  !} n

endif  !}

return

end subroutine  coupler_type_copy_1d_2d  !}
! </SUBROUTINE> NAME="coupler_type_copy_1d_2d


!#######################################################################
! <SUBROUTINE NAME="coupler_type_copy_1d_3d">
!  <OVERVIEW>
!   Copy fields from one coupler type to another.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Copy fields from one coupler type to another.
!   Specific version for generic coupler_type_copy.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call coupler_type_copy(var_in, var_out, is, ie, js, je, kd, &
!        diag_name, axes, time, suffix = 'something')
!		
!  </TEMPLATE>
!  <IN NAME="var_in" TYPE="coupler_1d_bc_type">
!   variable to copy information from
!  </IN>
!  <IN NAME="var_out" TYPE="coupler_3d_bc_type">
!   variable to copy information to
!  </IN>
!  <IN NAME="is" TYPE="integer">
!   lower bound of first dimension
!  </IN>
!  <IN NAME="ie" TYPE="integer">
!   upper bound of first dimension
!  </IN>
!  <IN NAME="js" TYPE="integer">
!   lower bound of second dimension
!  </IN>
!  <IN NAME="je" TYPE="integer">
!   upper bound of second dimension
!  </IN>
!  <IN NAME="kd" TYPE="integer">
!   third dimension
!  </IN>
!  <IN NAME="diag_name" TYPE="character">
!   name for diagnostic file--if blank, then don't register the fields
!  </IN>
!  <IN NAME="axes" TYPE="integer">
!   array of axes identifiers for diagnostic variable registration
!  </IN>
!  <IN NAME="time" TYPE="time_type">
!   model time variable for registering diagnostic field
!  </IN>
!  <IN NAME="suffix" TYPE="character">
!   optional suffix to make the name identifier unique
!  </IN>
!

subroutine coupler_type_copy_1d_3d(var_in, var_out, is, ie, js, je, kd, &
     diag_name, axes, time, suffix)  !{

!
!-----------------------------------------------------------------------
!     modules
!-----------------------------------------------------------------------
!

use time_manager_mod, only: time_type
use diag_manager_mod, only: register_diag_field
use mpp_mod,          only: mpp_error, FATAL

implicit none

!
!-----------------------------------------------------------------------
!     arguments
!-----------------------------------------------------------------------
!

type(coupler_1d_bc_type), intent(in)    :: var_in
type(coupler_3d_bc_type), intent(inout) :: var_out
integer, intent(in)                     :: is
integer, intent(in)                     :: ie
integer, intent(in)                     :: js
integer, intent(in)                     :: je
integer, intent(in)                     :: kd
character(len=*), intent(in)            :: diag_name
integer, dimension(:), intent(in)       :: axes
type(time_type), intent(in)             :: time
character(len=*), intent(in), optional  :: suffix
 
!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

character(len=64), parameter    :: sub_name = 'coupler_type_copy_1d_3d'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!-----------------------------------------------------------------------
!     local variables
!-----------------------------------------------------------------------
!

character(len=128)      :: error_msg
integer                 :: m
integer                 :: n

!
! =====================================================================
!     begin executable code
! =====================================================================
!

!
!       Error if output fields is not zero
!

if (var_out%num_bcs .ne. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Number of output fields is non-zero')
endif  !}
  
var_out%num_bcs = var_in%num_bcs

!
!       Return if no input fields
!

if (var_in%num_bcs .ne. 0) then  !{
  if (associated(var_out%bc)) then  !{
    call mpp_error(FATAL, trim(error_header) // ' var_out%bc already associated')
  endif  !}
  allocate ( var_out%bc(var_out%num_bcs) )
  do n = 1, var_out%num_bcs  !{
    var_out%bc(n)%name = var_in%bc(n)%name
    var_out%bc(n)%atm_tr_index = var_in%bc(n)%atm_tr_index
    var_out%bc(n)%ice_restart_file = var_in%bc(n)%ice_restart_file
    var_out%bc(n)%ocean_restart_file = var_in%bc(n)%ocean_restart_file
    var_out%bc(n)%use_atm_pressure = var_in%bc(n)%use_atm_pressure
    var_out%bc(n)%use_10m_wind_speed = var_in%bc(n)%use_10m_wind_speed
    var_out%bc(n)%pass_through_ice = var_in%bc(n)%pass_through_ice
    var_out%bc(n)%mol_wt = var_in%bc(n)%mol_wt
    var_out%bc(n)%num_fields = var_in%bc(n)%num_fields
    if (associated(var_out%bc(n)%field)) then  !{
      write (error_msg, *) trim(error_header), ' var_out%bc(', n, ')%field already associated'
      call mpp_error(FATAL, trim(error_msg))
    endif  !}
    allocate ( var_out%bc(n)%field(var_out%bc(n)%num_fields) )
    do m = 1, var_out%bc(n)%num_fields  !{
      if (present(suffix)) then  !{
        var_out%bc(n)%field(m)%name = trim(var_in%bc(n)%field(m)%name) // suffix
      else  !}{
        var_out%bc(n)%field(m)%name = var_in%bc(n)%field(m)%name
      endif  !}
      var_out%bc(n)%field(m)%long_name = var_in%bc(n)%field(m)%long_name
      var_out%bc(n)%field(m)%units = var_in%bc(n)%field(m)%units
      var_out%bc(n)%field(m)%mean = var_in%bc(n)%field(m)%mean
      if (associated(var_out%bc(n)%field(m)%values)) then  !{
        write (error_msg, *) trim(error_header), ' var_out%bc(', n, ')%field(', m, ')%values already associated'
        call mpp_error(FATAL, trim(error_msg))
      endif  !}
      allocate ( var_out%bc(n)%field(m)%values(is:ie,js:je,kd) )
      var_out%bc(n)%field(m)%values = 0.0
      if (diag_name .ne. ' ') then  !{
        if (size(axes) .lt. 3) then  !{
          call mpp_error(FATAL, trim(error_header) // ' axes less than 3 elements')
        endif  !}
        var_out%bc(n)%field(m)%id_diag = register_diag_field(diag_name,                &
             var_out%bc(n)%field(m)%name, axes(1:3), Time,                             &
             var_out%bc(n)%field(m)%long_name, var_out%bc(n)%field(m)%units )
      endif  !}
    enddo  !} m
  enddo  !} n

endif  !}

return

end subroutine  coupler_type_copy_1d_3d  !}
! </SUBROUTINE> NAME="coupler_type_copy_1d_3d

end module coupler_types_mod  !}

module atmos_nudge_mod

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only: check_nml_error, close_file, &
                   stdlog, mpp_pe, mpp_root_pe, write_version_number, &
                   error_mesg, FATAL, WARNING
use time_manager_mod, only: time_type, set_time, get_date, &
                            operator( + ), operator( < )
use data_override_mod,only: data_override
use diag_manager_mod, only: register_diag_field, send_data
use mpp_mod, only: mpp_min,mpp_max

implicit none
private

public :: atmos_nudge_init, get_atmos_nudge, atmos_nudge_end, do_ps

character(len=128), parameter :: version = '$Id: atmos_nudge.F90,v 19.0 2012/01/06 20:28:34 fms Exp $'
character(len=128), parameter :: tagname = '$Name: tikal $'

logical :: module_is_initialized = .false.

integer :: freq = 0   ! frequency in seconds
real ::  u_tau = -1.  ! relaxation time in seconds (no insertion if < 0)
real ::  v_tau = -1.
real ::  t_tau = -1.
real ::  q_tau = -1.
real :: ps_tau = -1.
integer :: skip_top_v = 2            ! momentum
integer :: skip_bot_v = 0
integer :: skip_top_t = 0            ! temperature
integer :: skip_bot_t = 21
integer :: skip_top_q = 8            ! specific humidity
integer :: skip_bot_q = 0

namelist /atmos_nudge_nml/ freq, u_tau, v_tau, t_tau, q_tau, ps_tau, &
                           skip_top_v, skip_bot_v,               &
                           skip_top_t, skip_bot_t,               &
                           skip_top_q, skip_bot_q

type(time_type) :: Time_next
integer :: id_udt, id_vdt, id_tdt, id_qdt, id_psdt
logical :: do_u, do_v, do_t, do_q, do_ps

contains

!-----------------------------------------------------------------------

subroutine get_atmos_nudge(Time, dt, beglon, endlon, beglat, endlat, nlev,  &
                           ng, ps, u, v, t, q, psdt, udt, vdt, tdt, qdt )
type (time_type),       intent(in)    :: Time
real,                   intent(in)    :: dt

integer, intent(in):: beglon, endlon, beglat, endlat, nlev, ng

real, intent(inout):: ps(beglon:endlon, beglat:endlat)
real, intent(inout):: psdt(beglon:endlon, beglat:endlat)

real, intent(inout):: u(beglon:endlon, beglat:endlat, nlev)
real, intent(inout):: v(beglon:endlon, beglat:endlat, nlev)
real, intent(inout):: t(beglon:endlon, beglat-ng:endlat+ng, nlev)
real, intent(inout):: q(beglon:endlon, beglat-ng:endlat+ng, nlev)

real, intent(inout):: udt(beglon:endlon, beglat:endlat, nlev)
real, intent(inout):: vdt(beglon:endlon, beglat:endlat, nlev)
real, intent(inout):: tdt(beglon:endlon, beglat:endlat, nlev)
real, intent(inout):: qdt(beglon:endlon, beglat:endlat, nlev)

real ::  obs(beglon:endlon, beglat:endlat, nlev)
real :: tend(beglon:endlon, beglat:endlat, nlev)
real ::  obs2(beglon:endlon, beglat:endlat)
real :: tend2(beglon:endlon, beglat:endlat)
real :: factor(nlev,3)
logical :: sent, done
integer :: i,j,k

   if (.not.module_is_initialized) then
       call error_mesg ('atmos_nudge_mod', 'module not initialized', FATAL)
   endif

 ! no data forcing override
   if (freq <= 0) then
       return
   endif

 ! is it time for data forcing
   if (Time < Time_next) then
       return
   endif
   Time_next = Time_next + set_time(freq)

! vertically dependent Tau
! very crude - zero at top/bottom + linear increase with level downward/upward

   factor = 1.

!------------------------------------------------------------------
! Momentum:
   if (skip_top_v > 0) then
      factor(1,1) = 0.
      do k = 2, skip_top_v
         factor(k,1) = factor(k-1,1) + 1./real(skip_top_v)
      enddo
   endif
   if (skip_bot_v > 0) then
      factor(nlev,1) = 0.
      do k = nlev-1, nlev-skip_bot_v+1, -1
         factor(k,1) = factor(k+1,1) + 1./real(skip_bot_v)
      enddo
   endif

! temperature
   if (skip_top_t > 0) then
      factor(1,2) = 0.
      do k = 2, skip_top_t
         factor(k,2) = factor(k-1,2) + 1./real(skip_top_t)
      enddo
   endif
   if (skip_bot_t > 0) then
         factor(nlev-skip_bot_t-1,2) = 0.5
         factor(nlev-skip_bot_t,  2) = 0.25
      do k=nlev-skip_bot_t+1,nlev
         factor(k,2) = 0.
      enddo
   endif
   
! Specific humidity
   if (skip_top_q > 0) then
      do k = 1, skip_top_q
         factor(k,3) = 0.
      enddo
         factor(skip_top_q+1,3) = 0.25
         factor(skip_top_q+2,3) = 0.5
   endif
   if (skip_bot_q > 0) then
      factor(nlev,3) = 0.
      do k = nlev-1, nlev-skip_bot_q+1, -1
         factor(k,3) = factor(k+1,3) + 1./real(skip_bot_q)
      enddo
   endif
!------------------------------------------------------------------

! zonal wind component
   if (do_u .or. id_udt>0) then
       call data_override ('ATM', 'u_obs', obs, Time, override=done)
       if (.not.done) call override_error (Time,'zonal wind')
   endif
   if (do_u) then
       do k=1,nlev
          do j=beglat,endlat
             do i=beglon,endlon
                tend(i,j,k) = (obs(i,j,k) - u(i,j,k)) / (u_tau + dt) * factor(k,1)
                   u(i,j,k) = u(i,j,k) + dt*tend(i,j,k)
                 udt(i,j,k) = udt(i,j,k) + tend(i,j,k)
             enddo
          enddo
       enddo
   else
       if (id_udt > 0) then
!          tend = 0.
       do k=1,nlev
          do j=beglat,endlat
             do i=beglon,endlon
! Report the error if not nudging
                tend(i,j,k) = u(i,j,k) - obs(i,j,k)
             enddo
          enddo
       enddo
       endif
   endif
   if (id_udt > 0) sent = send_data (id_udt, tend, Time) ! masking?

! meridional wind component
   if (do_v .or. id_vdt>0) then
       call data_override ('ATM', 'v_obs', obs, Time, override=done)
       if (.not.done) call override_error (Time,'meridional wind')
   endif
   if (do_v) then
       do k=1,nlev
          do j=beglat,endlat
             do i=beglon,endlon
                tend(i,j,k) = (obs(i,j,k) - v(i,j,k)) / (v_tau + dt) * factor(k,1)
                   v(i,j,k) = v(i,j,k) + dt*tend(i,j,k)
                 vdt(i,j,k) = vdt(i,j,k) + tend(i,j,k)
             enddo
          enddo
       enddo
   else
       if (id_vdt > 0) then
!          tend = 0.
       do k=1,nlev
          do j=beglat,endlat
             do i=beglon,endlon
                tend(i,j,k) = v(i,j,k) - obs(i,j,k)
             enddo
          enddo
       enddo
       endif
   endif
   if (id_vdt > 0) sent = send_data (id_vdt, tend, Time) ! masking?

! temperature
   if (do_t .or. id_tdt>0) then
       call data_override ('ATM', 't_obs', obs, Time, override=done)
       if (.not.done) call override_error (Time,'temperature')
   endif
   if (do_t) then
       do k=1,nlev
          do j=beglat,endlat
             do i=beglon,endlon
                tend(i,j,k) = (obs(i,j,k) - t(i,j,k)) / (t_tau + dt) * factor(k,2)
                   t(i,j,k) = t(i,j,k) + dt*tend(i,j,k)
                 tdt(i,j,k) = tdt(i,j,k) + tend(i,j,k)
             enddo
          enddo
       enddo
   else
       if (id_tdt > 0) then
!          tend = 0.
       do k=1,nlev
          do j=beglat,endlat
             do i=beglon,endlon
                tend(i,j,k) = t(i,j,k) - obs(i,j,k)
             enddo
          enddo
       enddo
       endif
   endif
   if (id_tdt > 0) sent = send_data (id_tdt, tend, Time) ! masking?

! specific humidity
   if (do_q .or. id_qdt>0) then
       call data_override ('ATM', 'q_obs', obs, Time, override=done)
       if (.not.done) call override_error (Time,'specific humidity')
   endif
   if (do_q) then
       do k=1,nlev
          do j=beglat,endlat
             do i=beglon,endlon
                tend(i,j,k) = (max(1.e-8,obs(i,j,k)) - q(i,j,k)) / (q_tau + dt) * factor(k,3)
                   q(i,j,k) = q(i,j,k) + dt*tend(i,j,k)
                 qdt(i,j,k) = qdt(i,j,k) + tend(i,j,k)
             enddo
          enddo
       enddo
   else
       if (id_qdt > 0) then
!          tend = 0.
       do k=1,nlev
          do j=beglat,endlat
             do i=beglon,endlon
                tend(i,j,k) = q(i,j,k) - obs(i,j,k)
             enddo
          enddo
       enddo
       endif
   endif
   if (id_qdt > 0) sent = send_data (id_qdt, tend, Time) ! masking?

! surface pressure
   if (do_ps .or. id_psdt>0) then
       call data_override ('ATM', 'ps_obs', obs2, Time, override=done)
       if (.not.done) call override_error (Time,'surface pressure')
   endif
   if (do_ps) then
       do j=beglat,endlat
          do i=beglon,endlon
             tend2(i,j) = (obs2(i,j) - ps(i,j)) / (ps_tau + dt)
                ps(i,j) = ps(i,j) + dt*tend2(i,j)
              psdt(i,j) = psdt(i,j) + tend2(i,j)
          enddo
       enddo
   else
       if (id_psdt > 0) then
!          tend2 = 0.
          do j=beglat,endlat
             do i=beglon,endlon
                tend2(i,j) = ps(i,j) - obs2(i,j)
             enddo
          enddo
       endif
   endif
   if (id_psdt > 0) sent = send_data (id_psdt, tend2, Time) ! masking?
!if (mpp_pe()==mpp_root_pe()) print *, 'Leaving atmos_nudge'

end subroutine get_atmos_nudge

!-----------------------------------------------------------------------

subroutine atmos_nudge_init ( Time, axes, flag )
type (time_type),      intent(in)  :: Time
integer, dimension(3), intent(in)  :: axes
logical, optional,     intent(out) :: flag
integer :: ierr, io, unit, logunit
real :: eps
character(len=64) :: desc
real :: missing_value = -1.e10

 ! read namelist
#ifdef INTERNAL_FILE_NML
   read (input_nml_file, nml=atmos_nudge_nml, iostat=io)
   ierr = check_nml_error(io, 'atmos_nudge_nml')
#else
   unit = open_namelist_file()
   ierr=1  
   do while (ierr /= 0)
     read (unit, nml=atmos_nudge_nml, iostat=io, end=10) 
     ierr = check_nml_error (io, 'atmos_nudge_nml')
   enddo   
10 call close_file (unit)
#endif
   call write_version_number(version, tagname)
   logunit=stdlog()
   if (mpp_pe() == mpp_root_pe()) write (logunit, nml=atmos_nudge_nml)

 ! initialize flags
   eps = 1.e-10
   do_u  = .false.; if ( u_tau > -eps) do_u  = .true.
   do_v  = .false.; if ( v_tau > -eps) do_v  = .true.
   do_t  = .false.; if ( t_tau > -eps) do_t  = .true.
   do_q  = .false.; if ( q_tau > -eps) do_q  = .true.
   do_ps = .false.; if (ps_tau > -eps) do_ps = .true.

 ! namelist dummy checks
 ! if no overrides turned on then set freq = 0
   if (freq > 0) then
       if ( .not.do_u .and. .not.do_v .and. .not.do_t .and. &
            .not.do_q .and. .not.do_ps ) then
!           call error_mesg ('atmos_nudge_mod', 'no variables specified '//&
!                            'for override, resetting freq = 0', WARNING)
!           freq = 0
            call error_mesg ('atmos_nudge_mod', 'no variables specified '//&
                             'for override', WARNING)
       endif
   else
       if ( do_u .or. do_v .or. do_t .or.  do_q .or. do_ps ) then
            call error_mesg ('atmos_nudge_mod', 'variables specified '//&
                             'for override when freq = 0', FATAL)
       endif
       freq = 0
   endif

 ! return flag = true when override is needed
   if (present(flag)) then
       flag = freq .gt. 0
   endif

 ! what is the next time for data insertion

   Time_next = Time + set_time(freq)

 ! initialize diagnostics

   desc = ' tendency due to data override/insertion'

   id_udt = register_diag_field ('atmos_nudge', 'udt_nudge', axes, Time, &
                                 'zonal wind'//trim(desc), 'm/s2', missing_value=missing_value)
   id_vdt = register_diag_field ('atmos_nudge', 'vdt_nudge', axes, Time, &
                                 'meridional wind'//trim(desc), 'm/s2',missing_value=missing_value)
   id_tdt = register_diag_field ('atmos_nudge', 'tdt_nudge', axes, Time, &
                                 'temperature'//trim(desc), 'degK/s',missing_value=missing_value)
   id_qdt = register_diag_field ('atmos_nudge', 'qdt_nudge', axes, Time, &
                                 'specific humidity'//trim(desc), 'kg/kg/s',missing_value=missing_value)
   id_psdt = register_diag_field ('atmos_nudge', 'psdt_nudge', axes(1:2), Time, &
                                 'surface pressure'//trim(desc), 'Pa/s',missing_value=missing_value)

   module_is_initialized = .true.

end subroutine atmos_nudge_init

!-----------------------------------------------------------------------

subroutine atmos_nudge_end

    u_tau = -1.
    v_tau = -1.
    t_tau = -1.
    q_tau = -1.
   ps_tau = -1.
   module_is_initialized = .false.

end subroutine atmos_nudge_end

!-----------------------------------------------------------------------

subroutine override_error ( Time, field )
type (time_type), intent(in) :: Time
character(len=*), intent(in) :: field
integer :: date(6)
character(len=19) :: cdate

! private routine for handling data override errors
! prints out field name and time of error

   call get_date (Time,date(1),date(2),date(3),date(4),date(5),date(6))
   write (cdate,'(i4,5(a1,i2.2))') date(1),'-',date(2),'-',date(3),' ', &
                                  date(4),':',date(5),':',date(6)
   call error_mesg ('atmos_nudge_mod', &
     'data override not done for '//trim(field)//', date = '//cdate, FATAL)

end subroutine override_error

!#######################################################################

end module atmos_nudge_mod

module ocean_submesoscale_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S. M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! This module computes a streamfunction within
! the upper surface boundary layer, and applies this
! streamfunction to all tracers. It also optionally 
! applies horizontal diffusion in the surface layer 
! as determined by the strength of the streamfunction. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes a streamfunction within
! the upper surface boundary layer, and applies this
! streamfunction to all tracers.  It also optionally 
! applies horizontal diffusion in the surface layer 
! as determined by the strength of the streamfunction. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! Fox-Kemper, Ferrari, and Hallberg 2008: Parameterization of 
! mixed layer eddies. Part I: theory and diagnosis
! Journal of Physical Oceanography, vol. 38, pages 1145-1165. 
! </REFERENCE>
!
! <REFERENCE>
! Fox-Kemper, Danabasoglu, Ferrari, and Hallberg 2008: 
! Parameterizing submesoscale physics in global models.
! Clivar Exchanges, vol 13, no.1,  Jan2008. pages 3-5.
! </REFERENCE>
!
! <REFERENCE>
! Fox-Kemper, Danabasoglu, Ferrari, Griffies, Hallberg,
! Holland, Peacock, Samuels, 2011: Parameterization of 
! Mixed Layer Eddies. III: Global Implementation and 
! Impact on Ocean Climate Simulations, Ocean Modelling, 
! vol. 39, pages 61-78.
! </REFERENCE>
!
! <REFERENCE>
! Griffies, 2012: Elements of MOM 
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_submesoscale_nml">
!  <DATA NAME="use_this_module=" TYPE="logical">
!  Must be .true. to use this module.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging purposes.
!  </DATA> 
!  <DATA NAME="diag_step" TYPE="integer">
!  Number of time steps between computing max bottom value for
!  wrho_bt_submeso. Default diag_step=1200.
!  </DATA> 
!
!  <DATA NAME="submeso_skew_flux" TYPE="logical">
!  For computing the tendency as convergence of skew flux.
!  This is the recommended method.
!  Default submeso_skew_flux=.true.
!  </DATA> 
!
!  <DATA NAME="submeso_advect_flux" TYPE="logical">
!  For computing the tendency as convergence of advective flux.
!  This approach uses either a flux limited sweby advection or 
!  first order upwind, both of which ensure that the resulting 
!  tendency will not create extrema in the tracer field.  
!  Default submeso_advect_flux=.false.
!  </DATA> 
!  <DATA NAME="submeso_advect_upwind" TYPE="logical">
!  For computing the tendency as convergence of a first order
!  advective flux. 
!  Default submeso_advect_upwind=.true.
!  </DATA> 
!  <DATA NAME="submeso_advect_sweby" TYPE="logical">
!  For computing the tendency as convergence of a sweby 
!  advective flux. This routine is incomplete and has a bug.  
!  Default submeso_advect_sweby=.false.
!  </DATA> 
!  <DATA NAME="submeso_advect_limit" TYPE="logical">
!  For limiting the value of the horizontal transports 
!  to be less than a velocity scale set by limit_psi_velocity_scale.
!  This option is not needed if limit_psi=.true.
!  Default submeso_advect_limit=.false.
!  </DATA> 
!  <DATA NAME="submeso_advect_zero_bdy" TYPE="logical">
!  For removing the advective transport next to boundaries. 
!  This is useful since computation of the advective transport
!  velocity components can be problematic next to boundaries. 
!  Default submeso_advect_zero_bdy=.false.
!  </DATA> 
!  <DATA NAME="smooth_advect_transport" TYPE="logical">
!  For doing a horizontal 1-2-1 smoothing on the diagnosed  
!  uhrho_et_submeso and vhrho_nt_submeso fields.  
!  Default smooth_advect_transport=.true.
!  </DATA> 
!  <DATA NAME="smooth_advect_transport_num" TYPE="integer">
!  Number of iterations for the smooothing of horizontal transport. 
!  Default smooth_advect_transport_num=2.
!  </DATA> 
!
!  <DATA NAME="submeso_diffusion" TYPE="logical">
!  For computing a horizontal diffusive flux in the boundary layer
!  as determined by the strength of the vector streamfunction.
!  Default submeso_diffusion=.false.
!  </DATA> 
!  <DATA NAME="submeso_diffusion_biharmonic" TYPE="logical">
!  The default submeso diffusion is Laplacian. However, one may wish to
!  use a biharmonic mixing operator instead.  
!  Default submeso_diffusion_biharmonic=.false. 
!  </DATA> 
!  <DATA NAME="submeso_diffusion_scale" UNITS="dimensionless" TYPE="real">
!  A dimensionless scaling to be used for scaling up or down the effects from 
!  horizontal diffusion in the boundary layer. Default submeso_diffusion_scale=1.0.
!  </DATA> 
!
!  <DATA NAME="use_hblt_constant" TYPE="logical">
!  For running with a constant boundary layer depth. This for the case when 
!  not using a realistic mixed layer scheme.  Default use_hblt_constant=.false.
!  </DATA> 
!  <DATA NAME="constant_hblt" UNITS="metre" TYPE="real">
!  The boundary layer depth for the case when use_hblt_constant=.true.
!  Default constant_hblt=100.0.
!  </DATA> 
!  <DATA NAME="use_hblt_equal_mld" TYPE="logical">
!  For using the diagnosed mld as the hblt for submeso.  
!  This is useful for those test models that do not have a mixed layer
!  scheme enabled, such as KPP, where the mixed layer scheme provides a
!  boundary layer depth.  In this case, it is sensible to employ the diagnosed
!  mixed layer depth for the submeso scheme. Additionally, in general it is 
!  more physical to use the mld than the KPP hblt as the depth over which 
!  the submesoscale eddies act.  Hence, default use_hblt_equal_mld=.true.
!  </DATA> 
!  <DATA NAME="min_kblt" UNITS="dimensionless" TYPE="integer">
!  The minimum number of vertical cells in the surface boundary layer 
!  that are required in order to compute the submesoscale streamfunction.
!  Default min_kblt=4.  Need at least three to fit a parabola with zero 
!  streamfunction at the top and bottom of the boundary layer.  
!  </DATA> 
!
!  <DATA NAME="minimum_hblt" TYPE="real" UNITS="metre">
!  For setting a floor to the hblt used for submesoscale scheme. 
!  Default minimum_hblt=0.0.
!  </DATA> 
!
!  <DATA NAME="smooth_hblt" TYPE="logical">
!  For smoothing on the submeso bldepth field. This is useful 
!  since the bldepth obtained from KPP or diagnosed mld can 
!  have some grid noise. 
!  Default smooth_hblt=.false. since this agrees with legacy.
!  Note that this scheme fails to reproduce across
!  processor layout, so it remains broken.  
!  </DATA> 
!  <DATA NAME="smooth_hblt_num" TYPE="integer">
!  Number of iterations for the smooothing of bldepth. 
!  Default smooth_hblt_num=1.
!  </DATA> 
!
!  <DATA NAME="use_psi_legacy" TYPE="logical">
!  For computing psi using older legacy methods. 
!  These methods are not ideal, and can be problematic
!  depending on nml settings for the limiters and smoothers.
!  This option is retained only for legacy purposes. 
!  Default use_psi_legacy=.false.
!  </DATA> 
!  <DATA NAME="smooth_psi" TYPE="logical">
!  For doing a horizontal 1-2-1 smoothing on the 
!  psix_horz and psiy_horz fields. 
!  Default smooth_psi=.true.
!  </DATA> 
!  <DATA NAME="smooth_psi_num" TYPE="integer">
!  Number of iterations for the smooothing of psi. 
!  Default smooth_psi_num=2.
!  </DATA> 
!  <DATA NAME="limit_psi" TYPE="logical">
!  For limiting the magnitude of psi in order to reduce possibility of 
!  model crashes. Rescales the full psi to maintain vertical structure
!  but to keep overall magnitude within bounds.  
!  Default limit_psi=.false.
!  </DATA> 
!  <DATA NAME="limit_psi_velocity_scale" UNITS="metre/sec" TYPE="real">
!  Velocity scale used to limit the value of psi when limit_psi=.true.
!  Default limit_psi_velocity_scale=5.0
!  </DATA> 
!
!  <DATA NAME="submeso_limit_flux" TYPE="logical">
!  For limiting the fluxes arising from submeso scheme, according to 
!  tmask_limit. When reach a point where tmask_limit=1.0, then set
!  the submeso flux for this cell to zero. 
!  Default submeso_limit_flux=.true.
!  </DATA> 
!
! <DATA NAME="coefficient_ce" UNITS="dimensionless" TYPE="real">
!  The dimensionless coefficient from the Fox-Kemper etal scheme. 
!  They recommend setting coefficient_ce between 0.06 and 0.08.  
!  Default coefficient_ce=0.07.
!  </DATA> 
! <DATA NAME="time_constant" UNITS="seconds" TYPE="real">
!  Timescale to mix momentum across the mixed layer.  
!  Default time_constant=86400.0 = 1day. 
!  </DATA> 
! <DATA NAME="front_length_const" UNITS="metre" TYPE="real">
!  Take constant horizontal length scale of submesoscale front. 
!  Default front_length_const=5e3.
!  </DATA> 
! <DATA NAME="front_length_deform_radius" TYPE="logical">
!  To compute the front length using the mixed layer deformation 
!  radius. Default front_length_deform_radius=.true.  Note, 
!  will have a floor on the variable front length set by the
!  nml setting for front_length_const.
!  </DATA> 
!
!</NAMELIST>

use constants_mod,     only: epsln
use diag_manager_mod,  only: register_diag_field, register_static_field, need_data, send_data
use fms_mod,           only: write_version_number, open_namelist_file, close_file, check_nml_error
use fms_mod,           only: stdout, stdlog, read_data, NOTE, FATAL, WARNING
use mpp_domains_mod,   only: mpp_update_domains, XUPDATE, YUPDATE, CGRID_NE, EDGEUPDATE, SUPDATE, WUPDATE
use mpp_domains_mod,   only: mpp_global_sum, NON_BITWISE_EXACT_SUM
use mpp_mod,           only: input_nml_file, mpp_error, mpp_max, mpp_pe
use time_manager_mod,  only: time_type, increment_time

use ocean_domains_mod,    only: get_local_indices, set_ocean_domain
use ocean_operators_mod,  only: FMX, FMY, FDX_T, FDY_T, BDX_ET, BDY_NT
use ocean_parameters_mod, only: missing_value, DEPTH_BASED, omega_earth, grav
use ocean_parameters_mod, only: rho0, rho0r, onehalf, onefourth, onesixth, oneeigth
use ocean_tracer_diag_mod,only: calc_mixed_layer_depth, diagnose_eta_tend_3dflux 
use ocean_types_mod,      only: tracer_2d_type, tracer_3d_0_nk_type, tracer_3d_1_nk_type
use ocean_types_mod,      only: ocean_time_type, ocean_domain_type, ocean_grid_type, ocean_options_type
use ocean_types_mod,      only: ocean_prog_tracer_type, ocean_thickness_type, ocean_density_type
use ocean_util_mod,       only: write_timestamp, diagnose_2d, diagnose_3d, diagnose_sum, write_chksum_3d
use ocean_tracer_util_mod,only: diagnose_3d_rho
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3, wrk4, wrk5, wrk1_2d, wrk2_2d, wrk1_v

implicit none

private

! for diagnostics 
real, dimension(:,:,:),   allocatable :: advect_tendency 

! internally set for computing watermass diagnstics
logical :: compute_watermass_diag      = .false. 
logical :: compute_watermass_diff_diag = .false. 

! for diagnostics 
integer :: id_kblt_submeso         =-1
integer :: id_hblt_submeso         =-1
integer :: id_mu_submeso           =-1
integer :: id_dmu_submeso          =-1
integer :: id_psix_submeso         =-1
integer :: id_psiy_submeso         =-1
integer :: id_tx_trans_submeso     =-1
integer :: id_ty_trans_submeso     =-1
integer :: id_tz_trans_submeso     =-1
integer :: id_tx_trans_submeso_adv =-1
integer :: id_ty_trans_submeso_adv =-1
integer :: id_tz_trans_submeso_adv =-1
integer :: id_tx_trans_nrho_submeso=-1
integer :: id_ty_trans_nrho_submeso=-1
integer :: id_tz_trans_nrho_submeso=-1
integer :: id_tx_trans_rho_submeso=-1
integer :: id_ty_trans_rho_submeso=-1
integer :: id_tz_trans_rho_submeso=-1
integer :: id_front_length_submeso =-1
integer :: id_buoy_freq_ave_submeso=-1 
integer :: id_uhrho_et_submeso     =-1
integer :: id_vhrho_nt_submeso     =-1
integer :: id_wrho_bt_submeso      =-1
integer :: id_u_et_submeso         =-1
integer :: id_v_nt_submeso         =-1
integer :: id_w_bt_submeso         =-1
integer :: id_subdiff_diffusivity  =-1

integer :: id_eta_tend_submeso_flx      =-1
integer :: id_eta_tend_submeso_flx_glob =-1
integer :: id_eta_tend_submeso_tend     =-1
integer :: id_eta_tend_submeso_tend_glob=-1

integer :: id_eta_tend_subdiff_flx      =-1
integer :: id_eta_tend_subdiff_flx_glob =-1
integer :: id_eta_tend_subdiff_tend     =-1
integer :: id_eta_tend_subdiff_tend_glob=-1

integer :: id_neut_rho_submeso          =-1
integer :: id_pot_rho_submeso           =-1
integer :: id_neut_rho_submeso_on_nrho  =-1
integer :: id_wdian_rho_submeso         =-1
integer :: id_wdian_rho_submeso_on_nrho =-1
integer :: id_tform_rho_submeso         =-1
integer :: id_tform_rho_submeso_on_nrho =-1

integer :: id_neut_temp_submeso          =-1
integer :: id_neut_temp_submeso_on_nrho  =-1
integer :: id_wdian_temp_submeso         =-1
integer :: id_wdian_temp_submeso_on_nrho =-1
integer :: id_tform_temp_submeso         =-1
integer :: id_tform_temp_submeso_on_nrho =-1

integer :: id_neut_salt_submeso          =-1
integer :: id_neut_salt_submeso_on_nrho  =-1
integer :: id_wdian_salt_submeso         =-1
integer :: id_wdian_salt_submeso_on_nrho =-1
integer :: id_tform_salt_submeso         =-1
integer :: id_tform_salt_submeso_on_nrho =-1

integer :: id_neut_rho_subdiff          =-1
integer :: id_neut_rho_subdiff_on_nrho  =-1
integer :: id_wdian_rho_subdiff         =-1
integer :: id_wdian_rho_subdiff_on_nrho =-1
integer :: id_tform_rho_subdiff         =-1
integer :: id_tform_rho_subdiff_on_nrho =-1

integer :: id_neut_temp_subdiff          =-1
integer :: id_neut_temp_subdiff_on_nrho  =-1
integer :: id_wdian_temp_subdiff         =-1
integer :: id_wdian_temp_subdiff_on_nrho =-1
integer :: id_tform_temp_subdiff         =-1
integer :: id_tform_temp_subdiff_on_nrho =-1

integer :: id_neut_salt_subdiff          =-1
integer :: id_neut_salt_subdiff_on_nrho  =-1
integer :: id_wdian_salt_subdiff         =-1
integer :: id_wdian_salt_subdiff_on_nrho =-1
integer :: id_tform_salt_subdiff         =-1
integer :: id_tform_salt_subdiff_on_nrho =-1


integer, dimension(:), allocatable :: id_xflux_submeso       ! i-directed flux 
integer, dimension(:), allocatable :: id_yflux_submeso       ! j-directed flux 
integer, dimension(:), allocatable :: id_zflux_submeso       ! k-directed flux 
integer, dimension(:), allocatable :: id_xflux_submeso_int_z ! vertically integrated i-flux
integer, dimension(:), allocatable :: id_yflux_submeso_int_z ! vertically integrated j-flux
integer, dimension(:), allocatable :: id_submeso             ! tendency from streamfunction portion of submesoscale param 
integer, dimension(:), allocatable :: id_submeso_on_nrho     ! tendency from streamfunction portion of submesoscale param binned to neutral density

integer, dimension(:), allocatable :: id_xflux_subdiff       ! i-directed horz diffusive flux 
integer, dimension(:), allocatable :: id_yflux_subdiff       ! j-directed horz diffusive flux 
integer, dimension(:), allocatable :: id_xflux_subdiff_int_z ! vertically integrated horz diffusive i-flux
integer, dimension(:), allocatable :: id_yflux_subdiff_int_z ! vertically integrated horz diffusive j-flux
integer, dimension(:), allocatable :: id_subdiff             ! tendency from horz diffusion associated with submesoscale 

logical :: used


#include <ocean_memory.h>

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()
type(ocean_domain_type), save    :: Dom_flux_sub

character(len=128)  :: version='$$'
character (len=128) :: tagname = '$Name: tikal $'


#ifdef MOM_STATIC_ARRAYS
real, dimension(isd:ied,jsd:jed,nk)   :: uhrho_et_submeso ! i-component of transport for submeso 
real, dimension(isd:ied,jsd:jed,nk)   :: vhrho_nt_submeso ! j-component of transport for submeso 
real, dimension(isd:ied,jsd:jed,0:nk) :: wrho_bt_submeso  ! k-component of transport for submeso 

real, dimension(isd:ied,jsd:jed,nk,0:1) :: delqc   !density weighted (kg/m^3) quarter cell thickness(m)
real, dimension(isd:ied,jsd:jed,0:nk)   :: dzwtr   !(1/dzwt)(m^-1)
real, dimension(isd:ied,jsd:jed,0:1)    :: dtew    !grid distances from T-point to cell faces (m)
real, dimension(isd:ied,jsd:jed,0:1)    :: dtns    !grid distances from T-point to cell faces (m)
real, dimension(isd:ied,jsd:jed,0:1)    :: dtwedyt !horizontal areas (m^2) of quarter cell
real, dimension(isd:ied,jsd:jed,0:1)    :: dxtdtsn !horizontal areas (m^2) of quarter cell

real, dimension(isd:ied,jsd:jed,nk,0:1) :: psix             ! streamfunction x-component (m^2/sec) 
real, dimension(isd:ied,jsd:jed,nk,0:1) :: psiy             ! streamfunction y-component (m^2/sec) 
real, dimension(isd:ied,jsd:jed)        :: hblt             ! boundary layer depth (m) 
real, dimension(isd:ied,jsd:jed)        :: grid_length      ! grid length scale (m)
real, dimension(isd:ied,jsd:jed)        :: front_length_inv ! inverse front length (1/m)
real, dimension(isd:ied,jsd:jed)        :: buoy_freq_ave    ! buoyancy frequency averaged over mixed layer depth (1/sec)
real, dimension(isd:ied,jsd:jed)        :: time_factor      ! time factor (sec) for computing streamfunction
real, dimension(isd:ied,jsd:jed)        :: coriolis_param   ! absolute value of the Coriolis parameter (sec^-1) on T-grid 
integer, dimension(isd:ied,jsd:jed)     :: kblt             ! k-level encompassing hblt 

real, dimension(isd:ied,jsd:jed,nk)     :: flux_x      ! i-component to tracer flux
real, dimension(isd:ied,jsd:jed,nk)     :: flux_y      ! j-component to tracer flux
real, dimension(isd:ied,jsd:jed,0:nk)   :: flux_z      ! k-component to tracer flux

#else 

real, dimension(:,:,:), allocatable :: uhrho_et_submeso  ! i-component of transport for submeso 
real, dimension(:,:,:), allocatable :: vhrho_nt_submeso  ! j-component of transport for submeso 
real, dimension(:,:,:), allocatable :: wrho_bt_submeso   ! k-component of transport for submeso 

real, dimension(:,:,:,:), allocatable :: delqc   !density weighted (kg/m^3) quarter cell thickness(m)
real, dimension(:,:,:),   allocatable :: dzwtr   !(1/dzwt)(m^-1)
real, dimension(:,:,:),   allocatable :: dtew    !grid distances from T-point to cell faces (m)
real, dimension(:,:,:),   allocatable :: dtns    !grid distances from T-point to cell faces (m)
real, dimension(:,:,:),   allocatable :: dtwedyt !horizontal areas (m^2) of quarter cell
real, dimension(:,:,:),   allocatable :: dxtdtsn !horizontal areas (m^2) of quarter cell

real, dimension(:,:,:,:), allocatable :: psix             ! streamfunction x-component (m^2/sec) 
real, dimension(:,:,:,:), allocatable :: psiy             ! streamfunction y-component (m^2/sec) 
real, dimension(:,:),     allocatable :: hblt             ! boundary layer depth (m) 
real, dimension(:,:),     allocatable :: grid_length      ! grid length scale (m)
real, dimension(:,:),     allocatable :: front_length_inv ! inverse front length (1/m)
real, dimension(:,:),     allocatable :: buoy_freq_ave    ! buoyancy frequency averaged over mixed layer depth (1/sec)
real, dimension(:,:),     allocatable :: time_factor      ! time factor (sec) for computing streamfunction
real, dimension(:,:),     allocatable :: coriolis_param   ! absolute value of the Coriolis parameter (sec^-1) on T-grid 
integer, dimension(:,:),  allocatable :: kblt             ! k-level encompassing hblt 

real, dimension(:,:,:),   allocatable :: flux_x      ! i-component to tracer flux
real, dimension(:,:,:),   allocatable :: flux_y      ! j-component to tracer flux
real, dimension(:,:,:),   allocatable :: flux_z      ! k-component to tracer flux


#endif 

! for saving the horizontally dependent portion of psix and psiy
real, dimension(:,:,:), allocatable :: psix_horz ! streamfunction x-component sans vertical structure (m^2/sec) 
real, dimension(:,:,:), allocatable :: psiy_horz ! streamfunction y-component sans vertical structure (m^2/sec) 

! for eta_tend diagnostics 
real, dimension(:,:,:), allocatable :: flux_x_temp
real, dimension(:,:,:), allocatable :: flux_y_temp
real, dimension(:,:,:), allocatable :: flux_z_temp
real, dimension(:,:,:), allocatable :: flux_x_salt
real, dimension(:,:,:), allocatable :: flux_y_salt
real, dimension(:,:,:), allocatable :: flux_z_salt

! for advecting tracers with sweby submesoscale advection 
real, dimension(:,:,:), allocatable :: tmask_mdfl
real, dimension(:,:,:), allocatable :: tracer_mdfl
type  :: tracer_mdfl_type
  real, dimension(:,:,:), pointer :: field => NULL()
end type tracer_mdfl_type
type(tracer_mdfl_type),  dimension(:), allocatable  :: tracer_mdfl_all ! tracer array for sweby advection   
type(ocean_domain_type), save :: Dom_mdfl


type(tracer_3d_1_nk_type), dimension(:), allocatable  :: dTdx ! tracer partial derivative (tracer/m)
type(tracer_3d_1_nk_type), dimension(:), allocatable  :: dTdy ! tracer partial derivative (tracer/m)
type(tracer_3d_0_nk_type), dimension(:), allocatable  :: dTdz ! tracer partial derivative (tracer/m)

type(tracer_3d_1_nk_type), save :: dSdx ! density-salinity partial derivative (tracer/m)
type(tracer_3d_1_nk_type), save :: dSdy ! density-salinity partial derivative (tracer/m)
type(tracer_3d_0_nk_type), save :: dSdz ! density-salinity partial derivative (tracer/m)

public ocean_submesoscale_init 
public submeso_restrat
private tracer_derivs 
private salinity_derivs 
private compute_flux_x
private compute_flux_y
private compute_flux_z
private compute_psi
private compute_psi_legacy
private compute_bldepth 
private compute_advect_transport 
private compute_submeso_skewsion
private compute_submeso_upwind 
private compute_submeso_sweby
private maximum_bottom_w_submeso
private transport_on_rho_submeso
private transport_on_nrho_submeso
private transport_on_nrho_submeso_adv
private watermass_diag_init
private watermass_diag
private watermass_diag_diffusion

integer :: index_temp=-1
integer :: index_salt=-1 
integer :: num_prog_tracers=0

! for diagnosing fluxes
real    :: flux_sign

! vertical coordinate 
integer :: vert_coordinate_class=1

! for output
integer :: unit=6

real    :: fiveover21
real    :: eightover21
real    :: dtime 
real    :: ce_grav_rho0r 
real    :: time_constant2_r
real    :: grav_rho0r
real    :: front_length_const_inv
real    :: front_length_max=1e10

! for global area normalization
real    :: cellarea_r

logical :: module_is_initialized=.false.

! for specifying transport units
! can either be Sv or mks
character(len=32) :: transport_dims ='Sv (10^9 kg/s)' 
real              :: transport_convert=1.0e-9 

! for eta_tend diagnostics (internally set)
logical :: diagnose_eta_tend_submeso_flx=.false. 
logical :: diagnose_eta_tend_subdiff_flx=.false.

! internally determined 
logical :: diag_advect_transport = .false.

! nml parameters 
logical :: use_this_module               = .false.
logical :: debug_this_module             = .false. 
logical :: submeso_skew_flux             = .true.
logical :: submeso_advect_flux           = .false.
logical :: submeso_advect_upwind         = .true. 
logical :: submeso_advect_sweby          = .false. 
logical :: submeso_advect_limit          = .false. 
logical :: submeso_advect_zero_bdy       = .false.
logical :: submeso_limit_flux            = .true.
logical :: use_hblt_constant             = .false.    
logical :: use_hblt_equal_mld            = .true. 
logical :: smooth_hblt                   = .false.    
logical :: smooth_psi                    = .true.    
logical :: smooth_advect_transport       = .true. 
logical :: front_length_deform_radius    = .true.
logical :: limit_psi                     = .true.
logical :: use_psi_legacy                = .false.
logical :: submeso_diffusion             = .false.
logical :: submeso_diffusion_biharmonic  = .false.
real    :: limit_psi_velocity_scale      = 0.5
real    :: coefficient_ce                = 0.07
real    :: time_constant                 = 86400.0 
real    :: front_length_const            = 5e3 
real    :: constant_hblt                 = 100.0
real    :: minimum_hblt                  = 0.0
real    :: submeso_diffusion_scale       = 1.0 
integer :: min_kblt                      = 4
integer :: diag_step                     = 1200
integer :: smooth_psi_num                = 2
integer :: smooth_advect_transport_num   = 2
integer :: smooth_hblt_num               = 2

namelist /ocean_submesoscale_nml/ use_this_module, debug_this_module, diag_step,        &
                                  use_hblt_constant, use_hblt_equal_mld,                &
                                  smooth_hblt, smooth_hblt_num, constant_hblt,          &
                                  coefficient_ce, time_constant, front_length_const,    &
                                  min_kblt, minimum_hblt, smooth_psi, smooth_psi_num,   &
                                  front_length_deform_radius,                           &
                                  limit_psi, use_psi_legacy, limit_psi_velocity_scale,  &
                                  submeso_limit_flux, smooth_advect_transport,          &
                                  smooth_advect_transport_num,                          &
                                  submeso_skew_flux, submeso_advect_flux,               &
                                  submeso_advect_upwind, submeso_advect_sweby,          &
                                  submeso_advect_limit, submeso_advect_zero_bdy,        &
                                  submeso_diffusion, submeso_diffusion_scale,           &
                                  submeso_diffusion_biharmonic  

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_submesoscale_init">
!
! <DESCRIPTION>
! Initialization for the ocean_submesoscale module.
! </DESCRIPTION>
  subroutine ocean_submesoscale_init(Grid, Domain, Time, Dens, T_prog, Ocean_options, dtime_t, &
                                     ver_coordinate_class, cmip_units, debug)
  
    type(ocean_grid_type),        intent(in), target   :: Grid
    type(ocean_domain_type),      intent(in), target   :: Domain
    type(ocean_time_type),        intent(in)           :: Time
    type(ocean_density_type),     intent(in)           :: Dens
    type(ocean_prog_tracer_type), intent(in)           :: T_prog(:)
    type(ocean_options_type),     intent(inout)        :: Ocean_options 
    real,                         intent(in)           :: dtime_t
    integer,                      intent(in)           :: ver_coordinate_class 
    logical,                      intent(in)           :: cmip_units
    logical,                      intent(in), optional :: debug

    integer :: unit, io_status, ierr
    integer :: i,j,k,n
    integer :: num_methods=0

    integer :: stdoutunit,stdlogunit 
    stdoutunit=stdout();stdlogunit=stdlog() 

    if ( module_is_initialized ) then 
      call mpp_error(FATAL,&
      '==>Error from ocean_submesoscale_init_mod: module already initialized')
    endif 

    module_is_initialized = .TRUE.

    call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_submesoscale_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_submesoscale_nml')
#else
    unit = open_namelist_file()
    read(unit, ocean_submesoscale_nml,iostat=io_status)
    ierr = check_nml_error(io_status, 'ocean_submesoscale_nml')
    call close_file(unit)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit,ocean_submesoscale_nml)    
    write (stdlogunit,ocean_submesoscale_nml)

    Dom => Domain
    Grd => Grid

#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
    nk = Grid%nk
#endif

    if(cmip_units) then
        transport_convert=1.0
        transport_dims   = 'kg/s'
    else
        transport_convert=1.0e-9 
        transport_dims   = 'Sv (10^9 kg/s)'
    endif

    if (PRESENT(debug) .and. .not. debug_this_module) then
        debug_this_module = debug
    endif
    if(debug_this_module) then 
        write(stdoutunit,'(a)') '==>Note: running ocean_submesoscale_mod with debug_this_module=.true.'  
    endif

    if(use_this_module) then 
      call mpp_error(NOTE, '==>Note: USING ocean_submesoscale_mod')
      Ocean_options%submesoscale = 'Used submesoscale closure for surface restratification.'
    else 
      call mpp_error(NOTE, '==>Note: NOT using ocean_submesoscale_mod')
      Ocean_options%submesoscale = 'Did NOT use submesoscale closure for surface restratification.'
      return 
    endif 

    if(use_hblt_equal_mld) then 
      write(stdoutunit,'(a)') &
      '==>Note: For ocean_submesoscale, setting bldepth equal to diagnosed mld.'
    endif 
    if(use_hblt_constant) then 
      write(stdoutunit,'(a)') &
      '==>Note: For ocean_submesoscale, setting bldepth equal to prescribed constant.'
    endif 
    if(use_hblt_equal_mld .and. use_hblt_constant) then 
      call mpp_error(FATAL, &
      '==>Error: in ocean_submesoscale, use_hblt_equal_mld & use_hblt_constant cannot both be true.')
    endif 

    if(submeso_advect_flux) then 
        num_methods=num_methods+1
        flux_sign = 1.0
        if(submeso_advect_upwind) then 
            write(stdoutunit,'(a)') &
                 '==>Note: For ocean_submesoscale, tendency computed as convergence of upwind advective flux.'
        elseif(submeso_advect_sweby) then 
            write(stdoutunit,'(a)') &
                 '==>Note: For ocean_submesoscale, tendency computed as convergence of mdfl_sweby advective flux; has known bugs!'
        else
            call mpp_error(FATAL, &
            '==>Error: in ocean_submesoscale: submeso_advect_flux=.true. yet no advection scheme chosen')
        endif
        if(use_psi_legacy) then
            call mpp_error(FATAL, &
            '==>Error: in ocean_submesoscale: submeso_advect_flux=.true. is not compatible with use_psi_legacy=.true.')
        endif 
    endif
    if(submeso_skew_flux) then 
       write(stdoutunit,'(a)') &
       '==>Note: For ocean_submesoscale, tendency computed as skew flux convergence.'
       num_methods=num_methods+1
       flux_sign = -1.0
    endif 
    if(num_methods > 1) then 
       call mpp_error(FATAL, &
       '==>Error: in ocean_submesoscale, can choose only one method for computing tendency.')
    endif 
    if(num_methods == 0) then 
       call mpp_error(FATAL, &
       '==>Error: in ocean_submesoscale, must choose one method for computing tendency.')
    endif 

    if(use_psi_legacy) then
       write(stdoutunit,'(a)') &
       '==>Note: in ocean_submesoscale: use_psi_legacy=.true. This method has problems, and is retained solely for legacy.'  
    endif 

    if(submeso_diffusion) then
        if(submeso_diffusion_biharmonic) then 
            write(stdoutunit,'(a)') &
            '==>Note: in ocean_submesoscale: submeso_diffusion=.true. Adding horizontal biharmonic mixing in blayer.'  
        else 
            write(stdoutunit,'(a)') &
            '==>Note: in ocean_submesoscale: submeso_diffusion=.true. Adding horizontal Laplacian diffusion in blayer.'  
        endif
    endif


    fiveover21             = 5.0/21.0
    eightover21            = 8.0/21.0
    grav_rho0r             = grav*rho0r
    ce_grav_rho0r          = coefficient_ce*grav*rho0r
    time_constant2_r       = 1.0/(time_constant**2) 
    dtime                  = dtime_t 
    vert_coordinate_class  = ver_coordinate_class
    front_length_const_inv = 1.0/front_length_const
    cellarea_r             = 1.0/(epsln + Grd%tcellsurf)

    call set_ocean_domain(Dom_mdfl,Grd,xhalo=2,yhalo=2,name='mdfl',maskmap=Dom%maskmap)

    call set_ocean_domain(Dom_flux_sub, Grd,xhalo=Dom%xhalo,yhalo=Dom%yhalo,name='flux dom submeso',&
                          maskmap=Dom%maskmap)

    ! for diagnostics 
    allocate( advect_tendency(isd:ied,jsd:jed,nk) )
    advect_tendency(:,:,:) = 0.0

    num_prog_tracers = size(T_prog(:))
    do n=1,num_prog_tracers
       if (T_prog(n)%name == 'temp') index_temp = n
       if (T_prog(n)%name == 'salt') index_salt = n
    enddo

    allocate( dTdx(num_prog_tracers) )
    allocate( dTdy(num_prog_tracers) )
    allocate( dTdz(num_prog_tracers) )

#ifndef MOM_STATIC_ARRAYS
    allocate (uhrho_et_submeso(isd:ied,jsd:jed,nk))
    allocate (vhrho_nt_submeso(isd:ied,jsd:jed,nk))
    allocate (wrho_bt_submeso(isd:ied,jsd:jed,0:nk))

    allocate (delqc(isd:ied,jsd:jed,nk,0:1))
    allocate (dzwtr(isd:ied,jsd:jed,0:nk))
    allocate (dtew(isd:ied,jsd:jed,0:1))
    allocate (dtns(isd:ied,jsd:jed,0:1))
    allocate (dtwedyt(isd:ied,jsd:jed,0:1))
    allocate (dxtdtsn(isd:ied,jsd:jed,0:1))

    allocate (psix(isd:ied,jsd:jed,nk,0:1))
    allocate (psiy(isd:ied,jsd:jed,nk,0:1))
    allocate (hblt(isd:ied,jsd:jed))
    allocate (grid_length(isd:ied,jsd:jed))
    allocate (front_length_inv(isd:ied,jsd:jed))
    allocate (buoy_freq_ave(isd:ied,jsd:jed))
    allocate (time_factor(isd:ied,jsd:jed))
    allocate (coriolis_param(isd:ied,jsd:jed))
    allocate (kblt(isd:ied,jsd:jed))

    allocate (flux_x(isd:ied,jsd:jed,nk) )
    allocate (flux_y(isd:ied,jsd:jed,nk) )
    allocate (flux_z(isd:ied,jsd:jed,0:nk) )

    do n=1,num_prog_tracers
       allocate ( dTdx(n)%field(isd:ied,jsd:jed,nk) )
       allocate ( dTdy(n)%field(isd:ied,jsd:jed,nk) )
       allocate ( dTdz(n)%field(isd:ied,jsd:jed,0:nk) )
    enddo
    allocate ( dSdx%field(isd:ied,jsd:jed,nk) )
    allocate ( dSdy%field(isd:ied,jsd:jed,nk) )
    allocate ( dSdz%field(isd:ied,jsd:jed,0:nk) )

#endif 

    allocate (psix_horz(isd:ied,jsd:jed,0:1))
    allocate (psiy_horz(isd:ied,jsd:jed,0:1))

    uhrho_et_submeso = 0.0
    vhrho_nt_submeso = 0.0
    wrho_bt_submeso  = 0.0

    do n=1,num_prog_tracers
       dTdx(n)%field(:,:,:) = 0.0
       dTdy(n)%field(:,:,:) = 0.0
       dTdz(n)%field(:,:,:) = 0.0
    enddo
    dSdx%field(:,:,:) = 0.0
    dSdy%field(:,:,:) = 0.0
    dSdz%field(:,:,:) = 0.0

    psix      = 0.0
    psiy      = 0.0
    psix_horz = 0.0
    psiy_horz = 0.0

    kblt = 0
    hblt = 0.0

    flux_x = 0.0
    flux_y = 0.0
    flux_z = 0.0

    dzwtr = 0.0
    delqc = 0.0

    grid_length(:,:)      = 2.0*Grd%dxt(:,:)*Grd%dyt(:,:)/(Grd%dxt(:,:)+Grd%dyt(:,:))
    front_length_inv(:,:) = front_length_const_inv
    buoy_freq_ave(:,:)    = 0.0
    coriolis_param(:,:)   = 2.0*omega_earth*abs(sin(Grd%phit(:,:)))

    dtew(:,:,0) = Grd%dtw(:,:)
    dtew(:,:,1) = Grd%dte(:,:)
    dtns(:,:,0) = Grd%dts(:,:)
    dtns(:,:,1) = Grd%dtn(:,:)

    dtwedyt(:,:,:) = 0.0
    dtwedyt(:,:,0) = Grd%dte(:,:)*Grd%dyt(:,:)
    do i=isc-1,iec
       dtwedyt(i,:,1) = Grd%dtw(i+1,:)*Grd%dyt(i+1,:)
    enddo

    dxtdtsn(:,:,:) = 0.0
    dxtdtsn(:,:,0) = Grd%dxt(:,:)*Grd%dtn(:,:)
    do j=jsc-1,jec
       dxtdtsn(:,j,1) = Grd%dxt(:,j+1)*Grd%dts(:,j+1)
    enddo

    do j=jsd,jed
       do i=isd,ied
          time_factor(i,j) = 1.0/(sqrt( time_constant2_r + coriolis_param(i,j)**2 ))
       enddo
    enddo


    ! for the sweby advection scheme 
    if(submeso_advect_flux .and. submeso_advect_sweby) then 
        allocate(tracer_mdfl_all(num_prog_tracers))
        allocate(tmask_mdfl (isc-2:iec+2,jsc-2:jec+2,nk))    
        allocate(tracer_mdfl(isc-2:iec+2,jsc-2:jec+2,nk))    
        do n=1,num_prog_tracers
           allocate (tracer_mdfl_all(n)%field(isc-2:iec+2,jsc-2:jec+2,nk))
        enddo
        tmask_mdfl  = 0.0
        tracer_mdfl = 0.0 
        do n=1,num_prog_tracers
           tracer_mdfl_all(n)%field(:,:,:) = 0.0
        enddo
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 tmask_mdfl(i,j,k) = Grd%tmask(i,j,k)
              enddo
           enddo
        enddo
        call mpp_update_domains(tmask_mdfl,Dom_mdfl%domain2d)  
    endif


    ! diagnostics 
    id_kblt_submeso = register_diag_field ('ocean_model', 'kblt_submeso', &
         Grid%tracer_axes(1:2), Time%model_time,                          &
         'Number of k-levels in boundary layer for submesoscale closure', &
         'dimensionless', missing_value=missing_value, range=(/-1.0,1e6/))
    id_hblt_submeso = register_diag_field ('ocean_model', 'hblt_submeso', &
         Grid%tracer_axes(1:2), Time%model_time,                          &
         'Boundary layer depth used for submesoscale closure',            &
         'metre', missing_value=missing_value, range=(/-1.0,1e6/))
    id_front_length_submeso = register_diag_field ('ocean_model', 'front_length_submeso', &
         Grid%tracer_axes(1:2), Time%model_time,                                          &
         'Front length used for submesoscale closure',                                    &
         'metre', missing_value=missing_value, range=(/-1.0,1e6/))
    id_buoy_freq_ave_submeso = register_diag_field ('ocean_model', 'buoy_freq_ave_submeso',&
         Grid%tracer_axes(1:2), Time%model_time,                                           &
         'Buoyancy frequency averaged over depth of mixed layer for submesoscale closure', &
         '1/sec', missing_value=missing_value, range=(/-1.0,1e6/))
    id_mu_submeso = register_diag_field ('ocean_model', 'mu_submeso',   &
         Grd%tracer_axes(1:3), Time%model_time,                         &
         'vertical structure function for submesoscale streamfunction', &
         'dimensionless', missing_value=missing_value, range=(/-1.e2,1e2/))
    id_dmu_submeso = register_diag_field ('ocean_model', 'dmu_submeso',   &
         Grd%tracer_axes(1:3), Time%model_time,                                                &
         'vertical derivative of vertical structure function for submesoscale streamfunction', &
         '1/metre', missing_value=missing_value, range=(/-1.e6,1e6/))
    id_psix_submeso = register_diag_field ('ocean_model', 'psix_submeso', &
         Grd%tracer_axes_flux_y(1:3), Time%model_time,                    &
         'i-comp of submesoscale streamfunction',                         &
         'm^2/sec', missing_value=missing_value, range=(/-1.e10,1e10/))
    id_psiy_submeso = register_diag_field ('ocean_model', 'psiy_submeso', &
         Grd%tracer_axes_flux_x(1:3), Time%model_time,                    &
         'j-comp of submesoscale streamfunction',                         &
         'm^2/sec', missing_value=missing_value, range=(/-1.e10,1e10/))
    id_tx_trans_submeso = register_diag_field ('ocean_model', 'tx_trans_submeso', &
         Grd%tracer_axes_flux_x(1:3), Time%model_time,                            &
         'T-cell mass i-transport from submesoscale param',                       &
         trim(transport_dims), missing_value=missing_value, range=(/-1.e20,1e20/))
    id_ty_trans_submeso = register_diag_field ('ocean_model', 'ty_trans_submeso', &
         Grd%tracer_axes_flux_y(1:3), Time%model_time,                            &
         'T-cell mass j-transport from submesoscale param',                       &
         trim(transport_dims), missing_value=missing_value, range=(/-1.e20,1e20/))
    id_tz_trans_submeso = register_diag_field ('ocean_model', 'tz_trans_submeso', &
         Grd%tracer_axes_wt(1:3), Time%model_time,                                &
         'T-cell mass k-transport from submesoscale param',                       &
         trim(transport_dims), missing_value=missing_value, range=(/-1.e20,1e20/))

    id_tx_trans_nrho_submeso = register_diag_field ('ocean_model','tx_trans_nrho_submeso',&
         Dens%neutralrho_axes_flux_x(1:3),Time%model_time,                                &
         'T-cell i-mass transport from submesoscale param on neutral rho'                 &
         ,trim(transport_dims),missing_value=missing_value, range=(/-1e20,1e20/))
    id_ty_trans_nrho_submeso = register_diag_field ('ocean_model','ty_trans_nrho_submeso',&
         Dens%neutralrho_axes_flux_y(1:3),Time%model_time,                                &
         'T-cell j-mass transport from submesoscale param on neutral rho'                 &
         ,trim(transport_dims),missing_value=missing_value, range=(/-1e20,1e20/))
    id_tz_trans_nrho_submeso = register_diag_field ('ocean_model','tz_trans_nrho_submeso',&
         Dens%neutralrho_axes(1:3),Time%model_time,                                       &
         'T-cell k-mass transport from submesoscale param on neutral rho'                 &
         ,trim(transport_dims),missing_value=missing_value, range=(/-1e20,1e20/))

    id_tx_trans_rho_submeso = register_diag_field('ocean_model','tx_trans_rho_submeso',  &
         Dens%potrho_axes_flux_x(1:3),Time%model_time,                                   &
         'T-cell i-mass transport from submesoscale param on pot_rho'                    &
         ,trim(transport_dims),missing_value=missing_value,range=(/-1e20,1e20/))
    id_ty_trans_rho_submeso = register_diag_field('ocean_model','ty_trans_rho_submeso',  &
         Dens%potrho_axes_flux_y(1:3),Time%model_time,                                   &
         'T-cell j-mass transport from submesoscale param on pot_rho'                    &
         ,trim(transport_dims),missing_value=missing_value,range=(/-1e20,1e20/))

    id_u_et_submeso = register_diag_field ('ocean_model', 'u_et_submeso', &
        Grd%tracer_axes_flux_x(1:3), Time%model_time,                     &
       'i-component of submesoscale transport velocity',                  &
       'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
    id_v_nt_submeso = register_diag_field ('ocean_model', 'v_nt_submeso', &
        Grd%tracer_axes_flux_y(1:3), Time%model_time,                     &
       'j-component of submesoscale transport velocity',                  &
       'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
    id_w_bt_submeso = register_diag_field ('ocean_model', 'w_bt_submeso', &
        Grd%tracer_axes_wt(1:3), Time%model_time,                         &
       'vertical component of submesoscale transport velocity',           &
       'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))

    id_uhrho_et_submeso = register_diag_field ('ocean_model', 'uhrho_et_submeso', &
        Grd%tracer_axes_flux_x(1:3), Time%model_time,                             &
       'i-component of submesoscale advective mass transport',                    &
       '(kg/m^3)*m^2/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
    if(id_uhrho_et_submeso > 0) diag_advect_transport = .true. 

    id_vhrho_nt_submeso = register_diag_field ('ocean_model', 'vhrho_nt_submeso', &
        Grd%tracer_axes_flux_y(1:3), Time%model_time,                             &
       'j-component of submesoscale advective mass transport',                    &
       '(kg/m^3)*m^2/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
    if(id_vhrho_nt_submeso > 0) diag_advect_transport = .true. 

    id_wrho_bt_submeso = register_diag_field ('ocean_model', 'wrho_bt_submeso', &
        Grd%tracer_axes_wt(1:3), Time%model_time,                               &
       'k-component of submesoscale advective mass transport',                  &
       '(kg/m^3)*m/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
    if(id_wrho_bt_submeso > 0) diag_advect_transport = .true. 

    id_tx_trans_submeso_adv = register_diag_field ('ocean_model', 'tx_trans_submeso_adv', &
        Grd%tracer_axes_flux_x(1:3), Time%model_time,                                     &
       'i-component of submesoscale advective mass transport',                            &
       'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
    if(id_tx_trans_submeso_adv > 0) diag_advect_transport = .true. 

    id_ty_trans_submeso_adv = register_diag_field ('ocean_model', 'ty_trans_submeso_adv', &
        Grd%tracer_axes_flux_y(1:3), Time%model_time,                                     &
       'j-component of submesoscale advective mass transport',                            &
       'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
    if(id_ty_trans_submeso_adv > 0) diag_advect_transport = .true. 
    
    id_tz_trans_submeso_adv = register_diag_field ('ocean_model', 'tz_trans_submeso_adv', &
        Grd%tracer_axes_wt(1:3), Time%model_time,                                         &
       'k-component of submesoscale advective mass transport',                            &
       'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
    if(id_tz_trans_submeso_adv > 0) diag_advect_transport = .true. 

    if(submeso_diffusion_biharmonic) then 
        id_subdiff_diffusivity = register_diag_field ('ocean_model', 'subdiff_diffusivity', &
             Grd%tracer_axes(1:3), Time%model_time,                                         &
             'horizontal diffusivity used for submesoscale biharmonic mixing scheme',       &
             'm^4/sec', missing_value=missing_value, range=(/-1.e10,1e10/))
    else 
        id_subdiff_diffusivity = register_diag_field ('ocean_model', 'subdiff_diffusivity', &
             Grd%tracer_axes(1:3), Time%model_time,                                         &
             'horizontal diffusivity used for submesoscale laplacian diffusion scheme',     &
             'm^2/sec', missing_value=missing_value, range=(/-1.e10,1e10/))
    endif


    call watermass_diag_init(Time, Dens)


    id_eta_tend_submeso_flx= -1          
    id_eta_tend_submeso_flx= register_diag_field ('ocean_model','eta_tend_submeso_flx',&
         Grd%tracer_axes(1:2), Time%model_time,                                        &
         'non-Bouss steric sea level tendency from submesoscale fluxes', 'm/s',        &
         missing_value=missing_value, range=(/-1e10,1.e10/))
    if(id_eta_tend_submeso_flx > 0) diagnose_eta_tend_submeso_flx=.true.

    id_eta_tend_submeso_flx_glob= -1          
    id_eta_tend_submeso_flx_glob= register_diag_field ('ocean_model', 'eta_tend_submeso_flx_glob',&
         Time%model_time,                                                                         &
         'global mean non-bouss steric sea level tendency from submesoscale fluxes',              &
         'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
    if(id_eta_tend_submeso_flx_glob > 0) diagnose_eta_tend_submeso_flx=.true.

    id_eta_tend_subdiff_flx= -1          
    id_eta_tend_subdiff_flx= register_diag_field ('ocean_model','eta_tend_subdiff_flx',&
         Grd%tracer_axes(1:2), Time%model_time,                                        &
         'non-Bouss steric sea level tendency from subdiff fluxes', 'm/s',             &
         missing_value=missing_value, range=(/-1e10,1.e10/))
    if(id_eta_tend_subdiff_flx > 0) diagnose_eta_tend_subdiff_flx=.true.

    id_eta_tend_subdiff_flx_glob= -1          
    id_eta_tend_subdiff_flx_glob= register_diag_field ('ocean_model', 'eta_tend_subdiff_flx_glob',&
         Time%model_time,                                                                         &
         'global mean non-bouss steric sea level tendency from subdiff fluxes',                   &
         'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
    if(id_eta_tend_subdiff_flx_glob > 0) diagnose_eta_tend_subdiff_flx=.true.

    if(diagnose_eta_tend_submeso_flx .or. diagnose_eta_tend_subdiff_flx) then 
       allocate( flux_x_temp(isd:ied,jsd:jed,nk) )
       allocate( flux_y_temp(isd:ied,jsd:jed,nk) )
       allocate( flux_z_temp(isd:ied,jsd:jed,nk) )
       allocate( flux_x_salt(isd:ied,jsd:jed,nk) )
       allocate( flux_y_salt(isd:ied,jsd:jed,nk) )
       allocate( flux_z_salt(isd:ied,jsd:jed,nk) )
       flux_x_temp(:,:,:) = 0.0
       flux_y_temp(:,:,:) = 0.0
       flux_z_temp(:,:,:) = 0.0
       flux_x_salt(:,:,:) = 0.0
       flux_y_salt(:,:,:) = 0.0
       flux_z_salt(:,:,:) = 0.0
    endif 


    allocate (id_xflux_submeso(num_prog_tracers))
    allocate (id_yflux_submeso(num_prog_tracers))
    allocate (id_zflux_submeso(num_prog_tracers))
    allocate (id_xflux_submeso_int_z(num_prog_tracers))
    allocate (id_yflux_submeso_int_z(num_prog_tracers))
    allocate (id_submeso(num_prog_tracers))
    allocate (id_submeso_on_nrho(num_prog_tracers))

    allocate (id_xflux_subdiff(num_prog_tracers))
    allocate (id_yflux_subdiff(num_prog_tracers))
    allocate (id_xflux_subdiff_int_z(num_prog_tracers))
    allocate (id_yflux_subdiff_int_z(num_prog_tracers))
    allocate (id_subdiff(num_prog_tracers))

    do n=1,num_prog_tracers

       if(n == index_temp) then 

           id_xflux_submeso(n) = register_diag_field ('ocean_model', &
                trim(T_prog(n)%name)//'_xflux_submeso',              &
                Grd%tracer_axes_flux_x(1:3), Time%model_time,        &
                'cp*submeso_xflux*dyt*rho_dzt*temp',                 &
                'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
           id_yflux_submeso(n) = register_diag_field ('ocean_model', &
                trim(T_prog(n)%name)//'_yflux_submeso',              &
                Grd%tracer_axes_flux_y(1:3), Time%model_time,        &
                'cp*submeso_yflux*dxt*rho_dzt*temp',                 &
                'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
           id_zflux_submeso(n) = register_diag_field ('ocean_model', &
                trim(T_prog(n)%name)//'_zflux_submeso',              &
                Grd%tracer_axes_wt(1:3), Time%model_time,            &
                'cp*submeso_zflux*dxt*dyt*rho*temp',                 &
                'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
           id_xflux_submeso_int_z(n) = register_diag_field ('ocean_model', &
                trim(T_prog(n)%name)//'_xflux_submeso_int_z',              &
                Grd%tracer_axes_flux_x(1:2), Time%model_time,              &
                'z-integral cp*submeso_xflux*dyt*rho_dzt*temp',            &
                'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
           id_yflux_submeso_int_z(n) = register_diag_field ('ocean_model', &
                trim(T_prog(n)%name)//'_yflux_submeso_int_z',              &
                Grd%tracer_axes_flux_y(1:2), Time%model_time,              &
                'z-integral cp*submeso_yflux*dxt*rho_dzt*temp',            &
                'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
           id_submeso(n) = register_diag_field ('ocean_model',           &
                trim(T_prog(n)%name)//'_submeso',                        &              
                Grd%tracer_axes(1:3), Time%model_time,                   &
                'rho*dzt*cp*submesoscale tendency (heating)',            &
                trim(T_prog(n)%flux_units), missing_value=missing_value, &
                range=(/-1.e10,1.e10/))
           id_submeso_on_nrho(n) = register_diag_field ('ocean_model',   &
                trim(T_prog(n)%name)//'_submeso_on_nrho',                &
                Dens%neutralrho_axes(1:3), Time%model_time,              &
                'rho*dzt*cp*submesoscale tendency (heating) binned to neutral density',&
                trim(T_prog(n)%flux_units), missing_value=missing_value, &
                range=(/-1.e20,1.e20/))

           id_xflux_subdiff(n) = register_diag_field ('ocean_model', &
                trim(T_prog(n)%name)//'_xflux_subdiff',              &
                Grd%tracer_axes_flux_x(1:3), Time%model_time,        &
                'cp*xflux_subdiff*dyt*rho_dzt*temp',                 &
                'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
           id_yflux_subdiff(n) = register_diag_field ('ocean_model', &
                trim(T_prog(n)%name)//'_yflux_subdiff',              &
                Grd%tracer_axes_flux_y(1:3), Time%model_time,        &
                'cp*yflux_subdiff*dxt*rho_dzt*temp',                 &
                'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
           id_xflux_subdiff_int_z(n) = register_diag_field ('ocean_model', &
                trim(T_prog(n)%name)//'_xflux_subdiff_int_z',              &
                Grd%tracer_axes_flux_x(1:2), Time%model_time,              &
                'z-integral cp*xflux_subdiff*dyt*rho_dzt*temp',            &
                'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
           id_yflux_subdiff_int_z(n) = register_diag_field ('ocean_model', &
                trim(T_prog(n)%name)//'_yflux_subdiff_int_z',              &
                Grd%tracer_axes_flux_y(1:2), Time%model_time,              &
                'z-integral cp*yflux_subdiff*dxt*rho_dzt*temp',            &
                'Watt', missing_value=missing_value, range=(/-1.e18,1.e18/))
           id_subdiff(n) = register_diag_field ('ocean_model',           &
                trim(T_prog(n)%name)//'_subdiff',                        &              
                Grd%tracer_axes(1:3), Time%model_time,                   &
                'rho*dzt*cp*submesoscale_diff tendency (heating)',       &
                trim(T_prog(n)%flux_units), missing_value=missing_value, &
                range=(/-1.e10,1.e10/))

       else

           id_xflux_submeso(n) = register_diag_field ('ocean_model',          &
                trim(T_prog(n)%name)//'_xflux_submeso',                       &
                Grd%tracer_axes_flux_x(1:3), Time%model_time,                 &
                'submeso_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name), &
                'kg/sec', missing_value=missing_value,                        &
                range=(/-1.e18,1.e18/))
           id_yflux_submeso(n) = register_diag_field ('ocean_model',          &
                trim(T_prog(n)%name)//'_yflux_submeso',                       &
                Grd%tracer_axes_flux_y(1:3), Time%model_time,                 &
                'submeso_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name), &
                'kg/sec', missing_value=missing_value,                        &
                range=(/-1.e18,1.e18/))
           id_zflux_submeso(n) = register_diag_field ('ocean_model',          &
                trim(T_prog(n)%name)//'_zflux_submeso',                       &
                Grd%tracer_axes_wt(1:3), Time%model_time,                     &
                'submeso_yflux*dxt*dyt*rho*tracer for'//trim(T_prog(n)%name), &
                'kg/sec', missing_value=missing_value,                        &
                range=(/-1.e18,1.e18/))
           id_xflux_submeso_int_z(n) = register_diag_field ('ocean_model',              &
                trim(T_prog(n)%name)//'_xflux_submeso_int_z',                           &
                Grd%tracer_axes_flux_x(1:2), Time%model_time,                           &
                'z-integral submeso_xflux*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),&
                'kg/sec', missing_value=missing_value,                                  &
                range=(/-1.e18,1.e18/))
           id_yflux_submeso_int_z(n) = register_diag_field ('ocean_model',              &
                trim(T_prog(n)%name)//'_yflux_submeso_int_z',                           &
                Grd%tracer_axes_flux_y(1:2), Time%model_time,                           &
                'z-integral submeso_yflux*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),&
                'kg/sec', missing_value=missing_value,                                  &
                range=(/-1.e18,1.e18/))
           id_submeso(n) = register_diag_field ('ocean_model',              &
                trim(T_prog(n)%name)//'_submeso',                           &
                Grd%tracer_axes(1:3), Time%model_time,                      &
                'rho*dzt*submesoscale tendency for '//trim(T_prog(n)%name), &
                trim(T_prog(n)%flux_units), missing_value=missing_value,    &
                range=(/-1.e10,1.e10/))
           id_submeso_on_nrho(n) = register_diag_field ('ocean_model',      &
                trim(T_prog(n)%name)//'_submeso_on_nrho',                   &
                Dens%neutralrho_axes(1:3), Time%model_time,                 &
                'rho*dzt*submesoscale tendency for '//trim(T_prog(n)%name)//' binned to neutral density', &
                trim(T_prog(n)%flux_units), missing_value=missing_value,    &
                range=(/-1.e20,1.e20/))


           id_xflux_subdiff(n) = register_diag_field ('ocean_model',          &
                trim(T_prog(n)%name)//'_xflux_subdiff',                       &
                Grd%tracer_axes_flux_x(1:3), Time%model_time,                 &
                'xflux_subdiff*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name), &
                'kg/sec', missing_value=missing_value,                        &
                range=(/-1.e18,1.e18/))
           id_yflux_subdiff(n) = register_diag_field ('ocean_model',          &
                trim(T_prog(n)%name)//'_yflux_subdiff',                       &
                Grd%tracer_axes_flux_y(1:3), Time%model_time,                 &
                'yflux_subdiff*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name), &
                'kg/sec', missing_value=missing_value,                        &
                range=(/-1.e18,1.e18/))
           id_xflux_subdiff_int_z(n) = register_diag_field ('ocean_model',              &
                trim(T_prog(n)%name)//'_xflux_subdiff_int_z',                           &
                Grd%tracer_axes_flux_x(1:2), Time%model_time,                           &
                'z-integral xflux_subdiff*dyt*rho_dzt*tracer for'//trim(T_prog(n)%name),&
                'kg/sec', missing_value=missing_value,                                  &
                range=(/-1.e18,1.e18/))
           id_yflux_subdiff_int_z(n) = register_diag_field ('ocean_model',              &
                trim(T_prog(n)%name)//'_yflux_subdiff_int_z',                           &
                Grd%tracer_axes_flux_y(1:2), Time%model_time,                           &
                'z-integral yflux_subdiff*dxt*rho_dzt*tracer for'//trim(T_prog(n)%name),&
                'kg/sec', missing_value=missing_value,                                  &
                range=(/-1.e18,1.e18/))
           id_subdiff(n) = register_diag_field ('ocean_model',                   &
                trim(T_prog(n)%name)//'_subdiff',                                &
                Grd%tracer_axes(1:3), Time%model_time,                           &
                'rho*dzt*submesoscale_diff tendency for '//trim(T_prog(n)%name), &
                trim(T_prog(n)%flux_units), missing_value=missing_value,         &
                range=(/-1.e10,1.e10/))

       endif

    enddo


end subroutine ocean_submesoscale_init
! </SUBROUTINE> NAME="ocean_submesoscale_init"


!#######################################################################
! <SUBROUTINE NAME="submeso_restrat">
!
! <DESCRIPTION>
! This routine computes a thickness and density weighted time tendency
! for each tracer, arising from the effects of parameterized 
! submesoscale eddies acting in the surface mixed layer.  
! </DESCRIPTION>
!
  subroutine submeso_restrat(Time, Thickness, Dens, T_prog, surf_blthick)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_density_type),       intent(in)    :: Dens
  type(ocean_prog_tracer_type),   intent(inout) :: T_prog(:)
  real, dimension(isd:,jsd:),     intent(in)    :: surf_blthick

  integer :: i,j,k
  integer :: tau, taum1

  if (.not. use_this_module) return

  if ( .not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_submesoscale_mode (ocean_submeso): needs initialization')
  endif 

  tau   = Time%tau
  taum1 = Time%taum1 

  ! time dependent delqc geometric factor 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           delqc(i,j,k,0) = Grd%fracdz(k,0)*Thickness%rho_dzt(i,j,k,tau)
           delqc(i,j,k,1) = Grd%fracdz(k,1)*Thickness%rho_dzt(i,j,k,tau)
        enddo
     enddo
  enddo

  ! time dependent inverse dzwt 
  do k=0,nk
     do j=jsd,jed
        do i=isd,ied
           dzwtr(i,j,k) = 1.0/Thickness%dzwt(i,j,k) 
        enddo
     enddo
  enddo

  call compute_bldepth(Time, Thickness, Dens, T_prog, surf_blthick)
  call tracer_derivs(taum1, T_prog) 
  call salinity_derivs(taum1, Dens) 

  if(use_psi_legacy) then 
     call compute_psi_legacy(Time, Dens, Thickness)
  else 
     call compute_psi(Time, Dens, Thickness)
  endif 

  if(diag_advect_transport .or. submeso_advect_flux) then 
     call compute_advect_transport(Time, Dens, Thickness)
  endif 

  ! compute tracer flux components and their convergence
  if(submeso_skew_flux) then 
      call compute_submeso_skewsion(Thickness, Dens, Time, T_prog)
  elseif(submeso_advect_flux) then
      if(submeso_advect_upwind) then  
         call compute_submeso_upwind(Time, Dens, T_prog)
      elseif(submeso_advect_sweby) then 
         call compute_submeso_sweby(Thickness, Time, Dens, T_prog)
      endif 
  endif
  call watermass_diag(Time, T_prog, Dens)


  if(submeso_diffusion) then 
      call compute_submeso_diffusion(Thickness, Dens, Time, T_prog)
  endif 
  call watermass_diag_diffusion(Time, T_prog, Dens)


end subroutine submeso_restrat
! </SUBROUTINE> NAME="submeso_restrat"



!#######################################################################
! <SUBROUTINE NAME="compute_bldepth">
!
! <DESCRIPTION>
! Compute the boundary layer depth and kblt.
! </DESCRIPTION>
!
subroutine compute_bldepth(Time, Thickness, Dens, T_prog, surf_blthick) 

  type(ocean_time_type),       intent(in) :: Time
  type(ocean_thickness_type),  intent(in) :: Thickness
  type(ocean_density_type),    intent(in) :: Dens
  type(ocean_prog_tracer_type),intent(in) :: T_prog(:)
  real, dimension(isd:,jsd:),  intent(in) :: surf_blthick

  integer :: i, j, k, tau
  integer :: num_smooth
  real    :: active_cells 

  tau  = Time%tau 
  hblt = 0.0

  if(use_hblt_constant) then 

      do j=jsc,jec
         do i=isc,iec
            hblt(i,j) = Grd%tmask(i,j,1)*min(constant_hblt, Grd%ht(i,j))
         enddo
      enddo

  elseif(use_hblt_equal_mld) then 

      call calc_mixed_layer_depth(Thickness,                &
           Dens%rho_salinity(isd:ied,jsd:jed,:,tau),        &
           T_prog(index_temp)%field(isd:ied,jsd:jed,:,tau), &
           Dens%rho(isd:ied,jsd:jed,:,tau),                 &
           Dens%pressure_at_depth(isd:ied,jsd:jed,:),       &
           hblt, smooth_mld_input=.false.)

      do j=jsc,jec
         do i=isc,iec
            hblt(i,j) = Grd%tmask(i,j,1)*min(hblt(i,j), Grd%ht(i,j))
         enddo
      enddo

  else 

      do j=jsc,jec
         do i=isc,iec
            hblt(i,j) = Grd%tmask(i,j,1)*min(surf_blthick(i,j), Grd%ht(i,j))
         enddo
      enddo

  endif

  if(smooth_hblt) then 
      do num_smooth=1,smooth_hblt_num

         wrk1_2d(:,:) = 0.0
         call mpp_update_domains(hblt(:,:), Dom%domain2d, flags=EDGEUPDATE) 
         k=1
         do j=jsc,jec
            do i=isc,iec
               if(Grd%tmask(i,j,k)==1.0) then 
                   active_cells = 4.0       +&
                        Grd%tmask(i-1,j,k)  +&
                        Grd%tmask(i+1,j,k)  +&
                        Grd%tmask(i,j-1,k)  +&
                        Grd%tmask(i,j+1,k)
                   if (active_cells > 4.0) then
! Make sure that we do not smooth to deeper than the maximum column depth. Note that if we are in water cannot have zero index
                       wrk1_2d(i,j) = & 
                            min((4.0*hblt(i,j) +&
                            hblt(i-1,j)    +&
                            hblt(i+1,j)    +&
                            hblt(i,j-1)    +&
                            hblt(i,j+1)) / active_cells, Thickness%depth_zwt(i,j,Grd%kmt(i,j)))
                   else
                       wrk1_2d(i,j) = hblt(i,j)
                   endif
               endif
            enddo
         enddo

         do j=jsc,jec
            do i=isc,iec
               hblt(i,j) = wrk1_2d(i,j)*Grd%tmask(i,j,k)  ! No reason to mask to the north
            enddo
         enddo

      enddo  ! enddo for number of smoothing iterations 
  endif  ! endif for smooth_hblt

  ! set floor to hblt 
  do j=jsc,jec
     do i=isc,iec
        hblt(i,j) = Grd%tmask(i,j,1)*max(minimum_hblt, hblt(i,j))
     enddo
  enddo

  ! halo values needed 
  call mpp_update_domains(hblt(:,:), Dom%domain2d) 


  ! k-index at bottom of hblt
  ! also move the hblt to equal depth_zwt(kblt); this is 
  ! necessary to get a full extent of the streamfunction 
  ! contained in the boundary layer. 
  kblt=0
  do j=jsd,jed
     do i=isd,ied
        if(Grd%kmt(i,j) > 1) then  
            kloop: do k=1,nk
               if(Thickness%depth_zwt(i,j,k) >= hblt(i,j)) then
                   kblt(i,j) = k
                   hblt(i,j) = Thickness%depth_zwt(i,j,k)
                   exit kloop 
               endif
            enddo kloop
        endif
     enddo
  enddo

  ! inverse front length = f/(<N> H), with H=hblt and <N> ave buoyancy freq over hblt
  if(front_length_deform_radius) then 
     front_length_inv = front_length_const_inv 
     wrk1_2d(:,:)         = epsln
     where(kblt>=min_kblt)
         buoy_freq_ave=epsln
     elsewhere
         buoy_freq_ave=0.0
     endwhere
     do k=1,maxval(kblt)
        do j=jsd,jed
           do i=isd,ied
              if(kblt(i,j) >= min_kblt .and. k<=kblt(i,j)) then
                 wrk1_2d(i,j) = wrk1_2d(i,j) + Thickness%dzt(i,j,k)  
                 buoy_freq_ave(i,j) = buoy_freq_ave(i,j) - grav_rho0r*Thickness%dzt(i,j,k)*Dens%drhodz_zt(i,j,k)  
              endif
           enddo
        enddo
     enddo
     where(kblt>=min_kblt)
        buoy_freq_ave    = sqrt(abs(buoy_freq_ave)/wrk1_2d) 
        front_length_inv = min(front_length_const_inv, coriolis_param/(epsln+wrk1_2d*buoy_freq_ave)) 
     endwhere
  endif


  ! diagnostics  
  if (id_front_length_submeso > 0) then 
      do j=jsd,jed
         do i=isd,ied
            wrk1_2d(i,j) = min(front_length_max, 1.0/(front_length_inv(i,j)+epsln))
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_front_length_submeso, wrk1_2d(:,:))
  endif 
  call diagnose_2d(Time, Grd, id_buoy_freq_ave_submeso, buoy_freq_ave(:,:))
  call diagnose_2d(Time, Grd, id_hblt_submeso, hblt(:,:))
  if (id_kblt_submeso > 0) then 
      do j=jsd,jed
         do i=isd,ied
            wrk1_2d(i,j) = kblt(i,j)
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_kblt_submeso, wrk1_2d(:,:))
  endif 


end subroutine compute_bldepth
! </SUBROUTINE> NAME="compute_bldepth"


!#######################################################################
! <SUBROUTINE NAME="tracer_derivs">
!
! <DESCRIPTION>
! Compute the tracer derivatives, with the  
! lateral derivatives computed along constant k-level.
! </DESCRIPTION>
!
subroutine tracer_derivs(taum1, T_prog)

  integer,                      intent(in) :: taum1
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)

  integer :: i, j, k, n
  integer :: kp1
  real    :: tmaski, tmaskj

  do n=1,num_prog_tracers

     dTdx(n)%field(:,:,:) = 0.0
     dTdy(n)%field(:,:,:) = 0.0
     dTdz(n)%field(:,:,:) = 0.0

     do k=1,maxval(kblt)
        kp1 = min(k+1,nk)
        do j=jsc-1,jec
           do i=isc-1,iec

              if(kblt(i,j) >= max(min_kblt,k)) then  
                  tmaski = Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)
                  tmaskj = Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)
                  dTdx(n)%field(i,j,k) = (T_prog(n)%field(i+1,j,k,taum1)-T_prog(n)%field(i,j,k,taum1)) &
                                          *Grd%dxter(i,j)*tmaski
                  dTdy(n)%field(i,j,k) = (T_prog(n)%field(i,j+1,k,taum1)-T_prog(n)%field(i,j,k,taum1)) &
                                          *Grd%dytnr(i,j)*tmaskj
              endif

           enddo
        enddo

        do j=jsd,jed
           do i=isd,ied
              if(kblt(i,j) >= max(min_kblt,k)) then  
                  dTdz(n)%field(i,j,k) = (T_prog(n)%field(i,j,k,taum1)-T_prog(n)%field(i,j,kp1,taum1)) &
                                          *Grd%tmask(i,j,kp1)*dzwtr(i,j,k)
              endif
           enddo
        enddo
     enddo

  enddo

end subroutine tracer_derivs
! </SUBROUTINE> NAME="tracer_derivs"


!#######################################################################
! <SUBROUTINE NAME="salinity_derivs">
!
! <DESCRIPTION>
! Compute the density-salinity derivatives, with lateral 
! derivative computed on constant k-level. 
! </DESCRIPTION>
!
subroutine salinity_derivs(taum1, Dens)

  integer,                      intent(in) :: taum1
  type(ocean_density_type),     intent(in) :: Dens

  integer :: i, j, k
  integer :: kp1
  real    :: tmaski, tmaskj

  dSdx%field(:,:,:) = 0.0
  dSdy%field(:,:,:) = 0.0
  dSdz%field(:,:,:) = 0.0

  do k=1,maxval(kblt)
     kp1 = min(k+1,nk)
     do j=jsc-1,jec
        do i=isc-1,iec

           if(kblt(i,j) >= max(min_kblt,k)) then  
               tmaski = Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)
               tmaskj = Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)
               dSdx%field(i,j,k) = (Dens%rho_salinity(i+1,j,k,taum1)-Dens%rho_salinity(i,j,k,taum1)) &
                                       *Grd%dxter(i,j)*tmaski
               dSdy%field(i,j,k) = (Dens%rho_salinity(i,j+1,k,taum1)-Dens%rho_salinity(i,j,k,taum1)) &
                                       *Grd%dytnr(i,j)*tmaskj
           endif

        enddo
     enddo

     do j=jsd,jed
        do i=isd,ied
           if(kblt(i,j) >= max(min_kblt,k)) then  
               dSdz%field(i,j,k) = (Dens%rho_salinity(i,j,k,taum1)-Dens%rho_salinity(i,j,kp1,taum1)) &
                                       *Grd%tmask(i,j,kp1)*dzwtr(i,j,k)
           endif
        enddo
     enddo
  enddo


end subroutine salinity_derivs
! </SUBROUTINE> NAME="salinity_derivs"


!#######################################################################
! <SUBROUTINE NAME="compute_psi">
!
! <DESCRIPTION>
! Compute the vector streamfunction from parameterized 
! submesoscale restratification. 
!
! Units of psi are m^2/sec
!
! psix is defined on north face of tracer cell for jq=0,1.
! psiy is defined on east  face of tracer cell for ip=0,1.
!
! NOTE: the mpp updates for psix and psiy are treated as a 
! scalar, whereas they are actually components to a pseudo-vector.
! Some further thought is required for the tripolar grid. We ignore
! this detail in the present implementation.  
!
! </DESCRIPTION>
!
subroutine compute_psi(Time, Dens, Thickness)

  type(ocean_time_type),      intent(in) :: Time
  type(ocean_density_type),   intent(in) :: Dens
  type(ocean_thickness_type), intent(in) :: Thickness

  real    :: gradx, grady
  real    :: tmaski, tmaskj
  real    :: gradxrho(0:1), gradyrho(0:1)
  real    :: factor, coefficient
  real    :: active_cells 
  real    :: max_psi
  real    :: abs_psi
  real    :: rescale_psi
  real    :: hblt_r
  integer :: i, j, k
  integer :: ip, jq
  integer :: tau
  integer :: num_smooth

  integer :: stdoutunit 
  stdoutunit=stdout() 

  tau = Time%tau

  ! compute depth-independent portion of vector streamfunction (m^2/sec)
  psix_horz = 0.0
  psiy_horz = 0.0
  do j=jsc,jec
     do i=isc,iec

        if(kblt(i,j) >= min_kblt) then  

            gradxrho(:) = 0.0
            gradyrho(:) = 0.0

            do k=1,kblt(i,j)
               do ip=0,1 
                  jq=ip
                  gradx        =   Dens%drhodT(i+ip,j,k)*dTdx(index_temp)%field(i,j,k) &
                                  +Dens%drhodS(i+ip,j,k)*dSdx%field(i,j,k) 
                  grady        =   Dens%drhodT(i,j+jq,k)*dTdy(index_temp)%field(i,j,k) &
                                  +Dens%drhodS(i,j+jq,k)*dSdy%field(i,j,k)
                  gradxrho(ip) = gradxrho(ip) + gradx*Thickness%dzt(i,j,k)  
                  gradyrho(jq) = gradyrho(jq) + grady*Thickness%dzt(i,j,k)  
               enddo
            enddo

            ! normalization by depth of boundary layer 
            hblt_r = 1.0/hblt(i,j)
            do ip=0,1 
               jq=ip
               gradxrho(ip) = gradxrho(ip)*hblt_r
               gradyrho(jq) = gradyrho(jq)*hblt_r
            enddo

            ! coefficient has units m^6/(sec*kg)
            coefficient = time_factor(i,j)*ce_grav_rho0r*grid_length(i,j)*front_length_inv(i,j)*hblt(i,j)**2

            k=1
            tmaski = Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)
            tmaskj = Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)
            do ip=0,1 
               jq=ip
               psix_horz(i,j,jq) = -coefficient*gradyrho(jq)*tmaskj
               psiy_horz(i,j,ip) =  coefficient*gradxrho(ip)*tmaski
            enddo

        endif ! endif for kblt(i,j) >= min_kblt

     enddo  ! i-loop
  enddo     ! j-loop


  ! rescale psi if its maximum is larger than limited value. 
  ! to be conservative, base the maximum on the upper ocean thickness.
  ! this option is useful to avoid instabilities in presence of 
  ! strong lateral density gradients.
  if(limit_psi) then 
      do j=jsc,jec
         do i=isc,iec
            if(Grd%tmask(i,j,1) > 0.0) then 

               max_psi = limit_psi_velocity_scale*Thickness%dzt(i,j,1)   

               do ip=0,1 
                  jq=ip

                  abs_psi = abs(psix_horz(i,j,jq))
                  if(abs_psi > max_psi) then 
                     rescale_psi = max_psi/(epsln+abs_psi)
                     psix_horz(i,j,jq) = rescale_psi*psix_horz(i,j,jq)
                  endif 

                  abs_psi = abs(psiy_horz(i,j,ip))
                  if(abs_psi > max_psi) then 
                     rescale_psi = max_psi/(epsln+abs_psi)
                     psiy_horz(i,j,ip) = rescale_psi*psiy_horz(i,j,ip)
                  endif 

               enddo

            endif ! endif for tmask > 0
         enddo    ! enddo for i
      enddo       ! enddo for j
  endif

  ! spatially smooth psi_horz
  if(smooth_psi) then 
      do num_smooth=1,smooth_psi_num

         call mpp_update_domains(psix_horz(:,:,:), Dom%domain2d, flags=EDGEUPDATE) 
         call mpp_update_domains(psiy_horz(:,:,:), Dom%domain2d, flags=EDGEUPDATE) 

         do ip=0,1
            jq=ip
            do k=1,1     ! to keep loop structure as in other 3d smoothers 

               wrk1_2d(:,:) = 0.0
               wrk2_2d(:,:) = 0.0
               do j=jsc,jec
                  do i=isc,iec

                     if(Grd%tmask(i,j,k)==1.0) then 

                         active_cells = 4.0       +&
                              Grd%tmask(i-1,j,k)  +&
                              Grd%tmask(i+1,j,k)  +&
                              Grd%tmask(i,j-1,k)  +&
                              Grd%tmask(i,j+1,k)

                         if (active_cells > 4.0) then
                             wrk1_2d(i,j) =               &  
                                  (4.0*psix_horz(i,j,jq) +&
                                  psix_horz(i-1,j,jq)    +&
                                  psix_horz(i+1,j,jq)    +&
                                  psix_horz(i,j-1,jq)    +&
                                  psix_horz(i,j+1,jq)) / active_cells
                             wrk2_2d(i,j) =               &
                                  (4.0*psiy_horz(i,j,ip) +&
                                  psiy_horz(i-1,j,ip)    +&
                                  psiy_horz(i+1,j,ip)    +&
                                  psiy_horz(i,j-1,ip)    +&
                                  psiy_horz(i,j+1,ip)) / active_cells

                         else
                             wrk1_2d(i,j) = psix_horz(i,j,jq)
                             wrk2_2d(i,j) = psiy_horz(i,j,ip)
                         endif

                     endif

                  enddo
               enddo

               do j=jsc,jec
                  do i=isc,iec
                     psix_horz(i,j,jq) = wrk1_2d(i,j)*Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)
                     psiy_horz(i,j,ip) = wrk2_2d(i,j)*Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)
                  enddo
               enddo

            enddo  ! k=1,1 loop
         enddo     ! ip=0,1 loop


      enddo  ! enddo for number of smoothing iterations 

  endif      ! endif for smooth_psi

  ! compute 3d vector streamfunction components by applying 
  ! dimensionless vertical structure function 0 <= wrk3 <= 1.
  psix = 0.0
  psiy = 0.0
  wrk3 = 0.0

  do k=1,maxval(kblt(isc:iec,jsc:jec))
     do j=jsc,jec
        do i=isc,iec
           if(hblt(i,j) > 0.0 .and. kblt(i,j) > min_kblt .and. k <= kblt(i,j)) then 
              hblt_r = 1.0/hblt(i,j)
              factor      = (1.0 - 2.0*Thickness%depth_zt(i,j,k)*hblt_r)**2
              wrk3(i,j,k) = (1.0 - factor)*(1.0 + fiveover21*factor) 
           endif
        enddo
     enddo
  enddo
  do ip=0,1 
     jq=ip
     do k=1,maxval(kblt(isc:iec,jsc:jec))
        do j=jsc,jec
           do i=isc,iec
              tmaski = Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)
              tmaskj = Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)
              psix(i,j,k,jq) = wrk3(i,j,k)*psix_horz(i,j,jq)*tmaskj
              psiy(i,j,k,ip) = wrk3(i,j,k)*psiy_horz(i,j,ip)*tmaski
           enddo
        enddo
     enddo
  enddo

  call mpp_update_domains(psix(:,:,:,:), Dom%domain2d, flags=SUPDATE+WUPDATE) 
  call mpp_update_domains(psiy(:,:,:,:), Dom%domain2d, flags=SUPDATE+WUPDATE) 


  ! send diagnostics 
  if (id_psix_submeso > 0) then 
     call diagnose_3d(Time, Grd, id_psix_submeso, onehalf*(psix(:,:,:,0)+psix(:,:,:,1)))
  endif 
  if (id_psiy_submeso > 0) then
     call diagnose_3d(Time, Grd, id_psiy_submeso, onehalf*(psiy(:,:,:,0)+psiy(:,:,:,1)))
  endif 
  call diagnose_3d(Time, Grd, id_mu_submeso, wrk3(:,:,:))


  if(debug_this_module) then 
      write(stdoutunit,*) ' '
      write(stdoutunit,*) 'From ocean_submeso_mod: chksums'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('psix(:,:,:,0)', psix(COMP,:,0)*Grd%tmask(COMP,:))
      call write_chksum_3d('psix(:,:,:,1)', psix(COMP,:,1)*Grd%tmask(COMP,:))
      call write_chksum_3d('psiy(:,:,:,0)', psiy(COMP,:,0)*Grd%tmask(COMP,:))
      call write_chksum_3d('psiy(:,:,:,1)', psiy(COMP,:,1)*Grd%tmask(COMP,:))
  endif


end subroutine compute_psi
! </SUBROUTINE> NAME="compute_psi"



!#######################################################################
! <SUBROUTINE NAME="compute_psi_legacy">
!
! <DESCRIPTION>
! Compute the vector streamfunction 
!
! Units of psi are m^2/sec
!
! If computing skewsion tendency, then need psi at depth_zt. 
! If computing advection tendency, then need psi at depth_zwt. 
!
! Jan2012: This scheme has problems with the limiters and smoothers.
! These problems become particularly egregious when trying to compute
! an advective flux rather than a skew flux.  This routine is 
! retained only for legacy purposes. 
! Stephen.Griffies
!
! </DESCRIPTION>
!
subroutine compute_psi_legacy(Time, Dens, Thickness)

  type(ocean_time_type),      intent(in) :: Time
  type(ocean_density_type),   intent(in) :: Dens
  type(ocean_thickness_type), intent(in) :: Thickness
  real    :: gradx, grady
  real    :: tmaski, tmaskj
  real    :: gradxrho(0:1), gradyrho(0:1)
  real    :: factor, coefficient
  real    :: active_cells 
  real    :: max_psi
  real    :: hblt_r
  integer :: i, j, k
  integer :: ip, jq
  integer :: tau

  integer :: stdoutunit 
  stdoutunit=stdout() 

  tau = Time%tau

  wrk1 = 0.0   ! depth 
  wrk2 = 0.0
  wrk3 = 0.0   ! mu_submeso

  ! vector streamfunction components
  psix = 0.0
  psiy = 0.0


  ! for holding the depths 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           wrk1(i,j,k) = Thickness%depth_zt(i,j,k) 
        enddo
     enddo
  enddo

  do j=jsd,jec
     do i=isd,iec

        if(kblt(i,j) >= min_kblt) then  

            gradxrho(:) = 0.0
            gradyrho(:) = 0.0

            do k=1,kblt(i,j)
               do ip=0,1 
                  jq=ip
                  gradx        =   Dens%drhodT(i+ip,j,k)*dTdx(index_temp)%field(i,j,k) &
                                  +Dens%drhodS(i+ip,j,k)*dSdx%field(i,j,k) 
                  grady        =   Dens%drhodT(i,j+jq,k)*dTdy(index_temp)%field(i,j,k) &
                                  +Dens%drhodS(i,j+jq,k)*dSdy%field(i,j,k)
                  gradxrho(ip) = gradxrho(ip) + gradx*Thickness%dzt(i,j,k)  
                  gradyrho(jq) = gradyrho(jq) + grady*Thickness%dzt(i,j,k)  
               enddo

            enddo   ! enddo for k=1,kblt(i,j)

            ! normalization by depth of boundary layer 
            do ip=0,1 
               jq=ip
               gradxrho(ip) = gradxrho(ip)/hblt(i,j)
               gradyrho(jq) = gradyrho(jq)/hblt(i,j)
            enddo

            ! coefficient has units m^6/(sec*kg)
            coefficient = time_factor(i,j)*ce_grav_rho0r*grid_length(i,j)*front_length_inv(i,j)*hblt(i,j)**2
            hblt_r      = 1.0/hblt(i,j)

            ! compute the vector streamfunction (m^2/sec)
            do k=1,kblt(i,j) 

               tmaski = Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)
               tmaskj = Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)

               factor      = (1.0 - 2.0*wrk1(i,j,k)*hblt_r)**2
               wrk3(i,j,k) = (1.0 - factor)*(1.0 + fiveover21*factor) 

               do ip=0,1 
                  jq=ip
                  psix(i,j,k,jq) = -coefficient*wrk3(i,j,k)*gradyrho(jq)*tmaskj
                  psiy(i,j,k,ip) =  coefficient*wrk3(i,j,k)*gradxrho(ip)*tmaski
               enddo

            enddo

        endif ! endif for kblt(i,j) >= min_kblt

     enddo
  enddo


  ! limit magnitude of psi to reduce potential for crashes 
  ! Caution: this limiter method is really wrong, as it corrupts the vertical structure
  ! function and leads to spurious jumps in the horizontal eddy induced transport.  
  if(limit_psi) then 
      do j=jsd,jec
         do i=isd,iec
            do k=1,kblt(i,j) 
               max_psi = limit_psi_velocity_scale*Thickness%dzt(i,j,k)
               do ip=0,1 
                  jq=ip
                    psix(i,j,k,jq) = sign(1.0,psix(i,j,k,jq))*min(max_psi,abs(psix(i,j,k,jq))) 
                    psiy(i,j,k,ip) = sign(1.0,psiy(i,j,k,ip))*min(max_psi,abs(psiy(i,j,k,ip))) 
               enddo
            enddo
         enddo
      enddo
  endif


  ! spatially smooth psi
  ! Caution: this smoother method is really wrong, as it corrupts the vertical structure
  ! function and leads to spurious jumps in the horizontal eddy induced transport.  
  if(smooth_psi) then 

      call mpp_update_domains(psix(:,:,:,:), Dom%domain2d) 
      call mpp_update_domains(psiy(:,:,:,:), Dom%domain2d) 

      do ip=0,1
         jq=ip
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec

                  if(Grd%tmask(i,j,k)==1.0) then 

                      active_cells = 4.0       +&
                           Grd%tmask(i-1,j,k)  +&
                           Grd%tmask(i+1,j,k)  +&
                           Grd%tmask(i,j-1,k)  +&
                           Grd%tmask(i,j+1,k)

                      if (active_cells > 4.0) then
                          wrk1(i,j,k) = & 
                               (4.0*psix(i,j,k,jq) +&
                               psix(i-1,j,k,jq)    +&
                               psix(i+1,j,k,jq)    +&
                               psix(i,j-1,k,jq)    +&
                               psix(i,j+1,k,jq)) / active_cells
                          wrk2(i,j,k) =  &
                               (4.0*psiy(i,j,k,ip) +&
                               psiy(i-1,j,k,ip)    +&
                               psiy(i+1,j,k,ip)    +&
                               psiy(i,j-1,k,ip)    +&
                               psiy(i,j+1,k,ip)) / active_cells

                      else
                          wrk1(i,j,k) = psix(i,j,k,jq)
                          wrk2(i,j,k) = psiy(i,j,k,ip)
                      endif

                  endif

               enddo
            enddo

            do j=jsc,jec
               do i=isc,iec
                  psix(i,j,k,jq) = wrk1(i,j,k)*Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)
                  psiy(i,j,k,ip) = wrk2(i,j,k)*Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)
               enddo
            enddo

         enddo
      enddo

      call mpp_update_domains(psix(:,:,:,:), Dom%domain2d) 
      call mpp_update_domains(psiy(:,:,:,:), Dom%domain2d) 

  endif


  ! send diagnostics 
  if (id_psix_submeso > 0) then 
     call diagnose_3d(Time, Grd, id_psix_submeso, onehalf*(psix(:,:,:,0)+psix(:,:,:,1)))
  endif 

  if (id_psiy_submeso > 0) then 
     call diagnose_3d(Time, Grd, id_psiy_submeso, onehalf*(psiy(:,:,:,0)+psiy(:,:,:,1)))
  endif 
  call diagnose_3d(Time, Grd, id_mu_submeso, wrk3(:,:,:))


  if(debug_this_module) then 
      write(stdoutunit,*) ' '
      write(stdoutunit,*) 'From ocean_submeso_mod: chksums'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('psix(:,:,:,0)', psix(COMP,:,0)*Grd%tmask(COMP,:))
      call write_chksum_3d('psix(:,:,:,1)', psix(COMP,:,1)*Grd%tmask(COMP,:))
      call write_chksum_3d('psiy(:,:,:,0)', psiy(COMP,:,0)*Grd%tmask(COMP,:))
      call write_chksum_3d('psiy(:,:,:,1)', psiy(COMP,:,1)*Grd%tmask(COMP,:))
  endif


end subroutine compute_psi_legacy
! </SUBROUTINE> NAME="compute_psi_legacy"


!#######################################################################
! <SUBROUTINE NAME="compute_advect_transport">
!
! <DESCRIPTION>
! Compute the mass transport from submeso.  
!
! This routine is a diagnostic routine if skewsion, and 
! part of the calculation of the eddy-induced velocity if 
! advective approach used. 
!
! Comments on the scheme:
! 
! 1/ compute vertical component from convergence of horizontal, just
! as for the vertical velocity component for the Eulerian transport.
! 
! 2/ wrho_bt_submeso(:,:,k=0) = 0.0 by definition
!
! 3/ expand the BDX_ET and BDY_NT operators for efficiency.  
!
! 4/ mask to zero those regions where the horizontal divergence 
! vanishes, as these are regions beneath the submeso boundary 
! layer.  Base the mask on horz divergence rather than kblt(i,j), 
! since any smoothing performed to uhrho_et_submeso and vhrho_nt_submeso
! will modify the region of nonzero submesoscale advection so that 
! it reaches potentially to below kblt.  
!
! </DESCRIPTION>
!
subroutine compute_advect_transport(Time, Dens, Thickness)

  type(ocean_time_type),      intent(in) :: Time
  type(ocean_density_type),   intent(in) :: Dens
  type(ocean_thickness_type), intent(in) :: Thickness

  real    :: active_cells
  real    :: deriv_x, deriv_y
  real    :: divergence_mask, divergence
  real    :: tmask_bdy
  real    :: term1, term2, hblt_r
  integer :: i, j, k, kp1
  integer :: tau
  integer :: num_smooth

  integer :: stdoutunit 
  stdoutunit=stdout() 

  tau = Time%tau

  ! compute rho*Psi according to vertical coordinate class.   
  ! compute analytic vertical derivative of structure function
  ! and multipy by psix_horz and psiy_horz.
  ! ignore vertical derivative of density for pressure vertical coordinates. 

  uhrho_et_submeso = 0.0
  vhrho_nt_submeso = 0.0
  wrk1(:,:,:) = 0.0   ! dmu/dz = vertical derivative of structure function 
  wrk2(:,:,:) = 0.0   ! to hold the rho_dzt field
  do j=jsc,jec
     do i=isc,iec
        if(kblt(i,j) > min_kblt) then 
            hblt_r = Grd%tmask(i,j,1)/(epsln+hblt(i,j))
            do k=1,kblt(i,j)
               wrk2(i,j,k) = Grd%tmask(i,j,k)*Thickness%rho_dzt(i,j,k,tau)
               term1       = (8.0/21.0)*hblt_r*(1.0 - 2.0*Thickness%depth_zt(i,j,k)*hblt_r)
               term2       = 8.0 + 5.0*(1.0-2.0*Thickness%depth_zt(i,j,k)*hblt_r)**2
               wrk1(i,j,k) = -term1*term2  
               uhrho_et_submeso(i,j,k) = -wrk2(i,j,k)*wrk1(i,j,k)*onehalf*(psiy_horz(i,j,1)+psiy_horz(i,j,0))
               vhrho_nt_submeso(i,j,k) =  wrk2(i,j,k)*wrk1(i,j,k)*onehalf*(psix_horz(i,j,1)+psix_horz(i,j,0))
            enddo
        endif  
     enddo
  enddo

  ! this option is typically not needed if limit_psi is enabled.
  if(submeso_advect_limit) then 
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               uhrho_et_submeso(i,j,k) = sign(1.0,uhrho_et_submeso(i,j,k)) &
               *min(limit_psi_velocity_scale*Thickness%rho_dzt(i,j,k,tau),abs(uhrho_et_submeso(i,j,k))) 
               vhrho_nt_submeso(i,j,k) = sign(1.0,vhrho_nt_submeso(i,j,k)) &
               *min(limit_psi_velocity_scale*Thickness%rho_dzt(i,j,k,tau),abs(vhrho_nt_submeso(i,j,k))) 
            enddo
         enddo
      enddo
  endif


  ! update domains as per C-grid fluxes 
  call mpp_update_domains(uhrho_et_submeso(:,:,:), vhrho_nt_submeso(:,:,:),&
                          Dom_flux_sub%domain2d,gridtype=CGRID_NE)


  ! apply horizontal smoother to the transport.
  ! this option is typically not be needed if smooth_psi option enabled. 
  if(smooth_advect_transport) then 
      do num_smooth = 1,smooth_advect_transport_num

         wrk1_v(:,:,:,:) = 0.0

         do k=1,nk
            do j=jsc,jec
               do i=isc,iec

                  if(Grd%tmask(i,j,k)==1.0) then 

                      active_cells = 4.0       +&
                           Grd%tmask(i-1,j,k)  +&
                           Grd%tmask(i+1,j,k)  +&
                           Grd%tmask(i,j-1,k)  +&
                           Grd%tmask(i,j+1,k)

                      if (active_cells > 4.0) then
                          wrk1_v(i,j,k,1) = & 
                          (4.0*uhrho_et_submeso(i,j,k)      +&
                               uhrho_et_submeso(i-1,j,k)    +&
                               uhrho_et_submeso(i+1,j,k)    +&
                               uhrho_et_submeso(i,j-1,k)    +&
                               uhrho_et_submeso(i,j+1,k)) / active_cells
                          wrk1_v(i,j,k,2) =  &
                          (4.0*vhrho_nt_submeso(i,j,k)      +&
                               vhrho_nt_submeso(i-1,j,k)    +&
                               vhrho_nt_submeso(i+1,j,k)    +&
                               vhrho_nt_submeso(i,j-1,k)    +&
                               vhrho_nt_submeso(i,j+1,k)) / active_cells

                      else
                          wrk1_v(i,j,k,1) = uhrho_et_submeso(i,j,k)
                          wrk1_v(i,j,k,2) = vhrho_nt_submeso(i,j,k)
                      endif

                  endif

               enddo
            enddo

            do j=jsc,jec
               do i=isc,iec
                  uhrho_et_submeso(i,j,k) = wrk1_v(i,j,k,1)*Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)
                  vhrho_nt_submeso(i,j,k) = wrk1_v(i,j,k,2)*Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)
               enddo
            enddo

         enddo

         call mpp_update_domains(uhrho_et_submeso(:,:,:), vhrho_nt_submeso(:,:,:),&
                                 Dom_flux_sub%domain2d,gridtype=CGRID_NE)

      enddo  ! enddo for number of smoothing iterations 
  endif      ! endif for smooth_advect_transport

  ! set transports to zero next to any land points, including corners.
  ! this option aims to remove what can be some "noisy" features from 
  ! the advective tendencies the occurs near land.  
  if(submeso_advect_zero_bdy) then 
      do k=1,nk
         kp1 = min(k+1,nk)
         do j=jsc,jec
            do i=isc,iec
               tmask_bdy = Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)*Grd%tmask(i-1,j,k)         &
                                           *Grd%tmask(i,j+1,k)*Grd%tmask(i,j-1,k)         &
                                           *Grd%tmask(i+1,j+1,k)*Grd%tmask(i-1,j-1,k)     &
                          *Grd%tmask(i,j,kp1)*Grd%tmask(i+1,j,kp1)*Grd%tmask(i-1,j,kp1)   &
                                           *Grd%tmask(i,j+1,kp1)*Grd%tmask(i,j-1,kp1)     &
                                           *Grd%tmask(i+1,j+1,kp1)*Grd%tmask(i-1,j-1,kp1)
               uhrho_et_submeso(i,j,k) = tmask_bdy*uhrho_et_submeso(i,j,k) 
               vhrho_nt_submeso(i,j,k) = tmask_bdy*vhrho_nt_submeso(i,j,k) 
            enddo
         enddo
      enddo
      call mpp_update_domains(uhrho_et_submeso(:,:,:), vhrho_nt_submeso(:,:,:),&
                              Dom_flux_sub%domain2d,gridtype=CGRID_NE)
  endif


  ! diagnose vertical transport. read comments given at
  ! top of this subroutine for details.
  wrho_bt_submeso(:,:,:) = 0.0
  do k=1,nk
      do j=jsc,jec
         do i=isc,iec
            deriv_x = (Grd%dyte(i,j)*uhrho_et_submeso(i,j,k) - Grd%dyte(i-1,j)*uhrho_et_submeso(i-1,j,k))*Grd%datr(i,j)
            deriv_y = (Grd%dxtn(i,j)*vhrho_nt_submeso(i,j,k) - Grd%dxtn(i,j-1)*vhrho_nt_submeso(i,j-1,k))*Grd%datr(i,j)
            divergence = deriv_x + deriv_y 
            divergence_mask = 0.0
            if(divergence /= 0.0) divergence_mask = 1.0
            wrho_bt_submeso(i,j,k) = divergence_mask*Grd%tmask(i,j,k)*(wrho_bt_submeso(i,j,k-1) + divergence)
         enddo
     enddo
  enddo


  ! send diagnostics 

  call diagnose_3d(Time, Grd, id_dmu_submeso, wrk1(:,:,:))
  call diagnose_3d(Time, Grd, id_uhrho_et_submeso, uhrho_et_submeso(:,:,:))
  call diagnose_3d(Time, Grd, id_vhrho_nt_submeso, vhrho_nt_submeso(:,:,:))
  call diagnose_3d(Time, Grd, id_wrho_bt_submeso, wrho_bt_submeso(:,:,1:nk))

  if (id_u_et_submeso > 0) then
      wrk1 = 0.0 
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               wrk1(i,j,k) = Grd%tmask(i,j,k)*uhrho_et_submeso(i,j,k) &
                             /(epsln+Thickness%rho_dzt(i,j,k,tau))
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_u_et_submeso, wrk1(:,:,:))
  endif
  if (id_v_nt_submeso > 0) then
      wrk1 = 0.0 
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               wrk1(i,j,k) = Grd%tmask(i,j,k)*vhrho_nt_submeso(i,j,k) &
                             /(epsln+Thickness%rho_dzt(i,j,k,tau))
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_v_nt_submeso, wrk1(:,:,:))
  endif
  if (id_w_bt_submeso > 0) then
      wrk1 = 0.0 
      do k=1,nk
         kp1 = min(k+1,nk)
         do j=jsd,jed
            do i=isd,ied
               wrk1(i,j,k) = Grd%tmask(i,j,k)*Grd%tmask(i,j,kp1)*Thickness%dzt(i,j,k)*wrho_bt_submeso(i,j,k) &
                             /(epsln+Thickness%rho_dzt(i,j,k,tau))
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_w_bt_submeso, wrk1(:,:,:))
  endif

  
  !  for submeso_advect_flux, tx_trans_submeso_adv = tx_trans_submeso, as for other components.
  !  for submeso_shew_flux, they are distinct.  it is useful when running with skew approach to
  !  diagnose the advective mass transports from submeso. GM has an analogous diagnostic.  
  if (id_tx_trans_submeso_adv > 0 .or. id_ty_trans_submeso_adv > 0 .or. id_tz_trans_submeso_adv > 0) then 

      wrk1_v(:,:,:,:) = 0.0
      wrk1(:,:,:)     = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1_v(i,j,k,1) = transport_convert*uhrho_et_submeso(i,j,k)*Grd%dyte(i,j)
               wrk1_v(i,j,k,2) = transport_convert*vhrho_nt_submeso(i,j,k)*Grd%dxtn(i,j)
               wrk1(i,j,k)     = transport_convert*wrho_bt_submeso(i,j,k)*Grd%dat(i,j)
            enddo
         enddo
      enddo
      if (id_tx_trans_submeso_adv > 0) then 
          used = send_data (id_tx_trans_submeso_adv, wrk1_v(:,:,:,1), &
               Time%model_time, rmask=Grd%tmask(:,:,:),               &
               is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
      endif
      if (id_ty_trans_submeso_adv > 0) then 
          used = send_data (id_ty_trans_submeso_adv, wrk1_v(:,:,:,2), &
               Time%model_time, rmask=Grd%tmask(:,:,:),               &
               is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
      endif
      if (id_tz_trans_submeso_adv > 0) then 
          used = send_data (id_tz_trans_submeso_adv, wrk1(:,:,:), &
               Time%model_time, rmask=Grd%tmask(:,:,:),           &
               is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
      endif

  endif


  ! mass transports (skew approach diagnoses transports in compute_submeso_skewsion).
  ! to compute overturning streamfunction in Ferret, do so just like the Eulerian overturning. 
  if(submeso_advect_flux) then 
      if (id_tx_trans_submeso > 0 .or. id_ty_trans_submeso > 0 .or. id_tz_trans_submeso > 0) then 

          wrk1_v = 0.0
          wrk1   = 0.0
          do k=1,nk
             do j=jsc,jec
                do i=isc,iec
                   wrk1_v(i,j,k,1) = transport_convert*uhrho_et_submeso(i,j,k)*Grd%dyte(i,j)
                   wrk1_v(i,j,k,2) = transport_convert*vhrho_nt_submeso(i,j,k)*Grd%dxtn(i,j)
                   wrk1(i,j,k)     = transport_convert*wrho_bt_submeso(i,j,k)*Grd%dat(i,j)
                enddo
             enddo
          enddo
          call diagnose_3d(Time, Grd, id_tx_trans_submeso, wrk1_v(:,:,:,1))
          call diagnose_3d(Time, Grd, id_ty_trans_submeso, wrk1_v(:,:,:,2))
          call diagnose_3d(Time, Grd, id_tz_trans_submeso, wrk1(:,:,:))

      endif
      call transport_on_nrho_submeso_adv(Time, Dens, wrk1_v(:,:,:,1), wrk1_v(:,:,:,2))  
  endif

  if (diag_step > 0) then
      if (mod(Time%itt,diag_step) == 0) then
          call maximum_bottom_w_submeso(wrho_bt_submeso(:,:,1:nk),Grd%xt,Grd%yt,Thickness%depth_zwt,rho0r,Grd%kmt)
      endif
  endif

  if(debug_this_module) then 
      write(stdoutunit,*) ' '
      write(stdoutunit,*) 'From ocean_submeso_mod: chksums for transport'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('uhrho_et_submeso', uhrho_et_submeso(COMP,:)*Grd%tmask(COMP,:))
      call write_chksum_3d('vhrho_nt_submeso', vhrho_nt_submeso(COMP,:)*Grd%tmask(COMP,:))
      call write_chksum_3d('wrho_bt_submeso', wrho_bt_submeso(COMP,1:nk)*Grd%tmask(COMP,:))
  endif

end subroutine compute_advect_transport
! </SUBROUTINE> NAME="compute_advect_transport"


!#######################################################################
! <SUBROUTINE NAME="compute_submeso_skewsion">
!
! <DESCRIPTION>
! Compute tendency from submeso skewsion. 
! </DESCRIPTION>
!
subroutine compute_submeso_skewsion(Thickness, Dens, Time, T_prog)

  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)

  real, dimension(isd:ied,jsd:jed) :: eta_tend
  real    :: eta_tend_glob
  integer :: i,j,k,n,tau

  tau = Time%tau 
  
  do n=1,num_prog_tracers

     call compute_flux_x(Time,n,T_prog(n))
     call compute_flux_y(Time,n,T_prog(n))
     call compute_flux_z(Time,n,T_prog(n))

     if (Grd%tripolar) then 
         call mpp_update_domains(flux_x(:,:,:), flux_y(:,:,:), Dom_flux_sub%domain2d, &
              gridtype=CGRID_NE) 
     endif

     ! tracer tendency (units rho*dzt * tracer concentration/sec)
     T_prog(n)%wrk1 = 0.0
    do k=1,min(maxval(kblt)+1,nk)
        do j=jsc,jec
           do i=isc,iec
              T_prog(n)%wrk1(i,j,k) = Grd%tmask(i,j,k)*(flux_z(i,j,k-1)-flux_z(i,j,k)           &
                   +(flux_x(i,j,k)-flux_x(i-1,j,k)+flux_y(i,j,k)-flux_y(i,j-1,k))*Grd%datr(i,j) &
                   )
              T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + T_prog(n)%wrk1(i,j,k)
           enddo
        enddo
     enddo

     if(id_submeso(n) > 0) then
        call diagnose_3d(Time, Grd, id_submeso(n), T_prog(n)%wrk1(:,:,:)*T_prog(n)%conversion)
     endif
     if(id_submeso_on_nrho(n) > 0) then
        call diagnose_3d_rho(Time, Dens, id_submeso_on_nrho(n), T_prog(n)%wrk1*T_prog(n)%conversion)
     endif

  enddo ! enddo for n=1,num_prog_tracers


  ! diagnose mass transports for sending to diagnostics.
  wrk1_v = 0.0
  if(vert_coordinate_class==DEPTH_BASED) then 
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1_v(i,j,k,1) = &
                    -transport_convert*onehalf*(psiy(i,j,k,0)+psiy(i,j,k,1))*Grd%dyte(i,j)*rho0
               wrk1_v(i,j,k,2) = &
                    transport_convert*onehalf*(psix(i,j,k,0)+psix(i,j,k,1))*Grd%dxtn(i,j)*rho0
            enddo
         enddo
      enddo
  else
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1_v(i,j,k,1) = &
                    -transport_convert*onehalf*(psiy(i,j,k,0)+psiy(i,j,k,1))*Grd%dyte(i,j)*Dens%rho(i,j,k,tau)
               wrk1_v(i,j,k,2) = &
                    transport_convert*onehalf*(psix(i,j,k,0)+psix(i,j,k,1))*Grd%dxtn(i,j)*Dens%rho(i,j,k,tau)
            enddo
         enddo
      enddo
  endif

  ! change signs to agree with convention used for ty_trans_gm 
  if (id_tx_trans_submeso > 0) then 
     call diagnose_3d(Time, Grd, id_tx_trans_submeso, -1.0*wrk1_v(:,:,:,1))
  endif
  if (id_ty_trans_submeso > 0) then 
     call diagnose_3d(Time, Grd, id_ty_trans_submeso, -1.0*wrk1_v(:,:,:,2))
  endif

  call transport_on_nrho_submeso(Time, Dens,-1.0*wrk1_v(:,:,:,1),-1.0*wrk1_v(:,:,:,2))  
  call transport_on_rho_submeso(Time, Dens,-1.0*wrk1_v(:,:,:,1),-1.0*wrk1_v(:,:,:,2))

  if(diagnose_eta_tend_submeso_flx) then 
      call diagnose_eta_tend_3dflux (Time, Thickness, Dens,&
           flux_x_temp(:,:,:),                             &
           flux_y_temp(:,:,:),                             &
           flux_z_temp(:,:,:),                             &
           flux_x_salt(:,:,:),                             &
           flux_y_salt(:,:,:),                             &
           flux_z_salt(:,:,:),                             &    
           eta_tend, eta_tend_glob)   

      call diagnose_2d(Time, Grd, id_eta_tend_submeso_flx, eta_tend(:,:))
      if(id_eta_tend_submeso_flx_glob > 0) then  
          used  = send_data (id_eta_tend_submeso_flx_glob, eta_tend_glob, Time%model_time)
      endif
  endif


end subroutine compute_submeso_skewsion
! </SUBROUTINE> NAME="compute_submeso_skewsion"



!#######################################################################
! <SUBROUTINE NAME="compute_flux_x">
!
! <DESCRIPTION>
!
! Subroutine computes the zonal submesoscale tracer skew flux component.
!
! fx has physical dimensions (area*diffusivity*density*tracer gradient)
!
! </DESCRIPTION>
!
subroutine compute_flux_x(Time,n,Tracer)

  type(ocean_time_type),        intent(in) :: Time
  integer,                      intent(in) :: n
  type(ocean_prog_tracer_type), intent(in) :: Tracer

  integer :: i, j, k
  integer :: ip, kr
  real    :: tensor_13(isd:ied,jsd:jed,0:1)
  real    :: sumz(isd:ied,jsd:jed,0:1)
  flux_x = 0.0


  do k=1,min(maxval(kblt(isc-1:iec,jsc:jec)),nk) ! Only need to compute in surface layer

     ! tracer-independent part of the calculation 
     tensor_13(:,:,:) = 0.0
     do ip=0,1 
        do j=jsc,jec
           do i=isc-1,iec
              tensor_13(i,j,ip) = -psiy(i,j,k,ip)
           enddo
        enddo
     enddo

     ! tracer-dependent part of the calculation
     sumz(:,:,:) = 0.0
     do kr=0,1
        do ip=0,1
           do j=jsc,jec
              do i=isc-1,iec
                 sumz(i,j,kr) = sumz(i,j,kr) + dtwedyt(i,j,ip)*Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k) &
                      *tensor_13(i,j,ip)*dTdz(n)%field(i+ip,j,k-1+kr)                              &
                      *min(delqc(i,j,k,kr),delqc(i+1,j,k,kr))
              enddo
           enddo
        enddo
     enddo
     do j=jsc,jec
        do i=isc-1,iec
           flux_x(i,j,k) = Grd%dxter(i,j)*(sumz(i,j,0)+sumz(i,j,1))
        enddo
     enddo

     if(submeso_limit_flux) then 
         do j=jsc,jec
            do i=isc-1,iec
               if(Tracer%tmask_limit(i,j,k)==1.0) then 
                   flux_x(i,j,k) = 0.0
               endif
            enddo
         enddo
     endif

  enddo   ! k-loop


  ! send fluxes to diag_manager 
  if(id_xflux_submeso(n) > 0) then 
     call diagnose_3d(Time, Grd, id_xflux_submeso(n), flux_sign*Tracer%conversion*flux_x(:,:,:))
  endif

  if(id_xflux_submeso_int_z(n) > 0) then 
      wrk1_2d = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1_2d(i,j) = wrk1_2d(i,j) + flux_x(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_xflux_submeso_int_z(n), flux_sign*Tracer%conversion*wrk1_2d(:,:))
  endif

  ! save for eta_tend diagnostics 
  if(diagnose_eta_tend_submeso_flx) then 
      if(n==index_temp) then
          flux_x_temp(:,:,:) = 0.0
          do k=1,nk
             do j=jsc,jec
                do i=isc,iec
                   flux_x_temp(i,j,k) = flux_x(i,j,k)
                enddo
             enddo
          enddo
      elseif(n==index_salt) then
          flux_x_salt(:,:,:) = 0.0
          do k=1,nk
             do j=jsc,jec
                do i=isc,iec
                   flux_x_salt(i,j,k) = flux_x(i,j,k)
                enddo
             enddo
          enddo
      endif
  endif


end subroutine compute_flux_x
! </SUBROUTINE> NAME="compute_flux_x"



!#######################################################################
! <SUBROUTINE NAME="compute_flux_y">
!
! <DESCRIPTION>
!
! Subroutine computes the meridional submesoscale tracer skew flux component.
!
! fy has physical dimensions (area*diffusivity*density*tracer gradient)
!
! </DESCRIPTION>
!
subroutine compute_flux_y(Time,n,Tracer)

  type(ocean_time_type),        intent(in) :: Time
  integer,                      intent(in) :: n
  type(ocean_prog_tracer_type), intent(in) :: Tracer

  integer :: i, j, k
  integer :: jq, kr
  real    :: tensor_23(isd:ied,jsd:jed,0:1)
  real    :: sumz(isd:ied,jsd:jed,0:1)

  flux_y = 0.0

  do k=1,min(maxval(kblt(isc:iec,jsc-1:jec))+1,nk) ! Only need to compute in surface layer

     ! tracer-independent part of the calculation 
     tensor_23(:,:,:) = 0.0
     do jq=0,1  
        do j=jsc-1,jec
           do i=isc,iec
              tensor_23(i,j,jq) = psix(i,j,k,jq)
           enddo
        enddo
     enddo

     ! tracer-dependent part of the calculation
     sumz(:,:,:) = 0.0
     do kr=0,1
        do jq=0,1
           do j=jsc-1,jec
              do i=isc,iec
                 sumz(i,j,kr) = sumz(i,j,kr) + dxtdtsn(i,j,jq)*Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k) &
                      *tensor_23(i,j,jq)*dTdz(n)%field(i,j+jq,k-1+kr)                              &
                      *min(delqc(i,j,k,kr),delqc(i,j+1,k,kr))
              enddo
           enddo
        enddo
     enddo
     do j=jsc-1,jec
        do i=isc,iec
           flux_y(i,j,k) = Grd%dytnr(i,j)*(sumz(i,j,0)+sumz(i,j,1))
        enddo
     enddo

     if(submeso_limit_flux) then 
         do j=jsc-1,jec
            do i=isc,iec
               if(Tracer%tmask_limit(i,j,k)==1.0) then 
                   flux_y(i,j,k) = 0.0
               endif
            enddo
         enddo
     endif

  enddo   ! k-loop


  ! diagnostics 
  if(id_yflux_submeso(n) > 0) then 
     call diagnose_3d(Time, Grd, id_yflux_submeso(n), flux_sign*Tracer%conversion*flux_y(:,:,:))
  endif

  if(id_yflux_submeso_int_z(n) > 0) then 
      wrk1_2d = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1_2d(i,j) = wrk1_2d(i,j) + flux_y(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_yflux_submeso_int_z(n), flux_sign*Tracer%conversion*wrk1_2d(:,:))
  endif

  ! save for eta_tend diagnostics 
  if(diagnose_eta_tend_submeso_flx) then 
      if(n==index_temp) then
          flux_y_temp(:,:,:) = 0.0
          do k=1,nk
             do j=jsc,jec
                do i=isc,iec
                   flux_y_temp(i,j,k) = flux_y(i,j,k)
                enddo
             enddo
          enddo
      elseif(n==index_salt) then
          flux_y_salt(:,:,:) = 0.0
          do k=1,nk
             do j=jsc,jec
                do i=isc,iec
                   flux_y_salt(i,j,k) = flux_y(i,j,k)
                enddo
             enddo
          enddo
      endif
  endif


end subroutine compute_flux_y
! </SUBROUTINE> NAME="compute_flux_y"


!#######################################################################
! <SUBROUTINE NAME="compute_flux_z">
!
! <DESCRIPTION>
!
! Subroutine computes the vertical submeso tracer skew flux component.
!
! Surface and bottom boundary condition fz(k=0)=fz(k=kmt(i,j))=0
!
! fz has physical dimensions (density*diffusivity*tracer gradient)
!
! </DESCRIPTION>
!
subroutine compute_flux_z(Time,n,Tracer)

  type(ocean_time_type),        intent(in) :: Time
  integer,                      intent(in) :: n
  type(ocean_prog_tracer_type), intent(in) :: Tracer

  integer :: i, j, k, ip, jq, kr
  real :: sumx_0, sumx_1, sumy_0, sumy_1
  real :: temparray31(isc:iec,jsc:jec,0:1,0:1)
  real :: temparray32(isc:iec,jsc:jec,0:1,0:1)
  real :: tensor_31(isd:ied,jsd:jed,0:1)
  real :: tensor_32(isd:ied,jsd:jed,0:1)

  flux_z      = 0.0
  tensor_31   = 0.0
  tensor_32   = 0.0
  temparray31 = 0.0
  temparray32 = 0.0

  do k=1,min(maxval(kblt(isc-1:iec,jsc-1:jec)),nk-1) ! Only need to compute in surface layer

     do ip=0,1
        jq=ip  
        do j=jsc-1,jec
           do i=isc-1,iec
              tensor_31(i,j,ip) =  psiy(i,j,k,ip)
              tensor_32(i,j,jq) = -psix(i,j,k,jq)
           enddo
        enddo
     enddo

     do kr=0,1

        do ip=0,1
           do j=jsc,jec
              do i=isc,iec
                 temparray31(i,j,ip,kr) = tensor_31(i,j,ip)*dtew(i,j,ip) &
                      *min(delqc(i-1+ip,j,k+kr,1-kr),delqc(i+ip,j,k+kr,1-kr))
              enddo
           enddo
        enddo
        do jq=0,1
           do j=jsc,jec
              do i=isc,iec
                 temparray32(i,j,jq,kr) = tensor_32(i,j,jq)*dtns(i,j,jq) &
                      *min(delqc(i,j-1+jq,k+kr,1-kr),delqc(i,j+jq,k+kr,1-kr))  
              enddo
           enddo
        enddo

     enddo

     do j=jsc,jec
        do i=isc,iec
           sumx_0 =  temparray31(i,j,0,0)*dTdx(n)%field(i-1,j,k) &
                  +  temparray31(i,j,0,1)*dTdx(n)%field(i-1,j,k+1)
           sumx_1 =  temparray31(i,j,1,0)*dTdx(n)%field(i,j,k)   &
                  +  temparray31(i,j,1,1)*dTdx(n)%field(i,j,k+1)
           sumy_0 =  temparray32(i,j,0,0)*dTdy(n)%field(i,j-1,k) &
                  +  temparray32(i,j,0,1)*dTdy(n)%field(i,j-1,k+1)
           sumy_1 =  temparray32(i,j,1,0)*dTdy(n)%field(i,j,k)   &
                  +  temparray32(i,j,1,1)*dTdy(n)%field(i,j,k+1)

           flux_z(i,j,k) = Grd%tmask(i,j,k+1)                                      &
                *( Grd%dxtr(i,j)*(sumx_0+sumx_1) + Grd%dytr(i,j)*(sumy_0+sumy_1) ) &
                *dzwtr(i,j,k)

        enddo
     enddo

     if(submeso_limit_flux) then 
         do j=jsc,jec
            do i=isc,iec
               if(Tracer%tmask_limit(i,j,k)==1.0) then 
                   flux_z(i,j,k) = 0.0
               endif
            enddo
         enddo
     endif


  enddo   ! end of k=1,nk-1 loop


  ! diagnostics 
  if(id_zflux_submeso(n) > 0) then 
      wrk2 = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk2(i,j,k) = Grd%dat(i,j)*flux_z(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_zflux_submeso(n), flux_sign*Tracer%conversion*wrk2(:,:,1:nk))
  endif

  ! save for eta_tend diagnostics 
  if(diagnose_eta_tend_submeso_flx) then 
      if(n==index_temp) then
          flux_z_temp(:,:,:) = 0.0
          do k=1,nk
             do j=jsc,jec
                do i=isc,iec
                   flux_z_temp(i,j,k) = flux_z(i,j,k)
                enddo
             enddo
          enddo
      elseif(n==index_salt) then
          flux_z_salt(:,:,:) = 0.0
          do k=1,nk
             do j=jsc,jec
                do i=isc,iec
                   flux_z_salt(i,j,k) = flux_z(i,j,k)
                enddo
             enddo
          enddo
      endif
  endif

end subroutine compute_flux_z
! </SUBROUTINE> NAME="compute_flux_z"


!#######################################################################
! <SUBROUTINE NAME="compute_submeso_upwind">
!
! <DESCRIPTION>
! First order upwind to compute the tendency from submeso advection.
!
! Although this method adds diffusion, some of the mixing 
! is physically relevant. Absent this mixing, the submesoscale 
! parameterization is incomplete. The submesoscale parameterization is, 
! afterall, active only in the mixed layer, where there is lot of 
! physical mixing.  
!
! Use of first order upwind ensures that the tendency computed
! from submesoscale parameterization will not, in principle, 
! introduce extrema. However, there remain some issues with large
! tendencies appearing near boundaries that may compromise this 
! monotonicity property.   
!
! Apply masks so that there is no flux leaving cell next to bottom.  
!
! </DESCRIPTION>
!
subroutine compute_submeso_upwind(Time, Dens, T_prog)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)

  real,dimension(isc:iec,jsc:jec) :: ft1
  real,dimension(isc:iec,jsc:jec) :: ft2
  real,dimension(isc:iec,jsc:jec) :: fe
  real,dimension(isc:iec,jsc:jec) :: fn

  integer  :: i, j, k, n, kp1, kp2
  integer  :: tau, taum1
  real     :: velocity, upos, uneg, wpos, wneg

  tau     = Time%tau
  taum1   = Time%taum1

  ! do loop over all tracers 
  do n=1,num_prog_tracers

     ! initialize some arrays 
     advect_tendency(:,:,:) = 0.0
     flux_x(:,:,:)          = 0.0
     flux_y(:,:,:)          = 0.0
     flux_z(:,:,:)          = 0.0

     ! vertical flux divergence 
     ft1 = 0.0
     do k=1,nk
        kp1 = min(k+1,nk)
        kp2 = min(k+2,nk)
        do j=jsc,jec
           do i=isc,iec
              velocity = 0.5*wrho_bt_submeso(i,j,k)
              wpos     = velocity + abs(velocity) 
              wneg     = velocity - abs(velocity) 
              ft2(i,j) = (wneg*T_prog(n)%field(i,j,k,taum1) + wpos*T_prog(n)%field(i,j,kp1,taum1)) &
                         *Grd%tmask(i,j,k)*Grd%tmask(i,j,kp1)*Grd%tmask(i,j,kp2)
              advect_tendency(i,j,k) = Grd%tmask(i,j,k)*(ft1(i,j)-ft2(i,j))
              ft1(i,j) = ft2(i,j)
              flux_z(i,j,k) = Grd%dat(i,j)*ft2(i,j)
           enddo
        enddo
     enddo

     ! horizontal fluxes
     do k=1,nk 
        kp1 = min(k+1,nk)
 
        ! i-flux
        do j=jsc,jec
           do i=isc-1,iec
              velocity = 0.5*uhrho_et_submeso(i,j,k)
              upos     = velocity + abs(velocity)
              uneg     = velocity - abs(velocity)
              fe(i,j)  = Grd%dyte(i,j)*(upos*T_prog(n)%field(i,j,k,taum1) + uneg*T_prog(n)%field(i+1,j,k,taum1)) &
                         *Grd%tmask(i,j,k)*Grd%tmask(i+1,j,k)*Grd%tmask(i,j,kp1)*Grd%tmask(i+1,j,kp1)
              flux_x(i,j,k) = fe(i,j)
           enddo
        enddo

        ! j-flux
        do j=jsc-1,jec
           do i=isc,iec
              velocity = 0.5*vhrho_nt_submeso(i,j,k)
              upos     = velocity + abs(velocity)
              uneg     = velocity - abs(velocity)
              fn(i,j)  = Grd%dxtn(i,j)*(upos*T_prog(n)%field(i,j,k,taum1) + uneg*T_prog(n)%field(i,j+1,k,taum1)) &
                         *Grd%tmask(i,j,k)*Grd%tmask(i,j+1,k)*Grd%tmask(i,j,kp1)*Grd%tmask(i,j+1,kp1)
              flux_y(i,j,k) = fn(i,j)
           enddo
        enddo

     enddo  ! k-loop completed

     ! needed for tripolar 
     call mpp_update_domains(flux_x(:,:,:), flux_y(:,:,:), Dom_flux_sub%domain2d, gridtype=CGRID_NE) 

 
     ! advect_tendency is a divergence; minus sign produces a convergence needed for tendency 
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              advect_tendency(i,j,k) = advect_tendency(i,j,k) + &
              Grd%tmask(i,j,k)*(flux_x(i,j,k)-flux_x(i-1,j,k)+flux_y(i,j,k)-flux_y(i,j-1,k))*Grd%datr(i,j)
              T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) - advect_tendency(i,j,k)
           enddo
        enddo
     enddo


     ! send fluxes to diag_manager 
     if(id_xflux_submeso(n) > 0) then 
        call diagnose_3d(Time, Grd, id_xflux_submeso(n), flux_sign*T_prog(n)%conversion*flux_x(:,:,:))
     endif
     if(id_xflux_submeso_int_z(n) > 0) then 
         wrk1_2d = 0.0
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  wrk1_2d(i,j) = wrk1_2d(i,j) + flux_x(i,j,k)
               enddo
            enddo
         enddo
         call diagnose_2d(Time, Grd, id_xflux_submeso_int_z(n), flux_sign*T_prog(n)%conversion*wrk1_2d(:,:))
     endif

     if(id_yflux_submeso(n) > 0) then 
        call diagnose_3d(Time, Grd, id_yflux_submeso(n), flux_sign*T_prog(n)%conversion*flux_y(:,:,:))
     endif
     if(id_yflux_submeso_int_z(n) > 0) then 
         wrk1_2d = 0.0
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  wrk1_2d(i,j) = wrk1_2d(i,j) + flux_y(i,j,k)
               enddo
            enddo
         enddo
         call diagnose_2d(Time, Grd, id_yflux_submeso_int_z(n), flux_sign*T_prog(n)%conversion*wrk1_2d(:,:))
     endif

     ! sans the (1:nk) argument in flux_z, the diagnostics output spuriously has flux_z(k=1)=0.0.
     if(id_zflux_submeso(n) > 0) then 
        call diagnose_3d(Time, Grd, id_zflux_submeso(n), flux_sign*T_prog(n)%conversion*flux_z(:,:,1:nk))
     endif
     
     ! minus sign produces a convergence rather than divergence, 
     ! which is consistent with upwind computed in tracer_advect module.       
     if(id_submeso(n) > 0) then 
        call diagnose_3d(Time, Grd, id_submeso(n), -advect_tendency(:,:,:)*T_prog(n)%conversion)
     endif
     if(id_submeso_on_nrho(n) > 0) then
        call diagnose_3d_rho(Time, Dens, id_submeso_on_nrho(n), -advect_tendency*T_prog(n)%conversion)
     endif


  enddo ! end of tracer n-loop
  
end subroutine compute_submeso_upwind
! </SUBROUTINE> NAME="compute_submeso_upwind"



!#######################################################################
! <SUBROUTINE NAME="compute_submeso_sweby">
!
! <DESCRIPTION>
! Sweby scheme to compute the tendency from submeso advection.
! Algorithm taken after advect_tracer_sweby_all in the module
! ocean_tracers/ocean_tracer_advect.F90.
!
! Jan 2012: Stephen.Griffies
! This scheme has known bugs; it is not meant for general use. 
!
! </DESCRIPTION>
!
subroutine compute_submeso_sweby(Thickness, Time, Dens, T_prog)

  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)

  real,dimension(isc:iec,jsc:jec) :: ftp
  real,dimension(isc:iec,jsc:jec) :: fbt
  real,dimension(isc:iec,jsc:jec) :: wkm1

  integer  :: i, j, k, n
  integer  :: kp1, kp2, km1
  integer  :: tau, taum1
  real     :: Rjm, Rj, Rjp, cfl, massflux
  real     :: d0, d1, thetaP, psiP 
  real     :: thetaM, psiM

  tau     = Time%tau
  taum1   = Time%taum1
  flux_x  = 0.0
  flux_y  = 0.0
  flux_z  = 0.0
  wrk1    = 0.0

  ! calculate flux at bottom face of the T-cells
  do n=1,num_prog_tracers

     ftp  = 0.0
     fbt  = 0.0
     wkm1 = 0.0

     do k=1,nk
        do j=jsd,jed
           do i=isd,ied
              T_prog(n)%wrk1(i,j,k) = 0.0
           enddo
        enddo
     enddo

     do k=1,nk

        do j=jsc,jec
           do i=isc,iec
              tracer_mdfl_all(n)%field(i,j,k) = T_prog(n)%field(i,j,k,taum1)
           enddo
        enddo

        kp1 = min(k+1,nk)
        kp2 = min(k+2,nk)
        km1 = max(k-1,1)

        do j=jsc,jec
           do i=isc,iec

              Rjp = (T_prog(n)%field(i,j,km1,taum1) - T_prog(n)%field(i,j,k,taum1))    &
                   *tmask_mdfl(i,j,km1)*tmask_mdfl(i,j,k)
              Rj  = (T_prog(n)%field(i,j,k,taum1) - T_prog(n)%field(i,j,kp1,taum1))    &
                   *tmask_mdfl(i,j,k)*tmask_mdfl(i,j,kp1)
              Rjm = (T_prog(n)%field(i,j,kp1,taum1) - T_prog(n)%field(i,j,kp2,taum1))  &
                   *tmask_mdfl(i,j,kp1)*tmask_mdfl(i,j,kp2)

              massflux = Grd%dat(i,j) * wrho_bt_submeso(i,j,k)
              cfl = abs(wrho_bt_submeso(i,j,k) * dtime  / Thickness%rho_dzt(i,j,k,tau))
              d0 = (2.0 - cfl) * (1.0 - cfl) * onesixth
              d1 = (1.0 - cfl * cfl) * onesixth

              thetaP = Rjm / (1.0e-30 + Rj)
              thetaM = Rjp / (1.0e-30 + Rj)

              psiP = max(0.0, min(min(1.0, d0 + d1 * thetaP),       &
                   (1.0 - cfl) / (1.0e-30 + cfl) * thetaP ) )
              psiM = max(0.0, min(min(1.0, d0 + d1 * thetaM),       &
                   (1.0 - cfl) / (1.0e-30 + cfl) * thetaM ) )

              fbt(i,j) =  0.5 * ( ( massflux + abs(massflux) )         &
                   * ( T_prog(n)%field(i,j,kp1,taum1) + psiP * Rj )    &
                   + ( massflux - abs(massflux) )                      &
                   * ( T_prog(n)%field(i,j, k ,taum1) - psiM * Rj ) )  &
                   * tmask_mdfl(i,j,kp1) * tmask_mdfl(i,j,k)

              wrk1(i,j,k) = Grd%datr(i,j)*( fbt(i,j) - ftp(i,j))     &
                   + T_prog(n)%field(i,j,k,taum1)*(wkm1(i,j) - wrho_bt_submeso(i,j,k)) 

              tracer_mdfl_all(n)%field(i,j,k) = tracer_mdfl_all(n)%field(i,j,k)  &
                   + wrk1(i,j,k) * dtime/Thickness%rho_dzt(i,j,k,tau) 

              flux_z(i,j,k) = fbt(i,j)
              ftp(i,j)      = fbt(i,j)

           enddo
        enddo

        ! update vertical velocity for next k-level
        do j=jsc,jec
           do i=isc,iec
              wkm1(i,j) = wrho_bt_submeso(i,j,k)
           enddo
        enddo

     enddo ! end of k-loop

     call mpp_update_domains (tracer_mdfl_all(n)%field(:,:,:), Dom_mdfl%domain2d, &
                              flags=XUPDATE, complete=T_prog(n)%complete)

  enddo ! end of n-loop for tracers  


  ! calculate flux at the eastern face of the T-cells
  do n=1,num_prog_tracers

     do k=1,nk

        do j=jsc,jec
           do i=isc-1,iec

              Rjp = (tracer_mdfl_all(n)%field(i+2,j,k) - tracer_mdfl_all(n)%field(i+1,j,k))    &
                   *tmask_mdfl(i+2,j,k)*tmask_mdfl(i+1,j,k)
              Rj  = (tracer_mdfl_all(n)%field(i+1,j,k) - tracer_mdfl_all(n)%field( i ,j,k) )   &
                   *tmask_mdfl(i+1,j,k)*tmask_mdfl(i,j,k)
              Rjm = (tracer_mdfl_all(n)%field(i,j,k) - tracer_mdfl_all(n)%field(i-1,j,k))      &
                   *tmask_mdfl(i,j,k)*tmask_mdfl(i-1,j,k)

              massflux = Grd%dyte(i,j) * uhrho_et_submeso(i,j,k)
              cfl = abs(uhrho_et_submeso(i,j,k) * dtime * 2.0    &
                   / ((Thickness%rho_dzt(i,j,k,tau) + Thickness%rho_dzt(i+1,j,k,tau)) * Grd%dxte(i,j)))
              d0 = (2.0 - cfl) * (1.0 - cfl) * onesixth
              d1 = (1.0 - cfl * cfl) * onesixth

              thetaP = Rjm / (1.0e-30 + Rj)
              thetaM = Rjp / (1.0e-30 + Rj)

              psiP = max(0.0, min(min(1.0, d0 + d1 * thetaP),  &
                   (1.0 - cfl) / (1.0e-30 + cfl) * thetaP ) )
              psiM = max(0.0, min(min(1.0, d0 + d1 * thetaM),  &
                   (1.0 - cfl) / (1.0e-30 + cfl) * thetaM ) )

              flux_x(i,j,k) =  0.5 * ( ( massflux + abs(massflux) )      &
                   * ( tracer_mdfl_all(n)%field( i ,j,k) + psiP * Rj )   &
                   + ( massflux - abs(massflux) )                        &
                   * ( tracer_mdfl_all(n)%field(i+1,j,k) - psiM * Rj ) ) &
                   * tmask_mdfl(i,j,k) * tmask_mdfl(i+1,j,k)
           enddo
        enddo

        ! update the tracer
        do j=jsc,jec
           do i=isc,iec
              wrk1(i,j,k) = tmask_mdfl(i,j,k) * Grd%datr(i,j)       &
                   * (flux_x(i-1,j,k) - flux_x(i,j,k)               &
                   + T_prog(n)%field(i,j,k,taum1)* (                &
                     Grd%dyte(i,j)   * uhrho_et_submeso( i ,j,k)    &
                   - Grd%dyte(i-1,j) * uhrho_et_submeso(i-1,j,k) ) )

              tracer_mdfl_all(n)%field(i,j,k) = tracer_mdfl_all(n)%field(i,j,k) &
                   + wrk1(i,j,k)*dtime/Thickness%rho_dzt(i,j,k,tau)
           enddo
        enddo

     enddo ! end of k-loop

     call mpp_update_domains (tracer_mdfl_all(n)%field(:,:,:), Dom_mdfl%domain2d, &
                              flags=YUPDATE, complete=T_prog(n)%complete)

  enddo ! end of n-loop for tracers  


  ! calculate flux at the northern face of the T-cells 
  do n=1,num_prog_tracers 

     do j=jsc,jec
        do i=isc,iec
           wkm1(i,j) = 0.0
        enddo
     enddo

     do k=1,nk

        do j=jsc-1,jec
           do i=isc,iec

              Rjp = (tracer_mdfl_all(n)%field(i,j+2,k) - tracer_mdfl_all(n)%field(i,j+1,k))   &
                   *tmask_mdfl(i,j+2,k)*tmask_mdfl(i,j+1,k)
              Rj  = (tracer_mdfl_all(n)%field(i,j+1,k) - tracer_mdfl_all(n)%field(i,j,k))     &
                   *tmask_mdfl(i,j+1,k)*tmask_mdfl(i,j,k)
              Rjm = (tracer_mdfl_all(n)%field(i,j,k)   - tracer_mdfl_all(n)%field(i,j-1,k))   &
                   *tmask_mdfl(i,j,k)*tmask_mdfl(i,j-1,k)

              massflux = Grd%dxtn(i,j) * vhrho_nt_submeso(i,j,k)
              cfl = abs(vhrho_nt_submeso(i,j,k) * dtime * 2.0              &
                   / ((Thickness%rho_dzt(i,j,k,tau) + Thickness%rho_dzt(i,j+1,k,tau)) * Grd%dytn(i,j)))
              d0 = (2.0 - cfl) * (1.0 - cfl) * onesixth
              d1 = (1.0 - cfl * cfl) * onesixth

              thetaP = Rjm / (1.0e-30 + Rj)
              thetaM = Rjp / (1.0e-30 + Rj)

              psiP = max(0.0, min(min(1.0, d0 + d1 * thetaP),   &
                   (1.0 - cfl) / (1.0e-30 + cfl) * thetaP ) )
              psiM = max(0.0, min(min(1.0, d0 + d1 * thetaM),   &
                   (1.0 - cfl) / (1.0e-30 + cfl) * thetaM ) )

              flux_y(i,j,k) =  0.5 * ( ( massflux + abs(massflux) )       &
                   * ( tracer_mdfl_all(n)%field(i,j,k) + psiP * Rj )      &
                   + ( massflux - abs(massflux) )                         &
                   * ( tracer_mdfl_all(n)%field(i,j+1,k) - psiM * Rj ) )  &
                   * tmask_mdfl(i,j,k) * tmask_mdfl(i,j+1,k)

           enddo
        enddo

        ! calculate the overall tendency (advection convergence) and update tracer 
        do j=jsc,jec
           do i=isc,iec

              wrk1(i,j,k) = tmask_mdfl(i,j,k)*Grd%datr(i,j)*(flux_y(i,j-1,k)-flux_y(i,j,k))  &
                            + T_prog(n)%field(i,j,k,taum1) *                                 &
                   (wrho_bt_submeso(i,j,k) - wkm1(i,j)                                       &
                   + Grd%datr(i,j)*                                                          &
                   ( Grd%dyte(i-1,j) * uhrho_et_submeso(i-1,j,k)                             &
                   - Grd%dyte( i ,j) * uhrho_et_submeso( i ,j,k)))

              tracer_mdfl_all(n)%field(i,j,k) = tracer_mdfl_all(n)%field(i,j,k) &
                                              + wrk1(i,j,k)*dtime/Thickness%rho_dzt(i,j,k,tau)

              T_prog(n)%wrk1(i,j,k) = &
                Thickness%rho_dzt(i,j,k,tau)*(tracer_mdfl_all(n)%field(i,j,k)-T_prog(n)%field(i,j,k,taum1))/dtime  &
                   *tmask_mdfl(i,j,k) 

           enddo
        enddo

        do j=jsc,jec
           do i=isc,iec
              T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + T_prog(n)%wrk1(i,j,k)
          enddo
        enddo

        ! update vertical velocity for next level
        do j=jsc,jec
           do i=isc,iec
              wkm1(i,j) = wrho_bt_submeso(i,j,k)
           enddo
        enddo

     enddo ! end of k-loop



     ! send fluxes to diag_manager 
     if(id_xflux_submeso(n) > 0) then 
        call diagnose_3d(Time, Grd, id_xflux_submeso(n), flux_sign*T_prog(n)%conversion*flux_x(:,:,:))
     endif
     if(id_xflux_submeso_int_z(n) > 0) then 
         wrk1_2d = 0.0
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  wrk1_2d(i,j) = wrk1_2d(i,j) + flux_x(i,j,k)
               enddo
            enddo
         enddo
         call diagnose_2d(Time, Grd, id_xflux_submeso_int_z(n), flux_sign*T_prog(n)%conversion*wrk1_2d(:,:))
     endif

     if(id_yflux_submeso(n) > 0) then 
        call diagnose_3d(Time, Grd, id_yflux_submeso(n), flux_sign*T_prog(n)%conversion*flux_y(:,:,:))
     endif
     if(id_yflux_submeso_int_z(n) > 0) then 
         wrk1_2d = 0.0
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  wrk1_2d(i,j) = wrk1_2d(i,j) + flux_y(i,j,k)
               enddo
            enddo
         enddo
         call diagnose_2d(Time, Grd, id_yflux_submeso_int_z(n), flux_sign*T_prog(n)%conversion*wrk1_2d(:,:))
     endif

     if(id_zflux_submeso(n) > 0) then 
         wrk2 = 0.0
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  wrk2(i,j,k) = Grd%dat(i,j)*flux_z(i,j,k)
               enddo
            enddo
         enddo
         call diagnose_3d(Time, Grd, id_zflux_submeso(n), flux_sign*T_prog(n)%conversion*wrk2(:,:,1:nk))
     endif
     
     if(id_submeso(n) > 0) then
        call diagnose_3d(Time, Grd, id_submeso(n), T_prog(n)%wrk1(:,:,:)*T_prog(n)%conversion)
     endif

     if(id_submeso_on_nrho(n) > 0) then
        call diagnose_3d_rho(Time, Dens, id_submeso_on_nrho(n), T_prog(n)%wrk1*T_prog(n)%conversion)
     endif


  enddo ! end of n-loop
  
end subroutine compute_submeso_sweby
! </SUBROUTINE> NAME="compute_submeso_sweby"


!#######################################################################
! <SUBROUTINE NAME="compute_submeso_diffusion">
!
! <DESCRIPTION>
! Compute tendency from submeso horizontal diffusion.
! </DESCRIPTION>
!
subroutine compute_submeso_diffusion(Thickness, Dens, Time, T_prog)

  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)

  real, dimension(isd:ied,jsd:jed)    :: eta_tend
  real, dimension(isd:ied,jsd:jed)    :: fe
  real, dimension(isd:ied,jsd:jed)    :: fn
  real, dimension(isd:ied,jsd:jed,nk) :: del2_tracer 
  real    :: eta_tend_glob
  integer :: i,j,k,n,tau

  tau = Time%tau 

  ! compute effective horizontal diffusivity (m^2/sec)
  wrk1(:,:,:) = 0.0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = onefourth*Grd%tmask(i,j,k) &
                         *(psix(i,j,k,0)**2 + psix(i,j,k,1)**2 + psiy(i,j,k,0)**2 + psiy(i,j,k,1)**2) 
           wrk1(i,j,k) = submeso_diffusion_scale*(wrk1(i,j,k)**0.5)
        enddo
     enddo
  enddo

  ! biharmonic mixing coefficient (m^4/sec) = laplacian(m^2/sec) * horz_area(m^2) 
  if(submeso_diffusion_biharmonic) then 
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1(i,j,k) = wrk1(i,j,k)*grid_length(i,j)**2
            enddo
         enddo
      enddo
  endif


  ! compute tendency from horizontal mixing in submeso boundary layer 
  do n=1,num_prog_tracers


     if(submeso_diffusion_biharmonic) then 

         ! del2_tracer = laplacian operator with unit diffusivity.
         ! del2_tracer has units (tracer concentration / m^2) 
         del2_tracer(:,:,:) = 0.0 
         do k=1,nk
            fe(:,:) = dTdx(n)%field(:,:,k)*FMX(Thickness%rho_dzt(:,:,k,tau)*Grd%tmask(:,:,k))
            fn(:,:) = dTdy(n)%field(:,:,k)*FMY(Thickness%rho_dzt(:,:,k,tau)*Grd%tmask(:,:,k))
            del2_tracer(:,:,k) = &
            Grd%tmask(:,:,k)*(BDX_ET(fe(:,:)) + BDY_NT(fn(:,:)))/(epsln+Thickness%rho_dzt(:,:,k,tau))
         enddo
         call mpp_update_domains (del2_tracer, Dom%domain2d)

         ! compute biharmonic tracer flux components. 
         ! fluxes have dimensions (area*diffusivity*density*tracer gradient)
         flux_x = 0.0
         flux_y = 0.0
         do k=1,nk
            flux_x(:,:,k) = &
              -wrk1(:,:,k)*Grd%dyte(:,:)*FDX_T(del2_tracer(:,:,k))*FMX(Thickness%rho_dzt(:,:,k,tau)*Grd%tmask(:,:,k))
            flux_y(:,:,k) = &
              -wrk1(:,:,k)*Grd%dxtn(:,:)*FDY_T(del2_tracer(:,:,k))*FMY(Thickness%rho_dzt(:,:,k,tau)*Grd%tmask(:,:,k))
         enddo

     else  

         ! laplacian tracer flux components. 
         ! fluxes have dimensions (area*diffusivity*density*tracer gradient)
         flux_x = 0.0
         flux_y = 0.0
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  flux_x(i,j,k) = wrk1(i,j,k)*Thickness%rho_dzt(i,j,k,tau)*Grd%dyte(i,j)*dTdx(n)%field(i,j,k)
                  flux_y(i,j,k) = wrk1(i,j,k)*Thickness%rho_dzt(i,j,k,tau)*Grd%dxtn(i,j)*dTdy(n)%field(i,j,k)
               enddo
            enddo
         enddo

     endif

     call mpp_update_domains(flux_x(:,:,:), flux_y(:,:,:), Dom_flux_sub%domain2d, gridtype=CGRID_NE) 


     ! tracer tendency (units rho*dzt * tracer concentration/sec)
     T_prog(n)%wrk1(:,:,:) = 0.0
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              T_prog(n)%wrk1(i,j,k) = Grd%tmask(i,j,k) &
               *(flux_x(i,j,k)-flux_x(i-1,j,k)+flux_y(i,j,k)-flux_y(i,j-1,k))*Grd%datr(i,j)
              T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + T_prog(n)%wrk1(i,j,k)
           enddo
        enddo
     enddo


     ! diagnostics

     if(id_subdiff(n) > 0) then 
        call diagnose_3d(Time, Grd, id_subdiff(n), T_prog(n)%wrk1(:,:,:)*T_prog(n)%conversion)
     endif
     if(id_xflux_subdiff(n) > 0) then 
        call diagnose_3d(Time, Grd, id_xflux_subdiff(n), flux_sign*T_prog(n)%conversion*flux_x(:,:,:))
     endif

     if(id_xflux_subdiff_int_z(n) > 0) then 
         wrk1_2d = 0.0
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  wrk1_2d(i,j) = wrk1_2d(i,j) + flux_x(i,j,k)
               enddo
            enddo
         enddo
         call diagnose_2d(Time, Grd, id_xflux_subdiff_int_z(n), flux_sign*T_prog(n)%conversion*wrk1_2d(:,:))
     endif

     if(id_yflux_subdiff(n) > 0) then 
        call diagnose_3d(Time, Grd, id_yflux_subdiff(n), flux_sign*T_prog(n)%conversion*flux_y(:,:,:))
     endif
     if(id_yflux_subdiff_int_z(n) > 0) then 
         wrk1_2d = 0.0
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  wrk1_2d(i,j) = wrk1_2d(i,j) + flux_y(i,j,k)
               enddo
            enddo
         enddo
         call diagnose_2d(Time, Grd, id_yflux_subdiff_int_z(n), flux_sign*T_prog(n)%conversion*wrk1_2d(:,:))
     endif


     ! save fluxes for eta_tend diagnostics 
     if(diagnose_eta_tend_subdiff_flx) then 
         if(n==index_temp) then
             flux_x_temp(:,:,:) = 0.0
             flux_y_temp(:,:,:) = 0.0
             do k=1,nk
                do j=jsc,jec
                   do i=isc,iec
                      flux_x_temp(i,j,k) = flux_x(i,j,k)
                      flux_y_temp(i,j,k) = flux_y(i,j,k)
                   enddo
                enddo
             enddo
         elseif(n==index_salt) then
             flux_x_salt(:,:,:) = 0.0
             flux_y_salt(:,:,:) = 0.0
             do k=1,nk
                do j=jsc,jec
                   do i=isc,iec
                      flux_x_salt(i,j,k) = flux_x(i,j,k)
                      flux_y_salt(i,j,k) = flux_y(i,j,k)
                   enddo
                enddo
             enddo
         endif
     endif


  enddo ! enddo for n=1,num_prog_tracers


  ! save diffusivity 
  call diagnose_3d(Time, Grd, id_subdiff_diffusivity, wrk1(:,:,:))


  ! diagnose effects on sea level 
  if(diagnose_eta_tend_subdiff_flx) then 
      flux_z_temp(:,:,:) = 0.0
      flux_z_salt(:,:,:) = 0.0
      call diagnose_eta_tend_3dflux (Time, Thickness, Dens,&
           flux_x_temp(:,:,:),                             &
           flux_y_temp(:,:,:),                             &
           flux_z_temp(:,:,:),                             &
           flux_x_salt(:,:,:),                             &
           flux_y_salt(:,:,:),                             &
           flux_z_salt(:,:,:),                             &    
           eta_tend, eta_tend_glob)   

      call diagnose_2d(Time, Grd, id_eta_tend_subdiff_flx, eta_tend(:,:))
      if(id_eta_tend_subdiff_flx_glob > 0) then  
          used  = send_data (id_eta_tend_subdiff_flx_glob, eta_tend_glob, Time%model_time)
      endif
  endif


end subroutine compute_submeso_diffusion
! </SUBROUTINE> NAME="compute_submeso_diffusion"



!#######################################################################
! <SUBROUTINE NAME="maximum_bottom_w_general">
!
! <DESCRIPTION>
! Compute maximum vertical velocity from submeso.
! </DESCRIPTION>
!
subroutine maximum_bottom_w_submeso(wb,x_array,y_array,depth_array,scale,km_array)

  real,    dimension(isd:,jsd:,:) , intent(in) :: wb
  real,    dimension(isd:,jsd:)   , intent(in) :: x_array
  real,    dimension(isd:,jsd:)   , intent(in) :: y_array
  real,    dimension(isd:,jsd:,:) , intent(in) :: depth_array
  real,                             intent(in) :: scale
  integer, dimension(isd:,jsd:)   , intent(in) :: km_array

  real    :: wbot, wbot0, fudge
  integer :: i, j, k, iwbot, jwbot, kwbot

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error ocean_submesoscale_mod (maximum_bottom_w_submeso): module needs initialization ')
  endif 

  wbot=0.0; iwbot=isc; jwbot=jsc; kwbot=1
  do j=jsc,jec
    do i=isc,iec
      k = km_array(i,j)
      if (k /= 0 .and. (abs(wb(i,j,k)) > abs(wbot))) then
        wbot  = wb(i,j,k)
        iwbot = i
        jwbot = j
        kwbot = k
      endif
    enddo
  enddo
  wbot = scale*abs(wbot)


  write (stdoutunit,'(//60x,a/)') ' Summary of bottom vertical velocity from submeso:'
  fudge = 1 + 1.e-12*mpp_pe() ! to distinguish processors when tracer is independent of processor
  wbot  = wbot*fudge
  wbot0 = wbot
  wbot  = abs(wbot)
  call mpp_max(wbot)

  if (abs(wbot0) == wbot) then
    wbot = wbot0/fudge
    write (unit,9912) wbot, iwbot+Dom%ioff, jwbot+Dom%joff, kwbot, &
                      x_array(iwbot,jwbot), y_array(iwbot,jwbot), depth_array(iwbot,jwbot,kwbot)
  endif
  
9912  format(/' Maximum submeso bottom velocity (',es10.3,' m/s){error}  at (i,j,k) = ','(',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.0,'m)')

end subroutine maximum_bottom_w_submeso
! </SUBROUTINE> NAME="maximum_bottom_wrho_submeso"


!#######################################################################
! <SUBROUTINE NAME="transport_on_nrho_submeso">
!
! <DESCRIPTION>
! Classify horizontal submeso mass transport according to neutral
! density classes. 
!
! NOTE: This diagnostic works with transport integrated from bottom to 
! a particular cell depth. To get transport_on_rho_submeso, a remapping is 
! performed, rather than the binning done for transport_on_nrho_submeso_adv.
!
! This is the same algorithm as used for GM skew fluxes on rho surfaces. 
!
! Caveat: Since the submeso scheme operates only in the mixed layer,
! there are difficulties mapping this transport to neutral density 
! layers.  The user should be mindful of the problems with this 
! remapping.  An alternative that may be more suitable is to use 
! Ferret to remap the time mean submeso transport to the time mean
! neutral density surfaces.  There are missing correlations, but for
! many purposes, the Ferret remapping may be preferable.  
!
! Briefly, the Ferret command is the following:
! 
! let ty_trans_nrho_submeso_new = ZAXREPLACE(TY_TRANS_SUBMESO,NEUTRAL_RHO,TY_TRANS_NRHO)
! where TY_TRANS_SUBMESO is the level-space transport
!       NEUTRAL_RHO is the level space version of the neutral density 
!       TY_TRANS_NRHO is any density space field whose vertical coordinates 
!                     are accessed for the remapping. 
! </DESCRIPTION>
!
subroutine transport_on_nrho_submeso (Time, Dens, tx_trans_lev, ty_trans_lev)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_density_type),     intent(in) :: Dens
  real, dimension(isd:,jsd:,:), intent(in) :: tx_trans_lev
  real, dimension(isd:,jsd:,:), intent(in) :: ty_trans_lev
  type(time_type)                          :: next_time 

  integer :: i, j, k, k_rho, neutralrho_nk
  real    :: work(isd:ied,jsd:jed,size(Dens%neutralrho_ref),2)
  real    :: W1, W2
  real, dimension(jsc:jec) :: nrho_minj, nrho_maxj
  real                     :: nrho_min, nrho_max

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error transport_on_nrho_submeso (transport_on_nrho_submeso): module needs initialization ')
  endif 

  next_time = increment_time(Time%model_time, int(dtime), 0)

  if (need_data(id_tx_trans_nrho_submeso,next_time) .or. need_data(id_ty_trans_nrho_submeso,next_time)) then

      neutralrho_nk = size(Dens%neutralrho_ref(:))
      work(:,:,:,:) = 0.0

      ! for (i,j) points with neutralrho_ref < neutralrho(k=1),   work=0
      ! for (i,j) points with neutralrho_ref > neutralrho(k=kmt), work=0
      ! these assumptions mean there is no need to specially handle the endpoints,
      ! since the initial value for work is 0.

      ! interpolate trans_lev from k-levels to neutralrho_nk-levels
      do k = 1,nk-1
         do j = jsc,jec
            nrho_maxj(j) = maxval(Dens%neutralrho(isc:iec,j,k+1),mask=Grd%tmask(isc:iec,j,k+1)==1.)
            nrho_minj(j) = minval(Dens%neutralrho(isc:iec,j,k),mask=Grd%tmask(isc:iec,j,k)==1.)
         enddo
         nrho_max = maxval(nrho_maxj)
         nrho_min = minval(nrho_minj)
         if (nrho_max == -huge(nrho_max)) exit  ! only rock below this level
         do k_rho = 1,neutralrho_nk
            if (nrho_max < Dens%neutralrho_ref(k_rho)) cycle
            if (nrho_min > Dens%neutralrho_ref(k_rho)) cycle
            do j = jsc,jec
               if (nrho_maxj(j) < Dens%neutralrho_ref(k_rho)) cycle
               if (nrho_minj(j) > Dens%neutralrho_ref(k_rho)) cycle
               do i = isc,iec
                  if (    Dens%neutralrho_ref(k_rho) >  Dens%neutralrho(i,j,k)  ) then
                      if (Dens%neutralrho_ref(k_rho) <= Dens%neutralrho(i,j,k+1)) then 
                         W1 = Dens%neutralrho_ref(k_rho)- Dens%neutralrho(i,j,k)
                         W2 = Dens%neutralrho(i,j,k+1)  - Dens%neutralrho_ref(k_rho)
                         work(i,j,k_rho,1) = (tx_trans_lev(i,j,k+1)*W1 +tx_trans_lev(i,j,k)*W2) &
                                              /(W1 + W2 + epsln)
                         work(i,j,k_rho,2) = (ty_trans_lev(i,j,k+1)*W1 +ty_trans_lev(i,j,k)*W2) &
                                              /(W1 + W2 + epsln)
                      endif
                  endif
               enddo
            enddo
         enddo
      enddo

      do k_rho = 1,neutralrho_nk
         do j = jsc,jec
            do i = isc,iec
               work(i,j,k_rho,1) = work(i,j,k_rho,1)*Grd%tmask(i,j,1)
               work(i,j,k_rho,2) = work(i,j,k_rho,2)*Grd%tmask(i,j,1)
            enddo
         enddo
      enddo

      if (id_tx_trans_nrho_submeso > 0) then 
          used = send_data (id_tx_trans_nrho_submeso, work(:,:,:,1), Time%model_time, &
                 is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=neutralrho_nk)
      endif
      if (id_ty_trans_nrho_submeso > 0) then 
          used = send_data (id_ty_trans_nrho_submeso, work(:,:,:,2), Time%model_time, &
                 is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=neutralrho_nk)
      endif

  endif

end subroutine transport_on_nrho_submeso
! </SUBROUTINE> NAME="transport_on_nrho_submeso"


!#######################################################################
! <SUBROUTINE NAME="transport_on_rho_submeso">
!
! <DESCRIPTION>
! Classify horizontal submeso mass transport according to potential
! density classes. 
!
! NOTE: This diagnostic works with transport integrated from bottom to 
! a particular cell depth. To get transport_on_rho_submeso, a remapping is 
! performed, rather than the binning done for transport_on_nrho_submeso_adv.
!
! This is the same algorithm as used for GM skew fluxes on rho surfaces. 
!
! Caveat: Since the submeso scheme operates only in the mixed layer,
! there are difficulties mapping this transport to potential density 
! layers.  The user should be mindful of the problems with this 
! remapping.  An alternative that may be more suitable is to use 
! Ferret to remap the time mean submeso transport to the time mean
! potential density surfaces.  There are missing correlations, but for
! many purposes, the Ferret remapping may be preferable.  
!
! </DESCRIPTION>
!
subroutine transport_on_rho_submeso (Time, Dens, tx_trans_lev, ty_trans_lev)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_density_type),     intent(in) :: Dens
  real, dimension(isd:,jsd:,:), intent(in) :: tx_trans_lev
  real, dimension(isd:,jsd:,:), intent(in) :: ty_trans_lev
  type(time_type)                          :: next_time

  integer :: i, j, k, k_rho, potrho_nk
  real    :: work(isd:ied,jsd:jed,size(Dens%potrho_ref),2)
  real    :: W1, W2
  real, dimension(jsc:jec) :: rho_minj, rho_maxj
  real                     :: rho_min, rho_max

  if (.not.module_is_initialized) then
    call mpp_error(FATAL, &
    '==>Error transport_on_rho_submeso (transport_on_rho_submeso): module needs initialization ')
  endif

  next_time = increment_time(Time%model_time, int(dtime), 0)

  if (need_data(id_tx_trans_rho_submeso,next_time) .or. need_data(id_ty_trans_rho_submeso,next_time)) then

      potrho_nk = size(Dens%potrho_ref(:))
      work(:,:,:,:) = 0.0

      ! for (i,j) points with potrho_ref < potrho(k=1),   work=0
      ! for (i,j) points with potrho_ref > potrho(k=kmt), work=0
      ! these assumptions mean there is no need to specially handle the endpoints,
      ! since the initial value for work is 0.

      ! interpolate trans_lev from k-levels to potrho_nk-levels
      do k = 1,nk-1
         do j = jsc,jec
            rho_maxj(j) = maxval(Dens%potrho(isc:iec,j,k+1),mask=Grd%tmask(isc:iec,j,k+1)==1.)
            rho_minj(j) = minval(Dens%potrho(isc:iec,j,k),mask=Grd%tmask(isc:iec,j,k)==1.)
         enddo
         rho_max = maxval(rho_maxj)
         rho_min = minval(rho_minj)
         if (rho_max == -huge(rho_max)) exit  ! only rock below this level
         do k_rho = 1,potrho_nk
            if (rho_max < Dens%potrho_ref(k_rho)) cycle
            if (rho_min > Dens%potrho_ref(k_rho)) cycle
            do j = jsc,jec
               if (rho_maxj(j) < Dens%potrho_ref(k_rho)) cycle
               if (rho_minj(j) > Dens%potrho_ref(k_rho)) cycle
               do i = isc,iec
                  if (    Dens%potrho_ref(k_rho) >  Dens%potrho(i,j,k)  ) then
                      if (Dens%potrho_ref(k_rho) <= Dens%potrho(i,j,k+1)) then
                         W1 = Dens%potrho_ref(k_rho)- Dens%potrho(i,j,k)
                         W2 = Dens%potrho(i,j,k+1)  - Dens%potrho_ref(k_rho)
                         work(i,j,k_rho,1) = (tx_trans_lev(i,j,k+1)*W1 +tx_trans_lev(i,j,k)*W2) &
                                              /(W1 + W2 + epsln)
                         work(i,j,k_rho,2) = (ty_trans_lev(i,j,k+1)*W1 +ty_trans_lev(i,j,k)*W2) &
                                              /(W1 + W2 + epsln)
                      endif
                  endif
               enddo
            enddo
         enddo
      enddo

      do k_rho = 1,potrho_nk
         do j = jsc,jec
            do i = isc,iec
               work(i,j,k_rho,1) = work(i,j,k_rho,1)*Grd%tmask(i,j,1)
               work(i,j,k_rho,2) = work(i,j,k_rho,2)*Grd%tmask(i,j,1)
            enddo
         enddo
      enddo

      if (id_tx_trans_rho_submeso > 0) then
          used = send_data (id_tx_trans_rho_submeso, work(:,:,:,1), Time%model_time, &
                 is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=potrho_nk)
      endif
      if (id_ty_trans_rho_submeso > 0) then
          used = send_data (id_ty_trans_rho_submeso, work(:,:,:,2), Time%model_time, &
                 is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=potrho_nk)
      endif

  endif

end subroutine transport_on_rho_submeso
! </SUBROUTINE> NAME="transport_on_rho_submeso"


!#######################################################################
! <SUBROUTINE NAME="transport_on_nrho_submeso_adv">
!
! <DESCRIPTION>
! Classify horizontal transport according to neutral density classes. 
!
! Based on transport_on_nrho in ocean_diag/ocean_adv_diag.F90.
!
! </DESCRIPTION>
!
subroutine transport_on_nrho_submeso_adv (Time, Dens, utrans, vtrans)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_density_type),     intent(in) :: Dens
  real, dimension(isd:,jsd:,:), intent(in) :: utrans
  real, dimension(isd:,jsd:,:), intent(in) :: vtrans
  type(time_type)                          :: next_time 

  integer :: i, j, k, k_rho, neutralrho_nk
  real    :: work1(isc:iec,jsc:jec,size(Dens%neutralrho_ref))
  real    :: work2(isc:iec,jsc:jec,size(Dens%neutralrho_ref))
  real    :: tmp(2,isc:iec,jsc:jec)

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error transport_on_nrho_submeso_adv: module needs initialization ')
  endif 

  neutralrho_nk = size(Dens%neutralrho_ref(:))
  next_time = increment_time(Time%model_time, int(dtime), 0)

  if (need_data(id_tx_trans_nrho_submeso,next_time) .or. need_data(id_ty_trans_nrho_submeso,next_time)) then

      work1(:,:,:) = 0.0
      work2(:,:,:) = 0.0

      do k_rho = 1,neutralrho_nk

         tmp(:,:,:) = 0.0
         do k = 1,nk
            do j = jsc,jec
               do i = isc,iec
                  if (k_rho == 1) then
                     if (Dens%neutralrho(i,j,k) < Dens%neutralrho_bounds(k_rho+1)) then 
                         tmp(1,i,j) = tmp(1,i,j) + utrans(i,j,k)
                         tmp(2,i,j) = tmp(2,i,j) + vtrans(i,j,k)
                     endif
                  elseif (k_rho < neutralrho_nk) then
                     if ((Dens%neutralrho_bounds(k_rho) <= Dens%neutralrho(i,j,k)) .and.  &
                         (Dens%neutralrho(i,j,k)        <  Dens%neutralrho_bounds(k_rho+1)) ) then 
                           tmp(1,i,j) = tmp(1,i,j) + utrans(i,j,k)
                           tmp(2,i,j) = tmp(2,i,j) + vtrans(i,j,k)
                     endif
                  else    ! if (k_rho == neutralrho_nk) then
                     if (Dens%neutralrho_bounds(k_rho) <= Dens%neutralrho(i,j,k)) then 
                        tmp(1,i,j) = tmp(1,i,j) + utrans(i,j,k)             
                        tmp(2,i,j) = tmp(2,i,j) + vtrans(i,j,k)
                     endif
                  endif
               enddo
            enddo
         enddo

         do j=jsc,jec
            do i=isc,iec
               work1(i,j,k_rho) = (tmp(1,i,j)+work1(i,j,k_rho))*Grd%dyte(i,j)*transport_convert*Grd%tmask(i,j,1)
               work2(i,j,k_rho) = (tmp(2,i,j)+work2(i,j,k_rho))*Grd%dxtn(i,j)*transport_convert*Grd%tmask(i,j,1)
            enddo
         enddo

      enddo

      if (id_tx_trans_nrho_submeso > 0) then 
          used = send_data (id_tx_trans_nrho_submeso, work1, Time%model_time, &
                            ks_in=1, ke_in=neutralrho_nk)
      endif
      if (id_ty_trans_nrho_submeso > 0) then 
          used = send_data (id_ty_trans_nrho_submeso, work2, Time%model_time, &
                            ks_in=1, ke_in=neutralrho_nk)
      endif

  endif

end subroutine transport_on_nrho_submeso_adv
! </SUBROUTINE> NAME="transport_on_nrho_submeso_adv"



!#######################################################################
! <SUBROUTINE NAME="watermass_diag_init">
!
! <DESCRIPTION>
! Initialization of watermass diagnostic output files. 
! </DESCRIPTION>
!
subroutine watermass_diag_init(Time, Dens)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens

  integer :: stdoutunit
  stdoutunit=stdout()
  compute_watermass_diag = .false. 

  
  ! for the submeso streamfunction parameterization 

  id_neut_rho_submeso = register_diag_field ('ocean_model', 'neut_rho_submeso',&
    Grd%tracer_axes(1:3), Time%model_time,                                     &
    'update of locally referenced potential density from submeso param',       &
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_rho_submeso > 0) compute_watermass_diag = .true.

  id_pot_rho_submeso = register_diag_field ('ocean_model', 'pot_rho_submeso',&
    Grd%tracer_axes(1:3), Time%model_time,                                   &
    'update of depth referenced potential density from submeso param',       &
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_pot_rho_submeso > 0) compute_watermass_diag = .true.

  id_wdian_rho_submeso = register_diag_field ('ocean_model', 'wdian_rho_submeso',&
    Grd%tracer_axes(1:3), Time%model_time,                                       &
    'dianeutral mass transport due to submeso closure',                          &
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_rho_submeso > 0) compute_watermass_diag = .true.

  id_tform_rho_submeso = register_diag_field ('ocean_model', 'tform_rho_submeso',&
    Grd%tracer_axes(1:3), Time%model_time,                                       &
    'watermass transform due to submeso on levels (pre-layer binning)',          &
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_rho_submeso > 0) compute_watermass_diag = .true.

  id_neut_rho_submeso_on_nrho = register_diag_field ('ocean_model',                            &
    'neut_rho_submeso_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                    &
    'update of locally ref potential density from submeso as binned to neutral density layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_rho_submeso_on_nrho > 0) compute_watermass_diag = .true.

  id_wdian_rho_submeso_on_nrho = register_diag_field ('ocean_model',                &
     'wdian_rho_submeso_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,       &
     'dianeutral mass transport due to submeso as binned to neutral density layers',&
     'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_rho_submeso_on_nrho > 0) compute_watermass_diag = .true.

  id_tform_rho_submeso_on_nrho = register_diag_field ('ocean_model',          &
     'tform_rho_submeso_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time, &
     'watermass transform due to submeso as binned to neutral density layers',&
     'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_rho_submeso_on_nrho > 0) compute_watermass_diag = .true.

  id_eta_tend_submeso_tend= -1          
  id_eta_tend_submeso_tend= register_diag_field ('ocean_model','eta_tend_submeso_tend',&
       Grd%tracer_axes(1:2), Time%model_time,                                          &
       'non-Bouss steric sea level tendency from submesoscale tendency', 'm/s',        &
       missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_submeso_tend > 0) compute_watermass_diag=.true.

  id_eta_tend_submeso_tend_glob= -1          
  id_eta_tend_submeso_tend_glob= register_diag_field ('ocean_model', 'eta_tend_submeso_tend_glob',&
       Time%model_time,                                                                           &
       'global mean non-bouss steric sea level tendency from submesoscale tendency',              &
       'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_submeso_tend_glob > 0) compute_watermass_diag=.true.

  id_eta_tend_subdiff_tend= -1          
  id_eta_tend_subdiff_tend= register_diag_field ('ocean_model','eta_tend_subdiff_tend',&
       Grd%tracer_axes(1:2), Time%model_time,                                          &
       'non-Bouss steric sea level tendency from subdiff tendency', 'm/s',             &
       missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_subdiff_tend > 0) compute_watermass_diag=.true.

  id_eta_tend_subdiff_tend_glob= -1          
  id_eta_tend_subdiff_tend_glob= register_diag_field ('ocean_model', 'eta_tend_subdiff_tend_glob',&
       Time%model_time,                                                                           &
       'global mean non-bouss steric sea level tendency from subdiff tendency',                   &
       'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_subdiff_tend_glob > 0) compute_watermass_diag=.true.


  id_neut_temp_submeso = register_diag_field ('ocean_model', 'neut_temp_submeso',    &
    Grd%tracer_axes(1:3), Time%model_time,                                           &
    'temp related update of locally referenced potential density from submeso param',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_temp_submeso > 0) compute_watermass_diag = .true.

  id_wdian_temp_submeso = register_diag_field ('ocean_model', 'wdian_temp_submeso',&
    Grd%tracer_axes(1:3), Time%model_time,                                         &
    'temp related dianeutral mass transport due to submeso closure',               &
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_temp_submeso > 0) compute_watermass_diag = .true.

  id_tform_temp_submeso = register_diag_field ('ocean_model', 'tform_temp_submeso', &
    Grd%tracer_axes(1:3), Time%model_time,                                          &
    'temp related watermass transform due to submeso on levels (pre-layer binning)',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_temp_submeso > 0) compute_watermass_diag = .true.

  id_neut_temp_submeso_on_nrho = register_diag_field ('ocean_model',                                        &
    'neut_temp_submeso_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                                &
    'temp related update of locally ref potential density from submeso as binned to neutral density layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_temp_submeso_on_nrho > 0) compute_watermass_diag = .true.

  id_wdian_temp_submeso_on_nrho = register_diag_field ('ocean_model',                            &
     'wdian_temp_submeso_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                   &
     'temp related dianeutral mass transport due to submeso as binned to neutral density layers',&
     'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_temp_submeso_on_nrho > 0) compute_watermass_diag = .true.

  id_tform_temp_submeso_on_nrho = register_diag_field ('ocean_model',                       &
     'tform_temp_submeso_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,              &
     'temp related watermass transform due to submeso as binned to neutral density layers', &
     'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_temp_submeso_on_nrho > 0) compute_watermass_diag = .true.



  id_neut_salt_submeso = register_diag_field ('ocean_model', 'neut_salt_submeso',    &
    Grd%tracer_axes(1:3), Time%model_time,                                           &
    'salt related update of locally referenced potential density from submeso param',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_salt_submeso > 0) compute_watermass_diag = .true.

  id_wdian_salt_submeso = register_diag_field ('ocean_model', 'wdian_salt_submeso',&
    Grd%tracer_axes(1:3), Time%model_time,                                         &
    'salt related dianeutral mass transport due to submeso closure',               &
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_salt_submeso > 0) compute_watermass_diag = .true.

  id_tform_salt_submeso = register_diag_field ('ocean_model', 'tform_salt_submeso', &
    Grd%tracer_axes(1:3), Time%model_time,                                          &
    'salt related watermass transform due to submeso on levels (pre-layer binning)',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_salt_submeso > 0) compute_watermass_diag = .true.

  id_neut_salt_submeso_on_nrho = register_diag_field ('ocean_model',                                        &
    'neut_salt_submeso_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                                &
    'salt related update of locally ref potential density from submeso as binned to neutral density layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_salt_submeso_on_nrho > 0) compute_watermass_diag = .true.

  id_wdian_salt_submeso_on_nrho = register_diag_field ('ocean_model',                            &
     'wdian_salt_submeso_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                   &
     'salt related dianeutral mass transport due to submeso as binned to neutral density layers',&
     'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_salt_submeso_on_nrho > 0) compute_watermass_diag = .true.

  id_tform_salt_submeso_on_nrho = register_diag_field ('ocean_model',                      &
     'tform_salt_submeso_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,             &
     'salt related watermass transform due to submeso as binned to neutral density layers',&
     'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_salt_submeso_on_nrho > 0) compute_watermass_diag = .true.


  if(compute_watermass_diag) then 
    write(stdoutunit,'(/a/)') &
    '==>Note: running ocean_submesoscale_mod w/ compute_watermass_diag=.true.'  
  endif 



  ! for the submeso horizontal diffusion parameterization 

  id_neut_rho_subdiff = register_diag_field ('ocean_model', 'neut_rho_subdiff',&
    Grd%tracer_axes(1:3), Time%model_time,                                     &
    'update of locally referenced potential density from subdiff param',       &
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_rho_subdiff > 0) compute_watermass_diff_diag = .true.

  id_wdian_rho_subdiff = register_diag_field ('ocean_model', 'wdian_rho_subdiff',&
    Grd%tracer_axes(1:3), Time%model_time,                                       &
    'dianeutral mass transport due to subdiff closure',                          &
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_rho_subdiff > 0) compute_watermass_diff_diag = .true.

  id_tform_rho_subdiff = register_diag_field ('ocean_model', 'tform_rho_subdiff',&
    Grd%tracer_axes(1:3), Time%model_time,                                       &
    'watermass transform due to subdiff on levels (pre-layer binning)',          &
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_rho_subdiff > 0) compute_watermass_diff_diag = .true.

  id_neut_rho_subdiff_on_nrho = register_diag_field ('ocean_model',                            &
    'neut_rho_subdiff_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                    &
    'update of locally ref potential density from subdiff as binned to neutral density layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_rho_subdiff_on_nrho > 0) compute_watermass_diff_diag = .true.

  id_wdian_rho_subdiff_on_nrho = register_diag_field ('ocean_model',                &
     'wdian_rho_subdiff_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,       &
     'dianeutral mass transport due to subdiff as binned to neutral density layers',&
     'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_rho_subdiff_on_nrho > 0) compute_watermass_diff_diag = .true.

  id_tform_rho_subdiff_on_nrho = register_diag_field ('ocean_model',          &
     'tform_rho_subdiff_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time, &
     'watermass transform due to subdiff as binned to neutral density layers',&
     'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_rho_subdiff_on_nrho > 0) compute_watermass_diff_diag = .true.

  id_eta_tend_subdiff_tend= -1          
  id_eta_tend_subdiff_tend= register_diag_field ('ocean_model','eta_tend_subdiff_tend',&
       Grd%tracer_axes(1:2), Time%model_time,                                          &
       'non-Bouss steric sea level tendency from subdiffscale tendency', 'm/s',        &
       missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_subdiff_tend > 0) compute_watermass_diff_diag=.true.

  id_eta_tend_subdiff_tend_glob= -1          
  id_eta_tend_subdiff_tend_glob= register_diag_field ('ocean_model', 'eta_tend_subdiff_tend_glob',&
       Time%model_time,                                                                           &
       'global mean non-bouss steric sea level tendency from subdiffscale tendency',              &
       'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_subdiff_tend_glob > 0) compute_watermass_diff_diag=.true.


  id_neut_temp_subdiff = register_diag_field ('ocean_model', 'neut_temp_subdiff',    &
    Grd%tracer_axes(1:3), Time%model_time,                                           &
    'temp related update of locally referenced potential density from subdiff param',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_temp_subdiff > 0) compute_watermass_diff_diag = .true.

  id_wdian_temp_subdiff = register_diag_field ('ocean_model', 'wdian_temp_subdiff',&
    Grd%tracer_axes(1:3), Time%model_time,                                         &
    'temp related dianeutral mass transport due to subdiff closure',               &
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_temp_subdiff > 0) compute_watermass_diff_diag = .true.

  id_tform_temp_subdiff = register_diag_field ('ocean_model', 'tform_temp_subdiff', &
    Grd%tracer_axes(1:3), Time%model_time,                                          &
    'temp related watermass transform due to subdiff on levels (pre-layer binning)',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_temp_subdiff > 0) compute_watermass_diff_diag = .true.

  id_neut_temp_subdiff_on_nrho = register_diag_field ('ocean_model',                                        &
    'neut_temp_subdiff_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                                &
    'temp related update of locally ref potential density from subdiff as binned to neutral density layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_temp_subdiff_on_nrho > 0) compute_watermass_diff_diag = .true.

  id_wdian_temp_subdiff_on_nrho = register_diag_field ('ocean_model',                            &
     'wdian_temp_subdiff_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                   &
     'temp related dianeutral mass transport due to subdiff as binned to neutral density layers',&
     'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_temp_subdiff_on_nrho > 0) compute_watermass_diff_diag = .true.

  id_tform_temp_subdiff_on_nrho = register_diag_field ('ocean_model',                       &
     'tform_temp_subdiff_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,              &
     'temp related watermass transform due to subdiff as binned to neutral density layers', &
     'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_temp_subdiff_on_nrho > 0) compute_watermass_diff_diag = .true.



  id_neut_salt_subdiff = register_diag_field ('ocean_model', 'neut_salt_subdiff',    &
    Grd%tracer_axes(1:3), Time%model_time,                                           &
    'salt related update of locally referenced potential density from subdiff param',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_salt_subdiff > 0) compute_watermass_diff_diag = .true.

  id_wdian_salt_subdiff = register_diag_field ('ocean_model', 'wdian_salt_subdiff',&
    Grd%tracer_axes(1:3), Time%model_time,                                         &
    'salt related dianeutral mass transport due to subdiff closure',               &
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_salt_subdiff > 0) compute_watermass_diff_diag = .true.

  id_tform_salt_subdiff = register_diag_field ('ocean_model', 'tform_salt_subdiff', &
    Grd%tracer_axes(1:3), Time%model_time,                                          &
    'salt related watermass transform due to subdiff on levels (pre-layer binning)',&
    'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_salt_subdiff > 0) compute_watermass_diff_diag = .true.

  id_neut_salt_subdiff_on_nrho = register_diag_field ('ocean_model',                                        &
    'neut_salt_subdiff_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                                &
    'salt related update of locally ref potential density from subdiff as binned to neutral density layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_salt_subdiff_on_nrho > 0) compute_watermass_diff_diag = .true.

  id_wdian_salt_subdiff_on_nrho = register_diag_field ('ocean_model',                            &
     'wdian_salt_subdiff_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                   &
     'salt related dianeutral mass transport due to subdiff as binned to neutral density layers',&
     'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_wdian_salt_subdiff_on_nrho > 0) compute_watermass_diff_diag = .true.

  id_tform_salt_subdiff_on_nrho = register_diag_field ('ocean_model',                      &
     'tform_salt_subdiff_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,             &
     'salt related watermass transform due to subdiff as binned to neutral density layers',&
     'kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_tform_salt_subdiff_on_nrho > 0) compute_watermass_diff_diag = .true.


  if(compute_watermass_diff_diag) then 
    write(stdoutunit,'(/a/)') &
    '==>Note: running ocean_submesoscale_mod w/ compute_watermass_diff_diag=.true.'  
  endif 



end subroutine watermass_diag_init
! </SUBROUTINE> NAME="watermass_diag_init"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag">
!
! <DESCRIPTION>
! Diagnose effects from submesoscale on watermass transformation.  
! </DESCRIPTION>
!
subroutine watermass_diag(Time, T_prog, Dens)

  type(ocean_time_type),          intent(in) :: Time
  type(ocean_prog_tracer_type),   intent(in) :: T_prog(:)
  type(ocean_density_type),       intent(in) :: Dens

  integer :: i,j,k,tau
  real,  dimension(isd:ied,jsd:jed) :: eta_tend

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_submesoscale (watermass_diag): module needs initialization ')
  endif 

  if(.not. compute_watermass_diag) return 

  tau=Time%tau 

  ! rho related diagnostics 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodT(i,j,k)*T_prog(index_temp)%wrk1(i,j,k) &
                        +Dens%drhodS(i,j,k)*T_prog(index_salt)%wrk1(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
           wrk5(i,j,k) =-wrk1(i,j,k)/(epsln+Dens%rho(i,j,k,tau)**2)  ! for eta_tend
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_submeso, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_submeso, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_submeso, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_submeso_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_submeso_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_submeso_on_nrho, wrk4)


  ! sea level tendency 
  if(id_eta_tend_submeso_tend > 0 .or. id_eta_tend_submeso_tend_glob > 0) then
      eta_tend(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               eta_tend(i,j) = eta_tend(i,j) + wrk5(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_eta_tend_submeso_tend, eta_tend(:,:))
      call diagnose_sum(Time, Grd, Dom, id_eta_tend_submeso_tend_glob, eta_tend, cellarea_r)
  endif


  ! potential rho related diagnostics
  if(id_pot_rho_submeso > 0) then 
     wrk1(:,:,:) = 0.0
     wrk2(:,:,:) = 0.0
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              wrk1(i,j,k) = Dens%dpotrhodT(i,j,k)*T_prog(index_temp)%wrk1(i,j,k) &
                           +Dens%dpotrhodS(i,j,k)*T_prog(index_salt)%wrk1(i,j,k)
              wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           enddo
        enddo
     enddo
     call diagnose_3d(Time, Grd, id_pot_rho_submeso, wrk2(:,:,:))
  endif
  

  ! temp related diagnostics 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodT(i,j,k)*T_prog(index_temp)%wrk1(i,j,k) 
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_submeso, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_submeso, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_temp_submeso, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_submeso_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_submeso_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_submeso_on_nrho, wrk4)

  ! salinity related diagnostics 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodS(i,j,k)*T_prog(index_salt)%wrk1(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_submeso, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_submeso, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_salt_submeso, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_submeso_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_submeso_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_submeso_on_nrho, wrk4)
 
end subroutine watermass_diag
! </SUBROUTINE>  NAME="watermass_diag"



!#######################################################################
! <SUBROUTINE NAME="watermass_diag_diffusion">
!
! <DESCRIPTION>
! Diagnose effects from submesoscale horizontal diffusion 
! on watermass transformation.  
! </DESCRIPTION>
!
subroutine watermass_diag_diffusion(Time, T_prog, Dens)

  type(ocean_time_type),          intent(in) :: Time
  type(ocean_prog_tracer_type),   intent(in) :: T_prog(:)
  type(ocean_density_type),       intent(in) :: Dens

  integer :: i,j,k,tau
  real,  dimension(isd:ied,jsd:jed) :: eta_tend

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_submesoscale (watermass_diag_diffusion): module needs initialization ')
  endif 

  if(.not. compute_watermass_diff_diag) return 

  tau=Time%tau 

  ! rho related diagnostics 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodT(i,j,k)*T_prog(index_temp)%wrk1(i,j,k) &
                        +Dens%drhodS(i,j,k)*T_prog(index_salt)%wrk1(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
           wrk5(i,j,k) =-wrk1(i,j,k)/(epsln+Dens%rho(i,j,k,tau)**2)  ! for eta_tend
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_subdiff, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_subdiff, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_subdiff, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_subdiff_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_subdiff_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_subdiff_on_nrho, wrk4)

  ! sea level tendency 
  if(id_eta_tend_subdiff_tend > 0 .or. id_eta_tend_subdiff_tend_glob > 0) then
      eta_tend(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               eta_tend(i,j) = eta_tend(i,j) + wrk5(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_eta_tend_subdiff_tend, eta_tend(:,:))
      call diagnose_sum(Time, Grd, Dom, id_eta_tend_subdiff_tend_glob, eta_tend, cellarea_r)
  endif

  ! temp related diagnostics 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodT(i,j,k)*T_prog(index_temp)%wrk1(i,j,k) 
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_subdiff, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_subdiff, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_temp_subdiff, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_subdiff_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_subdiff_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_subdiff_on_nrho, wrk4)

  ! salinity related diagnostics 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodS(i,j,k)*T_prog(index_salt)%wrk1(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_subdiff, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_subdiff, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_salt_subdiff, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_subdiff_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_subdiff_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_subdiff_on_nrho, wrk4)

 
end subroutine watermass_diag_diffusion
! </SUBROUTINE>  NAME="watermass_diag_diffusion"


end module ocean_submesoscale_mod

module atmos_sea_salt_mod
! <DESCRIPTION>
!   This module evaluates the change of mass mixing ratio of sea salt
!   particles due to their emission at the ocean surface, and the removal by
!   gravitational settling. The sea salt particles are transported as dry
!   particles. Therefore, some conversion from wet to dry and vice-et-versa
!   are consdered.
!   The size distribution of sea salt ranges from 0.1 to 10 um (dry radius)
!   and is divided into 5 bins. For each bin, the volume size distribution
!   dV/dlnr is considered constant.
! </DESCRIPTION>
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Paul Ginoux
! </CONTACT>
! 
!
!-----------------------------------------------------------------------
use mpp_mod, only: input_nml_file 
use              fms_mod, only : file_exist, &
                                 write_version_number, &
                                 close_file,              &
                                 mpp_pe, &
                                 mpp_root_pe, &
                                 open_namelist_file, file_exist,    &
                                 check_nml_error, error_mesg,  &
                                 stdlog
use     time_manager_mod, only : time_type
use     diag_manager_mod, only : send_data,            &
                                 register_diag_field
use   tracer_manager_mod, only : get_tracer_index
use    field_manager_mod, only : MODEL_ATMOS
use        constants_mod, only : PI, GRAV,RDGAS, DENS_H2O, PSTD_MKS, WTMAIR
implicit none
private
!-----------------------------------------------------------------------
!----- interfaces -------

public  atmos_sea_salt_sourcesink, atmos_sea_salt_init, atmos_sea_salt_end

!---- version number -----
character(len=128) :: version = '$Id: atmos_sea_salt.F90,v 20.0 2013/12/13 23:23:59 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'


!-----------------------------------------------------------------------
!----------- namelist -------------------
character(len=80) :: scheme = " "
real, save :: coef1
real, save :: coef2
!---------------------------------------------------------------------
real :: coef_emis1=-999.
real :: coef_emis2=-999.
real :: critical_sea_fraction = 0.0   ! sea-salt aerosol production
                                      ! occurs in grid cells with
                                      ! ocn_flx_fraction .gt. this value


namelist /ssalt_nml/  scheme, coef_emis1, coef_emis2, &
                      critical_sea_fraction

!-----------------------------------------------------------------------

!--- Arrays to help calculate tracer sources/sinks ---

character(len=7), parameter :: mod_name = 'tracers'

integer :: nseasalt=0  ! tracer number for sea_salt
!--- identification numbers for  diagnostic fields and axes ----

integer :: id_SS_emis(5), id_SS_setl(5)
integer :: id_ocn_flx_fraction

logical :: module_is_initialized=.FALSE.
logical :: used
integer :: logunit

      real, parameter :: small_value = 1.e-20
      real, parameter :: mtv  = 1.    ! factor connversion for mixing ratio
      integer, parameter :: nrh= 65   ! number of RH in look-up table
      integer, parameter :: nr = 10   ! number of integration points 
                                      ! The difference with nr=100 & nr=5 < 1e-3
      real, dimension(nrh) :: rho_table, growth_table
!! Sea salt hygroscopic growth factor from 35 to 99% RH
!! We start at the deliquescence point of sea-salt for RH=37%
!! Any lower RH doesn't affect dry properties
!! Reference: Tang et al., JGR, v102(D19), 23,269-23,275, 1997. 
      data growth_table/1.000, 1.000, 1.396, &
       1.413, 1.428, 1.441, 1.454, 1.466, 1.478, 1.490, 1.501, 1.512, &
       1.523, 1.534, 1.545, 1.555, 1.566, 1.577, 1.588, 1.599, 1.610, &
       1.621, 1.632, 1.644, 1.655, 1.667, 1.679, 1.692, 1.704, 1.717, &
       1.730, 1.743, 1.757, 1.771, 1.786, 1.801, 1.816, 1.832, 1.849, &
       1.866, 1.884, 1.903, 1.923, 1.944, 1.966, 1.990, 2.014, 2.041, &
       2.069, 2.100, 2.134, 2.170, 2.210, 2.255, 2.306, 2.363, 2.430, &
       2.509, 2.605, 2.723, 2.880, 3.087, 3.402, 3.919, 5.048/
!! Seal salt density for 65 RH values from 35% to 99% [g/cm3]
      data rho_table/2.160, 2.160, 1.490, &
       1.475, 1.463, 1.452, 1.441, 1.432, 1.422, 1.414, 1.406, 1.398, &
       1.390, 1.382, 1.375, 1.368, 1.361, 1.354, 1.347, 1.341, 1.334, &
       1.328, 1.322, 1.315, 1.309, 1.303, 1.297, 1.291, 1.285, 1.279, &
       1.273, 1.267, 1.261, 1.255, 1.249, 1.243, 1.237, 1.231, 1.225, &
       1.219, 1.213, 1.207, 1.201, 1.195, 1.189, 1.183, 1.176, 1.170, &
       1.163, 1.156, 1.150, 1.142, 1.135, 1.128, 1.120, 1.112, 1.103, &
       1.094, 1.084, 1.074, 1.063, 1.051, 1.038, 1.025, 1.011/

real :: betha

!-----------------------------------------------------------------------

contains

!#######################################################################
!<SUBROUTINE NAME="atmos_sea_salt_sourcesink">
!<OVERVIEW>
! The routine that calculate the emission and settling of sea_salt.
!</OVERVIEW>
 subroutine atmos_sea_salt_sourcesink (i_SS,ra,rb,ssaltref,ssaltden, &
                                       lon, lat, ocn_flx_fraction, pwt, &
                                       zhalf, pfull, w10m, t, rh, &
                                       seasalt, seasalt_dt, dt, SS_setl, &
                                       SS_emis, Time, Time_next, &
                                       is,ie,js,je, kbot)

!-----------------------------------------------------------------------
   integer, intent(in)                 :: i_SS
   real, intent(in)                    :: ra
   real, intent(in)                    :: rb
   real, intent(in)                    :: dt
   real, intent(in)                    :: ssaltref
   real, intent(in)                    :: ssaltden
   real, intent(in),  dimension(:,:)   :: lon, lat
   real, intent(in),  dimension(:,:)   :: ocn_flx_fraction
   real, intent(in),  dimension(:,:)   :: w10m
   real, intent(out), dimension(:,:)   :: SS_setl, SS_emis
   real, intent(in),  dimension(:,:,:) :: pwt, seasalt
   real, intent(in),  dimension(:,:,:) :: zhalf, pfull, t, rh
   real, intent(out), dimension(:,:,:) :: seasalt_dt
   integer, intent(in)                 :: is, ie, js, je
   type(time_type), intent(in) :: Time, Time_next     
   integer, intent(in),  dimension(:,:), optional :: kbot
!-----------------------------------------------------------------------

real, dimension(size(seasalt,3)) :: SS_conc0, SS_conc1
integer  i, j, k, id, jd, kd, kb, ir, irh

!----------------------------------------------
!     Sea-Salt parameters
!----------------------------------------------
      real, dimension(size(seasalt,3)) :: setl

      integer :: istep, nstep
      real, parameter :: ptmb = 0.01     ! pascal to mb
      integer, parameter :: nstep_max = 5  !Maximum number of cyles for settling
      real :: step
      real :: rhb
      real :: rho_wet_salt, viscosity, free_path, C_c
      real :: rho_air, Bcoef
      real :: r, dr, rmid, rwet, seasalt_flux
      real :: a1, a2
      real, dimension(size(pfull,3))  :: vdep
!-----------------------------------------------------------------------

      id=size(seasalt,1); jd=size(seasalt,2); kd=size(seasalt,3)

      SS_emis(:,:)      = 0.0
      SS_setl(:,:)      = 0.0
      seasalt_dt(:,:,:) = 0.0

!-------------------------------------------------------------------------
! Smith et al. (1993) derived an expression for the sea-salt flux
! by assuming that particle size spectra measured at a height of 10 m
! on the ocast of the Outer Hevrides islands with prevailing winds from
! the ocean present a balance between production and loss. They approximate
! the flux by the sum of two lognormal distributions.
! 
! seasalt_flux is the flux of dry particles by bubble bursting .
! Monahan et al. (1986) established a formula for the flux of wet
! particles by bubble bursting. The radius needs to be converted
! into dry assuming an equilibrium relative humidity above water RH=80%
! Using Tang (1996) formula the sea-salt hygroscopic growth betha=2.009
! at RH=80 (cf. Fitzegrald and Hoppel, JGR, v103 D13, 16085-16102, 1998)
! Also, Monahan et al. (1986) formula is defined for radius in units of
! micrometers
! The flux of particles is converted into mass flux. The cube of the
! radius disappear by cancelation with r^3 in Monahan formula. However
! there is 1/betha3 remaining multiply by betha from the integrand, such
! that finally 1/betha^2 remained. 
!-------------------------------------------------------------------------

      if (scheme .ne. "Smith") then !  ie, Monahan et . (1986)
        r = ra* 1.e6
        dr= (rb - ra)/float(nr)* 1.e6
        seasalt_flux=0.
        do ir=1,nr
          rmid=r+dr*0.5   ! Dry radius
          r=r+dr
          Bcoef=(coef1-alog10(betha*rmid))/coef2
          seasalt_flux = seasalt_flux + &
             1.373*4./3.*pi*ssaltden/betha**2*1.e-18* &
             (1.+0.057*(betha*rmid)**1.05)*dr*      &
             10**(1.19*exp(-(Bcoef**2)))
        enddo
          do j=1,jd
            do i=1,id
              if (ocn_flx_fraction (i,j).gt.critical_sea_fraction) then
                SS_emis(i,j) = seasalt_flux*(ocn_flx_fraction (i,j))*   &
                                                           w10m(i,j)**3.41
              endif
            enddo
          enddo

      else  !  scheme .ne. smith
        if (mpp_pe() == mpp_root_pe())   &
          write (logunit,*) "Smith parameterization for sea-salt production"
          do j=1,jd
            do i=1,id
              if (ocn_flx_fraction (i,j).gt.critical_sea_fraction) then
!------------------------------------------------------------------
!    Surface emission of sea salt  (Smith et al. (1993))
!------------------------------------------------------------------
                seasalt_flux            = 0.0
                a1=exp(0.155*w10m(i,j)+5.595)
                a2=exp(2.2082*sqrt(w10m(i,j))-3.3986)
                r = ra* 1.e6
                dr= (rb - ra)/float(nr)* 1.e6
                do ir=1,nr
                  rmid=r+dr*0.5   ! Dry radius
                  r=r+dr
                  seasalt_flux            = seasalt_flux            + &
                     4.188e-18*rmid**3*ssaltden*betha*( &
                    + coef1*a1*exp(-3.1*(alog(betha*rmid/2.1))**2) &
                    + coef2*a2*exp(-3.3*(alog(betha*rmid/9.2))**2) )
                enddo
                  SS_emis(i,j) = seasalt_flux*ocn_flx_fraction (i,j)
              endif  
            enddo
          enddo
      endif

      if (present(kbot)) then
        do j=1,jd
          do i=1,id
            kb = kbot(i,j)
            seasalt_dt(i,j,kb)=amax1(0.,SS_emis(i,j)/pwt(i,j,kb)*mtv)
          enddo
        enddo
      else  
        do j=1,jd
          do i=1,id
            seasalt_dt(i,j,kd) =  amax1(0., SS_emis(i,j)/pwt(i,j,kd)*mtv)
          end do
        end do
      endif  

! Send the emission data to the diag_manager for output.
      if (id_SS_emis(i_SS) > 0 ) then
        used = send_data ( id_SS_emis(i_SS), SS_emis, Time_next, &
              is_in=is,js_in=js )
      endif
      if (id_ocn_flx_fraction > 0) then
        used = send_data ( id_ocn_flx_fraction, ocn_flx_fraction, Time_next, &
             is_in=is,js_in=js )
      endif

!------------------------------------------
!       Solve at the model TOP (layer plev-10)
!------------------------------------------
        do j=1,jd
          do i=1,id
            if (present(kbot)) then
              kb=kbot(i,j)
            else
              kb=kd
            endif
!
! Determine the maximum timestep to avoid particles settling more than 1 layer
!
            nstep=1
            do k=1,kb
              rhb=amin1(0.99,rh(i,j,k))
              rhb=amax1(0.001,rhb)
              irh=max0(1,int(rhb*100.-34.))
              rho_wet_salt=rho_table(irh)*1000. !Density of wet sea-salt [kg/m3]
              rwet=ssaltref*growth_table(irh) ! Radius of wet sea-salt [m]
              viscosity = 1.458E-6 * t(i,j,k)**1.5/(t(i,j,k)+110.4)
              free_path=6.6e-8*t(i,j,k)/293.15*(PSTD_MKS/pfull(i,j,k))
              C_c=1. + free_path/ssaltref* &            ! Slip correction [none]
                    (1.257+0.4*exp(-1.1*ssaltref/free_path))
              Vdep(k)=2./9.*C_c*GRAV*rho_wet_salt*rwet**2./viscosity
              step = (zhalf(i,j,k)-zhalf(i,j,k+1)) / vdep(k) / 2.
              nstep = max(nstep, int( dt/ step) )
!!! To avoid spending too much time on cycling the settling in case
!!! of very large particles falling through a tiny layer, impose
!!! maximum speed for the selected nstep_max. This is not physically
!!! correct, but as these particles are very large there will be removed
!!! fast enough to not change significantly their lifetime. The proper
!!! way would be to implement semi-lagrangian technique.
              if (nstep.gt.nstep_max) then
                nstep = nstep_max
                vdep(k)=(zhalf(i,j,k)-zhalf(i,j,k+1))*nstep / 2. /dt
              endif
            enddo
            step = dt / nstep

            SS_conc1(:) = seasalt(i,j,:) 
            do istep = 1, nstep
              SS_conc0(:) = SS_conc1(:) 
              do k=1,kb
                rho_air = pfull(i,j,k)/t(i,j,k)/RDGAS ! Air density [kg/m3]
                if (SS_conc0(k).gt.0.) then
!!!               settling flux [kg/m2/s]
                  setl(k)=SS_conc0(k)*rho_air/mtv*vdep(k) 
                else
                  setl(k)=0.
                endif
              enddo
              SS_setl(i,j)=SS_setl(i,j)+setl(kb)*step
              SS_conc1(1) = SS_conc0(1) - setl(1)/pwt(i,j,1)*mtv * step
              SS_conc1(2:kb)= SS_conc0(2:kb) &
              + ( setl(1:kb-1) - setl(2:kb) )/pwt(i,j,2:kb)*mtv * step
              where (SS_conc1 < 0 ) SS_conc1=0.0
            enddo
            seasalt_dt(i,j,:)=seasalt_dt(i,j,:)+ (SS_conc1(:)-seasalt(i,j,:))/dt
            SS_setl(i,j)=SS_setl(i,j)/dt
          enddo
        enddo 

! Send the settling data to the diag_manager for output.
      if (id_SS_setl(i_SS) > 0 ) then
        used = send_data ( id_SS_setl(i_SS), SS_setl, Time_next, &
              is_in=is,js_in=js )
      endif


!-----------------------------------------------------------------------

 end subroutine atmos_sea_salt_sourcesink
!</SUBROUTINE>


!#######################################################################
!<SUBROUTINE NAME="atmos_sea_salt_init">
!<OVERVIEW>
! The constructor routine for the sea_salt module.
!</OVERVIEW>
 subroutine atmos_sea_salt_init (lonb, latb, axes, Time, mask)
!-----------------------------------------------------------------------
real, intent(in),    dimension(:,:)                 :: lonb, latb
type(time_type),  intent(in)                        :: Time
integer,          intent(in)                        :: axes(4)
real, intent(in), dimension(:,:,:), optional        :: mask
integer :: n, m
!
!-----------------------------------------------------------------------
!
      integer  unit,ierr,io
      character(len=1) :: numb(5)
      data numb/'1','2','3','4','5'/

      if (module_is_initialized) return

!-----------------------------------------------------------------------
!    read namelist.
!-----------------------------------------------------------------------
      if ( file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
        read (input_nml_file, nml=ssalt_nml, iostat=io)
        ierr = check_nml_error(io,'ssalt_nml')
#else
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=ssalt_nml, iostat=io, end=10)
        ierr = check_nml_error(io, 'ssalt_nml')
        end do
10      call close_file (unit)
#endif
      endif
!--------- write version and namelist to standard log ------------
      call write_version_number(version, tagname)
      logunit=stdlog()
      if ( mpp_pe() == mpp_root_pe() ) &
        write ( logunit, nml=ssalt_nml )
      if (scheme .eq. "Smith") then
        if (coef_emis1 .le. -990) then
          coef1 = 1.0
        else
          coef1 = coef_emis1
        endif
        if (coef_emis2 .le. -990) then
          coef2 = 1.0
        else
          coef2 = coef_emis2
        endif
      else
        if (coef_emis1 .le. -990) then
          coef1 = 0.38
        else
          coef1 = coef_emis1
        endif
        if (coef_emis2 .le. -990) then
          coef2 = 0.65
        else
          coef2 = coef_emis2
        endif
      endif

      betha = growth_table(46)  ! Growth factor at 80% RH

!----- set initial value of sea_salt ------------
       do m=1,5
       n = get_tracer_index(MODEL_ATMOS,'seasalt'//numb(m))
       if (n>0) then
         nseasalt=n
         if (nseasalt > 0 .and. mpp_pe() == mpp_root_pe()) write (*,30) 'Sea-salt',nseasalt
         if (nseasalt > 0 .and. mpp_pe() == mpp_root_pe()) write (logunit,30) 'Sea-salt',nseasalt
       endif
!

! Register a diagnostic field : emission of seasalt
       id_SS_emis(m) = register_diag_field ( mod_name,             &
                     'ssalt'//numb(m)//'_emis', axes(1:2),Time,          &
                     'ssalt'//numb(m)//'_emis', 'kg/m2/s',      &
                     missing_value=-999.  )

! Register a diagnostic field : settling of seasalt
       id_SS_setl(m) = register_diag_field ( mod_name,              &
                     'ssalt'//numb(m)//'_setl', axes(1:2),Time,        &
                     'ssalt'//numb(m)//'_setl', 'kg/m2/s',      &
                     missing_value=-999.  )
      enddo

      id_ocn_flx_fraction  = register_diag_field   &
                  ( mod_name,'salt_flux_area_frac', &
                   axes(1:2),Time,'fractional_area_with_salt_flux','-', &
                                                     missing_value=-999.)
      module_is_initialized = .TRUE.
 
  30        format (A,' was initialized as tracer number ',i2)

!-----------------------------------------------------------------------

 end subroutine atmos_sea_salt_init
!</SUBROUTINE>

!#######################################################################
!<SUBROUTINE NAME="atmos_sea_salt_end">
!<OVERVIEW>
!  The destructor routine for the sea_salt module.
!</OVERVIEW>
 subroutine atmos_sea_salt_end
 
      module_is_initialized = .FALSE.

 end subroutine atmos_sea_salt_end
!</SUBROUTINE>


end module atmos_sea_salt_mod

module bgrid_integrals_mod

!-----------------------------------------------------------------------
!
!   computes diagnostic integrals for the bgrid dynamical core
!
!-----------------------------------------------------------------------

use mpp_mod, only: input_nml_file
use bgrid_change_grid_mod, only: change_grid, TEMP_GRID, WIND_GRID
use       bgrid_horiz_mod, only: horiz_grid_type
use        bgrid_vert_mod, only:  vert_grid_type, compute_pres_depth
use       bgrid_masks_mod, only:  grid_mask_type
use    bgrid_prog_var_mod, only:   prog_var_type
use      time_manager_mod, only:  time_type, get_time, set_time,  &
                                  operator(+),  operator(-),      &
                                  operator(==), operator(>=),     &
                                  operator(/=), operator(/),      &
                                  operator(*)

use         fms_mod, only: file_exist, open_namelist_file,        &
                           check_nml_error, write_version_number, &
                           stdout, error_mesg, FATAL, NOTE
use   constants_mod, only: CP_AIR

use         mpp_mod, only: mpp_pe, mpp_root_pe, mpp_max, mpp_min, &
                           mpp_sum, stdlog
use      mpp_io_mod, only: mpp_open, mpp_close, MPP_ASCII,  &
                           MPP_OVERWR, MPP_SEQUENTIAL, MPP_SINGLE
use mpp_domains_mod, only: mpp_global_sum, BITWISE_EXACT_SUM

use  field_manager_mod, only: MODEL_ATMOS
use tracer_manager_mod, only: get_tracer_names, get_number_tracers, &
                              get_tracer_index

implicit none
private

!-----------------------------------------------------------------------
!------ interfaces ------

public :: bgrid_integrals, bgrid_integrals_init, bgrid_integrals_end, global_integral

!-----------------------------------------------------------------------
!--------------------- namelist ----------------------------------------

   integer, parameter :: MXCH = 64 ! maximum length of file names

! file_name  = optional file name for output (max length of 64 chars);
!              if no name is specified (the default) then
!              standard output will be used
!                 [character, default: filename  = ' ']

   character(len=MXCH) :: file_name = ' '

! time_units = specifies the time units used for time,
!              the following values are valid strings
!                 time_units = 'seconds'
!                            = 'minutes'
!                            = 'hours'   (default)
!                            = 'days'

   character(len=8) :: time_units = 'hours'

! output_interval = time interval in units of "time_units" for
!                   global b-grid integral diagnostics;
!                   * if an interval of zero is specified then no
!                     diagnostics will be generated
!                       [real, default: output_interval = 0.0]

   real :: output_interval = 0.0

! chksum_file_name = Optional file name for global integral output in
!                    hexadecimal format.  If this file name is set, then
!                    both the hexadecimal output and standard integral
!                    output will be computed using bit-reproducible summations.

   character(len=MXCH) :: chksum_file_name = ' '

! tracer_file_name = Optional file name for global integrals of all tracers.
!                    Up to 99 tracer integrals can be output in this file.

   character(len=MXCH) :: tracer_file_name = ' '

! trsout = Tracer names to be output in the standard integral file.
!          Only up to 4 names can be specified. For more tracer integrals
!          use the "tracer_file_name" option above.
!          A default has been set for the standard atmospheric model runs.

   integer, parameter :: MXTRS = 4
   character(len=MXCH) :: trsout(MXTRS) = &
                           (/'sphum  ','liq_wat','ice_wat','cld_amt'/)


   namelist /bgrid_integrals_nml/ output_interval, time_units,  &
                                  file_name, chksum_file_name,  &
                                  trsout, tracer_file_name

!-----------------------------------------------------------------------
! private interface

interface global_integral
  module procedure global_integral_2d, global_integral_3d
end interface

!-----------------------------------------------------------------------

   type (time_type) :: Next_diag_time, Output_diag_interval,  &
                       Base_time, Zero_time

   integer :: diag_unit   = 0
   integer :: chksum_unit = 0
   integer :: tracer_unit = 0
   logical :: alarm_set  = .false.
   logical :: do_init    = .true.
   logical :: do_header  = .true.
   logical :: do_chksum  = .false.
   logical :: do_decomp_check = .true.

   character(len=128) :: version = '$Id: bgrid_integrals.F90,v 19.0 2012/01/06 19:55:13 fms Exp $'
   character(len=128) :: tagname = '$Name: tikal $'

   character(len=256) :: frmat   ! format used for standard intergals

! output for tracers
   integer :: ntrout=-1, indout(MXTRS)

! output options
   integer, parameter :: STANDARD=11  ! new format: min temp and TE
   integer, parameter :: TRACER1 =12  ! detailed tracer 1 (for conservation checks)
   integer, parameter :: KENERGY =13  ! old format: zonal mean and eddy KE
   integer :: output_option = STANDARD

! quantities accumulated over the output period
   real :: windspeed_max
   real :: temperature_min
   integer :: num_in_avg  ! not actually used
!-----------------------------------------------------------------------

contains

!#######################################################################

 subroutine bgrid_integrals (Time, Hgrid, Vgrid, Var, Masks)

!-----------------------------------------------------------------------
!  Time  = current/diagnostics time
!  Hgrid = horizontal grid constants
!  Vgrid = vertical grid constants
!  Var   = prognostic variables
!  Masks = grid box masking constants (for eta coordinate)
!-----------------------------------------------------------------------

   type (time_type),      intent(in) :: Time
   type(horiz_grid_type), intent(in) :: Hgrid
   type (vert_grid_type), intent(in) :: Vgrid
   type  (prog_var_type), intent(in) :: Var
   type (grid_mask_type), intent(in) :: Masks

!-----------------------------------------------------------------------

   real, dimension (Hgrid%ilb:Hgrid%iub,          &
                    Hgrid%jlb:Hgrid%jub, Var%nlev) :: dpde, dpde_xy, avg
   real, dimension (Hgrid%ilb:Hgrid%iub,          &
                    Hgrid%jlb:Hgrid%jub)           :: pssl_xy, ps_xy

   real :: avgps, avgke, avgzke, avgeke, avgens, avgtemp, avgpsv, avgte
   real ::  xtime, vmax, tmin
  integer :: i, j, k, n, ntmax, nout, ind

     real, dimension(Var%ntrace) :: avgtrace
     real, dimension(MXTRS)      :: avgtrout
  character(len=21) :: fmt

!-----------------------------------------------------------------------

  if (do_init) call error_mesg ('bgrid_integrals_mod',  &
                                'must call bgrid_integrals_init', FATAL)

! no diagnostics
  if (Output_diag_interval == Zero_time) return
!-----------------------------------------------------------------------
!  the following quantities represent averages over the output period:
!          windspeed_max, temperature_min
!-----------------------------------------------------------------------
! maximum wind speed (use dpde_xy as temp storage)
! get local maximum on current PE then across PEs

  dpde_xy(:,:,:) = sqrt(Var%u(:,:,:)*Var%u(:,:,:)+  &
                        Var%v(:,:,:)*Var%v(:,:,:))

  vmax = maxval (dpde_xy(Hgrid%Vel%is:Hgrid%Vel%ie, Hgrid%Vel%js:Hgrid%Vel%je, :))
  call mpp_max (vmax)
  windspeed_max = max(windspeed_max,vmax)

! minimum temperature

  if (Masks%sigma) then
      tmin = minval (Var%t(Hgrid%Tmp%is:Hgrid%Tmp%ie, Hgrid%Tmp%js:Hgrid%Tmp%je, :))
  else
      tmin = minval (Var%t(Hgrid%Tmp%is:Hgrid%Tmp%ie, Hgrid%Tmp%js:Hgrid%Tmp%je, :), &
       mask=Masks%Tmp%mask(Hgrid%Tmp%is:Hgrid%Tmp%ie, Hgrid%Tmp%js:Hgrid%Tmp%je, :) > .1 )
  endif
  call mpp_min (tmin)
  temperature_min = min(temperature_min,tmin)

! increment counter (not actually used for computing averages)

  num_in_avg = num_in_avg + 1

!-----------------------------------------------------------------------
! check output alarm

  if ( .not. bgrid_integrals_alarm(Time) ) return

!-----------------------------------------------------------------------
! if there is decomposition along x-axis you will not get the
! correct integrals for zonal mean and eddy kinetic energy

  if (do_decomp_check) then
    if (mpp_pe() == mpp_root_pe()) then
      if ( Hgrid%decompx .and. output_option == KENERGY ) then
           call error_mesg ('bgrid_integrals',                    &
             'checksum integrals of zonal and eddy KE will not be &
              &exact with x-axis decomposition', NOTE )
      endif
    endif
    do_decomp_check = .false.
  endif

!-----------------------------------------------------------------------
!  the following quantities represent instantaneous values at the
!  end of the output period:   global-average pressure, temperature,
!              kinetic energy, total energy, enstrophy, and tracers.
!-----------------------------------------------------------------------
! compute pressure weights on mass grid and velocity grid

  call compute_pres_depth (Vgrid, Var%pssl, dpde)
  call change_grid        (Hgrid, TEMP_GRID, WIND_GRID, dpde, dpde_xy)

! global average of surface pressure on mass and velocity grid

  avgps  = global_integral (Hgrid, 1, Var%ps,  do_exact=do_chksum)
  avgpsv = global_integral (Hgrid, 2, dpde_xy, do_exact=do_chksum)

! global average of various kinetic energy terms
! normalize with mean global mass

  if (output_option == KENERGY) then
      call kinetic_energy (Hgrid, Masks, dpde_xy, Var%u, Var%v, avgke, avgzke, avgeke )
      avgke  = avgke /avgpsv  ! total ke
      avgzke = avgzke/avgpsv  ! zonal mean ke
      avgeke = avgeke/avgpsv  ! eddy ke
  else
      call kinetic_energy (Hgrid, Masks, dpde_xy, Var%u, Var%v, avgke )
      avgke  = avgke /avgpsv  ! total ke
  endif

! global average of enstrophy on mass grid
! scale result 

  call enstrophy (Hgrid, Masks, dpde, dpde_xy, Var%u, Var%v, avgens)
  avgens = 1.e10*avgens/avgps

! global average of temperature

   avg = Var%t * dpde
   avgtemp = global_integral(Hgrid, 1, avg, Masks, do_chksum) / avgps

! total energy (cp*T+KE)

   avgte = CP_AIR * avgtemp + avgke

! global average of tracer fields

 ! compute integrals for all tracers?
   if (tracer_file_name(1:1) .ne. ' ') then
      do n = 1, Var%ntrace
         avg = Var%r(:,:,:,n) * dpde
         avgtrace(n) = global_integral(Hgrid, 1, avg, Masks, do_chksum) / avgps
      enddo
   endif
         
 ! determine indices for output tracers (first time only)
   if (ntrout < 0) then
      ntmax = min(MXTRS,Var%ntrace)
      if (output_option == TRACER1) ntmax = 1
      ntrout = 0
    ! first output namelist tracers
      do n = 1, ntmax
         ind = get_tracer_index ( MODEL_ATMOS, trim(trsout(n)) )
         if (ind <= 0) cycle
         ntrout = ntrout+1
         indout(ntrout) = ind
      enddo
    ! then add additional output tracers (if possible)
      if (ntrout < ntmax .and. ntrout < Var%ntrace) then
          do ind = 1, Var%ntrace
             ! checking current list
             do n = 1, ntrout
                if (ind == indout(n)) go to 10
             enddo
             ! adding new tracer index
             ntrout = ntrout + 1
             indout(ntrout) = ind
             if (ntrout == ntmax) exit
          10 continue
          enddo
      endif
   endif

 ! compute integrals for output tracers in B-grid integral file
   do n = 1, ntrout
      if (tracer_file_name(1:1) .ne. ' ') then
          avgtrout(n) = avgtrace(indout(n))
      else
          avg = Var%r(:,:,:,indout(n)) * dpde
          avgtrout(n) = global_integral(Hgrid, 1, avg, Masks, do_chksum) / avgps
      endif
   enddo

! tracer conservation debugging option
   nout = ntrout
   if (output_option == TRACER1 .and. nout == 1) then
      if (indout(1) > 0) then
         avgtrout(2) = minval(Var%r(:,:,:,indout(1)))
         avgtrout(3) = maxval(Var%r(:,:,:,indout(1)))
         call mpp_min (avgtrout(2))
         call mpp_max (avgtrout(3))
         nout = 3
      endif
   endif

!-----------------------------------------------------------------------
! increment diagnostics alarm

  Next_diag_time = Next_diag_time + Output_diag_interval

!-----------------------------------------------------------------------
! output on root PE only

 if ( mpp_pe() == mpp_root_pe() ) then

      xtime = get_axis_time (Time, time_units)

      if (do_header) call diag_header

      select case (output_option)
         case (STANDARD)
            write (diag_unit,trim(frmat)) xtime, avgps, avgtemp, temperature_min, &
                                          windspeed_max, avgke, avgte, avgens,    &
                                          (avgtrout(n),n=1,nout)
         case (TRACER1)
            write (diag_unit,trim(frmat)) xtime, avgps, avgtemp, temperature_min, &
                                          windspeed_max, avgke, avgte, avgens,    &
                                          (avgtrout(n),n=1,nout)
         case (KENERGY)
            write (diag_unit,trim(frmat)) xtime, avgps, avgtemp, windspeed_max, &
                                          avgke, avgzke, avgeke, avgens,        &
                                          (avgtrout(n),n=1,nout)
      end select

      if (do_chksum) then
          write (chksum_unit,8200) xtime, avgps, avgtemp, windspeed_max, avgens, &
                                   avgke, (avgtrout(n),n=1,min(nout,1))
 8200     format (1x,f10.2,2x,6z18)
      endif


!---- output additional tracers ----

     if (tracer_file_name(1:1) .ne. ' ') then
!        ---- open file, write header ----
         if (tracer_unit == 0) then
             call  mpp_open (tracer_unit, trim(tracer_file_name), &
                             form=MPP_ASCII, action=MPP_OVERWR,   &
                             access=MPP_SEQUENTIAL, threading=MPP_SINGLE, &
                             nohdrs=.true.)
             write (tracer_unit,8300)
         endif
         ! output up to 99 tracers
         write (fmt,8310) min(Var%ntrace,99)
         write (tracer_unit,fmt) xtime, (avgtrace(n),n=1,min(Var%ntrace,99))
     endif

 8300 format ('#',6x,'n', 8x, 'tracers --->')
 8310 format ('(1x,f10.2,2x,',i2.2,'e13.6)')

 endif

! reset 
  windspeed_max   = 0.
  temperature_min = 500.
  num_in_avg      = 0
!-----------------------------------------------------------------------

 end subroutine bgrid_integrals

!#######################################################################

 subroutine bgrid_integrals_init (Time_init, Time)

!----------------------------------------------------
!  Time_init = base time for experiment
!                the base time will be subtracted from all
!                specified times before that time is output/written.
!  Time      = current time
!----------------------------------------------------

    type (time_type), intent(in) :: Time_init, Time
      
    integer :: unit, io, ierr, seconds, nc, logunit
    type (time_type) :: Time_dif, Last_diag

!-----------------------------------------------------------------------
!       ----- read namelist -----
!      ----- write namelist (to standard output) -----

      if ( file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
         read (input_nml_file, nml=bgrid_integrals_nml, iostat=io)
         ierr = check_nml_error(io,'bgrid_integrals_nml')
#else
         unit = open_namelist_file ( )
         ierr=1; do while (ierr /= 0)
            read  (unit, nml=bgrid_integrals_nml, iostat=io, end=10)
            ierr = check_nml_error (io, 'bgrid_integrals_nml')
         enddo
  10     call mpp_close (unit)
#endif
      endif

      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe()) write (logunit, nml=bgrid_integrals_nml)
      do_init = .false. 

!----- initialize alarm if not already done -----

      Zero_time = set_time (0,0)
      Base_time = Time_init

    ! set output interval
      if ( output_interval > 0.0 ) then
         Output_diag_interval = set_axis_time (output_interval, time_units)
      else
       ! no diagnostics
         Output_diag_interval = Zero_time
      endif
      if ( Output_diag_interval == Zero_time ) return

    ! current diag time (base time subtracted off)
      Time_dif  = Time - Base_time
    ! last time of diagnostics
      Last_diag = (Time_dif/Output_diag_interval)*Output_diag_interval
      if ( Last_diag == Time_dif ) then
            Next_diag_time = Last_diag ! repeat diag at start of run
      else
            Next_diag_time = Last_diag + Output_diag_interval
      endif
      
!--- initialize diagnostics output unit/file ? ----

      if ( file_name(1:1) /= ' ' ) then
          call  mpp_open (diag_unit, trim(file_name), form=MPP_ASCII, &
                          action=MPP_OVERWR, access=MPP_SEQUENTIAL,   &
                          threading=MPP_SINGLE, nohdrs=.true.)
      else
          diag_unit = stdout()
      endif

      if ( chksum_file_name(1:1) /= ' ' ) then
          call  mpp_open (chksum_unit, trim(chksum_file_name),  &
                          form=MPP_ASCII, action=MPP_OVERWR,    &
                          access=MPP_SEQUENTIAL, threading=MPP_SINGLE, &
                          nohdrs=.true.)
        do_chksum = .true.
      endif


! reset quantities accumulated over the output period
! NOTE: will need a restart file if the end of the output period
!       does not coincide with the end of the model run.

  windspeed_max   = 0.
  temperature_min = 500.
  num_in_avg      = 0

!-----------------------------------------------------------------------

 end subroutine bgrid_integrals_init

!#######################################################################

 subroutine bgrid_integrals_end

! close all open units
  if (  diag_unit > 0 .and. diag_unit /= stdout()) &
                       call mpp_close (diag_unit)
  if (chksum_unit > 0) call mpp_close (chksum_unit)
  if (tracer_unit > 0) call mpp_close (tracer_unit)

! need to write a restart file if the end of the output period
! does not coincide with the end of the model run

  if (num_in_avg > 0 .and. mpp_pe() == mpp_root_pe()) then
   ! print a note for now
     call error_mesg ('bgrid_integrals_mod',  &
          'end of the output period did not coincide &
           &with the end of the model run', NOTE)
  endif

 end subroutine bgrid_integrals_end

!#######################################################################

 function bgrid_integrals_alarm (Time) result (answer)

    type (time_type), intent(in) :: Time
    logical                      :: answer

!-----------------------------------------------------------------------
!----- check the diagnostics alarm -----

      answer = .false.

!----- sound the diagnostics alarm -----

      if (Time - Base_time >= Next_diag_time) answer = .true.

 end function bgrid_integrals_alarm

!#######################################################################

 subroutine diag_header

 character(len=24) :: lab_time, lab_ps, lab_tavg, lab_tmin, lab_vmax, &
                      lab_ke, lab_zke, lab_eke, lab_te, lab_ens,      &
                      lab_trs, lab_tr1
 character(len=24) :: fmt_time, fmt_ps, fmt_tavg, fmt_tmin, fmt_vmax, &
                      fmt_ke, fmt_zke, fmt_eke, fmt_te, fmt_ens,      &
                      fmt_trs, fmt_tr1
 character(len=256) :: title
 character(len=64)  :: lab_tr, trname
 integer :: n


 lab_time = '''#'',5x,''n'',3x,' ; fmt_time = 'f10.2'
 lab_ps   = '5x,''ps'',4x,'      ; fmt_ps   = ',1x,f10.3'
 lab_tavg = '3x,''tavg'',1x,'    ; fmt_tavg = ',1x,f7.3'
 lab_tmin = '3x,''tmin'',1x,'    ; fmt_tmin = ',1x,f7.3'
 lab_vmax = '3x,''vmax'',2x,'    ; fmt_vmax = ',1x,f8.4'
 lab_ke   = '4x,''ke'',2x,'      ; fmt_ke   = ',1x,f7.2'
 lab_zke  = '4x,''zke'',1x,'     ; fmt_zke  = ',1x,f7.2'
 lab_eke  = '4x,''eke'',1x,'     ; fmt_eke  = ',1x,f7.2'
 lab_te   = '5x,''te'',4x,'      ; fmt_te   = ',1x,f10.3'
 lab_ens  = '6x,''ens'',5x,'     ; fmt_ens  = ',1x,e13.6'
 lab_trs  = '3x'                 ; fmt_trs  = ',2x,4e13.6'
!lab_trs  = '7x,''trs --->'''    ; fmt_trs  = ',2x,4e13.6'
 lab_tr1  = '7x,''tr1 --->'''    ; fmt_tr1  = ',1x,3e22.14'

 select case (output_option)

   case (STANDARD)
     title = '('//trim(lab_time)//trim(lab_ps)//trim(lab_tavg) &
                //trim(lab_tmin)//trim(lab_vmax)//trim(lab_ke) &
                //trim(lab_te)//trim(lab_ens)//trim(lab_trs)
     frmat = '('//trim(fmt_time)//trim(fmt_ps)//trim(fmt_tavg) &
                //trim(fmt_tmin)//trim(fmt_vmax)//trim(fmt_ke) &
                //trim(fmt_te)//trim(fmt_ens)//trim(fmt_trs)//')'
 
   case (KENERGY)
     title = '('//trim(lab_time)//trim(lab_ps)//trim(lab_tavg) &
                //trim(lab_vmax)//trim(lab_ke)//trim(lab_zke)  &
                //trim(lab_eke)//trim(lab_ens)//trim(lab_trs)
     frmat = '('//trim(fmt_time)//trim(fmt_ps)//trim(fmt_tavg) &
                //trim(fmt_vmax)//trim(fmt_ke)//trim(fmt_zke)  &
                //trim(fmt_eke)//trim(fmt_ens)//trim(fmt_trs)//')'
 
   case (TRACER1)
     title = '('//trim(lab_time)//trim(lab_ps)//trim(lab_tavg) &
                //trim(lab_tmin)//trim(lab_vmax)//trim(lab_ke) &
                //trim(lab_te)//trim(lab_ens)//trim(lab_trs)
     frmat = '('//trim(fmt_time)//trim(fmt_ps)//trim(fmt_tavg) &
                //trim(fmt_tmin)//trim(fmt_vmax)//trim(fmt_ke) &
                //trim(fmt_te)//trim(fmt_ens)//trim(fmt_tr1)//')'

 end select

   ! labels for tracers
     do n = 1, ntrout
        call get_tracer_names (MODEL_ATMOS,indout(n),trname)
        lab_tr = '4x,'//trim(trname)//''
        write (lab_tr,10) trim(trname)
     10 format (',2x,''',a9,''',2x')
        title = trim(title)//trim(lab_tr)
     enddo
     if (output_option == TRACER1) title = trim(title)//',''(avg,min,max)'''
     title = trim(title)//')'
    !if (mpp_pe() == mpp_root_pe()) print *, 'title=',trim(title)


   ! write the header/labels
     write (diag_unit,trim(title))


   ! for the exact integral file
     if (do_chksum) then
         write (chksum_unit,8002)
     endif
8002 format ('#',6x,'n', 14x, 'ps',  15x,  'temp', 13x, 'max vel', &
                         12x, 'ens', 16x, 'ke', 13x, 'tracer 1')

 do_header = .false.


 end subroutine diag_header

!#######################################################################

 subroutine kinetic_energy (Hgrid, Masks, dpde, u, v,   &
                            gke, gmke, geke )

 type(horiz_grid_type), intent(in)                     :: Hgrid
 type (grid_mask_type), intent(in)                     :: Masks
 real, intent(in) , dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: dpde, u, v
 real, intent(out)                                     :: gke
 real, intent(out), optional                           :: gmke, geke
!-----------------------------------------------------------------------

   real, dimension (Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub,  &
                    size(u,3)) :: ke, mke, eke
   real, dimension (Hgrid%ilb:Hgrid%iub) :: ustar, vstar
   real    :: usum, vsum, wsum, uavg, vavg
   integer :: i, j, k, is, ie

!-----------------------------------------------------------------------
!---- zero out quantities ----

      mke = 0.;  eke = 0.

!---- total kinetic energy (2x) ----

      ke(:,:,:) = dpde(:,:,:)*(u(:,:,:)**2+v(:,:,:)**2)
      gke = global_integral (Hgrid, 2,  ke, Masks, do_chksum) * 0.50

!---- compute mean zonal and eddy kinetic energy -----

      if (.not.present(gmke) .and. .not.present(geke)) return

      is=Hgrid%Vel%is
      ie=Hgrid%Vel%ie

      do k = 1, size(u,3)
      do j = Hgrid%Vel%js, Hgrid%Vel%je

         wsum = sum(Masks%Vel%mask(is:ie,j,k))

         if (wsum > 0.50) then
          ! zonal mean
            usum = sum(Masks%Vel%mask(is:ie,j,k)*u(is:ie,j,k))
            vsum = sum(Masks%Vel%mask(is:ie,j,k)*v(is:ie,j,k))
            uavg = usum/wsum
            vavg = vsum/wsum

          ! zonal eddy components
            ustar(:) = u(:,j,k)-uavg
            vstar(:) = v(:,j,k)-vavg

          ! zonal mean ke (2x)
            mke(:,j,k) = dpde(:,j,k)*(uavg**2+vavg**2)
          ! eddy ke (2x)
            eke(:,j,k) = dpde(:,j,k)*(ustar(:)**2+vstar(:)**2)
         else
            mke(:,j,k) = 0.0
            eke(:,j,k) = 0.0
         endif

      enddo
      enddo

    ! 3-dim global integrals
      if (present(gmke)) &
          gmke = global_integral (Hgrid, 2, mke, Masks, do_chksum) * 0.50
      if (present(geke)) &
          geke = global_integral (Hgrid, 2, eke, Masks, do_chksum) * 0.50

!-----------------------------------------------------------------------

 end subroutine kinetic_energy

!#######################################################################

 subroutine enstrophy (Hgrid, Masks, dpde, dpde_xy, u, v, avgens)

!-----------------------------------------------------------------------
   type(horiz_grid_type), intent(in)       :: Hgrid
   type (grid_mask_type), intent(in)       :: Masks
      real, intent(in), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: dpde,  &
                                                          dpde_xy, u, v
      real, intent(out) :: avgens
!-----------------------------------------------------------------------

   real, dimension (Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub, size(u,3)) :: ens

   real, dimension (Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub) :: &
                                            vdy,  udx, avdy, audx, vort
   real, dimension (Hgrid%jlb:Hgrid%jub) :: fens

   integer :: i, j, k, is, ie, js, je
   real    :: dysq

!-----------------------------------------------------------------------

      is = Hgrid%Tmp%is;  ie = Hgrid%Tmp%ie
      js = Hgrid%Tmp%js;  je = Hgrid%Tmp%je

!-----------------------------------------------------------------------

      ens = 0.0;  vort = 0.0
      fens = 0.25*Hgrid%Tmp%rarea*Hgrid%Tmp%rarea

      do k = 1, size(u,3)

         do j = js-1, je
            vdy(:,j) = v(:,j,k)*dpde_xy(:,j,k)*Hgrid%Vel%dy
            udx(:,j) = u(:,j,k)*dpde_xy(:,j,k)*Hgrid%Vel%dx(j)
         enddo

         do j = js,   je
         do i = is-1, ie
            avdy(i,j) = vdy(i,j-1)+vdy(i,j)
         enddo
         enddo
         do j = js-1, je
         do i = is,   ie
            audx(i,j) = udx(i-1,j)+udx(i,j)
         enddo
         enddo

!        ------ vorticity * dpde_xy * area ------
         do j = js, je
         do i = is, ie
            vort(i,j)=((avdy(i,j)-avdy(i-1,j))-(audx(i,j)-audx(i,j-1)))
         enddo
         enddo

!        ------ enstrophy ------
         do j = js, je
            ens(:,j,k) = vort(:,j)*vort(:,j)*fens(j)/dpde(:,j,k)
         enddo

      enddo

!-----------------------------------------------------------------------

      avgens = global_integral (Hgrid, 1, ens, Masks, do_chksum)

!-----------------------------------------------------------------------

 end subroutine enstrophy

!#######################################################################
!#######################################################################

function get_axis_time (Time, units) result (atime)

   type(time_type),  intent(in) :: Time
   character(len=*), intent(in) :: units
   real                         :: atime
   integer                      :: sec, day

!---- returns real time in the time axis units ----
!---- convert time type to appropriate real units ----

      call get_time (Time-Base_time, sec, day)

      if (units(1:3) == 'sec') then
         atime = float(sec) + 86400.*float(day)
      else if (units(1:3) == 'min') then
         atime = float(sec)/60. + 1440.*float(day)
      else if (units(1:3) == 'hou') then
         atime = float(sec)/3600. + 24.*float(day)
      else if (units(1:3) == 'day') then
         atime = float(sec)/86400. + float(day)
      endif

end function get_axis_time

!#######################################################################

function set_axis_time (atime, units) result (Time)

   real,             intent(in) :: atime
   character(len=*), intent(in) :: units
   type(time_type)  :: Time
   integer          :: sec, day = 0

!---- returns time type given real time in axis units ----
!---- convert real time units to time type ----

      if (units(1:3) == 'sec') then
         sec = int(atime + 0.5)
      else if (units(1:3) == 'min') then
         sec = int(atime*60. + 0.5)
      else if (units(1:3) == 'hou') then
         sec = int(atime*3600. + 0.5)
      else if (units(1:3) == 'day') then
         sec = int(atime*86400. + 0.5)
      endif

!     --- do not add in base time ---

      Time = set_time (sec, day)

end function set_axis_time

!#######################################################################
!####### global averaging routines for the bgrid model #################
!#######################################################################

function global_integral_2d (Hgrid, grid, data, do_exact)  &
                     result (avg)

   type(horiz_grid_type), intent(in) :: Hgrid
integer, intent(in)  :: grid
   real, intent(in)  :: data(Hgrid%ilb:,Hgrid%jlb:)
logical, intent(in), optional :: do_exact
   real :: avg

   real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub) :: aa
   real :: asum, wsum
integer :: i, j, isd, ied, vsd, ved
logical :: bitwise_exact

!-----------------------------------------------------------------------

   bitwise_exact = .false.
   if (present(do_exact)) bitwise_exact = do_exact

!  average on mass grid
   select case (grid)
      case(1)
        do j = Hgrid%Tmp%jsd, Hgrid%Tmp%jed
        do i = Hgrid%Tmp%isd, Hgrid%Tmp%ied
           aa(i,j)= data(i,j) * Hgrid%Tmp%area(j)
        enddo
        enddo
        if ( bitwise_exact ) then
            asum = mpp_global_sum ( Hgrid%Tmp%Domain, aa, flags=BITWISE_EXACT_SUM )
        else
            asum = mpp_global_sum ( Hgrid%Tmp%Domain, aa )
        endif
            wsum = Hgrid%Tmp%areasum

!  average on velocity grid
      case(2:3)
      ! must pass data domain to mpp_global_sum
        isd = Hgrid%Vel%isd;  ied = Hgrid%Vel%ied
        vsd = Hgrid%Vel%jsd;  ved = Hgrid%Vel%jed
        do j = vsd, ved
        do i = isd, ied
           aa(i,j)= data(i,j) * Hgrid%Vel%area(j)
        enddo
        enddo
        if ( bitwise_exact ) then
            asum = mpp_global_sum ( Hgrid%Vel%Domain, aa(isd:ied,vsd:ved), &
                                    flags=BITWISE_EXACT_SUM )
        else
            asum = mpp_global_sum ( Hgrid%Vel%Domain, aa(isd:ied,vsd:ved) )
        endif
            wsum = Hgrid%Vel%areasum

   end select

   if (wsum <= 0.0) call error_mesg ('global_integral_2d in bgrid_integrals_mod', &
                                     'wsum=0', FATAL)

   avg = asum/wsum

end function global_integral_2d

!#######################################################################

function global_integral_3d (Hgrid, grid, data, Masks, do_exact)  &
                     result (avg)

type(horiz_grid_type), intent(in) :: Hgrid
integer,               intent(in) :: grid
real,                  intent(in) :: data(Hgrid%ilb:,Hgrid%jlb:,:) 
type (grid_mask_type), intent(in), optional :: Masks
logical,               intent(in), optional :: do_exact
real :: avg
real, dimension(size(data,1),size(data,2)) :: aa

!-----------------------------------------------------------------------

 if (present(Masks)) then
   select case (grid)
      case(1)
         aa = sum( data*Masks%Tmp%mask, dim=3 )
      case(2:3)
         aa = sum( data*Masks%Vel%mask, dim=3 )
   end select
 else
         aa = sum( data, dim=3 )
 endif

   avg = global_integral_2d (Hgrid, grid, aa, do_exact)

!-----------------------------------------------------------------------

end function global_integral_3d

!#######################################################################
!#######################################################################

end module bgrid_integrals_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL
 
!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: mrgrnk.F90,v 20.0 2013/12/13 23:16:49 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

Module m_mrgrnk
Integer, Parameter :: kdp = selected_real_kind(15)
public :: mrgrnk
private :: kdp
private :: R_mrgrnk, I_mrgrnk, D_mrgrnk
interface mrgrnk
  module procedure D_mrgrnk, R_mrgrnk, I_mrgrnk
end interface mrgrnk
contains

Subroutine D_mrgrnk (XDONT, IRNGT)
! __________________________________________________________
!   MRGRNK = Merge-sort ranking of an array
!   For performance reasons, the first 2 passes are taken
!   out of the standard loop, and use dedicated coding.
! __________________________________________________________
! __________________________________________________________
      Real (kind=kdp), Dimension (:), Intent (In) :: XDONT
      Integer*4, Dimension (:), Intent (Out) :: IRNGT
! __________________________________________________________
      Real (kind=kdp) :: XVALA, XVALB
!
      Integer, Dimension (SIZE(IRNGT)) :: JWRKT
      Integer :: LMTNA, LMTNC, IRNG1, IRNG2
      Integer :: NVAL, IIND, IWRKD, IWRK, IWRKF, JINDA, IINDA, IINDB
!
      NVAL = Min (SIZE(XDONT), SIZE(IRNGT))
      Select Case (NVAL)
      Case (:0)
         Return
      Case (1)
         IRNGT (1) = 1
         Return
      Case Default
         Continue
      End Select
!
!  Fill-in the index array, creating ordered couples
!
      Do IIND = 2, NVAL, 2
         If (XDONT(IIND-1) <= XDONT(IIND)) Then
            IRNGT (IIND-1) = IIND - 1
            IRNGT (IIND) = IIND
         Else
            IRNGT (IIND-1) = IIND
            IRNGT (IIND) = IIND - 1
         End If
      End Do
      If (Modulo(NVAL, 2) /= 0) Then
         IRNGT (NVAL) = NVAL
      End If
!
!  We will now have ordered subsets A - B - A - B - ...
!  and merge A and B couples into     C   -   C   - ...
!
      LMTNA = 2
      LMTNC = 4
!
!  First iteration. The length of the ordered subsets goes from 2 to 4
!
      Do
         If (NVAL <= 2) Exit
!
!   Loop on merges of A and B into C
!
         Do IWRKD = 0, NVAL - 1, 4
            If ((IWRKD+4) > NVAL) Then
               If ((IWRKD+2) >= NVAL) Exit
!
!   1 2 3
!
               If (XDONT(IRNGT(IWRKD+2)) <= XDONT(IRNGT(IWRKD+3))) Exit
!
!   1 3 2
!
               If (XDONT(IRNGT(IWRKD+1)) <= XDONT(IRNGT(IWRKD+3))) Then
                  IRNG2 = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNG2
!
!   3 1 2
!
               Else
                  IRNG1 = IRNGT (IWRKD+1)
                  IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNG1
               End If
               Exit
            End If
!
!   1 2 3 4
!
            If (XDONT(IRNGT(IWRKD+2)) <= XDONT(IRNGT(IWRKD+3))) Cycle
!
!   1 3 x x
!
            If (XDONT(IRNGT(IWRKD+1)) <= XDONT(IRNGT(IWRKD+3))) Then
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
               If (XDONT(IRNG2) <= XDONT(IRNGT(IWRKD+4))) Then
!   1 3 2 4
                  IRNGT (IWRKD+3) = IRNG2
               Else
!   1 3 4 2
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+4) = IRNG2
               End If
!
!   3 x x x
!
            Else
               IRNG1 = IRNGT (IWRKD+1)
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
               If (XDONT(IRNG1) <= XDONT(IRNGT(IWRKD+4))) Then
                  IRNGT (IWRKD+2) = IRNG1
                  If (XDONT(IRNG2) <= XDONT(IRNGT(IWRKD+4))) Then
!   3 1 2 4
                     IRNGT (IWRKD+3) = IRNG2
                  Else
!   3 1 4 2
                     IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                     IRNGT (IWRKD+4) = IRNG2
                  End If
               Else
!   3 4 1 2
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+3) = IRNG1
                  IRNGT (IWRKD+4) = IRNG2
               End If
            End If
         End Do
!
!  The Cs become As and Bs
!
         LMTNA = 4
         Exit
      End Do
!
!  Iteration loop. Each time, the length of the ordered subsets
!  is doubled.
!
      Do
         If (LMTNA >= NVAL) Exit
         IWRKF = 0
         LMTNC = 2 * LMTNC
!
!   Loop on merges of A and B into C
!
         Do
            IWRK = IWRKF
            IWRKD = IWRKF + 1
            JINDA = IWRKF + LMTNA
            IWRKF = IWRKF + LMTNC
            If (IWRKF >= NVAL) Then
               If (JINDA >= NVAL) Exit
               IWRKF = NVAL
            End If
            IINDA = 1
            IINDB = JINDA + 1
!
!   Shortcut for the case when the max of A is smaller
!   than the min of B. This line may be activated when the
!   initial set is already close to sorted.
!
!          IF (XDONT(IRNGT(JINDA)) <= XDONT(IRNGT(IINDB))) CYCLE
!
!  One steps in the C subset, that we build in the final rank array
!
!  Make a copy of the rank array for the merge iteration
!
            JWRKT (1:LMTNA) = IRNGT (IWRKD:JINDA)
!
            XVALA = XDONT (JWRKT(IINDA))
            XVALB = XDONT (IRNGT(IINDB))
!
            Do
               IWRK = IWRK + 1
!
!  We still have unprocessed values in both A and B
!
               If (XVALA > XVALB) Then
                  IRNGT (IWRK) = IRNGT (IINDB)
                  IINDB = IINDB + 1
                  If (IINDB > IWRKF) Then
!  Only A still with unprocessed values
                     IRNGT (IWRK+1:IWRKF) = JWRKT (IINDA:LMTNA)
                     Exit
                  End If
                  XVALB = XDONT (IRNGT(IINDB))
               Else
                  IRNGT (IWRK) = JWRKT (IINDA)
                  IINDA = IINDA + 1
                  If (IINDA > LMTNA) Exit! Only B still with unprocessed values
                  XVALA = XDONT (JWRKT(IINDA))
               End If
!
            End Do
         End Do
!
!  The Cs become As and Bs
!
         LMTNA = 2 * LMTNA
      End Do
!
      Return
!
End Subroutine D_mrgrnk

Subroutine R_mrgrnk (XDONT, IRNGT)
! __________________________________________________________
!   MRGRNK = Merge-sort ranking of an array
!   For performance reasons, the first 2 passes are taken
!   out of the standard loop, and use dedicated coding.
! __________________________________________________________
! _________________________________________________________
#ifdef COSP_GFDL
!RSH:
!   this declaration is needed because "REAL" in FMS has been set to
!   64bit. Without use of the kind keyword, the interfaces to module
!   procedures D_mrgrnk and R_mrgrnk become identical, which upsets at 
!   least some compilers.
      Integer, Parameter :: ksp = selected_real_kind(6)
      Real(kind=ksp), Dimension (:), Intent (In) :: XDONT
#else
      Real, Dimension (:), Intent (In) :: XDONT
#endif
      Integer*4, Dimension (:), Intent (Out) :: IRNGT
! __________________________________________________________
      Real :: XVALA, XVALB
!
      Integer, Dimension (SIZE(IRNGT)) :: JWRKT
      Integer :: LMTNA, LMTNC, IRNG1, IRNG2
      Integer :: NVAL, IIND, IWRKD, IWRK, IWRKF, JINDA, IINDA, IINDB
!
      NVAL = Min (SIZE(XDONT), SIZE(IRNGT))
      Select Case (NVAL)
      Case (:0)
         Return
      Case (1)
         IRNGT (1) = 1
         Return
      Case Default
         Continue
      End Select
!
!  Fill-in the index array, creating ordered couples
!
      Do IIND = 2, NVAL, 2
         If (XDONT(IIND-1) <= XDONT(IIND)) Then
            IRNGT (IIND-1) = IIND - 1
            IRNGT (IIND) = IIND
         Else
            IRNGT (IIND-1) = IIND
            IRNGT (IIND) = IIND - 1
         End If
      End Do
      If (Modulo(NVAL, 2) /= 0) Then
         IRNGT (NVAL) = NVAL
      End If
!
!  We will now have ordered subsets A - B - A - B - ...
!  and merge A and B couples into     C   -   C   - ...
!
      LMTNA = 2
      LMTNC = 4
!
!  First iteration. The length of the ordered subsets goes from 2 to 4
!
      Do
         If (NVAL <= 2) Exit
!
!   Loop on merges of A and B into C
!
         Do IWRKD = 0, NVAL - 1, 4
            If ((IWRKD+4) > NVAL) Then
               If ((IWRKD+2) >= NVAL) Exit
!
!   1 2 3
!
               If (XDONT(IRNGT(IWRKD+2)) <= XDONT(IRNGT(IWRKD+3))) Exit
!
!   1 3 2
!
               If (XDONT(IRNGT(IWRKD+1)) <= XDONT(IRNGT(IWRKD+3))) Then
                  IRNG2 = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNG2
!
!   3 1 2
!
               Else
                  IRNG1 = IRNGT (IWRKD+1)
                  IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNG1
               End If
               Exit
            End If
!
!   1 2 3 4
!
            If (XDONT(IRNGT(IWRKD+2)) <= XDONT(IRNGT(IWRKD+3))) Cycle
!
!   1 3 x x
!
            If (XDONT(IRNGT(IWRKD+1)) <= XDONT(IRNGT(IWRKD+3))) Then
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
               If (XDONT(IRNG2) <= XDONT(IRNGT(IWRKD+4))) Then
!   1 3 2 4
                  IRNGT (IWRKD+3) = IRNG2
               Else
!   1 3 4 2
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+4) = IRNG2
               End If
!
!   3 x x x
!
            Else
               IRNG1 = IRNGT (IWRKD+1)
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
               If (XDONT(IRNG1) <= XDONT(IRNGT(IWRKD+4))) Then
                  IRNGT (IWRKD+2) = IRNG1
                  If (XDONT(IRNG2) <= XDONT(IRNGT(IWRKD+4))) Then
!   3 1 2 4
                     IRNGT (IWRKD+3) = IRNG2
                  Else
!   3 1 4 2
                     IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                     IRNGT (IWRKD+4) = IRNG2
                  End If
               Else
!   3 4 1 2
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+3) = IRNG1
                  IRNGT (IWRKD+4) = IRNG2
               End If
            End If
         End Do
!
!  The Cs become As and Bs
!
         LMTNA = 4
         Exit
      End Do
!
!  Iteration loop. Each time, the length of the ordered subsets
!  is doubled.
!
      Do
         If (LMTNA >= NVAL) Exit
         IWRKF = 0
         LMTNC = 2 * LMTNC
!
!   Loop on merges of A and B into C
!
         Do
            IWRK = IWRKF
            IWRKD = IWRKF + 1
            JINDA = IWRKF + LMTNA
            IWRKF = IWRKF + LMTNC
            If (IWRKF >= NVAL) Then
               If (JINDA >= NVAL) Exit
               IWRKF = NVAL
            End If
            IINDA = 1
            IINDB = JINDA + 1
!
!   Shortcut for the case when the max of A is smaller
!   than the min of B. This line may be activated when the
!   initial set is already close to sorted.
!
!          IF (XDONT(IRNGT(JINDA)) <= XDONT(IRNGT(IINDB))) CYCLE
!
!  One steps in the C subset, that we build in the final rank array
!
!  Make a copy of the rank array for the merge iteration
!
            JWRKT (1:LMTNA) = IRNGT (IWRKD:JINDA)
!
            XVALA = XDONT (JWRKT(IINDA))
            XVALB = XDONT (IRNGT(IINDB))
!
            Do
               IWRK = IWRK + 1
!
!  We still have unprocessed values in both A and B
!
               If (XVALA > XVALB) Then
                  IRNGT (IWRK) = IRNGT (IINDB)
                  IINDB = IINDB + 1
                  If (IINDB > IWRKF) Then
!  Only A still with unprocessed values
                     IRNGT (IWRK+1:IWRKF) = JWRKT (IINDA:LMTNA)
                     Exit
                  End If
                  XVALB = XDONT (IRNGT(IINDB))
               Else
                  IRNGT (IWRK) = JWRKT (IINDA)
                  IINDA = IINDA + 1
                  If (IINDA > LMTNA) Exit! Only B still with unprocessed values
                  XVALA = XDONT (JWRKT(IINDA))
               End If
!
            End Do
         End Do
!
!  The Cs become As and Bs
!
         LMTNA = 2 * LMTNA
      End Do
!
      Return
!
End Subroutine R_mrgrnk
Subroutine I_mrgrnk (XDONT, IRNGT)
! __________________________________________________________
!   MRGRNK = Merge-sort ranking of an array
!   For performance reasons, the first 2 passes are taken
!   out of the standard loop, and use dedicated coding.
! __________________________________________________________
! __________________________________________________________
      Integer, Dimension (:), Intent (In)  :: XDONT
      Integer*4, Dimension (:), Intent (Out) :: IRNGT
! __________________________________________________________
      Integer :: XVALA, XVALB
!
      Integer, Dimension (SIZE(IRNGT)) :: JWRKT
      Integer :: LMTNA, LMTNC, IRNG1, IRNG2
      Integer :: NVAL, IIND, IWRKD, IWRK, IWRKF, JINDA, IINDA, IINDB
!
      NVAL = Min (SIZE(XDONT), SIZE(IRNGT))
      Select Case (NVAL)
      Case (:0)
         Return
      Case (1)
         IRNGT (1) = 1
         Return
      Case Default
         Continue
      End Select
!
!  Fill-in the index array, creating ordered couples
!
      Do IIND = 2, NVAL, 2
         If (XDONT(IIND-1) <= XDONT(IIND)) Then
            IRNGT (IIND-1) = IIND - 1
            IRNGT (IIND) = IIND
         Else
            IRNGT (IIND-1) = IIND
            IRNGT (IIND) = IIND - 1
         End If
      End Do
      If (Modulo(NVAL, 2) /= 0) Then
         IRNGT (NVAL) = NVAL
      End If
!
!  We will now have ordered subsets A - B - A - B - ...
!  and merge A and B couples into     C   -   C   - ...
!
      LMTNA = 2
      LMTNC = 4
!
!  First iteration. The length of the ordered subsets goes from 2 to 4
!
      Do
         If (NVAL <= 2) Exit
!
!   Loop on merges of A and B into C
!
         Do IWRKD = 0, NVAL - 1, 4
            If ((IWRKD+4) > NVAL) Then
               If ((IWRKD+2) >= NVAL) Exit
!
!   1 2 3
!
               If (XDONT(IRNGT(IWRKD+2)) <= XDONT(IRNGT(IWRKD+3))) Exit
!
!   1 3 2
!
               If (XDONT(IRNGT(IWRKD+1)) <= XDONT(IRNGT(IWRKD+3))) Then
                  IRNG2 = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNG2
!
!   3 1 2
!
               Else
                  IRNG1 = IRNGT (IWRKD+1)
                  IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNG1
               End If
               Exit
            End If
!
!   1 2 3 4
!
            If (XDONT(IRNGT(IWRKD+2)) <= XDONT(IRNGT(IWRKD+3))) Cycle
!
!   1 3 x x
!
            If (XDONT(IRNGT(IWRKD+1)) <= XDONT(IRNGT(IWRKD+3))) Then
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
               If (XDONT(IRNG2) <= XDONT(IRNGT(IWRKD+4))) Then
!   1 3 2 4
                  IRNGT (IWRKD+3) = IRNG2
               Else
!   1 3 4 2
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+4) = IRNG2
               End If
!
!   3 x x x
!
            Else
               IRNG1 = IRNGT (IWRKD+1)
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
               If (XDONT(IRNG1) <= XDONT(IRNGT(IWRKD+4))) Then
                  IRNGT (IWRKD+2) = IRNG1
                  If (XDONT(IRNG2) <= XDONT(IRNGT(IWRKD+4))) Then
!   3 1 2 4
                     IRNGT (IWRKD+3) = IRNG2
                  Else
!   3 1 4 2
                     IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                     IRNGT (IWRKD+4) = IRNG2
                  End If
               Else
!   3 4 1 2
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+3) = IRNG1
                  IRNGT (IWRKD+4) = IRNG2
               End If
            End If
         End Do
!
!  The Cs become As and Bs
!
         LMTNA = 4
         Exit
      End Do
!
!  Iteration loop. Each time, the length of the ordered subsets
!  is doubled.
!
      Do
         If (LMTNA >= NVAL) Exit
         IWRKF = 0
         LMTNC = 2 * LMTNC
!
!   Loop on merges of A and B into C
!
         Do
            IWRK = IWRKF
            IWRKD = IWRKF + 1
            JINDA = IWRKF + LMTNA
            IWRKF = IWRKF + LMTNC
            If (IWRKF >= NVAL) Then
               If (JINDA >= NVAL) Exit
               IWRKF = NVAL
            End If
            IINDA = 1
            IINDB = JINDA + 1
!
!   Shortcut for the case when the max of A is smaller
!   than the min of B. This line may be activated when the
!   initial set is already close to sorted.
!
!          IF (XDONT(IRNGT(JINDA)) <= XDONT(IRNGT(IINDB))) CYCLE
!
!  One steps in the C subset, that we build in the final rank array
!
!  Make a copy of the rank array for the merge iteration
!
            JWRKT (1:LMTNA) = IRNGT (IWRKD:JINDA)
!
            XVALA = XDONT (JWRKT(IINDA))
            XVALB = XDONT (IRNGT(IINDB))
!
            Do
               IWRK = IWRK + 1
!
!  We still have unprocessed values in both A and B
!
               If (XVALA > XVALB) Then
                  IRNGT (IWRK) = IRNGT (IINDB)
                  IINDB = IINDB + 1
                  If (IINDB > IWRKF) Then
!  Only A still with unprocessed values
                     IRNGT (IWRK+1:IWRKF) = JWRKT (IINDA:LMTNA)
                     Exit
                  End If
                  XVALB = XDONT (IRNGT(IINDB))
               Else
                  IRNGT (IWRK) = JWRKT (IINDA)
                  IINDA = IINDA + 1
                  If (IINDA > LMTNA) Exit! Only B still with unprocessed values
                  XVALA = XDONT (JWRKT(IINDA))
               End If
!
            End Do
         End Do
!
!  The Cs become As and Bs
!
         LMTNA = 2 * LMTNA
      End Do
!
      Return
!
End Subroutine I_mrgrnk
end module m_mrgrnk

      module mcm_lw_mod

!   TK modified from ajb code 
!     /net/ajb/radiation_code/updates/v4.3/lw_mod.F 

!   Added interface routine (lw_rad_ss) which is called by
!     fsrad and which calls lwcool in this
!     module after constructing the appropriate inputs.

      USE   Constants_Mod, ONLY: grav, tfreeze

      Use       Fms_Mod, ONLY: Error_Mesg, FATAL, &
                               write_version_number, mpp_pe, mpp_root_pe

      implicit none
      private

      integer, parameter :: nb_lw=19, ng=3, ngp=ng+1
      integer :: ix, jx, kx, kp, km
!------------ VERSION NUMBER ----------------

      character(len=128) :: version = '$Id: mcm_lw.F90,v 13.0 2006/03/28 21:09:36 fms Exp $'
      character(len=128) :: tagname = '$Name: tikal $'
      logical :: module_is_initialized = .false.

      public :: MCM_LW_RAD, mcm_lw_init, mcm_lw_end

!     -------------------------------------------------
! TK NOTE: not ready for this yet...      implicit none

!-----------------------------------------------------------------------
!--------------------- G L O B A L   D A T A ---------------------------
!-----------------------------------------------------------------------

! #include "parm.h"

! TK note: (ix,jx are set up below -- depend on domain decomposition)
!      integer, parameter :: ix = 96
!      integer, parameter :: jx = 80

! TK note: (kx,kp,km defined in rdparm)
!      integer, parameter :: kx = 14
!      integer, parameter :: kp = kx + 1
!      integer, parameter :: km = kx - 1

! TK note: (nb,ng,ngp are defined in rdparm)
!      integer, parameter :: nb=19
!      integer, parameter :: ng=3
!      integer, parameter :: ngp=ng +1

!   nb=number of spectral bands
!   ng=number of absorbing gases

!    TK: This is a name change to avoid having to change nb locally:
      INTEGER, PARAMETER :: nb = nb_lw

      INTEGER :: LMAX, i

      real :: grav_accel
      real :: pi_alpha

      real :: co2_mixrat
      real :: t_freeze

      real :: h2o_line_width(nb)
      real :: h2o_line_strength(nb)
      real :: h2o_corr_a(nb,2)
      real :: h2o_corr_b(nb,2)
      real :: absorp_table(30,12)
      real :: d_absorp_dt(7,12)

      data h2o_line_width/ &
         .93000e-01,  .18200e-00,  .94000e-01,  .79700e-01,  .73300e-01, &
         .52000e-01,  .67000e-01,  .45900e-01,  .10000e+01,  .10000e+01, &
         .89000e-01,  .23000e-00,  .32000e-00,  .29600e-00,  .45200e-00, &
         .35900e+00,  .16500e+00,  .10400e+00,  .11600e+00 /

      data h2o_line_strength/ &
         .57975e+03,  .72103e+04,  .60248e+04,  .14039e+04,  .78952e+02, &
         .42700e+01,  .71500e-01,  .27500e-01,  .00000e+00,  .00000e+00, &
         .12650e+02,  .13440e+03,  .63290e+03,  .33120e+03,  .43410e+03, &
         .13600e+03,  .35650e+02,  .90150e+01,  .15290e+01 /

      data (h2o_corr_a(i,1),i=1,19)/ &
        -.87600e-02, -.26800e-02,  .20300e-02,  .96100e-02,  .15820e-01, &
         .01705e+00,  .02620e+00,  .02918e+00,  .0        ,  .0        , &
         .0        ,  .0        ,  .0        ,  .0        ,  .0        , &
         .0        ,  .0        ,  .0        ,  .0         /
      data (h2o_corr_a(i,2),i=1,19)/ &
        -.67500e-02, -.29300e-02,  .14300e-02,  .98400e-02,  .13710e-01, &
         .01579e+00,  .02410e+00,  .02596e+00,  .0        ,  .0        , &
         .0        ,  .0        ,  .0        ,  .0        ,  .0        , &
         .0        ,  .0        ,  .0        ,  .0         /

      data (h2o_corr_b(i,1),i=1,19)/ &
         .14150e-04,  .15700e-05, -.10300e-04, -.43140e-04, -.37440e-04, &
        -.51440e-04, -.74100e-04, -.80760e-04,  .0        ,  .0        , &
         .0        ,  .0        ,  .0        ,  .0        ,  .0        , &
         .0        ,  .0        ,  .0        ,  .0         /
      data (h2o_corr_b(i,2),i=1,19)/ &
         .85500e-05,  .20100e-05, -.13000e-04, -.40810e-04, -.16150e-04, &
        -.44510e-04, -.40300e-04, -.66720e-04,  .0        ,  .0        , &
         .0        ,  .0        ,  .0        ,  .0        ,  .0        , &
         .0        ,  .0        ,  .0        ,  .0         /

      data (absorp_table(i,12),i=1,30)/ &
      .0000,.0001,.0001,.0002,.0004,.0006,.0011,.0020,.0034,.0058, &
      .0097,.0156,.0248,.0386,.0586,.0861,.1205,.1607,.2040,.2480, &
      .2918,.3362,.3812,.4250,.4665,.5045,.5386,.5707,.6037,.6395/
      data (absorp_table(i,11),i=1,30)/ &
      .0000,.0001,.0001,.0002,.0004,.0006,.0011,.0020,.0034,.0057, &
      .0093,.0149,.0231,.0351,.0520,.0744,.1032,.1388,.1803,.2255, &
      .2715,.3157,.3580,.3993,.4404,.4812,.5200,.5558,.5899,.6248/
      data (absorp_table(i,10),i=1,30)/ &
      .0000,.0001,.0001,.0002,.0004,.0006,.0011,.0019,.0033,.0054, &
      .0086,.0131,.0194,.0280,.0398,.0557,.0771,.1047,.1385,.1777, &
      .2206,.2648,.3080,.3497,.3910,.4328,.4748,.5155,.5535,.5886/
      data (absorp_table(i,9),i=1,30)/ &
      .0000,.0001,.0001,.0002,.0004,.0006,.0011,.0019,.0031,.0049, &
      .0075,.0110,.0157,.0221,.0309,.0430,.0591,.0798,.1056,.1366, &
      .1728,.2133,.2565,.3004,.3436,.3856,.4271,.4680,.5079,.5456/
      data (absorp_table(i,8),i=1,30)/ &
      .0000,.0001,.0001,.0002,.0004,.0006,.0010,.0017,.0027,.0041, &
      .0060,.0086,.0122,.0170,.0236,.0323,.0437,.0585,.0772,.1005, &
      .1287,.1622,.2005,.2426,.2865,.3301,.3721,.4127,.4525,.4915/
      data (absorp_table(i,7),i=1,30)/ &
      .0000,.0001,.0001,.0002,.0003,.0006,.0009,.0015,.0023,.0034, &
      .0049,.0070,.0099,.0138,.0189,.0256,.0342,.0454,.0597,.0778, &
      .1003,.1278,.1603,.1977,.2390,.2824,.3257,.3673,.4073,.4466/
      data (absorp_table(i,6),i=1,30)/ &
      .0000,.0001,.0001,.0002,.0003,.0005,.0008,.0013,.0019,.0027, &
      .0039,.0056,.0079,.0109,.0149,.0200,.0265,.0349,.0457,.0595, &
      .0769,.0986,.1250,.1565,.1928,.2331,.2758,.3187,.3603,.4003/
      data (absorp_table(i,5),i=1,30)/ &
      .0000,.0001,.0001,.0002,.0003,.0005,.0007,.0010,.0014,.0021, &
      .0029,.0042,.0058,.0079,.0107,.0143,.0189,.0247,.0321,.0415, &
      .0535,.0688,.0879,.1113,.1395,.1727,.2104,.2515,.2943,.3366/
      data (absorp_table(i,4),i=1,30)/ &
      .0000,.0001,.0001,.0002,.0003,.0004,.0006,.0008,.0011,.0015, &
      .0021,.0029,.0039,.0052,.0069,.0091,.0118,.0152,.0194,.0248, &
      .0316,.0402,.0510,.0647,.0819,.1031,.1290,.1598,.1954,.2351/
      data (absorp_table(i,3),i=1,30)/ &
      .0000,.0001,.0001,.0002,.0003,.0004,.0005,.0007,.0010,.0013, &
      .0018,.0024,.0032,.0042,.0054,.0069,.0087,.0109,.0137,.0171, &
      .0214,.0267,.0333,.0416,.0520,.0652,.0818,.1025,.1277,.1579/
      data (absorp_table(i,2),i=1,30)/ &
      .0000,.0001,.0001,.0002,.0002,.0004,.0005,.0007,.0009,.0013, &
      .0017,.0022,.0029,.0037,.0046,.0058,.0071,.0086,.0105,.0127, &
      .0154,.0186,.0225,.0273,.0331,.0404,.0496,.0613,.0762,.0949/
      data (absorp_table(i,1),i=1,30)/ &
      .0000,.0001,.0001,.0002,.0002,.0004,.0005,.0007,.0009,.0013, &
      .0017,.0022,.0028,.0036,.0044,.0054,.0066,.0079,.0094,.0111, &
      .0131,.0154,.0180,.0212,.0249,.0295,.0351,.0421,.0511,.0627/

      data d_absorp_dt/ &
      0.,.0006,.0017,.0036,.0061,.0092,.0158,0.,.0006,.0017,.0035,.0065, &
      .0114,.0230,0.,.0005,.0016,.0038,.0081,.0169,.0376,0.,.0005,.0017, &
      .0045,.0111,.0256,.0568,0.,.0004,.0021,.0065,.0178,.0421,.0864,    &
      0.,.0004,.0011,.0088,.0248,.0579,.1046,0.,.0004,.0032,.0112,.0316, &
      .0725,.1160,0.,.0004,.0036,.0141,.0392,.0880,.1256,0.,.0004,.0038, &
      .0187,.0508,.1045,.1345,0.,.0003,.0036,.0220,.0650,.1138,.1380,0., &
      .0002,.0028,.0234,.0859,.1180,.1410,0.,.0001,.0022,.0257,.0936,    &
      .1183,.1444/

      contains

!#######################################################################
      subroutine mcm_lw_init(ix_in, jx_in, kx_in)
      integer, intent(in) :: ix_in, jx_in, kx_in

      ix = ix_in
      jx = jx_in
      kx = kx_in
      kp = kx + 1
      km = kx -1

!------- write version number and namelist ---------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
      endif

      module_is_initialized = .true.

      return
      end subroutine mcm_lw_init
!#######################################################################

subroutine mcm_lw_end

      module_is_initialized = .false.

!---------------------------------------------------------------------

end subroutine mcm_lw_end

!#######################################################################

      SUBROUTINE MCM_LW_RAD (KTOP,KBTM,NCLDS,EMCLD, &
                      PRES,TEMP,RH2O,QO3,CAMT, &
                      RRVCO2,  HEATRA,GRNFLX,TOPFLX, phalf)

!   This illustrates the intended sizes of arrays:
!      INTEGER, INTENT(IN), DIMENSION(ix,jx,kp) :: KTOP,KBTM
!      INTEGER, INTENT(IN), DIMENSION(ix,jx)    :: NCLDS
!      REAL,    INTENT(IN), DIMENSION(ix,jx,kp) :: EMCLD
!      REAL,    INTENT(IN), DIMENSION(ix,jx,kp) :: PRES,TEMP
!      REAL,    INTENT(IN), DIMENSION(ix,jx,kx) :: RH2O,QO3
!      REAL,    INTENT(IN), DIMENSION(ix,jx,kp) :: CAMT
!      REAL,    INTENT(IN)                      :: RRVCO2

!      REAL,   INTENT(OUT), DIMENSION(ix,jx,kx) :: HEATRA
!      REAL,   INTENT(OUT), DIMENSION(ix,jx)    :: GRNFLX,TOPFLX

!     TK mod:
!      REAL,    INTENT(IN), DIMENSION(ix,jx,kp) :: phalf

      INTEGER, INTENT(IN), DIMENSION(:,:,:) :: KTOP,KBTM
      INTEGER, INTENT(IN), DIMENSION(:,:)    :: NCLDS
      REAL,    INTENT(IN), DIMENSION(:,:,:) :: EMCLD
      REAL,    INTENT(IN), DIMENSION(:,:,:) :: PRES,TEMP
      REAL,    INTENT(IN), DIMENSION(:,:,:) :: RH2O,QO3
      REAL,    INTENT(IN), DIMENSION(:,:,:) :: CAMT
      REAL,    INTENT(IN)                      :: RRVCO2
 
      REAL,   INTENT(OUT), DIMENSION(:,:,:) :: HEATRA
      REAL,   INTENT(OUT), DIMENSION(:,:)    :: GRNFLX,TOPFLX

!     TK mod:
      REAL,    INTENT(IN), DIMENSION(:,:,:) :: phalf

!----------------LOCAL ARRAY STORAGE------------------------------------
      real, dimension(SIZE(PRES,1)) :: dummy
      REAL, DIMENSION(SIZE(PRES,1),SIZE(PRES,1),0:kp) :: cloud_cover

      REAL, DIMENSION(ix,jx,1:kx) :: sigma_level
      REAL, DIMENSION(ix,jx,0:kx) :: sigma_half_level
      REAL, DIMENSION(ix,jx,1:kx) :: sigma_thick
      REAL, DIMENSION(kx) :: o3_mixrat
 
      INTEGER :: i,j, n, ipr

!     TK mods:
      integer :: iindex, jindex, klev, kpr

      real :: pi

      if(.not.module_is_initialized) then
        call error_mesg('MCM_LW_RAD','module is not initialized.',FATAL)
      endif

!     ix = SIZE(PRES,1)
!     jx = SIZE(PRES,2)
      lmax = ix * (kx + 1)

!     Gather/calculate other needed parameters for ss longwave code:

!     Convert grav to grav_accel in cgs units:
      grav_accel = grav * 100.

      pi = 4. * atan(1.)
      pi_alpha = 0.28 * pi

      t_freeze = tfreeze

!     Multiply CO2 volume mixing ratio by 1.5194 to convert to mass mixing
!     ratio... TK -- need to check accuracy of this...

      co2_mixrat = RRVCO2 * 1.5194

!     Compute sigma levels, which are needed by ss routine:
!     This can be done on any x,y point in the domain.
      do klev = 1, kx
        do j=1,jx
          do i=1,ix
            sigma_level(i,j,klev) = pres(i,j,klev) / phalf(i,j,kp)
          enddo
        enddo
      enddo

!     Compute half sigma levels, which are needed by ss routine:
      do klev = 1, kp
        do j=1,jx
         do i=1,ix
          sigma_half_level(i,j,klev-1) = phalf(i,j,klev) / phalf(i,j,kp)
         enddo
        enddo
      enddo

!     Compute delta sigma of layers, which are needed by ss routine:
      do klev = 1, kx
        do j=1,jx
          do i=1,ix
            sigma_thick(i,j,klev) = sigma_half_level(i,j,klev) - &
                                    sigma_half_level(i,j,klev-1) 
          enddo
        enddo
      enddo

!     Create cloud_cover input field for ss longwave code:

!     Expand_cloud routine creates a Manabe Climate Model cloud_cover
!     field from the FMS arrays: nclds, ktop, kbtm, camt, and emcld.

!     This is patterned after the expand_cloud subroutine in
!      the clouds.f90 module.  See also the supersource code
!      in impt.f 
!     Accounts for cloud emmissivity...

      cloud_cover = 0.0
      do jindex=1,size(nclds,2)
      do iindex=1,size(nclds,1)
         do n=2,nclds(iindex,jindex)+1
            cloud_cover(iindex,jindex,  &
                ktop(iindex,jindex,n):kbtm(iindex,jindex,n)) =   &
                camt(iindex,jindex,n) * emcld(iindex,jindex,n)
         enddo
      enddo
      enddo
      
!     TK Mod to mimic supersource.  This is a temporary patch
!     which needs to be cleaned up.  A search is made for locations
!     where the LW cloud emissivity has been set to 0.6.
!     If that location is an isolated cloud with the layer above
!     and below being cloud free, the cloud_cover value is left
!     as 0.6, otherwise it is set to 1.0.   This is the
!     cirrus1L test.   7/09/01

      do jindex=1,size(nclds,2)
      do iindex=1,size(nclds,1)
!        For supersource runs, there should not be any cloud
!        at the top model level (k=1), nor should the high cloud
!        issue come into play the bottom level (k=kx).      

         do klev = 2, kx-1
            if (abs(cloud_cover(iindex,jindex,klev)-0.6) .lt. 0.001) then
 
!             The cloud at level klev has been previously reset to 0.6
 
               if ((cloud_cover(iindex,jindex,klev-1) .gt. 0.0) .or. &
                   (cloud_cover(iindex,jindex,klev+1) .gt. 0.0)) then
!             The cloud with 0.6 LW emiss has a neighboring cloud
!              so reset the LW emiss (cloud_cover) to 1.0 as follows:
                  cloud_cover(iindex,jindex,klev) = 1.0
               end if
 
            end if
         enddo
      enddo
      enddo

!     TK  Can Artificially set cloud_cover to 1 at the test point:
!         This method of doing this is now obsolete.  See radiation_driver.
!      print *, '***** TK Artificially set cloud_cover(49,27,14) = 1 ***'
!      cloud_cover(49,27,14) = 1.0

      DO j=1,jx

!        Specify ozone for the latitude (zonal mean used):
         do klev=1,kx
            o3_mixrat(klev) = QO3(1,j,klev)
         end do
 
!        TK Printout diagnostics:
        if ((j .eq. 27)) then
!        if ((j .eq. 27) .or. (j .eq. 69)) then
!        if ((j .eq. 10000) .or. (j .eq. 10000)) then

           ipr = 48

           print *
           print *, 'TK chkpt 1 in mcm_lw_mod.f.  Trap input to '
           print *, '  lwcool for i,j = ', ipr, j

           print *, 'k     cloud_cover     PRESSURE'
           do kpr = 1, 14
              write (6, 120) kpr, cloud_cover (ipr,j,kpr), &
                    PRES(ipr,j,kpr) 
120           format (i2, 2x, e10.3, 3x, e10.3)
           end do
           print *
           print *, 'Surface pressure = ', PRES(ipr,j,15)
        
           print *
           print *, 'k   TEMP        RH2O        QO3         CAMT', &
           '      RRVCO2'
           do kpr = 1, 14
              write (6, 125) kpr, TEMP(ipr,j,kpr),RH2O(ipr,j,kpr), &
                  QO3(ipr,j,kpr), CAMT(ipr,j,kpr), RRVCO2 
125           format (i2, 2x, f10.6, 2x, 2(e10.5,2x), 2(e8.3,2x))
           end do
           print *
           print *, 'Surface temperature = ', TEMP(ipr,j,15)
           print *
        end if
        
!       TK note that lw_down_sfc is just a throwaway variable in fms, 
!           so a dummy variable is used.  Some extra input
!           arguments are sent to lwcool.  Send i=1 values of 
!           ozone since zonally symmetric.
!           Use air temps in deg C as input parameter.
!           Convert surface pressures from Pa to dynes/cm2 for
!           input to the SS-derived routine...
!           The extra parameter j is for debugging only...

         call lwcool ( cloud_cover(:,j,:), temp(:,j,1:kx)-t_freeze, &
            RH2O(:,j,1:kx), phalf(:,j,kp)*10., temp(:,j,kp), &
            dummy, HEATRA(:,j,:), TOPFLX(:,j), GRNFLX(:,j), j, &
            sigma_level(:,j,:), sigma_half_level(:,j,:),  &
            sigma_thick(:,j,:), o3_mixrat)

!        TK Printout diagnostics:
         if ((j .eq. 27) ) then
!         if ((j .eq. 27) .or. (j .eq. 69)) then
!         if ((j .eq. 10000) .or. (j .eq. 10000)) then

           ipr = 48

           print *
           print *, 'TK chkpt 2b in mcm_lw_mod.f.  Trap output from '
           print *, '  lwcool for i,j =  ', ipr, j

!          Convert from ly/min to W/m2:
           print *, 'k    HEATRA(K/d)   GRNFLX      TOPFLX  (W/m2) '
           do kpr = 1, 14
              write (6, 130) kpr, HEATRA(ipr,j,kpr)*24*3600,  &
                 GRNFLX(ipr,j)*697., TOPFLX(ipr,j)*697. 
130           format (i2, 2x, f10.6, 3x, f10.6, 3x, f10.6)
           end do
           print *
         end if
      ENDDO

!      Convert top of atm and sfc fluxes into units FMS is
!      expecting as output: (milliWatts/m2, K/day).
!      TK mod 5/14/01: use identical conversion factor to SS: 697.496.
!      Note that 4186/6 = 697.66667.

       GRNFLX = GRNFLX * 1.0E3 * 697.496
       TOPFLX = TOPFLX * 1.0E3 * 697.496

!       GRNFLX = GRNFLX * 1.0E3 * 4186/6.
!       TOPFLX = TOPFLX * 1.0E3 * 4186/6.

       HEATRA = HEATRA * 24 * 3600


      END SUBROUTINE MCM_LW_RAD

!#######################################################################

      subroutine lwcool(cloud_cover, tj, rj, psj, t_sfc, &
       lw_down_sfc, lw_cooling_rate, lw_up_toa, lw_net_sfc, jrow_flag, &
       sigma_level, sigma_half_level, sigma_thick, o3_mixrat)
 

!  compute net longwave cooling rates

! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

!  routine :   lwcool
!  called by : impt
!  calls :     lwtran
!  purpose :   compute net longwave cooling rates

!  inputs:
!     tj(i,k)             temperature (deg C) at each grid point
!     rj(i,k)             mixing ratio of h2o (g/g) at each grid point
!     psj(i)              surface pressure (dynes/cm**2) at each grid point
!     t_sfc(i)            surface temperature (deg K) at each grid point
!     cloud_cover(i,k)    fractional cloud cover

!  outputs:
!     lw_up_toa(i)           upward flux at top of atmosphere (ly/min)
!     lw_net_sfc(i)          net flux at ground (ly/min)
!     lw_down_sfc(i)         downward flux at ground (ly/min)
!     lw_cooling_rate(i,k)   cooling rate at each grid point (deg/s)

!  procedure:
!     the temperature at each grid point is converted from celsius to
!     absolute (kelvin); from the temperatures planck blackbody
!     radiances are computed for each grid point.  the longwave
!     transmission coefficients (recomputed every ldisk timesteps) are
!     then combined with the blackbody radiances to determine clear
!     fluxes (i.e., the flux which would occur in the absence of
!     clouds) between all pairs of levels.  dqx(i,k,l), for example, is
!     the clear-path downward flux from vertical level l to level k.
!     then, from the known distribution of clouds, the actual upward and
!     downward fluxes at each level are computed.  these are used to
!     compute cooling rates as well as some diagnostic quantities.

! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


      real, parameter :: sigma = 5.673e-5, c1 = 3.740e-5, c2 = 1.4385 
      real, parameter :: cp1 = 0.24, cp2 = 4.1867e7 * cp1 

      real,    intent(in)  :: cloud_cover(ix,0:kp)
      real,    intent(in)  :: tj(ix,kx), rj(ix,kx), psj(ix)
      real,    intent(in)  :: t_sfc(ix)
      real,    intent(in)  :: sigma_level(ix,kx), sigma_half_level(ix,0:kx)
      real,    intent(in)  :: sigma_thick(ix,kx), o3_mixrat(kx)
      integer, intent(in)  :: jrow_flag

      real,    intent(out) :: lw_up_toa(ix)
      real,    intent(out) :: lw_net_sfc(ix)
      real,    intent(out) :: lw_cooling_rate(ix,kx)
      real,    intent(out) :: lw_down_sfc(ix)


!----------------LOCAL ARRAY STORAGE------------------------------------
      real :: dqx (ix,0:kp,0:kp), uqx (ix,0:kp,0:kp)
      real :: dfxc(ix,0:kp),      ufxc(ix,0:kp)
      real :: psigl(ix,2:kx)

      integer kloud (ix,0:kp)
      integer kldtop(ix,2:kx), kldmid(ix,2:kx), kldbot(ix,2:kx)

      integer :: numtop(2:kx), nummid(2:kx), numbot (2:kx)
      real :: ufxkb (ix),   uqxkt (ix),   ufxb(ix,2:kx)
      real :: dfxkt (ix),   dqxkb (ix),   dqxb(ix,2:kx)
      real :: ppfkb (ix),   ppfkt (ix),   ppfb(ix,2:kx)

      real :: cdxa  (kx),   cuxa(0:kx)
      real :: dfx(ix,0:kp), ufx(ix,0:kp)

      real temp_kelvin(ix,0:kp)
      real planck_func(ix,0:kp)
      real lw_trans_coeff(ix,0:kx,0:kx), lw_toa_correct(ix,0:kx)
      real lw_abs_quarter(ix,0:kx,2)
      real dpbb(ix,0:kx)
      integer :: k, l, kb, kt
      real :: cof

!    TK: I took out these equivalences but needed to modify the
!         code below so that dfx and ufx were initialized properly.
!         Printout answers for test points reproduced.  5/03/01 
!       equivalence (dfx, dqx(1,0,0))
!       equivalence (ufx, uqx(1,0,kp))


!      data cdxa / km * 0.5, 1.0 /, cuxa / -1.0, kx * -0.5 /

      do k=1,km
        cdxa(k) = 0.5
      end do
      cdxa(kx) = 1.0

      cuxa(0) = -1.0
      do k=1,kx
        cuxa(k) = -0.5
      end do

! ----------------------------------------------------------------------
!  compute clear (cloud-free) fluxes between all pairs of levels
! ----------------------------------------------------------------------

! ****** compute pbb (planck blackbody radiance), and d(pbb)/dk

      do 5 k=1,kx
        do 5 i=1,ix
          temp_kelvin(i,k) = tj(i,k) + t_freeze
    5 continue

      do 6 i=1,ix
        temp_kelvin(i, 0) = temp_kelvin(i,1)
        temp_kelvin(i,kp) = t_sfc(i)
    6 continue

      do 7 k=0,kp
        do 7 i=1,ix
          planck_func(i,k) = sigma*temp_kelvin(i,k)**4
    7 continue

      do 8 k=0,kx
        do 8 i=1,ix
          dpbb(i,k) = planck_func(i,k+1) - planck_func(i,k)
    8 continue

! ----------------------------------------------------------------------
!  Obtain transmission functions
! ----------------------------------------------------------------------
      call lwtran (planck_func, temp_kelvin, rj, psj,  &
        lw_trans_coeff, lw_toa_correct, lw_abs_quarter, jrow_flag,  &
        sigma_level, sigma_half_level, sigma_thick, o3_mixrat)

! ****** compute upward and downward fluxes at "flux" levels

      do 11 i=1,ix
        dqx(i,0,0) = 0.0
   11 continue

      do 12 k=1,kx
        do 12 i=1,ix
          dqx(i,k,k) = cdxa(k) * dpbb(i,k) * lw_abs_quarter(i,k,2) + planck_func(i,k)
   12 continue

      do 13 l=kx-1,0,-1
        do 13 k=l+1,kx
          do 13 i=1,ix
            dqx(i,k,l) = dqx(i,k,l+1) - lw_trans_coeff(i,k,l)*dpbb(i,l)
   13 continue

      do 14 k=1,kx
        do 14 i=1,ix
          dqx(i,k,0) = dqx(i,k,0) - lw_toa_correct(i,k) * planck_func(i,0)
   14 continue

      do 15 k=0,kx
        do 15 i=1,ix
          uqx(i,k,k+1) = cuxa(k) * dpbb(i,k) * lw_abs_quarter(i,k,1) + planck_func(i,k+1)
   15 continue

      do 16 l=2,kp
        do 16 k=0,l-2
          do 16 i=1,ix
            uqx(i,k,l) = uqx(i,k,l-1) + lw_trans_coeff(i,k,l-1) * dpbb(i,l-1)
   16 continue

!  TK Add code to initialize ufx to take place of equivalence:
      do 17 k = 0, kp
         do 17 i = 1, ix
            ufx(i,k) = uqx(i,k,kp)
17    continue 

!  TK Add code to initialize dfx to take place of equivalence:
      do 18 k = 0, kp
         do 18 i = 1, ix
            dfx(i,k) = dqx(i,k,0)
18    continue 

! ----------------------------------------------------------------------
!  compute actual fluxes from cloud distribution
! ----------------------------------------------------------------------

      do 105 k=0,kp
       do 105 i=1,ix
        if (cloud_cover(i,k) .ne. 0) then
          kloud(i,k) = 1
        else
          kloud(i,k) = 0
        endif
  105 continue
      do 110 k=2,kx
       do 110 i=1,ix
        kldtop(i,k) = kloud(i,k) * (1 - kloud(i,k-1))
        kldmid(i,k) = kloud(i,k) *      kloud(i,k+1)
        kldbot(i,k) = kloud(i,k) * (1 - kloud(i,k+1))
  110 continue

      do 20 kb=2,kx
        do 20 k=kb,kx
         do 20 i=1,ix
          if (kldbot(i,kb) .eq. 1) &
            dfx(i,k) = dfx(i,k) * (1.0-cloud_cover(i,kb)) &
                     + dqx(i,k,kb) * cloud_cover(i,kb)
   20 continue

      do 30 kt=kx,2,-1
        do 30 k=0,kt-1
         do 30 i=1,ix
          if (kldtop(i,kt) .eq. 1) &
            ufx(i,k) = ufx(i,k) * (1.0-cloud_cover(i,kt)) &
                     + uqx(i,k,kt) * cloud_cover(i,kt)
   30 continue

      do 35 k=2,kx
        numtop(k) = 0
        numbot(k) = 0
        nummid(k) = 0
   35 continue
      do 36 k=2,kx
       do 36 i=1,ix
        numtop(k) = numtop(k) + kldtop(i,k)
        numbot(k) = numbot(k) + kldbot(i,k)
        nummid(k) = nummid(k) + kldmid(i,k)
   36 continue

      do 40 k=kx,2,-1
       do 115 i=1,ix
        if (kldbot(i,k) .eq. 1) then
          ufxkb(i) = ufx(i,k)
          dqxkb(i) = dqx(i,k,k)
          ppfkb(i) = sigma_half_level(i,k)
        endif
  115  continue
        if (nummid(k) .eq. 0) goto 40
       do 120 i=1,ix
        if (kldmid(i,k) .eq. 1) then
          ufxb(i,k) = ufxkb(i)
          dqxb(i,k) = dqxkb(i)
          ppfb(i,k) = ppfkb(i)
        endif
  120  continue
  40  continue

      do 50 k=2,kx
       if (nummid(k) .eq. 0) goto 50
         do 125 i=1,ix
          if (kldtop(i,k) .eq. 1) then
            dfxkt(i) = dfx(i,k-1)
            uqxkt(i) = uqx(i,k-1,k)
            ppfkt(i) = sigma_half_level(i,k-1)
          endif
  125    continue
         do 130 i=1,ix
          if (kldmid(i,k) .eq. 1) then
            psigl(i,k) = (sigma_half_level(i,k) - ppfkt(i)) / &
                            (ppfb(i,k) - ppfkt(i))
            dfxc (i,k) = dfxkt(i) + psigl(i,k)*(dqxb(i,k) - dfxkt(i))
            ufxc (i,k) = uqxkt(i) + psigl(i,k)*(ufxb(i,k) - uqxkt(i))
          endif
  130    continue
   50 continue

      do 135 k=2,kx
       do 135 i=1,ix
        if (kldmid(i,k) .eq. 1) then
          dfx(i,k) = dfx(i,k)*(1.0-cloud_cover(i,k)) + dfxc(i,k)*cloud_cover(i,k)
          ufx(i,k) = ufx(i,k)*(1.0-cloud_cover(i,k)) + ufxc(i,k)*cloud_cover(i,k)
        endif
  135 continue

! ----------------------------------------------------------------------
!  compute net cooling rates from fluxes
! ----------------------------------------------------------------------

! 1.43306e-6 converts ergs / (cm**2*sec) to ly/min

   80 continue

        do 85 i=1,ix
         lw_up_toa(i)     = ufx(i,0) * 1.43306e-06
         lw_net_sfc(i)     = (ufx(i,kx) - dfx(i,kx)) * 1.43306e-06
         lw_down_sfc(i) = -dfx(i,kx) * 1.43306e-6
   85   continue

! 1.1574e-5 = 1.0 / 86400.0

        cof = grav_accel * 86400.0 / cp2
        cof = cof * 1.1574e-5

        do 90 k=1,kx
         do 90 i=1,ix
          lw_cooling_rate(i,k) = cof/(sigma_thick(i,k)*psj(i))
   90   continue

        do 95 k=1,kx
         do 95 i=1,ix
          lw_cooling_rate(i,k) = lw_cooling_rate(i,k) &
             * (ufx(i,k) - ufx(i,k-1) + dfx(i,k-1) - dfx(i,k))
   95   continue

      return
      end subroutine lwcool

function  expx(x)
real, intent(in) :: x
real :: expx

! ----------------------------------------------------------------------
!  statement function
! ----------------------------------------------------------------------

!  the approximation to exp(x) which follows is appropriate only given
!  the following assumptions:
!    1) since the correction coefficients (h2o_corr_a & h2o_corr_b) 
!       are known only to about four digits of accuracy, 6-7 digits 
!       of accuracy for the approximation is ample.
!    2) the input range for x is [-6.735,2.289].  this depends on:
!       a) the valid temperature range, now [-173.16,102] (celsius)
!       b) the values of the coefficients h2o_corr_a & h2o_corr_b
!

      real, parameter :: c0e = 9.999999810120017e-1 
      real, parameter :: c1e = 9.999999599140620e-1/16.**1 
      real, parameter :: c2e = 5.000056658124412e-1/16.**2 
      real, parameter :: c3e = 1.666837874572320e-1/16.**3 
      real, parameter :: c4e = 4.146341773620255e-2/16.**4 
      real, parameter :: c5e = 7.279860860195404e-3/16.**5 

      expx = ((( (((((c5e*x+c4e)*x+c3e)*x+c2e)*x+c1e)*x+c0e) &
                   **2)**2)**2)**2
end function expx


      subroutine lwtran (planck_func, temp_kelvin, rj, psj, &
        lw_trans_coeff, lw_toa_correct, lw_abs_quarter, jrow_flag, &
        sigma_level, sigma_half_level, sigma_thick, o3_mixrat)

!  compute longwave atmospheric transmission coefficients

! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

!  routine :   lwtran
!  called by : lwcool
!  calls :     lwco2
!  purpose :   compute longwave atmospheric transmission coefficients

!  inputs:
!     rj(i,k)             mixing ratio of h2o at each grid point (g/g)
!     psj(i,k)            surface presure at each ground point (dynes/cm**2)
!     temp_kelvin(i,k)    temperature (deg K)
!     planck_func(i,k)    blackbody function (total radiance; ergs/(cm**2)*s)

!  outputs:
!     lw_trans_coeff         longwave transmission coefficient (dimensionless)
!     lw_toa_correct         correction to above for top level (dimensionless)
!     lw_abs_quarter         quarter-level absorption (dimensionless)

!  procedure:
!     the main purpose of this routine is to compute the band-integrated
!     transmission coefficients transm(i,k,l) for radiation passing from
!     flux level l to flux level k.  in addition, it computes two
!     corrections. the first, transz(i,k), is for radiation from the top
!     level (split off from transm to improve code efficiency, i think).
!     the second, absrbx(i,k,kq), is a half-layer (flux level to data-
!     input level, or vice versa) absorption correction; kq=1 is the
!     correction for upward flux and kq=2 is for downward flux.

!     this routine splits the longwave radiation spectrum into nb bands,
!     ranging from about 20 to 2000 cm-1.  transmission coefficients are
!     computed for each absorber contributing to absorption in that
!     band.  the single-absorber transmission coefficients are
!     multiplied together to produce the total single-band transmission,
!     and then subtracted from 1 to produce an absorption.  the single-
!     band absorptions are weighted by the relative fraction of
!     blackbody radiation in that band (for a particular temperature),
!     and summed to produce the total band-integrated absorption
!     coefficient, which is converted back to a transmission.

!     transmissions for h2o are computed using a goody random model.
!     the function form and coefficients come from a paper by rogers and
!     walshaw (rogers, c.d. and c.d. walshaw, the computation of infra-
!     red cooling in planetary atmospheres, quart. j. royal meteorol.
!     soc., v.92, pp.67-92, 1966).

!        the water vapor continuum is now computed by using the
!     formulation given in roberts(first fit). reference:
!     roberts,r.e.,et al,applied optics,v. 15,pp 2085-2090,1976.

!     the co2 transmission table was generated by a program obtained
!     privately from s.r. drayson, university of michigan.  this program
!     assumed a homogeneous path between flux levels; a version which
!     did not assume homogeneous paths was later published by drayson
!     (drayson, s.r., atmospheric transmission in the co2 bands between
!     12 microns and 18 microns, appl. opt., v.5, pp.385-391, 1973).

!     the o3 transmission computation, changed from a table lookup in
!     the original longwave radiation code, also uses a goody random
!     model.  the functional form and coefficients were published by
!     rogers (rogers, c.d., some extensions and applications of the new
!     random model for molecular band transmission, q.j.r.m.s, v.94,
!     pp.99-102, 1968).

! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      real, intent(in) :: planck_func(ix,0:kp)
      real, intent(in) :: temp_kelvin(ix,0:kp)
      real, intent(in) :: rj(ix,kx)
      real, intent(in) :: psj(ix)

      real, intent(in) :: sigma_level(ix,kx), sigma_half_level(ix,0:kx)
      real, intent(in) :: sigma_thick(ix,kx), o3_mixrat(kx)
      integer, intent(in)  :: jrow_flag

      real, intent(out) :: lw_trans_coeff(ix,0:kx,0:kx)
      real, intent(out) :: lw_toa_correct(ix,0:kx)
      real, intent(out) :: lw_abs_quarter(ix,0:kx,2)

      real, parameter :: sigma = 5.673e-5, c1 = 3.740e-5, c2 = 1.4385 
      real, parameter :: po = 1013.25e3, opo = 1.0 / po, o2po = 0.5 * opo 
!     parameter ( opo = 9.8692271e-7, o2po = 4.9346136e-7 )
      real, parameter :: ak1 = 223.0, ak2=10.0 
!     parameter ( alpha = 0.28 )
!     parameter ( pi = 3.1415926535898 )
!     parameter ( pialph = pi * alpha )
      real, parameter :: ak1x4 = 4.0 * ak1 
      real, parameter :: ak2x4 = 4.0 * ak2 
!     parameter ( pialph = 0.8796459, ak1x4 = 892.0, ak2x4 = 40.0 )
      real, parameter ::            azint = 1.66                 
!     parameter ( g = 980.6, azint = 1.66, g1 = azint / g )
!     parameter ( g1h = 0.5 * g1 )
!     parameter ( g1 = 1.6938774e-3, g1h = 0.5 * g1 )
      real, parameter :: c3 = 1.0 / 120.0, a1 = 75.48, a2 = 23.44 
!     parameter ( c3 = 8.333333e-3, a1 = 75.48, a2 = 23.44 )
      real, parameter :: c3a1 = c3 * a1, c3a2 = c3 * a2 
      real, parameter :: c0e = 9.999999810120017e-1 
      real, parameter :: c1e = 9.999999599140620e-1/16.**1 
      real, parameter :: c2e = 5.000056658124412e-1/16.**2 
      real, parameter :: c3e = 1.666837874572320e-1/16.**3 
      real, parameter :: c4e = 4.146341773620255e-2/16.**4 
      real, parameter :: c5e = 7.279860860195404e-3/16.**5 

      real :: bw(ix,0:kx,nb), bwz(ix,nb), expzs(ix,nb)
      real :: trans(ix,0:kx,0:kx), dbbdt(ix,0:kx)

      real :: vcube(nb), c(nb), v(nb), dv(nb)
      real :: pdi   (ix,0:kp), pfl   (ix,0:kx), dpdi (ix,  kx)
      real :: rh2o  (ix,0:kp), ro3   (ix,0:kp), qdi  (ix,  kx)
      real :: duh2o (ix,  kx), duco2 (ix,  kx), duo3 (ix,  kx)
      real :: duqh2o(ix,  kx), duqfac(ix,  kx), dufac(ix,  kx)
      real :: fbignl(ix,  kx), bignel(ix,0:kx), bign (ix,  kx)
      real :: tdpfac(ix,  kx), tfac  (ix,  kx), teff (ix,  kx)
      real :: sfac  (ix,0:kx), pfac  (ix,0:kx), peff (ix,0:kx)
      real :: tcof  (ix,0:kx), fac1  (ix,0:kx), fac2 (ix,0:kx)
      real :: t260  (ix,0:kx), tadj  (ix,0:kx,2)
      real :: ulog  (ix,0:kx), plog  (ix,0:kx)


!  quarter-layer variables

      real :: txdegk(ix,0:kx), qx    (ix,0:kx), dpfac(ix,0:kx)
      real :: duxh2o(ix,0:kx), duxco2(ix,0:kx), duxo3(ix,0:kx)
      real :: g1, g1h, bc,  bandc1, bandc2, cco2, asodsq, diag, &
              factr1, factr2, diago3
      integer :: lb, k, l, len, kq

!c  TK: Removed unnecessary equivalences:
!      equivalence (ulog,  fac1  ), (plog,  fac2 ), (teff, peff )
!      equivalence (txdegk,dpdi  ), (qx,    qdi  )
!      equivalence (duxh2o,duh2o ), (duxco2,duco2), (duxo3,duo3 )
!      equivalence (tadj,  duqfac), (tadj(1,0,2),dufac,tdpfac,dpfac)

!  constants for h2o bignell continuum absorption

!        these are the roberts continuum coefficients
      data  c / 4*0.0, 149.566, 38.103, 11.312, 7.9193, 6.0741, 4.9179, 9*0.0 /

!  longwave frequency bands and band widths (inverse cm)

      data v /   20.0,  100.0,  220.0,  340.0,  470.0, &
                670.0,  850.0,  930.0, 1020.0, 1140.0, &
               1275.0, 1400.0, 1500.0, 1600.0, 1700.0, &
               1800.0, 1900.0, 2000.0, 2125.0 /
      data dv /  40.0, 120.0, 120.0, 120.0, 140.0, &
                260.0, 100.0,  60.0, 120.0, 120.0, &
                150.0, 100.0, 100.0, 100.0, 100.0, &
                100.0, 100.0, 100.0, 150.0 /

! ----------------------------------------------------------------------
!  description of variables and constants used in lwtran
! ----------------------------------------------------------------------

!  variables centered on data input levels:
!     sigma_level             1-d "sigma" (pressure/po) 
!     sigma_thick             d(sigma)/dk
!                             (not to be confused with planck bb sigma)
!     pdi, dpdi, qdi          pressure, d(pdi)/dk, and pdi/po
!     rh2o, co2_mixrat, ro3         mixing ratios for the various absorbers
!     duh2o, duco2, duo3      absorber amounts from top of atmosphere
!        (gm/cm**2)           (also called unadjusted optical depth)
!     temp_kelvin                   temperature (kelvin)

!  variables centered on flux levels (see last paragraph, below):
!     sigma_half_level, pfl                1-d "sigma", 2-d pressure

!  assorted additional variables and constants:
!     po, opo, o2po           average pressure at sea level, 1/po, 2/po
!     planck_func             planck blackbody function
!     dbbdt                   d(planck_func)/dt
!     sigma, c1, c2           constants in planck blackbody equation
!     v, dv                   frequencies and band widths (1/cm)
!                             (wavelength range is 5-500 microns)
!     bw, bwz                 weights for freq. bands derived from planck_func
!     alpha, c3, a1, a2,      empirical constants used in computing
!       ak1, ak2                ozone absorption
!     h2o_line_width, 
!     h2o_line_strength       empirical band constants for water lines
!       h2o_line_width          coefficient for h2o line width
!       h2o_line_strength       coefficient for h2o line strength
!     sfac, pfac, tfac        intensity, pressure, temperature factors
!     peff, teff              effective pressure, temperature
!     ulog, plog              logs of co2 amount, effective pressure
!     tadj                    temperature adjustments for h2o lines
!     fbignl, bignel, bign    factors associated with bignell continuum
!     tcof                    transmission coefficient, single absorber
!     trans                   transmission matrix, single frequency band

!  output variables:
!     transm, transz          band-integrated transmission coefficients
!     absrbx                  quarter-layer correction to above (absrp.)

!  quarter layer variables (x usually indicates quarter-layer):
!     txdegk, qx              quarter-layer temperature, "sigma"
!     duxh2o, duxco2, duxo3   quarter-layer absorber amounts

!  miscellaneous constants:
!     azint                   azimuthal integral factor for diffuse rad.
!     g1, g1h                 convert dp*mix-ratio to absorber amount

!  miscellaneous temporaries:
!     expzs, vcube, bc, bandc1, bandc2
!     t260, fac1, fac2, dufac, dpfac, duqfac, duqh2o, cco2

!     vertical levels in the model are numbered from the top of the
!  atmosphere to the bottom; thus vertical level 1 is in the
!  stratosphere and level kx is just above the ground.  in the
!  radiation code, additional "pseudo-levels" are tacked onto the top
!  (level 0) and the bottom (level kp).  these levels make it easier
!  to handle incoming solar radiation and longwave radiation emanating
!  from the ground.

!     an additional complication to the level numbering system for the
!  radiation code is the use of "flux" levels and "data-input" levels.
!  the simplest numbering scheme for radiation calculations focuses
!  on even and odd levels: the grid variables (pressure, temperature,
!  etc.) reside at even levels, and flux is computed across them, i.e.,
!  from odd level to odd level.  this a pedagogically sound approach,
!  but it poses problems for computers, particularly vector types.
!  thus this code numbers what would be odd and even levels separately.
!  "data-input" levels are normal model vertical levels; "flux" levels
!  are halfway between them.  flux level k is one-half level closer to
!  the ground than data-input level k.  in the diagram below, data-input
!  levels are shown as "++++++" and flux levels are shown as "------".

!           description          level  index
!    incoming solar radiation      0      0   +++++++
!                                 1/2     0   -------
!             top model level      1      1   +++++++
!                                  .
!                                  .
!                                  .
!          bottom model level     kx     kx   +++++++
!                               kx+1/2   kx   -------
!                ground level     kp     kp   +++++++

! ----------------------------------------------------------------------
!  Compute various constants involving gravity.
! ----------------------------------------------------------------------
      g1  = azint / grav_accel
      g1h = 0.5 * g1

! ----------------------------------------------------------------------
!  compute band weights
! ----------------------------------------------------------------------

      do 50 lb=1,nb
        vcube(lb) = v(lb) * v(lb) ** 2
   50 continue

      do 52 lb=1,nb
        do 52 i=1,ix
          expzs(i,lb) = exp(c2 / temp_kelvin(i,0) * v(lb)) - 1.0
   52 continue

      do 54 lb=1,nb
        bc = c1 * vcube(lb) * dv(lb)
        do 54 i=1,ix
          bwz(i,lb) = bc / (expzs(i,lb) * planck_func(i,0))
   54 continue

      do 56 k=0,kx
        do 56 i=1,ix
          dbbdt(i,k) = 4.0 * sigma * temp_kelvin(i,k)**3
   56 continue

      do 58 lb=1,nb
        bandc1 = c1 * vcube(lb)
        bandc2 = c2 * v(lb)
        bc     = bandc1 * bandc2 * dv(lb)
        do 58 k=0,kx
          do 58 i=1,ix
            bw(i,k,lb) = exp(bandc2 / temp_kelvin(i,k))
            bw(i,k,lb) = bc * bw(i,k,lb) &
                         / ((bw(i,k,lb) - 1.0) * temp_kelvin(i,k))**2
            bw(i,k,lb) = bw(i,k,lb) / dbbdt(i,k)
   58 continue

! ----------------------------------------------------------------------
!  compute field arrays needed for trans calculation
!    (note that temp_kelvin has already been computed and stored in flux)
! ----------------------------------------------------------------------

      do 70 i=1,ix
        pdi(i, 0) = 0.0
        pfl(i, 0) = 0.0
        pdi(i,kp) = psj(i)
   70 continue

      do 72 k=1,kx
        do 72 i=1,ix
          pdi (i,k) = psj(i) * sigma_level(i,k)
          pfl (i,k) = psj(i) * sigma_half_level(i,k)
          dpdi(i,k) = psj(i) * sigma_thick(i,k)
          ro3 (i,k) = o3_mixrat(k)
   72 continue

      do 74 k=1,kx
        do 74 i=1,ix
          rh2o  (i,k) = rj(i,k)
          qdi   (i,k) = (pfl(i,k) + pfl(i,k-1)) * o2po
          t260  (i,k) = temp_kelvin(i,k) - 260.0
          fbignl(i,k) = exp(1800.0/temp_kelvin(i,k)-6.081081081)
!        the kernel is      1800.0*(1.0/temp-1.0/296.0)
   74 continue

      do 76 i=1,ix
        rh2o(i, 0) = 0.0
        ro3 (i, 0) = 0.0
        rh2o(i,kp) = rh2o(i,kx)
        ro3 (i,kp) = ro3 (i,kx)
   76 continue

      do 77 k=1,kp
       do 77 i=1,ix
         rh2o(i,k) = max(rh2o(i,k),3.0e-6)
   77 continue

      cco2 = co2_mixrat * g1
      do 78 k=1,kx
        do 78 i=1,ix
          duh2o (i,k) = dpdi  (i,k) * rh2o  (i,k) * g1
          duco2 (i,k) = dpdi  (i,k) * cco2
          duo3  (i,k) = dpdi  (i,k) * ro3   (i,k) * g1
          duqh2o(i,k) = duh2o (i,k) * qdi   (i,k)
          bignel(i,k) = (fbignl(i,k)*duqh2o(i,k)*rh2o(i,k)) / (0.622+rh2o(i,k))
   78 continue

! ----------------------------------------------------------------------
!  compute transm and transz

!  transm(i,k,l) is the transmission coefficient for longwave radiation
!    passing from vertical level l to level k
!  transz is a correction for radiation from the top of the atmosphere
! ----------------------------------------------------------------------

      do 80 l=0,kx
       do 80 k=0,kx
        do 80 i=1,ix
         trans (i,k,l) = 0.0
         lw_trans_coeff(i,k,l) = 0.0
   80 continue
      do 82 k=0,kx
       do 82 i=1,ix
        lw_toa_correct(i,k) = 0.0
   82 continue

!  ***** begin loop on longwave frequency bands *****

      do 2890 lb= 1, nb

! ****** h2o contribution

! ******  compute temperature adjustment to line strength and line width

        do 1300 l=1,2
          do 1300 k=1,kx
            do 1300 i=1,ix
              tadj(i,k,l) = (h2o_corr_a(lb,l) + h2o_corr_b(lb,l) * t260(i,k)) * t260(i,k)
              tadj(i,k,l) = expx(tadj(i,k,l))
 1300   continue

        do 1310 k=0,kx
         do 1310 i=1,ix
          sfac(i,k) = 0.0
          pfac(i,k) = 0.0
 1310   continue
        do 1320 k=1,kx
         do 1320 i=1,ix
          bign(i,k) = 0.0
 1320   continue

!     compute h2o contribution to lower triangular half of trans matrix
!     note that a non-physical factor of sod has been folded into duqfac
!     to cancel the factor that arises when sfac is squared in 1550 loop

        asodsq = h2o_line_strength(lb) * h2o_line_width(lb)
        if (h2o_line_strength(lb) .eq. 0.0) asodsq = h2o_line_width(lb)
        do 1400 k=1,kx
          do 1400 i=1,ix
            dufac (i,k) = h2o_line_strength(lb) * duh2o (i,k) * tadj(i,k,2)
            duqfac(i,k) = asodsq  * duqh2o(i,k) * tadj(i,k,1)
 1400   continue

        do 1550 l=kx-1,0,-1
          do 1500 k=l+1,kx
            do 1500 i=1,ix
              sfac(i,k) = sfac(i,k) + dufac (i,l+1)
              pfac(i,k) = pfac(i,k) + duqfac(i,l+1)
              bign(i,k) = bign(i,k) + bignel(i,l+1)
 1500     continue

          do 1550 k=l+1,kx
            do 1550 i=1,ix
              trans(i,k,l) = exp(-c(lb) * bign(i,k) - sfac(i,k) / sqrt(1.0 + sfac(i,k)**2 / pfac(i,k)))
 1550   continue

! ****** compute h2o contribution to diagonal elements of trans matrix

        diag = exp(-c(lb) - h2o_line_strength(lb)/sqrt(1.0 + h2o_line_strength(lb)/h2o_line_width(lb)))

! ****** co2 contribution

        if (lb .ne. 6) goto 2500

        do 2005 k=0,kx
         do 2005 i=1,ix
          sfac(i,k) = 0.0
          pfac(i,k) = 0.0
 2005   continue
        do 2007 k=1,kx
         do 2007 i=1,ix
          tfac(i,k) = 0.0
 2007   continue

! **** compute co2 contribution to lower triangular half of trans matrix

        do 2010 k=1,kx
          do 2010 i=1,ix
            duqfac(i,k) = duco2(i,k) * qdi (i,k)
            tdpfac(i,k) = temp_kelvin(i,k) * dpdi(i,k)
 2010   continue

        do 2050 l=kx-1,0,-1
          do 2020 k=l+1,kx
            do 2020 i=1,ix
              sfac(i,k) = sfac(i,k) + duco2 (i,l+1)
              pfac(i,k) = pfac(i,k) + duqfac(i,l+1)
              tfac(i,k) = tfac(i,k) + tdpfac(i,l+1)
              teff(i,k) = tfac(i,k) / (pfl(i,k) - pfl(i,l))
 2020     continue
          do 2030 k=l+1,kx
            do 2030 i=1,ix
              ulog(i,k) = alog10(sfac(i,k))
              plog(i,k) = alog10(pfac(i,k)) - ulog(i,k)
              ulog(i,k) = ulog(i,k) + 2.70668
 2030     continue

!   ------ ORIGINAL CODE ------------------------
!          if (l .eq. kx-1) then
!            i = 0
!            ulog(i,kx) = 2.70668
!            plog(i,kx) = 0.0
!            teff(i,kx) = 0.0
!            len = ix + 1
!          else
!            i = 1
!            len = ix * (kx - l)
!          endif

! ****** call lwco2 to compute tcof values

!          call lwco2(ulog(i,l+1),  plog(i,l+1), teff(i,l+1), len, tcof(i,l+1))

! ****** compute co2 contribution to diagonal elements of trans matrix

!          if (l .eq. kx-1) diag = tcof(i,kx) * diag
!  ---------END OF ORIGINAL CODE -----------------------
!  ---------BEGIN TK MODIFICATIONS

          if (l .eq. kx-1) then
            i = ix
            ulog(i,kx-1) = 2.70668
            plog(i,kx-1) = 0.0
            teff(i,kx-1) = 0.0
            len = ix + 1

! ******    call lwco2 to compute tcof values

            call lwco2(ulog(i,kx-1),  plog(i,kx-1), teff(i,kx-1), &
                       len, tcof(i,kx-1))

! ******    compute co2 contribution to diagonal elements of trans matrix

            diag = tcof(i,kx-1) * diag

           else
             i = 1
             len = ix * (kx - l)

! ******    call lwco2 to compute tcof values

            call lwco2(ulog(i,l+1),  plog(i,l+1), teff(i,l+1), &
                       len, tcof(i,l+1))
          endif

!  -----------END OF TK MODIFICATIONS -------------------

! ****** accumulate co2 tcof into trans (lower triangular half)

          do 2040 k=l+1,kx
            do 2040 i=1,ix
              trans(i,k,l) = tcof(i,k) * trans(i,k,l)
 2040     continue
 2050   continue

! ****** ozone contribution

 2500   if (lb .ne. 9) go to 2855

        do 2555 k=0,kx
         do 2555 i=1,ix
          sfac(i,k) = 0.0
          pfac(i,k) = 0.0
 2555   continue
!       sfac = 0.0
!       pfac = 0.0

! **** compute o3 contribution to lower triangular half of trans matrix

        do 2600 k=1,kx
          do 2600 i=1,ix
            duqfac(i,k) = pi_alpha * duo3(i,k) * qdi(i,k)
 2600   continue

        do 2700 l=kx-1,0,-1
          do 2650 k=l+1,kx
            do 2650 i=1,ix
              sfac(i,k) = sfac(i,k) + duo3  (i,l+1)
              pfac(i,k) = pfac(i,k) + duqfac(i,l+1)
 2650     continue
          do 2700 k=l+1,kx
            do 2700 i=1,ix
              peff (i,k  ) = pfac(i,k) / sfac(i,k)
              fac1 (i,k  ) = sfac(i,k) / peff(i,k)
              fac2 (i,k  ) = 1.0 - exp(-5.0 * peff(i,k) * (sqrt(1.0 + ak2x4 * fac1(i,k)) - 1.0))
              fac1 (i,k  ) = 1.0 - exp(-5.0 * peff(i,k) * (sqrt(1.0 + ak1x4 * fac1(i,k)) - 1.0))
              tcof (i,k  ) = 1.0 - (c3a1 * fac1(i,k) + c3a2 * fac2(i,k))
              trans(i,k,l) = tcof(i,k) * trans(i,k,l)
 2700   continue

! ****** compute o3 contribution to diagonal elements of trans matrix

        factr1 = 1.0 - exp(-5.0 * pi_alpha * (sqrt(1.0 + ak1x4 / pi_alpha) - 1.0))
        factr2 = 1.0 - exp(-5.0 * pi_alpha * (sqrt(1.0 + ak2x4 / pi_alpha) - 1.0))
        diago3 = 1.0 - (c3a1 * factr1 + c3a2 * factr2)
        diag   = diago3 * diag

! ****** apply band weights to trans; accumulate
! ****** as absorp. in transm & transz

! ****** first convert trans and diag to absorption

 2855   continue
        do 2857 l=0,kx
         do 2857 k=0,kx
          do 2857 i=1,ix
           trans(i,k,l) = 1.0 - trans(i,k,l)
 2857   continue
        diag  = 1.0 - diag

        do 2860 l=0,kx-1
          do 2860 k=l+1,kx
            do 2860 i=1,ix
              lw_trans_coeff(i,k,l) = lw_trans_coeff(i,k,l) + trans(i,k,l) * bw(i,l,lb)
 2860   continue

        do 2865 l=1,kx
          do 2865 k=0,l-1
            do 2865 i=1,ix
              lw_trans_coeff(i,k,l) = lw_trans_coeff(i,k,l) + trans(i,l,k) * bw(i,l,lb)
 2865   continue

        do 2870 l=0,kx
          do 2870 i=1,ix
            lw_trans_coeff(i,l,l) = lw_trans_coeff(i,l,l) + diag * bw(i,l,lb)
 2870   continue

        do 2875 l=1,kx
          do 2875 i=1,ix
            lw_toa_correct(i,l) = lw_toa_correct(i,l) + trans(i,l,0) * bwz(i,lb)
 2875   continue

        do 2880 i=1,ix
          lw_toa_correct(i,0) = lw_toa_correct(i,0) + diag * bwz(i,lb)
 2880   continue

 2890 continue

!  ***** end loop on longwave frequency bands *****

!  convert transm & transz from absorption to transmission coefficients

      do 2897 l=0,kx
       do 2897 k=0,kx
        do 2897 i=1,ix
         lw_trans_coeff(i,k,l) = 1.0 - lw_trans_coeff(i,k,l)
 2897 continue
       do 2898 k=0,kx
        do 2898 i=1,ix
         lw_toa_correct(i,k) = 1.0 - lw_toa_correct(i,k)
 2898 continue

! ----------------------------------------------------------------------
!  compute absrbx

!  absrbx is a correction for the finite thickness of the vertical
!    levels, and represents within-layer absorption of radiation
! ----------------------------------------------------------------------

!     absrbx = 0.0
      do 2899 l=1,2
       do 2899 k=0,kx
        do 2899 i=1,ix
         lw_abs_quarter(i,k,l) = 0.0
 2899 continue

!  kq=1 is the upward-flux correction; kq=2 is for downward flux

      do 5000 kq=1,2

!  compute coefficients needed for quarter-layer correction

        if (kq.eq.2) goto 3050

        do 3010 k=1,kx-1
          do 3010 i=1,ix
            dpfac(i,k) = (pdi(i,k+1) - pfl(i,k)) * g1h
 3010   continue

        do 3020 k=1,kx-1
          do 3020 i=1,ix
            txdegk(i,k) = 0.375 * temp_kelvin(i,k) + 0.625 * temp_kelvin(i,k+1)
            qx    (i,k) = (0.75 * pfl(i,k) + 0.25 * pdi(i,k+1)) * opo
            duxh2o(i,k) = (0.375 * rh2o(i,k) + 0.625 * rh2o(i,k+1)) * dpfac(i,k)
            duxco2(i,k) = co2_mixrat * dpfac(i,k)
            duxo3 (i,k) = (0.375 * ro3(i,k) + 0.625 * ro3(i,k+1)) * dpfac(i,k)
            bignel(i,k) = (0.375 * rh2o(i,k) + 0.625 * rh2o(i,k+1))**2 &
                          * dpfac(i,k) * fbignl(i,k+1) / &
                          (0.622 + 0.375*rh2o(i,k) + 0.625*rh2o(i,k+1))
 3020   continue

        do 3030 i=1,ix
          txdegk(i, 0) = 0.75 * temp_kelvin(i,0) + 0.25 * temp_kelvin(i,1)
          txdegk(i,kx) = temp_kelvin(i,kp)
          qx    (i, 0) = (0.75 * pdi(i,0) + 0.25 * pdi(i,1)) * opo
          qx    (i,kx) = psj(i) * opo
          duxh2o(i, 0) = (0.25 * rh2o(i,0) + 0.75 * rh2o(i,1)) * (pdi(i,1) - pdi(i,0)) * g1h
          duxh2o(i,kx) = 0.0
          duxco2(i, 0) = co2_mixrat * (pdi(i,1) - pdi(i,0)) * g1h
          duxco2(i,kx) = 0.0
          duxo3 (i, 0) = (0.25 * ro3(i,0) + 0.75 * ro3(i,1)) * (pdi(i,1) - pdi(i,0)) * g1h
          duxo3 (i,kx) = 0.0
          bignel(i, 0) = (0.75 * rh2o(i,0) + 0.25 * rh2o(i,1))**2 &
                       * (pdi(i,1)-pdi(i,0)) * g1h * fbignl(i,1) / &
                         (0.622 + 0.75*rh2o(i,0) + 0.25*rh2o(i,1))
          bignel(i,kx) = 0.0
 3030   continue

        do 3040 k=0,kx
          do 3040 i=1,ix
            t260(i,k) = txdegk(i,k) - 260.0
 3040   continue

        go to 3100

 3050   do 3060 k=1,kx-1
          do 3060 i=1,ix
            dpfac(i,k) = (pfl(i,k) - pdi(i,k)) * g1h
 3060   continue

        do 3070 k=1,kx-1
          do 3070 i=1,ix
            txdegk(i,k) = 0.625 * temp_kelvin(i,k) + 0.375 * temp_kelvin(i,k+1)
            qx    (i,k) = (0.75 * pfl(i,k) + 0.25 * pdi(i,k)) * opo
            duxh2o(i,k) = (0.625 * rh2o(i,k) + 0.375 * rh2o(i,k+1)) * dpfac(i,k)
            duxco2(i,k) = co2_mixrat * dpfac(i,k)
            duxo3 (i,k) = (0.625 * ro3(i,k) + 0.375 * ro3(i,k+1)) * dpfac(i,k)
            bignel(i,k) = (0.625*rh2o(i,k) + 0.375*rh2o(i,k+1))**2 &
                          * dpfac(i,k) * fbignl(i,k) / &
                          (0.622 + 0.625*rh2o(i,k) + 0.375*rh2o(i,k+1))
 3070   continue

        do 3080 i=1,ix
          txdegk(i, 0) = temp_kelvin(i,0)
          txdegk(i,kx) = 0.75 * temp_kelvin(i,kp) + 0.25 * temp_kelvin(i,kx)
          qx    (i, 0) = 1.0
          qx    (i,kx) = (0.75 * pdi(i,kp) + 0.25 * pdi(i,kx)) * opo
          duxh2o(i, 0) = 0.0
          duxh2o(i,kx) = (0.75 * rh2o(i,kp) + 0.25 * rh2o(i,kx)) * (pdi(i,kp) - pdi(i,kx)) * g1h
          duxco2(i, 0) = 0.0
          duxco2(i,kx) = co2_mixrat * (pdi(i,kp) - pdi(i,kx)) * g1h
          duxo3 (i, 0) = 0.0
          duxo3 (i,kx) = (0.75 * ro3(i,kp) + 0.25 * ro3(i,kx)) * (pdi(i,kp) - pdi(i,kx)) * g1h
          bignel(i, 0) = 0.
          bignel(i,kx) = (0.75 * rh2o(i,kp) + 0.25 * rh2o(i,kx))**2 &
                       * (pdi(i,kp)-pdi(i,kx)) * g1h * fbignl(i,kx) / &
                         (0.622 + 0.75*rh2o(i,kp) + 0.25*rh2o(i,kx))
 3080   continue

        do 3090 k=0,kx
          do 3090 i=1,ix
            t260(i,k) = txdegk(i,k) - 260.0
 3090   continue

!  ***** begin loop on longwave frequency bands *****

 3100   do 4000 lb=1,nb

! ****** quarter-layer h2o absorption

! ****** compute temperature adjustment to line strength and line width

          do 3150 k=0,kx
            do 3150 i=1,ix
              tadj(i,k,1) = (h2o_corr_a(lb,1) + h2o_corr_b(lb,1) * t260(i,k)) * t260(i,k)
              tadj(i,k,2) = (h2o_corr_a(lb,2) + h2o_corr_b(lb,2) * t260(i,k)) * t260(i,k)
              tadj(i,k,1) = tadj(i,k,1) - tadj(i,k,2)
 3150     continue

          do 3200 l=1,2
            do 3200 k=0,kx
              do 3200 i=1,ix
                tadj(i,k,l) = expx(tadj(i,k,l))
 3200     continue

! ****** compute h2o contribution to quarter-layer absorption matrix

          do 3300 k=0,kx
            do 3300 i=1,ix
              sfac (i,k   ) = h2o_line_strength(lb) * duxh2o(i,k) * tadj(i,k,2)
              pfac (i,k   ) = h2o_line_width(lb) * qx(i,k) * tadj(i,k,1)
              trans(i,k,kq) = exp(-c(lb) * bignel(i,k) -sfac(i,k)/sqrt(1.0+sfac(i,k)/pfac(i,k)))
 3300     continue

! ****** quarter-layer co2 absorption

          if (lb .ne. 6) go to 3700

! ****** compute co2 contribution to quarter-layer absorption matrix

          len = ix * kp
          do 3410 k=0,kx
           do 3410 i=1,ix
            sfac(i,k) = duxco2(i,k)
 3410     continue
          do 3420 k=0,kx
           do 3420 i=1,ix
            duxco2(i,k) = max(duxco2(i,k),1.0e-6)
 3420     continue
          do 3500 k=0,kx
            do 3500 i=1,ix
              ulog(i,k) = alog10(duxco2(i,k)) + 2.70668
              plog(i,k) = alog10(qx(i,k))
 3500     continue

! ****** call lwco2 to compute tcof values

          call lwco2(ulog(1,0), plog(1,0), txdegk(1,0), len, tcof(1,0))

! ****** accumulate co2 ccp into trans

          do 3600 k=0,kx
            do 3600 i=1,ix
              tcof(i,k) = tcof(i,k) * trans(i,k,kq)
 3600     continue
          do 3610 k=0,kx
           do 3610 i=1,ix
            if(sfac(i,k) .gt. 0.0) then
              trans(i,k,kq) = tcof(i,k)
            endif
 3610     continue

! ****** quarter-layer o3 absorption

 3700     if (lb .ne. 9) go to 3900

          do 3800 k=0,kx
            do 3800 i=1,ix
              peff (i,k   ) = pi_alpha * qx(i,k)
              fac2 (i,k   ) = duxo3(i,k) / peff(i,k)
              fac1 (i,k   ) = 1.0 - exp(-5.0 * peff(i,k) * (sqrt(1.0 + ak1x4 * fac2(i,k)) - 1.0))
              fac2 (i,k   ) = 1.0 - exp(-5.0 * peff(i,k) * (sqrt(1.0 + ak2x4 * fac2(i,k)) - 1.0))
              tcof (i,k   ) = 1.0 - (c3a1 * fac1(i,k) + c3a2 *fac2(i,k))
              trans(i,k,kq) = tcof(i,k) * trans(i,k,kq)
 3800     continue
 
! ****** total quarter-layer absorption
 
 3900     do 4000 k=0,kx
            do 4000 i=1,ix
              lw_abs_quarter(i,k,kq) = lw_abs_quarter(i,k,kq) + (1.0 - trans(i,k,kq)) * bw(i,k,lb)
 4000 continue
 
 5000 continue
 
!  ***** end of principal quarter-layer loop *****
 
      return
        end subroutine lwtran
 
      subroutine lwco2 (ulog,plog,teff,ln,tco2)

!  table lookup routine for co2 transmission
 
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
!  routine:   lwco2
!  called by: lwtran
!  calls:     none
!  purpose:   compute longwave co2 transmission
 
!  inputs:
!     ulog           log of co2 amount
!     plog           log of effective pressure
!     teff           effective temperature
!     ln             length of call-argument arrays
 
!  output:
!     tco2           co2 transmission coefficient
 
!  side effects:
!     none
!     (i.e., no input variables or common blocks modified, etc.)
 
!  procedure:
!     a 2d table lookup of co2 absorption is performed.  the axes are
!     log of the co2 amount and log of the effective pressure.  an
!     effective temperature of 300k is assumed for this first step.
!     a correction for temperatures in the range 200k-300k is made by
!     multiplying a temperature correction factor by the difference
!     between the effective temperature and 300k, and adding the
!     result to the previously calculated absorption.  the temperature
!     correction factor is found by 2d table lookup, using the same
!     axes as were used to obtain the 300k absorption.  no temperature
!     correction is applied if the temperature exceeds 300k; if the
!     temperature falls below 200k, the 200k correction is applied.
!     if the co2 concentration is too low, no temperature correction
!     is made.
 
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
!  TK Mod:  set up in parent routine:
!      parameter ( lmax = ix * (kx + 1) )
 
      integer, intent(in) :: ln
      real, intent(in) :: ulog(ln) 
      real, intent(in) :: plog(ln) 
      real, intent(in) :: teff(ln)
 
      real, intent(out) :: tco2(ln) 
 
      real :: ahi   (lmax), alo   (lmax), cct   (lmax), cdt   (lmax), fulog (lmax)
      integer :: nplog (lmax), iulog (lmax), index (lmax)
      real :: plnum (lmax), plden (lmax), plfac (lmax), tcor  (lmax)
      real :: alogoo(lmax), alogpo(lmax), alogop(lmax), alogpp(lmax)
      real :: pltab (  12)
      integer :: iu, l, n
 
!c TK: Removed unnecessary equivalences:
!c TK:      equivalence (alogoo, plnum), (alogpo, plden, alo, tcor)
!c TK:      equivalence (alogop, iulog), (alogpp, index, ahi, cdt )
 
      data pltab / &
           -4.50000, -4.00000, -3.40000, -2.88081, -2.27875, -1.88081, &
           -1.57978, -1.27875, -0.88081, -0.48287,  0.     ,  0.29528 /

! ****** check for out-of-range ulog input values

      iu = 0
      do 25 l=1,ln
        if ( ulog(l).lt.-4.25 ) iu=iu+1
   25 continue
      if ( iu.ne.0 ) go to 1200

! ****** compute pressure range for tables,
! ****** and pressure interpolation factor

      do 50 l=1,ln
        nplog(l) = 1
   50 continue

      do 100  n=2,11
        do 100  l=1,ln
          if ( plog(l).gt.pltab(n) ) then
            nplog(l) = n
            plnum(l) = plog(l) - pltab(n)
            plden(l) = pltab(n+1) - pltab(n)
          endif
  100 continue

      do 200 l=1,ln
        plfac(l) = plnum(l) / plden(l)
  200 continue

! ****** compute co2 absorption for an effective temperature of 300k

      do 500 l=1,ln
        fulog(l) = 4 * ulog(l) + 18
        iulog(l) = int(fulog(l))

!        TK diagnostic printout:
!        print *, 'TK chkpt 1 in lwco2:  l, ulog(l), fulog(l), ', &
!                   'int(fulog(l)), iulog(l) = ', &
!                  l, ulog(l), fulog(l), int(fulog(l)), iulog(l)

        if ( iulog(l).gt.29 ) iulog(l) = 29
        fulog(l) = fulog(l) - real(iulog(l))
  500 continue

      do 600 l = 1, ln
        index(l) = iulog(l) + 30 * (nplog(l) - 1)
  600 continue

      do 620 l=1,ln
        alogoo(l) = absorp_table(index(l),1)
  620 continue
      do 640 l=1,ln
        index (l) = index(l) + 1
        alogpo(l) = absorp_table(index(l),1)
  640 continue
      do 660 l=1,ln
        index (l) = index(l) + (30 - 1)
        alogop(l) = absorp_table(index(l),1)
  660 continue
      do 680 l=1,ln
        index (l) = index(l) + 1
        alogpp(l) = absorp_table(index(l),1)
  680 continue

      do 700  l = 1, ln
        ahi(l) = alogop(l) + fulog(l) * (alogpp(l) - alogop(l))
        alo(l) = alogoo(l) + fulog(l) * (alogpo(l) - alogoo(l))
        cct(l) = alo   (l) + plfac(l) * (ahi   (l) - alo   (l))
  700 continue

! ****** compute temperature correction coefficient for co2 absorption

      do 750 l=1,ln
        fulog(l) = ulog(l) + 4
        iulog(l) = int(fulog(l))
        if ( iulog(l).gt.6 ) iulog(l) = 6
        fulog(l) = fulog(l) - real(iulog(l))
  750 continue

      do 800 l = 1, ln
        index(l) = iulog(l) + 7 * (nplog(l) - 1)
  800 continue

      do 820 l=1,ln
        alogoo(l) = d_absorp_dt(index(l),1)
  820 continue
      do 840 l=1,ln
        index (l) = index(l) + 1
        alogpo(l) = d_absorp_dt(index(l),1)
  840 continue
      do 860 l=1,ln
        index (l) = index(l) + (7 - 1)
        alogop(l) = d_absorp_dt(index(l),1)
  860 continue
      do 880 l=1,ln
        index (l) = index(l) + 1
        alogpp(l) = d_absorp_dt(index(l),1)
  880 continue

      do 900 i = 1, ln
        ahi(i) = alogop(i) + fulog(i) * (alogpp(i) - alogop(i))
        alo(i) = alogoo(i) + fulog(i) * (alogpo(i) - alogoo(i))
        cdt(i) = alo   (i) + plfac(i) * (ahi   (i) - alo   (i))
  900 continue

! ****** restrict effective temperature input values to proper range

      do 950 l=1,ln
        tcor(l) = teff(l)
        if ( tcor(l).gt.320.0 ) tcor(l) = 320
        if ( tcor(l).lt.180.0 ) tcor(l) = 180
  950 continue

! ****** apply temperature correction to co2
! ****** absorption if ulog is in range

      do 1000  l=1,ln
        cdt (l) = cct(l) + 0.01 * (cdt(l) * (tcor(l) - 300))
        tco2(l) = 1 - 1.3077 * cdt(l)
 1000 continue

      do 1100 l=1,ln
        if ( ulog(l).lt.-3 ) tco2(l) = 1 - 1.3077 * cct(l)
 1100 continue

      return

! ****** fatal error: ulog out-of-range

 1200 write(6,1201) ulog
      call Error_Mesg ( 'lwco2 in MCM_LW_MOD','ulog out of range.', FATAL)

 1201 format('1ulog > 3. or < -4.25; execution terminated' / ' the ulog vector is:' / (8e16.8))

        end subroutine lwco2

      end module mcm_lw_mod

module pinterp_utilities_mod

use netcdf

implicit none
private

public :: copy_axis, copy_variable,    &
          define_new_variable,         &
          set_verbose_level,           &
          error_handler

integer, parameter :: max_char = 128
integer :: verbose = 1


contains

!#######################################################################

   subroutine copy_axis (ncid_in, name_in, ncid_out, dimid_out, &
                         varid_in, varid_out, dimlen,           &
                         dimlen_in, name_out, name_edges)

   integer,          intent(in)  :: ncid_in
   character(len=*), intent(in)  :: name_in
   integer,          intent(in)  :: ncid_out
   integer,          intent(out) :: dimid_out, varid_in, varid_out, dimlen
   integer,          intent(in),  optional :: dimlen_in
   character(len=*), intent(in),  optional :: name_out
   character(len=*), intent(out), optional :: name_edges

    character(len=NF90_MAX_NAME) :: oname, attname
    integer :: istat, recdim, dimid_in, xtype, ndims, natts, attnum, i
    logical :: found_edges, found_bounds
    character(len=NF90_MAX_NAME) :: name_bounds

                             oname = trim(name_in)
      if (present(name_out)) oname = trim(name_out)

    ! search for axis edges (old convention) and bounds (CF convention)
      if (present(name_edges)) then
          do i=1,NF90_MAX_NAME; name_edges (i:i)=' '; enddo
          do i=1,NF90_MAX_NAME; name_bounds(i:i)=' '; enddo
      endif
      found_edges  = .false.
      found_bounds = .false.

      if (verbose > 1) print *, 'copy axis name=', trim(name_in)

    ! get record dimension id
      istat = NF90_INQUIRE (ncid_in, unlimiteddimid=recdim)

    ! get axis id
      istat = NF90_INQ_DIMID ( ncid_in, trim(name_in), dimid_in )
      if (istat /= NF90_NOERR) call error_handler (ncode=istat)

    ! get axis length
      if (present(dimlen_in)) then
         dimlen = dimlen_in
      else
         istat = NF90_INQUIRE_DIMENSION ( ncid_in, dimid_in, len=dimlen)
         if (istat /= NF90_NOERR) call error_handler (ncode=istat)
      endif

    ! define output axis

      if (dimid_in /= recdim) then
        ! non-time axis
          istat = NF90_DEF_DIM ( ncid_out, trim(oname), dimlen, dimid_out )
          if (istat /= NF90_NOERR) call error_handler (ncode=istat)
      else
        ! time axis
          istat = NF90_DEF_DIM ( ncid_out, trim(oname), NF90_UNLIMITED, dimid_out )
          if (istat /= NF90_NOERR) call error_handler (ncode=istat)
      endif

    ! get variable id
      istat = NF90_INQ_VARID ( ncid_in, trim(name_in), varid_in )
    ! axis does not have a variable associated with it
    ! set output variables and return
      if (istat /= NF90_NOERR) then
          varid_in  = -1
          varid_out = -1
          return
      endif
      istat = NF90_INQUIRE_VARIABLE (ncid_in, varid_in, xtype=xtype, ndims=ndims, natts=natts)
      if (istat /= NF90_NOERR) call error_handler (ncode=istat)

    ! must have one dimension
      if (ndims /= 1) then
         print *, 'ERROR: axis variable has more than one dimension'
         stop 111
      endif

    ! define output variable
      istat = NF90_DEF_VAR (ncid_out, trim(oname), xtype, (/dimid_out/), varid_out)
      if (istat /= NF90_NOERR) call error_handler (ncode=istat)

    ! copy attributes
      do attnum = 1, natts
         istat = NF90_INQ_ATTNAME (ncid_in, varid_in, attnum, attname)
         if (istat /= NF90_NOERR) call error_handler (ncode=istat)
         istat = NF90_COPY_ATT (ncid_in, varid_in, trim(attname), ncid_out, varid_out)
         if (istat /= NF90_NOERR) call error_handler (ncode=istat)
         if (trim(attname) == 'edges') then
             if (present(name_edges)) then
                istat = NF90_GET_ATT (ncid_in, varid_in, 'edges', name_edges)  ! should check to see that length
                                                                               ! of name_edges is sufficient
                if (istat /= NF90_NOERR) call error_handler (ncode=istat)
                found_edges = .true.
             endif
         else if (trim(attname) == 'bounds') then
             if (present(name_edges)) then
                istat = NF90_GET_ATT (ncid_in, varid_in, 'bounds', name_bounds)
                if (istat /= NF90_NOERR) call error_handler (ncode=istat)
                found_bounds = .true.
             endif
         endif
      enddo

    ! if both axis edges and axis bounds check for agreement
    ! if they disagree then use the axis bounds
      if (found_edges .and. found_bounds) then
          if (name_edges /= name_bounds) then
             print *, 'WARNING: axis edges and bounds disagee for axis = ',trim(name_in)
             print *, 'WARNING: will continue using the axis bounds'
             name_edges = name_bounds
          endif
      endif

!-----------------------------------------------------------------------

   end subroutine copy_axis

!#######################################################################

   subroutine copy_variable ( ncid_in, name_in, ncid_out, dimids, varid_out, &
                              name_out, pack, range, missvalue    )

   integer,          intent(in)  :: ncid_in, ncid_out, dimids(:)
   character(len=*), intent(in)  :: name_in
   integer,          intent(out) :: varid_out

   character(len=*), intent(in), optional :: name_out
            logical, intent(in), optional :: pack
               real, intent(in), optional :: range(2), missvalue

    character(len=NF90_MAX_NAME) :: oname, attname
    integer :: istat, varid_in,  xtype, ndims, natts, attnum
    logical :: no_missing_value, no_valid_range, no_add_offset, no_scale_factor
!-----------------------------------------------------------------------
      if (verbose > 1) print *, 'copy_variable name=', trim(name_in)

      no_missing_value = .true.
      no_valid_range   = .true.
      no_add_offset    = .true.
      no_scale_factor  = .true.

      oname = name_in
      if (present(name_out)) oname = name_out

    ! get variable information
      istat = NF90_INQ_VARID ( ncid_in, trim(name_in), varid_in )
      if (istat /= NF90_NOERR) call error_handler (ncode=istat)
      istat = NF90_INQUIRE_VARIABLE ( ncid_in, varid_in, &
                    xtype=xtype, ndims=ndims, natts=natts)
      if (istat /= NF90_NOERR) call error_handler (ncode=istat)

      if (size(dimids,1) /= ndims) then
          call error_handler ('Inconsistent number of dimensions when copying variable')
      endif

    ! define output variable 
      istat = NF90_DEF_VAR ( ncid_out, trim(oname), xtype, dimids, varid_out)
      if (istat /= NF90_NOERR) call error_handler (ncode=istat)

    ! new missing value?

    ! copy variable attributes
      do attnum = 1, natts
         istat = NF90_INQ_ATTNAME (ncid_in, varid_in, attnum, attname)
         if (istat /= NF90_NOERR) call error_handler (ncode=istat)
         ! special treatment of several attributes
         if (trim(attname) == 'missing_value') then
             if (present(missvalue)) then
                 call put_missing_value (ncid_out, varid_out, xtype, missvalue)
                 no_missing_value = .false.
                 cycle
             endif
         else if (trim(attname) == 'valid_range') then
             if (present(range)) then
                 call put_valid_range (ncid_out, varid_out, xtype, range)
                 no_valid_range = .false.
                 cycle
             endif
        !else if (trim(attname) == 'add_offset') then
        !    no_add_offset = .false.
        !else if (trim(attname) == 'scale_factor') then
        !    no_scale_factor = .false.
         endif
         istat = NF90_COPY_ATT (ncid_in, varid_in, trim(attname), ncid_out, varid_out)
         if (istat /= NF90_NOERR) call error_handler (ncode=istat)
      enddo

    ! add missing value attribute if necessary
      if (present(missvalue) .and. no_missing_value) then
          call put_missing_value (ncid_out, varid_out, xtype, missvalue)
      endif
    ! add valid range attribute if necessary
      if (present(range) .and. no_valid_range) then
          call put_valid_range (ncid_out, varid_out, xtype, range)
      endif

!-----------------------------------------------------------------------

   end subroutine copy_variable

!#######################################################################

 subroutine put_missing_value ( ncid, varid, xtype, missval )
 integer, intent(in) :: ncid, varid, xtype
 real,    intent(in) :: missval

  integer :: istatmiss
  integer :: istatfill
! machine dependent data kind
  integer(2) :: imiss2
  integer(4) :: imiss4
  real(4)    :: miss4
  real(8)    :: miss8

  ! save missing value with same data type as variable

    select case (xtype)
           case (NF90_REAL4)
                miss4 = missval
                istatmiss = NF90_PUT_ATT (ncid, varid, 'missing_value', miss4)
                istatfill = NF90_PUT_ATT (ncid, varid, '_FillValue', miss4)
           case (NF90_INT2)
                imiss2 = nint(missval)
                istatmiss = NF90_PUT_ATT (ncid, varid, 'missing_value', imiss2)
                istatfill = NF90_PUT_ATT (ncid, varid, '_FillValue', imiss2)
           case (NF90_INT)
                imiss4 = nint(missval)
                istatmiss = NF90_PUT_ATT (ncid, varid, 'missing_value', imiss4)
                istatfill = NF90_PUT_ATT (ncid, varid, '_FillValue', imiss4)
           case (NF90_REAL8)
                miss8 = missval
                istatmiss = NF90_PUT_ATT (ncid, varid, 'missing_value', miss8)
                istatfill = NF90_PUT_ATT (ncid, varid, '_FillValue', miss8)
           case default
                call error_handler ('invalid xtype for missing value')
           end select

    if (istatmiss /= NF90_NOERR) call error_handler ('putting missing value', ncode=istatmiss)
    if (istatfill /= NF90_NOERR) call error_handler ('putting fill value', ncode=istatfill)

 end subroutine put_missing_value

!#######################################################################

 subroutine put_valid_range ( ncid, varid, xtype, range )
 integer, intent(in) :: ncid, varid, xtype
 real,    intent(in) :: range(2)

  integer :: istat
! machine dependent data kind
  integer(2) :: irange2(2)
  integer(4) :: irange4(2)
  real(4)    ::  range4(2)
  real(8)    ::  range8(2)

  ! save valid range with same data type as variable

    select case (xtype)
           case (NF90_REAL4)
                range4 = range
                istat = NF90_PUT_ATT (ncid, varid, 'valid_range', range4)
           case (NF90_INT2)
                irange2 = nint(range)
                istat = NF90_PUT_ATT (ncid, varid, 'valid_range', irange2)
           case (NF90_INT)
                irange4 = nint(range)
                istat = NF90_PUT_ATT (ncid, varid, 'valid_range', irange4)
           case (NF90_REAL8)
                range8 = range
                istat = NF90_PUT_ATT (ncid, varid, 'valid_range', range8)
           case default
                call error_handler ('invalid xtype for valid range')
           end select

    if (istat /= NF90_NOERR) call error_handler ('putting valid range', ncode=istat)

 end subroutine put_valid_range

!#######################################################################

 subroutine define_new_variable ( ncid, name, xtype, dimids, varid, &
                                  units, long_name, missing_value,  &
                                  time_avg_info, cell_methods )
 integer,          intent(in)  :: ncid, xtype, dimids(:)
 character(len=*), intent(in)  :: name
 integer,          intent(out) :: varid
 character(len=*), intent(in), optional :: units, long_name, &
                                           time_avg_info, cell_methods
 real,             intent(in), optional :: missing_value

 integer :: istat

  ! define output variable
    istat = NF90_DEF_VAR ( ncid, trim(name), xtype, dimids, varid )
    if (istat /= NF90_NOERR) call error_handler &
                ('defining output variable '//trim(name), ncode=istat)

  ! new attributes
    if (present(units)) then
       istat = NF90_PUT_ATT (ncid, varid, 'units', trim(units))
       if (istat /= NF90_NOERR) call error_handler (ncode=istat)
    endif
    if (present(long_name)) then
       istat = NF90_PUT_ATT (ncid, varid, 'long_name', trim(long_name))
       if (istat /= NF90_NOERR) call error_handler (ncode=istat)
    endif
    ! NOTE: if data is packed then missing value needs to be packed
    if (present(missing_value)) then
       call put_missing_value (ncid, varid, xtype, missing_value)
    endif

    ! time average attributes
    if (present(cell_methods)) then
       if (cell_methods(1:1) .ne. ' ') then
          istat = NF90_PUT_ATT ( ncid, varid, 'cell_methods', trim(cell_methods) )
          if (istat /= NF90_NOERR) call error_handler (ncode=istat)
       endif
    endif
    if (present(time_avg_info)) then
       if (time_avg_info(1:1) .ne. ' ') then
          istat = NF90_PUT_ATT ( ncid, varid, 'time_avg_info',trim(time_avg_info) ) 
          if (istat /= NF90_NOERR) call error_handler (ncode=istat)
       endif
    endif

 end subroutine define_new_variable

!#######################################################################

   function get_variable_axes (ncid, name, axes) result (ndim)
    integer         , intent(in)  :: ncid
    character(len=*), intent(in)  :: name
    character(len=*), intent(out) :: axes(:)
    integer :: ndim

    integer :: dimids(NF90_MAX_VAR_DIMS), istat, varid, ndims, xtype, dimid

  ! get variable information
    istat = NF90_INQ_VARID (ncid, trim(name), varid)
    if (istat /= NF90_NOERR) call error_handler (ncode=istat)
    istat = NF90_INQUIRE_VARIABLE (ncid, varid, xtype=xtype, ndims=ndims, dimids=dimids)
    if (istat /= NF90_NOERR) call error_handler (ncode=istat)
    ndim = ndims

    if (size(axes) < ndim) &
        call error_handler ('ERROR in get_variable_axes: size(axes) < ndim')

    do dimid = 1, ndim
       istat = NF90_INQUIRE_DIMENSION (ncid, dimid, name=axes(dimid))
       if (istat /= NF90_NOERR) call error_handler (ncode=istat)
    enddo

   end function get_variable_axes

!#######################################################################

 subroutine set_verbose_level (verbose_level)
 integer, intent(in) :: verbose_level
   verbose = verbose_level
 end subroutine set_verbose_level

!#######################################################################

 subroutine error_handler (string, ncode)
 character(len=*), intent(in), optional :: string
 integer         , intent(in), optional :: ncode
 character(len=80) :: errstrg
   if (present(ncode))  then
       print *, 'NETCDF ERROR'
   else
       print *, 'ERROR'
   endif
   if (present(string)) print *, trim(string)
   if (present(ncode))  then
       errstrg = NF90_STRERROR (ncode)
       print *, trim(errstrg)
   endif  
   stop 111   
 end subroutine error_handler

!#######################################################################

end module pinterp_utilities_mod

module ocean_tracer_util_mod
#define COMP isc:iec,jsc:jec
!
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
! S. M. Griffies 
! </CONTACT>
!
!<OVERVIEW>
! This module contains many routines of use for tracer diagnostics in MOM. 
!</OVERVIEW>
!
!<DESCRIPTION>
! Tracer utility module for MOM. Of use for tracer diagnostics. 
!</DESCRIPTION>
!
!<NAMELIST NAME="ocean_tracer_util_nml">
!  <DATA NAME="rebin_onto_rho_all_values" TYPE="logical">
!  Set true to if wish to bin all values into density classes, even 
!  those cells whose density is outside the max and min range of the 
!  density bins.  The default is rebin_onto_rho_all_values=.true.,
!  which means those cells with extreme density values will be included. 
!  This default is consistent with the default computation of 
!  transport_on_nrho.  
!  </DATA> 
!
!  <DATA NAME="debug_diagnose_mass_of_layer" TYPE="logical">
!  To help debug the algorithm to diagnose mass of fluid within
!  a neutral density layer. 
!  Default:  debug_diagnose_mass_of_layer=.false.
!  </DATA> 
!  <DATA NAME="epsln_diagnose_mass_of_layer" TYPE="real">
!  Relative mass difference allowable between layer and level total mass. 
!  Default: epsln_diagnose_mass_of_layer=1e-4.
!  </DATA> 
!
!</NAMELIST>
!
use constants_mod,        only: epsln
use fms_mod,              only: open_namelist_file, check_nml_error, close_file
use mpp_mod,              only: input_nml_file, stdout, stdlog, FATAL
use mpp_mod,              only: mpp_error, mpp_pe, mpp_min, mpp_max
use platform_mod,         only: i8_kind
use diag_manager_mod,     only: send_data
  
use ocean_domains_mod,    only: get_local_indices
use ocean_parameters_mod, only: ADVECT_PSOM
use ocean_types_mod,      only: ocean_grid_type, ocean_domain_type
use ocean_types_mod,      only: ocean_prog_tracer_type, ocean_diag_tracer_type
use ocean_types_mod,      only: ocean_time_type, ocean_thickness_type 
use ocean_types_mod,      only: ocean_density_type
use ocean_util_mod,       only: write_timestamp, write_chksum_3d
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3, wrk4
use ocean_workspace_mod,  only: wrk1_v, wrk2_v, wrk3_v
use ocean_workspace_mod,  only: wrk1_2d, wrk2_2d , wrk3_2d 

implicit none

private

character(len=256) :: version='CVS $Id'
character(len=256) :: tagname='Tag $Name'

! for output
integer :: unit=6

logical :: use_blobs

#include <ocean_memory.h>

logical :: rebin_onto_rho_all_values    = .true.
logical :: module_is_initialized        = .false.
logical :: debug_diagnose_mass_of_layer = .false.
real    :: epsln_diagnose_mass_of_layer = 1e-5

type(ocean_domain_type), pointer :: Dom =>NULL()
type(ocean_grid_type), pointer   :: Grd =>NULL()

public ocean_tracer_util_init
public tracer_min_max
public dzt_min_max
public tracer_prog_chksum 
public tracer_diag_chksum 
public tracer_psom_chksum
public sort_pick_array
public sort_shell_array
public rebin_onto_rho
public diagnose_mass_of_layer
public diagnose_3d_rho

namelist /ocean_tracer_util_nml/ rebin_onto_rho_all_values, &
          debug_diagnose_mass_of_layer, epsln_diagnose_mass_of_layer


contains


!#######################################################################
! <SUBROUTINE NAME="ocean_tracer_util_init">
!
! <DESCRIPTION>
! Initialize MOM tracer utilities.
! </DESCRIPTION>
!
subroutine ocean_tracer_util_init (Grid, Domain, blobs)

  type(ocean_grid_type),   intent(in), target :: Grid
  type(ocean_domain_type), intent(in), target :: Domain
  logical,                 intent(in)         :: blobs

  integer :: ioun, io_status
#ifdef INTERNAL_FILE_NML
  integer :: ierr
#endif
  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 


  if (module_is_initialized) then 
    call mpp_error(FATAL,&
    '==>Error in ocean_tracer_util_mod (ocean_tracer_util_init): module already initialized')
  endif 

  module_is_initialized = .true.
  stdlogunit=stdlog()
  write( stdlogunit,'(/a/)') trim(version)

  use_blobs = blobs

  Dom => Domain
  Grd => Grid

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk=Grd%nk
#endif

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_tracer_util_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_tracer_util_nml')
#else
  ioun = open_namelist_file()
  read(ioun, ocean_tracer_util_nml, iostat=io_status)
  call close_file(ioun)
#endif
  write (stdlogunit, ocean_tracer_util_nml)
  write (stdoutunit,'(/)')
  write (stdoutunit, ocean_tracer_util_nml)

  if(rebin_onto_rho_all_values) then
      write (stdoutunit,'(/a)') &
      'Note: ocean_tracer_util: rebin_onto_rho will include density values outside bounds range.'
  else
      write (stdoutunit,'(/a)') &
      'Note: ocean_tracer_util: rebin_onto_rho will NOT include density values outside bounds range.'
  endif


end subroutine ocean_tracer_util_init
! </SUBROUTINE> NAME="ocean_tracer_util_init">



!#######################################################################
! <SUBROUTINE NAME="tracer_min_max">
!
! <DESCRIPTION>
! Compute the global min and max for tracers.  
!
! Vectorized using maxloc() and minloc() intrinsic functions by 
! Russell.Fiedler@csiro.au (May 2005).
!
! Modified by Zhi.Liang (July 2005)
!          
! </DESCRIPTION>
!
subroutine tracer_min_max(Time, Thickness, Tracer)
  
  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: Tracer

  real    :: tmax, tmin, tmax0, tmin0
  integer :: itmax, jtmax, ktmax, itmin, jtmin, ktmin
  integer :: tau 
  real    :: fudge

  ! arrays to enable vectorization
  integer :: iminarr(3),imaxarr(3)

  if (.not. module_is_initialized) then
     call mpp_error(FATAL,&
     '==>Error from ocean_tracer_util_mod (tracer_min_max): module not initialized')
  endif 

  tmax=-1.e10;tmin=1.e10
  itmax=0;jtmax=0;ktmax=0
  itmin=0;jtmin=0;ktmin=0

  tau = Time%tau

  call write_timestamp(Time%model_time)
  
  wrk1(isc:iec,jsc:jec,:) = Tracer%field(isc:iec,jsc:jec,:,tau)
  
  if(ANY(Grd%tmask(isc:iec,jsc:jec,:) > 0.)) then
     iminarr=minloc(wrk1(isc:iec,jsc:jec,:),Grd%tmask(isc:iec,jsc:jec,:) > 0.)
     imaxarr=maxloc(wrk1(isc:iec,jsc:jec,:),Grd%tmask(isc:iec,jsc:jec,:) > 0.)
     itmin=iminarr(1)+isc-1
     jtmin=iminarr(2)+jsc-1
     ktmin=iminarr(3)
     itmax=imaxarr(1)+isc-1
     jtmax=imaxarr(2)+jsc-1 
     ktmax=imaxarr(3)
     tmin=wrk1(itmin,jtmin,ktmin)
     tmax=wrk1(itmax,jtmax,ktmax)
  end if

  ! use "fudge" to distinguish processors when tracer extreme is independent of processor
  fudge = 1.0 + 1.e-12*mpp_pe() 
  tmax = tmax*fudge
  tmin = tmin*fudge
  if(tmax == 0.0) then 
    tmax = tmax + 1.e-12*mpp_pe() 
  endif 
  if(tmin == 0.0) then 
    tmin = tmin + 1.e-12*mpp_pe() 
  endif 
  

  tmax0=tmax;tmin0=tmin

  call mpp_max(tmax)
  call mpp_min(tmin)

  if (tmax0 == tmax) then
      if (trim(Tracer%name) == 'temp') then
          write(unit,'(/,a,es22.12,a,i4,a1,i4,a1,i3,a,f10.4,a,f10.4,a,f10.4,a)') &
               ' The maximum T is ', tmax,&
               ' deg C at (i,j,k) = (',itmax+Dom%ioff,',',jtmax+Dom%joff,',',ktmax,&
               '),  (lon,lat,dpt) = (',Grd%xt(itmax,jtmax),',', &
               Grd%yt(itmax,jtmax),',', Grd%zt(ktmax),' m)'
          if (use_blobs) then
             write(unit,'(a,es22.12,a,es22.12,a,es22.12,a,a,es22.12,a)')      &
                  ' The grid dimensions are (dxt, dyt, dztT), dzt = (', &
                  Grd%dxt(itmax,jtmax),',', Grd%dyt(itmax,jtmax),',', &
                  Thickness%dztT(itmax,jtmax,ktmax,tau),' m)',',', Thickness%dzt(itmax,jtmax,ktmax),' m'
             write(unit,'(a,es22.12,a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dztT,rho_dzt) = ', &
                  Thickness%dst(itmax,jtmax,ktmax),', ',Thickness%rho_dztT(itmax,jtmax,ktmax,tau),', ',&
                  Thickness%rho_dzt(itmax,jtmax,ktmax,tau)
          else
             write(unit,'(a,es22.12,a,es22.12,a,es22.12,a)')      &
                  ' The grid dimensions are (dxt, dyt, dzt) = (', &
                  Grd%dxt(itmax,jtmax),',', Grd%dyt(itmax,jtmax),',', Thickness%dzt(itmax,jtmax,ktmax),' m)'
             write(unit,'(a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dzt) = ', &
                  Thickness%dst(itmax,jtmax,ktmax),', ',Thickness%rho_dzt(itmax,jtmax,ktmax,tau)
          endif
          write(unit,'(a,i6)') ' And the number of cells in the column are kmt = ', Grd%kmt(itmax,jtmax)
          if (tmax > Tracer%max_tracer) then
              call mpp_error(FATAL, &
               '==>Error from ocean_tracer_util_mod: The maximum temperature is outside allowable range')
          endif
      else if (trim(Tracer%name) == 'salt') then
          write(unit,'(/,a,es22.12,a,i4,a1,i4,a1,i3,a,f10.4,a,f10.4,a,f10.4,a)') &
               ' The maximum S is ', tmax,&
               ' psu at (i,j,k) = (',itmax+Dom%ioff,',',jtmax+Dom%joff,',',ktmax,&
               '),  (lon,lat,dpt) = (',Grd%xt(itmax,jtmax),',', &
               Grd%yt(itmax,jtmax),',', Grd%zt(ktmax),' m)'
          if (use_blobs) then
             write(unit,'(a,es22.12,a,es22.12,a,es22.12,a,a,es22.12,a)')      &
                  ' The grid dimensions are (dxt, dyt, dztT), dzt = (', &
                  Grd%dxt(itmax,jtmax),',', Grd%dyt(itmax,jtmax),',', Thickness%dztT(itmax,jtmax,ktmax,tau),' m)',&
                  ',', Thickness%dzt(itmax,jtmax,ktmax),' m'
             write(unit,'(a,es22.12,a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dztT,rho_dzt) = ', &
                  Thickness%dst(itmax,jtmax,ktmax),', ',Thickness%rho_dztT(itmax,jtmax,ktmax,tau),', '&
                  ,Thickness%rho_dzt(itmax,jtmax,ktmax,tau)
          else
             write(unit,'(a,es22.12,a,es22.12,a,es22.12,a)')      &
                  ' The grid dimensions are (dxt, dyt, dzt) = (', &
                  Grd%dxt(itmax,jtmax),',', Grd%dyt(itmax,jtmax),',', Thickness%dzt(itmax,jtmax,ktmax),' m)'
             write(unit,'(a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dzt) = ', &
                  Thickness%dst(itmax,jtmax,ktmax),', ',Thickness%rho_dzt(itmax,jtmax,ktmax,tau)
          endif
          write(unit,'(a,i6)') ' And the number of cells in the column are kmt = ', Grd%kmt(itmax,jtmax)
          if (tmax > Tracer%max_tracer) then
              call mpp_error(FATAL,&
              '==>Error from ocean_tracer_util_mod: The maximum salinity is outside allowable range')
          endif
      else
          write(unit,'(/,a,es22.12,a,i4,a1,i4,a1,i3,a,f10.4,a,f10.4,a,f10.4,a)') &
               ' The maximum '//trim(Tracer%name)// ' is ', tmax,&
                ' '// trim(Tracer%units)// ' at (i,j,k) = (',itmax+Dom%ioff,',',jtmax+Dom%joff,','&
               ,ktmax,'),  (lon,lat,dpt) = (',Grd%xt(itmax,jtmax),',', &
               Grd%yt(itmax,jtmax),',', Grd%zt(ktmax),' m)'
          if (use_blobs) then
             write(unit,'(a,es22.12,a,es22.12,a,es22.12,a,a,es22.12,a)')      &
                  ' The grid dimensions are (dxt, dyt, dztT), dzt = (', &
                  Grd%dxt(itmax,jtmax),',', Grd%dyt(itmax,jtmax),',', Thickness%dztT(itmax,jtmax,ktmax,tau),' m)',&
                  ',', Thickness%dzt(itmax,jtmax,ktmax),' m'
             write(unit,'(a,es22.12,a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dztT,rho_dzt) = ', &
                  Thickness%dst(itmin,jtmin,ktmin),', ',Thickness%rho_dztT(itmin,jtmin,ktmin,tau),', ',&
                  Thickness%rho_dzt(itmin,jtmin,ktmin,tau)
          else
             write(unit,'(a,es22.12,a,es22.12,a,es22.12,a)')      &
                  ' The grid dimensions are (dxt, dyt, dzt) = (', &
                  Grd%dxt(itmax,jtmax),',', Grd%dyt(itmax,jtmax),',', Thickness%dzt(itmax,jtmax,ktmax),' m)'
             write(unit,'(a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dzt) = ', &
                  Thickness%dst(itmin,jtmin,ktmin),', ',Thickness%rho_dzt(itmin,jtmin,ktmin,tau)
          endif
          write(unit,'(a,i6)') ' And the number of cells in the column are kmt = ', Grd%kmt(itmax,jtmax)
          if (tmax > Tracer%max_tracer) then
              call mpp_error(FATAL, &
               '==>Error from ocean_tracer_util_mod: The maximum tracer is outside allowable range')
          endif 
      endif
  endif
  
  if (tmin0 == tmin) then
      if (trim(Tracer%name) == 'temp') then
          write(unit,'(/,a,es22.12,a,i4,a1,i4,a1,i3,a,f10.4,a,f10.4,a,f10.4,a)') &
               ' The minimum T is ', tmin,&
               ' deg C at (i,j,k) = (',itmin+Dom%ioff,',',jtmin+Dom%joff,',',ktmin,&
               '),  (lon,lat,dpt) = (',Grd%xt(itmin,jtmin),',', &
               Grd%yt(itmin,jtmin),',', Grd%zt(ktmin),' m)'
          if (use_blobs) then
             write(unit,'(a,es22.12,a,es22.12,a,es22.12,a,a,es22.12,a)')      &
                  ' The grid dimensions are (dxt, dyt, dztT), dzt = (', &
                  Grd%dxt(itmin,jtmin),',', Grd%dyt(itmin,jtmin),',', Thickness%dztT(itmin,jtmin,ktmin,tau),' m)',','&
                  , Thickness%dzt(itmin,jtmin,ktmin),' m'
             write(unit,'(a,es22.12,a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dztT,rho_dzt) = ', &
                  Thickness%dst(itmin,jtmin,ktmin),', ',Thickness%rho_dztT(itmin,jtmin,ktmin,tau),', ',&
                  Thickness%rho_dzt(itmin,jtmin,ktmin,tau)
          else
             write(unit,'(a,es22.12,a,es22.12,a,es22.12,a)')      &
                  ' The grid dimensions are (dxt, dyt, dzt) = (', &
                  Grd%dxt(itmin,jtmin),',', Grd%dyt(itmin,jtmin),',', Thickness%dzt(itmin,jtmin,ktmin),' m)'
             write(unit,'(a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dzt) = ', &
                  Thickness%dst(itmin,jtmin,ktmin),', ',Thickness%rho_dzt(itmin,jtmin,ktmin,tau)
          endif
          write(unit,'(a,i6)') ' And the number of cells in the column are kmt = ', Grd%kmt(itmin,jtmin)
          if (tmin < Tracer%min_tracer) then
              call mpp_error(FATAL, &
               '==>Error from ocean_tracer_util_mod (tracer_min_max): minimum temp outside allowable range')
          endif
      else if (trim(Tracer%name) == 'salt') then
          write(unit,'(/,a,es22.12,a,i4,a1,i4,a1,i3,a,f10.4,a,f10.4,a,f10.4,a)') &
               ' The minimum S is ', tmin,&
               ' psu at (i,j,k) = (',itmin+Dom%ioff,',',jtmin+Dom%joff,',',ktmin,&
               '),  (lon,lat,dpt) = (',Grd%xt(itmin,jtmin),',', &
               Grd%yt(itmin,jtmin),',', Grd%zt(ktmin),' m)'
          if (use_blobs) then
             write(unit,'(a,es22.12,a,es22.12,a,es22.12,a,a,es22.12,a)')      &
                  ' The grid dimensions are (dxt, dyt, dztT) = (', &
                  Grd%dxt(itmin,jtmin),',', Grd%dyt(itmin,jtmin),',', Thickness%dztT(itmin,jtmin,ktmin,tau),' m)',','&
                  , Thickness%dzt(itmin,jtmin,ktmin),' m'
             write(unit,'(a,es22.12,a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dztT,rho_dzt) = ', &
                  Thickness%dst(itmin,jtmin,ktmin),', ',Thickness%rho_dztT(itmin,jtmin,ktmin,tau),', ',&
                  Thickness%rho_dzt(itmin,jtmin,ktmin,tau)
          else
             write(unit,'(a,es22.12,a,es22.12,a,es22.12,a)')      &
                  ' The grid dimensions are (dxt, dyt, dzt) = (', &
                  Grd%dxt(itmin,jtmin),',', Grd%dyt(itmin,jtmin),',', Thickness%dzt(itmin,jtmin,ktmin),' m)'
             write(unit,'(a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dzt) = ', &
                  Thickness%dst(itmin,jtmin,ktmin),', ',Thickness%rho_dzt(itmin,jtmin,ktmin,tau)
          endif
          write(unit,'(a,i6)') ' And the number of cells in the column are kmt = ', Grd%kmt(itmin,jtmin)
          if (tmin < Tracer%min_tracer) then
              call mpp_error(FATAL, &
               '==>Error from ocean_tracer_util_mod: The minimum salinity is outside allowable range')
          endif
      else
          write(unit,'(/,a,es22.12,a,i4,a1,i4,a1,i3,a,f10.4,a,f10.4,a,f10.4,a)') &
               ' The minimum '//trim(Tracer%name)// ' is ', tmin,&
                ' '// trim(Tracer%units)// ' at (i,j,k) = (',itmin+Dom%ioff,',',jtmin+Dom%joff,','&
               ,ktmin,'),  (lon,lat,dpt) = (',Grd%xt(itmin,jtmin),',', &
               Grd%yt(itmin,jtmin),',', Grd%zt(ktmin),' m)'
          if (use_blobs) then
             write(unit,'(a,es22.12,a,es22.12,a,es22.12,a,a,es22.12,a)')      &
                  ' The grid dimensions are (dxt, dyt, dztT), dzt = (', &
                  Grd%dxt(itmin,jtmin),',', Grd%dyt(itmin,jtmin),',', Thickness%dztT(itmin,jtmin,ktmin,tau),' m)',',',&
                  Thickness%dzt(itmin,jtmin,ktmin),' m'
             write(unit,'(a,es22.12,a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dztT,rho_dzt) = ', &
                  Thickness%dst(itmin,jtmin,ktmin),', ',Thickness%rho_dztT(itmin,jtmin,ktmin,tau),', ',&
                  Thickness%rho_dzt(itmin,jtmin,ktmin,tau)
          else
             write(unit,'(a,es22.12,a,es22.12,a,es22.12,a)')      &
                  ' The grid dimensions are (dxt, dyt, dzt) = (', &
                  Grd%dxt(itmin,jtmin),',', Grd%dyt(itmin,jtmin),',', Thickness%dzt(itmin,jtmin,ktmin),' m)'
             write(unit,'(a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dzt) = ', &
                  Thickness%dst(itmin,jtmin,ktmin),', ',Thickness%rho_dzt(itmin,jtmin,ktmin,tau)
          endif
          write(unit,'(a,i6)') ' And the number of cells in the column are kmt = ', Grd%kmt(itmin,jtmin)
          if (tmin < Tracer%min_tracer) then
              call mpp_error(FATAL, &
               '==>Error from ocean_tracer_util_mod (tracer_min_max): minimum tracer outside allowable range')
          endif
      endif
  endif

  return


end subroutine tracer_min_max
! </SUBROUTINE>  NAME="tracer_min_max"


!#######################################################################
! <SUBROUTINE NAME="dzt_min_max">
!
! <DESCRIPTION>
! Compute the global min and max for dzt.  
!
! Modified by Stephen.Griffies from subroutine tracer_min_max
!          
! </DESCRIPTION>
!
subroutine dzt_min_max(Time, Thickness, filecaller)
  
  type(ocean_time_type),      intent(in) :: Time
  type(ocean_thickness_type), intent(in) :: Thickness
  character(len=*),           intent(in) :: filecaller

  real    :: dztmax, dztmin, dztmax0, dztmin0
  integer :: itmax, jtmax, ktmax, itmin, jtmin, ktmin
  integer :: tau
  real    :: fudge

  ! arrays to enable vectorization
  integer :: iminarr(3),imaxarr(3)

  tau = Time%tau

  dztmax=-1.e10;dztmin=1.e10
  itmax=0;jtmax=0;ktmax=0
  itmin=0;jtmin=0;ktmin=0

  call write_timestamp(Time%model_time)

  if (use_blobs) then
     wrk1(isc:iec,jsc:jec,:) = Thickness%dztT(isc:iec,jsc:jec,:,tau)
  else
     wrk1(isc:iec,jsc:jec,:) = Thickness%dzt(isc:iec,jsc:jec,:)
  endif
  
  if(ANY(Grd%tmask(isc:iec,jsc:jec,:) > 0.)) then
     iminarr=minloc(wrk1(isc:iec,jsc:jec,:),Grd%tmask(isc:iec,jsc:jec,:) > 0.)
     imaxarr=maxloc(wrk1(isc:iec,jsc:jec,:),Grd%tmask(isc:iec,jsc:jec,:) > 0.)
     itmin=iminarr(1)+isc-1
     jtmin=iminarr(2)+jsc-1
     ktmin=iminarr(3)
     itmax=imaxarr(1)+isc-1
     jtmax=imaxarr(2)+jsc-1 
     ktmax=imaxarr(3)
     dztmin=wrk1(itmin,jtmin,ktmin)
     dztmax=wrk1(itmax,jtmax,ktmax)
  end if

  ! use "fudge" to distinguish processors when extreme is independent of processor
  fudge = 1.0 + 1.e-12*mpp_pe() 
  dztmax = dztmax*fudge
  dztmin = dztmin*fudge
  if(dztmax == 0.0) then 
    dztmax = dztmax + 1.e-12*mpp_pe() 
  endif 
  if(dztmin == 0.0) then 
    dztmin = dztmin + 1.e-12*mpp_pe() 
  endif 

  dztmax0=dztmax;dztmin0=dztmin

  call mpp_max(dztmax)
  call mpp_min(dztmin)

  if (dztmax0 == dztmax) then

      write(unit,'(/a)') trim(filecaller)
      call write_timestamp(Time%model_time)

      write(unit,'(/,a,es22.12,a,i4,a1,i4,a1,i3,a,f10.4,a,f10.4,a,f15.4,a)') &
           ' The maximum dzt is ', dztmax,&
           ' metre at (i,j,k) = (',itmax+Dom%ioff,',',jtmax+Dom%joff,',',ktmax,&
           '),  (lon,lat,dpt) = (',Grd%xt(itmax,jtmax),',', &
           Grd%yt(itmax,jtmax),',', Thickness%depth_zt(itmax,jtmax,ktmax),' m)'
      if (use_blobs) then
         write(unit,'(a,es22.12,a,es22.12,a,es22.12)')      &
              ' The grid dimensions are (dxt, dyt, dztT) = (', &
              Grd%dxt(itmax,jtmax),',', Grd%dyt(itmax,jtmax),',', Thickness%dztT(itmax,jtmax,ktmax,tau),' m)'
         write(unit,'(a,i6)') ' The number of cells in the column are kmt = ', Grd%kmt(itmax,jtmax)
         write(unit,'(a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dztT) = ', &
              Thickness%dst(itmax,jtmax,ktmax),', ',Thickness%rho_dztT(itmax,jtmax,ktmax,tau)
      else
         write(unit,'(a,es22.12,a,es22.12,a,es22.12)')      &
              ' The grid dimensions are (dxt, dyt, dzt) = (', &
              Grd%dxt(itmax,jtmax),',', Grd%dyt(itmax,jtmax),',', Thickness%dzt(itmax,jtmax,ktmax),' m)'
         write(unit,'(a,i6)') ' The number of cells in the column are kmt = ', Grd%kmt(itmax,jtmax)
         write(unit,'(a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dzt) = ', &
              Thickness%dst(itmax,jtmax,ktmax),', ',Thickness%rho_dzt(itmax,jtmax,ktmax,tau)
      endif
  endif

  if (dztmin0 == dztmin) then
      write(unit,'(/,a,es22.12,a,i4,a1,i4,a1,i3,a,f10.4,a,f10.4,a,f15.4,a)') &
           ' The minimum dzt is ', dztmin,&
           ' metre at (i,j,k) = (',itmin+Dom%ioff,',',jtmin+Dom%joff,',',ktmin,&
           '),  (lon,lat,dpt) = (',Grd%xt(itmin,jtmin),',', &
           Grd%yt(itmin,jtmin),',', Thickness%depth_zt(itmin,jtmin,ktmin),' m)'
      if (use_blobs) then
         write(unit,'(a,es22.12,a,es22.12,a,es22.12,a)')      &
              ' The grid dimensions are (dxt, dyt, dztT) = (', &
              Grd%dxt(itmin,jtmin),',', Grd%dyt(itmin,jtmin),',', Thickness%dztT(itmin,jtmin,ktmin,tau),' m)'
         write(unit,'(a,i6)') ' And the number of cells in the column are kmt = ', Grd%kmt(itmin,jtmin)
         write(unit,'(a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dztT) = ', &
              Thickness%dst(itmin,jtmin,ktmin),', ',Thickness%rho_dztT(itmin,jtmin,ktmin,tau)
      else
         write(unit,'(a,es22.12,a,es22.12,a,es22.12,a)')      &
              ' The grid dimensions are (dxt, dyt, dzt) = (', &
              Grd%dxt(itmin,jtmin),',', Grd%dyt(itmin,jtmin),',', Thickness%dzt(itmin,jtmin,ktmin),' m)'
         write(unit,'(a,i6)') ' And the number of cells in the column are kmt = ', Grd%kmt(itmin,jtmin)
         write(unit,'(a,es22.12,a,es22.12)') ' The grid dimensions (dst,rho_dzt) = ', &
              Thickness%dst(itmin,jtmin,ktmin),', ',Thickness%rho_dzt(itmin,jtmin,ktmin,tau)         
      endif

      if(dztmin < 0.0) then 
          write(unit,'(a)') '==>Error in ocean_tracer_util_mod (dzt_min_max): dztT < 0 detected.'
          call mpp_error(FATAL,&
               '==>Error in ocean_tracer_util_mod (dzt_min_max): dzt < 0 detected.')
      endif

  endif


  return


end subroutine dzt_min_max
! </SUBROUTINE>  NAME="dzt_min_max"


!#######################################################################
! <SUBROUTINE NAME="tracer_prog_chksum">
!
! <DESCRIPTION>
! Compute checksums for prognostic tracers 
! </DESCRIPTION>
subroutine tracer_prog_chksum(Time, Tracer, index, chksum)

  type(ocean_time_type),        intent(in)  :: Time
  type(ocean_prog_tracer_type), intent(in)  :: Tracer
  integer,                      intent(in)  :: index
  integer(i8_kind), optional, intent(inout) :: chksum
  
  integer :: stdoutunit 
  stdoutunit=stdout() 

  if (.not. module_is_initialized) then 
    call mpp_error(FATAL,&
    '==>Error from ocean_tracer_util_mod (tracer_prog_chksum): module not initialized ')
  endif 

  write(stdoutunit,*) ' '
  write(stdoutunit,*) '=== Prognostic tracer checksum follows ==='
  call write_timestamp(Time%model_time)
  if (PRESENT(chksum)) then
     call write_chksum_3d(Tracer%name, Tracer%field(COMP,:,index)*Grd%tmask(COMP,:), chksum)
  else
     call write_chksum_3d(Tracer%name, Tracer%field(COMP,:,index)*Grd%tmask(COMP,:))
  endif

end subroutine tracer_prog_chksum
! </SUBROUTINE>  NAME="tracer_prog_chksum"


!#######################################################################
! <SUBROUTINE NAME="tracer_diag_chksum">
!
! <DESCRIPTION>
! Compute checksums for diagnostic tracers 
! </DESCRIPTION>
subroutine tracer_diag_chksum(Time, Tracer, chksum)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_diag_tracer_type), intent(in)    :: Tracer
  integer(i8_kind), optional,   intent(inout) :: chksum
  
  integer :: stdoutunit 
  stdoutunit=stdout() 

  if (.not. module_is_initialized) then 
    call mpp_error(FATAL,&
    '==>Error from ocean_tracer_util_mod (tracer_diag_chksum): module not initialized ')
  endif 

  write(stdoutunit,*) '=== Diagnostic tracer checksum follows ==='
  call write_timestamp(Time%model_time)
  if (PRESENT(chksum)) then
     call write_chksum_3d(Tracer%name, Tracer%field(COMP,:)*Grd%tmask(COMP,:), chksum)
  else
     call write_chksum_3d(Tracer%name, Tracer%field(COMP,:)*Grd%tmask(COMP,:))
  endif

end subroutine tracer_diag_chksum
! </SUBROUTINE>  NAME="tracer_diag_chksum"


!#######################################################################
! <SUBROUTINE NAME="tracer_psom_chksum">
!
! <DESCRIPTION>
! Compute checksums for PSOM advection second order moments. 
! </DESCRIPTION>
subroutine tracer_psom_chksum(Time, Tracer)

  type(ocean_time_type),        intent(in)  :: Time
  type(ocean_prog_tracer_type), intent(in)  :: Tracer
  
  integer :: stdoutunit 
  stdoutunit=stdout() 

  if (.not. module_is_initialized) then 
    call mpp_error(FATAL,&
    '==>Error from ocean_tracer_util_mod (tracer_psom_chksum): module not initialized ')
  endif 

  write(stdoutunit,*) ' '
  write (stdoutunit,*) 'Writing psom moments for tracer ',trim(Tracer%name)
  call write_timestamp(Time%model_time)

  call write_chksum_3d('Tracer%s0', Tracer%s0(COMP,:)*Grd%tmask(COMP,:))
  call write_chksum_3d('Tracer%sx', Tracer%sx(COMP,:)*Grd%tmask(COMP,:))
  call write_chksum_3d('Tracer%sxx', Tracer%sxx(COMP,:)*Grd%tmask(COMP,:))
  call write_chksum_3d('Tracer%sy', Tracer%sy(COMP,:)*Grd%tmask(COMP,:))
  call write_chksum_3d('Tracer%syy', Tracer%syy(COMP,:)*Grd%tmask(COMP,:))
  call write_chksum_3d('Tracer%sz', Tracer%sz(COMP,:)*Grd%tmask(COMP,:))
  call write_chksum_3d('Tracer%szz', Tracer%szz(COMP,:)*Grd%tmask(COMP,:))
  call write_chksum_3d('Tracer%sxy', Tracer%sxy(COMP,:)*Grd%tmask(COMP,:))
  call write_chksum_3d('Tracer%sxz', Tracer%sxy(COMP,:)*Grd%tmask(COMP,:))
  call write_chksum_3d('Tracer%syz', Tracer%syz(COMP,:)*Grd%tmask(COMP,:))

end subroutine tracer_psom_chksum
! </SUBROUTINE>  NAME="tracer_psom_chksum"



!#######################################################################
! <SUBROUTINE NAME="sort_pick_array">
!
! <DESCRIPTION>
! Simplest, and slowest, sorting algorithm from Numerical Recipes.
! Called "sort_pick" in Numerical Recipes.  
!
! Input are two arrays, first array defines the ascending sort 
! and second is a slave to the sort. 
!
! Typical example is sorting a vector of water parcels lightest
! to densest, with slave being volume of the parcels.  
!
! More sophisticated sorting algorithms exist, and may need to 
! be coded should this method prove too slow. 
!
! This scheme has order N^2 operations, which is a lot. 
!
! output has array(1) smallest and a(nsortpts) largest 
! with corresponding slave array.  
!
! coded Stephen.Griffies June 2005
!
! </DESCRIPTION>
!
subroutine sort_pick_array(array, slave)

  real, dimension(:), intent(inout) :: array
  real, dimension(:), intent(inout) :: slave

  real    :: tmp_a, tmp_s
  integer :: m, n, nsortpts

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL,&
    '==>Error from ocean_tracer_util_mod (sort_pick_array): module not initialized')
  endif 

  nsortpts = size(array)

  do n=2,nsortpts
      tmp_a = array(n)
      tmp_s = slave(n)
     do m=n-1,1,-1
        if(array(m) <= tmp_a) exit
        array(m+1)=array(m)
        slave(m+1)=slave(m)
     enddo
     array(m+1) = tmp_a
     slave(m+1) = tmp_s    
  enddo


end subroutine sort_pick_array
! </SUBROUTINE>  NAME="sort_pick_array"



!#######################################################################
! <SUBROUTINE NAME="sort_shell_array">
!
! <DESCRIPTION>
! Shell (or diminishing increment) sort from Numerical Recipes.
! Called "sort_shell" in Numerical Recipes.  
!
! Input are two arrays, first array defines the ascending sort 
! and second is a slave to the sort array. 
!
! Typical example is sorting a vector of water parcels lightest  
! to densest, with slave being volume of the parcels.  
!
! More sophisticated sorting algorithms exist, and may need to 
! be coded should this method prove too slow. 
!
! This scheme has order N^(5/4) operations. 
!
! output has array(1) smallest and a(nsortpts) largest,
! with corresponding ordering for slave array.  
!
! coded Stephen.Griffies June 2005
!
! </DESCRIPTION>
!
subroutine sort_shell_array(array, slave)

  real, dimension(:), intent(inout) :: array
  real, dimension(:), intent(inout) :: slave

  real    :: tmp_a, tmp_s
  integer :: m, n, inc, nsortpts

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL,&
    '==>Error from ocean_tracer_util_mod (sort_shell_array): module not initialized')
  endif 

  nsortpts = size(array)

  inc=1
  do 
     inc=3*inc+1
     if(inc > nsortpts) exit
  enddo

  do 
     inc=inc/3

     do m=inc+1,nsortpts
        tmp_a = array(m)
        tmp_s = slave(m)

        n=m
        do
           if(array(n-inc) <= tmp_a) exit
           array(n) = array(n-inc)
           slave(n) = slave(n-inc)
           n=n-inc
           if(n <= inc) exit
        enddo

        array(n)=tmp_a
        slave(n)=tmp_s

     enddo

     if(inc <=1) exit
  enddo

end subroutine sort_shell_array
! </SUBROUTINE>  NAME="sort_shell_array"


!#######################################################################
! <SUBROUTINE NAME="rebin_onto_rho">
!
! <DESCRIPTION>
! Bin a level input tendency field according to density classes. 
! The binning is meant for tendencies and transports, as used in particular
! for the neut_rho, wdian_rho, and tform_rho diagnostics.  
!
! Note that if use rebin_onto_rho_all_values=.false. then will 
! not be consistent with transport_on_nrho calculation, which includes
! bins all grid cells, including those outside of range for the bounds.  
!
! Stephen.Griffies 
! April 2012: algorithm made identical to transport_on_nrho as 
! computed in ocean_adv_vel_diag.
!
! </DESCRIPTION>
!
subroutine rebin_onto_rho (rho_bounds, rho_level, infield_level, outfield_rho)

  real, dimension(:),           intent(in)    :: rho_bounds
  real, dimension(isd:,jsd:,:), intent(in)    :: rho_level
  real, dimension(isd:,jsd:,:), intent(in)    :: infield_level
  real, dimension(isd:,jsd:,:), intent(inout) :: outfield_rho

  real    :: rho_max, rho_min

  integer :: i, j, k, k_rho, rho_nk

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error ocean_neutral_util_mod (rebin_onto_rho): module needs initialization ')
  endif 

  rho_nk = size(rho_bounds(:)) - 1 
  outfield_rho(:,:,:) = 0.0

  ! rebin infield_level to get outfield_rho

  ! include even those cells with density outside of the 
  ! maximum and minimum of rho_bounds.
  if(rebin_onto_rho_all_values) then 

      do j = jsc,jec
         do k = 1,nk
            rho_max = maxval(rho_level(isc:iec,j,k),mask=Grd%tmask(isc:iec,j,k)==1)
            if (rho_max == -huge(rho_max)) exit  ! All land in this row and lower
            rho_min = minval(rho_level(isc:iec,j,k),mask=Grd%tmask(isc:iec,j,k)==1)
            ! light waters 
            k_rho = 1
            if (rho_min < rho_bounds(k_rho+1)) then
               do i=isc,iec
                  if (rho_level(i,j,k) < rho_bounds(k_rho+1)) then 
                      outfield_rho(i,j,k_rho) = outfield_rho(i,j,k_rho) + infield_level(i,j,k)
                  endif
               enddo
            endif

            ! within the predefined range 
            do k_rho = 2,rho_nk-1
               if (rho_bounds(k_rho) > rho_max .or. rho_bounds(k_rho+1) <= rho_min) cycle
               do i=isc,iec
                  if ((rho_bounds(k_rho) <= rho_level(i,j,k)) .and.  &
                      (rho_level(i,j,k)  <  rho_bounds(k_rho+1)) ) then 
                      outfield_rho(i,j,k_rho) = outfield_rho(i,j,k_rho) + infield_level(i,j,k)
                  endif
               enddo
            enddo

                  ! denser than the last interface 
            k_rho = rho_nk
            if (rho_max >= rho_bounds(k_rho)) then
               do i = isc,iec
                  if (rho_bounds(k_rho) <= rho_level(i,j,k)) then 
                          outfield_rho(i,j,k_rho) = outfield_rho(i,j,k_rho) + infield_level(i,j,k)             
                  endif
               enddo
            endif

         enddo
      enddo

  else 

      ! ignore those cells with density outside of the 
      ! maximum and minimum of rho_bounds.
      do j = jsc,jec
         do k = 1,nk
            rho_max = maxval(rho_level(isc:iec,j,k),mask=Grd%tmask(isc:iec,j,k)==1)
            if (rho_max == -huge(rho_max)) exit  ! All land in this row and lower
            rho_min = minval(rho_level(isc:iec,j,k),mask=Grd%tmask(isc:iec,j,k)==1)
            do k_rho = 1,rho_nk
               if (rho_bounds(k_rho) > rho_max .or. rho_bounds(k_rho+1) <= rho_min) cycle
               do i = isc,iec
                  if ((rho_bounds(k_rho) <= rho_level(i,j,k)) .and.  &
                      (rho_level(i,j,k)  <  rho_bounds(k_rho+1)) ) then 
                      outfield_rho(i,j,k_rho) = outfield_rho(i,j,k_rho) + infield_level(i,j,k)
                  endif
               enddo
            enddo
         enddo
      enddo

  endif
 
  ! apply land-sea masks for level-mask at k=1 
  do k_rho = 1,rho_nk
     do j = jsc,jec
        do i = isc,iec
           outfield_rho(i,j,k_rho) = outfield_rho(i,j,k_rho)*Grd%tmask(i,j,1)
        enddo
     enddo
  enddo

end subroutine rebin_onto_rho
! </SUBROUTINE> NAME="rebin_onto_rho"



!#######################################################################
! <SUBROUTINE NAME="diagnose_3d_rho">
!
! <DESCRIPTION>
! Helper function for diagnosting 3D data mapped onto density levels.
! </DESCRIPTION>
!
subroutine diagnose_3d_rho(Time, Dens, id_name, data)
  type(ocean_time_type), intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens
  integer, intent(in) :: id_name
  real, dimension(isd:,jsd:,:), intent(in) :: data

  real :: nrho_work(isd:ied,jsd:jed,size(Dens%neutralrho_ref(:)))
  logical :: used

  integer :: neutralrho_nk

  if (id_name > 0) then
     neutralrho_nk = size(Dens%neutralrho_ref(:))
     nrho_work(:,:,:) = 0.0
     call rebin_onto_rho(Dens%neutralrho_bounds, Dens%neutralrho, data, nrho_work)
     used = send_data (id_name, nrho_work(:,:,:), &
          Time%model_time,                        &
          is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=neutralrho_nk)
  endif

end subroutine diagnose_3d_rho
! </SUBROUTINE> NAME="diagnose_3d_rho"


!#######################################################################
! <SUBROUTINE NAME="diagnose_mass_of_layer_orig">
! <DESCRIPTION>
!
! Diagnose the mass of a layer as a function of layer and (i,j). 
!
! Method uses linear interpolation to find the mass per area of
! layer boundaries, which are then used to get mass per area of
! layer, and then mass through multipication by area.  
!
! Scheme currently does not forward (backwards) interpolate if 
! layer boundary lies within lowest (uppermost) grid cell.
!
! Diagnostic only makes sense when layer_level is monotonically
! increasing as go deeper in water column. 
!
! layer_bounds = neutral density of layer interfaces 
! mass_level   = mass per area at bottom of tracer cell
! layer_level  = neutral density of model grid levels   
! mass_layer   = diagnosed mass of a neutral density layer
!
! </DESCRIPTION>
!
subroutine diagnose_mass_of_layer_orig(layer_bounds, mass_level, layer_level, mass_layer)

  real, dimension(:),           intent(in)    :: layer_bounds
  real, dimension(isd:,jsd:,:), intent(in)    :: mass_level
  real, dimension(isd:,jsd:,:), intent(in)    :: layer_level
  real, dimension(isd:,jsd:,:), intent(inout) :: mass_layer

  real      :: w1,w2
  integer   :: layer_nk
  integer   :: i, j, k, n

  if (.not.module_is_initialized) then 
      call mpp_error(FATAL, &
      '==>Error from ocean_tracer_util (diagnose_mass_of_layer): module needs initialization ')
  endif

  ! find mass per area at the layer bounds 
  layer_nk = size(layer_bounds(:)) - 1 
  mass_layer(:,:,:) = 0.0
  do n=1,layer_nk
     do j=jsc,jec
        do i=isc,iec
kloop:     do k=nk-1,1,-1
              if(    layer_level(i,j,k) <= layer_bounds(n)) then
                  if(layer_bounds(n)    < layer_level(i,j,k+1)) then
                      if(Grd%tmask(i,j,k+1) > 0) then 
                          W1= layer_bounds(n)      - layer_level(i,j,k)
                          W2= layer_level(i,j,k+1) - layer_bounds(n)
                          mass_layer(i,j,n) = ( mass_level(i,j,k+1)*W1  &
                                               +mass_level(i,j,k)  *W2) &
                                               /(W1 + W2 + epsln)
                          exit kloop 
                      endif
                  endif
              endif
           enddo kloop
        enddo
     enddo
  enddo

  ! take differences of mass per area at layer boundaries to then 
  ! get the mass within a layer. 
  ! if mass < 0, then this means we have reached edge of the density classes, 
  ! so set mass to zero. 
  do n=1,layer_nk-1
     do j=jsc,jec
        do i=isc,iec
            if(mass_layer(i,j,n+1) >= mass_layer(i,j,n)) then 
               mass_layer(i,j,n) = Grd%dat(i,j)*(mass_layer(i,j,n+1)-mass_layer(i,j,n))
            else
               mass_layer(i,j,n) = 0.0
            endif 
        enddo
     enddo
  enddo

  ! bottom layer mass equated to that above (cludge)
  n=layer_nk
  do j=jsc,jec
     do i=isc,iec
         mass_layer(i,j,n) = Grd%dat(i,j)*mass_layer(i,j,n-1)
     enddo
  enddo


end subroutine diagnose_mass_of_layer_orig
! </SUBROUTINE>  NAME="diagnose_mass_of_layer_orig"




!#######################################################################
! <SUBROUTINE NAME="diagnose_mass_of_layer">
! <DESCRIPTION>
!
! Diagnose the mass of a layer as a function of layer and (i,j). 
!
! Method uses linear interpolation to find the mass per area of
! layer boundaries, which are then used to get mass per area of
! layer, and then mass through multipication by area.  
!
! Diagnostic only makes sense when layer_level is monotonically
! increasing as go deeper in water column. 
!
! </DESCRIPTION>
!
subroutine diagnose_mass_of_layer(area_t, dzt, dztlo, dztup, rho_dzt, &
                                  nrho_level, nrho_nk, nrho_bdy, nrho_layer_mass)

  real, dimension(isd:,jsd:),   intent(in)    :: area_t 
  real, dimension(isd:,jsd:,:), intent(in)    :: dzt 
  real, dimension(isd:,jsd:,:), intent(in)    :: dztlo 
  real, dimension(isd:,jsd:,:), intent(in)    :: dztup
  real, dimension(isd:,jsd:,:), intent(in)    :: rho_dzt 
  real, dimension(isd:,jsd:,:), intent(in)    :: nrho_level
  integer,                      intent(in)    :: nrho_nk
  real, dimension(:),           intent(in)    :: nrho_bdy
  real, dimension(isd:,jsd:,:), intent(inout) :: nrho_layer_mass

  real    :: W1, W2
  real    :: tmp_mass, relative_mass_diff
  real, allocatable, dimension(:) :: nrho_bdy_mass
  integer :: i, j, k, n, kbot
  integer :: nrho_bdy_nk
  integer :: num_nonzero_bdy
  
  if (.not.module_is_initialized) then 
      call mpp_error(FATAL, &
      '==>Error from ocean_tracer_util (diagnose_mass_of_layer): module needs initialization ')
  endif
 
  nrho_bdy_nk = nrho_nk + 1 
  allocate(nrho_bdy_mass(nrho_nk+1))
  nrho_bdy_mass(:) = 0.0

  ! compute mass per area for levels 
  wrk1(:,:,:)  = 0.0  ! mass per area sitting above a T-cell center 
  wrk1_2d(:,:) = 0.0  ! mass per area in full T-cell column 
  do j=jsc,jec
     do i=isc,iec

        kbot = Grd%kmt(i,j)
        if(kbot > 1) then 

            k=1 
            wrk1(i,j,k) = rho_dzt(i,j,k)*dztup(i,j,k)/dzt(i,j,k)
            do k=2,kbot
               wrk1(i,j,k) = wrk1(i,j,k-1) + rho_dzt(i,j,k-1)*dztlo(i,j,k-1)/dzt(i,j,k-1) &
                                           + rho_dzt(i,j,k)  *dztup(i,j,k)  /dzt(i,j,k)
            enddo
            k=kbot
            wrk1_2d(i,j)  = wrk1(i,j,k) + rho_dzt(i,j,k)*dztlo(i,j,k)/dzt(i,j,k)

        endif

     enddo
  enddo


  ! determine mass within neutral rho layers 
  wrk2_2d(:,:) = 0.0  ! number of nonzero mass layers 
  do j=jsc,jec
     do i=isc,iec

        kbot = Grd%kmt(i,j)
        if(kbot > 1) then 

            wrk2_2d(i,j)     = 0.0
            num_nonzero_bdy  = 0

            ! loop to determine mass per area sitting above depth of layer interface 
            do n=1,nrho_bdy_nk
               nrho_bdy_mass(n) = 0.0

               ! linear interpolate for mass sitting above interior layer interfaces 
               do k=2,kbot
                  if(nrho_level(i,j,k) > nrho_bdy(n) .and. nrho_level(i,j,k-1) <= nrho_bdy(n)) then 
                      W1 = nrho_level(i,j,k) - nrho_bdy(n)
                      W2 = nrho_bdy(n)       - nrho_level(i,j,k-1) 
                      nrho_bdy_mass(n) = wrk1(i,j,k-1) + (                                                          &
                        W1*rho_dzt(i,j,k-1)*dztlo(i,j,k-1)/dzt(i,j,k-1) + W2*rho_dzt(i,j,k)*dztup(i,j,k)/dzt(i,j,k) &
                        )/(W1 + W2 + epsln)
                      wrk2_2d(i,j)     = wrk2_2d(i,j) + 1.0
                      num_nonzero_bdy  = num_nonzero_bdy + 1
                  endif
               enddo

               ! interfaces heavier than nrho_level(k=kbot) assumed to 
               ! have full column mass sitting above the interfaces.  
               k=kbot
               if(nrho_level(i,j,k) < nrho_bdy(n)) then 
                   nrho_bdy_mass(n) = wrk1_2d(i,j)
                   wrk2_2d(i,j)     = wrk2_2d(i,j) + 1.0 
                   num_nonzero_bdy  = num_nonzero_bdy + 1
               endif

            enddo

            ! determine mass within each neutral density layer. 
            ! linear interpolation can create negatives, so need to 
            ! apply an abs. The abs will cause some nonconsevation of mass,
            ! but hopefully will be negligible for purposes of the diagnostic. 
            do n=1,nrho_nk
               nrho_layer_mass(i,j,n) = area_t(i,j)*abs(nrho_bdy_mass(n+1)-nrho_bdy_mass(n))*Grd%tmask(i,j,1)
            enddo                  
                   
            ! if all nrho_bdy_mass containt full mass, we place 
            ! all mass in lightest of the nrho_layer_mass in order
            ! to conserve the full column mass. 
            if(num_nonzero_bdy == nrho_bdy_nk) then 
               nrho_layer_mass(i,j,1) = area_t(i,j)*wrk1_2d(i,j)*Grd%tmask(i,j,1)
            endif 


        endif ! endif for kbot > 1 

     enddo   ! enddo for i
  enddo   ! enddo for j


  if(debug_diagnose_mass_of_layer) then 
      wrk3_2d(:,:) = 0.0

      do j=jsc,jec
         do i=isc,iec
            relative_mass_diff = 0.0
            kbot = Grd%kmt(i,j)
            if(kbot > 0) then 
                do n=1,nrho_nk
                   wrk3_2d(i,j) = wrk3_2d(i,j) + nrho_layer_mass(i,j,n)  
                enddo
                tmp_mass           = area_t(i,j)*wrk1_2d(i,j)
                relative_mass_diff = (tmp_mass-wrk3_2d(i,j))/tmp_mass
            endif
            if(abs(relative_mass_diff) > epsln_diagnose_mass_of_layer) then 
                write(unit,'(/a,i5,a,i5,a,e20.10,a,e20.10,a,e20.10)')                               &
                'relative mass difference and masses at (i,j) = (',i+Dom%ioff,',',j+Dom%joff,') = ',&
                relative_mass_diff,',',tmp_mass,',',wrk3_2d(i,j)
                write(unit,'(a,f12.1)') &
                'number of nonzero interface masses in this column are ',wrk2_2d(i,j)  
            endif
            do n=1,nrho_nk
               if(nrho_layer_mass(i,j,n) < 0.0) then 
                   write(unit,'(/a,i5,a,i5,a,i5,e20.10)')                                      &
                   'negative layer mass at (i,j,n) = (',i+Dom%ioff,',',j+Dom%joff,',',n,') = ',&
                   nrho_layer_mass(i,j,n) 
               endif
            enddo

         enddo
      enddo
  endif


end subroutine diagnose_mass_of_layer
! </SUBROUTINE>  NAME="diagnose_mass_of_layer"


end module ocean_tracer_util_mod

module grids_type_mod
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov" >Z. Liang </CONTACT>
  ! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">S. M. Griffies</REVIEWER>


  ! <OVERVIEW>
  !   Define grid types, including cell type, horizontal grid, vertical grid and topography type
  ! </OVERVIEW>

  !<DESCRIPTION>
  !    From discussions with Robert Hallberg, as a prototype for ESMF
  !</DESCRIPTION>

  use mpp_domains_mod, only: domain2d

  implicit none
  private

  public :: hgrid_data_type, vgrid_data_type, topog_data_type, cell_type

  !<PUBLICTYPE >
  type cell_type
     real, dimension(:,:), pointer   :: x => NULL()        ! geographical longitude of cell center
     real, dimension(:,:), pointer   :: y => NULL()        ! geographical latitude of cell center 
     real, dimension(:,:,:), pointer :: x_vert => NULL()   ! geographical longitude of cell vertices
     real, dimension(:,:,:), pointer :: y_vert => NULL()   ! geographical latitude of cell vertices
     real, dimension(:,:), pointer   :: area => NULL()     ! cell area
     real, dimension(:,:), pointer   :: angle => NULL()    ! Angle between i-unit and x-unit vector of cell
     real, dimension(:,:), pointer   :: ds_00_02 => NULL() ! Length of western face of cell
     real, dimension(:,:), pointer   :: ds_20_22 => NULL() ! Length of eastern face of cell
     real, dimension(:,:), pointer   :: ds_02_22 => NULL() ! Length of northern face of cell
     real, dimension(:,:), pointer   :: ds_00_20 => NULL() ! Length of southern face of cell
     real, dimension(:,:), pointer   :: ds_01_21 => NULL() ! width of cell
     real, dimension(:,:), pointer   :: ds_10_12 => NULL() ! height of cell
     real, dimension(:,:), pointer   :: ds_00_01 => NULL() ! Distance from southwest corner to western face center of cell
     real, dimension(:,:), pointer   :: ds_01_02 => NULL() ! Distance from northwest corner to western face center of cell
     real, dimension(:,:), pointer   :: ds_02_12 => NULL() ! Distance from northwest corner to northern face center of cell
     real, dimension(:,:), pointer   :: ds_12_22 => NULL() ! Distance from northeast corner to northern face center of cell
     real, dimension(:,:), pointer   :: ds_21_22 => NULL() ! Distance from northeast corner to eastern face center of cell
     real, dimension(:,:), pointer   :: ds_20_21 => NULL() ! Distance from southeast corner to eastern face center of cell
     real, dimension(:,:), pointer   :: ds_10_20 => NULL() ! Distance from southeast corner to southern face center of cell
     real, dimension(:,:), pointer   :: ds_00_10 => NULL() ! Distance from southwest corner to southern face center of cell
     real, dimension(:,:), pointer   :: ds_01_11 => NULL() ! Distance from center to western face of cell
     real, dimension(:,:), pointer   :: ds_11_12 => NULL() ! Distance from center to northern face of cell
     real, dimension(:,:), pointer   :: ds_11_21 => NULL() ! Distance from center to eastern face of cell 
     real, dimension(:,:), pointer   :: ds_10_11 => NULL() ! Distance from center to southern face of cell
  end type cell_type
  !</PUBLICTYPE>

  !<PUBLICTYPE >
  type hgrid_data_type
     type(cell_type) :: T             ! T-cell
     type(cell_type) :: E             ! E-cell
     type(cell_type) :: N             ! N-cell
     type(cell_type) :: C             ! C-cell
     logical         :: tripolar_grid ! true means tripolar grid
     logical         :: cyclic_x      ! true means cyclic in i-direction
     logical         :: cyclic_y      ! true means cyclic in j-direction
     integer         :: ni, nj        ! grid size
     type(domain2d)  :: Domain
  end type hgrid_data_type
  !</PUBLICTYPE>

  !<PUBLICTYPE >
  type vgrid_data_type
     real, dimension(:), pointer :: zt => NULL()   ! vertical level at T-cell center 
     real, dimension(:), pointer :: zb => NULL()   ! vertical level at T-cell boundary
  end type vgrid_data_type
  !</PUBLICTYPE>

  !<PUBLICTYPE >
  type topog_data_type
     real, dimension(:,:), pointer :: depth_t => NULL()    ! topographic depth of T-cell
     real, dimension(:,:), pointer :: num_levels => NULL() ! number of vertical T-cells
     real, dimension(:,:), pointer :: wet => NULL()        ! wet mask of T-cell
     real, dimension(:,:), pointer :: depth_c => NULL()    ! topographic depth of C-cell
     real, dimension(:,:), pointer :: num_levels_c => NULL() ! number of vertical C-cells
     real, dimension(:,:), pointer :: wet_c => NULL()        ! wet mask of C-cell
  end type topog_data_type
  !</PUBLICTYPE>

end module grids_type_mod

module ocean_vert_const_mod
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</REVIEWER>
!
!<OVERVIEW>
! Compute constant vertical viscosity and diffusivity. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes a time independent vertical viscosity and diffusivity. 
!</DESCRIPTION>
!
! <INFO>
!
! <NOTE>
! The numerical implementation requires no calls to mpp_update_domains.  
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_vert_const_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is false. 
!  </DATA> 
!
!  <DATA NAME="kappa_h" UNITS="m^2/sec" TYPE="real">
!  The constant vertical diffusivity.  Used for cases when wanting a space-time
!  independent diffusivity.  The "h" is historical and stands for "heat".
!  </DATA> 
!  <DATA NAME="kappa_m" UNITS="m^2/sec" TYPE="real">
!  The constant vertical viscosity.  Used for cases when wanting a space-time
!  independent viscosity.  
!  </DATA> 
!  <DATA NAME="diff_cbt_limit" UNITS="m^2/sec" TYPE="real">
!  The largest allowable vertical diffusivity.  Of use for cases where vertically unstable
!  columns are stabilized with a large vertical diffusivity.  
!  </DATA> 
!</NAMELIST>

use constants_mod,      only: pi
use diag_manager_mod,   only: register_diag_field
use fms_mod,            only: write_version_number, FATAL, NOTE, stdout, stdlog
use fms_mod,            only: open_namelist_file, check_nml_error, close_file
use mpp_io_mod,         only: mpp_open, mpp_close, MPP_RDONLY, MPP_ASCII
use mpp_mod,            only: input_nml_file, mpp_error

use ocean_density_mod,    only: density_delta_z
use ocean_domains_mod,    only: get_local_indices
use ocean_parameters_mod, only: missing_value
use ocean_types_mod,      only: ocean_grid_type, ocean_domain_type
use ocean_types_mod,      only: ocean_prog_tracer_type
use ocean_types_mod,      only: ocean_density_type
use ocean_types_mod,      only: ocean_time_type, ocean_time_steps_type
use ocean_workspace_mod,  only: wrk1
use ocean_util_mod,       only: diagnose_3d, diagnose_3d_u

implicit none

public ocean_vert_const_init
public vert_mix_const

private

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()

integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk

character(len=256) :: version=&
     '=>Using: const/ocean_vert_const.F90 ($Id: ocean_vert_const.F90,v 20.0 2013/12/14 00:16:38 fms Exp $)'
character (len=128) :: tagname = &
     '$Name: tikal $'

integer :: index_temp
integer :: index_salt

integer :: id_diff_cbt_const  =-1
integer :: id_visc_cbt_const  =-1
integer :: id_visc_cbu_const  =-1
integer :: id_density_delta_z =-1

integer :: num_prog_tracers
logical :: module_is_initialized = .FALSE.

logical :: use_this_module = .false.
real :: kappa_h        = 0.1e-4  ! constant vertical diffusivity (m^2/sec)
real :: kappa_m        = 1.0e-4  ! constant vertical viscosity (m^2/sec)
real :: diff_cbt_limit = 1.0     ! diffusivity used to vertically adjust (m^2/sec)

namelist /ocean_vert_const_nml/ use_this_module, kappa_h, kappa_m, diff_cbt_limit

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_vert_const_init">
!
! <DESCRIPTION>
! Initialize the constant vertical diffusivity module.
! </DESCRIPTION>
!
subroutine ocean_vert_const_init (Grid, Domain, Time, Time_steps, T_prog)
 
  type(ocean_grid_type),              target, intent(in) :: Grid
  type(ocean_domain_type),            target, intent(in) :: Domain
  type(ocean_time_type),                      intent(in) :: Time
  type(ocean_time_steps_type),                intent(in) :: Time_steps 
  type(ocean_prog_tracer_type), dimension(:), intent(in) :: T_prog

  integer :: k, n, ioun, ierr, io_status

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_vert_const_mod (ocean_vert_const_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_vert_const_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_vert_const_nml')
#else
  ioun =  open_namelist_file()
  read (ioun,ocean_vert_const_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_vert_const_nml')
  call close_file (ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_vert_const_nml)  
  write (stdlogunit,ocean_vert_const_nml)

  if(kappa_h==0.0) then 
    write(stdoutunit,'(/a)')'==>USING constant vertical diffusivity with kappa_h = 0.0.'
  else 
    write(stdoutunit,'(/a)')'==>USING constant vertical diffusivity with kappa_h > 0.0.'
  endif
  if(kappa_m==0.0) then 
    write(stdoutunit,'(a/)')'==>USING constant vertical viscosity with kappa_m = 0.0.'
  else 
    write(stdoutunit,'(a/)')'==>USING constant vertical viscosity with kappa_m > 0.0.'
  endif

  write(stdoutunit,'(/a,f10.2)')&
   '==>Note from ocean_vert_const_mod: using forward time step for vert-frict of (secs)', &
                                  Time_steps%dtime_u 
  write(stdoutunit,'(/a,f10.2)')&
   '==>Note from ocean_vert_const_mod: using forward time step for vert-diff  of (secs)', &
                                  Time_steps%dtime_t 

  Dom => Domain
  Grd => Grid

  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk

  if(use_this_module) then 
    call mpp_error(NOTE, '==>Note: USING ocean_vert_const_mod')
  else
    call mpp_error(NOTE, '==>Note: NOT using ocean_vert_const_mod')
    return 
  endif

  if(Time_steps%aidif < 1.0) then 

      do k=1,nk
         if ((Time_steps%dtime_t*kappa_h)/Grid%dzt(k)**2 >= 0.5) then
             write (stdoutunit,'(a,a,i3)')&
             '==> Warning: vertical stability criteria exceeded for vertical diff.',&
                  ' Use aidif=1.0, or a smaller "dtts" and/or "kappa_h" at level k=',k
         endif
      enddo

      do k=1,nk
         if ((Time_steps%dtime_u*kappa_m)/Grid%dzt(k)**2 >= 0.5) then
             write (stdoutunit,'(a,a,i3)')&
             '==> Warning: vertical stability criteria exceeded for vertical visc.',&
                  ' Use aidif=1.0, smaller dtuv, or smaller kappa_m at level k=',k
         endif
      enddo

  endif

  num_prog_tracers = size(T_prog)

  index_temp = -1
  index_salt = -1
  
  do n = 1, num_prog_tracers
     if (trim(T_prog(n)%name) == 'temp') index_temp = n
     if (trim(T_prog(n)%name) == 'salt') index_salt = n
  enddo

  if (index_temp < 1 .or. index_salt < 1) then 
    call mpp_error(FATAL,&
    '==>Error in ocean_vert_const_mod: temp or salt not present in tracer array')
  endif 

  ! register vertical diffusivity
  id_diff_cbt_const = -1
  id_diff_cbt_const = register_diag_field ('ocean_model', 'diff_cbt_const', Grid%tracer_axes(1:3), &
                      Time%model_time, 'vert diff_cbt from constant scheme',                       &
                      'm^2/s',missing_value=missing_value, range=(/-10.0,1e6/))

  id_visc_cbt_const = -1
  id_visc_cbt_const = register_diag_field ('ocean_model', 'visc_cbt_const', Grid%tracer_axes(1:3), &
                      Time%model_time, 'vert visc_cbt from constant scheme',                       &
                      'm^2/s',missing_value=missing_value, range=(/-10.0,1e6/))

  id_visc_cbu_const = -1
  id_visc_cbu_const = register_diag_field ('ocean_model', 'visc_cbu_const', Grid%vel_axes_uv(1:3), &
                      Time%model_time, 'vert visc_cbu from constant scheme',                       &
                      'm^2/s',missing_value=missing_value, range=(/-10.0,1e6/))

  id_density_delta_z = -1
  id_density_delta_z = register_diag_field ('ocean_model', 'density_delta_z', Grid%tracer_axes(1:3), &
                       Time%model_time, 'rho(k)-rho(k+1) to check stability for const diff_cbt',     &
                       'kg/m^3',missing_value=missing_value, range=(/-10.0,1e6/))

end subroutine ocean_vert_const_init
! </SUBROUTINE>  NAME="ocean_vert_const_init"


!#######################################################################
! <SUBROUTINE NAME="vert_mix_const">
!
! <DESCRIPTION>
! This function computes the vertical diffusivity and viscosity.  
! These mixing coefficients are time independent but generally 
! arbitrary functions of space. 
! </DESCRIPTION>
!
  subroutine vert_mix_const(aidif, Time, T_prog, Dens, visc_cbu, visc_cbt, diff_cbt)

  real,                           intent(in)    :: aidif
  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_prog_tracer_type),   intent(in)    :: T_prog(:)
  type(ocean_density_type),       intent(in)    :: Dens
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbu
  real, dimension(isd:,jsd:,:),   intent(inout) :: visc_cbt
  real, dimension(isd:,jsd:,:,:), intent(inout) :: diff_cbt

  integer :: i, j, k
  integer :: tau

  if(.not. use_this_module) then 
    return 
  endif 

  if ( .not. module_is_initialized ) then 
     call mpp_error(FATAL, '==>Error from ocean_vert_const: module must be initialized')
  endif 

  tau         = Time%tau
  wrk1(:,:,:) = 0.0

  do k=1,nk-1
     do j=jsc,jec
        do i=isc,iec
           visc_cbu(i,j,k)   = kappa_m*Grd%umask(i,j,k+1)
           visc_cbt(i,j,k)   = kappa_m*Grd%tmask(i,j,k+1)
           diff_cbt(i,j,k,1) = kappa_h*Grd%tmask(i,j,k+1)
        enddo
     enddo
  enddo

  ! set vertical diffusivity to diff_cbt_limit where gravitationally unstable
  if(aidif==1.0) then

      wrk1(:,:,:) = density_delta_z (Dens%rho(:,:,:,tau),                 &
                                     Dens%rho_salinity(:,:,:,tau),        &
                                     T_prog(index_temp)%field(:,:,:,tau), &
                                     Dens%pressure_at_depth(:,:,:))   

      do k=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               if (wrk1(i,j,k)*Grd%tmask(i,j,k+1) > 0.0) then
                   diff_cbt(i,j,k,1) = diff_cbt_limit
               endif
            enddo
         enddo
      enddo

  endif

  ! no distinction between temperature and salinity for this mixing scheme 
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           diff_cbt(i,j,k,2) = diff_cbt(i,j,k,1)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_diff_cbt_const, diff_cbt(:,:,:,1))
  call diagnose_3d(Time, Grd, id_visc_cbt_const, visc_cbt(:,:,:))
  call diagnose_3d_u(Time, Grd, id_visc_cbu_const, visc_cbu(:,:,:))
  call diagnose_3d(Time, Grd, id_density_delta_z, wrk1(:,:,:))

end subroutine vert_mix_const
! </SUBROUTINE> NAME="vert_mix_const"

end module ocean_vert_const_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------
 
! $Id: lidar_simulator.F90,v 20.0 2013/12/13 23:15:57 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! Copyright (c) 2009, Centre National de la Recherche Scientifique
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the LMD/IPSL/CNRS/UPMC nor the names of its
!       contributors may be used to endorse or promote products derived from this software without 
!       specific prior written permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
      
      SUBROUTINE lidar_simulator(npoints,nlev,npart,nrefl &
                , undef &
                , pres, presf, temp &
                , q_lsliq, q_lsice, q_cvliq, q_cvice &
                , ls_radliq, ls_radice, cv_radliq, cv_radice &
                , frac_out, ice_type &
                , pmol, pnorm, tautot, refl )
!
!---------------------------------------------------------------------------------
! Purpose: To compute lidar signal from model-simulated profiles of cloud water
!          and cloud fraction in each sub-column of each model gridbox.
!
! References: 
! Chepfer H., S. Bony, D. Winker, M. Chiriaco, J.-L. Dufresne, G. Seze (2008),
! Use of CALIPSO lidar observations to evaluate the cloudiness simulated by a 
! climate model, Geophys. Res. Lett., 35, L15704, doi:10.1029/2008GL034207.
!
! Previous references:
! Chiriaco et al, MWR, 2006; Chepfer et al., MWR, 2007
!
! Contacts: Helene Chepfer (chepfer@lmd.polytechnique.fr), Sandrine Bony (bony@lmd.jussieu.fr)
!
! May 2007: ActSim code of M. Chiriaco and H. Chepfer rewritten by S. Bony
!
! May 2008, H. Chepfer:
! - Units of pressure inputs: Pa 
! - Non Spherical particles : LS Ice NS coefficients, CONV Ice NS coefficients
! - New input: ice_type (0=ice-spheres ; 1=ice-non-spherical)
!
! June 2008, A. Bodas-Salcedo:
! - Ported to Fortran 90 and optimisation changes
!
! August 2008, J-L Dufresne:
! - Optimisation changes (sum instructions suppressed)
!
! October 2008, S. Bony,  H. Chepfer and J-L. Dufresne :  
! - Interface with COSP v2.0:
!      cloud fraction removed from inputs
!      in-cloud condensed water now in input (instead of grid-averaged value)
!      depolarisation diagnostic removed
!      parasol (polder) reflectances (for 5 different solar zenith angles) added
!
! December 2008, S. Bony,  H. Chepfer and J-L. Dufresne : 
! - Modification of the integration of the lidar equation.
! - change the cloud detection threshold
!
! April 2008, A. Bodas-Salcedo:
! - Bug fix in computation of pmol and pnorm of upper layer
!
! April 2008, J-L. Dufresne
! - Bug fix in computation of pmol and pnorm, thanks to Masaki Satoh: a factor 2 
! was missing. This affects the ATB values but not the cloud fraction. 
!
!---------------------------------------------------------------------------------
!
! Inputs:
!  npoints  : number of horizontal points
!  nlev : number of vertical levels
!  npart: numberb of cloud meteors (stratiform_liq, stratiform_ice, conv_liq, conv_ice). 
!        Currently npart must be 4
!  nrefl: number of solar zenith angles for parasol reflectances
!  pres : pressure in the middle of atmospheric layers (full levels): Pa
!  presf: pressure in the interface of atmospheric layers (half levels): Pa
!     presf(..,1) : surface pressure ; presf(..,nlev+1)= TOA pressure
!  temp : temperature of atmospheric layers: K
!  q_lsliq: LS sub-column liquid water mixing ratio (kg/kg)
!  q_lsice: LS sub-column ice water mixing ratio (kg/kg)
!  q_cvliq: CONV sub-column liquid water mixing ratio (kg/kg)
!  q_cvice: CONV sub-column ice water mixing ratio (kg/kg)
!  ls_radliq: effective radius of LS liquid particles (meters)
!  ls_radice: effective radius of LS ice particles (meters)
!  cv_radliq: effective radius of CONV liquid particles (meters)
!  cv_radice: effective radius of CONV ice particles (meters)
!  frac_out : cloud cover in each sub-column of the gridbox (output from scops)
!  ice_type : ice particle shape hypothesis (ice_type=0 for spheres, ice_type=1 
!             for non spherical particles)
!
! Outputs:
!  pmol : molecular attenuated backscatter lidar signal power (m^-1.sr^-1)
!  pnorm: total attenuated backscatter lidar signal power (m^-1.sr^-1)
!  tautot: optical thickess integrated from top to level z
!  refl : parasol(polder) reflectance
!
! Version 1.0 (June 2007)
! Version 1.1 (May 2008)
! Version 1.2 (June 2008)
! Version 2.0 (October 2008)
! Version 2.1 (December 2008)
!---------------------------------------------------------------------------------

      IMPLICIT NONE
      REAL :: SRsat
      PARAMETER (SRsat = 0.01) ! threshold full attenuation 

      LOGICAL ok_parasol
      PARAMETER (ok_parasol=.true.)  ! set to .true. if you want to activate parasol reflectances

      INTEGER i, k
      
      INTEGER INDX_LSLIQ,INDX_LSICE,INDX_CVLIQ,INDX_CVICE
      PARAMETER (INDX_LSLIQ=1,INDX_LSICE=2,INDX_CVLIQ=3,INDX_CVICE=4)
! inputs:
      INTEGER npoints,nlev,npart,ice_type
      INTEGER nrefl
      real undef                 ! undefined value
      REAL pres(npoints,nlev)    ! pressure full levels
      REAL presf(npoints,nlev+1) ! pressure half levels
      REAL temp(npoints,nlev)
      REAL q_lsliq(npoints,nlev), q_lsice(npoints,nlev)
      REAL q_cvliq(npoints,nlev), q_cvice(npoints,nlev)
      REAL ls_radliq(npoints,nlev), ls_radice(npoints,nlev)
      REAL cv_radliq(npoints,nlev), cv_radice(npoints,nlev)
      REAL frac_out(npoints,nlev)

! outputs (for each subcolumn):

      REAL pmol(npoints,nlev)  ! molecular backscatter signal power (m^-1.sr^-1)
      REAL pnorm(npoints,nlev) ! total lidar backscatter signal power (m^-1.sr^-1)
      REAL tautot(npoints,nlev)! optical thickess integrated from top
      REAL refl(npoints,nrefl)! parasol reflectance ! parasol

! actsim variables:

      REAL km, rdiffm, Qscat, Cmol
      PARAMETER (Cmol = 6.2446e-32) ! depends on wavelength
      PARAMETER (km = 1.38e-23)     ! Boltzmann constant (J/K)

      PARAMETER (rdiffm = 0.7)      ! multiple scattering correction parameter
      PARAMETER (Qscat = 2.0)       ! particle scattering efficiency at 532 nm

      REAL rholiq, rhoice
      PARAMETER (rholiq=1.0e+03)     ! liquid water (kg/m3)
      PARAMETER (rhoice=0.5e+03)     ! ice (kg/m3)

      REAL pi, rhopart(npart)
      REAL polpart(npart,5)  ! polynomial coefficients derived for spherical and non spherical
                             ! particules

!   grid-box variables:
      REAL rad_part(npoints,nlev,npart)
      REAL rhoair(npoints,nlev), zheight(npoints,nlev+1)
      REAL beta_mol(npoints,nlev), alpha_mol(npoints,nlev)
      REAL kp_part(npoints,nlev,npart)

!   sub-column variables:
      REAL frac_sub(npoints,nlev)
      REAL qpart(npoints,nlev,npart) ! mixing ratio particles in each subcolumn
      REAL alpha_part(npoints,nlev,npart)
      REAL tau_mol_lay(npoints)  ! temporary variable, moL. opt. thickness of layer k
      REAL tau_mol(npoints,nlev) ! optical thickness between TOA and bottom of layer k
      REAL tau_part(npoints,nlev,npart)
      REAL betatot(npoints,nlev)
      REAL tautot_lay(npoints)   ! temporary variable, total opt. thickness of layer k
!     Optical thickness from TOA to surface for Parasol
      REAL tautot_S_liq(npoints),tautot_S_ice(npoints)     ! for liq and ice clouds


!------------------------------------------------------------
!---- 1. Preliminary definitions and calculations :
!------------------------------------------------------------

      if ( npart .ne. 4 ) then
        print *,'Error in lidar_simulator, npart should be 4, not',npart
        stop
      endif

      pi = dacos(-1.D0)

! Polynomial coefficients for spherical liq/ice particles derived from Mie theory.
! Polynomial coefficients for non spherical particles derived from a composite of
! Ray-tracing theory for large particles (e.g. Noel et al., Appl. Opt., 2001)
! and FDTD theory for very small particles (Yang et al., JQSRT, 2003).

! We repeat the same coefficients for LS and CONV cloud to make code more readable
!*     LS Liquid water coefficients:
         polpart(INDX_LSLIQ,1) =  2.6980e-8     
         polpart(INDX_LSLIQ,2) = -3.7701e-6
         polpart(INDX_LSLIQ,3) =  1.6594e-4
         polpart(INDX_LSLIQ,4) = -0.0024
         polpart(INDX_LSLIQ,5) =  0.0626
!*     LS Ice coefficients: 
      if (ice_type.eq.0) then     
         polpart(INDX_LSICE,1) = -1.0176e-8   
         polpart(INDX_LSICE,2) =  1.7615e-6
         polpart(INDX_LSICE,3) = -1.0480e-4
         polpart(INDX_LSICE,4) =  0.0019
         polpart(INDX_LSICE,5) =  0.0460
      endif
!*     LS Ice NS coefficients: 
      if (ice_type.eq.1) then 
         polpart(INDX_LSICE,1) = 1.3615e-8  
         polpart(INDX_LSICE,2) = -2.04206e-6 
         polpart(INDX_LSICE,3) = 7.51799e-5
         polpart(INDX_LSICE,4) = 0.00078213
         polpart(INDX_LSICE,5) = 0.0182131
      endif
!*     CONV Liquid water coefficients:
         polpart(INDX_CVLIQ,1) =  2.6980e-8     
         polpart(INDX_CVLIQ,2) = -3.7701e-6
         polpart(INDX_CVLIQ,3) =  1.6594e-4
         polpart(INDX_CVLIQ,4) = -0.0024
         polpart(INDX_CVLIQ,5) =  0.0626
!*     CONV Ice coefficients: 
      if (ice_type.eq.0) then 
         polpart(INDX_CVICE,1) = -1.0176e-8   
         polpart(INDX_CVICE,2) =  1.7615e-6
         polpart(INDX_CVICE,3) = -1.0480e-4
         polpart(INDX_CVICE,4) =  0.0019
         polpart(INDX_CVICE,5) =  0.0460
      endif
      if (ice_type.eq.1) then
         polpart(INDX_CVICE,1) = 1.3615e-8
         polpart(INDX_CVICE,2) = -2.04206e-6
         polpart(INDX_CVICE,3) = 7.51799e-5
         polpart(INDX_CVICE,4) = 0.00078213
         polpart(INDX_CVICE,5) = 0.0182131
      endif

! density:
!*    clear-sky air:
      rhoair = pres/(287.04*temp)

!*    liquid/ice particules:
      rhopart(INDX_LSLIQ) = rholiq
      rhopart(INDX_LSICE) = rhoice
      rhopart(INDX_CVLIQ) = rholiq
      rhopart(INDX_CVICE) = rhoice

! effective radius particles:
      rad_part(:,:,INDX_LSLIQ) = ls_radliq(:,:)
      rad_part(:,:,INDX_LSICE) = ls_radice(:,:)
      rad_part(:,:,INDX_CVLIQ) = cv_radliq(:,:)
      rad_part(:,:,INDX_CVICE) = cv_radice(:,:)
      rad_part(:,:,:)=MAX(rad_part(:,:,:),0.)
      rad_part(:,:,:)=MIN(rad_part(:,:,:),70.0e-6)
      
! altitude at half pressure levels:
      zheight(:,1) = 0.0
      do k = 2, nlev+1
        zheight(:,k) = zheight(:,k-1) &
                  -(presf(:,k)-presf(:,k-1))/(rhoair(:,k-1)*9.81)
      enddo

! cloud fraction (0 or 1) in each sub-column:
! (if frac_out=1or2 -> frac_sub=1; if frac_out=0 -> frac_sub=0)
      frac_sub = MIN( frac_out, 1.0 )

!------------------------------------------------------------
!---- 2. Molecular alpha and beta:
!------------------------------------------------------------

      beta_mol = pres/km/temp * Cmol
      alpha_mol = 8.0*pi/3.0 * beta_mol

!------------------------------------------------------------
!---- 3. Particles alpha and beta:
!------------------------------------------------------------

! polynomes kp_lidar derived from Mie theory:
      do i = 1, npart
       where ( rad_part(:,:,i).gt.0.0)
         kp_part(:,:,i) = &
            polpart(i,1)*(rad_part(:,:,i)*1e6)**4 &
          + polpart(i,2)*(rad_part(:,:,i)*1e6)**3 &
          + polpart(i,3)*(rad_part(:,:,i)*1e6)**2 &
          + polpart(i,4)*(rad_part(:,:,i)*1e6) &
          + polpart(i,5)
        elsewhere
         kp_part(:,:,i) = 0.
        endwhere
      enddo
      
! mixing ratio particules in each subcolumn:
          qpart(:,:,INDX_LSLIQ) = q_lsliq(:,:) ! oct08
          qpart(:,:,INDX_LSICE) = q_lsice(:,:) ! oct08
          qpart(:,:,INDX_CVLIQ) = q_cvliq(:,:) ! oct08
          qpart(:,:,INDX_CVICE) = q_cvice(:,:) ! oct08

! alpha of particles in each subcolumn:
      do i = 1, npart
        where ( rad_part(:,:,i).gt.0.0)
          alpha_part(:,:,i) = 3.0/4.0 * Qscat &
                 * rhoair(:,:) * qpart(:,:,i) &
                 / (rhopart(i) * rad_part(:,:,i) )
        elsewhere
          alpha_part(:,:,i) = 0.
        endwhere
      enddo

!------------------------------------------------------------
!---- 4. Backscatter signal:
!------------------------------------------------------------

! optical thickness (molecular):
!     opt. thick of each layer
      tau_mol(:,1:nlev) = alpha_mol(:,1:nlev) &
         & *(zheight(:,2:nlev+1)-zheight(:,1:nlev))
!     opt. thick from TOA
      DO k = nlev-1, 1, -1
        tau_mol(:,k) = tau_mol(:,k) + tau_mol(:,k+1)
      ENDDO

! optical thickness (particles):

      tau_part = rdiffm * alpha_part
      DO i = 1, npart
!       opt. thick of each layer
        tau_part(:,:,i) = tau_part(:,:,i) &
           & * (zheight(:,2:nlev+1)-zheight(:,1:nlev) )
!       opt. thick from TOA
        DO k = nlev-1, 1, -1 
          tau_part(:,k,i) = tau_part(:,k,i) + tau_part(:,k+1,i)
        ENDDO
      ENDDO

! molecular signal:
!      Upper layer 
       pmol(:,nlev) = beta_mol(:,nlev) / (2.*tau_mol(:,nlev)) &
            & * (1.-exp(-2.0*tau_mol(:,nlev)))
!      Other layers
       DO k= nlev-1, 1, -1
        tau_mol_lay(:) = tau_mol(:,k)-tau_mol(:,k+1) ! opt. thick. of layer k
        WHERE (tau_mol_lay(:).GT.0.)
          pmol(:,k) = beta_mol(:,k) * EXP(-2.0*tau_mol(:,k+1)) / (2.*tau_mol_lay(:)) &
            & * (1.-exp(-2.0*tau_mol_lay(:)))
        ELSEWHERE
!         This must never happend, but just in case, to avoid div. by 0
          pmol(:,k) = beta_mol(:,k) * EXP(-2.0*tau_mol(:,k+1))
        END WHERE
      END DO
!
! Total signal (molecular + particules):
!
! For performance reason on vector computers, the 2 following lines should not be used
! and should be replace by the later one.
!      betatot(:,:) = beta_mol(:,:) + sum(kp_part*alpha_part,dim=3)
!      tautot(:,:)  = tau_mol(:,:)  + sum(tau_part,dim=3)
      betatot(:,:) = beta_mol(:,:)
      tautot(:,:)  = tau_mol(:,:)
      DO i = 1, npart
           betatot(:,:) = betatot(:,:) + kp_part(:,:,i)*alpha_part(:,:,i)
           tautot(:,:) = tautot(:,:)  + tau_part(:,:,i)
      ENDDO ! i
!
!     Upper layer 
      pnorm(:,nlev) = betatot(:,nlev) / (2.*tautot(:,nlev)) &
            & * (1.-exp(-2.0*tautot(:,nlev)))
!     Other layers
      DO k= nlev-1, 1, -1
        tautot_lay(:) = tautot(:,k)-tautot(:,k+1) ! optical thickness of layer k
        WHERE (tautot_lay(:).GT.0.)
       pnorm(:,k) = betatot(:,k) * EXP(-2.0*tautot(:,k+1)) / (2.*tautot_lay(:)) &
!correc          pnorm(:,k) = betatot(:,k) * EXP(-2.0*tautot(:,k+1)) & ! correc Satoh
!correc               &               / (2.0*tautot_lay(:)) &          ! correc Satoh
               & * (1.-EXP(-2.0*tautot_lay(:)))
        ELSEWHERE
!         This must never happend, but just in case, to avoid div. by 0
          pnorm(:,k) = betatot(:,k) * EXP(-2.0*tautot(:,k+1))
        END WHERE
      END DO

!-------- End computation Lidar --------------------------

!---------------------------------------------------------
!  Parasol/Polder module
!
!  Purpose : Compute reflectance for one particular viewing direction
!  and 5 solar zenith angles (calculation valid only over ocean)
! ---------------------------------------------------------

! initialization:
    refl(:,:) = 0.0

! activate parasol calculations:
    if (ok_parasol) then

!     Optical thickness from TOA to surface
      tautot_S_liq = 0.
      tautot_S_ice = 0.
      tautot_S_liq(:) = tautot_S_liq(:) &
         + tau_part(:,1,1) + tau_part(:,1,3)
      tautot_S_ice(:) = tautot_S_ice(:) &
         + tau_part(:,1,2) + tau_part(:,1,4)

      call parasol(npoints,nrefl,undef  &
                 ,tautot_S_liq,tautot_S_ice &
                 ,refl)

    endif ! ok_parasol

  END SUBROUTINE lidar_simulator
!
!---------------------------------------------------------------------------------
!
  SUBROUTINE parasol(npoints,nrefl,undef  &
                       ,tautot_S_liq,tautot_S_ice  &
                       ,refl)
!---------------------------------------------------------------------------------
! Purpose: To compute Parasol reflectance signal from model-simulated profiles 
!          of cloud water and cloud fraction in each sub-column of each model 
!          gridbox.
!
!
! December 2008, S. Bony,  H. Chepfer and J-L. Dufresne : 
! - optimization for vectorization
!
! Version 2.0 (October 2008)
! Version 2.1 (December 2008)
!---------------------------------------------------------------------------------

    IMPLICIT NONE

! inputs
    INTEGER npoints              ! Number of horizontal gridpoints
    INTEGER nrefl                ! Number of angles for which the reflectance 
                                 ! is computed. Can not be greater then ntetas
    REAL undef                   ! Undefined value. Currently not used
    REAL tautot_S_liq(npoints)   ! liquid water cloud optical thickness, 
                                   ! integrated from TOA to surface
    REAL tautot_S_ice(npoints)   ! same for ice water clouds only
! outputs
    REAL refl(npoints,nrefl)     ! Parasol reflectances
!
! Local variables
    REAL tautot_S(npoints)       ! cloud optical thickness, from TOA to surface
    REAL frac_taucol_liq(npoints), frac_taucol_ice(npoints)

    REAL pi
!   look up table variables:
    INTEGER ny, it
    INTEGER ntetas, nbtau        ! number of angle and of optical thickness
                                   ! of the look-up table
    PARAMETER (ntetas=5, nbtau=7)
    REAL aa(ntetas,nbtau-1), ab(ntetas,nbtau-1)
    REAL ba(ntetas,nbtau-1), bb(ntetas,nbtau-1)  
    REAL tetas(ntetas),tau(nbtau)                        
    REAL r_norm(ntetas)
    REAL rlumA(ntetas,nbtau), rlumB(ntetas,nbtau)       
    REAL rlumA_mod(npoints,5), rlumB_mod(npoints,5) 

    DATA tau   /0., 1., 5., 10., 20., 50., 100./
    DATA tetas /0., 20., 40., 60., 80./
    
! Look-up table for spherical liquid particles:
    DATA (rlumA(1,ny),ny=1,nbtau) /0.03, 0.090886, 0.283965, &
     0.480587, 0.695235, 0.908229, 1.0 /
    DATA (rlumA(2,ny),ny=1,nbtau) /0.03, 0.072185, 0.252596, &
      0.436401,  0.631352, 0.823924, 0.909013 /
    DATA (rlumA(3,ny),ny=1,nbtau) /0.03, 0.058410, 0.224707, &
      0.367451,  0.509180, 0.648152, 0.709554 /
    DATA (rlumA(4,ny),ny=1,nbtau) /0.03, 0.052498, 0.175844, &
      0.252916,  0.326551, 0.398581, 0.430405 /
    DATA (rlumA(5,ny),ny=1,nbtau) /0.03, 0.034730, 0.064488, &
      0.081667,  0.098215, 0.114411, 0.121567 /

! Look-up table for ice particles:
    DATA (rlumB(1,ny),ny=1,nbtau) /0.03, 0.092170, 0.311941, &
       0.511298, 0.712079 , 0.898243 , 0.976646 /
    DATA (rlumB(2,ny),ny=1,nbtau) /0.03, 0.087082, 0.304293, &
       0.490879,  0.673565, 0.842026, 0.912966 /
    DATA (rlumB(3,ny),ny=1,nbtau) /0.03, 0.083325, 0.285193, &
      0.430266,  0.563747, 0.685773,  0.737154 /
    DATA (rlumB(4,ny),ny=1,nbtau) /0.03, 0.084935, 0.233450, &
      0.312280, 0.382376, 0.446371, 0.473317 /
    DATA (rlumB(5,ny),ny=1,nbtau) /0.03, 0.054157, 0.089911, &
      0.107854, 0.124127, 0.139004, 0.145269 /

!--------------------------------------------------------------------------------
! Lum_norm=f(tetaS,tau_cloud) derived from adding-doubling calculations
!        valid ONLY ABOVE OCEAN (albedo_sfce=5%)
!        valid only in one viewing direction (theta_v=30�, phi_s-phi_v=320�)
!        based on adding-doubling radiative transfer computation
!        for tau values (0 to 100) and for tetas values (0 to 80)
!        for 2 scattering phase functions: liquid spherical, ice non spherical

    IF ( nrefl.GT. ntetas ) THEN
        PRINT *,'Error in lidar_simulator, nrefl should be less then ',ntetas,' not',nrefl
        STOP
    ENDIF

    rlumA_mod=0
    rlumB_mod=0
!
    pi = ACOS(-1.0)
    r_norm(:)=1./ COS(pi/180.*tetas(:))
!
    tautot_S_liq(:)=MAX(tautot_S_liq(:),tau(1))
    tautot_S_ice(:)=MAX(tautot_S_ice(:),tau(1))
    tautot_S(:) = tautot_S_ice(:) + tautot_S_liq(:)
!
! relative fraction of the opt. thick due to liquid or ice clouds
    WHERE (tautot_S(:) .GT. 0.)
        frac_taucol_liq(:) = tautot_S_liq(:) / tautot_S(:)
        frac_taucol_ice(:) = tautot_S_ice(:) / tautot_S(:)
    ELSEWHERE
        frac_taucol_liq(:) = 1.
        frac_taucol_ice(:) = 0.
    END WHERE
    tautot_S(:)=MIN(tautot_S(:),tau(nbtau))
!
! Linear interpolation :

    DO ny=1,nbtau-1
! microphysics A (liquid clouds) 
      aA(:,ny) = (rlumA(:,ny+1)-rlumA(:,ny))/(tau(ny+1)-tau(ny))
      bA(:,ny) = rlumA(:,ny) - aA(:,ny)*tau(ny)
! microphysics B (ice clouds)
      aB(:,ny) = (rlumB(:,ny+1)-rlumB(:,ny))/(tau(ny+1)-tau(ny))
      bB(:,ny) = rlumB(:,ny) - aB(:,ny)*tau(ny)
    ENDDO
!
    DO it=1,ntetas
      DO ny=1,nbtau-1
        WHERE (tautot_S(:).GE.tau(ny).AND.tautot_S(:).LE.tau(ny+1))
            rlumA_mod(:,it) = aA(it,ny)*tautot_S(:) + bA(it,ny)
            rlumB_mod(:,it) = aB(it,ny)*tautot_S(:) + bB(it,ny)
        END WHERE
      END DO
    END DO
!
    DO it=1,ntetas
      refl(:,it) = frac_taucol_liq(:) * rlumA_mod(:,it) &
         + frac_taucol_ice(:) * rlumB_mod(:,it)
! normalized radiance -> reflectance: 
      refl(:,it) = refl(:,it) * r_norm(it)
    ENDDO

    RETURN
  END SUBROUTINE parasol

module ocean_blob_diag_mod
!
!<CONTACT EMAIL="m.bates@student.unsw.edu.au"> Michael L. Bates
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Controls the diagnostic output from individual blobs.
!</OVERVIEW>
!
!<DESCRIPTION>
! Controls the diagnostics from individual blobs.  Blob diagnostics
! are snapshots at full E system time steps of blob properties.  There is
! no averaging of individual blob properties. The properties that can be 
! output are set in a diagnostic file.  The name of the diagnostic file 
! is specified in the namelist.
!</DESCRIPTION>
!
!<INFO>
!<NAMELIST NAME="ocean_blob_diag_nml">
!
!  <DATA NAME ="blob_diagnostics" TYPE="LOGICAL">
!    Logical as to whether diagnostics should be saved or not.
!    Default is .false.
!  </DATA>
!
!  <DATA NAME ="diag_table" TYPE="character">
!    Name of file to look for blob diagnostic information.
!    Default is "blob_diag_table"
!  </DATA>
!
!  <DATA NAME ="dump_num" TYPE="integer">
!    The number of entried to keep in memory before writing
!    them to file.  The higher the number, the more memory that
!    the module will take up, but, it should lower the frequency of
!    IO operations.
!    Default is 2000000
!  </DATA>
!
!  <DATA NAME ="frequency" TYPE="integer">
!    The frequency (in number of E system time steps) that blob
!    diagnostics should be saved.
!    Default is 1
!  </DATA>
!
!</NAMELIST>
!</INFO>
!
use constants_mod, only: c2dbars
use fms_mod,       only: stderr, stdout, stdlog, error_mesg, FATAL, WARNING
use fms_mod,       only: close_file, check_nml_error, open_namelist_file
use fms_mod,       only: mpp_error
use mpp_mod,       only: mpp_pe, mpp_sum

use ocean_blob_util_mod,  only: put_att, def_var, inq_var, put_int, put_double, hashfun
use ocean_blob_util_mod,  only: free_blob_memory
use ocean_parameters_mod, only: DEPTH_BASED
use ocean_types_mod,      only: ocean_grid_type, ocean_domain_type, blob_grid_type
use ocean_types_mod,      only: ocean_blob_type, ocean_time_type, ocean_prog_tracer_type
use ocean_types_mod,      only: ocean_grid_type, ocean_domain_type

implicit none

include 'netcdf.inc'
include 'mpif.h'

private

! Logicals for optional diagnostics
logical :: usei
logical :: usej
logical :: usek
logical :: usedepth
logical :: usest
logical :: usemass
logical :: usedensity
logical :: useent
logical :: usedet
logical :: userichardson
logical :: usegprime
logical :: usevolume
logical :: useu
logical :: usev
logical :: usew
logical :: useage
logical, allocatable, dimension(:) :: usetracer(:)
logical, allocatable, dimension(:) :: usefield(:)

character(len=31) :: filename
character(len=31) :: filename_modeltime
integer :: num_prog_tracers
integer :: index_temp
integer :: length
integer :: nblobs
integer :: vert_coordinate_class
real    :: dtime

integer :: isc,iec,jsc,jec,nk

type, private :: diag_blob_type
   integer :: type
   integer :: hash
   integer :: number
   real    :: time
   real    :: lat
   real    :: lon
   real    :: geodepth
   integer :: i
   integer :: j
   integer :: k
   real    :: depth
   real    :: st
   real    :: mass
   real    :: density
   real    :: ent
   real    :: det
   real    :: richardson
   real    :: gprime
   real    :: volume
   real    :: u
   real    :: v
   real    :: w
   real    :: age
   real, allocatable :: tracer(:)
   real, allocatable :: field(:)
   type(diag_blob_type), pointer :: next
end type diag_blob_type

type(diag_blob_type), pointer :: diag_head

public blob_diag_init
public blob_diag
public open_netcdf_file
public blob_diag_end

! namelist variables and default values
logical           :: blob_diagnostics = .false.  
character(len=31) :: diag_table       = "blob_diag_table"
integer           :: dump_num         = 2000000
integer           :: frequency        = 1                 !How many steps from one snapshot to the next

namelist /ocean_blob_diag_nml/ blob_diagnostics, diag_table, dump_num, frequency

contains

!######################################################################
! <SUBROUTINE NAME="ocean_blob_diag_init">
!
! <DESCRIPTION>
! Initialises the blob diagnostic module.
! </DESCRIPTION>
!
  subroutine blob_diag_init(T_prog, Grid, Domain, num_tracers, dtimein, &
                            itemp, ver_coordinate_class, do_diag)
  type(ocean_prog_tracer_type), intent(in)  :: T_prog(:)
  type(ocean_grid_type),        intent(in)  :: Grid
  type(ocean_domain_type),      intent(in)  :: Domain
  integer,                      intent(in)  :: num_tracers
  real,                         intent(in)  :: dtimein
  integer,                      intent(in)  :: itemp
  integer,                      intent(in)  :: ver_coordinate_class
  logical,                      intent(out) :: do_diag
  

  integer :: ioun, ierr, io_status
  integer :: stdoutunit,stdlogunit 
  integer :: rootid, blobdim
  integer :: typeid, entryid, hashid, numberid, timeid
  integer :: latid, lonid, geodepthid
  integer :: iid, jid, kid
  integer :: depthid, stid, massid, volumeid, densityid, gprimeid
  integer :: entid, detid, richardsonid
  integer :: uid, vid, wid, ageid
  integer :: retval
  integer :: i,j,k,n,m
  integer :: maxhash
  logical :: validvar
  character(len=128) :: varname
  integer,allocatable,dimension(:) :: tracerid, fieldid

  stdoutunit = stdout(); stdlogunit=stdlog()

  ! provide for namelist over-ride of default values
  ioun =  open_namelist_file()
  read (ioun,ocean_blob_diag_nml,IOSTAT=io_status)
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_blob_diag_nml)  
  write (stdlogunit,ocean_blob_diag_nml)
  ierr = check_nml_error(io_status,'ocean_blob_diag_nml')
  call close_file (ioun)

  do_diag = blob_diagnostics

  if (.not. blob_diagnostics) return

  num_prog_tracers      = num_tracers
  vert_coordinate_class = ver_coordinate_class
  dtime                 = dtimein
  index_temp            = itemp
  diag_head => NULL()

  allocate(usetracer(num_prog_tracers))
  allocate(usefield(num_prog_tracers))

  allocate(tracerid(num_prog_tracers))
  allocate(fieldid(num_prog_tracers))

  usei        = .false.
  usej        = .false.
  usek        = .false.
  usedepth    = .false.
  usest       = .false.
  usemass     = .false.
  usedensity  = .false.
  useent      = .false.
  usedet      = .false.
  userichardson=.false.
  usegprime   = .false.
  usevolume   = .false.
  useu        = .false.
  usev        = .false.
  usew        = .false.
  useage      = .false.
  usetracer(:)  = .false.
  usefield(:)   = .false.
  
  write(stdoutunit,'(/,a)') 'Opening blob diagnostic table '//trim(diag_table)
  open(unit=1, iostat=ioun, file=trim(diag_table))
  if (ioun>0) then
     call error_mesg('ocean_blob_diag_mod, ocean_blob_diag_init, ',&
          'error opening blob diagnostic table: '//trim(diag_table), FATAL)
  endif

  write(stdoutunit,'(a)') 'Will write the following optional blob diagnostics:'
  m=0
  fileread: do
     read(unit=1, fmt=*, iostat=ioun) varname
     if (ioun>0) then
        ! there was an error: raise a warning but continue reading the file
        call error_mesg('ocean_blob_diag_mod, ocean_blob_diag_init, ',&
             'error reading blob diagnostic table: returned error '&
             //char(ioun)//' for variable '//trim(varname), WARNING)
        cycle fileread
     elseif (ioun<0) then
        ! end of the file: exit the loop
        exit fileread
     else
        ! line read ok: keep going
        write(stdoutunit,'(a)') trim(varname)
     endif
     m=m+1
     validvar=.false.

     if(trim(varname)=='entry')    validvar=.true.
     if(trim(varname)=='type')     validvar=.true.
     if(trim(varname)=='hash')     validvar=.true.
     if(trim(varname)=='number')   validvar=.true.
     if(trim(varname)=='time')     validvar=.true.
     if(trim(varname)=='lat')      validvar=.true.
     if(trim(varname)=='lon')      validvar=.true.
     if(trim(varname)=='geodepth') validvar=.true.
     if(trim(varname)=='i') then
        usei=.true.
        validvar=.true.
     endif
     if(trim(varname)=='j') then
        usej=.true.
        validvar=.true.
     endif
     if(trim(varname)=='k') then
        usek=.true.
        validvar=.true.
     endif
     if(trim(varname)=='depth') then
        usedepth=.true.
        validvar=.true.
     endif
     if(trim(varname)=='st') then
        usest=.true.
        validvar=.true.
     endif
     if(trim(varname)=='mass') then
        usemass=.true.
        validvar=.true.
     endif
     if(trim(varname)=='density') then
        usedensity=.true.
        validvar=.true.
     endif
     if(trim(varname)=='ent') then
        useent=.true.
        validvar=.true.
     endif
     if(trim(varname)=='det') then
        usedet=.true.
        validvar=.true.
     endif
     if(trim(varname)=='richardson') then
        userichardson = .true.
        validvar=.true.
     endif
     if(trim(varname)=='gprime') then
        usegprime=.true.
        validvar=.true.
     endif
     if(trim(varname)=='volume') then
        usevolume=.true.
        validvar=.true.
     endif
     if(trim(varname)=='u') then
        useu=.true.
        validvar=.true.
     endif
     if(trim(varname)=='v') then
        usev=.true.
        validvar=.true.
     endif
     if(trim(varname)=='w') then
        usew=.true.
        validvar=.true.
     endif
     if(trim(varname)=='blob_age') then
        useage=.true.
        validvar=.true.
     endif
     do n=1,num_prog_tracers
        if (n==index_temp) then
           if(trim(varname)=='heat') then
              usetracer(n)=.true.
              validvar=.true.
           endif
        else
           if(trim(varname)==trim(T_prog(n)%name)//'_cont') then
              usetracer(n)=.true.
              validvar=.true.
           endif
        endif
        if(trim(varname)==trim(T_prog(n)%name)) then
           usefield(n)=.true.
           validvar=.true.
        endif
     enddo
     if (.not.validvar) call error_mesg('ocean_blob_diag_mod, ocean_blob_diag_init, ', & 
          trim(varname)//' is not a recognised blob diagnostic field', WARNING)
  enddo fileread

  close(unit=1) 
  if(m==0) call error_mesg('ocean_blob_diag_mod, ocean_blob_diag_init, ',&
       'blob diagnostics table '//trim(diag_table)//' is empty', WARNING)

  write(filename, '("ocean_blobs.nc.",i4.4)') mpp_pe()

  call create_netcdf_file(filename, rootid, .false.)

  ! Write the maximum number of hash numbers
  isc=Domain%isc; iec=Domain%iec; jsc=Domain%jsc; jec=Domain%jec
  nk = Grid%nk
  maxhash = 0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           if (Grid%tmask(i,j,k) > 0.) maxhash = maxhash + 1
        enddo
     enddo
  enddo
  retval = nf_put_att_int(rootid, NF_GLOBAL, 'nhash', NF_INT, 1, maxhash)
  if (retval/=NF_NOERR) call handle_error(retval, 'blob_diag_init, nhash, nf_put_att_int')

  ! Define the dimensions
  retval = nf_def_dim(rootid, 'entry', NF_UNLIMITED, blobdim)
  if (retval/=NF_NOERR) call handle_error(retval, 'blob_diag_init, entry nf_def_dim')

  ! Define the variables
  entryid    = def_var(rootid, 'entry',    NF_INT,    blobdim)
  typeid     = def_var(rootid, 'type',     NF_INT,    blobdim)
  hashid     = def_var(rootid, 'hash',     NF_INT,    blobdim)
  numberid   = def_var(rootid, 'number',   NF_INT,    blobdim)
  timeid     = def_var(rootid, 'time',     NF_DOUBLE, blobdim)
  latid      = def_var(rootid, 'lat',      NF_DOUBLE, blobdim)
  lonid      = def_var(rootid, 'lon',      NF_DOUBLE, blobdim)
  geodepthid = def_var(rootid, 'geodepth', NF_DOUBLE, blobdim)

  call put_att(rootid, entryid,    'name',     'entry number')
  call put_att(rootid, typeid,     'name',     'blob type')
  call put_att(rootid, hashid,     'name',     'blob hash')
  call put_att(rootid, numberid,   'name',     'blob number')
  call put_att(rootid, timeid,     'name',     'time')
  call put_att(rootid, timeid,     'units',    'days')
  call put_att(rootid, latid,      'name',     'blob latitude')
  call put_att(rootid, latid,      'units',    'degrees N')
  call put_att(rootid, lonid,      'name',     'blob longitude')
  call put_att(rootid, lonid,      'units',    'degrees E')
  call put_att(rootid, geodepthid, 'name',     'blob depth relative to z=0')
  call put_att(rootid, geodepthid, 'units',    'm')
  call put_att(rootid, geodepthid, 'positive', 'up')
  
  if (usei) then
     iid = def_var(rootid, 'i', NF_INT, blobdim)
     call put_att(rootid, iid, 'name', 'zonal grid cell number')
  endif

  if (usej) then
     jid = def_var(rootid, 'j', NF_INT, blobdim)
     call put_att(rootid, jid, 'name', 'meridional grid cell number')
  endif

  if (usek) then
     kid = def_var(rootid, 'k', NF_INT, blobdim)
     call put_att(rootid, kid, 'name', 'vertical grid cell number')
  endif

  if (usedepth) then
     depthid = def_var(rootid, 'depth', NF_DOUBLE, blobdim)
     call put_att(rootid, depthid, 'name',     'blob depth relative to free surface')
     call put_att(rootid, depthid, 'units',    'm')
     call put_att(rootid, depthid, 'positive', 'up')
  endif

  if (usest) then
     stid = def_var(rootid, 'st', NF_DOUBLE, blobdim)
     call put_att(rootid, stid, 'name', 'vertical position in native coordiante')
  endif

  if (usemass) then
     massid = def_var(rootid, 'mass', NF_DOUBLE, blobdim)
     call put_att(rootid, massid, 'name',  'blob mass')
     call put_att(rootid, massid, 'units', 'kg')
  endif

  if (useent) then
     entid = def_var(rootid, 'ent', NF_DOUBLE, blobdim)
     call put_att(rootid, entid, 'name', 'blob entrainment velocity')
     call put_att(rootid, entid, 'units', 'm/s')
  endif

  if (usedet) then
     detid = def_var(rootid, 'det', NF_DOUBLE, blobdim)
     call put_att(rootid, detid, 'name', 'blob detrainment velocity')
     call put_att(rootid, detid, 'units', 'm/s')
  endif

  if (userichardson) then
     richardsonid = def_var(rootid, 'richardson', NF_DOUBLE, blobdim)
     call put_att(rootid, richardsonid, 'name', 'blob Richardson number')
     call put_att(rootid, richardsonid, 'units', 'dimensionless')
  endif

  if (usedensity) then
     densityid = def_var(rootid, 'density', NF_DOUBLE, blobdim)
     call put_att(rootid, densityid, 'name',  'blob density')
     call put_att(rootid, densityid, 'units', 'kg/m^3')
  endif

  if (usegprime) then
     gprimeid = def_var(rootid, 'gprime', NF_DOUBLE, blobdim)
     call put_att(rootid, gprimeid, 'name',  'blob reduced gravity')
     call put_att(rootid, gprimeid, 'units', 'm/s^2')
  endif

  if (usevolume) then
     volumeid = def_var(rootid, 'volume', NF_DOUBLE, blobdim)
     call put_att(rootid, volumeid, 'name',  'blob volume')
     call put_att(rootid, volumeid, 'units', 'm^3')
  endif

  if (useu) then
     uid = def_var(rootid, 'u', NF_DOUBLE, blobdim)
     call put_att(rootid, uid, 'name',  'blob zonal velocity')
     call put_att(rootid, uid, 'units', 'm/s')
  endif

  if (usev) then
     vid = def_var(rootid, 'v', NF_DOUBLE, blobdim)
     call put_att(rootid, vid, 'name',  'blob meridional velocity')
     call put_att(rootid, vid, 'units', 'm/s')
  endif

  if (usew) then
     wid = def_var(rootid, 'w', NF_DOUBLE, blobdim)
     call put_att(rootid, wid, 'name',  'blob vertical velocity')
     call put_att(rootid, wid, 'units', 'm/s')
  endif

  if(useage) then
     ageid = def_var(rootid, 'blob_age', NF_DOUBLE, blobdim)
     call put_att(rootid, ageid, 'name', 'blob age')
     call put_att(rootid, ageid, 'units', 'yr')
  endif

  do n=1,num_prog_tracers
     if (usetracer(n)) then
        if(n==index_temp) then
           tracerid(n) = def_var(rootid, 'heat', NF_DOUBLE, blobdim)
           call put_att(rootid, tracerid(n), 'name',  'blob heat content')
           call put_att(rootid, tracerid(n), 'units', 'J')
        else
           tracerid(n) = def_var(rootid, trim(T_prog(n)%name)//'_cont', NF_DOUBLE, blobdim)
           call put_att(rootid, tracerid(n), 'name',  'blob '//trim(T_prog(n)%name)//' content')
           call put_att(rootid, tracerid(n), 'units', 'kg')
        endif
     endif
     
     if (usefield(n)) then
        fieldid(n) = def_var(rootid, trim(T_prog(n)%name), NF_DOUBLE, blobdim)
        if(n==index_temp) then
           call put_att(rootid, fieldid(n), 'name', trim(T_prog(n)%name))
           call put_att(rootid, fieldid(n), 'units', 'C')
        else
           call put_att(rootid, fieldid(n), 'name',  'blob '//trim(T_prog(n)%name)//' concentration')
           call put_att(rootid, fieldid(n), 'units', 'kg/kg')
        endif
     endif
     
  enddo

  call close_netcdf_file(rootid)

  nblobs = 0
  length = 0

end subroutine blob_diag_init
! </SUBROUTINE> NAME="ocean_blob_diag_init"

!######################################################################
! <SUBROUTINE NAME="blob_diag">
!
! <DESCRIPTION>
! Accummulates the blob diagnostics by creating a linked list of
! diagnostic blobs.  The blobs are kept in the linked list until
! there are more than dump_num of them.  Then, they are written
! (using write_blobs), and erased from memory.
! </DESCRIPTION>
!
subroutine blob_diag(Time, head, T_prog, blob_type)
  type(ocean_time_type),        intent(in) :: Time
  type(ocean_blob_type),        pointer    :: head
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer,                      intent(in) :: blob_type

  type(ocean_blob_type), pointer :: this=>NULL()
  type(diag_blob_type), pointer  :: blob=>NULL()
  integer :: n, lenflag
  real :: day
  
  if (.not. blob_diagnostics) return

  if (mod(Time%itt,frequency) /= 0) return

  day = real(Time%itt0)*dtime/86400.
  lenflag = 0

  if(associated(head)) then
     this=>head
     blobcycle : do
        
        allocate(blob)
        allocate(blob%tracer(num_prog_tracers))
        allocate(blob%field(num_prog_tracers))

        blob%type     = blob_type
        blob%hash     = this%hash
        blob%number   = this%number
        blob%time     = day
        blob%lat      = this%lat
        blob%lon      = this%lon
        blob%geodepth = this%geodepth
        blob%i        = this%i
        blob%j        = this%j
        blob%k        = this%k
        blob%depth    = this%depth
        blob%st       = this%st
        blob%mass     = this%mass
        blob%density  = this%density
        blob%ent      = this%ent
        blob%det      = this%det
        blob%richardson=this%richardson
        blob%gprime   = this%gprime
        blob%volume   = this%volume
        blob%u        = this%v(1)
        blob%v        = this%v(2)
        blob%w        = this%v(3)
        blob%age      = this%age
        do n=1,num_prog_tracers
           blob%tracer(n)  = this%tracer(n)
           blob%field(n)   = this%field(n)
        enddo

        if(associated(diag_head)) then
           blob%next => diag_head
        else
           blob%next => NULL()
        endif
        diag_head => blob
        nullify(blob)

        length = length + 1

        this=>this%next
        if (.not.associated(this)) exit blobcycle
     enddo blobcycle
  endif
  
  ! So that we don't use too much memory, if any PE has more blobs
  ! than dump_num, we write all the diagnostic blobs (on all pes)
  ! and deallocate them from memory, and then start afresh with an 
  ! empty list.
  if(length>dump_num) lenflag = 1

  call mpp_sum(lenflag)
  if(lenflag>0) then
     call write_blobs(T_prog(:))
     length = 0
  endif

end subroutine blob_diag
! </SUBROUTINE> NAME="ocean_blob_diag_init"

!######################################################################
! <FUNCTION NAME="varid">
!
! <DESCRIPTION>
! Reads the variable id of a netcdf file.
! </DESCRIPTION>
!
integer function varid(rootid, name)
  integer,          intent(in)  :: rootid
  character(len=*), intent(in)  :: name

  integer :: retval

  retval = nf_inq_varid(rootid, trim(name), varid)
  if(retval/=NF_NOERR) then 
     call handle_error(retval, 'varid, '//trim(name)//' nf_inq_varid')
  endif

end function varid
! </FUNCTION> NAME="varid"


!######################################################################
! <SUBROUTINE NAME="blob_diag_end">
!
! <DESCRIPTION>
! </DESCRIPTION>
!
subroutine blob_diag_end(T_prog)
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  
  if (.not. blob_diagnostics) return

  call write_blobs(T_prog(:))

end subroutine blob_diag_end
! </SUBROUTINE> NAME="ocean_blob_diag_end"

!######################################################################
! <SUBROUTINE NAME="write_blobs">
!
! <DESCRIPTION>
! Write the diagnostics of individual blobs.
! </DESCRIPTION>
!
subroutine write_blobs(T_prog)
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)

  type(diag_blob_type), pointer :: prev=>NULL()
  type(diag_blob_type), pointer :: blob=>NULL()
  integer :: n
  integer :: rootid, retval
  integer :: entryid, typeid, hashid, numberid, timeid
  integer :: latid, lonid, geodepthid
  integer :: iid, jid, kid
  integer :: depthid, stid, massid, volumeid, densityid, gprimeid
  integer :: entid, detid, richardsonid
  integer :: uid, vid, wid, ageid
  integer :: tracerid(num_prog_tracers)
  integer :: fieldid(num_prog_tracers)

  call open_netcdf_file(filename, rootid)
  
  retval = nf_inq_dimid(rootid, 'entry', entryid)
  if(retval/=NF_NOERR) call handle_error(retval, 'blob_diag, entry nf_inq_dimid')
  
  typeid     = varid(rootid, 'type')
  hashid     = varid(rootid, 'hash')
  numberid   = varid(rootid, 'number')
  timeid     = varid(rootid, 'time')
  latid      = varid(rootid, 'lat')
  lonid      = varid(rootid, 'lon')
  geodepthid = varid(rootid, 'geodepth')
  if (usei)       iid       = varid(rootid, 'i')
  if (usej)       jid       = varid(rootid, 'j')
  if (usek)       kid       = varid(rootid, 'k')
  if (usedepth)   depthid   = varid(rootid, 'depth')
  if (usest)      stid      = varid(rootid, 'st')
  if (usemass)    massid    = varid(rootid, 'mass')
  if (usedensity) densityid = varid(rootid, 'density')
  if (useent)     entid     = varid(rootid, 'ent')
  if (usedet)     detid     = varid(rootid, 'det')
  if (userichardson) richardsonid = varid(rootid, 'richardson')
  if (usegprime)  gprimeid  = varid(rootid, 'gprime')
  if (usevolume)  volumeid  = varid(rootid, 'volume')
  if (useu)       uid       = varid(rootid, 'u')
  if (usev)       vid       = varid(rootid, 'v')
  if (usew)       wid       = varid(rootid, 'w')
  if (useage)     ageid     = varid(rootid, 'blob_age')
  do n=1,num_prog_tracers
     if (n==index_temp) then
        if (usetracer(n))  tracerid(n)  = varid(rootid, 'heat')
     else
        if (usetracer(n))  tracerid(n)  = varid(rootid, trim(T_prog(n)%name)//'_cont')
     endif
     if (usefield(n)) fieldid(n) = varid(rootid, trim(T_prog(n)%name))
  enddo
  
  if (associated(diag_head)) then
     blob=>diag_head
     blobcycle: do
        nblobs=nblobs+1
        call put_int(   rootid, entryid,    nblobs, nblobs)
        call put_int(   rootid, typeid,     nblobs, blob%type)
        call put_int(   rootid, hashid,     nblobs, blob%hash)
        call put_int(   rootid, numberid,   nblobs, blob%number)
        call put_double(rootid, timeid,     nblobs, blob%time)
        call put_double(rootid, latid,      nblobs, blob%lat)
        call put_double(rootid, lonid,      nblobs, blob%lon)
        call put_double(rootid, geodepthid, nblobs, blob%geodepth)
        if (usest) then
           if (vert_coordinate_class==DEPTH_BASED) then
              call put_double(rootid, stid, nblobs, blob%st)
           else
              call put_double(rootid, stid, nblobs, blob%st*c2dbars)
           endif
        endif
        if (usei)       call put_int(   rootid, iid,        nblobs, blob%i)
        if (usej)       call put_int(   rootid, jid,        nblobs, blob%j)
        if (usek)       call put_int(   rootid, kid,        nblobs, blob%k)
        if (usedepth)   call put_double(rootid, depthid,    nblobs, blob%depth)
        if (usemass)    call put_double(rootid, massid,     nblobs, blob%mass)
        if (usedensity) call put_double(rootid, densityid,  nblobs, blob%density)
        if (useent)     call put_double(rootid, entid,      nblobs, blob%ent)
        if (usedet)     call put_double(rootid, detid,      nblobs, blob%det)
        if (userichardson) call put_double(rootid, richardsonid, nblobs, blob%richardson)
        if (usegprime)  call put_double(rootid, gprimeid,   nblobs, blob%gprime)
        if (usevolume)  call put_double(rootid, volumeid,   nblobs, blob%volume)
        if (useu)       call put_double(rootid, uid,        nblobs, blob%u)
        if (usev)       call put_double(rootid, vid,        nblobs, blob%v)
        if (usew)       call put_double(rootid, wid,        nblobs, blob%w)
        if (useage)     call put_double(rootid, ageid,      nblobs, blob%age)
        do n=1,num_prog_tracers
           if (usetracer(n))  call put_double(rootid, tracerid(n),  nblobs, blob%tracer(n))
           if (usefield(n))   call put_double(rootid, fieldid(n),   nblobs, blob%field(n))
        enddo

        prev=>blob
        blob=>blob%next
        if(allocated(prev%tracer))  deallocate(prev%tracer)
        if(allocated(prev%field))   deallocate(prev%field)
        deallocate(prev)
        nullify(prev)
        if(.not.associated(blob)) exit blobcycle
     enddo blobcycle
     nullify(diag_head)
  endif

  call close_netcdf_file(rootid)

end subroutine write_blobs
! </SUBROUTINE> NAME="write_blobs"


!######################################################################
! <SUBROUTINE NAME="handle_error">
!
! <DESCRIPTION>
! Handles any errors from the reading/writing of netcdf files.  It
! should (hopefully) provide some sort of useful idea of what went 
! wrong.
! </DESCRIPTION>
!
subroutine handle_error(retval, operation)
  integer,          intent(in) :: retval
  character(len=*), intent(in) :: operation
  
  print '(a,i3)', 'ocean_blob_diag_mod, '&
       //trim(operation)//': failed with error number ', retval
  if(retval==nf_emaxname)   print *, '==> NF_MAX_NAME exceeded'
  if(retval==nf_enameinuse) print *, '==> Name already in use'
  if(retval==nf_ebadname)   print *, '==> Attribute or variable name contains illegal characters'
  if(retval==nf_ebadid)     print *, '==> Invalid ncid'
  if(retval==nf_einval)     print *, '==> Size is invalid'
  if(retval==nf_enomem)     print *, '==> Out of memory'
  if(retval==nf_ebadtype)   print *, '==> Cannot find the type id'
  if(retval==nf_ebaddim)    print *, '==> Bad dimension id'
  if(retval==nf_enotvar)    print *, '==> Variable not found'
  
  call error_mesg('ocean_blob_diag_mod, '//trim(operation), &
       ' netcdf function returned a failure!', FATAL)

end subroutine handle_error
! </SUBROUTINE> NAME="handle_error"

!######################################################################
! <SUBROUTINE NAME="create_netcdf_file">
!
! <DESCRIPTION>
! Creates a new netcdf file.
! </DESCRIPTION>
!
subroutine create_netcdf_file(filename, fileid, parallel)
  character(len=31), intent(in)  :: filename
  integer,           intent(out) :: fileid
  logical,           intent(in)  :: parallel
  integer :: mret
  integer :: stderrunit

  stderrunit = stderr()

  if (parallel) then
     call error_mesg('ocean_blob_diag_mod: ', 'Parallel access not supported!', FATAL)
  else
     mret = nf_create(filename, NF_CLOBBER, fileid)
  endif
  if (mret .ne. NF_NOERR) then
     write(stderrunit, '(/,a)') 'ocean_blob_diag_mod, create_netcdf_file: NF_CREATE failed'
     call error_mesg('ocean_blob_diag_mod,  create_netcdf_file', &
          'netcdf function NF_CREATE returned a failure!', FATAL)
  endif
end subroutine create_netcdf_file
! </SUBROUTINE> NAME="create_netcdf_file"


!######################################################################
! <SUBROUTINE NAME="open_netcdf_file">
!
! <DESCRIPTION>
! Opens an existing netcdf file.
! </DESCRIPTION>
!
subroutine open_netcdf_file(filename, fileid)
  character(len=31), intent(in)    :: filename
  integer,           intent(inout) :: fileid
  integer :: mret
  integer :: stderrunit

  stderrunit = stderr()

  mret = nf_open(filename, NF_WRITE, fileid)
  if (mret .ne. NF_NOERR) then
     write(stderrunit, '(/,a)') 'ocean_blob_diag_mod, open_netcdf_file: NF_OPEN failed'
     call error_mesg('ocean_blob_diag_mod, open_netcdf_file', &
          'netcdf function NF_OPEN returned a failure!', FATAL)
  endif
end subroutine open_netcdf_file
! </SUBROUTINE> NAME="open_netcdf_file"


!######################################################################
! <SUBROUTINE NAME="close_netcdf_file">
!
! <DESCRIPTION>
! Closes an existing netcdf file.
! </DESCRIPTION>
!
subroutine close_netcdf_file(fileid)
  integer, intent(inout) :: fileid
  integer :: mret
  integer :: stderrunit

  stderrunit = stderr()

  mret = nf_close(fileid)
  if (mret .ne. NF_NOERR) then
     write(stderrunit, '(/,a)') 'ocean_blob_diag_mod, close_netcdf_file: NF_CLOSE failed'
     call error_mesg('ocean_blob_diag_mod,  close_netcdf_file', &
          'netcdf function NF_CLOSE returned a failure!', FATAL)
  endif
end subroutine close_netcdf_file
! </SUBROUTINE> NAME="close_netcdf_file"


end module ocean_blob_diag_mod

#include <fms_platform.h>

module ocean_residency_range_mod  !{
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies 
!</REVIEWER>
!
!<OVERVIEW>
! Ocean age tracer module
!</OVERVIEW>
!
!<DESCRIPTION>
!       This module handles the case where the specified region is determined
!       from a range of another tracer. Any tracer, either prognostic or
!       diagnostic, may be used. The tracer field, mutiplied by an optional
!       scaling factor, will be multiplied by the current value in residency
!       mask array.
!
!       To use this module, in the field table namelist, you must do the following:
!
!       1) set "module_name" to "ocean_residency_range"
!       2) "strings" should have two values, the first is "tracer_range", and the
!          second to the name of a prognostic or diagnostic variable
!       3) set "params" to pairs of points defining the range of the variable
!          to select. For each pair of values, the first value must be less than
!          the second value. The grid cells will satisfy the union of all of the
!          grid cells which satisfy
!               "low value" < "cell value" <= "high value"
!          for at least one pair of points
!       4) no "flags" should be set
!
!       Any prognostic or diagnostic variable may be used. If you wish to allow
!       another variable to be used, you can just create a diagnostic variable
!       for it.
!
!       For an overview of the ocean residency modules, see ocean_residency.F90.
!
!</DESCRIPTION>
!
! $Id: ocean_residency_range.F90,v 20.0 2013/12/14 00:17:12 fms Exp $
!

!
!       modules
!

use field_manager_mod,   only: fm_field_name_len
use field_manager_mod,   only: fm_get_index
use mpp_mod,             only: stdout, mpp_error, FATAL

use ocean_residency_meta_mod, only: ocean_residency_get_instances
use ocean_residency_meta_mod, only: ocean_residency_instance_type
use ocean_residency_meta_mod, only: ocean_residency_set_region_3d

use ocean_types_mod,     only: ocean_prog_tracer_type, ocean_diag_tracer_type

!
!       force all variables to be "typed"
!

implicit none

!
!       Set all variables to be private by default

private

!
!       Public routines
!

public  :: ocean_residency_range_source
public  :: ocean_residency_range_start

!
!       Private routines
!

!
!       Public parameters
!


!
!       Private parameters
!

character(len=fm_field_name_len), parameter     :: package_name = 'ocean_residency_range'
character(len=48), parameter                    :: mod_name = 'ocean_residency_range_mod'

!
!       Public variables
!

logical, public :: do_ocean_residency_range

!
!       Private types
!

type, private                                                   :: instance_extra_region_type
  integer                                                       :: tracer_index = 0
  logical                                                       :: is_prog_tracer = .true.
end type instance_extra_region_type

type, private                                                   :: instance_extra_type
  type(instance_extra_region_type), dimension(:), _ALLOCATABLE  :: region  _NULL
end type instance_extra_type

!
!       Private variables
!

type(instance_extra_type), dimension(:), allocatable            :: instance_extra
type(ocean_residency_instance_type), dimension(:), pointer      :: instance
integer                                                         :: num_instances = 0

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_residency_range_source">
!
! <DESCRIPTION>
!       Calculate the mask for the tracer range(s)
!
!       Arguments:
!
!         Input:
!
!              isd:  low dimension of first index
!              ied:  high dimension of first index
!              jsd:  low dimension of second index
!              jed:  high dimension of second index
!               nk:  dimension of third index
!            taum1:  tau-1 time level index
!           T_prog:  array of ocean prognostic types
!           T_diag:  array of ocean diagnostic types
!         grid_kmt:  indices of the bottom grid cell
! </DESCRIPTION>
!

subroutine ocean_residency_range_source(isd, ied, jsd, jed, nk, taum1, T_prog, T_diag, grid_kmt)  !{

!
!       modules
!

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
integer, intent(in)                                             :: nk
integer, intent(in)                                             :: taum1
type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
type(ocean_diag_tracer_type), dimension(:), intent(inout)       :: T_diag
integer, dimension(isd:,jsd:), intent(in)                       :: grid_kmt

!
!       local parameters
!

!
!       local variables
!

integer :: n
integer :: nn

!
!       set the source values for the residency tracers
!

do n = 1, num_instances  !{

  do nn = 1, instance(n)%num_regions  !{

    if (instance_extra(n)%region(nn)%tracer_index .ne. 0) then  !{

      if (instance_extra(n)%region(nn)%is_prog_tracer) then  !{
        call ocean_residency_set_region_3d(isd, ied, jsd, jed, nk, instance(n)%region(nn)%mask, &
             t_prog(instance_extra(n)%region(nn)%tracer_index)%field(:,:,:,taum1),              &
             instance(n)%region(nn)%params, grid_kmt,                                           &
             restore_region_value = 1.0, integrate_region_value = 0.0,                          &
             swap = instance(n)%region(nn)%swap_module)
      else  !}{
        call ocean_residency_set_region_3d(isd, ied, jsd, jed, nk, instance(n)%region(nn)%mask, &
             t_diag(instance_extra(n)%region(nn)%tracer_index)%field,                           &
             instance(n)%region(nn)%params, grid_kmt,                                           &
             restore_region_value = 1.0, integrate_region_value = 0.0,                          &
             swap = instance(n)%region(nn)%swap_module)
      endif  !}

    endif  !}

  enddo  !} nn

enddo  !} n

return

end subroutine ocean_residency_range_source   !}
! </SUBROUTINE> NAME="ocean_residency_range_source"


!#######################################################################
! <SUBROUTINE NAME="ocean_residency_range_start">
!
! <DESCRIPTION>
!       Start the ocean residency tracer range package
!
! </DESCRIPTION>
!
subroutine ocean_residency_range_start  !{

!
!       modules
!

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!


!
!       local parameters
!

character(len=64), parameter    :: sub_name = 'ocean_residency_range_start'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!       local variables
!

integer :: i
integer :: n
integer :: nn

  integer :: stdoutunit 
  stdoutunit=stdout() 

instance => ocean_residency_get_instances(package_name)

write (stdoutunit,*)
if (.not. associated(instance)) then  !{
  write (stdoutunit,*) trim(note_header), ' No instances'
  num_instances = 0
  do_ocean_residency_range = .false.
else  !}{
  num_instances = size(instance)
  if (num_instances .eq. 1) then  !{
    write (stdoutunit,*) trim(note_header), ' ', num_instances, ' instance'
  else  !}{
    write (stdoutunit,*) trim(note_header), ' ', num_instances, ' instances'
  endif  !}
  do_ocean_residency_range = .true.
endif  !}

!
!       return if no tracers
!

if (.not. do_ocean_residency_range) then
  return
endif

!
!       Allocate array for extra instance information
!

allocate( instance_extra(num_instances) )
do n = 1, num_instances  !{
  allocate( instance_extra(n)%region(instance(n)%num_regions) )
enddo  !} n

do n = 1, num_instances  !{

  do nn = 1, instance(n)%num_regions  !{

!
!       Only process items for this module
!

    if (instance(n)%region(nn)%module_name .eq. package_name) then  !{

!
!       Check that a type was given
!

      if (.not. associated(instance(n)%region(nn)%strings)) then  !{
        call mpp_error(FATAL, trim(error_header) // ' No strings set for ' // trim(instance(n)%name))
      endif  !}


!
!       Check the types
!

      if (instance(n)%region(nn)%strings(1) .eq. 'tracer_range') then  !{

!
!       tracer_range: works with a region defined as
!               params(1) < T_prog(strings(2)) <= params(2)
!       if swap_module is true, then the region is inverted
!

        if (size(instance(n)%region(nn)%strings) .ne. 2) then  !{
          call mpp_error(FATAL, trim(error_header) // ' Wrong number of strings set for ' //            &
               trim(instance(n)%name) // ' (' // trim(instance(n)%region(nn)%strings(1)) // ')')
        endif  !}

        if (.not. associated(instance(n)%region(nn)%params)) then  !{
          call mpp_error(FATAL, trim(error_header) // ' No params array set for ' //                    &
               trim(instance(n)%name) // ' (' // trim(instance(n)%region(nn)%strings(1)) // ')')
        elseif (mod(size(instance(n)%region(nn)%params),2) .ne. 0) then  !}{
          call mpp_error(FATAL, trim(error_header) // ' Odd number of params set for ' //               &
               trim(instance(n)%name) // ' (' // trim(instance(n)%region(nn)%strings(1)) // ')')
        else  !}{
          do i = 1, size(instance(n)%region(nn)%params), 2  !{
            if (instance(n)%region(nn)%params(i) .ge. instance(n)%region(nn)%params(i+1)) then  !{
              write (stdoutunit, *) trim(error_header), instance(n)%region(nn)%params(i), ' >= ',         &
                   instance(n)%region(nn)%params(i+1)
              call mpp_error(FATAL, trim(error_header) // ' Params not increasing for ' //              &
                   trim(instance(n)%name) // ' (' // trim(instance(n)%region(nn)%strings(1)) // ')')
            endif  !}
          enddo  !} i
        endif  !}

        if (associated(instance(n)%region(nn)%flags)) then  !{
          call mpp_error(FATAL, trim(error_header) // ' Flags set for ' // trim(instance(n)%name) //    &
               ' (' // trim(instance(n)%region(nn)%strings(1)) // ')')
        endif  !}

        instance_extra(n)%region(nn)%tracer_index = fm_get_index('/ocean_mod/prog_tracers/' //          &
             trim(instance(n)%region(nn)%strings(2)))
        if (instance_extra(n)%region(nn)%tracer_index .gt. 0) then  !{
          instance_extra(n)%region(nn)%is_prog_tracer = .true.
        else  !}{
          instance_extra(n)%region(nn)%tracer_index = fm_get_index('/ocean_mod/diag_tracers/' //        &
               trim(instance(n)%region(nn)%strings(2)))
          if (instance_extra(n)%region(nn)%tracer_index .gt. 0) then  !{
            instance_extra(n)%region(nn)%is_prog_tracer = .false.
          else  !}{
            call mpp_error(FATAL, trim(error_header) // ' Could not get the index for tracer "' //      &
                 trim(instance(n)%region(nn)%strings(2)))
          endif  !}
        endif  !}

      else  !}{

!
!       Unknown type
!

        call mpp_error(FATAL, trim(error_header) // ' Unrecognized type (' //                           &
             trim(instance(n)%region(nn)%strings(1)) // ') for ' // trim(instance(n)%name))

      endif  !}

    endif  !}

  enddo  !} nn

enddo  !} n

return

end subroutine ocean_residency_range_start  !}
! </SUBROUTINE> NAME="ocean_residency_range_start"

end module ocean_residency_range_mod  !}

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: Update dimensionless alpha's\label{sec:alpha}
!
! !INTERFACE:
   subroutine alpha_mnb(nlev,NN,SS)
!
! !DESCRIPTION:
! This subroutine updates the dimensionless numbers $\alpha_M$, $\alpha_N$,
! and $\alpha_b$ according to \eq{alphaMN}. Note that according to \eq{Nbar}
! and \eq{NbarVertical} the following identities are valid
! \begin{equation}
!  \label{alphaIdentities}
!    \alpha_M = \overline{S}^2 \comma
!    \alpha_N = \overline{N}^2 \comma
!    \alpha_b = \overline{T}   \point
! \end{equation}
!
!
! !USES:
  use turbulence,  only:     tke,eps,kb
  use turbulence,  only:     as,an,at
  IMPLICIT NONE
!
! !INPUT PARAMETERS:
  integer,  intent(in)      :: nlev
  REALTYPE, intent(in)      :: NN(0:nlev),SS(0:nlev)
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: alpha_mnb.F90,v $
!  Revision 20.0  2013/12/14 00:13:27  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.2  2006-03-20 09:06:37  kbk
!  removed explicit double precission dependency
!
!  Revision 1.1  2005/06/27 10:54:33  kbk
!  new files needed
!
!
!EOP
!-----------------------------------------------------------------------
! !LOCAL VARIABLES:
  integer              :: i
  REALTYPE             :: tau2

!-----------------------------------------------------------------------
!BOC

  do i=0,nlev
     tau2   = tke(i)*tke(i) / ( eps(i)*eps(i) )
     as(i)  = tau2 * SS(i)
     an(i)  = tau2 * NN(i)
     at(i)  = tke(i)/eps(i) * kb(i)/eps(i)

!    clip negative values
     as(i) = max(as(i),1.e-10*_ONE_)
     at(i) = max(at(i),1.e-10*_ONE_)
  end do

  return
end subroutine alpha_mnb

!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

                     MODULE RAD_DIAG_MOD

!-----------------------------------------------------------------------

!!!   USE   RDPARM_MOD, ONLY:  IMAX, LMAX, LP1, NBLW, NBLY, NBLM
      USE   RDPARM_MOD, ONLY:  LMAX, LP1, NBLW, NBLY, NBLM

      USE   HCONST_MOD, ONLY:  RADCON, RADCON1

      USE LONGWAVE_MOD, ONLY: OSOUR, CSOUR, SS1
      USE LONGWAVE_MOD, ONLY: FLX1E1, GXCTS, FCTSG
      USE LONGWAVE_MOD, ONLY: CLDFAC
      USE LONGWAVE_MOD, ONLY: DELP2, DELP
      USE LONGWAVE_MOD, ONLY: TO3, CO21, EMISS, EMISS2, CTS, EXCTS,  &
                              EXCTSN, E1FLX, CO2SP
      USE LONGWAVE_MOD, ONLY: IBAND, BANDLO, BANDHI

      Use       Fms_Mod, ONLY: write_version_number, mpp_pe, mpp_root_pe, &
                               error_mesg, FATAL


implicit none
private

!-----------------------------------------------------------------------
      character(len=128) :: version = '$Id: rad_diag.F90,v 10.0 2003/10/24 22:00:32 fms Exp $'
      character(len=128) :: tagname = '$Name: tikal $'
      logical            :: module_is_initialized = .false.

public RADIAG, RAD_DIAG_init, RAD_DIAG_end


      CONTAINS

!#######################################################################
!#######################################################################

      SUBROUTINE RADIAG  &
          ( PRESS,TEMP,RH2O,RRVCO2,QO3,CAMT,KTOP,KBTM,NCLDS,  &
            HEATRA,GRNFLX,  &
            FSW,DFSW,UFSW,HSW,  &
            KTOPSW,KBTMSW,EMCLD,CUVRF,CIRRF,CIRAB,  &
            SALB,COSZRO,SSOLAR,   ip,jp)

!-----------------------------------------------------------------------
      REAL,    INTENT(IN), DIMENSION(:,:,:) :: PRESS,TEMP,RH2O
      REAL,    INTENT(IN)                   :: RRVCO2
      REAL,    INTENT(IN), DIMENSION(:,:,:) :: QO3,CAMT
      INTEGER, INTENT(IN), DIMENSION(:,:,:) :: KTOP,KBTM
      INTEGER, INTENT(IN), DIMENSION(:,:)   :: NCLDS

      REAL,    INTENT(IN), DIMENSION(:,:,:) :: HEATRA
      REAL,    INTENT(IN), DIMENSION(:,:)   :: GRNFLX

      REAL,    INTENT(IN), DIMENSION(:,:,:) :: FSW,DFSW,UFSW,HSW

      INTEGER, INTENT(IN), DIMENSION(:,:,:) :: KTOPSW,KBTMSW
      REAL,    INTENT(IN), DIMENSION(:,:,:) :: EMCLD,CUVRF,CIRRF,CIRAB

      REAL,    INTENT(IN), DIMENSION(:,:)   :: SALB,COSZRO,SSOLAR
      INTEGER, INTENT(IN)                 :: ip,jp
!-----------------------------------------------------------------------

      CALL RADPRT (PRESS(ip,jp,:),TEMP(ip,jp,:),RH2O(ip,jp,:),RRVCO2,QO3(ip,jp,:), &
                   CAMT(ip,jp,:),KTOP(ip,jp,:),KBTM(ip,jp,:),NCLDS(ip,jp),         &
                   HEATRA(ip,jp,:),GRNFLX(ip,jp),  &
                   CTS(ip,:),EXCTS(ip,:),    &
                   EMISS(ip,:,:),CLDFAC(ip,:,:),E1FLX(ip,:),        &
                   DELP(ip,:),DELP2(ip,:),EMISS2(ip,:,:),           &
                   SS1(ip,:),TO3(ip,:,:),OSOUR(ip,:),CO21(ip,:,:),  &
                   CSOUR(ip,:),CO2SP(ip,:),     &
                   GXCTS(ip),FLX1E1(ip),        &
                   FCTSG(ip,:),EXCTSN(ip,:,:),  &
                   FSW(ip,jp,:),DFSW(ip,jp,:),UFSW(ip,jp,:),HSW(ip,jp,:),  &
                   KTOPSW(ip,jp,:),KBTMSW(ip,jp,:),EMCLD(ip,jp,:),      &
                   CUVRF(ip,jp,:),CIRRF(ip,jp,:),CIRAB(ip,jp,:),        &
                   SALB(ip,jp),COSZRO(ip,jp),SSOLAR(ip,jp),   ip,jp)

!-----------------------------------------------------------------------

      END SUBROUTINE RADIAG

!#######################################################################
!#######################################################################

      subroutine RAD_DIAG_init
!------- write version number and namelist ---------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
      endif

      module_is_initialized = .true.

!---------------------------------------------------------------------

      end subroutine RAD_DIAG_init

!#######################################################################
!#######################################################################

      subroutine RAD_DIAG_end

      module_is_initialized = .false.

!---------------------------------------------------------------------

      end subroutine RAD_DIAG_end
!#######################################################################
!#######################################################################

      SUBROUTINE RADPRT (PRESS,TEMP,RH2O,RRVCO2,QO3,  &
                         CAMT,KTOP,KBTM,NCLDS,        &
                         HEATRA,GRNFLX,  &
                         CTS,EXCTS,      &
                         EMISS,CLDFAC,E1FLX,DELP,DELP2,          &
                         EMISS2,SS1,TO3,OSOUR,CO21,CSOUR,CO2SP,  &
                         GXCTS,FLX1E1,       &
                         FCTSG,EXCTSN,       &
                         FSW,DFSW,UFSW,HSW,  &
                         KTOPSW,KBTMSW,EMCLD,CUVRF,CIRRF,CIRAB,  &
                         SALB,COSZRO,SSOLAR,              &
                         IP,JP)

      IMPLICIT NONE
!-----------------------------------------------------------------------
!      Subroutine RADPRT prints out all diagnostic quantities
!      required for diagnosos of radiation quantities.
!-----------------------------------------------------------------------
      REAL,    INTENT(IN), DIMENSION(:) :: PRESS,TEMP,RH2O
      REAL,    INTENT(IN)               :: RRVCO2
      REAL,    INTENT(IN), DIMENSION(:) :: QO3,CAMT
      INTEGER, INTENT(IN), DIMENSION(:) :: KTOP,KBTM
      INTEGER, INTENT(IN)               :: NCLDS

      REAL,    INTENT(IN), DIMENSION(:) :: HEATRA
      REAL,    INTENT(IN)               :: GRNFLX

      REAL,    INTENT(IN), DIMENSION(:)   :: CTS,EXCTS,E1FLX,DELP,DELP2
      REAL,    INTENT(IN), DIMENSION(:,:) :: EMISS,CLDFAC,EMISS2,TO3
      REAL,    INTENT(IN), DIMENSION(:,:) :: CO21
      REAL,    INTENT(IN), DIMENSION(:)   :: SS1,OSOUR,CSOUR,CO2SP

      REAL,    INTENT(IN)                 :: GXCTS,FLX1E1
      REAL,    INTENT(INOUT), DIMENSION(:)   :: FCTSG
      REAL,    INTENT(INOUT), DIMENSION(:,:) :: EXCTSN

      REAL,    INTENT(IN), DIMENSION(:) :: FSW,DFSW,UFSW,HSW

      INTEGER, INTENT(IN), DIMENSION(:) :: KTOPSW,KBTMSW
      REAL,    INTENT(IN), DIMENSION(:) :: EMCLD,CUVRF,CIRRF,CIRAB

      REAL,    INTENT(IN)                 :: SALB,COSZRO,SSOLAR
      INTEGER, INTENT(IN)                 :: IP,JP
!-----------------------------------------------------------------------
!    ----- DIMENSION FOR LOCAL VARIABLES -----

      REAL  VSUM1(LP1),SUM(LP1),FLXDG(LP1),HTEM(LMAX),HTEM1(LMAX),  &
            HTEM2(LMAX),HTEM3(LMAX),HTEM4(LMAX),FLXNET(LP1),  &
            FTOPN(NBLY),FTOPAC(NBLY),VSUMAC(NBLY),PFLUX(LP1),  &
            CTS1(LMAX),CTS2(LMAX),CTST(LMAX),  &
            OSS(LP1),CSS(LP1),TC(LP1),DTC(LP1),SS2(LP1),  &
            HLWSW(LMAX),FLWSW(LP1),  &
            FSWD(LP1),DFSWD(LP1),UFSWD(LP1)
!-----------------------------------------------------------------------
      INTEGER  K,KP,N,NX,NY,NPRT
      REAL     FTOPC,FTOPE,FTOP,FGRD,FDIFF,SOLARW,QSUM
!-----------------------------------------------------------------------
!****COMPUTE LOCAL VARIABLES TC,DTC,OSS,CSS,SS2

      DO K=1,LP1
         TC(K)=TEMP(K)*TEMP(K)*TEMP(K)*TEMP(K)
      ENDDO

      DO K=2,LP1
         DTC(K)=TC(K)-TC(K-1)
         SS2(K)=SS1(K)-SS1(K-1)
         CSS(K)=CSOUR(K)-CSOUR(K-1)
         OSS(K)=OSOUR(K)-OSOUR(K-1)
      ENDDO

!***HTEM1 = EMISSIVITY HEATING RATE FOR 0-160,1200-2200 CM-1 BAND

      DO K=1,LP1
         SUM(K)=0.
         DO KP=1,LMAX
            VSUM1(KP)=DTC(KP+1)*EMISS(KP+1,K)*CLDFAC(KP+1,K)
         ENDDO
         DO KP=1,LMAX
            SUM(K)=SUM(K)+VSUM1(KP)
         ENDDO
      ENDDO

      DO K=1,LP1
         FLXDG(K)=SUM(K)+TC(1)*E1FLX(K)*CLDFAC(K,1)
      ENDDO

      DO K=1,LMAX
         HTEM1(K)=RADCON*(FLXDG(K+1)-FLXDG(K))*DELP(K)
      ENDDO

!***HTEM2 = EMISSIVITY HEATING RATE FOR 800-990,1070-1200 CM-1 BAND

      DO K=1,LP1
         SUM(K)=0.
         DO KP=1,LMAX
            VSUM1(KP)=SS2(KP+1)*EMISS2(KP+1,K)*CLDFAC(KP+1,K)
         ENDDO
         DO KP=1,LMAX
            SUM(K)=SUM(K)+VSUM1(KP)
         ENDDO
      ENDDO

      DO K=1,LP1
         FLXDG(K)=SUM(K)+SS1(1)*EMISS2(K,1)*CLDFAC(K,1)
      ENDDO

      DO K=1,LMAX
         HTEM2(K)=RADCON*(FLXDG(K+1)-FLXDG(K))*DELP(K)
      ENDDO

!***HTEM3 = EMISSIVITY HEATING RATE FOR 990-1070 CM-1 BAND

      DO K=1,LP1
         SUM(K)=0.
         DO KP=1,LMAX
            VSUM1(KP)=OSS(KP+1)*TO3(KP+1,K)*CLDFAC(KP+1,K)
         ENDDO
         DO KP=1,LMAX
            SUM(K)=SUM(K)+VSUM1(KP)
         ENDDO
      ENDDO

      DO K=1,LP1
         FLXDG(K)=SUM(K)+OSOUR(1)*TO3(K,1)*CLDFAC(K,1)
      ENDDO

      DO K=1,LMAX
         HTEM3(K)=RADCON*(FLXDG(K+1)-FLXDG(K))*DELP(K)
      ENDDO

!***HTEM4 = EMISSIVITY HEATING RATE FOR 560-800 CM-1 BAND

      DO K=1,LP1
         SUM(K)=0.
         DO KP=1,LMAX
            VSUM1(KP)=CSS(KP+1)*CO21(KP+1,K)*CLDFAC(KP+1,K)
         ENDDO
         DO KP=1,LMAX
            SUM(K)=SUM(K)+VSUM1(KP)
         ENDDO
      ENDDO

      DO K=1,LP1
         FLXDG(K)=SUM(K)+CSOUR(1)*CO2SP(K)*CLDFAC(K,1)
      ENDDO

      DO K=1,LMAX
         HTEM4(K)=RADCON*(FLXDG(K+1)-FLXDG(K))*DELP(K)
      ENDDO

!***HTEM = TOTAL APPROXIMATE HEATING RATE  (Q (APPROX))

      DO K=1,LMAX
         HTEM(K)=HTEM1(K)+HTEM2(K)+HTEM3(K)+HTEM4(K)
      ENDDO

!***COMPUTE FLUX PRESSURE LEVELS

      PFLUX(1)=0.
      DO K=2,LMAX
!!cgs   IF (PRESS(K-1).LT.100.) THEN
        IF (PRESS(K-1).LT.10.) THEN
           PFLUX(K)=2.0*PRESS(K-1)-PFLUX(K-1)
        ELSE
           PFLUX(K)=0.50*(PRESS(K)+PRESS(K-1))
        END IF
      ENDDO
      PFLUX(LP1)=PRESS(LP1)

!***COMPUTE FLUXES AT TOP, GROUND AND NET FLUX AT ALL LEVELS

      FTOPC=GXCTS*1.E-3
      FTOPE=FLX1E1*1.E-3
      FTOP=FTOPC+FTOPE
      FGRD=GRNFLX*1.E-3
      FDIFF=FTOP-FGRD
      FLXNET(1)=FTOP

      DO K=2,LP1
         FLXNET(K)=FLXNET(K-1)+HEATRA(K-1)*DELP2(K-1)*RADCON1*1.E-3
      ENDDO

      DO K=1,LP1
         FSWD(K)=FSW(K)*1.E-3
         DFSWD(K)=DFSW(K)*1.E-3
         UFSWD(K)=UFSW(K)*1.E-3
      ENDDO

!***COMPUTE NET RADIATIVE HEATING AND NET FLUX (UP-DOWN)

      SOLARW=SSOLAR*6.97667E5*1.E-3
      DO K=1,LP1
         FLWSW(K)=FLXNET(K)+FSWD(K)
      ENDDO
      DO K=1,LMAX
         HLWSW(K)=HSW(K)+HEATRA(K)
      ENDDO

!***THE CODE BELOW IS FOR DIAGNOSIS OF CTS QUANTITIES***

      DO N=1,NBLM
         QSUM=0.
         DO K=1,LMAX
            QSUM=QSUM+EXCTSN(K,N)/(DELP(K)*RADCON)
         ENDDO
         FTOPN(N)=FCTSG(N)-QSUM
      ENDDO

!***THIS STMT. ACCOUNTS FOR 4.3 UM BAND CONTRIB.

         FTOPN(NBLY)=0.
      DO N=1,NBLY
         FTOPN(N)=FTOPN(N)*1.E-3
      ENDDO

         FTOPAC(1)=FTOPN(1)
      DO N=2,NBLY
         FTOPAC(N)=FTOPAC(N-1)+FTOPN(N)
      ENDDO

!***THIS STMT. ACCOUNTS FOR 4.3 UM BAND CONTRIB.
      FCTSG(NBLY)=0.
!***THIS LOOP SETS EXCTS CONTRIB. OF BAND 15 (4.3UM) TO ZERO

      DO K=1,LMAX
         EXCTSN(K,NBLY)=0.
      ENDDO

      DO N=1,NBLY
         FCTSG(N)=FCTSG(N)*1.E-3
      ENDDO

         VSUMAC(1)=FCTSG(1)
      DO N=2,NBLY
         VSUMAC(N)=VSUMAC(N-1)+FCTSG(N)
      ENDDO

!***APPROXIMATE CTS HEATING RATES***

      DO K=1,LMAX
         CTS1(K)=RADCON*DELP(K)*(CSOUR(K)*  &
            (CO2SP(K+1)*CLDFAC(K+1,1)-CO2SP(K)*CLDFAC(K,1)))
         CTS2(K)=RADCON*DELP(K)*(OSOUR(K)*  &
          (TO3(K+1,1)*CLDFAC(K+1,1)-TO3(K,1)*CLDFAC(K,1)))
         CTST(K)=CTS1(K)+CTS2(K)+CTS(K)
      ENDDO

!-----------------------------------------------------------------------
!****PRINT STATEMENTS FOLLOW***
!***PRINT LAT. POINT AND CLOUD DATA (IF ANY) AND SFC ALBEDO

      PRINT 5650,IP,JP
 5650 FORMAT (//,'  RADIATION RESULTS FOR IP,JP= ',2I5)

      PRINT 5651,NCLDS
 5651 FORMAT (/,' NO. CLOUDS= ',I2)

      IF (NCLDS .ne. 0) THEN
         PRINT 5652
 5652    FORMAT (37X,' LW CLOUD DATA'/,' CLD. NO',8X,'CLD. AMT.',2X,  &
                 'CLD. EMISS',4X,'CLD TOP INDEX',2X,'CLD BOT INDEX')
         PRINT 5653,(N,CAMT(N+1),EMCLD(N+1),KTOP(N+1),  &
                     KBTM(N+1),N=1,NCLDS)
 5653    FORMAT (I5,7X,F12.6,F12.6,I10,I15)
         PRINT 6652
 6652    FORMAT (37X,' SW CLOUD DATA'/,' CLD. NO',8X,'CLD. AMT.',2X,  &
               'CLD TOP INDEX',2X,'CLD BOT INDEX',2X,'VIS. REFL',3X,  &
               ' IR REFL',4X,' IR ABS.')
         PRINT 6653,(N,CAMT(N+1),KTOPSW(N+1),KBTMSW(N+1),  &
                     CUVRF(N+1),CIRRF(N+1),CIRAB(N+1),N=1,NCLDS)
 6653    FORMAT (I5,7X,F12.6,I8,I15,6X,3F12.6)
      ENDIF

!!    NN=NCLDS+2
!!    PRINT 7653, CUVRF(NN),CIRRF(NN)
      PRINT 7653, SALB,SALB
 7653 FORMAT (/,10X,'VIS. SFC. ALBEDO=',F12.6,' IR SFC. ALBEDO=',F12.6)

!***PRINT CO2 AMOUNT***

      PRINT 5654, RRVCO2
 5654 FORMAT (/,' CO2 VOL. MIXING RATIO= ',F14.6,/)

!***PRINT SOLAR INPUT,ZENITH ANGLE***

      PRINT 6654, SOLARW,COSZRO
 6654 FORMAT (/,' INCOMING SOLAR FLUX =',F12.6,' W/M**2',/,  &
                ' COS(AZIMUTH)=',F12.6)

!***PRINT SOLAR INPUT,ZENITH ANGLE,DAY FRACTION***
!     PRINT 6654, SOLARW,COSZRO,TAUDAR
!6654 FORMAT (/,' INCOMING SOLAR FLUX =',F12.6,' W/M**2',/,  &
!               ' COS(AZIMUTH)=',F12.6,10X,' FRACTION SUNUP=',F12.6)

!***PRINT INPUT DATA AND OVERALL HEATING RATES AND FLUXES

      PRINT 5755
 5755 FORMAT (/,20X,' LW HEATING RATES AND FLUXES',/)

      PRINT 5655
 5655 FORMAT ('  LVL',' PRESSURE   ',4X,' TEMP.     ','H2O MMR',5X,  &
              'O3 MMR',7X,'HEAT RATE',2X,'NET FLUX',3X,'FLUX PRESS.')

      PRINT 5555, (K,PRESS(K),TEMP(K),RH2O(K),QO3(K),  &
                     HEATRA(K),FLXNET(K),PFLUX(K),K=1,LMAX)
      PRINT 5556, PRESS(LP1),TEMP(LP1),FLXNET(LP1),PFLUX(LP1)
 5555 FORMAT (I4,E13.6,F12.4,2E12.5,2F12.6,E13.6)
 5556 FORMAT (4X,E13.6,F12.4,36X,F12.6,E13.6)

      PRINT 6755
      PRINT 6655
      PRINT 6555, (K,PRESS(K),HSW(K),FSWD(K),DFSWD(K),  &
                     UFSWD(K),PFLUX(K),K=1,LMAX)
      PRINT 6556, PRESS(LP1),FSWD(LP1),DFSWD(LP1),  &
                  UFSWD(LP1),PFLUX(LP1)
 6755 FORMAT (/,20X,' SW HEATING RATES AND FLUXES',/)
 6655 FORMAT ('  LVL',' PRESSURE    ',3X,'HEAT RATE',2X,'NET FLUX',  &
                4X,'DN FLUX',6X,'UP FLUX',3X,'FLUX PRESS.')
 6556 FORMAT (4X,E13.6,12X,3F12.6,E13.6)
 6555 FORMAT (I4,E13.6,4F12.6,E13.6)

      PRINT 7755
      PRINT 7655
      PRINT 7555, (K,PRESS(K),HLWSW(K),FLWSW(K),PFLUX(K),K=1,LMAX)
      PRINT 7556,    PRESS(LP1),FLWSW(LP1),PFLUX(LP1)
 7755 FORMAT (/,20X,' COMBINED HEATING RATES AND FLUXES',/)
 7655 FORMAT ('  LVL',' PRESSURE    ',4X,'HEAT RATE',2X,'NET FLUX',  &
               3X,'FLUX PRESS.')
 7556 FORMAT (4X,E13.6,12X,F12.6,E13.6)
 7555 FORMAT (I4,E13.6,2F12.6,E13.6)

!***PRINT APPROXIMATE HEATING RATES

      PRINT 5659
 5659 FORMAT (/,37X,'APPROXIMATE HEATING RATES        (Q(APPROX))'/  &
                '  LVL',' PRESSURE   ',5X,'  0-160,1200-2200 ',      &
                ' 800-990,1070-1200','     990-1070     ',           &
                '      560-800     ','       TOTAL')

      PRINT 5559, (K,PRESS(K),HTEM1(K),HTEM2(K),HTEM3(K),HTEM4(K),  &
                     HTEM(K),K=1,LMAX)
 5559 FORMAT (I4,E13.6,5F18.6)

      PRINT 5561
 5561 FORMAT (/,37X,'APPROXIMATE CTS HEATING RATES',  &
              /,'  LVL',' PRESSURE',7X,' H2O BANDS    ',  &
                ' 15 UM BAND   ',' 9.6 UM BAND  ',' TOTAL')

      PRINT 5562, (K,PRESS(K),CTS(K),CTS1(K),CTS2(K),CTST(K),K=1,LMAX)
 5562 FORMAT (I4,E13.6,4F14.6)

      PRINT 5570
 5570 FORMAT (/,37X,'EXACT CTS HEATING RATES, BY BAND',  &
              /,'  LVL',' PRESSURE   ','    TOTAL    ',  &
              5X,'1',11X,'2',11X,'3',11X,'4',11X,'5',11X,'6',11X,'7',/)

      PRINT 5573, (K,PRESS(K),EXCTS(K),EXCTSN(K,1),EXCTSN(K,2),  &
                     EXCTSN(K,3),EXCTSN(K,4),EXCTSN(K,5),  &
                     EXCTSN(K,6),EXCTSN(K,7),K=1,LMAX)
 5573 FORMAT (I4,E13.6,8F12.6)

      PRINT 5572
 5572 FORMAT ('  LVL',' PRESSURE   ',7X,'8',11X,'9',10X,'10',10X,  &
                '11',10X,'12',10X,'13',10X,'14',10X,'15')

      PRINT 5573, (K,PRESS(K),EXCTSN(K,8),EXCTSN(K,9),EXCTSN(K,10),  &
                     EXCTSN(K,11),EXCTSN(K,12),EXCTSN(K,13),  &
                     EXCTSN(K,14),EXCTSN(K,15),K=1,LMAX)

!***PRINT FLUXES

      PRINT 5558, FTOPC,FTOPE,FTOP,FGRD,FDIFF
 5558 FORMAT ( 40X,'   FLUXES',  &
             /,' FLUX AT TOP,160-1200 CM-1       =',F14.6,' W/M**2',  &
             /,' FLUX AT TOP,0-160,1200-2200 CM-1=',F14.6,' W/M**2',  &
             /,' FLUX AT TOP,0-2200 CM-1         =',F14.6,' W/M**2',  &
             /,' NET FLUX AT GROUND,0-2200 CM-1  =',F14.6,' W/M**2',  &
             /,' NET FLUX DIFFERENCE,0-2200 CM-1 =',F14.6,' W/M**2')

      PRINT 5633
 5633 FORMAT (40X,'CTS FLUXES',  &
             /,1X,'BAND NO',8X,'LOFREQ',9X,'HIFREQ',9X,'F(1)',11X,  &
                  'ACCUM. F(1)',4X,'CTS F(GRD)',5X,'ACCUM. CTS F(GRD)')

!***PRINTOUT FOR 8 COMBINED BANDS,160-560 CM-1

      DO 767 NY=1,8
      NPRT=1
        DO 768 NX=1,40
         IF (IBAND(NX).EQ.NY) THEN
           IF (NPRT.EQ.1) THEN
              PRINT 5644,NY,BANDLO(NX+16),BANDHI(NX+16),  &
                         FTOPN(NY),FTOPAC(NY),FCTSG(NY),VSUMAC(NY)
              NPRT=0
           ELSE
              PRINT 5646,BANDLO(NX+16),BANDHI(NX+16)
           ENDIF
         ENDIF
768   CONTINUE
767   CONTINUE

!***PRINTOUT FOR REMAINING BANDS

      DO 769 NY=9,NBLM
        PRINT 5644, NY,BANDLO(NY+48),BANDHI(NY+48),FTOPN(NY),  &
                       FTOPAC(NY),FCTSG(NY),VSUMAC(NY)
769   CONTINUE
      NY=NBLY
        PRINT 5644, NY,BANDLO(NBLW),BANDHI(NBLW),FTOPN(NY),  &
                       FTOPAC(NY),FCTSG(NY),VSUMAC(NY)
5644  FORMAT (I11,6F15.6)
5646  FORMAT (11X,2F15.6)

!-----------------------------------------------------------------------

      END SUBROUTINE RADPRT

!#######################################################################
!#######################################################################

                 END MODULE RAD_DIAG_MOD

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The Schumann and Gerz (1995) stability function\label{sec:sg}
!
! !INTERFACE:
   subroutine cmue_sg(nlev)
!
! !DESCRIPTION:
!  This subroutine computes stability functions according to
! \begin{equation}
! c_{\mu}=c_{\mu}^0,\qquad c'_{\mu}=\frac{c_{\mu}^0}{Pr_t}
! \end{equation}
! with constant $c_{\mu}^0$. Based simulation data on stratified homogeneous
! shear-flows, \cite{SchumannGerz95} proposed the empirical relation
! for the turbulent Prandtl--number,
! \begin{equation}
!   Pr_t = Pr_t^0 \exp\left(-\frac{Ri}{Pr_t^0 Ri^{\infty}}\right)
!   -\frac{Ri}{Ri^{\infty}}
!   \comma
! \end{equation}
! where where $Ri$ is the gradient Richardson--number and $Pr_t^0$
! is the turbulent Prandtl--number for $Ri \rightarrow 0$. $Pr_t^0$
! and the fixed value $c_\mu^0$ have to be set in {\tt gotmturb.nml}.
! \cite{SchumannGerz95}  suggested $Pr_t^0=0.74$ and $Ri^{\infty}=0.25$.
!
! !USES:
   use turbulence, only: Prandtl0_fix,cm0_fix
   use turbulence, only: cmue1,cmue2,as,an
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: nlev
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard & Karsten Bolding
!
!  $Log: cmue_sg.F90,v $
!  Revision 20.0  2013/12/14 00:13:34  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.9  2010-09-17 12:53:52  jorn
!  extensive code clean-up to ensure proper initialization and clean-up of all variables
!
!  Revision 1.8  2007-01-06 11:49:15  kbk
!  namelist file extension changed .inp --> .nml
!
!  Revision 1.7  2005/11/15 11:35:02  lars
!  documentation finish for print
!
!  Revision 1.6  2005/07/18 08:54:56  lars
!  changed docu for html compliance
!
!  Revision 1.5  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.4  2004/08/18 12:53:07  lars
!  updated documentation
!
!  Revision 1.3  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.2  2003/03/10 09:02:04  gotm
!  Added new Generic Turbulence Model +
!  improved documentation and cleaned up code
!
!  Revision 1.1.1.1  2001/02/12 15:55:58  gotm
!  initial import into CVS
!
!EOP
!
! !LOCAL VARIABLES:
   integer                   :: i
   REALTYPE                  :: Ri,Prandtl
   REALTYPE,parameter        :: limit=3.
!
!-----------------------------------------------------------------------
!BOC
   do i=1,nlev-1
      Ri=an(i)/(as(i)+1.e-8)   ! Gradient Richardson number
      if (Ri.ge.1e-10) then
         Prandtl=Prandtl0_fix*exp(-Ri/(Prandtl0_fix*0.25))+Ri/0.25
      else
         Prandtl=Prandtl0_fix
      end if

      cmue1(i)=cm0_fix
      cmue2(i)=cm0_fix/min(limit,Prandtl)

   end do
   return
   end subroutine cmue_sg
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module nf_utils_mod

use nfu_mod ! netcdf utilities
use nfc_mod ! netcdf utilities for compressed files

implicit none
private

! ==== public interfaces =====================================================
! export stuff from nfu_mod
public :: nfu_inq_dim, nfu_inq_var, nfu_inq_att
public :: nfu_def_dim, nfu_def_var
public :: nfu_put_att
public :: nfu_get_dim, nfu_get_dim_bounds
public :: nfu_put_var, nfu_put_rec
public :: nfu_get_var, nfu_get_rec
public :: nfu_get_valid_range, nfu_is_valid, nfu_validtype, nfu_validtype2ascii
! export stuff from nfc_mod
public :: nfu_inq_compressed_dim, nfu_inq_compressed_var
public :: nfu_get_compressed_var
public :: nfu_put_compressed_var
public :: nfu_get_compressed_rec
! ==== end of public interfaces ==============================================

! ==== module constants ======================================================
character(len=*), parameter :: &
     version = '$Id: nf_utils.F90,v 17.0 2009/07/21 03:02:54 fms Exp $', &
     tagname = '$Name: tikal $'

end module nf_utils_mod

#include"cppdefs.h"
!-------------------------------------------------------------------------
!BOP
!
! !ROUTINE: Algebraic length-scale from ISPRAMIX \label{sec:ispramix}
!
! !INTERFACE:
   subroutine ispralength(nlev,NN,h,depth)
!
! !DESCRIPTION:
!  This subroutine calculates the
!  lengthscale used in the ISPRAMIX model,
!  see \cite{EiflerSchrimpf92} and \cite{Demirovetal98}.
!  In both mixing regions (close to the surface and the bottom),
!  $l$ is obtained from the formula
!  \begin{equation}
!    \label {Lmixed}
!    l = \frac {\kappa \tilde z} {1+\frac {\kappa \tilde z} {c_2 \cdot h_m}}
!        (1-R_f)^e
!  \end{equation}
!  where $\tilde z$
!  is the distance from the interface (surface or bottom). The
!  fraction in (\ref{Lmixed})
!  predicts an approximation to a linear behavior of $l$ near boundaries
!  and a value proportional to the thickness of the mixed
!  layer far from the interface, $l=c_2 h_m$, where $c_2=0.065$
!  is estimated from experimental data as discussed in
!  \cite{EiflerSchrimpf92}.
!  The factor $(1-R_f)$, with the flux Richardson
!  number $R_f=-G/P$, accounts for the effect
!  of stratification on the length-scale.
!  The parameter $e$ is here a tuning parameter
!  (pers.\ comm.\ Walter Eifler, JRC, Ispra, Italy)
!  which is usually set to $e=1$.
!
! !USES:
   use turbulence, only: L,tke,k_min,eps_min,xRF,kappa,cde

   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer,  intent(in)                :: nlev

!  buoyancy frequency (1/s^2)
   REALTYPE, intent(in)                :: NN(0:nlev)

!  layer thickness (m)
   REALTYPE, intent(in)                :: h(0:nlev)

!  local depth (m)
   REALTYPE, intent(in)                :: depth
!
! !REVISION HISTORY:
!  Original author(s):  Manuel Ruiz Villarreal, Hans Burchard
!
!  $Log: ispralength.F90,v $
!  Revision 20.0  2013/12/14 00:13:43  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.7  2005-11-15 11:35:02  lars
!  documentation finish for print
!
!  Revision 1.6  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.5  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.4  2003/03/28 08:30:15  kbk
!  removed tabs
!
!  Revision 1.3  2003/03/10 09:02:05  gotm
!  Added new Generic Turbulence Model +
!  improved documentation and cleaned up code
!
!  Revision 1.2  2002/02/08 08:59:58  gotm
!
!  Revision 1.1.1.1  2001/02/12 15:55:58  gotm
!  initial import into CVS
!
!EOP
!-------------------------------------------------------------------------
! !LOCAL VARIABLES:
  integer                    :: i,SLind,BLind,Index,Index2
  REALTYPE                   :: hms,hmb,db,ds
  REALTYPE                   :: kml,c2_i,c3_i
  REALTYPE                   :: l_min
!
!-------------------------------------------------------------------------
!BOC

   l_min = cde*k_min**1.5/eps_min

   kml   = 1.e-5
   c2_i  = 0.065

!  Calculation of surface mixed layer depth
   hms=0.
   SLind=1
   do i=nlev,1,-1
      hms=hms+h(i)
      if (tke(i).le.kml) then
         SLind=i
         goto 500
      end if
   end do
500  continue
!  Calculation of bottom mixed layer depth
   hmb=0.
   BLind=nlev
   do i=1,nlev
      hmb=hmb+h(i)
      if (tke(i).le.kml) then
         BLind=i
         goto 501
      end if
   end do
501  Continue

! If there is no point where k < kml, the water column is assumed to be mixed.
   if (BLind.gt.SLind) then
      hms=0.5*depth
      hmb=0.5*depth
      BLind=int(nlev/2)
      SLind=int(nlev/2)+1
   endif

! Calculation of mixing length in bottom layer
   db=0.
   do i=1,BLind
      db=db+h(i)
      L(i)=kappa*db/(1.+kappa*db/(c2_i*hmb+L_min))*xRf(i)**3
      if (L(i).lt.L_min) L(i)=L_min
   end do

! Calculation of mixing length in surface layer
   ds=h(nlev)
   do i=nlev-1,SLind,-1
      ds=ds+h(i)
      L(i)=kappa*ds/(1.+kappa*ds/(c2_i*hms+L_min))*xRf(i)**3
      if (L(i).lt.L_min) L(i)=L_min
   end do

! Calculation of mixing length in the intermediate region

   c3_i=L(SLind)*sqrt(NN(SLind)/tke(SLind))
   if (c3_i.lt.1e-10) c3_i=0.
   Index=Slind-1
   do i=SLind-1,BLind+1,-1
      if (NN(i).le.0.) then
         L(i)=L_min
      else
         L(i)=max(c3_i*sqrt(tke(i)/NN(i)),L_min)
         if (L(i).gt.L(SLind)) L(i)=L(SLind)
      endif
      if (L(i).eq.L_min) then
         Index=i
         goto 503
      end if
   end do
503  continue
   c3_i=L(BLind)*sqrt(NN(BLind)/tke(BLind))
   if (c3_i.lt.1e-10) c3_i=0.
   Index2=BLind+1
   do i=BLind+1,Index
      if (NN(i).le.0.) then
         L(i)=L_min
      else
         L(i)=max(c3_i*sqrt(tke(i)/NN(i)),L_min)
         if(L(i).gt.L(BLind)) L(i)=L(BLind)
      endif
      if (L(i).eq.L_min) then
         Index2=i
         goto 504
      end if
   end do
504  continue
   do i=Index2+1,Index-1
      L(i)=L_min
   end do

   return
   end subroutine ispralength
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module polvani_2004_mod

! Polvani, L. M., R. K. Scott, and S. J. Thomas, 2004:
! Numerically Converged Solutions of the Global Primitive Equations
! for Testing the Dynamical Core of Atmospheric GCMs.
! Monthly Weather Review, 132, 2539-2552.

use               mpp_mod, only: mpp_error, FATAL

use               fms_mod, only: mpp_pe, mpp_root_pe, stdlog, &
                                 write_version_number, close_file, check_nml_error, open_namelist_file

use         constants_mod, only: PI,    &
                                 GRAV,  & ! GRAV=9.800, not 9.806 as specified by Polvani
                                 RDGAS, & ! RDGAS=287.04, not 287.00 as specified by Polvani
                                 OMEGA, & ! same as specified by Polvani
                                 RADIUS,& ! same as specified by Polvani
                                 KAPPA    ! same as specified by Polvani

use   vert_coordinate_mod, only: compute_vert_coord

use        transforms_mod, only: get_grid_boundaries, get_sin_lat, get_cos_lat, trans_grid_to_spherical, trans_spherical_to_grid,&
                                 get_wts_lat, get_lon_max, get_lat_max, get_deg_lon, get_deg_lat, &
                                 vor_div_from_uv_grid, uv_grid_from_vor_div, get_grid_domain

use  press_and_geopot_mod, only: press_and_geopot_init, pressure_variables

use      diag_manager_mod, only: diag_axis_init, register_static_field, send_data

implicit none
private

character(len=128), parameter :: version = &
'$Id: polvani_2004.F90,v 19.0 2012/01/06 20:35:35 fms Exp $'

character(len=128), parameter :: tagname = &
'$Name: tikal $'

public :: polvani_2004

integer, parameter :: num_standard_levels = 8
real, parameter, dimension(num_standard_levels  ) :: z_standard=(/0., 11.e3, 20.e3, 32.e3, 47.e3, 51.e3, 71.e3, 80.e3/)
real, parameter, dimension(num_standard_levels-1) :: lapse_standard=(/-6.5e-3, 0.0, 1.e-3, 2.8e-3, 0.0, -2.8e-3, -2.0e-3/)
real,            dimension(num_standard_levels  ) :: T_standard

real :: lambda0, phi0, alpha, beta ! These determine the position of the initial temperature perturbation.
real, parameter :: P00=1.e5 ! Used to compute potential temperature. sea_level_press may be the same, but one should not assume that.

real, parameter :: twopi = 2*PI
real :: xx
integer :: kk

real :: H  = 7.340e3      ! meters
real :: z0 = 22.e3        ! meters
real :: delta_z0 = 5.e3   ! meters
real :: z1 = 30.e3        ! meters
real :: u0 = 50.          ! m/sec
real :: perturb_amp = 1.0 ! deg K

namelist / polvani_2004_nml / H, z0, delta_z0, z1, u0, perturb_amp

contains

!=========================================================================================================================

subroutine polvani_2004(sea_level_press, triang_trunc, vert_difference_option, pk, bk, &
                   vors, divs, ts, ln_ps, ug, vg, tg, psg, vorg, divg, surf_geopotential)

real,    intent(in) :: sea_level_press
logical, intent(in) :: triang_trunc 
character(len=*), intent(in) :: vert_difference_option
real,    intent(out), dimension(:) :: pk, bk
complex, intent(out), dimension(:,:,:) :: vors, divs, ts
complex, intent(out), dimension(:,:  ) :: ln_ps
real,    intent(out), dimension(:,:,:) :: ug, vg, tg
real,    intent(out), dimension(:,:  ) :: psg
real,    intent(out), dimension(:,:,:) :: vorg, divg
real,    intent(out), dimension(:,:  ) :: surf_geopotential

integer :: unit, ierr, io, i, j, k, ks, lon_max, lat_max, num_levels
integer :: id_lon, id_lat, id_phalf, id_pfull, id_basic_flow, id_term1_eq10, id_basic_temp, id_pot_temp, id_perturbation
integer :: is, ie, js, je
logical :: used
real, dimension(size(ug,1), size(ug,2)) :: ln_psg
real, dimension(size(ug,3)  ) :: p_full, ln_p_full, T0
real, dimension(size(ug,3)+1) :: p_half, ln_p_half
real :: F, du_dz, dF_dz, ff1, ff2, dzz1_dz, dzz2_dz, dff1_dz, dff2_dz, dTdy, dTdy_prev, ln_slp
real, dimension(size(ug,3)) :: z, zz1, zz2, gmean_term1

! The allocatable arrays below must be allocated for the global domain
real, allocatable, dimension(:)   :: deg_lon, lonb, deg_lat, latb, rad_lon, rad_lat, wts_lat, sin_lat, cos_lat, tan_lat, coriolis
real, allocatable, dimension(:,:) :: basic_flow, term1_eq10, basic_temp, pot_temp
real, allocatable, dimension(:)   :: lon_factor, lat_factor
real, allocatable, dimension(:,:) :: perturbation

!------------------------------------------------------------------------------------------------

unit = open_namelist_file()
ierr=1
do while (ierr /= 0)
  read(unit, nml=polvani_2004_nml, iostat=io, end=20)
  ierr = check_nml_error (io, 'polvani_2004_nml')
enddo
20 call close_file (unit)
call write_version_number(version, tagname)
if(mpp_pe() == mpp_root_pe()) write (stdlog(), nml=polvani_2004_nml)

T_standard(1) = 288.15
do ks=2,num_standard_levels
  T_standard(ks) = T_standard(ks-1) + lapse_standard(ks-1)*(z_standard(ks)-z_standard(ks-1))
enddo

call compute_vert_coord ('even_sigma', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, pk, bk)

surf_geopotential = 0.0
call press_and_geopot_init(pk, bk, .false., vert_difference_option)
call pressure_variables(p_half, ln_p_half, p_full, ln_p_full, sea_level_press)

call get_lon_max(lon_max)
call get_lat_max(lat_max)
num_levels = size(ug,3)
if(num_levels /= 20) then
  call mpp_error(FATAL,'Number of vertical levels must be 20 when using polvani_2004 initialization')
endif
allocate(rad_lon(lon_max), deg_lon(lon_max), lon_factor(lon_max))
allocate(rad_lat(lat_max), deg_lat(lat_max), lat_factor(lat_max))
allocate(wts_lat(lat_max), sin_lat(lat_max), cos_lat(lat_max), tan_lat(lat_max))
allocate(coriolis(lat_max), latb(lat_max+1), lonb(lon_max+1))
allocate(basic_flow(lat_max,num_levels), term1_eq10(lat_max,num_levels))
allocate(basic_temp(lat_max,num_levels),   pot_temp(lat_max,num_levels))
allocate(perturbation(lon_max,lat_max))
call get_deg_lon(deg_lon)
rad_lon = PI*deg_lon/180.
call get_deg_lat(deg_lat)
rad_lat = PI*deg_lat/180.
call get_wts_lat(wts_lat)
call get_sin_lat(sin_lat)
call get_cos_lat(cos_lat)
tan_lat = sin_lat/cos_lat
call get_grid_boundaries(lonb, latb, global=.true.) ! units = radians
coriolis = 2*OMEGA*sin_lat

ln_slp = log(sea_level_press)
do k=1,num_levels
  z(k) = H*(ln_slp - ln_p_full(k))
  zz1(k) = (z(k)-z0)/delta_z0
  zz2(k) = PI*z(k)/z1
enddo

do k=1,num_levels
  if(z(k) > z_standard(num_standard_levels)) then
    T0(k) = T_standard(num_standard_levels)
    cycle
  endif
  do ks=2,num_standard_levels
    if(z(k) <= z_standard(ks) .and. z(k) >= z_standard(ks-1)) then
      T0(k)=((z_standard(ks)-z(k))*T_standard(ks-1) + (z(k)-z_standard(ks-1))*T_standard(ks))/(z_standard(ks)-z_standard(ks-1))
      exit
    else
      cycle
    endif
  enddo
enddo

do k=1,num_levels
  ff1 = 1 - tanh(zz1(k))**3
  ff2 = sin(zz2(k))
  F = .5*ff1*ff2
  do j=1,lat_max
    if(sin_lat(j) > 0.0) then
      basic_flow(j,k) = u0*F*(sin(PI*sin_lat(j)**2))**3
    else
      basic_flow(j,k) = 0.0
    endif
  enddo
enddo

! The k loop below computes the integral of equation 10 in the paper.
! The inner loop over latitude does the actual integration.
! Prior to that the vertical derivative of F (equation 6) must be computed.
do k=1,num_levels
  ff1 = 1 - tanh(zz1(k))**3
  ff2 = sin(zz2(k))
  dzz1_dz = 1/delta_z0
  dzz2_dz = PI/z1
  dff1_dz = -3 * ( tanh(zz1(k))/cosh(zz1(k)) )**2 * dzz1_dz
  dff2_dz = cos(zz2(k)) * dzz2_dz
  dF_dz = .5*(ff1*dff2_dz + dff1_dz*ff2)

  gmean_term1(k) = 0.0
  do j=1,lat_max
    if(sin_lat(j) > 0.0) then
      du_dz = u0 * (sin(PI*sin_lat(j)**2))**3 * dF_dz
    else
      du_dz = 0.0
    endif
    dTdy = -(H/RDGAS) * (RADIUS*coriolis(j) + 2*basic_flow(j,k)*tan_lat(j)) * du_dz
    if(j == 1) then
!     term1_eq10(j,k) =    .5*wts_lat(j)*dTdy/cos_lat(j)
      term1_eq10(j,k) = (rad_lat(j)-latb(j))*dTdy/cos_lat(j)
    else
!     term1_eq10(j,k) = term1_eq10(j-1,k) + .5*(wts_lat(j-1)*dTdy/cos_lat(j-1) + wts_lat(j)*dTdy/cos_lat(j))
      term1_eq10(j,k) = term1_eq10(j-1,k) + (latb(j)-rad_lat(j-1))*dTdy_prev + (rad_lat(j)-latb(j))*dTdy
    endif
    gmean_term1(k) = gmean_term1(k) + .5*wts_lat(j)*term1_eq10(j,k)
    dTdy_prev = dTdy
  enddo
enddo

! The temperature perturbation is computed below.
lambda0 = 0.0
phi0    = PI/4.
alpha   = 1./3.
beta    = 1./6.
do i=1,lon_max
  xx = rad_lon(i)-lambda0
  ! Make sure xx falls in the range -PI to +PI.
  kk = nint(xx/twopi)
  xx = xx - twopi*kk
  lon_factor(i) = 1./cosh(xx/alpha)**2
enddo
do j=1,lat_max
  lat_factor(j) = 1./cosh((rad_lat(j)-phi0)/beta)**2
enddo
do j=1,lat_max
  do i=1,lon_max
    perturbation(i,j) = perturb_amp*lon_factor(i)*lat_factor(j)
  enddo
enddo

id_phalf = diag_axis_init('phalf',.01*p_half,'hPa','z','approx half pressure level',direction=-1)
id_pfull = diag_axis_init('pfull',.01*p_full,'hPa','z','approx full pressure level',direction=-1,edges=id_phalf)
id_lon   = diag_axis_init('lon',deg_lon,'degrees E','x','longitude')
id_lat   = diag_axis_init('lat',deg_lat,'degrees N','y','latitude')
id_basic_flow   = register_static_field('polvani_2004', 'basic_flow',  (/id_lat,id_pfull/),'initial zonal wind', 'm/sec')
id_term1_eq10   = register_static_field('polvani_2004', 'term1_eq10',  (/id_lat,id_pfull/),'first term of equation 10', 'K')
id_basic_temp   = register_static_field('polvani_2004', 'basic_temp',  (/id_lat,id_pfull/),'initial basic_temp', 'K')
id_pot_temp     = register_static_field('polvani_2004', 'pot_temp',    (/id_lat,id_pfull/),'initial potential basic_temp', 'K')
id_perturbation = register_static_field('polvani_2004', 'perturbation',(/id_lon,id_lat/),  'initial temperature perturbation','K')
if(id_basic_flow > 0) used = send_data(id_basic_flow, basic_flow)
if(id_term1_eq10 > 0) used = send_data(id_term1_eq10, term1_eq10)
do k=1,num_levels
  do j=1,lat_max
    basic_temp(j,k) = term1_eq10(j,k) - gmean_term1(k) + T0(k)
    pot_temp(j,k) = basic_temp(j,k)*(P00/p_full(k))**KAPPA
  enddo
enddo
if(id_basic_temp > 0) used = send_data(id_basic_temp, basic_temp)
if(id_pot_temp   > 0) used = send_data(id_pot_temp,     pot_temp)
if(id_perturbation>0) used = send_data(id_perturbation, perturbation)

call get_grid_domain(is, ie, js, je)

do k=1,num_levels
  do i=1,size(ug,1)
    ug(i,:,k) = basic_flow(js:je,k)
    tg(i,:,k) = basic_temp(js:je,k)
  enddo
enddo
do j=1,size(ug,2)
  do i=1,size(ug,1)
    tg(i,j,:) = tg(i,j,:) + perturbation(is+i-1,js+j-1)
  enddo
enddo
vg = 0.0

! Transform grid fields to spherical waves then transform
! back to ensure that spectral and grid representations match.

call trans_grid_to_spherical(tg, ts)
call trans_spherical_to_grid(ts, tg)
call vor_div_from_uv_grid(ug, vg, vors, divs, triang=triang_trunc)
call uv_grid_from_vor_div(vors, divs, ug, vg)
call trans_spherical_to_grid(vors, vorg)
call trans_spherical_to_grid(divs, divg)
psg = sea_level_press
ln_psg = alog(psg)
call trans_grid_to_spherical(ln_psg, ln_ps)
call trans_spherical_to_grid(ln_ps,  ln_psg)
psg = exp(ln_psg)

deallocate(deg_lon, deg_lat, rad_lon, rad_lat, wts_lat, sin_lat, cos_lat, tan_lat, coriolis)
deallocate(basic_flow, term1_eq10, basic_temp, pot_temp)
deallocate(lon_factor, lat_factor)
deallocate(perturbation)

return
end subroutine polvani_2004
!================================================================================

end module polvani_2004_mod

module fv_advection_mod

use         fms_mod, only: mpp_pe, mpp_npes, mpp_root_pe, error_mesg, FATAL, write_version_number

use   constants_mod, only : radius, pi

use mpp_domains_mod, only : mpp_define_domains, mpp_update_domains, &
                            mpp_get_compute_domain, domain2D

implicit none
private

character(len=128), parameter :: version = '$Id: fv_advection.F90,v 13.0 2006/03/28 21:17:47 fms Exp $'
character(len=128), parameter :: tagname = '$Name: tikal $'

type(domain2D), save, public :: advection_domain

logical :: module_is_initialized = .FALSE.
logical :: monotone      = .true.
integer :: is, ie, js, je, pe, npes, nx, ny, nz

real, allocatable, dimension(:) :: y, yy, c, s, cc, dy, dyy, dyyy, dy_plus, dy_minus
real :: dx

public :: fv_advection_init, fv_advection_end
public :: a_grid_horiz_advection

interface a_grid_horiz_advection
   module procedure a_grid_horiz_advection_3d
   module procedure a_grid_horiz_advection_2d
end interface

!===========================================================================================
contains
!===========================================================================================


subroutine fv_advection_init(nx_in, ny_in, yy_in, degrees_lon, advection_layout)

  integer, intent(in) ::  nx_in, ny_in
  real   , intent(in), dimension(:) :: yy_in
  real   , intent(in) :: degrees_lon
  integer, intent(in), optional :: advection_layout(2)


  integer :: layout(2)

  if (module_is_initialized) return

  call write_version_number(version, tagname)

  pe   = mpp_pe()
  npes = mpp_npes()

  nx = nx_in
  ny = ny_in

  allocate( y(ny), c(ny), s(ny), yy(ny+1), cc(ny+1), dy(-1:ny+2), dyy(ny+1), dyyy(0:ny+1) )
  allocate( dy_plus(0:ny+1), dy_minus(0:ny+1) )

  yy = yy_in

  y  = 0.5*(yy(2:ny+1) + yy(1:ny))

  c  = cos(y)
  s  = sin(y)
  cc = cos(yy)

  dy(1:ny) = yy(2:ny+1) - yy(1:ny)  ! distance between half level points (size of grid boxes)
  dy(-1)    = dy(2)
  dy(0)     = dy(1)
  dy(ny+1) = dy(ny)
  dy(ny+2) = dy(ny-1)

  dyy(2:ny) = y(2:ny) - y(1:ny-1)  ! distance between full points 
  dyy(1)    = 2*(y(1) - yy(1))
  dyy(ny+1) = 2*(yy(ny+1) - y(ny))

  dy_plus (0:ny+1) = dy(0:ny+1)/(dy( 0:ny+1) + dy(1:ny+2))
  dy_minus(0:ny+1) = dy(0:ny+1)/(dy(-1:ny  ) + dy(0:ny+1))

  y    =    y*radius
  yy   =   yy*radius
  dy   =   dy*radius
  dyy  =  dyy*radius

  dx = (degrees_lon/360.)*2.0*pi*radius/float(nx)

!1D decomposition along Y only
  layout = (/1,npes/)    
    
  if( present (advection_layout) ) layout = advection_layout

  call mpp_define_domains( (/1,nx,1,ny/), layout, advection_domain, yhalo=2 )

  module_is_initialized=.TRUE.

  call mpp_get_compute_domain( advection_domain, is, ie, js, je )

return
end subroutine fv_advection_init

!===========================================================================================

subroutine a_grid_horiz_advection_3d(ua, va, q, dt, dq_dt, flux)


real, intent(in)   , dimension(:,js:,:) :: ua, va, q
real, intent(in)                        :: dt
real, intent(inout), dimension(:,js:,:) :: dq_dt
logical, optional, intent(in) :: flux

real, dimension(nx,js-2:je+2,size(q,3)) :: vx, qx
real, dimension(nx,js  :je+1,size(q,3)) :: vc
real, dimension(nx,js  :je  ,size(q,3)) :: uc, div

integer :: i, j, k
integer, dimension(nx) :: ii

logical :: flux_local

if(.not.module_is_initialized) then
  call error_mesg('a_grid_horiz_advection','fv_advection_mod is not initialized', FATAL)
endif

flux_local = .false.
if(present(flux)) flux_local = flux

vx = 0.0
qx = 0.0

do i = 1,nx
  ii(i) = i + nx/2
  if (ii(i) > nx) ii(i) = ii(i) - nx
end do

vx(:, js:je, :) = va(:, js:je, :)
qx(:, js:je, :) = q (:, js:je, :)

call mpp_update_domains(vx, advection_domain)
call mpp_update_domains(qx, advection_domain)

if(js == 1) then
  do i = 1,nx
    vx(i, 0,:) = - vx(ii(i),1,:)
    qx(i, 0,:) =   qx(ii(i),1,:)
    qx(i,-1,:) =   qx(ii(i),2,:)
  end do
endif

if(je == ny) then
  do i = 1,nx
    vx(i,ny+1,:) = - vx(ii(i),ny  ,:)
    qx(i,ny+1,:) =   qx(ii(i),ny  ,:)
    qx(i,ny+2,:) =   qx(ii(i),ny-1,:)
  end do
endif

uc(2:nx,js:je,:)   = 0.5*(ua(1:nx-1, js:je  ,:) + ua(2:nx,js:je,:))
uc(1   ,js:je,:)   = 0.5*(ua(nx    , js:je  ,:) + ua(1   ,js:je,:))

 do k=1,size(vc,3)
   do j=js,je+1
     do i=1,nx
       vc(i,j,k) = 0.5*(vx(i,j-1,k) + vx(i,j,k))
     enddo
   enddo
 enddo

if(.not.flux_local) then 
  do j = js,je
    div(:,j,:) = (vc(:,j+1,:)*cc(j+1) - vc(:,j,:)*cc(j))/(c(j)*dy(j))
  enddo

  do j = js, je
    div(1:nx-1,j,:) = div(1:nx-1,j,:) + (uc(2:nx,j,:) - uc(1:nx-1,j,:))/(c(j)*dx)
    div(nx    ,j,:) = div(nx    ,j,:) + (uc(1   ,j,:) - uc(nx    ,j,:))/(c(j)*dx)
  enddo

  dq_dt = dq_dt + q*div
endif

call advection_sphere_3d(dq_dt, dt, qx, uc, vc, ua, va)

return
end subroutine a_grid_horiz_advection_3d

!===========================================================================================

subroutine a_grid_horiz_advection_2d(ua, va, q, dt, dq_dt, flux)

real, intent(in),    dimension(:,js:) :: ua, va, q
real, intent(in)                      :: dt
real, intent(inout), dimension(:,js:) :: dq_dt
logical, intent(in), optional :: flux

real, dimension(nx,js:je ,1) :: ua_3d, va_3d, q_3d, dq_dt_3d

q_3d     (:,js:je,1)   = q     (:,js:je)
ua_3d    (:,js:je,1)   = ua    (:,js:je)
va_3d    (:,js:je,1)   = va    (:,js:je)
dq_dt_3d (:,js:je,1)   = dq_dt (:,js:je)

if(present(flux)) then
  call a_grid_horiz_advection_3d(ua_3d, va_3d, q_3d, dt, dq_dt_3d, flux = flux)
else 
  call a_grid_horiz_advection_3d(ua_3d, va_3d, q_3d, dt, dq_dt_3d)
endif

dq_dt  =  dq_dt_3d(:,:,1)

return
end subroutine a_grid_horiz_advection_2d

!===========================================================================================

subroutine advection_sphere_3d(dq_dt, dt, q, uc, vc, ua, va)

real, intent(in)   , dimension(:,js-2:,:) :: q
real, intent(in)   , dimension(:,js  :,:) :: vc
real, intent(in)   , dimension(:,js  :,:) :: uc, ua, va
real, intent(in)                          :: dt
real, intent(inout), dimension(:,js  :,:) :: dq_dt

real, dimension(nx, js  :je  , size(q,3)) :: q2
real, dimension(nx, js-2:je+2, size(q,3)) :: q1

integer, dimension(nx) :: ii
integer :: i


call semi_x_3d(q1(:,js:je,:), ua(:,js:je,:), q(:,js :je ,:), 0.5*dt)
q1(:,js:je,:) = q(:,js:je,:) + q1(:,js:je,:)

call semi_y_3d(q2(:,js:je,:), va(:,js:je,:), q(:,js-2:je+2,:), 0.5*dt)
q2(:,js:je,:) = q(:,js:je,:) + q2(:,js:je,:)

call mpp_update_domains(q1, advection_domain)

do i = 1,nx
  ii(i) = i + nx/2
  if (ii(i) > nx) ii(i) = ii(i) - nx
end do

if(js == 1) then
  do i = 1,nx
    q1(i, 0,:) =   q1(ii(i),1,:)
    q1(i,-1,:) =   q1(ii(i),2,:)
  end do
endif

if(je == ny) then
  do i = 1,nx
    q1(i,ny+1,:) =   q1(ii(i),ny  ,:)
    q1(i,ny+2,:) =   q1(ii(i),ny-1,:)
  end do
endif

call vanleer_x_3d     (dq_dt(:,js:je,:), uc(:,js:je,:)  , q2(:,js:je,:)    , dt)

call vanleer_sphere_3d(dq_dt(:,js:je,:), vc(:,js:je+1,:), q1(:,js-2:je+2,:), dt)

return
end subroutine advection_sphere_3d

!===========================================================================================

subroutine vanleer_sphere_3d(dq_dt, vc, q, dt)

real, intent(in),    dimension(:,js-2:,:) :: q
real, intent(in),    dimension(:,js  :,:) :: vc
real, intent(in)                          :: dt
real, intent(inout), dimension(:,js  :,:) :: dq_dt

real, dimension(nx, js  :je+1, size(q,3)) :: flux
real, dimension(nx ,js-1:je+1, size(q,3)) :: s

real, dimension(js-1:je+1) :: dtdy 
real, dimension(js  :je) :: dyc
integer :: j

dtdy(js-1:je+1) = dt/(dy(js-1:je+1)) 
dyc (js  :je) = 1.0/(dy(js:je)*c(js:je))

call slope_sphere(s(:,js-1:je+1,:), q(:,js-2:je+2,:))

do j = js,je+1
  where (vc(:,j,:) >= 0.0) 
    flux(:,j,:) = vc(:,j,:)*cc(j) * &
             (q(:,j-1,:) + 0.5*s(:,j-1,:)*(1.0 - dtdy(j-1)*vc(:,j,:)))
  elsewhere
    flux(:,j,:) = vc(:,j,:)*cc(j) * &
             (q(:,j,:)   - 0.5*s(:,j,:)  *(1.0 + dtdy(j)  *vc(:,j,:)))
  end where
end do

if(js == 1) flux(:,js,: ) = 0.0
if(je == ny) flux(:,je+1,:) = 0.0

do j = js,je
  dq_dt(:,j,:) = dq_dt(:,j,:) - dyc(j)*(flux(:,j+1,:) - flux(:,j,:))
end do

return
end subroutine vanleer_sphere_3d

!===========================================================================================

subroutine vanleer_x_3d(dq_dt, uc, q, dt)

real, intent(in),  dimension(:,js:,:)   :: uc, q
real, intent(in)                        :: dt
real, intent(inout), dimension(:,js:,:) :: dq_dt

real   , dimension(nx+1,js:je,size(q,3)) :: flux
real   , dimension(nx  ,js:je,size(q,3)) :: b, bb, qq, ss, s
integer, dimension(nx  ,js:je,size(q,3)) :: ii

integer :: i, j, k

do j = js,je
  b(:,j,:)  = uc(:,j,:)*dt/(dx*c(j))
end do
bb = b - int(b)

flux = 0.0
do j = js, je   ! try doing one row at a time to avoid unecessary computations
  if(maxval(abs(b(:,j:j,:))) > 1.0 ) &
      call integer_flux_x(flux(1:nx,j:j,:), b(:,j:j,:), q(:,j:j,:))
end do
call slope_x(s, q)
call find_cell_x(ii, b)

do k = 1, size(q,3)
  do j = js,je
    do i = 1, nx
      qq(i,j,k)  = q(ii(i,j,k),j,k)
      ss(i,j,k)  = s(ii(i,j,k),j,k)
    end do
  end do
end do

flux(1:nx,:,:) = flux(1:nx,:,:) + bb*(qq + 0.5*ss*(sign(1.0,bb) - bb))
flux(nx+1,:,:) = flux(1,:,:)

dq_dt = dq_dt - (flux(2:nx+1,:,:) - flux(1:nx,:,:))/dt

do j = js,je
  flux(:,j,:)  = flux(:,j,:)*dt/(dx*c(j))
end do


return
end subroutine vanleer_x_3d

!===========================================================================================

subroutine semi_x_3d(dq, ua, q, dt)

real, intent(in),  dimension(:,js:,:) :: ua, q
real, intent(in)                      :: dt
real, intent(out), dimension(:,js:,:) :: dq

real   , dimension(nx,js:je,size(q,3)) :: b, bb, q_left, q_right
integer, dimension(nx,js:je,size(q,3)) :: ii, i_left, i_right

integer :: i, j, k

do j = js,je
  b(:,j,:)  = ua(:,j,:)*dt/(dx*c(j))
end do

call find_cell_x(ii, b)

i_left  = ii
i_right = i_left + 1
where(i_right.gt.nx) i_right = 1

bb = b - floor(b)

do k = 1, size(q,3)
  do j = js,je
    do i = 1, nx
      q_left (i,j,k) = q(i_left (i,j,k),j,k)
      q_right(i,j,k) = q(i_right(i,j,k),j,k)
    end do
  end do
end do

dq(:,js:je,:) = bb(:,js:je,:)*q_left (:,js:je,:) + (1.0 - bb(:,js:je,:))*q_right(:,js:je,:) &
               - q(:,js:je,:)

return
end subroutine semi_x_3d

!===========================================================================================

subroutine semi_y_3d(dq, va, qx, dt)

real, intent(out), dimension(:,js  :,:) :: dq
real, intent(in),  dimension(:,js  :,:) :: va
real, intent(in),  dimension(:,js-2:,:) :: qx
real, intent(in)                        :: dt

integer :: j

do j = js, je
  where (va(:,j,:) >= 0.0) 
    dq(:,j,:) = va(:,j,:)*dt*(qx(:,j-1,:) - qx(:,j  ,:))/dyy(j)
  elsewhere
    dq(:,j,:) = va(:,j,:)*dt*(qx(:,j  ,:) - qx(:,j+1,:))/dyy(j+1)
  end where
enddo

return
end subroutine semi_y_3d

!===========================================================================================

subroutine find_cell_x(ii,b)
!!dir$ INLINEALWAYS find_cell_x
integer, intent(out),  dimension(:,:,:) :: ii
real   , intent(in) ,  dimension(:,:,:) :: b

integer :: i

do i = 1,nx
  ii(i,:,:) = i-1 
end do

ii = ii - floor(b)

where(ii.gt.nx) ii = ii - nx
where(ii.lt.1 ) ii = ii + nx

return
end subroutine find_cell_x

!===========================================================================================

subroutine slope_x(slope, q)

real, intent(in),  dimension(:,:,:) :: q
real, intent(out), dimension(:,:,:) :: slope

real, dimension(size(q,1),size(q,2),size(q,3)) :: grad, q_min, q_max
integer :: n

n = size(q,1)

grad(2:n,:,:)  = q(2:n,:,:)-q(1:n-1,:,:)
grad(1,:,:)    = q(1,:,:)-q(n,:,:)

slope(1:n-1,:,:) = (grad(2:n,:,:) + grad(1:n-1,:,:))/2
slope(n,:,:) = (grad(1,:,:) + grad(n,:,:))/2

if(monotone) then

  q_min(2:n-1,:,:) = min(q(1:n-2,:,:),q(2:n-1,:,:),q(3:n,:,:))
  q_min(1,:,:)     = min(q(n,:,:)    ,q(1,:,:)    ,q(2,:,:)  )
  q_min(n,:,:)     = min(q(n-1,:,:)  ,q(n,:,:)    ,q(1,:,:)  )

  q_max(2:n-1,:,:) = max(q(1:n-2,:,:),q(2:n-1,:,:),q(3:n,:,:))
  q_max(1,:,:)     = max(q(n,:,:)    ,q(1,:,:)    ,q(2,:,:)  )
  q_max(n,:,:)     = max(q(n-1,:,:)  ,q(n,:,:)    ,q(1,:,:)  )

  slope = sign(1.0,slope) * min( abs(slope), 2.0*(q - q_min), 2.0*(q_max - q))
else
  slope = sign(1.0,slope) * min( abs(slope), 2.0*q )
end if

return
end subroutine slope_x

!===========================================================================================

subroutine integer_flux_x(flux, c, q)

real, intent(out),  dimension(:,:,:) :: flux
real, intent(in) ,  dimension(:,:,:) :: c, q

integer, dimension(size(c,1),size(c,2),size(c,3)) :: ii
integer :: n, i, j, k

n = size(c,1)
ii = int(c)

flux = 0.0

do k = 1, size(c,3)
  do j = 1, size(c,2)

      do i = 1, size(c,1)
        if(ii(i,j,k) >= 1) then
          if(i-ii(i,j,k) >= 1) then
             flux(i,j,k) = sum(q(i-ii(i,j,k):i-1,j,k))
          else
             flux(i,j,k) = sum(q(1:i-1,j,k)) + sum(q(i-ii(i,j,k)+n:n,j,k))
          end if
        else if (ii(i,j,k) <= -1) then
          if(i-1-ii(i,j,k) <= n) then
            flux(i,j,k) = -sum(q(i:i-1-ii(i,j,k),j,k))
          else
            flux(i,j,k) = -sum(q(i:n,j,k)) - sum(q(1:i-1-ii(i,j,k)-n,j,k))
          end if
        end if
      end do

  end do
end do
return
end subroutine integer_flux_x

!===========================================================================================

subroutine slope_sphere(slope, q)

real, intent(in),  dimension(:,js-2:,:) :: q
real, intent(out), dimension(:,js-1:,:) :: slope

real, dimension(nx,js-1:je+1,size(q,3)) :: q_max, q_min
integer :: j

do j = js-1, je+1
  slope(:,j,:) = (q(:,j+1,:) - q(:,j  ,:))*dy_plus (j) &
               + (q(:,j  ,:) - q(:,j-1,:))*dy_minus(j)
end do

if(monotone) then
  q_min = min(q(:,js-2:je,:),q(:,js-1:je+1,:),q(:,js:je+2,:))
  q_max = max(q(:,js-2:je,:),q(:,js-1:je+1,:),q(:,js:je+2,:))

  slope = sign(1.0,slope) * &
        min( abs(slope), 2.0*(q(:,js-1:je+1,:) - q_min), 2.0*(q_max - q(:,js-1:je+1,:)) )
else
  slope = sign(1.0,slope) * min( abs(slope), 2.0*q(:,js-1:je+1,:) )
end if
return
end subroutine slope_sphere

!===========================================================================================

subroutine solid_body(u, v)

!  used for check-out only

real, intent(out), dimension(nx,ny) :: u,v
real :: beta
integer :: i,j

beta = 45.0

do j = 1, ny
  do i = 1, nx
    v(i,j) = - sin(beta*pi/180.0)*sin(2.*pi*float(i)/float(nx))
    u(i,j) =   cos(beta*pi/180.0)*c(j)        &
             + sin(beta*pi/180.0)*cos(2.*pi*float(i)/float(nx))*s(j)
  end do
end do

end subroutine solid_body

!===========================================================================================
subroutine fv_advection_end

if(.not.module_is_initialized) return

deallocate(y, yy, c, s, cc, dy, dyy, dyyy, dy_plus, dy_minus)
module_is_initialized = .false.

return
end subroutine fv_advection_end
!===========================================================================================

end module fv_advection_mod

!-----------------------------------------------------------------------
!                 Communication for message-passing codes
!
! AUTHOR: V. Balaji (V.Balaji@noaa.gov)
!         SGI/GFDL Princeton University
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! For the full text of the GNU General Public License,
! write to: Free Software Foundation, Inc.,
!           675 Mass Ave, Cambridge, MA 02139, USA.  
!-----------------------------------------------------------------------
module mpp_mod
!a generalized communication package for use with shmem and MPI
!will add: co_array_fortran, MPI2
!Balaji (V.Balaji@noaa.gov) 11 May 1998

! <CONTACT EMAIL="V.Balaji@noaa.gov">
!   V. Balaji
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>
! <RCSLOG SRC="http://www.gfdl.noaa.gov/~vb/changes_mpp.html"/>

! <OVERVIEW>
!   <TT>mpp_mod</TT>, is a set of simple calls to provide a uniform interface
!   to different message-passing libraries. It currently can be
!   implemented either in the SGI/Cray native SHMEM library or in the MPI
!   standard. Other libraries (e.g MPI-2, Co-Array Fortran) can be
!   incorporated as the need arises.
! </OVERVIEW>

! <DESCRIPTION>
!   The data transfer between a processor and its own memory is based
!   on <TT>load</TT> and <TT>store</TT> operations upon
!   memory. Shared-memory systems (including distributed shared memory
!   systems) have a single address space and any processor can acquire any
!   data within the memory by <TT>load</TT> and
!   <TT>store</TT>. The situation is different for distributed
!   parallel systems. Specialized MPP systems such as the T3E can simulate
!   shared-memory by direct data acquisition from remote memory. But if
!   the parallel code is distributed across a cluster, or across the Net,
!   messages must be sent and received using the protocols for
!   long-distance communication, such as TCP/IP. This requires a
!   ``handshaking'' between nodes of the distributed system. One can think
!   of the two different methods as involving <TT>put</TT>s or
!   <TT>get</TT>s (e.g the SHMEM library), or in the case of
!   negotiated communication (e.g MPI), <TT>send</TT>s and
!   <TT>recv</TT>s.
!   
!   The difference between SHMEM and MPI is that SHMEM uses one-sided
!   communication, which can have very low-latency high-bandwidth
!   implementations on tightly coupled systems. MPI is a standard
!   developed for distributed computing across loosely-coupled systems,
!   and therefore incurs a software penalty for negotiating the
!   communication. It is however an open industry standard whereas SHMEM
!   is a proprietary interface. Besides, the <TT>put</TT>s or
!   <TT>get</TT>s on which it is based cannot currently be implemented in
!   a cluster environment (there are recent announcements from Compaq that
!   occasion hope).
!   
!   The message-passing requirements of climate and weather codes can be
!   reduced to a fairly simple minimal set, which is easily implemented in
!   any message-passing API. <TT>mpp_mod</TT> provides this API.
!
!    Features of <TT>mpp_mod</TT> include:
!   
!    1) Simple, minimal API, with free access to underlying API for
!       more complicated stuff.<BR/>
!    2) Design toward typical use in climate/weather CFD codes.<BR/>
!    3) Performance to be not significantly lower than any native API.
!   
!   This module is used to develop higher-level calls for <LINK 
!   SRC="mpp_domains.html">domain decomposition</LINK> and <LINK
!   SRC="mpp_io.html">parallel I/O</LINK>.
!   
!   Parallel computing is initially daunting, but it soon becomes
!   second nature, much the way many of us can now write vector code
!   without much effort. The key insight required while reading and
!   writing parallel code is in arriving at a mental grasp of several
!   independent parallel execution streams through the same code (the SPMD
!   model). Each variable you examine may have different values for each
!   stream, the processor ID being an obvious example. Subroutines and
!   function calls are particularly subtle, since it is not always obvious
!   from looking at a call what synchronization between execution streams
!   it implies. An example of erroneous code would be a global barrier
!   call (see <LINK SRC="#mpp_sync">mpp_sync</LINK> below) placed
!   within a code block that not all PEs will execute, e.g:
!   
!   <PRE>
!   if( pe.EQ.0 )call mpp_sync()
!   </PRE>
!   
!   Here only PE 0 reaches the barrier, where it will wait
!   indefinitely. While this is a particularly egregious example to
!   illustrate the coding flaw, more subtle versions of the same are
!   among the most common errors in parallel code.
!   
!   It is therefore important to be conscious of the context of a
!   subroutine or function call, and the implied synchronization. There
!   are certain calls here (e.g <TT>mpp_declare_pelist, mpp_init,
!   mpp_malloc, mpp_set_stack_size</TT>) which must be called by all
!   PEs. There are others which must be called by a subset of PEs (here
!   called a <TT>pelist</TT>) which must be called by all the PEs in the
!   <TT>pelist</TT> (e.g <TT>mpp_max, mpp_sum, mpp_sync</TT>). Still
!   others imply no synchronization at all. I will make every effort to
!   highlight the context of each call in the MPP modules, so that the
!   implicit synchronization is spelt out.  
!   
!   For performance it is necessary to keep synchronization as limited
!   as the algorithm being implemented will allow. For instance, a single
!   message between two PEs should only imply synchronization across the
!   PEs in question. A <I>global</I> synchronization (or <I>barrier</I>)
!   is likely to be slow, and is best avoided. But codes first
!   parallelized on a Cray T3E tend to have many global syncs, as very
!   fast barriers were implemented there in hardware.
!   
!   Another reason to use pelists is to run a single program in MPMD
!   mode, where different PE subsets work on different portions of the
!   code. A typical example is to assign an ocean model and atmosphere
!   model to different PE subsets, and couple them concurrently instead of
!   running them serially. The MPP module provides the notion of a
!   <I>current pelist</I>, which is set when a group of PEs branch off
!   into a subset. Subsequent calls that omit the <TT>pelist</TT> optional
!   argument (seen below in many of the individual calls) assume that the
!   implied synchronization is across the current pelist. The calls
!   <TT>mpp_root_pe</TT> and <TT>mpp_npes</TT> also return the values
!   appropriate to the current pelist. The <TT>mpp_set_current_pelist</TT>
!   call is provided to set the current pelist.

! </DESCRIPTION>
! <PUBLIC>
!  F90 is a strictly-typed language, and the syntax pass of the
!  compiler requires matching of type, kind and rank (TKR). Most calls
!  listed here use a generic type, shown here as <TT>MPP_TYPE_</TT>. This
!  is resolved in the pre-processor stage to any of a variety of
!  types. In general the MPP operations work on 4-byte and 8-byte
!  variants of <TT>integer, real, complex, logical</TT> variables, of
!  rank 0 to 5, leading to 48 specific module procedures under the same
!  generic interface. Any of the variables below shown as
!  <TT>MPP_TYPE_</TT> is treated in this way.
! </PUBLIC>

#include <fms_platform.h>

#if defined(use_libSMA) && defined(sgi_mipspro)
  use shmem_interface
#endif

#if defined(use_libMPI) && defined(sgi_mipspro)
  use mpi
#endif

  use mpp_parameter_mod, only : MPP_VERBOSE, MPP_DEBUG, ALL_PES, ANY_PE, NULL_PE
  use mpp_parameter_mod, only : NOTE, WARNING, FATAL, MPP_CLOCK_DETAILED,MPP_CLOCK_SYNC
  use mpp_parameter_mod, only : CLOCK_COMPONENT, CLOCK_SUBCOMPONENT, CLOCK_MODULE_DRIVER
  use mpp_parameter_mod, only : CLOCK_MODULE, CLOCK_ROUTINE, CLOCK_LOOP, CLOCK_INFRA
  use mpp_parameter_mod, only : MAX_EVENTS, MAX_BINS, MAX_EVENT_TYPES, MAX_CLOCKS
  use mpp_parameter_mod, only : MAXPES, EVENT_WAIT, EVENT_ALLREDUCE, EVENT_BROADCAST
  use mpp_parameter_mod, only : EVENT_ALLTOALL
  use mpp_parameter_mod, only : EVENT_RECV, EVENT_SEND, MPP_READY, MPP_WAIT
  use mpp_parameter_mod, only : mpp_parameter_version=>version, mpp_parameter_tagname=>tagname
  use mpp_parameter_mod, only : DEFAULT_TAG
  use mpp_parameter_mod, only : COMM_TAG_1,  COMM_TAG_2,  COMM_TAG_3,  COMM_TAG_4
  use mpp_parameter_mod, only : COMM_TAG_5,  COMM_TAG_6,  COMM_TAG_7,  COMM_TAG_8
  use mpp_parameter_mod, only : COMM_TAG_9,  COMM_TAG_10, COMM_TAG_11, COMM_TAG_12
  use mpp_parameter_mod, only : COMM_TAG_13, COMM_TAG_14, COMM_TAG_15, COMM_TAG_16
  use mpp_parameter_mod, only : COMM_TAG_17, COMM_TAG_18, COMM_TAG_19, COMM_TAG_20
  use mpp_parameter_mod, only : MPP_FILL_INT,MPP_FILL_DOUBLE
  use mpp_data_mod,      only : stat, mpp_stack, ptr_stack, status, ptr_status, sync, ptr_sync  
  use mpp_data_mod,      only : mpp_from_pe, ptr_from, remote_data_loc, ptr_remote
  use mpp_data_mod,      only : mpp_data_version=>version, mpp_data_tagname=>tagname

implicit none
private

#if defined(use_libSMA) 
#include <mpp/shmem.fh>
#endif

#if defined(use_libMPI) && !defined(sgi_mipspro)
#include <mpif.h>   
!sgi_mipspro gets this from 'use mpi'
#endif

  !--- public paramters  -----------------------------------------------
  public :: MPP_VERBOSE, MPP_DEBUG, ALL_PES, ANY_PE, NULL_PE, NOTE, WARNING, FATAL
  public :: MPP_CLOCK_SYNC, MPP_CLOCK_DETAILED, CLOCK_COMPONENT, CLOCK_SUBCOMPONENT
  public :: CLOCK_MODULE_DRIVER, CLOCK_MODULE, CLOCK_ROUTINE, CLOCK_LOOP, CLOCK_INFRA
  public :: MAXPES, EVENT_RECV, EVENT_SEND, INPUT_STR_LENGTH
  public :: COMM_TAG_1,  COMM_TAG_2,  COMM_TAG_3,  COMM_TAG_4
  public :: COMM_TAG_5,  COMM_TAG_6,  COMM_TAG_7,  COMM_TAG_8
  public :: COMM_TAG_9,  COMM_TAG_10, COMM_TAG_11, COMM_TAG_12
  public :: COMM_TAG_13, COMM_TAG_14, COMM_TAG_15, COMM_TAG_16
  public :: COMM_TAG_17, COMM_TAG_18, COMM_TAG_19, COMM_TAG_20
  public :: MPP_FILL_INT,MPP_FILL_DOUBLE

  !--- public data from mpp_data_mod ------------------------------
!  public :: request

  !--- public interface from mpp_util.h ------------------------------
  public :: stdin, stdout, stderr, stdlog, lowercase, uppercase, mpp_error, mpp_error_state
  public :: mpp_set_warn_level, mpp_sync, mpp_sync_self, mpp_set_stack_size, mpp_pe
  public :: mpp_node, mpp_npes, mpp_root_pe, mpp_set_root_pe, mpp_declare_pelist
  public :: mpp_get_current_pelist, mpp_set_current_pelist, mpp_get_current_pelist_name
  public :: mpp_clock_id, mpp_clock_set_grain, mpp_record_timing_data, get_unit
  public :: read_ascii_file, read_input_nml, mpp_clock_begin, mpp_clock_end
  public :: get_ascii_file_num_lines
  public :: mpp_record_time_start, mpp_record_time_end

  !--- public interface from mpp_comm.h ------------------------------
  public :: mpp_chksum, mpp_max, mpp_min, mpp_sum, mpp_transmit, mpp_send, mpp_recv
  public :: mpp_broadcast, mpp_malloc, mpp_init, mpp_exit
  public :: mpp_gather, mpp_scatter, mpp_alltoall
#ifdef use_MPI_GSM
  public :: mpp_gsm_malloc, mpp_gsm_free
#endif

  !*********************************************************************
  !
  !    public data type
  !
  !*********************************************************************
  !peset hold communicators as SHMEM-compatible triads (start, log2(stride), num)
  type :: communicator
     private
     character(len=32) :: name
     integer, pointer  :: list(:) =>NULL()
     integer           :: count
     integer           :: start, log2stride ! dummy variables when libMPI is defined.
     integer           :: id, group         ! MPI communicator and group id for this PE set.
                                            ! dummy variables when libSMA is defined.
  end type communicator

  type :: event
     private
     character(len=16)                         :: name
     integer(LONG_KIND), dimension(MAX_EVENTS) :: ticks, bytes
     integer                                   :: calls
  end type event

  !a clock contains an array of event profiles for a region
  type :: clock
     private
     character(len=32)    :: name
     integer(LONG_KIND)   :: tick
     integer(LONG_KIND)   :: total_ticks
     integer              :: peset_num
     logical              :: sync_on_begin, detailed
     integer              :: grain
     type(event), pointer :: events(:) =>NULL() !if needed, allocate to MAX_EVENT_TYPES
     logical              :: is_on              !initialize to false. set true when calling mpp_clock_begin
                                                ! set false when calling mpp_clock_end
  end type clock

  type :: Clock_Data_Summary
     private
     character(len=16)  :: name
     real(DOUBLE_KIND)  :: msg_size_sums(MAX_BINS)
     real(DOUBLE_KIND)  :: msg_time_sums(MAX_BINS)
     real(DOUBLE_KIND)  :: total_data
     real(DOUBLE_KIND)  :: total_time
     integer(LONG_KIND) :: msg_size_cnts(MAX_BINS)
     integer(LONG_KIND) :: total_cnts
  end type Clock_Data_Summary

  type :: Summary_Struct
     private
     character(len=16)         :: name
     type (Clock_Data_Summary) :: event(MAX_EVENT_TYPES)
  end type Summary_Struct

!***********************************************************************
!
!     public interface from mpp_util.h
!
!***********************************************************************
  ! <INTERFACE NAME="mpp_error">
  !  <OVERVIEW>
  !    Error handler.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    It is strongly recommended that all error exits pass through
  !    <TT>mpp_error</TT> to assure the program fails cleanly. An individual
  !    PE encountering a <TT>STOP</TT> statement, for instance, can cause the
  !    program to hang. The use of the <TT>STOP</TT> statement is strongly
  !    discouraged.
  !    
  !    Calling mpp_error with no arguments produces an immediate error
  !    exit, i.e:
  !    <PRE>
  !    call mpp_error
  !    call mpp_error(FATAL)
  !    </PRE>
  !    are equivalent.
  !    
  !    The argument order
  !    <PRE>
  !    call mpp_error( routine, errormsg, errortype )
  !    </PRE>
  !    is also provided to support legacy code. In this version of the
  !    call, none of the arguments may be omitted.
  !    
  !    The behaviour of <TT>mpp_error</TT> for a <TT>WARNING</TT> can be
  !    controlled with an additional call <TT>mpp_set_warn_level</TT>.
  !    <PRE>
  !    call mpp_set_warn_level(ERROR)
  !    </PRE>
  !    causes <TT>mpp_error</TT> to treat <TT>WARNING</TT>
  !    exactly like <TT>FATAL</TT>.
  !    <PRE>
  !    call mpp_set_warn_level(WARNING)
  !    </PRE>
  !    resets to the default behaviour described above.
  !    
  !    <TT>mpp_error</TT> also has an internal error state which
  !    maintains knowledge of whether a warning has been issued. This can be
  !    used at startup in a subroutine that checks if the model has been
  !    properly configured. You can generate a series of warnings using
  !    <TT>mpp_error</TT>, and then check at the end if any warnings has been
  !    issued using the function <TT>mpp_error_state()</TT>. If the value of
  !    this is <TT>WARNING</TT>, at least one warning has been issued, and
  !    the user can take appropriate action:
  !    
  !    <PRE>
  !    if( ... )call mpp_error( WARNING, '...' )
  !    if( ... )call mpp_error( WARNING, '...' )
  !    if( ... )call mpp_error( WARNING, '...' )
  !    ...
  !    if( mpp_error_state().EQ.WARNING )call mpp_error( FATAL, '...' )
  !    </PRE>
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_error( errortype, routine, errormsg )
  !  </TEMPLATE>
  !  <IN NAME="errortype">
  !    One of <TT>NOTE</TT>, <TT>WARNING</TT> or <TT>FATAL</TT> 
  !    (these definitions are acquired by use association).
  !    <TT>NOTE</TT> writes <TT>errormsg</TT> to <TT>STDOUT</TT>. 
  !    <TT>WARNING</TT> writes <TT>errormsg</TT> to <TT>STDERR</TT>.
  !    <TT>FATAL</TT> writes <TT>errormsg</TT> to <TT>STDERR</TT>,
  !    and induces a clean error exit with a call stack traceback.
  !  </IN>
  ! </INTERFACE>
  interface mpp_error
     module procedure mpp_error_basic
     module procedure mpp_error_mesg
     module procedure mpp_error_noargs
     module procedure mpp_error_is
     module procedure mpp_error_rs
     module procedure mpp_error_ia
     module procedure mpp_error_ra
     module procedure mpp_error_ia_ia
     module procedure mpp_error_ia_ra
     module procedure mpp_error_ra_ia
     module procedure mpp_error_ra_ra
     module procedure mpp_error_ia_is
     module procedure mpp_error_ia_rs
     module procedure mpp_error_ra_is
     module procedure mpp_error_ra_rs
     module procedure mpp_error_is_ia
     module procedure mpp_error_is_ra
     module procedure mpp_error_rs_ia
     module procedure mpp_error_rs_ra
     module procedure mpp_error_is_is
     module procedure mpp_error_is_rs
     module procedure mpp_error_rs_is
     module procedure mpp_error_rs_rs
  end interface

  interface array_to_char
     module procedure iarray_to_char
     module procedure rarray_to_char
  end interface

!***********************************************************************
!
!    public interface from mpp_comm.h
!
!***********************************************************************
#ifdef use_libSMA
  !currently SMA contains no generic shmem_wait for different integer kinds:
  !I have inserted one here
  interface shmem_integer_wait
     module procedure shmem_int4_wait_local
     module procedure shmem_int8_wait_local
  end interface
#endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !                                                                             !
  !       ROUTINES TO INITIALIZE/FINALIZE MPP MODULE: mpp_init, mpp_exit        !
  !                                                                             !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  ! <SUBROUTINE NAME="mpp_init">
  !  <OVERVIEW>
  !   Initialize <TT>mpp_mod</TT>.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Called to initialize the <TT>mpp_mod</TT> package. It is recommended
  !   that this call be the first executed line in your program. It sets the
  !   number of PEs assigned to this run (acquired from the command line, or
  !   through the environment variable <TT>NPES</TT>), and associates an ID
  !   number to each PE. These can be accessed by calling <LINK
  !   SRC="#mpp_npes"><TT>mpp_npes</TT></LINK> and <LINK
  !   SRC="#mpp_pe"><TT>mpp_pe</TT></LINK>.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call mpp_init( flags )
  !  </TEMPLATE>
  !  <IN NAME="flags" TYPE="integer">
  !   <TT>flags</TT> can be set to <TT>MPP_VERBOSE</TT> to
  !   have <TT>mpp_mod</TT> keep you informed of what it's up to.
  !  </IN>
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="mpp_exit">
  !  <OVERVIEW>
  !   Exit <TT>mpp_mod</TT>.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Called at the end of the run, or to re-initialize <TT>mpp_mod</TT>,
  !   should you require that for some odd reason.
  !
  !   This call implies synchronization across all PEs.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call mpp_exit()
  !  </TEMPLATE>
  ! </SUBROUTINE>

  !#######################################################################
  ! <SUBROUTINE NAME="mpp_malloc">
  !  <OVERVIEW>
  !    Symmetric memory allocation.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    This routine is used on SGI systems when <TT>mpp_mod</TT> is
  !    invoked in the SHMEM library. It ensures that dynamically allocated
  !    memory can be used with <TT>shmem_get</TT> and
  !    <TT>shmem_put</TT>. This is called <I>symmetric
  !    allocation</I> and is described in the
  !    <TT>intro_shmem</TT> man page. <TT>ptr</TT> is a <I>Cray
  !    pointer</I> (see the section on <LINK
  !    SRC="#PORTABILITY">portability</LINK>).  The operation can be expensive
  !    (since it requires a global barrier). We therefore attempt to re-use
  !    existing allocation whenever possible. Therefore <TT>len</TT>
  !    and <TT>ptr</TT> must have the <TT>SAVE</TT> attribute
  !    in the calling routine, and retain the information about the last call
  !    to <TT>mpp_malloc</TT>. Additional memory is symmetrically
  !    allocated if and only if <TT>newlen</TT> exceeds
  !    <TT>len</TT>.
  !
  !    This is never required on Cray PVP or MPP systems. While the T3E
  !    manpages do talk about symmetric allocation, <TT>mpp_mod</TT>
  !    is coded to remove this restriction.
  !
  !    It is never required if <TT>mpp_mod</TT> is invoked in MPI.
  !
  !   This call implies synchronization across all PEs.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call mpp_malloc( ptr, newlen, len )
  !  </TEMPLATE>
  !  <IN NAME="ptr">
  !     a cray pointer, points to a dummy argument in this routine.
  !  </IN>
  !  <IN NAME="newlen" TYPE="integer">
  !     the required allocation length for the pointer ptr
  !  </IN>
  !  <IN NAME="len" TYPE="integer">
  !     the current allocation (0 if unallocated).
  !  </IN>
  ! </SUBROUTINE>

  !#####################################################################

  ! <SUBROUTINE NAME="mpp_set_stack_size">
  !  <OVERVIEW>
  !    Allocate module internal workspace.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    <TT>mpp_mod</TT> maintains a private internal array called
  !    <TT>mpp_stack</TT> for private workspace. This call sets the length,
  !    in words, of this array. 
  !
  !    The <TT>mpp_init</TT> call sets this
  !    workspace length to a default of 32768, and this call may be used if a
  !    longer workspace is needed.
  !    
  !    This call implies synchronization across all PEs.
  !    
  !    This workspace is symmetrically allocated, as required for
  !    efficient communication on SGI and Cray MPP systems. Since symmetric
  !    allocation must be performed by <I>all</I> PEs in a job, this call
  !    must also be called by all PEs, using the same value of
  !    <TT>n</TT>. Calling <TT>mpp_set_stack_size</TT> from a subset of PEs,
  !    or with unequal argument <TT>n</TT>, may cause the program to hang.
  !    
  !    If any MPP call using <TT>mpp_stack</TT> overflows the declared
  !    stack array, the program will abort with a message specifying the
  !    stack length that is required. Many users wonder why, if the required
  !    stack length can be computed, it cannot also be specified at that
  !    point. This cannot be automated because there is no way for the
  !    program to know if all PEs are present at that call, and with equal
  !    values of <TT>n</TT>. The program must be rerun by the user with the
  !    correct argument to <TT>mpp_set_stack_size</TT>, called at an
  !    appropriate point in the code where all PEs are known to be present.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_set_stack_size(n)
  !  </TEMPLATE>
  !  <IN NAME="n" TYPE="integer"></IN>
  ! </SUBROUTINE>

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !                                                                             !
  !            GLOBAL REDUCTION ROUTINES: mpp_max, mpp_sum, mpp_min             !
  !                                                                             !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  ! <INTERFACE NAME="mpp_max">
  !  <OVERVIEW>
  !    Reduction operations.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    Find the max of scalar a the PEs in pelist
  !    result is also automatically broadcast to all PEs
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call  mpp_max( a, pelist )
  !  </TEMPLATE>
  !  <IN NAME="a">
  !    <TT>real</TT> or <TT>integer</TT>, of 4-byte of 8-byte kind.
  !  </IN>
  !  <IN NAME="pelist">
  !    If <TT>pelist</TT> is omitted, the context is assumed to be the
  !    current pelist. This call implies synchronization across the PEs in
  !    <TT>pelist</TT>, or the current pelist if <TT>pelist</TT> is absent.
  !  </IN>
  ! </INTERFACE>

  interface mpp_max
     module procedure mpp_max_real8
#ifndef no_8byte_integers
     module procedure mpp_max_int8
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_max_real4
#endif
     module procedure mpp_max_int4
  end interface

  interface mpp_min
     module procedure mpp_min_real8
#ifndef no_8byte_integers
     module procedure mpp_min_int8
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_min_real4
#endif
     module procedure mpp_min_int4
  end interface


  ! <INTERFACE NAME="mpp_sum">
  !  <OVERVIEW>
  !    Reduction operation.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    <TT>MPP_TYPE_</TT> corresponds to any 4-byte and 8-byte variant of
  !    <TT>integer, real, complex</TT> variables, of rank 0 or 1. A
  !    contiguous block from a multi-dimensional array may be passed by its
  !    starting address and its length, as in <TT>f77</TT>.
  !
  !    Library reduction operators are not required or guaranteed to be
  !    bit-reproducible. In any case, changing the processor count changes
  !    the data layout, and thus very likely the order of operations. For
  !    bit-reproducible sums of distributed arrays, consider using the
  !    <TT>mpp_global_sum</TT> routine provided by the <LINK
  !    SRC="mpp_domains.html"><TT>mpp_domains</TT></LINK> module.
  !
  !    The <TT>bit_reproducible</TT> flag provided in earlier versions of
  !    this routine has been removed.
  !
  !
  !    If <TT>pelist</TT> is omitted, the context is assumed to be the
  !    current pelist. This call implies synchronization across the PEs in
  !    <TT>pelist</TT>, or the current pelist if <TT>pelist</TT> is absent.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_sum( a, length, pelist )
  !  </TEMPLATE>
  !  <IN NAME="length"></IN>
  !  <IN NAME="pelist"></IN>
  !  <INOUT NAME="a"></INOUT>
  ! </INTERFACE>

  interface mpp_sum
#ifndef no_8byte_integers
     module procedure mpp_sum_int8
     module procedure mpp_sum_int8_scalar
     module procedure mpp_sum_int8_2d
     module procedure mpp_sum_int8_3d
     module procedure mpp_sum_int8_4d
     module procedure mpp_sum_int8_5d
#endif
     module procedure mpp_sum_real8
     module procedure mpp_sum_real8_scalar
     module procedure mpp_sum_real8_2d
     module procedure mpp_sum_real8_3d
     module procedure mpp_sum_real8_4d
     module procedure mpp_sum_real8_5d
#ifdef OVERLOAD_C8
     module procedure mpp_sum_cmplx8
     module procedure mpp_sum_cmplx8_scalar
     module procedure mpp_sum_cmplx8_2d
     module procedure mpp_sum_cmplx8_3d
     module procedure mpp_sum_cmplx8_4d
     module procedure mpp_sum_cmplx8_5d
#endif
     module procedure mpp_sum_int4
     module procedure mpp_sum_int4_scalar
     module procedure mpp_sum_int4_2d
     module procedure mpp_sum_int4_3d
     module procedure mpp_sum_int4_4d
     module procedure mpp_sum_int4_5d
#ifdef OVERLOAD_R4
     module procedure mpp_sum_real4
     module procedure mpp_sum_real4_scalar
     module procedure mpp_sum_real4_2d
     module procedure mpp_sum_real4_3d
     module procedure mpp_sum_real4_4d
     module procedure mpp_sum_real4_5d
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_sum_cmplx4
     module procedure mpp_sum_cmplx4_scalar
     module procedure mpp_sum_cmplx4_2d
     module procedure mpp_sum_cmplx4_3d
     module procedure mpp_sum_cmplx4_4d
     module procedure mpp_sum_cmplx4_5d
#endif
  end interface

  !#####################################################################
  ! <INTERFACE NAME="mpp_gather">
  !  <OVERVIEW>
  !    gather information onto root pe.
  !  </OVERVIEW>
  ! </INTERFACE>
  interface mpp_gather
     module procedure mpp_gather_int4_1d
     module procedure mpp_gather_real4_1d
     module procedure mpp_gather_real8_1d
     module procedure mpp_gather_int4_1dv
     module procedure mpp_gather_real4_1dv
     module procedure mpp_gather_real8_1dv
     module procedure mpp_gather_pelist_int4_2d
     module procedure mpp_gather_pelist_int4_3d
     module procedure mpp_gather_pelist_real4_2d
     module procedure mpp_gather_pelist_real4_3d
     module procedure mpp_gather_pelist_real8_2d
     module procedure mpp_gather_pelist_real8_3d
  end interface

  !#####################################################################
  ! <INTERFACE NAME="mpp_scatter">
  !  <OVERVIEW>
  !    gather information onto root pe.
  !  </OVERVIEW>
  ! </INTERFACE>
  interface mpp_scatter
     module procedure mpp_scatter_pelist_int4_2d
     module procedure mpp_scatter_pelist_int4_3d
     module procedure mpp_scatter_pelist_real4_2d
     module procedure mpp_scatter_pelist_real4_3d
     module procedure mpp_scatter_pelist_real8_2d
     module procedure mpp_scatter_pelist_real8_3d
  end interface

  !#####################################################################
  ! <interface name="mpp_alltoall">
  !   <overview>
  !     scatter a vector across all PEs
  !     (e.g. transpose the vector and PE index)
  !   </overview>
  ! </interface>
  interface mpp_alltoall
     module procedure mpp_alltoall_int4
     module procedure mpp_alltoall_int8
     module procedure mpp_alltoall_real4
     module procedure mpp_alltoall_real8
     module procedure mpp_alltoall_int4_v
     module procedure mpp_alltoall_int8_v
     module procedure mpp_alltoall_real4_v
     module procedure mpp_alltoall_real8_v
  end interface


  !#####################################################################

  ! <INTERFACE NAME="mpp_transmit">
  !  <OVERVIEW>
  !    Basic message-passing call.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    <TT>MPP_TYPE_</TT> corresponds to any 4-byte and 8-byte variant of
  !    <TT>integer, real, complex, logical</TT> variables, of rank 0 or 1. A
  !    contiguous block from a multi-dimensional array may be passed by its
  !    starting address and its length, as in <TT>f77</TT>.
  !    
  !    <TT>mpp_transmit</TT> is currently implemented as asynchronous
  !    outward transmission and synchronous inward transmission. This follows
  !    the behaviour of <TT>shmem_put</TT> and <TT>shmem_get</TT>. In MPI, it
  !    is implemented as <TT>mpi_isend</TT> and <TT>mpi_recv</TT>. For most
  !    applications, transmissions occur in pairs, and are here accomplished
  !    in a single call.
  !    
  !    The special PE designations <TT>NULL_PE</TT>,
  !    <TT>ANY_PE</TT> and <TT>ALL_PES</TT> are provided by use
  !    association.
  !    
  !    <TT>NULL_PE</TT>: is used to disable one of the pair of
  !    transmissions.<BR/>
  !    <TT>ANY_PE</TT>: is used for unspecific remote
  !    destination. (Please note that <TT>put_pe=ANY_PE</TT> has no meaning
  !    in the MPI context, though it is available in the SHMEM invocation. If
  !    portability is a concern, it is best avoided).<BR/>
  !    <TT>ALL_PES</TT>: is used for broadcast operations.
  !    
  !    It is recommended that <LINK
  !    SRC="#mpp_broadcast"><TT>mpp_broadcast</TT></LINK> be used for
  !    broadcasts.
  !    
  !    The following example illustrates the use of
  !    <TT>NULL_PE</TT> and <TT>ALL_PES</TT>:
  !    
  !    <PRE>
  !    real, dimension(n) :: a
  !    if( pe.EQ.0 )then
  !        do p = 1,npes-1
  !           call mpp_transmit( a, n, p, a, n, NULL_PE )
  !        end do
  !    else
  !        call mpp_transmit( a, n, NULL_PE, a, n, 0 )
  !    end if
  !    
  !    call mpp_transmit( a, n, ALL_PES, a, n, 0 )
  !    </PRE>
  !    
  !    The do loop and the broadcast operation above are equivalent.
  !    
  !    Two overloaded calls <TT>mpp_send</TT> and
  !     <TT>mpp_recv</TT> have also been
  !    provided. <TT>mpp_send</TT> calls <TT>mpp_transmit</TT>
  !    with <TT>get_pe=NULL_PE</TT>. <TT>mpp_recv</TT> calls
  !    <TT>mpp_transmit</TT> with <TT>put_pe=NULL_PE</TT>. Thus
  !    the do loop above could be written more succinctly:
  !    
  !    <PRE>
  !    if( pe.EQ.0 )then
  !        do p = 1,npes-1
  !           call mpp_send( a, n, p )
  !        end do
  !    else
  !        call mpp_recv( a, n, 0 )
  !    end if
  !    </PRE>
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_transmit( put_data, put_len, put_pe, get_data, get_len, get_pe )
  !  </TEMPLATE>
  ! </INTERFACE>
  interface mpp_transmit
     module procedure mpp_transmit_real8
     module procedure mpp_transmit_real8_scalar
     module procedure mpp_transmit_real8_2d
     module procedure mpp_transmit_real8_3d
     module procedure mpp_transmit_real8_4d
     module procedure mpp_transmit_real8_5d
#ifdef OVERLOAD_C8
     module procedure mpp_transmit_cmplx8
     module procedure mpp_transmit_cmplx8_scalar
     module procedure mpp_transmit_cmplx8_2d
     module procedure mpp_transmit_cmplx8_3d
     module procedure mpp_transmit_cmplx8_4d
     module procedure mpp_transmit_cmplx8_5d
#endif
#ifndef no_8byte_integers
     module procedure mpp_transmit_int8
     module procedure mpp_transmit_int8_scalar
     module procedure mpp_transmit_int8_2d
     module procedure mpp_transmit_int8_3d
     module procedure mpp_transmit_int8_4d
     module procedure mpp_transmit_int8_5d
     module procedure mpp_transmit_logical8
     module procedure mpp_transmit_logical8_scalar
     module procedure mpp_transmit_logical8_2d
     module procedure mpp_transmit_logical8_3d
     module procedure mpp_transmit_logical8_4d
     module procedure mpp_transmit_logical8_5d
#endif

     module procedure mpp_transmit_real4
     module procedure mpp_transmit_real4_scalar
     module procedure mpp_transmit_real4_2d
     module procedure mpp_transmit_real4_3d
     module procedure mpp_transmit_real4_4d
     module procedure mpp_transmit_real4_5d

#ifdef OVERLOAD_C4
     module procedure mpp_transmit_cmplx4
     module procedure mpp_transmit_cmplx4_scalar
     module procedure mpp_transmit_cmplx4_2d
     module procedure mpp_transmit_cmplx4_3d
     module procedure mpp_transmit_cmplx4_4d
     module procedure mpp_transmit_cmplx4_5d
#endif
     module procedure mpp_transmit_int4
     module procedure mpp_transmit_int4_scalar
     module procedure mpp_transmit_int4_2d
     module procedure mpp_transmit_int4_3d
     module procedure mpp_transmit_int4_4d
     module procedure mpp_transmit_int4_5d
     module procedure mpp_transmit_logical4
     module procedure mpp_transmit_logical4_scalar
     module procedure mpp_transmit_logical4_2d
     module procedure mpp_transmit_logical4_3d
     module procedure mpp_transmit_logical4_4d
     module procedure mpp_transmit_logical4_5d
  end interface
  interface mpp_recv
     module procedure mpp_recv_real8
     module procedure mpp_recv_real8_scalar
     module procedure mpp_recv_real8_2d
     module procedure mpp_recv_real8_3d
     module procedure mpp_recv_real8_4d
     module procedure mpp_recv_real8_5d
#ifdef OVERLOAD_C8
     module procedure mpp_recv_cmplx8
     module procedure mpp_recv_cmplx8_scalar
     module procedure mpp_recv_cmplx8_2d
     module procedure mpp_recv_cmplx8_3d
     module procedure mpp_recv_cmplx8_4d
     module procedure mpp_recv_cmplx8_5d
#endif
#ifndef no_8byte_integers
     module procedure mpp_recv_int8
     module procedure mpp_recv_int8_scalar
     module procedure mpp_recv_int8_2d
     module procedure mpp_recv_int8_3d
     module procedure mpp_recv_int8_4d
     module procedure mpp_recv_int8_5d
     module procedure mpp_recv_logical8
     module procedure mpp_recv_logical8_scalar
     module procedure mpp_recv_logical8_2d
     module procedure mpp_recv_logical8_3d
     module procedure mpp_recv_logical8_4d
     module procedure mpp_recv_logical8_5d
#endif

     module procedure mpp_recv_real4
     module procedure mpp_recv_real4_scalar
     module procedure mpp_recv_real4_2d
     module procedure mpp_recv_real4_3d
     module procedure mpp_recv_real4_4d
     module procedure mpp_recv_real4_5d

#ifdef OVERLOAD_C4
     module procedure mpp_recv_cmplx4
     module procedure mpp_recv_cmplx4_scalar
     module procedure mpp_recv_cmplx4_2d
     module procedure mpp_recv_cmplx4_3d
     module procedure mpp_recv_cmplx4_4d
     module procedure mpp_recv_cmplx4_5d
#endif
     module procedure mpp_recv_int4
     module procedure mpp_recv_int4_scalar
     module procedure mpp_recv_int4_2d
     module procedure mpp_recv_int4_3d
     module procedure mpp_recv_int4_4d
     module procedure mpp_recv_int4_5d
     module procedure mpp_recv_logical4
     module procedure mpp_recv_logical4_scalar
     module procedure mpp_recv_logical4_2d
     module procedure mpp_recv_logical4_3d
     module procedure mpp_recv_logical4_4d
     module procedure mpp_recv_logical4_5d
  end interface
  interface mpp_send
     module procedure mpp_send_real8
     module procedure mpp_send_real8_scalar
     module procedure mpp_send_real8_2d
     module procedure mpp_send_real8_3d
     module procedure mpp_send_real8_4d
     module procedure mpp_send_real8_5d
#ifdef OVERLOAD_C8
     module procedure mpp_send_cmplx8
     module procedure mpp_send_cmplx8_scalar
     module procedure mpp_send_cmplx8_2d
     module procedure mpp_send_cmplx8_3d
     module procedure mpp_send_cmplx8_4d
     module procedure mpp_send_cmplx8_5d
#endif
#ifndef no_8byte_integers
     module procedure mpp_send_int8
     module procedure mpp_send_int8_scalar
     module procedure mpp_send_int8_2d
     module procedure mpp_send_int8_3d
     module procedure mpp_send_int8_4d
     module procedure mpp_send_int8_5d
     module procedure mpp_send_logical8
     module procedure mpp_send_logical8_scalar
     module procedure mpp_send_logical8_2d
     module procedure mpp_send_logical8_3d
     module procedure mpp_send_logical8_4d
     module procedure mpp_send_logical8_5d
#endif

     module procedure mpp_send_real4
     module procedure mpp_send_real4_scalar
     module procedure mpp_send_real4_2d
     module procedure mpp_send_real4_3d
     module procedure mpp_send_real4_4d
     module procedure mpp_send_real4_5d

#ifdef OVERLOAD_C4
     module procedure mpp_send_cmplx4
     module procedure mpp_send_cmplx4_scalar
     module procedure mpp_send_cmplx4_2d
     module procedure mpp_send_cmplx4_3d
     module procedure mpp_send_cmplx4_4d
     module procedure mpp_send_cmplx4_5d
#endif
     module procedure mpp_send_int4
     module procedure mpp_send_int4_scalar
     module procedure mpp_send_int4_2d
     module procedure mpp_send_int4_3d
     module procedure mpp_send_int4_4d
     module procedure mpp_send_int4_5d
     module procedure mpp_send_logical4
     module procedure mpp_send_logical4_scalar
     module procedure mpp_send_logical4_2d
     module procedure mpp_send_logical4_3d
     module procedure mpp_send_logical4_4d
     module procedure mpp_send_logical4_5d
  end interface

  ! <INTERFACE NAME="mpp_broadcast">

  !   <OVERVIEW>
  !     Parallel broadcasts.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     The <TT>mpp_broadcast</TT> call has been added because the original
  !     syntax (using <TT>ALL_PES</TT> in <TT>mpp_transmit</TT>) did not
  !     support a broadcast across a pelist.
  !
  !     <TT>MPP_TYPE_</TT> corresponds to any 4-byte and 8-byte variant of
  !     <TT>integer, real, complex, logical</TT> variables, of rank 0 or 1. A
  !     contiguous block from a multi-dimensional array may be passed by its
  !     starting address and its length, as in <TT>f77</TT>.
  !
  !     Global broadcasts through the <TT>ALL_PES</TT> argument to <LINK
  !     SRC="#mpp_transmit"><TT>mpp_transmit</TT></LINK> are still provided for
  !     backward-compatibility.
  !
  !     If <TT>pelist</TT> is omitted, the context is assumed to be the
  !     current pelist. <TT>from_pe</TT> must belong to the current
  !     pelist. This call implies synchronization across the PEs in
  !     <TT>pelist</TT>, or the current pelist if <TT>pelist</TT> is absent.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call mpp_broadcast( data, length, from_pe, pelist )
  !   </TEMPLATE>
  !   <IN NAME="length"> </IN>
  !   <IN NAME="from_pe"> </IN>
  !   <IN NAME="pelist"> </IN>
  !   <INOUT NAME="data(*)"> </INOUT>
  ! </INTERFACE>
  interface mpp_broadcast
     module procedure mpp_broadcast_char
     module procedure mpp_broadcast_real8
     module procedure mpp_broadcast_real8_scalar
     module procedure mpp_broadcast_real8_2d
     module procedure mpp_broadcast_real8_3d
     module procedure mpp_broadcast_real8_4d
     module procedure mpp_broadcast_real8_5d
#ifdef OVERLOAD_C8
     module procedure mpp_broadcast_cmplx8
     module procedure mpp_broadcast_cmplx8_scalar
     module procedure mpp_broadcast_cmplx8_2d
     module procedure mpp_broadcast_cmplx8_3d
     module procedure mpp_broadcast_cmplx8_4d
     module procedure mpp_broadcast_cmplx8_5d
#endif
#ifndef no_8byte_integers
     module procedure mpp_broadcast_int8
     module procedure mpp_broadcast_int8_scalar
     module procedure mpp_broadcast_int8_2d
     module procedure mpp_broadcast_int8_3d
     module procedure mpp_broadcast_int8_4d
     module procedure mpp_broadcast_int8_5d
     module procedure mpp_broadcast_logical8
     module procedure mpp_broadcast_logical8_scalar
     module procedure mpp_broadcast_logical8_2d
     module procedure mpp_broadcast_logical8_3d
     module procedure mpp_broadcast_logical8_4d
     module procedure mpp_broadcast_logical8_5d
#endif

     module procedure mpp_broadcast_real4
     module procedure mpp_broadcast_real4_scalar
     module procedure mpp_broadcast_real4_2d
     module procedure mpp_broadcast_real4_3d
     module procedure mpp_broadcast_real4_4d
     module procedure mpp_broadcast_real4_5d

#ifdef OVERLOAD_C4
     module procedure mpp_broadcast_cmplx4
     module procedure mpp_broadcast_cmplx4_scalar
     module procedure mpp_broadcast_cmplx4_2d
     module procedure mpp_broadcast_cmplx4_3d
     module procedure mpp_broadcast_cmplx4_4d
     module procedure mpp_broadcast_cmplx4_5d
#endif
     module procedure mpp_broadcast_int4
     module procedure mpp_broadcast_int4_scalar
     module procedure mpp_broadcast_int4_2d
     module procedure mpp_broadcast_int4_3d
     module procedure mpp_broadcast_int4_4d
     module procedure mpp_broadcast_int4_5d
     module procedure mpp_broadcast_logical4
     module procedure mpp_broadcast_logical4_scalar
     module procedure mpp_broadcast_logical4_2d
     module procedure mpp_broadcast_logical4_3d
     module procedure mpp_broadcast_logical4_4d
     module procedure mpp_broadcast_logical4_5d
  end interface

  !#####################################################################
  ! <INTERFACE NAME="mpp_chksum">

  !   <OVERVIEW>
  !     Parallel checksums.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     <TT>mpp_chksum</TT> is a parallel checksum routine that returns an
  !     identical answer for the same array irrespective of how it has been
  !     partitioned across processors. <TT>LONG_KIND</TT>is the <TT>KIND</TT>
  !     parameter corresponding to long integers (see discussion on
  !     OS-dependent preprocessor directives) defined in
  !     the header file <TT>fms_platform.h</TT>. <TT>MPP_TYPE_</TT> corresponds to any
  !     4-byte and 8-byte variant of <TT>integer, real, complex, logical</TT>
  !     variables, of rank 0 to 5.
  !
  !     Integer checksums on FP data use the F90 <TT>TRANSFER()</TT>
  !     intrinsic.
  !
  !     The <LINK SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/shared/chksum/chksum.html">serial checksum module</LINK> is superseded
  !     by this function, and is no longer being actively maintained. This
  !     provides identical results on a single-processor job, and to perform
  !     serial checksums on a single processor of a parallel job, you only
  !     need to use the optional <TT>pelist</TT> argument.
  !     <PRE>
  !     use mpp_mod
  !     integer :: pe, chksum
  !     real :: a(:)
  !     pe = mpp_pe()
  !     chksum = mpp_chksum( a, (/pe/) )
  !     </PRE>
  !
  !     The additional functionality of <TT>mpp_chksum</TT> over
  !     serial checksums is to compute the checksum across the PEs in
  !     <TT>pelist</TT>. The answer is guaranteed to be the same for
  !     the same distributed array irrespective of how it has been
  !     partitioned.
  !
  !     If <TT>pelist</TT> is omitted, the context is assumed to be the
  !     current pelist. This call implies synchronization across the PEs in
  !     <TT>pelist</TT>, or the current pelist if <TT>pelist</TT> is absent.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     mpp_chksum( var, pelist )
  !   </TEMPLATE>
  !   <IN NAME="pelist" TYPE="integer" DIM="(:)"> </IN>
  !   <IN NAME="var" TYPE="MPP_TYPE_"> </IN>
  ! </INTERFACE>
  interface mpp_chksum
#ifndef no_8byte_integers
     module procedure mpp_chksum_i8_1d
     module procedure mpp_chksum_i8_2d
     module procedure mpp_chksum_i8_3d
     module procedure mpp_chksum_i8_4d
     module procedure mpp_chksum_i8_5d
     module procedure mpp_chksum_i8_1d_rmask
     module procedure mpp_chksum_i8_2d_rmask
     module procedure mpp_chksum_i8_3d_rmask
     module procedure mpp_chksum_i8_4d_rmask
     module procedure mpp_chksum_i8_5d_rmask

#endif
     module procedure mpp_chksum_i4_1d
     module procedure mpp_chksum_i4_2d
     module procedure mpp_chksum_i4_3d
     module procedure mpp_chksum_i4_4d
     module procedure mpp_chksum_i4_5d
     module procedure mpp_chksum_i4_1d_rmask
     module procedure mpp_chksum_i4_2d_rmask
     module procedure mpp_chksum_i4_3d_rmask
     module procedure mpp_chksum_i4_4d_rmask
     module procedure mpp_chksum_i4_5d_rmask
     module procedure mpp_chksum_r8_0d
     module procedure mpp_chksum_r8_1d
     module procedure mpp_chksum_r8_2d
     module procedure mpp_chksum_r8_3d
     module procedure mpp_chksum_r8_4d
     module procedure mpp_chksum_r8_5d
#ifdef OVERLOAD_C8
     module procedure mpp_chksum_c8_0d
     module procedure mpp_chksum_c8_1d
     module procedure mpp_chksum_c8_2d
     module procedure mpp_chksum_c8_3d
     module procedure mpp_chksum_c8_4d
     module procedure mpp_chksum_c8_5d
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_chksum_r4_0d
     module procedure mpp_chksum_r4_1d
     module procedure mpp_chksum_r4_2d
     module procedure mpp_chksum_r4_3d
     module procedure mpp_chksum_r4_4d
     module procedure mpp_chksum_r4_5d
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_chksum_c4_0d
     module procedure mpp_chksum_c4_1d
     module procedure mpp_chksum_c4_2d
     module procedure mpp_chksum_c4_3d
     module procedure mpp_chksum_c4_4d
     module procedure mpp_chksum_c4_5d
#endif
  end interface

!***********************************************************************
!
!            module variables 
!
!***********************************************************************
  integer, parameter   :: PESET_MAX = 10000
  integer              :: current_peset_max = 32
  type(communicator), allocatable :: peset(:) ! Will be allocated starting from 0, 0 is a dummy used to hold single-PE "self" communicator
  logical              :: module_is_initialized = .false.
  logical              :: debug = .false.
  integer              :: npes=1, root_pe=0, pe=0
  integer(LONG_KIND)   :: tick, ticks_per_sec, max_ticks, start_tick, end_tick, tick0=0
  integer              :: mpp_comm_private
  logical              :: first_call_system_clock_mpi=.TRUE.
  real(DOUBLE_KIND)    :: mpi_count0=0  ! use to prevent integer overflow
  real(DOUBLE_KIND)    :: mpi_tick_rate=0.d0  ! clock rate for mpi_wtick()
  logical              :: mpp_record_timing_data=.TRUE.
  type(clock),save     :: clocks(MAX_CLOCKS)
  integer              :: log_unit, etc_unit
  character(len=32)    :: configfile='logfile'
  integer              :: peset_num=0, current_peset_num=0
  integer              :: world_peset_num                  !the world communicator
  integer              :: error
  integer              :: clock_num=0, num_clock_ids=0,current_clock=0, previous_clock(MAX_CLOCKS)=0
  real                 :: tick_rate

  integer              :: cur_send_request = 0
  integer              :: cur_recv_request = 0
  integer, allocatable :: request_send(:)
  integer, allocatable :: request_recv(:)
  integer, allocatable :: size_recv(:)
  integer, allocatable :: type_recv(:)
! if you want to save the non-root PE information uncomment out the following line
! and comment out the assigment of etcfile to '/dev/null'
#ifdef NO_DEV_NULL
  character(len=32)    :: etcfile='._mpp.nonrootpe.msgs'
#else
  character(len=32)    :: etcfile='/dev/null'
#endif

#ifdef SGICRAY
  integer :: in_unit=100, out_unit=101, err_unit=102 !see intro_io(3F): to see why these values are used rather than 5,6,0
#else
  integer :: in_unit=5, out_unit=6, err_unit=0
#endif

  !--- variables used in mpp_util.h
  type(Summary_Struct) :: clock_summary(MAX_CLOCKS)
  logical              :: warnings_are_fatal = .FALSE.
  integer              :: error_state=0
  integer              :: clock_grain=CLOCK_LOOP-1

  !--- variables used in mpp_comm.h
#ifdef use_libMPI
#ifdef _CRAYT3E
  !BWA: mpif.h on t3e currently does not contain MPI_INTEGER8 datatype
  !(O2k and t90 do)
  !(t3e: fixed on 3.3 I believe)
  integer, parameter :: MPI_INTEGER8=MPI_INTEGER
#endif
#endif /* use_libMPI */
#ifdef use_MPI_SMA
#include <mpp/shmem.fh>
  integer :: pSync(SHMEM_BARRIER_SYNC_SIZE)
  pointer( p_pSync, pSync ) !used by SHPALLOC
#endif

  integer            :: clock0    !measures total runtime from mpp_init to mpp_exit
  integer            :: mpp_stack_size=0, mpp_stack_hwm=0
  logical            :: verbose=.FALSE.
#ifdef _CRAY
  integer(LONG_KIND) :: word(1)
#endif
#if defined(sgi_mipspro) || defined(__ia64)
  integer(INT_KIND)  :: word(1)
#endif

  integer :: get_len_nocomm = 0 ! needed for mpp_transmit_nocomm.h

!***********************************************************************
!  variables needed for subroutine read_input_nml (include/mpp_util.inc)
!
! parameter defining length of character variables 
  integer, parameter :: INPUT_STR_LENGTH = 256
! public variable needed for reading input.nml from an internal file
  character(len=INPUT_STR_LENGTH), dimension(:), allocatable, public :: input_nml_file
  logical :: read_ascii_file_on = .FALSE.
!***********************************************************************

  character(len=128), public :: version= &
       '$Id mpp.F90 $'
  character(len=128), public :: tagname= &
       '$Name$'

  integer, parameter :: MAX_REQUEST_MIN  = 10000
  integer            :: request_multiply = 20

  logical :: etc_unit_is_stderr = .false.
  integer :: max_request = 0
  logical :: sync_all_clocks = .false.
  namelist /mpp_nml/ etc_unit_is_stderr, request_multiply, mpp_record_timing_data, sync_all_clocks

  contains
#include <system_clock.h>
#include <mpp_util.inc>
#include <mpp_comm.inc>

  end module mpp_mod

MODULE DEEP_CONV_MOD

  use      fms_mod,         only : write_version_number
  use      Constants_Mod,   ONLY : tfreeze,HLv,HLf,HLs,CP_AIR,GRAV,Kappa,rdgas,rvgas
  use  conv_utilities_mod,  only : uw_params_init
  use  conv_utilities_k_mod,only : sd_init_k, sd_copy_k, sd_end_k,  &
                                   ac_init_k, ac_clear_k, ac_end_k, &
                                   pack_sd_k, adi_cloud_k, extend_sd_k,&
                                   exn_init_k, exn_end_k, findt_init_k,&
                                   findt_end_k, &
                                   adicloud, sounding, uw_params

  use  conv_plumes_k_mod,   only : cp_init_k, cp_end_k, cp_clear_k, &
                                   ct_init_k, ct_end_k, ct_clear_k, &
                                   cumulus_tend_k, cumulus_plume_k, &
                                   cplume, ctend, cpnlist

  use  conv_closures_mod,   only : cclosure_bretherton,   &
                                   cclosure_relaxcbmf, &
                                   cclosure_relaxwfn,  &
                                   cclosure_implicit, cclosure

!---------------------------------------------------------------------
  implicit none
  private
!----------- ****** VERSION NUMBER ******* ---------------------------

  character(len=128) :: version = '$Id: deep_conv.F90,v 20.0 2013/12/13 23:21:39 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

!-------  interfaces --------

  public  :: cpn_copy, dpconv0, dpconv1, dpconv2

  logical         :: module_is_initialized = .false.

  character(len=7) :: mod_name = 'deep_conv'

  public deepc
  type deepc
     real    :: rkm_dp1
     real    :: rkm_dp2
     real    :: cbmf_dp_frac1
     real    :: cbmf_dp_frac2
     real    :: crh_th_land
     real    :: crh_th_ocean
     real    :: cape_th 
     real    :: tau_dp 
     real    :: rpen_d
     integer :: mixing_assumption_d
     logical :: do_ppen_d
     logical :: do_pevap_d
     real    :: cfrac_d
     real    :: hcevap_d
     real    :: dcapedm_th
     real    :: frac_limit_d
     real    :: lofactor_d
     real    :: tcrit_d
     real    :: auto_th0_d
     logical :: do_forcedlifting_d
  end type deepc

contains

!#####################################################################
!#####################################################################

  subroutine cpn_copy(cpn, dpn)
    type(cpnlist), intent(in)    :: cpn
    type(cpnlist), intent(inout) :: dpn

    dpn % do_qctflx_zero     = cpn % do_qctflx_zero
    dpn % do_detran_zero     = cpn % do_detran_zero
    dpn % rle                = cpn % rle
    dpn % rpen               = cpn % rpen
    dpn % rmaxfrac           = cpn % rmaxfrac
    dpn % wmin               = cpn % wmin
    dpn % rbuoy              = cpn % rbuoy
    dpn % rdrag              = cpn % rdrag  
    dpn % frac_drs           = cpn % frac_drs
    dpn % bigc               = cpn % bigc    
    dpn % auto_th0           = cpn % auto_th0
    dpn % deltaqc0           = cpn % deltaqc0
    dpn % do_pdfpcp          = cpn % do_pdfpcp
    dpn % do_pmadjt          = cpn % do_pmadjt
    dpn % do_emmax           = cpn % do_emmax
    dpn % do_pnqv            = cpn % do_pnqv
    dpn % emfrac_max         = cpn % emfrac_max
    dpn % auto_rate          = cpn % auto_rate
    dpn % tcrit              = cpn % tcrit  
    dpn % cldhgt_max         = cpn % cldhgt_max
    dpn % do_ice             = cpn % do_ice
    dpn % do_ppen            = cpn % do_ppen
    dpn % do_pevap           = cpn % do_pevap
    dpn % hcevap             = cpn % hcevap
    dpn % cfrac              = cpn % cfrac
    dpn % mixing_assumption  = cpn % mixing_assumption
    dpn % mp_choice          = cpn % mp_choice
    dpn % Nl_land            = cpn % Nl_land
    dpn % Nl_ocean           = cpn % Nl_ocean
    dpn % qi_thresh          = cpn % qi_thresh
    dpn % r_thresh           = cpn % r_thresh
    dpn % peff_l             = cpn % peff_l
    dpn % peff_i             = cpn % peff_i
    dpn % peff               = cpn % peff
    dpn % t00                = cpn % t00
    dpn % rh0                = cpn % rh0
    dpn % do_forcedlifting   = cpn % do_forcedlifting
    dpn % atopevap           = cpn % atopevap
    dpn % wtwmin_ratio       = cpn % wtwmin_ratio
    dpn % do_auto_aero       = cpn % do_auto_aero
    dpn % rad_crit           = cpn % rad_crit
    dpn % wrel_min           = cpn % wrel_min
    dpn % do_weffect         = cpn % do_weffect
    dpn % weffect            = cpn % weffect
    dpn % use_online_aerosol = cpn % use_online_aerosol
    dpn % isdeep             = cpn % isdeep

  end subroutine cpn_copy

!#####################################################################
!#####################################################################

  subroutine dpconv0(dpc, dpn, Uw_p, sd, ac, cc, cp, ct, do_coldT, do_ice, &
                     rkm_dp, cbmf_deep, cp1, ct1, ocode, ier, ermesg)
    implicit none

    type(deepc),     intent(inout)  :: dpc
    type(cpnlist),   intent(inout)  :: dpn
    type(uw_params), intent(inout)  :: Uw_p
    type(sounding),  intent(in)     :: sd
    type(adicloud),  intent(in)     :: ac
    type(cclosure),  intent(in)     :: cc
    logical,         intent(in)     :: do_coldT
    logical,         intent(in)     :: do_ice
    type(cplume),    intent(inout)  :: cp
    type(ctend),     intent(inout)  :: ct
    real,            intent(inout)  :: rkm_dp, cbmf_deep
    type(cplume),    intent(inout)  :: cp1
    type(ctend),     intent(inout)  :: ct1
    real,            intent(inout)  :: ocode
    integer,            intent(out) :: ier
    character(len=256), intent(out) :: ermesg

    real          :: zcldtop, dcrh, cbmf_dp_frac

    ier = 0
    ermesg = ' '
    if ( (ocode.ne.0 .and. ocode.ne.4) .or. (cbmf_deep.eq.0) ) then
       ocode=6;
       return
    end if

    zcldtop = sd%z(cp%ltop)
    call cp_clear_k(cp1); cp1%maxcldfrac=1.;
    call ct_clear_k(ct1);
    call cumulus_plume_k(dpn, sd, ac, cp1, rkm_dp, cbmf_deep, cc%wrel, zcldtop, Uw_p, ier, ermesg)
    if(cp1%ltop.lt.cp1%krel+2 .or. cp1%let.le.cp1%krel+1) then
       ocode=6; return
    else
       call cumulus_tend_k(dpn, sd, Uw_p, cp1, ct1, do_coldT)
    end if
 
  end subroutine dpconv0


!#####################################################################
!#####################################################################

  subroutine dpconv1(dpc, dpn, Uw_p, sd, ac, cc, cp, ct, do_coldT, do_ice, &
                     rkm_dp, cbmf_deep, sd1, ac1, cp1, ct1, ocode, dcapedm, ier, ermesg)
    implicit none

    type(deepc),     intent(inout)  :: dpc
    type(cpnlist),   intent(inout)  :: dpn
    type(uw_params), intent(inout)  :: Uw_p
    type(sounding),  intent(in)     :: sd
    type(adicloud),  intent(in)     :: ac
    type(cclosure),  intent(in)     :: cc
    logical,         intent(in)     :: do_coldT
    logical,         intent(in)     :: do_ice
    type(cplume),    intent(inout)  :: cp
    type(ctend),     intent(inout)  :: ct
    real,            intent(inout)  :: rkm_dp, cbmf_deep
    type(sounding),  intent(inout)  :: sd1
    type(adicloud),  intent(inout)  :: ac1
    type(cplume),    intent(inout)  :: cp1
    type(ctend),     intent(inout)  :: ct1
    real,            intent(inout)  :: ocode, dcapedm
    integer,            intent(out) :: ier
    character(len=256), intent(out) :: ermesg

    real          :: zcldtop, wrel, cbmf0, cbmf_max, tmp
    integer       :: ksrc

    ier = 0
    ermesg = ' '
    zcldtop = 2000 !sd%z(cp%ltop)
    wrel = max(cc%wrel, 0.1)

!    if ( (ocode.ne.0 .and. ocode.ne.4) .or. (cbmf_deep.eq.0) ) then
    if ( cbmf_deep.eq.0 ) then
       ocode=6;
       return
    end if
    if (ac%cape .lt. dpc%cape_th) then
       ocode=7; return
    end if

    cbmf0 = 0.0001
    call cp_clear_k(cp1); cp1%maxcldfrac=1.;
    call ct_clear_k(ct1);
    call cumulus_plume_k(dpn, sd, ac, cp1, rkm_dp, cbmf0, wrel, zcldtop, Uw_p, ier, ermesg)
    if(cp1%ltop.lt.cp1%krel+2 .or. cp1%let.le.cp1%krel+1) then
       ocode=8; return
    else
       call cumulus_tend_k(dpn, sd, Uw_p, cp1, ct1, do_coldT)
    end if

    call sd_copy_k(sd, sd1)
    tmp      = 1.
    sd1 % t  = sd1 % t  + ct1%tten  * sd%delt * tmp
    sd1 % qv = sd1 % qv + ct1%qvten * sd%delt * tmp
    sd1 % ql = sd1 % ql + ct1%qlten * sd%delt * tmp
    sd1 % qi = sd1 % qi + ct1%qiten * sd%delt * tmp
    sd1 % qa = sd1 % qa + ct1%qaten * sd%delt * tmp
    sd1 % qn = sd1 % qn + ct1%qnten * sd%delt * tmp
    sd1 % u  = sd1 % u  + ct1%uten  * sd%delt * tmp
    sd1 % v  = sd1 % v  + ct1%vten  * sd%delt * tmp

    call extend_sd_k(sd1,sd%pblht, do_ice, Uw_p)

    call ac_clear_k(ac1);
    ksrc=1
    call adi_cloud_k(sd1%zs(ksrc), sd1%ps(ksrc), sd1%hl(ksrc), sd1%thc(ksrc), sd1%qct(ksrc), &
         sd1, Uw_p, .false., do_ice, ac1)

    dcapedm=(ac%cape-ac1%cape)/cbmf0

    if (dcapedm .lt. dpc%dcapedm_th) then
       cbmf_deep=0.; ocode=9; 
       call ct_clear_k(ct1);
       return
    else
       cbmf_deep= (ac%cape - dpc%cape_th) / dcapedm / (dpc%tau_dp/sd%delt)
    end if

    cbmf_max  = (sd%ps(0) - sd%ps(cp1%krel))*(dpc%frac_limit_d/sd%delt)/Grav
    cbmf_deep = max(min(cbmf_deep, cbmf_max), 0.)
 
    if(cbmf_deep.lt.1.e-10) then 
       cbmf_deep=0.; ocode=10; 
       call ct_clear_k(ct1);
       return
    end if

    call cumulus_plume_k(dpn, sd, ac, cp1, rkm_dp, cbmf_deep, wrel, zcldtop, Uw_p, ier, ermesg)
    if(cp1%ltop.lt.cp1%krel+2 .or. cp1%let.le.cp1%krel+1) then
       ocode=11; return
    else
       call cumulus_tend_k(dpn, sd, Uw_p, cp1, ct1, do_coldT)
    end if
    
  end subroutine dpconv1

!#####################################################################
!#####################################################################

  subroutine dpconv2(dpc, dpn, Uw_p, sd, ac, cc, cp, ct, do_coldT, do_ice, &
                     rkm_dp, cbmf_deep, sd1, ac1, cp1, ct1, ocode, ier, ermesg)
    implicit none

    type(deepc),     intent(inout)  :: dpc
    type(cpnlist),   intent(inout)  :: dpn
    type(uw_params), intent(inout)  :: Uw_p
    type(sounding),  intent(in)     :: sd
    type(adicloud),  intent(in)     :: ac
    type(cclosure),  intent(in)     :: cc
    logical,         intent(in)     :: do_coldT
    logical,         intent(in)     :: do_ice
    type(cplume),    intent(inout)  :: cp
    type(ctend),     intent(inout)  :: ct
    real,            intent(inout)  :: rkm_dp, cbmf_deep
    type(sounding),  intent(inout)  :: sd1
    type(adicloud),  intent(inout)  :: ac1
    type(cplume),    intent(inout)  :: cp1
    type(ctend),     intent(inout)  :: ct1
    real,            intent(inout)  :: ocode
    integer,            intent(out) :: ier
    character(len=256), intent(out) :: ermesg

    real          :: zcldtop, cbmf0, dcwfn, cwfn0, cwfn1, dpsum, cbmf_max, tmp
    integer       :: ksrc, k

    ier = 0
    ermesg = ' '
    zcldtop = sd%z(cp%ltop)

    if ( (ocode.ne.0 .and. ocode.ne.4) .or. (cbmf_deep.eq.0) ) then
       ocode=6;
       return
    end if

    cbmf0 = 0.0001
    call cp_clear_k(cp1); cp1%maxcldfrac=1.;
    call ct_clear_k(ct1);
    call cumulus_plume_k(dpn, sd, ac, cp1, rkm_dp, cbmf0, cc%wrel, zcldtop, Uw_p, ier, ermesg)
    if(cp1%ltop.lt.cp1%krel+2 .or. cp1%let.le.cp1%krel+1) then
       ocode=8; return
    else
       call cumulus_tend_k(dpn, sd, Uw_p, cp1, ct1, do_coldT)
    end if

    call sd_copy_k(sd, sd1)
    tmp      = 1.
    sd1 % t  = sd1 % t  + ct1%tten  * sd%delt * tmp
    sd1 % qv = sd1 % qv + ct1%qvten * sd%delt * tmp
    sd1 % ql = sd1 % ql + ct1%qlten * sd%delt * tmp
    sd1 % qi = sd1 % qi + ct1%qiten * sd%delt * tmp
    sd1 % qa = sd1 % qa + ct1%qaten * sd%delt * tmp
    sd1 % qn = sd1 % qn + ct1%qnten * sd%delt * tmp
    sd1 % u  = sd1 % u  + ct1%uten  * sd%delt * tmp
    sd1 % v  = sd1 % v  + ct1%vten  * sd%delt * tmp

    call extend_sd_k(sd1,sd%pblht, do_ice, Uw_p)

    call ac_clear_k(ac1);
    ksrc=1
    call adi_cloud_k(sd1%zs(ksrc), sd1%ps(ksrc), sd1%hl(ksrc), sd1%thc(ksrc), sd1%qct(ksrc), &
         sd1, Uw_p, .false., do_ice, ac1)
    call cumulus_plume_k(dpn, sd, ac, cp1, rkm_dp, cbmf_deep, cc%wrel, zcldtop, Uw_p, ier, ermesg)

    cwfn0=0.; dpsum=0.
    do k = cp%let,cp%ltop
       cwfn0 = cwfn0 + cp%buo(k)*sd%dp(k)
       dpsum = dpsum + sd%dp(k)
    end do
    cwfn0 = cwfn0 /dpsum

    cwfn1=0.; dpsum=0.
    do k = cp1%let,cp1%ltop
       cwfn1 = cwfn1 + cp%buo(k)*sd%dp(k)
       dpsum = dpsum + sd%dp(k)
    end do
    cwfn1 = cwfn1 /dpsum

    dcwfn =(cwfn0 - cwfn1)/cbmf0

    if (dcwfn <= 0.) then
       cbmf_deep=0.; ocode=9; return
    else
       cbmf_deep= (cwfn0-0) / dcwfn / (dpc%tau_dp/sd%delt)
    end if

    cbmf_max  = (sd%ps(0) - sd%ps(cp%krel))*(dpc%frac_limit_d/sd%delt)/Grav
    cbmf_deep = max(min(cbmf_deep, cbmf_max), 0.)
 
    if(cbmf_deep.lt.1.e-10) then 
       cbmf_deep=0.; ocode=10; 
       call ct_clear_k(ct1);
       return
    end if

    call cumulus_plume_k(dpn, sd, ac, cp1, rkm_dp, cbmf_deep, cc%wrel, zcldtop, Uw_p, ier, ermesg)
    if(cp1%ltop.lt.cp1%krel+2 .or. cp1%let.le.cp1%krel+1) then
       ocode=11; return
    else
       call cumulus_tend_k(dpn, sd, Uw_p, cp1, ct1, do_coldT)
    end if
    
  end subroutine dpconv2
!#####################################################################
!#####################################################################

end MODULE DEEP_CONV_MOD

module idealized_moist_phys_mod

#ifdef INTERNAL_FILE_NML
  use mpp_mod, only: input_nml_file
#else
  use fms_mod, only: open_namelist_file, close_file
#endif

use fms_mod, only: write_version_number, file_exist, close_file, stdlog, error_mesg, FATAL

use           constants_mod, only: grav

use        time_manager_mod, only: time_type, get_time, operator( + )

use    vert_turb_driver_mod, only: vert_turb_driver_init, vert_turb_driver, vert_turb_driver_end

use           vert_diff_mod, only: vert_diff_init, gcm_vert_diff_down, gcm_vert_diff_up, vert_diff_end, surf_diff_type

use two_stream_gray_rad_mod, only: two_stream_gray_rad_init, two_stream_gray_rad_down, two_stream_gray_rad_up, two_stream_gray_rad_end

use         mixed_layer_mod, only: mixed_layer_init, mixed_layer, mixed_layer_end

use         lscale_cond_mod, only: lscale_cond_init, lscale_cond, lscale_cond_end

use qe_moist_convection_mod, only: qe_moist_convection_init, qe_moist_convection, qe_moist_convection_end

use        diag_manager_mod, only: register_diag_field, send_data

use          transforms_mod, only: get_grid_domain

use   spectral_dynamics_mod, only: get_axis_id, get_num_levels, get_surf_geopotential

use        surface_flux_mod, only: surface_flux

implicit none
private
!=================================================================================================================================

character(len=128) :: version= &
'$Id: idealized_moist_phys.F90,v 20.0 2013/12/13 23:25:39 fms Exp $'

character(len=128) :: tagname= &
'$Name: tikal $'
character(len=10), parameter :: mod_name='atmosphere'

!=================================================================================================================================

public :: idealized_moist_phys_init , idealized_moist_phys , idealized_moist_phys_end

logical :: module_is_initialized =.false.
logical :: turb = .false.
logical :: do_virtual = .false. ! whether virtual temp used in gcm_vert_diff
logical :: lwet_convection = .false.
logical :: two_stream = .true.
logical :: mixed_layer_bc = .false.
real :: roughness_heat = 0.05
real :: roughness_moist = 0.05
real :: roughness_mom = 0.05

namelist / idealized_moist_phys_nml / turb, lwet_convection, roughness_heat, two_stream, mixed_layer_bc, &
                                      roughness_moist, roughness_mom, do_virtual

real, allocatable, dimension(:,:)   ::                                        &
     z_surf,               &   ! surface height
     t_surf,               &   ! surface temperature
     q_surf,               &   ! surface moisture
     u_surf,               &   ! surface U wind
     v_surf,               &   ! surface V wind
     rough_mom,            &   ! momentum roughness length for surface_flux
     rough_heat,           &   ! heat roughness length for surface_flux
     rough_moist,          &   ! moisture roughness length for surface_flux
     gust,                 &   ! gustiness constant
     z_pbl,                &   ! gustiness constant
     flux_t,               &   ! surface sensible heat flux
     flux_q,               &   ! surface moisture flux
     flux_r,               &   ! surface radiation flux
     flux_u,               &   ! surface flux of zonal mom.
     flux_v,               &   ! surface flux of meridional mom.
     drag_m,               &   ! momentum drag coefficient
     drag_t,               &   ! heat drag coefficient
     drag_q,               &   ! moisture drag coefficient
     w_atm,                &   ! wind speed
     ustar,                &   ! friction velocity
     bstar,                &   ! buoyancy scale
     qstar,                &   ! moisture scale
     dhdt_surf,            &   ! d(sensible heat flux)/d(surface temp)
     dedt_surf,            &   ! d(latent heat flux)/d(surface temp)???
     dedq_surf,            &   ! d(latent heat flux)/d(surface moisture)???
     drdt_surf,            &   ! d(upward longwave)/d(surface temp)
     dhdt_atm,             &   ! d(sensible heat flux)/d(atmos.temp)
     dedq_atm,             &   ! d(latent heat flux)/d(atmospheric mixing rat.)
     dtaudv_atm,           &   ! d(stress component)/d(atmos wind)
     dtaudu_atm,           &   ! d(stress component)/d(atmos wind)
     fracland,             &   ! fraction of land in gridbox
     rough                     ! roughness for vert_turb_driver


real, allocatable, dimension(:,:,:) ::                                        &
     diff_m,               &   ! momentum diffusion coeff.
     diff_t,               &   ! temperature diffusion coeff.
     tdtlw,                &   ! place holder. appears in calling arguments of vert_turb_driver but not used unless do_edt=.true. -- pjp
     diss_heat,            &   ! heat dissipated by vertical diffusion
     non_diff_dt_ug,       &   ! zonal wind tendency except from vertical diffusion
     non_diff_dt_vg,       &   ! merid. wind tendency except from vertical diffusion
     non_diff_dt_tg,       &   ! temperature tendency except from vertical diffusion
     non_diff_dt_qg,       &   ! moisture tendency except from vertical diffusion
     conv_dt_tg,           &   ! temperature tendency from convection
     conv_dt_qg,           &   ! moisture tendency from convection
     cond_dt_tg,           &   ! temperature tendency from condensation
     cond_dt_qg                ! moisture tendency from condensation


logical, allocatable, dimension(:,:) ::                                       &
     avail,                &   ! generate surf. flux (all true)
     land,                 &   ! land points (all false)
     coldT,                &   ! should precipitation be snow at this point
     convect                   ! place holder. appears in calling arguments of vert_turb_driver but not used unless do_entrain=.true. -- pjp

real, allocatable, dimension(:,:) ::                                          &
     klzbs,                &   ! stored level of zero buoyancy values
     cape,                 &   ! convectively available potential energy
     cin,                  &   ! convective inhibition (this and the above are before the adjustment)
     invtau_q_relaxation,  &   ! temperature relaxation time scale
     invtau_t_relaxation,  &   ! humidity relaxation time scale
     rain,                 &   !
     snow

real, allocatable, dimension(:,:,:) :: &
     t_ref,          &   ! relaxation temperature for bettsmiller scheme
     q_ref               ! relaxation moisture for bettsmiller scheme

real, allocatable, dimension(:,:) :: &
     net_surf_sw_down,  &   ! net sw flux at surface
     surf_lw_down           ! downward lw flux at surface

integer ::           &
     id_diff_dt_ug,  &   ! zonal wind tendency from vertical diffusion
     id_diff_dt_vg,  &   ! merid. wind tendency from vertical diffusion
     id_diff_dt_tg,  &   ! temperature tendency from vertical diffusion
     id_diff_dt_qg,  &   ! moisture tendency from vertical diffusion
     id_conv_rain,   &   ! rain from convection
     id_cond_rain,   &   ! rain from condensation
     id_conv_dt_tg,  &   ! temperature tendency from convection
     id_conv_dt_qg,  &   ! temperature tendency from convection
     id_cond_dt_tg,  &   ! temperature tendency from convection
     id_cond_dt_qg       ! temperature tendency from convection

integer, allocatable, dimension(:,:) :: convflag ! indicates which qe convection subroutines are used
real,    allocatable, dimension(:,:) :: rad_lat   

type(surf_diff_type) :: Tri_surf ! used by gcm_vert_diff

logical :: used, doing_edt, doing_entrain
integer, dimension(4) :: axes
integer :: is, ie, js, je, num_levels, nsphum, dt_integer
real :: dt_real
type(time_type) :: Time_step

!=================================================================================================================================
contains
!=================================================================================================================================

subroutine idealized_moist_phys_init(Time, Time_step_in, nhum, rad_lat_2d, rad_lonb_2d, rad_latb_2d, t_surf_init)
type(time_type), intent(in) :: Time, Time_step_in
integer, intent(in) :: nhum
real, intent(in), dimension(:,:) :: rad_lat_2d, rad_lonb_2d, rad_latb_2d, t_surf_init

integer :: io, nml_unit, stdlog_unit, seconds, days

if(module_is_initialized) return

call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
   read (input_nml_file, nml=idealized_moist_phys_nml, iostat=io)
#else  
   if ( file_exist('input.nml') ) then
      nml_unit = open_namelist_file()
      read (nml_unit, idealized_moist_phys_nml, iostat=io)
      call close_file(nml_unit)
   endif
#endif
stdlog_unit = stdlog()
write(stdlog_unit, idealized_moist_phys_nml)

nsphum = nhum
Time_step = Time_step_in
call get_time(Time_step, seconds, days)
dt_integer   = 86400*days + seconds
dt_real      = float(dt_integer)

call get_grid_domain(is, ie, js, je)
call get_num_levels(num_levels)

allocate(rad_lat     (is:ie, js:je)); rad_lat = rad_lat_2d
allocate(z_surf      (is:ie, js:je))
allocate(t_surf      (is:ie, js:je))
allocate(q_surf      (is:ie, js:je)); q_surf = 0.0
allocate(u_surf      (is:ie, js:je)); u_surf = 0.0
allocate(v_surf      (is:ie, js:je)); v_surf = 0.0
allocate(rough_mom   (is:ie, js:je)); rough_mom = roughness_mom
allocate(rough_heat  (is:ie, js:je)); rough_heat = roughness_heat
allocate(rough_moist (is:ie, js:je)); rough_moist = roughness_moist
allocate(gust        (is:ie, js:je)); gust = 1.0
allocate(z_pbl       (is:ie, js:je))
allocate(flux_t      (is:ie, js:je))
allocate(flux_q      (is:ie, js:je))
allocate(flux_r      (is:ie, js:je))
allocate(flux_u      (is:ie, js:je))
allocate(flux_v      (is:ie, js:je))
allocate(drag_m      (is:ie, js:je))
allocate(drag_t      (is:ie, js:je))
allocate(drag_q      (is:ie, js:je))
allocate(w_atm       (is:ie, js:je))
allocate(ustar       (is:ie, js:je))
allocate(bstar       (is:ie, js:je))
allocate(qstar       (is:ie, js:je))
allocate(dhdt_surf   (is:ie, js:je))
allocate(dedt_surf   (is:ie, js:je))
allocate(dedq_surf   (is:ie, js:je))
allocate(drdt_surf   (is:ie, js:je))
allocate(dhdt_atm    (is:ie, js:je))
allocate(dedq_atm    (is:ie, js:je))
allocate(dtaudv_atm  (is:ie, js:je))
allocate(dtaudu_atm  (is:ie, js:je))
allocate(land        (is:ie, js:je)); land = .false.
allocate(avail       (is:ie, js:je)); avail = .true.
allocate(fracland    (is:ie, js:je)); fracland = 0.0
allocate(rough       (is:ie, js:je))
allocate(diff_t      (is:ie, js:je, num_levels))
allocate(diff_m      (is:ie, js:je, num_levels))
allocate(diss_heat   (is:ie, js:je, num_levels))
allocate(tdtlw       (is:ie, js:je, num_levels)); tdtlw = 0.0

allocate(non_diff_dt_ug  (is:ie, js:je, num_levels))
allocate(non_diff_dt_vg  (is:ie, js:je, num_levels))
allocate(non_diff_dt_tg  (is:ie, js:je, num_levels))
allocate(non_diff_dt_qg  (is:ie, js:je, num_levels))

allocate(net_surf_sw_down        (is:ie, js:je))
allocate(surf_lw_down            (is:ie, js:je))
allocate(conv_dt_tg  (is:ie, js:je, num_levels))
allocate(conv_dt_qg  (is:ie, js:je, num_levels))
allocate(cond_dt_tg  (is:ie, js:je, num_levels))
allocate(cond_dt_qg  (is:ie, js:je, num_levels))

allocate(coldT        (is:ie, js:je)); coldT = .false.
allocate(klzbs        (is:ie, js:je))
allocate(cape         (is:ie, js:je))
allocate(cin          (is:ie, js:je))
allocate(invtau_q_relaxation  (is:ie, js:je))
allocate(invtau_t_relaxation  (is:ie, js:je))
allocate(rain         (is:ie, js:je)); rain = 0.0
allocate(snow         (is:ie, js:je)); snow = 0.0
allocate(convflag     (is:ie, js:je))
allocate(convect      (is:ie, js:je)); convect = .false.

allocate(t_ref (is:ie, js:je, num_levels)); t_ref = 0.0
allocate(q_ref (is:ie, js:je, num_levels)); q_ref = 0.0

call get_surf_geopotential(z_surf)
z_surf = z_surf/grav

if(mixed_layer_bc) then
  ! need an initial condition for the mixed layer temperature
  ! may be overwritten by restart file
  ! choose an unstable initial condition to allow moisture
  ! to quickly enter the atmosphere avoiding problems with the convection scheme
  t_surf = t_surf_init + 1.0
  call mixed_layer_init(is, ie, js, je, num_levels, t_surf, get_axis_id(), Time) ! t_surf is intent(inout)
endif

if(turb) then
! need to call vert_diff_init even if using gcm_vert_diff (rather than
! gcm_vert_diff_down) because the variable sphum is not initialized
! otherwise in the vert_diff module
   call vert_diff_init (Tri_surf, ie-is+1, je-js+1, num_levels, .true., do_virtual)
end if

call lscale_cond_init()

axes = get_axis_id()

id_cond_dt_qg = register_diag_field(mod_name, 'dt_qg_condensation',        &
     axes(1:3), Time, 'Moisture tendency from condensation','kg/kg/s')
id_cond_dt_tg = register_diag_field(mod_name, 'dt_tg_condensation',        &
     axes(1:3), Time, 'Temperature tendency from condensation','K/s')
id_cond_rain = register_diag_field(mod_name, 'condensation_rain',          &
     axes(1:2), Time, 'Rain from condensation','kg/m/m/s')

if(lwet_convection) then
   call qe_moist_convection_init()
   id_conv_dt_qg = register_diag_field(mod_name, 'dt_qg_convection',          &
        axes(1:3), Time, 'Moisture tendency from convection','kg/kg/s')
   id_conv_dt_tg = register_diag_field(mod_name, 'dt_tg_convection',          &
        axes(1:3), Time, 'Temperature tendency from convection','K/s')
   id_conv_rain = register_diag_field(mod_name, 'convection_rain',            &
        axes(1:2), Time, 'Rain from convection','kg/m/m/s')
endif

if(two_stream) call two_stream_gray_rad_init(is, ie, js, je, num_levels, get_axis_id(), Time)

if(turb) then
   call vert_turb_driver_init (rad_lonb_2d, rad_latb_2d, ie-is+1,je-js+1, &
                 num_levels,get_axis_id(),Time, doing_edt, doing_entrain)

   axes = get_axis_id()
   id_diff_dt_ug = register_diag_field(mod_name, 'dt_ug_diffusion',        &
        axes(1:3), Time, 'zonal wind tendency from diffusion','m/s^2')
   id_diff_dt_vg = register_diag_field(mod_name, 'dt_vg_diffusion',        &
        axes(1:3), Time, 'meridional wind tendency from diffusion','m/s^2')
   id_diff_dt_tg = register_diag_field(mod_name, 'dt_tg_diffusion',        &
        axes(1:3), Time, 'temperature diffusion tendency','T/s')
   id_diff_dt_qg = register_diag_field(mod_name, 'dt_qg_diffusion',        &
        axes(1:3), Time, 'moisture diffusion tendency','T/s')
endif

end subroutine idealized_moist_phys_init
!=================================================================================================================================
subroutine idealized_moist_phys(Time, p_half, p_full, z_half, z_full, ug, vg, tg, grid_tracers, &
                                previous, current, dt_ug, dt_vg, dt_tg, dt_tracers)

type(time_type),            intent(in)    :: Time
real, dimension(:,:,:,:),   intent(in)    :: p_half, p_full, z_half, z_full, ug, vg, tg
real, dimension(:,:,:,:,:), intent(in)    :: grid_tracers
integer,                    intent(in)    :: previous, current
real, dimension(:,:,:),     intent(inout) :: dt_ug, dt_vg, dt_tg
real, dimension(:,:,:,:),   intent(inout) :: dt_tracers

real :: delta_t
real, dimension(size(ug,1), size(ug,2), size(ug,3)) :: tg_tmp, qg_tmp

if(current == previous) then
   delta_t = dt_real
else
   delta_t = 2*dt_real
endif

if (lwet_convection) then
   rain = 0.0; snow = 0.0
   call qe_moist_convection ( delta_t,              tg(:,:,:,previous),      &
    grid_tracers(:,:,:,previous,nsphum),        p_full(:,:,:,previous),      &
                          p_half(:,:,:,previous),                coldT,      &
                                 rain,                            snow,      &
                           conv_dt_tg,                      conv_dt_qg,      &
                                q_ref,                        convflag,      &
                                klzbs,                            cape,      &
                                  cin,             invtau_q_relaxation,      &
                  invtau_t_relaxation,                           t_ref)

   tg_tmp = conv_dt_tg + tg(:,:,:,previous)
   qg_tmp = conv_dt_qg + grid_tracers(:,:,:,previous,nsphum)
!  note the delta's are returned rather than the time derivatives

   conv_dt_tg = conv_dt_tg/delta_t
   conv_dt_qg = conv_dt_qg/delta_t
   rain       = rain/delta_t

   dt_tg = dt_tg + conv_dt_tg
   dt_tracers(:,:,:,nsphum) = dt_tracers(:,:,:,nsphum) + conv_dt_qg

   if(id_conv_dt_qg > 0) used = send_data(id_conv_dt_qg, conv_dt_qg, Time)
   if(id_conv_dt_tg > 0) used = send_data(id_conv_dt_tg, conv_dt_tg, Time)
   if(id_conv_rain  > 0) used = send_data(id_conv_rain, rain, Time)

else

   tg_tmp = tg(:,:,:,previous)
   qg_tmp = grid_tracers(:,:,:,previous,nsphum)

endif

rain = 0.0
call lscale_cond (         tg_tmp,                          qg_tmp,        &
           p_full(:,:,:,previous),          p_half(:,:,:,previous),        &
                            coldT,                            rain,        &
                             snow,                      cond_dt_tg,        &
                       cond_dt_qg )
                                                                          
cond_dt_tg = cond_dt_tg/delta_t
cond_dt_qg = cond_dt_qg/delta_t
rain       = rain/delta_t
                                                                             
dt_tg = dt_tg + cond_dt_tg
dt_tracers(:,:,:,nsphum) = dt_tracers(:,:,:,nsphum) + cond_dt_qg
                                                                               
if(id_cond_dt_qg > 0) used = send_data(id_cond_dt_qg, cond_dt_qg, Time)
if(id_cond_dt_tg > 0) used = send_data(id_cond_dt_tg, cond_dt_tg, Time)
if(id_cond_rain  > 0) used = send_data(id_cond_rain, rain, Time)

! Begin the radiation calculation by computing downward fluxes.
! This part of the calculation does not depend on the surface temperature.

if(two_stream) then
   call two_stream_gray_rad_down(is, js, Time, &
                       rad_lat(:,:),           &
                       p_half(:,:,:,current),  &
                       tg(:,:,:,previous),     &
                       net_surf_sw_down(:,:),  &
                       surf_lw_down(:,:))
end if

if(.not.mixed_layer_bc) then
                                                                               
!!$! infinite heat capacity
!    t_surf = surface_temperature_forced(rad_lat)
!!$! no heat capacity:
!!$   t_surf = tg(:,:,num_levels,previous)
                                                                              
!!$! surface temperature has same potential temp. as lowest layer:
!!$  t_surf = surface_temperature(tg(:,:,:,previous), p_full(:,:,:,current), p_half(:,:,:,current))
end if

call surface_flux(                                                          &
                  tg(:,:,num_levels,previous),                              &
 grid_tracers(:,:,num_levels,previous,nsphum),                              &
                  ug(:,:,num_levels,previous),                              &
                  vg(:,:,num_levels,previous),                              &
               p_full(:,:,num_levels,current),                              &
   z_full(:,:,num_levels,current)-z_surf(:,:),                              &
             p_half(:,:,num_levels+1,current),                              &
                                  t_surf(:,:),                              &
                                  t_surf(:,:),                              &
                                  q_surf(:,:),                              & ! is intent(inout)
                                  u_surf(:,:),                              &
                                  v_surf(:,:),                              &
                               rough_mom(:,:),                              &
                              rough_heat(:,:),                              &
                             rough_moist(:,:),                              &
                               rough_mom(:,:),                              & ! using rough_mom in place of rough_scale -- pjp
                                    gust(:,:),                              &
                                  flux_t(:,:),                              & ! is intent(out)
                                  flux_q(:,:),                              & ! is intent(out)
                                  flux_r(:,:),                              & ! is intent(out)
                                  flux_u(:,:),                              & ! is intent(out)
                                  flux_v(:,:),                              & ! is intent(out)
                                  drag_m(:,:),                              & ! is intent(out)
                                  drag_t(:,:),                              & ! is intent(out)
                                  drag_q(:,:),                              & ! is intent(out)
                                   w_atm(:,:),                              & ! is intent(out)
                                   ustar(:,:),                              & ! is intent(out)
                                   bstar(:,:),                              & ! is intent(out)
                                   qstar(:,:),                              & ! is intent(out)
                               dhdt_surf(:,:),                              & ! is intent(out)
                               dedt_surf(:,:),                              & ! is intent(out)
                               dedq_surf(:,:),                              & ! is intent(out)
                               drdt_surf(:,:),                              & ! is intent(out)
                                dhdt_atm(:,:),                              & ! is intent(out)
                                dedq_atm(:,:),                              & ! is intent(out)
                              dtaudu_atm(:,:),                              & ! is intent(out)
                              dtaudv_atm(:,:),                              & ! is intent(out)
                                      delta_t,                              &
                                    land(:,:),                              &
                               .not.land(:,:),                              &
                                   avail(:,:)  )

! Now complete the radiation calculation by computing the upward and net fluxes.

if(two_stream) then
   call two_stream_gray_rad_up(is, js, Time, &
                     rad_lat(:,:),           &
                     p_half(:,:,:,current),  &
                     t_surf(:,:),            &
                     tg(:,:,:,previous),     &
                     dt_tg(:,:,:))
end if

if(turb) then

   call vert_turb_driver(            1,                              1, &
                                  Time,                 Time+Time_step, &
                               delta_t, tdtlw(:,:,:),    fracland(:,:), &
                 p_half(:,:,:,current),          p_full(:,:,:,current), &
                 z_half(:,:,:,current),          z_full(:,:,:,current), &
                            ustar(:,:),                     bstar(:,:), &
                            qstar(:,:),                     rough(:,:), &
                          rad_lat(:,:),                   convect(:,:), &
                    ug(:,:,:,current ),             vg(:,:,:,current ), &
                    tg(:,:,:,current ),                                 &
    grid_tracers(:,:,:,current,nsphum),  grid_tracers(:,:,:,current,:), &
                    ug(:,:,:,previous),                                 &
                    vg(:,:,:,previous),             tg(:,:,:,previous), &
   grid_tracers(:,:,:,previous,nsphum), grid_tracers(:,:,:,previous,:), &
                          dt_ug(:,:,:),                   dt_vg(:,:,:), &
                          dt_tg(:,:,:),       dt_tracers(:,:,:,nsphum), &
                   dt_tracers(:,:,:,:),                  diff_t(:,:,:), &
                         diff_m(:,:,:),                      gust(:,:), &
                            z_pbl(:,:) )
!
!! Don't zero these derivatives as the surface flux depends implicitly
!! on the lowest level values
!! However it should be noted that these derivatives do not take into
!! account the change in the Monin-Obukhov coefficients, and so are not
!! very accurate.
!
!!$   dtaudv_atm = 0.0
!!$   dhdt_atm   = 0.0
!!$   dedq_atm   = 0.0

   if(.not.mixed_layer_bc) then
     call error_mesg('atmosphere','no diffusion implentation for non-mixed layer b.c.',FATAL)
   endif


! We must use gcm_vert_diff_down and _up rather than gcm_vert_diff as the surface flux
! depends implicitly on the surface values

!
! Don't want to do time splitting for the implicit diffusion step in case
! of compensation of the tendencies
!
   non_diff_dt_ug  = dt_ug
   non_diff_dt_vg  = dt_vg
   non_diff_dt_tg  = dt_tg
   non_diff_dt_qg  = dt_tracers(:,:,:,nsphum)

   call gcm_vert_diff_down (1, 1,                                          &
                            delta_t,             ug(:,:,:,previous),       &
                            vg(:,:,:,previous),  tg(:,:,:,previous),       &
                            grid_tracers(:,:,:,previous,nsphum),           &
                            grid_tracers(:,:,:,previous,:), diff_m(:,:,:), &
                            diff_t(:,:,:),          p_half(:,:,:,current), &
                            p_full(:,:,:,current),  z_full(:,:,:,current), &
                            flux_u(:,:),                      flux_v(:,:), &
                            dtaudu_atm(:,:),              dtaudv_atm(:,:), &
                            dt_ug(:,:,:),                    dt_vg(:,:,:), &
                            dt_tg(:,:,:),        dt_tracers(:,:,:,nsphum), &
                            dt_tracers(:,:,:,:),         diss_heat(:,:,:), &
                            Tri_surf)
!
! update surface temperature
!
   call mixed_layer(                                                       &
                              Time,                                        &
                              t_surf(:,:),                                 & ! t_surf is intent(inout)
                              flux_t(:,:),                                 &
                              flux_q(:,:),                                 &
                              flux_r(:,:),                                 &
                                  dt_real,                                 &
                    net_surf_sw_down(:,:),                                 &
                        surf_lw_down(:,:),                                 &
                            Tri_surf,                                      & ! Tri_surf is intent(inout)
                           dhdt_surf(:,:),                                 &
                           dedt_surf(:,:),                                 &
                           dedq_surf(:,:),                                 &
                           drdt_surf(:,:),                                 &
                            dhdt_atm(:,:),                                 &
                            dedq_atm(:,:))


   call gcm_vert_diff_up (1, 1, delta_t, Tri_surf, dt_tg(:,:,:), dt_tracers(:,:,:,nsphum), dt_tracers(:,:,:,:))

   if(id_diff_dt_ug > 0) used = send_data(id_diff_dt_ug, dt_ug - non_diff_dt_ug, Time)
   if(id_diff_dt_vg > 0) used = send_data(id_diff_dt_vg, dt_vg - non_diff_dt_vg, Time)
   if(id_diff_dt_tg > 0) used = send_data(id_diff_dt_tg, dt_tg - non_diff_dt_tg, Time)
   if(id_diff_dt_qg > 0) used = send_data(id_diff_dt_qg, dt_tracers(:,:,:,nsphum) - non_diff_dt_qg, Time)

endif ! if(turb) then

end subroutine idealized_moist_phys
!=================================================================================================================================
subroutine idealized_moist_phys_end

if(two_stream)      call two_stream_gray_rad_end
if(lwet_convection) call qe_moist_convection_end
if(turb) then
   call vert_diff_end
   call vert_turb_driver_end
endif
call lscale_cond_end
if(mixed_layer_bc)  call mixed_layer_end(t_surf)

end subroutine idealized_moist_phys_end
!=================================================================================================================================

end module idealized_moist_phys_mod

!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                                   !!
!!                   GNU General Public License                      !!
!!                                                                   !!
!! This file is part of the Flexible Modeling System (FMS).          !!
!!                                                                   !!
!! FMS is free software; you can redistribute it and/or modify       !!
!! it and are expected to follow the terms of the GNU General Public !!
!! License as published by the Free Software Foundation.             !!
!!                                                                   !!
!! FMS is distributed in the hope that it will be useful,            !!
!! but WITHOUT ANY WARRANTY; without even the implied warranty of    !!
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     !!
!! GNU General Public License for more details.                      !!
!!                                                                   !!
!! You should have received a copy of the GNU General Public License !!
!! along with FMS; if not, write to:                                 !!
!!          Free Software Foundation, Inc.                           !!
!!          59 Temple Place, Suite 330                               !!
!!          Boston, MA  02111-1307  USA                              !!
!! or see:                                                           !!
!!          http://www.gnu.org/licenses/gpl.txt                      !!
!!                                                                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
! 
!<CONTACT EMAIL="Richard.Matear@csiro.au"> Richard Matear
!</CONTACT>
!
!<CONTACT EMAIL="Matthew.Chamberlain@csiro.au"> Matt Chamberlain
!</CONTACT>
!
!<REVIEWER EMAIL=""> 
!</REVIEWER>
!
!<OVERVIEW>
! CSIRO v3 bgc model
!</OVERVIEW>
!
!<DESCRIPTION>
!       Generic setup of the CSIRO BGC model; NO3-based NPZD cycle, 
!         with coupled carbon cycle
!</DESCRIPTION>
!
! <INFO>
! <REFERENCE>
! </REFERENCE>
!
! <REFERENCE>
! </REFERENCE>
!
! </INFO>
!
!------------------------------------------------------------------
!
!       Module csiro_bgc_mod
!
!	csiro bgc model version 3       
!
!------------------------------------------------------------------

module  csiro_bgc_mod  !{

!------------------------------------------------------------------
!
!       Global definitions
!
!------------------------------------------------------------------

!----------------------------------------------------------------------
!
!       Modules
!
!----------------------------------------------------------------------

use diag_manager_mod,         only: send_data
use field_manager_mod,        only: fm_field_name_len, fm_path_name_len, fm_string_len
use field_manager_mod,        only: fm_get_length, fm_get_value, fm_new_value
use field_manager_mod,        only: fm_get_index
use fms_mod,                  only: write_data, write_version_number
use mpp_mod,                  only: stdout, stdlog, mpp_error, mpp_sum, FATAL
use mpp_mod,                  only: mpp_pe, mpp_root_pe, mpp_sync
use mpp_mod,                  only: mpp_clock_id, mpp_clock_begin, mpp_clock_end, CLOCK_ROUTINE
use fms_io_mod,               only: register_restart_field, save_restart, restore_state
use fms_io_mod,               only: restart_file_type, reset_field_pointer

use ocean_types_mod,       only: ocean_domain_type, ocean_grid_type
use mpp_domains_mod,       only: mpp_global_field, mpp_global_sum, BITWISE_EXACT_SUM

use time_manager_mod,         only: get_date
use time_interp_external_mod, only: time_interp_external

use ocean_parameters_mod,     only: rho0

use ocean_tpm_util_mod, only: otpm_set_tracer_package, otpm_set_prog_tracer
use fm_util_mod, only: fm_util_check_for_bad_fields, fm_util_set_value
use fm_util_mod, only: fm_util_get_string, fm_util_get_logical, fm_util_get_integer, fm_util_get_real
use fm_util_mod, only: fm_util_get_logical_array, fm_util_get_real_array, fm_util_get_string_array
use fm_util_mod, only: fm_util_start_namelist, fm_util_end_namelist
! use fm_util_mod, only: domain, grid, time, dtts
! use fm_util_mod, only: isc, iec, jsc, jec, nk, isd, ied, jsd, jed 
! use fm_util_mod, only: taum1, tau, taup1 
! use fm_util_mod, only: t_prog, t_diag
! use fm_util_mod, only: indsal, indtemp
! use fm_util_mod, only: end_of_year, end_of_month

use ocean_types_mod,    only: ocean_thickness_type
use ocean_types_mod,    only: ocean_density_type
use ocean_types_mod,    only: ocean_grid_type, ocean_domain_type
use ocean_types_mod,    only: ocean_prog_tracer_type, ocean_diag_tracer_type
use ocean_types_mod,    only: ocean_time_type

use ocean_types_mod,    only: ocean_public_type

use ocean_tracer_diag_mod,   only: calc_mixed_layer_depth

!----------------------------------------------------------------------
!       force all variables to be "typed"
!----------------------------------------------------------------------

implicit none

!----------------------------------------------------------------------
!
!       Make all routines and variables private by default
!
!----------------------------------------------------------------------
private

!----------------------------------------------------------------------
!
!       Public routines
!
!----------------------------------------------------------------------
! order of call  init, start, loop(sbc, source, bbc, tracer), end
public  :: csiro_bgc_bbc
public  :: csiro_bgc_end
public  :: csiro_bgc_init
public  :: csiro_bgc_sbc
public  :: csiro_bgc_source
public  :: csiro_bgc_start
public  :: csiro_bgc_tracer
public  :: csiro_bgc_virtual_fluxes

!----------------------------------------------------------------------
!
!       Private routines
!
!----------------------------------------------------------------------

private :: allocate_arrays

!----------------------------------------------------------------------
!
!       Private parameters
!
!----------------------------------------------------------------------

character(len=fm_field_name_len), parameter     :: package_name = 'csiro_bgc'
character(len=48), parameter                    :: mod_name = 'csiro_bgc_mod'
character(len=fm_string_len), parameter         :: default_file_in = 'INPUT/csiro_bgc.res.nc'
character(len=fm_string_len), parameter         :: default_file_out = 'RESTART/csiro_bgc.res.nc'

integer, parameter                              :: ntr_bmax = 10

!-------------------------------------------------------
! private types
!--------------------------------------------------------

type biotic_type  !{
! set-up tracer indexes
  integer                               :: ntr_bgc = ntr_bmax
  integer,  dimension(ntr_bmax)         :: ind_bgc
  integer,  dimension(ntr_bmax)         :: id_bgc_stf
  integer,  dimension(ntr_bmax)         :: id_bgc_btf
  integer,  dimension(ntr_bmax)         :: id_bgc_vstf
  integer,  dimension(ntr_bmax)         :: id_bgc_src

  logical                               :: init
  character(len=fm_field_name_len)      :: name
! arrays for air-sea fluxes
  real                                      :: sal_global
  real, allocatable, dimension(:)           :: bgc_global
  real, allocatable, dimension(:,:)         :: htotal
  real, allocatable, dimension(:,:)         :: alpha
  real, allocatable, dimension(:,:)         :: csat
  real, allocatable, dimension(:,:)         :: csat_csurf
  real, allocatable, dimension(:,:)         :: csat_acsurf
  real, allocatable, dimension(:,:)         :: csurf
  real, allocatable, dimension(:,:)         :: acsurf
  real, allocatable, dimension(:,:)         :: dpco2
  real, allocatable, dimension(:,:)         :: pco2surf
  real, allocatable, dimension(:,:)         :: paco2surf
  real, allocatable, dimension(:,:)         :: pco2atm
  real, allocatable, dimension(:,:)         :: paco2atm
  real, allocatable, dimension(:,:)         :: det_sediment       ! mmol(NO3) m-2 in DET sitting at base of column as sediment. 
  real, allocatable, dimension(:,:)         :: caco3_sediment     ! mmol(CaCO3) m-2 sitting at base of column as sediment. 
  real, allocatable, dimension(:,:)         :: det_sed_remin      ! mmol(NO3) m-2 s-1, rate of remineralisation of DET in sediment.  
  real, allocatable, dimension(:,:)         :: caco3_sed_remin    ! mmol m-2 s-1, rate of remineralisation of CaCO3 in sediment.  
  real, allocatable, dimension(:,:)         :: det_sed_depst      ! mmol(NO3) m-2 s-1, rate of deposition of DET in sediment.  
  real, allocatable, dimension(:,:)         :: caco3_sed_depst    ! mmol m-2 s-1, rate of deposition of CaCO3 in sediment.  
  real, allocatable, dimension(:,:)         :: sio2
  real, allocatable, dimension(:,:)         :: po4
  real, allocatable, dimension(:,:,:)       :: vstf
end type biotic_type  !}

!----------------------------------------------------------------------
!       Public variables
!----------------------------------------------------------------------

logical, public :: do_csiro_bgc

!----------------------------------------------------------------------
!       Private variables
!----------------------------------------------------------------------
integer                                 :: package_index

! set the tracer index for the various tracers
integer :: id_po4, id_dic, id_alk, id_o2, id_no3, id_phy, id_det, id_zoo &
      , id_caco3, id_adic, id_fe, id_caco3_sediment, id_det_sediment
! internal pointer to make reading the code easier
integer :: ind_po4, ind_dic, ind_alk, ind_o2, ind_no3, ind_phy, ind_det, ind_zoo &
      , ind_caco3, ind_adic, ind_fe
character*6  :: qbio_model
integer      :: bio_version    ! version of the bgc module to use
logical      :: zero_floor     ! apply hard floor to bgc tracers 
logical      :: sw_thru_ice    ! make this true in a coupled model, so bgc knows swflx is already modified for the presense of ice.  
logical      :: gasx_from_file ! use gasx exchange coefficients from provided files. mac, may13.  
logical      :: ice_file4gasx  ! make this true in a ocean-only model, option to control whether to use ice file or the model ice when determining masking effect of ice on co2 gas exchange. 
logical      :: use_access_co2=.false. ! determine whether to use ACCESS atmospheric CO2 or a CO2 file to drive the ocean's anthropogenic CO2 tracer. mac, may13.  

integer  :: id_clock_csiro_obgc

integer                                 :: atmpress_id
character*128                           :: atmpress_file    
character*32                            :: atmpress_name    
real, allocatable, dimension(:,:)       :: fice_t
integer                                 :: id_light_limit = -1
integer                                 :: id_pprod_gross = -1
integer                                 :: id_pprod_gross_2d = -1
integer                                 :: id_zprod_gross = -1
integer                                 :: id_kw_o2  = -1
integer                                 :: id_o2_sat = -1
integer                                 :: id_sc_o2  = -1
integer                                 :: id_pco2 = -1, id_paco2 = -1
integer                                 :: id_co2_sat = -1, id_aco2_sat = -1
integer                                 :: id_caco3_sed_remin, id_det_sed_remin
integer                                 :: id_caco3_sed_depst, id_det_sed_depst
integer                                 :: id_total_aco2_flux, id_total_co2_flux
real, allocatable, dimension(:,:)       :: kw_co2 
real, allocatable, dimension(:,:)       :: kw_o2
real, allocatable, dimension(:,:)       :: patm_t
integer                                 :: pistonveloc_id
integer                                 :: aco2_id
integer                                 :: seaicefract_id
character*128                           :: pistonveloc_file
character*32                            :: pistonveloc_name
character*128                           :: aco2_file
character*32                            :: aco2_name
real, allocatable, dimension(:,:)       :: sc_o2
real, allocatable, dimension(:,:)       :: sc_co2
real, allocatable, dimension(:,:)       :: o2_saturation
character*128                           :: seaicefract_file
character*32                            :: seaicefract_name
character*128                           :: dust_file
character*32                            :: dust_name
integer                                 :: dust_id
real, allocatable, dimension(:,:)       :: dust_t

real, allocatable, dimension(:,:)       :: xkw_t
real, allocatable, dimension(:,:)       :: aco2
real, allocatable, dimension(:,:)             :: htotalhi
real, allocatable, dimension(:,:)             :: htotallo

type(biotic_type), allocatable, dimension(:)    :: biotic
integer                                         :: instances
real, allocatable, dimension(:)                 :: tk
real, allocatable, dimension(:)                 :: ts
real, allocatable, dimension(:)                 :: ts2
real, allocatable, dimension(:)                 :: ts3
real, allocatable, dimension(:)                 :: ts4
real, allocatable, dimension(:)                 :: ts5
real, allocatable, dimension(:)                 :: tt


! rjm biotic parameters 
integer :: n_eudepth=4
real :: p_k = 0.1
real :: rain_ratio = 8.48
real :: s_npp = -1
real :: ratio_poc(ntr_bmax)
real :: ratio_pic(ntr_bmax)

real, allocatable, dimension(:,:,:) :: poc
real, allocatable, dimension(:,:,:) :: pic
real, allocatable, dimension(:,:) :: poc_tot
real, allocatable, dimension(:,:) :: pic_tot
real, allocatable, dimension(:,:) :: pmax_growth
real, allocatable, dimension(:,:) :: pp
real, allocatable, dimension(:) :: fmin_poc
real, allocatable, dimension(:) :: fmin_pic
real, allocatable, dimension(:,:,:) :: biotr
real, allocatable, dimension(:,:) :: light_limit
real, allocatable, dimension(:,:,:) :: pprod_gross
real, allocatable, dimension(:,:) :: pprod_gross_2d
real, allocatable, dimension(:,:,:) :: zprod_gross
real, allocatable, dimension(:) :: ray
real, allocatable, dimension(:) :: dummy
real :: dummy1
real, allocatable, dimension(:) :: tracer_sources
real, allocatable, dimension(:,:) :: area_k
real, allocatable, dimension(:,:) :: tmp

integer :: global_sum_flag      ! flag for mpp_global_sum


integer                                 :: alphabio_id
real, allocatable, dimension(:,:)       :: alphabio
integer                                 :: parbio_id
real, allocatable, dimension(:,:)       :: parbio
integer                                 :: kwbio_id
real, allocatable, dimension(:,:)       :: kwbio
integer                                 :: kcbio_id
real, allocatable, dimension(:,:)       :: kcbio
integer                                 :: abio_id
real, allocatable, dimension(:,:)       :: abio
integer                                 :: bbio_id
real, allocatable, dimension(:,:)       :: bbio
integer                                 :: cbio_id
real, allocatable, dimension(:,:)       :: cbio
integer                                 :: k1bio_id
real, allocatable, dimension(:,:)       :: k1bio
integer                                 :: muepbio_id
real, allocatable, dimension(:,:)       :: muepbio
integer                                 :: muepsbio_id
real, allocatable, dimension(:,:)       :: muepsbio
integer                                 :: gam1bio_id
real, allocatable, dimension(:,:)       :: gam1bio
integer                                 :: gbio_id
real, allocatable, dimension(:,:)       :: gbio
integer                                 :: epsbio_id
real, allocatable, dimension(:,:)       :: epsbio
integer                                 :: muezbio_id
real, allocatable, dimension(:,:)       :: muezbio
integer                                 :: gam2bio_id
real, allocatable, dimension(:,:)       :: gam2bio
integer                                 :: muedbio_id
real, allocatable, dimension(:,:)       :: muedbio
integer                                 :: muecaco3_id
real, allocatable, dimension(:,:)       :: muecaco3
integer                                 :: muedbio_sed_id
real, allocatable, dimension(:,:)       :: muedbio_sed
integer                                 :: muecaco3_sed_id
real, allocatable, dimension(:,:)       :: muecaco3_sed
integer                                 :: wdetbio_id
real, allocatable, dimension(:,:)       :: wdetbio
integer                                 :: wcaco3_id
real, allocatable, dimension(:,:)       :: wcaco3
integer                                 :: nat_co2_id
real, allocatable, dimension(:,:)       :: nat_co2
integer                                 :: tscav_fe_id
real, allocatable, dimension(:,:)       :: tscav_fe
integer                                 :: fe_bkgnd_id
real, allocatable, dimension(:,:)       :: fe_bkgnd
integer                                 :: f_inorg_id
real, allocatable, dimension(:,:)       :: f_inorg


! for extra restart file(s)
integer                          :: id_restart(2)=0
type(restart_file_type), save    :: sed_restart


! Tracer names

character(5), dimension(10) :: tracer_name

!-----------------------------------------------------------------------
!
!       Subroutine and function definitions
!
!-----------------------------------------------------------------------

contains

!#######################################################################
! <SUBROUTINE NAME="allocate_arrays">
!
! <DESCRIPTION>
!     Dynamically allocate arrays
! </DESCRIPTION>
!

subroutine allocate_arrays (isc, iec, jsc, jec, isd, ied, jsd, jed, nk)  !{

!       arguments

!       local variables

integer, intent(in)                                        :: isd, isc
integer, intent(in)                                        :: ied, iec
integer, intent(in)                                        :: jsd, jsc
integer, intent(in)                                        :: jed, jec
integer, intent(in)                                        :: nk
integer :: m
integer :: k
integer :: j
integer :: i
integer :: n
integer :: ntr_bgc

!-----------------------------------------------------------------------
!     start executable code
!-----------------------------------------------------------------------

allocate( xkw_t(isd:ied,jsd:jed) )
allocate( patm_t(isd:ied,jsd:jed) )
allocate( fice_t(isd:ied,jsd:jed) )
allocate( aco2(isd:ied,jsd:jed) )
allocate( dust_t(isd:ied,jsd:jed) )

allocate( sc_o2(isc:iec,jsc:jec) )
allocate( sc_co2(isc:iec,jsc:jec) )
allocate( kw_o2(isc:iec,jsc:jec) )
allocate( kw_co2(isc:iec,jsc:jec) )
allocate( htotalhi(isd:ied,jsd:jed) )
allocate( htotallo(isd:ied,jsd:jed) )


allocate( o2_saturation(isc:iec,jsc:jec) )

allocate( tt(isc:iec) )
allocate( tk(isc:iec) )
allocate( ts(isc:iec) )
allocate( ts2(isc:iec) )
allocate( ts3(isc:iec) )
allocate( ts4(isc:iec) )
allocate( ts5(isc:iec) )

allocate( poc(isc:iec,jsc:jec,nk) )
allocate( pic(isc:iec,jsc:jec,nk) )
allocate( poc_tot(isc:iec,jsc:jec) )
allocate( pic_tot(isc:iec,jsc:jec) )
allocate( pmax_growth(isc:iec,nk) )
allocate( pp(isc:iec,nk) )
allocate( fmin_poc(nk) )
allocate( fmin_pic(nk) )
  ntr_bgc = biotic(1)%ntr_bgc
allocate( ray(nk) )
allocate( biotr(isc:iec,nk,ntr_bgc) )
allocate( light_limit(isc:iec,jsc:jec) )
allocate( pprod_gross(isc:iec,jsc:jec,nk) )
allocate( pprod_gross_2d(isc:iec,jsc:jec) )
allocate( zprod_gross(isc:iec,jsc:jec,nk) )

allocate (tmp(isd:ied,jsd:jed) )
allocate ( tracer_sources(0:nk) )
allocate(area_k(isd:ied,jsd:jed) )    
allocate( dummy(isc:iec) )

!       initialize some arrays

xkw_t(:,:)         = 0.0
patm_t(:,:)        = 0.0
fice_t(:,:)        = 0.0
dust_t(:,:)        = 0.0
aco2(:,:)          = 0.0 
sc_co2(:,:)        = 0.0
kw_co2(:,:)        = 0.0
sc_o2(:,:)         = 0.0
kw_o2(:,:)         = 0.0
o2_saturation(:,:) = 0.0

tt(:)              = 0.0
tk(:)              = 0.0
ts(:)              = 0.0
ts2(:)             = 0.0
ts3(:)             = 0.0
ts4(:)             = 0.0
ts5(:)             = 0.0

!       allocate biotic array elements

do n = 1, instances  !{
! rjm problem -  the allocation of the arrays is done
! after the initialization routine which cause problems
! solution - move the call to array allocation to the init subroutine
!  ntr_bgc = biotic(n)%ntr_bgc
!  allocate( biotic(n)%ind_bgc(1:ntr_bgc) )

  allocate( biotic(n)%htotal(isd:ied,jsd:jed) )
  allocate( biotic(n)%alpha(isd:ied,jsd:jed) )
  allocate( biotic(n)%csat(isd:ied,jsd:jed) )
  allocate( biotic(n)%csat_csurf(isd:ied,jsd:jed) )
  allocate( biotic(n)%csat_acsurf(isd:ied,jsd:jed) )
  allocate( biotic(n)%csurf(isd:ied,jsd:jed) )
  allocate( biotic(n)%acsurf(isd:ied,jsd:jed) )
  allocate( biotic(n)%dpco2(isd:ied,jsd:jed) )
  allocate( biotic(n)%pco2atm(isd:ied,jsd:jed) )
  allocate( biotic(n)%paco2atm(isd:ied,jsd:jed) )
  allocate( biotic(n)%pco2surf(isd:ied,jsd:jed) )
  allocate( biotic(n)%paco2surf(isd:ied,jsd:jed) )
  allocate( biotic(n)%caco3_sediment(isd:ied,jsd:jed) )
  allocate( biotic(n)%det_sediment(isd:ied,jsd:jed) )
  allocate( biotic(n)%caco3_sed_remin(isd:ied,jsd:jed) )
  allocate( biotic(n)%det_sed_remin(isd:ied,jsd:jed) )
  allocate( biotic(n)%caco3_sed_depst(isd:ied,jsd:jed) )
  allocate( biotic(n)%det_sed_depst(isd:ied,jsd:jed) )
  allocate( biotic(n)%sio2(isd:ied,jsd:jed) )
  allocate( biotic(n)%po4(isd:ied,jsd:jed) )

  ntr_bgc = biotic(n)%ntr_bgc
  allocate(biotic(n)%bgc_global(1:ntr_bgc) )
  allocate(biotic(n)%vstf(isc:iec,jsc:jec,1:ntr_bgc) )

enddo  !}

! allocate biotic parameters

allocate( alphabio(isd:ied,jsd:jed) )
allocate( parbio(isd:ied,jsd:jed) )
allocate( kwbio(isd:ied,jsd:jed) )
allocate( kcbio(isd:ied,jsd:jed) )
allocate( abio(isd:ied,jsd:jed) )
allocate( bbio(isd:ied,jsd:jed) )
allocate( cbio(isd:ied,jsd:jed) )
allocate( k1bio(isd:ied,jsd:jed) )
allocate( muepbio(isd:ied,jsd:jed) )
allocate( muepsbio(isd:ied,jsd:jed) )
allocate( gam1bio(isd:ied,jsd:jed) )
allocate( gbio(isd:ied,jsd:jed) )
allocate( epsbio(isd:ied,jsd:jed) )
allocate( muezbio(isd:ied,jsd:jed) )
allocate( gam2bio(isd:ied,jsd:jed) )
allocate( muedbio(isd:ied,jsd:jed) )
allocate( muecaco3(isd:ied,jsd:jed) )
allocate( muedbio_sed(isd:ied,jsd:jed) )
allocate( muecaco3_sed(isd:ied,jsd:jed) )
allocate( wdetbio(isd:ied,jsd:jed) )
allocate( wcaco3(isd:ied,jsd:jed) )
allocate( nat_co2(isd:ied,jsd:jed) )
allocate( tscav_fe(isd:ied,jsd:jed) )
allocate( fe_bkgnd(isd:ied,jsd:jed) )
allocate( f_inorg(isd:ied,jsd:jed) )


!       initialize some arrays

do n = 1, instances  !{
 biotic(n)%htotal(:,:)  = 1.e-8
  biotic(n)%sio2(:,:) = 35. *1e-3
  biotic(n)%bgc_global(:) = 0.  ! this will make vstf zero
  biotic(n)%sal_global = 35.
  biotic(n)%vstf(:,:,:) = 0.
  biotic(n)%caco3_sediment(:,:) = 0.0
  biotic(n)%det_sediment(:,:) = 0.0
enddo  !} n

return
end subroutine  allocate_arrays  !}
! </SUBROUTINE> NAME="allocate_arrays"


!#######################################################################
! <SUBROUTINE NAME="csiro_bgc_bbc">
!
! <DESCRIPTION>
!     compute bottom boundary conditions e.g. fluxes due to
!     interaction with the sediment 
! </DESCRIPTION>
!

subroutine csiro_bgc_bbc (isc, iec, jsc, jec, T_prog, grid, Time)  !{

integer, intent(in)                             :: isc, iec
integer, intent(in)                             :: jsc, jec
type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time


!-----------------------------------------------------------------------
!     local definitions
!-----------------------------------------------------------------------

character(len=64), parameter    :: sub_name = 'csiro_bgc_bbc'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer  :: i, j, n, k, nn
integer  :: ind_temp
real     :: fbc 
logical  :: used

! =====================================================================
!     begin executable code
! =====================================================================

!
!! rjm -- relax Fe to 1 at ocean bottom with 1 day time-constant
!! Huh? This is setting it to zero. RASF
!! Should we delete commented out code?       RASF
!! Yes, fe%btf() values are left as zero...
!!  bottom values for fe are assigned in csiro_bgc_tracer subroutine...
!!  so commenting out this block.  mac, nov10.
!
!do n = 1, instances  !{
! if (id_fe.ne.0) then 
!    ind_fe  = biotic(n)%ind_bgc(id_fe)
!    do j = jsc, jec  !{
!        do i = isc, iec  !{
!           k = grid%kmt(i,j)
!           t_prog(ind_fe)%btf(i,j) = rho0 * -1./86400. *0 ! negative into the ocean
!!grid%tmask(i,j,k) &
!!            / (-1.)  *            &
!!         (1  - max(0.0,t_prog(ind_fe)%field(i,j,k,taum1)))
!     enddo  !} i
!    enddo  !} j
!  endif
!enddo  !} n
!

!! Trial fe source within csiro_bgc_bbc. mac, nov12.
!do n = 1, instances  !{
! if (id_fe.ne.0) then 
!    do j = jsc, jec  !{
!        do i = isc, iec  !{
!           k = grid%kmt(i,j)
!           if (grid%zw(k) .le. 200) &
!t_prog(ind_fe)%btf(i,j) = -1.0 * rho0 * 1000. / 86400.
!!             t_prog(ind_fe)%btf(i,j) = -1.0 * rho0 * (0.999 - t_prog(ind_fe)%field(i,j,k,time%taum1)) * &
!!               grid%dzt(k) / (0.1 * 86400)  ! flux ~ density * diff(concentration) * dz / time_scale
!           ! setting time scale initial to 0.1 of a day, since at present, the concentration of the bottom is fixed in csiro_bgc_tracer;
!           !  and want the time scale to be shorter (stronger) than the scavenging to 0.6 within csiro_bgc_source.  
!           ! mac, nov12.  
!     enddo  !} i
!    enddo  !} j
!  endif
!enddo  !} n





 ! find remineralisation rate of sediment tracers.  mac, nov12.  
 call time_interp_external(muedbio_sed_id, time%model_time, muedbio_sed)
 call time_interp_external(muecaco3_sed_id, time%model_time, muecaco3_sed)
 ind_temp = fm_get_index('/ocean_mod/prog_tracers/temp')

 do n = 1, instances  !{
   do j = jsc, jec  !{
     do i = isc, iec  !{
       k = grid%kmt(i,j)
       if (k .gt. 0) then
         fbc= bbio(i,j)**(cbio(i,j)*T_prog(ind_temp)%field(i,j,k,time%taum1))
         biotic(n)%det_sed_remin(i,j) = muedbio_sed(i,j)*fbc*biotic(n)%det_sediment(i,j)
         biotic(n)%caco3_sed_remin(i,j) = muecaco3_sed(i,j)*fbc*biotic(n)%caco3_sediment(i,j)
         
! remineralisation of sediments to supply nutrient fields.  
! NB, btf values are positive from the water column into the sediment.  mac, nov12.  
         T_prog(ind_no3)%btf(i,j) = -1.0 * rho0 * biotic(n)%det_sed_remin(i,j)
         if (id_o2 .ne. 0) &
           T_prog(ind_o2)%btf(i,j)  = -172./16. * T_prog(ind_no3)%btf(i,j)
         if (id_dic .ne. 0) &
           T_prog(ind_dic)%btf(i,j)  = 106./16. * T_prog(ind_no3)%btf(i,j) - &
             rho0 * biotic(n)%caco3_sed_remin(i,j)
         if (id_adic .ne. 0) &
           T_prog(ind_adic)%btf(i,j)  = T_prog(ind_dic)%btf(i,j)
         if (id_fe .ne. 0) &
           T_prog(ind_fe)%btf(i,j)  = 2.0e-2 * T_prog(ind_no3)%btf(i,j)
         if (id_alk .ne. 0) &
           T_prog(ind_alk)%btf(i,j)  = -2.0 * rho0 * biotic(n)%caco3_sed_remin(i,j) - &
             T_prog(ind_no3)%btf(i,j)

       endif !} k > 0
     enddo  !} i
   enddo  !} j
 enddo  !} n
 
 

 ! send rate of remineralisation of sediment tracers to output. mac, nov12.
 do n = 1, instances  !{
  if (id_caco3_sed_remin .gt. 0) then
     used = send_data(id_caco3_sed_remin, biotic(n)%caco3_sed_remin(isc:iec,jsc:jec),          &
        time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
  endif
  if (id_det_sed_remin .gt. 0) then
     used = send_data(id_det_sed_remin, biotic(n)%det_sed_remin(isc:iec,jsc:jec),          &
        time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
  endif
 enddo

do n = 1, instances  !{
 do nn=1,biotic(n)%ntr_bgc
! save the tracer bottom fluxes
  if (biotic(n)%id_bgc_btf(nn) .gt. 0) then
    used = send_data(biotic(n)%id_bgc_btf(nn),                        &
         t_prog(biotic(n)%ind_bgc(nn))%btf(isc:iec,jsc:jec)/rho0,                    &
         time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
  endif
 enddo  !} nn
enddo  !} n

 
return
end subroutine  csiro_bgc_bbc  !}
! </SUBROUTINE> NAME="csiro_bgc_bbc"

!#######################################################################
! <SUBROUTINE NAME="csiro_bgc_end">
!
! <DESCRIPTION>
!     Clean up various BIOTIC quantities for this run.
! </DESCRIPTION>
!

subroutine csiro_bgc_end(isc, iec, jsc, jec, taup1, Thickness, T_prog, grid)  !{ 

type(ocean_thickness_type), intent(in) :: Thickness
integer, intent(in)                             :: isc
integer, intent(in)                             :: iec
integer, intent(in)                             :: jsc
integer, intent(in)                             :: jec
integer, intent(in)                             :: taup1
type(ocean_prog_tracer_type), dimension(:), intent(in)       :: T_prog
type(ocean_grid_type), intent(in)                               :: Grid

!-----------------------------------------------------------------------
!     local definitions
!-----------------------------------------------------------------------

character(len=64), parameter    :: sub_name = 'csiro_bgc_end'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer :: i
integer :: j
integer :: k
integer :: lun
integer :: n
real    :: total_det
real    :: total_zoo
real    :: total_phy
real    :: total_o2
real    :: total_no3

! =====================================================================
!     begin executable code
! =====================================================================

!       integrate the total concentrations of some tracers
!       for the end of the run

total_no3      = 0.0
total_phy      = 0.0
total_o2       = 0.0
total_zoo      = 0.0
total_det      = 0.0

do n = 1, instances  !{
  do k = 1,grid%nk !{
    do j = jsc, jec  !{
      do i = isc, iec  !{
        total_no3 = total_no3 +                                 &
             t_prog(biotic(n)%ind_bgc(1))%field(i,j,k,taup1) *     &
             grid%dat(i,j) * grid%tmask(i,j,k) * Thickness%rho_dzt(i,j,k,taup1)
        total_phy = total_phy +                                 &
             t_prog(biotic(n)%ind_bgc(2))%field(i,j,k,taup1) *     &
             grid%dat(i,j) * grid%tmask(i,j,k) * Thickness%rho_dzt(i,j,k,taup1)
        total_o2 = total_o2 +                                   &
             t_prog(biotic(n)%ind_bgc(3))%field(i,j,k,taup1) *      &
             grid%dat(i,j) * grid%tmask(i,j,k) * Thickness%rho_dzt(i,j,k,taup1)
        total_zoo = total_zoo +                                 &
             t_prog(biotic(n)%ind_bgc(4))%field(i,j,k,taup1) *     &
             grid%dat(i,j) * grid%tmask(i,j,k) * Thickness%rho_dzt(i,j,k,taup1)
        total_det = total_det +                   &
             t_prog(biotic(n)%ind_bgc(5))%field(i,j,k,taup1) *     &
             grid%dat(i,j) * grid%tmask(i,j,k) * Thickness%rho_dzt(i,j,k,taup1)
      enddo  !} i
    enddo  !} j
  enddo  !} k

  call mpp_sum(total_no3)
  call mpp_sum(total_phy)
  call mpp_sum(total_o2)
  call mpp_sum(total_zoo)
  call mpp_sum(total_det)

  write (stdout(),*) '  Instance ', trim(biotic(n)%name)
  write (stdout(),                                              &
       '(/'' Total NO3  = '',es19.12,'' Gmol N'')')     &
       total_no3 * 1.0e-12
  write (stdout(),                                              &
       '(/'' Total PHY  = '',es19.12,'' Gmol N'')')         &
       total_phy * 1.0e-12
  write (stdout(),                                              &
       '(/'' Total O2  = '',es19.12,'' Gmol O2'')')          &
       total_o2 * 1.0e-12
  write (stdout(),                                              &
       '(/'' Total ZOO  = '',es19.12,'' Gmol N'')')         &
       total_zoo * 1.0e-12
  write (stdout(),                                              &
       '(/'' Total DET  = '',es19.12,'' Gmol N'')')     &
       total_det * 1.0e-12
  write (stdout(),                                              &
       '(/'' Total N  = '',es19.12,'' Gmol N'')') &
       (total_no3+total_phy+total_zoo+total_det) * 1.0e-12

!
!  Write out extra restart file(s)
!

  call reset_field_pointer(sed_restart, id_restart(1), biotic(n)%caco3_sediment(:,:))
  call reset_field_pointer(sed_restart, id_restart(2), biotic(n)%det_sediment(:,:))

  call save_restart(sed_restart)

enddo  !} n

return
end subroutine  csiro_bgc_end  !}
! </SUBROUTINE> NAME="csiro_bgc_end"


!#######################################################################
! <SUBROUTINE NAME="csiro_bgc_sbc">
!
! <DESCRIPTION>
!     Calculate the surface boundary conditions
! </DESCRIPTION>
!

subroutine csiro_bgc_sbc(isc, iec, jsc, jec, isd, ied, jsd, jed, &
    T_prog, aice, wnd, grid, time, use_waterflux, salt_restore_as_salt_flux, atm_co2, co2flux, sfc_co2)

use ocmip2_co2calc_mod
use mpp_mod, only : mpp_sum
use time_interp_external_mod, only: time_interp_external
use time_manager_mod, only: days_in_year, days_in_month,        &
     get_date, set_date
use field_manager_mod,    only: fm_get_index

integer, intent(in)                             :: isc, iec
integer, intent(in)                             :: jsc, jec
integer, intent(in)                             :: isd, ied
integer, intent(in)                             :: jsd, jed
type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time
real, intent(in), dimension(isd:ied,jsd:jed)                    :: aice, wnd
logical, intent(in) :: use_waterflux, salt_restore_as_salt_flux

real, intent(in), dimension(isd:ied,jsd:jed), optional          :: atm_co2
real, intent(out), dimension(isd:ied,jsd:jed), optional         :: co2flux
real, intent(out), dimension(isd:ied,jsd:jed), optional         :: sfc_co2

real :: total_co2_flux, total_aco2_flux
logical :: used

!-----------------------------------------------------------------------
!     local definitions
!-----------------------------------------------------------------------

character(len=64), parameter    :: sub_name = 'csiro_bgc_sbc'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!       coefficients for O2 saturation
!

real, parameter :: a_0 = 2.00907
real, parameter :: a_1 = 3.22014
real, parameter :: a_2 = 4.05010
real, parameter :: a_3 = 4.94457
real, parameter :: a_4 = -2.56847e-01
real, parameter :: a_5 = 3.88767
real, parameter :: b_0 = -6.24523e-03
real, parameter :: b_1 = -7.37614e-03
real, parameter :: b_2 = -1.03410e-02
real, parameter :: b_3 = -8.17083e-03
real, parameter :: c_0 = -4.88682e-07

integer :: i
integer :: j
integer :: k
integer :: n
integer :: nn
integer :: ntr_bgc
integer :: ind_trc
integer :: m
integer :: kz
integer :: hour
integer :: day
real    :: days_in_this_year
integer :: minute
integer :: month
integer :: num_days
integer :: second
integer :: year
integer :: indtemp, indsal

! =====================================================================
!     begin executable code
! =====================================================================

  call get_date(time%model_time,                                &
                year, month, day, hour, minute, second)
  num_days = days_in_year(time%model_time)
  days_in_this_year = 0.0
  do m = 1, month - 1
    days_in_this_year = days_in_this_year +                     &
                       days_in_month(set_date(year, m, 1))
  enddo
  days_in_this_year = days_in_this_year + day - 1 + hour/24.0 + &
                      minute/1440.0 + second/86400.0

!---------------------------------------------------------------------
!     calculate interpolated xkw, seaice fraction and atmospheric
!       pressure & solar radiation
!---------------------------------------------------------------------
if (gasx_from_file) then
 call time_interp_external(pistonveloc_id, time%model_time, xkw_t)
else
 do j=jsc, jec
  do i=isc, iec
! the relations 0.31 * u^2 comes from Wanninkhof 1992, and is the coefficient for steady wind speed; the equation is 0.39 * u^2 for instaneous wind speeds. I don't know what exactly the timescale is between steady and instaneous...
! the 3.6e5 is a conversion of units; cm/hr to m/s.
! mac, may13.
   xkw_t(i,j)=(0.31 * wnd(i,j)**2.0 ) /3.6e5   
  enddo ! i
 enddo ! j
endif ! if (gasx_from_file)

call time_interp_external(nat_co2_id, time%model_time, nat_co2)
call time_interp_external(atmpress_id, time%model_time, patm_t)
call time_interp_external(dust_id, time%model_time, dust_t)
if (id_adic .ne. 0) then
! The atmospheric co2 value for the anthropogenic+natural carbon tracer
! is either read from a file or a value from the access atmospheric model, 
! as determined by the flag use_access_co2.  mac, may13.  
 if (use_access_co2) then 
  aco2(isc:iec,jsc:jec) = atm_co2(isc:iec,jsc:jec)
 else
  call time_interp_external(aco2_id, time%model_time, aco2)
 endif
endif
if (ice_file4gasx) then
 call time_interp_external(seaicefract_id, time%model_time, fice_t)
else
 fice_t(isc:iec,jsc:jec) = aice(isc:iec,jsc:jec)
endif

indtemp = fm_get_index('/ocean_mod/prog_tracers/temp')
indsal = fm_get_index('/ocean_mod/prog_tracers/salt')

! -------------------------------------------------------------------
! rjm: start by zeroing the fluxes
if ((.not. use_waterflux) .or. (salt_restore_as_salt_flux)) then  !{
 do n = 1, instances  !{
  ntr_bgc = biotic(n)%ntr_bgc
    do nn=1,ntr_bgc
     ind_trc =  biotic(n)%ind_bgc(nn)
     t_prog(ind_trc)%stf(:,:) = 0     
    enddo
 enddo
endif

!---------------------------------------------------------------------
!  Compute the Schmidt number of CO2 in seawater using the 
!  formulation presented by Wanninkhof (1992, J. Geophys. Res., 97,
!  7373-7382).
!---------------------------------------------------------------------
!
! no point doing the following calculations if no dic and o2 tracer
if (id_dic .eq. 0 .and. id_o2.eq. 0) return

do j = jsc, jec  !{
  do i = isc, iec  !{
    sc_co2(i,j) = 2073.1 + t_prog(indtemp)%field(i,j,1,time%taum1) * &
         (-125.62 + t_prog(indtemp)%field(i,j,1,time%taum1) *        &
          (3.6276 + t_prog(indtemp)%field(i,j,1,time%taum1) *        &
           (-0.043219))) * grid%tmask(i,j,1)
  enddo  !} i
enddo  !} j 

!---------------------------------------------------------------------
!  Compute the Schmidt number of O2 in seawater using the 
!  formulation proposed by Keeling et al. (1998, Global Biogeochem.
!  Cycles, 12, 141-163).
!---------------------------------------------------------------------

do j = jsc, jec  !{
  do i = isc, iec  !{
    sc_o2(i,j) = 1638.0 + t_prog(indtemp)%field(i,j,1,time%taum1) *  &
         (-81.83 + t_prog(indtemp)%field(i,j,1,time%taum1) *         &
          (1.483 + t_prog(indtemp)%field(i,j,1,time%taum1) *         &
           (-0.008004))) * grid%tmask(i,j,1)
  enddo  !} i
enddo  !} j 


!---------------------------------------------------------------------
!     calculate csurf, csat and csat - csurf via the routine co2calc
!        input and output units are in mol/m^3
!---------------------------------------------------------------------

!   determine the atmospheric pCO2 concetration for this time-step
do n = 1, instances  !{
  do j = jsc, jec
   do i = isc, iec
    biotic(n)%pco2atm(i,j) = nat_co2(i,j)
   enddo
  enddo
enddo  !} n

if (id_adic .ne. 0) then
 do n = 1, instances  !{
  do j = jsc, jec
   do i = isc, iec
    biotic(n)%paco2atm(i,j) = aco2(i,j)
   enddo
  enddo
 enddo  !} n
endif

!call init_ocmip2_co2calc(                                       &
!     time%model_time, isc, iec, jsc, jec, 1,                    &
!     t_prog(indtemp)%field(isc:iec,jsc:jec,1,time%taum1),            &
!     t_prog(indsal)%field(isc:iec,jsc:jec,1,time%taum1))

do n = 1, instances  !{
  do j = jsc, jec  !{
    do i = isc, iec  !{
      htotallo(i,j) =  .1
      htotalhi(i,j) =  100.0
    enddo  !} i
  enddo  !} j 

! ocmip2+co2cal expects tracers in mol/m3 !!!!
  if (id_dic.ne.0) then
    biotic(n)%po4(:,:) = t_prog(ind_dic)%field(isd:ied,jsd:jed,1,time%taum1)*0
    if (id_no3.ne.0) biotic(n)%po4(:,:) = t_prog(ind_no3)%field(isd:ied,jsd:jed,1,time%taum1)/16.*1e-3
    if (id_po4.ne.0) biotic(n)%po4(:,:) = t_prog(ind_po4)%field(isd:ied,jsd:jed,1,time%taum1)*1e-3

    call ocmip2_co2calc(isd, jsd, &
       isc, iec, jsc, jec,                     &
       grid%tmask(isd:ied,jsd:jed,1),                           &
       t_prog(indtemp)%field(isd:ied,jsd:jed,1,time%taum1),     &
       t_prog(indsal)%field(isd:ied,jsd:jed,1,time%taum1),     &
       t_prog(ind_dic)%field(isd:ied,jsd:jed,1,time%taum1)*1e-3,&
       t_prog(ind_alk)%field(isd:ied,jsd:jed,1,time%taum1)*1e-3,&
       biotic(n)%po4(isd:ied,jsd:jed),&
       biotic(n)%sio2(isd:ied,jsd:jed),                       &
       htotallo(isc:iec,jsc:jec), htotalhi(isc:iec,jsc:jec), &
       biotic(n)%htotal(isc:iec,jsc:jec),                      &
       biotic(n)%csurf(isc:iec,jsc:jec),                    &
       alpha=biotic(n)%alpha(isc:iec,jsc:jec) ,                   &            
       pco2surf = biotic(n)%pco2surf(isc:iec,jsc:jec),            &
       scale= 1.0/1024.5 )

    if (id_adic .ne. 0) then ! calculate CO2 flux including anthropogenic CO2
      call ocmip2_co2calc(isd, jsd,                     &
       isc, iec, jsc, jec,                    &
       grid%tmask(isd:ied,jsd:jed,1),                           &
       t_prog(indtemp)%field(isd:ied,jsd:jed,1,time%taum1),     &
       t_prog(indsal)%field(isd:ied,jsd:jed,1,time%taum1),     &
       t_prog(ind_adic)%field(isd:ied,jsd:jed,1,time%taum1)*1e-3,&
       t_prog(ind_alk)%field(isd:ied,jsd:jed,1,time%taum1)*1e-3,&
       biotic(n)%po4(isd:ied,jsd:jed),&
       biotic(n)%sio2(isd:ied,jsd:jed),                       &
       htotallo(isc:iec,jsc:jec), htotalhi(isc:iec,jsc:jec), &
       biotic(n)%htotal(isc:iec,jsc:jec),                      &
       biotic(n)%acsurf(isc:iec,jsc:jec),                    &
       alpha=biotic(n)%alpha(isc:iec,jsc:jec) ,                   &            
       pco2surf = biotic(n)%paco2surf(isc:iec,jsc:jec),           &
       scale = 1.0/1024.5 )
    endif  ! no adic
  endif  ! no dic
enddo  !} n 


!---------------------------------------------------------------------
!  Compute the oxygen saturation concentration at 1 atm total
!  pressure in mol/m^3 given the temperature (t, in deg C) and
!  the salinity (s, in permil)
!
!  From Garcia and Gordon (1992), Limnology and Oceonography.
!  The formula used is from page 1310, eq (8).
!
!  *** Note: the "a3*ts^2" term (in the paper) is incorrect. ***
!  *** It shouldn't be there.                                ***
!
!  o2_saturation is defiend between T(freezing) <= T <= 40 deg C and
!                                   0 permil <= S <= 42 permil
!
! check value: T = 10 deg C, S = 35 permil,
!              o2_saturation = 0.282015 mol/m^3
!---------------------------------------------------------------------
!

do j = jsc, jec  !{
  do i = isc, iec  !{
    tt(i) = 298.15 - t_prog(indtemp)%field(i,j,1,time%taum1)
    tk(i) = 273.15 + t_prog(indtemp)%field(i,j,1,time%taum1)
    ts(i) = log(tt(i) / tk(i))
    ts2(i) = ts(i) * ts(i)
    ts3(i) = ts2(i) * ts(i)
    ts4(i) = ts3(i) * ts(i)
    ts5(i) = ts4(i) * ts(i)
    o2_saturation(i,j) =                                        &
         exp(a_0 + a_1*ts(i) + a_2*ts2(i) +                     &
             a_3*ts3(i) + a_4*ts4(i) + a_5*ts5(i) +             &
             t_prog(indsal)%field(i,j,1,time%taum1) *                &
             (b_0 + b_1*ts(i) + b_2*ts2(i) + b_3*ts3(i) +       &
              c_0*t_prog(indsal)%field(i,j,1,time%taum1)))
  enddo  !} i
enddo  !} j 

!chd
!chd       convert from ml/l to mmol/m^3
!chd

do j = jsc, jec  !{
  do i = isc, iec  !{
    o2_saturation(i,j) = o2_saturation(i,j) *                   &
                        (1000.*1000.0/22391.6)
  enddo  !} i
enddo  !} j 

!
!---------------------------------------------------------------------
!     calculate piston-velocities
!      including  effect of sea-ice
!      xkw is given in cm/s (converted in read_biotic_bc), therefore
!      kw is also in cm/s
!---------------------------------------------------------------------

do j = jsc, jec  !{
  do i = isc, iec  !{
    kw_co2(i,j) = (1.0 - fice_t(i,j)) * xkw_t(i,j) *            &
                   sqrt(660.0/sc_co2(i,j)) * grid%tmask(i,j,1)

    kw_o2(i,j) = (1.0 - fice_t(i,j)) * xkw_t(i,j) *             &
                  sqrt(660.0/sc_o2(i,j)) * grid%tmask(i,j,1)
  enddo  !} i
enddo  !} j 

!
!chd---------------------------------------------------------------------
!chd     calculate surface fluxes for BIOTICs
!chd       kw is in m/s, o2_sat is in mmol/m^3,  
!chd       hence stf should be in  mmol/m^2/s
!chd---------------------------------------------------------------------
!

total_co2_flux = 0.0

if (id_dic.ne.0) then
  do n = 1, instances  !{
    do j = jsc, jec  !{
      do i = isc, iec  !{ 
       ! These calculations used to be done in ocmip2_co2calc in mom4p1_2007, 
       !  but not with mom4p1_2009.  
       ! Some extra calculations now required in csiro_bgc_sbc for co2 air-sea 
       ! alpha is in units of mol/m3/atm (atm -> partial pressure of CO2), and 1e6 is to convert micro-atm to atm.
       !  flux.   mac, apr11.  
       biotic(n)%csat(i,j) = biotic(n)%pco2atm(i,j) / 1e6 * biotic(n)%alpha(i,j) * patm_t(i,j)
       biotic(n)%csat_csurf(i,j) = biotic(n)%csat(i,j) - biotic(n)%csurf(i,j)
       
       t_prog(ind_dic)%stf(i,j) = rho0 * kw_co2(i,j) *        &
        biotic(n)%csat_csurf(i,j)*1e3 !convert from  mol/m^3 to mmol/m^3

       total_co2_flux = total_co2_flux + kw_co2(i,j) *        &
        biotic(n)%csat_csurf(i,j) * 3.7843e-7 * grid%dat(i,j) * grid%tmask(i,j,1) ! convert from  mol/s to Pg/year (12.0*1e-15*86400*365=3.78e-7)
      enddo  !} i
    enddo  !} j 
  enddo  !} n 
endif

if (id_total_co2_flux .gt. 0) then
 call mpp_sum(total_co2_flux)
 used = send_data(id_total_co2_flux,total_co2_flux,Time%model_time)
endif


total_aco2_flux = 0.0 

if (id_adic.ne.0) then
  do n = 1, instances  !{
    do j = jsc, jec  !{
      do i = isc, iec  !{
       ! These calculations used to be done in ocmip2_co2calc in mom4p1_2007, 
       !  but not with mom4p1_2009.  
       ! Some extra calculations now required in csiro_bgc_sbc for co2 air-sea 
       !  flux.   mac, apr11.  
       ! Note, csat has been used as temporary variable, alpha is only f(T,S),
       !  csurf had been used as a temporary variable, but now needs to be saved
       !  for preindustrial vs anthropogenic.
       biotic(n)%csat(i,j) = biotic(n)%paco2atm(i,j) / 1e6 * biotic(n)%alpha(i,j) * patm_t(i,j)
       biotic(n)%csat_acsurf(i,j) = biotic(n)%csat(i,j) - biotic(n)%acsurf(i,j)
       
       t_prog(ind_adic)%stf(i,j) = rho0 * kw_co2(i,j) *        &
        biotic(n)%csat_acsurf(i,j)*1e3 !convert from  mol/m^3 to mmol/m^3

       total_aco2_flux = total_aco2_flux + kw_co2(i,j) *        &
        biotic(n)%csat_acsurf(i,j) * 3.7843e-7 * grid%dat(i,j) * grid%tmask(i,j,1) ! convert from  mol/s to Pg/year (12.0*1e-15*86400*365=3.78e-7)
! send the anthropogenic Pco2 and co2 flux into the ocean back to the atmospheric model.  mac, may13.  
!RASF avoid using Ocean_sfc. 
!       if(present(Ocean_sfc)) then
!          Ocean_sfc%co2flux(i,j) = kw_co2(i,j) *        &
!                                   biotic(n)%csat_acsurf(i,j)*0.04401 !convert from  mol/m^2/s to kg(CO2)/m^2/s, 0.04401 kg(CO2)/mole
!          Ocean_sfc%co2(i,j) = biotic(n)%paco2surf(i,j) 
!       endif
      enddo  !} i
    enddo  !} j 
    if(present(co2flux) .and. present(sfc_co2)) then
      do j = jsc, jec  !{
        do i = isc, iec  !{
          co2flux(i,j) = kw_co2(i,j) *        &
                                   biotic(n)%csat_acsurf(i,j)*0.04401 !convert from  mol/m^2/s to kg(CO2)/m^2/s, 0.04401 kg(CO2)/mole
          sfc_co2(i,j) = biotic(n)%paco2surf(i,j) 
        enddo  !} i
      enddo  !} j 
    endif
    
  enddo  !} n 
endif

if (id_total_aco2_flux .gt. 0) then
 call mpp_sum(total_aco2_flux)
 used = send_data(id_total_aco2_flux,total_aco2_flux,Time%model_time)
endif


if (id_o2.ne.0) then
  do n = 1, instances  !{
    do j = jsc, jec  !{
      do i = isc, iec  !{
        t_prog(ind_o2)%stf(i,j) =   rho0 *     kw_o2(i,j) *        &
            (o2_saturation(i,j) * patm_t(i,j) -                     &
             t_prog(ind_o2)%field(i,j,1,time%taum1))
      enddo  !} i
    enddo  !} j 
  enddo  !} n 
endif

!rjm: Do atmospheric iron input
! for Fe units of nmol/m3, Fe input must be in nmol/m2/s
if (id_fe.ne.0) then
  do n = 1, instances  !{
    do j = jsc, jec  !{
      do i = isc, iec  !{
        t_prog(ind_fe)%stf(i,j) =  rho0 * dust_t(i,j)
      enddo  !} i
    enddo  !} j
  enddo  !} n
endif

if (.not. use_waterflux)  then  !{
! rjm - One only needs to compute virtual fluxes if waterflux is not used
! NB, when this routine is called, t_prog(ind_sal)%stf() only has applied fluxes
!  and not any restoring fluxes.  
! csiro_bgc_virtual_fluxes() now calculated BGC virtual fluxes if any virtual flux 
!  is use to restore salinity.   mac, dec12.  
  do n = 1, instances  !{
    ntr_bgc = biotic(n)%ntr_bgc

    do nn=1,ntr_bgc
      ind_trc =  biotic(n)%ind_bgc(nn) 

      do j = jsc, jec  !{
        do i = isc, iec  !{
          biotic(n)%vstf(i,j,nn) =                    &
               t_prog(indsal)%stf(i,j) *                &
               biotic(n)%bgc_global(nn) / biotic(n)%sal_global
          t_prog(ind_trc)%stf(i,j) =                  &
               t_prog(ind_trc)%stf(i,j) +             &
               biotic(n)%vstf(i,j,nn)
        enddo  !} i
      enddo  !} j
    enddo !} nn
  enddo  !} n 
endif  !}
   
return

end subroutine  csiro_bgc_sbc  !}
! </SUBROUTINE> NAME="csiro_bgc_sbc"

!#######################################################################
! <SUBROUTINE NAME="csiro_bgc_virtual_fluxes">
!
! <DESCRIPTION>
!      Apply virtual fluxes to BGC tracers when sea surface salinity
!      is restored as a salt flux within ocean_sbc//flux_adjust()
!      This subroutine only adds the virtual flux associated with
!      any virtual salt fluxes from salinity restoring; any virtual fluxes
!      from applied forcing (i.e. when use_waterflux = .false.) are applied to 
!      bgc virtual fluxes with the csiro_bgc_sbc() subroutine.  
!      mac, dec12.
! </DESCRIPTION>

subroutine csiro_bgc_virtual_fluxes(isc, iec, jsc, jec, isd, ied, jsd, jed, salt_vstf, T_prog)  !{

!-----------------------------------------------------------------------
!       arguments
!-----------------------------------------------------------------------

integer, intent(in)                          :: isc, iec, jsc, jec, isd, ied, jsd, jed
real, intent(in), dimension(isd:ied,jsd:jed) :: salt_vstf    ! virtual salt flux.  
type(ocean_prog_tracer_type), dimension(:), intent(inout) :: T_prog


!-----------------------------------------------------------------------
!       local definitions
!-----------------------------------------------------------------------

integer  :: i, j, n, nn, ntr_bgc, ind_trc

!-----------------------------------------------------------------------
!       start executable code
!-----------------------------------------------------------------------

  do n = 1, instances  !{
    ntr_bgc = biotic(n)%ntr_bgc

    do nn=1,ntr_bgc
      ind_trc =  biotic(n)%ind_bgc(nn) 

      do j = jsc, jec  !{
        do i = isc, iec  !{
          biotic(n)%vstf(i,j,nn) =             &
               salt_vstf(i,j) *                &
               biotic(n)%bgc_global(nn) / biotic(n)%sal_global
          t_prog(ind_trc)%stf(i,j) =                  &
               t_prog(ind_trc)%stf(i,j) +             &
               biotic(n)%vstf(i,j,nn)
        enddo  !} i
      enddo  !} j
    enddo !} nn
  enddo  !} n 


end subroutine  csiro_bgc_virtual_fluxes  !}
! </SUBROUTINE> NAME="csiro_bgc_virtual_fluxes"


!#######################################################################
! <SUBROUTINE NAME="csiro_bgc_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the tracer packages
!
!       Save pointers to various "types", such as Grid and Domains.
! </DESCRIPTION>

subroutine csiro_bgc_init  !{

!-----------------------------------------------------------------------
!       local definitions
!-----------------------------------------------------------------------

character(len=64), parameter    :: sub_name = 'csiro_bgc_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=128)              :: version = "git:/mom_mac/src/mom5csiro_bgc.F90"
character(len=128)              :: tagname = "mac, sep16."

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=fm_string_len)                            :: string
character(len=fm_field_name_len+3)                      :: long_suffix
character(len=256)                                      :: caller_str
character(len=fm_string_len), pointer, dimension(:)     :: good_list

integer                                                 :: nn, ntr_bgc
real                                                    :: min_range=0.0, max_range=1.e4
real                                                    :: sum_ntr = 0.0
character(len=8)                                        :: bgc_trc='tracer00'

!       Initialize the csiro_bgc package

!package_index = otpm_set_tracer_package(package_name,            &
!     file_in = default_file_in, file_out = default_file_out,     &
!     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
package_index = otpm_set_tracer_package(package_name,            &
       restart_file = default_file_in,      &
      caller = trim(mod_name) // '(' // trim(sub_name) // ')')

!       Check whether to use this package

path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
instances = fm_get_length(path_to_names)
if (instances .lt. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
endif  !}

!       Check some things

if (instances .eq. 0) then  !{
  write (stdout(),*) trim(note_header), ' No instances'
  do_csiro_bgc = .false.
else  !}{
  if (instances .eq. 1) then  !{
    write (stdout(),*) trim(note_header), ' ', instances, ' instance'
  else  !}{
    write (stdout(),*) trim(note_header), ' ', instances, ' instances'
    call mpp_error(FATAL, trim(error_header) // ' CSIRO_bgc code not yet ready for instances > 1, mac, nov12')
  endif  !}
  do_csiro_bgc = .true.
endif  !}

!       Return if we don't want to use this package,
!       after changing the list back

if (.not. do_csiro_bgc) then  !{
  return
endif  !}

!       allocate storage for biotic array
allocate ( biotic(instances) )

!       loop over the names, saving them into the biotic array

do n = 1, instances  !{
  if (fm_get_value(path_to_names, name, index = n)) then  !{
    biotic(n)%name = name
  else  !}{
    write (name,*) n
    call mpp_error(FATAL, trim(error_header) //        &
         'Bad field name for index ' // trim(name))
  endif  !}
enddo  !}

 
!-----------------------------------------------------------------------
!       Process the namelists
!-----------------------------------------------------------------------

!       Add the package name to the list of good namelists, to be used
!       later for a consistency check

if (fm_new_value('/ocean_mod/GOOD/good_namelists', package_name, append = .true.) .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) //                           &
       ' Could not add ' // trim(package_name) // ' to "good_namelists" list')
endif  !}

!-----------------------------------------------------------------------
!       Set up the *global* namelist
!-----------------------------------------------------------------------

caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

call fm_util_start_namelist(package_name, '*global*', caller = caller_str, no_overwrite = .true., &
     check = .true.)

  call fm_util_set_value('atmpress_file', 'INPUT/atmpress_ocmip2.nc')
  call fm_util_set_value('atmpress_name', 'atmpress')
  call fm_util_set_value('pistonveloc_file', 'INPUT/pistonveloc_ocmip2.nc')
  call fm_util_set_value('pistonveloc_name', 'pistonveloc')
  call fm_util_set_value('aco2_file', 'INPUT/co2_b35_2D.nc')
  call fm_util_set_value('aco2_name', 'co2')
  call fm_util_set_value('seaicefract_file', 'INPUT/f_ice_ocmip2.nc')
  call fm_util_set_value('seaicefract_name', 'f_ice')
  call fm_util_set_value('dust_file', 'INPUT/dust.nc')
  call fm_util_set_value('dust_name', 'DUST')

! additional information
  call fm_util_set_value('s_npp', -.1)           ! scale factor for NP
  call fm_util_set_value('qbio_model', 'bio_vx') ! version name 
  call fm_util_set_value('bio_version',1)        ! version of the bgc module
  call fm_util_set_value('zero_floor', .false.)  ! apply hard floor to bgc tracers
  call fm_util_set_value('sw_thru_ice', .true.)  ! is shortwave flux modified by an ice model?
  call fm_util_set_value('gasx_from_file', .true.)! use file with gas exchange coefficients?
  call fm_util_set_value('ice_file4gasx', .true.)! use file with ice cover for gas exchange?
! Set defaults to use the ACCESS atmospheric CO2 for the anthropogenic CO2 in the ocean if this is compiled for ACCESS-CM/ESM, otherwise to read CO2 from files provided.  mac, may13.  
#if defined(ACCESS_CM) 
  call fm_util_set_value('use_access_co2', .true.)! use access model co2 values.  mac, may13.  
#else
  call fm_util_set_value('use_access_co2', .false.)! use file for atmospheric co2 values.  
#endif
  call fm_util_set_value('id_po4',0)      
  call fm_util_set_value('id_dic',0)      
  call fm_util_set_value('id_adic',0)      
  call fm_util_set_value('id_alk',0)      
  call fm_util_set_value('id_o2',0)      
  call fm_util_set_value('id_no3',0)      
  call fm_util_set_value('id_phy',0)      
  call fm_util_set_value('id_zoo',0)      
  call fm_util_set_value('id_det',0)      
  call fm_util_set_value('id_caco3',0)      
  call fm_util_set_value('id_fe',0)      

  atmpress_file      =  fm_util_get_string ('atmpress_file', scalar = .true.)
  atmpress_name      =  fm_util_get_string ('atmpress_name', scalar = .true.)
  pistonveloc_file   =  fm_util_get_string ('pistonveloc_file', scalar = .true.)
  pistonveloc_name   =  fm_util_get_string ('pistonveloc_name', scalar = .true.)
  aco2_file          =  fm_util_get_string ('aco2_file', scalar = .true.)
  aco2_name          =  fm_util_get_string ('aco2_name', scalar = .true.)
  seaicefract_file   =  fm_util_get_string ('seaicefract_file', scalar = .true.)
  seaicefract_name   =  fm_util_get_string ('seaicefract_name', scalar = .true.)
  dust_file   =  fm_util_get_string ('dust_file', scalar = .true.)
  dust_name   =  fm_util_get_string ('dust_name', scalar = .true.)

  qbio_model   =  fm_util_get_string ('qbio_model', scalar = .true.)
  s_npp   =  fm_util_get_real ('s_npp', scalar = .true.)
  bio_version   =  fm_util_get_integer ('bio_version', scalar = .true.)
  ! rjm: Tracer to use
  zero_floor = fm_util_get_logical ('zero_floor', scalar = .true.)
  sw_thru_ice = fm_util_get_logical ('sw_thru_ice', scalar = .true.)
  gasx_from_file = fm_util_get_logical ('gasx_from_file', scalar = .true.)
  ice_file4gasx = fm_util_get_logical ('ice_file4gasx', scalar = .true.)
  use_access_co2 = fm_util_get_logical ('use_access_co2', scalar = .true.)

  id_dic   =   fm_util_get_integer ('id_dic', scalar = .true.)
  id_adic  =   fm_util_get_integer ('id_adic', scalar = .true.)
  id_alk   =   fm_util_get_integer ('id_alk', scalar = .true.)
  id_po4   =   fm_util_get_integer ('id_po4', scalar = .true.)
  id_o2    =   fm_util_get_integer ('id_o2', scalar = .true.)
  id_no3   =   fm_util_get_integer ('id_no3', scalar = .true.)
  id_zoo   =   fm_util_get_integer ('id_zoo', scalar = .true.)
  id_phy   =   fm_util_get_integer ('id_phy', scalar = .true.)
  id_det   =   fm_util_get_integer ('id_det', scalar = .true.)
  id_caco3 =   fm_util_get_integer ('id_caco3', scalar = .true.)
  id_fe    =   fm_util_get_integer ('id_fe', scalar = .true.)


call fm_util_end_namelist(package_name, '*global*', caller = caller_str, check = .true.)


sum_ntr = min(1,id_dic)+min(1,id_adic)+min(1,id_po4)+min(1,id_alk) &
   +min(1,id_o2)+min(1,id_no3)+min(1,id_phy)+min(1,id_zoo)+min(1,id_det) &
   +min(1,id_caco3)+min(1,id_fe)
if (mpp_pe() == mpp_root_pe() ) print*,'csiro_bgc_init: Number bgc tracers = ',sum_ntr


!-----------------------------------------------------------------------
!       Set up the prognostic tracers.
!-----------------------------------------------------------------------

! RASF: Use sensible names for tracers
! For default case names will be simply adic, o2 etc
! If we have multiple instances the names will take the form
! adic_instancename, o2_instancename
! Different input files etc can be set in the field_table like for temp, salt

do n = 1, instances  !{

  biotic(n)%ntr_bgc = min(1,id_dic)+min(1,id_adic)+min(1,id_po4)+min(1,id_alk) &
     +min(1,id_o2)+min(1,id_no3)+min(1,id_phy)+min(1,id_zoo)+min(1,id_det) &
     +min(1,id_caco3)+min(1,id_fe)
  if (mpp_pe() == mpp_root_pe() ) print*,'Number bgc tracers = ',biotic(n)%ntr_bgc
      

  name = biotic(n)%name
  if (name(1:1) .eq. '_') then  !{
    suffix = ''
    long_suffix = ''
  else  !}{
    suffix = '_' // name
    long_suffix = ' (' // trim(name) // ')'
  endif  !}

  ntr_bgc=biotic(n)%ntr_bgc

 do nn=1,ntr_bgc
    if ( nn == id_no3 ) then
          bgc_trc='no3'
          min_range=-1e-5
          max_range=100.0
    else if ( nn ==  id_phy ) then
          bgc_trc='phy'
          min_range=-1e-7
          max_range=10.0
    else if (nn == id_o2 ) then
          bgc_trc='o2'
          min_range=-1e-7
          max_range=10.0
    else if (nn == id_zoo ) then
          bgc_trc='zoo'
          min_range=-1e-7
          max_range=10.0
    else if (nn == id_det ) then
          bgc_trc='det'
          min_range=0.0
          max_range=10.0
    else if (nn == id_caco3 ) then
          bgc_trc='caco3'
          min_range=-1e-5
          max_range=10.0
    else if (nn == id_dic ) then
          bgc_trc='dic'
          min_range=0.0
          max_range=3000.0
    else if (nn == id_alk ) then
          bgc_trc='alk'
          min_range=0.0
          max_range=3000.0
    else if (nn == id_adic ) then
          bgc_trc='adic'
          min_range=-1e-5
          max_range=3000.0
    else if (nn == id_fe ) then
          bgc_trc='fe'
          min_range=-0.0001
          max_range=10.0
    else if (nn == id_po4 ) then
          bgc_trc='po4'
          min_range=0.0
          max_range=100.0
    else 
          bgc_trc(1:6)='dummy'
          write(bgc_trc(7:8),'(i2.2)') nn
          min_range=0.0
          max_range=100.0
    endif 
          
    
    biotic(n)%ind_bgc(nn) = otpm_set_prog_tracer(trim(bgc_trc) // trim(suffix),     &
       package_name,                                                  &
       longname = trim(bgc_trc) // trim(long_suffix),                      &
       units = 'mmol/m^3', flux_units = 'mmol/m^2/s',                 &
       caller = trim(mod_name)//'('//trim(sub_name)//')',              &
       min_range=min_range,max_range=max_range)
 enddo  !} nn
enddo  !} n

!-----------------------------------------------------------------------
!       Set up the instance namelists
!-----------------------------------------------------------------------


do n = 1, instances  !{

!       create the instance namelist

  call fm_util_start_namelist(package_name, trim(biotic(n)%name) , caller = caller_str, no_overwrite = .true., &
       check = .true.)


  call fm_util_set_value('file_in', default_file_in)
  call fm_util_set_value('file_out', default_file_out)
  call fm_util_set_value('init', .false.)

  call fm_util_end_namelist(package_name, biotic(n)%name, check = .true., caller = caller_str)

enddo  !} n

!       Check for any errors in the number of fields in the namelists for this package

good_list => fm_util_get_string_array('/ocean_mod/GOOD/namelists/' // trim(package_name) // '/good_values',   &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
if (associated(good_list)) then  !{
  call fm_util_check_for_bad_fields('/ocean_mod/namelists/' // trim(package_name), good_list,       &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')
  deallocate(good_list)
else  !}{
  call mpp_error(FATAL,trim(error_header) // ' Empty "' // trim(package_name) // '" list')
endif  !}


! possible tracers in model
do n = 1, instances  !{

   ind_dic = biotic(n)%ind_bgc(id_dic)
   ind_adic = biotic(n)%ind_bgc(id_adic)
   ind_alk = biotic(n)%ind_bgc(id_alk)
   if(id_po4 .ne. 0 ) ind_po4 = biotic(n)%ind_bgc(id_po4)
   ind_o2  = biotic(n)%ind_bgc(id_o2)

   ind_no3  = biotic(n)%ind_bgc(id_no3)

   ind_zoo  = biotic(n)%ind_bgc(id_zoo)
   ind_phy  = biotic(n)%ind_bgc(id_phy)
   ind_det  = biotic(n)%ind_bgc(id_det)

   ind_caco3= biotic(n)%ind_bgc(id_caco3)
   if(id_fe .ne. 0 ) ind_fe= biotic(n)%ind_bgc(id_fe)

enddo  !} n

! Write SVN version numbers to both the logfile and the standard output
! mac, mar12.  
call write_version_number(version, tagname)

if (mpp_pe() == mpp_root_pe() ) then
 print*
 print*,"Repo. details of csiro_bgc compiled into executable"
 print*,"git:/mom_mac/src/mom5csiro_bgc.F90"
 print*,"mac, sep16."
 print*
endif

id_clock_csiro_obgc = mpp_clock_id('(CSIRO ocean biogeochemistry)',grain=CLOCK_ROUTINE)

return

end subroutine csiro_bgc_init  !}
! </SUBROUTINE> NAME="csiro_bgc_init"


!#######################################################################
! <SUBROUTINE NAME="csiro_bgc_source">
!
! <DESCRIPTION>
!     compute the source terms for the BIOTICs, including boundary
!     conditions (not done in setvbc, to minimize number
!     of hooks required in MOM base code)
! </DESCRIPTION>
!

subroutine csiro_bgc_source(isc, iec, jsc, jec, isd, ied, jsd, jed, T_prog, grid, time, dtts, Thickness, Dens, swflx, sw_frac_zt)  !{

use field_manager_mod,        only: fm_get_index

!-----------------------------------------------------------------------
!     arguments
!-----------------------------------------------------------------------
!

integer, intent(in)                                             :: isc, iec
integer, intent(in)                                             :: jsc, jec
integer, intent(in)                                             :: isd, ied
integer, intent(in)                                             :: jsd, jed
type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time
real, intent(in)                                                :: dtts
type(ocean_thickness_type), intent(in)                          :: Thickness
type(ocean_density_type), intent(in)                            :: Dens
real, intent(in), dimension(isd:ied,jsd:jed)                    :: swflx        ! short wave radiation flux (W/m^2)
real, intent(in), dimension(isd:,jsd:,:)                        :: sw_frac_zt        ! fraction of short wave radiation flux (none)


!-----------------------------------------------------------------------
!     local definitions
!-----------------------------------------------------------------------

character(len=64), parameter    :: sub_name = 'csiro_bgc_source'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer :: i
integer :: j
integer :: k
integer :: n
logical :: used
integer :: day
integer :: month
integer :: year
integer :: hour
integer :: minute
integer :: second
integer :: indtemp

integer :: nn, ntr_bgc

! include "bio_v1.par"

real    :: total_trc
!
! =====================================================================
!     begin executable code
! =====================================================================

!       get the model month

call mpp_clock_begin(id_clock_csiro_obgc)

call get_date(time%model_time, year, month, day,                &
              hour, minute, second)

!-----------------------------------------------------------------------
!     calculate the source terms for BIOTICs
!-----------------------------------------------------------------------


 select case(bio_version)
case(0)
! call bio_v0a(Thickness)
!include "bio_v0.f90"

case(1)
! call bio_v1a(Thickness)
!include "bio_v1.f90"

case(2)
!include "bio_v2.f90"

case(3)
call bio_v3(isc, iec, jsc, jec, isd, ied, jsd, jed, T_prog, grid, time, dtts, Thickness, Dens, swflx, sw_frac_zt)

case default
if (mpp_pe() == mpp_root_pe() )print*,'rjm do no bio version'

end select

!-----------------------------------------------------------------------
!       Save variables for diagnostics
!-----------------------------------------------------------------------
if (id_pco2 .gt. 0) then
  used = send_data(id_pco2, biotic(1)%pco2surf(isc:iec,jsc:jec),            &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
endif
if (id_paco2 .gt. 0) then
  used = send_data(id_paco2, biotic(1)%paco2surf(isc:iec,jsc:jec),            &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
endif
if (id_co2_sat .gt. 0) then
  used = send_data(id_co2_sat, biotic(1)%csat_csurf(isc:iec,jsc:jec),   &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
endif
if (id_aco2_sat .gt. 0) then
  used = send_data(id_aco2_sat, biotic(1)%csat_acsurf(isc:iec,jsc:jec),   &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
endif

if (id_sc_o2 .gt. 0) then
  used = send_data(id_sc_o2, sc_o2(isc:iec,jsc:jec),            &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
endif
if (id_o2_sat .gt. 0) then
  used = send_data(id_o2_sat, o2_saturation(isc:iec,jsc:jec),   &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
endif
if (id_kw_o2 .gt. 0) then
  used = send_data(id_kw_o2, kw_o2(isc:iec,jsc:jec),            &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
endif

! Gross production of phytoplankton

if (id_pprod_gross .gt. 0) then
  used = send_data(id_pprod_gross, pprod_gross(isc:iec,jsc:jec,:),          &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,:))
endif

if (id_pprod_gross_2d .gt. 0) then
  pprod_gross_2d(:,:)=0.0
  do k=1,grid%nk
     do j=jsc,jec
        do i=isc,iec
           pprod_gross_2d(i,j)=pprod_gross_2d(i,j) + pprod_gross(i,j,k)*Thickness%dzt(i,j,k)
        enddo
     enddo
  enddo
  used = send_data(id_pprod_gross_2d, pprod_gross_2d(isc:iec,jsc:jec),          &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
endif

! Gross production of zooplankton

if (id_zprod_gross .gt. 0) then
  used = send_data(id_zprod_gross, zprod_gross(isc:iec,jsc:jec,:),          &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,:))
endif

! growth limit of phytoplankton for light.

if (id_light_limit .gt. 0) then
  used = send_data(id_light_limit, light_limit(isc:iec,jsc:jec),          &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
endif

do n = 1, instances  !{

 ntr_bgc=biotic(n)%ntr_bgc
 do nn=1,ntr_bgc

! save the tracer surface fluxes
  if (biotic(n)%id_bgc_stf(nn) .gt. 0) then
    used = send_data(biotic(n)%id_bgc_stf(nn),                        &
         t_prog(biotic(n)%ind_bgc(nn))%stf(isc:iec,jsc:jec)/rho0,                    &
         time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
  endif
! save the tracer sources
  if (biotic(n)%id_bgc_src(nn) .gt. 0) then
    used = send_data(biotic(n)%id_bgc_src(nn),                        &
         t_prog(biotic(n)%ind_bgc(nn))%th_tendency(isc:iec,jsc:jec,:)/     &
         Thickness%rho_dzt(isc:iec,jsc:jec,:,time%tau),               &
         time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,:))
  endif
 enddo  !} nn
 
 ! rate of deposition of sinking tracers to sediment
 if (id_caco3_sed_depst .gt. 0) then
    used = send_data(id_caco3_sed_depst, biotic(n)%caco3_sed_depst(isc:iec,jsc:jec),          &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
 endif
 if (id_det_sed_depst .gt. 0) then
    used = send_data(id_det_sed_depst, biotic(n)%det_sed_depst(isc:iec,jsc:jec),          &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
 endif
 
 
enddo  !} n


call mpp_clock_end(id_clock_csiro_obgc)

return
end subroutine  csiro_bgc_source  !}
! </SUBROUTINE> NAME="csiro_bgc_source"


!#######################################################################
! <SUBROUTINE NAME="csiro_bgc_start">
!
! <DESCRIPTION>
! Initialize variables, read in namelists, calculate constants
! for a given run and allocate diagnostic arrays
! </DESCRIPTION>
!

subroutine csiro_bgc_start (time, domain, grid) !{

use time_manager_mod, only: days_in_year, days_in_month,        &
     get_date, set_date
use time_interp_external_mod, only: init_external_field
use diag_manager_mod, only: register_diag_field, diag_axis_init
use fms_mod, only : read_data

!
!-----------------------------------------------------------------------
!     arguments
!-----------------------------------------------------------------------
!

type(ocean_time_type), intent(in)                               :: Time
type(ocean_domain_type), intent(in)                             :: Domain
type(ocean_grid_type), intent(in)                               :: Grid

!
!-----------------------------------------------------------------------
!     local definitions
!-----------------------------------------------------------------------

character(len=64), parameter    :: sub_name = 'csiro_bgc_start'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

character(len=fm_string_len)            :: file_in
character(len=fm_string_len)            :: file_out
integer                                 :: index
logical                                 :: init
integer                                 :: check
integer                                 :: m, n
integer                                 :: second
integer                                 :: minute
integer                                 :: hour
integer                                 :: day
integer                                 :: month
integer                                 :: year
character(len=fm_field_name_len)        :: name
real                                    :: days_in_this_year
integer                                 :: num_days
character(len=fm_field_name_len+1)      :: str
integer, dimension(:)                   :: tracer_axes_1(3)
integer                                 :: id_zt_1
character(len=256)                      :: caller_str

integer :: nn, ntr_bgc
character(len=5)        :: bgc_stf='stf00'
character(len=5)        :: bgc_btf='btf00'
character(len=5)        :: bgc_src='src00'
character(len=64)       :: name1, name2, name3, name4 


! =====================================================================
!       begin of executable code
! =====================================================================

write(stdout(),*) 
write(stdout(),*) trim(note_header),                     &
                  'Starting ', trim(package_name), ' module'

!-----------------------------------------------------------------------
!     dynamically allocate the global BIOTIC arrays
!-----------------------------------------------------------------------

call allocate_arrays(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Domain%isd, Domain%ied, Domain%jsd, Domain%jed, grid%nk) 

      
!-----------------------------------------------------------------------
!       Open up the files for boundary conditions
!-----------------------------------------------------------------------

atmpress_id = init_external_field(atmpress_file,                &
                                  atmpress_name,                &
                                  domain = Domain%domain2d)
if (atmpress_id .eq. 0) then  !{
  call mpp_error(FATAL, trim(error_header) //                   &
       'Could not open atmpress file: ' //                      &
       trim(atmpress_file))
endif  !}

pistonveloc_id = init_external_field(pistonveloc_file,          &
                                     pistonveloc_name,          &
                                     domain = Domain%domain2d)
if (pistonveloc_id .eq. 0) then  !{
  call mpp_error(FATAL, trim(error_header) //                   &
       'Could not open pistonveloc file: ' //                   &
       trim(pistonveloc_file))
endif  !}

!RASF I think the ifdafs are redundant
if (id_adic .ne. 0 .and. .not. use_access_co2) then
 aco2_id = init_external_field(aco2_file,                    &
                                      aco2_name,              &
                                      domain = Domain%domain2d)
 if (aco2_id .eq. 0) then  !{
   call mpp_error(FATAL, trim(error_header) //                   &
        'Could not open aco2 file: ' //                        &
        trim(aco2_file))
 endif  !}
endif

seaicefract_id = init_external_field(seaicefract_file,          &
                                     seaicefract_name,          &
                                     domain = Domain%domain2d)
if (seaicefract_id .eq. 0) then  !{
  call mpp_error(FATAL, trim(error_header) //                   &
       'Could not open seaicefract file: ' //                   &
       trim(seaicefract_file))
endif  !}

dust_id = init_external_field(dust_file,          &
                                     dust_name,          &
                                     domain = Domain%domain2d)
if (dust_id .eq. 0) then  !{
  call mpp_error(FATAL, trim(error_header) //                   &
       'Could not open dust file: ' //                   &
       trim(dust_file))
endif  !}


alphabio_id = init_external_field("INPUT/bgc_param.nc",          &
        "alphabio", domain = Domain%domain2d)
       
if (alphabio_id .eq. 0) then  !{
  call mpp_error(FATAL, trim(error_header) //                   &
       'Could not open bgc_param.nc file' )
endif  !}

parbio_id = init_external_field("INPUT/bgc_param.nc",          &
        "parbio", domain = Domain%domain2d)
kwbio_id = init_external_field("INPUT/bgc_param.nc",          &
        "kwbio", domain = Domain%domain2d)
kcbio_id = init_external_field("INPUT/bgc_param.nc",          &
        "kcbio", domain = Domain%domain2d)
abio_id = init_external_field("INPUT/bgc_param.nc",          &
        "abio", domain = Domain%domain2d)
bbio_id = init_external_field("INPUT/bgc_param.nc",          &
        "bbio", domain = Domain%domain2d)
cbio_id = init_external_field("INPUT/bgc_param.nc",          &
        "cbio", domain = Domain%domain2d)
k1bio_id = init_external_field("INPUT/bgc_param.nc",          &
        "k1bio", domain = Domain%domain2d)
muepbio_id = init_external_field("INPUT/bgc_param.nc",          &
        "muepbio", domain = Domain%domain2d)
muepsbio_id = init_external_field("INPUT/bgc_param.nc",          &
        "muepsbio", domain = Domain%domain2d)
gam1bio_id = init_external_field("INPUT/bgc_param.nc",          &
        "gam1bio", domain = Domain%domain2d)
gbio_id = init_external_field("INPUT/bgc_param.nc",          &
        "gbio", domain = Domain%domain2d)
epsbio_id = init_external_field("INPUT/bgc_param.nc",          &
        "epsbio", domain = Domain%domain2d)
muezbio_id = init_external_field("INPUT/bgc_param.nc",          &
        "muezbio", domain = Domain%domain2d)
gam2bio_id = init_external_field("INPUT/bgc_param.nc",          &
        "gam2bio", domain = Domain%domain2d)
muedbio_id = init_external_field("INPUT/bgc_param.nc",          &
        "muedbio", domain = Domain%domain2d)
muecaco3_id = init_external_field("INPUT/bgc_param.nc",          &
        "muecaco3", domain = Domain%domain2d)
muedbio_sed_id = init_external_field("INPUT/bgc_param.nc",          &
        "muedbio_sed", domain = Domain%domain2d)
muecaco3_sed_id = init_external_field("INPUT/bgc_param.nc",          &
        "muecaco3_sed", domain = Domain%domain2d)
wdetbio_id = init_external_field("INPUT/bgc_param.nc",          &
        "wdetbio", domain = Domain%domain2d)
wcaco3_id = init_external_field("INPUT/bgc_param.nc",          &
        "wcaco3", domain = Domain%domain2d)
nat_co2_id = init_external_field("INPUT/bgc_param.nc",          &
        "nat_co2", domain = Domain%domain2d)
tscav_fe_id = init_external_field("INPUT/bgc_param.nc",          &
        "tscav_fe", domain = Domain%domain2d)
fe_bkgnd_id = init_external_field("INPUT/bgc_param.nc",          &
        "fe_bkgnd", domain = Domain%domain2d)
f_inorg_id = init_external_field("INPUT/bgc_param.nc",          &
        "f_inorg", domain = Domain%domain2d)

! ---------------------------------
!
! Read extra restart field(s)
!
! ---------------------------------

do n = 1, instances !{
 id_restart(1) = register_restart_field(sed_restart, "csiro_bgc_sediment.res.nc", "caco3_sediment", biotic(n)%caco3_sediment(:,:), domain=Domain%domain2d)
 id_restart(2) = register_restart_field(sed_restart, "csiro_bgc_sediment.res.nc", "det_sediment", biotic(n)%det_sediment(:,:), domain=Domain%domain2d)
enddo !} n

call restore_state(sed_restart)


!-----------------------------------------------------------------------
!     do some calendar calculation for the next section,
!      calculate the number of days in this year as well as
!      those that have already passed
!-----------------------------------------------------------------------

call get_date(time%model_time,                                  &
              year, month, day, hour, minute, second)
num_days = days_in_year(time%model_time)
days_in_this_year = 0.0
do m = 1, month - 1
  days_in_this_year = days_in_this_year +                       &
                     days_in_month(set_date(year, m, 1))
enddo
days_in_this_year = days_in_this_year + day - 1 + hour/24.0 +   &
                   minute/1440.0 + second/86400.0

!-----------------------------------------------------------------------
!       read in additional information for a restart
!-----------------------------------------------------------------------

write(stdout(),*)

!-----------------------------------------------------------------------
!
!       initialize some arrays which are held constant for this
!       simulation
!
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!       register the fields
!-----------------------------------------------------------------------
id_pco2 = register_diag_field('ocean_model',                   &
     'pco2', grid%tracer_axes(1:2),                            &
     Time%model_time, 'pCO2', ' ',               &
     missing_value = -1.0e+10)
id_paco2 = register_diag_field('ocean_model',                   &
     'paco2', grid%tracer_axes(1:2),                            &
     Time%model_time, 'pCO2 inc. anthropogenic', ' ',               &
     missing_value = -1.0e+10)
id_co2_sat = register_diag_field('ocean_model',                  &
     'co2_saturation', grid%tracer_axes(1:2),                    &
     Time%model_time, 'CO2 saturation', 'mmol/m^3',            &
     missing_value = -1.0e+10)
id_aco2_sat = register_diag_field('ocean_model',                  &
     'aco2_saturation', grid%tracer_axes(1:2),                    &
     Time%model_time, 'CO2 saturation inc. anthropogenic', 'mmol/m^3',            &
     missing_value = -1.0e+10)

id_sc_o2 = register_diag_field('ocean_model',                   &
     'sc_o2', grid%tracer_axes(1:2),                            &
     Time%model_time, 'Schmidt number - O2', ' ',               &
     missing_value = -1.0e+10)

id_o2_sat = register_diag_field('ocean_model',                  &
     'o2_saturation', grid%tracer_axes(1:2),                    &
     Time%model_time, 'O2 saturation', 'mmolO2/m^3',            &
     missing_value = -1.0e+10)

id_kw_o2 = register_diag_field('ocean_model',                   &
     'kw_o2', grid%tracer_axes(1:2),                            &
     Time%model_time, 'Piston velocity - O2', ' ',              &
     missing_value = -1.0e+10)

id_light_limit = register_diag_field('ocean_model','light_limit', &
     grid%tracer_axes(1:2),Time%model_time, 'Integrated light limitation of phytoplankton growth', &
     ' ',missing_value = -1.0e+10)

id_pprod_gross = register_diag_field('ocean_model','pprod_gross', &
     grid%tracer_axes(1:3),Time%model_time, 'Gross PHY production', &
     'mmolN/m^3/s',missing_value = -1.0e+10)

id_pprod_gross_2d = register_diag_field('ocean_model','pprod_gross_2d', &
     grid%tracer_axes(1:2),Time%model_time, 'Vertically integrated Gross PHY production', &
     'mmolN/m^2/s',missing_value = -1.0e+10)

id_zprod_gross = register_diag_field('ocean_model','zprod_gross', &
     grid%tracer_axes(1:3),Time%model_time, 'Gross ZOO production', &
     'mmolN/m^3/s',missing_value = -1.0e+10)

id_caco3_sediment = register_diag_field('ocean_model','caco3_sediment', &
     grid%tracer_axes(1:2),Time%model_time, 'Accumulated CaCO3 in sediment at base of water column', &
     'mmolN/m^2',missing_value = -1.0e+10)

id_det_sediment = register_diag_field('ocean_model','det_sediment', &
     grid%tracer_axes(1:2),Time%model_time, 'Accumulated DET in sediment at base of water column', &
     'mmolN/m^2',missing_value = -1.0e+10)

id_caco3_sed_remin = register_diag_field('ocean_model','caco3_sed_remin', &
     grid%tracer_axes(1:2),Time%model_time, 'Rate of remineralisation of CaCO3 in accumulated sediment', &
     'mmolN/m^2',missing_value = -1.0e+10)

id_det_sed_remin = register_diag_field('ocean_model','det_sed_remin', &
     grid%tracer_axes(1:2),Time%model_time, 'Rate of remineralisation of DET in accumulated sediment', &
     'mmolN/m^2',missing_value = -1.0e+10)

id_caco3_sed_depst = register_diag_field('ocean_model','caco3_sed_depst', &
     grid%tracer_axes(1:2),Time%model_time, 'Rate of deposition of CaCO3 to sediment at base of water column', &
     'mmolN/m^2',missing_value = -1.0e+10)

id_det_sed_depst = register_diag_field('ocean_model','det_sed_depst', &
     grid%tracer_axes(1:2),Time%model_time, 'Rate of deposition of DET to sediment at base of water column', &
     'mmolN/m^2',missing_value = -1.0e+10)

id_total_co2_flux = register_diag_field('ocean_model','total_co2_flux', &
     Time%model_time, 'Total surface flux of inorganic C (natural) into ocean', &
     'Pg/yr',missing_value = -1.0e+30)

id_total_aco2_flux = register_diag_field('ocean_model','total_aco2_flux', &
     Time%model_time, 'Total surface flux of inorganic C (natural + anthropogenic) into ocean', &
     'Pg/yr',missing_value = -1.0e+30)

do n = 1, instances  !{

  if (instances .eq. 1) then  !{
    str = ' '
  else  !}{
    str = '_' // biotic(n)%name
  endif  !}

!  use generic definition for 
! surface tracer fluxes -stf1, stf2
! virtual tracer flux - vstf1
! sources - src1
 ntr_bgc=biotic(n)%ntr_bgc

 do nn=1,ntr_bgc
  if (nn .ge. 10) then
   write(bgc_stf(4:5),'(i2)') nn
   write(bgc_src(4:5),'(i2)') nn
   write(bgc_btf(4:5),'(i2)') nn
  else
    write(bgc_stf(4:4),'(i1)') 0
    write(bgc_src(4:4),'(i1)') 0
    write(bgc_btf(4:4),'(i1)') 0
    write(bgc_stf(5:5),'(i1)') nn
    write(bgc_src(5:5),'(i1)') nn
    write(bgc_btf(5:5),'(i1)') nn
  endif

! default field names...
  name1 = bgc_stf // ' flux into ocean'
  name2 = bgc_stf // ' virtual flux into ocean'
  name3 = bgc_src // ' source term'
  name4 = bgc_btf // ' flux into sediment'
! specified field names
  if (nn .eq. id_no3) then 
   name1 = 'Flux into ocean - nitrate'
   name2 = 'Virtual flux into ocean - nitrate'
   name3 = 'Source term - nitrate'
   name4 = 'Flux into sediment - nitrate'
  endif
  if (nn .eq. id_phy) then 
   name1 = 'Flux into ocean - phytoplankton'
   name2 = 'Virtual flux into ocean - phytoplankton'
   name3 = 'Source term - phytoplankton'
   name4 = 'Flux into sediment - phytoplankton'
  endif
  if (nn .eq. id_zoo) then 
   name1 = 'Flux into ocean - zooplankton'
   name2 = 'Virtual flux into ocean - zooplankton'
   name3 = 'Source term - zooplankton'
   name4 = 'Flux into sediment - zooplankton'
  endif
  if (nn .eq. id_det) then 
   name1 = 'Flux into ocean - detritus'
   name2 = 'Virtual flux into ocean - detritus'
   name3 = 'Source term - detritus'
   name4 = 'Flux into sediment - detritus'
  endif
  if (nn .eq. id_o2) then 
   name1 = 'Flux into ocean - oxygen'
   name2 = 'Virtual flux into ocean - oxygen'
   name3 = 'Source term - oxygen'
   name4 = 'Flux into sediment - oxygen'
  endif
  if (nn .eq. id_po4) then 
   name1 = 'Flux into ocean - phosphate'
   name2 = 'Virtual flux into ocean - phosphate'
   name3 = 'Source term - phosphate'
   name4 = 'Flux into sediment - phosphate'
  endif
  if (nn .eq. id_dic) then 
   name1 = 'Flux into ocean - DIC, PI'
   name2 = 'Virtual flux into ocean - DIC, PI'
   name3 = 'Source term - DIC, PI'
   name4 = 'Flux into sediment - DIC, PI'
  endif
  if (nn .eq. id_adic) then 
   name1 = 'Flux into ocean - DIC, inc. anth.'
   name2 = 'Virtual flux into ocean - DIC, inc. anth.'
   name3 = 'Source term - DIC, inc. anth.'
   name4 = 'Flux into sediment - DIC, inc. anth.'
  endif
  if (nn .eq. id_alk) then 
   name1 = 'Flux into ocean - alkalinity'
   name2 = 'Virtual flux into ocean - alkalinity'
   name3 = 'Source term - alkalinity'
   name4 = 'Flux into sediment - alkalinity'
  endif
  if (nn .eq. id_caco3) then 
   name1 = 'Flux into ocean - calcium carbonate'
   name2 = 'Virtual flux into ocean - calcium carbonate'
   name3 = 'Source term - calcium carbonate'
   name4 = 'Flux into sediment - calcium carbonate'
  endif
  if (nn .eq. id_fe) then
   name1 = 'Flux into ocean - iron'
   name2 = 'Virtual flux into ocean - iron'
   name3 = 'Source term - iron'
   name4 = 'Flux into sediment - iron'
  endif
  if (mpp_pe() == mpp_root_pe() )print*,'rjm bio',bgc_stf,'v'//bgc_stf

  biotic(n)%id_bgc_stf(nn) = register_diag_field('ocean_model',       &
       bgc_stf//str, grid%tracer_axes(1:2),                     &
       Time%model_time, name1, 'mmol/m^2/s',    &
!       Time%model_time, bgc_stf//'flux into ocean', 'mmol/m^2/s',    &
       missing_value = -1.0e+10)

  biotic(n)%id_bgc_vstf(nn) = register_diag_field('ocean_model',       &
       'v'//bgc_stf//str, grid%tracer_axes(1:2),                     &
       Time%model_time, name2, 'mmol/m^3/s',    &
!       Time%model_time, bgc_stf//'virtual flux into ocean', 'mmol/m^3/s',    &
       missing_value = -1.0e+10)

  biotic(n)%id_bgc_src(nn) = register_diag_field('ocean_model',       &
       bgc_src//str, grid%tracer_axes(1:3),                     &
       Time%model_time, name3, 'mmolN/m^3/s',    &
!       Time%model_time, bgc_src, 'mmolN/m^3/s',    &
       missing_value = -1.0e+10)

  biotic(n)%id_bgc_btf(nn) = register_diag_field('ocean_model',       &
       bgc_btf//str, grid%tracer_axes(1:2),                     &
       Time%model_time, name4, 'mmol/m^2/s',    &
!       Time%model_time, bgc_btf//'flux into sediment', 'mmol/m^2/s',    &
       missing_value = -1.0e+10)

 enddo  !} nn

enddo  !} n

!-----------------------------------------------------------------------
!     give info
!-----------------------------------------------------------------------

do n = 1, instances  !{
 biotic(n)%sal_global=34.6
 if (id_dic.ne.0) biotic(n)%bgc_global(id_dic)=1966.
 if (id_adic.ne.0) biotic(n)%bgc_global(id_adic)=1966.
 if (id_alk.ne.0) biotic(n)%bgc_global(id_alk)=2303.
 if (id_no3.ne.0) biotic(n)%bgc_global(id_no3)=4.67
enddo
  
write(stdout(),*)
write(stdout(),*) trim(note_header), 'Tracer runs initialized'
write(stdout(),*)


return
end subroutine  csiro_bgc_start  !}
! </SUBROUTINE> NAME="csiro_bgc_start"


!#######################################################################
! <SUBROUTINE NAME="csiro_bgc_tracer">
!
! <DESCRIPTION>
!     Perform things that should be done in tracer, but are done here
! in order to minimize the number of hooks necessary in the MOM4 basecode
! </DESCRIPTION>
!

subroutine csiro_bgc_tracer (isc, iec, jsc, jec, t_prog, grid, time, dtts) !{

use mpp_mod, only : mpp_sum


type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time
integer, intent(in)                             :: isc, iec
integer, intent(in)                             :: jsc, jec
real, intent(in)                                :: dtts

!-----------------------------------------------------------------------
!     local definitions
!-----------------------------------------------------------------------

character(len=64), parameter    :: sub_name = 'csiro_bgc_tracer'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: warn_header =                                &
     '==>Warning from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer :: i
integer :: j
integer :: n
integer :: k
integer :: nn, ntr_bgc, ind_trc
real    :: total_trc
integer :: indsal
logical :: used


indsal = fm_get_index('/ocean_mod/prog_tracers/salt')

!-----------------------------------------------------------------------
!     accumulate global annual means
!-----------------------------------------------------------------------


do n = 1, instances  !{
!  use generic definition for bgc tracers -tracer1, tracer2
 ntr_bgc=biotic(n)%ntr_bgc

 ! Use zero_floor = .false. to skip this floor to BGC tracers and allow the time_tendency calculation to non-negative values bring any small negatives up.
 ! This then improves the 'mismatch' in diagnostic output.
 ! mac, aug11.
 if (zero_floor) then
  do nn=1,ntr_bgc


   do k = 1,grid%nk  !{
     do j = jsc, jec  !{
       do i = isc, iec  !{
        t_prog(biotic(n)%ind_bgc(nn))%field(i,j,k,time%taup1)= & 
        max(0.,t_prog(biotic(n)%ind_bgc(nn))%field(i,j,k,time%taup1) )
       enddo  !} i
     enddo  !} j
   enddo  !} k

  enddo !} nn 
 endif ! zero_floor

! comment out this sediment source of fe while testing equivalent code in csiro_bgc_bbc.  mac, nov12.  

! rjm bottom Fe fix
! mac aug10, only apply this fix when the water is <= 200 m deep.  
 if (id_fe.ne.0) then
    do j = jsc, jec  !{
      do i = isc, iec  !{
         if (grid%kmt(i,j) .gt. 0) then
            k = grid%kmt(i,j)
            if (grid%zw(k) .le. 200) &
               t_prog(biotic(n)%ind_bgc(id_fe))%field(i,j,k,time%taup1)= 0.999
         endif
      enddo  !} i
    enddo  !} j
 endif

! apply deposition and remineralisation rates to sediment tracers.  mac, nov12. 
 do j = jsc, jec  !{
   do i = isc, iec  !{
     if (grid%kmt(i,j) .gt. 0) then
       biotic(n)%det_sediment(i,j) = biotic(n)%det_sediment(i,j) + dtts* &
         ( biotic(n)%det_sed_depst(i,j) -   &
         biotic(n)%det_sed_remin(i,j) )
       biotic(n)%caco3_sediment(i,j) = biotic(n)%caco3_sediment(i,j) + dtts* &
         ( biotic(n)%caco3_sed_depst(i,j) -   &
         biotic(n)%caco3_sed_remin(i,j) )
     endif
   enddo  !} i
 enddo  !} j

 ! send sediment tracers to output. mac, nov12. 
 if (id_caco3_sediment .gt. 0) then
    used = send_data(id_caco3_sediment, biotic(n)%caco3_sediment(isc:iec,jsc:jec),          &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
 endif
 if (id_det_sediment .gt. 0) then
    used = send_data(id_det_sediment, biotic(n)%det_sediment(isc:iec,jsc:jec),          &
       time%model_time, rmask = grid%tmask(isc:iec,jsc:jec,1))
 endif

enddo  !} n

return
end subroutine  csiro_bgc_tracer  !}
! </SUBROUTINE> NAME="csiro_bgc_tracer"

include "bio_v3.inc" 

end module  csiro_bgc_mod  !}

module ocean_residency_meta_mod  !{
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies 
!</REVIEWER>
!
!<OVERVIEW>
! Ocean residency module
!</OVERVIEW>
!
!<DESCRIPTION>
!       This module contains the meta definitions, subroutines and functions
!       to use in the ocean residency package. These routines are used by all
!       of the ocean residency modules and need to be defined in a separate
!       module so that there are no circular references between the modules.
!
!       For an overview of the ocean residency modules, see ocean_residency.F90.
!
!</DESCRIPTION>
!
! $Id: ocean_residency_meta.F90,v 20.0 2013/12/14 00:17:08 fms Exp $
!

!
!       modules
!

use field_manager_mod, only: fm_string_len, fm_field_name_len
use fm_util_mod,       only: fm_util_default_caller
use mpp_mod,           only: stdout, mpp_error, FATAL

!
!       force all variables to be "typed"
!

implicit none

!
!       Set all variables to be private by default

private

!
!       Public routines
!

public  :: ocean_residency_get_instances
public  :: ocean_residency_set_region_geog
public  :: ocean_residency_set_region_2d
public  :: ocean_residency_set_region_3d

!
!       Private routines
!

!
!       Public parameters
!

real, public, parameter                         :: secs_in_year_r = 1.0 / (86400.0 * 365.25)
real, public, parameter                         :: sec_per_day = 86400.0

!
!       Private parameters
!

character(len=fm_field_name_len), parameter     :: package_name = 'ocean_residency_meta'
character(len=48), parameter                    :: mod_name = 'ocean_residency_meta_mod'
character(len=48), parameter                    :: diag_name = 'ocean_residency_meta'

!
!       Public types
!

type, public                                                    :: ocean_residency_instance_type
  character(len=fm_field_name_len)                              :: name = ' '
  integer                                                       :: tracer_index = 0
  logical                                                       :: some_restore = .false.
  logical                                                       :: some_fix = .false.
  integer                                                       :: num_regions = 1
  type(ocean_residency_region_type), dimension(:), pointer      :: region => NULL()
  real                                                          :: integrate_region_value = secs_in_year_r
  integer, dimension(:,:,:), pointer                            :: index => NULL()
  real, dimension(:,:,:), pointer                               :: mask => NULL()
  logical                                                       :: union = .true.
  integer                                                       :: id_restore_region = -1
  integer                                                       :: id_change = -1
  logical                                                       :: int_found = .false.
  character(len=128)                                            :: int_module_name = ' '
  real, dimension(:), pointer                                   :: int_params => NULL()
  logical, dimension(:), pointer                                :: int_flags => NULL()
  character(len=fm_string_len), dimension(:), pointer           :: int_strings => NULL()
end type ocean_residency_instance_type

type, public                                                    :: ocean_residency_region_type
  character(len=fm_field_name_len)                              :: name = ' '
  real, dimension(:,:,:), pointer                               :: mask => NULL()
  real                                                          :: restore = 0.0
  real                                                          :: restore_region_value = 0.0
  logical                                                       :: swap = .false.
  logical                                                       :: swap_module = .false.
  logical                                                       :: found = .false.
  real, dimension(:), pointer                                   :: east_bnd => NULL()
  real, dimension(:), pointer                                   :: north_bnd => NULL()
  real, dimension(:), pointer                                   :: south_bnd => NULL()
  real, dimension(:), pointer                                   :: west_bnd => NULL()
  real, dimension(:), pointer                                   :: top_bnd => NULL()
  real, dimension(:), pointer                                   :: bottom_bnd => NULL()
  integer                                                       :: num_geog_regions = 0
  integer                                                       :: id_restore_region = -1
  character(len=128)                                            :: module_name = ' '
  real, dimension(:), pointer                                   :: params => NULL()
  logical, dimension(:), pointer                                :: flags => NULL()
  character(len=fm_string_len), dimension(:), pointer           :: strings => NULL()
end type ocean_residency_region_type

!
!       Public variables
!

type(ocean_residency_instance_type), dimension(:), allocatable, save, public    :: instance
integer, save, public                                                           :: num_instances = 0

!
!       Private variables
!


!
!        Interface definitions for overloaded routines
!

contains


!#######################################################################
! <FUNCTION NAME="ocean_residency_get_instances">
!
! <DESCRIPTION>
!       Return an array of instances which have the given module_name
!       This is used by modules, such as the mixed layer module, to obtain
!       a list of instances which use that module. Then, the module
!       needs only to loop over those instance to perform its required tasks.
! </DESCRIPTION>
!

function ocean_residency_get_instances(module_name, integrand)            &
     result(array)  !{

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

character(len=*), intent(in)    :: module_name
logical, intent(in), optional   :: integrand

!
!-----------------------------------------------------------------------
!       Result
!-----------------------------------------------------------------------
!

type(ocean_residency_instance_type), dimension(:), pointer      :: array

!
!       local parameters
!

character(len=64), parameter    :: sub_name = 'ocean_residency_get_instances'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!-----------------------------------------------------------------------
!       local variables
!-----------------------------------------------------------------------
!

logical                                 :: found
integer                                 :: n
integer                                 :: ind
integer                                 :: nn
integer                                 :: num_elements
logical                                 :: do_integrand

if (module_name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' No module name given')
endif  !}

!
!       check whether we want to look at modules for defining the region
!       (integrand = f or not given) or whether we are looking to set
!       the field we're integrating over to something other than time
!       (integrand = t)
!

if (present(integrand)) then  !{
  do_integrand = integrand
else  !}{
  do_integrand = .false.
endif  !}

!
!       return the mask array pointer for tracer "tracer_index"
!

num_elements = 0
do n = 1, num_instances  !{
  if (do_integrand) then  !{
    if (module_name .eq. instance(n)%int_module_name) then
      num_elements = num_elements + 1
    endif
  else  !}{
    do nn = 1, instance(n)%num_regions  !{
      if (module_name .eq. instance(n)%region(nn)%module_name) then
        num_elements = num_elements + 1
        exit
      endif
    enddo  !} nn
  endif  !}
enddo  !} n

if (num_elements .eq. 0) then  !{

  nullify(array)

elseif (num_elements .lt. 0) then  !}{

  call mpp_error(FATAL, trim(error_header) // ' Should never get here for ' // trim(module_name))

else  !}{

  allocate( array(num_elements) )
  ind = 0
  do n = 1, num_instances  !{
    found = .false.
    if (do_integrand) then  !{
      if (module_name .eq. instance(n)%int_module_name) then
        found = .true.
        instance(n)%int_found = .true.
      endif
    else  !}{
      do nn = 1, instance(n)%num_regions  !{
        if (module_name .eq. instance(n)%region(nn)%module_name) then
          found = .true.
          instance(n)%region(nn)%found = .true.
        endif
      enddo  !} nn
    endif  !}
    if (found) then  !{
      ind = ind + 1
      allocate ( array(ind)%region(instance(n)%num_regions) )
      array(ind)%num_regions            =  instance(n)%num_regions
      array(ind)%region                 => instance(n)%region
      array(ind)%name                   =  instance(n)%name
      array(ind)%tracer_index           =  instance(n)%tracer_index
      array(ind)%integrate_region_value =  instance(n)%integrate_region_value
      array(ind)%index                  => instance(n)%index
      array(ind)%mask                   => instance(n)%mask
      array(ind)%union                  =  instance(n)%union
      array(ind)%id_change              =  instance(n)%id_change
      array(ind)%int_module_name        =  instance(n)%int_module_name
      array(ind)%int_params             => instance(n)%int_params
      array(ind)%int_flags              => instance(n)%int_flags
      array(ind)%int_strings            => instance(n)%int_strings
    endif  !}
  enddo  !} n

  if (num_elements .ne. ind) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Number of elements do not match for ' // trim(module_name))
  endif  !}

endif  !}

return

end function ocean_residency_get_instances  !}
! </FUNCTION> NAME="ocean_residency_get_instances"


!#######################################################################
! <SUBROUTINE NAME="ocean_residency_set_region_2d">
!
! <DESCRIPTION>
!       Given a 2-d field of depths, determine the grid cells which fall inside (above) and
!       outside of that range, then set the mask appropriately, as to whether
!       we are interested in those points inside (swap=false) or outside (swap=true) of the region.
!
!       Note: if the output array is not initialized, then it is assumed that it is already
!             filled with a region, and the resulting region will be the intersection of the
!             existing region and the newly specified region.
!
!       Arguments:
!
!         Input:
!
!                    isd:  low dimension of first index
!                    ied:  high dimension of first index
!                    jsd:  low dimension of second index
!                    jed:  high dimension of second index
!                     nk:  dimension of third index
!                control:  array of depths that specifies the region
!              depth_zwt:  depth of bottom of grid cell
!   restore_region_value:  if supplied, the value to assign to array in the user-specified
!                          regions (default: 0.0)
! integrate_region_value:  if supplied, the value to assign to array outside of the
!                          user-specified regions (default: secs_in_year_r)
!                   swap:  if supplied and true then change the invert the defined region (default: true)
!             initialize:  if supplied and true, then initialize the region to the integrate_region_value (default: false)
!                 caller:  if supplied, use for traceback of error messages (default: fm_default_caller)
!
!         Input/Output:
!                  array:  3-d array which will contain the restore_region- and integrate_region-
!                          values.
!
! </DESCRIPTION>
!

subroutine ocean_residency_set_region_2d(isd, ied, jsd, jed, nk, control, array, depth_zwt,     &
     restore_region_value, integrate_region_value, swap, initialize, caller)  !{

implicit none

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'ocean_residency_set_region_2d'

!
!       arguments
!

integer, intent(in)                             :: isd
integer, intent(in)                             :: ied
integer, intent(in)                             :: jsd
integer, intent(in)                             :: jed
integer, intent(in)                             :: nk
real, intent(in), dimension(isd:,jsd:)          :: control
real, dimension(isd:,jsd:,:), intent(inout)     :: array
real, dimension(isd:,jsd:,:), intent(in)        :: depth_zwt
real, intent(in), optional                      :: restore_region_value
real, intent(in), optional                      :: integrate_region_value
logical, intent(in), optional                   :: swap
logical, intent(in), optional                   :: initialize
character(len=*), intent(in), optional          :: caller

!
!       Local variables
!

character(len=256)      :: error_header
character(len=128)      :: caller_str
integer                 :: i
integer                 :: j
integer                 :: k
real                    :: restore_region_value_use
real                    :: integrate_region_value_use
logical                 :: swap_use
logical                 :: assume_restore_region

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
  
!
! check that the array is as long as depth dimension
!

if (size(array,3) .lt. nk) then  
  call mpp_error(FATAL, trim(error_header) // ' Dimension 3 of output array too small')
endif

!
!       set some default values in case they have not been set in the argument list
!

if (present(restore_region_value)) then  !{
  restore_region_value_use = restore_region_value
else  !}{
  restore_region_value_use = 0.0
endif  !}

if (present(integrate_region_value)) then  !{
  integrate_region_value_use = integrate_region_value
else  !}{
  integrate_region_value_use = secs_in_year_r
endif  !}

if (present(swap)) then  !{
  swap_use = swap
else  !}{
  swap_use = .false.
endif  !}

!
!       If initialize is true, then set all values to integrate_region_value,
!       otherwise, array values are assumed to be initialized with the appropriate
!       distribution of in- and out-region-values and the final value will be
!       the intersection between this value and that determined below (i.e., both values
!       must be "restore_region_value" to stay "restore_region_value", otherwise it becomes "integrate_region_value")
!       If we initialize, we need to set assume_restore_region to true so that when
!       calculating the region below, the intersection will have values in it.
!       However, we don't want to initialize to restore_region_value, or else the behavior
!       when no regions are found will be to have all locations restore_region.
!

if (present(initialize)) then  !{
  assume_restore_region = initialize
  if (initialize) then  !{
    do k = 1, nk  !{
      do j = jsd, jed  !{
        do i = isd, ied  !{
          array(i,j,k) = integrate_region_value_use
        enddo  !} i
      enddo  !} j
    enddo  !} k
  endif  !}
else  !}{
  assume_restore_region = .false.
endif  !}

do j = jsd, jed  !{
  do i = isd, ied  !{
    if (((control(i,j) .gt. 0.0) .eqv. (.not. swap_use)) .and.   &
        (assume_restore_region .or. array(i,j,1) .eq. restore_region_value_use)) then  !{
      array(i,j,1) = restore_region_value_use
    else  !}{
      array(i,j,1) = integrate_region_value_use
    endif  !}
  enddo  !} i
enddo  !} j
do k = 2, nk  !{
  do j = jsd, jed  !{
    do i = isd, ied  !{
      if (((control(i,j) .gt. depth_zwt(i,j,k-1)) .eqv. (.not. swap_use)) .and.   &
          (assume_restore_region .or. array(i,j,k) .eq. restore_region_value_use)) then  !{
        array(i,j,k) = restore_region_value_use
      else  !}{
        array(i,j,k) = integrate_region_value_use
      endif  !}
    enddo  !} i
  enddo  !} j
enddo  !} k

return

end subroutine  ocean_residency_set_region_2d  !}
! </SUBROUTINE> NAME="ocean_residency_set_region_2d"


!#######################################################################
! <SUBROUTINE NAME="ocean_residency_set_region_geog">
!
! <DESCRIPTION>
!       Set up an array covering the model domain with a user-specified
!       value, in user-specified regions. There are a given number of
!       3-d regions specified by the values south_bnd, north_bnd, west_bnd,
!       east_bnd, top_bnd and bottom_bnd.
!       The longitudes are for a cyclic domain, and if west_bnd and east_bnd
!       are on opposite sides of the cut, the correct thing will
!       be done. east_bnd is considered to be east of west_bnd, so if east_bnd is
!       less than west_bnd, then the region east of east_bnd to the cut will be
!       filled, and the region from the cut to west_bnd will be filled.
!
!       If the bottom bound is less than or equal to zero, then the top model box
!       will be chosen. If the top bound is greater than or equal to the maximum
!       model depth, then the bottom box will be chosed. Otherwise, if the grid
!       cell center depth falls between top bound and bottom bound, then those cells
!       shall be chosen.
!
!       For longitude and latitude, if the grid cell center lies within the
!       rectabgle defined by (west_bnd,south_bnd) and (east_bnd,north_bnd), then
!       the whole grid cell is inside the region.
!
!       Arrays of coordinates may be specified for irregular regions.
!       The final region is the union of the multiple sets
!       of coordinates. If swap is true, then the inverse of the defined
!       region will be set.
!
!       Note: if the output array is not initialized, then it is assumed that it is already
!             filled with a region, and the resulting region will be the intersection of the
!             existing region and the newly specified region.
!
!       Arguments:
!
!         Input:
!
!                    isd:  low dimension of first index
!                    ied:  high dimension of first index
!                    jsd:  low dimension of second index
!                    jed:  high dimension of second index
!                     nk:  dimension of third index
!                grid_xt:  array of coordinates in the x-direction (typically longitude)
!                grid_yt:  array of coordinates in the y-direction (typically latitude)
!              max_depth:  maximum depth of the model
!               depth_zt:  depth of center of grid cell
!              depth_zwt:  depth of bottom of grid cell
!       num_geog_regions:  number of user-specified regions which will be filled
!            west_bnd_in:  1-d array of western (starting) longitudes for the regions
!            east_bnd_in:  1-d array of eastern (ending) longitudes for the regions
!              south_bnd:  1-d array of southern (starting) latitudes for the regions
!              north_bnd:  1-d array of northern (ending) latitudes for the regions
!                top_bnd:  1-d array of southern (starting) depths for the regions
!             bottom_bnd:  1-d array of northern (ending) depths for the regions
!                             Note: if south_bnd >= north_bnd, then nothing is done
!                                   for that region
!                    kmt:  array of indices for bottom grid cells
!                   name:  character variable used in informative messages
!   restore_region_value:  if supplied, the value to assign to array in the user-specified
!                          regions (default: 0.0)
! integrate_region_value:  if supplied, the value to assign to array outside of the
!                          user-specified regions (default: secs_in_year_r)
!                   swap:  if supplied and true then change the invert the defined region (default: true)
!
!         Input/Output:
!                  array:  3-d array which will contain the restore_region- and integrate_region-
!                          values.
! </DESCRIPTION>
!
!

subroutine ocean_residency_set_region_geog(isd, ied, jsd, jed, nk, array,       &
                     grid_xt, grid_yt, max_depth, depth_zt, depth_zwt,          &
                     num_geog_regions,                                          &
                     west_bnd_in, east_bnd_in, south_bnd, north_bnd,            &
                     top_bnd, bottom_bnd, kmt, name,                            &
                     restore_region_value, integrate_region_value, swap,        &
                     initialize, caller)  !{

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

integer, intent(in)                             :: isd
integer, intent(in)                             :: ied
integer, intent(in)                             :: jsd
integer, intent(in)                             :: jed
integer, intent(in)                             :: nk
real, dimension(isd:,jsd:,:), intent(inout)     :: array
real, dimension(isd:,jsd:), intent(in)          :: grid_xt
real, dimension(isd:,jsd:), intent(in)          :: grid_yt
real, dimension(isd:,jsd:,:), intent(in)        :: depth_zt
real, dimension(isd:,jsd:,:), intent(in)        :: depth_zwt
real, intent(in)                                :: max_depth
integer, intent(in)                             :: num_geog_regions
real, dimension(:), intent(in)                  :: west_bnd_in
real, dimension(:), intent(in)                  :: east_bnd_in
real, dimension(:), intent(in)                  :: south_bnd
real, dimension(:), intent(in)                  :: north_bnd
real, dimension(:), intent(in)                  :: top_bnd
real, dimension(:), intent(in)                  :: bottom_bnd
integer, dimension(isd:,jsd:), intent(in)       :: kmt
real, intent(in), optional                      :: restore_region_value
real, intent(in), optional                      :: integrate_region_value
logical, intent(in), optional                   :: swap
character*(*), intent(in)                       :: name
logical, intent(in), optional                   :: initialize
character(len=*), intent(in), optional          :: caller

!
!       local parameters
!

character(len=64), parameter    :: sub_name = 'ocean_residency_set_region_geog'

!
!       local variables
!

integer                         :: i
integer                         :: j
integer                         :: k
integer                         :: n
real, dimension(:), allocatable :: west_bnd
real, dimension(:), allocatable :: east_bnd
character(len=256)              :: error_header
character(len=128)              :: caller_str
real                            :: restore_region_value_use
real                            :: integrate_region_value_use
logical                         :: swap_use
logical                         :: restore_region
logical                         :: assume_restore_region

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       set some default values in case they have not been set in the argument list
!

if (present(restore_region_value)) then  !{
  restore_region_value_use = restore_region_value
else  !}{
  restore_region_value_use = 0.0
endif  !}

if (present(integrate_region_value)) then  !{
  integrate_region_value_use = integrate_region_value
else  !}{
  integrate_region_value_use = secs_in_year_r
endif  !}

if (present(swap)) then  !{
  swap_use = swap
else  !}{
  swap_use = .false.
endif  !}

!
!       check whether any regions have been specified
!

if (num_geog_regions .le. 0) then  !{

!
!       no regions specified, return all points out of region
!       unless swap is true
!

  if (swap_use) then  !{

    do k = 1, nk  !{
      do j = jsd, jed  !{
        do i = isd, ied  !{
          array(i,j,k) = restore_region_value_use
        enddo  !} i
      enddo  !} j
    enddo  !} k
  
  else  !}{

    do k = 1, nk  !{
      do j = jsd, jed  !{
        do i = isd, ied  !{
          array(i,j,k) = integrate_region_value_use
        enddo  !} i
      enddo  !} j
    enddo  !} k
  
  endif  !}

else  !}{

!
!       regions are specified, check that all array large enough
!

  if (size(west_bnd_in) .lt. num_geog_regions) then  !{
    call mpp_error(FATAL, trim(error_header) // ' west_bnd_in array too small for ' // trim(name))
  elseif (size(east_bnd_in) .lt. num_geog_regions) then  !}{
    call mpp_error(FATAL, trim(error_header) // ' east_bnd_in array too small for ' // trim(name))
  elseif (size(north_bnd) .lt. num_geog_regions) then  !}{
    call mpp_error(FATAL, trim(error_header) // ' north_bnd array too small for ' // trim(name))
  elseif (size(south_bnd) .lt. num_geog_regions) then  !}{
    call mpp_error(FATAL, trim(error_header) // ' south_bnd array too small for ' // trim(name))
  elseif (size(top_bnd) .lt. num_geog_regions) then  !}{
    call mpp_error(FATAL, trim(error_header) // ' top_bnd array too small for ' // trim(name))
  elseif (size(bottom_bnd) .lt. num_geog_regions) then  !}{
    call mpp_error(FATAL, trim(error_header) // ' bottom_bnd array too small for ' // trim(name))
  endif  !}

!
! loop over the regions, checking for errors
!

  do n = 1, num_geog_regions  !{

    if (north_bnd(n) .lt. south_bnd(n)) then  !{

      call mpp_error(FATAL, trim(error_header) //       &
           ' North bound less than south bound for ' // trim(name))

    elseif (top_bnd(n) .gt. bottom_bnd(n)) then  !}{

      call mpp_error(FATAL, trim(error_header) //       &
           ' Top depth deeper than bottom depth for ' // trim(name))

    endif  !}

  enddo  !} n

!
!       Find all boxes where the center lies in the
!       3-d rectangular region
!

!
!       If initialize is true, then set all values to integrate_region_value,
!       otherwise, array values are assumed to be initialized with the appropriate
!       distribution of in- and out-region-values and the final value will be
!       the intersection between this value and that determined below (i.e., both values
!       must be "restore_region_value" to stay "restore_region_value", otherwise it becomes "integrate_region_value")
!       If we initialize, we need to set assume_restore_region to true so that when
!       calculating the region below, the intersection will have values in it.
!       However, we don't want to initialize to restore_region_value, or else the behavior
!       when no regions are found will be to have all locations restore_region.
!

  if (present(initialize)) then  !{
    assume_restore_region = initialize
    if (initialize) then  !{
      do k = 1, nk  !{
        do j = jsd, jed  !{
          do i = isd, ied  !{
            array(i,j,k) = integrate_region_value_use
          enddo  !} i
        enddo  !} j
      enddo  !} k
    endif  !}
  else  !}{
    assume_restore_region = .false.
  endif  !}

!
!       save the longitudes in case they need to be modified
!

  allocate( west_bnd(num_geog_regions) )
  allocate( east_bnd(num_geog_regions) )

  do n = 1, num_geog_regions  !{

    west_bnd(n) = west_bnd_in(n)
    east_bnd(n) = east_bnd_in(n)

!
!       make sure that the longitudes are in the range [0,360]
!

    do while (west_bnd(n) .gt. 360.0)  !{
      west_bnd(n) = west_bnd(n) - 360.0
    enddo  !}
    do while (west_bnd(n) .lt. 0.0)  !{
      west_bnd(n) = west_bnd(n) + 360.0
    enddo  !}
    do while (east_bnd(n) .gt. 360.0)  !{
      east_bnd(n) = east_bnd(n) - 360.0
    enddo  !}
    do while (east_bnd(n) .lt. 0.0)  !{
      east_bnd(n) = east_bnd(n) + 360.0
    enddo  !}

  enddo  !} n

  do k = 1, nk  !{
    do j = jsd, jed  !{
      do i = isd, ied  !{
        if (k .le. kmt(i,j)) then  !{
          restore_region = .false.
          do n = 1, num_geog_regions  !{
            if ((((top_bnd(n) .lt. depth_zt(i,j,k) .and.                        &
                   depth_zt(i,j,k) .le. bottom_bnd(n)) .or.                     &
                  (bottom_bnd(n) .le. 0.0 .and. k .eq. 1) .or.                  &
                  (top_bnd(n) .ge. max_depth .and. k .eq. kmt(i,j)) .or.        &
                  (top_bnd(n) .lt. 0.0 .and.                                    &
                   depth_zt(i,j,k) .ge.                                         &
                   depth_zwt(i,j,kmt(i,j)) + top_bnd(n))) .and.                 &
                 north_bnd(n) .gt. grid_yt(i,j) .and.                           &
                 grid_yt(i,j) .ge. south_bnd(n) .and.                           &
                 lon_between(grid_xt(i,j), west_bnd(n), east_bnd(n)))) then  !{
              restore_region = .true.
            endif  !}
          enddo  !} n
          restore_region = restore_region .eqv. (.not. swap_use)
          if ((assume_restore_region .or. array(i,j,k) .eq. restore_region_value_use) .and. restore_region) then  !{
            array(i,j,k) = restore_region_value_use
          else  !}{
            array(i,j,k) = integrate_region_value_use
          endif  !}
        endif  !}
      enddo  !} i
    enddo  !} j
  enddo  !} k

!
!       Clean up
!

  deallocate( west_bnd )
  deallocate( east_bnd )

endif  !}

return

contains

!
!       Return true if w <= x_in < e, taking into account the
!       periodicity of longitude.
!
!       x_in    value to test
!       w       west longitude of boundary
!       e       east longitude of boundary
!

function lon_between(x_in, w, e)  !{

implicit none

!
!       function definition
!

logical :: lon_between

!
!       arguments
!

real, intent(in)                :: x_in
real, intent(in)                :: w
real, intent(in)                :: e

!
!       local variables
!

real                    :: x

!
!       Save input values so we may modify them safely
!

x = x_in

!
!       make sure that all longitudes are in the range [0,360]
!

do while (x .gt. 360.0)  !{
  x = x - 360.0
enddo  !}
do while (x .lt. 0.0)  !{
  x = x + 360.0
enddo  !}
 
if (w .gt. e) then  !{
  lon_between = w .le. x .or. x .lt. e
else  !}{
  lon_between = w .le. x .and. x .lt. e
endif  !}

return

end function  lon_between  !}

end subroutine  ocean_residency_set_region_geog  !}
! </SUBROUTINE> NAME="ocean_residency_set_region_geog"


!#######################################################################
! <SUBROUTINE NAME="ocean_residency_set_region_3d">
!
! <DESCRIPTION>
!       Set up an array where the a grid box is in the region if the value
!       of the specified property (temperature, say) is within the given bounds.
!       Multiple values for the range may be given, and the resulting mask
!       will be the union of the multiple regions. If swap is true, then the
!       inverse of the selected region will be set.
!
!       Note: if the output array is not initialized, then it is assumed that it is already
!             filled with a region, and the resulting region will be the intersection of the
!             existing region and the newly specified region.
!
!       Arguments:
!
!         Input:
!
!                    isd:  low dimension of first index
!                    ied:  high dimension of first index
!                    jsd:  low dimension of second index
!                    jed:  high dimension of second index
!                     nk:  dimension of third index
!       num_geog_regions:  number of user-specified regions which will be filled
!                 bounds:  1-d array of pairs of bounding values. The first value in
!                          the pair must be less than the second value
!                    kmt:  array of indices for bottom grid cells
!                   name:  character variable used in informative messages
!   restore_region_value:  if supplied, the value to assign to array in the user-specified
!                          regions (default: 0.0)
! integrate_region_value:  if supplied, the value to assign to array outside of the
!                          user-specified regions (default: secs_in_year_r)
!                   swap:  if supplied and true then change the invert the defined region (default: true)
!             initialize:  if supplied and true, then initialize the region to the integrate_region_value (default: false)
!                 caller:  if supplied, use for traceback of error messages (default: fm_default_caller)
!
!         Input/Output:
!                  array:  3-d array which will contain the restore_region- and integrate_region-
!                          values.
! </DESCRIPTION>
!
!

subroutine ocean_residency_set_region_3d(isd, ied, jsd, jed, nk, array,         &
                     variable, bounds, kmt,                                &
                     restore_region_value, integrate_region_value, swap,        &
                     initialize, caller)  !{

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: nk
real, dimension(isd:,jsd:,:), intent(inout)             :: array
real, dimension(isd:,jsd:,:), intent(in)                :: variable
real, dimension(:), intent(in)                          :: bounds
integer, dimension(isd:,jsd:), intent(in)               :: kmt
real, intent(in), optional                              :: restore_region_value
real, intent(in), optional                              :: integrate_region_value
logical, intent(in), optional                           :: swap
logical, intent(in), optional                           :: initialize
character(len=*), intent(in), optional                  :: caller

!
!       local parameters
!

character(len=64), parameter    :: sub_name = 'ocean_residency_set_region_3d'

!
!       local variables
!

character(len=132)      :: error_string
integer                 :: i
integer                 :: j
integer                 :: k
integer                 :: n
logical                 :: restore_region
character(len=256)      :: error_header
character(len=128)      :: caller_str
real                    :: restore_region_value_use
real                    :: integrate_region_value_use
logical                 :: swap_use
logical                 :: assume_restore_region

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that an even number of bounds have been given
!

if (mod(size(bounds),2) .ne. 0) then
  call mpp_error(FATAL, trim(error_header) // ' Odd number of bounds given')
endif

!
! check that the bounds are correctly set (i.e., lesser value first)
!

do n = 1, size(bounds), 2  !{
  if (bounds(n+1) .le. bounds(n)) then  !{
    write (error_string,*) ' Bounds out of order: ', bounds(n+1), ' <= ', bounds(n)
    call mpp_error(FATAL, trim(error_header) // trim(error_string))
  endif  !}
enddo  !} n

!
!       set some default values in case they have not been set in the argument list
!

if (present(restore_region_value)) then  !{
  restore_region_value_use = restore_region_value
else  !}{
  restore_region_value_use = 0.0
endif  !}

if (present(integrate_region_value)) then  !{
  integrate_region_value_use = integrate_region_value
else  !}{
  integrate_region_value_use = secs_in_year_r
endif  !}

if (present(swap)) then  !{
  swap_use = swap
else  !}{
  swap_use = .false.
endif  !}

!
!       If initialize is true, then set all values to integrate_region_value,
!       otherwise, array values are assumed to be initialized with the appropriate
!       distribution of in- and out-region-values and the final value will be
!       the intersection between this value and that determined below (i.e., both values
!       must be "restore_region_value" to stay "restore_region_value", otherwise it becomes "integrate_region_value")
!       If we initialize, we need to set assume_restore_region to true so that when
!       calculating the region below, the intersection will have values in it.
!       However, we don't want to initialize to restore_region_value, or else the behavior
!       when no regions are found will be to have all locations restore_region.
!

if (present(initialize)) then  !{
  assume_restore_region = initialize
  if (initialize) then  !{
    do k = 1, nk  !{
      do j = jsd, jed  !{
        do i = isd, ied  !{
          array(i,j,k) = integrate_region_value_use
        enddo  !} i
      enddo  !} j
    enddo  !} k
  endif  !}
else  !}{
  assume_restore_region = .false.
endif  !}

!
!       find all boxes where the center lies in the region
!

do k = 1, nk  !{
  do j = jsd, jed  !{
    do i = isd, ied  !{
      if (k .le. kmt(i,j)) then  !{
        restore_region = .false.
        do n = 1, size(bounds), 2  !{
          if ((bounds(n+1) .ge. variable(i,j,k) .and. variable(i,j,k) .gt. bounds(n))) then  !{
            restore_region = .true.
            exit
          endif  !}
        enddo  !} n
        restore_region = restore_region .eqv. (.not. swap_use)
        if ((assume_restore_region .or. array(i,j,k) .eq. restore_region_value_use) .and. restore_region) then  !{
          array(i,j,k) = restore_region_value_use
        else  !}{
          array(i,j,k) = integrate_region_value_use
        endif  !}
      endif  !}
    enddo  !} i
  enddo  !} j
enddo  !} k

return

end subroutine  ocean_residency_set_region_3d  !}
! </SUBROUTINE> NAME="ocean_residency_set_region_3d"

end module ocean_residency_meta_mod  !}

MODULE DIAG_CLOUD_MOD


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!       DIAGNOSTIC CLOUD PREDICTION - Gordon (1992)            
!
!       1999 Feb -> 2000 July
!       Contact persons: Bill Stern (for code structure information)
!                        Tony Gordon (for cloud scheme information)
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!-------------------------------------------------------------------
!  Calculates cloud fractions diagnostically using relative humidity,
!  omega and stability 
!-------------------------------------------------------------------

use mpp_mod, only: input_nml_file
 use       fms_mod, only: error_mesg, FATAL, NOTE, file_exist,    &
                          check_nml_error, open_namelist_file,       &
                          mpp_pe, mpp_root_pe,  close_file, &
                          read_data, write_data, &
                          write_version_number, stdlog
 use     fms_io_mod, only: register_restart_field, restart_file_type, &
                           save_restart, restore_state
 use  Constants_Mod, only: Cp_Air, rdgas, rvgas, Kappa, HLv
 use time_manager_mod, only:  TIME_TYPE
 use  cloud_zonal_mod, only:  CLOUD_ZONAL_INIT, GETCLD
 use  diag_cloud_rad_mod, only:  CLOUD_TAU_DRIVER, diag_cloud_rad_INIT,&
                                 cloud_pres_thick_for_tau,  &
                                 cloud_opt_prop_tg_lw, &
                                 cloud_opt_prop_tg_sw, &
                                 cloud_optical_depths, &
                                 cloud_optical_depths2
 use  sat_vapor_pres_mod, ONLY: compute_qs
 use  shallow_conv_mod, ONLY: SHALLOW_CONV_INIT,MYLCL

!-----------------------------------------------------------------------
 implicit none
!-----------------------------------------------------------------------

 private


!--------------------- version number ----------------------------------
 character(len=128) :: version = '$Id: diag_cloud.F90,v 19.0 2012/01/06 20:05:06 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'
 logical            :: module_is_initialized = .false.
!-----------------------------------------------------------------------

!  parmameter mxband = max number of radiative bands to be considered for some
!              cloud properties
 integer,  parameter :: mxband = 4
!  parmameter nrhc = number of critical relative humidity threshold values
!  as a function of vertical layers
 integer,  parameter :: nrhc = 3

! ****************************************************************************

!  WARNING: The parameter mxband and the namelist variable nband should have
!  the same value. Is there a way to guarantee this or can an error check
!  be added to the code to make sure that this condition is NOT violated?

! ****************************************************************************
!  The following constants are derive from other constants in constants_mod
   real,  parameter :: d622  = rdgas/rvgas, d378  = 1.0-d622
   real,  parameter :: p00 = 1000.0E2
!-----------------------------------------------------------------------

! ****  parameter used and defined in def_hi_mid_low ****

!  real,  parameter :: trshld_camt = 0.25

!      TRSHLD_CAMT - This is a cloud amounht threshold value, used in
!      conjunction with the thick cloud namelist options.  If a thick
!      cloud option is on then the level above the cloud amount max
!      for a particular cloud type is considered to be part of an
!      extended cloud if it is within this fraction of the max cloud amount.
!

!----------------- arrays for cloud predictor averaging code --------------------------

    real,    allocatable, dimension (:,:,:) :: temp_sum,qmix_sum,rhum_sum
    real,    allocatable, dimension (:,:) :: qmix_sum2
    real,    allocatable, dimension (:,:,:) :: omega_sum
    real,    allocatable, dimension (:,:,:) :: lgscldelq_sum,cnvcntq_sum
    real,    allocatable, dimension (:,:)   :: convprc_sum
    integer, allocatable, dimension (:,:)   :: nsum, nsum2

!-----------------------------------------------------------------------
! for netcdf restart
type(restart_file_type), save :: Dia_restart


!---------------------------------------------------------------------


! logical switches for initialization calls: 
! if = .false. -> has not been called
 logical :: do_cpred_init = .false.
 logical :: do_crad_init = .false.

!---------------------------------------------------------------------
! --- NAMELIST (diag_cloud_nml)
!---------------------------------------------------------------------
!     RHC -    critical humidity value (ras = 0.8 - 0.84, mca =0.7)
!              (note:  in vers >= 0.9.3 a function of 3 levels
!                i.e.,"high" , "mid", "low" - but here is more general)
!     PBOUNDS - sets pressure bounds for RHC (dimension = size(rhc) - 1
!     DO_AVERAGE - logical flag for time averaging cloud predictor variables
!     LQUADRA - logical switch for turning on quadratic relation
!             for calculating rhum clouds from rhum,
!             i.e., true for quadratice scheme, false for linear scheme
!     LRHCNV - logical switch for using rhum fields as follows:
!              if true - use rel humidities modified for presence of 
!              convective clouds (rhumcnv), otherwise use original 
!              rel humidities (rhum)
!     LOMEGA - logical switch for turning on omega correction to rhum 
!              clouds - true for omega correction, otherwise false 
!     LCNVCLD - logical switch for turning on calculation of deep convective 
!              clouds - true for deep convective clouds, otherwise false 
!     L_THEQV - logical switch for turning on calculation of shallow convective 
!              clouds - true for shallow convective clouds, otherwise false 
!     LINVERS - logical switch for turning on calculation of marine stratus 
!              clouds - true for marine stratus, otherwise false 
!     LSLINGO - logical variable = true apply Slingo marine stratus 
!                scheme, otherwise = false. 
!     LREGRSC - logical variable = true apply Tim Li marine stratus 
!                scheme, otherwise = false. Slingo & Li schemes may be
!                used in combination, but atleast one scheme must be used. 
!     LTHICK_HIGH - logical variable = true -> allow possibility of raising
!               high cloud tops one sigma level to increase their thickness
!               from 1 to nmax levels; otherwise they remain thin 
!               (1 level)
!     LTHICK_MID - logical variable = true -> allow possibility of raising
!               mid cloud tops one sigma level to increase their thickness
!               from 1 to nmax levels; otherwise they remain thin 
!               (1 level)
!     LTHICK_LOW - logical variable = true -> allow possibility of raising
!               low cloud tops one sigma level to increase their thickness
!               from 1 to nmax levels; otherwise they remain thin 
!               (1 level)
!     HIGH_LEV_CLOUD_INDEX - level above which no clouds are allowed to form 
!              (model level index)
!     NOFOG - logical switch for not allowing rhum clouds (or fog)
!             to occur beneath a certain level (low_lev_cloud_index) -> 
!              nofog = true
!             to allow clouds at the lowest model level -> nofog = false
!     LOW_LEV_CLOUD_INDEX - level below which no clouds are allowed to occur 
!               when nofog = true (model level index)
!     NBAND - max number of radiative bands to be considered for some
!              cloud properties
!     PSHALLOW - top of shallow convective layer (pressure level - n/m**2 )
!     WCUT0 - omega cutoff value for omega cloud depletion factor = 0
!     WCUT1 - omega cutoff value for omega cloud depletion factor = 1
!     t_cold     temperature defining ice-liquid cloud transition
!-----------------------------------------------------------------------

      real        :: t_cold= 263.16
 real :: &
      pshallow=.750E+05, wcut0 = .10, wcut1 = 0.0
 real, dimension(nrhc) :: rhc = (/ 0.8,0.8,0.84 /)
 real, dimension(nrhc-1) :: pbounds = (/ .400E5, .750e5 /)

 integer :: &
      high_lev_cloud_index=3, low_lev_cloud_index=16, nband=4 

 logical :: &
      do_average = .true., &
      lquadra = .true., nofog = .false.,lrhcnv = .false., & 
      lomega = .true.,lcnvcld = .true.,l_theqv = .true., & 
      linvers = .false.,lslingo = .true., lregrsc = .true., &
      lthick_high = .true.,lthick_mid = .true.,lthick_low = .true.

    NAMELIST / diag_cloud_nml /                         &
       rhc,pbounds,do_average,lquadra,lrhcnv,lomega,lcnvcld,l_theqv, & 
       linvers,lslingo,lregrsc,lthick_high,lthick_mid,lthick_low, & 
       high_lev_cloud_index, nofog, low_lev_cloud_index, nband, &
       pshallow, wcut0, wcut1, t_cold

integer :: num_pts, tot_pts

 public diag_cloud_driver, diag_cloud_init, diag_cloud_end
 public diag_cloud_driver2
 public diag_cloud_sum, diag_cloud_avg, diag_cloud_avg2, do_diag_cloud
 public diag_cloud_restart

 contains

!#############################################################################      

 SUBROUTINE DIAG_CLOUD_DRIVER (is,js, &
                    temp,qmix,rhum,omega,lgscldelq,cnvcntq,convprc, &
                    pfull,phalf,psfc,coszen,lat,time, &
                    nclds,cldtop,cldbas,cldamt,r_uv,r_nir,ab_uv,ab_nir, &
                    em_lw, conc_drop, conc_ice, size_drop, size_ice, &
    kbot)

! Arguments (intent in)

 integer, intent(in)   ::  is,js
 type(time_type), intent(in)  :: time
 real, intent(in)  :: lat(:,:)
 real, intent(in), dimension (:,:,:) ::  temp,qmix,rhum,omega
 real, intent(in), dimension (:,:,:) ::  lgscldelq,cnvcntq,pfull, phalf
 real, intent(in), dimension (:,:)   ::  convprc,psfc, coszen
 
 integer, intent(in), OPTIONAL, dimension(:,:) :: kbot


!      INPUT
!      ------

!      IS,JS    starting i,j indices from the full horizontal grid
!      IX, IY   Horizontal dimensions for global storage arrays
!      TEMP     Temperature (Deg K) at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      QMIX     Mixing Ratio at full model levels 
!                   (dimensioned IDIM x JDIM x kx)
!      RHUM     Relative humidity fraction at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      OMEGA  Pressure vertical velocity at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      LGSCLDELQ  Averaged rate of change in mix ratio due to lg scale precip 
!               at full model levels  
!               (dimensioned IDIM x JDIM x kx)
!      CNVCNTQ  Accumulated count of change in mix ratio due to conv precip 
!               at full model levels  
!               (dimensioned IDIM x JDIM x kx)
!      convprc Accumulated conv precip rate summed over all
!               full model levels (mm/day )
!               (dimensioned IDIM x JDIM)
!      PFULL    Pressure at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      PHALF    Pressure at half model levels
!                   (dimensioned IDIM x JDIM x kx+1)
!      PSFC     Surface pressure field
!                   (dimensioned IDIM x JDIM)
!      COSZEN     cosine of the zenith angle
!                   (dimensioned IDIM x JDIM)
!      TIME       time of year (time_type)
!      LAT        latitudes in radians, dimensioned by (1xJDIM)   
!      KBOT      OPTIONAL; lowest model level index array
!                   (dimensioned IDIM x JDIM)
!===================================================================
! Arguments (intent out)

 integer, intent(out), dimension(:,:,:) :: cldtop,cldbas
 integer, intent(out), dimension(:,:)  ::  nclds

   real, intent(out), dimension(:,:,:), optional :: r_uv,r_nir,ab_uv, &
                                                  ab_nir,em_lw, &
                                                  conc_drop, conc_ice, &
                                                  size_drop, size_ice
   real, intent(out), dimension(:,:,:) :: cldamt

!      OUTPUT
!      ------

!       NCLDS   number of (random overlapping) clouds in column and also
!                     the current # for clouds to be operating on
!                   (dimensioned IDIM x JDIM )
!      CLDTOP   index of cloud tops (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      CLDBAS   index of cloud bottoms (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      CLDAMT   cloud amount (fraction) (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      R_UV     fractional amount of ultraviolet radiation
!                     reflected by the clouds (at cloud levels)
!      R_NIRfractional amount of near inrared radiation
!                     reflected by the clouds (at cloud levels)
!      AB_UVfractional amount of ultraviolet radiation
!                     absorbed by the clouds (at cloud levels)
!      AB_NIRfractional amount of near inrared radiation
!                     absorbed by the clouds (at cloud levels)
!      EM_LWemissivity for the clouds (at cloud levels)

!=======================================================================
!  (Intent local)
integer, dimension(size(rhum,1),size(rhum,2)) :: &
         lhight, lhighb, lmidt, lmidb, llowt
integer,  dimension(size(rhum,1),size(rhum,2),size(rhum,3))  :: icld
real, dimension(size(rhum,1),size(rhum,2)) :: qmix_kx
real,  dimension(size(rhum,1),size(rhum,2),size(rhum,3),mxband)  :: tau
real,  dimension(size(rhum,1),size(rhum,2),size(rhum,3))  :: &
                  tempcld,delp_true, delp
integer idim, jdim, kx, lk
logical :: rad_prop, wat_prop
integer :: max_cld
integer :: i,j,k,n

!       TAU        cloud optical depth (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx x MXBAND)
!      TEMPCLD    cloud layer mean temperature (degrees Kelvin)
!                    (at cloud levels)
!      DELP_TRUE  true cloud pressure thickness of distinct cloud layers 
!                    (at cloud levels)
!       QMIX_KX     Lowest level mixing ratio 
!                   (dimensioned IDIM x JDIM)
!       ICLD          marker array of cloud types/heights (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!       LHIGHT        vertical level index upper limit for high cloud tops
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LHIGHB        vertical level index lower limit for high cloud bases
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LMIDT         vertical level index upper limit for mid cloud tops
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LMIDB         vertical level index lower limit for mid cloud bases
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LLOWT         vertical level index upper limit for low cloud tops
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       IERR        Error flag
!       IPRNT       Longitude index for sample printing
!
!  note:  LK - vertical level below which no low cloud bases can exist, is
!         calculated in routines where needed using namelist inputs 
!         low_lev_cloud_index and nofog for the cloud amount prediction code
!         but is passed to the cloud raidiative properties code as an argument.
!===================================================================

!-----------------------------------------------------------------------

      idim = size(rhum,1)
      jdim = size(rhum,2)
      kx = size(rhum,3)
      tau = 0.0

      rad_prop = .false.
      wat_prop = .false.
      if (present (r_uv) .or. present(r_nir) .or. present (ab_uv) &
       .or. present(ab_nir) .or. present (em_lw) ) then
   rad_prop = .true.
   r_uv = 0.
   r_nir = 0.
   ab_uv = 0.
   ab_nir = 0.
   em_lw = 0.
endif
if (present(conc_drop) .or. present(conc_ice) .or.    &
     present(size_drop) .or. present(size_ice) ) then
   wat_prop = .true.
endif
if ( (.not. rad_prop) .and. (.not. wat_prop) ) then
  rad_prop = .true.
endif

  !  define lower limit for low cloud bases
if (nofog) then
  lk = low_lev_cloud_index
else
  lk = kx
endif

!  cldtim drives cloud prediction scheme
      call cldtim ( temp,qmix,rhum,omega,lgscldelq,cnvcntq,convprc, &
                    pfull, phalf,psfc, lat, time, tempcld,delp_true, &
                    cldtop,cldbas,cldamt,                              &
                    lhight,lhighb, lmidt, lmidb, llowt,icld,nclds,kbot)

! lowest level mixing ratio for anomalous absorption in cloud-radiation
      qmix_kx(:,:) = qmix(:,:,kx)

    max_cld  = MAXVAL(nclds(:,:))

    IF (max_cld .gt. 0) then

       call cloud_pres_thick_for_tau (nclds,icld,cldtop,cldbas, &
   &          delp_true,lhight,lhighb, lmidt, lmidb, llowt,lk, delp, &
   &          phalf, psfc )

       call cloud_optical_depths(nclds,icld,cldtop,cldbas,tempcld,delp, &
                          tau,phalf )

!  cloud_tau_driver drives cloud radiative properties scheme
      if (rad_prop) then
      call cloud_tau_driver (            qmix_kx,                   &
                                          tempcld, &
                                               tau, coszen,  &
                                   r_uv=r_uv, r_nir=r_nir, ab_nir=ab_nir, ab_uv=ab_uv, &
                 em_lw=em_lw)

      endif

      endif ! (max_cld > 0)

!-----------------------------------------------------------------------
!  print output for 1-d testing
!            iprnt = 1
!            print *, ' diag_cloud sample output for iprnt,js= ', iprnt,js
!            print *,'cloud layers = ', nclds(iprnt,1)     
!            print *,'cloud amounts = ', cldamt(iprnt,1,:)     
!            print *,'cloud tops = ', cldtop(iprnt,1,:)     
!            print *,'cloud bases = ', cldbas(iprnt,1,:)     
!            print *,'cloud types = ', icld(iprnt,1,:)    
!            print *, ' clouds_rad_tg sample output '
!            print *,'reflectivity uv = ', r_uv(iprnt,1,:)     
!            print *,'reflectivity nir = ', r_nir(iprnt,1,:)     
!            print *,'absorptivity uv = ', ab_uv(iprnt,1,:)     
!            print *,'absorptivity nir = ', ab_nir(iprnt,1,:)     
!            print *,'emissivity = ', em_lw(iprnt,1,:)     
!            print *,'optical depth = ', tau(iprnt,1,:,:)     

!-----------------------------------------------------------------------
   if (present (conc_drop)) then
!-----------------------------------------------------------------------
!!!RSH
!!      NOTE:
!  THE FOLLOWING is here as an INITIAL IMPLEMENTATION to allow compil-
!  ation and model execution, and provide "reasonable ?? " values.
!  Code developed but NOT YET ADDED HERE reflects the current approach.
!  That code is available under the fez release, and will be added to
!  the repository when upgrades to the cloud-radiation modules are com-
!  pleted.
!!!RSH
! obtain drop and ice size and concentration here, consistent with the
! diag_cloud scheme.
!  As a test case, 
!  the following is a simple specification of constant concentration and
!  size in all boxes defined as cloudy, attempting to come close to
!  the prescribd values in microphys_rad.
!  assume ice cld thickness = 2.0 km; then conc_ice=10.0E-03 => 
!    iwp = 20 g/m^2, similar to that prescribed in microphys_rad.
!  assume water cld thickness = 3.5 km; then conc_drop = 20E-03 =>
!    lwp = 70 g / m^2, similar to that prescribed in microphys_rad.
!   use sizes as used in microphys_rad (50 and 20 microns). when done,
!   radiative boundary fluxes are "similar" to non-microphysical results
!   for test case done here, and shows reasonable sensitivity to
!   variations in concentrations.

    conc_ice = 0.
    conc_drop = 0.
    size_ice = 50.
    size_drop = 20.


    IF (max_cld .gt. 0) then
         idim = size(tau,1)
           jdim = size(tau,2)
         do j= 1,jdim
           do i=1,idim
          do n=1,nclds(i,j)
          do k=cldtop(i,j,n), cldbas(i,j,n)
           if (tempcld(i,j,n) < t_cold) then
            conc_ice(i,j,k) = 10.0E-03  ! units : g/m^3
          size_ice(i,j,k) = 50.       ! units : diameter in microns
           else
            conc_drop(i,j,k) = 20.0E-03 ! units : g/m^3
            size_drop(i,j,k) = 20.      ! units : diameter in microns
           endif
           end do
        end do
           end do
           end do

    endif
 endif


end SUBROUTINE DIAG_CLOUD_DRIVER

!---------------------------------------------------------------------

subroutine diag_cloud_driver2 (is, js, press, pflux, lat, time, nclds, &
                               cldtop, cldbas, cldamt, liq_frac, tau, &
                               ice_cloud, kbot) 

!--------------------------------------------------------------------- 
!    diag_cloud_driver2 returns the cloud specification arrays for the 
!    gordon diag cloud scheme. returned are the number of clouds per 
!    column, the cloud top, cloud base and fractional coverage of each 
!    cloud, the amount of the cloud which is liquid, its optical depth 
!    and an indicator as to whether it is ice or liquid (a different 
!    criterion than is used for the liquid fraction determination).
!----------------------------------------------------------------------
 
integer,                     intent(in)             ::  is,js
real,    dimension (:,:,:),  intent(in)             ::  press, pflux 
real,    dimension(:,:),     intent(in)             ::  lat
type(time_type),             intent(in)             ::  time
integer, dimension(:,:),     intent(inout)          ::  nclds
integer, dimension(:,:,:),   intent(out)            ::  cldtop,cldbas
real,    dimension(:,:,:),   intent(out)            ::  cldamt, liq_frac
real,    dimension(:,:,:,:), intent(out)            ::  tau
logical, dimension(:,:,:),   intent(out)            ::  ice_cloud
integer, dimension(:,:),     intent(in), optional   ::  kbot

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      is,js             starting subdomain i,j indices of data 
!                        in the physics_window being integrated
!      press             pressure at model levels (1:nlev), surface    
!                        pressure is stored at index value nlev+1   
!                        [ (kg /( m s^2) ]
!      pflux             average of pressure at adjacent model levels  
!                        [ (kg /( m s^2) ]
!      lat               latitude of model points  [ radians ]
!      time              time at which radiation calculation is to apply
!                        [ time_type (days, seconds) ]
!
!   intent(inout) variables:
!
!      nclds             total number of clouds in each grid column
!
!   intent(out) variables:
!
!      cldtop            k index of cloud top for each cloud
!      cldbas            k index of cloud base for each cloud
!      cldamt            fractional cloudiness for each cloud
!                        [ dimensionless ]
!      liq_frac          fraction of cloud which is liquid 
!                        [ dimensionless ]
!      tau               cloud optical depth  [ dimensionless ]
!      ice_cloud         logical flag indicating whether cloud is liquid
!                        or ice
!
!    intent(in), optional variables:
!
!      kbot              present when running eta vertical coordinate,
!                        index of lowest model level above ground
!
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:

      integer, dimension (size(press,1), size(press,2)) :: &
                                    lhight, lhighb, lmidt, lmidb, llowt

      integer,  dimension (size(press,1), size(press,2),  &
                                          size(press,3)-1)  :: icld

      real,  dimension (size(press,1), size(press,2),   &
                                       size(press,3)-1)  :: &
                         temp, qmix, rhum, omega, lgscldelq, cnvcntq, &
                 delp, tempcld, delp_true, pfull

      real, dimension (size(press,1), size(press,2)) ::  convprc, psfc

      real,  dimension(size(press,1), size(press,2),  &
                       size(press,3))  ::  phalf

      integer     :: kx, lk, ierr, max_cld
      integer     :: i, j, n
      
!---------------------------------------------------------------------
!   local variables:
!
!       lhight     vertical level index upper limit for high cloud tops
!                  a function of lat and lon
!       lhighb     vertical level index lower limit for high cloud bases
!                  a function of lat and lon
!       lmidt      vertical level index upper limit for mid cloud tops
!                  a function of lat and lon
!       lmidb      vertical level index lower limit for mid cloud bases
!                  a function of lat and lon
!       llowt      vertical level index upper limit for low cloud tops
!                  a function of ltt and lon
!       icld       marker array of cloud types/heights (at cloud levels)
!       temp       temperature at full model levels [ deg K ]
!       qmix       mixing ratio at full model levels [ kg H2O / kg air ]
!       rhum       relative humidity fraction at full model levels
!                  [ dimensionless ]
!       omega      pressure vertical velocity at full model levels
!                  [ mb / sec ??????? ]
!       lgscldelq  averaged rate of change in mixing ratio due to large 
!                  scale precip at full model levels  
!       cnvcntq    accumulated count of change in mixing ratio due to 
!                  convective  precip at full model levels  
!       delp       pressure thickness of model layers [ kg / (m s^2) ]
!       tempcld    cloud layer mean temperature, at cloud levels
!                  [ deg K ]
!       delp_true  true cloud pressure thickness of distinct cloud 
!                  layers (at cloud levels) [ kg / (m s^2) ]
!       pfull      pressure at full levels [ kg / (m s^2) ]
!       convprc    accumulated conv precip rate summed over all
!                  full model levels [ mm/day ]
!       psfc       surface pressure field [ kg / (m s^2) ]
!       phalf      pressure at model half levels [ kg / (m s^2) ]


!       kx         number of model layers
!       lk         vertical level below which no low cloud bases can 
!                  exist
!       ierr       error flag
!       max_cld    max number of clouds in any column in the current
!                  physics window
!       i,j,n    do loop indices
!
!--------------------------------------------------------------------- 

!----------------------------------------------------------------------
!    define the number of model layers.
!----------------------------------------------------------------------
      kx   = size(press,3) - 1

!---------------------------------------------------------------------
!    define the needed pressure arrays. 
!---------------------------------------------------------------------
      pfull(:,:,:) = press(:,:,1:kx)
      phalf(:,:,:) = pflux(:,:,:)
      psfc(:,:)    = press(:,:,kx+1)

!--------------------------------------------------------------------
!    call diag_cloud_avg to obtain the appropriate values for the input 
!    arrays needed to define the cloud locations and amounts. these may
!    or may not be time-averaged values.
!---------------------------------------------------------------------
      call diag_cloud_avg (is, js, temp, qmix, rhum, omega, lgscldelq, &
                           cnvcntq, convprc, ierr)

!----------------------------------------------------------------------
!    initialize the output fields produced by this module.
!---------------------------------------------------------------------
      tau = 0.
      liq_frac = 0.
      cldamt = 0.
      cldtop = 0
      cldbas = 0
      ice_cloud = .false.

!----------------------------------------------------------------------
!    if input data was appropriately returned from diag_cloud_avg,
!    proceed with the determination of the cloud field.
!---------------------------------------------------------------------
      if (ierr == 0) then

!---------------------------------------------------------------------
!    define the lowest model level which can be a cloud base. it is 
!    either the lowest model level, or a level determined from namelist
!    input.
!---------------------------------------------------------------------
        if (nofog) then
          lk = low_lev_cloud_index
        else
          lk = kx
        endif

!--------------------------------------------------------------------
!    call cldtim to drive the cloud prediction scheme.
!--------------------------------------------------------------------
        call cldtim (temp, qmix, rhum, omega, lgscldelq, cnvcntq,   &
                     convprc, pfull, phalf, psfc, lat, time, tempcld, &
                     delp_true, cldtop, cldbas, cldamt, lhight, lhighb,&
                     lmidt, lmidb, llowt, icld, nclds, kbot)

!---------------------------------------------------------------------
!    determine the maximum number of clouds in any of the columns in the
!    physics window.
!---------------------------------------------------------------------
        max_cld  = MAXVAL(nclds(:,:))

!--------------------------------------------------------------------
!    if cloud is present anywhere in the window, call 
!    cloud_pres_thick_for_tau to determine the cloud thicknesses and
!    the call cloud_optical_depths2 to determine the optical depths and
!    liquid fraction of each cloud.
!---------------------------------------------------------------------
        if (max_cld > 0) then
          call cloud_pres_thick_for_tau (nclds, icld, cldtop, cldbas, &
                                         delp_true, lhight, lhighb,  &
                                         lmidt, lmidb, llowt, lk, delp,&
                                         phalf, psfc)
          call cloud_optical_depths2 (nclds, icld, cldtop, cldbas,  & 
                                      tempcld, delp, tau, phalf, &
                                      liq_frac)
        endif

!---------------------------------------------------------------------
!    determine whether the cloud temperature will support a liquid or
!    an ice cloud. the parameter t_cold is the cutoff temperature value.
!---------------------------------------------------------------------
        do j= 1,size(press,2)
          do i=1,size(press,1)
            do n=1,nclds(i,j)
              if (tempcld(i,j,n) < t_cold) then
                ice_cloud(i,j,n) = .true.
              endif
            end do
          end do
        end do

!----------------------------------------------------------------------
!    if input data was not acceptably returned from diag_cloud_avg,
!    determine if this represents an error, or is just a manifestation
!    of coldstart behavior. if this is coldstart step, set clouds to
!    zero and continue.
!---------------------------------------------------------------------
      else
        if (num_pts >= tot_pts) then
          call error_mesg ('diag_cloud_mod',  &
             ' no diag cloud data available; ierr /= 0', FATAL)
        else
          num_pts = num_pts + size(press,1)*size(press,2)
          nclds = 0
        endif
      endif ! (ierr=0)


!--------------------------------------------------------------------




end subroutine diag_cloud_driver2



!---------------------------------------------------------------------



!##################################################################      

 SUBROUTINE CLDTIM (temp,qmix,rhum, omega,lgscldelq,cnvcntq,convprc,  &
                    pfull, phalf,psfc, lat, time, tempcld,delp_true, &
                    cldtop,cldbas,cldamt,                              &
                    lhight,lhighb, lmidt, lmidb, llowt,icld,nclds,kbot)

!===================================================================
! Arguments (intent in)

! Namelist variables used in this routine (defined at top of module)
!     HIGH_LEV_CLOUD_INDEX - level above which no clouds are allowed to form 
!              (model level index)
!     NOFOG - logical switch for not allowing rhum clouds (or fog)
!             to occur beneath a certain level (low_lev_cloud_index) -> 
!              nofog = true
!             to allow clouds at the lowest model level -> nofog = false
!     LOW_LEV_CLOUD_INDEX - level below which no clouds are allowed to occur 
!               when nofog = true (model level index)


 type(time_type), intent(in)  :: time
 real, intent(in)  :: lat(:,:)
 real, intent(in), dimension (:,:,:) ::  temp,qmix,rhum,omega
 real, intent(in), dimension (:,:,:) ::  lgscldelq,cnvcntq,pfull, phalf
 real, intent(in), dimension (:,:) ::    convprc,psfc

!
!      INPUT
!      -----
!
!      TEMP     Temperature (Deg K) at full model levels 
!                   (dimensioned IDIM x JDIM x kx)
!      QMIX     Mixing Ratio at full model levels 
!                   (dimensioned IDIM x JDIM x kx)
!      RHUM     Relative humidity fraction at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      OMEGA  Pressure vertical velocity at full model levels 
!                   (dimensioned IDIM x JDIM x kx)
!      LGSCLDELQ  Averaged rate of change in mix ratio due to lg scale precip 
!               at full model levels  
!               (dimensioned IDIM x JDIM x kx)
!      CNVCNTQ  Accumulated count of change in mix ratio due to conv precip 
!               at full model levels  
!               (dimensioned IDIM x JDIM x kx)
!      CONVPRC Accumulated conv precip rate summed over all
!               full model levels (mm/day )
!               (dimensioned IDIM x JDIM)
!      PFULL    Pressure at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      PHALF    Pressure at half model levels
!                   (dimensioned IDIM x JDIM x kx+1)
!      PSFC     Surface pressure field
!                   (dimensioned IDIM x JDIM)
!      TIME       time of year (time_type)
!      LAT        latitudes in radians, dimensioned by (IDIMxJDIM)   
!      KBOT    -  OPTIONAL; lowest model level index array
!                   (dimensioned IDIM x JDIM)
!===================================================================
! Arguments (intent out)

integer, intent(out), dimension(:,:,:) :: cldtop,cldbas,icld
integer, intent(out), dimension(:,:)  :: nclds
integer, intent(out), dimension(:,:)  :: lhight,lhighb, lmidt, lmidb, llowt
   real, intent(out), dimension(:,:,:) :: cldamt
   real, intent(out), dimension(:,:,:) :: tempcld,delp_true


integer, intent(in), OPTIONAL, dimension(:,:) :: kbot


!      OUTPUT
!      ------

!      ICLD          marker array of cloud types (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      CLDTOP     index of cloud tops (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      CLDBAS     index of cloud bottoms (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      CLDAMT   cloud amount (fraction) (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      TEMPCLD    cloud layer mean temperature (degrees Kelvin)
!                    (at cloud levels)
!      DELP_TRUE  true cloud pressure thickness of distinct cloud layers 
!                    (at cloud levels)
!      R_UV    fractional amount of ultraviolet radiation
!                     reflected by the clouds
!      R_NIRfractional amount of near inrared radiation
!                     reflected by the clouds
!      AB_UVfractional amount of ultraviolet radiation
!                     absorbed by the clouds
!      AB_NIRfractional amount of near inrared radiation
!                     absorbed by the clouds
!      EM_LWemissivity for the clouds
!       NCLDS        number of (random overlapping) clouds in column and also
!                        the current # for clouds to be operating on
!       LHIGHT        vertical level index upper limit for high cloud tops
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LHIGHB        vertical level index lower limit for high cloud bases
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LMIDT         vertical level index upper limit for mid cloud tops
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LMIDB         vertical level index lower limit for mid cloud bases
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LLOWT         vertical level index upper limit for low cloud tops
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!
!  note:  vertical level below which no low cloud bases can exist is
!         calculated in routines where needed using namelist inputs 
!         low_lev_cloud_index and nofog

!===================================================================


!=======================================================================
!  (Intent local)
 real , dimension(size(rhum,1),size(rhum,2),size(rhum,3)) :: theta
 real , dimension(size(rhum,1),size(rhum,2),size(rhum,3)) :: rhumcnv, &
      camtcnv,camtrh,camtw,camtsh,camtsc,camt
 real, dimension (size(rhum,1),size(rhum,2)) :: camtsh_mx 
 real, dimension (size(phalf,1),size(phalf,2),size(phalf,3)) :: pnorm
 integer , dimension(size(rhum,1),size(rhum,2),size(rhum,3)) :: icld_k
 integer , dimension(size(rhum,1),size(rhum,2),3) ::  kthclm, kbhclm
 integer, dimension (size(rhum,1),size(rhum,2)) :: kmaxshl,kminshl
! horizontal dimensions
 integer idim,jdim
! bottom level vertical index
 integer kx 
! loop index
 integer k 

!-----------------------------------------------------------------------
!      THETA    Potential temperature 
!               at full model levels (Deg K) )
!               (dimensioned IDIM x JDIM x kx)
!      THETA_E  Equivalent potential temperature 
!               at full model levels (Deg K) )
!               (dimensioned IDIM x JDIM x kx)
!      RHUMCNV  Relative humidity fraction modified for convective clouds
!                   (dimensioned IDIM x JDIM x kx)
!      CAMTCNV  tentative deep convective cloud amounts  
!                   (dimensioned IDIM x JDIM x kx)
!      CAMTRH   tentative rel. humidity cloud amounts  
!                   (dimensioned IDIM x JDIM x kx)
!      CAMTW    tentative cloud amounts omega corrected clouds 
!                   (dimensioned IDIM x JDIM x kx)
!      CAMTSH   tentative shallow convective cloud amounts  
!                   (dimensioned IDIM x JDIM x kx)
!      CAMTSC   tentativemarine stratus cloud amounts  
!                   (dimensioned IDIM x JDIM x kx)
!      CAMTSL   tentative Slingo marine stratus cloud amounts  
!                   (dimensioned IDIM x JDIM x kx)
!      CAMTTL   tentative Tim Li marine stratus cloud amounts  
!                   (dimensioned IDIM x JDIM x kx)
!      CAMTSH_MX maximum value of shallow convective cloud amount within
!                  shallow convective layer. (dimensioned IDIM x JDIM)
!      CAMT     tentative merged cloud amounts  
!                   (dimensioned IDIM x JDIM x kx)
!      PNORM    Normalized pressure at half or full  model levels
!                   (dimensioned IDIM x JDIM x kx+1)
!      ICLD_K     tentative merged cloud marker array  
!                   (dimensioned IDIM x JDIM x kx)
!      KTHCLM,KBHCLM gcm vert coord indices of climo high, mid, low cloud   
!                   tops and bases, (dimensioned IDIM x JDIM x 3)
!      KMINSHL,KMAXSHL indices of vertical levels corresponding to 
!                   final top and base of shallow convective cloud layer
!                   (dimensioned IDIM x JDIM)

!-----------------------------------------------------------------------
! Calculate gcm vetical coord. indices for high, mid and low clouds based
! on observed  mean climatology. They will be a function of latitude and 
! time of year.  Optionally, climatological zonal mean cloud amounts may
! also be returned, presumably for a special "cold" start situation.

! ***** caveats: the current climo cloud setup uses climo average pressure 
! *****          values for locating single layer high and middle clouds
! *****          and the bottom and top of climo average low clouds
! *****          in the future a better approach to locating a vertical
! *****          layer range for each type of cloud will be needed

! *****          camt from getcld is only used to complete the argument list

! need to normalize pressures since table is based on assumption that 
! surface pressure = 101325 Pa


      idim = size(rhum,1)
      jdim = size(rhum,2)
      kx = size(rhum,3)

! for clouds at half levels
!         do k=1,kx+1
!            pnorm(:,:,k)=101325.*phalf(:,:,k)/phalf(:,:,kx+1)
!         enddo
! call getcld (time, lat, phalf, kthclm, kbhclm, camt)

! for clouds at full levels
         do k=1,kx
            pnorm(:,:,k)=101325.*pfull(:,:,k)/phalf(:,:,kx+1)
         enddo
         pnorm(:,:,kx+1) = 101325.
! call getcld (time, lat, pfull, kthclm, kbhclm, camt)
call getcld (time, lat, pnorm, kthclm, kbhclm, camt)

!  re-initialize camt, icld_k, nclds, cldbas,cldtop
      camt(:,:,:) = 0.0
      icld_k(:,:,:) = 0
      cldbas(:,:,:) = 0
      cldtop(:,:,:) = 0
      nclds(:,:) = 0

      lhight(:,:) = high_lev_cloud_index
      lhighb(:,:) = kthclm(:,:,2) - 1
      lmidt(:,:) = kthclm(:,:,2) 
!  if climo mid cloud top level = climo high cloud base level, reset high base 
      where (kthclm(:,:,2) .eq. kbhclm(:,:,1))
         lhighb(:,:) = kbhclm(:,:,1)
         lmidt(:,:) = kbhclm(:,:,1) + 1
      endwhere
      lmidb(:,:) = kthclm(:,:,3) - 1
      llowt(:,:) = kthclm(:,:,3) 
!  if climo low cloud top level = climo mid cloud base level, reset mid base 
      where (kthclm(:,:,3) .eq. kbhclm(:,:,2))
         lmidb(:,:) = kbhclm(:,:,2)
         llowt(:,:) = kbhclm(:,:,2) + 1
      endwhere
         
!      print *, ' climatological cloud tops & bases'
!      print *, ' kthclm = ', kthclm
!      print *, ' kbhclm = ', kbhclm

 
!-----------------------------------------------------------------------
!  calculate potential temperature for use in computing marine stratus and/or 
!  shallow convective clouds

      if (linvers .or. l_theqv) then
        theta(:,:,:) = temp(:,:,:)*(p00/pfull(:,:,:)**Kappa)
      endif

!  calculate deep convective clouds
          if (lcnvcld) then
call cloud_cnv (rhum,cnvcntq,convprc, pfull, phalf, camtcnv, rhumcnv )
          endif

!  calculate rel humidity clouds
          if (lrhcnv .and. lcnvcld) then
call cloud_rhum (rhumcnv, pnorm, camtrh)
          else
call cloud_rhum (rhum, pnorm, camtrh)
          endif

!  calculate omega corrected rel humidity clouds
          if (lomega) then
call cloud_omga (camtrh, omega, llowt, camtw)
          endif


!  calculate marine stratus clouds
! ******* not implemented at this time *******
          if (linvers) then
!!!  call cloud_m_stratus (...,camtsc )
          endif

      kx = size(rhum,3)
!  calculate shallow convective clouds
          if (l_theqv) then
!  need to call shallow_conv_init to set up constants for mylcl
call cloud_shallow_conv (theta,omega,pfull,phalf,temp,qmix,camtrh, &
                    camtsh,camtsh_mx,kminshl,kmaxshl,kbot)
          endif

!  merge stratiform cloud types
call merge_strat_clouds (camtrh,camtw,camtsc,llowt,camt,icld_k)


!  group clouds into high, middle and low
call def_hi_mid_low (phalf,lhight,lhighb,lmidt,lmidb,llowt,camt,icld_k)


!  merge convective cloud types
          if (lcnvcld .or. l_theqv) then
call merge_cnv_clouds (camtcnv,camtsh,camtsh_mx,kminshl,kmaxshl, &
                        lhight,lhighb,lmidt,lmidb,llowt,camt,icld_k)
          endif

!  calculate vertical indices and tot number of distinct cloud layers
!  as a  function of lat and longitude.
call layr_top_base (icld_k,nclds,cldtop,cldbas,icld)

!  calculate vertical, mass weighted cloud amount fraction of distinct cloud
!  layers
call cldamt_mn (nclds,cldtop,cldbas,phalf,camt,cldamt)

!  compute total cloud amount from cloud amount of in distinct cloud layers
! ***** this diagnostice routine is postpooned for now *******
! call total_cld_amt()

!  Define the occurence of anvil cirrus clouds
call anvil_cirrus (lhighb,lmidb,nclds,cldtop,cldbas,cnvcntq,lgscldelq, &
                    pfull,phalf,icld)

!  Compute the mass weighted mean cloud temperature and pressure thickness
!  of each distinct cloud layer
call cld_layr_mn_temp_delp (nclds,cldtop,cldbas,temp,phalf,tempcld,delp_true)

!  Compute the cum mean water vapor mixing ratio of each distinct cloud layer
!  (This is proposed for the future)
!  call cld_lay_cum_qmix()


!-----------------------------------------------------------------------

end subroutine CLDTIM
!=======================================================================

!#############################################################################      
 
subroutine CLOUD_CNV (rhum,cnvcntq,convprc, pfull, phalf, camtcnv, rhumcnv )
                                  


!-------------------------------------------------------------------
!  This subroutine calculates deep convective cloud amounts
!-------------------------------------------------------------------

!===================================================================
! Arguments (intent in)

!-------------------------------------------------------------------
! Namelist variables used in this routine (defined at top of module)
!     HIGH_LEV_CLOUD_INDEX - level above which no clouds are allowed to form 
!              (model level index)
!     NOFOG - logical switch for not allowing rhum clouds (or fog)
!             to occur beneath a certain level (low_lev_cloud_index) -> 
!              nofog = true
!             to allow clouds at the lowest model level -> nofog = false
!     LOW_LEV_CLOUD_INDEX - level below which no clouds are allowed to occur 
!               when nofog = true (model level index)
!-------------------------------------------------------------------

!-------------------------------------------------------------------
!  parameters used in cloud_cnv

 real,  parameter :: beta = .125, cprc_thres = 0.14 
 real,  parameter :: cmax = 0.8, ctower = 0.25
 real,  parameter :: cnvdelqmn = 0.0

!      BETA -       convective cloud regression coefficients
!      CPRC_THRES - minimum convective precip amount imposed for
!                   for work array.  This allows the use of the log
!                   function in the convective cloud regression relation.
!      CMAX, CTOWER - factors limiting convective cloud amount
!                           and vertical profile
!      CNVDELQMN - min threshold value of accumulated count of mixing ratio 
!                  change due to convection above which convective clouds are 
!                  allowed
!                  ( It is set = 0.0 as a parameter, because it not anticipated
!                    that it would be changed.)
!-------------------------------------------------------------------

 real, intent(in), dimension (:,:,:) :: rhum, cnvcntq, pfull, phalf
 real, intent(in), dimension (:,:) :: convprc

!-------------------------------------------------------------------
!      RHUM     Relative humidity fraction at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      CNVCNTQ  Accumulated count of change in mix ratio due to conv precip 
!               at full model levels  
!               (dimensioned IDIM x JDIM x kx)
!      convprc Accumulated conv precip rate summed over all
!               full model levels (mm/day )
!               (dimensioned IDIM x JDIM)
!      PFULL    Pressure at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      PHALF    Pressure at half model levels
!                   (dimensioned IDIM x JDIM x kx+1)
!===================================================================
! Arguments (intent out)
 real, intent(out), dimension (:,:,:) :: camtcnv, rhumcnv
!     CAMTCNV - convective cloud amount at full model levels 
!               (dimensioned IDIM x JDIM x kx)
!     RHUMCNV - relative humidity adjusted for convective clouds
!=======================================================================
!  (Intent local)

 real, dimension (size(rhum,1),size(rhum,2),size(rhum,3)) :: delp
 real, dimension (size(rhum,1),size(rhum,2)) :: wrkcprc

!      DELP       pressure thickness of model layers 
!                   (dimensioned IDIM x JDIM x kx)
!      DCPRC - weighted convective precip as a function of vertical layer
!                   (dimensioned IDIM x JDIM x kx)
!      WRKCPRC - convective precip work array
!                   (dimensioned IDIM x JDIM)

 integer i, j, idim, jdim, kx, lk, lkxm1, kcbtop
 real alpha
!-----------------------------------------------------------------------
!  type loop index variable
 integer k 

!===================================================================

! Initialize convective cloud amount array
      camtcnv = 0.0

!  Define regression coefficient alpha base on coeficient beta, defined
!  above as a parameter
      alpha = -beta*log(cprc_thres)

!-----------------------------------------------------------------------
! <><><><><><><><>   set up vertical index range <><><><><><><><>
!-----------------------------------------------------------------------
      idim  = SIZE(rhum,1)
      jdim  = SIZE(rhum,2)
      kx = size(rhum,3)

!  define lower limit of cloud bottoms
      if (nofog) then
        lk = low_lev_cloud_index
      else
        lk = kx
      endif

!  no convective clouds allowed in lowest layer
      lkxm1 = min(lk,kx-1)  

!  define upper limit of cloud tops
      kcbtop = high_lev_cloud_index


! calculate pressure thickness of model layers, for vertcal averaging
      do k=1,kx
        delp (:,:,k) = phalf(:,:,k+1)-phalf(:,:,k)
      end do
!-----------------------------------------------------------------------
! <><><><><><><><>   code to identify convecting levels <><><><><><><><>
!-----------------------------------------------------------------------

! use total convective precip amount passed in as argument
      wrkcprc(:,:) = convprc(:,:)
!-----------------------------------------------------------------------
! <><><><><><><><>   code to compute conv cloud fraction <><><><><><><><>
!-----------------------------------------------------------------------

      do k=kcbtop,lkxm1
! check that accumulated count of convective mix ratio changes is greater
! than a minimum threshold (usually 0 )
        where (cnvcntq (:,:,k) > cnvdelqmn .and. wrkcprc(:,:) > cprc_thres)
          camtcnv(:,:,k) = alpha + beta * log(wrkcprc(:,:) )
        end where
      end do

! Impose contraints on convective cloud

      camtcnv(:,:,:) = min(camtcnv(:,:,:),cmax)


              do k=kcbtop,lkxm1
            do j=1,jdim
            do i=1,idim
      if (camtcnv(i,j,k) .lt. 0.0) then
         print *, ' pe,i,j,k,camtcnv = ', mpp_pe(),i,j,k,  &
                    camtcnv(i,j,k)
         call error_mesg ('cloud_cnv','cloud amount < 0' ,FATAL) 
      endif
            end do
            end do
              end do

      where (camtcnv(:,:,:) > 0.0 .and. pfull(:,:,:) < pshallow)
        camtcnv(:,:,:) = ctower * camtcnv(:,:,:) 
      endwhere

! calculate relative humidity adjusted for convective clouds

       rhumcnv (:,:,:) = (1.0 - camtcnv(:,:,:)) * rhum(:,:,:) 


!-----------------------------------------------------------------------

end subroutine CLOUD_CNV

!#############################################################################      

subroutine CLOUD_RHUM (rhum,pnorm, camtrh)
                                  


!-------------------------------------------------------------------
!  calculates stratiform cloud amounts based on relative humidities
!-------------------------------------------------------------------

!===================================================================
! Arguments (intent in)

! Namelist variables used in this routine (defined at top of module)
!     HIGH_LEV_CLOUD_INDEX - level above which no clouds are allowed to form 
!              (model level index)
!     NOFOG - logical switch for not allowing rhum clouds (or fog)
!             to occur beneath a certain level (low_lev_cloud_index) -> 
!              nofog = true
!             to allow clouds at the lowest model level -> nofog = false
!     LOW_LEV_CLOUD_INDEX - level below which no clouds are allowed to occur 
!               when nofog = true (model level index)
!-------------------------------------------------------------------

real, intent(in), dimension (:,:,:) :: rhum,pnorm

!-------------------------------------------------------------------
!      RHUM     Relative humidity fraction at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      PNORM    Normalized pressure at half or full  model levels
!                   (dimensioned IDIM x JDIM x kx+1)
!===================================================================

! Arguments (intent out)
 real, intent(out), dimension (:,:,:) :: camtrh
!     CAMTRH - Rel Humidity cloud amount at full model levels 
!               (dimensioned IDIM x JDIM x kx)
!=======================================================================
!  (Intent local)
 real, dimension (size(rhum,1),size(rhum,2)) :: rhc_work
! real, dimension (size(rhum,1),size(rhum,2),size(rhum,3)) :: rhum2      
 integer kx, lk, npower
!-----------------------------------------------------------------------
!  type loop index variable
 integer k,kk

!===================================================================

      kx = size(rhum,3)


!  define cloud amt - rel hum relation as linear or quadratic

      if (lquadra) then
        npower = 2
      else
        npower = 1
      endif


!    if (mpp_pe() == 0) then
!      print *, 'npower', npower
!    endif

!  define lower limit rel hum clouds
      if (nofog) then
        lk = low_lev_cloud_index 
      else
        lk = kx
      endif

! Initialize rhum cloud amount array
     camtrh = 0.0
!
!-----------------------------------------------------------------------
! <><><><><><><><>   code to compute rhum cloud fraction <><><><><><><><>
!-----------------------------------------------------------------------

      do k=high_lev_cloud_index,lk
        where (pnorm(:,:,k) .ge. pbounds(nrhc-1))
              rhc_work(:,:) = rhc(nrhc)
        end where
      do kk=nrhc-1,2
        where ((pnorm(:,:,k).lt.pbounds(kk)) .and. &
               (pnorm(:,:,k).ge.pbounds(kk-1)))
              rhc_work(:,:) = rhc(kk)
        end where
      end do
        where (pnorm(:,:,k).lt.pbounds(1)) 
              rhc_work(:,:) = rhc(1)
        end where
!BUGFIX ??
!       where (rhum(:,:,k) == rhc_work(:,:))
!    rhum2(:,:,k) = rhum(:,:,k) - 0.00007
!elsewhere
!    rhum2(:,:,k) = rhum(:,:,k)
!       endwhere
        where (rhum (:,:,k) > rhc_work(:,:))
          camtrh(:,:,k) = min(1.0, (  &
           (rhum (:,:,k) - rhc_work(:,:))/(1-rhc_work(:,:)) )** npower)
        elsewhere
          camtrh(:,:,k) = 0.0
        end where
      end do


end subroutine CLOUD_RHUM

!#############################################################################      

subroutine CLOUD_OMGA (camtrh, omega, llowt, camtw)
                                  


!-------------------------------------------------------------------
!  calculates omega corrected cloud amounts
!  This subroutine reduces rel hum clouds in regions of decending motion
!-------------------------------------------------------------------

!===================================================================
! Arguments (intent in)

! Namelist variables used in this routine (defined at top of module)
!     NOFOG - logical switch for not allowing rhum clouds (or fog)
!             to occur beneath a certain level (low_lev_cloud_index) -> 
!              nofog = true
!             to allow clouds at the lowest model level -> nofog = false
!     LOW_LEV_CLOUD_INDEX - level below which no clouds are allowed to occur 
!               when nofog = true (model level index)
!     WCUT0 - omega cutoff value for omega cloud depletion factor = 0
!     WCUT1 - omega cutoff value for omega cloud depletion factor = 1
!-----------------------------------------------------------------------

 real, intent(in), dimension (:,:,:) :: camtrh, omega
 integer, intent(in), dimension (:,:) :: llowt

!-----------------------------------------------------------------------
!      CAMTRH   tentative rel. humidity cloud amounts 
!                   (dimensioned IDIM x JDIM x kx)
!      OMEGA  Pressure vertical velocity at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      LLOWT    vertical level index upper limit for low cloud tops
!               a function of lon and latitude (dimensioned IDIMxJDIM)
!-----------------------------------------------------------------------

!===================================================================
! Arguments (intent out)
 real, intent(out), dimension (:,:,:) :: camtw
!     CAMTW - omega cloud amount at full model levels 
!               (dimensioned IDIM x JDIM x kx)
!=======================================================================

!  (Intent local)
!-----------------------------------------------------------------------
!  type loop limits 
integer kx, lk, idim, jdim
integer low_top
!-----------------------------------------------------------------------
!  type loop index variables
integer i,j, k 

!===================================================================

      kx = size(camtrh,3)
      jdim = size(camtrh,2)
      idim = size(camtrh,1)

! Initialize omega cloud amount array
     camtw = 0.0

!  define lower limit for calculating omega corrected clouds
      if (nofog) then
        lk = low_lev_cloud_index 
      else
        lk = kx
      endif

!  llowt is used to define an upper bound for calculating omega corrected 
!  clouds, i.e., estimate of highest level of a low cloud top

!-----------------------------------------------------------------------
!===================================================================

!-----------------------------------------------------------------------
! <><><><><><><>   code to compute omega corrected cloud fraction <><><>
!-----------------------------------------------------------------------
     
      do j=1,jdim
      do i=1,idim
        low_top = llowt(i,j)
        do k=low_top,lk
!  For regions of upward motion (or zero) set = rhum clouds
          if (omega (i,j,k) .le. wcut1 ) then
            camtw(i,j,k) = camtrh(i,j,k)
          endif
!  For regions of descending motion reduce clouds linearly to 0 where
!  descent = 3.6mb/hr = .1 n m-2 s-1
          if (omega (i,j,k) .gt. wcut1 .and. omega (i,j,k) .lt. wcut0 ) then
            camtw(i,j,k) = camtrh(i,j,k)*(omega(i,j,k) - wcut0)/(wcut1-wcut0)
          endif
!  For regions of descent >= 3.6mb/hr set to 0 
          if (omega (i,j,k) .ge. wcut0 ) then
            camtw(i,j,k) = 0.0
          endif
        end do
        end do
      end do
!-----------------------------------------------------------------------

end subroutine CLOUD_OMGA


!#############################################################################      
 
subroutine CLOUD_SHALLOW_CONV (theta,omega,pfull,phalf,temp,qmix,camtrh, &
                    camtsh,camtsh_mx,kminshl,kmaxshl,kbot)
                                  

!-------------------------------------------------------------------
!  This subroutine calculates shallow convective cloud amounts
!-------------------------------------------------------------------

!===================================================================
! Arguments (intent in)

! Namelist variables used in this routine (defined at top of module)
!     PSHALLOW - top of shallow convective layer (pressure level - n/m**2 )
!     L_THEQV - logical switch for turning on calculation of shallow convective 
!              clouds - true for shallow convective clouds, otherwise false 
!     WCUT1 - omega cutoff value for omega cloud depletion factor = 1
!     LOMEGA - logical switch for turning on omega correction to rhum 
!              clouds - true for omega correction, otherwise false 
!     LINVERS - logical switch for turning on calculation of marine stratus 
!              clouds - true for marine stratus, otherwise false 
!     HIGH_LEV_CLOUD_INDEX - level above which no clouds are allowed to form 
!              (model level index)
!-------------------------------------------------------------------
!  parameters used in cloud_shallow_conv

 real,  parameter :: twcfac = 0.2, crtcons = 0.0

!      TWCFAC - scaling factor for computing shallow conv cloud amt (= 0.2)
!      CRTCONS - crit value of d(Theta_e)/dP (= 0.0)


 real, intent(in), dimension (:,:,:) :: &
           theta,omega,pfull,phalf,temp,qmix,camtrh

 integer, intent(in), OPTIONAL, dimension(:,:) :: kbot

!     THETA     Potential temperature at full model levels ( Deg K )
!               (dimensioned IDIM x JDIM x kx)
!      OMEGA  Pressure vertical velocity at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      PFULL    Pressure at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      PHALF    Pressure at half model levels
!                   (dimensioned IDIM x JDIM x kx+1)
!      TEMP     Temperature (Deg K) at full model levels 
!                   (dimensioned IDIM x JDIM x kx)
!      QMIX     Mixing Ratio at full model levels 
!                   (dimensioned IDIM x JDIM x kx)
!      CAMTRH   tentative rel. humidity cloud amounts 
!                   (dimensioned IDIM x JDIM x kx)
!      KBOT      OPTIONAL; lowest model level index array
!                   (dimensioned IDIM x JDIM)
!===================================================================
! Arguments (intent out)

 real, intent(out), dimension (:,:,:) :: camtsh
 real, intent(out), dimension (:,:) :: camtsh_mx
 integer, intent(out), dimension (:,:) :: kminshl, kmaxshl

!     CAMTSH - shallow convective cloud amount at full model levels 
!               (dimensioned IDIM x JDIM x kx)
!     CAMTSH_MX  maximum value of shallow convective cloud amount within
!                  shallow convective layer. (dimensioned IDIM x JDIM)
!     KMINSHL,KMAXSHL indices of vertical levels corresponding to 
!                   final top and base of shallow convective cloud layer
!                   (dimensioned IDIM x JDIM)
!=======================================================================
!  (Intent local)

 real,    dimension(size(temp,1),size(temp,2),size(temp,3)) :: &
                   qsat,dcldnrm,theta_e,dtheta_e
 real,    dimension (size(temp,1),size(temp,2)) :: plcl
 integer, dimension (size(temp,1),size(temp,2)) :: ksiglcl,kshallow


!      QSAT - saturation vapor pressure
!                   (dimensioned IDIM x JDIM x KX)
!      PLCL - pressure of the lifting condensation level (LCL)
!                   (dimensioned IDIM x JDIM)
!      KSIGLCL - index of nearest vertical level to the LCL
!                   (dimensioned IDIM x JDIM)
!      DCLDNRM - normalization factor
!                   (dimensioned IDIM x JDIM x KX)
!      THETA_E  Equivalent potential temperature at full model levels ( Deg K )
!               (dimensioned IDIM x JDIM x kx)
!      DTHETA_E - vertical (p) derivative of theta_e
!                   (dimensioned IDIM x JDIM x KX)

! define 2-D work arrays
 real,    dimension(size(temp,1),size(temp,2)) ::  xy1, xy2, xy3

!-----------------------------------------------------------------------
!  type local variables
 integer i, j, k, kmin, kmax, kmin0, kmax0, idim, jdim,lk, lkxm1, kx, &
         kcbtop, kcount, knt_shl

!=======================================================================
!=======================================================================

  idim  = SIZE(Temp,1)
  jdim  = SIZE(Temp,2)
  kx  = SIZE(Temp,3)

 
!  define lower limit of cloud bottom
      if (nofog) then
        lk = low_lev_cloud_index
      else
        lk = kx
      endif

!  no convective clouds allowed in lowest layer
      lkxm1 = min(lk,kx-1) 

!  define upper limit of cloud tops
      kcbtop = high_lev_cloud_index

!  find index of vertical level closest to but not above the 
!  shallow convective lid (pshallow) 
     
      kshallow = 99999
      do k = kx,1,-1
        where (pfull(:,:,k) .ge. pshallow) 
           kshallow(:,:) = k
        end where
      end do

      
! Initialize shallow convective cloud amount and other related arrays
      camtsh = 0.0
      camtsh_mx = 0.0
      dcldnrm = 0.0

! calculate lcl 

! --- saturation mixing ratio 
     call compute_qs (Temp, pfull, qsat)

!  calculate equivalent potential temperature 
     
     theta_e(:,:,:) = theta(:,:,:)*exp(HLv*qmix(:,:,:)/    &
                      (Cp_Air*temp(:,:,:)))
 

!=======================================================================
! --- CALCULATE THE LIFTING CONDENSATION LEVEL, IE CLOUB BASE
!=======================================================================

! The optional argument array kbot allows for use of discontinuous vertical 
! coordinate systems. However, if the kbot index value relates to a level
! which is well above the local surface, the resulting lcl may not be 
! physically correct.

      if( PRESENT( kbot ) ) then
        do j=1,jdim
          do i=1,idim   
             k = kbot(i,j)
             xy1(i,j) =      Temp(i,j,k)
             xy2(i,j) =  MIN(MAX( qmix(i,j,k), 1.0e-6), qsat(i,j,k) )
             xy3(i,j) =     pfull(i,j,k)
          end do
        end do
      else
             xy1(:,:) =      Temp(:,:,kx)
             xy2(:,:) = MIN(MAX( qmix(:,:,kx), 1.0e-6), qsat(:,:,kx) )
             xy3(:,:) =     pfull(:,:,kx)
      end if

 

      CALL MYLCL( xy1, xy2, xy3, phalf, plcl, ksiglcl )


!=======================================================================
! --- Calculate d(theta_e)/dp
!=======================================================================

!  set dtheta_e = 0 at the first level 
      dtheta_e(:,:,1) = 0.0

      do k=2,kx-1
        dtheta_e(:,:,k) = &
       0.5*(theta_e(:,:,k+1)-theta_e(:,:,k))/(pfull(:,:,k+1)-pfull(:,:,k)) + &
       0.5*(theta_e(:,:,k)-theta_e(:,:,k-1))/(pfull(:,:,k)-pfull(:,:,k-1))
      end do

!  set dtheta_e at bottom level = detheta_e at next level up
!  (note:  bottom level value is not used in current scheme) 
      dtheta_e(:,:,kx) = dtheta_e(:,:,kx-1)


!=======================================================================
! --- Shallow Convective Cloud Calculation
!=======================================================================

      kmaxshl(:,:) = min(lkxm1,ksiglcl(:,:))
!  tentatively set kminshl to kshallow
      kminshl(:,:) = kshallow(:,:)
        
      do k = lkxm1,kcbtop,-1
        where (((k.ge.kshallow(:,:)) .and. (k.le.kmaxshl(:,:))) &
         .and. (dtheta_e(:,:,k).ge.crtcons )  &
         .and. (pfull(:,:,k) .le. plcl(:,:) ) )
           dcldnrm(:,:,k) = twcfac
        end where
      end do

!  Apply constraint that the shallow convective layer is confined to the
! lowest contigous layer between plcl and pshallow
     do j=1,jdim
       do i=1,idim
! no shallow conv clouds allowed in regions where lowest full P level
! is above the specified shallow convective lid
                   if (kshallow(i,j) .le. kx) then
         kmax=kmaxshl(i,j) 
         kmin=kshallow(i,j)
         kcount = 0
         knt_shl = 0
         do k = kmax,kmin,-1
             if (pfull(i,j,k) .le. plcl(i,j) ) then
               if (dcldnrm(i,j,k).eq.0.0 .and. knt_shl.ge.1) then
                 dcldnrm(i,j,k-1) = 0.0
                 kcount = kcount + 1
!  kminshl calculation is completed here
                 if (kcount .eq. 1) then
                   kminshl(i,j) = k
                 endif
               else
                 if (dcldnrm(i,j,k) .gt. 0.0) knt_shl = knt_shl + 1
               endif
             endif
         end do  
                   else
         dcldnrm(i,j,:) = 0.0
                   endif
       end do  
      end do  

!  calculate cloud amounts
      do k = lkxm1,kcbtop,-1
        where ((k.ge.kminshl(:,:)) .and. (k .le.kmaxshl(:,:)) &
         .and. dcldnrm(:,:,k).gt.0.0 .and. (omega(:,:,k).gt.wcut1) )
          camtsh(:,:,k) = dcldnrm(:,:,k)*camtrh(:,:,k)
          camtsh_mx (:,:) = max(camtsh_mx (:,:),camtsh (:,:,k) )      
        end where
      end do
!  impose maximum cloud overlap within the contiguous shallow convective 
!  cloud layer. Also check that an rhum cloud exists and that the condition
!  on vertical motion is satisfied
      do k = lkxm1,kcbtop,-1
        where ((k.ge.kminshl(:,:)) .and. (k .le.kmaxshl(:,:)) &
         .and. dcldnrm(:,:,k).gt.0.0 .and. (camtrh(:,:,k).gt.0.0) &
         .and. (omega(:,:,k).gt.wcut1) )
          camtsh(:,:,k) =  camtsh_mx (:,:)
        elsewhere
          camtsh(:,:,k) = 0.0 
        endwhere
      end do
!  redefine kminshl and kmaxshl based on actual shallow conv clouds
        do j=1,jdim
          do i=1,idim
                 if (camtsh_mx(i,j) .gt. 0.0) then

            kmax = kmaxshl(i,j)
            kmax0 = kmaxshl(i,j)
            kmin = kminshl(i,j)
            kmin0 = kminshl(i,j)
! find actual shallow conv cloud base by searching upwards 
            do k=kmax0,kmin0,-1
              if (camtsh(i,j,k) .gt. 0.0) then
                kmax = k
                go to 100
              endif
            end do
100    continue
! find actual shallow conv cloud top by searching downward
            do k=kmin0,kmax
              if (camtsh(i,j,k) .gt. 0.0) then
                kmin = k
                go to 200
              endif
            end do
200    continue
       kmaxshl(i,j) = kmax
       kminshl(i,j) = kmin

                 endif
          end do
        end do


!-----------------------------------------------------------------------

!-----------------------------------------------------------------------

end subroutine CLOUD_SHALLOW_CONV

!#######################################################################

subroutine MERGE_STRAT_CLOUDS (camtrh,camtw,camtsc,llowt,camt,icld_k)



!-------------------------------------------------------------------
!  This subroutine determines a dominant stratiform cloud amount
!-------------------------------------------------------------------

!===================================================================
! Arguments (intent in)

! Namelist variables used in this routine (defined at top of module)
!     LOMEGA - logical switch for turning on omega correction to rhum 
!              clouds - true for omega correction, otherwise false 
!     LINVERS - logical switch for turning on calculation of marine stratus 
!              clouds - true for marine stratus, otherwise false 
!     NOFOG - logical switch for not allowing rhum clouds (or fog)
!             to occur beneath a certain level (low_lev_cloud_index) -> 
!              nofog = true
!             to allow clouds at the lowest model level -> nofog = false
!     LOW_LEV_CLOUD_INDEX - level below which no clouds are allowed to occur 
!               when nofog = true (model level index)
 real, intent(in), dimension (:,:,:) ::  camtrh, camtw, camtsc 
 integer, intent(in), dimension (:,:) :: llowt

!      CAMTRH   tentative cloud amounts from stratiform clouds 
!                   (dimensioned IDIM x JDIM x kx)
!      CAMTW    tentative cloud amounts omega corrected clouds 
!                   (dimensioned IDIM x JDIM x kx)
!      CAMTSC   tentativemarine stratus cloud amounts  
!                   (dimensioned IDIM x JDIM x kx)
!       LLOWT   vertical level index upper limit for low cloud tops
!               a function of lon and latitude (dimensioned IDIMxJDIM)
!===================================================================
! Arguments (intent out)

 real, intent(out), dimension (:,:,:) :: camt
 integer, intent(out), dimension (:,:,:) :: icld_k

!      CAMT     tentative (only stratiform) merged cloud amounts  
!                   (dimensioned IDIM x JDIM x kx)
!      ICLD_K     tentative merged cloud marker array  
!                   (dimensioned IDIM x JDIM x kx)



!=======================================================================
!  (Intent local)
 integer kx, lk, idim, jdim, i, j, k
 integer low_top

!=======================================================================
!=======================================================================

  idim  = SIZE(camtrh,1)
  jdim  = SIZE(camtrh,2)
  kx  = SIZE(camtrh,3)

!  define lower limit for stratiform clouds
      if (nofog) then
        lk = low_lev_cloud_index 
      else
        lk = kx
      endif


!  Initialize output cloud amounts to rel hum cloud amounts and define
!  cloud type marker values

      camt(:,:,:) = camtrh(:,:,:)
      where ( camtrh(:,:,:) .gt. 0.0)
        icld_k(:,:,:) = 1
      endwhere

!  assign omega corrected cloud amounts
        if (lomega) then
      do j=1,jdim
      do i=1,idim
        low_top =llowt(i,j)
        do k=low_top,lk
          if ( camtw(i,j,k).gt. 0.0) then 
            camt(i,j,k) = camtw(i,j,k)
            if ( camtw(i,j,k) .lt. camtrh(i,j,k) ) then
              icld_k(i,j,k) = 2
            endif
          endif
        end do
      end do
      end do
        endif

!  assign marine stratus cloud amounts
        if (linvers) then
      where ( camtsc(:,:,:) .gt. camt(:,:,:) )
        camt(:,:,:) = camtsc(:,:,:)
        icld_k(:,:,:) = 3
      endwhere
        endif

!-----------------------------------------------------------------------

end subroutine MERGE_STRAT_CLOUDS


!#######################################################################

subroutine DEF_HI_MID_LOW (phalf,lhight,lhighb,lmidt,lmidb,llowt,camt,icld_k)


!-------------------------------------------------------------------
!  This subroutine transforms a vertical profile of stratiform cloud
!  amounts into "high", "middle" and "low" cloud layers 
!  if a "thick" cloud option is in effect the current implementation
!  extends the cloud up one layer (with current tentative cloud amounts)
!-------------------------------------------------------------------

!===================================================================
! Arguments (intent in)

! Namelist variables used in this routine (defined at top of module)
!     LTHICK_HIGH - logical variable = true -> allow possibility of raising
!               high cloud tops one sigma level to increase their thickness
!               from 1 to 2 sigma levels; otherwise they remain thin 
!               (1 sigma level)
!     LTHICK_MID - logical variable = true -> allow possibility of raising
!               mid cloud tops one sigma level to increase their thickness
!               from 1 to 2 sigma levels; otherwise they remain thin 
!               (1 sigma level)
!     LTHICK_LOW - logical variable = true -> allow possibility of raising
!               low cloud tops one sigma level to increase their thickness
!               from 1 to 2 sigma levels; otherwise they remain thin 
!               (1 sigma level)
!     NOFOG - logical switch for not allowing rhum clouds (or fog)
!             to occur beneath a certain level (low_lev_cloud_index) -> 
!              nofog = true
!             to allow clouds at the lowest model level -> nofog = false
!     LOW_LEV_CLOUD_INDEX - level below which no clouds are allowed to occur 
!               when nofog = true (model level index)
 real, intent(in), dimension (:,:,:) ::  phalf 
 integer,intent(in), dimension(:,:) :: lhight, lhighb, lmidt, lmidb, llowt

!       PHALF         Pressure at half model levels
!                     (dimensioned IDIM x JDIM x kx+1)
!       LHIGHT        vertical level index upper limit for high cloud tops
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LHIGHB        vertical level index lower limit for high cloud bases
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LMIDT         vertical level index upper limit for mid cloud tops
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LMIDB         vertical level index lower limit for mid cloud bases
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LLOWT         vertical level index upper limit for low cloud tops
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!
! !===================================================================
! Arguments (intent inout)

 real, intent(inout), dimension (:,:,:) :: camt
 integer, intent(inout), dimension (:,:,:) :: icld_k

!      CAMT     tentative merged cloud amounts  
!                   (dimensioned IDIM x JDIM x kx)
!      ICLD_K     tentative merged cloud marker array  
!                   (dimensioned IDIM x JDIM x kx)

!
!=======================================================================
!  (Intent local)

!  parameter used in def_hi_mid_low

 real,  parameter :: trshld_camt = 0.25
 integer,  parameter :: nmax = 2

!      TRSHLD_CAMT - This is a cloud amount threshold value, used in
!      conjunction with the thick cloud namelist options.  If a thick
!      cloud option is on then the level above the cloud amount max
!      for a particular cloud type is considered to be part of an
!      extended cloud if it is within this fraction of the max cloud amount.
!


  real,    dimension(SIZE(camt,1),SIZE(camt,2),SIZE(camt,3)) :: delp,c_work
  integer, dimension(SIZE(camt,1),SIZE(camt,2),SIZE(camt,3)) :: ic_work
  integer, dimension(1) :: kindex

!      DELP       pressure thickness of model layers 
!                   (dimensioned IDIM x JDIM x kx)
!      C_WORK     cloud amount work array 
!                   (dimensioned IDIM x JDIM x kx)
!      IC_WORK    cloud marker work array 
!                   (dimensioned IDIM x JDIM x kx)
!      NMAX       maximum number of model levels allowed in a thick cloud

       
! loop limits and indices
 integer idim,jdim,kx, lk, i, j, k, kbtm, ktop
!  special setting of max levels for special cases of mid & high thick clouds
 integer nmax_mh
! special threshold value for allowing thick middle and high clouds
! when cloud amounts at contiguous levels are the same value (typically 1.0)
 real trshld_mh

  idim  = SIZE(camt,1)
  jdim  = SIZE(camt,2)
  kx  = SIZE(camt,3)

!=======================================================================

 trshld_mh = .0001
 nmax_mh = kx

!=======================================================================


!  define lower limit for stratiform clouds
      if (nofog) then
        lk = low_lev_cloud_index 
      else
        lk = kx
      endif

!-----------------------------------------------------------------------

! caclulate stratiform  l-m-h cloud amounts for thin or thick clouds
! current implementation of thick clouds will extend max stratiform
! cloud layer upward 1 level - assuming the level
! above the max level is within a threshold cloud amount 

! [note: the maxloc function used below will choose the lowest value index
! in case of two identical max values. In the extremely unlikely event of
! two identical max cloud amounts in a particular column section, the
! maxloc selection priority will result in a bias toward higher clouds.]

      c_work(:,:,:) = 0.0
      ic_work(:,:,:) = 0

! calculate pressure thickness of model layers, for vertcal averaging
      do k=1,kx
        delp (:,:,k) = phalf(:,:,k+1)-phalf(:,:,k)
      end do
 

      do j = 1,jdim
        do i = 1,idim

! low clouds
          kbtm = min(lk,kx-1) 
          ktop = llowt(i,j)
          kindex(:) = maxloc (camt(i,j,ktop:kbtm)) 
          k=kindex(1) + ktop - 1
          c_work(i,j,k) = camt(i,j,k)
!  for low clouds add 300 to previous cloud marker type
          ic_work(i,j,k) = icld_k(i,j,k) + 300 

          if (lthick_low) then
!            do k = kbtm,ktop,-1
call THICK_CLOUDS (camt,delp,trshld_camt,i,j,k,ktop,kbtm,nmax,c_work,ic_work)
!            end do   
          endif

! mid clouds
          kbtm = lmidb(i,j) 
          ktop = lmidt(i,j)
          kindex(:) = maxloc (camt(i,j,ktop:kbtm)) 
          k=kindex(1) + ktop - 1
          c_work(i,j,k) = camt(i,j,k)         
!  for mid clouds add 200 to previous cloud marker type
          ic_work(i,j,k) = icld_k(i,j,k) + 200         

          if (lthick_mid) then
call THICK_CLOUDS (camt,delp,trshld_mh,i,j,k,ktop,kbtm,nmax_mh,c_work,ic_work)
! call THICK_CLOUDS (camt,delp,trshld_camt,i,j,k,ktop,kbtm,nmax,c_work,ic_work)
          endif

! high clouds
          kbtm = lhighb(i,j) 
          ktop = lhight(i,j)
          kindex(:) = maxloc (camt(i,j,ktop:kbtm)) 
          k=kindex(1) + ktop - 1
          c_work(i,j,k) = camt(i,j,k)         
!  for high clouds add 100 to previous cloud marker type
          ic_work(i,j,k) = icld_k(i,j,k) + 100         

          if (lthick_high) then
call THICK_CLOUDS (camt,delp,trshld_mh,i,j,k,ktop,kbtm,nmax_mh,c_work,ic_work)
! call THICK_CLOUDS (camt,delp,trshld_camt,i,j,k,ktop,kbtm,nmax,c_work,ic_work)
          endif

        end do
      end do

! Store the resulting values of c_work and ic_work back into camt and icld_k

      where (camt(:,:,:) .eq. 0.0)
        ic_work(:,:,:) = 0
      endwhere
!  Thick clouds are currently not allowed to extend to the lowest level, but
!  fog is allowed there if nofog = f
      do k=1,kx-1
        camt(:,:,k) = c_work(:,:,k)
        icld_k(:,:,k) = ic_work(:,:,k)
      end do
!  at lowest level check for fog and assign low cloud type
      where (icld_k(:,:,kx).gt.0)
       c_work(:,:,kx) = icld_k(:,:,kx) + 300
      endwhere
      icld_k(:,:,kx) = c_work(:,:,kx)


end subroutine DEF_HI_MID_LOW


!#######################################################################

subroutine THICK_CLOUDS (camt,delp,trshld_camt,i,j,kk,ktop,kbtm,nmax, &
                         c_work,ic_work)


!-------------------------------------------------------------------
!  This subroutine returns "thick" cloud amounts to routine def_hi_mid_low
!  if the criteria for those clouds are met.  First the level of the max 
!  cloud amount in a low, middle  or high cloud regime is determined.
!  A thick cloud layer consisting of a maximum of "nmax"  contiguous levels 
!  is determined to exist by looking for a cloud amount value one level
!  above that is within a specified threshold amount (trshld_camt). If
!  a contiguous cloud is found and nmax = 2 the search is over.  If no
!  contiguous cloud is found or nmax > 2 the search continues one level
!  below. If contiguous cloud is found both above and below and nmax > 3
!  the search will continue using the same threshold criteria 2 levels
!  above.  The search will continue to "zigzag" in this manner as long as
!  no maximum cloud thickness criteria has not been violated and as long
!  as there is no break in contiguous cloud amounts as described above.
!  Eventually a pressure thickness value will overide the nmax levels 
!  criteria for determining the maximum thickness of the clouds.  Another
!  factor limiting the thickness of clouds is that the cloud extent must 
!  remain within its respective high, middle, low cloud regime boundaries
!  ( i.e., ktop to kbtm). 
!-------------------------------------------------------------------
!
! !===================================================================
! Arguments (intent in)



 real, intent(in), dimension (:,:,:) :: camt,delp
 real, intent(in) :: trshld_camt
 integer, intent(in) :: i,j,kk,ktop,kbtm,nmax

!      CAMT     tentative merged cloud amounts  
!                   (dimensioned IDIM x JDIM x kx)
!      DELP       pressure thickness of model layers 
!                   (dimensioned IDIM x JDIM x kx)
!      I,J,KK     indicies for longitude, latitude and 
!                 vertical level (at level of max cloud amount)
!      KTOP,KBTM  - vertical index valid range for cloud top, cloud bottom
!      NMAX -       maximum number of model levels allowed in a thick cloud
!      TRSHLD_CAMT - This is a cloud amounht threshold value, used in
!                    conjunction with the thick cloud namelist options.   
!                    If a thick cloud option is on then level(s) adjacent  
!                    to the level of max cloud amount for a particular 
!                    cloud type is considered to be part of an extended cloud 
!                    if it is within this fraction of the max cloud amount.
!

!
!=======================================================================
! Arguments (intent inout)


  real, intent(inout), dimension(:,:,:) :: c_work
  integer,intent(inout), dimension(:,:,:) :: ic_work

!      C_WORK     cloud amount work array 
!                   (dimensioned IDIM x JDIM x kx)
!      IC_WORK    cloud marker work array 
!                   (dimensioned IDIM x JDIM x kx)
!
!=======================================================================
!  (Intent local)
 integer ncount,no_up,no_down,k,c_top,c_btm
! loop index
 integer ki,pass_count
 real delp_sum,thick_cld_amt
!      NCOUNT -       counter for number of model levels in a thick cloud
!      NO_UP -       if = 1 -> no more upward extension of cloud is possible
!      NO_DOWN -      if = 1 -> no more downward extension of cloud is possible
!      K  -          vertical level index of thick cloud as it being extended
!      C_TOP, C_BTM - Top and bottom of calculated thick cloud 
!      DELP_SUM - sum of pressure weights for thcik cloud layer
!      THICK_CLD_AMT - pressure weighted thick cloud amount     
!=======================================================================
!=======================================================================
      ncount = 1
      no_up = 0
      no_down = 0
      k = kk
      c_top = kk
      c_btm = kk

      pass_count = 0

!  no clouds to process
      if (camt(i,j,kk) .eq.0.0) go to 300 

100   continue

      pass_count = pass_count + 1

     
                     if (no_up .eq. 0) then
! First check to extend cloud upward
              k = c_top
              if (camt(i,j,k) .gt.0.0 .and. k.gt.ktop .and. k.le.kbtm) then
                if ((camt(i,j,kk)-camt(i,j,k-1)).le.trshld_camt) then
                  c_top = c_top - 1
                  ic_work(i,j,k-1) = ic_work(i,j,k)
                  ncount = ncount + 1
                else
! no upward extension of cloud possible
                  no_up = 1
                endif
             else
                no_up = 1
             endif
! check for reaching limiting number of levels in a thick cloud
     if (ncount .eq. nmax) go to 200
                     endif

! Next check to extend cloud downward
                     if (no_down .eq. 0) then
              k = c_btm
              if (camt(i,j,k) .gt.0.0 .and. k.ge.ktop .and. k.lt.kbtm) then
                if ((camt(i,j,kk)-camt(i,j,k+1)).le.trshld_camt) then
                  c_btm = c_btm + 1
                  ic_work(i,j,k+1) = ic_work(i,j,k)
                  ncount = ncount + 1
                else
! no downward extension of cloud possible
                  no_down = 1
                endif
             else
                no_down = 1
             endif
! check for reaching limiting number of levels in a thick cloud
      if (ncount .eq. nmax) go to 200
                     endif

!  Further tests for completion of thick cloud calculations
!  Make sure upward or downward extension of the cloud is still allowed
!  and the cloud level index is still within the allowable range
       if ( ( no_up.eq.1 .or. c_top.eq.ktop) .and. &
          ( no_down.eq.1 .or. c_btm.eq.kbtm) ) go to 200

! loop back to do another pass at extending the thick cloud
       go to 100

200   continue

!  calculate press thickness weighted thick clouds
      delp_sum = 0.0
      do ki=c_top,c_btm
        delp_sum = delp_sum + delp(i,j,ki)
      end do
      thick_cld_amt = 0.0
      do ki=c_top,c_btm
        thick_cld_amt = thick_cld_amt + camt(i,j,ki)*delp(i,j,ki)
      end do
      thick_cld_amt = thick_cld_amt/delp_sum

! broadcast thick cloud amount throughout thick cloud layer
      do ki=c_top,c_btm
        c_work(i,j,ki) = thick_cld_amt
      end do

300   continue

          
!===================================================================
end subroutine THICK_CLOUDS

!#######################################################################

subroutine MERGE_CNV_CLOUDS (camtcnv,camtsh,camtsh_mx,kminshl,kmaxshl, &
                           lhight,lhighb,lmidt,lmidb,llowt,camt,icld_k)



!-------------------------------------------------------------------
!  This subroutine adds convective cloud amounts to the already merged 
!  stratiform cloud amounts
!-------------------------------------------------------------------

!===================================================================
! Arguments (intent in)

!-------------------------------------------------------------------
! Namelist variables used in this routine (defined at top of module)
!     LCNVCLD - logical switch for turning on calculation of deep convective 
!              clouds - true for deep convective clouds, otherwise false 
!     L_THEQV - logical switch for turning on calculation of shallow convective 
!              clouds - true for shallow convective clouds, otherwise false 
!     HIGH_LEV_CLOUD_INDEX - level above which no clouds are allowed to form 
!              (model level index)
!     NOFOG - logical switch for not allowing rhum clouds (or fog)
!             to occur beneath a certain level (low_lev_cloud_index) -> 
!              nofog = true
!             to allow clouds at the lowest model level -> nofog = false
!     LOW_LEV_CLOUD_INDEX - level below which no clouds are allowed to occur 
!               when nofog = true (model level index)
!!-------------------------------------------------------------------

 real, intent(in), dimension (:,:,:) :: camtcnv, camtsh
 real, intent(in), dimension (:,:) :: camtsh_mx
 integer, intent(in), dimension (:,:) :: kminshl, kmaxshl
 integer, intent(in), dimension(:,:) :: lhight, lhighb, lmidt, lmidb, llowt

!     CAMTCNV - deep convective cloud amounts at full model levels  
!                   (dimensioned IDIM x JDIM x kx)
!     CAMTSH - shallow convective cloud amount at full model levels 
!               (dimensioned IDIM x JDIM x kx)
!     CAMTSH_MX  maximum value of shallow convective cloud amount within
!                  shallow convective layer. (dimensioned IDIM x JDIM)
!     KMINSHL,KMAXSHL indices of vertical levels corresponding to 
!                   final top and base of shallow convective cloud layer
!                   (dimensioned IDIM x JDIM)
!       LHIGHT        vertical level index upper limit for high cloud tops
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LHIGHB        vertical level index lower limit for high cloud bases
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LMIDT         vertical level index upper limit for mid cloud tops
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LMIDB         vertical level index lower limit for mid cloud bases
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LLOWT         vertical level index upper limit for low cloud tops
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
! !===================================================================
! Arguments (intent inout)

 real, intent(inout), dimension (:,:,:) :: camt
 integer, intent(inout), dimension (:,:,:) :: icld_k

!      CAMT     tentative merged cloud amounts  
!                   (dimensioned IDIM x JDIM x kx)
!      ICLD_K     tentative merged cloud marker array  
!                   (dimensioned IDIM x JDIM x kx)


!=======================================================================
!  (Intent local)
  real,    dimension(SIZE(camt,1),SIZE(camt,2)) ::   cmax_strat
  real,    dimension(SIZE(camt,1),SIZE(camt,2),SIZE(camt,3)) ::   c_work
  integer, dimension(SIZE(camt,1),SIZE(camt,2),SIZE(camt,3)) ::   ic_work

!      CMAX_STRAT   max stratiform cloud amount work array 
!                   (dimensioned IDIM x JDIM)
!      C_WORK     cloud amount work array 
!                   (dimensioned IDIM x JDIM x kx)
!      IC_WORK    cloud marker work array 
!                   (dimensioned IDIM x JDIM x kx)

 integer i,j,k,kx, lk, kcbtop, kbtm , ktop, idim, jdim

!=======================================================================
!=======================================================================

  idim  = SIZE(camt,1)
  jdim  = SIZE(camt,2)
  kx  = SIZE(camt,3)


      if (nofog) then
        lk = low_lev_cloud_index 
      else
        lk = kx
      endif
!  define upper limit of cloud tops
      kcbtop = high_lev_cloud_index

!  initialize work arrays
      c_work(:,:,:) = camt(:,:,:)

!  decide whether or not to replace stratiform low cloud within the
!  contiguous shallow convective layer with shallow convective cloud
      
      if (l_theqv) then
!  find maximum stratiform low cloud amount within shallow conv layer
!  assume shallow convective layer is always below upper bound for low clouds

      do j = 1,jdim
        do i = 1,idim
          kbtm = kmaxshl(i,j)
          ktop = kminshl(i,j)
          cmax_strat(i,j) = 0.0
          do k = kbtm,ktop,-1
            cmax_strat(i,j) = max (cmax_strat(i,j),camt(i,j,k))
          end do
        end do
      end do

!  check to see if shallow convective cloud will be dominant type
!  if so reset cloud amounts to shallow amount and reset cloud marker
      do k = lk,kcbtop,-1
        where ( (k.ge.kminshl(:,:)) .and. (k.le.kmaxshl(:,:)) .and. &
              (camtsh_mx(:,:) .gt. cmax_strat(:,:)) )
          c_work(:,:,k) =  camtsh (:,:,k)
          icld_k(:,:,k) = 304
        endwhere
      end do

      endif

!  randomly overlap stratiform and deep convective cloud amounts.
!  also check to see if the convective cloud is dominant based on
!  a comparison of cloud amounts (pre-random overlap), if so assign
!  cloud marker values based on H-M-L and cloud type (convective = 5)
  
      ic_work(:,:,:) = mod(icld_k(:,:,:),100)
       
        if (lcnvcld) then

      do k = lk,kcbtop,-1

        where ( ic_work(:,:,k) .le. 3)
          c_work(:,:,k) = camtcnv(:,:,k) + (1.0-camtcnv(:,:,k))*camt(:,:,k)
        endwhere

!  low cloud range
          where ( (camtcnv(:,:,k).gt.camt(:,:,k)) .and. &
             (k.ge.llowt(:,:) .and. k.le.lk) .and. (ic_work(:,:,k).le.3) )
            icld_k(:,:,k) = 305
          endwhere
!  mid cloud range
          where ( (camtcnv(:,:,k).gt.camt(:,:,k)) .and. &
             (k.ge.lmidt(:,:) .and. k.le.lmidb(:,:)) )
            icld_k(:,:,k) = 205
          endwhere
!  high cloud range
          where ( (camtcnv(:,:,k).gt.camt(:,:,k)) .and. &
             (k.ge.lhight(:,:) .and. k.le.lhighb(:,:)) )
            icld_k(:,:,k) = 105
          endwhere

      end do

        endif

!  re-define convective cloud amount as the max of deep and shallow convective
!  cloud at levels where shallow convective clouds are currently defined.

        if (lcnvcld .and. l_theqv) then

          where ( (camtcnv(:,:,:).gt.c_work(:,:,:)) .and. &
             (ic_work(:,:,:) .eq. 4 ) )
            c_work(:,:,:) = camtcnv(:,:,:)
            icld_k(:,:,:) = 305
          endwhere

        endif

! Store the resulting values of c_work back into camt

      camt(:,:,:) = c_work(:,:,:)

!-----------------------------------------------------------------------

end subroutine MERGE_CNV_CLOUDS

!#######################################################################

subroutine LAYR_TOP_BASE (icld_k,nclds,cldtop,cldbas,icld)



!-------------------------------------------------------------------
!  This subroutine determines cloud layers, tops and bases
!-------------------------------------------------------------------

!===================================================================
! Arguments (intent in)

! Namelist variables used in this routine (defined at top of module)
!     LTHICK_HIGH - logical variable = true -> allow possibility of raising
!               high cloud tops one sigma level to increase their thickness
!               from 1 to 2 sigma levels; otherwise they remain thin 
!               (1 sigma level)
!     LTHICK_MID - logical variable = true -> allow possibility of raising
!               mid cloud tops one sigma level to increase their thickness
!               from 1 to 2 sigma levels; otherwise they remain thin 
!               (1 sigma level)
!     LTHICK_LOW - logical variable = true -> allow possibility of raising
!               low cloud tops one sigma level to increase their thickness
!               from 1 to 2 sigma levels; otherwise they remain thin 
!               (1 sigma level)
!     HIGH_LEV_CLOUD_INDEX - level above which no clouds are allowed to form 
!              (model level index)
!     NOFOG - logical switch for not allowing rhum clouds (or fog)
!             to occur beneath a certain level (low_lev_cloud_index) -> 
!              nofog = true
!             to allow clouds at the lowest model level -> nofog = false
!     LOW_LEV_CLOUD_INDEX - level below which no clouds are allowed to occur 
!               when nofog = true (model level index)
!-------------------------------------------------------------------

integer, intent(in), dimension (:,:,:) :: icld_k

!      ICLD_K     tentative merged cloud marker array  
!                   (dimensioned IDIM x JDIM x kx)
!===================================================================
! Arguments (intent out)

integer, intent(out), dimension(:,:,:) :: cldtop,cldbas,icld
integer, intent(out), dimension(:,:)  :: nclds

!      NCLDS       number of (random overlapping) clouds in column and also
!                     the current # for clouds to be operating on
!                   (dimensioned IDIM x JDIM )
!      CLDTOP     index of cloud tops (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      CLDBAS    index of cloud bottoms (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      ICLD          marker array of cloud types (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)



!=======================================================================
!  (Intent local)

  integer, dimension(SIZE(icld_k,1),SIZE(icld_k,2),SIZE(icld_k,3)) :: &  
                 ctop_work,cbas_work,ic_work

!      CTOP_WORK    cloud top work array (at model levels)
!                   (dimensioned IDIM x JDIM x kx)
!      CBAS_WORK    cloud bsse work array (at model levels)
!                   (dimensioned IDIM x JDIM x kx)
!      IC_WORK    cloud marker work array 
!                   (dimensioned IDIM x JDIM x kx)
 integer k,kcbtop,i,j,idim, jdim, kx, lk, kp, kpmax, maxcld

!=======================================================================
!=======================================================================

  idim  = SIZE(icld_k,1)
  jdim  = SIZE(icld_k,2)
  kx  = SIZE(icld_k,3)


!  define lower limit of cloud bottom
      if (nofog) then
        lk = low_lev_cloud_index
      else
        lk = kx
      endif
!  define upper limit of cloud tops
      kcbtop = high_lev_cloud_index

!  Initialize output arrays

      nclds(:,:) = 0
      icld(:,:,:) = 0
      cldtop(:,:,:) = 0
      cldbas(:,:,:) = 0

!  Initialize work arrays

      ctop_work(:,:,:) = 0
      cbas_work(:,:,:) = 0
      ic_work(:,:,:) = mod(icld_k(:,:,:),100)


!  locate distinct cloud layers, tops and bases

      do k=kcbtop,lk

!  first locate tops and increment cloud layer counter, nclds

!  check for no clouds above any type of cloud layer 
      where ( ic_work(:,:,k).ge.1 .and. ic_work(:,:,k-1).eq.0)
        nclds(:,:) = nclds(:,:) + 1
        ctop_work(:,:,k) = k
      endwhere
!  check for stratiform cloud layer above convective cloud layer 
!  anvil and super anvil (types 6,7) are stratiform type clouds 
      where ( (ic_work(:,:,k).ge.4 .and. ic_work(:,:,k).le.5) .and. &
             (ic_work(:,:,k-1).ge.1 .and. ic_work(:,:,k-1).le.3) .or. &
             (ic_work(:,:,k-1).ge.6) )
        nclds(:,:) = nclds(:,:) + 1
        ctop_work(:,:,k) = k
      endwhere
!  check for convective cloud layer above stratiform cloud layer 
      where ( (ic_work(:,:,k-1).ge.4 .and. ic_work(:,:,k-1).le.5) .and. &
             (ic_work(:,:,k).ge.1 .and. ic_work(:,:,k).le.3) .or. &
             (ic_work(:,:,k).ge.6) )
        nclds(:,:) = nclds(:,:) + 1
        ctop_work(:,:,k) = k
      endwhere

        if (k.lt.lk) then

!  locate bases

!  check for no clouds above any type of cloud layer 
      where ( ic_work(:,:,k).ge.1 .and. ic_work(:,:,k+1).eq.0)
        cbas_work(:,:,k) = k
      endwhere
!  check for stratiform cloud layer above convective cloud layer 
!  anvil and super anvil (types 6,7) are stratiform type clouds 
      where ( (ic_work(:,:,k+1).ge.4 .and. ic_work(:,:,k+1).le.5) .and. &
             (ic_work(:,:,k).ge.1 .and. ic_work(:,:,k).le.3) .or. &
             (ic_work(:,:,k).ge.6) )
        cbas_work(:,:,k) = k
      endwhere
!  check for convective cloud layer above stratiform cloud layer 
      where ( (ic_work(:,:,k).ge.4 .and. ic_work(:,:,k).le.5) .and. &
             (ic_work(:,:,k+1).ge.1 .and. ic_work(:,:,k+1).le.3) .or. &
             (ic_work(:,:,k+1).ge.6) )
        cbas_work(:,:,k) = k
      endwhere

        endif


          do j = 1,jdim
            do i = 1,idim
        if (k.eq.lk .and. ic_work(i,j,k).ge.1) then

          cbas_work(i,j,k) = lk

        endif
            end do
          end do

      end do

!-----------------------------------------------------------------------

!  compress output cloud tops, bases and cloud markers to cloud levels

      do j = 1,jdim
        do i = 1,idim

          if (nclds(i,j) .ge.1) then

          kpmax = nclds(i,j)
          kp = 1
            do k = kcbtop,lk

              if (ctop_work(i,j,k).ne. 0) then
                cldtop(i,j,kp) = ctop_work(i,j,k)
                icld(i,j,kp) = icld_k(i,j,k)
              endif

              if (cbas_work(i,j,k).ne. 0) then
                cldbas(i,j,kp) = cbas_work(i,j,k)
                kp = kp + 1 
              endif

              if (kp .gt. kpmax) go to 999              

            end do
   
999     continue
     
        endif

        end do
      end do


!-----------------------------------------------------------------------

!  error check for too many cloud layers

! find maximum number of cloud layers
      maxcld  = maxval(nclds(:,:))
                   if (maxcld .gt. kx/2) then
     print *,'pe, NCLDS =', mpp_pe(),nclds
                 call error_mesg ('diag_cloud, layr_top_base',  &
                   'NCLDS too large', FATAL)
                    endif


!-----------------------------------------------------------------------

end subroutine LAYR_TOP_BASE

!#######################################################################


subroutine CLDAMT_MN (nclds,cldtop,cldbas,phalf,camt,cldamt)



!-------------------------------------------------------------------
!  This subroutine computes mass-weighted vertical mean cloud amount 
!  for each distinct cloud layer
!-------------------------------------------------------------------

!===================================================================
! Arguments (intent in)

! Namelist variables used in this routine (defined at top of module)
!     NOFOG - logical switch for not allowing rhum clouds (or fog)
!             to occur beneath a certain level (low_lev_cloud_index) -> 
!              nofog = true
!             to allow clouds at the lowest model level -> nofog = false
!     LOW_LEV_CLOUD_INDEX - level below which no clouds are allowed to occur 
!               when nofog = true (model level index)
!-------------------------------------------------------------------

 integer, intent(out), dimension(:,:,:) :: cldtop,cldbas
 integer, intent(out), dimension(:,:)  :: nclds
 real, intent(in), dimension (:,:,:) ::  phalf

!      NCLDS       number of (random overlapping) clouds in column and also
!                     the current # for clouds to be operating on
!                   (dimensioned IDIM x JDIM )
!      CLDTOP     index of cloud tops (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      CLDBAS    index of cloud bottoms (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      PHALF    Pressure at half model levels
!                   (dimensioned IDIM x JDIM x kx+1)
!===================================================================
! Arguments (intent inout)

 real, intent(inout), dimension (:,:,:) :: camt

!      CAMT     tentative merged cloud amounts  
!                   (dimensioned IDIM x JDIM x kx)
!=======================================================================
 real, intent(out), dimension(:,:,:) :: cldamt

!      CLDAMT   cloud amount (fraction) (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)

!=======================================================================
!  (Intent local)


  real, dimension(SIZE(camt,1),SIZE(camt,2),SIZE(camt,3)) :: delp,c_work,weight

!      DELP       pressure thickness of model layers 
!                   (dimensioned IDIM x JDIM x kx)
!      C_WORK     cloud amount work array (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      WEIGHT     vertical sum of press thickness over model levels for each
!                 cloud level (dimensioned IDIM x JDIM x kx)

! loop limits and indices
 integer idim,jdim,kx, kpr, lk, i, j, k
 integer maxcld

!=======================================================================
!=======================================================================

  idim  = SIZE(camt,1)
  jdim  = SIZE(camt,2)
  kx  = SIZE(camt,3)


!  define lower limitfor stratiform clouds
      if (nofog) then
        lk = low_lev_cloud_index 
      else
        lk = kx
      endif

! find maximum number of cloud layers
      maxcld  = maxval(nclds(:,:))

!-----------------------------------------------------------------------
 ! initialize output and work cloud amount arrays 

      cldamt(:,:,:) = 0.0
      c_work(:,:,:) = 0.0
      weight(:,:,:) = 0.0
!-----------------------------------------------------------------------

! calculate pressure thickness of model layers, for vertcal averaging
      do k=1,kx
        delp (:,:,k) = phalf(:,:,k+1)-phalf(:,:,k)
      end do
!-----------------------------------------------------------------------

! calculate mass weighted vertical mean cloud amount
      do kpr=1,maxcld
        do j=1,jdim
          do i=1,idim 
  
             if (cldtop(i,j,kpr) .lt. cldbas(i,j,kpr)) then

               do k=cldtop(i,j,kpr),cldbas(i,j,kpr) 
                 c_work(i,j,kpr) = c_work(i,j,kpr) + &
                 delp(i,j,k)*camt(i,j,k)
                 weight(i,j,kpr) = weight(i,j,kpr) + delp(i,j,k)
               end do
               cldamt(i,j,kpr) = c_work(i,j,kpr)/weight(i,j,kpr)
! reset cloud amounts at model sigma levels to mass weighted for the layer
               do k=cldtop(i,j,kpr),cldbas(i,j,kpr) 
                 camt(i,j,k) = cldamt(i,j,kpr)
               end do

             else if ( (cldtop(i,j,kpr) .eq. cldbas(i,j,kpr)) .and. &
             (cldtop(i,j,kpr).gt.0 .and. cldtop(i,j,kpr).le.kx)) then
 
               k = cldtop(i,j,kpr)
               cldamt(i,j,kpr) = camt(i,j,k)

             else if ( (cldtop(i,j,kpr) .gt. cldbas(i,j,kpr)) .or. &
             (cldtop(i,j,kpr).lt.0) .or. (cldbas(i,j,kpr).lt.0)) then

     print *,'pe, i,j,kpr, cldtop,cldbas =', mpp_pe(),i,j,kpr, &
         cldtop(i,j,kpr),cldbas(i,j,kpr),cldtop(i,j,kpr),cldbas(i,j,kpr)
                 call error_mesg ('diag_cloud, cldamt_mn',  &
                   'invalid cldtop and/or cldbas', FATAL)

             endif
          end do
        end do
      end do


end subroutine CLDAMT_MN 

!#############################################################################      
 
subroutine ANVIL_CIRRUS (lhighb,lmidb,nclds,cldtop,cldbas,cnvcntq,lgscldelq,  &
                   pfull,phalf,icld)
                                  


!------------------------------------------------------------------------
!  This subroutine calculates anvil and super anvil cirrus cloud amounts
!------------------------------------------------------------------------

!===================================================================
! Arguments (intent in)

!-------------------------------------------------------------------
! Namelist variables used in this routine (defined at top of module)
!     HIGH_LEV_CLOUD_INDEX - level above which no clouds are allowed to form 
!              (model level index)
!-------------------------------------------------------------------

!-------------------------------------------------------------------
!  parameters used in anvil_cirrus

 real,  parameter :: cnvdelqmn = 0.0,lgscldelqmn = 1.0e-9 
 real,  parameter :: lcldbas_prc = .55, lcldtop_prc = .225

!      CNVDELQMN - min threshold value of accumulated count of mixing ratio 
!                  change due to convection above which convective clouds are 
!                  allowed
!                  ( It is set = 0.0 as a parameter, because it not anticipated
!                    that it would be changed.)
!      LGSCLDELQMN - min threshold value of averaged mixing ratio rate of
!                  change due to large scale condensation
!      LCLDBAS_PRC - Threshold sigma value for base of an "anvil cirrus 
!                    indicator" layer
!      LCLDBAS_PRC - Threshold sigma value for top of an "anvil cirrus 
!                    indicator" layer
!-------------------------------------------------------------------

 integer, intent(out), dimension(:,:,:) :: cldtop,cldbas
 integer, intent(out), dimension(:,:)  ::  nclds,lhighb,lmidb
 real, intent(in), dimension (:,:,:) ::  lgscldelq,cnvcntq,pfull,phalf

!-------------------------------------------------------------------
!       LHIGHB        vertical level index lower limit for high cloud bases
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       LMIDB         vertical level index lower limit for mid cloud bases
!                     a function of lon and latitude (dimensioned IDIMxJDIM)
!       NCLDS   number of (random overlapping) clouds in column and also
!                     the current # for clouds to be operating on
!                   (dimensioned IDIM x JDIM )
!      CLDTOP   index of cloud tops (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      CLDBAS   index of cloud bottoms (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      LGSCLDELQ  Averaged rate of change in mix ratio due to lg scale precip 
!               at full model levels  
!               (dimensioned IDIM x JDIM x kx)
!      CNVCNTQ  Accumulated count of change in mix ratio due to conv precip 
!               at full model levels  
!               (dimensioned IDIM x JDIM x kx)
!      PFULL    Pressure at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      PHALF    Pressure at half model levels
!                   (dimensioned IDIM x JDIM x kx+1)
!===================================================================
! Arguments (intent inout)
 integer, intent(out), dimension (:,:,:) :: icld
!       ICLD          marker array of cloud types/heights (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!=======================================================================
!  (Intent local)

 integer, dimension (size(pfull,1),size(pfull,2),size(pfull,3)) :: ic_work
!-------------------------------------------------------------------
!      IC_WORK    cloud marker work array 
!                   (dimensioned IDIM x JDIM x kx)
!       LCLDT         Top of anvil cirrus 
!                     (model level index)
!       LCLDB         Base of anvil cirrus 
!                     (model level index)
!       LPRCTOP       Base of region in search for anvil cirrus markers
!                     (model level index)
!       LPRCBAS       Base of region in search for anvil cirrus markers
!                     (model level index)
!       SIG_TOP_BASE  Sigma value of top/base of region in search for 
!                      anvil cirrus markers
!                     

 real sig_top_base
 integer lcldt, lcldb, lprcbas, lprctop
 integer i, j, idim, jdim, kx
!-----------------------------------------------------------------------
!  type loop index variable
 integer k,kl 

!===================================================================

      idim  = SIZE(pfull,1)
      jdim  = SIZE(pfull,2)
      kx = size(pfull,3)

! Initialize cloud type work array
      ic_work (:,:,:) = icld(:,:,:)


!-----------------------------------------------------------------------
! <><><><><><><><>   search for anvil cirrus  <><><><><><><><>
!-----------------------------------------------------------------------
      
      do j=1,jdim
      do i=1,idim
        do k=1,kx
          sig_top_base = pfull(i,j,k)/phalf(i,j,kx+1)
          if ( sig_top_base .gt. lcldtop_prc) then
             lprctop = k-1
             go to 100
          endif
        end do

100     continue

        do k=1,kx
          sig_top_base = pfull(i,j,k)/phalf(i,j,kx+1)
          if ( sig_top_base .gt. lcldbas_prc) then
             lprcbas = k-1
             go to 150
          endif
        end do

150     continue
           
        do k=1,nclds(i,j)
          lcldt = cldtop(i,j,k)
          lcldb = cldbas(i,j,k)


! Must have a high cloud for any anvil cirrus

                    if (icld(i,j,k) .ne. 101) go to 400

! First check whether super-anvil cirrus criteria is satisfied
! This criteria differs from v197, because calculation of convective precip for 
! high cloud region only is unreliable. Instead it is required that there has  
! been a change in mixing ratio due to convection at at least one time step during
! the time interval over which the clouds are being calculated, at ALL levels 
! between the base of the anvil cirrus indicator region (lprcbas- clculated from preset parameter)
! and the higher of either the actual top of the high cloud or the previoulsy computed top of the 
! Anvil Cirrus cloud indicator region.

           if (lcldt .lt. lprctop) then
              lprctop = lcldt
           endif
           do kl=lprcbas,lprctop,-1
             if (cnvcntq(i,j,kl) .lt. 1.0) then
               go to 200
             endif
           end do
           ic_work(i,j,k) = 107
! found super-anvil cirrus, no need to search for anvil cirrus
           go to 400

200        continue

! search for anvil cirrus using criteria that a change in mixing ratio due to 
! either convection or large scale condensation at any level within an actual high 
! cloud takes places during the time interval over which the clouds are being 
! calculated.

          do kl=lcldb,lcldt,-1
            if (cnvcntq(i,j,kl) .gt. 0.0) go to 300
            if (kl.le.lhighb(i,j) .and. lgscldelq(i,j,kl).gt.lgscldelqmn) &
                go to 300
          end do
          go to 400
300       continue
               ic_work(i,j,k) = 106
   
        end do

400   continue

!                    endif

      end do
      end do


!-----------------------------------------------------------------------
! <><><><><><><><>   update cloud marker array  <><><><><><><><>
!-----------------------------------------------------------------------
      
      icld(:,:,:) = ic_work(:,:,:)       


!-----------------------------------------------------------------------

end subroutine ANVIL_CIRRUS



!#######################################################################

subroutine CLD_LAYR_MN_TEMP_DELP &
                        (nclds,cldtop,cldbas,temp,phalf,tempcld,delp_true)



!-------------------------------------------------------------------
!  This subroutine computes the mass-weighted mean cloud temperature
!  and true cloud pressure thickness of distinct cloud layers.
!-------------------------------------------------------------------

!===================================================================
! Arguments (intent in)

! Namelist variables used in this routine (defined at top of module)
!     HIGH_LEV_CLOUD_INDEX - level above which no clouds are allowed to form 
!              (model level index)
!     NOFOG - logical switch for not allowing rhum clouds (or fog)
!             to occur beneath a certain level (low_lev_cloud_index) -> 
!              nofog = true
!             to allow clouds at the lowest model level -> nofog = false
!     LOW_LEV_CLOUD_INDEX - level below which no clouds are allowed to occur 
!               when nofog = true (model level index)
!-------------------------------------------------------------------

! Arguments (intent in)

integer, intent(in), dimension(:,:)  :: nclds
integer, intent(in), dimension(:,:,:) :: cldtop,cldbas
real, intent(in), dimension(:,:,:) :: temp,phalf

!      NCLDS       number of (random overlapping) clouds in column and also
!                     the current # for clouds to be operating on
!                   (dimensioned IDIM x JDIM )
!      CLDTOP     index of cloud tops (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      CLDBAS    index of cloud bottoms (at cloud levels)
!                   (dimensioned IDIM x JDIM x kx)
!      TEMP        Temperature (Deg K) at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      PHALF    Pressure at half model levels
!                   (dimensioned IDIM x JDIM x kx+1)
!===================================================================
! Arguments (intent out)

real, intent(out), dimension(:,:,:) :: tempcld,delp_true

!      TEMPCLD    cloud layer mean temperature (degrees Kelvin)
!                    (at cloud levels)
!      DELP_TRUE  true cloud pressure thickness of distinct cloud layers 
!                    (at cloud levels)



!=======================================================================
!  (Intent local)

 integer, dimension (size(cldtop,1),size(cldtop,2)) :: cldt,cldb

!      CLDT       cloud top index work array 
!                   (dimensioned IDIM x JDIM x kx)
!      CLDB       cloud base index work array 
!                   (dimensioned IDIM x JDIM x kx)
 integer i,j,k,kk,kx,idim,jdim, lk, kcbtop, maxcld

!=======================================================================
!=======================================================================

  idim  = SIZE(temp,1)
  jdim  = SIZE(temp,2)
  kx  = SIZE(temp,3)


!  define lower limit of cloud bottom
      if (nofog) then
        lk = low_lev_cloud_index
      else
        lk = kx
      endif
!  define upper limit of cloud tops
      kcbtop = high_lev_cloud_index

!  Initialize output arrays

      tempcld(:,:,:) = 0
      delp_true(:,:,:) = 0

! find maximum number of clouds
      maxcld  = maxval(nclds(:,:))

                   if (maxcld .ge. 1) then

!-----------------------------------------------------------------------
! <><><><><><><><>   calc pressure thickness <><><><><><><><>
!-----------------------------------------------------------------------

      do k = 1,maxcld

! Initialize internal arrays
      cldt = 0
      cldb = 0
         where (nclds(:,:) .ge. k)
           cldt(:,:) = cldtop(:,:,k)      
           cldb(:,:) = cldbas(:,:,k) 
         end where

         do j=1,jdim
         do i=1,idim
           if (k .le. nclds(i,j)) then
             delp_true(i,j,k) = phalf(i,j,cldb(i,j)+1)-phalf(i,j,cldt(i,j))
           endif
         end do
         end do
       end do



!-----------------------------------------------------------------------
! <><><><><><><><>   calc mass-weghted mean cloud temp <><><><><><><><>
!-----------------------------------------------------------------------

      do j=1,jdim
      do i=1,idim
        do kk= 1,nclds(i,j)
          do k=cldtop(i,j,kk),cldbas(i,j,kk)
            tempcld(i,j,kk) = tempcld(i,j,kk) + &
            (phalf(i,j,k+1)-phalf(i,j,k))*temp(i,j,k)/delp_true(i,j,kk)
          end do
        end do
      end do
      end do

                   endif


!-----------------------------------------------------------------------

end subroutine CLD_LAYR_MN_TEMP_DELP

!#######################################################################

  SUBROUTINE DIAG_CLOUD_INIT( ix,iy,kx, ierr )

!=======================================================================
! ***** INITIALIZE Predicted Cloud Scheme
!=======================================================================


!---------------------------------------------------------------------
! Arguments (Intent in)
!  parmameter mxband = max number of radiative bands to be considered for some
!              cloud properties (defined at top of module)
!---------------------------------------------------------------------
 integer, intent(in) :: ix, iy, kx
!      INPUT
!      ------

!      IX, IY, KX   Dimensions for global storage arrays (2- horiz, vert)
!---------------------------------------------------------------------
! Arguments (Intent out)
!---------------------------------------------------------------------
 integer, intent(out) :: ierr

!      OUTPUT
!      ------

!      IERR     Error flag

!---------------------------------------------------------------------
!  (Intent local)
!---------------------------------------------------------------------
 integer  unit, io, ierrnml, logunit
 integer  id_restart
 character(len=32) :: fname

!=====================================================================


!---------------------------------------------------------------------
! --- Read namelist
!---------------------------------------------------------------------

#ifdef INTERNAL_FILE_NML
   read (input_nml_file, nml=diag_cloud_nml, iostat=io)
   ierr = check_nml_error(io,"diag_cloud_nml")
#else
  if( FILE_EXIST( 'input.nml' ) ) then
! -------------------------------------
    unit = open_namelist_file ('input.nml')
    ierrnml = 1
    do while( ierrnml .ne. 0 )
      READ ( unit,  nml = diag_cloud_nml, iostat = io, end = 10 ) 
      ierrnml = check_nml_error(io,'diag_cloud_nml')
    end do
10  call close_file (unit)
! -------------------------------------
  end if
#endif

!---------------------------------------------------------------------
! --- Output namelist
!---------------------------------------------------------------------

  logunit = stdlog()
  if ( mpp_pe() == mpp_root_pe() ) then
    call write_version_number(version, tagname)
    write (logunit, nml=diag_cloud_nml)
  endif     

!---------------------------------------------------------------------
! --- Allocate storage for global cloud quantities
!---------------------------------------------------------------------


  allocate( temp_sum(ix,iy,kx),qmix_sum(ix,iy,kx),rhum_sum(ix,iy,kx) )
  allocate( qmix_sum2(ix,iy) )
  allocate( omega_sum(ix,iy,kx),lgscldelq_sum(ix,iy,kx),cnvcntq_sum(ix,iy,kx) )
  allocate( convprc_sum(ix,iy),nsum(ix,iy), nsum2(ix,iy) )

! need to set up to account for first radiation step without having
! diag cloud info available (radiation called before diag_cloud, and
! diag_cloud being initiated (cold-started) in this job). 

      tot_pts = ix*iy
!---------------------------------------------------------------------
!---------- initialize for cloud averaging -------------------------
!---------------------------------------------------------------------

  fname = 'diag_cloud.res.nc'
  id_restart = register_restart_field(Dia_restart, fname, 'nsum', nsum, no_domain=.true.)
  id_restart = register_restart_field(Dia_restart, fname, 'temp_sum', temp_sum, no_domain=.true.)
  id_restart = register_restart_field(Dia_restart, fname, 'qmix_sum', qmix_sum, no_domain=.true.)
  id_restart = register_restart_field(Dia_restart, fname, 'rhum_sum', rhum_sum, no_domain=.true.)
  id_restart = register_restart_field(Dia_restart, fname, 'omega_sum', omega_sum, no_domain=.true.)
  id_restart = register_restart_field(Dia_restart, fname, 'lgscldelq_sum', lgscldelq_sum, no_domain=.true.)
  id_restart = register_restart_field(Dia_restart, fname, 'cnvcntq_sum', cnvcntq_sum, no_domain=.true.)
  id_restart = register_restart_field(Dia_restart, fname, 'convprc_sum', convprc_sum, no_domain=.true.)

  if( FILE_EXIST( 'INPUT/diag_cloud.res.nc' ) ) then
     if(mpp_pe() == mpp_root_pe() ) call error_mesg ('diag_cloud_mod', &
          'Reading netCDF formatted restart file: INPUT/diag_cloud.res.nc', NOTE)
     call restore_state(Dia_restart)
     nsum2 = nsum
     qmix_sum2(:,:) = qmix_sum(:,:,size(qmix_sum,3))
     ierr = 0
     num_pts = tot_pts
  else if( FILE_EXIST( 'INPUT/diag_cloud.res' ) ) then
      call error_mesg ( 'diag_cloud_mod', 'Native restart capability has been removed.', &
                                         FATAL)
  else

      ierr = 1
      if (mpp_pe() == mpp_root_pe() ) write (logunit,12)
  12  format ('*** WARNING *** No cloud_tg restart file found ***  ' )

      nsum = 0
      nsum2 = 0
      temp_sum = 0.0
      qmix_sum = 0.0
      qmix_sum2 = 0.0
      rhum_sum = 0.0
      omega_sum = 0.0
      lgscldelq_sum = 0.0
      cnvcntq_sum = 0.0
      convprc_sum = 0.0

      num_pts = 0

  end if





!-------------------------------------------------------------------
! initialize zonal cloud routine for climatological zonal mean cloud info
! Passing the number 5 as the argument to cloud_zonal_init initializes the 
! clim zonal clouds allowing seasonal variation

       call cloud_zonal_init (5)

! initialize shallow convection for shallow convective clouds
       call shallow_conv_init( kx )

! Initialize cloud optical and radiative properties scheme 
      if (.not. do_crad_init) then
         call diag_cloud_rad_init (do_crad_init)
      endif
  do_cpred_init = .true.
  module_is_initialized = .true.

 
!=====================================================================
  end SUBROUTINE DIAG_CLOUD_INIT

!#######################################################################

  SUBROUTINE DIAG_CLOUD_END

!=======================================================================
! local
!=======================================================================

  if (mpp_pe() == mpp_root_pe()) then
     call error_mesg ('diag_cloud_mod', 'Writing netCDF formatted restart file: RESTART/diag_cloud.res.nc', NOTE)
  endif
  call diag_cloud_restart

  module_is_initialized = .false.
 
!=====================================================================
  end SUBROUTINE DIAG_CLOUD_END

!#######################################################################
! <SUBROUTINE NAME="diag_cloud_restart">
!
! <DESCRIPTION>
! write out restart file.
! Arguments: 
!   timestamp (optional, intent(in)) : A character string that represents the model time, 
!                                      used for writing restart. timestamp will append to
!                                      the any restart file name as a prefix. 
! </DESCRIPTION>
!
subroutine diag_cloud_restart(timestamp)
  character(len=*), intent(in), optional :: timestamp

  call save_restart(Dia_restart, timestamp)

end subroutine diag_cloud_restart
! </SUBROUTINE> NAME="diag_cloud_restart"

!#######################################################################

 function do_diag_cloud ( ) result (answer)
   logical :: answer

!  returns logical value for whether diag_cloud has been initialized
!  presumably if initialized then diag_cloud will be used

   answer = do_cpred_init

 end function do_diag_cloud

!#######################################################################

 SUBROUTINE DIAG_CLOUD_SUM (is,js, &
                    temp,qmix,rhum,omega,lgscldelq,cnvcntq,convprc,kbot)

!-----------------------------------------------------------------------
 integer, intent(in)                 :: is,js
 real, intent(in), dimension (:,:,:) ::  temp,qmix,rhum,omega
 real, intent(in), dimension (:,:,:) ::  lgscldelq,cnvcntq
 real, intent(in), dimension (:,:)   ::  convprc

 integer, intent(in), OPTIONAL, dimension(:,:) :: kbot

!      INPUT
!      ------

!      IS,JS    starting i,j indices from the full horizontal grid
!      TEMP     Temperature (Deg K) at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      QMIX     Mixing Ratio at full model levels 
!                   (dimensioned IDIM x JDIM x kx)
!      RHUM     Relative humidity fraction at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      OMEGA  Pressure vertical velocity at full model levels
!                   (dimensioned IDIM x JDIM x kx)
!      LGSCLDELQ  Averaged rate of change in mix ratio due to lg scale precip 
!               at full model levels  
!               (dimensioned IDIM x JDIM x kx)
!      CNVCNTQ  Accumulated count of change in mix ratio due to conv precip 
!               at full model levels  
!               (dimensioned IDIM x JDIM x kx)
!      convprc Accumulated conv precip rate summed over all
!               full model levels (mm/day )
!               (dimensioned IDIM x JDIM)
!      KBOT      OPTIONAL; lowest model level index array
!                   (dimensioned IDIM x JDIM)
! ******* kbot will be used to select only those qmix values that are really
! ******* needed (typically this will be the bottom level except for 
! ******* step mountains
!-----------------------------------------------------------------------
   integer :: ie, je

   ie = is + size(rhum,1) - 1
   je = js + size(rhum,2) - 1

!--------- use time-averaged or instantaneous clouds -----------

   if (do_average) then
      nsum(is:ie,js:je)   =  nsum(is:ie,js:je)   +  1
      nsum2(is:ie,js:je)   =  nsum2(is:ie,js:je)   +  1
      temp_sum(is:ie,js:je,:) = temp_sum(is:ie,js:je,:) + temp(:,:,:)
      qmix_sum(is:ie,js:je,:) = qmix_sum(is:ie,js:je,:) + qmix(:,:,:)
      qmix_sum2(is:ie,js:je) = qmix_sum2(is:ie,js:je) + qmix(:,:,size(qmix,3))
      rhum_sum(is:ie,js:je,:) = rhum_sum(is:ie,js:je,:) + rhum(:,:,:)
      omega_sum(is:ie,js:je,:) = omega_sum(is:ie,js:je,:) + omega(:,:,:)
      lgscldelq_sum(is:ie,js:je,:) = lgscldelq_sum(is:ie,js:je,:) &
                                   + lgscldelq(:,:,:)
      cnvcntq_sum(is:ie,js:je,:) = cnvcntq_sum(is:ie,js:je,:) + cnvcntq(:,:,:)
      convprc_sum(is:ie,js:je) = convprc_sum(is:ie,js:je) + convprc(:,:)
   else
      nsum(is:ie,js:je)   =  1
      nsum2(is:ie,js:je)   =  1
      temp_sum(is:ie,js:je,:) = temp(:,:,:)
      qmix_sum(is:ie,js:je,:) = qmix(:,:,:)
      qmix_sum2(is:ie,js:je) = qmix(:,:,size(qmix,3))
      rhum_sum(is:ie,js:je,:) = rhum(:,:,:)
      omega_sum(is:ie,js:je,:) = omega(:,:,:)
      lgscldelq_sum(is:ie,js:je,:) = lgscldelq(:,:,:)
      cnvcntq_sum(is:ie,js:je,:) = cnvcntq(:,:,:)
      convprc_sum(is:ie,js:je) = convprc(:,:)
   endif

!-----------------------------------------------------------------------

 end SUBROUTINE DIAG_CLOUD_SUM

!#######################################################################

 subroutine DIAG_CLOUD_AVG (is, js, temp,qmix,rhum,omega, &
                           lgscldelq,cnvcntq,convprc,      ierr)

!-----------------------------------------------------------------------
   integer, intent(in)                    :: is, js
      real, intent(inout), dimension(:,:,:) :: temp,qmix,rhum,omega
      real, intent(inout), dimension(:,:,:) :: lgscldelq,cnvcntq
      real, intent(inout), dimension(:,:)   :: convprc
   integer, intent(out)                   :: ierr
!-----------------------------------------------------------------------
   integer ::ie, je, num, k
!-----------------------------------------------------------------------

   if (size(rhum,3) .ne. size(rhum_sum,3)) call error_mesg ( &
                               'diag_cloud_avg in diag_cloud_mod',  &
                               'input argument has the wrong size',2)

   ie = is + size(rhum,1) - 1
   je = js + size(rhum,2) - 1
   num = count(nsum(is:ie,js:je) == 0)

   if (num > 0) then

!     ----- no average, return error flag -----

!!!    call error_mesg ('diag_cloud_avg in diag_cloud_mod',  &
!!!                     'dividing by a zero counter', 2)
       ierr = 1

   else

!      ----- compute average -----

       do k = 1, size(rhum,3)
          temp(:,:,k) = temp_sum(is:ie,js:je,k) / float(nsum(is:ie,js:je))
          qmix(:,:,k) = qmix_sum(is:ie,js:je,k) / float(nsum(is:ie,js:je))
          rhum(:,:,k) = rhum_sum(is:ie,js:je,k) / float(nsum(is:ie,js:je))
          omega(:,:,k) = omega_sum(is:ie,js:je,k) / float(nsum(is:ie,js:je))
          lgscldelq(:,:,k) = lgscldelq_sum(is:ie,js:je,k) / &
                             float(nsum(is:ie,js:je))
       enddo
          convprc(:,:) = convprc_sum(is:ie,js:je) / &
                             float(nsum(is:ie,js:je))

! The convective delta qmix count should be a sum, so no average is taken
          cnvcntq(:,:,:) = cnvcntq_sum(is:ie,js:je,:) 

       ierr = 0

   endif

    nsum(is:ie,js:je)   = 0
   temp_sum(is:ie,js:je,:) = 0.0
   qmix_sum(is:ie,js:je,:) = 0.0
   rhum_sum(is:ie,js:je,:) = 0.0
   omega_sum(is:ie,js:je,:) = 0.0
   lgscldelq_sum(is:ie,js:je,:) = 0.0
   cnvcntq_sum(is:ie,js:je,:) = 0.0
   convprc_sum(is:ie,js:je) = 0.0
     
!-----------------------------------------------------------------------

 end SUBROUTINE DIAG_CLOUD_AVG

!#######################################################################

 subroutine DIAG_CLOUD_AVG2 (is, js, qmix, ierr)

!-----------------------------------------------------------------------
   integer, intent(in)                    :: is, js
      real, intent(inout), dimension(:,:) :: qmix
   integer, intent(out)                   :: ierr
!-----------------------------------------------------------------------
   integer ::ie, je, num
!-----------------------------------------------------------------------

!  if (size(qmix,3) .ne. size(qmix_sum2,3)) call error_mesg ( &
!                              'diag_cloud_avg in diag_cloud_mod',  &
!                              'input argument has the wrong size',2)

   ie = is + size(qmix,1) - 1
   je = js + size(qmix,2) - 1
   num = count(nsum2(is:ie,js:je) == 0)

   if (num > 0) then

!     ----- no average, return error flag -----

!!!    call error_mesg ('diag_cloud_avg in diag_cloud_mod',  &
!!!                     'dividing by a zero counter', 2)
       ierr = 1

   else

!      ----- compute average -----

          qmix(:,:) = qmix_sum2(is:ie,js:je) / float(nsum2(is:ie,js:je))

       ierr = 0

   endif

    nsum2(is:ie,js:je)   = 0
   qmix_sum2(is:ie,js:je) = 0.0
     
!-----------------------------------------------------------------------

 end SUBROUTINE DIAG_CLOUD_AVG2

!#######################################################################


end MODULE DIAG_CLOUD_MOD

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: turbulence: its all in here \ldots \label{sec:turbulence}
!
! !INTERFACE:
   module turbulence
!
! !DESCRIPTION:
! In this module, variables of the turbulence model and some
! member functions to manipulate them are defined. The key-functions
! are {\tt init\_turbulence()}, which initialises the model, and
! {\tt do\_turbulence()}, which manages the time step for the
! whole procedure. These two functions are the only `public' member
! functions i.e.\ they are callable from outside the module.
! There are many more internal functions, for
! which descriptions are provided seperately.
!
! It should be pointed out that the turbulence module of GOTM may be used in
! combination with virtually any shallow-wate 3-D circulation model
! using a structured grid in the vertical direction.
! To this end, a clear interface separating the mean flow and the turbulence
! part of GOTM is required. Vertical columns of the three-dimensional fields have
! to copied into one-dimensional vectors, which are passed to GOTM. With the help
! of this information, GOTM updates the turbulent fields and returns one-dimensional
! vectors of the turbulent diffusivities and/or the turbulent fluxes to the 3-D model.
! The `door' between the 3-D model and GOTM is the function {\tt do\_turbulence()},
! which has been designed with these ideas in mind.
!
!
! !USES:
   use mpp_mod, only: mpp_pe, mpp_root_pe
   IMPLICIT NONE

!  default: all is private.
   private
!
! !PUBLIC MEMBER FUNCTIONS:
   public init_turbulence, do_turbulence
   public k_bc,q2over2_bc,epsilon_bc,psi_bc,q2l_bc
   public clean_turbulence
#ifdef _PRINTSTATE_
   public print_state_turbulence
#endif

! !PUBLIC DATA MEMBERS:
!  TKE, rate of dissipation, turbulent length-scale
   REALTYPE, public, dimension(:), allocatable   :: tke,eps,L

!  TKE at old time level
   REALTYPE, public, dimension(:), allocatable   :: tkeo

!  buoyancy variance and its destruction
   REALTYPE, public, dimension(:), allocatable   :: kb,epsb

!  shear and buoyancy production
!  of tke and buoyancy variance
   REALTYPE, public, dimension(:), allocatable   :: P,B,Pb

!  turbulent diffusivities
!  of momentum, temperature, salinity
   REALTYPE, public, dimension(:), allocatable   :: num,nuh,nus

!  non-local fluxes of momentum
   REALTYPE, public, dimension(:), allocatable   :: gamu,gamv

!  non-local fluxes
!  of buoyancy, temperature, salinity
   REALTYPE, public, dimension(:), allocatable   :: gamb,gamh,gams

!  non-dimensional  stability functions
   REALTYPE, public, dimension(:), allocatable   :: cmue1,cmue2

!  non-dimensional counter-gradient term
   REALTYPE, public, dimension(:), allocatable   :: gam

!  alpha_M, alpha_N, and alpha_B
   REALTYPE, public, dimension(:), allocatable   :: as,an,at

!  time scale ratio r
   REALTYPE, public, dimension(:), allocatable   :: r

!  the gradient Richardson number
   REALTYPE, public, dimension(:), allocatable   :: Rig

!  the flux Richardson number
   REALTYPE, public, dimension(:), allocatable   :: xRf

!  turbulent velocity variances
   REALTYPE, public, dimension(:), allocatable   :: uu,vv,ww

# ifdef EXTRA_OUTPUT

!  dummies for testing
   REALTYPE, public, dimension(:), allocatable   :: turb1,turb2,turb3,turb4,turb5

# endif

!  some additional constants
   REALTYPE, public                              :: cm0,cmsf,cde,rcm, b1

!  Prandtl-number in neutrally stratified flow
   REALTYPE, public                              :: Prandtl0

!  parameters for wave-breaking
   REALTYPE, public                              :: craig_m,sig_e0

!  the 'turbulence' namelist
   integer, public                               :: turb_method
   integer, public                               :: tke_method
   integer, public                               :: len_scale_method
   integer, public                               :: stab_method

!  the 'bc' namelist
   integer, public                               :: k_ubc
   integer, public                               :: k_lbc
   integer, public                               :: kb_ubc
   integer, public                               :: kb_lbc
   integer, public                               :: psi_ubc
   integer, public                               :: psi_lbc
   integer, public                               :: ubc_type
   integer, public                               :: lbc_type

!  the 'turb_param' namelist
   REALTYPE, public                              :: cm0_fix
   REALTYPE, public                              :: Prandtl0_fix
   REALTYPE, public                              :: cw
   logical                                       :: compute_kappa
   REALTYPE, public                              :: kappa
   logical                                       :: compute_c3
   REALTYPE                                      :: ri_st
   logical,  public                              :: length_lim
   REALTYPE, public                              :: galp
   REALTYPE, public                              :: const_num
   REALTYPE, public                              :: const_nuh
   REALTYPE, public                              :: k_min
   REALTYPE, public                              :: eps_min
   REALTYPE, public                              :: kb_min
   REALTYPE, public                              :: epsb_min

!  the 'generic' namelist
   logical                                       :: compute_param
   REALTYPE, public                              :: gen_m
   REALTYPE, public                              :: gen_n
   REALTYPE, public                              :: gen_p
   REALTYPE, public                              :: cpsi1
   REALTYPE, public                              :: cpsi2
   REALTYPE, public                              :: cpsi3minus
   REALTYPE, public                              :: cpsi3plus
   REALTYPE                                      :: sig_kpsi
   REALTYPE, public                              :: sig_psi
   REALTYPE                                      :: gen_d
   REALTYPE                                      :: gen_alpha
   REALTYPE                                      :: gen_l

!  the 'keps' namelist
   REALTYPE, public                              :: ce1
   REALTYPE, public                              :: ce2
   REALTYPE, public                              :: ce3minus
   REALTYPE, public                              :: ce3plus
   REALTYPE, public                              :: sig_k
   REALTYPE, public                              :: sig_e
   logical,  public                              :: sig_peps

!  the 'my' namelist
   REALTYPE, public                              :: e1
   REALTYPE, public                              :: e2
   REALTYPE, public                              :: e3
   REALTYPE, public                              :: sq
   REALTYPE, public                              :: sl
   integer,  public                              :: my_length
   logical,  public                              :: new_constr

!  the 'scnd' namelist
   integer                                       ::  scnd_method
   integer                                       ::  kb_method
   integer                                       ::  epsb_method
   integer                                       ::  scnd_coeff
   REALTYPE ,public                              ::  cc1
   REALTYPE, public                              ::  ct1,ctt
   REALTYPE, public                              ::  cc2,cc3,cc4,cc5,cc6
   REALTYPE, public                              ::  ct2,ct3,ct4,ct5

!  the a_i's for the ASM
   REALTYPE, public                              ::  a1,a2,a3,a4,a5
   REALTYPE, public                              ::  at1,at2,at3,at4,at5


!  the 'iw' namelist
   integer,  public                              :: iw_model
   REALTYPE, public                              :: alpha
   REALTYPE, public                              :: klimiw
   REALTYPE, public                              :: rich_cr
   REALTYPE, public                              :: numiw
   REALTYPE, public                              :: nuhiw
   REALTYPE, public                              :: numshear
!
! !DEFINED PARAMETERS:

!  general outline of the turbulence model
   integer, parameter, public                    :: convective=0
   integer, parameter, public                    :: algebraic=1
   integer, parameter, public                    :: first_order=2
   integer, parameter, public                    :: second_order=3

!  method to update TKE
   integer, parameter, public                    :: tke_local_eq=1
   integer, parameter, public                    :: tke_keps=2
   integer, parameter, public                    :: tke_MY=3

!  stability functions
   integer, parameter, public                    :: Constant=1
   integer, parameter, public                    :: MunkAnderson=2
   integer, parameter, public                    :: SchumGerz=3
   integer, parameter, public                    :: EiflerSchrimpf=4

!  method to update length scale
   integer, parameter                            :: Parabola=1
   integer, parameter                            :: Triangle=2
   integer, parameter                            :: Xing=3
   integer, parameter                            :: RobertOuellet=4
   integer, parameter                            :: Blackadar=5
   integer, parameter                            :: BougeaultAndre=6
   integer, parameter                            :: ispra_length=7
   integer, parameter, public                    :: diss_eq=8
   integer, parameter, public                    :: length_eq=9
   integer, parameter, public                    :: generic_eq=10

!  boundary conditions
   integer, parameter, public                    :: Dirichlet=0
   integer, parameter, public                    :: Neumann=1
   integer, parameter, public                    :: viscous=0
   integer, parameter, public                    :: logarithmic=1
   integer, parameter, public                    :: injection=2

!  type of second-order model
   integer, parameter                            :: quasiEq=1
   integer, parameter                            :: weakEqKbEq=2
   integer, parameter                            :: weakEqKb=3

!  method to solve equation for k_b
   integer, parameter                            :: kb_algebraic=1
   integer, parameter                            :: kb_dynamic=2

!  method to solve equation for epsilon_b
   integer, parameter                            :: epsb_algebraic=1
   integer, parameter                            :: epsb_dynamic=2

!
! !BUGS:
!        The algebraic equation for the TKE is not safe
!        to use at the moment. Use it only in connection
!        with the prescribed length-scale profiles. The
!        functions report_model() will report wrong things
!        for the algebraic TKE equation. To be fixed with
!        the next version.
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding, Hans Burchard,
!                      Manuel Ruiz Villarreal,
!                      Lars Umlauf

!
!  $Log: turbulence.F90,v $
!  Revision 20.0  2013/12/14 00:13:54  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:54  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.19  2010-09-17 12:53:52  jorn
!  extensive code clean-up to ensure proper initialization and clean-up of all variables
!
!  Revision 1.18  2007-07-23 11:28:39  hb
!  cw for Craig-Banner wave breaking from namelist now used in fk_craig.F90
!
!  Revision 1.17  2007-01-06 11:49:15  kbk
!  namelist file extension changed .inp --> .nml
!
!  Revision 1.16  2006-11-24 15:13:41  kbk
!  de-allocate memory and close open files
!
!  Revision 1.15  2005/11/15 11:35:02  lars
!  documentation finish for print
!
!  Revision 1.14  2005/09/13 10:00:54  kbk
!  init_turbulence() now prints version - obtained from Makefile
!
!  Revision 1.13  2005/08/11 13:00:15  lars
!  Added explicit interface for xP. Bug found by Vicente Fernandez.
!
!  Revision 1.12  2005/07/19 16:46:14  hb
!  removed superfluous variables - NNT, NNS, SSU, SSV
!
!  Revision 1.11  2005/07/19 16:33:22  hb
!  moved  variances() from do_turbulence() to time_loop()
!
!  Revision 1.10  2005/07/12 10:13:22  hb
!  dependence of init_turbulence from depth, z0s, z0b removed
!
!  Revision 1.9  2005/07/06 14:07:17  kbk
!  added KPP, updated documentation, new structure of turbulence module
!
!  Revision 1.7  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.6  2003/03/28 08:20:01  kbk
!  removed tabs
!
!  Revision 1.5  2003/03/10 09:02:06  gotm
!  Added new Generic Turbulence Model +
!  improved documentation and cleaned up code
!
!
!  Revision 1.3  2001/11/27 19:42:58  gotm
!  Cleaned
!
!  Revision 1.2  2001/11/18 16:15:30  gotm
!  New generic two-equation model
!
!  Revision 1.1.1.1  2001/02/12 15:55:58  gotm
!  initial import into CVS
!EOP
!-----------------------------------------------------------------------

   contains

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Initialise the turbulence module
!
! !INTERFACE:
   subroutine init_turbulence(namlst,fn,nlev)
!
! !DESCRIPTION:
! Initialises all turbulence related stuff. This routine reads a number
! of namelists and allocates memory for turbulence related vectors.
! The core consists of calls to the the internal functions
! {\tt generate\_model()} and {\tt analyse\_model()}, discussed in
! great detail in \sect{sec:generate} and \sect{sec:analyse}, respectively.
! The former function computes the model coefficients for the generic two-equation
! model (see \cite{Umlaufetal2003}) from physically motivated quantities
! like the von K{\'a}rm{\'a}n constant, $\kappa$, the decay rate in homogeneous
! turbulence, $d$, the steady-state Richardson number, $Ri_{st}$,
! and many others. The latter function does the inverse:
! it computes the physically motivated quantities from the model constants
! of any model currently available in GOTM.
! After the call to either function, all relevant model parameters
! are known to GOTM.
! Then, the function {\tt report\_model()} is called, which displays all
! results on the screen.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer,          intent(in)        :: namlst
   character(len=*), intent(in)        :: fn
   integer,          intent(in)        :: nlev
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding, Hans Burchard,
!                      Manuel Ruiz Villarreal,
!                      Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
   integer                            :: rc
   REALTYPE                           :: L_min
!
   namelist /turbulence/    turb_method,tke_method,            &
                            len_scale_method,stab_method

   namelist /bc/            k_ubc,k_lbc,kb_ubc,kb_lbc,         &
                            psi_ubc,psi_lbc,                   &
                            ubc_type,lbc_type

   namelist /turb_param/    cm0_fix,Prandtl0_fix,cw,           &
                            compute_kappa,kappa,               &
                            compute_c3,ri_st,length_lim,galp,  &
                            const_num,const_nuh,k_min,eps_min, &
                            kb_min,epsb_min

   namelist /generic/       compute_param,gen_m,gen_n,gen_p,   &
                            cpsi1,cpsi2,cpsi3minus,cpsi3plus,  &
                            sig_kpsi,sig_psi,                  &
                            gen_d,gen_alpha,gen_l

   namelist /keps/          ce1,ce2,ce3minus,ce3plus,sig_k,    &
                            sig_e,sig_peps

   namelist /my/            e1,e2,e3,sq,sl,my_length,new_constr

   namelist /scnd/          scnd_method,kb_method,epsb_method, &
                            scnd_coeff,                        &
                            cc1,cc2,cc3,cc4,cc5,cc6,           &
                            ct1,ct2,ct3,ct4,ct5,ctt

   namelist /iw/            iw_model,alpha,klimiw,rich_cr,     &
                            numiw,nuhiw,numshear
!
!-----------------------------------------------------------------------
!BOC
   if(mpp_pe() == mpp_root_pe()) then
   LEVEL1 'init_turbulence: v',RELEASE
   endif

   a1 = _ZERO_
   a2 = _ZERO_
   a3 = _ZERO_
   a4 = _ZERO_
   a5 = _ZERO_

   at1 = _ZERO_
   at2 = _ZERO_
   at3 = _ZERO_
   at4 = _ZERO_
   at5 = _ZERO_

   cm0 = _ZERO_
   cmsf = _ZERO_
   cde = _ZERO_
   rcm = _ZERO_
   b1 = _ZERO_

!  Prandtl-number in neutrally stratified flow
   Prandtl0 = _ZERO_

!  parameters for wave-breaking
   craig_m = _ZERO_
   sig_e0 = _ZERO_

   ! Initialize all namelist variables to reasonable defaults.
   turb_method=2
   tke_method=2
   len_scale_method=8
   stab_method=3

!  the 'bc' namelist
   k_ubc=1
   k_lbc=1
   kb_ubc=1
   kb_lbc=1
   psi_ubc=1
   psi_lbc=1
   ubc_type=1
   lbc_type=1

!  the 'turb_param' namelist
   cm0_fix=0.5477
   Prandtl0_fix=0.74
   cw=100.0
   compute_kappa=.false.
   kappa=0.4
   compute_c3=.false.
   ri_st=0.25
   length_lim=.false.
   galp=0.53
   const_num=5.0e-4
   const_nuh=5.0e-4
   k_min=1.0e-8
   eps_min=1.0e-12
   kb_min=1.0e-8
   epsb_min=1.0e-12

!  the 'generic' namelist
   compute_param=.false.
   gen_m=1.5
   gen_n=-1.0
   gen_p=3.0
   cpsi1=1.44
   cpsi2=1.92
   cpsi3minus=0.0
   cpsi3plus=1.0
   sig_kpsi=1.0
   sig_psi=1.3
   gen_d=-1.2
   gen_alpha=-2.0
   gen_l=0.2

!  the 'keps' namelist
   ce1=1.44
   ce2=1.92
   ce3minus=0.0
   ce3plus=1.0
   sig_k=1.0
   sig_e=1.3
   sig_peps=.false.

!  the 'my' namelist
   e1=1.8
   e2=1.33
   e3=1.8
   sq=0.2
   sl=0.2
   my_length=1
   new_constr=.false.

!  the 'scnd' namelist
   scnd_method = 0
   kb_method   = 0
   epsb_method = 0
   scnd_coeff  = 0
   cc1 = _ZERO_
   ct1 = _ZERO_
   ctt = _ZERO_
   cc2 = _ZERO_
   cc3 = _ZERO_
   cc4 = _ZERO_
   cc5 = _ZERO_
   cc6 = _ZERO_
   ct2 = _ZERO_
   ct3 = _ZERO_
   ct4 = _ZERO_
   ct5 = _ZERO_

!  the 'iw' namelist
   iw_model=0
   alpha=0.0
   klimiw=1e-6
   rich_cr=0.7
   numiw=1.e-4
   nuhiw=5.e-5
   numshear=5.e-3

   ! read the variables from the namelist file

   open(namlst,file=fn,status='old',action='read',err=80)

   if(mpp_pe() == mpp_root_pe()) then
   LEVEL2 'reading turbulence namelists..'
   endif

   read(namlst,nml=turbulence,err=81)

   if (turb_method.eq.99) then
      close (namlst)
      if(mpp_pe() == mpp_root_pe()) then
      LEVEL2 'done.'
      LEVEL1 'done.'
      endif
      return
   else
      read(namlst,nml=bc,err=82)
      read(namlst,nml=turb_param,err=83)
      read(namlst,nml=generic,err=84)
      read(namlst,nml=keps,err=85)
      read(namlst,nml=my,err=86)
      read(namlst,nml=scnd,err=87)
      read(namlst,nml=iw,err=88)
      close (namlst)
      if(mpp_pe() == mpp_root_pe()) then
      LEVEL2 'done.'
      endif
   endif


!  allocate memory

   if(mpp_pe() == mpp_root_pe()) then
    LEVEL2 'allocation memory..'
   endif
   allocate(tke(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (tke)'
   tke = k_min

   allocate(tkeo(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (tkeo)'
   tkeo = k_min

   allocate(eps(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (eps)'
   eps = eps_min

   allocate(L(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (L)'
   L = _ZERO_

   if(mpp_pe() == mpp_root_pe()) then
   LEVEL2 'allocation memory..'
   endif
   allocate(kb(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (kb)'
   kb = kb_min

   if(mpp_pe() == mpp_root_pe()) then
   LEVEL2 'allocation memory..'
   endif
   allocate(epsb(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (epsb)'
   epsb = epsb_min

   allocate(P(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (P)'
   P = _ZERO_

   allocate(B(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (B)'
   B = _ZERO_

   allocate(Pb(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (Pb)'
   Pb = _ZERO_

   allocate(num(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (num)'
   num = 1.0D-6

   allocate(nuh(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (nuh)'
   nuh = 1.0D-6

   allocate(nus(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (nus)'
   nus = 1.0D-6

   allocate(gamu(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (gamu)'
   gamu = _ZERO_

   allocate(gamv(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (gamv)'
   gamv = _ZERO_

   allocate(gamb(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (gamb)'
   gamb = _ZERO_

   allocate(gamh(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (gamh)'
   gamh = _ZERO_

   allocate(gams(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (gams)'
   gams = _ZERO_

   allocate(cmue1(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (cmue1)'
   cmue1 = _ZERO_

   allocate(cmue2(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (cmue2)'
   cmue2 = _ZERO_

   allocate(gam(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (gam)'
   gam = _ZERO_

   allocate(an(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (an)'
   an = _ZERO_

   allocate(as(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (as)'
   as = _ZERO_

   allocate(at(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (at)'
   at = _ZERO_

   allocate(r(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (r)'
   r = _ZERO_

   allocate(Rig(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (Rig)'
   Rig = _ZERO_

   allocate(xRf(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (xRf)'
   xRf = _ZERO_

   allocate(uu(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (uu)'
   uu = _ZERO_

   allocate(vv(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (vv)'
   vv = _ZERO_

   allocate(ww(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (ww)'
   ww = _ZERO_

# ifdef EXTRA_OUTPUT

   allocate(turb1(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (turb1)'
   turb1 = _ZERO_

   allocate(turb2(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (turb2)'
   turb2 = _ZERO_

   allocate(turb3(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (turb3)'
   turb3 = _ZERO_

   allocate(turb4(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (turb4)'
   turb4 = _ZERO_

   allocate(turb5(0:nlev),stat=rc)
   if (rc /= 0) stop 'init_turbulence: Error allocating (turb5)'
   turb5 = _ZERO_

# endif

   if(mpp_pe() == mpp_root_pe()) then
   LEVEL2 'done.'
   endif


!  initialize the parameters of the second-order closure
   if (turb_method.eq.second_order) then
      call init_scnd(scnd_coeff)
   end if

!  cm0 (the value in the log-layer) and cmsf (the shear-free value)
!  are set by the stability functions
   call compute_cm0(turb_method,stab_method,scnd_method)

!  compute auxiliary constants
   cde  = cm0**3.
   rcm  = cm0/cmsf

!  cm0 is related to B1 of Mellor and Yamada (1982)
   b1   = 2.**1.5/cde

!  initialise some things
   L_min=cde*k_min**1.5/eps_min
   L=L_min

!  generate or analyse the model constants
   if ((len_scale_method.eq.generic_eq).and.compute_param) then
      call generate_model
   else
      call analyse_model
   endif

!  report on parameters and properties of the model
   call report_model

   return

80 FATAL 'I could not open "gotmturb.nml"'
   stop 'init_turbulence'
81 FATAL 'I could not read "turbulence" namelist'
   stop 'init_turbulence'
82 FATAL 'I could not read "bc" namelist'
   stop 'init_turbulence'
83 FATAL 'I could not read "turb_param" namelist'
   stop 'init_turbulence'
84 FATAL 'I could not read "generic" namelist'
   stop 'init_turbulence'
85 FATAL 'I could not read "keps" namelist'
   stop 'init_turbulence'
86 FATAL 'I could not read "my" namelist'
   stop 'init_turbulence'
87 FATAL 'I could not read "scnd" namelist'
   stop 'init_turbulence'
88 FATAL 'I could not read "iw" namelist'
   stop 'init_turbulence'

 end subroutine init_turbulence
!EOC


!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Initialize the second-order model
!
! !INTERFACE:
   subroutine init_scnd(scnd_coeff)
!
! !DESCRIPTION:
! This subroutine computes the $a_i$'s defined in \eq{bASM} and
! the $a_bi$'s defined in \eq{gammaASM} from the model parameters
! of the pressure redistribution models \eq{Phi} and \eq{Phib}.
! Parameter sets from different authors are converted to the GOTM
! notation according to the relations discussed in \sect{sec:parameterConversion}.
!
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: scnd_coeff

!
! !DEFINED PARAMETERS:
   REALTYPE,  parameter                :: cc1GL78     =  3.6000
   REALTYPE,  parameter                :: cc2GL78     =  0.8000
   REALTYPE,  parameter                :: cc3GL78     =  1.2000
   REALTYPE,  parameter                :: cc4GL78     =  1.2000
   REALTYPE,  parameter                :: cc5GL78     =  0.0000
   REALTYPE,  parameter                :: cc6GL78     =  0.5000
   REALTYPE,  parameter                :: ct1GL78     =  3.0000
   REALTYPE,  parameter                :: ct2GL78     =  0.3333
   REALTYPE,  parameter                :: ct3GL78     =  0.3333
   REALTYPE,  parameter                :: ct4GL78     =  0.0000
   REALTYPE,  parameter                :: ct5GL78     =  0.3333
   REALTYPE,  parameter                :: cttGL78     =  0.8000

   REALTYPE,  parameter                :: cc1MY82     =  6.0000
   REALTYPE,  parameter                :: cc2MY82     =  0.3200
   REALTYPE,  parameter                :: cc3MY82     =  0.0000
   REALTYPE,  parameter                :: cc4MY82     =  0.0000
   REALTYPE,  parameter                :: cc5MY82     =  0.0000
   REALTYPE,  parameter                :: cc6MY82     =  0.0000
   REALTYPE,  parameter                :: ct1MY82     =  3.7280
   REALTYPE,  parameter                :: ct2MY82     =  0.0000
   REALTYPE,  parameter                :: ct3MY82     =  0.0000
   REALTYPE,  parameter                :: ct4MY82     =  0.0000
   REALTYPE,  parameter                :: ct5MY82     =  0.0000
   REALTYPE,  parameter                :: cttMY82     =  0.6102

   REALTYPE,  parameter                :: cc1KC94     =  6.0000
   REALTYPE,  parameter                :: cc2KC94     =  0.3200
   REALTYPE,  parameter                :: cc3KC94     =  0.0000
   REALTYPE,  parameter                :: cc4KC94     =  0.0000
   REALTYPE,  parameter                :: cc5KC94     =  0.0000
   REALTYPE,  parameter                :: cc6KC94     =  0.0000
   REALTYPE,  parameter                :: ct1KC94     =  3.7280
   REALTYPE,  parameter                :: ct2KC94     =  0.7000
   REALTYPE,  parameter                :: ct3KC94     =  0.7000
   REALTYPE,  parameter                :: ct4KC94     =  0.0000
   REALTYPE,  parameter                :: ct5KC94     =  0.2000
   REALTYPE,  parameter                :: cttKC94     =  0.6102

   REALTYPE,  parameter                :: cc1LDOR96   =  3.0000
   REALTYPE,  parameter                :: cc2LDOR96   =  0.8000
   REALTYPE,  parameter                :: cc3LDOR96   =  2.0000
   REALTYPE,  parameter                :: cc4LDOR96   =  1.1180
   REALTYPE,  parameter                :: cc5LDOR96   =  0.0000
   REALTYPE,  parameter                :: cc6LDOR96   =  0.5000
   REALTYPE,  parameter                :: ct1LDOR96   =  3.0000
   REALTYPE,  parameter                :: ct2LDOR96   =  0.3333
   REALTYPE,  parameter                :: ct3LDOR96   =  0.3333
   REALTYPE,  parameter                :: ct4LDOR96   =  0.0000
   REALTYPE,  parameter                :: ct5LDOR96   =  0.3333
   REALTYPE,  parameter                :: cttLDOR96   =  0.8000

   REALTYPE,  parameter                :: cc1CHCD01A  =  5.0000
   REALTYPE,  parameter                :: cc2CHCD01A  =  0.8000
   REALTYPE,  parameter                :: cc3CHCD01A  =  1.9680
   REALTYPE,  parameter                :: cc4CHCD01A  =  1.1360
   REALTYPE,  parameter                :: cc5CHCD01A  =  0.0000
   REALTYPE,  parameter                :: cc6CHCD01A  =  0.4000
   REALTYPE,  parameter                :: ct1CHCD01A  =  5.9500
   REALTYPE,  parameter                :: ct2CHCD01A  =  0.6000
   REALTYPE,  parameter                :: ct3CHCD01A  =  1.0000
   REALTYPE,  parameter                :: ct4CHCD01A  =  0.0000
   REALTYPE,  parameter                :: ct5CHCD01A  =  0.3333
   REALTYPE,  parameter                :: cttCHCD01A  =  0.7200

   REALTYPE,  parameter                :: cc1CHCD01B  =  5.0000
   REALTYPE,  parameter                :: cc2CHCD01B  =  0.6983
   REALTYPE,  parameter                :: cc3CHCD01B  =  1.9664
   REALTYPE,  parameter                :: cc4CHCD01B  =  1.0940
   REALTYPE,  parameter                :: cc5CHCD01B  =  0.0000
   REALTYPE,  parameter                :: cc6CHCD01B  =  0.4950
   REALTYPE,  parameter                :: ct1CHCD01B  =  5.6000
   REALTYPE,  parameter                :: ct2CHCD01B  =  0.6000
   REALTYPE,  parameter                :: ct3CHCD01B  =  1.0000
   REALTYPE,  parameter                :: ct4CHCD01B  =  0.0000
   REALTYPE,  parameter                :: ct5CHCD01B  =  0.3333
   REALTYPE,  parameter                :: cttCHCD01B  =  0.4770

   REALTYPE,  parameter                :: cc1CCH02    =  5.0000
   REALTYPE,  parameter                :: cc2CCH02    =  0.7983
   REALTYPE,  parameter                :: cc3CCH02    =  1.9680
   REALTYPE,  parameter                :: cc4CCH02    =  1.1360
   REALTYPE,  parameter                :: cc5CCH02    =  0.0000
   REALTYPE,  parameter                :: cc6CCH02    =  0.5000
   REALTYPE,  parameter                :: ct1CCH02    =  5.5200
   REALTYPE,  parameter                :: ct2CCH02    =  0.2134
   REALTYPE,  parameter                :: ct3CCH02    =  0.3570
   REALTYPE,  parameter                :: ct4CCH02    =  0.0000
   REALTYPE,  parameter                :: ct5CCH02    =  0.3333
   REALTYPE,  parameter                :: cttCCH02    =  0.8200

   integer, parameter                  :: LIST        = 0
   integer, parameter                  :: GL78        = 1
   integer, parameter                  :: MY82        = 2
   integer, parameter                  :: KC94        = 3
   integer, parameter                  :: LDOR96      = 4
   integer, parameter                  :: CHCD01A     = 5
   integer, parameter                  :: CHCD01B     = 6
   integer, parameter                  :: CCH02       = 7
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
!-----------------------------------------------------------------------
! !LOCAL VARIABLES:
!
!-----------------------------------------------------------------------
!BOC

   select case (scnd_coeff)
   case (LIST)
      !  do nothing, parameters are read from namelist
   case (GL78)
      cc1     =    cc1GL78
      cc2     =    cc2GL78
      cc3     =    cc3GL78
      cc4     =    cc4GL78
      cc5     =    cc5GL78
      cc6     =    cc6GL78
      ct1     =    ct1GL78
      ct2     =    ct2GL78
      ct3     =    ct3GL78
      ct4     =    ct4GL78
      ct5     =    ct5GL78
      ctt     =    cttGL78
   case (MY82)
      cc1     =    cc1MY82
      cc2     =    cc2MY82
      cc3     =    cc3MY82
      cc4     =    cc4MY82
      cc5     =    cc5MY82
      cc6     =    cc6MY82
      ct1     =    ct1MY82
      ct2     =    ct2MY82
      ct3     =    ct3MY82
      ct4     =    ct4MY82
      ct5     =    ct5MY82
      ctt     =    cttMY82
   case (KC94)
      cc1     =    cc1KC94
      cc2     =    cc2KC94
      cc3     =    cc3KC94
      cc4     =    cc4KC94
      cc5     =    cc5KC94
      cc6     =    cc6KC94
      ct1     =    ct1KC94
      ct2     =    ct2KC94
      ct3     =    ct3KC94
      ct4     =    ct4KC94
      ct5     =    ct5KC94
      ctt     =    cttKC94
   case (LDOR96)
      cc1     =    cc1LDOR96
      cc2     =    cc2LDOR96
      cc3     =    cc3LDOR96
      cc4     =    cc4LDOR96
      cc5     =    cc5LDOR96
      cc6     =    cc6LDOR96
      ct1     =    ct1LDOR96
      ct2     =    ct2LDOR96
      ct3     =    ct3LDOR96
      ct4     =    ct4LDOR96
      ct5     =    ct5LDOR96
      ctt     =    cttLDOR96
   case (CHCD01A)
      cc1     =    cc1CHCD01A
      cc2     =    cc2CHCD01A
      cc3     =    cc3CHCD01A
      cc4     =    cc4CHCD01A
      cc5     =    cc5CHCD01A
      cc6     =    cc6CHCD01A
      ct1     =    ct1CHCD01A
      ct2     =    ct2CHCD01A
      ct3     =    ct3CHCD01A
      ct4     =    ct4CHCD01A
      ct5     =    ct5CHCD01A
      ctt     =    cttCHCD01A
   case (CHCD01B)
      cc1     =    cc1CHCD01B
      cc2     =    cc2CHCD01B
      cc3     =    cc3CHCD01B
      cc4     =    cc4CHCD01B
      cc5     =    cc5CHCD01B
      cc6     =    cc6CHCD01B
      ct1     =    ct1CHCD01B
      ct2     =    ct2CHCD01B
      ct3     =    ct3CHCD01B
      ct4     =    ct4CHCD01B
      ct5     =    ct5CHCD01B
      ctt     =    cttCHCD01B
   case (CCH02)
      cc1     =    cc1CCH02
      cc2     =    cc2CCH02
      cc3     =    cc3CCH02
      cc4     =    cc4CCH02
      cc5     =    cc5CCH02
      cc6     =    cc6CCH02
      ct1     =    ct1CCH02
      ct2     =    ct2CCH02
      ct3     =    ct3CCH02
      ct4     =    ct4CCH02
      ct5     =    ct5CCH02
      ctt     =    cttCCH02
   case default
      STDERR '... not a valid parameter set'
      STDERR 'Choose different value for scnd_coeff'
      STDERR 'Program execution stopped ...'
      stop 'turbulence.F90'
   end select


   !  compute the a_i's for the Algebraic Stress Model

   a1   =  2./3. - cc2/2.
   a2   =  1.    - cc3/2.
   a3   =  1.    - cc4/2.
   a4   =          cc5/2.
   a5   =  1./2. - cc6/2.

   at1  =           1. - ct2
   at2  =           1. - ct3
   at3  =  2. *   ( 1. - ct4)
   at4  =  2. *   ( 1. - ct5)
   at5  =  2.*ctt*( 1. - ct5)

   return
 end subroutine init_scnd

!-----------------------------------------------------------------------
!EOC





!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Generate a two-equation model \label{sec:generate}

! !INTERFACE:
   subroutine generate_model
!
! !DESCRIPTION:
! Computes the parameters of an instance of the `generic' two-equation
! model according to the specifications set in {\tt gotmturb.nml}. This model
! solves \eq{tkeA} for the $k$ and \eq{generic} for the generic length-scale
! defined in \sect{sec:genericeq} together with an Algebraic Stress Model. For several
! simple turbulent flows, analytical solutions of this models exist and
! can be used to calibrate the model coefficients. The method is described
! in great detail in \cite{UmlaufBurchard2003}. Also users that are
! not interested in the generic part of GOTM should have a look in
! this section, because results derived here are referenced in later
! parts of the manual.
!
! After the call to {\tt generate\_model()}, all parameters of the generic
! two-equation model are known. The user has full
! control over specific  properties of the resulting model (see \sect{sec:genericeq}).
!
! In the following sections, the effects of model parameters on the behaviour of
! two-equation models in specific situations are briefly reviewed. For a more
! in-depth discussion, see \cite{UmlaufBurchard2003}.
!
! \vspace{10mm}
! {\bf The logarithmic boundary layer}
! \vspace{5mm}
!
! In the logarithmic boundary layer one has $P=\epsilon$ and
! $k\propto u^2_*$ by defintion. Under these conditions it is easy
! to show that a solution of \eq{tkeA} is
! \begin{equation}
!   \label{kLog}
!   k = \dfrac{u_*^2}{(c_\mu^0)^2}
!   \comma
! \end{equation}
! and a solution of \eq{generic} can only be obtained if the condition
! \begin{equation}
!   \label{psiLog}
!   \sigma_\psi = \dfrac{n^2 \kappa^2}{(c_\mu^0)^2 (c_{\psi 2}-c_{\psi 1})}
! \end{equation}
! is satisfied. \eq{kLog} can be conveniently used to obtain boundary conditions
! for $k$, whereas \eq{psiLog} yields for example the value for the turbulent
! Schmidt-number $\sigma_\psi$ as a function of the von K{\'a}rm{\'a}n constant
! (provided, of course, that the other constants are known). The
! value of the von K{\'a}rm{\'a}n constant is usually assumed to be
! $\kappa \approx 0.4$.
!
! \vspace{10mm}
! {\bf Decay of homogeneous turbulence}
! \vspace{5mm}
!
! Another example of a simple but fundamental turbulent situation is the
! temporal decay of isotropic, homogeneous turbulence (approximated by
! the spatial decay of turbulence behind grids in laboratory settings).
! At large times, $t$, data from many experiments are well described by
! a power law of the form
! \begin{equation}
!   \label{decay}
!   \frac{k}{k_0} = A \left( \frac{t}{\tau_0} \right)^d
!   \comma
! \end{equation}
! with constant $A$ and initial values of the kinetic energy, $k_0$, and
! the {\it eddy turnover time}, $\tau_0$. The decay rates, $d$, have
! been thoroughly documented. Experiments (\cite{Bradshaw75},
! \cite{Townsend76}, \cite{DomaradzkiMellor84}, \cite{Mohamed90})
! suggest that $d$ is in the range $-1.3 < d < -1$.  DNS, generally
! conducted at low Reynolds numbers, produce consistently higher values.
! For example, \cite{Briggsetal96} obtain a value near $-1.5$ from their
! DNS.
!
! In homogeneous decaying turbulence, \eq{tkeA} and \eq{generic} reduce
! to a balance between the rate and dissipation terms, respectively. The
! coupled system of ordinary differential equations can be solved for
! given initial values $k_0$ and $\psi_0$ (see e.g.\ \cite{Wilcox98}).
! The solution can be shown to reduce to \eq{decay} at large times.
! Then, the decay exponent, $d$, is determined by
! \begin{equation}
!   \label{d}
!   d = - \frac{2n}{2m+n-2c_{\psi 2}}
!   \comma
! \end{equation}
! and thus depends only on the exponents $m$ and $n$ defined in \eq{psi_l} and
! the model constant $c_{\psi 2}$. For given exponents $m$ and $n$, the
! experimental values of $d$ can be used to derive the value of the
! model constant $c_{\psi 2}$.
! Note, that the predicted decay rate, $d$, is
! completely independent of the ASM (or the stability functions in other
! words).
!
! \vspace{10mm}
! {\bf Homogeneous turbulent shear-flows}
! \vspace{5mm}
!
! A natural extension of decaying homogeneous turbulence is the
! inclusion of a homogeneous shear and an aligned homogeneous
! stratification.  Since turbulence is still assumed to be homogeneous,
! the divergence of any turbulent transport term vanishes and the
! interplay between the stabilizing effects of stratification
! and the destabilizing action of shear can be isolated. Thus, it is not
! surprising that this interesting special case of turbulence has
! been explored extensively by laboratory experiments
! (\cite{TavoularisCorrsin81a,TavoularisCorrsin81b},
! \cite{TavoularisKarnik89}, \cite{Rohretal88}), by Direct Numerical
! Simulation (\cite{Gerzetal89}, \cite{Holtetal92},
! \cite{Jacobitzetal97}, \cite{Shihetal2000}) and by Large-Eddy
! Simulation (\cite{Kaltenbachetal94}).  That flows of this kind are
! crucial also in many oceanographic flows has been pointed out
! by \cite{BaumertPeters2000}.
!
! In the context of the generic two-equation model, this turbulent flow
! is mathematically established by neglecting the turbulent transport
! terms and the advective part of the material time derivative. Then,
! \eq{tkeA} and \eq{generic} reduce to a set of ordinary differential
! equations. Using the chain rule of differentiation, the relation
! \begin{equation}
!   \label{GE_l_chain_rule}
!   \frac{1}{l} \deriv{l}{t} =
!   \frac{1}{n} \frac{1}{\psi} \deriv{\psi}{t} -
!   \frac{m}{n} \frac{1}{k}    \deriv{k}{t}
! \end{equation}
! for the mixing length, $l$, follows immediately from \eq{psi_l}. With
! \eq{GE_l_chain_rule}, the generic model expressed by \eq{tkeA} and
! \eq{generic} can be used to derive an evolution equation for the
! integral length scale, $l$,
! \begin{equation}
!   \label{GE_length_homogeneous}
!   \begin{array}{rcl}
!     \dfrac{1}{l} \deriv{l}{t}
!     &=&
!     - \left( \dfrac{1}{n} c_{\psi_2} - \dfrac{m}{n}  \right) \dfrac{\epsilon}{k}
!     \\[5mm]
!     &+&
!     \dfrac{1}{k}
!     \left(
!       \left( \dfrac{1}{n} c_{\psi_1} - \dfrac{m}{n}  \right) P +
!       \left( \dfrac{1}{n} c_{\psi_3} - \dfrac{m}{n}  \right) G
!     \right)
!     \point
!   \end{array}
! \end{equation}
!
! \cite{Tennekes89} derived an equation similar to
! \eq{GE_length_homogeneous}, however only for the special case of the
! $k$-$\epsilon$ model applied to unstratified flows, and stated that
! \emph{`on dimensional grounds, $l$ cannot depend upon the shear because the
! shear is homogeneous and cannot impose a length scale'}. This argument
! requires immediately
! \begin{equation}
!   \label{c_psi1}
!   c_{\psi 1} = m
!   \comma
! \end{equation}
! which is used in the subroutine to determine the model parameter
! $c_{\psi 1}$. A more detailed discussion of this method is given
! in \cite{UmlaufBurchard2003}.
!
! \vspace{10mm}
! {\bf Shear-free turbulence, wave-breaking}
! \vspace{5mm}
!
! The first step in understanding the behaviour of two-equation models
! in the surface layer affected by breaking gravity waves is the
! investigation of a special case, in which turbulence decays spatially
! away from a planar source {\em without mean shear}.  Turbulence generated by
! an oscillating grid in a water tank has been used in various
! laboratory settings to study the spatial decay of velocity
! fluctuations in this basic turbulent flow, where turbulent transport
! and dissipation balance exactly. For a summary of these results,
! see \cite{Umlaufetal2003}.
!
! All grid stirring experiments confirmed a power
! law for the decay of $k$ and a linear increase of the length scale, $l$,
! according to
! \begin{equation}
!   \label{power_law}
!   k = K (z+z_0)^\alpha \comma l = L(z+z_0)
!   \comma
! \end{equation}
! where $K$, $L$, and $z_0$ are constants, and the source of turbulence
! has been assumed to be at $z=0$.  In these experiments, $z_0 = l / L$
! at $z=0$ is not related to any kind of surface roughness length.
! Rather, it is connected to the length scale of injected turbulence,
! uniquely determined by the spectral properties of turbulence
! at the source. Experiments suggest that the decay rate for the
! turbulent kinetic energy is likely to be in the range $-3<\alpha<-2$. The
! value of $L$, i.e.\ the slope of the turbulent length scale, $l$,
! was found to be consistently smaller than in wall-bounded shear flows,
! $L < \kappa \approx 0.4$, see \cite{Umlaufetal2003}.
!
! In stationary, shear-free, unstratified turbulence, the generic model
! simplifies to a balance between the turbulent transport terms and the
! dissipative terms in \eq{tkeA} and \eq{generic}. Using the definition
! of $\psi$ in \eq{psi_l} and the scaling for the rate of
! dissipation, \eq{epsilon}, the transport and dissipation of $k$ and
! $\psi$ are balanced according to
! \begin{equation}
!   \begin{array}{rcl}
!   \label{GE_shear_free}
!     \frstderiv{z} \left( \dfrac{c_\mu}{\sigma_k^{\psi}}
!       k^{\frac{1}{2}} l  \deriv{k}{z} \right)
!   &=&
!     (c_\mu^0)^3 \dfrac{k^{\frac{3}{2}}}{l}
!   \comma  \\[5mm]
!   \frstderiv{z} \left( \dfrac{c_\mu}{\sigma_{\psi}}
!     k^{\frac{1}{2}} l  \frstderiv{z} \left(  (c_\mu^0)^p k^m l^n \right) \right)
!   &=&
!   c_{\psi 2} (c_\mu^0)^{p+3} k^{m+\frac{1}{2}} l^{n-1}
!   \point
!   \end{array}
! \end{equation}
! Note, that in shear-free turbulence, the shear-number defined in
! \eq{alphaMN} is $\alpha_M=0$ by
! definition, and stability functions always reduce to a constant which
! is, however, different from the constant $c_\mu^0$ approached in the
! logarithmic boundary layer, see \sect{sec:computeCmu}.
!
! For the solution of this non-linear system , we inserted the
! expressions \eq{power_law} in \eq{GE_shear_free}. From \eq{epsilon} and
! \eq{nu}, power-laws follow then also for $\epsilon = E(z+z_0)^\beta$
! and $\nu_t = N (z+z_0)^\gamma$.
!
! Inserting \eq{power_law} into \eq{GE_shear_free}$_1$ yields the
! equation
! \begin{equation}
!   \label{GE_alphaL_1}
!   (\alpha L)^2 = \frac{2}{3}   (c_\mu^0)^2 R \, \sigma_k^\psi
!   \comma
! \end{equation}
! where the constant ratio $R=c_\mu^0/c_\mu$ follows uniquely from the
! respective ASM.  The power-law \eq{power_law} can also be inserted in
! \eq{GE_shear_free}$_2$ to yield
! \begin{equation}
!   \label{GE_alphaL_2}
!   \left( \alpha m + n \right) \left( \left( \dfrac{1}{2}
!     + m \right) \alpha + n \right) L^2
!   =
!   \left(c_\mu^0 \right)^2 R \, \sigma_\psi  c_{\psi 2}
!   \point
! \end{equation}
!
! We note that with the help of \eq{d} and \eq{c_psi1}, the
! relation \eq{psiLog} can be rewritten as
! \begin{equation}
!   \label{psiLog2}
!   \sigma_\psi = \frac{2 \kappa^2 d}{(c_\mu^0)^2 (d+2)} n
!   \point
! \end{equation}
! Expressing now $\sigma_\psi$ with \eq{psiLog2} and $c_{\psi 2}$ with the help
! of \eq{d} on the right hand side of \eq{GE_alphaL_2},
! an equation expressing the exponent $m$ in terms of
! $n$ (or vice-versa) can be obtained. The result for $n$ can be written
! as
! \begin{equation}
!   \label{GE_n}
!   \begin{array}{rcl}
!     n &=& - \dfrac{1}{4 (2+d) (\kappa^2 R - L^2)}
!     \Bigg(
!       4 d \kappa^2 R \,  m - (1+4m) (2+d) \alpha L^2
!       \\
!     &+&
!       \left.  \sqrt{ 8 m (1+2m) (2+d)^2 (\kappa^2 R - L^2) \alpha^2 L^2
!     + \Big( - 4 d \kappa^2 R \ m + (2+d) (1+4m) \alpha L^2   \Big)^2
!        }
!     \right)
!     \point
!   \end{array}
! \end{equation}
!
! After assigning appropriate values for the von K{\'a}rm{\'a}n
! constant, $\kappa$, the decay coefficient of homogeneous turbulence,
! $d$, the spatial decay rate, $\alpha$, and the slope, $L$, an infinite
! number of pairs of $m$ and $n$ satisfying \eq{GE_n} can be derived.
! Each corresponds to a different two-equation model.  Some example are
! given in \tab{tab:alphaL} (see \cite{UmlaufBurchard2003}).
!
! \begin{table}[ht]
!   \begin{center}
!     \begin{tabular}{ccccccc}
!       $\alpha$   &   $L$    &    $m$    &    $n$    &    $c_{\psi 2}$   &   $\sigma_k^\psi$   &     $\sigma_\psi$     \\[2mm] \hline
!       $-2.0$    &  $0.20$   &  $1.00$   &  $-0.67$  &      $1.22$       &       $0.80$        &          $1.07$       \\
!       $-2.0$    &  $0.20$   &  $2.00$   &  $-1.09$  &      $2.36$       &       $0.80$        &          $1.75$       \\[2mm]
! %      $-2.5$    &  $0.20$   &  $0.92$   &  $-1.00$  &      $1.27$       &       $1.25$        &          $1.60$       \\
!       $-2.5$    &  $0.20$   &  $1.00$   &  $-1.05$  &      $1.35$       &       $1.25$        &          $1.68$       \\
!       $-2.5$    &  $0.20$   &  $2.00$   &  $-1.74$  &      $2.58$       &       $1.25$        &          $2.78$       \\
! %      $-2.5$    &  $0.25$   &  $0.19$   &  $-1.00$  &      $0.52$       &       $1.95$        &          $1.60$       \\
!     \end{tabular}
!     \caption{\label{tab:alphaL} Some parameter sets for the generic model with $\kappa = 0.4$,
!       $d = -1.2$, $(c_\mu^0)^2=0.3$, $c_{\psi_1}=m$ and obeying the log-layer
!       compatibility relation \eq{psiLog2}.}
!   \end{center}
! \end{table}
! Even though each line in this table represents a different
! two-equation model with completely different model constants, each of
! the two groups of models (with $\alpha=-2.0$ and $\alpha=-2.5$,
! respectively) {\em performs completely identical in all situations
!   discussed until here.} Thus, the generic model allows for the
! formulation of groups of two-equation models with fully controlled
! properties from the outset. As discussed by \cite{UmlaufBurchard2003},
! one more constraint is necessary to obtain the final values of all
! parameters, including the exponents $m$ and $n$. These authors suggested
! that the first line in \tab{tab:alphaL} yields a model with excellent
! properties in all flows they considered.
!
! \vspace{10mm}
! {\bf Mixed layer deepending}
! \vspace{5mm}
!
! The correct prediction of mixed layer deepening into a stratified
! fluid due to a wind stress at the surface is one of the most crucial
! requirements for an oceanic turbulence model. This situation has been
! frequently interpreted by analogy with the classical experiment of
! \cite{KatoPhillips69} and its re-interpretation by \cite{Price79}, in
! which the entrainment in a linearly stratified fluid subject to a
! constant surface stress was investigated. The results of this
! experiment have been used by numerous authors to calibrate their
! turbulence models.
!
! In particular, it has been shown by \cite{BurchardBolding2001} for the
! $k$-$\epsilon$ model of \cite{Rodi87}, by \cite{Burchard2001c} for the
! $q^2 l$ model of \cite{MellorYamada82}, and by \cite{Umlaufetal2003}
! for the $k$-$\omega$ model of \cite{Wilcox88} that, remarkably, the mixed
! layer depth predicted by these models depends almost exclusively on
! the value of the Richardson number, $Ri=N^2/M^2$, computed in a {\em
!   homogeneous}, stratified shear-flow in steady-state. This value is
! usually referred to as the steady-state Richardson number, $Ri_{st}$
! (\cite{Rohretal88}, \cite{Kaltenbachetal94}, \cite{Jacobitzetal97},
! \cite{Shihetal2000}).
!
! \cite{Umlaufetal2003} showed that in the context of models considered
! in GOTM, the steady-state Richardson number is determined by the
! relation
! \begin{equation}
!   \label{Ri_st}
!   Ri_{st}=\dfrac{c_\mu}{{c_\mu}'} \dfrac{c_{\psi 2} - c_{\psi 1}}{c_{\psi 2} - c_{\psi 3}}
!   \point
! \end{equation}
! Since it is well-known that, with the equilibrium assumption $P+G=\epsilon$,
! stability functions reduce to functions of $Ri$ only
! (\cite{MellorYamada74}, \cite{Galperinetal88}), \eq{Ri_st} is a
! non-linear equation for the model constant $c_{\psi 3}$ for given
! $Ri_{st}$. Note, that the structure parameters, $m$ and $n$, do not
! appear in \eq{Ri_st}. This implies that the type of the two-equation
! model is irrelevant for the prediction of the mixed layer depth, as
! long as \eq{Ri_st} is fulfilled for identical $Ri_{st}$. Numerical
! examples with very different values of $m$ and $n$ confirmed indeed
! that the mixed layer depth only depends on $Ri_{st}$.
! The experiment of \cite{KatoPhillips69} could almost perfectly be
! reproduced, provided the parameter $c_{\psi 3}$ was chosen to
! correspond to $Ri_{st}\approx0.25$, see \cite{Umlaufetal2003}.

! Note, that in instable
! situations, a different value of the parameter $c_{\psi 3}$ needs to
! be used. This does not cause a discontinuity in the model because the
! buoyancy term in \eq{generic} is zero at the transition.  An
! evaluation of the length-scale equations in convective flows, however,
! is intimately related to the third-order modelling of the triple
! correlation terms, a topic outside the scope of this documentation.
!
! !USES:
  IMPLICIT NONE
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
   REALTYPE                   ::  rad
   REALTYPE, external         ::  compute_cpsi3,compute_rist
!-----------------------------------------------------------------------
!BOC
! do some checks

   if (tke_method.ne.tke_keps) then
      STDERR 'The generic scale equation should be used only'
      STDERR 'in connection with the dynamic equation for'
      STDERR 'the tke (use tke_method = 2).'
      STDERR 'Please change gotmturb.nml accordingly'
      STDERR 'Program aborts now in turbulence.F90'
      stop
   endif

   if (gen_d.gt.0.) then
      STDERR 'Temporal decay rate d in homogeneous'
      STDERR 'turbulence has to be negative.'
      STDERR 'Measured values are: -1.0 < d < -1.3'
      STDERR 'Please change gotmturb.nml accordingly'
      STDERR 'Program aborts now in turbulence.F90'
      stop
   endif

   if (gen_alpha.gt.0.) then
      STDERR 'Decay exponent alpha has to be negative.'
      STDERR 'Measured values are: -3 < alpha < -2'
      STDERR 'Please change gotmturb.nml accordingly'
      STDERR 'Program aborts now in turbulence.F90'
      stop
   endif

   if (gen_l.lt.0.) then
      STDERR 'Slope L of the length scale in shear-free'
      STDERR 'turbulence has to be positive.'
      STDERR 'Measured values are: 0.15 < L < 0.25'
      STDERR 'Please change gotmturb.nml accordingly'
      STDERR 'Program aborts now in turbulence.F90'
      stop
   endif

! compute the parameters as decribed in
! Umlauf and Burchard, J. Mar. Res., 2003
   cpsi1    = gen_m
   sig_kpsi = 1.5*(gen_alpha*gen_l)**2/(rcm*cm0**2)
   sig_k    = sig_kpsi

   rad      = 8.*gen_alpha**2.*gen_l**2.*(2.+gen_d)**2.* &
                   (rcm*kappa**2.-gen_l**2.)*gen_m*(1.+2.*gen_m) + &
                   ( -4.*gen_d*rcm*kappa**2.*gen_m &
                     +gen_alpha*gen_l**2.*(2.+gen_d)*(1.+4.*gen_m) )**2.

! check for negative radicand and compute n
   if (rad.gt.0) then
      gen_n = -1./( 4.*(2.+gen_d)*(rcm*kappa**2.-gen_l**2.) )* &
           ( 4.*gen_d*rcm*kappa**2.*gen_m &
             -gen_alpha*gen_l**2.*(2.+gen_d)*(1.+4.*gen_m) + sqrt(rad) )

   else
      STDERR 'Negative radicand discovered in computing'
      STDERR 'exponent n of the generic model.'
      STDERR 'Please choose other value for gen_m in gotmturb.nml'
      STDERR 'Program aborts now in turbulence.F90'
      stop
   endif

! check for positive exponent n
   if (gen_n.gt.0.) then
      STDERR 'A positive exponent n of the lengt scale l'
      STDERR 'has been computed. This indicates that the model'
      STDERR 'would require a wall-function.'
      STDERR 'Please change gotmturb.nml accordingly'
      STDERR 'Program aborts now in turbulence.F90'
      stop
   endif

! compute Schmidt-number for psi
   sig_psi  = 2.*kappa**2.*gen_d*gen_n/(cm0**2*(gen_d+2.))

! check for negative Schmidt-number sig_psi
   if (sig_psi.lt.0.) then
      STDERR 'A negative Schmidt-number sig_psi has been'
      STDERR 'computed. Physically, that does not make sense.'
      STDERR 'Possible reason: You set gen_d < -2 in gotmturb.nml?'
      STDERR 'Please change gotmturb.nml accordingly'
      STDERR 'Program aborts now in turbulence.F90'
      stop
   endif
   cpsi2    = gen_n**2*kappa**2/(cm0**2*sig_psi)+cpsi1

! compute c3 from given steady-state Richardson-number, or vice-versa
   if (compute_c3)  then
      cpsi3minus = compute_cpsi3(cpsi1,cpsi2,Ri_st)
   else
      ri_st      = compute_rist(cpsi1,cpsi2,cpsi3minus)
   endif

! compute c3 for unstable stratification corresponding to a certain
! ce3 in the k-epsilon model

   cpsi3plus=(1.5-ce3plus)*gen_n+gen_m

   return
   end subroutine generate_model
!EOC


!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Analyse the turbulence models\label{sec:analyse}
!
! !INTERFACE:
   subroutine analyse_model
!
! !DESCRIPTION:
! This routine analyses all models in GOTM for their physical properties
! implied by chosen model parameters. These results can be displayed by
! calling the internal routine {\tt report\_model()}, also defined in the
! {\tt turbulence} module (see \sect{sec:report}).
!
! In most cases, the relations connecting model parameters and physical
! properties have already been derived in \sect{sec:generate}:
! the von K{\'a}rm{\'a}n constant, $\kappa$, follows from \eq{psiLog},
! the decay rate in homogeneous turbulence , $d$, from \eq{d}, and
! the steady-state Richardson-number from \eq{Ri_st}. These relations have
!  been obtained in `generic' form (see \sect{sec:genericeq}), but relations
! for specific models, like the $k$-$\epsilon$ model or the $k$-$\omega$ model,
! can be derived by simply adopting the parameters compiled in \tab{tab:psi} and
! \tab{tab:constants} in \sect{sec:genericeq}.
!
! The decay rates $\alpha$ and $L$ in shear-free turbulence follow from
! the physically meaningful roots of \eq{GE_alphaL_1} and \eq{GE_alphaL_2},
! which are
! \begin{equation}
!   \label{GE_alphaL}
!   \begin{array}{rcl}
!     \alpha
!     &=& -
!     \dfrac{4 n {(\sigma_k^\psi)}^\frac{1}{2}}
!     { (1+4m) {(\sigma_k^\psi)}^\frac{1}{2} - {(\sigma_k^\psi + 24 \sigma_\psi c_{\psi 2} )}^\frac{1}{2}} \comma \\[8mm]
!     L
!     &=&
!     c_\mu^0 R^{\frac{1}{2}} \left(
!       \dfrac{ (1+4m+8m^2) \sigma_k^\psi
!         + 12 \sigma_\psi c_{\psi 2}
!          - (1+4m) ( {\sigma_k^\psi} ( \sigma_k^\psi
!           + 24 \sigma_\psi c_{\psi 2} ))^\frac{1}{2}  }{12 n^2}
!   \right)^\frac{1}{2}
!   \comma
!   \end{array}
! \end{equation}
! where it should be recalled that $R=c_\mu^0/c_\mu$.
! For the standard models (without ASM), $R=1$ may be assumed. Then,
! with the values from \tab{tab:psi} and \tab{tab:constants},
! solutions for the $k$-$\epsilon$ model of \cite{Rodi87},
!  and the $k$-$\omega$ model of \cite{Umlaufetal2003} can be directly
! recovered as special cases of this equation.
!
! Due to its wall-functions, the model of \cite{MellorYamada82} described
! in \sect{sec:lengthscaleeq} requires a slightly more complicated
! analysis. For this model, the von K{\'a}rm{\'a}n constant is computed
! according to
! \begin{equation}
!    \label{kappaMY}
!    \kappa = \sqrt{\dfrac{E_2 - E_1 + 1}{S_l B_1}}
! \point
! \end{equation}
!
! The decay rates in shear-free turbulence can be shown to be
! \begin{equation}
!   \label{MY_alphaL}
!   \begin{array}{rcl}
!     \alpha
!     &=& \dfrac{5 \kappa B_1^{\frac{1}{2}} S_l
!       + \left( 12 E_2 \left( 2 S_l - S_q \right)
!       +  B_1 \kappa^2 S_l \left(S_l + 12 S_q \right) \right)^{\frac{1}{2}}}{
!       3 \kappa B_1^{\frac{1}{2}} (S_q - 2 S_l)  }  \\
!     L
!     &=&
!     \kappa \left(
!       \dfrac{\cal N }{
!        6 S_q (E_2 - B_1 \kappa^2 S_l )^2}
!     \right)^\frac{1}{2}
!   \comma
!   \end{array}
! \end{equation}
! where we introduced the abbreviation
! \begin{equation}
!   \begin{array}{rcl}
!     {\cal N}
!     &=&
!     6 E_2 \left( 2 S_l - S_q \right)
!    + B_1 \kappa^2 S_l \left( 13 S_l + 6 S_q \right) \\[2mm]
!    &-& 5 B_1^\frac{1}{2} \kappa S_l \left( 12 E_2 (2 S_l-S_q)
!    + B_1 \kappa^2 S_l (S_l + 12 S_q )\right)^\frac{1}{2}
!   \point
!   \end{array}
! \end{equation}
! These equations replace \eq{GE_alphaL} for the model of \cite{MellorYamada82}.
! Decay-rates for this model do not at all depend on the stability
! functions. However, they depend on the parameter $E_2$ of the
! wall-functions. This parameter, however, has been derived for
! wall-bounded shear flows, and it is not very plausible to find it in an
! expression for \emph{shear-free} flows.
!
! The routine {\tt analyse\_model()} works also for one-equation models,
! where the length-scale, $l$, is prescribed by an analytical expression
! (see \sect{sec:algebraiclength}).  However, some attention has to be paid
! in interpreting the results. First, it is clear that these models cannot
! predict homogeneous turbulence, simply because all formulations rely on
! some type of modified boundary layer expressions for the length-scale.
! This impies that a well-defined decay rate, $d$, and a steady-state
! Richardson-number, $Ri_{st}$, cannot be computed. Second, the von
! K{\'a}rm{\'a}n constant, $\kappa$, does not follow from \eq{psiLog} or
! \eq{kappaMY}, because $\kappa$ now relates directly to
! the prescribed slope of the length-scale close to the bottom or the surface.
! Third, in shear-free flows, \eq{GE_alphaL}$_1$ or \eq{MY_alphaL}$_1$ remain
! valid, provided the planar source of the spatially decaying turbulence
! is located at $z=0$. Then, the slope of the length-scale, $L$,
! defined in \eq{power_law} can be identified with the prescribed slope,
! $\kappa$, and \eq{GE_alphaL}$_1$ or \eq{MY_alphaL}$_1$ are identical
! to the solutions suggested by \cite{CraigBanner94}.
!
! In this context, it should be pointed out that the
! shear-free solutions also have a
! direct relation to an important oceanic situation. If the planar
! source of turbulence is assumed to be located at $z=0$,
! and if the injected turbulence is identified with turbulence caused
! by breaking surface-waves, then it can be shown that \eq{GE_alphaL}
! or \eq{MY_alphaL} are valid in a thin boundary layer adjacent to the
! suface. Further below, to classical law of the wall determines the
! flow, see \cite{CraigBanner94} and cite{Umlaufetal2003}.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
   REALTYPE                   :: rad,one=1.0
   REALTYPE, external         :: compute_cpsi3,compute_rist
!
!-----------------------------------------------------------------------
!BOC
!  compute the basic properties of all models available

   select case(len_scale_method)
   case(Parabola)

      if (compute_kappa) kappa=0.4
      gen_l     = kappa
      gen_alpha = -sqrt(2./3.*cm0**2.*rcm*sig_k/gen_l**2.)

   case(Triangle)

      if (compute_kappa) kappa=0.4
      gen_l     = kappa
      gen_alpha = -sqrt(2./3.*cm0**2.*rcm*sig_k/gen_l**2.)

   case(Xing)

      if (compute_kappa) kappa=0.4
      gen_l     = kappa
      gen_alpha = -sqrt(2./3.*cm0**2.*rcm*sig_k/gen_l**2.)

   case(RobertOuellet)

      if (compute_kappa) kappa=0.4
      ! Slope at the surface computed from the analytical profile
      ! of Robert and Ouellet (1987) (see algebraiclength.F90):
      ! gen_l and gen_alpha will not be computed since they require
      ! the depth, and the surface and bed roughness length, three
      ! quantities which are not available in init_turbulence when
      ! the GOTM turbulence module is coupled to 3D models.

   case(Blackadar)

      if (compute_kappa) kappa=0.4
      gen_l     = kappa
      gen_alpha = -sqrt(2./3.*cm0**2.*rcm*sig_k/gen_l**2.)

   case(BougeaultAndre)

      !     This needs a check
      if (compute_kappa) kappa=0.4
      gen_l     = kappa
      gen_alpha = -sqrt(2./3.*cm0**2.*rcm*sig_k/gen_l**2.)

   case(ispra_length)

      if (compute_kappa) kappa=0.4
      gen_l     = kappa
      gen_alpha = -sqrt(2./3.*cm0**2.*rcm*sig_k/gen_l**2.)


   case(diss_eq)

      ! compute kappa from the parameters
      if (compute_kappa)  then
         rad=sig_e*(ce2-ce1)
         if (rad .gt. 0) then
            kappa=cm0*sqrt(rad)
         else
            STDERR 'Negative radicand discovered in computing'
            STDERR 'kappa for the k-epsilon model.'
            STDERR 'Possible reason: you took ce2 < ce1 '
            STDERR 'Please change gotmturb.nml accordingly.'
            STDERR 'Program aborts now in turbulence.F90'
            stop
         endif
         if (sig_peps) then
            STDERR 'For using the Craig & Banner 1994 parameterisation'
            STDERR 'by Burchard (2001) kappa must be prescribed.'
            STDERR 'For doing so, compute_kappa=.false. must be set.'
            STDERR 'Please change gotmturb.nml accordingly.'
            STDERR 'Program aborts now in turbulence.F90'
            stop
         end if

         sig_e0=sig_e  ! use constant Schmidt-number always

      ! or compute the Schmidt-number for given kappa
      else

         sig_e= kappa**2/(ce2-ce1)/cm0**2

         ! compute Schmidt-number for Burchard (2001) wave-breaking
         if (sig_peps) then
            craig_m=sqrt(1.5*cmsf**2*sig_k/kappa**2)
            sig_e0=(4./3.*craig_m+1.)*(craig_m+1.)*kappa**2/(ce2*cmsf**2)
         else
            sig_e0=sig_e
         endif
      endif


      ! compute model propeties
      gen_d      = 1./(1.-ce2)
      gen_alpha  = 4.*sqrt(sig_k)/(7.*sqrt(sig_k)-sqrt(sig_k+24.*sig_e0*ce2))
      gen_l      = cm0*sqrt(rcm)*sqrt( (25.*sig_k+12.*sig_e0*ce2 -  &
                   7.*sqrt(sig_k*(sig_k+24.*sig_e0*ce2 ) ) ) / 12. )

      ! compute c3 from given steady-state Richardson-number, or vice-versa
      if (compute_c3)  then
         ce3minus  =  compute_cpsi3(ce1,ce2,Ri_st)
      else
         ri_st     =  compute_rist(ce1,ce2,ce3minus)
      endif
   case(generic_eq)
      rad=sig_psi*(cpsi2-cpsi1)/gen_n**2.
      if (rad.gt.0) then
         kappa=cm0*sqrt(rad)
      else
         STDERR 'Negative radicand discovered in computing'
         STDERR 'kappa for the generic model.'
         STDERR 'Possible reason: you took cpsi2 < cpsi1'
         STDERR 'Please change gotmturb.nml accordingly.'
         STDERR 'Program aborts now in turbulence.F90'
         stop
      endif
      sig_k      = sig_kpsi
      gen_d      = -2.*gen_n/(2.*gen_m + gen_n - 2.*cpsi2)
      gen_alpha  = -4.*gen_n*sqrt(sig_k) / &
                    ( (1.+4.*gen_m)*sqrt(sig_k) &
                     - sqrt(sig_k + 24.*sig_psi*cpsi2 ) )
      gen_l      = cm0*sqrt(rcm)* &
                  sqrt( ( (1.+4.*gen_m+8.*gen_m**2)*sig_k &
                         + 12.*sig_psi*cpsi2 &
                         - (1.+4.*gen_m) &
                            *sqrt(sig_k*(sig_k+24.*sig_psi*cpsi2)) ) &
                       /(12.*gen_n**2.) )

      ! compute c3 from given steady-state Richardson-number, or vice-versa
      if (compute_c3)  then
         cpsi3minus  =  compute_cpsi3(cpsi1,cpsi2,Ri_st)
      else
         ri_st       =  compute_rist(cpsi1,cpsi2,cpsi3minus)
      endif

      ! compute c3 for unstable stratification from corresponding value of
      ! ce3 for the k-epsilon model
      cpsi3plus=(1.5-ce3plus)*gen_n+gen_m


   case(length_eq)
      ! compute kappa from the parameters or vice-versa
      if (compute_kappa)  then
         rad = (e2-e1+1.)/(sl*b1)
         if (rad.gt.0) then
            kappa=sqrt(rad)
         else
            STDERR 'Negative radicand discovered in computing'
            STDERR 'kappa for the Mellor-Yamada model.'
            STDERR 'Possible reason: you took E2 < E1-1 '
            STDERR 'Please change gotmturb.nml accordingly.'
            STDERR 'Program aborts now in turbulence.F90'
            stop
         endif
      else
         ! E_2 instead of S_l is used here to tune kappa
         e2=kappa**2*b1*sl+e1-1.
      endif
      ! d=-1 always for the Mellor-Yamada (1982) model
      gen_d      = -1.

      ! spatial decay rates of turbulence from a planar source are
      ! given here for the Mellor-Yamada model with (!) function.
      ! This corresponds to the wave-breaking case.
      gen_alpha  = ( 5.*kappa*sqrt(b1)*sl &
                    +sqrt(12.*e2*(2.*sl-sq)+b1*kappa**2.*sl*(sl+12.*sq) ) ) &
                  /( 3.*kappa*sqrt(b1)*(sq-2*sl) )
      gen_l = kappa*sqrt( ( 6.*e2*(2.*sl-sq)+b1*kappa**2.*sl*(13.*sl+6.*sq) &
                           -5.*sqrt(b1)*kappa*sl*sqrt( 12.*e2*(2.*sl-sq) &
                           +b1*kappa**2.*sl*(sl+12.*sq) ) ) &
                              /(6.*sq*(e2-b1*kappa**2.*sl)**2.) )

      ! compute E3 from given steady-state Richardson-number, or vice-versa
      if (compute_c3)  then
         e3      = compute_cpsi3(e1,one,Ri_st)
      else
         ri_st   = compute_rist(e1,one,e3)
      endif

   case default
   end select

   return
   end subroutine analyse_model
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Report turbulence model \label{sec:report}
!
! !INTERFACE:
   subroutine report_model
!
! !DESCRIPTION:
! This routine reports on the parameters and the propeties
! of all turbulence models implemented in GOTM. Results are
! written to the screen.

! !USES:
   IMPLICIT NONE
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!-----------------------------------------------------------------------
!BOC
! Report on the properties of each model
   if(mpp_pe() == mpp_root_pe()) then

   select case(len_scale_method)
      case(Parabola)
         LEVEL2 ' '
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 'You are using a one-equation model'
         LEVEL2 'with a parabolic prescribed length-scale.'
         LEVEL2 'The properties of this model are:'
         LEVEL2 ' '
         LEVEL3 'Schmidt-number for k,          sig_k =', sig_k
         LEVEL3 'von Karman constant,           kappa =', kappa
         LEVEL2 ' '

         LEVEL3 'Value of the stability function'
         LEVEL3 'in the log-law,                   cm0 =', cm0
         LEVEL3 'in shear-free turbulence,        cmsf =', cmsf
         LEVEL2 ' '
         LEVEL3 'At the surface:'
         LEVEL3 'spatial decay rate (no shear), alpha =', gen_alpha
         LEVEL3 'length-scale slope (no shear), L     =', gen_l
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 ' '
      case(Triangle)
         LEVEL2 ' '
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 'You are using a one-equation model'
         LEVEL2 'with a triangular prescribed length-scale.'
         LEVEL2 'The properties of this model are:'
         LEVEL2 ' '
         LEVEL3 'Schmidt-number for k,          sig_k =', sig_k
         LEVEL3 'von Karman constant,           kappa =', kappa
         LEVEL2 ' '
         LEVEL3 'Value of the stability function'
         LEVEL3 'in the log-law,                   cm0 =', cm0
         LEVEL3 'in shear-free turbulence,        cmsf =', cmsf
         LEVEL2 ' '
         LEVEL3 'At the surface:'
         LEVEL3 'spatial decay rate (no shear), alpha =', gen_alpha
         LEVEL3 'length-scale slope (no shear),    L =', gen_l
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 ' '
      case(Xing)
         LEVEL2 ' '
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 'You are using a one-equation model'
         LEVEL2 'with the prescribed length-scale of Xing and Davies (1995)'
         LEVEL2 'The properties of this model are:'
         LEVEL2 ' '
         LEVEL3 'Schmidt-number for k,          sig_k =', sig_k
         LEVEL3 'von Karman constant,           kappa =', kappa
         LEVEL2 ' '
         LEVEL3 'Value of the stability function'
         LEVEL3 'in the log-law,                   cm0 =', cm0
         LEVEL3 'in shear-free turbulence,        cmsf =', cmsf
         LEVEL2 ' '
         LEVEL3 'At the surface:'
         LEVEL3 'spatial decay rate (no shear), alpha =', gen_alpha
         LEVEL3 'length-scale slope (no shear), L     =', gen_l
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 ' '
      case(RobertOuellet)
         LEVEL2 ' '
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 'You are using a one-equation model'
         LEVEL2 'with the prescribed length-scale of Robert and Ouellet (1987)'
         LEVEL2 ' '
         LEVEL2 'The properties of this model are:'
         LEVEL3 'Schmidt-number for k,          sig_k =', sig_k
         LEVEL3 'von Karman constant,           kappa =', kappa
         LEVEL2 ' '
         LEVEL3 'Value of the stability function'
         LEVEL3 'in the log-law,                   cm0 =', cm0
         LEVEL3 'in shear-free turbulence,        cmsf =', cmsf
         LEVEL2 ' '
         LEVEL3 'At the surface:'
         LEVEL3 'spatial decay rate (no shear), alpha = not computed'
         LEVEL3 'length-scale slope (no shear),     L = not computed'
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 ' '
      case(Blackadar)
         LEVEL2 ' '
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 'You are using a one-equation model'
         LEVEL2 'with the length-scale of Blackadar (1962)'
         LEVEL2 'The properties of this model are:'
         LEVEL2 ' '
         LEVEL3 'Schmidt-number for k,          sig_k =', sig_k
         LEVEL3 'von Karman constant,           kappa =', kappa
         LEVEL2 ' '
         LEVEL3 'Value of the stability function'
         LEVEL3 'in the log-law,                   cm0 =', cm0
         LEVEL3 'in shear-free turbulence,        cmsf =', cmsf
         LEVEL2 ' '
         LEVEL3 'At the surface:'
         LEVEL3 'spatial decay rate (no shear), alpha =', gen_alpha
         LEVEL3 'length-scale slope (no shear),     L =', gen_l
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 ' '
      case(BougeaultAndre)
         LEVEL2 ' '
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 'You are using a one-equation model'
         LEVEL2 'with the length-scale of Bougeault and Andre (1986)'
         LEVEL2 'The properties of this model are:'
         LEVEL2 ' '
         LEVEL3 'Schmidt-number for k,          sig_k =', sig_k
         LEVEL3 'von Karman constant,           kappa =', kappa
         LEVEL2 ' '
      case(ispra_length)
         LEVEL2 ' '
         LEVEL2 'You are using a one-equation model'
         LEVEL2 'with the ISPRAMIX length-scale (see GOTM-report)'
         LEVEL2 'The properties of this model are:'
         LEVEL2 ' '
         LEVEL3 'Schmidt-number for k,          sig_k =', sig_k
         LEVEL3 'von Karman constant,          kappa  =', kappa
         LEVEL2 ' '
         LEVEL3 'Value of the stability function'
         LEVEL3 'in the log-law,                   cm0 =', cm0
         LEVEL3 'in shear-free turbulence,        cmsf =', cmsf
         LEVEL2 ' '
         LEVEL3 'At the surface:'
         LEVEL3 'spatial decay rate (no shear), alpha =', gen_alpha
         LEVEL3 'length-scale slope (no shear),     L =', gen_l
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 ' '
      case(diss_eq)
         LEVEL2 ' '
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 'You are using the k-epsilon model'
         LEVEL2 'with the following properties:'
         LEVEL2 ' '
         LEVEL3 'ce1                                  =', ce1
         LEVEL3 'ce2                                  =', ce2
         LEVEL3 'ce3minus                             =', ce3minus
         LEVEL3 'ce3plus                              =', ce3plus
         LEVEL3 'sig_k                                =', sig_k
         LEVEL3 'sig_e                                =', sig_e
         LEVEL2 ' '
         LEVEL3 'Value of the stability function'
         LEVEL3 'in the log-law,                   cm0 =', cm0
         LEVEL3 'in shear-free turbulence,        cmsf =', cmsf
         LEVEL2 ' '
         LEVEL3 'von Karman constant,           kappa =', kappa
         LEVEL3 'homogeneous decay rate,            d =', gen_d
         LEVEL3 'spatial decay rate (no shear), alpha =', gen_alpha
         LEVEL3 'length-scale slope (no shear),     L =', gen_l
         LEVEL3 'steady-state Richardson-number, Ri_st=', ri_st
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 ' '
      case(length_eq)
         LEVEL2 ' '
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 'You are using the Mellor-Yamada model'
         LEVEL2 'with the following properties:'
         LEVEL2 ' '
         LEVEL3 'B1                                   =', b1
         LEVEL3 'E1                                   =', e1
         LEVEL3 'E2                                   =', e2
         LEVEL3 'E3                                   =', e3
         LEVEL3 'Sq                                   =', sq
         LEVEL3 'Sl                                   =', sl
         LEVEL2 ' '
         LEVEL3 'Value of the stability function'
         LEVEL3 'in the log-law,                   cm0 =', cm0
         LEVEL3 'in shear-free turbulence,        cmsf =', cmsf
         LEVEL2 ' '
         LEVEL3 'von Karman constant,           kappa =', kappa
         LEVEL3 'homogeneous decay rate,            d =', gen_d
         LEVEL3 'steady-state Richardson-number, Ri_st=', ri_st
         LEVEL2 ' '
         LEVEL3 'At the surface (i.e. with wall-function):'
         LEVEL3 'spatial decay rate (no shear), alpha =', gen_alpha
         LEVEL3 'length-scale slope (no shear),     L =', gen_l
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 ' '
      case(generic_eq)
         LEVEL2 ' '
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 'You are using the generic two-equation model'
         LEVEL2 'with the following properties:'
         LEVEL2 ' '
         LEVEL3 'exponent of k in psi-equation,    m  =', gen_m
         LEVEL3 'exponent of l in psi-equation,    n  =', gen_n
         LEVEL3 'exponent of cm0 in psi-equation,  p  =', gen_p
         LEVEL3 'cpsi1                                =', cpsi1
         LEVEL3 'cpsi2                                =', cpsi2
         LEVEL3 'cpsi3minus                           =', cpsi3minus
         LEVEL3 'cpsi3plus                            =', cpsi3plus
         LEVEL3 'sig_k                                =', sig_kpsi
         LEVEL3 'sig_psi                              =', sig_psi
         LEVEL2 ' '
         LEVEL3 'Value of the stability function'
         LEVEL3 'in the log-law,                   cm0 =', cm0
         LEVEL3 'in shear-free turbulence,        cmsf =', cmsf
         LEVEL2 ' '
         LEVEL3 'von Karman constant,           kappa =', kappa
         LEVEL3 'homogeneous decay rate,            d =', gen_d
         LEVEL3 'spatial decay rate (no shear), alpha =', gen_alpha
         LEVEL3 'length-scale slope (no shear),     L =', gen_l
         LEVEL3 'steady-state Richardson-number, Ri_st=', ri_st
         LEVEL2 '--------------------------------------------------------'
         LEVEL2 ' '
      case default
   end select

   endif

   return
   end subroutine report_model
!EOC

!-------------------------------------------------------------------------
!BOP
!
! !IROUTINE: Manage turbulence time-stepping\label{sec:doTurbulence}
!
! !INTERFACE:
   subroutine do_turbulence(nlev,dt,depth,u_taus,u_taub,z0s,z0b,h,      &
                            NN,SS,xP)
!
! !DESCRIPTION: This routine is the central point of the
! turbulence scheme. It determines the order, in which
! turbulence variables are updated, and calls
! other member functions updating
! the TKE, the length-scale, the dissipation rate, the ASM etc.
! Note, that the list of arguments in {\tt do\_turbulence()} corresponds
! exactly to those mean flow and grid-related variables required to update
! the turbulent quantities. These variables have to be passed
! from a 3-D model, if the {\tt turbulence} module of GOTM is used
! for the computation of the turbulent fluxes. Do not forget to call
! {\tt init\_turbulence()} from the 3-D model before the first call to
! {\tt do\_turbulence()}.
!
!
! The variable {\tt turb\_method} determines the essential structure
! of the calls in {\tt do\_turbulence()}. At the moment, the following
! model types are available:
! \begin{itemize}
!   \item {\tt turb\_method = 0} corresponds to the "convective adjustment"
!   algorithm, see \sect{sec:convective}. Since this model is not a real
!   one-point turbulence closure, it is not called from {\tt do\_turbulence} but
!   directly from the main GOTM loop.
!   \item {\tt turb\_method = 1} corresponds to a purely algebraic description
!   of the turbulent diffusivities.
!  \item  {\tt turb\_method = 2} corresponds to models computing the diffusivities
!  from the TKE and the turbulent length scale according to \eq{nu}. TKE and length scale
!  are computed from dynamic PDEs or algebraic relations, an empirical (i.e.\ not
!  derived from a second-order model) stability function is used, see
!  \sect{sec:stabilityFunctions}.
!  \item  {\tt turb\_method = 3} corresponds to a second-order model for the turbulent
!  fluxes.
! \end{itemize}
!
! The second-order models fall into different categories, depending on the
! value of {\tt second\_method}. These models, discussed in detail
! in \sect{sec:EASM}, are listed in the following.
! \begin{itemize}
!   \item {\tt second\_method = 1} corresponds to algebraic quasi-equilibrium models
!         with scaling in the spirit of \cite{Galperinetal88}, see \sect{sec:cmueD}.
!  \item  {\tt second\_method = 2} corresponds to algebraic models
!         assuming $P_b=\epsilon_b$, and hence using \eq{Tequilibrium}. Furthermore,
!         full equilibrium $P+G=\epsilon$ and $P_b=\epsilon_b$ is assumed for the
!         computation of ${\cal N}$ and ${\cal N}_b$ in \eq{NandNb}, see \sect{sec:cmueC}
!  \item  {\tt second\_method = 3} corresponds to algebraic models assuming
!         full equilibrium $P+G=\epsilon$ and $P_b=\epsilon_b$ for the
!         computation of ${\cal N}$ and ${\cal N}_b$ in \eq{NandNb}. Now, however,
!         also an equation for (half) the buoyancy variance $k_b$ is solved,
!         leading to the appearance of the counter-gradient term in \eq{b13}, see \sect{sec:cmueB}.
!         This model is not yet fully tested and therefore not available.
! \end{itemize}
! Depending on the values of {\tt kb\_method} and {\tt epsb\_method}, different
! algebraic or differential equations for $k_b$ and $\epsilon_b$ are solved for
! {\tt second\_method = 3,4}.
!
! !USES:
   IMPLICIT NONE

   interface
      subroutine production(nlev,NN,SS,xP)
        integer,  intent(in)                :: nlev
        REALTYPE, intent(in)                :: NN(0:nlev)
        REALTYPE, intent(in)                :: SS(0:nlev)
        REALTYPE, intent(in), optional      :: xP(0:nlev)
      end subroutine production
   end interface

!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer,  intent(in)                :: nlev

!  time step (s)
   REALTYPE, intent(in)                :: dt

!  distance between surface
!  and bottom(m)
   REALTYPE, intent(in)                :: depth

!  surface and bottom
!  friction velocity (m/s)
   REALTYPE, intent(in)                :: u_taus,u_taub

!  surface and bottom
!  roughness length (m)
   REALTYPE, intent(in)                :: z0s,z0b

!  layer thickness (m)
   REALTYPE, intent(in)                :: h(0:nlev)

!  boyancy frequency squared (1/s^2)
   REALTYPE, intent(in)                :: NN(0:nlev)

!  shear-frequency squared (1/s^2)
   REALTYPE, intent(in)                :: SS(0:nlev)

!  TKE production due to seagrass
!  friction (m^2/s^3)
   REALTYPE, intent(in), optional      :: xP(0:nlev)
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding, Hans Burchard,
!                      Lars Umlauf
!
!EOP
!-------------------------------------------------------------------------
!BOC

   select case (turb_method)
   case (algebraic)
!  solve a model for algebraically described diffusity

      STDERR '----------------------------------------------------------'
      STDERR 'Model for turb_method=1 not coded yet.'
      STDERR 'Choose  turb_method=0,2,3,99'
      STDERR 'Program execution stopped ...'
      stop 'turbulence.F90'
      STDERR '----------------------------------------------------------'

   case (first_order)
!  solve a model for tke, length scale
!  empirical stability function

      if ( PRESENT(xP) ) then
!        with seagrass turbulence
         call production(nlev,NN,SS,xP)
      else
!        without
         call production(nlev,NN,SS)
      end if

      call alpha_mnb(nlev,NN,SS)
      call stabilityfunctions(nlev)
      call do_tke(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
      call do_lengthscale(nlev,dt,depth,u_taus,u_taub,z0s,z0b,h,NN,SS)
      call kolpran(nlev)

      call internal_wave(nlev,NN,SS)


   case (second_order)

!  solve a model for the second moments

      if ( PRESENT(xP) ) then
!        with seagrass turbulence
         call production(nlev,NN,SS,xP)
      else
!        without
         call production(nlev,NN,SS)
      end if

      select case(scnd_method)
      case (quasiEq)
         ! quasi-equilibrium model

         call alpha_mnb(nlev,NN,SS)
         call cmue_d(nlev)
         call do_tke(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
         call do_kb(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
         call do_lengthscale(nlev,dt,depth,u_taus,u_taub,z0s,z0b,h,NN,SS)
         call do_epsb(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
         call alpha_mnb(nlev,NN,SS)
         call kolpran(nlev)

      case (weakEqKbEq)

         call alpha_mnb(nlev,NN,SS)
         call cmue_c(nlev)
         call do_tke(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
         call do_kb(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
         call do_lengthscale(nlev,dt,depth,u_taus,u_taub,z0s,z0b,h,NN,SS)
         call do_epsb(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
         call alpha_mnb(nlev,NN,SS)
         call kolpran(nlev)

      case (weakEqKb)

      STDERR 'This second-order model is not yet tested.'
      STDERR 'Choose scnd_method=1,2 in gotmturb.nml.'
      STDERR 'Program execution stopped ...'
      stop 'turbulence.F90'

      case default

      STDERR 'Not a valid method for second-order model'
      STDERR 'Choose scnd_method=1,2,3 in gotmturb.nml.'
      STDERR 'Program execution stopped ...'
      stop 'turbulence.F90'

      end select

   case default

      STDERR 'Not a valid method for turbulence calculation'
      STDERR 'Choose  turb_method=0,1,2,3'
      STDERR 'Program execution stopped ...'
      stop 'turbulence.F90'

   end select

   return
 end subroutine do_turbulence
!EOC
!-----------------------------------------------------------------------




!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Update the turbulent kinetic energy \label{sec:updateTKE}
!
! !INTERFACE:
   subroutine do_tke(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
!
! !DESCRIPTION:
! Based on user input, this routine calls the appropriate routines for
! calculating the turbulent kinetic energy. The user has the choice
! between an algebraic equation described in \sect{sec:tkealgebraic}, and two
! versions of the dynamic transport equation of the TKE described
! in \sect{sec:tkeeq} and \sect{sec:q2over2eq}. The former uses
! $k$-$\epsilon$ notation, the latter the notation of
! \cite{MellorYamada82}. Apart from this, both equations
! are identical and update the vectors {\tt tke} and {\tt tkeo}, which
! is the value of the tke at the old time step.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer,  intent(in)                :: nlev
   REALTYPE, intent(in)                :: dt,u_taus,u_taub,z0s,z0b
   REALTYPE, intent(in)                :: h(0:nlev)
   REALTYPE, intent(in)                :: NN(0:nlev),SS(0:nlev)
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding, Hans Burchard,
!                      Manuel Ruiz Villarreal, Lars Umlauf
!
!EOP
!-----------------------------------------------------------------------
!BOC
   select case (tke_method)
      case(tke_local_eq)
         ! use algebraic length scale equation
          call tkealgebraic(nlev,u_taus,u_taub,NN,SS)
      case(tke_keps)
         ! use differential equation for tke (k-epsilon style)
         call tkeeq(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
      case(tke_MY)
         ! use differential equation for q^2/2 (Mellor-Yamada style)
         call q2over2eq(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
      case default
   end select

   return
 end subroutine do_tke
!-----------------------------------------------------------------------
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Update the buoyancy variance\label{sec:updateKb}
!
! !INTERFACE:
   subroutine do_kb(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
!
! !DESCRIPTION:
! Based on the value of {\tt kb\_method},
! this routine calls the appropriate routines for
! calculating (half) the buoyancy variance $k_b$ defined in \eq{defkb}.
! The user has the choice between a simple algebraic expression,
! described in \sect{sec:kbalgebraic}, and
! a dynamic equation for $k_b$, described in \sect{sec:kbeq}.
!

! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer,  intent(in)                :: nlev
   REALTYPE, intent(in)                :: dt,u_taus,u_taub,z0s,z0b
   REALTYPE, intent(in)                :: h(0:nlev)
   REALTYPE, intent(in)                :: NN(0:nlev),SS(0:nlev)
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!-----------------------------------------------------------------------
!BOC
   select case (kb_method)
      case(kb_algebraic)
         call kbalgebraic(nlev)
      case(kb_dynamic)
         call kbeq(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
      case default

      STDERR '... not a valid method to compute kb'
      STDERR 'Choose  kb_method=1,2 in gotmturb.nml'
      STDERR 'Program execution stopped ...'
      stop 'turbulence.F90'


   end select

   return
 end subroutine do_kb
!-----------------------------------------------------------------------
!EOC


!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE:  Update the dissipation length-scale\label{sec:updateLength}
!
! !INTERFACE:

   subroutine do_lengthscale(nlev,dt,depth,u_taus,u_taub, z0s,z0b,h,NN,SS)
!
! !DESCRIPTION:
! Based on the value of {\tt len\_scale\_method},
! this routine calls the appropriate routines for
! calculating the turbulent length-scale, $l$, and the rate of
! dissipation, $\epsilon$.  The user has the choice
! between several algebraic equations described in \sect{sec:algebraiclength},
! and several differential transport equations for a length-scale
! determining variable. At the moment, GOTM implements equations
! for the rate of dissipation, described in \sect{sec:dissipationeq},
! for the Mellor-Yamada model described in \sect{sec:lengthscaleeq}, and
! for the generic scale formulated by \cite{UmlaufBurchard2003} and described
! in \sect{sec:genericeq}. This last transport equation generalises all of the
! previously mentioned models. For example, the $k$-$\epsilon$ model
! and the $k$-$\omega$ model  can be recovered as special cases of the
! generic equation, see \cite{UmlaufBurchard2003}.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer,  intent(in)                :: nlev
   REALTYPE, intent(in)                :: dt,depth,u_taus,u_taub,z0s,z0b
   REALTYPE, intent(in)                :: h(0:nlev)
   REALTYPE, intent(in)                :: NN(0:nlev),SS(0:nlev)
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding, Hans Burchard,
!                      Manuel Ruiz Villarreal,
!                      Lars Umlauf
!
!EOP
!-----------------------------------------------------------------------
!BOC
   select case(len_scale_method)
      case(diss_eq)
         call dissipationeq(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
      case(generic_eq)
         call genericeq(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
      case(length_eq)
         call lengthscaleeq(nlev,dt,depth,u_taus,u_taub,z0s,z0b,h,NN,SS)
      case(BougeaultAndre)
         call potentialml(nlev,z0b,z0s,h,depth,NN)
      case default
         call algebraiclength(len_scale_method,nlev,z0b,z0s,depth,h,NN)
   end select

   return
   end subroutine do_lengthscale
!-----------------------------------------------------------------------
!EOC


!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Update the desctruction rate of buoyancy variance\label{sec:updateEpsb}
!
! !INTERFACE:
   subroutine do_epsb(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)
!
! !DESCRIPTION:
! Based on the value of {\tt epsb\_method},
! this routine calls the appropriate routines for
! calculating the molecular destruction rate of $k_b$, defined in \eq{kbeq}.
! Presently, only a simple algebraic expression,
! described in \sect{sec:epsbalgebraic}, is available in GOTM.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer,  intent(in)                :: nlev
   REALTYPE, intent(in)                :: dt,u_taus,u_taub,z0s,z0b
   REALTYPE, intent(in)                :: h(0:nlev)
   REALTYPE, intent(in)                :: NN(0:nlev),SS(0:nlev)
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!-----------------------------------------------------------------------
!BOC
   select case (epsb_method)
      case(epsb_algebraic)

         call epsbalgebraic(nlev)

      case(epsb_dynamic)

         STDERR '... sorry, epsb_method = 2 not yet implemented.'
         STDERR 'Choose  epsb_method=1 in gotmturb.nml'
         STDERR 'Program execution stopped ...'
         stop 'turbulence.F90'

      case default

         STDERR '... not a valid method to compute epsb'
         STDERR 'Choose  epsb_method=1,2 in gotmturb.nml'
         STDERR 'Program execution stopped ...'
         stop 'turbulence.F90'

   end select

   return
 end subroutine do_epsb
!-----------------------------------------------------------------------
!EOC



!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Update diffusivities (Kolmogorov-Prandtl relation)\label{sec:kolpran}
!
! !INTERFACE:
   subroutine kolpran(nlev)
!
! !DESCRIPTION:
! Eddy viscosity and diffusivity are calculated by means of the relation of
! Kolmogorov and Prandtl from the updated values of $k$, $l$ and the
! stability functions according to \eq{nu}. In addition, the counter-gradient
! term $\tilde{\Gamma}_B = \epsilon \Gamma$ is updated, see \eq{Db} and \eq{nuke}.
!
! Note, that this routine relies on the fact that the lowest and
! uppermost values of the stability functions and of $k$, $l$, and $\Gamma$
! have been computed using the correct boundary conditions. No
! special treatment of $\nu_t$, $\nu^B_t$, and $\tilde{\Gamma}_B$
!  at the boundaries is processed.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)       :: nlev
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding, Hans Burchard,
!                      Manuel Ruiz Villarreal, Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
   integer                   :: i
   REALTYPE                  :: x
!
!-----------------------------------------------------------------------
!BOC

!  update the turbulent diffusivities
   do i=0,nlev
      x        =  sqrt(tke(i))*L(i)
!     momentum
      num(i)   =  cmue1(i)*x
!     heat
      nuh(i)   =  cmue2(i)*x
!     salinity
      nus(i)   =  cmue2(i)*x
   end do

   return
   end subroutine kolpran
!EOC


!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Update stability functions\label{sec:stabilityFunctions}
!
! !INTERFACE:
   subroutine stabilityfunctions(nlev)
!
! !DESCRIPTION:
! Based on the user's specifications in {\tt gotmtub.nml}, this internal
! routine selects the desired stability functions defined in \eq{nu}.
! These simple functions depend on $\alpha_M$ and $\alpha_N$ defined
! in \eq{alphaMN}, which are in most cases only used to compute the
! Richardson-number
! \begin{equation}
!   \label{DefRi}
!    Ri = \dfrac{\alpha_N}{\alpha_M}
!    \point
! \end{equation}
! A description of individual stability functions starts from \sect{sec:cmueMA}.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: nlev
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard, Karsten Bollding, Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
!
!-----------------------------------------------------------------------
!BOC

   select case(stab_method)
      case(Constant)
         cmue1=cm0_fix
         cmue2=cm0_fix/Prandtl0_fix
      case(MunkAnderson)
         call cmue_ma(nlev)
      case(SchumGerz)
         call cmue_sg(nlev)
      case(EiflerSchrimpf)
         call cmue_rf(nlev)
      case default

      STDERR '... not a valid stability function'
      STDERR 'Choose different value for stab_method'
      STDERR 'Program execution stopped ...'
      stop 'turbulence.F90'

   end select

! formally set the values at the boundaries
   cmue1(0)      = cmue1(1)
   cmue1(nlev)   = cmue1(nlev-1)
   cmue2(0)      = cmue2(1)
   cmue2(nlev)   = cmue2(nlev-1)

   return
   end subroutine stabilityfunctions
!EOC


!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Compute special values of stability functions\label{sec:computeCmu}
!
! !INTERFACE:
   subroutine compute_cm0(turb_method,stab_method,scnd_method)
!
! !DESCRIPTION:
! Computes the values of the stability function $c_\mu$ defined
! in \eq{nu} in the logarithmic boundary-layer, $c_\mu^0$, and in
! shear-free, spatially decaying turbulence, $c_\mu^\text{sf}$ (see
! \sect{sec:analyse}).
!
! $c_\mu^0$ is the value of $c_\mu$  in unstratified
! equilibrium flows, i.e.\ in the logarithmic wall region. It can be obtained
! from the relation $P=\epsilon$, according to \eq{PeVertical}
! written in the form
!  \begin{equation}
!    \label{PeEquilibrium}
!      \dfrac{P}{\epsilon} = \hat{c}_\mu \alpha_M = 1
!    \point
!  \end{equation}
!  In unstratified flows, $\hat{c}_\mu$
! only depends on $\alpha_M$ (see \sects{sec:cmueA}{sec:cmueC}),
! and \eq{PeEquilibrium} is a polynomial equation for the value of
! $\alpha_M$ in equilibrium. Its solution is
!  \begin{equation}
!    \label{alphaEquilibrium}
!      \alpha_M  = \dfrac{3 {\cal N}^2}{a_2^2 - 3 a_3^2 + 3 a_1 {\cal N}}
!    \comma
!  \end{equation}
! where, according to \eq{NandNb} in equilibrium ${\cal N} = (c_1 + c^*_1)/2$.
! The value of the stability function in equilibrium follows directly from
! \eq{PeEquilibrium},
!  \begin{equation}
!    \label{cmEquilibrium}
!      \hat{c}_\mu^0  = \dfrac{a_2^2 - 3 a_3^2 + 3 a_1 {\cal N}}{3 {\cal N}^2}
!    \point
!  \end{equation}
!  Note that $\hat{c}_\mu^0 = (c_\mu^0)^4$ according to \eq{cmuConversion}.
!
!  Algebraic Stress Models exhibit an interesting behaviour in unstratified,
!  shear-free turbulence. Clearly, in the absence of shear, these models predict
!  isotropic turbulence, $b_{ij} = 0$, according to \eq{bASM}. This is a direct consequence of the
!  assumption \eq{Rodi}, implying an infinitely small return-to-isotropy time scale.
!  Formally, however, the limit of the stability function $\hat{c}_\mu$ for
!  $\alpha_M  \rightarrow 0$ follows from \eq{b13} and the definitions
!  given in \sects{sec:cmueA}{sec:cmueC}. The limiting value is
!  \begin{equation}
!    \label{cmShearfree}
!     \lim_{\alpha_M \rightarrow 0} \hat{c}_\mu = \hat{c}_\mu^\text{sf}  = \dfrac{a_1}{{\cal N}}
!    \comma
!  \end{equation}
!  where, according to \eq{NandNb}, one has either ${\cal N} = c_1/2-1$ or
!  ${\cal N} = (c_1 + c^*_1)/2$,
!  see \sect{sec:cmueA} and \sect{sec:cmueC}, respectively.
!  The above limit corresponds to nearly isotropic turbulence supporting a very
!  small momentum flux caused by a very small shear.

!  Note that $\hat{c}_\mu^\text{sf} = (c_\mu^0)^3 c_\mu^\text{sf}$ according to
!  \eq{cmuConversion}.
!
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: turb_method
   integer, intent(in)                 :: stab_method
   integer, intent(in)                 :: scnd_method
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
     REALTYPE                :: a1,a3,N
!
!-----------------------------------------------------------------------
!BOC

     if (turb_method.eq.first_order) then

        select case(stab_method)
        case(Constant)
           cm0  = cm0_fix
           cmsf = cm0_fix
        case(MunkAnderson)
           cm0  = cm0_fix
           cmsf = cm0_fix
        case(SchumGerz)
           cm0  = cm0_fix
           cmsf = cm0_fix
        case(EiflerSchrimpf)
           cm0  = cm0_fix
           cmsf = cm0_fix
        case default

           STDERR '... not a valid stability function to compute cm0'
             STDERR 'Choose different value for stab_method'
             STDERR 'Program execution stopped ...'
             stop 'turbulence.F90'

          end select
       endif

       if (turb_method.eq.second_order) then

          a1    =  2./3. - cc2/2.
          a3    =  1.    - cc4/2.

          N     =  cc1/2.

          cm0   =  ( (a2**2. - 3.*a3**2. + 3.*a1*N)/(3.* N**2.) )**0.25
          cmsf  =   a1/N/cm0**3

       endif

       return
     end subroutine compute_cm0
!EOC


!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Boundary conditons for the k-equation (k-epsilon style) \label{sec:kBC}
!
! !INTERFACE:

   REALTYPE function k_bc(bc,type,zi,z0,u_tau)
!
!
! !DESCRIPTION:
! Computes prescribed and flux boundary conditions for  the transport
! equation \eq{tkeA}. The formal parameter {\tt bc} determines
! whether {\tt Dirchlet} or {\tt Neumann}-type boundary conditions
! are computed. Depending on the physical properties of the
! boundary-layer, the parameter {\tt type} relates either to a {\tt visous},
! a {\tt logarithmic}, or an {\tt injection}-type boundary-layer.
! In the latter case, the flux of TKE caused by breaking surface waves
! has to be specified. Presently, there is only one possibility
! to do so implemented in GOTM. It is described in \sect{sec:fkCraig}.
! All parameters that determine the boundary layer have to be
! set in {\tt gotmturb.nml}.
!
! Note that  in this section, for brevity, $z$ denotes the distance
! from the wall (or the surface), and \emph{not} the standard
! coordinate of the same name used in GOTM.
!
! \vspace{6mm}
! {\bf Viscous boundary-layers}
! \vspace{4mm}
!
! This type is not implemented yet in GOTM.
!
! \vspace{6mm}
! {\bf Logarithmic boundary-layers}
! \vspace{4mm}
!
! The Dirichlet (prescribed) boundary condition follows from \eq{kLog} as
! \begin{equation}
!   \label{KE_k_Dirichlet}
!   k= \dfrac{u_*^2}{(c_\mu^0)^2}
!   \point
!  \end{equation}
!
! The Neumann (flux) boundary condition can be derived from
! the constancy of  $k$ in the logarithmic region. This fact
! can be written as
! \begin{equation}
!   \label{KE_k_Neumann}
!   F_k = - \dfrac{\nu_t}{\sigma_k} \partder{k}{z} = 0
!   \point
! \end{equation}
!
! \vspace{6mm}
! {\bf Shear-free boundary-layers with injection of TKE}
! \vspace{4mm}
!
! The Dirichlet (prescribed) boundary condition follows simply
! from the power-law in \eq{power_law},
! \begin{equation}
!   \label{KE_k_wave_Dirichlet}
!   k= K (z+z_0)^\alpha
!   \point
! \end{equation}
!
! The Neumann (flux) boundary condition can be written as
! \begin{equation}
!   \label{KE_k_wave_Neumann}
!   F_k = - \dfrac{\nu_t}{\sigma_k} \partder{k}{z} =
!   - \dfrac{c_\mu}{\sigma_k} K^\frac{3}{2} L \alpha (z+z_0)^{\frac{3}{2} \alpha}
!   \comma
! \end{equation}
! which follows immediately from \eq{power_law} and the expression for
! the turbulent diffusivity, \eq{nu}. The parameter $K$ can be determined
! from an evaluation of \eq{KE_k_wave_Neumann} at $z=0$. The result is
! \begin{equation}
!   \label{K}
!   K = \left( -\dfrac{\sigma_k}{c_\mu \alpha L} F_k \right)^\frac{2}{3} \dfrac{1}{z_0^\alpha}
!  \comma
! \end{equation}
! where the specification of the flux $F_k$ and the value of $z_0$ have to be
! determined from a suitable model of the wave breaking process.
!
! !USES:
     IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: bc,type
   REALTYPE, intent(in)                :: zi,z0,u_tau
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
   REALTYPE                  :: K
   REALTYPE                  :: f_k
   REALTYPE, external        :: fk_craig
!
!-----------------------------------------------------------------------
!BOC
! check for correct function call

   select case(type)

      case(viscous)
         STDERR 'Sorry, viscous boundary layers not yet implemented.'
         STDERR 'Please change gotmturb.nml accordingly'
         STDERR 'Program aborts now in turbulence.F90'
         stop

      case(logarithmic)
         if (bc.eq.Dirichlet) then
            k_bc = u_tau**2./cm0**2.
         else
            k_bc = 0.
         endif

      case(injection)
         ! compute the capital K from the analytical solution
         ! for shear-free flows

         ! compute the flux of k from the wave-breaking model
         f_k  = fk_craig(u_tau,cw)

         K    = (-sig_k*f_k/(cmsf*gen_alpha*gen_l) )**(2./3.) / z0**gen_alpha

         if (bc.eq.Dirichlet) then
            k_bc = K*(zi+z0)**gen_alpha
         else
            k_bc = -cmsf/sig_k*K**1.5*gen_alpha*gen_l*(zi+z0)**(1.5*gen_alpha)
         endif

      case default
   end select

   return
   end function k_bc
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Boundary conditons for the k-equation (Mellor-Yamada style)\label{sec:q2over2BC}
!
! !INTERFACE:
   REALTYPE function  q2over2_bc(bc,type,zi,z0,u_tau)
!
!
! !DESCRIPTION:
! Computes prescribed and flux boundary conditions for  the transport
! equation \eq{tkeB}. The formal parameter {\tt bc} determines
! whether {\tt Dirchlet} or {\tt Neumann}-type boundary conditions
! are computed. Depending on the physical properties of the
! boundary-layer, the parameter {\tt type} relates either to a {\tt visous},
! a {\tt logarithmic}, or an {\tt injection}-type boundary-layer.
! In the latter case, the flux of TKE caused by breaking surface waves
! has to be specified. Presently, there is only one possibility
! to do so implemented in GOTM. It is described in \sect{sec:fkCraig}.
! All parameters that determine the boundary layer have to be
! set in {\tt gotmturb.nml}.
!
! Note that  in this section, for brevity, $z$ denotes the distance
! from the wall (or the surface), and \emph{not} the standard
! coordinate of the same name used in GOTM.
!
! \vspace{6mm}
! {\bf Viscous boundary-layers}
! \vspace{4mm}
!
! This type is not implemented yet in GOTM.
!
! \vspace{6mm}
! {\bf Logarithmic boundary-layers}
! \vspace{4mm}
!
! The Dirichlet (prescribed) boundary condition follows from \eq{kLog}
! and \eq{B1} as
! \begin{equation}
!   \label{MY_k_Dirichlet}
!   q^2/2= \dfrac{u_*^2 B_1^\frac{2}{3}}{2}
!   \point
! \end{equation}
!
! The Neumann (flux) boundary condition can be derived from
! the constancy of  $q^2/2$ in the logarithmic region. This fact
! can be written as
! \begin{equation}
!   \label{MY_k_Neumann}
!   F_q = - S_q q l \partder{k}{z} = 0
!   \point
! \end{equation}
!
! \vspace{6mm}
! {\bf Shear-free boundary-layers with injection of TKE}
! \vspace{4mm}
!
! The Dirichlet (prescribed) boundary condition follows simply
! from the power-law in \eq{power_law},
! \begin{equation}
!   \label{MY_k_wave_Dirichlet}
!   \frac{q^2}{2} = k = K (z+z_0)^\alpha
!  \point
! \end{equation}
!
! The Neumann (flux) boundary condition can be written as
! \begin{equation}
!   \label{MY_k_wave_Neumann}
!   F_q = - S_q q l \partder{k}{z} =
!   - \sqrt{2} S_q  K^\frac{3}{2} \alpha L (z+ z_0)^{\frac{3}{2} \alpha}
!   \comma
! \end{equation}
! which follows immediately from \eq{power_law}.
! The parameter $K$ can be determined
! from an evaluation of \eq{MY_k_wave_Neumann} at $z=0$. The result is
! \begin{equation}
!   \label{MY_K}
!   K = \left( - \dfrac{F_q}{\sqrt{2} S_q \alpha L} \right)^\frac{2}{3}
!        \dfrac{1}{z_0^\alpha}
!    \comma
! \end{equation}
! where the specification of the flux $F_q$ and the value of $z_0$ have to be
! determined from a suitable model of the wave breaking process.
!
! !USES:
     IMPLICIT NONE
!
! !INPUT PARAMETERS:
  integer, intent(in)                  :: bc,type
  REALTYPE, intent(in)                 :: zi,z0,u_tau
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
      REALTYPE               :: K
      REALTYPE               :: f_k
      REALTYPE, external     :: fk_craig
!
!-----------------------------------------------------------------------
!BOC
! Compute the boundary conditions
   select case(type)

      case(viscous)
         STDERR 'Sorry, viscous boundary layers not yet implemented.'
         STDERR 'Please change gotmturb.nml accordingly'
         STDERR 'Program aborts now in turbulence.F90'
         stop

      case(logarithmic)
         if (bc.eq.Dirichlet) then
            q2over2_bc = u_tau**2.*b1**(2./3.)/2.
         else
            q2over2_bc = 0.
         endif

      case(injection)
         ! compute the capital K from the analytical solution
         ! of shear-free flows and from f_k given by the wave-breaking model

         ! compute the flux of k from the wave-breaking model
         f_k  = fk_craig(u_tau,cw)

         K = ( -f_k/(sqrt(2.)*sq*gen_alpha*gen_l) )**(2./3.) / z0**gen_alpha

         if (bc.eq.Dirichlet) then
            q2over2_bc = K*(zi+z0)**gen_alpha
         else
            q2over2_bc = -sqrt(2.)*sq*K**1.5*gen_alpha*gen_l* &
                         (zi+z0)**(1.5*gen_alpha)
         endif

      case default
   end select
   end function q2over2_bc
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Boundary conditons for the epsilon-equation\label{sec:epsilonBC}
!
! !INTERFACE:
   REALTYPE function  epsilon_bc(bc,type,zi,ki,z0,u_tau)
!
!
!DESCRIPTION:
! Computes prescribed and flux boundary conditions for  the transport
! equation \eq{dissipation}. The formal parameter {\tt bc} determines
! whether {\tt Dirchlet} or {\tt Neumann}-type boundary conditions
! are computed. Depending on the physical properties of the
! boundary-layer, the parameter {\tt type} relates either to a {\tt visous},
! a {\tt logarithmic}, or an {\tt injection}-type boundary-layer.
! In the latter case, the flux of TKE caused by breaking surface waves
! has to be specified. Presently, there is only one possibility
! to do so implemented in GOTM. It is described in \sect{sec:fkCraig}.
! All parameters that determine the boundary layer have to be
! set in {\tt gotmturb.nml}.
!
! Note that  in this section, for brevity, $z$ denotes the distance
! from the wall (or the surface), and \emph{not} the standard
! coordinate of the same name used in GOTM.
!
! \vspace{6mm}
! {\bf Viscous boundary-layers}
! \vspace{4mm}
!
! This type is not implemented yet in GOTM.
!
! \vspace{6mm}
! {\bf Logarithmic boundary-layers}
! \vspace{4mm}
!
! The Dirichlet (prescribed) boundary condition follows from \eq{epsilon} as
! \begin{equation}
!   \label{KE_e_Dirichlet}
!   \epsilon= \dfrac{(c_\mu^0)^3 k^\frac{3}{2}}{\kappa (z+z_0)}
!   \comma
! \end{equation}
! where we used the law-of-the-wall relation $l=\kappa(z+z_0)$.
!
! The Neumann (flux) boundary condition can be expressed as
! \begin{equation}
!   \label{KE_e_Neumann}
!   F_\epsilon = - \dfrac{\nu_t}{\sigma_\epsilon} \partder{\epsilon}{z}
!   = \dfrac{(c_\mu^0)^4}{\sigma_\epsilon}  \dfrac{k^2}{z+z_0}
!   \comma
! \end{equation}
! by inserting $l=\kappa(z+z_0)$ into the expression for the
! diffusivity in \eq{nu}. Note, that in \eq{KE_e_Dirichlet} and
! \eq{KE_e_Neumann}, we use {\tt ki}, the value of $k$ at the current time
! step, to compute the boundary conditions. By means of
! \eq{kLog}, it would have been also possible to express the boundary
! conditions in terms of the friction velocity, $u_*$. This, however,
! causes numerical difficulties in case of a stress-free surface
! boundary-layer as for example in the pressure-driven open channel
! flow.
!
! \vspace{6mm}
! {\bf Shear-free boundary-layers with injection of TKE}
! \vspace{4mm}
!
! The Dirichlet (prescribed) boundary condition follows simply
! from the power-law \eq{power_law} inserted in \eq{epsilon}. This
! yields
! \begin{equation}
!   \label{KE_e_wave_Dirichlet}
!   \epsilon= (c_\mu^0)^3 K^\frac{3}{2} L^{-1} (z+z_0)^{\frac{3}{2}\alpha - 1}
!   \point
! \end{equation}
!
! The Neumann (flux) boundary condition is
! \begin{equation}
!   \label{KE_e_wave_Neumann}
!   F_\epsilon = - \dfrac{\nu_t}{\sigma_\epsilon} \partder{\epsilon}{z} =
!   - \dfrac{c_\mu (c_\mu^0)^3}{\sigma_\epsilon} K^2 \left( \dfrac{3}{2}
!     \alpha -1  \right) (z+z_0)^{2\alpha-1}
!     \comma
! \end{equation}
! which follows from \eq{power_law} and \eq{nu}. The parameter $K$ is
! computed as described in the context of \eq{K}.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: bc,type
   REALTYPE, intent(in)                :: zi,ki,z0,u_tau
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
     REALTYPE                :: K
     REALTYPE                :: f_k
     REALTYPE, external      :: fk_craig
!
!-----------------------------------------------------------------------
!BOC
! Compute the boundary conditions
   select case(type)
      case(viscous)
         STDERR 'Sorry, viscous boundary layers not yet implemented.'
         STDERR 'Please change gotmturb.nml accordingly'
         STDERR 'Program aborts now in turbulence.F90'
         stop
      case(logarithmic)
         if (bc.eq.Dirichlet) then
            epsilon_bc = cde*ki**1.5/(kappa*(zi+z0))
         else
            epsilon_bc = cm0**4.*ki**2./(sig_e*(zi+z0))
         endif
      case(injection)
         ! compute the capital K from the analytical solution
         ! for shear-free flows
         ! compute the flux of k from the wave-breaking model
         f_k  = fk_craig(u_tau,cw)

         K    = (-sig_k*f_k/(cmsf*gen_alpha*gen_l) )**(2./3.) / z0**gen_alpha

         if (bc.eq.Dirichlet) then
            epsilon_bc = cde*K**1.5/gen_l*(zi+z0)**(1.5*gen_alpha-1.)
         else
            epsilon_bc = -cmsf*cde/sig_e0*K**2. &
                         *(1.5*gen_alpha-1.)*(zi+z0)**(2.*gen_alpha-1.)
         endif
      case default
   end select
    end function epsilon_bc
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Boundary conditons for the psi-equation  \label{sec:psiBC}
!
! !INTERFACE:
   REALTYPE function  psi_bc(bc,type,zi,ki,z0,u_tau)
!
!DESCRIPTION:
! Computes prescribed and flux boundary conditions for  the transport
! equation \eq{generic}. The formal parameter {\tt bc} determines
! whether {\tt Dirchlet} or {\tt Neumann}-type boundary conditions
! are computed. Depending on the physical properties of the
! boundary-layer, the parameter {\tt type} relates either to a {\tt visous},
! a {\tt logarithmic}, or an {\tt injection}-type boundary-layer.
! In the latter case, the flux of TKE caused by breaking surface waves
! has to be specified. Presently, there is only one possibility
! to do so implemented in GOTM. It is described in \sect{sec:fkCraig}.
! All parameters that determine the boundary layer have to be
! set in {\tt gotmturb.nml}.
!
! Note that  in this section, for brevity, $z$ denotes the distance
! from the wall (or the surface), and \emph{not} the standard
! coordinate of the same name used in GOTM.
!
! \vspace{6mm}
! {\bf Viscous boundary-layers}
! \vspace{4mm}
!
! This type is not implemented yet in GOTM.
!
! \vspace{6mm}
! {\bf Logarithmic boundary-layers}
! \vspace{4mm}
!
! The Dirichlet (prescribed) boundary condition follows from \eq{psi_l} as
! \begin{equation}
!   \label{GE_psi_Dirichlet}
!   \psi = (c_\mu^0)^p \kappa^n k^m \left( z+z_0 \right)^n
!   \comma
! \end{equation}
! where we used the law-of-the-wall relation $l=\kappa(z+z_0)$.
!
! Neumann (flux) boundary condition can be written as
! \begin{equation}
!   \label{GE_psi_Neumann}
!   F_\psi = - \dfrac{\nu_t}{\sigma_\psi} \partder{\psi}{z} =
!   - \dfrac{ n (c_\mu^0)^{p+1} \kappa^{n+1}}{\sigma_\psi} k^{m+\frac{1}{2}} (z+z_0)^n
! \end{equation}
! by inserting $l=\kappa(z+z_0)$ into the expression for the
! diffusivity in \eq{nu}. Note, that in \eq{GE_psi_Dirichlet} and
! \eq{GE_psi_Neumann}, we use {\tt ki}, the value of $k$ at the current time
! step, to compute the boundary conditions. By means of
! \eq{kLog}, it would have been also possible to express the boundary
! conditions in terms of the friction velocity, $u_*$. This, however,
! causes numerical difficulties in case of a stress-free surface
! boundary-layer as for example in the pressure-driven open channel
! flow.
!
! \vspace{6mm}
! {\bf Shear-free boundary-layers with injection of TKE}
! \vspace{4mm}
!
! The Dirichlet (prescribed) boundary condition follows simply
! from the power-law \eq{power_law} inserted in \eq{psi_l}. This
! yields
! \begin{equation}
!   \label{GE_psi_wave_Dirichlet}
!   \psi= (c_\mu^0)^p K^m  L^n (z+z_0)^{m \alpha + n}
!   \point
! \end{equation}
!
! The Neumann (flux) boundary condition is
! \begin{equation}
!   \label{GE_psi_wave_Neumann}
!   F_\psi = - \dfrac{\nu_t}{\sigma_\psi} \partder{\psi}{z} =
!   - \dfrac{c_\mu (c_\mu^0)^p}{\sigma_\psi} \left(m\alpha + n  \right)
!      K^{m+\frac{1}{2}} L^{n+1}
!  (z+z_0)^{(m+\frac{1}{2})\alpha+n}
!  \comma
! \end{equation}
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: bc,type
   REALTYPE, intent(in)                :: zi,ki,z0,u_tau
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
     REALTYPE                            :: K
     REALTYPE                            :: f_k
     REALTYPE, EXTERNAL                  :: fk_craig
!
!-----------------------------------------------------------------------
!BOC
! Compute the boundary conditions
   select case(type)
      case(viscous)
         STDERR 'Sorry, viscous boundary layers not yet implemented.'
         STDERR 'Please change gotmturb.nml accordingly'
         STDERR 'Program aborts now in turbulence.F90'
         stop
      case(logarithmic)
         if (bc.eq.Dirichlet) then
            psi_bc = cm0**gen_p*kappa**gen_n*ki**gen_m*(zi+z0)**gen_n
         else
            psi_bc = - gen_n*cm0**(gen_p+1.)*kappa**(gen_n+1.)/sig_psi      &
                       *ki**(gen_m+0.5)*(zi+z0)**gen_n
         endif
      case(injection)
         ! compute the capital K from the analytical solution
         ! of shear-free flows and from f_k given by the wave-breaking model

         ! compute the flux of k from the wave-breaking model
         f_k  = fk_craig(u_tau,cw)

         K    = (-sig_k*f_k/(cmsf*gen_alpha*gen_l) )**(2./3.) / z0**gen_alpha

         if (bc.eq.Dirichlet) then
            psi_bc = cm0**gen_p*K**gen_m*gen_l**gen_n &
                     *(zi+z0)**(gen_m*gen_alpha+gen_n)
         else
            psi_bc = - (gen_m*gen_alpha+gen_n)*cmsf*cm0**gen_p/sig_psi &
                         *K**(gen_m+0.5)*gen_l**(gen_n+1.) &
                         *(zi+z0)**((gen_m+0.5)*gen_alpha+gen_n)
         endif
      case default
   end select
   end function psi_bc
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Boundary conditons for the q2l-equation\label{sec:q2lBC}
!
! !INTERFACE:
   REALTYPE function  q2l_bc(bc,type,zi,ki,z0,u_tau)
!
!
! !DESCRIPTION:
! Computes prescribed and flux boundary conditions for  the transport
! equation \eq{MY}. The formal parameter {\tt bc} determines
! whether {\tt Dirchlet} or {\tt Neumann}-type boundary conditions
! are computed. Depending on the physical properties of the
! boundary-layer, the parameter {\tt type} relates either to a {\tt visous},
! a {\tt logarithmic}, or an {\tt injection}-type boundary-layer.
! In the latter case, the flux of TKE caused by breaking surface waves
! has to be specified. Presently, there is only one possibility
! to do so implemented in GOTM. It is described in \sect{sec:fkCraig}.
! All parameters that determine the boundary layer have to be
! set in {\tt gotmturb.nml}.
!
! Note that  in this section, for brevity, $z$ denotes the distance
! from the wall (or the surface), and \emph{not} the standard
! coordinate of the same name used in GOTM.
!
! \vspace{6mm}
! {\bf Viscous boundary-layers}
! \vspace{4mm}
!
! This type is not implemented yet in GOTM.
!
! \vspace{6mm}
! {\bf Logarithmic boundary-layers}
! \vspace{4mm}
!
! The Dirchlet (prescribed) boundary conditions can be written as
! \begin{equation}
!   \label{MY_q2l_Dirichlet}
!   q^2 l = 2 \kappa k (z+z_0)
!  \comma
! \end{equation}
! where we used the law-of-the-wall relation $l=\kappa(z+z_0)$.
!
! Neumann (flux) boundary condition can be written as
! \begin{equation}
!   \label{MY_q2l_Neumann}
!   F_l = - S_l q l \partder{q^2 l}{z}
!      = - 2 \sqrt{2} S_l \kappa^2 k^\frac{3}{2} (z+z_0)
! \end{equation}
! by inserting $l=\kappa(z+z_0)$ ($q$ is constant in the log-layer).
! Note, that in \eq{MY_q2l_Dirichlet} and
! \eq{MY_q2l_Neumann}, we use {\tt ki}, the value of $k$ at the current time
! step, to compute the boundary conditions. By means of
! \eq{kLog}, it would have been also possible to express the boundary
! conditions in terms of the friction velocity, $u_*$. This, however,
! causes numerical difficulties in case of a stress-free surface
! boundary-layer as for example in the pressure-driven open channel
! flow.
!
! \vspace{6mm}
! {\bf Shear-free boundary-layers with injection of TKE}
! \vspace{4mm}
!
! The Dirichlet (prescribed) boundary condition follows simply
! from the power-law \eq{power_law}, yielding
! \begin{equation}
!   \label{MY_q2l_wave_Dirichlet}
!   q^2 l = 2 K  L (z+z_0)^{\alpha + 1}
!   \point
! \end{equation}
!
! Neumann (flux) boundary condition is
! \begin{equation}
!   \label{MY_q2l_wave_Neumann}
!   F_l = - S_l q l \partder{q^2 l}{z} =
!   - 2 \sqrt{2} S_l  (\alpha+1) K^\frac{3}{2}  L^2 (z+ z_0)^{\frac{3}{2} \alpha + 1}
!   \comma
! \end{equation}
! which follows from \eq{power_law}. The parameter $K$ is
! computed as described in the context of \eq{MY_K}.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: bc,type
   REALTYPE, intent(in)                :: zi,ki,z0,u_tau
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
     REALTYPE                            :: K
     REALTYPE                            :: f_k
     REALTYPE, EXTERNAL                  :: fk_craig
!
!-----------------------------------------------------------------------
!BOC
! Compute the boundary conditions
   select case(type)
      case(viscous)
         STDERR 'Sorry, viscous boundary layers not yet implemented.'
         STDERR 'Please change gotmturb.nml accordingly'
         STDERR 'Program aborts now in turbulence.F90'
         stop
      case(logarithmic)
         if (bc.eq.Dirichlet) then
            q2l_bc = 2.*kappa*ki*(zi+z0)
         else
            q2l_bc = -2.*sqrt(2.)*sl*kappa**2.*ki**1.5*(zi+z0)
         endif
      case(injection)
         ! compute the capital K from the analytical solution
         ! of shear-free flows and from f_k given by the wave-breaking model

         ! compute the flux of k from the wave-breaking model
         f_k  = fk_craig(u_tau,cw)

         K = ( -f_k/(sqrt(2.)*sq*gen_alpha*gen_l) )**(2./3.) / z0**gen_alpha

         if (bc.eq.Dirichlet) then
            q2l_bc = 2.*K*gen_l*(zi+z0)**(gen_alpha+1.)
         else
            q2l_bc = -2.*sqrt(2.)*sl*(gen_alpha+1.)*K**1.5 &
                        *gen_l**2.*(zi+z0)**(1.5*gen_alpha+1.)
         endif
      case default
   end select
   end function q2l_bc
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Clean up the turbulence module
!
! !INTERFACE:
   subroutine clean_turbulence()
!
! !DESCRIPTION:
!  De-allocate all memory allocated in init\_turbulence().
!
! !USES:
   IMPLICIT NONE
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding
!
!EOP
!-----------------------------------------------------------------------
!BOC
   if(mpp_pe() == mpp_root_pe()) then
   LEVEL1 'clean_turbulence'

   LEVEL2 'de-allocating turbulence memory ...'
   endif
   if (allocated(tke)) deallocate(tke)
   if (allocated(tkeo)) deallocate(tkeo)
   if (allocated(eps)) deallocate(eps)
   if (allocated(L)) deallocate(L)
   if (allocated(kb)) deallocate(kb)
   if (allocated(epsb)) deallocate(epsb)
   if (allocated(P)) deallocate(P)
   if (allocated(B)) deallocate(B)
   if (allocated(Pb)) deallocate(Pb)
   if (allocated(num)) deallocate(num)
   if (allocated(nuh)) deallocate(nuh)
   if (allocated(nus)) deallocate(nus)
   if (allocated(gamu)) deallocate(gamu)
   if (allocated(gamv)) deallocate(gamv)
   if (allocated(gamb)) deallocate(gamb)
   if (allocated(gamh)) deallocate(gamh)
   if (allocated(gams)) deallocate(gams)
   if (allocated(cmue1)) deallocate(cmue1)
   if (allocated(cmue2)) deallocate(cmue2)
   if (allocated(gam)) deallocate(gam)
   if (allocated(an)) deallocate(an)
   if (allocated(as)) deallocate(as)
   if (allocated(at)) deallocate(at)
   if (allocated(r)) deallocate(r)
   if (allocated(Rig)) deallocate(Rig)
   if (allocated(xRf)) deallocate(xRf)
   if (allocated(uu)) deallocate(uu)
   if (allocated(vv)) deallocate(vv)
   if (allocated(ww)) deallocate(ww)
# ifdef EXTRA_OUTPUT
   if (allocated(turb1)) deallocate(turb1)
   if (allocated(turb2)) deallocate(turb2)
   if (allocated(turb3)) deallocate(turb3)
   if (allocated(turb4)) deallocate(turb4)
   if (allocated(turb5)) deallocate(turb5)
# endif
   if(mpp_pe() == mpp_root_pe()) then
   LEVEL2 'done.'
   endif

   return
   end subroutine clean_turbulence

#ifdef _PRINTSTATE_
!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Print the current state of the turbulence module.
!
! !INTERFACE:
   subroutine print_state_turbulence()
!
! !DESCRIPTION:
!  This routine writes the value of all module-level variables to screen.
!
! !USES:
   IMPLICIT NONE
!
! !REVISION HISTORY:
!  Original author(s): Jorn Bruggeman
!
!EOP
!-----------------------------------------------------------------------
!BOC
   if (turb_method.eq.99) return

   if(mpp_pe() == mpp_root_pe()) then

   LEVEL1 'State of turbulence module:'
   LEVEL2 'tke,eps,L',tke,eps,L
   LEVEL2 'tkeo',tkeo
   LEVEL2 'kb,epsb',kb,epsb
   LEVEL2 'P,B,Pb',P,B,Pb
   LEVEL2 'num,nuh,nus',num,nuh,nus
   LEVEL2 'gamu,gamv',gamu,gamv
   LEVEL2 'gamb,gamh,gams',gamb,gamh,gams
   LEVEL2 'cmue1,cmue2',cmue1,cmue2
   LEVEL2 'gam',gam
   LEVEL2 'as,an,at',as,an,at
   LEVEL2 'r',r
   LEVEL2 'Rig',Rig
   LEVEL2 'xRf',xRf
   LEVEL2 'uu,vv,ww',uu,vv,ww

#ifdef EXTRA_OUTPUT
   LEVEL2 'turb1',turb1
   LEVEL2 'turb2',turb2
   LEVEL2 'turb3',turb3
   LEVEL2 'turb4',turb4
   LEVEL2 'turb5',turb5
#endif

   LEVEL2 'cm0,cmsf,cde,rcm, b1',cm0,cmsf,cde,rcm, b1
   LEVEL2 'Prandtl0',Prandtl0
   LEVEL2 'craig_m,sig_e0',craig_m,sig_e0

   LEVEL2 'turbulence namelist', turb_method,tke_method,       &
                            len_scale_method,stab_method

   LEVEL2 'bc namelist',    k_ubc,k_lbc,kb_ubc,kb_lbc,         &
                            psi_ubc,psi_lbc,                   &
                            ubc_type,lbc_type

   LEVEL2 'turb_param namelist', cm0_fix,Prandtl0_fix,cw,           &
                            compute_kappa,kappa,               &
                            compute_c3,ri_st,length_lim,galp,  &
                            const_num,const_nuh,k_min,eps_min, &
                            kb_min,epsb_min

   LEVEL2 'generic namelist', compute_param,gen_m,gen_n,gen_p,   &
                            cpsi1,cpsi2,cpsi3minus,cpsi3plus,  &
                            sig_kpsi,sig_psi,                  &
                            gen_d,gen_alpha,gen_l

   LEVEL2 'keps namelist',  ce1,ce2,ce3minus,ce3plus,sig_k,    &
                            sig_e,sig_peps

   LEVEL2 'my namelist',    e1,e2,e3,sq,sl,my_length,new_constr

   LEVEL2 'scnd namelist',  scnd_method,kb_method,epsb_method, &
                            scnd_coeff,                        &
                            cc1,cc2,cc3,cc4,cc5,cc6,           &
                            ct1,ct2,ct3,ct4,ct5,ctt

   LEVEL2 'a1,a2,a3,a4,a5',a1,a2,a3,a4,a5
   LEVEL2 'at1,at2,at3,at4,at5',at1,at2,at3,at4,at5

   LEVEL2 'iw namelist',    iw_model,alpha,klimiw,rich_cr,     &
                            numiw,nuhiw,numshear
   endif

   end subroutine print_state_turbulence
!EOC
#endif

!-----------------------------------------------------------------------

 end module turbulence

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

#include <fms_platform.h>

module transport_matrix_mod  !{
!
!<CONTACT EMAIL="spk@ldeo.columbia.edu"> Samar Khatiwala
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Rick Slater
!</REVIEWER>
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies 
!</REVIEWER>
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Jennifer Simeon
!</REVIEWER>
!
!<OVERVIEW>
! Transport Matrix Method
!</OVERVIEW>
!
!<DESCRIPTION>
! Transport Matrix Method, for use in finding an approximate steady 
! state of tracers.  
!
! Ported to MOM4p0d by Samar Khatiwala spk@ldeo.columbia.edu 
! June-July 2007
!
! Ported to MOM4p1 by Stephen.Griffies 
! July 2007
!
! Some code clean-up; increased conformity to tracer module standard 
! jes.13JUN08
!
! further code cleanup by Richard.Slater Jan2009.
!
! **Preliminary testing only.
!
! This module saves out the components of the explicit and implicit
! transport matrix.  spk uses the output from the transport matrix module  
! to assemble the actual transport matrix with his matlab code.
! 
! In conjunction with the Newton-Krylov (NK) solver, the transport matrix 
! is used to do an accelerated forward model in an iterative manner
! which allows the NK solver to reach solution convergence with greater 
! efficiency.
!
! To create the transport matrix building blocks, passive, prognostic
! "tracers" are simulated.  These "tracers" are, in practice, dye
! tracers initialized to 1 at one or more grid points and initialized 
! to 0 elsewhere.  Since the "area of influence" of
! a tracer at a particular grid point is determined by the advection scheme,
! it becomes more practical to introduce a number of dye tracers at other
! grid points, such that the "tracers" are staggered and will have 
! non-overlapping areas of influence. These non-overlapping regions are
! called by spk, "tiles".  The total number of dye tracers 
! needed is independent of the horizontal grid resolution, but
! rather dependent upon the advection scheme's area of influence, i.e.
! the total number of grid points contained in a "tile". For a
! simple linear advection scheme, the number of tracers needed is about
! 10 x (number of vertical levels).
! spk has some special matlab code that generates the initial condition 
! for the "tracers", given the grid_spec of the model.
!
! The behavior of the tracers' advection and diffusion is averaged over 
! time (which the user may specify) and is saved out as a component 
! of the later-to-be-assembled transport matrix.
!
! To run the transport_matrix module, an initial condition
! must be created by spk.
! 
! Include the transport_matrix field_table and diag_table entries
! for the xml. Examples of these follow.
!
! Sample field table.
! -------------------------------------------------
! "tracer_packages","ocean_mod","transport_matrix"
!
! names = '01', '02', '03'
! horizontal-advection-scheme = mdfl_sweby
! vertical-advection-scheme = mdfl_sweby
! /
!
! --------------------------------------------------
!
! Sample diag table entry: enter as many "tracers" as you need
!                          with the naming convention exp_tm_# and imp_tm_#
!                          where # is a string as given abaove in "names"
! --------------------------------------------------
!"transport_matrix","exp_tm_01",  "exp_tm_01" ,"ocean_transport_matrix","all",.false.,"none",1
!"transport_matrix","imp_tm_01",  "imp_tm_01" ,"ocean_transport_matrix","all",.false.,"none",1
!"transport_matrix","exp_tm_02",  "exp_tm_02" ,"ocean_transport_matrix","all",.false.,"none",1
!"transport_matrix","imp_tm_02",  "imp_tm_02" ,"ocean_transport_matrix","all",.false.,"none",1
!"transport_matrix","exp_tm_03",  "exp_tm_03" ,"ocean_transport_matrix","all",.false.,"none",1
!"transport_matrix","imp_tm_03",  "imp_tm_03" ,"ocean_transport_matrix","all",.false.,"none",1
! --------------------------------------------------
!
!  
! SPK NOTES:
! 1) The calling sequence is as follows:
!  Top level driver (e.g., ocean_solo)
!    -> S/R ocean_model_init(Ocean, Time_init, Time_in, Time_step_ocean, ensemble_ocean)
!		Time%init       = Time_in .eq. Time_init
!		Time%Time_init  = Time_init
!		Time%Time_step  = Time_step_ocean
!		Time%model_time = Time_in
!		Time%itt        = 0
!		-> S/R ocean_prog_tracer_init 
!		   -> S/R ocean_tpm_init
!			  -> S/R transport_matrix_init
!		-> S/R ocean_tpm_start
!		   -> S/R transport_matrix_start
!	 Start time stepping loop
!	 do nc=1, num_cpld_calls     
!	   do no=1, num_ocean_calls
!		  ocean_seg_start = ( no .eq. 1 )     
!		  ocean_seg_end   = ( no .eq. num_ocean_calls )
!		  -> S/R update_ocean_model(Ice_ocean_boundary, Ocean_sfc, &
!                                           ocean_seg_start, ocean_seg_end, num_ocean_calls)
!			 Time%model_time = Time%model_time + Time%Time_step
!			 Time%itt        = Time%itt+1
!			 -> S/R ocean_tracer, S/R update_ocean_tracer              
!			 	   do explicit transport
!				   -> S/R transport_matrix_store_explicit 
!                                   (accumulate explicit matrix and reset tracer field to initial condition)
!  	 			   do implicit transport
!			 -> S/R ocean_tpm_tracer
!			    -> S/R transport_matrix_store_implicit 
!                           (accumulate implicit matrix and reset tracer field to initial condition)
!				   -> S/R transport_matrix_write(.FALSE.) (time average and write matrices)
!		  Time = Time + Time_step_ocean
!	   enddo
!	 enddo
!    -> S/R ocean_model_end
!       -> S/R ocean_tpm_end
!          -> S/R transport_matrix_end
!             -> S/R transport_matrix_write(.TRUE.) 
!                (time average and write matrices for multi year runs)
!
! 2) Time counters are incremented BEFORE calling S/R update_ocean_tracer, so the first time 
!    transport_matrix_store_explicit is called, itt (and hence myIter) will be 1.
!    The namelist parameter matrixStoreStartIter indicating the iteration number to begin 
!    accumulating matrices at should be RELATIVE to the current model run start (unlike 
!    in the MIT GCM where it refers to an absolute counter.
!    I am not entirely certain this is handled correctly below. Things might be off by 
!    1 time step.
!
!
!

!</DESCRIPTION>
!
! <INFO>
! <REFERENCE>
!      Khatiwala, S., M. Visbeck, M.A. Cane, 2005.
!  Accelerated simulation of passive tracers in ocean circulation models. 
!  Ocean Modelling, 9, 51-69.
! </REFERENCE>
! </INFO>
!
! $Id: transport_matrix.F90,v 20.0 2013/12/14 00:17:24 fms Exp $
!

use field_manager_mod,  only: fm_string_len, fm_path_name_len, fm_field_name_len
use field_manager_mod,  only: fm_get_length, fm_get_value
use mpp_mod,            only: stdout, mpp_error, FATAL
use diag_manager_mod,   only: send_data, register_diag_field

use ocean_tpm_util_mod, only: otpm_set_tracer_package, otpm_set_prog_tracer
use ocean_types_mod,    only: ocean_time_type, ocean_prog_tracer_type

!
!       force all variables to be "typed"
!

implicit none

!
!       Set all variables to be private by default

private

!
!       Public routines
!

public  :: transport_matrix_init
public  :: transport_matrix_start
public  :: transport_matrix_store_explicit
public  :: transport_matrix_store_implicit

!
!       Private routines
!

!
!       Public parameters
!

!
!       Private parameters
!

character(len=fm_field_name_len), parameter     :: package_name = 'transport_matrix'
character(len=48), parameter                    :: diag_name = 'transport_matrix'
character(len=48), parameter                    :: mod_name = 'transport_matrix_mod'
character(len=fm_string_len), parameter         :: default_restart_file = 'transport_matrix.res.nc'

!
!       Public variables
!

logical, public :: do_transport_matrix

!
!       Private types
!

type instance_type
  character(len=fm_field_name_len)                   :: name
  real, dimension(:,:,:),  _ALLOCATABLE              :: initial_value _NULL
  integer                                            :: index
  integer                                            :: id_extm
  integer                                            :: id_imtm
end type instance_type

!
!       Private variables
!

type(instance_type), dimension(:), allocatable          :: instance
integer                                                 :: instances
integer                                                 :: package_index

contains

!#######################################################################
! <SUBROUTINE NAME="transport_matrix_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by tracer package manager
! </DESCRIPTION>
!

subroutine transport_matrix_init  !{

!
!       local parameters
!

character(len=64), parameter    :: sub_name = 'transport_matrix_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!-----------------------------------------------------------------------
!       local variables
!-----------------------------------------------------------------------
!

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=fm_field_name_len+3)                      :: long_suffix

  integer :: stdoutunit 
  stdoutunit=stdout() 

!
!       Initialize the ocean transport matrix package
!

package_index = otpm_set_tracer_package(package_name,               &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')',       &
     restart_file = default_restart_file)

!
!       Check whether to use this package
!

path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
instances = fm_get_length(path_to_names)
if (instances .lt. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
endif  !}

!
!       Check some things
!

write (stdoutunit,*)
if (instances .eq. 0) then  !{
  write (stdoutunit,*)                                            &
       trim(note_header), ' No instances'
  do_transport_matrix = .false.
else  !}{
  write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
  do_transport_matrix = .true.
endif  !}

!
!       Return if we don't want to use this package
!

if (.not. do_transport_matrix) then  !{
  return
endif  !}

!
!       allocate the instance structure
!

allocate ( instance(instances) )

!
!       loop over the names, saving them into the instance array

do n = 1, instances  !{

  if (fm_get_value(path_to_names, name, index = n)) then  !{
    instance(n)%name = name
  else  !}{
    write (name,*) n
    call mpp_error(FATAL, trim(error_header) //        &
         ' Bad field name for index ' // trim(name))
  endif  !}
   
enddo  !} n

do n = 1, instances !{

!----------------------------------------------------------------------------------------
! Register the prognostic tracers
!----------------------------------------------------------------------------------------

  ! Set up the instance name from field table
  name = instance(n)%name
  if (name(1:1) .eq. '_') then  !{
    suffix = ' '
    long_suffix = ' '
  else  !}{
    suffix = '_' // name
    long_suffix = ' (' // trim(name) // ')'
  endif  !}

  ! determine the tracer names for this instance and assign indices

   instance(n)%index = otpm_set_prog_tracer('ptr' // trim(suffix),                              &
        package_name, longname = 'Transport matrix passive tracer' // trim(long_suffix),        &
        units = 'unit/kg', flux_units = 'unit/m^2/s',                                           &
        caller = trim(mod_name)//'('//trim(sub_name)//')')

enddo  !} n

return

end subroutine transport_matrix_init  !}
! </SUBROUTINE> NAME="transort_matrix_init"

!#######################################################################
! <SUBROUTINE NAME="transport_matrix_start">
!
! <DESCRIPTION>
!
! </DESCRIPTION>
!
subroutine transport_matrix_start(Time, T_prog, isd, ied, jsd, jed, nk, &
                                  grid_tracer_axes)  !{

!-----------------------------------------------------------------------
!       modules (have to come first)
!-----------------------------------------------------------------------

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

  type(ocean_time_type),                      intent(in) :: Time
  type(ocean_prog_tracer_type), dimension(:), intent(in) :: T_prog
  integer,                                    intent(in) :: isd
  integer,                                    intent(in) :: ied
  integer,                                    intent(in) :: jsd
  integer,                                    intent(in) :: jed
  integer,                                    intent(in) :: nk
  integer, dimension(3),                      intent(in) :: grid_tracer_axes

!
!       local parameters
!

!
!       local variables
!

integer                             :: n
character(len=fm_field_name_len)    :: name
character(len=fm_field_name_len+3)  :: long_suffix
character(len=fm_field_name_len+1)  :: suffix

!
!       save initial values
!

do n = 1, instances  !{
  allocate( instance(n)%initial_value(isd:ied,jsd:jed,nk) )
  instance(n)%initial_value(:,:,:) = T_prog(instance(n)%index)%field(:,:,:,Time%tau)
enddo  !} n


!-----------------------------------------------------------------------
!     Set up analyses
!-----------------------------------------------------------------------
!

!
!       register the diag fields, i.e. the TMs
!

do n = 1, instances  !{

  ! Set up the instance name from field table
  name = instance(n)%name
  if (name(1:1) .eq. '_') then  !{
    suffix = ' '
    long_suffix = ' '
  else  !}{
    suffix = '_' // name
    long_suffix = ' (' // trim(name) // ')'
  endif  !}

  ! determine the tracer names for this instance and register
   
  instance(n)%id_extm = register_diag_field(diag_name,                                          &
                 'exp_tm' // trim(suffix), grid_tracer_axes(1:3), Time%model_time,              &
                 'Explicit transport matrix for passive tracer ' // trim(long_suffix), ' ',     &
                 missing_value = -1.0e+10)
  instance(n)%id_imtm = register_diag_field(diag_name,                                          &
                 'imp_tm' // trim(suffix), grid_tracer_axes(1:3), Time%model_time,              &
                 'Implicit transport matrix for passive tracer ' // trim(long_suffix), ' ',     &
                 missing_value = -1.0e+10)

enddo  !} n

return

end subroutine transport_matrix_start  !}
! </SUBROUTINE> NAME="transport_matrix_start"


!#######################################################################
! <SUBROUTINE NAME="transport_matrix_store_explicit">
!
! <DESCRIPTION>
! For the time explicit tendencies. 
! </DESCRIPTION>
!

subroutine transport_matrix_store_explicit(Time, T_prog, isd, ied, jsd, jed, nk,        &
     isc, iec, jsc, jec, dtts, grid_tmask) 

  type(ocean_time_type),        intent(in)                  :: Time
  type(ocean_prog_tracer_type), dimension(:), intent(inout) :: T_prog
  integer, intent(in)                                       :: isd
  integer, intent(in)                                       :: ied
  integer, intent(in)                                       :: jsd
  integer, intent(in)                                       :: jed
  integer, intent(in)                                       :: nk
  integer, intent(in)                                       :: isc
  integer, intent(in)                                       :: iec
  integer, intent(in)                                       :: jsc
  integer, intent(in)                                       :: jec
  real, intent(in)                                          :: dtts
  real, dimension(isd:ied,jsd:jed,nk), intent(in)           :: grid_tmask

!
!       local parameters
!

!
!       local variables
!

integer :: n
real, dimension(isd:ied,jsd:jed,nk)     :: temp
logical                                 :: used

if(.not. do_transport_matrix) return

do n = 1, instances  !{

  if (instance(n)%id_extm .gt. 0) then !{
    temp(:,:,:) = (T_prog(instance(n)%index)%field(:,:,:,Time%taup1) - instance(n)%initial_value(:,:,:)) / dtts
    used = send_data(instance(n)%id_extm, temp, Time%model_time, rmask = grid_tmask,    &
         is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
  endif !}

  T_prog(instance(n)%index)%field(:,:,:,Time%taup1) = instance(n)%initial_value(:,:,:)

enddo  !} n

return

end subroutine transport_matrix_store_explicit  !}
! </SUBROUTINE> NAME="transport_matrix_store_explicit"

!#######################################################################
! <SUBROUTINE NAME="transport_matrix_store_implicit">
!
! <DESCRIPTION>
! For the time implicit tendencies. 
! </DESCRIPTION>
!

subroutine transport_matrix_store_implicit(Time, T_prog, isd, ied, jsd, jed, nk,        &
     isc, iec, jsc, jec, grid_tmask) !{

!---------------------------------------------------------------
! Modules first
!---------------------------------------------------------------

!---------------------------------------------------------------
! Arguments
!---------------------------------------------------------------


  type(ocean_time_type), intent(in)                         :: Time
  type(ocean_prog_tracer_type), dimension(:), intent(inout) :: T_prog
  integer, intent(in)                                       :: isd
  integer, intent(in)                                       :: ied
  integer, intent(in)                                       :: jsd
  integer, intent(in)                                       :: jed
  integer, intent(in)                                       :: nk
  integer, intent(in)                                       :: isc
  integer, intent(in)                                       :: iec
  integer, intent(in)                                       :: jsc
  integer, intent(in)                                       :: jec
  real, dimension(isd:ied,jsd:jed,nk), intent(in)           :: grid_tmask

!
!       local parameters
!

!
!       local variables
!

integer :: n
logical :: used

do n = 1, instances  !{

  if (instance(n)%id_imtm .gt. 0) then !{
      used = send_data(instance(n)%id_imtm, T_prog(instance(n)%index)%field(:,:,:,Time%taup1),  &
           Time%model_time, rmask = grid_tmask, is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
  endif !}

  T_prog(instance(n)%index)%field(:,:,:,Time%taup1) = instance(n)%initial_value(:,:,:)

enddo  !} n

return

end subroutine transport_matrix_store_implicit  !}
! </SUBROUTINE> NAME="transport_matrix_store_implicit"

end module transport_matrix_mod  !}

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The dynamic q2/2-equation \label{sec:q2over2eq}
!
! !INTERFACE:
   subroutine q2over2eq(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)

! !DESCRIPTION:
! The transport equation for the TKE $q^2/2=k$ can be written as
! \begin{equation}
!   \label{tkeB}
!   \dot{\overline{q^2/2}}
!   =
!   {\cal D}_q +  P + G  - \epsilon
!   \comma
! \end{equation}
! where $\dot{\overline{q^2/2}}$ denotes the material derivative of $q^2/2$.
! With $P$ and $G$ following from \eq{PandG}, evidently, this equation is
! formally identical to \eq{tkeA}. The only reason why it is discretized
! seperately here, is the slightly different down-gradient model for the
! transport term,
! \begin{equation}
!   \label{diffusionMYTKE}
!   {\cal D}_q = \frstder{z} \left( q l S_q \partder{q^2/2}{z} \right)
!  \comma
! \end{equation}
! where $S_q$ is a model constant. The notation has been chosen according
! to that introduced by \cite{MellorYamada82}. Using their notation,
! also \eq{epsilon} can be expressed in mathematically identical form
! as
! \begin{equation}
!   \label{epsilonMY}
!   \epsilon = \frac{q^3}{B_1 l}
!   \comma
! \end{equation}
! where $B_1$ is a constant of the model. Note, that the equivalence of
! \eq{epsilon} and \eq{epsilonMY} requires that
! \begin{equation}
!   \label{B1}
!   (c_\mu^0)^{-2} = \frac{1}{2} B_1^\frac{2}{3}
!   \point
! \end{equation}
!
! !USES:
   use turbulence,   only: P,B
   use turbulence,   only: tke,tkeo,k_min,eps,L
   use turbulence,   only: q2over2_bc, k_ubc, k_lbc, ubc_type, lbc_type
   use turbulence,   only: sq
   use util,         only: Dirichlet,Neumann

   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer,  intent(in)                :: nlev

!  time step (s)
   REALTYPE, intent(in)                :: dt

!  surface and bottom
!  friction velocity (m/s)
   REALTYPE, intent(in)                :: u_taus,u_taub

!  surface and bottom
!  roughness length (m)
   REALTYPE, intent(in)                :: z0s,z0b

!  layer thickness (m)
   REALTYPE, intent(in)                :: h(0:nlev)

!  square of shear and buoyancy
!  frequency (1/s^2)
   REALTYPE, intent(in)                :: NN(0:nlev),SS(0:nlev)

!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: q2over2eq.F90,v $
!  Revision 20.0  2013/12/14 00:13:50  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:54  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.6  2010-09-17 12:53:52  jorn
!  extensive code clean-up to ensure proper initialization and clean-up of all variables
!
!  Revision 1.5  2005-12-28 09:42:33  hb
!  Patankar trick reverted to older versions for stabilising 3D computations
!
!  Revision 1.4  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.3  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.2  2003/03/10 09:04:04  gotm
!  Fixed comment char
!
!  Revision 1.1  2003/03/10 09:00:36  gotm
!  Part of new generic turbulence model
!
!
!EOP
!------------------------------------------------------------------------
!
! !LOCAL VARIABLES:
   REALTYPE                  :: DiffKup,DiffKdw,pos_bc
   REALTYPE                  :: prod,buoyan,diss
   REALTYPE                  :: prod_pos,prod_neg,buoyan_pos,buoyan_neg
   REALTYPE                  :: cnpar=_ONE_
   REALTYPE                  :: avh(0:nlev)
   REALTYPE                  :: Lsour(0:nlev),Qsour(0:nlev)
   integer                   :: i
!
!------------------------------------------------------------------------
!BOC
!

   tkeo=tke

   do i=1,nlev-1

!     compute diffusivity
      avh(i) = sq*sqrt( 2.*tke(i) )*L(i)

!     compute production terms in q^2/2-equation
      prod     = P(i)
      buoyan   = B(i)
      diss     = eps(i)


      if (prod+buoyan.gt.0) then
         Qsour(i)  = prod+buoyan
         Lsour(i) = -diss/tke(i)
      else
         Qsour(i)  = prod
         Lsour(i) = -(diss-buoyan)/tke(i)
      end if


   end do

!  position for upper BC
   if (k_ubc.eq.Neumann) then
!     flux at center "nlev"
      pos_bc = 0.5*h(nlev)
   else
!     value at face "nlev-1"
      pos_bc = h(nlev)
   end if

!  obtain BC for upper boundary of type "ubc_type"
   DiffKup  = q2over2_bc(k_ubc,ubc_type,pos_bc,z0s,u_taus)


!  position for lower BC
   if (k_lbc.eq.Neumann) then
!     flux at center "1"
      pos_bc = 0.5*h(1)
   else
!     value at face "1"
      pos_bc = h(1)
   end if

!  obtain BC for lower boundary of type "lbc_type"
   DiffKdw  = q2over2_bc(k_lbc,lbc_type,pos_bc,z0b,u_taub)



!  do diffusion step
   call diff_face(nlev,dt,cnpar,h,k_ubc,k_lbc,                          &
                    DiffKup,DiffKdw,avh,Lsour,Qsour,tke)

!  fill top and bottom value with something nice
!  (only for output)
   tke(nlev)  = q2over2_bc(Dirichlet,ubc_type,z0s,z0s,u_taus)
   tke(0   )  = q2over2_bc(Dirichlet,lbc_type,z0b,z0b,u_taub)

!  clip at k_min
   do i=0,nlev
      tke(i) = max(tke(i),k_min)
   enddo

   return
   end subroutine q2over2eq
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: cosp.F90,v 20.0 2013/12/13 23:10:35 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#ifndef COSP_GFDL
#include "cosp_defs.h"
#endif
MODULE MOD_COSP
  USE MOD_COSP_TYPES
  USE MOD_COSP_SIMULATOR
  USE MOD_COSP_MODIS_SIMULATOR
  IMPLICIT NONE

CONTAINS


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!--------------------- SUBROUTINE COSP ---------------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#ifdef RTTOV
#ifdef COSP_GFDL
SUBROUTINE COSP(overlap,Ncolumns,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,rttov,stradar,stlidar,sghydro,cloud_type)
#else
SUBROUTINE COSP(overlap,Ncolumns,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,rttov,stradar,stlidar)
#endif COSP_GFDL
#else
#ifdef COSP_GFDL
SUBROUTINE COSP(overlap,Ncolumns,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,stradar,stlidar, sghydro, cloud_type)
#else
SUBROUTINE COSP(overlap,Ncolumns,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,stradar,stlidar)
#endif COSP_GFDL
#endif
  ! Arguments
  integer,intent(in) :: overlap !  overlap type in SCOPS: 1=max, 2=rand, 3=max/rand
  integer,intent(in) :: Ncolumns
  type(cosp_config),intent(in) :: cfg   ! Configuration options
  type(cosp_vgrid),intent(in) :: vgrid   ! Information on vertical grid of stats
  type(cosp_gridbox),intent(inout) :: gbx
  type(cosp_subgrid),intent(inout) :: sgx   ! Subgrid info
  type(cosp_sgradar),intent(inout) :: sgradar ! Output from radar simulator
  type(cosp_sglidar),intent(inout) :: sglidar ! Output from lidar simulator
  type(cosp_isccp),intent(inout)   :: isccp   ! Output from ISCCP simulator
  type(cosp_misr),intent(inout)    :: misr    ! Output from MISR simulator
  type(cosp_modis),intent(inout)   :: modis   ! Output from MODIS simulator
#ifdef RTTOV
  type(cosp_rttov),intent(inout)   :: rttov   ! Output from RTTOV
#endif
  type(cosp_radarstats),intent(inout) :: stradar ! Summary statistics from radar simulator
  type(cosp_lidarstats),intent(inout) :: stlidar ! Summary statistics from lidar simulator
#ifdef COSP_GFDL
  type(cosp_sghydro), intent(inout)   :: sghydro   ! Subgrid info for hydrometeors en each iteration
  real, dimension(gbx%Npoints, Ncolumns, gbx%Nlevels),  &
                   intent(in), optional ::  cloud_type
#endif

  ! Local variables 
  integer :: Npoints   ! Number of gridpoints
  integer :: Nlevels   ! Number of levels
  integer :: Nhydro    ! Number of hydrometeors
  integer :: Niter     ! Number of calls to cosp_simulator
  integer :: i_first,i_last ! First and last gridbox to be processed in each iteration
  integer :: i,Ni
  integer,dimension(2) :: ix,iy
  logical :: reff_zero
  real :: maxp,minp
  integer,dimension(:),allocatable :: & ! Dimensions nPoints
                  seed    !  It is recommended that the seed is set to a different value for each model
                          !  gridbox it is called on, as it is possible that the choice of the same 
                          !  seed value every time may introduce some statistical bias in the results, 
                          !  particularly for low values of NCOL.
  ! Types used in one iteration
  type(cosp_gridbox) :: gbx_it
  type(cosp_subgrid) :: sgx_it
#ifdef COSP_GFDL
  type(cosp_sghydro) :: sghydro_it
#endif
  type(cosp_vgrid)   :: vgrid_it
  type(cosp_sgradar) :: sgradar_it
  type(cosp_sglidar) :: sglidar_it
  type(cosp_isccp)   :: isccp_it
  type(cosp_modis)   :: modis_it
  type(cosp_misr)    :: misr_it
#ifdef RTTOV
  type(cosp_rttov)   :: rttov_it
#endif
  type(cosp_radarstats) :: stradar_it
  type(cosp_lidarstats) :: stlidar_it
  
  !++++++++++ Dimensions ++++++++++++
  Npoints  = gbx%Npoints
  Nlevels  = gbx%Nlevels
  Nhydro   = gbx%Nhydro

!++++++++++ Apply sanity checks to inputs ++++++++++
  call cosp_check_input('longitude',gbx%longitude,min_val=0.0,max_val=360.0)
  call cosp_check_input('latitude',gbx%latitude,min_val=-90.0,max_val=90.0)
  call cosp_check_input('dlev',gbx%dlev,min_val=0.0)
  call cosp_check_input('p',gbx%p,min_val=0.0)
  call cosp_check_input('ph',gbx%ph,min_val=0.0)
  call cosp_check_input('T',gbx%T,min_val=0.0)
  call cosp_check_input('q',gbx%q,min_val=0.0)
  call cosp_check_input('sh',gbx%sh,min_val=0.0)
  call cosp_check_input('dtau_s',gbx%dtau_s,min_val=0.0)
  call cosp_check_input('dtau_c',gbx%dtau_c,min_val=0.0)
  call cosp_check_input('dem_s',gbx%dem_s,min_val=0.0,max_val=1.0)
  call cosp_check_input('dem_c',gbx%dem_c,min_val=0.0,max_val=1.0)
  ! Point information (Npoints)
  call cosp_check_input('land',gbx%land,min_val=0.0,max_val=1.0)
  call cosp_check_input('psfc',gbx%psfc,min_val=0.0)
  call cosp_check_input('sunlit',gbx%sunlit,min_val=0.0,max_val=1.0)
  call cosp_check_input('skt',gbx%skt,min_val=0.0)
  ! TOTAL and CONV cloud fraction for SCOPS
  call cosp_check_input('tca',gbx%tca,min_val=0.0,max_val=1.0)
  call cosp_check_input('cca',gbx%cca,min_val=0.0,max_val=1.0)
  ! Precipitation fluxes on model levels
  call cosp_check_input('rain_ls',gbx%rain_ls,min_val=0.0)
  call cosp_check_input('rain_cv',gbx%rain_cv,min_val=0.0)
  call cosp_check_input('snow_ls',gbx%snow_ls,min_val=0.0)
  call cosp_check_input('snow_cv',gbx%snow_cv,min_val=0.0)
  call cosp_check_input('grpl_ls',gbx%grpl_ls,min_val=0.0)
  ! Hydrometeors concentration and distribution parameters
  call cosp_check_input('mr_hydro',gbx%mr_hydro,min_val=0.0)
  ! Effective radius [m]. (Npoints,Nlevels,Nhydro)
  call cosp_check_input('Reff',gbx%Reff,min_val=0.0)
  reff_zero=.true.
  if (any(gbx%Reff > 1.e-8)) then
     reff_zero=.false.
      ! reff_zero == .false.
      !     and gbx%use_reff == .true.   Reff use in radar and lidar
      !     and reff_zero    == .false.  Reff use in lidar and set to 0 for radar
  endif
  if ((.not. gbx%use_reff) .and. (reff_zero)) then ! No Reff in radar. Default in lidar
        gbx%Reff = DEFAULT_LIDAR_REFF
        print *, '---------- COSP WARNING ------------'
        print *, ''
        print *, 'Using default Reff in lidar simulations'
        print *, ''
        print *, '----------------------------------'
  endif
  
  ! Aerosols concentration and distribution parameters
  call cosp_check_input('conc_aero',gbx%conc_aero,min_val=0.0)
#ifdef COSP_GFDL
  ! Check sg tau, emiss, mrs and sizes if they are being input from
  ! model
  if (sgx%cols_input_from_model) then
  call cosp_check_input('sgx%Reff1',sghydro%Reff(:,:,:,1),min_val=0.0)
  call cosp_check_input('sgx%Reff2',sghydro%Reff(:,:,:,2),min_val=0.0)
  call cosp_check_input('sgx%Reff5',sghydro%Reff(:,:,:,5),min_val=0.0)
  call cosp_check_input('sgx%Reff6',sghydro%Reff(:,:,:,6),min_val=0.0)
  call cosp_check_input('sgx%  mr1',sghydro%mr_hydro(:,:,:,1),min_val=0.0)
  call cosp_check_input('sgx%  mr2',sghydro%mr_hydro(:,:,:,2),min_val=0.0)
  call cosp_check_input('sgx%  mr5',sghydro%mr_hydro(:,:,:,5),min_val=0.0)
  call cosp_check_input('sgx%  mr6',sghydro%mr_hydro(:,:,:,6),min_val=0.0)
  call cosp_check_input('sgx%  tau',sgx%dtau_col,min_val=0.0)
  call cosp_check_input('sgx%   em',sgx%dem_col,min_val=0.0)
 endif
#else
  ! Checks for CRM mode
  if (Ncolumns == 1) then
     if (gbx%use_precipitation_fluxes) then
        print *, '---------- COSP ERROR ------------'
        print *, ''
        print *, 'Use of precipitation fluxes not supported in CRM mode (Ncolumns=1)'
        print *, ''
        print *, '----------------------------------'
        stop
     endif
     if ((maxval(gbx%dtau_c) > 0.0).or.(maxval(gbx%dem_c) > 0.0)) then
        print *, '---------- COSP ERROR ------------'
        print *, ''
        print *, ' dtau_c > 0.0 or dem_c > 0.0. In CRM mode (Ncolumns=1), '
        print *, ' the optical depth (emmisivity) of all clouds must be '
        print *, ' passed through dtau_s (dem_s)'
        print *, ''
        print *, '----------------------------------'
        stop
     endif
  endif
#endif

   ! We base the seed in the decimal part of the surface pressure.
   allocate(seed(Npoints))
   seed = int(gbx%psfc) ! This is to avoid division by zero when Npoints = 1   
      ! Roj Oct/2008 ... Note: seed value of 0 caused me some problems + I want to 
      ! randomize for each call to COSP even when Npoints ==1
   minp = minval(gbx%psfc)
   maxp = maxval(gbx%psfc)
   if (Npoints .gt. 1) seed=int((gbx%psfc-minp)/(maxp-minp)*100000) + 1
   ! Below it's how it was done in the original implementation of the ISCCP simulator. 
   ! The one above is better for offline data, when you may have packed data 
   ! that subsamples the decimal fraction of the surface pressure. 
!    if (Npoints .gt. 1) seed=(gbx%psfc-int(gbx%psfc))*1000000 

  
   if (gbx%Npoints_it >= gbx%Npoints) then ! One iteration gbx%Npoints
#ifdef RTTOV
#ifdef COSP_GFDL
        call cosp_iter(overlap,seed,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,rttov,stradar,stlidar,sghydro,cloud_type)
#else
        call cosp_iter(overlap,seed,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,rttov,stradar,stlidar)
#endif
#else
#ifdef COSP_GFDL
        call cosp_iter(overlap,seed,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,stradar,stlidar, sghydro,cloud_type)
#else
        call cosp_iter(overlap,seed,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,stradar,stlidar)
#endif
#endif
   else ! Several iterations to save memory
        Niter = gbx%Npoints/gbx%Npoints_it ! Integer division
        if (Niter*gbx%Npoints_it < gbx%Npoints) Niter = Niter + 1
        do i=1,Niter
            i_first = (i-1)*gbx%Npoints_it + 1
            i_last  = i_first + gbx%Npoints_it - 1
            i_last  = min(i_last,gbx%Npoints)
            Ni = i_last - i_first + 1
            if (i == 1) then
                ! Allocate types for all but last iteration
                call construct_cosp_gridbox(gbx%time,gbx%time_bnds,gbx%radar_freq,gbx%surface_radar,gbx%use_mie_tables, &
                                            gbx%use_gas_abs,gbx%do_ray,gbx%melt_lay,gbx%k2,Ni,Nlevels, &
                                            Ncolumns,N_HYDRO,gbx%Nprmts_max_hydro, &
                                            gbx%Naero,gbx%Nprmts_max_aero,Ni,gbx%lidar_ice_type,gbx%isccp_top_height, &
                                            gbx%isccp_top_height_direction,gbx%isccp_overlap,gbx%isccp_emsfc_lw, &
                                            gbx%use_precipitation_fluxes,gbx%use_reff, &
                                            gbx%plat,gbx%sat,gbx%inst,gbx%nchan,gbx%ZenAng, &
                                            gbx%Ichan(1:gbx%nchan),gbx%surfem(1:gbx%nchan), &
                                            gbx%co2,gbx%ch4,gbx%n2o,gbx%co, &
                                            gbx_it)
                call construct_cosp_vgrid(gbx_it,vgrid%Nlvgrid,vgrid%use_vgrid,vgrid%csat_vgrid,vgrid_it)
                call construct_cosp_subgrid(Ni, Ncolumns, Nlevels, sgx_it)
#ifdef COSP_GFDL
                call construct_cosp_sghydro(Ni, Ncolumns, Nlevels, N_hydro, sghydro_it)
#endif
                call construct_cosp_sgradar(cfg,Ni,Ncolumns,Nlevels,N_HYDRO,sgradar_it)
                call construct_cosp_sglidar(cfg,Ni,Ncolumns,Nlevels,N_HYDRO,PARASOL_NREFL,sglidar_it)
                call construct_cosp_isccp(cfg,Ni,Ncolumns,Nlevels,isccp_it)
#ifdef COSP_GFDL
                call construct_cosp_modis(cfg, Ni, Ncolumns, modis_it)
#else
                call construct_cosp_modis(cfg, Ni, modis_it)
#endif
                call construct_cosp_misr(cfg,Ni,misr_it)
#ifdef RTTOV
                call construct_cosp_rttov(Ni,gbx%nchan,rttov_it)
#endif
                call construct_cosp_radarstats(cfg,Ni,Ncolumns,vgrid%Nlvgrid,N_HYDRO,stradar_it)
                call construct_cosp_lidarstats(cfg,Ni,Ncolumns,vgrid%Nlvgrid,N_HYDRO,PARASOL_NREFL,stlidar_it)
            elseif (i == Niter) then ! last iteration
                call free_cosp_gridbox(gbx_it,.true.)
                call free_cosp_subgrid(sgx_it)
#ifdef COSP_GFDL
                call free_cosp_sghydro(sghydro_it)
#endif
                call free_cosp_vgrid(vgrid_it)
                call free_cosp_sgradar(sgradar_it)
                call free_cosp_sglidar(sglidar_it)
                call free_cosp_isccp(isccp_it)
                call free_cosp_modis(modis_it)
                call free_cosp_misr(misr_it)
#ifdef RTTOV
                call free_cosp_rttov(rttov_it)
#endif
                call free_cosp_radarstats(stradar_it)
                call free_cosp_lidarstats(stlidar_it)
                ! Allocate types for iterations
                call construct_cosp_gridbox(gbx%time,gbx%time_bnds,gbx%radar_freq,gbx%surface_radar,gbx%use_mie_tables, &
                                            gbx%use_gas_abs,gbx%do_ray,gbx%melt_lay,gbx%k2,Ni,Nlevels, &
                                            Ncolumns,N_HYDRO,gbx%Nprmts_max_hydro, &
                                            gbx%Naero,gbx%Nprmts_max_aero,Ni,gbx%lidar_ice_type,gbx%isccp_top_height, &
                                            gbx%isccp_top_height_direction,gbx%isccp_overlap,gbx%isccp_emsfc_lw, &
                                            gbx%use_precipitation_fluxes,gbx%use_reff, &
                                            gbx%plat,gbx%sat,gbx%inst,gbx%nchan,gbx%ZenAng, &
                                            gbx%Ichan(1:gbx%nchan),gbx%surfem(1:gbx%nchan), &
                                            gbx%co2,gbx%ch4,gbx%n2o,gbx%co, &
                                            gbx_it)
                ! --- Copy arrays without Npoints as dimension ---
                gbx_it%dist_prmts_hydro = gbx%dist_prmts_hydro
                gbx_it%dist_type_aero   = gbx_it%dist_type_aero
                call construct_cosp_vgrid(gbx_it,vgrid%Nlvgrid,vgrid%use_vgrid,vgrid%csat_vgrid,vgrid_it)
                call construct_cosp_subgrid(Ni, Ncolumns, Nlevels, sgx_it)
#ifdef COSP_GFDL
                call construct_cosp_sghydro(Ni, Ncolumns, Nlevels, N_hydro, sghydro_it)
#endif
                call construct_cosp_sgradar(cfg,Ni,Ncolumns,Nlevels,N_HYDRO,sgradar_it)
                call construct_cosp_sglidar(cfg,Ni,Ncolumns,Nlevels,N_HYDRO,PARASOL_NREFL,sglidar_it)
                call construct_cosp_isccp(cfg,Ni,Ncolumns,Nlevels,isccp_it)
#ifdef COSP_GFDL
                call construct_cosp_modis(cfg,Ni, Ncolumns, modis_it)
#else
                call construct_cosp_modis(cfg,Ni, modis_it)
#endif
                call construct_cosp_misr(cfg,Ni,misr_it)
#ifdef RTTOV 
                call construct_cosp_rttov(Ni,gbx%nchan,rttov_it) 
#endif 
                call construct_cosp_radarstats(cfg,Ni,Ncolumns,vgrid%Nlvgrid,N_HYDRO,stradar_it)
                call construct_cosp_lidarstats(cfg,Ni,Ncolumns,vgrid%Nlvgrid,N_HYDRO,PARASOL_NREFL,stlidar_it)
            endif
            ! --- Copy sections of arrays with Npoints as dimension ---
            ix=(/i_first,i_last/)
            iy=(/1,Ni/)
            call cosp_gridbox_cpsection(ix,iy,gbx,gbx_it)
              ! These serve as initialisation of *_it types
            call cosp_subgrid_cpsection(ix,iy,sgx,sgx_it)
            if (cfg%Lradar_sim) call cosp_sgradar_cpsection(ix,iy,sgradar,sgradar_it)
            if (cfg%Llidar_sim) call cosp_sglidar_cpsection(ix,iy,sglidar,sglidar_it)
            if (cfg%Lisccp_sim) call cosp_isccp_cpsection(ix,iy,isccp,isccp_it)
            if (cfg%Lmodis_sim) call cosp_modis_cpsection(ix,iy,modis,modis_it)
            if (cfg%Lmisr_sim)  call cosp_misr_cpsection(ix,iy,misr,misr_it)
#ifdef RTTOV 
            if (cfg%Lrttov_sim) call cosp_rttov_cpsection(ix,iy,rttov,rttov_it) 
#endif
            if (cfg%Lradar_sim) call cosp_radarstats_cpsection(ix,iy,stradar,stradar_it)
            if (cfg%Llidar_sim) call cosp_lidarstats_cpsection(ix,iy,stlidar,stlidar_it)
!             print *,'---------ix: ',ix
#ifdef RTTOV
#ifdef COSP_GFDL
            call cosp_iter(overlap,seed(ix(1):ix(2)),cfg,vgrid_it,gbx_it,sgx_it,sgradar_it, &
                           sglidar_it,isccp_it,misr_it,modis_it,rttov_it,stradar_it,stlidar_it, sghydro_it, cloud_type)
#else
            call cosp_iter(overlap,seed(ix(1):ix(2)),cfg,vgrid_it,gbx_it,sgx_it,sgradar_it, &
                           sglidar_it,isccp_it,misr_it,modis_it,rttov_it,stradar_it,stlidar_it)
#endif
#else
#ifdef COSP_GFDL
            call cosp_iter( overlap,seed(ix(1):ix(2)),cfg,vgrid_it,gbx_it,sgx_it,sgradar_it, &
                           sglidar_it,isccp_it,misr_it,modis_it,stradar_it,stlidar_it, sghydro_it,cloud_type)
#else
            call cosp_iter(overlap,seed(ix(1):ix(2)),cfg,vgrid_it,gbx_it,sgx_it,sgradar_it, &
                           sglidar_it,isccp_it,misr_it,modis_it,stradar_it,stlidar_it)
#endif
#endif
            ! --- Copy results to output structures ---
            ix=(/1,Ni/)
            iy=(/i_first,i_last/)
            call cosp_subgrid_cpsection(ix,iy,sgx_it,sgx)
            if (cfg%Lradar_sim) call cosp_sgradar_cpsection(ix,iy,sgradar_it,sgradar)
            if (cfg%Llidar_sim) call cosp_sglidar_cpsection(ix,iy,sglidar_it,sglidar)
            if (cfg%Lisccp_sim) call cosp_isccp_cpsection(ix,iy,isccp_it,isccp)
            if (cfg%Lmodis_sim) call cosp_modis_cpsection(ix,iy,modis_it,modis)
            if (cfg%Lmisr_sim)  call cosp_misr_cpsection(ix,iy,misr_it,misr)
#ifdef RTTOV 
            if (cfg%Lrttov_sim) call cosp_rttov_cpsection(ix,iy,rttov_it,rttov) 
#endif 
            if (cfg%Lradar_sim) call cosp_radarstats_cpsection(ix,iy,stradar_it,stradar)
            if (cfg%Llidar_sim) call cosp_lidarstats_cpsection(ix,iy,stlidar_it,stlidar)
        enddo
        ! Deallocate types
        call free_cosp_gridbox(gbx_it,.true.)
        call free_cosp_subgrid(sgx_it)
#ifdef COSP_GFDL
        call free_cosp_sghydro(sghydro_it)
#endif
        call free_cosp_vgrid(vgrid_it)
        call free_cosp_sgradar(sgradar_it)
        call free_cosp_sglidar(sglidar_it)
        call free_cosp_isccp(isccp_it)
        call free_cosp_modis(modis_it)
        call free_cosp_misr(misr_it)
#ifdef RTTOV 
        call free_cosp_rttov(rttov_it) 
#endif
        call free_cosp_radarstats(stradar_it)
        call free_cosp_lidarstats(stlidar_it)
   endif
   deallocate(seed)

    
END SUBROUTINE COSP

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!--------------------- SUBROUTINE COSP_ITER ----------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#ifdef RTTOV
#ifdef COSP_GFDL
SUBROUTINE COSP_ITER(overlap,seed,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,rttov,stradar,stlidar, sghydro, cloud_type)
#else
SUBROUTINE COSP_ITER(overlap,seed,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,rttov,stradar,stlidar)
#endif
#else
#ifdef COSP_GFDL
SUBROUTINE COSP_ITER(overlap,seed,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,stradar,stlidar, sghydro,cloud_type)
#else
SUBROUTINE COSP_ITER(overlap,seed,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,stradar,stlidar)
#endif
#endif
  ! Arguments
  integer,intent(in) :: overlap !  overlap type in SCOPS: 1=max, 2=rand, 3=max/rand
  integer,dimension(:),intent(in) :: seed
  type(cosp_config),intent(in) :: cfg   ! Configuration options
  type(cosp_vgrid),intent(in) :: vgrid   ! Information on vertical grid of stats
  type(cosp_gridbox),intent(inout) :: gbx
  type(cosp_subgrid),intent(inout) :: sgx   ! Subgrid info
  type(cosp_sgradar),intent(inout) :: sgradar ! Output from radar simulator
  type(cosp_sglidar),intent(inout) :: sglidar ! Output from lidar simulator
  type(cosp_isccp),intent(inout)   :: isccp   ! Output from ISCCP simulator
  type(cosp_misr),intent(inout)    :: misr    ! Output from MISR simulator
  type(cosp_modis),intent(inout)   :: modis   ! Output from MODIS simulator
#ifdef RTTOV
  type(cosp_rttov),intent(inout)   :: rttov   ! Output from RTTOV
#endif
  type(cosp_radarstats),intent(inout) :: stradar ! Summary statistics from radar simulator
  type(cosp_lidarstats),intent(inout) :: stlidar ! Summary statistics from lidar simulator
#ifdef COSP_GFDL
  type(cosp_sghydro), intent(inout)   :: sghydro   ! Subgrid info for hydrometeors en each iteration
  real, dimension(gbx%Npoints, gbx%Ncolumns, gbx%Nlevels),  &
                  intent(in), optional ::  cloud_type
#endif


  ! Local variables 
  integer :: Npoints   ! Number of gridpoints
  integer :: Ncolumns  ! Number of subcolumns
  integer :: Nlevels   ! Number of levels
  integer :: Nhydro    ! Number of hydrometeors
  integer :: i,j,k
  integer :: I_HYDRO 
  real,dimension(:,:),pointer :: column_frac_out ! Array with one column of frac_out
  integer :: scops_debug=0    !  set to non-zero value to print out inputs for debugging in SCOPS
  real,dimension(:, :),allocatable :: cca_scops,ls_p_rate,cv_p_rate, &
                     tca_scops ! Cloud cover in each model level (HORIZONTAL gridbox fraction) of total cloud.
                               ! Levels are from TOA to SURFACE. (nPoints, nLev)
  real,dimension(:,:),allocatable :: frac_ls,prec_ls,frac_cv,prec_cv ! Cloud/Precipitation fraction in each model level
                                                                     ! Levels are from SURFACE to TOA
  real,dimension(:,:),allocatable :: rho ! (Npoints, Nlevels). Atmospheric density
#ifndef COSP_GFDL
  type(cosp_sghydro) :: sghydro   ! Subgrid info for hydrometeors en each iteration
#endif

  
  !++++++++++ Dimensions ++++++++++++
  Npoints  = gbx%Npoints
  Ncolumns = gbx%Ncolumns
  Nlevels  = gbx%Nlevels
  Nhydro   = gbx%Nhydro
    
  !++++++++++ Climate/NWP mode ++++++++++  
  if (Ncolumns > 1) then
        !++++++++++ Subgrid sampling ++++++++++
        ! Allocate arrays before calling SCOPS
        allocate(frac_ls(Npoints,Nlevels),frac_cv(Npoints,Nlevels),prec_ls(Npoints,Nlevels),prec_cv(Npoints,Nlevels))
        allocate(tca_scops(Npoints,Nlevels),cca_scops(Npoints,Nlevels), &
                ls_p_rate(Npoints,Nlevels),cv_p_rate(Npoints,Nlevels))
        ! Initialize to zero
        frac_ls=0.0
        prec_ls=0.0
        frac_cv=0.0
        prec_cv=0.0
#ifdef COSP_GFDL
IF (sgx%cols_input_from_model) then
  sgx%frac_out = cloud_type
ELSE
        ! Cloud fractions for SCOPS from TOA to SFC
        tca_scops = gbx%tca(:,Nlevels:1:-1)
        cca_scops = gbx%cca(:,Nlevels:1:-1)

        ! Call to SCOPS
        ! strat and conv arrays are passed with levels from TOA to SURFACE.
        call scops(Npoints,Nlevels,Ncolumns,seed,tca_scops,cca_scops,overlap,sgx%frac_out,scops_debug)
ENDIF
#else
        ! Cloud fractions for SCOPS from TOA to SFC
        tca_scops = gbx%tca(:,Nlevels:1:-1)
        cca_scops = gbx%cca(:,Nlevels:1:-1)
        
        ! Call to SCOPS
        ! strat and conv arrays are passed with levels from TOA to SURFACE.
        call scops(Npoints,Nlevels,Ncolumns,seed,tca_scops,cca_scops,overlap,sgx%frac_out,scops_debug)
#endif
        
        ! temporarily use prec_ls/cv to transfer information about precipitation flux into prec_scops
        if(gbx%use_precipitation_fluxes) then
            ls_p_rate(:,Nlevels:1:-1)=gbx%rain_ls(:,1:Nlevels)+gbx%snow_ls(:,1:Nlevels)+gbx%grpl_ls(:,1:Nlevels)
            cv_p_rate(:,Nlevels:1:-1)=gbx%rain_cv(:,1:Nlevels)+gbx%snow_cv(:,1:Nlevels)
        else
            ls_p_rate(:,Nlevels:1:-1)=gbx%mr_hydro(:,1:Nlevels,I_LSRAIN)+ &
                                      gbx%mr_hydro(:,1:Nlevels,I_LSSNOW)+ &
                                      gbx%mr_hydro(:,1:Nlevels,I_LSGRPL)
            cv_p_rate(:,Nlevels:1:-1)=gbx%mr_hydro(:,1:Nlevels,I_CVRAIN)+ &
                                      gbx%mr_hydro(:,1:Nlevels,I_CVSNOW)
        endif
        
        call prec_scops(Npoints,Nlevels,Ncolumns,ls_p_rate,cv_p_rate,sgx%frac_out,sgx%prec_frac)
        
        ! Precipitation fraction
        do j=1,Npoints,1
        do k=1,Nlevels,1
            do i=1,Ncolumns,1
                if (sgx%frac_out (j,i,Nlevels+1-k) == I_LSC) frac_ls(j,k)=frac_ls(j,k)+1.
                if (sgx%frac_out (j,i,Nlevels+1-k) == I_CVC) frac_cv(j,k)=frac_cv(j,k)+1.
                if (sgx%prec_frac(j,i,Nlevels+1-k) .eq. 1) prec_ls(j,k)=prec_ls(j,k)+1.
                if (sgx%prec_frac(j,i,Nlevels+1-k) .eq. 2) prec_cv(j,k)=prec_cv(j,k)+1.
                if (sgx%prec_frac(j,i,Nlevels+1-k) .eq. 3) then
                    prec_cv(j,k)=prec_cv(j,k)+1.
                    prec_ls(j,k)=prec_ls(j,k)+1.
                endif
            enddo  !i
            frac_ls(j,k)=frac_ls(j,k)/Ncolumns
            frac_cv(j,k)=frac_cv(j,k)/Ncolumns
            prec_ls(j,k)=prec_ls(j,k)/Ncolumns
            prec_cv(j,k)=prec_cv(j,k)/Ncolumns
        enddo  !k
        enddo  !j
        
         ! Levels from SURFACE to TOA.
        if (Npoints*Ncolumns*Nlevels < 10000) then
            sgx%frac_out(1:Npoints,:,1:Nlevels)  = sgx%frac_out(1:Npoints,:,Nlevels:1:-1)
            sgx%prec_frac(1:Npoints,:,1:Nlevels) = sgx%prec_frac(1:Npoints,:,Nlevels:1:-1)
        else
            ! This is done within a loop (unvectorized) over nPoints to save memory
            do j=1,Npoints
                sgx%frac_out(j,:,1:Nlevels)  = sgx%frac_out(j,:,Nlevels:1:-1)
                sgx%prec_frac(j,:,1:Nlevels) = sgx%prec_frac(j,:,Nlevels:1:-1)
            enddo
        endif
       
       ! Deallocate arrays that will no longer be used
        deallocate(tca_scops,cca_scops,ls_p_rate,cv_p_rate)

        ! Populate the subgrid arrays
#ifndef COSP_GFDL
        call construct_cosp_sghydro(Npoints,Ncolumns,Nlevels,Nhydro,sghydro)
#endif
        do k=1,Ncolumns
#ifdef COSP_GFDL
IF (sgx%cols_input_from_model) then
!   the sghydro%mr_hydro cloud components were previously defined in
!   cosp_driver and have been passed in
ELSE
            !--------- Mixing ratios for clouds and Reff for Clouds and precip -------
            column_frac_out => sgx%frac_out(:,k,:)
            where (column_frac_out == I_LSC)     !+++++++++++ LS clouds ++++++++
                sghydro%mr_hydro(:,k,:,I_LSCLIQ) = gbx%mr_hydro(:,:,I_LSCLIQ)
                sghydro%mr_hydro(:,k,:,I_LSCICE) = gbx%mr_hydro(:,:,I_LSCICE)

                sghydro%Reff(:,k,:,I_LSCLIQ)     = gbx%Reff(:,:,I_LSCLIQ)
                sghydro%Reff(:,k,:,I_LSCICE)     = gbx%Reff(:,:,I_LSCICE)
                sghydro%Reff(:,k,:,I_LSRAIN)     = gbx%Reff(:,:,I_LSRAIN)
                sghydro%Reff(:,k,:,I_LSSNOW)     = gbx%Reff(:,:,I_LSSNOW)
                sghydro%Reff(:,k,:,I_LSGRPL)     = gbx%Reff(:,:,I_LSGRPL)
            elsewhere (column_frac_out == I_CVC) !+++++++++++ CONV clouds ++++++++
                sghydro%mr_hydro(:,k,:,I_CVCLIQ) = gbx%mr_hydro(:,:,I_CVCLIQ)
                sghydro%mr_hydro(:,k,:,I_CVCICE) = gbx%mr_hydro(:,:,I_CVCICE)
 
                sghydro%Reff(:,k,:,I_CVCLIQ)     = gbx%Reff(:,:,I_CVCLIQ)
                sghydro%Reff(:,k,:,I_CVCICE)     = gbx%Reff(:,:,I_CVCICE)
                sghydro%Reff(:,k,:,I_CVRAIN)     = gbx%Reff(:,:,I_CVRAIN)
                sghydro%Reff(:,k,:,I_CVSNOW)     = gbx%Reff(:,:,I_CVSNOW)
            end where
ENDIF
#else
            !--------- Mixing ratios for clouds and Reff for Clouds and precip -------
            column_frac_out => sgx%frac_out(:,k,:)
            where (column_frac_out == I_LSC)     !+++++++++++ LS clouds ++++++++
                sghydro%mr_hydro(:,k,:,I_LSCLIQ) = gbx%mr_hydro(:,:,I_LSCLIQ)
                sghydro%mr_hydro(:,k,:,I_LSCICE) = gbx%mr_hydro(:,:,I_LSCICE)
                
                sghydro%Reff(:,k,:,I_LSCLIQ)     = gbx%Reff(:,:,I_LSCLIQ)
                sghydro%Reff(:,k,:,I_LSCICE)     = gbx%Reff(:,:,I_LSCICE)
                sghydro%Reff(:,k,:,I_LSRAIN)     = gbx%Reff(:,:,I_LSRAIN)
                sghydro%Reff(:,k,:,I_LSSNOW)     = gbx%Reff(:,:,I_LSSNOW)
                sghydro%Reff(:,k,:,I_LSGRPL)     = gbx%Reff(:,:,I_LSGRPL)
            elsewhere (column_frac_out == I_CVC) !+++++++++++ CONV clouds ++++++++
                sghydro%mr_hydro(:,k,:,I_CVCLIQ) = gbx%mr_hydro(:,:,I_CVCLIQ) 
                sghydro%mr_hydro(:,k,:,I_CVCICE) = gbx%mr_hydro(:,:,I_CVCICE) 
                
                sghydro%Reff(:,k,:,I_CVCLIQ)     = gbx%Reff(:,:,I_CVCLIQ) 
                sghydro%Reff(:,k,:,I_CVCICE)     = gbx%Reff(:,:,I_CVCICE) 
                sghydro%Reff(:,k,:,I_CVRAIN)     = gbx%Reff(:,:,I_CVRAIN) 
                sghydro%Reff(:,k,:,I_CVSNOW)     = gbx%Reff(:,:,I_CVSNOW) 
            end where 
#endif
            !--------- Precip -------
            if (.not. gbx%use_precipitation_fluxes) then
                where (column_frac_out == I_LSC)  !+++++++++++ LS Precipitation ++++++++
                    sghydro%mr_hydro(:,k,:,I_LSRAIN) = gbx%mr_hydro(:,:,I_LSRAIN)
                    sghydro%mr_hydro(:,k,:,I_LSSNOW) = gbx%mr_hydro(:,:,I_LSSNOW)
                    sghydro%mr_hydro(:,k,:,I_LSGRPL) = gbx%mr_hydro(:,:,I_LSGRPL)
                elsewhere (column_frac_out == I_CVC) !+++++++++++ CONV Precipitation ++++++++
                    sghydro%mr_hydro(:,k,:,I_CVRAIN) = gbx%mr_hydro(:,:,I_CVRAIN) 
                    sghydro%mr_hydro(:,k,:,I_CVSNOW) = gbx%mr_hydro(:,:,I_CVSNOW) 
                end where 
            endif
        enddo
        ! convert the mixing ratio and precipitation flux from gridbox mean to the fraction-based values
        do k=1,Nlevels
            do j=1,Npoints
#ifdef COSP_GFDL
!RSH: When  columns are input, are already in-cloud values.
IF (sgx%cols_input_from_model) then
ELSE
                !--------- Clouds -------
                if (frac_ls(j,k) .ne. 0.) then
                    sghydro%mr_hydro(j,:,k,I_LSCLIQ) = sghydro%mr_hydro(j,:, k,I_LSCLIQ)/frac_ls(j,k)
                    sghydro%mr_hydro(j,:,k,I_LSCICE) = sghydro%mr_hydro(j,:, k,I_LSCICE)/frac_ls(j,k)
                 endif
                 if (frac_cv(j,k) .ne. 0.) then
                     sghydro%mr_hydro(j,:,k,I_CVCLIQ) = sghydro%mr_hydro(j,:,k,I_CVCLIQ)/frac_cv(j,k)
                     sghydro%mr_hydro(j,:,k,I_CVCICE) = sghydro%mr_hydro(j,:,k,I_CVCICE)/frac_cv(j,k)
                 endif
ENDIF
#else
                !--------- Clouds -------
                if (frac_ls(j,k) .ne. 0.) then
                    sghydro%mr_hydro(j,:,k,I_LSCLIQ) = sghydro%mr_hydro(j,:,k,I_LSCLIQ)/frac_ls(j,k)
                    sghydro%mr_hydro(j,:,k,I_LSCICE) = sghydro%mr_hydro(j,:,k,I_LSCICE)/frac_ls(j,k)
                endif
                if (frac_cv(j,k) .ne. 0.) then
                    sghydro%mr_hydro(j,:,k,I_CVCLIQ) = sghydro%mr_hydro(j,:,k,I_CVCLIQ)/frac_cv(j,k)
                    sghydro%mr_hydro(j,:,k,I_CVCICE) = sghydro%mr_hydro(j,:,k,I_CVCICE)/frac_cv(j,k)
                endif
#endif
                !--------- Precip -------
                if (gbx%use_precipitation_fluxes) then
                    if (prec_ls(j,k) .ne. 0.) then
                        gbx%rain_ls(j,k) = gbx%rain_ls(j,k)/prec_ls(j,k)
                        gbx%snow_ls(j,k) = gbx%snow_ls(j,k)/prec_ls(j,k)
                        gbx%grpl_ls(j,k) = gbx%grpl_ls(j,k)/prec_ls(j,k)
                    endif
                    if (prec_cv(j,k) .ne. 0.) then
                        gbx%rain_cv(j,k) = gbx%rain_cv(j,k)/prec_cv(j,k)
                        gbx%snow_cv(j,k) = gbx%snow_cv(j,k)/prec_cv(j,k)
                    endif
                else
                    if (prec_ls(j,k) .ne. 0.) then
                        sghydro%mr_hydro(j,:,k,I_LSRAIN) = sghydro%mr_hydro(j,:,k,I_LSRAIN)/prec_ls(j,k)
                        sghydro%mr_hydro(j,:,k,I_LSSNOW) = sghydro%mr_hydro(j,:,k,I_LSSNOW)/prec_ls(j,k)
                        sghydro%mr_hydro(j,:,k,I_LSGRPL) = sghydro%mr_hydro(j,:,k,I_LSGRPL)/prec_ls(j,k)
                    endif
                    if (prec_cv(j,k) .ne. 0.) then
                        sghydro%mr_hydro(j,:,k,I_CVRAIN) = sghydro%mr_hydro(j,:,k,I_CVRAIN)/prec_cv(j,k)
                        sghydro%mr_hydro(j,:,k,I_CVSNOW) = sghydro%mr_hydro(j,:,k,I_CVSNOW)/prec_cv(j,k)
                    endif
                endif  
            enddo !k
        enddo !j
        deallocate(frac_ls,prec_ls,frac_cv,prec_cv)
        
        if (gbx%use_precipitation_fluxes) then
            ! Density
            allocate(rho(Npoints,Nlevels))
            I_HYDRO = I_LSRAIN
            call cosp_precip_mxratio(Npoints,Nlevels,Ncolumns,gbx%p,gbx%T,sgx%prec_frac,1., &
                    n_ax(I_HYDRO),n_bx(I_HYDRO),alpha_x(I_HYDRO),c_x(I_HYDRO),d_x(I_HYDRO), &
                    g_x(I_HYDRO),a_x(I_HYDRO),b_x(I_HYDRO), &
                    gamma_1(I_HYDRO),gamma_2(I_HYDRO),gamma_3(I_HYDRO),gamma_4(I_HYDRO), &
                    gbx%rain_ls,sghydro%mr_hydro(:,:,:,I_HYDRO),sghydro%Reff(:,:,:,I_HYDRO))
            I_HYDRO = I_LSSNOW
            call cosp_precip_mxratio(Npoints,Nlevels,Ncolumns,gbx%p,gbx%T,sgx%prec_frac,1., &
                    n_ax(I_HYDRO),n_bx(I_HYDRO),alpha_x(I_HYDRO),c_x(I_HYDRO),d_x(I_HYDRO), &
                    g_x(I_HYDRO),a_x(I_HYDRO),b_x(I_HYDRO), &
                    gamma_1(I_HYDRO),gamma_2(I_HYDRO),gamma_3(I_HYDRO),gamma_4(I_HYDRO), &
                    gbx%snow_ls,sghydro%mr_hydro(:,:,:,I_HYDRO),sghydro%Reff(:,:,:,I_HYDRO))
            I_HYDRO = I_CVRAIN
            call cosp_precip_mxratio(Npoints,Nlevels,Ncolumns,gbx%p,gbx%T,sgx%prec_frac,2., &
                    n_ax(I_HYDRO),n_bx(I_HYDRO),alpha_x(I_HYDRO),c_x(I_HYDRO),d_x(I_HYDRO), &
                    g_x(I_HYDRO),a_x(I_HYDRO),b_x(I_HYDRO), &
                    gamma_1(I_HYDRO),gamma_2(I_HYDRO),gamma_3(I_HYDRO),gamma_4(I_HYDRO), &
                    gbx%rain_cv,sghydro%mr_hydro(:,:,:,I_HYDRO),sghydro%Reff(:,:,:,I_HYDRO))
            I_HYDRO = I_CVSNOW
            call cosp_precip_mxratio(Npoints,Nlevels,Ncolumns,gbx%p,gbx%T,sgx%prec_frac,2., &
                    n_ax(I_HYDRO),n_bx(I_HYDRO),alpha_x(I_HYDRO),c_x(I_HYDRO),d_x(I_HYDRO), &
                    g_x(I_HYDRO),a_x(I_HYDRO),b_x(I_HYDRO), &
                    gamma_1(I_HYDRO),gamma_2(I_HYDRO),gamma_3(I_HYDRO),gamma_4(I_HYDRO), &
                    gbx%snow_cv,sghydro%mr_hydro(:,:,:,I_HYDRO),sghydro%Reff(:,:,:,I_HYDRO))
            I_HYDRO = I_LSGRPL
            call cosp_precip_mxratio(Npoints,Nlevels,Ncolumns,gbx%p,gbx%T,sgx%prec_frac,1., &
                    n_ax(I_HYDRO),n_bx(I_HYDRO),alpha_x(I_HYDRO),c_x(I_HYDRO),d_x(I_HYDRO), &
                    g_x(I_HYDRO),a_x(I_HYDRO),b_x(I_HYDRO), &
                    gamma_1(I_HYDRO),gamma_2(I_HYDRO),gamma_3(I_HYDRO),gamma_4(I_HYDRO), &
                    gbx%grpl_ls,sghydro%mr_hydro(:,:,:,I_HYDRO),sghydro%Reff(:,:,:,I_HYDRO))
            if(allocated(rho)) deallocate(rho)
        endif
   !++++++++++ CRM mode ++++++++++
   else
#ifndef COSP_GFDL
      call construct_cosp_sghydro(Npoints,Ncolumns,Nlevels,Nhydro,sghydro)
#endif
      sghydro%mr_hydro(:,1,:,:) = gbx%mr_hydro
      sghydro%Reff(:,1,:,:) = gbx%Reff
      !--------- Clouds -------
      where ((gbx%dtau_s > 0.0))
             sgx%frac_out(:,1,:) = 1  ! Subgrid cloud array. Dimensions (Npoints,Ncolumns,Nlevels)
      endwhere
   endif ! Ncolumns > 1
  
   !++++++++++ Simulator ++++++++++
#ifdef RTTOV
    call cosp_simulator(gbx,sgx,sghydro,cfg,vgrid,sgradar,sglidar,isccp,misr,modis,rttov,stradar,stlidar)
#else
    call cosp_simulator(gbx,sgx,sghydro,cfg,vgrid,sgradar,sglidar,isccp,misr,modis,stradar,stlidar)
#endif

    ! Deallocate subgrid arrays
#ifndef COSP_GFDL
    call free_cosp_sghydro(sghydro)
#endif
END SUBROUTINE COSP_ITER

END MODULE MOD_COSP

#include <fms_platform.h>

module glac_tile_mod

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only : &
     write_version_number, file_exist, check_nml_error, &
     close_file, stdlog
use constants_mod, only : &
     pi, tfreeze, hlf
use land_constants_mod, only : NBANDS
use land_io_mod, only : &
     init_cover_field
use land_tile_selectors_mod, only : &
     tile_selector_type, SEL_GLAC, register_tile_selector

implicit none
private

! ==== public interfaces =====================================================
public :: glac_prog_type
public :: glac_pars_type
public :: glac_tile_type

public :: new_glac_tile, delete_glac_tile
public :: glac_tiles_can_be_merged, merge_glac_tiles
public :: glac_is_selected
public :: get_glac_tile_tag
public :: glac_tile_stock_pe
public :: glac_tile_heat

public :: read_glac_data_namelist
public :: glac_cover_cold_start

public :: glac_data_radiation
public :: glac_data_diffusion
public :: glac_data_thermodynamics
public :: glac_data_hydraulics

public :: max_lev
! =====end of public interfaces ==============================================
interface new_glac_tile
   module procedure glac_tile_ctor
   module procedure glac_tile_copy_ctor
end interface


! ==== module constants ======================================================
character(len=*), parameter   :: &
     version     = '$Id: glac_tile.F90,v 20.0 2013/12/13 23:29:33 fms Exp $', &
     tagname     = '$Name: tikal $', &
     module_name = 'glac_tile_mod'

integer, parameter :: max_lev          = 30 ! max number of levels in glacier
integer, parameter :: n_dim_glac_types = 1  ! size of lookup table
real,    parameter :: psi_wilt         = -150.  ! matric head at wilting
real,    parameter :: comp             = 0.001  ! m^-1

! from the modis brdf/albedo product user's guide:
real            :: g_iso  = 1.
real            :: g_vol  = 0.189184
real            :: g_geo  = -1.377622
real            :: g0_iso = 1.0
real            :: g1_iso = 0.0
real            :: g2_iso = 0.0
real            :: g0_vol = -0.007574
real            :: g1_vol = -0.070987
real            :: g2_vol =  0.307588
real            :: g0_geo = -1.284909
real            :: g1_geo = -0.166314
real            :: g2_geo =  0.041840

! ==== types =================================================================
type :: glac_pars_type
  real w_sat
  real awc_lm2
  real k_sat_ref
  real psi_sat_ref
  real chb
  real alpha              ! *** REPLACE LATER BY alpha(layer)
  real heat_capacity_ref
  real thermal_cond_ref
  real :: refl_max_dir(NBANDS), refl_max_dif(NBANDS) ! max reflectance for the direct and diffuse light
  real :: refl_min_dir(NBANDS), refl_min_dif(NBANDS) ! min reflectance for the direct and diffuse light
  real emis_dry
  real emis_sat
  real z0_momentum
  real tau_groundwater
  real rsa_exp         ! riparian source-area exponent
  real tfreeze
end type glac_pars_type

type :: glac_prog_type
  real wl
  real ws
  real T
  real groundwater
  real groundwater_T
end type glac_prog_type

type :: glac_tile_type
   integer :: tag ! kind of the glacier
   type(glac_pars_type)               :: pars
   type(glac_prog_type), pointer :: prog(:)
   real,                 pointer :: w_fc(:)
   real,                 pointer :: w_wilt(:)
   real :: Eg_part_ref
   real :: z0_scalar
   real :: geothermal_heat_flux

   real, pointer :: heat_capacity_dry(:)
   real, pointer :: e(:), f(:)
end type glac_tile_type
! NOTE: When adding or modifying fields of this types, don't forget to change
! the operations on tile (e.g. copy) accordingly
! ==== module data ===========================================================

!---- namelist ---------------------------------------------------------------
real    :: k_over_B              = 2         ! reset to 0 for MCM
real    :: rate_fc               = 0.1/86400 ! 0.1 mm/d drainage rate at FC
real    :: sfc_heat_factor       = 1
integer :: z_sfc_layer           = 0
integer :: num_l                 = 18        ! number of glacier levels
real    :: dz(max_lev)           = (/ &
    0.02, 0.04, 0.04, 0.05, 0.05, 0.1, 0.1, 0.2, 0.2, &
    0.2,   0.4,  0.4,  0.4,  0.4, 0.4,  1.,  1.,  1., &
    0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0. /)
                                             ! thickness (m) of model layers,
                                             ! from top down
logical :: use_lm2_awc           = .false.
logical :: use_lad1_glac         = .false.
real    :: t_range               = 10.0

! from analysis of modis data (ignoring temperature dependence):
  real :: f_iso_cold(NBANDS) = (/ 0.177, 0.265 /)
  real :: f_vol_cold(NBANDS) = (/ 0.100, 0.126 /)
  real :: f_geo_cold(NBANDS) = (/ 0.027, 0.032 /)
  real :: f_iso_warm(NBANDS) = (/ 0.177, 0.265 /)
  real :: f_vol_warm(NBANDS) = (/ 0.100, 0.126 /)
  real :: f_geo_warm(NBANDS) = (/ 0.027, 0.032 /)
  real :: refl_cold_dif(NBANDS), refl_warm_dif(NBANDS)

! ---- remainder are used only for cold start ---------
character(len=16):: glac_to_use  = 'single-tile'
       ! 'multi-tile' for tiled soil [default]
       ! 'single-tile' for geographically varying glacier with single type per
       !     model grid cell
       ! 'uniform' for global constant soil, e.g., to reproduce MCM
logical :: use_single_glac       = .false.   ! true for single global glacier,
                                             ! e.g., to recover MCM
logical :: use_mcm_albedo        = .false.   ! .true. for CLIMAP albedo inputs
logical :: use_single_geo        = .false.   ! .true. for global gw res time,
                                             ! e.g., to recover MCM
integer :: glac_index_constant   = 1         ! index of global constant glacier,
                                             ! used when use_single_glacier
real    :: gw_res_time           = 60.*86400 ! mean groundwater residence time,
                                             ! used when use_single_geo
real    :: rsa_exp_global        = 1.5
real    :: geothermal_heat_flux_constant = 0.0  ! true continental average is ~0.065 W/m2
real, dimension(n_dim_glac_types) :: &
     dat_w_sat             =(/ 1.000   /),&
     dat_awc_lm2           =(/ 1.000   /),&
     dat_k_sat_ref         =(/ 0.021   /),&
     dat_psi_sat_ref       =(/ -.059   /),&
     dat_chb               =(/   3.5   /),&
     dat_heat_capacity_ref =(/ 1.6e6   /),&
     dat_thermal_cond_ref  =(/   1.8   /),&
     dat_emis_dry          =(/ 0.950   /),&
     dat_emis_sat          =(/ 0.980   /),&
     dat_z0_momentum       =(/  0.01   /),&
     dat_tf_depr           =(/  0.00   /)
real, dimension(n_dim_glac_types, NBANDS) :: &
     dat_refl_max_dir, dat_refl_max_dif, &
     dat_refl_min_dir, dat_refl_min_dif
                      !  VIS    NIR
data dat_refl_max_dir / 0.800, 0.800 /, & 
     dat_refl_max_dif / 0.800, 0.800 /, & 
     dat_refl_min_dir / 0.650, 0.650 /, &
     dat_refl_min_dif / 0.650, 0.650 /
integer, dimension(n_dim_glac_types) :: &
     input_cover_types     =(/ 9 /)
character(len=4), dimension(n_dim_glac_types) :: &
     tile_names            =(/'glac'/)
real, public :: &
     cpw = 1952.0, &  ! specific heat of water vapor at constant pressure
     clw = 4218.0, &  ! specific heat of water (liquid)
     csw = 2106.0     ! specific heat of water (ice)

namelist /glac_data_nml/ &
     glac_to_use, tile_names, input_cover_types, &
     k_over_B,  &
     rate_fc, sfc_heat_factor, z_sfc_layer,          &
     num_l, dz,             &
     use_lm2_awc,   use_lad1_glac, &
     use_single_glac,      use_mcm_albedo,            &
     use_single_geo,        glac_index_constant,         &
     gw_res_time,      rsa_exp_global,  geothermal_heat_flux_constant, &
     dat_w_sat,             dat_awc_lm2,     &
     dat_k_sat_ref,         &
     dat_psi_sat_ref,               dat_chb,          &
     dat_heat_capacity_ref,         dat_thermal_cond_ref,   &
     dat_refl_max_dir,  dat_refl_max_dif,  &
     dat_refl_min_dir,  dat_refl_min_dif,  &
     dat_emis_dry,              dat_emis_sat,                &
     dat_z0_momentum,           dat_tf_depr, &
     tile_names, input_cover_types, &
     f_iso_cold, f_vol_cold, f_geo_cold, f_iso_warm, f_vol_warm, f_geo_warm 

! ---- end of namelist

integer :: num_sfc_layers

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-


! ============================================================================
subroutine read_glac_data_namelist(glac_n_lev, glac_dz)
  integer, intent(out) :: glac_n_lev
  real,    intent(out) :: glac_dz(:)
  ! ---- local vars
  integer :: unit         ! unit for namelist i/o
  integer :: io           ! i/o status for the namelist
  integer :: ierr         ! error code, returned by i/o routines
  integer :: i
  real    :: z

  call write_version_number(version, tagname)
#ifdef INTERNAL_FILE_NML
     read (input_nml_file, nml=glac_data_nml, iostat=io)
     ierr = check_nml_error(io, 'glac_data_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file()
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=glac_data_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'glac_data_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif
  unit=stdlog()
  write (unit, nml=glac_data_nml)

  refl_cold_dif = g_iso*f_iso_cold + g_vol*f_vol_cold + g_geo*f_geo_cold
  refl_warm_dif = g_iso*f_iso_warm + g_vol*f_vol_warm + g_geo*f_geo_warm

  ! register selectors for tile-specific diagnostics
  do i=1, n_dim_glac_types
     call register_tile_selector(tile_names(i), long_name='',&
          tag = SEL_GLAC, idata1 = i )
  enddo

  ! initialize num_sfc_layers
  z = 0
  num_sfc_layers = 0
  do i = 1, num_l
     z = z + dz(i)
     if (z < z_sfc_layer+1.e-4) num_sfc_layers = i
  enddo

  ! set up output arguments
  glac_n_lev = num_l
  glac_dz = dz
end subroutine 


! ============================================================================
function glac_tile_ctor(tag) result(ptr)
  type(glac_tile_type), pointer :: ptr ! return value
  integer, intent(in)  :: tag ! kind of tile

  allocate(ptr)
  ptr%tag = tag
  ! allocate storage for tile data
  allocate(ptr%prog   (num_l),  &
           ptr%w_fc   (num_l),  &
           ptr%w_wilt (num_l),  &
           ptr%heat_capacity_dry (num_l),  &
           ptr%e      (num_l),  &
           ptr%f      (num_l)   )

  ! set initial values of the tile data
  call glacier_data_init_0d(ptr)
end function glac_tile_ctor
  

! ============================================================================
function glac_tile_copy_ctor(glac) result(ptr)
  type(glac_tile_type), intent(in) :: glac ! return value
  type(glac_tile_type), pointer    :: ptr  ! return value

  allocate(ptr)
  ptr = glac ! copy all non-allocatable data
  ! allocate storage for tile data
  allocate(ptr%prog   (num_l),  &
           ptr%w_fc   (num_l),  &
           ptr%w_wilt (num_l),  &
           ptr%heat_capacity_dry (num_l),  &
           ptr%e      (num_l),  &
           ptr%f      (num_l)   )
  ! copy allocatable data
   ptr%prog(:)   = glac%prog(:)
   ptr%w_fc(:)   = glac%w_fc(:)
   ptr%w_wilt(:) = glac%w_wilt(:)
   ptr%heat_capacity_dry(:) = glac%heat_capacity_dry(:) 
   ptr%e(:)      = glac%e(:)
   ptr%f(:)      = glac%f(:)
 end function glac_tile_copy_ctor


! ============================================================================
subroutine delete_glac_tile(ptr)
  type(glac_tile_type), pointer :: ptr

  deallocate(ptr%prog, ptr%w_fc, ptr%w_wilt, ptr%heat_capacity_dry, &
        ptr%e,  ptr%f)
  deallocate(ptr)
end subroutine delete_glac_tile


! ============================================================================
subroutine glacier_data_init_0d(glac)
  type(glac_tile_type), intent(inout) :: glac

  integer :: k
  k = glac%tag

  glac%pars%w_sat             = dat_w_sat            (k)
  glac%pars%awc_lm2           = dat_awc_lm2          (k)
  glac%pars%k_sat_ref         = dat_k_sat_ref        (k)
  glac%pars%psi_sat_ref       = dat_psi_sat_ref      (k)
  glac%pars%chb               = dat_chb              (k)
  glac%pars%alpha             = 1
  glac%pars%heat_capacity_ref = dat_heat_capacity_ref(k)
  glac%pars%thermal_cond_ref  = dat_thermal_cond_ref (k)
  glac%pars%refl_max_dir      = dat_refl_max_dir     (k,:)
  glac%pars%refl_max_dif      = dat_refl_max_dif     (k,:)
  glac%pars%refl_min_dir      = dat_refl_min_dir     (k,:)
  glac%pars%refl_min_dif      = dat_refl_min_dif     (k,:)
  glac%pars%emis_dry          = dat_emis_dry         (k)
  glac%pars%emis_sat          = dat_emis_sat         (k)
  glac%pars%z0_momentum       = dat_z0_momentum      (k)
  glac%pars%tfreeze           = tfreeze - dat_tf_depr(k)

  glac%pars%tau_groundwater   = 86400*30 ! 30 days
  glac%pars%rsa_exp           = rsa_exp_global

  ! initialize derived data
  if (use_lm2_awc) then
     glac%w_wilt(:) = 0.15
     glac%w_fc  (:) = 0.15 + glac%pars%awc_lm2
  else
     glac%w_wilt(:) = glac%pars%w_sat &
          *(glac%pars%psi_sat_ref/(psi_wilt*glac%pars%alpha))**(1/glac%pars%chb)
     glac%w_fc  (:) = glac%pars%w_sat &
          *(rate_fc/(glac%pars%k_sat_ref*glac%pars%alpha**2))**(1/(3+2*glac%pars%chb))
  endif

  ! below made use of phi_e from parlange via entekhabi
  glac%Eg_part_ref  = (-4*glac%w_fc(1)**2*glac%pars%k_sat_ref*glac%pars%psi_sat_ref*glac%pars%chb &
       /(pi*glac%pars%w_sat)) * (glac%w_fc(1)/glac%pars%w_sat)**(2+glac%pars%chb)   &
       *(2*pi/(3*glac%pars%chb**2*(1+3/glac%pars%chb)*(1+4/glac%pars%chb)))/2

  glac%z0_scalar = glac%pars%z0_momentum * exp(-k_over_B)
  glac%geothermal_heat_flux = geothermal_heat_flux_constant
  
end subroutine glacier_data_init_0d


! ============================================================================
function glac_cover_cold_start(land_mask, lonb, latb) result (glac_frac)
  logical, intent(in) :: land_mask(:,:)    ! land mask
  real,    intent(in) :: lonb(:,:), latb(:,:) ! boundaries of the grid cells
  real,    pointer    :: glac_frac (:,:,:) ! output: map of fractional coverage

  allocate( glac_frac(size(land_mask,1),size(land_mask,2),n_dim_glac_types))

  call init_cover_field(glac_to_use, 'INPUT/ground_type.nc', 'cover','frac', &
       lonb, latb, glac_index_constant, input_cover_types, glac_frac)
  
end function 

! =============================================================================
function glac_tiles_can_be_merged(glac1,glac2) result(response)
  logical :: response
  type(glac_tile_type), intent(in) :: glac1,glac2

  response = (glac1%tag==glac2%tag)
end function

! =============================================================================
! combine two glacier states with specified weights; the result goes into
! the second one.
! t1 does not change; the properties of t2 (that is, heat capacity, etc) do not 
! change either -- that might be not good in the long run
subroutine merge_glac_tiles(g1,w1,g2,w2)
  type(glac_tile_type), intent(in)    :: g1
  type(glac_tile_type), intent(inout) :: g2     
  real                , intent(in)    :: w1, w2 ! relative weights
  
  ! ---- local vars
  real    :: x1, x2 ! normalized relative weights
  real    :: gw, HEAT1, HEAT2 ! temporaries for groundwater and heat
  integer :: i
  real    :: C1(num_l), C2(num_l) ! heat capacities of dry glacier
  
  ! calculate normalized weights
  x1 = w1/(w1+w2)
  x2 = 1.0 - x1
  
  ! calculate dry heat capacities of the glaciers
  call glac_dry_heat_cap(g1,C1)
  call glac_dry_heat_cap(g2,C2)

  ! combine state variables
  do i = 1,num_l
    ! calculate heat content at this level for both source tiles
    HEAT1 = &
    (C1(i)*dz(i)+clw*g1%prog(i)%wl+csw*g1%prog(i)%ws) * (g1%prog(i)%T-tfreeze)
    HEAT2 = &
    (C2(i)*dz(i)+clw*g2%prog(i)%wl+csw*g2%prog(i)%ws) * (g2%prog(i)%T-tfreeze)
    ! calculate (and assign) combined water mass
    g2%prog(i)%wl = g1%prog(i)%wl*x1 + g2%prog(i)%wl*x2
    g2%prog(i)%ws = g1%prog(i)%ws*x1 + g2%prog(i)%ws*x2
    ! if dry heat capacity of combined glacier is to be changed, update it here
    ! ...
    ! calculate combined temperature, based on total heat content and combined
    ! heat capacity
    g2%prog(i)%T = (HEAT1*x1+HEAT2*x2) / &
      (C2(i)*dz(i)+clw*g2%prog(i)%wl+csw*g2%prog(i)%ws) + tfreeze

    ! calculate combined groundwater content
    gw = g1%prog(i)%groundwater*x1 + g2%prog(i)%groundwater*x2
    ! calculate combined groundwater temperature
    if(gw/=0) then
       g2%prog(i)%groundwater_T = ( &
            g1%prog(i)%groundwater*x1*(g1%prog(i)%groundwater_T-tfreeze) + &
            g2%prog(i)%groundwater*x2*(g2%prog(i)%groundwater_T-tfreeze)   &
            ) / gw + Tfreeze
    else
       g2%prog(i)%groundwater_T = &
            x1*g1%prog(i)%groundwater_T + x2*g2%prog(i)%groundwater_T
    endif
    g2%prog(i)%groundwater = gw
  enddo
  
end subroutine

! =============================================================================
! returns true if tile fits the specified selector
function glac_is_selected(glac, sel)
  logical glac_is_selected
  type(tile_selector_type),  intent(in) :: sel
  type(glac_tile_type),      intent(in) :: glac

  glac_is_selected = (sel%idata1 == glac%tag)
end function 


! ============================================================================
! returns tag of the tile
function get_glac_tile_tag(glac) result(tag)
  integer :: tag
  type(glac_tile_type), intent(in) :: glac
  
  tag = glac%tag
end function

! ============================================================================
! compute glacier thermodynamic properties.
subroutine glac_dry_heat_cap ( glac, heat_capacity_dry)
  type(glac_tile_type), intent(in)  :: glac
  real,                 intent(out) :: heat_capacity_dry(:)

  ! ---- local vars
  integer l

  ! these will eventually be functions of water content (or psi) and T.
  do l = 1, num_sfc_layers
     heat_capacity_dry(l) = sfc_heat_factor*glac%pars%heat_capacity_ref
  enddo
  do l = num_sfc_layers+1, num_l
     heat_capacity_dry(l) = glac%pars%heat_capacity_ref
  enddo

end subroutine 


! ============================================================================
! compute bare-glacier albedos and bare-glacier emissivity
subroutine glac_data_radiation ( glac, cosz, use_brdf, &
                                 glac_refl_dir, glac_refl_dif, glac_emis )
  type(glac_tile_type), intent(in) :: glac
  real,                 intent(in) :: cosz
  logical,              intent(in) :: use_brdf
  real,                 intent(out):: glac_refl_dir(:), glac_refl_dif(:), glac_emis

  ! ---- local vars 
  real  :: blend, t_crit
  real :: warm_value_dir(NBANDS), cold_value_dir(NBANDS)
  real :: warm_value_dif(NBANDS), cold_value_dif(NBANDS)
  real :: zenith_angle, zsq, zcu

  t_crit = tfreeze - t_range
  blend = (glac%prog(1)%T - t_crit) / t_range
  if (blend < 0.0) blend = 0.0
  if (blend > 1.0) blend = 1.0
  if (use_brdf) then
      zenith_angle = acos(cosz)
      zsq = zenith_angle*zenith_angle
      zcu = zenith_angle*zsq
      warm_value_dir = f_iso_warm*(g0_iso+g1_iso*zsq+g2_iso*zcu) &
                     + f_vol_warm*(g0_vol+g1_vol*zsq+g2_vol*zcu) &
                     + f_geo_warm*(g0_geo+g1_geo*zsq+g2_geo*zcu)
      cold_value_dir = f_iso_cold*(g0_iso+g1_iso*zsq+g2_iso*zcu) &
                     + f_vol_cold*(g0_vol+g1_vol*zsq+g2_vol*zcu) &
                     + f_geo_cold*(g0_geo+g1_geo*zsq+g2_geo*zcu)
      warm_value_dif = refl_warm_dif
      cold_value_dif = refl_cold_dif
    else
      warm_value_dir = glac%pars%refl_min_dir
      cold_value_dir = glac%pars%refl_max_dir
      warm_value_dif = glac%pars%refl_min_dif
      cold_value_dif = glac%pars%refl_max_dif
    endif
  glac_refl_dir = cold_value_dir + blend*(warm_value_dir-cold_value_dir)
  glac_refl_dif = cold_value_dif + blend*(warm_value_dif-cold_value_dif)
  glac_emis     = glac%pars%emis_dry + blend*(glac%pars%emis_sat-glac%pars%emis_dry)

end subroutine glac_data_radiation


! ============================================================================
! compute bare-glacier roughness
subroutine glac_data_diffusion ( glac, glac_z0s, glac_z0m )
  type(glac_tile_type), intent(in) :: glac
  real,                 intent(out):: glac_z0s, glac_z0m

  ! ---- surface roughness ---------------------------------------------------
  glac_z0s = glac%z0_scalar
  glac_z0m = glac%pars%z0_momentum

end subroutine glac_data_diffusion


! ============================================================================
! compute glacier thermodynamic properties.
subroutine glac_data_thermodynamics ( glac_pars, vlc_sfc, vsc_sfc, &  
     glac_rh, heat_capacity_dry, thermal_cond)
  type(glac_pars_type), intent(in)  :: glac_pars
  real,                 intent(in)  :: vlc_sfc
  real,                 intent(in)  :: vsc_sfc
  real,                 intent(out) :: glac_rh
  real,                 intent(out) :: heat_capacity_dry(:)
  real,                 intent(out) :: thermal_cond(:)

  ! ---- local vars
  integer l

! ----------------------------------------------------------------------------
! in preparation for implicit energy balance, determine various measures
! of water availability, so that vapor fluxes will not exceed mass limits
! ----------------------------------------------------------------------------

  glac_rh = 1

  ! these will eventually be functions of water content (or psi) and T.
  do l = 1, num_sfc_layers
     heat_capacity_dry(l) = sfc_heat_factor*glac_pars%heat_capacity_ref
     thermal_cond(l)  = sfc_heat_factor*glac_pars%thermal_cond_ref
  enddo
  do l = num_sfc_layers+1, num_l
     heat_capacity_dry(l) = glac_pars%heat_capacity_ref
     thermal_cond(l)  = glac_pars%thermal_cond_ref
  enddo

end subroutine 


! ============================================================================
! compute glacier hydraulic properties.
subroutine glac_data_hydraulics (glac, vlc, vsc, &
     psi, DThDP, hyd_cond, DKDP, DPsi_min, DPsi_max, tau_gw, &
     glac_w_fc  )
  type(glac_tile_type),        intent(in)  :: glac
  real,                        intent(in),  dimension(:) :: vlc, vsc
  real,                        intent(out), dimension(:) :: &
       psi, DThDP, hyd_cond, DKDP, glac_w_fc
  real,                        intent(out) :: &
       DPsi_min, DPsi_max, tau_gw

  ! ---- local vars
  integer l
  real,  dimension(num_l) :: vlc_loc
  real :: real1
  logical :: logical1

  ! ---- T-dependence of hydraulic properties --------------------------------
  ! k_sat   = glac%pars%k_sat0   !  * mu(t0)/mu(t), where mu is dynamic viscosity
  ! psi_sat = glac%pars%psi_sat0 !  * exp(c*(psi-psi0)), where c~+/-(?)0.0068
  ! better approach would be to adopt air entrapment model
  ! or at least to scale against surface tension model


  ! ---- water and ice dependence of hydraulic properties --------------------
  ! ---- (T-dependence can be added later)
  hyd_cond = 1; DThDP = 1
  do l = 1, num_l
    hyd_cond(l) = (glac%pars%k_sat_ref*glac%pars%alpha**2)*  &
         ! * mu(T)/mu(t_ref), where mu is dynamic viscosity
          (vlc(l)/glac%pars%w_sat)**(3+2*glac%pars%chb)
    if (hyd_cond(l).lt.1.e-12*glac%pars%k_sat_ref) then
      vlc_loc (l) = glac%pars%w_sat*(1.e-12)**(1./(3+2*glac%pars%chb))
      hyd_cond(l) = 1.e-12*glac%pars%k_sat_ref
      if (vsc(l).eq.0.) then
        DThDP   (l) = -vlc_loc(l)  &
             *(vlc_loc(l)/glac%pars%w_sat)**glac%pars%chb &
             /(glac%pars%psi_sat_ref*glac%pars%chb)
        psi     (l) = (glac%pars%psi_sat_ref/glac%pars%alpha) &
             *(glac%pars%w_sat/vlc_loc(l))**glac%pars%chb &
             + (vlc(l)-vlc_loc (l))/DThDP   (l)
        DKDP    (l) = 0.
      else
        psi     (l) = ((glac%pars%psi_sat_ref/glac%pars%alpha) / 2.2) &
             *(glac%pars%w_sat/vlc_loc(l))**glac%pars%chb
        DKDP    (l) = 0.
        DThDP   (l) = 0.
      endif
    else
      if (vsc(l).eq.0.) then
        real1 = glac%pars%w_sat - vlc(l)
        logical1 = real1.ge.0.
        if (logical1) then
           !              where (vlc(l).le.glac%pars%w_sat)
           psi     (l) = (glac%pars%psi_sat_ref/glac%pars%alpha) &
                *(glac%pars%w_sat/vlc(l))**glac%pars%chb
           DKDP    (l) = -(2+3/glac%pars%chb)*hyd_cond(l) &
                /psi(l)
           DThDP   (l) = -vlc(l)/(psi(l)*glac%pars%chb)
        else
           psi(l) = glac%pars%psi_sat_ref &
                + (vlc(l)-glac%pars%w_sat)/comp
           DThDP(l) = comp
           hyd_cond(l) = glac%pars%k_sat_ref
           DKDP(l) = 0.
        endif
      else
        psi     (l) = ((glac%pars%psi_sat_ref/glac%pars%alpha) / 2.2) &
             *(glac%pars%w_sat/vlc(l))**glac%pars%chb
        DKDP    (l) = 0.
        DThDP   (l) = 0.
      endif
    endif
  enddo

  if (DThDP(1).ne.0.) then
    DPsi_min =            -vlc(1) /DThDP(1)
    DPsi_max = (glac%pars%w_sat-vlc(1))/DThDP(1)
  else
    Dpsi_min = -1.e16
    DPsi_max = -psi(1)
  endif

  glac_w_fc = glac%w_fc

  ! ---- groundwater ---------------------------------------------------------
  tau_gw = glac%pars%tau_groundwater

end subroutine glac_data_hydraulics

! ============================================================================
subroutine glac_tile_stock_pe (glac, twd_liq, twd_sol  )
  type(glac_tile_type),  intent(in)    :: glac
  real,                  intent(out)   :: twd_liq, twd_sol
  integer n
  
  twd_liq = 0.
  twd_sol = 0.
  do n=1, size(glac%prog)
    twd_liq = twd_liq + glac%prog(n)%wl + glac%prog(n)%groundwater
    twd_sol = twd_sol + glac%prog(n)%ws
    enddo

end subroutine glac_tile_stock_pe

! ============================================================================
! returns glacier heat content, J/m2
function glac_tile_heat (glac) result(heat) ; real heat
  type(glac_tile_type),  intent(in)  :: glac

  integer :: i

  heat = 0
  do i = 1, num_l
     heat = heat + &
          (glac%heat_capacity_dry(i)*dz(i) + clw*glac%prog(i)%wl + csw*glac%prog(i)%ws)&
                           *(glac%prog(i)%T-tfreeze) + &
          clw*glac%prog(i)%groundwater*(glac%prog(i)%groundwater_T-tfreeze) - &
          hlf*glac%prog(i)%ws
  enddo
end function

end module glac_tile_mod

!-----------------------------------------------------------------------
! Copyright 2011 NOAA Geophysical Fluid Dynamics Lab, Princeton, NJ
! This program is distributed under the terms of the GNU General Public
! License. See the file COPYING contained in this directory
!-----------------------------------------------------------------------

module moisture_convert_mod

!-----------------------------------------------------------------------

use  plev_constants_mod, only: RDGAS, RVGAS, TFREEZE

implicit none
private

public  sphum_to_mixrat, mixrat_to_sphum,  &
            e_to_mixrat,      e_to_sphum,  &
           mixrat_to_rh,     sphum_to_rh,  &
           rh_to_mixrat,     rh_to_sphum

!-----------------------------------------------------------------------

interface sphum_to_mixrat
    module procedure sphum_to_mixrat_0d, sphum_to_mixrat_3d
end interface

interface mixrat_to_sphum
    module procedure mixrat_to_sphum_0d, mixrat_to_sphum_3d
end interface

interface e_to_mixrat
    module procedure e_to_mixrat_0d, e_to_mixrat_3d
end interface

interface e_to_sphum
    module procedure e_to_sphum_0d, e_to_sphum_3d
end interface

interface mixrat_to_rh
    module procedure mixrat_to_rh_0d, mixrat_to_rh_3d
end interface

interface sphum_to_rh
    module procedure sphum_to_rh_0d, sphum_to_rh_3d
end interface

interface rh_to_mixrat
    module procedure rh_to_mixrat_0d, rh_to_mixrat_3d
end interface

interface rh_to_sphum
    module procedure rh_to_sphum_0d, rh_to_sphum_3d
end interface

interface lookup_es
    module procedure lookup_es_0d, lookup_es_3d
end interface

!-----------------------------------------------------------------------

real, parameter :: eps = RDGAS/RVGAS,  one_eps = 1.-eps

!-----------------------------------------------------------------------
!  parameters for es table size and resolution

 integer, parameter :: tcmin = -160  ! minimum temperature (degC) in lookup table
 integer, parameter :: tcmax =  100  ! maximum temperature (degC) in lookup table
 integer, parameter :: esres =  10   ! table resolution (increments per degree)
 integer, parameter :: nsize = (tcmax-tcmin)*esres+1    !  lookup table size
 integer, parameter :: nlim  = nsize-1

 real    :: tmin, tmax          !  lookup table limits in degK
 real    :: dtres, dtinv, teps

 real ::   TABLE(nsize)    !  sat vapor pres (es)
 real ::  DTABLE(nsize)    !  first derivative of es
 real :: D2TABLE(nsize)    ! second derivative of es

 logical :: table_is_initialized = .FALSE.

contains

!#######################################################################

  function sphum_to_mixrat_0d (sphum) result (mixrat)

    real, intent(in) :: sphum
    real             :: mixrat

    mixrat = sphum / (1.0 - sphum)

  end function sphum_to_mixrat_0d

!-----------------------------------------------------------------------

  function sphum_to_mixrat_3d (sphum) result (mixrat)

    real, intent(in) :: sphum(:,:,:)
    real, dimension(size(sphum,1),size(sphum,2),size(sphum,3)) :: mixrat

    mixrat = sphum / (1.0 - sphum)

  end function sphum_to_mixrat_3d

!#######################################################################

  function mixrat_to_sphum_0d (mixrat) result (sphum)

    real, intent(in) :: mixrat
    real             :: sphum

    sphum = mixrat / (1.0 + mixrat)

  end function mixrat_to_sphum_0d

!-----------------------------------------------------------------------

  function mixrat_to_sphum_3d (mixrat) result (sphum)

    real, intent(in) :: mixrat(:,:,:)
    real, dimension(size(mixrat,1),size(mixrat,2),size(mixrat,3)) ::  &
            sphum

    sphum = mixrat / (1.0 + mixrat)

  end function mixrat_to_sphum_3d

!#######################################################################

  function e_to_mixrat_0d (e, pres) result (mixrat)

    real, intent(in) :: e, pres
    real             :: mixrat

    mixrat = eps * e / (pres - e )

  end function e_to_mixrat_0d

!-----------------------------------------------------------------------

  function e_to_mixrat_3d (e, pres) result (mixrat)

    real, intent(in), dimension(:,:,:) :: e, pres
    real, dimension(size(e,1),size(e,2),size(e,3)) :: mixrat

    mixrat = eps * e / (pres - e )

  end function e_to_mixrat_3d

!#######################################################################

  function e_to_sphum_0d (e, pres) result (sphum)

    real, intent(in) :: e, pres
    real             :: sphum

    sphum = eps * e / (pres - one_eps * e )

  end function e_to_sphum_0d

!-----------------------------------------------------------------------

  function e_to_sphum_3d (e, pres) result (sphum)

    real, intent(in), dimension(:,:,:) :: e, pres
    real, dimension(size(e,1),size(e,2),size(e,3)) :: sphum

    sphum = eps * e / (pres - one_eps * e )

  end function e_to_sphum_3d

!#######################################################################

  function mixrat_to_rh_0d (mixrat, temp, pres) result (rh)

    real, intent(in) :: mixrat, temp, pres
    real             :: rh, esat, mixrat_sat

    call lookup_es (temp, esat)
    mixrat_sat = e_to_mixrat (esat, pres)

    rh = mixrat / mixrat_sat

  end function mixrat_to_rh_0d

!-----------------------------------------------------------------------

  function mixrat_to_rh_3d (mixrat, temp, pres) result (rh)

    real, intent(in), dimension(:,:,:) :: mixrat, temp, pres
    real, dimension(size(temp,1),size(temp,2),size(temp,3)) ::  &
            rh, esat, mixrat_sat

    call lookup_es (temp, esat)
    mixrat_sat = e_to_mixrat (esat, pres)

    rh = mixrat / mixrat_sat

  end function mixrat_to_rh_3d

!#######################################################################

  function sphum_to_rh_0d (sphum, temp, pres) result (rh)

    real, intent(in) :: sphum, temp, pres
    real  ::  rh, mixrat

    mixrat = sphum_to_mixrat (sphum)
    rh = mixrat_to_rh (mixrat, temp, pres)

  end function sphum_to_rh_0d

!-----------------------------------------------------------------------

  function sphum_to_rh_3d (sphum, temp, pres) result (rh)

    real, intent(in), dimension(:,:,:) :: sphum, temp, pres
    real, dimension(size(temp,1),size(temp,2),size(temp,3)) ::  &
            rh, mixrat

    mixrat = sphum_to_mixrat (sphum)
    rh = mixrat_to_rh (mixrat, temp, pres)

  end function sphum_to_rh_3d

!#######################################################################

  function rh_to_mixrat_0d (rh, temp, pres) result (mixrat)

    real, intent(in) :: rh, temp, pres
    real             ::  mixrat, esat, mixrat_sat

    call lookup_es (temp, esat)
    mixrat_sat = e_to_mixrat (esat, pres)

    mixrat = mixrat_sat * rh

  end function rh_to_mixrat_0d

!-----------------------------------------------------------------------

  function rh_to_mixrat_3d (rh, temp, pres) result (mixrat)

    real, intent(in), dimension(:,:,:) :: rh, temp, pres
    real, dimension(size(temp,1),size(temp,2),size(temp,3)) ::  &
            mixrat, esat, mixrat_sat

    call lookup_es (temp, esat)
    mixrat_sat = e_to_mixrat (esat, pres)

    mixrat = mixrat_sat * rh

  end function rh_to_mixrat_3d

!#######################################################################

  function rh_to_sphum_0d (rh, temp, pres) result (sphum)

    real, intent(in) :: rh, temp, pres
    real             ::  sphum, mixrat

    mixrat = rh_to_mixrat (rh, temp, pres)
    sphum  = mixrat_to_sphum (mixrat)

  end function rh_to_sphum_0d

!-----------------------------------------------------------------------

  function rh_to_sphum_3d (rh, temp, pres) result (sphum)

    real, intent(in), dimension(:,:,:) :: rh, temp, pres
    real, dimension(size(temp,1),size(temp,2),size(temp,3)) ::  &
            sphum, mixrat

    mixrat = rh_to_mixrat (rh, temp, pres)
    sphum  = mixrat_to_sphum (mixrat)

  end function rh_to_sphum_3d

!#######################################################################
!           saturation vapor pressure lookup table
!#######################################################################

  subroutine lookup_es_0d (temp, esat)
    real, intent(in)  :: temp
    real, intent(out) :: esat
    real    :: tmp, del
    integer :: ind

    call sat_vapor_pres_init

    tmp = temp-tmin
    ind = int(dtinv*(tmp+teps))
    del = tmp-dtres*real(ind)
    esat = TABLE(ind+1) + del*(DTABLE(ind+1) + del*D2TABLE(ind+1))

    if (ind < 0 .or. ind > nlim) then
       print *, 'ERROR: saturation vapor pressure error'
       stop 111
    endif

  end subroutine lookup_es_0d

!-----------------------------------------------------------------------

  subroutine lookup_es_3d (temp, esat)
    real, intent(in)  :: temp(:,:,:)
    real, intent(out) :: esat(:,:,:)
    real    :: tmp, del
    integer :: ind
    integer :: i, j, k

    call sat_vapor_pres_init

    do  k = 1, size(temp,3)
    do  j = 1, size(temp,2)
    do  i = 1, size(temp,1)
       tmp = temp(i,j,k)-tmin
       ind = int(dtinv*(tmp+teps))
       del = tmp-dtres*real(ind)
       esat(i,j,k) = TABLE(ind+1) + del*(DTABLE(ind+1) + del*D2TABLE(ind+1))
       if (ind < 0 .or. ind > nlim) then
          print *, 'ERROR: saturation vapor pressure error'
          stop 111
       endif
    enddo
    enddo
    enddo

  end subroutine lookup_es_3d

!-----------------------------------------------------------------------
!                Computation of the es values
!
!   Saturation vapor pressure (es) values are computed from
!   equations in the Smithsonian meteorological tables page 350.
!   For temperatures < 0C, sat vapor pres is computed over ice.
!   For temperatures > -20C, sat vapor pres is computed over water.
!   Between -20C and 0C the returned value is blended (over water
!   and over ice).  All sat vapor pres values are returned in pascals.
!
!   Reference:  Smithsonian meteorological tables, page 350.

function compute_es (tem) result (es)
 real, intent(in) :: tem(:)
 real :: es(size(tem,1))

 real, parameter :: TBASW = TFREEZE+100.
 real, parameter :: TBASI = TFREEZE
 real, parameter :: ESBASW = 101324.60
 real, parameter :: ESBASI =    610.71

 real    :: x, esice, esh2o
 integer :: i

   do i = 1, size(tem(:))

!  compute es over ice 

     if (tem(i) < TBASI) then
         x = -9.09718*(TBASI/tem(i)-1.0) - 3.56654*log10(TBASI/tem(i)) &
             +0.876793*(1.0-tem(i)/TBASI) + log10(ESBASI)
         esice =10.**(x)
     else
         esice = 0.
     endif

!  compute es over water greater than -20 c.
!  values over 100 c may not be valid
!  see smithsonian meteorological tables page 350.

     if (tem(i) > -20.+TBASI) then
         x = -7.90298*(TBASW/tem(i)-1) + 5.02808*log10(TBASW/tem(i)) &
             -1.3816e-07*(10**((1-tem(i)/TBASW)*11.344)-1)        &
             +8.1328e-03*(10**((TBASW/tem(i)-1)*(-3.49149))-1)    &
             +log10(ESBASW)
         esh2o = 10.**(x)
     else
         esh2o = 0.
     endif

!  derive blended es over ice and supercooled water between -20c and 0c

     if (tem(i) <= -20.+TBASI) then
         es(i) = esice
     else if (tem(i) >= TBASI) then
         es(i) = esh2o
     else
         es(i) = 0.05*((TBASI-tem(i))*esice + (tem(i)-TBASI+20.)*esh2o)
     endif

   enddo

end function compute_es

!-----------------------------------------------------------------------

subroutine sat_vapor_pres_init

  real    :: tem(3), es(3), hdtinv
  integer :: i

! increment used to generate derivative table
  real, parameter :: tinrc = .01           
  real, parameter :: tfact = 1./(2.*tinrc)

! return silently if this routine has already been called
  if (table_is_initialized) return

! global variables
      tmin = real(tcmin)+TFREEZE   ! minimum valid temp in table
      tmax = real(tcmax)+TFREEZE   ! maximum valid temp in table
      dtinv = real(esres)
      dtres = 1./dtinv
      teps = 1./real(2*esres)
! local variables
      hdtinv = dtinv*0.5! global variables
      tmin = real(tcmin)+TFREEZE   ! minimum valid temp in table
      tmax = real(tcmax)+TFREEZE   ! maximum valid temp in table
      dtinv = real(esres)
      dtres = 1./dtinv
      teps = 1./real(2*esres)
! local variables
      hdtinv = dtinv*0.5

! compute es tables from tcmin to tcmax
! estimate es derivative with small +/- difference

      do i = 1, nsize
         tem(1) = tmin + dtres*real(i-1)
         tem(2) = tem(1)-tinrc
         tem(3) = tem(1)+tinrc
         es = compute_es (tem)
          TABLE(i) = es(1)
         DTABLE(i) = (es(3)-es(2))*tfact
      enddo

! compute one-half second derivative using centered differences
! differencing des values in the table

      do i = 2, nsize-1
         D2TABLE(i) = 0.25*dtinv*(DTABLE(i+1)-DTABLE(i-1))
      enddo
    ! one-sided derivatives at boundaries
         D2TABLE(1)     = 0.50*dtinv*(DTABLE(2)    -DTABLE(1))
         D2TABLE(nsize) = 0.50*dtinv*(DTABLE(nsize)-DTABLE(nsize-1))

   table_is_initialized = .true.

end subroutine sat_vapor_pres_init

end module moisture_convert_mod

module ocean_lap_friction_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! This module calls the appropriate lateral laplacian friction modules. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module serves as an interface to the chosen lateral 
! laplacian friction modules.  
!</DESCRIPTION>
!
! <INFO>
!
! <NOTE>
! The model can generally run with both Laplacian and biharmonic friction
! enabled at the same time.  Such has been found useful for some eddying 
! ocean simulations. 
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_lap_friction_nml">
!
! <DATA NAME="lap_friction_scheme" TYPE="character">
! To determine the laplacian friction scheme: "const" or "general"
! </DATA> 
!
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging.  
!  </DATA> 
!
!  <DATA NAME="write_a_restart" TYPE="logical">
!  Set true to write a restart.  False setting only for rare 
!  cases where wish to benchmark model without measuring the cost
!  of writing restarts and associated chksums.  
!  Default is write_a_restart=.true. 
!  </DATA> 
!</NAMELIST>

use diag_manager_mod,only: register_diag_field
use fms_mod,         only: open_namelist_file, check_nml_error, write_version_number, close_file
use fms_mod,         only: FATAL, WARNING, stdout, stdlog
use fms_mod,         only: file_exist
use fms_io_mod,      only: register_restart_field, save_restart, restore_state
use fms_io_mod,      only: restart_file_type
use mpp_domains_mod, only: mpp_update_domains
use mpp_mod,         only: input_nml_file, mpp_clock_id, mpp_clock_begin, mpp_clock_end, CLOCK_MODULE
use mpp_mod,         only: mpp_error

use ocean_domains_mod,           only: get_local_indices
use ocean_lapcst_friction_mod,   only: ocean_lapcst_friction_init, lapcst_friction
use ocean_lapcst_friction_mod,   only: lapcst_viscosity_check, lapcst_reynolds_check
use ocean_lapgen_friction_mod,   only: ocean_lapgen_friction_init, lapgen_friction
use ocean_lapgen_friction_mod,   only: lapgen_viscosity_check, lapgen_reynolds_check 
use ocean_lapcgrid_friction_mod, only: lapcgrid_viscosity_check, lapcgrid_reynolds_check 
use ocean_lapcgrid_friction_mod, only: ocean_lapcgrid_friction_init, lapcgrid_friction
use ocean_operators_mod,         only: BAX, BAY, BDX_EU, BDY_NU, FDX_U, FDY_U, FMX, FMY
use ocean_parameters_mod,        only: missing_value, MOM_BGRID, MOM_CGRID 
use ocean_types_mod,             only: ocean_time_type, ocean_grid_type
use ocean_types_mod,             only: ocean_domain_type, ocean_adv_vel_type
use ocean_types_mod,             only: ocean_thickness_type, ocean_velocity_type
use ocean_types_mod,             only: ocean_options_type, ocean_density_type 
use ocean_util_mod,              only: write_timestamp, diagnose_2d_u, write_chksum_2d

implicit none

private

public ocean_lap_friction_init
public ocean_lap_friction_end
public lap_friction 
public lap_viscosity_check
public lap_reynolds_check
public lap_friction_barotropic
public ocean_lap_friction_restart

! for choosing the mixing scheme
character(len=10) :: lap_friction_scheme='general'  ! 'const' or 'general'
integer :: MIX_SCHEME=2  ! 1=const, 2=general, 3=cgrid 
logical :: debug_this_module = .false.

! for deciding whether we are using laplacian friction 
logical :: use_lapcst_friction  =.false. 
logical :: use_lapgen_friction  =.false. 
logical :: use_lapcgrid_friction=.false. 
logical :: use_this_module      =.false. 

! vertically averaged viscosity on east and north face of U cells (m^2/s)
real, dimension(:,:), allocatable :: lap_viscosity
real, dimension(:,:), allocatable :: lap_visc_ceu
real, dimension(:,:), allocatable :: lap_visc_cnu

! for diagnostics 
integer :: id_lap_viscosity=-1 
logical :: used

! for Bgrid or Cgrid
integer :: horz_grid

! for clocks
integer :: id_clock_lapcst
integer :: id_clock_lapgen
integer :: id_clock_lapcgrid

! for restart
type(restart_file_type), save :: Lap_restart

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()

integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk

character(len=256) :: version=&
     '=>Using: ocean_lap_friction.f90 ($Id: ocean_lap_friction.F90,v 20.0 2013/12/14 00:14:18 fms Exp $)'
character (len=128) :: tagname = &
     '$Name: tikal $'

logical :: module_is_initialized = .FALSE.
logical :: write_a_restart       = .true.

namelist /ocean_lap_friction_nml/ lap_friction_scheme, debug_this_module, write_a_restart 

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_lap_friction_init">
!
! <DESCRIPTION>
! Initialize the horizontal Laplacian friction module.
! </DESCRIPTION>
!
subroutine ocean_lap_friction_init(Grid, Domain, Time, Ocean_options, dtime, obc, hor_grid, debug)

  type(ocean_grid_type),   target,  intent(in)    :: Grid
  type(ocean_domain_type), target,  intent(in)    :: Domain
  type(ocean_time_type),            intent(in)    :: Time
  type(ocean_options_type),         intent(inout) :: Ocean_options
  real,                             intent(in)    :: dtime
  logical,                          intent(in)    :: obc
  integer,                          intent(in)    :: hor_grid
  logical,                optional, intent(in)    :: debug

  integer :: ioun, io_status, ierr
  integer :: num_methods=0 
  integer :: id_restart

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
     '==>Error in ocean_lap_friction_mod (ocean_lap_friction_init): already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_lap_friction_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_lap_friction_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_lap_friction_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_lap_friction_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_lap_friction_nml)  
  write (stdlogunit,ocean_lap_friction_nml)

  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk

  Grd => Grid
  Dom => Domain
  horz_grid = hor_grid 

  if (PRESENT(debug) .and. .not. debug_this_module) then 
    debug_this_module = debug
  endif 

  ! for clocks 
  id_clock_lapcst   = mpp_clock_id('(Ocean const   lap frict) ' ,grain=CLOCK_MODULE)
  id_clock_lapgen   = mpp_clock_id('(Ocean general lap frict) ' ,grain=CLOCK_MODULE)
  id_clock_lapcgrid = mpp_clock_id('(Ocean C-grid lap frict) '  ,grain=CLOCK_MODULE)

  ! vertically averaged vicsosities 
  allocate (lap_viscosity(isd:ied,jsd:jed))
  allocate (lap_visc_ceu(isd:ied,jsd:jed))
  allocate (lap_visc_cnu(isd:ied,jsd:jed))
  lap_viscosity(:,:) = 0.0
  lap_visc_ceu(:,:)  = 0.0
  lap_visc_cnu(:,:)  = 0.0


  ! initialize laplacian friction scheme

 ! older B-grid scheme originating from Cox model 
 if(lap_friction_scheme == 'const' .and. horz_grid == MOM_BGRID) then 
     num_methods=num_methods+1
     write(stdoutunit,'(a)') &
     '==>Note from ocean_lap_friction_init: constant laplacian friction scheme for B-grid is used.'
     MIX_SCHEME=1
     call ocean_lapcst_friction_init (Grid, Domain, Time, Ocean_options, dtime, &
                                      obc, use_lapcst_friction, debug_this_module)
     if(use_lapcst_friction) then 
        use_this_module = .true. 
     endif 

  ! modern B-grid scheme based on triads and allowing for many viscosity options 
  elseif(lap_friction_scheme == 'general' .and. horz_grid == MOM_BGRID) then 
     num_methods=num_methods+1
     write(stdoutunit,'(a)') &
     '==>Note from ocean_lap_friction_init: general laplacian friction scheme for B-grid is used.'
     MIX_SCHEME=2
     call ocean_lapgen_friction_init (Grid, Domain, Time, Ocean_options, dtime, &
                                      obc, use_lapgen_friction, debug_this_module)
     if(use_lapgen_friction) then 
        use_this_module = .true. 
     endif 


  ! Cgrid scheme allowing for many viscosity options 
  elseif(horz_grid == MOM_CGRID) then 
     num_methods=num_methods+1
     write(stdoutunit,'(a)') &
     '==>Note from ocean_lap_friction_init: C-grid laplacian friction scheme is used.'
     MIX_SCHEME=3
     call ocean_lapcgrid_friction_init (Grid, Domain, Time, Ocean_options, dtime, &
                                        obc, use_lapcgrid_friction, debug_this_module)
     if(use_lapcgrid_friction) then 
        use_this_module = .true. 
     endif 

 endif

 if(num_methods==0) then 
     write(stdoutunit,'(a)') &
     '==>Error: ocean_lap_friction_mod: pick a laplacian friction scheme.'
     call mpp_error(FATAL, &
     '==>Error: ocean_lap_friction_mod: pick a laplacian friction scheme.')
 elseif(num_methods>1) then 
     write(stdoutunit,'(a)') &
     '==>Error: ocean_lap_friction_mod: choose only one laplacian friction scheme.'
     call mpp_error(FATAL, &
     '==>Error: ocean_lap_friction_mod: choose only one laplacian friction scheme.')
 endif


  if(use_this_module) then 
       id_restart = register_restart_field(Lap_restart, 'ocean_lap_friction.res.nc', 'lap_viscosity', &
                    lap_viscosity, domain=Dom%domain2d)
      if(.NOT.file_exist('INPUT/ocean_lap_friction.res.nc')) then
          if (.NOT. Time%init) then 
              call mpp_error(FATAL,'Expecting file INPUT/ocean_lap_friction.res.nc to exist.&
                   &This file was not found and Time%init=.false.')
          endif
      else
          call restore_state(Lap_restart)
          call mpp_update_domains(lap_viscosity,Dom%domain2d)
          write (stdoutunit,'(1x,a)') 'lap_viscosity being read from restart.'
          call write_chksum_2d('start lap_viscosity', lap_viscosity(COMP)*Grd%umask(COMP,1))

          lap_visc_ceu(:,:) = BAY(lap_viscosity(:,:))
          lap_visc_cnu(:,:) = BAX(lap_viscosity(:,:))
          call mpp_update_domains (lap_visc_ceu, Dom%domain2d)
          call mpp_update_domains (lap_visc_cnu, Dom%domain2d)

      endif

      if(.not. write_a_restart) then 
          write(stdoutunit,'(a)') '==>Note: running ocean_lap_friction with write_a_restart=.false.'
          write(stdoutunit,'(a)') '   Will NOT write restart file, and so cannot restart the run.'
      endif

  endif


 id_lap_viscosity = register_diag_field ('ocean_model', 'lap_viscosity_2d', Grd%vel_axes_uv(1:2), &
                     Time%model_time,'Vertically averaged laplacian viscosity',                   &
                    'm^2/s',missing_value=missing_value, range=(/-10.0,1.e20/))


end subroutine ocean_lap_friction_init
! </SUBROUTINE>  NAME="ocean_lap_friction_init"


!#######################################################################
! <SUBROUTINE NAME="lap_friction">
!
! <DESCRIPTION>
! Compute the thickness weighted and density weighted accel due to 
! lateral laplacian friction.  Add this contribution to Velocity%accel. 
! </DESCRIPTION>
!
subroutine lap_friction(Time, Thickness, Adv_vel, Velocity, energy_analysis_step)

  type(ocean_time_type),       intent(in)    :: Time
  type(ocean_thickness_type),  intent(in)    :: Thickness
  type(ocean_adv_vel_type),    intent(in)    :: Adv_vel
  type(ocean_velocity_type),   intent(inout) :: Velocity
  logical,                     intent(in)    :: energy_analysis_step 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lap_friction_mod (lap_friction): module needs to be initialized')
  endif 

  if(MIX_SCHEME==1) then 
    call mpp_clock_begin(id_clock_lapcst)
    call lapcst_friction(Time, Thickness, Velocity, lap_viscosity, energy_analysis_step)
    call mpp_clock_end(id_clock_lapcst)

  elseif(MIX_SCHEME==2) then 
    call mpp_clock_begin(id_clock_lapgen)
    call lapgen_friction(Time, Thickness, Adv_vel, Velocity, lap_viscosity, energy_analysis_step)
    call mpp_clock_end(id_clock_lapgen)

  elseif(MIX_SCHEME==3) then 
    call mpp_clock_begin(id_clock_lapcgrid)
    call lapcgrid_friction(Time, Thickness, Velocity, lap_viscosity, energy_analysis_step)
    call mpp_clock_end(id_clock_lapcgrid)

  endif 

  ! vertically averaged viscosity for north and east face of U-cells 
  if(use_this_module) then 
     lap_visc_ceu(:,:) = BAY(lap_viscosity(:,:))
     lap_visc_cnu(:,:) = BAX(lap_viscosity(:,:))
     call mpp_update_domains (lap_visc_ceu, Dom%domain2d)
     call mpp_update_domains (lap_visc_cnu, Dom%domain2d)
  endif 

  call diagnose_2d_u(Time, Grd, id_lap_viscosity, lap_viscosity(:,:))

end subroutine lap_friction
! </SUBROUTINE> NAME="lap_friction"


!#######################################################################
! <SUBROUTINE NAME="lap_viscosity_check">
!
! <DESCRIPTION>
! To check that the viscosity is not too large. 
! </DESCRIPTION>
!
subroutine lap_viscosity_check

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, '==>Error in ocean_lap_friction_mod (lap_viscosity_check): needs initialization')
  endif 

  if(MIX_SCHEME==1) then 
    call lapcst_viscosity_check
  elseif(MIX_SCHEME==2) then 
    call lapgen_viscosity_check
  elseif(MIX_SCHEME==3) then 
    call lapcgrid_viscosity_check
  endif 

end subroutine lap_viscosity_check
! </SUBROUTINE> NAME="lap_viscosity_check"


!#######################################################################
! <SUBROUTINE NAME="lap_reynolds_check">
!
! <DESCRIPTION>
! To check that the Reynolds number is not too large. 
! </DESCRIPTION>
!
subroutine lap_reynolds_check(Time, Velocity)

  type(ocean_time_type),     intent(in) :: Time
  type(ocean_velocity_type), intent(in) :: Velocity

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lap_friction_mod (lap_reynolds_check): needs initialization')
  endif 

  if(MIX_SCHEME==1) then 
    call lapcst_reynolds_check(Time, Velocity)
  elseif(MIX_SCHEME==2) then 
    call lapgen_reynolds_check(Time, Velocity)
  elseif(MIX_SCHEME==3) then 
    call lapcgrid_reynolds_check(Time, Velocity)
  endif 

end subroutine lap_reynolds_check
! </SUBROUTINE> NAME="lap_reynolds_check"

      
!#######################################################################
! <SUBROUTINE NAME="lap_friction_barotropic">
!
! <DESCRIPTION>
!
! This routine computes the laplacian friction acting on a two-dim
! array.  It uses the two-dimensional vertically averaged viscosity 
! used in the laplacian friction module.  The intent is to apply this
! 2d operator to the vertically integrated horizontal momentum. We 
! ignore the spherical metric terms in this form of the operator, 
! since we are aiming for a fast smoothing operator to be applied
! during each of the many barotropic time steps.  We also apply 
! just the isotropic portion of the more general anisotropic 
! laplacian operator.  
!
! This scheme is only meant for the B-grid version of MOM.  It 
! has not been generalized to the C-grid, since the C-grid has 
! less noise in the barotropic gravity waves anyhow, so it is 
! unlikely there will need to be extra friction applied to the 
! C-grid barotropic equations.
!
! </DESCRIPTION>
!
subroutine lap_friction_barotropic(lap_ceu_back, lap_cnu_back, array, friction)

  real, dimension(isd:,jsd:),   intent(in)    :: lap_ceu_back
  real, dimension(isd:,jsd:),   intent(in)    :: lap_cnu_back 
  real, dimension(isd:,jsd:,:), intent(in)    :: array
  real, dimension(isd:,jsd:,:), intent(inout) :: friction

  integer :: i, j, n
  real    :: tmp(isd:ied,jsd:jed)

  do n=1,2
     tmp(:,:) =  BDX_EU( (lap_ceu_back(:,:)+lap_visc_ceu(:,:))*FDX_U(array(:,:,n)) ) &
                +BDY_NU( (lap_cnu_back(:,:)+lap_visc_cnu(:,:))*FDY_U(array(:,:,n)) )  
     do j=jsc,jec
        do i=isc,iec
           friction(i,j,n) = tmp(i,j)*Grd%umask(i,j,1)
        enddo
     enddo
  enddo

  call mpp_update_domains (friction(:,:,:), Dom%domain2d)


end subroutine lap_friction_barotropic
! </SUBROUTINE> NAME="lap_friction_barotropic"


!#######################################################################
! <SUBROUTINE NAME="ocean_lap_friction_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocean_lap_friction_restart(time_stamp)
  character(len=*),           intent(in), optional :: time_stamp

  if(.not. use_this_module) return

  if (.not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_lap_friction (ocean_lap_friction_end): needs initialization')
  endif 

  call save_restart(Lap_restart, time_stamp)

end subroutine ocean_lap_friction_restart
! </SUBROUTINE> NAME="ocean_lap_friction_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_lap_friction_end">
!
! <DESCRIPTION>
! Write to restart of the vertically averaged viscosity. 
! </DESCRIPTION>
!
subroutine ocean_lap_friction_end(Time)

  type(ocean_time_type), intent(in) :: Time
  
  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return

  if (.not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_lap_friction (ocean_lap_friction_end): needs initialization')
  endif 

  if(.not. write_a_restart) then
    write(stdoutunit,'(/a)') &
    '==>Warning from ocean_lap_friction (ocean_lap_friction_end): NO restart written.'
    call mpp_error(WARNING,&
    '==>Warning from ocean_lap_friction_mod (ocean_lap_friction_end): NO restart written.')
    return
  endif 

  call ocean_lap_friction_restart

  write(stdoutunit,*)' ' 
  write(stdoutunit,*) 'From ocean_lap_friction_end: ending chksum'
  call write_timestamp(Time%model_time)
  call write_chksum_2d('ending lap_viscosity', lap_viscosity(COMP)*Grd%umask(COMP,1))


end subroutine ocean_lap_friction_end
! </SUBROUTINE> NAME="ocean_lap_friction_end"


end module ocean_lap_friction_mod
      

! ----------------------------------------------------------------
!                   GNU General Public License                        
! This file is a part of MOM.                                                                 
!                                                                      
! MOM is free software; you can redistribute it and/or modify it and  
! are expected to follow the terms of the GNU General Public License  
! as published by the Free Software Foundation; either version 2 of   
! the License, or (at your option) any later version.                 
!                                                                      
! MOM is distributed in the hope that it will be useful, but WITHOUT    
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
! License for more details.                                           
!                                                                      
! For the full text of the GNU General Public License,                
! write to: Free Software Foundation, Inc.,                           
!           675 Mass Ave, Cambridge, MA 02139, USA.                   
! or see:   http://www.gnu.org/licenses/gpl.html                      
!-----------------------------------------------------------------------
!
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> John P. Dunne
!</REVIEWER>
!
!<OVERVIEW>
! Surface fCO2 calculation
!</OVERVIEW>
!
!<DESCRIPTION>
! Calculate the fugacity of CO2 at the surface in thermodynamic
! equilibrium with the current alkalinity (Alk) and total dissolved
! inorganic carbon (DIC) at a particular temperature and salinity
! using an initial guess for the total hydrogen
! ion concentration (htotal)
!</DESCRIPTION>
!

module ocmip2_co2calc_mod

implicit none

private

public  :: ocmip2_co2calc
public  :: ocmip2_co2_alpha

character(len=128) :: version = '$Id: ocmip2_co2calc.F90,v 20.0 2013/12/14 00:09:44 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

contains


!#######################################################################
! <SUBROUTINE NAME="ocmip2_co2_alpha">
!
! <DESCRIPTION>
!       Calculate CO2 solubility, alpha, from
! temperature (t) and salinity (s).
!
! INPUT
!
!       isd        = first i-limit of the arrays with halo
!       ied        = last i-limit of the arrays with halo
!       jsd        = first j-limit of the arrays with halo
!       jed        = last j-limit of the arrays with halo
!       isc        = first i-limit of the arrays for computation
!       iec        = last i-limit of the arrays for computation
!       jsc        = first j-limit of the arrays for computation
!       jec        = last j-limit of the arrays for computation
!
!       t          = temperature (degrees C)
!
!       s          = salinity (PSU)
!
!       mask       = land mask array (0.0 = land)
!
! OUTPUT
!       alpha      = Solubility of CO2 for air? (mol/kg/atm unless scaled)
!
! IMPORTANT: Some words about units - (JCO, 4/4/1999)
!
!     - Models may carry tracers in mol/m^3 (on a per volume basis)
!
!     - Conversely, this routine, which was written by observationalists
!       (C. Sabine and R. Key), passes input arguments in umol/kg  
!       (i.e., on a per mass basis)
!
!     - Thus, if the input or output units need to be changed from/to mol/m^3
!       then set scale to an appropriate value. For example, if the model
!       uses mol/m^3, then scale should be set to something like 1.0/1024.5
!       to convert from mol/m^3 to mol/kg.
!
! </DESCRIPTION>
subroutine ocmip2_co2_alpha(isd, jsd, isc, iec, jsc, jec, t, s, mask, alpha, scale)

integer, intent(in)                     :: isd
integer, intent(in)                     :: jsd
integer, intent(in)                     :: isc
integer, intent(in)                     :: iec
integer, intent(in)                     :: jsc
integer, intent(in)                     :: jec
real, dimension(isd:,jsd:), intent(in)  :: t
real, dimension(isd:,jsd:), intent(in)  :: s
real, dimension(isd:,jsd:), intent(in)  :: mask
real, dimension(isc:,jsc:), intent(out) :: alpha
real, intent(in), optional              :: scale

integer :: i, j
real    :: log100
real    :: tk
real    :: tk100
real    :: tk1002
real    :: logtk
real    :: ff
real    :: scale_factor

! set the scale factor for unit conversion
if (present(scale)) then
  scale_factor = scale
else
  scale_factor = 1.0
endif

! Calculate all constants needed to convert between various measured
! carbon species. References for each equation are noted in the code.
! Once calculated, the constants are stored and passed in the common
! block "const". The original version of this code was based on
! the code by Dickson in Version 2 of "Handbook of Methods for the
! Analysis of the Various Parameters of the Carbon Dioxide System
! in Seawater", DOE, 1994 (SOP No. 3, p25-26).
!
! Derive simple terms used more than once
log100 = log(100.0)
do j = jsc, jec
  do i = isc, iec

    if (mask(i,j) .ne. 0.0) then

      tk     = 273.15 + t(i,j)
      tk100  = tk / 100.0
      tk1002 = tk100 * tk100
      logtk  = log(tk)

      ! f = k0(1-pH2O)*correction term for non-ideality
      
      ! Weiss & Price (1980, Mar. Chem., 8, 347-359; Eq 13 with table 6
      ! values)
      ff = exp(-162.8301 + 218.2968 / tk100  +                                  &
               90.9241 * (logtk - log100) - 1.47696 * tk1002 +                  &
               s(i,j) * (0.025695 - 0.025225 * tk100 + 0.0049867 * tk1002))

      !      Should we be using K0 or ff for the solubility here?
      !         convert to output units
      alpha(i,j) = ff / scale_factor
    else
      alpha(i,j) = 0.0
    endif
  enddo
enddo

return

end subroutine  ocmip2_co2_alpha
! </SUBROUTINE> NAME="ocmip2_co2_alpha"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_co2calc">
!
! <DESCRIPTION>
!       Calculate co2* from total alkalinity and total CO2 at
! temperature (t) and salinity (s).
! It is assumed that init_ocmip2_co2calc has already been called with
! the T and S to calculate the various coefficients.
!
! INPUT
!
!       isd        = first i-limit of the arrays with halo
!       ied        = last i-limit of the arrays with halo
!       jsd        = first j-limit of the arrays with halo
!       jed        = last j-limit of the arrays with halo
!       isc        = first i-limit of the arrays for computation
!       iec        = last i-limit of the arrays for computation
!       jsc        = first j-limit of the arrays for computation
!       jec        = last j-limit of the arrays for computation
!
!       mask       = land mask array (0.0 = land)
!
!       t          = temperature (degrees C)
!
!       s          = salinity (PSU)
!
!       dic_in     = total inorganic carbon (mol/kg unless scaled) 
!                    where 1 T = 1 metric ton = 1000 kg
!
!       ta_in      = total alkalinity (eq/kg unless scaled) 
!
!       pt_in      = inorganic phosphate (mol/kg unless scaled) 
!
!       sit_in     = inorganic silicate (mol/kg unless scaled) 
!
!       htotallo   = factor to set lower limit of htotal range
!
!       htotalhi   = factor to set upper limit of htotal range
!
!       htotal     = H+ concentraion
!
! OUTPUT
!       co2star    = CO2*water (kg/kg unless scaled)
!       alpha      = Solubility of CO2 for air? (kg/kg/atm unless scaled)
!       pco2surf   = oceanic pCO2 (ppmv)
!
!       k1         = activity factors for carbonate species
!
!       k2              (see below)
!
!       invtk      = 1/(t+273.15)
!
! IMPORTANT: Some words about units - (JCO, 4/4/1999)
!
!     - Models may carry tracers in mol/m^3 (on a per volume basis)
!
!     - Conversely, this routine, which was written by observationalists
!       (C. Sabine and R. Key), passes input arguments in umol/kg  
!       (i.e., on a per mass basis)
!
!     - Thus, if the input or output units need to be changed from/to mol/m^3
!       then set scale to an appropriate value. For example, if the model
!       uses mol/m^3, then scale should be set to something like 1.0/1024.5
!       to convert from mol/m^3 to mol/kg.
!
! </DESCRIPTION>
subroutine ocmip2_co2calc(isd, jsd, isc, iec, jsc, jec, mask, t, s,   &
     dic_in, ta_in, pt_in, sit_in, htotallo, htotalhi, htotal,                  &
     co2star, co3_ion, alpha, pCO2surf, k1_out, k2_out, invtk_out, scale)

real, parameter :: permeg = 1.e-6
real, parameter :: xacc = 1.0e-10

integer, intent(in)                                     :: isd
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
real, dimension(isd:,jsd:), intent(in)                  :: mask
real, dimension(isd:,jsd:), intent(in)                  :: t
real, dimension(isd:,jsd:), intent(in)                  :: s
real, dimension(isd:,jsd:), intent(in)                  :: dic_in
real, dimension(isd:,jsd:), intent(in)                  :: ta_in
real, dimension(isd:,jsd:), intent(in)                  :: pt_in
real, dimension(isd:,jsd:), intent(in)                  :: sit_in
real, dimension(isc:,jsc:), intent(in)                  :: htotallo
real, dimension(isc:,jsc:), intent(in)                  :: htotalhi
real, dimension(isc:,jsc:), intent(inout)               :: htotal
real, dimension(isc:,jsc:), intent(out), optional       :: co2star
real, dimension(isc:,jsc:), intent(out), optional       :: co3_ion
real, dimension(isc:,jsc:), intent(out), optional       :: alpha
real, dimension(isc:,jsc:), intent(out), optional       :: pCO2surf
real, dimension(isc:,jsc:), intent(out), optional       :: invtk_out
real, dimension(isc:,jsc:), intent(out), optional       :: k1_out
real, dimension(isc:,jsc:), intent(out), optional       :: k2_out
real, intent(in), optional                              :: scale

integer :: i
integer :: j
real    :: log100
real    :: pt
real    :: sit
real    :: ta
real    :: dic
real    :: tk
real    :: invtk
real    :: tk100
real    :: tk1002
real    :: logtk
real    :: is
real    :: is2
real    :: sqrtis
real    :: s2
real    :: sqrts
real    :: s15
real    :: scl
real    :: logf_of_s
real    :: ff
!real    :: k0
real    :: k1
real    :: k2
real    :: kb
real    :: k1p
real    :: k2p
real    :: k3p
real    :: ksi
real    :: kw
real    :: ks
real    :: kf
real    :: bt
real    :: st
real    :: ft
real    :: htotal2
real    :: co2star_internal
real    :: scale_factor

!       set the scale factor for unit conversion
if (present(scale)) then
  scale_factor = scale
else
  scale_factor = 1.0
endif

! Calculate all constants needed to convert between various measured
! carbon species. References for each equation are noted in the code.
! Once calculated, the constants are stored and passed in the common
! block "const". The original version of this code was based on
! the code by Dickson in Version 2 of "Handbook of Methods for the
! Analysis of the Various Parameters of the Carbon Dioxide System
! in Seawater", DOE, 1994 (SOP No. 3, p25-26).
!
! Derive simple terms used more than once
log100 = log(100.0)
do j = jsc, jec
  do i = isc, iec

    if (mask(i,j) .ne. 0.0) then

      tk        = 273.15 + t(i,j)
      tk100     = tk / 100.0
      tk1002    = tk100 * tk100
      invtk     = 1.0 / tk
      logtk    = log(tk)
      is        = 19.924 * s(i,j) / (1000.0 - 1.005 * s(i,j))
      is2       = is * is
      sqrtis    = sqrt(is)
      s2        = s(i,j) * s(i,j)
      sqrts     = sqrt(s(i,j))
      s15       = sqrts ** 3
      scl       = s(i,j) / 1.80655
      logf_of_s = log(1.0 - 0.001005 * s(i,j))

      ! k0 from Weiss 1974

      !k0 = exp(93.4517/tk100 - 60.2409 + 23.3585 * log(tk100) +                 &
                !s(i,j) * (0.023517 - 0.023656 * tk100 + 0.0047036 * tk1002))


      ! k1 = [H][HCO3]/[H2CO3]
      ! k2 = [H][CO3]/[HCO3]

      ! Millero p.664 (1995) using Mehrbach et al. data on seawater scale 
      k1 = 10.0 ** (-(3670.7 * invtk - 62.008 + 9.7944 * logtk -                &
                    0.0118 * s(i,j) + 0.000116 * s2))

      k2 = 10.0 ** (-(1394.7 * invtk + 4.777 - 0.0184 * s(i,j) + 0.000118 * s2))

      ! kb = [H][BO2]/[HBO2]

      ! Millero p.669 (1995) using data from Dickson (1990)
      kb = exp((-8966.90 - 2890.53 * sqrts - 77.942 * s(i,j) +                  &
                1.728 * s15 - 0.0996 * s2) * invtk +                            &
               (148.0248 + 137.1942 * sqrts + 1.62142 * s(i,j)) +               &
               (-24.4344 - 25.085 * sqrts - 0.2474 * s(i,j)) * logtk +          &
               0.053105 * sqrts * tk)

      ! k1p = [H][H2PO4]/[H3PO4]

      ! DOE(1994) eq 7.2.20 with footnote using data from Millero (1974)
      k1p = exp(-4576.752 * invtk + 115.525 - 18.453 * logtk +                  &
                (-106.736 * invtk + 0.69171) * sqrts +                          &
                (-0.65643 * invtk - 0.01844) * s(i,j))

      ! k2p = [H][HPO4]/[H2PO4]

      ! DOE(1994) eq 7.2.23 with footnote using data from Millero (1974))
      k2p = exp(-8814.715 * invtk + 172.0883 - 27.927 * logtk +                 &
                (-160.340 * invtk + 1.3566) * sqrts +                           &
                (0.37335 * invtk - 0.05778) * s(i,j))

      ! k3p = [H][PO4]/[HPO4]

      ! DOE(1994) eq 7.2.26 with footnote using data from Millero (1974)
      k3p = exp(-3070.75 * invtk - 18.141 +                                     &
                (17.27039 * invtk + 2.81197) * sqrts +                          &
                (-44.99486 * invtk - 0.09984) * s(i,j))

      ! ksi = [H][SiO(OH)3]/[Si(OH)4]

      ! Millero p.671 (1995) using data from Yao and Millero (1995)
      ksi = exp(-8904.2 * invtk + 117.385 - 19.334 * logtk +                    &
                (-458.79 * invtk + 3.5913) * sqrtis +                           &
                (188.74 * invtk - 1.5998) * is +                                &
                (-12.1652 * invtk + 0.07871) * is2 + logf_of_s)

      ! kw = [H][OH]
      
      ! Millero p.670 (1995) using composite data
      kw = exp(-13847.26 * invtk + 148.9652 - 23.6521 * logtk +                 &
               (118.67 * invtk - 5.977 + 1.0495 * logtk) * sqrts - 0.01615 * s(i,j))

      ! ks = [H][SO4]/[HSO4]

      ! Dickson (1990, J. chem. Thermodynamics 22, 113)
      ks = exp(-4276.1 * invtk + 141.328 - 23.093 * logtk +                     &
               (-13856.0 * invtk + 324.57 - 47.986 * logtk) * sqrtis +          &
               (35474.0 * invtk - 771.54 + 114.723 * logtk) * is -              &
               2698.0 * invtk * sqrtis ** 3 + 1776.0 * invtk * is2 + logf_of_s)

      ! kf = [H][F]/[HF]
      
      ! Dickson and Riley (1979) -- change pH scale to total
      kf = exp(1590.2 * invtk - 12.641 + 1.525 * sqrtis + logf_of_s +           &
               log(1.0 + (0.1400 / 96.062) * scl / ks))

      ! Calculate concentrations for borate, sulfate, and fluoride
      
      ! Uppstrom (1974)
      bt = 0.000232 / 10.811 * scl

      ! Morris & Riley (1966)
      st = 0.14 / 96.062 * scl

      ! Riley (1965)
      ft = 0.000067 / 18.9984 * scl

      ! set some stuff to pass back, if requested
      if (present(k1_out)) then
        k1_out(i,j) = k1
      endif

      if (present(k2_out)) then
        k2_out(i,j) = k2
      endif

      if (present(invtk_out)) then
        invtk_out(i,j)  = invtk
      endif

      ! Possibly convert input in mol/m^3 -> mol/kg 
      sit = sit_in(i,j) * scale_factor
      ta  = ta_in(i,j)  * scale_factor
      dic = dic_in(i,j) * scale_factor
      pt  = pt_in(i,j)  * scale_factor

!
!***********************************************************************
!
! Calculate [H+] total when DIC and TA are known at T, S and 1 atm.
! The solution converges to err of xacc. The solution must be within
! the range x1 to x2.
!
! If DIC and TA are known then either a root finding or iterative method
! must be used to calculate htotal. In this case we use the
! Newton-Raphson "safe" method taken from "Numerical Recipes"
! (function "rtsafe.f" with error trapping removed).
!
! As currently set, this procedure iterates about 12 times. The x1
! and x2 values set below will accomodate ANY oceanographic values.
! If an initial guess of the pH is known, then the number of
! iterations can be reduced to about 5 by narrowing the gap between
! x1 and x2. It is recommended that the first few time steps be run
! with x1 and x2 set as below. After that, set x1 and x2 to the
! previous value of the pH +/- ~0.5. The current setting of xacc will
! result in co2star accurate to 3 significant figures (xx.y). Making
! xacc bigger will result in faster convergence also, but this is not
! recommended (xacc of 10**-9 drops precision to 2 significant
! figures).
!

      htotal(i,j) = drtsafe(htotalhi(i,j)*htotal(i,j),  &
           htotallo(i,j)*htotal(i,j),                   &
           dic, ta, pt, sit, k1, k2, k1p, k2p, k3p,     &
           bt, ft, st, kb, kw, kf, ks, ksi, xacc)

      ! Calculate [CO2*] as defined in DOE Methods Handbook 1994 Ver.2, 
      ! ORNL/CDIAC-74, Dickson and Goyet, eds. (Ch 2 p 10, Eq A.49)
      ! Convert units of output arguments
      !      Note: co2star is calculated in
      !            mol/kg within this routine 
      !
      htotal2 = htotal(i,j) * htotal(i,j)
      co2star_internal = dic * htotal2 / (htotal2 + k1 * (htotal(i,j) + k2)) / scale_factor
      if (present(co2star)) then
        co2star(i,j) = co2star_internal
      endif
      if (present(co3_ion)) then
        co3_ion(i,j) = co2star_internal * k1 * k2 / htotal2
      endif
      !ph = -log10(htotal(i,j))

      ! f = k0(1-pH2O)*correction term for non-ideality

      ! Weiss & Price (1980, Mar. Chem., 8, 347-359; Eq 13 with table 6
      !                values)
      if (present(alpha) .or. present(pco2surf)) then

        ff = exp(-162.8301 + 218.2968 / tk100  +                                        &
                 90.9241 * (logtk - log100) - 1.47696 * tk1002 +                        &
                 s(i,j) * (0.025695 - 0.025225 * tk100 + 0.0049867 * tk1002))

        ! Add two output arguments for storing pCO2surf
        ! Should we be using K0 or ff for the solubility here?
        ! Convert pCO2surf from atm to uatm
        ! possibly convert output units
        if (present(alpha)) then
          alpha(i,j) = ff / scale_factor
        endif
        if (present(pco2surf)) then
          pCO2surf(i,j) = co2star_internal / (ff / scale_factor) / permeg
        endif

      endif

    else

      if (present(co2star)) then
        co2star(i,j) = 0.0
      endif
      if (present(k1_out)) then
        k1_out(i,j) = 0.0
      endif
      if (present(k2_out)) then
        k2_out(i,j) =0.0
      endif
      if (present(invtk_out)) then
        invtk_out(i,j)  = 0.0
      endif
      if (present(alpha)) then
        alpha(i,j) = 0.0
      endif
      if (present(pco2surf)) then
        pCO2surf(i,j) = 0.0
      endif

    endif

  enddo
enddo

return

end subroutine  ocmip2_co2calc
! </SUBROUTINE> NAME="ocmip2_co2calc"


!#######################################################################
! <FUNCTION NAME="drtsafe">
!
! <DESCRIPTION>
!       File taken from Numerical Recipes. Modified  R. M. Key 4/94
! </DESCRIPTION>

function drtsafe(x1, x2, dic, ta, pt, sit, k1, k2, k1p, k2p, k3p,       &
                 bt, ft, st, kb, kw, kf, ks, ksi, xacc)

real                    :: drtsafe
real, intent(in)        :: x1
real, intent(in)        :: x2
real, intent(in)        :: dic
real, intent(in)        :: ta
real, intent(in)        :: pt
real, intent(in)        :: sit
real, intent(in)        :: k1
real, intent(in)        :: k2
real, intent(in)        :: k1p
real, intent(in)        :: k2p
real, intent(in)        :: k3p
real, intent(in)        :: bt
real, intent(in)        :: ft
real, intent(in)        :: st
real, intent(in)        :: kb
real, intent(in)        :: kw
real, intent(in)        :: kf
real, intent(in)        :: ks
real, intent(in)        :: ksi
real, intent(in)        :: xacc

integer, parameter      :: maxit = 100

integer :: j
real    :: fl
real    :: df
real    :: fh
real    :: swap
real    :: xl
real    :: xh
real    :: dxold
real    :: dx
real    :: f
real    :: temp

call ta_iter_1(x1, fl, df, dic, ta, pt, sit, k1, k2,    &
     k1p, k2p, k3p, bt, ft, st, kb, kw, kf, ks, ksi)
call ta_iter_1(x2, fh, df, dic, ta, pt, sit, k1, k2,    &
     k1p, k2p, k3p, bt, ft, st, kb, kw, kf, ks, ksi)
if(fl .lt. 0.0) then
  xl=x1
  xh=x2
else
  xh=x1
  xl=x2
  swap=fl
  fl=fh
  fh=swap
end if
drtsafe=0.5*(x1+x2)
dxold=abs(x2-x1)
dx=dxold
call ta_iter_1(drtsafe, f, df, dic, ta, pt, sit, k1, k2,        &
     k1p, k2p, k3p, bt, ft, st, kb, kw, kf, ks, ksi)
do j=1,maxit
  if (((drtsafe-xh)*df-f)*((drtsafe-xl)*df-f) .ge. 0.0 .or.     &
      abs(2.0*f) .gt. abs(dxold*df)) then
    dxold=dx
    dx=0.5*(xh-xl)
    drtsafe=xl+dx
    if (xl .eq. drtsafe) then
      return
    endif
  else
    dxold=dx
    dx=f/df
    temp=drtsafe
    drtsafe=drtsafe-dx
    if (temp .eq. drtsafe) then
      return
    endif
  end if
  if (abs(dx) .lt. xacc) then
    return
  endif
  call ta_iter_1(drtsafe, f, df, dic, ta, pt, sit, k1, k2,      &
       k1p, k2p, k3p, bt, ft, st, kb, kw, kf, ks, ksi)
  if(f .lt. 0.0) then
    xl=drtsafe
    fl=f
  else
    xh=drtsafe
    fh=f
  end if
enddo

return

end function drtsafe
! </FUNCTION> NAME="drtsafe"


!#######################################################################
! <SUBROUTINE NAME="ta_iter_1">
!
! <DESCRIPTION>
! This routine expresses TA as a function of DIC, htotal and constants.
! It also calculates the derivative of this function with respect to 
! htotal. It is used in the iterative solution for htotal. In the call
! "x" is the input value for htotal, "fn" is the calculated value for TA
! and "df" is the value for dTA/dhtotal
! </DESCRIPTION>

subroutine ta_iter_1(x, fn, df, dic, ta, pt, sit, k1, k2,       &
     k1p, k2p, k3p, bt, ft, st, kb, kw, kf, ks, ksi)

real, intent(in)        :: x
real, intent(out)       :: fn
real, intent(out)       :: df
real, intent(in)        :: dic
real, intent(in)        :: ta
real, intent(in)        :: pt
real, intent(in)        :: sit
real, intent(in)        :: k1
real, intent(in)        :: k2
real, intent(in)        :: k1p
real, intent(in)        :: k2p
real, intent(in)        :: k3p
real, intent(in)        :: bt
real, intent(in)        :: ft
real, intent(in)        :: st
real, intent(in)        :: kb
real, intent(in)        :: kw
real, intent(in)        :: kf
real, intent(in)        :: ks
real, intent(in)        :: ksi

real    :: x2
real    :: x3
real    :: k12
real    :: k12p
real    :: k123p
real    :: c
real    :: a
real    :: a2
real    :: da
real    :: b
real    :: b2
real    :: db

x2 = x*x
x3 = x2*x
k12 = k1*k2
k12p = k1p*k2p
k123p = k12p*k3p
c = 1.0 + st/ks
a = x3 + k1p*x2 + k12p*x + k123p
a2 = a*a
da = 3.0*x2 + 2.0*k1p*x + k12p
b = x2 + k1*x + k12
b2 = b*b
db = 2.0*x + k1

!     fn = hco3+co3+borate+oh+hpo4+2*po4+silicate+hfree+hso4+hf+h3po4-ta
fn = k1*x*dic/b + 2.0*dic*k12/b + bt/(1.0 + x/kb) + kw/x +              &
     pt*k12p*x/a + 2.0*pt*k123p/a + sit/(1.0 + x/ksi) -                 &
     x/c - st/ (1.0 + ks/x/c) - ft/(1.0 + kf/x) -                       &
     pt*x3/a - ta

!     df = dfn/dx
df = ((k1*dic*b) - k1*x*dic*db)/b2 - 2.0*dic*k12*db/b2 -                &
     bt/kb/(1.0+x/kb)**2 - kw/x2 + (pt*k12p*(a - x*da))/a2 -            &
     2.0*pt*k123p*da/a2 - sit/ksi/(1.0+x/ksi)**2 - 1.0/c +              &
     st*(1.0 + ks/x/c)**(-2)*(ks/c/x2) + ft*(1.0 + kf/x)**(-2)*kf/x2 -  &
     pt*x2*(3.0*a-x*da)/a2

return

end subroutine  ta_iter_1
! </SUBROUTINE> NAME="ta_iter_1"

end module  ocmip2_co2calc_mod

module ocean_coriolis_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> A. Rosati
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Compute the Coriolis acceleration for either Bgrid or Cgrid. 
!</OVERVIEW>

!<DESCRIPTION>
! This module computes Coriolis acceleration on either a Bgrid or Cgrid. 
! Coriolis and beta parameters are located at B-grid
! velocity point, which equals the C-grid vorticity point. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! R.C. Pacanowski and S.M. Griffies
! The MOM3 Manual (1999)
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, M.J. Harrison, R.C. Pacanowski, and A. Rosati 
! A Technical Guide to MOM4 (2003)
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies: Elements of MOM (2012)
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_coriolis_nml">
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging.  
!  </DATA> 
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to add contributions from Coriolis force.   
!  </DATA> 
!
!  <DATA NAME="acor" TYPE="real">
!  acor=0.0 means explicit Coriolis force.  0.5 < = acor < 1.0 means semi-implicit,
!  and acor = 1.0 is implicit.  This option is only relevant for the Bgrid, since
!  the C-grid compute Coriolis using 3rd order Adams-Bashforth scheme. For the Bgrid, the 
!  semi-implicit method removes dtuv time step constraint associated with inertial oscillations,
!  but it leads to Coriolis force affecting energy balances.  
!  If use two-level tendency discretization, then acor=0 is NOT allowed since the 
!  model will be linearly unstable with growth rate going as f*(delta time). 
!  </DATA> 
!
!</NAMELIST>

use constants_mod,    only: radius, radian, pi, epsln, omega
use diag_manager_mod, only: register_static_field, register_diag_field
use fms_mod,          only: write_version_number, mpp_error, FATAL, WARNING
use fms_mod,          only: check_nml_error, close_file, open_namelist_file
use mpp_mod,          only: input_nml_file, mpp_max, stdout, stdlog

use ocean_domains_mod,    only: get_local_indices
use ocean_parameters_mod, only: TWO_LEVEL
use ocean_parameters_mod, only: missing_value, onefourth
use ocean_parameters_mod, only: MOM_BGRID, MOM_CGRID 
use ocean_types_mod,      only: ocean_grid_type, ocean_domain_type
use ocean_types_mod,      only: ocean_time_type, ocean_time_steps_type
use ocean_types_mod,      only: ocean_velocity_type, ocean_adv_vel_type
use ocean_types_mod,      only: ocean_options_type, ocean_thickness_type
use ocean_util_mod,       only: write_timestamp, diagnose_2d_u, diagnose_3d_u, diagnose_3d_en, write_chksum_3d
use ocean_workspace_mod,  only: wrk1, wrk2, wrk1_v  

implicit none

private

! for diagnostics 
logical :: used
integer :: id_coriolis  =-1
integer :: id_beta      =-1
integer :: id_beta_eff  =-1
integer :: id_cor_u     =-1
integer :: id_cor_v     =-1
integer :: id_hrho_cor_u=-1
integer :: id_hrho_cor_v=-1
integer :: id_ucori_impl=-1
integer :: id_vcori_impl=-1

#include <ocean_memory.h>

public ocean_coriolis_init
public coriolis_force_bgrid
public coriolis_force_bgrid_implicit
public coriolis_force_cgrid

type(ocean_grid_type), pointer :: Grd =>NULL()

character(len=128) :: version = &
     '$Id: ocean_coriolis.F90,v 20.0 2013/12/14 00:10:38 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

! for Bgrid or Cgrid
integer :: horz_grid

real    :: dtime 
logical :: module_is_initialized = .FALSE.

logical :: debug_this_module = .FALSE.
logical :: use_this_module   = .true.
real    :: acor              = 0.5

namelist /ocean_coriolis_nml/  debug_this_module, use_this_module, acor 

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_coriolis_init">
!
! <DESCRIPTION>
! Initialize the Coriolis module.
! </DESCRIPTION>
!
subroutine ocean_coriolis_init(Grid, Domain, Time, Time_steps, Ocean_options, hor_grid, debug)

  type(ocean_grid_type),       intent(inout),target :: Grid
  type(ocean_domain_type),     intent(in),   target :: Domain  
  type(ocean_time_type),       intent(in)           :: Time
  type(ocean_time_steps_type), intent(inout)        :: Time_steps
  type(ocean_options_type),    intent(inout)        :: Ocean_options
  integer,                     intent(in)           :: hor_grid
  logical,                     intent(in), optional :: debug

  real    :: deg2m, sin1, cos1, y, fmax
  real    :: max_dt_for_inertial_oscillation
  integer :: i, j
  integer :: ioun, io_status, ierr

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_coriolis_mod (ocean_coriolis_init): module already initialized.')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_coriolis_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_coriolis_nml')
#else
  ioun = open_namelist_file()
  read  (ioun, ocean_coriolis_nml,iostat=io_status)
  ierr = check_nml_error(io_status, 'ocean_coriolis_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit, ocean_coriolis_nml)  
  write (stdlogunit, ocean_coriolis_nml)

  if (PRESENT(debug) .and. .not. debug_this_module) then 
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') &
    '==>Note: running ocean_coriolis_mod with debug_this_module=.true.'  
  endif 
  if(.not. use_this_module) then 
    write(stdoutunit,'(a)') &
    '==>Warning: NOT adding Coriolis to acceleration. Simulation has no rotational effects.'  
  endif 

  Grd=> Grid
  dtime     = Time_steps%dtime_u
  horz_grid = hor_grid 

  ! consistency checks for acor parameter 
  if(horz_grid == MOM_CGRID) then 

     acor = 0.0
     write(stdoutunit,'(a)') &
     '==>Note: Cgrid MOM computes Coriolis force using 3rd order Adams-Bashforth, just as for momentum advection.'
     write(stdoutunit,'(a)') &
     '==>Note: Cgrid MOM sets acor=0 since cannot compute C-grid Coriolis force implicitly in time.'
     Ocean_options%coriolis = 'Computed Coriolis force on Cgrid using 3rd order Adams-Bashforth time stepping.'

  else ! Bgrid 

     if(acor == 0.0) then 
        write(stdoutunit,'(a)')'==>Note: Coriolis force on Bgrid computed explicitly in time.'
        Ocean_options%coriolis = 'Computed Coriolis force on Bgrid using explicit time stepping.'
     elseif(acor == 1.0) then 
        write(stdoutunit,'(a)')'==>Note: Coriolis on Bgrid computed implicitly so to remove inertial time step constraint.'
        Ocean_options%coriolis = 'Computed Coriolis force on Bgrid using implicit time stepping.'
     elseif(acor >= 0.5 .and. acor < 1.0) then 
        write(stdoutunit,'(a)')'==>Note: Coriolis on Bgrid computed semi-implicitly to remove inertial time step constraint.'
        Ocean_options%coriolis = 'Computed Coriolis force on Bgrid using semi-implicit time stepping.'
     elseif(acor > 0.0 .and. acor < 0.5) then 
        acor = 0.5 
        write(stdoutunit,'(a)')'==>Warning: Coriolis "acor" parameter spuriously set outside relevant range. Resetting acor to MOM default 0.5.'
        Ocean_options%coriolis = 'Computed Coriolis force on Bgrid using semi-implicit time stepping to remove inertial time step constraint.'
     elseif(acor < 0.0 .or. acor > 1.0) then 
        acor = 0.5 
        write(stdoutunit,'(a)')'==>Warning: Coriolis "acor" parameter spuriously set outside relevant range. Resetting acor to MOM default 0.5.'
        Ocean_options%coriolis = 'Computed Coriolis force on Bgrid using semi-implicit time stepping.'
     endif 

     if(Time_steps%tendency==TWO_LEVEL .and. acor==0.0) then  
        call mpp_error(WARNING,&
        '==>ocean_coriolis_mod: acor=0.0 w/ 2-level tendency is unstable. MOM reseting acor to default acor=0.5')
        write(stdoutunit,'(a)')'==>Warning: acor=0.0 w/ 2-level tendency is unstable. MOM reseting acor to default acor=0.5.'
        acor = 0.5 
     endif 

  endif 
  Time_steps%acor = acor


#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
  allocate (Grid%f(isd:ied,jsd:jed))
  allocate (Grid%fstar(isd:ied,jsd:jed))
  allocate (Grid%beta(isd:ied,jsd:jed))
  allocate (Grid%beta_eff(isd:ied,jsd:jed))
#endif

  ! coriolis and beta parameters are located at B-grid
  ! velocity point, which equals the C-grid vorticity point. 
  if (Grid%beta_plane .or. Grid%f_plane) then

    ! beta plane with f     = f0     + beta*y where f0    is at f_plane_latitude
    ! beta plane with fstar = fstar0 + beta*y where fstar is at f_plane_latitude
    ! if f_plane then beta  = 0

    if (Grid%f_plane) then
      Grid%beta(:,:) = 0.0
    else
      Grid%beta(:,:) = 2.0*omega*cos(Grid%f_plane_latitude*pi/180.0)/radius
    endif

    deg2m = radius/radian
    sin1  = sin(Grid%f_plane_latitude*pi/180.0)
    cos1  = cos(Grid%f_plane_latitude*pi/180.0)
    do j=jsd,jed
      do i=isd,ied
        y = (Grid%yu(i,j)-Grid%f_plane_latitude)*deg2m
        Grid%f(i,j)     = 2.0*omega*sin1  + y*Grid%beta(i,j)
        Grid%fstar(i,j) = 2.0*omega*cos1  + y*Grid%beta(i,j)
      enddo
    enddo
    if (Grid%f_plane) then
      write (stdoutunit,'(//,a,f6.2,a//)') &
      ' Note: "f plane" set using f0 at latitude =', Grid%f_plane_latitude,'deg'
    else
      write (stdoutunit,'(//,a,f6.2,a,g14.7//)') &
      ' Note: "beta plane" set using f0 at latitude=',&
       Grid%f_plane_latitude,'deg and beta =',Grid%beta(isc,jsc)
    endif

  else

    Grid%f(:,:)    = 2.0*omega*sin(Grid%phiu(:,:))
    Grid%fstar(:,:)= 2.0*omega*cos(Grid%phiu(:,:))
    Grid%beta(:,:) = 2.0*omega*cos(Grid%phiu(:,:))/radius

  endif

  ! beta_eff centered on u-cell
  ! beta_eff = H*|grad(f/H)| --> |(f/hu)*dht_dx| + |beta-(f/hu)*dht_dy|
  Grid%beta_eff(:,:) = 0.0
  do j=jsc,jec
     do i=isc,iec
        Grid%beta_eff(i,j) = sqrt( (Grid%f(i,j)/(epsln+Grid%hu(i,j))*Grid%dht_dx(i,j))**2 &
                                  +(Grid%beta(i,j)-Grid%f(i,j)/(epsln+Grid%hu(i,j))*Grid%dht_dy(i,j))**2 )
     enddo
  enddo 

  ! check for marginally resolved inertial oscillation.
  ! assume 2*pi timesteps to resolve oscillation
  fmax = 2.0*omega*0.0002 ! ~ 0.01 deg latitude
  do j=jsc,jec
     do i=isc,iec
        if (Grid%kmu(i,j) /= 0) then
           fmax = max(fmax,abs(Grid%f(i,j)))
        endif
     enddo
  enddo
  call mpp_max (fmax)
  max_dt_for_inertial_oscillation = int(1.0/fmax) 
  write (stdoutunit,'(/1x, a,f8.0,a)')&
  ' ==> Note: 2*pi timesteps/(min inertial period) implies a maximum dtuv for time-explicit Coriolis =',&
  max_dt_for_inertial_oscillation,' sec.'

  if(horz_grid == MOM_BGRID) then 
     if (Time_steps%dtuv > max_dt_for_inertial_oscillation .and. acor==0.0) then
       call mpp_error(FATAL,&
       '==> Error in ocean_coriolis_mod: inertial oscillation not resolved. Reduce time step or set 0.5<=acor<=1.0.')
     endif  
  endif

  ! diagnostic manager registers and sends for static fields 

  id_coriolis  = register_static_field ('ocean_model', 'f_coriolis', Grd%vel_axes_uv(1:2), &
                                        'Coriolis frequency on U-cell', '1/s',             &
                                         missing_value=missing_value, range=(/-10.0,10.0/))
  call diagnose_2d_u(Time, Grd, id_coriolis, Grid%f(:,:))

  id_beta  = register_static_field ('ocean_model', 'beta', Grd%vel_axes_uv(1:2), &
                                    'planetary beta', '1/(m*s)',&
                                    missing_value=missing_value, range=(/-10.0,10.0/))
  call diagnose_2d_u(Time, Grd, id_beta, Grd%beta(:,:))

  id_beta_eff  = register_static_field ('ocean_model', 'beta_eff', Grd%vel_axes_uv(1:2), &
                                        'effective beta', '1/(m*s)',&
                                        missing_value=missing_value, range=(/-10.0,10.0/))
  call diagnose_2d_u(Time, Grd, id_beta_eff, Grd%beta_eff(:,:))

  ! diagnostic manager registers for dynamic fields 
  id_cor_u =  register_diag_field ('ocean_model', 'cor_u', Grd%vel_axes_u(1:3), Time%model_time, &
     'explicit coriolis accel in i-direct', 'm/s^2', missing_value=missing_value, range=(/-1e9,1e9/))
  id_cor_v =  register_diag_field ('ocean_model', 'cor_v', Grd%vel_axes_v(1:3), Time%model_time, &
     'explicit coriolis accel in j-direct', 'm/s^2', missing_value=missing_value, range=(/-1e9,1e9/))

  id_hrho_cor_u =  register_diag_field ('ocean_model', 'hrho_cor_u', Grd%vel_axes_u(1:3), Time%model_time,&
                  'rho*dz weighted explicit coriolis accel in i-direct', 'N/m^2',                         &
                   missing_value=missing_value, range=(/-1e9,1e9/))
  id_hrho_cor_v =  register_diag_field ('ocean_model', 'hrho_cor_v', Grd%vel_axes_v(1:3), Time%model_time,&
                  'rho*dz weighted explicit coriolis accel in j-direct', 'N/m^2',                         &
                   missing_value=missing_value, range=(/-1e9,1e9/))

  id_ucori_impl = register_diag_field ('ocean_model', 'ucori_impl', Grd%vel_axes_u(1:3), Time%model_time, &
     'implicit Coriolis force in i-direction', 'N/m^2', missing_value=missing_value, range=(/-1e9,1e9/))
  id_vcori_impl = register_diag_field ('ocean_model', 'vcori_impl', Grd%vel_axes_v(1:3), Time%model_time, &
     'implicit Coriolis force in j-direction', 'N/m^2', missing_value=missing_value, range=(/-1e9,1e9/))


end subroutine ocean_coriolis_init
! </SUBROUTINE> NAME="ocean_coriolis_init"


!#######################################################################
! <SUBROUTINE NAME="coriolis_force_bgrid">
!
! <DESCRIPTION>
! Compute thickness and density weighted acceleration due to Coriolis
! force on a B-grid. 
! </DESCRIPTION>
!
subroutine coriolis_force_bgrid(Time, Thickness, Velocity, energy_analysis_step)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(in)    :: Thickness
  type(ocean_velocity_type),  intent(inout) :: Velocity
  logical,                    intent(in)    :: energy_analysis_step

  integer :: itime, tau, taum1, taup1
  integer :: i, j, k, n
  
  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_coriolis_mod (coriolis_force): module must be initialized')
  endif 

  if(.not. use_this_module) then 
      if(energy_analysis_step) then 
          Velocity%wrkv=0.0
      endif
      return
  endif

  wrk1_v = 0.0

  tau    = Time%tau
  taum1  = Time%taum1
  taup1  = Time%taup1

  if(acor == 0.0) then 
    itime = tau
  else 
    itime = taum1
  endif 


  if(energy_analysis_step) then 

      if(acor > 0) then 

          ! Coriolis force alters kinetic energy when acor>0.  To determine 
          ! effects via the energy analysis, compute Coriolis force as here.  
          do k=1,nk
             do j=jsc,jec
                do i=isc,iec
                   Velocity%wrkv(i,j,k,1) = Grd%f(i,j)  &
                        *(Velocity%u(i,j,k,2,taum1)*(1.0-acor) + acor*Velocity%u(i,j,k,2,taup1)) &
                        *Thickness%rho_dzu(i,j,k,tau)
                   Velocity%wrkv(i,j,k,2) =-Grd%f(i,j) &
                        *(Velocity%u(i,j,k,1,taum1)*(1.0-acor) + acor*Velocity%u(i,j,k,1,taup1)) &
                        *Thickness%rho_dzu(i,j,k,tau)
                enddo
             enddo
          enddo

      else 

          do k=1,nk
             do j=jsc,jec
                do i=isc,iec
                   Velocity%wrkv(i,j,k,1) =  Grd%f(i,j)*Velocity%u(i,j,k,2,itime)*Thickness%rho_dzu(i,j,k,tau)
                   Velocity%wrkv(i,j,k,2) = -Grd%f(i,j)*Velocity%u(i,j,k,1,itime)*Thickness%rho_dzu(i,j,k,tau)
                enddo
             enddo
          enddo
      endif

  else 

      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1_v(i,j,k,1) =  Grd%f(i,j)*Velocity%u(i,j,k,2,itime)
               wrk1_v(i,j,k,2) = -Grd%f(i,j)*Velocity%u(i,j,k,1,itime)
            enddo
         enddo
      enddo

      call diagnose_3d_u(Time, Grd, id_cor_u, wrk1_v(:,:,:,1))
      call diagnose_3d_u(Time, Grd, id_cor_v, wrk1_v(:,:,:,2))

      ! weight acceleration with thickness and density of velocity cell
      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  wrk1_v(i,j,k,n)         = wrk1_v(i,j,k,n)*Thickness%rho_dzu(i,j,k,tau)
                  Velocity%accel(i,j,k,n) = Velocity%accel(i,j,k,n) + wrk1_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo

      call diagnose_3d_u(Time, Grd, id_hrho_cor_u, wrk1_v(:,:,:,1))
      call diagnose_3d_u(TIme, Grd, id_hrho_cor_v, wrk1_v(:,:,:,2))
  endif


end subroutine coriolis_force_bgrid
! </SUBROUTINE> NAME="coriolis_force_bgrid"


!#######################################################################
! <SUBROUTINE NAME="coriolis_force_bgrid_implicit">
!
! <DESCRIPTION>
! Contributions to thickness weighted and density weighted 
! acceleration from time-implicit Coriolis force.
! </DESCRIPTION>
!
subroutine coriolis_force_bgrid_implicit(Time, Velocity)

  type(ocean_time_type),     intent(in)    :: Time
  type(ocean_velocity_type), intent(inout) :: Velocity

  integer :: i, j, k
  real    :: dtimeacor
  real    :: lambda,factor

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) then 
      return
  endif


  wrk1_v = 0.0
  
  if(acor > 0.0) then 

      dtimeacor = dtime*acor 

      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1_v(i,j,k,:) = Velocity%accel(i,j,k,:)  
               lambda          = dtimeacor*Grd%f(i,j)
               factor          = 1.0/(1.0 + lambda*lambda) 
               wrk1(i,j,k)     = (Velocity%accel(i,j,k,1) + lambda*Velocity%accel(i,j,k,2))*factor
               wrk2(i,j,k)     = (Velocity%accel(i,j,k,2) - lambda*Velocity%accel(i,j,k,1))*factor
            enddo
         enddo
      enddo

      do k=1,nk
         do j=jsc,jec
            do i=isc,iec       
               Velocity%accel(i,j,k,1) = wrk1(i,j,k) 
               Velocity%accel(i,j,k,2) = wrk2(i,j,k) 
               wrk1_v(i,j,k,:)         = Velocity%accel(i,j,k,:) - wrk1_v(i,j,k,:) 
            enddo
         enddo
      enddo

      if (debug_this_module) then
          write(stdoutunit,*) ' ' 
          write(stdoutunit,*) 'From ocean_coriolis_mod: chksums after acor>0 Coriolis' 
          call write_timestamp(Time%model_time)
          call write_chksum_3d('accel(1)', Velocity%accel(COMP,:,1))
          call write_chksum_3d('accel(2)', Velocity%accel(COMP,:,2))
          call write_chksum_3d('vel(1)', wrk1_v(COMP,:,1))
          call write_chksum_3d('vel(2)', wrk1_v(COMP,:,2))
      endif

  endif

  ! send to diagnostics manager  
  call diagnose_3d_u(Time, Grd, id_ucori_impl, wrk1_v(:,:,:,1))
  call diagnose_3d_u(Time, Grd, id_vcori_impl, wrk1_v(:,:,:,2))

end subroutine coriolis_force_bgrid_implicit
! </SUBROUTINE> NAME="coriolis_force_bgrid_implicit"


!#######################################################################
! <SUBROUTINE NAME="coriolis_force_cgrid">
!
! <DESCRIPTION>
!
! Compute thickness and density weighted acceleration due to Coriolis
! force on a C-grid. 
! 
! </DESCRIPTION>
!
subroutine coriolis_force_cgrid(Time, Adv_vel, Velocity, abtau_m0, abtau_m1, abtau_m2, energy_analysis_step)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_adv_vel_type),   intent(in)    :: Adv_vel
  type(ocean_velocity_type),  intent(inout) :: Velocity
  real,                       intent(in)    :: abtau_m0
  real,                       intent(in)    :: abtau_m1
  real,                       intent(in)    :: abtau_m2
  logical,                    intent(in)    :: energy_analysis_step

  integer :: tau
  integer :: tau_m0, tau_m1, tau_m2
  integer :: i, j, k, n
  
  if(.not. use_this_module) then 
      if(energy_analysis_step) then 
          Velocity%wrkv=0.0
      endif
      return
  endif

  wrk1_v = 0.0
  tau    = Time%tau
  tau_m0 = Time%tau_m0
  tau_m1 = Time%tau_m1
  tau_m2 = Time%tau_m2

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1_v(i,j,k,1) =  onefourth*Grd%tmasken(i,j,k,1)                                      &
                            *( Grd%f(i,j)  *(Adv_vel%vhrho_nt(i,j,k)  +Adv_vel%vhrho_nt(i+1,j,k)) &
                              +Grd%f(i,j-1)*(Adv_vel%vhrho_nt(i,j-1,k)+Adv_vel%vhrho_nt(i+1,j-1,k)) )
           wrk1_v(i,j,k,2) = -onefourth*Grd%tmasken(i,j,k,2)                                      &
                            *( Grd%f(i,j)  *(Adv_vel%uhrho_et(i,j,k)  +Adv_vel%uhrho_et(i,j+1,k)) &
                              +Grd%f(i-1,j)*(Adv_vel%uhrho_et(i-1,j,k)+Adv_vel%uhrho_et(i-1,j+1,k)) )
        enddo
     enddo
  enddo

  if(energy_analysis_step) then 
     do n=1,2 
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 Velocity%wrkv(i,j,k,n) = wrk1_v(i,j,k,n)
              enddo
           enddo
        enddo
     enddo
  else 
     do n=1,2
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 Velocity%coriolis(i,j,k,n,tau_m0) = Velocity%coriolis(i,j,k,n,tau_m0) + wrk1_v(i,j,k,n)
                 Velocity%accel(i,j,k,n) = Velocity%accel(i,j,k,n)                     + &
                                           abtau_m0*Velocity%coriolis(i,j,k,n,tau_m0)  + &
                                           abtau_m1*Velocity%coriolis(i,j,k,n,tau_m1)  + &
                                           abtau_m2*Velocity%coriolis(i,j,k,n,tau_m2)
              enddo
           enddo
        enddo
     enddo


     call diagnose_3d_en(Time, Grd, id_hrho_cor_u, id_hrho_cor_v, wrk1_v(:,:,:,:))
  endif

end subroutine coriolis_force_cgrid
! </SUBROUTINE> NAME="coriolis_force_cgrid"


end module ocean_coriolis_mod

      module m_tracname_mod
!-----------------------------------------------------------
!       ... List of advected and non-advected trace species, and
!           surface fluxes for the advected species.
!-----------------------------------------------------------

      use mo_grid_mod,   only : pcnst
      use chem_mods_mod, only : grpcnt

      implicit none

character(len=128), parameter :: version     = '$Id: m_tracname.F90,v 19.0 2012/01/06 20:32:14 fms Exp $'
character(len=128), parameter :: tagname     = '$Name: tikal $'
logical                       :: module_is_initialized = .false.

      save

      character(len=8) :: tracnam(pcnst)          ! species names
      character(len=8) :: natsnam(max(1,grpcnt))  ! names of non-advected trace species

      end module m_tracname_mod

module rh_clouds_mod

!=======================================================================
!
!                          RH_CLOUDS MODULE
!
!=======================================================================

use mpp_mod,    only : input_nml_file
use fms_mod,    only : error_mesg, FATAL, file_exist,    &
                       check_nml_error, open_namelist_file,       &
                       close_file, mpp_pe, mpp_root_pe, &
                       write_version_number, stdlog
use fms_io_mod, only : restore_state, &
                       register_restart_field, restart_file_type, &
                       save_restart, get_mosaic_tile_file

!=======================================================================

implicit none
private

public  rh_clouds, rh_clouds_init, rh_clouds_end,  &
        rh_clouds_sum, rh_clouds_avg, do_rh_clouds

!=======================================================================

!
!  The public interface in this module are RH_CLOUDS_INIT 
!                                          RH_CLOUDS
!                                          
!  SUBROUTINE RH_CLOUDS_INIT
!  -- no input or output -- initializes module by reading namelist 
!  
!  SUBROUTINE RH_CLOUDS(RH, P_FULL, P_SURF, ZENITH, DEG_LAT,
!          N_CLOUD, TOP, BOT, CLDAMT,
!          ALB_UV,ALB_NIR,ABS_UV,ABS_NIR,EMISS)
!
!  input -- 
!
!     real, rh(:,:,:)     -- relative humidity(nlon,nlat,nlev)  
!                            third index runs from top of atmosphere to bottom 
!     real, p_full(:,:,:) -- pressure(nlon, nlat, nlev) at rh levels 
!     real, p_surf(:,:)   -- surface pressure(nlon,nlat)
!                            p_full and p_surf must be in same units
!     real, zenith(:,:)   -- cosine of zenith angle (nlon, nlat) 
!     real, deg_lat(:)    -- latitude in degrees (nlon,nlat) 
!
!  output --
!
!     integer, n_cloud(:,:)  -- number of distinct clouds (nlon, nlat)
!                  
!     integer, top(:,:,:) -- 
!     integer, bot(:,:,:) -- (nlon,nlat,max) --  max must be
!                            larger than any value of n_cloud 
!                            max = (size(rh,3)+1)/2 is safe
!                            the n'th cloud at horizontal location i,j
!                            fills the levels from top(i,j,n) to bot(i,j,n)
!                            inclusive (i.e., if the cloud is only one 
!                            level thick, then top = bot)
!                            cloud numbering starts from top of atmosphere
!     real, cldamt       --  horizontal area covered by nth cloud
!                            each cloud covers total area currently
!                            (i.e. cldamt = 1.)
!
!     real, alb_uv(:,:,:) -- (lon, lat, max)
!                            short wave albedo for each cloud
!     real, alb_nir(:,:,:) - near infrared albedo for each cloud
!     real, abs_uv(:,:,:) -- (lon, lat, max)
!                            short wave absorption coeff for each cloud = 0
!     real, abs_nir(:,:,:) - near infrared absorption coeff for each cloud
!     real, emiss(:.:.:) --(lon, lat, max)
!                        infrared emissivity for each cloud
!=======================================================================
!----------------- data for rh averaging code --------------------------

    real,    allocatable, dimension (:,:,:) :: rhsum
    integer, allocatable, dimension (:,:)   :: nsum

!-----------------------------------------------------------------------

interface rh_clouds
    module procedure  rh_clouds_3d, rh_clouds_2d, rh_clouds_1d
end interface

!--------------------- version number ----------------------------------

character(len=128) :: version = '$Id: rh_clouds.F90,v 19.0 2012/01/06 20:12:00 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!=======================================================================

!  DEFAULT VALUES OF NAMELIST PARAMETERS:

! sigma coordinate boundary between high and middle clouds varies linearly
!   in latitude between high_middle_pole at the pole and high_middle_eq
!   at the equator, and similarly for the boundary between middle and low
!   clouds

real :: high_middle_pole = 0.7
real :: high_middle_eq   = 0.4
real :: middle_low_pole  = 0.85
real :: middle_low_eq    = 0.7

! cloud is present when relative humidity >= rh_crit, which varies liearly
!   in sigma from rh_crit_top at sigma = 0 to rh_crit_bot at sigma = 1

real :: rh_crit_bot    = 1.00
real :: rh_crit_top    = 0.90


!  near infrared absorption coeffs 

real :: high_abs    = 0.04
real :: middle_abs  = 0.30
real :: low_abs     = 0.40

! infrared emissivities

real :: high_emiss    = 0.6
real :: middle_emiss  = 1.0
real :: low_emiss     = 1.0

real :: tuning_coeff_low_cld = 1.0

!  flag for time averaging rh

logical :: do_average = .false.
logical :: do_mcm_no_clouds_top = .false.
logical :: do_mcm_crit_rh = .false.

! albedos are computed from a table look-up as function of zenith angle

namelist /rh_clouds_nml/ high_middle_pole, high_middle_eq, &
                         middle_low_pole , middle_low_eq, &
                         rh_crit_bot, rh_crit_top, &
                         high_abs, middle_abs, low_abs, &
                         high_emiss, middle_emiss, low_emiss, &
                         do_average, tuning_coeff_low_cld, &
                         do_mcm_no_clouds_top, do_mcm_crit_rh

!=======================================================================

!  OTHER MODULE VARIABLES

!--- for netcdf restart
type(restart_file_type), pointer, save :: RH_restart => NULL()

logical :: module_is_initialized = .false.

contains

!#######################################################################

subroutine rh_clouds_init (nlon, nlat, nlev)

integer, intent(in) :: nlon, nlat, nlev

integer :: unit, ierr, io, logunit, id_restart

      if (module_is_initialized) return

!------------------- read namelist input -------------------------------

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=rh_clouds_nml, iostat=io)
      ierr = check_nml_error(io,'rh_clouds_nml')
#else   
      if (file_exist('input.nml')) then
         unit = open_namelist_file ()
         ierr=1; do while (ierr /= 0)
            read  (unit, nml=rh_clouds_nml, iostat=io, end=10)
            ierr = check_nml_error(io,'rh_clouds_nml')
         enddo
  10     call close_file (unit)
      endif
#endif

!---------- output namelist to log-------------------------------------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
           logunit = stdlog()
           write (logunit, nml=rh_clouds_nml)
      endif

!---------- initialize for rh cloud averaging -------------------------

      allocate (rhsum(nlon,nlat,nlev), nsum(nlon,nlat))
      allocate(RH_restart)

      id_restart = register_restart_field(RH_restart, 'rh_clouds.res.nc', 'nsum',  nsum)
      id_restart = register_restart_field(RH_restart, 'rh_clouds.res.nc', 'rhsum', rhsum)
      if (file_exist('INPUT/rh_clouds.res.nc')) then
        call restore_state(RH_restart)
      else if (file_exist('INPUT/rh_clouds.res')) then
        call error_mesg ('rh_clouds_init', &
                         'Native restart files no longer supported.', FATAL)
!        unit = open_restart_file ('INPUT/rh_clouds.res', action='read')
!        call read_data (unit, nsum)
!        call read_data (unit, rhsum)
!        call close_file (unit)
      else
        rhsum = 0.0;  nsum = 0
      endif


      module_is_initialized = .true.

!-----------------------------------------------------------------------

end subroutine rh_clouds_init

!#######################################################################

subroutine rh_clouds_end


    call save_restart(RH_restart)
    module_is_initialized = .false.

end subroutine rh_clouds_end

!#######################################################################

 function do_rh_clouds ( ) result (answer)
   logical :: answer

!  returns logical value for whether rh_clouds has been initialized
!  presumably if initialized then rh_cloud will be used

   answer = module_is_initialized

 end function do_rh_clouds

!#######################################################################

 subroutine rh_clouds_sum (is, js, rh)

!-----------------------------------------------------------------------
   integer, intent(in)                   :: is, js
      real, intent(in), dimension(:,:,:) :: rh
!-----------------------------------------------------------------------
   integer :: ie, je

   ie = is + size(rh,1) - 1
   je = js + size(rh,2) - 1

!--------- use time-averaged or instantaneous clouds -----------

   if (do_average) then
       nsum(is:ie,js:je)   =  nsum(is:ie,js:je)   +  1
      rhsum(is:ie,js:je,:) = rhsum(is:ie,js:je,:) + rh(:,:,:)
   else
       nsum(is:ie,js:je)   =  1
      rhsum(is:ie,js:je,:) = rh(:,:,:)
   endif

!-----------------------------------------------------------------------

 end subroutine rh_clouds_sum

!#######################################################################

 subroutine rh_clouds_avg (is, js, rh, ierr)

!-----------------------------------------------------------------------
   integer, intent(in)                    :: is, js
      real, intent(out), dimension(:,:,:) :: rh
   integer, intent(out)                   :: ierr
!-----------------------------------------------------------------------
   integer ::ie, je, num, k
!-----------------------------------------------------------------------

   if (size(rh,3) .ne. size(rhsum,3)) call error_mesg ( &
                              'rh_clouds_avg in rh_clouds_mod',  &
                              'input argument has the wrong size',FATAL)

   ie = is + size(rh,1) - 1
   je = js + size(rh,2) - 1
   num = count(nsum(is:ie,js:je) == 0)

   if (num > 0) then

!     ----- no average, return error flag -----

!!!    call error_mesg ('rh_clouds_avg in rh_clouds_mod',  &
!!!                     'dividing by a zero counter', FATAL)
       ierr = 1

   else

!      ----- compute average -----

       do k = 1, size(rh,3)
          rh(:,:,k) = rhsum(is:ie,js:je,k) / float(nsum(is:ie,js:je))
       enddo
       ierr = 0

   endif

    nsum(is:ie,js:je)   = 0
   rhsum(is:ie,js:je,:) = 0.0
     
!-----------------------------------------------------------------------

 end subroutine rh_clouds_avg

!#######################################################################

subroutine rh_clouds_3d(rh, p_full, p_surf, zenith, deg_lat,&
            n_cloud,top,bot,cldamt,alb_uv,alb_nir,abs_uv,abs_nir,emiss)

real   , intent(in) , dimension(:,:,:)   :: rh, p_full
real   , intent(in) , dimension(:,:)     :: p_surf, zenith, deg_lat
integer, intent(out), dimension(:,:,:)   :: top, bot
integer, intent(out), dimension(:,:)     :: n_cloud
real   , intent(out), dimension(:,:,:)   :: cldamt,emiss
real   , intent(out), dimension(:,:,:)   :: alb_uv,alb_nir,abs_uv,abs_nir


integer :: i, j, k, n, nlev, max_n_cloud
real   , dimension(size(rh,1),size(rh,2))            :: rh_crit
logical, dimension(size(rh,1),size(rh,2),size(rh,3)) :: cloud
real, dimension(size(rh,1),size(rh,2),2) ::  high_alb, middle_alb, low_alb
real, dimension(size(rh,1),size(rh,2)) :: high_middle, middle_low
real :: sig_bot

! dummy checks

 if (.not.module_is_initialized) call error_mesg( 'RH_CLOUDS in RH_CLOUD        S_MOD', &
        'module not initialized', FATAL)
 if (size(zenith,1).ne.size(rh,1)) &
              call error_mesg( 'RH_CLOUDS in RH_CLOUDS_MOD', &
             'dimensions of zenith and top do not match', FATAL)
 if (size(zenith,2).ne.size(rh,2)) &
              call error_mesg( 'RH_CLOUDS in RH_CLOUDS_MOD', &
             'dimensions of zenith and top do not match', FATAL)
 if (size(deg_lat,1).ne.size(rh,1)) &
              call error_mesg( 'RH_CLOUDS in RH_CLOUDS_MOD', &
             'dimension of deg_lat and top do not match', FATAL)
 if (size(deg_lat,2).ne.size(rh,2)) &
              call error_mesg( 'RH_CLOUDS in RH_CLOUDS_MOD', &
             'dimension of deg_lat and top do not match', FATAL)

cloud = .false.
nlev  = size(rh,3)

do k = 1, nlev
  if ( do_mcm_crit_rh ) then
    rh_crit = rh_crit_top + (rh_crit_bot - rh_crit_top)*p_full(:,:,k)/p_full(:,:,nlev)
  else
    rh_crit = rh_crit_top + (rh_crit_bot - rh_crit_top)*p_full(:,:,k)/p_surf
  endif
  where(rh(:,:,k) >= rh_crit) cloud(:,:,k) = .true.
enddo

if ( do_mcm_no_clouds_top ) cloud(:,:,1) = .false.

n_cloud = 0

do j = 1, size(rh,2)
  do i = 1, size(rh,1)
    if(cloud(i,j,1)) then
      n_cloud(i,j) = 1
      top(i,j,n_cloud(i,j)) = 1
    end if
    do k = 2, nlev
      if(.not.cloud(i,j,k).and.cloud(i,j,k-1)) then
         bot(i,j,n_cloud(i,j)) = k-1
      else if(cloud(i,j,k).and..not.cloud(i,j,k-1)) then
        n_cloud(i,j) = n_cloud(i,j) + 1
        top(i,j,n_cloud(i,j)) = k
      end if
    end do
    if(cloud(i,j,nlev)) bot(i,j,n_cloud(i,j)) = nlev
  end do
end do

max_n_cloud = maxval(n_cloud)
if(size(top,3).lt.max_n_cloud) call error_mesg( 'RH_CLOUDS in RH_CLOUDS_MOD',&
             'third dimension of top not large enough', FATAL)
call cloud_bounds(high_middle, middle_low, deg_lat)
call cloud_albedo(zenith, high_alb, middle_alb, low_alb)


abs_uv(:,:,:) = 0.0

do j = 1, size(top,2)
  do i = 1, size(top,1)
    do n = 1, n_cloud(i,j)


      !set cloud amount
      cldamt(i,j,n) = 1.

      sig_bot = p_full(i,j,bot(i,j,n))/p_surf(i,j)
      
      !guarantee some transmission to the clouds
      !by reducing the actual cloud reflectance in uv and nir band
      ! this break is necessary to avoid the rest of the
      ! radiation code from breaking up.
      if (sig_bot.le.high_middle(i,j)) then      ! high cloud   !
        alb_uv(i,j,n) = high_alb(i,j,1)
        alb_nir(i,j,n) = high_alb(i,j,2)
        abs_nir(i,j,n) = MIN(0.99-alb_nir(i,j,n),high_abs)
        emiss(i,j,n) = high_emiss

      elseif (sig_bot.gt.high_middle(i,j) .and. &
                sig_bot.le.middle_low(i,j))  then  ! middle cloud !
        alb_uv(i,j,n) = middle_alb(i,j,1)
        alb_nir(i,j,n) = middle_alb(i,j,2)
        abs_nir(i,j,n) = MIN(0.99-alb_nir(i,j,n),middle_abs)
        emiss(i,j,n) = middle_emiss

      elseif (sig_bot.gt.middle_low(i,j))  then  ! low cloud    !
        alb_uv(i,j,n) = low_alb(i,j,1)
        alb_nir(i,j,n) = low_alb(i,j,2)
        abs_nir(i,j,n) = MIN(0.99-alb_nir(i,j,n),low_abs)
        emiss(i,j,n) = low_emiss

      endif
        
    end do
  end do
end do

end subroutine rh_clouds_3d

!#######################################################################

subroutine cloud_albedo(zenith, high, middle, low)

real, intent(in), dimension(:,:)    :: zenith
real, intent(out), dimension(:,:,:) :: high, middle, low

integer, parameter :: num_angles = 17
integer, parameter :: num_bands  = 2

real, dimension(num_angles, 2) :: high_cloud, middle_cloud, low_cloud
real, dimension(num_angles, 2) :: low_cloud_tun

real, dimension(size(zenith,1),size(zenith,2)) :: z

real    :: pi, del, x, r
integer :: n, i, j, ind
integer :: n1, n2

! high cloud albedos for zenith angles from 0-80 deg. every 5 degs.
!    first for band =1, then band = 2

data high_cloud  &
 /.04,.05,.05,.05,.06,.06,.07,.07,.08,.11,.13,.16,.21,.28,.39,.48,.61, &
  .04,.05,.05,.05,.06,.06,.07,.07,.08,.10,.11,.14,.19,.26,.35,.44,.55/

! middle cloud albedos 

data middle_cloud &
 /.18,.18,.19,.20,.21,.23,.24,.26,.29,.33,.37,.42,.47,.55,.64,.71,.79, &
  .14,.14,.15,.16,.17,.18,.18,.20,.23,.25,.29,.32,.37,.43,.50,.55,.61/

! low cloud albedos 

data low_cloud &
 /.50,.50,.51,.51,.52,.53,.54,.56,.58,.62,.65,.67,.69,.73,.78,.82,.86, &
  .42,.42,.43,.43,.44,.45,.46,.48,.50,.52,.55,.57,.59,.63,.66,.70,.74/

pi = 4.0*atan(1.0)
z  = acos(zenith)*180.0/pi
del = 90.0/float(num_angles+1)

  do n1 = 1,num_angles
    do n2 = 1,num_bands
      low_cloud_tun(n1,n2) = tuning_coeff_low_cld*low_cloud(n1,n2)
    end do
  end do

! if zenith angle >= 80 degrees, use albedos for zenith angle = 80
do j = 1, size(zenith,2)
  do i = 1, size(zenith,1)
    if (z(i,j) .ge. 80.0) then
      do n = 1,num_bands
          high(i,j,n) =   high_cloud(num_angles,n)
        middle(i,j,n) = middle_cloud(num_angles,n)
           low(i,j,n) = low_cloud_tun(num_angles,n)
      end do
    else
      x = z(i,j)/del
      ind = floor(x)
      r = x - ind
      ind = ind + 1
      do n = 1,num_bands
          high(i,j,n) =   high_cloud(ind,n) &
                   + r*(  high_cloud(ind+1,n) -   high_cloud(ind,n))
        middle(i,j,n) = middle_cloud(ind,n) &
                   + r*(middle_cloud(ind+1,n) - middle_cloud(ind,n))
           low(i,j,n) =    low_cloud_tun(ind,n) &
                   + r*(   low_cloud_tun(ind+1,n) - low_cloud_tun(ind,n))
      end do
    end if
  end do
end do


end subroutine cloud_albedo

!#######################################################################

subroutine cloud_bounds(high_middle, middle_low, deg_lat)

real, intent(in) , dimension(:,:) :: deg_lat
real, intent(out), dimension(:,:) :: high_middle, middle_low

real,dimension(size(deg_lat,1),size(deg_lat,2)) :: x

   x = (90.0 - abs(deg_lat))/90.

   high_middle = high_middle_pole + x*(high_middle_eq - high_middle_pole)
   middle_low  = middle_low_pole  + x*(middle_low_eq  - middle_low_pole )

return
end subroutine cloud_bounds


!#######################################################################
!  THE FOLLOWING CODE ALLOWS RH_CLOUDS TO BE USED IN 2D AND 1D MODELS
!#######################################################################

subroutine rh_clouds_2d(rh, p_full, p_surf, zenith, deg_lat,&
            n_cloud,top,bot,cldamt,alb_uv,alb_nir,abs_uv,abs_nir,emiss)

real   , intent(in) , dimension(:,:)   :: rh, p_full
real   , intent(in) , dimension(:)     :: p_surf,zenith,deg_lat
integer, intent(out), dimension(:,:)   :: top, bot
integer, intent(out), dimension(:)     :: n_cloud
real   , intent(out), dimension(:,:)   :: cldamt,alb_uv,alb_nir,abs_uv
real   , intent(out), dimension(:,:)   :: abs_nir,emiss

real, dimension(1, size(rh,1),size(rh,2)) :: rh_3d, p_full_3d
real, dimension(1, size(rh,1)           ) :: p_surf_3d, zenith_3d,deg_lat_3d
real, dimension(1, size(rh,1),size(rh,2)) :: cldamt_3d,alb_uv_3d,alb_nir_3d
real, dimension(1, size(rh,1),size(rh,2)) :: abs_uv_3d,abs_nir_3d,emiss_3d
integer, dimension(1, size(rh,1), size(rh,2)) :: top_3d, bot_3d
integer, dimension(1, size(rh,1)        ) :: n_cloud_3d

!assign variables to 3d matrices
rh_3d(1,:,:) = rh
p_full_3d(1,:,:) = p_full
p_surf_3d(1,:) = p_surf
zenith_3d(1,:) = zenith
deg_lat_3d(1,:) = deg_lat

call rh_clouds_3d(rh_3d, p_full_3d, p_surf_3d, zenith_3d, deg_lat_3d,&
   n_cloud_3d,top_3d,bot_3d,cldamt_3d,alb_uv_3d,alb_nir_3d,abs_uv_3d,&
   abs_nir_3d,emiss_3d)

!patch back results to 2d matrices
n_cloud = n_cloud_3d(1,:)
top = top_3d(1,:,:)
bot = bot_3d(1,:,:)
cldamt = cldamt_3d(1,:,:)
alb_uv = alb_uv_3d(1,:,:)
alb_nir = alb_nir_3d(1,:,:)
abs_uv = abs_uv_3d(1,:,:)
abs_nir = abs_nir_3d(1,:,:)
emiss = emiss_3d(1,:,:)

end subroutine rh_clouds_2d

!#######################################################################

subroutine rh_clouds_1d(rh, p_full, p_surf, zenith, deg_lat,&
            n_cloud,top,bot,cldamt,alb_uv,alb_nir,abs_uv,abs_nir,emiss)

real   , intent(in) , dimension(:)   :: rh, p_full
real   , intent(in)                  :: p_surf,zenith,deg_lat
integer, intent(out), dimension(:)   :: top, bot
integer, intent(out)                 :: n_cloud
real   , intent(out), dimension(:)   :: cldamt,alb_uv,alb_nir,abs_uv
real   , intent(out), dimension(:)   :: abs_nir,emiss

real, dimension(1, 1,size(rh(:))) :: rh_3d, p_full_3d
real, dimension(1, 1            ) :: p_surf_3d, zenith_3d,deg_lat_3d
real, dimension(1, 1,size(rh(:))) :: cldamt_3d,alb_uv_3d,alb_nir_3d
real, dimension(1, 1,size(rh(:))) :: abs_uv_3d,abs_nir_3d,emiss_3d
integer, dimension(1, 1, size(rh(:))) :: top_3d, bot_3d
integer, dimension(1, 1             ) :: n_cloud_3d

!assign variables to 3d matrices
rh_3d(1,1,:) = rh
p_full_3d(1,1,:) = p_full
p_surf_3d(1,1) = p_surf
zenith_3d(1,1) = zenith
deg_lat_3d(1,1) = deg_lat

call rh_clouds_3d(rh_3d, p_full_3d, p_surf_3d, zenith_3d, deg_lat_3d,&
   n_cloud_3d,top_3d,bot_3d,cldamt_3d,alb_uv_3d,alb_nir_3d,abs_uv_3d,&
   abs_nir_3d,emiss_3d)

!patch back results to 2d matrices
n_cloud = n_cloud_3d(1,1)
top = top_3d(1,1,:)
bot = bot_3d(1,1,:)
cldamt = cldamt_3d(1,1,:)
alb_uv = alb_uv_3d(1,1,:)
alb_nir = alb_nir_3d(1,1,:)
abs_uv = abs_uv_3d(1,1,:)
abs_nir = abs_nir_3d(1,1,:)
emiss = emiss_3d(1,1,:)

end subroutine rh_clouds_1d


!#######################################################################



end module rh_clouds_mod

module global_integral_mod

use              fms_mod, only: mpp_pe, mpp_root_pe, &
                                write_version_number

use press_and_geopot_mod, only: half_level_pressures

use       transforms_mod, only: area_weighted_global_mean

use        constants_mod, only: grav

use      mpp_domains_mod, only: mpp_global_field

implicit none
private

public :: mass_weighted_global_integral

real :: global_sum_of_wts
logical :: entry_to_logfile_done=.false.
character(len=128), parameter :: version = '$Id: global_integral.F90,v 13.0 2006/03/28 21:17:51 fms Exp $'
character(len=128), parameter :: tagname = '$Name: tikal $'

contains

!---------------------------------------------------------------------------------------------

function mass_weighted_global_integral(field, surf_press)

!  This function returns the mass weighted vertical integral of field,
!  area averaged over the globe. The units of the result are:
!  (units of field)*(Kg/meters**2)

real :: mass_weighted_global_integral
real, intent(in), dimension(:,:,:) :: field
real, intent(in), dimension(:,:)   :: surf_press
real, dimension(size(field,1), size(field,2), size(field,3)  ) :: dp
real, dimension(size(field,1), size(field,2), size(field,3)+1) :: p_half

real, dimension(size(field,1), size(field,2)) :: vert_integral

integer ::  k, num_levels

if(.not.entry_to_logfile_done) then
  call write_version_number(version, tagname)
  entry_to_logfile_done=.true.
endif


num_levels = size(field,3)
p_half= half_level_pressures(surf_press)
dp = p_half(:,:,2:num_levels+1) - p_half(:,:,1:num_levels)
vert_integral = 0.
do k=1,num_levels
  vert_integral = vert_integral + field(:,:,k)*dp(:,:,k)
enddo
mass_weighted_global_integral = area_weighted_global_mean(vert_integral)/grav

return
end function mass_weighted_global_integral
!---------------------------------------------------------------------------------------------
end module global_integral_mod

module horiz_interp_spherical_mod

  ! <CONTACT EMAIL="Matthew.Harrison@noaa.gov"> Matthew Harrison </CONTACT>
  ! <CONTACT EMAIL="Zhi.Liang@noaa.gov"> Zhi Liang </CONTACT>

  ! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

  ! <OVERVIEW>
  !   Performs spatial interpolation between grids using inverse-distance-weighted scheme.
  ! </OVERVIEW>

  ! <DESCRIPTION>
  !     This module can interpolate data from rectangular/tripolar grid
  !     to rectangular/tripolar grid. The interpolation scheme is inverse-distance-weighted 
  !     scheme.    There is an optional mask field for missing input data.
  !     An optional output mask field may be used in conjunction with
  !     the input mask to show where output data exists.
  ! </DESCRIPTION>

  use mpp_mod,               only : mpp_error, FATAL, WARNING, stdout
  use mpp_mod,               only : mpp_root_pe, mpp_pe
  use mpp_mod,               only : input_nml_file
  use fms_mod,               only : write_version_number, file_exist, close_file
  use fms_mod,               only : check_nml_error, open_namelist_file
  use constants_mod,         only : pi
  use horiz_interp_type_mod, only : horiz_interp_type, stats

  implicit none
  private


  public :: horiz_interp_spherical_new, horiz_interp_spherical, horiz_interp_spherical_del
  public :: horiz_interp_spherical_init, horiz_interp_spherical_wght

  integer, parameter :: max_neighbors = 400 
  real,    parameter :: max_dist_default = 0.1  ! radians
  integer, parameter :: num_nbrs_default = 4
  real,    parameter :: large=1.e20
  real,    parameter :: epsln=1.e-10

  integer            :: pe, root_pe


  !--- namelist interface
  !<NAMELIST NAME="horiz_interp_spherical_nml">
  ! <DATA NAME="search_method" TYPE="character(len=32)">
  !  indicate the searching method to find the nearest neighbor points. Its value
  !  can be "radial_search" and "full_search", with default value "radial_search".
  !  when search_method is "radial_search", the search may be not quite accurate for some cases.
  !  Normally the search will be ok if you chose suitable max_dist.  
  !  When search_method is "full_search", it will be always accurate, but will be slower
  !  comparing to "radial_search". Normally these two search algorithm will produce same 
  !  results other than order of operation. "radial_search" are recommended to use. 
  !  The purpose to add "full_search" is in case you think you interpolation results is 
  !  not right, you have other option to verify.
  ! </DATA>
  !</NAMELIST>

  character(len=32) :: search_method = "radial_search" ! or "full_search"
  namelist /horiz_interp_spherical_nml/ search_method

  !-----------------------------------------------------------------------
  character(len=128) :: version = '$Id$'
  character(len=128) :: tagname = '$Name$'
  logical            :: module_is_initialized = .FALSE.

contains

  !#######################################################################
  !  <SUBROUTINE NAME="horiz_interp_spherical_init">
  !  <OVERVIEW>
  !     writes version number and tag name to logfile.out
  !  </OVERVIEW>
  !  <DESCRIPTION>       
  !     writes version number and tag name to logfile.out
  !  </DESCRIPTION>

  subroutine horiz_interp_spherical_init
    integer :: unit, ierr, io


    if(module_is_initialized) return
    call write_version_number (version, tagname)
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, horiz_interp_spherical_nml, iostat=io)
      ierr = check_nml_error(io,'horiz_interp_spherical_nml') 
#else
    if (file_exist('input.nml')) then
       unit = open_namelist_file ( )
       ierr=1; do while (ierr /= 0)
       read  (unit, nml=horiz_interp_spherical_nml, iostat=io, end=10)
       ierr = check_nml_error(io,'horiz_interp_spherical_nml')  ! also initializes nml error codes
    enddo
10  call close_file (unit)
    endif
#endif

 module_is_initialized = .true.



end subroutine horiz_interp_spherical_init

  !  </SUBROUTINE>

  !#######################################################################
  ! <SUBROUTINE NAME="horiz_interp_spherical_new">

  !   <OVERVIEW>
  !      Initialization routine.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !      Allocates space and initializes a derived-type variable
  !      that contains pre-computed interpolation indices and weights.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call horiz_interp_spherical_new(Interp, lon_in,lat_in,lon_out,lat_out, num_nbrs, max_dist, src_modulo)
  !   </TEMPLATE>
  !   
  !   <IN NAME="lon_in" TYPE="real, dimension(:,:)" UNITS="radians">
  !      Longitude (in radians) for source data grid. 
  !   </IN>

  !   <IN NAME="lat_in" TYPE="real, dimension(:,:)" UNITS="radians">
  !      Latitude (in radians) for source data grid.
  !   </IN>

  !   <IN NAME="lon_out" TYPE="real, dimension(:,:)" UNITS="radians" >
  !      Longitude (in radians) for source data grid. 
  !   </IN>

  !   <IN NAME="lat_out" TYPE="real, dimension(:,:)" UNITS="radians" >
  !      Latitude (in radians) for source data grid. 
  !   </IN>

  !   <IN NAME="num_nbrs" TYPE="integer, optional">
  !     Number of nearest neighbors for regridding. When number of neighbors within
  !     the radius max_dist ( namelist variable) is less than num_nbrs, All the neighbors 
  !     will be used to interpolate onto destination grid. when number of neighbors within
  !     the radius max_dist ( namelist variable) is greater than num_nbrs, at least "num_nbrs"
  !     neighbors will be used to remap onto destination grid. 
  !   </IN>

  !   <IN NAME="max_dist" TYPE="real, optional" UNITS="radians">
  !      Maximum region of influence around destination grid points.
  !   </IN>

  !   <IN NAME="src_modulo" TYPE="logical, optional">
  !      logical variable to indicate if the boundary condition along zonal boundary
  !      is cyclic or not. When true, the zonal boundary condition is cyclic.
  !   </IN>

  !   <INOUT NAME="Interp" TYPE="type(horiz_interp_type)">
  !      A derived-type variable containing indices and weights used for subsequent 
  !      interpolations. To reinitialize this variable for a different grid-to-grid 
  !      interpolation you must first use the "horiz_interp_del" interface.
  !   </INOUT>

  subroutine horiz_interp_spherical_new(Interp, lon_in,lat_in,lon_out,lat_out, &
       num_nbrs, max_dist, src_modulo)
    type(horiz_interp_type), intent(inout) :: Interp
    real, intent(in),       dimension(:,:) :: lon_in, lat_in, lon_out, lat_out
    integer, intent(in),        optional   :: num_nbrs
    real, optional,             intent(in) :: max_dist
    logical,          intent(in), optional :: src_modulo

    !------local variables ---------------------------------------
    integer :: i, j, n
    integer :: map_dst_xsize, map_dst_ysize, map_src_xsize, map_src_ysize
    integer :: map_src_size, num_neighbors
    real    :: max_src_dist, tpi, hpi 
    logical :: src_is_modulo
    real    :: min_theta_dst, max_theta_dst, min_phi_dst, max_phi_dst
    real    :: min_theta_src, max_theta_src, min_phi_src, max_phi_src 
    integer :: map_src_add(size(lon_out,1),size(lon_out,2),max_neighbors)
    real    :: map_src_dist(size(lon_out,1),size(lon_out,2),max_neighbors)
    integer :: num_found(size(lon_out,1),size(lon_out,2))
    integer :: ilon(max_neighbors), jlat(max_neighbors)
    real, dimension(size(lon_out,1),size(lon_out,2)) :: theta_dst, phi_dst
    real, dimension(size(lon_in,1)*size(lon_in,2))   :: theta_src, phi_src

    !--------------------------------------------------------------

    pe      = mpp_pe()
    root_pe = mpp_root_pe()

    tpi = 2.0*PI; hpi = 0.5*PI

    num_neighbors = num_nbrs_default
    if(present(num_nbrs)) num_neighbors = num_nbrs
    if (num_neighbors <= 0) call mpp_error(FATAL,'horiz_interp_spherical_mod: num_neighbors must be > 0') 

    max_src_dist = max_dist_default
    if (PRESENT(max_dist)) max_src_dist = max_dist
    Interp%max_src_dist = max_src_dist

    src_is_modulo = .true.
    if (PRESENT(src_modulo)) src_is_modulo = src_modulo

    !--- check the grid size comformable
    map_dst_xsize=size(lon_out,1);map_dst_ysize=size(lon_out,2)
    map_src_xsize=size(lon_in,1); map_src_ysize=size(lon_in,2)
    map_src_size = map_src_xsize*map_src_ysize

    if (map_dst_xsize /= size(lat_out,1) .or. map_dst_ysize /= size(lat_out,2)) &
         call mpp_error(FATAL,'horiz_interp_spherical_mod: destination grids not conformable')
    if (map_src_xsize /= size(lat_in,1) .or. map_src_ysize /= size(lat_in,2)) &
         call mpp_error(FATAL,'horiz_interp_spherical_mod: source grids not conformable')

    theta_src      = reshape(lon_in,(/map_src_size/))
    phi_src        = reshape(lat_in,(/map_src_size/))
    theta_dst(:,:) = lon_out(:,:)
    phi_dst(:,:)   = lat_out(:,:)

    min_theta_dst=tpi;max_theta_dst=0.0;min_phi_dst=pi;max_phi_dst=-pi
    min_theta_src=tpi;max_theta_src=0.0;min_phi_src=pi;max_phi_src=-pi

    where(theta_dst<0.0)  theta_dst = theta_dst+tpi
    where(theta_dst>tpi)  theta_dst = theta_dst-tpi
    where(theta_src<0.0)  theta_src = theta_src+tpi
    where(theta_src>tpi)  theta_src = theta_src-tpi

    where(phi_dst < -hpi) phi_dst = -hpi
    where(phi_dst > hpi)  phi_dst =  hpi
    where(phi_src < -hpi) phi_src = -hpi
    where(phi_src > hpi)  phi_src =  hpi    

    do j=1,map_dst_ysize
       do i=1,map_dst_xsize
          min_theta_dst = min(min_theta_dst,theta_dst(i,j))
          max_theta_dst = max(max_theta_dst,theta_dst(i,j))
          min_phi_dst = min(min_phi_dst,phi_dst(i,j))
          max_phi_dst = max(max_phi_dst,phi_dst(i,j))
       enddo
    enddo

    do i=1,map_src_size
       min_theta_src = min(min_theta_src,theta_src(i))
       max_theta_src = max(max_theta_src,theta_src(i))
       min_phi_src = min(min_phi_src,phi_src(i))
       max_phi_src = max(max_phi_src,phi_src(i))
    enddo

    if (min_phi_dst < min_phi_src) print *, '=> WARNING:  latitute of dest grid exceeds src'
    if (max_phi_dst > max_phi_src) print *, '=> WARNING:  latitute of dest grid exceeds src'
    ! when src is cyclic, no need to print out the following warning.
    if(.not. src_is_modulo) then    
       if (min_theta_dst < min_theta_src) print *, '=> WARNING : longitude of dest grid exceeds src'
       if (max_theta_dst > max_theta_src) print *, '=> WARNING : longitude of dest grid exceeds src'
    endif

    ! allocate memory to data type
    if(ASSOCIATED(Interp%i_lon)) then
       if(size(Interp%i_lon,1) .NE. map_dst_xsize .OR.     &
          size(Interp%i_lon,2) .NE. map_dst_ysize )  call mpp_error(FATAL, &
          'horiz_interp_spherical_mod: size(Interp%i_lon(:),1) .NE. map_dst_xsize .OR. '// &
          'size(Interp%i_lon(:),2) .NE. map_dst_ysize')
    else
       allocate(Interp%i_lon(map_dst_xsize,map_dst_ysize,max_neighbors), &
            Interp%j_lat(map_dst_xsize,map_dst_ysize,max_neighbors),     &
            Interp%src_dist(map_dst_xsize,map_dst_ysize,max_neighbors),  &
            Interp%num_found(map_dst_xsize,map_dst_ysize)       )
    endif

    map_src_add         = 0
    map_src_dist        = large
    num_found           = 0

    !using radial_search to find the nearest points and corresponding distance.

    select case(trim(search_method))
    case ("radial_search") ! will be efficient, but may be not so accurate for some cases
       call radial_search(theta_src, phi_src, theta_dst, phi_dst, map_src_xsize, map_src_ysize, &
            map_src_add, map_src_dist, num_found, num_neighbors,max_src_dist,src_is_modulo)    
    case ("full_search")   ! always accurate, but less efficient.
       call full_search(theta_src, phi_src, theta_dst, phi_dst, map_src_add, map_src_dist, &
            num_found, num_neighbors,max_src_dist )
    case default
       call mpp_error(FATAL,"horiz_interp_spherical_new: nml search_method = "// &
                  trim(search_method)//" is not a valid namelist option")
    end select    

    do j=1,map_dst_ysize
       do i=1,map_dst_xsize
          do n=1,num_found(i,j)
             if(map_src_add(i,j,n) == 0) then
                jlat(n) = 0; ilon(n) = 0
             else
                jlat(n) = map_src_add(i,j,n)/map_src_xsize + 1
                ilon(n) = map_src_add(i,j,n) - (jlat(n)-1)*map_src_xsize
                if(ilon(n) == 0) then
                   jlat(n) = jlat(n) - 1
                   ilon(n) = map_src_xsize
                endif
             endif
          enddo
          Interp%i_lon(i,j,:)         = ilon(:)
          Interp%j_lat(i,j,:)         = jlat(:)
          Interp%num_found(i,j)       = num_found(i,j)
          Interp%src_dist(i,j,:)      = map_src_dist(i,j,:)
       enddo
    enddo

    Interp%nlon_src = map_src_xsize; Interp%nlat_src = map_src_ysize
    Interp%nlon_dst = map_dst_xsize; Interp%nlat_dst = map_dst_ysize

    return

  end subroutine horiz_interp_spherical_new
  ! </SUBROUTINE>

  !#######################################################################
  ! <SUBROUTINE NAME="horiz_interp_spherical">

  !   <OVERVIEW>
  !      Subroutine for performing the horizontal interpolation between two grids.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Subroutine for performing the horizontal interpolation between two grids. 
  !     horiz_interp_spherical_new must be called before calling this routine.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call horiz_interp_spherical( Interp, data_in, data_out, verbose, mask_in, mask_out, missing_value)
  !   </TEMPLATE>
  !   
  !   <IN NAME="Interp" TYPE="type(horiz_interp_type)">
  !     Derived-type variable containing interpolation indices and weights.
  !     Returned by a previous call to horiz_interp_spherical_new.
  !   </IN>
  !   <IN NAME="data_in" TYPE="real, dimension(:,:)">
  !      Input data on source grid.
  !   </IN>
  !   <IN NAME="verbose" TYPE="integer, optional">
  !      flag for the amount of print output.
  !               verbose = 0, no output; = 1, min,max,means; = 2, still more
  !   </IN>
  !   <IN NAME="mask_in" TYPE="real, dimension(:,:),optional">
  !      Input mask, must be the same size as the input data. The real value of
  !      mask_in must be in the range (0.,1.). Set mask_in=0.0 for data points 
  !      that should not be used or have missing data. 
  !   </IN>
  !   <IN NAME="missing_value" TYPE="real, optional">
  !      Use the missing_value to indicate missing data.
  !   </IN>
  !   <OUT NAME="data_out" TYPE="real, dimension(:,:)">
  !      Output data on destination grid.
  !   </OUT>
  !   <OUT NAME="mask_out" TYPE="real, dimension(:,:),optional">
  !      Output mask that specifies whether data was computed.
  !   </OUT>

  subroutine horiz_interp_spherical( Interp, data_in, data_out, verbose, mask_in, mask_out, missing_value)
    type (horiz_interp_type), intent(in)        :: Interp
    real, intent(in),  dimension(:,:)           :: data_in
    real, intent(out), dimension(:,:)           :: data_out
    integer, intent(in),               optional :: verbose
    real, intent(in), dimension(:,:),  optional :: mask_in
    real, intent(out), dimension(:,:), optional :: mask_out
    real, intent(in),                  optional :: missing_value

    !--- some local variables ----------------------------------------
    real, dimension(Interp%nlon_dst, Interp%nlat_dst,size(Interp%src_dist,3)) :: wt
    real, dimension(Interp%nlon_src, Interp%nlat_src) :: mask_src
    real, dimension(Interp%nlon_dst, Interp%nlat_dst) :: mask_dst
    integer :: nlon_in, nlat_in, nlon_out, nlat_out, num_found
    integer :: m, n, i, j, k, miss_in, miss_out, i1, i2, j1, j2, iverbose
    real    :: min_in, max_in, avg_in, min_out, max_out, avg_out, sum
    !-----------------------------------------------------------------

    iverbose = 0;  if (present(verbose)) iverbose = verbose

    nlon_in  = Interp%nlon_src; nlat_in  = Interp%nlat_src
    nlon_out = Interp%nlon_dst; nlat_out = Interp%nlat_dst   

    if(size(data_in,1) .ne. nlon_in .or. size(data_in,2) .ne. nlat_in ) &
         call mpp_error(FATAL,'horiz_interp_spherical_mod: size of input array incorrect')

    if(size(data_out,1) .ne. nlon_out .or. size(data_out,2) .ne. nlat_out ) & 
         call mpp_error(FATAL,'horiz_interp_spherical_mod: size of output array incorrect')

    mask_src = 1.0; mask_dst = 1.0
    if(present(mask_in)) mask_src = mask_in

    do n=1,nlat_out
       do m=1,nlon_out
          ! neighbors are sorted nearest to farthest
          ! check nearest to see if it is a land point
          num_found = Interp%num_found(m,n) 
          if(num_found == 0 ) then
             mask_dst(m,n) = 0.0
          else          
             i1 = Interp%i_lon(m,n,1); j1 = Interp%j_lat(m,n,1) 
             if (mask_src(i1,j1) .lt. 0.5) then
                mask_dst(m,n) = 0.0
             endif

             if(num_found .gt. 1 ) then
                i2 = Interp%i_lon(m,n,2); j2 = Interp%j_lat(m,n,2)
                ! compare first 2 nearest neighbors -- if they are nearly
                ! equidistant then use this mask for robustness
                if(abs(Interp%src_dist(m,n,2)-Interp%src_dist(m,n,1)) .lt. epsln) then
                   if((mask_src(i1,j1) .lt. 0.5))  mask_dst(m,n) = 0.0
                endif
             endif

             sum=0.0
             do k=1, num_found
                if(mask_src(Interp%i_lon(m,n,k),Interp%j_lat(m,n,k)) .lt. 0.5 ) then
                   wt(m,n,k) = 0.0
                else
                   if (Interp%src_dist(m,n,k) <= epsln) then
                      wt(m,n,k) = large
                      sum = sum + large
                   else if(Interp%src_dist(m,n,k) <= Interp%max_src_dist ) then
                      wt(m,n,k) = 1.0/Interp%src_dist(m,n,k)
                      sum = sum+wt(m,n,k)
                   else
                      wt(m,n,k) = 0.0
                   endif
                endif
             enddo
             if (sum > epsln) then
                do k = 1, num_found
                   wt(m,n,k) = wt(m,n,k)/sum
                enddo
             else
                mask_dst(m,n) = 0.0
             endif
          endif
       enddo
    enddo

    data_out = 0.0
    do n=1,nlat_out
       do m=1,nlon_out
          if(mask_dst(m,n) .gt. 0.5) then
             do k=1, Interp%num_found(m,n)
                i = Interp%i_lon(m,n,k)
                j = Interp%j_lat(m,n,k)
                data_out(m,n) = data_out(m,n)+data_in(i,j)*wt(m,n,k)
             enddo
          else
             if(present(missing_value)) then
                data_out(m,n) = missing_value
             else
                data_out(m,n) = 0.0
             endif
          endif
       enddo
    enddo

    if(present(mask_out)) mask_out = mask_dst

    !***********************************************************************
    ! compute statistics: minimum, maximum, and mean
    !-----------------------------------------------------------------------

    if (iverbose > 0) then

       ! compute statistics of input data

       call stats (data_in, min_in, max_in, avg_in, miss_in, missing_value, mask=mask_src)

       ! compute statistics of output data
       call stats (data_out, min_out, max_out, avg_out, miss_out, missing_value, mask=mask_dst)

       !---- output statistics ----
       ! root_pe have the information of global mean, min and max
       if(pe == root_pe) then
          write (*,900)
          write (*,901)  min_in ,max_in, avg_in
          if (present(mask_in))  write (*,903)  miss_in
          write (*,902)  min_out,max_out,avg_out
          if (present(mask_out)) write (*,903)  miss_out
       endif
900    format (/,1x,10('-'),' output from horiz_interp ',10('-'))
901    format ('  input:  min=',f16.9,'  max=',f16.9,'  avg=',f22.15)
902    format (' output:  min=',f16.9,'  max=',f16.9,'  avg=',f22.15)
903    format ('          number of missing points = ',i6)

    endif

    return
  end subroutine horiz_interp_spherical

  ! </SUBROUTINE>
  !#######################################################################
  subroutine horiz_interp_spherical_wght( Interp, wt, verbose, mask_in, mask_out, missing_value)
    type (horiz_interp_type), intent(in)        :: Interp
    real, intent(out), dimension(:,:,:)         :: wt
    integer, intent(in),               optional :: verbose
    real, intent(in), dimension(:,:),  optional :: mask_in
    real, intent(out), dimension(:,:), optional :: mask_out
    real, intent(in),                  optional :: missing_value

    !--- some local variables ----------------------------------------
    real, dimension(Interp%nlon_src, Interp%nlat_src) :: mask_src
    real, dimension(Interp%nlon_dst, Interp%nlat_dst) :: mask_dst
    integer :: nlon_in, nlat_in, nlon_out, nlat_out, num_found
    integer :: m, n, i, j, k, miss_in, miss_out, i1, i2, j1, j2, iverbose
    real    :: min_in, max_in, avg_in, min_out, max_out, avg_out, sum
    !-----------------------------------------------------------------

    iverbose = 0;  if (present(verbose)) iverbose = verbose

    nlon_in  = Interp%nlon_src; nlat_in  = Interp%nlat_src
    nlon_out = Interp%nlon_dst; nlat_out = Interp%nlat_dst

    mask_src = 1.0; mask_dst = 1.0
    if(present(mask_in)) mask_src = mask_in

    do n=1,nlat_out
       do m=1,nlon_out
          ! neighbors are sorted nearest to farthest
          ! check nearest to see if it is a land point
          num_found = Interp%num_found(m,n)

          if (num_found > num_nbrs_default) then
            print*,'pe=',mpp_pe(),'num_found=',num_found
            num_found = num_nbrs_default
          end if

          if(num_found == 0 ) then
             mask_dst(m,n) = 0.0
          else
             i1 = Interp%i_lon(m,n,1); j1 = Interp%j_lat(m,n,1)
             if (mask_src(i1,j1) .lt. 0.5) then
                mask_dst(m,n) = 0.0
             endif

             if(num_found .gt. 1 ) then
                i2 = Interp%i_lon(m,n,2); j2 = Interp%j_lat(m,n,2)
                ! compare first 2 nearest neighbors -- if they are nearly
                ! equidistant then use this mask for robustness
                if(abs(Interp%src_dist(m,n,2)-Interp%src_dist(m,n,1)) .lt. epsln) then
                   if((mask_src(i1,j1) .lt. 0.5))  mask_dst(m,n) = 0.0
                endif
             endif

             sum=0.0
             do k=1, num_found
                if(mask_src(Interp%i_lon(m,n,k),Interp%j_lat(m,n,k)) .lt. 0.5 ) then
                   wt(m,n,k) = 0.0
                else
                   if (Interp%src_dist(m,n,k) <= epsln) then
                      wt(m,n,k) = large
                      sum = sum + large
                   else if(Interp%src_dist(m,n,k) <= Interp%max_src_dist ) then
                      wt(m,n,k) = 1.0/Interp%src_dist(m,n,k)
                      sum = sum+wt(m,n,k)
                   else
                      wt(m,n,k) = 0.0
                   endif
                endif
             enddo
             if (sum > epsln) then
                do k = 1, num_found
                   wt(m,n,k) = wt(m,n,k)/sum
                enddo
             else
                mask_dst(m,n) = 0.0
             endif
          endif
       enddo
    enddo

    return
  end subroutine horiz_interp_spherical_wght
  ! </SUBROUTINE>

  !#######################################################################
  ! <SUBROUTINE NAME="horiz_interp_spherical_del">

  !   <OVERVIEW>
  !     Deallocates memory used by "horiz_interp_type" variables.
  !     Must be called before reinitializing with horiz_interp_spherical_new.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Deallocates memory used by "horiz_interp_type" variables.
  !     Must be called before reinitializing with horiz_interp_spherical_new.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call horiz_interp_spherical_del ( Interp )
  !   </TEMPLATE>

  !   <INOUT NAME="Interp" TYPE="horiz_interp_type">
  !     A derived-type variable returned by previous call
  !     to horiz_interp_spherical_new. The input variable must have
  !     allocated arrays. The returned variable will contain
  !     deallocated arrays.
  !   </INOUT>


  subroutine horiz_interp_spherical_del( Interp )

    type (horiz_interp_type), intent(inout) :: Interp

    if(associated(Interp%src_dist))  deallocate(Interp%src_dist)
    if(associated(Interp%num_found)) deallocate(Interp%num_found)
    if(associated(Interp%i_lon))     deallocate(Interp%i_lon)
    if(associated(Interp%j_lat))     deallocate(Interp%j_lat)

  end subroutine horiz_interp_spherical_del
  ! </SUBROUTINE>

  !#######################################################################


  subroutine radial_search(theta_src,phi_src,theta_dst,phi_dst, map_src_xsize, map_src_ysize, &
       map_src_add, map_src_dist, num_found, num_neighbors,max_src_dist,src_is_modulo)
    real,    intent(in),    dimension(:)   :: theta_src, phi_src
    real,    intent(in),    dimension(:,:) :: theta_dst, phi_dst
    integer, intent(in)                    :: map_src_xsize, map_src_ysize
    integer, intent(out), dimension(:,:,:) :: map_src_add
    real,    intent(out), dimension(:,:,:) :: map_src_dist
    integer, intent(inout), dimension(:,:) :: num_found
    integer, intent(in)                    :: num_neighbors
    real,    intent(in)                    :: max_src_dist
    logical, intent(in)                    :: src_is_modulo

    !---------- local variables ----------------------------------------
    integer, parameter :: max_nbrs = 50
    integer :: i, j, jj, i0, j0, n, l,i_left, i_right
    integer :: map_dst_xsize, map_dst_ysize
    integer :: i_left1, i_left2, i_right1, i_right2
    integer :: map_src_size, step, step_size, bound, bound_start, bound_end
    logical :: continue_search, result, continue_radial_search
    real    :: d, res
    !------------------------------------------------------------------
    map_dst_xsize=size(theta_dst,1);map_dst_ysize=size(theta_dst,2)
    map_src_size = map_src_xsize*map_src_ysize

    do j=1,map_dst_ysize
       do i=1,map_dst_xsize
          continue_search=.true.
          step = 1
          step_size = sqrt(real(map_src_size) )
          do while (continue_search .and. step_size > 0)
             do while (step <= map_src_size .and. continue_search)
                ! count land points as nearest neighbors
                d = spherical_distance(theta_dst(i,j),phi_dst(i,j),theta_src(step),phi_src(step))
                if (d <= max_src_dist) then
                   result = update_dest_neighbors(map_src_add(i,j,:),map_src_dist(i,j,:), &
                        step,d, num_found(i,j), num_neighbors )
                   if (result) then
                      n = 0
                      i0 = mod(step,map_src_xsize)

                      if (i0 == 0) i0 = map_src_xsize
                      res = float(step)/float(map_src_xsize)
                      j0 = ceiling(res)
                      continue_radial_search = .true.
                      do while (continue_radial_search)
                         continue_radial_search = .false.
                         n = n+1 ! radial counter
                         if(n > max_nbrs) exit
                         ! ************** left boundary *******************************
                         i_left = i0-n
                         if (i_left <= 0) then
                            if (src_is_modulo) then
                               i_left = map_src_xsize + i_left
                            else
                               i_left = 1
                            endif
                         endif

                         do l = 0, 2*n
                            jj = j0 - n - 1 + l
                            if( jj < 0) then
                               bound = ( 1 - jj )*map_src_xsize - i_left
                            else if ( jj >= map_src_ysize ) then
                               bound = ( 2*map_src_ysize - jj ) * map_src_xsize - i_left
                            else
                               bound = jj * map_src_xsize + i_left
                            endif

                            d = spherical_distance(theta_dst(i,j),phi_dst(i,j),theta_src(bound),phi_src(bound))
                            if(d<=max_src_dist) then
                               result = update_dest_neighbors(map_src_add(i,j,:),map_src_dist(i,j,:), &
                                    bound,d, num_found(i,j), num_neighbors)
                               if (result) continue_radial_search = .true.
                            endif
                         enddo

                         ! ***************************right boundary ******************************* 
                         i_right = i0+n
                         if (i_right > map_src_xsize) then
                            if (src_is_modulo) then
                               i_right = i_right - map_src_xsize
                            else
                               i_right = map_src_xsize
                            endif
                         endif

                         do l = 0, 2*n
                            jj = j0 - n - 1 + l
                            if( jj < 0) then
                               bound = ( 1 - jj )*map_src_xsize - i_right
                            else if ( jj >= map_src_ysize ) then
                               bound = ( 2*map_src_ysize - jj) * map_src_xsize - i_right

                            else
                               bound = jj * map_src_xsize + i_right
                            endif

                            d = spherical_distance(theta_dst(i,j),phi_dst(i,j),theta_src(bound),phi_src(bound))
                            if(d<=max_src_dist) then
                               result = update_dest_neighbors(map_src_add(i,j,:),map_src_dist(i,j,:), &
                                    bound,d, num_found(i,j), num_neighbors)
                               if (result) continue_radial_search = .true.
                            endif
                         enddo

                         ! ************************* bottom boundary **********************************
                         i_left2 = 0
                         if( i_left > i_right) then
                            i_left1 = 1
                            i_right1 = i_right
                            i_left2 = i_left
                            i_right2 = map_src_xsize
                         else
                            i_left1 = i_left
                            i_right1 = i_right                            
                         endif

                         jj = j0 - n - 1
                         if( jj < 0 ) then
                            bound_start = ( 1 - jj)*map_src_xsize - i_right1
                            bound_end   = ( 1 - jj)*map_src_xsize - i_left1
                         else
                            bound_start = jj * map_src_xsize + i_left1
                            bound_end = jj * map_src_xsize + i_right1
                         endif

                         bound = bound_start
                         do while (bound <= bound_end)
                            d = spherical_distance(theta_dst(i,j),phi_dst(i,j),theta_src(bound),phi_src(bound))
                            if(d<=max_src_dist) then
                               result = update_dest_neighbors(map_src_add(i,j,:),map_src_dist(i,j,:), &
                                    bound,d, num_found(i,j), num_neighbors)
                               if (result) continue_radial_search = .true.
                            endif
                            bound = bound + 1

                         enddo

                         if(i_left2 > 0 ) then
                            if( jj < 0 ) then
                               bound_start = ( 1 - jj)*map_src_xsize - i_right2
                               bound_end   = ( 1 - jj)*map_src_xsize - i_left2
                            else
                               bound_start = jj * map_src_xsize + i_left2
                               bound_end = jj * map_src_xsize + i_right2
                            endif

                            bound = bound_start
                            do while (bound <= bound_end)
                               d = spherical_distance(theta_dst(i,j),phi_dst(i,j),theta_src(bound),phi_src(bound))
                               if(d<=max_src_dist) then
                                  result = update_dest_neighbors(map_src_add(i,j,:),map_src_dist(i,j,:), &
                                       bound,d, num_found(i,j), num_neighbors)
                                  if (result) continue_radial_search = .true.
                               endif
                               bound = bound + 1
                            enddo
                         endif

                         ! ************************** top boundary ************************************
                         jj = j0 + n - 1
                         if( jj >= map_src_ysize) then
                            bound_start = ( 2*map_src_ysize - jj ) * map_src_xsize - i_right1
                            bound_end   = ( 2*map_src_ysize - jj ) * map_src_xsize - i_left1
                         else
                            bound_start = jj * map_src_xsize + i_left1
                            bound_end = jj * map_src_xsize + i_right1
                         endif

                         bound = bound_start
                         do while (bound <= bound_end)
                            d = spherical_distance(theta_dst(i,j),phi_dst(i,j),theta_src(bound),phi_src(bound))
                            if(d<=max_src_dist) then
                               result = update_dest_neighbors(map_src_add(i,j,:),map_src_dist(i,j,:), &
                                    bound,d, num_found(i,j), num_neighbors)
                               if (result) continue_radial_search = .true.
                            endif
                            bound = bound + 1
                         enddo

                         if(i_left2 > 0) then
                            if( jj >= map_src_ysize) then
                               bound_start = ( 2*map_src_ysize - jj ) * map_src_xsize - i_right2
                               bound_end   = ( 2*map_src_ysize - jj ) * map_src_xsize - i_left2
                            else
                               bound_start = jj * map_src_xsize + i_left2
                               bound_end = jj * map_src_xsize + i_right2
                            endif

                            bound = bound_start
                            do while (bound <= bound_end)
                               d = spherical_distance(theta_dst(i,j),phi_dst(i,j),theta_src(bound),phi_src(bound))
                               if(d<=max_src_dist) then
                                  result = update_dest_neighbors(map_src_add(i,j,:),map_src_dist(i,j,:), &
                                       bound,d, num_found(i,j), num_neighbors)
                                  if (result) continue_radial_search = .true.
                               endif
                               bound = bound + 1
                            enddo
                         endif

                      enddo
                      continue_search = .false. ! stop looking
                   endif
                endif
                step=step+step_size
             enddo ! search loop
             step = 1
             step_size = step_size/2
          enddo
       enddo
    enddo

    return

  end subroutine radial_search


  !#####################################################################

  function update_dest_neighbors(map_src_add, map_src_dist, src_add,d, num_found, min_nbrs)

    integer, intent(inout), dimension(:) :: map_src_add
    real, intent(inout),    dimension(:) :: map_src_dist
    integer, intent(in)                  :: src_add
    real, intent(in)                     :: d
    integer, intent(inout)               :: num_found
    integer, intent(in)                  :: min_nbrs

    logical :: update_dest_neighbors, already_exist = .false.

    integer :: n,m

    update_dest_neighbors = .false.

    n = 0
    NLOOP : do while ( n .le. num_found )
       n = n + 1
       DIST_CHK : if (d .le. map_src_dist(n)) then
          do m=n,num_found
             if (src_add == map_src_add(m)) then
                already_exist = .true.
                exit NLOOP
             endif
          enddo
          if(num_found < max_neighbors) then
             num_found = num_found + 1
          else
             call mpp_error(FATAL,'update_dest_neighbors: '// &
                  'number of neighbor points found is greated than maxium neighbor points' )
          endif
          do m=num_found,n+1,-1
             map_src_add(m) = map_src_add(m-1)
             map_src_dist(m) = map_src_dist(m-1)
          enddo
          map_src_add(n) = src_add
          map_src_dist(n) = d
          update_dest_neighbors = .true.
          if( num_found > min_nbrs ) then
             if( map_src_dist(num_found) > map_src_dist(num_found-1) ) then
                num_found = num_found - 1
             endif
             if( map_src_dist(min_nbrs+1) > map_src_dist(min_nbrs) ) then
                num_found = min_nbrs
             endif
          endif
          exit NLOOP ! n loop
       endif DIST_CHK
    end do NLOOP
    if(already_exist) return

    if( .not. update_dest_neighbors ) then
       if( num_found < min_nbrs ) then
          num_found               = num_found + 1
          update_dest_neighbors   = .true.
          map_src_add(num_found)  = src_add
          map_src_dist(num_found) = d
       endif
    endif


    return

  end function update_dest_neighbors

  !########################################################################
!  function spherical_distance(theta1,phi1,theta2,phi2)

!    real, intent(in) :: theta1, phi1, theta2, phi2
!    real :: spherical_distance

!    real :: r1(3), r2(3), cross(3), s, dot, ang

    ! this is a simple, enough way to calculate distance on the sphere
    ! first, construct cartesian vectors r1 and r2
    ! then calculate the cross-product which is proportional to the area
    ! between the 2 vectors.  The angular distance is arcsin of the 
    ! distancealong the sphere
    !
    ! theta is longitude and phi is latitude
    !


!    r1(1) = cos(theta1)*cos(phi1);r1(2)=sin(theta1)*cos(phi1);r1(3)=sin(phi1)
!    r2(1) = cos(theta2)*cos(phi2);r2(2)=sin(theta2)*cos(phi2);r2(3)=sin(phi2)

!    cross(1) = r1(2)*r2(3)-r1(3)*r2(2)
!    cross(2) = r1(3)*r2(1)-r1(1)*r2(3)
!    cross(3) = r1(1)*r2(2)-r1(2)*r2(1)

!    s = sqrt(cross(1)**2.+cross(2)**2.+cross(3)**2.)

!    s = min(s,1.0-epsln)

!    dot = r1(1)*r2(1) + r1(2)*r2(2) + r1(3)*r2(3)

!    if (dot > 0) then
!       ang = asin(s)
!    else if (dot < 0) then
!       ang = pi + asin(s)  !?  original is pi - asin(s)
!    else
!       ang = pi/2.
!    endif

!    spherical_distance = abs(ang) ! in radians

!    return

!  end function spherical_distance
  ! The great cycle distance
  function spherical_distance(theta1,phi1,theta2,phi2)

    real, intent(in) :: theta1, phi1, theta2, phi2
    real :: spherical_distance, dot

    if(theta1 == theta2 .and. phi1 == phi2) then
        spherical_distance = 0.0
        return
    endif
  
    dot = cos(phi1)*cos(phi2)*cos(theta1-theta2) + sin(phi1)*sin(phi2)
    if(dot > 1. ) dot = 1.
    if(dot < -1.) dot = -1.
    spherical_distance = acos(dot)

    return

  end function spherical_distance


  !#######################################################################

  subroutine full_search(theta_src,phi_src,theta_dst,phi_dst,map_src_add, map_src_dist,num_found, &
                         num_neighbors,max_src_dist)
    real,    intent(in),    dimension(:)   :: theta_src, phi_src
    real,    intent(in),    dimension(:,:) :: theta_dst, phi_dst
    integer, intent(out), dimension(:,:,:) :: map_src_add
    real,    intent(out), dimension(:,:,:) :: map_src_dist
    integer, intent(out), dimension(:,:)   :: num_found
    integer, intent(in)                    :: num_neighbors
    real, intent(in)                       :: max_src_dist

    integer :: i,j,map_src_size, step
    integer :: map_dst_xsize,map_dst_ysize
    real    :: d
    logical :: found

    map_dst_xsize=size(theta_dst,1);map_dst_ysize=size(theta_dst,2)
    map_src_size =size(theta_src(:))

    do j=1,map_dst_ysize
       do i=1,map_dst_xsize
          do step = 1, map_src_size
             d = spherical_distance(theta_dst(i,j),phi_dst(i,j),theta_src(step),phi_src(step))
             if( d <= max_src_dist) then
                found = update_dest_neighbors(map_src_add(i,j,:),map_src_dist(i,j,:), &
                     step,d,num_found(i,j), num_neighbors )
             endif
          enddo
       enddo
    enddo

  end subroutine full_search

  !#######################################################################


end module horiz_interp_spherical_mod

module check_mask_mod

  use mpp_mod,         only : stdout, mpp_error, WARNING, FATAL, mpp_pe, mpp_root_pe, get_unit
  use mpp_domains_mod, only : mpp_define_layout, mpp_compute_extent
  use fms_mod,         only : open_namelist_file, close_file, check_nml_error, file_exist, string

  implicit none 
  private

  !--- namelist interface
  integer :: max_pe = 128 
  integer :: halo = 1
  logical :: show_valid_only = .false.
  namelist /check_mask_nml/ max_pe, halo, show_valid_only
!--- namelist variables for OBC check----------------------------------------------

  integer, parameter :: max_obc = 4      ! maximum number of open boundaries (increase if want more)
  integer                               :: nobc= 0
  character(len=10), dimension(max_obc) :: direction='none' ! open directions; to be consistent with is, ie, js, je
  integer, dimension(max_obc)           :: is=-999, ie=-999, js=-999, je=-999     ! boundary position
  integer, dimension(max_obc)           :: nsmooth=2        ! number of points to be smoothed
  character(len=32), dimension(max_obc) :: name='none' 
  
  namelist /obc_nml/ nobc, direction, is, ie, js, je, nsmooth, name


  public :: checking_mask

contains

  subroutine checking_mask (wet_in, cyclic_x, cyclic_y, is_tripolar, have_obc)   
    real,     intent(in) :: wet_in(:,:)
    logical,  intent(in) :: cyclic_x, cyclic_y, is_tripolar
    logical,  intent(in) :: have_obc

    integer              :: unit, ierr, io, nx, ny
    integer, allocatable :: mask(:,:), mask_list(:,:), obc_error(:,:)
    integer, allocatable :: ibegin(:), iend(:), jbegin(:), jend(:)
    real,    allocatable :: wet(:,:)
    integer              :: isd, ied, jsd, jed
    integer              :: isc, iec, jsc, jec
    integer              :: isg, ieg, jsg, jeg
    integer              :: i, j, layout(2), no, np, nmask, n, ii, jj
    character(len=64)    :: formatstring
    logical              :: on_domain = .false.
    character(len=128)   :: tablefile
    integer              :: fileunit, io_stat

    if(file_exist('input.nml')) then
       unit = open_namelist_file ( )
       ierr=1
       do while (ierr /= 0)
          read  (unit, nml=check_mask_nml, iostat=io, end=10)
          ierr = check_nml_error(io,'check_mask_nml')  ! also initializes nml error codes
       enddo
10     call close_file (unit)
       unit = open_namelist_file ( )
       ierr=1
       do while (ierr /= 0)
          read  (unit, nml=obc_nml, iostat=io, end=20)
          ierr = check_nml_error(io,'obc_nml')  ! also initializes nml error codes
       enddo
20     call close_file (unit)
    endif

    layout = 0
    nx = size(wet_in,1)
    ny = size(wet_in,2)

    allocate(wet(1-halo:nx+halo,1-halo:ny+halo) )
    wet = 0.0
    wet(1:nx,1:ny) = wet_in(1:nx,1:ny)

    ! fill the global halo.
    if(cyclic_x) then
       wet(1-halo:0, 1:ny) = wet(nx-halo+1:nx, 1:ny)
       wet(nx+1:nx+halo, 1:ny) = wet(1:halo, 1:ny)
    end if

    if(cyclic_y) then
       wet(1:nx, 1-halo:0) = wet(1:nx,ny-halo+1:ny)
       wet(1:nx, ny+1:ny+halo) = wet(1:nx, 1:halo)
    end if

    if(is_tripolar) wet(1-halo:nx+halo,ny+1:ny+halo) = wet(nx+halo:1-halo:-1,ny:ny-halo+1:-1)

    write(stdout(),'(a)') 'Checking for possible masking:'
    write(stdout(),*)     'Assuming ',halo,' halo rows. '
    write(stdout(),*)     'Total domain size: ', nx, ny
    if(show_valid_only .and. have_obc) then
      write(stdout(),*)     'Only layouts valid with OBC are shown.'
    else
      if (have_obc) write(stdout(),*)     'Also layouts invalid with OBC are shown.'
    endif

    isg = 1 
    ieg = nx 
    jsg = 1 
    jeg = ny 

    do np = 4, min(max_pe,nx*ny)
       call mpp_define_layout((/1,nx,1,ny/),np,layout)
       if (layout(1) > nx .or. layout(2) > ny) cycle
       allocate ( mask(layout(1), layout(2)) )
       if (have_obc) allocate ( obc_error(layout(1), layout(2)) )
       allocate(ibegin(layout(1)), iend(layout(1)) )
       allocate(jbegin(layout(2)), jend(layout(2)) )
       call mpp_compute_extent(1,nx,layout(1),ibegin,iend)
       call mpp_compute_extent(1,ny,layout(2),jbegin,jend)

       mask   = 0
       if (have_obc) obc_error = 0
       do j = 1, layout(2)
          jsc = jbegin(j) 
          jec = jend(j) 
          jsd = jbegin(j) - halo
          jed = jend(j) + halo
          do i = 1, layout(1)
             isc = ibegin(i) 
             iec = iend(i) 
             isd = ibegin(i) - halo
             ied = iend(i) + halo
             if (ANY(wet(isd:ied,jsd:jed) > 0.5) ) mask(i,j) = 1
	     if (have_obc) then
	       do no=1, nobc
! check, if the open boundary is at a domain     
                 on_domain=.false.
		 do jj = jsd, jed
                   do ii = isd, ied
                    if(jj.ge.js(no).and.jj.le.je(no).and.ii.ge.is(no).and.ii.le.ie(no)) on_domain = .true.
                   enddo
                 enddo
		 if (.not.on_domain) cycle
! check, if the open boundary is at a domain halo	     
                 select case( trim(direction(no)) )
                 case ('west') 
                   if (isg /= isc) then
                     if ((is(no)-isc) < 0)    obc_error(i,j)=no
                   endif
                   if ((ied-is(no)) <= halo)  obc_error(i,j)=no
                 case ('east') 
                   if (ieg /= iec) then
                     if ((iec-is(no)) < 0)    obc_error(i,j)=no
                   endif
                   if ((is(n)-isd) <= halo)   obc_error(i,j)=no
                 case ('south') 
                   if (jsg /= jsc) then
                     if ((js(no)-jsc) < 0)    obc_error(i,j)=no
                   endif
                   if ((jec-js(no)) <= halo)  obc_error(i,j)=no
                 case ('north')
		   if (jeg /= jec) then
                     if ((jec-js(no)) < 0)    obc_error(i,j)=no
                   endif
                   if ((js(no)-jsc) <= halo)  obc_error(i,j)=no
                 end select
	       enddo
	     endif
          enddo
       enddo

       nmask = count(mask == 0)
       if(nmask > 0) then
          allocate(mask_list(2, nmask))
          n = 0
          do j = 1, layout(2)
             do i = 1, layout(1)
                if(mask(i,j) == 0) then
                   n = n + 1
                   mask_list(1,n) = i
                   mask_list(2,n) = j
                end if
             end do
          end do

          if(nmask == np) call mpp_error(WARNING, "check_mask_mod: all points are land")
          if(show_valid_only .and. have_obc) then 
	    if(ANY(obc_error > 0)) then
              deallocate(ibegin, iend, jbegin, jend)
	      deallocate(mask, obc_error)
              deallocate(mask_list)
	      cycle
	    endif    
	  endif    

          ! write the n_mask, layout_mask and mask_list information to a table file
          if(mpp_pe() == mpp_root_pe()) then
             tablefile = "mask_table."//trim(string(nmask))//"."//trim(string(layout(1)))//"x"//trim(string(layout(2)))
             fileunit = get_unit()
             open(unit=fileunit, file=trim(tablefile), iostat=io_stat)
             if(io_stat .NE. 0) call mpp_error(FATAL,"check_mask: error in opening file"//trim(tablefile) )
             write(fileunit, *)trim(string(nmask))
             write(fileunit,*)trim(string(layout(1))), " , ", trim(string(layout(2)))
             do n = 1, nmask
                write(fileunit,*) trim(string(mask_list(1,n))), ",", trim(string(mask_list(2,n)))
             enddo
             close(unit=fileunit, iostat=io_stat)
             if(io_stat .NE. 0) call mpp_error(FATAL,"check_mask: error in closing file"//trim(tablefile) )
          endif

          write(stdout(),*) '_______________________________________________________________________'
          write(stdout(),*) 'Possible setting to mask out all-land points region, for use in coupler_nml'
          write(stdout(),'((a),i4)') 'Total number of domains                                  ', np 
          write(stdout(),'((a),i4)') 'Number of tasks (excluded all-land region) to be used is ', np - nmask
          write(stdout(),'((a),i4)') 'Number of regions to be masked out                       ', nmask
          write(stdout(),'((a),2i4)') 'The layout is                                           ', layout
!          write(stdout(),*) 'The list of masked region mask_list is ( specified x-layout and y-layout)'
!          write(stdout(),*) 'mask_list = ', mask_list
          write(stdout(),*) 'Masked and used tasks, 1: used, 0: masked'
	  write(formatstring,*) "(",layout(2),"(2x,",layout(1),"i1,/))"
          write(stdout(),formatstring) ((mask(i,j),i=1,layout(1)),j=layout(2),1,-1)
          if (have_obc .and. ANY(obc_error > 0)) then
	     write(stdout(),*) 'OBC at halos is not allowed yet. Do not use this configuration.'
	     write(stdout(),formatstring) ((obc_error(i,j),i=1,layout(1)),j=layout(2),1,-1)
          endif
	  write(*,*) ' domain decomposition'
          write (*,110) (iend(i)-ibegin(i)+1, i= 1, layout(1))
          write (*,120) (jend(i)-jbegin(i)+1, i= 1, layout(2))
110       format ('  X-AXIS = ',24i4,/,(11x,24i4))
120       format ('  Y-AXIS = ',24i4,/,(11x,24i4))
          write(stdout(),*) 'used, masked, layout ', np - nmask, nmask, layout 
          write(stdout(),*) ' '
          write(stdout(),*) 'To chose this mask layout please put the following lines in coupler_nml '
          write(stdout(),130) nmask
          write(stdout(),140) layout(1), layout(2)
          if (nmask > 1) then
	    write(formatstring,*) "('     mask_list = ',i0,',',i0,",nmask-1,"(',',i0,',',i0))"
          else
	    write(formatstring,*) "('     mask_list = ',i0,',',i0)"
	  endif
          write(stdout(),trim(formatstring)) ((mask_list(i,j),i=1,2),j=1,nmask)
130       format ('     n_mask = ',i4)
140       format ('     layout_mask = ',i4,',',i4)
          deallocate(mask_list)
       end if
       deallocate(ibegin, iend, jbegin, jend)
       deallocate (mask)
       if (have_obc) deallocate (obc_error)
    enddo

    return

  end subroutine checking_mask


end module check_mask_mod

! program to check mask for existing grid file.

#ifdef check_mask
program check_mask_driver
  use mpp_mod,        only : stdout
  use mpp_io_mod,     only : mpp_open,  MPP_RDONLY, MPP_NETCDF, MPP_MULTI, MPP_SINGLE
  use mpp_io_mod,     only : mpp_get_info, atttype, mpp_get_atts, mpp_close
  use mpp_io_mod,     only : mpp_get_att_name, mpp_get_att_char
  use fms_mod,        only : open_namelist_file, close_file, check_nml_error, file_exist
  use fms_mod,        only : fms_init, fms_end, field_size, read_data
  use check_mask_mod, only : checking_mask
implicit none

  integer :: dims(4), unit, ierr, io, ndim, nvar, natt, ntime, i, ni, nj
  logical :: cyclic_x, cyclic_y, is_tripolar
  type(atttype), allocatable :: global_atts(:)
  real,          allocatable :: wet(:,:)
  logical                    :: have_obc = .false.
  character(len=128) :: grid_file = "INPUT/grid_spec.nc"
  namelist /check_mask_driver_nml/ grid_file, have_obc


  call fms_init()

  if(file_exist('input.nml')) then
     unit = open_namelist_file ( )
     ierr=1
     do while (ierr /= 0)
        read  (unit, nml=check_mask_driver_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'check_mask_driver_nml')  ! also initializes nml error codes
     enddo
10   call close_file (unit)
  endif

  ! get boundary condition

  call mpp_open(unit,trim(grid_file),MPP_RDONLY,MPP_NETCDF,threading=MPP_MULTI,fileset=MPP_SINGLE)
  call mpp_get_info(unit, ndim, nvar, natt, ntime)

  cyclic_x = .FALSE.
  cyclic_y = .FALSE.
  is_tripolar = .FALSE.
  allocate(global_atts(natt))
  call mpp_get_atts(unit,global_atts)
  do i=1,natt
     select case (trim(mpp_get_att_name(global_atts(i))))
     case ('x_boundary_type')
        if (trim(mpp_get_att_char(global_atts(i))) == 'cyclic') cyclic_x = .true.
     case ('y_boundary_type')
        if (trim(mpp_get_att_char(global_atts(i))) == 'fold_north_edge') then
           is_tripolar = .true.
        else if(trim(mpp_get_att_char(global_atts(i))) == 'cyclic')  then
           cyclic_y = .true.
        end if
     end select
  end do

  deallocate(global_atts)
  call mpp_close(unit)

  ! read land/sea mask information from grid file.
  call field_size(grid_file, 'wet', dims )
  ni = dims(1)
  nj = dims(2)
  allocate(wet(ni,nj))
  call read_data(grid_file, 'wet', wet  )
  call checking_mask(wet, cyclic_x, cyclic_y, is_tripolar, have_obc) ! The namelist for obc is read in checking_mask
  write(stdout(),*) " successfully run program check_mask"

  call fms_end()

end program check_mask_driver

#endif

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: cosp_modis_simulator.F90,v 20.0 2013/12/13 23:15:47 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) 2009, Regents of the Unversity of Colorado
!   Author: Robert Pincus, Cooperative Institute for Research in the Environmental Sciences
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!

!
! History:
!   May 2009 - Robert Pincus - Initial version
!   Dec 2009 - Robert Pincus - Tiny revisions
!
MODULE MOD_COSP_Modis_Simulator
  USE MOD_COSP_CONSTANTS
  USE MOD_COSP_TYPES
  use mod_modis_sim, numModisTauBins      => numTauHistogramBins,      &
                     numModisPressureBins => numPressureHistogramBins, &
                     MODIS_TAU      => nominalTauHistogramCenters,     &
                     MODIS_TAU_BNDS => nominalTauHistogramBoundaries,  &
                     MODIS_PC       => nominalPressureHistogramCenters, &
                     MODIS_PC_BNDS  => nominalPressureHistogramBoundaries                     
  implicit none
  !------------------------------------------------------------------------------------------------
  ! Public type
  !
  ! Summary statistics from MODIS retrievals
  type COSP_MODIS
     ! Dimensions
     integer :: Npoints   ! Number of gridpoints
#ifdef COSP_GFDL
     integer :: Ncolumns  ! Number of columns
#endif
     
     !
     ! Grid means; dimension nPoints
     ! 
     real, dimension(:),       pointer :: & 
       Cloud_Fraction_Total_Mean,       Cloud_Fraction_Water_Mean,       Cloud_Fraction_Ice_Mean,       &
       Cloud_Fraction_High_Mean,        Cloud_Fraction_Mid_Mean,         Cloud_Fraction_Low_Mean,       &
       Optical_Thickness_Total_Mean,    Optical_Thickness_Water_Mean,    Optical_Thickness_Ice_Mean,    &
       Optical_Thickness_Total_LogMean, Optical_Thickness_Water_LogMean, Optical_Thickness_Ice_LogMean, &
                                        Cloud_Particle_Size_Water_Mean,  Cloud_Particle_Size_Ice_Mean,  &
       Cloud_Top_Pressure_Total_Mean,                                                                   &
                                        Liquid_Water_Path_Mean,          Ice_Water_Path_Mean

#ifdef COSP_GFDL
      !  Subcolumn particle sizes, optical thickness and cloud top pressure
      !  dimensions (npoints, ncolumns)
      real, dimension(:,:),       pointer :: &
        Column_Particle_Size, Column_Optical_Thickness, &
        Column_Cloud_Top_Pressure, &
        retrievedPhase
#endif

     !
     ! Also need the ISCCP-type optical thickness/cloud top pressure histogram
     !
     real, dimension(:, :, :), pointer :: Optical_Thickness_vs_Cloud_Top_Pressure
  end type COSP_MODIS 
  
contains
  !------------------------------------------------------------------------------------------------
#ifdef COSP_GFDL
  subroutine COSP_Modis_Simulator(gridBox, subCols, subcolHydro, isccpSim, nSunlit, modisSim)
#else
  subroutine COSP_Modis_Simulator(gridBox, subCols, subcolHydro, isccpSim, modisSim)
#endif
    ! Arguments
    type(cosp_gridbox), intent(in   ) :: gridBox     ! Gridbox info
    type(cosp_subgrid), intent(in   ) :: subCols     ! subCol indicators of convective/stratiform 
    type(cosp_sghydro), intent(in   ) :: subcolHydro ! subcol hydrometeor contens
    type(cosp_isccp),   intent(in   ) :: isccpSim    ! ISCCP simulator output
#ifdef COSP_GFDL
    integer,            intent(in   ) :: nSunlit     ! Are there any sunlit points?
#endif 
    type(cosp_modis),   intent(  out) :: modisSim    ! MODIS simulator subcol output
    
    ! ------------------------------------------------------------
    ! Local variables 
    !   Leave space only for sunlit points
    
#ifdef COSP_GFDL
    integer :: nPoints, nSubCols, nLevels, i
#else
    integer :: nPoints, nSubCols, nLevels, nSunlit, i
#endif
    
#ifdef COSP_GFDL
    ! Grid-mean quanties;  dimensions nPoints, nLevels
    real, &
      dimension(nSunlit,                  gridBox%nLevels) :: &
        temperature, pressureLayers
    real, &
      dimension(nSunlit,                  gridBox%nLevels + 1) :: &
        pressureLevels

    ! Subcol quantities, dimension nPoints, nSubCols, nLevels
    real, &
      dimension(nSunlit, subCols%nColumns, gridBox%nLevels) :: &
         opticalThickness, cloudWater, cloudIce, waterSize, iceSize, &
         liquid_opticalThickness, ice_opticalThickness

    ! Vertically-integrated subcol quantities; dimensions nPoints, nSubcols
    integer, &
      dimension(nSunlit, subCols%nColumns) :: &
        retrievedPhase
    real, &
      dimension(nSunlit, subCols%nColumns) :: &
        isccpTau, isccpCloudTopPressure, retrievedCloudTopPressure, retrievedTau, retrievedSize

    ! Vertically-integrated results
    real, dimension(nSunlit) :: &
        cfTotal, cfLiquid, cfIce,                &
        cfHigh,  cfMid,    cfLow,                &
        meanTauTotal, meanTauLiquid, meanTauIce, &
        meanLogTauTotal, meanLogTauLiquid, meanLogTauIce , &
        meanSizeLiquid, meanSizeIce,             &
        meanCloudTopPressure,                    &
        meanLiquidWaterPath, meanIceWaterPath

    real, dimension(nSunlit, numModisTauBins, numModisPressureBins) :: &
       jointHistogram

    integer, dimension(nSunlit) :: sunlit
    integer, dimension(:), allocatable :: notSunlit
#else
    ! Grid-mean quanties;  dimensions nPoints, nLevels
    real, &
      dimension(count(gridBox%sunlit(:) > 0),                  gridBox%nLevels) :: &
        temperature, pressureLayers
    real, &
      dimension(count(gridBox%sunlit(:) > 0),                  gridBox%nLevels + 1) :: &
        pressureLevels
    
    ! Subcol quantities, dimension nPoints, nSubCols, nLevels 
    real, &
      dimension(count(gridBox%sunlit(:) > 0), subCols%nColumns, gridBox%nLevels) :: & 
        opticalThickness, cloudWater, cloudIce, waterSize, iceSize
    
    ! Vertically-integrated subcol quantities; dimensions nPoints, nSubcols 
    integer, &
      dimension(count(gridBox%sunlit(:) > 0), subCols%nColumns) :: & 
        retrievedPhase
    real, &
      dimension(count(gridBox%sunlit(:) > 0), subCols%nColumns) :: & 
        isccpTau, isccpCloudTopPressure, retrievedCloudTopPressure, retrievedTau, retrievedSize  
    
    ! Vertically-integrated results
    real, dimension(count(gridBox%sunlit(:) > 0)) :: & 
        cfTotal, cfLiquid, cfIce,                &
        cfHigh,  cfMid,    cfLow,                &
        meanTauTotal, meanTauLiquid, meanTauIce, &
        meanLogTauTotal, meanLogTauLiquid, meanLogTauIce , &
        meanSizeLiquid, meanSizeIce,             &
        meanCloudTopPressure,                    &
        meanLiquidWaterPath, meanIceWaterPath
        
    real, dimension(count(gridBox%sunlit(:) > 0), numModisTauBins, numModisPressureBins) :: & 
       jointHistogram
    
    integer, dimension(count(gridBox%sunlit(:) >  0)) :: sunlit
    integer, dimension(count(gridBox%sunlit(:) <= 0)) :: notSunlit
#endif
    ! ------------------------------------------------------------
    
    !
    ! Are there any sunlit points? 
    !
#ifdef COSP_GFDL
    allocate(notSunlit(count(gridBox%sunlit(:) <= 0)))
#else
    nSunlit = count(gridBox%sunlit(:) > 0)
#endif
    if(nSunlit > 0) then 
      nLevels  = gridBox%Nlevels
      nPoints  = gridBox%Npoints
      nSubCols = subCols%Ncolumns
      !
      ! This is a vector index indicating which points are sunlit
      !
      sunlit(:)    = pack((/ (i, i = 1, nPoints ) /), mask =       gridBox%sunlit(:) > 0)
      notSunlit(:) = pack((/ (i, i = 1, nPoints ) /), mask = .not. gridBox%sunlit(:) > 0)
               
      !
      ! Copy needed quantities, reversing vertical order and removing points with no sunlight 
      !
      pressureLevels(:, 1) = 0.0 ! Top of model, following ISCCP sim
      temperature(:, :)     = gridBox%T (sunlit(:), nLevels:1:-1) 
      pressureLayers(:, :)  = gridBox%p (sunlit(:), nLevels:1:-1) 
      pressureLevels(:, 2:) = gridBox%ph(sunlit(:), nLevels:1:-1) 
      
      !
      ! Subcolumn properties - first stratiform cloud...
      ! 
#ifdef COSP_GFDL
      if (subCols%cols_input_from_model) then
      ! Use stochastic column taus
      opticalThickness(:, :, :) = subCols%dtau_col(sunlit(:),:,:)
      where(subCols%frac_out(sunlit(:), :, :) == I_LSC)
        cloudWater(:, :, :) = subcolHydro%mr_hydro(sunlit(:), :, :, I_LSCLIQ)
        waterSize (:, :, :) = subcolHydro%reff    (sunlit(:), :, :, I_LSCLIQ)
        cloudIce  (:, :, :) = subcolHydro%mr_hydro(sunlit(:), :, :, I_LSCICE)
        iceSize   (:, :, :) = subcolHydro%reff    (sunlit(:), :, :, I_LSCICE)
      elsewhere
        cloudWater      (:, :, :) = 0.
        cloudIce        (:, :, :) = 0.
        waterSize       (:, :, :) = 0.
        iceSize         (:, :, :) = 0.
      end where

      !
      ! .. then add convective cloud
      !
       where(subCols%frac_out(sunlit(:), :, :) == I_CVC)
        cloudWater(:, :, :) = subcolHydro%mr_hydro(sunlit(:), :, :, I_CVCLIQ)
        waterSize (:, :, :) = subcolHydro%reff    (sunlit(:), :, :, I_CVCLIQ)
        cloudIce  (:, :, :) = subcolHydro%mr_hydro(sunlit(:), :, :, I_CVCICE)
        iceSize   (:, :, :) = subcolHydro%reff    (sunlit(:), :, :, I_CVCICE)
      end where
      else
#endif
      where(subCols%frac_out(sunlit(:), :, :) == I_LSC)
        opticalThickness(:, :, :) = & 
                       spread(gridBox%dtau_s      (sunlit(:),    :), dim = 2, nCopies = nSubCols)
        cloudWater(:, :, :) = subcolHydro%mr_hydro(sunlit(:), :, :, I_LSCLIQ)
        waterSize (:, :, :) = subcolHydro%reff    (sunlit(:), :, :, I_LSCLIQ)
        cloudIce  (:, :, :) = subcolHydro%mr_hydro(sunlit(:), :, :, I_LSCICE)
        iceSize   (:, :, :) = subcolHydro%reff    (sunlit(:), :, :, I_LSCICE)
      elsewhere
        opticalThickness(:, :, :) = 0.
        cloudWater      (:, :, :) = 0.
        cloudIce        (:, :, :) = 0.
        waterSize       (:, :, :) = 0.
        iceSize         (:, :, :) = 0.
      end where 
      !
      ! .. then add convective cloud 
      !
      where(subCols%frac_out(sunlit(:), :, :) == I_CVC) 
        opticalThickness(:, :, :) = &
                       spread(gridBox%dtau_c(      sunlit(:),    :), dim = 2, nCopies = nSubCols)
        cloudWater(:, :, :) = subcolHydro%mr_hydro(sunlit(:), :, :, I_CVCLIQ)
        waterSize (:, :, :) = subcolHydro%reff    (sunlit(:), :, :, I_CVCLIQ)
        cloudIce  (:, :, :) = subcolHydro%mr_hydro(sunlit(:), :, :, I_CVCICE)
        iceSize   (:, :, :) = subcolHydro%reff    (sunlit(:), :, :, I_CVCICE)
      end where
#ifdef COSP_GFDL
     endif
#endif
      !
      ! Reverse vertical order 
      !
#ifdef COSP_GFDL
      ! Optical thickness need not be reversed when using subcolumn values
#else
      opticalThickness(:, :, :)  = opticalThickness(:, :, nLevels:1:-1)
#endif
      cloudWater      (:, :, :)  = cloudWater      (:, :, nLevels:1:-1)
      waterSize       (:, :, :)  = waterSize       (:, :, nLevels:1:-1)
      cloudIce        (:, :, :)  = cloudIce        (:, :, nLevels:1:-1)
      iceSize         (:, :, :)  = iceSize         (:, :, nLevels:1:-1)
      
      isccpTau(:, :)              = isccpSim%boxtau (sunlit(:), :)
      isccpCloudTopPressure(:, :) = isccpSim%boxptop(sunlit(:), :)
      
      do i = 1, nSunlit
        call modis_L2_simulator(temperature(i, :), pressureLayers(i, :), pressureLevels(i, :),     &
                                opticalThickness(i, :, :), cloudWater(i, :, :), cloudIce(i, :, :), &
                                waterSize(i, :, :), iceSize(i, :, :),                       &
                                isccpTau(i, :), isccpCloudTopPressure(i, :),                &
                                retrievedPhase(i, :), retrievedCloudTopPressure(i, :),      & 
                                retrievedTau(i, :), retrievedSize(i, :))
      end do
      call modis_L3_simulator(retrievedPhase,              &
                              retrievedCloudTopPressure,   &
                              retrievedTau, retrievedSize, &
                              cfTotal,         cfLiquid,         cfIce,         &
                              cfHigh,          cfMid,            cfLow,         &
                              meanTauTotal,    meanTauLiquid,    meanTauIce,    &
                              meanLogTauTotal, meanLogTauLiquid, meanLogTauIce, &
                                               meanSizeLiquid,   meanSizeIce,   &
                              meanCloudTopPressure,                             &
                                               meanLiquidWaterPath, meanIceWaterPath, &
                              jointHistogram)
      !
      ! Copy results into COSP structure
      !
      modisSim%Cloud_Fraction_Total_Mean(sunlit(:)) = cfTotal(:)
      modisSim%Cloud_Fraction_Water_Mean(sunlit(:)) = cfLiquid
      modisSim%Cloud_Fraction_Ice_Mean  (sunlit(:)) = cfIce
  
      modisSim%Cloud_Fraction_High_Mean(sunlit(:)) = cfHigh
      modisSim%Cloud_Fraction_Mid_Mean (sunlit(:)) = cfMid
      modisSim%Cloud_Fraction_Low_Mean (sunlit(:)) = cfLow
  
      modisSim%Optical_Thickness_Total_Mean(sunlit(:)) = meanTauTotal
      modisSim%Optical_Thickness_Water_Mean(sunlit(:)) = meanTauLiquid
      modisSim%Optical_Thickness_Ice_Mean  (sunlit(:)) = meanTauIce
  
      modisSim%Optical_Thickness_Total_LogMean(sunlit(:)) = meanLogTauTotal
      modisSim%Optical_Thickness_Water_LogMean(sunlit(:)) = meanLogTauLiquid
      modisSim%Optical_Thickness_Ice_LogMean  (sunlit(:)) = meanLogTauIce
  
      modisSim%Cloud_Particle_Size_Water_Mean(sunlit(:)) = meanSizeLiquid
      modisSim%Cloud_Particle_Size_Ice_Mean  (sunlit(:)) = meanSizeIce
  
      modisSim%Cloud_Top_Pressure_Total_Mean(sunlit(:)) = meanCloudTopPressure
  
      modisSim%Liquid_Water_Path_Mean(sunlit(:)) = meanLiquidWaterPath
      modisSim%Ice_Water_Path_Mean   (sunlit(:)) = meanIceWaterPath
      
#ifdef COSP_GFDL
      modisSim%Column_Particle_Size(sunlit(:),:) = RetrievedSize(:,:)
      modisSim%retrievedPhase      (sunlit(:),:) = RetrievedPhase(:,:)
      modisSim%Column_Optical_Thickness(sunlit(:),:) = RetrievedTau(:,:)
      modisSim%Column_Cloud_Top_Pressure(sunlit(:),:) = RetrievedCloudTopPressure(:,:)

#endif
      modisSim%Optical_Thickness_vs_Cloud_Top_Pressure(sunlit(:), 2:numModisTauBins+1, :) = jointHistogram(:, :, :)
      ! 
      ! Reorder pressure bins in joint histogram to go from surface to TOA 
      !
      modisSim%Optical_Thickness_vs_Cloud_Top_Pressure(:,:,:) = &
        modisSim%Optical_Thickness_vs_Cloud_Top_Pressure(:, :, numModisPressureBins:1:-1)
      if(nSunlit < nPoints) then 
        !
        ! Where it's night and we haven't done the retrievals the values are undefined
        !
        modisSim%Cloud_Fraction_Total_Mean(notSunlit(:)) = R_UNDEF
        modisSim%Cloud_Fraction_Water_Mean(notSunlit(:)) = R_UNDEF
        modisSim%Cloud_Fraction_Ice_Mean  (notSunlit(:)) = R_UNDEF
    
        modisSim%Cloud_Fraction_High_Mean(notSunlit(:)) = R_UNDEF
        modisSim%Cloud_Fraction_Mid_Mean (notSunlit(:)) = R_UNDEF
        modisSim%Cloud_Fraction_Low_Mean (notSunlit(:)) = R_UNDEF

        modisSim%Optical_Thickness_Total_Mean(notSunlit(:)) = R_UNDEF
        modisSim%Optical_Thickness_Water_Mean(notSunlit(:)) = R_UNDEF
        modisSim%Optical_Thickness_Ice_Mean  (notSunlit(:)) = R_UNDEF
    
        modisSim%Optical_Thickness_Total_LogMean(notSunlit(:)) = R_UNDEF
        modisSim%Optical_Thickness_Water_LogMean(notSunlit(:)) = R_UNDEF
        modisSim%Optical_Thickness_Ice_LogMean  (notSunlit(:)) = R_UNDEF
    
        modisSim%Cloud_Particle_Size_Water_Mean(notSunlit(:)) = R_UNDEF
        modisSim%Cloud_Particle_Size_Ice_Mean  (notSunlit(:)) = R_UNDEF
    
        modisSim%Cloud_Top_Pressure_Total_Mean(notSunlit(:)) = R_UNDEF
    
        modisSim%Liquid_Water_Path_Mean(notSunlit(:)) = R_UNDEF
        modisSim%Ice_Water_Path_Mean   (notSunlit(:)) = R_UNDEF
#ifdef COSP_GFDL
        modisSim%Column_Particle_Size(notSunlit(:),:) = R_UNDEF
        modisSim%retrievedPhase(notSunlit(:),:) = R_UNDEF
        modisSim%Column_Optical_Thickness(notSunlit(:),:) = R_UNDEF
        modisSim%Column_Cloud_Top_Pressure(notSunlit(:),:) = R_UNDEF
#endif
  
        modisSim%Optical_Thickness_vs_Cloud_Top_Pressure(notSunlit(:), :, :) = R_UNDEF
      end if 
    else
      !
      ! It's nightime everywhere - everything is undefined
      !
      modisSim%Cloud_Fraction_Total_Mean(:) = R_UNDEF
      modisSim%Cloud_Fraction_Water_Mean(:) = R_UNDEF
      modisSim%Cloud_Fraction_Ice_Mean  (:) = R_UNDEF
  
      modisSim%Cloud_Fraction_High_Mean(:) = R_UNDEF
      modisSim%Cloud_Fraction_Mid_Mean (:) = R_UNDEF
      modisSim%Cloud_Fraction_Low_Mean (:) = R_UNDEF

      modisSim%Optical_Thickness_Total_Mean(:) = R_UNDEF
      modisSim%Optical_Thickness_Water_Mean(:) = R_UNDEF
      modisSim%Optical_Thickness_Ice_Mean  (:) = R_UNDEF
  
      modisSim%Optical_Thickness_Total_LogMean(:) = R_UNDEF
      modisSim%Optical_Thickness_Water_LogMean(:) = R_UNDEF
      modisSim%Optical_Thickness_Ice_LogMean  (:) = R_UNDEF
  
      modisSim%Cloud_Particle_Size_Water_Mean(:) = R_UNDEF
      modisSim%Cloud_Particle_Size_Ice_Mean  (:) = R_UNDEF
  
      modisSim%Cloud_Top_Pressure_Total_Mean(:) = R_UNDEF
  
      modisSim%Liquid_Water_Path_Mean(:) = R_UNDEF
      modisSim%Ice_Water_Path_Mean   (:) = R_UNDEF
  
#ifdef COSP_GFDL
      modisSim%Column_Particle_Size(:,:) = R_UNDEF
      modisSim%retrievedPhase      (:,:) = R_UNDEF
      modisSim%Column_Optical_Thickness(:,:) = R_UNDEF
      modisSim%Column_Cloud_Top_Pressure(:,:) = R_UNDEF
#endif

      modisSim%Optical_Thickness_vs_Cloud_Top_Pressure(:, :, :) = R_UNDEF
    end if 

#ifdef COSP_GFDL
    deallocate (notSunlit)
#endif

  end subroutine COSP_Modis_Simulator
  !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  !------------- SUBROUTINE CONSTRUCT_COSP_MODIS ------------------
  !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#ifdef COSP_GFDL
  SUBROUTINE CONSTRUCT_COSP_MODIS(cfg, nPoints, nColumns, x)
#else
  SUBROUTINE CONSTRUCT_COSP_MODIS(cfg, nPoints, x)
#endif
    type(cosp_config), intent(in)  :: cfg ! Configuration options
    integer,           intent(in)  :: Npoints  ! Number of sampled points
#ifdef COSP_GFDL
    integer,           intent(in)  :: Ncolumns  ! Number of subgrid columns
#endif
    type(cosp_MODIS),  intent(out) :: x
    !
    ! Allocate minumum storage if simulator not used
    !
    if (cfg%LMODIS_sim) then
      x%nPoints  = nPoints
#ifdef COSP_GFDL
      x%nColumns  = nColumns
#endif
    else
      x%Npoints  = 1
#ifdef COSP_GFDL
      x%Ncolumns  = 1
#endif
    endif
    
    ! --- Allocate arrays ---
    allocate(x%Cloud_Fraction_Total_Mean(x%nPoints)) 
    allocate(x%Cloud_Fraction_Water_Mean(x%nPoints)) 
    allocate(x%Cloud_Fraction_Ice_Mean(x%nPoints)) 
    
    allocate(x%Cloud_Fraction_High_Mean(x%nPoints)) 
    allocate(x%Cloud_Fraction_Mid_Mean(x%nPoints)) 
    allocate(x%Cloud_Fraction_Low_Mean(x%nPoints)) 
    
    allocate(x%Optical_Thickness_Total_Mean(x%nPoints)) 
    allocate(x%Optical_Thickness_Water_Mean(x%nPoints)) 
    allocate(x%Optical_Thickness_Ice_Mean(x%nPoints)) 
    
    allocate(x%Optical_Thickness_Total_LogMean(x%nPoints)) 
    allocate(x%Optical_Thickness_Water_LogMean(x%nPoints)) 
    allocate(x%Optical_Thickness_Ice_LogMean(x%nPoints)) 
    
    allocate(x%Cloud_Particle_Size_Water_Mean(x%nPoints)) 
    allocate(x%Cloud_Particle_Size_Ice_Mean(x%nPoints)) 
    
    allocate(x%Cloud_Top_Pressure_Total_Mean(x%nPoints)) 
    
    allocate(x%Liquid_Water_Path_Mean(x%nPoints)) 
    allocate(x%Ice_Water_Path_Mean(x%nPoints)) 
      
#ifdef COSP_GFDL
    allocate(x%Column_Particle_Size(x%nPoints,x%nColumns))
    allocate(x%retrievedPhase      (x%nPoints,x%nColumns))
    allocate(x%Column_Optical_Thickness(x%nPoints,x%nColumns))
    allocate(x%Column_Cloud_Top_Pressure(x%nPoints,x%nColumns))
#endif
    allocate(x%Optical_Thickness_vs_Cloud_Top_Pressure(nPoints, numModisTauBins+1, numModisPressureBins))
    x%Optical_Thickness_vs_Cloud_Top_Pressure(:, :, :) = R_UNDEF
  END SUBROUTINE CONSTRUCT_COSP_MODIS

  !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  !------------- SUBROUTINE FREE_COSP_MODIS -----------------------
  !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE FREE_COSP_MODIS(x)
    type(cosp_MODIS),intent(inout) :: x
    !
    ! Free space used by cosp_modis variable. 
    !
    
    if(associated(x%Cloud_Fraction_Total_Mean)) deallocate(x%Cloud_Fraction_Total_Mean) 
    if(associated(x%Cloud_Fraction_Water_Mean)) deallocate(x%Cloud_Fraction_Water_Mean) 
    if(associated(x%Cloud_Fraction_Ice_Mean  )) deallocate(x%Cloud_Fraction_Ice_Mean) 
    
    if(associated(x%Cloud_Fraction_High_Mean)) deallocate(x%Cloud_Fraction_High_Mean) 
    if(associated(x%Cloud_Fraction_Mid_Mean )) deallocate(x%Cloud_Fraction_Mid_Mean) 
    if(associated(x%Cloud_Fraction_Low_Mean )) deallocate(x%Cloud_Fraction_Low_Mean) 
    
    if(associated(x%Optical_Thickness_Total_Mean)) deallocate(x%Optical_Thickness_Total_Mean) 
    if(associated(x%Optical_Thickness_Water_Mean)) deallocate(x%Optical_Thickness_Water_Mean) 
    if(associated(x%Optical_Thickness_Ice_Mean  )) deallocate(x%Optical_Thickness_Ice_Mean) 
    
    if(associated(x%Optical_Thickness_Total_LogMean)) deallocate(x%Optical_Thickness_Total_LogMean) 
    if(associated(x%Optical_Thickness_Water_LogMean)) deallocate(x%Optical_Thickness_Water_LogMean) 
    if(associated(x%Optical_Thickness_Ice_LogMean  )) deallocate(x%Optical_Thickness_Ice_LogMean) 
    
    if(associated(x%Cloud_Particle_Size_Water_Mean)) deallocate(x%Cloud_Particle_Size_Water_Mean) 
    if(associated(x%Cloud_Particle_Size_Ice_Mean  )) deallocate(x%Cloud_Particle_Size_Ice_Mean) 
    
    if(associated(x%Cloud_Top_Pressure_Total_Mean )) deallocate(x%Cloud_Top_Pressure_Total_Mean   ) 
    
    if(associated(x%Liquid_Water_Path_Mean)) deallocate(x%Liquid_Water_Path_Mean   ) 
    if(associated(x%Ice_Water_Path_Mean   )) deallocate(x%Ice_Water_Path_Mean   ) 
    
#ifdef COSP_GFDL
    if(associated(x%Column_Particle_Size  )) deallocate(x%Column_Particle_Size  )
    if(associated(x%retrievedPhase        )) deallocate(x%retrievedPhase )
    if(associated(x%Column_Optical_Thickness)) deallocate(x%Column_Optical_Thickness)
    if(associated(x%Column_Cloud_Top_Pressure)) deallocate(x%Column_Cloud_Top_Pressure  )
#endif

    if(associated(x%Optical_Thickness_vs_Cloud_Top_Pressure)) deallocate(x%Optical_Thickness_vs_Cloud_Top_Pressure   ) 
  END SUBROUTINE FREE_COSP_MODIS
  ! -----------------------------------------------------

  !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  !------------- SUBROUTINE COSP_MODIS_CPSECTION -----------------
  !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE COSP_MODIS_CPSECTION(ix, iy, orig, copy)
    integer, dimension(2), intent(in) :: ix, iy
    type(cosp_modis),      intent(in   ) :: orig
    type(cosp_modis),      intent(  out) :: copy
    !
    ! Copy a set of grid points from one cosp_modis variable to another.
    !   Should test to be sure ix and iy refer to the same number of grid points 
    !
    integer :: orig_start, orig_end, copy_start, copy_end
    
    orig_start = ix(1); orig_end = ix(2)
    copy_start = iy(1); copy_end = iy(2) 
    
    copy%Cloud_Fraction_Total_Mean(copy_start:copy_end) = orig%Cloud_Fraction_Total_Mean(orig_start:orig_end)
    copy%Cloud_Fraction_Water_Mean(copy_start:copy_end) = orig%Cloud_Fraction_Water_Mean(orig_start:orig_end)
    copy%Cloud_Fraction_Ice_Mean  (copy_start:copy_end) = orig%Cloud_Fraction_Ice_Mean  (orig_start:orig_end)
    
    copy%Cloud_Fraction_High_Mean(copy_start:copy_end) = orig%Cloud_Fraction_High_Mean(orig_start:orig_end)
    copy%Cloud_Fraction_Mid_Mean (copy_start:copy_end) = orig%Cloud_Fraction_Mid_Mean (orig_start:orig_end)
    copy%Cloud_Fraction_Low_Mean (copy_start:copy_end) = orig%Cloud_Fraction_Low_Mean (orig_start:orig_end)
    
    copy%Optical_Thickness_Total_Mean(copy_start:copy_end) = orig%Optical_Thickness_Total_Mean(orig_start:orig_end)
    copy%Optical_Thickness_Water_Mean(copy_start:copy_end) = orig%Optical_Thickness_Water_Mean(orig_start:orig_end)
    copy%Optical_Thickness_Ice_Mean  (copy_start:copy_end) = orig%Optical_Thickness_Ice_Mean  (orig_start:orig_end)
    
    copy%Optical_Thickness_Total_LogMean(copy_start:copy_end) = &
                                                          orig%Optical_Thickness_Total_LogMean(orig_start:orig_end)
    copy%Optical_Thickness_Water_LogMean(copy_start:copy_end) = &
                                                          orig%Optical_Thickness_Water_LogMean(orig_start:orig_end)
    copy%Optical_Thickness_Ice_LogMean  (copy_start:copy_end) = &
                                                          orig%Optical_Thickness_Ice_LogMean  (orig_start:orig_end)

    copy%Cloud_Particle_Size_Water_Mean(copy_start:copy_end) = orig%Cloud_Particle_Size_Water_Mean(orig_start:orig_end)
    copy%Cloud_Particle_Size_Ice_Mean  (copy_start:copy_end) = orig%Cloud_Particle_Size_Ice_Mean  (orig_start:orig_end)

    copy%Cloud_Top_Pressure_Total_Mean(copy_start:copy_end) = orig%Cloud_Top_Pressure_Total_Mean(orig_start:orig_end)
    
    copy%Liquid_Water_Path_Mean(copy_start:copy_end) = orig%Liquid_Water_Path_Mean(orig_start:orig_end)
    copy%Ice_Water_Path_Mean   (copy_start:copy_end) = orig%Ice_Water_Path_Mean  (orig_start:orig_end)
    
#ifdef COSP_GFDL
    copy%Column_Particle_Size  (copy_start:copy_end,:) = orig%Column_Particle_Size (orig_start:orig_end,:)
    copy%retrievedPhase        (copy_start:copy_end,:) = orig%retrievedPhase       (orig_start:orig_end,:)
    copy%Column_Optical_Thickness  (copy_start:copy_end,:) = orig%Column_Optical_Thickness (orig_start:orig_end,:)
    copy%Column_Cloud_Top_Pressure  (copy_start:copy_end,:) = orig%Column_Cloud_Top_Pressure (orig_start:orig_end,:)
#endif

    copy%Optical_Thickness_vs_Cloud_Top_Pressure(copy_start:copy_end, :, :) = &
                          orig%Optical_Thickness_vs_Cloud_Top_Pressure(orig_start:orig_end, :, :)
  END SUBROUTINE COSP_MODIS_CPSECTION
  ! -----------------------------------------------------

END MODULE MOD_COSP_Modis_Simulator

! $Id$

#include <fms_platform.h>


module drifters_input_mod
  implicit none
  private

  public :: drifters_input_type, drifters_input_new, drifters_input_del, drifters_input_save, assignment(=)

  ! Globals
  integer, parameter, private   :: MAX_STR_LEN = 128
  character(MAX_STR_LEN), parameter, private :: version = '$Id$'
  character, parameter, private :: SEPARATOR = ' '

  type drifters_input_type
     ! Be sure to update drifters_input_new, drifters_input_del and drifters_input_copy_new
     ! when adding members
     character(len=MAX_STR_LEN), _ALLOCATABLE :: position_names(:) _NULL
     character(len=MAX_STR_LEN), _ALLOCATABLE :: position_units(:) _NULL
     character(len=MAX_STR_LEN), _ALLOCATABLE :: field_names(:)    _NULL
     character(len=MAX_STR_LEN), _ALLOCATABLE :: field_units(:)    _NULL
     character(len=MAX_STR_LEN), _ALLOCATABLE :: velocity_names(:) _NULL
     real                      , _ALLOCATABLE :: positions(:,:) _NULL
     integer                   , _ALLOCATABLE :: ids(:)         _NULL
     character(len=MAX_STR_LEN)               :: time_units
     character(len=MAX_STR_LEN)               :: title
     character(len=MAX_STR_LEN)               :: version
  end type drifters_input_type

  interface assignment(=)
     module procedure drifters_input_copy_new
  end interface
 

  contains

!===============================================================================

  subroutine drifters_input_new(self, filename, ermesg)
    type(drifters_input_type)    :: self
    character(len=*), intent(in) :: filename
    character(len=*), intent(out):: ermesg

    ! Local 
    integer :: ier, ncid, nd, nf, np, ipos, j, id, i, isz
    character(len=MAX_STR_LEN) :: attribute
    include 'netcdf.inc'
    
    ermesg = ''

    ier = nf_open(filename, NF_NOWRITE, ncid)
    if(ier/=NF_NOERR) then
       ermesg = 'drifters_input: ERROR could not open netcdf file '//filename
       return
    endif

    ! version
    ier = NF_PUT_ATT_TEXT(NCID, NF_GLOBAL, 'version', len(version), version)

    ier = NF_INQ_DIMID(NCID, 'nd', id)
    if(ier/=NF_NOERR) then
       ermesg = 'drifters_input: ERROR could not find "nd" (number of dimensions)'
       ier = nf_close(ncid)
       return
    endif
    ier = NF_INQ_DIMLEN(NCID, id, nd)

    ! determine number of fields (nf)
    attribute = ''
    ier = nf_get_att_text(ncid, NF_GLOBAL, 'field_names', attribute)
    isz = min(len(attribute), len(trim(attribute))+1)
    attribute(isz:isz) = ' '
    ipos = 1
    nf = 0
    do i = 1, isz
       if(attribute(i:i)==SEPARATOR) then
          nf = nf + 1
       endif
    enddo
      
    ier = NF_INQ_DIMID(NCID, 'np', id)
    if(ier/=NF_NOERR) then
       ermesg = 'drifters_input: ERROR could not find "np" (number of particles)'
       ier = nf_close(ncid)
       return
    endif
    ier = NF_INQ_DIMLEN(NCID, id, np)

    allocate(self%position_names(nd))
    allocate(self%position_units(nd))
    allocate(self%field_names(nf))
    allocate(self%field_units(nf))
    allocate(self%velocity_names(nd))
    allocate(self%ids(np))
    allocate(self%positions(nd, np))

    ier = NF_INQ_VARID(NCID, 'ids', id)
    if(ier/=NF_NOERR) then
       ermesg = 'drifters_input: ERROR could not find "ids"'
       ier = nf_close(ncid)
       return
    endif
    ier = NF_GET_VAR_INT(NCID, id, self%ids)

    ier = NF_INQ_VARID(NCID, 'positions', id)
    if(ier/=NF_NOERR) then
       ermesg = 'drifters_input: ERROR could not find "positions"'
       ier = nf_close(ncid)
       return
    endif
    ier = NF_GET_VAR_DOUBLE(NCID, id, self%positions)

    attribute = ''
    ier = nf_get_att_text(ncid, NF_GLOBAL, 'version', attribute)
    self%version = trim(attribute)
   
    attribute = ''
    ier = nf_get_att_text(ncid, NF_GLOBAL, 'time_units', attribute)
    self%time_units = trim(attribute)

    attribute = ''
    ier = nf_get_att_text(ncid, NF_GLOBAL, 'title', attribute)
    self%title = trim(attribute)

    attribute = ''
    ier = nf_get_att_text(ncid, id, 'names', attribute)
    isz = min(len(attribute), len(trim(attribute))+1)
    attribute(isz:isz) = ' '
    ipos = 1
    j = 1
    do i = 1, isz
       if(attribute(i:i)==SEPARATOR) then
          self%position_names(j)  = trim(adjustl(attribute(ipos:i-1)))
          ipos = i+1
          j = j + 1
          if(j > nd) exit
       endif
    enddo

    attribute = ''
    ier = nf_get_att_text(ncid, id, 'units', attribute)
    isz = min(len(attribute), len(trim(attribute))+1)
    attribute(isz:isz) = ' '
    ipos = 1
    j = 1
    do i = 1, isz
       if(attribute(i:i)==SEPARATOR) then
          self%position_units(j)  = trim(adjustl(attribute(ipos:i-1)))
          ipos = i+1
          j = j + 1
          if(j > nd) exit
       endif
    enddo

    attribute = ''
    ier = nf_get_att_text(ncid, NF_GLOBAL, 'field_names', attribute)
    isz = min(len(attribute), len(trim(attribute))+1)
    attribute(isz:isz) = ' '
    ipos = 1
    j = 1
    do i = 1, isz
       if(attribute(i:i)==SEPARATOR) then
          self%field_names(j)  = trim(adjustl(attribute(ipos:i-1)))
          ipos = i+1
          j = j + 1
          if(j > nf) exit
       endif
    enddo

    attribute = ''
    ier = nf_get_att_text(ncid, NF_GLOBAL, 'field_units', attribute)
    isz = min(len(attribute), len(trim(attribute))+1)
    attribute(isz:isz) = ' '
    ipos = 1
    j = 1
    do i = 1, isz
       if(attribute(i:i)==SEPARATOR) then
          self%field_units(j)  = trim(adjustl(attribute(ipos:i-1)))
          ipos = i+1
          j = j + 1
          if(j > nf) exit
       endif
    enddo

    attribute = ''
    ier = nf_get_att_text(ncid, NF_GLOBAL, 'velocity_names', attribute)
    isz = min(len(attribute), len(trim(attribute))+1)
    attribute(isz:isz) = ' '
    ipos = 1
    j = 1
    do i = 1, isz
       if(attribute(i:i)==SEPARATOR) then
          self%velocity_names(j)  = trim(adjustl(attribute(ipos:i-1)))
          ipos = i+1
          j = j + 1
          if(j > nd) exit
       endif
    enddo

  end subroutine drifters_input_new

!===============================================================================
  subroutine drifters_input_del(self, ermesg)
    type(drifters_input_type)    :: self
    character(len=*), intent(out):: ermesg

    integer :: iflag

    ermesg = ''

    deallocate(self%position_names, stat=iflag)
    deallocate(self%position_units, stat=iflag)
    deallocate(self%field_names, stat=iflag)
    deallocate(self%field_units, stat=iflag)
    deallocate(self%velocity_names, stat=iflag)
    deallocate(self%ids, stat=iflag)
    deallocate(self%positions, stat=iflag)
    
  end subroutine drifters_input_del

!===============================================================================
  subroutine drifters_input_copy_new(new_instance, old_instance)

    type(drifters_input_type), intent(inout) :: new_instance
    type(drifters_input_type), intent(in)    :: old_instance

    allocate(new_instance%position_names( size(old_instance%position_names) ))
    allocate(new_instance%position_units( size(old_instance%position_units) ))
    allocate(new_instance%field_names( size(old_instance%field_names) ))
    allocate(new_instance%field_units( size(old_instance%field_units) ))
    allocate(new_instance%velocity_names( size(old_instance%velocity_names) ))
    new_instance%position_names = old_instance%position_names
    new_instance%position_units = old_instance%position_units 
    new_instance%field_names    = old_instance%field_names
    new_instance%field_units    = old_instance%field_units
    new_instance%velocity_names = old_instance%velocity_names
    new_instance%time_units     = old_instance%time_units
    new_instance%title          = old_instance%title
    new_instance%version        = old_instance%version
    allocate(new_instance%positions( size(old_instance%positions,1),size(old_instance%positions,2) ))
    new_instance%positions      = old_instance%positions
    allocate(new_instance%ids(size(old_instance%ids)))
    new_instance%ids            = old_instance%ids

  end subroutine drifters_input_copy_new

!===============================================================================
  subroutine drifters_input_save(self, filename, geolon, geolat, ermesg)
    ! save state in netcdf file. can be used as restart file.
    type(drifters_input_type)    :: self
    character(len=*), intent(in ):: filename
    real, intent(in), optional   :: geolon(:), geolat(:)
    character(len=*), intent(out):: ermesg

    integer ncid, nc_nd, nc_np, ier, nd, np, nf, nc_pos, nc_ids, i, j, n
    integer nc_lon, nc_lat
    character(len=MAX_STR_LEN) :: att

    include 'netcdf.inc'

    ermesg = ''
    
    ier = nf_create(filename, NF_CLOBBER, ncid)
    if(ier/=NF_NOERR) then 
       ermesg = 'drifters_input: ERROR cannot create '//filename
       return
    endif

    nd = size(self%positions, 1)
    np = size(self%positions, 2)
    nf = size(self%field_names)

    ! dimensions
    ier = nf_def_dim(ncid, 'nd', nd, nc_nd)
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR creating dim "nd" '//nf_strerror(ier)

    ier = nf_def_dim(ncid, 'np', np, nc_np)
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR creating dim "np" '//nf_strerror(ier)

    ! global attributes
    ier = nf_put_att_text(ncid, NF_GLOBAL, 'title', len_trim(self%title), self%title)
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR setting global att "title" ' &
         & //nf_strerror(ier)
    
    ier = nf_put_att_text(ncid, NF_GLOBAL, 'time_units', len_trim(self%time_units), self%time_units)
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR setting global att "time_units" ' &
         & //nf_strerror(ier)

    att = ''
    j = 1
    do i = 1, nf
       n = len_trim(self%field_units(i))
       att(j:j+n+1) = trim(self%field_units(i)) // ' '
       j = j + n + 1
    enddo
    ier = nf_put_att_text(ncid, NF_GLOBAL, 'field_units',   len_trim(att), &
         & att)
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR setting global att "field_units" ' &
         & //nf_strerror(ier)

    att = ''
    j = 1
    do i = 1, nf
       n = len_trim(self%field_names(i))
       att(j:j+n+1) = trim(self%field_names(i)) // ' '
       j = j + n + 1
    enddo
    ier = nf_put_att_text(ncid, NF_GLOBAL, 'field_names',   len_trim(att), &
         & att)
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR setting global att "field_names" ' &
         & //nf_strerror(ier)

    att = ''
    j = 1
    do i = 1, nd
       n = len_trim(self%velocity_names(i))
       att(j:j+n+1) = trim(self%velocity_names(i)) // ' '
       j = j + n + 1
    enddo
    ier = nf_put_att_text(ncid, NF_GLOBAL, 'velocity_names',   len_trim(att), &
         & att)
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR setting global att "velocity_names" ' &
         & //nf_strerror(ier)

    ! variables
    ier = nf_def_var(ncid, 'positions', NF_DOUBLE, 2, (/nc_nd, nc_np/), nc_pos)
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR creating var "positions" '//nf_strerror(ier)

    ier = nf_def_var(ncid, 'ids', NF_INT, 1, (/nc_np/), nc_ids)
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR creating var "ids" '//nf_strerror(ier)

    ! optional: longitudes/latitudes in deg
    if(present(geolon)) then
       ier = nf_def_var(ncid, 'longitude', NF_DOUBLE, 1, (/nc_np/), nc_lon)
       if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR creating var "longitude" ' &
            & //nf_strerror(ier)
       att = 'degrees_east'
       ier = nf_put_att_text(ncid, nc_lon, 'units', len(trim(att)), trim(att))
       if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR setting att "units" to "longitude" ' &
         & //nf_strerror(ier)
    endif
    if(present(geolat)) then
       ier = nf_def_var(ncid, 'latitude', NF_DOUBLE, 1, (/nc_np/), nc_lat)
       if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR creating var "latitude" ' &
            & //nf_strerror(ier)
       att = 'degrees_north'
       ier = nf_put_att_text(ncid, nc_lat, 'units', len(trim(att)), trim(att))
       if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR setting att "units" to "latitude" ' &
         & //nf_strerror(ier)
    endif
    
    ! variable attributes
    
    att = ''
    j = 1
    do i = 1, nd
       n = len_trim(self%position_units(i))
       att(j:j+n+1) = trim(self%position_units(i)) // ' '
       j = j + n + 1
    enddo
    ier = nf_put_att_text(ncid, nc_pos, 'units',   len_trim(att), &
         & att)
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR setting att "units" to "positions" ' &
         & //nf_strerror(ier)
    
    att = ''
    j = 1
    do i = 1, nd
       n = len_trim(self%position_names(i))
       att(j:j+n+1) = trim(self%position_names(i)) // ' '
       j = j + n + 1
    enddo
    ier = nf_put_att_text(ncid, nc_pos, 'names',   len_trim(att), &
         & att)
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR setting att "names" to "positions" ' &
         & //nf_strerror(ier)

    ! end of define mode
    ier = nf_enddef(ncid)
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR could not end define mode ' &
         & //nf_strerror(ier)

    ! data
    ier = nf_put_var_double(ncid, nc_pos, self%positions)    
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR could not write "positions" ' &
         & //nf_strerror(ier)
    
    ier = nf_put_var_int(ncid, nc_ids, self%ids)    
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR could not write "ids" ' &
         & //nf_strerror(ier)

    if(present(geolon)) then
       ier = nf_put_var_double(ncid, nc_lon, geolon)    
       if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR could not write "geolon" ' &
            & //nf_strerror(ier)       
    endif
    if(present(geolat)) then
       ier = nf_put_var_double(ncid, nc_lat, geolat)    
       if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR could not write "geolat" ' &
            & //nf_strerror(ier)       
    endif
    
    
    ier = nf_close(ncid)
    if(ier/=NF_NOERR) ermesg = 'drifters_input_save: ERROR could not close file ' &
         & //nf_strerror(ier)
    
  end subroutine drifters_input_save

end module drifters_input_mod

!===============================================================================
!===============================================================================
#ifdef _TEST_DRIFTERS_INPUT
program test
  use drifters_input_mod
  implicit none
  character(len=128) :: ermesg
  integer :: i
  
  type(drifters_input_type) :: obj
  
  call drifters_input_new(obj, 'input.nc', ermesg)
  if(ermesg/='') print *,'ERROR: ', ermesg

  print *,'field_names:'
  do i = 1, size(obj%field_names)
     print *,trim(obj%field_names(i))
  enddo

  print *,'velocity_names:'
  do i = 1, size(obj%velocity_names)
     print *,trim(obj%velocity_names(i))
  enddo

  print *,'ids = ', obj%ids

  print *,'positions: '
  do i = 1, size(obj%positions, 2)
     print *,obj%positions(:,i)
  enddo

  call drifters_input_del(obj, ermesg)
end program test

#endif

module ocean_nphysics_util_new_mod
  !
  !<CONTACT EMAIL="tim.leslie@gmail.com"> Tim Leslie
  !</CONTACT>
  !
  !<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
  !</REVIEWER>
  !
  !<OVERVIEW>
  ! Utilities for neutral physics modules. 
  !</OVERVIEW>
  !
  !<DESCRIPTION>
  ! Utilities for neutral physics modules. 
  !</DESCRIPTION>
  !
  ! <INFO>
  !
  ! <REFERENCE>
  ! D.B. Chelton,  R.A. deSzoeke, M.G. Schlax, K.E. Naggar, N. Siwertz
  ! Geographical Variability of the First Baroclinic Rossby Radius of Deformation
  ! Journal of Physical Oceanography (1998) vol 28 pages 433-460 
  ! </REFERENCE>
  !
  ! <REFERENCE>
  ! K. Eden and R. Greatbatch, 2008: Towards a mesoscale eddy closure,
  ! Ocean Modelling, vol. 20, pages 223-239
  ! </REFERENCE>
  !
  ! <REFERENCE>
  ! S.M. Griffies "Elements of MOM (2012) (EoM)"
  ! </REFERENCE>
  !
  ! <REFERENCE>
  ! S.M. Griffies 
  ! Fundamentals of Ocean Climate Models (2004)
  ! Princeton University Press 
  ! </REFERENCE>
  !  
  ! <NOTE>
  ! </NOTE>
  !
  ! </INFO>
  !
  !<NAMELIST NAME="ocean_nphysics_util_new_nml">
  !
  !  <DATA NAME="num_121_passes" TYPE="integer">
  !  For number of 1-2-1 passes through to smooth drhodz or 
  !  eady_rate in vertical. Default num_121_passes=1. 
  !  </DATA>
  !
  !</NAMELIST>

#define COMP isc:iec,jsc:jec
#define COMPXLYL isc-1:iec,jsc-1:jec
#define COMPXRYL isc:iec+1,jsc-1:jec
#define COMPXLYR isc-1:iec,jsc:jec+1

  use constants_mod,    only: epsln
  use diag_manager_mod, only: register_diag_field
  use fms_mod,          only: FATAL, open_namelist_file, check_nml_error, close_file
  use mpp_mod,          only: mpp_error, stdout, stdlog
  use mpp_mod,          only: input_nml_file
  use mpp_domains_mod,  only: mpp_update_domains
  
  use ocean_domains_mod,    only: get_local_indices
  use ocean_parameters_mod, only: omega_earth
  use ocean_types_mod,      only: ocean_domain_type, ocean_grid_type, ocean_time_type

  implicit none

  public ocean_nphysics_util_new_init
  public stencil_centre_to_vert
  public stencil_centre_to_horiz
  public vert_smooth
  public horz_smooth 
  public compute_rossby_radius

  private check_init
  private

#include <ocean_memory.h>

character(len=128) :: version=&
     '$Id: ocean_nphysics_util_new.F90,v 20.0 2013/12/14 00:14:54 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

character(len=*), parameter :: FILENAME=&
     __FILE__


  logical :: module_is_initialized = .false.

  ! absolute value of the Coriolis parameter (sec^-1)
  real, dimension(:,:), allocatable :: coriolis_param

  ! beta = d(Coriolis)/dy (m^-1 sec^-1)
  real, dimension(:,:), allocatable :: beta_param

  !**************nml settings**************
  ! vert_smooth()
  integer :: num_121_passes = 1
  !**************end of nml settings**************

  namelist /ocean_nphysics_util_new_nml/ num_121_passes

contains

  !#######################################################################
  ! <SUBROUTINE NAME="stencil_centre_to_vert">
  !
  ! <DESCRIPTION>
  ! Initialise the grid indices and constants.
  ! </DESCRIPTION>
  !
  subroutine ocean_nphysics_util_new_init(Domain, Grid)

    type(ocean_domain_type), intent(in) :: Domain
    type(ocean_grid_type),   intent(in) :: Grid

    integer :: ioun, ierr, io_status
    integer :: stdoutunit, stdlogunit
    stdoutunit = stdout()
    stdlogunit = stdlog()

    if (module_is_initialized) then
       call mpp_error(FATAL, &
            '==> Error from ocean_nphysics_util_new (ocean_nphysics_util_new_init): already initialized.')
    endif
    module_is_initialized = .true.

    ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_nphysics_util_new_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_nphysics_util_new_nml')
#else
    ioun = open_namelist_file()
    read (ioun, ocean_nphysics_util_new_nml, IOSTAT=io_status)
    ierr = check_nml_error(io_status, 'ocean_nphysics_util_new_nml')
    call close_file(ioun)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit, ocean_nphysics_util_new_nml)
    write (stdlogunit, ocean_nphysics_util_new_nml)

#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
    nk = Grid%nk
#endif

    ! Coriolis parameter and beta parameter
    allocate (coriolis_param(isd:ied,jsd:jed))
    allocate (beta_param(isd:ied,jsd:jed))
    coriolis_param(COMP) = 2.0*omega_earth*abs(sin(Grid%phit(COMP)))
    beta_param(COMP) = max(2.28e-11*abs(cos(Grid%phit(COMP))), epsln)

  end subroutine ocean_nphysics_util_new_init
  ! </SUBROUTINE> NAME="ocean_nphysics_util_new_init"


  !#######################################################################
  ! <SUBROUTINE NAME="stencil_centre_to_vert">
  !
  ! <DESCRIPTION>
  ! Take an array defined over the 4 quadrants centred on a tracer cell
  ! and shift them vertically to the four quadrants spanning the bottom
  ! cell face. The top and bottom half cells are set to zero.
  ! _____________       _____________
  ! |     :     |       |     :     |
  ! | 0,0 : 1,0 |       |     :     |
  ! |     :     !       |     :     |
  ! |-----T-----|  ==>  |-----T-----|
  ! |     :     !       |     :     |
  ! | 0,1 : 1,1 !       | 0,0 : 1,0 |
  ! |_____:_____|       |_____:_____|
  !                     |     :     |
  !                     | 0,1 : 1,1 |
  !                     |     :     |
  !                     |-----o-----|
  !                     |     :     |
  !                     |     :     |
  !                     |_____:_____|
  ! </DESCRIPTION>
  !
  subroutine stencil_centre_to_vert(array_xz, array_yz, array_v_xz, array_v_yz)

    real, dimension(isd:,jsd:,:,0:,0:), intent(in)    :: array_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in)    :: array_yz
    real, dimension(isd:,jsd:,:,0:,0:), intent(inout) :: array_v_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(inout) :: array_v_yz

    integer :: k

    call check_init("stencil_centre_to_vert")

    do k = 1, nk-1
       array_v_xz(COMP,k,:,0) = array_xz(COMP,k,  :,1)
       array_v_xz(COMP,k,:,1) = array_xz(COMP,k+1,:,0)
       array_v_yz(COMP,k,:,0) = array_yz(COMP,k,  :,1)
       array_v_yz(COMP,k,:,1) = array_yz(COMP,k+1,:,0)
    enddo
    array_v_xz(COMP,nk,:,0) = array_xz(COMP,nk,:,1)
    array_v_yz(COMP,nk,:,0) = array_yz(COMP,nk,:,1)
    array_v_xz(COMP,nk,:,1) = 0.0
    array_v_yz(COMP,nk,:,1) = 0.0
    
  end subroutine stencil_centre_to_vert
  ! </SUBROUTINE> NAME="stencil_centre_to_vert"


  !#######################################################################
  ! <SUBROUTINE NAME="stencil_centre_to_horiz">
  !
  ! <DESCRIPTION>
  ! Take an array defined over the 4 quadrants centred on a tracer cell
  ! and shift them horizontally to the four quadrants spanning the right hand
  ! cell face.
  ! _____________       _________________________
  ! |     :     |       |     :     |     :     |
  ! | 0,0 : 1,0 |       |     : 0,0 | 1,0 :     |
  ! |     :     !       |     :     |     :     |
  ! |-----T-----|  ==>  |-----T-----|-----o-----|
  ! |     :     !       |     :     |     :     |
  ! | 0,1 : 1,1 !       |     : 0,1 | 1,1 :     |
  ! |_____:_____|       |_____:_____|_____:_____|
  ! </DESCRIPTION>
  !
  subroutine stencil_centre_to_horiz(array_xz, array_yz, array_h_xz, array_h_yz)

    real, dimension(isd:,jsd:,:,0:,0:), intent(in)    :: array_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in)    :: array_yz
    real, dimension(isd:,jsd:,:,0:,0:), intent(inout) :: array_h_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(inout) :: array_h_yz

    call check_init("stencil_centre_to_horz")

    array_h_xz(COMPXLYL,:,0,:) = array_xz(COMPXLYL,:,1,:)
    array_h_xz(COMPXLYL,:,1,:) = array_xz(COMPXRYL,:,0,:)

    array_h_yz(COMPXLYL,:,0,:) = array_yz(COMPXLYL,:,1,:)
    array_h_yz(COMPXLYL,:,1,:) = array_yz(COMPXLYR,:,0,:)

  end subroutine stencil_centre_to_horiz
  ! </SUBROUTINE> NAME="stencil_centre_to_horiz"


  !#######################################################################
  ! <SUBROUTINE NAME="vert_smooth">
  !
  ! <DESCRIPTION>
  ! Apply a vertical smoothing using a weighted 3 point stencil.
  !
  !                    1
  ! Stencil weights :  2
  !                    1
  ! 
  ! Smoothing is applied to all points in the column which admit
  ! the full stencil (so vertical boundaries are not modified).
  ! 
  ! The smoothing is applied multiple times, controlled by the namelist
  ! parameter num_121_passes.
  ! </DESCRIPTION>
  !
  subroutine vert_smooth(kmt, array)
    integer, dimension(isd:,jsd:), intent(in)    :: kmt
    real, dimension(isd:,jsd:,:),  intent(inout) :: array

    integer :: m, i, j, kbot

    call check_init("vert_smooth")

    do m=1,num_121_passes
       do j=jsd,jed
          do i=isd,ied
             kbot = kmt(i,j)
             if (kbot > 1) then
                array(i,j,2:kbot-1) = (array(i,j,1:kbot-2) + 2*array(i,j,2:kbot-1) + array(i,j,3:kbot))/4.0
             endif
          enddo
       enddo
    enddo

  end subroutine vert_smooth
  ! </SUBROUTINE> NAME="vert_smooth"


  !#######################################################################
  ! <SUBROUTINE NAME="horz_smooth">
  !
  ! <DESCRIPTION>
  ! Apply a horizontal smoothing using a weighted five point stencil.
  !
  !                     1
  ! Stencil weights : 1 4 1
  !                     1
  ! 
  ! Only active cells, as defined by the tmask, are used in the calculation.
  ! Operates over the COMP domain.
  ! </DESCRIPTION>
  !
  subroutine horz_smooth(Domain, tmask, array)

    type(ocean_domain_type),      intent(inout) :: Domain
    real, dimension(isd:,jsd:,:), intent(in)    :: tmask
    real, dimension(isd:,jsd:,:), intent(inout) :: array

    real, dimension(isd:ied,jsd:jed) :: tmp
    integer :: i, j, k
    real :: active_cells

    call check_init("horz_smooth")

    array(COMP,:) = tmask(COMP,:)*array(COMP,:)
    call mpp_update_domains(array(:,:,:), Domain%domain2d)
    do k = 1, nk
       tmp(:,:) = 0.0
       do j=jsc,jec
          do i=isc,iec
             if (tmask(i,j,k) == 1.0) then
                active_cells = 4.0   +&
                     tmask(i-1,j,k)  +&
                     tmask(i+1,j,k)  +&
                     tmask(i,j-1,k)  +&
                     tmask(i,j+1,k)
                if (active_cells > 4.0) then
                   tmp(i,j) = &
                        (4.0*array(i,j,k) +&
                        array(i-1,j,k)    +&
                        array(i+1,j,k)    +&
                        array(i,j-1,k)    +&
                        array(i,j+1,k)) / active_cells
                else
                   tmp(i,j) = array(i,j,k)
                endif
             endif
          enddo
       enddo
       array(COMP,k) = tmp(COMP)
    enddo

  end subroutine horz_smooth
  ! </SUBROUTINE> NAME="horz_smooth"



  !#######################################################################
  ! <SUBROUTINE NAME="compute_rossby_radius">
  !
  ! <DESCRIPTION>
  ! Subroutine computes the first baroclinic Rossby radius of deformation.
  ! Employ WKB approach described by Chelton et al.  In particular,
  ! use formulae (2.2), (2.3a) and (2.3b) from their paper.  
  ! </DESCRIPTION>
  !
  subroutine compute_rossby_radius(gravity_wave_speed, rossby_radius)

    real, dimension(isd:,jsd:), intent(in)    :: gravity_wave_speed
    real, dimension(isd:,jsd:), intent(inout) :: rossby_radius

    real, dimension(isd:ied,jsd:jed) :: rossby_non_equator
    real, dimension(isd:ied,jsd:jed) :: rossby_equator

    ! EoM: 16.62, G(2004) 14.81
    rossby_non_equator(COMP) = gravity_wave_speed(COMP)/(coriolis_param(COMP) + epsln)
    
    ! EoM: 16.63, G(2004) 14.82    
    rossby_equator(COMP)     = sqrt(gravity_wave_speed(COMP)/(2.0*beta_param(COMP)))

    ! Eden and Greatbatch section 4.2    
    rossby_radius(COMP)      = min(rossby_non_equator(COMP), rossby_equator(COMP))          

  end subroutine compute_rossby_radius
  ! </SUBROUTINE> NAME="compute_rossby_radius"

  !#######################################################################
  ! <SUBROUTINE NAME="check_init">
  !
  ! <DESCRIPTION>
  ! Helper function to ensure the module is initialised when calling the
  ! module's functions.
  ! </DESCRIPTION> 
  !
  subroutine check_init(function_name)

    character(len=*), intent(in) :: function_name

    if (.not. module_is_initialized) then 
       call mpp_error(FATAL, &
            '==> Error '//FILENAME//' (' // function_name // '): needs initialization.')
    endif

  end subroutine check_init
  ! </SUBROUTINE> NAME="check_init"


end module ocean_nphysics_util_new_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: TKE flux from wave-breaking\label{sec:fkCraig}
!
! !INTERFACE:
   REALTYPE  function fk_craig(u_tau,eta)
!
! !DESCRIPTION:
! This functions returns the flux of $k$ caused by breaking surface waves
! according to
! \begin{equation}
!  \label{craig}
!   F_k = \eta u_*^3
!  \point
! \end{equation}
! This form has also been used by \cite{CraigBanner94}, who suggested
! $\eta \approx 100$.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)                :: u_tau
   REALTYPE, intent(in)                :: eta
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: fk_craig.F90,v $
!  Revision 20.0  2013/12/14 00:13:39  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.5  2007-07-23 11:28:39  hb
!  cw for Craig-Banner wave breaking from namelist now used in fk_craig.F90
!
!  Revision 1.4  2005-06-27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.3  2004/08/18 12:50:57  lars
!  updated documentation
!
!  Revision 1.2  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.1  2003/03/10 09:00:36  gotm
!  Part of new generic turbulence model
!
!
!EOP
!-----------------------------------------------------------------------
!BOC
   fk_craig = eta*u_tau**3.

   end function fk_craig
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module ocean_overflow_mod
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</CONTACT>
!
!<CONTACT EMAIL="m.bates@student.unsw.edu.au"> Michael Bates 
!</CONTACT>
!
!<OVERVIEW>
! Tracer source from discharging dense shallow water into the abyss
! at the parcel's depth of neutral buoyancy.  
!</OVERVIEW>
!
!<DESCRIPTION>
! Tracer source from discharging dense shallow water into the abyss
! at the parcel's depth of neutral buoyancy.  Follow the approach
! of Campin and Goosse (1999), as well as modifications.  
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! Campin and Goosse (1999): Parameterization of density-driven downsloping flow 
! for a coarse-resolution model in z-coordinate", Tellus 51A, pages 412-430
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, M.J. Harrison, R. C. Pacanowski, and A. Rosati
! A Technical Guide to MOM4 (2003)
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, Elements of MOM (2012)
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_overflow_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  For using this module.  Default is false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging 
!  </DATA> 
!
!  <DATA NAME="overflow_mu" TYPE="real" UNITS="inverse seconds">
!  Dissipation rate for the bottom friction.  Campin and Goosse 
!  suggest overflow_mu=10^-4
!  </DATA> 
!  <DATA NAME="overflow_delta" TYPE="real" UNITS="dimensionless">
!  Fraction of a grid cell participating in the overflow process. 
!  Campin and Goosse suggest overflow_delta=1/3. 
!  </DATA> 
!  <DATA NAME="overflow_umax" TYPE="real" UNITS="m/s">
!  Maximum downslope speed. 
!  </DATA> 
!  <DATA NAME="do_bitwise_exact_sum" TYPE="logical">
!  Set true to do bitwise exact global sum. When it is false, the global
!  sum will be non-bitwise_exact, but will significantly increase efficiency. 
!  The default value is false.
!  </DATA> 
!
!  <DATA NAME="no_return_flow" TYPE="logical">
!  Set true to remove the Campin and Goose return flow "piping".
!  Default no_return_flow=.false. to recover the standard approach from 
!  Campin and Goose. 
!  </DATA> 
!
!</NAMELIST>
!

use constants_mod,       only: epsln
use diag_manager_mod,    only: register_diag_field, register_static_field
use fms_mod,             only: write_version_number, error_mesg, FATAL, NOTE
use fms_mod,             only: open_namelist_file, check_nml_error, close_file, stdout, stdlog
use mpp_domains_mod,     only: mpp_update_domains, CGRID_NE
use mpp_domains_mod,     only: mpp_global_sum, BITWISE_EXACT_SUM, NON_BITWISE_EXACT_SUM
use mpp_domains_mod,     only: mpp_define_domains, mpp_update_domains
use mpp_domains_mod,     only: cyclic_global_domain, global_data_domain 
use mpp_mod,             only: input_nml_file, mpp_error

use ocean_density_mod,    only: density
use ocean_domains_mod,    only: get_local_indices
use ocean_parameters_mod, only: missing_value, rho0r, grav
use ocean_parameters_mod, only: TERRAIN_FOLLOWING
use ocean_types_mod,      only: ocean_domain_type, ocean_grid_type, ocean_time_type, ocean_options_type
use ocean_types_mod,      only: ocean_prog_tracer_type, ocean_density_type, ocean_thickness_type
use ocean_util_mod,       only: write_timestamp, diagnose_2d, diagnose_3d
use ocean_tracer_util_mod,only: diagnose_3d_rho
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3, wrk4, wrk1_v, wrk2_v

implicit none

private 

public ocean_overflow_init
public overflow
private watermass_diag_init
private watermass_diag


type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

#include <ocean_memory.h>

! for the algorithm
real    :: overflow_factor ! grav*overflow_delta/(rho0*overflow_mu)  (m^4/kg/sec)
integer :: ip(4),jq(4)     ! to label four surrounding cells 
integer :: ijsc(4),ijec(4) ! for shifting do-loop indices to minimize calls to mpp_update_domains

real, dimension(:,:),   allocatable   :: slope_x          ! topog slope (dimensionless) in the i-direction
real, dimension(:,:),   allocatable   :: slope_y          ! topog slope (dimensionless) in the j-direction 
real, dimension(:,:,:), allocatable   :: topog_slope      ! topog slope (dimensionless) for 4-directions 
real, dimension(:,:,:), allocatable   :: topog_step       ! where downslope flow is topgraphically possible 
real, dimension(:,:,:), allocatable   :: flux_int_z       ! for diagnostics 
real, dimension(:,:,:), allocatable   :: source_overflow  ! thickness weighted tendency from overflow  
real, dimension(:,:,:), allocatable   :: overflow_flux    ! tracer flux associated with overflow 
real, dimension(:,:),   allocatable   :: overflow_xflux   ! mass flux in i-direction
real, dimension(:,:),   allocatable   :: overflow_yflux   ! mass flux in j-direction 

! internally set for computing watermass diagnostics
logical :: compute_watermass_diag = .false. 

! for diagnostic manager 
logical :: used
integer :: id_over_slope_x=-1
integer :: id_over_slope_y=-1
integer :: id_topog_step_1=-1
integer :: id_topog_step_2=-1
integer :: id_topog_step_3=-1
integer :: id_topog_step_4=-1
integer :: id_overflow_xflux=-1 
integer :: id_overflow_yflux=-1
integer :: id_tx_trans_overflow=-1
integer :: id_ty_trans_overflow=-1
integer, dimension(:), allocatable :: id_overflow
integer, dimension(:), allocatable :: id_overflow_xflux_int_z
integer, dimension(:), allocatable :: id_overflow_yflux_int_z

integer :: id_neut_rho_overfl          =-1
integer :: id_wdian_rho_overfl         =-1
integer :: id_neut_rho_overfl_on_nrho  =-1
integer :: id_wdian_rho_overfl_on_nrho =-1
integer :: id_tform_rho_overfl_on_nrho =-1

integer :: id_neut_temp_overfl          =-1
integer :: id_wdian_temp_overfl         =-1
integer :: id_neut_temp_overfl_on_nrho  =-1
integer :: id_wdian_temp_overfl_on_nrho =-1
integer :: id_tform_temp_overfl_on_nrho =-1

integer :: id_neut_salt_overfl          =-1
integer :: id_wdian_salt_overfl         =-1
integer :: id_neut_salt_overfl_on_nrho  =-1
integer :: id_wdian_salt_overfl_on_nrho =-1
integer :: id_tform_salt_overfl_on_nrho =-1

! for specifying transport units
! can either be Sv or mks
character(len=32) :: transport_units='Sv' 
character(len=32) :: transport_dims ='Sv (10^9 kg/s)' 
real              :: transport_convert=1.0e-9 

character(len=128) :: version=&
       '=>Using: ocean_overflow.f90 ($Id: ocean_overflow.F90,v 20.0 2013/12/14 00:16:06 fms Exp $)'
character (len=128) :: tagname=&
     '$Name: tikal $'

! number of prognostic tracers
integer :: num_prog_tracers=0

! processor zero writes to unit 6
integer :: unit=6  

! initialization flag 
logical :: module_is_initialized=.false.

! flag for mpp_global_sum
integer :: global_sum_flag      

! time step 
real :: dtime 
real :: p5dtimer

! set from nml
logical :: use_this_module        = .false. ! must be set .true. in nml to enable this scheme
logical :: debug_this_module      = .false. ! for debugging
logical :: do_bitwise_exact_sum   = .false. ! set true to get slower sum that is same for all PEs. 
logical :: no_return_flow         = .false. ! set true to remove the pre-defined return flow "piping"
real    :: overflow_mu            = 1.e-4   ! frictional dissipation rate (sec^-1) at bottom  
real    :: overflow_delta         = 0.3333  ! fraction of a grid cell participating in overflow 
real    :: overflow_umax          = 0.01    ! maximum downslope speed (m/s)

namelist /ocean_overflow_nml/ use_this_module, debug_this_module, overflow_mu,     &
                              overflow_delta, overflow_umax, do_bitwise_exact_sum, &
                              no_return_flow, transport_units 

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_overflow_init">
!
! <DESCRIPTION>
! Initial set up for mixing of tracers into the abyss next to topography.
! </DESCRIPTION>
!
  subroutine ocean_overflow_init(Grid, Domain, Time, Dens, T_prog, Ocean_options, &
                                 vert_coordinate_type, dtim, debug)

    type(ocean_grid_type),        intent(in), target   :: Grid
    type(ocean_domain_type),      intent(in), target   :: Domain
    type(ocean_time_type),        intent(in), target   :: Time
    type(ocean_density_type),     intent(in)           :: Dens
    type(ocean_prog_tracer_type), intent(inout)        :: T_prog(:)
    type(ocean_options_type),     intent(inout)        :: Ocean_options
    integer,                      intent(in)           :: vert_coordinate_type 
    real,                         intent(in)           :: dtim
    logical,                      intent(in), optional :: debug

    integer :: io_status, ioun, ierr
    integer :: i,j,m,n,kbot

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

    if ( module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error from ocean_overflow_mod (ocean_overflow_init): module already initialized')
    endif 

    module_is_initialized = .TRUE.

    call write_version_number(version, tagname)
#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
    nk = Grid%nk
#endif
    Dom => Domain
    Grd => Grid

    num_prog_tracers = size(T_prog(:))
    dtime = dtim 
    p5dtimer = 0.5/dtime

    ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_overflow_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_overflow_nml')
#else
    ioun =  open_namelist_file()
    read (ioun,ocean_overflow_nml,IOSTAT=io_status)
    ierr = check_nml_error(io_status,'ocean_overflow_nml')
    call close_file (ioun)
#endif
    write (stdlogunit,ocean_overflow_nml)
    write (stdoutunit,'(/)') 
    write (stdoutunit,ocean_overflow_nml)

    if(do_bitwise_exact_sum) then
       global_sum_flag = BITWISE_EXACT_SUM
    else
       global_sum_flag = NON_BITWISE_EXACT_SUM
    endif

    if (PRESENT(debug) .and. .not. debug_this_module) then
       debug_this_module = debug
    endif 
    if(debug_this_module) then 
       write(stdoutunit,'(a)') '==>Note: running ocean_overflow_mod with debug_this_module=.true.'  
    endif 
    
    if(transport_units=='Sv') then
        transport_convert=1.0e-9 
        transport_dims   = 'Sv (10^9 kg/s)'
    else
        transport_convert=1.0
        transport_dims   = 'kg/s'
    endif


    if(.not. use_this_module) then 
      call mpp_error(NOTE,&
      '==>From ocean_overflow_mod: NOT using Campin and Goosse overflow scheme.')
      Ocean_options%overflow = 'Did NOT use Campin and Goosse overflow scheme.'
      return
    else 
      if(vert_coordinate_type == TERRAIN_FOLLOWING) then 
          call mpp_error(FATAL, &
          '==>ocean_overflow_mod: this module is NOT for use with TERRAIN_FOLLOWING vert coodinates.')
      endif
      Ocean_options%overflow = 'Used the Campin and Goosse overflow scheme.'

      if(no_return_flow) then
         call mpp_error(NOTE,&
         '==>From ocean_overflow_mod: USING modified Campin and Goosse overflow scheme with no specified return flow.')
      else
         call mpp_error(NOTE,&
         '==>From ocean_overflow_mod: USING original Campin and Goosse overflow scheme with specified return flow.')
      endif

    endif

    if(debug_this_module) then 
      call mpp_error(NOTE,'==>From ocean_overflow_mod: USING debug_this_module')
    endif 

    ! for holding the tracer tendency from the overflow scheme 
    allocate (source_overflow(isd:ied,jsd:jed,nk))
    source_overflow(:,:,:) = 0.0    

    ! compute a common factor that is time independent 
    overflow_factor = grav*overflow_delta*rho0r/(epsln+overflow_mu)

    ! compute topographic slope arrays for the i-slope and j-slope
    ! slopes are centered on the i-face and j-face of tracer cells 
    allocate (slope_x(isd:ied,jsd:jed))
    allocate (slope_y(isd:ied,jsd:jed))
    slope_x = 0.0 
    slope_y = 0.0
    do j=jsc,jec
      do i=isc,iec
        slope_x(i,j) = (Grd%ht(i+1,j)-Grd%ht(i,j))*Grd%dxter(i,j)     
        slope_y(i,j) = (Grd%ht(i,j+1)-Grd%ht(i,j))*Grd%dytnr(i,j)
        slope_x(i,j) = abs(slope_x(i,j))
        slope_y(i,j) = abs(slope_y(i,j))
      enddo
    enddo 
    call mpp_update_domains(slope_x(:,:),Dom%domain2d)
    call mpp_update_domains(slope_y(:,:),Dom%domain2d)

    ! topographic slope for the four surrounding directions 
    allocate (topog_slope(isd:ied,jsd:jed,4))
    topog_slope(:,:,:) = 0.0
    do j=jsc,jec
       do i=isc,iec
          m=1 ; topog_slope(i,j,m) = slope_x(i,j)  
          m=2 ; topog_slope(i,j,m) = slope_y(i,j)  
          m=3 ; topog_slope(i,j,m) = slope_x(i-1,j)
          m=4 ; topog_slope(i,j,m) = slope_y(i,j-1)
       enddo
    enddo

    ! compute directions from an (i,j) point where topography deepens.
    ! these directions may potentially have downslope flow. 
    ! insist that downslope flow occurs only when there are more kmt cells
    ! in the adjacent column. 
    ! also insist that downslope flow does not involve k=1 cells. 
    allocate (topog_step(isd:ied,jsd:jed,4))
    topog_step(:,:,:) = 0.0
    do j=jsc,jec
      do i=isc,iec
         kbot = Grd%kmt(i,j)
         if(kbot > 1) then 
           if(Grd%kmt(i+1,j) > kbot) topog_step(i,j,1)=1.0
           if(Grd%kmt(i,j+1) > kbot) topog_step(i,j,2)=1.0
           if(Grd%kmt(i-1,j) > kbot) topog_step(i,j,3)=1.0
           if(Grd%kmt(i,j-1) > kbot) topog_step(i,j,4)=1.0
         endif 
      enddo
    enddo   
    ! Block out the bipolar fold in order to ensure tracer conservation.
    ! The reason we do so is related to how the algorithm reaches between  
    ! two adjacent columns of tracer points.  When the column straddles 
    ! the bipolar fold, the code logic is not general and so it actually 
    ! attempts to reach to a non-adjacent column.  Shy of generalizing 
    ! the logic, we simply do not consider overflow for points along fold. 
    if(jec+Dom%joff==Dom%jeg) then 
       topog_step(:,jec,:) = 0.0
    endif 

    ! labels for the four tracer cells surrounding a 
    ! central tracer cell (moving counter-clockwise)
    m=1 ; ip(m)=1  ; jq(m)=0  ; ijsc(m) = 1 ; ijec(m) = 0
    m=2 ; ip(m)=0  ; jq(m)=1  ; ijsc(m) = 1 ; ijec(m) = 0
    m=3 ; ip(m)=-1 ; jq(m)=0  ; ijsc(m) = 0 ; ijec(m) = 1
    m=4 ; ip(m)=0  ; jq(m)=-1 ; ijsc(m) = 0 ; ijec(m) = 1 

    ! for overflow flux 
    allocate (overflow_flux(isd:ied,jsd:jed,4))
    overflow_flux(:,:,:) = 0.0

    ! for diagnosing vertically integrated tracer flux
    allocate (flux_int_z(isd:ied,jsd:jed,4))
    flux_int_z = 0.0

    ! for diagnostics with the traditional overflow scheme 
    allocate (overflow_xflux(isd:ied,jsd:jed))
    allocate (overflow_yflux(isd:ied,jsd:jed))
    overflow_xflux(:,:) = 0.0
    overflow_yflux(:,:) = 0.0


    ! register/send diagnostics 
    id_over_slope_x = register_static_field ('ocean_model', 'over_slope_x', Grd%tracer_axes_flux_x(1:2), &
                 '|d(ht)/dx| on T-cell face', 'm/m', missing_value=missing_value, range=(/-1.e9,1.e9/))
    call diagnose_2d(Time, Grd, id_over_slope_x, slope_x(:,:))

    id_over_slope_y = register_static_field ('ocean_model', 'over_slope_y', Grd%tracer_axes_flux_y(1:2), &
                 '|d(ht)/dy| on T-cell face', 'm/m', missing_value=missing_value, range=(/-1.e9,1.e9/))
    call diagnose_2d(Time, Grd, id_over_slope_y, slope_y(:,:))

    id_topog_step_1 = register_static_field ('ocean_model', 'topog_step_1', Grd%tracer_axes(1:2), &
                 'topog_step_1', 'dimensionless', missing_value=missing_value, range=(/-1.0,1.0/))
    call diagnose_2d(Time, Grd, id_topog_step_1, topog_step(:,:,1))

    id_topog_step_2 = register_static_field ('ocean_model', 'topog_step_2', Grd%tracer_axes(1:2), &
                 'topog_step_2', 'dimensionless', missing_value=missing_value, range=(/-1.0,1.0/))
    call diagnose_2d(Time, Grd, id_topog_step_2, topog_step(:,:,2))

    id_topog_step_3 = register_static_field ('ocean_model', 'topog_step_3', Grd%tracer_axes(1:2), &
                 'topog_step_3', 'dimensionless', missing_value=missing_value, range=(/-1.0,1.0/))
    call diagnose_2d(Time, Grd, id_topog_step_3, topog_step(:,:,3))

    id_topog_step_4 = register_static_field ('ocean_model', 'topog_step_4', Grd%tracer_axes(1:2), &
                 'topog_step_4', 'dimensionless', missing_value=missing_value, range=(/-1.0,1.0/))
    call diagnose_2d(Time, Grd, id_topog_step_4, topog_step(:,:,4))


    id_overflow_xflux = register_diag_field ('ocean_model', 'overflow_xflux', Grd%tracer_axes_flux_x(1:2), &
         Time%model_time, 'off-shelf i-transport from overflow', &
        'kg/s', missing_value=missing_value, range=(/-1.e14,1.e14/))

    id_overflow_yflux = register_diag_field ('ocean_model', 'overflow_yflux', Grd%tracer_axes_flux_y(1:2), &
         Time%model_time, 'off-shelf j-transport from overflow', &
        'kg/s', missing_value=missing_value, range=(/-1.e9,1.e9/))

    id_tx_trans_overflow = register_diag_field ('ocean_model', 'tx_trans_overflow',               &
         Grd%tracer_axes_flux_x(1:3), Time%model_time, 'i-directed mass transport from overflow', &
        trim(transport_dims), missing_value=missing_value, range=(/-1.e20,1.e20/))

    id_ty_trans_overflow = register_diag_field ('ocean_model', 'ty_trans_overflow',               &
         Grd%tracer_axes_flux_x(1:3), Time%model_time, 'j-directed mass transport from overflow', &
        trim(transport_dims), missing_value=missing_value, range=(/-1.e20,1.e20/))

    call watermass_diag_init(Time,Dens)

    allocate (id_overflow(num_prog_tracers))
    allocate (id_overflow_xflux_int_z(num_prog_tracers))
    allocate (id_overflow_yflux_int_z(num_prog_tracers))
    id_overflow = -1
    id_overflow_xflux_int_z=-1
    id_overflow_yflux_int_z=-1

    do n=1,num_prog_tracers
       if(T_prog(n)%name == 'temp') then 
           id_overflow(n) = register_diag_field ('ocean_model', &
                'overflow_'//trim(T_prog(n)%name),              &
                Grd%tracer_axes(1:3), Time%model_time,          &
                'cp*overflow*rho*dzt*temp',                     &
                'Watt/m^2', missing_value=missing_value, range=(/-1.e9,1.e9/))
           id_overflow_xflux_int_z(n) = register_diag_field ('ocean_model', &
              trim(T_prog(n)%name)//'_xflux_overflow_int_z',                &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                 &
              'vert-integ cp*overflow_xflux*rho*dzt*dyt*temp',              &
              'Watt', missing_value=missing_value, range=(/-1.e9,1.e9/))
           id_overflow_yflux_int_z(n) = register_diag_field ('ocean_model', &
              trim(T_prog(n)%name)//'_yflux_overflow_int_z',                &
              Grd%tracer_axes_flux_y(1:2), Time%model_time,                 &
              'vert-integ cp*overflow_yflux*rho*dzt*dxt*temp',              &
              'Watt', missing_value=missing_value, range=(/-1.e9,1.e9/))
       else
           id_overflow(n) = register_diag_field ('ocean_model',      &
                'overflow_'//trim(T_prog(n)%name),                   &
                Grd%tracer_axes(1:3), Time%model_time,               &
                'overflow*rho*dzt*tracer for '//trim(T_prog(n)%name),&
                trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e9,1.e9/))
           id_overflow_xflux_int_z(n) = register_diag_field ('ocean_model',             &
              trim(T_prog(n)%name)//'_xflux_overflow_int_z',                            &
              Grd%tracer_axes_flux_x(1:2), Time%model_time,                             &
              'vert-integ overflow_xflux*dyt*rho*dzt*tracer for '//trim(T_prog(n)%name),&
              'kg/sec', missing_value=missing_value, range=(/-1.e9,1.e9/))
           id_overflow_yflux_int_z(n) = register_diag_field ('ocean_model',             &
              trim(T_prog(n)%name)//'_yflux_overflow_int_z',                            &
              Grd%tracer_axes_flux_y(1:2), Time%model_time,                             &
              'vert-integ overflow_yflux*dxt*rho*dzt*tracer for '//trim(T_prog(n)%name),&
              'kg/sec', missing_value=missing_value, range=(/-1.e9,1.e9/)) 
       endif
    enddo

    if (debug_this_module) then
       write(stdoutunit,*) ' '
       write(stdoutunit,*) '==Global sums from ocean_overflow_mod== '
       call write_timestamp(Time%model_time)
       write(stdoutunit,'(a,es24.17)') &
       'slope_x        = ',mpp_global_sum(Dom%domain2d,slope_x(:,:), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'slope_y        = ',mpp_global_sum(Dom%domain2d,slope_y(:,:), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_slope(1) = ',mpp_global_sum(Dom%domain2d,topog_slope(:,:,1), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_slope(2) = ',mpp_global_sum(Dom%domain2d,topog_slope(:,:,2), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_slope(3) = ',mpp_global_sum(Dom%domain2d,topog_slope(:,:,3), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_slope(4) = ',mpp_global_sum(Dom%domain2d,topog_slope(:,:,4), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_step(1)  = ',mpp_global_sum(Dom%domain2d,topog_step(:,:,1), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_step(2)  = ',mpp_global_sum(Dom%domain2d,topog_step(:,:,2), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_step(3)  = ',mpp_global_sum(Dom%domain2d,topog_step(:,:,3), global_sum_flag)
       write(stdoutunit,'(a,es24.17)') &
       'topog_step(4)  = ',mpp_global_sum(Dom%domain2d,topog_step(:,:,4), global_sum_flag)
    endif

  end subroutine ocean_overflow_init
! </SUBROUTINE> NAME="ocean_overflow_init"


!#######################################################################
! <SUBROUTINE NAME="overflow">
!
! <DESCRIPTION>
! Compute thickness and density weighted tracer source [tracer*rho*m/s]
! due to upstream tracer advection in regions where density-driven
! overflows are favorable. 
!
! The MOM implementation of the Campin and Goosse (1999)
! algorithm is detailed in MOM Elements.
!
! </DESCRIPTION>
!
subroutine overflow (Time, Thickness, T_prog, Dens, index_temp, index_salt)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(inout) :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_density_type),     intent(in)    :: Dens
  integer,                      intent(in)    :: index_temp
  integer,                      intent(in)    :: index_salt

  integer, dimension(isd:ied,jsd:jed,4) :: kup
  integer, dimension(isd:ied,jsd:jed,4) :: kdw

  real, dimension(0:nk)              :: source_check
  real, dimension(0:nk)              :: flux
  real, dimension(nk)                :: source_column
  real, dimension(isd:ied,jsd:jed)   :: tmp

  integer :: tau, taum1
  integer :: i, j, k, m, n
  real    :: temp_so, salt_so, press, density_check
  real    :: overflow_thickness, overflow_speed
  real    :: max_overflow_flux

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if(.not. use_this_module) return 

  if(.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_overflow_mod (overflow): module must be initialized')
  endif 

  tau     = Time%tau
  taum1   = Time%taum1
  wrk2_v  = 0.0

  ! compute grid details for cells participating in downslope flow 
  ! note:  "so" = "shallow ocean" cell 
  ! note:  "do" = cells within the "deep ocean" column 

  kup(:,:,:) = 0
  kdw(:,:,:) = 0
  overflow_flux(:,:,:) = 0.0
  overflow_xflux(:,:)  = 0.0
  overflow_yflux(:,:)  = 0.0

  do m=1,4
    do j=jsc,jec
       do i=isc,iec

           max_overflow_flux = Grd%dat(i,j)*p5dtimer

           ! check to see if downslope flow is topographically possible
           if(topog_step(i,j,m) == 1.0) then  

               ! check to see if density of so-cell > density of adjacent do-cell  
               k = Grd%kmt(i,j) 
               if(Dens%rho(i,j,k,tau) > Dens%rho(i+ip(m),j+jq(m),k,tau)) then   

                   ! k-level of shallow-ocn (so) bottom cell
                   kup(i,j,m) = Grd%kmt(i,j) 

                   ! speed (m/sec) of downslope flow 
                   k=kup(i,j,m) 
                   temp_so     = T_prog(index_temp)%field(i,j,k,tau)         
                   salt_so     = Dens%rho_salinity(i,j,k,tau) 
                   overflow_speed = overflow_factor*topog_slope(i,j,m) &
                                    *(Dens%rho(i,j,k,tau)-Dens%rho(i+ip(m),j+jq(m),k,tau))
                   overflow_speed = min(overflow_speed,overflow_umax)

                   ! kdw = k-level in the do-column where so-cell is neutrally buoyant or at bottom
                   kdw(i,j,m) = kup(i,j,m)
                   do k=kup(i,j,m)+1,Grd%kmt(i+ip(m),j+jq(m))
                      press         = Dens%pressure_at_depth(i+ip(m),j+jq(m),k)
                      density_check = density(salt_so,temp_so,press)
                      if(density_check > Dens%rho(i+ip(m),j+jq(m),k,tau)) then 
                          kdw(i,j,m)=k
                      else 
                          exit
                      endif
                   enddo

                   ! compute m^2/sec flux leaving vertical face of cell  
                   if(m==1 .or. m==3) then 
                       overflow_flux(i,j,m)=overflow_speed*Grd%dyt(i,j)
                   elseif(m==2 .or. m==4) then 
                       overflow_flux(i,j,m)=overflow_speed*Grd%dxt(i,j)
                   endif

                   ! check for too large flux. based on 1D diffusive stability criteria, 
                   ! no more than one-half the mass of a grid cell can be mixed per time 
                   ! step, which means
                   ! overflow_flux(m^2/sec)*rho_dzt*dtime < 0.5*rho_dzt*dat, 
                   ! or equivalently overflow_flux(m^2/sec) < 0.5*dat/dtime
                   overflow_flux(i,j,m) = min(overflow_flux(i,j,m),max_overflow_flux) 

                   ! convert from m^2/sec to (kg/sec) using min rho_dzt
                   k=kup(i,j,m)
                   overflow_thickness = min(Thickness%rho_dzt(i,j,k,tau), &
                                            Thickness%rho_dzt(i+ip(m),j+jq(m),k,tau)) 
                   do k=kup(i,j,m),kdw(i,j,m)
                     overflow_thickness = min(overflow_thickness,Thickness%rho_dzt(i+ip(m),j+jq(m),k,tau))
                   enddo
                   overflow_flux(i,j,m) = overflow_flux(i,j,m)*overflow_thickness

                   ! for diagnostics: mass transport (kg/sec) off the shelf
                   if(m==1) overflow_xflux(i,j) = overflow_xflux(i,j) + overflow_flux(i,j,m)
                   if(m==2) overflow_yflux(i,j) = overflow_yflux(i,j) + overflow_flux(i,j,m)
                   if(m==3) overflow_xflux(i,j) = overflow_xflux(i,j) - overflow_flux(i,j,m)
                   if(m==4) overflow_yflux(i,j) = overflow_yflux(i,j) - overflow_flux(i,j,m)

               endif    ! if-test for density difference
           endif      ! if-test for topog_step(i,j,m)==1.0
        enddo      ! i-end  
     enddo      ! j-end
  enddo      ! m-end for the four surrounding cells 

  call mpp_update_domains(overflow_flux(:,:,:),Dom%domain2d)
  call mpp_update_domains(kup(:,:,:),Dom%domain2d)
  call mpp_update_domains(kdw(:,:,:),Dom%domain2d)

  if (debug_this_module) then
     write(stdoutunit,*) ' '
     write(stdoutunit,*) '==Global sums from ocean_overflow_mod== '
     call write_timestamp(Time%model_time)
     write(stdoutunit,'(a,es24.17)')  'overflow_flux(1)(kg/sec) = ',&
       mpp_global_sum(Dom%domain2d,overflow_flux(:,:,1), global_sum_flag)
     write(stdoutunit,'(a,es24.17)')  'overflow_flux(2)(kg/sec) = ',&
       mpp_global_sum(Dom%domain2d,overflow_flux(:,:,2), global_sum_flag)
     write(stdoutunit,'(a,es24.17)')  'overflow_flux(3)(kg/sec) = ',&
       mpp_global_sum(Dom%domain2d,overflow_flux(:,:,3), global_sum_flag)
     write(stdoutunit,'(a,es24.17)')  'overflow_flux(4)(kg/sec) = ',&
       mpp_global_sum(Dom%domain2d,overflow_flux(:,:,4), global_sum_flag)
     write(stdoutunit,'(a,i22)')      'kup(1)           = ',&
       mpp_global_sum(Dom%domain2d,kup(:,:,1), global_sum_flag)
     write(stdoutunit,'(a,i22)')      'kup(2)           = ',&
       mpp_global_sum(Dom%domain2d,kup(:,:,2), global_sum_flag)
     write(stdoutunit,'(a,i22)')      'kup(3)           = ',&
       mpp_global_sum(Dom%domain2d,kup(:,:,3), global_sum_flag)
     write(stdoutunit,'(a,i22)')      'kup(4)           = ',&
       mpp_global_sum(Dom%domain2d,kup(:,:,4), global_sum_flag)
     write(stdoutunit,'(a,i22)')      'kdw(1)           = ',&
       mpp_global_sum(Dom%domain2d,kdw(:,:,1), global_sum_flag)
     write(stdoutunit,'(a,i22)')      'kdw(2)           = ',&
       mpp_global_sum(Dom%domain2d,kdw(:,:,2), global_sum_flag)
     write(stdoutunit,'(a,i22)')      'kdw(3)           = ',&
       mpp_global_sum(Dom%domain2d,kdw(:,:,3), global_sum_flag)
     write(stdoutunit,'(a,i22)')      'kdw(4)           = ',&
       mpp_global_sum(Dom%domain2d,kdw(:,:,4), global_sum_flag)
  endif

  ! compute fluxes and the source for those 
  ! cells participating in downslope transport 

  ! do the mass first
  if (no_return_flow) then

     source_overflow(:,:,:) = 0.0
     flux_int_z(:,:,:)      = 0.0
     wrk1(:,:,:)=0.0 ; wrk2(:,:,:)=0.0 ; wrk3(:,:,:)=0.0 ; wrk4(:,:,:)=0.0
     flux(:) = 0.0

     ! extended do-loop limits perform extra computations, but
     ! save time by reducing need to call to mpp_update_domains.
     do m=1,4
        do j=jsc-ijsc(m),jec+ijec(m)
           do i=isc-ijsc(m),iec+ijec(m)
              
              ! see if (i,j) is a so-cell participating in downslope flow in the m-direction
              if(kup(i,j,m) > 0) then

                 ! initialize upstream mass flux leaving tracer cells
                 flux(0) = 0.0

                 ! initialize thickness*density weighted mass tendency in column
                 source_column(:) = 0.0

                 ! mass flux horizontally leaving so-cell at k=kup and entering do-cell at k=kdw
                 k=kup(i,j,m)
                 flux(0) = overflow_flux(i,j,m)

                 ! for diagnosing mass transport in 3-d space  
                 if(m==1) wrk2_v(i,j,k,1) = wrk2_v(i,j,k,1) + overflow_flux(i,j,m)
                 if(m==2) wrk2_v(i,j,k,2) = wrk2_v(i,j,k,2) + overflow_flux(i,j,m)
                 if(m==3) wrk2_v(i,j,k,1) = wrk2_v(i,j,k,1) - overflow_flux(i,j,m)
                 if(m==4) wrk2_v(i,j,k,2) = wrk2_v(i,j,k,2) - overflow_flux(i,j,m)

                 ! mass source for so-cell at k=kup [(kg/m^3)*(m/s)]
                 source_overflow(i,j,k) = source_overflow(i,j,k) - Grd%datr(i,j)*flux(0)

                 ! mass source for do-cell at k=kdw  [(kg/m^3)*(m/s)]
                 k = kdw(i,j,m)
                 source_column(k) = Grd%datr(i+ip(m),j+jq(m)) * flux(0)

                 if(m==1) then 
                    wrk1(i,j,:) = source_column(:)
                    wrk2_v(i+ip(m),j+jq(m),k,1) = wrk2_v(i+ip(m),j+jq(m),k,1) + overflow_flux(i,j,m)
                 endif 
                 if(m==2) then 
                    wrk2(i,j,:) = source_column(:)
                    wrk2_v(i+ip(m),j+jq(m),k,2) = wrk2_v(i+ip(m),j+jq(m),k,2) + overflow_flux(i,j,m) 
                 endif 
                 if(m==3) then 
                    wrk3(i,j,:) = source_column(:)
                    wrk2_v(i+ip(m),j+jq(m),k,1) = wrk2_v(i+ip(m),j+jq(m),k,1) - overflow_flux(i,j,m) 
                 endif 
                 if(m==4) then 
                    wrk4(i,j,:) = source_column(:)
                    wrk2_v(i+ip(m),j+jq(m),k,2) = wrk2_v(i+ip(m),j+jq(m),k,2) - overflow_flux(i,j,m)
                 endif 

              endif ! kup(i,j,m) > 0
           enddo ! i-end
        enddo ! j-end
     enddo ! m-end for the four directions

     ! each cell can have a mass source five different ways:
     ! 1:   when cell is the so-cell
     ! 2-5: when cell is one of the do-cells for adjacent so-cells.
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              source_overflow(i,j,k)  = source_overflow(i,j,k)   &
                                        + wrk1(i-1,j,k) &
                                        + wrk2(i,j-1,k) &
                                        + wrk3(i+1,j,k) &
                                        + wrk4(i,j+1,k)
              if (source_overflow(i,j,k) .ne. 0.0) then
                 Thickness%mass_source(i,j,k) = Thickness%mass_source(i,j,k) + source_overflow(i,j,k)
              endif
           enddo
        enddo
     enddo

     call mpp_update_domains(Thickness%mass_source(:,:,:),Dom%domain2d)
     
  endif ! no_return_flow?

  ! now do the tracer
  ! tracer source = convergence of upstream advective fluxes 
  wrk1_v(:,:,:,:) = 0.0
  do n=1,num_prog_tracers 

     source_overflow(:,:,:) = 0.0
     flux_int_z(:,:,:)      = 0.0 
     wrk1=0.0 ; wrk2=0.0 ; wrk3=0.0 ; wrk4=0.0

     ! extended do-loop limits perform extra computations, but  
     ! save time by reducing need to call to mpp_update_domains.
     do m=1,4
        do j=jsc-ijsc(m),jec+ijec(m)
           do i=isc-ijsc(m),iec+ijec(m)

              ! see if (i,j) is a so-cell participating in downslope flow in the m-direction
              if(kup(i,j,m) > 0) then 

                  ! initialize upstream tracer flux leaving tracer cells   
                  flux(:) = 0.0

                  ! initialize thickness*density weighted tendency in column 
                  source_column(:) = 0.0

                  ! flux horizontally leaving so-cell at k=kup and entering do-cell at k=kdw 
                  k=kup(i,j,m) 
                  flux(0) = overflow_flux(i,j,m)*T_prog(n)%field(i,j,k,taum1)

                  if (.not. no_return_flow) then
                     ! flux leaving do-cells
                     do k=kup(i,j,m),kdw(i,j,m)
                        flux(k) = overflow_flux(i,j,m)*T_prog(n)%field(i+ip(m),j+jq(m),k,taum1)
                     enddo

                     ! source for so-cell at k=kup [tracer*(kg/m^3)*(m/s)] 
                     k = kup(i,j,m)
                     source_overflow(i,j,k) = source_overflow(i,j,k) + Grd%datr(i,j)*flux(k) 

                     ! source for do-cell at k=kdw  [tracer*(kg/m^3)*(m/s)]
                     k = kdw(i,j,m)
                     source_column(k) = - Grd%datr(i+ip(m),j+jq(m))*flux(k)

                     ! source for do-cell with kup <= k <= kdw-1 [tracer*(kg/m^3)*(m/s)]
                     if(kdw(i,j,m) > kup(i,j,m)) then 
                        do k = kup(i,j,m),kdw(i,j,m)-1
                           source_column(k) = Grd%datr(i+ip(m),j+jq(m))*(flux(k+1)-flux(k)) 
                        enddo
                     endif

                  endif !.not. no_return_flow

                  ! for diagnosing vertically integrated horizontal flux
                  flux_int_z(i,j,m) = flux_int_z(i,j,m) + flux(0)-flux(kup(i,j,m))
                  
                  ! source for so-cell at k=kup [tracer*(kg/m^3)*(m/s)]
                  k = kup(i,j,m)
                  source_overflow(i,j,k) = source_overflow(i,j,k) - Grd%datr(i,j)*flux(0)

                  ! source for do-cell at k=kdw  [tracer*(kg/m^3)*(m/s)]
                  k = kdw(i,j,m)
                  source_column(k) = source_column(k) + Grd%datr(i+ip(m),j+jq(m))*flux(0)
                  
                  if(m==1) wrk1(i,j,:) = source_column(:) 
                  if(m==2) wrk2(i,j,:) = source_column(:) 
                  if(m==3) wrk3(i,j,:) = source_column(:) 
                  if(m==4) wrk4(i,j,:) = source_column(:)


              endif  ! kup(i,j,m) > 0
           enddo ! i-end 
        enddo  ! j-end
     enddo  ! m-end for the four directions 

     ! each cell can have a source five different ways:
     ! 1:   when cell is the so-cell
     ! 2-5: when cell is one of the do-cells for adjacent so-cells.
     do k=1,nk
        do j=jsc,jec   
           do i=isc,iec
              source_overflow(i,j,k)  = source_overflow(i,j,k)   &
                                        + wrk1(i-1,j,k) & 
                                        + wrk2(i,j-1,k) &
                                        + wrk3(i+1,j,k) &
                                        + wrk4(i,j+1,k)
              if (source_overflow(i,j,k) .ne. 0.0) then
                 T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + source_overflow(i,j,k)
              endif
           enddo
        enddo
     enddo

     ! for some diagnostics 
     if(n==index_temp) then 
         wrk1_v(:,:,:,1) = 0.0
         do k=1,nk
            do j=jsc,jec   
               do i=isc,iec
                  wrk1_v(i,j,k,1) = source_overflow(i,j,k)
               enddo
            enddo
         enddo
     endif
     if(n==index_salt) then 
         wrk1_v(:,:,:,2) = 0.0
         do k=1,nk
            do j=jsc,jec   
               do i=isc,iec
                  wrk1_v(i,j,k,2) = source_overflow(i,j,k)
               enddo
            enddo
         enddo
     endif

     if (debug_this_module) then
        source_check(:) = 0.0
        do k=1,nk
           do j=jsc,jec  
             do i=isc,iec
               tmp(i,j) =  T_prog(n)%conversion*dtime*Grd%dat(i,j)*source_overflow(i,j,k)
             enddo
           enddo    
           source_check(k) = mpp_global_sum(Dom%domain2d,tmp(:,:), global_sum_flag)
        enddo
        do k=1,nk
           source_check(0) = source_check(0) + source_check(k)
        enddo
        if(T_prog(n)%name == 'temp' ) then 
           write(stdoutunit,'(a,i3,a,es24.17)') &
           'For tracer(',n,'), (temp   ) total overflow source is (J) ', source_check(0)
        elseif(T_prog(n)%name == 'salt' ) then 
           write(stdoutunit,'(a,i3,a,es24.17)') &
           'For tracer(',n,'), (salt   ) total overflow source is (kg)', source_check(0)
        else 
           write(stdoutunit,'(a,i3,a,es24.17)') &
           'For tracer(',n,'), (passive) total overflow source is (kg)', source_check(0)
        endif 
     endif

     ! send some diagnostics that are functions of tracer
     if(id_overflow(n) > 0) then 
        call diagnose_3d(Time, Grd, id_overflow(n), T_prog(n)%conversion*source_overflow(:,:,:))
     endif
     if(id_overflow_xflux_int_z(n) > 0) then 
        call diagnose_2d(Time, Grd, id_overflow_xflux_int_z(n),             &
                T_prog(n)%conversion*(flux_int_z(:,:,1)-flux_int_z(:,:,3)))
     endif 
     if(id_overflow_yflux_int_z(n) > 0) then 
        call diagnose_2d(Time, Grd, id_overflow_yflux_int_z(n),             &
                T_prog(n)%conversion*(flux_int_z(:,:,2)-flux_int_z(:,:,4)))
     endif

  enddo  ! n-end for num_prog_tracers 


  ! diagnostics for tracer independent mass transports 
  call diagnose_2d(Time, Grd, id_overflow_xflux, overflow_xflux(:,:))
  call diagnose_2d(Time, Grd, id_overflow_yflux, overflow_yflux(:,:))

  if (id_tx_trans_overflow > 0) then 
     call diagnose_3d(Time, Grd, id_tx_trans_overflow, transport_convert*wrk2_v(:,:,:,1))
  endif
  if (id_ty_trans_overflow > 0) then 
     call diagnose_3d(Time, Grd, id_ty_trans_overflow, transport_convert*wrk2_v(:,:,:,2))
  endif

  call watermass_diag(Time, Dens, wrk1_v)


end subroutine overflow
! </SUBROUTINE> NAME="overflow"



!#######################################################################
! <SUBROUTINE NAME="watermass_diag_init">
!
! <DESCRIPTION>
! Initialization of watermass diagnostic output files. 
! </DESCRIPTION>
!
subroutine watermass_diag_init(Time, Dens)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens

  integer :: stdoutunit
  stdoutunit=stdout()
  compute_watermass_diag = .false. 

  id_neut_rho_overfl = register_diag_field ('ocean_model', 'neut_rho_overfl',&
       Grd%tracer_axes(1:3), Time%model_time,                                &
       'update of locally referenced potrho from overflow scheme',           &
       '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_overfl > 0) compute_watermass_diag = .true. 

  id_neut_rho_overfl_on_nrho = register_diag_field ('ocean_model',                  &
       'neut_rho_overfl_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,        &
       'update of locally ref potrho from overflow as binned to neutral rho layers',&
       '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_overfl_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_rho_overfl = register_diag_field ('ocean_model',      &
       'wdian_rho_overfl', Grd%tracer_axes(1:3), Time%model_time,&
       'dianeutral mass transport due to overflow',              &
       'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_overfl > 0) compute_watermass_diag = .true. 

  id_wdian_rho_overfl_on_nrho = register_diag_field ('ocean_model',                &
       'wdian_rho_overfl_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,     &
       'dianeutral mass transport due to overflow as binned to neutral rho layers',&
       'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_overfl_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_rho_overfl_on_nrho = register_diag_field ('ocean_model',           &
       'tform_rho_overfl_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,&
       'watermass transform due to overflow as binned to neutral rho layers', &
       'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_overfl_on_nrho > 0) compute_watermass_diag = .true. 



  id_neut_temp_overfl = register_diag_field ('ocean_model', 'neut_temp_overfl',&
       Grd%tracer_axes(1:3), Time%model_time,                                  &
       'temp related update of locally referenced potrho from overflow scheme',&
       '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_overfl > 0) compute_watermass_diag = .true. 

  id_neut_temp_overfl_on_nrho = register_diag_field ('ocean_model',                           &
       'neut_temp_overfl_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,                 &
       'temp related update of locally ref potrho from overflow binned to neutral rho layers',&
       '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_overfl_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_temp_overfl = register_diag_field ('ocean_model',      &
       'wdian_temp_overfl', Grd%tracer_axes(1:3), Time%model_time,&
       'temp related dianeutral mass transport due to overflow',  &
       'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_overfl > 0) compute_watermass_diag = .true. 

  id_wdian_temp_overfl_on_nrho = register_diag_field ('ocean_model',                         &
       'wdian_temp_overfl_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,              &
       'temp related dianeutral mass transport due to overflow binned to neutral rho layers',&
       'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_overfl_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_temp_overfl_on_nrho = register_diag_field ('ocean_model',                      &
       'tform_temp_overfl_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,           &
       'temp related watermass transform due to overflow as binned to neutral rho layers',&
       'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_overfl_on_nrho > 0) compute_watermass_diag = .true. 


  id_neut_salt_overfl = register_diag_field ('ocean_model', 'neut_salt_overfl',&
       Grd%tracer_axes(1:3), Time%model_time,                                  &
       'salt related update of locally referenced potrho from overflow scheme',&
       '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_overfl > 0) compute_watermass_diag = .true. 

  id_neut_salt_overfl_on_nrho = register_diag_field ('ocean_model',                           &
       'neut_salt_overfl_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,                 &
       'salt related update of locally ref potrho from overflow binned to neutral rho layers',&
       '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_overfl_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_salt_overfl = register_diag_field ('ocean_model',      &
       'wdian_salt_overfl', Grd%tracer_axes(1:3), Time%model_time,&
       'salt related dianeutral mass transport due to overflow',  &
       'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_overfl > 0) compute_watermass_diag = .true. 

  id_wdian_salt_overfl_on_nrho = register_diag_field ('ocean_model',                         &
       'wdian_salt_overfl_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,              &
       'salt related dianeutral mass transport due to overflow binned to neutral rho layers',&
       'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_overfl_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_salt_overfl_on_nrho = register_diag_field ('ocean_model',                      &
       'tform_salt_overfl_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,           &
       'salt related watermass transform due to overflow as binned to neutral rho layers',&
       'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_overfl_on_nrho > 0) compute_watermass_diag = .true. 



  if(compute_watermass_diag) then 
      write(stdoutunit,'(/a/)') &
      '==>Note: running ocean_overflow_mod w/ compute_watermass_diag=.true.'  
  endif

end subroutine watermass_diag_init
! </SUBROUTINE> NAME="watermass_diag_init"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag">
!
! <DESCRIPTION>
! Diagnose effects from overflow on the watermass transformation.
! </DESCRIPTION>
!
subroutine watermass_diag(Time, Dens, wrk1_v)

  type(ocean_time_type),           intent(in)    :: Time
  type(ocean_density_type),        intent(in)    :: Dens
  real, dimension(isd:,jsd:,:,:),  intent(inout) :: wrk1_v

  integer :: i,j,k

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_overflow (watermass_diag): module needs initialization ')
  endif 

  if (.not. compute_watermass_diag) return

  ! full effects on rho 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Grd%tmask(i,j,k)*(Dens%drhodT(i,j,k)*wrk1_v(i,j,k,1)+Dens%drhodS(i,j,k)*wrk1_v(i,j,k,2))
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)  
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_overfl,wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_overfl, wrk3(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_overfl_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_overfl_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_overfl_on_nrho, wrk4)

  ! temperature effects on rho 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Grd%tmask(i,j,k)*Dens%drhodT(i,j,k)*wrk1_v(i,j,k,1)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)  
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_overfl,wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_overfl, wrk3(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_overfl_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_overfl_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_overfl_on_nrho, wrk4)

  ! salinity effects on rho 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Grd%tmask(i,j,k)*Dens%drhodS(i,j,k)*wrk1_v(i,j,k,2)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)  
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_overfl,wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_overfl, wrk3(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_overfl_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_overfl_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_overfl_on_nrho, wrk4)


end subroutine watermass_diag
! </SUBROUTINE>  NAME="watermass_diag"


end module ocean_overflow_mod

#include <fms_platform.h>

module soil_tile_mod

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only : &
     write_version_number, file_exist, check_nml_error, &
     close_file, stdlog, read_data, error_mesg, FATAL
use constants_mod, only : &
     pi, tfreeze, rvgas, grav, dens_h2o, hlf
use land_constants_mod, only : &
     NBANDS
use land_io_mod, only : &
     init_cover_field, print_netcdf_error
use land_tile_selectors_mod, only : &
     tile_selector_type, SEL_SOIL, register_tile_selector

implicit none
private

! ==== netcdf declarations ===================================================
include 'netcdf.inc'
#define __NF_ASRT__(x) call print_netcdf_error((x),module_name,__LINE__)

! ==== public interfaces =====================================================
public :: soil_pars_type
public :: soil_prog_type
public :: soil_tile_type

public :: new_soil_tile, delete_soil_tile
public :: soil_tiles_can_be_merged, merge_soil_tiles
public :: soil_is_selected
public :: get_soil_tile_tag
public :: soil_tile_stock_pe
public :: soil_tile_heat, soil_tile_carbon

public :: read_soil_data_namelist
public :: soil_cover_cold_start

public :: soil_data_radiation
public :: soil_data_diffusion
public :: soil_data_thermodynamics
public :: soil_data_hydraulic_properties
public :: soil_data_psi_for_rh
public :: soil_data_gw_hydraulics
public :: soil_data_gw_hydraulics_ar5
public :: soil_data_vwc_for_init_only
public :: soil_data_init_derive_subsurf_pars
public :: soil_data_init_derive_subsurf_pars_ar5
public :: soil_ave_temp  ! calculate average soil temeperature
public :: soil_ave_theta0! calculate average soil moisture, pcm based on available water, zeta input
public :: soil_ave_theta1! calculate average soil moisture, ens based on all water
public :: soil_theta     ! returns array of soil moisture, for all layers
public :: soil_psi_stress ! return soil-water-stress index
public :: g_iso, g_vol, g_geo, g_RT
public :: num_storage_pts
public :: gw_zeta_s, gw_flux_table, gw_area_table
public :: gw_scale_length, gw_scale_relief, gw_scale_soil_depth, slope_exp
public :: num_zeta_pts, num_tau_pts
public :: log_tau, log_zeta_s, log_rho_table, gw_scale_perm, aspect
public :: use_alpha, z_ref, k_macro_constant, use_tau_fix

public :: max_lev, psi_wilt
! =====end of public interfaces ==============================================
interface new_soil_tile
   module procedure soil_tile_ctor
   module procedure soil_tile_copy_ctor
end interface

! ==== module constants ======================================================
character(len=*), parameter   :: &
     version     = '$Id: soil_tile.F90,v 20.0 2013/12/13 23:30:50 fms Exp $', &
     tagname     = '$Name: tikal $', &
     module_name = 'soil_tile_mod'

integer, parameter :: max_lev          = 100 
integer, parameter :: n_dim_soil_types = 9       ! size of lookup table
real,    parameter :: small            = 1.e-4
real,    parameter :: t_ref            = 293
real,    parameter :: g_RT             = grav / (rvgas*t_ref)
real,    parameter :: sigma_max        = 2.2
real,    parameter :: K_rel_min        = 1.e-12

! from the modis brdf/albedo product user's guide:
real            :: g_iso  = 1.
real            :: g_vol  = 0.189184
real            :: g_geo  = -1.377622
real            :: g0_iso = 1.0
real            :: g1_iso = 0.0
real            :: g2_iso = 0.0
real            :: g0_vol = -0.007574
real            :: g1_vol = -0.070987
real            :: g2_vol =  0.307588
real            :: g0_geo = -1.284909
real            :: g1_geo = -0.166314
real            :: g2_geo =  0.041840

! geohydrology option selector (not used by lm2)
integer, parameter, public ::   &
     GW_LM2            = 0, &
     GW_LINEAR         = 1, &
     GW_HILL_AR5       = 2, &
     GW_HILL           = 3, &
     GW_TILED          = 4

! ==== types =================================================================
type :: soil_pars_type
  real vwc_wilt
  real vwc_fc
  real vwc_sat
  real vlc_min
  real awc_lm2
  real k_sat_ref
  real psi_sat_ref
  real chb
  real heat_capacity_dry
  real thermal_cond_dry
  real thermal_cond_sat
  real thermal_cond_exp
  real thermal_cond_scale
  real thermal_cond_weight
  real refl_dry_dir(NBANDS)
  real refl_dry_dif(NBANDS)
  real refl_sat_dir(NBANDS)
  real refl_sat_dif(NBANDS)
  real f_iso_dry(NBANDS)
  real f_vol_dry(NBANDS)
  real f_geo_dry(NBANDS)
  real f_iso_sat(NBANDS)
  real f_vol_sat(NBANDS)
  real f_geo_sat(NBANDS)
  real emis_dry
  real emis_sat
  real z0_momentum
  real tau_groundwater
  real rsa_exp         ! riparian source-area exponent
  real hillslope_length
  real hillslope_relief
  real hillslope_zeta_bar
  real soil_e_depth
  real zeta
  real tau
  real k_sat_gw
  real k_sat_sfc
  integer storage_index
  real tfreeze
end type soil_pars_type


type :: soil_prog_type
  real wl
  real ws
  real T
  real groundwater
  real groundwater_T
end type soil_prog_type


type :: soil_tile_type
   integer :: tag ! kind of the soil
   type(soil_pars_type)               :: pars
   type(soil_prog_type), pointer :: prog(:)
   real,                 pointer :: w_fc(:)
   real,                 pointer :: w_wilt(:)
   real,                 pointer :: d_trans(:)
   real,                 pointer :: alpha(:)
   real,                 pointer :: k_macro(:)
   real :: Eg_part_ref
   real :: z0_scalar
   real :: geothermal_heat_flux
   real :: psi_x0 = -1000.
   ! data that were local to soil.f90
   real,                 pointer :: uptake_frac(:)
   real,                 pointer :: heat_capacity_dry(:)
   real,                 pointer :: e(:),f(:)
   ! added to avoid recalculation of soil hydraulics in case of Darcy uptake
   real          :: uptake_T
   real, pointer :: psi(:) ! soil water potential
   real,                 pointer ::  gw_flux_norm(:)
   real,                 pointer ::  gw_area_norm(:)

   ! soil carbon
   real, pointer :: fast_soil_C(:) => NULL() ! fast soil carbon pool, (kg C/m2), per layer
   real, pointer :: slow_soil_C(:) => NULL() ! slow soil carbon pool, (kg C/m2), per layer
   ! values for the diagnostic of carbon budget and soil carbon acceleration
   real, pointer :: asoil_in(:)    => NULL()
   real, pointer :: fsc_in(:)      => NULL()
   real, pointer :: ssc_in(:)      => NULL()
end type soil_tile_type

! ==== module data ===========================================================
integer :: gw_option

real, public :: &
     cpw = 1952.0, & ! specific heat of water vapor at constant pressure
     clw = 4218.0, & ! specific heat of water (liquid)
     csw = 2106.0    ! specific heat of water (ice)

!---- namelist ---------------------------------------------------------------
real    :: psi_wilt              = -150.0  ! matric head at wilting
real    :: comp                  = 0.001  ! m^-1, dThdPsi at saturation
real    :: k_over_B              = 2         ! reset to 0 for MCM
real    :: rate_fc               = 0.1/86400 ! 0.1 mm/d drainage rate at FC
real    :: sfc_heat_factor       = 1
real    :: z_sfc_layer           = 0.0
real    :: sub_layer_tc_fac      = 1.0
real    :: z_sub_layer_min       = 0.0
real    :: z_sub_layer_max       = 0.0
real    :: freeze_factor         = 1.0
real    :: aspect                = 1.0
real    :: zeta_mult             = 1.0  ! multiplier for root depth scale in stress index
integer :: num_l                 = 18        ! number of soil levels
real    :: dz(max_lev)           = (/ &
    0.02, 0.04, 0.04, 0.05, 0.05, 0.1, 0.1, 0.2, 0.2, &
    0.2,   0.4,  0.4,  0.4,  0.4, 0.4,  1.,  1.,  1., &
    0.,0.,&
    0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,&
    0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,&
    0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,&
    0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,&
    0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,&
    0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,&
    0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,&
    0.,0.,0.,0.,0.,0.,0.,0.,0.,0. /)
                                              ! thickness (m) of model layers,
                                              ! from top down
logical :: use_lm2_awc           = .false.
logical :: lm2                   = .false.
logical :: use_alt_psi_for_rh    = .false.
logical :: use_tau_fix           = .false.
logical :: use_sat_fix           = .false.
logical :: use_comp_for_ic       = .false.
! ---- remainder are used only for cold start ---------
character(32):: soil_to_use     = 'single-tile'
       ! 'multi-tile' for multiple soil types per grid cell, a tile per type
       ! 'single-tile' for geographically varying soil with single type per
       !     model grid cell [default]
       ! 'uniform' for global constant soil, e.g., to reproduce MCM
character(32) :: geohydrology_to_use = 'hill_ar5'
       ! 'lm2' for lm2 hydrology -- must be consistent with lm2 flag
       ! 'linear'
       ! 'hill' -- for hillslope geohydrology
       ! 'hill_ar5' -- hillslope geohydrology reproducing AR5 simulations

logical :: use_mcm_albedo        = .false.   ! .true. for CLIMAP albedo inputs
logical :: use_single_geo        = .false.   ! .true. for global gw res time,
                                             ! e.g., to recover MCM
logical :: use_alpha             = .false.   ! for vertical change in soil properties
integer :: soil_index_constant   = 9         ! index of global constant soil,
                                             ! used when use_single_soil
real    :: gw_res_time           = 60.*86400 ! mean groundwater residence time,
                                             ! used when use_single_geo
real    :: rsa_exp_global        = 1.5
real    :: gw_scale_length       = 1.0
real    :: gw_scale_relief       = 1.0
real    :: gw_scale_soil_depth   = 1.0
real    :: slope_exp             = 0.0
real    :: gw_scale_perm         = 1.0
real    :: k_macro_constant      = 0.0
real    :: log_rho_max           = 2.0
real    :: z_ref                 = 0.0       ! depth where [psi/k]_sat = [psi/k]_sat_ref
real    :: geothermal_heat_flux_constant = 0.0  ! true continental average is ~0.065 W/m2
real    :: Dpsi_min_const        = -1.e16

real, dimension(n_dim_soil_types) :: &
  dat_w_sat=&
  (/ 0.380, 0.445, 0.448, 0.412, 0.414, 0.446, 0.424, 0.445, 0.445   /),&
  dat_awc_lm2=&
  (/ 0.063, 0.132, 0.109, 0.098, 0.086, 0.120, 0.101, 0.445, 0.150   /),&
  dat_k_sat_ref=&
  (/ 0.021, .0036, .0018, .0087, .0061, .0026, .0051, .0036, .0036   /),&
  dat_psi_sat_ref=&
  (/ -.059, -0.28, -0.27, -0.13, -0.13, -0.27, -0.16, -0.28, -0.28   /),&
  dat_chb=&
  (/   3.5,   6.4,  11.0,   4.8,   6.3,   8.4,   6.3,   6.4,   6.4   /),&
!  dat_heat_capacity_ref =&
!  (/ 1.8e6, 2.0e6, 2.6e6, 1.9e6, 2.2e6, 2.3e6, 2.1e6, 3.0e6,   1.0   /),&
! previous (ref) values were based on typical water contents
! following dry values are based on w_min=(1-w_sat) w_org=0
! except for peat, where            w_org-(1-w_sat) w_min=0
! microscopic rho*c for w_min is 2650*733 and for w_org is 1300*1926
! (brutsaert 1982 evaporation into the atmosphere p 146)
! ignored air
  dat_heat_capacity_dry =&
  (/ 1.2e6, 1.1e6, 1.1e6, 1.1e6, 1.1e6, 1.1e6, 1.1e6, 1.4e6,   1.0   /),&
!  dat_thermal_cond_ref =&
!  (/   1.5,   0.8,  1.35,  1.15, 1.475, 1.075, 1.217,  0.39, 2.e-7   /),&
! previous (ref) values were based on typical water contents
! following dry and sat values and interpolating exponents are based on
! computations after deVries. i computed C M and F functions for
! unfrozen soil in
! spreadsheet Research\LaD2\soil thermal conductivity. the dry and
! sat values come right out of those computations. the exponent was
! done by eye. curves look like typical literature curves.
! TEMP: still need to treat freezing, maybe import deVries model into code.
  dat_thermal_cond_dry =&
  (/  0.14,  0.21,  0.20,  .175, 0.170, 0.205, 0.183,  0.05, 2.e-7   /),&
  dat_thermal_cond_sat =&
  (/  2.30,  1.50,  1.50,  1.90, 1.900, 1.500, 1.767,  0.50, 2.e-7   /),&
  dat_thermal_cond_scale =&
  (/  15.0,  0.50,   10.,  2.74,  12.2,  2.24,  4.22,   1.0,   1.0   /),&
  dat_thermal_cond_exp =&
  (/   3.0,   5.0,   6.0,   4.0,   4.5,   5.5, 4.667,   1.0,   1.0   /),&
  dat_thermal_cond_weight =&
  (/  0.20,  0.70,   0.7,  0.45, 0.450, 0.700, 0.533,   1.0,   1.0   /),&
  dat_emis_dry=&
  (/ 0.950, 0.950, 0.950, 0.950, 0.950, 0.950, 0.950, 0.950,   1.0   /),&
  dat_emis_sat=&
  (/ 0.980, 0.975, 0.970, .9775, 0.975, .9725, 0.975, 0.975,   1.0   /),&
  dat_z0_momentum=&
  (/  0.01,  0.01,  0.01,  0.01,  0.01,  0.01,  0.01,  0.01, 0.045   /),&
  dat_tf_depr=&
  (/  0.00,  0.00,  0.00,  0.00,  0.00,  0.00,  0.00,  0.00,   0.0   /)
  !Coarse  Medium   Fine    CM     CF     MF    CMF    Peat    MCM
real :: dat_refl_dry_dir(n_dim_soil_types,NBANDS); data dat_refl_dry_dir &
   / 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 999.0,      & ! visible
     0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 999.0   /     ! NIR
real :: dat_refl_dry_dif(n_dim_soil_types,NBANDS); data dat_refl_dry_dif &
   / 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 999.0,      & ! visible
     0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 999.0   /     ! NIR
real :: dat_refl_sat_dir(n_dim_soil_types,NBANDS); data dat_refl_sat_dir &
   / 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 999.0,      & ! visible
     0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 999.0   /     ! NIR
real :: dat_refl_sat_dif(n_dim_soil_types,NBANDS); data dat_refl_sat_dif &
   / 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 999.0,      & ! visible
     0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 0.333, 999.0   /     ! NIR
  !Coarse  Medium   Fine    CM     CF     MF    CMF    Peat    MCM
integer, dimension(n_dim_soil_types) :: &
  input_cover_types=&
  (/ 1,     2,     3,     4,     5,     6,     7,     8,     100   /)
character(len=4), dimension(n_dim_soil_types) :: &
  tile_names=&
  (/'c   ','m   ','f   ','cm  ','cf  ','mf  ','cmf ','peat','mcm ' /)

namelist /soil_data_nml/ psi_wilt, &
     soil_to_use, tile_names, input_cover_types, &
     comp, k_over_B,             &
     rate_fc, sfc_heat_factor, z_sfc_layer, &
     sub_layer_tc_fac, z_sub_layer_min, z_sub_layer_max, freeze_factor, &
     aspect, zeta_mult, num_l,  dz,                      &
     use_lm2_awc,    lm2, use_alt_psi_for_rh, &
     use_tau_fix, use_sat_fix, use_comp_for_ic, use_mcm_albedo,            &
     use_single_geo, geohydrology_to_use, &
     use_alpha, &
     soil_index_constant,         &
     gw_res_time,            rsa_exp_global,      &
     gw_scale_length, gw_scale_relief, gw_scale_soil_depth, &
     slope_exp, &
     gw_scale_perm, z_ref, geothermal_heat_flux_constant, &
     Dpsi_min_const, &
     k_macro_constant, log_rho_max, &
     dat_w_sat,               dat_awc_lm2,     &
     dat_k_sat_ref,            &
     dat_psi_sat_ref,               dat_chb,          &
     dat_heat_capacity_dry,       dat_thermal_cond_dry,   &
     dat_thermal_cond_sat,        dat_thermal_cond_exp,   &
     dat_thermal_cond_scale,        dat_thermal_cond_weight,   &
     dat_refl_dry_dir,            dat_refl_sat_dir,              &
     dat_refl_dry_dif,            dat_refl_sat_dif,              &
     dat_emis_dry,              dat_emis_sat,                &
     dat_z0_momentum,           dat_tf_depr
!---- end of namelist --------------------------------------------------------

real    :: gw_hillslope_length   = 1000.
real    :: gw_hillslope_relief   =  100.
real    :: gw_hillslope_zeta_bar =    0.5
real    :: gw_soil_e_depth       =    4.
real    :: gw_perm               = 3.e-14   ! nominal permeability, m^2
real :: gw_flux_table(26,31), gw_area_table(26,31)
real, allocatable :: log_rho_table(:,:,:)
real, allocatable :: log_deficit_list(:)
real, allocatable :: log_zeta_s(:)
real, allocatable :: log_tau(:)

real, dimension(31 ) :: gw_zeta_s       = &
  (/ 1.0000000e-5, 1.5848932e-5, 2.5118864e-5, 3.9810717e-5, 6.3095737e-5, &
     1.0000000e-4, 1.5848932e-4, 2.5118864e-4, 3.9810717e-4, 6.3095737e-4, &
     1.0000000e-3, 1.5848932e-3, 2.5118864e-3, 3.9810717e-3, 6.3095737e-3, &
     1.0000000e-2, 1.5848932e-2, 2.5118864e-2, 3.9810717e-2, 6.3095737e-2, &
     1.0000000e-1, 1.5848932e-1, 2.5118864e-1, 3.9810717e-1, 6.3095737e-1, &
     1.0000000e+0, 1.5848932e+0, 2.5118864e+0, 3.9810717e+0, 6.3095737e+0, &
     1.0000000e+1 /)

real, dimension(26) :: gw_storage_norm = &
  (/ 0.,      0.04000, 0.08000, 0.12000, 0.16000, 0.20000, &
     0.24000, 0.28000, 0.32000, 0.36000, 0.40000, 0.44000, &
     0.48000, 0.52000, 0.56000, 0.60000, 0.64000, 0.68000, &
     0.72000, 0.76000, 0.80000, 0.84000, 0.88000, 0.92000, &
     0.96000, 1.00000   /)
real, dimension(26) :: gw_flux_norm_zeta_s_04 = &
  (/ 0.0e000, 7.04e-6, 1.14e-5, 1.85e-5, 3.01e-5, 4.89e-5, &
     6.95e-5, 8.10e-5, 9.26e-5, 1.42e-4, 2.93e-4, 6.14e-4, &
     1.25e-3, 2.47e-3, 4.76e-3, 8.98e-3, 1.66e-2, 3.02e-2, &
     5.41e-2, 9.56e-2, 1.67e-1, 2.88e-1, 4.92e-1, 8.36e-1, &
     1.53e+0, 1.00e+1   /)
real, dimension(26) :: gw_area_norm_zeta_s_04 = &
  (/ 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, &
     0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, &
     0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, &
     0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, &
     3.48e-1, 1.00000  /)

integer :: num_sfc_layers, sub_layer_min, sub_layer_max
integer :: num_storage_pts, num_zeta_pts, num_tau_pts

real    :: zfull (max_lev)
real    :: zhalf (max_lev+1)

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

! ============================================================================
subroutine read_soil_data_namelist(soil_num_l, soil_dz, soil_single_geo, &
                                   soil_gw_option )
  integer, intent(out) :: soil_num_l
  real,    intent(out) :: soil_dz(:)
  logical, intent(out) :: soil_single_geo
  integer, intent(out) :: soil_gw_option
  ! ---- local vars
  integer :: unit         ! unit for namelist i/o
  integer :: io           ! i/o status for the namelist
  integer :: ierr         ! error code, returned by i/o routines
  integer :: i, rcode, ncid, varid, dimids(3)
  real    :: z

  call write_version_number(version, tagname)
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=soil_data_nml, iostat=io)
  ierr = check_nml_error(io, 'soil_data_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file()
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=soil_data_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'soil_data_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif
  unit=stdlog()
  write(unit, nml=soil_data_nml)
  
  ! register selector for all soil tiles
  call register_tile_selector('soil', long_name='soil',&
       tag = SEL_SOIL, idata1 = 0 )
  ! register selectors for tile-specific diagnostics
  do i=1, n_dim_soil_types
     call register_tile_selector(tile_names(i), long_name='',&
          tag = SEL_SOIL, idata1 = i )
  enddo
  z = 0
  num_sfc_layers = 0
  sub_layer_min = 0
  sub_layer_max = 0

  zhalf(1) = 0
  do i = 1, num_l
    zhalf(i+1) = zhalf(i) + dz(i)
    zfull(i)   = 0.5*(zhalf(i+1) + zhalf(i))
    
    if (z < z_sub_layer_min+1.e-4) sub_layer_min = i
    z = z + dz(i)
    if (z < z_sfc_layer+1.e-4) num_sfc_layers = i
    if (z < z_sub_layer_max+1.e-4) sub_layer_max = i
  enddo

!!$  write (*,*) 'min/max index of layers whose thermal cond is scaled:',sub_layer_min,sub_layer_max

  if (trim(geohydrology_to_use)=='lm2') then
     gw_option = GW_LM2
  else if (trim(geohydrology_to_use)=='linear') then
     gw_option = GW_LINEAR
  else if (trim(geohydrology_to_use)=='hill_ar5') then
     gw_option = GW_HILL_AR5
  else if (trim(geohydrology_to_use)=='hill') then
     gw_option = GW_HILL
  else
     call error_mesg('read_soil_data_namelist',&
        'option geohydrology_to_use="'//trim(geohydrology_to_use)//'" is invalid, use '// &
        ' "lm2", "linear", "hill", or "hill_ar5"', &
        FATAL)
  endif
  
  if ((gw_option==GW_LM2).neqv.lm2) then
     call error_mesg('read_soil_data_namelist',&
        'geohydrlogy/LM2 option conflict: geohydrology_to_use must be consistent with the LM2 flag', &
        FATAL)
  endif

  if (gw_option==GW_HILL_AR5.and..not.use_single_geo) then
     num_storage_pts = 26
     call read_data('INPUT/geohydrology_table.nc', 'gw_flux_norm', &
                 gw_flux_table, no_domain=.true.)
     call read_data('INPUT/geohydrology_table.nc', 'gw_area_norm', &
                 gw_area_table, no_domain=.true.)
  else if (gw_option==GW_HILL.or.gw_option==GW_HILL_AR5) then
     __NF_ASRT__(nf_open('INPUT/geohydrology_table.nc',NF_NOWRITE,ncid))
     __NF_ASRT__(nf_inq_varid(ncid,'log_rho',varid))
     __NF_ASRT__(nf_inq_vardimid(ncid,varid,dimids))
     __NF_ASRT__(nf_inq_dimlen(ncid,dimids(1),num_storage_pts))
     __NF_ASRT__(nf_inq_dimlen(ncid,dimids(2),num_tau_pts))
     __NF_ASRT__(nf_inq_dimlen(ncid,dimids(3),num_zeta_pts))
     __NF_ASRT__(nf_close(ncid))
     
     allocate (log_rho_table(num_storage_pts,  &
                                 num_tau_pts, num_zeta_pts))
     allocate (log_deficit_list(num_storage_pts))
     allocate (log_tau(num_tau_pts))
     allocate (log_zeta_s(num_zeta_pts))
  
     call read_data('INPUT/geohydrology_table.nc', 'log_rho', &
                 log_rho_table, no_domain=.true.)
     call read_data('INPUT/geohydrology_table.nc', 'log_deficit', &
                 log_deficit_list, no_domain=.true.)
     call read_data('INPUT/geohydrology_table.nc', 'log_tau', &
                 log_tau, no_domain=.true.)
     call read_data('INPUT/geohydrology_table.nc', 'log_zeta_s', &
                 log_zeta_s, no_domain=.true.)
  endif


  ! set up output arguments
  soil_num_l      = num_l
  soil_dz         = dz
  soil_single_geo = use_single_geo
  soil_gw_option  = gw_option

end subroutine 


! ============================================================================
function soil_tile_ctor(tag) result(ptr)
  type(soil_tile_type), pointer :: ptr ! return value
  integer, intent(in)  :: tag ! kind of tile

  allocate(ptr)
  ptr%tag = tag
  ! allocate storage for tile data
  allocate( ptr%prog(num_l))
  allocate( ptr%w_fc              (num_l),  &
            ptr%w_wilt            (num_l),  &
            ptr%d_trans           (num_l),  &
            ptr%alpha             (num_l),  &
            ptr%k_macro           (num_l),  &
            ptr%uptake_frac       (num_l),  &
            ptr%heat_capacity_dry (num_l),  &
            ptr%e                 (num_l),  &
            ptr%f                 (num_l),  &
            ptr%psi               (num_l),  &
            ptr%gw_flux_norm      (num_storage_pts),  &
            ptr%gw_area_norm      (num_storage_pts),  &
            ptr%fast_soil_C       (num_l),  &
            ptr%slow_soil_C       (num_l),  &
            ptr%fsc_in            (num_l),  & 
            ptr%ssc_in            (num_l),  & 
            ptr%asoil_in          (num_l)   )
  call soil_data_init_0d(ptr)
end function soil_tile_ctor


! ============================================================================
function soil_tile_copy_ctor(soil) result(ptr)
  type(soil_tile_type), pointer :: ptr ! return value
  type(soil_tile_type), intent(in) :: soil ! tile to copy

  allocate(ptr)
  ptr = soil ! copy all non-pointer members
  ! allocate storage for tile data
  allocate( ptr%prog(num_l))
  allocate( ptr%w_fc              (num_l),  &
            ptr%w_wilt            (num_l),  &
            ptr%d_trans           (num_l),  &
            ptr%alpha             (num_l),  &
            ptr%k_macro           (num_l),  &
            ptr%uptake_frac       (num_l),  &
            ptr%heat_capacity_dry (num_l),  &
            ptr%e                 (num_l),  &
            ptr%f                 (num_l),  &
            ptr%psi               (num_l),  &
            ptr%gw_flux_norm      (num_storage_pts),  &
            ptr%gw_area_norm      (num_storage_pts),  &
            ptr%fast_soil_C       (num_l),  &
            ptr%slow_soil_C       (num_l),  &
            ptr%fsc_in            (num_l),  & 
            ptr%ssc_in            (num_l),  & 
            ptr%asoil_in          (num_l)   )
  ! copy all pointer members
  ptr%prog(:) = soil%prog(:)
  ptr%w_fc(:) = soil%w_fc(:)
  ptr%w_wilt(:) = soil%w_wilt(:)
  ptr%d_trans(:) = soil%d_trans(:)
  ptr%alpha(:) = soil%alpha(:)
  ptr%k_macro(:) = soil%k_macro(:)
  ptr%uptake_frac(:) = soil%uptake_frac(:)
  ptr%uptake_T = soil%uptake_T
  ptr%heat_capacity_dry(:) = soil%heat_capacity_dry(:)
  ptr%e(:) = soil%e(:)
  ptr%f(:) = soil%f(:)
  ptr%psi(:) = soil%psi(:)
  ptr%gw_flux_norm(:) = soil%gw_flux_norm(:)
  ptr%gw_area_norm(:) = soil%gw_area_norm(:)
  ptr%fast_soil_C(:)  = soil%fast_soil_C(:)
  ptr%slow_soil_C(:)  = soil%slow_soil_C(:)
  ptr%fsc_in(:)       = soil%fsc_in(:)
  ptr%ssc_in(:)       = soil%ssc_in(:)
  ptr%asoil_in(:)     = soil%asoil_in(:)
end function soil_tile_copy_ctor


! ============================================================================
subroutine delete_soil_tile(ptr)
  type(soil_tile_type), pointer :: ptr

  deallocate(ptr%prog)
  deallocate(ptr%w_fc, ptr%w_wilt, ptr%d_trans, ptr%alpha, ptr%k_macro, &
             ptr%uptake_frac,&
             ptr%heat_capacity_dry, ptr%e, ptr%f, ptr%psi, &
             ptr%gw_flux_norm, ptr%gw_area_norm, &
             ptr%fast_soil_C, ptr%slow_soil_C, &
             ptr%fsc_in, ptr%ssc_in, ptr%asoil_in )
  deallocate(ptr)
end subroutine delete_soil_tile


! ============================================================================
subroutine soil_data_init_0d(soil)
  type(soil_tile_type), intent(inout) :: soil
  
!  real tau_groundwater
!  real rsa_exp         ! riparian source-area exponent
  integer :: k, i, l, code, m_zeta, m_tau
  real alpha_inf_sq, alpha_sfc_sq
  real :: single_log_zeta_s, single_log_tau, frac_zeta, frac_tau
  
  k = soil%tag

  soil%pars%vwc_sat           = dat_w_sat            (k)
  soil%pars%awc_lm2           = dat_awc_lm2          (k)
  soil%pars%k_sat_ref         = dat_k_sat_ref        (k)
  soil%pars%psi_sat_ref       = dat_psi_sat_ref      (k)
  soil%pars%chb               = dat_chb              (k)
  soil%pars%heat_capacity_dry = dat_heat_capacity_dry(k)
  soil%pars%thermal_cond_dry  = dat_thermal_cond_dry (k)
  soil%pars%thermal_cond_sat  = dat_thermal_cond_sat (k)
  soil%pars%thermal_cond_exp  = dat_thermal_cond_exp (k)
  soil%pars%thermal_cond_scale  = dat_thermal_cond_scale (k)
  soil%pars%thermal_cond_weight  = dat_thermal_cond_weight (k)
  soil%pars%refl_dry_dir      = dat_refl_dry_dir     (k,:)
  soil%pars%refl_dry_dif      = dat_refl_dry_dif     (k,:)
  soil%pars%refl_sat_dir      = dat_refl_sat_dir     (k,:)
  soil%pars%refl_sat_dif      = dat_refl_sat_dif     (k,:)
  soil%pars%emis_dry          = dat_emis_dry         (k)
  soil%pars%emis_sat          = dat_emis_sat         (k)
  soil%pars%z0_momentum       = dat_z0_momentum      (k)
  soil%pars%tfreeze           = tfreeze - dat_tf_depr(k)
  soil%pars%rsa_exp           = rsa_exp_global
  soil%pars%tau_groundwater   = gw_res_time
  soil%pars%hillslope_length  = gw_hillslope_length*gw_scale_length
  soil%pars%hillslope_zeta_bar= gw_hillslope_zeta_bar
  soil%pars%hillslope_relief  = gw_hillslope_relief*gw_scale_relief
  soil%pars%soil_e_depth      = gw_soil_e_depth*gw_scale_soil_depth
  soil%pars%k_sat_gw          = gw_perm*gw_scale_perm*9.8e9  ! m^2 to kg/(m2 s)
  soil%pars%storage_index     = 1
  soil%alpha                  = 1.0
  soil%fast_soil_C(:)         = 0.0
  soil%slow_soil_C(:)         = 0.0
  soil%asoil_in(:)            = 0.0
  soil%fsc_in(:)              = 0.0
  soil%ssc_in(:)              = 0.0
  do l = 1, num_l
    soil%k_macro(l) = k_macro_constant &
                         * exp(zfull(l)/soil%pars%soil_e_depth)
  enddo

  select case(gw_option)
  case(GW_HILL_AR5)
     if (use_single_geo) then
        soil%gw_flux_norm = gw_flux_norm_zeta_s_04
        soil%gw_area_norm = gw_area_norm_zeta_s_04
     endif
     soil%pars%zeta = soil%pars%soil_e_depth / soil%pars%hillslope_relief
  case(GW_HILL)
     if (use_single_geo) &
         call soil_data_init_derive_subsurf_pars ( soil )
  case default
     ! do nothing
  end select

  ! ---- derived constant soil parameters
  ! w_fc (field capacity) set to w at which hydraulic conductivity equals
  ! a nominal drainage rate "rate_fc"
  ! w_wilt set to w at which psi is psi_wilt
  if (use_lm2_awc) then
     soil%w_wilt(:) = 0.15
     soil%w_fc  (:) = 0.15 + soil%pars%awc_lm2
  else
     soil%w_wilt(:) = soil%pars%vwc_sat &
          *(soil%pars%psi_sat_ref/(psi_wilt*soil%alpha(:)))**(1/soil%pars%chb)
     soil%w_fc  (:) = soil%pars%vwc_sat &
          *(rate_fc/(soil%pars%k_sat_ref*soil%alpha(:)**2))**(1/(3+2*soil%pars%chb))
  endif

  soil%pars%vwc_wilt = soil%w_wilt(1)
  soil%pars%vwc_fc   = soil%w_fc  (1)

  soil%pars%vlc_min = soil%pars%vwc_sat*K_rel_min**(1/(3+2*soil%pars%chb))

  soil%z0_scalar = soil%pars%z0_momentum * exp(-k_over_B)
  
  soil%geothermal_heat_flux = geothermal_heat_flux_constant

end subroutine soil_data_init_0d

! ============================================================================
subroutine soil_data_init_derive_subsurf_pars ( soil )
  type(soil_tile_type), intent(inout) :: soil
  integer i, l, code, m_zeta, m_tau
  real :: alpha_inf_sq, alpha_sfc_sq
  real :: single_log_zeta_s, single_log_tau, frac_zeta, frac_tau

  if (use_alpha) then
      soil%pars%k_sat_sfc = (soil%pars%k_sat_ref-soil%pars%k_sat_gw) &
                * exp(z_ref/soil%pars%soil_e_depth) + soil%pars%k_sat_gw
      alpha_inf_sq = soil%pars%k_sat_gw / soil%pars%k_sat_ref
      alpha_sfc_sq = soil%pars%k_sat_sfc / soil%pars%k_sat_ref
      do l = 1, num_l
        soil%alpha(l) = sqrt(alpha_inf_sq+(alpha_sfc_sq-alpha_inf_sq) &
                    *exp(-zfull(l)/soil%pars%soil_e_depth))
        enddo
    else
      soil%pars%k_sat_sfc = soil%pars%k_sat_ref
      soil%alpha = 1.0
    endif

  soil%pars%tau =    &
    (soil%pars%k_sat_gw*aspect*soil%pars%hillslope_length) &
     / ((soil%pars%k_sat_sfc+k_macro_constant)*soil%pars%soil_e_depth)

  soil%d_trans(1) = 1.
  do l = 1, num_l-1
    soil%d_trans(l+1) = exp(-zhalf(l+1)/soil%pars%soil_e_depth)
    soil%d_trans(l)   = soil%d_trans(l) - soil%d_trans(l+1)
    enddo
  soil%d_trans = soil%d_trans &
       * (soil%pars%k_sat_sfc + k_macro_constant ) &
       * soil%pars%soil_e_depth
  soil%d_trans(num_l) = soil%d_trans(num_l) &
       + soil%pars%k_sat_gw*aspect*soil%pars%hillslope_length

  if (soil%pars%hillslope_relief.le.0.) soil%pars%hillslope_relief = 1.e-10
  soil%pars%zeta = soil%pars%soil_e_depth &
                                        / soil%pars%hillslope_relief
  single_log_zeta_s = log10(soil%pars%zeta)
  single_log_zeta_s = max(single_log_zeta_s, log_zeta_s(1))
  single_log_zeta_s = min(single_log_zeta_s, log_zeta_s(num_zeta_pts))
  m_zeta = num_zeta_pts / 2
  code = 0
  do while (code.eq.0)
    if (single_log_zeta_s .lt. log_zeta_s(m_zeta)) then
        m_zeta = m_zeta - 1
      else if (single_log_zeta_s .gt. log_zeta_s(m_zeta+1)) then
        m_zeta = m_zeta + 1
      else
        code = 1
      endif
    enddo
  frac_zeta = (single_log_zeta_s - log_zeta_s(m_zeta)) &
     / (log_zeta_s(m_zeta+1) - log_zeta_s(m_zeta))
  single_log_tau = log10( soil%pars%tau )
  single_log_tau = max(single_log_tau, log_tau(1))
  single_log_tau = min(single_log_tau, log_tau(num_tau_pts))
  m_tau = num_tau_pts / 2
  code = 0
  do while (code.eq.0)
    if (single_log_tau .lt. log_tau(m_tau)) then
        m_tau = m_tau - 1
      else if (single_log_tau .gt. log_tau(m_tau+1)) then
        m_tau = m_tau + 1
      else
        code = 1
      endif
    enddo
  frac_tau = (single_log_tau - log_tau(m_tau)) &
     / (log_tau(m_tau+1) - log_tau(m_tau))
  do i = 1, num_storage_pts
    soil%gw_flux_norm(i) = min ( log_rho_max,                      &
       (1.-frac_zeta)*(1.-frac_tau)*log_rho_table(i , m_tau  , m_zeta  ) &
     + (   frac_zeta)*(1.-frac_tau)*log_rho_table(i , m_tau  , m_zeta+1) &
     + (1.-frac_zeta)*(   frac_tau)*log_rho_table(i , m_tau+1, m_zeta  ) &
     + (   frac_zeta)*(   frac_tau)*log_rho_table(i , m_tau+1, m_zeta+1) )
    enddo

end subroutine soil_data_init_derive_subsurf_pars

! ============================================================================
subroutine soil_data_init_derive_subsurf_pars_ar5 ( soil )
  type(soil_tile_type), intent(inout) :: soil
  integer i, code, m_zeta
  real :: frac_zeta
  if (soil%pars%hillslope_relief.le.0.) &
     soil%pars%hillslope_relief =      &
        soil%pars%soil_e_depth / 10.**log_zeta_s(num_zeta_pts)
  soil%pars%zeta = soil%pars%soil_e_depth &
     / soil%pars%hillslope_relief
  soil%pars%zeta = max(soil%pars%zeta, gw_zeta_s(1))
  soil%pars%zeta = min(soil%pars%zeta, gw_zeta_s(31))
  m_zeta = 31 / 2
  code = 0
  do while (code.eq.0)
    if (soil%pars%zeta .lt. gw_zeta_s(m_zeta)) then
        m_zeta = m_zeta - 1
      else if (soil%pars%zeta .gt. gw_zeta_s(m_zeta+1)) then
        m_zeta = m_zeta + 1
      else
        code = 1
      endif
    enddo
  frac_zeta = (soil%pars%zeta - gw_zeta_s(m_zeta)) &
                / (gw_zeta_s(m_zeta+1) - gw_zeta_s(m_zeta))
  do i = 1, num_storage_pts
    soil%gw_flux_norm(i) = gw_flux_table(i,m_zeta) &
         + frac_zeta*(gw_flux_table(i,m_zeta+1)-gw_flux_table(i,m_zeta))
    soil%gw_area_norm(i) = gw_area_table(i,m_zeta) &
         + frac_zeta*(gw_area_table(i,m_zeta+1)-gw_area_table(i,m_zeta))
    enddo
end subroutine soil_data_init_derive_subsurf_pars_ar5

! ============================================================================
function soil_cover_cold_start(land_mask, lonb, latb) result (soil_frac)
! creates and initializes a field of fractional soil coverage
  logical, intent(in) :: land_mask(:,:)    ! land mask
  real,    intent(in) :: lonb(:,:), latb(:,:) ! boundaries of the grid cells
  real,    pointer    :: soil_frac (:,:,:) ! output: map of soil fractional coverage

  allocate( soil_frac(size(land_mask,1),size(land_mask,2),n_dim_soil_types))

  call init_cover_field(soil_to_use, 'INPUT/ground_type.nc', 'cover','frac', &
       lonb, latb, soil_index_constant, input_cover_types, soil_frac)
  
end function 


! =============================================================================
function soil_tiles_can_be_merged(soil1,soil2) result(response)
  logical :: response
  type(soil_tile_type), intent(in) :: soil1,soil2

  response = (soil1%tag==soil2%tag)
end function


! =============================================================================
subroutine merge_soil_tiles(s1,w1,s2,w2)
  type(soil_tile_type), intent(in) :: s1
  type(soil_tile_type), intent(inout) :: s2
  real                , intent(in) :: w1,w2

  ! ---- local vars
  real    :: x1, x2 ! normalized relative weights
  real    :: gw, HEAT1, HEAT2 ! temporaries for groundwater and heat
  integer :: i
  
  ! calculate normalized weights
  x1 = w1/(w1+w2)
  x2 = 1.0 - x1

  ! combine state variables
  do i = 1,num_l
     ! calculate heat content at this level for both source tiles
     HEAT1 = &
          (s1%heat_capacity_dry(i)*dz(i)+clw*s1%prog(i)%Wl+csw*s1%prog(i)%Ws)* &
          (s1%prog(i)%T-tfreeze)
     HEAT2 = &
          (s2%heat_capacity_dry(i)*dz(i)+clw*s2%prog(i)%Wl+csw*s2%prog(i)%Ws)* &
          (s2%prog(i)%T-tfreeze)
     ! merge the amounts of water
     s2%prog(i)%Wl = x1*s1%prog(i)%Wl + x2*s2%prog(i)%Wl
     s2%prog(i)%Ws = x1*s1%prog(i)%Ws + x2*s2%prog(i)%Ws
     ! if the dry heat capacity of merged soil is to be changed, do it here
     ! ...
     ! calculate the merged temperature based on heat content
     s2%prog(i)%T = tfreeze + (x1*HEAT1+x2*HEAT2)/ &
          (s2%heat_capacity_dry(i)*dz(i)+clw*s2%prog(i)%Wl+csw*s2%prog(i)%Ws)

     ! calculate combined groundwater content
     gw = s1%prog(i)%groundwater*x1 + s2%prog(i)%groundwater*x2
     ! calculate combined groundwater temperature
     if (gw/=0) then
        s2%prog(i)%groundwater_T = ( &
             s1%prog(i)%groundwater*x1*(s1%prog(i)%groundwater_T-tfreeze) + &
             s2%prog(i)%groundwater*x2*(s2%prog(i)%groundwater_T-tfreeze)   &
             ) / gw + tfreeze
     else
        s2%prog(i)%groundwater_T = &
             s1%prog(i)%groundwater_T*x1 + s2%prog(i)%groundwater_T*x2
     endif
     s2%prog(i)%groundwater = gw

  enddo
  s2%uptake_T    = s1%uptake_T*x1 + s2%uptake_T*x2
  ! merge soil carbon
  s2%fast_soil_C(:) = s1%fast_soil_C(:)*x1 + s2%fast_soil_C(:)*x2
  s2%slow_soil_C(:) = s1%slow_soil_C(:)*x1 + s2%slow_soil_C(:)*x2
  s2%asoil_in(:)    = s1%asoil_in(:)*x1 + s2%asoil_in(:)*x2
  s2%fsc_in(:)      = s1%fsc_in(:)*x1 + s2%fsc_in(:)*x2
  s2%ssc_in(:)      = s1%ssc_in(:)*x1 + s2%ssc_in(:)*x2
end subroutine

! =============================================================================
! returns true if tile fits the specified selector
function soil_is_selected(soil, sel)
  logical soil_is_selected
  type(tile_selector_type),  intent(in) :: sel
  type(soil_tile_type),      intent(in) :: soil

  soil_is_selected = (sel%idata1==0).or.(sel%idata1==soil%tag)
end function


! ============================================================================
! returns tag of the tile
function get_soil_tile_tag(soil) result(tag)
  integer :: tag
  type(soil_tile_type), intent(in) :: soil
  
  tag = soil%tag
end function



! ============================================================================
! compute average soil temperature with a given depth scale
function soil_ave_temp(soil, depth) result (A) ; real :: A
  type(soil_tile_type), intent(in) :: soil
  real, intent(in)                 :: depth ! averaging depth

  real    :: w ! averaging weight
  real    :: N ! normalizing factor for averaging
  integer :: k

  A = 0 ; N = 0 
  do k = 1, num_l
     w = dz(k) * exp(-zfull(k)/depth)
     A = A + soil%prog(k)%T * w
     N = N + w
     if (zhalf(k+1).gt.depth) exit
  enddo
  A = A/N
end function soil_ave_temp


! ============================================================================
! compute average soil moisture with a given depth scale
function soil_ave_theta0(soil, zeta) result (A) ; real :: A
  type(soil_tile_type), intent(in) :: soil
  real, intent(in)                 :: zeta ! root depth scale
  real :: zeta2  !  adjusted length scale for soil-water-stress
  real    :: w ! averaging weight
  real    :: N ! normalizing factor for averaging
  integer :: k

  A = 0 ; N = 0 
  zeta2 = zeta*zeta_mult
  do k = 1, num_l
     w = exp(-zhalf(k)/zeta2)-exp(-zhalf(k+1)/zeta2)
     A = A + max(soil%prog(k)%wl/(dens_h2o*dz(k))-soil%w_wilt(k),0.0)/&
          (soil%w_fc(k)-soil%w_wilt(k)) * w
     N = N + w
  enddo
  A = A/N
end function soil_ave_theta0


! ============================================================================
function soil_ave_theta1(soil, depth) result (A) ; real :: A
  type(soil_tile_type), intent(in) :: soil
  real, intent(in)                 :: depth ! averaging depth

  real    :: w ! averaging weight
  real    :: N ! normalizing factor for averaging
  integer :: k

  A = 0 ; N = 0 
  do k = 1, num_l
     w = dz(k) * exp(-zfull(k)/depth)
     A = A +min(max(soil%prog(k)%wl/(dens_h2o*dz(k)),0.0)/&
          (soil%pars%vwc_sat),1.0) * w
     N = N + w
     if (zhalf(k+1).gt.depth) exit
  enddo
  A = A/N
end function soil_ave_theta1


! ============================================================================
! returns array of soil moisture
function soil_theta(soil) result (theta1)
  type(soil_tile_type), intent(in) :: soil
  real :: theta1(num_l)

  theta1(:) = min(max(soil%prog(:)%wl/(dens_h2o*dz(:)),0.0)/(soil%pars%vwc_sat),1.0)
end function soil_theta


! ============================================================================
function soil_psi_stress(soil, zeta) result (A) ; real :: A
  type(soil_tile_type), intent(in) :: soil
  real,                 intent(in) :: zeta  ! root-mass depth scale
  real :: zeta2  !  adjusted length scale for soil-water-stress
  real    :: w ! averaging weight
  real    :: N ! normalizing factor for averaging
  integer :: k

  A = 0 ; N = 0
  zeta2 = zeta*zeta_mult
  do k = 1, num_l
     w = exp(-zhalf(k)/zeta2)-exp(-zhalf(k+1)/zeta2)
     A = A + w * soil%psi(k)/psi_wilt
     N = N + w
     enddo
  A = A/N

end function soil_psi_stress

! ============================================================================
! compute bare-soil albedo, bare-soil emissivity, bare-soil roughness
! for scalar transport, and beta function
subroutine soil_data_radiation ( soil, cosz, use_brdf, soil_alb_dir, soil_alb_dif, soil_emis )
  type(soil_tile_type), intent(in)  :: soil
  real,                 intent(in)  :: cosz
  logical,              intent(in)  :: use_brdf
  real,                 intent(out) :: soil_alb_dir(NBANDS), soil_alb_dif(NBANDS), soil_emis
  ! ---- local vars
  real :: soil_sfc_vlc, blend, dry_value(NBANDS), sat_value(NBANDS)
  real :: zenith_angle, zsq, zcu

  soil_sfc_vlc  = soil%prog(1)%wl/(dens_h2o*dz(1))
  blend         = max(0., min(1., soil_sfc_vlc/soil%pars%vwc_sat))
  if (use_brdf) then
      zenith_angle = acos(cosz)
      zsq = zenith_angle*zenith_angle
      zcu = zenith_angle*zsq
      dry_value =  soil%pars%f_iso_dry*(g0_iso+g1_iso*zsq+g2_iso*zcu) &
                 + soil%pars%f_vol_dry*(g0_vol+g1_vol*zsq+g2_vol*zcu) &
                 + soil%pars%f_geo_dry*(g0_geo+g1_geo*zsq+g2_geo*zcu)
      sat_value =  soil%pars%f_iso_sat*(g0_iso+g1_iso*zsq+g2_iso*zcu) &
                 + soil%pars%f_vol_sat*(g0_vol+g1_vol*zsq+g2_vol*zcu) &
                 + soil%pars%f_geo_sat*(g0_geo+g1_geo*zsq+g2_geo*zcu)
    else
      dry_value = soil%pars%refl_dry_dir
      sat_value = soil%pars%refl_sat_dir
    endif
  soil_alb_dir  = dry_value              + blend*(sat_value             -dry_value)
  soil_alb_dif  = soil%pars%refl_dry_dif + blend*(soil%pars%refl_sat_dif-soil%pars%refl_dry_dif)
  soil_emis     = soil%pars%emis_dry     + blend*(soil%pars%emis_sat    -soil%pars%emis_dry    )
end subroutine soil_data_radiation


! ============================================================================
! compute bare-soil albedo, bare-soil emissivity, bare-soil roughness
! for scalar transport, and beta function
subroutine soil_data_diffusion ( soil, soil_z0s, soil_z0m )
  type(soil_tile_type), intent(in)  :: soil
  real,                 intent(out) :: soil_z0s, soil_z0m

  soil_z0s = soil%z0_scalar
  soil_z0m = soil%pars%z0_momentum
end subroutine soil_data_diffusion

! ============================================================================
! compute soil thermodynamic properties.
subroutine soil_data_thermodynamics ( soil, vlc, vsc, &
                                      soil_E_max, thermal_cond)
  type(soil_tile_type), intent(inout) :: soil
  real,                 intent(in)  :: vlc(:)
  real,                 intent(in)  :: vsc(:)
  real,                 intent(out) :: soil_E_max
  real,                 intent(out) :: thermal_cond(:)
  real s, w, a, n, f

  integer l

  ! assign some index of water availability for snow-free soil

  soil_E_max = (soil%pars%k_sat_ref*soil%alpha(1)**2) &
               * (-soil%pars%psi_sat_ref/soil%alpha(1)) &
               * ((4.+soil%pars%chb)*vlc(1)/ &
                ((3.+soil%pars%chb)*soil%pars%vwc_sat))**(3.+soil%pars%chb) &
                / ((1.+3./soil%pars%chb)*dz(1))

     w = soil%pars%thermal_cond_weight
     a = soil%pars%thermal_cond_scale
     n = soil%pars%thermal_cond_exp
  do l = 1, num_sfc_layers
     soil%heat_capacity_dry(l) = sfc_heat_factor*soil%pars%heat_capacity_dry
     s = (vlc(l)+vsc(l))/soil%pars%vwc_sat
     thermal_cond(l)      = sfc_heat_factor * &
          ( soil%pars%thermal_cond_dry+ &
            (soil%pars%thermal_cond_sat-soil%pars%thermal_cond_dry) &
            *(w*s +(1-w)*(1+a**n)*(s**n)/(1+(a*s)**n))    )
     f = 1.
     if (vlc(l)+vsc(l).gt.0.) f = 1.+(freeze_factor-1.)*vsc(l)/(vlc(l)+vsc(l))
     thermal_cond(l) = f * thermal_cond(l)
  enddo
  do l = num_sfc_layers+1, num_l
     soil%heat_capacity_dry(l) = soil%pars%heat_capacity_dry
     s = (vlc(l)+vsc(l))/soil%pars%vwc_sat
     thermal_cond(l)  = &
          ( soil%pars%thermal_cond_dry+ &
            (soil%pars%thermal_cond_sat-soil%pars%thermal_cond_dry) &
            *(w*s +(1-w)*(1+a**n)*(s**n)/(1+(a*s)**n))    )
     f = 1.
     if (vlc(l)+vsc(l).gt.0.) f = 1.+(freeze_factor-1.)*vsc(l)/(vlc(l)+vsc(l))
     thermal_cond(l) = f * thermal_cond(l)
  enddo
  
  ! this is an additional factor intended for tuning annual T range in
  ! high latitudes. presumably other locations are insensitive to this
  ! global parameter, since they don't have freeze/thaw. this really is just a fudge.
  do l = sub_layer_min, sub_layer_max
    thermal_cond(l) = sub_layer_tc_fac * thermal_cond(l)
    enddo
  
end subroutine soil_data_thermodynamics


! ============================================================================
! compute soil hydraulic properties: wrapper to get all parameters for
! richards equation for full column. note that psi_for_rh is not passed.
subroutine soil_data_hydraulic_properties (soil, vlc, vsc, &
                    psi, DThDP, hyd_cond, DKDP, DPsi_min, DPsi_max  )
  type(soil_tile_type),        intent(in) :: soil
  real,                        intent(in),  dimension(:) :: vlc, vsc
  real,                        intent(out), dimension(:) :: &
      psi, DThDP, hyd_cond, DKDP
  real,                        intent(out) :: &
      DPsi_min, DPsi_max
  ! ---- local vars ----------------------------------------------------------
  real ::  psi_for_rh

  call soil_data_hydraulics (soil, vlc, vsc, &
                    psi, DThDP, hyd_cond, DKDP, DPsi_min, DPsi_max, &
                    psi_for_rh  )

end subroutine soil_data_hydraulic_properties


! ============================================================================
! wrapper to compute psi and the potentially different psi used for surface
! relative humidity computation.
! use of this wrapper allows us to avoid passing all the other properties
! back to soil module. (they're computed anyway.)
subroutine soil_data_psi_for_rh (soil, vlc, vsc, psi, psi_for_rh  )
  type(soil_tile_type),        intent(in) :: soil
  real,                        intent(in),  dimension(:) :: vlc, vsc
  real,                        intent(out), dimension(:) :: psi
  real,                        intent(out) :: psi_for_rh
  ! ---- local vars ----------------------------------------------------------
  real, dimension(num_l) ::  DThDP, hyd_cond, DKDP
  real :: DPsi_min, DPsi_max

  call soil_data_hydraulics (soil, vlc, vsc, &
                    psi, DThDP, hyd_cond, DKDP, DPsi_min, DPsi_max, &
                    psi_for_rh  )

end subroutine soil_data_psi_for_rh


! ============================================================================
! compute soil hydraulic properties.
subroutine soil_data_hydraulics (soil, vlc, vsc, &
                    psi, DThDP, hyd_cond, DKDP, DPsi_min, DPsi_max, &
                    psi_for_rh  )
  type(soil_tile_type),        intent(in) :: soil
  real,                        intent(in),  dimension(:) :: vlc, vsc
  real,                        intent(out), dimension(:) :: &
      psi, DThDP, hyd_cond, DKDP
  real,                        intent(out) :: &
      DPsi_min, DPsi_max, psi_for_rh
  ! ---- local vars ----------------------------------------------------------
  integer l
  real :: vlc_loc, vlc_k, psi_k, sigma, B, por, psi_s, k_sat, alt_psi_for_rh
  real :: alpha_sq, f_psi
  logical flag
  
  ! ---- T-dependence of hydraulic properties --------------------------------
  ! k_sat   = soil%pars%k_sat0   !  * mu(t0)/mu(t), where mu is dynamic viscosity
  ! psi_sat = soil%pars%psi_sat0 !  * exp(c*(psi-psi0)), where c~+/-(?)0.0068
                     ! better approach would be to adopt air entrapment model
                     ! or at least to scale against surface tension model
  ! ---- water and ice dependence of hydraulic properties --------------------
  ! ---- (T-dependence can be added later)
  hyd_cond=1;DThDP=1;psi=1
  DKDP=0
  flag = .false.
  do l = 1, size(vlc)
    alpha_sq = soil%alpha(l)**2
    hyd_cond(l) = (soil%pars%k_sat_ref*alpha_sq)*  &
               (vlc(l)/soil%pars%vwc_sat)**(3+2*soil%pars%chb)
    if (hyd_cond(l).lt.1.e-12*soil%pars%k_sat_ref*alpha_sq) then
        vlc_loc     = soil%pars%vwc_sat*(1.e-12)**(1./(3+2*soil%pars%chb))
        hyd_cond(l) = 1.e-12*soil%pars%k_sat_ref*alpha_sq
        if (l.eq.1) flag = .true.
        if (vsc(l).eq.0.) then
            DThDP   (l) = -vlc_loc     &
                      *(vlc_loc/soil%pars%vwc_sat)**soil%pars%chb &
                      /(soil%pars%psi_sat_ref*soil%pars%chb/soil%alpha(l))
            psi     (l) = (soil%pars%psi_sat_ref/soil%alpha(l)) &
                      *(soil%pars%vwc_sat/vlc_loc)**soil%pars%chb &
                      + (vlc(l)-vlc_loc)/DThDP   (l)
            if (l.eq.1.and.vlc(1).gt.0.) then
                alt_psi_for_rh = &
                     (soil%pars%psi_sat_ref/soil%alpha(l)) &
                     *(soil%pars%vwc_sat/vlc(1)   )**soil%pars%chb
              else if (l.eq.1.and.vlc(1).le.0.) then
                alt_psi_for_rh = -1.e10
              endif
          else
            psi     (l) = ((soil%pars%psi_sat_ref/soil%alpha(l)) / 2.2) &
                    *(soil%pars%vwc_sat/vlc_loc   )**soil%pars%chb
            DThDP   (l) = 0.
            if (l.eq.1) alt_psi_for_rh = -1.e10
          endif
      else
          if (vsc(l).eq.0.) then
              if (vlc(l).le.soil%pars%vwc_sat) then
                  psi     (l) = (soil%pars%psi_sat_ref/soil%alpha(l)) &
                          *(soil%pars%vwc_sat/vlc(l))**soil%pars%chb
                  DKDP    (l) = -(2+3/soil%pars%chb)*hyd_cond(l) &
                                                 /psi(l)
                  DThDP   (l) = -vlc(l)/(psi(l)*soil%pars%chb)
                else
                  psi(l) = soil%pars%psi_sat_ref/soil%alpha(l) &
                         + (vlc(l)-soil%pars%vwc_sat)/comp
	          f_psi = min(max(1.-psi(l)/soil%pars%psi_sat_ref/soil%alpha(l),0.),1.)
                  DThDP(l) = comp
                  hyd_cond(l) = soil%pars%k_sat_ref*alpha_sq &
	                           + f_psi * soil%k_macro(l)
                endif
            else
              psi     (l) = ((soil%pars%psi_sat_ref/soil%alpha(l)) / 2.2) &
                        *(soil%pars%vwc_sat/vlc(l))**soil%pars%chb
              DThDP   (l) = 0.
            endif
      endif
    enddo

  if (use_alt_psi_for_rh .and. flag) then
      psi_for_rh = alt_psi_for_rh
    else
      psi_for_rh = psi(1)
    endif

  if (DThDP(1).ne.0.) then
      DPsi_min =            -vlc(1) /DThDP(1)
      DPsi_max = (soil%pars%vwc_sat-vlc(1))/DThDP(1)
    else
      Dpsi_min = Dpsi_min_const
      DPsi_max = -psi(1)
    endif

end subroutine soil_data_hydraulics

! ============================================================================
! compute soil hydraulic properties (undeveloped code)
subroutine soil_data_hydraulics_EXPERIMENTAL (soil, vlc, vsc, &
                    psi, DThDP, hyd_cond, DKDP, DPsi_min, DPsi_max, &
                    psi_for_rh  )
  type(soil_tile_type),        intent(in) :: soil
  real,                        intent(in),  dimension(:) :: vlc, vsc
  real,                        intent(out), dimension(:) :: &
      psi, DThDP, hyd_cond, DKDP
  real,                        intent(out) :: &
      DPsi_min, DPsi_max, psi_for_rh
  ! ---- local vars ----------------------------------------------------------
  integer l
  real :: vlc_loc, vlc_k, psi_k, sigma, B, por, psi_s, k_sat, alt_psi_for_rh
  real :: alpha_sq, f_psi
  logical flag
  
  ! ---- T-dependence of hydraulic properties --------------------------------
  ! k_sat   = soil%pars%k_sat0   !  * mu(t0)/mu(t), where mu is dynamic viscosity
  ! psi_sat = soil%pars%psi_sat0 !  * exp(c*(psi-psi0)), where c~+/-(?)0.0068
                     ! better approach would be to adopt air entrapment model
                     ! or at least to scale against surface tension model


  ! ---- water and ice dependence of hydraulic properties --------------------
  ! ---- (T-dependence can be added later)
  hyd_cond=1;DThDP=1;psi=1
    B     = soil%pars%chb
    por   = soil%pars%vwc_sat
    vlc_k = soil%pars%vlc_min
    psi_s = soil%pars%psi_sat_ref
    psi_k = psi_s*(por/vlc_k)**B
    k_sat = soil%pars%k_sat_ref
    do l = 1, num_l
      vlc_loc = max(vlc(l), vlc_k)
      ! sigma is an adjustment to surface tension for presence of ice
      sigma = 1. + (sigma_max-1.)*min(vsc(l)/vlc(l),1.)
      if (vlc(l).lt.vlc_k) then  ! very dry, no ice, sigma=1 in this case
          DThDP(l) = -vlc_k/(B*psi_k)
          psi  (l) = psi_s*(por/vlc_k)**B + (vlc(l)-vlc_k)/DThDP(l)
        else if (vlc(l).lt.por-vsc(l)) then  ! unsaturated, maybe with ice
          psi  (l) = (psi_s/sigma)*(por/vlc(l))**B
          DThDP(l) = -vlc(l)/(B*psi(l))
        else  ! no air is present in this case
          psi  (l) = (psi_s/sigma)*(por/(por-vsc(l)))**B &
                             + (vlc(l)+vsc(l)-por)/comp
          DThDP(l) = comp
        endif
      hyd_cond(l) = k_sat*(vlc_loc/por)**(3+2*B)
      DKDP(l) = 0
      enddo
    DPsi_min =            -vlc(1) /DThDP(1)
    if (vsc(1).gt.0.) DPsi_min = (vlc_k-vlc(1)) /DThDP(1)
    DPsi_max = (por-vsc(1)-vlc(1))/DThDP(1)
    psi_for_rh = psi(1)

end subroutine soil_data_hydraulics_EXPERIMENTAL

! ============================================================================
subroutine soil_data_gw_hydraulics_ar5(soil, storage_normalized, &
                                                     gw_flux, sat_frac )
  type(soil_tile_type), intent(inout)  :: soil
  real,                 intent(in)  :: storage_normalized
  real,                 intent(out) :: gw_flux
  real,                 intent(out) :: sat_frac

  integer :: code, m
  real :: recharge_normalized, frac

  ! storage_normalized is the fraction of soil above drainage base elevation
  ! that is below the water table
  code = 0
  m = soil%pars%storage_index
  do while (code.eq.0)
    if (storage_normalized .lt. gw_storage_norm(m)) then
        m = m - 1
      else if (storage_normalized .gt. gw_storage_norm(m+1)) then
        m = m + 1
      else
        code = 1
      endif
    enddo
  if (m.lt.1.or.m.gt.num_storage_pts-1) then
      write(*,*) '!!! *** m=',m, ' is outside the table in soil_data_gw_hydraulics_ar5 *** !!!'
      write(*,*) 'num_storage_pts=',num_storage_pts
      write(*,*) 'storage_normalized=',storage_normalized
      write(*,*) 'interval bounds:',gw_storage_norm(m),gw_storage_norm(m+1)
    endif
  frac = (storage_normalized-gw_storage_norm(m)) &
           /(gw_storage_norm(m+1)-gw_storage_norm(m))
  sat_frac = soil%gw_area_norm(m) &
               + frac*(soil%gw_area_norm(m+1)-soil%gw_area_norm(m))
  recharge_normalized = soil%gw_flux_norm(m) &
               + frac*(soil%gw_flux_norm(m+1)-soil%gw_flux_norm(m))
  gw_flux = recharge_normalized * soil%pars%k_sat_ref * soil%pars%soil_e_depth &
                * soil%pars%hillslope_relief &
                   / (soil%pars%hillslope_length * soil%pars%hillslope_length)
  soil%pars%storage_index = m
  
end subroutine soil_data_gw_hydraulics_ar5

! ============================================================================
subroutine soil_data_gw_hydraulics(soil, deficit_normalized, &
                                                     gw_flux, sat_frac )
  type(soil_tile_type), intent(inout)  :: soil
  real,                 intent(in)  :: deficit_normalized
  real,                 intent(out) :: gw_flux
  real,                 intent(out) :: sat_frac

  integer :: code, m
  real :: recharge_normalized, frac, log_deficit_normalized

  ! deficit_normalized is the fraction of soil above drainage base elevation
  ! that is NOT saturated/contributing to horizontal flow
  
  IF (deficit_normalized .LE. 0.) THEN
    m = 0
  ELSE IF (deficit_normalized .GE. 1.) THEN
    m = num_storage_pts
  ELSE 
    log_deficit_normalized = log10(deficit_normalized)
    code = 0
    m = soil%pars%storage_index
    do while (code.eq.0.and.m.gt.0.and.m.lt.num_storage_pts)
      if (log_deficit_normalized .lt. log_deficit_list(m)) then
          m = m - 1
        else if (log_deficit_normalized .gt. log_deficit_list(m+1)) then
          m = m + 1
        else
          code = 1
        endif
      enddo
  ENDIF

  IF (m.eq.0) THEN
      recharge_normalized = 10.**soil%gw_flux_norm(1)
    ELSE IF (m.lt.num_storage_pts) then
      frac = (log_deficit_normalized-log_deficit_list(m)) &
               /(log_deficit_list(m+1)-log_deficit_list(m))
      recharge_normalized = 10.**(soil%gw_flux_norm(m) &
                   + frac*(soil%gw_flux_norm(m+1)-soil%gw_flux_norm(m)))
    ELSE
      recharge_normalized = 0.
    ENDIF

  if (use_tau_fix) then
      gw_flux = recharge_normalized * &
         ((soil%pars%k_sat_sfc+k_macro_constant) * soil%pars%soil_e_depth + &
	           soil%pars%k_sat_gw*aspect*soil%pars%hillslope_length) &
         * soil%pars%hillslope_relief &
         / (soil%pars%hillslope_length * soil%pars%hillslope_length)
    else
      gw_flux = recharge_normalized * &
         ((soil%pars%k_sat_sfc+k_macro_constant) * soil%pars%soil_e_depth) &
         * soil%pars%hillslope_relief &
         / (soil%pars%hillslope_length * soil%pars%hillslope_length)
    endif

  if (recharge_normalized.gt.1.) then
      sat_frac = 1. - 1./recharge_normalized
    else
      sat_frac = 0.
    endif
  if (use_sat_fix) then
      if (recharge_normalized.gt.1.+soil%pars%tau) then
          sat_frac = 1. - (1.+soil%pars%tau)/recharge_normalized
        else
          sat_frac = 0.
        endif
    endif

  soil%pars%storage_index = min(max(1,m),num_storage_pts-1)
  
!          if(is_watch_point()) then
!	         write(*,*) 'm            ', m
!		 write(*,*) 'code         ',code
!		 write(*,*) 'num_storage_pts', num_storage_pts
!		 write(*,*) 'frac         ', frac
!		 write(*,*) 'recharge_normalized', recharge_normalized
!		 write(*,*) 'deficit_normalized ', deficit_normalized
!		 write(*,*) 'log_deficit_normalized',log_deficit_normalized
!		 write(*,*) 'gw_flux      ',gw_flux
!		 write(*,*) 'm,log_deficit_list,gw_flux_norm'
!		 do m=1,num_storage_pts
!		   write(*,*) m, log_deficit_list(m),soil%gw_flux_norm(m)
!		   enddo
!               endif

  
end subroutine soil_data_gw_hydraulics

! ============================================================================
subroutine soil_data_vwc_for_init_only (soil, psi, vwc)
  type(soil_tile_type), intent(in) :: soil
  real,                 intent(in) :: psi(:)
  real,                 intent(out):: vwc(:)
  vwc = soil%pars%vwc_sat* &
    ((soil%pars%psi_sat_ref/soil%alpha)/min(psi,(soil%pars%psi_sat_ref/soil%alpha))) &
     ** (1./ soil%pars%chb)
  if (use_comp_for_ic) then
      vwc = vwc + comp*max(psi-soil%pars%psi_sat_ref/soil%alpha,0.)
    endif
end subroutine soil_data_vwc_for_init_only

! ============================================================================
subroutine soil_tile_stock_pe (soil, twd_liq, twd_sol  )
  type(soil_tile_type),  intent(in)    :: soil
  real,                  intent(out)   :: twd_liq, twd_sol
  integer n
  
  twd_liq = 0.
  twd_sol = 0.
  do n=1, size(soil%prog)
    twd_liq = twd_liq + soil%prog(n)%wl + soil%prog(n)%groundwater
    twd_sol = twd_sol + soil%prog(n)%ws
    enddo

end subroutine soil_tile_stock_pe


! ============================================================================
! returns soil tile heat content, J/m2
function soil_tile_heat (soil) result(heat) ; real heat
  type(soil_tile_type),  intent(in)  :: soil

  integer :: i

  heat = 0
  do i = 1, num_l
     heat = heat + &
          (soil%heat_capacity_dry(i)*dz(i)+clw*soil%prog(i)%Wl+csw*soil%prog(i)%Ws)&
                           *(soil%prog(i)%T-tfreeze) + &
          clw*soil%prog(i)%groundwater*(soil%prog(i)%groundwater_T-tfreeze) - &
          hlf*soil%prog(i)%ws
  enddo
end function

! ============================================================================
! returns soil tile carbon content, kg C/m2
function soil_tile_carbon (soil); real soil_tile_carbon
  type(soil_tile_type),  intent(in)  :: soil

  soil_tile_carbon = sum(soil%fast_soil_C(:))+sum(soil%slow_soil_C(:))
end function

end module soil_tile_mod

module tile_diag_buff_mod

implicit none
private

! ==== public interfaces =====================================================
public :: diag_buff_type
public :: new_diag_buff, delete_diag_buff, realloc_diag_buff
! ==== end of public interfaces ==============================================
interface new_diag_buff
   module procedure diag_buff_ctor
   module procedure diag_buff_copy_ctor
end interface

! storage for tile diagnostic data
type :: diag_buff_type
   real   , pointer :: data(:) => NULL()
   logical, pointer :: mask(:) => NULL()
end type diag_buff_type

! ==== module constants =====================================================
integer, parameter :: MIN_DIAG_BUFF_SIZE = 1
character(len=*), parameter :: &
     version = '$Id: land_tile_diag_buff.F90,v 17.0 2009/07/21 03:02:39 fms Exp $', &
     tagname = '$Name: tikal $'

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

! ============================================================================
function diag_buff_ctor() result(buffer)
  type(diag_buff_type), pointer :: buffer
  
  integer :: m ! initial size of the buffer
  
  allocate(buffer)
  m = MIN_DIAG_BUFF_SIZE
  allocate(buffer%mask(m),buffer%data(m))
  ! initialize buffer content
  buffer%mask(:) = .FALSE.
  buffer%data(:) = 0.0
end function


! ============================================================================
function diag_buff_copy_ctor(buffer) result(ptr)
  type(diag_buff_type), pointer :: ptr ! return value
  type(diag_buff_type), intent(in) :: buffer ! buffer to copy
  
  allocate(ptr)
  allocate(ptr%mask(size(buffer%mask)),ptr%data(size(buffer%data)))
  ! initialize buffer content
  ptr%mask(:) = buffer%mask(:)
  ptr%data(:) = buffer%data(:)
end function


! ============================================================================
subroutine delete_diag_buff(buffer)
  type(diag_buff_type), pointer :: buffer
  
  if(.not.associated(buffer)) return
  deallocate(buffer%mask,buffer%data)
  deallocate(buffer)
  
end subroutine


! ============================================================================
! reallocates buffer to have at least m elements
subroutine realloc_diag_buff(buffer, m)
  type(diag_buff_type), intent(inout) :: buffer
  integer             , intent(in)    :: m 

  real    , pointer :: new_data(:)
  logical , pointer :: new_mask(:)
  integer           :: n

  ! n is size of the original buffer; m is the current size of the buffer
  ! for all diagnostic fields
  n = size(buffer%data(:))
  ! do nothing if buffer is big enough
  if(n >= m) return

  allocate(new_data(m), new_mask(m))
  new_data(1:n) = buffer%data(1:n) ; new_data(n+1:m) = 0.0
  new_mask(1:n) = buffer%mask(1:n) ; new_mask(n+1:m) = .FALSE.
  deallocate(buffer%data, buffer%mask)

  buffer%data=>new_data
  buffer%mask=>new_mask

end subroutine


end module tile_diag_buff_mod

module ocean_blob_dynamic_bottom_mod
!
!<CONTACT EMAIL="m.bates@student.unsw.edu.au"> Michael L. Bates
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! This module runs the dynamic bottom blob implementation of the embedded 
! Lagrangian buoyancy blob framework. The module forms new dynamic 
! bottom blobs, integrates the properties of existing blobs, and handles
! the transfer of free blobs to bottom blobs.
!</OVERVIEW>
!
!<DESCRIPTION>
! Bottom blobs are formed using the subroutine dynamic_bottom_form_new,
! which is called from the main blob driver module.  Bottom blobs are
! formed explicitly in time, directly after the integration of existing
! blobs.
!
! The properties of a bottom blob are also integrated in this module,
! that is, position, velocity, mass and tracer content.  Position and
! velocity are integrated using an adaptive step Runge-Kutta scheme.
! There are several schemes available of varying order.
!
! The module also recieves blobs that are transferring from the free
! blob dynamic regime to the bottom blob dynamic regime (i.e. free
! blobs that have interacted with topography).
!</DESCRIPTION>
!
!<INFO>
!
! <REFERENCE>
!  Price, J.F., Baringer, M.O'N. (1994) Outflows and deep water production 
!  by marginal seas. Progress in Oceanography 33(3), 161-200.
! </REFERENCE>
!
! <REFERENCE>
!  Campin, J-.M., Goosse, H. (1999) Parameterization of a density-driven
!  downsloping flow for a coarse-resolution ocean model in z-coordinate.
!  Tellus 51A(3), 412-430.
! </REFERENCE>
!
! <REFERENCE>
!  Bogacki, P., Shampine, L.F. (1989) A 3(2) pair of Runge-Kutta formulas.
!  Applied Mathematical Letters 2(4), 321-325.
! </REFERENCE>
!
! <REFERENCE>
!  Cash, J.R., Karp, A.H. (1990) A variable order Runge-Kutta method for 
!  initial value problems with rapidly varying right-hand sides.
!  ACM Transactions on Mathematical Software 16(3), 201-222.
! </REFERENCE>
!
!</INFO>
!<NAMELIST NAME="ocean_blob_dynamic_bottom_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module.
!  Default is use_this_module=.false.
!  </DATA>
!
!  <DATA NAME="blob_overflow_mu" TYPE="real">
!  Frictional dissipation rate used for calculating initial
!  properties of bottom blobs.  Corresponds to mu in Campin and 
!  Goosse (1999).  Units are 1/s.
!  Default is blob_overflow_mu=1.0e-4
!  </DATA>
!
!  <DATA NAME="blob_overflow_delta" TYPE="real">
!  Fraction of a grid cell participating in an overflow event.
!  Corresponds to delta in Campin and Goosse (1999).  Dimensionless.
!  Default is blob_overflow_mu=1.0e-4
!  </DATA>
!
!  <DATA NAME="drag" TYPE="real">
!  Coefficient of drag used for bottom stress drag.
!  Corresponds to Cd in Price and Baringer (1994). Dimensionless.
!  Default is drag=3.0e-3
!  </DATA>
!
!  <DATA NAME="det_param" TYPE="real">
!  The detrainment parameter (kg m^2/s). 
!  Corresponds to Gamma in the notes.
!  Default is det_param=5.0e-8
!
!  </DATA>
!  <DATA NAME="max_detrainment" TYPE="real">
!  The Maximum allowable detrainment velocity (m/s).
!  Default is max_detrainment=1.0e-3
!  </DATA>
!
!  <DATA NAME="rel_error" TYPE="real">
!  Relative error for the RK scheme (dimensionless).
!  A smaller number is more accurate, but, 
!  is more computationally expensive. Corresponds to
!  zeta* in the notes.
!  Must be 0<rel_error<=1.0
!  Default is rel_error=0.01
!  </DATA>
!
!  <DATA NAME="safety_factor" TYPE="real">
!  Safety factor for the RK scheme (dimensionless).
!  A smaller number should reduce the number
!  of rejected steps, but, decreases the locally
!  extrapolated step.  Corresponds to varrho in 
!  the notes.
!  Must be 0<safety_factor<=1.0
!  Default is safety_factor=0.8
!  </DATA>
!
!  <DATA NAME="minstep" TYPE="real">
!  Minimum step size (in seconds) for a blob.
!  Default is minstep=9.0
!  </DATA>
!
!  <DATA NAME="elastic" TYPE="real">
!  The elasticity of a blob's collision with
!  the topography.  Corresponds to epsilon in 
!  the notes. Should have values 0<=elastic<=1.0
!  Values greater than 1 would be super-elastic,
!  and values less than 0 would send the blob
!  in the opposite direction than it should be 
!  going in.
!  Default is elastic=1.0
!  </DATA>
!
!  <DATA NAME="min_do_levels" TYPE="integer">
!  Minimum number of deep ocean levels for
!  overflows to be considered.  That is, how many
!  k levels lower should the deep ocean water column
!  be than the shelf/shallow ocean column.  Value
!  must be greater than 0.
!  Default is min_do_levels=1
!  </DATA>
!
!  <DATA NAME="rho_threshold" TYPE="real">
!  The density difference required before a blob
!  is formed.  rho_threshold must be greater than
!  zero.
!  Default is rho_threshold=0.01
!  </DATA>
!
!  <DATA NAME="large_speed" TYPE="real">
!  A value for error checking.  If the speed of a
!  blob exceeds large_speed in any of x,y,z then
!  a warning flag is raised.
!  Default is large_speed=10.0
!  </DATA>
!
!  <DATA NAME="no_rotation" TYPE="real">
!  Sets the coriolis parameter to zero regardless
!  of latitude
!  Default is no_rotation=.false.
!  </DATA>
!
!  <DATA NAME="critical_richardson" TYPE="real">
!  The critical Richardson number for the entrainment
!  velocity.  Default is based on Price and Baringer
!  (1994).
!  Default is critical_richardson=0.8
!  </DATA>
!
!</NAMELIST>
!

use constants_mod,    only: rad_to_deg, deg_to_rad, epsln, pi
use diag_manager_mod, only: register_diag_field, send_data

use fms_mod,         only: stdout, stdlog, open_namelist_file, FATAL, WARNING
use fms_mod,         only: mpp_error, check_nml_error, close_file
use mpp_mod,         only: NULL_PE, mpp_sum, mpp_max, mpp_recv, mpp_send, mpp_sync_self
use mpp_mod,         only: CLOCK_LOOP, mpp_clock_id, mpp_clock_begin, mpp_clock_end
use mpp_mod,         only: mpp_get_current_pelist, mpp_root_pe, mpp_npes
use mpp_domains_mod, only: mpp_update_domains

use ocean_blob_util_mod,  only: insert_blob, unlink_blob, blob_delete, interp_tcoeff, interp_ucoeff
use ocean_blob_util_mod,  only: check_ijcell, free_blob_memory, kill_blob, count_blob, write_blobs
use ocean_blob_util_mod,  only: allocate_interaction_memory, reallocate_interaction_memory
use ocean_blob_util_mod,  only: E_and_L_totals, check_cyclic
use ocean_density_mod,    only: density
use ocean_parameters_mod, only: onehalf, onethird, twothirds, rho0, rho0r, grav, omega_earth
use ocean_parameters_mod, only: PRESSURE_BASED, DEPTH_BASED
use ocean_types_mod,      only: ocean_time_type, ocean_grid_type, blob_diag_type
use ocean_types_mod,      only: ocean_domain_type, blob_grid_type, ocean_external_mode_type
use ocean_types_mod,      only: ocean_lagrangian_type, ocean_thickness_type, ocean_velocity_type
use ocean_types_mod,      only: ocean_blob_type, ocean_prog_tracer_type, ocean_density_type
use ocean_util_mod,       only: write_timestamp

implicit none

private

! set module types 
type(ocean_grid_type),   pointer :: Grd   => NULL()
type(ocean_domain_type), pointer :: Dom   => NULL()
type(ocean_domain_type), pointer :: Bdom  => NULL()
type(blob_grid_type),    pointer :: Info  => NULL()

real :: dtime
real :: dtime_yr
real :: det_factor
real :: ent_factor

real, parameter :: sixonpi   = 6.0/pi
real :: two_omega

logical :: module_is_initialized=.false.

!RK coefficients
real, dimension(:,:), allocatable :: beta
real, dimension(:),   allocatable :: lgamma
real, dimension(:),   allocatable :: hgamma
real :: order
real :: orderp1_r
integer :: ns, nsp1, total_ns, total_nsp1, total_nsp2

! For topography
real, dimension(:,:), allocatable :: ht, dht_dx, dht_dy

!initial stretching function for blobs
real, dimension(:,:,:), allocatable :: blobh1
real, dimension(:,:,:), allocatable :: blobh2

integer :: num_prog_tracers=0
integer :: index_temp=-1
integer :: index_salt=-1
integer :: isd,ied,jsd,jed
integer :: isc,iec,jsc,jec
integer :: isg,ieg,jsg,jeg
integer :: nk
integer :: isbd, iebd, jsbd, jebd

integer :: method

!clock variables
integer :: id_clock_rk

!Diagnostics
logical :: used
integer :: id_free_to_bot
integer :: id_new_blobs

!variables for initialising blobs
real :: overflow_factor
real :: dtime_rad_to_deg
real, dimension(:,:,:), allocatable :: topog_step
real, dimension(:,:,:), allocatable :: topog_slope
real, dimension(:,:,:), allocatable :: vert_factor
integer, dimension(4) :: ip, jp, ish, jsh, ieh, jeh

real, dimension(:,:,:), allocatable :: hb
real, dimension(:,:,:), allocatable :: xb
real, dimension(:,:,:), allocatable :: yb

real, dimension(:,:,:), allocatable :: umask !umask, but, halo=2

integer, dimension(:,:), allocatable :: kmt
integer, dimension(:,:), allocatable :: kmu
integer, dimension(5) :: it, jt
integer, dimension(4) :: iu, ju 

type, private :: blob_buffer_type
   integer :: numblobs
   integer :: size
   integer :: pe
   integer, allocatable, dimension(:,:)   :: integer_buff
   real,    allocatable, dimension(:,:)   :: real_buff
   integer, allocatable, dimension(:,:,:) :: history_integer_buff
   real,    allocatable, dimension(:,:,:) :: history_real_buff
end type blob_buffer_type

integer :: rea_buff_size, int_buff_size
integer :: hist_rea_buff_size, hist_int_buff_size
type(blob_buffer_type), pointer :: Ebuffer_out,  Ebuffer_in
type(blob_buffer_type), pointer :: Wbuffer_out,  Wbuffer_in
type(blob_buffer_type), pointer :: Nbuffer_out,  Nbuffer_in
type(blob_buffer_type), pointer :: Sbuffer_out,  Sbuffer_in
type(blob_buffer_type), pointer :: NEbuffer_out, NEbuffer_in
type(blob_buffer_type), pointer :: NWbuffer_out, NWbuffer_in
type(blob_buffer_type), pointer :: SEbuffer_out, SEbuffer_in
type(blob_buffer_type), pointer :: SWbuffer_out, SWbuffer_in
type(blob_buffer_type), pointer :: diagbuffer_out, diagbuffer_in

! buffers and buffer variables to send blobs to adjacent PE's
integer, parameter :: delta_buffer = 25   ! Size by which to increment the buffer

public blob_dynamic_bottom_init
public blob_dynamic_bottom_update
public transfer_free_to_bottom
public dynamic_bottom_form_new
public blob_dynamic_bottom_end

! variables controlled by other namelists
logical :: debug_this_module
logical :: really_debug
integer :: vert_coordinate_class ! the class of vertical coordinate
integer :: vert_coordinate
logical :: blob_diag
real    :: small_mass
logical :: bitwise_reproduction

! namelist defaults
logical :: use_this_module   = .false.
character(len=10) :: update_method = 'BS_RK3(2)'
real    :: blob_overflow_mu    = 1.0e-4  ! frictional dissipation rate (sec^-1) at bottom  
real    :: blob_overflow_delta = 0.3333  ! fraction of a grid cell participating in overflow 
real    :: drag                = 3.0e-3
logical :: enforce_big_blobs   = .false.
real    :: det_param           = 5.0e-8
real    :: max_detrainment     = 1.0e-3
real    :: rel_error           = 0.01
real    :: safety_factor       = 0.8
real    :: minstep             =  9.0
real    :: first_step          = 50.0
real    :: elastic             = 1.0
integer :: min_do_levels       = 1
real    :: rho_threshold       = 0.01
logical :: accept_free_blobs   = .true.
real    :: large_speed         = 10.0 !m/s
logical :: no_rotation         = .false.
real    :: critical_richardson = 0.8
real    :: blob_height         = 100.0 !m
real    :: blobs_south_of      = -45.0
real    :: blobs_north_of      =  45.0

namelist /ocean_blob_dynamic_bottom_nml/ use_this_module, update_method,   &
     blob_overflow_mu, blob_overflow_delta, drag, enforce_big_blobs,       &
     det_param, max_detrainment, rel_error, safety_factor, elastic,        &
     minstep, first_step, min_do_levels, rho_threshold, accept_free_blobs, &
     large_speed, no_rotation, critical_richardson, blob_height,           &
     blobs_south_of, blobs_north_of
     
contains
!#######################################################################
! <SUBROUTINE NAME="blob_dynamic_bottom_init">
!
! <DESCRIPTION>
! Initialises the dynamic free blobs by checking the namelist and also
! inherited namelists (from ocean_blob_nml).  Also sets up some useful
! constants (including spatially varying constants) - particularly for
! the formation of bottom blobs.  It also allocates memory to special 
! halo=2 masks and sets up the blob buffers for sending blobs from one 
! PE to another.
! </DESCRIPTION>
!
subroutine blob_dynamic_bottom_init(Time, Grid, Domain, Blob_domain, PE_Info,          &
                                    debug, big_debug, bitwise, num_tracers,            &
                                    itemp, isalt, dtimein, ver_coord_class, ver_coord, &
                                    blob_diagnostics, bott_minstep, bott_total_ns,     &
                                     smallmass, use_dyn_bot)

  type(ocean_time_type),        intent(in)         :: Time
  type(ocean_grid_type),        intent(in), target :: Grid
  type(ocean_domain_type),      intent(in), target :: Domain
  type(ocean_domain_type),      intent(in), target :: Blob_domain
  type(blob_grid_type),         intent(in), target :: PE_Info
  logical, intent(in)  :: debug
  logical, intent(in)  :: big_debug
  logical, intent(in)  :: bitwise
  integer, intent(in)  :: num_tracers
  integer, intent(in)  :: itemp
  integer, intent(in)  :: isalt
  real,    intent(in)  :: dtimein
  integer, intent(in)  :: ver_coord_class
  integer, intent(in)  :: ver_coord
  logical, intent(in)  :: blob_diagnostics
  real,    intent(out) :: bott_minstep
  integer, intent(out) :: bott_total_ns
  real,    intent(in)  :: smallmass
  logical, intent(out) :: use_dyn_bot

  real, dimension(:,:), allocatable :: slope_x
  real, dimension(:,:), allocatable :: slope_y
  real, dimension(:,:), allocatable :: coeff1
  real, dimension(:,:), allocatable :: coeff2
  real, parameter                   :: secs_in_year_r = 1.0 / (86400.0 * 365.25)
  integer :: ioun, ierr, io_status
  integer :: stdoutunit,stdlogunit
  integer :: i,j,m,iip,jjp

  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL,&
         '==>Error in ocean_blob_dynamic_free_mod (ocean_blob_dynamic_free_init):' &
         //' module already initialized')
  endif 

  ! provide for namelist over-ride of default values
  ioun =  open_namelist_file()
  read (ioun,ocean_blob_dynamic_bottom_nml,IOSTAT=io_status)
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_blob_dynamic_bottom_nml)  
  write (stdlogunit,ocean_blob_dynamic_bottom_nml)
  ierr = check_nml_error(io_status,'ocean_blob_dynamic_bottom_nml')
  call close_file (ioun)

  module_is_initialized = .true.
  
  use_dyn_bot = use_this_module

  Grd   => Grid
  Dom   => Domain
  Bdom  => Blob_domain
  Info  => PE_Info

  if (no_rotation) then
     two_omega = 0.0
  else
     two_omega = 2*omega_earth
  endif

  debug_this_module = debug

  index_temp           = itemp
  index_salt           = isalt
  num_prog_tracers     = num_tracers
  bitwise_reproduction = bitwise
  dtime                = dtimein
  small_mass           = smallmass
  bott_minstep         = minstep
  blob_diag            = blob_diagnostics
  really_debug         = big_debug

  id_free_to_bot = register_diag_field('ocean_model','free_to_bot', Time%model_time, &
       'free blobs interacting with topography', 'number of blobs')

  if (.not. use_this_module) return

  id_new_blobs   = register_diag_field('ocean_model','new_bottom_blobs', Time%model_time, &
       'new bottom blobs', 'number of blobs')

  dtime_rad_to_deg = dtime*rad_to_deg
  dtime_yr         = dtime*secs_in_year_r

  vert_coordinate_class = ver_coord_class
  vert_coordinate       = ver_coord

  isd=Dom%isd; ied=Dom%ied; jsd=Dom%jsd; jed=Dom%jed
  isc=Dom%isc; iec=Dom%iec; jsc=Dom%jsc; jec=Dom%jec
  isg=Dom%isg; ieg=Dom%ieg; jsg=Dom%jsg; jeg=Dom%jeg
  nk = Grd%nk

  isbd=Bdom%isd; iebd=Bdom%ied; jsbd=Bdom%jsd; jebd=Bdom%jed

  if (min_do_levels<1) then
     write(stdoutunit,'(a)')&
          '==>Error in ocean_blob_dynamic_bottom_mod (ocean_blob_dynamic_bottom_init):' &
          //' invalid value for min_do_levels chosen.  Should be greater than or equal to one.'
     write(stdoutunit,'(a,i3)') 'min_do_levels =',min_do_levels
     call mpp_error(FATAL,&
          '==>Error in ocean_blob_dynamic_bottom_mod (ocean_blob_dynamic_bottom_init):' &
          //' invalid value for min_do_levels chosen.  Should be greater than or equal to one.')
  endif

  allocate(kmt(isbd:iebd, jsbd:jebd))
  allocate(kmu(isbd:iebd, jsbd:jebd))
  kmt(isc:iec,jsc:jec) = Grd%kmt(isc:iec, jsc:jec)
  kmu(isc:iec,jsc:jec) = Grd%kmu(isc:iec, jsc:jec)
  call mpp_update_domains(kmt(:,:), Bdom%domain2d, complete=.false.)
  call mpp_update_domains(kmu(:,:), Bdom%domain2d, complete=.true.)

  allocate(ht(isbd:iebd, jsbd:jebd))
  allocate(dht_dx(isbd:iebd, jsbd:jebd))
  allocate(dht_dy(isbd:iebd, jsbd:jebd))
  ht(isc:iec,jsc:jec) = Grd%ht(isc:iec,jsc:jec)
  dht_dx(isd:iec,jsd:jec) = Grd%dht_dx(isd:iec,jsd:jec)
  dht_dy(isd:iec,jsd:jec) = Grd%dht_dy(isd:iec,jsd:jec)
  call mpp_update_domains(ht(:,:),     Bdom%domain2d, complete=.false.)
  call mpp_update_domains(dht_dx(:,:), Bdom%domain2d, complete=.false.)
  call mpp_update_domains(dht_dy(:,:), Bdom%domain2d, complete=.true.)

  ! special treatment for boundaries if they are NULL_PEs.
  ! Make sure that kmt==0, kmu==0, ht==0.0, dht_dx==0 
  ! and dht_dy==0 in solid boundaries.
  if (Info%pe_S==NULL_PE) then
     kmt(:,jsbd:jsd) = 0
     kmu(:,jsbd:jsd) = 0
     ht (:,jsbd:jsd) = 0.0
     dht_dx(:,jsbd:jsd)  = 0.0
     dht_dy(:,jsbd:jsd)  = 0.0
  endif
  if (Info%pe_N==NULL_PE) then
     kmt(:,jed:jebd) = 0
     kmu(:,jed:jebd) = 0
     ht (:,jed:jebd) = 0.0
     dht_dx(:,jed:jebd) = 0.0
     dht_dy(:,jed:jebd) = 0.0
  endif
  if (Info%pe_E==NULL_PE) then
     kmt(ied:iebd,:) = 0
     kmu(ied:iebd,:) = 0
     ht( ied:iebd,:) = 0.0
     dht_dx(ied:iebd,:) = 0.0
     dht_dy(ied:iebd,:) = 0.0
  endif
  if (Info%pe_W==NULL_PE) then
     kmt(isbd:isd,:) = 0
     kmu(isbd:isd,:) = 0
     ht (isbd:isd,:) = 0.0
     dht_dx(isbd:isd,:) = 0.0
     dht_dy(isbd:isd,:) = 0.0
  endif

  allocate(umask(isbd:iebd,jsbd:jebd,1:nk))
  umask(isc:iec,jsc:jec,1:nk) = Grd%umask(isc:iec,jsc:jec, 1:nk)
  call mpp_update_domains(umask(:,:,1:nk), Bdom%domain2d)
  ! special treatment for boundaries if they are NULL_PEs.
  ! Make sure that umask==0
  if (Info%pe_S==NULL_PE) umask(:,jsbd:jsd,:) = 0.0
  if (Info%pe_N==NULL_PE) umask(:,jed:jebd,:) = 0.0
  if (Info%pe_E==NULL_PE) umask(ied:iebd,:,:) = 0.0
  if (Info%pe_W==NULL_PE) umask(isbd:isd,:,:) = 0.0

  allocate(coeff1(isc:iec,jsc:jec))
  allocate(coeff2(isc:iec,jsc:jec))

  ! Calculate the depth, lon and lat of initial blob positions
  allocate(hb(isc:iec,jsc:jec,4))
  allocate(xb(isc:iec,jsc:jec,4))
  allocate(yb(isc:iec,jsc:jec,4))

  ! Calculate the stretching function in the places we form blobs
  ! We do not need to worry about special treatment for solid wall 
  ! because we will never form a blob at a solid wall boundary
  allocate(blobh1(isc:iec,jsc:jec,4))
  allocate(blobh2(isc:iec,jsc:jec,4))

  m=1
  coeff1(:,:) = Grd%dtw(isc+1:iec+1,jsc:jec)/Grd%dxte(isc:iec,jsc:jec)
  coeff2(:,:) = Grd%dte(isc  :iec  ,jsc:jec)/Grd%dxte(isc:iec,jsc:jec)

  hb(:,:,m) = Grd%ht(isc:iec,jsc:jec)*coeff1(:,:) + Grd%ht(isc+1:iec+1,jsc:jec)*coeff2(:,:)
  xb(:,:,m) = Grd%xt(isc:iec,jsc:jec)*coeff1(:,:) + Grd%xt(isc+1:iec+1,jsc:jec)*coeff2(:,:) 
  yb(:,:,m) = Grd%yt(isc:iec,jsc:jec)*coeff1(:,:) + Grd%yt(isc+1:iec+1,jsc:jec)*coeff2(:,:) 
  blobh1(:,:,m) = Grd%h1t(isc:iec,jsc:jec)*coeff1(:,:) + Grd%h1t(isc+1:iec+1,jsc:jec)*coeff2(:,:)
  blobh2(:,:,m) = Grd%h2t(isc:iec,jsc:jec)*coeff1(:,:) + Grd%h2t(isc+1:iec+1,jsc:jec)*coeff2(:,:)

  m=2
  coeff1(:,:) = Grd%dts(isc:iec,jsc+1:jec+1)/Grd%dytn(isc:iec,jsc:jec)
  coeff2(:,:) = Grd%dtn(isc:iec,jsc  :jec  )/Grd%dytn(isc:iec,jsc:jec)

  hb(:,:,m) = Grd%ht(isc:iec,jsc:jec)*coeff1(:,:) + Grd%ht(isc:iec,jsc+1:jec+1)*coeff2(:,:) 
  xb(:,:,m) = Grd%xt(isc:iec,jsc:jec)*coeff1(:,:) + Grd%xt(isc:iec,jsc+1:jec+1)*coeff2(:,:) 
  yb(:,:,m) = Grd%yt(isc:iec,jsc:jec)*coeff1(:,:) + Grd%yt(isc:iec,jsc+1:jec+1)*coeff2(:,:) 
  blobh1(:,:,m) = Grd%h1t(isc:iec,jsc:jec)*coeff1(:,:) + Grd%h1t(isc:iec,jsc+1:jec+1)*coeff2(:,:)
  blobh2(:,:,m) = Grd%h2t(isc:iec,jsc:jec)*coeff1(:,:) + Grd%h2t(isc:iec,jsc+1:jec+1)*coeff2(:,:)

  m=3
  coeff1(:,:) = Grd%dte(isc-1:iec-1,jsc:jec)/Grd%dxte(isc-1:iec-1,jsc:jec)
  coeff2(:,:) = Grd%dtw(isc  :iec,  jsc:jec)/Grd%dxte(isc-1:iec-1,jsc:jec)

  hb(:,:,m) = Grd%ht(isc:iec,jsc:jec)*coeff1(:,:) + Grd%ht(isc-1:iec-1,jsc:jec)*coeff2(:,:) 
  xb(:,:,m) = Grd%xt(isc:iec,jsc:jec)*coeff1(:,:) + Grd%xt(isc-1:iec-1,jsc:jec)*coeff2(:,:) 
  yb(:,:,m) = Grd%yt(isc:iec,jsc:jec)*coeff1(:,:) + Grd%yt(isc-1:iec-1,jsc:jec)*coeff2(:,:) 
  blobh1(:,:,m) = Grd%h1t(isc:iec,jsc:jec)*coeff1(:,:) + Grd%h1t(isc-1:iec-1,jsc:jec)*coeff2(:,:)
  blobh2(:,:,m) = Grd%h2t(isc:iec,jsc:jec)*coeff1(:,:) + Grd%h2t(isc-1:iec-1,jsc:jec)*coeff2(:,:)

  m=4
  coeff1(:,:) = Grd%dtn(isc:iec,jsc-1:jec-1)/Grd%dytn(isc:iec,jsc-1:jec-1)
  coeff2(:,:) = Grd%dts(isc:iec,jsc  :jec  )/Grd%dytn(isc:iec,jsc-1:jec-1)

  hb(:,:,m) = Grd%ht(isc:iec,jsc:jec)*coeff1(:,:) + Grd%ht(isc:iec,jsc-1:jec-1)*coeff2(:,:)
  xb(:,:,m) = Grd%xt(isc:iec,jsc:jec)*coeff1(:,:) + Grd%xt(isc:iec,jsc-1:jec-1)*coeff2(:,:)
  yb(:,:,m) = Grd%yt(isc:iec,jsc:jec)*coeff1(:,:) + Grd%yt(isc:iec,jsc-1:jec-1)*coeff2(:,:)
  blobh1(:,:,m) = Grd%h1t(isc:iec,jsc:jec)*coeff1(:,:) + Grd%h1t(isc:iec,jsc-1:jec-1)*coeff2(:,:)
  blobh2(:,:,m) = Grd%h2t(isc:iec,jsc:jec)*coeff1(:,:) + Grd%h2t(isc:iec,jsc-1:jec-1)*coeff2(:,:)

  solver_method: select case (trim(update_method))
  case('BS_RK3(2)')
     method = 1

     allocate(beta(1:3,0:2)); beta(:,:) = 0.
     allocate(lgamma(0:3)); lgamma(:)   = 0. !2nd order coefficients
     allocate(hgamma(0:3)); hgamma(:)   = 0. !3rd order coefficients
     
     beta(1,0)   =    1/2.
     beta(2,0:1) = (/ 0.,    3/4.       /)
     beta(3,0:2) = (/ 2/9.,  1/3., 4/9. /)
     
     hgamma(0:3) = (/ 2/9.,  1/3., 4/9., 0.   /)
     lgamma(0:3) = (/ 7/24., 1/4., 1/3., 1/8. /)
     
     order     = 2.
     orderp1_r = 1/(order + 1.)

  case('DP_RK5(4)')
     method = 2

     write(stdoutunit,'(a,/,a)')&
          '==>Warning in ocean_blob_dynamic_bottom_mod (ocean_blob_dynamic_bottom_init):' &
          //' The Dormand-Prince 5(4) method chosen.  This scheme is buggy.',             &
          '   It is suggested to use the Cash-Karp scheme by setting the namelist '      &
          //'variable update_method=CK_RK5(4)'
     
     call mpp_error(WARNING,&
          '==>Warning in ocean_blob_dynamic_bottom_mod (ocean_blob_dynamic_bottom_init):' &
          //' The Dormand-Prince 5(4) method chosen.  This scheme is buggy.')

     ! The scheme is buggy because it produces large error estimates compared to the CK or
     ! BS schemes.  Not sure why it is so.
     ! The large error estimates mean that it takes a lot of sub-cycles to for each blob.

     allocate(beta(1:6,0:5)); beta(:,:) = 0.
     allocate(lgamma(0:6));   lgamma(:) = 0. !4th order coefficients
     allocate(hgamma(0:6));   hgamma(:) = 0. !5th order coefficients
     
     beta(1,0)   =        1/5.
     beta(2,0:1) = (/     3/40.  ,       9/40.  /)
     beta(3,0:2) = (/    44/45.  ,     -56/15.  ,    32/9.   /)
     beta(4,0:3) = (/ 19372/6561.,  -25360/2187., 64448/6561., -212/729. /)
     beta(5,0:4) = (/  9017/3168.,    -355/33.  , 46732/5247.,   49/176., -5103/18656./)
     beta(6,0:5) = (/    35/384. ,       0.     ,   500/1113.,  125/192., -2187/6784. , 11/84./)
     
     hgamma(0:6) = (/   35/384.  , 0.,  500/1113. , 125/192.,  -2187/6784.  ,  11/84. , 0.    /)
     lgamma(0:6) = (/ 5179/57600., 0., 7571/16695., 393/640., -92097/339200., 187/2100., 1/40. /)
     
     order     = 4.
     orderp1_r = 1/(order + 1.)

  case('CK_RK5(4)')
     method = 3

     allocate(beta(1:5,0:4)); beta(:,:) = 0.
     allocate(lgamma(0:5));   lgamma(:) = 0. !4th order coefficients
     allocate(hgamma(0:5));   hgamma(:) = 0. !5th order coefficients
     
     beta(1,0)   =        1/5.
     beta(2,0:1) = (/     3/40.   ,   9/40.  /)
     beta(3,0:2) = (/     3/10.   ,  -9/10. ,   6/5.     /)
     beta(4,0:3) = (/   -11/54.   ,   5/2.  , -70/27.   ,    35/27.    /)
     beta(5,0:4) = (/  1631/55296., 175/512., 575/13824., 44275/110592.,   253/4096. /)
     
     hgamma(0:5) = (/   37/378.  , 0.,   250/621.  ,   125/594.  ,  0.       , 512/1771. /)
     lgamma(0:5) = (/ 2825/27648., 0., 18575/48384., 13525/55296., 277/14336.,   1/4.    /)
     
     order     = 4.
     orderp1_r = 1/(order + 1.)

  case default 
     write(stdoutunit,'(a)')&
          '==>Error in ocean_blob_dynamic_bottom_mod (ocean_blob_dynamic_bottom_init):' &
          //' invalid solver chosen ('//update_method//').  Check update_method in namelist.'
     call mpp_error(FATAL,&
          '==>Error in ocean_blob_dynamic_bottom_mod (ocean_blob_dynamic_bottom_init):' &
          //' invalid solver chosen ('//update_method//').  Check update_method in namelist.')
  endselect solver_method

  ns            = ubound(lgamma,1)   ! number of partial steps in a fractional step
  nsp1          = ns+1               ! number of partial steps in a fractional step+1
  total_ns      = ceiling(dtime/minstep) !maximum number of partial steps in a full step
  total_nsp1    = total_ns+1
  total_nsp2    = total_nsp1+1
  bott_total_ns = total_ns

  ! This collects all the constant terms together in the expression
  ! for the rate of change of mass.
  ! For detrainment:
  ! dm/dt = rhoL A D (A=blob surface area, D=detrainment rate)
  !       = -rhoL A Gamma/|rhoL - rhoE|
  !       = -m**2/3 Gamma rhoL (36pi)**1/3 / (rhoL**2/3 |rhoL-rhoE|)
  ! For entrainment:
  ! dm/dt = rhoE A E (A=blob surface area, E=entrainment rate)
  !       = -m**2/3 rhoE (36pi)**1/3 / (rhoL**2/3)
  !
  ! In the Boussinesq case rhoE=rhoL=rho0 (excepting |rhoL-rhoE|)
  ! we also need to take into account that this is done for each PARTIAL step.
  if (vert_coordinate_class==DEPTH_BASED) then
     det_factor = det_param*((rho0*36*pi)**onethird)
     ent_factor = ((rho0*36*pi)**onethird)
  else !PRESSURE_BASED
     det_factor = det_param*((36*pi)**onethird)
     ent_factor = ((36*pi)**onethird)
  endif

  ! Allocate the buffers
  ! Things that dictate the size of the real buffer are:
  ! tracer content (num_prog_tracer), change in mass (1),
  ! change in tracer (num_prog_tracer; only needed for bitwise_reproduction),
  ! velocity(3), position (3),
  ! step size (1), blob time(1),  mass (1), stretching function (2), 
  ! gprime (1), and age (1).
  rea_buff_size = 2*num_prog_tracers+18
  ! Integer buffer is: ijk (3), model_steps (1), hash (1), number (1),
  ! nfrac_steps (1), nsteps (1)
  int_buff_size = 8

  if (bitwise_reproduction) then
     ! History real buffer is: entrainment (num_prog_tracers+1), detrainment (num_prog_tracers+1) 
     ! mass in/out (2).
     hist_rea_buff_size = 2*num_prog_tracers+3 !it is not 2*(num_prog_tracers+1)+2 because the dimension goes from 0 
     ! History integer buffer is: ijk (3)
     hist_int_buff_size = 3
  else
     ! History real buffer is: entrainment (num_prog_tracers+1), detrainment (num_prog_tracers+1) 
     hist_rea_buff_size = 2*num_prog_tracers + 1 !it is not 2*(num_prog_tracers+1) because the dimension goes from 0 
  endif
  call allocate_buffer(Ebuffer_out,  Info%pe_E);  call allocate_buffer(Ebuffer_in,  Info%pe_E)
  call allocate_buffer(Wbuffer_out,  Info%pe_W);  call allocate_buffer(Wbuffer_in,  Info%pe_W)
  call allocate_buffer(Nbuffer_out,  Info%pe_N);  call allocate_buffer(Nbuffer_in,  Info%pe_N)
  call allocate_buffer(Sbuffer_out,  Info%pe_S);  call allocate_buffer(Sbuffer_in,  Info%pe_S)
  call allocate_buffer(NEbuffer_out, Info%pe_NE); call allocate_buffer(NEbuffer_in, Info%pe_NE)
  call allocate_buffer(NWbuffer_out, Info%pe_NW); call allocate_buffer(NWbuffer_in, Info%pe_NW)
  call allocate_buffer(SEbuffer_out, Info%pe_SE); call allocate_buffer(SEbuffer_in, Info%pe_SE)
  call allocate_buffer(SWbuffer_out, Info%pe_SW); call allocate_buffer(SWbuffer_in, Info%pe_SW)

  if (Info%pe_this == mpp_root_pe()) then
     call allocate_buffer(diagbuffer_in, NULL_PE)
  else
     call allocate_buffer(diagbuffer_out, mpp_root_pe())
  endif

  id_clock_rk = mpp_clock_id('(Ocean dyn. bottom blob: RK scheme)', grain=CLOCK_LOOP)

  ! The rest of the initialisation is for  variables that 
  ! are used for calculating formation of blobs.  They are NOT
  ! used for the evolution of blobs.

  ! gravity * fraction of cell participating in overflow / friction
  overflow_factor = grav*blob_overflow_delta/blob_overflow_mu

  ! compute topographic slope arrays for the i-slope and j-slope
  ! slopes are centered on the i-face and j-face of tracer cells 
  allocate(slope_x(isd:ied,jsd:jed))
  allocate(slope_y(isd:ied,jsd:jed))
  slope_x(:,:) = 0.0 
  slope_y(:,:) = 0.0
  do j=jsc,jec
     do i=isc,iec
        slope_x(i,j) = (Grd%ht(i+1,j)-Grd%ht(i,j))*Grd%dxter(i,j)
        slope_y(i,j) = (Grd%ht(i,j+1)-Grd%ht(i,j))*Grd%dytnr(i,j)
        slope_x(i,j) = abs(slope_x(i,j))
        slope_y(i,j) = abs(slope_y(i,j))
     enddo
  enddo

  call mpp_update_domains(slope_x(:,:),Dom%domain2d)
  call mpp_update_domains(slope_y(:,:),Dom%domain2d)
  
  ! labels for the four tracer cells surrounding a 
  ! central tracer cell (moving counter-clockwise)
  m=1 ; ip(m)=1  ; jp(m)=0
  m=2 ; ip(m)=0  ; jp(m)=1
  m=3 ; ip(m)=-1 ; jp(m)=0
  m=4 ; ip(m)=0  ; jp(m)=-1

  ! compute directions from an (i,j) point where topography deepens.
  ! these directions may potentially have downslope flow. 
  ! insist that downslope flow occurs only when there are more kmt 
  ! cells in the adjacent column. 
  ! also insist that downslope flow does not involve k=1 cells. 
  allocate (topog_step(isd:ied,jsd:jed,4))
  allocate (topog_slope(isd:ied,jsd:jed,4))
  topog_step(:,:,:)  = 0.0
  topog_slope(:,:,:) = 0.0

  ! figure out which vertical cell in the deep ocean column a blob
  ! will be inserted into when it is created

  do m=1,4
     do j=jsc,jec
        do i=isc,iec
           iip = i+ip(m)
           jjp = j+jp(m)
           ! Make sure that we are in an area we want to form blobs
           if ( blobs_south_of>Grd%yt(iip,jjp) .or. &
                blobs_north_of<Grd%yt(iip,jjp) ) then
              ! check whether downslope flow is possible
              if (kmt(i,j)>1 .and. kmt(iip,jjp)>kmt(i,j)+min_do_levels) then
                 topog_step(i,j,m)=1.0
              endif
           endif
        enddo
     enddo
  enddo

  ! Block out the bipolar fold in order to ensure tracer 
  ! conservation.
  ! NOTE TO SELF: do we need this for the blobs?
  if(jec+Dom%joff==Dom%jeg) topog_step(:,jec,:) = 0.0

  do j=jsc,jec
     do i=isc,iec
        topog_slope(i,j,1) = slope_x(i,j)   !m=1
        topog_slope(i,j,2) = slope_y(i,j)   !m=2
        topog_slope(i,j,3) = slope_x(i-1,j) !m=3
        topog_slope(i,j,4) = slope_y(i,j-1) !m=4
     enddo
  enddo

  call mpp_update_domains(topog_step(:,:,:), Dom%domain2d)
  call mpp_update_domains(topog_slope(:,:,:),Dom%domain2d)

  deallocate(slope_x)
  deallocate(slope_y)

  allocate(vert_factor(isc:iec,jsc:jec,4))
  do m=1,4
     do i=isc,iec
        do j=jsc,jec
           vert_factor(i,j,m) = dtime*grav*(-1 + 1/sqrt( 1+topog_slope(i,j,m)**2 ))
        enddo
     enddo
  enddo

contains

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that allocates memory to a buffer        !
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine allocate_buffer(buffer, pe)
    type(blob_buffer_type), pointer :: buffer
    integer, intent(in) :: pe

    allocate(buffer)
    buffer%pe = pe
    buffer%numblobs = 0
    if (buffer%pe /= NULL_PE) then
       buffer%size = delta_buffer
       
       allocate(buffer%integer_buff(int_buff_size, delta_buffer))
       allocate(buffer%real_buff(   rea_buff_size, delta_buffer))

       if(bitwise_reproduction) then
          allocate(buffer%history_integer_buff(hist_int_buff_size, 0:total_nsp1, delta_buffer))
          allocate(buffer%history_real_buff( 0:hist_rea_buff_size, 0:total_nsp1, delta_buffer))
       else
          allocate(buffer%history_real_buff(0:hist_rea_buff_size, 1, delta_buffer))
       endif
    endif
  end subroutine allocate_buffer

end subroutine blob_dynamic_bottom_init
! </SUBROUTINE>  NAME="blob_dynamic_bottom_init"

!######################################################################
! <SUBROUTINE NAME="blob_dynamic_bottom_update">
!
! <DESCRIPTION>
! This routine calls the routine to update blob positions.  When
! bitwise_reproduction=.false., it also figures out when to continue
! the integration of blobs that have changed PE's.
! </DESCRIPTION>
!
subroutine blob_dynamic_bottom_update(bottom_head, free, Time, Dens, Thickness, &
                                      T_prog, Ext_mode, L_system, tend_blob,    &
                                      blob_source, u, model_rho, mass_in,       &
                                      mass_out, EL_diag, ngrnd, ndetrn)
  type(ocean_blob_type),                               pointer       :: bottom_head
  type(ocean_blob_type),                               pointer       :: free
  type(ocean_time_type),                               intent(in)    :: Time
  type(ocean_density_type),                            intent(in)    :: Dens
  type(ocean_thickness_type),                          intent(inout) :: Thickness
  type(ocean_prog_tracer_type),                        intent(inout) :: T_prog(:)
  type(ocean_external_mode_type),                      intent(inout) :: Ext_mode
  type(ocean_lagrangian_type),                         intent(inout) :: L_system
  real,dimension(num_prog_tracers,isd:ied,jsd:jed,nk), intent(inout) :: tend_blob
  real,dimension(isd:ied,jsd:jed),                     intent(inout) :: blob_source
  real, dimension(isbd:iebd,jsbd:jebd,1:nk,1:2),       intent(in)    :: u
  real, dimension(isbd:iebd,jsbd:jebd,1:nk),           intent(in)    :: model_rho
  real, dimension(isd:ied,jsd:jed,1:nk),               intent(inout) :: mass_in
  real, dimension(isd:ied,jsd:jed,1:nk),               intent(inout) :: mass_out
  type(blob_diag_type), dimension(0:num_prog_tracers), intent(inout) :: EL_diag
  integer,                                             intent(inout) :: ngrnd
  integer,                                             intent(inout) :: ndetrn

  type(ocean_blob_type), pointer :: prev, this, next, buffer_head
  integer :: check_buffers
  integer :: i,j,k,n,iit,jjt,mm,tau
  integer :: stdoutunit
  real :: topog, tbigd, tdsq_r(9)

  if (.not. use_this_module) return

  tau=Time%tau

  nullify(free)
  nullify(this)

  ! Clear buffers for sending and receiving bottom blobs
  call clear_buffer(Ebuffer_out);  call clear_buffer( Ebuffer_in)
  call clear_buffer(Wbuffer_out);  call clear_buffer( Wbuffer_in)
  call clear_buffer(Nbuffer_out);  call clear_buffer( Nbuffer_in)
  call clear_buffer(Sbuffer_out);  call clear_buffer( Sbuffer_in)
  call clear_buffer(NEbuffer_out); call clear_buffer(NEbuffer_in)
  call clear_buffer(NWbuffer_out); call clear_buffer(NWbuffer_in)
  call clear_buffer(SEbuffer_out); call clear_buffer(SEbuffer_in)
  call clear_buffer(SWbuffer_out); call clear_buffer(SWbuffer_in)
        
  if (debug_this_module) then
     stdoutunit = stdout()
     write(stdoutunit, '(a)') ' '
     call write_timestamp(Time%model_time)
     write(stdoutunit,'(a)') 'From ocean_blob_dynamic_free_mod'
     write(stdoutunit,'(a)') 'Totals before free dynamic blob update (tau)'
     call E_and_L_totals(L_system,Thickness,T_prog(:),Time%tau)
     write(stdoutunit,'(a)') ' '
  endif

  ! Reset the blob time to zero for the beginning of the Eulerian time step
  if (associated(bottom_head)) then
     this=>bottom_head
     timecycle: do
        this%blob_time = 0.0
        this=>this%next
        if(.not.associated(this)) exit timecycle
     enddo timecycle
  endif

  call dynamic_update(bottom_head, free, Time, Dens, Thickness, T_prog, &
                      Ext_mode, L_system, tend_blob, blob_source, u,    &
                      model_rho, mass_in, mass_out, EL_diag(:), ngrnd, ndetrn)

  if (bitwise_reproduction) then
     ! Send, receive and unpack buffers for free blobs
     call send_buffer( Ebuffer_out)
     call send_buffer( Wbuffer_out)
     call send_buffer( Sbuffer_out)
     call send_buffer( Nbuffer_out)
     call send_buffer(NEbuffer_out)
     call send_buffer(NWbuffer_out)
     call send_buffer(SEbuffer_out)
     call send_buffer(SWbuffer_out)
     
     call mpp_sync_self()

     call receive_buffer( Wbuffer_in); call unpackbuffer(Time,  Wbuffer_in, bottom_head, Dens, Ext_mode, Thickness)
     call receive_buffer( Ebuffer_in); call unpackbuffer(Time,  Ebuffer_in, bottom_head, Dens, Ext_mode, Thickness)
     call receive_buffer( Nbuffer_in); call unpackbuffer(Time,  Nbuffer_in, bottom_head, Dens, Ext_mode, Thickness)
     call receive_buffer( Sbuffer_in); call unpackbuffer(Time,  Sbuffer_in, bottom_head, Dens, Ext_mode, Thickness)
     call receive_buffer(SWbuffer_in); call unpackbuffer(Time, SWbuffer_in, bottom_head, Dens, Ext_mode, Thickness)
     call receive_buffer(SEbuffer_in); call unpackbuffer(Time, SEbuffer_in, bottom_head, Dens, Ext_mode, Thickness)
     call receive_buffer(NWbuffer_in); call unpackbuffer(Time, NWbuffer_in, bottom_head, Dens, Ext_mode, Thickness)
     call receive_buffer(NEbuffer_in); call unpackbuffer(Time, NEbuffer_in, bottom_head, Dens, Ext_mode, Thickness)

     call mpp_sync_self()

  else
     ! When bitwise reproduction is not necessary, blobs can be packed into 
     ! buffers and sent to other PE's before they have finished a full E system
     ! step, i.e. this%blob_time < dtime.
     ! So, here, we unpack the blobs and continue to evolve them on the new PE.
     ! We need to take into account that a blob may traverse more than one PE
     ! in a given E system step, e.g.
     ! ------------------
     ! |       |        |
     ! | PE=2  +a  PE=3 |
     ! |      /|        |
     ! |     b |        |
     ! ------+-----------
     ! |    /  |        |
     ! |   c   |        |
     ! |       |        |
     ! |  PE=0 |   PE=1 |
     ! ------------------
     ! So, we need to keep on checking buffers and evolving blobs until all received 
     ! buffers are empty

     ! Send, receive and unpack buffers for bottom blobs
     call send_buffer( Ebuffer_out) 
     call send_buffer( Wbuffer_out)
     call send_buffer( Sbuffer_out)
     call send_buffer( Nbuffer_out)
     call send_buffer(NEbuffer_out)
     call send_buffer(NWbuffer_out)
     call send_buffer(SEbuffer_out)
     call send_buffer(SWbuffer_out)
     
     call mpp_sync_self()
     
     buffer_head => NULL()
     call receive_buffer( Wbuffer_in) 
     call unpackbuffer(Time,  Wbuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)
     call receive_buffer( Ebuffer_in)
     call unpackbuffer(Time,  Ebuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)
     call receive_buffer( Nbuffer_in)
     call unpackbuffer(Time,  Nbuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)
     call receive_buffer( Sbuffer_in)
     call unpackbuffer(Time,  Sbuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)
     call receive_buffer(SWbuffer_in)
     call unpackbuffer(Time, SWbuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)
     call receive_buffer(SEbuffer_in)
     call unpackbuffer(Time, SEbuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)
     call receive_buffer(NWbuffer_in)
     call unpackbuffer(Time, NWbuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)
     call receive_buffer(NEbuffer_in) 
     call unpackbuffer(Time, NEbuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)

     call mpp_sync_self()

     ! Clear buffers for sending and receiving free blobs
     call clear_buffer(Ebuffer_out);  call clear_buffer( Ebuffer_in)
     call clear_buffer(Wbuffer_out);  call clear_buffer( Wbuffer_in)
     call clear_buffer(Nbuffer_out);  call clear_buffer( Nbuffer_in)
     call clear_buffer(Sbuffer_out);  call clear_buffer( Sbuffer_in)
     call clear_buffer(NEbuffer_out); call clear_buffer(NEbuffer_in)
     call clear_buffer(NWbuffer_out); call clear_buffer(NWbuffer_in)
     call clear_buffer(SEbuffer_out); call clear_buffer(SEbuffer_in)
     call clear_buffer(SWbuffer_out); call clear_buffer(SWbuffer_in)

     check_buffers = 0
     this=>buffer_head
     if (associated(this)) then
        buff_cycle0: do

           if(this%blob_time == dtime) then
              ! Adjust the geodepth so we are sitting on topography
              topog = 0.0
              i=this%i; j=this%j; k=this%k
              call interp_tcoeff(i,j,(/this%h1,this%h2/),this%lon,this%lat,tdsq_r(:))
              tbigd = 0.0
              do mm=1,Info%tidx(0,i,j)
                 iit=i+Info%it(Info%tidx(mm,i,j))
                 jjt=j+Info%jt(Info%tidx(mm,i,j))
                 topog = topog + ht(iit,jjt)*tdsq_r(mm)
                 tbigd = tbigd + tdsq_r(mm)
              enddo
              tbigd = 1.0/tbigd
              
              this%geodepth =  topog*tbigd
              this%depth    =  this%geodepth + Ext_mode%eta_t(i,j,tau)
              if (vert_coordinate_class==DEPTH_BASED) then
                 this%st = -Thickness%depth_swt(i,j,k)
              else !PRESSURE_BASED
                 this%st = Thickness%depth_swt(i,j,k)
              endif
              
              call unlink_blob(this, buffer_head, prev, next)
              call insert_blob(this, bottom_head)
              this=>next
           else
              check_buffers = check_buffers + 1
              this=>this%next
           endif
           if (.not. associated(this)) exit buff_cycle0
        enddo buff_cycle0
     endif

     call mpp_sum(check_buffers)
     
     do while (check_buffers>0) 
        call dynamic_update(buffer_head, free, Time, Dens, Thickness, &
                            T_prog(:), Ext_mode, L_system, tend_blob, &
                            blob_source, u, model_rho, mass_in,       &
                            mass_out, EL_diag(:), ngrnd, ndetrn)

        ! Send, receive and unpack buffers for bottom blobs
        call send_buffer( Ebuffer_out) 
        call send_buffer( Wbuffer_out)
        call send_buffer( Sbuffer_out)
        call send_buffer( Nbuffer_out)
        call send_buffer(NEbuffer_out)
        call send_buffer(NWbuffer_out)
        call send_buffer(SEbuffer_out)
        call send_buffer(SWbuffer_out)

        call mpp_sync_self()
  
        call receive_buffer( Wbuffer_in) 
        call unpackbuffer(Time,  Wbuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)
        call receive_buffer( Ebuffer_in)
        call unpackbuffer(Time,  Ebuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)
        call receive_buffer( Nbuffer_in)
        call unpackbuffer(Time,  Nbuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)
        call receive_buffer( Sbuffer_in)
        call unpackbuffer(Time,  Sbuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)
        call receive_buffer(SWbuffer_in)
        call unpackbuffer(Time, SWbuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)
        call receive_buffer(SEbuffer_in)
        call unpackbuffer(Time, SEbuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)
        call receive_buffer(NWbuffer_in)
        call unpackbuffer(Time, NWbuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)
        call receive_buffer(NEbuffer_in) 
        call unpackbuffer(Time, NEbuffer_in, buffer_head, Dens, Ext_mode, Thickness, L_system, EL_diag, blob_source, tend_blob, mass_in)

        call mpp_sync_self()

        ! Clear buffers for sending and receiving free blobs
        call clear_buffer(Ebuffer_out);  call clear_buffer( Ebuffer_in)
        call clear_buffer(Wbuffer_out);  call clear_buffer( Wbuffer_in)
        call clear_buffer(Nbuffer_out);  call clear_buffer( Nbuffer_in)
        call clear_buffer(Sbuffer_out);  call clear_buffer( Sbuffer_in)
        call clear_buffer(NEbuffer_out); call clear_buffer(NEbuffer_in)
        call clear_buffer(NWbuffer_out); call clear_buffer(NWbuffer_in)
        call clear_buffer(SEbuffer_out); call clear_buffer(SEbuffer_in)
        call clear_buffer(SWbuffer_out); call clear_buffer(SWbuffer_in)

        check_buffers = 0
        
        if (associated(buffer_head)) then
           this => buffer_head
           timecheck: do
              if(this%blob_time == dtime) then
                 ! Adjust the geodepth so we are sitting on topography
                 topog = 0.0
                 i=this%i; j=this%j; k=this%k
                 call interp_tcoeff(i,j,(/this%h1,this%h2/),this%lon,this%lat,tdsq_r(:))
                 tbigd = 0.0
                 do mm=1,Info%tidx(0,i,j)
                    iit=i+Info%it(Info%tidx(mm,i,j))
                    jjt=j+Info%jt(Info%tidx(mm,i,j))
                    topog = topog + ht(iit,jjt)*tdsq_r(mm)
                    tbigd = tbigd + tdsq_r(mm)
                 enddo
                 tbigd = 1.0/tbigd
                 
                 this%geodepth =  topog*tbigd
                 this%depth    =  this%geodepth + Ext_mode%eta_t(i,j,tau)
                 if (vert_coordinate_class==DEPTH_BASED) then
                    this%st = -Thickness%depth_swt(i,j,k)
                 else !PRESSURE_BASED
                    this%st = Thickness%depth_swt(i,j,k)
                 endif
 
                 call unlink_blob(this, buffer_head, prev, next)
                 call insert_blob(this, bottom_head)
                 this=>next
              else
                 check_buffers = check_buffers + 1
                 this=>this%next
              endif
              if(.not. associated(this)) exit timecheck
           enddo timecheck
        endif
        call mpp_sum(check_buffers)

     enddo
  endif!bitwise_reproduction


  ! Check if a separating blob has also changed processors.  If it has, pack it into
  ! a buffer, send the buffer, receive other buffers and unpack them.

  ! Clear buffers for sending and receiving free blobs
  call clear_buffer(Ebuffer_out);  call clear_buffer( Ebuffer_in)
  call clear_buffer(Wbuffer_out);  call clear_buffer( Wbuffer_in)
  call clear_buffer(Nbuffer_out);  call clear_buffer( Nbuffer_in)
  call clear_buffer(Sbuffer_out);  call clear_buffer( Sbuffer_in)
  call clear_buffer(NEbuffer_out); call clear_buffer(NEbuffer_in)
  call clear_buffer(NWbuffer_out); call clear_buffer(NWbuffer_in)
  call clear_buffer(SEbuffer_out); call clear_buffer(SEbuffer_in)
  call clear_buffer(SWbuffer_out); call clear_buffer(SWbuffer_in)
        
  if (associated(free)) then
     this=>free
     freecycle: do
        i=this%i
        j=this%j
        k=this%k
        if     (i>iec .and. j>jec) then
           call packfreebuffer(NEbuffer_out)
        elseif (i<isc .and. j>jec) then
           call packfreebuffer(NWbuffer_out)
        elseif (i>iec .and. j<jsc) then
           call packfreebuffer(SEbuffer_out)
        elseif (i<isc .and. j<jsc) then
           call packfreebuffer(SWbuffer_out)
        elseif (i>iec)             then
           call packfreebuffer(Ebuffer_out)
        elseif (i<isc)             then
           call packfreebuffer(Wbuffer_out)
        elseif (j>jec)             then
           call packfreebuffer(Nbuffer_out)
        elseif (j<jsc)             then
           call packfreebuffer(Sbuffer_out)
        endif
        this=>this%next
        if(.not.associated(this)) exit freecycle
     enddo freecycle
  endif

  ! Send buffers for bottom blobs that have become free blobs
  call send_buffer( Ebuffer_out)
  call send_buffer( Wbuffer_out)
  call send_buffer( Sbuffer_out)
  call send_buffer( Nbuffer_out)
  call send_buffer(NEbuffer_out)
  call send_buffer(NWbuffer_out)
  call send_buffer(SEbuffer_out)
  call send_buffer(SWbuffer_out)

  call mpp_sync_self()
  
  ! Receive and unpack bottom blobs that have become free blobs
  call receive_buffer( Ebuffer_in); call unpackbuffer(Time,  Ebuffer_in, free, Dens, Ext_mode, Thickness)
  call receive_buffer( Wbuffer_in); call unpackbuffer(Time,  Wbuffer_in, free, Dens, Ext_mode, Thickness)
  call receive_buffer( Nbuffer_in); call unpackbuffer(Time,  Nbuffer_in, free, Dens, Ext_mode, Thickness)
  call receive_buffer( Sbuffer_in); call unpackbuffer(Time,  Sbuffer_in, free, Dens, Ext_mode, Thickness)
  call receive_buffer(NEbuffer_in); call unpackbuffer(Time, NEbuffer_in, free, Dens, Ext_mode, Thickness)
  call receive_buffer(NWbuffer_in); call unpackbuffer(Time, NWbuffer_in, free, Dens, Ext_mode, Thickness)
  call receive_buffer(SEbuffer_in); call unpackbuffer(Time, SEbuffer_in, free, Dens, Ext_mode, Thickness)
  call receive_buffer(SWbuffer_in); call unpackbuffer(Time, SWbuffer_in, free, Dens, Ext_mode, Thickness)

  call mpp_sync_self()

contains
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that packs the buffer of bottom blobs    !
! that are transferring to free blobs and have crossed a processor     !
! boundary                                                             !
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine packfreebuffer(buffer)
    type(blob_buffer_type), pointer :: buffer
    real, dimension(0:num_prog_tracers) :: entrainment, detrainment
    integer :: s

    if (buffer%pe == Info%pe_this) then
       ! We have a cyclic grid and the blob is just going to
       ! end up back on the same processor.  So, we just adjust
       ! the (i,j) values for the blob.
       call check_cyclic(this, this%i, this%j, .true.)

       if (bitwise_reproduction) then
          do s=0,this%nfrac_steps
             call check_cyclic(this, this%di(s), this%dj(s), .false.)
          enddo
       endif

    else !going to a different PE
       if (bitwise_reproduction) then
          call packbuffer(this,buffer)
       else
          entrainment(:) = 0.0 
          detrainment(:) = 0.0 
          call packbuffer(this,buffer, entrainment(:), detrainment(:))
       endif
       this%mass=0.
       do n=1,num_prog_tracers
          this%tracer(n) = 0.
       enddo

    endif
  end subroutine packfreebuffer
  

end subroutine blob_dynamic_bottom_update
! </SUBROUTINE>  NAME="blob_dynamic_bottom_update"

!######################################################################
! <SUBROUTINE NAME="dynamic_update">
!
! <DESCRIPTION>
! This routine contains the RK scheme used to integrate the position 
! and velocity of blobs.  It also does many checks for (and 
! subsequently handles) things like grounding of blobs, blobs going to
! different PEs, blobs that separate from topography, blobs that 
! detrain to less than small_mass and blobs going outside the compute 
! domain.  
!
! It also does the interpolation of E system variables to a blob.
! </DESCRIPTION>
!
subroutine dynamic_update(head, free, Time, Dens, Thickness,    &
                          T_prog, Ext_mode, L_system,           &
                          tend_blob, blob_source, u, model_rho, &
                          mass_in, mass_out, EL_diag, ngrnd, ndetrn)
  type(ocean_blob_type),                               pointer       :: head
  type(ocean_blob_type),                               pointer       :: free
  type(ocean_time_type),                               intent(in)    :: Time
  type(ocean_density_type),                            intent(in)    :: Dens
  type(ocean_thickness_type),                          intent(inout) :: Thickness
  type(ocean_prog_tracer_type),                        intent(inout) :: T_prog(:)
  type(ocean_external_mode_type),                      intent(inout) :: Ext_mode   
  type(ocean_lagrangian_type),                         intent(inout) :: L_system
  real,dimension(num_prog_tracers,isd:ied,jsd:jed,nk), intent(inout) :: tend_blob
  real,dimension(isd:ied,jsd:jed),                     intent(inout) :: blob_source
  real, dimension(isbd:iebd,jsbd:jebd,1:nk,1:2),       intent(in)    :: u
  real, dimension(isbd:iebd,jsbd:jebd,1:nk),           intent(in)    :: model_rho
  real, dimension(isd:ied,jsd:jed,1:nk),               intent(inout) :: mass_in
  real, dimension(isd:ied,jsd:jed,1:nk),               intent(inout) :: mass_out
  type(blob_diag_type), dimension(0:num_prog_tracers), intent(inout) :: EL_diag
  integer,                                             intent(inout) :: ngrnd
  integer,                                             intent(inout) :: ndetrn

  type(ocean_blob_type), pointer :: this => NULL()
  type(ocean_blob_type), pointer :: prev => NULL()
  type(ocean_blob_type), pointer :: next => NULL()
  real,    dimension(1:6,0:ns) :: V
  integer, dimension(3) :: old_ijk
  logical, dimension(2) :: off
  real,    dimension(6) :: Xn, update, Xnp1, Xnp1_hat
  real,    dimension(3) :: old_lld, vel
  real,    dimension(2) :: h, old_h
  real,    dimension(num_prog_tracers) :: tracer, field
  real,    dimension(0:num_prog_tracers) :: entrainment, detrainment
  real, dimension(9) :: tdsq_r
  real, dimension(4) :: udsq_r
  logical :: go_e, go_ne, go_n, go_nw, go_w, go_sw, go_s, go_se
  integer :: total_blobs, leaving_pe, tfer_free, detrn_zero, move_lateral, ngrounded
  integer :: i, j, k, m, mm, n, r, s, ii
  integer :: iiu,jju,iit,jjt,ku
  integer :: n_frac_steps, tau
  integer :: stdoutunit
  logical :: change_pe, reached_end, advance_blob, accept_step, grounded
  real :: blob_time, tstep, lon, lat, geodepth, rhoL, rhoLr
  real :: rho, rhor, rhoE, volume
  real :: old_tstep, trunc, hstar, tstar, mass
  real :: Hx, Hy, bstress_hr, absv2, absv, uE, vE, absrelv2, absrelv
  real :: height, heightr, f, richardson, dmdt_ent, dmdt_det, ent, det, tstress
  real :: ent_hr, red_grav, rgd
  real :: ubigd, tbigd, denom, topog

  nullify(this)

  tau = Time%tau

  ! zero some diagnostics
  total_blobs  = 0
  leaving_pe   = 0
  tfer_free    = 0
  detrn_zero   = 0
  move_lateral = 0
  ngrounded    = 0

  if (associated(head)) then
     this=>head

     blobcycle: do
        ! time relative to the beginning of the time step
        blob_time = this%blob_time
        tstep     = this%step

        this%dmass      = 0.0
        this%dtracer(:) = 0.0
        if (bitwise_reproduction) then
           ! initialise the values of the history arrays
           this%di(:) = -1
           this%dj(:) = -1
           this%dk(:) = -1
           this%nfrac_steps      = 0
           this%entrainment(:,:) = 0.0 
           this%detrainment(:,:) = 0.0 
           this%mass_in(:)       = 0.0
           this%mass_out(:)      = 0.0
           
           this%di(0) = this%i
           this%dj(0) = this%j
           this%dk(0) = this%k
        endif

        ! Make adjustments to the lon-lat and i-j (if necessary)
        ! on a cyclic or tripolar grid.
        call check_cyclic(this, this%i, this%j, .true.)

        ! We don't want to alter the blob properties until 
        ! we have completed the full fractional step.  So, we save
        ! the variables into local variables in case the step is
        ! rejected and we need to try again with a different value
        ! for tstep.
        
        ! These variables get updated from one RK sub-step to
        ! the next, so, we need to save copies of them in case
        ! the step is rejected.
        i        = this%i - Dom%ioff
        j        = this%j - Dom%joff
        k        = this%k
        old_ijk  = (/ i, j, k/)
        lon      = this%lon
        lat      = this%lat
        geodepth = this%geodepth
        old_lld  = (/lon, lat, geodepth/)
        h(:)     = (/ this%h1, this%h2 /)
        old_h    = h
        
        ! These variables are only updated at the end
        ! of all the RK sub-steps, so, we do not need
        ! to save copies
        ent    = this%ent
        det    = this%det
        richardson = this%richardson
        vel(:) = this%v(:)
        mass   = this%mass
        volume = this%volume
        rhoL   = this%density
        rhoLr  = this%densityr
        if (vert_coordinate_class==DEPTH_BASED) then
           rho  = rho0
           rhor = rho0r
        else !PRESSURE_BASED
           rho  = rhoL
           rhor = rhoLr
        endif
        do n=1,num_prog_tracers
           tracer(n) = this%tracer(n)
           field(n)  = this%field(n)
        enddo
        height  = this%height
        heightr = 1.0/this%height
        n_frac_steps = 0
        
        reached_end  = .false.
        change_pe    = .false.
        advance_blob = .true.
        off(:)       = .false.
        grounded     = .false.
        
        ! Calculate the horizontal interpolation coefficients
        call interp_tcoeff(i,j,h(:),lon,lat,tdsq_r(:))
        call interp_ucoeff(i,j,h(:),lon,lat,udsq_r(:))        

        partialstep: do while (.not. reached_end)
           accept_step = .false.
           
           ! Interpolate the E system variables to the blobs
           ! Note, we treat the stretching function separately

           ! U-grid variables
           ! We want to treat the 
           ubigd = 0.0
           uE=0.0; vE=0.0
           Hx=0.0; Hy=0.0
           do mm=1,Info%uidx(0,i,j)
              iiu=i+Info%iu(Info%uidx(mm,i,j))
              jju=j+Info%ju(Info%uidx(mm,i,j))
              ku =kmu(iiu,jju)
              Hx = Hx + dht_dx(iiu,jju)*udsq_r(mm)
              Hy = Hy + dht_dy(iiu,jju)*udsq_r(mm)
              ! Because we interpolate from surrounding bottom cells, we make
              ! use of kmu.  kmu can have values of k=0 (which means, a land
              ! point).  When interpolating velocities from the U grid, we wish
              ! for them to have a zero value over land points.
              if (ku>0) then
                 uE = uE + umask(iiu,jju,ku)*u(iiu,jju,ku,1)*udsq_r(mm)
                 vE = vE + umask(iiu,jju,ku)*u(iiu,jju,ku,2)*udsq_r(mm)
              endif
              ubigd = ubigd + udsq_r(mm)
           enddo
           ubigd = 1.0/ubigd

           Hx = Hx*ubigd
           Hy = Hy*ubigd
           uE = uE*ubigd
           vE = vE*ubigd

           ! Put rhoE to the model density (rather than interpolate) so 
           ! free blobs are not prematurely created.
           rhoE = model_rho(i,j,k)

           ! speed of the blob
           absv2  = vel(1)**2 + vel(2)**2 + vel(3)**2
           absv   = sqrt(absv2)

           ! relative speed of the blob (to the E system)
           absrelv2 = (vel(1)-uE)**2 + (vel(2)-vE)**2 + vel(3)**2
           absrelv  = sqrt(absrelv2)

           m=0
           trystep: do while (.not. accept_step)
              prev => NULL()
              next => NULL()

              ! Load the old variables into some local variables that we will change.
              ! We want to keep the old variables in case the step is rejected.
              i = old_ijk(1)
              j = old_ijk(2)
              k = old_ijk(3)
              h(:) = old_h(:)
              lon  = old_lld(1)
              lat  = old_lld(2)
              
              ! Horizontal distances are calculated relative to the inital 
              ! position for this partial step.  Vertical distance is calculated
              ! relative to the initial geodepth of the step
              Xn(1) =  0.         ! x-position
              Xn(2) =  vel(1)     ! u-velocity
              Xn(3) =  0.         ! y-position
              Xn(4) =  vel(2)     ! v-velocity
              Xn(5) = -old_lld(3) ! z-position (relative to z=0)
              Xn(6) =  vel(3)     ! w-velocity

              ! Temporary variables for the RK scheme
              Xnp1(:)     = Xn(:)
              Xnp1_hat(:) = Xn(:)
              update(:)   = Xn(:)

              ! Temporary variables for the entrainment/detrainment history
              entrainment(:) = 0.
              detrainment(:) = 0.

              ! Friction from entrainment
              ent_hr = ent*heightr
              
              ! The bottom stress.  We omit a rho, because it cancels below
              bstress_hr = drag*absv*heightr
              tstress    = bstress_hr + ent_hr
              
              ! rotation
              f  = two_omega*sin(deg_to_rad*lat)
              
              ! The pseudo-non-hydrostatic (reduced gravity) and normal force terms
              denom    = 1.0/sqrt(Hx**2 + Hy**2 + 1)
              red_grav = grav*(rhoL - rhoE)*rhor
              rgd      = red_grav * denom

              ! Cycle through the RK sub-steps
              call mpp_clock_begin(id_clock_rk)
              do s=0,ns
                 ! Solve the equations of motion
                 V(1,s) =   update(2)                                           !xdot
                 V(2,s) = - tstress*update(2) + update(4)*f + rgd*Hx + uE*ent_hr!xddot
                 
                 V(3,s) =   update(4)                                           !ydot
                 V(4,s) = - update(2)*f - tstress*update(4) + rgd*Hy + vE*ent_hr!yddot
                 
                 V(5,s) =   update(6)                                           !zdot
                 V(6,s) = - tstress*update(6)               + rgd    - red_grav !zddot

                 ! calculate new update
                 if(s<ns) then
                    update(:) = Xn(:)
                    do r=0,s
                       update(:) = update(:) + tstep*beta(s+1,r)*V(:,r)
                    enddo
                 endif

                 ! The high and low order estimates
                 Xnp1(:)     = Xnp1(:)     + tstep*hgamma(s)*V(:,s)
                 Xnp1_hat(:) = Xnp1_hat(:) + tstep*lgamma(s)*V(:,s)

              enddo!s
              call mpp_clock_end(id_clock_rk)

              ! Estimate the error using the difference in the high and low order schemes.
              ii    = maxloc(abs((Xnp1(:) - Xnp1_hat(:))/(Xnp1(:)+epsln)),1)
              trunc = abs(Xnp1(ii) - Xnp1_hat(ii) + epsln)
              tstar = rel_error*abs(Xnp1(ii))
              hstar = tstep * (safety_factor*tstar/trunc)**(orderp1_r)

              ! Save the old time step (if this step fails, we will need it again)
              old_tstep = tstep

              ! Reject the step if the accuracy condition is not met. Redo the 
              ! trystep loop with an adjusted step.
              ! There are some caveats, listed below.
              if(trunc > tstar) then 
                 accept_step = .false.
                 if (hstar > minstep) then 
                    !If the suggested step is not smaller than the minimum step, 
                    !retry with the smaller step.
                    tstep = min(hstar, dtime - blob_time)
                 else
                    if (tstep<=minstep) then 
                       !If the step is smaller than the minimum step and 
                       !it is still rejected, we accept the step anyway.
                       accept_step = .true.
                    else
                       ! Otherwise, set the step to the minimum step size.
                       accept_step = .false.
                       tstep = min(minstep, dtime - blob_time)
                    endif
                 endif
                 
              else !Accept the step
                 accept_step = .true.
                 ! We want to impose some restrictions on the local extrapolation to ensure
                 ! we maintain stability and minimise the number of rejected steps:
                 ! 1/ only let the next step increase in size if the previous step was 
                 ! never rejected,
                 ! 2/ we don't let the next step be any larger than twice this step.
                 if (m==0 .and. hstar>=tstep) then
                    tstep = min(2*tstep, hstar)
                 elseif (hstar<tstep) then
                    tstep = max(minstep, hstar)
                 endif
                 ! 3/ We do not want tstep to be greater than dtime (the E system time step)
                 tstep = min(tstep, dtime)

                 ! There may be more adjustments to tstep later on, depending on
                 ! how close we are to reaching the Eulerian time step.
              endif

              if (accept_step) then
                 ! Do some rudimentary stability checking
                 if (abs(Xnp1(2))>large_speed .or. abs(Xnp1(4))>large_speed .or. abs(Xnp1(6))>large_speed) then
                    if (tstep<=minstep) then
                       call mpp_error(WARNING,&
                            '==>Warning in ocean_blob_dynamic_bottom_mod (dynamic_update): It looks like a blob is becoming unstable'//&
                            ' and the timestep is already as small as is permitted.  Suggest reducing minstep in the namelist.')
                    endif
                 endif

                 ! Update the grid stretching values
                 tbigd = 0.0
                 h(:)  = 0.0
                 do mm=1,Info%tidx(0,i,j)
                    iit=i+Info%it(Info%tidx(mm,i,j))
                    jjt=j+Info%jt(Info%tidx(mm,i,j))
                    ! Stretching function is defined over land points, so, we do 
                    ! not mask out land points.
                    h(:) = h(:) + Info%ht(iit,jjt,:)*tdsq_r(mm)
                    tbigd = tbigd + tdsq_r(mm)
                 enddo

                 tbigd = 1.0/tbigd
                 h(:) = h(:)*tbigd

                 n_frac_steps = n_frac_steps+1

                 ! Entrainment and detrainment calculations are based on the properties of the blob
                 ! at the beginning of this blob step.
                 richardson = grav*height*abs(rhoL-rhoE)/(rho*absrelv2 + epsln)
                 if (richardson <= critical_richardson) then
                    ent = absrelv*(0.08 - 0.1*richardson)/(1.+5.*richardson)
                 else
                    ent = 0.
                 endif
                 
                 det = -det_factor/abs(rhoL - rhoE + epsln)
                 
                 if (vert_coordinate_class==DEPTH_BASED) then
                    !det_factor = Gamma * (rho0*36pi)**1/3
                    dmdt_det = det * (mass**twothirds)
                    !ent_factor = (rho0*36*pi)**onethird
                    dmdt_ent = ent * ent_factor * (mass**onethird)
                    
                 else !PRESSURE_BASED
                    !det_factor = Gamma * (36pi)**1/3
                    dmdt_det = det * (mass**twothirds) * (rhoL**onethird)
                    !ent_factor = (36*pi)**onethird
                    dmdt_ent = ent * rhoE * ent_factor*(volume**onethird)
                    
                 endif

                 ! Make sure we do not exceed the maximum detrainment
                 dmdt_det = sign(min(abs(dmdt_det),abs(max_detrainment)),dmdt_det)

                 detrainment(0) = dmdt_det*old_tstep
                 entrainment(0) = dmdt_ent*old_tstep
                 do n=1,num_prog_tracers
                    ! Detrainment
                    detrainment(n) = detrainment(0)*field(n)
                    ! Entrainment
                    entrainment(n) = entrainment(0)*T_prog(n)%field(i,j,k,tau)
                 enddo
                 
                 ! Check and see if the blob will detrain to zero mass during this partial time step.
                 ! If it does, just dump all its properties in the original cell.  We also check to 
                 ! see if a blob would fully detrain (without entrainment).  It has been obvserved
                 ! that instabilities can ensue with a realistic EOS if a blob "head bangs" 
                 ! around a zero tracer content.
                 if ((entrainment(0) + detrainment(0) + mass) < small_mass .or. mass < abs(detrainment(0))) then
                    entrainment(0) = 0.0
                    detrainment(0) = -mass
                    do n=1,num_prog_tracers
                       entrainment(n) = 0.0
                       detrainment(n) = -tracer(n)
                    enddo
                    detrn_zero = detrn_zero + 1

                    ! If a blob detrains to less than small mass, we no longer
                    ! need to calculate its trajectory.  So that it stops being 
                    ! processed, we set the time to the end of full step.
                    old_tstep = 0.0
                    blob_time = dtime

                 else
                    ! Check if we have changed horizontal cells
                    call check_ijcell(Xnp1(1),Xnp1(3),i,j,h,old_lld(1:2),lon,lat,off(1:2))

                 endif

                 if (Grd%kmt(i,j) == 0) then
                    ! If the blob has grounded, we put it back in its previous cell
                    ! It will have all its properties returned to the E system later
                    ! Here, grounded means a blob has moved laterally into a zero 
                    ! depth (i.e. land) column, NOT that it has interacted with topography.
                    off(1:2) = .false.
                    grounded = .true.
                    ngrounded = ngrounded + 1
                    i = old_ijk(1)
                    j = old_ijk(2)
                    lon = old_lld(1)
                    lat = old_lld(2)
                 else
                    k = Grd%kmt(i,j)
                 endif

                 if (any(off(1:2))) change_pe = .true.

                 if (change_pe .and. .not. bitwise_reproduction) then
                    ! Check to see if the blob has left this pe
                    ! If we are not enforcing bitwise reproduction, we pack 
                    ! the blob into a buffer immediately, as we do not need
                    ! to worry about saving the histories and processing the
                    ! blob histories in order.
                    Ext_mode%conv_blob(old_ijk(1),old_ijk(2)) = &
                         Ext_mode%conv_blob(old_ijk(1),old_ijk(2)) - mass
                    
                    L_system%conv_blob(old_ijk(1),old_ijk(2),old_ijk(3)) = &
                         L_system%conv_blob(old_ijk(1),old_ijk(2),old_ijk(3)) - mass

                    mass_out(old_ijk(1),old_ijk(2),old_ijk(3)) = &
                         mass_out(old_ijk(1),old_ijk(2),old_ijk(3)) + mass

                    ! Save some variables
                    do n=1,num_prog_tracers
                       this%tracer(n) = tracer(n)
                    enddo
                    this%v(1)      = Xnp1(2)
                    this%v(2)      = Xnp1(4)
                    this%v(3)      = Xnp1(6)
                    this%lon       = lon
                    this%lat       = lat
                    this%geodepth  = -Xnp1(5)
                    this%blob_time = blob_time + old_tstep
                    if (this%blob_time == dtime) then
                       this%ent    = ent
                       this%det    = det
                       this%richardson = richardson
                       this%age    = this%age + dtime_yr
                       this%gprime = grav*(rhoE-rhoL)/rhoE
                       this%step = max(tstep,minstep)
                    elseif ((this%blob_time + 1.1*tstep) > dtime) then
                       this%step = dtime - this%blob_time
                    else
                       this%step      = max(tstep,minstep)
                    endif
                    this%mass = mass

                    this%i = i
                    this%j = j
                    this%k = k

                    if     (i>iec .and. j>jec) then
                       call packbuffer(this, NEbuffer_out, entrainment(:), detrainment(:))
                    elseif (i<isc .and. j>jec) then
                       call packbuffer(this, NWbuffer_out, entrainment(:), detrainment(:))
                    elseif (i>iec .and. j<jsc) then
                       call packbuffer(this, SEbuffer_out, entrainment(:), detrainment(:))
                    elseif (i<isc .and. j<jsc) then
                       call packbuffer(this, SWbuffer_out, entrainment(:), detrainment(:))
                    elseif (i>iec)             then
                       call packbuffer(this,  Ebuffer_out, entrainment(:), detrainment(:))
                    elseif (i<isc)             then
                       call packbuffer(this,  Wbuffer_out, entrainment(:), detrainment(:))
                    elseif (j>jec)             then
                       call packbuffer(this,  Nbuffer_out, entrainment(:), detrainment(:))
                    elseif (j<jsc)             then
                       call packbuffer(this,  Sbuffer_out, entrainment(:), detrainment(:))
                    endif

                    move_lateral = move_lateral + 1
                    leaving_pe   = leaving_pe   + 1

                    call unlink_blob(this, head, prev, next)
                    call free_blob_memory(this)
                    advance_blob=.false.

                    exit partialstep
                 endif!change_pe .and. .not. bitwise_reproduction

                 if (grounded) then
                    
                    this%nfrac_steps = n_frac_steps

                    old_tstep = 0.0
                    blob_time = dtime

                    if (bitwise_reproduction) then
                       this%di(n_frac_steps) = i
                       this%dj(n_frac_steps) = j
                       this%dk(n_frac_steps) = k
                       this%dmass = -mass
                       this%mass  = 0.0
                       mass       = 0.0
                       do n=1,num_prog_tracers
                          this%dtracer(n) = -tracer(n)
                          this%tracer(n)  = 0.0
                          tracer(n)       = 0.0
                       enddo

                       exit trystep
                    else
                       blob_source(this%i,this%j) = blob_source(this%i,this%j) + mass
                       this%mass        = 0.0
                       mass             = 0.0
                       do n=1,num_prog_tracers
                          tend_blob(n,this%i,this%j,this%k) = tend_blob(n,this%i,this%j,this%k) + tracer(n)
                          this%tracer(n)     = 0.0
                          tracer(n)          = 0.0
                       enddo

                       ! Diagnostics 
                       EL_diag(0)%dstry(i,j,k) = EL_diag(0)%dstry(i,j,k) + mass 
                       do n=1,num_prog_tracers 
                          EL_diag(n)%dstry(i,j,k) = EL_diag(n)%dstry(i,j,k) + tracer(n) 
                       enddo
                       exit trystep
                    endif
                 endif!grounded

                 if (bitwise_reproduction) then

                    ! Update the intermediate values of variables
                    ! If we detect that a blob changes cells, save the mass in and out
                    ! Note, the convention is that both are positive and we take care of
                    ! the sign when calculating the convergence.
                    if (old_ijk(1)/=i .or. old_ijk(2)/=j .or. old_ijk(3)/=k) then
                       this%mass_out(n_frac_steps-1) = mass
                       this%mass_in( n_frac_steps  ) = mass
                    endif
                    
                    ! Save the indices to history too (for divergence and ent/detrainment)
                    this%di(n_frac_steps) = i + Dom%ioff
                    this%dj(n_frac_steps) = j + Dom%joff
                    this%dk(n_frac_steps) = k
                 
                    ! save mass
                    mass                     = mass + entrainment(0) + detrainment(0)
                    this%entrainment(n_frac_steps,0) = entrainment(0)
                    this%detrainment(n_frac_steps,0) = detrainment(0)
                    
                    ! save tracer
                    do n=1,num_prog_tracers
                       tracer(n)                        = tracer(n) + entrainment(n) + detrainment(n)
                       this%entrainment(n_frac_steps,n) = entrainment(n)
                       this%detrainment(n_frac_steps,n) = detrainment(n)
                    enddo

                 else !not bitwise reproduction

                    ! If we detect that a blob changes cells, save the mass into the new
                    ! water column and and out of the old water column.
                    ! save mass
                    if (old_ijk(1)/=i .or. old_ijk(2)/=j .or. old_ijk(3)/=k) then
                       Ext_mode%conv_blob(old_ijk(1),old_ijk(2)) = &
                            Ext_mode%conv_blob(old_ijk(1),old_ijk(2)) - mass
                       Ext_mode%conv_blob(i,j) = &
                            Ext_mode%conv_blob(i,j) + mass

                       L_system%conv_blob(old_ijk(1),old_ijk(2),old_ijk(3)) = &
                            L_system%conv_blob(old_ijk(1),old_ijk(2),old_ijk(3)) - mass
                       L_system%conv_blob(i,j,k) = &
                            L_system%conv_blob(i,j,k) + mass

                       mass_out(old_ijk(1),old_ijk(2),old_ijk(3)) = mass_out(old_ijk(1),old_ijk(2),old_ijk(3)) + mass
                       mass_in(          i,         j,         k) = mass_in(          i,         j,         k) + mass
                    endif

                    mass             = mass + entrainment(0) + detrainment(0)
                    blob_source(i,j) = blob_source(i,j) - entrainment(0) - detrainment(0)
                    
                    ! save tracer
                    do n=1,num_prog_tracers
                       tracer(n)          = tracer(n) + entrainment(n) + detrainment(n)
                       tend_blob(n,i,j,k) = tend_blob(n,i,j,k) - entrainment(n) - detrainment(n)
                    enddo

                    do n=0,num_prog_tracers 
                       EL_diag(n)%detrainment(i,j,k) = EL_diag(n)%detrainment(i,j,k) - detrainment(n) 
                       EL_diag(n)%entrainment(i,j,k) = EL_diag(n)%entrainment(i,j,k) + entrainment(n) 
                    enddo 

                 endif !bitwise_reproduction

                 ! save other variables
                 geodepth = -Xnp1(5)
                 old_lld  =  (/lon, lat, geodepth/)
                 old_ijk  =  (/i,   j,   k       /)
                 old_h    =  h
                 vel(1)   = Xnp1(2)
                 vel(2)   = Xnp1(4)
                 vel(3)   = Xnp1(6)

                 !Avoid crazy numbers if the blob has detrained to be less than small mass
                 if(mass>small_mass) then
                    do n=1,num_prog_tracers
                       field(n) = tracer(n)/mass
                    enddo
                    rhoL  = density(field(index_salt), field(index_temp), Dens%pressure_at_depth(i,j,k))
                    rhoLr = 1.0/rhoL
                    if (vert_coordinate_class==PRESSURE_BASED) then
                       rho  = rhoL
                       rhor = rhoLr
                       !else DEPTH_BASED: rho=rho0, rhor=rho0r
                    endif

                    volume = mass*rhor
                    ! Update rhoE before the free blob check
                    ! to account for blobs that moved to shallower water
                    rhoE = model_rho(i,j,k)

                    ! Check whether a blob that is not small has separated
                    if (rhoL < rhoE) then
                       ! If so, save values to the blob, unlink it and send it to an
                       ! intermediate linked list, before turning it into a free blob.
                       
                       ! Update a counter
                       if (this%i /= i .or. this%j /= j) move_lateral = move_lateral + 1
                       
                       this%blob_time = dtime
                       this%step      = max(tstep, minstep)

                       this%i         = i+Dom%ioff
                       this%j         = j+Dom%joff
                       this%k         = k
                       this%geodepth  = geodepth
                       this%lon       = lon
                       this%lat       = lat
                       this%ent       = ent
                       this%det       = det
                       this%richardson=richardson
                       this%v(:)      = vel(:)
                       this%h1        = h(1)
                       this%h2        = h(2)
                       this%model_steps = this%model_steps + 1
                       
                       this%mass      = mass
                       this%volume    = volume
                       this%density   = rhoL
                       this%densityr  = rhoLr
                       this%gprime    = grav*(rhoE-rhoL)/rhoE !diagnostic
                       this%age       = this%age + dtime_yr
                       do n=1,num_prog_tracers
                          if(T_prog(n)%name(1:3) =='age') then
                             ! If it is an age tracer advance the age of the tracer
                             this%field(n)  = field(n) + dtime_yr
                             this%tracer(n) = this%field(n)*mass
                          else
                             this%tracer(n) = tracer(n)
                             this%field(n)  = field(n)
                          endif
                       enddo
                       this%model_steps = this%model_steps + 1
                       call unlink_blob(this, head, prev, next)
                       call insert_blob(this, free)
                       advance_blob = .false.
                       this%nfrac_steps = n_frac_steps
                       this=>next
                       tfer_free = tfer_free + 1
                       

                       exit partialstep
                    endif !rhoL<rhoE
                    
                 endif !mass>small_mass

                 this%nfrac_steps = n_frac_steps
              endif !accept_step
              m=m+1
           enddo trystep

           ! The step has been accepted.  We now decide whether we need
           ! to conduct any more steps, and if we do, whether we need to 
           ! adjust them so that the final step coincides with the Eulerian
           ! model time step.
           blob_time = blob_time + old_tstep
           this%blob_time = blob_time
           
           if (blob_time == dtime) then
              ! no more steps required.  Save all the new variables to the blob
              reached_end = .true.

              ! update a counter
              if (this%i /= i .or. this%j /= j) move_lateral = move_lateral + 1

              ! Update the blob variables
              this%step = max(tstep,minstep)
              this%i    = i
              this%j    = j
              this%k    = k
              this%lon  = lon
              this%lat  = lat
              this%v(:) = vel(:)
              this%h1   = h(1)
              this%h2   = h(2)

              this%mass     = mass
              this%volume   = volume
              this%density  = rhoL
              this%densityr = rhoLr
              this%ent      = ent
              this%det      = det
              this%richardson=richardson
              this%gprime   = grav*(rhoE-rhoL)/rhoE !diagnostic
              this%age      = this%age + dtime_yr
              do n=1,num_prog_tracers
                 if(T_prog(n)%name(1:3) =='age') then
                    ! If it is an age tracer advance the age of the tracer
                    this%field(n)  = field(n) + dtime_yr
                    this%tracer(n) = this%field(n)*mass
                 else
                    this%tracer(n) = tracer(n)
                    this%field(n)  = field(n)
                 endif
              enddo
              this%model_steps = this%model_steps + 1

              ! Adjust the geodepth so we are sitting on topography
              topog = 0.0
              call interp_tcoeff(i,j,h(:),lon,lat,tdsq_r(:))
              tbigd = 0.0
              do mm=1,Info%tidx(0,i,j)
                 iit=i+Info%it(Info%tidx(mm,i,j))
                 jjt=j+Info%jt(Info%tidx(mm,i,j))
                 topog = topog + ht(iit,jjt)*tdsq_r(mm)
                 tbigd = tbigd + tdsq_r(mm)
              enddo
              tbigd = 1.0/tbigd

              this%geodepth =  topog*tbigd
              this%depth    =  this%geodepth + Ext_mode%eta_t(i,j,tau)
              if (vert_coordinate_class==DEPTH_BASED) then
                 this%st = -Thickness%depth_swt(i,j,k)
              else !PRESSURE_BASED
                 this%st = Thickness%depth_swt(i,j,k)
              endif
        
              if (bitwise_reproduction) then
                 ! check to see if the blob has left this pe
                 ! NOTE: we assume the blob does not go beyond the halo, so, we 
                 ! don't pack them into buffers until the end of the time step
                 ! We do this to maintain bitwise reproduction.  If we are not
                 ! maintaining bitwise reproduction, we pack a blob into a buffer
                 ! as soon as a change in pe is detected.
                 !
                 ! We also consider what happens when a blob traverses three
                 ! PE's in a time step.  e.g.
                 ! ------------------
                 ! |       |        |
                 ! | PE=2  +a  PE=3 |
                 ! |      /|        |
                 ! |     b |        |
                 ! ------+-----------
                 ! |    /  |        |
                 ! |   c   |        |
                 ! |       |        |
                 ! |  PE=0 |   PE=1 |
                 ! ------------------
                 ! Maintaining bitwise reproducability requires that each
                 ! PE knows about the history of the blob.  In the instance
                 ! depicted above, the blobs history must be processed on PE
                 ! 3,2 and 0.  We achieve this by keeping the history on
                 ! 3, and sending the history to 2 and 0.  When unpacking
                 ! the buffer, the unpacking subroutine checks if the blob 
                 ! is on that PE.  If it is not, it will set the blob%mass 
                 ! and blob%tracer(n) to zero.

                 if (change_pe) then
                    go_ne = .false.
                    go_nw = .false.
                    go_sw = .false.
                    go_se = .false.
                    go_e  = .false.
                    go_n  = .false.
                    go_w  = .false.
                    go_s  = .false.
                    do s=0,this%nfrac_steps

                       ! If we are on a cyclic grid, and, there is only one
                       ! processor in the cyclic direction, we want to avoid
                       ! having the blob sent and received to the same list.
                       ! (which means it can appear twice in the list). 
                       ! This can cause non-conservation.
                       call check_cyclic(this, this%di(s), this%dj(s), .false.)

                       if     (iec<this%di(s) .and. jec<this%dj(s)) then
                          go_ne = .true.
                       elseif (this%di(s)<isc .and. jec<this%dj(s)) then
                          go_nw = .true.
                       elseif (this%di(s)<isc .and. this%dj(s)<jsc) then
                          go_sw = .true.
                       elseif (iec<this%di(s) .and. this%dj(s)<jsc) then
                          go_se = .true.
                       elseif (iec<this%di(s)) then
                          go_e  = .true.
                       elseif (jec<this%dj(s)) then
                          go_n = .true.
                       elseif (this%di(s)<isc) then
                          go_w  = .true.
                       elseif (this%dj(s)<jsc) then
                          go_s = .true.
                       endif
                    enddo
                    if (go_ne) call packbuffer(this, NEbuffer_out)
                    if (go_nw) call packbuffer(this, NWbuffer_out)
                    if (go_se) call packbuffer(this, SEbuffer_out)
                    if (go_sw) call packbuffer(this, SWbuffer_out)
                    if (go_e ) call packbuffer(this,  Ebuffer_out)
                    if (go_w ) call packbuffer(this,  Wbuffer_out)
                    if (go_n ) call packbuffer(this,  Nbuffer_out)
                    if (go_s ) call packbuffer(this,  Sbuffer_out)

                    if (.not. any((/go_ne, go_nw, go_se, go_sw, go_e, go_w, go_n, go_s/))) then
                       call check_cyclic(this, this%i, this%j, .true.)
                       i=this%i; j=this%j
                    endif

                    ! We leave the blobs history in the linked list, but, we 
                    ! remove all its properties.  It will be deleted next call
                    ! to blob_delete, but, we need its history to be processed 
                    ! before it is deleted.  The history is processed only after
                    ! all blobs have been stepped.
                    ! A blob may go from one PE and then back to the same PE within an
                    ! E system time step, e.g.
                    ! +----------------+
                    ! | PE=2  +a  PE=3 |
                    ! |      /|        |
                    ! |     b |        |
                    ! |      \|        |
                    ! |       +c       |
                    ! +-------+--------+
                    ! |       |        |
                    ! |       |        |
                    ! |       |        |
                    ! |       |        |
                    ! |  PE=0 |   PE=1 |
                    ! +----------------+
                    ! So, we only set its properties to zero if it is no longer on this PE.
                    if (i<isc .or. iec<i .or. j<jsc .or. jec<j) then
                       this%mass=0.
                       do n=1,num_prog_tracers
                          this%tracer(n)=0.
                       enddo
                    endif
                    leaving_pe = leaving_pe + 1
                 endif
              endif !bitwise_reproduction
              
           elseif( (blob_time + 1.1*tstep) > dtime) then
              ! If we are within 10% of dtime with the suggested tstep, then, 
              ! we extend the step slightly to save having to take a really 
              ! small step next time. We ensure that the step size is chosen 
              ! so that blob_time coincides with the model step after the next blob step.
              reached_end = .false.
              tstep = dtime - blob_time

              ! Update the interpolation coefficients to reflect the new position
              call interp_tcoeff(i,j,h(:),lon,lat,tdsq_r(:))
              call interp_ucoeff(i,j,h(:),lon,lat,udsq_r(:))        
           else
              ! More step(s) required.  No need to adjust the step size.
              reached_end = .false.

              ! Update the interpolation coefficients to reflect the new position
              call interp_tcoeff(i,j,h(:),lon,lat,tdsq_r(:))
              call interp_ucoeff(i,j,h(:),lon,lat,udsq_r(:))        
           endif !blob_time == dtime

        enddo partialstep

        total_blobs = total_blobs + 1

        if (advance_blob) then
           this=>this%next 
        else
           this=>next
        endif
        if (.not. associated(this)) exit blobcycle
        
     enddo blobcycle
  endif !associated(head)

  ngrnd  = ngrnd  + ngrounded
  ndetrn = ndetrn + detrn_zero

  if (debug_this_module) then
     stdoutunit = stdout()
     write (stdoutunit, '(/,a)') 'Dynamic Bottom Blob Statistics'
     call write_timestamp(Time%model_time)
     call mpp_sum(total_blobs)
     write (stdoutunit, *) 'Total Bottom Dynamic Blobs             =', total_blobs
     call mpp_sum(leaving_pe)
     write (stdoutunit, *) 'Bottom Dynamic Blobs Changing PEs      =', leaving_pe
     call mpp_sum(tfer_free)
     write (stdoutunit, *) 'Bottom Dynamic Blob Transfer to free   =', tfer_free
     call mpp_sum(detrn_zero)
     write (stdoutunit, *) 'Bottom Blobs detrained to zero mass    =', detrn_zero
     call mpp_sum(move_lateral)
     write (stdoutunit, *) 'Bottom Blobs changing water columns    =', move_lateral
     call mpp_sum(ngrounded)
     write (stdoutunit, *) 'Grounded Bottom Blobs                  =', ngrounded
  endif
end subroutine dynamic_update
! </SUBROUTINE>  NAME="dynamic_update"


!######################################################################
! <SUBROUTINE NAME="transfer_free_to_bottom">
!
! <DESCRIPTION>
! Takes free blobs that have interacted with topography and turns them
! into bottom blobs.
! </DESCRIPTION>
!
subroutine transfer_free_to_bottom(Time, Thickness, T_prog, new_head, &
                                   head, use_free, EL_diag)
  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(inout) :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_blob_type),        pointer       :: new_head
  type(ocean_blob_type),        pointer       :: head
  logical,                      intent(in)    :: use_free
  type(blob_diag_type), dimension(0:num_prog_tracers) :: EL_diag

  type(ocean_blob_type), pointer :: this => NULL()
  type(ocean_blob_type), pointer :: prev => NULL()
  type(ocean_blob_type), pointer :: next => NULL()
  real,    dimension(3) :: v_par, v_perp, v_new
  real, dimension(9) :: tdsq_r
  real, dimension(4) :: udsq_r
  real :: ubigd, tbigd
  integer :: i,j,k,iiu,jju,iit,jjt,mm,n
  integer :: nblobs
  real    :: Hx, Hy
  real    :: topog
  real    :: mag_v, mag_v_par, constant
  integer :: stdoutunit

  nblobs = 0
  if (associated(new_head)) then
     this=>new_head
     if (use_this_module .and. accept_free_blobs) then
        ! If we are using dynamic bottom blobs, transfer free blobs
        ! that have interacted with topography to the dynamic 
        ! bottom blob list
        blobcycle: do
           i = this%i
           j = this%j
           k = this%k

           call unlink_blob(this, new_head, prev, next)
           call insert_blob(this, head)
           call reallocate_interaction_memory(this, head, total_ns)

           call interp_ucoeff(i,j,(/this%h1,this%h2/),this%lon,this%lat,udsq_r(:))
           ubigd = 0.0
           Hx=0.0; Hy=0.0
           do mm=1,Info%uidx(0,i,j)
              iiu=i+Info%iu(Info%uidx(mm,i,j))
              jju=j+Info%ju(Info%uidx(mm,i,j))
              Hx = Hx + dht_dx(iiu,jju)*udsq_r(mm)
              Hy = Hy + dht_dy(iiu,jju)*udsq_r(mm)
              ubigd = ubigd + udsq_r(mm)
           enddo
           ubigd = 1.0/ubigd
           Hx = Hx*ubigd
           Hy = Hy*ubigd

           constant  = this%v(1)*Hx + this%v(2)*Hy + this%v(3)
           constant  = constant/(Hx**2 + Hy**2 + 1)
           v_perp(:) = (/Hx*constant, Hy*constant, constant/)
           v_par(:)  = this%v(:) - v_perp(:)
           mag_v     = sqrt(this%v(1)**2 + this%v(2)**2 + this%v(3)**2)
           mag_v_par = sqrt( v_par(1)**2 + v_par(2)**2 + v_par(3)**2 )
           if (mag_v_par /= 0.0) then
              v_new(:) = elastic*v_par(:)*mag_v/mag_v_par
           else
              v_new(:) = 0.0
           endif

           this%v(:) = v_new(:)

           this%height = blob_height

           call interp_tcoeff(i,j,(/this%h1,this%h2/),this%lon,this%lat,tdsq_r(:))
           
           tbigd = 0.0
           topog = 0.0
           do mm=1,Info%tidx(0,i,j)
              iit=i+Info%it(Info%tidx(mm,i,j))
              jjt=j+Info%jt(Info%tidx(mm,i,j))
              topog = topog + ht(iit,jjt)*tdsq_r(mm)
              tbigd = tbigd+tdsq_r(mm)
           enddo
           tbigd = 1.0/tbigd

           this%geodepth = topog*tbigd
           if (vert_coordinate_class==DEPTH_BASED) then
              this%st = -Thickness%depth_swt(i,j,k)
           else !PRESSURE_BASED
              this%st = Thickness%depth_swt(i,j,k)
           endif
           
           this=>next
           nblobs = nblobs+1
           if (.not. associated(this)) exit blobcycle
        enddo blobcycle

     else !not use_this_module
        ! If we are not using dynamic bottom blobs, return their
        ! properties to the E system.
        blobcycle2: do
           i = this%i
           j = this%j
           k = this%k

           ! Diagnostics
           EL_diag(0)%dstry(i,j,k) = EL_diag(0)%dstry(i,j,k) + this%mass
           do n=1,num_prog_tracers
              EL_diag(n)%dstry(i,j,k) = EL_diag(n)%dstry(i,j,k) + this%tracer(n)
           enddo

           call kill_blob(Thickness, T_prog(:), this, i, j, k)
           this=>this%next
           nblobs = nblobs+1
           if (.not. associated(this)) exit blobcycle2
        enddo blobcycle2
     endif !use_this_module
     call blob_delete(Time, Thickness, T_prog(:), new_head)
  endif!associated(new_head)

  call mpp_sum(nblobs)
  if (id_free_to_bot>0) used = send_data(id_free_to_bot, real(nblobs), Time%model_time)

  if(debug_this_module .and. use_free) then
     stdoutunit = stdout()
     write(stdoutunit, '(/,a)') 'Free blobs interacting with topography'
     if (use_this_module) then
        write(stdoutunit, *) 'Free blobs transferred to bottom blobs = ', nblobs
     else
        write(stdoutunit, *) 'Free blobs destroyed from reaching bottom = ', nblobs
     endif
  endif

end subroutine transfer_free_to_bottom
! </SUBROUTINE>  NAME="transfer_free_to_bottom"


!######################################################################
! <SUBROUTINE NAME="dynamic_bottom_form_new">
!
! <DESCRIPTION>
! Initialises blobs that are formed when an on-shelf/off-shelf
! instability occurs.  The method used for determining an instability
! and the initial conditions are based on that of Campin and Goosse
! (1999).  
!
! When the density difference between the shallow ocean cell and the 
! deep ocean cell (referenced to the deep ocean cell) exceeds the
! namelist variable rho_threshold, a blob is formed.  The deep ocean
! cell is chosen based on which deep ocean cell (in the k plane)
! the blob topography intersects.
!
! After formation, the new blobs are added to the bottom blob linked
! list, and, their properties are integrated, starting at time taup1.
! </DESCRIPTION>
!
subroutine dynamic_bottom_form_new(Time, Dens, T_prog, Thickness, Ext_mode, &
                                   L_system, tend_blob, blob_counter, u,    &
                                   mass_out, mass_in, head, EL_diag)
  type(ocean_time_type),                  intent(in)    :: Time
  type(ocean_density_type),               intent(in)    :: Dens
  type(ocean_prog_tracer_type),           intent(inout) :: T_prog(:)
  type(ocean_thickness_type),             intent(inout) :: Thickness
  type(ocean_external_mode_type),         intent(inout) :: Ext_mode
  type(ocean_lagrangian_type),            intent(inout) :: L_system
  real, dimension(num_prog_tracers,isd:ied,jsd:jed,nk), intent(inout) :: tend_blob
  integer, dimension(isc:iec,jsc:jec,nk),               intent(inout) :: blob_counter
  real, dimension(isbd:iebd,jsbd:jebd,1:nk,1:2),        intent(in)    :: u
  real, dimension(isd:ied,jsd:jed,1:nk),                intent(inout) :: mass_out
  real, dimension(isd:ied,jsd:jed,1:nk),                intent(inout) :: mass_in
  type(ocean_blob_type), pointer                                      :: head
  type(blob_diag_type),  dimension(0:num_prog_tracers), intent(inout) :: EL_diag
  
  type(ocean_blob_type), pointer :: this, prev, next, new_head
  real, dimension(4) :: udsq_r
  real :: ubigd
  integer :: tau, i, iip, iiu, j, jjp, jju, k, m, mm, n, nblobs
  integer :: stdoutunit
  real :: overflow_flux, overflow_speed
  real :: blob_mass, do_dens, so_dens, drho, drho_rhor
  real :: uE, vE

  if (.not. use_this_module) return

  nblobs = 0

  tau   = Time%tau

  ! For diagnostics
  do n=1,num_prog_tracers
     T_prog(n)%wrk1(:,:,:) = 0.0
  enddo

  call clear_buffer(Ebuffer_out)
  call clear_buffer(Wbuffer_out)
  call clear_buffer(Nbuffer_out)
  call clear_buffer(Ebuffer_out)

  nullify(new_head)

  if (debug_this_module) then
     stdoutunit = stdout()
     write(stdoutunit, '(a)') ' '
     call write_timestamp(Time%model_time)
     write(stdoutunit, '(a)') 'From ocean_blob_dynamics_bottom_mod'
     write(stdoutunit, '(a)') 'Totals before bottom dynamic blob creation (tau)'
     call E_and_L_totals(L_system,Thickness,T_prog(:),tau)
     call mpp_sum(nblobs)
     write(stdoutunit, '(a,i4,/)') 'New bottom dynamic blobs (tau) = ', nblobs
  endif

  ! search for horizontal instability, including in certain parts of the halo
  do m=1,4
     do j=jsc,jec
        do i=isc,iec

           ! check whether downslope flow is possible and it is within
           ! the latitude bands of interest
           if (topog_step(i,j,m) == 1.0) then

              ! some convenient variables
              iip = i+ip(m)
              jjp = j+jp(m)
              k   = Grd%kmt(i,j)

              ! Check whether density of E system shelf water is more than deep water.
              so_dens = density(T_prog(index_salt)%field(i,j,k,tau), &
                                T_prog(index_temp)%field(i,j,k,tau), &
                                Dens%pressure_at_depth(iip,jjp,kmt(iip,jjp)))
              do_dens = Dens%rho(iip,jjp,kmt(iip,jjp),tau)
              if ((so_dens - do_dens) > rho_threshold) then

                 nullify(this)
                 
                 drho      = abs(so_dens-do_dens)
                 drho_rhor = drho/so_dens
                 
                 ! calculate the overflow velocity
                 overflow_speed = overflow_factor*topog_slope(i,j,m)*drho_rhor
                 
                 ! Overflow flux has units kg/(m*s) 
                 overflow_flux = overflow_factor * topog_slope(i,j,m)      & 
                                 *drho * Thickness%dzt(i,j,k) 

                 if (enforce_big_blobs) then
                    ! 0.2 = 0.8*1/4
                    blob_mass = 0.2*Grd%dat(i,j)*Thickness%rho_dzt(i,j,k,tau)

                 else
                    if    (m==1) then 
                       blob_mass = overflow_flux*Grd%dyte(i,j)*dtime 
                    elseif(m==2) then 
                       blob_mass = overflow_flux*Grd%dxtn(i,j)*dtime 
                    elseif(m==3) then 
                       blob_mass = overflow_flux*Grd%dyte(i-1,j)*dtime 
                    else  !m==4 
                       blob_mass = overflow_flux*Grd%dxtn(i,j-1)*dtime 
                    endif

                    ! There can be, theoretically, up to four overflow events take 
                    ! place from a single grid cell.  Therefore, we do not want a single 
                    ! overflow event to take away more than 1/4 of the mass of a grid cell. 
                    if (0.25*Thickness%rho_dzt(i,j,k,tau)*Grd%dat(i,j) < blob_mass) then 
                       blob_mass = 0.25*Thickness%rho_dzt(i,j,k,tau)*Grd%dat(i,j) 
                    endif
                 endif


                 ! Form the onshelf blobs.  Make sure they are in the 
                 ! compute domain.
                 allocate(this)
                 allocate(this%tracer(num_prog_tracers))
                 allocate(this%field(num_prog_tracers))
                 
                 this%mass = blob_mass
                 do n=1,num_prog_tracers
                    this%tracer(n)     = this%mass*T_prog(n)%field(i,j,k,tau)
                    this%field(n)      = this%tracer(n)/this%mass
                    tend_blob(n,i,j,k) = tend_blob(n,i,j,k) - this%tracer(n)
                 enddo
                 this%density = density(this%field(index_salt), &
                                        this%field(index_temp), &
                                        Dens%pressure_at_depth(iip,jjp,k))
                 this%densityr = 1.0/this%density

                 ! Calculate the divergence (convergence comes later)
                 Ext_mode%conv_blob(i,j)   = Ext_mode%conv_blob(i,j)   - this%mass
                 L_system%conv_blob(i,j,k) = L_system%conv_blob(i,j,k) - this%mass
                 mass_out(i,j,k)           = mass_out(i,j,k)           + this%mass
                 
                 this%height = blob_height

                 if (vert_coordinate_class == DEPTH_BASED) then
                    this%volume = this%mass*rho0r
                 else
                    this%volume = this%mass*this%densityr
                 endif
                 
                 ! Firstly, give the blob the grid cell of origin, so that it is
                 ! counted correctly.
                 this%i = i
                 this%j = j
                 this%k = k

                 ! We need to keep the blob in a separate list for the moment
                 ! so that we can maintain reproducibility
                 call count_blob(this, blob_counter)
                 call insert_blob(this, new_head)
                 call allocate_interaction_memory(this, total_ns)
                 nblobs = nblobs + 1

                 this%age = 0.0

                 ! Diagnostic
                 EL_diag(0)%new(i,j,k) = EL_diag(0)%new(i,j,k) + this%mass
                 do n=1,num_prog_tracers
                    EL_diag(n)%new(i,j,k) = EL_diag(n)%new(i,j,k) + this%tracer(n)
                 enddo

                 this%i = iip
                 this%j = jjp
                 
                 ! Find the initial position and stretching function
                 ! We will adjust the initial position after the initial velocity
                 ! has been calculated
                 this%h1  = blobh1(i,j,m)
                 this%h2  = blobh2(i,j,m)
                 this%lon = xb(i,j,m)
                 this%lat = yb(i,j,m)

                 this%blob_time = 0.0
                 
                 this%geodepth = hb(i,j,m)
                 this%depth    = this%geodepth + Ext_mode%eta_t(i,j,tau)
                 if (vert_coordinate_class==DEPTH_BASED) then
                    this%st = -Thickness%depth_swt(i,j,k)
                 else !PRESSURE_BASED
                    this%st = Thickness%depth_swt(i,j,k)
                 endif

                 call interp_ucoeff(i,j,(/this%h1,this%h2/),this%lon,this%lat,udsq_r(:))        
                 ! Interpolate the E system variables to the blobs
                 ! Note, we treat the stretching function separately
                 ubigd = 0.0
                 uE=0.0; vE=0.0
                 do mm=1,Info%uidx(0,i,j)
                    iiu=i+Info%iu(Info%uidx(mm,i,j))
                    jju=j+Info%ju(Info%uidx(mm,i,j))
                    ! Land points are treated as a zero
                    if(kmu(iiu,jju)>0) then
                       uE = uE + u(iiu,jju,kmu(iiu,jju),1)*udsq_r(mm)
                       vE = vE + u(iiu,jju,kmu(iiu,jju),2)*udsq_r(mm)
                    endif
                    ubigd = ubigd + udsq_r(mm)
                 enddo
                 ubigd = 1.0/ubigd
                 
                 uE = uE*ubigd
                 vE = vE*ubigd

                 ! Initial Velocity
                 if(m==1) then
                    this%v(1) = uE + overflow_speed
                    this%v(2) = vE
                 elseif(m==2) then
                    this%v(1) = uE 
                    this%v(2) = vE + overflow_speed
                 elseif (m==3) then
                    this%v(1) = uE - overflow_speed
                    this%v(2) = vE
                 else!m==4
                    this%v(1) = uE 
                    this%v(2) = vE - overflow_speed
                 endif
                 this%v(3) = vert_factor(i,j,m)*drho_rhor

                 ! Adjust the initial position (this guarantees we are in
                 ! the correct cell, and not exactly on the edge of two cells)
                 this%lon = this%lon + this%v(1)*dtime_rad_to_deg/this%h1
                 this%lat = this%lat + this%v(2)*dtime_rad_to_deg/this%h2

                 this%new  = .false.
                 this%step = first_step
                 
                 ! test if this has gone out to the E,W,N or S of the 
                 ! compute domain.  If it has, then pack it into an outward
                 ! buffer and remove it from this PE's list of blobs
                 if (iip>iec) then
                    call packbuffer(this, Ebuffer_out)
                    call unlink_blob(this, new_head, prev, next)
                    call free_blob_memory(this)
                 elseif (iip<isc) then
                    call packbuffer(this, Wbuffer_out)
                    call unlink_blob(this, new_head, prev, next)
                    call free_blob_memory(this)
                 elseif (jjp>jec) then
                    call packbuffer(this, Nbuffer_out)
                    call unlink_blob(this, new_head, prev, next)
                    call free_blob_memory(this)
                 elseif (jjp<jsc) then
                    call packbuffer(this, Sbuffer_out)
                    call unlink_blob(this, new_head, prev, next)
                    call free_blob_memory(this)
                 endif
              endif !rho_so>rho_do?
           endif !topog_step==1.0?
        enddo !i
     enddo !j
  enddo !m
  
  ! Now, send blobs to neighbouring PE's.  Note: since blobs can only move
  ! N,S,E or W, we do not need to worry about diagonal PE's 
  ! (i.e. NE,SE,SW,NW)
  call send_buffer(Ebuffer_out)
  call send_buffer(Wbuffer_out)
  call send_buffer(Nbuffer_out)
  call send_buffer(Sbuffer_out)
  
  call mpp_sync_self()

  ! Clear the incoming buffers
  call clear_buffer(Wbuffer_in)
  call clear_buffer(Ebuffer_in)
  call clear_buffer(Sbuffer_in)
  call clear_buffer(Nbuffer_in)
  
  ! Now receive blobs from neighbouring PE's
  call receive_buffer(Wbuffer_in)
  call receive_buffer(Ebuffer_in)
  call receive_buffer(Sbuffer_in)
  call receive_buffer(Nbuffer_in)
  
  ! Now unpack the buffer and add the received blobs to this PE's blob list
  call unpackbuffer(Time, Wbuffer_in, new_head, Dens, Ext_mode, Thickness)
  call unpackbuffer(Time, Ebuffer_in, new_head, Dens, Ext_mode, Thickness)
  call unpackbuffer(Time, Sbuffer_in, new_head, Dens, Ext_mode, Thickness)
  call unpackbuffer(Time, Nbuffer_in, new_head, Dens, Ext_mode, Thickness)

  if(associated(new_head)) then
     this=>new_head
     blobcycle: do
        i = this%i
        j = this%j
        k = this%k

        ! Calculate the convergence
        Ext_mode%conv_blob(i,j)   = Ext_mode%conv_blob(i,j)   + this%mass
        L_system%conv_blob(i,j,k) = L_system%conv_blob(i,j,k) + this%mass
        mass_in(i,j,k)            = mass_in(i,j,k)            + this%mass

        call unlink_blob(this, new_head, prev, next)
        call insert_blob(this, head)
        
        this=>next
        if(.not.associated(this)) exit blobcycle
     enddo blobcycle
  endif
  
  call mpp_sum(nblobs)
  if (id_new_blobs>0) used = send_data(id_new_blobs, real(nblobs), Time%model_time)

  if (debug_this_module) then
     call write_timestamp(Time%model_time)
     write(stdoutunit, '(a)') 'From ocean_blob_dynamics_bottom_mod'
     write(stdoutunit, '(a)') 'Totals after bottom dynamic blob creation (tau)'
     call E_and_L_totals(L_system,Thickness,T_prog(:),tau)
     write(stdoutunit, '(a,i4)') 'New bottom dynamic blobs (taup1) = ', nblobs
     write(stdoutunit, '(a)') ' '
  endif

end subroutine dynamic_bottom_form_new
! </SUBROUTINE>  NAME="dynamic_bottom_form_new"


!######################################################################
! <SUBROUTINE NAME="blob_dynamic_bottom_end">
!
! <DESCRIPTION>
! Clears memory to give a nice clean ending to the run.
! </DESCRIPTION>
!
subroutine blob_dynamic_bottom_end()

  if (.not. use_this_module) return

  call deallocate_buffer(Ebuffer_out);  call deallocate_buffer(Ebuffer_in)
  call deallocate_buffer(Wbuffer_out);  call deallocate_buffer(Wbuffer_in)
  call deallocate_buffer(Nbuffer_out);  call deallocate_buffer(Nbuffer_in)
  call deallocate_buffer(Sbuffer_out);  call deallocate_buffer(Sbuffer_in)
  call deallocate_buffer(NEbuffer_out); call deallocate_buffer(NEbuffer_in)
  call deallocate_buffer(NWbuffer_out); call deallocate_buffer(NWbuffer_in)
  call deallocate_buffer(SEbuffer_out); call deallocate_buffer(SEbuffer_in)
  call deallocate_buffer(SWbuffer_out); call deallocate_buffer(SWbuffer_in)

  nullify(Dom)
  nullify(Grd)
  nullify(Info)
  nullify(Bdom)

contains
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that deallocates memory from a buffer    !
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine deallocate_buffer(buffer)
    type(blob_buffer_type), pointer :: buffer
    if (buffer%pe /= NULL_PE) deallocate(buffer)
  end subroutine deallocate_buffer
end subroutine blob_dynamic_bottom_end
! </SUBROUTINE>  NAME="blob_dynamic_bottom_end"


!######################################################################
! <SUBROUTINE NAME="packbuffer">
!
! <DESCRIPTION>
! Packs a buffer with all the information needed to send a blob from
! one PE to another.
! </DESCRIPTION>
!
subroutine packbuffer(blob, buffer, entrainment, detrainment)
  type(ocean_blob_type),  pointer    :: blob
  type(blob_buffer_type), pointer    :: buffer
  real,         optional, intent(in) :: entrainment(0:)
  real,         optional, intent(in) :: detrainment(0:)
  integer :: n, nb, s, npt
  integer :: stdoutunit

  stdoutunit = stdout()

  if (buffer%pe == NULL_PE) then
     write (stdoutunit, '(a)') 'Error: Trying to send blob to a NULL_PE'
     call mpp_error(FATAL, &
          '==>Error in ocean_blob_static_bottom_mod (packbuffer): '&
          //'Trying to send blob to a NULL_PE')
  endif
  buffer%numblobs = buffer%numblobs+1
  if (buffer%numblobs>buffer%size) call increase_buffer(buffer,buffer%numblobs)

  npt = num_prog_tracers
  nb  = buffer%numblobs
  
  ! Fill the real buffer
  do n=1,num_prog_tracers
     buffer%real_buff(2*n-1,nb) = blob%tracer(n)
     buffer%real_buff(2*n  ,nb) = blob%dtracer(n)
  enddo
  buffer%real_buff(2*npt+1 ,nb) = blob%v(1)
  buffer%real_buff(2*npt+2 ,nb) = blob%v(2)
  buffer%real_buff(2*npt+3 ,nb) = blob%v(3)
  buffer%real_buff(2*npt+4 ,nb) = blob%lon
  buffer%real_buff(2*npt+5 ,nb) = blob%lat
  buffer%real_buff(2*npt+6 ,nb) = blob%geodepth
  buffer%real_buff(2*npt+7 ,nb) = blob%step
  buffer%real_buff(2*npt+8 ,nb) = blob%mass
  buffer%real_buff(2*npt+9 ,nb) = blob%blob_time
  buffer%real_buff(2*npt+10,nb) = blob%h1
  buffer%real_buff(2*npt+11,nb) = blob%h2
  buffer%real_buff(2*npt+12,nb) = blob%ent
  buffer%real_buff(2*npt+13,nb) = blob%det
  buffer%real_buff(2*npt+14,nb) = blob%richardson
  buffer%real_buff(2*npt+15,nb) = blob%dmass
  buffer%real_buff(2*npt+16,nb) = blob%gprime
  buffer%real_buff(2*npt+17,nb) = blob%age
  buffer%real_buff(2*npt+18,nb) = blob%height

  ! Fill the integer buffer
  buffer%integer_buff(1,nb) = blob%i
  buffer%integer_buff(2,nb) = blob%j
  buffer%integer_buff(3,nb) = blob%k
  buffer%integer_buff(4,nb) = blob%model_steps
  buffer%integer_buff(5,nb) = blob%hash
  buffer%integer_buff(6,nb) = blob%number
  buffer%integer_buff(7,nb) = blob%nfrac_steps
  buffer%integer_buff(8,nb) = blob%nsteps

  if (bitwise_reproduction) then
     ! History buffers
     
     ! only some variables use s=0
     s=0
     buffer%history_integer_buff(1,s,nb) = blob%di(s)
     buffer%history_integer_buff(2,s,nb) = blob%dj(s)
     buffer%history_integer_buff(3,s,nb) = blob%dk(s)
     buffer%history_real_buff(npt+3,s,nb) = blob%mass_out(s)
     
     do s=1,blob%nfrac_steps
        ! Integer buffer
        buffer%history_integer_buff(1,s,nb) = blob%di(s)
        buffer%history_integer_buff(2,s,nb) = blob%dj(s)
        buffer%history_integer_buff(3,s,nb) = blob%dk(s)
        
        ! Real buffer
        do n=0,num_prog_tracers
           buffer%history_real_buff(2*n  ,s,nb) = blob%entrainment(s,n)
           buffer%history_real_buff(2*n+1,s,nb) = blob%detrainment(s,n)
        enddo
        buffer%history_real_buff(2*npt+2,s,nb) = blob%mass_in(s)
        buffer%history_real_buff(2*npt+3,s,nb) = blob%mass_out(s)
     enddo

  else
     ! dtracer is not parsed for new blobs, so we do
     ! not need to worry about it
     if (present(entrainment)) then
        do n=0,num_prog_tracers
           buffer%history_real_buff(2*n  ,1,nb) = entrainment(n)
           buffer%history_real_buff(2*n+1,1,nb) = detrainment(n)
        enddo
     endif
  endif

end subroutine packbuffer
! </SUBROUTINE>  NAME="packbuffer"

!######################################################################
! <SUBROUTINE NAME="unpackbuffer">
!
! <DESCRIPTION>
! Unpacks a received buffer.
! </DESCRIPTION>
!
subroutine unpackbuffer(Time, buffer, head, Dens, Ext_mode, Thickness, &
                        L_system, EL_diag, blob_source, tend_blob, mass_in)
  type(ocean_time_type),                    intent(in)    :: Time
  type(blob_buffer_type),                   pointer       :: buffer
  type(ocean_blob_type),                    pointer       :: head
  type(ocean_density_type),                 intent(in)    :: Dens
  type(ocean_external_mode_type),           intent(inout) :: Ext_mode
  type(ocean_thickness_type),               intent(in)    :: Thickness
  type(ocean_lagrangian_type),    optional, intent(inout) :: L_system
  type(blob_diag_type),           optional, intent(inout) :: EL_diag(0:)
  real, optional, dimension(num_prog_tracers,isd:ied,jsd:jed,nk), intent(inout) :: tend_blob
  real, optional, dimension(isd:ied,jsd:jed),                     intent(inout) :: blob_source
  real, optional, dimension(isd:ied,jsd:jed,1:nk),                intent(inout) :: mass_in

  type(ocean_blob_type), pointer       :: blob
  real, dimension(0:num_prog_tracers) :: entrainment, detrainment
  integer :: n, nb, s, npt
  integer :: i,j,k

  if (buffer%pe /= NULL_PE .and. buffer%numblobs>0) then
     npt = num_prog_tracers
     
     do nb=1,buffer%numblobs
        allocate(blob)
        allocate(blob%tracer(num_prog_tracers))
        allocate(blob%field(num_prog_tracers))
        call allocate_interaction_memory(blob, total_ns)
        
        ! unpack the real buffer
        do n=1,num_prog_tracers
           blob%tracer(n)  = buffer%real_buff(2*n-1,nb)
           blob%dtracer(n) = buffer%real_buff(2*n  ,nb)
        enddo
        blob%v(1)       = buffer%real_buff(2*npt+ 1,nb)
        blob%v(2)       = buffer%real_buff(2*npt+ 2,nb)
        blob%v(3)       = buffer%real_buff(2*npt+ 3,nb)
        blob%lon        = buffer%real_buff(2*npt+ 4,nb)
        blob%lat        = buffer%real_buff(2*npt+ 5,nb)
        blob%geodepth   = buffer%real_buff(2*npt+ 6,nb)
        blob%step       = buffer%real_buff(2*npt+ 7,nb)
        blob%mass       = buffer%real_buff(2*npt+ 8,nb)
        blob%blob_time  = buffer%real_buff(2*npt+ 9,nb)
        blob%h1         = buffer%real_buff(2*npt+10,nb)
        blob%h2         = buffer%real_buff(2*npt+11,nb)
        blob%ent        = buffer%real_buff(2*npt+12,nb)
        blob%det        = buffer%real_buff(2*npt+13,nb)
        blob%richardson = buffer%real_buff(2*npt+14,nb)
        blob%dmass      = buffer%real_buff(2*npt+15,nb)
        blob%gprime     = buffer%real_buff(2*npt+16,nb)
        blob%age        = buffer%real_buff(2*npt+17,nb)
        blob%height     = buffer%real_buff(2*npt+18,nb)

        ! unpack the integer buffer
        blob%i           = buffer%integer_buff(1,nb)
        blob%j           = buffer%integer_buff(2,nb)
        blob%k           = buffer%integer_buff(3,nb)
        blob%model_steps = buffer%integer_buff(4,nb)
        blob%hash        = buffer%integer_buff(5,nb)
        blob%number      = buffer%integer_buff(6,nb)
        blob%nfrac_steps = buffer%integer_buff(7,nb)
        blob%nsteps      = buffer%integer_buff(8,nb)
        call check_cyclic(blob, blob%i, blob%j, .true.)
        
        i=blob%i; j=blob%j; k=blob%k

        ! We check to make sure that the blob belongs on this PE, or,
        ! whether we only need to process its history.  If it does not
        ! belong on this PE, set its mass and tracer to zero so that 
        ! it will be destroyed.  If it does not belong, then we do not 
        ! need to bother with finding tracer concentration, density,
        ! or volume.

        if (isc <= i .and. i<=iec .and. jsc<=j .and. j<=jec .and. blob%mass>0.0) then
        ! Derived variables
           do n=1,num_prog_tracers
              blob%field(n)  = blob%tracer(n)/blob%mass
           enddo

           blob%density = density(blob%field(index_salt), & 
                                  blob%field(index_temp), &
                                  Dens%pressure_at_depth(i,j,k))
           blob%densityr = 1./blob%density
        
           if (vert_coordinate_class == DEPTH_BASED) then
              blob%volume = blob%mass * rho0r 
           else
              blob%volume = blob%mass * blob%densityr
           endif

           if (vert_coordinate_class==DEPTH_BASED) then
              blob%st = -Thickness%depth_swt(i,j,k)
           else !PRESSURE_BASED
              blob%st = Thickness%depth_swt(i,j,k)
           endif
           blob%depth =  blob%geodepth + Ext_mode%eta_t(i,j,Time%tau)
           
        else
           blob%mass      = 0.0
           blob%tracer(:) = 0.0
        endif

        if (bitwise_reproduction) then
           ! History buffers
           blob%di(:) = -1
           blob%dj(:) = -1
           blob%dk(:) = -1
           blob%entrainment(:,:) = 0.0
           blob%detrainment(:,:) = 0.0
           blob%mass_in(:)       = 0.0
           blob%mass_out(:)      = 0.0
           
           ! only some variables use s=0
           s=0
           blob%di(s) = buffer%history_integer_buff(1,s,nb)
           blob%dj(s) = buffer%history_integer_buff(2,s,nb)
           blob%dk(s) = buffer%history_integer_buff(3,s,nb)
           blob%mass_out(s) = buffer%history_real_buff(npt+3,s,nb)
           
           if (blob%nfrac_steps>0) then
              do s=1,blob%nfrac_steps
                 ! Integer buffer
                 blob%di(s) = buffer%history_integer_buff(1,s,nb)
                 blob%dj(s) = buffer%history_integer_buff(2,s,nb)
                 blob%dk(s) = buffer%history_integer_buff(3,s,nb)
                 ! Real buffer
                 do n=0,num_prog_tracers
                    blob%entrainment(s,n) = buffer%history_real_buff(2*n  ,s,nb)
                    blob%detrainment(s,n) = buffer%history_real_buff(2*n+1,s,nb)
                 enddo
                 blob%mass_in(s)  = buffer%history_real_buff(2*npt+2,s,nb)
                 blob%mass_out(s) = buffer%history_real_buff(2*npt+3,s,nb)
              enddo
           endif
              
           do s=0,blob%nfrac_steps
              call check_cyclic(blob, blob%di(s), blob%dj(s), .false.)
           enddo

           call insert_blob(blob, head)

        else!not bitwise_reproduction
           ! blob_source is not parsed for new blobs, so, we do 
           ! not need to worry about it
           if(present(blob_source)) then !if blob_source is present, so is tend_blob and L_system
              Ext_mode%conv_blob(i,j)   = Ext_mode%conv_blob(i,j)   + blob%mass
              L_system%conv_blob(i,j,k) = L_system%conv_blob(i,j,k) + blob%mass
              mass_in(i,j,k)            = mass_in(i,j,k)            + blob%mass

              do n=0,num_prog_tracers 
                 entrainment(n) = buffer%history_real_buff(2*n  ,1,nb) 
                 detrainment(n) = buffer%history_real_buff(2*n+1,1,nb) 
              enddo 
              blob_source(i,j) = blob_source(i,j) - detrainment(0) - entrainment(0) 
              blob%mass        = blob%mass + detrainment(0) + entrainment(0) 
              EL_diag(0)%detrainment(i,j,k) = EL_diag(0)%detrainment(i,j,k) - detrainment(0) 
              EL_diag(0)%entrainment(i,j,k) = EL_diag(0)%entrainment(i,j,k) + entrainment(0) 

              do n=1,num_prog_tracers
                 tend_blob(n,i,j,k) = tend_blob(n,i,j,k) - detrainment(n) - entrainment(n) 
                 blob%tracer(n)     = blob%tracer(n) + detrainment(n) + entrainment(n) 
                 EL_diag(n)%detrainment(i,j,k) = EL_diag(n)%detrainment(i,j,k) - detrainment(n) 
                 EL_diag(n)%entrainment(i,j,k) = EL_diag(n)%entrainment(i,j,k) + entrainment(n)
               enddo

              if (blob%mass>small_mass) then
                 do n=1,num_prog_tracers
                    blob%field(n) = blob%tracer(n)/blob%mass
                 enddo

                 blob%density = density(blob%field(index_salt), & 
                                        blob%field(index_temp), &
                                        Dens%pressure_at_depth(i,j,k))
                 blob%densityr = 1./blob%density
                 
                 if (vert_coordinate_class == DEPTH_BASED) then
                    blob%volume = blob%mass * rho0r 
                 else
                    blob%volume = blob%mass * blob%densityr
                 endif
              endif
           endif

           ! If a blob is of zero mass, we are only interested in its detrainment
           ! properties.  So, to stop any confusion, we kill it after its 
           ! tendencies have been added to the gridded variables.
           if (blob%mass>0.0) then
              call insert_blob(blob, head)
           else
              call free_blob_memory(blob)
           endif

        endif
        nullify(blob)
     enddo
  endif

end subroutine unpackbuffer
! </SUBROUTINE>  NAME="unpackbuffer"

!######################################################################
! <SUBROUTINE NAME="increase_buffer">
!
! <DESCRIPTION>
! Increases the buffer size for sending blobs from one PE to another.
! </DESCRIPTION>
!
subroutine increase_buffer(buffer, newnum)
  type(blob_buffer_type), pointer :: buffer
  integer, intent(in) :: newnum

  ! local variables
  type(blob_buffer_type), pointer :: new_buffer
  integer :: newbuffsize, m

  newbuffsize = buffer%size
  allocate(new_buffer)
  m=1
  do while (newnum>newbuffsize)
     newbuffsize = buffer%size + m*delta_buffer
     m=m+1
  enddo

  allocate(new_buffer%integer_buff(int_buff_size,newbuffsize))
  allocate(new_buffer%real_buff(   rea_buff_size,newbuffsize))

  if (bitwise_reproduction) then
     allocate(new_buffer%history_integer_buff(hist_int_buff_size, 0:total_nsp1, newbuffsize))
     allocate(new_buffer%history_real_buff( 0:hist_rea_buff_size, 0:total_nsp1, newbuffsize))
  else
     allocate(new_buffer%history_real_buff( 0:hist_rea_buff_size, 1, newbuffsize))
  endif

  call clear_buffer(new_buffer)
  
  new_buffer%integer_buff(:,1:buffer%size) = buffer%integer_buff(:,:)
  new_buffer%real_buff(   :,1:buffer%size) = buffer%real_buff(:,:)

  if (bitwise_reproduction) new_buffer%history_integer_buff(:,:,1:buffer%size) = buffer%history_integer_buff(:,:,:)
  new_buffer%history_real_buff(   :,:,1:buffer%size) = buffer%history_real_buff(:,:,:)

  new_buffer%pe = buffer%pe
  new_buffer%size = newbuffsize
  new_buffer%numblobs = buffer%numblobs

  deallocate(buffer)

  nullify(buffer)
  buffer=>new_buffer

end subroutine increase_buffer
! </SUBROUTINE>  NAME="increase_buffer"

!######################################################################
! <SUBROUTINE NAME="send_buffer">
!
! <DESCRIPTION>
! Sends a buffer to an adjoining PE
! </DESCRIPTION>
!
subroutine send_buffer(buffer)
  type(blob_buffer_type), pointer :: buffer
  integer :: nb, n_frac_steps
  if (buffer%pe /= NULL_PE) then
     call mpp_send(buffer%numblobs, plen=1, to_pe=buffer%pe)
     if (buffer%numblobs>0) then
        ! We cycle through the blobs because sending them en-mass can cause the
        ! program to hang.
        do nb=1,buffer%numblobs
           call mpp_send(buffer%integer_buff(:,nb), int_buff_size, buffer%pe)
           call mpp_send(buffer%real_buff(:,nb),    rea_buff_size, buffer%pe)

           n_frac_steps = buffer%integer_buff(7,nb)
           if (bitwise_reproduction) then
              call mpp_send(buffer%history_integer_buff(:,0:n_frac_steps,nb), hist_int_buff_size*(n_frac_steps+1), buffer%pe)
              call mpp_send(buffer%history_real_buff(:,0:n_frac_steps,nb),    (1+hist_rea_buff_size)*(n_frac_steps+1), buffer%pe)
           else
              call mpp_send(buffer%history_real_buff(:,1,nb), 1+hist_rea_buff_size, buffer%pe)
           endif
        enddo
     endif
  endif
end subroutine send_buffer
! </SUBROUTINE>  NAME="send_buffer"

!######################################################################
! <SUBROUTINE NAME="receive_buffer">
!
! <DESCRIPTION>
! Receives a buffer from an adjoining PE
! </DESCRIPTION>
!
subroutine receive_buffer(buffer)
  type(blob_buffer_type), pointer :: buffer
  integer :: nb, incoming, n_frac_steps
  if (buffer%pe /= NULL_PE) then
     call mpp_recv(incoming, glen=1, from_pe=buffer%pe)
     if (incoming>0) then
        if (incoming>buffer%size) then
           call increase_buffer(buffer,incoming)
        endif
        do nb=1,incoming
           call mpp_recv(buffer%integer_buff(:,nb), int_buff_size, buffer%pe)
           call mpp_recv(buffer%real_buff(:,nb),    rea_buff_size, buffer%pe)

           n_frac_steps = buffer%integer_buff(7,nb)
           if (bitwise_reproduction) then
              call mpp_recv(buffer%history_integer_buff(:,0:n_frac_steps,nb), hist_int_buff_size*(n_frac_steps+1), buffer%pe)
              call mpp_recv(buffer%history_real_buff(:,0:n_frac_steps,nb), (1+hist_rea_buff_size)*(n_frac_steps+1), buffer%pe)
           else
              call mpp_recv(buffer%history_real_buff(:,1,nb), 1+hist_rea_buff_size,buffer%pe)
           endif
        enddo
     endif
     buffer%numblobs = incoming
  endif
end subroutine receive_buffer
! </SUBROUTINE>  NAME="receive_buffer"

!######################################################################
! <SUBROUTINE NAME="clear_buffer">
!
! <DESCRIPTION>
! Clears the contents of a buffer
! </DESCRIPTION>
!
subroutine clear_buffer(buffer)
  type(blob_buffer_type), pointer :: buffer
  buffer%numblobs          = 0
  if (buffer%pe /= NULL_PE) then
     buffer%integer_buff(:,:) = 0
     buffer%real_buff(:,:)    = 0.0
     if(allocated(buffer%history_integer_buff)) buffer%history_integer_buff(:,:,:) = 0
     if(allocated(buffer%history_real_buff))    buffer%history_real_buff(:,:,:)    = 0.0
  endif
  !note, we do not clear buffer%size
end subroutine clear_buffer
! </SUBROUTINE>  NAME="clear_buffer"

end module ocean_blob_dynamic_bottom_mod

!FDOC_TAG_GFDL

                 module rh_based_clouds_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   fil
! </CONTACT>
! <REVIEWER EMAIL="">
!   
! </REVIEWER>
! <OVERVIEW>
!           module which defines cloud locations
!                     based on model relative humidity
!   
! </OVERVIEW>
! <DESCRIPTION>
!   
! </DESCRIPTION>
!

use mpp_mod,           only: input_nml_file
use fms_mod,           only: fms_init, open_namelist_file, mpp_pe, &
                             mpp_root_pe, stdlog,  &
                             write_version_number, file_exist, & 
                             check_nml_error, error_mesg,   &
                             FATAL, close_file
use rh_clouds_mod,     only: rh_clouds_avg      
use rad_utilities_mod, only: rad_utilities_init, &
                             cldrad_properties_type, &
                             cld_specification_type
use constants_mod,     only: radian
                                 

!--------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!           module which defines cloud locations
!                     based on model relative humidity
!
!--------------------------------------------------------------------



!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------

  character(len=128)  :: version =  '$Id: rh_based_clouds.F90,v 19.0 2012/01/06 20:23:01 fms Exp $'
  character(len=128)  :: tagname =  '$Name: tikal $'



!---------------------------------------------------------------------
!-------  interfaces --------

public          &
          rh_based_clouds_init,  &
          rh_clouds_amt,  &
          obtain_bulk_lw_rh, obtain_bulk_sw_rh, &
          rh_based_clouds_end, &
          cldalb, albcld_lw, albcld_sw




!---------------------------------------------------------------------
!-------- namelist  ---------


character(len=8)             :: cirrus_cld_prop_form  = 'full'

!    logical variables derived from namelist input

logical                      :: do_part_black_cirrus=.false.
logical                      :: do_full_black_cirrus=.false.






namelist /rh_based_clouds_nml /     &
       cirrus_cld_prop_form


!----------------------------------------------------------------------
!----  public data -------


!----------------------------------------------------------------------
!----  private data -------

!--------------------------------------------------------------------
!     define radiative properties for low, middle and high clouds
!     indices 1, 2 and 3, respectively).
!     cldem     : infrared emissivity
!     crfvis    : visible band reflectivity
!     crfir     : near-ir band reflectivity
!     cabir     : near-ir band absorptivity
!     crz       : cloud fraction
!--------------------------------------------------------------------
 
integer, parameter             :: NOFCLDS_SP=3  

real, dimension(NOFCLDS_SP)    ::                                  &
  crfvis,     crfir,     cabir,  &
                                  cldem
real                           :: crz


data crfvis / 0.59E+00, 0.45E+00, 0.21E+00 /
data crfir  / 0.59E+00, 0.45E+00, 0.21E+00 /
data cabir  / 0.40E+00, 0.30E+00, 0.04E+00 /
data cldem  / 1.0E+00, 1.0E+00, 1.0E+00 /  
data crz    / 1.00 /                     

!---------------------------------------------------------------------

!--------------------------------------------------------------------
!     these arrays define the cloud reflectivities as a function of 
!     zenith angle and the radiation band (visible and infrared) for 
!     high, middle and low clouds.
!     NREFL_BDS = number of radiative bands over which reflectivities
!              are provided.
!     NANGS     = number of zenith angles at which reflectivity values
!              are given.
!--------------------------------------------------------------------
 
integer, parameter                    ::  NANGS=17
integer, parameter                    ::  NREFL_BDS=2
real, dimension(NANGS,NREFL_BDS)      ::  albch, albcm, albcl 
 

!---------------------------------------------------------------------
!     albedos for high clouds at zenith angles from 0-80 deg. at 5 deg.
!     intervals for 1) visible and 2) infrared radiation.
!---------------------------------------------------------------------

data albch /      &
                 .04,.05,.05,.05,.06,.06,.07,.07,.08,.11,.13,.16,.21,  &
                 .28,.39,.48,.61,                                     &
                 .04,.05,.05,.05,.06,.06,.07,.07,.08,.10,.11,.14,.19, &
                 .26,.35,.44,.55 /

!---------------------------------------------------------------------
!     albedos for middle clouds at zenith angles from 0-80 deg. at 5 deg
!     intervals for 1) visible and 2) infrared radiation.
!----------------------------------------------------------------------

data albcm /     &
               .18,.18,.19,.20,.21,.23,.24,.26,.29,.33,.37,.42,.47,  &
               .55,.64,.71,.79,                                      &
               .14,.14,.15,.16,.17,.18,.18,.20,.23,.25,.29,.32,.37, &
               .43,.50,.55,.61 /

!-----------------------------------------------------------------------
!     albedos for low clouds at zenith angles from 0-80 deg. at 5 deg
!     intervals for 1) visible and 2) infrared radiation.
!-----------------------------------------------------------------------

data albcl /     &
                .50,.50,.51,.51,.52,.53,.54,.56,.58,.62,.65,.67,.69, &
                .73,.78,.82,.86,                                     &
                .42,.42,.43,.43,.44,.45,.46,.48,.50,.52,.55,.57,.59, &
                .63,.66,.70,.74 /


 
!-------------------------------------------------------------------
!     this array defines the zenith angle dependent albedo for each of 
!     the different cloud types (NOFCLDS_SP) for each of the radiative 
!     bands (NREFL_BDS). currently NREFL_BDS are the visible and the
!     infrared.
!-------------------------------------------------------------------
 
real, dimension (NOFCLDS_SP,NREFL_BDS)  ::  zza 
 
!--------------------------------------------------------------------
!     these variables define the boundaries (in sigma coordinates) 
!     between high and middle and middle and low clouds at the poles
!     and at the equator. 
!--------------------------------------------------------------------

real    :: cldhp = 0.7E+00
real    :: cldhe = 0.4E+00
real    :: cldmp = 0.85E+00
real    :: cldme = 0.7E+00
!-----------------------------------------------------------------

! cloud is present when relative humidity >= rh_crit, which varies liearly
!   in sigma from rh_crit_top at sigma = 0 to rh_crit_bot at sigma = 1

real :: rh_crit_bot    = 1.00
real :: rh_crit_top    = 0.90

logical :: module_is_initialized = .false.

!----------------------------------------------------------------------
!----------------------------------------------------------------------




                           contains 


! <SUBROUTINE NAME="rh_based_clouds_init">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call rh_based_clouds_init
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine rh_based_clouds_init 



!--------------------------------------------------------------------
     integer :: unit, ierr, io, logunit


      if (module_is_initialized) return
      call fms_init
      call rad_utilities_init
!---------------------------------------------------------------------
!    read namelist.
!---------------------------------------------------------------------

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=rh_based_clouds_nml, iostat=io)
      ierr = check_nml_error(io,"rh_based_clouds_nml")
#else
      if (file_exist('input.nml')) then
        unit =  open_namelist_file (                          )
        ierr=1; do while (ierr /= 0)
        read (unit, nml=rh_based_clouds_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'rh_based_clouds_nml')
        enddo
10      call close_file (unit)
      endif
#endif

!----------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
           write (logunit, nml=rh_based_clouds_nml)

!--------------------------------------------------------------------
! define the "blackness" of the cirrus clouds. cirrus clouds are either 
! "part black" with emissivity of 0.6 or are "full black" with emis-
! sivity of 1.0
!--------------------------------------------------------------------
        if (trim(cirrus_cld_prop_form) == 'part') then
          do_part_black_cirrus = .true.
        else if (trim(cirrus_cld_prop_form) == 'full') then
          do_full_black_cirrus = .true.
        else
          call error_mesg( 'cloudrad_package_init',  &
                ' cirrus_cld_prop_form is not an acceptable value.', & 
                                                      FATAL)
        endif


       module_is_initialized = .true.

end subroutine rh_based_clouds_init

!####################################################################

! <SUBROUTINE NAME="rh_based_clouds_end">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call rh_based_clouds_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine rh_based_clouds_end

!----------------------------------------------------------------------
!    rh_based_clouds_end is the destructor for rh_based_cloouds_mod.
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!    mark the module as not initialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.

!--------------------------------------------------------------------


end subroutine rh_based_clouds_end



!######################################################################

! <SUBROUTINE NAME="rh_clouds_amt">
!  <OVERVIEW>
!    rh_clouds_amt defines the location, amount (cloud fraction), number
!    and type (hi, mid, low) of clouds present on the model grid.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    rh_clouds_amt defines the location, amount (cloud fraction), number
!    and type (hi, mid, low) of clouds present on the model grid.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call rh_clouds_amt (is, ie, js, je, press, lat, Cld_spec)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!   is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <IN NAME="press" TYPE="real">
!      press        pressure at model levels (1:nlev), surface
!                   pressure is stored at index value nlev+1
!                   [ (kg /( m s^2) ]
! 
!  </IN>
!  <IN NAME="lat" TYPE="real">
!      lat          latitude of model points  [ radians ]
! 
!  </IN>
!  <INOUT NAME="Cld_spec" TYPE="cld_specification_type">
!      Cld_spec     cld_specification_type variable containing the
!                   cloud specification input fields needed by the
!                   radiation package
!
!               the following elements of Cld_spec are defined here:
!
!                  %cmxolw  fraction of maximally overlapped clouds
!                           seen by the longwave radiation
!                           [ dimensionless ]
!                  %crndlw  fraction of randomly overlapped clouds
!                           seen by the longwave radiation
!                           [ dimensionless ]
!                  %camtsw  cloud fraction seen by the shortwave
!                           radiation; the sum of the maximally
!                           overlapped and randomly overlapped
!                           longwave cloud fractions  [ dimensionless ]
!                  %nmxolw  number of maximally overlapped longwave
!                           clouds in each grid column.
!                  %nrndlw  number of randomly overlapped longwave
!                           clouds in each grid column.
!                  %ncldsw  number of clouds seen by he shortwave
!                           radiation in each grid column.
!                  %hi_cld  logical flag indicating the presence of
!                           high clouds in a grid box
!                 %mid_cld  logical flag indicating the presence of
!                           middle clouds in a grid box
!                 %low_cld  logical flag indicating the presence of
!                           low clouds in a grid box
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine rh_clouds_amt (is, ie, js, je, press, lat, Cld_spec)

!----------------------------------------------------------------------
!    rh_clouds_amt defines the location, amount (cloud fraction), number
!    and type (hi, mid, low) of clouds present on the model grid.
!----------------------------------------------------------------------

integer,                      intent(in)    ::  is, ie, js, je
real,    dimension(:,:,:),    intent(in)    ::  press
real,    dimension(:,:),      intent(in)    ::  lat                    
type(cld_specification_type), intent(inout) ::  Cld_spec       

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      press        pressure at model levels (1:nlev), surface 
!                   pressure is stored at index value nlev+1
!                   [ (kg /( m s^2) ]
!      lat          latitude of model points  [ radians ]
!
!   intent(inout) variables:
!
!      Cld_spec     cld_specification_type variable containing the 
!                   cloud specification input fields needed by the 
!                   radiation package
!
!               the following elements of Cld_spec are defined here:
!
!                  %cmxolw  fraction of maximally overlapped clouds
!                           seen by the longwave radiation 
!                           [ dimensionless ]
!                  %crndlw  fraction of randomly overlapped clouds
!                           seen by the longwave radiation 
!                           [ dimensionless ]
!                  %camtsw  cloud fraction seen by the shortwave
!                           radiation; the sum of the maximally
!                           overlapped and randomly overlapped 
!                           longwave cloud fractions  [ dimensionless ]
!                  %nmxolw  number of maximally overlapped longwave 
!                           clouds in each grid column.
!                  %nrndlw  number of randomly overlapped longwave 
!                           clouds in each grid column.
!                  %ncldsw  number of clouds seen by he shortwave
!                           radiation in each grid column.
!                  %hi_cld  logical flag indicating the presence of 
!                           high clouds in a grid box
!                 %mid_cld  logical flag indicating the presence of 
!                           middle clouds in a grid box
!                 %low_cld  logical flag indicating the presence of 
!                           low clouds in a grid box
!                                                                  
!---------------------------------------------------------------------
 
!-------------------------------------------------------------------
!   local variables:
 
      real, dimension (size(press,1), size(press,2),    &
                       size(press,3)-1)   ::  ccover, rh, sigma

      real, dimension (size(lat,1), size(lat,2)) ::     &
                                                 cldhm, cldml, rh_crit

      logical   ::  inside_max_ovlp_cld
      integer   ::  kmax 
      integer   ::  ierr
      integer   ::  k, j, i

!----------------------------------------------------------------------
!   local variables:
!
!           ccover       cloud fraction in a grid box [ dimensinless ]
!           rh           relative humidity [ dimensionless ]
!           sigma        ratio of pressure to surface pressure 
!                        [ dimensionless ]
!           cldhm        sigma value to use as the transition between
!                        middle and high clouds [ dimensionless ]
!           cldml        sigma value to use as the transition between
!                        low and middle clouds [ dimensionless ]
!           rh_crit      value of relative humidity at which clouds 
!                        are assumed present, as a function of sigma
!                        [ dimensionless ]
!           inside_max_ovlp_cld
!                        logical flag indicating whether the model grid
!                        box under consideration is part of a maximum
!                        overlap cloud with its base below the current
!                        level
!           kmax         number of model layers
!           ierr         error flag returned from rh_clouds_mod, if 
!                        non-zero indicates that all or some of the 
!                        relative humidity field was not retrievable
!           i,j,k        do loop indices
!
!--------------------------------------------------------------------- 


!--------------------------------------------------------------------
!    define the number of model layers.
!----------------------------------------------------------------------
      kmax = size (Cld_spec%camtsw,3)

!---------------------------------------------------------------------
!    define the sigma values marking the transitions between high,
!    middle and low clouds.  it must be calculated in this routine 
!    because model latitudes are not available during initialization
!    phase in the bgrid model core.
!---------------------------------------------------------------------
      cldhm(:,:) = cldhp + (90.0E+00-abs(lat(:,:)*   &
                   radian))*(cldhe-cldhp)/90.0E+00
      cldml(:,:) = cldmp + (90.0E+00-abs(lat(:,:)*    &
                   radian))*(cldme-cldmp)/90.0E+00

!---------------------------------------------------------------------- 
!    call rh_clouds_avg to obtain the appropriate array of relative 
!    humidity to use in defining cloud locations. this may be the inst-
!    antaneous field from the last time step or the average field in the
!    interval from the previous call to rh_clouds_avg.
!----------------------------------------------------------------------
      call rh_clouds_avg (is, js, rh, ierr)

!----------------------------------------------------------------------
!    if relative humidity data was present in rh_clouds_mod and values 
!    have been returned, determine those grid points where the relative
!    humidity exceeds the critical value for that grid box. define a
!    non-zero cloud fraction for those boxes; other boxes are given a
!    zero cloud fraction. note that cloud is not allowed to be present
!    in the topmost layer.
!----------------------------------------------------------------------
      if (ierr ==  0) then
        ccover(:,:,1) = 0.0
        do k=2,kmax 
          do j=1,size(press,2)
            do i=1,size(press,1)
              sigma(i,j,k) = press(i,j,k)/press(i,j,kmax+1)
              rh_crit(i,j) = rh_crit_top + sigma(i,j,k)*  &
                                           (rh_crit_bot - rh_crit_top)
              if (rh(i,j,k) >= rh_crit(i,j))  then 
                ccover(i,j,k) = crz
              else 
                ccover(i,j,k) = 0.0
              endif     
            end do
          end do
        end do

!---------------------------------------------------------------------
!    if relative humidity data could not be returned, set the clouds
!    to zero everywhere. this is a valid occurrence on the first
!    time step of a run, when radiation is calculated prior to the
!    moist_processes physics, and so no relative humidity data is 
!    present. if it occurs after the first step, an error is likely
!    present.
!---------------------------------------------------------------------
      else
        ccover(:,:,:) = 0.0
      endif

!---------------------------------------------------------------------
!    define the cloud specification arrays used by rh_clouds -- cloud 
!    fractions for random and maximally overlapped clouds and total 
!    clouds, number of each type of cloud in each column, and flags to
!    indicate whether a given cloud is to be given high, middle or low 
!    cloud properties.
!---------------------------------------------------------------------
      do j=1,size(press,2)
        do i=1,size(press,1)

!--------------------------------------------------------------------
!    define an indicator as to whether the current level is part of a
!    maximum-overlap cloud with a base at a lower level. the lowest
!    level obviously is not.
!---------------------------------------------------------------------
          inside_max_ovlp_cld = .false.

!---------------------------------------------------------------------
!    move upwards from the surface to level 2, since clouds are not
!    allowed at the topmost model level.
!----------------------------------------------------------------------
          do k=kmax,2,-1

!---------------------------------------------------------------------
!    if inside_max_ovlp_cld is .false., then this level is not part of 
!    a multi-layer cloud with a cloud base at a lower level, either 
!    because it does not contain cloud or because it contains a single 
!    level cloud, or because it is the lowest model level.
!---------------------------------------------------------------------
            if (.not. inside_max_ovlp_cld) then

!---------------------------------------------------------------------
!    if there is cloud at this level, determine if cloud exists at the
!    level above. if it doesn't then this is a one layer cloud and it
!    is counted as a random overlap cloud. if cloud does exist at the
!    level above, then this is the lowest level of a multi-layer cloud,
!    and it is denoted as a maximum overlap cloud. the flag 
!    inside_max_ovlp_cld is set to .true. to indicate that the next 
!    level is within a maximum overlap cloud.
!---------------------------------------------------------------------
              if (ccover(i,j,k) .NE. 0.0E+00) then
                if (ccover(i,j,k-1) .EQ. 0.0E+00 ) then
                  Cld_spec%nrndlw(i,j) = Cld_spec%nrndlw(i,j) + 1
                  Cld_spec%crndlw(i,j,k) = ccover(i,j,k)
                else
                  inside_max_ovlp_cld = .true.
                  Cld_spec%cmxolw(i,j,k) = ccover(i,j,k)
                endif
              endif
!--------------------------------------------------------------------
!    if inside_max_ovlp_cld is .true., then the current level is 
!    contained within a multi-layer cloud (max overlap) with a cloud 
!    base at a lower level. define the cloud on this level as maximum 
!    overlap. the counter of maximum overlap clouds is incremented when 
!    either the model top (k = 2, since no clouds allowed at level 1) 
!    is reached, or the level above does not contain cloudiness. if the 
!    level above does not contain clouds, then the flag 
!    inside_max_ovlp_cld is set .false. to indicate that the level above
!    is not part of a maximum overlap cloud with a cloud base at a 
!    lower level.
!--------------------------------------------------------------------
            else
              Cld_spec%cmxolw(i,j,k) = ccover(i,j,k)
              if (k .EQ. 2) then
                Cld_spec%nmxolw(i,j) = Cld_spec%nmxolw(i,j) + 1
              endif
              if (ccover(i,j,k-1) .EQ. 0.0E+00) then
                Cld_spec%nmxolw(i,j) = Cld_spec%nmxolw(i,j) + 1
                inside_max_ovlp_cld = .false.
              endif
            endif

!---------------------------------------------------------------------
!    define the cloud fraction seen by the shortwave radiation as the 
!    sum of the random and maximum overlap cloud fractions.
!---------------------------------------------------------------------
            Cld_spec%camtsw(i,j,k) = Cld_spec%cmxolw(i,j,k) +  &
                                     Cld_spec%crndlw(i,j,k)

!----------------------------------------------------------------------
!    if cloud is present, it must be designated as high, middle or low
!    so that the grid box can be given the radiation characteristics of
!    that cloud type. the arrays cldhm and cldml define the sigma
!    boundaries of the different cloud types.
!----------------------------------------------------------------------
            if (Cld_spec%camtsw(i,j,k) > 0.0) then
              if (sigma(i,j,k) <= cldhm(i,j) ) then
                Cld_spec%hi_cloud(i,j,k) = .true.
              else if (sigma(i,j,k) > cldhm(i,j)  .and.  &
                       sigma(i,j,k) < cldml(i,j) ) then
                Cld_spec%mid_cloud(i,j,k) = .true.
              else if (sigma(i,j,k) >= cldml(i,j) ) then
                Cld_spec%low_cloud(i,j,k) = .true.
              endif
            endif
          end do

!-------------------------------------------------------------------
!      define the total number of clouds present in each column.
!-------------------------------------------------------------------
          Cld_spec%ncldsw(i,j) = Cld_spec%nmxolw(i,j) +   &
                                 Cld_spec%nrndlw(i,j)
        end do
      end do

!--------------------------------------------------------------------


end subroutine rh_clouds_amt 





!####################################################################

! <SUBROUTINE NAME="obtain_bulk_lw_rh">
!  <OVERVIEW>
!    obtain_bulk_lw_rh defines bulk longwave cloud radiative
!    properties for the rh cloud scheme.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    obtain_bulk_lw_rh defines bulk longwave cloud radiative
!    properties for the rh cloud scheme.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call obtain_bulk_lw_rh (is, ie, js, je, Cld_spec, Cldrad_props)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!      Cld_spec          cloud specification arrays defining the
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input
!                        to this subroutine
!                        [ cld_specification_type ]
! 
!  </IN>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output
!               from this routine:
!
!                    %emrndlw   longwave cloud emissivity for
!                               randomly overlapped clouds
!                               in each of the longwave
!                               frequency bands  [ dimensionless ]
!                    %emmxolw   longwave cloud emissivity for
!                               maximally overlapped clouds
!                               in each of the longwave
!                               frequency bands  [ dimensionless ]
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine obtain_bulk_lw_rh (is, ie, js, je, Cld_spec, Cldrad_props)

!---------------------------------------------------------------------
!    obtain_bulk_lw_rh defines bulk longwave cloud radiative 
!    properties for the rh cloud scheme.
!---------------------------------------------------------------------

integer,                     intent(in)     :: is, ie, js, je
type(cld_specification_type), intent(in   ) :: Cld_spec
type(cldrad_properties_type), intent(inout) :: Cldrad_props

!--------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!
!   intent(inout) variables:
!
!      Cld_spec          cloud specification arrays defining the 
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input 
!                        to this subroutine
!                        [ cld_specification_type ]
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output 
!               from this routine:
!
!                    %emrndlw   longwave cloud emissivity for 
!                               randomly overlapped clouds
!                               in each of the longwave 
!                               frequency bands  [ dimensionless ]
!                    %emmxolw   longwave cloud emissivity for 
!                               maximally overlapped clouds
!                               in each of the longwave 
!                               frequency bands  [ dimensionless ]
!
!---------------------------------------------------------------------


!------------------------------------------------------------------
!     call albcld_lw to define long-wave cloud emissivities.
!-------------------------------------------------------------------
        call albcld_lw (Cld_spec%hi_cloud, Cld_spec%mid_cloud,  &
                        Cld_spec%low_cloud, Cld_spec%cmxolw,  &
                        Cld_spec%crndlw,    &
                        Cldrad_props%emmxolw(:,:,:,:,1),  &
                        Cldrad_props%emrndlw(:,:,:,:,1))


end subroutine obtain_bulk_lw_rh



!######################################################################

! <SUBROUTINE NAME="obtain_bulk_sw_rh">
!  <OVERVIEW>
!    obtain_bulk_sw_rh defines bulk shortwave cloud radiative
!    properties for the rh cloud scheme.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    obtain_bulk_sw_rh defines bulk shortwave cloud radiative
!    properties for the rh cloud scheme.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call obtain_bulk_sw_rh (is, ie, js, je, cosz, Cld_spec,   &
!                Cldrad_props)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      is,ie,js,je  starting/ending subdomain i,j indices of data in
!                   the physics_window being integrated
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <IN NAME="cosz" TYPE="real">
!      cosz         cosine of the zenith angle [ dimensionless ]
! 
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
!      Cld_spec          cloud specification arrays defining the
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input
!                        to this subroutine
!                        [ cld_specification_type ]
! 
!  </IN>
!  <INOUT NAME="Cldrad_props" TYPE="cldrad_properties_type">
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output
!               from this routine:
!
!                    %cirabsw   absorptivity of clouds in the
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cirrfsw   reflectivity of clouds in the
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cvisrfsw  reflectivity of clouds in the
!                               visible frequency band
!                               [ dimensionless ]
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine obtain_bulk_sw_rh (is, ie, js, je, cosz, Cld_spec,   &
                              Cldrad_props)

!---------------------------------------------------------------------
!    obtain_bulk_sw_rh defines bulk shortwave cloud radiative 
!    properties for the rh cloud scheme.
!---------------------------------------------------------------------
 
integer,                      intent(in)    :: is, ie, js, je
real,    dimension(:,:),      intent(in)    :: cosz
type(cld_specification_type), intent(in   ) :: Cld_spec
type(cldrad_properties_type), intent(inout) :: Cldrad_props

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      is,ie,js,je  starting/ending subdomain i,j indices of data in 
!                   the physics_window being integrated
!      cosz         cosine of the zenith angle [ dimensionless ]
!
!   intent(inout) variables:
!
!      Cld_spec          cloud specification arrays defining the 
!                        location, amount and type (hi, middle, lo)
!                        of clouds that are present, provides input 
!                        to this subroutine
!                        [ cld_specification_type ]
!      Cldrad_props      cloud radiative properties on model grid,
!                        [ cldrad_properties_type ]
!
!               the following components of this variable are output 
!               from this routine:
!
!                    %cirabsw   absorptivity of clouds in the 
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cirrfsw   reflectivity of clouds in the 
!                               infrared frequency band
!                               [ dimensionless ]
!                    %cvisrfsw  reflectivity of clouds in the 
!                               visible frequency band
!                               [ dimensionless ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    local variables:

      integer      ::  j, i  ! do-loop indices
 
!-------------------------------------------------------------------
!    define the bulk sw cloud radiative properties at each grid point 
!    which contains cloud.
!-------------------------------------------------------------------
      do j=1,size(Cld_spec%ncldsw,2)          
        do i=1,size(Cld_spec%ncldsw,1)          
          if (Cld_spec%ncldsw(i,j) > 0 ) then

!-----------------------------------------------------------------------
!    call cldalb to define the zenith angle dependent cloud visible
!    and infrared reflectivities for high, middle and low clouds in
!    each model column containing cloud.
!-----------------------------------------------------------------------
            call cldalb (cosz(i,j))

!-----------------------------------------------------------------------
!    call albcld_sw to assign the zenith-angle-dependent visible and 
!    infrared reflectivities and infrared absorptivities to the model 
!    clouds in the current column.
!-----------------------------------------------------------------------
            call albcld_sw (i, j, Cld_spec%hi_cloud, &
                            Cld_spec%mid_cloud, Cld_spec%low_cloud,  &
                            Cld_spec%camtsw, Cld_spec%cmxolw,   &
                            Cld_spec%crndlw, Cldrad_props%cvisrfsw, &
                            Cldrad_props%cirrfsw, Cldrad_props%cirabsw)
          endif
        end do
      end do

!----------------------------------------------------------------------
 

 end subroutine obtain_bulk_sw_rh



!####################################################################

! <SUBROUTINE NAME="cldalb">
!  <OVERVIEW>
!     cldalb calculates a zenith angle dependency for the cloud albedos.
!     the cloud albedos are interpolated using data adapted from fritz
!     (1954).  the solar zenith angle is the only input required.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!     cldalb calculates a zenith angle dependency for the cloud albedos.
!     the cloud albedos are interpolated using data adapted from fritz
!     (1954).  the solar zenith angle is the only input required.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call cldalb (zenith)
!
!  </TEMPLATE>
!  <IN NAME="zenith" TYPE="real">
!   zenith angle
!  </IN>
! </SUBROUTINE>
!
subroutine cldalb (zenith)

!---------------------------------------------------------------------
!     cldalb calculates a zenith angle dependency for the cloud albedos.
!     the cloud albedos are interpolated using data adapted from fritz 
!     (1954).  the solar zenith angle is the only input required.
!-----------------------------------------------------------------------

real, intent(in)           ::  zenith

!--------------------------------------------------------------------
      real                 :: zangle, remain
      integer              :: nband, indx

!--------------------------------------------------------------------
!     define zenith angle in degrees. for original Skyhi results, use 
!     a zenith angle specified as 60.00001 and the skyhi albedo values.
!-----------------------------------------------------------------------

        zangle = ACOS(zenith)*radian

!-----------------------------------------------------------------------
!     define reflectivities for each cloud level.
!-----------------------------------------------------------------------
        if (zangle .GE. 80.0E+00) then
!-----------------------------------------------------------------------
!     if zenith angle is greater than 80 degrees, define the reflect-
!     ivities as those values in the table at 80 degrees (last entry).
!-----------------------------------------------------------------------
          do nband=1,NREFL_BDS
            zza(3,nband) = albch(NANGS,nband)
            zza(2,nband) = albcm(NANGS,nband)
            zza(1,nband) = albcl(NANGS,nband)
          end do  
        else
!-----------------------------------------------------------------------
!     if zenith angle is less than 80 degrees, interpolate albedos from 
!     tables for each cloud level.
!-----------------------------------------------------------------------
          indx   = IFIX(zangle/5.0E+00) + 1
          remain = AMOD(zangle, 5.0E+00)
          do nband=1,NREFL_BDS
            zza(3,nband) = albch(indx,nband) + (remain/5.0E+00)*  &
                           (albch(indx+1,nband) - albch(indx,nband))
            zza(2,nband) = albcm(indx,nband) + (remain/5.0E+00)*  &
                           (albcm(indx+1,nband) - albcm(indx,nband))
            zza(1,nband) = albcl(indx,nband) + (remain/5.0E+00)*   &
                           (albcl(indx+1,nband) - albcl(indx,nband))
          end do 
        endif



end subroutine cldalb




!##################################################################

! <SUBROUTINE NAME="albcld_lw">
!  <OVERVIEW>
!     albcld_lw computes the lw cloud emissivities. This calculation is
!     based on sigma and cloud thickness in the old scheme (cldht60)
!     and sigma, cloud thickness and latitude in the new scheme
!     (cldht93).
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!     albcld_lw computes the lw cloud emissivities. This calculation is
!     based on sigma and cloud thickness in the old scheme (cldht60)
!     and sigma, cloud thickness and latitude in the new scheme
!     (cldht93).
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call albcld_lw(hi_cloud, mid_cloud, low_cloud,       &
!                cmxolw, crndlw, emmxolw, emrndlw)
!
!  </TEMPLATE>
!  <IN NAME="hi_cloud" TYPE="logical">
! 
!  </IN>
!  <IN NAME="mid_cloud" TYPE="logical">
! 
!  </IN>
!  <IN NAME="low_cloud" TYPE="logical">
! 
!  </IN>
!  <IN NAME="cmxolw" TYPE="real">
! 
!  </IN>
!  <IN NAME="crndlw" TYPE="real">
! 
!  </IN>
!  <INOUT NAME="emmxolw" TYPE="real">
! 
!  </INOUT>
!  <INOUT NAME="emrndlw" TYPE="real">
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine albcld_lw(hi_cloud, mid_cloud, low_cloud,       &
             cmxolw, crndlw, emmxolw, emrndlw)

!-----------------------------------------------------------------------
!     albcld_lw computes the lw cloud emissivities. This calculation is 
!     based on sigma and cloud thickness in the old scheme (cldht60) 
!     and sigma, cloud thickness and latitude in the new scheme 
!     (cldht93).
!-----------------------------------------------------------------------

real, dimension(:,:,:),   intent(in)    :: cmxolw, crndlw
real, dimension(:,:,:,:), intent(inout) :: emmxolw, emrndlw
logical, dimension(:,:,:),intent(in)    :: hi_cloud, mid_cloud,   &
   low_cloud

!---------------------------------------------------------------------
!    local variables
!---------------------------------------------------------------------

       integer  ::  i, j, k, kk
      integer  :: israd, ierad, jsrad, jerad, ksrad, kerad
      israd= 1
      jsrad= 1
      ksrad= 1
      ierad = size (cmxolw,1)
      jerad = size (cmxolw,2)
      kerad = size (cmxolw,3)

!-----------------------------------------------------------------------
!     compute the emissivities for each cloud in the column. 
!-----------------------------------------------------------------------

         do k=KSRAD,KERAD
   do j=JSRAD,JERAD
     do i=ISRAD,IERAD
               if ((cmxolw(i,j,k) + crndlw(i,j,k) ) > 0.0) then
!-----------------------------------------------------------------------
!     case of a thick cloud. note that thick cloud properties are deter-
!     mined by the height of the base of the thick cloud, so that if 
!     there are two adjacent cirrus level clouds, they are assigned
!     cirrus cloud properties, incontrast to the cldht60 treatment.
!-----------------------------------------------------------------------
                 if (cmxolw(i,j,k) .NE. 0.0E+00) then
!-----------------------------------------------------------------------
!     case of a thick high cloud.
!-----------------------------------------------------------------------
                   if (hi_cloud(i,j,k)) then
                       emmxolw(i,j,k,:) = cldem(3)*0.6
!-----------------------------------------------------------------------
!     case of a thick middle cloud.
!-----------------------------------------------------------------------
                   else if (mid_cloud(i,j,k)) then
             emmxolw(i,j,k,:) = cldem(2)
!-----------------------------------------------------------------------
!     case of a thick low cloud.
!-----------------------------------------------------------------------
                   else if (low_cloud (i,j,k)) then
             emmxolw(i,j,k,:) = cldem(1)
                   endif
                 endif
         if (crndlw(i,j,k) .NE. 0.0E+00) then
!-----------------------------------------------------------------------
!     case of a thin high cloud.
!-----------------------------------------------------------------------
                   if (hi_cloud(i,j,k)) then
             if (do_full_black_cirrus) then
                       emrndlw(i,j,k,:) = cldem(3)
             else if (do_part_black_cirrus) then
               emrndlw(i,j,k,:) = 0.6E+00*cldem(3)
             endif
!-----------------------------------------------------------------------
!     case of a thin middle cloud.
!-----------------------------------------------------------------------
                   else if (mid_cloud(i,j,k)) then 
             emrndlw(i,j,k,:) = cldem(2)
!-----------------------------------------------------------------------
!     case of a thin low cloud.
!-----------------------------------------------------------------------
                   else if (low_cloud(i,j,k)) then
             emrndlw(i,j,k,:) = cldem(1)
           endif
                 endif
       endif
             end do     
           end do
         end do
!------------------------------------------------------------------
!! for fms formulation, set thick cloud properties based on cloud base,
!  even if some cloud layers extend out of the cloud base type region
!-------------------------------------------------------------------

           do k=KERAD,KSRAD+1,-1
     do j=JSRAD,JERAD
       do i=ISRAD,IERAD
                 if (cmxolw(i,j,k) /= 0.0) then
                   kk = k-1
                   if (cmxolw(i,j,kk) /= 0.0) then
                     emmxolw(i,j,kk,:) = emmxolw(i,j,k,:)
                   endif
                 endif
               end do
             end do
           end do
     
 
end subroutine albcld_lw


!####################################################################

! <SUBROUTINE NAME="albcld_sw">
!  <OVERVIEW>
!     albcld_sw computes the cloud albedos. This calculation is based on
!     sigma and cloud thickness in the old scheme (cldht60) and sigma,
!     cloud thickness  and latitude in the new scheme (cldht93).
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!     albcld_sw computes the cloud albedos. This calculation is based on
!     sigma and cloud thickness in the old scheme (cldht60) and sigma,
!     cloud thickness  and latitude in the new scheme (cldht93).
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call albcld_sw(i,j, hi_cloud, mid_cloud, low_cloud,         &
!                camtsw, cmxolw, crndlw, cvisrfsw, cirrfsw, cirabsw)
!
!  </TEMPLATE>
!  <INOUT NAME="i" TYPE="real">
! 
!  </INOUT>
!  <IN NAME="j" TYPE="integer">
! 
!  </IN>
!  <IN NAME="hi_cloud" TYPE="logical">
! 
!  </IN>
!  <IN NAME="mid_cloud" TYPE="logical">
! 
!  </IN>
!  <IN NAME="low_cloud" TYPE="logical">
! 
!  </IN>
!  <IN NAME="camtsw" TYPE="real">
! 
!  </IN>
!  <IN NAME="cmxolw" TYPE="real">
! 
!  </IN>
!  <IN NAME="crndlw" TYPE="real">
! 
!  </IN>
!  <INOUT NAME="cvisrfsw" TYPE="real">
! 
!  </INOUT>
!  <INOUT NAME="cirrfsw" TYPE="real">
! 
!  </INOUT>
!  <INOUT NAME="cirabsw" TYPE="real">
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine albcld_sw(i,j, hi_cloud, mid_cloud, low_cloud,         &
     camtsw, cmxolw, crndlw, cvisrfsw, cirrfsw, cirabsw)

!-----------------------------------------------------------------------
!     albcld_sw computes the cloud albedos. This calculation is based on
!     sigma and cloud thickness in the old scheme (cldht60) and sigma, 
!     cloud thickness  and latitude in the new scheme (cldht93).
!-----------------------------------------------------------------------

!real, dimension(:,:,:),   intent(inout) :: camtsw, cmxolw, crndlw
real, dimension(:,:,:),   intent(in) :: camtsw, cmxolw, crndlw
real, dimension(:,:,:), intent(inout) :: cvisrfsw, cirrfsw, cirabsw
logical, dimension(:,:,:),intent(in)    :: hi_cloud, mid_cloud,   &
   low_cloud
integer,                  intent(in)    :: i, j
!---------------------------------------------------------------------

       integer  ::  k,  kk

      integer  :: israd, ierad, jsrad, jerad, ksrad, kerad

      israd = 1
      jsrad = 1
      ksrad = 1
      ierad = size (camtsw,1)
      jerad = size (camtsw,2)
      kerad = size (camtsw,3)
!-----------------------------------------------------------------------
!     compute the reflectivities and absorptivities for each cloud in 
!     the column. cldhm and cldml are sigma levels which serve as 
!     boundaries between low, middle and high clouds. 
!-----------------------------------------------------------------------
         do k=KSRAD+1,KERAD
           if (camtsw(i,j,k) .NE. 0.0E+00) then
!-----------------------------------------------------------------------
!     case of a thick cloud. note that thick cloud properties are deter-
!     mined by the height of the base of the thick cloud, so that if 
!     there are two adjacent cirrus level clouds, they are assigned
!     cirrus cloud properties.
!-----------------------------------------------------------------------
             if (cmxolw(i,j,k) .NE. 0.0E+00) then
!-----------------------------------------------------------------------
!     case of a thick high cloud.
!-----------------------------------------------------------------------
               if (hi_cloud(i,j,k)) then
                 cvisrfsw(i,j,k) = zza(3,1)
                 cirrfsw(i,j,k) = zza(3,2)
                   cirabsw(i,j,k) = MIN(0.99-cirrfsw(i,j,k), &
                                            cabir(3) )

!-----------------------------------------------------------------------
!     case of a thick middle cloud.
!-----------------------------------------------------------------------
               else if (mid_cloud(i,j,k)) then
                 cvisrfsw(i,j,k) = zza(2,1)
                 cirrfsw(i,j,k) = zza(2,2)
                   cirabsw(i,j,k) = MIN(0.99-cirrfsw(i,j,k), &
                                            cabir(2) )

!-----------------------------------------------------------------------
!     case of a thick low cloud.
!-----------------------------------------------------------------------
               else if (low_cloud(i,j,k)) then
                 cvisrfsw(i,j,k) = zza(1,1)
                 cirrfsw(i,j,k) = zza(1,2)
                   cirabsw(i,j,k) = MIN(0.99-cirrfsw(i,j,k), &
                                    cabir(1) )
               endif
             endif
     if (crndlw(i,j,k) .NE. 0.0E+00) then

!-----------------------------------------------------------------------
!     case of a thin high cloud.
!-----------------------------------------------------------------------
               if (hi_cloud(i,j,k)) then
                 cvisrfsw(i,j,k) = zza(3,1)
                 cirrfsw(i,j,k) = zza(3,2)
                   cirabsw(i,j,k) = MIN(0.99-cirrfsw(i,j,k), &
                                            cabir(3) )

!-----------------------------------------------------------------------
!     case of a thin middle cloud.
!-----------------------------------------------------------------------
               else if (mid_cloud(i,j,k))  then
                 cvisrfsw(i,j,k) = zza(2,1)
                 cirrfsw(i,j,k) = zza(2,2)
                   cirabsw(i,j,k) = MIN(0.99-cirrfsw(i,j,k), &
                                            cabir(2) )

!-----------------------------------------------------------------------
!     case of a thin low cloud.
!-----------------------------------------------------------------------
               else if (low_cloud(i,j,k)) then
                 cvisrfsw(i,j,k) = zza(1,1)
                 cirrfsw(i,j,k) = zza(1,2)
                   cirabsw(i,j,k) = MIN(0.99-cirrfsw(i,j,k), &
                                            cabir(1) )
               endif
             endif
           endif
         end do     

!------------------------------------------------------------------
!! for fms formulation, set thick cloud properties based on cloud base,
!  even if some cloud layers extend out of the cloud base type region
!-------------------------------------------------------------------
           do k=KERAD,KSRAD+1,-1
             if (cmxolw(i,j,k) /= 0.0) then
               kk = k-1
               if (cmxolw(i,j,kk) /= 0.0) then
                 cvisrfsw(i,j,kk) = cvisrfsw(i,j,k)
                 cirrfsw(i,j,kk) = cirrfsw(i,j,k)
                 cirabsw(i,j,kk) = cirabsw(i,j,k)
               endif
             endif
           end do
     
 
end subroutine albcld_sw



       end module rh_based_clouds_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The dynamic epsilon-equation \label{sec:dissipationeq}
!
! !INTERFACE:
   subroutine dissipationeq(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)

! !DESCRIPTION:
! The $k$-$\epsilon$ model in its form suggested by \cite{Rodi87} has been
! implemented in GOTM.
! In this model, the rate of dissipation is balanced according to
! \begin{equation}
!   \label{dissipation}
!   \dot{\epsilon}
!   =
!   {\cal D}_\epsilon
!   + \frac{\epsilon}{k} ( c_{\epsilon 1} P + c_{\epsilon 3} G
!                        - c_{\epsilon 2} \epsilon )
!   \comma
! \end{equation}
! where $\dot{\epsilon}$ denotes the material derivative of $\epsilon$.
! The production terms $P$ and $G$ follow from \eq{PandG} and
! ${\cal D}_\epsilon$ represents the sum of the viscous and turbulent
! transport terms.
!
! For horizontally homogeneous flows, the transport term ${\cal D}_\epsilon$
! appearing in \eq{dissipation} is presently expressed by a simple
! gradient formulation,
! \begin{equation}
!   \label{diffusionEps}
!   {\cal D}_\epsilon = \frstder{z}
!    \left( \dfrac{\nu_t}{\sigma_\epsilon} \partder{\epsilon}{z} \right)
!  \comma
! \end{equation}
! where $\sigma_\epsilon$ is the constant Schmidt-number for $\epsilon$.
!
! It should be pointed out that not all authors retain the buoyancy term
! in \eq{dissipation}, see e.g.\ \cite{GibsonLaunder76}.  Similar to the
! model of \cite{MellorYamada82}, \cite{Craftetal96a} set
! $c_{\epsilon 1}=c_{\epsilon 3}$.
! However, in both cases, the $k$-$\epsilon$ model cannot
! predict a proper state of full equilibrium in stratified flows at a
! predefined value of the Richardson number (see
! \cite{Umlaufetal2003} and discussion around \eq{Ri_st}). Model constants are
! summarised in \tab{tab:KE_constants}.
! \begin{table}[ht]
!   \begin{center}
! \begin{tabular}{cccccc}
!     & $c_\mu^0$ & $\sigma_k$  & $\sigma_\epsilon$
!     & $c_{\epsilon 1}$ & $c_{\epsilon 2}$  \\[1mm] \hline
!     \cite{Rodi87} & $0.5577$ & $1.0$ &  $1.3$ & $1.44$ & $1.92$ \\
!   \end{tabular}
!   \caption{\label{tab:KE_constants} Constants appearing in
!    \eq{dissipation} and \eq{epsilon}.}
!   \end{center}
! \end{table}
!
! At the end of this routine the length-scale can be constrained according to a
! suggestion of \cite{Galperinetal88}. This feature is optional and can be activated
! by setting {\tt length\_lim = .true.} in {\tt gotmturb.nml}.
!
! !USES:
   use turbulence, only: P,B,num
   use turbulence, only: tke,tkeo,k_min,eps,eps_min,L
   use turbulence, only: ce1,ce2,ce3plus,ce3minus
   use turbulence, only: cm0,cde,galp,length_lim
   use turbulence, only: epsilon_bc, psi_ubc, psi_lbc, ubc_type, lbc_type
   use turbulence, only: sig_e,sig_e0,sig_peps
   use util,       only: Dirichlet,Neumann

   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer,  intent(in)                :: nlev

!  time step (s)
   REALTYPE, intent(in)                :: dt

!  surface and bottom
!  friction velocity (m/s)
   REALTYPE, intent(in)                :: u_taus,u_taub

!  surface and bottom
!  roughness length (m)
   REALTYPE, intent(in)                :: z0s,z0b

!  layer thickness (m)
   REALTYPE, intent(in)                :: h(0:nlev)

!  square of shear and buoyancy
!  frequency (1/s^2)
   REALTYPE, intent(in)                :: NN(0:nlev),SS(0:nlev)
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!                     (re-write after first version of
!                      H. Burchard and K. Bolding

!
!  $Log: dissipationeq.F90,v $
!  Revision 20.0  2013/12/14 00:13:37  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.10  2007-01-06 11:49:15  kbk
!  namelist file extension changed .inp --> .nml
!
!  Revision 1.9  2005/11/15 11:35:02  lars
!  documentation finish for print
!
!  Revision 1.8  2005/11/03 20:53:37  hb
!  Patankar trick reverted to older versions for
!  stabilising 3D computations
!
!  Revision 1.7  2005/08/11 13:11:50  lars
!  Added explicit loops for diffusivities for 3-D z-level support.
!  Thanks to Vicente Fernandez.
!
!  Revision 1.6  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.5  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.4  2003/03/10 13:43:42  lars
!  double definitions removed - to conform with DEC compiler
!
!  Revision 1.3  2003/03/10 09:02:04  gotm
!  Added new Generic Turbulence Model +
!  improved documentation and cleaned up code
!
!
!EOP
!
! !LOCAL VARIABLES:
   REALTYPE                  :: DiffEpsup,DiffEpsdw,pos_bc
   REALTYPE                  :: prod,buoyan,diss
   REALTYPE                  :: prod_pos,prod_neg,buoyan_pos,buoyan_neg
   REALTYPE                  :: ki,epslim,peps,EpsOverTke,NN_pos
   REALTYPE                  :: cnpar=_ONE_
   REALTYPE                  :: avh(0:nlev),sig_eff(0:nlev)
   REALTYPE                  :: Lsour(0:nlev),Qsour(0:nlev)
   REALTYPE                  :: ce3

   integer                   :: i
!
!------------------------------------------------------------------------
!BOC
!
!  Determination of the turbulent Schmidt number for the Craig & Banner (1994)
!  parameterisation for breaking surface waves suggested by Burchard (2001):

   if (sig_peps) then          ! With wave breaking
      sig_eff(nlev)=sig_e0
      do i=1,nlev-1
         peps=(P(i)+B(i))/eps(i)
         if (peps .gt. 1.) peps=_ONE_
         sig_eff(i)=peps*sig_e+(_ONE_-peps)*sig_e0
      end do
      sig_eff(0)=sig_e
   else                        ! No wave breaking
      do i=1,nlev-1
         sig_eff(i)=sig_e
      enddo
   end if

!  compute RHS
   do i=1,nlev-1

!     compute epsilon diffusivity
      avh(i) = num(i)/sig_eff(i)

!     compute production terms in eps-equation
      if (B(i).gt.0) then
         ce3=ce3plus
      else
         ce3=ce3minus
      end if

      EpsOverTke  = eps(i)/tkeo(i)
      prod        = ce1*EpsOverTke*P(i)
      buoyan      = ce3*EpsOverTke*B(i)
      diss        = ce2*EpsOverTke*eps(i)

      if (prod+buoyan.gt.0) then
         Qsour(i)  = prod+buoyan
         Lsour(i) = -diss/eps(i)
      else
         Qsour(i)  = prod
         Lsour(i) = -(diss-buoyan)/eps(i)
      end if

   end do


!  TKE and position for upper BC
   if (psi_ubc.eq.Neumann) then
!     tke at center "nlev"
      ki = tke(nlev-1)

!     flux at center "nlev"
      pos_bc = 0.5*h(nlev)
   else
!     tke at face "nlev-1"
      ki = tke(nlev-1)

!     value at face "nlev-1"
      pos_bc = h(nlev)
   end if

!  obtain BC for upper boundary of type "ubc_type"
   DiffEpsup  = epsilon_bc(psi_ubc,ubc_type,pos_bc,ki,z0s,u_taus)


!  TKE and position for lower BC
   if (psi_lbc.eq.Neumann) then
!     tke at center "1"
      ki = tke(1)

!     flux at center "1"
      pos_bc = 0.5*h(1)
   else
!     tke at face "1"
      ki = tke(1)

!     value at face "1"
      pos_bc = h(1)
   end if

!  obtain BC for lower boundary of type "lbc_type"
   DiffEpsdw  = epsilon_bc(psi_lbc,lbc_type,pos_bc,ki,z0b,u_taub)


!  do diffusion step
   call diff_face(nlev,dt,cnpar,h,psi_ubc,psi_lbc,                          &
                  DiffEpsup,DiffEpsdw,avh,Lsour,Qsour,eps)


!  fill top and bottom value with something nice
!  (only for output)
   eps(nlev)  = epsilon_bc(Dirichlet,ubc_type,z0s,tke(nlev),z0s,u_taus)
   eps(0   )  = epsilon_bc(Dirichlet,lbc_type,z0b,tke(0   ),z0b,u_taub)

!  clip at eps_min
   do i=0,nlev
      eps(i) = max(eps(i),eps_min)
   enddo

!  limit dissipation rate under stable stratification,
!  see Galperin et al. (1988)
   if (length_lim) then
      do i=0,nlev

 !       look for N^2 > 0
         NN_pos = 0.5*( NN(i) + abs( NN(i) ) )

!        compute limit
         epslim = cde/sqrt(2.)/galp*tke(i)*sqrt(NN_pos)

!        clip at limit
         eps(i) = max(eps(i),epslim)

      end do
   endif

      do i=0,nlev
!        compute dissipative scale
         L(i) = cde*sqrt(tke(i)*tke(i)*tke(i))/eps(i)
      enddo

   return
   end subroutine dissipationeq
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

                    module moist_proc_utils_mod

!-----------------------------------------------------------------------
!
!         interface module for moisture processes
!         ---------------------------------------
!             moist convective adjustment
!             relaxed arakawa-schubert
!             donner deep convection
!             large-scale condensation
!             stratiform prognostic cloud scheme 
!             rel humidity cloud scheme 
!             diagnostic cloud scheme 
!             lin cloud microphysics
!             betts-miller convective adjustment
!
!-----------------------------------------------------------------------

use  sat_vapor_pres_mod, only: compute_qs, lookup_es
use    time_manager_mod, only: time_type
use    diag_manager_mod, only: send_data
use       constants_mod, only: RDGAS, RVGAS

implicit none
private

!------------------ private and public data/interfaces -----------------

public   capecalcnew, tempavg, column_diag, rh_calc

private  column_diag_1, column_diag_2, column_diag_3

interface column_diag
  module procedure column_diag_1, column_diag_2, column_diag_3
end interface column_diag


!--------------------- version number ----------------------------------
character(len=128) :: &
version = '$Id: moist_processes_utils.F90,v 19.0 2012/01/06 20:10:44 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!-----------------------------------------------------------------------

real, public, allocatable, dimension(:,:,:) :: pmass

                             contains

!#######################################################################

      subroutine tempavg (pdepth,phalf,temp,tsnow,mask)

!-----------------------------------------------------------------------
!
!    computes a mean atmospheric temperature for the bottom
!    "pdepth" pascals of the atmosphere.
!
!   input:  pdepth     atmospheric layer in pa.
!           phalf      pressure at model layer interfaces
!           temp       temperature at model layers
!           mask       data mask at model layers (0.0 or 1.0)
!
!   output:  tsnow     mean model temperature in the lowest
!                      "pdepth" pascals of the atmosphere
!
!-----------------------------------------------------------------------
      real, intent(in)  :: pdepth
      real, intent(in) , dimension(:,:,:) :: phalf,temp
      real, intent(out), dimension(:,:)   :: tsnow
      real, intent(in) , dimension(:,:,:), optional :: mask
!-----------------------------------------------------------------------
 real, dimension(size(temp,1),size(temp,2)) :: prsum, done, pdel, pdep
 real  sumdone
 integer  k
!-----------------------------------------------------------------------

      tsnow=0.0; prsum=0.0; done=1.0; pdep=pdepth

      do k=size(temp,3),1,-1

         if (present(mask)) then
           pdel(:,:)=(phalf(:,:,k+1)-phalf(:,:,k))*mask(:,:,k)*done(:,:)
         else
           pdel(:,:)=(phalf(:,:,k+1)-phalf(:,:,k))*done(:,:)
         endif

         where ((prsum(:,:)+pdel(:,:))  >  pdep(:,:))
            pdel(:,:)=pdepth-prsum(:,:)
            done(:,:)=0.0
            pdep(:,:)=0.0
         endwhere

         tsnow(:,:)=tsnow(:,:)+pdel(:,:)*temp(:,:,k)
         prsum(:,:)=prsum(:,:)+pdel(:,:)

         sumdone=sum(done(:,:))
         if (sumdone < 1.e-4) exit

      enddo

         tsnow(:,:)=tsnow(:,:)/prsum(:,:)

!-----------------------------------------------------------------------

      end subroutine tempavg

!#######################################################################
!cape calculation.
                                                                                
subroutine capecalcnew(kx,p,phalf,cp,rdgas,rvgas,hlv,kappa,tin,rin,&
                                avgbl,cape,cin)
                                                                                
!
!    Input:
!
!    kx          number of levels
!    p           pressure (index 1 refers to TOA, index kx refers to surface)
!    phalf       pressure at half levels
!    cp          specific heat of dry air
!    rdgas       gas constant for dry air
!    rvgas       gas constant for water vapor (used in Clausius-Clapeyron,
!                not for virtual temperature effects, which are not considered)
!    hlv         latent heat of vaporization
!    kappa       the constant kappa
!    tin         temperature of the environment
!    rin         specific humidity of the environment
!    avgbl       if true, the parcel is averaged in theta and r up to its LCL
!
!    Output:
!    cape        Convective available potential energy
!    cin         Convective inhibition (if there's no LFC, then this is set
!                to zero)
!
!    Algorithm:
!    Start with surface parcel.
!    Calculate the lifting condensation level (uses an analytic formula and a
!       lookup table).
!    Average under the LCL if desired, if this is done, then a new LCL must
!       be calculated.
!    Calculate parcel ascent up to LZB.
!    Calculate CAPE and CIN.
      implicit none
      integer, intent(in)                    :: kx
      logical, intent(in)                    :: avgbl
      real, intent(in), dimension(:)         :: p, phalf, tin, rin
      real, intent(in)                       :: rdgas, rvgas, hlv, kappa, cp
      real, intent(out)                      :: cape, cin
                                                                                
      integer            :: k, klcl, klfc, klzb
      logical            :: nocape
      real, dimension(kx)   :: tp, rp
      real                  :: t0, r0, es, rs, theta0, pstar, value, tlcl, &
                               a, b, dtdlnp, &
                               plcl, plzb

      pstar = 1.e5
                                                                                
      nocape = .true.
      cape = 0.
      cin = 0.
      plcl = 0.
      plzb = 0.
      klfc = 0
      klcl = 0
      klzb = 0
      tp(1:kx) = tin(1:kx)
      rp(1:kx) = rin(1:kx)
                                                                                
! start with surface parcel
      t0 = tin(kx)
      r0 = rin(kx)
! calculate the lifting condensation level by the following:
! are you saturated to begin with?
      call lookup_es(t0,es)
      rs = rdgas/rvgas*es/p(kx)
      if (r0.ge.rs) then
! if you're already saturated, set lcl to be the surface value.
         plcl = p(kx)
! the first level where you're completely saturated.
         klcl = kx
! saturate out to get the parcel temp and humidity at this level
! first order (in delta T) accurate expression for change in temp
         tp(kx) = t0 + (r0 - rs)/(cp/hlv + hlv*rs/rvgas/t0**2.)
         call lookup_es(tp(kx),es)
         rp(kx) = rdgas/rvgas*es/p(kx)
      else
! if not saturated to begin with, use the analytic expression to calculate the
! exact pressure and temperature where you?re saturated.
         theta0 = tin(kx)*(pstar/p(kx))**kappa
! the expression that we utilize is 
! log(r/theta**(1/kappa)*pstar*rvgas/rdgas/es00) = log(es/T**(1/kappa))
! The right hand side of this is only a function of temperature, therefore
! this is put into a lookup table to solve for temperature.
         if (r0.gt.0.) then
            value = log(theta0**(-1/kappa)*r0*pstar*rvgas/rdgas) 
            call lcltabl(value,tlcl)
            plcl = pstar*(tlcl/theta0)**(1/kappa)
! just in case plcl is very high up
            if (plcl.lt.p(1)) then
               plcl = p(1)
               tlcl = theta0*(plcl/pstar)**kappa
               write (*,*) 'hi lcl'
            end if
            k = kx
         else
! if the parcel sp hum is zero or negative, set lcl to 2nd to top level
            plcl = p(2)
            tlcl = theta0*(plcl/pstar)**kappa
!            write (*,*) 'zero r0', r0
            do k=2,kx
               tp(k) = theta0*(p(k)/pstar)**kappa
               rp(k) = 0.
! this definition of CIN contains everything below the LCL
               cin = cin + rdgas*(tin(k) - tp(k))*log(phalf(k+1)/phalf(k))
            end do
            go to 11
         end if
! calculate the parcel temperature (adiabatic ascent) below the LCL.
! the mixing ratio stays the same
         do while (p(k).gt.plcl)
            tp(k) = theta0*(p(k)/pstar)**kappa
            call lookup_es(tp(k),es)
            rp(k) = rdgas/rvgas*es/p(k)
! this definition of CIN contains everything below the LCL
            cin = cin + rdgas*(tin(k) - tp(k))*log(phalf(k+1)/phalf(k))
            k = k-1
         end do
! first level where you're saturated at the level
         klcl = k
         if (klcl.eq.1) klcl = 2
! do a saturated ascent to get the parcel temp at the LCL.
! use your 2nd order equation up to the pressure above.
! moist adaibat derivatives: (use the lcl values for temp, humid, and
! pressure)
         a = kappa*tlcl + hlv/cp*r0
         b = hlv**2.*r0/cp/rvgas/tlcl**2.
         dtdlnp = a/(1. + b)
! first order in p
!         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl)
! second order in p (RK2)
! first get temp halfway up
         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl)/2.
         if ((tp(klcl).lt.173.16).and.nocape) go to 11
         call lookup_es(tp(klcl),es)
         rp(klcl) = rdgas/rvgas*es/(p(klcl) + plcl)*2.
         a = kappa*tp(klcl) + hlv/cp*rp(klcl)
         b = hlv**2./cp/rvgas*rp(klcl)/tp(klcl)**2.
         dtdlnp = a/(1. + b)
! second half of RK2
         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl)
!         d2tdlnp2 = (kappa + b - 1. - b/tlcl*(hlv/rvgas/tlcl - &
!                   2.)*dtdlnp)/ (1. + b)*dtdlnp - hlv*r0/cp/ &
!                   (1. + b)
! second order in p
!         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl) + .5*d2tdlnp2*(log(&
!             p(klcl)/plcl))**2.
         if ((tp(klcl).lt.173.16).and.nocape) go to 11
         call lookup_es(tp(klcl),es)
         rp(klcl) = rdgas/rvgas*es/p(klcl)
!         write (*,*) 'tp, rp klcl:kx, new', tp(klcl:kx), rp(klcl:kx)
! CAPE/CIN stuff
         if ((tp(klcl).lt.tin(klcl)).and.nocape) then
! if you're not yet buoyant, then add to the CIN and continue
            cin = cin + rdgas*(tin(klcl) - &
                 tp(klcl))*log(phalf(klcl+1)/phalf(klcl))
         else
! if you're buoyant, then add to cape
            cape = cape + rdgas*(tp(klcl) - &
                  tin(klcl))*log(phalf(klcl+1)/phalf(klcl))
! if it's the first time buoyant, then set the level of free convection to k
            if (nocape) then
               nocape = .false.
               klfc = klcl
            endif
         end if
      end if
! then, start at the LCL, and do moist adiabatic ascent by the first order
! scheme -- 2nd order as well
      do k=klcl-1,1,-1
         a = kappa*tp(k+1) + hlv/cp*rp(k+1)
         b = hlv**2./cp/rvgas*rp(k+1)/tp(k+1)**2.
         dtdlnp = a/(1. + b)
! first order in p
!         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1))
! second order in p (RK2)
! first get temp halfway up
         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1))/2.
         if ((tp(k).lt.173.16).and.nocape) go to 11
         call lookup_es(tp(k),es)
         rp(k) = rdgas/rvgas*es/(p(k) + p(k+1))*2.
         a = kappa*tp(k) + hlv/cp*rp(k)
         b = hlv**2./cp/rvgas*rp(k)/tp(k)**2.
         dtdlnp = a/(1. + b)
! second half of RK2
         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1))
!         d2tdlnp2 = (kappa + b - 1. - b/tp(k+1)*(hlv/rvgas/tp(k+1) - &
!               2.)*dtdlnp)/(1. + b)*dtdlnp - hlv/cp*rp(k+1)/(1. + b)
! second order in p

!         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1)) + .5*d2tdlnp2*(log( &
!             p(k)/p(k+1)))**2.
! if you're below the lookup table value, just presume that there's no way
! you could have cape and call it quits
         if ((tp(k).lt.173.16).and.nocape) go to 11
         call lookup_es(tp(k),es)
         rp(k) = rdgas/rvgas*es/p(k)
         if ((tp(k).lt.tin(k)).and.nocape) then
! if you're not yet buoyant, then add to the CIN and continue
            cin = cin + rdgas*(tin(k) - tp(k))*log(phalf(k+1)/phalf(k))
         elseif((tp(k).lt.tin(k)).and.(.not.nocape)) then
! if you have CAPE, and it's your first time being negatively buoyant,
! then set the level of zero buoyancy to k+1, and stop the moist ascent
            klzb = k+1
            go to 11
         else
! if you're buoyant, then add to cape
            cape = cape + rdgas*(tp(k) - tin(k))*log(phalf(k+1)/phalf(k))
! if it's the first time buoyant, then set the level of free convection to k
            if (nocape) then
               nocape = .false.
               klfc = k
            endif
         end if
      end do
 11   if(nocape) then
! this is if you made it through without having a LZB
! set LZB to be the top level.
         plzb = p(1)
         klzb = 0
         klfc = 0
         cin = 0.
         tp(1:kx) = tin(1:kx)
         rp(1:kx) = rin(1:kx)
      end if
!      write (*,*) 'plcl, klcl, tlcl, r0 new', plcl, klcl, tlcl, r0
!      write (*,*) 'tp, rp new', tp, rp
!       write (*,*) 'tp, new', tp
!       write (*,*) 'tin new', tin
!       write (*,*) 'klcl, klfc, klzb new', klcl, klfc, klzb
      end subroutine capecalcnew


!#######################################################################
! lookup table for the analytic evaluation of LCL
      subroutine lcltabl(value,tlcl)
!
! Table of values used to compute the temperature of the lifting condensation
! level.
!
! the expression that we utilize is 
! log(r/theta**(1/kappa)*pstar*rvgas/rdgas/es00) = log(es/T**(1/kappa))
! the RHS is tabulated for the control amount of moisture, hence the 
! division by es00 on the LHS

! Gives the values of the temperature for the following range:
!   starts with -23, is uniformly distributed up to -10.4.  There are a
! total of 127 values, and the increment is .1.
!
      implicit none
      real, intent(in)     :: value
      real, intent(out)    :: tlcl
      integer              :: ival
      real, dimension(127) :: lcltable
      real                 :: v1, v2
                                                                                
      data lcltable/   1.7364512e+02,   1.7427449e+02,   1.7490874e+02, &
      1.7554791e+02,   1.7619208e+02,   1.7684130e+02,   1.7749563e+02, &
      1.7815514e+02,   1.7881989e+02,   1.7948995e+02,   1.8016539e+02, &
      1.8084626e+02,   1.8153265e+02,   1.8222461e+02,   1.8292223e+02, &
      1.8362557e+02,   1.8433471e+02,   1.8504972e+02,   1.8577068e+02, &
      1.8649767e+02,   1.8723077e+02,   1.8797006e+02,   1.8871561e+02, &
      1.8946752e+02,   1.9022587e+02,   1.9099074e+02,   1.9176222e+02, &
      1.9254042e+02,   1.9332540e+02,   1.9411728e+02,   1.9491614e+02, &
      1.9572209e+02,   1.9653521e+02,   1.9735562e+02,   1.9818341e+02, &
      1.9901870e+02,   1.9986158e+02,   2.0071216e+02,   2.0157057e+02, &
      2.0243690e+02,   2.0331128e+02,   2.0419383e+02,   2.0508466e+02, &
      2.0598391e+02,   2.0689168e+02,   2.0780812e+02,   2.0873335e+02, &
      2.0966751e+02,   2.1061074e+02,   2.1156316e+02,   2.1252493e+02, &
      2.1349619e+02,   2.1447709e+02,   2.1546778e+02,   2.1646842e+02, &
      2.1747916e+02,   2.1850016e+02,   2.1953160e+02,   2.2057364e+02, &
      2.2162645e+02,   2.2269022e+02,   2.2376511e+02,   2.2485133e+02, &
      2.2594905e+02,   2.2705847e+02,   2.2817979e+02,   2.2931322e+02, &
      2.3045895e+02,   2.3161721e+02,   2.3278821e+02,   2.3397218e+02, &
      2.3516935e+02,   2.3637994e+02,   2.3760420e+02,   2.3884238e+02, &
      2.4009473e+02,   2.4136150e+02,   2.4264297e+02,   2.4393941e+02, &
      2.4525110e+02,   2.4657831e+02,   2.4792136e+02,   2.4928053e+02, &
      2.5065615e+02,   2.5204853e+02,   2.5345799e+02,   2.5488487e+02, &
      2.5632953e+02,   2.5779231e+02,   2.5927358e+02,   2.6077372e+02, &
      2.6229310e+02,   2.6383214e+02,   2.6539124e+02,   2.6697081e+02, &
      2.6857130e+02,   2.7019315e+02,   2.7183682e+02,   2.7350278e+02, &
      2.7519152e+02,   2.7690354e+02,   2.7863937e+02,   2.8039954e+02, &
      2.8218459e+02,   2.8399511e+02,   2.8583167e+02,   2.8769489e+02, &
      2.8958539e+02,   2.9150383e+02,   2.9345086e+02,   2.9542719e+02, &
      2.9743353e+02,   2.9947061e+02,   3.0153922e+02,   3.0364014e+02, &
      3.0577420e+02,   3.0794224e+02,   3.1014515e+02,   3.1238386e+02, &
      3.1465930e+02,   3.1697246e+02,   3.1932437e+02,   3.2171609e+02, &
      3.2414873e+02,   3.2662343e+02,   3.2914139e+02,   3.3170385e+02 /
                                                                                
      v1 = value
      if (value.lt.-23.0) v1 = -23.0
      if (value.gt.-10.4) v1 = -10.4
      ival = floor(10.*(v1 + 23.0))
      v2 = -230. + ival
      v1 = 10.*v1
      tlcl = (v2 + 1.0 - v1)*lcltable(ival+1) + (v1 - v2)*lcltable(ival+2)
                                                                                
      end subroutine lcltabl


!#######################################################################
subroutine column_diag_1 (id_diag, is, js, Time, val1, c_val1, temp_in)
  integer, intent(in)                       :: id_diag, is, js
  real, intent(in)                          :: c_val1
  type(time_type), intent(in)               :: Time
  real, dimension(:,:,:), intent(in)        :: val1
  real, dimension(:,:), optional, intent(inout) :: temp_in
!local
  real, dimension(size(val1,1), size(val1,2)) :: temp
  integer :: k
  logical :: used
  integer :: ie, je

  if (present(temp_in)) then
    temp = temp_in
  else
    temp = 0.
  endif

  ie = is + size(val1,1) -1
  je = js + size(val1,2) -1

  do k = 1,size(val1,3)
    temp(:,:) = temp(:,:) + c_val1 * val1(:,:,k) * pmass(is:ie,js:je,k)
  enddo
  used = send_data (id_diag, temp, Time, is, js)

  if (present(temp_in)) temp_in=temp

end subroutine column_diag_1


!#######################################################################
subroutine column_diag_2 (id_diag, is, js, Time, val1, c_val1, val2, c_val2, temp_in)
  integer, intent(in)                       :: id_diag, is, js
  real, intent(in)                          :: c_val1, c_val2
  type(time_type), intent(in)               :: Time
  real, dimension(:,:,:), intent(in)        :: val1, val2
  real, dimension(:,:), optional, intent(inout) :: temp_in
!local
  real, dimension(size(val1,1), size(val1,2)) :: temp
  integer :: k
  logical :: used
  integer :: ie, je

  if (present(temp_in)) then
    temp = temp_in
  else
    temp = 0.
  endif

  ie = is + size(val1,1) -1
  je = js + size(val1,2) -1
  do k = 1,size(val1,3)
    temp(:,:) = temp(:,:) + (c_val1 * val1(:,:,k) + &
                             c_val2 * val2(:,:,k) ) * pmass(is:ie,js:je,k)
  enddo
  used = send_data (id_diag, temp, Time, is, js)

  if (present(temp_in)) temp_in=temp

end subroutine column_diag_2


!#######################################################################
subroutine column_diag_3 (id_diag, is, js, Time, val1, c_val1, val2, c_val2, val3, c_val3, temp_in)
  integer, intent(in)                       :: id_diag, is, js
  real, intent(in)                          :: c_val1, c_val2, c_val3
  type(time_type), intent(in)               :: Time
  real, dimension(:,:,:), intent(in)        :: val1, val2, val3
  real, dimension(:,:), optional, intent(inout) :: temp_in
!local
  real, dimension(size(val1,1), size(val1,2)) :: temp
  integer :: k
  logical :: used
  integer :: ie, je

  if (present(temp_in)) then
    temp = temp_in
  else
    temp = 0.
  endif

  ie = is + size(val1,1) -1
  je = js + size(val1,2) -1
  do k = 1,size(val1,3)
    temp(:,:) = temp(:,:) + (c_val1 * val1(:,:,k) + &
                             c_val2 * val2(:,:,k) + &
                             c_val3 * val3(:,:,k) ) * pmass(is:ie,js:je,k)
  enddo
  used = send_data (id_diag, temp, Time, is, js)

  if (present(temp_in)) temp_in=temp

end subroutine column_diag_3

  
!#######################################################################
subroutine rh_calc(pfull,T,qv,RH,do_simple,MASK, do_cmip)
  
!-----------------------------------------------------------------------
!       Calculate RELATIVE humidity. 
!       This is calculated according to the formula:
! 
!       RH   = qv / (epsilon*esat/ [pfull  -  (1.-epsilon)*esat])
!     
!       Where epsilon = RDGAS/RVGAS = d622
!     
!       and where 1- epsilon = d378
!     
!       Note that RH does not have its proper value 
!       until all of the following code has been executed.  That
!       is, RH is used to store intermediary results
!       in forming the full solution.

        IMPLICIT NONE
        
        REAL, INTENT (IN),    DIMENSION(:,:,:) :: pfull,T,qv
        REAL, INTENT (OUT),   DIMENSION(:,:,:) :: RH
        REAL, INTENT (IN), OPTIONAL, DIMENSION(:,:,:) :: MASK
        logical, intent(in), optional :: do_cmip
        logical, intent(in) :: do_simple
        REAL, DIMENSION(SIZE(T,1),SIZE(T,2),SIZE(T,3)) :: esat
      
        real, parameter :: d622 = RDGAS/RVGAS
        real, parameter :: d378 = 1.-d622

! because Betts-Miller uses a simplified scheme for calculating the relative humidity
        if (do_simple) then
          call lookup_es(T, esat)
          RH(:,:,:) = pfull(:,:,:)
          RH(:,:,:) = MAX(RH(:,:,:),esat(:,:,:))  !limit where pfull ~ esat
          RH(:,:,:)=qv(:,:,:)/(d622*esat(:,:,:)/RH(:,:,:))
        else
          if (present(do_cmip)) then
            call compute_qs (T, pfull, rh, q=qv,  &
                                          es_over_liq_and_ice = .true.)
             RH(:,:,:)=qv(:,:,:)/RH(:,:,:)
          else
            call compute_qs (T, pfull, rh, q=qv)
            RH(:,:,:)=qv(:,:,:)/RH(:,:,:)
          endif
        endif

        !IF MASK is present set RH to zero
        IF (present(MASK)) RH(:,:,:)=MASK(:,:,:)*RH(:,:,:)

END SUBROUTINE rh_calc


!#######################################################################

                 end module moist_proc_utils_mod

!FDOC_TAG_GFDL

                 module uw_clouds_W_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   fil
! </CONTACT>
! <REVIEWER EMAIL="">
!   
! </REVIEWER>
! <OVERVIEW>
!          uw shallow convection cloud radiative properties module
!   
! </OVERVIEW>
! <DESCRIPTION>
!   
! </DESCRIPTION>
!

use  time_manager_mod, only: time_type
use           mpp_mod, only: input_nml_file
use           fms_mod, only: open_namelist_file, file_exist,   &
                             check_nml_error, error_mesg,   &
                             close_file, FATAL, NOTE, &
                             WARNING, mpp_pe, mpp_root_pe, &
                             write_version_number, stdlog
use     constants_mod, only: DENS_H2O, RDGAS, TFREEZE, pi
use rad_utilities_mod, only: longwave_control_type, Lw_control, &
                             shortwave_control_type, Sw_control,&
                             microphysics_type,  &
                             microrad_properties_type, &
                             cld_specification_type, &
                             cloudrad_control_type, Cldrad_control

!--------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!          uw shallow convection cloud radiative properties module
!
!--------------------------------------------------------------------



!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------

   character(len=128)  :: version =  '$Id: uw_clouds_W.F90,v 19.0 2012/01/06 20:25:15 fms Exp $'
   character(len=128)  :: tagname =  '$Name: tikal $'



!---------------------------------------------------------------------
!-------  interfaces --------

public          &
          uw_clouds_W_init,   &
          uw_clouds_W_end , uw_clouds_amt

!---------------------------------------------------------------------
!-------- namelist  ---------

logical   :: dummy = .true.


namelist /uw_clouds_W_nml /     &
                                     dummy                          


!----------------------------------------------------------------------
!----  public data -------


!----------------------------------------------------------------------
!----  private data -------

real, parameter :: K_LAND  = 1.143
real, parameter :: K_OCEAN = 1.077
real, parameter :: N_LAND  = 250.E+06
real, parameter :: N_OCEAN = 100.E+06
real, parameter :: N_MIN   = 1.0e06
real, parameter :: QMIN    = 1.0e-10
real, parameter :: QAMIN   = 1.0e-2

  logical :: module_is_initialized = .false.
!----------------------------------------------------------------------
!----------------------------------------------------------------------




contains 





! <SUBROUTINE NAME="uw_clouds_W_init">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call uw_clouds_W_init  (pref, lonb, latb, axes, Time)
!
!  </TEMPLATE>
!  <IN NAME="pref" TYPE="real">
! 
!  </IN>
!  <IN NAME="lonb" TYPE="real">
! 
!  </IN>
!  <IN NAME="latb" TYPE="real">
! 
!  </IN>
!  <IN NAME="axes" TYPE="integer">
! 
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
! 
!  </IN>
! </SUBROUTINE>
!
subroutine uw_clouds_W_init  (pref, lonb, latb, axes, Time)

real, dimension(:,:),  intent(in) :: pref
real, dimension(:,:),  intent(in) :: lonb, latb
integer, dimension(4), intent(in) :: axes
type(time_type),       intent(in) :: Time

      integer            :: unit, ierr, io, logunit

     if (module_is_initialized) return
!---------------------------------------------------------------------
!-----  read namelist  ------
!---------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=uw_clouds_W_nml, iostat=io)
      ierr = check_nml_error(io,"uw_clouds_W_nml")
#else
      if (file_exist('input.nml')) then
        unit =  open_namelist_file ()
        ierr=1; do while (ierr /= 0)
        read (unit, nml=uw_clouds_W_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'uw_clouds_W_nml')
        enddo
10      call close_file (unit)
      endif
#endif

      if ( mpp_pe() == mpp_root_pe() ) then
         call write_version_number(version, tagname)
         logunit = stdlog()
         write (logunit,nml=uw_clouds_W_nml)
      endif

!---------------------------------------------------------------------

       module_is_initialized = .true.


end subroutine uw_clouds_W_init

! <SUBROUTINE NAME="uw_clouds_W_end">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call uw_clouds_W_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine uw_clouds_W_end
       
!----------------------------------------------------------------------
!    uw_clouds_W_end is the destructor for uw_clouds_W_mod.
!----------------------------------------------------------------------
       
!---------------------------------------------------------------------
!    mark the module as not initialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.
       
!--------------------------------------------------------------------


end subroutine uw_clouds_W_end


!#################################################################


!---------------------------------------------------------------------

! <SUBROUTINE NAME="uw_clouds_amt">
!  <OVERVIEW>
!    uw_clouds_amt defines the distribution of cloud water and cloud ice 
!    amounts [ g / m**3 ] and liquid and ice particle sizes and total cloud 
!    fraction for the clouds associated with uw shallow convection. these 
!    values will later be combined with other cloud fields to produce the 
!    cloud radiative properties that will be seen by the radiation package.
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!    uw_clouds_amt defines the distribution of cloud water and cloud ice 
!    amounts [ g / m**3 ] and liquid and ice particle sizes and total cloud 
!    fraction for the clouds associated with uw shallow convection. these 
!    values will later be combined with other cloud fields to produce the 
!    cloud radiative properties that will be seen by the radiation package.
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call uw_clouds_amt (is, ie, js, je, Shallow_microphys)   
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <INOUT NAME="Shallow_microphys" TYPE="microphysics_type">
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine uw_clouds_amt (is, ie, js, je,   &
                   shallow_cloud_area, shallow_liquid, shallow_ice, &
                   shallow_droplet_number, shallow_ice_number, land,  &
                   pfull, tkel, Shallow_microphys)

!---------------------------------------------------------------------
!    uw_clouds_amt defines the distribution of cloud water and cloud ice 
!    amounts [ g / m**3 ] and liquid and ice particle sizes and total cloud 
!    fraction for the clouds associated with uw shallow convection. these 
!    values will later be combined with other cloud fields to produce the 
!    cloud radiative properties that will be seen by the radiation package.
!----------------------------------------------------------------------

integer,                 intent(in)    :: is,ie,js,je
real, dimension(:,:,:),  intent(in)    :: shallow_cloud_area,  &
                                          shallow_liquid, shallow_ice, &
                                          shallow_droplet_number, &
                                          shallow_ice_number
real, dimension(:,:),    intent(in)    :: land
real, dimension(:,:,:),  intent(in)    :: pfull, tkel
type(microphysics_type), intent(inout) :: Shallow_microphys

!--------------------------------------------------------------------------
!   local variables:

      real, dimension (size(shallow_liquid,1),                             &
                       size(shallow_liquid,2),                             &
                       size(shallow_liquid,3)) ::  liq_local, area_local,  &
                                                   ice_local, rho
      real, dimension (size(shallow_liquid,1),                             &
                       size(shallow_liquid,2)) ::  k_ratio, ndrops
      integer     :: ix, jx, kx
      integer     :: i, j, k

!cms++
!should better also pre-calc some const. in initialization ...
!    REAL :: dumc, dumnc, rho1, pgam, lamc, lammax, lammin, &
!           dumi, dumni, lami
 
!cms--
      
!----------------------------------------------------------------------
!    define vertical index.
!----------------------------------------------------------------------
      ix = size(Shallow_microphys%size_drop,1)
      jx = size(Shallow_microphys%size_drop,2)
      kx = size(Shallow_microphys%size_drop,3)

!---------------------------------------------------------------------
!    define k_ratio as appropriate mix of land and ocean values.
!----------------------------------------------------------------------
      k_ratio(:,:) = K_LAND*land(:,:) + K_OCEAN*(1.0 - land(:,:))
      ndrops(:,:)  = N_LAND*land(:,:) + N_OCEAN*(1.0 - land(:,:))
      
!---------------------------------------------------------------------
!    limit shallow cloud area and cloud amount so that non-zero clouds 
!    exist only in boxes with non-zero cloud areas.
!---------------------------------------------------------------------
      do k=1,kx                                      
        do j=1,jx
          do i=1,ix
            area_local(i,j,k) = 0.
            if ( (shallow_cloud_area(i,j,k) > QAMIN) .and.  &
                 (shallow_liquid(i,j,k) > QMIN) ) then
              liq_local(i,j,k) = shallow_liquid(i,j,k)
              area_local(i,j,k) = shallow_cloud_area(i,j,k)
            else
              liq_local(i,j,k) = 0.0                     
            endif

            if ( (shallow_cloud_area(i,j,k) > QAMIN) .and.  &
                 (shallow_ice(i,j,k) > QMIN)) then
              ice_local(i,j,k) = shallow_ice(i,j,k)
              area_local(i,j,k) = shallow_cloud_area(i,j,k)
            else
              ice_local(i,j,k) = 0.0                     
            endif
          end do
        end do
      end do
          
!!$!cms++
!!$   ice_num_if: if ( .NOT. Cldrad_control%do_ice_num) then
!!$!cms--


!----------------------------------------------------------------------
!    define droplet diameter based on cloud amount and droplet number. 
!    use formula as in cloud_rad_mod.
!----------------------------------------------------------------------
      if (Cldrad_control%do_liq_num) then
      do k=1,kx
        do j=1,jx
          do i=1,ix
            if (liq_local(i,j,k) > QMIN) then
              Shallow_microphys%size_drop(i,j,k)  =  2.0* &
                       (k_ratio(i,j)*620350.49*(liq_local(i,j,k)/DENS_H2O/ &
                       MAX(shallow_droplet_number(i,j,k), N_MIN*   &
                               max(area_local(i,j,k), QAMIN)/ &
                       (pfull(i,j,k)/RDGAS/tkel(i,j,k))))**(1./3.) )
            else
              Shallow_microphys%size_drop(i,j,k)  =  0.0 
            endif
          end do
        end do
      end do
      Shallow_microphys%droplet_number = shallow_droplet_number
      else
!----------------------------------------------------------------------
!  case of non-prognostic droplet number
!----------------------------------------------------------------------
      do k=1,kx
        do j=1,jx
          do i=1,ix
            if (liq_local(i,j,k) > QMIN) then
              Shallow_microphys%size_drop(i,j,k)  =    &
                 2.0* k_ratio(i,j)*620350.49*(pfull(i,j,k)*  &
                 shallow_liquid(i,j,k)/area_local(i,j,k)/RDGAS/  &
                 tkel(i,j,k)/DENS_H2O/ndrops(i,j))**(1./3.)
            else
              Shallow_microphys%size_drop(i,j,k)  =  0.0 
            endif
              Shallow_microphys%droplet_number(i,j,k) =   &
                                        ndrops(i,j)/(pfull(i,j,k)/  &
                                                    (RDGAS*tkel(i,j,k)))
          end do
        end do
      end do
      endif

!--------------------------------------------------------------------
!    if ice crystals are present, define their effective size, which
!    is a function of temperature. for ice clouds the effective radius
!    is taken from the formulation in Donner (1997, J. Geophys. Res., 
!    102, pp. 21745-21768) which is based on Heymsfield and Platt (1984)
!    with enhancement for particles smaller than 20 microns.  
!
!              T Range (K)               Reff (microns) 
!     -------------------------------    --------------
!
!     tfreeze-25. < T                      100.6           
!     tfreeze-30. < T <= Tfreeze-25.        80.8         
!     tfreeze-35. < T <= Tfreeze-30.        93.5             
!     tfreeze-40. < T <= Tfreeze-35.        63.9            
!     tfreeze-45. < T <= Tfreeze-40.        42.5           
!     tfreeze-50. < T <= Tfreeze-45.        39.9         
!     Tfreeze-55  < T <= Tfreeze-50         21.6          
!                   T <= Tfreeze-55.        20.2        
!
!--------------------------------------------------------------------
      if (Cldrad_control%using_fu2007) then
        do k=1,kx
          do j=1,jx
            do i=1,ix
!+yim Fu's parameterization of dge
              Shallow_microphys%size_ice(i,j,k) =   &
                            47.05 + 0.6624*(tkel(i,j,k) - TFREEZE) +  &
                            0.001741*(tkel(i,j,k)-TFREEZE)**2 
            end do
          end do
        end do
      else ! (using_fu2007)
        do k=1,kx
          do j=1,jx
            do i=1,ix
              if (ice_local(i,j,k) > QMIN) then
                if (tkel(i,j,k) > TFREEZE - 25. ) then
                  Shallow_microphys%size_ice(i,j,k) = 100.6    
                else if (tkel(i,j,k) >  TFREEZE - 30. .and. &
                       tkel(i,j,k) <= TFREEZE - 25.) then
                  Shallow_microphys%size_ice(i,j,k) = 80.8       
                else if (tkel(i,j,k) >  TFREEZE - 35. .and. &
                         tkel(i,j,k) <= TFREEZE - 30.) then
                  Shallow_microphys%size_ice(i,j,k)  = 93.5     
                else if (tkel(i,j,k) >  TFREEZE - 40. .and. &
                         tkel(i,j,k) <= TFREEZE - 35.) then
                  Shallow_microphys%size_ice(i,j,k) = 63.9      
                else if (tkel(i,j,k) >  TFREEZE - 45. .and. &
                         tkel(i,j,k) <= TFREEZE - 40.) then
                  Shallow_microphys%size_ice(i,j,k) = 42.5    
                else if (tkel(i,j,k) >  TFREEZE - 50. .and. &
                         tkel(i,j,k) <= TFREEZE - 45.) then
                  Shallow_microphys%size_ice(i,j,k) = 39.9       
                else if (tkel(i,j,k) >  TFREEZE - 55. .and. &
                         tkel(i,j,k) <= TFREEZE - 50.) then
                  Shallow_microphys%size_ice(i,j,k) = 21.6        
                else
                  Shallow_microphys%size_ice(i,j,k) = 20.2        
                end if
              else
                Shallow_microphys%size_ice(i,j,k) = 0.0
              endif
            end do
          end do
        end do
      endif  ! (using_fu2007)


!------------------------------------------------------------------------
!!$else  ! ice_num_if
!!$
!!$!also cal. liq. as in Morrison scheme
!!$ 
!!$      do k=1,kx
!!$        do j=1,jx
!!$          do i=1,ix
!!$
!!$
!!$! calc. based on Morrison Gettelman code
!!$!     
!!$          qamin_if: IF ( shallow_cloud_area(i,j,k) .GT. qamin ) THEN 
!!$
!!$! in-cloud mixing ratio and number conc
!!$         dumi = ice_local(i,j,k)/area_local(i,j,k)
!!$         dumni =  shallow_ice_number(i,j,k)/area_local(i,j,k)
!!$
!!$
!!$! limit in-cloud mixing ratio to reasonable value of 5 g kg-1
!!$         dumi =min(dumi ,5.e-3)
!!$
!!$!...................
!!$! cloud ice effective radius
!!$      if ( dumi > qmin ) then
!!$
!!$! add upper limit to in-cloud number concentration to prevent numerical error
!!$     dumni=min(dumni,dumi*1.e20)
!!$     lami = (gamma_mg(1.+di_mg)*ci_mg* &
!!$              dumni/dumi)**(1./di_mg)
!!$     lammax = 1./10.e-6
!!$     lammin = 1./(2.*dcs_mg)
!!$
!!$     if (lami.lt.lammin) then
!!$     lami = lammin
!!$     else if (lami.gt.lammax) then
!!$     lami = lammax
!!$     end if
!!$        Shallow_microphys%size_ice(i,j,k)  = 1.5/lami*1.e6
!!$        else
!!$        Shallow_microphys%size_ice(i,j,k)  =  0.
!!$        end if
!!$
!!$
!!$   must mult by 2 
!!$
!!$!-----------------------------------------------------------
!!$!
!!$! cloud droplet effective radius
!!$!
!!$
!!$! in-cloud mixing ratio and number conc
!!$         dumc = liq_local(i,j,k)/area_local(i,j,k)
!!$         dumnc = shallow_droplet_number(i,j,k)/area_local(i,j,k)
!!$! limit in-cloud mixing ratio to reasonable value of 5 g kg-1
!!$
!!$      dumc =min(dumc,5.e-3)
!!$
!!$
!!$      if ( dumc > qmin ) then
!!$
!!$
!!$! add upper limit to in-cloud number concentration to prevent numerical error
!!$       dumnc = min(dumnc,dumc*1.e20)
!!$
!!$         rho1=pfull(i,j,k)/(RDGAS*tkel(i,j,k))
!!$
!!$         pgam=0.0005714*(dumnc/1.e6/rho1)+0.2714
!!$         pgam=1./(pgam**2)-1.
!!$         pgam=max(pgam,2.)
!!$         pgam=min(pgam,15.)
!!$
!!$       lamc = (pi/6.*rhow*dumnc*gamma_mg(pgam+4.)/ &
!!$                 (dumc*gamma_mg(pgam+1.)))**(1./3.)
!!$       lammin = (pgam+1.)/50.e-6
!!$       lammax = (pgam+1.)/2.e-6
!!$       if (lamc.lt.lammin) then
!!$         lamc = lammin
!!$        else if (lamc.gt.lammax) then
!!$       lamc = lammax
!!$       end if
!!$       Shallow_microphys%size_drop(i,j,k)  =  gamma_mg(qcvar+1./3.)/(gamma_mg(qcvar)*qcvar**(1./3.))* &
!!$             gamma_mg(pgam+4.)/ &
!!$             gamma_mg(pgam+3.)/lamc/2.*1.e6
!!$        else
!!$        Shallow_microphys%size_drop(i,j,k)  = 0.
!!$        end if
!!$
!!$
!!$
!!$
!!$           END IF qamin_if
!!$          end do
!!$        end do
!!$      end do
!!$
!!$
!!$
!!$
!!$      Shallow_microphys%ice_number = shallow_ice_number
!!$      Shallow_microphys%droplet_number = shallow_droplet_number
!!$
!!$  
!!$
!!$    end if ice_num_if

!---------------------------------------------------------------------
!    convert the cloud and ice amounts from kg(h2o) / kg(air) to 
!    g(h2o) / m**3, as required for use in the microphys_rad routines
!    which compute cloud radiative properties.
!---------------------------------------------------------------------
      rho(:,:,:) = pfull(:,:,1:kx)/(RDGAS*tkel(:,:,1:kx))
      Shallow_microphys%conc_drop = 1.0e03*rho*liq_local  
      Shallow_microphys%conc_ice  = 1.0e03*rho* ice_local  

!---------------------------------------------------------------------
!    define the cloud area to be that after adjustment for trivial cloud
!    amounts.
!---------------------------------------------------------------------
      Shallow_microphys%cldamt = area_local


!---------------------------------------------------------------------



end subroutine uw_clouds_amt  



!####################################################################


                     end module uw_clouds_W_mod

module ocean_shortwave_jerlov_mod
!
!<CONTACT EMAIL="martin.schmidt@io-warnemuende.de"> Martin Schmidt
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</REVIEWER>
!
!<OVERVIEW>
! This module returns thickness and density weighted temperature 
! tendency [kg/m^3 * deg C *m/sec] from penetrative shortwave heating.
!</OVERVIEW>
!
!<DESCRIPTION>
! Compute thickness and density weighted tendency [deg C *m/sec *kg/m^3]
! of temperature associated with penetrative shortwave heating in the upper
! ocean. 
!
! This module ussumes a simple double exponential decay law. The e-folding 
! depth may vary spatially and temporaly.  
!
! The exponentials represents a parameterization of the
! attenuation coefficient for light between 300 um and 750 um in the following
! form:
!
!      E(z) = E(0) * (r1*exp(-z/efold1) + (1-r1)*exp(-z/efold2))
!      with z > 0 the ocean depth 
!
! The "efold" is the efolding depth of the long and short
! visable and ultra violet light.
! efold will vary between 30 m in oligotrophic waters and 4 m in coastal
! regions. 
!
! If the thickness of the first ocean level "dzt(1)" is 50 meters,
! then shortwave penetration does not do much. However, for finer 
! vertical resolution, such as dzt(1) = 10 meters commonly used
! in ocean climate models, the effect of shortwave heating can
! be significant. This can be particularly noticable in the summer
! hemisphere.
!
! Radiation at the bottom is set to zero, hence the remaining radiation
! at the bottom of the deepest ocean cells is totally absorbed 
! by these cells. This implies, that partial cells need not to
! be considered explicitly. Radiation at tracer depth within these 
! cells is not set to zero. This differs from 
! ocean_shortwave_gfdl and ocean_shortwave_csiro and reduces slightly the
! bouyancy forcing to the mixing layer in the kpp-scheme, if surface mixing 
! goes down to the bottom. 
! 
! </DESCRIPTION>
!
! <INFO>
!
! <NOTE>
!  The efolding depth is depth independent.
! </NOTE> 
!
! <NOTE>
!  Simpson and Dickey (1981) and others have argued between one and 
!  two exponentials for light between 300 um and 750 um.  
!  With vertical grid resolution of 5 meters or finer
!  for the upper 20 meters, a second exponential will make a difference.
! </NOTE> 
!
! <REFERENCE>
! Jerlov (1968)
! Optical Oceanography
! Elsevier Press
! </REFERENCE>
!
! <REFERENCE>
! Paulson and Simpson (1977)
! Irradiance measurements in the upper ocean
! Journal of Physical Oceanography vol 7 pages 952-956
! </REFERENCE>
!
! <REFERENCE>
! Rosati and Miyakoda (1988)
! A General Circulation Model for Upper Ocean Simulation
! Journal of Physical Oceanography vol 18 pages 1601-1626.
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_shortwave_jerlov_nml">
!  <DATA NAME="use_this_module=" TYPE="logical">
!   Must be .true. to run with module. Default is false.
!  </DATA> 
!  <DATA NAME="sw_frac_top" TYPE="real">
!   The fraction of shortwave radiation that should be incorporated into 
!   the sw_source array at k=1.  The generic treatment in MOM is to assume
!   that shortwave radiation is already contained inside the 
!   T_prog(index_temp)%stf field. Hence, to avoid   
!   double counting, sw_frac(k=0)=sw_frac_top should=0.0.
!   If one removes shortwave from stf, then set sw_frac_top=1.0.
!  </DATA> 
!  <DATA NAME="f_vis_in" TYPE="real">
!   F_vis is the amount of light in the shortwave versus the long wave.
!   F_vis=0.54 on sunny days and F_vis=0.60 on cloudy days. With 
!   override_f_vis  = .true. F_vis is defined from f_vis_in.
!   We believe, that this effect is in the first exponential in 
!   Paulson and Simpson (1977). The default is f_vis_in=1., instead of .57
!   but it is still possible to define this quantity. 
!  </DATA> 
!  <DATA NAME="rpart_in" TYPE="real">
!   rpart_in = (0..1)   
!  </DATA> 
!  <DATA NAME="coef1_in" UNITS="meter" TYPE="real">
!  </DATA> 
!  <DATA NAME="coef2_in" UNITS="meter"  TYPE="real">
!  </DATA> 
!  <DATA NAME="override_coeff" TYPE="logical">
!   With override_coeff  = .true. rpart_in, coef1_in, coef2_in specify
!   the parameters for the double exponential. The default is .false..
!  </DATA> 
!  <DATA NAME="override_f_vis" TYPE="logical">
!   With override_f_vis  = .true. F_vis is defined from f_vis_in,
!   otherwise it is the shortwave versus the long wave amount of light.
!   The default is .true.
!  </DATA> 
!  <DATA NAME="zmax_pen" UNITS="meter" TYPE="real">
!   Maximum depth of penetration of shortwave radiation. 
!   Below this depth, shortwave penetration is exponentially 
!   small and so is ignored.
!  </DATA>
!  <DATA NAME="baltic_optics, jerlov_1, jerlov_2, jerlov_3, jerlov_1a, jerlov_1b" TYPE="logical">
!   Logical switch to select a watertype. Default=.false.. The model stops, if none is selected
!   and override_coeff=.false..  
!  </DATA>
!  <DATA NAME="enforce_sw_frac" TYPE="logical">
!  To ensure the shortwave fraction is monotonically decreasing with depth. 
!  </DATA> 
!  <DATA NAME="sw_pen_fixed_depths" TYPE="logical">
!  To compute penetration assuming fixed depths via Grd%zw(k) depths.
!  This is strictly incorrect when have undulating free surface or 
!  generatlized vertical coordinates.  This option is here for purposes
!  of legacy, as this was done in MOM4.0 versions. It saves some compute time
!  if the surface elevation is small compared with the upper cells' thickness.
!  The default is .false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging purposes.
!  </DATA> 
!</NAMELIST>

use constants_mod,            only: epsln
use fms_mod,                  only: write_version_number, open_namelist_file
use fms_mod,                  only: close_file, check_nml_error
use fms_mod,                  only: stdout, stdlog, FATAL, NOTE
use mpp_mod,                  only: input_nml_file, mpp_error, mpp_max, mpp_min
use mpp_mod,                  only: mpp_clock_id, mpp_clock_begin, mpp_clock_end
use mpp_mod,                  only: CLOCK_ROUTINE
use time_interp_external_mod, only: time_interp_external, init_external_field

use ocean_domains_mod,        only: get_local_indices
use ocean_parameters_mod,     only: GEOPOTENTIAL 
use ocean_types_mod,          only: ocean_time_type, ocean_domain_type, ocean_grid_type
use ocean_types_mod,          only: ocean_prog_tracer_type, ocean_thickness_type
use ocean_types_mod,          only:  ocean_options_type, ocean_diag_tracer_type
use ocean_workspace_mod,      only: wrk1, wrk3, wrk4 

implicit none

private

! for vertical coordinate 
integer :: vert_coordinate 

! clock ids
integer :: id_sw_pen

logical :: verbose_flag=.false.

#include <ocean_memory.h>
  
#ifdef MOM_STATIC_ARRAYS
  real, dimension(isd:ied,jsd:jed,0:nk) :: sw_frac_zw      ! fractional short wave radiation on w-points     
  real, dimension(0:nk)                 :: sw_frac_zw_fix  ! fractional short wave radiation on w-points
                                                           ! with sw_pen_fixed_depths   
  real, dimension(1:nk)                 :: sw_frac_zt_fix  ! fractional short wave radiation on t-points
                                                           ! with sw_pen_fixed_depths   
#else  
  real, allocatable, dimension(:,:,:) :: sw_frac_zw        ! fractional short wave radiation on w-points  
  real, allocatable, dimension(:)     :: sw_frac_zw_fix    ! fractional short wave radiation on w-points  
                                                           ! with sw_pen_fixed_depths   
  real, allocatable, dimension(:)     :: sw_frac_zt_fix    ! fractional short wave radiation on t-points  
                                                           ! with sw_pen_fixed_depths   
#endif

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

character(len=128)  :: version='$Id: ocean_shortwave_jerlov.F90,v 20.0 2013/12/14 00:16:20 fms Exp $'
character (len=128) :: tagname = '$Name: tikal $'
character(len=48), parameter          :: mod_name = 'ocean_shortwave_jerlov_mod'

real         :: rpart, rscl1, rscl2, rscl_ir

public  ocean_shortwave_jerlov_init
public  sw_source_jerlov

real    :: f_vis_in               = 1.       
logical :: use_this_module        = .false.
logical :: read_depth             = .false.
logical :: module_is_initialized  = .FALSE.
logical :: debug_this_module      = .false. 
logical :: enforce_sw_frac        = .false. 
logical :: override_f_vis         = .true. 
logical :: override_coeff         = .false. 
logical :: sw_pen_fixed_depths    = .false. 
logical :: jerlov_1               = .false. 
logical :: jerlov_2               = .false. 
logical :: jerlov_3               = .false. 
logical :: jerlov_1a              = .false. 
logical :: jerlov_1b              = .false. 
logical :: baltic_optics          = .false.
real    :: rpart_in               = 0.58  !Jerlov I
real    :: coef1_in               = 0.35  !Jerlov I
real    :: coef2_in               = 23.   !Jerlov I

real :: zmax_pen      = 120.0 ! maximum depth (m) of solar penetration. 
                              ! below, penetration is exponentially small and so is ignored
real :: sw_frac_top   = 0.0   ! set to 1.0 if do not have shortwave radiation inside of T_prog(index_temp)%stf.

namelist /ocean_shortwave_jerlov_nml/ use_this_module,                   &
                               zmax_pen, sw_frac_top, debug_this_module, &  
                               enforce_sw_frac, override_f_vis,          &
                               override_coeff,                           & 
                               sw_pen_fixed_depths , baltic_optics,      &
                               jerlov_1, jerlov_2, jerlov_3, jerlov_1a,  &
                               jerlov_1b, f_vis_in,                      &
                               rpart_in, coef1_in, coef2_in 

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_shortwave_jerlov_init">
!
! <DESCRIPTION>
! Initialization for the shortwave module
! </DESCRIPTION>
  subroutine ocean_shortwave_jerlov_init(Grid, Domain, ver_coordinate, Ocean_options)

    type(ocean_grid_type),    intent(in), target :: Grid
    type(ocean_domain_type),  intent(in), target :: Domain
    integer,                  intent(in)         :: ver_coordinate
    type(ocean_options_type), intent(inout)      :: Ocean_options

    real    :: coef1, coef2, efold1, efold2, depth
    integer :: unit, io_status, ierr, k, nopt

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

    if ( module_is_initialized ) return
    
    module_is_initialized = .TRUE.
    vert_coordinate = ver_coordinate

    call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_shortwave_jerlov_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_shortwave_jerlov_nml')
#else
    unit = open_namelist_file()
    read(unit, ocean_shortwave_jerlov_nml,iostat=io_status)
    ierr = check_nml_error(io_status, 'ocean_shortwave_jerlov_nml')
    call close_file(unit)
#endif
    write(stdoutunit,'(/)')
    write(stdoutunit,ocean_shortwave_jerlov_nml)    
    write(stdlogunit,ocean_shortwave_jerlov_nml)

    Dom => Domain
    Grd => Grid

#ifndef MOM_STATIC_ARRAYS    
    call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
    nk = Grid%nk
#endif 
    
    if(use_this_module) then 
      call mpp_error(NOTE, '==>Note: USING shortwave_jerlov_mod.')
      Ocean_options%shortwave = 'Used the shortwave penetration from the Jerlov formulaton.'
    else 
      call mpp_error(NOTE, '==>Note: NOT using shortwave_jerlov_mod.')
      Ocean_options%shortwave = 'Did NOT use any shortwave penetration option.'
      return 
    endif 

#ifndef MOM_STATIC_ARRAYS    
    allocate( sw_frac_zw(isd:ied,jsd:jed,0:nk))
#endif

    ! set clock ids     
    id_sw_pen = mpp_clock_id('(Ocean shortwave penetrate) ' ,grain=CLOCK_ROUTINE)
    
    if(sw_frac_top==0.0) then 
        write(stdoutunit,*) &
        '=>Note: computing solar shortwave penetration. Assume stf has sw-radiation field'
        write(stdoutunit,*) &
        '  included.  Hence, solar shortwave penetration effects placed in sw_source will '
        write(stdoutunit,*) &
        '  subtract out the effects of shortwave at k=1 to avoid double-counting.'
    elseif(sw_frac_top==1.0) then 
        write(stdoutunit,*) &
        '=>Note: computing solar shortwave penetration. Assume stf does not have sw-radiation'
        write(stdoutunit,*) &
        ' field included.  Shortwave penetration effects are placed completely in sw_source.'
        write(stdoutunit,*) &
        ' This is not the standard approach used in MOM.'
    elseif(sw_frac_top/=1.0 .and. sw_frac_top/=0.0) then 
        write(stdoutunit,*) &
        '=>Note: Computing solar shortwave penetration. Assume a portion of sw-effects are'
        write(stdoutunit,*) &
        '  included in stf and a portion in sw_source.  Are you sure you wish to do this?'
    endif

    if(enforce_sw_frac) then  
        write(stdoutunit,*) &
        '=>Note: enforce_sw_frac=.true. enforcing monotonic decrease of sw_frac with depth.'
    else 
        write(stdoutunit,*) &
        '=>Note: enforce_sw_frac=.false. non-monotonic sw_frac w/ some penetration profiles.'
    endif

    if(sw_pen_fixed_depths) then
        write(stdoutunit,*) &
        ' ==>Warning: sw_pen_fixed_depths=.true. is unsuitable for time varying thicknesses.'
        write(stdoutunit,*)&
        '             Time varying thicknesses are the norm in MOM, so recommend'
        write(stdoutunit,*) &
        '             setting sw_pen_fixed_depths=.false.  However, to reproduce MOM4.0'
        write(stdoutunit,*) &
        '             algorithm, then set sw_pen_fixed_depths=.true.' 
    endif
    
    nopt = 0
    if(jerlov_1) then 
        write(stdoutunit,*)' ==>Note: Setting optical model coefficients assuming Jerlov I water.'
        rpart = 0.58
        coef1 = 0.35
        coef2 = 23.
        nopt = nopt + 1
    endif
    if(jerlov_1a) then 
        write(stdoutunit,*)' ==>Note: Setting optical model coefficients assuming Jerlov IA water.'
        rpart = 0.62
        coef1 = 0.60
        coef2 = 20.
        nopt = nopt + 1
    endif
    if(jerlov_1b) then 
        write(stdoutunit,*)' ==>Note: Setting optical model coefficients assuming Jerlov IB water.'
        rpart = 0.67
        coef1 = 1.0
        coef2 = 17.
        nopt = nopt + 1
    endif
    if(jerlov_2) then 
        write(stdoutunit,*)' ==>Note: Setting optical model coefficients assuming Jerlov II water.'
        rpart = 0.77
        coef1 = 1.5
        coef2 = 14.
        nopt = nopt + 1
    endif
    if(jerlov_3) then 
        write(stdoutunit,*)' ==>Note: Setting optical model coefficients assuming Jerlov III water.'
        rpart = 0.78
        coef1 = 1.4
        coef2 = 7.9
        nopt = nopt + 1
    endif
    if(baltic_optics) then 
        write(stdoutunit,*)' ==>Note: Setting optical model coefficients assuming Baltic water.'
        rpart = 0.521
        coef1 = 0.15
        coef2 = 3.3
        nopt = nopt + 1
    endif
    if(override_coeff) then
        write(stdoutunit,*)' ==>Note: Setting optical model coefficients from namelist.'
        rpart = rpart_in
        coef1 = coef1_in
        coef2 = coef2_in
        nopt = nopt + 1
    endif 
    if (nopt == 0 ) &
        call mpp_error(FATAL, &
        'FATAL ==>ocean_shortwave_jerlov_init: No water type specified for short wave radiation.')
    if (nopt >= 2 ) &
        call mpp_error(FATAL, &
        'FATAL ==>ocean_shortwave_jerlov_init: More then one water type specified for short wave radiation.')
    
    rscl1 = -1./coef1
    rscl2 = -1./coef2
    
    write(stdoutunit,*)'=>Note: computing solar shortwave penetration with Jerlov exponentials '
    write(stdoutunit,*)'        R  = ',rpart
    write(stdoutunit,*)'        z1 = ',coef1
    write(stdoutunit,*)'        z2 = ',coef2
    if(override_f_vis) then
      write(stdoutunit,*)'=>Note: using vis/(IR+vis) fraction f_vis = ',f_vis_in 
      write(stdoutunit,*)'  A value different from 1. is not consistent with the '
      write(stdoutunit,*)'  original work of Paulson and Simpson (1977).'
    endif
    
    if(sw_pen_fixed_depths) then 
#ifndef MOM_STATIC_ARRAYS    
      allocate (sw_frac_zw_fix(0:nk))
      allocate (sw_frac_zt_fix(1:nk))
#endif
      sw_frac_zw_fix = 0.
      sw_frac_zt_fix = 0.
      do k=1,nk
         depth = Grd%zt(k)
         if ( depth <= zmax_pen ) then
            efold1   = depth * rscl1; efold2   = depth * rscl2
            sw_frac_zt_fix(k) = rpart*exp(efold1) + (1.-rpart)*exp(efold2) 
         endif
      enddo
      do k=1,nk-1
         depth = Grd%zw(k)
         if ( depth <= zmax_pen ) then
            efold1   = depth * rscl1; efold2   = depth * rscl2
            sw_frac_zw_fix(k) = rpart*exp(efold1) + (1.-rpart)*exp(efold2) 
         endif
      enddo
    endif  

end subroutine ocean_shortwave_jerlov_init
! </SUBROUTINE> NAME="ocean_shortwave_jerlov_init"



!#######################################################################
! <SUBROUTINE NAME="sw_source_jerlov">
!
! <DESCRIPTION>
! Add short wave penetrative heating to T_prog(index_temp)%th_tendency.
!
! Note that the divergence of shortwave for the first
! level "div_sw(0)" is compensating for the effect of having
! the shortwave component already included in the total
! surface tracer flux "stf(i,j,temp)"
!
! </DESCRIPTION>
subroutine sw_source_jerlov (Thickness, T_diag, swflx, swflx_vis, index_irr, Temp, sw_frac_zt, opacity)

  type(ocean_thickness_type),    intent(in)    :: Thickness
  type(ocean_diag_tracer_type),  intent(inout) :: T_diag(:)
  real, dimension(isd:,jsd:) ,   intent(in)    :: swflx
  real, dimension(isd:,jsd:),    intent(in)    :: swflx_vis
  integer,                       intent(in)    :: index_irr
  type(ocean_prog_tracer_type),  intent(inout) :: Temp
  real, dimension(isd:,jsd:,:),  intent(inout) :: sw_frac_zt
  real, dimension(isd:,jsd:,:),  intent(inout) :: opacity

  real, dimension(isd:ied,jsd:jed)       :: f_vis
    
  real    :: efold1, efold2, efold_ir, zenith_angle, depth
  real    :: swmax, swmin

  real    :: div_sw 
  integer :: i, j, k, kp1

  integer :: stdoutunit 
  stdoutunit=stdout() 

  call mpp_clock_begin(id_sw_pen)  

  ! zero out the wrk1 array used to diagnose heating from shortwave 
  Temp%wrk1(:,:,:) = 0.0

  if (.not. use_this_module) return 

  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_shortwave_jerlov_mod (sw_source_jerlov): module must be initialized ')
  endif 
  if (Temp%name /= 'temp') then 
    call mpp_error(FATAL, &
    '==>Error in ocean_shortwave_pen_mod (sw_source): invalid tracer for sw_source')
  endif 

  ! only compute 3-D sw_fract for ocean regions shallower than zmax_pen 
  f_vis(:,:)        = 0.0
  sw_frac_zw(:,:,:) = 0.
  sw_frac_zt(:,:,:) = 0.
  sw_frac_zw(:,:,0) = sw_frac_top

  if(override_f_vis) then
     do j=jsc,jec
       do i=isc,iec
         f_vis(i,j) = f_vis_in
       enddo
    enddo
  else
    do j=jsc,jec
      do i=isc,iec
        f_vis(i,j) = max(swflx_vis(i,j)/(epsln + swflx(i,j)),epsln)
      enddo
    enddo
  endif
  
! If the zenith angle comes from astronomy, move these lines into the i,j-loops
  zenith_angle = 0.0
!  rscl_ir = -1./(0.267 * cos(zenith_angle))
  rscl_ir = -1./0.267 
  
  if(sw_pen_fixed_depths) then 

     do k=1,nk
        depth = Grd%zt(k)
        efold_ir = exp( depth * rscl_ir )
        do j=jsc,jec
           do i=isc,iec
              if ( depth <= zmax_pen .and. Grd%tmask(i,j,k) /= 0) then
                 sw_frac_zt(i,j,k) = (1-f_vis(i,j)) *efold_ir    &
                          + f_vis(i,j)  * sw_frac_zt_fix(k)
              endif
           enddo  ! i-loop finish 
        enddo  ! j-loop finish 
     enddo
     do k=1,nk-1
        kp1 = k+1
        depth = Grd%zw(k)
        efold_ir = exp( depth * rscl_ir )
        do j=jsc,jec
           do i=isc,iec
              if ( depth <= zmax_pen .and. Grd%tmask(i,j,kp1) /= 0) then
                 sw_frac_zw(i,j,k) = (1-f_vis(i,j)) * efold_ir   &
                          + f_vis(i,j)  * sw_frac_zw_fix(k)
              endif
           enddo  ! i-loop finish 
        enddo  ! j-loop finish 
     enddo

  else

  ! determine depths to T-points and W-points
     wrk3(:,:,:) = 0.0
     wrk4(:,:,:) = 0.0
     if(vert_coordinate==GEOPOTENTIAL) then 
       do j=jsd,jed
         do i=isd,ied
            wrk3(i,j,1) = Thickness%dzwt(i,j,0)
            wrk4(i,j,1) = Thickness%dzt(i,j,1)
         enddo
       enddo
       do k=2,nk
         do j=jsd,jed
            do i=isd,ied
               wrk3(i,j,k) = wrk3(i,j,k-1) + Thickness%dzwt(i,j,k-1)
               wrk4(i,j,k) = wrk4(i,j,k-1) + Thickness%dzt(i,j,k)
            enddo
         enddo
       enddo
     else 
       do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               wrk3(i,j,k) = Thickness%depth_zt(i,j,k)
               wrk4(i,j,k) = Thickness%depth_zwt(i,j,k)
            enddo
         enddo
       enddo
     endif
     
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              depth = wrk3(i,j,k)
              if ( depth <= zmax_pen .and. Grd%tmask(i,j,k) /= 0) then
                 efold1   = depth * rscl1
                 efold2   = depth * rscl2
                 efold_ir = depth * rscl_ir
                 sw_frac_zt(i,j,k) = (1-f_vis(i,j)) * exp( efold_ir )   &
                          + f_vis(i,j)  * ( rpart*exp(efold1) + (1.-rpart)*exp(efold2) )
              endif
           enddo  ! i-loop finish 
        enddo  ! j-loop finish 
     enddo

!The deepest interface is never to another ocean cell
!Hence, sw_frac_zw(i,j,nk) = 0 in any case
     do k=1,nk-1 
        kp1 = k+1
        do j=jsc,jec
           do i=isc,iec
              depth = wrk4(i,j,k)
              if ( depth <= zmax_pen .and. Grd%tmask(i,j,kp1) /= 0) then
                 efold1   = depth * rscl1
                 efold2   = depth * rscl2
                 efold_ir = depth * rscl_ir
                 sw_frac_zw(i,j,k) = (1-f_vis(i,j)) * exp( efold_ir )   &
                          + f_vis(i,j)  * ( rpart*exp(efold1) + (1.-rpart)*exp(efold2) )
              endif
           enddo  ! i-loop finish 
        enddo  ! j-loop finish 
     enddo
  endif

  if(enforce_sw_frac) then   
      do k=2,nk
         do j=jsc,jec
            do i=isc,iec
               sw_frac_zt(i,j,k) = min(sw_frac_zt(i,j,k),sw_frac_zt(i,j,k-1))
            enddo
         enddo
      enddo
  endif

  if (index_irr > 0) then 
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               T_diag(index_irr)%field(i,j,k) = swflx(i,j) * sw_frac_zt(i,j,k) 
            enddo
         enddo
      enddo
  endif

  ! compute and load heating rate.
  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        div_sw           = sw_frac_zw(i,j,k-1) - sw_frac_zw(i,j,k)
        Temp%wrk1(i,j,k) = Grd%tmask(i,j,k)*swflx(i,j)*div_sw
      enddo
    enddo
  enddo
  
  ! Compute opacity, which is used by biogeochemistry. 
  ! We split off the k=1 level, since sw_frac_zw(k=0)=sw_frac_top,
  ! which is typically set to sw_frac_top=0.0 for purposes of 
  ! accounting (as swflx is also in stf(index_temp). A value 
  ! of sw_frac_zw(k=0)=0.0 to compute opacity would result in a
  ! negative opacity at k=1, which is not physical. Instead, for 
  ! purposes of opacity calculation, we need sw_frac_zw(k=0)=1.0. 
  k=1
  do j=jsc,jec
     do i=isc,iec           
        opacity(i,j,k) = -log( sw_frac_zw(i,j,k)/(f_vis(i,j)+epsln) + epsln) &
                          /(Thickness%dzt(i,j,k) + epsln)
     enddo
  enddo
  do k=2,nk-1
     do j=jsc,jec
        do i=isc,iec           
           opacity(i,j,k) = -log( sw_frac_zw(i,j,k)/(sw_frac_zw(i,j,k-1)+epsln) + epsln) &
                             /(Thickness%dzt(i,j,k) + epsln)
        enddo
     enddo
  enddo
  if(debug_this_module) then 
     do k=2,nk
        swmax=maxval(sw_frac_zw(isc:iec,jsc:jec,k))
        call mpp_max(swmax);write(stdoutunit,*)'In ocean_shortwave_jerlov : max sw_fk_zw=',swmax
        swmin=maxval(sw_frac_zw(isc:iec,jsc:jec,k))
        call mpp_min(swmin);write(stdoutunit,*)'In ocean_shortwave_jerlov : min sw_fk_zw=',swmin
     enddo
  endif
  
  call mpp_clock_end(id_sw_pen)

end subroutine sw_source_jerlov
! </SUBROUTINE> NAME="sw_source_jerlov"

end module ocean_shortwave_jerlov_mod

module atmos_sulfur_hex_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Jeff Greenblatt
! </CONTACT>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   William Cooke
! </REVIEWER>


! <OVERVIEW>
!     This code allows the implementation of sulfur hexafluoride
!     tracer in the FMS framework.
! </OVERVIEW>

! <DESCRIPTION>

! </DESCRIPTION>

! <DATASET NAME="Sulfur hexaflouride emissions">
!
! Monthly.emissions contains the estimated global emission rate of SF6 in
! Gg/yr for 62 months between December 1988 and January 1994, inclusive.
! These are based on the annual estimates of Levin and Hesshaimer
! (submitted), and have been linearly interpolated to monthly values. The
! last half of 1993 has been extrapolated using the trend for the previous 12
! months. 
!
!   The dataset can be obtained from the contact person above.
! </DATASET>  
! <INFO>

!   <REFERENCE>
!Levin, I. and V. Hessahimer: Refining of atmospheric
! transport model entries by the globally observed passive tracer
! distributions of 85Krypton and Sulfur Hexafluoride (SF6). Submitted to the
! Journal of Geophysical Research.
! </REFERENCE>
!</INFO>

use              fms_mod, only : file_exist,           &
!                                 open_file,            &
                                 mpp_pe,               &
                                 mpp_root_pe,          &
                                 stdlog, stdout,       &
                                 close_file,           &
                                 write_version_number
use              mpp_mod, only : get_unit
use     time_manager_mod, only : time_type,            &
                                 set_date,             &
                                 operator( > ),        &
                                 operator( < ),        &
                                 operator( >= )
use     diag_manager_mod, only : send_data,            &
                                 register_diag_field,  &
                                 register_static_field
use   tracer_manager_mod, only : get_tracer_index
use    field_manager_mod, only : MODEL_ATMOS
use atmos_tracer_utilities_mod, only : interp_emiss
use        constants_mod, only : grav, PI

implicit none
private
!-----------------------------------------------------------------------
!----- interfaces -------

public  atmos_sf6_sourcesink, atmos_sulfur_hex_init, atmos_sulfur_hex_end

!-----------------------------------------------------------------------
!----------- namelist -------------------
!-----------------------------------------------------------------------
!
!  When initializing additional tracers, the user needs to make the
!  following changes.
!
!  Add an integer variable below for each additional tracer. This should
!  be initialized to zero. 
!
!-----------------------------------------------------------------------

! tracer number for radon
integer :: nsf6     =0


!--- identification numbers for  diagnostic fields and axes ----

integer :: id_emiss

!--- Arrays to help calculate tracer sources/sinks ---
real, allocatable, dimension(:,:) :: sf6_grid

integer, parameter :: NUM_SF6_RATE = 62 !number of entries in file 'monthly.emissions'
type sf6_rate_type
  type(time_type) :: Time
  real :: rate
end type sf6_rate_type
type(sf6_rate_type), dimension(NUM_SF6_RATE) :: sf6_rate

character(len=6), parameter :: module_name = 'tracer'

logical :: module_is_initialized=.FALSE.
logical :: used

!---- version number -----
character(len=128) :: version = '$Id: atmos_sulfur_hex.F90,v 19.0 2012/01/06 20:31:28 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
!-----------------------------------------------------------------------

contains

!#######################################################################
!<SUBROUTINE NAME="atmos_sf6_sourcesink">
!<OVERVIEW>
! A routine to calculate the sources and sinks of sulfur hexafluoride.
!</OVERVIEW>
!<DESCRIPTION>
! A routine to calculate the sources and sinks of sulfur hexafluoride.
!</DESCRIPTION>
!<TEMPLATE>
!call atmos_sf6_sourcesink (lon, lat, land, pwt, sf6, sf6_dt, 
!        Time, is, ie, js, je, kbot)
!
!</TEMPLATE>
!   <IN NAME="lon" TYPE="real" DIM="(:,:)">
!     Longitude of the centre of the model gridcells.
!   </IN>
!   <IN NAME="lat" TYPE="real" DIM="(:,:)">
!     Latitude of the centre of the model gridcells.
!   </IN>
!   <IN NAME="land" TYPE="real" DIM="(:,:)">
!     Land/sea mask.
!   </IN>
!   <IN NAME="pwt" TYPE="real" DIM="(:,:,:)">
!     The pressure weighting array. = dP/grav
!   </IN>
!   <IN NAME="sf6" TYPE="real" DIM="(:,:,:)">
!     The array of the sulfur hexafluoride mixing ratio.
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="is, ie, js, je" TYPE="integer">
!     Local domain boundaries.
!   </IN>
!   <IN NAME="kbot" TYPE="integer, optional" DIM="(:,:)">
!     Integer array describing which model layer intercepts the surface.
!   </IN>

!   <OUT NAME="sf6_dt" TYPE="real" DIM="(:,:,:)">
!     The array of the tendency of the sulfur hexafluoride mixing ratio.
!   </OUT>
!
subroutine atmos_sf6_sourcesink (lon, lat, land, pwt, sf6, sf6_dt, &
        Time, is, ie, js, je, kbot)
!-----------------------------------------------------------------------
   real, intent(in),  dimension(:,:)   :: lon, lat
   real, intent(in),  dimension(:,:)   :: land
   real, intent(in),  dimension(:,:,:) :: pwt, sf6
   real, intent(out), dimension(:,:,:) :: sf6_dt
     type(time_type), intent(in) :: Time     
integer, intent(in),  dimension(:,:), optional :: kbot
integer, intent(in)                    :: is, ie, js, je
!-----------------------------------------------------------------------
   real, dimension(size(sf6,1),size(sf6,2),size(sf6,3)) ::  &
         source, sink
integer :: i,j,kb,kd, id,jd
real :: rate ! sf6 interpolated emission rate
!-----------------------------------------------------------------------

      id=size(sf6,1); jd=size(sf6,2); kd=size(sf6,3)

source=0.0
! Interpolate SF6 global emission rate from sf6_rate (time dependent). For now
! just use first or last entry if time falls outside the bounds of the table.

      if (Time < sf6_rate(1)%Time) then
        rate=0. !previously sf6_rate(1)%Rate
      else
        if (Time > sf6_rate(size(sf6_rate(:)))%Time) then
          rate=sf6_rate(size(sf6_rate(:)))%Rate !just keep fixed past end of array
        else
          do i=1,size(sf6_rate(:))-1 !This can be optimized with efficient search
            if (Time >= sf6_rate(i)%Time .and. Time < sf6_rate(i+1)%Time) then
              rate=sf6_rate(i)%Rate
              exit
            endif
          enddo
        endif
      endif

      if (present(kbot)) then
          do j=1,jd
          do i=1,id
             kb=kbot(i,j)
             source(i,j,kb)=sf6_grid(i,j+js-1)*rate/pwt(i,j,kb)
          enddo
          enddo
      else
          do j=1,jd
            source(:,j,kd)=sf6_grid(:,j+js-1)*rate/pwt(:,j,kd)
          enddo
      endif
      
      sink=0.0

      sf6_dt=source+sink

end subroutine atmos_sf6_sourcesink
!</SUBROUTINE>

!#######################################################################
!<SUBROUTINE NAME="atmos_sulfur_hex_init">
!<OVERVIEW>
! The constructor routine for the sulfur hexafluoride module.
!</OVERVIEW>
!<DESCRIPTION>
! A routine to initialize the sulfur hexafluoride module.
!</DESCRIPTION>
!<TEMPLATE>
!call atmos_sulfur_hex_init (lonb, latb, r, axes, Time, mask)
!</TEMPLATE>
!   <IN NAME="lonb" TYPE="real" DIM="(:,:)">
!     The longitude corners for the local domain.
!   </IN>
!   <IN NAME="latb" TYPE="real" DIM="(:,:)">
!     The latitude corners for the local domain.
!   </IN>
!   <INOUT NAME="r" TYPE="real" DIM="(:,:,:,:)">
!     Tracer fields dimensioned as (nlon,nlat,nlev,ntrace). 
!   </INOUT>
!   <IN NAME="mask" TYPE="real, optional" DIM="(:,:,:)">
!      optional mask (0. or 1.) that designates which grid points
!           are above (=1.) or below (=0.) the ground dimensioned as
!           (nlon,nlat,nlev).
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="axes" TYPE="integer" DIM="(4)">
!     The axes relating to the tracer array dimensioned as
!      (nlon, nlat, nlev, ntime)
!   </IN>

 subroutine atmos_sulfur_hex_init (lonb, latb, r, axes, Time, mask)

!-----------------------------------------------------------------------
!
!   r    = tracer fields dimensioned as (nlon,nlat,nlev,ntrace)
!   mask = optional mask (0. or 1.) that designates which grid points
!          are above (=1.) or below (=0.) the ground dimensioned as
!          (nlon,nlat,nlev).
!
!-----------------------------------------------------------------------
real,            intent(in),    dimension(:,:)             :: lonb, latb
real,            intent(inout), dimension(:,:,:,:)         :: r
real,            intent(in),    dimension(:,:,:), optional :: mask
type(time_type), intent(in)                                :: Time
integer        , intent(in)                                :: axes(4)

integer :: n
!-----------------------------------------------------------------------
!
!  When initializing additional tracers, the user needs to make changes 
!  to two namelists. 
!
!  In what is core_namelist in the run_script (atmos_*_input.nml)
!  ntrace and ntprog need to be changed in &atmosphere_nml so that 
!  the number is the numbers of tracers in this module plus 
!  one (specific humidity I believe)
!
!  In what is phys_namelist in the run_script ( atmos_param_*_input.nml)
!  the namelist &tracer_driver_nml needs to be extended with numbers 
!  corresponding to each tracer. Thes numbers should be positive and 
!  non-zero.
!
!-----------------------------------------------------------------------
      integer  logunit, outunit

      if (module_is_initialized) return

!---- write namelist ------------------

      call write_version_number(version, tagname)

      n = get_tracer_index(MODEL_ATMOS,'sf6')
      if (n>0) then
        nsf6=n
        logunit=stdlog()
        outunit=stdout()
        if (nsf6 > 0 .and. mpp_pe() == mpp_root_pe()) write (outunit,30) 'SF6',nsf6
        if (nsf6 > 0 .and. mpp_pe() == mpp_root_pe()) write (logunit,30) 'SF6',nsf6
      endif

  30        format (A,' was initialized as tracer number ',i2)
      !Read in emission files
      

     id_emiss = register_static_field ( 'tracers',                    &
                     'sf6emiss', axes(1:2),       &
                     'sulfhexemiss', 'g/m2/s')

   allocate (sf6_grid(size(lonb,1)-1,size(latb,2)-1))


      call sf6_init(Time)

      module_is_initialized = .TRUE.
!-----------------------------------------------------------------------
 end subroutine atmos_sulfur_hex_init
!</SUBROUTINE>



!######################################################################

subroutine sf6_init(Time)
type(time_type), intent(in) :: Time
!-------------------------------------------------
!-------------------------------------------------
      integer      :: i,j,unit !,imon,irec,n,io
      real         :: dtr,deg_90, deg_180, gxdeg, gydeg
      real         :: GEIA(720, 360)
      integer, parameter :: k6=selected_int_kind(6) ! find kind sufficient for 6 digit integer precision
      integer(kind=k6) :: t ! temporary time variable of kind k6
      integer      :: y,m,d ! calendar vars
!-------------------------------------------------
      real :: MW_air=28.9644 ! molecular wt. of air (gm/mole)
      real :: MW_sf6=86.0 ! molecular wt. of sf6 (gm/mole) PLEASE CHECK!
      logical :: used

      dtr=PI/180.
      deg_90= -90.*dtr; deg_180= -180.*dtr ! -90 and -180 degrees are the southwest boundaries 
                                           ! of the emission field you are reading in.

! Read in GEIA SF6 emission distribution grid and determine sizes:
!
! GEIA grid arrangement (taken from snf's togasp.f code documentation):
!     i  = 1 is centered at 179.75w
!     i increases eastward
!     j  = 1 is centered at 89.75s
!     j increases northward
!
!       88.5s - | - - - | - - - | - - - | - -
!               | (1,3) | (2,3) | (3,3) |
!       89s   - | - - - | - - - | - - - | - -
!               | (1,2) | (2,2) | (3,2) |
!       89.5s - | - - - | - - - | - - - | - -
!               | (1,1) | (2,1) | (3,1) |
!       90s -   | - - - | - - - | - - - |
!              180w   179.5w  179w    178.5w

      unit = get_unit()
      open(unit,file='distribution.grid', form='formatted',action='read')
      do j = 1, 360 !rearrange input array so begins at 0 E
        read(unit,'(5e16.8)') (GEIA(I,J), I=361,720)
        read(unit,'(5e16.8)') (GEIA(I,J), I=  1,360)
      end do
      close(unit) 

      gxdeg=360./size(GEIA,1)*dtr
      gydeg=180./size(GEIA,2)*dtr

      call interp_emiss (GEIA, deg_180, deg_90, gxdeg, gydeg, sf6_grid)

! Note: must do scaling of global integral to 3.1828e-2 (for kg/m2/s) or 2750.
! (for kg/m2/day), according to S.-M. Fan.

! Scale to same units as used for radon (see radon_sourcesink):

      sf6_grid=sf6_grid * grav * MW_air / MW_sf6

! Now read in emission rate table. Comments from README file supplied by
! Song-Miao Fan:
! "Monthly.emissions contains the estimated global emission rate of SF6 in
! Gg/yr for 62 months between December 1988 and January 1994, inclusive.
! These are based on the annual estimates of Levin and Hesshaimer
! (submitted), and have been linearly interpolated to monthly values. The
! last half of 1993 has been extrapolated using the trend for the previous 12
! months. (Ref: Levin, I. and V. Hessahimer: Refining of atmospheric
! transport model entries by the globally observed passive tracer
! distributions of 85Krypton and Sulfur Hexafluoride (SF6). Submitted to the
! Journal of Geophysical Research)."
!
! Units are Gg/yr. When multiplied by sf6_grid cell, units will be kg/m2/s.
!
! Note time is in integer YYMMDD format, which must be converted to Time_type
! for storage in the sf6_rate array.
!
      unit = get_unit()
      open(unit,file='monthly.emissions', form='formatted',action='read')
      do j = 1, size(sf6_rate(:))
        read(unit,'(i6,2x,f7.5)') t, sf6_rate(j)%rate
! convert YYMMDD into components:
        y=int(t/10000)
        m=int((t-y*10000)/100)
        d=mod(t,100)
! shift start year to 1981 (start date 1981.12.15):
        y=y-88+1981 ! y was 2-digit year
! now convert to time_type format and store:
        sf6_rate(j)%Time=set_date(y, m, d)
      end do
      close(unit) 

         if (id_emiss > 0 ) &
         used = send_data ( id_emiss, sf6_grid, Time )
         
      end subroutine sf6_init

!######################################################################
!<SUBROUTINE NAME="sulfur_hex_end">
!<OVERVIEW>
!  The destructor routine for the sulfur hexafluoride module.
!</OVERVIEW>
! <DESCRIPTION>
! This subroutine is the exit routine for the sulfur hexafluoride module.
! </DESCRIPTION>
!<TEMPLATE>
! call atmos_sulfur_hex_end
!</TEMPLATE>

 subroutine atmos_sulfur_hex_end
 
      module_is_initialized = .FALSE.

 end subroutine atmos_sulfur_hex_end
!</SUBROUTINE>


end module atmos_sulfur_hex_mod

module river_physics_mod 

!-----------------------------------------------------------------------
!                   GNU General Public License                        
!                                                                      
! This program is free software; you can redistribute it and/or modify it and  
! are expected to follow the terms of the GNU General Public License  
! as published by the Free Software Foundation; either version 2 of   
! the License, or (at your option) any later version.                 
!                                                                      
! For the full text of the GNU General Public License,               
! write to: Free Software Foundation, Inc.,                           
!           675 Mass Ave, Cambridge, MA 02139, USA.                   
! or see:   http://www.gnu.org/licenses/gpl.html                      
!-----------------------------------------------------------------------
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Kirsten Findell </CONTACT> 
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Zhi Liang </CONTACT> 

#ifdef INTERNAL_FILE_NML
  use mpp_mod, only: input_nml_file
#else
  use fms_mod, only: open_namelist_file
#endif

  use mpp_mod,         only : mpp_sync_self, mpp_send, mpp_recv, EVENT_RECV, EVENT_SEND
  use mpp_mod,         only : mpp_npes, mpp_error, FATAL, mpp_get_current_pelist
  use mpp_mod,         only : mpp_root_pe, mpp_pe, mpp_max
  use mpp_mod,         only : COMM_TAG_1, COMM_TAG_2, COMM_TAG_3, COMM_TAG_4
  use mpp_domains_mod, only : domain2d, mpp_get_compute_domain, mpp_get_data_domain
  use mpp_domains_mod, only : ZERO, NINETY, MINUS_NINETY, mpp_update_domains 
  use mpp_domains_mod, only : mpp_get_compute_domains
  use mpp_domains_mod, only : mpp_get_num_overlap, mpp_get_overlap
  use mpp_domains_mod, only : mpp_get_update_size, mpp_get_update_pelist
  use fms_mod,         only : stdlog, write_version_number
  use fms_mod,         only : close_file, check_nml_error, file_exist
  use diag_manager_mod,only : register_diag_field, send_data
  use river_type_mod,  only : river_type, Leo_Mad_trios, NO_RIVER_FLAG
  use lake_mod,        only : large_dyn_small_stat
  use lake_tile_mod,   only : num_l
  use constants_mod,   only : tfreeze, hlf, DENS_H2O
  use land_debug_mod,  only : set_current_point, is_watch_cell

  implicit none
  private

  real    :: missing = -1.e8

!--- version information ---------------------------------------------
  character(len=128) :: version = '$Id: river_physics.F90,v 20.0 2013/12/13 23:29:43 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'


! ---- public interfaces -----------------------------------------------------

  public :: river_physics_init, river_physics_step, river_impedes_lake, river_impedes_large_lake

!----------------------------------------------------------------------
  real               :: clw = 4218.
  real               :: csw = 2106.
  real,    parameter :: sec_in_day = 86400.
  integer :: num_lake_lev

! ---- namelist interface
  character*6 :: algor = 'linear'
  real :: lake_outflow_frac_ceiling = 1.e20
  real :: lake_sfc_w_min = -1.e20
  real :: storage_threshold_for_melt = 1.
  real :: storage_threshold_for_diag = 1.e6
  logical :: ice_frac_from_sfc = .false.
  logical :: use_lake_area_bug = .false.
  logical :: zero_frac_bug     = .false. ! it TRUE, reverts to quebec (buggy)
      ! behavior, where the discharge points with zero land fraction were
      ! missed, resulting in water non-conservation
  real :: ice_frac_factor = 0.
  logical :: prohibit_cold_ice_outflow = .TRUE. ! default retrieves old behavior,
      ! to activate bugfix, set it to FALSE
  logical :: lockstep = .false. ! set to true to recognize that lake level falls
      ! in lockstep with river when integrating river storage
  logical :: river_impedes_lake = .false.
  logical :: river_impedes_large_lake = .true.

  namelist /river_physics_nml/ algor, lake_outflow_frac_ceiling, &
                               lake_sfc_w_min, storage_threshold_for_melt, &
                               storage_threshold_for_diag, &
                               ice_frac_from_sfc, ice_frac_factor, &
                               use_lake_area_bug, zero_frac_bug, &
                               prohibit_cold_ice_outflow, lockstep, &
                               river_impedes_lake, river_impedes_large_lake

  integer, parameter, dimension(8) :: di=(/1,1,0,-1,-1,-1,0,1/)
  integer, parameter, dimension(8) :: dj=(/0,-1,-1,-1,0,1,1,1/)
  integer                          :: isc, iec, jsc, jec  ! compute domain
  integer                          :: isd, ied, jsd, jed  ! data domain
  integer                          :: maxtravel
  integer                          :: npes
  integer                          :: num_species
 
  type comm_type
     integer          :: count
     integer          :: pe
     integer, pointer :: i(:) => NULL()
     integer, pointer :: j(:) => NULL()
     integer, pointer :: k(:) => NULL()
  end type comm_type

  type halo_update_type
     type(comm_type), pointer :: send(:) => NULL();
     type(comm_type), pointer :: recv(:) => NULL();
  end type halo_update_type

  type(halo_update_type),  allocatable :: halo_update(:)
  integer                              :: nsend_update, nrecv_update
  real, dimension(:),      allocatable :: send_buffer, recv_buffer
  logical, dimension(:,:), allocatable :: in_domain
  integer, dimension(:,:), allocatable :: nlev

  ! ---- diag field IDs
  integer :: id_temp, id_ice
  integer :: id_temp_old, id_ice_old ! for compatibility with older diagTables

contains

!#######################################################################

  subroutine river_physics_init(River, domain, id_lon, id_lat )
    type(river_type), intent(inout) :: River
    type(domain2d),   intent(inout) :: domain
    integer, intent(in) :: id_lon, id_lat ! diag field IDs

    integer                         :: unit, io_status, ierr
    integer                         :: i, j


!--- read namelist -------------------------------------------------
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=river_physics_nml, iostat=io_status)
    ierr = check_nml_error(io_status, 'river_physics_nml')
#else
    if (file_exist('input.nml')) then
      unit = open_namelist_file()
      ierr = 1;
      do while ( ierr/=0 )
         read  (unit, river_physics_nml, iostat=io_status, end=10)
         ierr = check_nml_error(io_status,'river_physics_nml')
      enddo
10    continue
      call close_file (unit)
    endif
#endif

!--- write version and namelist info to logfile --------------------
    call write_version_number(version, tagname)
    unit=stdlog()
    write (unit, river_physics_nml)  

    npes     = mpp_npes()

    call mpp_get_compute_domain(domain, isc, iec, jsc, jec)
    call mpp_get_data_domain(domain, isd, ied, jsd, jed)

    num_lake_lev = num_l
    num_species = size(River%outflow_c,3)
    maxtravel = maxval(River%travel)
    call mpp_max(maxtravel)

!--- set up the halo update 
    call setup_halo_update(River, domain)

    River%i_tocell = NO_RIVER_FLAG; River%j_tocell = NO_RIVER_FLAG
    do j = jsc, jec
       do i = isc, iec
          if(River%tocell(i,j) > 0) then
             River%i_tocell(i,j) = i + di(River%tocell(i,j))
             River%j_tocell(i,j) = j + dj(River%tocell(i,j))
          end if
       end do
    end do
 
    ! ---- register diagnostic fields
    id_ice  = register_diag_field ( 'river', 'rv_ice', (/id_lon, id_lat/), &
         River%Time, 'river ice mass fraction', '-', missing_value=missing, &
         mask_variant=.TRUE. )
    id_temp = register_diag_field ( 'river', 'rv_T', (/id_lon, id_lat/), &
         River%Time, 'river temperature', 'K', missing_value=missing, &
         mask_variant=.TRUE. )

    id_ice_old = register_diag_field ( 'river', 'ice', (/id_lon, id_lat/), &
         River%Time, 'obsolete, pls use rv_ice', '-', missing_value=missing, &
         mask_variant=.TRUE. )
    id_temp_old = register_diag_field ( 'river', 'temp', (/id_lon, id_lat/), &
         River%Time, 'obsolete, pls use rv_T', 'K', missing_value=missing, &
         mask_variant=.TRUE. )
  end subroutine river_physics_init

!#####################################################################

  subroutine river_physics_step(River, cur_travel, &
         lake_sfc_A, lake_sfc_bot, lake_depth_sill, lake_width_sill, &
         lake_whole_area, lake_T, lake_wl, lake_ws )

    type(river_type),     intent(inout) :: River
    integer,                 intent(in) :: cur_travel

    real, dimension(isd:ied,jsd:jed), intent(in) :: &
                             lake_sfc_A, lake_sfc_bot
    real, dimension(isd:ied,jsd:jed,num_lake_lev), intent(inout) :: &
                             lake_wl, lake_ws
    real, dimension(isc:iec,jsc:jec), intent(in) :: &
                lake_depth_sill, lake_width_sill, lake_whole_area
    real, dimension(isc:iec,jsc:jec,num_lake_lev), intent(inout) :: &
                             lake_T
! ---- local vars ----------------------------------------------------------
    integer   :: i, j, to_i, to_j, i_species, lev
    real      :: Q0, dQ_dV, dh_dQ, avail, out_frac, qmelt
    real      :: liq_to_flow, ice_to_flow, liq_this_lev, ice_this_lev
    real      :: lake_area, h, ql, qs, qh, qt, h0, t_scale
    real      :: influx
    real      :: influx_c(River%num_species)
    real      :: v_r_d(River%num_species-River%num_c+1:River%num_species)
    real      :: conc(1:River%num_species)
    logical, dimension(isc:iec,jsc:jec) :: &
         diag_mask ! mask of valid ice and temperature values fo diagnostics
    real, dimension(isc:iec,jsc:jec) :: &
         ice, temperature ! variables for diag output (were in River_type) 
    logical :: used ! flag returned by the send_data

    ! invalidate diag_mask everywhere
    diag_mask = .FALSE.

    ! do for all cells at current number of steps from river mouth
    do j = jsc, jec 
      do i = isc, iec
        call set_current_point(i,j,1) ! for debug output
        if (River%travel(i,j)==cur_travel.and.&
            ((.not.zero_frac_bug).or.(River%landfrac(i,j).gt.0))) then
            ! if zero_frac_bug is FALSE, the second line of condition is
            ! always TRUE, so we revert to bugfix
            ! if zero_frac_bug is TRUE, the second line is simply
            ! River%landfrac(i,j).gt.0, so we get quebec (buggy) condition

            ! FIRST COMPUTE LAKE MASS BALANCE (FROM INFLOC AND INFLOW TO LAKE_OUTFLOW)
          
            lake_area = lake_sfc_A(i,j)
            influx   =(River%inflow  (i,j)  +River%infloc  (i,j))  *DENS_H2O*River%dt_slow
            influx_c =(River%inflow_c(i,j,:)+River%infloc_c(i,j,:))*DENS_H2O*River%dt_slow
            if (River%tocell(i,j).eq.0 .and. River%landfrac(i,j).ge.1.) then
                ! terminal, all-land cell (must have lake)
                h = (clw*lake_wl(i,j,1)+csw*lake_ws(i,j,1))*(lake_T(i,j,1)-tfreeze)
                lake_wl(i,j,1) = lake_wl(i,j,1) + (influx-influx_c(1))/lake_area
                lake_ws(i,j,1) = lake_ws(i,j,1) +         influx_c(1) /lake_area
                lake_T (i,j,1) = tfreeze + &
                   (h+influx_c(2)/lake_area)/(clw*lake_wl(i,j,1)+csw*lake_ws(i,j,1))
                ! LAKE_SFC_C(I,J,:) = LAKE_SFC_C(I,J,:) + INFLUX_C / LAKE_AREA
              else
                ! non-terminal all-land cell (possible lake), or terminal coastal cell (possible lake)
                if (lake_area.gt.0.) then
                     if (is_watch_cell()) then
                          write(*,*) 'lake_wl(1):', lake_wl(i,j,1)
                          write(*,*) 'lake_ws(1):', lake_ws(i,j,1)
                          write(*,*) 'lake_T (1):', lake_T (i,j,1)
                     endif
                     h = (clw*lake_wl(i,j,1)+csw*lake_ws(i,j,1))*(lake_T(i,j,1)-tfreeze)
                     lake_wl(i,j,1) = lake_wl(i,j,1) + (influx-influx_c(1))/lake_area
                     lake_ws(i,j,1) = lake_ws(i,j,1) +         influx_c(1) /lake_area
                     lake_T (i,j,1) = tfreeze + &
                        (h+influx_c(2)/lake_area)/(clw*lake_wl(i,j,1)+csw*lake_ws(i,j,1))
                     if (is_watch_cell()) then
                          write(*,*) 'lake_wl(1):', lake_wl(i,j,1)
                          write(*,*) 'lake_ws(1):', lake_ws(i,j,1)
                          write(*,*) 'lake_T (1):', lake_T (i,j,1)
                     endif
                     ! LAKE_SFC_C(I,J,:) = LAKE_SFC_C(I,J,:) + INFLUX_C / LAKE_AREA
                     h0 = lake_sfc_bot(i,j) + (lake_wl(i,j,1)+lake_ws(i,j,1))/DENS_H2O &
                                           -lake_depth_sill(i,j)
                     qt = lake_area * h0 * DENS_H2O
                     ! qt is mass of water stored transiently above sill
                     ! now reduce it to amount that discharges this time step
                     if (qt.gt.0.) then
                         IF (large_dyn_small_stat) THEN
                             if (is_watch_cell()) write(*,*) 'qt[1]/A', qt/lake_area
                             if (lake_width_sill(i,j) .gt. 0.) then
                                 t_scale = lake_whole_area(i,j)/(0.9*lake_width_sill(i,j)*sqrt(h0))
                                 qt = qt * (1. - (1.+River%dt_slow/t_scale)**(-2) )
                                 if (.not.use_lake_area_bug) qt = qt * lake_whole_area(i,j)/lake_area
                               endif
                             if (is_watch_cell()) write(*,*) 'qt[2]/A', qt/lake_area
                             qt = min(qt, lake_outflow_frac_ceiling * lake_area &
                                          * max(0.,(lake_wl(i,j,1)+lake_ws(i,j,1))))
                             if (is_watch_cell()) write(*,*) 'qt[3]/A', qt/lake_area
                             qt = min(qt, (lake_wl(i,j,1)+lake_ws(i,j,1)-lake_sfc_w_min)*lake_area )
                             if (is_watch_cell()) write(*,*) 'qt[4]/A', qt/lake_area
                           ELSE
                             t_scale = lake_whole_area(i,j)/(0.9*lake_width_sill(i,j)*sqrt(h0))
                             qt = qt * (1. - (1.+River%dt_slow/t_scale)**(-2) )
                             if (.not.use_lake_area_bug) qt = qt * lake_whole_area(i,j)/lake_area
                             qt = min(qt, lake_outflow_frac_ceiling * lake_area &
                                          * max(0.,(lake_wl(i,j,1)+lake_ws(i,j,1))))
                             qt = min(qt, (lake_wl(i,j,1)+lake_ws(i,j,1)-lake_sfc_w_min)*lake_area )
                           ENDIF
                         if (ice_frac_from_sfc) then
                             out_frac = lake_wl(i,j,1)/(lake_wl(i,j,1)+lake_ws(i,j,1))
                           else
                             out_frac = max (sum(lake_wl(i,j,:))/sum(lake_wl(i,j,:)+lake_ws(i,j,:)), &
                                           lake_wl(i,j,1)/(lake_wl(i,j,1)+lake_ws(i,j,1)))
                           endif
                         out_frac = min(1., max(0., out_frac))
                         if (ice_frac_factor.lt.1.) then
                             ql = (1.-ice_frac_factor*(1.-out_frac)) * qt
                             ql = min (ql, lake_area*sum(lake_wl(i,j,:)))
                           else
                             ql = out_frac * qt
                           endif
                         qs = qt - ql
                         liq_to_flow = ql
                         ice_to_flow = qs
                         qh = 0.
                         if (is_watch_cell()) &
                              write(*,*) 'ql/A,qs/A,A',ql/lake_area,qs/lake_area,lake_area
                         do lev = 1, num_lake_lev
                           if (is_watch_cell() .and. lev.le.10) &
                                write(*,'(a,i3,99(x,a,g23.16))')'l=',lev,&
                                    'wl(1)=',lake_wl(i,j,1),'ws(1)=',lake_ws(i,j,1), &
                                    'wl(l)=',lake_wl(i,j,lev),'ws(l)=',lake_ws(i,j,lev)
                           liq_this_lev = max(0.,min(liq_to_flow, lake_area*lake_wl(i,j,lev)))
                           ice_this_lev = max(0.,min(ice_to_flow, lake_area*lake_ws(i,j,lev)))
                           lake_wl(i,j,lev) = lake_wl(i,j,lev) - liq_this_lev/lake_area
                           lake_ws(i,j,lev) = lake_ws(i,j,lev) - ice_this_lev/lake_area
                           liq_to_flow = liq_to_flow - liq_this_lev
                           ice_to_flow = ice_to_flow - ice_this_lev
                           qh = qh + (clw*liq_this_lev+csw*ice_this_lev)*(lake_T(i,j,lev)-tfreeze)
                           if (lev.gt.1) then
                             ! replensih (liquid) water lost from depth, using ice from surface,
                             ! so as to preserve thickness of deeper layer
                             h = (clw*lake_wl(i,j,lev)+csw*lake_ws(i,j,lev)) &
                                                            *(lake_T(i,j,lev)-tfreeze)
                             lake_ws(i,j,lev) = lake_ws(i,j,lev) + liq_this_lev/lake_area
                             lake_ws(i,j,1)   = lake_ws(i,j,1)   - liq_this_lev/lake_area
                             lake_T (i,j,lev) = tfreeze + &
                                (h +(liq_this_lev/lake_area)*csw*(lake_T(i,j,1)-tfreeze))  &
                                            /(clw*lake_wl(i,j,lev)+csw*lake_ws(i,j,lev))
                           endif
                           if (is_watch_cell() .and. lev.le.10) &
                                write(*,'(a,i3,99(x,a,g23.16))')'l=',lev,&
                                    'wl(1)=',lake_wl(i,j,1),'ws(1)=',lake_ws(i,j,1), &
                                    'wl(l)=',lake_wl(i,j,lev),'ws(l)=',lake_ws(i,j,lev)
                           if (liq_to_flow.eq.0..and.ice_to_flow.eq.0.) exit
                           enddo
                         River%lake_outflow  (i,j)   = qt
                         River%lake_outflow_c(i,j,1) = qs
                         River%lake_outflow_c(i,j,2) = qh
                       endif
                     if (is_watch_cell()) then
                          write(*,*) 'lake_wl(1):', lake_wl(i,j,1)
                          write(*,*) 'lake_ws(1):', lake_ws(i,j,1)
                          write(*,*) 'lake_T (1):', lake_T (i,j,1)
                     endif
                   else
                     River%lake_outflow  (i,j  ) = influx
                     River%lake_outflow_c(i,j,1) = influx_c(1)
                     River%lake_outflow_c(i,j,2) = influx_c(2)
                   endif
              endif

            ! NEXT COMPUTE RIVER-REACH MASS BALANCE (FROM LAKE_OUTFLOW TO OUTFLOW)
          
            if (River%tocell(i,j).gt.0 .or. River%landfrac(i,j).lt.1.) then
                ! avail is volume to be split between outflow and new storage
                avail = River%storage(i,j) + River%lake_outflow(i,j) / DENS_H2O
                ! determine total water storage at end of step
                if (River%reach_length(i,j) .gt. 0.) then
                    if (algor.eq.'linear') then   ! assume outflow = Q0+dQ_dV*dS
                        if (River%storage(i,j) .le. 0.) then
                            Q0 = 0.; dQ_dV = 0.
                          else
                            Q0=River%o_coef(i,j)*River%storage(i,j)**River%o_exp
                            dQ_dV=River%o_exp*Q0/River%storage(i,j)
                          endif
                        if (.not.river_impedes_lake.or..not.lockstep) then
                            River%storage(i,j) = River%storage(i,j) + River%dt_slow *   &
                             (River%lake_outflow(i,j)/(DENS_H2O*River%dt_slow)-Q0) &
                             /(1.+River%dt_slow*dQ_dV)
                        else
                            if (River%storage(i,j) .le. 0.) then
                                dh_dQ = 0.
                            else
                                dh_dQ = River%d_coef(i,j)*River%d_exp*Q0**(River%d_exp-1)
                            endif
                            River%storage(i,j) = River%storage(i,j) + River%dt_slow *   &
                             (River%lake_outflow(i,j)/(DENS_H2O*River%dt_slow)-Q0) &
                             /(1.+dQ_dV*(River%dt_slow+lake_whole_area(i,j)*dh_dQ))
                        endif
                      else if (algor.eq.'nonlin') then   ! assume all inflow at start of step 
                        if (avail .gt. 0.) then
                            River%storage(i,j) = (avail**(1.-River%o_exp) &
                                 + River%o_coef(i,j)*(River%o_exp-1.)*River%dt_slow) &
                                 **(1./(1.-River%o_exp))
                          else
                            River%storage(i,j) = avail
                          endif
                      endif
                  endif
                ! determine total water outflow during step
                River%outflow(i,j) = (avail - River%storage(i,j)) / River%dt_slow
                ! given outflow, determine flow width, depth, velocity
                if (River%outflow(i,j) .le. 0.) then
                    River%depth(i,j) = 0.
                    River%width(i,j) = 0.
                    River%vel(i,j)   = 0.
                  else
                    River%depth(i,j) = River%d_coef(i,j) &
                         * River%outflow(i,j)**River%d_exp
                    River%width(i,j) = River%w_coef(i,j) &
                         * River%outflow(i,j)**River%w_exp
                    River%vel(i,j) = River%outflow(i,j) /                   &
                                        (River%width(i,j) * River%depth(i,j))
                  endif
                ! given water outflow and storage, split other tracked stuff same way
                out_frac = 0.
                if (avail .gt. 0.) out_frac = River%outflow(i,j)/avail
                River%outflow_c(i,j,:) = out_frac * (River%storage_c(i,j,:) &
                                         +River%lake_outflow_c(i,j,:)/DENS_H2O)
                ! 2011/05/13 PCM: fix ice outflow temperature bug
                if (prohibit_cold_ice_outflow) then
                  River%outflow_c(i,j,:) = max(River%outflow_c(i,j,:), 0.)
                else
                  River%outflow_c(i,j,1) = max(River%outflow_c(i,j,1), 0.)
                  if(River%num_phys+1 <= River%num_species) then
                     River%outflow_c(i,j,River%num_phys+1:River%num_species) = &
                       max(River%outflow_c(i,j,River%num_phys+1:River%num_species), 0.)
                  endif
                endif
                River%outflow_c(i,j,1) = min(River%outflow_c(i,j,1), River%outflow(i,j))
                River%storage_c(i,j,:) = River%storage_c(i,j,:)       &
                      + River%lake_outflow_c(i,j,:)/DENS_H2O       &
                      - River%outflow_c(i,j,:)*River%dt_slow
                ! define intensive variables for diagnostics and for use in transformations.
                ! along the way, melt swept snow as necessary. freeze will be a separate
                ! process, added later; it will be different in that frozen river water will
                ! be stationary, thus a different species

                if (River%storage(i,j) .gt. storage_threshold_for_melt) then
                    conc(1) = River%storage_c(i,j,1)/River%storage(i,j)
                    conc(2) = tfreeze + River%storage_c(i,j,2) /  &
                       ( clw*River%storage(i,j) + (csw-clw)*River%storage_c(i,j,1))
                    if (River%storage_c(i,j,1).gt.0. .and. conc(2).gt.tfreeze) then
!                    if (River%storage_c(i,j,1).gt.0. .and. River%storage_c(i,j,2).gt.0.) then
                        qmelt = min(hlf*River%storage_c(i,j,1), River%storage_c(i,j,2))
                        River%melt(i,j) = qmelt
                        River%storage_c(i,j,1) = River%storage_c(i,j,1) - qmelt/hlf
                        River%storage_c(i,j,2) = River%storage_c(i,j,2) - qmelt
!                        conc(2) = tfreeze + River%storage_c(i,j,2) /  &
!                           ( clw*River%storage(i,j) + (csw-clw)*River%storage_c(i,j,1))
                      endif
                  endif

                if (River%storage(i,j) .gt. storage_threshold_for_diag) then
                    conc(1) = River%storage_c(i,j,1)/River%storage(i,j)
                    conc(2) = tfreeze + River%storage_c(i,j,2) /  &
                       ( clw*River%storage(i,j) + (csw-clw)*River%storage_c(i,j,1))
                    diag_mask(i,j) = .TRUE. 
                  else
                    conc(1) = missing
                    conc(2) = missing
                  endif

                ice(i,j)=conc(1)
                temperature(i,j)=conc(2)

                if (River%do_age) then
                    River%removal_c(i,j,River%num_phys+1) = -River%storage(i,j)/sec_in_day
                    River%storage_c(i,j,River%num_phys+1) = River%storage_c(i,j,River%num_phys+1) &
                       - River%removal_c(i,j,River%num_phys+1)*River%dt_slow
                  endif

                if (River%storage(i,j) .gt. 0.) then
                    conc(River%num_phys+1:River%num_species) = &
                       River%storage_c(i,j,River%num_phys+1:River%num_species)/River%storage(i,j)
                  else
                    conc(River%num_phys+1:River%num_species) = 0.
                  endif

                if(River%num_c.gt.0) then
                    if (River%depth(i,j).gt.0. .and. conc(2).gt.100.) then
                        v_r_d = River%vf_ref * River%Q10**((conc(2)-River%t_ref)/10.)&
                           / ((1+River%kinv*conc(River%num_species-River%num_c+1:River%num_species)) &
                           *River%depth(i,j))
                        ! next should not be necessary if storage_c is positive, but maybe it's not.
                        v_r_d = River%vf_ref * River%Q10**((conc(2)-River%t_ref)/10.)&
                           / ((1+River%kinv*max(0.,conc(River%num_species-River%num_c+1:River%num_species)))*River%depth(i,j))
                      else
                        v_r_d = 0.
                      endif
                    River%removal_c(i,j,River%num_species-River%num_c+1:River%num_species) = &
                       River%storage_c(i,j,River%num_species-River%num_c+1:River%num_species) &
                       * (1-exp( -v_r_d * River%dt_slow)) &
                       / River%dt_slow
                    River%storage_c(i,j,River%num_species-River%num_c+1:River%num_species) = &
                       River%storage_c(i,j,River%num_species-River%num_c+1:River%num_species) &
                       - River%removal_c(i,j,River%num_species-River%num_c+1:River%num_species)* River%dt_slow
                  endif
              endif

            ! FINALLY, REDEFINE OUTFLOW AS DISCHARGE IF WE HAVE OCEAN HERE
          
            if (River%landfrac(i,j).lt.1.) then
                River%disw2o(i,j) = River%outflow(i,j)
                River%outflow(i,j) = 0.
                do i_species = 1, num_species
                  River%disc2o(i,j,i_species) = River%outflow_c(i,j,i_species)
                  River%outflow_c(i,j,i_species) = 0.
                  enddo
              endif

          endif
        enddo
      enddo

    

    if (cur_travel .gt. 0) call do_halo_update(River, halo_update(cur_travel))
    
    ! ---- diagnostic section
    if (id_ice > 0) used = send_data (id_ice, &
         ice(isc:iec,jsc:jec), River%Time, mask=diag_mask)
    if (id_temp > 0) used = send_data (id_temp, &
         temperature(isc:iec,jsc:jec), River%Time, mask=diag_mask)
    ! for compatibility with old diag table
    if (id_ice_old > 0) used = send_data (id_ice_old, &
         ice(isc:iec,jsc:jec), River%Time, mask=diag_mask)
    if (id_temp_old > 0) used = send_data (id_temp_old, &
         temperature(isc:iec,jsc:jec), River%Time, mask=diag_mask)

  end subroutine river_physics_step

!#####################################################################
  subroutine setup_halo_update(River, domain)
    type(river_type),      intent(inout) :: River
    type(domain2d),        intent(inout) :: domain

    integer, parameter                   :: MAXCOMM      = 8  ! should be no larger than 8.
    integer                              :: travelnow, nsend2, p, toc
    integer                              :: spos, rpos, n, m, l
    integer                              :: buffer_pos, pos, msgsize
    integer                              :: i, j, i1, j1, i2, j2, i3, j3, i4, j4, k, kk
    integer                              :: send_size, recv_size, siz, i_dest, j_dest
    logical                              :: is_my_recv, is_my_send
    integer                              :: my_recv_index, my_send_index, roff, soff, pe, total_size
    integer                              :: nsend, nrecv, total_send, total_recv, max_send, max_recv
    integer, allocatable, dimension(:,:) :: tocell
    integer, allocatable, dimension(:,:) :: is_recv, ie_recv, js_recv, je_recv
    integer, allocatable, dimension(:,:) :: is1_send, ie1_send, js1_send, je1_send
    integer, allocatable, dimension(:,:) :: is2_send, ie2_send, js2_send, je2_send
    integer, allocatable, dimension(:,:) :: rot_send, rot_recv, dir_send, dir_recv
    integer, allocatable, dimension(:)   :: send_pelist, recv_pelist, pelist_r, pelist_s
    integer, allocatable, dimension(:)   :: send_count, recv_count, recv_size2
    integer, allocatable, dimension(:)   :: isl, iel, jsl, jel  
    integer, allocatable, dimension(:)   :: sbuf, rbuf
    type(comm_type), pointer             :: send => NULL()
    integer, allocatable, dimension(:,:,:) :: i_send, j_send, t_send, p_send, n_send

    call mpp_get_data_domain   (domain, isd, ied, jsd, jed)
    
    !--- first get the travel and tocell information onto data domain
    allocate(tocell(isd:ied,jsd:jed))
    allocate(isl(0:npes-1), iel(0:npes-1), jsl(0:npes-1), jel(0:npes-1) )
    tocell(isc:iec,jsc:jec) = River%tocell(isc:iec,jsc:jec)
    call mpp_update_domains(tocell, domain)
    call mpp_get_compute_domains(domain, xbegin=isl, xend=iel, ybegin=jsl, yend=jel)

    !--- first get the halo update information for send and recv.
    call mpp_get_update_size(domain, nsend, nrecv)

    if(nsend>0) then
       allocate(send_count(nsend))
       do p = 1, nsend
          send_count(p) = mpp_get_num_overlap(domain, EVENT_SEND, p)
       enddo
       if(ANY(send_count .LE. 0)) call mpp_error(FATAL, &
                  "river_mod: send_count should be positive for any entry")
       total_send = sum(send_count)
       allocate(rbuf(4*total_send))
    endif

    if(nrecv>0) then
       allocate(recv_count(nrecv))
       do p = 1, nrecv
          recv_count(p) = mpp_get_num_overlap(domain, EVENT_RECV, p)
       enddo
       if(ANY(recv_count .LE. 0)) call mpp_error(FATAL, &
            "river_mod: recv_count should be positive for any entry")
       total_recv = sum(recv_count)
       allocate(sbuf(4*total_recv))
    endif
 
    !--- pre-post recv
    rpos = 0
    if(nsend > 0) then
       allocate(pelist_s(nsend))
       max_send = maxval(send_count)
       allocate(is1_send(nsend,max_send), ie1_send(nsend,max_send) )
       allocate(js1_send(nsend,max_send), je1_send(nsend,max_send) )
       allocate(is2_send(nsend,max_send), ie2_send(nsend,max_send) )
       allocate(js2_send(nsend,max_send), je2_send(nsend,max_send) )
       allocate(dir_send(nsend,max_send), rot_send(nsend,max_send) )
       call mpp_get_update_pelist(domain, EVENT_SEND, pelist_s)
       do p = 1, nsend    
          call mpp_get_overlap(domain, EVENT_SEND, p, is1_send(p,1:send_count(p)), ie1_send(p,1:send_count(p)), &
               js1_send(p,1:send_count(p)), je1_send(p,1:send_count(p)), dir_send(p,1:send_count(p)), &
               rot_send(p,1:send_count(p)) )
          call mpp_recv(rbuf(rpos+1), glen=4*send_count(p), from_pe=pelist_s(p), block=.FALSE., tag=COMM_TAG_1)
          rpos = rpos + 4*send_count(p)
       enddo
    endif

    spos = 0
    if(nrecv>0) then
       allocate(pelist_r(nrecv))
       max_recv = maxval(recv_count)
       allocate(is_recv (nrecv,max_recv), ie_recv (nrecv,max_recv) )
       allocate(js_recv (nrecv,max_recv), je_recv (nrecv,max_recv) )
       allocate(rot_recv(nrecv,max_recv), dir_recv(nrecv,max_recv) )
       call mpp_get_update_pelist(domain, EVENT_RECV, pelist_r)
       do p = 1, nrecv
          call mpp_get_overlap(domain, EVENT_RECV, p, is_recv(p,1:recv_count(p)), ie_recv(p,1:recv_count(p)), &
               js_recv(p,1:recv_count(p)), je_recv(p,1:recv_count(p)), dir_recv(p,1:recv_count(p)), &
               rot_recv(p,1:recv_count(p)))
          !--- send the information to the process that send data.
          do n = 1, recv_count(p)
             sbuf(spos+(n-1)*4+1) = is_recv(p,n)
             sbuf(spos+(n-1)*4+2) = ie_recv(p,n)
             sbuf(spos+(n-1)*4+3) = js_recv(p,n)
             sbuf(spos+(n-1)*4+4) = je_recv(p,n)
          end do
          call mpp_send(sbuf(spos+1), plen = 4*recv_count(p), to_pe = pelist_r(p), tag=COMM_TAG_1)
          spos = spos + 4*recv_count(p)
       end do
    endif

    call mpp_sync_self(check=EVENT_RECV)
    !--- unpack
    do p = nsend, 1, -1
       rpos = rpos - 4*send_count(p)
       do n = 1, send_count(p)
          is2_send(p,n) = rbuf(rpos+(n-1)*4+1)
          ie2_send(p,n) = rbuf(rpos+(n-1)*4+2)
          js2_send(p,n) = rbuf(rpos+(n-1)*4+3)
          je2_send(p,n) = rbuf(rpos+(n-1)*4+4)
       end do
    end do
        
    call mpp_sync_self()

    is_my_recv = .false.
    do p = 1, nsend
       if(pelist_s(p) == mpp_pe()) then
          is_my_recv = .true.
          my_recv_index = p
       endif
    enddo
    is_my_send = .false.
    do p = 1, nrecv
       if(pelist_r(p) == mpp_pe()) then
          is_my_send = .true.
          my_send_index = p
       endif
    enddo
    roff = 0
    soff = 0
    if( is_my_recv) then
       nrecv_update = nsend
       if(nsend > 0) then
          allocate(recv_pelist(nrecv_update))
          recv_pelist = pelist_s
       endif
    else
       nrecv_update = nsend + 1
       allocate(recv_pelist(nrecv_update))
       my_recv_index = 1
       roff = 1
       recv_pelist(1) = mpp_pe()
       do p = 1, nsend
          recv_pelist(p+1) = pelist_s(p)
       enddo
    endif
    if( is_my_send ) then
       nsend_update = nrecv
       if(nrecv>0) then
          allocate(send_pelist(nsend_update))
          send_pelist = pelist_r
       endif
    else
       nsend_update = nrecv + 1
       allocate(send_pelist(nsend_update))
       my_send_index = 1
       soff = 1
       send_pelist(1) = mpp_pe()
       do p = 1, nrecv
          send_pelist(p+1) = pelist_r(p)
       enddo
    endif

    allocate(halo_update(maxtravel) )
    if(nsend_update>0) then
       do travelnow = 1, maxtravel
          allocate(halo_update(travelnow)%send(nsend_update))
          halo_update(travelnow)%send(:)%count = 0
          do p = 1, nsend_update
             halo_update(travelnow)%send(p)%count = 0
             halo_update(travelnow)%send(p)%pe    = send_pelist(p)
          end do
       end do
    endif

    if(nrecv_update>0) then
       do travelnow = 1, maxtravel
          allocate(halo_update(travelnow)%recv(nrecv_update))
          halo_update(travelnow)%recv(:)%count = 0
          do p = 1, nrecv_update
             halo_update(travelnow)%recv(p)%count = 0
             halo_update(travelnow)%recv(p)%pe    = recv_pelist(p)
          end do
       end do
    endif

    do p = 1, nsend
       pe = pelist_s(p) - mpp_root_pe()
       !--- configure points need to receive from other pe.
       !--- (i,j) --- halo index on the pe sent to, one neighbor pe data domain
       !--- (i1,j1) --- neighbor index of (i,j) on the pe sent to, on neighbor pe compute domain
       !--- (i2,j2) --- my index corresponding to (i,j), on my compute domain
       !--- (i3,j3) --- neighbor index of (i2,j2), on my data domain
       !--- (i4,j4) --- index of (i1,j1) tocell. 
       do n = 1, send_count(p)
          select case ( dir_send(p,n) )
          case(1)  ! east
             i = is2_send(p,n)  ! is2_send(p,n) == ie2_send(p,n)
             i1 = i - 1
             do j = js2_send(p,n), je2_send(p,n)
                do l = -1,1
                   j1 = j + l
                   if(j1<jsl(pe) .OR. j1 > jel(pe) ) cycle
                   select case(rot_send(p,n))
                   case (ZERO) ! w->e
                      i2 = is1_send(p,n)
                      i3 = i2 -1
                      j2 = js1_send(p,n) + j  - js2_send(p,n)
                      j3 = js1_send(p,n) + j1 - js2_send(p,n)
                   case (NINETY) ! s->e
                      i2 = is1_send(p,n) + (je2_send(p,n) - j )
                      i3 = is1_send(p,n) + (je2_send(p,n) - j1)
                      j2 = js1_send(p,n)
                      j3 = j2 - 1
                   end select
                   if(River%travel(i3,j3) >0) then
                      toc = tocell(i3,j3)
                      i4 = i1 + di(toc)
                      j4 = j1 + dj(toc) 
                      if(i4 == i .AND. j4 == j) then
                         call add_single_overlap(halo_update(River%travel(i3,j3))%recv(p+roff), i2, j2)
                      end if
                   end if
                end do
             end do
          case(2)  ! south east
             i = is2_send(p,n)  ! is2_send(p,n) == ie2_send(p,n)
             j = js2_send(p,n)  ! js2_send(p,n) == je2_send(p,n)
             i1 = i - 1
             j1 = j + 1
             i2 = is1_send(p,n)  ! is1_send(p,n) == ie1_send(p,n)
             j2 = js1_send(p,n)  ! js1_send(p,n) == je1_send(p,n)
             select case(rot_send(p,n))
             case (ZERO) ! nw->se 
                i3 = i2 - 1
                j3 = j2 + 1
             case (NINETY)
                i3 = i2 - 1
                j3 = j2 - 1
             case (MINUS_NINETY)
                i3 = i2 + 1
                j3 = j2 + 1
             end select  
             if(River%travel(i3,j3) >0) then
                toc = tocell(i3,j3)
                i4 = i1 + di(toc)
                j4 = j1 + dj(toc) 
                if(i4 == i .AND. j4 == j) then
                   call add_single_overlap(halo_update(River%travel(i3,j3))%recv(p+roff), i2, j2)
                end if
             end if
          case(3)  ! south
             j = js2_send(p,n)  ! js2_send(p,n) == je2_send(p,n)
             j1 = j + 1
             do i = is2_send(p,n), ie2_send(p,n)
                do l = -1,1
                   i1 = i + l
                   if(i1<isl(pe) .OR. i1 > iel(pe) ) cycle
                   select case(rot_send(p,n))
                   case (ZERO) ! n->s
                      i2 = is1_send(p,n) + i  - is2_send(p,n)
                      i3 = is1_send(p,n) + i1 - is2_send(p,n)
                      j2 = js1_send(p,n)
                      j3 = j2 + 1
                   case (MINUS_NINETY) ! e->s
                      i2 = is1_send(p,n)
                      i3 = i2 + 1
                      j2 = js1_send(p,n) + (ie2_send(p,n) - i )
                      j3 = js1_send(p,n) + (ie2_send(p,n) - i1)
                   end select
                   if(River%travel(i3,j3) >0) then
                      toc = tocell(i3,j3)
                      i4 = i1 + di(toc)
                      j4 = j1 + dj(toc) 
                      if(i4 == i .AND. j4 == j) then
                         call add_single_overlap(halo_update(River%travel(i3,j3))%recv(p+roff), i2, j2)
                      end if
                   end if
                end do
             end do
          case(4)  ! south west
             i = is2_send(p,n)  ! is2_send(p,n) == ie2_send(p,n)
             j = js2_send(p,n)  ! js2_send(p,n) == je2_send(p,n)
             i1 = i + 1
             j1 = j + 1
             i2 = is1_send(p,n)  ! is1_send(p,n) == ie1_send(p,n)
             j2 = js1_send(p,n)  ! js1_send(p,n) == je1_send(p,n)
             select case(rot_send(p,n))
             case (ZERO) ! ne->sw 
                i3 = i2 + 1
                j3 = j2 + 1
             case (NINETY) !  
                i3 = i2 - 1
                j3 = j2 + 1
             case (MINUS_NINETY)
                i3 = i2 + 1
                j3 = j2 - 1
             end select  
             if(River%travel(i3,j3) >0) then
                toc = tocell(i3,j3)
                i4 = i1 + di(toc)
                j4 = j1 + dj(toc) 
                if(i4 == i .AND. j4 == j) then
                   call add_single_overlap(halo_update(River%travel(i3,j3))%recv(p+roff), i2, j2)
                end if
             end if
          case(5)  ! west
             i = is2_send(p,n)  ! is2_send(p,n) == ie2_send(p,n)
             i1 = i + 1
             do j = js2_send(p,n), je2_send(p,n)
                do l = -1,1
                   j1 = j + l
                   if(j1<jsl(pe) .OR. j1 > jel(pe) ) cycle
                   select case(rot_send(p,n))
                   case (ZERO) ! e->w
                      i2 = is1_send(p,n)
                      i3 = i2 + 1
                      j2 = js1_send(p,n) + j  - js2_send(p,n)
                      j3 = js1_send(p,n) + j1 - js2_send(p,n)
                   case (NINETY) ! n->w
                      i2 = is1_send(p,n) + (je2_send(p,n) - j )
                      i3 = is1_send(p,n) + (je2_send(p,n) - j1)
                      j2 = js1_send(p,n)
                      j3 = j2 + 1
                   end select
                   if(River%travel(i3,j3) >0) then
                      toc = tocell(i3,j3)
                      i4 = i1 + di(toc)
                      j4 = j1 + dj(toc) 
                      if(i4 == i .AND. j4 == j) then
                         call add_single_overlap(halo_update(River%travel(i3,j3))%recv(p+roff), i2, j2)
                      end if
                   end if
                end do
             end do
          case(6)  ! north west
             i = is2_send(p,n)  ! is2_send(p,n) == ie2_send(p,n)
             j = js2_send(p,n)  ! js2_send(p,n) == je2_send(p,n)
             i1 = i + 1
             j1 = j - 1
             i2 = is1_send(p,n)  ! is1_send(p,n) == ie1_send(p,n)
             j2 = js1_send(p,n)  ! js1_send(p,n) == je1_send(p,n)
             select case(rot_send(p,n))
             case (ZERO) ! se->nw 
                i3 = i2 + 1
                j3 = j2 - 1
             case (NINETY) !  
                i3 = i2 + 1
                j3 = j2 + 1
             case (MINUS_NINETY)
                i3 = i2 - 1
                j3 = j2 - 1
             end select  
             if(River%travel(i3,j3) >0) then
                toc = tocell(i3,j3)
                i4 = i1 + di(toc)
                j4 = j1 + dj(toc) 
                if(i4 == i .AND. j4 == j) then
                   call add_single_overlap(halo_update(River%travel(i3,j3))%recv(p+roff), i2, j2)
                end if
             end if
          case(7)  ! north
             j = js2_send(p,n)  ! js2_send(p,n) == je2_send(p,n)
             j1 = j - 1
             do i = is2_send(p,n), ie2_send(p,n)
                do l = -1,1
                   i1 = i + l
                   if(i1<isl(pe) .OR. i1 > iel(pe)) cycle
                   select case(rot_send(p,n))
                   case (ZERO) ! s->n
                      i2 = is1_send(p,n) + i  - is2_send(p,n)
                      i3 = is1_send(p,n) + i1 - is2_send(p,n)
                      j2 = js1_send(p,n)
                      j3 = j2 - 1
                   case (MINUS_NINETY) ! w->n
                      i2 = is1_send(p,n)
                      i3 = i2 - 1
                      j2 = js1_send(p,n) + (ie2_send(p,n) - i )
                      j3 = js1_send(p,n) + (ie2_send(p,n) - i1)
                   end select
                   if(River%travel(i3,j3) >0) then
                      toc = tocell(i3,j3)
                      i4 = i1 + di(toc)
                      j4 = j1 + dj(toc) 
                      if(i4 == i .AND. j4 == j) then
                         call add_single_overlap(halo_update(River%travel(i3,j3))%recv(p+roff), i2, j2)
                      end if
                   end if
                end do
             end do
          case(8)  ! north east
             i = is2_send(p,n)  ! is2_send(p,n) == ie2_send(p,n)
             j = js2_send(p,n)  ! js2_send(p,n) == je2_send(p,n)
             i1 = i - 1
             j1 = j - 1
             i2 = is1_send(p,n)  ! is1_send(p,n) == ie1_send(p,n)
             j2 = js1_send(p,n)  ! js1_send(p,n) == je1_send(p,n)
             select case(rot_send(p,n))
             case (ZERO) ! sw->ne 
                i3 = i2 - 1
                j3 = j2 - 1
             case (NINETY) !  
                i3 = i2 + 1
                j3 = j2 - 1
             case (MINUS_NINETY)
                i3 = i2 - 1
                j3 = j2 + 1
             end select  
             if(River%travel(i3,j3) >0) then
                toc = tocell(i3,j3)
                i4 = i1 + di(toc)
                j4 = j1 + dj(toc) 
                if(i4 == i .AND. j4 == j) then
                   call add_single_overlap(halo_update(River%travel(i3,j3))%recv(p+roff), i2, j2)
                end if
             end if
          end select
       end do       
    enddo

    do p = 1, nrecv
       !--- configure points need to send to other pe.
       !--- (i,j) ---  index on my data domain
       !--- (i1,j1) --- index on my compute domain corresponding to (i,j)
       !--- (i2,j2) --- index of (i1,j1) tocell
       do n = 1, recv_count(p)
          select case ( dir_recv(p,n) )
          case(1)  ! east
             i = is_recv(p,n)  ! is_recv(p,n) == ie_recv(p,n)
             i1 = i - 1
             do j = js_recv(p,n), je_recv(p,n)
                do l = -1,1
                   j1 = j + l
                   if(j1<jsc .OR. j1 > jec .OR. River%travel(i1,j1) < 1) cycle
                   i2 = i1 + di(tocell(i1,j1))
                   j2 = j1 + dj(tocell(i1,j1)) 
                   if(i2 == i .AND. j2 == j) then
                      call add_single_overlap(halo_update(River%travel(i1,j1))%send(p+soff), i1, j1)
                   end if
                end do
             end do
          case(2)  ! south east
             i = is_recv(p,n)  ! is_recv(p,n) == ie_recv(p,n)
             j = js_recv(p,n)  ! js_recv(p,n) == je_recv(p,n)
             i1 = i - 1
             j1 = j + 1
             if(River%travel(i1,j1) > 0) then
                i2 = i1 + di(tocell(i1,j1))
                j2 = j1 + dj(tocell(i1,j1)) 
                if(i2 == i .AND. j2 == j) then
                   call add_single_overlap(halo_update(River%travel(i1,j1))%send(p+soff), i1, j1)
                end if
             end if
          case(3)  ! south
             j = js_recv(p,n)  ! js_recv(p,n) == je_recv(p,n)
             j1 = j + 1
             do i = is_recv(p,n), ie_recv(p,n)
                do l = -1,1
                   i1 = i + l
                   if(i1<isc .OR. i1 > iec .OR. River%travel(i1,j1) < 1) cycle
                   i2 = i1 + di(tocell(i1,j1))
                   j2 = j1 + dj(tocell(i1,j1)) 
                   if(i2 == i .AND. j2 == j) then
                      call add_single_overlap(halo_update(River%travel(i1,j1))%send(p+soff), i1, j1)
                   end if
                end do
             end do
          case(4)  ! south west
             i = is_recv(p,n)  ! is_recv(p,n) == ie_recv(p,n)
             j = js_recv(p,n)  ! js_recv(p,n) == je_recv(p,n)
             i1 = i + 1
             j1 = j + 1
             if( River%travel(i1,j1) > 0) then
                i2 = i1 + di(tocell(i1,j1))
                j2 = j1 + dj(tocell(i1,j1)) 
                if(i2 == i .AND. j2 == j) then
                   call add_single_overlap(halo_update(River%travel(i1,j1))%send(p+soff), i1, j1)
                end if
             end if
          case(5)  ! west
             i = is_recv(p,n)  ! is_recv(p,n) == ie_recv(p,n)
             i1 = i + 1
             do j = js_recv(p,n), je_recv(p,n)
                do l = -1,1
                   j1 = j + l
                   if(j1<jsc .OR. j1 > jec .OR. River%travel(i1,j1) < 1) cycle
                   i2 = i1 + di(tocell(i1,j1))
                   j2 = j1 + dj(tocell(i1,j1)) 
                   if(i2 == i .AND. j2 == j) then
                      call add_single_overlap(halo_update(River%travel(i1,j1))%send(p+soff), i1, j1)
                   end if
                end do
             end do
          case(6)  ! north west
             i = is_recv(p,n)  ! is_recv(p,n) == ie_recv(p,n)
             j = js_recv(p,n)  ! js_recv(p,n) == je_recv(p,n)
             i1 = i + 1
             j1 = j - 1
             if( River%travel(i1,j1) > 0) then
                i2 = i1 + di(tocell(i1,j1))
                j2 = j1 + dj(tocell(i1,j1)) 
                if(i2 == i .AND. j2 == j) then
                   call add_single_overlap(halo_update(River%travel(i1,j1))%send(p+soff), i1, j1)
                end if
             end if
          case(7)  ! north
             j = js_recv(p,n)  ! js_recv(p,n) == je_recv(p,n)
             j1 = j - 1
             do i = is_recv(p,n), ie_recv(p,n)
                do l = -1,1
                   i1 = i + l
                   if(i1<isc .OR. i1 > iec .OR. River%travel(i1,j1) < 1) cycle
                   i2 = i1 + di(tocell(i1,j1))
                   j2 = j1 + dj(tocell(i1,j1)) 
                   if(i2 == i .AND. j2 == j) then
                      call add_single_overlap(halo_update(River%travel(i1,j1))%send(p+soff), i1, j1)
                   end if
                end do
             end do
          case(8)  ! north east
             i = is_recv(p,n)  ! is_recv(p,n) == ie_recv(p,n)
             j = js_recv(p,n)  ! js_recv(p,n) == je_recv(p,n)
             i1 = i - 1
             j1 = j - 1
             if( River%travel(i1,j1) > 0) then
                i2 = i1 + di(tocell(i1,j1))
                j2 = j1 + dj(tocell(i1,j1)) 
                if(i2 == i .AND. j2 == j) then
                   call add_single_overlap(halo_update(River%travel(i1,j1))%send(p+soff), i1, j1)
                end if
             end if
          end select
       end do       
    end do

    allocate(in_domain(isc:iec,jsc:jec))
    in_domain = .true.
    do j = jsc, jec
       do i = isc, iec
          if(River%tocell(i,j) > 0) then
             i_dest = i + di(River%tocell(i,j))
             j_dest = j + dj(River%tocell(i,j))
             if(i_dest < isc .OR. i_dest > iec .OR. j_dest < jsc .OR. j_dest > jec) then 
                LOOP_TRAVEL: do travelnow = 1, maxtravel
                   do p = 1, nrecv
                      send => halo_update(travelnow)%send(p+soff)
                      do n = 1, send%count
                         if(send%i(n) == i .AND. send%j(n) == j) then
                            in_domain(i,j) = .false.
                            exit LOOP_TRAVEL 
                         end if
                      end do
                   end do
                end do LOOP_TRAVEL
                if(in_domain(i,j)) then
                   i_dest = i
                   j_dest = j
                end if
             end if
             River%i_tocell(i,j) = i_dest
             River%j_tocell(i,j) = j_dest
          end if
       end do
    end do

    !--- add points that sent to self.
    do j = jsc, jec
       do i = isc, iec
          m = River%travel(i,j)
          if(m >0 .and. in_domain(i,j) ) then
             call add_single_overlap(halo_update(m)%send(my_send_index), i, j)
             call add_single_overlap(halo_update(m)%recv(my_recv_index), River%i_tocell(i, j), River%j_tocell(i, j))
          end if
       end do
    end do

    !--- the following is for the purpose of bitwise reproduce between processor count
    if(nrecv_update>0) allocate(recv_size2(nrecv_update))
    do p=1, nrecv_update
       call mpp_recv(recv_size2(p), glen = 1, from_pe = recv_pelist(p), block=.FALSE., tag=COMM_TAG_2 )
    enddo

    do p= 1, nsend_update
       msgsize = 0
       do m = 1, maxtravel
          msgsize = msgsize + 2*halo_update(m)%send(p)%count
       enddo
       call mpp_send(msgsize, plen = 1, to_pe = send_pelist(p), tag=COMM_TAG_2)
    enddo

    call mpp_sync_self(check=EVENT_RECV)
    do p=1, nrecv_update 
       recv_size = 0   
       do m = 1, maxtravel
          recv_size = recv_size + halo_update(m)%recv(p)%count
       end do
       recv_size = recv_size*2
       if(recv_size2(p) .NE. recv_size) then
          print*, "At pe = ", mpp_pe()," p = ", p, " from_pe = ", recv_pelist(p), ", send_size = ", recv_size2(p), "recv_size = ", recv_size
          call mpp_error(FATAL, "river_physics_mod: mismatch at send size and recv size")
       endif
    enddo
    call mpp_sync_self()

    total_size = 0
    do p = 1, nrecv_update
       total_size = total_size + recv_size2(p)
    enddo

    if(total_size >0) allocate(recv_buffer(total_size))
    pos = 0
    do p=1, nrecv_update
       if(recv_size2(p) >0) then
          call mpp_recv(recv_buffer(pos+1), glen = recv_size2(p), from_pe = recv_pelist(p), block=.FALSE., tag=COMM_TAG_3 )
          pos = pos + recv_size2(p)
       endif
    enddo

    send_size = 0
    do p = 1, nsend_update
       do m = 1, maxtravel
          send_size = send_size + halo_update(m)%send(p)%count
       end do
    end do
    send_size = send_size*2
    if(send_size>0) allocate(send_buffer(send_size))
    pos = 0
    do p= 1, nsend_update
       buffer_pos = pos
       do m = 1, maxtravel
          do n = 1, halo_update(m)%send(p)%count
             send_buffer(pos+1) = halo_update(m)%send(p)%i(n)
             send_buffer(pos+2) = halo_update(m)%send(p)%j(n)
             pos = pos + 2
          end do
       end do
       msgsize = pos - buffer_pos
       if(msgsize >0) then
          call mpp_send(send_buffer(buffer_pos+1), plen = msgsize, to_pe = send_pelist(p), tag=COMM_TAG_3)
       end if      
    end do

    call mpp_sync_self(check=EVENT_RECV)

    !--- unpack buffer
    allocate(i_send(isc:iec,jsc:jec,8), j_send(isc:iec,jsc:jec,8) )
    allocate(p_send(isc:iec,jsc:jec,8), t_send(isc:iec,jsc:jec,8) )
    allocate(n_send(isc:iec,jsc:jec,8), nlev(isc:iec,jsc:jec))
    nlev = 0
    pos = 0
    do p=1, nrecv_update
       if(recv_size2(p) >0) then
          do m = 1, maxtravel
             do n = 1, halo_update(m)%recv(p)%count
                i = halo_update(m)%recv(p)%i(n)
                j = halo_update(m)%recv(p)%j(n)
                i1 = recv_buffer(pos+1)
                j1 = recv_buffer(pos+2)
                pos = pos + 2
                do k = 1, nlev(i,j)
                   if( j1 < j_send(i,j,k) .OR. (j1 == j_send(i,j,k) .AND. i1 < i_send(i,j,k) ) ) then
                      do kk = nlev(i,j)+1, k+1, -1
                         i_send(i,j,kk) = i_send(i,j,kk-1)
                         j_send(i,j,kk) = j_send(i,j,kk-1)
                         p_send(i,j,kk) = p_send(i,j,kk-1)
                         t_send(i,j,kk) = t_send(i,j,kk-1)
                         n_send(i,j,kk) = n_send(i,j,kk-1)
                         halo_update(t_send(i,j,kk))%recv(p_send(i,j,kk))%k(n_send(i,j,kk)) = &
                             halo_update(t_send(i,j,kk))%recv(p_send(i,j,kk))%k(n_send(i,j,kk)) + 1
                      end do
                      exit
                   end if
                end do
                nlev(i,j) = nlev(i,j) + 1
                i_send(i,j,k) = i1
                j_send(i,j,k) = j1
                p_send(i,j,k) = p
                t_send(i,j,k) = m
                n_send(i,j,k) = n         
                halo_update(m)%recv(p)%k(n) = k               
             end do
          end do
       end if
    end do

    call mpp_sync_self()    
    if(allocated(send_buffer)) deallocate(send_buffer)
    if(allocated(recv_buffer)) deallocate(recv_buffer)
    if(allocated(recv_size2 )) deallocate(recv_size2 )

    !--- set up buffer for send and recv.
    send_size = 0
    do m = 1, maxtravel
       siz = 0
       do p = 1, nsend_update
          siz = siz + halo_update(m)%send(p)%count
       end do
       send_size = max(send_size, siz)
    end do
    send_size = send_size*(num_species+1)
    if(send_size > 0) allocate(send_buffer(send_size))

    recv_size = 0
    do m = 1, maxtravel
       siz = 0
       do p = 1, nrecv_update
          siz = siz + halo_update(m)%recv(p)%count
       end do
       recv_size = max(recv_size, siz)
    end do
    recv_size = recv_size*(num_species+1)
    if(recv_size > 0) allocate(recv_buffer(recv_size))

    deallocate(tocell)
    deallocate(isl, iel, jsl, jel )
    deallocate(sbuf, rbuf)
    deallocate(is_recv, ie_recv, js_recv, je_recv)
    deallocate(is1_send, ie1_send, js1_send, je1_send)
    deallocate(is2_send, ie2_send, js2_send, je2_send)
    deallocate(rot_send, rot_recv, send_count, recv_count)
    if(ALLOCATED(pelist_r)) deallocate(pelist_r)
    if(ALLOCATED(pelist_s)) deallocate(pelist_s)
    if(ALLOCATED(send_pelist)) deallocate(send_pelist)
    if(ALLOCATED(recv_pelist)) deallocate(recv_pelist)
    return

  end subroutine setup_halo_update

!###############################################################################
  subroutine do_halo_update(River, update)
     type(river_type),    intent(inout) :: River
     type(halo_update_type), intent(in) :: update
     type(comm_type), pointer           :: send=>NULL()
     type(comm_type), pointer           :: recv=>NULL()
     integer                            :: buffer_pos, pos, recv_buffer_pos
     integer                            :: p, n, i, j, count, l, k
     real                               :: wrk_c(isc:iec,jsc:jec,num_species, 8)
     real                               :: wrk  (isc:iec,jsc:jec, 8)

     !--- pre-post recv data
     pos = 0
     do p = 1, nrecv_update
        recv => update%recv(p)
        count = recv%count
        if(count == 0) cycle
        call mpp_recv(recv_buffer(pos+1), glen=count*(num_species+1), from_pe=recv%pe, block=.FALSE., tag=COMM_TAG_4 )            
        pos = pos + count*(num_species+1)
     enddo
     recv_buffer_pos = pos

     !--- send the data
     pos = 0
     do p = 1, nsend_update
        send => update%send(p)
        count = send%count
        if(count == 0) cycle
        buffer_pos = pos
        do n = 1, count
           i = send%i(n)
           j = send%j(n)
           pos = pos + 1
           send_buffer(pos)   = River%outflow(i,j)
           do l = 1, num_species
              pos = pos + 1
              send_buffer(pos) = River%outflow_c(i,j,l)
           end do
        end do
        call mpp_send(send_buffer(buffer_pos+1), plen=count*(num_species+1), to_pe = send%pe, tag=COMM_TAG_4 ) 
     end do

     call mpp_sync_self(check=EVENT_RECV)

     !--- update the buffer in reverse order
     nlev = 0
     pos = recv_buffer_pos
     do p = nrecv_update, 1, -1
        recv => update%recv(p)
        count = recv%count
        if(count == 0) cycle
        pos = recv_buffer_pos - count*(num_species+1)
        recv_buffer_pos = pos
        do n = 1, count
           i = recv%i(n)
           j = recv%j(n)
           k = recv%k(n)
           pos = pos + 1
           wrk(i,j,k) = recv_buffer(pos)
           nlev(i,j) = nlev(i,j)+1
           do l = 1, num_species
              pos = pos + 1
              wrk_c(i,j,l,k) = recv_buffer(pos)
           end do
        end do
     enddo

     do j = jsc, jec
        do i = isc, iec
           do k = 1, nlev(i,j)
              River%inflow(i,j)   = River%inflow(i,j) + wrk(i,j,k)
              River%inflow_c(i,j,:) = River%inflow_c(i,j,:) + wrk_c(i,j,:,k)
           end do
        end do
     end do

     call mpp_sync_self()


     return

  end subroutine do_halo_update


!###############################################################################
!  This routine will add one point for send/recv into the data type, allocate 
!  memory or expand memory if needed 

  subroutine add_single_overlap(comm, i, j)
    type(comm_type), intent(inout) :: comm
    integer,         intent(in)    :: i, j
    integer, parameter             :: DEFAULT_SIZE = 40 ! too big or too small
    integer                        :: count, maxcount
    integer, allocatable           :: tmp(:)

    count = comm%count 
    count = count + 1
    if(count == 1) then ! assign default space to hold index
       allocate(comm%i(DEFAULT_SIZE))
       allocate(comm%j(DEFAULT_SIZE))
       allocate(comm%k(DEFAULT_SIZE))
    end if
    maxcount = size(comm%i)

    if(count > maxcount) then ! need to expend the size to hold the index
       allocate(tmp(maxcount))
       tmp = comm%i
       deallocate(comm%i)
       allocate(comm%i(2*maxcount))
       comm%i(1:maxcount) = tmp
       tmp = comm%j
       deallocate(comm%j)
       allocate(comm%j(2*maxcount))
       comm%j(1:maxcount) = tmp
       deallocate(tmp)
       deallocate(comm%k)
       allocate(comm%k(2*maxcount))
    end if
    comm%i(count) = i
    comm%j(count) = j    
    comm%k(count) = 0
    comm%count    = count

    return    

  end subroutine add_single_overlap

!#####################################################################

end module river_physics_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: dsd.F90,v 20.0 2013/12/13 23:16:13 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

  subroutine dsd(Q,Re,D,N,nsizes,dtype,rho_a,tc, &
             dmin,dmax,apm,bpm,rho_c,p1,p2,p3,fc,scaled)
  use array_lib
  use math_lib 
  implicit none

! Purpose:
!   Create a discrete drop size distribution
!   Part of QuickBeam v1.03 by John Haynes
!   http://reef.atmos.colostate.edu/haynes/radarsim
!
! Inputs:
!   [Q]        hydrometeor mixing ratio (g/kg)
!   [Re]       Optional Effective Radius (microns).  0 = use default.
!   [D]        discrete drop sizes (um)
!   [nsizes]   number of elements of [D]
!   [dtype]    distribution type
!   [rho_a]    ambient air density (kg m^-3)
!   [tc]       temperature (C)
!   [dmin]     minimum size cutoff (um)
!   [dmax]     maximum size cutoff (um)
!   [rho_c]    alternate constant density (kg m^-3)
!   [p1],[p2],[p3]  distribution parameters
!
! Input/Output:
!   [fc]       scaling factor for the distribution
!   [scaled]   has this hydrometeor type been scaled?
!   [apm]      a parameter for mass (kg m^[-bpm])
!   [bmp]      b params for mass
!
! Outputs:
!   [N]        discrete concentrations (cm^-3 um^-1)
!              or, for monodisperse, a constant (1/cm^3)
!
! Requires:
!   function infind
!
! Created:
!   11/28/05  John Haynes (haynes@atmos.colostate.edu)
! Modified:
!   01/31/06  Port from IDL to Fortran 90
!   07/07/06  Rewritten for variable DSD's
!   10/02/06  Rewritten using scaling factors (Roger Marchand and JMH)
 
! ----- INPUTS -----  
  
  integer, intent(in) :: nsizes
  integer, intent(in) :: dtype
  real*8, intent(in) :: Q,D(nsizes),rho_a,tc,dmin,dmax, &
    rho_c,p1,p2,p3
    
! ----- INPUT/OUTPUT -----

  real*8, intent(inout) :: fc(nsizes),apm,bpm,Re
  logical, intent(inout) :: scaled  
    
! ----- OUTPUTS -----

  real*8, intent(out) :: N(nsizes)
  
! ----- INTERNAL -----
  
  real*8 :: &
  N0,D0,vu,np,dm,ld, &             ! gamma, exponential variables
  dmin_mm,dmax_mm,ahp,bhp, &       ! power law variables
  rg,log_sigma_g, &           ! lognormal variables
  rho_e                       ! particle density (kg m^-3)
  
  real*8 :: tmp1, tmp2
  real*8 :: pi

  integer k,lidx,uidx

  pi = acos(-1.0)
  
! // if density is constant, store equivalent values for apm and bpm
  if ((rho_c > 0) .and. (apm < 0)) then
    apm = (pi/6)*rho_c
    bpm = 3.
  endif
  
  select case(dtype)
  
! ---------------------------------------------------------!
! // modified gamma                                        !
! ---------------------------------------------------------!
! :: N0 = total number concentration (m^-3)
! :: np = fixed number concentration (kg^-1)
! :: D0 = characteristic diameter (um)
! :: dm = mean diameter (um)
! :: vu = distribution width parameter

  case(1)  
    if (abs(p1+1) < 1E-8) then

!     // D0, vu are given  
      vu = p3 
      
      if(Re.le.0) then 
          dm = p2
     D0 = gamma(vu)/gamma(vu+1)*dm
      else
     D0 = 2.0*Re*gamma(vu+2)/gamma(vu+3)
      endif
     
      if (scaled .eqv. .false.) then
      
        fc = ( &
             ((D*1E-6)**(vu-1)*exp(-1*D/D0)) / &
             (apm*((D0*1E-6)**(vu+bpm))*gamma(vu+bpm)) &
          ) * 1E-12
     scaled = .true.

      endif       

      N = fc*rho_a*(Q*1E-3)
    
    elseif (abs(p2+1) < 1E-8) then

!     // N0, vu are given    
      np = p1
      vu = p3 
      tmp1 = (Q*1E-3)**(1./bpm)
      
      if (scaled .eqv. .false.) then

        fc = (D*1E-6 / (gamma(vu)/(apm*np*gamma(vu+bpm)))** &
             (1./bpm))**vu
          
        scaled = .true.

      endif

      N = ( &
          (rho_a*np*fc*(D*1E-6)**(-1.))/(gamma(vu)*tmp1**vu) * &
          exp(-1.*fc**(1./vu)/tmp1) &
       ) * 1E-12

    else

!     // vu isn't given
      print *, 'Error: Must specify a value for vu'
      stop
    
    endif
    
! ---------------------------------------------------------!
! // exponential                                           !
! ---------------------------------------------------------!
! :: N0 = intercept parameter (m^-4)
! :: ld = slope parameter (um)

  case(2)
    if (abs(p1+1) > 1E-8) then

!     // N0 has been specified, determine ld
      N0 = p1

      if(Re>0) then

     ! if Re is set and No is set than the distribution is fully defined.
     ! so we assume Re and No have already been chosen consistant with  
     ! the water content, Q.

     ! print *,'using Re pass ...'

     ld = 1.5/Re   ! units 1/um

     N = ( &
               N0*exp(-1*ld*D) &
        ) * 1E-12
    
      else

          tmp1 = 1./(1.+bpm)
      
          if (scaled .eqv. .false.) then
          fc = ((apm*gamma(1.+bpm)*N0)**tmp1)*(D*1E-6)
          scaled = .true.

          endif
     
          N = ( &
          N0*exp(-1.*fc*(1./(rho_a*Q*1E-3))**tmp1) &
     ) * 1E-12

      endif    

    elseif (abs(p2+1) > 1E-8) then

!     // ld has been specified, determine N0
      ld = p2

      if (scaled .eqv. .false.) then

        fc = (ld*1E6)**(1.+bpm)/(apm*gamma(1+bpm))* &
             exp(-1.*(ld*1E6)*(D*1E-6))*1E-12
        scaled = .true.

      endif

      N = fc*rho_a*(Q*1E-3)

    else

!     // ld will be determined from temperature, then N0 follows
      ld = 1220*10.**(-0.0245*tc)*1E-6
      N0 = ((ld*1E6)**(1+bpm)*Q*1E-3*rho_a)/(apm*gamma(1+bpm))
    
      N = ( &
          N0*exp(-1*ld*D) &
          ) * 1E-12
    
    endif
  
! ---------------------------------------------------------!
! // power law                                             !
! ---------------------------------------------------------!
! :: ahp = Ar parameter (m^-4 mm^-bhp)
! :: bhp = br parameter
! :: dmin_mm = lower bound (mm)
! :: dmax_mm = upper bound (mm)

  case(3)

!   :: br parameter
    if (abs(p1+2) < 1E-8) then
!     :: if p1=-2, bhp is parameterized according to Ryan (2000),
!     :: applicatable to cirrus clouds
      if (tc < -30) then
        bhp = -1.75+0.09*((tc+273)-243.16)
      elseif ((tc >= -30) .and. (tc < -9)) then
        bhp = -3.25-0.06*((tc+273)-265.66)
      else
        bhp = -2.15
      endif
    elseif (abs(p1+3) < 1E-8) then      
!     :: if p1=-3, bhp is parameterized according to Ryan (2000),
!     :: applicable to frontal clouds
      if (tc < -35) then
        bhp = -1.75+0.09*((tc+273)-243.16)
      elseif ((tc >= -35) .and. (tc < -17.5)) then
        bhp = -2.65+0.09*((tc+273)-255.66)
      elseif ((tc >= -17.5) .and. (tc < -9)) then
        bhp = -3.25-0.06*((tc+273)-265.66)
      else
        bhp = -2.15
      endif    
    else
!     :: otherwise the specified value is used
      bhp = p1
    endif

!   :: Ar parameter
    dmin_mm = dmin*1E-3
    dmax_mm = dmax*1E-3

!   :: commented lines are original method with constant density
      ! rc = 500.        ! (kg/m^3)
      ! tmp1 = 6*rho_a*(bhp+4)
      ! tmp2 = pi*rc*(dmax_mm**(bhp+4))*(1-(dmin_mm/dmax_mm)**(bhp+4))
      ! ahp = (Q*1E-3)*1E12*tmp1/tmp2

!   :: new method is more consistent with the rest of the distributions
!   :: and allows density to vary with particle size
      tmp1 = rho_a*(Q*1E-3)*(bhp+bpm+1)
      tmp2 = apm*(dmax_mm**bhp*dmax**(bpm+1)-dmin_mm**bhp*dmin**(bpm+1))
      ahp = tmp1/tmp2 * 1E24
      ! ahp = tmp1/tmp2 
 
      lidx = infind(D,dmin)
      uidx = infind(D,dmax)    
      do k=lidx,uidx
 
     N(k) = ( &
        ahp*(D(k)*1E-3)**bhp &
     ) * 1E-12    

      enddo

     ! print *,'test=',ahp,bhp,ahp/(rho_a*Q),D(100),N(100),bpm,dmin_mm,dmax_mm

! ---------------------------------------------------------!
! // monodisperse                                          !
! ---------------------------------------------------------!
! :: D0 = particle diameter (um)

  case(4)
  
    if (scaled .eqv. .false.) then
    
      D0 = p1
      rho_e = (6/pi)*apm*(D0*1E-6)**(bpm-3)
      fc(1) = (6./(pi*D0**3*rho_e))*1E12
      scaled = .true.
      
    endif
    
    N(1) = fc(1)*rho_a*(Q*1E-3)
    
! ---------------------------------------------------------!
! // lognormal                                             !
! ---------------------------------------------------------!
! :: N0 = total number concentration (m^-3)
! :: np = fixed number concentration (kg^-1)
! :: rg = mean radius (um)
! :: log_sigma_g = ln(geometric standard deviation)

  case(5)
    if (abs(p1+1) < 1E-8) then

!     // rg, log_sigma_g are given
      log_sigma_g = p3
      tmp2 = (bpm*log_sigma_g)**2.
      if(Re.le.0) then 
          rg = p2
      else
     rg =Re*exp(-2.5*(log_sigma_g**2))
      endif
 
      if (scaled .eqv. .false.) then
            
        fc = 0.5 * ( &
          (1./((2.*rg*1E-6)**(bpm)*apm*(2.*pi)**(0.5) * &
          log_sigma_g*D*0.5*1E-6)) * &
          exp(-0.5*((log(0.5*D/rg)/log_sigma_g)**2.+tmp2)) &
          ) * 1E-12
     scaled = .true.
          
      endif
             
      N = fc*rho_a*(Q*1E-3)
      
    elseif (abs(p2+1) < 1E-8) then

!     // N0, log_sigma_g are given    
      Np = p1
      log_sigma_g = p3
      N0 = np*rho_a
      tmp1 = (rho_a*(Q*1E-3))/(2.**bpm*apm*N0)
      tmp2 = exp(0.5*bpm**2.*(log_sigma_g))**2.      
      rg = ((tmp1/tmp2)**(1/bpm))*1E6
      
      N = 0.5*( &
        N0 / ((2.*pi)**(0.5)*log_sigma_g*D*0.5*1E-6) * &
     exp((-0.5*(log(0.5*D/rg)/log_sigma_g)**2.)) &
     ) * 1E-12      
      
    else

!     // vu isn't given
      print *, 'Error: Must specify a value for sigma_g'
      stop
    
    endif

  end select
  
  end subroutine dsd

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                                   !!
!!                   GNU General Public License                      !!
!!                                                                   !!
!! This file is part of the Flexible Modeling System (FMS).          !!
!!                                                                   !!
!! FMS is free software; you can redistribute it and/or modify       !!
!! it and are expected to follow the terms of the GNU General Public !!
!! License as published by the Free Software Foundation.             !!
!!                                                                   !!
!! FMS is distributed in the hope that it will be useful,            !!
!! but WITHOUT ANY WARRANTY; without even the implied warranty of    !!
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     !!
!! GNU General Public License for more details.                      !!
!!                                                                   !!
!! You should have received a copy of the GNU General Public License !!
!! along with FMS; if not, write to:                                 !!
!!          Free Software Foundation, Inc.                           !!
!!          59 Temple Place, Suite 330                               !!
!!          Boston, MA  02111-1307  USA                              !!
!! or see:                                                           !!
!!          http://www.gnu.org/licenses/gpl.txt                      !!
!!                                                                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module data_override_mod
!
! <CONTACT EMAIL="Zhi.Liang@noaa.gov">
! G.T. Nong
! </CONTACT>
!
! <CONTACT EMAIL="Matthew.Harrison@noaa.gov">
!  M.J. Harrison 
! </CONTACT>
!
! <CONTACT EMAIL="Michael.Winton@noaa.gov">
! M. Winton
! </CONTACT>

!<OVERVIEW>
! Given a gridname, fieldname and model time this routine will get data in a file whose
! path is described in a user-provided data_table, do spatial and temporal interpolation if 
! necessary to convert data to model's grid and time.
!
! Before using data_override a data_table must be created with the following entries:
! gridname, fieldname_code, fieldname_file, file_name, ongrid, factor.
!
! More explainations about data_table entries can be found in the source code (defining data_type)
!
! If user wants to override fieldname_code with a const, set fieldname_file in data_table = ""
! and factor = const
!
! If user wants to override fieldname_code with data from a file, set fieldname_file = name in
! the netCDF data file, factor then will be for unit conversion (=1 if no conversion required)
!
! A field can be overriden globally (by default) or users can specify one or two regions in which
! data_override will take place, field values outside the region will not be affected. 
!</OVERVIEW>
#include <fms_platform.h>
use platform_mod, only: r8_kind
use constants_mod, only: PI
use mpp_io_mod, only: axistype,mpp_close,mpp_open,mpp_get_axis_data,MPP_RDONLY,MPP_ASCII
use mpp_mod, only : mpp_error,FATAL,WARNING,mpp_pe,stdout,stdlog,mpp_root_pe, NOTE, mpp_min, mpp_max, mpp_chksum
use mpp_mod, only : input_nml_file
use horiz_interp_mod, only : horiz_interp_init, horiz_interp_new, horiz_interp_type, &
                             assignment(=), horiz_interp_del
use time_interp_external_mod, only:time_interp_external_init, time_interp_external, &
                                   init_external_field, get_external_field_size, &
                                   NO_REGION, INSIDE_REGION, OUTSIDE_REGION,     &
                                   set_override_region, reset_src_data_region
use fms_io_mod, only: field_size, read_data, fms_io_init,get_mosaic_tile_grid, get_mosaic_tile_file
use fms_mod, only: write_version_number, field_exist, lowercase, file_exist, open_namelist_file, check_nml_error, close_file
use axis_utils_mod, only: get_axis_bounds, nearest_index
use mpp_domains_mod, only : domain2d, mpp_get_compute_domain, NULL_DOMAIN2D,operator(.NE.),operator(.EQ.)
use mpp_domains_mod, only : mpp_copy_domain, mpp_get_global_domain
use mpp_domains_mod, only : mpp_get_data_domain, mpp_set_compute_domain, mpp_set_data_domain
use mpp_domains_mod, only : mpp_set_global_domain, mpp_deallocate_domain

use time_manager_mod, only: time_type

implicit none
private

character(len=128) :: version = '$Id$'
character(len=128) :: tagname = '$Name$'

type data_type
   character(len=3)   :: gridname
   character(len=128) :: fieldname_code !fieldname used in user's code (model)
   character(len=128) :: fieldname_file ! fieldname used in the netcdf data file
   character(len=512) :: file_name   ! name of netCDF data file
   character(len=128) :: interpol_method   ! interpolation method (default "bilinear")
   real               :: factor ! For unit conversion, default=1, see OVERVIEW above
   real               :: lon_start, lon_end, lat_start, lat_end
   integer            :: region_type   
end type data_type


type override_type
   character(len=3)                 :: gridname  
   character(len=128)               :: fieldname
   integer                          :: t_index                 !index for time interp
   type(horiz_interp_type), pointer :: horz_interp(:) =>NULL() ! index for horizontal spatial interp
   integer                          :: dims(4)                 ! dimensions(x,y,z,t) of the field in filename
   integer                          :: comp_domain(4)          ! istart,iend,jstart,jend for compute domain
   integer                          :: numthreads
   real, _ALLOCATABLE               :: lon_in(:) _NULL
   real, _ALLOCATABLE               :: lat_in(:) _NULL
   logical, _ALLOCATABLE            :: need_compute(:) _NULL
   integer                          :: numwindows
   integer                          :: window_size(2)
   integer                          :: is_src, ie_src, js_src, je_src
end type override_type

 integer, parameter :: max_table=100, max_array=100
 integer            :: table_size ! actual size of data table
 integer, parameter :: ANNUAL=1, MONTHLY=2, DAILY=3, HOURLY=4, UNDEF=-1
 real, parameter    :: tpi=2*PI
 real               :: deg_to_radian, radian_to_deg 
 logical            :: module_is_initialized = .FALSE.

type(domain2D),save :: ocn_domain,atm_domain,lnd_domain, ice_domain 
real, dimension(:,:), target, allocatable :: lon_local_ocn, lat_local_ocn
real, dimension(:,:), target, allocatable :: lon_local_atm, lat_local_atm
real, dimension(:,:), target, allocatable :: lon_local_ice, lat_local_ice
real, dimension(:,:), target, allocatable :: lon_local_lnd, lat_local_lnd
real                                      :: min_glo_lon_ocn, max_glo_lon_ocn
real                                      :: min_glo_lon_atm, max_glo_lon_atm
real                                      :: min_glo_lon_lnd, max_glo_lon_lnd
real                                      :: min_glo_lon_ice, max_glo_lon_ice
integer:: num_fields = 0 ! number of fields in override_array already processed
type(data_type), dimension(max_table)           :: data_table ! user-provided data table
type(data_type)                                 :: default_table
type(override_type), dimension(max_array), save :: override_array ! to store processed fields
type(override_type), save                       :: default_array
logical                                         :: atm_on, ocn_on, lnd_on, ice_on
logical                                         :: debug_data_override
logical                                         :: grid_center_bug = .false.

namelist /data_override_nml/ debug_data_override, grid_center_bug

interface data_override
     module procedure data_override_0d
     module procedure data_override_2d
     module procedure data_override_3d
end interface

public :: data_override_init, data_override

contains
!===============================================================================================
! <SUBROUTINE NAME="data_override_init">
!   <DESCRIPTION>
! Assign default values for default_table, get domain of component models,
! get global grids of component models.
! Users should call data_override_init before calling data_override
!   </DESCRIPTION>
!   <TEMPLATE>
! call data_override_init
!   </TEMPLATE>
subroutine data_override_init(Atm_domain_in, Ocean_domain_in, Ice_domain_in, Land_domain_in)
  type (domain2d), intent(in), optional :: Atm_domain_in
  type (domain2d), intent(in), optional :: Ocean_domain_in, Ice_domain_in 
  type (domain2d), intent(in), optional :: Land_domain_in

! <NOTE>
! This subroutine should be called in coupler_init after
! (ocean/atmos/land/ice)_model_init have been called.
!
! data_override_init can be called more than once, in one call the user can pass 
! up to 4 domains of component models, at least one domain must be present in
! any call
!
! Data_table is initialized here with default values. Users should provide "real" values
! that will override the default values. Real values can be given using data_table, each
! line of data_table contains one data_entry. Items of data_entry are comma separated.
!
! </NOTE>
  character(len=128)    :: grid_file = 'INPUT/grid_spec.nc'
  integer               :: is,ie,js,je,count
  integer               :: i, iunit, ntable, ntable_lima, ntable_new, unit,io_status, ierr
  character(len=256)    :: record
  logical               :: file_open
  logical               :: ongrid
  character(len=128)    :: region, region_type


  type(data_type)  :: data_entry

  debug_data_override = .false.

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, data_override_nml, iostat=io_status)
  ierr = check_nml_error(io_status, 'data_override_nml')
#else
  iunit = open_namelist_file ()
  ierr=1; do while (ierr /= 0)
  read  (iunit, nml=data_override_nml, iostat=io_status, end=10)
  ierr = check_nml_error(io_status, 'data_override_nml')
  enddo
10 call close_file (iunit)
#endif
  unit = stdlog()
  write(unit, data_override_nml)

!  if(module_is_initialized) return

  atm_on = PRESENT(Atm_domain_in)
  ocn_on = PRESENT(Ocean_domain_in)
  lnd_on = PRESENT(Land_domain_in)
  ice_on = PRESENT(Ice_domain_in)
  if(.not. module_is_initialized) then
    atm_domain = NULL_DOMAIN2D
    ocn_domain = NULL_DOMAIN2D
    lnd_domain = NULL_DOMAIN2D
    ice_domain = NULL_DOMAIN2D 
  end if   
  if (atm_on) atm_domain = Atm_domain_in
  if (ocn_on) ocn_domain = Ocean_domain_in
  if (lnd_on) lnd_domain = Land_domain_in
  if (ice_on) ice_domain = Ice_domain_in 

  if(.not. module_is_initialized) then
    call horiz_interp_init
    radian_to_deg = 180./PI
    deg_to_radian = PI/180.

    call write_version_number (version, tagname)

!  Initialize user-provided data table  
    default_table%gridname = 'none'
    default_table%fieldname_code = 'none'
    default_table%fieldname_file = 'none'
    default_table%file_name = 'none'
    default_table%factor = 1.
    default_table%interpol_method = 'bilinear'
    do i = 1,max_table
       data_table(i) = default_table
    enddo

!  Read coupler_table 
    call mpp_open(iunit, 'data_table', action=MPP_RDONLY)
    ntable = 0
    ntable_lima = 0
    ntable_new = 0

    do while (ntable <= max_table)
       read(iunit,'(a)',end=100) record
       if (record(1:1) == '#') cycle
       if (record(1:10) == '          ') cycle
       ntable=ntable+1 
       if (index(lowercase(record), "inside_region") .ne. 0 .or. index(lowercase(record), "outside_region") .ne. 0) then
          if(index(lowercase(record), ".false.") .ne. 0 .or. index(lowercase(record), ".true.") .ne. 0 ) then
             ntable_lima = ntable_lima + 1
             read(record,*,err=99) data_entry%gridname, data_entry%fieldname_code, data_entry%fieldname_file, &
                                   data_entry%file_name, ongrid, data_entry%factor, region, region_type
             if(ongrid) then
                data_entry%interpol_method = 'none'
             else
                data_entry%interpol_method = 'bilinear'
             endif
          else
             ntable_new=ntable_new+1
             read(record,*,err=99) data_entry%gridname, data_entry%fieldname_code, data_entry%fieldname_file, &
                                   data_entry%file_name, data_entry%interpol_method, data_entry%factor, region, region_type
             if (data_entry%interpol_method == 'default') then
                data_entry%interpol_method = default_table%interpol_method
             endif
             if (.not.(data_entry%interpol_method == 'default'  .or. &
                  data_entry%interpol_method == 'bicubic'  .or. &
                  data_entry%interpol_method == 'bilinear' .or. &
                  data_entry%interpol_method == 'none')) then
                unit = stdout()
                write(unit,*)" gridname is ", trim(data_entry%gridname)
                write(unit,*)" fieldname_code is ", trim(data_entry%fieldname_code)
                write(unit,*)" fieldname_file is ", trim(data_entry%fieldname_file)
                write(unit,*)" file_name is ", trim(data_entry%file_name)
                write(unit,*)" factor is ", data_entry%factor 
                write(unit,*)" interpol_method is ", trim(data_entry%interpol_method)
                call mpp_error(FATAL, 'data_override_mod: invalid last entry in data_override_table, ' &
                     //'its value should be "default", "bicubic", "bilinear" or "none" ') 
             endif
          endif
          if( trim(region_type) == "inside_region" ) then
             data_entry%region_type = INSIDE_REGION
          else if( trim(region_type) == "outside_region" ) then
             data_entry%region_type = OUTSIDE_REGION     
          else
             call mpp_error(FATAL, 'data_override_mod: region type should be inside_region or outside_region')
          endif
          if (data_entry%file_name == "") call mpp_error(FATAL, &
              "data_override: filename not given in data_table when region_type is not NO_REGION")
          if(data_entry%fieldname_file == "") call mpp_error(FATAL, &
             "data_override: fieldname_file must be specified in data_table when region_type is not NO_REGION")
          if( trim(data_entry%interpol_method) == 'none') call mpp_error(FATAL, &
             "data_override(data_override_init): ongrid must be false when region_type is not NO_REGION")
          read(region,*) data_entry%lon_start, data_entry%lon_end, data_entry%lat_start, data_entry%lat_end
          !--- make sure data_entry%lon_end > data_entry%lon_start and data_entry%lat_end > data_entry%lat_start
          if(data_entry%lon_end .LE. data_entry%lon_start) call mpp_error(FATAL, &
             "data_override: lon_end should be greater than lon_start")
          if(data_entry%lat_end .LE. data_entry%lat_start) call mpp_error(FATAL, &
             "data_override: lat_end should be greater than lat_start")
       else if (index(lowercase(record), ".false.") .ne. 0 .or. index(lowercase(record), ".true.") .ne. 0 ) then ! old format
          ntable_lima = ntable_lima + 1
          read(record,*,err=99) data_entry%gridname, data_entry%fieldname_code, data_entry%fieldname_file, &
                                   data_entry%file_name, ongrid, data_entry%factor
          if(ongrid) then
             data_entry%interpol_method = 'none'
          else
             data_entry%interpol_method = 'bilinear'
          endif
          data_entry%lon_start = 0.0
          data_entry%lon_end   = -1.0
          data_entry%lat_start = 0.0
          data_entry%lat_end   = -1.0
          data_entry%region_type = NO_REGION
       else                                      ! new format
          ntable_new=ntable_new+1
          read(record,*,err=99) data_entry%gridname, data_entry%fieldname_code, data_entry%fieldname_file, &
                                data_entry%file_name, data_entry%interpol_method, data_entry%factor
          if (data_entry%interpol_method == 'default') then
            data_entry%interpol_method = default_table%interpol_method
          endif
          if (.not.(data_entry%interpol_method == 'default'  .or. &
                    data_entry%interpol_method == 'bicubic'  .or. &
                    data_entry%interpol_method == 'bilinear' .or. &
                    data_entry%interpol_method == 'none')) then
             unit = stdout()
             write(unit,*)" gridname is ", trim(data_entry%gridname)
             write(unit,*)" fieldname_code is ", trim(data_entry%fieldname_code)
             write(unit,*)" fieldname_file is ", trim(data_entry%fieldname_file)
             write(unit,*)" file_name is ", trim(data_entry%file_name)
             write(unit,*)" factor is ", data_entry%factor 
             write(unit,*)" interpol_method is ", trim(data_entry%interpol_method)
             call mpp_error(FATAL, 'data_override_mod: invalid last entry in data_override_table, ' &
                               //'its value should be "default", "bicubic", "bilinear" or "none" ') 
          endif
          data_entry%lon_start = 0.0
          data_entry%lon_end   = -1.0
          data_entry%lat_start = 0.0
          data_entry%lat_end   = -1.0
          data_entry%region_type = NO_REGION
       endif
       data_table(ntable) = data_entry
    enddo
    call mpp_error(FATAL,'too many enries in data_table')
99  call mpp_error(FATAL,'error in data_table format')
100 continue
    table_size = ntable
    if(ntable_new*ntable_lima /= 0) call mpp_error(FATAL, &
       'data_override_mod: New and old formats together in same data_table not supported')
    call mpp_close(iunit)
!  Initialize override array
    default_array%gridname = 'NONE'
    default_array%fieldname = 'NONE'
    default_array%t_index = -1
    default_array%dims = -1
    default_array%comp_domain = -1
    do i = 1, max_array
       override_array(i) = default_array
    enddo
    call time_interp_external_init
 endif

 module_is_initialized = .TRUE.

 if ( .NOT. (atm_on .or. ocn_on .or. lnd_on .or. ice_on)) return 
 call fms_io_init

! Test if grid_file is already opened
 inquire (file=trim(grid_file), opened=file_open)
 if(file_open) call mpp_error(FATAL, trim(grid_file)//' already opened')

 if(field_exist(grid_file, "x_T" ) .OR. field_exist(grid_file, "geolon_t" ) ) then
    if (atm_on .and. .not. allocated(lon_local_atm) ) then
       call mpp_get_compute_domain( atm_domain,is,ie,js,je) 
       allocate(lon_local_atm(is:ie,js:je), lat_local_atm(is:ie,js:je))
       call get_grid_version_1(grid_file, 'atm', atm_domain, is, ie, js, je, lon_local_atm, lat_local_atm, &
            min_glo_lon_atm, max_glo_lon_atm )
    endif
    if (ocn_on .and. .not. allocated(lon_local_ocn) ) then
       call mpp_get_compute_domain( ocn_domain,is,ie,js,je) 
       allocate(lon_local_ocn(is:ie,js:je), lat_local_ocn(is:ie,js:je))
       call get_grid_version_1(grid_file, 'ocn', ocn_domain, is, ie, js, je, lon_local_ocn, lat_local_ocn, &
            min_glo_lon_ocn, max_glo_lon_ocn )
    endif

    if (lnd_on .and. .not. allocated(lon_local_lnd) ) then
       call mpp_get_compute_domain( lnd_domain,is,ie,js,je) 
       allocate(lon_local_lnd(is:ie,js:je), lat_local_lnd(is:ie,js:je))
       call get_grid_version_1(grid_file, 'lnd', lnd_domain, is, ie, js, je, lon_local_lnd, lat_local_lnd, &
            min_glo_lon_lnd, max_glo_lon_lnd )
    endif

    if (ice_on .and. .not. allocated(lon_local_ice) ) then
       call mpp_get_compute_domain( ice_domain,is,ie,js,je) 
       allocate(lon_local_ice(is:ie,js:je), lat_local_ice(is:ie,js:je))
       call get_grid_version_1(grid_file, 'ice', ice_domain, is, ie, js, je, lon_local_ice, lat_local_ice, &
            min_glo_lon_ice, max_glo_lon_ice )
    endif
 else if(field_exist(grid_file, "ocn_mosaic_file" ) .OR. field_exist(grid_file, "gridfiles" ) ) then
    if(field_exist(grid_file, "gridfiles" ) ) then
       count = 0
       if (atm_on) count = count + 1 
       if (lnd_on) count = count + 1 
       if ( ocn_on .OR. ice_on ) count = count + 1 
       if(count .NE. 1) call mpp_error(FATAL, 'data_override_mod: the grid file is a solo mosaic, ' // &
            'one and only one of atm_on, lnd_on or ice_on/ocn_on should be true')
    endif
   if (atm_on .and. .not. allocated(lon_local_atm) ) then
       call mpp_get_compute_domain(atm_domain,is,ie,js,je) 
       allocate(lon_local_atm(is:ie,js:je), lat_local_atm(is:ie,js:je))
       call get_grid_version_2(grid_file, 'atm', atm_domain, is, ie, js, je, lon_local_atm, lat_local_atm, &
            min_glo_lon_atm, max_glo_lon_atm )
    endif

    if (ocn_on .and. .not. allocated(lon_local_ocn) ) then
       call mpp_get_compute_domain( ocn_domain,is,ie,js,je) 
       allocate(lon_local_ocn(is:ie,js:je), lat_local_ocn(is:ie,js:je))
       call get_grid_version_2(grid_file, 'ocn', ocn_domain, is, ie, js, je, lon_local_ocn, lat_local_ocn, &
            min_glo_lon_ocn, max_glo_lon_ocn )
    endif

    if (lnd_on .and. .not. allocated(lon_local_lnd) ) then
       call mpp_get_compute_domain( lnd_domain,is,ie,js,je) 
       allocate(lon_local_lnd(is:ie,js:je), lat_local_lnd(is:ie,js:je))
       call get_grid_version_2(grid_file, 'lnd', lnd_domain, is, ie, js, je, lon_local_lnd, lat_local_lnd, &
            min_glo_lon_lnd, max_glo_lon_lnd )
    endif

    if (ice_on .and. .not. allocated(lon_local_ice) ) then
       call mpp_get_compute_domain( ice_domain,is,ie,js,je) 
       allocate(lon_local_ice(is:ie,js:je), lat_local_ice(is:ie,js:je))
       call get_grid_version_2(grid_file, 'ocn', ice_domain, is, ie, js, je, lon_local_ice, lat_local_ice, &
            min_glo_lon_ice, max_glo_lon_ice )
    endif
 else
    call mpp_error(FATAL, 'data_override_mod: none of x_T, geolon_t, ocn_mosaic_file or gridfiles exist in '//trim(grid_file))
 end if

end subroutine data_override_init
! </SUBROUTINE>
!===============================================================================================
subroutine check_grid_sizes(domain_name, Domain, nlon, nlat)
character(len=12), intent(in) :: domain_name
type (domain2d),   intent(in) :: Domain
integer,           intent(in) :: nlon, nlat

character(len=184) :: error_message
integer            :: xsize, ysize

call mpp_get_global_domain(Domain, xsize=xsize, ysize=ysize)
if(nlon .NE. xsize .OR. nlat .NE. ysize) then
  error_message = 'Error in data_override_init. Size of grid as specified by '// &
                  '             does not conform to that specified by grid_spec.nc.'// &
                  '  From             :     by      From grid_spec.nc:     by    '
  error_message( 59: 70) = domain_name
  error_message(130:141) = domain_name
  write(error_message(143:146),'(i4)') xsize
  write(error_message(150:153),'(i4)') ysize
  write(error_message(174:177),'(i4)') nlon
  write(error_message(181:184),'(i4)') nlat
  call mpp_error(FATAL,error_message)
endif

end subroutine check_grid_sizes
!===============================================================================================
subroutine get_domain(gridname, domain, comp_domain)
! Given a gridname, this routine returns the working domain associated with this gridname
  character(len=3), intent(in) :: gridname
  type(domain2D), intent(inout) :: domain
  integer, intent(out), optional :: comp_domain(4) ! istart,iend,jstart,jend for compute domain

  domain = NULL_DOMAIN2D
  select case (gridname)
     case('OCN')
        domain = ocn_domain
     case('ATM')       
        domain = atm_domain
     case('LND')       
        domain = lnd_domain
     case('ICE')        
        domain = ice_domain
     case default
        call mpp_error(FATAL,'error in data_override get_domain')
  end select
  if(domain .EQ. NULL_DOMAIN2D) call mpp_error(FATAL,'data_override: failure in get_domain')
  if(present(comp_domain)) &
     call mpp_get_compute_domain(domain,comp_domain(1),comp_domain(2),comp_domain(3),comp_domain(4)) 
end subroutine get_domain
!===============================================================================================

! <SUBROUTINE NAME="data_override_2d">
!   <DESCRIPTION>
! This routine performs data override for 2D fields; for usage, see data_override_3d.
!   </DESCRIPTION>
subroutine data_override_2d(gridname,fieldname,data_2D,time,override, is_in, ie_in, js_in, je_in)
  character(len=3), intent(in) :: gridname ! model grid ID
  character(len=*), intent(in) :: fieldname ! field to override
  logical, intent(out), optional :: override ! true if the field has been overriden succesfully
  type(time_type), intent(in) :: time !  model time
  real, dimension(:,:), intent(inout) :: data_2D !data returned by this call
  integer,           optional,  intent(in) :: is_in, ie_in, js_in, je_in
!  real, dimension(size(data_2D,1),size(data_2D,2),1) :: data_3D
  real, dimension(:,:,:), allocatable ::  data_3D
  integer       :: index1
  integer       :: i

!1  Look  for the data file in data_table 
  if(PRESENT(override)) override = .false.
  index1 = -1
  do i = 1, table_size
     if( trim(gridname) /= trim(data_table(i)%gridname)) cycle
     if( trim(fieldname) /= trim(data_table(i)%fieldname_code)) cycle
     index1 = i                               ! field found        
     exit
  enddo
  if(index1 .eq. -1) then
     if(mpp_pe() == mpp_root_pe() .and. debug_data_override) &
          call mpp_error(WARNING,'this field is NOT found in data_table: '//trim(gridname)//' '//trim(fieldname))
     return  ! NO override was performed
  endif

  allocate(data_3D(size(data_2D,1),size(data_2D,2),1))
  data_3D(:,:,1) = data_2D
  call data_override_3d(gridname,fieldname,data_3D,time,override,data_index=index1,&
                       is_in=is_in,ie_in=ie_in,js_in=js_in,je_in=je_in)
     
  data_2D(:,:) = data_3D(:,:,1)
  deallocate(data_3D)
end subroutine data_override_2d
! </SUBROUTINE>
!===============================================================================================

! <SUBROUTINE NAME="data_override_3d">
!   <DESCRIPTION>
! This routine performs data override for 3D fields
!   <TEMPLATE>
! call data_override(gridname,fieldname,data,time,override)
!   </TEMPLATE>
!   </DESCRIPTION>

!   <IN NAME="gridname"  TYPE="character" DIM="(*)">
! Grid name (Ocean, Ice, Atmosphere, Land)
!   </IN>
!   <IN NAME="fieldname_code" TYPE="character" DIM="(*)">
!    Field name as used in the code (may be different from the name in NetCDF data file)
!   </IN>
!   <OUT NAME="data" TYPE="real" DIM="(:,:,:)">
!    array containing output data
!   </OUT>
!   <IN NAME="time" TYPE="time_type">
!    model time
!   </IN>
!   <OUT NAME="override" TYPE="logical">
!    TRUE if the field is overriden, FALSE otherwise
!   </OUT>
!   <IN NAME="data_index" TYPE="integer">
!   </IN>
subroutine data_override_3d(gridname,fieldname_code,data,time,override,data_index, is_in, ie_in, js_in, je_in)
  character(len=3),             intent(in) :: gridname ! model grid ID
  character(len=*),             intent(in) :: fieldname_code ! field name as used in the model
  logical,           optional, intent(out) :: override ! true if the field has been overriden succesfully
  type(time_type),              intent(in) :: time !(target) model time
  integer,           optional,  intent(in) :: data_index
  real, dimension(:,:,:),    intent(inout) :: data !data returned by this call
  integer,           optional,  intent(in) :: is_in, ie_in, js_in, je_in
  logical, dimension(:,:,:),   allocatable :: mask_out

  character(len=512) :: filename, filename2 !file containing source data
  character(len=128) :: fieldname ! fieldname used in the data file
  integer            :: i,j
  integer            :: dims(4)
  integer            :: index1 ! field index in data_table
  integer            :: id_time !index for time interp in override array
  integer            :: axis_sizes(4)
  real, dimension(:,:), pointer :: lon_local =>NULL(), &
                                   lat_local =>NULL() !of output (target) grid cells
  real, dimension(:), allocatable :: lon_tmp, lat_tmp

  type(axistype) :: axis_centers(4), axis_bounds(4)
  logical :: data_file_is_2D = .false.  !data in netCDF file is 2D
  logical :: ongrid, use_comp_domain
  type(domain2D) :: domain
  integer :: curr_position ! position of the field currently processed in override_array
  real :: factor
  integer, dimension(4) :: comp_domain = 0  ! istart,iend,jstart,jend for compute domain
  integer :: nxd, nyd, nxc, nyc, nwindows
  integer :: nwindows_x, ipos, jpos, window_size(2)
  integer :: istart, iend, jstart, jend
  integer :: isw, iew, jsw, jew, n
  integer :: omp_get_num_threads, omp_get_thread_num, thread_id, window_id
  logical :: need_compute
  real    :: lat_min, lat_max
  integer :: is_src, ie_src, js_src, je_src
  logical :: exists

  use_comp_domain = .false.
  if(.not.module_is_initialized) &
       call mpp_error(FATAL,'Error: need to call data_override_init first')

!1  Look  for the data file in data_table 
  if(PRESENT(override)) override = .false.
  if (present(data_index)) then
    index1 = data_index
  else
    index1 = -1
    do i = 1, table_size
       if( trim(gridname) /= trim(data_table(i)%gridname)) cycle
       if( trim(fieldname_code) /= trim(data_table(i)%fieldname_code)) cycle
       index1 = i                               ! field found        
       exit
    enddo
    if(index1 .eq. -1) then
       if(mpp_pe() == mpp_root_pe() .and. debug_data_override) &
            call mpp_error(WARNING,'this field is NOT found in data_table: '//trim(gridname)//' '//trim(fieldname_code))
       return  ! NO override was performed
    endif
  endif

  fieldname = data_table(index1)%fieldname_file ! fieldname in netCDF data file
  factor = data_table(index1)%factor

  if(fieldname == "") then
     data = factor
     if(PRESENT(override)) override = .true.
     return
  else
     filename = data_table(index1)%file_name
     if (filename == "") call mpp_error(FATAL,'data_override: filename not given in data_table')
  endif  

  ongrid = (data_table(index1)%interpol_method == 'none')

!3 Check if fieldname has been previously processed
!$OMP CRITICAL
  curr_position = -1
  if(num_fields > 0 ) then
     do i = 1, num_fields
        if(trim(override_array(i)%gridname) /= trim(gridname))   cycle 
        if(trim(override_array(i)%fieldname) /= trim(fieldname_code)) cycle
        curr_position = i
        exit        
     enddo
  endif

  if(curr_position < 0) then ! the field has not been processed previously
     num_fields = num_fields + 1
     curr_position = num_fields     

! Get working domain from model's gridname
     call get_domain(gridname,domain,comp_domain)                          
     call mpp_get_data_domain(domain, xsize=nxd, ysize=nyd) 
     nxc = comp_domain(2)-comp_domain(1) + 1
     nyc = comp_domain(4)-comp_domain(3) + 1

! record fieldname, gridname in override_array    
     override_array(curr_position)%fieldname = fieldname_code
     override_array(curr_position)%gridname = gridname
     override_array(curr_position)%comp_domain = comp_domain
! get number of threads
     override_array(curr_position)%numthreads = 1
#if defined(_OPENMP)
     override_array(curr_position)%numthreads = omp_get_num_threads()
#endif
!--- data_override may be called from physics windows. The following are possible situations
!--- 1. size(data,1) == nxd and size(data,2) == nyd   ( on data domain and there is only one window).
!--- 2. nxc is divisible by size(data,1), nyc is divisible by size(data,2),
!---    nwindow = (nxc/size(data(1))*(nyc/size(data,2)), also we require nwindows is divisible by nthreads.
!---    The another restrition is that size(data,1) == ie_in - is_in + 1,
!---                                   size(data,2) == je_in - js_in + 1            
     nwindows = 1
     if( nxd == size(data,1) .AND. nyd == size(data,2) ) then  ! 
        use_comp_domain = .false.
     else if ( mod(nxc, size(data,1)) ==0 .AND. mod(nyc, size(data,2)) ==0 ) then
        use_comp_domain = .true.
        nwindows = (nxc/size(data,1))*(nyc/size(data,2))
     else
        call mpp_error(FATAL, "data_override: data is not on data domain and compute domain is not divisible by size(data)")
     endif
     override_array(curr_position)%window_size(1) = size(data,1)
     override_array(curr_position)%window_size(2) = size(data,2)

     window_size = override_array(curr_position)%window_size
     override_array(curr_position)%numwindows = nwindows
     if( mod(nwindows, override_array(curr_position)%numthreads) .NE. 0 ) then
        call mpp_error(FATAL, "data_override: nwindow is not divisible by nthreads")
     endif
     allocate(override_array(curr_position)%need_compute(nwindows))
     override_array(curr_position)%need_compute = .true.

!4 get index for time interp   
     if(ongrid) then
        if( data_table(index1)%region_type .NE. NO_REGION ) then
           call mpp_error(FATAL,'data_override: ongrid must be false when region_type .NE. NO_REGION')
        endif

!  Allow on-grid data_overrides on cubed sphere grid
        inquire(file=trim(filename),EXIST=exists)
        if (.not. exists) then
           call get_mosaic_tile_file(filename,filename2,.false.,domain)
           filename = filename2
        endif

        !--- we always only pass data on compute domain
        id_time = init_external_field(filename,fieldname,domain=domain,verbose=.false., &
                                      use_comp_domain=use_comp_domain, nwindows=nwindows)
        dims = get_external_field_size(id_time)
        override_array(curr_position)%dims = dims
        if(id_time<0) call mpp_error(FATAL,'data_override:field not found in init_external_field 1') 
        override_array(curr_position)%t_index = id_time     
     else !ongrid=false
        id_time = init_external_field(filename,fieldname,domain=domain, axis_centers=axis_centers,&
             axis_sizes=axis_sizes, verbose=.false.,override=.true.,use_comp_domain=use_comp_domain, &
             nwindows = nwindows)  
        dims = get_external_field_size(id_time)
        override_array(curr_position)%dims = dims
        if(id_time<0) call mpp_error(FATAL,'data_override:field not found in init_external_field 2')
        override_array(curr_position)%t_index = id_time

        !  get lon and lat of the input (source) grid, assuming that axis%data contains
        !  lat and lon of the input grid (in degrees)
        call get_axis_bounds(axis_centers(1),axis_bounds(1), axis_centers)
        call get_axis_bounds(axis_centers(2),axis_bounds(2), axis_centers)

        allocate(override_array(curr_position)%horz_interp(nwindows))
        allocate(override_array(curr_position)%lon_in(axis_sizes(1)+1))
        allocate(override_array(curr_position)%lat_in(axis_sizes(2)+1))
        call mpp_get_axis_data(axis_bounds(1),override_array(curr_position)%lon_in)
        call mpp_get_axis_data(axis_bounds(2),override_array(curr_position)%lat_in)

! convert lon_in and lat_in from deg to radian
        override_array(curr_position)%lon_in = override_array(curr_position)%lon_in * deg_to_radian
        override_array(curr_position)%lat_in = override_array(curr_position)%lat_in * deg_to_radian

        !--- find the region of the source grid that cover the local model grid.
        !--- currently we only find the index range for j-direction because  
        !--- of the cyclic condition in i-direction. The purpose of this is to 
        !--- decrease the memory usage and increase the IO performance.
        select case(gridname)
        case('OCN')
           lon_local => lon_local_ocn; lat_local => lat_local_ocn
        case('ICE')
           lon_local => lon_local_ice; lat_local => lat_local_ice
        case('ATM')
           lon_local => lon_local_atm; lat_local => lat_local_atm
        case('LND')
           lon_local => lon_local_lnd; lat_local => lat_local_lnd
        case default
           call mpp_error(FATAL,'error: gridname not recognized in data_override')
        end select
     
        lat_min = minval(lat_local)
        lat_max = maxval(lat_local)
        is_src = 1
        ie_src = axis_sizes(1)
        js_src = 1
        je_src = axis_sizes(2)
        do j = 1, axis_sizes(2)+1
           if( override_array(curr_position)%lat_in(j) > lat_min ) exit
           js_src = j
        enddo
        do j = 1, axis_sizes(2)+1
           je_src = j
           if( override_array(curr_position)%lat_in(j) > lat_max ) exit
        enddo

        !--- bicubic interpolation need one extra point in each direction. Also add 
        !--- one more point for because lat_in is in the corner but the interpolation
        !--- use center points.
        select case (data_table(index1)%interpol_method)
        case ('bilinear')
           js_src = max(1, js_src-1)
           je_src = min(axis_sizes(2), je_src+1)
        case ('bicubic')        
           js_src = max(1, js_src-2)
           je_src = min(axis_sizes(2), je_src+2)
        end select
        override_array(curr_position)%is_src = is_src
        override_array(curr_position)%ie_src = ie_src
        override_array(curr_position)%js_src = js_src
        override_array(curr_position)%je_src = je_src
        call reset_src_data_region(id_time, is_src, ie_src, js_src, je_src)

!       Find the index of lon_start, lon_end, lat_start and lat_end in the input grid (nearest points)
        if( data_table(index1)%region_type .NE. NO_REGION ) then
           allocate( lon_tmp(axis_sizes(1)), lat_tmp(axis_sizes(2)) )
           call mpp_get_axis_data(axis_centers(1), lon_tmp)
           call mpp_get_axis_data(axis_centers(2), lat_tmp)
           ! limit lon_start, lon_end are inside lon_in
           !       lat_start, lat_end are inside lat_in
           if( data_table(index1)%lon_start < lon_tmp(1) .OR. data_table(index1)%lon_start .GT. lon_tmp(axis_sizes(1))) &
              call mpp_error(FATAL, "data_override: lon_start is outside lon_T")
           if( data_table(index1)%lon_end < lon_tmp(1) .OR. data_table(index1)%lon_end .GT. lon_tmp(axis_sizes(1))) &
              call mpp_error(FATAL, "data_override: lon_end is outside lon_T")
           if( data_table(index1)%lat_start < lat_tmp(1) .OR. data_table(index1)%lat_start .GT. lat_tmp(axis_sizes(2))) &
              call mpp_error(FATAL, "data_override: lat_start is outside lat_T")
           if( data_table(index1)%lat_end < lat_tmp(1) .OR. data_table(index1)%lat_end .GT. lat_tmp(axis_sizes(2))) &
              call mpp_error(FATAL, "data_override: lat_end is outside lat_T")
           istart = nearest_index(data_table(index1)%lon_start, lon_tmp)
           iend   = nearest_index(data_table(index1)%lon_end,   lon_tmp)
           jstart = nearest_index(data_table(index1)%lat_start, lat_tmp)
           jend   = nearest_index(data_table(index1)%lat_end,   lat_tmp)
           ! adjust the index according to is_src and js_src
           istart = istart - is_src + 1
           iend   = iend   - is_src + 1
           jstart = jstart - js_src + 1
           jend   = jend   - js_src + 1
           call set_override_region(id_time, data_table(index1)%region_type, istart, iend, jstart, jend)
           deallocate(lon_tmp, lat_tmp)
        endif

     endif
  else !curr_position >0
     dims = override_array(curr_position)%dims
     comp_domain = override_array(curr_position)%comp_domain
     is_src      = override_array(curr_position)%is_src
     ie_src      = override_array(curr_position)%ie_src
     js_src      = override_array(curr_position)%js_src
     je_src      = override_array(curr_position)%je_src
     window_size = override_array(curr_position)%window_size
     !---make sure data size match window_size
     if( window_size(1) .NE. size(data,1) .OR. window_size(2) .NE. size(data,2) ) then
        call mpp_error(FATAL, "data_override: window_size does not match size(data)")
     endif
!9 Get id_time  previously stored in override_array
     id_time = override_array(curr_position)%t_index
  endif 
!$OMP END CRITICAL  

  if( override_array(curr_position)%numwindows > 1 ) then
      if( .NOT. PRESENT(is_in) .OR. .NOT. PRESENT(is_in) .OR. .NOT. PRESENT(is_in) .OR. .NOT. PRESENT(is_in) ) then
          call mpp_error(FATAL, "data_override: is_in, ie_in, js_in, je_in must be present when nwindows > 1")
      endif
  endif
 
  isw = comp_domain(1)
  iew = comp_domain(2)
  jsw = comp_domain(3)
  jew = comp_domain(4)
  window_id = 1
  if( override_array(curr_position)%numwindows > 1 ) then
     nxc = comp_domain(2) - comp_domain(1) + 1
     nwindows_x = nxc/window_size(1)
     ipos = (is_in-1)/window_size(1) + 1
     jpos = (js_in-1)/window_size(2)

     window_id = jpos*nwindows_x + ipos 
     isw = isw + is_in - 1
     iew = isw + ie_in - is_in
     jsw = jsw + js_in - 1
     jew = jsw + je_in - js_in
  endif

  if( ongrid ) then
     need_compute = .false.
  else
     !--- find the index for windows.
     need_compute=override_array(curr_position)%need_compute(window_id)
  endif

  !--- call horiz_interp_new is not initialized

  if( need_compute ) then
     select case(gridname)
     case('OCN')
        lon_local => lon_local_ocn; lat_local => lat_local_ocn
     case('ICE')
        lon_local => lon_local_ice; lat_local => lat_local_ice
     case('ATM')
        lon_local => lon_local_atm; lat_local => lat_local_atm
     case('LND')
        lon_local => lon_local_lnd; lat_local => lat_local_lnd
     case default
        call mpp_error(FATAL,'error: gridname not recognized in data_override')
     end select

     select case (data_table(index1)%interpol_method)
     case ('bilinear')
        call horiz_interp_new (override_array(curr_position)%horz_interp(window_id), &
             override_array(curr_position)%lon_in(is_src:ie_src+1),                  &
             override_array(curr_position)%lat_in(js_src:je_src+1),                  &
             lon_local(isw:iew,jsw:jew), lat_local(isw:iew,jsw:jew), interp_method="bilinear")
     case ('bicubic')
        call horiz_interp_new (override_array(curr_position)%horz_interp(window_id), &
             override_array(curr_position)%lon_in(is_src:ie_src+1),                  &
             override_array(curr_position)%lat_in(js_src:je_src+1),                  &
             lon_local(isw:iew,jsw:jew), lat_local(isw:iew,jsw:jew), interp_method="bicubic")
     end select
     override_array(curr_position)%need_compute(window_id) = .false.
  endif

  ! Determine if  data in netCDF file is 2D or not  
  data_file_is_2D = .false.
  if((dims(3) == 1) .and. (size(data,3)>1)) data_file_is_2D = .true. 

  if(ongrid) then
!10 do time interp to get data in compute_domain
     if(data_file_is_2D) then        
        call time_interp_external(id_time,time,data(:,:,1),verbose=.false., &
                                  is_in=is_in,ie_in=ie_in,js_in=js_in,je_in=je_in,window_id=window_id)
        data(:,:,1) = data(:,:,1)*factor
        do i = 2, size(data,3)
           data(:,:,i) = data(:,:,1)
        enddo
     else
        call time_interp_external(id_time,time,data,verbose=.false., &
                                  is_in=is_in,ie_in=ie_in,js_in=js_in,je_in=je_in,window_id=window_id)
        data = data*factor
     endif    
  else  ! off grid case
! do time interp to get global data
     if(data_file_is_2D) then
        if( data_table(index1)%region_type == NO_REGION ) then
           call time_interp_external(id_time,time,data(:,:,1),verbose=.false., &
                   horz_interp=override_array(curr_position)%horz_interp(window_id), &
                   is_in=is_in,ie_in=ie_in,js_in=js_in,je_in=je_in,window_id=window_id)
           data(:,:,1) = data(:,:,1)*factor   
           do i = 2, size(data,3)
             data(:,:,i) = data(:,:,1)
           enddo
        else
           allocate(mask_out(size(data,1), size(data,2),1))
           mask_out = .false.
           call time_interp_external(id_time,time,data(:,:,1),verbose=.false., &
                   horz_interp=override_array(curr_position)%horz_interp(window_id),      &
                   mask_out   =mask_out(:,:,1), &
                   is_in=is_in,ie_in=ie_in,js_in=js_in,je_in=je_in,window_id=window_id)
           where(mask_out(:,:,1))
              data(:,:,1) = data(:,:,1)*factor
           end where
           do i = 2, size(data,3)
              where(mask_out(:,:,1))
                data(:,:,i) = data(:,:,1)
              end where
           enddo
           deallocate(mask_out)
        endif
     else
        if( data_table(index1)%region_type == NO_REGION ) then
           call time_interp_external(id_time,time,data,verbose=.false.,      &
                horz_interp=override_array(curr_position)%horz_interp(window_id), &
                is_in=is_in,ie_in=ie_in,js_in=js_in,je_in=je_in,window_id=window_id)
           data = data*factor
        else
           allocate(mask_out(size(data,1), size(data,2), size(data,3)) )
           mask_out = .false.
           call time_interp_external(id_time,time,data,verbose=.false.,      &
                horz_interp=override_array(curr_position)%horz_interp(window_id),    &
                mask_out   =mask_out, &
                is_in=is_in,ie_in=ie_in,js_in=js_in,je_in=je_in,window_id=window_id)

           where(mask_out)        
              data = data*factor
           end where
           deallocate(mask_out)
        endif
     endif

  endif

  if(PRESENT(override)) override = .true.

end subroutine data_override_3d
! </SUBROUTINE>

! <SUBROUTINE NAME="data_override_0d">
!   <DESCRIPTION>
! This routine performs data override for scalar fields
!   <TEMPLATE>
! call data_override(fieldname,data,time,override)
!   </TEMPLATE>
!   </DESCRIPTION>
!   <IN NAME="gridname"  TYPE="character" DIM="(*)">
! Grid name (Ocean, Ice, Atmosphere, Land)
!   </IN>
!   <IN NAME="fieldname_code" TYPE="character" DIM="(*)">
!    Field name as used in the code (may be different from the name in NetCDF data file)
!   </IN>
!   <OUT NAME="data" TYPE="real" DIM="(:,:,:)">
!    array containing output data
!   </OUT>
!   <IN NAME="time" TYPE="time_type">
!    model time
!   </IN>
!   <OUT NAME="override" TYPE="logical">
!    TRUE if the field is overriden, FALSE otherwise
!   </OUT>
!   <IN NAME="data_index" TYPE="integer">
!   </IN>
subroutine data_override_0d(gridname,fieldname_code,data,time,override,data_index)
  character(len=3), intent(in) :: gridname ! model grid ID
  character(len=*), intent(in) :: fieldname_code ! field name as used in the model
  logical, intent(out), optional :: override ! true if the field has been overriden succesfully
  type(time_type), intent(in) :: time !(target) model time
  real,             intent(out) :: data !data returned by this call
  integer, intent(in), optional :: data_index

  character(len=512) :: filename !file containing source data
  character(len=128) :: fieldname ! fieldname used in the data file
  integer :: index1 ! field index in data_table
  integer :: id_time !index for time interp in override array
  integer :: curr_position ! position of the field currently processed in override_array
  integer :: i
  real :: factor

  if(.not.module_is_initialized) &
       call mpp_error(FATAL,'Error: need to call data_override_init first')

!1  Look  for the data file in data_table 
  if(PRESENT(override)) override = .false.
  if (present(data_index)) then
    index1 = data_index
  else
    index1 = -1
    do i = 1, table_size
       if( trim(gridname) /= trim(data_table(i)%gridname)) cycle
       if( trim(fieldname_code) /= trim(data_table(i)%fieldname_code)) cycle
       index1 = i                               ! field found        
       exit
    enddo
    if(index1 .eq. -1) then
       if(mpp_pe() == mpp_root_pe() .and. debug_data_override) &
            call mpp_error(WARNING,'this field is NOT found in data_table: '//trim(gridname)//' '//trim(fieldname_code))
       return  ! NO override was performed
    endif
  endif
 
  fieldname = data_table(index1)%fieldname_file ! fieldname in netCDF data file
  factor = data_table(index1)%factor

  if(fieldname == "") then
     data = factor
     if(PRESENT(override)) override = .true.
     return
  else
     filename = data_table(index1)%file_name
     if (filename == "") call mpp_error(FATAL,'data_override: filename not given in data_table')
  endif  

!3 Check if fieldname has been previously processed
!$OMP SINGLE
  curr_position = -1
  if(num_fields > 0 ) then
     do i = 1, num_fields
        if(trim(override_array(i)%gridname) /= trim(gridname))   cycle 
        if(trim(override_array(i)%fieldname) /= trim(fieldname_code)) cycle
        curr_position = i
        exit        
     enddo
  endif

  if(curr_position < 0) then ! the field has not been processed previously
     num_fields = num_fields + 1
     curr_position = num_fields     
     ! record fieldname, gridname in override_array    
     override_array(curr_position)%fieldname = fieldname_code
     override_array(curr_position)%gridname = gridname
     id_time = init_external_field(filename,fieldname,verbose=.false.)
     if(id_time<0) call mpp_error(FATAL,'data_override:field not found in init_external_field 1') 
     override_array(curr_position)%t_index = id_time     
  else !curr_position >0
     !9 Get id_time  previously stored in override_array
     id_time = override_array(curr_position)%t_index
  endif !if curr_position < 0

  !10 do time interp to get data in compute_domain
  call time_interp_external(id_time, time, data, verbose=.false.)
  data = data*factor
!$OMP END SINGLE

  if(PRESENT(override)) override = .true.

end subroutine data_override_0d
! </SUBROUTINE>

!===============================================================================================

! Get lon and lat of three model (target) grids from grid_spec.nc
subroutine get_grid_version_1(grid_file, mod_name, domain, isc, iec, jsc, jec, lon, lat, min_lon, max_lon)
  character(len=*),            intent(in) :: grid_file
  character(len=*),            intent(in) :: mod_name
  type(domain2d),              intent(in) :: domain
  integer,                     intent(in) :: isc, iec, jsc, jec
  real, dimension(isc:,jsc:), intent(out) :: lon, lat
  real,                       intent(out) :: min_lon, max_lon

  integer                                      :: i, j, siz(4)
  integer                                      :: nlon, nlat         ! size of global lon and lat
  real,          dimension(:,:,:), allocatable :: lon_vert, lat_vert !of OCN grid vertices
  real,          dimension(:),     allocatable :: glon, glat         ! lon and lat of 1-D grid of atm/lnd
  logical                                      :: is_new_grid
  integer                                      :: is, ie, js, je
  integer                                      :: isd, ied, jsd, jed
  integer                                      :: isg, ieg, jsg, jeg
  type(domain2d)                               :: domain2
  character(len=3)                             :: xname, yname

  call mpp_get_data_domain(domain, isd, ied, jsd, jed)
  call mpp_get_global_domain(domain, isg, ieg, jsg, jeg)

  select case(mod_name)
  case('ocn', 'ice')
    is_new_grid = .FALSE.
    if(field_exist(grid_file, 'x_T')) then
       is_new_grid = .true.
    else if(field_exist(grid_file, 'geolon_t')) then
       is_new_grid = .FALSE.
    else
       call mpp_error(FATAL,'data_override: both x_T and geolon_t is not in the grid file '//trim(grid_file) )
    endif

    if(is_new_grid) then
      call field_size(grid_file, 'x_T', siz)
      nlon = siz(1); nlat = siz(2)
      call check_grid_sizes(trim(mod_name)//'_domain  ', domain, nlon, nlat)
      allocate(lon_vert(isc:iec,jsc:jec,4), lat_vert(isc:iec,jsc:jec,4) )
      call read_data(trim(grid_file), 'x_vert_T', lon_vert, domain)
      call read_data(trim(grid_file), 'y_vert_T', lat_vert, domain)
      
!2 Global lon and lat of ocean grid cell centers are determined from adjacent vertices
      lon(:,:) = (lon_vert(:,:,1) + lon_vert(:,:,2) + lon_vert(:,:,3) + lon_vert(:,:,4))*0.25
      lat(:,:) = (lat_vert(:,:,1) + lat_vert(:,:,2) + lat_vert(:,:,3) + lat_vert(:,:,4))*0.25
    else      
      if(grid_center_bug) call mpp_error(NOTE, &
           'data_override: grid_center_bug is set to true, the grid center location may be incorrect')
      call field_size(grid_file, 'geolon_vert_t', siz)
      nlon = siz(1) - 1; nlat = siz(2) - 1;
      call check_grid_sizes(trim(mod_name)//'_domain  ', domain, nlon, nlat)
      call mpp_copy_domain(domain, domain2)
      call mpp_set_compute_domain(domain2, isc, iec+1, jsc, jec+1, iec-isc+2, jec-jsc+2 )
      call mpp_set_data_domain   (domain2, isd, ied+1, jsd, jed+1, ied-isd+2, jed-jsd+2 )   
      call mpp_set_global_domain (domain2, isg, ieg+1, jsg, jeg+1, ieg-isg+2, jeg-jsg+2 )    
      allocate(lon_vert(isc:iec+1,jsc:jec+1,1))
      allocate(lat_vert(isc:iec+1,jsc:jec+1,1))
      call read_data(trim(grid_file), 'geolon_vert_t', lon_vert, domain2)
      call read_data(trim(grid_file), 'geolat_vert_t', lat_vert, domain2)

      if(grid_center_bug) then
         do j = jsc, jec
            do i = isc, iec
               lon(i,j) = (lon_vert(i,j,1) + lon_vert(i+1,j,1))/2.
               lat(i,j) = (lat_vert(i,j,1) + lat_vert(i,j+1,1))/2.
            enddo
         enddo
      else
         do j = jsc, jec
            do i = isc, iec
               lon(i,j) = (lon_vert(i,j,1) + lon_vert(i+1,j,1) + &
                    lon_vert(i+1,j+1,1) + lon_vert(i,j+1,1))*0.25
               lat(i,j) = (lat_vert(i,j,1) + lat_vert(i+1,j,1) + &
                    lat_vert(i+1,j+1,1) + lat_vert(i,j+1,1))*0.25
            enddo
         enddo
      end if
      call mpp_deallocate_domain(domain2)
    endif
    deallocate(lon_vert)
    deallocate(lat_vert)
  case('atm', 'lnd')
     if(trim(mod_name) == 'atm') then
        xname = 'xta'; yname = 'yta'
     else
        xname = 'xtl'; yname = 'ytl'
     endif
     call field_size(grid_file, xname, siz)
     nlon = siz(1); allocate(glon(nlon))
     call read_data(grid_file, xname, glon, no_domain = .true.)

     call field_size(grid_file, yname, siz)
     nlat = siz(1); allocate(glat(nlat))
     call read_data(grid_file, yname, glat, no_domain = .true.)
     call check_grid_sizes(trim(mod_name)//'_domain  ', domain, nlon, nlat)

     is = isc - isg + 1; ie = iec - isg + 1
     js = jsc - jsg + 1; je = jec - jsg + 1
     do j = js, jec
        do i = is, ie
           lon(i,j) = glon(i)
           lat(i,j) = glat(j)
        enddo
     enddo
     deallocate(glon)
     deallocate(glat)
  case default
     call mpp_error(FATAL, "data_override_mod: mod_name should be 'atm', 'ocn', 'ice' or 'lnd' ")
  end select
 
  ! convert from degree to radian
  lon = lon * deg_to_radian
  lat = lat* deg_to_radian
  min_lon = minval(lon)
  max_lon = maxval(lon)
  call mpp_min(min_lon)
  call mpp_max(max_lon)


end subroutine get_grid_version_1

! Get global lon and lat of three model (target) grids from mosaic.nc
! z1l: currently we assume the refinement ratio is 2 and there is one tile on each pe.
subroutine get_grid_version_2(mosaic_file, mod_name, domain, isc, iec, jsc, jec, lon, lat, min_lon, max_lon)
  character(len=*),            intent(in) :: mosaic_file
  character(len=*),            intent(in) :: mod_name
  type(domain2d),              intent(in) :: domain
  integer,                     intent(in) :: isc, iec, jsc, jec
  real, dimension(isc:,jsc:), intent(out) :: lon, lat
  real,                       intent(out) :: min_lon, max_lon

  integer            :: i, j, siz(4)
  integer            :: nlon, nlat             ! size of global grid
  integer            :: nlon_super, nlat_super ! size of global supergrid.
  integer            :: isd, ied, jsd, jed
  integer            :: isg, ieg, jsg, jeg
  integer            :: isc2, iec2, jsc2, jec2
  character(len=256) :: solo_mosaic_file, grid_file
  real, allocatable  :: tmpx(:,:), tmpy(:,:)
  type(domain2d)     :: domain2

  if(trim(mod_name) .NE. 'atm' .AND. trim(mod_name) .NE. 'ocn' .AND. &
     trim(mod_name) .NE. 'ice' .AND. trim(mod_name) .NE. 'lnd' ) call mpp_error(FATAL, &
        "data_override_mod: mod_name should be 'atm', 'ocn', 'ice' or 'lnd' ")

  call mpp_get_data_domain(domain, isd, ied, jsd, jed)
  call mpp_get_global_domain(domain, isg, ieg, jsg, jeg)

  ! get the grid file to read
  if(field_exist(mosaic_file, trim(mod_name)//'_mosaic_file' )) then
     call read_data(mosaic_file, trim(mod_name)//'_mosaic_file', solo_mosaic_file) 
     solo_mosaic_file = 'INPUT/'//trim(solo_mosaic_file)
  else
     solo_mosaic_file = mosaic_file
  end if
  call get_mosaic_tile_grid(grid_file, solo_mosaic_file, domain)

  call field_size(grid_file, 'area', siz)
  nlon_super = siz(1); nlat_super = siz(2)
  if( mod(nlon_super,2) .NE. 0) call mpp_error(FATAL,  &
       'data_override_mod: '//trim(mod_name)//' supergrid longitude size can not be divided by 2')
  if( mod(nlat_super,2) .NE. 0) call mpp_error(FATAL,  &
       'data_override_mod: '//trim(mod_name)//' supergrid latitude size can not be divided by 2')
  nlon = nlon_super/2;
  nlat = nlat_super/2;     
  call check_grid_sizes(trim(mod_name)//'_domain  ', domain, nlon, nlat)

  !--- setup the domain for super grid.
  call mpp_copy_domain(domain, domain2)
  call mpp_set_compute_domain(domain2, 2*isc-1, 2*iec+1, 2*jsc-1, 2*jec+1, 2*iec-2*isc+3, 2*jec-2*jsc+3 )
  call mpp_set_data_domain   (domain2, 2*isd-1, 2*ied+1, 2*jsd-1, 2*jed+1, 2*ied-2*isd+3, 2*jed-2*jsd+3 )   
  call mpp_set_global_domain (domain2, 2*isg-1, 2*ieg+1, 2*jsg-1, 2*jeg+1, 2*ieg-2*isg+3, 2*jeg-2*jsg+3 )

  call mpp_get_compute_domain(domain2, isc2, iec2, jsc2, jec2)
  if(isc2 .NE. 2*isc-1 .OR. iec2 .NE. 2*iec+1 .OR. jsc2 .NE. 2*jsc-1 .OR. jec2 .NE. 2*jec+1) then
     call mpp_error(FATAL, 'data_override_mod: '//trim(mod_name)//' supergrid domain is not set properly')
  endif

  allocate(tmpx(isc2:iec2, jsc2:jec2), tmpy(isc2:iec2, jsc2:jec2) )
  call read_data( grid_file, 'x', tmpx, domain2)
  call read_data( grid_file, 'y', tmpy, domain2)     
  ! copy data onto model grid
  if(trim(mod_name) == 'ocn' .OR. trim(mod_name) == 'ice') then
     do j = jsc, jec
        do i = isc, iec
           lon(i,j) = (tmpx(i*2-1,j*2-1)+tmpx(i*2+1,j*2-1)+tmpx(i*2+1,j*2+1)+tmpx(i*2-1,j*2+1))*0.25
           lat(i,j) = (tmpy(i*2-1,j*2-1)+tmpy(i*2+1,j*2-1)+tmpy(i*2+1,j*2+1)+tmpy(i*2-1,j*2+1))*0.25
        end do
     end do
  else
     do j = jsc, jec
        do i = isc, iec
           lon(i,j) = tmpx(i*2,j*2)
           lat(i,j) = tmpy(i*2,j*2)
        end do
     end do
  endif

  ! convert to radian
  lon = lon * deg_to_radian
  lat = lat * deg_to_radian

  deallocate(tmpx, tmpy)
  min_lon = minval(lon)
  max_lon = maxval(lon)
  call mpp_min(min_lon)
  call mpp_max(max_lon)

  call mpp_deallocate_domain(domain2)

end subroutine get_grid_version_2

!===============================================================================================
end module data_override_mod

#ifdef test_data_override

 program test

 ! Input data and path_names file for this program is in:
 ! /archive/pjp/unit_tests/test_data_override/lima/exp1

 use           mpp_mod, only: input_nml_file, stdout, mpp_chksum
 use   mpp_domains_mod, only: domain2d, mpp_define_domains, mpp_get_compute_domain, mpp_define_layout
 use           fms_mod, only: fms_init, fms_end, mpp_npes, file_exist, open_namelist_file, check_nml_error, close_file
 use           fms_mod, only: error_mesg, FATAL, file_exist, field_exist, field_size
 use        fms_io_mod, only: read_data, fms_io_exit
 use     constants_mod, only: constants_init, pi
 use  time_manager_mod, only: time_type, set_calendar_type, set_date, NOLEAP, JULIAN, operator(+), set_time, print_time
 use  diag_manager_mod, only: diag_manager_init, diag_manager_end, register_static_field, register_diag_field
 use  diag_manager_mod, only: send_data, diag_axis_init
 use data_override_mod, only: data_override_init, data_override

 implicit none

 integer                           :: stdoutunit
 integer                           :: num_threads = 1
 integer                           :: omp_get_thread_num
 integer                           :: isw, iew, jsw, jew
 integer, allocatable              :: is_win(:), js_win(:)
 integer                           :: nx_dom, ny_dom, nx_win, ny_win
 type(domain2d)                    :: Domain
 integer                           :: nlon, nlat, siz(4)
 real, allocatable, dimension(:)   :: x, y
 real, allocatable, dimension(:,:) :: lon, lat
 real, allocatable, dimension(:,:) :: sst, ice
 integer                           :: id_x, id_y, id_lon, id_lat, id_sst, id_ice
 integer                           :: i, j, is, ie, js, je, unit, io, ierr, n
 real                              :: rad_to_deg
 character(len=36)                 :: message
 type(time_type)                   :: Time
 logical                           :: used
 logical, allocatable              :: ov_sst(:), ov_ice(:)
 integer, dimension(2)             :: layout = (/0,0/)
 character(len=256)                :: solo_mosaic_file, tile_file
 character(len=128)                :: grid_file   = "INPUT/grid_spec.nc"
 integer                           :: window(2) = (/1,1/)
 integer                           :: get_cpu_affinity, base_cpu
 integer                           :: nthreads=1
 integer                           :: nwindows

 namelist / test_data_override_nml / layout, window, nthreads

 call fms_init
 call constants_init
 call set_calendar_type(NOLEAP)
 call diag_manager_init

 rad_to_deg = 180./pi

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, test_data_override_nml, iostat=io)
      ierr = check_nml_error(io, 'test_data_override_nml')
#else
 if (file_exist('input.nml')) then
   unit = open_namelist_file ( )
   ierr=1
   do while (ierr /= 0)
     read(unit, nml=test_data_override_nml, iostat=io, end=10)
          ierr = check_nml_error(io, 'test_data_override_nml')
   enddo
10 call close_file (unit)
 endif
#endif

 if(field_exist(grid_file, "x_T" ) ) then
    call field_size(grid_file, 'x_T', siz)
    nlon = siz(1)
    nlat = siz(2)
 else if(field_exist(grid_file, "geolon_t" ) ) then
    call field_size(grid_file, 'geolon_t', siz)
    nlon = siz(1)
    nlat = siz(2)
 else if (field_exist(grid_file, "ocn_mosaic_file" )) then
    call read_data(grid_file, 'ocn_mosaic_file', solo_mosaic_file) 
    solo_mosaic_file = 'INPUT/'//trim(solo_mosaic_file)
    call field_size(solo_mosaic_file, 'gridfiles', siz)
    if( siz(2) .NE. 1) call error_mesg('test_data_override', 'only support single tile mosaic, contact developer', FATAL)
    call read_data(solo_mosaic_file, 'gridfiles', tile_file)
    tile_file = 'INPUT/'//trim(tile_file)
    call field_size(tile_file, 'area', siz)
    if(mod(siz(1),2) .NE. 0 .OR. mod(siz(2),2) .NE. 0 ) call error_mesg('test_data_override', &
        "test_data_override: supergrid size can not be divided by 2", FATAL)
    nlon = siz(1)/2
    nlat = siz(2)/2
 else
    call error_mesg('test_data_override', 'x_T, geolon_t and ocn_mosaic_file does not exist', FATAL)
 end if

 if(layout(1)*layout(2) .NE. mpp_npes() ) then
    call mpp_define_layout( (/1,nlon,1,nlat/), mpp_npes(), layout )
 end if


 call mpp_define_domains( (/1,nlon,1,nlat/), layout, Domain, name='test_data_override')
 call data_override_init(Ice_domain_in=Domain, Ocean_domain_in=Domain)
 call data_override_init(Ice_domain_in=Domain, Ocean_domain_in=Domain)
 call mpp_get_compute_domain(Domain, is, ie, js, je)
 call get_grid

 allocate(x(nlon), y(nlat))

 do i=1,nlon
   x(i) = i
 enddo
 do j=1,nlat
   y(j) = j
 enddo

 Time = set_date(2,1,1,0,0,0)

 allocate(sst(is:ie,js:je), ice(is:ie,js:je))
 sst = 0
 ice = 0

 id_x  = diag_axis_init('x',  x,  'point_E', 'x', long_name='point_E', Domain2=Domain)
 id_y  = diag_axis_init('y',  y,  'point_N', 'y', long_name='point_N', Domain2=Domain)

 Time = Time + set_time(0,1)

 id_lon = register_static_field('test_data_override_mod', 'lon', (/id_x,id_y/), 'longitude', 'Degrees')
 id_lat = register_static_field('test_data_override_mod', 'lat', (/id_x,id_y/), 'longitude', 'Degrees')
 id_sst = register_diag_field  ('test_data_override_mod', 'sst', (/id_x,id_y/), Time, 'SST', 'K')
 id_ice = register_diag_field  ('test_data_override_mod', 'ice', (/id_x,id_y/), Time, 'ICE', ' ')
 used = send_data(id_lon, lon, Time)
 used = send_data(id_lat, lat, Time)

 sst = 0.
 ice = 0.

! get number of threads

nx_dom = ie - is + 1
ny_dom = je - js + 1
if( mod( nx_dom, window(1) ) .NE. 0 ) call error_mesg('test_data_override', &
        "nx_dom is not divisible by window(1)", FATAL)
if( mod( ny_dom, window(2) ) .NE. 0 ) call error_mesg('test_data_override', &
        "ny_dom is not divisible by window(2)", FATAL)

nwindows = window(1)*window(2)
!$ call omp_set_num_threads(nthreads)
!$ base_cpu = get_cpu_affinity()
!$OMP PARALLEL
!$ call set_cpu_affinity( base_cpu + omp_get_thread_num() )
!$OMP END PARALLEL

nx_win = nx_dom/window(1)
ny_win = ny_dom/window(2)
allocate(is_win(nwindows), js_win(nwindows))

i = 1
do jsw = js,je,ny_win
   do isw = is,ie,nx_win
      is_win(i) = isw
      js_win(i) = jsw
      i = i + 1
   enddo
enddo

allocate(ov_sst(nwindows), ov_ice(nwindows))
!$OMP parallel  do schedule(static) default(shared) private(isw, iew, jsw, jew)
do n = 1, nwindows
   isw = is_win(n)
   iew = isw + nx_win - 1
   jsw = js_win(n)
   jew = jsw + ny_win - 1
   call data_override('OCN','sst_obs',sst(isw:iew,jsw:jew),Time,override=ov_sst(n), &
                      is_in=isw-is+1, ie_in=iew-is+1, js_in=jsw-js+1, je_in=jew-js+1)
   call data_override('ICE', 'sic_obs', ice(isw:iew,jsw:jew), Time, override=ov_ice(n), &
                      is_in=isw-is+1, ie_in=iew-is+1, js_in=jsw-js+1, je_in=jew-js+1)
enddo

 if(ANY(.NOT. ov_sst) .or. ANY(.not.ov_ice)) then
   if(ANY(.NOT. ov_sst)) then
     message = 'override failed for ice'
   else if(ANY(.NOT. ov_ice)) then
     message = 'override failed for sst'
   else
     message = 'override failed for both sst and ice'
   endif
   call error_mesg('test_data_override', trim(message), FATAL)
 endif

 stdoutunit = stdout()
 write(stdoutunit,*)"===>NOTE from test_data_override: sst chksum = ", mpp_chksum(sst)
 write(stdoutunit,*)"===>NOTE from test_data_override: ice chksum = ", mpp_chksum(ice)


 if(id_sst > 0) used = send_data(id_sst, sst, Time)
 if(id_ice > 0) used = send_data(id_ice, ice, Time)

!-------------------------------------------------------------------------------------------------------
! What follows is a test of calendar conversion
 
!Time = set_date(1980,2,27,0,0,0)
!call print_time(Time)
!call data_override('OCN','sst_obs',sst,Time)
!if(id_sst > 0) used = send_data(id_sst, sst, Time)
 
!Time = set_date(1980,2,28,0,0,0)
!call print_time(Time)
!call data_override('OCN','sst_obs',sst,Time)
!if(id_sst > 0) used = send_data(id_sst, sst, Time)
 
!Time = set_date(1980,2,29,0,0,0)
!call print_time(Time)
!call data_override('OCN','sst_obs',sst,Time)
!if(id_sst > 0) used = send_data(id_sst, sst, Time)
 
!Time = set_date(1980,3,1,0,0,0)
!call print_time(Time)
!call data_override('OCN','sst_obs',sst,Time)
!if(id_sst > 0) used = send_data(id_sst, sst, Time)
 
!Time = set_date(1980,3,2,0,0,0)
!call print_time(Time)
!call data_override('OCN','sst_obs',sst,Time)
!if(id_sst > 0) used = send_data(id_sst, sst, Time)
!-------------------------------------------------------------------------------------------------------

 call diag_manager_end(Time)
 call fms_io_exit
 call fms_end

 contains
!=================================================================================================================================
 subroutine get_grid
   real, allocatable, dimension(:,:,:) :: lon_vert_glo, lat_vert_glo
   real, allocatable, dimension(:,:)   :: lon_global, lat_global
   integer, dimension(4)  :: siz
   character(len=128) :: message


   if(field_exist(grid_file, 'x_T')) then
      call field_size(grid_file, 'x_T', siz)
      if(siz(1) /= nlon .or. siz(2) /= nlat) then
         write(message,'(a,2i4)') 'x_T is wrong shape. shape(x_T)=',siz(1:2)
         call error_mesg('test_data_override', trim(message), FATAL)
      endif
      allocate(lon_vert_glo(nlon,nlat,4), lat_vert_glo(nlon,nlat,4) )
      allocate(lon_global  (nlon,nlat  ), lat_global  (nlon,nlat  ) )
      call read_data(trim(grid_file), 'x_vert_T', lon_vert_glo, no_domain=.true.)
      call read_data(trim(grid_file), 'y_vert_T', lat_vert_glo, no_domain=.true.)
      lon_global(:,:)  = (lon_vert_glo(:,:,1) + lon_vert_glo(:,:,2) + lon_vert_glo(:,:,3) + lon_vert_glo(:,:,4))*0.25
      lat_global(:,:) =  (lat_vert_glo(:,:,1) + lat_vert_glo(:,:,2) + lat_vert_glo(:,:,3) + lat_vert_glo(:,:,4))*0.25
   else  if(field_exist(grid_file, "geolon_t" ) ) then
      call field_size(grid_file, 'geolon_vert_t', siz)
      if(siz(1) /= nlon+1 .or. siz(2) /= nlat+1) then
         write(message,'(a,2i4)') 'geolon_vert_t is wrong shape. shape(geolon_vert_t)=',siz(1:2)
         call error_mesg('test_data_override', trim(message), FATAL)
      endif
      allocate(lon_vert_glo(nlon+1,nlat+1,1), lat_vert_glo(nlon+1,nlat+1,1))
      allocate(lon_global  (nlon,  nlat    ), lat_global  (nlon,  nlat    ))
      call read_data(trim(grid_file), 'geolon_vert_t', lon_vert_glo, no_domain=.true.)
      call read_data(trim(grid_file), 'geolat_vert_t', lat_vert_glo, no_domain=.true.)

      do i = 1, nlon
         do j = 1, nlat
            lon_global(i,j) = (lon_vert_glo(i,j,1) + lon_vert_glo(i+1,j,1) + &
                 lon_vert_glo(i+1,j+1,1) + lon_vert_glo(i,j+1,1))*0.25
            lat_global(i,j) = (lat_vert_glo(i,j,1) + lat_vert_glo(i+1,j,1) + &
                 lat_vert_glo(i+1,j+1,1) + lat_vert_glo(i,j+1,1))*0.25
         enddo
      enddo
   else if( field_exist(grid_file, "ocn_mosaic_file") ) then ! reading from mosaic file
      call field_size(tile_file, 'area', siz)
      if(siz(1) /= nlon*2 .or. siz(2) /= nlat*2) then
         write(message,'(a,2i4)') 'area is wrong shape. shape(area)=',siz(1:2)
         call error_mesg('test_data_override', trim(message), FATAL)
      endif
      allocate(lon_vert_glo(siz(1)+1,siz(2)+1,1), lat_vert_glo(siz(1)+1,siz(2)+1,1))
      allocate(lon_global  (nlon,  nlat    ), lat_global  (nlon,  nlat    ))
      call read_data( tile_file, 'x', lon_vert_glo, no_domain=.true.)
      call read_data( tile_file, 'y', lat_vert_glo, no_domain=.true.)  
      do j = 1, nlat
         do i = 1, nlon
            lon_global(i,j) = lon_vert_glo(i*2,j*2,1)
            lat_global(i,j) = lat_vert_glo(i*2,j*2,1)
         end do
      end do
   end if

  allocate(lon(is:ie,js:je), lat(is:ie,js:je))
  lon = lon_global(is:ie,js:je)
  lat = lat_global(is:ie,js:je)

  deallocate(lon_vert_glo)
  deallocate(lat_vert_glo)
  deallocate(lon_global)
  deallocate(lat_global)

 end subroutine get_grid
!=================================================================================================================================
 end program test
#endif

program grid_generator
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">Z. Liang </CONTACT>
  ! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">S. M. Griffies</REVIEWER>

  !<OVERVIEW>
  !  Generate horizontal grid for atmosphere or land model. 
  !  The grid is either bgrid or spectral grid.
  !</OVERVIEW>

  use fms_mod,         only : check_nml_error, open_namelist_file, close_file, stdout
  use fms_mod,         only : write_version_number, fms_init, fms_end, file_exist
  use mpp_mod,         only : mpp_pe, mpp_root_pe, mpp_error, FATAL
  use mpp_io_mod,      only : mpp_open, MPP_OVERWR,MPP_NETCDF, MPP_SINGLE, axistype
  use atmos_grid_mod,  only : generate_atmos_grid, atmos_grid_init, atmos_grid_end
  use atmos_grid_mod,  only : write_atmos_grid_meta, write_atmos_grid_data, atmos_grid_type
  use constants_mod,   only : constants_init

  implicit none

  character(len=128), parameter :: version= '$Id: atmos_grid_generator.f90,v 10.0 2003/10/24 22:01:43 fms Exp $'
  character(len=128), parameter :: tagname='$Name: tikal $'

  type(atmos_grid_type) :: Hgrid  
  integer               :: unit   ! output_file io unit
  !--- namelist interface
  character(len=128) :: output_file = "atmos_grid.nc"
  !
  !<NAMELIST NAME="atmos_grid_generator_nml">
  !<DATA NAME="output_file" TYPE="character(len=128)">
  !  name of grid file to be created. Default value is "atmos_grid.nc".
  !</DATA>
  !</NAMELIST>
  namelist / atmos_grid_generator_nml / output_file
  integer :: io, ierr

  !---------------------------------------------------------------------------

  call fms_init()
  call constants_init()

  !--- read namelist information ---------------------------------------
  if (file_exist('input.nml')) then
     unit = open_namelist_file ( )
     ierr=1
     do while (ierr /= 0)
        read  (unit, nml=atmos_grid_generator_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'atmos_grid_generator_nml')  ! also initializes nml error codes
     enddo
10   call close_file (unit)
  else
     call mpp_error(FATAL,'atmos_grid_generator: file input.nml does not exist')
  endif
  !--- write version info and namelist to logfile ----------------------
  write (stdout(), nml=atmos_grid_generator_nml)
  call write_version_number(version, tagname)

  !--- generate data ---------------------------------------------------
  call atmos_grid_init
  call generate_atmos_grid(Hgrid)

  !--- write out data-----------------------------------------------------

  if(mpp_pe() == mpp_root_pe()) then
     call mpp_open(unit,trim(output_file),MPP_OVERWR,MPP_NETCDF, &
          threading=MPP_SINGLE,  fileset=MPP_SINGLE)
     call write_atmos_grid_meta(unit, Hgrid)
     call write_atmos_grid_data(unit, Hgrid)
  endif

  !--- release the memory
  call atmos_grid_end(Hgrid)
  call fms_end()

end program grid_generator

module atmosphere_mod

use               mpp_mod, only: mpp_clock_id, mpp_clock_begin, mpp_clock_end, MPP_CLOCK_SYNC

use               fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, write_version_number, set_domain, &
                                 stdlog, close_file, open_namelist_file, check_nml_error, file_exist, field_size, &
                                 read_data, write_data

use    physics_driver_mod, only: do_moist_in_phys_up

use     field_manager_mod, only: MODEL_ATMOS

use    tracer_manager_mod, only: get_number_tracers, get_tracer_index

use  spectral_physics_mod, only: spectral_physics_init, spectral_physics_down, spectral_physics_up, &
                                 spectral_physics_end, surf_diff_type, spectral_physics_moist

use         constants_mod, only: grav

use        transforms_mod, only: trans_grid_to_spherical, trans_spherical_to_grid, get_deg_lon, get_deg_lat, &
                                 get_wts_lat, get_grid_boundaries, compute_ucos_vcos, divide_by_cos, get_lon_max, &
                                 get_lat_max, get_grid_domain, grid_domain

use  press_and_geopot_mod, only: pressure_variables, compute_pressures_and_heights, compute_z_bot

use      time_manager_mod, only: time_type, set_time, get_time, operator(+), operator(<), operator(-)

use spectral_dynamics_mod, only: spectral_dynamics_init, spectral_dynamics, spectral_dynamics_end, get_num_levels, &
                                 complete_robert_filter, complete_update_of_future, &
                                 get_axis_id, spectral_diagnostics, get_initial_fields

use       mpp_domains_mod, only: domain2d

use       tracer_type_mod, only: tracer_type

implicit none
private

character(len=128), parameter :: version = &
'$Id: atmosphere.F90,v 17.0 2009/07/21 03:00:28 fms Exp $'

character(len=128), parameter :: tagname = &
'$Name: tikal $'

public :: atmosphere_init, atmosphere_down, atmosphere_up, atmosphere_end, atmosphere_domain
public :: atmosphere_resolution, atmosphere_boundary, get_bottom_mass, get_bottom_wind, get_atmosphere_axes
public :: surf_diff_type, atmosphere_restart
integer :: seconds, days, num_tracers, num_levels, nhum
logical :: dry_model

integer, parameter :: num_time_levels=2
integer :: phyclock, dynclock

real, allocatable, dimension(:,:,:) :: p_half, p_full, z_half, z_full, wg_full
type(tracer_type), allocatable, dimension(:) :: tracer_attributes
real,    allocatable, dimension(:,:,:,:,:) :: grid_tracers
real,    allocatable, dimension(:,:,:    ) :: psg
real,    allocatable, dimension(:,:,:,:  ) :: ug, vg, tg

real, allocatable, dimension(:,:    ) :: dt_psg, z_bot
real, allocatable, dimension(:,:,:  ) :: dt_ug, dt_vg, dt_tg
real, allocatable, dimension(:,:,:,:) :: dt_tracers

! dt_real is the atmospheric time step, converted to a real number.
! delta_t is passed to physics. It is twice dt_real, except for
! the first time step of a cold start, when it equals dt_real.
real :: delta_t, dt_real

integer :: is, ie, js, je
integer :: previous, current, future
logical :: module_is_initialized=.false., atmos_domain_is_computed=.false.

type(time_type) :: Time_step, Time_prev, Time_next

logical :: do_mcm_moist_processes = .false.

namelist / atmosphere_nml / do_mcm_moist_processes

!------------------------------------------------------------------------------------------------

contains

!####################################################################################################################

subroutine atmosphere_init(Time_init, Time, Time_step_in, Surf_diff)

type(time_type),      intent(in)    :: Time_init, Time, Time_step_in
type(surf_diff_type), intent(inout) :: Surf_diff

integer :: ierr, io, unit, lon_max, lat_max, ntr, nt
integer, dimension(4) :: siz
character(len=64) :: file, tr_name
character(len=4) :: ch1,ch2,ch3,ch4

if(module_is_initialized) return

dynclock = mpp_clock_id('Dynamics', flags=MPP_CLOCK_SYNC)
phyclock = mpp_clock_id('Physics',  flags=MPP_CLOCK_SYNC)

unit = open_namelist_file()
ierr=1
do while (ierr /= 0)
  read(unit, nml=atmosphere_nml, iostat=io, end=20)
  ierr = check_nml_error (io, 'atmosphere_nml')
  enddo
20 call close_file (unit)

call write_version_number(version, tagname)
if(mpp_pe() == mpp_root_pe()) write (stdlog(), nml=atmosphere_nml)
!-----------------------------------------------------------------------------------------

!  because the time step is used in different ways,
!  it must exist as a real and time_type variable

call get_time(Time_step_in, seconds, days)
dt_real   = float(86400*days + seconds)
Time_step = Time_step_in

call get_number_tracers(MODEL_ATMOS, num_prog=num_tracers)
allocate (tracer_attributes(num_tracers))

call spectral_dynamics_init(Time, Time_step, tracer_attributes, dry_model, nhum)
atmos_domain_is_computed = .true.
call get_grid_domain(is, ie, js, je)
call get_num_levels(num_levels)

allocate (p_half       (is:ie, js:je, num_levels+1))
allocate (z_half       (is:ie, js:je, num_levels+1))
allocate (p_full       (is:ie, js:je, num_levels))
allocate (z_full       (is:ie, js:je, num_levels))
allocate (wg_full      (is:ie, js:je, num_levels))
allocate (psg          (is:ie, js:je, num_time_levels))
allocate (ug           (is:ie, js:je, num_levels, num_time_levels))
allocate (vg           (is:ie, js:je, num_levels, num_time_levels))
allocate (tg           (is:ie, js:je, num_levels, num_time_levels))
allocate (grid_tracers (is:ie, js:je, num_levels, num_time_levels, num_tracers ))
allocate (dt_psg       (is:ie, js:je))
allocate (dt_ug        (is:ie, js:je, num_levels))
allocate (dt_vg        (is:ie, js:je, num_levels))
allocate (dt_tg        (is:ie, js:je, num_levels))
allocate (dt_tracers   (is:ie, js:je, num_levels, num_tracers ))
allocate (z_bot        (is:ie, js:je))

p_half=0.; z_half=0.; p_full=0.; z_full=0.; wg_full=0.
psg=0.; ug=0.; vg=0.; tg=0.; grid_tracers=0.
dt_psg=0.; dt_ug=0.; dt_vg=0.; dt_tg=0.; dt_tracers=0.

file = 'INPUT/atmosphere.res.nc'
if(file_exist(trim(file))) then
  call get_lon_max(lon_max)
  call get_lat_max(lat_max)
  call field_size(trim(file), 'ug', siz)
  if(lon_max /= siz(1) .or. lat_max /= siz(2)) then
    write(ch1,'(i4)') siz(1)
    write(ch2,'(i4)') siz(2)
    write(ch3,'(i4)') lon_max
    write(ch4,'(i4)') lat_max
    call error_mesg('atmosphere_init','Resolution of restart data does not match resolution specified on namelist.'// &
    ' Restart data: lon_max='//ch1//', lat_max='//ch2//'  Namelist: lon_max='//ch3//', lat_max='//ch4, FATAL)
  endif
  call read_data(trim(file), 'previous', previous, no_domain=.true.)
  call read_data(trim(file), 'current',  current,  no_domain=.true.)
  do nt=1,num_time_levels
    call read_data(trim(file), 'ug',   ug(:,:,:,nt), grid_domain, timelevel=nt)
    call read_data(trim(file), 'vg',   vg(:,:,:,nt), grid_domain, timelevel=nt)
    call read_data(trim(file), 'tg',   tg(:,:,:,nt), grid_domain, timelevel=nt)
    call read_data(trim(file), 'psg', psg(:,:,  nt), grid_domain, timelevel=nt)
    do ntr = 1,num_tracers
      tr_name = trim(tracer_attributes(ntr)%name)
      call read_data(trim(file), trim(tr_name), grid_tracers(:,:,:,nt,ntr), grid_domain, timelevel=nt)      
    enddo ! end loop over tracers
  enddo ! end loop over time levels
  call read_data(trim(file), 'wg_full', wg_full, grid_domain)
else if(file_exist('INPUT/atmosphere.res')) then
  call error_mesg('atmosphere_init', &
                  'Binary restart file, INPUT/atmosphere.res, is not supported by this version of atmosphere.f90',FATAL)
else
  previous = 1; current = 1
  call get_initial_fields(ug(:,:,:,1), vg(:,:,:,1), tg(:,:,:,1), psg(:,:,1), grid_tracers(:,:,:,1,:))
endif

call spectral_physics_init(Time, get_axis_id(), Surf_diff, nhum, p_half, do_mcm_moist_processes)

if(dry_model) then
  call compute_pressures_and_heights(tg(:,:,:,current), psg(:,:,current), z_full, z_half, p_full, p_half)
else
  call compute_pressures_and_heights( &
       tg(:,:,:,current), psg(:,:,current), z_full, z_half, p_full, p_half, grid_tracers(:,:,:,current,nhum))
endif

call compute_z_bot(psg(:,:,current), tg(:,:,num_levels,current), z_bot, grid_tracers(:,:,num_levels,current,nhum))

module_is_initialized = .true.

return
end subroutine atmosphere_init
!#################################################################################################################################

subroutine atmosphere_down(Time, frac_land, t_surf, albedo,                                              &
                      albedo_vis_dir, albedo_nir_dir, albedo_vis_dif, albedo_nir_dif,                    &
                      rough_mom, u_star, b_star, q_star, dtau_du, dtau_dv, tau_x, tau_y,                 &
                      gust, coszen, flux_sw, flux_sw_dir, flux_sw_dif, flux_sw_down_vis_dir,             &
                      flux_sw_down_vis_dif, flux_sw_down_total_dir, flux_sw_down_total_dif, flux_sw_vis, &
                      flux_sw_vis_dir, flux_sw_vis_dif, flux_lw, Surf_diff )

type(time_type),      intent(in) :: Time
real,                 intent(in),    dimension(:,:) :: frac_land, t_surf, albedo
real,                 intent(in),    dimension(:,:) :: albedo_vis_dir, albedo_nir_dir, albedo_vis_dif, albedo_nir_dif 
real,                 intent(in),    dimension(:,:) :: rough_mom, u_star, b_star, q_star, dtau_du, dtau_dv
real,                 intent(inout), dimension(:,:) :: tau_x, tau_y
real,                 intent(out),   dimension(:,:) :: flux_sw, flux_sw_dir, flux_sw_dif, flux_sw_down_vis_dir
real,                 intent(out),   dimension(:,:) :: flux_sw_down_vis_dif, flux_sw_down_total_dir, flux_sw_down_total_dif
real,                 intent(out),   dimension(:,:) :: flux_sw_vis, flux_sw_vis_dir, flux_sw_vis_dif, flux_lw, coszen, gust
type(surf_diff_type), intent(inout)                 :: Surf_diff

if(.not.module_is_initialized) then
  call error_mesg('atmosphere_down','atmosphere module has not been initialized.', FATAL)
endif

dt_psg = 0.
dt_ug  = 0.
dt_vg  = 0.
dt_tg  = 0.
dt_tracers = 0.

if(current == previous) then
  delta_t = dt_real
  Time_prev = Time
else
  delta_t = 2*dt_real
  Time_prev = Time - Time_step
endif
Time_next = Time + Time_step

call mpp_clock_begin(phyclock)
call spectral_physics_down(Time_prev, Time, Time_next, previous, current, p_half, p_full, z_half, z_full, psg,      &
                        ug, vg, tg, grid_tracers, frac_land, rough_mom, albedo, t_surf, u_star, b_star, q_star,     &
                        dtau_du, dtau_dv, tau_x, tau_y, albedo_vis_dir, albedo_nir_dir, albedo_vis_dif, albedo_nir_dif, &
                        dt_ug, dt_vg, dt_tg, dt_tracers, flux_sw, flux_sw_dir, flux_sw_dif,                         &
                        flux_sw_down_vis_dir, flux_sw_down_vis_dif, flux_sw_down_total_dir, flux_sw_down_total_dif, &
                        flux_sw_vis, flux_sw_vis_dir, flux_sw_vis_dif, flux_lw, coszen,gust, Surf_diff)
call mpp_clock_end(phyclock)

return
end subroutine atmosphere_down
!#################################################################################################################################

subroutine atmosphere_up(Time, frac_land, Surf_diff, lprec, fprec, gust)

type(time_type),      intent(in)                          :: Time
real,                 intent(in),  dimension(is:ie,js:je) :: frac_land
type(surf_diff_type), intent(inout)                       :: Surf_diff
real,                 intent(out), dimension(is:ie,js:je) :: lprec, fprec, gust

real, dimension(is:ie,js:je,1:num_levels+1) :: ln_p_half
real, dimension(is:ie,js:je,1:num_levels  ) :: ln_p_full

if(.not.module_is_initialized) then
  call error_mesg('atmosphere_up','atmosphere module has not been initialized.', FATAL)
endif

call mpp_clock_begin(phyclock)
call spectral_physics_up(Time_prev, Time, Time_next, previous, current, p_half, p_full, z_half, z_full, wg_full, ug, vg, tg, &
                         grid_tracers, frac_land, dt_ug, dt_vg, dt_tg, dt_tracers, Surf_diff, lprec, fprec, gust)
call mpp_clock_end(phyclock)

if(previous == current) then
  future = num_time_levels + 1 - current
else
  future = previous
endif

call mpp_clock_begin(dynclock)
call spectral_dynamics(Time, psg(:,:,future), ug(:,:,:,future), vg(:,:,:,future), &
                       tg(:,:,:,future), tracer_attributes, grid_tracers(:,:,:,:,:), future, &
                       dt_psg, dt_ug, dt_vg, dt_tg, dt_tracers, wg_full, p_full, p_half, z_full)
call mpp_clock_end(dynclock)

if(do_moist_in_phys_up()) then
  if ( do_mcm_moist_processes ) then
    call error_mesg('atmosphere_up','do_mcm_moist_processes cannot be .true. when moist_processes'// &
                    ' is called by physics_driver_up', FATAL)
  endif
else
  call pressure_variables(p_half, ln_p_half, p_full, ln_p_full, psg(:,:,future))
  call spectral_physics_moist(Time_next, delta_t, frac_land, p_half, p_full, z_half, z_full, wg_full, &
                              tg(:,:,:,future), grid_tracers(:,:,:,future,nhum), ug(:,:,:,future), vg(:,:,:,future), &
                              grid_tracers(:,:,:,future,:), lprec, fprec, gust)
  call complete_update_of_future(psg(:,:,future), ug(:,:,:,future), vg(:,:,:,future), tg(:,:,:,future), &
                              tracer_attributes, grid_tracers(:,:,:,future,:))
endif
call complete_robert_filter(tracer_attributes)

call spectral_diagnostics(Time_next, psg(:,:,future), ug(:,:,:,future), vg(:,:,:,future), &
                          tg(:,:,:,future), wg_full, grid_tracers(:,:,:,:,:), future)

previous = current
current  = future

call compute_pressures_and_heights( &
            tg(:,:,:,current), psg(:,:,current), z_full, z_half, p_full, p_half, grid_tracers(:,:,:,current,nhum))
call compute_z_bot(psg(:,:,current), tg(:,:,num_levels,current), z_bot, grid_tracers(:,:,num_levels,current,nhum))

return
end subroutine atmosphere_up
!####################################################################################################################

subroutine get_bottom_mass (t_bot, tr_bot, p_bot, z_bot_out, p_surf)

real, intent(out), dimension(:,:) :: t_bot, p_bot, z_bot_out, p_surf
real, intent(out), dimension(:,:,:) :: tr_bot

if(.not.module_is_initialized) then
  call error_mesg('get_bottom_mass','atmosphere module has not been initialized.', FATAL)
endif

t_bot     = tg(:,:,num_levels, previous)
tr_bot    = grid_tracers(:,:,num_levels, previous,:)
p_bot     = p_full(:,:,num_levels)
p_surf    = psg(:,:,previous)
z_bot_out = z_bot

return
end subroutine get_bottom_mass
!####################################################################################################################

subroutine get_bottom_wind (u_bot, v_bot)

real, intent(out), dimension(:,:) :: u_bot, v_bot

if(.not.module_is_initialized) then
  call error_mesg('get_bottom_wind','atmosphere module has not been initialized.', FATAL)
endif

u_bot = ug(:,:,num_levels, previous)
v_bot = vg(:,:,num_levels, previous)

return
end subroutine get_bottom_wind
!####################################################################################################################

subroutine atmosphere_resolution(num_lon_out, num_lat_out, global)

integer, intent(out)          :: num_lon_out, num_lat_out
logical, intent(in), optional :: global
logical :: global_tmp

if(.not.module_is_initialized) then
  call error_mesg('atmosphere_resolution','atmosphere module has not been initialized.', FATAL)
endif

if (present(global)) then
  global_tmp = global
else
  global_tmp = .false.
endif

if(global_tmp) then
  call get_lon_max(num_lon_out)
  call get_lat_max(num_lat_out)
else
  num_lon_out = ie-is+1
  num_lat_out = je-js+1
endif

return
end subroutine atmosphere_resolution
!####################################################################################################################

subroutine get_atmosphere_axes(axes_out)
integer, intent(out), dimension(:) :: axes_out

if(.not.module_is_initialized) then
  call error_mesg('get_atmosphere_axes','atmosphere module has not been initialized.', FATAL)
endif

axes_out = get_axis_id()

return
end subroutine get_atmosphere_axes
!####################################################################################################################

subroutine atmosphere_boundary(lon_boundaries, lat_boundaries, global)

real,    intent(out), dimension(:) :: lon_boundaries, lat_boundaries
logical, intent(in),  optional     :: global

logical :: global_tmp

if(.not.module_is_initialized) then
  call error_mesg('atmosphere_boundary','atmosphere module has not been initialized.', FATAL)
endif

if(present(global)) then
  global_tmp = global
else
  global_tmp = .false.
endif
call get_grid_boundaries(lon_boundaries, lat_boundaries, global_tmp)

return
end subroutine atmosphere_boundary
!####################################################################################################################
subroutine atmosphere_domain(domain)
type (domain2d), intent(out) :: domain

if(.not.atmos_domain_is_computed) then
  call error_mesg('atmosphere_domain','spec_mpp has not been initialized.', FATAL)
endif

domain = grid_domain

end subroutine atmosphere_domain
!####################################################################################################################

subroutine atmosphere_end(Time)
type(time_type), intent(in) :: Time
integer :: ntr, nt
character(len=64) :: file, tr_name

if(.not.module_is_initialized) return

file='RESTART/atmosphere.res'
call write_data(trim(file), 'previous', previous, no_domain=.true.)
call write_data(trim(file), 'current',  current,  no_domain=.true.)
do nt=1,num_time_levels
  call write_data(trim(file), 'ug',   ug(:,:,:,nt), grid_domain)
  call write_data(trim(file), 'vg',   vg(:,:,:,nt), grid_domain)
  call write_data(trim(file), 'tg',   tg(:,:,:,nt), grid_domain)
  call write_data(trim(file), 'psg', psg(:,:,  nt), grid_domain)
  do ntr = 1,num_tracers
    tr_name = trim(tracer_attributes(ntr)%name)
    call write_data(trim(file), tr_name, grid_tracers(:,:,:,nt,ntr), grid_domain)
  enddo
enddo
call write_data(trim(file), 'wg_full', wg_full, grid_domain)

deallocate(dt_psg, dt_ug, dt_vg, dt_tg, dt_tracers)

call set_domain(grid_domain)
call spectral_physics_end(Time)
call spectral_dynamics_end(tracer_attributes, Time)

module_is_initialized = .false.

return
end subroutine atmosphere_end

  !#######################################################################
  ! <SUBROUTINE NAME="atmosphere_restart">
  ! <DESCRIPTION>
  !  dummy routine.
  ! </DESCRIPTION>
  subroutine atmosphere_restart(timestamp)
    character(len=*),  intent(in) :: timestamp

    call error_mesg ('atmosphere_restart in atmosphere_mod', &
                     'intermediate restart capability is not implemented for this model', FATAL)

  end subroutine atmosphere_restart
  ! </SUBROUTINE>


!####################################################################################################################

end module atmosphere_mod

program idealized_bc_driver
  !
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  ! This file is a part of MOM.                                                                 
  !                                                                      
  ! MOM is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  !
  !<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">Z. Liang </CONTACT>
  !<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies </REVIEWER>
  !
  !<OVERVIEW>
  ! Driver for ideal surface boundary conditions
  !</OVERVIEW>
  !
  !<DESCRIPTION>
  ! The program drives the idealized boundary condition generation routines. 
  ! </DESCRIPTION>

  use fms_mod,          only : fms_init, fms_end
  use idealized_bc_mod, only : idealized_bc_init, write_idealized_bc_data, idealized_bc_end
  use constants_mod,    only : constants_init
  use mpp_mod,          only : mpp_pe, mpp_root_pe

  implicit none

  integer :: error

  call fms_init
  call constants_init

  call idealized_bc_init
  if(mpp_pe() == mpp_root_pe()) call write_idealized_bc_data
  call idealized_bc_end

  call fms_end

end program idealized_bc_driver

module bgrid_polar_filter_mod
!-----------------------------------------------------------------------

use bgrid_horiz_mod, only: horiz_grid_type, bgrid_type, &
                           TGRID, VGRID

use         fft_mod, only: fft_init, fft_grid_to_fourier,  &
                                     fft_fourier_to_grid

use         fms_mod, only: error_mesg, FATAL,    &
                           write_version_number, &
                           mpp_npes, mpp_pe, mpp_root_pe, &
                           mpp_clock_id, mpp_clock_begin, &
                           mpp_clock_end, MPP_CLOCK_SYNC, &
                           CLOCK_ROUTINE

use mpp_domains_mod, only: domain2d, domain1d,         &
                           mpp_redistribute,           &
                           mpp_define_layout,          &
                           mpp_define_domains,         &
                           mpp_get_domain_components,  &
                           mpp_get_layout,             &
                           mpp_get_global_domain,      &
                           mpp_get_data_domain,        &
                           mpp_get_compute_domains,    &
                           CYCLIC_GLOBAL_DOMAIN

implicit none
private

 public :: polar_filter, polar_filter_wind, polar_filter_init
 public :: TGRID, VGRID

 interface polar_filter
    module procedure polar_filter_3d, polar_filter_two_3d, &
                     polar_filter_2d, polar_filter_two_2d
 end interface polar_filter

 interface polar_filter_wind
    module procedure polar_filter_wind_3d, polar_filter_wind_2d
 end interface polar_filter_wind

!--------------------------------
! derived types
 public :: pfilt_domain_type, pfilt_index_type, pfilt_control_type

 type pfilt_domain_type
    private
    type (domain2d) :: Domain
    integer :: isd, ied, jsd, jed
 end type pfilt_domain_type

 type pfilt_index_type
    private
    integer    :: leng, lenc
    integer    :: is, ie, js, je
    integer    :: isd, ied, jsd, jed
    integer    :: weight
    logical    :: sigma, rowend
    real       :: cph0
    real,    pointer :: sklm(:) =>NULL(), cph(:) =>NULL()
    integer ,pointer :: jpf(:) =>NULL()
    type (pfilt_domain_type) :: Local, Zonal, Local2, Zonal2
 end type pfilt_index_type

 type pfilt_control_type
    private
    integer    :: nlpf, nlev
    integer    :: isize, jsize
    real, pointer, dimension(:) :: slm =>NULL(), clm =>NULL()
    type (pfilt_index_type) :: Tmp, Vel
 end type pfilt_control_type
   
!--------------------------------
! version id info
 character(len=128) :: version='$Id: bgrid_polar_filter.F90,v 10.0 2003/10/24 22:00:19 fms Exp $'
 character(len=128) :: tagname='$Name: tikal $'
 logical :: do_log = .true.
!--------------------------------
! private data
 real   , allocatable :: xsum(:)
 integer, allocatable :: xknt(:)

! performance timing data
 integer :: id_pfiltr
 logical :: do_clock_init = .true.

contains

!#######################################################################
! public routines for polaring filtering
!#######################################################################

 subroutine polar_filter_3d ( Control, u, grid, mask )

!-----------------------------------------------------
!     Polar filter a single 3D field
!
! Control = control parameters for polar filter
! u       = 3D data
! grid    = grid identifier, use: TGRID, VGRID
! mask    = grid box mask for eta coordinate topography
!-------------------------------------------------------

 type(pfilt_control_type), intent(in)               :: Control
 real,    intent(inout), dimension(:,:,:)           :: u
 integer, intent(in)                                :: grid
 real,    intent(in),    dimension(:,:,:), optional :: mask

 ! error checks
   if (size(u,1) /= Control%isize .or. size(u,2) /= Control%jsize) &
   call error_mesg ('polar_filter_mod', 'incorrect horizontal dimension', FATAL)
   if (size(u,3) /= Control%nlev) &
   call error_mesg ('polar_filter_mod', 'incorrect number of levels', FATAL )

 ! select grid
   select case (grid)
     case (TGRID)
        call filter_field ( Control%Tmp, u, mask=mask )
     case (VGRID)
        call filter_field ( Control%Vel, u, mask=mask )
     case default
        call error_mesg ('polar_filter_mod', 'invalid grid argument', FATAL)
   end select

 end subroutine polar_filter_3d

!=======================================================================

 subroutine polar_filter_two_3d ( Control, u, v, grid, mask )

!-----------------------------------------------------
!   Polar filter two 3D fields on the same grid
!
! Control = control parameters for polar filter
! u, v    = 3D data field on the same grid
! grid    = grid identifier, use: TGRID, VGRID
! mask    = grid box mask for eta coordinate topography
!-------------------------------------------------------

 type(pfilt_control_type), intent(in)               :: Control
 real,    intent(inout), dimension(:,:,:)           :: u, v
 integer, intent(in)                                :: grid
 real,    intent(in),    dimension(:,:,:), optional :: mask

 ! error checks
   if (size(u,1) /= Control%isize .or. size(u,2) /= Control%jsize) &
   call error_mesg ('polar_filter_mod', 'incorrect horizontal dimension', FATAL)
   if (size(u,3) /= Control%nlev .or. size(v,3) /= Control%nlev) &
   call error_mesg ('polar_filter_mod', 'incorrect number of levels', FATAL )

 ! select grid
   select case (grid)
     case (TGRID)
        call filter_two_fields ( Control%Tmp, u, v, mask=mask )
     case (VGRID)
        call filter_two_fields ( Control%Vel, u, v, mask=mask )
     case default
        call error_mesg ('polar_filter_mod', 'invalid grid argument', FATAL)
   end select

 end subroutine polar_filter_two_3d

!=======================================================================

 subroutine polar_filter_wind_3d ( Control, u, v, mask )

!-----------------------------------------------------
!      Polar filter 3D momentum fields
!
! Control = control parameters for polar filter
! u, v    = 3D data field on the same grid
! mask    = grid box mask for eta coordinate topography
!
! NOTE: a polar stereographic transformation of the
!       wind components done when the filter is applied
!-------------------------------------------------------

 type(pfilt_control_type), intent(in)               :: Control
 real,    intent(inout), dimension(:,:,:)           :: u, v
 real,    intent(in),    dimension(:,:,:), optional :: mask

 ! error checks
   if (size(u,1) /= Control%isize .or. size(u,2) /= Control%jsize) &
   call error_mesg ('polar_filter_mod', 'incorrect horizontal dimension', FATAL)
   if (size(u,3) /= Control%nlev .or. size(v,3) /= Control%nlev) &
   call error_mesg ('polar_filter_mod', 'incorrect number of levels', FATAL )

   call filter_two_fields ( Control%Vel, u, v, &
                            slm=Control%slm, clm=Control%clm, mask=mask )

 end subroutine polar_filter_wind_3d

!#######################################################################
!=============== overloaded 2D interfaces ====================

 subroutine polar_filter_2d ( Control, u, grid, mask )

!-----------------------------------------------------
!     Polar filter a single 2D field
!
! Control = control parameters for polar filter
! u       = 2D data
! grid    = grid identifier, use: TGRID, VGRID
! mask    = grid box mask for eta coordinate topography
!-------------------------------------------------------

 type(pfilt_control_type), intent(in)             :: Control
 real,    intent(inout), dimension(:,:)           :: u
 integer, intent(in)                              :: grid
 real,    intent(in),    dimension(:,:), optional :: mask

 real, dimension(size(u,1),size(u,2),1) :: u3, m3

   u3(:,:,1) = u
   if (present(mask)) then
       m3(:,:,1) = mask
       call polar_filter_3d ( Control, u3, grid, mask=m3 )
   else
       call polar_filter_3d ( Control, u3, grid )
   endif
   u = u3(:,:,1)

 end subroutine polar_filter_2d

!=======================================================================

 subroutine polar_filter_two_2d ( Control, u, v, grid, mask )

!-----------------------------------------------------
!   Polar filter two 2D fields on the same grid
!
! Control = control parameters for polar filter
! u, v    = 2D data field on the same grid
! grid    = grid identifier, use: TGRID, VGRID
! mask    = grid box mask for eta coordinate topography
!-------------------------------------------------------

 type(pfilt_control_type), intent(in)             :: Control
 real,    intent(inout), dimension(:,:)           :: u, v
 integer, intent(in)                              :: grid
 real,    intent(in),    dimension(:,:), optional :: mask

 real, dimension(size(u,1),size(u,2),1) :: u3, v3, m3

   u3(:,:,1) = u
   v3(:,:,1) = v
   if (present(mask)) then
       m3(:,:,1) = mask
       call polar_filter_two_3d ( Control, u3, v3, grid, mask=m3 )
   else
       call polar_filter_two_3d ( Control, u3, v3, grid )
   endif
   u = u3(:,:,1)
   v = v3(:,:,1)

 end subroutine polar_filter_two_2d

!=======================================================================

 subroutine polar_filter_wind_2d ( Control, u, v, mask )

!-----------------------------------------------------
!      Polar filter 2D momentum fields
!
! Control = control parameters for polar filter
! u, v    = 2D data field on the same grid
! mask    = grid box mask for eta coordinate topography
!
! NOTE: a polar stereographic transformation of the
!       wind components done when the filter is applied
!-------------------------------------------------------

 type(pfilt_control_type), intent(in)             :: Control
 real,    intent(inout), dimension(:,:)           :: u, v
 real,    intent(in),    dimension(:,:), optional :: mask

 real, dimension(size(u,1),size(u,2),1) :: u3, v3, m3

 ! error checks
   if (size(u,1) /= Control%isize .or. size(u,2) /= Control%jsize) &
   call error_mesg ('polar_filter_mod', 'incorrect horizontal dimension', FATAL)

   u3(:,:,1) = u
   v3(:,:,1) = v
   if (present(mask)) then
       m3(:,:,1) = mask
       call filter_two_fields ( Control%Vel, u3, v3, &
                            slm=Control%slm, clm=Control%clm, mask=m3 )
   else
       call filter_two_fields ( Control%Vel, u3, v3, &
                            slm=Control%slm, clm=Control%clm )
   endif
   u = u3(:,:,1)
   v = v3(:,:,1)

 end subroutine polar_filter_wind_2d

!#######################################################################
! filter a single field

 subroutine filter_field ( Index, u, mask )

 type(pfilt_index_type), intent(in)     :: Index
 real, intent(inout), dimension(Index%isd:,Index%jsd:,:) :: u
 real, intent(in),    dimension(Index%isd:,Index%jsd:,:), &
                                                optional :: mask

 real, dimension( Index%Local%isd:Index%Local%ied, &
                  Index%Local%jsd:Index%Local%jed ) :: g, gm
 real, dimension( Index%Zonal%isd:Index%Zonal%ied, &
                  Index%Zonal%jsd:Index%Zonal%jed ) :: z, zm

 real,    dimension( Index%lenc, Index%Zonal%jsd:Index%Zonal%jed ) :: ss
 complex, dimension( Index%lenc, Index%Zonal%jsd:Index%Zonal%jed ) :: c

 integer :: i, j, k, n, nlev, is, ie, isg, ieg
 logical :: use_mask
 real    :: zm_min

  call mpp_clock_begin (id_pfiltr)

! scalar constants
  nlev = size(u,3)
  is  = Index%is;        ie  = Index%ie
  isg = Index%Zonal%isd; ieg = Index%Zonal%ied-1
  use_mask = .not.Index%sigma .and. present(mask)
  zm_min = 1.0

!--------------------------------------------
! reorder indexing i*k*j

     n = Index%Local%jsd - 1
  do j = Index%js, Index%je
  do k = 1, nlev
     if (Index%jpf(j) /= 0) then
        n = n + 1
        do i = is, ie
          g(i,n) = u(i,j,k)
        enddo
        ! add cosine latitude to end of rows
        if (Index%rowend) g(ie+1,n) = Index%cph(j)
        ! step-mountain mask
        if (use_mask) then
          do i = is, ie
            gm(i,n) = mask(i,j,k)
          enddo
        endif
     endif
  enddo
  enddo
!--------------------------------------------
! distribute the data across all processors
  call mpp_redistribute ( Index%Local%Domain, g, Index%Zonal%Domain, z )
! mask ?
  if (use_mask) then
    call mpp_redistribute ( Index%Local%Domain, gm, Index%Zonal%Domain, zm )
    zm_min = minval(zm(isg:ieg,:))
    if (zm_min < .01) call fill_missing (zm(isg:ieg,:), z(isg:ieg,:))
  endif

! compute filter response
  call set_filter_response ( Index, z(ieg+1,:), ss )
! transform to fourier coefficients
  c = fft_grid_to_fourier (z)
! filter
  c = c * ss
! transform back to grid spce
  z = fft_fourier_to_grid (c)
! restore zonal mean if mask used
  if (zm_min < .01) call fix_missing (zm(isg:ieg,:), z(isg:ieg,:))

! distribute the data back to original processor
  call mpp_redistribute ( Index%Zonal%Domain, z, Index%Local%Domain, g )

!--------------------------------------------
! place data back in original arrays

     n = Index%Local%jsd - 1
  do j = Index%js, Index%je
  do k = 1, nlev
     ! only replace filtered data
     if (Index%jpf(j) /= 0) then
        n = n + 1
        do i = is, ie
          u(i,j,k) = g(i,n)
        enddo
     endif
     ! apply mask for step-mountain coord
     if (use_mask) then
       do i = is, ie
         u(i,j,k) = u(i,j,k) * mask(i,j,k)
       enddo
     endif
  enddo
  enddo

  call mpp_clock_end (id_pfiltr)
!--------------------------------------------

end subroutine filter_field

!#######################################################################
! filter two fields on the same grid

 subroutine filter_two_fields ( Index, u, v, slm, clm, mask )

 type(pfilt_index_type), intent(in)     :: Index
 real, intent(inout), dimension(Index%isd:,Index%jsd:,:) :: u, v
 real, intent(in),    dimension(Index%isd:), optional    :: slm, clm
 real, intent(in),    dimension(Index%isd:,Index%jsd:,:), &
                                                optional :: mask

 real, dimension( Index%Local2%isd:Index%Local2%ied, &
                  Index%Local2%jsd:Index%Local2%jed ) :: g, gm
 real, dimension( Index%Zonal2%isd:Index%Zonal2%ied, &
                  Index%Zonal2%jsd:Index%Zonal2%jed ) :: z, zm

 real,    dimension( Index%lenc, Index%Zonal2%jsd:Index%Zonal2%jed ) :: ss
 complex, dimension( Index%lenc, Index%Zonal2%jsd:Index%Zonal2%jed ) :: c

 integer :: i, j, k, n1, n2, nlev, nfld, is, ie, isg, ieg
 logical :: vectors, use_mask
 real    :: zm_min

  call mpp_clock_begin (id_pfiltr)

! initialize scalars
  nlev = size(u,3)
  nfld = 2
  is  = Index%is;         ie  = Index%ie
  isg = Index%Zonal2%isd; ieg = Index%Zonal2%ied-1
  vectors = present(slm) .and. present(clm)
  use_mask = .not.Index%sigma .and. present(mask)
  zm_min = 1.0

!--------------------------------------------
! reorder indexing i*k*j
! add cosine latitude to end of rows

     n1 = Index%Local2%jsd - 2
  do j = Index%js, Index%je
  do k = 1, nlev
     if (Index%jpf(j) /= 0) then
        n1 = n1 + 2
        n2 = n1 + 1
        if (vectors) then
           ! convert u/v components using streographic projection
           select case (Index%jpf(j))
             case (-1) ! so.hemis.
               do i = is, ie
                 g(i,n1) = -u(i,j,k)*slm(i) + v(i,j,k)*clm(i)
                 g(i,n2) = +u(i,j,k)*clm(i) + v(i,j,k)*slm(i)
               enddo
             case (+1) ! no.hemis.
               do i = is, ie
                 g(i,n1) = -u(i,j,k)*slm(i) - v(i,j,k)*clm(i)
                 g(i,n2) = +u(i,j,k)*clm(i) - v(i,j,k)*slm(i)
               enddo
           end select
        else
           ! two distinct fields - no conversion necessary
           do i = is, ie
             g(i,n1) = u(i,j,k)
             g(i,n2) = v(i,j,k)
           enddo
        endif
        ! insert cosine latitude at end of global latitude rows
        if (Index%rowend) then
            g(ie+1,n1) = Index%cph(j)
            g(ie+1,n2) = Index%cph(j)
        endif
        ! step-mountain mask (need two copies)
        if (use_mask) then
            do i = is, ie
              gm(i,n1) = mask(i,j,k)
              gm(i,n2) = mask(i,j,k)
            enddo
        endif
     endif
  enddo
  enddo
!--------------------------------------------
! distribute the data across all processors
  call mpp_redistribute ( Index%Local2%Domain, g, Index%Zonal2%Domain, z )
! mask ?
  if (use_mask) then
    call mpp_redistribute ( Index%Local2%Domain, gm, Index%Zonal2%Domain, zm )
    zm_min = minval(zm(isg:ieg,:))
    if (zm_min < .01) call fill_missing (zm(isg:ieg,:), z(isg:ieg,:))
  endif

! compute filter response
  call set_filter_response ( Index, z(ieg+1,:), ss )
! transform to fourier coefficients
  c = fft_grid_to_fourier (z)
! filter
  c = c * ss
! transform back to grid spce
  z = fft_fourier_to_grid (c)
! restore zonal mean if mask used
  if (zm_min < .01) call fix_missing (zm(isg:ieg,:), z(isg:ieg,:))

! distribute the data back to original processor
  call mpp_redistribute ( Index%Zonal2%Domain, z, Index%Local2%Domain, g )

!--------------------------------------------
! place data back in original arrays

     n1 = Index%Local2%jsd - 2
  do j = Index%js, Index%je
  do k = 1, nlev
     if (Index%jpf(j) /= 0) then
        n1 = n1 + 2
        n2 = n1 + 1
        if (vectors) then
           ! convert stereographic projection back to u/v components
           select case (Index%jpf(j))
             case (-1) ! so. hemis.
               do i = is, ie
                 u(i,j,k) = -g(i,n1)*slm(i) + g(i,n2)*clm(i)
                 v(i,j,k) = +g(i,n1)*clm(i) + g(i,n2)*slm(i)
               enddo
             case (+1) ! no. hemis.
               do i = is, ie
                 u(i,j,k) = -g(i,n1)*slm(i) + g(i,n2)*clm(i)
                 v(i,j,k) = -g(i,n1)*clm(i) - g(i,n2)*slm(i)
               enddo
           end select
        else
           ! two distinct fields
           do i = is, ie
             u(i,j,k) = g(i,n1)
             v(i,j,k) = g(i,n2)
           enddo
        endif
     endif
     ! apply mask for step-mountain coord
     if (use_mask) then
       do i = is, ie
         u(i,j,k) = u(i,j,k) * mask(i,j,k)
         v(i,j,k) = v(i,j,k) * mask(i,j,k)
       enddo
     endif
  enddo
  enddo

  call mpp_clock_end (id_pfiltr)
!--------------------------------------------

end subroutine filter_two_fields

!#######################################################################
! computes standard filter response (after arakawa & lamb)

 subroutine set_filter_response ( Index, cph, ss )
 type(pfilt_index_type), intent(in)  :: Index
 real                  , intent(in)  :: cph (:)
 real                  , intent(out) :: ss (:,:)

 real, dimension(Index%lenc) :: cph0_sklm
 integer :: j, k

  ! longitude dependent values
    do k = 2, Index%lenc
      cph0_sklm (k) = Index%cph0 * Index%sklm(k)
    enddo   

  ! mean always one
    ss (1,:) = 1.0

  ! compute response function (range 0. to 1.)
    do j = 1, size(ss,2)
       do k = 2, Index%lenc
          ss (k,j) = max(0.0, min( 1.0, cph(j)/cph0_sklm(k) ))
       enddo   
    enddo   

 end subroutine set_filter_response

!#######################################################################
!======== routines for step-mountain coordinate =========
!#######################################################################

subroutine fill_missing ( mask, dat )
real, intent(in),    dimension(:,:) :: mask
real, intent(inout), dimension(:,:) :: dat
integer :: i, j, nlon, nlat

! computes zonal mean at points where mask /= 0
! interpolates values into points where mask = 0

  nlon = size(dat,1);  nlat = size(dat,2)
  allocate ( xknt(nlat), xsum(nlat) )
  xknt = 0; xsum = 0.

  do j = 1, nlat
    do i = 1, nlon
      if (mask(i,j) < .01) cycle
      xknt(j) = xknt(j) + 1
      xsum(j) = xsum(j) + dat(i,j)
    enddo
    if (xknt(j) == nlon .or. xknt(j) == 0) cycle
    call intrp ( mask(:,j), dat(:,j) )
   !where (mask(:,j)<.01) dat(:,j)=xsum(j)/real(xknt(j))
  enddo

end subroutine fill_missing

!=======================================================================

subroutine fix_missing ( mask, dat )
real, intent(in),    dimension(:,:) :: mask
real, intent(inout), dimension(:,:) :: dat
integer :: i, j, nlon, nlat
real :: avg, dif

! restores zonal mean in latitude rows with missing values

  nlon = size(dat,1);  nlat = size(dat,2)

  do j = 1, nlat
     if (xknt(j) == nlon .or. xknt(j) == 0) cycle
     avg = 0.
     do i = 1, nlon
        if (mask(i,j) < .01) cycle
        avg = avg + dat(i,j)
     enddo
     dif = (xsum(j)-avg)/real(xknt(j))
     do i = 1, nlon
        if (mask(i,j) < .01) cycle
        dat(i,j) = dat(i,j) + dif
     enddo
  enddo
  deallocate ( xknt, xsum )

end subroutine fix_missing

!=======================================================================

subroutine intrp ( mask, dat )
real, intent(in),    dimension(:) :: mask
real, intent(inout), dimension(:) :: dat

integer, dimension(size(dat,1)) :: m1, m2, mbas
real,    dimension(size(dat,1)) :: base, slop
integer :: nlon, last, nseg, i, m, n

!  fill in missing values by linear interpolating

  m1(:)=99999
  m2(:)=99999
  mbas(:)=99999
  base(:)=99999.
  slop(:)=99999.

  nlon = size(dat,1)
  last = -1
  nseg =  1

  do i = 1, nlon
     if (mask(i) < .01) then
         if (last == 1) then 
           m1(nseg) = i
           mbas(nseg) = i-1
           base(nseg) = dat(i-1)
         endif
         last = 0
     else
         if (last == 0) then
           m2(nseg) = i-1
           slop(nseg) = (dat(i)-base(nseg))/real(i-mbas(nseg))
           nseg = nseg+1
         endif
         last = 1
     endif
  enddo

  if ( m1(nseg) == 99999 .and. m2(nseg) == 99999) nseg = nseg-1
  if ( m1(1)    == 99999 .and. m2(nseg) == 99999) then
       m1(1) = 1
       m2(nseg) = nlon
       mbas(1) = mbas(nseg)-nlon
       base(1) = base(nseg)
       slop(1) = (dat(m2(1)+1)-base(1))/real(m2(1)+1-mbas(1))
       slop(nseg) = slop(1)
  endif
  if (m1(1) == 99999) then
      m1(1) = 1
      mbas(1) = 0
      base(1) = dat(nlon)
      slop(1) = (dat(m2(1)+1)-base(1))/real(m2(1)+1-mbas(1))
  endif
  if (m2(nseg) == 99999) then
      m2(nseg) = nlon
      slop(nseg) = (dat(1)-base(nseg))/real(nlon+1-mbas(nseg))
  endif

  do n = 1, nseg
  do m = m1(n), m2(n)
       dat(m) = base(n) + real(m-mbas(n))*slop(n)
  enddo
  enddo

end subroutine intrp

!#######################################################################
!   initialization routines
!#######################################################################
 
 subroutine polar_filter_init ( Control, Hgrid, nlev, reflat, weight, sigma, verbose )

!-----------------------------------------------------------------------
!  Hgrid  = horizontal grid constants
!  nlev   = number of vertical model levels
!             all input data must have this number of levels
!  reflat = reference latitude in degrees, default=60.,
!             poleward of this latitude the filter is applied
!  weight = weight to strengthen filter (not recommended)
!  sigma  = flag to improve optimization for sigma coordinate models
!             default=FALSE, set to TRUE for sigma models
!  verbose = not used?
!-----------------------------------------------------------------------

 type(pfilt_control_type), intent(inout)        :: Control
 type(horiz_grid_type),    intent(in)           :: Hgrid
 integer,                  intent(in)           :: nlev
 real,                     intent(in), optional :: reflat
 integer,                  intent(in), optional :: weight, verbose 
 logical,                  intent(in), optional :: sigma

 integer :: nlpf, i
 real    :: filter_lats
!-----------------------------------------------------------------------

 if (do_log) then
   call write_version_number(version, tagname)
   do_log = .false. 
 endif

  ! reference latitude
    filter_lats = 30.
    if (present(reflat)) then
         if ( reflat-epsilon(reflat) <= 90. .and. reflat >= 0. ) then
           filter_lats = 90. - reflat
         else    
           call error_mesg  ('polar_filter_init',      &
              'reflat must lie between 0 and 90.', FATAL)
        endif
    endif
  ! number of latitude rows of filtering per hemisphere
    nlpf = int(float(Hgrid%Tmp%jeg-Hgrid%Tmp%jsg+1)*filter_lats/180.)
    Control%nlpf = nlpf
    Control%nlev = nlev
  ! grid size (for error checking)
    Control%isize = Hgrid%isize
    Control%jsize = Hgrid%jsize

  ! Temp/Vel grid constants
    call set_index_type ( nlpf, nlev, Hgrid%dlm, Hgrid%dph, Hgrid%Tmp, &
                          Control%Tmp, weight, sigma )
    call set_index_type ( nlpf, nlev, Hgrid%dlm, Hgrid%dph, Hgrid%Vel, &
                          Control%Vel, weight, sigma )

  ! fourier transform initialization
    call fft_init (Hgrid%nlon)

  ! trig constants for converting u,v to polar stereographic
    allocate ( Control%slm(Control%Vel%isd:Control%Vel%ied), &
               Control%clm(Control%Vel%isd:Control%Vel%ied)  )
    do i = Control%Vel%isd, Control%Vel%ied
       Control%slm(i) = sin( Hgrid%Vel%tlm(i) )
       Control%clm(i) = cos( Hgrid%Vel%tlm(i) )
    enddo

  ! initialize performance clock
    if (do_clock_init) then
       id_pfiltr = mpp_clock_id ('BGRID: polar_filter (TOTAL)',  &
                        flags=MPP_CLOCK_SYNC, grain=CLOCK_ROUTINE)
       do_clock_init = .false.
    endif

end subroutine polar_filter_init
 
!=======================================================================

 subroutine set_index_type ( nlpf, nlev, dlm, dph, Grid, Index, weight, sigma )
 integer,                intent(in)  :: nlpf, nlev
 real,                   intent(in)  :: dlm, dph
 type(bgrid_type),       intent(in)  :: Grid
 type(pfilt_index_type), intent(inout) :: Index
 integer, optional,      intent(in)  :: weight
 logical, optional,      intent(in)  :: sigma

 integer :: leng, lenc, j, k
 real    :: hpi, rlat

 ! optional arguments
   Index%weight = 1;       if (present(weight)) Index%weight = weight
   Index%sigma = .false.;  if (present(sigma))  Index%sigma  = sigma

 ! east-most box in zonal row needs one more point
 ! this is used to store the latitude value
   Index % rowend = Grid%ie == Grid%ieg
 ! for full zonal rows
   leng = Grid%ieg - Grid%isg + 1
   lenc = leng/2+1
 
   Index % leng = leng
   Index % lenc = lenc

 ! copy indexing for this domain
   Index % is = Grid%is
   Index % ie = Grid%ie
   Index % js = Grid%js
   Index % je = Grid%je
   Index % isd = Grid%isd
   Index % ied = Grid%ied
   Index % jsd = Grid%jsd
   Index % jed = Grid%jed

 ! reference latitude (first lat w/o filtering)
   hpi = acos(0.0)
   rlat = hpi - (float(nlpf)+0.50)*dph
   Index % cph0 = cos(rlat)

   allocate ( Index%jpf(Index%js:Index%je), &
              Index%cph(Index%js:Index%je)  )
   do j = Index%js, Index%je
      Index%jpf(j) = 0   ! jpf non-zero for filtered rows
      if (j <= Grid%jsg+nlpf-1) Index%jpf(j) = -1
      if (j >= Grid%jeg-nlpf+1) Index%jpf(j) = +1
      Index%cph(j) = cos( Grid%tph(j) )
   enddo

 ! set trig constants for response function
   allocate ( Index%sklm(lenc) )
   do k = 2, lenc
      Index%sklm(k) = sin( 0.5*float(k-1)*dlm )
   enddo

 ! set domain types
   call pf_domain_init ( nlpf, nlev,  &
            Grid%Domain, Index%Local%Domain, Index%Zonal%Domain )
   call mpp_get_data_domain ( Index%Local%Domain,                &
                              Index%Local%isd, Index%Local%ied, &
                              Index%Local%jsd, Index%Local%jed  )
   call mpp_get_data_domain ( Index%Zonal%Domain,                &
                              Index%Zonal%isd, Index%Zonal%ied, &
                              Index%Zonal%jsd, Index%Zonal%jed  )
   call pf_domain_init ( nlpf, nlev*2,  &
            Grid%Domain, Index%Local2%Domain, Index%Zonal2%Domain )
   call mpp_get_data_domain ( Index%Local2%Domain,                 &
                              Index%Local2%isd, Index%Local2%ied, &
                              Index%Local2%jsd, Index%Local2%jed  )
   call mpp_get_data_domain ( Index%Zonal2%Domain,                 &
                              Index%Zonal2%isd, Index%Zonal2%ied, &
                              Index%Zonal2%jsd, Index%Zonal2%jed  )

 end subroutine set_index_type

!=======================================================================

subroutine pf_domain_init ( nlpf, nlev, Dom, Dom1, Dom2 )
integer       , intent(in)  :: nlpf, nlev 
type(domain2d), intent(in)  :: Dom  
type(domain2d), intent(inout) :: Dom1, Dom2

type(domain1d) :: Dx, Dy
integer, allocatable, dimension(:) :: xext, yext, yext1, ybeg, yend
logical, allocatable, dimension(:,:) :: mask 
integer :: layout(2), nlon, nlat, npes, ndiv, lin, rem, n
integer :: isg, ieg, jsg, jeg, rows
logical :: mask_rows

  npes = mpp_npes()

! get x/y extents
  call mpp_get_domain_components ( Dom, Dx, Dy )
  call mpp_get_layout ( Dom, layout )
  allocate ( xext(layout(1)), yext(layout(2)) )
  allocate ( ybeg(layout(2)), yend(layout(2)) )
  call mpp_get_compute_domains   ( Dx, size=xext )
  call mpp_get_compute_domains   ( Dy, size=yext )
  call mpp_get_compute_domains   ( Dy, begin=ybeg, end=yend )
  call mpp_get_global_domain     ( Dom, isg, ieg, jsg, jeg, &
                                   xsize=nlon, ysize=nlat   )
  ! compute number of filtered rows per y-axis processor
  mask_rows = .false.
  do n = 1, layout(2)
     rows = max(0, min(jsg+nlpf-1,yend(n))-max(jsg,ybeg(n))+1) + &
            max(0, min(jeg,yend(n))-max(jeg-nlpf+1,ybeg(n))+1)
     if (rows == 0) then
        yext(n) = 1  ! one row minimum
        mask_rows = .true.
     else
        yext(n) = rows*nlev
     endif
  enddo
  xext(layout(1)) = xext(layout(1)) + 1   ! extra column will hold cos(lat)
 !if (mpp_pe()==mpp_root_pe()) then
 ! print *, 'layout = ', layout
 ! print *, 'xext = ', xext
 ! print *, 'yext = ', yext
 !endif

! define new domain for polar filter
  call mpp_define_domains ( (/1,nlon+1,1,sum(yext)/), layout, Dom1, &
                           xflags = CYCLIC_GLOBAL_DOMAIN,           &
                           xextent = xext, yextent = yext )
                          !xextent = xext, yextent = yext, name = 'global' )
!------------------------------------------------------
! define zonal domain
  ndiv = npes
  if (mask_rows) ndiv = npes+1  ! setup extra division for masking rows
  layout = (/ 1, ndiv /)        ! one-dimensional decomposition
  allocate ( yext1(ndiv), mask(layout(1),layout(2)) )
  yext1 = 0
  mask  = .false.

! determine number of rows per PE in each hemisphere
! this can only be done when running on multiple PEs
  if (npes > 1) then
     ! sh
       lin = max(nlpf*nlev/((npes+1)/2), 1)
       rem = max(nlpf*nlev - lin*((npes+1)/2), 0)
       do n = 1, (npes+1)/2
         yext1(n) = lin
         mask (1,n) = .true.
       enddo
       do n = 1, rem
         yext1(n+1) = yext1(n+1) + 1
       enddo
     ! nh
       lin = max(nlpf*nlev/(npes/2), 1)
       rem = max(nlpf*nlev - lin*(npes/2), 0)
       do n = ndiv, ndiv-(npes/2)+1, -1
         yext1(n) = lin
         mask (1,n) = .true.
       enddo
       do n = ndiv, ndiv-rem+1, -1
         yext1(n) = yext1(n) + 1
       enddo
     ! non filtered row
       if (mask_rows) then
          lin = sum(yext1)
          yext1((npes+1)/2+1) = sum(yext) - lin
       endif
  else
! special case for NPES=1
! just copy original decomposition
     yext1 = yext
     mask  = .true.
  endif

 !if (mpp_pe()==mpp_root_pe()) then
 ! do n = npes, 0, -1
 !  print *, 'yext1, mask = ', yext1(n+1), mask(1,n+1)
 ! enddo
 !  print *, 'sum(yext1) = ', sum(yext1)
 !endif

  call mpp_define_domains ( (/1,nlon+1,1,sum(yext1)/), layout, Dom2, &
                           xflags = CYCLIC_GLOBAL_DOMAIN,            &
                           yextent = yext1, maskmap = mask )
                          !yextent = yext1, maskmap = mask, name = 'filter' )

  deallocate ( xext, yext, yext1, mask )

 end subroutine pf_domain_init

!#######################################################################

end module bgrid_polar_filter_mod

module ocean_residency_integrand_mod  !{
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies 
!</REVIEWER>
!
!<OVERVIEW>
! Ocean age tracer module
!</OVERVIEW>
!
!<DESCRIPTION>
!       This module contains the subroutines to set up fields other
!       than reciprocal time over which to integrate.
!
!       To use this module, in the field table namelist, you must do the following:
!
!       1) set "module_name_int" to "ocean_residency_integrand"
!       2) "int_strings" should have one or two values, the first is
!          the name of a prognostic or diagnostic variable to use as the integrand,
!          and if the second value is given and is "average", then the array is assumed
!          to be defined at the top of the grid cells, and the average of the top
!          and bottom will be used for each grid cell (top of bottommost grid cell),
!          otherwise the value at each level will be used
!       3) "int_params" may be set to a single value to scale the integrand,
!          at most one value may be set
!       4) no "int_flags" should be set
!
!       For an overview of the ocean residency modules, see ocean_residency.F90.
!
!</DESCRIPTION>
!
! $Id: ocean_residency_integrand.F90,v 20.0 2013/12/14 00:17:06 fms Exp $
!

!
!       modules
!

use field_manager_mod,   only: fm_field_name_len
use field_manager_mod,   only: fm_get_index
use mpp_mod,             only: stdout, mpp_error, FATAL
use fms_mod,             only: lowercase

use ocean_residency_meta_mod, only: ocean_residency_get_instances
use ocean_residency_meta_mod, only: ocean_residency_instance_type

use ocean_types_mod,     only: ocean_prog_tracer_type, ocean_diag_tracer_type

!
!       force all variables to be "typed"
!

implicit none

!
!       Set all variables to be private by default
!

private

!
!       Public routines
!

public  :: ocean_residency_integrand_source
public  :: ocean_residency_integrand_start

!
!       Private routines
!

!
!       Public parameters
!


!
!       Private parameters
!

character(len=fm_field_name_len), parameter     :: package_name = 'ocean_residency_integrand'
character(len=48), parameter                    :: mod_name = 'ocean_residency_integrand_mod'

!
!       Public variables
!

logical, public :: do_ocean_residency_integrand

!
!       Private types
!

type, private                           :: instance_extra_type
  integer                               :: tracer_index = 0
  logical                               :: is_prog_tracer = .true.
  logical                               :: average = .true.
  real                                  :: scale = 1.0
end type instance_extra_type

!
!       Private variables
!

type(instance_extra_type), dimension(:), allocatable            :: instance_extra
type(ocean_residency_instance_type), dimension(:), pointer      :: instance
integer                                                         :: num_instances = 0

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_residency_integrand_source">
!
! <DESCRIPTION>
!       Set the selected integrand field to be used in the "integrate_region"
!       as defined in ocean_residency.F90. The selected prognostic
!       or diagnostic variable will be multiplied by the residency mask
!       (which is usually either 1 or 0, but is not so required) and a
!       user-selected scale factor (default of 1). The variable may be either
!       the average of the surrounding points ( C(k) = (C(k) + C(k+1))/2 )
!       or just the same indexical value.
! </DESCRIPTION>
!

subroutine ocean_residency_integrand_source(isd, ied, jsd, jed, nk, taum1, T_prog, T_diag, grid_tmask)  !{

!
!       modules
!

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
integer, intent(in)                                             :: nk
integer, intent(in)                                             :: taum1
type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
type(ocean_diag_tracer_type), dimension(:), intent(inout)       :: T_diag
real, dimension(isd:,jsd:,:), intent(in)                        :: grid_tmask

!
!       local parameters
!

!
!       local variables
!

integer                                 :: tracer_index
integer                                 :: i
integer                                 :: j
integer                                 :: k
integer                                 :: n

!
!       set the source values for the residency tracers
!

do n = 1, num_instances  !{

  if (instance(n)%integrate_region_value .ne. 0.0) then  !{

    tracer_index = instance_extra(n)%tracer_index

    if (instance_extra(n)%is_prog_tracer) then  !{

!
!       The variable is a prognostic variable
!

      if (instance_extra(n)%average) then  !{

        do k = 1, nk - 1  !{
          do j = jsd, jed  !{
            do i = isd, ied  !{
              if (instance(n)%index(i,j,k) .eq. 0) then  !{
                instance(n)%mask(i,j,k) = instance(n)%mask(i,j,k) * instance_extra(n)%scale *   &
                     (T_prog(tracer_index)%field(i,j,k,taum1) * grid_tmask(i,j,k) +             &
                      T_prog(tracer_index)%field(i,j,k+1,taum1) * grid_tmask(i,j,k+1)) * 0.5
              endif  !}
            enddo  !} i
          enddo  !} j
        enddo  !} k
        do j = jsd, jed  !{
          do i = isd, ied  !{
            if (instance(n)%index(i,j,k) .eq. 0) then  !{
              instance(n)%mask(i,j,nk) = instance(n)%mask(i,j,nk) * instance_extra(n)%scale *   &
                   T_prog(tracer_index)%field(i,j,nk,taum1) * grid_tmask(i,j,nk) * 0.5
            endif  !}
          enddo  !} i
        enddo  !} j

      else  !}{

        do k = 1, nk  !{
          do j = jsd, jed  !{
            do i = isd, ied  !{
              if (instance(n)%index(i,j,k) .eq. 0) then  !{
                instance(n)%mask(i,j,k) = instance(n)%mask(i,j,k) * instance_extra(n)%scale *   &
                     T_prog(tracer_index)%field(i,j,k,taum1) * grid_tmask(i,j,k)
              endif  !}
            enddo  !} i
          enddo  !} j
        enddo  !} k

      endif  !}

    else  !}{

!
!       The variable is a diagnostic variable
!

      if (instance_extra(n)%average) then  !{

        do k = 1, nk - 1  !{
          do j = jsd, jed  !{
            do i = isd, ied  !{
              if (instance(n)%index(i,j,k) .eq. 0) then  !{
                instance(n)%mask(i,j,k) = instance(n)%mask(i,j,k) * instance_extra(n)%scale *   &
                     (T_diag(tracer_index)%field(i,j,k) * grid_tmask(i,j,k) +                   &
                      T_diag(tracer_index)%field(i,j,k+1) * grid_tmask(i,j,k+1)) * 0.5
              endif  !}
            enddo  !} i
          enddo  !} j
        enddo  !} k
        do j = jsd, jed  !{
          do i = isd, ied  !{
            if (instance(n)%index(i,j,k) .eq. 0) then  !{
              instance(n)%mask(i,j,nk) = instance(n)%mask(i,j,nk) * instance_extra(n)%scale *   &
                   T_diag(tracer_index)%field(i,j,nk) * grid_tmask(i,j,nk) * 0.5
            endif  !}
          enddo  !} i
        enddo  !} j

      else  !}{

        do k = 1, nk  !{
          do j = jsd, jed  !{
            do i = isd, ied  !{
              if (instance(n)%index(i,j,k) .eq. 0) then  !{
                instance(n)%mask(i,j,k) = instance(n)%mask(i,j,k) * instance_extra(n)%scale *   &
                     T_diag(tracer_index)%field(i,j,k) * grid_tmask(i,j,k)
              endif  !}
            enddo  !} i
          enddo  !} j
        enddo  !} k

      endif  !}

    endif  !}

  endif  !}

enddo  !} n

return

end subroutine ocean_residency_integrand_source  !}
! </SUBROUTINE> NAME="ocean_residency_integrand_source"


!#######################################################################
! <SUBROUTINE NAME="ocean_residency_integrand_start">
!
! <DESCRIPTION>
!       Start the ocean residency integrand package
!
! </DESCRIPTION>
!
subroutine ocean_residency_integrand_start  !{

!
!       modules
!

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

!
!       local parameters
!

character(len=64), parameter    :: sub_name = 'ocean_residency_integrand_start'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!
!       local variables
!

integer :: n

  integer :: stdoutunit 
  stdoutunit=stdout() 

instance => ocean_residency_get_instances(package_name, integrand = .true.)

write (stdoutunit,*)
if (.not. associated(instance)) then  !{
  write (stdoutunit,*) trim(note_header), ' No instances'
  num_instances = 0
  do_ocean_residency_integrand = .false.
else  !}{
  num_instances = size(instance)
  if (num_instances .eq. 1) then  !{
    write (stdoutunit,*) trim(note_header), ' ', num_instances, ' instance'
  else  !}{
    write (stdoutunit,*) trim(note_header), ' ', num_instances, ' instances'
  endif  !}
  do_ocean_residency_integrand = .true.
endif  !}

!
!       return if no tracers
!

if (.not. do_ocean_residency_integrand) then
  return
endif

!
!       Allocate array for extra instance information
!

allocate( instance_extra(num_instances) )

do n = 1, num_instances  !{

!
!       Check that a type was given
!

  if (.not. associated(instance(n)%int_strings)) then  !{
    call mpp_error(FATAL, trim(error_header) // ' No int_strings set for ' // trim(instance(n)%name))
  endif  !}

!
!       Check the types
!

  if (associated(instance(n)%int_strings)) then  !{

!
!       Define the tracer field to use as the integrand.
!       The first int_strings has the name of the field to use, and the
!       second int_strings, if given, sets whether to do a vertical average of
!       the field or just use the field. By default, averaging is not done.
!
!       An optional int_param may be given to scale to field. If not given,
!       then a value of one is used.
!

    if (size(instance(n)%int_strings) .gt. 2) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Wrong number of int_strings set for ' //    &
           trim(instance(n)%name))
    elseif (size(instance(n)%int_strings) .eq. 1) then  !}{
      instance_extra(n)%average = .false.
    else  !}{
      instance_extra(n)%average = lowercase(instance(n)%int_strings(2)) .eq. 'average'
    endif  !}

    if (associated(instance(n)%int_params)) then  !{
      if (size(instance(n)%int_params) .ne. 1) then  !{
        call mpp_error(FATAL, trim(error_header) // ' Too many int_params set for ' //          &
             trim(instance(n)%name) // ' (' // trim(instance(n)%int_strings(1)) // ')')
      else  !}{
        instance_extra(n)%scale = instance(n)%int_params(1)
      endif  !}
    else  !}{
      instance_extra(n)%scale = 1.0
    endif  !}

    if (associated(instance(n)%int_flags)) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Flags set for ' //                          &
           trim(instance(n)%name) // ' (' // trim(instance(n)%int_strings(1)) // ')')
    endif  !}

    instance_extra(n)%tracer_index = fm_get_index('/ocean_mod/prog_tracers/' //                 &
         trim(instance(n)%int_strings(1)))
    if (instance_extra(n)%tracer_index .gt. 0) then  !{
      instance_extra(n)%is_prog_tracer = .true.
    else  !}{
      instance_extra(n)%tracer_index = fm_get_index('/ocean_mod/diag_tracers/' //               &
           trim(instance(n)%int_strings(1)))
      if (instance_extra(n)%tracer_index .gt. 0) then  !{
        instance_extra(n)%is_prog_tracer = .false.
      else  !}{
        call mpp_error(FATAL, trim(error_header) // ' Could not get the index for tracer "' //  &
             trim(instance(n)%int_strings(1)))
      endif  !}
    endif  !}

  endif  !}

enddo  !} n

return

end subroutine ocean_residency_integrand_start  !}
! </SUBROUTINE> NAME="ocean_residency_integrand_start"

end module ocean_residency_integrand_mod  !}

module atmosphere_mod
! 
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> B.L. Samuels
!</CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  Zhi Liang
! </REVIEWER>

!<OVERVIEW>
!         interface for spherical grid dynamical core and physics
!                   for the energy balance model (EBM)
!</OVERVIEW>
!
!<DESCRIPTION>
!    The Energy Balance Model is a simple spectral atmospheric model
!     using diffusion and radiative balance. The EBM solves two
!     prognostic equations for atmospheric temperature and specific
!     humidity 
!</DESCRIPTION>
!
!<INFO>
!     The Energy Balance Model was originally developed at GFDL
!     by I. Held and extensively modified by J. Russell to be
!     MOM4 compatible. Zhi Liang made the appropriate modifications
!     for the code to be fms_io compatible and meet RTS standards.
!      No current reference of this code exists.
!</INFO>
!<REFERENCE>
!    Zhang,Rong and Geoffrey Vallis, " The Role of the Deep Western Boundary Current in the
!     Separation of the Gulf Stream", Journal of Physical Oceanography,submitted 2004
!     see Appendix A  
!</REFERENCE>
!<NOTE>
!     Note by J. Russell: the number of processors you use must be less than the number of
!     atmospheric latitude boxes and must divide into that number equally
!</NOTE>
!
!-----------------------------------------------------------------------
!
!         interface for spherical grid dynamical core and physics
!                   for the energy balance model (EBM)
!
!-----------------------------------------------------------------------
!---------------- m o d u l e   i n f o r m a t i o n ------------------

use mpp_mod,             only: mpp_pe, stdout, stdlog, mpp_error
use fms_mod,             only: file_exist, close_file, read_data, write_data
use fms_mod,             only: error_mesg, FATAL, check_nml_error, open_namelist_file
use fms_mod,             only: write_version_number
use constants_mod,       only: radius, rdgas, rvgas, cp_air, hlv, hlf, tfreeze, stefan, PI
use transforms_mod,      only: transforms_init, grid_domain, spectral_domain
use transforms_mod,      only: trans_grid_to_spherical, trans_spherical_to_grid
use transforms_mod,      only: get_deg_lat, get_eigen_laplacian, compute_gradient_cos
use transforms_mod,      only: compute_div, get_grid_boundaries, divide_by_cos2
use transforms_mod,      only: triangular_truncation, get_grid_domain, get_spec_domain
use transforms_mod,      only: get_wts_lat
use time_manager_mod,    only: time_type, get_time, get_date, operator(+)
use ebm_diagnostics_mod, only: ebm_diagnostics_init, ebm_diagnostics_up, ebm_diagnostics_down
use astronomy_mod,       only: astronomy_init, daily_mean_solar, annual_mean_solar
use sat_vapor_pres_mod,  only: escomp, descomp
use mpp_domains_mod,     only: domain2D
use tracer_manager_mod,  only: get_number_tracers
use xgrid_mod,           only: grid_box_type

!==================================================================================
implicit none
private
!==================================================================================

! version information 

character(len=128), parameter :: version = &
'$Id: atmosphere.F90,v 19.0 2012/01/06 20:00:07 fms Exp $'

character(len=128), parameter :: tagname = &
'$Name: tikal $'

!==================================================================================

! public interfaces

public :: atmosphere_init, atmosphere_down, atmosphere_up
public :: atmosphere_end, atmosphere_resolution, atmosphere_boundary
public :: get_bottom_mass, get_bottom_wind, get_atmosphere_axes
public :: surf_diff_type, radiation, precipitation
public :: diffusion, atmosphere_domain
public :: get_stock_pe, atmosphere_cell_area
public :: atmosphere_restart

!==================================================================================

! module variables

!<PUBLICTYPE>
type surf_diff_type
  real, pointer, dimension(:,:) :: dtmass  => NULL() ! dt/mass, where dt = atmospheric time step (sec)
                                                     ! mass = mass of lowest atmospheric layer (Kg/m2)
  real, pointer, dimension(:,:) :: dflux_t => NULL() ! derivative of the temperature flux at the top of the lowest
                                                     ! atmospheric layer with respect to the temperature
                                                     ! of that layer  (J/(m2 K))
  real, pointer, dimension(:,:,:) :: dflux_tr => NULL() ! derivative of the flux of specific humidity
                                                     ! at the top of the lowest atmospheric layer with respect to
                                                     ! the specific humidity of that layer  (--/(m2 K))
  real, pointer, dimension(:,:) :: delta_t => NULL() ! the increment in temperature in the lowest atmospheric
                                                     ! layer (((i+1)-(i-1) if atmos model is leapfrog) (K)
                                                     ! (defined in  gcm_vert_diff_down as the increment computed up
                                                     ! to this point in model, including effect of vertical
                                                     ! diffusive flux at top of lowest model level, presumed
                                                     ! to be modified to include effects of surface fluxes
                                                     ! outside of this module, then used to start upward
                                                     ! tridiagonal sweep,
  real, pointer, dimension(:,:,:):: delta_tr => NULL() ! similarly for the increment in specific humidity
                                                     ! (non-dimensional  = Kg/Kg)
  real, pointer, dimension(:,:) :: delta_u => NULL()
  real, pointer, dimension(:,:) :: delta_v => NULL()
  real, pointer, dimension(:,:) :: sst_miz => NULL()
end type surf_diff_type
!</PUBLICTYPE>

complex, allocatable, dimension(:,:) :: ts    ! atmospheric temperature  deg_k
complex, allocatable, dimension(:,:) :: qs    ! specific humidity  no units
complex, allocatable, dimension(:,:) :: dt_ts ! rate of change in atmospheric temperature (degK/s)
complex, allocatable, dimension(:,:) :: dt_qs ! rate of change in specific humidity (1/s)
real   , allocatable, dimension(:,:) :: tg    ! atmospheric temperature  ( deg_k )
real   , allocatable, dimension(:,:) :: qg    ! specific humidity ( no units )
real   , allocatable, dimension(:,:) :: dt_tg ! rate of change in atmospheric temperature (degK/s)
real   , allocatable, dimension(:,:) :: dt_qg ! rate of change in specific humidity (1/s)
real   , allocatable, dimension(:,:) :: u_bot ! zonal wind component at lowest model level (m/s)
real   , allocatable, dimension(:,:) :: v_bot ! meridional wind component at lowest model level (m/s)
real   , allocatable, dimension(:,:) :: t_bot ! temperature at lowest model level (deg k)
real   , allocatable, dimension(:,:) :: q_bot ! specific humidity at lowest model level (kg/kg)

real   , allocatable, dimension(:) :: deg_lat, deg_lon, rad_lat, annual_solar, annual_cosz

integer, dimension(4) :: axis_id         ! axes identifiers provided by ebm_diagnostics_mod
real                  :: dt              ! time step (secs)
type(time_type)       :: Time, Time_next, Time_step

integer :: is,ie,js,je,ms,me,ns,ne

real, parameter :: d622 = rdgas/rvgas
real, parameter :: d378 = 1.-d622
logical         :: module_is_initialized =.false.
integer         :: q_ind = 1
!-----------------------------------------------------------------------
!---- namelist (saved in file input.nml) ----
!
! namelist parameters with default values
! Default values are based on ebm run with 1p5 ocean model
!   120 x 65 as run by Joellen Russell

integer  :: lon_max        = 180
integer  :: lat_max        = 120
integer  :: num_fourier    = 42

real    :: diff            = 1.e04
real    :: nu              = 4.0e16
real    :: solar_constant  = 1360.0
real    :: atm_abs         = 0.15
real    :: atm_ref         = 0.05
real    :: mass            = 8.e03
real    :: rh              = 0.8
real    :: t_bot_atm       = 30.0
logical :: seasonal_solar  = .true.
logical :: diff_is_uniform = .false.

real    :: tg_init         = 273.0
real    :: gustiness       = 1.0

logical :: debug_ebm_atm   = .false.

!<NAMELIST NAME="atmosphere_nml">
!  namelist/atmosphere_nml/ lon_max, lat_max, num_fourier, &
!                        mass, rh, t_bot_atm,          &
!                        solar_constant, atm_abs, atm_ref, seasonal_solar, &
!                        diff_is_uniform, nu, diff, tg_init, debug_ebm_atm
!  <DATA NAME="lon_max" TYPE="integer"  DEFAULT="180">
!  This is the longitude of the spectral atmospheric grid
!  </DATA>
!  <DATA NAME="lat_max" TYPE="integer" DEFAULT="120">
!  This is the latitude of the spectral atmospheric grid
!  Note that the number of processors you use must be less than the number of
!  atmospheric latitude boxes and must divide into that number equally
!  </DATA>
!  <DATA NAME="num_fourier" TYPE="integer" DEFAULT="42">
!   num_fourier is used along with lon_max, lat_max in the spectral transforms of grids
!  </DATA>
!  <DATA NAME="diff" UNITS="m^2/sec" TYPE="real" DEFAULT="1.e04">
!   background atmospheric lateral eddy diffusion coefficient for the EBM
!  </DATA>
!  <DATA NAME="nu"  TYPE="real" DEFAULT="4.0e16">
!    scaling factor for spherical grid analysis used in diffusion subroutine
!  </DATA>
!  <DATA NAME="solar_constant" UNITS="Watts/m^2" TYPE="real" DEFAULT="1360.0">
!   standard value for the annual mean solar flux at the top of atmosphere.
!    Default value if seasonal_solar=.false.
!  </DATA>
!  <DATA NAME="atm_abs" TYPE="real" DEFAULT="0.15">
!   atmospheric absorption (fraction)
!  </DATA>
!  <DATA NAME="atm_ref" TYPE="real" DEFAULT="0.05">
!   atmosphere reflectance  (fraction)
!  </DATA>
!  <DATA NAME="mass" UNITS="Kg/m2" TYPE="real" DEFAULT="8.e03">
!   mass = mass of lowest atmospheric layer (Kg/m2)
!  </DATA>
!  <DATA NAME="rh" TYPE="real" DEFAULT="0.8">
!     relative humidity (fraction)
!  </DATA>
!  <DATA NAME="t_bot_atm" UNITS="deg K"  TYPE="real" DEFAULT="30.0">
!    temperature at the bottom of the atmosphere
!  </DATA>
!  <DATA NAME="seasonal_solar" UNITS="Watts/m^2" TYPE="logical" DEFAULT=".true.">
!     If .true., seasonal solar value is computed
!  </DATA>
!  <DATA NAME="diff_is_uniform" TYPE="logical" DEFAULT=".false.">
!  </DATA>
!  <DATA NAME="tg_init" UNITS="deg K" TYPE="real" DEFAULT="273.0">
!   constant value for inital atmospheric temperature  (degK)
!  </DATA>
!  <DATA NAME="debug_ebm_atm" TYPE="logical" DEFAULT=".false.">
!  For debugging purposes.
!  </DATA>

namelist/atmosphere_nml/ lon_max, lat_max, num_fourier, mass, rh, t_bot_atm, &
                         solar_constant, atm_abs, atm_ref, seasonal_solar,   &
                         diff_is_uniform, nu, diff, tg_init, debug_ebm_atm, gustiness
!</NAMELIST>

!==================================================================================

contains



! ==================================================================================
! ==================================================================================

! <SUBROUTINE NAME="atmosphere_init">
!
! <OVERVIEW>
!  public routine required for atmospheric components of coupled models
!  Read in restart files and initialize arrays
! </OVERVIEW>
!
! <DESCRIPTION>
!  public routine required for atmospheric components of coupled models
!  Read in restart files and initialize arrays
! </DESCRIPTION>
!
! <TEMPLATE>
!   call atmosphere_init(Time_init, Time_in, Time_step_in, Surf_diff, Grid_box)
! </TEMPLATE>
!
! <IN NAME="Time_init" TYPE="type(time_type)" >
!   The base (or initial) time of the experiment.
! </IN>

! <IN NAME="Time_in" TYPE="type(time_type)" >
!   The current time.
! </IN>

! <IN NAME="Time_step_in" TYPE="type(time_type)" >
!   The atmospheric model/physics time step.
! </IN>

! <INOUT NAME="Surf_diff" TYPE="type(surf_diff_type)">
!   The surface terms for vertical diffusion that are exchanged
!   with other component models. On input fields have not been
!   allocated, on output all arrays are allocated.
! </INOUT>

! <INOUT NAME="Grid_box" TYPE="type(grid_box_type)">
!   Contains information about the grid cells 
! </INOUT>

subroutine atmosphere_init(Time_init, Time_in, Time_step_in, Surf_diff, Grid_box)

type(time_type),      intent(in)    :: Time_init, Time_in, Time_step_in
type(surf_diff_type), intent(inout) :: Surf_diff
type(grid_box_type),  intent(inout) :: Grid_box

integer                           :: ierr, io, unit, seconds, days, m, n
character(len=64)                 :: filename
real, allocatable, dimension(:,:) :: real_part, imag_part
!-----------------------------------------------------------------------------------------
! managing time

Time      = Time_in
Time_step = Time_step_in

call get_time(Time_step, seconds, days)
dt      = float(86400*days + seconds)

!-----------------------------------------------------------------------------------------
! read namelist and copy to logfile

unit = open_namelist_file()
read  (unit, nml=atmosphere_nml,iostat=io)
write (stdout(),'(/)')
write (stdout(), atmosphere_nml)  
write (stdlog(), atmosphere_nml)
ierr = check_nml_error(io, 'atmosphere_nml')
call close_file(unit)

!--- write out version information
call write_version_number(version, tagname)


!-----------------------------------------------------------------------------------------
! Initialize spherical fourier
call transforms_init(radius, lat_max, lon_max, num_fourier, 1, num_fourier+1)

!-----------------------------------------------------------------------------------------

call get_grid_domain(is,ie,js,je)
call get_spec_domain(ms,me,ns,ne)

! allocate module variables
 
allocate ( tg    (is:ie, js:je) )
allocate ( qg    (is:ie, js:je) )
allocate ( dt_tg (is:ie, js:je) )
allocate ( dt_qg (is:ie, js:je) )

allocate ( u_bot (is:ie, js:je) )
allocate ( v_bot (is:ie, js:je) )
allocate ( t_bot (is:ie, js:je) )
allocate ( q_bot (is:ie, js:je) )

allocate ( ts    (ms:me, ns:ne) )
allocate ( qs    (ms:me, ns:ne) )
allocate ( dt_ts (ms:me, ns:ne) )
allocate ( dt_qs (ms:me, ns:ne) )

allocate ( deg_lon      (is:ie) )
allocate ( deg_lat      (js:je) )
allocate ( rad_lat      (js:je) )

allocate ( annual_cosz  (js:je) )
allocate ( annual_solar (js:je) )

allocate (real_part( ms:me, ns:ne) )
allocate (imag_part( ms:me, ns:ne) )

! hack: in case EBM use more than 1 tracer other than water vapor, revamp this code.
! fil
allocate (Surf_diff%dtmass  (is:ie, js:je) )
allocate (Surf_diff%dflux_t (is:ie, js:je) )
allocate (Surf_diff%dflux_tr (is:ie, js:je, q_ind) )
allocate (Surf_diff%delta_t (is:ie, js:je) )
allocate (Surf_diff%delta_tr (is:ie, js:je, q_ind) )
allocate (Surf_diff%delta_u (is:ie, js:je) )
allocate (Surf_diff%delta_v (is:ie, js:je) )

Surf_diff%dtmass  = 0.0
Surf_diff%dflux_t = 0.0
Surf_diff%dflux_tr = 0.0
Surf_diff%delta_t = 0.0
Surf_diff%delta_tr = 0.0
Surf_diff%delta_u = 0.0
Surf_diff%delta_v = 0.0

!-----------------------------------------------------------------------------------------

! these elements of Surf_diff are static

Surf_diff%dtmass  = dt/mass
Surf_diff%dflux_t = 0.0
Surf_diff%dflux_tr = 0.0

!-----------------------------------------------------------------------------------------

! read restart

filename = 'INPUT/atmosphere.res.nc'

if(file_exist(filename)) then

  call read_data(filename, 'ts_real', real_part, spectral_domain)
  call read_data(filename, 'ts_imag', imag_part, spectral_domain)
  do n = ns, ne
     do m = ms, me
        ts(m,n) = cmplx(real_part(m,n),imag_part(m,n))
     enddo
  enddo
  call read_data(filename, 'qs_real', real_part, spectral_domain)
  call read_data(filename, 'qs_imag', imag_part, spectral_domain)

  do n = ns, ne
     do m = ms, me
        qs(m,n) = cmplx(real_part(m,n),imag_part(m,n))
     enddo
  enddo

  call read_data(filename, 'tg', tg, grid_domain)
  call read_data(filename, 'qg', qg, grid_domain)
else
! tg-initial atmospheric temperature default value 273 deg Kelvin
! qg-initial atmospheric specific humidity
  tg = tg_init
  qg = rh*sat_mixing_ratio(tg)

  call trans_grid_to_spherical(tg, ts)
  call trans_grid_to_spherical(qg, qs)

endif

v_bot = 0.0
t_bot = tg + t_bot_atm
q_bot = rh*sat_mixing_ratio(t_bot)  

! initalize other modules

call ebm_diagnostics_init(Time, lon_max, lat_max, axis_id)
call astronomy_init()

! get latitudes of grid points in degrees and radians
call get_deg_lat(deg_lat)
rad_lat = deg_lat*PI/180.

! if annual mean option is used, compute solar radiation here
!  Use version for  spectral 2-layer model 
if(.not.seasonal_solar) call annual_mean_solar ( rad_lat, annual_cosz, annual_solar ) 

module_is_initialized = .true.

return
end subroutine atmosphere_init
! </SUBROUTINE>

! ==================================================================================
! <SUBROUTINE NAME="atmosphere_down">
! <OVERVIEW>
!  public routine required for atmospheric components of coupled models
! </OVERVIEW>

! <DESCRIPTION>
!   atmosphere_down
!  This routine calls the dynamical core and the
!  "downward pass" of the atmospheric physics.
!  It should only be called once per time step and before
!  calling atmosphere_up.
! </DESCRIPTION>

! <TEMPLATE>
!     call atmosphere_down(Time, frac_land, t_surf, albedo, rough_mom, &
!                          u_star, b_star, q_star, dtau_du, dtau_dv, tau_x, tau_y,  &
!                          gust, coszen, net_surf_sw_down, surf_lw_down, &
!                          Surf_diff)
! </TEMPLATE>

! <IN NAME="Time" TYPE="type(time_type)">
!  time at the current time level (tau)
! </IN>

! <IN NAME="frac_land" TYPE="real, dimension(is:ie,js:je)">
!  fraction (0. to 1.) of underlying surface which covered by land
! </IN>

! <IN NAME="t_surf" TYPE="real, dimension(is:ie,js:je)">
!  surface (skin) temperature (in deg k)
! </IN>

! <IN NAME="albedo" TYPE="real, dimension(is:ie,js:je)">
!  surface albedo
! </IN>

! <IN NAME="rough_mom" TYPE="real, dimension(is:ie,js:je)">
!  momentum roughness length (units=m)
! </IN>

! <IN NAME="u_star" TYPE=" real, dimension(is:ie,js:je)">
!  friction velocity
! </IN>

! <IN NAME="b_star" TYPE="real, dimension(is:ie,js:je) ">
!  buoyancy scale
! </IN>

! <IN NAME="q_star" TYPE="real, dimension(is:ie,js:je) ">
!  moisture scale
! </IN>

! <IN NAME="dtau_du" TYPE=" real, dimension(is:ie,js:je)">
!  derivative of zonal wind stress w.r.t. the lowest level wind speed
! </IN>

! <IN NAME="dtau_dv" TYPE=" real, dimension(is:ie,js:je)">
!  derivative of meridional wind stress w.r.t. the lowest level wind speed
! </IN>

! <OUT NAME="gust" TYPE="real, dimension(is:ie,js:je)" >
!  wind gustiness
! </OUT>

! <OUT NAME="coszen" TYPE="real, dimension(is:ie,js:je)" >
!  cosine of the zenith angle
! </OUT>

! <OUT NAME="coszen_radwt" TYPE="real, dimension(is:ie,js:je)" >
!  cosine of the zenith angle, radiation weighted, not used in EBM
! </OUT>

! <OUT NAME="net_surf_sw_down" TYPE="real, dimension(is:ie,js:je)" >
!  net shortwave surface flux (down minus up) (in watts/m**2)
! </OUT>

! <OUT NAME="surf_lw_down" TYPE="real, dimension(is:ie,js:je)" >
!  downward longwave surface flux (in watts/m**2)
! </OUT>

! <INOUT NAME=" Surf_diff" TYPE="type(surf_diff_type)" >
!  Surface diffusion terms computed by the vertical diffusion scheme
! </INOUT>

subroutine atmosphere_down(Time, frac_land, t_surf, albedo, albedo_vis_dir, &
                           albedo_nir_dir, albedo_vis_dif,  albedo_nir_dif, &
                           rough_mom, u_star, b_star, q_star, dtau_du, dtau_dv, &
                           tau_x, tau_y,frac_open_sea, gust, coszen, coszen_radwt, net_surf_sw_down,    &
                           flux_sw_dir, flux_sw_dif, flux_sw_down_vis_dir,  &
                           flux_sw_down_vis_dif, flux_sw_down_total_dir,    &
                           flux_sw_down_total_dif, flux_sw_vis,             &
                           flux_sw_vis_dir, flux_sw_vis_dif,surf_lw_down,   &
                           Surf_diff)

!  public routine required for atmospheric components of coupled models
type(time_type),  intent(in)                 :: Time
real, intent(in),     dimension(is:ie,js:je) :: frac_land, t_surf, albedo, rough_mom
real, intent(in),     dimension(is:ie,js:je) :: albedo_vis_dir, albedo_nir_dir
real, intent(in),     dimension(is:ie,js:je) :: albedo_vis_dif, albedo_nir_dif
real, intent(in),     dimension(is:ie,js:je) :: u_star, b_star, q_star, dtau_du, dtau_dv, frac_open_sea
real,  intent(inout), dimension(is:ie,js:je) :: tau_x, tau_y
real,  intent(out),   dimension(is:ie,js:je) :: gust, coszen, coszen_radwt, net_surf_sw_down, surf_lw_down
real, intent(out),    dimension(is:ie,js:je) :: flux_sw_dir, flux_sw_dif, flux_sw_down_vis_dir
real, intent(out),    dimension(is:ie,js:je) :: flux_sw_down_vis_dif, flux_sw_down_total_dir
real, intent(out),    dimension(is:ie,js:je) :: flux_sw_down_total_dif, flux_sw_vis
real, intent(out),    dimension(is:ie,js:je) :: flux_sw_vis_dir, flux_sw_vis_dif
type(surf_diff_type),   intent(inout)        :: Surf_diff

coszen_radwt = 0.0

! initialize tendencies of temperature and mixing ratio to zero 
dt_tg = 0.0
dt_qg = 0.0

! add temperature tendency due to radiation, and compute radiative fluxes and
!    zenith angle needed by flux module

call radiation (Time, t_surf, albedo, coszen, net_surf_sw_down, surf_lw_down)

!
!           VIS                NIR          VIS+NIR
!-----------------------------------------------------
!       |                 |              |
! DIR   |flux_sw_vis_dir  |              | flux_sw_dir
!       |                 |              |
!-----------------------------------------------------
!       |                 |              |
! DIF   |flux_sw_vis_dif  |              | flux_sw_dif
!-----------------------------------------------------
!       |                 |              |
!DIR+DIF|flux_sw_vis      |              | flux_sw        
!       |                 |              |(diagnostic only)
!-----------------------------------------------------

! bls-total Short wave is equally divided into VIS and NIR
! flux_sw_dif - total Diffusive Short wave : VIS + NIR
flux_sw_dif = .5*net_surf_sw_down
! flux_sw_dir - total Direct Short wave : VIS + NIR
flux_sw_dir = net_surf_sw_down - flux_sw_dif

! bls- Visible Direct and Diffusive short wave will be assumed to be
! half of the total VIS+DIR components
flux_sw_vis_dir = .5*flux_sw_dir
flux_sw_vis_dif = .5*flux_sw_dif
! Total Visible short wave (DIR + DIFFUSE)
 flux_sw_vis = flux_sw_vis_dir + flux_sw_vis_dif
! NIR components are determined in the ice model

! for surface flux computation 
gust    = gustiness
v_bot   = 0.0
t_bot   = tg + t_bot_atm  
q_bot   = rh*sat_mixing_ratio(t_bot)  

Surf_diff%delta_t = dt*dt_tg   ! needed in this form for surface models
Surf_diff%delta_tr(:,:,q_ind) = dt*dt_qg

return
end subroutine atmosphere_down
! </SUBROUTINE>


! ==================================================================================
! <SUBROUTINE NAME="atmosphere_up">
! <OVERVIEW>
!  public routine required for atmospheric components of coupled models
!</OVERVIEW>
!
!<DESCRIPTION>
!   atmosphere_up
!  This routine calls the "upward pass" of the atmospheric physics,
!  spherical diagnostics, and time differencing.  The prognostic
!  variables are advanced to the next time step.  It should only be
!  called once per time step and after calling atmosphere_down.
!</DESCRIPTION>

!   <TEMPLATE>
!     call  atmosphere_up(Time, frac_land, Surf_diff, lprec, fprec, gust)
!   </TEMPLATE>

! <IN NAME="Time" TYPE="type(time_type)">
!  time at the current time level (tau)
! </IN>

! <IN NAME="frac_land" TYPE="real, dimension(is:ie,js:je)">
!  fraction (0. to 1.) of underlying surface which covered by land
! </IN>

! <OUT NAME="lprec" TYPE="real, dimension(is:ie,js:je)" >
!  liquid precipitation rate (rain) in kg/m2/s
! </OUT>

! <OUT NAME="fprec" TYPE="real, dimension(is:ie,js:je)" >
!  frozen precipitation rate (snow) in kg/m2/s
! </OUT>

! <OUT NAME="gust" TYPE="real, dimension(is:ie,js:je)" >
!  wind gustiness
! </OUT>

! <INOUT NAME=" Surf_diff" TYPE="type(surf_diff_type)" >
!  urface diffusion terms computed by the vertical diffusion scheme
! </INOUT>

! <IN NAME="u_star" TYPE="real,dimension(:,:)">
!  NOT USED in this routine. Dummy argument added for compilation success.
! </IN>
! <IN NAME="b_star" TYPE="real,dimension(:,:)">
!  NOT USED in this routine. Dummy argument added for compilation success.
! </IN>
! <IN NAME="q_star" TYPE="real,dimension(:,:)">
!  NOT USED in this routine. Dummy argument added for compilation success.
! </IN>

subroutine atmosphere_up(Time,  frac_land, Surf_diff, lprec, fprec, gust, u_star, b_star, q_star )

    
type(time_type),      intent(in)                          :: Time
real,                 intent(in),  dimension(is:ie,js:je) :: frac_land
type(surf_diff_type), intent(in)                          :: Surf_diff
real,                 intent(out), dimension(is:ie,js:je) :: lprec, fprec, gust
real,                 intent(in),  dimension(:,:)         :: u_star, b_star, q_star

complex, dimension(ms:me,ns:ne) :: lap, spec
real,    dimension(ms:me,ns:ne) :: eigen

integer :: year, month, day, hour, minute, second

dt_tg = Surf_diff%delta_t/dt
dt_qg = Surf_diff%delta_tr(:,:,q_ind)/dt

!initialize arrays to zero
 gust = gustiness

call precipitation(lprec, fprec)
call diffusion

Time_next = Time + Time_step
     if(debug_ebm_atm) then
 call get_date(Time_next, year, month, day, hour, minute, second)
 if (mpp_pe() == 0 .and. hour+minute == 0 ) then
    print *,"atmosphere_up:Current time: year =",year," month = ",month," day = ",day
    write (stdout(),1000) tg(ie,je), qg(ie,je), lprec(ie,je), fprec(ie,je)
 endif
     endif
call ebm_diagnostics_up(Time_next, tg, qg, lprec, fprec, dt_qg)
     if(debug_ebm_atm) then
! print out a few things for degbugging
 if (mpp_pe() == 0 .and. hour+minute == 0 ) then 
    print *,"atmosphere_up aft diag:Current time: year =",year," month = ",month," day = ",day
    write (stdout(),1000) tg(ie,je), qg(ie,je), lprec(ie,je), fprec(ie,je)
 endif
 1000 format(4(1x,e11.4))
     endif


return
end subroutine atmosphere_up
! </SUBROUTINE>

! ==================================================================================
! <SUBROUTINE NAME="radiation">
! <DESCRIPTION>
!    radiation
!    Radiation module for prognostic equation of atmospheric temperature
!    The atmospheric tendency term (dt_tg) includes the balance of shortwave
!    and longwave radiation terms at the surface
! </DESCRIPTION>
!
! <TEMPLATE>
!  call radiation (Time, t_surf, albedo, coszen, net_surf_sw_down, surf_lw_down)
! </TEMPLATE>

! <IN NAME="Time" TYPE="type(time_type)">
!  time at the current time level (tau)
! </IN>

! <IN NAME="t_surf" TYPE="real, dimension(is:ie,js:je)">
!  surface (skin) temperature (in deg k)
! </IN>

! <IN NAME="albedo" TYPE="real, dimension(is:ie,js:je)">
!  surface albedo
! </IN>

! <OUT NAME="coszen" TYPE="real, dimension(is:ie,js:je)" >
!  cosine of the zenith angle
! </OUT>

! <OUT NAME="net_surf_sw_down" TYPE="real, dimension(is:ie,js:je)" >
!  net shortwave surface flux (down minus up) (in watts/m**2)
! </OUT>

! <OUT NAME="surf_lw_down" TYPE="real, dimension(is:ie,js:je)" >
!  downward longwave surface flux (in watts/m**2)
! </OUT>

subroutine radiation (Time, t_surf, albedo, coszen, net_surf_sw_down, surf_lw_down)
!
type(time_type),      intent(in)                    :: Time
real,                 intent(in),    dimension(is:ie,js:je) :: t_surf, albedo
real,                 intent(out),   dimension(is:ie,js:je) :: coszen, net_surf_sw_down, surf_lw_down

integer :: j

real, dimension(is:ie,js:je) :: net_top_sw_down, top_lw_up, surf_lw_up
real, dimension(js:je) :: cosz, solar, incident_solar

integer :: year, month, day, hour, minute, second

if(seasonal_solar) then 
! Use spectral 2-layer model version
  call daily_mean_solar  (rad_lat, Time, cosz, solar) 
else
  cosz  = annual_cosz
  solar = annual_solar
endif
incident_solar =  solar_constant*solar

     if(debug_ebm_atm) then
 call get_date(Time, year, month, day, hour, minute, second)
     endif

do j = js, je

  net_top_sw_down  (:,j) = incident_solar(j)*(1.0 - atm_ref - (1.0 - atm_ref - atm_abs)*albedo(:,j))  
  net_surf_sw_down (:,j) = incident_solar(j)*(1.0 - atm_ref- atm_abs)*(1. - albedo(:,j))              
  top_lw_up        (:,j) = stefan*( tg     (:,j)      **4)                                           
  surf_lw_down     (:,j) = stefan*((tg     (:,j)+20.0)**4)                                         
  surf_lw_up       (:,j) = stefan*( t_surf (:,j)      **4)                                         

  dt_tg            (:,j) = dt_tg(:,j) +                                     &
                       ( + surf_lw_up     (:,j)                             &
                         - top_lw_up      (:,j) - surf_lw_down    (:,j)     &
                         + net_top_sw_down(:,j) - net_surf_sw_down(:,j) )/(cp_air*mass)

  coszen           (:,j) = cosz(j) 

     if(debug_ebm_atm) then
 if (mpp_pe() == 0 .and. hour+minute == 0 ) then
    print *,"radiation:Current time: year =",year," month = ",month," day = ",day, " j=",j
    write (stdout(),1000) incident_solar(j),albedo(ie,j),atm_ref,atm_abs
    write (stdout(),1000) tg(ie,j), qg(ie,j), net_top_sw_down(ie,j), net_surf_sw_down(ie,j)
    write (stdout(),1000) top_lw_up(ie,j), surf_lw_down(ie,j), surf_lw_up(ie,j), dt_tg(ie,j)
 endif
 1000 format(4(1x,e11.4))
      endif
enddo

call ebm_diagnostics_down(Time, top_lw_up, surf_lw_down, surf_lw_up, net_top_sw_down, net_surf_sw_down)

     if(debug_ebm_atm) then
 if (mpp_pe() == 0 .and. hour+minute == 0 ) then
    print *,"radiation aft diag:Current time: year =",year," month = ",month," day = ",day, " j=",j-1
    write (stdout(),1000) incident_solar(j-1),albedo(ie,j-1),atm_ref,atm_abs
    write (stdout(),1000) tg(ie,j-1), qg(ie,j-1), net_top_sw_down(ie,j-1), net_surf_sw_down(ie,j-1)
    write (stdout(),1000) top_lw_up(ie,j-1), surf_lw_down(ie,j-1), surf_lw_up(ie,j-1), dt_tg(ie,j-1)
 endif
      endif

return
end subroutine radiation
! </SUBROUTINE>


! ==================================================================================
! <SUBROUTINE NAME="precipitation">
!
! <OVERVIEW>
!    Precipiatation module for prognostic equation of atmospheric temperature
!     and specific humidity
! </OVERVIEW>

! <DESCRIPTION>
!    Precipiatation module for prognostic equation of atmospheric temperature
!     and specific humidity
!    The atmospheric tendency term (dt_tg) includes the latent heat flux released
!     during precipitation (tdel)
!    The specific humidity is the balance of evaporation and precipitation (dt_qg)
! </DESCRIPTION>

!   <TEMPLATE>
!     call   precipitation(lprec, fprec)
!   </TEMPLATE>

! <OUT NAME="lprec" TYPE="real, dimension(is:ie,js:je)" >
!  liquid precipitation rate (rain) in kg/m2/s
! </OUT>

! <OUT NAME="fprec" TYPE="real, dimension(is:ie,js:je)" >
!  frozen precipitation rate (snow) in kg/m2/s
! </OUT>

subroutine precipitation(lprec, fprec)

real, intent(out), dimension(is:ie,js:je) :: lprec, fprec
real,              dimension(is:ie,js:je) :: qsat, dqsat, tdel, qdel, &
                                             tg_temp, qg_temp
real :: hlcp, hfcp
integer :: i,j

integer :: year, month, day, hour, minute, second

tg_temp = tg + dt_tg*dt + t_bot_atm  
qg_temp = qg + dt_qg*dt

qsat   =       sat_mixing_ratio(tg_temp)   
dqsat  = deriv_sat_mixing_ratio(tg_temp)
! tfreeze - temperature where fresh water freezes 273.16 degK 
! hlv - Latent heat of evaporation J/kg
! hlf - latent heat of fusion      J/kg condensate
! cp_air  - specific heat of air at         J/kg air/K
hlcp   =  hlv       /cp_air
hfcp   = (hlv + hlf)/cp_air
! initialize precipiation to zero
lprec = 0.0
fprec = 0.0

where (qg_temp > qsat .and. tg_temp > tfreeze)
  qdel = (qsat - qg_temp)/(1.0 + hlcp*dqsat)
  tdel = -hlcp*qdel
  lprec = -qdel*mass/dt
elsewhere (qg_temp > qsat .and. tg_temp <= tfreeze)
  qdel = (qsat - qg_temp)/(1.0 + hfcp*dqsat)
  tdel = -hfcp*qdel
  fprec = -qdel*mass/dt
elsewhere
  qdel = 0.0
  tdel = 0.0
endwhere
dt_tg = dt_tg + tdel/dt
dt_qg = dt_qg + qdel/dt

     if(debug_ebm_atm) then
 if (mpp_pe() == 0 ) then
    print *,"in precip:"
    write (stdout(),1000)  qg_temp(ie,je), qsat(ie,je), tg_temp(ie,je), dqsat(ie,je)
    write (stdout(),1000) tg(ie,je), qg(ie,je), lprec(ie,je), fprec(ie,je)
    write (stdout(),1000) dt_tg(ie,je), dt_qg(ie,je), tdel(ie,je), qdel(ie,je)
 endif
 1000 format(4(1x,e11.4))
     endif

return
end subroutine precipitation
! </SUBROUTINE>

! ==================================================================================
! <SUBROUTINE NAME="diffusion">
!
! <OVERVIEW>
!    Lateral eddy diffusion module for prognostic equation of atmospheric temperature
!     and specific humidity
! </OVERVIEW>

! <DESCRIPTION>
!    Lateral eddy diffusion module for prognostic equation of atmospheric temperature
!     and specific humidity
!    There are two options: uniform or variable diffusion
! </DESCRIPTION>

!   <TEMPLATE>
!     call diffusion()
!   </TEMPLATE>

subroutine diffusion  

real   , dimension (ms:me,ns:ne) :: eigen, denom 
complex, dimension (ms:me,ns:ne) :: dxs, dys, div
real   , dimension (is:ie,js:je) :: dxg, dyg, d

integer :: m, n

! real :: nu = 4.0e16

call trans_grid_to_spherical(dt_tg, dt_ts)
call trans_grid_to_spherical(dt_qg, dt_qs)

call get_eigen_laplacian(eigen)

if(diff_is_uniform) then

  dt_ts = dt_ts - diff*eigen*ts
  dt_qs = dt_qs - diff*eigen*qs

else

  d = diffusivity()  

! temperature

  call compute_gradient_cos(ts, dxs, dys)

  call trans_spherical_to_grid(dxs,dxg)
  call trans_spherical_to_grid(dys,dyg)

  dxg = d*dxg
  dyg = d*dyg

  call divide_by_cos2(dxg)
  call divide_by_cos2(dyg)

  call trans_grid_to_spherical(dxg,dxs)
  call trans_grid_to_spherical(dyg,dys)

  div = compute_div(dxs, dys)
  call triangular_truncation(div)

  dt_ts = dt_ts + div

! water vapor

  call compute_gradient_cos(qs, dxs, dys)

  call trans_spherical_to_grid(dxs,dxg)
  call trans_spherical_to_grid(dys,dyg)

  dxg = d*dxg
  dyg = d*dyg

  call divide_by_cos2(dxg)
  call divide_by_cos2(dyg)

  call trans_grid_to_spherical(dxg,dxs)
  call trans_grid_to_spherical(dyg,dys)

  div = compute_div(dxs, dys)
  call triangular_truncation(div)

  dt_qs = dt_qs + div

endif


dt_ts = dt_ts - nu*eigen*eigen*ts
dt_qs = dt_qs - nu*eigen*eigen*qs


denom = 1./(1.0 + (diff*eigen + nu*eigen*eigen)*dt)

ts = ts + denom*dt*dt_ts
qs = qs + denom*dt*dt_qs

call trans_spherical_to_grid(ts,tg)
call trans_spherical_to_grid(qs,qg)

     if(debug_ebm_atm) then
 if (mpp_pe() == 0 ) then
    print *,"diffusion:"
    write (stdout(),1000) tg(ie,je), qg(ie,je), denom(me,ne), eigen(me,ne)
    write (stdout(),1000) ts(me,ne), qs(me,ne), dt_qs(me,ne), dt_ts(me,ne)
 endif
 1000 format(4(1x,e11.4))
      endif

return
end subroutine diffusion
! </SUBROUTINE>

! ==================================================================================
! <FUNCTION NAME="diffusivity">
!
! <OVERVIEW>
!  For the a given scalar diffusion coefficient the routine returns an array
! </OVERVIEW>

! <DESCRIPTION>
!  For the a given scalar diffusion coefficient the routine returns an array
! </DESCRIPTION>

!   <TEMPLATE>
!     d = diffusivity()
!   </TEMPLATE>

function diffusivity() result(d)

real, dimension(is:ie,js:je) :: d
d = diff

return
end function diffusivity
! </FUNCTION>


!#######################################################################
! <FUNCTION NAME="sat_mixing_ratio">
!
! <OVERVIEW>
!  For the given temperatures routine returns the saturation mixing ratio
!   esat - saturation vapor pressure
! </OVERVIEW>
!   <TEMPLATE>
!     q = sat_mixing_ratio(t)
!   </TEMPLATE>
! <DESCRIPTION>
!  For the given temperatures routine returns the saturation mixing ratio
!   esat - saturation vapor pressure
! </DESCRIPTION>

function sat_mixing_ratio(t) result(q)

real, dimension(is:ie,js:je) :: t, q, esat

call escomp (t, esat)
q = d622*esat/1.e05   

return
end function sat_mixing_ratio
! </FUNCTION>

! ==================================================================================
! <FUNCTION NAME="deriv_sat_mixing_ratio">
!
! <OVERVIEW>
!  For the given temperatures, routine returns the derivative of the  saturation mixing ratio
! </OVERVIEW>

! <DESCRIPTION>
!  For the given temperatures, routine returns the derivative of the  saturation mixing ratio
! </DESCRIPTION>

!   <TEMPLATE>
!     q = deriv_sat_mixing_ratio(t)
!   </TEMPLATE>
function deriv_sat_mixing_ratio(t) result(q)

real, dimension(is:ie,js:je) :: t, q, desat

call descomp (t, desat)
q = d622*desat/1.e05   

return
end function deriv_sat_mixing_ratio
! </FUNCTION>

! ==================================================================================
! <SUBROUTINE NAME="get_bottom_mass">
!
! <OVERVIEW>
! returns temp, sphum, pres, height at the lowest model level
!         and surface pressure
! </OVERVIEW>

! <DESCRIPTION>
!  public routine required for atmospheric components of coupled models
!  returns temp, sphum, pres, height at the lowest model level
!         and surface pressure
! </DESCRIPTION>

!   <TEMPLATE>
!     call get_bottom_mass (t_bot_out, q_bot_out, p_bot, z_bot, p_surf)
!   </TEMPLATE>

!   <OUT NAME="t_bot_out" TYPE="real">
!                near surface temperature in degrees Kelvin
!   </OUT>

!   <OUT NAME="q_bot_out" TYPE="real">
!                near surface mixing  ratio
!   </OUT>

!   <OUT NAME="p_bot" TYPE="real">
!                 pressure at which atmos near usrface values are assumed to be defined
!   </OUT>

!   <OUT NAME="z_bot" TYPE="real">
!                 height at which atmos near usrface values are assumed to be defined
!   </OUT>

!   <OUT NAME="p_surf" TYPE="real">
!                 surface pressure
!   </OUT>

subroutine get_bottom_mass (t_bot_out, tr_bot_out, p_bot, z_bot, p_surf, slp)
real, intent(out), dimension(is:ie,js:je) :: t_bot_out, p_bot, z_bot, p_surf, slp
real, intent(out), dimension(:,:,:) :: tr_bot_out

p_surf    = 1000.0e02   ! surface pressure
p_bot     = 990.0e02    ! pressure at which atmos near usrface values are assumed to be defined
z_bot     = 100.0       !   height at which atmos near surface values are assumed to be defined
t_bot_out = t_bot(is:ie,js:je)       ! near surface temperature
tr_bot_out(:,:,1) = q_bot(is:ie,js:je)       ! near surface mixing ratio
slp = p_surf

return
end subroutine get_bottom_mass
! </SUBROUTINE>

! ==================================================================================
! <SUBROUTINE NAME="get_bottom_wind">
!
! <OVERVIEW>
! returns u and v on the mass grid at the lowest model level
! </OVERVIEW>

! <DESCRIPTION>
!  public routine required for atmospheric components of coupled models
!  returns u and v on the mass grid at the lowest model level
! </DESCRIPTION>

!   <TEMPLATE>
!     call get_bottom_wind (u_bot_out, v_bot_out)
!   </TEMPLATE>

!   <OUT NAME="u_bot"  TYPE="real" >
!    near surface zonal      wind
!   </OUT>

!   <OUT NAME="v_bot"  TYPE="real" >
!    near surface meridional wind
!   </OUT>

subroutine get_bottom_wind (u_bot_out, v_bot_out)
real, intent(out), dimension(is:ie,js:je) :: u_bot_out, v_bot_out

u_bot_out = u_bot(is:ie,js:je)   ! near surface zonal      wind
v_bot_out = v_bot(is:ie,js:je)   ! near surface meridional wind

return
end subroutine get_bottom_wind
! </SUBROUTINE>

! ==================================================================================
! <SUBROUTINE NAME="atmosphere_resolution">
! <OVERVIEW>
!    returns the number of longitude and latitude grid points
!    for either the local PEs grid (default) or the global grid
! </OVERVIEW>

! <DESCRIPTION>
!  public routine required for atmospheric components of coupled models
!    returns the number of longitude and latitude grid points
!    for either the local PEs grid (default) or the global grid
! </DESCRIPTION>

! <TEMPLATE>
!   call  atmosphere_resolution(num_lon_out, num_lat_out, global)
! </TEMPLATE>

! <OUT NAME="num_lon_out" TYPE="integer">
!  The number of longitude points in the compute domain.
! </OUT>

! <OUT NAME="num_lat_out" TYPE="integer">
!  The number of latitude points in the compute domain.
! </OUT>

! <IN NAME="global" TYPE="logical,optional">
!  Flag that specifies whether the returned compute domain size is
!  for the global grid (TRUE) or for the current processor (FALSE).
! </IN>

subroutine atmosphere_resolution(num_lon_out, num_lat_out, global)
 
integer, intent(out)          :: num_lon_out, num_lat_out
logical, intent(in), optional :: global
logical :: global_tmp

if (present(global)) then
  global_tmp = global
else
  global_tmp = .false.
endif

if(global_tmp) then
  num_lon_out = lon_max
  num_lat_out = lat_max
else
  num_lon_out = ie+1-is
  num_lat_out = je+1-js
endif

return
end subroutine atmosphere_resolution
! </SUBROUTINE>

! ==================================================================================
! <SUBROUTINE NAME="get_atmosphere_axes">
!
! <OVERVIEW>
!    returns the axis indices associated with the coupling grid
! </OVERVIEW>

! <DESCRIPTION>
!  public routine required for atmospheric components of coupled models
!    returns the axis indices associated with the coupling grid
! </DESCRIPTION>

! <TEMPLATE>
!     call  get_atmosphere_axes(axes_out)
! </TEMPLATE>

! <OUT NAME="axes_out" TYPE="integer,dimension(:)" >
!  The axis identifiers for the atmospheric grids.
!  The size of axes must be least 1 but not greater than 4.
!  The axes are returned in the order (/ x, y, p_full, p_half /)
!</OUT>

subroutine get_atmosphere_axes(axes_out)
integer, intent(out), dimension(:) :: axes_out

axes_out = axis_id

return
end subroutine get_atmosphere_axes
! </SUBROUTINE>

! ==================================================================================
! <SUBROUTINE NAME="atmosphere_boundary">
! <OVERVIEW>
!    returns the longitude and latitude grid box edges
!    for either the local PEs grid (default) or the global grid
! </OVERVIEW>
! <DESCRIPTION>
!  public routine required for atmospheric components of coupled models
!    returns the longitude and latitude grid box edges
!    for either the local PEs grid (default) or the global grid
! </DESCRIPTION>

! <TEMPLATE>
!   call atmosphere_boundary(lon_boundaries, lat_boundaries, global)
! </TEMPLATE>

! <OUT NAME = "lon_boundaries" TYPE = "real,dimension(:,:)"> 
!  The west-to-east longitude edges of grid boxes (in radians).
! </OUT>

! <OUT NAME = "lat_boundaries" TYPE = "real,dimension(:,:)"> 
!  The south-to-north latitude edges of grid boxes (in radians).
! </OUT>

! <IN NAME="global" TYPE="logical, optional">
!  Flag that specifies whether the returned grid box edges are
!  for the global grid (TRUE) or for the current processor (FALSE).
! </IN>
subroutine atmosphere_boundary(lon_boundaries, lat_boundaries, global)

real,    intent(out), dimension(:,:) :: lon_boundaries, lat_boundaries
logical, intent(in),  optional     :: global
real, dimension(size(lon_boundaries,1)) :: tmpx
real, dimension(size(lon_boundaries,2)) :: tmpy
integer :: i
logical :: global_tmp


if(present(global)) then
  global_tmp = global
else
  global_tmp = .false.
endif
call get_grid_boundaries(tmpx, tmpy, global_tmp)

do i = 1, size(lon_boundaries,2)
  lon_boundaries(:,i) = tmpx(:)
end do

do i = 1, size(lon_boundaries,1)
  lat_boundaries(i,:) = tmpy(:)
end do

return
end subroutine atmosphere_boundary
! </SUBROUTINE>

! ==================================================================================
! <SUBROUTINE NAME="atmosphere_cell_area">
!
! <OVERVIEW>
!   returns grid cell areas for the domain
! </OVERVIEW>
!
! <DESCRIPTION>
!   returns grid cell areas for the domain
! </DESCRIPTION>

 subroutine atmosphere_cell_area(area_out)
 real, dimension(:,:),  intent(out) :: area_out
 integer :: xsize, ysize, j
 real, dimension(size(area_out,2)) :: wts_lat

 xsize = ie-is+1
 ysize = je-js+1
 if(any(shape(area_out) /= (/xsize,ysize/))) then
   call mpp_error(FATAL,'atmosphere_cell_area: argument has wrong shape. Its shape is ', &
     shape(area_out),'  It should be ',(/xsize,ysize/))
 endif

 call get_wts_lat(wts_lat)
 do j=1,ysize
   area_out(:,j) = 2*PI*radius*radius*wts_lat(j)/lon_max
 enddo

 end subroutine atmosphere_cell_area

! </SUBROUTINE>

! ==================================================================================
! <SUBROUTINE NAME="atmosphere_domain">
!
! <OVERVIEW>
!    returns the domain2d variable associated with the coupling grid
! </OVERVIEW>
!
! <DESCRIPTION>
!  public routine required for atmospheric components of coupled models
!    returns the domain2d variable associated with the coupling grid
!  note: coupling is done using the mass/temperature grid with no halos
!
!OUTPUT
!  Domain   The domain2d variable describing the grid used for coupling.
!           For the B-grid, this corresponds to the temperature grid
!           without halos.
! </DESCRIPTION>

! <TEMPLATE>
!     call atmosphere_domain(domain)
! </TEMPLATE>

! <INOUT NAME="domain" TYPE="type (domain2d)">
!  The domain2d variable describing the grid used for coupling.
!  For the B-grid, this corresponds to the temperature grid
!  without halos.
! </INOUT>

subroutine atmosphere_domain(domain)

type (domain2d), intent(inout) :: domain

   
domain = grid_domain;
   
end subroutine atmosphere_domain
! </SUBROUTINE>

! =====================================================================
! <SUBROUTINE NAME="atmosphere_end">
!
! <OVERVIEW>
!  write out restart file
!  Termination routine for atmosphere_mod.
! </OVERVIEW>
! <DESCRIPTION>
!  public routine required for atmospheric components of coupled models
!  write out restart file
!  Termination routine for atmosphere_mod.
! </DESCRIPTION>

! <TEMPLATE>
!     call atmosphere_end(Time, Grid_box)
! </TEMPLATE>

! <IN NAME="Time" TYPE="type(time_type)">
!  time at the current time level (tau)
! </IN>

! <INOUT NAME="Grid_box" TYPE="type(grid_box_type)">
!   Contains information about the grid cells 
! </INOUT>

subroutine atmosphere_end(Time, Grid_box)

type(time_type), intent(in) :: Time
type(grid_box_type), intent(inout) :: Grid_box
integer :: time_level,seconds,days,unit
character(len=64)            :: filename

if(.not.module_is_initialized) then
  call error_mesg('atmosphere_end',' atmosphere_init has not been called.', FATAL)
end if

!--- write out restart file
filename = 'RESTART/atmosphere.res.nc'

call write_data(filename, 'ts_real', real(ts), spectral_domain)
call write_data(filename, 'ts_imag', aimag(ts), spectral_domain)
call write_data(filename, 'qs_real', real(qs), spectral_domain)
call write_data(filename, 'qs_imag', aimag(qs), spectral_domain)
call write_data(filename, 'tg', tg, grid_domain)
call write_data(filename, 'qg', qg, grid_domain)

return
end subroutine atmosphere_end
! </SUBROUTINE>

  !#######################################################################
  ! <SUBROUTINE NAME="atmosphere_restart">
  ! <DESCRIPTION>
  !  dummy routine.
  ! </DESCRIPTION>
  subroutine atmosphere_restart(timestamp)
    character(len=*),  intent(in) :: timestamp

    call error_mesg ('atmosphere_restart in atmosphere_mod', &
                     'intermediate restart capability is not implemented for this model', FATAL)

  end subroutine atmosphere_restart
  ! </SUBROUTINE>

! =====================================================================
! <SUBROUTINE NAME="get_stock_pe">
!
! <OVERVIEW>
!  Not implemented properly. Puts value=0
! </OVERVIEW>
! <DESCRIPTION>
!  This is a stub routine needed for compilation of mom4_test6.
!  It puts value=0 for any index.
! </DESCRIPTION>

! <TEMPLATE>
!     call get_stock_pe(index, value)
! </TEMPLATE>

! <IN NAME="index" TYPE="integer">
! </IN>
! <OUT NAME="value" TYPE="real">
! </OUT>

subroutine get_stock_pe(index, value)
  use stock_constants_mod, only : ISTOCK_WATER, ISTOCK_HEAT
  integer, intent(in) :: index
  real, intent(out)   :: value

  select case (index)

  case (ISTOCK_WATER)
     ! don't know how to compute water stock
     value = 0

  case (ISTOCK_HEAT)
     ! don't know how to compute water stock
     value = 0

  case default
     value = 0.0
  end select

end subroutine get_stock_pe

! ==================================================================================
! ==================================================================================

end module atmosphere_mod

                       module nonfms_donner_mod

use  sat_vapor_pres_k_mod, only: sat_vapor_pres_init_k ! replace with 
                                                     ! non-FMS interface
use donner_types_mod,       only: donner_initialized_type, &
                                  donner_save_type, donner_rad_type, &
                                  donner_nml_type, donner_param_type, &
                                  donner_budgets_type, &
                                  donner_column_diag_type, &
                                  MAXMAG, MAXVAL, MINMAG, MINVAL, &
                                  DET_MASS_FLUX, MASS_FLUX,  &
                                  CELL_UPWARD_MASS_FLUX, TEMP_FORCING, &
                                  MOIST_FORCING, PRECIP,  FREEZING, &
                                  RADON_TEND, &
                                  donner_conv_type, donner_cape_type, &
                                  donner_cem_type

implicit none
private

!--------------------------------------------------------------------
!        donner_deep_mod diagnoses the location and computes the 
!        effects of deep convection on the model atmosphere
!--------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------


character(len=128)  :: version =  '$Id: nonfms_donner.F90,v 19.0 2012/01/06 20:08:40 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!--------------------------------------------------------------------
!---interfaces------

public   &
        nonfms_donner_process_nml,  nonfms_donner_process_tracers, &
        nonfms_donner_process_monitors, &
        nonfms_donner_activate_diag, nonfms_donner_read_restart,&
        nonfms_donner_col_diag, nonfms_donner_write_restart, &
        nonfms_donner_column_control, nonfms_donner_deep_netcdf,    &
        nonfms_sat_vapor_pres, nonfms_get_pe_number, nonfms_error_mesg,&
        nonfms_close_col_diag_units, &
        nonfms_deallocate_variables, nonfms_constants

private   &
!  module subroutines called during initialization:
        process_coldstart


!---------------------------------------------------------------------
!---namelist----

# include "donner_nml.h"


!--------------------------------------------------------------------
!--- public data ----------




!--------------------------------------------------------------------
!----private data-----------








!-----------------------------------------------------------------------
!   miscellaneous variables
!


!-----------------------------------------------------------------------
!-----------------------------------------------------------------------


                          contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                   PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!#####################################################################

subroutine nonfms_donner_process_nml  (Nml, kpar)

!---------------------------------------------------------------------
!    nonfms_donner_process_nml si intended to process the 
!    donner_deep_nml file, using the procedure of the nonFMS model.
!    for now, default values are reset here within the Fortran source
!    and no nml read is done.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
type(donner_nml_type), intent(inout)    :: Nml
integer,               intent(in)       :: kpar

!---------------------------------------------------------------------
!  intent(in) variables:
!
!
!-------------------------------------------------------------------

!-------------------------------------------------------------------
!  local variables:

     real, dimension(:), allocatable :: erat_loc, arat_loc
  
!-------------------------------------------------------------------
!  local variables:
!
!                         
!-------------------------------------------------------------------

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    1. READ NAMELIST AND WRITE IT TO LOG FILE.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!--------------------------------------------------------------------
!    here non-default values are reset (as desired) within the Fortran 
!    source. note that changes to arat / erat are handled at the end of
!    this subroutine.
!--------------------------------------------------------------------
!  THESE SETTINGS MAY BE USED FOR DONNER_LITE:
!    SETTINGS USED IN DATABASE EXPT C48L24_AM3p5-gamma-B6:
       parcel_launch_level = 2
       model_levels_in_sfcbl = 0
       donner_deep_freq = 1800
       allow_mesoscale_circulation = .true.
       do_donner_cape    = .false.
       do_donner_plume   = .false.
       do_donner_closure = .false.
       do_donner_lscloud = .true.
       do_dcape          = .false.
       do_lands          = .false.
       do_freezing_for_cape = .true.
       do_freezing_for_closure = .true.
       gama              = 0.0
       tau               = 28800.
       tke0              = 0.5
       cape0             = 1000.
       lochoice          = 10
       do_capetau_land   = .false.
       use_llift_criteria= .false.
       do_ice            = .true.
       atopevap  = 0.1
       auto_rate = 1.e-3
       auto_th   = 0.5e-3
       frac      = 1.65
       ttend_max = 0.005

       EVAP_IN_DOWNDRAFTS  = 0.00
       EVAP_IN_ENVIRON     = 0.00
       ENTRAINED_INTO_MESO = 1.00

       ANVIL_PRECIP_EFFICIENCY = 0.85
       MESO_DOWN_EVAP_FRACTION = 0.1
       MESO_UP_EVAP_FRACTION   = 0.05

       wmin_ratio      = 0.05
       arat(1:7) =  (/ 1.0, 0.26, 0.35, 0.32, 0.3, 0.54, 0.66 /)
       erat(1:7) =  (/ 1.0, 1.30, 1.80, 2.50, 3.3, 4.50, 10.0 /)
       frc_internal_enthalpy_conserv = .true.
       limit_pztm_to_tropo = .true.
 
!  THESE SETTINGS MAY BE USED FOR DONNER_FULL:
!      parcel_launch_level = 2
!      donner_deep_freq = 1800
!      allow_mesoscale_circulation = .true.
!      do_donner_cape    = .true.
!      do_donner_plume   = .true.
!      do_donner_closure = .true.
!      do_donner_lscloud = .true.
!      do_dcape          = .true.
!      do_freezing_for_cape = .false.
!      do_freezing_for_closure = .false.
!      gama              = 0.0
!      lochoice          = 10
!      use_llift_criteria= .true.
!      EVAP_IN_DOWNDRAFTS  = 0.25
!      EVAP_IN_ENVIRON     = 0.13
!      ENTRAINED_INTO_MESO = 0.62

!      ANVIL_PRECIP_EFFICIENCY = 0.5
!      MESO_DOWN_EVAP_FRACTION = 0.4
!      MESO_UP_EVAP_FRACTION   = 0.1 

!      wmin_ratio      = 0.05
!      arat(1:7) =  (/ 1.0, 0.26, 0.35, 0.32, 0.3, 0.54, 0.3 /)
!      erat(1:7) =  (/ 1.0, 1.30, 1.80, 2.50, 3.3, 4.50, 6.5 /)
!      frc_internal_enthalpy_conserv = .true.
!      limit_pztm_to_tropo = .true.

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    8. STORE THE NAMELIST VARIABLES THAT NEED TO BE MADE AVAILABLE 
!       OUTSIDE OF THIS MODULE INTO THE DONNER_NML_TYPE VARIABLE.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

      Nml%parcel_launch_level         = parcel_launch_level
      Nml%allow_mesoscale_circulation = allow_mesoscale_circulation
      Nml%do_hires_cape_for_closure   = do_hires_cape_for_closure
      Nml%do_donner_cape              = do_donner_cape    !miz
      Nml%do_donner_plume             = do_donner_plume   !miz
      Nml%do_donner_closure           = do_donner_closure !miz
      Nml%do_dcape                    = do_dcape          !miz
      Nml%do_lands                    = do_lands          !miz
      Nml%tau                         = tau               !miz
      Nml%cape0                       = cape0             !miz
      Nml%rhavg0                      = rhavg0            !miz
      Nml%plev0                       = plev0             !miz
      Nml%do_rh_trig                  = do_rh_trig        !miz
      Nml%do_capetau_land             = do_capetau_land   !miz
      Nml%pblht0                      = pblht0            !miz
      Nml%tke0                        = tke0              !miz
      Nml%lofactor0                   = lofactor0         !miz
      Nml%deephgt0                    = deephgt0          !miz
      Nml%lochoice                    = lochoice          !miz
      Nml%deep_closure                = deep_closure      !miz
      Nml%gama                        = gama              !miz
      Nml%do_ice                      = do_ice            !miz
      Nml%atopevap                    = atopevap          !miz
      Nml%do_donner_lscloud           = do_donner_lscloud !miz
      Nml%auto_rate                   = auto_rate         !miz
      Nml%auto_th                     = auto_th           !miz
      Nml%frac                        = frac              !miz
      Nml%ttend_max                   = ttend_max         !miz
      Nml%mesofactor                  = mesofactor        !miz
      Nml%use_llift_criteria          = use_llift_criteria
      Nml%use_pdeep_cv                = use_pdeep_cv
      Nml%entrainment_constant_source = entrainment_constant_source
      Nml%donner_deep_freq            = donner_deep_freq             
      Nml%model_levels_in_sfcbl       = model_levels_in_sfcbl        
      Nml%cell_liquid_size_type       = cell_liquid_size_type 
      Nml%cell_ice_size_type          = cell_ice_size_type
      Nml%cell_liquid_eff_diam_input  = cell_liquid_eff_diam_input
      Nml%cell_ice_geneff_diam_input  = cell_ice_geneff_diam_input
      Nml%meso_liquid_eff_diam_input  = meso_liquid_eff_diam_input
      Nml%do_average                  = do_average
      Nml%use_memphis_size_limits     = use_memphis_size_limits
      Nml%wmin_ratio                  = wmin_ratio
      Nml%do_freezing_for_cape         = do_freezing_for_cape
      Nml%tfre_for_cape               = tfre_for_cape
      Nml%dfre_for_cape               = dfre_for_cape
      Nml%rmuz_for_cape               = rmuz_for_cape
      Nml%do_freezing_for_closure     = do_freezing_for_closure
      Nml%tfre_for_closure            = tfre_for_closure
      Nml%dfre_for_closure            = dfre_for_closure
      Nml%rmuz_for_closure            = rmuz_for_closure
      Nml%do_budget_analysis          = do_budget_analysis
      Nml%frc_internal_enthalpy_conserv =  &
                                 frc_internal_enthalpy_conserv
      Nml%do_ensemble_diagnostics     = do_ensemble_diagnostics
      Nml%limit_pztm_to_tropo = limit_pztm_to_tropo
      Nml%entrainment_scheme_for_closure =   &
                                        entrainment_scheme_for_closure
      Nml%modify_closure_plume_condensate =   &
                                       modify_closure_plume_condensate
      Nml%closure_plume_condensate = closure_plume_condensate

      Nml%evap_in_downdrafts = evap_in_downdrafts
      Nml%evap_in_environ  = evap_in_environ
      Nml%entrained_into_meso = entrained_into_meso
      Nml%anvil_precip_efficiency = anvil_precip_efficiency
      Nml%meso_down_evap_fraction = meso_down_evap_fraction
      Nml%meso_up_evap_fraction = meso_up_evap_fraction
      Nml%cdeep_cv = cdeep_cv

!---------------------------------------------------------------------
!  if mods are desired for arat / erat when these values are being
!  specified (option = 0), make them to arat_loc / erat_loc. these
!  will be transferred to arat / erat later. if arat / erat come from
!  optional formulae, they will be calculated here used nml-supplied
!  input values.
!---------------------------------------------------------------------
      allocate (arat_loc(kpar))
      allocate (erat_loc(kpar))
 
      if (arat_erat_option == 0) then
        arat_loc = arat
        erat_loc = erat
      else
        call define_arat_erat (arat_erat_option, kpar, eratb, erat0, &
                               erat_min, erat_max,erat_loc,arat_loc)
        print *,'donner_deep_nml: redefined arat and erat using &
                          &arat_erat_option == ', arat_erat_option
        print *,'donner_deep_nml: arat = ',arat_loc
        print *,'donner_deep_nml: erat = ',erat_loc
      endif
      allocate (Nml%arat(kpar))
      allocate (Nml%ensemble_entrain_factors_gate(kpar)) 

      Nml%arat = arat_loc
      Nml%ensemble_entrain_factors_gate = erat_loc

      deallocate (arat_loc, erat_loc)

end subroutine nonfms_donner_process_nml



!#####################################################################

subroutine nonfms_donner_process_tracers 


      return



end subroutine nonfms_donner_process_tracers



!#####################################################################

subroutine nonfms_donner_process_monitors


      return



end subroutine nonfms_donner_process_monitors


!#####################################################################

subroutine nonfms_donner_activate_diag (secs, days, axes, &
                     Don_save, Nml, n_water_budget, n_enthalpy_budget, &
                   n_precip_paths, n_precip_types, nlev_hires, kpar)

integer, intent(in) :: secs, days, n_water_budget,  &
                   n_enthalpy_budget, n_precip_paths, n_precip_types, &
                   nlev_hires, kpar
integer,         dimension(4),   intent(in)   :: axes
type(donner_save_type), intent(inout) :: Don_save
type(donner_nml_type), intent(inout) :: Nml       


!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    4. INITIALIZE THE NETCDF OUTPUT VARIABLES.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!--------------------------------------------------------------------
!    activate the netcdf diagnostic fields.
!-------------------------------------------------------------------
!     call register_fields (secs, days, axes, Don_save, Nml)


end subroutine nonfms_donner_activate_diag 


!#####################################################################

subroutine nonfms_donner_read_restart (Initialized, ntracers,   &
                                    secs, days, Don_save, Nml)

type(donner_initialized_type), intent(inout) :: Initialized
type(donner_save_type), intent(inout) :: Don_save
type(donner_nml_type), intent(inout) :: Nml     
integer, intent(in) :: secs, days, ntracers



!--------------------------------------------------------------------
!    if no restart file is present, call subroutine process_coldstart
!    to define the needed variables.
!--------------------------------------------------------------------
      call process_coldstart (secs, days, Initialized, Nml, Don_save)


end subroutine nonfms_donner_read_restart 


!#####################################################################

subroutine nonfms_donner_col_diag (lonb, latb, Col_diag, pref) 

real, dimension(:,:), intent(in) :: lonb, latb
type(donner_column_diag_type), intent(inout) :: Col_diag
real, dimension(:), intent(in) :: pref


!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    6. INITIALIZE VARIABLES NEEDED FOR COLUMN_DIAGNOSTICS_MOD OUTPUT.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!---------------------------------------------------------------------
!    define the total number of columns for which diagnostics
!    are desired.
!---------------------------------------------------------------------
      Col_diag%num_diag_pts = num_diag_pts_ij + num_diag_pts_latlon

!---------------------------------------------------------------------
!    initialize the value of the k index associated with diagnostics
!    cutoff.
!---------------------------------------------------------------------
      Col_diag%kstart = -99



end subroutine nonfms_donner_col_diag 




!#####################################################################

subroutine nonfms_donner_write_restart (ntracers, Don_save,  &
                                        Initialized, Nml)

integer, intent(in) :: ntracers
type(donner_initialized_type), intent(inout) :: Initialized
type(donner_save_type), intent(inout) :: Don_save
type(donner_nml_type), intent(inout) :: Nml     

!-------------------------------------------------------------------
!    call subroutine to write restart file. 
!-------------------------------------------------------------------

      return


end subroutine nonfms_donner_write_restart 


!#####################################################################

subroutine nonfms_get_pe_number (me, root_pe)
 
!--------------------------------------------------------------------
!    define pe number (needed for column diagnostics and as dummy arg-
!    ument for donner_lite diagnostics). For now, column
!    diagnostics are unavailable outside of FMS, so the value is set 
!    to 0 for all pes. 
!--------------------------------------------------------------------

integer, intent(out) :: me, root_pe
   
      me = 0
      root_pe = 0

end subroutine nonfms_get_pe_number




!#####################################################################

subroutine nonfms_error_mesg (ermesg)   
                             
character(len=*), intent(in) :: ermesg     

 
!    call error_mesg ('donner_deep_mod', ermesg, FATAL)
!!  NOTE POTENTIAL HANG HERE : USE APPROPRIATE ERROR EXIT ON NONFMS
!!  SYSTEM RATHER THAN 'STOP'
    print *, 'STOPPING DUE TO ERROR:', ermesg
    stop 

 

 
end subroutine nonfms_error_mesg




!#####################################################################

subroutine nonfms_close_col_diag_units 

      return

end subroutine nonfms_close_col_diag_units 



!#####################################################################

subroutine nonfms_deallocate_variables

      return 




end subroutine nonfms_deallocate_variables

!######################################################################

subroutine nonfms_sat_vapor_pres
 
!---------------------------------------------------------------------
!    should contain needed calls to initialize nonfms saturation
!    vapor pressure calculation. currently uses fms interface to allow
!    testing.
!---------------------------------------------------------------------

integer, parameter :: TCMIN = -160
integer, parameter :: TCMAX = 100
integer, parameter :: ESRES = 10
real,    parameter :: HLV = 2.500e6   
real,    parameter :: ES0 = 1.0 
real,    parameter :: RVGAS = 461.50 
integer, parameter :: NSIZE = (TCMAX-TCMIN)*esres + 1
integer, parameter :: NLIM = NSIZE - 1
real, parameter :: TFREEZE = 273.16
logical, parameter :: use_exact_qs_input = .true.
logical, parameter :: do_simple = .false.
logical, parameter :: construct_table_wrt_liq = .false.
logical, parameter :: construct_table_wrt_liq_and_ice = .false.

      real  :: teps, tmin, dtinv
      character(len=128) :: err_msg
!     logical :: dum = .false.

      call sat_vapor_pres_init_k (NSIZE, REAL(TCMIN), REAL(TCMAX), &
                             TFREEZE, HLV, RVGAS, ES0, err_msg,  &
                             use_exact_qs_input, do_simple,  &
                             construct_table_wrt_liq, &
                             construct_table_wrt_liq_and_ice, &
                             teps, tmin, dtinv)
 

end subroutine nonfms_sat_vapor_pres




!######################################################################

subroutine nonfms_constants (Param)

type(donner_param_type), intent(inout)  :: Param


!----------------------------------------------------------------------
!    define the components of Param that come from the fms module
!    constants_mod. see donner_types.h for their definitions.
!----------------------------------------------------------------------
      Param%dens_h2o        = 1000.    
      Param%rdgas           = 287.04
      Param%kappa           = 2. / 7.
      Param%grav            = 9.80 
      Param%cp_air          = Param%rdgas/ Param%kappa
      Param%pie             = 3.14159265358979323846
      Param%rvgas           = 461.5
      Param%seconds_per_day = 86400.          
      Param%hlv             = 2.500e+06
      Param%hlf             = 3.34e+05
      Param%hls             = Param%hlv + Param%hlf
      Param%kelvin          = 273.15 

!----------------------------------------------------------------------


end subroutine nonfms_constants


!######################################################################


 subroutine nonfms_donner_column_control (is, ie, js, je, secs,  &
                                          days, Col_diag)               

!---------------------------------------------------------------------
!    subroutine fms_donner_column_control returns the number, location
!    (processor and window indices) and output units associated with 
!    any diagnostic columns requested within the current physics window.
!---------------------------------------------------------------------

integer,                       intent(in)   :: is, ie, js, je
integer,                       intent(in) :: secs, days
type(donner_column_diag_type), intent(inout) :: Col_diag
      
      return     
 
end subroutine nonfms_donner_column_control



subroutine nonfms_donner_deep_netcdf 



      return



end subroutine nonfms_donner_deep_netcdf 


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                   PRIVATE SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!      1. ROUTINES CALLED BY DONNER_DEEP_INIT
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!#####################################################################
 



!####################################################################


!#####################################################################

subroutine process_coldstart (secs, days, Initialized, Nml, Don_save)

!-----------------------------------------------------------------------
!    subroutine process_coldstart provides initialization that is needed
!    when the job is a donner_deep coldstart, or if the user-supplied 
!    restart file is not usable for a restart with the current code 
!    version.
!-----------------------------------------------------------------------

integer, intent(in) :: secs, days
type(donner_initialized_type), intent(inout) :: Initialized
type(donner_save_type), intent(inout) :: Don_save
type(donner_nml_type), intent(inout) :: Nml     

!---------------------------------------------------------------------
!   intent(in) variables:
!
!
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!   local variables:


!---------------------------------------------------------------------
!    set the coldstart flag to .true.. set the time until the first cal-
!    culation call to donner_deep_mod, donner_deep calculation calls will
!    be every donner_deep_freq seconds after the start of the day.
!---------------------------------------------------------------------
      Initialized%coldstart = .true.
      if (secs == 0) then    ! i.e., 00Z
        Initialized%conv_alarm = Nml%donner_deep_freq
      else 
        Initialized%conv_alarm = Nml%donner_deep_freq -   &
                                 MOD (secs, Nml%donner_deep_freq)
      endif

!----------------------------------------------------------------------
!    initialize the variables which must be returned from donner_deep_mod
!    on the first step when coldstarting.
!----------------------------------------------------------------------
      Don_save%cemetf            = 0.
      Don_save%cememf            = 0.
      Don_save%tracer_tends      = 0.
      Don_save%mass_flux         = 0.
      Don_save%mflux_up          = 0.
      Don_save%cell_up_mass_flux = 0.
      Don_save%det_mass_flux     = 0.
      Don_save%dql_strat         = 0.
      Don_save%dqi_strat         = 0.
      Don_save%dqa_strat         = 0.
      Don_save%humidity_area     = 0.
      Don_save%humidity_factor   = 0.
      Don_save%tprea1            = 0.
      Don_save%parcel_disp       = 0.

!----------------------------------------------------------------------


end subroutine process_coldstart






!#####################################################################





                     end module nonfms_donner_mod

!-----------------------------------------------------------------------
!                 Parallel I/O for message-passing codes
!
! AUTHOR: V. Balaji (vb@gfdl.gov)
!         SGI/GFDL Princeton University
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! For the full text of the GNU General Public License,
! write to: Free Software Foundation, Inc.,
!           675 Mass Ave, Cambridge, MA 02139, USA.  
!-----------------------------------------------------------------------

! <CONTACT EMAIL="vb@gfdl.noaa.gov">
!   V. Balaji
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>
! <RCSLOG SRC="http://www.gfdl.noaa.gov/~vb/changes_mpp_io.html"/>

! <OVERVIEW>
!   <TT>mpp_io_mod</TT>, is a set of simple calls for parallel I/O on
!   distributed systems. It is geared toward the writing of data in netCDF
!   format. It requires the modules <LINK
!   SRC="mpp_domains.html">mpp_domains_mod</LINK> and <LINK
!   SRC="mpp.html">mpp_mod</LINK>, upon which it is built.
! </OVERVIEW>

! <DESCRIPTION>
!   In massively parallel environments, an often difficult problem is
!   the reading and writing of data to files on disk. MPI-IO and MPI-2 IO
!   are moving toward providing this capability, but are currently not
!   widely implemented. Further, it is a rather abstruse
!   API. <TT>mpp_io_mod</TT> is an attempt at a simple API encompassing a
!   certain variety of the I/O tasks that will be required. It does not
!   attempt to be an all-encompassing standard such as MPI, however, it
!   can be implemented in MPI if so desired. It is equally simple to add
!   parallel I/O capability to <TT>mpp_io_mod</TT> based on vendor-specific
!   APIs while providing a layer of insulation for user codes.
!   
!   The <TT>mpp_io_mod</TT> parallel I/O API built on top of the <LINK
!   SRC="mpp_domains.html">mpp_domains_mod</LINK> and <LINK
!   SRC="mpp.html">mpp_mod</LINK> API for domain decomposition and
!   message passing. Features of <TT>mpp_io_mod</TT> include:
!   
!    1) Simple, minimal API, with free access to underlying API for more
!   complicated stuff.<BR/>
!    2) Self-describing files: comprehensive header information
!   (metadata) in the file itself.<BR/>
!    3) Strong focus on performance of parallel write: the climate models
!   for which it is designed typically read a minimal amount of data
!   (typically at the beginning of the run); but on the other hand, tend
!   to write copious amounts of data during the run. An interface for
!   reading is also supplied, but its performance has not yet been optimized.<BR/>
!    4) Integrated netCDF capability: <LINK SRC
!   ="http://www.unidata.ucar.edu/packages/netcdf/">netCDF</LINK> is a
!   data format widely used in the climate/weather modeling
!   community. netCDF is considered the principal medium of data storage
!   for <TT>mpp_io_mod</TT>. But I provide a raw unformatted
!   fortran I/O capability in case netCDF is not an option, either due to
!   unavailability, inappropriateness, or poor performance.<BR/>
!    5) May require off-line post-processing: a tool for this purpose,
!   <TT>mppnccombine</TT>, is available. GFDL users may use
!   <TT>~hnv/pub/mppnccombine</TT>. Outside users may obtain the
!   source <LINK SRC
!   ="ftp://ftp.gfdl.gov/perm/hnv/mpp/mppnccombine.c">here</LINK>.  It
!   can be compiled on any C compiler and linked with the netCDF
!   library. The program is free and is covered by the <LINK SRC
!   ="ftp://ftp.gfdl.gov/perm/hnv/mpp/LICENSE">GPL license</LINK>.
!   
!   The internal representation of the data being written out is
!   assumed be the default real type, which can be 4 or 8-byte. Time data
!   is always written as 8-bytes to avoid overflow on climatic time scales
!   in units of seconds.
!   
!   <LINK SRC="modes"></LINK><H4>I/O modes in <TT>mpp_io_mod</TT></H4>
!   
!   The I/O activity critical to performance in the models for which
!   <TT>mpp_io_mod</TT> is designed is typically the writing of large
!   datasets on a model grid volume produced at intervals during
!   a run. Consider a 3D grid volume, where model arrays are stored as
!   <TT>(i,j,k)</TT>. The domain decomposition is typically along
!   <TT>i</TT> or <TT>j</TT>: thus to store data to disk as a global
!   volume, the distributed chunks of data have to be seen as
!   non-contiguous. If we attempt to have all PEs write this data into a
!   single file, performance can be seriously compromised because of the
!   data reordering that will be required. Possible options are to have
!   one PE acquire all the data and write it out, or to have all the PEs
!   write independent files, which are recombined offline. These three
!   modes of operation are described in the <TT>mpp_io_mod</TT> terminology
!   in terms of two parameters, <I>threading</I> and <I>fileset</I>,
!   as follows:
!   
!   <I>Single-threaded I/O:</I> a single PE acquires all the data
!   and writes it out.<BR/>
!   <I>Multi-threaded, single-fileset I/O:</I> many PEs write to a
!   single file.<BR/>
!    <I>Multi-threaded, multi-fileset I/O:</I> many PEs write to
!   independent files. This is also called <I>distributed I/O</I>.
!   
!   The middle option is the most difficult to achieve performance. The
!   choice of one of these modes is made when a file is opened for I/O, in
!   <LINK SRC="#mpp_open">mpp_open</LINK>.
!   
!   <LINK name="metadata"></LINK><H4>Metadata in <TT>mpp_io_mod</TT></H4>
!   
!   A requirement of the design of <TT>mpp_io_mod</TT> is that the file must
!   be entirely self-describing: comprehensive header information
!   describing its contents is present in the header of every file. The
!   header information follows the model of netCDF. Variables in the file
!   are divided into <I>axes</I> and <I>fields</I>. An axis describes a
!   co-ordinate variable, e.g <TT>x,y,z,t</TT>. A field consists of data in
!   the space described by the axes. An axis is described in
!   <TT>mpp_io_mod</TT> using the defined type <TT>axistype</TT>:
!   
!   <PRE>
!   type, public :: axistype
!      sequence
!      character(len=128) :: name
!      character(len=128) :: units
!      character(len=256) :: longname
!      character(len=8) :: cartesian
!      integer :: len
!      integer :: sense           !+/-1, depth or height?
!      type(domain1D), pointer :: domain
!      real, dimension(:), pointer :: data
!      integer :: id, did
!      integer :: type  ! external NetCDF type format for axis data
!      integer :: natt
!      type(atttype), pointer :: Att(:) ! axis attributes
!   end type axistype
!   </PRE>
!   
!   A field is described using the type <TT>fieldtype</TT>:
!   
!   <PRE>
!   type, public :: fieldtype
!      sequence
!      character(len=128) :: name
!      character(len=128) :: units
!      character(len=256) :: longname
!      real :: min, max, missing, fill, scale, add
!      integer :: pack
!      type(axistype), dimension(:), pointer :: axes
!      integer, dimension(:), pointer :: size
!      integer :: time_axis_index
!      integer :: id
!      integer :: type ! external NetCDF format for field data
!      integer :: natt, ndim
!      type(atttype), pointer :: Att(:) ! field metadata
!   end type fieldtype
!   </PRE>
!   
!   An attribute (global, field or axis) is described using the <TT>atttype</TT>:
!   
!   <PRE>
!   type, public :: atttype
!      sequence
!      integer :: type, len
!      character(len=128) :: name
!      character(len=256)  :: catt
!      real(FLOAT_KIND), pointer :: fatt(:)
!   end type atttype
!   </PRE>
!   
!   <LINK name="packing"></LINK>This default set of field attributes corresponds
!   closely to various conventions established for netCDF files. The
!   <TT>pack</TT> attribute of a field defines whether or not a
!   field is to be packed on output. Allowed values of
!   <TT>pack</TT> are 1,2,4 and 8. The value of
!   <TT>pack</TT> is the number of variables written into 8
!   bytes. In typical use, we write 4-byte reals to netCDF output; thus
!   the default value of <TT>pack</TT> is 2. For
!   <TT>pack</TT> = 4 or 8, packing uses a simple-minded linear
!   scaling scheme using the <TT>scale</TT> and <TT>add</TT>
!   attributes. There is thus likely to be a significant loss of dynamic
!   range with packing. When a field is declared to be packed, the
!   <TT>missing</TT> and <TT>fill</TT> attributes, if
!   supplied, are packed also.
!   
!   Please note that the pack values are the same even if the default
!   real is 4 bytes, i.e <TT>PACK=1</TT> still follows the definition
!   above and writes out 8 bytes.
!   
!   A set of <I>attributes</I> for each variable is also available. The
!   variable definitions and attribute information is written/read by calling
!   <LINK SRC="#mpp_write_meta">mpp_write_meta</LINK> or <LINK SRC="#mpp_read_meta">mpp_read_meta</LINK>. A typical calling
!   sequence for writing data might be:
!   
!   <PRE>
!   ...
!     type(domain2D), dimension(:), allocatable, target :: domain
!     type(fieldtype) :: field
!     type(axistype) :: x, y, z, t
!   ...
!     call mpp_define_domains( (/1,nx,1,ny/), domain )
!     allocate( a(domain(pe)%x%data%start_index:domain(pe)%x%data%end_index, &
!                 domain(pe)%y%data%start_index:domain(pe)%y%data%end_index,nz) )
!   ...
!     call mpp_write_meta( unit, x, 'X', 'km', 'X distance', &
!          domain=domain(pe)%x, data=(/(float(i),i=1,nx)/) )
!     call mpp_write_meta( unit, y, 'Y', 'km', 'Y distance', &
!          domain=domain(pe)%y, data=(/(float(i),i=1,ny)/) )
!     call mpp_write_meta( unit, z, 'Z', 'km', 'Z distance', &
!          data=(/(float(i),i=1,nz)/) )
!     call mpp_write_meta( unit, t, 'Time', 'second', 'Time' )
!   
!     call mpp_write_meta( unit, field, (/x,y,z,t/), 'a', '(m/s)', AAA', &
!          missing=-1e36 )
!   ...
!     call mpp_write( unit, x )
!     call mpp_write( unit, y )
!     call mpp_write( unit, z )
!   ...
!   </PRE>
!   
!   In this example, <TT>x</TT> and <TT>y</TT> have been
!   declared as distributed axes, since a domain decomposition has been
!   associated. <TT>z</TT> and <TT>t</TT> are undistributed
!   axes. <TT>t</TT> is known to be a <I>record</I> axis (netCDF
!   terminology) since we do not allocate the <TT>data</TT> element
!   of the <TT>axistype</TT>. <I>Only one record axis may be
!   associated with a file.</I> The call to <LINK
!   SRC="#mpp_write_meta">mpp_write_meta</LINK> initializes
!   the axes, and associates a unique variable ID with each axis. The call
!   to <TT>mpp_write_meta</TT> with argument <TT>field</TT>
!   declared <TT>field</TT> to be a 4D variable that is a function
!   of <TT>(x,y,z,t)</TT>, and a unique variable ID is associated
!   with it. A 3D field will be written at each call to
!   <TT>mpp_write(field)</TT>.
!   
!   The data to any variable, including axes, is written by
!   <TT>mpp_write</TT>.
!   
!   Any additional attributes of variables can be added through
!   subsequent <TT>mpp_write_meta</TT> calls, using the variable ID as a
!   handle. <I>Global</I> attributes, associated with the dataset as a
!   whole, can also be written thus. See the <LINK
!   SRC="#mpp_write_meta">mpp_write_meta</LINK> call syntax below
!   for further details.
!   
!   You cannot interleave calls to <TT>mpp_write</TT> and
!   <TT>mpp_write_meta</TT>: the first call to
!   <TT>mpp_write</TT> implies that metadata specification is
!   complete.
!   
!   A typical calling sequence for reading data might be:
!   
!   <PRE>
!   ...
!     integer :: unit, natt, nvar, ntime
!     type(domain2D), dimension(:), allocatable, target :: domain
!     type(fieldtype), allocatable, dimension(:) :: fields
!     type(atttype), allocatable, dimension(:) :: global_atts
!     real, allocatable, dimension(:) :: times
!   ...
!     call mpp_define_domains( (/1,nx,1,ny/), domain )
!   
!     call mpp_read_meta(unit)
!     call mpp_get_info(unit,natt,nvar,ntime)
!     allocate(global_atts(natt))
!     call mpp_get_atts(unit,global_atts)
!     allocate(fields(nvar))
!     call mpp_get_vars(unit, fields)
!     allocate(times(ntime))
!     call mpp_get_times(unit, times)
!   
!     allocate( a(domain(pe)%x%data%start_index:domain(pe)%x%data%end_index, &
!                 domain(pe)%y%data%start_index:domain(pe)%y%data%end_index,nz) )
!   ...
!     do i=1, nvar
!       if (fields(i)%name == 'a')  call mpp_read(unit,fields(i),domain(pe), a,
!                                                 tindex)
!     enddo
!   ...
!   </PRE>
!   
!   In this example, the data are distributed as in the previous
!   example. The call to <LINK
!   SRC="#mpp_read_meta">mpp_read_meta</LINK> initializes
!   all of the metadata associated with the file, including global
!   attributes, variable attributes and non-record dimension data. The
!   call to <TT>mpp_get_info</TT> returns the number of global
!   attributes (<TT>natt</TT>), variables (<TT>nvar</TT>) and
!   time levels (<TT>ntime</TT>) associated with the file
!   identified by a unique ID (<TT>unit</TT>).
!   <TT>mpp_get_atts</TT> returns all global attributes for
!   the file in the derived type <TT>atttype(natt)</TT>.
!   <TT>mpp_get_vars</TT> returns variable types
!   (<TT>fieldtype(nvar)</TT>).  Since the record dimension data are not allocated for calls to <LINK SRC="#mpp_write">mpp_write</LINK>, a separate call to  <TT>mpp_get_times</TT> is required to access record dimension data.  Subsequent calls to
!   <TT>mpp_read</TT> return the field data arrays corresponding to
!   the fieldtype.  The <TT>domain</TT> type is an optional
!   argument.  If <TT>domain</TT> is omitted, the incoming field
!   array should be dimensioned for the global domain, otherwise, the
!   field data is assigned to the computational domain of a local array.
!   
!   <I>Multi-fileset</I> reads are not supported with <TT>mpp_read</TT>.

! </DESCRIPTION>

module mpp_io_mod
#include <fms_platform.h>

use mpp_parameter_mod,  only : MPP_WRONLY, MPP_RDONLY, MPP_APPEND, MPP_OVERWR, MPP_ASCII
use mpp_parameter_mod,  only : MPP_IEEE32, MPP_NATIVE, MPP_NETCDF, MPP_SEQUENTIAL
use mpp_parameter_mod,  only : MPP_DIRECT, MPP_SINGLE, MPP_MULTI, MPP_DELETE, MPP_COLLECT
use mpp_parameter_mod,  only : MPP_DEBUG, MPP_VERBOSE, NULLUNIT, NULLTIME, ALL_PES
use mpp_parameter_mod,  only : CENTER, EAST, NORTH, CORNER
use mpp_parameter_mod,  only : MAX_FILE_SIZE, GLOBAL_ROOT_ONLY, XUPDATE, YUPDATE
use mpp_mod,            only : mpp_error, FATAL, WARNING, NOTE, stdin, stdout, stderr, stdlog
use mpp_mod,            only : mpp_pe, mpp_root_pe, mpp_npes, lowercase, mpp_transmit, mpp_sync_self
use mpp_mod,            only : mpp_init, mpp_sync, mpp_clock_id, mpp_clock_begin, mpp_clock_end
use mpp_mod,            only : MPP_CLOCK_SYNC, MPP_CLOCK_DETAILED, CLOCK_ROUTINE
use mpp_mod,            only : input_nml_file, mpp_gather, mpp_broadcast
use mpp_mod,            only : mpp_send, mpp_recv, mpp_sync_self, EVENT_RECV, COMM_TAG_1
use mpp_domains_mod,    only : domain1d, domain2d, NULL_DOMAIN1D, mpp_domains_init
use mpp_domains_mod,    only : mpp_get_global_domain, mpp_get_compute_domain
use mpp_domains_mod,    only : mpp_get_data_domain, mpp_get_memory_domain, mpp_get_pelist
use mpp_domains_mod,    only : mpp_update_domains, mpp_global_field, mpp_domain_is_symmetry
use mpp_domains_mod,    only : operator( .NE. ), mpp_get_domain_shift
use mpp_domains_mod,    only : mpp_get_io_domain, mpp_domain_is_tile_root_pe, mpp_get_domain_tile_root_pe
use mpp_domains_mod,    only : mpp_get_tile_id, mpp_get_tile_npes, mpp_get_io_domain_layout
use mpp_domains_mod,    only : mpp_get_domain_name, mpp_get_domain_npes
use mpp_parameter_mod,  only : MPP_FILL_DOUBLE,MPP_FILL_INT
use mpp_mod,            only : mpp_chksum

implicit none
private

#ifdef use_netCDF
#include <netcdf.inc>
#endif

  !--- public parameters  -----------------------------------------------
  public :: MPP_WRONLY, MPP_RDONLY, MPP_APPEND, MPP_OVERWR, MPP_ASCII, MPP_IEEE32
  public :: MPP_NATIVE, MPP_NETCDF, MPP_SEQUENTIAL, MPP_DIRECT, MPP_SINGLE
  public :: MPP_MULTI, MPP_DELETE, MPP_COLLECT
  public :: FILE_TYPE_USED
  public :: MAX_FILE_SIZE
  !--- public data type ------------------------------------------------
  public :: axistype, atttype, fieldtype, validtype, filetype

  !--- public data -----------------------------------------------------
  public :: default_field, default_axis, default_att
    
  !--- public interface from mpp_io_util.h ----------------------
  public :: mpp_get_iospec, mpp_get_id, mpp_get_ncid, mpp_get_unit_range, mpp_is_valid
  public :: mpp_set_unit_range, mpp_get_info, mpp_get_atts, mpp_get_fields
  public :: mpp_get_times, mpp_get_axes, mpp_get_recdimid, mpp_get_axis_data, mpp_get_axis_by_name
  public :: mpp_io_set_stack_size, mpp_get_field_index, mpp_get_axis_index
  public :: mpp_get_field_name, mpp_get_att_value, mpp_get_att_length
  public :: mpp_get_att_type, mpp_get_att_name, mpp_get_att_real, mpp_get_att_char
  public :: mpp_get_att_real_scalar, mpp_get_axis_length, mpp_is_dist_ioroot
  public :: mpp_get_file_name, mpp_file_is_opened, mpp_attribute_exist 
  public :: mpp_io_clock_on, mpp_get_time_axis, mpp_get_default_calendar
  public :: mpp_get_dimension_length, mpp_get_axis_bounds

  !--- public interface from mpp_io_misc.h ----------------------
  public :: mpp_io_init, mpp_io_exit, netcdf_err, mpp_flush

  !--- public interface from mpp_io_write.h ---------------------
  public :: mpp_write, mpp_write_meta, mpp_copy_meta, mpp_modify_meta, mpp_write_axis_data, mpp_def_dim

  !--- public interface from mpp_io_read.h ---------------------
  public :: mpp_read, mpp_read_meta, mpp_get_tavg_info
  public :: mpp_read_compressed, mpp_write_compressed, mpp_read_distributed_ascii, mpp_write_unlimited_axis

  !--- public interface from mpp_io_switch.h ---------------------
  public :: mpp_open, mpp_close

  !-----------------------------------------------------------------------------
  !--- mpp_io data types
  !-----------------------------------------------------------------------------
integer FILE_TYPE_USED  
type :: atttype
     private
     integer             :: type, len
     character(len=128)  :: name
     character(len=1280) :: catt
     real, pointer       :: fatt(:) =>NULL() ! just use type conversion for integers
  end type atttype

  type :: axistype
     private
     character(len=128) :: name
     character(len=128) :: name_bounds
     character(len=128) :: units
     character(len=256) :: longname
     character(len=8)   :: cartesian
     character(len=256) :: compressed
     character(len=24)  :: calendar
     integer            :: sense, len          !+/-1, depth or height?
     type(domain1D)     :: domain              !if pointer is associated, it is a distributed data axis
     real, pointer      :: data(:) =>NULL()    !axis values (not used if time axis)
     real, pointer      :: data_bounds(:) =>NULL()    !axis bounds values
     integer, pointer   :: idata(:) =>NULL()   !compressed axis valuesi
     integer            :: id, did, type, natt !id is the "variable ID", did is the "dimension ID": 
                                               !netCDF requires 2 IDs for axes
     integer            :: shift               !normally is 0. when domain is symmetry, its value maybe 1.
     type(atttype), pointer :: Att(:) =>NULL()
  end type axistype

  type :: validtype
     private
     logical :: is_range ! if true, then the data represent the valid range
     real    :: min,max  ! boundaries of the valid range or missing value
  end type validtype

  type :: fieldtype
     private
     character(len=128)      :: name
     character(len=128)      :: units
     character(len=256)      :: longname
     character(len=128)      :: standard_name   ! CF standard name
     real                    :: min, max, missing, fill, scale, add
     integer                 :: pack
     integer(LONG_KIND), dimension(3) :: checksum
     type(axistype), pointer :: axes(:) =>NULL() !axes associated with field size, time_axis_index redundantly 
                                        !hold info already contained in axes. it's clunky and inelegant, 
                                        !but required so that axes can be shared among multiple files
     integer, pointer        :: size(:) =>NULL()
     integer                 :: time_axis_index
     integer                 :: id, type, natt, ndim
     type(atttype), pointer  :: Att(:) =>NULL()
     integer                 :: position ! indicate the location of the data ( CENTER, NORTH, EAST, CORNER )
  end type fieldtype

  type :: filetype
     private
     character(len=256) :: name
     integer            :: action, format, access, threading, fileset, record, ncid
     logical            :: opened, initialized, nohdrs
     integer            :: time_level
     real(DOUBLE_KIND)  :: time
     logical            :: valid
     logical            :: write_on_this_pe   ! indicate if will write out from this pe
     logical            :: read_on_this_pe    ! indicate if will read from this pe
     logical            :: io_domain_exist    ! indicate if io_domain exist or not.
     integer            :: id       !variable ID of time axis associated with file (only one time axis per file)
     integer            :: recdimid !dim ID of time axis associated with file (only one time axis per file)
     real(DOUBLE_KIND), pointer :: time_values(:) =>NULL() ! time axis values are stored here instead of axis%data 
                                                  ! since mpp_write assumes these values are not time values. 
                                                  ! Not used in mpp_write
     ! additional elements of filetype for mpp_read (ignored for mpp_write)
     integer :: ndim, nvar, natt  ! number of dimensions, non-dimension variables and global attributes
                                  ! redundant axis types stored here and in associated fieldtype
                                  ! some axes are not used by any fields, i.e. "edges"
     type(axistype), pointer  :: axis(:) =>NULL()
     type(fieldtype), pointer :: var(:) =>NULL()
     type(atttype), pointer   :: att(:) =>NULL()
     type(domain2d), pointer  :: domain =>NULL()
  end type filetype

!***********************************************************************
!
!     public interface from mpp_io_util.h
!
!***********************************************************************
  interface mpp_get_id
     module procedure mpp_get_axis_id
     module procedure mpp_get_field_id
  end interface

! <INTERFACE NAME="mpp_get_atts">
!   <OVERVIEW>
!     Get file global metdata.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Get file global metdata.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call mpp_get_atts( unit, global_atts)
!   </TEMPLATE>
!  <IN NAME="unit"></IN>
!  <IN NAME="global_atts"></IN>
! </INTERFACE>
  interface mpp_get_atts
     module procedure mpp_get_global_atts
     module procedure mpp_get_field_atts
     module procedure mpp_get_axis_atts
  end interface

  interface mpp_get_att_value
     module procedure mpp_get_field_att_text 
  end interface


!***********************************************************************
!
!      public interface from mpp_io_read.h
!
!***********************************************************************
! <INTERFACE NAME="mpp_read">
!   <OVERVIEW>
!     Read from an open file.
!   </OVERVIEW>
!   <DESCRIPTION>
!      <TT>mpp_read</TT> is used to read data to the file on an I/O unit
!      using the file parameters supplied by <LINK
!      SRC="#mpp_open"><TT>mpp_open</TT></LINK>. There are two
!      forms of <TT>mpp_read</TT>, one to read
!      distributed field data, and one to read non-distributed field
!      data. <I>Distributed</I> data refer to arrays whose two
!      fastest-varying indices are domain-decomposed. Distributed data must
!      be 2D or 3D (in space). Non-distributed data can be 0-3D.
!
!      The <TT>data</TT> argument for distributed data is expected by
!      <TT>mpp_read</TT> to contain data specified on the <I>data</I> domain,
!      and will read the data belonging to the <I>compute</I> domain,
!      fetching data as required by the parallel I/O <LINK
!      SRC="#modes">mode</LINK> specified in the <TT>mpp_open</TT> call. This
!      is consistent with our definition of <LINK
!      SRC="http:mpp_domains.html#domains">domains</LINK>, where all arrays are
!      expected to be dimensioned on the data domain, and all operations
!      performed on the compute domain.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call mpp_read( unit, field, data, time_index )
!   </TEMPLATE>
!   <TEMPLATE>
!     call mpp_read( unit, field, domain, data, time_index )
!   </TEMPLATE>
!  <IN NAME="unit"></IN>
!  <IN NAME="field"></IN>
!  <INOUT NAME="data"></INOUT>
!  <IN NAME="domain"></IN>
!  <IN NAME="time_index">
!     time_index is an optional argument. It is to be omitted if the
!     field was defined not to be a function of time. Results are
!     unpredictable if the argument is supplied for a time- independent
!     field, or omitted for a time-dependent field.
!  </IN>
!  <NOTE>
!     The type of read performed by <TT>mpp_read</TT> depends on
!     the file characteristics on the I/O unit specified at the <LINK
!     SRC="#mpp_open"><TT>mpp_open</TT></LINK> call. Specifically, the
!     format of the input data (e.g netCDF or IEEE) and the
!     <TT>threading</TT> flags, etc., can be changed there, and
!     require no changes to the <TT>mpp_read</TT>
!     calls. (<TT>fileset</TT> = MPP_MULTI is not supported by
!     <TT>mpp_read</TT>; IEEE is currently not supported).
!
!     Packed variables are unpacked using the <TT>scale</TT> and
!     <TT>add</TT> attributes.
!
!     <TT>mpp_read_meta</TT> must be called prior to calling <TT>mpp_read.</TT>
!  </NOTE>
! </INTERFACE>
  interface mpp_read
     module procedure mpp_read_2ddecomp_r2d
     module procedure mpp_read_2ddecomp_r3d
     module procedure mpp_read_2ddecomp_r4d
     module procedure mpp_read_r0D
     module procedure mpp_read_r1D
     module procedure mpp_read_r2D
     module procedure mpp_read_r3D
     module procedure mpp_read_r4D
     module procedure mpp_read_text
     module procedure mpp_read_region_r2D
     module procedure mpp_read_region_r3D
  end interface

!***********************************************************************
!
!      public interfaces from mpp_io_read_distributed_ascii.inc
!
!***********************************************************************
! <INTERFACE NAME="mpp_read_distributed_ascii">
!   <OVERVIEW>
!     Read from an opened, ascii file, translating data to the desired format
!   </OVERVIEW>
!   <DESCRIPTION>
!     These routines are part of the mpp_read family. It is intended to 
!     provide a general purpose, distributed, list directed read
!  </DESCRIPTION>
!   <TEMPLATE>
!     call mpp_read_distributed_ascii(unit,fmt,ssize,data,iostat)
!   </TEMPLATE>
!  <IN NAME="unit"></IN>
!  <IN NAME="fmt"></IN>
!  <IN NAME="ssize"></IN>
!  <INOUT NAME="data"></IN>
!  <OUT NAME="iostat">
!  </IN>
!  <NOTE>
!     <TT>mpp_read_distributed_ascii</TT>
!     The stripe size must be greater than or equal to 1. The stripe
!     size does not have to be a common denominator of the number of
!     MPI ranks.
!  </NOTE>
! </INTERFACE>
  interface mpp_read_distributed_ascii
     module procedure mpp_read_distributed_ascii_r1d
     module procedure mpp_read_distributed_ascii_i1d
     module procedure mpp_read_distributed_ascii_a1d
  end interface


!***********************************************************************
!
!      public interfaces from mpp_io_read_compressed.h
!
!***********************************************************************
! <INTERFACE NAME="mpp_read_compressed">
!   <OVERVIEW>
!     Read from an opened, sparse data, compressed file (e.g. land_model)
!   </OVERVIEW>
!   <DESCRIPTION>
!     These routines are similar to mpp_read except that they are designed
!     to handle sparse, compressed vectors of data such as from the
!     land model. Currently, the sparse vector may vary in z. Hence
!     the need for the rank 2 treatment.
!  </DESCRIPTION>
!   <TEMPLATE>
!     call mpp_read_compressed( unit, field, domain, data, time_index )
!   </TEMPLATE>
!  <IN NAME="unit"></IN>
!  <IN NAME="field"></IN>
!  <IN NAME="domain"></IN>
!  <INOUT NAME="data"></INOUT>
!  <IN NAME="time_index">
!     time_index is an optional argument. It is to be omitted if the
!     field was defined not to be a function of time. Results are
!     unpredictable if the argument is supplied for a time- independent
!     field, or omitted for a time-dependent field.
!  </IN>
!  <NOTE>
!     <TT>mpp_read_meta</TT> must be called prior to calling 
!     <TT>mpp_read_compressed.</TT>
!     Since in general, the vector is distributed across the io-domain
!     The read expects the io_domain to be defined.
!  </NOTE>
! </INTERFACE>
  interface mpp_read_compressed
     module procedure mpp_read_compressed_r1d
     module procedure mpp_read_compressed_r2d
  end interface mpp_read_compressed


!***********************************************************************
!
!    public interface from mpp_io_write.h
!
!***********************************************************************

! <INTERFACE NAME="mpp_write_meta">
!   <OVERVIEW>
!     Write metadata.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This routine is used to write the <LINK SRC="#metadata">metadata</LINK>
!     describing the contents of a file being written. Each file can contain
!     any number of fields, which are functions of 0-3 space axes and 0-1
!     time axes. (Only one time axis can be defined per file). The basic
!     metadata defined <LINK SRC="#metadata">above</LINK> for <TT>axistype</TT>
!     and <TT>fieldtype</TT> are written in the first two forms of the call
!     shown below. These calls will associate a unique variable ID with each
!     variable (axis or field). These can be used to attach any other real,
!     integer or character attribute to a variable. The last form is used to
!     define a <I>global</I> real, integer or character attribute that
!     applies to the dataset as a whole.
!   </DESCRIPTION>
!  <TEMPLATE>
!    call mpp_write_meta( unit, axis, name, units, longname,
!      cartesian, sense, domain, data )
!  </TEMPLATE>
!  <NOTE>
!    The first form defines a time or space axis. Metadata corresponding to the type
!    above are written to the file on &lt;unit&gt;. A unique ID for subsequen
!    references to this axis is returned in axis%id. If the &lt;domain&gt;
!    element is present, this is recognized as a distributed data axis
!    and domain decomposition information is also written if required (the
!    domain decomposition info is required for multi-fileset multi-threaded
!    I/O). If the &lt;data&gt; element is allocated, it is considered to be a
!    space axis, otherwise it is a time axis with an unlimited dimension. Only
!    one time axis is allowed per file.
!  </NOTE>
!  <TEMPLATE>
!    call mpp_write_meta( unit, field, axes, name, units, longname,
!                              min, max, missing, fill, scale, add, pack )
!  </TEMPLATE>
!  <NOTE>
!    The second form defines a field. Metadata corresponding to the type
!    above are written to the file on &lt;unit&gt;. A unique ID for subsequen
!    references to this field is returned in field%id. At least one axis
!    must be associated, 0D variables are not considered. mpp_write_meta
!    must previously have been called on all axes associated with this
!    field.
!  </NOTE>
!  <TEMPLATE>
!    call mpp_write_meta( unit, id, name, rval=rval, pack=pack )
!  </TEMPLATE>
!  <TEMPLATE>
!    call mpp_write_meta( unit, id, name, ival=ival )
!  </TEMPLATE>
!  <TEMPLATE>
!    call mpp_write_meta( unit, id, name, cval=cval )
!  </TEMPLATE>
!  <NOTE>
!    The third form (3 - 5) defines metadata associated with a previously defined
!    axis or field, identified to mpp_write_meta by its unique ID &lt;id&gt;.
!    The attribute is named &lt;name&gt; and can take on a real, integer
!    or character value. &lt;rval&gt; and &lt;ival&gt; can be scalar or 1D arrays.
!    This need not be called for attributes already contained in
!    the type.
!  </NOTE>
!  <TEMPLATE>
!    call mpp_write_meta( unit, name, rval=rval, pack=pack )
!  </TEMPLATE>
!  <TEMPLATE>
!    call mpp_write_meta( unit, name, ival=ival )
!  </TEMPLATE>
!  <TEMPLATE>
!    call mpp_write_meta( unit, name, cval=cval )
!  </TEMPLATE>
!  <NOTE>
!    The last form (6 - 8) defines global metadata associated with the file as a
!    whole. The attribute is named &lt;name&gt; and can take on a real, integer
!    or character value. &lt;rval&gt; and &lt;ival&gt; can be scalar or 1D arrays.
!  </NOTE>
!  <IN NAME="unit"></IN>
!  <OUT NAME="axis"></OUT>
!  <IN NAME="name"></IN>
!  <IN NAME="units"></IN>
!  <IN NAME="longname"></IN>
!  <IN NAME="cartesian"></IN>
!  <IN NAME="sense"></IN>
!  <IN NAME="domain"></IN>
!  <IN NAME="data"></IN>
!  <OUT NAME="field"></OUT>
!  <IN NAME="min, max"></IN>
!  <IN NAME="missing"></IN>
!  <IN NAME="fill"></IN>
!  <IN NAME="scale"></IN>
!  <IN NAME="add"></IN>
!  <IN NAME="pack"></IN>
!  <IN NAME="id"></IN>
!  <IN NAME="cval"></IN>
!  <IN NAME="ival"></IN>
!  <IN NAME="rval"></IN>
! <NOTE>
!    Note that <TT>mpp_write_meta</TT> is expecting axis data on the
!    <I>global</I> domain even if it is a domain-decomposed axis.
!
!    You cannot interleave calls to <TT>mpp_write</TT> and
!    <TT>mpp_write_meta</TT>: the first call to
!    <TT>mpp_write</TT> implies that metadata specification is complete.
! </NOTE>
! </INTERFACE>
  interface mpp_write_meta
     module procedure mpp_write_meta_var
     module procedure mpp_write_meta_scalar_r
     module procedure mpp_write_meta_scalar_i
     module procedure mpp_write_meta_axis_r1d
     module procedure mpp_write_meta_axis_i1d
     module procedure mpp_write_meta_axis_unlimited
     module procedure mpp_write_meta_field
     module procedure mpp_write_meta_global
     module procedure mpp_write_meta_global_scalar_r
     module procedure mpp_write_meta_global_scalar_i
  end interface
     
  interface mpp_copy_meta
     module procedure mpp_copy_meta_axis
     module procedure mpp_copy_meta_field
     module procedure mpp_copy_meta_global
  end interface

  interface mpp_modify_meta
!     module procedure mpp_modify_att_meta
     module procedure mpp_modify_field_meta
     module procedure mpp_modify_axis_meta
  end interface

! <INTERFACE NAME="mpp_write">
!   <OVERVIEW>
!     Write to an open file.
!   </OVERVIEW>
!   <DESCRIPTION>
!    <TT>mpp_write</TT> is used to write data to the file on an I/O unit
!    using the file parameters supplied by <LINK
!    SRC="#mpp_open"><TT>mpp_open</TT></LINK>. Axis and field definitions must
!    have previously been written to the file using <LINK
!    SRC="#mpp_write_meta"><TT>mpp_write_meta</TT></LINK>.  There are three
!    forms of <TT>mpp_write</TT>, one to write axis data, one to write
!    distributed field data, and one to write non-distributed field
!    data. <I>Distributed</I> data refer to arrays whose two
!    fastest-varying indices are domain-decomposed. Distributed data must
!    be 2D or 3D (in space). Non-distributed data can be 0-3D.
!
!    The <TT>data</TT> argument for distributed data is expected by
!    <TT>mpp_write</TT> to contain data specified on the <I>data</I> domain,
!    and will write the data belonging to the <I>compute</I> domain,
!    fetching or sending data as required by the parallel I/O <LINK
!    SRC="#modes">mode</LINK> specified in the <TT>mpp_open</TT> call. This
!    is consistent with our definition of <LINK
!    SRC="http:mpp_domains.html#domains">domains</LINK>, where all arrays are
!    expected to be dimensioned on the data domain, and all operations
!    performed on the compute domain.
!
!     The type of the <TT>data</TT> argument must be a <I>default
!     real</I>, which can be 4 or 8 byte.
!   </DESCRIPTION>
!  <TEMPLATE>
!    mpp_write( unit, axis )
!  </TEMPLATE>
!  <TEMPLATE>
!    mpp_write( unit, field, data, tstamp )
!  </TEMPLATE>
!  <TEMPLATE>
!    mpp_write( unit, field, domain, data, tstamp )
!  </TEMPLATE>
!  <IN NAME="tstamp">
!    <TT>tstamp</TT> is an optional argument. It is to
!    be omitted if the field was defined not to be a function of time.
!    Results are unpredictable if the argument is supplied for a time-
!    independent field, or omitted for a time-dependent field. Repeated
!    writes of a time-independent field are also not recommended. One
!    time level of one field is written per call. tstamp must be an 8-byte
!    real, even if the default real type is 4-byte.
!  </IN>
!  <NOTE>
!    The type of write performed by <TT>mpp_write</TT> depends on the file
!    characteristics on the I/O unit specified at the <LINK
!    SRC="#mpp_open"><TT>mpp_open</TT></LINK> call. Specifically, the format of
!    the output data (e.g netCDF or IEEE), the <TT>threading</TT> and
!    <TT>fileset</TT> flags, etc., can be changed there, and require no
!    changes to the <TT>mpp_write</TT> calls.
!
!    Packing is currently not implemented for non-netCDF files, and the
!    <TT>pack</TT> attribute is ignored. On netCDF files,
!    <TT>NF_DOUBLE</TT>s (8-byte IEEE floating point numbers) are
!    written for <TT>pack</TT>=1 and <TT>NF_FLOAT</TT>s for
!    <TT>pack</TT>=2. (<TT>pack</TT>=2 gives the customary
!    and default behaviour). We write <TT>NF_SHORT</TT>s (2-byte
!    integers) for <TT>pack=4</TT>, or <TT>NF_BYTE</TT>s
!    (1-byte integers) for <TT>pack=8</TT>. Integer scaling is done
!    using the <TT>scale</TT> and <TT>add</TT> attributes at
!    <TT>pack</TT>=4 or 8, satisfying the relation
!
!    <PRE>
!    data = packed_data*scale + add
!    </PRE>
!
!    <TT>NOTE: mpp_write</TT> does not check to see if the scaled
!    data in fact fits into the dynamic range implied by the specified
!    packing. It is incumbent on the user to supply correct scaling
!    attributes.
!
!    You cannot interleave calls to <TT>mpp_write</TT> and
!    <TT>mpp_write_meta</TT>: the first call to
!    <TT>mpp_write</TT> implies that metadata specification is
!    complete.
! </NOTE>
! </INTERFACE>
  interface mpp_write
     module procedure mpp_write_2ddecomp_r2d
     module procedure mpp_write_2ddecomp_r3d
     module procedure mpp_write_2ddecomp_r4d
     module procedure mpp_write_r0D
     module procedure mpp_write_r1D
     module procedure mpp_write_r2D
     module procedure mpp_write_r3D
     module procedure mpp_write_r4D
     module procedure mpp_write_axis
  end interface


!***********************************************************************
! <INTERFACE NAME="mpp_write_compressed">
!   <OVERVIEW>
!     Write to an opened, sparse data, compressed file (e.g. land_model)
!   </OVERVIEW>
!   <DESCRIPTION>
!     These routines are similar to mpp_write except that they are 
!     designed to handle sparse, compressed vectors of data such 
!     as from the land model. Currently, the sparse vector may vary in z.
!     Hence the need for the rank 2 treatment.
!  </DESCRIPTION>
!   <TEMPLATE>
!     call mpp_write(unit, field, domain, data, nelems_io, tstamp, default_data )
!   </TEMPLATE>
!  <IN NAME="unit"></IN>
!  <IN NAME="field"></IN>
!  <IN NAME="domain"></IN>
!  <INOUT NAME="data"></INOUT>
!  <IN NAME="nelems_io">
!    <TT>nelems</TT> is a vector containing the number of elements expected
!    from each member of the io_domain. It MUST have the same order as
!    the io_domain pelist.
!  </IN>
!  <IN NAME="tstamp">
!    <TT>tstamp</TT> is an optional argument. It is to
!    be omitted if the field was defined not to be a function of time.
!    Results are unpredictable if the argument is supplied for a time-
!    independent field, or omitted for a time-dependent field. Repeated
!    writes of a time-independent field are also not recommended. One
!    time level of one field is written per call. tstamp must be an 8-byte
!    real, even if the default real type is 4-byte.
!  </IN>
!  <IN NAME="default_data"></IN>
!  <NOTE>
!     <TT>mpp_write_meta</TT> must be called prior to calling 
!     <TT>mpp_write_compressed.</TT>
!     Since in general, the vector is distributed across the io-domain
!     The write expects the io_domain to be defined.
!  </NOTE>
! </INTERFACE>
  interface mpp_write_compressed
     module procedure mpp_write_compressed_r1d
     module procedure mpp_write_compressed_r2d
  end interface mpp_write_compressed

!***********************************************************************
! <INTERFACE NAME="mpp_write_unlimited_axis">
!   <OVERVIEW>
!     Write to an opened file along the unlimited axis (e.g. icebergs)
!   </OVERVIEW>
!   <DESCRIPTION>
!     These routines are similar to mpp_write except that they are 
!     designed to handle data written along the unlimited axis that
!     is not time (e.g. icebergs).
!  </DESCRIPTION>
!   <TEMPLATE>
!     call mpp_write(unit, field, domain, data, nelems_io)
!   </TEMPLATE>
!  <IN NAME="unit"></IN>
!  <IN NAME="field"></IN>
!  <IN NAME="domain"></IN>
!  <INOUT NAME="data"></INOUT>
!  <IN NAME="nelems">
!    <TT>nelems</TT> is a vector containing the number of elements expected
!    from each member of the io_domain. It MUST have the same order as
!    the io_domain pelist.
!  </IN>
!  <NOTE>
!     <TT>mpp_write_meta</TT> must be called prior to calling 
!     <TT>mpp_write_unlimited_axis.</TT>
!     Since in general, the vector is distributed across the io-domain
!     The write expects the io_domain to be defined.
!  </NOTE>
! </INTERFACE>
  interface mpp_write_unlimited_axis
     module procedure mpp_write_unlimited_axis_r1d
  end interface mpp_write_unlimited_axis


!***********************************************************************
! <INTERFACE NAME="mpp_def_dim">
!   <OVERVIEW>
!     Define an dimension variable
!   </OVERVIEW>
!   <DESCRIPTION>
!     Similar to the mpp_write_meta routines, but simply defines the
!     a dimension variable with the optional attributes
!  </DESCRIPTION>
!   <TEMPLATE>
!     call mpp_def_dim( unit, name, dsize, longname, data )
!   </TEMPLATE>
!  <IN NAME="unit"></IN>
!  <IN NAME="name"></IN>
!  <IN NAME="dsize"></IN>
!  <IN NAME="data"></INOUT>
! </INTERFACE>
  interface mpp_def_dim
     module procedure mpp_def_dim_nodata
     module procedure mpp_def_dim_int
     module procedure mpp_def_dim_real
  end interface mpp_def_dim

!***********************************************************************
!
!            module variables
!
!***********************************************************************
  logical            :: module_is_initialized = .FALSE.
  logical            :: verbose =.FALSE.
  logical            :: debug = .FALSE.
  integer            :: maxunits, unit_begin, unit_end
  integer            :: mpp_io_stack_size=0, mpp_io_stack_hwm=0
  integer            :: varnum=0
  integer            :: pe, npes
  character(len=256) :: text
  integer            :: error
  integer            :: records_per_pe
  integer            :: mpp_read_clock=0, mpp_write_clock=0
  integer            :: mpp_open_clock=0, mpp_close_clock=0


!initial value of buffer between meta_data and data in .nc file
  integer            :: header_buffer_val = 16384  ! value used in NF__ENDDEF
  logical            :: global_field_on_root_pe = .true.
  logical            :: io_clocks_on = .false.
  integer            :: shuffle = 0
  integer            :: deflate = 0
  integer            :: deflate_level = -1
  
  namelist /mpp_io_nml/header_buffer_val, global_field_on_root_pe, io_clocks_on, &
                       shuffle, deflate_level

  real(DOUBLE_KIND), allocatable :: mpp_io_stack(:)
  type(axistype),save            :: default_axis      !provided to users with default components
  type(fieldtype),save           :: default_field     !provided to users with default components
  type(atttype),save             :: default_att       !provided to users with default components
  type(filetype), allocatable    :: mpp_file(:)

  integer :: pack_size ! = 1 when compiling with -r8 and = 2 when compiling with -r4.

  character(len=128) :: version= &
       '$Id$'
  character(len=128) :: tagname= &
       '$Name$'

contains

#include <mpp_io_util.inc>
#include <mpp_io_misc.inc>
#include <mpp_io_connect.inc>
#include <mpp_io_read.inc>
#include <mpp_io_write.inc>

end module mpp_io_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL
 
!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: array_lib.F90,v 20.0 2013/12/13 23:16:11 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! ARRAY_LIB: Array procedures for F90
! Compiled/Modified:
!   07/01/06  John Haynes (haynes@atmos.colostate.edu)
!
! infind (function)
! lin_interpolate (function)
  
  module array_lib
  implicit none

  contains

! ----------------------------------------------------------------------------
! function INFIND
! ----------------------------------------------------------------------------
  function infind(list,val,sort,dist)
  use m_mrgrnk
  implicit none
!
! Purpose:
!   Finds the index of an array that is closest to a value, plus the
!   difference between the value found and the value specified
!
! Inputs:
!   [list]   an array of sequential values
!   [val]    a value to locate
! Optional input:
!   [sort]   set to 1 if [list] is in unknown/non-sequential order
!
! Returns:
!   index of [list] that is closest to [val]
!
! Optional output:
!   [dist]   set to variable containing [list([result])] - [val]
!
! Requires:
!   mrgrnk library
!
! Created:
!   10/16/03  John Haynes (haynes@atmos.colostate.edu)
! Modified:
!   01/31/06  IDL to Fortran 90
 
! ----- INPUTS -----
  real*8, dimension(:), intent(in) :: list
  real*8, intent(in) :: val  
  integer, intent(in), optional :: sort
  
! ----- OUTPUTS -----
  integer*4 :: infind
  real*8, intent(out), optional :: dist

! ----- INTERNAL -----
  real*8, dimension(size(list)) :: lists
  integer*4 :: nlist, result, tmp(1), sort_list
  integer*4, dimension(size(list)) :: mask, idx

  if (present(sort)) then
    sort_list = sort
  else
    sort_list = 0
  endif  

  nlist = size(list)
  if (sort_list == 1) then
    call mrgrnk(list,idx)
    lists = list(idx)
  else
    lists = list
  endif

  if (val >= lists(nlist)) then
    result = nlist
  else if (val <= lists(1)) then
    result = 1
  else
    mask(:) = 0
    where (lists < val) mask = 1
      tmp = minloc(mask,1)
      if (abs(lists(tmp(1)-1)-val) < abs(lists(tmp(1))-val)) then
        result = tmp(1) - 1
      else
        result = tmp(1)
      endif
  endif
  if (present(dist)) dist = lists(result)-val
  if (sort_list == 1) then
    infind = idx(result)
  else
    infind = result
  endif

  end function infind

! ----------------------------------------------------------------------------
! function LIN_INTERPOLATE
! ----------------------------------------------------------------------------  
  subroutine lin_interpolate(yarr,xarr,yyarr,xxarr,tol)
  use m_mrgrnk
  implicit none
!
! Purpose:
!   linearly interpolate a set of y2 values given a set of y1,x1,x2
!
! Inputs:
!   [yarr]    an array of y1 values
!   [xarr]    an array of x1 values
!   [xxarr]   an array of x2 values
!   [tol]     maximum distance for a match
!
! Output:
!   [yyarr]   interpolated array of y2 values
!
! Requires:
!   mrgrnk library
!
! Created:
!   06/07/06  John Haynes (haynes@atmos.colostate.edu)

! ----- INPUTS -----
  real*8, dimension(:), intent(in) :: yarr, xarr, xxarr
  real*8, intent(in) :: tol

! ----- OUTPUTS -----
  real*8, dimension(size(xxarr)), intent(out) :: yyarr

! ----- INTERNAL -----
  real*8, dimension(size(xarr)) :: ysort, xsort
  integer*4, dimension(size(xarr)) :: ist
  integer*4 :: nx, nxx, i, iloc
  real*8 :: d, m

  nx = size(xarr)
  nxx = size(xxarr)

! // xsort, ysort are sorted versions of xarr, yarr  
  call mrgrnk(xarr,ist)
  ysort = yarr(ist)
  xsort = xarr(ist)
  
  do i=1,nxx
    iloc = infind(xsort,xxarr(i),dist=d)
    if (d > tol) then
      print *, 'interpolation error'
      stop
    endif
    if (iloc == nx) then
!     :: set to the last value
      yyarr(i) = ysort(nx)
    else
!     :: is there another closeby value?
      if (abs(xxarr(i)-xsort(iloc+1)) < 2*tol) then
!       :: yes, do a linear interpolation      
        m = (ysort(iloc+1)-ysort(iloc))/(xsort(iloc+1)-xsort(iloc))
        yyarr(i) = ysort(iloc) + m*(xxarr(i)-xsort(iloc))
      else
!       :: no, set to the only nearby value
        yyarr(i) = ysort(iloc)
      endif
    endif
  enddo
  
  end subroutine lin_interpolate

  end module array_lib

!----------------------------------------------------------------
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Niki Zadeh 
! </CONTACT>
! 
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> William Cooke
! </REVIEWER>
!
! <OVERVIEW>
! This module provides the main interfaces between Ocean models and 
! generic tracers.
! </OVERVIEW>
!<DESCRIPTION>
! Generic Tracers are designed to be used by both GFDL Ocean models, GOLD and MOM.
! This module provides the main interfaces for using generic tracers.
! Generic Tracers are contained in separate modules according to their
! chemical/physical similarity (currently generic_TOPAZ, generic_COBALT, 
! generic_ERGOM and generic_CFC)
! This module acts as a router for these various tracer modules and 
! routes the subroutine calls to the appropriate tracer module.
! It also maintains a (linked) list of all generic tracers created in 
! the experiment. This list acts as the "state" of generic tracers and
! contains all the information for all such tracers. This module provides
! a subroutine to query its state at any time. 
!</DESCRIPTION>
! <REFERENCE>
! http://cobweb.gfdl.noaa.gov/~nnz/MITeam_GUTS_022708.pdf 
! </REFERENCE>
! <REFERENCE>
! http://cobweb.gfdl.noaa.gov/~nnz/wiki/doku.php?id=genericunifiedtracers 
! </REFERENCE>
! 
!----------------------------------------------------------------

module generic_tracer

  use fms_mod,           only: open_namelist_file, close_file, check_nml_error  
  use field_manager_mod, only: fm_string_len
  use mpp_mod, only : input_nml_file, mpp_error, NOTE, WARNING, FATAL, stdout, stdlog
  use time_manager_mod, only : time_type
  use coupler_types_mod, only : coupler_2d_bc_type

  use g_tracer_utils, only : g_tracer_type, g_tracer_init, g_diag_type
  use g_tracer_utils, only : g_tracer_get_common, g_tracer_set_common, g_tracer_is_prog
  use g_tracer_utils, only : g_tracer_coupler_set,g_tracer_coupler_get, g_tracer_register_diag
  use g_tracer_utils, only : g_tracer_vertdiff_M, g_tracer_vertdiff_G, g_tracer_get_next     
  use g_tracer_utils, only : g_tracer_diag

  use generic_CFC,    only : generic_CFC_register
  use generic_CFC,    only : generic_CFC_init, generic_CFC_update_from_source,generic_CFC_update_from_coupler
  use generic_CFC,    only : generic_CFC_set_boundary_values, generic_CFC_end, do_generic_CFC

  use generic_ERGOM, only : generic_ERGOM_register, generic_ERGOM_register_diag
  use generic_ERGOM, only : generic_ERGOM_init, generic_ERGOM_update_from_source,generic_ERGOM_update_from_coupler
  use generic_ERGOM, only : generic_ERGOM_set_boundary_values, generic_ERGOM_end, do_generic_ERGOM
  use generic_ERGOM, only : generic_ERGOM_update_from_bottom

  use generic_TOPAZ,  only : generic_TOPAZ_register
  use generic_TOPAZ,  only : generic_TOPAZ_init, generic_TOPAZ_update_from_source,generic_TOPAZ_register_diag
  use generic_TOPAZ,  only : generic_TOPAZ_update_from_bottom,generic_TOPAZ_update_from_coupler
  use generic_TOPAZ,  only : generic_TOPAZ_set_boundary_values, generic_TOPAZ_end, do_generic_TOPAZ

  use generic_BLING,  only : generic_BLING_register
  use generic_BLING,  only : generic_BLING_init, generic_BLING_update_from_source,generic_BLING_register_diag
  use generic_BLING,  only : generic_BLING_update_from_bottom,generic_BLING_update_from_coupler
  use generic_BLING,  only : generic_BLING_set_boundary_values, generic_BLING_end, do_generic_BLING

  use generic_miniBLING_mod,  only : generic_miniBLING_register
  use generic_miniBLING_mod,  only : generic_miniBLING_init, generic_miniBLING_update_from_source,generic_miniBLING_register_diag
  use generic_miniBLING_mod,  only : generic_miniBLING_update_from_bottom,generic_miniBLING_update_from_coupler
  use generic_miniBLING_mod,  only : generic_miniBLING_set_boundary_values, generic_miniBLING_end, do_generic_miniBLING
  use generic_miniBLING_mod,  only : generic_miniBLING_diag

  use generic_COBALT,  only : generic_COBALT_register
  use generic_COBALT,  only : generic_COBALT_init, generic_COBALT_update_from_source,generic_COBALT_register_diag
  use generic_COBALT,  only : generic_COBALT_update_from_bottom,generic_COBALT_update_from_coupler
  use generic_COBALT,  only : generic_COBALT_set_boundary_values, generic_COBALT_end, do_generic_COBALT

  implicit none ; private

  character(len=fm_string_len), parameter :: mod_name       = 'generic_tracer'
  character(len=fm_string_len), parameter :: package_name   = 'generic_tracer'

  public generic_tracer_register
  public generic_tracer_init
  public generic_tracer_register_diag
  public generic_tracer_source
  public generic_tracer_diag
  public generic_tracer_update_from_bottom
  public generic_tracer_coupler_get
  public generic_tracer_coupler_set
  public generic_tracer_coupler_zero
  public generic_tracer_end
  public generic_tracer_get_list
  public do_generic_tracer
  public generic_tracer_vertdiff_G
  public generic_tracer_vertdiff_M
  public generic_tracer_get_diag_list


  !Linked Lists of all prog and diag tracers in this module
  !Ensure these pointers are "save"d between the calls
  type(g_tracer_type), save, pointer :: tracer_list => NULL()

  !Linked Lists of diagnostics fields (specially those that need to be manipulated by the ocean model)
  !Ensure these pointers are "save"d between the calls
  type(g_diag_type), save, pointer :: diag_list => NULL()

  logical, save :: do_generic_tracer = .false.

  !JGJ 2013/05/31  merged COBALT into siena_201303
  namelist /generic_tracer_nml/ do_generic_tracer, do_generic_CFC, do_generic_TOPAZ,    &
       do_generic_ERGOM, do_generic_BLING, do_generic_miniBLING, do_generic_COBALT

contains


  subroutine generic_tracer_register

    integer :: ioun, io_status, ierr
    integer :: stdoutunit,stdlogunit
    character(len=fm_string_len), parameter :: sub_name = 'generic_tracer_register'

    stdoutunit=stdout();stdlogunit=stdlog()
    ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=generic_tracer_nml, iostat=io_status)
ierr = check_nml_error(io_status,'generic_tracer_nml')
#else
    ioun = open_namelist_file()
    read  (ioun, generic_tracer_nml,iostat=io_status)
    ierr = check_nml_error(io_status,'generic_tracer_nml')
    call close_file (ioun)
#endif

    write (stdoutunit,'(/)')
    write (stdoutunit, generic_tracer_nml)
    write (stdlogunit, generic_tracer_nml)

    if(do_generic_CFC) &
         call generic_CFC_register(tracer_list)

    if(do_generic_TOPAZ) &
         call generic_TOPAZ_register(tracer_list)

    if(do_generic_ERGOM) &
         call generic_ERGOM_register(tracer_list)

    if(do_generic_BLING) &
         call generic_BLING_register(tracer_list)

    if(do_generic_miniBLING) &
         call generic_miniBLING_register(tracer_list)

    if(do_generic_COBALT) &
         call generic_COBALT_register(tracer_list)

  end subroutine generic_tracer_register


  ! <SUBROUTINE NAME="generic_tracer_init">
  !  <OVERVIEW>
  !   Initialize generic tracers
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Reads the namelist generic_tracer_nml to find the requested tracer packages
  !   Sets the common properties to be used by ALL generic tracers: isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,axes,grid_tmask,init_time
  !   Initialize each requested generic tracer package by calling their init routine
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_tracer_init(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,axes,grid_tmask,init_time)
  !  </TEMPLATE>
  !  <IN NAME="isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,axes(3)" TYPE="integer">
  !   Domain boundaries,
  !   ntau: number of time steps retained in the concentration field
  !   axes(3): diag axes
  !  </IN>
  !  <IN NAME="init_time" TYPE="">
  !   
  !  </IN>
  !  <IN NAME="" TYPE="type(time_type)">
  !   Initiation time
  !  </IN>
  !  <IN NAME="grid_tmask" TYPE="real, dimension(:,:,:),target">
  !   Grid mask
  !  </IN>
  ! </SUBROUTINE>
  subroutine generic_tracer_init(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,axes,grid_tmask,grid_kmt,init_time)
    integer,                       intent(in) :: isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,axes(3)
    type(time_type),               intent(in) :: init_time
    real, dimension(:,:,:),target, intent(in) :: grid_tmask
    integer, dimension(:,:)      , intent(in) :: grid_kmt
    type(g_tracer_type), pointer    :: g_tracer,g_tracer_next

    character(len=fm_string_len), parameter :: sub_name = 'generic_tracer_init'

    call g_tracer_set_common(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,axes,grid_tmask,grid_kmt,init_time) 

    !Allocate and initialize all registered generic tracers
    !JGJ 2013/05/31  merged COBALT into siena_201303
    if(do_generic_CFC .or. do_generic_TOPAZ .or. do_generic_ERGOM .or. do_generic_BLING .or. do_generic_miniBLING .or. do_generic_COBALT) then
       g_tracer => tracer_list        
       !Go through the list of tracers 
       do  
          call g_tracer_init(g_tracer)

          !traverse the linked list till hit NULL
          call g_tracer_get_next(g_tracer, g_tracer_next)
          if(.NOT. associated(g_tracer_next)) exit
          g_tracer=>g_tracer_next  

       enddo
    endif    

    !Initilalize specific tracers
    if(do_generic_CFC) &
         call generic_CFC_init(tracer_list)

    if(do_generic_TOPAZ) &
         call generic_TOPAZ_init(tracer_list)

    if(do_generic_ERGOM) &
         call generic_ERGOM_init(tracer_list)

    if(do_generic_BLING) &
         call generic_BLING_init(tracer_list)

    if(do_generic_miniBLING) &
         call generic_miniBLING_init(tracer_list)

    if(do_generic_COBALT) &
         call generic_COBALT_init(tracer_list)

  end subroutine generic_tracer_init

  subroutine generic_tracer_register_diag
    character(len=fm_string_len), parameter :: sub_name = 'generic_tracer_register_diag'
    type(g_tracer_type), pointer    :: g_tracer,g_tracer_next
    
    !Diagnostics register for the fields common to All generic tracers
    !JGJ 2013/05/31  merged COBALT into siena_201303

    if(do_generic_CFC .or. do_generic_TOPAZ .or. do_generic_ERGOM .or. do_generic_BLING .or. do_generic_miniBLING .or. do_generic_COBALT) then

       g_tracer => tracer_list        
       !Go through the list of tracers 
       do  
          call g_tracer_register_diag(g_tracer)

          !traverse the linked list till hit NULL
          call g_tracer_get_next(g_tracer, g_tracer_next)
          if(.NOT. associated(g_tracer_next)) exit
          g_tracer=>g_tracer_next  

       enddo
    endif    

    !Diagnostics register for fields particular to each tracer module
    
    if(do_generic_TOPAZ)  call generic_TOPAZ_register_diag(diag_list)    

    if(do_generic_ERGOM)  call generic_ERGOM_register_diag(diag_list)    

    if(do_generic_BLING)  call generic_BLING_register_diag()    
    
    if(do_generic_miniBLING)  call generic_miniBLING_register_diag()    

    if(do_generic_COBALT)  call generic_COBALT_register_diag(diag_list)

  end subroutine generic_tracer_register_diag

  ! <SUBROUTINE NAME="generic_tracer_coupler_get">
  !  <OVERVIEW>
  !   Get coupler values
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Calls the corresponding generic_X_update_from_coupler routine for each package X.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_tracer_coupler_get(IOB_struc) 
  !  </TEMPLATE>
  !  <IN NAME="IOB_struc" TYPE="type(coupler_2d_bc_type)">
  !   Ice Ocean Boundary flux structure
  !  </IN>
  ! </SUBROUTINE>

  subroutine generic_tracer_coupler_get(IOB_struc)
    type(coupler_2d_bc_type), intent(in)    :: IOB_struc

    character(len=fm_string_len), parameter :: sub_name = 'generic_tracer_coupler_get'
    !All generic tracers
    !Update tracer boundary values (%stf and %triver) from coupler fluxes foreach tracer in the prog_tracer_list
    call g_tracer_coupler_get(tracer_list,IOB_struc)

    !Specific tracers
    !    if(do_generic_CFC)    call generic_CFC_update_from_coupler(tracer_list) !Nothing to do

    if(do_generic_TOPAZ)  call generic_TOPAZ_update_from_coupler(tracer_list)

    if(do_generic_BLING)  call generic_BLING_update_from_coupler(tracer_list)

    if(do_generic_miniBLING)  call generic_miniBLING_update_from_coupler(tracer_list)

    if(do_generic_COBALT)  call generic_COBALT_update_from_coupler(tracer_list)

  end subroutine generic_tracer_coupler_get


  ! <SUBROUTINE NAME="generic_tracer_diag">
  !  <OVERVIEW>
  !   Do things which must be done after all transports and sources have been calculated
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Calls the corresponding generic_X_diag routine for each package X.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call  generic_tracer_diag(tau,model_time)
  !  </TEMPLATE>
  !  <IN NAME="ilb,jlb" TYPE="integer">
  !   Lower bounds of x and y extents of input arrays on data domain
  !  </IN>
  !  <IN NAME="tau" TYPE="integer">
  !   Time step index of %field
  !  </IN>
  !  <IN NAME="model_time" TYPE="time_type">
  !   Model time
  !  </IN>
  !  <IN NAME="dzt" TYPE="real, dimension(ilb:,jlb:,:)">
  !   Ocean layer thickness (meters)
  !  </IN>
  ! </SUBROUTINE>

  subroutine generic_tracer_diag(ilb, jlb, tau, taup1, dtts, model_time, dzt, rho_dzt_tau, rho_dzt_taup1)
    integer,                        intent(in) :: ilb
    integer,                        intent(in) :: jlb
    integer,                        intent(in) :: tau
    integer,                        intent(in) :: taup1
    real,                           intent(in) :: dtts
    type(time_type),                intent(in) :: model_time
    real, dimension(ilb:,jlb:,:),   intent(in) :: dzt
    real, dimension(ilb:,jlb:,:),   intent(in) :: rho_dzt_tau
    real, dimension(ilb:,jlb:,:),   intent(in) :: rho_dzt_taup1

    character(len=fm_string_len), parameter :: sub_name = 'generic_tracer_update_from_diag'

    if(do_generic_miniBLING)  call generic_miniBLING_diag(tracer_list, ilb, jlb, taup1, model_time, dzt, rho_dzt_taup1)

    call g_tracer_diag(tracer_list, ilb, jlb, rho_dzt_tau, rho_dzt_taup1, model_time, tau, taup1, dtts)

    return

  end subroutine generic_tracer_diag


  ! <SUBROUTINE NAME="generic_tracer_source">
  !  <OVERVIEW>
  !   Update the tracers from sources/sinks
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Calls the corresponding generic_X_update_from_source routine for each package X.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call  generic_tracer_source(Temp,Salt,rho_dzt,dzt,hblt_depth,ilb,jlb,tau,dtts,&
  !                               grid_dat,sw_pen,opacity,river,neutralrho,grid_yt)
  !  </TEMPLATE>
  !  </IN>
  !  <IN NAME="ilb,jlb" TYPE="integer">
  !   Lower bounds of x and y extents of input arrays on data domain
  !  </IN>
  !  <IN NAME="Temp" TYPE="real, dimension(ilb:,jlb:,:)">
  !   Ocean temperature   
  !  </IN>
  !  <IN NAME="Salt" TYPE="real, dimension(ilb:,jlb:,:)">
  !   Ocean salinity
  !  </IN>
  !  <IN NAME="dzt" TYPE="real, dimension(ilb:,jlb:,:)">
  !   Ocean layer thickness (meters)
  !  </IN>
  !  <IN NAME="opacity" TYPE="real, dimension(ilb:,jlb:,:)">
  !   Ocean opacity
  !  </IN>
  !  <IN NAME="sw_pen" TYPE="real, dimension(ilb:,jlb:)">
  !   Shortwave peneteration
  !  </IN>
  !  <IN NAME="hblt_depth" TYPE="real, dimension(ilb:,jlb:)">
  !   
  !  </IN>
  !  <IN NAME="grid_dat" TYPE="real, dimension(ilb:,jlb:)">
  !   Grid area
  !  </IN>
  !  <IN NAME="tau" TYPE="integer">
  !   Time step index of %field
  !  </IN>
  !  <IN NAME="dt" TYPE="real">
  !   Time step increment
  !  </IN>
  ! </SUBROUTINE>

  subroutine generic_tracer_source(Temp,Salt,rho_dzt,dzt,hblt_depth,ilb,jlb,tau,dtts,&
       grid_dat,model_time,nbands,max_wavelength_band,sw_pen_band,opacity_band,      &
       grid_ht, current_wave_stress)
    real, dimension(ilb:,jlb:,:),   intent(in) :: Temp,Salt,rho_dzt,dzt
    real, dimension(ilb:,jlb:),     intent(in) :: hblt_depth
    integer,                        intent(in) :: ilb,jlb,tau
    real,                           intent(in) :: dtts
    real, dimension(ilb:,jlb:),     intent(in) :: grid_dat
    type(time_type),                intent(in) :: model_time
    integer,                        intent(in) :: nbands
    real, dimension(:),             intent(in) :: max_wavelength_band
    real, dimension(:,ilb:,jlb:),   intent(in) :: sw_pen_band
    real, dimension(:,ilb:,jlb:,:), intent(in) :: opacity_band
    real, dimension(ilb:,jlb:),optional, intent(in) :: grid_ht
    real, dimension(ilb:,jlb:),optional ,    intent(in) :: current_wave_stress


    character(len=fm_string_len), parameter :: sub_name = 'generic_tracer_update_from_source'

    !    if(do_generic_CFC)    call generic_CFC_update_from_source(tracer_list) !Nothing to do for CFC

    if(do_generic_TOPAZ)  call generic_TOPAZ_update_from_source(tracer_list,Temp,Salt,rho_dzt,dzt,&
         hblt_depth,ilb,jlb,tau,dtts,grid_dat,model_time,&
         nbands,max_wavelength_band,sw_pen_band,opacity_band)

    if(do_generic_ERGOM)  call generic_ERGOM_update_from_source(tracer_list,Temp,Salt,rho_dzt,dzt,&
         hblt_depth,ilb,jlb,tau,dtts,grid_dat,model_time,&
         nbands,max_wavelength_band,sw_pen_band,opacity_band,current_wave_stress)

    if(do_generic_BLING)  call generic_BLING_update_from_source(tracer_list,Temp,Salt,rho_dzt,dzt,&
         hblt_depth,ilb,jlb,tau,dtts,grid_dat,model_time,&
         nbands,max_wavelength_band,sw_pen_band,opacity_band)

    if(do_generic_miniBLING)  call generic_miniBLING_update_from_source(tracer_list,Temp,Salt,rho_dzt,dzt,&
         hblt_depth,ilb,jlb,tau,dtts,grid_dat,model_time,&
         nbands,max_wavelength_band,sw_pen_band,opacity_band, grid_ht)

    if(do_generic_COBALT)  call generic_COBALT_update_from_source(tracer_list,Temp,Salt,rho_dzt,dzt,&
         hblt_depth,ilb,jlb,tau,dtts,grid_dat,model_time,&
         nbands,max_wavelength_band,sw_pen_band,opacity_band)

    return

  end subroutine generic_tracer_source

  ! <SUBROUTINE NAME="generic_tracer_update_from_bottom">
  !  <OVERVIEW>
  !   Update the tracers from bottom fluxes
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Calls the corresponding generic_X_update_from_bottom routine for each package X.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_tracer_update_from_bottom(dt, tau, model_time)
  !  </TEMPLATE>
  !  <IN NAME="dt" TYPE="real">
  !   Time step increment
  !  </IN>
  !  <IN NAME="tau" TYPE="integer">
  !   Time step index used for the concentration field   
  !  </IN>
  ! </SUBROUTINE>

  subroutine generic_tracer_update_from_bottom(dt, tau, model_time)
    real,    intent(in) :: dt
    integer, intent(in) ::tau
    type(time_type),                intent(in) :: model_time

    character(len=fm_string_len), parameter :: sub_name = 'generic_tracer_update_from_bottom'

    !    if(do_generic_CFC)    call generic_CFC_update_from_bottom(tracer_list)!Nothing to do for CFC 

    if(do_generic_TOPAZ)  call generic_TOPAZ_update_from_bottom(tracer_list,dt, tau, model_time)

    if(do_generic_ERGOM)  call generic_ERGOM_update_from_bottom(tracer_list,dt, tau, model_time)
   
    if(do_generic_BLING)  call generic_BLING_update_from_bottom(tracer_list,dt, tau)

    if(do_generic_miniBLING)  call generic_miniBLING_update_from_bottom(tracer_list,dt, tau)

    if(do_generic_COBALT)  call generic_COBALT_update_from_bottom(tracer_list,dt, tau, model_time)

    return

  end subroutine generic_tracer_update_from_bottom


  ! <SUBROUTINE NAME="generic_tracer_vertdiff_G">
  !  <OVERVIEW>
  !   Vertically diffuse all generic tracers for GOLD ocean
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   This subroutine use a tridiagonal solver to update the values
  !   of concentration field from vertical diffusion.
  !   The implicit vertdiff for these tracers should be disabled in the Ocean model.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_tracer_vertdiff_G(h_old, ea, eb, dt, Rho_0,tau)
  !  </TEMPLATE>
  !  <IN NAME="" TYPE="">
  !   
  !  </IN>
  ! </SUBROUTINE>
  subroutine generic_tracer_vertdiff_G(h_old, ea, eb, dt, kg_m2_to_H, m_to_H, tau)
    real, dimension(:,:,:), intent(in) :: h_old, ea, eb
    real,                   intent(in) :: dt, kg_m2_to_H, m_to_H
    integer,                intent(in) :: tau
    type(g_tracer_type), pointer    :: g_tracer,g_tracer_next

    !nnz: Should I loop here or inside the sub g_tracer_vertdiff ?    
    !JGJ 2013/05/31  merged COBALT into siena_201303
    if(do_generic_CFC .or. do_generic_TOPAZ .or. do_generic_ERGOM .or. do_generic_BLING .or. do_generic_miniBLING .or. do_generic_COBALT) then

       g_tracer => tracer_list        
       !Go through the list of tracers 
       do  
          if(g_tracer_is_prog(g_tracer)) &
             call g_tracer_vertdiff_G(g_tracer,h_old, ea, eb, dt, kg_m2_to_H, m_to_H, tau)

          !traverse the linked list till hit NULL
          call g_tracer_get_next(g_tracer, g_tracer_next)
          if(.NOT. associated(g_tracer_next)) exit
          g_tracer=>g_tracer_next  

       enddo
    endif

  end subroutine generic_tracer_vertdiff_G

  ! <SUBROUTINE NAME="">
  !  <OVERVIEW>
  !   
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call 
  !  </TEMPLATE>
  !  <IN NAME="" TYPE="">
  !   
  !  </IN>
  ! </SUBROUTINE>
  subroutine generic_tracer_vertdiff_M(dh, dhw, diff_cbt, dt, Rho_0,tau)
    real, dimension(:,:,:), intent(in) :: dh, dhw, diff_cbt
    real,                   intent(in) :: dt,Rho_0
    integer,                intent(in) :: tau
    type(g_tracer_type), pointer    :: g_tracer,g_tracer_next

    !nnz: Should I loop here or inside the sub g_tracer_vertdiff ?    
    !JGJ 2013/05/31  merged COBALT into siena_201303
    if(do_generic_CFC .or. do_generic_TOPAZ .or. do_generic_ERGOM .or. do_generic_BLING .or. do_generic_miniBLING .or. do_generic_COBALT) then

       g_tracer => tracer_list        
       !Go through the list of tracers 
       do  
          if(g_tracer_is_prog(g_tracer)) &
               call g_tracer_vertdiff_M(g_tracer,dh, dhw, diff_cbt, dt, Rho_0,tau) 

          !traverse the linked list till hit NULL
          call g_tracer_get_next(g_tracer, g_tracer_next)
          if(.NOT. associated(g_tracer_next)) exit
          g_tracer=>g_tracer_next  

       enddo
    endif

  end subroutine generic_tracer_vertdiff_M

  ! <SUBROUTINE NAME="generic_tracer_coupler_set">
  !  <OVERVIEW>
  !   Set the coupler values for each generic tracer
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Calls the corresponding generic_X_set_boundary_values routine for each package X.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_tracer_coupler_set(IOB_struc, ST,SS,rho,ilb,jlb,tau)
  !  </TEMPLATE>
  !  <IN NAME="IOB_struc" TYPE="type(coupler_2d_bc_type)">
  !   Ice Ocean Boundary flux structure
  !  </IN>
  !  <IN NAME="ilb,jlb" TYPE="integer">
  !   Lower bounds of x and y extents of input arrays on data domain
  !  </IN>
  !  <IN NAME="ST" TYPE="real, dimension(ilb:,jlb:)">
  !   Sea Surface Temperature   
  !  </IN>
  !  <IN NAME="SS" TYPE="real, dimension(ilb:,jlb:)">
  !   Sea Surface Salinity
  !  </IN>
  !  <IN NAME="rho" TYPE="real, dimension(ilb:,jlb:,:,:)">
  !   Ocean density
  !  </IN>
  !  <IN NAME="tau" TYPE="integer">
  !   Time step index of %field
  !  </IN>
  ! </SUBROUTINE>
  subroutine generic_tracer_coupler_set(IOB_struc, ST,SS,rho,ilb,jlb,tau)
    type(coupler_2d_bc_type), intent(inout) :: IOB_struc
    integer, intent(in) :: ilb,jlb,tau
    real, dimension(ilb:,jlb:),  intent(in) :: ST,SS
    real, dimension(ilb:,jlb:,:,:), intent(in)              :: rho

    character(len=fm_string_len), parameter :: sub_name = 'generic_tracer_coupler_set'

    !Set coupler fluxes from tracer boundary values (%stf and %triver)for each tracer in the prog_tracer_list
    !User must identify these tracers (not all tracers in module need to set coupler)
    !User must provide the calculations for these boundary values.

    if(do_generic_CFC) &
         call generic_CFC_set_boundary_values(tracer_list,ST,SS,rho,ilb,jlb,tau)

    if(do_generic_TOPAZ) &
         call generic_TOPAZ_set_boundary_values(tracer_list,ST,SS,rho,ilb,jlb,tau)

    if(do_generic_ERGOM) &
         call generic_ERGOM_set_boundary_values(tracer_list,ST,SS,rho,ilb,jlb,tau)

    if(do_generic_BLING) &
         call generic_BLING_set_boundary_values(tracer_list,ST,SS,rho,ilb,jlb,tau)
    !
    if(do_generic_miniBLING) &
         call generic_miniBLING_set_boundary_values(tracer_list,ST,SS,rho,ilb,jlb,tau)

    if(do_generic_COBALT) &
         call generic_COBALT_set_boundary_values(tracer_list,ST,SS,rho,ilb,jlb,tau)

    !
    !Set coupler fluxes from tracer boundary values (%alpha and %csurf)
    !for each tracer in the tracer_list that has been marked by the user routine above
    !JGJ 2013/05/31  merged COBALT into siena_201303
    !
    if(do_generic_CFC .or. do_generic_TOPAZ .or. do_generic_ERGOM .or. do_generic_BLING .or. do_generic_miniBLING .or. do_generic_COBALT) &
       call g_tracer_coupler_set(tracer_list,IOB_struc)

  end subroutine generic_tracer_coupler_set

  ! <SUBROUTINE NAME="generic_tracer_coupler_zero">
  !  <OVERVIEW>
  !   Zero out the coupler values for each tracer
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Set the coupler arrays for ALL generic tracers to 0
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call 
  !  </TEMPLATE>
  !  <IN NAME="IOB_struc" TYPE="type(coupler_2d_bc_type)">
  !   Ice Ocean Boundary flux structure
  !  </IN>
  ! </SUBROUTINE>
  subroutine generic_tracer_coupler_zero(IOB_struc)
    type(coupler_2d_bc_type), intent(inout) :: IOB_struc
    !Generic tracer coupler values are not accumulative. No need to set them to zero
!    call g_tracer_coupler_set(tracer_list,IOB_struc,value=0.0)
  end subroutine generic_tracer_coupler_zero

  ! <SUBROUTINE NAME="generic_tracer_end">
  !  <OVERVIEW>
  !   End this module by calling the corresponding generic_X_end for each package X.
  !  </OVERVIEW>
  !  <TEMPLATE>
  !   call generic_tracer_end
  !  </TEMPLATE>
  ! </SUBROUTINE>
  subroutine generic_tracer_end
    character(len=fm_string_len), parameter :: sub_name = 'generic_tracer_end'
    if(do_generic_CFC) call generic_CFC_end
    if(do_generic_TOPAZ)  call generic_TOPAZ_end
    if(do_generic_ERGOM)  call generic_ERGOM_end
    if(do_generic_BLING)  call generic_BLING_end
    if(do_generic_miniBLING)  call generic_miniBLING_end
    if(do_generic_COBALT)  call generic_COBALT_end

  end subroutine generic_tracer_end

  ! <SUBROUTINE NAME="generic_tracer_get_list">
  !  <OVERVIEW>
  !   Get a pointer to the head of the generic tracers list
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   The (linked) list of all generic tracers acts as the "state"
  !   of the generic tracers. This routine provides a way to get
  !   this state at any time.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_tracer_get_list(list)
  !  </TEMPLATE>
  !  <IN NAME="list" TYPE="type(g_tracer_type),    pointer">
  !   Pointer to head of the linked list
  !  </IN>
  ! </SUBROUTINE>

  subroutine generic_tracer_get_list(list)
    type(g_tracer_type),    pointer    :: list
    list => tracer_list
  end subroutine generic_tracer_get_list

  subroutine generic_tracer_get_diag_list(list)
    type(g_diag_type),    pointer    :: list
    list => diag_list
  end subroutine generic_tracer_get_diag_list

end module generic_tracer

module ocean_rivermix_mod
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> M.J. Harrison 
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">  K.W. Dixon 
!</CONTACT>
!
!<OVERVIEW>
! Tracer source from discharging river with depth or 
! mixing rivers with depth. 
!</OVERVIEW>
!
!<DESCRIPTION>
! Compute thickness weighted tendency [tracer*rho*meter/sec]
! associated with discharge of river tracer content 
! over a user defined column of ocean points. Points are
! selected based on whether river flow into a point is nonzero.
! Contribution added to tracer source array.
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies, M.J. Harrison, R. C. Pacanowski, and A. Rosati
! A Guide to MOM4 (2003)
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
! <NOTE>
! Algorithm ensures total tracer is conserved.  Note that volume/mass is 
! modified by river water within the eta-equation using the big leap-frog.  
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_rivermix_nml">
!  <DATA NAME="use_this_module"  TYPE="logical">
!  Must be true to enable this module.  Default=.true., since
!  this is the only way that tracer in river water enters the ocean. 
!  </DATA>
!
! <DATA NAME="discharge_combine_runoff_calve"  TYPE="logical">
!  Set discharge_combine_runoff_calve=.true. to discharge combined tracer carried
!  by liquid and solid runoff. This approach is sensible when ocean 
!  assigns a tracer content to the liquid and solid runoff fields.  
!  The alternative is to have a land model that provides information about
!  the tracer coming into the ocean from land water, in which case it is 
!  preferable to set discharge_combine_runoff_calve=.false., so to do the runoff 
!  and calving separately.  
!  Default discharge_combine_runoff_calve=.true. 
!  </DATA>
!
!  <DATA NAME="river_insertion_thickness" TYPE="real" UNITS="meter">
!  Thickness of the column over which to insert tracers from 
!  rivers. Default river_insertion_thickness=0.0 (all in top).
!  </DATA>
!  <DATA NAME="runoff_insertion_thickness" TYPE="real" UNITS="meter">
!  Thickness of the column over which to insert tracers carried by 
!  liquid runoff. Default runoff_insertion_thickness=0.0 (all in top).
!  </DATA>
!  <DATA NAME="calving_insertion_thickness" TYPE="real" UNITS="meter">
!  Thickness of the column over which to insert tracers carried by 
!  solid runoff. Default calving_insertion_thickness=0.0 (all in top).
!  </DATA>
!
!  <DATA NAME="river_diffusion_thickness" TYPE="real" UNITS="meter">
!  Thickness of the column over which to diffuse tracers from 
!  rivers. 
!  </DATA> 
!  <DATA NAME="river_diffusivity" TYPE="real" UNITS="m^2/s">
!  Vertical diffusivity enhancement at river mouths which is applied 
!  to a depth of river_diffusion_thickness, with linear tapering to zero
!  enhancement from the ocean surface to river_diffusion_thickness. 
!  </DATA> 
!  <DATA NAME="river_diffuse_temp" TYPE="logical">
!  Logical to determine if enhance vertical diffusion of temp at river mouths 
!  </DATA> 
!  <DATA NAME="river_diffuse_salt" TYPE="logical">
!  Logical to determine if enhance vertical diffusion of salt and all other 
!  passive tracers at river mouths 
!  </DATA> 
!
!  <DATA NAME="do_bitwise_exact_sum" TYPE="logical">
!  Set true to do bitwise exact global sum. When it is false, the global
!  sum will be non-bitwise_exact, but will significantly increase efficiency. 
!  The default value is do_bitwise_exact_sum=.false.
!  </DATA> 
!
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging 
!  </DATA> 
!  <DATA NAME="debug_all_in_top_cell" TYPE="logical">
!  For debugging, by placing all in top cell, regardless value of 
!  river_insertion_thickness.
!  </DATA> 
!  <DATA NAME="debug_this_module_heat" TYPE="logical">
!  For debugging, print global sum of heating rate by river water. 
!  </DATA> 
!</NAMELIST>
!

use axis_utils_mod,      only: frac_index, nearest_index
use constants_mod,       only: epsln
use diag_manager_mod,    only: register_diag_field
use fms_mod,             only: write_version_number, open_namelist_file, check_nml_error, close_file
use fms_mod,             only: FATAL, NOTE, stdout, stdlog 
use mpp_domains_mod,     only: domain2D, mpp_global_sum
use mpp_domains_mod,     only: BITWISE_EXACT_SUM, NON_BITWISE_EXACT_SUM
use mpp_mod,             only: input_nml_file, mpp_error

use ocean_domains_mod,     only: get_local_indices
use ocean_parameters_mod,  only: missing_value, rho0r
use ocean_types_mod,       only: ocean_domain_type, ocean_grid_type, ocean_thickness_type 
use ocean_types_mod,       only: ocean_time_type, ocean_time_steps_type, ocean_options_type
use ocean_types_mod,       only: ocean_prog_tracer_type, ocean_external_mode_type, ocean_density_type
use ocean_workspace_mod,   only: wrk1, wrk2, wrk3, wrk4, wrk5, wrk1_2d 
use ocean_util_mod,        only: diagnose_2d, diagnose_3d, diagnose_sum
use ocean_tracer_util_mod, only: diagnose_3d_rho

implicit none

private 

public ocean_rivermix_init
public rivermix
private river_discharge_tracer
private runoff_calving_discharge_tracer
private river_kappa
private watermass_diag_init
private watermass_diag_river
private watermass_diag_runoff
private watermass_diag_calving 


type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

real    :: river_insertion_thickness=0.0   ! static thickness (m) of ocean column where discharge rivers.  
                                           ! actual thickness is based on model grid spacing. min thickness=dtz(1).
real    :: runoff_insertion_thickness=0.0  ! static thickness (m) of ocean column where discharge liquid runoff.
                                           ! actual thickness is based on model grid spacing. min thickness=dtz(1).
real    :: calving_insertion_thickness=0.0 ! static thickness (m) of ocean column where discharge solid runoff.
                                           ! actual thickness is based on model grid spacing. min thickness=dtz(1).

real    :: river_diffusion_thickness=0.0 ! static thickness (m) of ocean column where diffuse tracer at river mouths.    
                                         ! actual thickness is based on model grid spacing. min thickness=dtz(1).      
real    :: river_diffusivity=5.0e-3      ! enhancement to the vertical diffusivity (m^2/s) at river mouths 
logical :: river_diffuse_temp=.false.    ! to enhance diffusivity of temp at river mouths over river_thickness column
logical :: river_diffuse_salt=.false.    ! to enhance diffusivity of salt at river mouths over river_thickness column

logical :: discharge_combine_runoff_calve=.true. ! to discharge liquid+solid together  

! for bitwise exact global sums independent of PE number
logical :: do_bitwise_exact_sum = .false.
integer :: global_sum_flag

! for global area normalization
real    :: cellarea_r

real, dimension(:,:), allocatable :: tracer_flux

! internally set for computing watermass diagnostics
logical :: compute_watermass_diag = .false. 

! for diagnostics 
integer, dimension(:), allocatable :: id_rivermix
integer, dimension(:), allocatable :: id_rivermix_on_nrho
integer, dimension(:), allocatable :: id_runoffmix
integer, dimension(:), allocatable :: id_calvingmix
integer :: id_diff_cbt_river_t =-1
integer :: id_diff_cbt_river_s =-1

integer :: id_eta_tend_rivermix        =-1
integer :: id_eta_tend_runoffmix       =-1
integer :: id_eta_tend_calvingmix      =-1
integer :: id_eta_tend_rivermix_glob   =-1
integer :: id_eta_tend_runoffmix_glob  =-1
integer :: id_eta_tend_calvingmix_glob =-1

integer :: id_neut_rho_rivermix   =-1
integer :: id_neut_rho_runoffmix  =-1
integer :: id_pot_rho_runoffmix   =-1
integer :: id_neut_rho_calvingmix =-1

integer :: id_neut_rho_rivermix_on_nrho   =-1
integer :: id_neut_rho_runoffmix_on_nrho  =-1
integer :: id_neut_rho_calvingmix_on_nrho =-1

integer :: id_wdian_rho_rivermix   =-1
integer :: id_wdian_rho_runoffmix  =-1
integer :: id_wdian_rho_calvingmix =-1

integer :: id_wdian_rho_rivermix_on_nrho   =-1
integer :: id_wdian_rho_runoffmix_on_nrho  =-1
integer :: id_wdian_rho_calvingmix_on_nrho =-1

integer :: id_tform_rho_rivermix   =-1
integer :: id_tform_rho_runoffmix  =-1
integer :: id_tform_rho_calvingmix =-1

integer :: id_tform_rho_rivermix_on_nrho   =-1
integer :: id_tform_rho_runoffmix_on_nrho  =-1
integer :: id_tform_rho_calvingmix_on_nrho =-1


integer :: id_neut_rho_pbl_rv_kn          =-1
integer :: id_neut_rho_pbl_rv_kn_on_nrho  =-1
integer :: id_wdian_rho_pbl_rv_kn         =-1
integer :: id_wdian_rho_pbl_rv_kn_on_nrho =-1
integer :: id_tform_rho_pbl_rv_kn         =-1
integer :: id_tform_rho_pbl_rv_kn_on_nrho =-1

integer :: id_neut_temp_pbl_rv_kn          =-1
integer :: id_neut_temp_pbl_rv_kn_on_nrho  =-1
integer :: id_wdian_temp_pbl_rv_kn         =-1
integer :: id_wdian_temp_pbl_rv_kn_on_nrho =-1
integer :: id_tform_temp_pbl_rv_kn         =-1
integer :: id_tform_temp_pbl_rv_kn_on_nrho =-1

integer :: id_neut_salt_pbl_rv_kn          =-1
integer :: id_neut_salt_pbl_rv_kn_on_nrho  =-1
integer :: id_wdian_salt_pbl_rv_kn         =-1
integer :: id_wdian_salt_pbl_rv_kn_on_nrho =-1
integer :: id_tform_salt_pbl_rv_kn         =-1
integer :: id_tform_salt_pbl_rv_kn_on_nrho =-1


integer :: id_neut_rho_pbl_rv_pr          =-1
integer :: id_neut_rho_pbl_rv_pr_on_nrho  =-1
integer :: id_wdian_rho_pbl_rv_pr         =-1
integer :: id_wdian_rho_pbl_rv_pr_on_nrho =-1
integer :: id_tform_rho_pbl_rv_pr         =-1
integer :: id_tform_rho_pbl_rv_pr_on_nrho =-1

integer :: id_neut_temp_pbl_rv_pr          =-1
integer :: id_neut_temp_pbl_rv_pr_on_nrho  =-1
integer :: id_wdian_temp_pbl_rv_pr         =-1
integer :: id_wdian_temp_pbl_rv_pr_on_nrho =-1
integer :: id_tform_temp_pbl_rv_pr         =-1
integer :: id_tform_temp_pbl_rv_pr_on_nrho =-1

integer :: id_neut_salt_pbl_rv_pr          =-1
integer :: id_neut_salt_pbl_rv_pr_on_nrho  =-1
integer :: id_wdian_salt_pbl_rv_pr         =-1
integer :: id_wdian_salt_pbl_rv_pr_on_nrho =-1
integer :: id_tform_salt_pbl_rv_pr         =-1
integer :: id_tform_salt_pbl_rv_pr_on_nrho =-1


integer :: id_neut_rho_pbl_rn_kn          =-1
integer :: id_neut_rho_pbl_rn_kn_on_nrho  =-1
integer :: id_wdian_rho_pbl_rn_kn         =-1
integer :: id_wdian_rho_pbl_rn_kn_on_nrho =-1
integer :: id_tform_rho_pbl_rn_kn         =-1
integer :: id_tform_rho_pbl_rn_kn_on_nrho =-1

integer :: id_neut_temp_pbl_rn_kn          =-1
integer :: id_neut_temp_pbl_rn_kn_on_nrho  =-1
integer :: id_wdian_temp_pbl_rn_kn         =-1
integer :: id_wdian_temp_pbl_rn_kn_on_nrho =-1
integer :: id_tform_temp_pbl_rn_kn         =-1
integer :: id_tform_temp_pbl_rn_kn_on_nrho =-1

integer :: id_neut_salt_pbl_rn_kn          =-1
integer :: id_neut_salt_pbl_rn_kn_on_nrho  =-1
integer :: id_wdian_salt_pbl_rn_kn         =-1
integer :: id_wdian_salt_pbl_rn_kn_on_nrho =-1
integer :: id_tform_salt_pbl_rn_kn         =-1
integer :: id_tform_salt_pbl_rn_kn_on_nrho =-1


integer :: id_neut_rho_pbl_rn_pr          =-1
integer :: id_neut_rho_pbl_rn_pr_on_nrho  =-1
integer :: id_wdian_rho_pbl_rn_pr         =-1
integer :: id_wdian_rho_pbl_rn_pr_on_nrho =-1
integer :: id_tform_rho_pbl_rn_pr         =-1
integer :: id_tform_rho_pbl_rn_pr_on_nrho =-1

integer :: id_neut_temp_pbl_rn_pr          =-1
integer :: id_neut_temp_pbl_rn_pr_on_nrho  =-1
integer :: id_wdian_temp_pbl_rn_pr         =-1
integer :: id_wdian_temp_pbl_rn_pr_on_nrho =-1
integer :: id_tform_temp_pbl_rn_pr         =-1
integer :: id_tform_temp_pbl_rn_pr_on_nrho =-1

integer :: id_neut_salt_pbl_rn_pr          =-1
integer :: id_neut_salt_pbl_rn_pr_on_nrho  =-1
integer :: id_wdian_salt_pbl_rn_pr         =-1
integer :: id_wdian_salt_pbl_rn_pr_on_nrho =-1
integer :: id_tform_salt_pbl_rn_pr         =-1
integer :: id_tform_salt_pbl_rn_pr_on_nrho =-1


integer :: id_neut_rho_pbl_cl_kn          =-1
integer :: id_neut_rho_pbl_cl_kn_on_nrho  =-1
integer :: id_wdian_rho_pbl_cl_kn         =-1
integer :: id_wdian_rho_pbl_cl_kn_on_nrho =-1
integer :: id_tform_rho_pbl_cl_kn         =-1
integer :: id_tform_rho_pbl_cl_kn_on_nrho =-1

integer :: id_neut_temp_pbl_cl_kn          =-1
integer :: id_neut_temp_pbl_cl_kn_on_nrho  =-1
integer :: id_wdian_temp_pbl_cl_kn         =-1
integer :: id_wdian_temp_pbl_cl_kn_on_nrho =-1
integer :: id_tform_temp_pbl_cl_kn         =-1
integer :: id_tform_temp_pbl_cl_kn_on_nrho =-1

integer :: id_neut_salt_pbl_cl_kn          =-1
integer :: id_neut_salt_pbl_cl_kn_on_nrho  =-1
integer :: id_wdian_salt_pbl_cl_kn         =-1
integer :: id_wdian_salt_pbl_cl_kn_on_nrho =-1
integer :: id_tform_salt_pbl_cl_kn         =-1
integer :: id_tform_salt_pbl_cl_kn_on_nrho =-1


integer :: id_neut_rho_pbl_cl_pr          =-1
integer :: id_neut_rho_pbl_cl_pr_on_nrho  =-1
integer :: id_wdian_rho_pbl_cl_pr         =-1
integer :: id_wdian_rho_pbl_cl_pr_on_nrho =-1
integer :: id_tform_rho_pbl_cl_pr         =-1
integer :: id_tform_rho_pbl_cl_pr_on_nrho =-1

integer :: id_neut_temp_pbl_cl_pr          =-1
integer :: id_neut_temp_pbl_cl_pr_on_nrho  =-1
integer :: id_wdian_temp_pbl_cl_pr         =-1
integer :: id_wdian_temp_pbl_cl_pr_on_nrho =-1
integer :: id_tform_temp_pbl_cl_pr         =-1
integer :: id_tform_temp_pbl_cl_pr_on_nrho =-1

integer :: id_neut_salt_pbl_cl_pr          =-1
integer :: id_neut_salt_pbl_cl_pr_on_nrho  =-1
integer :: id_wdian_salt_pbl_cl_pr         =-1
integer :: id_wdian_salt_pbl_cl_pr_on_nrho =-1
integer :: id_tform_salt_pbl_cl_pr         =-1
integer :: id_tform_salt_pbl_cl_pr_on_nrho =-1


integer :: unit=6       ! processor zero writes to unit 6

! time step (sec)
real    :: dtime 

integer :: num_prog_tracers=0
integer :: index_temp=-1
integer :: index_salt=-1

character(len=128) :: version=&
       '$Id: ocean_rivermix.F90,v 20.0 2013/12/14 00:16:10 fms Exp $'
character (len=128) :: tagname=&
     '$Name: tikal $'

integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk

logical :: debug_this_module     = .false. 
logical :: debug_all_in_top_cell = .false.
logical :: debug_this_module_heat=.false.
logical :: module_is_initialized = .FALSE.
logical :: use_this_module       = .true.

namelist /ocean_rivermix_nml/ use_this_module, debug_this_module,   &
         debug_all_in_top_cell, debug_this_module_heat,             &
         river_diffuse_temp, river_diffuse_salt,                    & 
         river_diffusion_thickness, river_diffusivity,              &
         discharge_combine_runoff_calve, river_insertion_thickness, &
         runoff_insertion_thickness, calving_insertion_thickness,   &
         do_bitwise_exact_sum

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_rivermix_init">
!
! <DESCRIPTION>
! Initial set up for mixing of tracers at runoff points. 
! </DESCRIPTION>
!
  subroutine ocean_rivermix_init(Grid, Domain, Time, Time_steps, Dens, &
                                 T_prog, Ocean_options, debug)
  
    type(ocean_grid_type),        target, intent(in) :: Grid
    type(ocean_domain_type),      target, intent(in) :: Domain
    type(ocean_time_type),        intent(in)         :: Time 
    type(ocean_time_steps_type),  intent(in)         :: Time_steps
    type(ocean_density_type),     intent(in)         :: Dens 
    type(ocean_prog_tracer_type), intent(inout)      :: T_prog(:)
    type(ocean_options_type),     intent(inout)      :: Ocean_options
    logical, optional,            intent(in)         :: debug

    integer :: n, nz_insert, nz_diffuse
    integer :: io_status, ioun, ierr

    integer :: stdoutunit,stdlogunit 
    stdoutunit=stdout();stdlogunit=stdlog() 

    if ( module_is_initialized ) then 
      call mpp_error(FATAL, &
       '==>Error from ocean_rivermix_mod (ocean_rivermix_init): module already initialized')
    endif 

    module_is_initialized = .TRUE.

    call write_version_number(version, tagname)

    call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
    nk = Grid%nk

    Dom => Domain
    Grd => Grid

    dtime = Time_steps%dtts
    cellarea_r = 1.0/(epsln + Grd%tcellsurf)

    num_prog_tracers = size(T_prog(:))
    do n=1,num_prog_tracers
       if (T_prog(n)%name == 'temp') index_temp = n
       if (T_prog(n)%name == 'salt') index_salt = n
    enddo
    
    if (PRESENT(debug)) debug_this_module = debug

    ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_rivermix_nml, iostat=io_status)  
    ierr = check_nml_error(io_status,'ocean_rivermix_nml')
#else
    ioun =  open_namelist_file()
    read (ioun,ocean_rivermix_nml,IOSTAT=io_status)
    ierr = check_nml_error(io_status,'ocean_rivermix_nml')
    call close_file (ioun)
#endif
    write (stdlogunit,ocean_rivermix_nml)
    write (stdoutunit,'(/)') 
    write (stdoutunit,ocean_rivermix_nml)

    if(use_this_module) then 
      call mpp_error(NOTE,&
      '==>From ocean_rivermix_mod: Using rivermix module to mix liquid and/or solid runoff into the ocean.')
      Ocean_options%rivermix = 'Used rivermix module to mix liquid and/or solid runoff into ocean.'
    else
      call mpp_error(NOTE,&
      '==>From ocean_rivermix_mod: NOT using rivermix module. Will NOT mix river tracers into ocean. Is this what you wish?')
      Ocean_options%rivermix = 'Did NOT use rivermix module. River tracers NOT mixed into the ocean. '
      return
    endif 

    if(do_bitwise_exact_sum) then
       global_sum_flag = BITWISE_EXACT_SUM
    else
       global_sum_flag = NON_BITWISE_EXACT_SUM
    endif

    ! allocate for tracer flux in runoff or calving 
    allocate (tracer_flux(isd:ied,jsd:jed))
    tracer_flux=0.0

 
    if(discharge_combine_runoff_calve) then 
        write(stdoutunit,'(a)')'==>Note: discharging calving+runoff together. The alternative is to separately discharge. '

        ! get nominal thickness 
        nz_insert  = nearest_index(river_insertion_thickness,Grd%zw)
        nz_insert  = max(1,nz_insert)
        if(river_insertion_thickness==0.0) then 
            call mpp_error(NOTE, &
            '==>Note: resetting river_insertion_thickness to dzt(1). Discharge all river into top cell')  
        else 
            write(stdoutunit,'(a)')'==>Note: if using waterflux and rivers, then will'
            write(stdoutunit,'(a,i3,a)')'   discharge river tracer over ',nz_insert,' grid points in vertical'
        endif

    else 

        ! get nominal thickness 
        nz_insert  = nearest_index(runoff_insertion_thickness,Grd%zw)
        nz_insert  = max(1,nz_insert)
        if(runoff_insertion_thickness==0.0) then 
            call mpp_error(NOTE, &
            '==>Note: resetting runoff_insertion_thickness to dzt(1). Discharge all liquid runoff into top cell')  
        else 
            write(stdoutunit,'(a)')'==>Note: if using waterflux and liquid runoff, then will'
            write(stdoutunit,'(a,i3,a)')'   discharge liquid runoff tracer over ',nz_insert,' grid points in vertical'
        endif


        ! get nominal thickness 
        nz_insert  = nearest_index(calving_insertion_thickness,Grd%zw)
        nz_insert  = max(1,nz_insert)
        if(calving_insertion_thickness==0.0) then 
            call mpp_error(NOTE, &
            '==>Note: resetting calving_insertion_thickness to dzt(1). Discharge all solid runoff into top cell')  
        else 
            write(stdoutunit,'(a)')'==>Note: if using waterflux and solid runoff, then will'
            write(stdoutunit,'(a,i3,a)')'   discharge solid runoff tracer over ',nz_insert,' grid points in vertical'
        endif

    endif


    ! get nominal thickness over which to diffuse river
    nz_diffuse = nearest_index(river_diffusion_thickness,Grd%zw)    
    nz_diffuse = max(1,nz_diffuse)    

    if(river_diffuse_temp) then 
        if(Time_steps%aidif==0.0) then
            call mpp_error(FATAL, &
             '==>Error: aidif=1.0 must be set to allow stable time stepping with river_diffuse_temp=.true.')  
        endif
        if(river_diffusion_thickness==0.0) then 
            call mpp_error(NOTE, &
            '==>Note: resetting river_diffusion_thickness=dzt(1) for enhanced diff_cbt of temperature.')  
        else  
            write(stdoutunit,'(a,i3,a)') &
            ' ==>Note: enhance temp diff_cbt at rivers over ',nz_diffuse,' points in vertical'
            write(stdoutunit,'(a,e12.5,a)')&
            '          Do so by adding diffusivity of ',river_diffusivity,' m^2/s to diff_cbt(temp)'
        endif
    endif

    if(river_diffuse_salt) then 
        if(Time_steps%aidif==0.0) then
            call mpp_error(FATAL, &
             ' ==>Error: aidif=1.0 must be set to allow stable time stepping with river_diffuse_salt=.true.')  
        endif
        if(river_diffusion_thickness==0.0) then 
            call mpp_error(NOTE, &
            '==>Note: resetting river_diffusion_thickness=dzt(1) for enhanced diff_cbt of salt and passive')  
        else 
            write(stdoutunit,'(a,i3,a)') &
            ' ==>Note: enhance salt/passive diff_cbt at rivers over ',nz_diffuse,' points in vertical'
            write(stdoutunit,'(a,e12.5,a)') &
            '          Do so by adding diffusivity of ',river_diffusivity,' m^2/s to diff_cbt(salt)'
        endif
    endif

    ! register for diag_manager 
    allocate (id_rivermix(num_prog_tracers))
    allocate (id_rivermix_on_nrho(num_prog_tracers))
    allocate (id_runoffmix(num_prog_tracers))
    allocate (id_calvingmix(num_prog_tracers))
    id_rivermix   = -1
    id_rivermix_on_nrho   = -1
    id_runoffmix  = -1
    id_calvingmix = -1

    do n=1,num_prog_tracers
       if(T_prog(n)%name == 'temp') then 
           id_rivermix(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_rivermix', &
                            Grd%tracer_axes(1:3), Time%model_time,                                 &
                            'cp*rivermix*rho_dzt*temp', 'Watt/m^2',                                & 
                            missing_value=missing_value, range=(/-1.e10,1.e10/))
           id_rivermix_on_nrho(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_rivermix_on_nrho', &
                            Dens%neutralrho_axes(1:3), Time%model_time,                                 &
                            'cp*rivermix*rho_dzt*temp binned to neutral density', 'Watt/m^2',       &
                            missing_value=missing_value, range=(/-1.e20,1.e20/))
           id_runoffmix(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_runoffmix',&
                            Grd%tracer_axes(1:3), Time%model_time,                                  &
                            'cp*runoffmix*rho_dzt*temp', 'Watt/m^2',                                & 
                            missing_value=missing_value, range=(/-1.e10,1.e10/))
           id_calvingmix(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_calvingmix',&
                            Grd%tracer_axes(1:3), Time%model_time,                                    &
                            'cp*calvingmix*rho_dzt*temp', 'Watt/m^2',                                 & 
                            missing_value=missing_value, range=(/-1.e10,1.e10/))
       else
           id_rivermix(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_rivermix', &
                            Grd%tracer_axes(1:3), Time%model_time,                                 &
                            'rivermix*rho_dzt*tracer for '//trim(T_prog(n)%name),                  &
                            trim(T_prog(n)%flux_units),                                            &
                            missing_value=missing_value, range=(/-1.e10,1.e10/))
           id_rivermix_on_nrho(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_rivermix_on_nrho', &
                            Dens%neutralrho_axes(1:3), Time%model_time,                                 &
                            'rivermix*rho_dzt*tracer for '//trim(T_prog(n)%name)//' binned to neutral density',&
                            trim(T_prog(n)%flux_units),                                            &
                            missing_value=missing_value, range=(/-1.e10,1.e10/))
           id_runoffmix(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_runoffmix',&
                            Grd%tracer_axes(1:3), Time%model_time,                                  &
                            'runoffmix*rho_dzt*tracer for '//trim(T_prog(n)%name),                  &
                            trim(T_prog(n)%flux_units),                                             &
                            missing_value=missing_value, range=(/-1.e10,1.e10/))
           id_calvingmix(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_calvingmix',&
                            Grd%tracer_axes(1:3), Time%model_time,                                    &
                            'calvingmix*rho_dzt*tracer for '//trim(T_prog(n)%name),                   &
                            trim(T_prog(n)%flux_units),                                               &
                            missing_value=missing_value, range=(/-1.e10,1.e10/))
       endif
    enddo

    if(debug_all_in_top_cell) then 
        call mpp_error(NOTE, &
        '==>Note: in rivermix module, debug_all_in_top_cell=.true., so placing all river water to top cell.')
    endif

   id_diff_cbt_river_t = -1
   id_diff_cbt_river_t = register_diag_field ('ocean_model', 'diff_cbt_river_t', &
                         Grid%tracer_axes(1:3), Time%model_time,                 &
                         'diff_cbt(temp) enhancement at rivers', 'm^2/s',        &
                         missing_value=missing_value, range=(/-10.0,1e6/))

   id_diff_cbt_river_s = -1
   id_diff_cbt_river_s = register_diag_field ('ocean_model', 'diff_cbt_river_s', &
                         Grid%tracer_axes(1:3), Time%model_time,                 &
                         'diff_cbt(salt) enhancement at rivers', 'm^2/s',        &
                         missing_value=missing_value,range=(/-10.0,1e6/))

   call watermass_diag_init(Time, Dens)


  end subroutine ocean_rivermix_init
! </SUBROUTINE> NAME="ocean_rivermix_init"


!#######################################################################
! <SUBROUTINE NAME="rivermix">
!
! <DESCRIPTION>
! This subroutine computes one or all of the following: 
!
! (1) Thickness weighted and rho weighted tracer source associated 
! with river tracer content discharged into a vertical column of ocean 
! tracer cells. This is done if river_discharge=.true.
!
! (2) Enhance vertical diffusivity at river mouths. 
! This is done if river_diffuse_temp=.true. or 
! river_diffuse_salt=.true. 
!
! Doing one or both are useful for models with fine vertical  
! resolution, where discharging river content to top cell 
! is often not numerically suitable nor physically relevant.
!
! </DESCRIPTION>
!
subroutine rivermix (Time, Thickness, Dens, T_prog, river, runoff, calving, &
                     diff_cbt, index_temp, index_salt)

  type(ocean_time_type),          intent(in)     :: Time
  type(ocean_thickness_type),     intent(in)     :: Thickness
  type(ocean_density_type),       intent(in)     :: Dens
  type(ocean_prog_tracer_type),   intent(inout)  :: T_prog(:)
  integer,                        intent(in)     :: index_temp
  integer,                        intent(in)     :: index_salt
  real, dimension(isd:,jsd:),     intent(in)     :: river
  real, dimension(isd:,jsd:),     intent(in)     :: runoff
  real, dimension(isd:,jsd:),     intent(in)     :: calving 
  real, dimension(isd:,jsd:,:,:), intent(inout)  :: diff_cbt

  integer :: i,j,n,tau
  logical :: river_discharge  =.false.
  logical :: runoff_discharge =.false.
  logical :: calving_discharge=.false.

  if(.not. use_this_module) return

  if(.not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_rivermix_mod (rivermix): module must be initialized')
  endif 

  tau = Time%tau

  ! for discharging the combined runoff+calving fields  
  if(discharge_combine_runoff_calve) then 

      do n=1,num_prog_tracers  
        T_prog(n)%wrk1(:,:,:) = 0.0
      enddo  

      river_discharge=.false. 
      do j=jsc,jec
         do i=isc,iec
            if(river(i,j) > 0.0 .and. Grd%kmt(i,j) > 0) river_discharge=.true.
         enddo
      enddo
      if(river_discharge) then 
          call river_discharge_tracer(Time, Thickness, T_prog(1:num_prog_tracers), river)
      endif

      do n=1,num_prog_tracers 
         if(id_rivermix(n) > 0) then 
            call diagnose_3d(Time, Grd, id_rivermix(n), T_prog(n)%wrk1(:,:,:)*T_prog(n)%conversion)
         endif
         if(id_rivermix_on_nrho(n) > 0) then
            call diagnose_3d_rho(Time, Dens, id_rivermix_on_nrho(n), T_prog(n)%wrk1*T_prog(n)%conversion)
         endif
      enddo
      call watermass_diag_river(Time, Dens, T_prog, river, &
       T_prog(index_temp)%wrk1(:,:,:),T_prog(index_salt)%wrk1(:,:,:))


  ! for separately discharging liquid runoff and solid calving 
  else

      do n=1,num_prog_tracers  
        T_prog(n)%wrk1(:,:,:) = 0.0
      enddo  
      runoff_discharge=.false. 
      do j=jsc,jec
         do i=isc,iec
            if(runoff(i,j) > 0.0 .and. Grd%kmt(i,j) > 0) runoff_discharge=.true.
         enddo
      enddo
      if(runoff_discharge) then
          call runoff_calving_discharge_tracer(Time, Thickness, &
          T_prog(1:num_prog_tracers), runoff, runoff_insertion_thickness, 1)
      endif 
      do n=1,num_prog_tracers 
         if(id_runoffmix(n) > 0) then 
            call diagnose_3d(Time, Grd, id_runoffmix(n), T_prog(n)%wrk1(:,:,:)*T_prog(n)%conversion)
         endif
      enddo
      call watermass_diag_runoff(Time, Dens, T_prog, runoff, &
      T_prog(index_temp)%wrk1(:,:,:),T_prog(index_salt)%wrk1(:,:,:))

      
      do n=1,num_prog_tracers  
        T_prog(n)%wrk1(:,:,:) = 0.0
      enddo  
      calving_discharge=.false. 
      do j=jsc,jec
         do i=isc,iec
            if(calving(i,j) > 0.0 .and. Grd%kmt(i,j) > 0) calving_discharge=.true.
         enddo
      enddo
      if(calving_discharge) then
          call runoff_calving_discharge_tracer(Time, Thickness, &
          T_prog(1:num_prog_tracers), calving, calving_insertion_thickness, 2)
      endif 
      do n=1,num_prog_tracers 
         if(id_calvingmix(n) > 0) then 
            call diagnose_3d(Time, Grd, id_calvingmix(n), T_prog(n)%wrk1(:,:,:)*T_prog(n)%conversion)
         endif
      enddo
      call watermass_diag_calving(Time, Dens, T_prog, calving, &
      T_prog(index_temp)%wrk1(:,:,:),T_prog(index_salt)%wrk1(:,:,:))

      
  endif  ! discharge_combine_runoff_calve


  if(river_diffuse_temp) then 
     call river_kappa(Time, Thickness, T_prog(index_temp), diff_cbt(isd:ied,jsd:jed,:,1))
  endif 
  if(river_diffuse_salt) then 
     call river_kappa(Time, Thickness, T_prog(index_salt), diff_cbt(isd:ied,jsd:jed,:,2))
  endif 


end subroutine rivermix
! </SUBROUTINE> NAME="rivermix"


!#######################################################################
! <SUBROUTINE NAME="river_discharge_tracer">
!
! <DESCRIPTION>
! Compute thickness weighted tracer source [tracer*m/s]
! associated with the discharge of tracer from a river over 
! a vertical column whose thickness is set by River_insertion_thickness 
! and whose horizontal location is given by the river array. 
!
! Jan 2005: converted to mass weighting for use with non-Boussinesq
! pressure-like coodinates. 
!
! This subroutine is maintained for legacy purposes.
!
! </DESCRIPTION>
!
subroutine river_discharge_tracer (Time, Thickness, T_prog, river)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_prog_tracer_type),   intent(inout) :: T_prog(:)
  real, dimension(isd:,jsd:),     intent(in)    :: river

  integer :: i, j, k, n, nz
  integer :: tau
  real    :: depth, thkocean
  real    :: delta(nk), delta_rho_tocean(nk), delta_rho0_triver(nk)
  real    :: zextra, zinsert, tracerextra, tracernew(nk)
  real    :: tracer_input 
  
  integer :: stdoutunit 
  stdoutunit=stdout() 


  if(.not. use_this_module) return
  
  if(.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_rivermix_mod (river_discharge_tracer): module must be initialized')
  endif 

  tau   = Time%tau
  
  do n=1,num_prog_tracers  
    T_prog(n)%wrk1(:,:,:) = 0.0
  enddo  
  delta             = 0.0
  delta_rho_tocean  = 0.0
  delta_rho0_triver = 0.0
  wrk1              = 0.0
               
  do j=jsc,jec
     do i=isc,iec

        if (river(i,j) > 0.0 .and. Grd%kmt(i,j) > 0) then


        ! the array "river" contains the volume rate (m/s) or mass
        ! rate (kg/m2/sec) of fluid with tracer concentration triver
        ! that is to be distributed in the vertical. 

            depth = min(Grd%ht(i,j),river_insertion_thickness)        ! be sure not to discharge river content into rock 
            nz    = min(Grd%kmt(i,j),floor(frac_index(depth,Grd%zw))) ! number of k-levels into which discharge rivers
            nz    = max(1,nz)                                         ! make sure have at least one cell to discharge into

            ! determine fractional thicknesses of grid cells 
            thkocean = 0.0
            do k=1,nz
               thkocean = thkocean + Thickness%rho_dzt(i,j,k,tau)
            enddo
            do k=1,nz
               delta(k) = Thickness%rho_dzt(i,j,k,tau)/(epsln+thkocean)
            enddo


            do n=1,num_prog_tracers

! mix a portion of the river mass(volume) inserted over the course of a tracer timestep
! into each model level from k=1:nz, in proportion to the fractional cell thickness.
! The mixing scheme used here follows scheme devised by Keith Dixon to handle hydraulic
! control across xland mixing points
!
! The following schematic illustrates the scheme, assuming constant layer thickness
! neglecting free surface height variations and assuming the river insertion depth
! extends to the base of the third model level.  Each of these assumptions are for 
! purposes of this schematic only.  The scheme that is implemented works in general
! for non-constant cell thicknesses.  
!               
!                  Total depth = H; cell thickness = dz; River mass flux/timestep = R
!  x--------x
!  !        !
!  !        !  < === Insert  zinsert = R*dz/H meters of riverwater at a temperature of 
!  !        !        Triver + 2*zinsert meters of water at T*(2)
!  !        !        T*(1) = (T(1).dz + 3.T*(2).zinsert + Triver.zinsert ) / (dz + 3.zinsert)               
!  x--------x               
!  !        !
!  !        !  < === Insert  zinsert = R*dz/H meters of riverwater at a temperature of 
!  !        !        Triver + zinsert meters of water at T*(3)           
!  !        !        T*(2) = (T(2).dz + 2.T*(3).zinsert + Triver.zinsert ) / (dz + 2.zinsert)               
!  !        !
!  x--------x                              
!  !        !
!  !        !  < === Insert  zinsert = R*dz/H meters of riverwater at a temperature of Triver 
!  !        !        T*(3) = (T(3).dz + Triver.zinsert ) / (dz + zinsert)
!  !        !
!  xxxxxxxxxx               

               zextra=0.0
               do k=nz,1,-1
                  tracernew(k) = 0.0

                  if (k.eq.nz) then
                      tracerextra=0.0
                  else
                      tracerextra = tracernew(k+1)
                  endif

                  zinsert = river(i,j)*dtime*delta(k)
                  tracernew(k) = (tracerextra*zextra + T_prog(n)%field(i,j,k,tau)*Thickness%rho_dzt(i,j,k,tau) + &
                                  T_prog(n)%triver(i,j)*zinsert) / (zextra+Thickness%rho_dzt(i,j,k,tau)+zinsert)

                  zextra=zextra+zinsert
               enddo

               k=1
               T_prog(n)%wrk1(i,j,k) = (tracernew(k)*(Thickness%rho_dzt(i,j,k,tau)+river(i,j)*dtime) -&
                                        T_prog(n)%field(i,j,k,tau)*Thickness%rho_dzt(i,j,k,tau))/dtime
               do k=2,nz
                  T_prog(n)%wrk1(i,j,k) = Thickness%rho_dzt(i,j,k,tau)*(tracernew(k) - T_prog(n)%field(i,j,k,tau))/dtime
               enddo

               if(debug_all_in_top_cell) then 
                   k=1
                   T_prog(n)%wrk1(i,j,:) = 0.0
                   T_prog(n)%wrk1(i,j,k) = Grd%tmask(i,j,k)*river(i,j)*T_prog(n)%triver(i,j)
               endif

               do k=1,nz
                  T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + T_prog(n)%wrk1(i,j,k)
               enddo

               if (debug_this_module) then
                   write(6,*) 'i,j,n,river((kg/m^3)*m/sec),triver= ',i,j,n,river(i,j),T_prog(n)%triver(i,j)
                   do k=1,nz
                      write(6,*) 'i,j,k,tracer(k),tracernew(k),tendency(tracer*rho*thickness/sec)= ',&
                           i,j,k,T_prog(n)%field(i,j,k,tau),tracernew(k),T_prog(n)%wrk1(i,j,k)
                   enddo
               endif
                            
               
            enddo ! n end  

        endif ! river > 0

     enddo   ! i end
  enddo      ! j end


  if (debug_this_module_heat) then
          wrk1_2d(:,:) = 0.0
          do j=jsc,jec
             do i=isc,iec
                wrk1_2d(i,j) = Grd%tmask(i,j,1)*Grd%dat(i,j)*T_prog(index_temp)%conversion &
                               *river(i,j)*T_prog(index_temp)%triver(i,j)*dtime
             enddo
          enddo
          tracer_input = mpp_global_sum(Dom%domain2d,wrk1_2d(:,:), global_sum_flag)
          write(stdoutunit,'(a)')
          write (stdoutunit,'(a,es24.17,a)') ' Heat input via river (runoff+calving) in rivermix  = ',&
                                           tracer_input,' Joule'
          write(stdoutunit,'(a)')
  endif 


end subroutine river_discharge_tracer
! </SUBROUTINE> NAME="river_discharge_tracer"


!#######################################################################
! <SUBROUTINE NAME="runoff_calving_discharge_tracer">
!
! <DESCRIPTION>
! Compute thickness weighted tracer source [tracer*m/s]
! associated with the discharge of tracer from runoff or calving over 
! a vertical column whose thickness is set by either runoff_insertion_thickness 
! or calving_insertion_thickness, and whose horizontal location is given 
! by the runoff or calving array. 
!
! Jan 2005: converted to mass weighting for use with non-Boussinesq
! pressure-like coodinates. 
!
! Feb 2009: now use calving_tracer_flux and runoff_tracer_flux, as the 
! land model carries information about the tracer content in the 
! liquid and solid runoff.  
!
! </DESCRIPTION>
!
subroutine runoff_calving_discharge_tracer (Time, Thickness, T_prog, &
           river, insertion_thickness, runoff_type)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_prog_tracer_type),   intent(inout) :: T_prog(:)
  real, dimension(isd:,jsd:),     intent(in)    :: river
  real,                           intent(in)    :: insertion_thickness
  integer,                        intent(in)    :: runoff_type

  integer :: i, j, k, n, nz
  integer :: tau
  real    :: depth, thkocean
  real    :: delta(nk), delta_rho_tocean(nk), delta_rho0_triver(nk)
  real    :: zextra, zinsert, tracerextra, tracernew(nk)
  real    :: tracer_input 
  
  integer :: stdoutunit 
  stdoutunit=stdout() 


  if(.not. use_this_module) return
  
  if(.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_rivermix_mod (runoff_calving_discharge_tracer): module must be initialized')
  endif 

  tau   = Time%tau
  
  do n=1,num_prog_tracers  
    T_prog(n)%wrk1(:,:,:) = 0.0
  enddo  
  delta             = 0.0
  delta_rho_tocean  = 0.0
  delta_rho0_triver = 0.0
  wrk1              = 0.0
  tracer_flux       = 0.0
               
  do j=jsc,jec
     do i=isc,iec

        if (river(i,j) > 0.0 .and. Grd%kmt(i,j) > 0) then


        ! the array "river" contains the volume rate (m/s) or mass
        ! rate (kg/m2/sec) of fluid with tracer 
        ! that is to be distributed in the vertical. 

            depth = min(Grd%ht(i,j),insertion_thickness)              ! be sure not to discharge river content into rock 
            nz    = min(Grd%kmt(i,j),floor(frac_index(depth,Grd%zw))) ! number of k-levels into which discharge rivers
            nz    = max(1,nz)                                         ! make sure have at least one cell to discharge into

            ! determine fractional thicknesses of grid cells 
            thkocean = 0.0
            do k=1,nz
               thkocean = thkocean + Thickness%rho_dzt(i,j,k,tau)
            enddo
            do k=1,nz
               delta(k) = Thickness%rho_dzt(i,j,k,tau)/(epsln+thkocean)
            enddo


            do n=1,num_prog_tracers

! mix a portion of the river mass(volume) inserted over the course of a tracer timestep
! into each model level from k=1:nz, in proportion to the fractional cell thickness.
! The mixing scheme used here follows scheme devised by Keith Dixon to handle hydraulic
! control across xland mixing points
!
! The following schematic illustrates the scheme, assuming constant layer thickness
! neglecting free surface height variations and assuming the river insertion depth
! extends to the base of the third model level.  Each of these assumptions are for 
! purposes of this schematic only.  The scheme that is implemented works in general
! for non-constant cell thicknesses.  
!               
!                  Total depth = H; cell thickness = dz; River mass flux/timestep = R
!  x--------x
!  !        !
!  !        !  < === Insert  zinsert = R*dz/H meters of riverwater at a temperature of 
!  !        !        Triver + 2*zinsert meters of water at T*(2)
!  !        !        T*(1) = (T(1).dz + 3.T*(2).zinsert + Triver.zinsert ) / (dz + 3.zinsert)               
!  x--------x               
!  !        !
!  !        !  < === Insert  zinsert = R*dz/H meters of riverwater at a temperature of 
!  !        !        Triver + zinsert meters of water at T*(3)           
!  !        !        T*(2) = (T(2).dz + 2.T*(3).zinsert + Triver.zinsert ) / (dz + 2.zinsert)               
!  !        !
!  x--------x                              
!  !        !
!  !        !  < === Insert  zinsert = R*dz/H meters of riverwater at a temperature of Triver 
!  !        !        T*(3) = (T(3).dz + Triver.zinsert ) / (dz + zinsert)
!  !        !
!  xxxxxxxxxx               

               if(runoff_type==1) then 
                  tracer_flux(i,j) = T_prog(n)%runoff_tracer_flux(i,j)
               else 
                  tracer_flux(i,j) = T_prog(n)%calving_tracer_flux(i,j)
               endif

               zextra=0.0
               do k=nz,1,-1
                  tracernew(k) = 0.0

                  if (k.eq.nz) then
                      tracerextra=0.0
                  else
                      tracerextra = tracernew(k+1)
                  endif

                  zinsert = river(i,j)*dtime*delta(k)
                  tracernew(k) = (tracerextra*zextra + T_prog(n)%field(i,j,k,tau)*Thickness%rho_dzt(i,j,k,tau) + &
                                  tracer_flux(i,j)*dtime*delta(k)) / (zextra+Thickness%rho_dzt(i,j,k,tau)+zinsert)

                  zextra=zextra+zinsert
               enddo

               k=1
               T_prog(n)%wrk1(i,j,k) = (tracernew(k)*(Thickness%rho_dzt(i,j,k,tau)+river(i,j)*dtime) -&
                                        T_prog(n)%field(i,j,k,tau)*Thickness%rho_dzt(i,j,k,tau))/dtime
               do k=2,nz
                  T_prog(n)%wrk1(i,j,k) = Thickness%rho_dzt(i,j,k,tau)*(tracernew(k) - T_prog(n)%field(i,j,k,tau))/dtime
               enddo

               if(debug_all_in_top_cell) then 
                   k=1
                   T_prog(n)%wrk1(i,j,:) = 0.0
                   T_prog(n)%wrk1(i,j,k) = Grd%tmask(i,j,k)*river(i,j)*T_prog(n)%triver(i,j)
               endif

               do k=1,nz
                  T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + T_prog(n)%wrk1(i,j,k)
               enddo

               if (debug_this_module) then
                   write(6,*) 'i,j,n,river((kg/m^3)*m/sec),tracer_flux= ',i,j,n,river(i,j),tracer_flux(i,j)
                   do k=1,nz
                      write(6,*) 'i,j,k,tracer(k),tracernew(k),tendency(tracer*rho*thickness/sec)= ',&
                           i,j,k,T_prog(n)%field(i,j,k,tau),tracernew(k),T_prog(n)%wrk1(i,j,k)
                   enddo
               endif
                            
               
            enddo ! n end for number of prognostic tracers 

        endif ! river > 0

     enddo   ! i end
  enddo      ! j end



  if (debug_this_module_heat) then 

      if(runoff_type==1) then 
          wrk1_2d(:,:) = 0.0
          do j=jsc,jec
             do i=isc,iec
                wrk1_2d(i,j) = Grd%tmask(i,j,1)*Grd%dat(i,j)*T_prog(index_temp)%conversion &
                              *T_prog(index_temp)%runoff_tracer_flux(i,j)*dtime
             enddo
          enddo
          tracer_input = mpp_global_sum(Dom%domain2d,wrk1_2d(:,:), global_sum_flag)
          write(stdoutunit,'(a)')
          write (stdoutunit,'(a,es24.17,a)') ' Heat input via runoff in rivermix  = ',&
               tracer_input,' Joule'
          write(stdoutunit,'(a)')
      endif

      if(runoff_type==2) then 
          wrk1_2d(:,:) = 0.0
          do j=jsc,jec
             do i=isc,iec
                wrk1_2d(i,j) = Grd%tmask(i,j,1)*Grd%dat(i,j)*T_prog(index_temp)%conversion &
                              *T_prog(index_temp)%calving_tracer_flux(i,j)*dtime
             enddo
          enddo
          tracer_input = mpp_global_sum(Dom%domain2d,wrk1_2d(:,:), global_sum_flag)
          write(stdoutunit,'(a)')
          write (stdoutunit,'(a,es24.17,a)') ' Heat input via calving in rivermix  = ',&
               tracer_input,' Joule'
          write(stdoutunit,'(a)')
      endif

  endif

end subroutine runoff_calving_discharge_tracer
! </SUBROUTINE> NAME="runoff_calving_discharge_tracer"



!#######################################################################
! <SUBROUTINE NAME="river_kappa">
!
! <DESCRIPTION>
! This subroutine enhances the vertical diffusivity kappa over 
! a vertical column whose thickness is set by river_diffusion_thickness 
! and whose horizontal location is given by the rmask array.
! Note that rmask can be > 0 even if river=0 in the case when 
! use virtual salt flux.   
! The enhanced diffusivity is maximum at the top cell and is linearly 
! interpolated to the normal diffusivity at the depth set by 
! river_diffusion_thickness
! </DESCRIPTION>
!
subroutine river_kappa (Time, Thickness, Tracer, kappa)

  type(ocean_time_type),         intent(in)    :: Time
  type(ocean_thickness_type),    intent(in)    :: Thickness
  type(ocean_prog_tracer_type),  intent(in)    :: Tracer
  real, dimension(isd:,jsd:,:),  intent(inout) :: kappa

  integer :: i, j, k, nz
  real    :: depth 
  real, dimension(nk) :: zw_ij

  if(.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_rivermix_mod (river_kappa): module must be initialized')
  endif 

  wrk1=0.0

  do j=jsc,jec
     do i=isc,iec

        do k=1,nk
           zw_ij(k) = Thickness%depth_zwt(i,j,k) 
        enddo

        if (Tracer%riverdiffuse(i,j) > 0.0 .and. Grd%kmt(i,j) > 0) then
            depth = min(Grd%ht(i,j),river_diffusion_thickness)
            nz    = min(Grd%kmt(i,j),floor(frac_index(depth,zw_ij)))
            nz    = max(1,nz)                                
            do k=1,nz 
              wrk1(i,j,k)  = river_diffusivity*(1.0 - Thickness%depth_zt(i,j,k)/Thickness%depth_zt(i,j,nk))
              kappa(i,j,k) = kappa(i,j,k) + wrk1(i,j,k)
            enddo
        endif
     enddo
  enddo

  if (id_diff_cbt_river_t > 0 .and. Tracer%name=='temp') then 
     call diagnose_3d(Time, Grd, id_diff_cbt_river_t, wrk1(:,:,:))
  endif 
  if (id_diff_cbt_river_s > 0 .and. Tracer%name=='salt') then 
     call diagnose_3d(Time, Grd, id_diff_cbt_river_s, wrk1(:,:,:))
  endif 

end subroutine river_kappa
! </SUBROUTINE> NAME="river_kappa"



!#######################################################################
! <SUBROUTINE NAME="watermass_diag_init">
!
! <DESCRIPTION>
! Initialization of watermass diagnostic output files. 
! </DESCRIPTION>
!
subroutine watermass_diag_init(Time, Dens)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens

  integer :: stdoutunit
  stdoutunit=stdout()
  compute_watermass_diag = .false. 


  ! runoff plus calving mixing 
  id_neut_rho_rivermix = register_diag_field ('ocean_model', 'neut_rho_rivermix',&
     Grd%tracer_axes(1:3), Time%model_time,                                      &
     'update of locally ref potrho from rivermix scheme',                        &
     '(kg/m^3)/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_neut_rho_rivermix > 0) compute_watermass_diag = .true. 

  id_neut_rho_rivermix_on_nrho = register_diag_field ('ocean_model',                    &
    'neut_rho_rivermix_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,            &
    'update of locally ref potrho from rivermix scheme as binned to neutral rho layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_neut_rho_rivermix_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_rho_rivermix = register_diag_field ('ocean_model', 'wdian_rho_rivermix',&
     Grd%tracer_axes(1:3), Time%model_time,                                        &
     'dianeutral mass transport due to rivermix scheme',                           &
     'kg/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_wdian_rho_rivermix > 0) compute_watermass_diag = .true. 

  id_wdian_rho_rivermix_on_nrho = register_diag_field ('ocean_model',                  &
    'wdian_rho_rivermix_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,          &
    'dianeutral mass transport due to rivermix scheme as binned to neutral rho layers',&
    'kg/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_wdian_rho_rivermix_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_rho_rivermix = register_diag_field ('ocean_model', 'tform_rho_rivermix',&
     Grd%tracer_axes(1:3), Time%model_time,                                        &
     'transform due to rivermix scheme pre-binning to neutral rho',                &
     'kg/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_tform_rho_rivermix > 0) compute_watermass_diag = .true. 

  id_tform_rho_rivermix_on_nrho = register_diag_field ('ocean_model',          &
    'tform_rho_rivermix_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,  &
    'watermass transform from rivermix scheme as binned to neutral rho layers',&
    'kg/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_tform_rho_rivermix_on_nrho > 0) compute_watermass_diag = .true. 


  ! runoff mixing 
  id_neut_rho_runoffmix = register_diag_field ('ocean_model', 'neut_rho_runoffmix',&
    Grd%tracer_axes(1:3), Time%model_time,                                         &
    'update of locally ref potrho from runoffmix scheme',                          &
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_neut_rho_runoffmix > 0) compute_watermass_diag = .true. 

  id_pot_rho_runoffmix = register_diag_field ('ocean_model', 'pot_rho_runoffmix',&
    Grd%tracer_axes(1:3), Time%model_time,                                       &
    'update of depth ref potrho from runoffmix scheme',                          &
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_pot_rho_runoffmix > 0) compute_watermass_diag = .true. 

  id_neut_rho_runoffmix_on_nrho = register_diag_field ('ocean_model',                   &
   'neut_rho_runoffmix_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,             &
   'update of locally ref potrho from runoffmix scheme as binned to neutral rho layers',&
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_neut_rho_runoffmix_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_rho_runoffmix = register_diag_field ('ocean_model', 'wdian_rho_runoffmix',&
    Grd%tracer_axes(1:3), Time%model_time,                                           &
    'dianeutral mass transport due to runoffmix scheme',                             &
    'kg/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_wdian_rho_runoffmix > 0) compute_watermass_diag = .true. 

  id_wdian_rho_runoffmix_on_nrho = register_diag_field ('ocean_model',                    &
      'wdian_rho_runoffmix_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,          &
      'dianeutral mass transport due to runoffmix scheme as binned to neutral rho layers',&
      'kg/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_wdian_rho_runoffmix_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_rho_runoffmix = register_diag_field ('ocean_model', 'tform_rho_runoffmix',&
    Grd%tracer_axes(1:3), Time%model_time,                                           &
    'transform due to runoffmix scheme pre-binning to neutral rho ',                 &
    'kg/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_tform_rho_runoffmix > 0) compute_watermass_diag = .true. 

  id_tform_rho_runoffmix_on_nrho = register_diag_field ('ocean_model',          &
    'tform_rho_runoffmix_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,   &
    'watermass transform from runoffmix scheme as binned to neutral rho layers',&
    'kg/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_tform_rho_runoffmix_on_nrho > 0) compute_watermass_diag = .true. 


  ! calving mixing 
  id_neut_rho_calvingmix = register_diag_field ('ocean_model', 'neut_rho_calvingmix',&
    Grd%tracer_axes(1:3), Time%model_time,                                           &
    'update of locally ref potrho from calvingmix scheme',                           &
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_neut_rho_calvingmix > 0) compute_watermass_diag = .true. 

  id_wdian_rho_calvingmix = register_diag_field ('ocean_model', 'wdian_rho_calvingmix',&
    Grd%tracer_axes(1:3), Time%model_time,                                             &
   'dianeutral mass transport due to calvingmix scheme',                               &
   'kg/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_wdian_rho_calvingmix > 0) compute_watermass_diag = .true. 

  id_tform_rho_calvingmix = register_diag_field ('ocean_model', 'tform_rho_calvingmix',&
    Grd%tracer_axes(1:3), Time%model_time,                                             &
   'watermass transform due to calvingmix scheme pre-binned',                          &
   'kg/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_tform_rho_calvingmix > 0) compute_watermass_diag = .true. 

  id_neut_rho_calvingmix_on_nrho = register_diag_field ('ocean_model',                    &
    'neut_rho_calvingmix_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,             &
    'update of locally ref potrho from calvingmix scheme as binned to neutral rho layers',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_neut_rho_calvingmix_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_rho_calvingmix_on_nrho = register_diag_field ('ocean_model',                  &
    'wdian_rho_calvingmix_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,           &
    'dianeutral mass transport due to calvingmix scheme as binned to neutral rho layers',&
    'kg/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_wdian_rho_calvingmix_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_rho_calvingmix_on_nrho = register_diag_field ('ocean_model',          &
    'tform_rho_calvingmix_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,   &
    'watermass transform from calvingmix scheme as binned to neutral rho layers',&
    'kg/sec', missing_value=missing_value, range=(/-1e20,1e20/))
  if(id_tform_rho_calvingmix_on_nrho > 0) compute_watermass_diag = .true. 



  ! process advective form of runoff + calving  
  id_neut_rho_pbl_rv_pr = register_diag_field ('ocean_model',   &
   'neut_rho_pbl_rv_pr', Grd%tracer_axes(1:3), Time%model_time, &
   'process advective-form material time derivative from river',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_pbl_rv_pr > 0) compute_watermass_diag=.true.

  id_neut_rho_pbl_rv_pr_on_nrho = register_diag_field ('ocean_model',                        &
   'neut_rho_pbl_rv_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                 &
   'process advective-form material time derivative from river as binned to neutral density',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_pbl_rv_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_rho_pbl_rv_pr = register_diag_field ('ocean_model',  &
   'wdian_rho_pbl_rv_pr', Grd%tracer_axes(1:3), Time%model_time,&
   'process advective-form dianeutral transport from river',    &
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_pbl_rv_pr > 0) compute_watermass_diag=.true.

  id_wdian_rho_pbl_rv_pr_on_nrho = register_diag_field ('ocean_model',                    &
    'wdian_rho_pbl_rv_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,            &
    'process advective-form dianeutral transport from river as binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_pbl_rv_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_rho_pbl_rv_pr = register_diag_field ('ocean_model',                              &
    'tform_rho_pbl_rv_pr', Grd%tracer_axes(1:3), Time%model_time,                           &
    'process advective-form water mass transform from river pre-binning to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_pbl_rv_pr > 0) compute_watermass_diag=.true.

  id_tform_rho_pbl_rv_pr_on_nrho = register_diag_field ('ocean_model',                &
   'tform_rho_pbl_rv_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,         &
   'process advective-form water mass transform from river binned to neutral density',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_pbl_rv_pr_on_nrho > 0) compute_watermass_diag=.true.


  ! process advective form of runoff + calving from temperature pieces
  id_neut_temp_pbl_rv_pr = register_diag_field ('ocean_model',               &
   'neut_temp_pbl_rv_pr', Grd%tracer_axes(1:3), Time%model_time,             &
   'temp related process advective-form material time derivative from river',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_pbl_rv_pr > 0) compute_watermass_diag=.true.

  id_neut_temp_pbl_rv_pr_on_nrho = register_diag_field ('ocean_model',                                 &
   'neut_temp_pbl_rv_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                          &
   'temp related process advective-form material time derivative from river binned to neutral density',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_pbl_rv_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_temp_pbl_rv_pr = register_diag_field ('ocean_model',          &
   'wdian_temp_pbl_rv_pr', Grd%tracer_axes(1:3), Time%model_time,        &
   'temp related process advective-form dianeutral transport from river',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_pbl_rv_pr > 0) compute_watermass_diag=.true.

  id_wdian_temp_pbl_rv_pr_on_nrho = register_diag_field ('ocean_model',                             &
    'wdian_temp_pbl_rv_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                     &
    'temp related process advective-form dianeutral transport from river binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_pbl_rv_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_temp_pbl_rv_pr = register_diag_field ('ocean_model',           &
    'tform_temp_pbl_rv_pr', Grd%tracer_axes(1:3), Time%model_time,        &
    'temp related process advective-form water mass transform from river',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_pbl_rv_pr > 0) compute_watermass_diag=.true.

  id_tform_temp_pbl_rv_pr_on_nrho = register_diag_field ('ocean_model',                            &
   'tform_temp_pbl_rv_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                     &
   'temp related process advective-form water mass transform from river binned to neutral density',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_pbl_rv_pr_on_nrho > 0) compute_watermass_diag=.true.


  ! process advective form of runoff + calving from salinity pieces
  id_neut_salt_pbl_rv_pr = register_diag_field ('ocean_model',               &
   'neut_salt_pbl_rv_pr', Grd%tracer_axes(1:3), Time%model_time,             &
   'salt related process advective-form material time derivative from river',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_pbl_rv_pr > 0) compute_watermass_diag=.true.

  id_neut_salt_pbl_rv_pr_on_nrho = register_diag_field ('ocean_model',                                 &
   'neut_salt_pbl_rv_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                          &
   'salt related process advective-form material time derivative from river binned to neutral density',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_pbl_rv_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_salt_pbl_rv_pr = register_diag_field ('ocean_model',          &
   'wdian_salt_pbl_rv_pr', Grd%tracer_axes(1:3), Time%model_time,        &
   'salt related process advective-form dianeutral transport from river',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_pbl_rv_pr > 0) compute_watermass_diag=.true.

  id_wdian_salt_pbl_rv_pr_on_nrho = register_diag_field ('ocean_model',                             &
    'wdian_salt_pbl_rv_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                     &
    'salt related process advective-form dianeutral transport from river binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_pbl_rv_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_salt_pbl_rv_pr = register_diag_field ('ocean_model',           &
    'tform_salt_pbl_rv_pr', Grd%tracer_axes(1:3), Time%model_time,        &
    'salt related process advective-form water mass transform from river',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_pbl_rv_pr > 0) compute_watermass_diag=.true.

  id_tform_salt_pbl_rv_pr_on_nrho = register_diag_field ('ocean_model',                            &
   'tform_salt_pbl_rv_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                     &
   'salt related process advective-form water mass transform from river binned to neutral density',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_pbl_rv_pr_on_nrho > 0) compute_watermass_diag=.true.



  ! kinematic advective form of runoff + calving  
  id_neut_rho_pbl_rv_kn = register_diag_field ('ocean_model',     &
   'neut_rho_pbl_rv_kn', Grd%tracer_axes(1:3), Time%model_time,   &
   'kinematic advective-form material time derivative from river',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_pbl_rv_kn > 0) compute_watermass_diag=.true.

  id_neut_rho_pbl_rv_kn_on_nrho = register_diag_field ('ocean_model',                           &
    'neut_rho_pbl_rv_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                   &
    'kinematic advective-form material time derivative from river as binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_pbl_rv_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_rho_pbl_rv_kn = register_diag_field ('ocean_model',   &
    'wdian_rho_pbl_rv_kn', Grd%tracer_axes(1:3), Time%model_time,&
    'kinematic advective-form dianeutral transport from river',  &
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_pbl_rv_kn > 0) compute_watermass_diag=.true.

  id_wdian_rho_pbl_rv_kn_on_nrho = register_diag_field ('ocean_model',                      &
    'wdian_rho_pbl_rv_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,              &
    'kinematic advective-form dianeutral transport from river as binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_pbl_rv_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_rho_pbl_rv_kn = register_diag_field ('ocean_model',                                &
    'tform_rho_pbl_rv_kn', Grd%tracer_axes(1:3), Time%model_time,                             &
    'kinematic advective-form water mass transform from river pre-binning to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_pbl_rv_kn > 0) compute_watermass_diag=.true.

  id_tform_rho_pbl_rv_kn_on_nrho = register_diag_field ('ocean_model',                   &
    'tform_rho_pbl_rv_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,           &
    'kinematic advective-form water mass transform from river binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_pbl_rv_kn_on_nrho > 0) compute_watermass_diag=.true.


  ! kinematic advective form of runoff + calving from temperature contributions
  id_neut_temp_pbl_rv_kn = register_diag_field ('ocean_model',                 &
   'neut_temp_pbl_rv_kn', Grd%tracer_axes(1:3), Time%model_time,               &
   'temp related kinematic advective-form material time derivative from river',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_pbl_rv_kn > 0) compute_watermass_diag=.true.

  id_neut_temp_pbl_rv_kn_on_nrho = register_diag_field ('ocean_model',                                    &
    'neut_temp_pbl_rv_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                            &
    'temp related kinematic advective-form material time derivative from river binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_pbl_rv_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_temp_pbl_rv_kn = register_diag_field ('ocean_model',             &
    'wdian_temp_pbl_rv_kn', Grd%tracer_axes(1:3), Time%model_time,          &
    'temp related kinematic advective-form dianeutral transport from river',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_pbl_rv_kn > 0) compute_watermass_diag=.true.

  id_wdian_temp_pbl_rv_kn_on_nrho = register_diag_field ('ocean_model',                               &
    'wdian_temp_pbl_rv_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
    'temp related kinematic advective-form dianeutral transport from river binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_pbl_rv_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_temp_pbl_rv_kn = register_diag_field ('ocean_model',             &
    'tform_temp_pbl_rv_kn', Grd%tracer_axes(1:3), Time%model_time,          &
    'temp related kinematic advective-form water mass transform from river',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_pbl_rv_kn > 0) compute_watermass_diag=.true.

  id_tform_temp_pbl_rv_kn_on_nrho = register_diag_field ('ocean_model',                               &  
    'tform_temp_pbl_rv_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
    'temp related kinematic advective-form water mass transform from river binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_pbl_rv_kn_on_nrho > 0) compute_watermass_diag=.true.



  ! kinematic advective form of runoff + calving from salinity contributions
  id_neut_salt_pbl_rv_kn = register_diag_field ('ocean_model',                 &
   'neut_salt_pbl_rv_kn', Grd%tracer_axes(1:3), Time%model_time,               &
   'salt related kinematic advective-form material time derivative from river',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_pbl_rv_kn > 0) compute_watermass_diag=.true.

  id_neut_salt_pbl_rv_kn_on_nrho = register_diag_field ('ocean_model',                                    &
    'neut_salt_pbl_rv_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                            &
    'salt related kinematic advective-form material time derivative from river binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_pbl_rv_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_salt_pbl_rv_kn = register_diag_field ('ocean_model',             &
    'wdian_salt_pbl_rv_kn', Grd%tracer_axes(1:3), Time%model_time,          &
    'salt related kinematic advective-form dianeutral transport from river',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_pbl_rv_kn > 0) compute_watermass_diag=.true.

  id_wdian_salt_pbl_rv_kn_on_nrho = register_diag_field ('ocean_model',                               &
    'wdian_salt_pbl_rv_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
    'salt related kinematic advective-form dianeutral transport from river binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_pbl_rv_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_salt_pbl_rv_kn = register_diag_field ('ocean_model',             &
    'tform_salt_pbl_rv_kn', Grd%tracer_axes(1:3), Time%model_time,          &
    'salt related kinematic advective-form water mass transform from river',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_pbl_rv_kn > 0) compute_watermass_diag=.true.

  id_tform_salt_pbl_rv_kn_on_nrho = register_diag_field ('ocean_model',                               &  
    'tform_salt_pbl_rv_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
    'salt related kinematic advective-form water mass transform from river binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_pbl_rv_kn_on_nrho > 0) compute_watermass_diag=.true.



  ! process advective form of river runoff 
  id_neut_rho_pbl_rn_pr = register_diag_field ('ocean_model',     &
    'neut_rho_pbl_rn_pr', Grd%tracer_axes(1:3), Time%model_time,  &
    'process advective-form material time derivative from runoff',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_pbl_rn_pr > 0) compute_watermass_diag=.true.

  id_neut_rho_pbl_rn_pr_on_nrho = register_diag_field ('ocean_model',                          &
    'neut_rho_pbl_rn_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                  &
    'process advective-form material time derivative from runoff as binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_pbl_rn_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_rho_pbl_rn_pr = register_diag_field ('ocean_model',    &
    'wdian_rho_pbl_rn_pr', Grd%tracer_axes(1:3), Time%model_time, &
    'process advective-form dianeutral transport from runoff',    &
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_pbl_rn_pr > 0) compute_watermass_diag=.true.

  id_wdian_rho_pbl_rn_pr_on_nrho = register_diag_field ('ocean_model',                     &
    'wdian_rho_pbl_rn_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,             &
    'process advective-form dianeutral transport from runoff as binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_pbl_rn_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_rho_pbl_rn_pr = register_diag_field ('ocean_model',                               &
    'tform_rho_pbl_rn_pr', Grd%tracer_axes(1:3), Time%model_time,                            &
    'process advective-form water mass transform from runoff pre-binning to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_pbl_rn_pr > 0) compute_watermass_diag=.true.

  id_tform_rho_pbl_rn_pr_on_nrho = register_diag_field ('ocean_model',                  &
    'tform_rho_pbl_rn_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,          &
    'process advective-form water mass transform from runoff binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_pbl_rn_pr_on_nrho > 0) compute_watermass_diag=.true.


  ! process advective form of river runoff from temperature contribution
  id_neut_temp_pbl_rn_pr = register_diag_field ('ocean_model',                 &
    'neut_temp_pbl_rn_pr', Grd%tracer_axes(1:3), Time%model_time,              &
    'temp related process advective-form material time derivative from runoff',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_pbl_rn_pr > 0) compute_watermass_diag=.true.

  id_neut_temp_pbl_rn_pr_on_nrho = register_diag_field ('ocean_model',                                   &
    'neut_temp_pbl_rn_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                           &
    'temp related process advective-form material time derivative from runoff binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_pbl_rn_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_temp_pbl_rn_pr = register_diag_field ('ocean_model',            &
    'wdian_temp_pbl_rn_pr', Grd%tracer_axes(1:3), Time%model_time,         &
    'temp related process advective-form dianeutral transport from runoff',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_pbl_rn_pr > 0) compute_watermass_diag=.true.

  id_wdian_temp_pbl_rn_pr_on_nrho = register_diag_field ('ocean_model',                              &
    'wdian_temp_pbl_rn_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                      &
    'temp related process advective-form dianeutral transport from runoff binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_pbl_rn_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_temp_pbl_rn_pr = register_diag_field ('ocean_model',            &
    'tform_temp_pbl_rn_pr', Grd%tracer_axes(1:3), Time%model_time,         &
    'temp related process advective-form water mass transform from runoff',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_pbl_rn_pr > 0) compute_watermass_diag=.true.

  id_tform_temp_pbl_rn_pr_on_nrho = register_diag_field ('ocean_model',                              &
    'tform_temp_pbl_rn_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                      &
    'temp related process advective-form water mass transform from runoff binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_pbl_rn_pr_on_nrho > 0) compute_watermass_diag=.true.


  ! process advective form of river runoff from salinity contribution
  id_neut_salt_pbl_rn_pr = register_diag_field ('ocean_model',                 &
    'neut_salt_pbl_rn_pr', Grd%tracer_axes(1:3), Time%model_time,              &
    'salt related process advective-form material time derivative from runoff',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_pbl_rn_pr > 0) compute_watermass_diag=.true.

  id_neut_salt_pbl_rn_pr_on_nrho = register_diag_field ('ocean_model',                                   &
    'neut_salt_pbl_rn_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                           &
    'salt related process advective-form material time derivative from runoff binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_pbl_rn_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_salt_pbl_rn_pr = register_diag_field ('ocean_model',            &
    'wdian_salt_pbl_rn_pr', Grd%tracer_axes(1:3), Time%model_time,         &
    'salt related process advective-form dianeutral transport from runoff',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_pbl_rn_pr > 0) compute_watermass_diag=.true.

  id_wdian_salt_pbl_rn_pr_on_nrho = register_diag_field ('ocean_model',                              &
    'wdian_salt_pbl_rn_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                      &
    'salt related process advective-form dianeutral transport from runoff binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_pbl_rn_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_salt_pbl_rn_pr = register_diag_field ('ocean_model',            &
    'tform_salt_pbl_rn_pr', Grd%tracer_axes(1:3), Time%model_time,         &
    'salt related process advective-form water mass transform from runoff',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_pbl_rn_pr > 0) compute_watermass_diag=.true.

  id_tform_salt_pbl_rn_pr_on_nrho = register_diag_field ('ocean_model',                              &
    'tform_salt_pbl_rn_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                      &
    'salt related process advective-form water mass transform from runoff binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_pbl_rn_pr_on_nrho > 0) compute_watermass_diag=.true.



  ! kinematic advective form of river runoff 
  id_neut_rho_pbl_rn_kn = register_diag_field ('ocean_model',       &
    'neut_rho_pbl_rn_kn', Grd%tracer_axes(1:3), Time%model_time,    &
    'kinematic advective-form material time derivative from runoff',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_pbl_rn_kn > 0) compute_watermass_diag=.true.

  id_neut_rho_pbl_rn_kn_on_nrho = register_diag_field ('ocean_model',                            &
    'neut_rho_pbl_rn_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                    &
    'kinematic advective-form material time derivative from runoff as binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_pbl_rn_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_rho_pbl_rn_kn = register_diag_field ('ocean_model',    &
    'wdian_rho_pbl_rn_kn', Grd%tracer_axes(1:3), Time%model_time, &
    'kinematic advective-form dianeutral transport from runoff',  &
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_pbl_rn_kn > 0) compute_watermass_diag=.true.

  id_wdian_rho_pbl_rn_kn_on_nrho = register_diag_field ('ocean_model',                       &
    'wdian_rho_pbl_rn_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,               &
    'kinematic advective-form dianeutral transport from runoff as binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_pbl_rn_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_rho_pbl_rn_kn = register_diag_field ('ocean_model',                                 &
    'tform_rho_pbl_rn_kn', Grd%tracer_axes(1:3), Time%model_time,                              &
    'kinematic advective-form water mass transform from runoff pre-binning to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_pbl_rn_kn > 0) compute_watermass_diag=.true.

  id_tform_rho_pbl_rn_kn_on_nrho = register_diag_field ('ocean_model',                    &
    'tform_rho_pbl_rn_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,            &
    'kinematic advective-form water mass transform from runoff binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_pbl_rn_kn_on_nrho > 0) compute_watermass_diag=.true.


  ! kinematic advective form of river runoff from temperature contributions 
  id_neut_temp_pbl_rn_kn = register_diag_field ('ocean_model',                   &
    'neut_temp_pbl_rn_kn', Grd%tracer_axes(1:3), Time%model_time,                &
    'temp related kinematic advective-form material time derivative from runoff',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_pbl_rn_kn > 0) compute_watermass_diag=.true.

  id_neut_temp_pbl_rn_kn_on_nrho = register_diag_field ('ocean_model',                                     &
    'neut_temp_pbl_rn_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                             &
    'temp related kinematic advective-form material time derivative from runoff binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_pbl_rn_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_temp_pbl_rn_kn = register_diag_field ('ocean_model',              &
    'wdian_temp_pbl_rn_kn', Grd%tracer_axes(1:3), Time%model_time,           &
    'temp related kinematic advective-form dianeutral transport from runoff',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_pbl_rn_kn > 0) compute_watermass_diag=.true.

  id_wdian_temp_pbl_rn_kn_on_nrho = register_diag_field ('ocean_model',                                &
    'wdian_temp_pbl_rn_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                        &
    'temp related kinematic advective-form dianeutral transport from runoff binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_pbl_rn_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_temp_pbl_rn_kn = register_diag_field ('ocean_model',              &
    'tform_temp_pbl_rn_kn', Grd%tracer_axes(1:3), Time%model_time,           &
    'temp related kinematic advective-form water mass transform from runoff',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_pbl_rn_kn > 0) compute_watermass_diag=.true.

  id_tform_temp_pbl_rn_kn_on_nrho = register_diag_field ('ocean_model',                                &
    'tform_temp_pbl_rn_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                        &
    'temp related kinematic advective-form water mass transform from runoff binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_pbl_rn_kn_on_nrho > 0) compute_watermass_diag=.true.


  ! kinematic advective form of river runoff from salinity contributions 
  id_neut_salt_pbl_rn_kn = register_diag_field ('ocean_model',                   &
    'neut_salt_pbl_rn_kn', Grd%tracer_axes(1:3), Time%model_time,                &
    'salt related kinematic advective-form material time derivative from runoff',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_pbl_rn_kn > 0) compute_watermass_diag=.true.

  id_neut_salt_pbl_rn_kn_on_nrho = register_diag_field ('ocean_model',                                     &
    'neut_salt_pbl_rn_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                             &
    'salt related kinematic advective-form material time derivative from runoff binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_pbl_rn_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_salt_pbl_rn_kn = register_diag_field ('ocean_model',              &
    'wdian_salt_pbl_rn_kn', Grd%tracer_axes(1:3), Time%model_time,           &
    'salt related kinematic advective-form dianeutral transport from runoff',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_pbl_rn_kn > 0) compute_watermass_diag=.true.

  id_wdian_salt_pbl_rn_kn_on_nrho = register_diag_field ('ocean_model',                                &
    'wdian_salt_pbl_rn_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                        &
    'salt related kinematic advective-form dianeutral transport from runoff binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_pbl_rn_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_salt_pbl_rn_kn = register_diag_field ('ocean_model',              &
    'tform_salt_pbl_rn_kn', Grd%tracer_axes(1:3), Time%model_time,           &
    'salt related kinematic advective-form water mass transform from runoff',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_pbl_rn_kn > 0) compute_watermass_diag=.true.

  id_tform_salt_pbl_rn_kn_on_nrho = register_diag_field ('ocean_model',                                &
    'tform_salt_pbl_rn_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                        &
    'salt related kinematic advective-form water mass transform from runoff binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_pbl_rn_kn_on_nrho > 0) compute_watermass_diag=.true.



   ! process advective form of calving
  id_neut_rho_pbl_cl_pr = register_diag_field ('ocean_model',      &
    'neut_rho_pbl_cl_pr', Grd%tracer_axes(1:3), Time%model_time,   &
    'process advective-form material time derivative from calving',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_pbl_cl_pr > 0) compute_watermass_diag=.true.

  id_neut_rho_pbl_cl_pr_on_nrho = register_diag_field ('ocean_model',                           &
    'neut_rho_pbl_cl_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                   &
    'process advective-form material time derivative from calving as binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_pbl_cl_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_rho_pbl_cl_pr = register_diag_field ('ocean_model',    &
    'wdian_rho_pbl_cl_pr', Grd%tracer_axes(1:3), Time%model_time, &
    'process advective-form dianeutral transport from calving',   &
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_pbl_cl_pr > 0) compute_watermass_diag=.true.

  id_wdian_rho_pbl_cl_pr_on_nrho = register_diag_field ('ocean_model',                      &
    'wdian_rho_pbl_cl_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,              &
    'process advective-form dianeutral transport from calving as binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_pbl_cl_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_rho_pbl_cl_pr = register_diag_field ('ocean_model',                                &
    'tform_rho_pbl_cl_pr', Grd%tracer_axes(1:3), Time%model_time,                             &
    'process advective-form water mass transform from calving pre-binning to neutral density',&
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_pbl_cl_pr > 0) compute_watermass_diag=.true.

  id_tform_rho_pbl_cl_pr_on_nrho = register_diag_field ('ocean_model',                   &
    'tform_rho_pbl_cl_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,           &
    'process advective-form water mass transform from calving binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_pbl_cl_pr_on_nrho > 0) compute_watermass_diag=.true.


   ! process advective form of calving from temperature contributions 
  id_neut_temp_pbl_cl_pr = register_diag_field ('ocean_model',                  &
    'neut_temp_pbl_cl_pr', Grd%tracer_axes(1:3), Time%model_time,               &
    'temp related process advective-form material time derivative from calving',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_pbl_cl_pr > 0) compute_watermass_diag=.true.

  id_neut_temp_pbl_cl_pr_on_nrho = register_diag_field ('ocean_model',                                    &
    'neut_temp_pbl_cl_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                            &
    'temp related process advective-form material time derivative from calving binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_pbl_cl_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_temp_pbl_cl_pr = register_diag_field ('ocean_model',             &
    'wdian_temp_pbl_cl_pr', Grd%tracer_axes(1:3), Time%model_time,          &
    'temp related process advective-form dianeutral transport from calving',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_pbl_cl_pr > 0) compute_watermass_diag=.true.

  id_wdian_temp_pbl_cl_pr_on_nrho = register_diag_field ('ocean_model',                               &
    'wdian_temp_pbl_cl_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
    'temp related process advective-form dianeutral transport from calving binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_pbl_cl_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_temp_pbl_cl_pr = register_diag_field ('ocean_model',             &
    'tform_temp_pbl_cl_pr', Grd%tracer_axes(1:3), Time%model_time,          &
    'temp related process advective-form water mass transform from calving',&
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_pbl_cl_pr > 0) compute_watermass_diag=.true.

  id_tform_temp_pbl_cl_pr_on_nrho = register_diag_field ('ocean_model',                               &
    'tform_temp_pbl_cl_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
    'temp related process advective-form water mass transform from calving binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_pbl_cl_pr_on_nrho > 0) compute_watermass_diag=.true.


   ! process advective form of calving from salinity contributions 
  id_neut_salt_pbl_cl_pr = register_diag_field ('ocean_model',                  &
    'neut_salt_pbl_cl_pr', Grd%tracer_axes(1:3), Time%model_time,               &
    'salt related process advective-form material time derivative from calving',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_pbl_cl_pr > 0) compute_watermass_diag=.true.

  id_neut_salt_pbl_cl_pr_on_nrho = register_diag_field ('ocean_model',                                    &
    'neut_salt_pbl_cl_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                            &
    'salt related process advective-form material time derivative from calving binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_pbl_cl_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_salt_pbl_cl_pr = register_diag_field ('ocean_model',             &
    'wdian_salt_pbl_cl_pr', Grd%tracer_axes(1:3), Time%model_time,          &
    'salt related process advective-form dianeutral transport from calving',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_pbl_cl_pr > 0) compute_watermass_diag=.true.

  id_wdian_salt_pbl_cl_pr_on_nrho = register_diag_field ('ocean_model',                               &
    'wdian_salt_pbl_cl_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
    'salt related process advective-form dianeutral transport from calving binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_pbl_cl_pr_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_salt_pbl_cl_pr = register_diag_field ('ocean_model',             &
    'tform_salt_pbl_cl_pr', Grd%tracer_axes(1:3), Time%model_time,          &
    'salt related process advective-form water mass transform from calving',&
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_pbl_cl_pr > 0) compute_watermass_diag=.true.

  id_tform_salt_pbl_cl_pr_on_nrho = register_diag_field ('ocean_model',                               &
    'tform_salt_pbl_cl_pr_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
    'salt related process advective-form water mass transform from calving binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_pbl_cl_pr_on_nrho > 0) compute_watermass_diag=.true.




  ! kinematic advective form of calving 
  id_neut_rho_pbl_cl_kn = register_diag_field ('ocean_model',        &
    'neut_rho_pbl_cl_kn', Grd%tracer_axes(1:3), Time%model_time,     &
    'kinematic advective-form material time derivative from calving',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_pbl_cl_kn > 0) compute_watermass_diag=.true.

  id_neut_rho_pbl_cl_kn_on_nrho = register_diag_field ('ocean_model',                             &
    'neut_rho_pbl_cl_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                     &
    'kinematic advective-form material time derivative from calving as binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_pbl_cl_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_rho_pbl_cl_kn = register_diag_field ('ocean_model',    &
    'wdian_rho_pbl_cl_kn', Grd%tracer_axes(1:3), Time%model_time, &
    'kinematic advective-form dianeutral transport from calving', &
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_pbl_cl_kn > 0) compute_watermass_diag=.true.

  id_wdian_rho_pbl_cl_kn_on_nrho = register_diag_field ('ocean_model',                        &
    'wdian_rho_pbl_cl_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                &
    'kinematic advective-form dianeutral transport from calving as binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_pbl_cl_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_rho_pbl_cl_kn = register_diag_field ('ocean_model',                                  &
    'tform_rho_pbl_cl_kn', Grd%tracer_axes(1:3), Time%model_time,                               &
    'kinematic advective-form water mass transform from calving pre-binning to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_pbl_cl_kn > 0) compute_watermass_diag=.true.

  id_tform_rho_pbl_cl_kn_on_nrho = register_diag_field ('ocean_model',                     &
    'tform_rho_pbl_cl_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,             &
    'kinematic advective-form water mass transform from calving binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_pbl_cl_kn_on_nrho > 0) compute_watermass_diag=.true.


  ! kinematic advective form of calving from temperature contributions 
  id_neut_temp_pbl_cl_kn = register_diag_field ('ocean_model',                    &
    'neut_temp_pbl_cl_kn', Grd%tracer_axes(1:3), Time%model_time,                 &
    'temp related kinematic advective-form material time derivative from calving',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_pbl_cl_kn > 0) compute_watermass_diag=.true.

  id_neut_temp_pbl_cl_kn_on_nrho = register_diag_field ('ocean_model',                                      &
    'neut_temp_pbl_cl_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                              &
    'temp related kinematic advective-form material time derivative from calving binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_pbl_cl_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_temp_pbl_cl_kn = register_diag_field ('ocean_model',               &
    'wdian_temp_pbl_cl_kn', Grd%tracer_axes(1:3), Time%model_time,            &
    'temp related kinematic advective-form dianeutral transport from calving',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_pbl_cl_kn > 0) compute_watermass_diag=.true.

  id_wdian_temp_pbl_cl_kn_on_nrho = register_diag_field ('ocean_model',                                 &
    'wdian_temp_pbl_cl_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                         &
    'temp related kinematic advective-form dianeutral transport from calving binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_pbl_cl_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_temp_pbl_cl_kn = register_diag_field ('ocean_model',               &
    'tform_temp_pbl_cl_kn', Grd%tracer_axes(1:3), Time%model_time,            &
    'temp related kinematic advective-form water mass transform from calving',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_pbl_cl_kn > 0) compute_watermass_diag=.true.

  id_tform_temp_pbl_cl_kn_on_nrho = register_diag_field ('ocean_model',                                 &
    'tform_temp_pbl_cl_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                         &
    'temp related kinematic advective-form water mass transform from calving binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_pbl_cl_kn_on_nrho > 0) compute_watermass_diag=.true.


  ! kinematic advective form of calving from salinity contributions 
  id_neut_salt_pbl_cl_kn = register_diag_field ('ocean_model',                    &
    'neut_salt_pbl_cl_kn', Grd%tracer_axes(1:3), Time%model_time,                 &
    'salt related kinematic advective-form material time derivative from calving',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_pbl_cl_kn > 0) compute_watermass_diag=.true.

  id_neut_salt_pbl_cl_kn_on_nrho = register_diag_field ('ocean_model',                                      &
    'neut_salt_pbl_cl_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                              &
    'salt related kinematic advective-form material time derivative from calving binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_pbl_cl_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_salt_pbl_cl_kn = register_diag_field ('ocean_model',               &
    'wdian_salt_pbl_cl_kn', Grd%tracer_axes(1:3), Time%model_time,            &
    'salt related kinematic advective-form dianeutral transport from calving',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_pbl_cl_kn > 0) compute_watermass_diag=.true.

  id_wdian_salt_pbl_cl_kn_on_nrho = register_diag_field ('ocean_model',                                 &
    'wdian_salt_pbl_cl_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                         &
    'salt related kinematic advective-form dianeutral transport from calving binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_pbl_cl_kn_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_salt_pbl_cl_kn = register_diag_field ('ocean_model',               &
    'tform_salt_pbl_cl_kn', Grd%tracer_axes(1:3), Time%model_time,            &
    'salt related kinematic advective-form water mass transform from calving',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_pbl_cl_kn > 0) compute_watermass_diag=.true.

  id_tform_salt_pbl_cl_kn_on_nrho = register_diag_field ('ocean_model',                                 &
    'tform_salt_pbl_cl_kn_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                         &
    'salt related kinematic advective-form water mass transform from calving binned to neutral density',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_pbl_cl_kn_on_nrho > 0) compute_watermass_diag=.true.


  ! eta tendency terms 
  id_eta_tend_rivermix= -1          
  id_eta_tend_rivermix= register_diag_field ('ocean_model','eta_tend_rivermix', &
       Grd%tracer_axes(1:2), Time%model_time,                                   &
       'non-Bouss steric sea level tendency from rivermix', 'm/s',              &
       missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_rivermix > 0) compute_watermass_diag = .true. 

  id_eta_tend_runoffmix= -1          
  id_eta_tend_runoffmix= register_diag_field ('ocean_model','eta_tend_runoffmix', &
       Grd%tracer_axes(1:2), Time%model_time,                                     &
       'non-Bouss steric sea level tendency from runoffmix', 'm/s',               &
       missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_runoffmix > 0) compute_watermass_diag = .true. 

  id_eta_tend_calvingmix= -1          
  id_eta_tend_calvingmix= register_diag_field ('ocean_model','eta_tend_calvingmix', &
       Grd%tracer_axes(1:2), Time%model_time,                                       &
       'non-Bouss steric sea level tendency from calvingmix', 'm/s',                &
       missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_calvingmix > 0) compute_watermass_diag = .true. 

  id_eta_tend_rivermix_glob= -1          
  id_eta_tend_rivermix_glob= register_diag_field ('ocean_model', 'eta_tend_rivermix_glob',&
       Time%model_time,                                                                   &
       'global mean non-bouss steric sea level tendency from rivermix',                   &
       'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_rivermix_glob > 0) compute_watermass_diag = .true. 

  id_eta_tend_runoffmix_glob= -1          
  id_eta_tend_runoffmix_glob= register_diag_field ('ocean_model', 'eta_tend_runoffmix_glob',&
       Time%model_time,                                                                     &
       'global mean non-bouss steric sea level tendency from runoffmix',                    &
       'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_runoffmix_glob > 0) compute_watermass_diag = .true. 

  id_eta_tend_calvingmix_glob= -1          
  id_eta_tend_calvingmix_glob= register_diag_field ('ocean_model', 'eta_tend_calvingmix_glob',&
       Time%model_time,                                                                       &
       'global mean non-bouss steric sea level tendency from calvingmix',                     &
       'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_calvingmix_glob > 0) compute_watermass_diag = .true. 




  if(compute_watermass_diag) then 
    write(stdoutunit,'(/a/)') &
    '==>Note: running ocean_rivermix_mod w/ compute_watermass_diag=.true.'  
  endif 


end subroutine watermass_diag_init
! </SUBROUTINE> NAME="watermass_diag_init"



!#######################################################################
! <SUBROUTINE NAME="watermass_diag_river">
!
! <DESCRIPTION>
! watermass diagnostics for river = runoff + calving. 
! </DESCRIPTION>
!
subroutine watermass_diag_river(Time, Dens, T_prog, river, &
                          temp_wrk, salt_wrk)

  type(ocean_time_type),        intent(in)  :: Time
  type(ocean_density_type),     intent(in)  :: Dens
  type(ocean_prog_tracer_type), intent(in)  :: T_prog(:)
  real, dimension(isd:,jsd:),   intent(in)  :: river
  real, dimension(isd:,jsd:,:), intent(in)  :: temp_wrk
  real, dimension(isd:,jsd:,:), intent(in)  :: salt_wrk

  real, dimension(isd:ied,jsd:jed) :: eta_tend
  integer :: i,j,k,tau
 
  if (.not. compute_watermass_diag) return

  tau = Time%tau

  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0
 
  ! flux-form contributions to material time derivative and dianeutral transport
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Grd%tmask(i,j,k)*(Dens%drhodT(i,j,k)*temp_wrk(i,j,k)+Dens%drhodS(i,j,k)*salt_wrk(i,j,k))
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
           wrk5(i,j,k) =-wrk1(i,j,k)/(epsln+Dens%rho(i,j,k,tau)**2) ! for eta_tend          
        enddo
     enddo
  enddo

  
  call diagnose_3d(Time, Grd, id_neut_rho_rivermix, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_rivermix, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_rivermix, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_rivermix_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_rivermix_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_rivermix_on_nrho, wrk4)

  if(id_eta_tend_rivermix > 0 .or. id_eta_tend_rivermix_glob > 0) then
      eta_tend(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               eta_tend(i,j) = eta_tend(i,j) + wrk5(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_eta_tend_rivermix, eta_tend(:,:))
      call diagnose_sum(Time, Grd, Dom, id_eta_tend_rivermix_glob, eta_tend, cellarea_r)
  endif


  !-----------------------------------------------------------------------------
  ! advective-form material time derivative and associated dianeutral transport 
  !
  ! assumes all river enters to the top grid cell; this is not correct when 
  ! have insertion of river water into depths.  

  ! kinematic form of the contributions
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*river(i,j)                            &
             *(Dens%drhodT(i,j,k)*(0.0-T_prog(index_temp)%field(i,j,k,tau))  &
              +Dens%drhodS(i,j,k)*(0.0-T_prog(index_salt)%field(i,j,k,tau)))
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_pbl_rv_kn, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_pbl_rv_kn, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_pbl_rv_kn, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_pbl_rv_kn_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_pbl_rv_kn_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_pbl_rv_kn_on_nrho, wrk4)

  ! kinematic form of the contributions from temperature
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*river(i,j)                            &
             *(Dens%drhodT(i,j,k)*(0.0-T_prog(index_temp)%field(i,j,k,tau))  &
              +0.0)
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_pbl_rv_kn, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_pbl_rv_kn, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_temp_pbl_rv_kn, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_pbl_rv_kn_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_pbl_rv_kn_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_pbl_rv_kn_on_nrho, wrk4)

  ! kinematic form of the contributions from salinity 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*river(i,j)                            &
             *(0.0                                                           &
              +Dens%drhodS(i,j,k)*(0.0-T_prog(index_salt)%field(i,j,k,tau)))
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_pbl_rv_kn, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_pbl_rv_kn, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_salt_pbl_rv_kn, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_pbl_rv_kn_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_pbl_rv_kn_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_pbl_rv_kn_on_nrho, wrk4)

  ! process contributions
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*river(i,j)                                                 &
         *(Dens%drhodT(i,j,k)*(T_prog(index_temp)%triver(i,j)-T_prog(index_temp)%field(i,j,k,tau))&
          +Dens%drhodS(i,j,k)*(T_prog(index_salt)%triver(i,j)-T_prog(index_salt)%field(i,j,k,tau)))
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_pbl_rv_pr, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_pbl_rv_pr, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_pbl_rv_pr, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_pbl_rv_pr_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_pbl_rv_pr_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_pbl_rv_pr_on_nrho, wrk4)

  ! process contribution associated with temperature 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*river(i,j)                                                 &
         *(Dens%drhodT(i,j,k)*(T_prog(index_temp)%triver(i,j)-T_prog(index_temp)%field(i,j,k,tau))&
          +0.0)
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_pbl_rv_pr, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_pbl_rv_pr, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_temp_pbl_rv_pr, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_pbl_rv_pr_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_pbl_rv_pr_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_pbl_rv_pr_on_nrho, wrk4)

  ! process contribution associated with salinity 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*river(i,j)                                                 &
         *(0.0                                                                                    &
          +Dens%drhodS(i,j,k)*(T_prog(index_salt)%triver(i,j)-T_prog(index_salt)%field(i,j,k,tau)))
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_pbl_rv_pr, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_pbl_rv_pr, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_salt_pbl_rv_pr, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_pbl_rv_pr_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_pbl_rv_pr_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_pbl_rv_pr_on_nrho, wrk4)

end subroutine watermass_diag_river
! </SUBROUTINE> NAME="watermass_diag_river"



!#######################################################################
! <SUBROUTINE NAME="watermass_diag_runoff">
!
! <DESCRIPTION>
! watermass diagnostics for liquid runoff 
! </DESCRIPTION>
!
subroutine watermass_diag_runoff(Time, Dens, T_prog, runoff, &
                          temp_wrk, salt_wrk)

  type(ocean_time_type),        intent(in)  :: Time
  type(ocean_density_type),     intent(in)  :: Dens
  type(ocean_prog_tracer_type), intent(in)  :: T_prog(:)
  real, dimension(isd:,jsd:),   intent(in)  :: runoff
  real, dimension(isd:,jsd:,:), intent(in)  :: temp_wrk
  real, dimension(isd:,jsd:,:), intent(in)  :: salt_wrk

  real, dimension(isd:ied,jsd:jed) :: eta_tend
  integer :: i,j,k,tau
 
  if (.not. compute_watermass_diag) return

  tau = Time%tau

  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0
 
  ! flux-form contributions to material time derivative and dianeutral transport
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Grd%tmask(i,j,k)*(Dens%drhodT(i,j,k)*temp_wrk(i,j,k)+Dens%drhodS(i,j,k)*salt_wrk(i,j,k))
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
           wrk5(i,j,k) =-wrk1(i,j,k)/(epsln+Dens%rho(i,j,k,tau)**2) ! for eta_tend          
        enddo
     enddo
  enddo

  
  call diagnose_3d(Time, Grd, id_neut_rho_runoffmix, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_runoffmix, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_runoffmix, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_runoffmix_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_runoffmix_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_runoffmix_on_nrho, wrk4)


  if(id_eta_tend_runoffmix > 0 .or. id_eta_tend_runoffmix_glob > 0) then
      eta_tend(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               eta_tend(i,j) = eta_tend(i,j) + wrk5(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_eta_tend_runoffmix, eta_tend(:,:))
      call diagnose_sum(Time, Grd, Dom, id_eta_tend_runoffmix_glob, eta_tend, cellarea_r)
  endif

  
  ! flux-form contributions to material time derivative and dianeutral transport
  if(id_pot_rho_runoffmix > 0) then 
     wrk1(:,:,:) = 0.0
     wrk2(:,:,:) = 0.0
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              wrk1(i,j,k) = Grd%tmask(i,j,k)*(Dens%dpotrhodT(i,j,k)*temp_wrk(i,j,k)+Dens%dpotrhodS(i,j,k)*salt_wrk(i,j,k))
              wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           enddo
        enddo
     enddo
     call diagnose_3d(Time, Grd, id_pot_rho_runoffmix, wrk2(:,:,:))
  endif
  
  !-----------------------------------------------------------------------------
  ! advective-form material time derivative and associated dianeutral transport 
  !
  ! assumes all runoff enters to the top grid cell; this is not correct when 
  ! have insertion of water into depths.  

  ! kinematic form of the contributions
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*runoff(i,j)                           &
             *(Dens%drhodT(i,j,k)*(0.0-T_prog(index_temp)%field(i,j,k,tau))  &
              +Dens%drhodS(i,j,k)*(0.0-T_prog(index_salt)%field(i,j,k,tau)))
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_pbl_rn_kn, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_pbl_rn_kn, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_pbl_rn_kn, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_pbl_rn_kn_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_pbl_rn_kn_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_pbl_rn_kn_on_nrho, wrk4)

  ! kinematic form of the contributions from temperature 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*runoff(i,j)                           &
             *(Dens%drhodT(i,j,k)*(0.0-T_prog(index_temp)%field(i,j,k,tau))  &
              +0.0)
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_pbl_rn_kn, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_pbl_rn_kn, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_temp_pbl_rn_kn, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_pbl_rn_kn_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_pbl_rn_kn_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_pbl_rn_kn_on_nrho, wrk4)

  ! kinematic form of the contributions from salinity 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*runoff(i,j)                           &
             *(0.0                                                           &
              +Dens%drhodS(i,j,k)*(0.0-T_prog(index_salt)%field(i,j,k,tau)))
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_pbl_rn_kn, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_pbl_rn_kn, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_salt_pbl_rn_kn, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_pbl_rn_kn_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_pbl_rn_kn_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_pbl_rn_kn_on_nrho, wrk4)

  ! process contributions
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*runoff(i,j)                                                 &
         *(Dens%drhodT(i,j,k)*(T_prog(index_temp)%trunoff(i,j)-T_prog(index_temp)%field(i,j,k,tau))&
          +Dens%drhodS(i,j,k)*(T_prog(index_salt)%trunoff(i,j)-T_prog(index_salt)%field(i,j,k,tau)))
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_pbl_rn_pr, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_pbl_rn_pr, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_pbl_rn_pr, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_pbl_rn_pr_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_pbl_rn_pr_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_pbl_rn_pr_on_nrho, wrk4)

  ! process contribution associated with temperature 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*runoff(i,j)                                                 &
         *(Dens%drhodT(i,j,k)*(T_prog(index_temp)%trunoff(i,j)-T_prog(index_temp)%field(i,j,k,tau))&
          +0.0)
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_pbl_rn_pr, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_pbl_rn_pr, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_temp_pbl_rn_pr, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_pbl_rn_pr_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_pbl_rn_pr_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_pbl_rn_pr_on_nrho, wrk4)

  ! process contribution associated with salinity 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*runoff(i,j)                                                 &
         *(0.0                                                                                     &
          +Dens%drhodS(i,j,k)*(T_prog(index_salt)%trunoff(i,j)-T_prog(index_salt)%field(i,j,k,tau)))
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_pbl_rn_pr, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_pbl_rn_pr, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_salt_pbl_rn_pr, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_pbl_rn_pr_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_pbl_rn_pr_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_pbl_rn_pr_on_nrho, wrk4)

end subroutine watermass_diag_runoff
! </SUBROUTINE> NAME="watermass_diag_runoff"




!#######################################################################
! <SUBROUTINE NAME="watermass_diag_calving">
!
! <DESCRIPTION>
! watermass diagnostics for solid calving.
! </DESCRIPTION>
!
subroutine watermass_diag_calving(Time, Dens, T_prog, calving, &
                          temp_wrk, salt_wrk)

  type(ocean_time_type),        intent(in)  :: Time
  type(ocean_density_type),     intent(in)  :: Dens
  type(ocean_prog_tracer_type), intent(in)  :: T_prog(:)
  real, dimension(isd:,jsd:),   intent(in)  :: calving 
  real, dimension(isd:,jsd:,:), intent(in)  :: temp_wrk
  real, dimension(isd:,jsd:,:), intent(in)  :: salt_wrk

  real, dimension(isd:ied,jsd:jed) :: eta_tend
  integer :: i,j,k,tau
 
  if (.not. compute_watermass_diag) return

  tau = Time%tau

  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0
 
  ! flux-form contributions to material time derivative and dianeutral transport
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Grd%tmask(i,j,k)*(Dens%drhodT(i,j,k)*temp_wrk(i,j,k)+Dens%drhodS(i,j,k)*salt_wrk(i,j,k))
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
           wrk5(i,j,k) =-wrk1(i,j,k)/(epsln+Dens%rho(i,j,k,tau)**2) ! for eta_tend          
        enddo
     enddo
  enddo

  
  call diagnose_3d(Time, Grd, id_neut_rho_calvingmix, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_calvingmix, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_calvingmix, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_calvingmix_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_calvingmix_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_calvingmix_on_nrho, wrk4)

  if(id_eta_tend_calvingmix > 0 .or. id_eta_tend_calvingmix_glob > 0) then
      eta_tend(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               eta_tend(i,j) = eta_tend(i,j) + wrk5(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_eta_tend_calvingmix, eta_tend(:,:))
      call diagnose_sum(Time, Grd, Dom, id_eta_tend_calvingmix_glob, eta_tend, cellarea_r)
  endif


  !-----------------------------------------------------------------------------
  ! advective-form material time derivative and associated dianeutral transport 
  !
  ! assumes all calving enters to the top grid cell; this is not correct when 
  ! have insertion of calving into depths.  

  ! kinematic form of the contributions
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*calving(i,j)                          &
             *(Dens%drhodT(i,j,k)*(0.0-T_prog(index_temp)%field(i,j,k,tau))  &
              +Dens%drhodS(i,j,k)*(0.0-T_prog(index_salt)%field(i,j,k,tau)))
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(TIme, Grd, id_neut_rho_pbl_cl_kn, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_pbl_cl_kn, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_pbl_cl_kn, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_pbl_cl_kn_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_pbl_cl_kn_on_nrho, wrk3)
  call diagnose_3d_rho(TIme, Dens, id_tform_rho_pbl_cl_kn_on_nrho, wrk4)

  ! kinematic form of the contributions from temperature 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*calving(i,j)                          &
             *(Dens%drhodT(i,j,k)*(0.0-T_prog(index_temp)%field(i,j,k,tau))  &
              +0.0)
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_pbl_cl_kn, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_pbl_cl_kn, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_temp_pbl_cl_kn, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_pbl_cl_kn_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_pbl_cl_kn_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_pbl_cl_kn_on_nrho, wrk4)

  ! kinematic form of the contributions from salinity 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*calving(i,j)                          &
             *(0.0                                                           &
              +Dens%drhodS(i,j,k)*(0.0-T_prog(index_salt)%field(i,j,k,tau)))
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_pbl_cl_kn, wrk2(:,:,:))
  call diagnose_3d(TIme, Grd, id_wdian_salt_pbl_cl_kn, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_salt_pbl_cl_kn, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_pbl_cl_kn_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_pbl_cl_kn_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_pbl_cl_kn_on_nrho, wrk4)

  ! process contributions
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*calving(i,j)                                                 &
         *(Dens%drhodT(i,j,k)*(T_prog(index_temp)%tcalving(i,j)-T_prog(index_temp)%field(i,j,k,tau))&
          +Dens%drhodS(i,j,k)*(T_prog(index_salt)%tcalving(i,j)-T_prog(index_salt)%field(i,j,k,tau)))
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_pbl_cl_pr, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_pbl_cl_pr, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_pbl_cl_pr, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_pbl_cl_pr_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_pbl_cl_pr_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_pbl_cl_pr_on_nrho, wrk4)

  ! process contribution associated with temperature 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*calving(i,j)                                                 &
         *(Dens%drhodT(i,j,k)*(T_prog(index_temp)%tcalving(i,j)-T_prog(index_temp)%field(i,j,k,tau))&
          +0.0)
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_pbl_cl_pr, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_pbl_cl_pr, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_temp_pbl_cl_pr, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_pbl_cl_pr_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_pbl_cl_pr_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_pbl_cl_pr_on_nrho, wrk4)

  ! process contribution associated with salinity 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  k=1
  do j=jsc,jec
     do i=isc,iec
        wrk1(i,j,k) = Grd%tmask(i,j,k)*calving(i,j)                                                &
         *(0.0                                                                                     &
          +Dens%drhodS(i,j,k)*(T_prog(index_salt)%tcalving(i,j)-T_prog(index_salt)%field(i,j,k,tau)))
        wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
        wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
        wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_pbl_cl_pr, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_pbl_cl_pr, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_salt_pbl_cl_pr, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_pbl_cl_pr_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_pbl_cl_pr_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_pbl_cl_pr_on_nrho, wrk4)


end subroutine watermass_diag_calving
! </SUBROUTINE> NAME="watermass_diag_calving"


end module ocean_rivermix_mod

module land_debug_mod

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only: &
     error_mesg, file_exist, check_nml_error, stdlog, write_version_number, &
     close_file, mpp_pe, mpp_npes, mpp_root_pe, string, FATAL, WARNING, NOTE
use time_manager_mod, only : &
     time_type, get_date
use grid_mod, only: &
     get_grid_ntiles

! NOTE TO SELF: the "!$" sentinels are not comments: they are compiled if OpenMP 
! support is turned on
!$ use omp_lib, only: OMP_GET_MAX_THREADS, OMP_GET_THREAD_NUM

implicit none
private

! ==== public interfaces =====================================================
public :: land_debug_init
public :: land_debug_end

public :: set_current_point
public :: get_current_point
public :: current_i, current_j, current_k, current_face
public :: is_watch_point
public :: is_watch_cell
public :: get_watch_point

public :: check_temp_range
public :: check_var_range
public :: check_conservation

public :: dpri

interface dpri
   module procedure debug_printout_r0d
   module procedure debug_printout_i0d
   module procedure debug_printout_l0d
   module procedure debug_printout_r1d
end interface dpri

! ==== module constants ======================================================
character(len=*), parameter, private   :: &
    module_name = 'land_debug',&
    version     = '$Id: land_debug.F90,v 20.0 2013/12/13 23:29:49 fms Exp $',&
    tagname     = '$Name: tikal $'

! ==== module variables ======================================================
integer, allocatable :: current_debug_level(:)
integer :: mosaic_tile = 0
integer, allocatable :: curr_i(:), curr_j(:), curr_k(:)
character(128) :: fixed_format

!---- namelist ---------------------------------------------------------------
integer :: watch_point(4)=(/0,0,0,1/) ! coordinates of the point of interest, 
           ! i,j,tile,mosaic_tile
real    :: temp_lo = 120.0 ! lower limit of "reasonable" temperature range, deg K
real    :: temp_hi = 373.0 ! upper limit of "reasonable" temperature range, deg K
logical :: print_hex_debug = .FALSE. ! if TRUE, hex representation of debug 
           ! values is also printed
integer :: label_len = 12  ! minimum length of text labels for debug output
logical :: trim_labels = .FALSE. ! if TRUE, the length of text labels in debug 
           ! printout is never allowed to exceed label_len, resulting in 
           ! trimming of the labels. Set it to TRUE to match earlier debug 
           ! printout
namelist/land_debug_nml/ watch_point, temp_lo, temp_hi, &
   print_hex_debug, label_len, trim_labels


contains

! ============================================================================
subroutine land_debug_init()
  ! ---- local vars
  integer :: unit, ierr, io, ntiles
  integer :: max_threads

  call write_version_number(version, tagname)
  
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=land_debug_nml, iostat=io)
  ierr = check_nml_error(io, 'land_debug_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file()
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=land_debug_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'land_debug_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif
  if (mpp_pe() == mpp_root_pe()) then
     unit=stdlog()
     write(unit, nml=land_debug_nml)
  endif
  ! set number of our mosaic tile 
  call get_grid_ntiles('LND',ntiles)
  mosaic_tile = ntiles*mpp_pe()/mpp_npes() + 1  ! assumption

  ! set number of threads and allocate by-thread arrays
    max_threads = 1  
!$  max_threads = OMP_GET_MAX_THREADS()
  allocate(curr_i(max_threads),curr_j(max_threads),curr_k(max_threads))
  allocate(current_debug_level(max_threads))
  current_debug_level(:) = 0

  ! construct the format string for output
  fixed_format = '(a'//trim(string(label_len))//',99g23.16)'

end subroutine land_debug_init

! ============================================================================
subroutine land_debug_end()
  deallocate(curr_i,curr_j,curr_k)
  deallocate(current_debug_level)
end subroutine

! ============================================================================
subroutine set_current_point(i,j,k)
  integer, intent(in) :: i,j,k

  integer :: thread
    thread = 1
!$  thread = OMP_GET_THREAD_NUM()+1

  curr_i(thread) = i ; curr_j(thread) = j ; curr_k(thread) = k

  current_debug_level(thread) = 0
  if ( watch_point(1)==i.and. &
       watch_point(2)==j.and. &
       watch_point(3)==k.and. &
       watch_point(4)==mosaic_tile) then
     current_debug_level(thread) = 1
  endif
end subroutine set_current_point

! ============================================================================
subroutine get_current_point(i,j,k,face)
  integer, intent(out), optional :: i,j,k,face

  integer :: thread
    thread = 1
!$  thread = OMP_GET_THREAD_NUM()+1

  if (present(i)) i = curr_i(thread)
  if (present(j)) j = curr_j(thread)
  if (present(k)) k = curr_k(thread)
  if (present(face)) face = mosaic_tile
end subroutine get_current_point

! ============================================================================
integer function current_i()
  integer :: thread
    thread = 1
!$  thread = OMP_GET_THREAD_NUM()+1
  current_i = curr_i(thread)
end function

integer function current_j()
  integer :: thread
    thread = 1
!$  thread = OMP_GET_THREAD_NUM()+1
  current_j = curr_j(thread)
end function

integer function current_k()
  integer :: thread
    thread = 1
!$  thread = OMP_GET_THREAD_NUM()+1
  current_k = curr_k(thread)
end function

integer function current_face() ; current_face = mosaic_tile ; end function

! ============================================================================
function is_watch_point()
  logical :: is_watch_point

  integer :: thread
    thread = 1
!$  thread = OMP_GET_THREAD_NUM()+1
  is_watch_point = (current_debug_level(thread) > 0)
end function is_watch_point

! ============================================================================
! returns true, if the watch point is within the grid cell, regardless of
! the tile number
function is_watch_cell()
  logical :: is_watch_cell
  is_watch_cell = ( current_i() == watch_point(1) &
              .and. current_j() == watch_point(2) &
              .and. mosaic_tile == watch_point(4) )
end function is_watch_cell


! ============================================================================
subroutine get_watch_point(i,j,k,face)
  integer, intent(out), optional :: i,j,k,face
  if (present(i)) i = watch_point(1)
  if (present(j)) j = watch_point(2)
  if (present(k)) k = watch_point(3)
  if (present(face)) face = watch_point(4)
end subroutine get_watch_point

! ============================================================================
! checks if the temperature within reasonable range, and prints a message
! if it isn't
subroutine check_temp_range(temp, tag, varname, time)
  real, intent(in) :: temp ! temperature to check
  character(*), intent(in) :: tag ! tag to print
  character(*), intent(in) :: varname ! name of the variable for printout
  type(time_type), intent(in) :: time ! current time

  call check_var_range(temp,temp_lo,temp_hi,tag,varname,time)
end subroutine 

! ============================================================================
! checks if the value is within specified range, and prints a message
! if it isn't
subroutine check_var_range(value, lo, hi, tag, varname, time, severity)
  real, intent(in) :: value ! value to check
  real, intent(in) :: lo,hi ! lower and upper bounds of acceptable range
  character(*), intent(in) :: tag ! tag to print
  character(*), intent(in) :: varname ! name of the variable for printout
  type(time_type), intent(in) :: time ! current time
  integer, intent(in), optional :: severity ! severity of the non-conservation error:
         ! Can be WARNING, FATAL, or negative. Negative means check is not done.

  ! ---- local vars
  integer :: y,mo,d,h,m,s ! components of date
  integer :: thread
  character(512) :: message
  integer :: severity_

  severity_=WARNING
  if (present(severity)) severity_=severity

  if (severity_<0) return

  if(lo<=value.and.value<=hi) then
     return
  else
     thread = 1
!$   thread = OMP_GET_THREAD_NUM()+1
     call get_date(time,y,mo,d,h,m,s)
     write(message,'(a,g23.16,4(x,a,i4),x,a,i4.4,2("-",i2.2),x,i2.2,2(":",i2.2))')&
          trim(varname)//' out of range: value=', value,&
	  'at i=',curr_i(thread),'j=',curr_j(thread),'tile=',curr_k(thread),'face=',mosaic_tile, &
          'time=',y,mo,d,h,m,s
     call error_mesg(trim(tag),message,severity_)
  endif
end subroutine 

! ============================================================================
! debug printout procedures
subroutine debug_printout_r0d(description,value)
  character(*), intent(in) :: description
  real        , intent(in) :: value
  
  if (trim_labels.or.len_trim(description)<label_len) then
     write(*,fixed_format,advance='NO')trim(description),value
  else
     write(*,'(x,a,g23.16)',advance='NO')trim(description),value
  endif
  if(print_hex_debug) write(*,'(z17)',advance='NO')value
end subroutine


subroutine debug_printout_i0d(description,value)
  character(*), intent(in) :: description
  integer     , intent(in) :: value
  
  if (trim_labels.or.len_trim(description)<label_len) then
     write(*,fixed_format,advance='NO')trim(description),value
  else
     write(*,'(x,a,g23.16)',advance='NO')trim(description),value
  endif
end subroutine


subroutine debug_printout_l0d(description,value)
  character(*), intent(in) :: description
  logical     , intent(in) :: value
  
  if (trim_labels.or.len_trim(description)<label_len) then
     write(*,fixed_format,advance='NO')trim(description),value
  else
     write(*,'(x,a,g23.16)',advance='NO')trim(description),value
  endif
end subroutine


subroutine debug_printout_r1d(description,values)
  character(*), intent(in) :: description
  real        , intent(in) :: values(:)
  
  if (trim_labels.or.len_trim(description)<label_len) then
     write(*,fixed_format,advance='NO')trim(description),values
  else
     write(*,'(x,a,99g23.16)',advance='NO')trim(description),values
  endif
end subroutine

! ============================================================================
! checks the conservation of a substance and issues a message with specified
! severity if the difference is not within tolerance.
subroutine check_conservation(tag, substance, d1, d2, tolerance, time, severity)
  character(*), intent(in) :: tag ! message tag (subroutine name or some such)
  character(*), intent(in) :: substance ! name of the substance for printout
  real, intent(in) :: d1,d2 ! values to check
  real, intent(in) :: tolerance ! tolerance of the test
  type(time_type), intent(in) :: time ! current time
  integer, intent(in), optional :: severity ! severity of the non-conservation error:
         ! Can be WARNING, FATAL, or negative. Negative means check is not done.

  ! ---- local vars
  integer :: y,mo,d,h,m,s ! components of date
  integer :: thread
  character(512) :: message
  integer :: severity_
  
  severity_=FATAL
  if (present(severity))severity_=severity

  if (severity_<0) return

  if (abs(d2-d1)<tolerance) then
     return
  else
     thread = 1
!$   thread = OMP_GET_THREAD_NUM()+1
     call get_date(time,y,mo,d,h,m,s)
     write(message,'(3(x,a,g23.16),4(x,a,i4),x,a,i4.4,2("-",i2.2),x,i2.2,2(":",i2.2))')&
          'conservation of '//trim(substance)//' is violated; before=', d1, 'after=', d2, 'diff=',d2-d1,&
          'at i=',curr_i(thread),'j=',curr_j(thread),'tile=',curr_k(thread),'face=',mosaic_tile, &
          'time=',y,mo,d,h,m,s
     call error_mesg(tag,message,severity_)
  endif
end subroutine 

end module land_debug_mod

module river_type_mod
!-----------------------------------------------------------------------
!                   GNU General Public License                        
!                                                                      
! This program is free software; you can redistribute it and/or modify it and  
! are expected to follow the terms of the GNU General Public License  
! as published by the Free Software Foundation; either version 2 of   
! the License, or (at your option) any later version.                 
!                                                                      
! MOM is distributed in the hope that it will be useful, but WITHOUT    
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
! License for more details.                                           
!                                                                      
! For the full text of the GNU General Public License,                
! write to: Free Software Foundation, Inc.,                           
!           675 Mass Ave, Cambridge, MA 02139, USA.                   
! or see:   http://www.gnu.org/licenses/gpl.html                      
!-----------------------------------------------------------------------
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Kirsten Findell </CONTACT> 
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Zhi Liang </CONTACT> 

  use time_manager_mod, only : time_type

  implicit none
  private

!--- version information ---------------------------------------------
  character(len=128) :: version = '$Id: river_type.F90,v 20.0 2013/12/13 23:29:45 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

!--- public interface ------------------------------------------------
  public :: river_type, Leo_Mad_trios
  integer, public, parameter :: NO_RIVER_FLAG = -9999

!--- public data type ------------------------------------------------

  type river_type
     real, dimension(:),        pointer :: lon_1d        => NULL()  ! in degree
     real, dimension(:),        pointer :: lat_1d        => NULL()  ! in degree
     real, dimension(:,:),      pointer :: lon           => NULL()  ! in radians
     real, dimension(:,:),      pointer :: lat           => NULL()  ! in radians
     real, dimension(:,:),      pointer :: reach_length  => NULL()
     real, dimension(:,:),      pointer :: landfrac      => NULL()
     logical, dimension(:,:),   pointer :: mask          => NULL()
     real, dimension(:,:),      pointer :: land_area     => NULL()
     integer, dimension(:,:),   pointer :: basinid       => NULL() 
     integer, dimension(:,:),   pointer :: tocell        => NULL()
     integer, dimension(:,:),   pointer :: travel        => NULL()
     integer, dimension(:,:),   pointer :: i_tocell      => NULL()
     integer, dimension(:,:),   pointer :: j_tocell      => NULL()
     real, dimension(:,:),      pointer :: storage       => NULL()     
     real, dimension(:,:),      pointer :: stordis       => NULL()     
     real, dimension(:,:),      pointer :: run_stor      => NULL()  ! runoff storage
     real, dimension(:,:,:),    pointer :: storage_c     => NULL()     
     real, dimension(:,:,:),    pointer :: stordis_c     => NULL()     
     real, dimension(:,:,:),    pointer :: run_stor_c    => NULL()  ! tracer runoff storage
     real, dimension(:,:),      pointer :: inflow        => NULL()
     real, dimension(:,:,:),    pointer :: inflow_c      => NULL()
     real, dimension(:,:),      pointer :: infloc        => NULL()
     real, dimension(:,:,:),    pointer :: infloc_c      => NULL()
     real, dimension(:,:),      pointer :: outflow       => NULL()
     real, dimension(:,:,:),    pointer :: outflow_c     => NULL()
     real, dimension(:,:),      pointer :: lake_outflow   => NULL()
     real, dimension(:,:,:),    pointer :: lake_outflow_c => NULL()
     real, dimension(:,:),      pointer :: disw2o        => NULL()
     real, dimension(:,:),      pointer :: disw2l        => NULL()
     real, dimension(:,:,:),    pointer :: disc2o        => NULL()
     real, dimension(:,:,:),    pointer :: disc2l        => NULL()
     real, dimension(:,:),      pointer :: melt          => NULL()
     real, dimension(:,:,:),    pointer :: removal_c     => NULL()
     real, dimension(:,:),      pointer :: outflowmean   => NULL()
     real, dimension(:,:),      pointer :: o_coef        => NULL()
     real, dimension(:,:),      pointer :: d_coef        => NULL()
     real, dimension(:,:),      pointer :: w_coef        => NULL()
     real, dimension(:,:,:),    pointer :: source_conc   => NULL()
     real, dimension(:,:,:),    pointer :: source_flux   => NULL()
     real, dimension(:,:),      pointer :: So            => NULL()
     real, dimension(:,:),      pointer :: depth         => NULL()
     real, dimension(:,:),      pointer :: width         => NULL()
     real, dimension(:,:),      pointer :: vel           => NULL()
     real, dimension(:),        pointer :: t_ref         => NULL()
     real, dimension(:),        pointer :: vf_ref        => NULL()
     real, dimension(:),        pointer :: q10           => NULL()
     real, dimension(:),        pointer :: kinv          => NULL()
     real                               :: o_exp
     real                               :: d_exp
     real                               :: w_exp
     real                               :: channel_tau
     type (time_type)                   :: Time
     integer                            :: dt_fast, dt_slow
     integer                            :: nlon, nlat, num_species, num_c
     integer                            :: num_phys
     logical                            :: do_age
  end type river_type

  type Leo_Mad_trios
     real :: on_V, on_d, on_w
  end type Leo_Mad_trios


end module river_type_mod

module ocean_parameters_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
! S.M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! This module contains some parameters used in MOM.
!</OVERVIEW>
!
!<DESCRIPTION>
! The parameter settings for numerical and/or physical schemes. 
! Also some physical constants, whose values can be modified via namelist.  
!</DESCRIPTION>
!
!
!<NAMELIST NAME="ocean_parameters_nml">
!
!  <DATA NAME="cp_ocean" UNITS="J/(kg degC)" TYPE="real">
!  Specific heat capacity J/(kg degC) for liquid seawater.
!  Values are taken from from Jackett etal (2006) for preTEOS10 and 
!  from TEOS-10 manual for TEOS10 value. The default values differ
!  from that in shared/constants since the MOM defaults are more updated.  
!  Note that there is a check inside of ocean_tempsalt.F90 to ensure that
!  cp_ocean=cp_ocean_teos10 if using the teos10 recommendations, 
!  and cp_ocean=cp_ocean_preteos10 for cases not using teos10.  
!  </DATA> 
!
!  <DATA NAME="cp_solid_runoff" UNITS="J/(kg degC)" TYPE="real">
!  Specific heat capacity J/(kg degC) for solid water runoff via calving land ice.
!  Default cp_solid_runoff = 2106.0 is consistent with that used in the 
!  GFDL land model. 
!  </DATA> 
!
!  <DATA NAME="cp_liquid_runoff" UNITS="J/(kg degC)" TYPE="real">
!  Specific heat capacity J/(kg degC) for liquid water runoff from land. 
!  Default cp_liquid_runoff = 4218.0 is consistent with that used in the 
!  GFDL land model. 
!  </DATA> 
!
!  <DATA NAME="rho0" UNITS="kg/m^3" TYPE="real">
!  Boussinesq reference density.  Default rho0=1035.0
!  corresponds to the value in Gill (page 47), where he notes 
!  that the ocean density typically deviates less than 2 per cent
!  from this value. But if using the Boussinesq approximation for 
!  other water bodies, such as the Baltic, then may wish to change
!  rho0 to a more appropriate value. 
!  </DATA> 
!
!  <DATA NAME="tfreeze" UNITS="Kelvin" TYPE="real">
!  freezing point of fresh water at standard atmos pressure.
!  Default tfreeze=273.15
!  </DATA> 
!
!  <DATA NAME="omega_earth" UNITS="radians per second" TYPE="real">
!  rotation of earth in radians per second
!  Default omega_earth= 7.2921e-5, as per equation (4.1) in Griffies (2004).
!  </DATA> 
!
!  <DATA NAME="grav" UNITS="m/s^2" TYPE="real">
!  Gravitational acceleration at earth surface. Assumed to be constant
!  throughout the ocean domain.  Default grav=9.8 corresponds to the
!  "grav" parameter from shared/constants.F90. 
!  </DATA> 
!
!  <DATA NAME="von_karman" UNITS="dimensionless" TYPE="real">
!  Von Karman constant for law of wall turbulence. 
!  Default von_karman=0.4. 
!  Note: due to answer changes on some compilers, von_karman 
!  has been removed from nml and is now set as a hard-value
!  to be consistent with earlier simulations (06mar2012).  
!  </DATA> 
!
!</NAMELIST>

  use mpp_mod,  only: stdlog, stdout, input_nml_file
  use fms_mod,  only: open_namelist_file, check_nml_error, close_file

  implicit none
  private

  public ocean_parameters_init
  public ocean_parameters_end 


  ! some numerical constants
  real, parameter, public  :: missing_value=-1.e20
  real, parameter, public  :: onehalf      = 1.0/2.0 
  real, parameter, public  :: onethird     = 1.0/3.0
  real, parameter, public  :: twothirds    = 2.0/3.0
  real, parameter, public  :: onefourth    = 1.0/4.0 
  real, parameter, public  :: onesixth     = 1.0/6.0 
  real, parameter, public  :: oneeigth     = 1.0/8.0 
  real, parameter, public  :: onesixteenth = 1.0/16.0 
  real, parameter, public  :: sec_in_day   = 86400.0 
  real, parameter, public  :: sec_in_day_r = 1.0/86400.0 
  real, parameter, public  :: sec_in_yr    = 86400.0*365.25 
  real, parameter, public  :: sec_in_yr_r  = 1.0/(86400.0*365.25)
  real, parameter, public  :: m3toSv       = 1.e-6   ! volume based Sv (10^6 m^3/s)
  real, parameter, public  :: kgtoSv       = 1.e-9   ! mass   based Sv (10^9 kg/s)

  ! parameters for choosing the time tendency calculation
  integer, parameter, public :: TWO_LEVEL   = 2
  integer, parameter, public :: THREE_LEVEL = 3

  ! parameters for vertical coordinates 
  integer, parameter, public :: GEOPOTENTIAL = 1
  integer, parameter, public :: ZSTAR        = 2
  integer, parameter, public :: ZSIGMA       = 3
  integer, parameter, public :: PRESSURE     = 4
  integer, parameter, public :: PSTAR        = 5 
  integer, parameter, public :: PSIGMA       = 6 

  integer, parameter, public :: DEPTH_BASED    = 1
  integer, parameter, public :: PRESSURE_BASED = 2

  integer, parameter, public :: QUASI_HORIZONTAL  = 1
  integer, parameter, public :: TERRAIN_FOLLOWING = 2

  ! parameters for choosing method of computing vertical cell thickness 
  integer, parameter, public :: ENERGETIC   =1
  integer, parameter, public :: FINITEVOLUME=2

  ! parameters for choosing the temperature variable
  integer, parameter, public :: CONSERVATIVE_TEMP = 1
  integer, parameter, public :: POTENTIAL_TEMP    = 2

  ! parameters for choosing the salinity variable
  integer, parameter, public :: PREFORMED_SALT = 1
  integer, parameter, public :: PRACTICAL_SALT = 2

  ! parameters for choosing the vertical mixing scheme 
  integer, parameter, public :: VERTMIX_CONST      = 1
  integer, parameter, public :: VERTMIX_PP         = 2
  integer, parameter, public :: VERTMIX_CHEN       = 3
  integer, parameter, public :: VERTMIX_GOTM       = 4
  integer, parameter, public :: VERTMIX_KPP_MOM4P0 = 5
  integer, parameter, public :: VERTMIX_KPP_MOM4P1 = 6
  integer, parameter, public :: VERTMIX_KPP_TEST   = 7

  ! parameters for choosing the horizontal layout of variables 
  integer, parameter, public :: MOM_BGRID = 1
  integer, parameter, public :: MOM_CGRID = 2

  integer, parameter, public :: TEMP_ID = 1
  integer, parameter, public :: SALT_ID = 2

  ! parameters for tracer advection 
  integer, parameter, public :: ADVECT_UPWIND            = 1
  integer, parameter, public :: ADVECT_2ND_ORDER         = 2
  integer, parameter, public :: ADVECT_4TH_ORDER         = 3
  integer, parameter, public :: ADVECT_6TH_ORDER         = 4 
  integer, parameter, public :: ADVECT_QUICKER           = 5
  integer, parameter, public :: ADVECT_QUICKMOM3         = 6
  integer, parameter, public :: ADVECT_MDFL_SUP_B        = 7
  integer, parameter, public :: ADVECT_MDPPM             = 8
  integer, parameter, public :: ADVECT_MDFL_SWEBY        = 9
  integer, parameter, public :: ADVECT_DST_LINEAR        = 10
  integer, parameter, public :: ADVECT_PSOM              = 11
  integer, parameter, public :: ADVECT_MDFL_SWEBY_TEST   = 12
  integer, parameter, public :: ADVECT_MDPPM_TEST        = 13
  integer, parameter, public :: ADVECT_DST_LINEAR_TEST   = 14
  integer, parameter, public :: ADVECT_MDMDT_TEST        = 15
 
  ! parameters for linear mometum  advection 
  integer, parameter, public :: VEL_ADVECT_UPWIND     = 1
  integer, parameter, public :: VEL_ADVECT_2ND_ORDER  = 2


  !---------------------------------------------------------
  ! the following are some physical parameters; some 
  ! can be modified through namelist settings. 

  ! acceleration due to gravity (m/s^2), assumed constant 
  ! throughout the ocean domain.  
  real, public :: grav = 9.80

  ! specific heat capacity J/(kg degC) for seawater 
  real, public            :: cp_ocean           = 3992.10322329649d0  
  real, parameter, public :: CP_OCEAN_PRETEOS10 = 3992.10322329649d0  
  real, parameter, public :: CP_OCEAN_TEOS10    = 3991.86795711963d0 

  ! specific heat capacity J/(kg degC) for calving land ice. 
  ! this value is consistent with that used in the GFDL land model. 
  real, public :: cp_solid_runoff = 2106.

  ! specific heat capacity J/(kg degC) for liquid runoff from land.
  ! this value is consistent with that used in the GFDL land model. 
  real, public :: cp_liquid_runoff = 4218.

  ! Boussinesq reference density (kg/m3) and its inverse.  Ideally, this 
  ! density should be set equal to the domain averaged density 
  ! in the model.   
  real, public :: rho0  = 1035.0
  real, public :: rho0r = 1.0/1035.0 

  ! product of rho0*cp_ocean
  ! (kg/m^3)*(cal/kg/deg C)(joules/cal) = (joules/m^3/deg C)
  real, public :: rho_cp = 1035.0 * 3992.10322329649d0 

  ! freezing point of fresh water at standard atmos pressure 
  real, public :: tfreeze  = 273.15

  ! rotation of earth in radians per second 
  ! from equation (4.1) in Griffies (2004)
  real, public :: omega_earth = 7.2921e-5 

  ! von Karman constant (dimensionless)
  ! 06mar2012: reset as real, parameter to keep
  ! consistent with earlier compilers 
  real, parameter, public :: von_karman=0.4


  character(len=128) :: version = &
     '$Id: ocean_parameters.F90,v 20.0 2013/12/14 00:10:55 fms Exp $'
  character (len=128) :: tagname = &
     '$Name: tikal $'

  namelist /ocean_parameters_nml/ cp_ocean, cp_liquid_runoff, cp_solid_runoff, &
                                  rho0, tfreeze, omega_earth, grav
  
contains


!#######################################################################
! <SUBROUTINE NAME="ocean_parameters_init">
!
! <DESCRIPTION>
! Initialize the parameter module, passing cp_ocean back to ocean_model.F90
! and setting all other parameters that will be used throughout the model
! simulation. 
!
! Note: we do not enable check_nml_error, since the default settings 
! are generally those recommended for simulations.
!
! </DESCRIPTION>
!
subroutine ocean_parameters_init()

    integer :: stdoutunit, stdlogunit
    integer :: ioun, io_status

    stdoutunit = stdout()
    stdlogunit = stdlog()

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_parameters_nml, iostat=io_status)
!    ierr = check_nml_error(io_status,'ocean_parameters_nml')
#else
    ioun = open_namelist_file()
    read  (ioun, ocean_parameters_nml,iostat=io_status)
!    ierr = check_nml_error(io_status, 'ocean_parameters_nml')
    call close_file(ioun)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit, ocean_parameters_nml)
    write (stdlogunit, ocean_parameters_nml)
    write( stdlogunit,'(/a/)') trim(version)

    rho0r  = 1.0/rho0
    rho_cp = rho0*cp_ocean 

    return

  end subroutine ocean_parameters_init
! </SUBROUTINE> NAME="ocean_parameters_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_parameters_end">
!
! <DESCRIPTION>
! Summarize the basic physical parameters used in the simulation. 
! </DESCRIPTION>
!
subroutine ocean_parameters_end()

    integer :: stdoutunit
    stdoutunit=stdout()
 
    write (stdoutunit,'(a)')  ' '
    write (stdoutunit,'(2x,a)') 'Some of the basic physical parameters used in the simulation'
    write (stdoutunit,'(2x,a,e20.10)')  'Reference density for the Boussinesq approximation (kg/m^3) = ',rho0
    write (stdoutunit,'(2x,a,e20.10)')  'Gravitational acceleration (m/s^2)                          = ',grav
    write (stdoutunit,'(2x,a,e20.10)')  'Rotational rate of the earth (radians/sec)                  = ',omega_earth
    write (stdoutunit,'(2x,a,e20.10)')  'Specific heat capacity of seawater      J/(kg*degC)         = ',cp_ocean
    write (stdoutunit,'(2x,a,e20.10)')  'Specific heat capacity of liquid runoff J/(kg*degC)         = ',cp_liquid_runoff
    write (stdoutunit,'(2x,a,e20.10)')  'Specific heat capacity of solid  runoff J/(kg*degC)         = ',cp_liquid_runoff
    write (stdoutunit,'(2x,a,e20.10)')  'Von Karman dimensionless constant for turbulent mixing      = ',von_karman
    write (stdoutunit,'(a)')  ' '


  end subroutine ocean_parameters_end
! </SUBROUTINE> NAME="ocean_parameters_end"


end module ocean_parameters_mod

module tp_core
!BOP
!
! !MODULE: tp_core --- A collection of routines to support FV transport
!
!

#ifdef USE_LIMA
use shr_kind_mod, only : r8 => shr_kind_r8
#endif

use fill_module, only: fillxy
use mpp_mod, only: mpp_error, FATAL
 implicit none

 private

 public :: split_trac, tp2c, xtp, ytp, tpcc, ycc
#ifndef USE_LIMA
 public :: tp2d
#else               
 public :: tp2d_lima
#endif
 real, parameter:: tiny = 1.e-20
!
! !DESCRIPTION:
!
!      This module provides 
!
! !REVISION HISTORY:
!
!EOP
!-----------------------------------------------------------------------

CONTAINS

 subroutine split_trac(dp1, dp2, dh, q, crx, cry, im, jm, iord, jord,   &
                       ng, fx, fy, ffsl, tra_step, fill, acap,   &
                       acosp, xfx, yfx, cosp, id, jfirst, jlast)

! !INPUT PARAMETERS:
   integer, intent(in):: im, jm                ! Dimensions
   integer, intent(in):: jfirst, jlast         ! Latitude strip
   integer, intent(in):: iord, jord            ! Interpolation order in x,y
   integer, intent(in):: ng                    ! Max. NS dependencies
   integer, intent(in):: id                    ! density (0)  (mfx = C)
   integer, intent(in):: tra_step ! 

! tra_step = 0: default fully symmetrical Lin-Rood 1996 scheme 
! tra_step = 1: asymmetrical Lin-Rood scheme
!                   no need to ghost crx
! tra_step = 2: symmetrical scheme based on density scaling
!                   need to ghost both crx & xfx (see comments)

   logical, intent(in):: ffsl(jm)   ! flux-form semi-Lagrangian trans
   logical, intent(in):: fill       ! 

   real, intent(in):: acap
   real, intent(in):: cosp(jm)                   ! Critical angle
   real, intent(in):: acosp(jm)             !
   real, intent(in):: dp1(im,jfirst:jlast)     !
   real, intent(in):: dp2(im,jfirst:jlast)     !
   real, intent(in):: crx(im,jfirst-ng:jlast+ng) ! 
   real, intent(in):: xfx(im,jfirst:jlast) ! 
   real, intent(in):: cry(im,jfirst:jlast+1)     ! 
   real, intent(in):: yfx(im,jfirst:jlast+1)     !

   real, intent(inout):: q(im,jfirst-ng:jlast+ng)   ! 

! !OUTPUT PARAMETERS:
   real, intent(out):: dh(im,jfirst:jlast)        ! density increment
   real, intent(out):: fx(im,jfirst:jlast)        ! mass Flux in x
   real, intent(out):: fy(im,jfirst:jlast+1)      ! mass Flux in y

! !DESCRIPTION:
!
!-----------------------------------------------------------------------
   real  dm(-im/3:im+im/3)
   real  qtmp(-im/3:im+im/3)
   real  al(-im/3:im+im/3)
   real  ar(-im/3:im+im/3)
   real  a6(-im/3:im+im/3)
   real  fx1(im+1)
   real  den(im), qt(im)
   real  q2d(im,jfirst-ng:jlast+ng)

   integer i, j
   integer:: iad=2
   real    sum1

  select case (tra_step)

  case(1)
 
!-----------------------------------------------------------------------------
! This is a faster and fully monotonic transport option. But it is not
! consistent wth the dynamics (PV-tracer consistency, anyone cares?)
! ytp is called first to avoid halo update with 1D decomposition!
!-----------------------------------------------------------------------------

   call ytp(im, jm, fy, q, cry, yfx, ng, jord, 0, jfirst, jlast)

   do j=max(2,jfirst), min(jm-1,jlast)
      do i=1,im
!------------------
! tracer density:
!------------------
         den(i) = q(i,j)*dp1(i,j) + (fy(i,j)-fy(i,j+1))*acosp(j)
!--------------------
! tracer mixing ratio:
!--------------------
         qt(i) = den(i) / (dp1(i,j)+(yfx(i,j)-yfx(i,j+1))*acosp(j))
      enddo
 
      call xtp(im, ffsl(j), fx1, qt, crx(1,j), iord,  &
               xfx(1,j), cosp(j), id, dm, qtmp, al, ar, a6)

      fx1(im+1) = fx1(1)

! Update tracer mixing ratio
      do i=1,im
         q(i,j) = (den(i)+fx1(i)-fx1(i+1)) / dp2(i,j)
      enddo
   enddo

   call update_poles(im, jm, jfirst, jlast, q(1,jfirst), fy, dp1, dp2, acosp)
   
  case (2)

   do j=max(2,jfirst-ng), min(jm-1,jlast+ng)

      call xtp(im, ffsl(j), fx1, q(1,j), crx(1,j), iord,  &
               crx(1,j), cosp(j), 0, dm, qtmp, al, ar, a6)
    
      if ( j >= jfirst .and. j <= jlast) then
         if(id==0) then
            do i=1,im
               fx(i,j) = fx1(i)
            enddo
         else
           if(ffsl(j)) then
              do i=1,im
                 fx(i,j) = fx1(i)*xfx(i,j)
              enddo
           else
              do i=1,im
                 fx(i,j) = fx1(i)*xfx(i,j)/sign(max(abs(crx(i,j)),tiny), crx(i,j))
              enddo
           endif
         endif
      endif

      do i=1,im-1
         q2d(i,j) = (q(i,j) + fx1(i)-fx1(i+1)) / (1.+crx(i,j)-crx(i+1,j))
      enddo
         q2d(im,j) = (q(im,j) + fx1(im)-fx1(1)) / (1.+crx(im,j)-crx(1,j))
   enddo
     if ( jfirst-ng <= 1 ) then
          do i=1,im 
             q2d(i,1) = q(i,1)
          enddo
     endif 
     if ( jlast+ng >= jm ) then
          do i=1,im 
             q2d(i,jm) = q(i,jm)
          enddo
     endif

   call ytp(im, jm, fy, q2d, cry, yfx, ng, jord, 0, jfirst, jlast)

   do j=max(2,jfirst), min(jm-1,jlast)
      do i=1,im-1
        q(i,j) = ( q(i,j)*dp1(i,j) + fx(i,j) - fx(i+1,j) +      &
                  (fy(i,j)-fy(i,j+1))*acosp(j) ) / dp2(i,j)
      enddo
        q(im,j) = ( q(im,j)*dp1(im,j) + fx(im,j) - fx(1,j) +      &
                  (fy(im,j)-fy(im,j+1))*acosp(j) ) / dp2(im,j)
   enddo

   call update_poles(im, jm, jfirst, jlast, q(1,jfirst), fy, dp1, dp2, acosp)

  case default
!-----------------------------------------------------------------------------
! This is a fully symmetrical multi-dimensional algorithm 
! Lin-Rood 1996 scheme. This revision requires 4 calls to flux-form operators
!-----------------------------------------------------------------------------
!---------
! E-W flux
!---------

   call ytp(im, jm, fy, q, cry, yfx, ng, min(iad,jord), 0, jfirst, jlast)
   do j=max(2,jfirst), min(jm-1,jlast)
      do i=1,im
         dh(i,j) = q(i,j)*dp1(i,j)
         qt(i) = 0.5 * ( q(i,j) +                      &
                         (dh(i,j) +  (fy(i,j)-fy(i,j+1))*acosp(j)) /  &
                         (dp1(i,j) + (yfx(i,j)-yfx(i,j+1))*acosp(j)) )
      enddo
 
      call xtp(im,   ffsl(j),  fx1, qt, crx(1,j), iord, &
               xfx(1,j), cosp(j), id, dm, qtmp, al, ar, a6)
      fx1(im+1) = fx1(1)

      do i=1,im
         dh(i,j) = dh(i,j) + fx1(i) - fx1(i+1)
      enddo
   enddo

!---------
! N-S flux
!---------
   do j=max(2,jfirst-ng), min(jm-1,jlast+ng)
 
! To avoid ghosting dp1 and xfx transport mixing ratio using CRX
      call xtp(im, ffsl(j), fx1, q(1,j), crx(1,j),     &
               min(iad,iord), crx(1,j), cosp(j), 0,    &
               dm, qtmp, al, ar, a6)

      do i=1,im-1
         qt(i) = (q(i,j) + fx1(i)-fx1(i+1)) / (1.+crx(i,j)-crx(i+1,j))
      enddo
         qt(im) = (q(im,j) + fx1(im)-fx1(1)) / (1.+crx(im,j)-crx(1,j))

      do i=1,im
         q(i,j) = 0.5 * (qt(i) + q(i,j))
      enddo
   enddo

   call ytp(im, jm, fy, q, cry, yfx, ng, jord, 0, jfirst, jlast)

   do j=max(2,jfirst), min(jm-1,jlast)
      do i=1,im
         dh(i,j) = dh(i,j) + (fy(i,j)-fy(i,j+1))*acosp(j)
      enddo
   enddo

!------
! Poles
!------
   if ( jfirst == 1 ) then
           sum1 = 0.
        do i=1,im
           sum1 = sum1 + q(i,1)*dp1(i,1) - fy(i,2)*acosp(1)
        enddo
           sum1 = sum1 / real(im)

        do i=1,im
           dh(i,1) = sum1
        enddo
   endif
   
   if ( jlast == jm ) then
          sum1 = 0.
        do i=1,im
           sum1 = sum1 + q(i,jm)*dp1(i,jm) + fy(i,jm)*acosp(jm)
        enddo
           sum1 = sum1 / real(im)

        do i=1,im
           dh(i,jm) = sum1
        enddo
   endif

   if (fill) call fillxy(dh, im, jm, jfirst, jlast, acap, cosp, acosp)

   do j=jfirst,jlast
      do i=1,im
         q(i,j) = dh(i,j) / dp2(i,j)
      enddo
   enddo
  end select

 end subroutine split_trac
 

 subroutine update_poles(im, jm, jfirst, jlast, q2, fy, dp1, dp2, acosp)
   integer, intent(in)::im, jm         ! Dimensions
   integer, intent(in)::jfirst, jlast  ! Latitude strip
   real, intent(in)::acosp(jm)         ! 
   real, intent(in)::fy(im,jfirst:jlast+1)    ! mass Flux in y
   real, intent(in)::dp1(im,jfirst:jlast)      ! "air density" at current step
   real, intent(in)::dp2(im,jfirst:jlast)      ! 
   real, intent(inout)::q2(im,jfirst:jlast)  ! transported scalar
! Local:
   integer i
   real sum1

   if ( jfirst == 1 ) then
           sum1 = 0.
        do i=1,im
           sum1 = sum1 + q2(i,1)*dp1(i,1) - fy(i,2)*acosp(1)
        enddo
           sum1 = sum1 / (real(im)*dp2(1,1))

        do i=1,im
           q2(i,1) = sum1
        enddo
   endif
   
   if ( jlast == jm ) then
          sum1 = 0.
        do i=1,im
           sum1 = sum1 + q2(i,jm)*dp1(i,jm) + fy(i,jm)*acosp(jm)
        enddo
           sum1 = sum1 / (real(im)*dp2(1,jm))

        do i=1,im
           q2(i,jm) = sum1
        enddo
   endif
 end subroutine update_poles

#ifndef USE_LIMA
 subroutine tp2d(q, crx, cry, im, jm, iord, jord, ng, fx, fy, ffsl,  &
                 xfx, yfx, cosp, acosp, id, jfirst, jlast, dp1, tp_step)
!-----------------------------------------------------------------------
! !INPUT PARAMETERS:
   integer, intent(in)::im, jm         ! Dimensions
   integer, intent(in)::jfirst, jlast  ! Latitude strip
   integer, intent(in)::iord, jord     ! Interpolation order in x,y
   integer, intent(in)::ng             ! Max. NS dependencies
   integer, intent(in)::id             ! density (0)  (mfx = C)
                                       ! mixing ratio (1) (mfx = mass flux)
   integer, intent(in)::tp_step
   logical, intent(in)::ffsl(jm)       ! Use flux-form semi-Lagrangian trans.?

   real, intent(in)::cosp(jm)          !
   real, intent(in)::acosp(jm)         ! 
   real, intent(in)::q(im,jfirst-ng:jlast+ng)  ! transported scalar
   real, intent(in)::dp1(im,jfirst:jlast)      ! "air density" at current step
   real, intent(in)::crx(im,jfirst-ng:jlast+ng)   !
   real, intent(in)::xfx(im,jfirst:jlast)   !
   real, intent(in)::cry(im,jfirst:jlast+1)       !
   real, intent(in)::yfx(im,jfirst:jlast+1)       !

! !OUTPUT PARAMETERS:
   real, intent(out)::fx(im,jfirst:jlast)     ! Flux in x ( unghosted )
   real, intent(out)::fy(im,jfirst:jlast+1)   ! Flux in y ( N, see tp2c )

! Local:
   integer:: iad=2
   real   dm(-im/3:im+im/3)
   real qtmp(-im/3:im+im/3)
   real   al(-im/3:im+im/3)
   real   ar(-im/3:im+im/3)
   real   a6(-im/3:im+im/3)
   real   qt(im)
   real  fx1(im)
   real  q2d(im,jfirst-ng:jlast+ng)
   integer i, j

   select case (tp_step)
   case(1)
          call ytp(im, jm, fy, q, cry, yfx, ng, jord, 0, jfirst, jlast)
          do j=max(2,jfirst), min(jm-1,jlast)
             if (id == 0) then
                do i=1,im
                   qt(i) = (q(i,j) + (fy(i,j)-fy(i,j+1))*acosp(j)) /  &
                           (1.+(yfx(i,j)-yfx(i,j+1))*acosp(j))
                enddo
             else
                do i=1,im
                   qt(i) = (q(i,j)*dp1(i,j)+(fy(i,j)-fy(i,j+1))*acosp(j)) /  &
                           (dp1(i,j)+(yfx(i,j)-yfx(i,j+1))*acosp(j))
                enddo
            endif
 
          call xtp(im,   ffsl(j),  fx(1,j), qt, crx(1,j), iord,  &
                   xfx(1,j), cosp(j), id, dm, qtmp, al, ar, a6)
          enddo
   case(2)
          do j=max(2,jfirst-ng), min(jm-1,jlast+ng)
             call xtp(im, ffsl(j), fx1, q(1,j), crx(1,j), iord,  &
                      crx(1,j), cosp(j), 0, dm, qtmp, al, ar, a6)
             do i=1,im-1
                q2d(i,j) = (q(i,j) + fx1(i)-fx1(i+1)) / (1.+crx(i,j)-crx(i+1,j))
             enddo
                q2d(im,j) = (q(im,j) + fx1(im)-fx1(1)) / (1.+crx(im,j)-crx(1,j))

             if ( j >= jfirst .and. j <= jlast) then
                if ( id == 0 ) then
                  do i=1,im
                     fx(i,j) = fx1(i)
                  enddo
                else
                  if(ffsl(j)) then
                     do i=1,im
                        fx(i,j) = fx1(i)*xfx(i,j)
                     enddo
                  else
                     do i=1,im
                        fx(i,j) = fx1(i)*xfx(i,j)/sign(max(abs(crx(i,j)),tiny), crx(i,j))
                     enddo
                  endif
                endif
             endif
          enddo

          if ( jfirst-ng <= 1 ) then
               do i=1,im 
                  q2d(i,1) = q(i,1)
               enddo
          endif 
          if ( jlast+ng >= jm ) then
               do i=1,im 
                  q2d(i,jm) = q(i,jm)
               enddo
          endif
          call ytp(im, jm, fy, q2d, cry, yfx, ng, jord, 0, jfirst, jlast)

   case default
!--------------------------------------------------
! Fully symmetrical revised Lin-Rood 1996 algorithm
!--------------------------------------------------

! E-W flux
   call ytp(im, jm, fy, q, cry, yfx, ng, min(iad,jord), 0, jfirst, jlast)

   do j=max(2,jfirst), min(jm-1,jlast)
      if (id == 0) then
      do i=1,im
         qt(i) = 0.5 * ( q(i,j) +                    &
                        (q(i,j) + (fy(i,j)-fy(i,j+1))*acosp(j) ) /  &
                        (1.+(yfx(i,j)-yfx(i,j+1))*acosp(j)) )
      enddo
      else
      do i=1,im
         qt(i) = 0.5 * ( q(i,j) +              &
                        (q(i,j)*dp1(i,j)+(fy(i,j)-fy(i,j+1))*acosp(j)) /  &
                        (dp1(i,j)+(yfx(i,j)-yfx(i,j+1))*acosp(j)) )
      enddo
      endif
 
      call xtp(im,   ffsl(j),  fx(1,j), qt, crx(1,j), iord,  &
               xfx(1,j), cosp(j), id, dm, qtmp, al, ar, a6)
   enddo

! N-S flux
   do j=max(2,jfirst-ng), min(jm-1,jlast+ng)
      call xtp(im, ffsl(j), fx1, q(1,j), crx(1,j), min(iad,iord),  &
               crx(1,j), cosp(j), 0, dm, qtmp, al, ar, a6)

      do i=1,im-1
         qt(i) = (q(i,j) + fx1(i)-fx1(i+1)) / (1.+crx(i,j)-crx(i+1,j))
      enddo
         qt(im) = (q(im,j) + fx1(im)-fx1(1)) / (1.+crx(im,j)-crx(1,j))

      do i=1,im
         q2d(i,j) = 0.5 * (qt(i) + q(i,j))
      enddo
   enddo

   if ( jfirst-ng <= 1 ) then
        do i=1,im 
          q2d(i,1) = q(i,1)
        enddo
   endif 
   if ( jlast+ng >= jm ) then
        do i=1,im 
          q2d(i,jm) = q(i,jm)
        enddo
   endif

   call ytp(im, jm, fy, q2d, cry, yfx, ng, jord, 0, jfirst, jlast)
 end select

 end subroutine tp2d
#endif


#ifndef USE_LIMA
 subroutine tp2c(dh, h, crx, cry, im, jm,       &
                 iord, jord, ng, fx, fy, ffsl,      &
                 rcap, acosp, xfx, yfx, cosp,       &
                 id, jfirst, jlast, dp1, tp_step)
#else               
 subroutine tp2c(dh, va, h, crx, cry, im, jm,                            &
                 iord, jord, ng, fx, fy, ffsl,                           &
		 rcap, acosp, xfx, yfx, cosp,                            &
		 id, jfirst, jlast)
#endif
!-----------------------------------------------------------------------


! !INPUT PARAMETERS:
   integer im, jm                  ! Dimensions
   integer jfirst, jlast           ! Latitude strip
   integer iord, jord              ! Interpolation order in x,y
   integer ng                      ! Max. NS dependencies
   integer id                      ! density (0)  (mfx = C)
   real rcap                  !
   real acosp(jm)             !
   logical ffsl(jm)                ! Use flux-form semi-Lagrangian trans.?
   real cosp(jm)                   ! Critical angle
#ifdef USE_LIMA
   real va(im,jfirst:jlast)        ! Courant  (unghosted)
#endif
   real h(im,jfirst-ng:jlast+ng)   !
   real crx(im,jfirst-ng:jlast+ng) !
   real xfx(im,jfirst:jlast) !
   real   cry(im,jfirst:jlast+1)   !
   real   yfx(im,jfirst:jlast+1)   !
#ifndef USE_LIMA
   real, intent(in):: dp1(im,jfirst:jlast)     !
   integer, intent(in):: tp_step
#endif

! !OUTPUT PARAMETERS:
   real   dh(im,jfirst:jlast)      !
   real   fx(im,jfirst:jlast)      ! Flux in x ( unghosted )
   real   fy(im,jfirst:jlast+1)    ! Flux in y ( N, see tp2c )

! !DESCRIPTION:
!     Perform transport on a C grid.   The number of ghost
!     latitudes (NG) depends on what method (JORD) will be used
!     subsequentally.    NG is equal to MIN(ABS(JORD),3).
!     Ask S.-J. how exactly this differs from TP2C.
!
! !REVISION HISTORY:
!
!EOP
!-----------------------------------------------------------------------
!BOC
   integer i, j, js2g0, jn2g0
   real    sum1

   js2g0  = max(2,jfirst)          !  No ghosting
   jn2g0  = min(jm-1,jlast)        !  No ghosting

#ifndef USE_LIMA
   call tp2d(h, crx, cry, im, jm, iord, jord, ng,fx, fy, ffsl,    &
             xfx, yfx, cosp, acosp, id, jfirst, jlast, dp1, tp_step)
#else
   call tp2d_lima(va, h, crx, cry, im, jm, iord, jord, ng,fx, fy, ffsl,    &
             xfx, yfx, cosp, id, jfirst, jlast)
#endif
   do j=js2g0,jn2g0
      do i=1,im-1
         dh(i,j) = fx(i,j) - fx(i+1,j) + (fy(i,j)-fy(i,j+1))*acosp(j)
      enddo
   enddo

   do j=js2g0,jn2g0
      dh(im,j) = fx(im,j) - fx(1,j) + (fy(im,j)-fy(im,j+1))*acosp(j)
   enddo

! Poles
   if ( jfirst ==  1 ) then
        sum1 = 0.
        do i=1,im
          sum1 = sum1 + fy(i,2)
        enddo
          sum1 = -sum1*rcap
        do i=1,im
          dh(i, 1) = sum1
        enddo
   endif
   
   if ( jlast == jm ) then
        sum1 = 0.
        do i=1,im
          sum1 = sum1 + fy(i,jm)
        enddo
          sum1 = sum1*rcap
        do i=1,im
          dh(i,jm) = sum1
        enddo
   endif
 end subroutine tp2c



 subroutine xtp(im, ffsl,  fx,  q,  c,  iord,  mfx,            &
                cosa, id, dm, qtmp, al, ar, a6)
!---------------------------------------------------------------

! !INPUT PARAMETERS:
   integer, intent(in):: id      ! ID = 0: density (mfx = C)
                                 ! ID = 1: mixing ratio (mfx is mass flux)

   integer, intent(in):: im      ! Total longitudes
   integer, intent(in):: iord
   real, intent(in):: c(im)      ! Courant numbers
   real, intent(in):: q(im)
   real, intent(in):: mfx(im)
   real, intent(in):: cosa
   logical, intent(in):: ffsl

! !INPUT/OUTPUT PARAMETERS:
   real, intent(out):: qtmp(-im/3:im+im/3)   ! Input work arrays:
   real, intent(out):: dm(-im/3:im+im/3)
   real, intent(out):: al(-im/3:im+im/3)
   real, intent(out):: ar(-im/3:im+im/3)
   real, intent(out):: a6(-im/3:im+im/3)

! !OUTPUT PARAMETERS:
   real, intent(out):: fx(im)

! !DESCRIPTION:
!   
!
! !REVISION HISTORY:
!
!EOP
!-----------------------------------------------------------------------
!BOC

! Local:
   real:: cos_upw = 0.04              !critical cosine for upwind
   real:: cos_ppm = 0.17               !critical cosine for ppm

   real   qmax, qmin
   real   rut, tmp
   integer isave(im)
   integer iu, itmp, ist
   integer iuw, iue
   integer i, imp

   imp = im + 1

   do i=1,im
      qtmp(i) = q(i)
   enddo

   if( ffsl ) then
!-----------------------------------
! Flux-Form Semi-Lagrangian transport
!-----------------------------------

! Figure out ghost zone for the western edge:
      iuw =  -c(1)
      iuw = min(0, iuw)
 
      do i=iuw, 0
         qtmp(i) = q(im+i)
      enddo 

! Figure out ghost zone for the eastern edge:
      iue = im - c(im)
      iue = max(imp, iue)

      do i=imp, iue
         qtmp(i) = q(i-im)
      enddo

      if( iord == 1 .or. cosa < cos_upw) then
          do i=1,im
             iu = c(i)
             if(c(i) <= 0.) then
                itmp = i - iu
                isave(i) = itmp - 1
             else
                itmp = i - iu - 1
                isave(i) = itmp + 1
             endif
             fx(i) = (c(i)-iu) * qtmp(itmp)
          enddo
      else
          do i=1,im
             tmp = 0.25*(qtmp(i+1) - qtmp(i-1))
             qmax = max(qtmp(i-1), qtmp(i), qtmp(i+1)) - qtmp(i)
             qmin = qtmp(i) - min(qtmp(i-1), qtmp(i), qtmp(i+1))
             dm(i) = sign(min(abs(tmp),qmax,qmin), tmp)
          enddo
 
          do i=iuw, 0
             dm(i) = dm(im+i)
          enddo 

          do i=imp, iue
             dm(i) = dm(i-im)
          enddo

          if(iord >= 3 .and. cosa > cos_ppm) then
! mfx is not used in fxppm if ffsl = T
             call fxppm(im, c, mfx, qtmp, dm, fx, min(4,iord),  &
                        al, ar, a6, iuw, iue, ffsl, isave)
          else
             do i=1,im
                iu  = c(i)
                rut = c(i) - iu
                if(c(i) <= 0.) then
                   itmp = i - iu
                   isave(i) = itmp - 1
                   fx(i) = rut*(qtmp(itmp)-dm(itmp)*(1.+rut))
                else
                   itmp = i - iu - 1
                   isave(i) = itmp + 1
                   fx(i) = rut*(qtmp(itmp)+dm(itmp)*(1.-rut))
                endif
             enddo
          endif
      endif

      do i=1,im
!     if(c(i) >= 1.) then
      if(c(i) > 1.) then
         do ist = isave(i),i-1
            fx(i) = fx(i) + qtmp(ist)
         enddo
!     elseif(c(i) <= -1.) then
      elseif(c(i) < -1.) then
         do ist = i,isave(i)
            fx(i) = fx(i) - qtmp(ist)
         enddo
      endif
      enddo

      if(id /= 0) then
         do i=1,im
            fx(i) = fx(i)*mfx(i)
         enddo
      endif

   else
!----------------------------------------------
! Regular PPM (Eulerian without FFSL extension)
!----------------------------------------------

      qtmp(imp) = q(1)
      qtmp(  0) = q(im)

      if(iord == 1 .or. cosa < cos_upw) then
         do i=1,im
            iu = float(i) - c(i)
            fx(i) = mfx(i)*qtmp(iu)
         enddo
      else

         qtmp(-1)    = q(im-1)
         qtmp(imp+1) = q(2)

         if(iord > 0 .or. cosa < cos_ppm) then
            call xmist(im, qtmp, dm, 2)
         else
            call xmist(im, qtmp, dm, iord)
         endif

         dm(0) = dm(im)

         if( abs(iord)==2 .or. cosa < cos_ppm ) then
            do i=1,im
               iu = float(i) - c(i)
               fx(i) =  mfx(i)*(qtmp(iu)+dm(iu)*(sign(1.,c(i))-c(i)))
            enddo
         else
            call fxppm(im, c, mfx, qtmp, dm, fx, iord, al, ar, a6,  &
                       iuw, iue, ffsl, isave)
         endif
      endif

   endif
 end subroutine xtp



 subroutine xmist(im,  q,  dm,  id)
!-----------------------------------------------------------------------

! !INPUT PARAMETERS:
 integer im                   ! Total number of longitudes
 integer id                   ! ID = 0: density (mfx = C)
                              ! ID = 1: mixing ratio (mfx is mass flux)
 real   q(-im/3:im+im/3)   ! Input latitude 

! !OUTPUT PARAMETERS:
 real  dm(-im/3:im+im/3)   ! 

! !DESCRIPTION:
!   
!
! !REVISION HISTORY:
!   99.01.01 Lin      Creation
!   01.03.27 Sawyer   Additional ProTeX documentation
!
!EOP
!-----------------------------------------------------------------------
!BOC

 real::  r24 = 1./24.

 integer i
 real  qmin, qmax

    if(id <= 2) then
       do i=1,im
          dm(i) = r24*(8.*(q(i+1) - q(i-1)) + q(i-2) - q(i+2))
       enddo
    else
       do i=1,im
          dm(i) = 0.25*(q(i+1) - q(i-1))
       enddo
    endif

    if( id < 0 ) return

! Apply monotonicity constraint (Lin et al. 1994, MWR)
      do i=1,im
         qmax = max( q(i-1), q(i), q(i+1) ) - q(i)
         qmin = q(i) - min( q(i-1), q(i), q(i+1) )
         dm(i) = sign( min(abs(dm(i)), qmax, qmin), dm(i) )
      enddo
!EOC
 end subroutine xmist
!-----------------------------------------------------------------------


 subroutine fxppm(im, c, mfx,  p, dm, fx, iord, al, ar, a6,        &
                  iuw, iue, ffsl, isave)
!-----------------------------------------------------------------------
!
! !USES:

! !INPUT PARAMETERS:
 integer, intent(in):: im, iord
 real, intent(in):: c(im)
 real, intent(in):: p(-im/3:im+im/3)
 real, intent(in):: dm(-im/3:im+im/3)
 real, intent(in):: mfx(im)
 integer, intent(in):: iuw, iue
 logical, intent(in):: ffsl

! !OUTPUT PARAMETERS:
 integer, intent(out):: isave(im)
 real, intent(out):: fx(im)

! work arrays:
 real, intent(out):: al(-im/3:im+im/3)
 real, intent(out):: ar(-im/3:im+im/3)
 real, intent(out):: a6(-im/3:im+im/3)

! !DESCRIPTION:
!   
!
! !REVISION HISTORY:
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
 real::  r3 = 1./3.
 real::  r23 = 2./3.

 integer i, lmt
 integer iu, itmp
 real   ru

  do i=1,im
     al(i) = 0.5*(p(i-1)+p(i)) + (dm(i-1) - dm(i))*r3
  enddo

  if( iord>=6 ) call steepx( im, p, al(1), dm )

     do i=1,im-1
        ar(i) = al(i+1)
     enddo
        ar(im) = al(1)

  if(iord == 7) then
     call huynh(im, ar(1), al(1), p(1), a6(1), dm(1))
  else
     if(iord == 3 .or. iord == 5) then
         do i=1,im
            a6(i) = 3.*(p(i)+p(i)  - (al(i)+ar(i)))
         enddo
     endif
     lmt = iord - 3
     call lmppm( dm(1), a6(1), ar(1), al(1), p(1), im, lmt )
  endif

  if( ffsl ) then

      do i=iuw, 0
         al(i) = al(im+i)
         ar(i) = ar(im+i)
         a6(i) = a6(im+i)
      enddo

      do i=im+1, iue
         al(i) = al(i-im)
         ar(i) = ar(i-im)
         a6(i) = a6(i-im)
      enddo

      do i=1,im
            iu = c(i)
            ru = c(i) - iu
         if(c(i) > 0.) then
            itmp = i - iu - 1
            isave(i) = itmp + 1
            fx(i) = ru*(ar(itmp)+0.5*ru*(al(itmp)-ar(itmp) +     &
                        a6(itmp)*(1.-r23*ru)) )
         else
            itmp = i - iu
            isave(i) = itmp - 1
            fx(i) = ru*(al(itmp)-0.5*ru*(ar(itmp)-al(itmp) +     &
                        a6(itmp)*(1.+r23*ru)) )
         endif
      enddo

  else
         al(0) = al(im)
         ar(0) = ar(im)
         a6(0) = a6(im)
      do i=1,im
         if(c(i) > 0.) then
            fx(i) = ar(i-1) + 0.5*c(i)*(al(i-1) - ar(i-1) +   &
                    a6(i-1)*(1.-r23*c(i)) )
      else
            fx(i) = al(i) - 0.5*c(i)*(ar(i) - al(i) +         &
                    a6(i)*(1.+r23*c(i)))
      endif
            fx(i) = mfx(i) * fx(i)
      enddo
  endif
!EOC
 end subroutine fxppm
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
! !IROUTINE: steepx
!
! !INTERFACE: 
 subroutine  steepx(im, p, al, dm)
!-----------------------------------------------------------------------

! !USES:

! !INPUT PARAMETERS:
 integer im
 real    p(-im/3:im+im/3)
 real   dm(-im/3:im+im/3)

! !INPUT/OUTPUT PARAMETERS:
 real   al(im)

! !DESCRIPTION:
!   
!
! !REVISION HISTORY:
!   99.01.01 Lin      Creation
!   01.03.27 Sawyer   Additional ProTeX documentation
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
 integer i
 real::  r3 = 1./3.
 real   dh(0:im)
 real   d2(0:im+1)
 real   eta(0:im)
 real   xxx, bbb, ccc

   do i=0,im
      dh(i) = p(i+1) - p(i)
   enddo

! Needs dh(0:im)
   do i=1,im
      d2(i) = dh(i) - dh(i-1)
   enddo
   d2(0) = d2(im)
   d2(im+1) = d2(1)

! needs p(-1:im+2), d2(0:im+1)
   do i=1,im
      if( d2(i+1)*d2(i-1).lt.0. .and. p(i+1).ne.p(i-1) ) then
          xxx    = 1. - 0.5 * ( p(i+2) - p(i-2) ) / ( p(i+1) - p(i-1) )
          eta(i) = max(0., min(xxx, 0.5) )
      else
          eta(i) = 0.
      endif
    enddo

    eta(0) = eta(im)

! needs eta(0:im), dh(0:im-1), dm(0:im)
   do i=1,im
      bbb = ( 2.*eta(i  ) - eta(i-1) ) * dm(i-1) 
      ccc = ( 2.*eta(i-1) - eta(i  ) ) * dm(i  ) 
      al(i) = al(i) + 0.5*( eta(i-1) - eta(i)) * dh(i-1) + (bbb - ccc) * r3
   enddo
!EOC
 end subroutine steepx
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
! !IROUTINE: lmppm
!
! !INTERFACE: 
 subroutine lmppm(dm, a6, ar, al, p, im, lmt)
!-----------------------------------------------------------------------


! !INPUT PARAMETERS:
 integer im   ! Total longitudes
 integer lmt  ! LMT = 0: full monotonicity
              ! LMT = 1: Improved and simplified full monotonic constraint
              ! LMT = 2: positive-definite constraint
              ! LMT = 3: Quasi-monotone constraint
 real  p(im)
 real  dm(im)

! !OUTPUT PARAMETERS:
 real  a6(im)
 real  ar(im)
 real  al(im)

! !DESCRIPTION:
!
!
! !REVISION HISTORY:
!   99.01.01 Lin      Creation
!   01.03.27 Sawyer   Additional ProTeX documentation
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
 real:: r12 = 1./12.

 real   da1, da2, fmin, a6da
 real   dr, dl

 integer i

! LMT = 0: full monotonicity
! LMT = 1: Improved and simplified full monotonic constraint
! LMT = 2: positive-definite constraint
! LMT = 3: Quasi-monotone constraint

  if( lmt == 0 ) then

! Full constraint
  do i=1,im
     if(dm(i) == 0.) then
         ar(i) = p(i)
         al(i) = p(i)
         a6(i) = 0.
     else
         da1  = ar(i) - al(i)
         da2  = da1**2
         a6da = a6(i)*da1
         if(a6da < -da2) then
            a6(i) = 3.*(al(i)-p(i))
            ar(i) = al(i) - a6(i)
         elseif(a6da > da2) then
            a6(i) = 3.*(ar(i)-p(i))
            al(i) = ar(i) - a6(i)
         endif
     endif
  enddo

  elseif( lmt == 1 ) then

! Improved (Lin 2004) full constraint
      do i=1,im
           da1 = dm(i) + dm(i)
            dl = sign(min(abs(da1),abs(al(i)-p(i))), da1)
            dr = sign(min(abs(da1),abs(ar(i)-p(i))), da1)
         ar(i) = p(i) + dr
         al(i) = p(i) - dl
         a6(i) = 3.*(dl-dr)
      enddo

  elseif( lmt == 2 ) then
! Positive definite constraint
      do 250 i=1,im
      if(abs(ar(i)-al(i)) .ge. -a6(i)) go to 250
      fmin = p(i) + 0.25*(ar(i)-al(i))**2/a6(i) + a6(i)*r12
      if(fmin.ge.0.) go to 250
      if(p(i).lt.ar(i) .and. p(i).lt.al(i)) then
            ar(i) = p(i)
            al(i) = p(i)
            a6(i) = 0.
      elseif(ar(i) .gt. al(i)) then
            a6(i) = 3.*(al(i)-p(i))
            ar(i) = al(i) - a6(i)
      else
            a6(i) = 3.*(ar(i)-p(i))
            al(i) = ar(i) - a6(i)
      endif
250   continue

  elseif(lmt == 3) then
! Quasi-monotone constraint
      do i=1,im
         da1 = 4.*dm(i)
          dl = sign(min(abs(da1),abs(al(i)-p(i))), da1)
          dr = sign(min(abs(da1),abs(ar(i)-p(i))), da1)
         ar(i) = p(i) + dr
         al(i) = p(i) - dl
         a6(i) = 3.*(dl-dr)
      enddo
  endif
!EOC
 end subroutine lmppm
!-----------------------------------------------------------------------


!-----------------------------------------------------------------------
!BOP
! !IROUTINE: huynh --- Enforce Huynh's 2nd constraint in 1D periodic domain
!
! !INTERFACE: 
 subroutine huynh(im, ar, al, p, d2, d1)
!-----------------------------------------------------------------------

! !USES:


! !INPUT PARAMETERS:
 integer im
 real   p(im)

! !OUTPUT PARAMETERS:
 real  ar(im)
 real  al(im)
 real  d2(im)
 real  d1(im)

! !DESCRIPTION:
!
!   Enforce Huynh's 2nd constraint in 1D periodic domain
!
! !REVISION HISTORY:
!   99.01.01 Lin      Creation
!   01.03.27 Sawyer   Additional ProTeX documentation
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
 integer  i
 real  pmp
 real  lac
 real  pmin
 real  pmax

! Compute d1 and d2
      d1(1) = p(1) - p(im)
      do i=2,im
         d1(i) = p(i) - p(i-1)
      enddo

      do i=1,im-1
         d2(i) = d1(i+1) - d1(i)
      enddo
      d2(im) = d1(1) - d1(im)

! Constraint for AR
!            i = 1
         pmp   = p(1) + 2.0 * d1(1)
         lac   = p(1) + 0.5 * (d1(1)+d2(im)) + d2(im) 
         pmin  = min(p(1), pmp, lac)
         pmax  = max(p(1), pmp, lac)
         ar(1) = min(pmax, max(ar(1), pmin))

      do i=2, im
         pmp   = p(i) + 2.0*d1(i)
         lac   = p(i) + 0.5*(d1(i)+d2(i-1)) + d2(i-1)
         pmin  = min(p(i), pmp, lac)
         pmax  = max(p(i), pmp, lac)
         ar(i) = min(pmax, max(ar(i), pmin))
      enddo

! Constraint for AL
      do i=1, im-1
         pmp   = p(i) - 2.0*d1(i+1)
         lac   = p(i) + 0.5*(d2(i+1)-d1(i+1)) + d2(i+1)
         pmin  = min(p(i), pmp, lac)
         pmax  = max(p(i), pmp, lac)
         al(i) = min(pmax, max(al(i), pmin))
      enddo

! i=im
         i = im
         pmp    = p(im) - 2.0*d1(1)
         lac    = p(im) + 0.5*(d2(1)-d1(1)) + d2(1)
         pmin   = min(p(im), pmp, lac)
         pmax   = max(p(im), pmp, lac)
         al(im) = min(pmax, max(al(im), pmin))

! compute A6 (d2)
      do i=1, im
         d2(i) = 3.*(p(i)+p(i)  - (al(i)+ar(i)))
      enddo
!EOC
 end subroutine huynh
!-----------------------------------------------------------------------


!-----------------------------------------------------------------------
!BOP
! !IROUTINE: ytp
!
! !INTERFACE: 
 subroutine ytp(im, jm, fy, q, c, yfx, ng, jord, iv, jfirst, jlast)
!-----------------------------------------------------------------------

! !USES:

! !INPUT PARAMETERS:
 integer, intent(in):: im, jm          !  Dimensions
 integer, intent(in):: jfirst, jlast   !  Latitude strip
 integer, intent(in):: ng              !  Max. NS dependencies
 integer, intent(in):: jord            !  order of subgrid dist
 integer, intent(in):: iv              !  Scalar=0, Vector=1
 real, intent(in):: q(im,jfirst-ng:jlast+ng)   !  advected scalar
 real, intent(in):: c(im,jfirst:jlast+1)       !  Courant   N (like FY)
 real, intent(in):: yfx(im,jfirst:jlast+1)     !  Backgrond mass flux

! !OUTPUT PARAMETERS:
 real, intent(out):: fy(im,jfirst:jlast+1)     !  Flux   

! !DESCRIPTION:
!     This routine calculates the flux.  The method chosen
!     depends on the order of the calculation JORD (currently
!     1, 2 or 3).  
!
! !REVISION HISTORY:
!
!  SJL 99.04.13:  Delivery
!  WS  99.04.13:  Added jfirst:jlast concept
!  WS  99.04.21:  Removed j1 and j2 (j1=2, j2=jm-1 consistently)
!                 removed a6,ar,al from argument list
!  WS  99.04.27:  DM made local to this routine
!  WS  99.09.09:  Documentation; indentation; cleaning
!  WS  99.10.22:  Added NG as argument; pruned arrays
!  SJL 99.12.24:  Revised documentation; optimized for better cache usage
!  WS  00.05.14:  Renamed ghost indices as per Kevin's definitions
!
!EOP
!---------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
 integer i, j, jt
 integer js2g0, jn1g1

! work arrays (should pass in eventually for performance enhancement):
 real   dm(im,jfirst-ng:jlast+ng)

!     real   ar(im,jfirst-1:jlast+1)  ! AR needs to be ghosted on NS
!     real   al(im,jfirst-1:jlast+2)  ! AL needs to be ghosted on N2S
!     real   a6(im,jfirst-1:jlast+1)  ! A6 needs to be ghosted on NS

   js2g0  = max(2,jfirst)       ! No ghosting
   jn1g1  = min(jm,jlast+1)     ! Ghost N*1
     
   if(jord == 1) then
!!!        do j=2,jm
        do j=js2g0,jn1g1
          do i=1,im
            jt = float(j) - c(i,j)
            fy(i,j) = q(i,jt)
          enddo
        enddo
   else

!
! YMIST requires q on NS;  Only call to YMIST here
!
        call ymist(im, jm, q, dm, ng, jord, iv, jfirst, jlast)

        if( abs(jord) .ge. 3 ) then
 
          call fyppm(c,q,dm,fy,im,jm,ng,jord,iv,jfirst,jlast)

        else
!
! JORD can either have the value 2 or -2 at this point
!
!!!          do j=2,jm
          do j=js2g0,jn1g1
            do i=1,im
               jt = float(j) - c(i,j)
! Uncomment the next 3 lines if you are debugging and want the model to 
! come down immediately when there's a CFL violation.
!               if( jt.LT.jfirst-ng )then
!                   call mpp_error( FATAL, 'YTP' )
!               end if
              fy(i,j) = q(i,jt) + (sign(1.,c(i,j))-c(i,j))*dm(i,jt)
            enddo
          enddo
        endif
   endif

!!!      do j=2,jm
      do j=js2g0,jn1g1
        do i=1,im
          fy(i,j) = fy(i,j)*yfx(i,j)
        enddo
      enddo
!EOC
 end subroutine ytp
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
! !IROUTINE: ymist
!
! !INTERFACE: 
 subroutine ymist(im, jm, q, dm, ng, jord, iv, jfirst, jlast)
!-----------------------------------------------------------------------

! !USES:

! !INPUT PARAMETERS:
 integer im, jm                      !  Dimensions
 integer jfirst, jlast               !  Latitude strip
 integer ng                          !  NS dependencies
 integer jord                        !  order of subgrid distribution
 integer iv                          !  Scalar (==0) Vector (==1)
 real   q(im,jfirst-ng:jlast+ng)  !  transported scalar  N*ng S*ng

! !OUTPUT PARAMETERS:
 real   dm(im,jfirst-ng:jlast+ng)      !  Slope only N*(ng-1) S*(ng-1) used

! !DESCRIPTION:
!     Calculate the slope of the pressure.  The number of ghost
!     latitudes (NG) depends on what method (JORD) will be used
!     subsequentally.    NG is equal to MIN(ABS(JORD),3).
!
! !CALLED FROM:
!     ytp
!
! !REVISION HISTORY:
!
!  SJL 99.04.13:  Delivery
!  WS  99.04.13:  Added jfirst:jlast concept
!  WS  99.09.09:  Documentation; indentation; cleaning
!  SJL 00.01.06:  Documentation
!  WS  00.05.14:  Renamed ghost indices as per Kevin's definitions
!
!EOP
!---------------------------------------------------------------------
!BOC

! Local variables

 integer i, j, jm1, im2, js2gng1, jn2gng1
 real   qmax, qmin, tmp

    js2gng1 = max(2,   jfirst-ng+1)     !  Number needed on S
    jn2gng1 = min(jm-1,jlast+ng-1)      !  Number needed on N

    jm1 = jm - 1
    im2 = im / 2

!!!      do j=2,jm1
      do j=js2gng1,jn2gng1
        do i=1,im
           dm(i,j) = 0.25*(q(i,j+1) - q(i,j-1))
        enddo
      enddo

   if( iv == 0 ) then

        if ( jfirst-ng <= 1 ) then
! S pole
          do i=1,im2
            tmp = 0.25*(q(i,2)-q(i+im2,2))
            qmax = max(q(i,2),q(i,1), q(i+im2,2)) - q(i,1)
            qmin = q(i,1) - min(q(i,2),q(i,1), q(i+im2,2))
            dm(i,1) = sign(min(abs(tmp),qmax,qmin),tmp)
          enddo

          do i=im2+1,im
            dm(i, 1) =  - dm(i-im2, 1)
          enddo
        endif

        if ( jlast+ng >= jm ) then
! N pole
          do i=1,im2
            tmp = 0.25*(q(i+im2,jm1)-q(i,jm1))
            qmax = max(q(i+im2,jm1),q(i,jm), q(i,jm1)) - q(i,jm)
            qmin = q(i,jm) - min(q(i+im2,jm1),q(i,jm), q(i,jm1))
            dm(i,jm) = sign(min(abs(tmp),qmax,qmin),tmp)
          enddo

          do i=im2+1,im
            dm(i,jm) =  - dm(i-im2,jm)
          enddo
        endif

   else

        if ( jfirst-ng <= 1 ) then
! South
          do i=1,im2
            tmp  = 0.25*(q(i,2)+q(i+im2,2))
            qmax = max(q(i,2),q(i,1), -q(i+im2,2)) - q(i,1)
            qmin = q(i,1) - min(q(i,2),q(i,1),-q(i+im2,2))
            dm(i,1) = sign(min(abs(tmp),qmax,qmin),tmp)
          enddo

          do i=im2+1,im
            dm(i, 1) = dm(i-im2, 1)
          enddo
        endif

        if ( jlast+ng >= jm ) then
! North
          do i=1,im2
            tmp  = -0.25*(q(i+im2,jm1)+q(i,jm1))
            qmax = max(-q(i+im2,jm1),q(i,jm), q(i,jm1)) - q(i,jm)
            qmin = q(i,jm) - min(-q(i+im2,jm1),q(i,jm), q(i,jm1))
            dm(i,jm) = sign(min(abs(tmp),qmax,qmin),tmp)
          enddo

          do i=im2+1,im
            dm(i,jm) = dm(i-im2,jm)
          enddo
        endif

   endif

   if( jord > 0 ) then
!
! Applies monotonic slope constraint (off if jord less than zero)
!
!!!        do j=2,jm1
        do j=js2gng1,jn2gng1
          do i=1,im
            qmax = max(q(i,j-1),q(i,j),q(i,j+1)) - q(i,j)
            qmin = q(i,j) - min(q(i,j-1),q(i,j),q(i,j+1))
            dm(i,j) = sign(min(abs(dm(i,j)),qmin,qmax),dm(i,j))
          enddo
        enddo
   endif
!EOC
 end subroutine ymist
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
! !IROUTINE: fyppm
!
! !INTERFACE: 
 subroutine fyppm(c,  q,  dm, flux, im, jm, ng, jord, iv, jfirst, jlast)
!-----------------------------------------------------------------------

! !USES:

! !INPUT PARAMETERS:
 integer im, jm                      !  Dimensions
 integer jfirst, jlast               !  Latitude strip
 integer ng                          !  Max. NS dependencies
 integer jord                        !  Approximation order
 integer iv                          !  Scalar=0, Vector=1
 real    q(im,jfirst-ng:jlast+ng) !  mean value needed only N*2 S*2
 real   dm(im,jfirst-ng:jlast+ng) !  Slope     needed only N*2 S*2
 real    c(im,jfirst:jlast+1)     !  Courant   N (like FLUX)

! !INPUT/OUTPUT PARAMETERS:
 real   ar(im,jfirst-1:jlast+1)   ! AR needs to be ghosted on NS
 real   al(im,jfirst-1:jlast+2)   ! AL needs to be ghosted on N2S
 real   a6(im,jfirst-1:jlast+1)   ! A6 needs to be ghosted on NS

! !OUTPUT PARAMETERS:
 real   flux(im,jfirst:jlast+1)   !  Flux    

! !DESCRIPTION:
!
!   NG is passed from YTP for convenience -- it is actually 1 more in NS
!   than the actual number of latitudes needed here.  But in the shared-memory 
!   case it becomes 0, which is much cleaner.
!
! !CALLED FROM:
!      ytp
!
! !REVISION HISTORY:
!
!  SJL 99.04.13:  Delivery
!  WS  99.04.19:  Added jfirst:jlast concept; FYPPM only called from YTP
!  WS  99.04.21:  Removed j1, j2  (j1=2, j2=jm-1 consistently)
!                 removed a6,ar,al from argument list
!  WS  99.09.09:  Documentation; indentation; cleaning
!  WS  99.10.22:  Added ng as argument; Pruned arrays
!  WS  00.05.14:  Renamed ghost indices as per Kevin's definitions
!
!EOP
!---------------------------------------------------------------------
!BOC
 real:: r3 = 1./3.
 real:: r23 = 2./3.
 integer i, j, imh, jm1, lmt
 integer js1g1, js2g0, js2g1, jn1g2, jn1g1, jn2g1
!     logical steep

!     if(jord .eq. 6) then
!        steep = .true.
!     else
!        steep = .false.
!     endif

      imh = im / 2
      jm1 = jm - 1

      js1g1  = max(1,jfirst-1)         ! Ghost S*1
      js2g0  = max(2,jfirst)           ! No ghosting
      js2g1  = max(2,jfirst-1)         ! Ghost S*1
      jn1g1  = min(jm,jlast+1)         ! Ghost N*1
      jn1g2  = min(jm,jlast+2)         ! Ghost N*2
      jn2g1  = min(jm-1,jlast+1)       ! Ghost N*1

!!!      do j=2,jm
      do j=js2g1,jn1g2                 ! AL needed N2S
        do i=1,im                      ! P, dm ghosted N2S2 (at least)
          al(i,j) = 0.5*(q(i,j-1)+q(i,j)) + r3*(dm(i,j-1) - dm(i,j))
        enddo
      enddo

! Yeh's steepening procedure; to be implemented
!     if(steep) call steepy(im,   jm,   jfirst,   jlast,       &
!                           ng,    q,       al,   dm )

!!!      do j=1,jm1
      do j=js1g1,jn2g1                 ! AR needed NS
        do i=1,im
          ar(i,j) = al(i,j+1)          ! AL ghosted N2S
        enddo
      enddo

! Poles:

   if( iv == 0 ) then

        if ( jfirst-1 <= 1 ) then
          do i=1,imh
            al(i,    1) = al(i+imh,2)
            al(i+imh,1) = al(i,    2)
          enddo
        endif

        if ( jlast+2 >= jm ) then
          do i=1,imh
            ar(i,    jm) = ar(i+imh,jm1)
            ar(i+imh,jm) = ar(i,    jm1)
          enddo
        endif

   else

        if ( jfirst-1 <= 1 ) then
          do i=1,imh
            al(i,    1) = -al(i+imh,2)
            al(i+imh,1) = -al(i,    2)
          enddo
        endif

        if ( jlast+2 >= jm ) then
          do i=1,imh
            ar(i,    jm) = -ar(i+imh,jm1)
            ar(i+imh,jm) = -ar(i,    jm1)
          enddo
        endif

   endif

   if( jord == 3 .or. jord == 5 ) then
!!!      do j=1,jm
      do j=js1g1,jn1g1               ! A6 needed NS
        do i=1,im
          a6(i,j) = 3.*(q(i,j)+q(i,j) - (al(i,j)+ar(i,j)))
        enddo
      enddo
   endif

      lmt = jord - 3

      call lmppm(dm(1,js1g1), a6(1,js1g1), ar(1,js1g1),               &
                 al(1,js1g1),  q(1,js1g1), im*(jn1g1-js1g1+1), lmt)

!!!      do j=2,jm
      do j=js2g0,jn1g1                 ! flux needed N
        do i=1,im
          if(c(i,j).gt.0.) then
            flux(i,j) = ar(i,j-1) + 0.5*c(i,j)*(al(i,j-1) - ar(i,j-1) +  &
                        a6(i,j-1)*(1.-r23*c(i,j)) )
          else
            flux(i,j) = al(i,j) - 0.5*c(i,j)*(ar(i,j) - al(i,j) +        &
                        a6(i,j)*(1.+r23*c(i,j)))
          endif
        enddo
      enddo
!EOC
 end subroutine fyppm 
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
! !IROUTINE: tpcc
!
! !INTERFACE: 
 subroutine tpcc(va,   ymass,  q,   crx,  cry,  im,   jm,  ng_c, ng_d,   &
                 iord, jord,   fx,  fy,   ffsl, cose, jfirst, jlast,     &
                 dm,   qtmp,   al,  ar,   a6 )       
!-----------------------------------------------------------------------

! !USES:

! !INPUT PARAMETERS:
  integer im, jm                    ! Dimensions
  integer ng_c                      ! 
  integer ng_d                      ! 
  integer jfirst, jlast             ! Latitude strip
  integer iord, jord                ! Interpolation order in x,y
  logical ffsl(jm)                  ! Flux-form semi-Lagrangian transport?
  real   cose(jm)                ! cosine at cell edges
  real   va(im,jfirst:jlast)     ! Courant (unghosted like FX)
  real   q(im,jfirst-ng_d:jlast+ng_d) !
  real   crx(im,jfirst-ng_c:jlast+ng_c)
  real   cry(im,jfirst:jlast)    ! Courant # (ghosted like FY)
  real   ymass(im,jfirst:jlast)  ! Background y-mass-flux (ghosted like FY)

! Input 1D work arrays:
  real     dm(-im/3:im+im/3)
  real   qtmp(-im/3:im+im/3)
  real     al(-im/3:im+im/3)
  real     ar(-im/3:im+im/3)
  real     a6(-im/3:im+im/3)

! !OUTPUT PARAMETERS:
  real   fx(im,jfirst:jlast)     ! Flux in x (unghosted)
  real   fy(im,jfirst:jlast)     ! Flux in y (unghosted since iv==0)

! !DESCRIPTION:
!     In this routine the number 
!     of north ghosted latitude min(abs(jord),2), and south ghosted
!     latitudes is XXXX
!
! !CALLED FROM:
!     cd_core
!
! !REVISION HISTORY:
!   SJL 99.04.13:  Delivery
!   WS  99.04.13:  Added jfirst:jlast concept
!   WS  99.05.10:  Replaced JNP with JM, JMR with JM-1, IMR with IM
!   WS  99.05.10:  Removed fvcore.h and JNP, IMH, IML definitions
!   WS  99.10.20:  Pruned arrays
!   WS  00.05.14:  Renamed ghost indices as per Kevin's definitions
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:

  real   adx(im,jfirst-1:jlast+2)
  integer north, south
  integer i, j, jp, im2, js2g0, js2gs, jn2g0, jn1g0, jn1gn
  real   wk1(im)
  real   fx1(im)

    im2 = im/2
    north = min(2,abs(jord))         ! north == 1 or 2
    south = north-1                  ! south == 0 or 1
    js2g0 = max(2,jfirst)
    js2gs = max(2,jfirst-south)
    jn2g0 = min(jm-1,jlast)
    jn1gn = min(jm,jlast+north)
    jn1g0 = min(jm,jlast)

! This loop must be ghosted N*NG, S*NG

!!!      do j=2,jm
      do j=js2gs,jn1gn
        call xtp( im, ffsl(j), wk1, q(1,j),           &
                  crx(1,j), 1, crx(1,j), cose(j), 0,  &
                  dm, qtmp, al, ar, a6 )

        do i=1,im-1
          adx(i,j) = q(i,j) + 0.5 *                   &
                     (wk1(i)-wk1(i+1) + q(i,j)*(crx(i+1,j)-crx(i,j)))
        enddo

        adx(im,j) = q(im,j) + 0.5 *                   &
                    (wk1(im)-wk1(1) + q(im,j)*(crx(1,j)-crx(im,j)))
      enddo

      call ycc(im, jm, fy, adx, cry, ymass, jord, 0,jfirst,jlast)

! For Scalar only!!!
      if ( jfirst-2 <= 1 ) then
        do i=1,im2
          q(i,1) = q(i+im2,  2)
        enddo
        do i=im2+1,im
           q(i,1) = q(i-im2,  2)
        enddo
      endif

      if ( jlast+2 == jm ) then
        do i=1,im2
          fx1(i) = q(i+im2,jm)
        enddo
        do i=im2+1,im
           fx1(i) = q(i-im2,jm)
        enddo

        do i=1,im
          if(va(i,jm) .gt. 0.) then
            adx(i,jm) = q(i,jm) + 0.5*va(i,jm)*(q(i,jm-1)-q(i,jm))
          else
            adx(i,jm) = q(i,jm) + 0.5*va(i,jm)*(q(i,jm)-fx1(i))
          endif
        enddo
      endif

      do j=js2g0,jn2g0
        do i=1,im
          jp = j-va(i,j)
! jp = j     if va < 0
! jp = j -1  if va < 0
! q needed max(1, jfirst-1)
          adx(i,j) = q(i,j) + 0.5*va(i,j)*(q(i,jp)-q(i,jp+1))
        enddo
      enddo

      do j=js2g0,jn1g0
        call xtp( im, ffsl(j), fx(1,j), adx(1,j),                 &
                  crx(1,j), iord, crx(1,j), cose(j), 0,           &
                  dm, qtmp, al, ar, a6 )
      enddo
!EOC
 end subroutine tpcc
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
! !IROUTINE: ycc
!
! !INTERFACE: 
 subroutine ycc(im, jm, fy, q, vc, ymass, jord, iv, jfirst, jlast)
!-----------------------------------------------------------------------

! !USES:

! !INPUT PARAMETERS:
 integer im, jm                      !  Dimensions
 integer jfirst, jlast               !  Latitude strip
 integer jord                        !  Approximation order
 integer iv                          !  Scalar=0, Vector=1
 real   q(im,jfirst-1-iv:jlast+2)      !  Field (N*2 S*(iv+1))
 real   vc(im,jfirst-iv:jlast)         !  Courant  (like FY)
 real   ymass(im,jfirst-iv:jlast)      !  background mass flux

! !OUTPUT PARAMETERS:
 real   fy(im,jfirst-iv:jlast)         !  Flux (S if iv=1)

! !DESCRIPTION:
!     Will Sawyer's note: In this routine the number 
!     of ghosted latitudes NG is min(abs(jord),2).  The scalar/vector
!     flag determines whether the flux FY needs to be ghosted on the
!     south.  If called from CD\_CORE (iv==1) then it does, if called
!     from TPCC (iv==0) it does not.  
!
! !CALLED FROM:
!     cd_core
!     tpcc
!
! !REVISION HISTORY:
!
!   SJL 99.04.13:  Delivery
!   WS  99.04.19:  Added jfirst:jlast concept
!   WS  99.04.27:  DC removed as argument (local to this routine); DC on N
!   WS  99.05.10:  Replaced JNP with JM, JMR with JM-1, IMR with IM
!   WS  99.05.10:  Removed fvcore.h
!   WS  99.07.27:  Built in tests for SP or NP
!   WS  99.09.09:  Documentation; indentation; cleaning; pole treatment
!   WS  99.09.14:  Loop limits
!   WS  00.05.14:  Renamed ghost indices as per Kevin's definitions
!
!EOP
!---------------------------------------------------------------------
!BOC

! !LOCAL VARIABLES:
  real   dc(im,jfirst-iv:jlast+1)
  real   qmax, qmin
  integer i, j, jt, im2, js2giv, js3giv, jn2g1, jn2g0

   im2 = im/2

   js2giv = max(2,jfirst-iv)
   js3giv = max(3,jfirst-iv)
   jn2g1  = min(jm-1,jlast+1)
   jn2g0  = min(jm-1,jlast)
      
   if(jord == 1) then
!!!        do j=2,jm-1
        do j=js2giv,jn2g0                      ! FY needed on S*iv
          do i=1,im
! jt=j if vc > 0; jt=j+1 if vc <=0
            jt = float(j+1)  - vc(i,j)         ! VC ghosted like fy
            fy(i,j) = q(i,jt)*ymass(i,j)       ! ymass ghosted like fy
          enddo                                ! q ghosted N*1, S*iv
        enddo

   else

!!!        do j=3,jm-1
        do j=js3giv,jn2g1                      ! dc needed N*1, S*iv
          do i=1,im
            dc(i,j) = 0.25*(q(i,j+1)-q(i,j-1)) ! q ghosted N*2, S*(iv+1)
          enddo
        enddo

        if(iv.eq.0) then
! Scalar.

! WS 99.07.27 : Split loops in SP and NP regions, added SP/NP tests

          if ( jfirst-iv <= 2 ) then
            do i=1,im2
              dc(i, 2) = 0.25 * ( q(i,3) - q(i+im2,2) )
            enddo

            do i=im2+1,im
              dc(i, 2) = 0.25 * ( q(i,3) - q(i-im2,2) )
            enddo
          endif

          if ( jlast == jm ) then
            do i=1,im2
              dc(i,jm) = 0.25 * ( q(i+im2,jm) - q(i,jm-1) )
            enddo

            do i=im2+1,im
              dc(i,jm) = 0.25 * ( q(i-im2,jm) - q(i,jm-1) )
            enddo
          endif

        else
! Vector winds

! WS 99.07.27 : Split loops in SP and NP regions, added SP/NP tests

          if ( jfirst-iv <= 2 ) then
            do i=1,im2
              dc(i, 2) =  0.25 * ( q(i,3) + q(i+im2,2) )
            enddo

            do i=im2+1,im
              dc(i, 2) =  0.25 * ( q(i,3) + q(i-im2,2) )
            enddo
          endif

          if ( jlast == jm ) then
            do i=1,im2
              dc(i,jm) = -0.25 * ( q(i,jm-1) + q(i+im2,jm) )
            enddo

            do i=im2+1,im
              dc(i,jm) = -0.25 * ( q(i,jm-1) + q(i-im2,jm) )
            enddo
          endif

        endif

        if( jord > 0 ) then
! Monotonic constraint
!!!          do j=3,jm-1
          do j=js3giv,jn2g1            ! DC needed N*1, S*iv
            do i=1,im                  ! P ghosted N*2, S*(iv+1)
              qmax = max(q(i,j-1),q(i,j),q(i,j+1)) - q(i,j)
              qmin = q(i,j) - min(q(i,j-1),q(i,j),q(i,j+1))
              dc(i,j) = sign(min(abs(dc(i,j)),qmin,qmax),dc(i,j))
            enddo
          enddo
!
! WS 99.08.03 : Following loop split into SP and NP part
!
          if ( jfirst-iv <= 2 ) then
            do i=1,im
              dc(i, 2) = 0.
            enddo
          endif
          if ( jlast == jm ) then
            do i=1,im
              dc(i,jm) = 0.
            enddo
          endif
        endif

!!!        do j=2,jm-1
       do j=js2giv,jn2g0                   ! fy needed S*iv
         do i=1,im                       
           jt = float(j+1)  - vc(i,j)      ! vc, ymass ghosted like fy
           fy(i,j) = (q(i,jt)+(sign(1.,vc(i,j))-vc(i,j))*dc(i,jt))*ymass(i,j)
         enddo
       enddo
    endif
!EOC
 end subroutine ycc
!-----------------------------------------------------------------------




#ifdef USE_LIMA

!-----------------------------------------------------------------------
!BOP
! !IROUTINE: tp2d --- Perform transport on a D grid
!
! !INTERFACE: 
 subroutine tp2d_lima(va, q, crx, cry, im, jm, iord, jord, ng, fx, fy,        &
                 ffsl, xfx, yfx, cosp, id, jfirst, jlast)
!-----------------------------------------------------------------------
! !USES:

! !INPUT PARAMETERS:
   integer im, jm                    ! Dimensions
   integer jfirst, jlast             ! Latitude strip
   integer iord, jord                ! Interpolation order in x,y
   integer ng                        ! Max. NS dependencies
   integer id                        ! density (0)  (mfx = C)
                                     ! mixing ratio (1) (mfx = mass flux)
   logical ffsl(jm)                  ! Use flux-form semi-Lagrangian trans.?
                                     ! ghosted N*ng S*ng
   real (r8) cosp(jm)                     ! Critical angle
   real (r8) va(im,jfirst:jlast)          ! Courant  (unghosted)
   real (r8) q(im,jfirst-ng:jlast+ng)     ! transported scalar ( N*NG S*NG )
   real (r8) crx(im,jfirst-ng:jlast+ng)   ! Ask S.-J. ( N*NG S*NG )
   real (r8) cry(im,jfirst:jlast+1)       ! Ask S.-J. ( N like FY )
   real (r8) xfx(im,jfirst:jlast)         ! Ask S.-J. ( unghosted like FX )
   real (r8) yfx(im,jfirst:jlast+1)       ! Ask S.-J. ( N like FY )

! !OUTPUT PARAMETERS:
   real (r8) fx(im,jfirst:jlast)          ! Flux in x ( unghosted )
   real (r8) fy(im,jfirst:jlast+1)        ! Flux in y ( N, see tp2c )

! !DESCRIPTION:
!     Perform transport on a D grid.   The number of ghost
!     latitudes (NG) depends on what method (JORD) will be used
!     subsequentally.    NG is equal to MIN(ABS(JORD),3).
!
!
! !REVISION HISTORY:
!   WS  99.04.13:  Added jfirst:jlast concept
!       99.04.21:  Removed j1 and j2 (j1=2, j2=jm-1 consistently)
!       99.04.27:  Removed dc, wk2 as arguments (local to YTP)
!       99.04.27:  Removed adx as arguments (local here)
!   SJL 99.07.26:  ffsl flag added
!   WS  99.09.07:  Restructuring, cleaning, documentation
!   WS  99.10.22:  NG now argument; arrays pruned
!   WS  00.05.14:  Renamed ghost indices as per Kevin's definitions
!
!EOP
!---------------------------------------------------------------------
!BOC

! Local:
   integer i, j, iad, jp, js2g0, js2gng, jn2g0, jn2gng
   real (r8) adx(im,jfirst-ng:jlast+ng)
   real (r8) wk1(im)
   real (r8)   dm(-im/3:im+im/3)
   real (r8) qtmp(-im/3:im+im/3)
   real (r8)   al(-im/3:im+im/3)
   real (r8)   ar(-im/3:im+im/3)
   real (r8)   a6(-im/3:im+im/3)

! Number of ghost latitudes
    js2g0  = max(2,jfirst)          !  No ghosting
    js2gng = max(2,jfirst-ng)       !  Number needed on S
    jn2g0  = min(jm-1,jlast)        !  No ghosting
    jn2gng = min(jm-1,jlast+ng)     !  Number needed on N
    iad = 1

!!!      do j=2,jm-1
    do j=js2gng,jn2gng               !  adx needed on N*ng S*ng

       call xtp(im,  ffsl(j), wk1, q(1,j),                &
                crx(1,j), iad, crx(1,j), cosp(j), 0,      &
                dm, qtmp, al, ar, a6)

       do i=1,im-1
          adx(i,j) = q(i,j) + 0.5 *                       &
                     (wk1(i)-wk1(i+1) + q(i,j)*(crx(i+1,j)-crx(i,j)))
       enddo
          adx(im,j) = q(im,j) + 0.5 *                     &
                      (wk1(im)-wk1(1) + q(im,j)*(crx(1,j)-crx(im,j)))
    enddo

! WS 99.09.07 : Split up north and south pole

     if ( jfirst-ng <= 1 ) then
        do i=1,im 
          adx(i, 1) = q(i,1)
        enddo
     endif 
     if ( jlast+ng >= jm ) then
        do i=1,im 
          adx(i,jm) = q(i,jm)
        enddo
     endif

     call ytp(im,jm,fy, adx,cry,yfx,ng,jord,0,jfirst,jlast)

!!!   do j=2,jm-1
      do j=js2g0,jn2g0
        do i=1,im
           jp = j-va(i,j)
           wk1(i) = q(i,j) +0.5*va(i,j)*(q(i,jp)-q(i,jp+1))
        enddo

        call xtp(im,  ffsl(j), fx(1,j), wk1,                  &
                 crx(1,j), iord, xfx(1,j), cosp(j), id,       &
                 dm, qtmp, al, ar, a6)
      enddo
!EOC
 end subroutine tp2d_lima
!-----------------------------------------------------------------------
#endif

end module tp_core

  MODULE RAS_MOD

!=======================================================================
!  RELAXED ARAKAWA/SCHUBERT (RAS) CUMULUS PARAM SCHEME MODULE          !
!=======================================================================
!  SUBROUTINE RAS_INIT        - INITIALIZE RAS
!  SUBROUTINE RAS             - DRIVER
!  SUBROUTINE RAS_CLOUD       - RAS CU PARAMETERIZATION
!  SUBROUTINE COMP_LCL        - COMPUTE LCL (CLOUD BASE)
!  SUBROUTINE RAS_CEVAP       - EVAPORATION OF CONVECTIVE SCALE PRECIP
!  SUBROUTINE RAS_CLOUD_INDEX - SET ORDER IN WHICH CLOUDS ARE TO BE DONE 
!  SUBROUTINE RAS_CLOUD_EXIST - TEST FOR INSTABILITY IN COLUMN
!  SUBROUTINE RAS_BDGT        - BUDGET CHECK FOR RAS
!  FUNCTION   RAN0            - RANDOM NUMBER GENERATOR
!=======================================================================

 use            mpp_mod, only: mpp_pe,             &
                               mpp_root_pe,        &
                               stdlog
 use Sat_Vapor_Pres_Mod, ONLY: compute_qs
 use      Constants_Mod, ONLY:  HLv, HLs, Cp_Air, Grav, Kappa, rdgas, rvgas
 use   Diag_Manager_Mod, ONLY: register_diag_field, send_data
 use   Time_Manager_Mod, ONLY: time_type
 use            mpp_mod, only: input_nml_file
 use            fms_mod, only: write_version_number, open_namelist_file, &
                               FILE_EXIST, ERROR_MESG, check_nml_error, &
                               CLOSE_FILE, FATAL
 use  field_manager_mod, only: MODEL_ATMOS
 use tracer_manager_mod, only: get_tracer_index,   &
                               get_number_tracers, &
                               get_tracer_names,   &
                               get_tracer_indices, &
                               query_method,       &
                               NO_TRACER
 use  rad_utilities_mod,  only : aerosol_type
 use  aer_ccn_act_mod,    only : aer_ccn_act, aer_ccn_act2
!---------------------------------------------------------------------
 implicit none
 private
 public  :: ras, ras_init, ras_end, ras_bdgt
!---------------------------------------------------------------------

!      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 character(len=128) :: version = '$Id: ras.F90,v 19.0 2012/01/06 20:11:58 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'
!      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 real :: cp_div_grav
 real :: one_plus_kappa, one_minus_kappa
 real :: onebcp, onebg
 real :: rn_pfac

 logical :: module_is_initialized = .false.

 real, parameter :: d622        = rdgas/rvgas
 real, parameter :: d378        = 1.0-d622
 
!---------------------------------------------------------------------
! --- Climatological cloud work function data
!---------------------------------------------------------------------
 
 real                :: actop 
 real, dimension(15) :: ac, ad
 real, dimension(15) :: ph, a

 data ph / 150.0, 200.0, 250.0, 300.0, 350.0, 400.0, 450.0, 500.0,   &
           550.0, 600.0, 650.0, 700.0, 750.0, 800.0, 850.0 /

 data a / 1.6851, 1.1686, 0.7663, 0.5255, 0.4100, 0.3677,            &
          0.3151, 0.2216, 0.1521, 0.1082, 0.0750, 0.0664,            &
          0.0553, 0.0445, 0.0633  /

!---------------------------------------------------------------------
! --- NAMELIST
!---------------------------------------------------------------------
!       fracs  - Fraction of PBL mass allowed to be used 
!                by a cloud-type in time DT
!       rasal0 - Base value for cloud type relaxation parameter
!       puplim - Upper limit for cloud tops of deepest clouds
!       aratio - Ratio of critical cloud work function to standard
!                value of cloud work function
!       cufric - Should Cumulus friction (momentum transport) occur?
!      rh_trig - Convection takes place only if the relative humidity
!                of the lowest model level exceeds rh_trig
!      alm_min - Min value for entrainment parameter.
!   Tokioka_on - If true, alm_min computed using Tokioka formulation
!  Tokioka_con - Constant for alm_min computed using Tokioka formulation
! Tokioka_plim - Tokioka applied only to clouds detraining above Tokioka_plim
!   modify_pbl - If true, mass flux in sub cloud layer varies linearly   
!                between value at cloud base and zero at surface, and   
!                tendencies are spread out throughout the entire sub cloud layer.
! prevent_unreasonable - If true, unreasonable states (negatives) for the water 
!                        tracers are prevented. This is achieved by borrowing 
!                        from the sources of tracer within this module. 
!                        Otherwise the tendency is added without correction and
!                        can lead to negative mixing ratios. (Default = .FALSE.)
! --- CLOUD ORDER SPECIFICATION ---
!     ncrnd  - Number of random cloud-types between krmin and krmax to be
!              invoked in a single call to ras
!     iseed  - Integer seed used in generating random numbers
!              -- used only when ncrnd > 0
!     krmin  - Index of the top most level to which random clouds may
!              be invoked
!     krmax  - Index of the bottom most level to which random clouds 
!              may be invoked. krmin should be <= krmax. 
!              If ncrnd is specified as zero, then all cloud-types 
!              below the level krmax will be called sequentially.
!     botop  - A logical variable -- .true. if sequential clouds are 
!              called from bottom to top and .false. if top to bottom.
!              Level krmax will be called sequentially.
! --- PARTION CLOUD LIQUID WATER INTO PRECIP & DETRAINED VAPOR AND LIQUID --- 
!     rn_ptop - rn_frac_top of parcel liquid water converted to precip 
!               for cloud top pressures above rn_ptop
!     rn_pbot - rn_frac_bot of parcel liquid water converted to precip 
!               for cloud top pressures below rn_pbot (linear profile in 
!               between)
!     rn_frac_bot - Fraction of parcel liquid water converted to 
!                   precip for cloud top pressures below rn_pbot
!     rn_frac_top - Fraction of liquid water converted to
!                   precip for cloud top pressures above rn_ptop
! --- EVAPORATION OF CONVECTIVE SCALE PRECIP ---
!     evap_on - Turn on evaporation if true
!     cfrac   - Fraction of grid box assumed to be covered by convection
!     hcevap  - Evap allowed while q <= hcevap * qsat
! --- CRITICAL CLOUD WORK FUNCTION ---
!     ph - array, dim(15), of cloud top pressures
!      a - array, dim(15), of critical cloud work functions 
!          for clouds detraining at level ph
!---------------------------------------------------------------------

 logical :: use_online_aerosol = .false.
 real    :: fracs        = 0.25
 real    :: rasal0       = 0.25
 real    :: puplim       = 20.0E2
 real    :: aratio       = 1.4
 logical :: cufric       = .false.
 real    :: rh_trig      = 0.0      
 real    :: alm_min      = 0.0  
 logical :: Tokioka_on   = .false.
 real    :: Tokioka_con  = 0.05 
 real    :: Tokioka_plim = 500.0E2
 logical :: modify_pbl   = .false.
 logical :: prevent_unreasonable   = .false.
 
! --- cloud order specification ---
 integer :: ncrnd = 0
 integer :: iseed = 123
 integer :: krmin = 2
 integer :: krmax = 2
 logical :: botop = .true.

! --- partion cloud liquid water into precip & detrained water --- 
 real :: rn_ptop = 500.0E2
 real :: rn_pbot = 800.0E2
 real :: rn_frac_bot = 0.8
 real :: rn_frac_top = 1.0

! --- evaporation of convective scale precip ---
 logical :: evap_on = .true.   
 real    :: cfrac   = 0.05
 real    :: hcevap  = 0.80    

 real    :: sea_salt_scale = 0.1
 real    :: om_to_oc = 1.67

 integer :: nqn   ! tracer indices for stratiform clouds

    NAMELIST / ras_nml /                          &
      fracs,   rasal0,  puplim, aratio, cufric,   &
      ncrnd,   iseed,   krmin,   krmax, botop,    &
      rn_ptop, rn_pbot, rn_frac_top, rn_frac_bot, &
      evap_on, cfrac,   hcevap, rh_trig, alm_min, &
      Tokioka_on, Tokioka_con, Tokioka_plim, modify_pbl, prevent_unreasonable, &
      ph, a, sea_salt_scale, om_to_oc, use_online_aerosol

!---------------------------------------------------------------------
! DIAGNOSTICS FIELDS 
!---------------------------------------------------------------------

integer :: id_tdt_revap,  id_qdt_revap,    id_prec_revap,  &
           id_snow_revap, id_prec_conv_3d, id_pcldb, &
           id_det0, &
           id_tdt_conv, id_qdt_conv, id_prec_conv, id_snow_conv, &
           id_q_conv_col, id_t_conv_col, id_mc,&
           id_qldt_conv, id_qidt_conv, id_qadt_conv, id_qndt_conv, &
           id_ql_conv_col, id_qi_conv_col, id_qa_conv_col,         &
           id_mfcb, id_mfct, id_alm, id_cfq_ras
integer, allocatable, dimension(:) :: id_tracer_conv, id_tracer_conv_col

character(len=3) :: mod_name = 'ras'

real :: missing_value = -999.

integer  :: num_ras_tracers = 0
logical  :: do_ras_tracer = .false.

!---------------------------------------------------------------------

 contains

!#####################################################################
!#####################################################################

  SUBROUTINE RAS_INIT( do_strat, do_liq_num, axes, Time, tracers_in_ras )

!=======================================================================
! ***** INITIALIZE RAS
!=======================================================================
!---------------------------------------------------------------------
! Arguments (Intent in)
!---------------------------------------------------------------------

 logical,         intent(in) :: do_strat, do_liq_num
 integer,         intent(in) :: axes(4)
 type(time_type), intent(in) :: Time
 logical, dimension(:), intent(in), optional :: tracers_in_ras

!---------------------------------------------------------------------
!  (Intent local)
!---------------------------------------------------------------------

 integer             :: unit, io, ierr
 real                :: actp, facm 
 real, dimension(15) :: au,   tem
 integer, dimension(3) :: half = (/1,2,4/)
 character(len=128)    :: diagname, diaglname, tendunits, name, units
 integer               :: tr
 integer               :: num_tracers
 integer               :: nn, logunit
!=====================================================================

!---------------------------------------------------------------------
! --- Read namelist
!---------------------------------------------------------------------

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ras_nml, iostat=io)
  ierr = check_nml_error(io,"ras_nml")
#else
  if( FILE_EXIST( 'input.nml' ) ) then
      unit = OPEN_NAMELIST_FILE ()
      ierr = 1 ; do while ( ierr .ne. 0 )
        READ( unit, nml = ras_nml, iostat = io, end = 10 )
        ierr = check_nml_error (io, 'ras_nml')
      end do
10  CALL CLOSE_FILE ( unit )
  end if
#endif

!---------------------------------------------------------------------
! --- Write namelist
!---------------------------------------------------------------------

  call write_version_number(version, tagname)
       logunit = stdlog()
       WRITE( logunit, nml = ras_nml ) 


!---------------------------------------------------------------------
! --- Find the tracer indices 
!---------------------------------------------------------------------
  call get_number_tracers(MODEL_ATMOS,num_prog=num_tracers)

  nqn = get_tracer_index ( MODEL_ATMOS, 'liq_drp' )
  if (do_liq_num .and. nqn == NO_TRACER) &
    call error_mesg ('ras_init', &
         'prognostic droplet number scheme requested but tracer not found', FATAL) 


!---------------------------------------------------------------------
! --- Initialize constants
!---------------------------------------------------------------------

  
  cp_div_grav = Cp_Air / Grav

  one_plus_kappa  = 1.0 + Kappa
  one_minus_kappa = 1.0 - Kappa

  onebcp = 1.0 / Cp_Air
  onebg  = 1.0 / Grav
  
  rn_pfac = ( rn_frac_top -  rn_frac_bot)  / ( rn_pbot - rn_ptop ) 
  
! --- Climatological cloud work function

 actp  = 1.7
 facm  = 0.01                               
 actop = actp * facm

  a  = facm * a
  ph = 100.0*ph
   
  ac = 0.0     
  ad = 0.0     
  au = 0.0     
 tem = 0.0     

 tem(2:15) = ph(2:15) -  ph(1:14)
  au(2:15) =  a(1:14) / tem(2:15) 
  ad(2:15) =  a(2:15) / tem(2:15)

  ac(2:15) = ph(2:15) * au(2:15) - ph(1:14) * ad(2:15)
  ad(2:15) = ad(2:15) - au(2:15)

!---------------------------------------------------------------------
! --- initialize quantities for diagnostics output
!---------------------------------------------------------------------

   id_tdt_revap = register_diag_field ( mod_name, &
     'tdt_revap', axes(1:3), Time, &
     'Temperature tendency from RAS prec evap',      'deg_K/s',  &
                        missing_value=missing_value               )

   id_qdt_revap = register_diag_field ( mod_name, &
     'qdt_revap', axes(1:3), Time, &
     'Spec humidity tendency from RAS prec evap',    'kg/kg/s',  &
                        missing_value=missing_value               )

   id_prec_revap = register_diag_field ( mod_name, &
     'prec_revap', axes(1:2), Time, &
     'Evap Precip rate from RAS',                   'kg/m2/s' )

   id_snow_revap = register_diag_field ( mod_name, &
     'snow_revap', axes(1:2), Time, &
     'Evap Frozen precip rate from RAS',             'kg/m2/s' )

   id_prec_conv_3d = register_diag_field ( mod_name, &
     'prec_conv_3d', axes(1:3), Time, &
     '3D Precipitation rate from RAS',      'kg/m2/s',  &
                        missing_value=missing_value               )

   id_pcldb = register_diag_field ( mod_name, &
     'pcldb', axes(1:2), Time, &
     'Pressure at cloud base from RAS',              'hPa' )

!---------------------------------------------------------------------

   id_tdt_conv = register_diag_field ( mod_name, &
     'tdt_conv', axes(1:3), Time, &
     'Temperature tendency from RAS',                'deg_K/s',  &
                        missing_value=missing_value               )

   id_qdt_conv = register_diag_field ( mod_name, &
     'qdt_conv', axes(1:3), Time, &
     'Spec humidity tendency from RAS',              'kg/kg/s',  &
                        missing_value=missing_value               )

   id_prec_conv = register_diag_field ( mod_name, &
     'prec_conv', axes(1:2), Time, &
    'Precipitation rate from RAS',                  'kg/m2/s' )

   id_snow_conv = register_diag_field ( mod_name, &
     'snow_conv', axes(1:2), Time, &
    'Frozen precip rate from RAS',                  'kg/m2/s' )

   id_q_conv_col = register_diag_field ( mod_name, &
     'q_conv_col', axes(1:2), Time, &
    'Water vapor path tendency from RAS',           'kg/m2/s' )
   
   id_t_conv_col = register_diag_field ( mod_name, &
     't_conv_col', axes(1:2), Time, &
    'Column static energy tendency from RAS',       'W/m2' )


   id_mc = register_diag_field ( mod_name, &
     'mc', axes(half), Time, &
         'Cumulus Mass Flux from RAS',                   'kg/m2/s', &
                        missing_value=missing_value               )

   id_mfcb = register_diag_field ( mod_name, &
     'mfcb', axes(1:3), Time, &
       'Cumulus cloud-base mass flux from RAS', 'kg/m2/s', &
                        missing_value=missing_value) 

   id_mfct = register_diag_field ( mod_name, &
     'mfct', axes(1:3), Time, &
     'Cumulus cloud-top mass flux from RAS', 'kg/m2/s', &
                       missing_value=missing_value) 
       
   id_alm  = register_diag_field ( mod_name, &
     'alm', axes(1:3), Time, &
     'Cumulus entrainment rate from RAS', '1/m', &
                       missing_value=missing_value) 

   id_cfq_ras = register_diag_field ( mod_name,&
     'cfq_ras', axes(1:3), Time, &
     'Cumulus frequency from RAS', 'none', &
                       missing_value=missing_value) 

   id_qndt_conv = register_diag_field ( mod_name, &
     'qndt_conv', axes(1:3), Time, &
     'Cloud droplet tendency from RAS',              '#/kg/s',  &
                        missing_value=missing_value               )

   id_qldt_conv = register_diag_field ( mod_name, &
     'qldt_conv', axes(1:3), Time, &
     'Liquid water tendency from RAS',              'kg/kg/s',  &
                        missing_value=missing_value               )

   id_qidt_conv = register_diag_field ( mod_name, &
     'qidt_conv', axes(1:3), Time, &
     'Ice water tendency from RAS',                 'kg/kg/s',  &
                        missing_value=missing_value               )

   id_qadt_conv = register_diag_field ( mod_name, &
     'qadt_conv', axes(1:3), Time, &
     'Cloud fraction tendency from RAS',            '1/sec',    &
                        missing_value=missing_value               )

   id_ql_conv_col = register_diag_field ( mod_name, &
     'ql_conv_col', axes(1:2), Time, &
    'Liquid water path tendency from RAS',          'kg/m2/s' )
   
   id_qi_conv_col = register_diag_field ( mod_name, &
     'qi_conv_col', axes(1:2), Time, &
    'Ice water path tendency from RAS',             'kg/m2/s' )
   
   id_qa_conv_col = register_diag_field ( mod_name, &
     'qa_conv_col', axes(1:2), Time, &
    'Cloud mass tendency from RAS',                 'kg/m2/s' )
      
   id_det0        = register_diag_field ( mod_name, &
     'ras_det0', axes(1:3), Time, &
    'Detrained mass flux from RAS',                 'kg/m2/s' )
      
!----------------------------------------------------------------------
!    determine how many tracers are to be transported by ras_mod.
!----------------------------------------------------------------------
      if (present(tracers_in_ras)) then
        num_ras_tracers = count(tracers_in_ras)
      else
        num_ras_tracers = 0
      endif
      if (num_ras_tracers > 0) then
        do_ras_tracer = .true.
      else
        do_ras_tracer = .false.
      endif

!---------------------------------------------------------------------
!    allocate the arrays to hold the diagnostics for the ras tracers.
!---------------------------------------------------------------------
     allocate(id_tracer_conv    (num_ras_tracers)) ; id_tracer_conv = 0
     allocate(id_tracer_conv_col(num_ras_tracers)) ; id_tracer_conv_col = 0
     nn = 1
    do tr = 1,num_tracers
      if (tracers_in_ras(tr)) then
        call get_tracer_names(MODEL_ATMOS, tr, name=name, units=units)
 
!----------------------------------------------------------------------
!    for the column tendencies, the name for the diagnostic will be 
!    the name of the tracer followed by 'dt_RAS'. the longname will be 
!    the name of the tracer followed by ' tendency from RAS'. units are
!    the supplied units of the tracer divided by seconds.
!----------------------------------------------------------------------
        diagname = trim(name)//'dt_RAS'
        diaglname = trim(name)//' tendency from RAS'
        tendunits = trim(units)//'/s'
        id_tracer_conv(nn) = register_diag_field ( mod_name, &
                             trim(diagname), axes(1:3), Time, &
                             trim(diaglname), trim(tendunits),  &
                             missing_value=missing_value               )

!----------------------------------------------------------------------
!    for the column integral  tendencies, the name for the diagnostic 
!    will be the name of the tracer followed by 'dt_RAS_col'. the long-
!    name will be the name of the tracer followed by ' path tendency 
!    from RAS'. units are the supplied units of the tracer multiplied
!    by m**2 /kg divided by seconds.
!----------------------------------------------------------------------
      diagname = trim(name)//'dt_RAS_col'
      diaglname = trim(name)//' path tendency from RAS'
      tendunits = trim(units)//'m2/kg/s'
      id_tracer_conv_col(nn) = register_diag_field ( mod_name, &
                               trim(diagname), axes(1:2), Time, &
                               trim(diaglname), trim(tendunits),  &
                               missing_value=missing_value)
       nn = nn + 1
      endif
     end do

  module_is_initialized = .true.

!=====================================================================
  end SUBROUTINE RAS_INIT


!#####################################################################
subroutine ras_end

integer :: log_unit

log_unit = stdlog()
if ( mpp_pe() == mpp_root_pe() ) then
   write (log_unit,'(/,(a))') 'Exiting RAS.'
endif

module_is_initialized = .FALSE.


end subroutine ras_end

!#####################################################################

  SUBROUTINE RAS( is,     js,      Time,      temp0,   qvap0,     &
          uwnd0,  vwnd0,  pres0,   pres0_int, zhalf0,  coldT0,    &
                  dtime,  dtemp0,  dqvap0,    duwnd0,  dvwnd0,    &
                  rain3d, snow3d,                                 &
                  rain0,  snow0,   ras_tracers, qtrras,           &
                  mask,    kbot,  mc0, det0,                      & ! optional
                  ql0, qi0, qa0,                                  & ! optional
                  dl0, di0, da0,                                  & ! optional
                  qn0, dn0, do_strat, Aerosol)                      ! optional

!=======================================================================
! ***** DRIVER FOR RAS
!=======================================================================
!---------------------------------------------------------------------
! Arguments (Intent in)
!     is, js    - Starting indices for window
!     Time      - Time used for diagnostics [time_type]
!     dtime     - Size of time step in seconds
!     pres0     - Pressure
!     pres0_int - Pressure at layer interface
!     zhalf0    - Height at layer interface
!     temp0     - Temperature
!     qvap0     - Water vapor 
!     uwnd0     - U component of wind
!     vwnd0     - V component of wind
!     coldT0    - should the precipitation assume to be frozen?
!     kbot      - OPTIONAL;lowest model level index (integer)
!     mask      - OPTIONAL;used only for diagnostic output
!     ras_tracers- prognostic tracers to move around
!                 note that R0 is assumed to be dimensioned
!                 (nx,ny,nz,nt), where nt is the number of tracers
!---------------------------------------------------------------------
! Arguments (Intent inout)
!     ql0       - OPTIONAL;cloud liquid
!     qi0       - OPTIONAL;cloud ice
!     qa0       - OPTIONAL;cloud/saturated volume fraction
!---------------------------------------------------------------------
  type(time_type), intent(in)                   :: Time
  integer,         intent(in)                   :: is, js
  real,            intent(in)                   :: dtime
  real,            intent(in), dimension(:,:,:) :: pres0, pres0_int, zhalf0
  real,            intent(inout), dimension(:,:,:) :: temp0, qvap0, uwnd0, vwnd0
  logical,         intent(in), dimension(:,:)   :: coldT0
  logical,         intent(in), optional         :: do_strat
  type(aerosol_type), intent (in), optional     :: Aerosol  
  real, intent(in) , dimension(:,:,:), OPTIONAL :: mask
  integer, intent(in), OPTIONAL, dimension(:,:) :: kbot
  real,  intent(inout), OPTIONAL,dimension(:,:,:)   :: ql0, qi0, qa0, qn0
  real,  intent(in), dimension(:,:,:,:)          :: ras_tracers
!---------------------------------------------------------------------
! Arguments (Intent out)
!       rain0  - surface rain
!       snow0  - surface snow
!       rain3d - 3D rain
!       snow3d - 3D snow
!       dtemp0 - Temperature change 
!       dqvap0 - Water vapor change 
!       duwnd0 - U wind      change 
!       dvwnd0 - V wind      change 
!       mc0    - OPTIONAL; cumulus mass flux
!       Dl0    - OPTIONAL; cloud liquid tendency
!       Di0    - OPTIONAL; cloud ice tendency
!       Da0    - OPTIONAL; cloud fraction tendency
!       qtrras - prognostic tracers tendency
!---------------------------------------------------------------------
  real, intent(out), dimension(:,:,:)           :: dtemp0, dqvap0, duwnd0, dvwnd0
  real, intent(out), dimension(:,:)             :: rain0,  snow0
  real, intent(out), dimension(:,:,:,:)         :: qtrras
  real, intent(out), dimension(:,:,:)           :: rain3d,snow3d
  
  real, intent(out), OPTIONAL, dimension(:,:,:) :: mc0
  real, intent(out), OPTIONAL, dimension(:,:,:) :: det0
  real, intent(out), OPTIONAL, dimension(:,:,:) :: dl0, di0, da0, dn0

!---------------------------------------------------------------------
!  (Intent local)
!---------------------------------------------------------------------

! precipitation flux and evaporation profiles [kg/m2/sec]
 real, dimension(SIZE(temp0,3)) :: flxprec,flxprec_evap       ! sum of all clouds
 real, dimension(SIZE(temp0,3)) :: flxprec_ib,flxprec_ib_evap ! for each cloud

 real, parameter :: p00 = 1000.0E2

 logical :: coldT,  exist    
 real    :: precip, Hl, psfc, dpcu, dtinv
 integer :: ksfc,   klcl, kk

 integer, dimension(SIZE(temp0,3)) :: ic

 real, dimension(SIZE(temp0,3)) :: &
       temp, qvap, uwnd, vwnd, pres, dtemp, dqvap, duwnd, dvwnd, &    
       ql,   qi,   qa,   qn ,  Dl,   Di,    Da,    Dn,    mass,  pi,    theta, &
       cp_by_dp,   dqvap_sat,  qvap_sat,    alpha, beta,  gamma, &
       dtcu, dqcu, ducu, dvcu, Dlcu, Dicu,  Dacu,  Dncu

 real, dimension(SIZE(temp0      ,3),num_ras_tracers) :: tracer, dtracer, dtracercu
 real, dimension(SIZE(temp0,3)+1) ::  pres_int, mc, pi_int, mccu, zhalf
 real, dimension(SIZE(temp0,3)) ::  det                               

 logical, dimension(size(temp0,1),size(temp0,2)) :: rhtrig_mask
 integer, dimension(size(temp0,1),size(temp0,2)) :: kcbase

 real,    dimension(size(temp0,1),size(temp0,2)) :: &
          psfc0, t_parc, q_parc, p_parc, qs_parc   

 real,    dimension(size(temp0,1),size(temp0,2),size(temp0,3)) :: &
          qvap_sat0, dqvap_sat0, pmass

 real,    dimension(size(temp0,1),size(temp0,2),size(temp0,3)+1) :: mask3

 real,    dimension(size(temp0,1),size(temp0,2),size(temp0,3)) :: mfcb0, mfct0, alm0, cfq_ras !miz
 real,    dimension(SIZE(temp0,3)) ::  mfcb, mfct, alm !miz
 real  :: almx

real, dimension(size(temp0,1),size(temp0,2),size(temp0,3)+1) :: mc0_local

 logical :: setras, cloud_tracers_present, do_liq_num
 integer :: i, imax, j, jmax, k, kmax, tr, num_present
 integer :: ncmax, nc, ib, naer, na
 real    :: rasal, frac, zbase
 real    :: dpfac, dtcu_pbl, dqcu_pbl, ducu_pbl, dvcu_pbl, dtracercu_pbl(num_ras_tracers)
 
 real, dimension(size(temp0,1),size(temp0,2),size(temp0,3),3) :: totalmass1
 real, dimension(size(temp0,1),size(temp0,2),size(temp0,3)) :: airdens
 real, dimension(size(temp0,3),3) :: aerosolmass

 real :: thickness

!--- For extra diagnostics

 logical :: used
 real    :: dpevap, precip_ev

 real, dimension(SIZE(temp0,3)) :: &
       cup, dtevap, dqevap, dtemp_ev, dqvap_ev

 real, dimension(size(temp0,1),size(temp0,2)) :: &
       pcldb0, rain_ev0, snow_ev0, tempdiag

 real, dimension(size(temp0,1),size(temp0,2),size(temp0,3)) :: &
       cuprc3d, dtemp_ev0, dqvap_ev0

!=====================================================================

! --- Check to see if ras has been initialized
  if( .not. module_is_initialized ) CALL ERROR_MESG( 'RAS',  &
                                 'ras_init has not been called', FATAL )
  
  num_present = count((/present(ql0), present(qi0), present(qa0), present(Dl0), present(Di0), present(Da0)/))
  if(num_present == 0) then
    cloud_tracers_present = .false.
  else if(num_present == 6) then
    cloud_tracers_present = .true.
  else
    call ERROR_MESG( 'RAS','Either all or none of the cloud tracers and their tendencies'// &
                     ' must be present in the call to subroutine ras',FATAL)
  endif

  if(cloud_tracers_present .and. .not.present(mc0)) then
    call ERROR_MESG( 'RAS','mc0 must be present when cloud tracers are present',FATAL)
  endif


! --- Set dimensions
  imax  = size( temp0, 1 )
  jmax  = size( temp0, 2 )
  kmax  = size( temp0, 3 )

  
  do_liq_num = PRESENT(qn0) ! Test for presence of liquid droplet number array

  if ( do_liq_num ) then
    if (.not.(PRESENT(dn0)) .or. .not.(PRESENT(Aerosol))) &
      call ERROR_MESG( 'RAS','dn0 and Aerosol must be present when liquid droplet number are present',FATAL)
  
     naer = size(Aerosol%aerosol,4)

 if(use_online_aerosol) then
 
    do k = 1,kmax
      do j = 1,jmax
        do i = 1,imax
          if(pres0_int(i,j,k)<1.) then
            thickness=(pres0_int(i,j,k+1)-pres0_int(i,j,k))* &
             8.314*temp0(i,j,k)/(9.8*0.02888*pres0_int(i,j,k))
          else
            thickness=log(pres0_int(i,j,k+1)/ &
             pres0_int(i,j,k))*8.314*temp0(i,j,k)/(9.8*0.02888)
          end if
         do na = 1,naer
            if(Aerosol%aerosol_names(na) == 'so4' .or. &
                Aerosol%aerosol_names(na) == 'so4_anthro' .or. Aerosol%aerosol_names(na) == 'so4_natural') then
                        totalmass1(i,j,k,1)=totalmass1(i,j,k,1)+Aerosol%aerosol(i,j,k,na)
            else if(Aerosol%aerosol_names(na) == 'omphilic' .or. &
            Aerosol%aerosol_names(na) == 'omphobic') then
                        totalmass1(i,j,k,3)=totalmass1(i,j,k,3)+Aerosol%aerosol(i,j,k,na)
                 else if(Aerosol%aerosol_names(na) == 'seasalt1' .or. &
                  Aerosol%aerosol_names(na) == 'seasalt2') then
                        totalmass1(i,j,k,2)=totalmass1(i,j,k,2)+Aerosol%aerosol(i,j,k,na)
                 end if
         end do
  
         do na = 1, 3
              totalmass1(i,j,k,na)=totalmass1(i,j,k,na)/thickness*1.0e9*1.0e-12
          end do
  
         end do
        end do
      end do
  
    else
    
    do k = 1,kmax
      do j = 1,jmax
        do i = 1,imax
          if(pres0_int(i,j,k)<1.) then
            thickness=(pres0_int(i,j,k+1)-pres0_int(i,j,k))* &
            8.314*temp0(i,j,k)/(9.8*0.02888*pres0_int(i,j,k))
          else
            thickness=log(pres0_int(i,j,k+1)/ &
            pres0_int(i,j,k))*8.314*temp0(i,j,k)/(9.8*0.02888)
          end if
          totalmass1(i,j,k,1)=(Aerosol%aerosol(i,j,k,1)+Aerosol%aerosol(i,j,k,2))  &
          /thickness*1.0e9*1.0e-12
          totalmass1(i,j,k,2)=sea_salt_scale*Aerosol%aerosol(i,j,k,5)  &
          /thickness*1.0e9*1.0e-12
          totalmass1(i,j,k,3)=om_to_oc*Aerosol%aerosol(i,j,k,3)  &
          /thickness*1.0e9*1.0e-12
        end do
      end do
    end do
  
end if

    airdens = pres0 / (rdgas * temp0 * (1.   - ql0 - qi0) )
  endif   

 
! --- Initalize

   dtemp0 = 0.0                               
   dqvap0 = 0.0                               
   duwnd0 = 0.0                               
   dvwnd0 = 0.0                                                                        
    rain0 = 0.0   
    snow0 = 0.0

  dtemp_ev0 = 0.0
  dqvap_ev0 = 0.0
   rain_ev0 = 0.0
   snow_ev0 = 0.0
    cuprc3d = 0.0
     rain3d = 0.0
     snow3d = 0.0
      mfcb0 = 0.0 
      mfct0 = 0.0 
      alm0  = 0.0
    cfq_ras = 0.0

  if ( cloud_tracers_present ) then
      Da0 = 0.0
      Dl0 = 0.0
      Di0 = 0.0
      if ( do_liq_num ) Dn0 = 0.0
  end if
  if (present(mc0) ) then
      mc0 = 0.0
      det0 = 0.0
  end if
! Initialize the tracer tendencies
    qtrras = 0.0

  do k=1,kmax
    pmass(:,:,k) = (pres0_int(:,:,k+1)-pres0_int(:,:,k))/GRAV
  end do

    frac  = fracs  / dtime
    rasal = rasal0 / dtime 
       
! --- Compute saturation value of water vapor & its derivative

    call compute_qs (temp0, pres0, qvap_sat0, dqsdT=dqvap_sat0)


! --- Find LCL ---> cloud base

  if (present(kbot ) ) then
     do j = 1,jmax
     do i = 1,imax
        k = kbot(i,j)
          t_parc(i,j) =     temp0(i,j,k)
          q_parc(i,j) =     qvap0(i,j,k)
          p_parc(i,j) =     pres0(i,j,k)
         qs_parc(i,j) = qvap_sat0(i,j,k)
     end do
     end do
  else
          t_parc(:,:) =     temp0(:,:,kmax)
          q_parc(:,:) =     qvap0(:,:,kmax)
          p_parc(:,:) =     pres0(:,:,kmax)
         qs_parc(:,:) = qvap_sat0(:,:,kmax)
  end if

  q_parc  = MAX( q_parc, 1.0E-6   )
  q_parc  = MIN( q_parc, qs_parc )

  CALL COMP_LCL( t_parc, q_parc, p_parc, pres0, kcbase )

! --- set rh trigger
  rhtrig_mask(:,:) = q_parc(:,:) >= rh_trig*qs_parc(:,:) 

! --- Set surface pressure
  if (present(kbot ) ) then
     do j = 1,jmax
     do i = 1,imax
        k = kbot(i,j) + 1
        psfc0(i,j) = pres0_int(i,j,k)
     end do
     end do
  else
        psfc0(:,:) = pres0_int(:,:,kmax+1)
  end if

! --- Save cloud base pressure
  if ( id_pcldb > 0 ) then
     do j = 1,jmax
     do i = 1,imax
     klcl = kcbase(i,j)
            pcldb0(i,j) = pres0_int(i,j,klcl)
     end do
     end do
  end if

  mc0_local = 0.

!---------------------------------------------------------------------

! LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL
  do j = 1,jmax
  do i = 1,imax
! TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
    flxprec(:) = 0.
    flxprec_evap(:) = 0.

! --- Set order in which clouds are to be done                   
  CALL RAS_CLOUD_INDEX ( ic, ncmax )

! --- rh trigger
  if ( .not.rhtrig_mask(i,j) ) CYCLE

! --- Pack input variables / Initalize output variables 

      temp(:) =      temp0(i,j,:)
      qvap(:) =      qvap0(i,j,:)
      uwnd(:) =      uwnd0(i,j,:)
      vwnd(:) =      vwnd0(i,j,:)
      pres(:) =      pres0(i,j,:)
  pres_int(:) =  pres0_int(i,j,:)
     zhalf(:) =     zhalf0(i,j,:)
  qvap_sat(:) =  qvap_sat0(i,j,:) 
 dqvap_sat(:) = dqvap_sat0(i,j,:) 
      psfc    =      psfc0(i,j)
     coldT    =     coldT0(i,j)
      klcl    =     kcbase(i,j)
      if ( do_liq_num ) &
        aerosolmass(:,:) = totalmass1(i,j,:,:)

     dtemp(:) = 0.0                               
     dqvap(:) = 0.0                               
     duwnd(:) = 0.0                               
     dvwnd(:) = 0.0  
    precip    = 0.0   

          cup(:) = 0.0
     dtemp_ev(:) = 0.0 
     dqvap_ev(:) = 0.0 
    precip_ev    = 0.0 
         mfcb(:) = 0.0
         mfct(:) = 0.0
         alm (:) = 0.0
         almx    = 0.0

  if ( cloud_tracers_present ) then
        qa(:) = qa0(i,j,:)
        ql(:) = ql0(i,j,:)
        qi(:) = qi0(i,j,:)
        Da(:) = 0.0
        Dl(:) = 0.0
        Di(:) = 0.0
        if ( do_liq_num ) then
          qn(:) = qn0(i,j,:)
          Dn(:) = 0.0
        endif     
  end if
  if ( present(mc0) .or. id_mc > 0 ) then
        mc(:) = 0.0
        det(:) = 0.0
  end if

! Get the column of tracer data
    do tr = 1,num_ras_tracers
      dtracer(:,tr) = 0.0
      tracer(:,tr)  = ras_tracers(i,j,:,tr)
    enddo

    if( coldT ) then
     Hl = HLs
  else  
     Hl = HLv
  end if

  if( PRESENT( kbot ) ) then
       ksfc = kbot(i,j) + 1
  else
       ksfc = kmax + 1
  endif

! --- Thickness of layers 
  mass(1:kmax) =  pres_int(2:kmax+1) - pres_int(1:kmax) 
  mass(1:kmax) = MAX( mass(1:kmax), 1.0e-5 )

! --- Sub-cloud layer thickness
   zbase = zhalf(klcl) - zhalf(ksfc)

! --- Compute exner functions 
! --- at layer interfaces
  pi_int(:) = ( pres_int(:) / p00  ) ** Kappa                                   
! --- at full levels
  pi(1:kmax) = ( pi_int(2:kmax+1) * pres_int(2:kmax+1)     &
               - pi_int(1:kmax  ) * pres_int(1:kmax  ) )   &
               / ( mass(1:kmax  ) * one_plus_kappa )
  pi(1:kmax) =  MAX( pi(1:kmax), 1.0e-5 )

! --- Compute potential temperature
  theta(:) = temp(:) / pi(:)                                 

! --- Compute Cp divided by dpres                  
  cp_by_dp(1:kmax) = Cp_Air / mass(1:kmax)

! --- Compute mass of layers              
  mass(:) = mass(:) / Grav

  setras  = .true.

! --- Test for convective instability in column             
 CALL RAS_CLOUD_EXIST( klcl, qvap,   qvap_sat, theta,    &
                       pi,   pi_int, ic,       ncmax,    &
                       Hl,   exist  )
 if ( .not. exist ) CYCLE

!---------------------------------------------------------------------
! Cloud top loop starts
!---------------------------------------------------------------------
  do nc = 1,ncmax
!---------------------------------------------------------------------

     ib  = ic(nc)
 if( ib >= klcl) CYCLE

 if ( setras ) then
! --- Compute some stuff
     alpha(:) =  qvap_sat(:) - dqvap_sat(:) * temp(:)
      beta(:) = dqvap_sat(:) * pi(:)
     gamma(:) = 1.0 / ( ( 1.0 + ( Hl * dqvap_sat(:) / Cp_Air ) ) * pi(:) )
 endif

! --- Do adjustment
  if ( cloud_tracers_present .and. .not.(do_liq_num)) then
  CALL RAS_CLOUD(temp0(i,j,:), pres0(i,j,:),airdens(i,j,:),          &
       klcl,  ib,   rasal, frac, Hl, coldT,                          &
       theta, qvap, uwnd,  vwnd, pres_int, pi_int, pi, psfc,         &
       alpha, beta, gamma, cp_by_dp, zbase, almx,                    &
       dtcu,  dqcu, ducu,  dvcu, dpcu, tracer, dtracercu,            &
       mccu, ql, qi, qa, Dlcu, Dicu, Dacu)
  else if ( cloud_tracers_present .and. do_liq_num) then
  CALL RAS_CLOUD(temp0(i,j,:), pres0(i,j,:),airdens(i,j,:),          &
       klcl,  ib,   rasal, frac, Hl, coldT,                          &
       theta, qvap, uwnd,  vwnd, pres_int, pi_int, pi, psfc,         &
       alpha, beta, gamma, cp_by_dp, zbase, almx,                    &
       dtcu,  dqcu, ducu,  dvcu, dpcu, tracer, dtracercu,            &
       mccu, ql, qi, qa, Dlcu, Dicu, Dacu, aerosolmass, qn, Dncu)
  else if (present(mc0) .or. id_mc > 0) then
  CALL RAS_CLOUD(temp0(i,j,:), pres0(i,j,:),airdens(i,j,:),          &
       klcl,  ib,   rasal, frac, Hl,  coldT,                         &
       theta, qvap, uwnd,  vwnd, pres_int, pi_int, pi, psfc,         &
       alpha, beta, gamma, cp_by_dp, zbase, almx,                    &
       dtcu,  dqcu, ducu,  dvcu, dpcu, tracer, dtracercu, mccu)  
  else
  CALL RAS_CLOUD(temp0(i,j,:), pres0(i,j,:),airdens(i,j,:),          &
       klcl,  ib,   rasal, frac, Hl,  coldT,                         &
       theta, qvap, uwnd,  vwnd, pres_int, pi_int, pi, psfc,         &
       alpha, beta, gamma, cp_by_dp, zbase, almx,                    &
       dtcu,  dqcu, ducu,  dvcu, dpcu, tracer, dtracercu)
  end if

! --- For optional diagnostic output
  cup(ib) = dpcu

! --- Multiply tendencies by size of time step
  dtcu(:) =  dtcu(:) * dtime
  dqcu(:) =  dqcu(:) * dtime
  ducu(:) =  ducu(:) * dtime
  dvcu(:) =  dvcu(:) * dtime
  dpcu    =  dpcu    * dtime

  if ( cloud_tracers_present ) then
  Dacu(:) =  Dacu(:) * dtime
  Dlcu(:) =  Dlcu(:) * dtime
  Dicu(:) =  Dicu(:) * dtime
  if ( do_liq_num ) &
    Dncu(:) =  Dncu(:) * dtime
  end if

    do tr = 1,num_ras_tracers
      dtracercu(:,tr) = dtracercu(:,tr) * dtime
    enddo
  if( modify_pbl ) then   
! TTTTTTTTTTTTTTTTTTTTT      
! --- Adjust mass flux between cloud base and surface       
    if ( present(mc0) .or. id_mc > 0 ) then
      do k = klcl+1,ksfc
        mccu(k) = mccu(klcl) * ( psfc - pres_int(k)    ) / &
                               ( psfc - pres_int(klcl) )
      end do
    end if
! --- Adjust tendencies between cloud base and surface
    dpfac = ( pres_int(klcl+1) - pres_int(klcl) ) / &
             ( psfc             - pres_int(klcl) )   
    dtcu_pbl = dpfac * dtcu(klcl) * pi(klcl)
    dqcu_pbl = dpfac * dqcu(klcl) 
    ducu_pbl = dpfac * ducu(klcl) 
    dvcu_pbl = dpfac * dvcu(klcl) 
    do tr = 1,num_ras_tracers
      dtracercu_pbl(tr) = dpfac * dtracercu(klcl,tr)
    enddo
    do k = klcl,ksfc-1
      dtcu(k) = dtcu_pbl / pi(k) 
      dqcu(k) = dqcu_pbl
      ducu(k) = ducu_pbl
      dvcu(k) = dvcu_pbl
        do tr = 1,num_ras_tracers
          dtracercu(k,tr) = dtracercu_pbl(tr)
        enddo
    end do
! LLLLLLLLLLLLLLLLL
  endif
! --- Evaporate some precip

      dtevap(:) = 0.0
      dqevap(:) = 0.0
      dpevap    = 0.0
!
! -- initialise the precipitation and evaporation flux
      flxprec_ib_evap = 0.0

  if( evap_on .and. ( dpcu > 0.0 ) ) then

  CALL RAS_CEVAP ( ib, temp, qvap, pres, mass, qvap_sat,       &
                   dqvap_sat, psfc, Hl, dtime, ksfc, dpcu,     &
                   dtevap, dqevap,  dpevap, flxprec_ib, flxprec_ib_evap  )

      dtcu(:) =  dtcu(:) + dtevap(:) / pi(:)
      dqcu(:) =  dqcu(:) + dqevap(:)
      dpcu    = MAX(dpcu - dpevap, 0.)

  else
    flxprec_ib(1:ib-1) = 0.0
    flxprec_ib(ib:) = dpcu/dtime
  endif

!---sum up precipitation flux and evaporation from  each cloud type
!
flxprec      = flxprec +flxprec_ib
flxprec_evap = flxprec_evap +flxprec_ib_evap

! --- Update prognostic tracers
!     NOTE: negative values of tracers are not prevented
    do tr = 1,num_ras_tracers
         tracer(:,tr)   = amax1(0.,tracer(:,tr) + dtracercu(:,tr))
    enddo  

if ( prevent_unreasonable ) then
! --- Update cloud liquid, ice, and fraction
!     NOTE: unreasonable states are prevented

  if ( cloud_tracers_present ) then
  
    !cloud fraction---------------
    where ((qa + Dacu) .lt. 0.)
         Dacu = -1.*qa
        qa   = 0.
    elsewhere
         qa   = qa + Dacu
    end where
    where (qa .gt. 1.)
         Dacu = Dacu + (1. - qa)
         qa   = 1.
    end where
    
    !cloud liquid----------------
    where ((ql + Dlcu) .lt. 0.)
         dtcu = dtcu - HLv*(ql+Dlcu)/Cp_Air/pi
        dqcu = dqcu + (ql + Dlcu)
         Dlcu = Dlcu - (ql + Dlcu)
        ql   = 0.
    elsewhere
         ql   = ql + Dlcu
    end where
    
    !cloud ice----------------
    where ((qi + Dicu) .lt. 0.)
         dtcu = dtcu - HLs*(qi+Dicu)/Cp_Air/pi
        dqcu = dqcu + (qi + Dicu)
         Dicu = Dicu - (qi + Dicu)
        qi   = 0.
    elsewhere
         qi   = qi + Dicu
    endwhere
            
  end if
else

  if ( cloud_tracers_present ) then
    ql(:) = ql(:) + Dlcu(:)
    qi(:) = qi(:) + Dicu(:)
    qa(:) = qa(:) + Dacu(:)
    if ( do_liq_num ) &
      qn(:) = qn(:) + Dncu(:)
  end if

endif

! --- Update potential temperature, water vapor, winds
  theta(:) = theta(:) + dtcu(:)
   qvap(:) =  qvap(:) + dqcu(:)
   uwnd(:) =  uwnd(:) + ducu(:)
   vwnd(:) =  vwnd(:) + dvcu(:)

! --- Recover temperature 
  temp(:) = theta(:) * pi(:)

! --- Accumulate precip 
  precip    = precip    + dpcu 
  precip_ev = precip_ev + dpevap

! --- Accumulate tendencies 
     dtemp(:) =    dtemp(:) +   dtcu(:) * pi(:)
     dqvap(:) =    dqvap(:) +   dqcu(:)
     duwnd(:) =    duwnd(:) +   ducu(:) 
     dvwnd(:) =    dvwnd(:) +   dvcu(:)
  dtemp_ev(:) = dtemp_ev(:) + dtevap(:)
  dqvap_ev(:) = dqvap_ev(:) + dqevap(:)

  if ( cloud_tracers_present ) then
    Da(:) = Da(:) + Dacu(:)
    Dl(:) = Dl(:) + Dlcu(:)
    Di(:) = Di(:) + Dicu(:)
    if ( do_liq_num ) &
      Dn(:) = Dn(:) + Dncu(:)
  end if
  mfcb(ib)=mccu(klcl) 
  mfct(ib)=mccu(ib+1) 
  alm (ib)=almx 

  if ( present(mc0) .or. id_mc > 0 ) then
    mc(:) = mc(:) + mccu(:)
    det(ib) = det(ib) + mccu(ib+1)
  end if
  do tr = 1,num_ras_tracers
    dtracer(:,tr) = dtracer(:,tr) + dtracercu(:,tr)
  enddo  

  setras = .false.

 if ( setras ) then
! --- Re-Compute saturation value of water vapor & its derivative
   call compute_qs (temp, pres, qvap_sat, dqsdT=dqvap_sat)
  end if
     
!---------------------------------------------------------------------
  end do ! do nc = 1,ncmax
!---------------------------------------------------------------------
! Cloud top loop ends
!---------------------------------------------------------------------

! --- Unpack variables
      dtemp0(i,j,:) = dtemp(:)
      dqvap0(i,j,:) = dqvap(:) 
      duwnd0(i,j,:) = duwnd(:)
      dvwnd0(i,j,:) = dvwnd(:)
      mfcb0 (i,j,:) = mfcb(:)
      mfct0 (i,j,:) = mfct(:)
      alm0  (i,j,:) = alm (:)

   if ( coldT ) then
      snow0(i,j) = precip
   else
      rain0(i,j) = precip
   end if

!-- unpacking the precipitation flux. The 
    do kk = 1,kmax
      if ( coldT ) then
       snow3d(i,j,kk+1)   = flxprec(kk)      !kg/m2/sec
      else
       rain3d(i,j,kk+1)   = flxprec(kk)      !kg/m2/sec
      end if
    enddo

  if ( cloud_tracers_present ) then
        Da0(i,j,:) = Da(:) 
        Dl0(i,j,:) = Dl(:) 
        Di0(i,j,:) = Di(:)
        if ( do_liq_num ) &
          Dn0(i,j,:) = Dn(:)
  end if
  if ( present(mc0) .or. id_mc > 0 ) then
        mc0_local(i,j,:) = mc(:)
        det0(i,j,:) = det(:)
  end if
  do tr = 1,num_ras_tracers
    qtrras(i,j,:,tr) = dtracer(:,tr)
  enddo    

! --- For extra diagnostics
 
     cuprc3d(i,j,:) =       cup(:) 
   dtemp_ev0(i,j,:) =  dtemp_ev(:)
   dqvap_ev0(i,j,:) =  dqvap_ev(:)

    if ( coldT ) then
       snow_ev0(i,j) = precip_ev
    else
       rain_ev0(i,j) = precip_ev
    end if

! LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL
  end do ! do i = 1,imax
  end do ! do j = 1,jmax
! TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT

!------- update input values and compute tendency -----------
   dtinv = 1.0/dtime

   temp0=temp0+dtemp0;    qvap0=qvap0+dqvap0
   uwnd0=uwnd0+duwnd0;    vwnd0=vwnd0+dvwnd0

   duwnd0=duwnd0*dtinv; dvwnd0=dvwnd0*dtinv

   dtemp0=dtemp0*dtinv; dqvap0=dqvap0*dtinv
   rain0=rain0*dtinv; snow0=snow0*dtinv

!!------- add on tendency ----------
!      tdt=tdt+ttnd; qdt=qdt+qtnd
!      udt=udt+utnd; vdt=vdt+vtnd

!------- update input values , compute and add on tendency -----------
!-------              in the case of strat                 -----------

   if (cloud_tracers_present) then
     ql0(:,:,:) = ql0(:,:,:)+Dl0(:,:,:)
     qi0(:,:,:) = qi0(:,:,:)+Di0(:,:,:)
     qa0(:,:,:) = qa0(:,:,:)+Da0(:,:,:)
     if ( do_liq_num ) &
       qn0(:,:,:) = qn0(:,:,:)+Dn0(:,:,:)

     Dl0(:,:,:) = Dl0(:,:,:)*dtinv
     Di0(:,:,:) = Di0(:,:,:)*dtinv
     Da0(:,:,:) = Da0(:,:,:)*dtinv
     if ( do_liq_num ) &
       Dn0(:,:,:)=Dn0(:,:,:)*dtinv

   end if
   do tr = 1,num_ras_tracers
     qtrras(:,:,:,tr) = qtrras(:,:,:,tr)*dtinv
   enddo    

   if(present(mc0)) mc0 = mc0_local

!---------------------------------------------------------------------
! --- Extra diagnostics
!---------------------------------------------------------------------
 
   dtemp_ev0(:,:,:) = dtemp_ev0(:,:,:) * dtinv
   dqvap_ev0(:,:,:) = dqvap_ev0(:,:,:) * dtinv
   snow_ev0(:,:)   =  snow_ev0(:,:)   * dtinv
   rain_ev0(:,:)   =  rain_ev0(:,:)   * dtinv

   used = send_data ( id_tdt_revap, dtemp_ev0, Time, is, js, 1 )
   used = send_data ( id_qdt_revap, dqvap_ev0, Time, is, js, 1 )
   used = send_data ( id_prec_revap, rain_ev0+snow_ev0, Time, is, js )
   used = send_data ( id_snow_revap, snow_ev0, Time, is, js )
   used = send_data ( id_prec_conv_3d, cuprc3d, Time, is, js, 1 )
   used = send_data ( id_pcldb, pcldb0, Time, is, js )

!------- diagnostics for dt/dt_ras -------
   used = send_data ( id_tdt_conv, dtemp0, Time, is, js, 1, &
                      rmask=mask )
!------- diagnostics for dq/dt_ras -------
   used = send_data ( id_qdt_conv, dqvap0, Time, is, js, 1, &
                      rmask=mask )
!------- diagnostics for precip_ras -------
   used = send_data ( id_prec_conv, (rain0+snow0), Time, is, js )
!------- diagnostics for snow_ras -------
   used = send_data ( id_snow_conv, snow0, Time, is, js )
!------- diagnostics for cumulus mass flux from ras -------
   if ( id_mc > 0 ) then
        !------- set up mask --------
        mask3(:,:,1:(kmax+1)) = 1.
        if (present(mask)) then
          WHERE (mask(:,:,1:kmax) <= 0.5)
                  mask3(:,:,1:kmax) = 0.
          END WHERE
        endif
        used = send_data ( id_mc, mc0_local, Time, is, js, 1, rmask=mask3 )
   endif
   used = send_data ( id_mfcb, mfcb0(:,:,1:kmax), Time, is, js, 1, rmask=mask )
   used = send_data ( id_mfct, mfct0(:,:,1:kmax), Time, is, js, 1, rmask=mask )
   used = send_data ( id_alm,  alm0 (:,:,1:kmax), Time, is, js, 1, rmask=mask )
   if ( id_cfq_ras > 0 ) then
     where (mfcb0(:,:,:) .gt. 0.)
       cfq_ras(:,:,:) = 1
     end where
     used = send_data ( id_cfq_ras,  cfq_ras (:,:,1:kmax), Time, is, js, 1, rmask=mask )
   endif
    

!------- diagnostics for water vapor path tendency ----------
   if ( id_q_conv_col > 0 ) then
     tempdiag(:,:)=0.
     do k=1,kmax
       tempdiag(:,:) = tempdiag(:,:) + dqvap0(:,:,k)*pmass(:,:,k)*dtinv
     end do
     used = send_data ( id_q_conv_col, tempdiag, Time, is, js )
   end if

!------- diagnostics for dry static energy tendency ---------
   if ( id_t_conv_col > 0 ) then
     tempdiag(:,:)=0.
     do k=1,kmax
       tempdiag(:,:) = tempdiag(:,:) + dtemp0(:,:,k)*Cp_Air*pmass(:,:,k)
     end do
     used = send_data ( id_t_conv_col, tempdiag, Time, is, js )
   end if

   if ( cloud_tracers_present ) then

      !------- diagnostics for dql/dt from RAS -----------------
      used = send_data ( id_qldt_conv, Dl0, Time, is, js, 1, &
                         rmask=mask )
      
      !------- diagnostics for dqi/dt from RAS -----------------
      used = send_data ( id_qidt_conv, Di0, Time, is, js, 1, &
                         rmask=mask )
      
      !------- diagnostics for dqa/dt from RAS -----------------
      used = send_data ( id_qadt_conv, Da0, Time, is, js, 1, &
                         rmask=mask )

      !------- diagnostics for dqn/dt from RAS -----------------
      if (do_liq_num .and. id_qndt_conv > 0 ) &
        used = send_data ( id_qndt_conv, Dn0, Time, is, js, 1, &
                         rmask=mask )

      !------- diagnostics for liquid water path tendency ------
      if ( id_ql_conv_col > 0 ) then
        tempdiag(:,:)=0.
        do k=1,kmax
          tempdiag(:,:) = tempdiag(:,:) + Dl0(:,:,k)*pmass(:,:,k)
        end do
        used = send_data ( id_ql_conv_col, tempdiag, Time, is, js )
      end if
      
      !------- diagnostics for ice water path tendency ---------
      if ( id_qi_conv_col > 0 ) then
        tempdiag(:,:)=0.
        do k=1,kmax
          tempdiag(:,:) = tempdiag(:,:) + Di0(:,:,k)*pmass(:,:,k)
        end do
        used = send_data ( id_qi_conv_col, tempdiag, Time, is, js )
      end if
      
      !---- diagnostics for column integrated cloud mass tendency ---
      if ( id_qa_conv_col > 0 ) then
        tempdiag(:,:)=0.
        do k=1,kmax
          tempdiag(:,:) = tempdiag(:,:) + Da0(:,:,k)*pmass(:,:,k)
        end do
        used = send_data ( id_qa_conv_col, tempdiag, Time, is, js )
      end if
         
      !------- diagnostics for det0 from RAS -----------------
      used = send_data ( id_det0, det0, Time, is, js, 1, &
                         rmask=mask )

   end if !end do strat if

   do tr = 1, num_ras_tracers
      !------- diagnostics for dtracer/dt from RAS -------------
      used = send_data ( id_tracer_conv(tr), qtrras(:,:,:,tr), Time, is, js, 1, &
                         rmask=mask )

      !------- diagnostics for column tracer path tendency -----
      if ( id_tracer_conv_col(tr) > 0 ) then
        tempdiag(:,:)=0.
        do k=1,kmax
          tempdiag(:,:) = tempdiag(:,:) + qtrras(:,:,k,tr)*pmass(:,:,k)
        end do
        used = send_data ( id_tracer_conv_col(tr), tempdiag, Time, is, js )
      end if


   enddo
!=====================================================================



  end SUBROUTINE RAS


!#######################################################################
!#######################################################################

 SUBROUTINE RAS_CLOUD(t, p, dens,                                &
            k, ic, rasal, frac, hl, coldT,                       &
            theta, qvap, uwnd, vwnd, pres_int, pi_int, pi, psfc, &
            alf, bet, gam, cp_by_dp, zbase, almx,                &
            dtcu, dqcu, ducu,  dvcu, dpcu, tracer, dtracercu,    &
            mccu, ql, qi, qa, Dlcu, Dicu, Dacu, aerosolmass, qn, Dncu)   ! optional
!=======================================================================
! RAS Cu Parameterization 
!=======================================================================
!---------------------------------------------------------------------
! Arguments (Intent in)
!     k        : Cloud base index.
!     ic       : Cloud top index.
!     hl       : proper latent heat for the column
!     coldT    : is the precipitation frozen?
!     theta    : Potential temperature
!     qvap     : Water vapor 
!     uwnd     : U component of wind
!     vwnd     : V component of wind
!     pres_int : Pressure       at layer interface
!     pi_int   : Exner function at layer interface
!     pi       : Exner function 
!     psfc     : Surface pressure
!     zbase    : Thickness of sub-cloud layer
!     rasal    : Relaxation parameter for cloud type ic
!     ql       : OPTIONAL, cloud liquid
!     qi       : OPTIONAL, cloud ice
!     qa       : OPTIONAL, cloud fraction or saturated volume fraction
!---------------------------------------------------------------------

 real,    intent(inout):: almx    !miz
 real,    intent(in) :: rasal, frac, zbase
 real,    intent(in) :: hl,    psfc
 integer, intent(in) :: ic,    k
 logical, intent(in) :: coldT
 real, intent(in), dimension(:) :: t,p,dens
 real, intent(in), dimension(:) :: theta, qvap, uwnd, vwnd, pres_int, pi_int
 real, intent(in), dimension(:) :: alf,   bet,  gam,  pi,   cp_by_dp
 real, intent(in), OPTIONAL, dimension(:) :: ql,qi,qa,qn
 real, intent(in), dimension(:,:) :: tracer
 real, intent(in), OPTIONAL, dimension(:,:) :: aerosolmass
!---------------------------------------------------------------------
! Arguments (Intent out)
!     dpcu    : Precip for cloud type ic.
!     dtcu    : Potential temperature change
!     dqcu    : Water vapor change
!     ducu    : Cu friction - u component.
!     dvcu    : Cu friction - v component.
!     mccu    : OPTIONAL ; Cumulus Mass Flux
!     Dacu    : OPTIONAL ; Detrained saturated mass fraction tendency
!     Dlcu    : OPTIONAL ; Detrained cloud liquid tendency
!     Dicu    : OPTIONAL ; Detrained cloud ice tendency
!     dtracercu : OPTIONAL ; Detrained tracer tendency 
!---------------------------------------------------------------------

 real, intent(out)  :: dpcu
 real, intent(out), dimension(:) :: dtcu, dqcu, ducu, dvcu
 real, intent(out), OPTIONAL, dimension(:) :: mccu, Dacu, Dlcu, Dicu, Dncu
 real, intent(out), dimension(:,:) :: dtracercu

!---------------------------------------------------------------------
!    (Intent local)
!---------------------------------------------------------------------

 real, parameter :: rhmax  = 0.9999 

  logical :: lcase1,    lcase2
  real    :: wfn_crit,  ftop, rn_frac
  real    :: wfn,  akm, qs1,  uht, vht, wlq, alm 
  real    :: rasalf
  real    :: wll,  wli, wlN
  integer :: km1,  ic1, l,    iwk
  real    :: xx1,  xx2, xx3,  xx4
  real    :: ssl, dtemp, zzl, hccp, hcc,  dpib, dpit 
  real    :: dut, dvt,   dub, dvb,  wdet, dhic, hkb, hic, sic
 
 real, dimension(size(theta,1)) :: gmh, eta, hol, hst, qol
 real, dimension(SIZE(tracer,2)) :: wlR

 logical :: Ldacu, Lmccu, LRcu, do_liq_num

!thetac in-cloud potential temperature (K)
!qc in-cloud vapor mixing ratio (kg water/kg air)
!qt in-cloud qc + ql (kg water/kg air)
 real, dimension(size(theta,1)) :: thetac, qc, qt
 real     :: tc, te, Nc, up_conv, drop
 real, dimension(3) :: totalmass
 integer :: tr

!=====================================================================

! --- Check for presence of optional arguments
  Ldacu = PRESENT( Dacu )
  Lmccu = PRESENT( mccu ) 
  LRcu  = (num_ras_tracers > 0 ) !.TRUE.
  do_liq_num = PRESENT(qn) 


! Initialize
  dtcu = 0.0
  dqcu = 0.0
  ducu = 0.0
  dvcu = 0.0
  dpcu = 0.0
  if ( Ldacu ) then
  Dacu = 0.0
  Dlcu = 0.0
  Dicu = 0.0
  if ( do_liq_num ) Dncu = 0.0
  end if
  if ( Lmccu ) then
  mccu = 0.0
  end if
  if ( LRcu ) then
  do tr = 1,num_ras_tracers
    dtracercu(:,tr) = 0.0
  enddo
  end if

! Initialize
  wfn=0.0
  akm=0.0
  qs1=0.0
  uht=0.0
  vht=0.0
  wlq=0.0
  alm=0.0
  almx=0.0
  wll=0.0
  wli=0.0
  if ( do_liq_num ) &
    wlN=0.0
  gmh=0.0
  eta=0.0
  hol=0.0
  hst=0.0
  qol=0.0
  km1=0
  ic1=0
  l=0
  rasalf=0.0

  km1 = k  - 1
  ic1 = ic + 1

!=====================================================================
! --- RECOMPUTE SOUNDING UP TO DETRAINMENT LEVEL
!=====================================================================

! --- at cloud base
    qs1    = alf(k) + bet(k) * theta(k)
    qol(k) = MIN( qs1 * rhmax, qvap(k) )
    hol(k) = pi_int(k+1) * theta(k) * Cp_Air + qol(k) * Hl
    eta(k) = 0.0
    zzl    = ( pi_int(k+1) - pi_int(k) ) * theta(k) * Cp_Air

! --- between cloud base & cloud top
 if ( ic < km1 ) then
 do l = km1,ic1,-1
    qs1    = alf(l) + bet(l) * theta(l)
    qol(l) = MIN( qs1 * rhmax, qvap(l) )
    ssl    = zzl + pi_int(l+1) * theta(l) * Cp_Air 
    hol(l) = ssl + qol(l) * Hl
    hst(l) = ssl + qs1    * Hl
    dtemp  = ( pi_int(l+1) - pi_int(l) ) * theta(l)
    eta(l) = eta(l+1) + dtemp * cp_div_grav
    zzl    = zzl      + dtemp * Cp_Air    
 end do
 end if

! --- at cloud top
    qs1     = alf(ic) + bet(ic) * theta(ic)
    qol(ic) = MIN( qs1 * rhmax, qvap(ic) ) 
    ssl     = zzl + pi_int(ic1) * theta(ic) * Cp_Air 
    hol(ic) = ssl + qol(ic) * Hl
    hst(ic) = ssl + qs1     * Hl
    dtemp   = ( pi_int(ic1) - pi(ic) ) * theta(ic)
    eta(ic) = eta(ic1) + dtemp * cp_div_grav

!=====================================================================
!     ENTRAINMENT PARAMETER
!=====================================================================

    xx1 = hol(k) - hst(ic)

    xx2 = 0.0
 do l = ic,km1
    xx2 = xx2 + ( hst(ic) - hol(l) ) * ( eta(l) - eta(l+1) )
 end do

   lcase1 = ( xx2    >  0.0      ) .and.  &
            ( xx1    >  0.0      )

   lcase2 = ( xx1    <= 0.0      ) .and. &
            ( hol(k) >  hst(ic1) ) .and. &
            ( ic1    <  k ) 

!$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
 if ( .not.lcase1 .and. .not.lcase2 )  RETURN
!$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

  if ( lcase1 ) then
     alm = xx1 / xx2
  else 
     alm = 0.0
  end if

!$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
!  if( Tokioka_on ) alm_min = Tokioka_con / zbase
!  if( alm < alm_min ) RETURN
     xx2 = alm_min
  if( Tokioka_on ) then
     xx1  = 0.5 * ( pres_int(ic) + pres_int(ic1) )
     if(  xx1 <= Tokioka_plim ) xx2 = Tokioka_con / zbase
  endif
  if( alm < xx2 ) then
    almx = 0.0
    RETURN
  endif
!$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

!=====================================================================
!    NORMALIZED MASSFLUX
!=====================================================================

 do l = ic,km1
    eta(l) = 1.0 + alm * eta(l)
 end do
    eta(k) = 1.0

!=====================================================================
!     CLOUD WORKFUNCTION
!=====================================================================

    wfn  = 0.0
    hccp = hol(k)

!=====================================================================
!     IN-CLOUD TEMP AND WATER MIXING RATIO
!=====================================================================

    if ( do_liq_num ) then
    thetac(k) = theta(k)
    zzl  = ( pi_int(k+1) - pi_int(k) ) * theta(k) * Cp_Air
    wlq =  qol(k)
    qt(k) = qol(k)
    endif


 if ( ic1 <= km1 ) then
 do l = km1,ic1,-1
!hcc in-cloud moist static energy (MSE)
    hcc = hccp + ( eta(l) - eta(l+1) ) * hol(l)
    dpib = pi_int(l+1) - pi(l)
    dpit = pi(l)       - pi_int(l)
!environment
    xx1  = ( eta(l+1) * dpib + eta(l) * dpit ) * hst(l)
!in-cloud
    xx2  =       hccp * dpib +    hcc * dpit
    wfn  = wfn + ( xx2 - xx1 ) * gam(l)
    hccp = hcc

    if ( do_liq_num ) then
    thetac(l) = ((hcc-zzl)/eta(l)-alf(l)*Hl)/(pi_int(l+1)*Cp_Air+bet(l)*Hl)
!    qc(l) = alf(l)+bet(l)*thetac(l)
    qc(l) = alf(l)+bet(l)*theta(l)

    ssl  = zzl + pi_int(l+1) * thetac(l) * Cp_Air
    dtemp  = ( pi_int(l+1) - pi_int(l) ) * thetac(l)

    zzl    = zzl      + dtemp * Cp_Air    
    xx1 = eta(l) - eta(l+1)
    wlq = wlq + xx1 *  qol(l)
    qt(l) = wlq/eta(l)
    endif

 end do
 end if

 if ( lcase1 ) then
    wfn = wfn + gam(ic) * ( pi_int(ic1) - pi(ic) ) * &
               ( hccp - hst(ic) * eta(ic1) )
 end if

    if ( do_liq_num ) &
      up_conv=0.7*max(wfn,0.)**0.5

!=====================================================================
!    CRITICAL CLOUD WORK FUNCTION
!=====================================================================

      xx1  = 0.5 * ( pres_int(ic) + pres_int(ic1) )
      xx2  = pres_int(k)
      ftop = 1.0

 if ( lcase2 ) then
   if ( hst(ic1) < hst(ic) ) then
      ftop = ( hst(ic1) - hol(k) ) / ( hst(ic1) - hst(ic) )
   else
      ftop = 0.0
   endif
      xx3 = 0.5 * ( pres_int(ic1) + pres_int(ic1+1) )
      xx1 = xx3 * ( 1.0 - ftop ) + xx1 * ftop
 endif

! $$$  CALL RAS_ACRITN ( xx1, xx2, wfn_crit )

        iwk = xx1 * 0.02E-2 - 0.999999999
 if ( ( iwk > 1 ) .and. ( iwk <= 15 ) ) then
         wfn_crit = ac(iwk) + xx1 * ad(iwk)
 else if ( iwk <= 1 ) then
         wfn_crit = actop
 else if ( iwk > 15 ) then
         wfn_crit = a(15)
 end if
         wfn_crit = aratio * wfn_crit * ( xx2 - xx1 )

  wfn = wfn - wfn_crit

 lcase1 = lcase1 .and. ( wfn > 0.0 )
 lcase2 = lcase2 .and. ( wfn > 0.0 ) .and. ( ftop > 0.0 )

!$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
  if ( .not.lcase1 .and. .not.lcase2 )  then
    almx = 0.0
    RETURN
  endif
!$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
  almx = alm
!=====================================================================

  if ( lcase1 ) then
      dhic = hst(ic) - hol(ic)
  else
      dhic = ( hol(k)  - hol(ic1) ) &
           - ( hol(ic) - hol(ic1) ) * ftop
  end if

  if ( lcase2 ) then
     xx1 = ftop * ( hol(ic) - hol(ic1) ) + hol(ic1)
     xx2 = ftop * ( qol(ic) - qol(ic1) ) + qol(ic1)
     sic = xx1 - xx2 * Hl
     qs1 = xx2 + dhic * ( 1.0 / Hl )
  end if

     hic = hol(ic)
     hkb = hol(k)

!=====================================================================

     wlq =  qol(k) - qs1      * eta(ic)
     uht = uwnd(k) - uwnd(ic) * eta(ic)
     vht = vwnd(k) - vwnd(ic) * eta(ic)

 do l = km1,ic,-1
     xx1 = eta(l) - eta(l+1)
     wlq = wlq + xx1 *  qol(l)
     uht = uht + xx1 * uwnd(l)
     vht = vht + xx1 * vwnd(l)
 end do

!=====================================================================
!         CALCULATE TRACER UPDRAFT PROPERTIES
!            AND CONVECTIVE SOURCE OF TRACER
!=====================================================================


!------------ Prognostic tracers

if ( LRcu ) then

!     wlR = tracer(k,:)
     
! do l = km1,ic,-1
!     xx1 = eta(l) - eta(l+1)
!     wlR = wlR + xx1 * tracer(l,:)
! end do
! 
!!do cloud base level
!     xx1     = 0.5 * cp_by_dp(k) / Cp_Air / onebg
!     dtracercu(k,:) = ( tracer(km1,:) - tracer(k,:) ) * xx1
     
! if ( ic1 <= km1 ) then
! do l = km1,ic1,-1
!     xx1     = 0.5 * cp_by_dp(l) / Cp_Air / onebg
!     dtracercu(l,:) = ( eta(l+1) * ( tracer(l  ,:) - tracer(l+1,:) ) + &
!                   eta(l  ) * ( tracer(l-1,:) - tracer(l  ,:) ) ) * xx1
! end do
! end if
!
! !do cloud top level
!     xx1      = cp_by_dp(ic) / Cp_Air / onebg
!     xx2      = 0.5 * xx1
!     dtracercu(ic,:) = ( eta(ic1) * ( tracer(ic,:) - tracer(ic1,:) ) * xx2 ) + &
!                  ( wlR      - eta(ic) * tracer(ic,:)  ) * xx1
!
 end if

!------------ Cloud liquid, ice, and fraction

 if ( Ldacu ) then

     wll = ql(k)
     wli = qi(k)
     if ( do_liq_num ) &
       wlN = qn(k)
 do tr=1,num_ras_tracers
     wlR(tr) = tracer(k,tr)
 enddo

 do l = km1,ic,-1
     xx1 = eta(l) - eta(l+1)
     wll = wll + xx1 * ql(l)
     wli = wli + xx1 * qi(l)
     do tr=1,num_ras_tracers
       wlR(tr) = wlR(tr) + xx1 * tracer(l,tr)
     enddo
 end do


 if ( do_liq_num ) then
   do l = km1,ic,-1
     xx1 = eta(l) - eta(l+1)
       wlN = wlN + xx1 * qn(l)
   end do
 endif
 
!do cloud base level
     xx1     = 0.5 * cp_by_dp(k) / Cp_Air / onebg
     Dlcu(k) = ( ql(km1) - ql(k) ) * xx1
     Dicu(k) = ( qi(km1) - qi(k) ) * xx1
     Dacu(k) = ( qa(km1) - qa(k) ) * xx1
     if ( do_liq_num ) &
       Dncu(k) = ( qn(km1) - qn(k) ) * xx1
     mccu(k) = eta(k)
     do tr = 1,num_ras_tracers
       dtracercu(k,tr) = ( tracer(km1,tr) - tracer(k,tr) ) * xx1
     enddo

 if ( ic1 <= km1 ) then
   do l = km1,ic1,-1
     xx1     = 0.5 * cp_by_dp(l) / Cp_Air / onebg
     Dlcu(l) = ( eta(l+1) * ( ql(l  ) - ql(l+1) ) + &
                 eta(l  ) * ( ql(l-1) - ql(l  ) ) ) * xx1
     Dicu(l) = ( eta(l+1) * ( qi(l  ) - qi(l+1) ) + &
                 eta(l  ) * ( qi(l-1) - qi(l  ) ) ) * xx1
     Dacu(l) = ( eta(l+1) * ( qa(l  ) - qa(l+1) ) + &
                 eta(l  ) * ( qa(l-1) - qa(l  ) ) ) * xx1
     mccu(l) = eta(l)
     do tr = 1,num_ras_tracers
       dtracercu(l,tr) = ( eta(l+1) * ( tracer(l  ,tr) - tracer(l+1,tr) ) + &
                     eta(l  ) * ( tracer(l-1,tr) - tracer(l  ,tr) ) ) * xx1
     enddo
   end do

   if ( do_liq_num ) then
     do l = km1,ic1,-1
       xx1     = 0.5 * cp_by_dp(l) / Cp_Air / onebg
       Dncu(l) = ( eta(l+1) * ( qn(l  ) - qn(l+1) ) + &
                   eta(l  ) * ( qn(l-1) - qn(l  ) ) ) * xx1
     enddo
   endif
 end if
 

 !do cloud top level
     xx1      = cp_by_dp(ic) / Cp_Air / onebg
     xx2      = 0.5 * xx1
     Dlcu(ic) = ( eta(ic1) * ( ql(ic) - ql(ic1) ) * xx2 ) + &
                ( wll       - eta(ic) * ql(ic)  ) * xx1
     Dicu(ic) = ( eta(ic1) * ( qi(ic) - qi(ic1) ) * xx2 ) + &
                ( wli       - eta(ic) * qi(ic)  ) * xx1
     Dacu(ic) = ( eta(ic1) * ( qa(ic) - qa(ic1) ) * xx2 ) + &
                ( eta(ic)   - eta(ic) * qa(ic)  ) * xx1
     if ( do_liq_num ) &
       Dncu(ic) = ( eta(ic1) * ( qn(ic) - qn(ic1) ) * xx2 ) + &
                  ( wlN       - eta(ic) * qn(ic)  ) * xx1
     do tr = 1,num_ras_tracers
       dtracercu(ic,tr) = ( eta(ic1) * ( tracer(ic,tr) - tracer(ic1,tr) ) * xx2 ) + &
                    ( wlR(tr)      - eta(ic) * tracer(ic,tr)  ) * xx1
     enddo

 end if

 if ( Lmccu .and. .not.Ldacu ) then

 !do cloud base level
     mccu(k) = eta(k)

 if ( ic1 <= km1 ) then
 do l = km1,ic1,-1
   mccu(l) = eta(l)
 end do
 end if

 end if

!=======================================================================
!     CALCULATE GS AND PART OF AKM (THAT REQUIRES ETA)
!=======================================================================

     xx1      = ( theta(km1) - theta(k) ) / ( pi(k) - pi(km1) )
     hol(k)   = xx1 * ( pi_int(k) - pi(km1) ) * pi(k)   * cp_by_dp(k)
     hol(km1) = xx1 * ( pi(k) - pi_int(k)   ) * pi(km1) * cp_by_dp(km1)
     akm      = 0.0

 if ( ic1 <= km1 ) then
 do l = km1,ic1,-1
     xx1      = ( theta(l-1) - theta(l) ) * eta(l) / ( pi(l) - pi(l-1) )
     hol(l)   = xx1 * ( pi_int(l) - pi(l-1) ) * pi(l)   * cp_by_dp(l) + hol(l)  
     hol(l-1) = xx1 * ( pi(l) - pi_int(l)   ) * pi(l-1) * cp_by_dp(l-1)
     akm      = akm - hol(l)  * ( eta(l)   * ( pi(l  ) - pi_int(l) ) +  &
                                  eta(l+1) * ( pi_int(l+1) - pi(l) ) ) / pi(l)
 end do
 end if

!=======================================================================
!  PARTION CLOUD LIQUID WATER INTO PRECIP & DETRAINED WATER 
!=======================================================================

     xx1 = 0.5 * ( pres_int(ic) + pres_int(ic1) )

! $$$ CALL RAS_RNCL( xx1, rn_frac)
       rn_frac = rn_frac_top
   if ( ( xx1 >= rn_ptop ) .and. ( xx1 <= rn_pbot ) ) then
       rn_frac = ( rn_pbot - xx1 ) * rn_pfac +  rn_frac_bot
   end if
   if ( xx1 > rn_pbot ) then
       rn_frac = rn_frac_bot
   end if

       wdet = ( 1.0 - rn_frac ) * wlq
       wlq  =         rn_frac   * wlq

  if ( Ldacu ) then !detrain non-precipitated fraction of condensed vapor
    
      if (coldT) then
         Dicu(ic) = Dicu(ic) + wdet * cp_by_dp(ic)/Cp_Air/onebg
      else
         Dlcu(ic) = Dlcu(ic) + wdet * cp_by_dp(ic)/Cp_Air/onebg
         if ( do_liq_num ) then
!=======================================================================
!     yim's CONVECTIVE NUCLEATION
!=======================================================================

!Use aerosol at cloud base.

!An assumption which treats ss and oc as sulfate
!convert SO4 to AS
!convert OC to OM
           totalmass(1)=aerosolmass(k,1)
           totalmass(2)=aerosolmass(k,2)
           totalmass(3)=aerosolmass(k,3)
 
           call aer_ccn_act(t(k),p(k),up_conv,totalmass,drop)
           zzl=drop*1.0e6/dens(k)

!YM choose not to do above-cloud activation for the sake of computer time
           if ( ic1 <= km1 ) then
             do l = km1,ic1,-1
               totalmass(1)=aerosolmass(l,1)
               totalmass(2)=aerosolmass(l,2)
               totalmass(3)=aerosolmass(l,3)
 
               tc=thetac(l)*pi(l)
               te=theta(l)*pi(l)
               Nc=zzl/eta(l+1)
 
               call aer_ccn_act2(t(l),p(l),up_conv,totalmass,alm,dens(l),  &
                                 Nc,qc(l),qt(l),qol(l),tc,te,drop)
                                 zzl=zzl+drop*1.0e6/dens(l)*(eta(l)-eta(l+1))
             end do
           end if



           Dncu(ic) = Dncu(ic) + zzl*(1.0-rn_frac)* &
           cp_by_dp(ic)/Cp_Air/onebg
         endif ! end of warm_cloud_aerosol interaction
      end if
          wdet = 0.0

  end if

!=======================================================================
!     CALCULATE GH
!=======================================================================

   xx1 = hol(ic)
 if ( lcase2 ) then
   xx1 = xx1 + ( sic - hic + qol(ic) * Hl ) * ( cp_by_dp(ic) / Cp_Air )
 end if

   hol(ic) = xx1 - ( wdet * Hl * cp_by_dp(ic) / Cp_Air )

 if ( lcase1 ) then
   akm = akm - eta(ic1) * ( pi_int(ic1) - pi(ic) ) * xx1 / pi(ic)
 end if

    xx2    = qol(km1) - qol(k)
    gmh(k) = hol(k) + ( xx2 * cp_by_dp(k) * Hl * 0.5 / Cp_Air )
    akm    = akm + gam(km1) * ( pi_int(k) - pi(km1) ) * gmh(k)

 if ( ic1 <= km1 ) then
 do l = km1,ic1,-1
     xx3    = xx2
     xx2    = ( qol(l-1) - qol(l) ) * eta(l)
     xx3    = xx3 + xx2
     gmh(l) = hol(l) + ( xx3 * cp_by_dp(l) * Hl * 0.5 / Cp_Air )
 end do
 end if

 if ( lcase2 ) then
    xx2 = xx2 + 2.0 * ( hkb - dhic - sic - qol(ic) * Hl ) / Hl
 end if

  gmh(ic) = xx1 + cp_by_dp(ic) * onebcp * ( xx2 * Hl * 0.5 + eta(ic) * dhic )

!=======================================================================
!     CALCULATE HC PART OF AKM
!=======================================================================

 if ( ic1 <= km1 ) then
    xx1 = gmh(k)
 do  l = km1,ic1,-1
   xx1 = xx1 + ( eta(l) - eta(l+1) ) * gmh(l)
   xx2 = gam(l-1) * ( pi_int(l) - pi(l-1) )
   if ( lcase2 .and. ( l == ic1 ) ) xx2 = 0.0
   akm = akm + xx1 * ( xx2 + gam(l) * ( pi(l) - pi_int(l) ) )
 end do
 end if

!=======================================================================

 if ( lcase2 ) then

      xx1 = 0.5*( pres_int(ic  ) + pres_int(ic1) )   &
          + 0.5*( pres_int(ic+2) - pres_int(ic ) ) * ( 1.0 - ftop )
      xx2 =       pres_int(ic1 )
      xx3 = 0.5*( pres_int(ic1 ) + pres_int(ic+2) )

 if ( ( xx1 >= xx2 ) .and. ( xx1 < xx3 ) ) then
        ftop = 1.0 - ( xx1 - xx2 ) / ( xx3 - xx2 )
         xx4 = cp_by_dp(ic1) / cp_by_dp(ic)
    hol(ic1) = hol(ic1) + hol(ic) * xx4
    gmh(ic1) = gmh(ic1) + gmh(ic) * xx4
    hol(ic)  = 0.0
    gmh(ic)  = 0.0
 else if ( xx1 < xx2 ) then
     ftop = 1.0
 else
     ftop = 0.0
 end if

 end if

!=======================================================================
!   MASS FLUX
!=======================================================================
 
 if ( ( akm < 0.0 ) .and. ( wlq >= 0.0 ) ) then
!jjs
  rasalf = rasal * ( pres_int(ic+1) - puplim ) /      &
                   (     psfc       - puplim )
  if (puplim > psfc) rasalf=0.
  rasalf = MAX( 0.0, rasalf )
!jjs
     wfn = -ftop * wfn * rasalf / akm
 else
     wfn = 0.0
 end if

!    xx1 = ( pres_int(k+1) - pres_int(k) ) * frac
     xx1 = ( psfc          - pres_int(k) ) * frac
     wfn = MIN( wfn, xx1 )

!=======================================================================
!     FOR SAK CLOUDS
!=======================================================================

 if ( Ldacu ) then
   xx1 = wfn * onebg
   do l = ic,k
     Dacu(l) = Dacu(l) * xx1
     Dlcu(l) = Dlcu(l) * xx1
     Dicu(l) = Dicu(l) * xx1
     mccu(l) = mccu(l) * xx1
   end do
   if ( do_liq_num ) then
     xx1 = wfn * onebg
     do l = ic,k
       Dncu(l) = Dncu(l) * xx1
     enddo
   endif           

 end if


 if ( LRcu ) then
      xx1 = wfn * onebg
     do l = ic,k
       do tr = 1,num_ras_tracers
          dtracercu(l,tr) = dtracercu(l,tr) * xx1
       end do
     end do
 end if

 if ( Lmccu .and. .not.Ldacu ) then
      xx1 = wfn * onebg
     do l = ic,k
          mccu(l) = mccu(l) * xx1
     end do
 end if
 
!=======================================================================
!     PRECIPITATION
!=======================================================================

   dpcu =  wlq * wfn * onebg

!=======================================================================
!     THETA AND Q CHANGE DUE TO CLOUD TYPE IC
!=======================================================================
 
    xx1 = wfn * onebcp
    xx2 = wfn * ( 1.0 / Hl )

 do l = ic,k
   dtcu(l) = xx1 * hol(l) / pi(l)
   dqcu(l) = xx2 * ( gmh(l) - hol(l) )
 end do

!=======================================================================
!  CUMULUS FRICTION 
!=======================================================================
 if (cufric) then

    xx1 = 0.5 * wfn * onebcp

! --- At cloud base
    xx2    = xx1 * cp_by_dp(k)
    dut    = ( uwnd(km1) - uwnd(k) )
    dvt    = ( vwnd(km1) - vwnd(k) )
   ducu(k) = dut * xx2
   dvcu(k) = dvt * xx2

! --- Between cloud base & cloud top
 do l = km1,ic1,-1
    xx2    = xx1 * cp_by_dp(l)
    dub    = dut
    dvb    = dvt
    dut    = ( uwnd(l-1) - uwnd(l) ) * eta(l)
    dvt    = ( vwnd(l-1) - vwnd(l) ) * eta(l)
   ducu(l) = ( dut + dub ) * xx2
   dvcu(l) = ( dvt + dvb ) * xx2
 end do

! --- At cloud top
    xx2      =   xx1 * cp_by_dp(ic)
    ducu(ic) = ( dut + uht + uht ) * xx2
    dvcu(ic) = ( dvt + vht + vht ) * xx2

  end if

!=======================================================================
  end SUBROUTINE RAS_CLOUD

!#####################################################################
!#####################################################################

  SUBROUTINE COMP_LCL( t_parc, q_parc, p_parc, pres, k_lcl )

!=======================================================================
! ***** COMPUTE LCL ( CLOUD BASE )
!=======================================================================
!---------------------------------------------------------------------
! Arguments (Intent in)
!       t_parc   Initial parcel temperature
!       q_parc   Initial parcel mixing ratio
!       p_parc   Initial parcel pressure
!       pres     Pressure in colunm
!---------------------------------------------------------------------
  real, intent(in), dimension(:,:)   :: t_parc, q_parc, p_parc
  real, intent(in), dimension(:,:,:) :: pres

!---------------------------------------------------------------------
! Arguments (Intent out)
!       k_lcl   Index of LCL in column
!---------------------------------------------------------------------
  integer, intent(out), dimension(:,:) :: k_lcl

!---------------------------------------------------------------------
!  (Intent local)
!---------------------------------------------------------------------

  real, dimension(size(t_parc,1),size(t_parc,2)) :: &
        qsat, rhum, chi, p_lcl

  integer :: k, kmax, k_lcl_min

!=====================================================================

! --- Index of lowest level
  kmax = size( pres, 3 )

! --- Compute relative humidity
  call compute_qs (t_parc, p_parc, qsat, q = q_parc)
  rhum(:,:) = q_parc(:,:) / qsat(:,:)
  rhum(:,:) = MIN( rhum(:,:), 1.0 )

! --- Compute exponent
   chi(:,:) = t_parc(:,:) / ( 1669.0 - 122.0*rhum(:,:) - t_parc(:,:) )

! --- Compute pressure at LCL
    rhum(:,:) =    chi(:,:) * LOG( rhum(:,:) )
   p_lcl(:,:) = p_parc(:,:) * EXP( rhum(:,:) )

! --- Bound p_lcl 
  p_lcl(:,:) = MAX( p_lcl(:,:), pres(:,:,1) )
  p_lcl(:,:) = MIN( p_lcl(:,:), p_parc(:,:) )

! --- Find index of LCL
  do k = 2,kmax
  where ( ( p_lcl(:,:) >= pres(:,:,k-1) ) .and. &
          ( p_lcl(:,:) <= pres(:,:,k) ) )
     k_lcl(:,:) = k
  end where
  end do

! --- Bound k_lcl
  k_lcl_min  = kmax / 2
  k_lcl(:,:) = MAX( k_lcl(:,:), k_lcl_min )

!=====================================================================
  end SUBROUTINE COMP_LCL

!#######################################################################
!#######################################################################

 SUBROUTINE RAS_CEVAP ( type,     temp,      qvap,   pres,   mass,  &
                        qvap_sat, dqvap_sat, psfc,   hl,     dtime, &
                        ksfc,     dpcu,      dtevap, dqevap, dpevap, &
                        flxprec_ib, flxprec_ib_evap )

!=======================================================================
! EVAPORATION OF CONVECTIVE SCALE PRECIP         
!=======================================================================
!---------------------------------------------------------------------
! Arguments (Intent in)
!     type  - cloud type index
!     temp  - Temperature
!     qvap  - Water vapor
!     pres  - Pressure
!     mass  - Mass of layers
!     qvap_sat - Saturation value of qvap
!     dqvap_sat - Temperature derivative of qvap_sat
!     psfc  - surface presure
!     hl    - proper latent heat for the column
!     dtime - size of time step in seconds
!     ksfc  - index of lowest model level
!     dpcu - Precip in mm
!---------------------------------------------------------------------

  integer, intent(in) :: type
  real,    intent(in) :: dtime

  real,    intent(in), dimension(:) :: temp, qvap, pres, mass
  real,    intent(in), dimension(:) :: qvap_sat, dqvap_sat
  real,    intent(in)               :: psfc, hl, dpcu
  integer, intent(in)               :: ksfc

!---------------------------------------------------------------------
! Arguments (Intent out)
!     dtevap - Temperature change due to precip evap
!     dqevap - Water vapor change due to precip evap
!     dpevap - Amount of precip evaporated
!---------------------------------------------------------------------
  real, intent(out), dimension(:) :: dtevap, dqevap
  real, intent(out)               :: dpevap
  real, intent(out), dimension(:) ::  &
                flxprec_ib,    & ! precipation flux profile for cloud ib
                flxprec_ib_evap  ! evaporaton of precip profile for cloud id
                                 ! [kg/m2/s]

!---------------------------------------------------------------------
!  (Intent local)
!---------------------------------------------------------------------

  real, parameter :: cem  = 0.054
  real, parameter :: ceta = -544.0E-6

  real, dimension(size(temp,1)) ::  temp_new, qvap_new

  real    :: prec, def, evef
  real    :: prec_mmph, pfac, emx
  integer :: itopp1, kmax, k
  real    :: totalprecip

!=======================================================================

  kmax   = size(temp(:))
  itopp1 = type + 1
  flxprec_ib =0.0
  flxprec_ib_evap =0.0

! --- Initalize
  dpevap   = 0.0
  qvap_new = qvap
  temp_new = temp

!=======================================================================

  do k = itopp1,kmax
!-----------------------------------------

! --- Compute whats available for evaporation 
   prec = MAX(dpcu - dpevap, 0.0 )

! --- Compute precipitation efficiency factor
  prec_mmph = prec * 3600.0 / dtime
  pfac      = SQRT( pres(k) / psfc )
  emx       = SQRT( cem * cfrac * prec_mmph * pfac )   
  evef      = 1.0 - EXP( ceta * dtime * emx ) 
  def=0.

! --- Evaporate precip where needed
  if ( ( hcevap*qvap_sat(k) >= qvap(k) ) .and.  &
          ( prec            > 0.0      ) .and.  &
          ( ksfc            > k        ) ) then
            def = ( hcevap*qvap_sat(k) - qvap(k) ) /    &
                  ( 1.0 + (hl * hcevap * dqvap_sat(k) / Cp_Air ) )
            def = evef*def
            def = MIN( def, prec/mass(k) )
    qvap_new(k) = qvap(k) + def
    temp_new(k) = temp(k) - (def * hl/Cp_Air)
         dpevap = dpevap + def * mass(k)
    flxprec_ib_evap(k) = def * mass(k)/dtime
  end if

!-----------------------------------------
  end do   ! itopp1
!
!-------compute precipitation flux at each model layer
! by deducting the evaporation in each layer  from 
! cloud top to surface/lowest model layer
!

  totalprecip = dpcu         ! precipitation at cloud top
!
  flxprec_ib(type) = MAX(totalprecip,0.0)/dtime
  do k = itopp1,kmax
    flxprec_ib(k) = MAX((totalprecip - flxprec_ib_evap(k)*dtime),0.0)/dtime
    totalprecip =   totalprecip - flxprec_ib_evap(k)*dtime

!-----------------------------------------
  end do


! --- Changes to temperature and water vapor from evaporation
  dtevap(:) = temp_new(:) - temp(:) 
  dqevap(:) = qvap_new(:) - qvap(:) 

!=======================================================================
  end SUBROUTINE RAS_CEVAP

!#######################################################################
!#######################################################################

 SUBROUTINE RAS_CLOUD_INDEX ( ic, ncmax )

!=======================================================================
! Set order in which clouds are to be done                   
!=======================================================================
!---------------------------------------------------------------------
! Arguments (Intent out)
!       ic      Cloud order index
!       ncmax   Max number of clouds
!---------------------------------------------------------------------
 integer, intent(out), dimension(:) :: ic
 integer, intent(out) :: ncmax

!---------------------------------------------------------------------
!  (Intent local)
!---------------------------------------------------------------------

 integer :: kmax
 integer :: km1, kcr, kfx, nc, irnd

!=======================================================================

 kmax = size( ic(:) )

 km1   = kmax  - 1
 kcr   = MIN( km1, krmax )
 kfx   = km1 - kcr
 ncmax = kfx + ncrnd

! --- Sequential clouds
  if ( kfx > 0) then
     if ( botop ) then
! --- bottom to top
       do nc = 1,kfx
          ic(nc) = kmax - nc
       end do
     else
! --- top to bottom
       do nc = kfx,1,-1
          ic(nc) = kmax - nc
       end do
     endif
  endif

! --- set non-used clouds to zero
  ic((kfx+1):kmax) = 0

! --- Random clouds
 if ( ncrnd > 0 ) then
     do nc = 1,ncrnd
       irnd      = ( RAN0(iseed) - 0.0005 ) * ( kcr - krmin + 1 )
       ic(kfx+nc) = irnd + krmin
     end do
  endif

!=======================================================================
  end SUBROUTINE RAS_CLOUD_INDEX 

!#####################################################################
!#####################################################################


 SUBROUTINE RAS_CLOUD_EXIST( k,      qvap,   qsat, theta,    &
                             pifull, pihalf, nc,   ncmax,    &
                             Hl,     exist  )
!=======================================================================
 implicit none
!=======================================================================

 integer, intent(in)               :: k, ncmax
 real,    intent(in)               :: Hl
 integer, intent(in), dimension(:) :: nc 
 real,    intent(in), dimension(:) :: qvap, qsat, theta, pifull, pihalf 

 logical, intent(out) :: exist

!---------------------------------------------------------------------
 real, parameter :: rhmax  = 0.9999 

 real, dimension(size(theta(:))) :: ssl, hst
 real                         :: zzl, hol_k, qol_k
 integer                      :: km1, ic, ic1, l

!=======================================================================

 ic  = MINVAL( nc(1:ncmax) )

 km1 = k  - 1
 ic1 = ic + 1

! --- at cloud base
    qol_k = MIN( qsat(k) * rhmax, qvap(k) )
    ssl(k) = pihalf(k+1) * theta(k) * Cp_Air 
    hol_k  = ssl(k) +  qol_k  * Hl
    hst(k) = ssl(k) + qsat(k) * Hl
    zzl    = ( pihalf(k+1) - pihalf(k) ) * theta(k) * Cp_Air

! --- between cloud base & cloud top
 do l = km1,ic1,-1
    ssl(l) = zzl + pihalf(l+1) * theta(l) * Cp_Air 
    hst(l) = ssl(l) + qsat(l) * Hl
    zzl    = zzl + ( pihalf(l+1) - pihalf(l) ) * theta(l) * Cp_Air    
 end do

! --- at cloud top
    ssl(ic) = zzl  + pihalf(ic1) * theta(ic) * Cp_Air 
    hst(ic) = ssl(ic) + qsat(ic) * Hl

! --- test
    exist = hol_k > MINVAL( hst(ic:k) )

!=======================================================================
 end SUBROUTINE RAS_CLOUD_EXIST

!#####################################################################
!#####################################################################

  SUBROUTINE RAS_BDGT ( precip, coldT, dtemp, dqvap, duwnd, dvwnd, &
                        pres_int, dql, dqi)

!=====================================================================
! ***** BUDGET CHECK FOR RAS - A DEBUGGING TOOL
!=====================================================================
!---------------------------------------------------------------------
! Arguments (Intent in)
!       precip   - either rain or snow
!       coldT    - is the precip snow?
!       dtemp    - Temperature change 
!       dqvap    - Water vapor change 
!       duwnd    - U wind change 
!       dvwnd    - V wind change 
!       pres_int - Pressure at layer interface
!       dql      - OPTIONAL, liquid change
!       dqi      - OPTIONAL, ice change
!---------------------------------------------------------------------
  real, intent(in), dimension(:,:,:) :: dtemp, dqvap, duwnd, dvwnd, pres_int
  real, intent(in), dimension(:,:)   :: precip
  logical, intent(in), dimension(:,:):: coldT
  real, intent(in), optional, dimension(:,:,:) :: dql, dqi
!---------------------------------------------------------------------
!  (Intent local)
!---------------------------------------------------------------------

 integer :: imax, jmax, kmax, i, j, k
 real    :: sum_dtemp, sum_dqvap, sum_duwnd, sum_dvwnd
 real    :: dqvap_prec, dqvap_dtemp
 real , dimension(size(dtemp,1),size(dtemp,2),size(dtemp,3)) :: mass
 
!=====================================================================

  imax = size ( dtemp, 1 )
  jmax = size ( dtemp, 2 )
  kmax = size ( dtemp, 3 )

  mass(:,:,1:kmax) = pres_int(:,:,2:kmax+1) - pres_int(:,:,1:kmax)
  mass = mass / Grav

  do j = 1,jmax
  do i = 1,imax

    sum_dtemp = 0.                                                          
    sum_dqvap = 0. 
    sum_duwnd = 0. 
    sum_dvwnd = 0. 

  do k = 1,kmax
    sum_dtemp = sum_dtemp + dtemp(i,j,k)*mass(i,j,k)                                   
    sum_dqvap = sum_dqvap + dqvap(i,j,k)*mass(i,j,k)  
    sum_duwnd = sum_duwnd + duwnd(i,j,k)*mass(i,j,k)  
    sum_dvwnd = sum_dvwnd + dvwnd(i,j,k)*mass(i,j,k)
  end do

    dqvap_prec  = sum_dqvap + precip(i,j)
     
    if (present(dql)) then
  do k = 1,kmax
    dqvap_prec = dqvap_prec + (dql(i,j,k)+dqi(i,j,k))*mass(i,j,k)      
  end do
    end if  

     if (coldT(i,j)) then
     dqvap_dtemp = sum_dqvap + Cp_Air*sum_dtemp/HLs
     else
     dqvap_dtemp = sum_dqvap + Cp_Air*sum_dtemp/HLv
     end if

   if ( ( abs( dqvap_prec  ) > 1.0E-4 ) .or.     &
        ( abs( dqvap_dtemp ) > 1.0E-4 ) .or.     &
        ( abs( sum_duwnd   ) > 1.0E-1 ) .or.     &      
        ( abs( sum_dvwnd   ) > 1.0E-1 ) )  then
    print *
    print *, ' RAS BUDGET CHECK AT i,j = ', i,j
    print *, ' dqvap + (Cp_Air/hl)*dtemp = ',  dqvap_dtemp                                                                     
    print *, ' dqvap + precip        = ',  dqvap_prec                                                                     
    print *, ' duwnd                 = ',  sum_duwnd                                                                    
    print *, ' dvwnd                 = ',  sum_dvwnd                                                                     
    print *, 'STOP'
!    STOP
   CALL ERROR_MESG( 'RAS_BDGT', 'RAS budget thresholds exceeded.', FATAL )
   endif

  end do
  end do

!=====================================================================
  end SUBROUTINE RAS_BDGT

!#######################################################################
!#######################################################################

FUNCTION ran0(idum)


!     $Id: ras.F90,v 19.0 2012/01/06 20:11:58 fms Exp $
!     Platform independent random number generator from
!     Numerical Recipies
!     Mark Webb July 1999
      
      REAL :: ran0
      INTEGER, INTENT (INOUT) :: idum
      
      INTEGER :: IA,IM,IQ,IR,k
      REAL :: AM

      IA=16807; IM=2147483647; AM=1.0/IM; IQ=127773; IR=2836
      
      if (idum.eq.0) then
        CALL ERROR_MESG( 'ran0', 'idum=0, ZERO seed not allowed.', FATAL )
      endif

      k=idum/IQ
      idum=ia*(idum-k*iq)-ir*k
      if (idum.lt.0) idum=idum+im
      ran0=am*idum

END FUNCTION ran0

!#######################################################################
!#######################################################################
  end MODULE RAS_MOD

#include "cosp_defs.H"

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.



module cosp_diagnostics_mod

use mpp_mod,                  only: input_nml_file
use fms_mod,                  only: open_namelist_file, open_file,  &
                                    close_file, error_mesg, FATAL, &
                                    file_exist, mpp_pe, mpp_root_pe,   &
                                    check_nml_error, write_version_number,&
                                    stdlog
use time_manager_mod,         only: set_date, time_type, operator (+), &
                                    operator(-), operator(<),    &
                                    operator(>), operator(<=), &
                                    operator(>=),  get_date, print_date, &
                                    get_calendar_type, NOLEAP, &
                                    assignment(=), set_time
use diag_grid_mod,            only: get_local_indexes2
use diag_manager_mod,         only: register_diag_field, send_data,  &
                                    diag_axis_init, register_static_field
USE MOD_COSP_TYPES,           only: cosp_config, cosp_gridbox,   &
                                    cosp_subgrid, cosp_sgradar,  &
                                    cosp_sglidar, cosp_isccp, &
#ifdef RTTOV
                                    cosp_rttov, &
#endif
                                    cosp_vgrid, cosp_radarstats,  &
                                    cosp_lidarstats, &
                                    cosp_sghydro,  cosp_misr, &
                                    construct_cosp_vgrid,  &
                                    free_cosp_vgrid
USE MOD_COSP_IO,              only: map_point_to_ll            
                       
use MOD_COSP_CONSTANTS,       only: DBZE_BINS,SR_BINS, PARASOL_NREFL,  &
                                    PARASOL_SZA, CFAD_ZE_MIN,    &
                                    CFAD_ZE_WIDTH, &
                                    LIDAR_UNDEF, ISCCP_PC_BNDS, ISCCP_TAU,&
                                    I_LSCLIQ, I_LSCICE, I_CVCLIQ,   &
                                    I_CVCICE, I_LSGRPL, &
                                    I_LSRAIN, I_LSSNOW, I_CVRAIN,   &
                                    I_CVSNOW, &
                                    N_HYDRO, ISCCP_TAU_BNDS,&
                                    RTTOV_MAX_CHANNELS, MISR_N_CTH,  &
                                    MISR_CTH_BNDS
use MOD_LMD_IPSL_STATS,       only: define_srbval
use MOD_COSP_Modis_Simulator, only: COSP_MODIS
use mod_modis_sim,            only: numTauHistogramBins,   &
                                    numPressureHistogramBins, &
                                    tauHistogramBoundaries, &
                                    nominalTauHistogramBoundaries, &
                                    nominalTauHistogramCenters, &
                                    nominalPressureHistogramBoundaries
use mod_cosp_utils,           only: flip_vert_index

IMPLICIT NONE

public cosp_diagnostics_init, output_cosp_fields, cosp_diagnostics_end, &
       cosp_diagnostics_time_vary, cosp_diagnostics_endts

!---------------------------------------------------------------------
!----------- version number for this module --------------------------

character(len=128)  :: version =  '$Id $'
character(len=128)  :: tagname =  '$Name $'

!---------------------------------------------------------------------
!namelist variables

logical :: output_p_and_z_by_index = .false.
logical :: generate_orbital_output = .false.
character (len = 128) :: orbital_filename =  '  '
integer, dimension(6) :: sat_begin_time = (/0,0,0,0,0,0/)
integer :: sat_period     = 0  ! [seconds]
integer :: num_sat_periods = 0
integer :: max_sdgs_per_sat_period = 3500

namelist/cosp_diagnostics_nml/ output_p_and_z_by_index, &
                    generate_orbital_output, orbital_filename, &
                    sat_begin_time, sat_period, num_sat_periods, &
                    max_sdgs_per_sat_period

! Local variables

character(len=16)       :: mod_name = 'cosp'

integer, dimension(14)  :: cosp_axes

integer :: id_lat, id_lon, id_p, id_ph, id_z, id_zh, id_T, id_sh, &
           id_u_wind, id_v_wind, id_mr_ozone, &
           id_tot_h2o, &
           id_rh, id_tca, id_cca, id_lsliq, id_lsice, id_ccliq, &
           id_ccice, id_fl_lsrain, id_fl_lssnow, id_fl_lsgrpl, &
           id_fl_ccrain, id_fl_ccsnow, &
           id_reff_lsclliq, id_reff_lsclice, &
           id_reff_lsprliq, id_reff_lsprice, &
           id_reff_ccclliq, id_reff_ccclice, &
           id_reff_ccprliq, id_reff_ccprice, &
           id_reff_lsclliq_cmip, id_reff_ccclliq_cmip, &
           id_lsca_cmip, id_cca_cmip, &
           id_dtau_s, id_dtau_c, id_dem_s, id_dem_c, id_skt, id_land, &
           id_sfcht, id_sunlit
integer :: id_cltcalipso_sat, id_cllcalipso_sat, id_clmcalipso_sat,  &
           id_clhcalipso_sat
integer :: id_cltcalipso, id_cllcalipso, id_clmcalipso, id_clhcalipso, &
           id_cltlidarradar, id_tclisccp, id_ctpisccp, id_tauisccp, &
           id_tbisccp, id_tbclrisccp, &
           id_betamol532, &
           id_albisccp, id_clcalipso, id_clcalipso2, &
           id_clcalipso_sat, id_clcalipso2_sat, &
           id_clcalipso_mdl, id_clcalipso2_mdl, &
           id_boxtauisccp, id_boxptopisccp, id_parasolrefl, &
           id_parasolrefl_sat, &
           id_sampling_sat, id_location_sat, id_lat_sat, id_lon_sat
integer :: id_tclmodis, id_lclmodis, id_iclmodis, id_ttaumodis, &
           id_ltaumodis, id_itaumodis, id_tlogtaumodis, &
           id_llogtaumodis, id_ilogtaumodis, id_lremodis, &
           id_badlremodis, id_badiremodis, &
           id_locldmodis, id_mdcldmodis, id_hicldmodis, &
           id_iremodis, id_ctpmodis, id_lwpmodis, id_iwpmodis
integer, allocatable, dimension(:) :: id_dbze94, id_cloudsatcfad, &
                                      id_cloudsatcfad_sat, &
                                      id_atb532, id_calipsosrcfad, &
                                      id_calipsosrcfad_sat, &
                                      id_cloud_type, id_boxtauisccp_n, &
                                      id_boxptopisccp_n, &
                                      id_taumodis_n, id_ptopmodis_n, &
                                      id_badsizemodis_n, &
                                      id_sizemodis_n, id_phasemodis_n
integer, allocatable, dimension(:) :: id_cloudsatcfad_mdl, &
                                      id_calipsosrcfad_mdl
integer , dimension(7)            :: id_clisccp
integer , dimension(7,7)          :: id_clisccp_n
integer , dimension(MISR_N_CTH)   :: id_misr    
integer , dimension(7,MISR_N_CTH) :: id_misr_n
integer , dimension(numTauHistogramBins, numPressureHistogramBins) ::  &
                                                         id_tauctpmodis_n
integer , dimension(numPressureHistogramBins) :: id_tauctpmodis

real  :: missing_value = -1.0E30

real, dimension(:,:,:), allocatable        :: location   
logical, dimension(:,:,:), allocatable     :: lflag_array
logical, dimension(:,:,:,:), allocatable   :: lflag_array_temp, &
                                              lflag_array_parasol
real, dimension(:,:,:), allocatable        :: flag_array
type(time_type), dimension(:), allocatable :: Time_start, Time_end
integer   :: imax, jmax, nlr, nlevels, ncolumns
integer   :: nsat_time_prev
integer   :: nsat_time
logical   :: use_vgrid, csat_vgrid

!---------------- End of declaration of variables --------------

include 'netcdf.inc'

contains

!######################################################################

subroutine cosp_diagnostics_init     &
             (imax_in, jmax_in, Time, axes, nlevels_in, ncolumns_in, cfg, &
              use_vgrid_in, csat_vgrid_in, nlr_in)       

type(time_type), intent(in) :: Time
integer, dimension(4), intent(in) :: axes
integer, intent(in) :: imax_in, jmax_in           
integer, intent(in) :: nlevels_in, ncolumns_in
logical, intent(in) :: use_vgrid_in
type(cosp_config), intent(in) :: cfg   ! Configuration options
logical, intent(in) :: csat_vgrid_in
integer, intent (in) :: nlr_in

   integer :: io, unit, ierr, logunit

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=cosp_diagnostics_nml, iostat=io)
    ierr = check_nml_error(io,"cosp_diagnostics_nml")
#else
!---------------------------------------------------------------------
!    read namelist.
!---------------------------------------------------------------------
    if ( file_exist('input.nml')) then
       unit =  open_namelist_file ()
      ierr=1; do while (ierr /= 0)
      read  (unit, nml=cosp_diagnostics_nml, iostat=io, end=10)
      ierr = check_nml_error(io,'cosp_diagnostics_nml')
      enddo
10    call close_file (unit)
    endif
#endif
        
!---------------------------------------------------------------------
!    write namelist to logfile.
!---------------------------------------------------------------------
    call write_version_number(version, tagname)
    logunit = stdlog()
    if (mpp_pe() == mpp_root_pe() )    &
                        write (logunit, nml=cosp_diagnostics_nml)

!----------------------------------------------------------------------
!    save i and j dimensions.
!----------------------------------------------------------------------
    imax = imax_in
    jmax = jmax_in
    nlr = nlr_in
    nlevels = nlevels_in
    ncolumns = ncolumns_in
    use_vgrid = use_vgrid_in
    csat_vgrid = csat_vgrid_in

    if (generate_orbital_output) then
      if (sat_begin_time(1) == 0 .or. sat_begin_time(2) == 0 .or. &
          sat_begin_time(3) ==0) then
        call error_mesg ('cosp_diagnostics_init', &
           'requesting orbital output but not supplying &
                                               &valid start time', FATAL)
      endif
      if (sat_period == 0) then
        call error_mesg ('cosp_diagnostics_init', &
           'satellite sampling period [seconds] must be non-zero', FATAL)
      endif
      if (num_sat_periods == 0) then
        call error_mesg ('cosp_diagnostics_init', &
         'must define number of satellite periods to be processed', FATAL)
      endif
      if (trim(orbital_filename) == '') then
        call error_mesg ('cosp_diagnostics_init', &
              'filename for orbital specification not provided', FATAL)
      endif
    endif

    call diag_field_init (Time, axes, cfg)

    if (generate_orbital_output) then
      allocate (location    (imax,jmax, 1:num_sat_periods))
      allocate (lflag_array (imax,jmax, 0:num_sat_periods))
      allocate (lflag_array_temp (imax,jmax, nlr, 0:num_sat_periods))
      allocate (lflag_array_parasol   &
                            (imax,jmax, PARASOL_NREFL, 0:num_sat_periods))
      allocate (flag_array(imax,jmax,12))
      allocate (Time_start(num_sat_periods))
      allocate (Time_end  (num_sat_periods))
      call read_cloudsat_orbit  
      nsat_time_prev = 1
    endif

end subroutine cosp_diagnostics_init 

!#####################################################################

subroutine diag_field_init (Time, axes, cfg)

type(time_type), intent(in) :: Time
integer, dimension(4), intent(in) :: axes
type(cosp_config), intent(in) :: cfg   ! Configuration options

   real :: column_ax(Ncolumns)
   real :: level_ax(Nlevels )
   real :: isccp_ax(7)           
   real :: modis_ax(numTauHistogramBins)
   real :: dbze_ax(DBZE_BINS)
   real :: lidar_ax(SR_BINS)
   real :: sratio_bounds(2, SR_BINS)
   real :: srbval(SR_BINS)
   real :: csat_ax(NLR)
   real :: month_ax(12)
   real :: hr_ax(num_sat_periods)
   integer :: parasol_ax(PARASOL_NREFL)
   integer, dimension(3) :: halfindx = (/1,2,4/)
   integer, dimension(3) :: columnindx = (/1,2,5/)
   integer, dimension(3) :: levelindx = (/1,2,11/)
   integer, dimension(3) :: parasolindx = (/1,2,6/)
   integer, dimension(3) :: dbzeindx = (/1,2,7/)
   integer, dimension(3) :: lidarindx = (/1,2,8/)
   integer, dimension(3) :: tauindx = (/1,2,9/)
   integer, dimension(3) :: modistauindx = (/1,2,12/)
   integer, dimension(3) :: csatindx = (/1,2,10/)
   integer, dimension(3) :: samplingindx = (/1,2,13/)
   integer, dimension(3) :: samplingindx2 = (/1,2,14/)
   integer :: i, n, m
   integer :: id_columnindx, id_parasolindx, id_dbzeindx, id_lidarindx
   integer :: id_levelindx
   integer :: id_tauindx
   integer :: id_modistauindx
   integer :: id_csatindx
   integer :: id_monindx
   integer :: id_3hrindx
   character(len=2) :: chvers, chvers4
   character(len=8) :: chvers2, chvers3, chvers5, chvers6
   type(cosp_gridbox) :: gbx_t ! Gridbox information. Input for COSP
   type(cosp_vgrid)   :: vgrid_t   ! Information on vertical grid of stats


!--------------------------------------------------------------------
!    define the varisous axes needed for this data.
!--------------------------------------------------------------------
   cosp_axes(1:4) = axes(1:4)

!--------------------------------------------------------------------
! a level counter:
!--------------------------------------------------------------------
   do i=1,Nlevels 
     level_ax(i) = float(i)
   end do
   id_levelindx = diag_axis_init  ('levelindx', level_ax, &
          'levels', 'n', 'level number', & 
           set_name =  mod_name)
   cosp_axes(11) = id_levelindx

!--------------------------------------------------------------------
! a stochastic column counter:
!--------------------------------------------------------------------
   do i=1,Ncolumns
     column_ax(i) = float(i)
   end do
   id_columnindx = diag_axis_init  ('columnindx', column_ax, &
          'subcol', 'n', 'subcolumn number', & 
           set_name =  mod_name)
   cosp_axes(5) = id_columnindx

!--------------------------------------------------------------------
!  a PARASOL index counter:
!--------------------------------------------------------------------
   id_parasolindx = diag_axis_init  ('parasolindx', PARASOL_SZA, &
          'parasolindx', 'n', 'parasol reflectivity index', & 
           set_name =  mod_name)
   cosp_axes(6) = id_parasolindx

!--------------------------------------------------------------------
!  a radar bin counter:
!--------------------------------------------------------------------
   do i=1,DBZE_BINS
      dbze_ax(i) = CFAD_ZE_MIN + CFAD_ZE_WIDTH*(i-0.5)
   end do
   id_dbzeindx = diag_axis_init  ('dbzeindx', dbze_ax, &
          'dbzeindx', 'n', 'dbze', & 
           set_name =  mod_name)
   cosp_axes(7) = id_dbzeindx

!--------------------------------------------------------------------
!  a lidar bin counter:
!--------------------------------------------------------------------

   call define_srbval (srbval)

   sratio_bounds(1,:) = srbval(:)
   sratio_bounds(2,1:SR_BINS-1) = srbval(2:SR_BINS)
   sratio_bounds(2,SR_BINS) = srbval(SR_BINS) +10.0
   lidar_ax(1:SR_BINS) = (sratio_bounds(1,1:SR_BINS) +    &
                                           sratio_bounds(2,1:SR_BINS))/2.0
   id_lidarindx = diag_axis_init  ('lidarindx', lidar_ax, &
          'lidarindx', 'n', 'lidar scattering', & 
           set_name =  mod_name)
   cosp_axes(8) = id_lidarindx

!--------------------------------------------------------------------
!  an isccp tau bin counter:
!--------------------------------------------------------------------
   isccp_ax = isccp_tau
   id_tauindx = diag_axis_init  ('tauindx', isccp_ax, &
          'tauindx', 'n', 'isccp tau category', & 
           set_name =  mod_name)
   cosp_axes(9) = id_tauindx

!--------------------------------------------------------------------
!  a modis tau bin counter:
!--------------------------------------------------------------------
   modis_ax = nominalTauHistogramCenters
   id_modistauindx = diag_axis_init  ('modistauindx', modis_ax, &
          'modistauindx', 'n', 'modis tau category', &
           set_name =  mod_name)
   cosp_axes(12) = id_modistauindx

!--------------------------------------------------------------------
!  a specified vertical index needed when use_vgrid = .true. 
!--------------------------------------------------------------------
   gbx_t%Npoints = 256       
   gbx_t%Ncolumns = ncolumns    
   gbx_t%Nlevels = Nlevels
   allocate(gbx_t%zlev(256    , nlevels))
   allocate(gbx_t%zlev_half(256    , nlevels))
   gbx_t%zlev = 0.0
   gbx_t%zlev_half = 0.0
   call construct_cosp_vgrid(gbx_t,Nlr,use_vgrid,csat_vgrid,vgrid_t)
   csat_ax = vgrid_t%z
   id_csatindx = diag_axis_init  ('csatindx', csat_ax, &
          'csatindx', 'z', 'csat vert index', & 
           set_name =  mod_name)
   cosp_axes(10) = id_csatindx
   deallocate (gbx_t%zlev, gbx_t%zlev_half) 
   call free_cosp_vgrid (vgrid_t)
   do i=1,12
     month_ax(i) = i
   end do
   id_monindx = diag_axis_init  ('samplingindx', month_ax, &
          'samplingindx', 'n', 'month index', & 
           set_name =  mod_name)
   cosp_axes(13) = id_monindx
   
   do i=1,num_sat_periods
     hr_ax(i) = i
   end do
   id_3hrindx = diag_axis_init  ('samplingindx2', hr_ax, &
          'samplingindx2', 'n', '3hr index', & 
           set_name =  mod_name)
   cosp_axes(14) = id_3hrindx
   
!--------------------------------------------------------------------
!    register input fields with diag_manager.
!--------------------------------------------------------------------
   id_lat        = register_diag_field &
      (mod_name, 'lat', axes(1:2), Time, 'Latitude',  'degrees N')

   id_lon        = register_diag_field &
      (mod_name, 'lon', axes(1:2), Time, 'Longitude',  'degrees E')

   id_u_wind     = register_diag_field &
      (mod_name, 'u_wind', axes(1:2), Time, 'sfc u wind',  'm / s')

   id_v_wind     = register_diag_field &
      (mod_name, 'v_wind', axes(1:2), Time, 'sfc v wind',  'm / s')

   if (output_p_and_z_by_index) then
     id_p          = register_diag_field &
       (mod_name, 'p', cosp_axes(levelindx), Time,  &
                                        'P at full levels',  'Pa  ')
     id_ph         = register_diag_field &
       (mod_name, 'ph', cosp_axes(levelindx), Time, &
                                        'p at half levels',  'Pa')
     id_z        = register_diag_field &
       (mod_name, 'z', cosp_axes(levelindx), Time, 'height  ', 'meters')
     id_zh        = register_diag_field &
       (mod_name, 'zh', cosp_axes(levelindx), Time, &
                                      'height at half levs',  'meters')
   else
     id_p          = register_diag_field &
      (mod_name, 'p', axes(1:3), Time, 'P at full levels',  'Pa  ')
     id_ph         = register_diag_field &
      (mod_name, 'ph', axes(halfindx), Time, 'p at half levels',  'Pa')
     id_z        = register_diag_field &
      (mod_name, 'z', axes(1:3), Time,  'height  ',  'meters  ')
     id_zh        = register_diag_field &
      (mod_name, 'zh', axes(halfindx), Time, 'height at half levs', &
                                                              'meters')
   endif

   id_mr_ozone   = register_diag_field &
      (mod_name, 'ozone', axes(1:3), Time, 'Ozone mass mixing ratio', &
                                                   'kg (o3) / kg (air)')

   id_T          = register_diag_field &
      (mod_name, 'T', axes(1:3), Time, 'Temp at full levels',  'deg K ')

   id_sh         = register_diag_field &
      (mod_name, 'sh', axes(1:3), Time, &
        'vapor specific humidity at full levels',  'kg(h2o) / kg(air) ')

   id_rh         = register_diag_field &
      (mod_name, 'relhum', axes(1:3), Time, &
                      'relative humidity at full levels',  'fraction ')

   id_tot_h2o   = register_diag_field &
      (mod_name, 'tot_h2o', axes(1:3), Time, &
                                  'total water substance',  &
                            'kg(h2o) / kg(air) ' )

   id_lsca_cmip       = register_diag_field &
      (mod_name, 'lsca_cmip', axes(1:3), Time, &
                'ls liq cld fraction',  'fraction ', &
                mask_variant = .true., &
                   missing_value = missing_value)

   id_cca_cmip   = register_diag_field &
      (mod_name, 'cca_cmip', axes(1:3), Time, &
                 'convective liq cld fraction',  'fraction ', &
                mask_variant = .true., &
                   missing_value = missing_value)

   id_tca       = register_diag_field &
      (mod_name, 'tca', axes(1:3), Time, &
                                  'total cld fraction',  'fraction ')

   id_cca        = register_diag_field &
      (mod_name, 'cca', axes(1:3), Time, &
                           'convective cld fraction',  'fraction ')

   id_lsliq      = register_diag_field &
      (mod_name, 'lsliq', axes(1:3), Time, &
                                  'large scale cld liq',  'kg / kg  ')

   id_lsice      = register_diag_field &
      (mod_name, 'lsice', axes(1:3), Time, &
                                   'large scale cld ice',  'kg / kg  ')

   id_ccliq      = register_diag_field &
      (mod_name, 'ccliq', axes(1:3), Time, &
                                   'convective  cld liq',  'kg / kg  ')

   id_ccice      = register_diag_field &
      (mod_name, 'ccice', axes(1:3), Time, &
                                   'convective  cld ice',  'kg / kg  ')

   id_fl_lsrain  = register_diag_field &
      (mod_name, 'fl_lsrain', axes(1:3), Time, &
                             'large scale rain flx',  'kg / (m**2 s)')

   id_fl_lssnow  = register_diag_field &
      (mod_name, 'fl_lssnow', axes(1:3), Time, &
                             'large scale snow flx',  'kg / (m**2 s)')

   id_fl_lsgrpl  = register_diag_field &
      (mod_name, 'fl_lsgrpl', axes(1:3), Time, &
                           'large scale graupel flx',  'kg / (m**2 s)')

   id_fl_ccrain  = register_diag_field &
      (mod_name, 'fl_ccrain', axes(1:3), Time, &
                            'cnvctv scale rain flx',  'kg / (m**2 s)')

   id_fl_ccsnow  = register_diag_field &
      (mod_name, 'fl_ccsnow', axes(1:3), Time, &
                            'cnvctv scale snow flx',  'kg / (m**2 s)')

   id_reff_lsclliq_cmip  = register_diag_field &
      (mod_name, 'reff_lsclliq_cmip', axes(1:3), Time, &
           'ls liq cld drop size*cfrac ',  'm', mask_variant = .true., &
                   missing_value = missing_value)

   id_reff_ccclliq_cmip  = register_diag_field &
      (mod_name, 'reff_ccclliq_cmip', axes(1:3), Time, &
         'cv liq cld drop size*cfrac ',  'm', mask_variant = .true., &
                   missing_value = missing_value)

   id_reff_lsclliq  = register_diag_field &
      (mod_name, 'reff_lsclliq', axes(1:3), Time, &
               'ls liq cld drop size ',  'm', mask_variant = .true., &
                   missing_value = missing_value)

   id_reff_lsclice  = register_diag_field &
      (mod_name, 'reff_lsclice', axes(1:3), Time, &
                'ls ice cld drop size ',  'm', mask_variant = .true., &
                   missing_value = missing_value)

   id_reff_lsprliq  = register_diag_field &
      (mod_name, 'reff_lsprliq', axes(1:3), Time, &
                                       'ls liq prcp drop size ',  'm')

   id_reff_lsprice  = register_diag_field &
      (mod_name, 'reff_lsprice', axes(1:3), Time, &
                                        'ls ice prcp drop size ',  'm')

   id_reff_ccclliq  = register_diag_field &
      (mod_name, 'reff_ccclliq', axes(1:3), Time, &
             'cv liq cld drop size ',  'm', mask_variant = .true., &
                   missing_value = missing_value)

   id_reff_ccclice  = register_diag_field &
      (mod_name, 'reff_ccclice', axes(1:3), Time, &
          'cv ice cld drop size ',  'm', mask_variant = .true., &
                   missing_value = missing_value)

   id_reff_ccprliq  = register_diag_field &
      (mod_name, 'reff_ccprliq', axes(1:3), Time, &
                                        'cv liq prcp drop size ',  'm')

   id_reff_ccprice  = register_diag_field &
      (mod_name, 'reff_ccprice', axes(1:3), Time, &
                                        'cv ice prcp drop size ',  'm')

   id_dtau_s  = register_diag_field &
      (mod_name, 'dtau_s', axes(1:3), Time, &
                   'ls cloud optical depth ',  'dimensionless')

   id_dtau_c  = register_diag_field &
      (mod_name, 'dtau_c', axes(1:3), Time, &
                    'cv cloud optical depth ',  'dimensionless')

   id_dem_s  = register_diag_field &
      (mod_name, 'dem_s', axes(1:3), Time, &
                             'ls cloud emissivity ',  'dimensionless')

   id_dem_c  = register_diag_field &
      (mod_name, 'dem_c', axes(1:3), Time, &
                             'cv cloud emissivity  ',  'dimensionless')

   id_skt        = register_diag_field &
      (mod_name, 'skt', axes(1:2), Time, 'skin temp',  'deg K')

   id_sunlit     = register_diag_field &
      (mod_name, 'sunlit', axes(1:2), Time, 'sun is shining?',  'none')

   id_land       = register_diag_field &
      (mod_name, 'land', axes(1:2), Time, 'land frac',  'fraction')

   id_sfcht      = register_diag_field &
      (mod_name, 'sfc_ht', axes(1:2), Time, 'height of surface',   &
                                                             'meters')

!---------------------------------------------------------------------
!    COSP output fields:
!---------------------------------------------------------------------
   allocate (id_dbze94(Ncolumns))
   if (use_vgrid) then
     allocate (id_cloudsatcfad(DBZE_BINS))
     allocate (id_calipsosrcfad(SR_BINS ))
     allocate (id_cloudsatcfad_sat(DBZE_BINS))
     allocate (id_calipsosrcfad_sat(SR_BINS ))
   else
     allocate (id_cloudsatcfad_mdl(DBZE_BINS))
     allocate (id_calipsosrcfad_mdl(SR_BINS ))
   endif
   allocate (id_cloud_type     (Ncolumns ))
   do n=1, size(id_cloud_type,1)
     if (n <= 9) then
       write (chvers, '(i1)') n
     else if (n <=99) then
       write (chvers, '(i2)') n
     else
       call error_mesg ('cosp_driver', &      
        'can not process over 99 levels', FATAL)
     endif
     id_cloud_type(n) = register_diag_field &
         (mod_name, 'cloud_type_' // trim(chvers), axes(1:3), Time, &
           'Cloud type present in column ' // trim(chvers), 'none')
   end do

   if (cfg%Llidar_sim) then
     id_cltcalipso = register_diag_field &
      (mod_name, 'cltcalipso', axes(1:2), Time, &
          'Lidar Total Cloud Fraction',  'percent', &
          mask_variant = .true., missing_value=missing_value)

     id_cllcalipso = register_diag_field &
      (mod_name, 'cllcalipso', axes(1:2), Time, &
          'Lidar Low-level Cloud Fraction',  'percent', &
          mask_variant = .true., missing_value=missing_value)

     id_clmcalipso = register_diag_field &
      (mod_name, 'clmcalipso', axes(1:2), Time, &
          'Lidar Mid-level Cloud Fraction',  'percent', &
          mask_variant = .true., missing_value=missing_value)

     id_clhcalipso = register_diag_field &
      (mod_name, 'clhcalipso', axes(1:2), Time, &
          'Lidar High-level Cloud Fraction',  'percent', &
          mask_variant = .true., missing_value=missing_value)

     if (generate_orbital_output) then

       id_cltcalipso_sat = register_diag_field &
      (mod_name, 'cltcalipso_sat', axes(1:2), Time, &
          'Lidar Total Cloud Fraction',  'percent', &
          mask_variant = .true., missing_value=missing_value)

       id_cllcalipso_sat = register_diag_field &
      (mod_name, 'cllcalipso_sat', axes(1:2), Time, &
          'Lidar Low-level Cloud Fraction',  'percent', &
          mask_variant = .true., missing_value=missing_value)

       id_clmcalipso_sat = register_diag_field &
      (mod_name, 'clmcalipso_sat', axes(1:2), Time, &
          'Lidar Mid-level Cloud Fraction',  'percent', &
          mask_variant = .true., missing_value=missing_value)

       id_clhcalipso_sat = register_diag_field &
      (mod_name, 'clhcalipso_sat', axes(1:2), Time, &
          'Lidar High-level Cloud Fraction',  'percent', &
          mask_variant = .true., missing_value=missing_value)

       id_clcalipso_sat = register_diag_field &
      (mod_name, 'clcalipso_sat', cosp_axes(csatindx), Time, &
       'Lidar Cloud Fraction (532 nm)', 'percent', &
          mask_variant = .true., missing_value=missing_value)

       id_sampling_sat = register_static_field &
      (mod_name, 'sampling_sat', cosp_axes(samplingindx),       &
       'Times sampled by Cloudsat', 'number', &
           missing_value=missing_value)

       id_location_sat = register_static_field &
      (mod_name, 'location_sat', cosp_axes(samplingindx2),       &
       'Satellite location index', 'counter', &
           missing_value=missing_value)

       id_lon_sat = register_diag_field &
      (mod_name, 'lon_sat', axes(1:2),  Time,      &
       'Satellite longitude', 'degrees E', &
          mask_variant = .true.,  missing_value=missing_value)

       id_lat_sat = register_diag_field &
      (mod_name, 'lat_sat', axes(1:2), Time,      &
       'Satellite latitude', 'degrees N', &
      mask_variant = .true.,     missing_value=missing_value)

       id_parasolrefl_sat = register_diag_field &
      (mod_name, 'parasol_refl_sat', cosp_axes(parasolindx), Time, &
      'PARASOL-like mono-directional reflectance', 'fraction', &
          mask_variant = .true., missing_value=missing_value)

     endif

     id_clcalipso = register_diag_field &
      (mod_name, 'clcalipso', cosp_axes(csatindx), Time, &
       'Lidar Cloud Fraction (532 nm)', 'percent', &
          mask_variant = .true., missing_value=missing_value)

     id_clcalipso_mdl = register_diag_field &
      (mod_name, 'clcalipso_mdl', axes(1:3), Time, &
       'Lidar Cloud Fraction (532 nm)', 'percent', &
          mask_variant = .true., missing_value=missing_value)
     id_parasolrefl = register_diag_field &
      (mod_name, 'parasol_refl', cosp_axes(parasolindx), Time, &
      'PARASOL-like mono-directional reflectance', 'fraction', &
          mask_variant = .true., missing_value=missing_value)
     id_betamol532 = register_diag_field &
        (mod_name, 'betamol532', axes(1:3       ), Time, &
           'Lidar Molecular Backscatter (532 nm)', &
           '(m sr)**(-1)', &
          mask_variant = .true., missing_value=missing_value)
     allocate (id_atb532(Ncolumns))
     do n=1, size(id_atb532,1)
       if (n <= 9) then
         write (chvers, '(i1)') n
       else if (n <=99) then
         write (chvers, '(i2)') n
       else
         call error_mesg ('cosp_driver', &      
          'can not process over 99 columns', FATAL)
       endif
       id_atb532(n) = register_diag_field &
        (mod_name, 'atb532_' // trim(chvers), axes(1:3       ), Time, &
           'Lidar Attenuated Total Backscatter (532 nm) column# ' // &
          & trim(chvers), '(m sr)**(-1)', &
          mask_variant = .true., missing_value=missing_value)
     end do

     do n=1, SR_BINS                       
       if (n <= 9) then
         write (chvers, '(i1)') n
       else if (n <=99) then
         write (chvers, '(i2)') n
       else
         call error_mesg ('cosp_driver', &      
          'can not process over 99 levels', FATAL)
       endif
       if (n == 1) then
         write (chvers2, '(f8.2)') -100.0            
       else
         write (chvers2, '(f8.2)') srbval(n-1)
       endif
       write (chvers3, '(f8.2)') srbval(n)
       if (use_vgrid) then
         id_calipsosrcfad(n) = register_diag_field &
          (mod_name, 'calipsosrcfad_' // trim(chvers),  &
            cosp_axes(csatindx ), Time, &
              'Fractional area with Lidar 532 nm Scattering Ratio  &
              &between' // trim(chvers2) // ' and' // trim(chvers3) // &
                    ' -- bin' // trim(chvers),  'fraction', &
                    mask_variant = .true., missing_value=missing_value)
         if (generate_orbital_output) then
           id_calipsosrcfad_sat(n) = register_diag_field &
             (mod_name, 'calipsosrcfad_sat_' // trim(chvers),  &
            cosp_axes(csatindx ), Time, &
              'Fractional area with Lidar 532 nm Scattering Ratio  &
              &between' // trim(chvers2) // ' and' // trim(chvers3) // &
                    ' -- bin' // trim(chvers),  'fraction', &
                    mask_variant = .true., missing_value=missing_value)
         endif
       else
         id_calipsosrcfad_mdl(n) = register_diag_field &
           (mod_name, 'calipsosrcfad_mdl_' // trim(chvers), axes(1:3), &
          Time, 'Fractional area with Lidar 532 nm Scattering Ratio  &
           &between' // trim(chvers2) // ' and' // trim(chvers3) // &
                ' -- bin' // trim(chvers), 'fraction', &
                mask_variant = .true., missing_value=missing_value)
       endif
     end do
   endif  !(Llidar_sim)

 if (cfg%Lradar_sim) then
   do n=1, size(id_dbze94,1)
     if (n <= 9) then
       write (chvers, '(i1)') n
     else if (n <=99) then
       write (chvers, '(i2)') n
     else
       call error_mesg ('cosp_driver', &      
        'can not process over 99 levels', FATAL)
     endif
     id_dbze94(n) = register_diag_field &
       (mod_name, 'dbze94_' // trim(chvers), axes(1:3), Time, &
      'Radar Effective Reflectivity Factor in dBZe (94 GHz) column# ' &
            // trim(chvers), 'dBZe')
   end do

   do n=1, DBZE_BINS              
     if (n <= 9) then
       write (chvers, '(i1)') n
     else if (n <=99) then
       write (chvers, '(i2)') n
     else
       call error_mesg ('cosp_driver', &      
        'can not process over 99 levels', FATAL)
     endif
     write (chvers2, '(i6)') INT(cfad_ze_min + float(n-1)*cfad_ze_width)
     write (chvers3, '(i6)') INT(cfad_ze_min + float(n)*cfad_ze_width)
     if (use_vgrid) then
       id_cloudsatcfad(n) = register_diag_field &
          (mod_name, 'cloudsatcfad_' // trim(chvers),   &
           cosp_axes(csatindx), Time, &
           'Fractional area with radar reflectivity (94 GHz) between ' &
              // trim(chvers2) //  ' and' // trim(chvers3) //  &
               ' dbZe -- bin # '  //  trim(chvers),   'fraction', &
                mask_variant = .true., missing_value=missing_value)
       if (generate_orbital_output) then
         id_cloudsatcfad_sat(n) = register_diag_field &
          (mod_name, 'cloudsatcfad_sat_' // trim(chvers),   &
           cosp_axes(csatindx), Time, &
           'Fractional area with radar reflectivity (94 GHz) between ' &
              // trim(chvers2) //  ' and' // trim(chvers3) //  &
               ' dbZe -- bin # '  //  trim(chvers),   'fraction', &
                mask_variant = .true., missing_value=missing_value)
       endif
     else
       id_cloudsatcfad_mdl(n) = register_diag_field &
           (mod_name, 'cloudsatcfad_mdl_' // trim(chvers), axes(1:3), &
              Time, 'Fractional area with radar reflectivity &
             &(94 GHz) between ' // trim(chvers2) //  ' and' // &
             & trim(chvers3) //  ' dbZe -- bin # '  //  trim(chvers),  &
             'fraction', &
             mask_variant = .true., missing_value=missing_value)
     endif
   end do
 endif ! (Lradar_sim)


 if (cfg%Lradar_sim .and. cfg%Llidar_sim) then
   id_cltlidarradar = register_diag_field &
      (mod_name, 'cltlidarradar', axes(1:2), Time, &
          'Lidar and Radar Total Cloud Fraction',  'percent', &
          mask_variant = .true., missing_value=missing_value)
   id_clcalipso2 = register_diag_field &
      (mod_name, 'clcalipso2', cosp_axes(csatindx), Time, &
'Cloud frequency of occurrence as seen by CALIPSO but not CloudSat', &
         'percent', &
          mask_variant = .true., missing_value=missing_value)

   if (generate_orbital_output) then
     id_clcalipso2_sat = register_diag_field &
      (mod_name, 'clcalipso2_sat', cosp_axes(csatindx), Time, &
'Cloud frequency of occurrence as seen by CALIPSO but not CloudSat', &
         'percent', &
          mask_variant = .true., missing_value=missing_value)
   endif

   id_clcalipso2_mdl = register_diag_field &
      (mod_name, 'clcalipso2_mdl', axes(1:3), Time, &
'Cloud frequency of occurrence as seen by CALIPSO but not CloudSat', &
         'percent', &
          mask_variant = .true., missing_value=missing_value)
 endif !(cfg%Lradar_sim .and. cfg%Llidar_sim) 

 if (cfg%Lisccp_sim) then
   id_tclisccp = register_diag_field &
      (mod_name, 'tclisccp', axes(1:2), Time, &
          'Total Cloud Fraction as Calculated by the ISCCP Simulator', &
          'percent', &
          mask_variant = .true., missing_value=missing_value)

   id_ctpisccp = register_diag_field &
      (mod_name, 'ctpisccp', axes(1:2), Time, &
       'Mean Cloud Top Pressure *CPCT as Calculated by the ISCCP Simulator', &
         'Pa', mask_variant = .true., missing_value=missing_value)

   id_tbisccp = register_diag_field &
      (mod_name, 'tbisccp', axes(1:2), Time, &
       'Mean All-sky 10.5 micron brightness temp -- ISCCP Simulator', &
         'deg K', mask_variant = .true., missing_value=missing_value)

   id_tbclrisccp = register_diag_field &
      (mod_name, 'tbclrisccp', axes(1:2), Time, &
       'Mean Clr-sky 10.5 micron brightness temp -- ISCCP Simulator', &
         'deg K', mask_variant = .true., missing_value=missing_value)

   id_tauisccp = register_diag_field &
      (mod_name, 'tauisccp', axes(1:2), Time, &
       'Mean Optical Depth *CPCT as Calculated by the ISCCP Simulator', &
         'dimensionless', &
          mask_variant = .true., missing_value=missing_value)

   id_albisccp = register_diag_field &
      (mod_name, 'albisccp', axes(1:2), Time, &
       'Mean Cloud Albedo *CPCT as Calculated by the ISCCP Simulator', &
         'fraction', &
          mask_variant = .true., missing_value=missing_value)
   id_boxtauisccp = register_diag_field &
      (mod_name, 'boxtauisccp', cosp_axes(columnindx), Time, &
         'Optical Depth  from the ISCCP Simulator', 'dimensionless', &
          mask_variant = .true., missing_value=missing_value)

   id_boxptopisccp = register_diag_field &
      (mod_name, 'boxptopisccp', cosp_axes(columnindx), Time, &
          'Cloud Top Pressure from the ISCCP Simulator', 'Pa')
   allocate (id_boxtauisccp_n(Ncolumns))
   allocate (id_boxptopisccp_n(Ncolumns))
   do n=1,Ncolumns
     if (n <= 9) then
       write (chvers, '(i1)') n
     else if (n <=99) then
       write (chvers, '(i2)') n
     else
       call error_mesg ('cosp_driver', &      
                   'can not process over 99 levels', FATAL)
     endif

     id_boxtauisccp_n(n) = register_diag_field &
        (mod_name, 'boxtauisccp_' // trim(chvers), axes(1:2), Time, &
          'Optical Depth in stochastic Column' // trim(chvers) //  &
            ' from the ISCCP Simulator', 'dimensionless', &
          mask_variant = .true., missing_value=missing_value)

     id_boxptopisccp_n(n) = register_diag_field &
       (mod_name, 'boxptopisccp_' // trim(chvers), axes(1:2), Time, &
          'Cloud Top Pressure in stochastic column' // trim(chvers)  &
             //' from the ISCCP Simulator', 'Pa', &
          mask_variant = .true., missing_value=missing_value)
   end do
   do n=1,7
     write (chvers, '(i1)') n
     write (chvers2, '(i6)') INT(isccp_pc_bnds(1,n)*1.0e-02)
     write (chvers3, '(i6)') INT(isccp_pc_bnds(2,n)*1.0e-02)
     id_clisccp(n) = register_diag_field &
       (mod_name, 'clisccp_'// trim(chvers), cosp_axes(tauindx), &
          Time, 'ISCP Cld Frac for clouds between ' // trim(chvers2) &
             // ' and' // trim(chvers3) // ' hPa', 'percent', &
                  mask_variant = .true., missing_value=missing_value)
   end do

   do m=1,7
     write (chvers4, '(i1)') m
     write (chvers5, '(f4.1)') isccp_tau_bnds(1,m)
     write (chvers6, '(f8.1)') isccp_tau_bnds(2,m)
     do n=1,7
       write (chvers, '(i1)') n
       write (chvers2, '(i5)') INT(isccp_pc_bnds(1,n)*1.0e-02)
       write (chvers3, '(i5)') INT(isccp_pc_bnds(2,n)*1.0e-02)
       id_clisccp_n(m,n) = register_diag_field &
         (mod_name, 'clisccp_'// trim(chvers4)//'_' // trim(chvers), &
          axes(1:2), Time, 'ISCCP CldFrac - tau between ' // &
           trim(chvers5) // ' and ' // trim(chvers6) //  &
           ' , pr between ' // trim(chvers2) // ' and' // &
             trim(chvers3) // ' hPa',  'percent', &
                mask_variant = .true., missing_value=missing_value)
     end do
   end do
 endif !(Lisccp_sim)

  if (cfg%Lmisr_sim) then
   do n=1,MISR_N_CTH
       if (n <=9) then
       write (chvers, '(i1)') n
       else
       write (chvers, '(i2)') n
       endif
     write (chvers2, '(f6.1)') 1.0e-03*MISR_CTH_BNDS(1,n)
     write (chvers3, '(f6.1)') 1.0E-03*MISR_CTH_BNDS(2,n)
     id_misr(n) = register_diag_field &
       (mod_name, 'misr_'// trim(chvers), cosp_axes(tauindx), &
          Time, 'MISR Cld Frac for clouds with top between ' // trim(chvers2) &
             // ' and' // trim(chvers3) // ' km', 'percent', &
                  mask_variant = .true., missing_value=missing_value)
   end do

   do m=1,7
     write (chvers4, '(i1)') m
     write (chvers5, '(f4.1)') isccp_tau_bnds(1,m)
     write (chvers6, '(f8.1)') isccp_tau_bnds(2,m)
     do n=1,MISR_N_CTH
       if (n <=9) then
       write (chvers, '(i1)') n
       else
       write (chvers, '(i2)') n
       endif
       write (chvers2, '(f6.1)') 1.0e-03*MISR_CTH_BNDS(1,n)
       write (chvers3, '(f6.1)') 1.0e-03*MISR_CTH_BNDS(2,n)
       id_misr_n(m,n) = register_diag_field &
         (mod_name, 'misr_'// trim(chvers4)//'_' // trim(chvers), &
          axes(1:2), Time, 'MISR CldFrac - tau between ' // &
           trim(chvers5) // ' and ' // trim(chvers6) //  &
           ' , top between ' // trim(chvers2) // ' and' // &
             trim(chvers3) // ' km', 'percent', &
                mask_variant = .true., missing_value=missing_value)
     end do
   end do
 endif !(Lmisr_sim)

  if (cfg%Lmodis_sim) then

   id_tclmodis = register_diag_field &
      (mod_name, 'tclmodis', axes(1:2), Time, &
          'Total Cloud Fraction as Calculated by the MODIS Simulator', &
          'percent', &
          mask_variant = .true., missing_value=missing_value)

   id_locldmodis = register_diag_field &
      (mod_name, 'locldmodis', axes(1:2), Time, &
          'Low Cloud Fraction as Calculated by the MODIS Simulator', &
          'percent', &
          mask_variant = .true., missing_value=missing_value)

   id_mdcldmodis = register_diag_field &
      (mod_name, 'mdcldmodis', axes(1:2), Time, &
          'Middle Cloud Fraction as Calculated by the MODIS Simulator', &
          'percent', &
          mask_variant = .true., missing_value=missing_value)

   id_hicldmodis = register_diag_field &
      (mod_name, 'hicldmodis', axes(1:2), Time, &
          'High Cloud Fraction as Calculated by the MODIS Simulator', &
          'percent', &
          mask_variant = .true., missing_value=missing_value)

   id_lclmodis = register_diag_field &
      (mod_name, 'lclmodis', axes(1:2), Time, &
          'Total Liquid Cloud Fraction as Calculated by the MODIS Simulator', &
          'percent', &
          mask_variant = .true., missing_value=missing_value)

   id_iclmodis = register_diag_field &
      (mod_name, 'iclmodis', axes(1:2), Time, &
          'Total Ice Cloud Fraction as Calculated by the MODIS Simulator', &
          'percent', &
          mask_variant = .true., missing_value=missing_value)

   id_ttaumodis = register_diag_field &
      (mod_name, 'ttaumodis', axes(1:2), Time, &
          'Total Optical Thickness*CPCT as Calculated by the MODIS Simulator', &
          'dimensionless', &
          mask_variant = .true., missing_value=missing_value)

   id_ltaumodis = register_diag_field &
      (mod_name, 'ltaumodis', axes(1:2), Time, &
          'Total Liquid Optical Thickness*CPCT as Calculated by the MODIS Simulator', &
          'dimensionless', &
          mask_variant = .true., missing_value=missing_value)

   id_itaumodis = register_diag_field &
      (mod_name, 'itaumodis', axes(1:2), Time, &
          'Total Ice Optical Thickness*CPCT as Calculated by the MODIS Simulator', &
          'dimensionless', &
          mask_variant = .true., missing_value=missing_value)

   id_tlogtaumodis = register_diag_field &
      (mod_name, 'tlogtaumodis', axes(1:2), Time, &
          'Total Log Mean Optical Thickness*CPCT as Calculated by the MODIS Simulator', &
          'dimensionless', &
          mask_variant = .true., missing_value=missing_value)

   id_llogtaumodis = register_diag_field &
      (mod_name, 'llogtaumodis', axes(1:2), Time, &
          'Total Log Mean Liquid Optical Thickness*CPCT as Calculated by the MODIS Simulator', &
          'dimensionless', &
          mask_variant = .true., missing_value=missing_value)

   id_ilogtaumodis = register_diag_field &
      (mod_name, 'ilogtaumodis', axes(1:2), Time, &
          'Total Log Mean Ice Optical Thickness*CPCT as Calculated by the MODIS Simulator', &
          'dimensionless', &
          mask_variant = .true., missing_value=missing_value)

   id_lremodis = register_diag_field &
      (mod_name, 'lremodis', axes(1:2), Time, &
          ' Liquid Water particle Size*CPCT as Calculated by the MODIS Simulator', &
          'm', &
          mask_variant = .true., missing_value=missing_value)

   id_badlremodis = register_diag_field &
      (mod_name, 'badlsizemodis', axes(1:2), Time, &
          ' Flag for liquid size retrieval failure in the MODIS Simulator', &
          '1', &
          mask_variant = .true., missing_value=missing_value)

   id_badiremodis = register_diag_field &
      (mod_name, 'badisizemodis', axes(1:2), Time, &
          ' Flag for ice size retrieval failure in the MODIS Simulator', &
          '1', &
          mask_variant = .true., missing_value=missing_value)

   id_iremodis = register_diag_field &
      (mod_name, 'iremodis', axes(1:2), Time, &
          ' Ice Water particle Size*CPCT as Calculated by the MODIS Simulator', &
          'm', &
          mask_variant = .true., missing_value=missing_value)

   id_ctpmodis = register_diag_field &
      (mod_name, 'ctpmodis', axes(1:2), Time, &
          ' Mean Cloud Top Pressure*CPCT as Calculated by the MODIS Simulator', &
          'Pa', &
          mask_variant = .true., missing_value=missing_value)

   id_lwpmodis = register_diag_field &
      (mod_name, 'lwpmodis', axes(1:2), Time, &
          ' Mean Liquid Water Path*CPCT as Calculated by the MODIS Simulator', &
          'kg / ( m**2)',   &
          mask_variant = .true., missing_value=missing_value)

   id_iwpmodis = register_diag_field &
      (mod_name, 'iwpmodis', axes(1:2), Time, &
          ' Mean Ice Water Path*CPCT as Calculated by the MODIS Simulator', &
          'kg / ( m**2)',  &
          mask_variant = .true., missing_value=missing_value)

   allocate (id_taumodis_n(Ncolumns))
   allocate (id_ptopmodis_n(Ncolumns))
   allocate (id_sizemodis_n(Ncolumns))
   allocate (id_badsizemodis_n(Ncolumns))
   allocate (id_phasemodis_n(Ncolumns))
   do n=1,Ncolumns
     if (n <= 9) then
       write (chvers, '(i1)') n
     else if (n <=99) then
       write (chvers, '(i2)') n
     else
       call error_mesg ('cosp_driver', &      
                   'can not process over 99 levels', FATAL)
     endif

     id_taumodis_n(n) = register_diag_field &
        (mod_name, 'taumodis_' // trim(chvers), axes(1:2), Time, &
          'Optical Depth in stochastic Column' // trim(chvers) //  &
            ' from the MODIS Simulator', 'dimensionless', &
          mask_variant = .true., missing_value=missing_value)

     id_ptopmodis_n(n) = register_diag_field &
       (mod_name, 'ptopmodis_' // trim(chvers), axes(1:2), Time, &
          'Cloud Top Pressure in stochastic column' // trim(chvers)  &
             //' from the MODIS Simulator', 'hPa', &
          mask_variant = .true., missing_value=missing_value)

     id_sizemodis_n(n) = register_diag_field &
        (mod_name, 'sizemodis_' // trim(chvers), axes(1:2), Time, &
          'Particle Size in stochastic Column' // trim(chvers) //  &
            ' from the MODIS Simulator', 'meters', &
          mask_variant = .true., missing_value=missing_value)

     id_badsizemodis_n(n) = register_diag_field &
        (mod_name, 'badsizemodis_' // trim(chvers), axes(1:2), Time, &
          'Particle Size failures in stochastic Column' // trim(chvers) //  &
            ' from the MODIS Simulator', 'meters', &
          mask_variant = .true., missing_value=missing_value)

     id_phasemodis_n(n) = register_diag_field &
        (mod_name, 'phasemodis_' // trim(chvers), axes(1:2), Time, &
          'Phase in stochastic Column' // trim(chvers) //  &
            ' from the MODIS Simulator', 'unitless', &
          mask_variant = .true., missing_value=missing_value)

   end do
   do n=numPressureHistogramBins,1,-1
       if (n <=9) then
       write (chvers, '(i1)') n
       else
       write (chvers, '(i2)') n
       endif
     write (chvers2, '(f8.1)') nominalPressureHistogramBoundaries(1,n)
     write (chvers3, '(f8.1)') nominalPressureHistogramBoundaries(2,n)
     id_tauctpmodis(n) = register_diag_field &
       (mod_name, 'tauctpmodis_'// trim(chvers), cosp_axes(modistauindx), &
          Time, 'MODIS Cld Frac for clouds with top between ' // trim(chvers2) &
             // ' and' // trim(chvers3) // ' Pa', 'percent', &
                  mask_variant = .true., missing_value=missing_value)
   end do

   do m=1,numTauHistogramBins
     write (chvers4, '(i1)') m + 1
     write (chvers5, '(f6.1)') nominalTauHistogramBoundaries(1,m)
     write (chvers6, '(f6.1)') nominalTauHistogramBoundaries(2,m)
     do n=numPressureHistogramBins,1,-1
       if (n <=9) then
       write (chvers, '(i1)') n
       else
       write (chvers, '(i2)') n
       endif
       write (chvers2, '(f8.1)') nominalPressureHistogramBoundaries(1,n)
       write (chvers3, '(f8.1)') nominalPressureHistogramBoundaries(2,n)
       id_tauctpmodis_n(m,n) = register_diag_field &
         (mod_name, 'tauctpmodis_'// trim(chvers4)//'_' // trim(chvers), &
          axes(1:2), Time, 'MODIS CldFrac - tau between ' // &
           trim(chvers5) // ' and ' // trim(chvers6) //  &
           ' , top between ' // trim(chvers2) // ' and' // &
             trim(chvers3) // ' Pa', 'percent', &
                mask_variant = .true., missing_value=missing_value)
     end do
   end do
 endif !(Lmodis_sim)




  end subroutine diag_field_init 

!####################################################################

subroutine cosp_diagnostics_time_vary (Time_diag)

type(time_type), intent(in) :: Time_diag

    integer :: n

      if (generate_orbital_output) then
!----------------------------------------------------------------------
!    determine the time index of the current time in the satellite 
!    orbit data.
!----------------------------------------------------------------------
        do n= nsat_time_prev, num_sat_periods  
          if (Time_diag >= Time_start(n) .and.   &
                                           Time_diag < Time_end(n)) then
            nsat_time = n
            nsat_time_prev = nsat_time
            exit
          else
!   set nsat_time to 0 if current time not within sampling region
            nsat_time = 0
          endif
        end do
      endif



end subroutine cosp_diagnostics_time_vary



!####################################################################

subroutine cosp_diagnostics_endts      

    return

end subroutine cosp_diagnostics_endts

!####################################################################

subroutine output_cosp_fields   &
        (nlon,nlat,npoints, geomode, stlidar, stradar, isccp, modis,   &
         misr, sgradar, sglidar, sg, Time_diag, is, js, cloud_type,   &
         gbx, cfg, phalf_plus, zhalf_plus)

!---------------------------------------------------------------------
!     subroutine output_cosp_fields outputs fields relevant to the
!     cosp ismulator, both input and output.
!---------------------------------------------------------------------

integer,                            intent(in) :: nlon,nlat,npoints
integer,                            intent(in) :: geomode
integer,                            intent(in) :: is, js
type(cosp_config),                  intent(in) :: cfg   
real, dimension(npoints, ncolumns, nlevels),  intent(in) :: cloud_type
type(cosp_lidarstats), intent(in) :: stlidar
type(cosp_radarstats), intent(in) :: stradar
type(cosp_isccp     ), intent(in) :: isccp  
type(cosp_modis     ), intent(in) :: modis
type(cosp_misr      ), intent(in) :: misr   
type(cosp_sgradar   ), intent(in) :: sgradar
type(cosp_sglidar   ), intent(in) :: sglidar
type(cosp_subgrid   ), intent(in) :: sg
type(time_type)      , intent(in) :: Time_diag
type(cosp_gridbox)   , intent(in) :: gbx
real, dimension(nlon,nlat, nlevels+1), intent(in) :: phalf_plus, zhalf_plus

!   local variables:

      logical :: used
      integer :: n, m
      real, dimension(Nlon,Nlat) :: y2, y2save, alpha, y2sunlit 
      real, dimension(Nlon,Nlat) :: y2lsave, y2isave
      real, dimension(Nlon,Nlat,Nlevels) :: y3 
      real, dimension(Nlon,Nlat,Nlevels) :: y31,y32, y33,y34, y35, y36,y37 
      real, dimension(Nlon,Nlat,Nlevels) :: y3a
      real, dimension(Nlon,Nlat,Nlr    ) :: z3 
      real, dimension(Nlon,Nlat,Nlr    ) :: z3a
      real, dimension(Nlon,Nlat,Ncolumns) :: y4 
      real, dimension(Nlon,Nlat,PARASOL_NREFL) :: y5 
      real, dimension(Nlon,Nlat,Ncolumns,Nlevels) :: y6,y6a 
      real, dimension(Nlon,Nlat,Ncolumns,Nlr    ) :: z6,z6a 
      real, dimension(Nlon,Nlat,DBZE_BINS,Nlevels) :: y7,y7a 
      real, dimension(Nlon,Nlat,DBZE_BINS,Nlr    ) :: z7,z7a 
      real, dimension(Nlon,Nlat,SR_BINS,Nlevels) :: y8, y8a
      real, dimension(Nlon,Nlat,SR_BINS,Nlr    ) :: z8, z8a
      real, dimension(Nlon,Nlat,7,7            ) :: y9 
      real, dimension(Nlon,Nlat,numTauHistogramBins,  &
                                      numPressureHistogramBins  ) :: y13
      real, dimension(Nlon,Nlat,numTauHistogramBins+1,  &
                                      numPressureHistogramBins  ) :: y12
      real, dimension(Nlon,Nlat,7,MISR_N_CTH   ) :: y10
      logical, dimension (Nlon,Nlat,Nlevels) :: mask_y3a
      logical, dimension (Nlon,Nlat) :: lmsk
      integer  :: ie, je

     ie = is + nlon -1
     je = js + nlat -1
!----------------------------------------------------------------------
!    output the input fields to COSP. fields must be converted from
!    2d arrays (i,j)
!----------------------------------------------------------------------

!   2D fields:
   call map_point_to_ll (Nlon, Nlat, geomode, x1=gbx%latitude, y2 = y2)
   used = send_data (id_lat       , y2, Time_diag, is, js )
  if (generate_orbital_output) then
   used = send_data (id_lat_sat   , y2, Time_diag, is, js,  mask =  &
                                           lflag_array(is:ie,js:je,nsat_time))
endif

   call map_point_to_ll (Nlon, Nlat, geomode, x1=gbx%longitude, y2 = y2)
   used = send_data (id_lon       , y2, Time_diag, is, js )
  if (generate_orbital_output) then
   used = send_data (id_lon_sat   , y2, Time_diag, is, js,  mask =  &
                                           lflag_array(is:ie,js:je,nsat_time))
endif

   call map_point_to_ll (Nlon, Nlat, geomode, x1=gbx%sunlit, y2 = y2sunlit)
   used = send_data (id_sunlit    , y2sunlit, Time_diag, is, js )

   call map_point_to_ll (Nlon, Nlat, geomode, x1=gbx%skt, y2 = y2)
   used = send_data (id_skt       , y2, Time_diag, is, js )

   call map_point_to_ll (Nlon, Nlat, geomode, x1=gbx%land, y2 = y2)
   used = send_data (id_land      , y2, Time_diag, is, js )

   call map_point_to_ll (Nlon, Nlat, geomode, x1=gbx%u_wind, y2 = y2)
   used = send_data (id_u_wind    , y2, Time_diag, is, js )

   call map_point_to_ll (Nlon, Nlat, geomode, x1=gbx%v_wind, y2 = y2)
   used = send_data (id_v_wind    , y2, Time_diag, is, js )

   call map_point_to_ll (Nlon, Nlat, geomode, x1=gbx%sfc_height, y2 = y2)
   used = send_data (id_sfcht     , y2, Time_diag, is, js )

!   3D fields:

       used = send_data (id_ph    , phalf_plus, Time_diag, is, js, 1 )
       used = send_data (id_zh     , zhalf_plus, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%p,  y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_p         , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%zlev, y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_z         , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%mr_ozone, y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_mr_ozone  , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%T, y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_T         , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%sh, y3 = y3)
   call flip_vert_index    (y3, nlevels,y37   )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%q, y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_rh        , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%tca, y3 = y3)
   call flip_vert_index    (y3, nlevels,y35   )
   used = send_data (id_tca       , y35, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%cca, y3 = y3)
   call flip_vert_index    (y3, nlevels,y36   )
   used = send_data (id_cca       , y36, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%mr_hydro(:,:,I_lscliq), y3 = y3)
   call flip_vert_index    (y3, nlevels,y31   )
   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%mr_hydro(:,:,i_lscice), y3 = y3)
   call flip_vert_index    (y3, nlevels,y32   )
   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%mr_hydro(:,:,i_cvcliq), y3 = y3)
   call flip_vert_index    (y3, nlevels,y33   )
   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%mr_hydro(:,:,I_cvcice), y3 = y3)
   call flip_vert_index    (y3, nlevels,y34   )

   used = send_data (id_lsca_cmip  , y35-y36, Time_diag, is, js, 1, &
                                           mask =  y31 > 0)
   used = send_data (id_cca_cmip  , y36, Time_diag, is, js, 1, &
                                           mask =  y33 > 0)

   used = send_data (id_lsliq     , (y35-y36)*y31/((1.0+y36*(y33+y34))*&
                                       (1+y31)), Time_diag, is, js, 1 )

   used = send_data (id_lsice     , (y35-y36)*y32/((1.0+y36*  &
                            (y33+y34))*(1+y32)), Time_diag, is, js, 1 )

   used = send_data (id_ccliq     , y36*y33/((1.0+y36*(y33+y34))*  &
                                       (1+y33)), Time_diag, is, js, 1 )

   used = send_data (id_ccice     , y36*y34/((1.0+y36*(y33+y34))* &
                                       (1+y34)), Time_diag, is, js, 1 )

  used = send_data (id_sh        , y37/(1.+y36*(y33+y34)),  &
                                                 Time_diag, is, js, 1 )
   used = send_data (id_tot_h2o   , (y37 + (y35-y36)*y31/(1.+y31)+ &
          (y35-y36)*y32/(1.+y32)+y36*(y33/(1.+y33)+y34/(1.+y34)))/ &
                     ((1.0+y36*(y33+y34) )), Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%rain_ls, y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_fl_lsrain , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%snow_ls, y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_fl_lssnow , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%grpl_ls, y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_fl_lsgrpl , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%rain_cv, y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_fl_ccrain , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%snow_cv, y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_fl_ccsnow , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%reff(:,:,i_lscliq),&
                                                             y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a )
   used = send_data (id_reff_lsclliq , 0.5*y3a, Time_diag, is, js, 1, &
                   mask = y31 > 0.0 )
   used = send_data (id_reff_lsclliq_cmip , 0.5*y3a*(y35-y36) , Time_diag, is, js, 1, &
                   mask = y31 > 0.0 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%reff(:,:,i_lscice),&
                                                               y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_reff_lsclice , 0.5*y3a, Time_diag, is, js, 1 , &
                   mask = y32 > 0.0)

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%reff(:,:,i_lsrain),&
                                                               y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_reff_lsprliq , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%reff(:,:,i_lssnow),&
                                                               y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_reff_lsprice , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%reff(:,:,i_cvcliq),&
                                                               y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_reff_ccclliq , 0.5*y3a, Time_diag, is, js, 1 , &
                   mask = y33 > 0.0)
   used = send_data (id_reff_ccclliq_cmip , 0.5*y3a*y36 , Time_diag, is, js, 1 , &
                   mask = y33 > 0.0)

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%reff(:,:,i_cvcice),&
                                                                y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_reff_ccclice , 0.5*y3a, Time_diag, is, js, 1 , &
                   mask = y34 > 0.0)

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%reff(:,:,i_cvrain),&
                                                              y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_reff_ccprliq , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%reff(:,:,i_cvsnow),&
                                                              y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_reff_ccprice , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%dtau_s, y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_dtau_s       , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%dtau_c, y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_dtau_c       , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%dem_s, y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_dem_s       , y3a, Time_diag, is, js, 1 )

   call map_point_to_ll (Nlon, Nlat, geomode, x2=gbx%dem_c, y3 = y3)
   call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_dem_c       , y3a, Time_diag, is, js, 1 )

!---------------------------------------------------------------------
!    process COSP output variables
!---------------------------------------------------------------------

 if (cfg%Llidar_sim) then
   call map_point_to_ll (Nlon, Nlat, geomode, x1=stlidar%cldlayer(:,4),&
                                                               y2 = y2)
   used = send_data (id_cltcalipso,      y2, Time_diag, is, js , &
                                          mask = y2 /= missing_value )

   if (generate_orbital_output) then
     used = send_data (id_cltcalipso_sat,      y2, Time_diag, is, js , &
                                     mask = y2 /= missing_value  .and. &
                                          lflag_array(is:ie,js:je,nsat_time))
   endif

   call map_point_to_ll (Nlon, Nlat, geomode, x1=stlidar%cldlayer(:,1),&
                                                               y2 = y2)
   used = send_data (id_cllcalipso,      y2, Time_diag, is, js , &
                           mask = y2 /= missing_value )

   if (generate_orbital_output) then
     used = send_data (id_cllcalipso_sat,      y2, Time_diag, is, js , &
                                     mask = y2 /= missing_value  .and. &
                                          lflag_array(is:ie,js:je,nsat_time))
   endif

   call map_point_to_ll (Nlon, Nlat, geomode, x1=stlidar%cldlayer(:,2),&
                                                               y2 = y2)
   used = send_data (id_clmcalipso,      y2, Time_diag, is, js , &
                           mask = y2 /= missing_value )

   if (generate_orbital_output) then
     used = send_data (id_clmcalipso_sat,      y2, Time_diag, is, js , &
                                     mask = y2 /= missing_value  .and. &
                                          lflag_array(is:ie,js:je,nsat_time))
   endif

   call map_point_to_ll (Nlon, Nlat, geomode, x1=stlidar%cldlayer(:,3),&
                                                               y2 = y2)
   used = send_data (id_clhcalipso,      y2, Time_diag, is, js , &
                                           mask = y2 /= missing_value )

   if (generate_orbital_output) then
     used = send_data (id_clhcalipso_sat,      y2, Time_diag, is, js , &
                                     mask = y2 /= missing_value  .and. &
                                          lflag_array(is:ie,js:je,nsat_time))
   endif
 endif

 if(cfg%Lradar_sim .and.cfg%Llidar_sim) then
   call map_point_to_ll (Nlon, Nlat, geomode,  &
                                    x1=stradar%radar_lidar_tcc,y2 = y2)
   used = send_data (id_cltlidarradar, y2, Time_diag, is, js , &
                                           mask = y2 /= missing_value )
 endif

 if (cfg%Lisccp_sim) then
   call map_point_to_ll (Nlon, Nlat, geomode, x1=isccp%totalcldarea,&
                                                       y2 = y2save)
   used = send_data (id_tclisccp,      y2save, Time_diag, is, js , &
                                           mask = y2save /= missing_value )

   call map_point_to_ll (Nlon, Nlat, geomode, x1=isccp%meanptop,&
                                                              y2 = y2)
   where (y2save== 0.0 .and. y2sunlit == 1.0)
     alpha = 0.0
   elsewhere
     alpha =     y2*y2save
   endwhere

   used = send_data (id_ctpisccp , alpha     , Time_diag, is, js , &
                                           mask = y2sunlit == 1.0    )

   call map_point_to_ll (Nlon, Nlat, geomode, x1=isccp%meantb,&
                                                              y2 = y2)

   used = send_data (id_tbisccp  , y2, Time_diag, is, js , &
                                           mask = y2sunlit == 1.0 )
!---

   call map_point_to_ll (Nlon, Nlat, geomode, x1=isccp%meantbclr,&
                                                              y2 = y2)
   used = send_data (id_tbclrisccp  , y2, Time_diag, is, js , &
                                           mask = y2sunlit == 1.0 )

!----
   call map_point_to_ll (Nlon, Nlat, geomode, x1=isccp%meantaucld,&
                                                             y2 = y2)
   where (y2save== 0.0 .and. y2sunlit == 1.0)
     alpha = 0.0
   elsewhere
     alpha = y2*y2save
   endwhere

   used = send_data (id_tauisccp  , alpha    , Time_diag, is, js , &
                                           mask = y2sunlit == 1.0 )

   call map_point_to_ll (Nlon, Nlat, geomode, x1=isccp%meanalbedocld,&
                                                              y2 = y2)
   where (y2save== 0.0 .and. y2sunlit == 1.0)
     alpha = 0.0
   elsewhere
     alpha = y2*y2save
   endwhere

   used = send_data (id_albisccp  , alpha, Time_diag, is, js , &
                                           mask = y2sunlit == 1.0 )
 endif

 if (cfg%Lmodis_sim) then
   call map_point_to_ll (Nlon, Nlat, geomode,  &
                               x1=modis%Cloud_Fraction_Total_Mean,   &
                                                           y2 = y2save)
   used = send_data (id_tclmodis  , y2save, Time_diag, is, js , &
                                           mask = y2save /= missing_value )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                               x1=modis%Cloud_Fraction_High_Mean,   &
                                                           y2 = y2)
   used = send_data (id_hicldmodis  , y2, Time_diag, is, js , &
                                           mask = y2 /= missing_value )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                               x1=modis%Cloud_Fraction_Mid_Mean,   &
                                                           y2 = y2)
   used = send_data (id_mdcldmodis  , y2, Time_diag, is, js , &
                                           mask = y2 /= missing_value )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                               x1=modis%Cloud_Fraction_Low_Mean,   &
                                                           y2 = y2)
   used = send_data (id_locldmodis  , y2, Time_diag, is, js , &
                                           mask = y2 /= missing_value )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                               x1=modis%Cloud_Fraction_Water_Mean,   &
                                                              y2 = y2lsave)
   used = send_data (id_lclmodis  , y2lsave, Time_diag, is, js , &
                                           mask = y2lsave /= missing_value )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                               x1=modis%Cloud_Fraction_Ice_Mean,   &
                                                              y2 = y2isave)
   used = send_data (id_iclmodis  , y2isave, Time_diag, is, js , &
                                           mask = y2isave /= missing_value )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                           x1=modis%Optical_Thickness_Total_Mean,   &
                                                              y2 = y2)

   where (y2save == 0.0 .and. y2sunlit == 1.0) 
     alpha = 0.
   elsewhere
     alpha = y2*y2save
   endwhere

   used = send_data (id_ttaumodis  , alpha, Time_diag, is, js , &
                                         mask = y2sunlit == 1.0 )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                           x1=modis%Optical_Thickness_Water_Mean,   &
                                                              y2 = y2)
   where (y2lsave == 0.0 .and. y2sunlit == 1.0) 
     alpha = 0.
   elsewhere
     alpha = y2*y2lsave
   endwhere

   used = send_data (id_ltaumodis  , alpha, Time_diag, is, js , &
                                           mask = y2 /= missing_value )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                           x1=modis%Optical_Thickness_Ice_Mean,   &
                                                              y2 = y2)
   where (y2isave == 0.0 .and. y2sunlit == 1.0) 
     alpha = 0.
   elsewhere
     alpha = y2*y2save
     alpha = y2*y2isave
   endwhere

   used = send_data (id_itaumodis  , alpha, Time_diag, is, js , &
                                           mask = y2 /= missing_value )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                        x1=modis%Optical_Thickness_Total_LogMean,   &
                                                              y2 = y2)
   where (y2save == 0.0 .and. y2sunlit == 1.0) 
     alpha = 0.
   elsewhere
     alpha = y2*y2save
   endwhere

   used = send_data (id_tlogtaumodis  , alpha, Time_diag, is, js , &
                                           mask = y2 /= missing_value )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                           x1=modis%Optical_Thickness_Water_LogMean,   &
                                                              y2 = y2)
   where (y2lsave == 0.0 .and. y2sunlit == 1.0) 
     alpha = 0.
   elsewhere
     alpha = y2*y2lsave
   endwhere

   used = send_data (id_llogtaumodis  , alpha, Time_diag, is, js , &
                                           mask = y2 /= missing_value )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                           x1=modis%Optical_Thickness_Ice_LogMean,   &
                                                              y2 = y2)
   where (y2isave == 0.0 .and. y2sunlit == 1.0) 
     alpha = 0.
   elsewhere
     alpha = y2*y2isave
   endwhere

   used = send_data (id_ilogtaumodis  , alpha, Time_diag, is, js , &
                                           mask = y2 /= missing_value )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                               x1=modis%Cloud_Particle_Size_Water_Mean,   &
                                                              y2 = y2)
   where (y2lsave == 0.0 .and. y2sunlit == 1.0) 
     alpha = 0.
   elsewhere
     alpha = y2*y2lsave
   endwhere

   used = send_data (id_lremodis  , alpha, Time_diag, is, js , &
                                           mask = y2 /= missing_value )
     lmsk(:,:) = (y2(:,:) < 0.0) .and. (y2(:,:) > -1.0)
   used = send_data (id_badlremodis  , y2, Time_diag, is, js , &
                                           mask = lmsk                )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                               x1=modis%Cloud_Particle_Size_Ice_Mean,   &
                                                              y2 = y2)
  where (y2isave == 0.0 .and. y2sunlit == 1.0) 
    alpha = 0.
  elsewhere
     alpha = y2*y2isave
   endwhere

   used = send_data (id_iremodis  , alpha, Time_diag, is, js , &
                                           mask = y2 /= missing_value )
     lmsk(:,:) = (y2(:,:) < 0.0) .and. (y2(:,:) > -1.0)
   used = send_data (id_badiremodis  , y2, Time_diag, is, js , &
                                           mask = lmsk                )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                               x1=modis%Cloud_Top_Pressure_Total_Mean,   &
                                                              y2 = y2)
   where (y2save == 0.0 .and. y2sunlit == 1.0) 
     alpha = 0.
   elsewhere
     alpha = y2*y2save
   endwhere

   used = send_data (id_ctpmodis  , alpha, Time_diag, is, js , &
                                           mask = y2 /= missing_value )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                               x1=modis%Liquid_Water_Path_Mean,   &
                                                              y2 = y2)
   where (y2lsave == 0.0 .and. y2sunlit == 1.0) 
     alpha = 0.
   elsewhere
     alpha = y2*y2lsave
   endwhere

   used = send_data (id_lwpmodis  , alpha, Time_diag, is, js , &
                                           mask = y2 /= missing_value )

   call map_point_to_ll (Nlon, Nlat, geomode,  &
                               x1=modis%Ice_Water_Path_Mean,   &
                                                              y2 = y2)
   where (y2isave == 0.0 .and. y2sunlit == 1.0) 
     alpha = 0.
   elsewhere
     alpha = y2*y2isave
   endwhere

   used = send_data (id_iwpmodis  , alpha, Time_diag, is, js , &
                                           mask = y2 /= missing_value )


   call map_point_to_ll (Nlon, Nlat, geomode,   &
                          x2=modis%Column_Optical_Thickness, y3 = y4)
   do n=1,ncolumns
     used = send_data (id_taumodis_n(n), y4(:,:,n), Time_diag,  &
                       is, js, mask = y4(:,:,n) /= missing_value )
   end do

   call map_point_to_ll (Nlon, Nlat, geomode,   &
                          x2=modis%Column_Cloud_Top_Pressure, y3 = y4)
   do n=1,ncolumns
     used = send_data (id_ptopmodis_n(n), 0.01*y4(:,:,n), Time_diag, &
                       is, js, mask = y4(:,:,n) /= missing_value )
   end do
   
   call map_point_to_ll (Nlon, Nlat, geomode,   &
                          x2=modis%Column_Particle_Size, y3 = y4)
   do n=1,ncolumns
     used = send_data (id_sizemodis_n(n), y4(:,:,n), Time_diag, &
                       is, js, mask = y4(:,:,n) > 0.0 )
    
     lmsk(:,:) = (y4(:,:,n) < 0.0) .and. (y4(:,:,n) > -1.0)
     used = send_data (id_badsizemodis_n(n), y4(:,:,n), Time_diag, &
                       is, js, mask =  lmsk       )
   end do

   call map_point_to_ll (Nlon, Nlat, geomode,   &
                          x2=modis%retrievedPhase      , y3 = y4)
   do n=1,ncolumns
     used = send_data (id_phasemodis_n(n), y4(:,:,n), Time_diag, &
                       is, js, mask = y4(:,:,n) /= missing_value )
   end do

 endif 

 if (use_vgrid) then
   if (cfg%Llidar_sim) then
     
     call map_point_to_ll (Nlon, Nlat, geomode, x2=stlidar%lidarcld,&
                                                             y3 = z3)
     used = send_data (id_clcalipso,      z3 , Time_diag, is, js, 1,  &
                                  mask = z3 (:,:,:) /= missing_value )
     if (generate_orbital_output) then
       used = send_data (id_clcalipso_sat,   z3 , Time_diag, is, js, 1,  &
                               mask = (z3 (:,:,:) /= missing_value) .and.& 
                                         lflag_array_temp(is:ie,js:je,:,nsat_time))
     endif
   endif
   if(cfg%Lradar_sim .and. cfg%Llidar_sim) then
     call map_point_to_ll (Nlon, Nlat, geomode,   &
                            x2=stradar%lidar_only_freq_cloud, y3 = z3)
     used = send_data (id_clcalipso2,      z3 , Time_diag, is, js, 1 , &
                                 mask = z3 (:,:,:) /= missing_value )
     if (generate_orbital_output) then
       used = send_data (id_clcalipso2_sat,  z3 , Time_diag, is, js, 1,  &
                               mask = (z3 (:,:,:) /= missing_value) .and.& 
                                         lflag_array_temp(is:ie,js:je,:,nsat_time))
     endif
   endif
 else
   if (cfg%Llidar_sim) then
     call map_point_to_ll (Nlon, Nlat, geomode, x2=stlidar%lidarcld,&
                                                              y3 = y3)
     call flip_vert_index    (y3, nlevels,y3a   )
     used = send_data (id_clcalipso_mdl, y3a, Time_diag, is, js, 1,  &
                                   mask = y3a(:,:,:) /= missing_value )
   endif
   if(cfg%Lradar_sim .and. cfg%Llidar_sim) then
     call map_point_to_ll (Nlon, Nlat, geomode,   &
                             x2=stradar%lidar_only_freq_cloud, y3 = y3)
     call flip_vert_index    (y3, nlevels,y3a   )
     used = send_data (id_clcalipso2_mdl, y3a, Time_diag, is, js, 1 , &
                                  mask = y3a(:,:,:) /= missing_value )
   endif
 endif

!3d arrays (i,j,columns):
 if (cfg%Lisccp_sim) then
   call map_point_to_ll (Nlon, Nlat, geomode,   &
                          x2=isccp%boxtau, y3 = y4)
   used = send_data (id_boxtauisccp, y4, Time_diag, is, js,  &
                           mask = y4 /= missing_value )
   do n=1,ncolumns
     used = send_data (id_boxtauisccp_n(n), y4(:,:,n), Time_diag,  &
                       is, js, mask = y4(:,:,n) /= missing_value )
   end do

   call map_point_to_ll (Nlon, Nlat, geomode,   &
                          x2=isccp%boxptop, y3 = y4)
   used = send_data (id_boxptopisccp, y4, Time_diag, is, js )
   do n=1,ncolumns
     used = send_data (id_boxptopisccp_n(n),      y4(:,:,n), Time_diag, &
                       is, js, mask = y4(:,:,n) /= missing_value )
   end do
 endif

!3d arrays (i,j,parasol_nrefl):
 if (cfg%Llidar_sim) then
   call map_point_to_ll (Nlon, Nlat, geomode,   &
                                       x2=stlidar%parasolrefl, y3 = y5)
   used = send_data (id_parasolrefl, y5, Time_diag, is, js, 1 , &
                                          mask = y5 /= missing_value )
   if (generate_orbital_output) then
     used = send_data (id_parasolrefl_sat, y5, Time_diag, is, js, 1 , &
                                     mask = y5 /= missing_value  .and. &
                                  lflag_array_parasol(is:ie,js:je,:,nsat_time))
   endif
   call map_point_to_ll (Nlon, Nlat, geomode,   &
                                       x2=sglidar%beta_mol, y3 = y3)
     call flip_vert_index    (y3, nlevels,y3a   )
   used = send_data (id_betamol532, y3a, Time_diag, is, js, 1 , &
                                          mask = y3 /= missing_value )
 endif

!4d array (i,j,columns, levels):
   call map_point_to_ll (Nlon, Nlat, geomode, x3=sg%frac_out, y4 = y6)
     call flip_vert_index    (y6, nlevels,y6a   )
   do n=1, size(id_cloud_type,1)
     used = send_data (id_cloud_type(n), y6a(:,:,n,:),  &
                                                 Time_diag, is, js,1 )
   end do

!4d array (i,j,columns, levels):
 if(cfg%Lradar_sim) then
   call map_point_to_ll (Nlon, Nlat, geomode,   &
                          x3=sgradar%Ze_tot, y4 = y6)
   call flip_vert_index    (y6, nlevels,y6a   )
   do n=1, size(id_dbze94,1)
     used = send_data (id_dbze94(n), y6a(:,:,n,:), Time_diag, is, js,1 )
   end do

!4d array (i,j, dbze_bins, levels):
   if (use_vgrid) then
     call map_point_to_ll (Nlon, Nlat, geomode, x3=stradar%cfad_ze, &
                                                              y4 = z7)
     do n=1, size(id_cloudsatcfad,1)
       used = send_data (id_cloudsatcfad(n), z7(:,:,n,:), Time_diag, &
                        is, js, 1, mask = z7(:,:,n,:) /= missing_value )
       if (generate_orbital_output) then
         used = send_data (id_cloudsatcfad_sat(n), z7(:,:,n,:), Time_diag,&
                  is, js, 1, mask = (z7(:,:,n,:) /= missing_value) .and. & 
                       lflag_array_temp(is:ie,js:je,:,nsat_time))
       endif
     end do
   else
     call map_point_to_ll (Nlon, Nlat, geomode,   &
                                         x3=stradar%cfad_ze, y4 = y7)
     call flip_vert_index    (y7, nlevels,y7a   )
     do n=1, size(id_cloudsatcfad_mdl,1)
       used = send_data (id_cloudsatcfad_mdl(n), y7a(:,:,n,:),  &
                             Time_diag, is, js,1 , &
                                mask = y7a(:,:,n,:) /= missing_value )
     end do
   endif
endif

!4d array (i,j,columns, levels   ):
 if (cfg%Llidar_sim) then
   call map_point_to_ll (Nlon, Nlat, geomode,   &
                                          x3=sglidar%beta_tot, y4 = y6)
   call flip_vert_index    (y6, nlevels,y6a   )
   do n=1, size(id_atb532,1)
     used = send_data (id_atb532(n), y6a(:,:,n,:), Time_diag, is,  &
                        js, 1, mask = y6a(:,:,n,:) /= missing_value )
   end do

!4d array (i,j, sr_bins,levels):
   if (use_vgrid) then
     call map_point_to_ll (Nlon, Nlat, geomode,   &
                          x3=stlidar%cfad_sr, y4 = z8)
     do n=1, size(id_calipsosrcfad,1)
       used = send_data (id_calipsosrcfad(n), z8(:,:,n,:),    &
                          Time_diag, is, js,1 , &
                                 mask = z8 (:,:,n,:) /= missing_value )
       if (generate_orbital_output) then
         used = send_data (id_calipsosrcfad_sat(n), z8(:,:,n,:),    &
                          Time_diag, is, js,1 , &
                            mask = (z8 (:,:,n,:) /= missing_value) .and. & 
                                       lflag_array_temp(is:ie,js:je,:,nsat_time))
       endif
     end do
   else
     call map_point_to_ll (Nlon, Nlat, geomode,   &
                                          x3=stlidar%cfad_sr, y4 = y8)
     call flip_vert_index    (y8, nlevels,y8a   )
     do n=1, size(id_calipsosrcfad_mdl,1)
       used = send_data (id_calipsosrcfad_mdl(n), y8a (:,:,n,:),    &
                          Time_diag, is, js,1 , &
                                 mask = y8a(:,:,n,:) /= missing_value )
     end do
   endif
 endif

!4d array (i,j, isccp_tau,isccp_press):
 if (cfg%Lisccp_sim) then
   call map_point_to_ll (Nlon, Nlat, geomode,   &
                                            x3=isccp%fq_isccp, y4 = y9)
   do n=1, 7                           
     used = send_data (id_clisccp(n),      y9(:,:,:,n), Time_diag, is, &
                           js, 1, mask = y9(:,:,:,n) /= missing_value )
   end do

   do m=1,7
     do n=1, 7                           
       used = send_data (id_clisccp_n(m,n), y9(:,:,m,n), Time_diag, &
                           is, js, mask = y9(:,:,m,n) /= missing_value )
     end do
   end do
 endif


!4d array (i,j, modis_tau,modis_press):
 if (cfg%Lmodis_sim) then
   call map_point_to_ll (Nlon, Nlat, geomode,   &
             x3=modis%Optical_Thickness_vs_Cloud_Top_Pressure, y4 = y12)
   y13(:,:,1:numTauHistogramBins,:) = y12(:,:,2:numTauHistogramBins+1,:)
   do n=1, numPressureHistogramBins   
     used = send_data (id_tauctpmodis(n), y13(:,:,:,n), Time_diag, is, &
                           js, 1, mask = y13(:,:,:,n) /= missing_value )
   end do

   do m=1,numTauHistogramBins
     do n=1, numPressureHistogramBins   
       used = send_data (id_tauctpmodis_n(m,n), y13(:,:,m,n), Time_diag, &
                           is, js, mask = y13(:,:,m,n) /= missing_value )
     end do
   end do
 endif

!4d array (i,j, isccp_tau,MISR_N_CTH ):
 if (cfg%Lmisr_sim) then
   call map_point_to_ll (Nlon, Nlat, geomode,   &
                                            x3=misr%fq_misr, y4 = y10)
   do n=1, MISR_N_CTH                  
     used = send_data (id_misr(n), y10(:,:,:,n), Time_diag, is, &
                           js, 1, mask = y10(:,:,:,n) /= missing_value )
   end do

   do m=1,7
     do n=1, MISR_N_CTH                  
       used = send_data (id_misr_n(m,n), y10(:,:,m,n), Time_diag, &
                          is, js, mask = y10(:,:,m,n) /= missing_value )
     end do
   end do
 endif

!-------------------------------------------------------------------
 
 
end subroutine output_cosp_fields



!#####################################################################

subroutine cosp_diagnostics_end 

!-------------------------------------------------------------------
!    deallocate the module arrays.
!-------------------------------------------------------------------
    deallocate (id_dbze94)
    deallocate (id_cloud_type)
    if (allocated(id_atb532)) deallocate (id_atb532)
    if (use_vgrid) then
      deallocate (id_cloudsatcfad)
      deallocate (id_calipsosrcfad)
      deallocate (id_cloudsatcfad_sat)
      deallocate (id_calipsosrcfad_sat)
    else
      deallocate (id_cloudsatcfad_mdl)
      deallocate (id_calipsosrcfad_mdl)
    endif
    
    if (generate_orbital_output) then
      deallocate (location, lflag_array, flag_array, lflag_array_temp, &
                  lflag_array_parasol, Time_start, Time_end)
    endif

end subroutine cosp_diagnostics_end

!#######################################################################

subroutine read_cloudsat_orbit 


!------------------------------------------------------------------------
!    subroutine read_cloudsat_orbit reads a netcdf file containing the
!    orbital position of the satellites as a function of time.
!------------------------------------------------------------------------

      real*4, dimension(:), allocatable    :: lat_in, lon_in
      integer*2, dimension(:), allocatable :: year_in
      byte, dimension(:), allocatable      ::  mon_in
      byte, dimension(:), allocatable      :: day_in, hour_in
      byte, dimension(:), allocatable      :: min_in
      real*4, dimension(:), allocatable    :: sec_in
      integer, dimension(:), allocatable   :: int_year_in
      integer, dimension(:), allocatable   ::  int_mon_in
      integer, dimension(:), allocatable   :: int_day_in, int_hour_in
      integer, dimension(:), allocatable   :: int_min_in
      real*8, dimension(:,:), allocatable  :: lat_out, lon_out

      character (len = *), parameter :: LAT_NAME  = "lat"
      character (len = *), parameter :: LON_NAME  = "lon"
      character (len = *), parameter :: YEAR_NAME = "year"
      character (len = *), parameter ::  MON_NAME = "month"
      character (len = *), parameter ::  DAY_NAME = "day"
      character (len = *), parameter :: HOUR_NAME = "hour"
      character (len = *), parameter ::  MIN_NAME = "minute"
      character (len = *), parameter ::  SEC_NAME = "second"

      integer          :: lat_varid, lon_varid, year_varid, day_varid,  &
                          mon_varid, hour_varid, min_varid, sec_varid
      integer          :: ncid
      integer          :: nlocs
      integer (kind=4) :: rcode, recdim
      type(time_type)  :: Time
      integer          :: k, mm, ptctr, n, ll, j, i
      integer          :: yeara, montha, daya, houra, minutea, seconda
      integer          :: yearb, monthb, dayb, hourb, minuteb, secondb
      integer          :: is, ie, js, je
      real             :: UNSET = -500.
      integer          :: calendar, nstart
      logical          :: used
      integer          :: ndims, nvars, ngatts
      integer          :: ndsize
      character*31     :: dummy
   
!------------------------------------------------------------------------
!    open the netcdf file. 
!------------------------------------------------------------------------
      ncid = ncopn (orbital_filename,   0, rcode)

!------------------------------------------------------------------------
!    determine number of dimensions (ndims); current file has 
!    only 1 ("location")
!------------------------------------------------------------------------
      call ncinq (ncid, ndims, nvars, ngatts, recdim, rcode)

!------------------------------------------------------------------------
!    determine value of the location dimension (nlocs) to use to dimension
!    arrays allocated below.
!------------------------------------------------------------------------
      do n=1,ndims
        call ncdinq(ncid, n, dummy, ndsize, rcode)
        if (trim(dummy) == 'location') then
          nlocs = ndsize
        endif
      end do

!------------------------------------------------------------------------
!    allocate arrays to hold the data read from the file.
!------------------------------------------------------------------------
      allocate (lat_in(nlocs), lon_in(nlocs), year_in(nlocs),  &
                mon_in(nlocs), day_in(nlocs), hour_in(nlocs),  &
                min_in(nlocs), sec_in(nlocs), int_year_in(nlocs), &
                int_mon_in(nlocs), int_day_in(nlocs), int_hour_in(nlocs), &
                int_min_in(nlocs) )
      allocate (lat_out(num_sat_periods, max_sdgs_per_sat_period), &
                lon_out(num_sat_periods, max_sdgs_per_sat_period) )
 
!------------------------------------------------------------------------
!    obtain the var_ids for the needed variables.
!------------------------------------------------------------------------

      lat_varid = ncvid(ncid, LAT_NAME , rcode)
      lon_varid = ncvid(ncid, LON_NAME , rcode)
      year_varid = ncvid(ncid, YEAR_NAME , rcode)
      mon_varid = ncvid(ncid, MON_NAME , rcode)
      day_varid = ncvid(ncid, DAY_NAME , rcode)
      hour_varid = ncvid(ncid, HOUR_NAME , rcode)
      min_varid = ncvid(ncid, MIN_NAME , rcode)
      sec_varid = ncvid(ncid, SEC_NAME , rcode)

!------------------------------------------------------------------------
!    read the netcdf data.
!------------------------------------------------------------------------
      call ncvgt (ncid, lat_varid, 1, nlocs, lat_in, rcode)
      call ncvgt (ncid, lon_varid, 1, nlocs, lon_in, rcode)
      call ncvgt (ncid, year_varid, 1, nlocs, year_in, rcode)
      call ncvgt (ncid, mon_varid, 1, nlocs, mon_in, rcode)
      call ncvgt (ncid, day_varid, 1, nlocs, day_in, rcode)
      call ncvgt (ncid, hour_varid, 1, nlocs, hour_in, rcode)
      call ncvgt (ncid, min_varid, 1, nlocs, min_in, rcode)
      call ncvgt (ncid, sec_varid, 1, nlocs, sec_in, rcode)

      call ncclos (ncid, rcode)

!------------------------------------------------------------------------
!    convert non-integer fields to integers.
!------------------------------------------------------------------------
      int_year_in = year_in
      int_mon_in = mon_in
      int_day_in = day_in
      int_hour_in = hour_in
      int_min_in = min_in

!------------------------------------------------------------------------
!    convert longitude to lie between 0 --> 360, rather than -180 --> 180.
!------------------------------------------------------------------------
      do  mm=1, size(lon_in)
        if (lon_in(mm) < 0.) then
          lon_in(mm) = lon_in(mm) + 360.
        endif
      end do

!------------------------------------------------------------------------
!    define the start and end of each time period for which the satellite 
!    orbital curtain data is desired. it is centered on sat_begin_time from
!    the cosp_input namelist.
!------------------------------------------------------------------------
      Time_start(1) = set_date (sat_begin_time(1), sat_begin_time(2),  &
                                sat_begin_time(3), sat_begin_time(4),  &
                                sat_begin_time(5), sat_begin_time(6))  - &
                                                   set_time(sat_period/2,0)
      Time_end(1) = Time_start(1) + set_time(sat_period, 0)

      do mm = 2,num_sat_periods 
        Time_start(mm) = Time_start(mm-1) + set_time(sat_period, 0)      
        Time_end  (mm) = Time_end  (mm-1) + set_time(sat_period, 0)      
      end do

!------------------------------------------------------------------------
!    initialize output variables.
!------------------------------------------------------------------------
      lat_out = UNSET
      lon_out = UNSET
      flag_array = 0.
      lflag_array = .false.
      location = 0.

!------------------------------------------------------------------------
!    define the latitudes/longitudes coordinates over which the satellite 
!    passes during each of the requested model sampling periods.
!------------------------------------------------------------------------
      calendar = get_calendar_type()

      nstart = 1
      do k=1,num_sat_periods      
        ptctr = 0
        do n=nstart, nlocs
          if (calendar == NOLEAP) then
!------------------------------------------------------------------------
!    ignore 2/29 when using the noleap calendar
!------------------------------------------------------------------------
            if (int_mon_in(n) == 2 .and. int_day_in(n) == 29) cycle
          endif

!-------------------------------------------------------------------------
!    determine if satellite observation time n is in any of the requested 
!    sampling periods. if it is before the first sampling period, cycle. 
!    if it is within sampling period k, increment the counter of obser-
!    vation times ptctr and enter the satellite location in the output 
!    arrays as the ptctr occurrence for sampling period k. if the sampling 
!    period has ended, exit the loop.
!-------------------------------------------------------------------------
          Time = set_date(int_year_in(n), int_mon_in(n), int_day_in(n), &
                          int_hour_in(n), int_min_in(n), INT(sec_in(n)))
          if (Time < Time_start(k)) then
            cycle
          else if (Time >= Time_start(k) .and. Time < Time_end(k)) then
            ptctr = ptctr + 1
            if (ptctr >= max_sdgs_per_sat_period) then
              call error_mesg ('cosp_driver:read_cloudsat_orbit', &
                    ' Need to increase &cosp_input variable &
                                       &max_sdgs_per_sat_period', FATAL)
            endif
            lat_out(k, ptctr) = lat_in(n)
            lon_out(k,ptctr) = lon_in(n)
          else if (Time >= Time_end(k))  then

!-------------------------------------------------------------------------
!    reset starting index into observations for next sampling period.
!-------------------------------------------------------------------------
            nstart = n - 1
            exit
          endif
        end do  ! n

!-------------------------------------------------------------------------
!    reset counter for next sampling period.
!-------------------------------------------------------------------------
        ptctr = 0
      end do   ! k

!-------------------------------------------------------------------------
!    call get_local_indexes2 to map the latitudes/longitudes seen by the 
!    satellite during sampling period k to the closest model grid  point 
!    (is,js). set a logical to indicate that grid point (is,js) is seen 
!    during time period k. 
!-------------------------------------------------------------------------
      do k=1,num_sat_periods   
        do ll = 1,max_sdgs_per_sat_period
          if (lat_out(k,ll) == UNSET .and. lon_out(k,ll) == UNSET) exit
          call get_local_indexes2(lat_out(k,ll),lon_out(k,ll), is,js)
          if (is /= 0 .and. js /= 0 .and. is <= imax .and. js <= jmax) then
            lflag_array(is,js,k) = .true.
            location(is,js,k) = ll
          endif
        end do

!-------------------------------------------------------------------------
!     collect sampling frequency diagnostic, if desired.
!-------------------------------------------------------------------------
        if (id_sampling_sat > 0) then
          call get_date(Time_end(k), yearb, monthb, dayb, hourb,    &
                                                         minuteb, secondb)
          do j=1,jmax
            do i=1,imax
              if (lflag_array(i,j,k)) then
                flag_array(i,j,monthb) = flag_array(i,j,monthb) + 1.
              endif
            end do
          end do
        endif
      end do

!-------------------------------------------------------------------------
!    define additional flag arrays for other diagnostics.
!-------------------------------------------------------------------------
      do k=1,PARASOL_NREFL
        lflag_array_parasol(:,:,k,:) = lflag_array(:,:,:)
      end do
      do k=1,nlr
        lflag_array_temp(:,:,k,:) = lflag_array(:,:,:)
      end do
   
!-------------------------------------------------------------------------
!    output the satellite sampling frequency at each point for each
!    month of the year for which data is requested.
!-------------------------------------------------------------------------
      used = send_data (id_sampling_sat, flag_array,   &
                                             is_in=1, js_in=1, ks_in=1) 

!-------------------------------------------------------------------------
!    output the satellite location index for each sampling period
!    for which data is requested.
!-------------------------------------------------------------------------
      used = send_data (id_location_sat, location,   &
                          is_in=1, js_in=1, ks_in=1, mask = location > 0.) 

!-----------------------------------------------------------------------
!    deallocate local variables.
!-----------------------------------------------------------------------
      deallocate (lat_in, lon_in, year_in, mon_in,&
                  day_in, hour_in, min_in, sec_in,&
                  int_year_in, int_mon_in, int_day_in, &
                  int_hour_in, int_min_in, lat_out, lon_out )

end subroutine read_cloudsat_orbit

!#####################################################################



end module cosp_diagnostics_mod

!VERSION NUMBER:
!  $Id: donner_cloud_model_k.F90,v 19.0 2012/01/06 20:06:50 fms Exp $

!module donner_cloud_model_inter_mod

!#include "donner_cloud_model_interfaces.h"

!end module donner_cloud_model_inter_mod



!#####################################################################

subroutine don_cm_cloud_model_k   &
         (nlev_lsm, nlev_hires, ntr, kou, diag_unit, debug_ijt, Param, &
!++lwh
          Col_diag, Initialized, tb, pb, alpp, cld_press, temp_c, &
!--lwh
          mixing_ratio_c, pfull_c, phalf_c, tracers_c, pcsave, &
          exit_flag_c, wv, rcl, dpf, dpftr, qlw, dfr, flux, pt_kou,  &
          dint, cu, cell_precip, apt, cell_melt, pmelt_lsm, summel, &
          efchr, emfhr, cfracice, etfhr, ncc_kou, tcc, ermesg, error)

!--------------------------------------------------------------------
!
!                ONE-DIMENSIONAL CLOUD MODEL 
!                L. DONNER     NCAR     3 OCT 1984
!
!    subroutine cloud_model receives as input cloud base temperature 
!    (tb), pressure (pb), large-scale model vertical profiles of temper-
!    ature (temp_c), mixing ratio (mixing_ratio_c), pressure (pfull_c and
!    phalf_c), and tracer concentrations (tracers_c) for ensemble member
!    kou and produces as output the in-cloud profiles of temperature 
!    (tcc), vertical velocity (wv), cloud radius (rcl), liquid water 
!    (qlw), condensation rate (dpf), wet-deposition rate (dpftr), 
!    freezing rate (dfr), mass flux
!    (flux), tracer concentrations (xclo), the environmental profiles of 
!    temperature (te), mixing ratio (mre) and tracer concentrations 
!    (xtrae), cloud top pressure (pt_kou), and column integrals of pre-
!    cipitation rate (precip), condensation rate (conint) and freezing 
!    rate (dint). if the current column is a column for which diagnostics
!    is desired (debug_ijt = .true.), then output is written to the diag-
!    nostics file (diag_unit).
!--------------------------------------------------------------------

use donner_types_mod, only : donner_param_type, donner_column_diag_type, &
!++lwh
                             donner_initialized_type
!--lwh

implicit none

!--------------------------------------------------------------------
integer,                            intent(in)     :: nlev_lsm,  &
                                                      nlev_hires, ntr, &
                                                      kou, diag_unit
logical,                            intent(in)     :: debug_ijt
type(donner_param_type),            intent(in)     :: Param
type(donner_column_diag_type),      intent(in)     :: Col_diag
!++lwh
type(donner_initialized_type),      intent(in)     :: Initialized
!--lwh
real,                               intent(in)     :: tb, pb, alpp
real,    dimension(nlev_hires),     intent(in)     :: cld_press
real,    dimension(nlev_lsm),       intent(in)     :: temp_c,   &
                                                      mixing_ratio_c, &
                                                      pfull_c
real,    dimension(nlev_lsm+1),     intent(in)     :: phalf_c 
real,    dimension(nlev_lsm,ntr),   intent(in)     :: tracers_c
real,                               intent(inout)  :: pcsave
logical,                            intent(inout)  :: exit_flag_c     
real,    dimension(nlev_hires),     intent(out)    :: wv, rcl, dpf, &
                                                      qlw, dfr, flux, &
                                                      tcc 
real,                               intent(out)    :: pt_kou, dint, cu,&
                                                      cell_precip,  &
                                                             apt
real,    dimension(nlev_lsm),       intent(out)    :: cell_melt
real,    dimension(nlev_hires),     intent(out)    :: efchr, emfhr,   &
                                                      cfracice
real,    dimension(nlev_hires,ntr), intent(out)    :: etfhr, dpftr
integer,                            intent(out)    :: ncc_kou
real,                               intent( in)    :: pmelt_lsm
real,                               intent(out)    :: summel
character(len=*),                   intent(out)    :: ermesg
integer,                            intent(out)    :: error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!     tb             cloud base temperature [ deg K ]
!     pb             cloud base pressure [ Pa ]             
!     temp_c         large-scale model temperature profile (index 1 
!                    nearest the surface) [ deg K ]
!     mixing_ratio_c large-scale model mixing ratio profile (index 1 
!                    nearest the surface) [ kg(h2o)/ kg(air) ]
!     sig            sigma coordinate of large-scale model levels
!                    index 1 nearest the surface) [ dimensionless ]
!     tracers_c      large-scale model tracer concentration profiles 
!                    (index 1 nearest the surface) [ kg/ kg ]  ???
!     kou            current ensemble member index i
!     diag_unit      output unit number for this diagnostics column
!     debug_ijt      is this a diagnostics column ?
!
!   intent(out) variables:
!
!     tcc            in-cloud temperature profile (index 1 at physical 
!                    base of cloud)  [ deg K ]
!     wv             in-cloud vertical velocity profile (index 1 at 
!                    physical base of cloud)  [ m / sec ]
!     rcl            cloud radius profile (index 1 at physical 
!                    base of cloud)  [ m ]
!     dpf            cloud-area-weighted condensation rate profile
!                    (index 1 at physical base of cloud) 
!                    [ (m**2) * kg(h2o) / kg(air) / sec ]
!     dpftr          wet-deposition rate profile,
!                    weighted by ratio of fractional area to
!                    fractional area at base 
!                    (index 1 at physical base of cloud)
!                    [  [units of xclo] /(sec) ]
!     qlw            cloud liquid water content profile (index 1 at
!                    physical base of cloud) [ kg(h2o) / kg(air) ]
!     dfr            cloud-area-weighted freezing rate profile in 
!                    convective updraft (index 1 at physical base of 
!                    cloud) [ (m**2) *g(h2o) / (kg(air) /  day ]
!     flux           upward mass flux profile in cloud (index 1 at 
!                    physical base of cloud) [ kg(air) / sec ]
!     xclo           in-cloud tracer concentration profiles (index 1 at 
!                    physical base of cloud)  [ kg / kg ] ???
!     te             environmental temperature profile on cloud-model 
!                    grid (index 1 at physical base of cloud) [ deg K ]
!     mre            environmental mixing ratio profile on cloud-model 
!                    grid (index 1 at physical base of cloud) 
!                    [ kg(air) / kg(h2o) ]
!     cell_melt      in-cloud melting of condensate associated with 
!                    convective cells. made up of two parts, 1) that 
!                    due to the freezing of liquid carried upwards 
!                    in the cell updraft, 2) that due to the melting of
!                    condensed ice that precipitates out. if meso 
!                    circulation is present, this component is zero; 
!                    melting will be determined in subroutine mesub.
!     xtrae          environmental tracer profiles on cloud-model 
!                    grid (index 1 at physical base of cloud) 
!                    [ kg / kg ]  ?????
!     pt_kou         pressure at cloud top for this ensemble member[ Pa ]
!     precip         total precipitation rate [ kg(h2o) / sec ]
!     conint         total condensation rate [ kg(h2o) / sec ]
!     dint           total freezing rate in convective updraft 
!                    [ kg(h20) / sec ]
!     cu
!     rc
!     lfc_not_reached      level of free convection was reached ?
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:

      real, dimension (nlev_hires)         ::  pf, te, mre
      real, dimension (nlev_hires,ntr)     ::  xclo, xtrae, pftr 
      real        :: precip, conint,                 pmel
      integer     :: k, kc
      real        :: accond, acpre
      real        :: sumfrea, sumlhr
      logical     :: lfc_not_reached, do_donner_tracer
      integer     ::  cldtop_indx

!--------------------------------------------------------------------
!   local variables:
!
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    initialize the character string which will contain any error mes-
!    sages returned through this subroutine.
!---------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!--------------------------------------------------------------------
!    if in diagnostic column, output the ensemble member index which
!    is being integrated.
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, i4)')    &
            'PROCESSING CLOUD ENSEMBLE MEMBER # ', kou
      endif

!-------------------------------------------------------------------
!    define  or initialize an array to hold any in-cloud tracer sources.
!-------------------------------------------------------------------
      call don_cm_gen_incloud_profs_k  &
           (nlev_lsm, nlev_hires, ntr, kou, diag_unit, debug_ijt, &
            Col_diag, Param, Initialized, tb, pb, alpp, cld_press,  &
            temp_c, mixing_ratio_c, pfull_c, phalf_c, tracers_c,  &
            pcsave,tcc, wv, rcl, qlw, dfr, flux, pf, pftr, te, mre, &
            xclo, xtrae, dint, accond, acpre, sumfrea, cldtop_indx, &
            do_donner_tracer, lfc_not_reached, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!--------------------------------------------------------------------
!    define the cloud top pressure for the current ensemble member.
!--------------------------------------------------------------------
      pt_kou = pb + cldtop_indx*Param%dp_of_cloud_model

!--------------------------------------------------------------------
!    if in diagnostics column, output the ensemble member number and
!    the level of free convection of the most-entraining (first)
!    ensemble member.
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, i4, f19.10)') &
                        'in cloudm: kou,pcsave= ',kou,pcsave
      endif

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      call don_cm_process_condensate_k     &
         (nlev_lsm, nlev_hires, ntr, cldtop_indx, diag_unit, debug_ijt,&
          Param, acpre, accond, pb, pt_kou, pf, pftr, tcc, rcl,  &
          cld_press, phalf_c, conint, dint, pmel, pmelt_lsm, precip, &
          cu, cell_precip, sumlhr, summel, dpf, dpftr, dfr, cell_melt, &
          ermesg, error)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!----------------------------------------------------------------------
!    if the level of free convection was never reached for this ensemble
!    member, set exit_flag_c so that calculations will cease in this 
!    column, and exit the ensemble members loop. if this is a diag-
!    nostics column, print a message.
!----------------------------------------------------------------------
      if (lfc_not_reached) then
        if (debug_ijt) then
          write (diag_unit, '(a)')  &
                           'in mulsub: lfc never reached'     
        endif
        exit_flag_c = .true.
        return
      endif

!----------------------------------------------------------------------
!    if no precipitation was produced by the ensemble member, set 
!    exit_flag_c so that calculations will cease in this column, and exit
!    the ensemble members loop. if this is a diagnostics column, print 
!    a message.
!----------------------------------------------------------------------
      if (precip == 0.) then
        if (debug_ijt) then
          write (diag_unit, '(a)') &
                       'in mulsub: PRECIP=0 AFTER CLOUD MODEL'
        endif
        exit_flag_c   = .true.
        return
      endif

!---------------------------------------------------------------------
!    if condensate is being evaporated at any level within the cloud, 
!    set exit_flag_c so that calculations will cease in this 
!    column, and exit the ensemble members loop. if this is a diag-
!    nostics column, print a message.
!---------------------------------------------------------------------
      do kc=1,nlev_hires-1           
        if (dpf(kc) > 0.) then 
          if (debug_ijt) then
            write (diag_unit, '(a)') 'in mulsub: dpf  .GT. 0.'
          endif
          exit_flag_c   = .true.
          return   
        endif 
      end do
      if (exit_flag_c) return

!--------------------------------------------------------------------
!    define the cloud model vertical index that is just above cloud top
!    (ncc_kou). this index may be used to limit calculations on the cloud
!    model dimensioned arrays.
!--------------------------------------------------------------------
      do k=1,nlev_hires
        if (cld_press(k) < pt_kou) then
          ncc_kou = k 
          exit
        endif
      end do

!--------------------------------------------------------------------
!    call compute_vertical_fluxes to calculate cumulus thermal forcing 
!    and moisture forcing on the cloud-model grid associated with this
!    ensemble member. 
!--------------------------------------------------------------------
      call don_cm_compute_vert_fluxes_k   &
           (nlev_hires, ntr, ncc_kou, kou, diag_unit, debug_ijt, &
            do_donner_tracer, Param, pt_kou, cld_press, rcl, te, mre, &
            wv, tcc, dpf, xclo, xtrae, apt, efchr, emfhr, etfhr, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!----------------------------------------------------------------------
!    define the fraction of condensation that is ice (cfraci) and that
!    which is liquid (cfracl). at temps above tfre, all condensate is
!    liquid;at temps below (tfre-dfre) all condensate is ice; in between
!    the condensate is partitioned linearly with the temperature depart-
!    ure between these two limits.
!----------------------------------------------------------------------
      cfracice = 0.
      do k=1,ncc_kou
        if (qlw(k) > 0.0) then
          if (tcc(k) > Param%tfre) then
            cfracice(k) = 0.
          else if (tcc(k) < (Param%tfre - Param%dfre)) then
            cfracice(k) = 1.
          else
            cfracice(k) = (Param%tfre - tcc(k))/Param%dfre
          endif
        endif
      end do

!---------------------------------------------------------------------


end subroutine don_cm_cloud_model_k



!#####################################################################

subroutine don_cm_gen_incloud_profs_k  &
         (nlev_lsm, nlev_hires, ntr, kou, diag_unit, debug_ijt, &
          Col_diag,  Param, Initialized, tb, pb, alpp, cld_press, &
          temp_c, mixing_ratio_c, pfull_c, phalf_c, tracers_c, pcsave, &
          tcc, wv, rcl, qlwa, dfr, flux, pf, pftr, te, mre, xclo, &
          xtrae, dint, accond, acpre, sumfrea, cldtop_indx,  &
          do_donner_tracer, lfc_not_reached, ermesg, error)

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------

!  modified by Leo Donner, GFDL, 5 February 2007
!
use donner_types_mod, only : donner_param_type, &
                             donner_column_diag_type, &
                             donner_initialized_type
use sat_vapor_pres_k_mod, only: compute_mrs_k

implicit none 

!----------------------------------------------------------------------
integer,                            intent(in)    :: nlev_lsm,   &
                                                     nlev_hires,&
                                                     ntr, kou, diag_unit
logical,                            intent(in)    :: debug_ijt
type(donner_column_diag_type),      intent(in)    :: Col_diag
type(donner_param_type),            intent(in)    :: Param      
!++lwh
type(donner_initialized_type),      intent(in)    :: Initialized
!--lwh
real,                               intent(in)    :: tb, pb, alpp
real,    dimension(nlev_hires),     intent(in)    :: cld_press
real,    dimension(nlev_lsm),       intent(in)    :: temp_c,   &
                                                     mixing_ratio_c,  &
                                                     pfull_c
real,    dimension(nlev_lsm+1),     intent(in)    :: phalf_c    
real,    dimension(nlev_lsm,ntr),   intent(in)    :: tracers_c
real,                               intent(inout) :: pcsave         
real,    dimension(nlev_hires),     intent(out)   :: tcc, wv, rcl, qlwa,&
                                                     dfr, flux, pf
real,    dimension(nlev_hires),     intent(out)   :: te, mre
real,    dimension(nlev_hires,ntr), intent(out)   :: xclo, xtrae, pftr
real,                               intent(out)   :: dint, accond, acpre
real,                               intent(out)  :: sumfrea
integer,                            intent(out)   :: cldtop_indx
logical,                            intent(out)   :: do_donner_tracer, &
                                                     lfc_not_reached
character(len=*),                   intent(out)   :: ermesg
integer,                            intent(out)   :: error

!--------------------------------------------------------------------
!
!--------------------------------------------------------------------


!---------------------------------------------------------------------
!   intent(in) variables:
!
!     psfc           surface pressure [ Pa ]
!     tb             cloud base temperature [ deg K ]
!     pb             cloud base pressure [ Pa ]             
!     temp_c         large-scale model temperature profile (index 1 
!                    nearest the surface) [ deg K ]
!     mixing_ratio_c large-scale model mixing ratio profile (index 1 
!                    nearest the surface) [ kg(h2o)/ kg(air) ]
!     sig            sigma coordinate of large-scale model levels
!                    index 1 nearest the surface) [ dimensionless ]
!     tracers_c      large-scale model tracer concentration profiles 
!                    (index 1 nearest the surface) [ kg/ kg ]  ???
!     kou            current ensemble member index i
!     diag_unit      output unit number for this diagnostics column
!     debug_ijt      is this a diagnostics column ?
!
!   intent(out) variables:
!
!     tcc            in-cloud temperature profile (index 1 at physical 
!                    base of cloud)  [ deg K ]
!     wv             in-cloud vertical velocity profile (index 1 at 
!                    physical base of cloud)  [ m / sec ]
!     rcl            cloud radius profile (index 1 at physical 
!                    base of cloud)  [ m ]
!     pf             cloud-area-weighted condensation rate profile
!                    (index 1 at physical base of cloud) 
!                    [ (m**2) * kg(h2o) / kg(air) / sec ]
!     pftr           cloud-area-weighted wet-deposition profile
!                    (index 1 at physical base of cloud)
!                    [ (m**2) * [xlco units] /sec ]
!     qlwa           cloud liquid water content profile (index 1 at
!                    physical base of cloud) [ kg(h2o) / kg(air) ]
!     dfr            cloud-area-weighted freezing rate profile in 
!                    convective updraft (index 1 at physical base of 
!                    cloud) [ (m**2) *g(h2o) / (kg(air) /  day ]
!     flux           upward mass flux profile in cloud (index 1 at 
!                    physical base of cloud) [ kg(air) / sec ]
!     xclo           in-cloud tracer concentration profiles (index 1 at 
!                    physical base of cloud)  [ kg / kg ] ???
!     te             environmental temperature profile on cloud-model 
!                    grid (index 1 at physical base of cloud) [ deg K ]
!     mre            environmental mixing ratio profile on cloud-model 
!                    grid (index 1 at physical base of cloud) 
!                    [ kg(air) / kg(h2o) ]
!     cell_melt      in-cloud melting of condensate associated with 
!                    convective cells. made up of two parts, 1) that 
!                    due to the freezing of liquid carried upwards 
!                    in the cell updraft, 2) that due to the melting of
!                    condensed ice that precipitates out. if meso 
!                    circulation is present, this component is zero; 
!                    melting will be determined in subroutine mesub.
!     xtrae          environmental tracer profiles on cloud-model 
!                    grid (index 1 at physical base of cloud) 
!                    [ kg / kg ]  ?????
!     pt             pressure at cloud top [ Pa ]
!     precip         total precipitation rate [ kg(h2o) / sec ]
!     conint         total condensation rate [ kg(h2o) / sec ]
!     dint           total freezing rate in convective updraft 
!                    [ kg(h20) / sec ]
!     rc
!     lfc_not_reached      level of free convection was reached ?
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:

      real,   dimension(nlev_lsm)         :: sig
      real,   dimension(nlev_hires)       :: dis, rsc
      real,   dimension (nlev_hires,ntr)  ::   clsou
      real     :: qlw, qcw, qrw, dtfr, dtupa, dfrac, rmu,  &
                  rhodt_inv, psfc, actot, dt_micro,          dcw1,  &
                  dqrw3, rbar, rmub, density, densityp, d1, d2, dztr, &
                  entrain, dt_inv
      logical  :: flag
      integer  :: max_cloud_level, ktr
      integer  :: k, nbad
!++lwh
      real, parameter :: g_2_kg = 1.e-3 ! kg/g
      real :: qlw_save, t_avg
      real, dimension( size(xclo,2) ) :: delta_xclo0, delta_xclo1, dwet
      integer :: n
!--lwh

!--------------------------------------------------------------------
!   local variables:
!
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    initialize the character string which will contain any error mes-
!    sages returned through this subroutine.
!---------------------------------------------------------------------
      ermesg = '  ' ; error = 0

      psfc = phalf_c(1)
      if (ntr /= 0) then
        do_donner_tracer = .true.
      else
        do_donner_tracer = .false.
      endif

!--------------------------------------------------------------------
!    provide appropriate initialization for the output fields. 
!    NOTE: input tracer fields of all zeroes are currently provided if 
!    do_donner_tracer is .false.. one could make the tracer fields
!    optional and define output only when present.
!--------------------------------------------------------------------
      tcc(:)  = 0.
      wv(:)   = 0.
      rcl(:)  = 0.
      qlwa(:) = 0.
      dfr(:)  = 0.
      te(:)   = 0.
      mre(:)  = 0.
      xclo(:,:)  = 0.
      xtrae(:,:) = 0.
      pftr(:,:) = 0.
      flux(:) = 0.
      dint   = 0. 
      lfc_not_reached = .true.

!-------------------------------------------------------------------
!    initialize local variables.
!-------------------------------------------------------------------
      do k=1,nlev_hires
        dis(k)=0.
        pf(k)=0.
      end do

      rsc(:) = 0.
      sig(:) = pfull_c(:)/psfc

!--------------------------------------------------------------------
!    if in diagnostics column, output the cloud base radius, pressure
!    and temperature, and the large-scale model sigma levels.
!--------------------------------------------------------------------
      if (debug_ijt) then
        do k=1,nlev_lsm-Col_diag%kstart+1
          write (diag_unit, '(a, i4, e20.12)')  &
                        'in cloudm: k,sig   = ',k, sig(k)    
        end do
      endif

!---------------------------------------------------------------------
!    initialize various integrals.
!---------------------------------------------------------------------

      qcw = 0.
      qlw = 0.
      qrw = 0.

!---------------------------------------------------------------------
!    initialize various integrals.
!---------------------------------------------------------------------
      accond  = 0.
      acpre   = 0.
      dtupa   = 0.
      dfrac   = 0.
      dtfr    = 0.
      sumfrea = 0.

!---------------------------------------------------------------------
!    initialize various conditionals.
!---------------------------------------------------------------------
      cldtop_indx = 0
  
!--------------------------------------------------------------------
!    define the cloud model pressure levels. 
!--------------------------------------------------------------------
      max_cloud_level = nlev_hires + 2
      do k=1,nlev_hires
        if (cld_press(k) < Param%pstop) then
          max_cloud_level = k - 1 
        endif
      end do

!--------------------------------------------------------------------
!    define cloud base (k = 1) values of vertical velocity (wv),
!    temperature (tcc), mixing ratio (rsc), cloud radius (rcl) and
!    tracer concentrations (xclo).
!--------------------------------------------------------------------
      wv(1) = Param%cld_base_vert_vel
      rcl(1) = Param%cloud_base_radius
      tcc(1) = tb
      xclo(1,:) = tracers_c(1,:)
      call compute_mrs_k (tb, pb, Param%D622, Param%D608, rsc(1), nbad)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (nbad /= 0) then
        ermesg = 'subroutine don_cm_gen_incloud_profs_k: '// &
                 'temperatures out of range of esat table'
        error = 1
        return
      endif

!--------------------------------------------------------------------
!    call gcm_to_cm to obtain the large-scale model moisture, temper-
!    ature, and tracer field values at the cloud base pressure to be
!    used as the environmental values in the cloud model.
!--------------------------------------------------------------------
      call don_u_lo1d_to_hi0d_log_k             &
           (nlev_lsm, mixing_ratio_c, sig, psfc, pb, mre(1), ermesg, error)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

      call don_u_lo1d_to_hi0d_log_k             &
           (nlev_lsm, temp_c, sig, psfc, pb, te(1), ermesg, error )
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return


      if (do_donner_tracer) then
        do ktr=1,ntr          
          call don_u_lo1d_to_hi0d_log_k             &
               (nlev_lsm, tracers_c(:,ktr), sig, psfc, pb,   &
                xtrae(1,ktr), ermesg, error)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (error /= 0 ) return
        end do
      endif

!--------------------------------------------------------------------
!    if in diagnostics column, output the cloud base radius, pressure
!    and temperature, and the large-scale model sigma levels.
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, e20.12, f19.10, f20.14)')  &
                'in cloudm: RR,PB,TB= ',Param%cloud_base_radius, pb, tb
      endif

!--------------------------------------------------------------------
!    if in diagnostics column, output cloud base values of environ-
!    mental moisture (mre) and temperature (te), and the in-cloud 
!    temperature (tcc).
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12,f20.14)')  &
                       'in cloudm: QE,TE,TCC= ',mre(1), te(1), tcc(1)
      endif
      
!---------------------------------------------------------------------
!    loop over cloud model levels, generating the desired in-cloud and 
!    environmental profiles. under no circumstances extend the cal-
!    culation above max_cloud_level (the level above which cloud is not
!    allowed).
!---------------------------------------------------------------------
      do k=1,max_cloud_level-1

!----------------------------------------------------------------------
!    exit the loop if the pressure is lower than the upper limit allowed
!    for the level of free convection and free convection has not yet 
!    been achieved.
!----------------------------------------------------------------------
        if ((cld_press(k+1) <= Param%upper_limit_for_lfc) .and. &
            (lfc_not_reached)) then
          cldtop_indx = 0
          exit
        endif 

!--------------------------------------------------------------------
!    call gcm_to_cm to obtain the large-scale model moisture, temper-
!    ature, and tracer field values at cloud model pressure level to be
!    used as the environmental values in the cloud model.
!--------------------------------------------------------------------
        call don_u_lo1d_to_hi0d_log_k             &
             (nlev_lsm, mixing_ratio_c, sig, psfc, cld_press(k+1),  &
              mre(k+1), ermesg, error)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (error /= 0 ) return

        call don_u_lo1d_to_hi0d_log_k             &
             (nlev_lsm, temp_c, sig, psfc, cld_press(k+1),   &
              te(k+1), ermesg, error )

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (error /= 0 ) return

        if (do_donner_tracer) then
          do ktr=1, ntr           
            call don_u_lo1d_to_hi0d_log_k             &
                 (nlev_lsm, tracers_c(:,ktr), sig, psfc,   &
                  cld_press(k+1), xtrae(k+1,ktr), ermesg, error)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
            if (error /= 0 ) return
          end do
        endif

!--------------------------------------------------------------------
!    if in diagnostics column, output level k values of vertical
!    velocity, pressure, environmental temperature (te) and moisture 
!    (mre), the in-cloud temperature (tcc) and liquid water (qlw).
!--------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, 3e20.12)')  &
                      'in cloudm: WV,PP,TE= ',wv(k), cld_press(k), te(k)
          write (diag_unit, '(a,f20.14, 2e20.12)')  &
                     'in cloudm: TCC(k),qe(k),QLW= ',tcc(k), wv(k), qlw
        endif

!-----------------------------------------------------------------------
!
!-----------------------------------------------------------------------
!++lwh
        qlw_save = qlw
!--lwh

        call don_cm_move_parcel_k    &
             (k, kou, diag_unit, debug_ijt, cld_press(k),  &
              cld_press(k+1), alpp, Param, pcsave, qlw, sumfrea, qrw, &
              qcw, dcw1, dqrw3, wv(k), tcc(k), rcl(k), te(k), mre(k), &
              rcl(k+1), wv(k+1), tcc(k+1), rsc(k+1), te(k+1), mre(k+1),&
              qlwa(k+1), dfr(k+1), rmu, rbar, dfrac, dtfr, dtupa,  &
              lfc_not_reached, flag, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (error /= 0 ) return

        if (flag) exit

!---------------------------------------------------------------------
!    define the in-cloud  density at levels k and k+1 
!    (density, densityp).
!---------------------------------------------------------------------
        density  = cld_press(k)/(Param%rdgas*(tcc(k)*  &
                               (1. + Param%D608*(rsc(k)/(1.0+rsc(k))))))
        densityp = cld_press(k+1)/(Param%rdgas*(tcc(k+1)*  &
                           (1. + Param%D608*(rsc(k+1)/(1.0+rsc(k+1))))))
 
!--------------------------------------------------------------------
!    calculate in-cloud tracer distribution.
!--------------------------------------------------------------------
        if (do_donner_tracer) then
          clsou(k,:) = 0.0
          clsou(k+1,:) = 0.0
          d1 = Param%rdgas*(1.+Param%virt_mass_co)*tcc(k)*te(k)/  &
               (Param%grav*cld_press(k)*(Param%virt_mass_co*te(k) +  &
                                                                tcc(k)))
          d2 = Param%rdgas*(1.+Param%virt_mass_co)*tcc(k+1)*te(k+1)/ &
               (Param%grav*cld_press(k+1)*      &
                                (Param%virt_mass_co*te(k+1) + tcc(k+1)))
          dztr = ((d1 + d2)*(cld_press(k) - cld_press(k+1))/2.)
          rmub = 2.*alpp/rbar
          entrain = dztr*rmub
          dt_micro = dztr/(0.5*(wv(k) + wv(k+1)))
          if (debug_ijt) then
            write (diag_unit, '(a, 3e20.12)')   &
                 'in clotr: d1,d2,dz= ',d1,d2,dztr
            write (diag_unit, '(a, e20.12)')   &
                 'in clotr: ent= ',rmub
          endif

!++lwh
!--------------------------------------------------------------------
!    Call tracer wet deposition
!    
!    Convert dqrw3 from g/m3 to kg/m3
!    from g(h2o) per m**3 to kg(h2o) per kg(air).
!--------------------------------------------------------------------
          t_avg = 0.5*(tcc(k)+tcc(k+1))
          do n = 1,size(xclo,2)
             if (Initialized%wetdep(n)%Lwetdep) then
                call wet_deposition_0D    &
                           (Initialized%wetdep(n)%Henry_constant, &
                            Initialized%wetdep(n)%Henry_variable, &
                            Initialized%wetdep(n)%frac_in_cloud, &
                            Initialized%wetdep(n)%alpha_r, &
                            Initialized%wetdep(n)%alpha_s, &
                            t_avg, cld_press(k), cld_press(k+1), &
                            0.5*(density+densityp), &
                            qlw_save, dqrw3*g_2_kg, 0., &
                            xclo(k,n), &
                            Initialized%wetdep(n)%Lgas, &
                            Initialized%wetdep(n)%Laerosol, &
                            Initialized%wetdep(n)%Lice, &
                            delta_xclo0(n) )
             end if
          end do
!--lwh          
          call don_cm_clotr_k    &
               (ntr, diag_unit, debug_ijt, Param, clsou(k,:),  &
                clsou(k+1,:), xtrae(k,:), xtrae(k+1,:), xclo(k,:), &
                entrain, dt_micro, xclo(k+1,:), ermesg, error)
!++lwh
          do n = 1,size(xclo,2)
             if (Initialized%wetdep(n)%Lwetdep) then
                call wet_deposition_0D   &
                           (Initialized%wetdep(n)%Henry_constant, &
                            Initialized%wetdep(n)%Henry_variable, &
                            Initialized%wetdep(n)%frac_in_cloud, &
                            Initialized%wetdep(n)%alpha_r, &
                            Initialized%wetdep(n)%alpha_s, &
                            t_avg, cld_press(k), cld_press(k+1), &
                            0.5*(density+densityp), &
                            qlw, dqrw3*g_2_kg, 0., &
                            xclo(k+1,n), &
                            Initialized%wetdep(n)%Lgas, &
                            Initialized%wetdep(n)%Laerosol, &
                            Initialized%wetdep(n)%Lice, &
                            delta_xclo1(n) )
                dwet(n) = - 0.5*(delta_xclo0(n)+delta_xclo1(n))
                xclo(k+1,n) = xclo(k+1,n) + dwet(n)
             else
                dwet(n) = 0.
             end if
          end do
!--lwh          
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (error /= 0 ) return
        endif

!--------------------------------------------------------------------
!    define cloud-area-weighted precip removal from the layer (dis) in 
!    units of  m**2 * kg(h2o) per kg(air) per day. define rhodt_inv 
!    (10e-03*g*w/delta p) to be used to convert units of dqrw3 and dcw1
!    from g(h2o) per m**3 to kg(h2o) per kg(air).
!--------------------------------------------------------------------
        rhodt_inv = 1.0e-03*(0.5*(wv(k) + wv(k+1)))*Param%GRAV  /   &
                    Param%dp_of_cloud_model
        dis(k) = dqrw3*(rbar**2)*rhodt_inv
        pf(k)  = dcw1*(rbar**2)*rhodt_inv

!---------------------------------------------------------------------
!     define the removal by wet deposition between levels k and k+1
!---------------------------------------------------------------------
        dt_inv = -.25*(wv(k)+wv(k+1))*(density+densityp)*Param%grav  / &
                 Param%dp_of_cloud_model
        do n = 1,size(xclo,2)
          pftr(k,n) = dwet(n) *(rbar**2)*dt_inv
        end do

!---------------------------------------------------------------------
!    calculate moisture subject to freezing in units of g(h2o) per 
!    kg(air) per day, weighted by the cloud area (dfr). add this layer's
!    contribution to the integrated water mass frozen in the updraft 
!    in units of kg(h2o)/sec (dint). 
!---------------------------------------------------------------------
        if (dfr(k+1) /= 0.) then
          dfr(k+1) = dfr(k+1)*densityp*wv(k+1)*(rcl(k+1)**2)*   &
                                      Param%grav/Param%dp_of_cloud_model 
          dfr(k+1) = -dfr(k+1)*Param%cp_air/Param%hlf   
          dint = dint - dfr(k+1)*Param%dp_of_cloud_model/Param%grav  
          dfr(k+1) = dfr(k+1)*8.64E07
        endif 
 
!---------------------------------------------------------------------
!    add this layer's contribution to the integrals accumulating total
!    condensation (accond), precipitation (acpre) and  total liquid
!    water (actot).
!---------------------------------------------------------------------
        accond = accond + dcw1
        acpre  = acpre  + dqrw3
        actot =  accond + acpre

!--------------------------------------------------------------------
!    if in diagnostics column, output the values of accumulated conden-
!    sation, precipitation and total liquid water at this level.
!--------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, i4, 2e20.12)')  &
                        'in cloudm: k,ACCOND,ACPRE= ',k, accond, acpre
          write (diag_unit, '(a, i4, e20.12)')  &
                        'in cloudm:  k,ACTOT= ',k, actot
        endif

!--------------------------------------------------------------------
!    define the mass flux at level k+1 (flux).
!--------------------------------------------------------------------
        if (k == 1) flux(k) = (rcl(k)**2)*wv(k)*density 
        flux(k+1) = (rcl(k+1)**2)*wv(k+1)*densityp

!--------------------------------------------------------------------
!    if in diagnostics column, output the values of cloud radius and
!    entrainment coefficient at this level.
!--------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, i4, 2e20.12)')  &
                     'in cloudm: k,rcl,RMU= ',k, rcl(k), rmu
        endif

!---------------------------------------------------------------------
!    if non-negative water is present, save the current k index as the
!    index of the last cloud model level containing cloud (cldtop_indx).
!---------------------------------------------------------------------
        if (qlwa(k+1) >= 0.) then    
          cldtop_indx = k
        endif  ! (qlwa(k+1) >= 0.0)

!---------------------------------------------------------------------
!    end of loop over cloud model levels. upon leaving loop, in-cloud
!    profiles of model variables have been generated.
!---------------------------------------------------------------------
      end do   ! (do 1 loop)


!--------------------------------------------------------------------
!    if in diagnostics column, output the water mass frozen in the
!    updraft in units of cloud area*kg(h2o) / sec (dint) and the 
!    resultant temperature change (sumfrea).
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12)')  &
                'in cloudm: DINT IN CLOUDM,sumfrea= ', dint, sumfrea
      endif

!--------------------------------------------------------------------
!    normalize the column integral of water mass frozen in the updraft
!    by the cloud base area of ensemble member #1.
!--------------------------------------------------------------------
      dint = dint/(Param%cloud_base_radius**2)

!--------------------------------------------------------------------
!    if an acceptable cloud was found for this ensemble member, obtain
!    the needed diagnostic / integral output.
!--------------------------------------------------------------------
      if (cldtop_indx /= 0) then

!--------------------------------------------------------------------
!    if in diagnostics column, output the topmost cloud level and
!    the mixing ratios at and one level above cloud top.  
!--------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, i4, 2e20.12)')  &
                      'in cloudm: n,rsc(n+2),rsc(n)= ',cldtop_indx,   &
                             rsc(cldtop_indx+1),rsc(cldtop_indx)
        endif
      endif ! (cldtop_indx /= 0)

!--------------------------------------------------------------------
!    if in diagnostics column, output the values of cloud-area-
!    weighted layer-mean condensation and  fallout.
!--------------------------------------------------------------------
        do k = 1, cldtop_indx
          if (debug_ijt) then
            write (diag_unit, '(a, i4, 2e20.12)')   &
                       'in cloudm: K,PF,DIS= ', k, pf(k), dis(k)
          endif
        end do


end subroutine don_cm_gen_incloud_profs_k


!#####################################################################

subroutine don_cm_move_parcel_k    &
              (k, kou, diag_unit, debug_ijt, pbot, ptop, alpp, Param,  &
               pcsave, qlw, sumfrea, qrw, qcw, dcw1, dqrw3, wvbot,  &
               tccbot, rclbot, tebot, mrebot, rcltop, wvtop, tcctop, &
               rsctop, tetop, mretop, qlwatop, dfrtop, rmu, rbar, &
               dfrac, dtfr,  dtupa, lfc_not_reached, flag, ermesg, error)

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------

use donner_types_mod, only : donner_param_type
use sat_vapor_pres_k_mod, only: compute_mrs_k

implicit none

!----------------------------------------------------------------------
integer,                 intent(in)    :: k, kou, diag_unit
logical,                 intent(in)    :: debug_ijt
real,                    intent(in)    :: pbot, ptop, alpp
type(donner_param_type), intent(in)    :: Param
real,                    intent(inout) :: pcsave, qlw, sumfrea, qrw, &
                                          qcw, dcw1, dqrw3, wvbot,  &
                                          tccbot, rclbot, tebot, &
                                          mrebot, rcltop, wvtop, &
                                          tcctop, rsctop,&
                                          tetop, mretop, qlwatop,  &
                                          dfrtop, rmu, rbar, dfrac,  &
                                          dtfr, dtupa
logical,                 intent(inout) :: lfc_not_reached
logical,                 intent(out)   :: flag
character(len=*),        intent(out)   :: ermesg
integer,                 intent(out)   :: error

!----------------------------------------------------------------------
      real    ::  dtdp, drdp, dwdp, tcest, west, &
                  rest, qcwest,  qlwest, dtdp2, drdp2, dwdp2, qrwest
      integer :: nbad

!---------------------------------------------------------------------
      flag = .false.

!---------------------------------------------------------------------
!    initialize the character string which will contain any error mes-
!    sages returned through this subroutine.
!---------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!---------------------------------------------------------------------
!    define the entrainment coefficient (rmu). 
!    pcsave    = p at which ensemble member 1 becomes buoyant.
!    lfc_not_reached = T below level where vert vel starts to increase 
!    with height 
!    THUS:
!    rmu = 0 when above buoyancy level for member 1, above level where 
!            vert vel starts to increase for this member, AND vert vel
!            is so small that are detraining. Thus rmu = 0. when
!            detraining after having been through a convective tower.
!---------------------------------------------------------------------
      if ((pbot    <= pcsave) .and. (.not. lfc_not_reached) .and. &
          (wvbot <= Param%wdet)) then
        rmu = 0.
      else
        rmu = 2.*alpp/rclbot
      end if 

!--------------------------------------------------------------------
!    call simult to solve for the in-cloud derivatives dT/dp (dtdp), 
!    dw/dp (dwdp) and dr/dp (drdp) for a parcel in motion from cloud 
!    model level k (pressure pp) to pressure level pp + delta p.
!--------------------------------------------------------------------
      call don_cm_simult_k   &
           (diag_unit, debug_ijt, lfc_not_reached, Param, pcsave, rmu, &
            tccbot, rclbot, wvbot, pbot, qlw, tebot, mrebot,   &
            dtdp, drdp, dwdp, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!--------------------------------------------------------------------
!    if in diagnostics column, output cloud base values of environ-
!    mental moisture (mre), liquid water (qlw) and initial cloud
!    radius (cloud_base_radius), and the cloud radius and vertical vel-
!    ocity tendencies returned from subroutine simult.
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 3e20.12)')   &
             'in cloudm: QE,QLW,RR= ',mrebot,QLW,Param%cloud_base_radius
        write (diag_unit, '(a, 2e20.12)')  &
                                'in cloudm: DPD,DWDP= ',drdp, dwdp
      endif

!--------------------------------------------------------------------
!    define estimated values for t, w and cloud radius based on the
!    derivatives returned from subroutine simult. define the average of
!    the original cloud radius and the new estimate (rbar).
!--------------------------------------------------------------------
      tcest = tccbot + dtdp*Param%dp_of_cloud_model
      west  = wvbot  + dwdp*Param%dp_of_cloud_model
      rest  = rclbot + drdp*Param%dp_of_cloud_model
      rbar  = 0.5*(rest + rclbot)

!--------------------------------------------------------------------
!    if in diagnostics column, output the newly estimated values of 
!    cloud radius (rest) and vertical velocity (west).
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12)')  &
                         'in cloudm: rest,west= ',rest, west
      endif

!--------------------------------------------------------------------
!    if any of these estimated values are incompatible with the exist-
!    ence of deep convection at this level, exit this vertical loop --
!    cloud does not extend any higher.
!--------------------------------------------------------------------
      if (rbar <= Param%rbound .or. &    
          west <= Param%wbound .or. &     
          rest <= Param%rbound) then
        flag = .true.
        return
      endif

!---------------------------------------------------------------------
!    define estimated values of the liquid water components to be passed
!    to subroutine micro to hold first pass values.
!---------------------------------------------------------------------
      qrwest = qrw
      qcwest = qcw
      qlwest = qlw

!---------------------------------------------------------------------
!    call micro to calculate the microphysical terms which occur during
!    the parcel movement from cld_press(k) to cld_press(k+1).
!---------------------------------------------------------------------
      call don_cm_micro_k   &
           (diag_unit, debug_ijt, Param, tccbot, tcest, pbot, ptop,  &
            tebot, tetop, mrebot, mretop, wvbot, west, rbar, rmu,  &
            qrwest, qcwest, qlwest, dcw1, dqrw3, ermesg, error)  
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!--------------------------------------------------------------------
!    if in diagnostics column, output the newly estimated values of 
!    environmental pressure (cld_press(k+1)), temperature (te) and 
!    mixing ratio (mre), and cloud temperature (tcest), cloud radius 
!    (rest) and liquid water (qlwest)
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, f19.10, f20.14, e20.12)') &
             'in cloudm: P,TEST,QEST= ',ptop     ,TEtop  ,mretop  
        write (diag_unit, '(a, f20.14, 2e20.12)')   &
                   'in cloudm: TCEST,rest,QLWT= ',TCEST,REST,qlwest
      endif

!----------------------------------------------------------------------
!    define the entrainment coefficient (rmu). it is set to 0.0 if the
!    parcel is above the lcl of ensemble member #1, and above the cur-
!    rent ensemble member's cloud base, and if the vertical velocity
!    is below the detrainment threshold; i.e., the current cloud is in
!    its detraining region. if it is not in its detraining zone, set the
!    entrainment coefficient to be the specified entrainment coefficient
!    divided by current cloud radius.
!----------------------------------------------------------------------
      if ((ptop <= pcsave) .and. (.not. lfc_not_reached) .and. &
          (west <= Param%wdet)) then
        rmu = 0.
      else
        rmu = 2.*alpp/rest
      endif 

!----------------------------------------------------------------------
!    call simult to solve for the in-cloud derivatives dT/dp (dtdp2), 
!    dw/dp (dwdp2) and dr/dp (drdp2) using the previously estimated
!    values at p + delta p, including the microphysical contributions.
!----------------------------------------------------------------------
      call don_cm_simult_k   &
           (diag_unit, debug_ijt, lfc_not_reached, Param, pcsave, rmu, &
            tcest, rest, west, ptop, qlwest, tetop, mretop, dtdp2,  &
            drdp2, dwdp2, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!--------------------------------------------------------------------
!    if in diagnostics column, output the lfc flag (lfc_not_reached), and
!    the temperature, cloud radius and vertical velocity tendencies 
!    returned from subroutine simult.
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, l4, 2e20.12)')  &
            'in cloudm: TESTLC,DTDP2,DPD2= ',lfc_not_reached,DTDP2,drdp2
        write (diag_unit, '(a, e20.12)')  'in cloudm: DWDP2= ',DWDP2
      endif

!--------------------------------------------------------------------
!    define new values of cloud radius and vertical velocity at level
!    k+1 using the values at level k and the vertical derivatives
!    returned from subroutine simult. if either of these values is below
!    its acceptable bound, set both values to 0.0 and exit the loop -- 
!    the cloud top has been reached.
!--------------------------------------------------------------------
      rcltop   = rclbot + drdp2*Param%dp_of_cloud_model
      wvtop    = wvbot  + dwdp2*Param%dp_of_cloud_model
      if ((wvtop <= Param%wbound) .or. (rcltop   <= Param%rbound)) then 
        rcltop   = 0.0
        wvtop    = 0.
        flag = .true.
        return
      endif

!--------------------------------------------------------------------
!    average the two derivatives calculated for temperature, vertical
!    velocity and cloud radius. define the cloud temperature at the
!    k+1 level as the value at k + the  effect of the calculated deriv-
!    ative.
!--------------------------------------------------------------------
      dtdp = 0.5*(dtdp + dtdp2)
      dwdp = 0.5*(dwdp2 + dwdp)
      drdp = 0.5*(drdp + drdp2)
      tcctop   = tccbot + dtdp*Param%dp_of_cloud_model

!--------------------------------------------------------------------
!    call subroutine freeze_liquid to define the amount of liquid in 
!    the updraft is frozen in the current layer.
!--------------------------------------------------------------------
      call don_cm_freeze_liquid_k   &
           (k, diag_unit, debug_ijt, Param, tccbot, tcctop, qlwest, &
            dfrac, dtfr, dtupa, dfrtop, sumfrea, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!--------------------------------------------------------------------
!    add the effect of droplet freezing to the cloud temperature.
!--------------------------------------------------------------------
      tcctop   = tcctop   + dfrtop  

!--------------------------------------------------------------------
!    define the values of vertical velocity and cloud radius at level 
!    k+1 using the averaged values of dw/dp and dr/dp. if either of 
!    these values is below its acceptable bound, set both values to 0.0
!    and exit the loop -- the cloud top has been reached.
!--------------------------------------------------------------------
      wvtop    = wvbot  + dwdp*Param%dp_of_cloud_model
      rcltop   = rclbot + drdp*Param%dp_of_cloud_model
      if ((wvtop <= Param%wbound) .or. (rcltop <= Param%rbound)) then 
        rcltop   = 0.0
        wvtop    = 0.
        flag = .true.
        return
      endif
 
!--------------------------------------------------------------------
!    define the pressure at which nsemble member #l becomes buoyant (its
!    level of free convection). all ensemble members must have their 
!    cloud top pressure lower than this value.
!--------------------------------------------------------------------
      if (kou == 1) then
        if ((lfc_not_reached) .and. (wvtop > wvbot))  then
          pcsave = ptop     
        endif
      endif

!--------------------------------------------------------------------
!    check to see if the level of free convection has been reached. if
!    so, set the logical variable indicating such (lfc_not_reached) to  
!    be .false..
!--------------------------------------------------------------------
      if (wvtop   > wvbot)  then
        lfc_not_reached = .false.
      endif

!--------------------------------------------------------------------
!    define the vapor mixing ratio for the new cloud temperature at
!    level k+1.
!--------------------------------------------------------------------
      call compute_mrs_k (tcctop, ptop, Param%D622, Param%D608,  &
                          rsctop, nbad)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (nbad /= 0) then
        ermesg = 'subroutine don_cm_move_parcel_k: '// &
                 'temperatures out of range of esat table'
        error = 1
        return
      endif

!--------------------------------------------------------------------
!    if in diagnostics column, output the values of environmental 
!    temperature (te) and mixing ratio (mre) and in-cloud mixing ratio 
!    (rsc) at level k+1.
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, f20.14, 2e20.12)')  &
                   'in cloudm: TE,QE,RSC= ',tetop  , mretop  , rsctop  
      endif

!--------------------------------------------------------------------
!    define the layer-mean cloud radius (rbar) and entrainment coef-
!    ficient (rmub).  if the cloud radius is less than the lower bound,
!    exit the loop -- the cloud top has been reached.
!--------------------------------------------------------------------
      rbar = 0.5*(rclbot + rcltop  )
      if (rbar <= Param%rbound) then
        flag = .true.
        return   
      endif

!---------------------------------------------------------------------
!    call micro to calculate the microphysical terms which occur during
!    the parcel movement from p to p + delta p using the second itera-
!    tion values for the cloud conditions at level k + 1.
!---------------------------------------------------------------------
      call don_cm_micro_k   &
           (diag_unit, debug_ijt, Param, tccbot, tcctop, pbot, ptop, &
            tebot, tetop, mrebot, mretop, wvbot, wvtop, rbar, rmu,  &
            qrw, qcw, qlw, dcw1, dqrw3, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!---------------------------------------------------------------------
!    save the final values of cloud water, rainwater and total liquid
!    that are found at level k+1 in arrays disc, disd and qlwa.
!---------------------------------------------------------------------
      qlwatop = qlw

!--------------------------------------------------------------------
!    if in diagnostics column, output the values of in-cloud temperature
!    (tcc), vertical velocity (wv), liquid water (qlw), condensation
!    (dcw1) and precipitation (dqrw3) at level k+1.
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, f20.14, 2e20.12)') &
                     'in cloudm: TCC(k+1),WV(k+1),QLW= ',tcctop  ,  &
                      wvtop  , qlw
        write (diag_unit, '(a, 2e20.12)')  &
                        'in cloudm: DCW1,DQRW3= ',dcw1, dqrw3
      endif

!---------------------------------------------------------------------


end subroutine don_cm_move_parcel_k




!######################################################################

subroutine don_cm_lcl_k    &
         (Param, t_init, p_init, mr_init, t_lcl, p_lcl, mr_lcl,  &
          lcl_reached, ermesg, error)

!---------------------------------------------------------------------
!    subroutine don_cm_lcl_k computes the lifting conden-
!    sation level by raising a parcel with temperature t_init and vapor 
!    mixing ratio mr_init adiabatically from pressure p_init until satur-
!    ation is reached at pressure p_lcl, temperature t_lcl and vapor 
!    mixing ratio mr_lcl. a flag lcl_reached is set to .true. to indicate
!    that the lcl was successfully reached.
!---------------------------------------------------------------------

use donner_types_mod, only : donner_param_type
use sat_vapor_pres_k_mod, only: compute_mrs_k

implicit none

!-----------------------------------------------------------------------
type(donner_param_type), intent(in)   :: Param
real,                    intent(in)   :: t_init, p_init, mr_init
real,                    intent(out)  :: t_lcl, p_lcl, mr_lcl
logical,                 intent(out)  :: lcl_reached
character(len=*),        intent(out)  :: ermesg
integer,                 intent(out)  :: error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      t_init         temperature of parcel at its launch point
!                     [ deg K ]
!      p_init         pressure of the parcel at its launch point [ Pa ]
!      mr_init        mixing ratio of the parcel at its launch point
!                     [ kg(h2o) / kg(air) ]
!
!   intent(out) variables:
!
!      t_lcl          temperature at lifting condensation level 
!                     [ deg K ]
!      p_lcl          pressure at lifting condensation level [ Pa ]
!      mr_lcl         mixing ratio of parcel at lifting condensation
!                     level [ kg(h2o) / kg(air) ]
!      lcl_reached    lcl was reached for this parcel ?
!
!----------------------------------------------------------------------


!---------------------------------------------------------------------
!   local variables:

      real    ::  t_parcel, p_start, p_end, gamma, rs, kappa_moist
      integer ::  max_levels
      integer ::  k, nbad

!---------------------------------------------------------------------
!   local variables:
!
!      t_parcel     temperature of parcel at current level
!      p_start      pressure at start of current iteration [ Pa ]
!      p_end        pressure at end of current iteration [ Pa ]
!      gamma        adiabatic lapse rate for moist air at current 
!                   location [ deg K / Pa ] 
!      es           saturation vapor pressure at temperature t_parcel 
!                   [ Pa ]
!      rs           saturation mixing ratio at t_parcel and p_end 
!                   [ kg(h2o) / kg(air) ]
!      kappa_moist  exponent in expression for moist potential 
!                   temperature [ dimensionless ]
!      max_levels   maximum number of iterations of parcel movement
!                   which must be taken before knowing that the
!                   parcel will not undergo deep convection
!      k            do-loop index
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!    initialize the character string which will contain any error mes-
!    sages returned through this subroutine.
!---------------------------------------------------------------------
      ermesg = ' '  ; error = 0

!---------------------------------------------------------------------
!    define an approximation for kappa (R/Cp) for moist air 
!    (kappa_moist). 
!---------------------------------------------------------------------
      kappa_moist = (Param%RDGAS/Param%CP_AIR)*(1. +    &
                    (Param%RVGAS/Param%RDGAS -     &
                     Param%CP_VAPOR/Param%CP_AIR)*mr_init)
      
!---------------------------------------------------------------------
!    define the initial values for t_parcel (the parcel temperature) 
!    and p_start and p_end, which define the pressure increment through
!    which the parcel rises during the first iteration.
!---------------------------------------------------------------------
      t_parcel = t_init
      p_start  = p_init
      p_end    = p_start + Param%parcel_dp

!---------------------------------------------------------------------
!    initialize the output variables.
!---------------------------------------------------------------------
      p_lcl  = 0.
      t_lcl  = 0.
      mr_lcl = 0.
      lcl_reached = .false.

!---------------------------------------------------------------------
!    define the maximum number of increments (max_levels) that the 
!    parcel may be raised without reaching condensation before it is 
!    no longer viable as a deep convection parcel.
!---------------------------------------------------------------------
      max_levels = int( (p_init - Param%upper_limit_for_lfc)/  &
                        abs(Param%parcel_dp) ) + 1

!----------------------------------------------------------------------
!    raise the parcel in increments of parcel_dp, following the adia-
!    batic lapse rate for moist air, until either the lcl is reached
!    or the parcel is no longer capable of undergoing deep convection. 
!----------------------------------------------------------------------
      do k=1,max_levels

!---------------------------------------------------------------------
!    exit the loop if the parcel has risen beyond where deep convection
!    is possible.
!---------------------------------------------------------------------
        if (p_end < Param%upper_limit_for_lfc) exit

!---------------------------------------------------------------------
!    define the lapse rate of temp with respect to pressure for moist
!    air (gamma). update the parcel temperature to the value at the
!    top of this layer.
!---------------------------------------------------------------------
        gamma = kappa_moist*t_parcel/p_start
        t_parcel = t_parcel + gamma*Param%parcel_dp 

!---------------------------------------------------------------------
!    determine the saturation mixing ratio for this temperature and
!    pressure. 
!---------------------------------------------------------------------
        call compute_mrs_k (t_parcel, p_end,                  &
                            Param%d622 , Param%d608 , rs, nbad, &
                            mr = mr_init)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (nbad /= 0) then
          ermesg = 'subroutine don_cm_lcl_k: '// &
                   'temperatures out of range of esat table'
          error = 1
          return
        endif

!---------------------------------------------------------------------
!   determine if the parcel is saturated. if it is, define the lcl 
!   values of temperature (t_lcl), mixing ratio (mr_lcl) and pressure 
!   (p_lcl), and return to the calling routine.
!---------------------------------------------------------------------
        if (rs <= mr_init) then
          p_lcl = p_end
          t_lcl = t_parcel
          mr_lcl = mr_init                     
          lcl_reached = .true.
          exit
        endif

!---------------------------------------------------------------------
!    define the starting and ending pressures for the next iteration.
!---------------------------------------------------------------------
        p_start = p_end
        p_end   = p_end + Param%parcel_dp
      end do

!---------------------------------------------------------------------


 end subroutine don_cm_lcl_k  


!#####################################################################


subroutine don_cm_mesub_k     &
         (Nml, pfull_c, nlev_lsm, me, diag_unit, debug_ijt, Param, cu,           &
          ci_liq_cond, ci_ice_cond, pmelt_lsm, cell_precip, &
          dint, plzb_c, pb, pt_kou, temp_c, phalf_c,   &
          ca_liq, ca_ice, ecd, ecd_liq, ecd_ice, ecei_liq,   &
          ece, ece_liq, ece_ice, meso_freeze, meso_melt, ermesg, error)

!----------------------------------------------------------------------
!    subroutine mesub calculates mesoscale heat and moisture sources,
!    using a variation on the Leary and Houze (JAS, 1980) procedure.
!    the defined fields are condensate transferred from cell to anvil
!    (ca), condensate evaporated in convective downdrafts (ecd), conden-
!    sate evaporated in convective updrafts (ece), the condensate 
!    entering the anvil which has not yet been frozen (meso_freeze), and 
!    the amount of condensate which must be melted in the mesoscale down-
!    draft to assure ice conservation (meso_melt). the subroutine is 
!    called separately for each ensemble member. for notation, see 
!    "Cu Closure A notes," 2/97.
!----------------------------------------------------------------------

use donner_types_mod, only : donner_param_type, donner_nml_type

implicit none

!----------------------------------------------------------------------
type(donner_nml_type),         intent(in)    :: Nml
integer,                       intent(in)    :: nlev_lsm, me, diag_unit
logical,                       intent(in)    :: debug_ijt
type(donner_param_type),       intent(in)    :: Param
real,                          intent(in)    :: cu, cell_precip, dint, &
                                                plzb_c, pb, pt_kou
real,   dimension(nlev_lsm),   intent(in)    :: temp_c, pfull_c
real,   dimension(nlev_lsm+1), intent(in)    :: phalf_c
real,                          intent(out)   :: ca_liq, ca_ice
real,                          intent(in)    :: pmelt_lsm, &
                                                ci_liq_cond, ci_ice_cond
real,   dimension(nlev_lsm),   intent(out)   :: ecd, ece, meso_freeze, &
                                                meso_melt, &
                                                ecd_liq, ecd_ice, &
                                                ece_liq, ece_ice
real,                          intent(out)   :: ecei_liq
character(len=*),              intent(out)   :: ermesg
integer,                       intent(out)   :: error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!       cu           column integrated condensation integral
!                    [ mm / day ]
!       cell_precip  column integrated precipitation integral
!                    [ mm / day ]
!       dint???      water mass frozen in convective updraft
!            ??????  plus ice deposited convective updraft
!                    [ kg(h2o) /( (m**2) sec) ]
!                    weighted as cu,cell_precip
!       plzb_c       pressure at level of zero buoyancy [ Pa ]
!       ps           surface pressure [ Pa ]
!       pb           cloud-base pressure [ Pa ]
!       pt_kou       cloud-top pressure [ Pa ]
!       pmelt_lsm    pressure at bottom of layer in which melting 
!                    begins   [ Pa ]
!       phalf_c      large-scale model pressure half-levels (Pa)
!       debug_ijt    is this a diagnostics column ?
!       diag_unit    output unit number for this diagnostics column
!
!   intent(out) variables:
!
!       ca           total condensate transfered from cells to anvil 
!                    by this ensemble member [ mm/day ]
!       ecd          profile of condensate evaporated in convective
!                    downdraft on large-scale model grid 
!                    [ g(h2o) / kg(air) / day ] 
!       ece          profile of condensate evaporated in convective 
!                    updraft on large-scale model grid 
!                    [ g(h2o) / kg(air) / day ] 
!       meso_freeze  profile of condensate which is frozen upon enter-
!                    ing the anvil on the large-scale grid
!                    [ g(h2o) / kg(air) / day ] 
!       meso_melt    profile of condensate which is melted in mesoscale
!                    downdraft on large-scale model grid
!                    [ g(h2o) / kg(air) / day ] 
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:
 
      integer ::     k
      real    ::  avail_meso_cd     ! fraction of column integrated
                                    ! condensation available to meso-
                                    ! scale circulation (1. - gnu)
                                    ! [ dimensionless ]
      real    ::  caa               ! amount of condensate which must
                                    ! be frozen when it enters the anvil
                                    ! [ g(h2o) / kg(air) / day ]
      real    ::  dint2             ! amount of condensate which has
                                    ! been frozen in the cumulus updraft
                                    ! before entering the anvil
                                    ! [ g(h2o) / kg(air) / day ]
      real    ::  ecda              ! amount of condensate evaporated 
                                    ! in cumulus downdrafts
                                    ! [ g(h2o) / kg(air) / day ]
      real :: ecda_liq, ecda_ice
      real    ::  ecdi              ! amount of condensate evaporated 
                                    ! in cumulus downdrafts [ mm / day ]
      real :: ecdi_liq, ecdi_ice
      real    ::  ecea              ! amount of condensate evaporated 
                                    ! in cumulus updrafts 
                                    ! [ g(h2o) / kg(air) / day ]
      real :: ecea_liq, ecea_ice
      real    ::  ecei              ! amount of condensate evaporated 
                                    ! in cumulus updrafts [ mm / day ]
      real ::           ecei_ice
      real    ::  elta              ! amount of condensate which must
                                    ! be melted in the mesoscale down-
                                    ! draft to conserve ice mass
                                    ! [ g(h2o) / kg(air) / day ]
      real    ::  gnu               ! fraction of column integrated 
                                    ! condensation which precipitates
                                    ! out [ dimensionless ]
      real    ::  ptt               ! pressure one cloud model delta p 
                                    ! above cloud top [ Pa ]
      real    ::  pzm               ! pressure at base of mesoscale 
                                    ! circulation [ Pa ]
      real    ::  pztm              ! pressure at top of mesoscale cir-
                                    ! culation [ Pa ]
      real    ::  p1                ! lower pressure limit for the layer
                                    ! in which one of the physical
                                    ! processes is occurring [ Pa ]
      real    ::  p2                ! upper pressure limit for the layer
                                    ! in which one of the physical
                                    ! processes is occurring [ Pa ]
      integer :: itrop
      real    :: ptrop

!---------------------------------------------------------------------
!   local variables:
!
!      
      ermesg = '  ' ; error = 0

!---------------------------------------------------------------------
!    define pressure one cloud-model level above cloud top (ptt). 
!    define the pressure at top of mesoscale updraft (pztm, 300 hPa 
!    plus one model-layer pressure thickness above cloud top).
!---------------------------------------------------------------------
      ptt = pt_kou + Param%dp_of_cloud_model
      pztm = ptt - 300.E02

!---------------------------------------------------------------------
!    restrict pztm to >= 100 hPa, cf Ackerman et al (JAS,1988), unless 
!    pt_kou <= 100 hPa. it was found in AM2p9 that the stratospheric 
!    water vapor was excessive with this pztm restriction, so pztm is now
!    set to be no higher than the level of zero buoyancy, or if the
!    cloud top is above the level of zero buoyancy, it is set to one 
!    model layer above the level of zero buoyancy. 
!---------------------------------------------------------------------
      if (pztm < plzb_c) pztm = plzb_c
      if (ptt < plzb_c)  pztm = plzb_c + Param%dp_of_cloud_model

      if (Nml%limit_pztm_to_tropo) then
        call find_tropopause (nlev_lsm, temp_c, pfull_c, ptrop, itrop)
        pztm = MAX (pztm, ptrop)
      endif

!---------------------------------------------------------------------
!    define the base of the mesoscale updraft (pzm), as the layer imm-
!    ediately above cloud top, or, if the top of the mesoscale updraft
!    has been redefined to be at or just above the level of zero 
!    buoyancy, to be one layer below the mesoscale updraft top. 
!---------------------------------------------------------------------
      pzm = ptt
      if (pzm <= pztm) pzm = pztm - Param%dp_of_cloud_model

!---------------------------------------------------------------------
!    if in a diagnostics column, output the convective rain 
!    (cell_precip), convective updraft condensation (cu), and the pres-
!    sure at the level of zero buoyancy (plzb_c).
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12)') 'in mesub: rc,cu= ',  &
                                                    cell_precip, cu
        write (diag_unit, '(a,  e20.12)') 'in mesub: plzb = ',plzb_c
      endif

!----------------------------------------------------------------------
!    define the ratio of precipitation to condensation for the current
!    ensemble member (gnu). define the remaining fraction of condens-
!    ation 1 - gnu as the condensate available to the mesoscale circ-
!    ulation (avail_meso_cd). define the mass of this available conden-
!    sate which is evaporated in convective downdrafts (ecdi), the mass
!    evaporated into the cell environment (ecei) and the portion incor-
!    porated into the mesoscale region (ca). this partitioning is 
!    defined by the parameters evap_in_downdraft, evap_in_environ and 
!    entrained_into_meso, taken from the work of Leary and Houze 
!    (JAS, 1980).
!----------------------------------------------------------------------
      gnu = cell_precip/cu
      avail_meso_cd = 1. - gnu
      ecdi  = (Param%evap_in_downdrafts*avail_meso_cd)*cu
      ecdi_liq  = (Param%evap_in_downdrafts*avail_meso_cd)* &
                         (Param%seconds_per_day*ci_liq_cond)
      ecdi_ice  = (Param%evap_in_downdrafts*avail_meso_cd)*     &
                         (Param%seconds_per_day*ci_ice_cond)
      ecei  = (Param%evap_in_environ*avail_meso_cd)*cu
      ecei_liq  = (Param%evap_in_environ*avail_meso_cd)*    &
                         (Param%seconds_per_day*ci_liq_cond)
      ecei_ice  = (Param%evap_in_environ*avail_meso_cd)*     &
                         (Param%seconds_per_day*ci_ice_cond)
      ca_liq    = (Param%entrained_into_meso*avail_meso_cd)*   &
                         (Param%seconds_per_day*ci_liq_cond)
      ca_ice    = (Param%entrained_into_meso*avail_meso_cd)*   &
                         (Param%seconds_per_day*ci_ice_cond)
      if (debug_ijt) then
        write (diag_unit, '(a, 3e20.12)')  &
               'in mesub: cu, h1_liqintg, h1_iceintg= ',  &
            cu, ci_liq_cond*Param%seconds_per_day      ,  &
                 ci_ice_cond*Param%seconds_per_day      
      endif

!---------------------------------------------------------------------
!    if in a diagnostics column, output the ratio of convective rain 
!    to convective updraft condensation (gnu) and the mass entrained
!    into the mesoscale region (ca).
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, e20.12)')  'in mesub: gnu= ',gnu
        write (diag_unit, '(a, e20.12)') 'in mesub: ca= ',  &
                                                       ca_liq + ca_ice
        write (diag_unit, '(a, 2e20.12)') 'in mesub: ca_liq,ca_ice= ', &
                                                ca_liq, ca_ice
      endif

!--------------------------------------------------------------------
!    calculate the mass of water which must be frozen as it enters the
!    mesoscale anvil (caa). if no freezing has occurred in the cumulus
!    updraft (i.e., dint2 = 0) then this will be ca, the total mass 
!    available to the anvil. if freezing has occurred, (ie, 
!    dint2 /= 0.), then the amount to be frozen is the total amount 
!    available (ca) plus additional vapor mass deposited on the ice in 
!    the updraft (ecei), less that which has already frozen (dints). 
!    dints and caa are expressed in units of g(h2o) per kg(air) per day.
!--------------------------------------------------------------------
!9/15/07, 1037AM:
      dint2 = avail_meso_cd*(dint                               )*  &
               8.64e07*Param%grav/(pzm - pztm)

      if (dint2 /= 0.)  then 
       caa = ((ca_liq + ecei_liq)*Param%grav*1000./(pzm - pztm)) - dint2
      else
        caa = ca_liq*Param%grav*1000./(pzm - pztm)
      endif

!---------------------------------------------------------------------
!    if in a diagnostics column, output the previously frozen condensate
!    (dint2), the additional amount to be frozen (caa) and the pressure
!    range over which the freezing will occur (pzm, pztm). if 
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a,  e20.12)')  &
                         'in mesub:     dint           =',    dint 
        write (diag_unit, '(a, 2e20.12)')  &
                         'in mesub:     dint2, ecei_liq=',    dint2, &
                                                          ecei_liq
        write (diag_unit, '(a, 3e20.12)')  &
                           'in mesub: caa,pzm,pztm= ',caa,pzm,pztm
      endif

!---------------------------------------------------------------------
!    if there is additional condensate which must be frozen upon enter-
!    ing the anvil, call map_hi_res_intgl_to_lo_res_col to spread this 
!    additional freezing uniformly over the region between anvil base 
!    (pzm) and anvil top (pztm) in the large-scale model. store the out-
!    put in array meso_freeze. if no additional freezing is needed, set 
!    meso_freeze to be 0.0.
!---------------------------------------------------------------------
      if (caa > 0.)  then 
        if (debug_ijt) then
          write (diag_unit, '(a, e20.12, 2f19.10)')  &
                      'in cm_intgl_to_gcm_col: xav,p1,p2= ',caa, pzm, &
                                                  pztm
        endif
        call don_u_map_hires_i_to_lores_c_k   &
             (nlev_lsm, caa, pzm, pztm, phalf_c, meso_freeze, ermesg, error)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (error /= 0 ) return
        if (debug_ijt) then
          do k=1,nlev_lsm       
            if (meso_freeze(k) /= 0.0) then
              write (diag_unit, '(a, i4, e20.12)') &
                    'in cm_intgl_to_gcm_col: k,x= ',k, meso_freeze   (k)
            endif
          end do
        endif
      else
        meso_freeze = 0.
      endif

!---------------------------------------------------------------------
!    define the evaporation which occurs in the convective downdraft.
!    the convective downdraft is assumed to originate one layer above
!    the cloud top (ptt) and extend to the surface (phalf_c(1)). 
!    convert the convective downdraft evaporation to units of
!    g(h20) / kg(air) per day.
!---------------------------------------------------------------------
      ecda = ecdi*Param%grav*1000./(phalf_c(1) - ptt)
      ecda_liq = ecdi_liq*Param%grav*1000./(phalf_c(1) - ptt)
      ecda_ice = ecdi_ice*Param%grav*1000./(phalf_c(1) - ptt)

!---------------------------------------------------------------------
!    if in a diagnostics column, output the convective downdraft evap-
!    oration (ecda) and the large-scale model pressure limits over which
!    this evaporation occurs (phalf_c(1), ptt).
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 3e20.12)')  &
                         'in mesub: ecda,p1,pz0= ',ecda,phalf_c(1),ptt
        write (diag_unit, '(a, 2e20.12)')  &
                         'in mesub: ecda_liq, ecda_ice= ',  &
                                ecda_liq, ecda_ice
      endif

!---------------------------------------------------------------------
!    call map_hi_res_intgl_to_lo_res_col to spread the integrated evap-
!    oration in convective downdrafts uniformly over the region between
!    the surface (phalf_c(1)) and the anvil base (pzm) and the top of 
!    cloud (ptt). output field is ecd.
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, e20.12, 2f19.10)')  &
             'in cm_intgl_to_gcm_col: xav,p1,p2= ',ecda, phalf_c(1) , &
                                                  ptt 
      endif
      call don_u_map_hires_i_to_lores_c_k   &
           (nlev_lsm, ecda, phalf_c(1), ptt, phalf_c, ecd, ermesg, error)
      call don_u_map_hires_i_to_lores_c_k   &
         (nlev_lsm, ecda_liq, phalf_c(1), ptt, phalf_c, ecd_liq, ermesg, error)
      call don_u_map_hires_i_to_lores_c_k   &
         (nlev_lsm, ecda_ice, phalf_c(1), ptt, phalf_c, ecd_ice, ermesg, error)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return
      if (debug_ijt) then
        do k=1,nlev_lsm       
          if (ecd(k) /= 0.0) then
            write (diag_unit, '(a, i4, e20.12)') &
                'in cm_intgl_to_gcm_col: k,ecd= ',k, ecd   (k)
            write (diag_unit, '(a, i4, 2e20.12)') &
              'in cm_intgl_to_gcm_col: k,ecdliq,ecdice= ',k, &
                       ecd_liq(k), ecd_ice(k)
          endif
        end do
      endif

!---------------------------------------------------------------------
!    be sure that the melting level in the large-scale model (pmelt_lsm)
!    is below the top of the mesoscale circulation (pztm),and above
!    cloud base (pb). if not, no melting will occur; set p2 to be 0.0.
!---------------------------------------------------------------------
      elta = 0.
      if (pmelt_lsm  < pztm                    )  then
        meso_melt = 0.
      if (debug_ijt) then
        write (diag_unit, '(a, 2f19.10)') &
                 ' NO MELTING DONE: melting level above top of &
                    &mesoscale circulation : pmelt_lsm,pztm',     &
                                                pmelt_lsm, pztm      
      endif

!---------------------------------------------------------------------
!    if pmelt_lsm is within the region of the cloud and mesoscale circ-
!    ulation, calculate any melting that must occur in the mesoscale
!    downdraft in order to conserve ice mass; ie, if the amount to be
!    frozen was calculated as more than the available condensate, then
!    the excess must be melted, and is done so in the mesoscale down-
!    draft between the melting level and cloud base.
!---------------------------------------------------------------------
      else if (pmelt_lsm >= pztm .and. pmelt_lsm <= pb) then
        p2 = pmelt_lsm
        p1 = pb
        if (caa <= 0.) then 
          caa = -caa*(pzm - pztm)/(pb - p2)
          elta = caa
        endif
      if (debug_ijt) then
        write (diag_unit, '(a, 3f19.10)') &
                   'MELTING DONE: pmelt_lsm,pb,caa  ',pmelt_lsm, pb, &
                                                            caa  
      endif

!---------------------------------------------------------------------
!    if in diagnostics column, output the melting (elta) and the 
!    pressures defining the layer in which it occurs (pb, p2)
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, e20.12, 2f19.10)') &
                           'in mesub: elta,p1,p2= ',elta,p1,p2
      endif

!---------------------------------------------------------------------
!    call map_hi_res_intgl_to_lo_res_col to spread the required melting
!    resulting from excessive freezing over the layer between cloud base
!    and the melting level. output field is meso_melt.
!---------------------------------------------------------------------
      call don_u_map_hires_i_to_lores_c_k   &
           (nlev_lsm, elta, p1, p2, phalf_c, meso_melt, ermesg, error)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return
      if (debug_ijt) then
        do k=1,nlev_lsm       
          if (meso_melt(k) /= 0.0) then
            write (diag_unit, '(a, i4, e20.12)') &
                 'in cm_intgl_to_gcm_col: k,meso_melt= ',k, meso_melt(k)
          endif
        end do
      endif

      else if (pmelt_lsm > pb) then
        meso_melt = 0.
        if (pmelt_lsm == phalf_c(1)) then
          if (debug_ijt) then
             write (diag_unit, '(a)') &
                   'NO MELTING LEVEL PRESENT IN COLUMN'
          endif
        else
! melt below cloud base 
      if (debug_ijt) then
        write (diag_unit, '(a, 2f19.10)') &
            ' NO MELTING DONE: melting level below PB: pmelt_lsm,pb', &
                                                      pmelt_lsm, pb
      endif
      endif
      endif ! (pmelt<pztm or pmelt > pb)

!---------------------------------------------------------------------
!    calculate the evaporation which occurs in the convective 
!    updraft.
!    this is spread between 50 hPa below cloud top and 10 hPa above 
!    cloud top.
!---------------------------------------------------------------------
      p1 = pt_kou + 50.0e02
      p2 = ptt
      ecea = ecei*Param%grav*1000./(p1-p2)
      ecea_liq = ecei_liq*Param%grav*1000./(p1-p2)
      ecea_ice = ecei_ice*Param%grav*1000./(p1-p2)

!---------------------------------------------------------------------
!    if in diagnostics column, output the convective updraft evaporation
!    (ecea, ecei) and the large-scale model pressure layer limits over 
!    which it occurs (p1, p2).
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12)')  &
                         'in mesub: ecea,ecei= ',ecea, ecei
        write (diag_unit, '(a, 2e20.12)')  &
                         'in mesub: LIQecea,ecei= ',ecea_liq, ecei_liq
        write (diag_unit, '(a, 2e20.12)')  &
                         'in mesub: ICEecea,ecei= ',ecea_ice, ecei_ice
        write (diag_unit, '(a, e20.12, 2f19.10)')  &
                         'in mesub: ecea,p1,p2= ',ecea, p1, p2
      endif

!---------------------------------------------------------------------
!    call map_hi_res_intgl_to_lo_res_col to spread the integrated evap-
!    oration in convective updrafts uniformly over the designated 
!    region.  output field is ece.
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, e20.12, 2f19.10)')  &
                      'in cm_intgl_to_gcm_col: xav,p1,p2= ',ecea, p1, &
                                                  p2
      endif
      call don_u_map_hires_i_to_lores_c_k   &
           (nlev_lsm, ecea, p1, p2, phalf_c, ece, ermesg, error)
      call don_u_map_hires_i_to_lores_c_k   &
           (nlev_lsm, ecea_liq, p1, p2, phalf_c, ece_liq, ermesg, error)
      call don_u_map_hires_i_to_lores_c_k   &
           (nlev_lsm, ecea_ice, p1, p2, phalf_c, ece_ice, ermesg, error)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return
      if (debug_ijt) then
        do k=1,nlev_lsm     
          if (ece(k) /= 0.0) then
            write (diag_unit, '(a, i4, e20.12)') &
                           'in cm_intgl_to_gcm_col: k,x= ',k, ece   (k)
          endif
        end do
      endif

!---------------------------------------------------------------------


end subroutine don_cm_mesub_k



!######################################################################

subroutine don_cm_compute_vert_fluxes_k   &
         (nlev_hires, ntr, ncc_kou, kou, diag_unit, debug_ijt, &
          do_donner_tracer, Param, pt_kou, cld_press, rcl, te, mre, wv, &
          tcc, dpf, xclo, xtrae, apt, efchr, emfhr, etfhr, ermesg, error)

!---------------------------------------------------------------------
!    subroutine compute_vertical_fluxes computes vertical flux conver-
!    gence terms and their column integrals for temperature, entropy, 
!    moisture and tracers within the cloud. 
!---------------------------------------------------------------------

use donner_types_mod, only : donner_param_type
use sat_vapor_pres_k_mod, only: compute_qs_k

implicit none 

!---------------------------------------------------------------------
integer,                            intent(in)     :: nlev_hires, ntr,  &
                                                      ncc_kou, kou,  &
                                                      diag_unit
logical,                            intent(in)     :: debug_ijt,   &
                                                      do_donner_tracer
type(donner_param_type),            intent(in)     :: Param
real,                               intent(in)     :: pt_kou
real,    dimension(nlev_hires),     intent(in)     :: cld_press, rcl,  &
                                                      te, mre, wv, tcc, &
                                                      dpf
real,    dimension(nlev_hires,ntr), intent(in)     :: xclo, xtrae      
real,                               intent(out)    :: apt               
real,    dimension(nlev_hires),     intent(out)    :: efchr, emfhr    
real,    dimension(nlev_hires,ntr), intent(out)    :: etfhr            
character(len=*),                   intent(out)    :: ermesg
integer,                            intent(out)    :: error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      pt_kou      pressure at cloud top [ Pa ]
!      cld_press   pressure at full levels in cloud model [ Pa ]
!      rcl         vertical profile of cloud radius [ m ]
!      te          environmental temperature profile [ deg K ]
!      mre         environmental vapor mixing ratio profile 
!                  [ kg(h2o) / kg (dry air) ]
!      wv          in-cloud vertical velocity profile [ m / sec ]
!      tcc         in-cloud temperature profile [ deg K ] 
!      xclo        in-cloud tracer profiles 
!                  [ kg(tracer) / kg (dry air) ]
!      xtrae       environmental tracer profiles 
!                  [ kg(tracer) / kg (dry air) ]
!      debug_ijt   logical indicating whether diagnostics are desired
!                  for column
!      ncc_kou     cloud model level index of level at or above 
!                  cloud top
!      kou         index of current ensemble member 
!      diag_unit   output unit for diagnostics for this column
!
!   intent(out) variables:
!
!      apt         ratio of cloud area at cloud top to that at cloud 
!                  base [ dimensionless ]
!      efchr       vertical entropy flux convergence [ deg K / sec ]
!      emfhr       vertical moisture flux convergence 
!                  [ kg(h2o) / ( kg(dry air) sec ] 
!      etfhr       vertical tracer flux convergence 
!                  [ kg(tracer) / ( kg(dry air) sec ] 
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      real, dimension(nlev_hires)       ::  dpdz, q_sat, ehf, emf
      real, dimension(nlev_hires,ntr) ::  etf                      
      real, dimension(ntr)      ::  sumetf
      real                        ::  p, pl, ph, dpp, ptt, exf, &
                                      thetf, tv_env, tv_cld,  &
                                      dpdz_cb, sumemf, sumefc, sumthet
      integer                     ::  kcl, kch
      integer                     ::  kc, kcont, nbad


!---------------------------------------------------------------------
!   local variables:
!
!        dpdz            value of dp/dz, evaluated from hydrostatic
!                        equation, with virtual mass coefficient to
!                        account for non-hydrostatic effects. see
!                        Donner, 1986, j. atmos. sci., 43, p 2288.
!                        [ kg(air) / (sec**2 m**2) ]
!        q_sat           saturation specific humidity 
!                        [ kg(h2o) / kg (air) ]
!        ehf             vertical temperature flux 
!                        [ ( kg(air) deg K ) / (m sec**3) ]
!        emf             vertical moisture flux
!                        [ kg (h2o) / (m sec**3) ]
!        etf             vertical tracer flux
!                        [  kg(tracer) / (m sec**3) ]
!        sumetf          column integral of vertical tracer flux 
!                        convergence [  kg(tracer) / (m sec**3) ]
!        p               pressure  at level where subgrid scale temper-
!                        ature flux is calculated [ Pa ]
!        pl              pressure at lower flux interface [ Pa ]
!        ph              pressure at upper flux interface [ Pa ]
!        dpp             pressure depth over which flux is being 
!                        calculated [ Pa ]
!        ptt             pressure one level above cloud top [ Pa ]
!        exf             perturbation vertical subgrid scale temp-
!                        erature flux [ ( kg(air) deg K ) / (m sec**3) ]
!        thetf           vertical flux of potential temperature at
!                        cloud base [ ( kg(air) deg K ) / (m sec**3) ]
!        esat            saturation vapor pressure [ Pa ]
!        tv_env          environmental virtual temperature [ deg K ]
!        tv_clda         in-cloud virtual temperature [ deg K ]
!        dpdz_cb         value of dp/dz over the lowest cloud model
!                        pressure layer [ kg(air) / (sec**2 m**2) ]
!        sumemf          column integral of vertical moisture flux 
!                        convergence [ kg (h2o) / (m sec**3) ]
!        sumefc          column integral of vertical entropy flux 
!                        convergence [ ( kg(air) deg K ) / (m sec**3) ]
!        sumthet         column integral of vertical potential temper-
!                        ature flux convergence 
!                        [ ( kg(air) deg K ) / (m sec**3) ]
!        kcl             k index of lower interface level
!        kch             k index of upper interface level
!        kc, kcont       do-loop indices
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    initialize the character string which will contain any error mes-
!    sages returned through this subroutine.
!---------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!--------------------------------------------------------------------
!    initialize the output arrays.
!--------------------------------------------------------------------
      do kc=1,nlev_hires
        do kcont=1,ntr
          etfhr(kc,kcont) = 0.
        end do
        efchr(kc) = 0.
        emfhr(kc) = 0.
      end do

!---------------------------------------------------------------------
!    initialize variables which will collect column sums.
!---------------------------------------------------------------------
      sumemf    = 0.
      sumefc    = 0.
      sumthet   = 0.
      sumetf(1:ntr) = 0.

!--------------------------------------------------------------------
!    initialize the ratio of cloud area at cloud top to cloud area at 
!    cloud base. 
!--------------------------------------------------------------------
      apt = 0.

!---------------------------------------------------------------------
!    loop over the cloud model levels from cloud base (kc=1) to the 
!    level just below cloud top (ncc_kou-1), defining variables needed 
!    for the flux convergence calculations.
!---------------------------------------------------------------------
      do kc=1,ncc_kou-1 

!---------------------------------------------------------------------
!    define the environmental and in-cloud virtual temperatures. NOTE: 
!    q_sat is correctly a specific humidity; mre(kc) is incorrectly a 
!    mixing ratio.
!---------------------------------------------------------------------
        call compute_qs_k (tcc(kc), cld_press(kc), Param%D622,  &
                           Param%D608, q_sat(kc), nbad)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (nbad /= 0) then
          ermesg = 'subroutine don_cm_compute_vert_fluxes_k: '// &
                   'temperatures out of range of esat table'
          error = 1
          return
        endif
        tv_env     = te(kc)* (1. + Param%d608*(mre(kc)/(1. + mre(kc))))
        tv_cld     = tcc(kc)*(1. + Param%d608*q_sat(kc))

!---------------------------------------------------------------------
!    compute dp/dz (dpdz) as in equation (B3) in Donner (1986), 
!    j. atm. sci., 43, pp 2277-2288.  here the expression uses the 
!    pressure mid-way between cloud base and level 2. compute vertical 
!    eddy transport of temperature (ehf), moisture (emf) and tracers
!    (etf), using equation (3) from Donner et al (1982), j. atm. sci.,
!    39, pp 2159-2181. multiply by dpdz to put flux in pressure (omega) 
!    units. note (1 - a) is approximated as 1. note that q_sat is a 
!    specific humidity while mre is a mixing ratio.
!---------------------------------------------------------------------
        if (kc == 1) then

!--------------------------------------------------------------------
!    at cloud base level, calculate dpdz valid over the interval between
!    level 1 and level 2 (dpdz_cb). this term is needed to determine 
!    the subgrid scale vertical temperature flux valid in the first 
!    cloud layer.
!--------------------------------------------------------------------
          dpdz_cb = -Param%grav*(0.5*(cld_press(1) + cld_press(2)))* &
                    (Param%virt_mass_co*tv_env + tv_cld)/(Param%rdgas*  &
                    (1. + Param%virt_mass_co)*tv_env*tv_cld)

!----------------------------------------------------------------------
!    when at cloud top, calculate dpdz and the cloud perturbation flux 
!    terms that are valid for the model layer including cloud top. save
!    these values as index ncc_kou of the various arrays.
!--------------------------------------------------------------------
        else if (kc == ncc_kou-1) then
          dpdz(ncc_kou) = -Param%grav*pt_kou*(    &
                          Param%virt_mass_co*tv_env + tv_cld)/   &
                          (Param%rdgas*(1. + Param%virt_mass_co)*  &
                          tv_env*tv_cld)
          ehf(ncc_kou) = ((rcl(ncc_kou-1)/Param%cloud_base_radius)**2)* &
                         wv(ncc_kou-1)*dpdz(ncc_kou)*   &
                         (tcc(ncc_kou-1) - te(ncc_kou-1))
          emf(ncc_kou) = ((rcl(ncc_kou-1)/Param%cloud_base_radius)**2)* &
                         wv(ncc_kou-1)*dpdz(ncc_kou)*    &
                         (q_sat(ncc_kou-1)/(1. - q_sat(ncc_kou-1)) - &
                                                         mre(ncc_kou-1))
          do kcont=1,ntr
            etf(ncc_kou,kcont) = ((rcl(ncc_kou-1)/  &
                                 Param%cloud_base_radius)**2)* &
                                 wv(ncc_kou-1)*dpdz(ncc_kou)*  &
                                 (xclo(ncc_kou-1,kcont) -   &
                                                  xtrae(ncc_kou-1,kcont))
          end do
        endif

!---------------------------------------------------------------------
!    compute dpdz and the vertical eddy flux terms at interior cloud
!    levels.
!---------------------------------------------------------------------
        dpdz(kc) = -Param%grav*cld_press(kc)*  &
                   (Param%virt_mass_co*tv_env + tv_cld)/&
                   (Param%rdgas*(1. + Param%virt_mass_co)*tv_env*tv_cld)
        ehf(kc) = ((rcl(kc)/Param%cloud_base_radius)**2)*wv(kc)*  &
                  dpdz(kc)*(tcc(kc) - te(kc))
        emf(kc) = ((rcl(kc)/Param%cloud_base_radius)**2)*wv(kc)*   &
                  dpdz(kc)*(q_sat(kc)/(1. - q_sat(kc)) - mre(kc))
        do kcont=1,ntr
          etf(kc,kcont) = ((rcl(kc)/Param%cloud_base_radius)**2)*  &
                            wv(kc)*dpdz(kc)*  &
                            (xclo(kc,kcont) - xtrae(kc,kcont))
        end do
      end do

!--------------------------------------------------------------------
!    loop over levels from cloud base to the highest level within
!    the cloud to compute the eddy flux convergence profiles.
!--------------------------------------------------------------------
      do kc=1,ncc_kou-1  

!--------------------------------------------------------------------
!    define the lower interface index (kcl) to be one less than 
!    the current level. at cloud base, define the lower interface index
!    to be the current index. define the lower interface pressure (pl).
!    if the lower interface is at or above cloud top, calculation is
!    complete in this column, so return. define the upper interface 
!    pressure (ph) to be the pressure one level above the current index.
!    define the delta p between the interface pressures (dpp).
!--------------------------------------------------------------------
        kcl = MAX (1, kc-1)
        pl = cld_press(kcl)
        if (pl <= pt_kou) return
        ph = cld_press(kc+1)
        dpp = (ph - pl)/2.0

!---------------------------------------------------------------------
!     if the upper interface pressure is not above cloud top, set the 
!     upper interface index (kch) to be one above the current index. set
!     the current level pressure p to be the average value of the higher
!     and lower level pressures, which will be the current level value,
!     except at the lowest level. 
!---------------------------------------------------------------------
        if (ph >= pt_kou) then
          kch = kc + 1
          p = (pl + ph)/2.0

!---------------------------------------------------------------------
!     if the upper interface pressure is above cloud top, set the 
!     upper interface index (kch) to be the current value (kc), and set
!     the upper interface and current level pressures to be the cloud 
!     top pressure.  define the ratio of cloud-top cloud area to cloud-
!     base cloud area (apt).
!---------------------------------------------------------------------
        else
          kch = kc
          ph = pt_kou
          p = pt_kou
          apt = (rcl(kc)/rcl(1))**2
        endif

!!$$^%S^&A^^^**
!!    SHOULDN'T dpp be defined here, after any adjustnment to ph has 
!     BEEN MADE ???? Problem would be at topmost layer.
!!$$^%S^&A^^^**

!---------------------------------------------------------------------
!    if in a debug column, output values of cloud-level indices and 
!    cloud temperature, along with environmental mixing ratio and
!    temperature at these levels.
!---------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, 3i4)')  &
                             'in mulsub: kc,kcl,kch= ',kc,kcl,kch
          write (diag_unit, '(a, 3e20.14)')  &
                         'in mulsub: TCC = ',TCC(kc),TCC(kcl),TCC(kch)
          write (diag_unit, '(a, 3e20.12)')  &
                              'in mulsub: QE= ',mrE(kc),mrE(kcl),mrE(kch)
          write (diag_unit, '(a, 3e20.12)')   &
                              'in mulsub: TE= ',TE(kc),TE(kcl),TE(kch)
        endif

!----------------------------------------------------------------------
!    define the perturbation vertical subgrid scale temperature flux 
!    associated with the cloud (exf). note the special definitions at
!    cloud bottom and top.
!----------------------------------------------------------------------
        if (kc == 1) then
          exf = Param%rdgas*wv(kc)*dpdz_cb*(tcc(kc) - te(kc))*  &
                ((rcl(kc)/Param%cloud_base_radius)**2)/(Param%cp_air*p)
        else if (kc == kch) then
          exf = Param%rdgas*wv(kc)*dpdz(ncc_kou)*(tcc(kc) - te(kc))*  &
                ((rcl(kc)/Param%cloud_base_radius)**2)/(Param%cp_air*p)
        else             
          exf = Param%rdgas*wv(kc)*dpdz(kc)*(tcc(kc) - te(kc))*   &
                ((rcl(kc)/Param%cloud_base_radius)**2)/(Param%cp_air*p)
        endif

!----------------------------------------------------------------------
!    at the cloud top, define the cumulus vertical-flux convergence of 
!    temperature, moisture and tracers as the flux transport entering 
!    the layer which contains cloud top. this "through the top" trans-
!    port is assumed to be all deposited in this layer which includes 
!    cloud top. set the vertical eddy transports of temperature, moist-
!    ure and tracer at the uppermost interior cloud level to zero.
!----------------------------------------------------------------------
        if (kc == kch) then
          efchr(ncc_kou ) = ehf(ncc_kou)/Param%dp_of_cloud_model
          emfhr(ncc_kou ) = emf(ncc_kou)/Param%dp_of_cloud_model
          ehf(ncc_kou-1) = 0.
          emf(ncc_kou-1) = 0.

!##$%$%$%^&^&!!&&*** 
!!!???? is this correct ? shouldn't the flux across the upper interface
!!! of this layer be accounted for ?  I..e., 

!!!!     efchr(ncc-1) = exf +  (ehf(ncc-2) - ehf(ncc))/(2.*dpp)

!!   As it stands, it appears that all the flux into the ncc-1 layer 
!!   (ehf(ncc-2)) remains. however, some (ehf(ncc)) is exported 
!    into the ncc layer (above cloud top), suggesting a non-conservation
!!!   condition.
!##$%$%$%^&^&!!&&*** 

          efchr(ncc_kou-1) = exf + (ehf(ncc_kou-2))/(2.*dpp)
          emfhr(ncc_kou-1) = emf(ncc_kou-2)/(2.*dpp)
          do kcont=1,ntr
            etfhr(ncc_kou,kcont) = etf(ncc_kou,kcont)/Param%dp_of_cloud_model
            etf(ncc_kou-1,kcont) = 0.
            etfhr(ncc_kou-1,kcont) = etf(ncc_kou-2,kcont)/(2.*dpp)
          end do

!----------------------------------------------------------------------
!    add the appropriately pressure-weighted contributions from the
!    layer containing cloud top to the integrals of the in-cloud vert-
!    ical-flux convergence of entropy, (sumefc) potential temperature
!    (sumthet), moisture (sumemf) and tracers (sumetf).
!----------------------------------------------------------------------
          sumefc = sumefc + efchr(ncc_kou)*Param%dp_of_cloud_model/2.
          ptt = pt_kou + Param%dp_of_cloud_model
          sumthet = sumthet + efchr(ncc_kou)*    &
                                   ((1.0e05/ptt)**Param%kappa)* &
                                               Param%dp_of_cloud_model/2.
          sumemf = sumemf + emfhr(ncc_kou)*Param%dp_of_cloud_model/2.
          do kcont=1,ntr
            sumetf(kcont) = sumetf(kcont) + etfhr(ncc_kou,kcont)*  &
                            Param%dp_of_cloud_model/2.
          end do

!----------------------------------------------------------------------
!    if in diagnostic column, output the entropy and moisture flux 
!    convergence in the layer containing cloud top.
!----------------------------------------------------------------------
          if (debug_ijt) then 
            write (diag_unit, '(a, e20.12)')  &
                      'in mulsub: EFCHR(kc+1)= ',efchr(ncc_kou)
            write (diag_unit, '(a, e20.12)')  &
                          'in mulsub: EMFHRIT=kch ',emfhr(ncc_kou)
          endif

!---------------------------------------------------------------------
!    for all but the topmost layer, define the layer flux convergences
!    of entropy (efchr), moisture (emfhr) and tracers (etfhr). the ver-
!    tical flux convergence of entropy (efchr) is defined as the sum of
!    the in-cloud perturbation vertical subgrid scale temperature flux 
!    (exf) and the eddy flux convergence of temperature across 
!    the layer.
!---------------------------------------------------------------------
        else
          efchr(kc) = exf + (ehf(kcl) - ehf(kch))/(2.*dpp)
          emfhr(kc) = (emf(kcl) - emf(kch))/(2.*dpp)
          do kcont=1,ntr
            etfhr(kc,kcont) = (etf(kcl,kcont) - etf(kch,kcont))/(2.*dpp)
          end do
        endif

!----------------------------------------------------------------------
!    add the appropriately pressure-weighted contributions from the
!    current layer to the integrals of the in-cloud vertical-flux con-
!    vergence of entropy, (sumefc) potential temperature (sumthet), 
!    moisture (sumemf) and tracers (sumetf).
!----------------------------------------------------------------------
        sumefc  = sumefc  + (efchr(kc)*dpp)
        sumthet = sumthet + efchr(kc)*((1.0e05/p)**Param%kappa)*dpp
        sumemf  = sumemf  + (emfhr(kc)*dpp)
        do kcont=1,ntr
          sumetf(kcont) = sumetf(kcont) + etfhr(kc,kcont)*dpp
        end do

!---------------------------------------------------------------------
!    if in diagnostic column, write out the current vertical sum of 
!    the entropy and potential temperature flux convergence. output the
!    vertical flux of theta (thetf) and moisture (emf) at cloud base.
!    output the in-cloud (xclo) and environmental (xtrae) tracer 
!    mixing ratios.  if this is the 4th cumulus subensemble, output 
!    some fluxes, flux convergences, dpdz and other terms related to 
!    the flux calculation.
!---------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, 2e20.12)')  &
                    'in mulsub: SUMTHET,SUMEFC= ',sumthet, sumefc
          do kcont=1,ntr
            write (diag_unit, '(a, e20.12)')'in mulsub: SUMETF=', &
                                           sumetf(kcont)
          end do
          if (kc == 1) then
            thetf = ehf(kcl)*((1.0e05/pl)**Param%kappa)
            write (diag_unit, '(a, 2e20.12)')  &
                             'in mulsub: THETF,EMFF= ',thetf,emf(kcl)
          endif
          do kcont=1,ntr
            write (diag_unit, '(a, 3i4, 2e20.12)')  &
                   'in muls:kou,k,kcont,xclo,xtrae=' &
                    ,kou,kc,kcont,xclo(kc,kcont),xtrae(kc,kcont)
          end do
          if (kou == 4) then
            write (diag_unit, '(a, i4, 2f19.10)') &
                                  'in mulsub: kc,PL,PH= ',kc, pl, ph
            write (diag_unit, '(a, 4e20.12)')  &
                'in mulsub: EHFH,EHFL,EXF,efchr(kc)= ', &
                        ehf(kch), ehf(kcl), exf, efchr(kc)
            write (diag_unit, '(a, 3e20.12)')   &
                          'in mulsub: EMFH,EMFL,EMF= ',  &
                         emf(kch), emf(kcl), emfhr(kc)
            if (do_donner_tracer) then
              write (diag_unit, '(a, 3e20.12)')   &
                       'in mulsub: ETFH,ETFL,ETF=         ', &
                     etf(kch,ntr), etf(kcl,ntr), etfhr(kc,ntr)
            endif
            write (diag_unit, '(a, 3e20.12)')   &
                               'etfh diag: rcl,wv,dpdzh=         ', &
                                    rcl(kch), wv(kch), dpdz(kch)
            write (diag_unit, '(a, 3e20.12)')   &
                                'etfl diag: rcl,wv,dpdzl=         ', &
                                    rcl(kcl), wv(kcl), dpdz(kcl)
            do kcont=1,ntr
              write (diag_unit, '(a, 3e20.12)')  &
                                   'etfh diag: xclo,xtrae= ',         &
                                   xclo(kch,kcont), xtrae(kch,kcont)
              write (diag_unit, '(a, 3e20.12)')  &
                                 'etfl diag: xclo,xtrae= ',         &
                                   xclo(kcl,kcont), xtrae(kcl,kcont)
            end do
            write (diag_unit, '(a, 3e20.12)')   &
                            'in mulsub: WV,RH,QE= ',  &
                                     wv(kch), q_sat(kch), mre(kch)
            write (diag_unit, '(a, 3e20.12)')   &
                            'in mulsub: WV,RL,QE= ',   &
                                     wv(kcl), q_sat(kcl), mre(kcl)
          endif 
        endif
      end do  ! (end of kc loop)

!----------------------------------------------------------------------
!    if this is a debug column, output the moisture and temperature 
!    tendency profiles produced by this ensemble member.
!----------------------------------------------------------------------
      if (debug_ijt) then
        call don_cm_output_member_tends_k  &
             (nlev_hires, ncc_kou, diag_unit, Param, tcc, dpf,  &
              efchr, emfhr, cld_press, ermesg, error) 
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (error /= 0 ) return
      endif

!------------------------------------------------------------------


end subroutine don_cm_compute_vert_fluxes_k



!#####################################################################

subroutine don_cm_output_member_tends_k    &
         (nlev_hires, ncc_kou, diag_unit, Param, tcc, dpf,   &
          efchr, emfhr, cld_press, ermesg, error) 

!----------------------------------------------------------------------
!    subroutine don_cm_output_member_tends_k prints out
!    the temperature (ctfhr) and moisture (cmfhr) tendency profiles 
!    produced by the current ensemble member.
!----------------------------------------------------------------------

use donner_types_mod, only : donner_param_type

implicit none 

!----------------------------------------------------------------------
integer,                     intent(in)  :: nlev_hires, ncc_kou,  &
                                            diag_unit
type(donner_param_type),     intent(in)  :: Param
real, dimension(nlev_hires), intent(in)  :: tcc, dpf, efchr, emfhr, &
                                            cld_press
character(len=*),            intent(out) :: ermesg
integer,                     intent(out) :: error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!     ncc_kou        vertical index on cloud model grid of the level
!                    above cloud top (maximum number of vertical
!                    levels affected by current cloud)
!     diag_unit      unit number for column diagnostics output, if 
!                    diagnostics are requested for the current column
!     tcc            temperature field at cloud model levels
!                    [ degrees K ]
!     dpf            condensation rate profile 
!                    [ kg(h2o) / ( kg(air) sec) ]
!     efchr          profile of entropy tendency due to flux 
!                    convergence [ deg K / sec ]
!     emfhr          profile of moisture tendency due to flux 
!                    convergence [ kg(h2o) / (kg(air) sec) ]
!     cld_press      pressure at cloud model levels [ Pa ]
!     
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      real, dimension(nlev_hires)     :: cmfhr, ctfhr
      real                            :: convrat
      integer                         :: k

!---------------------------------------------------------------------
!   local variables:
!
!      cmfhr     moisture tendency due to flux convergence and 
!                condensation [ kg(h2o) / (kg(air) sec) ]
!      ctfhr     entropy tendency due to flux convergence and 
!                condensation [ deg K / sec ]
!      convrat   latent heat factor used with condensation term in 
!                entropy equation [ deg K ]
!      k         do-loop index
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    initialize the character string which will contain any error mes-
!    sages returned through this subroutine.
!---------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!---------------------------------------------------------------------
!    define the tendency terms at the levels within the cloud.
!---------------------------------------------------------------------
      do k=1,ncc_kou

!---------------------------------------------------------------------
!    define the appropriate latent heat to be used at the current 
!    cloud level. use the latent heat of vaporization for temperatures
!    at or above the freezing point (Param%tfre) and the latent heat of 
!    sublimation at temperatures lower than the freezing point. 
!---------------------------------------------------------------------
        if (tcc(k) >= Param%tfre) then
          convrat = Param%hlv/Param%cp_air   
        else
          convrat = Param%hls/Param%cp_air   
        endif

!---------------------------------------------------------------------
!    define the entropy tendency as the sum of the vertical flux conver-
!    gence of entropy (efchr) and the latent heat release.
!---------------------------------------------------------------------
        ctfhr(k) = -dpf(k)*convrat + efchr(k)

!---------------------------------------------------------------------
!     define the moisture tendency as the sum of vertical flux conver-
!     gence and total condensation. 
!---------------------------------------------------------------------
        cmfhr(k) = dpf(k) + emfhr(k)
      end do

!---------------------------------------------------------------------
!    set the values at layers above cloud top to 0.0.
!---------------------------------------------------------------------
      cmfhr(ncc_kou+1:nlev_hires) = 0.
      ctfhr(ncc_kou+1:nlev_hires) = 0.

!---------------------------------------------------------------------
!  ctfhr : cloud ensemble entropy tendency due to flux convergence and
!          condensation       
!          [ deg K / sec ]
!---------------------------------------------------------------------
      do k=1,nlev_hires       
        if (ctfhr(k) /= 0.0) then
          write (diag_unit, '(a, i4, 2e20.12)')  &
                    'in mulsub: k, P & cond/efc              =',    &
                     k, cld_press(k),ctfhr(k)
        endif
      end do

!---------------------------------------------------------------------
!  cmfhr : cloud ensemble moisture tendency due to flux convergence and
!          condensation       
!          [ kg(h2o) / (kg(air) sec) ]
!---------------------------------------------------------------------
      do k=1,nlev_hires       
        if (cmfhr(k) /= 0.0) then
          write (diag_unit, '(a, i4, 2e20.12)')  &
                   'in mulsub: k, P & cond/mfc              =',    &
                     k, cld_press(k),cmfhr(k)
        endif
      end do

!---------------------------------------------------------------------


end subroutine don_cm_output_member_tends_k


!#####################################################################


subroutine don_cm_process_condensate_k     &
       (nlev_lsm, nlev_hires, ntr, cldtop_indx, diag_unit, debug_ijt, &
        Param, acpre, accond, pb, pt_kou, pf, pftr, tcc, rcl, &
        cld_press, phalf_c, conint, dint, pmel, pmelt_lsm, precip, cu,&
        cell_precip, sumlhr, summel, dpf, dpftr, dfr, cell_melt, ermesg, error)

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------

use donner_types_mod, only : donner_param_type

implicit none

!----------------------------------------------------------------------
integer,                      intent(in)    :: nlev_lsm, nlev_hires, &
                                               ntr, &
                                               cldtop_indx, diag_unit
logical,                      intent(in)    :: debug_ijt  
type(donner_param_type),      intent(in)    :: Param
real,                         intent(in)    :: acpre, accond, pb, pt_kou
real, dimension(nlev_hires),  intent(in)    :: pf, tcc, rcl, cld_press
real, dimension(nlev_hires,ntr), intent(in) :: pftr
real, dimension(nlev_lsm+1),  intent(in)    :: phalf_c
real,                         intent(inout) :: conint, dint,         &
                                               pmel, precip, cu, &
                                               cell_precip, sumlhr, &
                                               summel
real,                          intent(in) :: pmelt_lsm
real, dimension(nlev_hires),  intent(inout) :: dfr
real, dimension(nlev_hires),  intent(out)   :: dpf
real, dimension(nlev_hires,ntr),  intent(out)   :: dpftr
real, dimension(nlev_lsm),    intent(out)   :: cell_melt
character(len=*),             intent(out)   :: ermesg
integer,                      intent(out)   :: error
              

      real    :: dmela
      integer  :: k, kc, n
 
!---------------------------------------------------------------------
!    initialize the character string which will contain any error mes-
!    sages returned through this subroutine.
!---------------------------------------------------------------------
      ermesg = ' ' ; error = 0

      dpf(1:nlev_hires) = 0.
      dpftr(:,:) = 0.
      precip = 0.
      conint = 0.


      if (cldtop_indx /= 0) then
!--------------------------------------------------------------------
!    loop over the cloud levels to adjust various outputs as needed.
!--------------------------------------------------------------------
        do k=1,cldtop_indx

!--------------------------------------------------------------------
!    convert the layer-mean values of cloud-area-weighted condensation 
!    (pf) and wet deposition (pftr)
!    to values at cloud model interfaces (dpf and dpftr).
!--------------------------------------------------------------------
          if (k == 1) then
            dpf(1) =     pf(1)
            do n=1,ntr
              dpftr(1,n) =     pftr(1,n)
            end do
          else 
            dpf(k) = 0.5*(pf(k) + pf(k-1))
            do n=1,ntr
              dpftr(k,n) = 0.5*(pftr(k,n) + pftr(k-1,n))
            end do
          endif 
          if (k == cldtop_indx) then
            dpf(cldtop_indx+1) = 0.5*pf(cldtop_indx)
            do n=1,ntr
              dpftr(cldtop_indx+1,n) = 0.5*pftr(cldtop_indx,n)
            end do
          endif
        end do
      endif ! (cldtop_indx /= 0)

!--------------------------------------------------------------------
!    if in a diagnostics column, output the freezing (dfr) and conden-
!    sation (dpf) rates and cloud radius (rcl) at each cloud model
!    level, before normalization by the cloud base area.
!----------------------------------------------------------------------
      do k=1,cldtop_indx + 2
        if (debug_ijt) then
          write (diag_unit, '(a, i4, 3e20.12)')  &
                'in mulsub: k,dfr,dpr,rcl= ', k, dfr(k) ,dpf(k), rcl(k)
        endif
        if (debug_ijt) then
          write (diag_unit, '(a, i4, 3e20.12)')  &
                'in mulsub: k,dpf,pf,pfavg= ', k, dpf(k) ,pf(k),  &
! note pf(k-1) when k=1 is garbage !
                                  0.5*(pf(k) + pf(k-1))
        endif
 
!--------------------------------------------------------------------
!    normalize the freezing rate and condensation rate profiles by the
!    cloud base area of ensemble member #1.
!--------------------------------------------------------------------
        dfr(k) = dfr(k)/(Param%cloud_base_radius**2)
        dpf(k) = dpf(k)/(Param%cloud_base_radius**2)
        do n=1,ntr
          dpftr(k,n) = dpftr(k,n)/(Param%cloud_base_radius**2)
        end do
 
!----------------------------------------------------------------------
!    if in a diagnostics column, output the freezing (dfr) and conden-
!    sation (dpf) rates and cloud radius (rcl) at each cloud model
!    level, after normalization by the cloud base area.
!----------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, i4, 3e20.12)')  &
               'in mulsub: k,dfr,dpr,rcl= ', k, dfr(k), dpf(k), rcl(k)
          do n=1,ntr
            write (diag_unit, '(a, i4, e20.12)')  &
                'in mulsub: k,dpftr= ', k, dpftr(k,n)
          end do
        endif
      end do

      if (cldtop_indx /= 0) then
        do k=1,cldtop_indx
          conint = conint + pf(k)*Param%dp_of_cloud_model/Param%grav  
        if (debug_ijt) then
          write (diag_unit, '(a, i4, 2e20.12)')  &
                          'in mulsub: kc, PF,coninT= ',k, pf(k)*  &
                                Param%dp_of_cloud_model/Param%grav, &
                                                            conint  
        endif
        end do

!--------------------------------------------------------------------
!    if in diagnostics column, output the ensemble member number (kou), 
!    moisture convergence integral (sub1sum),  and condensation 
!    integral (conint).
!--------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, e20.12, a)')  &
                   'in cloudm: CONINT= ',CONINT,' KG/(M**2)/SEC'
        endif

!--------------------------------------------------------------------
!    normalize the column integral of condensate by the cloud base area
!    of ensemble member #1. 
!--------------------------------------------------------------------
        conint = conint/(Param%cloud_base_radius**2)

!--------------------------------------------------------------------
!    define the precipitation generated by this ensemble member.
!--------------------------------------------------------------------
        precip = conint*acpre/accond
      endif ! (cldtop_indx /= 0)

!--------------------------------------------------------------------
!    define the condensation (cu) and precipitation rates (cell_precip) 
!    in units of mm(h2o) per day. add this ensemble member's contribution
!    to the total precipitation (ensmbl_precip) and condensation
!    (ensmbl_cond), normalized by the ensemble member's cloud base area.
!--------------------------------------------------------------------
      cu  = conint*Param%seconds_per_day
      cell_precip  = precip*Param%seconds_per_day
 
!----------------------------------------------------------------------
!    if in a diagnostics column, output the condensation (conint),
!    precipitataion (precip) and freezing (dint) rates for this ensemble
!    member, in both kg per m**2 per second and in mm per day.
!----------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 3e20.12, a)')  &
                   'in mulsub: CONPRE, CPRE,DINT= ', conint, precip, &
                      dint, ' KG/(M**2)/SEC'
        write (diag_unit, '(a, e20.12, a)')   &
                    'in mulsub: CONDENSATION PRE= ', cu, ' MM/DAY'
        write (diag_unit, '(a, e20.12, a)')  &
                 'in mulsub: CLOUD MODEL PRE= ', cell_precip, ' MM/DAY'
      endif

!---------------------------------------------------------------------
!    compute the contribution to the column integrals of total conden-
!    sation (sumlhr) and frozen condensate from the lowest cloud layer.
!    units are kg(h2o) per square meter per second.
!---------------------------------------------------------------------
      sumlhr = (dpf(1)*((Param%dp_of_cloud_model/2.)/Param%grav))
      if (tcc(1) <= Param%tfre) then
        summel = (Param%dp_of_cloud_model/2.)*dpf(1)/Param%grav  
      else
        summel = 0.
      endif

!---------------------------------------------------------------------
!    if in a diagnostics window, output the condensation rate and
!    accumulated condensate integral at level 1.
!---------------------------------------------------------------------
      if (debug_ijt) then
        kc = 1
        write (diag_unit, '(a, i4, 2e20.12)')  &
                               'in mulsub: kc,DPF, SUMLHR= ',kc, &
               dpf(1)*((Param%dp_of_cloud_model/2.)/Param%grav),   &
                                                sumlhr
      endif

!--------------------------------------------------------------------
!    add the contributions from the remaining cloud layers to the 
!    integrals.
!--------------------------------------------------------------------
      do kc = 2,cldtop_indx+1

!---------------------------------------------------------------------
!    add the density weighted increment of column condensate to the 
!    array accumulating it (sumlhr). if in diagnostic column, write
!    out the condensate at the level and the current vertical sum of 
!    the column condensate.
!---------------------------------------------------------------------
        sumlhr = sumlhr + (dpf(kc)*(Param%dp_of_cloud_model/Param%grav))
        if (debug_ijt) then
          write (diag_unit, '(a, i4, 2e20.12)')  &
                         'in mulsub: kc,DPF,SUMLHR= ',kc,   &
               dpf(kc)*(Param%dp_of_cloud_model/Param%grav),   &
                                                               sumlhr
        endif

!---------------------------------------------------------------------
!    if the temperature is at or below the freezing level, add the 
!    current-level's density-weighted condensation to the array accum-
!    ulating the total frozen condensate in the column (summel).
!---------------------------------------------------------------------
        if (tcc(kc) <= Param%tfre) then
          summel = summel +  Param%dp_of_cloud_model*dpf(kc) /Param%grav 
        endif
      end do

!---------------------------------------------------------------------
!    if in diagnostics column, output the column integral of frozen 
!    condensate (summel). determine the amount of this condensate which
!    precipitates out by multiplying by the factor (cell_precip/cu).  add
!    this amount to the amount frozen in the updraft (dint) to obtain the
!    total amount which must be melted in the column (dints).
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, e20.12)')  'summel= ',summel
      endif

!--------------------------------------------------------------------
!    define the cloud model pressure at the level where melting occurs 
!    (pmel). 
!---------------------------------------------------------------------
      pmel = pb             
      do kc=1,cldtop_indx
        if ((tcc(kc) >= Param%kelvin) .and.   &
            (tcc(kc+1) <= Param%kelvin))  pmel = cld_press(kc)
      end do
      if (tcc(cldtop_indx+1) == Param%kelvin) pmel = pt_kou 
          if (debug_ijt) then
            write (diag_unit, '(a, 3e20.12 )')  &
             'pmelt_lsm, pmel from hi-res, pb   = ', pmelt_lsm, pmel, pb
          endif

!---------------------------------------------------------------------
!    if there has been no freezing in the column, then there will be
!    no melting.
!---------------------------------------------------------------------
      dmela = 0.
      if (dint == 0.) then
        cell_melt(1:nlev_lsm) = 0.
      else

!--------------------------------------------------------------------
!    if the melting level is above cloud base, partition the integrated
!    ice melt from the cloud model within the appropriate large-scale 
!    model layers.
!--------------------------------------------------------------------
        if (pb > pmelt_lsm) then

!--------------------------------------------------------------------
!    define the rate of ice melt (dmela) in units of g(h2o) per 
!    kg(air) per day. 
!--------------------------------------------------------------------
          if (cu /= 0.0) then
! melt ice precip plus frozen liq precip
            dmela = -((summel*cell_precip/cu + dint*cell_precip/cu)*  &
                                  Param%grav/(pmelt_lsm - pb))*8.64E07
         endif

!--------------------------------------------------------------------
!    call map_hi_res_intgl_to_lo_res_col to distribute this integrated 
!    column melting over the appropriate pressure interval on the 
!    large-scale model grid. if in a diagnostic column, output the 
!    melting rates as mapped to the large-scale grid.
!--------------------------------------------------------------------
          if (debug_ijt) then
            write (diag_unit, '(a, e20.12, 2f19.10)')  &
              'in cm_intgl_to_gcm_col: dmela,pb,pmelt_lsm= ',  &
                                                 dmela, pb, pmelt_lsm
          endif
          call don_u_map_hires_i_to_lores_c_k  &
            (nlev_lsm, dmela, pb, pmelt_lsm, phalf_c, cell_melt, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (error /= 0 ) return

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
          if (debug_ijt) then
            do k=1,nlev_lsm              
              if (cell_melt(k) /= 0.0) then
                write (diag_unit, '(a, i4, e20.12)') &
                 'in cm_intgl_to_gcm_col: k,cell_melt= ',k,cell_melt(k)
              endif
            end do
          endif

!---------------------------------------------------------------------
!    if the melting level is at or below cloud base, then there is no
!    in-cloud melting of frozen condensate.
!---------------------------------------------------------------------
        else
          cell_melt(1:nlev_lsm) = 0.
        endif  ! ( pb > pmel)
      endif  !  (dint == 0.0)


!---------------------------------------------------------------------
!    change the sign of the integral and convert to units of kg(h2o)
!    per square meter per day (or mm per day). if in diagnostics col-
!    umn, output the column integrated melting (summel), precipitation 
!    (cell_precip) and condensation rates (cu) in units of mm per day.
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 3e20.12,a)')   &
             'in mulsub: summel,rc,cu= ',    &
        -(summel*cell_precip/cu)*Param%seconds_per_day,cell_precip,cu, &
                                            'mm/day'
      endif

!---------------------------------------------------------------------


end subroutine don_cm_process_condensate_k



!#####################################################################


subroutine don_cm_simult_k   &
         (diag_unit, debug_ijt, lfc_not_reached, Param, pcsave, rmu,  &
          cloud_temp, cloud_radius, w_vel, cloud_p, liq_wat, env_temp, &
          env_mixing_ratio, dtdp,  drdp, dwdp, ermesg, error)

!--------------------------------------------------------------------
!    subroutine simult returns the vertical derivatives of temperature
!    (dtdp), cloud radius (drdp) and vertical velocity (dwdp) in the
!    cloud.
!    Reference: Donner, JAS, 1986, v43, pp.2277-2288.
!    See LJD "Cloud Model 89" notes on Generalized mu (10/1/89)
!    and dwdz (10/2/89). The value of epsilon is taken as 1.
!    Version where cloud properties independent of cloud area.
!--------------------------------------------------------------------

use donner_types_mod, only : donner_param_type
use sat_vapor_pres_k_mod, only: compute_qs_k

implicit none

!--------------------------------------------------------------------
integer,                 intent(in)    ::  diag_unit
logical,                 intent(in)    ::  debug_ijt, lfc_not_reached
type(donner_param_type), intent(in)    ::  Param
real,                    intent(in)    ::  pcsave, rmu, cloud_temp,  &
                                           cloud_radius, w_vel,   &
                                           cloud_p, liq_wat, env_temp, &
                                           env_mixing_ratio
real,                    intent(out)   ::  dtdp, drdp, dwdp
character(len=*),        intent(out)   ::  ermesg
integer,                 intent(out)   ::  error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!        cloud_temp  cloud temperature [ deg K ]
!        cloud_radius 
!                    cloud radius  [ m ]
!        w_vel       cloud vertical velocity [ m / s ] 
!        cloud_p     pressure at current level [ Pa ]
!        env_temp    environmental temperature [ deg K ]
!        env_mixing_ratio
!                    environmental mixing ratio [ kg / kg ]
!        liq_wat     liquid water [ kg / kg ]
!        pcsave      pressure at which cloud ensemble member 1 becomes
!                    buoyant [ Pa ]
!        rmu         entrainment coefficient [ m**(-1) ]
!        lfc_not_reached   if true, have not yet reached buoyant part of 
!                    cloud (vertical velocity has not yet begun to
!                    increase)
!        debug_ijt   is this a diagnostics column ?
!        diag_unit   output unit number for this diagnostics column
!
!   intent(out) variables:
!
!        dtdp        temperature derivative [ deg K / Pa ]
!        drdp        cloud radius derivative [ m / Pa ]
!        dwdp        vertical velocity derivative [ m / (sec Pa) ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      real  ::  areap, c2, c3, c4, dadp, dw2dz, dwdz, dzdp, dz, es,  &
                entrain_co, htv, htve, lat, rhoaw, rhoawp, &
                rstar, sphum, tcae, teae, test, west, w2test, wtest
      integer :: nbad

!---------------------------------------------------------------------
!   local variables:
!
!         areap             updated cloud area [ m**2 ]
!         c2                term in dt/dz eqn (eqn 5, Donner, JAS, 1993)
!         c3                term in dt/dz eqn (eqn 5, Donner, JAS, 1993)
!         c4                term in dt/dz eqn (eqn 5, Donner, JAS, 1993)
!         dadp              derivative of cloud area with respect to
!                           pressure [ m**2 / Pa ]
!         dw2dz             vertical derivative of vertical velocity
!                           squared with respect to height 
!                           [ m / sec**2 ]
!         dwdz              vertical derivative of vertical velocity
!                           with respect to height [ sec**(-1) ]
!         dzdp              dz/dp when virtual mass coefficient is
!                           used [ m / Pa ]
!         dz                delta z corresponding to dp_of_cloud_model
!                           [ m ]
!         es                saturation vapor pressure [ Pa ]
!         entrain_co        entrainment coefficient [ m**(-1) ]
!         htv               virtual temperature of cloud       [ deg K ]
!         htve              virtual temperature of environment [ deg K ]
!         lat               latent heat relevant at input temperature
!                           cloud_temp [ J/kg ]
!         rhoaw             rho * cloudarea * vertical velocity for
!                           input values [ kg / sec ]
!         rhoawp            rho * cloudarea * vertical velocity for
!                           updated values [ kg / sec ]
!         rstar             gas constant for moist air [ J / (kg degK) ]
!         sphum             saturation specific humidity [ kg / kg ]   
!         tcae              equivalent potential temperature in cloud
!                           [ deg K ]
!         teae              equivalent potential temperature in env-
!                           ironment [ deg K ]
!         test              updated temperature [ deg K ]
!         west              updated vetical velocity [ m / sec ]
!         w2test            updated vertical velocity squared (without
!                           entrainment term) [ m**2 / sec**2 ]
!         wtest             updated vertical velocity  (without
!                           entrainment term) [ m / sec ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    initialize the character string which will contain any error mes-
!    sages returned through this subroutine.
!---------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!---------------------------------------------------------------------
!   define appropriate latent heat for the given cloud temperature.
!---------------------------------------------------------------------
      if (cloud_temp < Param%tfre) then
        lat = Param%hls    
      else
        lat = Param%hlv   
      endif
 
!---------------------------------------------------------------------
!    define the specific humidity at the cloud temperature (sphum) and
!    the gas constant for moist air (rstar).
!---------------------------------------------------------------------
      call compute_qs_k (cloud_temp, cloud_p, Param%D622,  &
                           Param%D608, sphum, nbad, esat = es)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (nbad /= 0) then
        ermesg = 'subroutine don_cm_simult_k: '// &
                 'temperatures out of range of esat table'
        error = 1
        return
      endif

      rstar = Param%rdgas*(1. + Param%d608*sphum)

!---------------------------------------------------------------------
!    define the in-cloud (htv) and environmental (htve) virtual 
!    temperature.                                                       
!---------------------------------------------------------------------
      htv  = cloud_temp*(1. + Param%d608*sphum)
      htve = env_temp*(1. + Param%d608*(env_mixing_ratio/   &
                                                (1.0+env_mixing_ratio)))

!---------------------------------------------------------------------
!    if in diagnostics window, output the in-cloud and environmmental
!    virtual temperatures.
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12)')  &
                      'in simult: htve,htv= ',htve, htv
      endif

!---------------------------------------------------------------------
!    define one of the terms present in the dt/dz eqn (Eqn 5) in 
!    Donner, JAS, 1993, v50, pp.890-906.
!---------------------------------------------------------------------
      c2 = (htv + (lat*sphum/rstar))*Param%grav/(Param%cp_air*cloud_temp)

!---------------------------------------------------------------------
!    if in diagnostics window, output the c2 term in the dt/dz equation
!    and the environmmental temperature, moisture and pressure at this
!    level. 
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, e20.12)')  'in simult: c2= ',c2
        write (diag_unit, '(a, f20.14, f19.10, e20.12)')  &
              'in simult: te,p,qe= ',env_temp, cloud_p ,env_mixing_ratio
      endif

!--------------------------------------------------------------------
!    call tae to calculate environmental adiabatic equivalent 
!    temperature (teae).
!--------------------------------------------------------------------
      call don_cm_tae_k    &
           (Param, env_temp, cloud_p, env_mixing_ratio, lat, teae,  &
            ermesg, error)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!---------------------------------------------------------------------
!    if in diagnostics window, output the environmental adiabatic 
!    equivalent temperature.
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, f20.14)') 'in simult: teae= ',teae
      endif

!--------------------------------------------------------------------
!    calculate in-cloud adiabatic equivalent temperature (tcae).
!--------------------------------------------------------------------
      tcae = cloud_temp*exp(lat*sphum/(Param%cp_air*cloud_temp))

!----------------------------------------------------------------------
!    define dz/dp in the presence of a virtual mass coefficient (used
!    to roughly account for non-hydrostatic effects). define the cor-
!    resonding dz for the cloud model pressure increment dp.
!    Reference: Donner, JAS, 1986, v43, pp.2277-2288.
!----------------------------------------------------------------------
      dzdp = -Param%rdgas*(1. + Param%virt_mass_co)*htv*htve/    &
                                (Param%grav*cloud_p*  &
                                      (Param%virt_mass_co*htve + htv))
      dz   = Param%dp_of_cloud_model*dzdp

!---------------------------------------------------------------------
!    define the remaining terms (c3, c4) in the dt/dz equation (eqn (5)
!    in the reference cited below).
!    note : the entrainment coefficient (dln(rho*a*w)/dz) is given by 
!    (exp(rmu*dz) - 1.)/(exp(rmu*dz)*dz), with assumption that 
!    rhoaw(z) = rhoaw(0)*exp(rmu*dz)
!    Reference: Donner, JAS, 1993, v50, pp.890-906.
!---------------------------------------------------------------------
      entrain_co = (exp(rmu*dz) - 1.0)/(exp(rmu*dz)*dz)
      c3 = (tcae - teae)/exp(lat*sphum/(Param%cp_air*cloud_temp))*  &
                                                               entrain_co
      c4 = 1. + (Param%d622*lat*(Param%hlv*es/     &
                   (Param%rvgas*(cloud_temp**2)))/(Param%cp_air*cloud_p))

!---------------------------------------------------------------------
!    if in diagnostics window, output the c3 and c4 terms in the dt/dz 
!    equation.
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12)')  'in simult: c3,c4= ',c3,c4
      endif

!---------------------------------------------------------------------
!    define the dt/dp tendency by combining the component terms 
!    in the dt/dz equation and multiplying by dz/dp. define an 
!    updated estimated value of in-cloud temperature (test).
!---------------------------------------------------------------------
      dtdp = -((c2 + c3)/c4)*dzdp
      test = cloud_temp + dtdp*Param%dp_of_cloud_model

!--------------------------------------------------------------------
!    define the buoyancy and drag terms in the d(w**2)/dz equation. 
!    Reference: Donner, JAS, 1993, v50, pp.890-906.
!--------------------------------------------------------------------
      dw2dz = 2.0*((Param%grav*(htv - htve)/      &
                                  (htve*(1. + Param%virt_mass_co))) -  &
                                                      Param%grav*liq_wat)

!-------------------------------------------------------------------
!    produce an updated vertical velocity squared (wtest) by adding this
!    tendency term to the input value. be sure w**2 is positive; then 
!    define the vertical velocity.
!-------------------------------------------------------------------
      w2test = (w_vel**2) + dw2dz*dz
      if (w2test < 0.) then
        wtest = 0.
      else
        wtest = sqrt(w2test)
      endif

!---------------------------------------------------------------------
!    if in diagnostics window, output the updated vertical velocity.
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, l4, e20.12)')  &
                     'in simult: testlc,wtest= ',lfc_not_reached, wtest
      endif

!----------------------------------------------------------------------
!    define the dw/dp derivative from this updated value, ignoring the 
!    entrainment term.
!----------------------------------------------------------------------
      dwdp = (wtest - w_vel)/Param%dp_of_cloud_model

!----------------------------------------------------------------------
!    determine if the necessary conditions for entrainment are present.
!    allow entrainment to change vertical velocity if parcel has 
!       (1) previously achieved initial acceleration 
!           (.not. lfc_not_reached) 
!           and it has ascended above the level where the most entrain-
!           ing parcel (ensemble member #1) initially accelerates or,
!       (2) the parcel is currently accelerating. 
!    the first condition ensures that a shallow, lower-entrainment cloud
!    will not develop below the pressure where the most entraining
!    parcel initially accelerates.
!----------------------------------------------------------------------
      if ( ((.not. lfc_not_reached) .and. (cloud_p <= pcsave)) .or.   &
           (dwdp <= 0.) ) then
        dwdz = -w_vel*entrain_co
        dwdp = (dwdz*dzdp) + dwdp
      endif

!----------------------------------------------------------------------
!    if the parcel has not reached the level of free convection, do
!    not allow its vertical velocity to decrease. BL turbulence or 
!    other sub-grid mechanisms are assumed present to sustain its
!    upward motion.
!----------------------------------------------------------------------
      if ((lfc_not_reached) .and. (dwdp > 0.) )  then
        dwdp = 0.
      endif

!----------------------------------------------------------------------
!    if the parcel is above its level of free convection  but below
!    the pressure level at which the ensemble member #1 initially 
!    accelerates, do not allow its vertical velocity to decrease. this
!    ensures that less entraining clouds will not develop between the
!    ground and the pressure at which the most entraining parcel 
!    initally accelerates. BL turbulence or some other sub-grid 
!    mechanism is assumed to sustain its upward motion.
!----------------------------------------------------------------------
      if ( (.not. lfc_not_reached) .and. (cloud_p > pcsave) .and.    &
           (dwdp > 0.) )  then
        dwdp = 0.
      endif

!---------------------------------------------------------------------
!    if in diagnostics window, output the updated vertical velocity.
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a,l4,  2e20.12)')  &
          'in simult: testlc,dwdp,test= ',lfc_not_reached,dwdp,test
      endif

!---------------------------------------------------------------------
!    produce an updated vertical velocity (eqn (6) of reference).
!---------------------------------------------------------------------
      west = w_vel + dwdp*Param%dp_of_cloud_model

!--------------------------------------------------------------------
!    calculate the terms in the cloud area tendency equation.
!    Reference: Donner, JAS, 1993, v50, pp.890-906.
!--------------------------------------------------------------------
      if (west < Param%wdet) then

!--------------------------------------------------------------------
!    if the updated vertical velocity is weaker than the detrainment
!    velocity, set the cloud radius tendency to 0.0,maintaining the
!    input value.
!--------------------------------------------------------------------
        drdp = 0.
      else

!--------------------------------------------------------------------
!    define the value of rho*cloudarea*vertical velocity (rhoaw) for 
!    the input values of these variables. define the same quantity at 
!    a level dz higher (rhoawp), assuming rhoaw(z) = 
!    rhoaw(0)*exp(rmu*dz).
!--------------------------------------------------------------------
        rhoaw = cloud_p*(cloud_radius**2)*w_vel/(Param%rdgas*htv)
        rhoawp = rhoaw*exp((dzdp*rmu)*Param%dp_of_cloud_model)

!---------------------------------------------------------------------
!    if in diagnostics window, output rho*cloudarea*w obtained from
!    input values and at a height dz higher.
!---------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, f19.10, 2e20.12)')  &
                       'in simult: p,fm,fmp= ', cloud_p, rhoaw, rhoawp
        endif

!---------------------------------------------------------------------
!    define the virtual temperature (htv) corresponding to the updated 
!    temperature test.
!----------------------------------------------------------------------
        call compute_qs_k (test, cloud_p, Param%D622,  &
                           Param%D608, sphum, nbad)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (nbad /= 0) then
          ermesg = 'subroutine don_cm_simult_k: '// &
                   'temperatures out of range of esat table'
          error = 1
          return
        endif
        htv = test*(1. + Param%d608*sphum)

!----------------------------------------------------------------------
!    define the updated cloud area (areap). define the area tendency 
!    (dadp) and then the cloud radius tendency (drdp).
!----------------------------------------------------------------------
        areap = rhoawp*Param%rdgas*htv/  &
                               ((cloud_p + Param%dp_of_cloud_model)*west)
        dadp = (areap - (cloud_radius**2))/Param%dp_of_cloud_model
        drdp = dadp/(2.*cloud_radius)
      endif

!--------------------------------------------------------------------



end subroutine don_cm_simult_k




!####################################################################

subroutine don_cm_tae_k    &
         (Param, init_temp, init_pr, parcel_mixing_ratio, latent_heat,  &
          equivalent_temp, ermesg, error)

!--------------------------------------------------------------------
!    subroutine tae determines the saturation temperature of an init-
!    ially non-saturated parcel ( defined by init_temp, 
!    parcel_mixing_ratio, init_pr) by incrementally moving the parcel 
!    upward dry adiabatically until it reaches the temperature at which 
!    saturation would occur for the initial pressure init_pr.  using this
!    saturation temperature (te) and the parcel moisture 
!    parcel_mixing_ratio and pressure init_pr, the equivalent temperature
!    is calculated (the temperature attained if all vapor were condensed 
!    out by moist adiabatic ascent, followed by dry adiabatic descent to
!    the initial pressure level init_pr.
!--------------------------------------------------------------------

use donner_types_mod, only : donner_param_type
use sat_vapor_pres_k_mod, only: compute_mrs_k

implicit none

!--------------------------------------------------------------------
type(donner_param_type), intent(in)    :: Param
real,                    intent(in)    :: init_temp, init_pr,   &
                                          parcel_mixing_ratio,  &
                                          latent_heat
real,                    intent(out)   :: equivalent_temp
character(len=*),        intent(out)   :: ermesg
integer,                 intent(out)   :: error

!--------------------------------------------------------------------
!   intent(in) variables:
!
!        init_temp              temperature   [ deg K ]
!        init_pr                pressure      [ Pa ]
!        parcel_mixing_ratio    mixing ratio [kg(H2O)/kg (dry air) ]
!        latent_heat            applicable latent heat constant  [ J/kg ]
!
!   intent(out) variables:
!
!        equivalent_temp        adiabatic equivalent temperature 
!                               [ deg K ]
!
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:

      real      ::   pr, te, mre
      integer   ::   nbad

!--------------------------------------------------------------------
!   local variables:
!
!        pr   pressure at current level  [ Pa ]
!        te   temperature of parcel move dry adiabatically from
!             pressure p to pressure pr
!        es   stauration vapor pressure at temperature te
!        mre  saturation mixing ratio at temperature te and pressure p
!        k    do-loop index
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    initialize the character string which will contain any error mes-
!    sages returned through this subroutinE.
!---------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!---------------------------------------------------------------------
!    initialize the output variable equivalent_temp and the pressure at 
!    current level (pr).
!---------------------------------------------------------------------
      equivalent_temp = init_temp
      pr = init_pr

!---------------------------------------------------------------------
!    vertical loop. if the pressure  pr is less than pstop (absolute 
!    lowest pressure for cloud) exit the loop.
!---------------------------------------------------------------------
      do while (pr >= Param%pstop) 

!--------------------------------------------------------------------
!    define the temperature (te) at pressure pr assuming dry adiabatic
!    ascent from initial pressure p. determine the saturation vapor
!    pressure (es) for this temperature. define the saturation mixing
!    ratio for a parcel of this temperature at the initial pressure
!    level (mre).
!--------------------------------------------------------------------
        te = init_temp*((pr/init_pr)**Param%kappa)
        call compute_mrs_k (te, init_pr,                               &
                            Param%d622 , Param%d608 , mre, nbad, &
                            mr = parcel_mixing_ratio)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (nbad /= 0) then
          ermesg = 'subroutine don_cm_tae_k: '// &
                   'temperatures out of range of esat table'
          error = 1
          return
        endif

!--------------------------------------------------------------------
!    determine if saturation at the initial pressure level would occur
!    for this temperature.
!--------------------------------------------------------------------
        if (parcel_mixing_ratio >= mre) then

!--------------------------------------------------------------------
!    if saturation would occur for this temperature (te) at the initial
!    pressure init_pr (i.e., parcel_mixing_ratio >= mre), then use te to
!    calculate the equivalent temperature. exit the loop. otherwise,
!    increment the current pressure and continue within the loop.
!--------------------------------------------------------------------
          equivalent_temp = init_temp*exp(latent_heat*  &
                                   parcel_mixing_ratio/(te*Param%cp_air))
          exit
        endif
        pr = pr + Param%dp_of_cloud_model
      end do

!---------------------------------------------------------------------



end subroutine don_cm_tae_k

!####################################################################

subroutine don_cm_micro_k   &
         (diag_unit, debug_ijt, Param, tc1, tc2, p1, p2, te1, te2,  &
          qe1, qe2, w1, w2, rr, rmu, qrw, qcw, qlw, dcw1, dqrw3, ermesg, error)

!----------------------------------------------------------------------
!    subroutine micro calculates microphysical tendencies (kessler
!    microphysics) of the cloud parcel defined by (tc, w, qrw, qcw, 
!    qlw, rr) in an environment defined by (te, qe, rmu) during the 
!    movement of the parcel from pressure level p1 to level p2.
!--------------------------------------------------------------------

use donner_types_mod, only : donner_param_type
use sat_vapor_pres_k_mod, only: compute_mrs_k

implicit none

!--------------------------------------------------------------------
integer,                  intent(in)    :: diag_unit
logical,                  intent(in)    :: debug_ijt
type(donner_param_type),  intent(in)    :: Param
real,                     intent(in)    :: tc1, tc2, p1, p2, te1, te2, &
                                           qe1, qe2, w1, w2, rr, rmu
real,                     intent(inout) :: qrw, qcw, qlw, dcw1, dqrw3
character(len=*),         intent(out)   :: ermesg
integer,                  intent(out)   :: error

!--------------------------------------------------------------------
!  intent(in) variables:
!
!        tc1       cloud temperature at starting point [ deg K ]
!        tc2       cloud temperature at ending point [ deg K ]
!        p1        pressure at starting point [ Pa ]
!        p2        pressure at ending point [ Pa ]
!        te1       environmental temperature at starting point [ deg K ]
!        te2       environmental temperature at ending point [ deg K ]
!        qe1       environmental mixing ratio at starting point  
!                  [ kg(H2O) / kg(air) ] 
!        qe2       environmental mixing ratio at ending point  
!                  [ kg(H2O) / kg(air) ] 
!        w1        cloud vertical velocity at starting point [ m / sec ]
!        w2        cloud vertical velocity at ending point [ m / sec ]
!        rr        cloud radius [ m ]
!        rmu       entrainment coefficient [ m**(-1) ]
!        debug_ijt is this a diagnostics column ?
!        diag_unit output unit number for this diagnostics column
!
!   intent(inout) variables:
!
!        qrw    rain water              [ g(h2o) / m**3 ]
!        qcw    cloud water             [ g(h2o) / m**3 ]
!        qlw    total liquid water      [ kg(h2o) / kg(air) ]
!        dcw1   condensation increment  [ g(h2o) / m**3 ]
!        dqrw3  precipitation increment [ g(h2o) / m**3 ]
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:
  
      real :: cond, d1, d2, dcw2, dqcw3, dt_micro, dz, ent, pav,  &
              rb, qcwa, qeb, qrwa, red, rho, rs1, rs2, tcb, wav
      integer :: nbad

!--------------------------------------------------------------------
!   local variables:
!
!     cond      condensation in the layer [ kg(h2o) / kg(air) ]
!     d1        dz/dp at the starting level [ m / Pa ]  
!     d2        dz/dp at the ending level [ m / Pa ]  
!     dcw2      change in cloudwater due to autoconversion 
!               [ g (h2o) / m**3 ]
!     dqcw3     change in cloudwater content due to accretion     
!               [ g (h2o) / m**3 ]
!     dt_micro  microphysical time step [ sec ]
!     dz        average delta z in the layer [ m ]
!     ent       ratio of parcel mass after entrainment to mass
!               before entrainment [ dimensionless ]
!     es1       saturation vapor pressure at level p1 [ Pa ]
!     es2       saturation vapor pressure at level p2 [ Pa ]
!     pav       average pressure in the layer [ Pa ]
!     rb        average in-cloud mixing ratio in the layer 
!               [ kg(h2o) / kg(air) ]
!     qcwa      initial value of cloudwater after microphysical term
!               updates; it is then adjusted to avoid negative values
!               [ g(h2o) / m**3 ]
!     qeb       average environmental mixing ratio in the layer 
!               [ kg(h2o) / kg(air) ]
!     qrwa      initial value of rainwater after microphysical term
!               updates; it is then adjusted to avoid negative values
!               [ g(h2o) / m**3 ]
!     red       reducing factor applied to the microphysical loss terms
!               in the cloud and rain equations to avoid creation of
!               negative cloud and rain water [ dimensionless ]
!     rho       atmospheric density [ kg / m**3 ]
!     rs1       saturation mixing ratio in cloud at level p1
!     rs2       saturation mixing ratio in cloud at level p2
!     tcb       mean in-cloud temperature in the layer [ deg K ]
!     teb       mean environmental temperature in the layer [ deg K ]
!     wav       mean vertical velocity in the layer [ m / sec ]
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    initialize the character string which will contain any error mes-
!    sages returned through this subroutine.
!---------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!--------------------------------------------------------------------
!    define the saturation mixing ratio (rs1) at level p1.
!--------------------------------------------------------------------
      call compute_mrs_k (tc1, p1, Param%d622 , Param%d608 , rs1, nbad)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (nbad /= 0) then
        ermesg = 'subroutine don_cm_micro_k: '// &
                 'temperatures out of range of esat table'
        error = 1
        return
      endif

!--------------------------------------------------------------------
!    define the saturation mixing ratio (rs2) at level p2.
!--------------------------------------------------------------------
      call compute_mrs_k (tc2, p2, Param%d622 , Param%d608 , rs2, nbad)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (nbad /= 0) then
        ermesg = 'subroutine don_cm_micro_k: '// &
                 'temperatures out of range of esat table'
        error = 1
        return
      endif

!--------------------------------------------------------------------
!    if in diagnostic column, output the relevant atmospheric fields 
!    at the two pressure levels.
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12)')   &
                         'in micro: qrw,qcw= ',qrw,qcw
        write (diag_unit, '(a, e20.12)')  'in micro: rr= ',rr
        write (diag_unit, '(a, 2e20.12, 2f19.10)') &
                         'in micro: rs1,rs2,p1,p2= ',rs1,rs2,p1,p2
        write (diag_unit, '(a, 2e20.12, 2f20.14)')  &
!                        'in micro: es1,es2,tc1,tc2= ',es1,es2,tc1,tc2
                         'in micro: tc1,tc2= ',tc1,tc2
        write (diag_unit, '(a, 2f20.14)')  &
                          'in micro: te1,te2= ',te1,te2
      endif

!--------------------------------------------------------------------
!    define the layer-mean cloud temperature (tcb) and mixing ratio 
!    (rb), environmental mixing ratio (qeb), vertical velocity (wav), 
!    pressure (pav) and density (rho). define a layer-mean dz, as the  
!    average of the values of dz/dp (when using a virtual mass coeffic-
!    ient) at the two input levels. define the ratio of post-entrainment
!    mass to the pre-entrainment mass (ent).
!--------------------------------------------------------------------
      tcb = 0.5*(tc1 + tc2)
      rb  = 0.5*(rs1 + rs2)
      qeb = 0.5*(qe1 + qe2)
      wav = 0.5*(w1  +  w2)
      pav = 0.5*(p1  +  p2)
      rho = pav/(Param%rdgas*tcb*(1. + Param%d608*(rb/(1.0+rb))))
      d1  = Param%rdgas*(1. + Param%virt_mass_co)*tc1*te1/  &
            (Param%grav*p1*(Param%virt_mass_co*te1 + tc1))
      d2  = Param%rdgas*(1. + Param%virt_mass_co)*tc2*te2/  &
            (Param%grav *p2*(Param%virt_mass_co*te2 + tc2))
      dz  = -0.5*(d1 + d2)*Param%dp_of_cloud_model
      ent = exp(rmu*dz)

!--------------------------------------------------------------------
!    if in diagnostic column, output the entrainment coefficient (rmu)
!    and the environmental mixing ratio (qeb).
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12)')  &
                   'in micro: qeb,rmu= ', qeb, rmu
      endif

!----------------------------------------------------------------------
!    calculate the condensation (cond). the condensation is made up of
!    that which would occur due to adiabatic expansion (rs2 - rs1)
!    less the vapor which must be evaporated to saturate the environ-
!    mental air entrained into the cloud ((ent-1.)*(rs2-qeb)).  cond is
!    further modified to allow the condensation to be added to the
!    parcel at any point during the timestep through the variable
!    tr_insert_time. if the condensate is assumed to be added to the 
!    parcel while at mass m (its initial size), tr_insert_time = 0; 
!    if assumed to be added at end of step when parcel mass is ent 
!    times larger than its initial value, tr_insert_time is 1.  force 
!    the condensation to be non-negative.
!----------------------------------------------------------------------
      cond = (rs2 - rs1) + (ent - 1.)*(rs2 - qeb)
      cond = -cond/(1. - Param%tr_insert_time +    &
                         Param%tr_insert_time*ent)
      cond  = max (cond, 0.0)

!--------------------------------------------------------------------
!    if in diagnostic column, output the condensation (cond).
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, e20.12)') 'in micro: cond= ', cond
      endif

!--------------------------------------------------------------------
!    convert the condensation from units of kg(h2o)/ kg(air) to units
!    of (g(h2o) / m**3) by multiplying by rho*1000. define the timestep
!    for microphysical processes (dt_micro).
!--------------------------------------------------------------------
      dcw1 = cond*rho*1000.
      dt_micro = dz/wav

!--------------------------------------------------------------------
!    calculate the amount of cloud autoconverted to rain (dcw2). 
!--------------------------------------------------------------------
      if (qcw >= Param%autoconv_threshold)  then
        dcw2 = Param%autoconv_rate*(qcw - Param%autoconv_threshold)* &
                                                                dt_micro 
      else
        dcw2 = 0.0
      endif

!--------------------------------------------------------------------
!    calculate the cloud accretion by rainwater (dqcw3).
!--------------------------------------------------------------------
      if (qcw /= 0.0 .and. qrw /= 0.0) then
        dqcw3 = 5.26e-03*qcw*(qrw**.875)*dt_micro 
      else
        dqcw3 = 0.
      endif

!--------------------------------------------------------------------
!    calculate effect of entrainment on cloud water.
!--------------------------------------------------------------------
      qcw = qcw/ent

!---------------------------------------------------------------------
!    add the microphysical terms to the cloud water equation. if neces-
!    sary adjust the magnitudes of the loss terms so that negative
!    values of cloud water are not created. define the final value of
!    qcw.
!---------------------------------------------------------------------
      qcwa = qcw + dcw1 - dcw2 - dqcw3
      if (qcwa < 0.) then
        red = (qcw + dcw1)/(dcw2 + dqcw3)
        dcw2 = dcw2*red
        dqcw3 = dqcw3*red
      endif
      qcw = qcw + dcw1 - dcw2 - dqcw3

!--------------------------------------------------------------------
!    if in diagnostic column, output the cloud water entrainment  
!    factor (ent), the updated cloud water (qcw) and the condensation 
!    term (dcw1).
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 3e20.12)')  &
                             'in micro: ent,qcw,dcw1= ',ent,qcw,dcw1
      endif

!--------------------------------------------------------------------
!    calculate the flux of rainwater due to fallout.
!--------------------------------------------------------------------
      if (qrw /= 0.0) then
        dqrw3 = (qrw**1.125)*5.1*dt_micro/rr
      else
        dqrw3 = 0.  
      endif
 
!--------------------------------------------------------------------
!     calculate effect of entrainment on rain water
!--------------------------------------------------------------------
      qrw = qrw/ent

!---------------------------------------------------------------------
!    add the microphysical terms to the rain water equation. if neces-
!    sary adjust the magnitudes of the loss term so that negative
!    values of rain water are not created. define the final value of
!    qrw.
!---------------------------------------------------------------------
      qrwa = qrw + dcw2 + dqcw3 - dqrw3
      if (qrwa < 0.) then
        red   = (qrw + dcw2 + dqcw3)/dqrw3
        dqrw3 = red*dqrw3
      endif
      qrw = qrw + dcw2 + dqcw3 - dqrw3

!--------------------------------------------------------------------
!    if in diagnostic column, output the rainwater entrainment effect
!    (ent) and the updated value of rainwater. (qrw).
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12)') &
                               'in micro: ent,qrw= ',ent,qrw
      endif

!--------------------------------------------------------------------
!    apply realizability consitions to qcw and qrw. define total liquid
!    water qlw.
!--------------------------------------------------------------------
      qcw = max (qcw, 0.0)
      qrw = max (qrw, 0.0)
      qlw = qrw + qcw

!--------------------------------------------------------------------
!    if in diagnostic column, output the condensation (dcw1), the 
!    rainwater fallout (dqrw3) and the total liquid remaining (qlw).
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 3e20.12)')   &
                      'in micro: exit micro dcw1,dqrw3,qlw= ',   &
                       dcw1,dqrw3,qlw
      endif

!--------------------------------------------------------------------
!    convert the liquid water from g / m**3 to kg / kg.
!--------------------------------------------------------------------
      qlw = 1.0E-03*qlw/rho

!-------------------------------------------------------------------




end subroutine don_cm_micro_k


!######################################################################

subroutine don_cm_freeze_liquid_k    &
         (k, diag_unit, debug_ijt, Param, tbot, ttop, qlwest, dfrac, &
          dtfr, dtupa, dfrtop, sumfrea, ermesg, error)

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------

use donner_types_mod, only : donner_param_type

implicit none

!----------------------------------------------------------------------
integer,                  intent(in)    :: k, diag_unit
logical,                  intent(in)    :: debug_ijt 
type(donner_param_type),  intent(in)    :: Param
real,                     intent(in)    :: tbot, ttop, qlwest
real,                     intent(inout) :: dfrac, dtfr, dtupa, sumfrea
real,                     intent(inout) :: dfrtop
character(len=*),         intent(out)   :: ermesg
integer,                  intent(out)   :: error


      real ::  dfraca, dtupb

!---------------------------------------------------------------------
!    initialize the character string which will contain any error mes-
!    sages returned through this subroutine.
!---------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!--------------------------------------------------------------------
!    define the amount of liquid in the updraft which may be frozen.
!    multiply by a factor (freeze_fraction) to take account that not all
!    this water will freeze before falling out. use Leary and Houze
!    (JAS,1980) cell_precip/cu ratio to estimate this ratio.
!--------------------------------------------------------------------
      if ((tbot >= Param%tfre) .and. (ttop <= Param%tfre) .and.    &
          (dtfr == 0.)) then
        dtfr = qlwest*Param%hlf/Param%cp_air
        dtfr = Param%freeze_fraction*dtfr
      endif

!---------------------------------------------------------------------
!    define the fraction of liquid which is to be frozen at this level. 
!    freezing is assumed to occur linearly between 258 K and 248 K 
!    (dfre), with all liquid being frozen at 248 K. the fraction is not
!    allowed to decrease from its previous value if the temperature 
!    starts to increase with height within this temperature range. the 
!    fraction of the total which is frozen at the current level is 
!    dtupb; the amount frozen at this level (dfr(k+1) is the difference
!    between this amount and the amount frozen at the previous level 
!    (dtupa). cumulative total of frozen liquid is kept in sumfrea.
!---------------------------------------------------------------------
      if (dtfr > 0.0 .and. dtfr /= dtupa) then 
        dfraca = MIN ((Param%tfre - ttop)/Param%dfre, 1.0)
        dfrac = AMAX1 (dfrac, dfraca)
        dtupb = dtfr*dfrac 
        dfrtop   = dtupb - dtupa
        sumfrea = sumfrea + dfrtop   
        dtupa = dtupb

!--------------------------------------------------------------------
!    if in diagnostics column, output the values of available liquid
!    from freezing (dtfr), the amount frozen at level k+1 (dfr) and the 
!    constants hlf    and cp_air at this level.
!--------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(4(a, e20.12),a, i4)') &
             'in cloudm: DTFR=',DTFR,' dfr=',dfrtop  ,   &
               'LATICE=',Param%hlf, 'CPAIR=',Param%cp_air,'k= ',k
        endif
      endif



end subroutine don_cm_freeze_liquid_k 


!#####################################################################



!######################################################################

subroutine don_cm_clotr_k    &
         (ntr, diag_unit, debug_ijt, Param, sou1, sou2, xe1, xe2, &
          xc1, entrain, dt_micro, xc2, ermesg, error)

!----------------------------------------------------------------------
!    subroutine clotr calculates the in-cloud tracer profiles for 
!    all of the travcers being transported by the donner convection
!    scheme.
!    author :  Leo Donner,  GFDL, 14 Jan 2000
!----------------------------------------------------------------------

use donner_types_mod, only : donner_param_type

implicit none

!----------------------------------------------------------------------
integer,                  intent(in)  ::  ntr
integer,                  intent(in)  ::  diag_unit
logical,                  intent(in)  ::  debug_ijt
type(donner_param_type),  intent(in)  ::  Param
real,   dimension(ntr),   intent(in)  ::  sou1 
real,   dimension(ntr),   intent(in)  ::  sou2 
real,   dimension(ntr),   intent(in)  ::  xe1  
real,   dimension(ntr),   intent(in)  ::  xe2  
real,   dimension(ntr),   intent(in)  ::  xc1  
real,                     intent(in)  ::  entrain, dt_micro
real,   dimension(ntr),   intent(out) ::  xc2  
character(len=*),         intent(out) ::  ermesg
integer,                  intent(out) ::  error

!----------------------------------------------------------------------
!   intent(in) variables:
!
!        sou1          in-cloud source of tracer at bottom of layer 
!                      [ kg / kg(air) / sec ]  
!        sou2          in-cloud source of tracer at top of layer 
!                      [ kg / kg(air) / sec ]  
!        xe1           environmental tracer concentration at bottom of
!                      layer [ kg / kg(air) ]
!        xe2           environmental tracer concentration at top of
!                      layer [ kg / kg(air) ]
!        xc1           in-cloud tracer concentration at bottom of
!                      layer [ kg / kg(air) ]
!        entrain       entrainment factor [ dimensionless ]
!        dt_micro      microphysics time step
!        debug_ijt     is this a diagnostics column ?
!        diag_unit     output unit number for this diagnostics column
!
!   intent(out) variables:
!
!        xc2           in-cloud tracer concentration at top of
!                      layer [ kg / kg(air) ]
!
!---------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:

      real    ::  xeb        ! layer-average environmental value of 
                             ! tracer n  [ kg / kg(air) ]
      real    ::  seb        ! layer-average source for tracer n
                             ! [ kg / kg(air) / sec ]
      real    ::  mass_ratio ! ratio of entraining parcel mass at top
                             ! of layer to that at bottom 
                             ! [ dimensionless ]
      real    ::  delta_m    ! fractional amount of mass added to 
                             ! parcel in current model layer 
                             ! [ dimensionless ]
      integer ::  n          ! do-loop index

!---------------------------------------------------------------------
!    initialize the character string which will contain any error mes-
!    sages returned through this subroutine.
!---------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!-----------------------------------------------------------------------
!    if in diagnostics column, print out an entry message.
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a)') 'in clotr: entering clotr'
      endif

!---------------------------------------------------------------------
!    define ratio of parcel mass at top of layer to that at bottom 
!    (mass_ratio) and the increase in parcel mass across the layer.
!---------------------------------------------------------------------
      mass_ratio = exp(entrain)
      delta_m = mass_ratio - 1.0

!----------------------------------------------------------------------
!    loop over the tracers transported by donner convection.
!----------------------------------------------------------------------
      do n=1,ntr             

!---------------------------------------------------------------------
!    define layer-mean environmental tracer (xeb) and the tracer source 
!    (seb).
!---------------------------------------------------------------------
        xeb = 0.5*(xe1(n) + xe2(n))
        seb = 0.5*(sou1(n) + sou2(n))

!--------------------------------------------------------------------
!    define in-cloud tracer amount at top of layer (xc2) as the sum of 
!    the value at bottom of layer (xc1) plus the amount of environ-
!    mental tracer entrained into the parcel plus the amount produced
!    by the internal source (seb). the time of insertion of the internal
!    source is given by tr_insert_time (in terms of parcel's mass 
!    increase during its traversal of the layer). if source is assumed
!    to be made available at bottom of layer (tr_insert_time = 0), then
!    seb is unmodified; if not available until completion of traversal,
!    then tr_insert_time is 1.0, and amount supplied is reduced by the
!    ratio of parcel mass between layer top and bottom. renormalize the
!    mixing ratio by the total parcel mass at the top of the layer.
!!! BUG :: seb must be multiplied by dt (perhaps as wv/dz ???)
!!!  BUG FIXED 6/2/05
!!!! BUG :: shouldn't the 1 + epm*(   ) be divided into seb  ????
!--------------------------------------------------------------------
        xc2(n) = (xc1(n) + delta_m*xeb + seb*dt_micro*   &
                              (1. + Param%tr_insert_time*delta_m))/mass_ratio 

!--------------------------------------------------------------------
!    assure that the in-cloud tracer mixing ratio is non-negative.
!--------------------------------------------------------------------
        if (xc2(n) < 0.) xc2(n) = 0.

!--------------------------------------------------------------------
!    if in diagnostics column, output the tracer mixing ratio at top
!    of layer (xc2), the layer-mean environmental tracer mixing ratio
!    (xeb) and the layer-mean tracer source (seb).
!--------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, e20.12)')   &
           'in clotr: xc= ',xc2(n)
          write (diag_unit, '(a, e20.12)')   &
               'in clotr: xeb= ',xeb
          write (diag_unit, '(a, e20.12)')   &
               'in clotr: seb= ',seb
        endif
      end do

!--------------------------------------------------------------------


end subroutine don_cm_clotr_k

!#######################################################################

MODULE DIAG_CLOUD_RAD_MOD


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!CLOUD RADIATIVE PROPERTIES
!
!       May-Oct  1998 -> Sep 2000
!       Contact persons: Tony Gordon, Bill Stern (for modified code)
!                        Steve Klein for original Fotran 90 code)
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!This module solves for the radiative properties of
!       every cloud.  In particular it uses either the
!       two stream approach or the delta-Eddington approach
!       to solve for the longwave emissivity, the ultra-violet-
!       visible reflectivities and absorptions, and the
!       near-infrared reflectivities and absorptions.
!
!       Modifications to Steve Klein's version have been made
!       to accomodate the empirical diagnostic cloud scheme of Tony Gordon,
!       frozen version v197 as discussed below.
!     
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!-------------------------------------------------------------------

use       mpp_mod, only: input_nml_file
use       fms_mod, only: file_exist, check_nml_error, open_namelist_file, &
                         mpp_pe, mpp_root_pe, close_file, &
                         write_version_number, stdlog

! Steve Klein's Cloud_Rad module
use Cloud_Rad_Mod, ONLY: CLOUD_RAD, CLOUD_RAD_INIT, cloud_rad_k_diag


!-------------------------------------------------------------------
 
  implicit none

!-------------------------------------------------------------------

!        The module contains the following:
!
!SUBROUTINES
!
! CLOUD_TAU_DRIVER
!   calls a sequence of suboutines to compute
!   cloud optical and radiative properties, as detailed
!   below -->
! CLOUD_PRES_THICK_FOR_TAU
!   computes cloud-type dependent set of pressure 
!   thicknesses for each distinct cloud layer, which are  
!   used to parameterize cloud optical depths
! CLOUD_OPTICAL_DEPTHS
!   Specify / crudely parameterize cloud optical depths
!   for distinct cloud layers,incorporating a 
!   parameterization scheme for non-anvil cirrus
!   proposed by Harshvardhan, based upon observations by
!   Platt and Harshvardhan
! CLOUD_OPTICAL_PROP_tg
!   for each cloud, it first establishes the standard
!   values of cloud optical depths (tau) in the 
!   vis+nir band for low, middle and high (anvil or non-
!   anvil cirrus) clouds. Then, it calculates the 
!   effective cloud liquid and cloud ice water paths, from
!   the cloud optical depths, mass aborption coefficients
!   for cloud water and cloud ice, and the temperature-
!   dependent ratio of cloud ice to cloud water path.
!   In the vis band, the single scattering albedo (wo), and
!   the asymmetry parameter (g) are both specified as 
!   constants (wo = 0.99999 and g = 0.85); 
!   In the nir band, wo is specified as a constant, 0.9942
!   (standard case), but is a function of zonal mean water 
!   vapor mixing ratio at the model's lowest vertical level
!   (anomalous absorption case). This subroutine also 
!   computes the longwave emissivity of each cloud.
! CLOUD_RAD   
!   solves for the radiative properties of the
!   every cloud.  In particular it uses either the
!   two stream approach or the delta-Eddington approach
!   to solve for the longwave emmissivity, the 
!   ultra-violet - visible reflectivities and absorptions,
!   and the near-infrared reflectivities and absorptions.
!   ****    Note    ****  This subroutine is from
!   the CLOUD_RAD_MOD module of Steve Klein .
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     PARAMETERS OF THE SCHEME
!
!     taumin       minimum permissible tau
!
!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !
! 
!       PARAMETERS In Tony Gordon's v197 scheme only
!
!       k_lw_liq     liquid cloud mass absorption coefficient for longwave
!                       portion of the spectrum (meters**2./kg of condensate).
!                       The diffusivity factor, 1.66 is incoporated into
!                       k_lw_liq.
!       k_lw_ice     ice cloud mass absorption coefficient for longwave
!                       portion of the spectrum (meters**2./kg of condensate).
!                       The diffusivity factor, 1.66 is incoporated into
!                       k_lw_ice.
!       k_sw_liq     liquid cloud mass absorption coefficient for shortwave
!                       portion of the spectrum (meters**2./kg of condensate).
!       k_sw_ice     ice cloud mass absorption coefficient for shortwave
!                       portion of the spectrum (meters**2./kg of condensate).
!
!       tk_all_ice    minimum temperature at which cloud liquid water phase
!                       can exist (degrees Kelvin)
!       tk_all_liq    maximum temperature at which cloud ice can exist
!                       (degrees Kelvin)
!       wgt_liq       The ratio of liquid water path to total cloud water path,
!                        i.e., LWP / CWP
!       wgt_ice       The ratio of ice water path to total cloud water path,
!                        i.e., IWP / CWP
!
!       qsat_min      For zonal mean saturation water vapor mixing ratios
!                        less than this value entering into the variable 
!                        anomalous absorption calculations, the nir single 
!                        scattering albedo will asymptote to w0_anom2_nir
!                        where w0_anom2_nir is defined below.
!       qsat_trans    Transition value of zonal mean saturation mixing ratio
!                        between two branches of a piecewise continuous
!                        function entering into the variable anomalous
!                        absorption single scattering albedo calculations.
!       qsat_max      For zonal mean saturation water vapor mixing ratios
!                        greater than this value entering into the variable
!                        anomalous absorption calculations, the nir single
!                        scattering albedo will asymptote to w0_anom1_nir,
!                        where w0_anom1_nir is defined below.
!
!       w0_norm_uv    Normal, constant single scattering albedo in the uv-vis
!                        wavelength band of the radiation spectrum.
!       w0_norm_nir   Normal, constant single scattering albedo in the nir
!                        wavelength band of the radiation spectrum.
!       w0_anom1_nir  Asymptotic minimum value of single scattering albedo
!                        for variable anomalous absorption; also the
!                        low constant value, if L_anom_abs_g is set to TRUE.
!       w0_anom2_nir  Asymptotic maximum value of single scattering albedo
!                        for variable anomalous absorption,usually occurring
!                        at high latitudes.
! 
!       g_norm        Normal, constant asymmetry parameter used in Tony Gordon's
!                        v197 scheme. It is independent of wavelength.                                
!
!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !
!          

 private



!--------------------- version number ----------------------------------
 character(len=128) :: version = '$Id: diag_cloud_rad.F90,v 19.0 2012/01/06 20:05:09 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'
 logical            :: module_is_initialized = .false.
!-----------------------------------------------------------------------

! REAL, PARAMETER :: taumin = 1.E-06
! Allow optical depths = 0.0 to remain 0.0
REAL, PARAMETER :: taumin = 0.0
!
!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!     PARAMETERS in Tony Gordon's v197 scheme only:

!       Absorption Coefficients
REAL, PARAMETER     :: k_lw_liq = 140., k_lw_ice = 100.
REAL, PARAMETER     :: k_sw_liq = 130., k_sw_ice =  74.

!       Single scattering albedo and asymmetry parameters
REAL, PARAMETER     :: w0_norm_uv   = 0.99999, w0_norm_nir  = 0.9942
REAL, PARAMETER     :: w0_anom1_nir = 0.9700,  w0_anom2_nir = 0.9980
REAL, PARAMETER     :: g_norm = 0.85

!       Parameters controlling the proportion of ice to liquid phase
REAL, PARAMETER     :: tk_all_ice = 258.16, tk_all_liq = 268.16
 
!       Mixing ratio parameters in dimensionless units.
!       (To convert these parameters to g/kg, one would multiply them by 1000).

REAL, PARAMETER  :: qsat_min = 0.0, qsat_trans = 0.01, qsat_max = 0.02


!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

!  An initialization subroutine, DIAG_CLOUD_RAD_INIT is called from 
!  clouds_tg_init do_crad_init will be reset to .false.

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 

!---------------------------------------------------------------------
! --- NAMELIST (clouds_rad_tg_nml)
!---------------------------------------------------------------------
!     l_har_anvil - logical variable = t -> anvil and super anvil cirrus
!                 clouds are treated as warm clouds.
!     l_har_coldcld - logical variable = t -> activates cold cloud portion
!                 of Harshvardhan scheme.
!                 Default value has been changed to .true., consistent with
!                 AMIP 2 run and preferred when employing RAS with no cap.
!                 l_har_coldcld = .false. would correspond to
!                 v197 frozen model runs.
!     l_anom_abs_g - logical variable = t -> anomalous absorption is
!                  specified as a constant value of single scattering albedo.
!     l_anom_abs_v - logical variable = t -> anomalous absorption is
!                  computed as a piecewise continuous function of zonal
!                  mean saturation mixing ratio.
!---------------------------------------------------------------------

 logical :: &
     & l_har_anvil = .true.,l_har_coldcld = .true., &
     & l_anom_abs_g = .false., l_anom_abs_v = .false.

  NAMELIST / diag_cloud_rad_nml /  &                          
     & l_har_anvil, l_har_coldcld, l_anom_abs_g, l_anom_abs_v

!  Need to create an initialization subroutine which reads this namelist.
!  Also, in that subroutine, check that L_anom_abs_g and L_anom_abs_v
!  are not both set to .true., after reading the namelist.
!  If they are, either code an ERROR EXIT, or else, allow L_anom_abs_v to take
!  precedence, i.e., reset L_anom_abs_g = .false. :

!     IF (L_anom_abs_v) THEN
!        L_anom_abs_g = .FALSE.
!    ENDIF   

!
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!
!    ******    For Tony Gordon's v197 scheme only:    ****
!
!    The maximum number of distinct cloud layers in a vertical column,
!    max_cld = maxval(nclds), can be supplied by the cldtim driver in module
!    clouds_tg. Also, the cldtim driver can call a special subroutine to
!    compute the useful diagnostic total_cld_amt.
!
!    For efficiency, it is preferrable to work with the compressed vertical
!    index k'. Also, all of the argument calls in this module are presently
!    set up that way. Of course, that can be changed, by filling all levels
!    within a distinct cloud layer with the same values of data
!
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 public cloud_tau_driver,diag_cloud_rad_init, diag_cloud_rad_end, &
     cloud_pres_thick_for_tau, cloud_optical_depths,  &
     cloud_optical_depths2, &
     cloud_opt_prop_tg_lw, cloud_opt_prop_tg_sw, cloud_opt_prop_tg2

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 contains


!########################################################################
!########################################################################

SUBROUTINE CLOUD_TAU_DRIVER (qmix_kx, tempcld, tau, coszen,  &
                             r_uv, r_nir, ab_uv, ab_nir, em_lw)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!      This subroutine returns the following radiative properties of clouds
!
!               1. r_uv:   cloud reflectance in uv band
!               2. r_nir:  cloud reflectance in nir band
!               3. ab_uv:  cloud absorption in uv band
!               4. ab_nir: cloud absorption in nir band
!               5. em_lw:  longwave cloud emissivity
!
!               Note: Our nir is split, later, into 3 smaller bands
!                     employed in a module created by Steve Klein.
!                     The radiative properties do not vary amongst
!                     those bands.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!VARIABLES
!
!       ------
!INPUT:
!       ------
!
!      NCLDS       number of (random overlapping) clouds in column
!      ICLD          marker array of cloud types/heights (at cloud levels)
!      CLDTOP     indices of model levels where cloud tops of distinct cloud
!                    layers are located. 
!      CLDBAS     indices of model levels where cloud bases of distinct cloud
!                    layers are located.
!      CLDAMT       cloud amount fraction of distinct cloud layers
!      DELP_TRUE  true cloud pressure thickness of distinct cloud layers
!      TEMPCLD    cloud layer mean temperature (degrees Kelvin) of distinct
!                    cloud layers
!      PFULL        pressure at full levels (Pascals)
!      PHALF        pressure at half levels (Pascals)
!                     NOTE: it is assumed that phalf(j+1) > phalf(j)
!      PSFC       Surface pressure field
!      COSZEN     cosine of the zenith angle

! -----------------------------------------------------------------------------
! as of May 1999 these variables are internal to Steve Klein's routine

!      l2strem      logical variable indicating 2 stream operating or not
!                          l2strem = T  2 stream solution to the calculation
!                          of cloud raditive properties
!                          l2strem = F  Delta-Eddington solution to the
!                          calculation of cloud radiative properties.
!
!                            IF l2strem = T then the solution does not
!                            depend on solar zenith angle
!
!                    [ namelist variable in Steve Klein's Cloud_Rad module ]
!
!      taucrit      critical tau for switching direct beam to diffuse beam
!
!                    [ namelist variable in Steve Klein's Cloud_Rad module ]
! -----------------------------------------------------------------------------
!
!       -------------
!OUTPUT:
!       -------------
!
!       r_uv         cloud reflectance in uv band
!       r_nir        cloud reflectance in nir band
!       ab_uv        cloud absorption in uv band
!       ab_nir       cloud absorption in nir band
!       em_lw        longwave cloud emissivity
!
!       -------------
!       The following variables might be elevated to "OUTPUT" status later.
!          They are computed in subroutines called by this subroutine.
!          Perhaps they would be needed for diagnostics purposes.
!          If so, add w0 and gg to the argument list of CLOUD_TAU_DRIVER
!
!       -------------
!       w0           single scattering albedo for each band
!       gg           asymmetry parameter for each band
!
!       -------------------
!INTERNAL VARIABLES:
!       -------------------
!
!       i,j,k,t        looping variable
!       IDIM         number of first dimension points
!       JDIM         number of second dimension points
!       KDIM         number of vertical levels
!       max_cld      maximum number of distinct cloud layers in whole array
!       LWP          cloud liquid water path (kg of condensate per square meter)
!       IWP          cloud ice water path (kg of condensate per squre meter)
!
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
!
!      For Tony Gordon's v197 scheme only
!
!      L_anom_abs-g Logical namelist variable. If true, anomalous absorption
!                   is represented by a constant value of single scattering
!                   albedo. The default value and the v197 setting are
!                   both false.
!
!      L_anom_abs_v Logical namelist variable. If true, anomalous absorption
!                   is computed as a piecewise continuous function of zonal
!                   mean saturation water vapor mixing ratio at the model's
!                   vertical level closest to the earth's surface. The
!                   default value is false. The analogous namelist variable
!                   in v197, LWALBV is set to TRUE. 
!                   If both L_anom_abs_g and L_anom_abs_v are set to FALSE,
!                   then the single scattering albedo, w0,  assumes its normal
!                   constant value of 0.9942, in tg's version. w0 is a
!                   variable in Steve Klein's version.
!                   L_anom_abs_v takes precedence over L_anom_abs_g, if
!                   the former is TRUE and the latter is FALSE.
!
!     qmix_kx       water vapor mixing ratio at the
!                   model's vertical level closest to the earth's surface.
!                   It is more convenient to pass the zonal mean, in case
!                   single column tests are performed. Alternatively,
!                   the zonal mean could be computed within this subroutine. 
!
!
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!  User Interface variables
!  ------------------------

real, intent(in), dimension(:,:,:) ::    tempcld
real,    intent (in),dimension(:,:)   :: qmix_kx

real,    intent(in), dimension (:,:)  ::  coszen


! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

real,     intent (out),dimension(:,:,:), optional  :: r_uv,r_nir,  &
                           ab_uv,ab_nir,em_lw

!  *****************************************************************

real,     intent (in   ),dimension(:,:,:,:) :: tau

real, dimension(size(tau,1),size(tau,2),size(tau,3),size(tau,4)) :: w0,gg

real, dimension(size(tau,1),size(tau,2),size(tau,3)) :: lwp,iwp

!  *****************************************************************




!compute cloud radiative properties



if (present(em_lw)) then
          call cloud_opt_prop_tg(lwp,iwp,tau,w0,gg,tempcld,qmix_kx,  &
       em_lw=em_lw)
        else
          call cloud_opt_prop_tg(lwp,iwp,tau,w0,gg,tempcld,qmix_kx)
endif
 
!  From Steve Klein's cloud_rad_mod

        if (present(r_uv)) then
            call cloud_rad(tau,w0,gg,coszen,r_uv,r_nir,ab_uv,ab_nir)
        endif

!--------------------------------------------------------------------


END SUBROUTINE CLOUD_TAU_DRIVER





!########################################################################
subroutine cloud_pres_thick_for_tau (nclds,icld,cldtop,cldbas, &
     &          delp_true,lhight,lhighb, lmidt, lmidb, llowt,lk,delp, &
     &          phalf, psfc )

! This subroutine calculates a special cloud-type dependent set of 
! cloud pressure thicknesses that will be employed to compute cloud optical
! depths.

!===================================================================

!  parameters used in this routine 
!
! standard optical pressure thickness quantities (hPa)
REAL, PARAMETER :: delp_high = 31.25, delp_mid = 75.0, delp_low = 112.5
REAL, PARAMETER :: delp_high_thk = 2.0*delp_high, delp_cnv = 112.5
REAL, PARAMETER :: delp_high_thk_anvil = 2.0*delp_high
! REAL, PARAMETER :: delp_strat = 112.5, delp_min = 25.0, delp_thk_crit = 125.0
! impose v197 value for delp_min
REAL, PARAMETER :: delp_strat = 112.5, delp_min = 9.0, delp_thk_crit = 125.0

! delp_high - standard specified pressure thickness for high (warm) clouds,
!             which is used to compute their optical depth.
! delp_mid -  standard specified pressure thickness for middle (warm) clouds,
!             which is used to compute their optical depth.
! delp_low -  standard specified pressure thickness for low (warm) clouds, 
!             which is used to compute their optical depth, 
!             provided that those clouds are not too close to the ground.
! delp_high_thk - specified pressure thickness  for high clouds (other than 
!             precipitating convective clouds), whose true cloud pressure
!             thickness exceeds delp_thk_crit, and 
!             which is used to compute their optical depth.
! delp_high_thk_anvil - specified pressure thickness  for anvil cirrus clouds 
!             whose true cloud pressure thickness exceeds delp_thk_crit, and
!             which is used to compute their optical depth.
! delp_cnv -  cloud optical depth for precipitating convective clouds with
!             bases in the "low" cloud region of the atmosphere,
!             which is used to compute their optical depth.
! delp_strat - standard specified pressure thickness for marine stratus clouds,
!             which is used to compute their optical depth.
!             They could be quite optically thick, in some regions, e.g.,
!             off the coast of Peru, based upon ISCCP obs.
! delp_min -  minimum pressure thickness of a cloud layer.
! delp_thk_crit - critical true cloud pressure thickness, which, if exceeded,
!             signifies a thick stratiform cloud.

!===================================================================


! Arguments (intent in)

real,    intent(in), dimension(:,:,:) :: phalf, delp_true
integer, intent(in), dimension(:,:,:) :: cldtop,cldbas,icld
integer, intent(in), dimension(:,:)   ::  nclds
integer, intent(in), dimension(:,:)   :: lhight, lhighb, lmidt, lmidb, llowt
integer, intent(in)                   :: lk
real,    intent(in), dimension (:,:)  ::  psfc

!      INPUT
!      ------

!       PHALF        pressure at half levels (Pascals)
!                     NOTE: it is assumed that phalf(j+1) > phalf(j)
!       PSFC         Surface pressure field
!       NCLDS       number of (random overlapping) clouds in column and also
!                     the current # for clouds to be operating on
!       ICLD          marker array of cloud types/heights (at cloud levels)
!       CLDTOP     index of cloud tops (at cloud levels)
!       CLDBAS     index of cloud bottoms (at cloud levels)
!       DELP_TRUE  true cloud pressure thickness of distinct cloud layers 
!                    (at cloud levels - in Pa)
!       LHIGHT        vertical level index upper limit for high cloud tops
!       LHIGHB        vertical level index lower limit for high cloud bases
!       LMIDT         vertical level index upper limit for mid cloud tops
!       LMIDB         vertical level index lower limit for mid cloud bases
!       LLOWT         vertical level index upper limit for low cloud tops
!       LK            vertical level below which no low cloud bases can exist

!===================================================================

! Arguments (intent out)

real, intent(out), dimension(:,:,:) :: delp

!      OUTPUT
!      ------

!      DELP     cloud pressure thickness used to calculate cloud optical depths 
!                   of distinct cloud layers
!=======================================================================
!  (Intent local)

 integer, dimension (size(cldtop,1),size(cldtop,2)) :: cldt,cldb,icwork
 real, dimension (size(cldtop,1),size(cldtop,2)) :: delpstd,pwork

! scalars
 integer k, max_cld, idim, jdim, kmaxp

 integer i, j

!      DELP_STD     tentative cloud pressure thickness values 
!                   (at cloud levels)
!      CLDT, CLDB   work arrays for cloud top,base indices
!      ICWORK       cloud type marker work array at cloud levels 
!      PWORK        work array for pressure values at cloud levels (hPa)

!===================================================================

! define horizontal dimensions

  idim = SIZE( cldtop, 1 )
  jdim = SIZE( cldtop, 2 )
  kmaxp = SIZE( phalf, 3 )


! Initialize cloud pressure thickness array
      delp = 0.0

! find maximum number of cloud levels
      max_cld  = maxval(nclds(:,:))
                   if (max_cld .ge. 1) then

!-----------------------------------------------------------------------
! <><><><><><><><>   calc cloud press thickness <><><><><><><><>
!-----------------------------------------------------------------------

      do k = 1,max_cld

! Initialize internal arrays
      cldt = kmaxp
      cldb = 0
      icwork = 0
      pwork = 0.0
      delpstd = 0.0
         where (nclds(:,:) .ge. k)
           cldt(:,:) = cldtop(:,:,k)      
           cldb(:,:) = cldbas(:,:,k) 
         end where

! separate cloud type marker from cloud height marker
         icwork(:,:) = mod(icld(:,:,k),100)

! fill array pwork with the pressure difference value of the half level 
! corresponding to the cloud top level cldt and the surface pressure
! also convert from Pa to hPa
         do j=1,jdim
         do i=1,idim
           pwork(i,j) = (psfc(i,j) - phalf(i,j,cldt(i,j)))*.01
         end do
         end do

         where (cldb(:,:) .ge. lhight(:,:) .and. cldb(:,:) .le. lhighb(:,:) )
           delpstd(:,:) = delp_high
         end where

         where (cldb(:,:) .ge. lmidt(:,:) .and. cldb(:,:) .le. lmidb(:,:) )
           delpstd(:,:) = delp_mid
         end where

         where ( (cldb(:,:) .ge. llowt(:,:) .and. cldb(:,:) .le. lk) .and. &
     &                 (pwork(:,:) .ge. delp_low) )
           delpstd(:,:) = delp_low
         end where

         where ( (cldb(:,:) .ge. llowt(:,:) .and. cldb(:,:) .le. lk) .and. &
     &                 (pwork(:,:) .lt. delp_low) )
           delpstd(:,:) = max(pwork(:,:), delp_min)
         end where


! tentative value of cloud pressure thickness used in cloud optical depth calc
         where (cldb(:,:) .ge. lhight(:,:) .and. cldb(:,:) .le. lk)
           delp(:,:,k) = delpstd(:,:)
         end where
! redefine cloud pressure thickness for precipitating convective clouds with
! low cloud bases so that a small value such as delp_min is not a possiblity
         where (cldb(:,:) .ge. llowt(:,:) .and. cldb(:,:) .le. (lk-1) .and. &
     &               icwork(:,:) .eq. 5)
           delp(:,:,k) = delp_cnv
         end where

! use pwork to store delp_true  converted from Pa to hPa
         pwork(:,:) = delp_true(:,:,k)*.01

! redefine cloud pressure thickness for thick, high stratiform clouds
         where ( (cldb(:,:) .ge. lhight(:,:) .and. &
     &            cldb(:,:) .le. lhighb(:,:)) .and. &
     &           (pwork(:,:) .gt. delp_thk_crit) .and. &
     &           (icwork(:,:) .eq. 1) )
           delp(:,:,k) = delp_high_thk
         end where
! redefine cloud pressure thickness for thick, anvil cirrus clouds
         where ( (cldb(:,:) .ge. lhight(:,:) .and. &
     &            cldb(:,:) .le. lhighb(:,:)) .and. &
     &           (pwork(:,:) .gt. delp_thk_crit) .and. &
     &           (icwork(:,:) .ge. 6) )
           delp(:,:,k) = delp_high_thk_anvil
         end where
! redefine cloud pressure thickness for marine stratus clouds
         where ( (cldb(:,:) .ge. llowt(:,:) .and. cldb(:,:) .le. lk) .and. &
     &           (cldb(:,:) .eq. cldt(:,:)) .and. (icwork(:,:) .eq. 3) )
           delp(:,:,k) = min(delpstd(:,:),delp_strat)
         end where

      end do

      
                   endif

end subroutine cloud_pres_thick_for_tau

!########################################################################

subroutine cloud_optical_depths2 (nclds,icld,cldtop,cldbas,tempcld,delp, &
     &          tau,phalf,           liq_frac )

! This subroutine specifies/crudely parameterizes cloud optical depths 
! of non-anvil cirrus clouds based upon a parameterization scheme 
! resembling that proposed by Harshvardhan,
! (which is based on observations by Platt and Harshvardhan).

!===================================================================

!  namelist quantities used in this routine (defined in module intro above).

!     l_har_anvil - logical variable = t -> anvil and super anvil cirrus
!                 clouds are treated as warm clouds.
!     l_har_coldcld - logical variable = t -> activates cold cloud portion
!                 of Harshvardhan scheme.
!===================================================================

!  parameters used in this routine 

REAL, PARAMETER :: ctok = 273.16, t_ref = ctok - 82.5 
REAL, PARAMETER :: t_warm = ctok, t_cold = ctok-10.0
REAL, PARAMETER :: temp_dif_min = 1.0, inv_delta_t = 1./(t_warm-t_cold)
REAL, PARAMETER :: harshb_std = 0.08, harshb_cnv = 2.0*harshb_std
REAL, PARAMETER :: harshb_anvil = harshb_std, harshb_super_anvil = harshb_std
! The following value is 6 times larger than suggested by Platt-Harshvardan.
! The new value boosts the cold cloud emissivities in the tropics, giving
! closer agreement with ERBE.
REAL, PARAMETER :: harsha_cold = 12.8e-06

! ctok -      freezing point in deg. K..
! t_ref -     a reference minimum permitted cloud temperature in the
!             Harshvardan parameterization.
! t_warm -    the lowest temperature the cloud layer can have and still 
!             be considered warm.
! t_cold -    the highest temperature the cloud layer can have and still 
!             be considered cold. 
! temp_dif_min - the minimum temperature difference to be used in the 
!             computation of Platt-Harshvardhan cold cloud optical depths.
! inv_delta_t =  1./(t_warm-t_cold)
! harshb_std - Harshvardan coefficient for a "standard" cloud layer 
! harshb_cnv - Harshvardan coefficient for convective clouds treated as warm 
! harshb_anvil - Harshvardan coefficient for anvil cirrus clouds 
! harshb_super_anvil - Harshvardan coefficient for super anvil cirrus clouds 
! harsha_cold - Harshvardan coefficient for a cold high cloud 

!===================================================================


! Arguments (intent in)

real, intent(in), dimension(:,:,:)    :: phalf, delp, tempcld
integer, intent(in), dimension(:,:,:) :: cldtop,cldbas,icld
integer, intent(in), dimension(:,:)   ::  nclds

!      INPUT
!      ------

!       PHALF        pressure at half levels (Pascals)
!                     NOTE: it is assumed that phalf(j+1) > phalf(j)
!       NCLDS       number of (random overlapping) clouds in column and also
!                     the current # for clouds to be operating on
!      ICLD          marker array of cloud types (at cloud levels)
!      CLDTOP     index of cloud tops (at cloud levels)
!      CLDBAS     index of cloud bottoms (at cloud levels)
!      TEMPCLD    cloud layer mean temperature 
!                 (degrees Kelvin, at cloud levels)
!      DELP      cloud pressure thickness used for cloud optical depth 
!                   (at cloud levels)

!===================================================================

! Arguments (intent out)

real, intent(inout), dimension(:,:,:,:) :: tau
real, intent(inout), dimension(:,:,:) ::           liq_frac

!      OUTPUT
!      ------

!      TAU     cloud optical depth (at cloud levels)

!=======================================================================

!  (Intent local)

 integer, dimension (size(cldtop,1),size(cldtop,2)) :: cldt,cldb,icwork
 real, dimension (size(cldtop,1),size(cldtop,2)) :: & 
                                          temp_dif,tau_cold,tau_warm,pwork
 real, dimension (size(tau,1),size(tau,2),size(tau,3) )  :: tau_vis

! scalars
 integer i, j, idim, jdim, kmaxp
 integer k, max_cld
 integer n, max_band

! real 

!      CLDT, CLDB   work arrays for cloud top,base indices
!      TAU_COLD     cloud optical depth work array for cold calculation in
!                   transition regime 
!      TAU_WARM     cloud optical depth work array for warm calculation in
!                   transition regime 
!      TEMP_DIF     work array for temperature diference of distinct cloud
!                   layers 
!      ICWORK       cloud type marker work array of distinct cloud layers
!      PWORK        work array for pressure values at cloud levels (hPa) 
!      TAU_VIS      work array for cloud optical depth in visible part
!                   of spectrum
!      MAX_BAND     maximum number of radiative bands for cloud optical depth
!      MAX_CLD      maximum number of distinct cloud layers within a 
!                   vertical column

!===================================================================


! define horizontal dimensions

  idim = SIZE( cldtop, 1 )
  jdim = SIZE( cldtop, 2 )
  kmaxp = SIZE( phalf, 3 )


! find maximum number of cloud levels
      max_cld  = maxval(nclds(:,:))

! define maximum number of wave number bands for tau
      max_band = size(tau,4)


!===================================================================

! Initialize working and final cloud optical depth arrays
      tau_vis = 0.0
      tau     = 0.0

! find maximum number of clouds
      max_cld  = maxval(nclds(:,:))
                   if (max_cld .ge. 1) then

!-----------------------------------------------------------------------
! <><><><><><><><>   calc cloud optical depths <><><><><><><><>
!-----------------------------------------------------------------------

      do k = 1,max_cld

! Initialize internal arrays
      cldt = kmaxp
      cldb = 0
      icwork = 0
         where (nclds(:,:) .ge. k)
           cldt(:,:) = cldtop(:,:,k)      
           cldb(:,:) = cldbas(:,:,k) 
         end where

! fill array pwork with pressure values at the half level corresponding
! to the cloud top level cldt and convert from Pa to hPa
         do j=1,jdim
         do i=1,idim
           pwork(i,j) = phalf(i,j,cldt(i,j))*.01
         end do
         end do

! separate cloud type marker from cloud height marker
         icwork(:,:) = mod(icld(:,:,k),100)

! Standard case: warm cloud treatment will be applied to warm and cold clouds.
! Later, the cold cloud cases will be re-computed, if namelist parameter
! l_har_coldcld is set to true.

! preliminary optical depths computed everywhere

         tau_vis(:,:,k) = harshb_std * delp(:,:,k)

! redefine tau_vis for convective clouds, which are always treated as warm
         where (icwork(:,:) .eq. 5)
           tau_vis(:,:,k) = harshb_anvil * delp(:,:,k)
         end where

                   if (l_har_anvil) then
! redefine tau_vis for high clouds that meet the anvil cirrus criterion
         where (icld(:,:,k) .eq. 106)
           tau_vis(:,:,k) = harshb_anvil * delp(:,:,k)
         end where

! redefine tau_vis for high clouds that meet the super anvil cirrus criterion
         where (icld(:,:,k) .eq. 107)
           tau_vis(:,:,k) = harshb_super_anvil * delp(:,:,k)
         end where
                   endif

                   if (l_har_coldcld .and. l_har_anvil ) then

! ordinary rhum cirrus clouds: redefine tau_vis for cold regime and
! transition regime
         where (icld(:,:,k) .eq. 101 .and. (tempcld(:,:,k).le.t_cold))
! compute Platt-Harshvardhan optical depths in cold cloud regime
           temp_dif(:,:) = max ( (tempcld(:,:,k)-t_ref), temp_dif_min)
           tau_vis(:,:,k) = harsha_cold * temp_dif(:,:)**2 * delp(:,:,k)
         end where

         where (icld(:,:,k) .eq. 101 .and.  &
     &             (tempcld(:,:,k).gt.t_cold .and. tempcld(:,:,k).lt.t_warm))
! compute Platt-Harshvardhan optical depths in the transition regime,
! by linearly interpolating solutions from the cold and warm regimes
! with respect to temperature
           temp_dif(:,:) = t_cold - t_ref
           tau_cold(:,:) = harsha_cold * temp_dif(:,:)**2 * delp(:,:,k)
           tau_warm(:,:) = harshb_std * delp(:,:,k)
           tau_vis(:,:,k) = tau_cold(:,:) + (tau_warm(:,:)-tau_cold(:,:)) * &
     &              (tempcld(:,:,k)-t_cold) * inv_delta_t 
         end where

                   endif

                   if (l_har_coldcld .and. (.not.l_har_anvil) ) then

! ordinary rhum cirrus clouds: redefine tau_vis for cold regime and
! transition regime
         where ( (icld(:,:,k) .eq. 101 .or. icld(:,:,k) .eq. 106 .or. &
     &            icld(:,:,k) .eq. 107) .and. &
     &              (tempcld(:,:,k).le.t_cold))
! compute Platt-Harshvardhan optical depths in cold cloud regime
           temp_dif(:,:) = max ( (tempcld(:,:,k)-t_ref), temp_dif_min)
           tau_vis(:,:,k) = harsha_cold * temp_dif(:,:)**2 * delp(:,:,k)
         end where

         where ( (icld(:,:,k) .eq. 101 .or. icld(:,:,k) .eq. 106 .or. &
     &            icld(:,:,k) .eq. 107) .and. &
     &             (tempcld(:,:,k).gt.t_cold .and. tempcld(:,:,k).lt.t_warm))
! compute Platt-Harshvardhan optical depths in the transition regime,
! by linearly interpolating solutions from the cold and warm regimes
! with respect to temperature
           temp_dif(:,:) = t_cold - t_ref
           tau_cold(:,:) = harsha_cold * temp_dif(:,:)**2 * delp(:,:,k)
           tau_warm(:,:) = harshb_std * delp(:,:,k)
           tau_vis(:,:,k) = tau_cold(:,:) + (tau_warm(:,:)-tau_cold(:,:)) * &
     &              (tempcld(:,:,k)-t_cold) * inv_delta_t 
         end where

                   endif


      end do


!  The cloud optical depths of all four wave number bands are set equal to 
!  tau_vis, i.e., the value in the visible band.

     do n=1,max_band
           tau(:,:,:,n) = tau_vis(:,:,:)
     end do

        WHERE (tau(:,:,:,:) .lt. taumin)
               tau(:,:,:,:) = taumin
        END WHERE

         call  CLOUD_OPT_PROP_tg2 (tau, tempcld,           liq_frac)

                   else
     liq_frac = 0.0
                   endif

end subroutine cloud_optical_depths2




subroutine cloud_optical_depths (nclds,icld,cldtop,cldbas,tempcld,delp, &
     &          tau,phalf )

! This subroutine specifies/crudely parameterizes cloud optical depths 
! of non-anvil cirrus clouds based upon a parameterization scheme 
! resembling that proposed by Harshvardhan,
! (which is based on observations by Platt and Harshvardhan).

!===================================================================

!  namelist quantities used in this routine (defined in module intro above).

!     l_har_anvil - logical variable = t -> anvil and super anvil cirrus
!                 clouds are treated as warm clouds.
!     l_har_coldcld - logical variable = t -> activates cold cloud portion
!                 of Harshvardhan scheme.
!===================================================================

!  parameters used in this routine 

REAL, PARAMETER :: ctok = 273.16, t_ref = ctok - 82.5 
REAL, PARAMETER :: t_warm = ctok, t_cold = ctok-10.0
REAL, PARAMETER :: temp_dif_min = 1.0, inv_delta_t = 1./(t_warm-t_cold)
REAL, PARAMETER :: harshb_std = 0.08, harshb_cnv = 2.0*harshb_std
REAL, PARAMETER :: harshb_anvil = harshb_std, harshb_super_anvil = harshb_std
! The following value is 6 times larger than suggested by Platt-Harshvardan.
! The new value boosts the cold cloud emissivities in the tropics, giving
! closer agreement with ERBE.
REAL, PARAMETER :: harsha_cold = 12.8e-06

! ctok -      freezing point in deg. K..
! t_ref -     a reference minimum permitted cloud temperature in the
!             Harshvardan parameterization.
! t_warm -    the lowest temperature the cloud layer can have and still 
!             be considered warm.
! t_cold -    the highest temperature the cloud layer can have and still 
!             be considered cold. 
! temp_dif_min - the minimum temperature difference to be used in the 
!             computation of Platt-Harshvardhan cold cloud optical depths.
! inv_delta_t =  1./(t_warm-t_cold)
! harshb_std - Harshvardan coefficient for a "standard" cloud layer 
! harshb_cnv - Harshvardan coefficient for convective clouds treated as warm 
! harshb_anvil - Harshvardan coefficient for anvil cirrus clouds 
! harshb_super_anvil - Harshvardan coefficient for super anvil cirrus clouds 
! harsha_cold - Harshvardan coefficient for a cold high cloud 

!===================================================================


! Arguments (intent in)

real, intent(in), dimension(:,:,:)    :: phalf, delp, tempcld
integer, intent(in), dimension(:,:,:) :: cldtop,cldbas,icld
integer, intent(in), dimension(:,:)   ::  nclds

!      INPUT
!      ------

!       PHALF        pressure at half levels (Pascals)
!                     NOTE: it is assumed that phalf(j+1) > phalf(j)
!       NCLDS       number of (random overlapping) clouds in column and also
!                     the current # for clouds to be operating on
!      ICLD          marker array of cloud types (at cloud levels)
!      CLDTOP     index of cloud tops (at cloud levels)
!      CLDBAS     index of cloud bottoms (at cloud levels)
!      TEMPCLD    cloud layer mean temperature 
!                 (degrees Kelvin, at cloud levels)
!      DELP      cloud pressure thickness used for cloud optical depth 
!                   (at cloud levels)

!===================================================================

! Arguments (intent out)

real, intent(out), dimension(:,:,:,:) :: tau

!      OUTPUT
!      ------

!      TAU     cloud optical depth (at cloud levels)

!=======================================================================

!  (Intent local)

 integer, dimension (size(cldtop,1),size(cldtop,2)) :: cldt,cldb,icwork
 real, dimension (size(cldtop,1),size(cldtop,2)) :: & 
                                          temp_dif,tau_cold,tau_warm,pwork
 real, dimension (size(tau,1),size(tau,2),size(tau,3) )  :: tau_vis

! scalars
 integer i, j, idim, jdim, kmaxp
 integer k, max_cld
 integer n, max_band

! real 

!      CLDT, CLDB   work arrays for cloud top,base indices
!      TAU_COLD     cloud optical depth work array for cold calculation in
!                   transition regime 
!      TAU_WARM     cloud optical depth work array for warm calculation in
!                   transition regime 
!      TEMP_DIF     work array for temperature diference of distinct cloud
!                   layers 
!      ICWORK       cloud type marker work array of distinct cloud layers
!      PWORK        work array for pressure values at cloud levels (hPa) 
!      TAU_VIS      work array for cloud optical depth in visible part
!                   of spectrum
!      MAX_BAND     maximum number of radiative bands for cloud optical depth
!      MAX_CLD      maximum number of distinct cloud layers within a 
!                   vertical column

!===================================================================


! define horizontal dimensions

  idim = SIZE( cldtop, 1 )
  jdim = SIZE( cldtop, 2 )
  kmaxp = SIZE( phalf, 3 )


! find maximum number of cloud levels
      max_cld  = maxval(nclds(:,:))

! define maximum number of wave number bands for tau
      max_band = size(tau,4)


!===================================================================

! Initialize working and final cloud optical depth arrays
      tau_vis = 0.0
      tau     = 0.0

! find maximum number of clouds
      max_cld  = maxval(nclds(:,:))
                   if (max_cld .ge. 1) then

!-----------------------------------------------------------------------
! <><><><><><><><>   calc cloud optical depths <><><><><><><><>
!-----------------------------------------------------------------------

      do k = 1,max_cld

! Initialize internal arrays
      cldt = kmaxp
      cldb = 0
      icwork = 0
         where (nclds(:,:) .ge. k)
           cldt(:,:) = cldtop(:,:,k)      
           cldb(:,:) = cldbas(:,:,k) 
         end where

! fill array pwork with pressure values at the half level corresponding
! to the cloud top level cldt and convert from Pa to hPa
         do j=1,jdim
         do i=1,idim
           pwork(i,j) = phalf(i,j,cldt(i,j))*.01
         end do
         end do

! separate cloud type marker from cloud height marker
         icwork(:,:) = mod(icld(:,:,k),100)

! Standard case: warm cloud treatment will be applied to warm and cold clouds.
! Later, the cold cloud cases will be re-computed, if namelist parameter
! l_har_coldcld is set to true.

! preliminary optical depths computed everywhere

         tau_vis(:,:,k) = harshb_std * delp(:,:,k)

! redefine tau_vis for convective clouds, which are always treated as warm
         where (icwork(:,:) .eq. 5)
           tau_vis(:,:,k) = harshb_anvil * delp(:,:,k)
         end where

                   if (l_har_anvil) then
! redefine tau_vis for high clouds that meet the anvil cirrus criterion
         where (icld(:,:,k) .eq. 106)
           tau_vis(:,:,k) = harshb_anvil * delp(:,:,k)
         end where

! redefine tau_vis for high clouds that meet the super anvil cirrus criterion
         where (icld(:,:,k) .eq. 107)
           tau_vis(:,:,k) = harshb_super_anvil * delp(:,:,k)
         end where
                   endif

                   if (l_har_coldcld .and. l_har_anvil ) then

! ordinary rhum cirrus clouds: redefine tau_vis for cold regime and
! transition regime
         where (icld(:,:,k) .eq. 101 .and. (tempcld(:,:,k).le.t_cold))
! compute Platt-Harshvardhan optical depths in cold cloud regime
           temp_dif(:,:) = max ( (tempcld(:,:,k)-t_ref), temp_dif_min)
           tau_vis(:,:,k) = harsha_cold * temp_dif(:,:)**2 * delp(:,:,k)
         end where

         where (icld(:,:,k) .eq. 101 .and.  &
     &             (tempcld(:,:,k).gt.t_cold .and. tempcld(:,:,k).lt.t_warm))
! compute Platt-Harshvardhan optical depths in the transition regime,
! by linearly interpolating solutions from the cold and warm regimes
! with respect to temperature
           temp_dif(:,:) = t_cold - t_ref
           tau_cold(:,:) = harsha_cold * temp_dif(:,:)**2 * delp(:,:,k)
           tau_warm(:,:) = harshb_std * delp(:,:,k)
           tau_vis(:,:,k) = tau_cold(:,:) + (tau_warm(:,:)-tau_cold(:,:)) * &
     &              (tempcld(:,:,k)-t_cold) * inv_delta_t 
         end where

                   endif

                   if (l_har_coldcld .and. (.not.l_har_anvil) ) then

! ordinary rhum cirrus clouds: redefine tau_vis for cold regime and
! transition regime
         where ( (icld(:,:,k) .eq. 101 .or. icld(:,:,k) .eq. 106 .or. &
     &            icld(:,:,k) .eq. 107) .and. &
     &              (tempcld(:,:,k).le.t_cold))
! compute Platt-Harshvardhan optical depths in cold cloud regime
           temp_dif(:,:) = max ( (tempcld(:,:,k)-t_ref), temp_dif_min)
           tau_vis(:,:,k) = harsha_cold * temp_dif(:,:)**2 * delp(:,:,k)
         end where

         where ( (icld(:,:,k) .eq. 101 .or. icld(:,:,k) .eq. 106 .or. &
     &            icld(:,:,k) .eq. 107) .and. &
     &             (tempcld(:,:,k).gt.t_cold .and. tempcld(:,:,k).lt.t_warm))
! compute Platt-Harshvardhan optical depths in the transition regime,
! by linearly interpolating solutions from the cold and warm regimes
! with respect to temperature
           temp_dif(:,:) = t_cold - t_ref
           tau_cold(:,:) = harsha_cold * temp_dif(:,:)**2 * delp(:,:,k)
           tau_warm(:,:) = harshb_std * delp(:,:,k)
           tau_vis(:,:,k) = tau_cold(:,:) + (tau_warm(:,:)-tau_cold(:,:)) * &
     &              (tempcld(:,:,k)-t_cold) * inv_delta_t 
         end where

                   endif


      end do


!  The cloud optical depths of all four wave number bands are set equal to 
!  tau_vis, i.e., the value in the visible band.

     do n=1,max_band
           tau(:,:,:,n) = tau_vis(:,:,:)
     end do

        WHERE (tau(:,:,:,:) .lt. taumin)
               tau(:,:,:,:) = taumin
        END WHERE
                   endif


end subroutine cloud_optical_depths

!########################################################################

subroutine CLOUD_OPT_PROP_tg(LWP,IWP,       &
                        tau,w0,gg,          &
                        tempcld,qmix_kx, em_lw )

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!      This subroutine calculates the following optical properties
!      for each cloud:
!
!               1. tau    :optical depth in each band
!               2. w0     :single scattering albedo for each band
!               3. gg     :asymmetry parameter for each band
!               4. em_lw  :longwave cloud emissivity
!
!   The formulas for optical depth come from Slingo (1989) for liquid
!   clouds and from Ebert and Curry (1992) for ice clouds.
!
!   Slingo (1989) is at J. Atmos. Sci., vol. 46, pp. 1419-1427
!   Ebert and Curry (1992) is at J. Geophys. Res., vol. 97, pp. 3831-3836
!
!                    IMPORTANT!!!
!
!    NOTE WE ARE CHEATING HERE BECAUSE WE ARE FORCING THE FIVE BAND
!    MODEL OF EBERT AND CURRY INTO THE FOUR BAND MODEL OF SLINGO
!
!    THIS IS DONE BY COMBINING BANDS 3 and 4 OF EBERT AND CURRY TOGETHER
!
!   EVEN SO THE EXACT BAND LIMITS DO NOT MATCH.  FOR COMPLETENESS
!   HERE ARE THE BAND LIMITS IN MICRONS
!
!            BAND               SLINGO                 EBERT AND CURRY
!
!             1               0.25-0.69                0.25 - 0.7
!             2               0.69-1.19                0.7 - 1.3
!             3               1.19-2.38                1.3 - 2.5
!             4               2.38-4.00                2.5 - 3.5
!
! *************************    WARNING    *****************************
!
!   The above bands are used by Steve Klein.
!   We retain the scheme from the v197 frozen model,instead.
!   Nominally, our band 2 is expanded into bands 2 + 3 + 4 of Slingo.
!   The same cloud optical depth is specified in all 4 bands.
!   The same asymmetry parameter is specified in all 4 bands.
!   For single scattering albedo w0, the uv value is specified in band 1,
!   while the nir value is specified in bands 2, 3, and 4.

!   ****  WARNING    ****  The code is intended to be applied to 2 to 4 bands.
!   An error check to check that this condition is satisfied is advised.  

! *********************************************************************
!            BAND               v197     
!             1               0.25-0.70
!             2               0.70-4.00
! *********************************************************************
!
!

!
!   The mixed phase optical properties are based upon equation 14
!   of Rockel et al. 1991, Contributions to Atmospheric Physics,
!   volume 64, pp.1-12.   These equations are:
!
!   (1)    tau = tau_liq + tau_ice
!
!   (2)    w0  =   ( w0_liq * tau_liq  +  w0_ice * tau_ice ) /
!                  (          tau_liq  +           tau_ice )
!
!   w0(:,:,1) = 0.99999;  w0(:,:,2) = 0.9942  (in v197 - standard)
!   w0(:,:,1) = 0.99999;  w0(:,:,2) = F(Z.M. mixing ratio at lowest model level)
!                                    (in v197 - anomalous absorption)
!
!   (3)     g  = ( g_liq * w0_liq * tau_liq +  g_ice * w0_ice * tau_ice ) /
!                (         w0_liq * tau_liq +          w0_ice * tau_ice )
!
!           g(:,:,1:2) = 0.85 in v197
!   
!
!   (4) transmivvity_lw =   transmissivity_lw_ice * transmissivity_lw_liq
!
!    The last equation could be rewritten, after algebraic manipulation, as:
!
!   (5)  em_lw =  em_lw_liq + em_lw_ice -  (em_lw_liq * em_lw_ice )
!
!    However, the other form of the equation, i.e., 
!    1 - exp(tau_liq + tau_ice) will actually be solved.

! *******************************************************************
!
!
!   (6)  v197 only: Must first solve for LWP and IWP knowing
!                   tau, k_sw_liq, k_sw_ice, wgt_liq and wgt_ice.
!                   
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!VARIABLES
!
!       ------
!INPUT:
!       ------
!


!      L_anom_abs-g Logical namelist variable. If true, anomalous absorption
!                   is represented by a constant value of single scattering
!                   albedo. The default value and the v197 setting are
!                   both false.
!
!      L_anom_abs_v Logical namelist variable. If true, anomalous absorption
!                   is computed as a piecewise continuous function of zonal
!                   mean saturation water vapor mixing ratio at the model's
!                   vertical level closest to the earth's surface. The
!                   default value is false. The analogous namelist variable
!                   in v197, LWALBV is set to TRUE. 
!                   If both L_anom_abs_g and L_anom_abs_v are set to FALSE,
!                   then the single scattering albedo, w0,  assumes its normal
!                   constant value of 0.9942, in tg's version. w0 is a
!                   variable in Steve Klein's version.
!                   L_anom_abs_v takes precedence over L_anom_abs_g, if
!                   the former is TRUE and the latter is FALSE.
!
!     qmix_kx    Zonal mean saturation water vapor mixing ratio at the
!                   model's vertical level closest to the earth's surface.
!                   It is more convenient to pass the zonal mean, in case
!                   single column tests are performed. Alternatively,
!                   the zonal mean could be computed within this subroutine. 
!
!      tempcld      cloud layer mean temperature (degrees Kelvin), with
!                   compressed cloud layer index.
!
!
!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!       ------------
!INPUT/OUTPUT:
!       ------------
!
!      tau          optical depth in each band
!      w0           single scattering albedo for each band
!      gg           asymmetry parameter for each band
!      em_lw        longwave cloud emissivity

!            NOTE:  In tg's version, LWP and IWP are effective cloud
!                   water paths. They could be computed either in this
!                   subroutine or in subroutine cloud_water_path.

!      LWP          cloud liquid water path (kg of condensate per square meter)
!      IWP          cloud ice path (kg of condensate per square meter)
!
!
!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
!
!
!       -------------------
!INTERNAL VARIABLES:
!       -------------------
!
!       tau_liq      optical depth            at each band for cloud liquid
!       tau_ice      optical depth            at each band for cloud ice
!       w0_liq       single scattering albedo at each band for cloud liquid
!       w0_ice       single scattering albedo at each band for cloud ice
!       g_liq        asymmetry parameter      at each band for cloud liquid
!       g_ice        asymmetry parameter      at each band for cloud ice
!
!
!                   In Tony Gordon's v197 version only.
!
!       CWP           total cloud water path, i.e., cloud liquid plus
!                        cloud ice (kg of condensate per square meter)
!
!                    Parameters (defined above)
!
!       k_lw_liq     liquid cloud mass absorption coefficient for longwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_lw_ice     ice cloud mass absorption coefficient for longwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_sw_liq     liquid cloud mass absorption coefficient for shortwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_sw_ice     ice cloud mass absorption coefficient for shortwave
!                       portion of the spectrum (meters**2./kg of condensate)
!
!       tk_all_ice    minimum temperature at which cloud liquid water phase
!                       can exist (degrees Kelvin)
!       tk_all_liq    maximum temperature at which cloud ice can exist
!                       (degrees Kelvin)
!       wgt_liq       The ratio of liquid water path to total cloud water path,
!                        i.e., LWP / CWP
!       wgt_ice       The ratio of ice water path to total cloud water path,
!                        i.e., IWP / CWP
!
!       qsat_min      Minimum value of zonal mean saturation water vapor mixing
!                        ratio entering into the variable anomalous absorption
!                        single scattering albedo calculations.
!       qsat_trans    Transition value of zonal mean saturation mixing ratio
!                        between two branches of a piecewise continuous
!                        function entering into the variable anomalous
!                        absorption single scattering albedo calculations.
!       qsat_max      Maximum value of zonal mean saturation water vapor mixing
!                        ratio entering into the variable anomalous absorption
!                        single scattering albedo calculations.
!
!       w0_norm_uv    Normal, constant single scattering albedo in the uv-vis
!                        wavelength band of the radiation spectrum.
!       w0_norm_nir   Normal, constant single scattering albedo in the nir
!                        wavelength band of the radiation spectrum.
!       w0_anom1_nir  Asymptotic minimum value of single scattering albedo
!                        for variable anomalous absorption; also the
!                        low constant value, if L_anom_abs_g is set to TRUE.
!       w0_anom2_nir  Asymptotic maximum value of single scattering albedo
!                        for variable anomalous absorption,usually occurring
!                        at high latitudes.
! 
!       g_norm        Normal, constant asymmetry parameter used in Tony Gordon's
!                        v197 scheme. It is independent of wavelength.                                
!

!      MAX_BAND     maximum number of wave number bands for tau,etc.

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !
!                   
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!  User Interface variables
!  ------------------------

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!  in tony gordon's v197 scheme only:
!
real,     intent (in),     dimension(:,:)      :: qmix_kx
real,     intent (in),     dimension(:,:,:)    :: tempcld


!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

real,     intent (in   ),dimension(:,:,:,:)   :: tau
real,     intent (out),dimension(:,:,:,:)   :: w0,gg
real,     intent (out),dimension(:,:,:), optional     :: em_lw

real,     intent (out)   ,dimension(:,:,:)  :: LWP,IWP


! XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
! XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
!  Internal variables
!  ------------------

real, dimension(size(lwp,1),size(lwp,2),size(lwp,3),4) :: tau_liq, tau_ice
real, dimension(size(lwp,1),size(lwp,2),size(lwp,3),4) :: w0_liq, w0_ice
real, dimension(size(lwp,1),size(lwp,2),size(lwp,3),4) :: g_liq, g_ice
real, dimension(size(lwp,1),size(lwp,2),size(lwp,3))   :: wgt_ice, wgt_liq
real, dimension(size(lwp,1),size(lwp,2),size(lwp,3))   :: cwp
real, dimension(size(lwp,1),size(lwp,2),size(lwp,3))   :: w0_anom_work
real, dimension(size(lwp,1),size(lwp,2),size(lwp,3))   :: qmix_kx_work
integer                                                :: k, kmax
integer                                                :: n, max_band

!  Declare tau_chk to compare with tau, if code needs to be debugged.
real, dimension(size(lwp,1),size(lwp,2),size(lwp,3),4) :: tau_chk

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!
! Code
! ----

!  define maximum number of wave number bands for tau
      max_band = size(tau,4)

!  For tg v197, tau is previously computed in subroutine cloud_optical_depths,
!  while w0 and gg will be reinitialized.
!  Also, internal variables w0_liq, w0_ice, g_liq, and g_ice
!  will be re-initialized, while tau_liq and tau_ice will not be.

!  Therefore, the only output variable to be initialized is em_lw.
!  Comment out the other reinitialization commands.


!  These are Tony Gordon's reinitialized values.
        gg(:,:,:,:)    = 0.85
        w0(:,:,:,1)    = 0.99999
        w0(:,:,:,2:4)  = 0.9942
if (present (em_lw)) then
        em_lw(:,:,:)   = 0.
endif

        w0_liq(:,:,:,1)   = 0.99999
        w0_liq(:,:,:,2:4) = 0.9942
        w0_ice(:,:,:,1)   = 0.99999
        w0_ice(:,:,:,2:4) = 0.9942
        g_liq(:,:,:,:)    = 0.85
        g_ice(:,:,:,:)    = 0.85

! . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

!       Comment out Steve Klein's reinitialized values.
!       tau(:,:,:,:) = 0.
!       gg(:,:,:,:)  = 0.85
!       w0(:,:,:,:)  = 0.95
!       em_lw(:,:,:) = 0.

!       w0_liq(:,:,:,:) = 0.95
!       w0_ice(:,:,:,:) = 0.95
!       tau_liq(:,:,:,:)= 0.
!       tau_ice(:,:,:,:)= 0.



    !---------------   COMPUTE OPTICAL DEPTH ---------------------------!



        ! compute uv cloud optical depths due to liquid
        ! and ice phase separately


!       by Tony Gordon's v197 scheme

        WHERE (tempcld(:,:,:) .le. tk_all_ice)
               wgt_liq(:,:,:) = 0.
               wgt_ice(:,:,:) = 1.
        END WHERE

        WHERE (tempcld(:,:,:) .ge. tk_all_liq)
               wgt_liq(:,:,:) = 1.
               wgt_ice(:,:,:) = 0.
        END WHERE

        WHERE (tempcld(:,:,:) .gt. tk_all_ice .and. tempcld(:,:,:) &
               .lt. tk_all_liq)
               wgt_liq(:,:,:) = (tempcld(:,:,:) - tk_all_ice) / &
                                (tk_all_liq - tk_all_ice)
               wgt_ice(:,:,:) = 1. - wgt_liq(:,:,:)
        END WHERE
                     
        CWP(:,:,:) = tau(:,:,:,1) / &
                     (k_sw_liq * wgt_liq(:,:,:) + &
                      k_sw_ice * wgt_ice(:,:,:) )

        LWP(:,:,:) = wgt_liq(:,:,:) * CWP(:,:,:)
        IWP(:,:,:) = wgt_ice(:,:,:) * CWP(:,:,:)

        tau_liq(:,:,:,1)   = k_sw_liq * LWP(:,:,:)
        tau_ice(:,:,:,1)   = k_sw_ice * IWP(:,:,:)

!  tau_liq and tau_ice are purely diagnostic, since tau is already known.
!  Generalize code to n bands, though it may need to be revised,
!  if max_band changes.

             if (max_band .ge. 2) then
        do n=2,max_band
        tau_liq(:,:,:,n) = tau_liq(:,:,:,1)
        tau_ice(:,:,:,n) = tau_ice(:,:,:,1)
        end do
             endif

! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

!  Compute total cloud optical depth, using same formula as Steve Klein.
!  Note:  Comment out the following command in Tony Gordon's v197 scheme.
!         tau should have the same as the input, except for roundoff error.

!         tau(:,:,:,:)     = tau_liq(:,:,:,:) + tau_ice(:,:,:,:)

!  Define tau_chk to compare with tau, if code needs to be debugged.
          tau_chk(:,:,:,:) = tau_liq(:,:,:,:) + tau_ice(:,:,:,:)

! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -



   !---------------   COMPUTE SINGLE SCATTERING ALBEDO ----------------!


!
        w0_liq(:,:,:,1) =  w0_norm_uv
        w0_ice(:,:,:,1) =  w0_norm_uv

     IF (.not. L_anom_abs_g .and. .not. L_anom_abs_v) THEN

!       Specify tg's normal single scattering albedos for NIR bands.

!  Generalize code to n bands, though it may need to be revised,
!  if max_band changes

             if (max_band .ge. 2) then
        do n=2,max_band
        w0_liq(:,:,:,n) =  w0_norm_nir
        w0_ice(:,:,:,n) =  w0_norm_nir
        end do
             endif

     ENDIF

     IF (L_anom_abs_g) THEN

!  Generalize code to n bands, though it may need to be revised,
!  if max_band changes

             if (max_band .ge. 2) then
        do n=2,max_band
        w0_liq(:,:,:,n) =  w0_anom1_nir
        w0_ice(:,:,:,n) =  w0_anom1_nir
        end do
             endif

     ENDIF

!
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!
!    Broadcast qmix_kx to generate WHERE statements with correct syntax.

     kmax = SIZE(LWP,3)

     DO k = 1,kmax
        qmix_kx_work(:,:,k) = qmix_kx(:,:)
     END DO
!
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!
! 
     IF (L_anom_abs_v) THEN

       WHERE (qmix_kx_work(:,:,:) .le. qsat_min)

!      Apply lower asymptotic limit to anomalously weak cloud absorption,
!      i.e., upper asymptotic limit of w0.

!      This situation should not occur for saturation mixing ratios. However,
!      negative mixing ratios are possible in the spectral AGCM,
!      especially in cold temperature, e.g., high latitude regions.
!      Retain this WHERE loop, in case parameterization is ever changed 
!      from saturation mixing ratio to mixing ratio.
      
              w0_anom_work(:,:,:) = w0_anom2_nir

       END WHERE 

       WHERE (qmix_kx_work(:,:,:) .gt. qsat_min .and.                  &
              qmix_kx_work(:,:,:) .lt. qsat_trans)

!      Anomalously weak cloud absorption relative to the reference value 
!      w0_norm_nir will tend to occur at higher latitudes for these values
!      of w0.

            w0_anom_work(:,:,:) = w0_anom2_nir -                    &
               (w0_anom2_nir - w0_norm_nir)    *                    &
               ( (qmix_kx_work(:,:,:) - qsat_min) / (qsat_trans - qsat_min))

       END WHERE

       WHERE (qmix_kx_work(:,:,:) .eq. qsat_trans)

!      The reference value of nir single scattering albedo will be used.

           w0_anom_work(:,:,:) = w0_norm_nir

       END WHERE

       WHERE (qmix_kx_work(:,:,:) .gt. qsat_trans .and.                &
              qmix_kx_work(:,:,:) .lt. qsat_max)

!      Anomalously high absorption relative to the reference value w0_norm_nir
!      will tend to occur at tropical and subtropical latitudes for 
!      these values of w0.

           w0_anom_work(:,:,:) = w0_norm_nir  -                    &
              (w0_norm_nir - w0_anom1_nir)    *                    &
              ( (qmix_kx_work(:,:,:) - qsat_trans) / (qsat_max - qsat_trans))

       END WHERE

       WHERE (qmix_kx_work(:,:,:) .ge. qsat_max)

!      Apply upper asymptotic limit to the anomalous absorption, i.e.,
!      lower asymptotic limit of w0.

              w0_anom_work = w0_anom1_nir

       END WHERE

!  Generalize code to n bands, though it may need to be revised,
!  if max_band changes

             if (max_band .ge. 2) then
        do n=2,max_band
       w0_liq(:,:,:,n) = w0_anom_work(:,:,:)
       w0_ice(:,:,:,n) = w0_anom_work(:,:,:)
        end do
             endif

     ENDIF



! compute total single scattering albedo
        WHERE (tau(:,:,:,:) .gt. 0.)
               w0(:,:,:,:) = ( w0_liq(:,:,:,:) * tau_liq(:,:,:,:) + &
                               w0_ice(:,:,:,:) * tau_ice(:,:,:,:) ) / &
                             tau(:,:,:,:)
        END WHERE

   !---------------   COMPUTE ASYMMETRY PARAMETER --------------------!

        WHERE (tau(:,:,:,:) .gt. 0. )
              gg(:,:,:,:) = ( &
                 w0_liq(:,:,:,:) * g_liq(:,:,:,:) * tau_liq(:,:,:,:) + &
                 w0_ice(:,:,:,:) * g_ice(:,:,:,:) * tau_ice(:,:,:,:) ) &
                       /          (w0_liq(:,:,:,:) * tau_liq(:,:,:,:) + &
                                   w0_ice(:,:,:,:) * tau_ice(:,:,:,:) )
        END WHERE


   !---------------   COMPUTE LONGWAVE EMISSIVITY --------------------!


       if (present(em_lw)) then
!
!  In Tony Gordon's v197 scheme, k_lw-liq and k_lw_ice are parameters.
!        k_lw_liq(:,:,:) = 140.
!        k_lw_ice(:,:,:) = 100.

! compute combined emmisivity
        em_lw(:,:,:) =  1. - exp( -1. * ( k_lw_liq * LWP(:,:,:) + &
                                          k_lw_ice * IWP(:,:,:) ) )

     endif

   !--------------    RANGE LIMIT QUANTITIES --------------------------!

!       WHERE (tau(:,:,:,:) .lt. taumin)
!              tau(:,:,:,:) = taumin
!       END WHERE


end subroutine CLOUD_OPT_PROP_tg


subroutine CLOUD_OPT_PROP_tg3(LWP,IWP,       &
                        tau,w0,gg,          &
                        tempcld,qmix_kx, em_lw )

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!      This subroutine calculates the following optical properties
!      for each cloud:
!
!               1. tau    :optical depth in each band
!               2. w0     :single scattering albedo for each band
!               3. gg     :asymmetry parameter for each band
!               4. em_lw  :longwave cloud emissivity
!
!   The formulas for optical depth come from Slingo (1989) for liquid
!   clouds and from Ebert and Curry (1992) for ice clouds.
!
!   Slingo (1989) is at J. Atmos. Sci., vol. 46, pp. 1419-1427
!   Ebert and Curry (1992) is at J. Geophys. Res., vol. 97, pp. 3831-3836
!
!                    IMPORTANT!!!
!
!    NOTE WE ARE CHEATING HERE BECAUSE WE ARE FORCING THE FIVE BAND
!    MODEL OF EBERT AND CURRY INTO THE FOUR BAND MODEL OF SLINGO
!
!    THIS IS DONE BY COMBINING BANDS 3 and 4 OF EBERT AND CURRY TOGETHER
!
!   EVEN SO THE EXACT BAND LIMITS DO NOT MATCH.  FOR COMPLETENESS
!   HERE ARE THE BAND LIMITS IN MICRONS
!
!            BAND               SLINGO                 EBERT AND CURRY
!
!             1               0.25-0.69                0.25 - 0.7
!             2               0.69-1.19                0.7 - 1.3
!             3               1.19-2.38                1.3 - 2.5
!             4               2.38-4.00                2.5 - 3.5
!
! *************************    WARNING    *****************************
!
!   The above bands are used by Steve Klein.
!   We retain the scheme from the v197 frozen model,instead.
!   Nominally, our band 2 is expanded into bands 2 + 3 + 4 of Slingo.
!   The same cloud optical depth is specified in all 4 bands.
!   The same asymmetry parameter is specified in all 4 bands.
!   For single scattering albedo w0, the uv value is specified in band 1,
!   while the nir value is specified in bands 2, 3, and 4.

!   ****  WARNING    ****  The code is intended to be applied to 2 to 4 bands.
!   An error check to check that this condition is satisfied is advised.  

! *********************************************************************
!            BAND               v197     
!             1               0.25-0.70
!             2               0.70-4.00
! *********************************************************************
!
!

!
!   The mixed phase optical properties are based upon equation 14
!   of Rockel et al. 1991, Contributions to Atmospheric Physics,
!   volume 64, pp.1-12.   These equations are:
!
!   (1)    tau = tau_liq + tau_ice
!
!   (2)    w0  =   ( w0_liq * tau_liq  +  w0_ice * tau_ice ) /
!                  (          tau_liq  +           tau_ice )
!
!   w0(:,:,1) = 0.99999;  w0(:,:,2) = 0.9942  (in v197 - standard)
!   w0(:,:,1) = 0.99999;  w0(:,:,2) = F(Z.M. mixing ratio at lowest model level)
!                                    (in v197 - anomalous absorption)
!
!   (3)     g  = ( g_liq * w0_liq * tau_liq +  g_ice * w0_ice * tau_ice ) /
!                (         w0_liq * tau_liq +          w0_ice * tau_ice )
!
!           g(:,:,1:2) = 0.85 in v197
!   
!
!   (4) transmivvity_lw =   transmissivity_lw_ice * transmissivity_lw_liq
!
!    The last equation could be rewritten, after algebraic manipulation, as:
!
!   (5)  em_lw =  em_lw_liq + em_lw_ice -  (em_lw_liq * em_lw_ice )
!
!    However, the other form of the equation, i.e., 
!    1 - exp(tau_liq + tau_ice) will actually be solved.

! *******************************************************************
!
!
!   (6)  v197 only: Must first solve for LWP and IWP knowing
!                   tau, k_sw_liq, k_sw_ice, wgt_liq and wgt_ice.
!                   
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!VARIABLES
!
!       ------
!INPUT:
!       ------
!


!      L_anom_abs-g Logical namelist variable. If true, anomalous absorption
!                   is represented by a constant value of single scattering
!                   albedo. The default value and the v197 setting are
!                   both false.
!
!      L_anom_abs_v Logical namelist variable. If true, anomalous absorption
!                   is computed as a piecewise continuous function of zonal
!                   mean saturation water vapor mixing ratio at the model's
!                   vertical level closest to the earth's surface. The
!                   default value is false. The analogous namelist variable
!                   in v197, LWALBV is set to TRUE. 
!                   If both L_anom_abs_g and L_anom_abs_v are set to FALSE,
!                   then the single scattering albedo, w0,  assumes its normal
!                   constant value of 0.9942, in tg's version. w0 is a
!                   variable in Steve Klein's version.
!                   L_anom_abs_v takes precedence over L_anom_abs_g, if
!                   the former is TRUE and the latter is FALSE.
!
!     qmix_kx    Zonal mean saturation water vapor mixing ratio at the
!                   model's vertical level closest to the earth's surface.
!                   It is more convenient to pass the zonal mean, in case
!                   single column tests are performed. Alternatively,
!                   the zonal mean could be computed within this subroutine. 
!
!      tempcld      cloud layer mean temperature (degrees Kelvin), with
!                   compressed cloud layer index.
!
!
!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!       ------------
!INPUT/OUTPUT:
!       ------------
!
!      tau          optical depth in each band
!      w0           single scattering albedo for each band
!      gg           asymmetry parameter for each band
!      em_lw        longwave cloud emissivity

!            NOTE:  In tg's version, LWP and IWP are effective cloud
!                   water paths. They could be computed either in this
!                   subroutine or in subroutine cloud_water_path.

!      LWP          cloud liquid water path (kg of condensate per square meter)
!      IWP          cloud ice path (kg of condensate per square meter)
!
!
!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
!
!
!       -------------------
!INTERNAL VARIABLES:
!       -------------------
!
!       tau_liq      optical depth            at each band for cloud liquid
!       tau_ice      optical depth            at each band for cloud ice
!       w0_liq       single scattering albedo at each band for cloud liquid
!       w0_ice       single scattering albedo at each band for cloud ice
!       g_liq        asymmetry parameter      at each band for cloud liquid
!       g_ice        asymmetry parameter      at each band for cloud ice
!
!
!                   In Tony Gordon's v197 version only.
!
!       CWP           total cloud water path, i.e., cloud liquid plus
!                        cloud ice (kg of condensate per square meter)
!
!                    Parameters (defined above)
!
!       k_lw_liq     liquid cloud mass absorption coefficient for longwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_lw_ice     ice cloud mass absorption coefficient for longwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_sw_liq     liquid cloud mass absorption coefficient for shortwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_sw_ice     ice cloud mass absorption coefficient for shortwave
!                       portion of the spectrum (meters**2./kg of condensate)
!
!       tk_all_ice    minimum temperature at which cloud liquid water phase
!                       can exist (degrees Kelvin)
!       tk_all_liq    maximum temperature at which cloud ice can exist
!                       (degrees Kelvin)
!       wgt_liq       The ratio of liquid water path to total cloud water path,
!                        i.e., LWP / CWP
!       wgt_ice       The ratio of ice water path to total cloud water path,
!                        i.e., IWP / CWP
!
!       qsat_min      Minimum value of zonal mean saturation water vapor mixing
!                        ratio entering into the variable anomalous absorption
!                        single scattering albedo calculations.
!       qsat_trans    Transition value of zonal mean saturation mixing ratio
!                        between two branches of a piecewise continuous
!                        function entering into the variable anomalous
!                        absorption single scattering albedo calculations.
!       qsat_max      Maximum value of zonal mean saturation water vapor mixing
!                        ratio entering into the variable anomalous absorption
!                        single scattering albedo calculations.
!
!       w0_norm_uv    Normal, constant single scattering albedo in the uv-vis
!                        wavelength band of the radiation spectrum.
!       w0_norm_nir   Normal, constant single scattering albedo in the nir
!                        wavelength band of the radiation spectrum.
!       w0_anom1_nir  Asymptotic minimum value of single scattering albedo
!                        for variable anomalous absorption; also the
!                        low constant value, if L_anom_abs_g is set to TRUE.
!       w0_anom2_nir  Asymptotic maximum value of single scattering albedo
!                        for variable anomalous absorption,usually occurring
!                        at high latitudes.
! 
!       g_norm        Normal, constant asymmetry parameter used in Tony Gordon's
!                        v197 scheme. It is independent of wavelength.                                
!

!      MAX_BAND     maximum number of wave number bands for tau,etc.

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !
!                   
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!  User Interface variables
!  ------------------------

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!  in tony gordon's v197 scheme only:
!
real,     intent (in),     dimension(:,:)      :: qmix_kx
real,     intent (in),     dimension(:,:,:)    :: tempcld


!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

real,     intent (in   ),dimension(:,:,:,:)   :: tau
real,     intent (out),dimension(:,:,:,:)   :: w0,gg
real,     intent (out),dimension(:,:,:), optional     :: em_lw

real,     intent ( in)   ,dimension(:,:,:)  :: LWP,IWP


! XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
! XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
!  Internal variables
!  ------------------

real, dimension(size(lwp,1),size(lwp,2),size(lwp,3),4) :: tau_liq, tau_ice
real, dimension(size(lwp,1),size(lwp,2),size(lwp,3),4) :: w0_liq, w0_ice
real, dimension(size(lwp,1),size(lwp,2),size(lwp,3),4) :: g_liq, g_ice
real, dimension(size(lwp,1),size(lwp,2),size(lwp,3))   :: w0_anom_work
real, dimension(size(lwp,1),size(lwp,2),size(lwp,3))   :: qmix_kx_work
integer                                                :: k, kmax
integer                                                :: n, max_band

!  Declare tau_chk to compare with tau, if code needs to be debugged.
real, dimension(size(lwp,1),size(lwp,2),size(lwp,3),4) :: tau_chk

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!
! Code
! ----

!  define maximum number of wave number bands for tau
      max_band = size(tau,4)

!  For tg v197, tau is previously computed in subroutine cloud_optical_depths,
!  while w0 and gg will be reinitialized.
!  Also, internal variables w0_liq, w0_ice, g_liq, and g_ice
!  will be re-initialized, while tau_liq and tau_ice will not be.

!  Therefore, the only output variable to be initialized is em_lw.
!  Comment out the other reinitialization commands.


!  These are Tony Gordon's reinitialized values.
        gg(:,:,:,:)    = 0.85
        w0(:,:,:,1)    = 0.99999
        w0(:,:,:,2:4)  = 0.9942
if (present (em_lw)) then
        em_lw(:,:,:)   = 0.
endif

        w0_liq(:,:,:,1)   = 0.99999
        w0_liq(:,:,:,2:4) = 0.9942
        w0_ice(:,:,:,1)   = 0.99999
        w0_ice(:,:,:,2:4) = 0.9942
        g_liq(:,:,:,:)    = 0.85
        g_ice(:,:,:,:)    = 0.85

! . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

!       Comment out Steve Klein's reinitialized values.
!       tau(:,:,:,:) = 0.
!       gg(:,:,:,:)  = 0.85
!       w0(:,:,:,:)  = 0.95
!       em_lw(:,:,:) = 0.

!       w0_liq(:,:,:,:) = 0.95
!       w0_ice(:,:,:,:) = 0.95
!       tau_liq(:,:,:,:)= 0.
!       tau_ice(:,:,:,:)= 0.



    !---------------   COMPUTE OPTICAL DEPTH ---------------------------!



        ! compute uv cloud optical depths due to liquid
        ! and ice phase separately


!       by Tony Gordon's v197 scheme


        tau_liq(:,:,:,1)   = k_sw_liq * LWP(:,:,:)
        tau_ice(:,:,:,1)   = k_sw_ice * IWP(:,:,:)

!  tau_liq and tau_ice are purely diagnostic, since tau is already known.
!  Generalize code to n bands, though it may need to be revised,
!  if max_band changes.

             if (max_band .ge. 2) then
        do n=2,max_band
        tau_liq(:,:,:,n) = tau_liq(:,:,:,1)
        tau_ice(:,:,:,n) = tau_ice(:,:,:,1)
        end do
             endif

! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

!  Compute total cloud optical depth, using same formula as Steve Klein.
!  Note:  Comment out the following command in Tony Gordon's v197 scheme.
!         tau should have the same as the input, except for roundoff error.

!         tau(:,:,:,:)     = tau_liq(:,:,:,:) + tau_ice(:,:,:,:)

!  Define tau_chk to compare with tau, if code needs to be debugged.
          tau_chk(:,:,:,:) = tau_liq(:,:,:,:) + tau_ice(:,:,:,:)

! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -



   !---------------   COMPUTE SINGLE SCATTERING ALBEDO ----------------!


!
        w0_liq(:,:,:,1) =  w0_norm_uv
        w0_ice(:,:,:,1) =  w0_norm_uv

     IF (.not. L_anom_abs_g .and. .not. L_anom_abs_v) THEN

!       Specify tg's normal single scattering albedos for NIR bands.

!  Generalize code to n bands, though it may need to be revised,
!  if max_band changes

             if (max_band .ge. 2) then
        do n=2,max_band
        w0_liq(:,:,:,n) =  w0_norm_nir
        w0_ice(:,:,:,n) =  w0_norm_nir
        end do
             endif

     ENDIF

     IF (L_anom_abs_g) THEN

!  Generalize code to n bands, though it may need to be revised,
!  if max_band changes

             if (max_band .ge. 2) then
        do n=2,max_band
        w0_liq(:,:,:,n) =  w0_anom1_nir
        w0_ice(:,:,:,n) =  w0_anom1_nir
        end do
             endif

     ENDIF

!
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!
!    Broadcast qmix_kx to generate WHERE statements with correct syntax.

     kmax = SIZE(LWP,3)

     DO k = 1,kmax
        qmix_kx_work(:,:,k) = qmix_kx(:,:)
     END DO
!
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!
! 
     IF (L_anom_abs_v) THEN

       WHERE (qmix_kx_work(:,:,:) .le. qsat_min)

!      Apply lower asymptotic limit to anomalously weak cloud absorption,
!      i.e., upper asymptotic limit of w0.

!      This situation should not occur for saturation mixing ratios. However,
!      negative mixing ratios are possible in the spectral AGCM,
!      especially in cold temperature, e.g., high latitude regions.
!      Retain this WHERE loop, in case parameterization is ever changed 
!      from saturation mixing ratio to mixing ratio.
      
              w0_anom_work(:,:,:) = w0_anom2_nir

       END WHERE 

       WHERE (qmix_kx_work(:,:,:) .gt. qsat_min .and.                  &
              qmix_kx_work(:,:,:) .lt. qsat_trans)

!      Anomalously weak cloud absorption relative to the reference value 
!      w0_norm_nir will tend to occur at higher latitudes for these values
!      of w0.

            w0_anom_work(:,:,:) = w0_anom2_nir -                    &
               (w0_anom2_nir - w0_norm_nir)    *                    &
               ( (qmix_kx_work(:,:,:) - qsat_min) / (qsat_trans - qsat_min))

       END WHERE

       WHERE (qmix_kx_work(:,:,:) .eq. qsat_trans)

!      The reference value of nir single scattering albedo will be used.

           w0_anom_work(:,:,:) = w0_norm_nir

       END WHERE

       WHERE (qmix_kx_work(:,:,:) .gt. qsat_trans .and.                &
              qmix_kx_work(:,:,:) .lt. qsat_max)

!      Anomalously high absorption relative to the reference value w0_norm_nir
!      will tend to occur at tropical and subtropical latitudes for 
!      these values of w0.

           w0_anom_work(:,:,:) = w0_norm_nir  -                    &
              (w0_norm_nir - w0_anom1_nir)    *                    &
              ( (qmix_kx_work(:,:,:) - qsat_trans) / (qsat_max - qsat_trans))

       END WHERE

       WHERE (qmix_kx_work(:,:,:) .ge. qsat_max)

!      Apply upper asymptotic limit to the anomalous absorption, i.e.,
!      lower asymptotic limit of w0.

              w0_anom_work = w0_anom1_nir

       END WHERE

!  Generalize code to n bands, though it may need to be revised,
!  if max_band changes

             if (max_band .ge. 2) then
        do n=2,max_band
       w0_liq(:,:,:,n) = w0_anom_work(:,:,:)
       w0_ice(:,:,:,n) = w0_anom_work(:,:,:)
        end do
             endif

     ENDIF



! compute total single scattering albedo
        WHERE (tau(:,:,:,:) .gt. 0.)
               w0(:,:,:,:) = ( w0_liq(:,:,:,:) * tau_liq(:,:,:,:) + &
                               w0_ice(:,:,:,:) * tau_ice(:,:,:,:) ) / &
                             tau(:,:,:,:)
        END WHERE

   !---------------   COMPUTE ASYMMETRY PARAMETER --------------------!

        WHERE (tau(:,:,:,:) .gt. 0. )
              gg(:,:,:,:) = ( &
                 w0_liq(:,:,:,:) * g_liq(:,:,:,:) * tau_liq(:,:,:,:) + &
                 w0_ice(:,:,:,:) * g_ice(:,:,:,:) * tau_ice(:,:,:,:) ) &
                       /          (w0_liq(:,:,:,:) * tau_liq(:,:,:,:) + &
                                   w0_ice(:,:,:,:) * tau_ice(:,:,:,:) )
        END WHERE


   !---------------   COMPUTE LONGWAVE EMISSIVITY --------------------!


       if (present(em_lw)) then
!
!  In Tony Gordon's v197 scheme, k_lw-liq and k_lw_ice are parameters.
!        k_lw_liq(:,:,:) = 140.
!        k_lw_ice(:,:,:) = 100.

! compute combined emmisivity
        em_lw(:,:,:) =  1. - exp( -1. * ( k_lw_liq * LWP(:,:,:) + &
                                          k_lw_ice * IWP(:,:,:) ) )

     endif

   !--------------    RANGE LIMIT QUANTITIES --------------------------!

!       WHERE (tau(:,:,:,:) .lt. taumin)
!              tau(:,:,:,:) = taumin
!       END WHERE


end subroutine CLOUD_OPT_PROP_tg3

subroutine CLOUD_OPT_PROP_tg_lw(               tau, liq_frac, em_lw)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!      This subroutine calculates the following optical properties
!      for each cloud:
!
!               1. tau    :optical depth in each band
!               2. w0     :single scattering albedo for each band
!               3. gg     :asymmetry parameter for each band
!               4. em_lw  :longwave cloud emissivity
!
!   The formulas for optical depth come from Slingo (1989) for liquid
!   clouds and from Ebert and Curry (1992) for ice clouds.
!
!   Slingo (1989) is at J. Atmos. Sci., vol. 46, pp. 1419-1427
!   Ebert and Curry (1992) is at J. Geophys. Res., vol. 97, pp. 3831-3836
!
!                    IMPORTANT!!!
!
!    NOTE WE ARE CHEATING HERE BECAUSE WE ARE FORCING THE FIVE BAND
!    MODEL OF EBERT AND CURRY INTO THE FOUR BAND MODEL OF SLINGO
!
!    THIS IS DONE BY COMBINING BANDS 3 and 4 OF EBERT AND CURRY TOGETHER
!
!   EVEN SO THE EXACT BAND LIMITS DO NOT MATCH.  FOR COMPLETENESS
!   HERE ARE THE BAND LIMITS IN MICRONS
!
!            BAND               SLINGO                 EBERT AND CURRY
!
!             1               0.25-0.69                0.25 - 0.7
!             2               0.69-1.19                0.7 - 1.3
!             3               1.19-2.38                1.3 - 2.5
!             4               2.38-4.00                2.5 - 3.5
!
! *************************    WARNING    *****************************
!
!   The above bands are used by Steve Klein.
!   We retain the scheme from the v197 frozen model,instead.
!   Nominally, our band 2 is expanded into bands 2 + 3 + 4 of Slingo.
!   The same cloud optical depth is specified in all 4 bands.
!   The same asymmetry parameter is specified in all 4 bands.
!   For single scattering albedo w0, the uv value is specified in band 1,
!   while the nir value is specified in bands 2, 3, and 4.

!   ****  WARNING    ****  The code is intended to be applied to 2 to 4 bands.
!   An error check to check that this condition is satisfied is advised.  

! *********************************************************************
!            BAND               v197     
!             1               0.25-0.70
!             2               0.70-4.00
! *********************************************************************
!
!

!
!   The mixed phase optical properties are based upon equation 14
!   of Rockel et al. 1991, Contributions to Atmospheric Physics,
!   volume 64, pp.1-12.   These equations are:
!
!   (1)    tau = tau_liq + tau_ice
!
!   (2)    w0  =   ( w0_liq * tau_liq  +  w0_ice * tau_ice ) /
!                  (          tau_liq  +           tau_ice )
!
!   w0(:,:,1) = 0.99999;  w0(:,:,2) = 0.9942  (in v197 - standard)
!   w0(:,:,1) = 0.99999;  w0(:,:,2) = F(Z.M. mixing ratio at lowest model level)
!                                    (in v197 - anomalous absorption)
!
!   (3)     g  = ( g_liq * w0_liq * tau_liq +  g_ice * w0_ice * tau_ice ) /
!                (         w0_liq * tau_liq +          w0_ice * tau_ice )
!
!           g(:,:,1:2) = 0.85 in v197
!   
!
!   (4) transmivvity_lw =   transmissivity_lw_ice * transmissivity_lw_liq
!
!    The last equation could be rewritten, after algebraic manipulation, as:
!
!   (5)  em_lw =  em_lw_liq + em_lw_ice -  (em_lw_liq * em_lw_ice )
!
!    However, the other form of the equation, i.e., 
!    1 - exp(tau_liq + tau_ice) will actually be solved.

! *******************************************************************
!
!
!   (6)  v197 only: Must first solve for LWP and IWP knowing
!                   tau, k_sw_liq, k_sw_ice, wgt_liq and wgt_ice.
!                   
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!VARIABLES
!
!       ------
!INPUT:
!       ------
!


!      L_anom_abs-g Logical namelist variable. If true, anomalous absorption
!                   is represented by a constant value of single scattering
!                   albedo. The default value and the v197 setting are
!                   both false.
!
!      L_anom_abs_v Logical namelist variable. If true, anomalous absorption
!                   is computed as a piecewise continuous function of zonal
!                   mean saturation water vapor mixing ratio at the model's
!                   vertical level closest to the earth's surface. The
!                   default value is false. The analogous namelist variable
!                   in v197, LWALBV is set to TRUE. 
!                   If both L_anom_abs_g and L_anom_abs_v are set to FALSE,
!                   then the single scattering albedo, w0,  assumes its normal
!                   constant value of 0.9942, in tg's version. w0 is a
!                   variable in Steve Klein's version.
!                   L_anom_abs_v takes precedence over L_anom_abs_g, if
!                   the former is TRUE and the latter is FALSE.
!
!     qmix_kx    Zonal mean saturation water vapor mixing ratio at the
!                   model's vertical level closest to the earth's surface.
!                   It is more convenient to pass the zonal mean, in case
!                   single column tests are performed. Alternatively,
!                   the zonal mean could be computed within this subroutine. 
!
!      tempcld      cloud layer mean temperature (degrees Kelvin), with
!                   compressed cloud layer index.
!
!
!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!       ------------
!INPUT/OUTPUT:
!       ------------
!
!      tau          optical depth in each band
!      w0           single scattering albedo for each band
!      gg           asymmetry parameter for each band
!      em_lw        longwave cloud emissivity

!            NOTE:  In tg's version, LWP and IWP are effective cloud
!                   water paths. They could be computed either in this
!                   subroutine or in subroutine cloud_water_path.

!      LWP          cloud liquid water path (kg of condensate per square meter)
!      IWP          cloud ice path (kg of condensate per square meter)
!
!
!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
!
!
!       -------------------
!INTERNAL VARIABLES:
!       -------------------
!
!       tau_liq      optical depth            at each band for cloud liquid
!       tau_ice      optical depth            at each band for cloud ice
!       w0_liq       single scattering albedo at each band for cloud liquid
!       w0_ice       single scattering albedo at each band for cloud ice
!       g_liq        asymmetry parameter      at each band for cloud liquid
!       g_ice        asymmetry parameter      at each band for cloud ice
!
!
!                   In Tony Gordon's v197 version only.
!
!       CWP           total cloud water path, i.e., cloud liquid plus
!                        cloud ice (kg of condensate per square meter)
!
!                    Parameters (defined above)
!
!       k_lw_liq     liquid cloud mass absorption coefficient for longwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_lw_ice     ice cloud mass absorption coefficient for longwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_sw_liq     liquid cloud mass absorption coefficient for shortwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_sw_ice     ice cloud mass absorption coefficient for shortwave
!                       portion of the spectrum (meters**2./kg of condensate)
!
!       tk_all_ice    minimum temperature at which cloud liquid water phase
!                       can exist (degrees Kelvin)
!       tk_all_liq    maximum temperature at which cloud ice can exist
!                       (degrees Kelvin)
!       wgt_liq       The ratio of liquid water path to total cloud water path,
!                        i.e., LWP / CWP
!       wgt_ice       The ratio of ice water path to total cloud water path,
!                        i.e., IWP / CWP
!
!       qsat_min      Minimum value of zonal mean saturation water vapor mixing
!                        ratio entering into the variable anomalous absorption
!                        single scattering albedo calculations.
!       qsat_trans    Transition value of zonal mean saturation mixing ratio
!                        between two branches of a piecewise continuous
!                        function entering into the variable anomalous
!                        absorption single scattering albedo calculations.
!       qsat_max      Maximum value of zonal mean saturation water vapor mixing
!                        ratio entering into the variable anomalous absorption
!                        single scattering albedo calculations.
!
!       w0_norm_uv    Normal, constant single scattering albedo in the uv-vis
!                        wavelength band of the radiation spectrum.
!       w0_norm_nir   Normal, constant single scattering albedo in the nir
!                        wavelength band of the radiation spectrum.
!       w0_anom1_nir  Asymptotic minimum value of single scattering albedo
!                        for variable anomalous absorption; also the
!                        low constant value, if L_anom_abs_g is set to TRUE.
!       w0_anom2_nir  Asymptotic maximum value of single scattering albedo
!                        for variable anomalous absorption,usually occurring
!                        at high latitudes.
! 
!       g_norm        Normal, constant asymmetry parameter used in Tony Gordon's
!                        v197 scheme. It is independent of wavelength.                                
!

!      MAX_BAND     maximum number of wave number bands for tau,etc.

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !
!                   
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!  User Interface variables
!  ------------------------

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!  in tony gordon's v197 scheme only:
!
!real,     intent (in),     dimension(:,:)      :: qmix_kx
!real,     intent (in),     dimension(:,:,:)    :: tempcld


!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

real,     intent (out),dimension(:,:,:)     :: em_lw
real,     intent ( in)   ,dimension(:,:,:)  ::                liq_frac
real,     intent ( in)   ,dimension(:,:,:,:)  :: tau                 


! XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
! XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
!  Internal variables
!  ------------------

real, dimension(size(tau   ,1),size(tau   ,2),size(tau   ,3))   :: cwp, lwp, iwp

!  Declare tau_chk to compare with tau, if code needs to be debugged.

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!
! Code
! ----

!  define maximum number of wave number bands for tau
!      max_band = size(tau,4)

!  For tg v197, tau is previously computed in subroutine cloud_optical_depths,
!  while w0 and gg will be reinitialized.
!  Also, internal variables w0_liq, w0_ice, g_liq, and g_ice
!  will be re-initialized, while tau_liq and tau_ice will not be.

!  Therefore, the only output variable to be initialized is em_lw.
!  Comment out the other reinitialization commands.


        em_lw(:,:,:)   = 0.


! compute combined emmisivity
        CWP(:,:,:) = tau(:,:,:,1) / &
                     (k_sw_liq * liq_frac(:,:,:) + &
                      k_sw_ice * (1.0-liq_frac(:,:,:)) )

        LWP(:,:,:) = liq_frac(:,:,:) * CWP(:,:,:)
        IWP(:,:,:) = (1.0-liq_frac(:,:,:)) * CWP(:,:,:)
        em_lw(:,:,:) =  1. - exp( -1. * ( k_lw_liq * LWP(:,:,:) + &
                                          k_lw_ice * IWP(:,:,:) ) )


   !--------------    RANGE LIMIT QUANTITIES --------------------------!



end subroutine CLOUD_OPT_PROP_tg_lw

subroutine CLOUD_OPT_PROP_tg_sw(         liq_frac,       &
                        tau, direct,              &
                                qmix_kx, cosz, cuvrf, cirrf, &
                        cuvab, cirab)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!      This subroutine calculates the following optical properties
!      for each cloud:
!
!               1. tau    :optical depth in each band
!               2. w0     :single scattering albedo for each band
!               3. gg     :asymmetry parameter for each band
!               4. em_lw  :longwave cloud emissivity
!
!   The formulas for optical depth come from Slingo (1989) for liquid
!   clouds and from Ebert and Curry (1992) for ice clouds.
!
!   Slingo (1989) is at J. Atmos. Sci., vol. 46, pp. 1419-1427
!   Ebert and Curry (1992) is at J. Geophys. Res., vol. 97, pp. 3831-3836
!
!                    IMPORTANT!!!
!
!    NOTE WE ARE CHEATING HERE BECAUSE WE ARE FORCING THE FIVE BAND
!    MODEL OF EBERT AND CURRY INTO THE FOUR BAND MODEL OF SLINGO
!
!    THIS IS DONE BY COMBINING BANDS 3 and 4 OF EBERT AND CURRY TOGETHER
!
!   EVEN SO THE EXACT BAND LIMITS DO NOT MATCH.  FOR COMPLETENESS
!   HERE ARE THE BAND LIMITS IN MICRONS
!
!            BAND               SLINGO                 EBERT AND CURRY
!
!             1               0.25-0.69                0.25 - 0.7
!             2               0.69-1.19                0.7 - 1.3
!             3               1.19-2.38                1.3 - 2.5
!             4               2.38-4.00                2.5 - 3.5
!
! *************************    WARNING    *****************************
!
!   The above bands are used by Steve Klein.
!   We retain the scheme from the v197 frozen model,instead.
!   Nominally, our band 2 is expanded into bands 2 + 3 + 4 of Slingo.
!   The same cloud optical depth is specified in all 4 bands.
!   The same asymmetry parameter is specified in all 4 bands.
!   For single scattering albedo w0, the uv value is specified in band 1,
!   while the nir value is specified in bands 2, 3, and 4.

!   ****  WARNING    ****  The code is intended to be applied to 2 to 4 bands.
!   An error check to check that this condition is satisfied is advised.  

! *********************************************************************
!            BAND               v197     
!             1               0.25-0.70
!             2               0.70-4.00
! *********************************************************************
!
!

!
!   The mixed phase optical properties are based upon equation 14
!   of Rockel et al. 1991, Contributions to Atmospheric Physics,
!   volume 64, pp.1-12.   These equations are:
!
!   (1)    tau = tau_liq + tau_ice
!
!   (2)    w0  =   ( w0_liq * tau_liq  +  w0_ice * tau_ice ) /
!                  (          tau_liq  +           tau_ice )
!
!   w0(:,:,1) = 0.99999;  w0(:,:,2) = 0.9942  (in v197 - standard)
!   w0(:,:,1) = 0.99999;  w0(:,:,2) = F(Z.M. mixing ratio at lowest model level)
!                                    (in v197 - anomalous absorption)
!
!   (3)     g  = ( g_liq * w0_liq * tau_liq +  g_ice * w0_ice * tau_ice ) /
!                (         w0_liq * tau_liq +          w0_ice * tau_ice )
!
!           g(:,:,1:2) = 0.85 in v197
!   
!
!   (4) transmivvity_lw =   transmissivity_lw_ice * transmissivity_lw_liq
!
!    The last equation could be rewritten, after algebraic manipulation, as:
!
!   (5)  em_lw =  em_lw_liq + em_lw_ice -  (em_lw_liq * em_lw_ice )
!
!    However, the other form of the equation, i.e., 
!    1 - exp(tau_liq + tau_ice) will actually be solved.

! *******************************************************************
!
!
!   (6)  v197 only: Must first solve for LWP and IWP knowing
!                   tau, k_sw_liq, k_sw_ice, wgt_liq and wgt_ice.
!                   
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!VARIABLES
!
!       ------
!INPUT:
!       ------
!


!      L_anom_abs-g Logical namelist variable. If true, anomalous absorption
!                   is represented by a constant value of single scattering
!                   albedo. The default value and the v197 setting are
!                   both false.
!
!      L_anom_abs_v Logical namelist variable. If true, anomalous absorption
!                   is computed as a piecewise continuous function of zonal
!                   mean saturation water vapor mixing ratio at the model's
!                   vertical level closest to the earth's surface. The
!                   default value is false. The analogous namelist variable
!                   in v197, LWALBV is set to TRUE. 
!                   If both L_anom_abs_g and L_anom_abs_v are set to FALSE,
!                   then the single scattering albedo, w0,  assumes its normal
!                   constant value of 0.9942, in tg's version. w0 is a
!                   variable in Steve Klein's version.
!                   L_anom_abs_v takes precedence over L_anom_abs_g, if
!                   the former is TRUE and the latter is FALSE.
!
!     qmix_kx    Zonal mean saturation water vapor mixing ratio at the
!                   model's vertical level closest to the earth's surface.
!                   It is more convenient to pass the zonal mean, in case
!                   single column tests are performed. Alternatively,
!                   the zonal mean could be computed within this subroutine. 
!
!      tempcld      cloud layer mean temperature (degrees Kelvin), with
!                   compressed cloud layer index.
!
!
!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!       ------------
!INPUT/OUTPUT:
!       ------------
!
!      tau          optical depth in each band
!      w0           single scattering albedo for each band
!      gg           asymmetry parameter for each band
!      em_lw        longwave cloud emissivity

!            NOTE:  In tg's version, LWP and IWP are effective cloud
!                   water paths. They could be computed either in this
!                   subroutine or in subroutine cloud_water_path.

!      LWP          cloud liquid water path (kg of condensate per square meter)
!      IWP          cloud ice path (kg of condensate per square meter)
!
!
!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
!
!
!       -------------------
!INTERNAL VARIABLES:
!       -------------------
!
!       tau_liq      optical depth            at each band for cloud liquid
!       tau_ice      optical depth            at each band for cloud ice
!       w0_liq       single scattering albedo at each band for cloud liquid
!       w0_ice       single scattering albedo at each band for cloud ice
!       g_liq        asymmetry parameter      at each band for cloud liquid
!       g_ice        asymmetry parameter      at each band for cloud ice
!
!
!                   In Tony Gordon's v197 version only.
!
!       CWP           total cloud water path, i.e., cloud liquid plus
!                        cloud ice (kg of condensate per square meter)
!
!                    Parameters (defined above)
!
!       k_lw_liq     liquid cloud mass absorption coefficient for longwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_lw_ice     ice cloud mass absorption coefficient for longwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_sw_liq     liquid cloud mass absorption coefficient for shortwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_sw_ice     ice cloud mass absorption coefficient for shortwave
!                       portion of the spectrum (meters**2./kg of condensate)
!
!       tk_all_ice    minimum temperature at which cloud liquid water phase
!                       can exist (degrees Kelvin)
!       tk_all_liq    maximum temperature at which cloud ice can exist
!                       (degrees Kelvin)
!       wgt_liq       The ratio of liquid water path to total cloud water path,
!                        i.e., LWP / CWP
!       wgt_ice       The ratio of ice water path to total cloud water path,
!                        i.e., IWP / CWP
!
!       qsat_min      Minimum value of zonal mean saturation water vapor mixing
!                        ratio entering into the variable anomalous absorption
!                        single scattering albedo calculations.
!       qsat_trans    Transition value of zonal mean saturation mixing ratio
!                        between two branches of a piecewise continuous
!                        function entering into the variable anomalous
!                        absorption single scattering albedo calculations.
!       qsat_max      Maximum value of zonal mean saturation water vapor mixing
!                        ratio entering into the variable anomalous absorption
!                        single scattering albedo calculations.
!
!       w0_norm_uv    Normal, constant single scattering albedo in the uv-vis
!                        wavelength band of the radiation spectrum.
!       w0_norm_nir   Normal, constant single scattering albedo in the nir
!                        wavelength band of the radiation spectrum.
!       w0_anom1_nir  Asymptotic minimum value of single scattering albedo
!                        for variable anomalous absorption; also the
!                        low constant value, if L_anom_abs_g is set to TRUE.
!       w0_anom2_nir  Asymptotic maximum value of single scattering albedo
!                        for variable anomalous absorption,usually occurring
!                        at high latitudes.
! 
!       g_norm        Normal, constant asymmetry parameter used in Tony Gordon's
!                        v197 scheme. It is independent of wavelength.                                
!

!      MAX_BAND     maximum number of wave number bands for tau,etc.

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !
!                   
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!  User Interface variables
!  ------------------------

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!  in tony gordon's v197 scheme only:
!
real,     intent (in),     dimension(:,:)      :: qmix_kx, cosz
logical,  intent (in),     dimension(:,:,:)    :: direct           


!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

real,     intent (in),dimension(:,:,:,:)   :: tau

real,     intent ( in)   ,dimension(:,:,:)  ::          liq_frac
real,     intent (out),     dimension(:,:,:)    :: cuvrf, cirrf,   &
                                                   cuvab, cirab


! XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
! XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
!  Internal variables
!  ------------------

real, dimension(size(tau,1),size(tau,2),size(tau,3),4) :: tau_liq, tau_ice
real, dimension(size(tau,1),size(tau,2),size(tau,3),4) :: w0_liq, w0_ice
real, dimension(size(tau,1),size(tau,2),size(tau,3),4) :: g_liq, g_ice
real, dimension(size(tau,1),size(tau,2),size(tau,3))   :: w0_anom_work
real, dimension(size(tau,1),size(tau,2),size(tau,3))   :: qmix_kx_work
real, dimension(size(tau,1),size(tau,2),size(tau,3))   :: lwp_new, iwp_new, cwp
integer                                                :: k, kmax
integer                                                :: n, max_band

!  Declare tau_chk to compare with tau, if code needs to be debugged.
real, dimension(size(tau,1),size(tau,2),size(tau,3),4) :: tau_chk
real, dimension(size(tau,1),size(tau,2),size(tau,3),   &
                size(tau,4)) :: w0, gg 

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!
! Code
! ----

!  define maximum number of wave number bands for tau
      max_band = size(tau,4)

!  For tg v197, tau is previously computed in subroutine cloud_optical_depths,
!  while w0 and gg will be reinitialized.
!  Also, internal variables w0_liq, w0_ice, g_liq, and g_ice
!  will be re-initialized, while tau_liq and tau_ice will not be.

!  Therefore, the only output variable to be initialized is em_lw.
!  Comment out the other reinitialization commands.


!  These are Tony Gordon's reinitialized values.
        gg(:,:,:,:)    = 0.85
        w0(:,:,:,1)    = 0.99999
        w0(:,:,:,2:4)  = 0.9942

        w0_liq(:,:,:,1)   = 0.99999
        w0_liq(:,:,:,2:4) = 0.9942
        w0_ice(:,:,:,1)   = 0.99999
        w0_ice(:,:,:,2:4) = 0.9942
        g_liq(:,:,:,:)    = 0.85
        g_ice(:,:,:,:)    = 0.85

! . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

!       Comment out Steve Klein's reinitialized values.
!       tau(:,:,:,:) = 0.
!       gg(:,:,:,:)  = 0.85
!       w0(:,:,:,:)  = 0.95
!       em_lw(:,:,:) = 0.

!       w0_liq(:,:,:,:) = 0.95
!       w0_ice(:,:,:,:) = 0.95
!       tau_liq(:,:,:,:)= 0.
!       tau_ice(:,:,:,:)= 0.



    !---------------   COMPUTE OPTICAL DEPTH ---------------------------!



        ! compute uv cloud optical depths due to liquid
        ! and ice phase separately


                     
        CWP(:,:,:) = tau(:,:,:,1) / &
                     (k_sw_liq * liq_frac(:,:,:) + &
                      k_sw_ice * (1.-liq_frac(:,:,:)) )

        LWP_new(:,:,:) = liq_frac(:,:,:) * CWP(:,:,:)
        IWP_new(:,:,:) = (1.0-liq_frac(:,:,:)) * CWP(:,:,:)

        tau_liq(:,:,:,1)   = k_sw_liq * LWP_new(:,:,:)
        tau_ice(:,:,:,1)   = k_sw_ice * IWP_new(:,:,:)

!  tau_liq and tau_ice are purely diagnostic, since tau is already known.
!  Generalize code to n bands, though it may need to be revised,
!  if max_band changes.

             if (max_band .ge. 2) then
        do n=2,max_band
        tau_liq(:,:,:,n) = tau_liq(:,:,:,1)
        tau_ice(:,:,:,n) = tau_ice(:,:,:,1)
        end do
             endif

! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

!  Compute total cloud optical depth, using same formula as Steve Klein.
!  Note:  Comment out the following command in Tony Gordon's v197 scheme.
!         tau should have the same as the input, except for roundoff error.

!         tau(:,:,:,:)     = tau_liq(:,:,:,:) + tau_ice(:,:,:,:)

!  Define tau_chk to compare with tau, if code needs to be debugged.
          tau_chk(:,:,:,:) = tau_liq(:,:,:,:) + tau_ice(:,:,:,:)

! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -



   !---------------   COMPUTE SINGLE SCATTERING ALBEDO ----------------!


!
        w0_liq(:,:,:,1) =  w0_norm_uv
        w0_ice(:,:,:,1) =  w0_norm_uv

     IF (.not. L_anom_abs_g .and. .not. L_anom_abs_v) THEN

!       Specify tg's normal single scattering albedos for NIR bands.

!  Generalize code to n bands, though it may need to be revised,
!  if max_band changes

             if (max_band .ge. 2) then
        do n=2,max_band
        w0_liq(:,:,:,n) =  w0_norm_nir
        w0_ice(:,:,:,n) =  w0_norm_nir
        end do
             endif

     ENDIF

     IF (L_anom_abs_g) THEN

!  Generalize code to n bands, though it may need to be revised,
!  if max_band changes

             if (max_band .ge. 2) then
        do n=2,max_band
        w0_liq(:,:,:,n) =  w0_anom1_nir
        w0_ice(:,:,:,n) =  w0_anom1_nir
        end do
             endif

     ENDIF

!
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!
!    Broadcast qmix_kx to generate WHERE statements with correct syntax.

     kmax = SIZE(tau,3)

     DO k = 1,kmax
        qmix_kx_work(:,:,k) = qmix_kx(:,:)
     END DO
!
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!
! 
     IF (L_anom_abs_v) THEN

       WHERE (qmix_kx_work(:,:,:) .le. qsat_min)

!      Apply lower asymptotic limit to anomalously weak cloud absorption,
!      i.e., upper asymptotic limit of w0.

!      This situation should not occur for saturation mixing ratios. However,
!      negative mixing ratios are possible in the spectral AGCM,
!      especially in cold temperature, e.g., high latitude regions.
!      Retain this WHERE loop, in case parameterization is ever changed 
!      from saturation mixing ratio to mixing ratio.
      
              w0_anom_work(:,:,:) = w0_anom2_nir

       END WHERE 

       WHERE (qmix_kx_work(:,:,:) .gt. qsat_min .and.                  &
              qmix_kx_work(:,:,:) .lt. qsat_trans)

!      Anomalously weak cloud absorption relative to the reference value 
!      w0_norm_nir will tend to occur at higher latitudes for these values
!      of w0.

            w0_anom_work(:,:,:) = w0_anom2_nir -                    &
               (w0_anom2_nir - w0_norm_nir)    *                    &
               ( (qmix_kx_work(:,:,:) - qsat_min) / (qsat_trans - qsat_min))

       END WHERE

       WHERE (qmix_kx_work(:,:,:) .eq. qsat_trans)

!      The reference value of nir single scattering albedo will be used.

           w0_anom_work(:,:,:) = w0_norm_nir

       END WHERE

       WHERE (qmix_kx_work(:,:,:) .gt. qsat_trans .and.                &
              qmix_kx_work(:,:,:) .lt. qsat_max)

!      Anomalously high absorption relative to the reference value w0_norm_nir
!      will tend to occur at tropical and subtropical latitudes for 
!      these values of w0.

           w0_anom_work(:,:,:) = w0_norm_nir  -                    &
              (w0_norm_nir - w0_anom1_nir)    *                    &
              ( (qmix_kx_work(:,:,:) - qsat_trans) / (qsat_max - qsat_trans))

       END WHERE

       WHERE (qmix_kx_work(:,:,:) .ge. qsat_max)

!      Apply upper asymptotic limit to the anomalous absorption, i.e.,
!      lower asymptotic limit of w0.

              w0_anom_work = w0_anom1_nir

       END WHERE

!  Generalize code to n bands, though it may need to be revised,
!  if max_band changes

             if (max_band .ge. 2) then
        do n=2,max_band
       w0_liq(:,:,:,n) = w0_anom_work(:,:,:)
       w0_ice(:,:,:,n) = w0_anom_work(:,:,:)
        end do
             endif

     ENDIF



! compute total single scattering albedo
        WHERE (tau(:,:,:,:) .gt. 0.)
               w0(:,:,:,:) = ( w0_liq(:,:,:,:) * tau_liq(:,:,:,:) + &
                               w0_ice(:,:,:,:) * tau_ice(:,:,:,:) ) / &
                             tau(:,:,:,:)
        END WHERE

   !---------------   COMPUTE ASYMMETRY PARAMETER --------------------!

        WHERE (tau(:,:,:,:) .gt. 0. )
              gg(:,:,:,:) = ( &
                 w0_liq(:,:,:,:) * g_liq(:,:,:,:) * tau_liq(:,:,:,:) + &
                 w0_ice(:,:,:,:) * g_ice(:,:,:,:) * tau_ice(:,:,:,:) ) &
                       /          (w0_liq(:,:,:,:) * tau_liq(:,:,:,:) + &
                                   w0_ice(:,:,:,:) * tau_ice(:,:,:,:) )
        END WHERE



       call cloud_rad_k_diag(tau, direct, w0,gg,cosz,cuvrf,cirrf,cuvab,cirab )

end subroutine CLOUD_OPT_PROP_tg_sw




subroutine CLOUD_OPT_PROP_tg2 (tau, tempcld,           liq_frac)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!
!      tempcld      cloud layer mean temperature (degrees Kelvin), with
!                   compressed cloud layer index.
!
!
!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!       ------------
!INPUT/OUTPUT:
!       ------------
!
!      tau          optical depth in each band

!            NOTE:  In tg's version, LWP and IWP are effective cloud
!                   water paths. They could be computed either in this
!                   subroutine or in subroutine cloud_water_path.

!      LWP          cloud liquid water path (kg of condensate per square meter)
!      IWP          cloud ice path (kg of condensate per square meter)
!
!
!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
!
!
!       -------------------
!INTERNAL VARIABLES:
!       -------------------
!
!       tau_liq      optical depth            at each band for cloud liquid
!       tau_ice      optical depth            at each band for cloud ice
!
!
!                   In Tony Gordon's v197 version only.
!
!       CWP           total cloud water path, i.e., cloud liquid plus
!                        cloud ice (kg of condensate per square meter)
!
!                    Parameters (defined above)
!
!       k_lw_liq     liquid cloud mass absorption coefficient for longwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_lw_ice     ice cloud mass absorption coefficient for longwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_sw_liq     liquid cloud mass absorption coefficient for shortwave
!                       portion of the spectrum (meters**2./kg of condensate)
!       k_sw_ice     ice cloud mass absorption coefficient for shortwave
!                       portion of the spectrum (meters**2./kg of condensate)
!
!       tk_all_ice    minimum temperature at which cloud liquid water phase
!                       can exist (degrees Kelvin)
!       tk_all_liq    maximum temperature at which cloud ice can exist
!                       (degrees Kelvin)
!       wgt_liq       The ratio of liquid water path to total cloud water path,
!                        i.e., LWP / CWP
!       wgt_ice       The ratio of ice water path to total cloud water path,
!                        i.e., IWP / CWP
!
!

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !
!                   
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!  User Interface variables
!  ------------------------

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

real,     intent (in   ),dimension(:,:,:,:)   :: tau
real,     intent (in),     dimension(:,:,:)    :: tempcld


!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !


real,     intent (out)   ,dimension(:,:,:)  ::          liq_frac


! XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
! XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
!  Internal variables
!  ------------------

real, dimension(size(tau,1),size(tau,2),size(tau,3))   :: wgt_ice, wgt_liq
real, dimension(size(tau,1),size(tau,2),size(tau,3))   :: cwp, lwp, iwp

!  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

!



    !---------------   COMPUTE OPTICAL DEPTH ---------------------------!



        ! compute uv cloud optical depths due to liquid
        ! and ice phase separately


!       by Tony Gordon's v197 scheme

        WHERE (tempcld(:,:,:) .le. tk_all_ice)
               wgt_liq(:,:,:) = 0.
               wgt_ice(:,:,:) = 1.
        END WHERE

        WHERE (tempcld(:,:,:) .ge. tk_all_liq)
               wgt_liq(:,:,:) = 1.
               wgt_ice(:,:,:) = 0.
        END WHERE

        WHERE (tempcld(:,:,:) .gt. tk_all_ice .and. tempcld(:,:,:) &
               .lt. tk_all_liq)
               wgt_liq(:,:,:) = (tempcld(:,:,:) - tk_all_ice) / &
                                (tk_all_liq - tk_all_ice)
               wgt_ice(:,:,:) = 1. - wgt_liq(:,:,:)
        END WHERE
                     
        CWP(:,:,:) = tau(:,:,:,1) / &
                     (k_sw_liq * wgt_liq(:,:,:) + &
                      k_sw_ice * wgt_ice(:,:,:) )

        LWP(:,:,:) = wgt_liq(:,:,:) * CWP(:,:,:)
        IWP(:,:,:) = wgt_ice(:,:,:) * CWP(:,:,:)
liq_frac = wgt_liq



end subroutine CLOUD_OPT_PROP_tg2


!#######################################################################

  SUBROUTINE DIAG_CLOUD_RAD_INIT(do_crad_init)

!=======================================================================
! ***** INITIALIZE Predicted Cloud Scheme
!=======================================================================

!---------------------------------------------------------------------
! Argument (Intent inout)
!  do_crad_init - logical switch to be set = .true. after init is done
!---------------------------------------------------------------------
 logical, intent(inout) :: do_crad_init

!---------------------------------------------------------------------
!  (Intent local)
!---------------------------------------------------------------------
 integer             :: unit, io, logunit, ierr

!=====================================================================

!---------------------------------------------------------------------
! --- Read namelist
!---------------------------------------------------------------------

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=diag_cloud_rad_nml, iostat=io)
  ierr = check_nml_error(io,"diag_cloud_rad_nml")
#else
  if( FILE_EXIST( 'input.nml' ) ) then
! -------------------------------------
         unit = open_namelist_file ()
   io = 1
   do while( io .ne. 0 )
      READ ( unit,  nml = diag_cloud_rad_nml, iostat = io, end = 10 ) 
      ierr = check_nml_error(io,'diag_cloud_rad_nml')
   end do
10 continue
   call close_file (unit)
! -------------------------------------
  end if
#endif

!   **** call cloud_rad_init to read namelist containing L2STREM  ****
       call cloud_rad_init()

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
           logunit = stdlog()
           write (logunit, nml=diag_cloud_rad_nml)
      endif

!-------------------------------------------------------------------
  do_crad_init = .true.
  module_is_initialized = .true.
END SUBROUTINE DIAG_CLOUD_RAD_INIT

SUBROUTINE DIAG_CLOUD_RAD_END

  module_is_initialized = .false.

END SUBROUTINE DIAG_CLOUD_RAD_END


end MODULE DIAG_CLOUD_RAD_MOD

MODULE diag_table_mod
  ! <CONTACT EMAIL="seth.underwood@noaa.gov">
  !   Seth Underwood
  ! </CONTACT>
  ! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/" />
  ! <OVERVIEW>
  !   <TT>diag_table_mod</TT> is a set of subroutines use to parse out the data from a <TT>diag_table</TT>.  This module
  !   will also setup the arrays required to store the information by counting the number of input fields, output files, and
  !   files.
  ! </OVERVIEW>
  ! <DESCRIPTION>
  !   <TT>diag_table_mod</TT> parses the <TT>diag_table</TT> file, and sets up the required arrays to hold the information
  !   needed for the <TT>diag_manager_mod</TT> to correctly write out the model history files.
  !
  !   The <I>diagnostics table</I> allows users to specify sampling rates and the choice of fields at run time.  The
  !   <TT>diag_table</TT> file consists of comma-separated ASCII values.  The <TT>diag_table</TT> essentially has three sections:
  !   <B>Global</B>, <B>File</B>, and <B>Field</B> sections.  The <B>Global</B> section must be the first two lines of the file,
  !   whereas the <B>File</B> and <B>Field</B> sections can be inter mixed to allow the file to be organized as desired.
  !   Comments can be added to the <TT>diag_table</TT> file by using the hash symbol (#) as the first character in the line.
  !
  !   All errors in the <TT>diag_table</TT> will throw a <TT>FATAL</TT> error.  A simple utility <TT>diag_table_chk</TT>has been
  !   added to the FRE tools suite to check a <TT>diag_table</TT> for errors.  A brief usage statement can be obtained by running
  !   <TT>diag_table_chk --help</TT>, and a man page like description can views by running <TT>perldoc diag_table_chk</TT>.
  !
  !   Below is a description of the three sections.
  !   <OL>
  !     <LI>
  !       <B>Global Section:</B>  The first two lines of the <TT>diag_table</TT> must contain the <I>title</I> and the <I>base
  !       date</I> of the experiment respectively.  The <I>title</I> must be a Fortran CHARACTER string.  The <I>base date</I>
  !       is the reference time used for the time units, and must be greater than or equal to the model start time.
  !       The <I>base date</I> consists of six space-separated integer in the following format.<BR />
  !       <TT><NOBR>year month day hour minute second</NOBR></TT><BR />
  !     </LI>
  !     <LI>
  !       <B>File Section:</B> File lines contain 6 required and 5 optional fields (optional fields are surrounded with
  !       square brackets ([]).  File lines can be intermixed with the field lines, but the file must be defined before any
  !       fields that are to be written to the file.  File lines have the following format:<BR />
  !       <PRELN>
  !         "file_name", output_freq, "output_freq_units", file_format, "time_axis_units", "time_axis_name"
  !         [, new_file_freq, "new_file_freq_units"[, "start_time"[, file_duration, "file_duration_units"]]]
  !       </PRELN>
  !       <BR />
  !       with the following descriptions.
  !       <DL>
  !         <DT><TT>CHARACTER(len=128) :: file_name</TT></DT>
  !         <DD>
  !           Output file name without the trailing "<TT>.nc</TT>".
  !
  !           A single file description can produce multiple files using special time string suffix keywords.  This time string
  !           will append the time strings to the base file name each time a new file is opened.  They syntax for the time string
  !           suffix keywords are <TT>%#tt</TT> Where <TT>#</TT> is a mandatory single digit number specifying the width of the
  !           field, and <TT>tt</TT> can be as follows:
  !           <NL>
  !             <LI><TT>yr</TT> <EN /> Years</LI>
  !             <LI><TT>mo</TT> <EN /> Months</LI>
  !             <LI><TT>dy</TT> <EN /> Days</LI>
  !             <LI><TT>hr</TT> <EN /> Hours</LI>
  !             <LI><TT>mi</TT> <EN /> Minutes</LI>
  !             <LI><TT>sc</TT> <EN /> Seconds</LI>
  !           </NL>
  !           Thus, a file name of <TT>file2_yr_dy%1yr%3dy</TT> will have a base file name of <TT>file2_yr_dy_1_001</TT> if the
  !           file is created on year 1 day 1 of the model run.  <B><I>NOTE:</I></B> The time suffix keywords must be used if the
  !           optional fields <TT>new_file_freq</TT> and <TT>new_file_freq_units</TT> are used, otherwise a <TT>FATAL</TT> error
  !           will occur.
  !         </DD>
  !
  !         <DT><TT>INTEGER :: output_freq</TT></DT>
  !         <DD>How often to write fields to file.
  !           <NL>
  !             <LI><TT>> 0</TT> <EN /> Output frequency in <TT>output_freq_units</TT>.</LI>
  !             <LI><TT>= 0</TT> <EN /> Output frequency every time set. (<TT>output_freq_units</TT> is ignored.)</LI>
  !             <LI><TT>=-1</TT> <EN /> Output at end of run only. (<TT>output_freq_units</TT> is ignored.)</LI>
  !           </NL>
  !         </DD>
  !         <DT><TT>CHARACTER(len=10) :: output_freq_units</TT></DT>
  !         <DD>
  !           Time units for output.  Can be either <TT>years</TT>, <TT>months</TT>, <TT>days</TT>, <TT>minutes</TT>,
  !           <TT>hours</TT>, or <TT>seconds</TT>.
  !         </DD>
  !         <DT><TT>INTEGER :: file_format</TT></DT>
  !         <DD>
  !           Output file format.  Currently only the <I>netCDF</I> file format is supported.
  !           <NL>
  !             <LI><TT>= 1</TT> <EN /> netCDF</LI>
  !           </NL>
  !         </DD>
  !         <DT><TT>CHARACTER(len=10) :: time_axis_units</TT></DT>
  !         <DD>
  !           Time units for the output file time axis.  Can be either <TT>years</TT>, <TT>months</TT>, <TT>days</TT>,
  !           <TT>minutes</TT>, <TT>hours</TT>, or <TT>seconds</TT>.
  !         </DD>
  !         <DT><TT>CHARACTER(len=128) :: time_axis_name</TT></DT>
  !         <DD>
  !           Axis name for the output file time axis.  The character sting must contain the string 'time'. (mixed upper and
  !           lowercase allowed.)
  !         </DD>
  !         <DT><TT>INTEGER, OPTIONAL :: new_file_freq</TT></DT>
  !         <DD>
  !           Frequency for closing the existing file, and creating a new file in <TT>new_file_freq_units</TT>.
  !         </DD>
  !         <DT><TT>CHARACTER(len=10), OPTIONAL :: new_file_freq_units</TT></DT>
  !         <DD>
  !           Time units for creating a new file.  Can be either <TT>years</TT>, <TT>months</TT>, <TT>days</TT>,
  !           <TT>minutes</TT>, <TT>hours</TT>, or <TT>seconds</TT>.  <B><I>NOTE:</I></B> If the <TT>new_file_freq</TT> field is
  !           present, then this field must also be present.
  !         </DD>
  !         <DT><TT>CHARACTER(len=25), OPTIONAL :: start_time</TT></DT>
  !         <DD>
  !           Time to start the file for the first time.  The format of this string is the same as the <I>global date</I>.  <B><I>
  !           NOTE:</I></B> The <TT>new_file_freq</TT> and the <TT>new_file_freq_units</TT> fields must be present to use this field.
  !         </DD>
  !         <DT><TT>INTEGER, OPTIONAL :: file_duration</TT></DT>
  !         <DD>
  !           How long file should receive data after start time in <TT>file_duration_units</TT>.  This optional field can only
  !           be used if the <TT>start_time</TT> field is present.  If this field is absent, then the file duration will be equal
  !           to the frequency for creating new files.  <B><I>NOTE:</I></B> The <TT>file_duration_units</TT> field must also be
  !           present if this field is present.
  !         </DD>
  !         <DT><TT>CHARACTER(len=10), OPTIONAL :: file_duration_units</TT></DT>
  !         <DD>
  !           File duration units. Can be either <TT>years</TT>, <TT>months</TT>, <TT>days</TT>,
  !           <TT>minutes</TT>, <TT>hours</TT>, or <TT>seconds</TT>.  <B><I>NOTE:</I></B> If the <TT>file_duration</TT> field is
  !           present, then this field must also be present.
  !         </DD>
  !       </DL>
  !     </LI>
  !     <LI>
  !       <B>Field Section:</B> Field lines contain 8 fields.  Field lines can be intermixed with file lines.  Fields line can contain
  !       fields that are not written to any files.  The file name for these fields is <TT>null</TT>.
  !
  !       Field lines have the following format:<BR />
  !       <PRE>
  ! "module_name", "field_name", "output_name", "file_name", "time_sampling", "reduction_method", "regional_section", packing
  !       </PRE>
  !       with the following descriptions.
  !       <DL>
  !         <DT><TT>CHARACTER(len=128) :: module_name</TT></DT>
  !         <DD>Module that contains the <TT>field_name</TT> variable.  (e.g. <TT>atmos_mod</TT>, <TT>land_mod</TT>)</DD>
  !         <DT><TT>CHARACTER(len=128) :: field_name</TT></DT>
  !         <DD>Module variable name that has data to be written to file.</DD>
  !         <DT><TT>CHARACTER(len=128) :: output_name</TT></DT>
  !         <DD>Name of the field as written in <TT>file_name</TT>.</DD>
  !         <DT><TT>CHARACTER(len=128) :: file_name</TT></DT>
  !         <DD>
  !           Name of the file where the field is to be written. <B><I>NOTE:</I></B> The file <TT>file_name</TT> must be
  !           defined first.
  !         </DD>
  !         <DT><TT>CHARACTER(len=50) :: time_sampling</TT></DT>
  !         <DD>Currently not used.  Please use the string "all".</DD>
  !         <DT><TT>CHARACTER(len=50) :: reduction_method</TT></DT>
  !         <DD>
  !           The data reduction method to perform prior to writing data to disk.  Valid options are (redundant names are
  !           separated with commas):
  !           <DL>
  !             <DT><TT>.TRUE.</TT>, average</DT>
  !             <DD>Average from the last time written to the current time.</DD>
  !             <DT><TT>.FALSE.</TT>, none</DT>
  !             <DD>No reduction performed.  Write current time step value only.</DD>
  !             <DT>rms</DT> <DD>Calculate the root mean square from the last time written to the current time.</DD>
  !             <DT>pow##</DT> <DD>Calculate the mean of the power ## from the last time written to the current time.</DD>
  !             <DT>min</DT> <DD>Minimum value from last write to current time.</DD>
  !             <DT>max</DT> <DD>Maximum value from last write to current time.</DD>
  !             <DT>diurnal##</DT> <DD>## diurnal averages</DD>
  !           </DL>
  !         </DD>
  !         <DT><TT>CHARACTER(len=50) :: regional_section</TT></DT>
  !         <DD>
  !           Bounds of the regional section to capture.  A value of <TT>none</TT> indicates a global region.  The regional
  !           section has the following format:<BR />
  !           <TT>lat_min, lat_max, lon_min, lon_max, vert_min, vert_max</TT><BR />
  !           Use <TT>vert_min = -1</TT> and <TT>vert_max = -1</TT> to get the entire vertical axis.  <B><I>NOTE:</I></B>
  !           Currently, the defined region <I>MUST</I> be confined to a single tile.
  !         </DD>
  !         <DT><TT>INTEGER :: packing</TT></DT>
  !         <DD>
  !           Fortran number <TT>KIND</TT> of the data written.  Valid values:
  !           <NL>
  !             <LI><TT>= 1</TT> <EN /> double precision</LI>
  !             <LI><TT>= 2</TT> <EN /> float</LI>
  !             <LI><TT>= 4</TT> <EN /> packed 16-bit integers</LI>
  !             <LI><TT>= 8</TT> <EN /> packed 1-byte (not tested).</LI>
  !           </NL>
  !         </DD>
  !       </DL>
  !     </LI>
  !   </OL>
  !
  !   <H4><B>Sample <TT>diag_table</TT></B></H4>
  !   <NL>
  !     <LI>
  !       <PRE>
  ! "diag manager test"
  ! 1999 1 1 0 0 0
  !
  ! #output files
  ! 10_days,               10, "days", 1, "hours", "Time"
  ! "file1_hr%hr3",         5, "days", 1, "hours", "Time", 15, "days"
  ! "file2_yr_dy%yr1%dy3",  5, "days", 1, "hours", "Time", 10, "days", "1 1 7 0 0 0"
  ! "file3_yr_dy%yr1%dy3",  5, "days", 1, "hours", "Time", 20, "days", "1 1 7 0 0 0", 5, "years"
  !
  ! #output variables
  ! "ice_mod", "ice", "ice", "10_days", "all", .false., "none", 2
  !
  ! # temp_local file and fields.
  ! temp_local, 1, "days", 1, "hours", "Time"
  ! "ocean_mod", "temp", "temp", "temp_local", "all", .FALSE., "5 259.5 -59.5 59.5 1 1", 2
  !       </PRE>
  !     </LI>
  !   </NL>
  !
  !   <H4>Useful Additional Utility</H4>
  !   A simple utility has been created to help discover
  ! </DESCRIPTION>
  USE mpp_io_mod, ONLY: mpp_open, MPP_RDONLY
  USE mpp_mod, ONLY: read_ascii_file, get_ascii_file_num_lines
  USE fms_mod, ONLY: fms_error_handler, error_mesg, file_exist, stdlog, mpp_pe, mpp_root_pe, FATAL, WARNING, lowercase, close_file
  USE time_manager_mod, ONLY: get_calendar_type, NO_CALENDAR, set_date, set_time, month_name, time_type
  USE constants_mod, ONLY: SECONDS_PER_HOUR, SECONDS_PER_MINUTE

  USE diag_data_mod, ONLY: global_descriptor, base_time, base_year, base_month, base_day, base_hour, base_minute, base_second,&
       & DIAG_OTHER, DIAG_OCEAN, DIAG_ALL, coord_type, append_pelist_name, pelist_name
  USE diag_util_mod, ONLY: init_file, check_duplicate_output_fields, init_input_field, init_output_field

  IMPLICIT NONE

  PRIVATE
  PUBLIC :: parse_diag_table

  TYPE field_description_type
     CHARACTER(len=128) :: module_name, field_name, output_name, file_name
     CHARACTER(len=50) :: time_sampling
     CHARACTER(len=50) :: time_method
     CHARACTER(len=50) :: spatial_ops
     TYPE(coord_type) :: regional_coords
     INTEGER :: pack
  END TYPE field_description_type

  TYPE file_description_type
     INTEGER :: output_freq
     INTEGER :: file_format
     INTEGER :: new_file_freq
     INTEGER :: file_duration
     INTEGER :: iTime_units
     INTEGER :: iOutput_freq_units
     INTEGER :: iNew_file_freq_units
     INTEGER :: iFile_duration_units
     CHARACTER(len=128) :: file_name
     CHARACTER(len=10) :: output_freq_units
     CHARACTER(len=10) :: time_units
     CHARACTER(len=128) :: long_name
     CHARACTER(len=10) :: new_file_freq_units
     CHARACTER(len=25) :: start_time_s
     CHARACTER(len=10) :: file_duration_units
     TYPE(time_type) :: start_time
  END TYPE file_description_type

  CHARACTER(len=*), PARAMETER :: UNALLOWED_QTE = "'"//'"'
  CHARACTER(len=*), PARAMETER :: UNALLOWED_ALL = UNALLOWED_QTE//","

CONTAINS

  ! <SUBROUTINE NAME="parse_diag_table">
  !   <OVERVIEW>
  !     Parse the <TT>diag_table</TT> in preparation for diagnostic output.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE parse_diag_table(diag_subset, istat, err_msg)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     <TT>parse_diag_table</TT> is the public interface to parse the diag_table, and setup the arrays needed to store the
  !     requested diagnostics from the <TT>diag_table</TT>.  <TT>parse_diag_table</TT> will return a non-zero <TT>istat</TT> if
  !     a problem parsing the <TT>diag_table</TT>.
  !
  !     NOT YET IMPLEMENTED: <TT>parse_diag_table</TT> will parse through the <TT>diag_table</TT> twice.  The first pass, will be
  !     to get a good "guess" of array sizes.  These arrays, that will hold the requested diagnostic fields and files, will then be
  !     allocated to the size of the "guess" plus a slight increase.
  !   </DESCRIPTION>
  !   <IN NAME="diag_subset" TYPE="INTEGER, OPTIONAL">
  !     Diagnostic sampling subset.
  !   </IN>
  !   <OUT NAME="iunit" TYPE="INTEGER, OPTIONAL">
  !     Status of parsing the <TT>diag_table</TT>.  A non-zero status indicates a problem parsing the table.
  !   </OUT>
  !   <OUT NAME="err_msg" TYPE="CHARACTER(len=*), OPTIONAL">
  !     Error message corresponding to the <TT>istat</TT> return value.
  !   </OUT>
  !   <ERROR STATUS="FATAL">
  !     diag_table file does not exist.
  !   </ERROR>
  !   <ERROR STATUS="FATAL">
  !     Error reading the global descriptor from the diagnostic table.
  !   </ERROR>
  !   <ERROR STATUS="FATAL">
  !     Error reading the base date from the diagnostic table.
  !   </ERROR>
  !   <ERROR STATUS="FATAL">
  !     The base_year/month/day can not equal zero
  !   </ERROR>
  !   <ERROR STATUS="WARNING">
  !     Problem reading diag_table, line numbers in errors may be incorrect.
  !   </ERROR>
  !   <ERROR STATUS="FATAL">
  !     Problem reading the diag_table (line: <line_number>)
  !   </ERROR>
  !   <ERROR STATUS="FATAL">
  !     Incorrect file description FORMAT in diag_table. (line: <line_number>)
  !   </ERROR>
  !   <ERROR STATUS="FATAL">
  !     Invalid file FORMAT for file description in the diag_table. (line: <line_number>)
  !   </ERROR>
  !   <ERROR STATUS="FATAL">
  !     Invalid time axis units in diag_table. (line: <line_number>)
  !   </ERROR>
  !   <ERROR STATUS="FATAL">
  !     Invalid output frequency units in diag_table. (line: <line_number>)
  !   </ERROR>
  !   <ERROR STATUS="FATAL">
  !     Invalid NEW file frequency units in diag_table. (line: <line_number>)
  !   </ERROR>
  !   <ERROR STATUS="FATAL">
  !     Invalid file duration units in diag_table. (line: <line_number>)
  !   </ERROR>
  !   <ERROR STATUS="FATAL">
  !     Invalid start time in the file description in diag_table. (line: <line_number>)
  !   </ERROR>
  !   <ERROR STATUS="FATAL">
  !     Field description FORMAT is incorrect in diag_table. (line: <line_number>)
  !   </ERROR>
  !   <ERROR STATUS="FATAL">
  !     Packing is out of range for the field description in diag_table. (line: <line_number>)
  !   </ERROR>
  !   <ERROR STATUS="FATAL">
  !     Error in regional output description for field description in diag_table. (line: <line_number>)
  !   </ERROR>
  SUBROUTINE parse_diag_table(diag_subset, istat, err_msg)
    INTEGER, INTENT(in), OPTIONAL :: diag_subset
    INTEGER, INTENT(out), OPTIONAL, TARGET :: istat
    CHARACTER(len=*), INTENT(out), OPTIONAL :: err_msg

    INTEGER, PARAMETER :: DT_LINE_LENGTH = 256

    INTEGER :: stdlog_unit !< Fortran file unit number for the stdlog file.
    INTEGER :: record_len !< String length of the diag_table line read in.
    INTEGER :: num_lines !< Number of lines in diag_table
    INTEGER :: line_num !< Integer representation of the line number.
    INTEGER :: commentStart !< Index location of first '#' on line
    INTEGER :: diag_subset_output !< local value of diag_subset
    INTEGER :: nfields, nfiles !< Number of fields and files.  Not used yet.
    INTEGER :: npass !< number of passes done while parsing the diag_table (1 for files, 2 for fields)
    INTEGER, TARGET :: mystat !< variable to hold return status of function/subroutine calls.
    INTEGER, POINTER :: pstat !< pointer that points to istat if preset, otherwise, points to mystat.

    CHARACTER(len=5) :: line_number !< String representation of the line number.
    CHARACTER(len=9) :: amonth !< Month name
    CHARACTER(len=256) :: record_line !< Current line from the diag_table.
    CHARACTER(len=256) :: local_err_msg !< Sting to hold local error messages.
    CHARACTER(len=DT_LINE_LENGTH), DIMENSION(:), ALLOCATABLE :: diag_table

    TYPE(file_description_type) :: temp_file
    TYPE(field_description_type) :: temp_field

    ! set up the pstat pointer
    IF ( PRESENT(istat) ) THEN
       pstat => istat
    ELSE
       pstat => mystat
    END IF
    ! Default return value (success)
    pstat = 0

    IF ( PRESENT(diag_subset) ) THEN
       diag_subset_output = diag_subset
    ELSE
       diag_subset_output = DIAG_ALL
    END IF

    ! get the stdlog unit number
    stdlog_unit = stdlog()
    num_lines = get_ascii_file_num_lines('diag_table', DT_LINE_LENGTH)
    allocate(diag_table(num_lines))

    call read_ascii_file('diag_table', DT_LINE_LENGTH, diag_table)

    ! Read in the global file labeling string
    READ (UNIT=diag_table(1), FMT=*, IOSTAT=mystat) global_descriptor
    IF ( mystat /= 0 ) THEN
       pstat = mystat
       IF ( fms_error_handler('diag_table_mod::parse_diag_table', 'Error reading the global descriptor from the diagnostic table.',&
            & err_msg) ) RETURN
    END IF

    ! Read in the base date
    READ (UNIT=diag_table(2), FMT=*, IOSTAT=mystat) base_year, base_month, base_day, base_hour, base_minute, base_second
    IF ( mystat /= 0 ) THEN
       pstat = mystat
       IF ( fms_error_handler('diag_manager_init', 'Error reading the base date from the diagnostic table.', err_msg) ) RETURN
    END IF

    ! Set up the time type for base time
    IF ( get_calendar_type() /= NO_CALENDAR ) THEN
       IF ( base_year==0 .OR. base_month==0 .OR. base_day==0 ) THEN
          pstat = 101
          IF ( fms_error_handler('diag_table_mod::parse_diag_table', 'The base_year/month/day can not equal zero', err_msg) ) RETURN
       END IF
       base_time = set_date(base_year, base_month, base_day, base_hour, base_minute, base_second)
       amonth = month_name(base_month)
    ELSE
       ! No calendar - ignore year and month
       base_time = set_time(NINT(base_hour*SECONDS_PER_HOUR)+NINT(base_minute*SECONDS_PER_MINUTE)+base_second, base_day)
       base_year = 0
       base_month = 0
       amonth = 'day'
    END IF

    IF ( mpp_pe() == mpp_root_pe() ) THEN
       WRITE (stdlog_unit,'("base date used = ",I4,1X,A,2I3,2(":",I2.2)," gmt")') base_year, TRIM(amonth), base_day, &
            & base_hour, base_minute, base_second
    END IF

    nfiles=0
    nfields=0
    pass: DO npass = 1, 2
       parser: DO line_num=3, num_lines
          ! Read in the entire line from the file.
          ! If there is a read error, give a warning, and
          ! cycle the parser loop.
          READ (diag_table(line_num), FMT='(A)', IOSTAT=mystat) record_line
          ! Increase line counter, and put in string for use in warning/error messages.
          WRITE (line_number, '(I5)') line_num

          IF ( mystat > 0 ) THEN
             IF ( mpp_pe() == mpp_root_pe() ) &
                  & CALL error_mesg("diag_table_mod::parse_diag_table",&
                  & "Problem reading the diag_table (line:" //line_number//").", FATAL)
             CYCLE parser
          ELSE IF ( mystat < 0 ) THEN
             EXIT parser
          END IF

          ! How long is the read in string?
          record_len = LEN_TRIM(record_line)

          ! ignore blank lines and  lines with comments only (comment marker '#')
          commentStart = INDEX(record_line,'#')
          IF ( commentStart .NE. 0 ) record_line = record_line(1:commentStart-1)
          IF ( LEN_TRIM(record_line) == 0 .OR. record_len == 0 ) CYCLE parser

          init: IF ( npass == 1 ) THEN ! Checking for files only
             IF ( is_a_file(TRIM(record_line)) ) THEN
                temp_file = parse_file_line(LINE=record_line, ISTAT=mystat, ERR_MSG=local_err_msg)

                IF ( mystat > 0 ) THEN
                   CALL error_mesg("diag_table_mod::parse_diag_table",&
                        & TRIM(local_err_msg)//" (line:" //TRIM(line_number)//").", FATAL)
                ELSE IF ( mystat < 0 ) THEN
                   IF ( mpp_pe() == mpp_root_pe() )&
                        & CALL error_mesg("diag_table_mod::parse_diag_table",&
                        & TRIM(local_err_msg)//" (line: "//TRIM(line_number)//").", WARNING)
                   CYCLE parser
                ELSE IF ( (diag_subset_output == DIAG_OTHER .AND. VERIFY('ocean', lowercase(temp_file%file_name)) == 0).OR.&
                     &    (diag_subset_output == DIAG_OCEAN .AND. VERIFY('ocean', lowercase(temp_file%file_name)) /= 0) ) THEN
                   CYCLE parser
                ELSE IF ( temp_file%new_file_freq > 0 ) THEN ! Call the init_file subroutine.  The '1' is for the tile_count
                   CALL init_file(temp_file%file_name, temp_file%output_freq, temp_file%iOutput_freq_units, temp_file%file_format,&
                        & temp_file%iTime_units, temp_file%long_name, 1, temp_file%new_file_freq, temp_file%iNew_file_freq_units,&
                        & temp_file%start_time, temp_file%file_duration, temp_file%iFile_duration_units)
                ELSE
                   CALL init_file(temp_file%file_name, temp_file%output_freq, temp_file%iOutput_freq_units, temp_file%file_format,&
                        & temp_file%iTime_units, temp_file%long_name, 1)
                END IF

                ! Increment number of files
                nfiles = nfiles + 1
             END IF
          ELSE ! Looking for fields
             IF ( .NOT.is_a_file(TRIM(record_line)) ) THEN
                temp_field = parse_field_line(LINE=record_line, ISTAT=mystat, ERR_MSG=local_err_msg)

                ! Check for errors, then initialize the input and output field
                IF (  mystat > 0 ) THEN
                   CALL error_mesg("diag_table_mod::parse_diag_table",&
                        & TRIM(local_err_msg)//" (line: "//TRIM(line_number)//").",FATAL)
                ELSE IF ( mystat < 0 ) THEN
                   IF ( mpp_pe() == mpp_root_pe() )&
                        & CALL error_mesg("diag_table_mod::Parse_diag_table",&
                        & TRIM(local_err_msg)//" (line: "//TRIM(line_number)//").",WARNING)
                   CYCLE parser
                ELSE IF ( (diag_subset_output == DIAG_OTHER .AND. VERIFY('ocean', lowercase(temp_field%file_name)) == 0).OR.&
                     &    (diag_subset_output == DIAG_OCEAN .AND. VERIFY('ocean', lowercase(temp_field%file_name)) /= 0) ) THEN
                   CYCLE parser
                ELSE IF ( lowercase(TRIM(temp_field%spatial_ops)) == 'none' ) THEN
                   CALL init_input_field(temp_field%module_name, temp_field%field_name, 1)
                   CALL init_output_field(temp_field%module_name, temp_field%field_name, temp_field%output_name, temp_field%file_name,&
                        & temp_field%time_method, temp_field%pack, 1)
                ELSE
                   CALL init_input_field(temp_field%module_name, temp_field%field_name, 1)
                   CALL init_output_field(temp_field%module_name, temp_field%field_name, temp_field%output_name, temp_field%file_name,&
                        & temp_field%time_method, temp_field%pack, 1, temp_field%regional_coords)
                END IF

                ! Increment number of fields
                nfields = nfields + 1
             END IF
          END IF init
       END DO parser
    END DO pass

    ! Close the diag_table file.
    DEALLOCATE(diag_table)

    ! check duplicate output_fields in the diag_table
    CALL check_duplicate_output_fields(ERR_MSG=local_err_msg)
    IF ( local_err_msg /= '' ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_diag_table', TRIM(local_err_msg), err_msg) ) RETURN
    END IF

  END SUBROUTINE parse_diag_table
  ! </SUBROUTINE>

  ! <PRIVATE>
  ! <SUBROUTINE NAME="open_diag_table">
  !   <OVERVIEW>
  !     Open the diag_table file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE open_diag_table(iunit, iostat)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Open the <TT>diag_table</TT> file, and return the Fortran file unit number.
  !   </DESCRIPTION>
  !   <OUT NAME="iunit" TYPE="INTEGER">Fortran file unit number of the <TT>diag_table</TT>.</OUT>
  !   <IN NAME="iostat" TYPE="INTEGER, OPTIONAL">
  !     Status of opening file.  If iostat == 0, file exists.  If iostat > 0, the diag_table file does not exist.
  !   </IN>
  !   <OUT NAME="err_msg" TYPE="CHARACTER(len=*), OPTIONAL">
  !     String to hold the return error message.
  !   </OUT>
  SUBROUTINE open_diag_table(iunit, iostat, err_msg)
    INTEGER, INTENT(out) :: iunit
    INTEGER, INTENT(out), OPTIONAL, TARGET :: iostat
    CHARACTER(len=*), INTENT(out), OPTIONAL :: err_msg

    INTEGER, TARGET :: mystat
    INTEGER, POINTER :: pstat

    IF ( PRESENT(iostat) ) THEN
       pstat => iostat
    ELSE
       pstat => mystat
    END IF

    IF ( .NOT.file_exist('diag_table') ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::open_diag_table',&
            & 'diag_table file does not exist.', err_msg) ) RETURN
    ELSE
       pstat = 0
    END IF

    CALL mpp_open(iunit, 'diag_table', action=MPP_RDONLY)
  END SUBROUTINE open_diag_table
  ! </SUBROUTINE>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <SUBROUTINE NAME="close_diag_table">
  !   <OVERVIEW>
  !     Close the diag_table file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE close_diag_table(iunit)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Closes the diag_table file.
  !   </DESCRIPTION>
  !   <IN NAME="iunit" TYPE="INTEGER">Fortran file unit number of the <TT>diag_table</TT>.</IN>
  SUBROUTINE close_diag_table(iunit)
    INTEGER, INTENT(in) :: iunit

    CALL close_file(iunit)
  END SUBROUTINE close_diag_table
  ! </SUBROUTINE>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <FUNCTION NAME="parse_file_line">
  !   <OVERVIEW>
  !     Parse a file description line from the <TT>diag_table</TT> file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     TYPE(file_description_type) FUNCTION parse_file_line(line, istat, err_msg)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     <TT>parse_file_line</TT> parses a file description line from the <TT>diag_table</TT> file, and returns a
  !     <TT>TYPE(file_description_type)</TT>.  The calling function, would then need to call the <TT>init_file</TT> to initialize
  !     the diagnostic output file.
  !   </DESCRIPTION>
  !   <IN NAME="line" TYPE="CHARACTER(len=*)">Line to parse from the <TT>diag_table</TT> file.</IN>
  !   <OUT NAME="istat" TYPE="INTEGER, OPTIONAL">
  !     Return state of the function.  A value of 0 indicates success.  A positive value indicates a <TT>FATAL</TT> error occurred,
  !     and a negative value indicates a <TT>WARNING</TT> should be issued.
  !   </OUT>
  !   <OUT NAME="err_msg" TYPE="CHARACTER(len=*), OPTIONAL">
  !     Error string to include in the <TT>FATAL</TT> or <TT>WARNING</TT> message.
  !   </OUT>
  TYPE(file_description_type) FUNCTION parse_file_line(line, istat, err_msg)
    CHARACTER(len=*), INTENT(in) :: line
    INTEGER, INTENT(out), OPTIONAL, TARGET :: istat
    CHARACTER(len=*), INTENT(out), OPTIONAL :: err_msg

    INTEGER, TARGET :: mystat
    INTEGER, POINTER :: pstat
    INTEGER :: year, month, day, hour, minute, second
    CHARACTER(len=256) :: local_err_msg !< Hold the return error message from routine calls.

    IF ( PRESENT(istat) ) THEN
       pstat => istat
    ELSE
       pstat => mystat
    END IF
    pstat = 0 ! default success return value

    ! Initialize the optional file description fields.
    parse_file_line%new_file_freq = 0
    parse_file_line%new_file_freq_units = ''
    parse_file_line%start_time_s = ''
    parse_file_line%file_duration = 0
    parse_file_line%file_duration_units = ''

    ! Read in the file description line..
    READ (line, FMT=*, IOSTAT=mystat) parse_file_line%file_name, parse_file_line%output_freq, parse_file_line%output_freq_units,&
         & parse_file_line%file_format, parse_file_line%time_units, parse_file_line%long_name,&
         & parse_file_line%new_file_freq, parse_file_line%new_file_freq_units, parse_file_line%start_time_s,&
         & parse_file_line%file_duration, parse_file_line%file_duration_units
    IF ( mystat > 0 ) THEN
       pstat = mystat
       IF ( fms_error_handler('diag_table_mod::parse_file_line', 'Incorrect file description format in diag_table.', err_msg) )&
            & RETURN
    END IF

    ! Check for unallowed characters in strings
    IF ( SCAN(parse_file_line%file_name, UNALLOWED_ALL) > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_file_line',&
            & 'Unallowed character in file_name in the diag_table.', err_msg) ) RETURN
    END IF
    IF ( SCAN(parse_file_line%output_freq_units, UNALLOWED_ALL) > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_file_line',&
            & 'Unallowed character in output_freq_units in the diag_table.', err_msg) ) RETURN
    END IF
    IF ( SCAN(parse_file_line%time_units, UNALLOWED_ALL) > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_file_line',&
            & 'Unallowed character in time_units in the diag_table.', err_msg) ) RETURN
    END IF
    IF ( SCAN(parse_file_line%long_name, UNALLOWED_ALL) > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_file_line',&
            & 'Unallowed character in long_name in the diag_table.', err_msg) ) RETURN
    END IF
    IF ( SCAN(parse_file_line%new_file_freq_units, UNALLOWED_ALL) > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_file_line',&
            & 'Unallowed character in new_file_freq_units in the diag_table.', err_msg) ) RETURN
    END IF
    IF ( SCAN(parse_file_line%start_time_s, UNALLOWED_ALL) > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_file_line',&
            & 'Unallowed character in start_time_s in the diag_table.', err_msg) ) RETURN
    END IF
    IF ( SCAN(parse_file_line%file_duration_units, UNALLOWED_ALL) > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_file_line',&
            & 'Unallowed character in file_duration_units in the diag_table.', err_msg) ) RETURN
    END IF


    ! Fix the file name
    parse_file_line%file_name = fix_file_name(TRIM(parse_file_line%file_name))

    ! Verify values / formats are correct
    IF ( parse_file_line%file_format > 2 .OR. parse_file_line%file_format < 1 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_file_line', 'Invalid file format for file description in the diag_table.',&
            & err_msg) ) RETURN
    END IF

    ! check for known units
    parse_file_line%iTime_units = find_unit_ivalue(parse_file_line%time_units)
    parse_file_line%iOutput_freq_units = find_unit_ivalue(parse_file_line%output_freq_units)
    parse_file_line%iNew_file_freq_units = find_unit_ivalue(parse_file_line%new_file_freq_units)
    parse_file_line%iFile_duration_units = find_unit_ivalue(parse_file_line%file_duration_units)
    ! Verify the units are valid
    IF ( parse_file_line%iTime_units < 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_file_line', 'Invalid time axis units in diag_table.', err_msg) )&
            & RETURN
    END IF
    IF ( parse_file_line%iOutput_freq_units < 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_file_line', 'Invalid output frequency units in diag_table.', err_msg) )&
            & RETURN
    END IF
    IF ( parse_file_line%iNew_file_freq_units < 0 .AND. parse_file_line%new_file_freq > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_file_line', 'Invalid new file frequency units in diag_table.', err_msg) )&
            & RETURN
    END IF
    IF ( parse_file_line%iFile_duration_units < 0 .AND. parse_file_line%file_duration > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_file_line', 'Invalid file duration units in diag_table.', err_msg) )&
            & RETURN
    END IF

    !::sdu::
    !::sdu:: Here is where we would want to parse the regional/global string
    !::sdu::

    ! Check for file frequency, start time and duration presence.
    ! This will determine how the init subroutine is called.
    new_file_freq_present: IF ( parse_file_line%new_file_freq > 0 ) THEN ! New file frequency present.
       IF ( LEN_TRIM(parse_file_line%start_time_s) > 0 ) THEN ! start time present
          READ (parse_file_line%start_time_s, FMT=*, IOSTAT=mystat) year, month, day, hour, minute, second
          IF ( mystat /= 0 ) THEN
             pstat = 1
             IF ( fms_error_handler('diag_table_mod::parse_file_line',&
                  & 'Invalid start time in the file description in diag_table.', err_msg) ) RETURN
          END IF
          parse_file_line%start_time = set_date(year, month, day, hour, minute, second, err_msg=local_err_msg)
          IF ( local_err_msg /= '' ) THEN
             pstat = 1
             IF ( fms_error_handler('diag_table_mod::parse_file_line', local_err_msg, err_msg) ) RETURN
          END IF
          IF ( parse_file_line%file_duration <= 0 ) THEN ! file_duration not present
             parse_file_line%file_duration = parse_file_line%new_file_freq
             parse_file_line%iFile_duration_units = parse_file_line%iNew_file_freq_units
          END IF
       ELSE
          parse_file_line%start_time = base_time
          parse_file_line%file_duration = parse_file_line%new_file_freq
          parse_file_line%iFile_duration_units = parse_file_line%iNew_file_freq_units
       END IF
    END IF new_file_freq_present

  END FUNCTION parse_file_line
  ! </FUNCTION>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <FUNCTION NAME="parse_field_line">
  !   <OVERVIEW>
  !     Parse a field description line from the <TT>diag_table</TT> file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     TYPE(field_description_type) FUNCTION parse_field_line(line, istat, err_msg)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     <TT>parse_field_line</TT> parses a field description line from the <TT>diag_table</TT> file, and returns a
  !     <TT>TYPE(field_description_type)</TT>.  The calling function, would then need to call the <TT>init_input_field</TT> and
  !     <TT>init_output_field</TT> to initialize the diagnostic output field.
  !   </DESCRIPTION>
  !   <IN NAME="line" TYPE="CHARACTER(len=*)">Line to parse from the <TT>diag_table</TT> file.</IN>
  !   <OUT NAME="istat" TYPE="INTEGER, OPTIONAL">
  !     Return state of the function.  A value of 0 indicates success.  A positive value indicates a <TT>FATAL</TT> error occurred,
  !     and a negative value indicates a <TT>WARNING</TT> should be issued.
  !   </OUT>
  !   <OUT NAME="err_msg" TYPE="CHARACTER(len=*), OPTIONAL">
  !     Error string to include in the <TT>FATAL</TT> or <TT>WARNING</TT> message.
  !   </OUT>
  TYPE(field_description_type) FUNCTION parse_field_line(line, istat, err_msg)
    CHARACTER(len=*), INTENT(in) :: line
    INTEGER, INTENT(out), OPTIONAL, TARGET :: istat
    CHARACTER(len=*), OPTIONAL, INTENT(out) :: err_msg

    INTEGER, TARGET :: mystat
    INTEGER, POINTER :: pstat

    IF ( PRESENT(istat) ) THEN
       pstat => istat
    ELSE
       pstat => mystat
    END IF
    pstat = 0 ! default success return value

    READ (line, FMT=*, IOSTAT=mystat) parse_field_line%module_name, parse_field_line%field_name, parse_field_line%output_name,&
         & parse_field_line%file_name, parse_field_line%time_sampling, parse_field_line%time_method, parse_field_line%spatial_ops,&
         & parse_field_line%pack
    IF ( mystat /= 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_field_line',&
            & 'Field description format is incorrect in diag_table.', err_msg) ) RETURN
    END IF

    ! Check for unallowed characters in the string
    IF ( SCAN(parse_field_line%module_name, UNALLOWED_ALL) > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_field_line',&
            & 'Unallowed character in module_name in the diag_table.', err_msg) ) RETURN
    END IF
    IF ( SCAN(parse_field_line%field_name, UNALLOWED_ALL) > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_field_line',&
            & 'Unallowed character in field_name in the diag_table.', err_msg) ) RETURN
    END IF
    IF ( SCAN(parse_field_line%output_name, UNALLOWED_ALL) > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_field_line',&
            & 'Unallowed character in output_name in the diag_table.', err_msg) ) RETURN
    END IF
    IF ( SCAN(parse_field_line%file_name, UNALLOWED_ALL) > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_field_line',&
            & 'Unallowed character in file_name in the diag_table.', err_msg) ) RETURN
    END IF
    IF ( SCAN(parse_field_line%time_sampling, UNALLOWED_ALL) > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_field_line',&
            & 'Unallowed character in time_sampling in the diag_table.', err_msg) ) RETURN
    END IF
    IF ( SCAN(parse_field_line%time_method, UNALLOWED_ALL) > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_field_line',&
            & 'Unallowed character in time_method in the diag_table.', err_msg) ) RETURN
    END IF
    IF ( SCAN(parse_field_line%spatial_ops, UNALLOWED_QTE) > 0 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_field_line',&
            & 'Unallowed character in spatial_ops in the diag_table.', err_msg) ) RETURN
    END IF

    ! Fix the file name
    ! Removes any added '.nc' and appends additional information.
    parse_field_line%file_name = fix_file_name(TRIM(parse_field_line%file_name))

    IF ( parse_field_line%pack > 8 .OR. parse_field_line%pack < 1 ) THEN
       pstat = 1
       IF ( fms_error_handler('diag_table_mod::parse_field_line',&
            & 'Packing is out of range for the field description in diag_table.', err_msg) ) RETURN
    END IF

    IF ( lowercase(TRIM(parse_field_line%spatial_ops)) /= 'none' ) THEN
       READ (parse_field_line%spatial_ops, FMT=*, IOSTAT=mystat) parse_field_line%regional_coords
       IF ( mystat /= 0 ) THEN
          IF ( fms_error_handler('diag_table_mod::parse_field_line',&
               & 'Error in regional output description for field description in diag_table.', err_msg) ) RETURN
       END IF
    END IF
  END FUNCTION parse_field_line
  ! </FUNCTION>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <FUNCTION NAME="is_a_file">
  !   <OVERVIEW>
  !     Determines if a line from the diag_table file is a file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     PURE LOGICAL FUNCTION is_a_file(line)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     <TT>is_a_file</TT> checks a diag_table line to determine if the line describes a file.  If the line describes a file, the
  !     <TT>is_a_file</TT> will return <TT>.TRUE.</TT>.  Otherwise, it will return <TT>.FALSE.</TT>
  !   </DESCRIPTION>
  !   <IN NAME="line" TYPE="CARACTER(len=*)">String containing the <TT>diag_table</TT> line.</IN>
  PURE LOGICAL FUNCTION is_a_file(line)
    CHARACTER(len=*), INTENT(in) :: line

    CHARACTER(len=5) :: first
    INTEGER :: second
    INTEGER :: mystat !< IO status from read

#if defined __PATHSCALE__ || defined _CRAYFTN
    ! This portion is to 'fix' pathscale's and Cray's Fortran compilers inability to handle the FMT=* correctly in the read
    ! statement.
    CHARACTER(len=10) :: secondString
    INTEGER :: comma1, comma2, linelen

    linelen = LEN(line)
    comma1 = INDEX(line,',') + 1 ! +1 to go past the comma
    comma2 = INDEX(line(comma1:linelen),',') + comma1 - 2 ! -2 to get rid of +1 in comma1 and to get 1 character before the comma

    secondString = ADJUSTL(line(comma1:comma2))
    READ (UNIT=secondString, FMT='(I)', IOSTAT=mystat) second
#else
    READ (UNIT=line, FMT=*, IOSTAT=mystat) first, second
#endif

    ! The line is a file if my status is zero after the read.
    is_a_file = mystat == 0
  END FUNCTION is_a_file
  ! </FUNCTION>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <FUNCTION NAME="fix_file_name(file_name_string)">
  !   <OVERVIEW>
  !     Fixes the file name for use with diagnostic file and field initializations.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     PURE CHARACTER(len=128) FUNCTION fix_file_name(file_name_string)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Removes any trailing '.nc' and appends (if requested) append_pelist_name.
  !
  !     Presently, the ensemble appendix will override the append_pelist_name variable.
  !   </DESCRIPTION>
  !   <IN NAME="file_name_string" TYPE="CHARACTER(len=*)">String containing the file name from the <TT>diag_table</TT>.</IN>
  PURE CHARACTER(len=128) FUNCTION fix_file_name(file_name_string)
    CHARACTER(len=*), INTENT(IN) :: file_name_string

    INTEGER :: file_name_len

    fix_file_name = file_name_string ! Default return value

    file_name_len = LEN_TRIM(file_name_string)

    ! Remove trailing '.nc' from the file_name, and append suffixes
    IF ( file_name_len > 2 ) THEN
       IF ( file_name_string(file_name_len-2:file_name_len) == '.nc' ) THEN
          fix_file_name = file_name_string(1:file_name_len-3)
          file_name_len = file_name_len - 3
       END IF
    END IF

    ! Add the optional suffix based on the pe list name if the
    ! append_pelist_name == .TRUE.
    IF ( append_pelist_name ) THEN
       fix_file_name(file_name_len+1:) = TRIM(pelist_name)
    END IF
  END FUNCTION fix_file_name
  ! </FUNCTION>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <FUNCTION NAME="find_unit_ivalue">
  !   <OVERVIEW>
  !     Return the integer value for the given time unit.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     PURE INTEGER FUNCTION find_unit_ivalue(unit_string)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Returns the corresponding integer value for the given time unit.
  !     <UL>
  !       <LI> seconds = 1 </LI>
  !       <LI> minutes = 2 </LI>
  !       <LI> hours = 3 </LI>
  !       <LI> days = 4 </LI>
  !       <LI> months = 5 </LI>
  !       <LI> years = 6 </LI>
  !       <LI> unknown = -1 </LI>
  !     </UL>
  !   </DESCRIPTION>
  !   <IN NAME="unit_string" TYPE="CHARACTER(len=*)">String containing the unit.</IN>
  PURE INTEGER FUNCTION find_unit_ivalue(unit_string)
       CHARACTER(len=*), INTENT(IN) :: unit_string !< Input string, containing the unit.

    SELECT CASE (TRIM(unit_string))
    CASE ('seconds')
       find_unit_ivalue = 1
    CASE ('minutes')
       find_unit_ivalue = 2
    CASE ('hours')
       find_unit_ivalue = 3
    CASE ('days')
       find_unit_ivalue = 4
    CASE ('months')
       find_unit_ivalue = 5
    CASE ('years')
       find_unit_ivalue = 6
    CASE DEFAULT
       find_unit_ivalue = -1 ! Return statement if an incorrect / unknown unit used.
    END SELECT
  END FUNCTION find_unit_ivalue
  ! </FUNCTION>
  ! </PRIVATE>

  ! <PRIVATE>
  ! <SUBROUTINE NAME="initialize_output_arrays">
  !   <OVERVIEW>
  !     Allocate the file, in and out field arrays after reading the <TT>diag_table</TT> file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE initialize_output_arrays()
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     After reading in the <TT>diag_table</TT> file, the arrays that will hold the file, in, and out field data need to be
  !     allocated.  This routine will determine the size of the arrays, and then allocate the arrays.
  !   </DESCRIPTION>
  SUBROUTINE initialize_output_arrays()
    ! Place Holder
  END SUBROUTINE initialize_output_arrays
  ! </SUBROUTINE>
  ! </PRIVATE>
END MODULE diag_table_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The non-local, exact weak-equilibrium stability function \label{sec:cmueA}
!
! !INTERFACE:
   subroutine cmue_a(nlev)

! !DESCRIPTION:
!
!  The solution of \eq{bijVertical} and \eq{giVertical} has the shape indicated
!  by \eq{b13}. This subroutine is used to update the quantities
!  $c_\mu$, $c'_\mu$ and $\Gamma$, defined in \eq{b13}, from which all turbulent
!  fluxes can be computed. The non-linear terms ${\cal N}$ and ${\cal N}_b$ are updated
!  by evaluating the right hand side of \eq{NandNb} at the old time step.
!
!  The numerators and the denominator appearing in \eq{cm}
!  are polynomials of the form
!  \begin{equation}
!   \label{vdng}
!    \begin{array}{rcl}
!    D         &=& d_0
!               +  d_1 \overline{N}^2  + d_2 \overline{S}^2
!               +  d_3 \overline{N}^2 \overline{S}^2
!               + d_4 \overline{N}^4   + d_5 \overline{S}^4      \comma \\[3mm]
!    N_n        &=& n_0
!               +  n_1 \overline{N}^2  + n_2 \overline{S}^2
!               +  n_3 \overline{T}                              \comma \\[3mm]
!    N_b       &=& n_{b0}
!               +  n_{b1} \overline{N}^2 + n_{b2} \overline{S}^2 \comma \\[3mm]
!    N_\Gamma  &=& ( g_0
!               +  g_1 \overline{N}^2  + g_2 \overline{S}^2 ) \overline{T}
!   \point
!   \end{array}
!  \end{equation}
!
!  The coefficients of $D$ are given by
!  \begin{equation}
!   \label{vdi}
!   \begin{array}{rcl}
!     d_0 &=& 36 {\cal N}^3 {\cal N}_b^2                           \comma \\[3mm]
!     d_1 &=& 84 a_5 a_{b3} {\cal N}^2 {\cal N}_b                  \comma \\[3mm]
!     d_2 &=&  9 (a_{b2}^2 - a_{b1}^2) {\cal N}^3
!           + 12 ( 3 a_3^2 - a_2^2) {\cal N}   {\cal N}_b^2        \comma \\[3mm]
!     d_3 &=& 12 (a_2 a_{b1} - 3 a_3 a_{b2} ) a_5 a_{b3} {\cal N}
!           + 12 ( a_3^2 - a_2^2)  a_5 a_{b3} {\cal N}_b           \comma \\[3mm]
!     d_4 &=& 48 a_5^2 a_{b3}^2 {\cal N}                           \comma \\[3mm]
!     d_5 &=&  3 ( 3 a_3^2 - a_2^2)(a_{b2}^2 - a_{b1}^2) {\cal N}
!     \point
!   \end{array}
!  \end{equation}
!  The coefficients of the numerators $N_n$ and $N_b$ can be expressed as
!  \begin{equation}
!   \label{vni}
!   \begin{array}{rcl}
!     n_0 &=& 36 a_1 {\cal N}^2 {\cal N}_b^2                       \comma \\[3mm]
!     n_1 &=&-12 a_5 a_{b3} (a_{b1}+a_{b2}) {\cal N}^2
!           -  8 a_5 a_{b3} (-6 a_1+a_2+3 a_3) {\cal N} {\cal N}_b \comma \\[3mm]
!     n_2 &=& 9 a_1 (a_{b2}^2 - a_{b1}^2){\cal N}^2                \comma \\[3mm]
!     n_3 &=& 36 a_5 a_{b4} (a_{b1}+a_{b2}) {\cal N}^2
!           + 24 a_5 a_{b4} (a_2+3 a_3) {\cal N} {\cal N}_b        \comma
!   \end{array}
!  \end{equation}
!  \begin{equation}
!   \label{vnbi}
!   \begin{array}{rcl}
!     n_{b0} &=& 12 a_{b3} {\cal N}^3 {\cal N}_b                   \comma \\[3mm]
!     n_{b1} &=& 12 a_5 a_{b3}^2 {\cal N}^2                        \comma \\[3mm]
!     n_{b2} &=&  9 a_1 a_{b3} (a_{b1}-a_{b2}) {\cal N}^2
!              +    a_{b3} (6 a_1 (a_2-3 a_3)
!              -    4 (a_2^2-3 a_3^2) ) {\cal N} {\cal N}_b        \comma
!   \end{array}
!  \end{equation}
!  and the numerator of the term $\Gamma$ is
!  \begin{equation}
!   \label{vgi}
!   \begin{array}{rcl}
!     g_0 &=& 36 a_{b4} {\cal N}^3 {\cal N}_b                      \comma \\[3mm]
!     g_1 &=& 36 a_5 a_{b3}  a_{b4} {\cal N}^2                     \comma \\[3mm]
!     g_2 &=& 12 a_{b4} ( 3 a_3^2 - a_2^2) {\cal N}  {\cal N}_b    \point
!   \end{array}
!  \end{equation}

!
! !USES:
   use turbulence, only: eps
   use turbulence, only: P,B,Pb,epsb
   use turbulence, only: an,as,at,r
   use turbulence, only: cmue1,cmue2,gam
   use turbulence, only: cm0
   use turbulence, only: cc1
   use turbulence, only: ct1,ctt
   use turbulence, only: a1,a2,a3,a4,a5
   use turbulence, only: at1,at2,at3,at4,at5

   IMPLICIT NONE
!
! !INPUT PARAMETERS:
!
!  number of vertical layers
   integer, intent(in)       :: nlev
!
! !BUGS:
! Test stage. Do not yet use.
!
! !REVISION HISTORY:
! Original author(s): Lars Umlauf
!
!  $Log: cmue_a.F90,v $
!  Revision 20.0  2013/12/14 00:13:28  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1  2005-06-27 10:54:33  kbk
!  new files needed
!
!
!EOP
!-----------------------------------------------------------------------!
! !LOCAL VARIABLES:
     integer                 ::   i
     REALTYPE                ::   N,Nt,Pe,Pbeb
     REALTYPE                ::   xd0,xd1,xd2,xd3,xd4,xd5,xd6,xd7
     REALTYPE                ::   xn0,xn1,xn2,xn3,xn4,xn5
     REALTYPE                ::   xt0,xt1,xt2,xt3
     REALTYPE                ::   xg0,xg1,xg2
     REALTYPE                ::   d0,d1,d2,d3,d4,d5
     REALTYPE                ::   n0,n1,n2,n3,nt0,nt1,nt2
     REALTYPE                ::   gam0,gam1,gam2
     REALTYPE                ::   nGam,dCm,nCm,nCmp
     REALTYPE                ::   cm3_inv,r_i
!
!-----------------------------------------------------------------------
!BOC



     cm3_inv = 1./cm0**3.

     xd0   =   36.
     xd1   =   84.*a5*at3
     xd2   =   9.*(at2**2.-at1**2.)
     xd3   = - 12.*(a2**2.-3.*a3**2.)
     xd4   =   12.*a5*at3*(a2*at1-3.*a3*at2)
     xd5   =   12.*a5*at3*(a3**2.-a2**2.)
     xd6   =   48.*a5**2.*at3**2.
     xd7  =    3.*(a2**2.-3.*a3**2.)*(at1**2.-at2**2.)


     xn0   =   36.*a1
     xn1   = - 12.*a5*at3*(at1+at2)
     xn2   =   8.*a5*at3*(6.*a1-a2-3.*a3)
     xn3   =   9.*a1*(at2**2.-at1**2.)
     xn4   =   36.*a5*at4*(at1+at2)
     xn5   =   24.*a5*at4*(a2+3.*a3)

     xt0   =   12.*at3
     xt1   =   12*a5*at3**2.
     xt2   =   9.*a1*at3*(at1-at2)
     xt3   =   (  6.*a1*(a2-3.*a3) - 4.*(a2**2.-3.*a3**2.) )*at3

     xg0   =   36.*at4
     xg1   =   36.*a5*at3*at4
     xg2   =  -12.*at4*(a2**2.-3.*a3**2.)


     do i=0,nlev

        Pe   =   ( P(i) + B(i) )/eps(i)
        Pbeb =   Pb(i)/epsb(i)
        r_i  =   1./r(i)

        N    =   Pe + 0.5*cc1 - 1.
        Nt   =   0.5*(Pe-1.) + ct1 + 0.5*r_i*(Pbeb - 1.) ! general
        Nt   =   (Pe-1.) + ct1                           ! weak equilibrium


        d0   =   xd0  * N**3. * Nt**2.
        d1   =   xd1  * N**2. * Nt
        d2   =   xd2  * N**3.          + xd3 * N     * Nt**2.
        d3   =   xd4  * N              + xd5         * Nt
        d4   =   xd6  * N
        d5   =   xd7  * N

        n0   =   xn0  * N**2. * Nt**2.
        n1   =   xn1  * N**2.          + xn2 * N     * Nt
        n2   =   xn3  * N**2.
        n3   =   xn4  * N**2.          + xn5 * N     * Nt

        nt0  =   xt0  * N**3. * Nt
        nt1  =   xt1  * N**2.
        nt2  =   xt2  * N**2.          + xt3 * N     * Nt

        gam0 =   xg0  * N**3. * Nt
        gam1 =   xg1  * N**2.
        gam2 =   xg2  * N     * Nt


        dCm  =  d0  +  d1*an(i) +  d2*as(i) + d3*an(i)*as(i) + d4*an(i)*an(i) + d5*as(i)*as(i)
        nCm  =  n0  +  n1*an(i) +  n2*as(i) + n3*at(i)
        nCmp =  nt0 + nt1*an(i) + nt2*as(i)

        nGam = ( gam0 + gam1*an(i) + gam2*as(i) )*at(i)

        cmue1(i) =  cm3_inv*nCm/dCm
        cmue2(i) =  cm3_inv*nCmp/dCm
        gam(i)   =  nGam/dCm

     end do



     return
     end subroutine cmue_a


!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module ocean_workspace_mod
!
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
! M.J. Harrison 
! </CONTACT>
!
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
! S.M. Griffies 
! </REVIEWER>
!
!<OVERVIEW>
! This module allocates some workspace for use in MOM. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module allocates some workspace for use in MOM. 
!</DESCRIPTION>
!
use ocean_types_mod, only: ocean_domain_type, ocean_grid_type

implicit none

private

#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS
real, public, dimension(isd:ied,jsd:jed)      :: wrk1_2d
real, public, dimension(isd:ied,jsd:jed)      :: wrk2_2d
real, public, dimension(isd:ied,jsd:jed)      :: wrk3_2d
real, public, dimension(isd:ied,jsd:jed)      :: wrk4_2d

real, public, dimension(isd:ied,jsd:jed,2)    :: wrk1_v2d
real, public, dimension(isd:ied,jsd:jed,2)    :: wrk2_v2d

real, public, dimension(isd:ied,jsd:jed,nk)   :: wrk1
real, public, dimension(isd:ied,jsd:jed,nk)   :: wrk2
real, public, dimension(isd:ied,jsd:jed,nk)   :: wrk3
real, public, dimension(isd:ied,jsd:jed,nk)   :: wrk4
real, public, dimension(isd:ied,jsd:jed,nk)   :: wrk5
real, public, dimension(isd:ied,jsd:jed,nk)   :: wrk6

real, public, dimension(isd:ied,jsd:jed,0:nk) :: wrk1_zw
real, public, dimension(isd:ied,jsd:jed,0:nk) :: wrk2_zw

real, public, dimension(isd:ied,jsd:jed,nk,2) :: wrk1_v
real, public, dimension(isd:ied,jsd:jed,nk,2) :: wrk2_v
real, public, dimension(isd:ied,jsd:jed,nk,2) :: wrk3_v
real, public, dimension(isd:ied,jsd:jed,nk,2) :: wrk4_v
real, public, dimension(isd:ied,jsd:jed,nk,2) :: wrk5_v

#else

real, public, allocatable, dimension(:,:)     :: wrk1_2d
real, public, allocatable, dimension(:,:)     :: wrk2_2d
real, public, allocatable, dimension(:,:)     :: wrk3_2d
real, public, allocatable, dimension(:,:)     :: wrk4_2d

real, public, allocatable, dimension(:,:,:)   :: wrk1
real, public, allocatable, dimension(:,:,:)   :: wrk2
real, public, allocatable, dimension(:,:,:)   :: wrk3
real, public, allocatable, dimension(:,:,:)   :: wrk4
real, public, allocatable, dimension(:,:,:)   :: wrk5
real, public, allocatable, dimension(:,:,:)   :: wrk6

real, public, allocatable, dimension(:,:,:)   :: wrk1_zw
real, public, allocatable, dimension(:,:,:)   :: wrk2_zw

real, public, allocatable, dimension(:,:,:,:) :: wrk1_v
real, public, allocatable, dimension(:,:,:,:) :: wrk2_v
real, public, allocatable, dimension(:,:,:,:) :: wrk3_v
real, public, allocatable, dimension(:,:,:,:) :: wrk4_v
real, public, allocatable, dimension(:,:,:,:) :: wrk5_v

real, public, allocatable, dimension(:,:,:)   :: wrk1_v2d
real, public, allocatable, dimension(:,:,:)   :: wrk2_v2d

#endif

public ocean_workspace_init, ocean_workspace_end



logical, private :: module_is_initialized = .FALSE.

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_workspace_init">
!
! <DESCRIPTION>
! Initialize MOM workspace module.
! </DESCRIPTION>
!
subroutine ocean_workspace_init(Domain, Grid)

type(ocean_domain_type), intent(in) :: Domain
type(ocean_grid_type), intent(in)   :: Grid

module_is_initialized = .TRUE.

#ifndef MOM_STATIC_ARRAYS
allocate(wrk1_2d(Domain%isd:Domain%ied,Domain%jsd:Domain%jed))
allocate(wrk2_2d(Domain%isd:Domain%ied,Domain%jsd:Domain%jed))
allocate(wrk3_2d(Domain%isd:Domain%ied,Domain%jsd:Domain%jed))
allocate(wrk4_2d(Domain%isd:Domain%ied,Domain%jsd:Domain%jed))

allocate(wrk1(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,Grid%nk))
allocate(wrk2(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,Grid%nk))
allocate(wrk3(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,Grid%nk))
allocate(wrk4(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,Grid%nk))
allocate(wrk5(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,Grid%nk))
allocate(wrk6(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,Grid%nk))

allocate(wrk1_zw(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,0:Grid%nk))
allocate(wrk2_zw(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,0:Grid%nk))

allocate(wrk1_v(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,Grid%nk,2))
allocate(wrk2_v(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,Grid%nk,2))
allocate(wrk3_v(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,Grid%nk,2))
allocate(wrk4_v(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,Grid%nk,2))
allocate(wrk5_v(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,Grid%nk,2))

allocate(wrk1_v2d(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,2))
allocate(wrk2_v2d(Domain%isd:Domain%ied,Domain%jsd:Domain%jed,2))
#endif

end subroutine ocean_workspace_init
! </SUBROUTINE> NAME="ocean_workspace_init">


!#######################################################################
! <SUBROUTINE NAME="ocean_workspace_end">
!
! <DESCRIPTION>
! End MOM workspace.
! </DESCRIPTION>
!
subroutine ocean_workspace_end()

module_is_initialized = .FALSE.

#ifndef MOM_STATIC_ARRAYS
deallocate(wrk1,wrk2,wrk3,wrk4,wrk5,wrk6)
deallocate(wrk1_zw,wrk2_zw)
deallocate(wrk1_v,wrk2_v,wrk3_v,wrk4_v,wrk5_v)
deallocate(wrk1_2d,wrk2_2d,wrk3_2d,wrk4_2d)
deallocate(wrk1_v2d,wrk2_v2d)
#endif

end subroutine ocean_workspace_end
! </SUBROUTINE> NAME="ocean_workspace_end">

end module ocean_workspace_mod

module atmosphere_mod

!-----------------------------------------------------------------------
!
!         interface for b-grid dynamical core and physics
!
!-----------------------------------------------------------------------
!---------------- m o d u l e   i n f o r m a t i o n ------------------

use mpp_mod, only: input_nml_file 
use bgrid_core_driver_mod, only: bgrid_dynam_type,       &
                                 bgrid_core_driver_init, &
                                 bgrid_core_driver,      &
                                 bgrid_core_time_diff,   &
                                 bgrid_core_driver_end,  &
                                 get_bottom_data,        &
                                 put_bottom_data

use   bgrid_prog_var_mod, only: prog_var_type, var_init

use      bgrid_horiz_mod, only: get_horiz_grid_size,        &
                                get_horiz_grid_bound, TGRID

use     time_manager_mod, only: time_type, get_time, operator(+)

use              fms_mod, only: file_exist, open_namelist_file, &
                                error_mesg, FATAL, WARNING,     &
                                check_nml_error, stdlog,        &
                                write_version_number,           &
                                mpp_pe, mpp_root_pe,            &
                                close_file, set_domain,         &
                                mpp_clock_id, mpp_clock_begin,  &
                                mpp_clock_end, MPP_CLOCK_SYNC,  &
                                CLOCK_SUBCOMPONENT, NOTE

use        bgrid_vert_mod, only: compute_height_bottom
use bgrid_change_grid_mod, only: change_grid, WIND_GRID, TEMP_GRID

use     bgrid_physics_mod, only: bgrid_physics_down, bgrid_physics_up,  &
                                 bgrid_physics_init, bgrid_physics_end, &
                                 surf_diff_type

use      mpp_domains_mod, only: domain2d

use  field_manager_mod, only: MODEL_ATMOS
use tracer_manager_mod, only: get_tracer_index, NO_TRACER
use xgrid_mod,          only: grid_box_type

!-----------------------------------------------------------------------

implicit none
private

public  atmosphere_down,       atmosphere_up,       &
        atmosphere_init,       atmosphere_end,      &
        atmosphere_resolution, atmosphere_boundary, &
        atmosphere_cell_area,  atmosphere_restart,  &
        get_atmosphere_axes,   atmosphere_domain

public  get_bottom_mass,     get_bottom_wind

public  surf_diff_type,      get_stock_pe

!-----------------------------------------------------------------------

character(len=128) :: version = '$Id: atmosphere.F90,v 19.0 2012/01/06 19:52:46 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!-----------------------------------------------------------------------
!---- namelist (saved in file input.nml) ----
!
! physics_window  The number of "i" by "j" rows processed each time
!                 the modular physics is called. To process the entire
!                 domain use physics_window = (/0,0/).
!                   [integer, default: physics_window = 0,1]

   integer, dimension(2) :: physics_window = (/0,1/)

   namelist /atmosphere_nml/ physics_window

!-----------------------------------------------------------------------
!---- private data ----

type (bgrid_dynam_type), save :: Dynam
type    (prog_var_type), save :: Var, Var_dt
type        (time_type) :: Time_step_atmos

real                               :: dt_atmos
real,    dimension(:,:,:), pointer :: omega =>NULL()
integer, dimension(4)              :: atmos_axes

integer :: id_dynam, id_phys_down, id_phys_up
logical :: stock_warning_issued = .FALSE.

!-----------------------------------------------------------------------

contains

!#######################################################################

 subroutine atmosphere_down (Time,    frac_land,                         &
                             t_surf,  albedo, albedo_vis_dir,            &
                             albedo_nir_dir,  albedo_vis_dif,            &
                             albedo_nir_dif,  rough_mom,                 &
                             u_star,  b_star, q_star,                    &
                             dtau_du, dtau_dv, tau_x,   tau_y,           &
                             frac_open_sea,                              &
                             gust, coszen, flux_sw, flux_sw_dir,         &
                             flux_sw_dif,                                &
                         flux_sw_down_vis_dir,   flux_sw_down_vis_dif,   &
                         flux_sw_down_total_dir, flux_sw_down_total_dif, &
                             flux_sw_vis,                                &
                             flux_sw_vis_dir,                            &
                             flux_sw_vis_dif, flux_lw,                   &
                             Surf_diff                       )

!
!        Time = time at the current time level
!

  type(time_type),intent(in)    :: Time

  real, intent(in),    dimension(:,:) :: frac_land,                 &
                                         t_surf, albedo, rough_mom, &
                                   albedo_vis_dir, albedo_nir_dir,  &
                                   albedo_vis_dif, albedo_nir_dif,  &
                                   u_star, b_star, q_star,          &
                                   dtau_du, dtau_dv, frac_open_sea
  real, intent(inout), dimension(:,:) :: tau_x,  tau_y
  real, intent(out),   dimension(:,:) :: gust, coszen, flux_sw,    &
                                                      flux_sw_dir,    &
                                                      flux_sw_dif,    &
                                          flux_sw_down_vis_dir, &
                                         flux_sw_down_vis_dif, &
                                         flux_sw_down_total_dir,   &
                                         flux_sw_down_total_dif,   &
                                         flux_sw_vis,         &
                                         flux_sw_vis_dir,    &
                                         flux_sw_vis_dif, flux_lw
  type(surf_diff_type), intent(inout) :: Surf_diff

  type(time_type) :: Time_prev, Time_next
!-----------------------------------------------------------------------

   Time_prev = Time                       ! two time-level scheme
   Time_next = Time + Time_step_atmos

!---- dynamics -----

   call mpp_clock_begin (id_dynam)
   call bgrid_core_driver ( Time_next, Var, Var_dt, Dynam, omega )
   call mpp_clock_end (id_dynam)

!---- call physics -----

   call mpp_clock_begin (id_phys_down)
   call bgrid_physics_down (physics_window, dt_atmos,         &
                            Time_prev, Time, Time_next,       &
                            Dynam%Hgrid, Dynam%Vgrid, Dynam,  &
                            Var,     Var_dt,     frac_land,   &
                            albedo,  albedo_vis_dir, albedo_nir_dir,  &
                            albedo_vis_dif, albedo_nir_dif,  &
                            rough_mom,  t_surf,      &
                            u_star,  b_star, q_star,          &
                            dtau_du, dtau_dv, tau_x, tau_y,   &
                            flux_sw,    &
                            flux_sw_dir,    &
                            flux_sw_dif,    &
                            flux_sw_down_vis_dir,     &
                            flux_sw_down_vis_dif,     &
                            flux_sw_down_total_dir,  &
                            flux_sw_down_total_dif,  &
                            flux_sw_vis,  &
                            flux_sw_vis_dir,  &
                            flux_sw_vis_dif,  &
                            flux_lw, coszen, gust,   &
                            Surf_diff, frac_open_sea          )
   call mpp_clock_end (id_phys_down)

!-----------------------------------------------------------------------

 end subroutine atmosphere_down

!#######################################################################

 subroutine atmosphere_up (Time,  frac_land, Surf_diff, lprec, fprec, gust, &
                           u_star, b_star, q_star )

  type(time_type),intent(in)        :: Time
  real, intent(in),  dimension(:,:) :: frac_land
  type(surf_diff_type), intent(inout) :: Surf_diff
  real, intent(out), dimension(:,:) :: lprec,   fprec
  real, intent(inout), dimension(:,:) :: gust
  real, intent(in),  dimension(:,:) :: u_star, b_star, q_star

  type(time_type) :: Time_prev, Time_next
!-----------------------------------------------------------------------
!------ call physics up ------

   Time_prev = Time                       ! two time-level scheme
   Time_next = Time + Time_step_atmos

     call mpp_clock_begin (id_phys_up)
     call bgrid_physics_up (physics_window, dt_atmos,        &
                            Time_prev, Time, Time_next,      &
                            Dynam%Hgrid, Dynam%Vgrid, Dynam, &
                            Var,        Var_dt,     omega,   &
                            frac_land,  Surf_diff,           &
                            lprec,      fprec,      gust,    &
                            u_star,     b_star,     q_star   )
     call mpp_clock_end (id_phys_up)

!------ time differencing and diagnostics -------

     call bgrid_core_time_diff ( omega, Time_next, Dynam, Var, Var_dt )

!-----------------------------------------------------------------------

 end subroutine atmosphere_up

!#######################################################################

 subroutine atmosphere_init (Time_init, Time, Time_step, Surf_diff, Grid_box)

 type (time_type),     intent(in)    :: Time_init, Time, Time_step
 type(surf_diff_type), intent(inout) :: Surf_diff
 type(grid_box_type),  intent(inout) :: Grid_box

  integer :: unit, sec, ierr, io, logunit

!-----------------------------------------------------------------------
!----- read namelist -----

    if (file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
        read (input_nml_file, nml=atmosphere_nml, iostat=io)
        ierr = check_nml_error(io,'atmosphere_nml')
#else
        unit = open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
           read (unit, nml=atmosphere_nml, iostat=io, end=10)
           ierr = check_nml_error (io, 'atmosphere_nml')
        enddo
 10     call close_file (unit)
#endif
    endif

!----- write version and namelist to log file -----

    call write_version_number(version, tagname)
    logunit = stdlog()
    if ( mpp_pe() == mpp_root_pe() ) write (logunit, nml=atmosphere_nml)

!---- compute physics/atmos time step in seconds ----

   Time_step_atmos = Time_step
   call get_time (Time_step_atmos, sec)
   dt_atmos = real(sec)

!----- initialize dynamical core -----

   call bgrid_core_driver_init ( Time_init, Time, Time_step,    &
                                 Var, Var_dt, Dynam, atmos_axes )

!----- initialize storage needed for vert motion ----

    omega => var_init (Dynam%Hgrid, Dynam%Vgrid%nlev)

!----- initialize physics interface -----
!----- initialize domains for reading global physics data -----

    call set_domain ( Dynam%Hgrid%Tmp%Domain_nohalo )

    call bgrid_physics_init (atmos_axes, Time, Dynam%Hgrid, Dynam%Vgrid, Dynam, &
                             Var, Surf_diff)

!   ----- use entire grid as window ? -----

    if (physics_window(1) <= 0) physics_window(1) = Dynam%Hgrid%Tmp%ie-Dynam%Hgrid%Tmp%is+1
    if (physics_window(2) <= 0) physics_window(2) = Dynam%Hgrid%Tmp%je-Dynam%Hgrid%Tmp%js+1

!  --- initialize clocks for dynamics, physics_down and physics_up

    id_dynam     = mpp_clock_id ('BGRID: dynamical core',   &
                       flags=MPP_CLOCK_SYNC, grain=CLOCK_SUBCOMPONENT )
    id_phys_down = mpp_clock_id ('Physics_down',   &
                       flags=MPP_CLOCK_SYNC, grain=CLOCK_SUBCOMPONENT )
    id_phys_up   = mpp_clock_id ('Physics_up',   &
                       flags=MPP_CLOCK_SYNC, grain=CLOCK_SUBCOMPONENT )

!-----------------------------------------------------------------------

 end subroutine atmosphere_init

!#######################################################################

 subroutine atmosphere_end (Time, Grid_box)

 type (time_type), intent(in) :: Time
 type(grid_box_type),  intent(inout) :: Grid_box
 integer :: unit


    call bgrid_core_driver_end ( Var, Dynam )

!----- initialize domains for writing global physics data -----

    call set_domain ( Dynam%Hgrid%Tmp%Domain_nohalo )

    call bgrid_physics_end   (Time)                           

 end subroutine atmosphere_end

  !#######################################################################
  ! <SUBROUTINE NAME="atmosphere_restart">
  ! <DESCRIPTION>
  !  dummy routine.
  ! </DESCRIPTION>
  subroutine atmosphere_restart(timestamp)
    character(len=*),  intent(in) :: timestamp

    call error_mesg ('atmosphere_restart in atmosphere_mod', &
                     'intermediate restart capability is not implemented for this model', FATAL)

  end subroutine atmosphere_restart
  ! </SUBROUTINE>

!#######################################################################
!    returns the number of longitude and latitude grid points
!    for either the local PEs grid (default) or the global grid

 subroutine atmosphere_resolution (nlon, nlat, global)

  integer, intent(out)          :: nlon, nlat
  logical, intent(in), optional :: global

!---- return the size of the grid used for physics computations ----

    call get_horiz_grid_size (Dynam % Hgrid, TGRID, nlon, nlat, global)

 end subroutine atmosphere_resolution

!#######################################################################
 subroutine atmosphere_cell_area(area_out)
   real, dimension(:,:), intent(out) :: area_out
   integer :: j

   do j=Dynam%Hgrid%Tmp%js,Dynam%Hgrid%Tmp%je
     area_out(:,j-Dynam%Hgrid%Tmp%js+1) = Dynam%Hgrid%Tmp%area(j)
   enddo

 end subroutine atmosphere_cell_area
!#######################################################################
!    returns the longitude and latitude grid box edges
!    for either the local PEs grid (default) or the global grid

 subroutine atmosphere_boundary (blon, blat, global)

    real,    intent(out)          :: blon(:,:), blat(:,:)
    logical, intent(in), optional :: global
    
    real, dimension(size(blon,1)) :: rlonb
    real, dimension(size(blat,2)) :: rlatb
    integer :: i, j
!----- return the longitudinal and latitudinal grid box edges ----------

    call get_horiz_grid_bound (Dynam % Hgrid, TGRID, rlonb, rlatb, global)
    do i=1,size(blon,1)
       blon(i,:) = rlonb(i)
    end do
    do j=1,size(blat,2)
       blat(:,j) = rlatb(j)
    end do

 end subroutine atmosphere_boundary

!#######################################################################
!    returns the domain2d variable associated with the coupling grid
!  note: coupling is done using the mass/temperature grid with no halos

 subroutine atmosphere_domain (Domain)
 type(domain2d), intent(inout) :: Domain

   Domain = Dynam % Hgrid % Tmp % Domain_nohalo

 end subroutine atmosphere_domain

!#######################################################################
!    returns the axis indices associated with the coupling grid

 subroutine get_atmosphere_axes ( axes )

   integer, intent(out) :: axes (:)

!----- returns the axis indices for the atmospheric (mass) grid -----

     if ( size(axes(:)) < 0 .or. size(axes(:)) > 4 ) call error_mesg (    &
                           'get_atmosphere_axes in atmosphere_mod', &
                           'size of argument is incorrect', FATAL   )

     axes (1:size(axes(:))) = atmos_axes (1:size(axes(:)))

 end subroutine get_atmosphere_axes

!#######################################################################
! returns temp, tracers, pres, height at the lowest model level
!         and surface pressure and sea level pressure

 subroutine get_bottom_mass (t_bot, tr_bot, p_bot, z_bot, p_surf, slp)

  real, intent(out),   &
        dimension(Dynam%Hgrid%Tmp%is:Dynam%Hgrid%Tmp%ie,Dynam%Hgrid%Tmp%js:Dynam%Hgrid%Tmp%je)   &
        :: t_bot, p_bot, z_bot, p_surf, slp
  real, intent(out),   &
        dimension(Dynam%Hgrid%Tmp%is:Dynam%Hgrid%Tmp%ie,Dynam%Hgrid%Tmp%js:Dynam%Hgrid%Tmp%je,Var%ntrace) :: tr_bot

  real, dimension(Dynam%Hgrid%Tmp%is:Dynam%Hgrid%Tmp%ie,Dynam%Hgrid%Tmp%js:Dynam%Hgrid%Tmp%je) :: q_bot
  integer :: i, j, kb, sphum, n
  integer :: is,ie,js,je


  is = Dynam%Hgrid%Tmp%is;  ie = Dynam%Hgrid%Tmp%ie
  js = Dynam%Hgrid%Tmp%js;  je = Dynam%Hgrid%Tmp%je

  sphum = get_tracer_index ( MODEL_ATMOS, 'sphum' )

    do j = js, je
    do i = is, ie
      kb = Dynam%Masks%Tmp%kbot(i,j)
      t_bot(i,j) = Var % t(i,j,kb)
    enddo
    enddo

    if(sphum == NO_TRACER) then
      q_bot = 0.0
    else
      do j = js, je
      do i = is, ie
        kb = Dynam%Masks%Tmp%kbot(i,j)
        q_bot(i,j) = Var % r(i,j,kb,sphum)
      enddo
      enddo
    endif

    do n=1,size(tr_bot,3)
    do j = js, je
    do i = is, ie
      kb = Dynam%Masks%Tmp%kbot(i,j)
      tr_bot(i,j,n) = Var % r(i,j,kb,n)
    enddo
    enddo
    enddo

    p_surf = Var % ps (is:ie,js:je)

    slp = Var % ps (is:ie,js:je)

    call compute_height_bottom ( Dynam%Vgrid, Var%pssl(is:ie,js:je), &
                                 t_bot, q_bot, z_bot, p_bot,         &
                                 Dynam%Masks%Tmp%kbot(is:ie,js:je)   )


 end subroutine get_bottom_mass

!#######################################################################
! returns u and v on the mass grid at the lowest model level

 subroutine get_bottom_wind (u_bot, v_bot)

  real, intent(out),   &
        dimension(Dynam%Hgrid%Tmp%is:Dynam%Hgrid%Tmp%ie,Dynam%Hgrid%Tmp%js:Dynam%Hgrid%Tmp%je) &
        :: u_bot, v_bot

  real, dimension(Dynam%Hgrid%ilb:Dynam%Hgrid%iub,Dynam%Hgrid%jlb:Dynam%Hgrid%jub) :: u,v,uh,vh

!---- compute lowest level winds on mass grid -----

  call get_bottom_data ( Var % u, Var % v,    &
                         u, v, Dynam%Masks%Vel%kbot )

  call change_grid ( Dynam%Hgrid, WIND_GRID, TEMP_GRID, u, v, uh, vh )

  u_bot = uh (Dynam%Hgrid%Tmp%is:Dynam%Hgrid%Tmp%ie,Dynam%Hgrid%Tmp%js:Dynam%Hgrid%Tmp%je)
  v_bot = vh (Dynam%Hgrid%Tmp%is:Dynam%Hgrid%Tmp%ie,Dynam%Hgrid%Tmp%js:Dynam%Hgrid%Tmp%je)

 end subroutine get_bottom_wind

!#######################################################################

 subroutine get_stock_pe(index, value)

 ! This is a dummy routine.
 ! It is neccessary to satisfy revision 13.0.4.3.2.1 of atmos_coupled/atmos_model.f90
 ! Since that revision of atmos_coupled/atmos_model.f90 does nothing with the result,
 ! this routine can be a dummy.
 ! If and when the result is needed, it should be the total water content of the
 ! global atmosphere (Kg), including vapor, liquid and ice.

 integer, intent(in) :: index
 real, intent(out)   :: value

 value = 0.0
 if(.not.stock_warning_issued) then
   call error_mesg('get_stock_pe','Stocks not yet implemented. Returning zero.',NOTE)
   stock_warning_issued = .true.
 endif

 end subroutine get_stock_pe

!#######################################################################

end module atmosphere_mod

module land_tile_io_mod

use mpp_mod, only : mpp_send, mpp_recv, mpp_sync
use mpp_mod, only : COMM_TAG_1,  COMM_TAG_2,  COMM_TAG_3,  COMM_TAG_4
use mpp_mod, only : COMM_TAG_5,  COMM_TAG_6,  COMM_TAG_7,  COMM_TAG_8
use fms_mod, only : error_mesg, FATAL, mpp_pe, get_mosaic_tile_file
use fms_io_mod, only : get_instance_filename
use time_manager_mod, only : time_type
use data_override_mod, only : data_override

use nf_utils_mod, only : nfu_inq_dim, nfu_inq_var, nfu_def_dim, nfu_def_var, &
     nfu_get_var, nfu_put_att
use land_io_mod, only : print_netcdf_error, read_field, input_buf_size
use land_tile_mod, only : land_tile_type, land_tile_list_type, land_tile_enum_type, &
     first_elmt, tail_elmt, next_elmt, current_tile, operator(/=), &
     get_elmt_indices
use land_data_mod, only  : lnd
use land_utils_mod, only : put_to_tiles_r0d_fptr

implicit none
private

! ==== public interfaces =====================================================
! restart i/o subroutines: those use CF "compression by gathering" technique
! to pack tile data.
public :: create_tile_out_file
public :: read_tile_data_r0d_fptr,  read_tile_data_r1d_fptr
public :: read_tile_data_i0d_fptr
public :: write_tile_data_r0d_fptr, write_tile_data_r1d_fptr
public :: write_tile_data_i0d_fptr

! data override subroutines
public :: override_tile_data_r0d_fptr

! auxiliary subroutines
public :: get_tile_by_idx
public :: print_netcdf_error

public :: read_field

public :: get_input_restart_name

public :: sync_nc_files ! synchronizes writer and reader processors
! ==== end of public interfaces ==============================================
interface create_tile_out_file
   module procedure create_tile_out_file_idx
   module procedure create_tile_out_file_fptr
end interface

interface read_tile_data_r1d_fptr
   module procedure read_tile_data_r1d_fptr_all
   module procedure read_tile_data_r1d_fptr_idx
end interface

interface write_tile_data_r1d_fptr
   module procedure write_tile_data_r1d_fptr_all
   module procedure write_tile_data_r1d_fptr_idx
end interface

! ==== module constants ======================================================
character(len=*), parameter :: &
     module_name = 'land_tile_io_mod', &
     version     = '$Id: land_tile_io.F90,v 20.0 2013/12/13 23:29:59 fms Exp $', &
     tagname     = '$Name: tikal $'

! name of the "compressed" dimension (and dimension variable) in the output 
! netcdf files -- that is, the dimensions written out using compression by 
! gathering, as described in CF conventions. See subroutines write_tile_data,
! read_tile_data, read_unpack_tile_data, write_cohort_data
character(len=*),   parameter :: tile_index_name   = 'tile_index'


! ==== NetCDF declarations ===================================================
include 'netcdf.inc'
#define __NF_ASRT__(x) call print_netcdf_error((x),module_name,__LINE__)


contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

! =============================================================================
! given a generic name of the restart file, checks if a file with one of the 
! possible restarts file names exists, and if it does returns the tile-qualified 
! (or tile- and processor-qualified) name of the restart.
subroutine get_input_restart_name(name, restart_exists, actual_name)
  character(*), intent(in)  :: name        ! "generic" name of the restart
  logical     , intent(out) :: restart_exists ! TRUE if any file found
  character(*), intent(out) :: actual_name ! name of the found file, if any

  ! ---- local vars
  character(6) :: PE_suffix ! PE number
  
  ! Build the restart file name.
  call get_instance_filename(trim(name), actual_name)
  call get_mosaic_tile_file(trim(actual_name),actual_name,.false.,lnd%domain)
  ! we can't use fms file_exist function here, because it lies: it checks not
  ! just the original name, but the name with PE suffix, and returns true if
  ! either of those exist
  inquire (file=trim(actual_name), exist=restart_exists)
  if (.not.restart_exists) then
     ! try the name with current PE number attached
     write(PE_suffix,'(".",I4.4)') lnd%io_id
     actual_name = trim(actual_name)//trim(PE_suffix)
     inquire (file=trim(actual_name), exist=restart_exists)
  endif

end subroutine

! =============================================================================
! this subroutine creates netcdf file for output of tiled data using "compression
! by gathering," as described in CF conventions, and creates coordinate system
! necessary for write_tile_data subroutines.
! In particular:
!  "compressed" dimension and integer variable with appropriate attributes, with 
! variable filled with packing indices
!   horizontal dimensions "lat" and "lon" with associated variable, and boundaries, 
! describing global grid
!   dimension "tile," without any associated variable. length of this dimension is
! equal to current global max of number of tiles per grid cell
!
! The file is actually created only by root processor of our io_domain; the rest 
! of the processors just open the created file in NOWRITE mode. 
subroutine create_tile_out_file_idx(ncid, name, glon, glat, tidx, tile_dim_length, reserve)
  integer          , intent(out) :: ncid      ! resulting NetCDF id
  character(len=*) , intent(in)  :: name      ! name of the file to create
  real             , intent(in)  :: glon(:)   ! longitudes of the grid centers
  real             , intent(in)  :: glat(:)   ! latitudes of the grid centers
  integer          , intent(in)  :: tidx(:)   ! integer compressed index of tiles
  integer          , intent(in)  :: tile_dim_length ! length of tile axis
  integer, optional, intent(in)  :: reserve   ! amount of space to reserve for 
  ! header expansion. This subroutine and following calls to write_tile_data
  ! will work even if this is set to 0, but for efficiency it is useful to
  ! specify some non-zero value, so that netcdf library do not have to rewrite
  ! entire file each time a new variable is added. Default value (8K) should do
  ! fine in most cases.

  ! ---- local vars
  integer        :: reserve_  ! local value of space to reserve at the end of NetCDF header
  character(256) :: full_name ! full name of the file, including the processor number
  character(6)   :: PE_suffix ! PE number
  integer, allocatable :: ntiles(:) ! list of land tile numbers for each of PEs in io_domain
  integer, allocatable :: tidx2(:)  ! array of tile indices from all PEs in io_domain
  integer :: p ! io_domain PE iterator 
  integer :: k ! current index in tidx2 array for receive operation
  integer :: i
  integer :: iret

  ! form the full name of the file
  call get_instance_filename(trim(name), full_name)
  call get_mosaic_tile_file(trim(full_name),full_name,.false.,lnd%domain)
  if (lnd%append_io_id) then
      write(PE_suffix,'(".",I4.4)') lnd%io_id
  else
      PE_suffix = ''
  endif

  full_name = trim(full_name)//trim(PE_suffix)

  if(tile_dim_length<=0) &
    call error_mesg('create_tile_out_file','tile axis length must be positive', FATAL)

  if (mpp_pe()/=lnd%io_pelist(1)) then
     ! if current PE doesn't do io, we just send the data to the processor that
     ! does
     call mpp_send(size(tidx), plen=1,          to_pe=lnd%io_pelist(1), tag=COMM_TAG_1)
     call mpp_send(tidx(1),    plen=size(tidx), to_pe=lnd%io_pelist(1), tag=COMM_TAG_2)
  else
     ! gather an array of tile sizes from all processors in our io_domain
     allocate(ntiles(size(lnd%io_pelist)))
     ntiles(1) = size(tidx)
     do p = 2,size(lnd%io_pelist)
        call mpp_recv(ntiles(p), from_pe=lnd%io_pelist(p), glen=1, tag=COMM_TAG_1)
     enddo
     ! gather tile indices from all processors in our io_domain
     allocate(tidx2(sum(ntiles(:))))
     tidx2(1:ntiles(1))=tidx(:)
     k=ntiles(1)+1
     do p = 2,size(lnd%io_pelist)
        call mpp_recv(tidx2(k), from_pe=lnd%io_pelist(p), glen=ntiles(p), tag=COMM_TAG_2)
        k = k+ntiles(p)
     enddo

     ! create netcdf file
#ifdef use_netCDF3
     __NF_ASRT__(nf_create(full_name,NF_CLOBBER,ncid))
#elif use_LARGEFILE
     __NF_ASRT__(nf_create(full_name,ior(NF_64BIT_OFFSET,NF_CLOBBER),ncid))
#else
     __NF_ASRT__(nf_create(full_name,ior(NF_NETCDF4,NF_CLASSIC_MODEL),ncid))
#endif

     ! create lon, lat, dimensions and variables
     __NF_ASRT__(nfu_def_dim(ncid,'lon' ,glon(:) ,'longitude','degrees_east'))
     __NF_ASRT__(nfu_def_dim(ncid,'lat' ,glat(:) ,'latitude','degrees_north'))

     iret=nfu_def_dim(ncid,'tile',(/(p,p=1,tile_dim_length)/),'tile number within grid cell')
     __NF_ASRT__(iret)
     ! the size of tile dimension really does not matter for the output, but it does
     ! matter for uncompressing utility, since it uses it as a size of the array to
     ! unpack to
     ! create tile index dimension and variable
     __NF_ASRT__(nfu_def_dim(ncid,tile_index_name,tidx2,'compressed land point index'))
     __NF_ASRT__(nfu_put_att(ncid,tile_index_name,'compress','tile lat lon'))
     __NF_ASRT__(nfu_put_att(ncid,tile_index_name,'valid_min',0))
     ! release the data we no longer need
     deallocate(ntiles,tidx2)

     ! determine the local value of space reserved in the header; by default 16K
     reserve_ = 1024*16
     if(present(reserve)) reserve_ = reserve

     ! end definition mode, reserving some space for future additions
     ! this call also commits the changes to the disk
     __NF_ASRT__(nf__enddef(ncid,reserve_,4,0,4))
     ! arguments are ncid,h_minfree,v_align,v_minfree,r_align; default is (ncid,0,4,0,4).
     ! The above call reserves some space at the end of the netcdf header for
     ! future expansion without library's having to rewrite the entire file. See 
     ! manual pages netcdf(3f) or netcdf(3) for more information.
  endif
  ! make sure send-receive operations and file creation have finished
  call mpp_sync()
  ! open file on non-writing processors to have access to the tile index
  if (mpp_pe()/=lnd%io_pelist(1)) then
     __NF_ASRT__(nf_open(full_name,NF_NOWRITE,ncid))
  endif
end subroutine create_tile_out_file_idx

! =============================================================================
subroutine create_tile_out_file_fptr(ncid, name, glon, glat, tile_exists, &
     tile_dim_length, reserve, created)
  integer          , intent(out) :: ncid      ! resulting NetCDF id
  character(len=*) , intent(in)  :: name      ! name of the file to create
  real             , intent(in)  :: glon(:)   ! longitudes of the grid centers
  real             , intent(in)  :: glat(:)   ! latitudes of the grid centers
  integer          , intent(in)  :: tile_dim_length ! length of tile axis
  integer, optional, intent(in)  :: reserve   ! amount of space to reserve for
  logical, optional, intent(out) :: created   ! indicates wether the file was 
      ! created; it is set to false if no restart needs to be written, in case 
      ! the total number of qualifying tiles in this domain is equal to zero
  ! the following interface describes the "detector function", which is passed 
  ! through the argument list and must return true for any tile to be written 
  ! to the specific restart, false otherwise
  interface
     logical function tile_exists(tile)
        use land_tile_mod, only : land_tile_type
        type(land_tile_type), pointer :: tile
     end function tile_exists
  end interface

  ! ---- local vars
  type(land_tile_enum_type) :: ce, te ! tile list elements
  integer, allocatable :: idx(:)   ! integer compressed index of tiles
  integer :: i,j,k,n

  ! count total number of tiles in this domain
  ce = first_elmt(lnd%tile_map, lnd%is, lnd%js)
  te = tail_elmt (lnd%tile_map)
  n  = 0
  do while (ce/=te)
     if (tile_exists(current_tile(ce))) n = n+1
     ce=next_elmt(ce)
  end do
  
  ! calculate compressed tile index to be written to the restart file;
  allocate(idx(max(n,1))); idx(:) = -1 ! set init value to a known invalid index
  ce = first_elmt(lnd%tile_map, lnd%is, lnd%js)
  n = 1
  do while (ce/=te)
     call get_elmt_indices(ce,i,j,k)
     
     if(tile_exists(current_tile(ce))) then
        idx (n) = (k-1)*lnd%nlon*lnd%nlat + (j-1)*lnd%nlon + (i-1)
        n = n+1
     endif
     ce=next_elmt(ce)
  end do
  ! create tile output file, defining horizontal coordinate and compressed
  ! dimension
  call create_tile_out_file_idx(ncid, name, glon, glat, idx, tile_dim_length, reserve)

  if (present(created)) created = .true.
  
end subroutine

! ============================================================================
! given compressed index, sizes of the global grid, 2D array of tile lists
! and the lower boundaries of this array returns a pointer to the tile
! corresponding to the compressed index, or NULL is the index is outside 
! current domain, or such tile does not exist.
subroutine get_tile_by_idx(idx,nlon,nlat,tiles,is,js,ptr)
   integer, intent(in) :: idx ! index
   integer, intent(in) :: nlon, nlat
   integer, intent(in) :: is, js
   type(land_tile_list_type), intent(in) :: tiles(is:,js:)
   type(land_tile_type), pointer :: ptr

   ! ---- local vars
   integer :: i,j,k
   type(land_tile_enum_type) :: ce,te
   
   ptr=>null()

   if(idx<0) return ! negative indices do not correspond to any tile

   ! given tile idx, calculate global lon, lat, and tile indices
   k = idx
   i = modulo(k,nlon)+1 ; k = k/nlon
   j = modulo(k,nlat)+1 ; k = k/nlat
   ! do nothing if the indices is outside of our domain
   if (i<is.or.i>is+size(tiles,1)-1) return ! skip points outside of domain
   if (j<js.or.j>js+size(tiles,2)-1) return ! skip points outside of domain
   ! loop through the list of tiles at the given point to find k+1st tile
   ce = first_elmt (tiles(i,j))
   te = tail_elmt  (tiles(i,j))
   do while(ce/=te.and.k>0)
     ce=next_elmt(ce); k = k-1
   enddo
   ! set the returned pointer   
   ! NOTE that if (ce==te) at the end of the loop (that is, there are less
   ! tiles in the list then requested by the idx), current_tile(ce) returns
   ! NULL
   ptr=>current_tile(ce)
   
end subroutine


! ============================================================================
! given the netcdf file id, name of the variable, and accessor subroutine, this
! subroutine reads integer 2D data (a scalar value per grid cell, that's why 
! there is 0d in the name of this subroutine) and assigns the input values to 
! each tile in respective grid cell.  
subroutine read_tile_data_i0d_fptr(ncid,name,fptr)
   integer     , intent(in) :: ncid ! netcdf file id
   character(*), intent(in) :: name ! name of the variable to read
   ! subroutine returning the pointer to the data to be written
   interface ; subroutine fptr(tile, ptr)
      use land_tile_mod, only : land_tile_type
      type(land_tile_type), pointer :: tile ! input
      integer             , pointer :: ptr  ! returned pointer to the data
    end subroutine fptr 
   end interface
   
   ! ---- local constants
   character(*), parameter :: module_name='read_tile_data_i0d_fptr'
   ! ---- local vars
   integer :: ndims     ! number of the variable dimensions
   integer :: dimids(1) ! IDs of the variable dimensions
   integer :: dimlen(1) ! size of the variable dimensions
   character(NF_MAX_NAME) :: idxname ! name of the index variable
   integer, allocatable :: idx(:) ! storage for compressed index 
   integer, allocatable :: x1d(:) ! storage for the data
   integer :: i,j,bufsize
   integer :: varid, idxid
   type(land_tile_type), pointer :: tileptr ! pointer to tile   
   integer, pointer :: ptr
   
   ! get the number of variable dimensions, and their lengths
   __NF_ASRT__(nfu_inq_var(ncid,name,id=varid,ndims=ndims,dimids=dimids,dimlens=dimlen))
   if(ndims/=1) then
      call error_mesg(module_name,'variable "'//trim(name)//'" has incorrect number of dimensions -- must be 1-dimensional', FATAL)
   endif
   ! get the name of compressed dimension and ID of corresponding variable
   __NF_ASRT__(nfu_inq_dim(ncid,dimids(1),idxname))
   __NF_ASRT__(nfu_inq_var(ncid,idxname,id=idxid))
   ! allocate input buffers for compression index and the variable
   bufsize = min(input_buf_size,dimlen(1))
   allocate(idx(bufsize),x1d(bufsize))
   ! read the input buffer-by-buffer
   do j = 1,dimlen(1),bufsize
      ! read the index variable
      __NF_ASRT__(nf_get_vara_int(ncid,idxid,(/j/),(/min(bufsize,dimlen(1)-j+1)/),idx))
      ! read the data
      __NF_ASRT__(nf_get_vara_int(ncid,varid,(/j/),(/min(bufsize,dimlen(1)-j+1)/),x1d))
      ! distribute the data over the tiles
      do i = 1, min(input_buf_size,dimlen(1)-j+1)
         call get_tile_by_idx(idx(i),lnd%nlon,lnd%nlat,lnd%tile_map,&
                              lnd%is,lnd%js, tileptr)
         call fptr(tileptr, ptr)
         if(associated(ptr)) ptr = x1d(i)
      enddo
   enddo
   ! release allocated memory
   deallocate(idx,x1d)
end subroutine


! ============================================================================
subroutine read_tile_data_r0d_fptr(ncid,name,fptr)
   integer     , intent(in) :: ncid ! netcdf file id
   character(*), intent(in) :: name ! name of the variable to read
   ! subroutine returning the pointer to the data to be written
   interface ; subroutine fptr(tile, ptr)
      use land_tile_mod, only : land_tile_type
      type(land_tile_type), pointer :: tile ! input
      real                , pointer :: ptr  ! returned pointer to the data
   end subroutine fptr
   end interface
   
   ! ---- local constants
   character(*), parameter :: module_name='read_tile_data_r0d_fptr'
   ! ---- local vars
   integer :: ndims     ! number of the variable dimensions
   integer :: dimids(1) ! IDs of the variable dimensions
   integer :: dimlen(1) ! size of the variable dimensions
   character(NF_MAX_NAME) :: idxname ! name of the index variable
   integer, allocatable :: idx(:) ! storage for compressed index 
   real   , allocatable :: x1d(:) ! storage for the data
   integer :: i, j, bufsize
   integer :: varid, idxid
   type(land_tile_type), pointer :: tileptr ! pointer to tile   
   real, pointer :: ptr
   
   ! get the number of variable dimensions, and their lengths
   __NF_ASRT__(nfu_inq_var(ncid,name,id=varid,ndims=ndims,dimids=dimids,dimlens=dimlen))
   if(ndims/=1) then
      call error_mesg(module_name,'variable "'//trim(name)//'" has incorrect number of dimensions -- must be 1-dimensional', FATAL)
   endif
   ! get the name of compressed dimension and ID of corresponding variable
   __NF_ASRT__(nfu_inq_dim(ncid,dimids(1),idxname))
   __NF_ASRT__(nfu_inq_var(ncid,idxname,id=idxid))
   ! allocate input buffers for compression index and the variable
   bufsize=min(input_buf_size,dimlen(1))
   allocate(idx(bufsize),x1d(bufsize))
   ! read the input buffer-by-buffer
   do j = 1,dimlen(1),bufsize
      ! read the index variable
      __NF_ASRT__(nf_get_vara_int(ncid,idxid,(/j/),(/min(bufsize,dimlen(1)-j+1)/),idx))
      ! read the data
      __NF_ASRT__(nf_get_vara_double(ncid,varid,(/j/),(/min(bufsize,dimlen(1)-j+1)/),x1d))
      ! distribute the data over the tiles
      do i = 1, min(bufsize,dimlen(1)-j+1)
         call get_tile_by_idx(idx(i),lnd%nlon,lnd%nlat,lnd%tile_map,&
                              lnd%is,lnd%js, tileptr)
         call fptr(tileptr, ptr)
         if(associated(ptr)) ptr = x1d(i)
      enddo
   enddo
   ! release allocated memory
   deallocate(idx,x1d)
end subroutine

! ============================================================================
subroutine read_tile_data_r1d_fptr_all(ncid,name,fptr)
   integer     , intent(in) :: ncid ! netcdf file id
   character(*), intent(in) :: name ! name of the variable to read
   ! subroutine returning the pointer to the data to be written
   interface ; subroutine fptr(tile, ptr)
      use land_tile_mod, only : land_tile_type
      type(land_tile_type), pointer :: tile ! input
      real                , pointer :: ptr(:) ! returned pointer to the data
   end subroutine fptr
   end interface
   
   ! ---- local constants
   character(*), parameter :: module_name='read_tile_data_r1d_fptr'
   ! ---- local vars
   integer :: ndims     ! number of the variable dimensions
   integer :: dimids(2) ! IDs of the variable dimensions
   integer :: dimlen(2) ! size of the variable dimensions
   character(NF_MAX_NAME) :: idxname ! name of the index variable
   integer, allocatable :: idx(:)   ! storage for compressed index 
   real   , allocatable :: x1d(:)   ! storage for the data
   integer :: i, j, bufsize
   integer :: varid,idxid
   integer :: start(2), count(2) ! input slab parameters
   type(land_tile_type), pointer :: tileptr ! pointer to tile   
   real, pointer :: ptr(:)
   
   ! get the number of variable dimensions, and their lengths
   __NF_ASRT__(nfu_inq_var(ncid,name,id=varid,ndims=ndims,dimids=dimids,dimlens=dimlen))
   if(ndims/=2) then
      call error_mesg(module_name,'variable "'//trim(name)//'" has incorrect number of dimensions -- must be 2-dimensional', FATAL)
   endif
   ! get the name of compressed dimension and ID of corresponding variable
   __NF_ASRT__(nfu_inq_dim(ncid,dimids(1),idxname))
   __NF_ASRT__(nfu_inq_var(ncid,idxname,id=idxid))
   ! allocate input buffers for compression index and the variable
   bufsize=min(input_buf_size,dimlen(1))
   allocate(idx(bufsize),x1d(bufsize*dimlen(2)))
   ! read the input buffer-by-buffer
   do j = 1,dimlen(1),bufsize
      ! set up slab parameters
      start(1) = j ; count(1) = min(bufsize,dimlen(1)-j+1)
      start(2) = 1 ; count(2) = dimlen(2)
      ! read the index variable
      __NF_ASRT__(nf_get_vara_int(ncid,idxid,start(1),count(1),idx))
      ! read the data
      __NF_ASRT__(nf_get_vara_double(ncid,varid,start,count,x1d))
      ! distribute the data over the tiles
      do i = 1, min(bufsize,dimlen(1)-j+1)
         call get_tile_by_idx(idx(i),lnd%nlon,lnd%nlat,lnd%tile_map,&
                              lnd%is,lnd%js, tileptr)
         call fptr(tileptr, ptr)
         if(associated(ptr)) ptr(:) = x1d(i:count(1)*count(2):count(1))
      enddo
   enddo
   ! release allocated memory
   deallocate(idx,x1d)
end subroutine


! ============================================================================
subroutine read_tile_data_r1d_fptr_idx (ncid,name,fptr,index)
   integer     , intent(in) :: ncid ! netcdf file id
   character(*), intent(in) :: name ! name of the variable to read
   ! subroutine returning the pointer to the data to be written
   interface ; subroutine fptr(tile, ptr)
      use land_tile_mod, only : land_tile_type
      type(land_tile_type), pointer :: tile ! input
      real                , pointer :: ptr(:) ! returned pointer to the data
   end subroutine fptr 
   end interface
   integer    , intent(in) :: index ! index where to read the data
   
   ! ---- local constants
   character(*), parameter :: module_name='read_tile_data_r0d_fptr'
   ! ---- local vars
   integer :: ndims     ! number of the variable dimensions
   integer :: dimids(1) ! IDs of the variable dimensions
   integer :: dimlen(1) ! size of the variable dimensions
   character(NF_MAX_NAME) :: idxname ! name of the index variable
   integer, allocatable :: idx(:) ! storage for compressed index 
   real   , allocatable :: x1d(:) ! storage for the data
   integer :: i,j,bufsize
   integer :: varid, idxid
   type(land_tile_type), pointer :: tileptr ! pointer to tile   
   real, pointer :: ptr(:)
   
   ! get the number of variable dimensions, and their lengths
   __NF_ASRT__(nfu_inq_var(ncid,name,id=varid,ndims=ndims,dimids=dimids,dimlens=dimlen))
   if(ndims/=1) then
      call error_mesg(module_name,'variable "'//trim(name)//'" has incorrect number of dimensions -- must be 1-dimensional', FATAL)
   endif
   ! get the name of compressed dimension and ID of corresponding variable
   __NF_ASRT__(nfu_inq_dim(ncid,dimids(1),idxname))
   __NF_ASRT__(nfu_inq_var(ncid,idxname,id=idxid))
   ! allocate input buffers for compression index and the variable
   bufsize=min(input_buf_size,dimlen(1))
   allocate(idx(bufsize),x1d(bufsize))
   ! read the input buffer-by-buffer
   do j = 1,dimlen(1),bufsize
      ! read the index variable
      __NF_ASRT__(nf_get_vara_int(ncid,idxid,(/j/),(/min(bufsize,dimlen(1)-j+1)/),idx))
      ! read the data
      __NF_ASRT__(nf_get_vara_double(ncid,varid,(/j/),(/min(bufsize,dimlen(1)-j+1)/),x1d))
      ! distribute the data over the tiles
      do i = 1, min(bufsize,dimlen(1)-j+1)
         call get_tile_by_idx(idx(i),lnd%nlon,lnd%nlat,lnd%tile_map,&
                              lnd%is,lnd%js, tileptr)
         call fptr(tileptr, ptr)
         if(associated(ptr)) ptr(index) = x1d(i)
      enddo
   enddo
   ! release allocated memory
   deallocate(idx,x1d)
end subroutine


! ============================================================================
! The subroutines write_tile_data_* below write tiled data (that is, data provided
! in arrays congruous with current tiling) to NetCDF files using "compression
! by gathering" (see CF conventions). They assume that the compressed dimension
! is already created, has certain name (see parameter "tile_index_name" at the beginning
! of this file), and has length equal to the number of actually used tiles in the 
! current domain.

! ============================================================================
! writes out 1-d integer tiled data using "compression by gathering"
subroutine write_tile_data_i1d(ncid,name,data,mask,long_name,units)
  integer         , intent(in) :: ncid
  character(len=*), intent(in) :: name
  integer         , intent(inout) :: data(:) ! data to write
  integer         , intent(inout) :: mask(:) ! mask of valid data
  character(len=*), intent(in), optional :: units, long_name
  ! data and mask are "inout" to save the memory on send-receive buffers. On the
  ! root io_domain PE mask is destroyed and data is filled with the information 
  ! from other PEs in our io_domain. On other PEs these arrays reman intact.

  ! local vars
  integer :: varid,iret,p
  integer, allocatable :: buffer(:) ! data buffers

  ! if our PE doesn't do io (that is, it isn't the root io_domain processor),  
  ! simply send the data and mask of valid data to the root IO processor
  if (mpp_pe()/=lnd%io_pelist(1)) then
     call mpp_send(data(1), plen=size(data), to_pe=lnd%io_pelist(1), tag=COMM_TAG_3)
     call mpp_send(mask(1), plen=size(data), to_pe=lnd%io_pelist(1), tag=COMM_TAG_4)
  else
     ! gather data and masks from all processors in io_domain
     allocate(buffer(size(data)))
     do p = 2,size(lnd%io_pelist)
        call mpp_recv(buffer(1), glen=size(data), from_pe=lnd%io_pelist(p), tag=COMM_TAG_3)
        call mpp_recv(mask(1),   glen=size(data), from_pe=lnd%io_pelist(p), tag=COMM_TAG_4)
        where (mask>0) data = buffer
     enddo
     ! clean up allocated memory
     deallocate(buffer)
   
     ! create variable, if it does not exist
     if(nf_inq_varid(ncid,name,varid)/=NF_NOERR) then
        __NF_ASRT__(nfu_def_var(ncid,name,NF_INT,(/tile_index_name/),long_name,units,varid))
     endif
     ! write data
     iret = nf_enddef(ncid) ! ignore errors (file may be in data mode already)
     __NF_ASRT__(nf_put_var_int(ncid,varid,data))
  endif
  ! wait for all PEs to finish: necessary because mpp_send doesn't seem to 
  ! copy the data, and therefore on non-root io_domain PE there would be a chance
  ! that the data and mask are destroyed before they are actually sent.
  call mpp_sync()
end subroutine


! ============================================================================
! writes out 1-d real tiled data using "compression by gathering"
subroutine write_tile_data_r1d(ncid,name,data,mask,long_name,units)
  integer         , intent(in) :: ncid    ! netcdf ID
  character(len=*), intent(in) :: name    ! name of the variable
  real            , intent(inout) :: data(:) ! data to write
  integer         , intent(inout) :: mask(:) ! mask of valid data
  character(len=*), intent(in), optional :: units, long_name ! attributes
  ! data and mask are "inout" to save the memory on send-receive buffers. On the
  ! root io_domain PE mask is destroyed and data is filled with the information 
  ! from other PEs in our io_domain. On other PEs these arrays reman intact.

  ! ---- local vars
  integer :: varid,iret,p
  real,    allocatable :: buffer(:) ! data buffer

  ! if our PE doesn't do io (that is, it isn't the root io_domain processor),  
  ! simply send the data and mask of valid data to the root IO processor
  if (mpp_pe()/=lnd%io_pelist(1)) then
     call mpp_send(data(1), plen=size(data), to_pe=lnd%io_pelist(1), tag=COMM_TAG_5)
     call mpp_send(mask(1), plen=size(data), to_pe=lnd%io_pelist(1), tag=COMM_TAG_6)
  else
     ! gather data and masks from the processors in io_domain
     allocate(buffer(size(data)))
     do p = 2,size(lnd%io_pelist)
        call mpp_recv(buffer(1), glen=size(data), from_pe=lnd%io_pelist(p), tag=COMM_TAG_5)
        call mpp_recv(mask(1),   glen=size(data), from_pe=lnd%io_pelist(p), tag=COMM_TAG_6)
        where(mask>0) data = buffer
     enddo
     ! clean up allocated memory
     deallocate(buffer)
     
     ! create variable, if it does not exist
     if(nf_inq_varid(ncid,name,varid)/=NF_NOERR) then
        __NF_ASRT__(nfu_def_var(ncid,name,NF_DOUBLE,(/tile_index_name/),long_name,units,varid))
     endif
     ! write data
     iret = nf_enddef(ncid) ! ignore errors (file may be in data mode already)
     __NF_ASRT__(nf_put_var_double(ncid,varid,data))
  endif
  ! wait for all PEs to finish: necessary because mpp_send doesn't seem to 
  ! copy the data, and therefore on non-root io_domain PE there would be a chance
  ! that the data and mask are destroyed before they are actually sent.
  call mpp_sync()
end subroutine


! ============================================================================
! writes out 2-d real tiled data using "compression by gathering". The dimension
! of the data is (tile,z), and both tile and z dimensions are assumed to be 
! already created
subroutine write_tile_data_r2d(ncid,name,data,mask,zdim,long_name,units)
  integer         , intent(in) :: ncid ! netcdf id
  character(len=*), intent(in) :: name ! name of the variable to write
  character(len=*), intent(in) :: zdim ! name of the z-dimension
  real            , intent(inout) :: data(:,:) ! (tile,z)
  integer         , intent(inout) :: mask(:) ! mask of valid data
  character(len=*), intent(in), optional :: units, long_name
  ! data and mask are "inout" to save the memory on send-receive buffers. On the
  ! root io_domain PE mask is destroyed and data is filled with the information 
  ! from other PEs in our io_domain. On other PEs these arrays reman intact.

  ! local vars
  integer :: varid,iret,p,i
  character(NF_MAX_NAME)::dimnames(2)
  real, allocatable :: buffer(:,:) ! send/receive buffer

  ! if our PE doesn't do io (that is, it isn't the root io_domain processor),  
  ! simply send the data and mask of valid data to the root IO processor
  if (mpp_pe()/=lnd%io_pelist(1)) then
     call mpp_send(data(1,1), plen=size(data),   to_pe=lnd%io_pelist(1), tag=COMM_TAG_7)
     call mpp_send(mask(1),   plen=size(data,1), to_pe=lnd%io_pelist(1), tag=COMM_TAG_8)
  else
     allocate(buffer(size(data,1),size(data,2)))
     ! gather data and masks from the processors in our io_domain
     do p = 2,size(lnd%io_pelist)
        call mpp_recv(buffer(1,1), glen=size(data),   from_pe=lnd%io_pelist(p), tag=COMM_TAG_7)
        call mpp_recv(mask(1),     glen=size(data,1), from_pe=lnd%io_pelist(p), tag=COMM_TAG_8)
        do i=1,size(data,1)
           if(mask(i)>0) data(i,:) = buffer(i,:)
        enddo
     enddo
     ! clean up allocated memory
     deallocate(buffer)
   
     ! create variable, if it does not exist
     if(nf_inq_varid(ncid,name,varid)/=NF_NOERR) then
        dimnames(1) = tile_index_name
        dimnames(2) = zdim
        __NF_ASRT__(nfu_def_var(ncid,name,NF_DOUBLE,dimnames,long_name,units,varid))
     endif
     ! write data
     iret = nf_enddef(ncid) ! ignore errors: its OK if file is in data mode already
     __NF_ASRT__(nf_put_var_double(ncid,varid,data))
  endif
  ! wait for all PEs to finish: necessary because mpp_send doesn't seem to 
  ! copy the data, and therefore on non-root io_domain PE there would be a chance
  ! that the data and mask are destroyed before they are actually sent.
  call mpp_sync()
end subroutine


! ============================================================================
subroutine write_tile_data_i0d_fptr(ncid,name,fptr,long_name,units)
  integer         , intent(in) :: ncid ! netcdf id
  character(len=*), intent(in) :: name ! name of the variable to write
  character(len=*), intent(in), optional :: units, long_name
  ! subroutine returning the pointer to the data to be written
  interface ; subroutine fptr(tile, ptr)
     use land_tile_mod, only : land_tile_type
     type(land_tile_type), pointer :: tile ! input
     integer             , pointer :: ptr  ! returned pointer to the data
  end subroutine fptr
  end interface
  
  ! ---- local vars
  integer, allocatable :: idx(:)    ! index dimension
  integer, allocatable :: data(:)   ! data to be written
  integer, allocatable :: mask(:)   ! mask of valid data
  type(land_tile_type), pointer :: tileptr ! pointer to tile
  integer, pointer     :: ptr ! pointer to the tile data
  integer :: ntiles  ! total number of tiles (length of compressed dimension)
  integer :: i

  ! get the size of the output array. Note that at this point the variable
  ! might not yet exist, so we can't use nfu_inq_var
  __NF_ASRT__(nfu_inq_dim(ncid,tile_index_name,len=ntiles))

  ! allocate data
  allocate(data(ntiles),idx(ntiles), mask(ntiles))
  ! fill the data with initial values. This is for the case when some of the
  ! compressed tile indices are invalid, so that corresponding indices of the
  ! array are skipped in the loop below. The invalid indices occur when a restart
  ! is written for the domain where no tiles exist, e.g. the ocean-covered 
  ! region
  data = NF_FILL_INT
  mask = 0

  ! read tile index
  i = nf_enddef(ncid) ! ignore errors (file may be in data mode already)
  __NF_ASRT__(nfu_get_var(ncid,tile_index_name,idx))

  ! gather data into an array along the tile dimension. It is assumed that 
  ! the tile dimension spans all the tiles that need to be written.
  do i = 1, size(idx)
     call get_tile_by_idx(idx(i),lnd%nlon,lnd%nlat,lnd%tile_map,&
                          lnd%is,lnd%js, tileptr)
     call fptr(tileptr, ptr)
     if(associated(ptr)) then
        data(i) = ptr
        mask(i) = 1
     endif
  enddo

  ! write data
  call write_tile_data_i1d(ncid,name,data,mask,long_name,units)
  
  ! release allocated memory
  deallocate(data,idx,mask)
end subroutine


! ============================================================================
subroutine write_tile_data_r0d_fptr(ncid,name,fptr,long_name,units)
  integer         , intent(in) :: ncid ! netcdf id
  character(len=*), intent(in) :: name ! name of the variable to write
  character(len=*), intent(in), optional :: units, long_name
  ! subroutine returning the pointer to the data to be written
  interface ; subroutine fptr(tile, ptr)
     use land_tile_mod, only : land_tile_type
     type(land_tile_type), pointer :: tile ! input
     real                , pointer :: ptr  ! returned pointer to the data
  end subroutine fptr
  end interface
  
  ! ---- local vars
  integer, allocatable :: mask(:)   ! mask of valid data
  integer, allocatable :: idx(:)    ! index dimension
  real   , allocatable :: data(:)   ! data to be written
  type(land_tile_type), pointer :: tileptr ! pointer to tiles
  real   , pointer :: ptr ! pointer to the tile data
  integer :: ntiles  ! total number of tiles (length of compressed dimension)
  integer :: i
  
  ! get the size of the output array. Note that at this point the variable
  ! might not yet exist, so we can't use nfu_inq_var
  __NF_ASRT__(nfu_inq_dim(ncid,tile_index_name,len=ntiles))

  ! allocate data
  allocate(data(ntiles),idx(ntiles),mask(ntiles))
  data = NF_FILL_DOUBLE
  mask = 0

  ! read tile index
  i = nf_enddef(ncid) ! ignore errors (file may be in data mode already)
  __NF_ASRT__(nfu_get_var(ncid,tile_index_name,idx))

  ! gather data into an array along the tile dimension. It is assumed that 
  ! the tile dimension spans all the tiles that need to be written.
  do i = 1, size(idx)
     call get_tile_by_idx(idx(i),lnd%nlon,lnd%nlat,lnd%tile_map,&
                          lnd%is,lnd%js, tileptr)
     call fptr(tileptr, ptr)
     if(associated(ptr)) then
        data(i) = ptr
        mask(i) = 1
     endif
  enddo

  ! write data
  call write_tile_data_r1d(ncid,name,data,mask,long_name,units)

  ! free allocated memory
  deallocate(data,idx,mask)
end subroutine


! ============================================================================
subroutine write_tile_data_r1d_fptr_all(ncid,name,fptr,zdim,long_name,units)
  integer         , intent(in) :: ncid ! netcdf id
  character(len=*), intent(in) :: name ! name of the variable to write
  character(len=*), intent(in) :: zdim ! name of the z-dimension
  character(len=*), intent(in), optional :: units, long_name
  ! subroutine returning the pointer to the data to be written
  interface ; subroutine fptr(tile, ptr)
     use land_tile_mod, only : land_tile_type
     type(land_tile_type), pointer :: tile ! input
     real                , pointer :: ptr(:) ! returned pointer to the data
  end subroutine fptr
  end interface
  
  ! ---- local vars
  integer, allocatable :: idx(:)    ! index dimension
  real   , allocatable :: data(:,:) ! data to be written
  integer, allocatable :: mask(:)   ! mask of valid data
  type(land_tile_type), pointer :: tileptr ! pointer to tiles
  real   , pointer :: ptr(:) ! pointer to the tile data
  integer :: ntiles  ! total number of tiles (length of compressed dimension)
  integer :: i
  integer :: nlev ! number of levels of the output variable
  
  ! get the size of the output array. Note that at this point the variable
  ! might not yet exist, so we can't use nfu_inq_var
  __NF_ASRT__(nfu_inq_dim(ncid,tile_index_name,len=ntiles))
  __NF_ASRT__(nfu_inq_dim(ncid,zdim,len=nlev))

  ! allocate data
  allocate(data(ntiles,nlev),idx(ntiles),mask(ntiles))
  data = NF_FILL_DOUBLE
  mask = 0

  ! read tile index
  i = nf_enddef(ncid) ! ignore errors (file may be in data mode already)
  __NF_ASRT__(nfu_get_var(ncid,tile_index_name,idx))

  ! gather data into an array along the tile dimension. It is assumed that 
  ! the tile dimension spans all the tiles that need to be written.
  do i = 1, size(idx)
     call get_tile_by_idx(idx(i),lnd%nlon,lnd%nlat,lnd%tile_map,&
                          lnd%is,lnd%js, tileptr)
     call fptr(tileptr, ptr)
     if(associated(ptr)) then
        data(i,:) = ptr(:)
        mask(i) = 1
     endif
  enddo

  ! write data
  call write_tile_data_r2d(ncid,name,data,mask,zdim,long_name,units)
  
  ! free allocated memory
  deallocate(data,idx)
  
end subroutine


! ============================================================================
subroutine write_tile_data_r1d_fptr_idx(ncid,name,fptr,index,long_name,units)
  integer         , intent(in) :: ncid  ! netcdf id
  character(len=*), intent(in) :: name  ! name of the variable to write
  integer         , intent(in) :: index ! index of the fptr array element to 
                                        ! write out
  character(len=*), intent(in), optional :: units, long_name
  ! subroutine returning the pointer to the data to be written
  interface ; subroutine fptr(tile, ptr)
     use land_tile_mod, only : land_tile_type
     type(land_tile_type), pointer :: tile ! input
     real                , pointer :: ptr(:) ! returned pointer to the data
  end subroutine fptr 
  end interface
  
  ! ---- local vars
  integer, allocatable :: idx(:)    ! index dimension
  real   , allocatable :: data(:)   ! data to be written
  integer, allocatable :: mask(:)   ! mask of valid data
  type(land_tile_type), pointer :: tileptr ! pointer to tiles
  real   , pointer :: ptr(:) ! pointer to the tile data
  integer :: ntiles  ! total number of tiles (length of compressed dimension)
  integer :: i

  ! get the size of the output array. Note that at this point the variable
  ! might not yet exist, so we can't use nfu_inq_var
  __NF_ASRT__(nfu_inq_dim(ncid,tile_index_name,len=ntiles))

  ! allocate data
  allocate(data(ntiles),idx(ntiles),mask(ntiles))
  data = NF_FILL_DOUBLE
  mask = 0

  ! read tile index
  i = nf_enddef(ncid) ! ignore errors (file may be in data mode already)
  __NF_ASRT__(nfu_get_var(ncid,tile_index_name,idx))

  ! gather data into an array along the tile dimension. It is assumed that 
  ! the tile dimension spans all the tiles that need to be written.
  do i = 1, size(idx)
     call get_tile_by_idx(idx(i),lnd%nlon,lnd%nlat,lnd%tile_map,&
                          lnd%is,lnd%js, tileptr)
     call fptr(tileptr, ptr)
     if(associated(ptr)) then
        data(i) = ptr(index)
        mask(i) = 1
     endif
  enddo

  ! write data
  call write_tile_data_r1d(ncid,name,data,mask,long_name,units)

  ! free allocated memory
  deallocate(data,idx)
end subroutine


! ============================================================================
subroutine override_tile_data_r0d_fptr(fieldname,fptr,time,override)
  character(len=*), intent(in)   :: fieldname ! field to override
  type(time_type),  intent(in)   :: time      ! model time
  logical, optional, intent(out) :: override  ! true if the field has been 
                                              ! overridden successfully
  ! subroutine returning the pointer to the data to be overridden
  interface ; subroutine fptr(tile, ptr)
     use land_tile_mod, only : land_tile_type
     type(land_tile_type), pointer :: tile ! input
     real                , pointer :: ptr  ! returned pointer to the data
  end subroutine fptr
  end interface

  ! ---- local vars
  real    :: data2D(lnd%is:lnd%ie,lnd%js:lnd%je) ! storage for the input data
  logical :: override_
  
  call data_override('LND',fieldname,data2D, time, override_ )
  if(present(override)) override=override_
  if(.not.override_) return ! do nothing if the field was not overridden 

  ! distribute the data over the tiles
  call put_to_tiles_r0d_fptr(data2d,lnd%tile_map,fptr)
  
end subroutine

! =============================================================================
! given netcdf ID, synchronizes the definitions between writing and reading 
! processors
subroutine sync_nc_files(ncid)
  integer, intent(in) :: ncid

  integer :: iret

  if(mpp_pe()==lnd%io_pelist(1)) then
     iret = nf_enddef(ncid)
     ! commit possible definition changes and data to the disk
     __NF_ASRT__(nf_sync(ncid))
  endif
  call mpp_sync()
  if(mpp_pe()/=lnd%io_pelist(1)) then
     ! synchronize in-memory data structures with the changes on the disk
    __NF_ASRT__(nf_sync(ncid))
  endif
end subroutine sync_nc_files

end module

#include "cosp_defs.H" 
#ifdef COSP_GFDL
!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: lmd_ipsl_stats.F90,v 20.0 2013/12/13 23:15:58 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2
 
#endif
! Copyright (c) 2009, Centre National de la Recherche Scientifique
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without modification, are permitted
! provided that the following conditions are met:
!
!     * Redistributions of source code must retain the above copyright notice, this list
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials
!       provided with the distribution.
!     * Neither the name of the LMD/IPSL/CNRS/UPMC nor the names of its
!       contributors may be used to endorse or promote products derived from this software without
!       specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


!------------------------------------------------------------------------------------
! Authors: Sandrine Bony and Helene Chepfer (LMD/IPSL, CNRS, UPMC, France).
!------------------------------------------------------------------------------------
MODULE MOD_LMD_IPSL_STATS
  USE MOD_LLNL_STATS

#ifdef COSP_GFDL
  use mod_cosp_constants, only : SR_BINS, LIDAR_UNDEF
#endif

  IMPLICIT NONE

#ifdef COSP_GFDL
!RSH  the following are made module variables so they can be used by both 
!     cosp_cfad_sr and define_srbval, which is called from cosp_driver_init
!     to define netcdf axes.
! c threshold for cloud detection :
   real S_clr
   parameter (S_clr = 1.2)
   real S_cld
!      parameter (S_cld = 3.0)  ! Previous thresold for cloud detection
   parameter (S_cld = 5.0)  ! New (dec 2008) thresold for cloud detection
   real S_att
   parameter (S_att = 0.01)
#endif

CONTAINS
      SUBROUTINE diag_lidar(npoints,ncol,llm,max_bin,nrefl &
                  ,pnorm,pmol,refl,land,pplay,undef,ok_lidar_cfad &
                  ,cfad2,srbval &
                  ,ncat,lidarcld,cldlayer,parasolrefl)
!
! -----------------------------------------------------------------------------------
! Lidar outputs :
!
! Diagnose cloud fraction (3D cloud fraction + low/middle/high/total cloud fraction
! from the lidar signals (ATB and molecular ATB) computed from model outputs
!      +
! Compute CFADs of lidar scattering ratio SR and of depolarization index
!
! Authors: Sandrine Bony and Helene Chepfer (LMD/IPSL, CNRS, UPMC, France).
!
! December 2008, S. Bony,  H. Chepfer and J-L. Dufresne :
! - change of the cloud detection threshold S_cld from 3 to 5, for better
! with both day and night observations. The optical thinest clouds are missed.
! - remove of the detection of the first fully attenuated layer encountered from above.
! December 2008, A. Bodas-Salcedo:
! - Dimensions of pmol reduced to (npoints,llm)
! August 2009, A. Bodas-Salcedo:
! - Warning message regarding PARASOL being valid only over ocean deleted.
! February 2010, A. Bodas-Salcedo:
! - Undef passed into cosp_cfad_sr
! June 2010, T. Yokohata, T. Nishimura and K. Ogochi
! Optimisation of COSP_CFAD_SR
!
! Version 1.0 (June 2007)
! Version 1.1 (May 2008)
! Version 1.2 (June 2008)
! Version 2.0 (October 2008)
! Version 2.1 (December 2008)
! c------------------------------------------------------------------------------------

! c inputs :
      integer npoints
      integer ncol
      integer llm
      integer max_bin               ! nb of bins for SR CFADs
      integer ncat                  ! nb of cloud layer types (low,mid,high,total)
      integer nrefl                 ! nb of solar zenith angles for parasol reflectances

      real undef                    ! undefined value
      real pnorm(npoints,ncol,llm)  ! lidar ATB
      real pmol(npoints,llm)        ! molecular ATB
      real land(npoints)            ! Landmask [0 - Ocean, 1 - Land]
      real pplay(npoints,llm)       ! pressure on model levels (Pa)
      logical ok_lidar_cfad         ! true if lidar CFAD diagnostics need to be computed
      real refl(npoints,ncol,nrefl) ! subgrid parasol reflectance ! parasol

! c outputs :
      real lidarcld(npoints,llm)     ! 3D "lidar" cloud fraction
      real cldlayer(npoints,ncat)    ! "lidar" cloud fraction (low, mid, high, total)
      real cfad2(npoints,max_bin,llm) ! CFADs of SR
      real srbval(max_bin)           ! SR bins in CFADs
      real parasolrefl(npoints,nrefl)! grid-averaged parasol reflectance

#ifndef COSP_GFDL
! c threshold for cloud detection :
      real S_clr
      parameter (S_clr = 1.2)
      real S_cld
!      parameter (S_cld = 3.0)  ! Previous thresold for cloud detection
      parameter (S_cld = 5.0)  ! New (dec 2008) thresold for cloud detection
      real S_att
      parameter (S_att = 0.01)
#endif

! c local variables :
      integer ic,k
      real x3d(npoints,ncol,llm)
      real x3d_c(npoints,llm),pnorm_c(npoints,llm)
      real xmax
!
! c -------------------------------------------------------
! c 0- Initializations
! c -------------------------------------------------------
!

!  Should be modified in future version
      xmax=undef-1.0

! c -------------------------------------------------------
! c 1- Lidar scattering ratio :
! c -------------------------------------------------------
!
!       where ((pnorm.lt.xmax) .and. (pmol.lt.xmax) .and. (pmol.gt. 0.0 ))
!          x3d = pnorm/pmol
!       elsewhere
!           x3d = undef
!       end where
! A.B-S: pmol reduced to 2D (npoints,llm) (Dec 08)
      do ic = 1, ncol
        pnorm_c = pnorm(:,ic,:)
        where ((pnorm_c.lt.xmax) .and. (pmol.lt.xmax) .and. (pmol.gt. 0.0 ))
            x3d_c = pnorm_c/pmol
        elsewhere
            x3d_c = undef
        end where
        x3d(:,ic,:) = x3d_c
      enddo

! c -------------------------------------------------------
! c 2- Diagnose cloud fractions (3D, low, middle, high, total)
! c from subgrid-scale lidar scattering ratios :
! c -------------------------------------------------------

      CALL COSP_CLDFRAC(npoints,ncol,llm,ncat,  &
              x3d,pplay, S_att,S_cld,undef,lidarcld, &
              cldlayer)

! c -------------------------------------------------------
! c 3- CFADs
! c -------------------------------------------------------
      if (ok_lidar_cfad) then
!
! c CFADs of subgrid-scale lidar scattering ratios :
! c -------------------------------------------------------
      CALL COSP_CFAD_SR(npoints,ncol,llm,max_bin,undef, &
                 x3d, &
                 S_att,S_clr,xmax,cfad2,srbval)

      endif   ! ok_lidar_cfad
! c -------------------------------------------------------

! c -------------------------------------------------------
! c 4- Compute grid-box averaged Parasol reflectances
! c -------------------------------------------------------

      parasolrefl(:,:) = 0.0

      do k = 1, nrefl
       do ic = 1, ncol
         parasolrefl(:,k) = parasolrefl(:,k) + refl(:,ic,k)
       enddo
      enddo

      do k = 1, nrefl
        parasolrefl(:,k) = parasolrefl(:,k) / float(ncol)
! if land=1 -> parasolrefl=undef
! if land=0 -> parasolrefl=parasolrefl
        parasolrefl(:,k) = parasolrefl(:,k) * MAX(1.0-land(:),0.0) &
                           + (1.0 - MAX(1.0-land(:),0.0))*undef
      enddo

      RETURN
      END SUBROUTINE diag_lidar


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!-------------------- FUNCTION COSP_CFAD_SR ------------------------
! Author: Sandrine Bony (LMD/IPSL, CNRS, Paris)
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      SUBROUTINE COSP_CFAD_SR(Npoints,Ncolumns,Nlevels,Nbins,undef, &
                      x,S_att,S_clr,xmax,cfad,srbval)
      IMPLICIT NONE

!--- Input arguments
! Npoints: Number of horizontal points
! Ncolumns: Number of subcolumns
! Nlevels: Number of levels
! Nbins: Number of x axis bins
! xmax: maximum value allowed for x
! S_att: Threshold for full attenuation
! S_clr: Threshold for clear-sky layer
!
!--- Input-Outout arguments
! x: variable to process (Npoints,Ncolumns,Nlevels), mofified where saturation occurs
!
! -- Output arguments
! srbval : values of the histogram bins
! cfad: 2D histogram on each horizontal point

! Input arguments
      integer Npoints,Ncolumns,Nlevels,Nbins
      real xmax,S_att,S_clr,undef
! Input-output arguments
      real x(Npoints,Ncolumns,Nlevels)
! Output :
      real cfad(Npoints,Nbins,Nlevels)
      real srbval(Nbins)
! Local variables
      integer i, j, k, ib
      real srbval_ext(0:Nbins)

! c -------------------------------------------------------
! c 0- Initializations
! c -------------------------------------------------------
      if ( Nbins .lt. 6) return

#ifdef COSP_GFDL
      call define_srbval (srbval)
#else
      srbval(1) =  S_att
      srbval(2) =  S_clr
      srbval(3) =  3.0
      srbval(4) =  5.0
      srbval(5) =  7.0
      srbval(6) = 10.0
      do i = 7, MIN(10,Nbins)
       srbval(i) = srbval(i-1) + 5.0
      enddo
      DO i = 11, MIN(13,Nbins)
       srbval(i) = srbval(i-1) + 10.0
      enddo
      srbval(MIN(14,Nbins)) = 80.0
      srbval(Nbins) = xmax
#endif

      cfad(:,:,:) = 0.0

      srbval_ext(1:Nbins) = srbval
      srbval_ext(0) = -1.0
! c -------------------------------------------------------
! c c- Compute CFAD
! c -------------------------------------------------------

      do j = 1, Nlevels
         do ib = 1, Nbins
            do k = 1, Ncolumns
               do i = 1, Npoints
                  if (x(i,k,j) /= undef) then
                     if ((x(i,k,j).gt.srbval_ext(ib-1)).and.(x(i,k,j).le.srbval_ext(ib))) &
                          cfad(i,ib,j) = cfad(i,ib,j) + 1.0
                  else 
                     cfad(i,ib,j) = undef
                  endif
               enddo
            enddo
         enddo
      enddo

      where (cfad .ne. undef)  cfad = cfad / float(Ncolumns)

! c -------------------------------------------------------
      RETURN
      END SUBROUTINE COSP_CFAD_SR

#ifdef COSP_GFDL

      subroutine define_srbval (srbval)
 
real, dimension(:), intent(out) :: srbval

     integer :: i, Nbins

     Nbins = SR_BINS

     srbval(1) =  S_att
     srbval(2) =  S_clr
     srbval(3) =  3.0
     srbval(4) =  5.0
     srbval(5) =  7.0
     srbval(6) = 10.0
     do i = 7, MIN(10,Nbins)
      srbval(i) = srbval(i-1) + 5.0
     enddo
     DO i = 11, MIN(13,Nbins)
      srbval(i) = srbval(i-1) + 10.0
     enddo
     srbval(MIN(14,Nbins)) = 80.0
     srbval(Nbins) = LIDAR_UNDEF - 1.0

end subroutine define_srbval

#endif

   
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!-------------------- SUBROUTINE COSP_CLDFRAC -------------------
! c Purpose: Cloud fraction diagnosed from lidar measurements
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      SUBROUTINE COSP_CLDFRAC(Npoints,Ncolumns,Nlevels,Ncat, &
                  x,pplay,S_att,S_cld,undef,lidarcld, &
                  cldlayer)
      IMPLICIT NONE
! Input arguments
      integer Npoints,Ncolumns,Nlevels,Ncat
      real x(Npoints,Ncolumns,Nlevels)
      real pplay(Npoints,Nlevels)
      real S_att,S_cld
      real undef
! Output :
      real lidarcld(Npoints,Nlevels) ! 3D cloud fraction
      real cldlayer(Npoints,Ncat)    ! low, middle, high, total cloud fractions
! Local variables
      integer ip, k, iz, ic
      real p1
      real cldy(Npoints,Ncolumns,Nlevels)
      real srok(Npoints,Ncolumns,Nlevels)
      real cldlay(Npoints,Ncolumns,Ncat)
      real nsublay(Npoints,Ncolumns,Ncat), nsublayer(Npoints,Ncat)
      real nsub(Npoints,Nlevels)
#ifdef SYS_SX
      real cldlay1(Npoints,Ncolumns)
      real cldlay2(Npoints,Ncolumns)
      real cldlay3(Npoints,Ncolumns)
      real nsublay1(Npoints,Ncolumns)
      real nsublay2(Npoints,Ncolumns)
      real nsublay3(Npoints,Ncolumns)
#endif

! ---------------------------------------------------------------
! 1- initialization
! ---------------------------------------------------------------

      if ( Ncat .ne. 4 ) then
         print *,'Error in lmd_ipsl_stats.cosp_cldfrac, Ncat must be 4, not',Ncat
         stop
      endif

      lidarcld = 0.0
      nsub = 0.0
      cldlay = 0.0
      nsublay = 0.0

! ---------------------------------------------------------------
! 2- Cloud detection
! ---------------------------------------------------------------

      do k = 1, Nlevels

! cloud detection at subgrid-scale:
         where ( (x(:,:,k).gt.S_cld) .and. (x(:,:,k).ne. undef) )
           cldy(:,:,k)=1.0
         elsewhere
           cldy(:,:,k)=0.0
         endwhere

! number of usefull sub-columns:
         where ( (x(:,:,k).gt.S_att) .and. (x(:,:,k).ne. undef)  )
           srok(:,:,k)=1.0
         elsewhere
           srok(:,:,k)=0.0
         endwhere

      enddo ! k

! ---------------------------------------------------------------
! 3- grid-box 3D cloud fraction and layered cloud fractions (ISCCP pressure
! categories) :
! ---------------------------------------------------------------
      lidarcld = 0.0
      nsub = 0.0
#ifdef SYS_SX
!! XXX: Use cldlay[1-3] and nsublay[1-3] to avoid bank-conflicts.
      cldlay1 = 0.0
      cldlay2 = 0.0
      cldlay3 = 0.0
      cldlay(:,:,4) = 0.0 !! XXX: Ncat == 4
      nsublay1 = 0.0
      nsublay2 = 0.0
      nsublay3 = 0.0
      nsublay(:,:,4) = 0.0
      do k = Nlevels, 1, -1
       do ic = 1, Ncolumns
        do ip = 1, Npoints
         p1 = pplay(ip,k)

         if ( p1.gt.0. .and. p1.lt.(440.*100.)) then ! high clouds
            cldlay3(ip,ic) = MAX(cldlay3(ip,ic), cldy(ip,ic,k))
            nsublay3(ip,ic) = MAX(nsublay3(ip,ic), srok(ip,ic,k))
         else if(p1.ge.(440.*100.) .and. p1.lt.(680.*100.)) then  ! mid clouds
            cldlay2(ip,ic) = MAX(cldlay2(ip,ic), cldy(ip,ic,k))
            nsublay2(ip,ic) = MAX(nsublay2(ip,ic), srok(ip,ic,k))
         else
            cldlay1(ip,ic) = MAX(cldlay1(ip,ic), cldy(ip,ic,k))
            nsublay1(ip,ic) = MAX(nsublay1(ip,ic), srok(ip,ic,k))
         endif

         cldlay(ip,ic,4) = MAX(cldlay(ip,ic,4), cldy(ip,ic,k))
         lidarcld(ip,k)=lidarcld(ip,k) + cldy(ip,ic,k)
         nsublay(ip,ic,4) = MAX(nsublay(ip,ic,4),srok(ip,ic,k))
         nsub(ip,k)=nsub(ip,k) + srok(ip,ic,k)
        enddo
       enddo
      enddo
      cldlay(:,:,1) = cldlay1
      cldlay(:,:,2) = cldlay2
      cldlay(:,:,3) = cldlay3
      nsublay(:,:,1) = nsublay1
      nsublay(:,:,2) = nsublay2
      nsublay(:,:,3) = nsublay3
#else
      cldlay = 0.0
      nsublay = 0.0
      do k = Nlevels, 1, -1
       do ic = 1, Ncolumns
        do ip = 1, Npoints

          iz=1
          p1 = pplay(ip,k)
          if ( p1.gt.0. .and. p1.lt.(440.*100.)) then ! high clouds
            iz=3
          else if(p1.ge.(440.*100.) .and. p1.lt.(680.*100.)) then  ! mid clouds
            iz=2
         endif

         cldlay(ip,ic,iz) = MAX(cldlay(ip,ic,iz),cldy(ip,ic,k))
         cldlay(ip,ic,4) = MAX(cldlay(ip,ic,4),cldy(ip,ic,k))
         lidarcld(ip,k)=lidarcld(ip,k) + cldy(ip,ic,k)

         nsublay(ip,ic,iz) = MAX(nsublay(ip,ic,iz),srok(ip,ic,k))
         nsublay(ip,ic,4) = MAX(nsublay(ip,ic,4),srok(ip,ic,k))
         nsub(ip,k)=nsub(ip,k) + srok(ip,ic,k)

        enddo
       enddo
      enddo
#endif

! -- grid-box 3D cloud fraction

      where ( nsub(:,:).gt.0.0 )
         lidarcld(:,:) = lidarcld(:,:)/nsub(:,:)
      elsewhere
         lidarcld(:,:) = undef
      endwhere

! -- layered cloud fractions

      cldlayer = 0.0
      nsublayer = 0.0

      do iz = 1, Ncat
       do ic = 1, Ncolumns

          cldlayer(:,iz)=cldlayer(:,iz) + cldlay(:,ic,iz)
          nsublayer(:,iz)=nsublayer(:,iz) + nsublay(:,ic,iz)

       enddo
      enddo
      where ( nsublayer(:,:).gt.0.0 )
         cldlayer(:,:) = cldlayer(:,:)/nsublayer(:,:)
      elsewhere
         cldlayer(:,:) = undef
      endwhere

      RETURN
      END SUBROUTINE COSP_CLDFRAC
! ---------------------------------------------------------------

END MODULE MOD_LMD_IPSL_STATS

module fv_dynamics_mod
  implicit none
  private
  public :: fv_dynamics
contains
!-----------------------------------------------------------------------
!BOP
! !ROUTINE: driver for the finite-volume dynamical core,  
!           MPI in latitudinal direction SMP in (mostly) vertical direction
!
! !INTERFACE:
#ifndef USE_LIMA
  subroutine fv_dynamics(im,   jm,    km,    jfirst, jlast,     &
       nq,   pnats, p_map, consv,             &
       u,    v,     delp,  pt,     q,         &
       ps,   pe,    pk,    pkz,    phis,      &
       omga, peln,  ptop,  om,     ndt,       &
       r_vir, cp,    rg,    cappa,  ae, ua, va, Time_next )

! !USES:
    use fv_pack, only: acap, cosp, sinp, cose, sine, coslon, sinlon,    &
         rcap, acosp, ng_d, ng_s, cosl5, sinl5, f_d,      &
         one_by_dy,  dx,  one_by_dx, u_ghosted, n_split,  &
         iord_mt,  iord_tm, iord_tr,                      &
         jord_mt,  jord_tm, jord_tr,                      &
         kord_mt,  kord_tm, kord_tr,                      &
         tra_step, dyn_step,  fill, master, n_zonal,  &
         use_tendency, &
         ighost, ks, ak, bk, cp_vir, icase

    use mapz_module,    only: te_map, geo_map, benergy, p_energy
    use dyn_core,       only: cd_core

    use pft_module,     only: pft2d
    use timingModule,   only: timing_on, timing_off

#ifdef SPMD
    use mod_comm,       only: gid, mp_send4d_ns, mp_recv4d_ns
#endif
    use time_manager_mod, only: time_type

#else

    subroutine fv_dynamics(im,   jm,    km,    jfirst, jlast,     &
         nq,   pnats, p_map, consv,             &
         u,    v,     delp,  pt,     q,         &
         ps,   pe,    pk,    pkz,    phis,      &
         omga, peln,  ptop,  om,     ndt,       &
         r_vir, cp,    rg,    cappa,  ae, ua, va )

! !USES:
      use fv_pack,        only: acap, cosp, sinp, cose, sine, coslon, sinlon,    &
           rcap, acosp, ng_d, ng_s, cosl5, sinl5, f_d,      &
           one_by_dy,  dx,  one_by_dx, u_ghosted, n_split,  &
           iord_mt,  iord_tm, iord_tr,                      &
           jord_mt,  jord_tm, jord_tr,                      &
           kord_mt,  kord_tm, kord_tr,                      &
           fill, master, ifax, trigs, sc, dc, n_zonal,      &
           use_tendency,    &
           ighost, ks, ak, bk, cp_vir
      use fv_arrays_mod, only: ps_bp, u_phys, v_phys, t_phys, q_phys
      use mapz_module,    only: te_map, geo_map, benergy, p_energy
      use dyn_core,       only: cd_core

      use pft_module,     only: fftfax, pft2d
      use timingModule,   only: timing_on, timing_off

#ifdef SPMD
      use mod_comm,       only: gid, mp_send4d_ns, mp_recv4d_ns
#endif

      use shr_kind_mod,   only: r8 => shr_kind_r8

#endif
!  implicit none
      use fv_arrays_mod, only: fv_array_check, fv_array_sync, fv_stack_push, &
           fv_stack_reset, fv_print_chksums, jsp, jep, ksp, kep
#ifdef use_shared_pointers
      use fv_arrays_mod, only: is,ie,js,je, isd,ied,jsd,jed, isg,ieg,jsg,jeg, &
           nlev, ncnst, &
           ptr_ps_bp, ptr_u_phys, ptr_v_phys, ptr_t_phys, ptr_q_phys
      implicit none
      real :: ps_bp (isg:ieg, js:je)
      real :: u_phys(isg:ieg, js:je, nlev)
      real :: v_phys(isg:ieg, js:je, nlev)
      real :: t_phys(isg:ieg, js:je, nlev)
      real :: q_phys(isg:ieg, js:je, nlev, ncnst)
      pointer( p_ps_bp, ps_bp )
      pointer( p_u_phys, u_phys )
      pointer( p_v_phys, v_phys )
      pointer( p_t_phys, t_phys )
      pointer( p_q_phys, q_phys )
#else
      use fv_arrays_mod, only: ps_bp, u_phys, v_phys, t_phys, q_phys
      implicit none
#endif

! !INPUT PARAMETERS:
      integer, intent(in):: im       ! dimension in east-west
      integer, intent(in):: jm       ! dimension in North-South
      integer, intent(in):: km       ! number of Lagrangian layers
      integer, intent(in):: jfirst   ! starting latitude index for MPI
      integer, intent(in):: jlast    ! ending latitude index for MPI
      integer, intent(in):: nq       ! total # of tracers to be advected
      integer, intent(in):: pnats    ! number of non-advected tracers
      integer, intent(in):: ndt      ! the large time step in seconds

      real, intent(in):: ptop    ! constant pressure at model top (pascal)
      real, intent(in):: om      ! angular velocity of earth's rotation  
      real, intent(in):: r_vir    ! constant for the virtual effect
      real, intent(in):: cp      ! heat capacity of air at constant pressure
      real, intent(in):: rg
      real, intent(in):: cappa   ! rg/cp
      real, intent(in):: ae      ! radius of the earth (m)

      logical, intent(in):: p_map    ! Partial remapping 
      real,intent(in):: consv    ! energy conserving correcton factor: 0 = correction
!                                     1 = full correction
#ifndef USE_LIMA
      type(time_type), optional, intent(in) :: Time_next
#endif

      real, intent(inout):: phis(im,jfirst-ighost:jlast+ighost) ! surface geopotential (grav*zs)

! !INPUT/OUTPUT
      real, intent(inout):: ps(im,jfirst:jlast)      ! surface pressure (pascal)
      real, intent(inout):: delp(im,jfirst:jlast,km) ! pressure thickness (pascal)

! Ghosted prog arrays:
      real, intent(inout):: u(im,jfirst-ng_d:jlast+ng_s,km)  ! u-wind (m/s)
      real, intent(inout):: v(im,jfirst-ng_d:jlast+ng_d,km)  ! v-wind (m/s)
      real, intent(inout):: pt(im,jfirst-ng_d:jlast+ng_d,km) ! temperature (K)
      real, intent(inout):: q(im,jfirst-ng_d:jlast+ng_d,km,nq)
! tracers (e.g., specific humidity)
! tracer mass / moist_air_mass

      real, intent(inout):: pkz(im,jfirst:jlast,km)   ! finite-volume mean of pk

! peln are not needed as input if consv = 0.
      real, intent(inout):: pe(im,km+1,jfirst:jlast)  ! pressure (pascal) at layer edges
      real, intent(inout):: peln(im,km+1,jfirst:jlast)  ! log pressure (pe) at layer edges
      real, intent(inout):: ua(im,jfirst:jlast,km)    ! A grid u-wind (m/s)
      real, intent(inout):: va(im,jfirst:jlast,km)    ! A grid v-wind (m/s)

! !OUTPUT (input values are not used):
      real, intent(inout):: pk(im,jfirst:jlast,km+1)  ! pe**cappa (cappa = rg/cp)
! outputed values can be used by physdrv
      real, intent(out):: omga(im,jfirst:jlast,km)    ! vertical pressure velocity (pa/sec)
! This is the rate of change of the Lagrangian
! interface in pascal/sec unit.

! !DESCRIPTION:
!
! Developer: Shian-Jiann (SJ) Lin, NOAA/GFDL; email: Shian-Jiann.Lin
!
! D-grid prognostatic variables: u, v, and delp (and other scalars)
!
!               u(i,j+1)
!                 |
!      v(i,j)---delp(i,j)---v(i+1,j)
!                 |
!               u(i,j)
!
! The C grid component is hidden from the user

! External routine required: the user needs to supply a subroutine to set up
!                            "Eulerian vertical coordinate" for remapping purpose.
!                            Currently this routine is named as set_eta()
!                            In principle any terrian following vertical
!                            coordinate can be used. The input to fv_dynamics
!                            need not be on the same vertical coordinate
!                            as the output.
!
! Remarks: values at poles for both u and v need not be defined; but values for
!          all other scalars needed to be defined at both poles (as polar cap mean
!          quantities). Tracer advection is done "off-line" using the
!          large time step. Consistency is maintained by using the time accumulated
!          Courant numbers and horizontal mass fluxes for the FFSL algorithm.
!
!          The user may set the value of n_zonal to optimize the SMP performance
!          The optimal valuse of n_zonal depends on the total number of available
!          shared memory CPUs per node.
!
! !REVISION HISTORY:
!   SJL 99.04.13:  Initial SMP version delivered to Will Sawyer
!   WS  99.10.03:  1D MPI completed and tested; 
!   WS  99.10.11:  Additional documentation
!   WS  99.10.28:  benergy and te_map added; arrays pruned
!   SJL 00.01.01:  SMP and MPI enhancements; documentation
!   WS  00.07.13:  Changed PILGRIM API
!   SJL 03.11.21:  3rd major revision
!
!EOP
!-----------------------------------------------------------------------
!BOC
! Local variables:

      integer i, j, k
      integer it, padv, iq

      real :: umax = 300.   ! estimated upper bound of the maximum u-wind (m/s)
      real  dt
      real  bdt
      real  kappa, cp_dyn
      real frac       ! tracer time split fraction

! Local auto arrays
      real  wk1(im+2, jfirst:jlast+2)
      real  wk2(im+2, jfirst:jlast+2)
      real  tte(jfirst:jlast)
!temporary work arrays
      real :: cx(im,jfirst-ng_d:jlast+ng_d,km)
      real :: mfx(im,jfirst:jlast,km)
      real :: cy(im,jfirst:     jlast+1,   km)
      real :: mfy(im,jfirst:     jlast+1,   km)
      real :: dpt(im,jfirst-1:   jlast+1,   km)
      real :: vc(im,jfirst-2:   jlast+2,   km)
      real :: delpf(im,jfirst-ng_d:jlast+ng_d,km)
      real :: uc(im,jfirst-ng_d:jlast+ng_d,km)
      real :: dwz(im,jfirst-1:   jlast,     km+1)
      real :: pkc(im,jfirst-1:   jlast+1,   km+1) 
      real :: wz(im,jfirst-1:   jlast+1,   km+1)
! Save a copy of pe for the computation of vertical velocity

      real :: pem(im,km+1,jfirst:jlast)
#ifdef use_shared_pointers
      pointer( p_cx, cx )
      pointer( p_mfx, mfx )
      pointer( p_cy, cy )
      pointer( p_mfy, mfy )
      pointer( p_dpt, dpt )
      pointer( p_vc, vc )
      pointer( p_delpf, delpf )
      pointer( p_uc, uc )
      pointer( p_dwz, dwz )
      pointer( p_pkc, pkc )
      pointer( p_pem, pem )
      pointer( p_wz, wz )
      pointer( p_tte, tte )
#endif

      integer js2g0, jn2g0

#ifdef SW_DYN
! The following code segment is for shallow water test cases
      real yy, tday, aoft, pi, gv, ssec
      data ssec /0./

      kappa  = 1.
      cp_dyn = 1.
#else
      kappa  = cappa
      cp_dyn = cp
#endif

      js2g0 = max(2,jfirst)
      jn2g0 = min(jm-1,jlast) 
      padv = nq - pnats
#ifdef use_shared_pointers
      call fv_print_chksums( 'Entering  fv_dynamics' )
      p_ps_bp =  ptr_ps_bp
      p_u_phys =  ptr_u_phys
      p_v_phys =  ptr_v_phys
      p_t_phys =  ptr_t_phys
      p_q_phys =  ptr_q_phys
      call fv_stack_reset !zeroes stack from previous invocation
      call fv_stack_push( p_cx,    im*km*(jlast-jfirst+2*ng_d+1) )
      call fv_stack_push( p_mfx,   im*km*(jlast-jfirst+1)        )
      call fv_stack_push( p_cy,    im*km*(jlast-jfirst+2)        )
      call fv_stack_push( p_mfy,   im*km*(jlast-jfirst+2)        )
      call fv_stack_push( p_dpt,   im*km*(jlast-jfirst+3)        )
      call fv_stack_push( p_vc,    im*km*(jlast-jfirst+5)        )
      call fv_stack_push( p_delpf, im*km*(jlast-jfirst+2*ng_d+1) )
      call fv_stack_push( p_uc,    im*km*(jlast-jfirst+2*ng_d+1) )
      call fv_stack_push( p_dwz,   im*(km+1)*(jlast-jfirst+2)    )
      call fv_stack_push( p_pkc,   im*(km+1)*(jlast-jfirst+3)    )
      call fv_stack_push( p_wz,    im*(km+1)*(jlast-jfirst+3)    )
      call fv_stack_push( p_pem,   im*(km+1)*(jlast-jfirst+1)    )
      call fv_stack_push( p_tte,              jlast-jfirst+1     )
#endif
      call fv_array_check( LOC(phis) )
      call fv_array_check( LOC(ps) )
      call fv_array_check( LOC(delp) )
      call fv_array_check( LOC(u) )
      call fv_array_check( LOC(v) )
      call fv_array_check( LOC(pt) )
      call fv_array_check( LOC(q) )
      call fv_array_check( LOC(pkz) )
      call fv_array_check( LOC(pe) )
      call fv_array_check( LOC(peln) )
      call fv_array_check( LOC(ua) )
      call fv_array_check( LOC(va) )
      call fv_array_check( LOC(pk) )
      call fv_array_check( LOC(omga) )
      call fv_array_check( LOC(ps_bp) )
      call fv_array_check( LOC(u_phys) )
      call fv_array_check( LOC(v_phys) )
      call fv_array_check( LOC(t_phys) )
      call fv_array_check( LOC(q_phys) )

#ifdef SPMD
      call fv_array_sync()
      call mp_send4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_s, u)
      call mp_send4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, v)
#endif

      if ( use_tendency ) then
!$omp parallel do private(i,j,k,iq)
          do k=ksp,kep !1,km
             do j=jfirst,jlast
                do i=1,im
                   u_phys(i,j,k) = ua(i,j,k)
                   v_phys(i,j,k) = va(i,j,k)
                   t_phys(i,j,k) = pt(i,j,k)
                enddo
             enddo

             do iq=1,nq
                do j=jfirst,jlast
                   do i=1,im
                      q_phys(i,j,k,iq) = q(i,j,k,iq)
                   enddo
                enddo
             enddo
          enddo
      endif

! Mass conservation for non-advected tracers
      if(pnats /= 0) then
          do iq=padv+1,nq
!$omp parallel do private(i,j,k)
             do k=ksp,kep !1,km
                do j=jfirst,jlast
                   do i=1,im
                      q(i,j,k,iq) = q(i,j,k,iq)*delp(i,j,k)
                   enddo
                enddo
             enddo
          enddo
      endif

!$omp parallel do private(i,j,k)
      do k=ksp,kep !1,km
! Initialize the CFL number accumulators: (cx, cy)
! Initialize total mass fluxes: (mfx, mfy)
         if( padv > 0 ) then
             do j=jfirst-ng_d,jlast+ng_d
                do i=1,im
                   cx(i,j,k) = 0.
                enddo
             enddo
             do j=jfirst,jlast
                do i=1,im
                   cy(i,j,k) = 0.
                   mfx(i,j,k) = 0.
                   mfy(i,j,k) = 0.
                enddo
             enddo
         endif
      enddo        ! end parallel k-loop
      call fv_array_sync()
!      call fv_print_chksums( 'after cx cy mfx mfy' )

      if ( kord_tm > 0 ) then

!$omp parallel do private (i, j, k)
          do j=jsp,jep !jfirst,jlast
!    do k=1,km+1
!       do i=1,im
!          pem(i,k,j) = pe(i,k,j)
!       enddo
!    enddo

             do k=1,ks+1
                do i=1,im
                   pem(i,k,j) = ak(k)
                enddo
             enddo

             do k=ks+2,km+1
                do i=1,im
                   pem(i,k,j) = ak(k) + bk(k) * ps_bp(i,j)
                enddo
             enddo
          enddo
          call fv_array_sync()
      endif

#ifdef SPMD
      call mp_recv4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_s, u)
      u_ghosted = .true.
      call fv_array_sync()
#endif

      if( km > 1 .and. consv > 1.E-5 ) then

!---------------------------------------------------------------------
! Compute globally integrated Total Energy
! Assuming the 1st tracer is specific humidity
!---------------------------------------------------------------------

          if ( kord_tm > 0 ) then
              call benergy(im, jm, km, u, v, pt, delp, q(1,jfirst-ng_d,1,1),  &
                   pe, peln, phis(1,jfirst),  u_ghosted,              &
                   ng_d, ng_s, r_vir, cp_vir, cp, rg,  tte,           &
                   jfirst, jlast, acap, cosp, ua, va)
          else
              call p_energy(im, jm, km, u, v, pt, delp, q(1,jfirst-ng_d,1,1),  &
                   pe, peln, phis(1,jfirst),                           &
                   ng_d, ng_s, r_vir, cp_vir, cp, rg,  tte,            &
                   jfirst, jlast, acap, cosp, ua, va)
          endif
      endif
!      call fv_print_chksums( 'after benergy penergy' )

!$omp parallel do private(i, j, k, wk1, wk2)
      do k=ksp,kep !1,km
         do j=jfirst,jlast
            do i=1,im
!               Save initial delp field before the small-time-step
               va(i,j,k) = delp(i,j,k)
               delpf(i,j,k) = delp(i,j,k)
#ifdef SW_DYN
               pt(i,j,k) = 1.
#else
! Convert pt to virtual potential temperature * CP
               pt(i,j,k) = cp*pt(i,j,k)/pkz(i,j,k)*(1.+r_vir*q(i,j,k,1))
#endif
            enddo
         enddo

#ifndef USE_LIMA
         call pft2d( delpf(1,js2g0,k), im, jn2g0-js2g0+1, wk1, wk2, 1) 
#else               
         call pft2d( delpf(1,js2g0,k),  sc(js2g0), dc(1,js2g0),   &
              im, jn2g0-js2g0+1, ifax, trigs, wk1, wk2 )
#endif

      enddo !k-loop
      call fv_array_sync()
!      call fv_print_chksums( 'after delpf' )


#ifdef SPMD
      call mp_recv4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, v)

#if !defined (SW_DYN)                                                                 
      call mp_send4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, pt)      
#endif                                                                                
      call mp_send4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, delpf)   
#if !defined (SW_DYN)                                                                 
      call mp_recv4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, pt)      
#endif                                                                                
      call mp_recv4d_ns(im, jm, km, 1, jfirst, jlast, 1, km, ng_d, ng_d, delpf)   
      call fv_array_sync()
#endif

      bdt = ndt
      dt  = bdt / real(n_split)

      do it=1, n_split

#ifdef SW_DYN                                                                 
         pi = 4.*atan(1.)
         gv = 9.8*720.

         if (icase == 8 ) then
             tday = ssec/(24.*3600.)
             if(tday >= 20.) then
                 ssec = 0                  ! reset to 0
                 aoft = 0.
             elseif(tday <= 4.) then
                 aoft = 0.5*(1.-cos(0.25*pi*tday))
             elseif(tday <= 16.) then
                 aoft = 1.
             else
                 aoft = 0.5*(1.+cos(0.25*pi*(tday-16.)))
             endif

             aoft = aoft * gv

! Time invariant part of the terrain BC
             do j=jfirst, jlast
                if(sinp(j) > 0.) then
                    yy = (cosp(j)/sinp(j))**2
                    do i=1,im
                       phis(i,j) =  aoft*yy*exp(1.-yy)*sinlon(i)
                    enddo
                else
                    do i=1,im
                       phis(i,j) = 0.
                    enddo
                endif
             enddo
             ssec = ssec + dt
         endif
#endif

!--------------------------------------------------------
! Call the Lagrangian dynamical core using small tme step
!--------------------------------------------------------

         call timing_on('CD_CORE')


#ifndef USE_LIMA
         call cd_core(im,  jm,  km,  padv, n_zonal, jfirst, jlast, &
              u,   v,  pt,  delp, pe,  pk, n_split, dt,    &
              ptop, umax,   ae, rcap, cp_dyn, kappa,       &
              iord_mt, iord_tm, jord_mt, jord_tm,          &
              ng_d,   ng_s,  it, n_split,                  &
              om, phis, sinp, cosp, cose, acosp,           &
              sinlon, coslon, cosl5, sinl5, f_d, dx,       &
              one_by_dx, one_by_dy, cx  , cy , mfx, mfy,   &
              delpf, uc, vc, dpt, pkz, dwz, pkc, wz,       &
              omga,  master, ighost, dyn_step)

         if (dyn_step == 1 ) then
             dyn_step = 2
         elseif(dyn_step == 2 ) then
             dyn_step = 1
         endif

#else               
         call cd_core(im,  jm,  km,  padv, n_zonal, jfirst, jlast, &
              u,   v,  pt,  delp, pe,  pk, n_split, dt,    &
              ptop, umax,   ae, rcap, cp_dyn, kappa,       &
              iord_mt, iord_tm, jord_mt, jord_tm,          &
              ng_d,   ng_s,  it, n_split,                  &
              om, phis, sinp, cosp, cose, acosp,           &
              sinlon, coslon, cosl5, sinl5, f_d, dx,       &
              one_by_dx, one_by_dy, cx  , cy , mfx, mfy,   &
              delpf, uc, vc, dpt,                          &
              pkz, dwz, pkc, wz, omga,  master, ighost )

#endif

         call timing_off('CD_CORE')

      enddo

      if(padv /= 0) then

!--------------------------------------------------------
! Perform large-time-step scalar transport using the accumulated CFL and
! mass fluxes
!--------------------------------------------------------

          call timing_on('tracer_2d')
#ifndef USE_LIMA
          call tracer_2d(q, padv, va, cx, cy, mfx, mfy, iord_tr, jord_tr,    &
               ng_d, cose, cosp, acosp, acap, rcap, tra_step,      &
               fill, im, jm, km, jfirst, jlast, pkz, bdt, frac)
#else
          call tracer_2d_lima(q, padv, va, cx, cy, mfx, mfy, iord_tr, jord_tr,  &
               ng_d, cose, cosp, acosp, acap, rcap, fill,        &
               im, jm, km, jfirst, jlast, pkz, ua, bdt, frac)
#endif
          call timing_off('tracer_2d')


      endif
#ifdef SW_DYN
      do j=jfirst,jlast
         do i=1,im
            ps(i,j) = delp(i,j,1)
         enddo
      enddo
#endif

      if ( km > 2 ) then

!------------------------------------------------------------------------
! Peroform vertical remapping from Lagrangian control-volume to
! the Eulerian coordinate as specified by the routine set_eta.
! Note that this finite-volume dycore is otherwise independent of the vertical
! Eulerian coordinate.
!------------------------------------------------------------------------

          call timing_on('Remapping')

          if ( kord_tm < 0 ) then
              call geo_map(ps, omga,  pe, delp, pkz, pk, ndt,             &
                   im, jm, km, n_zonal, jfirst, jlast, padv,      &
                   u,   v,  pt,  q, r_vir, cp_vir, cp,  cappa,    &
                   abs(kord_mt), abs(kord_tr), abs(kord_tm),      &
                   peln, phis(1,jfirst),  ng_d, ng_s,  &
                   rg, acap, cosp, ua, va, consv, tte, fill)
          else
#ifndef USE_LIMA
              call te_map(consv, ps, omga,  pe, pem, delp, pkz, pk, ndt,    &
                   im, jm, km, p_map, n_zonal, jfirst, jlast, padv,  &
                   u,   v,  pt,  q, phis(1,jfirst), r_vir, cp_vir,   &
                   cp, cappa, kord_mt, kord_tr, kord_tm, peln, tte,  &
                   ng_d, ng_s, ua, va, fill, Time_next)
#else
              call te_map(consv, ps, omga,  pe, pem, delp, pkz, pk, ndt,    &
                   im, jm, km, p_map, n_zonal, jfirst, jlast, padv,  &
                   u,   v,  pt,  q, phis(1,jfirst), r_vir, cp_vir,   &
                   cp, cappa, kord_mt, kord_tr, kord_tm, peln, tte,  &
                   ng_d, ng_s, ua, va, fill)
#endif
          endif

          call timing_off('Remapping')
      endif

!-----------------------------------------------------
! Add the v*grad(p) term to omega (dp/dt) for physics
!-----------------------------------------------------
      call compute_vdot_gradp(im, jm, km, jfirst, jlast, ng_d,       &
           bdt, frac, cx, cy, pe, omga)
#ifdef OMGA_PHYS
#endif
      if(pnats /= 0) then
! Mass conservation for non-advected tracers
          do iq=padv+1,nq
!$omp parallel do private(i,j,k)
             do k=ksp,kep !1,km
                do j=jfirst,jlast
                   do i=1,im
                      q(i,j,k,iq) = q(i,j,k,iq) / delp(i,j,k)
                   enddo
                enddo
             enddo
          enddo
      endif

!EOC
      call fv_print_chksums( 'Exiting  fv_dynamics' )
    end subroutine fv_dynamics

!-----------------------------------------------------------------------

    subroutine compute_vdot_gradp(im, jm, km, jfirst, jlast, ng_d,       &
         dt, frac, cx, cy, pe, omga)

      use pft_module,     only: pft2d
#ifdef SPMD
      use mod_comm, only: gid,  mp_send3d, mp_recv3d
#endif
      use fv_arrays_mod, only: fv_array_check, fv_array_sync, fv_stack_push, &
           fv_print_chksums, ksp, kep
#ifndef USE_LIMA
#ifdef use_shared_pointers
      use fv_arrays_mod, only: isg,ieg,nlev
      use fv_arrays_mod, only: ptr_pesouth
      implicit none
      real :: pesouth(isg:ieg, nlev+1)
      pointer( p_pesouth, pesouth )
#else
      use fv_arrays_mod, only: pesouth
      implicit none
#endif
#else               
      use fv_pack,        only: ifax, trigs, sc, dc
      use fv_arrays_mod, only: pesouth
      implicit none
#endif

! !INPUT PARAMETERS:
      integer, intent(in):: im       ! dimension in east-west
      integer, intent(in):: jm       ! dimension in North-South
      integer, intent(in):: km       ! number of Lagrangian layers
      integer, intent(in):: jfirst   ! starting latitude index for MPI
      integer, intent(in):: jlast    ! ending latitude index for MPI
      integer, intent(in):: ng_d

      real, intent(in):: dt
      real, intent(in):: frac

      real, intent(in):: cx(im,jfirst-ng_d:jlast+ng_d,km) 
      real, intent(in):: cy(im,jfirst:     jlast+1,   km)
      real, intent(in):: pe(im,km+1,jfirst:jlast)     ! pressure (pascal) at layer edges
      real, intent(inout):: omga(im,jfirst:jlast,km)  ! vertical pressure velocity (pa/sec)

! Local 
      real pm(im, jfirst-1:jlast+4)
      real penorth(im, km+1)
      real grad(im, jfirst:jlast+4)
      real fac, sum1

      integer i,j,k, js2g0, jn2g0
#ifdef use_shared_pointers
      pointer( p_penorth, penorth )
      call fv_stack_push( p_penorth, im*(km+1) )
      p_pesouth = ptr_pesouth
#endif

      call fv_print_chksums( 'Entering  compute_vdot_gradp' )
      js2g0 = max(2,jfirst)
      jn2g0 = min(jm-1,jlast) 

      fac = 0.5 / (dt * frac)

      call fv_array_check( LOC(cx) )
      call fv_array_check( LOC(cy) )
      call fv_array_check( LOC(pe) )
      call fv_array_check( LOC(omga) )

#ifdef SPMD
      call mp_send3d(gid+1, gid-1, im, km+1, jm, 1, im, 1, km+1,               &
           jfirst, jlast, 1, im, 1, km+1, jlast, jlast, pe)
      call mp_send3d(gid-1, gid+1, im, km+1, jm, 1, im, 1, km+1,               &
           jfirst, jlast, 1, im, 1, km+1, jfirst, jfirst, pe)
      call mp_recv3d(gid-1, im, km+1, jm, 1, im, 1, km+1, 1, 1, &
           1, im,    1, km+1, 1, 1, pesouth)
      call mp_recv3d(gid+1, im, km+1, jm, 1, im, 1, km+1, 1, 1, &
           1, im,    1, km+1, 1, 1, penorth)
      call fv_array_sync()
#endif

!$omp parallel do private(i,j,k,pm,grad, sum1)
      do k=ksp,kep !1,km

! Compute layer mean p
         do j=jfirst,jlast
            do i=1,im
               pm(i,j) = 0.5 * ( pe(i,k,j) + pe(i,k+1,j) )
            enddo
         enddo

         if ( jfirst/=1 ) then
             do i=1,im
                pm(i,jfirst-1) = 0.5 * ( pesouth(i,k) + pesouth(i,k+1))
             enddo
         endif

         if ( jlast/=jm ) then
             do i=1,im
                pm(i,jlast+1) = 0.5 * ( penorth(i,k) + penorth(i,k+1))
             enddo
         endif

         do j=js2g0,jn2g0
            i=1
            grad(i,j) = fac * cx(i,j,k) * (pm(i,j)-pm(im,j)) 
            do i=2,im
               grad(i,j) = fac * cx(i,j,k) * (pm(i,j)-pm(i-1,j)) 
            enddo
         enddo

         do j=js2g0,jn2g0
            do i=1,im-1
               omga(i,j,k) = omga(i,j,k) + grad(i,j) + grad(i+1,j)
            enddo
            i=im
            omga(i,j,k) = omga(i,j,k) + grad(i,j) + grad(1,j)
         enddo

         do j=js2g0,min(jm,jlast+1)
            do i=1,im
               grad(i,j) = fac * cy(i,j,k) * (pm(i,j)-pm(i,j-1)) 
            enddo
         enddo

         do j=js2g0,jn2g0
            do i=1,im
               omga(i,j,k) = omga(i,j,k) + grad(i,j) + grad(i,j+1)
            enddo
         enddo

!-------------------
! Apply polar filter
!-------------------

#ifndef USE_LIMA
         call pft2d( omga(1,js2g0,k), im, jn2g0-js2g0+1, pm, grad, 1) 
#else               
         call pft2d( omga(1,js2g0,k),  sc(js2g0), dc(1,js2g0),   &
              im, jn2g0-js2g0+1, ifax, trigs, pm, grad)
#endif


! Note: Since V*grad(P) at poles are harder to compute accurately we use the average of sourding points
!       to be used as input to physics.

         if ( jfirst==1 ) then
             sum1 = 0.
             do i=1,im
                sum1 = sum1 + omga(i,2,k)
             enddo
             sum1 = sum1 / real(im)
             do i=1,im
                omga(i,1,k) = sum1
             enddo
         endif

         if ( jlast==jm ) then
             sum1 = 0.
             do i=1,im
                sum1 = sum1 + omga(i,jm-1,k)
             enddo
             sum1 = sum1 / real(im)
             do i=1,im
                omga(i,jm,k) = sum1
             enddo
         endif
      enddo
      call fv_array_sync()
      call fv_print_chksums( 'Exiting  compute_vdot_gradp' )
    end subroutine compute_vdot_gradp

end module fv_dynamics_mod

module oda_core_mod
!
!<CONTACT EMAIL="matthew.harrison@noaa.gov"> Matthew Harrison
!</CONTACT>
!
!<OVERVIEW>
! core ocean data assimilation subroutines for ocean models. This module
! includes interfaces to :
!  
! (i)   initialize the ODA core with observations and model
! (ii)  request ocean state increments using observed or idealized data 
! (iii) calculate model guess differences and output to file
! (iv)  terminate the DA core.  
!  
! NOTE: Profile files conform to v0.1a profile metadata standard.
! This metadata standard will evolve in time and will maintain
! backward compability.  
!  
! NOTE: This code is still under development. ODA data structures should be 
! opaque in future releases.
!  
!</OVERVIEW>
!
!<NAMELIST NAME="oda_core_nml">
! <DATA NAME="max_misfit" TYPE="real">
!  flag measurement if abs(omf) exceeds max_misfit
!</DATA>  
! <DATA NAME="min_obs_err_t" TYPE="real">
! minumum rms temperature observation error (degC) for
! variable obs error, else nominal temp error  
!</DATA>    
! <DATA NAME="min_obs_err_s" TYPE="real">
! minimum rms salinity observation error (g/kg) for
! variable obs error,else nominal salt error  
!</DATA>    
! <DATA NAME="eta_tide_const" TYPE="real">
! Tidal internal displacement amplitude (meters) for observational error estimation.  
!</DATA>    
! <DATA NAME="min_prof_depth" TYPE="real">
! Minimum profile depth (meters)  
!</DATA>    
! <DATA NAME="max_prof_spacing" TYPE="real">
! Data must be contiguous to this resolution (meters). Otherwise flag is activated.
! </DATA>
! <DATA NAME="data_window" TYPE="integer">
! Half-width of profile time window (days)
! </DATA>
! <DATA NAME="add_tidal_aliasing" TYPE="logical">
! Add tidal aliasing to observation error. Use eta_tide_const * dT/dz to estimate
! observation.  
! </DATA>
! <DATA NAME="max_profiles" TYPE="integer">
! Allocation size of profile array
! </DATA>
! <DATA NAME="max_sfc_obs" TYPE="integer">
! Allocation size of surface data array
! </DATA>
! <DATA NAME="temp_obs_rmse" TYPE="real">
! nominal temperature error rms error
! </DATA>
! <DATA NAME="salt_obs_rmse" TYPE="real">
! nominal salinity error rms error
! </DATA>      
!</NAMELIST>  
  use fms_mod, only : file_exist,read_data
  use mpp_mod, only : mpp_error, FATAL, NOTE, mpp_sum, stdout,&
                      mpp_sync_self, mpp_pe,mpp_npes,mpp_root_pe,&
                      mpp_broadcast, input_nml_file
  use mpp_domains_mod, only : mpp_get_compute_domain, mpp_get_data_domain, &
       domain2d, mpp_get_global_domain, mpp_update_domains
  use time_manager_mod, only : time_type, operator( <= ), operator( - ), &
       operator( > ), operator ( < ),  set_time, set_date, &
       get_date, get_time
  use get_cal_time_mod, only : get_cal_time
  use axis_utils_mod, only : frac_index  
  use constants_mod, only : radian, pi
  use oda_types_mod
  use write_ocean_data_mod, only : write_ocean_data_init
  
  implicit none

  private
  
  real, private :: max_misfit = 5.0 ! reject fg diff gt max_misfit


  real, parameter, private :: depth_min=0.0, depth_max=10000.
  real, parameter, private :: temp_min=-3.0, temp_max=40.
  real, parameter, private :: salt_min=0.0, salt_max=45.
  
  integer :: max_profiles = 250000, max_sfc_obs = 1 
  integer, parameter, private :: max_files=100 
  integer, parameter, private :: PROFILE_FILE = 1,SFC_FILE= 2,&
                                 IDEALIZED_PROFILES=3
  
  
! parameters for obs error inflation due to internal tidal displacements
  
  real, private :: min_obs_err_t = 0.5, min_obs_err_s=0.1, eta_tide_const = 7.0
  
  type(ocean_profile_type), target, save, private, allocatable  :: profiles(:)
  type(ocean_surface_type), target, save, private, allocatable  :: sfc_obs(:)  

  integer, private, save :: num_profiles, num_sfc_obs ! total number of observations 

  integer, private, save :: isc, iec, jsc, jec, isd, ied, jsd, jed  ! indices for local and global domain
  integer, private, save :: isg, ieg, jsg, jeg
  integer, private, save :: nk

! parameters used to restrict profiles
  real, private, save :: min_prof_depth = 200.0 ! profile data ending
                                                   ! above this level are
                                                   ! discarded.  
  real, private, save :: max_prof_spacing = 1.e5 ! reject profile data
                                                    ! if not contiguous
                                                    ! at this resolution

! internal arrays for forward and backward observations
  real, dimension(:,:,:), allocatable, private, save :: sum_wgt, nobs

  type(time_type) , dimension(0:100), public :: time_window

! the DA module maintains a unique grid,domain association
  
  type(grid_type), pointer :: Grd

! DA grid (1-d) coordinates.  Generalized horizontal coordinates are not supporte.
  
  real, allocatable, dimension(:) :: x_grid, y_grid

  real :: temp_obs_rmse = 0.7071
  real :: salt_obs_rmse = 0.1
  
  logical :: add_tidal_aliasing=.false.

  logical :: localize_data = .true.

  logical :: debug=.false.

  integer :: ndebug=10

  integer, allocatable, dimension(:) :: nprof_in_comp_domain
  
  namelist /oda_core_nml/ max_misfit,add_tidal_aliasing,min_obs_err_t,&
                          min_obs_err_s, eta_tide_const, debug, max_profiles,&
                          max_sfc_obs, temp_obs_rmse, salt_obs_rmse, ndebug
                          

! NOTE: Surface observation type is not yet implemented.

! transform from Grd => Obs
  
  interface forward_obs
     module procedure forward_obs_profile
     module procedure forward_obs_sfc
  end interface

! transform from Obs => Grd
  
  interface backward_obs
     module procedure backward_obs_profile
     module procedure backward_obs_sfc
  end interface


! one-time association between profile and grid, used for storing
! interpolation weights
  
  interface assign_forward_model
     module procedure assign_forward_model_profile
     module procedure assign_forward_model_sfc
  end interface

! duplicate observation array
  
  interface copy_obs
     module procedure copy_obs_prof
     module procedure copy_obs_sfc
  end interface

! multiply observation data by inverse error variance
 
  interface mult_obs_I_mse
     module procedure mult_obs_I_mse_profile
     module procedure mult_obs_I_mse_sfc
  end interface

! difference between two observations (e.g. model first guess and observations)
  
  interface diff_obs
     module procedure diff_obs_profile
     module procedure diff_obs_sfc
  end interface

! inflate observational error based on first guess misfit 
! and time window.
  
  interface adjust_obs_error
     module procedure adjust_obs_error_profile
     module procedure adjust_obs_error_sfc
  end interface


  interface nullify_obs
     module procedure nullify_obs_prof
  end interface
  
  public :: forward_obs, backward_obs, &
            copy_obs, adjust_obs_error, &
            oda_core_init, open_profile_dataset, get_obs, &
            assign_forward_model, diff_obs, mult_obs_I_mse, &
            purge_obs, nullify_obs
  
  contains


  subroutine open_profile_dataset(filename, localize)  
!    <DESCRIPTION>
!    open dataset containing profile information in fms station format.
!    store internally.
!    </DESCRIPTION>    
    
    use mpp_io_mod, only : mpp_open, mpp_get_atts, mpp_get_info, &
         mpp_get_fields, mpp_read, MPP_SINGLE, MPP_MULTI, MPP_NETCDF,&
         axistype, atttype, fieldtype, MPP_RDONLY, mpp_get_axes, mpp_close,&
         mpp_get_att_char
    
    character(len=*), intent(in) :: filename
    logical, intent(in), optional :: localize
    logical :: found_neighbor,continue_looking
    integer, parameter :: max_levels=1000
    integer :: unit, ndim, nvar, natt, nstation
    character(len=32) :: fldname, axisname
    type(atttype), allocatable, dimension(:), target :: global_atts
    type(atttype), pointer :: version => NULL()
    type(axistype), pointer :: depth_axis => NULL(), station_axis => NULL()
    type(axistype), allocatable, dimension(:), target :: axes
    type(fieldtype), allocatable, dimension(:), target :: fields
    
    type(fieldtype), pointer :: field_lon => NULL(), field_lat => NULL(), field_probe => NULL(),&
         field_time => NULL(), field_depth => NULL()
    type(fieldtype), pointer :: field_temp => NULL(), field_salt => NULL(), &
                                field_error => NULL(), field_link => NULL()
    ! NOTE: fields are restricted to be in separate files
    real :: lon, lat, time, depth(max_levels), temp(max_levels), salt(max_levels),&
         error(max_levels), rprobe, profile_error, rlink
    integer :: nlev, probe, yr, mon, day, hr, minu, sec, kl, outunit
    integer :: num_levs, num_levs_temp, num_levs_salt,&
               k, kk, ll, i, i0, j0, k0, nlevs, a, nn, ii, nlinks
    real :: ri0, rj0, rk0, dx1, dx2, dy1, dy2
    character(len=128) :: time_units, attname, catt
    type(time_type) :: profile_time
    integer :: flag_t(max_levels), flag_s(max_levels), cpe
    logical :: data_is_local, &
               continue
    logical :: found_temp=.false., found_salt=.false.
    real, dimension(max_links,max_levels) :: temp_bfr, salt_bfr, depth_bfr
    integer, dimension(max_links,max_levels) :: flag_t_bfr, flag_s_bfr
    real :: temp_missing=missing_value,salt_missing=missing_value,&
         depth_missing=missing_value
    real :: max_prof_depth, zdist
    
    
    ! read timeseries of local observational data from NetCDF files
    ! and allocate ocean_obs arrays.  

    ! File structure:
    !    dimensions:
    !       depth_index;station=UNLIMITED;
    !    variables:
    !       depth_index(depth_index);
    !       station(station);
    !       longitude(station);
    !       latitude(station);
    !       time(station); 
    !       data(station,depth_index);
    !       depth(station,depth_index);
    !       probe(station);
    !       err(station, depth_index);

    cpe = mpp_pe()

    dx1 = (x_grid(isc)-x_grid(isc-1))/2.0
    dx2 = (x_grid(iec+1)-x_grid(iec))/2.0
    dy1 = (y_grid(jsc)-y_grid(jsc-1))/2.0
    dy2 = (y_grid(jec+1)-y_grid(jec))/2.0
    
    localize_data = .true.

    if (PRESENT(localize)) localize_data = localize

    call mpp_open(unit,filename,form=MPP_NETCDF,fileset=MPP_SINGLE,&
         threading=MPP_MULTI,action=MPP_RDONLY)
    call mpp_get_info(unit, ndim, nvar, natt, nstation)

    outunit = stdout()
    write(outunit,*) 'Opened profile dataset :',trim(filename)

    ! get version number of profiles

    allocate(global_atts(natt))
    call mpp_get_atts(unit,global_atts)

    do i=1,natt
       catt = mpp_get_att_char(global_atts(i))
       select case (lowercase(trim(catt)))
       case ('version')
          version =>  global_atts(i)
       end select
    end do

    if (.NOT.ASSOCIATED(version)) then
        call mpp_error(NOTE,'no version number available for profile file, assuming v0.1a ')
    else
        write(outunit,*) 'Reading profile dataset version = ',trim(catt)
    endif
    
    
    ! get axis information

    allocate (axes(ndim))
    call mpp_get_axes(unit,axes)
    do i=1,ndim
       call mpp_get_atts(axes(i),name=axisname)
       select case (lowercase(trim(axisname)))
       case ('depth_index')
          depth_axis => axes(i)
       case ('station_index')
          station_axis => axes(i)
       end select
    end do

    if (.NOT.ASSOCIATED(depth_axis) .or. .NOT.ASSOCIATED(station_axis)) then
        call mpp_error(FATAL,'depth and/or station axes do not exist in input file')
    endif

    
! get selected field information.
! NOTE: not checking for all variables here.    

    allocate(fields(nvar))
    call mpp_get_fields(unit,fields)
    do i=1,nvar
       call mpp_get_atts(fields(i),name=fldname)
       select case (lowercase(trim(fldname)))
       case ('longitude')
           field_lon => fields(i)
       case ('latitude')
           field_lat => fields(i)
       case ('probe') 
           field_probe => fields(i)
       case ('time')
           field_time => fields(i)
       case ('temp')
           field_temp => fields(i)
       case ('salt')
           field_salt => fields(i)           
       case ('depth')
           field_depth => fields(i)
       case ('link')
           field_link => fields(i)
       case ('error')
           field_error => fields(i)
       end select
   enddo

    call mpp_get_atts(depth_axis,len=nlevs)

    if (nlevs > max_levels) call mpp_error(FATAL,'increase parameter max_levels ')

    if (nlevs < 1) call mpp_error(FATAL)

    outunit = stdout()
    write(outunit,*) 'There are ', nstation, ' records in this dataset'
    write(outunit,*) 'Searching for profiles matching selection criteria ...'

    if (ASSOCIATED(field_temp)) found_temp=.true.
    if (ASSOCIATED(field_salt)) found_salt=.true.

    if (.not. found_temp .and. .not. found_salt) then
        write(outunit,*) 'temp or salt not found in profile file'
        call mpp_error(FATAL)
    endif
    
    call mpp_get_atts(field_time,units=time_units)
    if (found_temp) call mpp_get_atts(field_temp,missing=temp_missing)
    if (found_salt) call mpp_get_atts(field_salt,missing=salt_missing)
    
    call mpp_get_atts(field_depth,missing=depth_missing)        

    if (found_salt) then
        write(outunit,*) 'temperature and salinity where available'
    else
        write(outunit,*) 'temperature only records'
    endif

    
    i=1
    continue=.true.
    
    do while (continue)

       depth(:) = missing_value
       temp(:)  = missing_value
       salt(:)  = missing_value       
! required fields       
       call mpp_read(unit,field_lon,lon,tindex=i)
       call mpp_read(unit,field_lat,lat, tindex=i)
       call mpp_read(unit,field_time,time,tindex=i)
       call mpp_read(unit,field_depth,depth(1:nlevs),tindex=i)
       if (found_temp) call mpp_read(unit,field_temp,temp(1:nlevs),tindex=i)
       if (found_salt) call mpp_read(unit,field_salt,salt(1:nlevs),tindex=i)       
! not required fields
       if (ASSOCIATED(field_error)) then
           call mpp_read(unit,field_error,profile_error,tindex=i)
       endif
       if (ASSOCIATED(field_probe)) then
           call mpp_read(unit, field_probe, rprobe,tindex=i)
       endif
       if (ASSOCIATED(field_link)) then
           call mpp_read(unit,field_link,rlink,tindex=i)
       else
           rlink = 0.0
       endif
       probe=rprobe
       data_is_local = .false.
! NOTE: assuming grid is modulo 360 here. This needs to be generalized.
       
       if (lon .lt. x_grid(isg-1) ) lon = lon + 360.0
       if (lon .gt. x_grid(ieg+1) ) lon = lon - 360.0

! localized data is within region bounded by halo points
! (halo size = 1) adjacent to boundary points of computational domain
       
       if (lon >= x_grid(isc-1) .and. &
           lon <  x_grid(iec+1) .and. &
           lat >= y_grid(jsc-1) .and. &
           lat <  y_grid(jec+1)) data_is_local = .true.

       
       profile_time = get_cal_time(time,time_units,'julian')

       
       if ( data_is_local .OR. .NOT.localize_data) then
           
           num_profiles=num_profiles+1
           if (num_profiles > max_profiles) then
               call mpp_error(FATAL,'maximum number of profiles exceeded.&
                    &Resize parameter max_profiles in ocean_obs_mod')
               
           endif

           call nullify_obs(Profiles(num_profiles))
           
           num_levs_temp = 0
           num_levs_salt = 0           
           do k = 1, nlevs
              
! flag=0 denotes a valid profile level, anything else
! is invalid. See NODC codes.
!================================================================
!0 -     accepted station
!1 -     failed annual standard deviation check
!2 -     two or more density inversions (Levitus, 1982 criteria)
!3 -     flagged cruise
!4 -     failed seasonal standard deviation check
!5 -     failed monthly standard deviation check
!6 -     flag 1 and flag 4
!7 -     bullseye from standard level data or failed annual and monthly
!        standard deviation check
!8 -     failed seasonal and monthly standard deviation check
!9 -     failed annual, seasonal, and monthly standard deviation check
!================================================================
              
              flag_t(k) = 0;flag_s(k) = 0
              
              if (.not.found_salt) then
                  flag_s(k) = 1
              endif
              
              if (depth(k) .eq. depth_missing .or. depth(k) .lt.depth_min&
                   .or. depth(k) .gt. depth_max) then
                  depth(k) = missing_value
                  flag_t(k)=1
                  flag_s(k)=1
              endif
              
              if (found_temp .and. flag_t(k) .eq. 0) then
                  if (temp(k) .eq. temp_missing .or. temp(k) .lt. temp_min&
                       .or. temp(k) .gt. temp_max) then
                      temp(k) = missing_value
                      flag_t(k) = 1
                      flag_s(k) = 1 ! flag salt if no temperature data
                  else 
                      num_levs_temp = num_levs_temp+1
                  endif
              endif
              if (found_salt .and. flag_s(k) .eq. 0) then
                  if (salt(k) .eq. salt_missing .or. salt(k) .lt. salt_min&
                       .or. salt(k) .gt. salt_max) then
                      salt(k) = missing_value
                      flag_s(k) = 1
                  else 
                      num_levs_salt = num_levs_salt+1
                  endif
              endif
              
           enddo

! large profile are stored externally in separate records
! follow the links to get complete profile
           
           ii=i+1
           nlinks = 0
           do while (rlink > 0.0 .and. nlinks .lt. max_links)
              nlinks=nlinks+1
              depth_bfr(nlinks,:) = missing_value
              temp_bfr(nlinks,:) = missing_value
              salt_bfr(nlinks,:) = missing_value              
              call mpp_read(unit,field_depth,depth_bfr(nlinks,1:nlevs),tindex=ii)
              if (found_temp) call mpp_read(unit,field_temp,temp_bfr(nlinks,1:nlevs),tindex=ii)
              if (found_salt) call mpp_read(unit,field_salt,salt_bfr(nlinks,1:nlevs),tindex=ii)
              call mpp_read(unit,field_link,rlink,tindex=ii)
              ii=ii+1
           enddo
           i=ii ! set record counter to start of next profile

           if (nlinks > 0) then
               do nn = 1, nlinks
                  do k=1, nlevs
                     flag_t_bfr(nn,k) = 0
                     flag_s_bfr(nn,k) = 0
                     if (depth_bfr(nn,k) .eq. depth_missing .or.&
                          depth_bfr(nn,k) .lt. depth_min .or. &
                          depth_bfr(nn,k) .gt. depth_max) then
                         depth_bfr(nn,k) = missing_value
                         flag_t_bfr(nn,k)  = 1
                         flag_s_bfr(nn,k)  = 1
                     endif
                     if (found_temp .and. flag_t_bfr(nn,k) .eq. 0) then
                         if (temp_bfr(nn,k) .eq. temp_missing .or.&
                              temp_bfr(nn,k) .lt. temp_min .or.&
                              temp_bfr(nn,k) .gt. temp_max) then
                             temp_bfr(nn,k) = missing_value
                             flag_t_bfr(nn,k) = 1
                             flag_s_bfr(nn,k) = 1                         
                         else 
                             num_levs_temp = num_levs_temp+1
                         endif
                     endif
                     if (found_salt .and. flag_s_bfr(nn,k) .eq. 0) then
                         if (salt_bfr(nn,k) .eq. salt_missing  .or.&
                              salt_bfr(nn,k) .lt. salt_min .or.&
                              salt_bfr(nn,k) .gt. salt_max) then
                             salt_bfr(nn,k) = missing_value
                             flag_t_bfr(nn,k) = 0                         
                             flag_s_bfr(nn,k) = 1
                         else
                             num_levs_salt = num_levs_salt+1
                         endif
                     endif
                  enddo
               enddo
           endif

           num_levs = max(num_levs_temp,num_levs_salt)
           
           if (num_levs == 0) then
               if (i .gt. nstation) continue = .false.
               cycle
           endif

           allocate(profiles(num_profiles)%depth(num_levs))
           profiles(num_profiles)%depth=missing_value
           if (num_levs_temp .gt. 0) then
               allocate(profiles(num_profiles)%data_t(num_levs))
               profiles(num_profiles)%data_t=missing_value
               allocate(profiles(num_profiles)%flag_t(num_levs))
               profiles(num_profiles)%flag_t= 1
               profiles(num_profiles)%nvar=1
           endif

           if (num_levs_salt .gt. 0) then
               allocate(profiles(num_profiles)%data_s(num_levs))
               profiles(num_profiles)%data_s=missing_value
               allocate(profiles(num_profiles)%flag_s(num_levs))
               profiles(num_profiles)%flag_s= 1
               profiles(num_profiles)%nvar=profiles(num_profiles)%nvar + 1
           endif
           

           if (probe < 1 )   probe = 0
           profiles(num_profiles)%probe = probe
           profiles(num_profiles)%levels = num_levs
           profiles(num_profiles)%lat = lat
           profiles(num_profiles)%lon = lon
           allocate(profiles(num_profiles)%ms_t(num_levs))
           profiles(num_profiles)%ms_t(:) = temp_obs_rmse**2.0 ! default error variance for temperature

           if(num_levs_salt .gt. 0) then
               allocate(profiles(num_profiles)%ms_s(num_levs))
               profiles(num_profiles)%ms_s(:) = salt_obs_rmse**2.0  ! default error variance for salinity
           endif
           
           kk= 1
           do k = 1, nlevs
              if (flag_t(k) .eq. 0) then
                  if (kk > profiles(num_profiles)%levels) then
                      call mpp_error(FATAL)
                  endif
                  profiles(num_profiles)%depth(kk) = depth(k)
                  profiles(num_profiles)%data_t(kk) = temp(k)
                  profiles(num_profiles)%flag_t(kk) = 0                  
                  if (found_salt .and. flag_s(k) .eq. 0) then
                      profiles(num_profiles)%data_s(kk) = salt(k)
                      profiles(num_profiles)%flag_s(kk) = 0
                  endif
                  kk=kk+1
              endif
           enddo

           do nn = 1, nlinks
              do k = 1, nlevs
                 if (flag_t_bfr(nn,k) .eq. 0) then
                     if (kk > profiles(num_profiles)%levels) then
                         call mpp_error(FATAL)
                     endif
                     profiles(num_profiles)%depth(kk) = depth_bfr(nn,k)
                     profiles(num_profiles)%data_t(kk) = temp_bfr(nn,k)
                     profiles(num_profiles)%flag_t(kk) = 0
                     if (found_salt .and. flag_s_bfr(nn,k) .eq. 0) then
                         profiles(num_profiles)%data_s(kk) = salt_bfr(nn,k)
                         profiles(num_profiles)%flag_s(kk) = 0
                     endif
                     kk=kk+1
                 endif
              enddo
           enddo
           
           profiles(num_profiles)%time = profile_time
           
! calculate interpolation coefficients (make sure to account for grid offsets here!)
! NOTE: this only works for lat/lon grids. Lower left indices.           
!       
           
           ri0 = frac_index(lon, x_grid(isg-1:ieg+1)) - 1.
           rj0 = frac_index(lat, y_grid(jsg-1:jeg+1)) - 1.
           i0 = floor(ri0)
           j0 = floor(rj0)
           Profiles(num_profiles)%i_index = ri0
           Profiles(num_profiles)%j_index = rj0           
           Profiles(num_profiles)%accepted = .true.
           if (i0 < 0 .or. j0 < 0) then
               Profiles(num_profiles)%accepted = .false.
           endif
           if (i0 > ieg .or. j0 > jeg) then  
               call mpp_error(FATAL,'grid lat/lon index is out of bounds ')
           endif
           if ((i0 < isc-1 .or. i0 > iec) .and. localize_data) then
               call mpp_error(FATAL,'grid lat/lon index is out of bounds ')
           endif
           if ((j0 < jsc-1 .or. j0 > jec) .and. localize_data) then
               call mpp_error(FATAL,'grid lat/lon index is out of bounds ')
           endif
!
! flag the profile if it sits on a model land point
!           
           if (Profiles(num_profiles)%accepted ) then
               if (Grd%mask(i0,j0,1) == 0.0 .or. &
                    Grd%mask(i0+1,j0,1) == 0.0 .or. &
                    Grd%mask(i0,j0+1,1) == 0.0 .or. &
                    Grd%mask(i0+1,j0+1,1) == 0.0) then
                   Profiles(num_profiles)%accepted = .false.
               endif
           endif

           if (Profiles(num_profiles)%accepted) then
               allocate(Profiles(num_profiles)%k_index(Profiles(num_profiles)%levels))
               max_prof_depth=0.0
               do k=1, Profiles(num_profiles)%levels
                  k0=0
                  if (Profiles(num_profiles)%flag_t(k).eq.0) then
                      rk0 = frac_index(Profiles(num_profiles)%depth(k), Grd%z(:))
                      k0 = floor(rk0)
                      if ( k0 == -1) then
                          if (Profiles(num_profiles)%depth(k) .lt. Grd%z(1)) then
                              k0 = 1
                              rk0 = 1.0
                          else if (Profiles(num_profiles)%depth(k) .gt. Grd%z(Grd%nk)) then
                              Profiles(num_profiles)%flag_t(k) = 1
                          endif
                      endif
                  else
                      cycle
                  endif

                  if (k0 .gt. size(Grd%z)-1 ) then
                      write(*,*) 'k0 out of bounds, rk0,k0= ',rk0,k0
                     write(*,*) 'Z_bound= ',Grd%z_bound
                     write(*,*) 'Profile%depth= ',Profiles(num_profiles)%depth
                     
                      call mpp_error(FATAL)
                  endif
                  
                  Profiles(num_profiles)%k_index(k) = rk0

! flag depth level if adjacent model grid points are land

                  if (Profiles(num_profiles)%flag_t(k) .eq. 0) then
                      if (i0 .lt. 0 .or. j0 .lt. 0 .or. k0 .lt. 0) then
                          write(*,*) 'profile index out of bounds'
                          write(*,*) 'i0,j0,k0=',i0,j0,k0
                          write(*,*) 'lon,lat,depth=',Profiles(num_profiles)%lon,&
                               Profiles(num_profiles)%lat,Profiles(num_profiles)%depth(k)
                          call mpp_error(FATAL)
                      endif
                      
                      if (Grd%mask(i0,j0,k0) == 0.0 .or. &
                          Grd%mask(i0+1,j0,k0) == 0.0 .or. &
                          Grd%mask(i0,j0+1,k0) == 0.0 .or. &
                          Grd%mask(i0+1,j0+1,k0) == 0.0) then
                          Profiles(num_profiles)%flag_t(k) = 1
                      endif
                      if (Grd%mask(i0,j0,k0+1) == 0.0 .or. &
                          Grd%mask(i0+1,j0,k0+1) == 0.0 .or. &
                          Grd%mask(i0,j0+1,k0+1) == 0.0 .or. &
                          Grd%mask(i0+1,j0+1,k0+1) == 0.0) then
                          Profiles(num_profiles)%flag_t(k) = 1
                      endif
                      if (Profiles(num_profiles)%flag_t(k) .eq. 0) then
                          max_prof_depth = Profiles(num_profiles)%depth(k)
                      endif
                  endif

               enddo ! Prof%levels loop

! Flag profile if it is too shallow.
               
               if (max_prof_depth .lt. min_prof_depth) then
                   Profiles(num_profiles)%accepted = .false.
               endif

               found_neighbor=.false.
               
               do k=2,Profiles(num_profiles)%levels - 1
                  if (Profiles(num_profiles)%flag_t(k) .eq. 0) then
                      kk = k-1
                      found_neighbor = .false.
                      continue_looking = .true.
                      do while (continue_looking .and. kk .ge. 1)
                         if (Profiles(num_profiles)%flag_t(kk) .eq. 0) then
                             zdist = Profiles(num_profiles)%depth(k) - Profiles(num_profiles)%depth(kk)
                             if (zdist .gt. max_prof_spacing) then
                                 Profiles(num_profiles)%accepted = .false.
                                 goto 199
                             else 
                                 continue_looking = .false.
                                 found_neighbor = .true.
                             endif
                         else
                             kk = kk - 1
                         endif
                      end do
                      kk = k+1
                      continue_looking = .true.
                      do while (continue_looking .and. kk .le. Profiles(num_profiles)%levels)
                         if (Profiles(num_profiles)%flag_t(kk).eq. 0) then
                             zdist = Profiles(num_profiles)%depth(kk) - Profiles(num_profiles)%depth(k)
                             if (zdist .gt. max_prof_spacing) then
                                 Profiles(num_profiles)%accepted = .false.
                                 goto 199
                             else
                                 continue_looking = .false.
                                 found_neighbor = .true.
                             endif
                         else
                             kk = kk+1
                         endif
                      enddo
                  endif
               enddo

               if (.not. found_neighbor) Profiles(num_profiles)%accepted = .false.

199            continue
               
           endif ! if Prof%accept
       else ! data is not local
           i = i+1
       endif ! if data_is_local

       
       if (i .gt. nstation) continue = .false.

    enddo

!    a = nprof_in_comp_domain(cpe)


    
!    call mpp_broadcast(nprof_in_comp_domain(cpe),cpe)
    
!    call mpp_sum(a)

!    write(stdout(),*) 'A grand total of ',int(a),' profiles satisify acceptance criteria'

!    do i=0,mpp_npes()
!       write(stdout(),*) 'pe=',i,'profile count=',nprof_in_comp_domain(i)
!    enddo
    
    call mpp_sync_self()
    call mpp_close(unit)

  end subroutine open_profile_dataset

  subroutine get_obs(model_time, Prof, Sfc, nprof, nsfc)


    ! get profiles and sfc
    ! obs relevant to current analysis interval

    type(time_type), intent(in) :: model_time
    type(ocean_profile_type), dimension(:) :: Prof
    type(ocean_surface_type), dimension(:) :: Sfc
    integer, intent(inout) :: nprof, nsfc

    integer :: i,k,yr,mon,day,hr,minu,sec,a,mon_obs,yr_obs, outunit
    type(time_type) :: tdiff
    character(len=1) :: cchar

    nprof=0
    nsfc=0

    outunit = stdout()
    write(outunit,*) 'Gathering profiles for current analysis time'
    call get_date(model_time,yr,mon,day,hr,minu,sec)
    write(outunit,'(a,i4,a,i2,a,i2)') 'Current yyyy/mm/dd= ',yr,'/',mon,'/',day
    write(outunit,*) 'num_profiles=',num_profiles

    
    do i=1,num_profiles

       if (debug .and. i.le.ndebug) then
           call get_date(Profiles(i)%time,yr,mon,day,hr,minu,sec)
           write(*,*) 'in get_obs prof time: yy/mm/dd= ',yr,mon,day
       endif
       
       if (Profiles(i)%time <= model_time) then
           tdiff = model_time - Profiles(i)%time
       else
           tdiff = Profiles(i)%time - model_time
       endif

       if (debug .and. i .le. ndebug) then
           write(*,*) 'Prof%accepted=',Profiles(i)%accepted
       endif
       
       if (tdiff <= time_window(0) .and. &
            Profiles(i)%accepted) then
           nprof=nprof+1
           if (nprof > size(Prof,1)) &
                call mpp_error(FATAL,'increase size of Prof array before call to get_obs')
           call copy_obs(Profiles(i:i),Prof(nprof:nprof))
           Prof(nprof)%tdiff = tdiff
           if (debug .and. nprof .le. ndebug) then
              call get_time(tdiff,sec,day)
              write(*,'(a,i3,a,2f10.5)') 'Accepted profile #',i,' : lon,lat= ',Prof(nprof)%lon,Prof(nprof)%lat
              do k=1,Prof(nprof)%levels
                 if (Prof(nprof)%nvar .eq. 2) then
                     write(*,'(a,i3,a,2f10.5,2i2,2f8.5)') 'Profile #',i,' : temp,salt,flag_t,flag_s,ms_t,ms_s= ',&
                          Prof(nprof)%data_t(k),Prof(nprof)%data_s(k),Prof(nprof)%flag_t(k),Prof(nprof)%flag_s(k),&
                          Prof(nprof)%ms_t(k),Prof(nprof)%ms_s(k)
                 else
                     write(*,'(a,i3,a,2f10.5)') 'Profile #',i,' : temp,flag_t= ',Prof(nprof)%data_t(k),Prof(nprof)%flag_t(k)
                 endif
              enddo
          endif
          
      else
          if (debug .and. i .le. ndebug) then
              call get_time(tdiff,sec,day)
              write(*,'(a,i3,a,2f10.5)') 'Rejected profile #',i,' : lon,lat= ',Prof(i)%lon,Prof(i)%lat
              do k=1,Prof(i)%levels
                 if (Prof(i)%nvar .eq. 2) then
                     write(*,'(a,i3,a,2f10.5,2i2)') 'Profile #',i,' : temp,salt,flag_t,flag_s= ',Prof(i)%data_t(k),Prof(i)%data_s(k),Prof(i)%flag_t(k),Prof(i)%flag_s(k)
                 else
                     write(*,'(a,i3,a,2f10.5)') 'Profile #',i,' : temp,flag_t= ',Prof(i)%data_t(k),Prof(i)%flag_t(k)
                 endif
              enddo
          endif
      endif

    enddo

    a=nprof
    call mpp_sum(a)
    write(outunit,*) 'A total of ',a,'  profiles are being used for the current analysis step'

    return

  end subroutine get_obs

  subroutine oda_core_init(Domain, Grid, localize)

    use fms_mod, only : open_namelist_file, check_nml_error, close_file
    
    type(domain2d), intent(in) :: Domain
    type(grid_type), target, intent(in) :: Grid
    logical, intent(in), optional :: localize

      
    integer :: ioun, ierr, io_status
    
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, oda_core_nml, iostat=io_status)
      ierr = check_nml_error(io_status,'oda_core_nml')
#else
    ioun = open_namelist_file()
    read(ioun,nml=oda_core_nml,iostat = io_status)
    ierr = check_nml_error(io_status,'oda_core_nml')
    call close_file(ioun)      
#endif

!    allocate(nprof_in_comp_domain(0:mpp_npes()-1))
!    nprof_in_comp_domain = 0
    
    Grd => Grid
    
    call mpp_get_compute_domain(Domain,isc,iec,jsc,jec)
    call mpp_get_data_domain(Domain,isd,ied,jsd,jed)
    call mpp_get_global_domain(Domain,isg,ieg,jsg,jeg)
    nk = size(Grid%z)

    allocate(sum_wgt(isd:ied,jsd:jed,nk))
    allocate(nobs(isd:ied,jsd:jed,nk))

    if (PRESENT(localize)) localize_data = localize
    
    call init_observations(localize_data)

    call write_ocean_data_init()
    
  end subroutine oda_core_init

  subroutine purge_obs()

    num_profiles=0
    num_sfc_obs=0

  end subroutine purge_obs

  subroutine forward_obs_profile(Model_obs, fg_t, fg_s)

! map first guess to observation locations
! note that forward operator only becomes associated after
! this call

    type(ocean_profile_type), dimension(:), intent(inout) ::Model_obs    
    real, dimension(isd:ied,jsd:jed,nk) , intent(in) :: fg_t ! first guess for temperature
    real, dimension(isd:ied,jsd:jed,nk) , intent(in), optional :: fg_s ! first guess for salinity

    integer :: n, i0, j0, k, num_prof, k0
    real :: a,b,c

    character(len=128) :: mesg
    
    num_prof = size(Model_obs)

    sum_wgt = 0.0

    do n = 1, num_prof
       i0 = floor(Model_obs(n)%i_index)
       j0 = floor(Model_obs(n)%j_index)
       a = Model_obs(n)%i_index - i0 
       b = Model_obs(n)%j_index - j0 

       if (a >= 1.0 .or. a < 0.0 ) call mpp_error(FATAL)
       if (b >= 1.0 .or. b < 0.0 ) call mpp_error(FATAL)


       if (i0 < isc-1 .or. i0 > iec) then
           write(mesg,'(a,i4,2x,i4)') 'out of bounds in forward_obs: i0,j0= ',i0,j0
           call mpp_error(FATAL,trim(mesg))
       endif

       if (j0 < jsc-1 .or. j0 > jec) then
           write(mesg,*) 'out of bounds in forward_obs: i0,j0= ',i0,j0
           call mpp_error(FATAL,trim(mesg))
       endif

       if (ASSOCIATED(Model_obs(n)%data_t) .and. Model_obs(n)%accepted) then

           if (ASSOCIATED(Model_obs(n)%Forward_model%wgt))&
                Model_obs(n)%Forward_model%wgt => NULL()
           allocate(Model_obs(n)%Forward_model%wgt(2,2,2,Model_obs(n)%levels))

           Model_obs(n)%Forward_model%wgt = 0.0
           
           do k = 1, Model_obs(n)%levels
              if (Model_obs(n)%flag_t(k) .eq. 0) then
                  k0 = floor(Model_obs(n)%k_index(k))
                  if (k0 < 1 .or. k0 > Grd%nk-1) then
                      write(mesg,*) 'out of bounds in forward_obs: k0= ',k0
                      call mpp_error(FATAL,trim(mesg))
                  endif          
                  c =	 Model_obs(n)%k_index(k) - k0

                  if (c >= 1.0 .or. c < 0.0 ) call mpp_error(FATAL)

                  Model_obs(n)%Forward_model%wgt(1,1,1,k) = (1.0-a)*(1.0-b)*(1.0-c)
                  Model_obs(n)%Forward_model%wgt(2,1,1,k) = a*(1.0-b)*(1.0-c)
                  Model_obs(n)%Forward_model%wgt(1,2,1,k) = (1.0-a)*b*(1.0-c)
                  Model_obs(n)%Forward_model%wgt(2,2,1,k) = a*b*(1.0-c)
                  Model_obs(n)%Forward_model%wgt(1,1,2,k) = (1.0-a)*(1.0-b)*c
                  Model_obs(n)%Forward_model%wgt(2,1,2,k) = a*(1.0-b)*c
                  Model_obs(n)%Forward_model%wgt(1,2,2,k) = (1.0-a)*b*c
                  Model_obs(n)%Forward_model%wgt(2,2,2,k) = a*b*c

                  sum_wgt(i0,j0,k0) = sum_wgt(i0,j0,k0)+&
                       Model_obs(n)%Forward_model%wgt(1,1,1,k)
                  sum_wgt(i0+1,j0,k0) = sum_wgt(i0+1,j0,k0)+&
                       Model_obs(n)%Forward_model%wgt(2,1,1,k)
                  sum_wgt(i0,j0+1,k0) = sum_wgt(i0,j0+1,k0)+&
                       Model_obs(n)%Forward_model%wgt(1,2,1,k)
                  sum_wgt(i0+1,j0+1,k0) = sum_wgt(i0+1,j0+1,k0)+&
                       Model_obs(n)%Forward_model%wgt(2,2,1,k)
                  sum_wgt(i0,j0,k0+1) = sum_wgt(i0,j0,k0+1)+&
                       Model_obs(n)%Forward_model%wgt(1,1,2,k)
                  sum_wgt(i0+1,j0,k0+1) = sum_wgt(i0+1,j0,k0+1)+&
                       Model_obs(n)%Forward_model%wgt(2,1,2,k)
                  sum_wgt(i0,j0+1,k0+1) = sum_wgt(i0,j0+1,k0+1)+&
                       Model_obs(n)%Forward_model%wgt(1,2,2,k)
                  sum_wgt(i0+1,j0+1,k0+1) = sum_wgt(i0+1,j0+1,k0+1)+&
                       Model_obs(n)%Forward_model%wgt(2,2,2,k)
                  
                      
                  Model_obs(n)%data_t(k) = &
                       fg_t(i0,j0,k0)*Model_obs(n)%Forward_model%wgt(1,1,1,k) &
                     + fg_t(i0+1,j0,k0)*Model_obs(n)%Forward_model%wgt(2,1,1,k) &
                     + fg_t(i0,j0+1,k0)*Model_obs(n)%Forward_model%wgt(1,2,1,k) &
                     + fg_t(i0+1,j0+1,k0)*Model_obs(n)%Forward_model%wgt(2,2,1,k) &
                     + fg_t(i0,j0,k0+1)*Model_obs(n)%Forward_model%wgt(1,1,2,k) &
                     + fg_t(i0+1,j0,k0+1)*Model_obs(n)%Forward_model%wgt(2,1,2,k) &
                     + fg_t(i0,j0+1,k0+1)*Model_obs(n)%Forward_model%wgt(1,2,2,k) &
                     + fg_t(i0+1,j0+1,k0+1)*Model_obs(n)%Forward_model%wgt(2,2,2,k)

                  if (ASSOCIATED(Model_obs(n)%data_s) .and. PRESENT(fg_s)) then
                      Model_obs(n)%data_s(k) = &
                       fg_s(i0,j0,k0)*Model_obs(n)%Forward_model%wgt(1,1,1,k) &
                     + fg_s(i0+1,j0,k0)*Model_obs(n)%Forward_model%wgt(2,1,1,k) &
                     + fg_s(i0,j0+1,k0)*Model_obs(n)%Forward_model%wgt(1,2,1,k) &
                     + fg_s(i0+1,j0+1,k0)*Model_obs(n)%Forward_model%wgt(2,2,1,k) &
                     + fg_s(i0,j0,k0+1)*Model_obs(n)%Forward_model%wgt(1,1,2,k) &
                     + fg_s(i0+1,j0,k0+1)*Model_obs(n)%Forward_model%wgt(2,1,2,k) &
                     + fg_s(i0,j0+1,k0+1)*Model_obs(n)%Forward_model%wgt(1,2,2,k) &
                     + fg_s(i0+1,j0+1,k0+1)*Model_obs(n)%Forward_model%wgt(2,2,2,k) 
                  endif
              else
                  if (ASSOCIATED(Model_obs(n)%data_t)) then
                      Model_obs(n)%data_t(k) = missing_value
                  endif
                  if (ASSOCIATED(Model_obs(n)%data_s)) then
                      Model_obs(n)%data_s(k) = missing_value
                  endif                  
              endif
           enddo
       endif
    enddo

    return

  end subroutine forward_obs_profile





  subroutine forward_obs_sfc(Sfc, Guess, Diff)
    type(ocean_surface_type), intent(in) :: Sfc
    type(ocean_dist_type), intent(in) :: Guess
    type(ocean_surface_type), intent(inout) :: Diff


    return

  end subroutine forward_obs_sfc

  subroutine backward_obs_profile(Obs,model_t,model_s)
!
! map observations back to model locations
!
    type(ocean_profile_type), dimension(:), intent(in) :: Obs
    real, dimension(isd:ied,jsd:jed,nk), intent(inout) :: model_t
    real, dimension(isd:ied,jsd:jed,nk), intent(inout), optional :: model_s    

    real :: tmp
    integer :: i0,j0,k0,k,n

    model_t = 0.0
    if (PRESENT(model_s)) model_s = 0.0
    
    do n=1,size(Obs)
       if (ASSOCIATED(Obs(n)%data_t) .and. Obs(n)%accepted) then
           i0 = floor(Obs(n)%i_index)
           j0 = floor(Obs(n)%j_index) 
! profiles are assumed to lie           
! in domain bounded by first halo points

           if (i0 < isd .or. i0 > ied-1) cycle
           if (j0 < jsd .or. j0 > jed-1) cycle
           
           if (.not.ASSOCIATED(Obs(n)%Forward_model%wgt)) call mpp_error(FATAL,'forward operator not associated with obs')
           
           do k=1, Obs(n)%levels
              if (Obs(n)%flag_t(k) .eq. 0) then
                  k0 = floor(Obs(n)%k_index(k))
                  if (k0 < 1 .or. k0 > Grd%nk-1) call mpp_error(FATAL,'profile k indx out of bnds')
                  
                  tmp = Obs(n)%data_t(k) 
                  model_t(i0,j0,k0)       = model_t(i0,j0,k0) + tmp*Obs(n)%Forward_model%wgt(1,1,1,k)
                  model_t(i0+1,j0,k0)     = model_t(i0+1,j0,k0) + tmp*Obs(n)%Forward_model%wgt(2,1,1,k)
                  model_t(i0,j0+1,k0)     = model_t(i0,j0+1,k0) + tmp*Obs(n)%Forward_model%wgt(1,2,1,k)
                  model_t(i0+1,j0+1,k0)   = model_t(i0+1,j0+1,k0) + tmp*Obs(n)%Forward_model%wgt(2,2,1,k)
                  model_t(i0,j0,k0+1)     = model_t(i0,j0,k0+1) + tmp*Obs(n)%Forward_model%wgt(1,1,2,k)
                  model_t(i0+1,j0,k0+1)   = model_t(i0+1,j0,k0+1) + tmp*Obs(n)%Forward_model%wgt(2,1,2,k)
                  model_t(i0,j0+1,k0+1)   = model_t(i0,j0+1,k0+1) + tmp*Obs(n)%Forward_model%wgt(1,2,2,k)
                  model_t(i0+1,j0+1,k0+1) = model_t(i0+1,j0+1,k0+1) + tmp*Obs(n)%Forward_model%wgt(2,2,2,k)

                  if (PRESENT(model_s)) then

                      tmp = Obs(n)%data_s(k) 
                      model_s(i0,j0,k0)       = model_s(i0,j0,k0) + tmp*Obs(n)%Forward_model%wgt(1,1,1,k)
                      model_s(i0+1,j0,k0)     = model_s(i0+1,j0,k0) + tmp*Obs(n)%Forward_model%wgt(2,1,1,k)
                      model_s(i0,j0+1,k0)     = model_s(i0,j0+1,k0) + tmp*Obs(n)%Forward_model%wgt(1,2,1,k)
                      model_s(i0+1,j0+1,k0)   = model_s(i0+1,j0+1,k0) + tmp*Obs(n)%Forward_model%wgt(2,2,1,k)
                      model_s(i0,j0,k0+1)     = model_s(i0,j0,k0+1) + tmp*Obs(n)%Forward_model%wgt(1,1,2,k)
                      model_s(i0+1,j0,k0+1)   = model_s(i0+1,j0,k0+1) + tmp*Obs(n)%Forward_model%wgt(2,1,2,k)
                      model_s(i0,j0+1,k0+1)   = model_s(i0,j0+1,k0+1) + tmp*Obs(n)%Forward_model%wgt(1,2,2,k)
                      model_s(i0+1,j0+1,k0+1) = model_s(i0+1,j0+1,k0+1) + tmp*Obs(n)%Forward_model%wgt(2,2,2,k)                      
                  endif

              end if

                  
           end do
       end if
    end do


    where(sum_wgt > 0.0)
        model_t = model_t /sum_wgt
    elsewhere
        model_t = 0.0
    end where

    if (PRESENT(model_s)) then
        where(sum_wgt > 0.0)
            model_s = model_s /sum_wgt
        elsewhere
            model_s = 0.0
        end where
    endif
    
  end subroutine backward_obs_profile


  subroutine backward_obs_sfc(Obs,model)

    type(ocean_surface_type), dimension(:), intent(in) :: Obs
    real, dimension(isd:ied,jsd:jed,nk), intent(inout) :: model


  end subroutine backward_obs_sfc
  
  subroutine assign_forward_model_profile(Obs1,Obs2)

    type(ocean_profile_type), dimension(:), target, intent(in) :: Obs1
    type(ocean_profile_type), dimension(:), intent(inout) :: Obs2    


    integer :: n

    if (size(Obs1) .ne. size(Obs2)) call mpp_error(FATAL)

    do n=1,size(Obs1)

       Obs2(n)%Forward_model%wgt => Obs1(n)%Forward_model%wgt

    enddo

  end subroutine assign_forward_model_profile


  subroutine assign_forward_model_sfc(Obs1,Obs2)

    type(ocean_surface_type), target, intent(in) :: Obs1
    type(ocean_surface_type), intent(inout) :: Obs2    
    

    return
  end subroutine assign_forward_model_sfc
  
  subroutine diff_obs_profile(prof1, prof2, Diff)

    type(ocean_profile_type), dimension(:), intent(in) :: prof1
    type(ocean_profile_type), dimension(:), intent(in) :: prof2    
    type(ocean_profile_type), dimension(:), intent(inout) :: Diff

    integer :: n,k

    if (size(prof1) .ne. size(prof2) ) call mpp_error(FATAL)
    
    if (size(prof1) .ne. size(Diff) ) call mpp_error(FATAL)    


    do n=1,size(prof1)
       do k=1,prof1(n)%levels
          if (prof1(n)%flag_t(k) .eq. 0) then
              Diff(n)%data_t(k) = prof2(n)%data_t(k)-prof1(n)%data_t(k)
          else
              Diff(n)%data_t(k) = missing_value
          endif
          if (abs(Diff(n)%data_t(k)) .gt. max_misfit) then
              Diff(n)%flag_t(k) = 1
          endif
         if (ASSOCIATED(prof1(n)%data_s)) then
             if (prof1(n)%flag_s(k) .eq. 0) then
                 Diff(n)%data_s(k) = prof2(n)%data_s(k)-prof1(n)%data_s(k)
             else
                 Diff(n)%data_s(k) = missing_value
             endif
             if (abs(Diff(n)%data_s(k)) .gt. max_misfit) then
                 Diff(n)%flag_s(k) = 1
             endif
         endif
       enddo
    enddo


  end subroutine diff_obs_profile

  subroutine diff_obs_sfc(prof1,prof2,Diff)

    type(ocean_surface_type), dimension(:), intent(in) :: prof1, prof2
    type(ocean_surface_type), dimension(:), intent(inout) :: Diff


  end subroutine diff_obs_sfc
  
  subroutine copy_obs_prof(obs_in, obs_out)

    type(ocean_profile_type), dimension(:), intent(in) :: obs_in
    type(ocean_profile_type), dimension(:), intent(inout) :: obs_out


    integer :: n

    if (size(obs_in) .ne. size(obs_out)) call mpp_error(FATAL,&
         'size mismatch in call to copy_obs_prof')


    do n=1,size(obs_in)
       call nullify_obs(obs_out(n))
       Obs_out(n)%nvar = Obs_in(n)%nvar
       Obs_out(n)%project = Obs_in(n)%project
       Obs_out(n)%probe = Obs_in(n)%probe
       Obs_out(n)%ref_inst = Obs_in(n)%ref_inst
       Obs_out(n)%wod_cast_num = Obs_in(n)%wod_cast_num
       Obs_out(n)%fix_depth = Obs_in(n)%fix_depth
       Obs_out(n)%ocn_vehicle = Obs_in(n)%ocn_vehicle
       Obs_out(n)%database_id = Obs_in(n)%database_id
       Obs_out(n)%levels = Obs_in(n)%levels
       Obs_out(n)%profile_flag = Obs_in(n)%profile_flag
       Obs_out(n)%profile_flag_s = Obs_in(n)%profile_flag_s       
       Obs_out(n)%lon = Obs_in(n)%lon
       Obs_out(n)%lat = Obs_in(n)%lat
       Obs_out(n)%accepted = Obs_in(n)%accepted
       ALLOCATE(Obs_out(n)%depth(Obs_in(n)%levels))
       Obs_out(n)%depth(:) = Obs_in(n)%depth(:)
       ALLOCATE(Obs_out(n)%data_t(Obs_in(n)%levels))
       Obs_out(n)%data_t(:) = Obs_in(n)%data_t(:)
       ALLOCATE(Obs_out(n)%flag_t(Obs_in(n)%levels))
       Obs_out(n)%flag_t(:) = Obs_in(n)%flag_t(:)
       if (ASSOCIATED(Obs_in(n)%data_s)) then
           ALLOCATE(Obs_out(n)%data_s(Obs_in(n)%levels))
           Obs_out(n)%data_s(:) = Obs_in(n)%data_s(:)
           ALLOCATE(Obs_out(n)%flag_s(Obs_in(n)%levels))
           Obs_out(n)%flag_s(:) = Obs_in(n)%flag_s(:)          
       endif
       
       Obs_out(n)%time = Obs_in(n)%time
       Obs_out(n)%yyyy = Obs_in(n)%yyyy
       Obs_out(n)%mmdd = Obs_in(n)%mmdd
       Obs_out(n)%i_index = Obs_in(n)%i_index
       Obs_out(n)%j_index = Obs_in(n)%j_index
       ALLOCATE(Obs_out(n)%k_index(Obs_in(n)%levels))          
       Obs_out(n)%k_index = Obs_in(n)%k_index
       ALLOCATE(Obs_out(n)%ms_t(Obs_in(n)%levels))          
       Obs_out(n)%ms_t = Obs_in(n)%ms_t
       if (ASSOCIATED(Obs_in(n)%ms_s)) then       
           ALLOCATE(Obs_out(n)%ms_s(Obs_in(n)%levels))          
           Obs_out(n)%ms_s = Obs_in(n)%ms_s
       endif
       


       Obs_out(n)%tdiff = Obs_in(n)%tdiff
       Obs_out(n)%nbr_index = Obs_in(n)%nbr_index
       Obs_out(n)%nbr_dist  = Obs_in(n)%nbr_dist
       if (ASSOCIATED(Obs_in(n)%Model_grid)) &
            Obs_out(n)%Model_grid => Obs_in(n)%Model_Grid
    enddo
 
end subroutine copy_obs_prof

  subroutine copy_obs_sfc(Obs_in, Obs_out)
    type(ocean_surface_type), dimension(:), intent(in) :: Obs_in
    type(ocean_surface_type), dimension(:), intent(inout) :: Obs_out


    return

  end subroutine copy_obs_sfc

  subroutine adjust_obs_error_profile(Prof)

    use time_manager_mod, only : get_time
    
    type(ocean_profile_type), dimension(:), intent(inout) :: Prof
    integer :: secs, days, n, k, secs_w, days_w, m
    real :: tfac, Ims
    
    do n=1,size(Prof)
       call get_time(Prof(n)%tdiff,secs, days)
       m=Prof(n)%probe
       call get_time(time_window(m),secs_w,days_w)
       tfac = (days + secs/86400.) / days_w
       tfac = 1. - min(1.,tfac)
       if (tfac > 1.0 ) call mpp_error(FATAL)
       if (tfac < 0.0 ) call mpp_error(FATAL)
       do k=1,Prof(n)%levels
           Prof(n)%ms_t(k) = 1.0/ max(1.e-1,tfac) * Prof(n)%ms_t(k)
           if (ASSOCIATED(Prof(n)%data_s)) then
               Prof(n)%ms_s(k) = 1.0/ max(1.e-1,tfac) * Prof(n)%ms_s(k)
          endif
       end do
    end do

  end subroutine adjust_obs_error_profile

  subroutine adjust_obs_error_sfc(Diff)

    type(ocean_surface_type), intent(inout) :: Diff

    return
    
  end subroutine adjust_obs_error_sfc


  subroutine mult_obs_I_mse_profile(Obs)

    type(ocean_profile_type), dimension(:), intent(inout) :: Obs

    integer :: n,k
    real :: Ims
    
    do n=1,size(Obs)
       do k = 1, Obs(n)%levels
          Ims = 1./Obs(n)%ms_t(k)
          if (Obs(n)%flag_t(k) .eq. 0) Obs(n)%data_t(k) = Ims*Obs(n)%data_t(k)
          if (ASSOCIATED(Obs(n)%data_s)) then
              Ims = 1/Obs(n)%ms_s(k)
              if (Obs(n)%flag_s(k) .eq. 0) Obs(n)%data_s(k) = Ims*Obs(n)%data_s(k)
          endif
       end do
    end do
    
  end subroutine mult_obs_I_mse_profile

  subroutine mult_obs_I_mse_sfc(a, Obs)

    real, dimension(:), intent(in) :: a
    type(ocean_surface_type), intent(inout) :: Obs

  end subroutine mult_obs_I_mse_sfc


       

 ! </SUBROUTINE>
! <FUNCTION NAME="lowercase">
!   <DESCRIPTION>
! Turn a string from uppercase to lowercase, do nothing if the
! string is already in lowercase.
!   </DESCRIPTION>
 function lowercase (cs) 
 character(len=*), intent(in) :: cs
 character(len=len(cs))       :: lowercase 
 character :: ca(len(cs)) 

 integer, parameter :: co=iachar('a')-iachar('A') ! case offset
    
    ca = transfer(cs,"x",len(cs)) 
    where (ca >= "A" .and. ca <= "Z") ca = achar(iachar(ca)+co) 
    lowercase = transfer(ca,cs) 
    
  end function lowercase

  subroutine init_observations(localize)  

    use fms_mod, only : open_namelist_file,close_file,check_nml_error
    use mpp_io_mod, only : mpp_open, MPP_ASCII, MPP_RDONLY, MPP_MULTI, MPP_SINGLE
    use mpp_domains_mod, only : mpp_global_field
    
    logical, intent(in), optional :: localize

    integer :: data_window = 15 ! default data half-window is 15 days

    integer :: i,j
    
    
    type obs_entry_type
       character(len=128) :: filename
       character(len=16)  :: file_type
    end type obs_entry_type

    namelist /ocean_obs_nml/ data_window, max_prof_spacing, min_prof_depth
    
    character(len=128) :: input_files(max_files) = ''
    integer :: nfiles, filetype(max_files), ioun, io_status, ierr,&
                unit, nrecs, n
    character(len=256) :: record
    type(obs_entry_type) :: tbl_entry

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, ocean_obs_nml, iostat=io_status)
      ierr = check_nml_error(io_status,'ocean_obs_nml')
#else
    ioun = open_namelist_file()
    read(ioun,nml=ocean_obs_nml,iostat = io_status)
    ierr = check_nml_error(io_status,'ocean_obs_nml')
    call close_file(ioun)    
#endif

    time_window(:) = set_time(0,data_window)

    nfiles=0
    
    if (file_exist('ocean_obs_table') ) then
        call mpp_open(unit,'ocean_obs_table',action=MPP_RDONLY)
        nfiles = 0;nrecs=0
        do while (nfiles <= max_files)
           read(unit,'(a)',end=99,err=98) record
           nrecs=nrecs+1
           if (record(1:1) == '#') cycle
           read(record,*,err=98,end=98) tbl_entry
           nfiles=nfiles+1       
           input_files(nfiles) = tbl_entry%filename
           select case (trim(tbl_entry%file_type))
           case ('profiles')
               filetype(nfiles)    = PROFILE_FILE
           case ('sfc')
               filetype(nfiles)    = SFC_FILE
           case ('idealized')
               filetype(nfiles)    = IDEALIZED_PROFILES
           case default
               call mpp_error(FATAL,'error in obs_table entry format')
           end select
98         continue
        enddo
        call mpp_error(FATAL,' number of obs files exceeds max_files parameter')
99      continue

    endif
    num_profiles=0
    num_sfc_obs=0
    
! get local indices for Model grid
! Since we currently only support regular grids, the
! input 2-d grid array is converted to 1-d
! halo points are added

!    xhalo=isc-isd
!    yhalo=jsc-jsd
!    if (xhalo.ne.ied-iec) call mpp_error(FATAL)
!    if (yhalo.ne.jed-jec) call mpp_error(FATAL)    

    allocate(x_grid(isg-1:ieg+1))
    allocate(y_grid(jsg-1:jeg+1))


    x_grid(isg:ieg) = Grd%x(isg:ieg,jsg)
    y_grid(jsg:jeg) = Grd%y(ieg/4,jsg:jeg)

    allocate(Profiles(max_profiles))

     if (Grd%cyclic) then
         x_grid(isg-1) = x_grid(ieg) - 360. ! assume grid is modulo 360 which is reasonable for data assimilation
         x_grid(ieg+1) = x_grid(isg) + 360.
     else
         x_grid(isg-1) = x_grid(isg) - 1.e-10
         x_grid(ieg+1) = x_grid(ieg) + 1.e-10
     endif

     y_grid(jsg-1) = y_grid(jsg) - 1.e-10
     y_grid(jeg+1) = y_grid(jeg) + 1.e-10
     
    
    do n=1, nfiles
       select case (filetype(n))
       case (PROFILE_FILE)
           call open_profile_dataset(trim(input_files(n)), localize)
       case (IDEALIZED_PROFILES)
           call create_ideal_profiles(localize)
       case default
          call mpp_error(FATAL,'filetype not currently supported')
       end select
    enddo


    return

  end subroutine init_observations
  
   subroutine add_tidal_error(Prof)
! NOT IMPLEMENTED YET !!!
     type(ocean_profile_type), intent(inout) :: Prof

     integer :: k
     real :: dtdz, err, a1, a2
    
     if (.not.ASSOCIATED(prof%ms_t)) then
         allocate(prof%ms_t(prof%levels))
         prof%ms_t(:) = min_obs_err_t
     endif
     
     do k=2,prof%levels - 1
        if (prof%flag_t(k-1) .eq. 0 .and. prof%flag_t(k+1) .eq. 0) then 
            dtdz = (prof%data_t(k+1)-prof%data_t(k-1))/(prof%depth(k+1)-prof%depth(k-1))
            a1 = abs(dtdz) * eta_tide_const
            err = max(a1,min_obs_err_t)
            prof%ms_t(k) = err*err
            if (ASSOCIATED(prof%data_s)) then
                dtdz = (prof%data_s(k+1)-prof%data_s(k-1))/(prof%depth(k+1)-prof%depth(k-1))
                a1 = abs(dtdz) * eta_tide_const
                err = max(a1,min_obs_err_s)
                prof%ms_s(k) = err*err
            endif
        endif
     enddo

   end subroutine add_tidal_error

  subroutine create_ideal_profiles(localize)
!
    use field_manager_mod, only: MODEL_OCEAN, parse, find_field_index, get_field_methods, method_type, get_field_info
    
    logical, intent(in), optional :: localize
    logical :: localize_data = .true.
    integer, parameter :: nlevels = 100 ! number of vertical levels for idealized profiles
    real, parameter :: width_trans = 250.0 ! with over which to transition from sfc value to bottom value
    real, parameter :: bot_depth = 2000.0 ! bottom depth for idealized profiles
    real, allocatable, dimension(:) :: lon,lat, sst, sss, bot_temp, bot_salt, depth
    real, allocatable, dimension(:,:) :: temp, salt, temp_error, salt_error
    integer, allocatable, dimension(:) :: yr, mon, day, hr, mm, ss
    integer :: nstation, unit, n, noobs, i, k
    real :: ri0,rj0,rk0, mid_depth, dtdf, temp_cent, depthC_I_trans, dsdf, salt_cent
    type(time_type) :: profile_time
    logical :: data_is_local
    integer :: model, parse_ok, cpe
    integer :: i0,j0,k0
    real :: dz, a, dx1, dx2, dy1, dy2
    
    real :: temp_missing=missing_value,salt_missing=missing_value,depth_missing=missing_value
    character(len=32) :: fld_type, fld_name
    type(method_type), allocatable, dimension(:) :: ocean_obs_methods
    
    if (PRESENT(localize)) localize_data = localize


    cpe = mpp_pe()

    dx1 = (x_grid(isc)-x_grid(isc-1))/2.0
    dx2 = (x_grid(iec+1)-x_grid(iec))/2.0
    dy1 = (y_grid(jsc)-y_grid(jsc-1))/2.0
    dy2 = (y_grid(jec+1)-y_grid(jec))/2.0
    
    model = model_ocean
    n = find_field_index(model,'ideal_profiles')
    call get_field_info(n,fld_type,fld_name,model,noobs)

    allocate(ocean_obs_methods(noobs))
    allocate(lon(noobs),lat(noobs), yr(noobs), mon(noobs), day(noobs), &
         hr(noobs), mm(noobs), ss(noobs), &
         sst(noobs), sss(noobs), bot_temp(noobs), bot_salt(noobs))
    allocate(temp(noobs,nlevels), salt(noobs,nlevels), temp_error(noobs,nlevels), salt_error(noobs,nlevels))
    allocate(depth(nlevels))
    
    call get_field_methods(n,ocean_obs_methods)
    do i=1,noobs
       parse_ok = parse(ocean_obs_methods(i)%method_control,'lon',lon(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error oda_core_mod: idealized_ocean_profiles table entry error')
       if (lon(i) .lt. x_grid(isg) ) lon(i) = lon(i) + 360.0
       if (lon(i) .gt. x_grid(ieg) ) lon(i) = lon(i) - 360.0       
       parse_ok = parse(ocean_obs_methods(i)%method_control,'lat',lat(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error oda_core_mod: idealized_ocean_profiles table entry error')
       parse_ok = parse(ocean_obs_methods(i)%method_control,'yr',yr(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error oda_core_mod: idealized_ocean_profiles table entry error')              
       parse_ok = parse(ocean_obs_methods(i)%method_control,'mon',mon(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error oda_core_mod: idealized_ocean_profiles table entry error')
       parse_ok = parse(ocean_obs_methods(i)%method_control,'day',day(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error oda_core_mod: idealized_ocean_profiles table entry error')
       parse_ok = parse(ocean_obs_methods(i)%method_control,'hr',hr(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error oda_core_mod: idealized_ocean_profiles table entry error')
       parse_ok = parse(ocean_obs_methods(i)%method_control,'mm',mm(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error oda_core_mod: idealized_ocean_profiles table entry error')
       parse_ok = parse(ocean_obs_methods(i)%method_control,'ss',ss(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error oda_core_mod: idealized_ocean_profiles table entry error')
       parse_ok = parse(ocean_obs_methods(i)%method_control,'sst',sst(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error oda_core_mod: idealized_ocean_profiles table entry error')
       parse_ok = parse(ocean_obs_methods(i)%method_control,'sss',sss(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error oda_core_mod: idealized_ocean_profiles table entry error')
       parse_ok = parse(ocean_obs_methods(i)%method_control,'bot_temp',bot_temp(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error oda_core_mod: idealized_ocean_profiles table entry error')
       parse_ok = parse(ocean_obs_methods(i)%method_control,'bot_salt',bot_salt(i))
       if (parse_ok == 0) call mpp_error(FATAL,'==>Error oda_core_mod: idealized_ocean_profiles table entry error')
    enddo

    if (noobs == 0 ) then
        call mpp_error(FATAL,'==> NOTE from oda_core_mod: no idealized profiles given in field table')
        return
    endif

    dz = bot_depth/(nlevels-1)
    
    do k=1,nlevels
       depth(k) = (k-1)*dz
    enddo
    
    mid_depth = bot_depth/2.0
    depthC_I_trans = mid_depth / width_trans
    do i=1,noobs
       dtdf = (bot_temp(i) - sst(i)) / (2.0*atan(1.0) + atan(depthC_I_trans))
       temp_cent = sst(i) + dtdf * atan(depthC_I_trans)
       temp(i,1) = sst(i)
       do k=2,nlevels-1
          temp(i,k) = temp_cent + dtdf * atan((depth(k)  - mid_depth)/width_trans)
       enddo
       temp(i,nlevels) = bot_temp(i)

       dsdf = (bot_salt(i) - sss(i)) / (2.0*atan(1.0) + atan(depthC_I_trans))
       salt_cent = sss(i) + dsdf * atan(depthC_I_trans)
       salt(i,1) = sss(i)
       do k=2,nlevels-1
          salt(i,k) = salt_cent + dsdf * atan((depth(k)  - mid_depth)/width_trans)
       enddo
       salt(i,nlevels) = bot_salt(i)
    enddo


    num_profiles=0
    do i=1,noobs

       data_is_local = .false.


! localized data is within region bounded by halo points
! (halo size = 1) adjacent to boundary points of computational domain
       
       if (lon(i) >= x_grid(isc-1) .and. &
            lon(i) <  x_grid(iec+1) .and. &
            lat(i) >= y_grid(jsc-1) .and. &
            lat(i) <  y_grid(jec+1)) data_is_local = .true.

      
       profile_time = set_date(yr(i),mon(i),day(i),hr(i),mm(i),ss(i))
       
       if ( data_is_local .OR. .NOT.localize_data) then
           if (lon(i) >= x_grid(isc)-dx1 .and. &
                lon(i) < x_grid(iec)+dx2 .and. &
                lat(i) >= y_grid(jsc)-dy1 .and. &
                lat(i) <  y_grid(jec)+dy2) then
!               nprof_in_comp_domain(cpe) = nprof_in_comp_domain(cpe)+1
           endif
           num_profiles=num_profiles+1
           if (num_profiles > max_profiles) then
               call mpp_error(FATAL,'maximum number of profiles exceeded.  Resize parameter max_profiles in ocean_obs_mod')
           endif


           profiles(num_profiles)%Model_Grid => Grd
           profiles(num_profiles)%nvar = 2
           profiles(num_profiles)%profile_flag = 0
           profiles(num_profiles)%profile_flag_s = 0
           profiles(num_profiles)%accepted = .true.
           allocate(profiles(num_profiles)%depth(nlevels))
           profiles(num_profiles)%depth=depth(1:nlevels)
           allocate(profiles(num_profiles)%data_t(nlevels))
           profiles(num_profiles)%data_t=temp(i,:)
           allocate(profiles(num_profiles)%flag_t(nlevels))
           profiles(num_profiles)%flag_t= 0               

           allocate(profiles(num_profiles)%data_s(nlevels))
           profiles(num_profiles)%data_s=salt(i,:)
           allocate(profiles(num_profiles)%flag_s(nlevels))
           profiles(num_profiles)%flag_s= 0

           profiles(num_profiles)%probe = 0.
           profiles(num_profiles)%levels = nlevels
           profiles(num_profiles)%lat = lat(i)
           profiles(num_profiles)%lon = lon(i)
           allocate(profiles(num_profiles)%ms_t(nlevels))
           profiles(num_profiles)%ms_t(:) = min_obs_err_t ! default error variance for temperature
           allocate(profiles(num_profiles)%ms_s(nlevels))
           profiles(num_profiles)%ms_s(:) = min_obs_err_s  ! default error variance for salinity

           profiles(num_profiles)%time = profile_time
           
! calculate interpolation coefficients (make sure to account for grid offsets here!)
! note that this only works for lat/lon grids
           
           ri0 = frac_index(lon(i), x_grid(isg-1:ieg+1)) - 1.
           rj0 = frac_index(lat(i), y_grid(jsg-1:jeg+1)) - 1.
           i0 = floor(ri0)
           j0 = floor(rj0)
           Profiles(num_profiles)%i_index = ri0
           Profiles(num_profiles)%j_index = rj0           
           Profiles(num_profiles)%accepted = .true.
           if (i0 < 0 .or. j0 < 0) then
               Profiles(num_profiles)%accepted = .false.
           endif
           if (i0 > ieg+1 .or. j0 > jeg+1) then
               call mpp_error(FATAL,'grid lat/lon index is out of bounds ')
           endif
           if (i0 < isc-1 .or. i0 > iec) then
               call mpp_error(FATAL,'grid lat/lon index is out of bounds ')
           endif
           if (j0 < jsc-1 .or. j0 > jec) then
               call mpp_error(FATAL,'grid lat/lon index is out of bounds ')
           endif
           if (Profiles(num_profiles)%accepted ) then
               if (Grd%mask(i0,j0,1) == 0.0 .or. &
                    Grd%mask(i0+1,j0,1) == 0.0 .or. &
                    Grd%mask(i0,j0+1,1) == 0.0 .or. &
                    Grd%mask(i0+1,j0+1,1) == 0.0) then
                   Profiles(num_profiles)%accepted = .false.
               endif
           endif


           
           if (Profiles(num_profiles)%accepted) then
               allocate(Profiles(num_profiles)%k_index(Profiles(num_profiles)%levels))
               do k=1, Profiles(num_profiles)%levels
                  rk0 = frac_index(Profiles(num_profiles)%depth(k), Grd%z(:))
                  k0 = floor(rk0)
                  if ( k0 == -1) then
                      if (Profiles(num_profiles)%depth(k) .ne. missing_value .and. &
                           Profiles(num_profiles)%depth(k) .lt. Grd%z(1)) then
                           k0 = 1
                           rk0 = 1.0
                       endif
                   endif


                  if (k0 .gt. size(Grd%z)-1 ) then
                      write(*,*) 'k0 out of bounds, rk0,k0= ',rk0,k0
                     write(*,*) 'Z_bound= ',Grd%z_bound
                      write(*,*) 'Profile%depth= ',Profiles(num_profiles)%depth
                      call mpp_error(FATAL)
                  endif
                  
                  Profiles(num_profiles)%k_index(k) = rk0
                  
                  if (Profiles(num_profiles)%flag_t(k) .eq. 0) then
                      if (Grd%mask(i0,j0,k0) == 0.0 .or. &
                          Grd%mask(i0+1,j0,k0) == 0.0 .or. &
                          Grd%mask(i0,j0+1,k0) == 0.0 .or. &
                          Grd%mask(i0+1,j0+1,k0) == 0.0) then
                          Profiles(num_profiles)%flag_t(k) = 1
                      endif
                      if (Grd%mask(i0,j0,k0+1) == 0.0 .or. &
                          Grd%mask(i0+1,j0,k0+1) == 0.0 .or. &
                          Grd%mask(i0,j0+1,k0+1) == 0.0 .or. &
                          Grd%mask(i0+1,j0+1,k0+1) == 0.0) then
                          Profiles(num_profiles)%flag_t(k) = 1
                      endif
                      if (Profiles(num_profiles)%data_t(k) == missing_value &
                         .or. Profiles(num_profiles)%depth(k) == missing_value) then
                          Profiles(num_profiles)%flag_t(k) = 1
                      endif
                  endif
                  
               enddo
           endif          
       endif

    enddo

!    a = nprof_in_comp_domain(cpe)

!    call mpp_broadcast(nprof_in_comp_domain(cpe),cpe)
    
!    call mpp_sum(a)

!    write(stdout(),*) 'A grand total of ',a,' profiles satisify acceptance criteria'

!    do i=0,mpp_npes()-1
!       write(stdout(),*) 'pe=',i,'profile count=',nprof_in_comp_domain(i)
!    enddo
    
  end subroutine create_ideal_profiles


  subroutine nullify_obs_prof(profile)

    type(ocean_profile_type), intent(inout) :: profile


    profile%nvar = 0
    profile%project=0.
    profile%probe=0.
    profile%ref_inst=0.
    profile%wod_cast_num=0
    profile%fix_depth=0.
    profile%ocn_vehicle=0.
    profile%database_id=0.
    profile%levels=0
    profile%profile_flag=-1
    profile%profile_flag_s=-1
    profile%lon=-1.0e10
    profile%lat=-1.0e10
    profile%accepted=.false.
    profile%nlinks=0
    if (ASSOCIATED(profile%next)) profile%next=>NULL()
    if (ASSOCIATED(profile%depth)) profile%depth=>NULL()
    if (ASSOCIATED(profile%data_t)) profile%data_t=>NULL()
    if (ASSOCIATED(profile%data_s)) profile%data_s=>NULL()
    if (ASSOCIATED(profile%flag_t)) profile%flag_t=>NULL()
    if (ASSOCIATED(profile%flag_s)) profile%flag_s=>NULL()
    profile%temp_err=0.0
    profile%salt_err=0.0
    if (ASSOCIATED(profile%ms_t)) profile%ms_t=>NULL()
    if (ASSOCIATED(profile%ms_s)) profile%ms_s=>NULL()    
    profile%time = set_time(0,0)
    profile%yyyy = 0
    profile%mmdd = 0
    if (ASSOCIATED(profile%model_time)) profile%model_time=>NULL()
    if (ASSOCIATED(profile%model_grid)) profile%model_grid=>NULL()
    if (ASSOCIATED(profile%k_index)) profile%k_index=>NULL()
    profile%i_index=-1.0
    profile%j_index=-1.0
    profile%tdiff = set_time(0,0)
    
  end subroutine nullify_obs_prof
  
end module oda_core_mod

module ocean_bihgen_friction_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S. M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! This module computes thickness weighted and density weighted
! time tendency for horizontal velocity arising from 
! biharmonic friction. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes thickness weighted and density weighted
! time tendency for horizontal velocity arising from biharmonic
! friction. 
!
! The viscosity used to determine the strength of the tendency 
! can be a general function of space and time as specified by 
! the Smagorinsky approach as well as a grid-scale dependent
! background viscosity.  The form of the friction operator 
! can be isotropic or anisotropic in the lateral plane. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies and R.W. Hallberg, 2000:
! Biharmonic friction with a Smagorinsky viscosity for use
! in large-scale eddy-permitting ocean models
! Monthly Weather Review, vol. 128, pages 2935-2946.
! </REFERENCE>
!
! <REFERENCE>
! R.D. Smith and J.C. McWilliams, 2003:
! Anisotropic horizontal viscosity for ocean models,
! Ocean Modelling, vol. 5, pages 129-156. 
! </REFERENCE>
!
! <REFERENCE>
! Maltrud and Holloway, 2008: Implementing biharmonic neptune in a
! global eddying ocean model, Ocean Modelling, vol. 21, pages 22-34.
! </REFERENCE>
!
! <REFERENCE>
! Deremble, Hogg, Berloff, and Dewar, 2011:
! On the application of no-slip lateral boundary conditions to coarsely
! resolved ocean models, Ocean Modelling. 
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, 2004: 
! Fundamentals of Ocean Climate Models 
! Princeton University Press
! </REFERENCE>
!
! <REFERENCE>
!  Griffies, Elements of MOM (2012)
! </REFERENCE>
!
! <NOTE>
! The ocean model can generally run with both Laplacian and biharmonic
! friction enabled at the same time.  Such has been found useful 
! for some eddying ocean simulations. 
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_bihgen_friction_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging by printing checksums.  
!  </DATA> 
!
!  <DATA NAME="k_smag_iso" UNITS="dimensionless" TYPE="real">
!  This is the dimensionless Smagorinsky coefficient used to set the scale 
!  of the Smagorinsky isotropic viscosity. 
!  </DATA> 
!  <DATA NAME="k_smag_aniso" UNITS="dimensionless" TYPE="real">
!  This is the dimensionless Smagorinsky coefficient used to set the scale 
!  of the Smagorinsky anisotropic viscosity. 
!  </DATA> 
!  <DATA NAME="vel_micom_iso" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM isotropic viscosity. 
!  </DATA> 
!  <DATA NAME="vel_micom_aniso" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM anisotropic viscosity. 
!  </DATA> 
!
!  <DATA NAME="visc_crit_scale" UNITS="dimensionless" TYPE="real">
!  Scaling factor used to determine the critical viscosity, above which 
!  the viscosity is not allowed to reach. 
!  Use visc_crit_scale < 1.0 for cases where the visc_crit from linear stability 
!  allows for still too large of a viscosity.  Use visc_crit_scale>1.0 when wish 
!  to allow for larger viscosity. Default is visc_crit_scale=1.0.
!  </DATA> 
!
!  <DATA NAME="equatorial_zonal" TYPE="real">
!  Orient the anisotropic friction within a latitudinal band according 
!  to zonal direction. 
!  </DATA> 
!  <DATA NAME="equatorial_zonal_lat" TYPE="real">
!  Latitudinal band to use the zonal friction orientation. 
!  </DATA> 
!  <DATA NAME="eq_vel_micom_iso" TYPE="real">
!  Velocity scale that is used for computing the MICOM isotropic viscosity 
!  within a user specified equatorial band. 
!  </DATA> 
!  <DATA NAME="eq_vel_micom_aniso" TYPE="real">
!  Velocity scale that is used for computing the MICOM anisotropic 
!  viscosity within a user specified equatorial band. 
!  </DATA> 
!  <DATA NAME="eq_lat_micom" TYPE="real">
!  Equatorial latitude band (degrees) within which the MICOM viscosity
!  is set according to eq_vel_micom_iso and eq_vel_micom_aniso.
!  </DATA> 
!  <DATA NAME="bottom_5point" TYPE="logical">
!  To alleviate problems with small partial cells, it is often necessary
!  to reduce the operator to the traditional 5-point Laplacian at the 
!  ocean bottom.  This logical implements this mixing. 
!  Default bottom_5point=.false. 
!  </DATA> 
!  <DATA NAME="vel_micom_bottom" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM viscosity for 
!  5point Laplacian at the bottom. 
!  </DATA> 
!
!  <DATA NAME="ncar_boundary_scaling" TYPE="logical">
!  To enhance the velocity scale used in western boundaries 
!  for the isotropic and anisotropic  background viscosities, 
!  we compute a scaling using the algorithm from the laplacian
!  NCAR anisotropic scheme.
!  Default ncar_boundary_scaling=.false.
!  </DATA> 
!  <DATA NAME="ncar_boundary_scaling_read" TYPE="logical">
!  To read in the ncar boundary scaling field rather than 
!  generating it during initialization.  Generating during 
!  initialization can be a bottle-neck on fine resolution models
!  since there are some global 2d fields needed.  So if the 
!  rescaling is produced once and then saved, it can be read
!  in during subsequent runs without incurring the slowdown 
!  of re-generating the scalings.  
!  Default ncar_boundary_scaling_read=.false.
!  </DATA> 
!  <DATA NAME="ncar_rescale_power" UNITS="dimensionless" TYPE="integer">
!  For determining rescaling of the viscosity so to enhance the 
!  friction near the western boundaries. Default ncar_rescale_power=1.
!  </DATA> 
!  <DATA NAME="ncar_vconst_4" UNITS="1/cm" TYPE="real">
!  Inverse damping length for exponential falloff of the velocity scale 
!  as move eastward away from western boundary. Default ncar_vconst_4=2.e-8.
!  </DATA> 
!  <DATA NAME="ncar_vconst_5" UNITS="dimensionless" TYPE="integer">
!  For determining number of grid points in boundary calculation.
!  Default ncar_vconst_5=3.
!  </DATA> 
!
!  <DATA NAME="neptune" TYPE="logical">
!  Set to true for computing friction relative to Neptune barotropic velocity. 
!  Default neptune=.false. 
!  </DATA> 
!  <DATA NAME="neptune_length_eq" UNITS="m" TYPE="real">
!  Length scale used to compute Neptune velocity at equator.  
!  Default neptune_length_eq= 4.2e3 from Maltrud and Holloway.
!  </DATA> 
!  <DATA NAME="neptune_length_pole" UNITS="m" TYPE="real">
!  Length scale used to compute Neptune velocity at pole. 
!  Default neptune_length_pole= 17.0e3 from Maltrud and Holloway.
!  </DATA> 
!  <DATA NAME="neptune_depth_min" UNITS="m" TYPE="real">
!  Minimum depth scale used for computing Neptune velocity.
!  Default neptune_depth_min=100.0 from Maltrud and Holloway.
!  </DATA> 
!  <DATA NAME="neptune_smooth" TYPE="logical">
!  For doing a horizontal 1-2-1 smoothing on the diagnosed  
!  neptune velocity scale. 
!  Default neptune_smooth=.true.
!  </DATA> 
!  <DATA NAME="neptune_smooth_num" TYPE="integer">
!  Number of smoothing passes for neptune velocity.
!  Default neptune_smooth_num=1.
!  </DATA> 
!  <DATA NAME="neptune_scaling" TYPE="real">
!  Overall scaling parameter to help tune neptune.  
!  Default neptune_scaling=1.0
!  </DATA> 
!
!  <DATA NAME="visc_diverge_scaling" TYPE="real">
!  Dimensionless scaling used for divergence based viscosity.  
!  Default visc_diverge_scaling=0.0 turns off the scheme. 
!  visc_diverge_scaling=10.0 produces sensible viscosities for 
!  1-degree model.  May need tuning for different resolutions.  
!  </DATA> 
!
!  <DATA NAME="use_side_drag_friction" TYPE="logical">
!  For converting friction at U-cells next to walls into 
!  a drag law, as per Deremble et al. Use cdbot_array
!  from ocean_core/ocean_bbc.F90 to compute drag force. 
!  Default use_side_drag_friction=.false.
!  </DATA> 
!  <DATA NAME="side_drag_friction_scaling" TYPE="real">
!  Dimensionless scaling used for cdbot_array when setting
!  side drag friction. So the effective side dragy coefficient
!  is side_drag_friction_scaling*cdbot_array.  
!  Default side_drag_friction_scaling=1.0.
!  </DATA> 
!  <DATA NAME="side_drag_friction_uvmag_max" UNITS="m/s" TYPE="real">
!  Maximum magnitude of horizontal velocity used to compute the 
!  side drag friction. This parameter can be useful especially
!  for pressure models where the bottom cells can be quite thin 
!  and subject to sporadic large magnitudes.  We do the same thing with 
!  bottom drag calculations. 
!  Default side_drag_friction_uvmag_max=10.0.
!  </DATA> 
!  <DATA NAME="side_drag_friction_max" UNITS="N/m^2" TYPE="real">
!  Maximum magnitude of the side drag induced friction. 
!  This parameter can be useful especially for pressure models 
!  where the bottom cells can be quite thin and subject to sporadic
!  large magnitudes.  We do the same thing with bottom drag calculations. 
!  Default side_drag_friction_max=1.0.
!  </DATA> 
!
!</NAMELIST>
!
use constants_mod,       only: pi, radius, epsln
use diag_manager_mod,    only: register_diag_field, register_static_field
use fms_mod,             only: open_namelist_file, check_nml_error
use fms_mod,             only: write_version_number, close_file
use fms_mod,             only: FATAL, NOTE, stdout, stdlog, read_data
use mpp_domains_mod,     only: mpp_update_domains, mpp_global_field, XUPDATE 
use mpp_domains_mod,     only: mpp_global_min, mpp_global_max, BGRID_NE
use mpp_mod,             only: input_nml_file, mpp_error, mpp_max, mpp_sum, mpp_pe

use ocean_domains_mod,    only: get_local_indices
use ocean_obc_mod,        only: ocean_obc_enhance_visc_back
use ocean_operators_mod,  only: BAY, BAX, BDX_EU, BDY_NU, FDX_U, FDY_U, FMX, FMY
use ocean_parameters_mod, only: missing_value, oneeigth, omega_earth, rho0, rho0r
use ocean_types_mod,      only: ocean_time_type, ocean_grid_type, ocean_domain_type, ocean_adv_vel_type
use ocean_types_mod,      only: ocean_thickness_type, ocean_velocity_type, ocean_options_type
use ocean_util_mod,       only: write_timestamp, diagnose_3d_u, diagnose_2d_u, diagnose_2d, write_chksum_3d
use ocean_workspace_mod,  only: wrk1, wrk2, wrk1_v, wrk2_v, wrk3_v, wrk1_v2d

implicit none

private

public ocean_bihgen_friction_init
public bihgen_friction
public bihgen_viscosity_check
public bihgen_reynolds_check

private ncar_boundary_scale_create 
private ncar_boundary_scale_read
private BDX_EU_smag
private BDY_NU_smag
private compute_neptune_velocity

real :: k_smag_iso          = 0.0    ! smag scaling coeff for isotropic viscosity (dimensionless) 
real :: k_smag_aniso        = 0.0    ! smag scaling coeff for anisotripic viscosity (dimensionless) 
real :: vel_micom_iso       = 0.0    ! background scaling velocity for isotropic viscosity (m/sec) 
real :: vel_micom_aniso     = 0.0    ! background scaling velocity for anisotropic viscosity (m/sec) 
real :: eq_vel_micom_iso    = 0.2    ! background scaling velocity (m/sec) within equatorial band for isotropic visc
real :: eq_vel_micom_aniso  = 0.0    ! background scaling velocity (m/sec) within equatorial band for anisotropic visc
real :: eq_lat_micom        = 0.0    ! equatorial latitude band for micom (degrees)
real :: vel_micom_bottom    = 0.01   ! velocity scale for determining viscosity at the bottom 
real :: equatorial_zonal_lat= 0.0    ! latitudinal band for orienting the friction along zonal direction
real :: visc_crit_scale     = 1.0    ! constant for setting the critical viscosity on the instability constraint 
logical :: equatorial_zonal = .false.! zonally orient anisotropic friction w/i equatorial_zonal_lat
logical :: bottom_5point    =.false.  ! for bottom Laplacian 5point mixing to avoid problems with thin partial cells. 

! for the western boundary scaling of the background viscosity
! nx and ny are number of global points in generalized x and y 
! directions
logical :: ncar_boundary_scaling      = .false.
logical :: ncar_boundary_scaling_read = .false.
real    :: ncar_vconst_4              = 2.e-8
integer :: ncar_vconst_5              = 3  
integer :: ncar_rescale_power         = 1
integer :: nx, ny 

! for neptune scheme  
logical :: neptune              = .false. ! for computing friction relative to barotropic Neptune velocity
logical :: neptune_smooth       = .true.  ! for smoothing diagnosed neptune velocity
integer :: neptune_smooth_num   = 1       ! number of smoothing passes for neptune smoother 
real    :: neptune_length_eq    = 4.2e3   ! (metres; from Maltrud and Holloway)
real    :: neptune_length_pole  = 17.0e3  ! (metres; from Maltrud and Holloway)
real    :: neptune_depth_min    = 100.0   ! (metres; from Maltrud and Holloway)
real    :: neptune_scaling      = 1.0     ! dimensionless scaling used for tuning 

! for divergence-based viscosity
real :: visc_diverge_scaling = 0.0  ! dimensionless
real, dimension(:,:),   allocatable :: visc_diverge_factor ! (m^4) for computing visc_diverge
real, dimension(:,:,:), allocatable :: divergence_t        ! array to hold diverge_t 

! for side-boundary drag law
logical :: use_side_drag_friction       = .false.
real    :: side_drag_friction_scaling   = 1.0
real    :: side_drag_friction_max       = 1.0
real    :: side_drag_friction_uvmag_max = 10.0
real, dimension(:,:,:), allocatable :: umask_next_to_land

! for diagnostics 
logical :: used
integer :: id_aiso                 =-1
integer :: id_aaniso               =-1
integer :: id_along                =-1
integer :: id_across               =-1
integer :: id_aiso_back            =-1
integer :: id_aaniso_back          =-1
integer :: id_along_back           =-1
integer :: id_across_back          =-1
integer :: id_visc_diverge         =-1
integer :: id_visc_crit_bih        =-1
integer :: id_bih_fric_u           =-1
integer :: id_bih_fric_v           =-1
integer :: id_horz_bih_diss        =-1
integer :: id_ncar_rescale         =-1
integer :: id_neptune_bih_u        =-1
integer :: id_neptune_bih_v        =-1
integer :: id_neptune_fu           =-1
integer :: id_umask_next_to_land   =-1
integer :: id_bih_plus_side_fric_u =-1
integer :: id_bih_plus_side_fric_v =-1
integer :: id_side_drag_friction_u =-1
integer :: id_side_drag_friction_v =-1

! time step 
real ::  dtime = 0.0  ! time step used for friction tendency (2*dtuv if threelevel, dtuv if twolevel) 

#include <ocean_memory.h>


#ifdef MOM_STATIC_ARRAYS

real, dimension(isd:ied,jsd:jed)    :: fsmag_iso       ! (m^4) combination of terms for computing isotropic smag visc
real, dimension(isd:ied,jsd:jed)    :: fsmag_aniso     ! (m^4) combination of terms for computing anisotropic smag visc
real, dimension(isd:ied,jsd:jed,nk) :: aiso_back       ! minimum allowable isotropic viscosity (m^4/s)
real, dimension(isd:ied,jsd:jed,nk) :: aaniso_back     ! minimum allowable anisotropic viscosity (m^4/s)
real, dimension(isd:ied,jsd:jed,nk) :: aiso            ! isotropic viscosity (m^4/s) averaged to U cell for diagnostics
real, dimension(isd:ied,jsd:jed,nk) :: visc_diverge    ! viscosity (m^4/s) arising from |grad(diverge_t)|
real, dimension(isd:ied,jsd:jed,nk) :: ncar_rescale    ! viscosity scale (cm^2/s) based on NCAR western boundary scaling 

real, dimension(isd:ied,jsd:jed)    :: daur_dxur   ! 1/(dxu*dxu*dyu) (m^-3)
real, dimension(isd:ied,jsd:jed)    :: daur_dyur   ! 1/(dxu*dyu*dyu) (m^-3)
real, dimension(isd:ied,jsd:jed,nk) :: massqc      ! (1/4)*dxu*dyu*rho_dzu (kg) time-independent quarter-cell mass
real, dimension(isd:ied,jsd:jed)    :: visc_crit   ! critical value of the viscosity (m^4/sec) for linear stability 
real, dimension(isd:ied,jsd:jed)    :: visc_bottom ! Laplacian viscosity at the bottom (m^2/sec)

real, dimension(isd:ied,jsd:jed,nk) :: stress001   !stress tensor: last index stress_xx
real, dimension(isd:ied,jsd:jed,nk) :: stress011   !stress tensor: last index stress_xx
real, dimension(isd:ied,jsd:jed,nk) :: stress101   !stress tensor: last index stress_xx
real, dimension(isd:ied,jsd:jed,nk) :: stress111   !stress tensor: last index stress_xx
real, dimension(isd:ied,jsd:jed,nk) :: stress002   !stress tensor: last index stress_xy
real, dimension(isd:ied,jsd:jed,nk) :: stress012   !stress tensor: last index stress_xy
real, dimension(isd:ied,jsd:jed,nk) :: stress102   !stress tensor: last index stress_xy
real, dimension(isd:ied,jsd:jed,nk) :: stress112   !stress tensor: last index stress_xy
real, dimension(isd:ied,jsd:jed,nk) :: tmplap1
real, dimension(isd:ied,jsd:jed,nk) :: tmplap2
real, dimension(isd:ied,jsd:jed)    :: tmpfdelx1
real, dimension(isd:ied,jsd:jed)    :: tmpfdelx2
real, dimension(isd:ied,jsd:jed)    :: tmpfdely1
real, dimension(isd:ied,jsd:jed)    :: tmpfdely2
real, dimension(isd:ied,jsd:jed)    :: tmp1
real, dimension(isd:ied,jsd:jed)    :: tmp2
real, dimension(isc:iec,jsc:jec,nk) :: cos2theta
real, dimension(isc:iec,jsc:jec,nk) :: sin2theta

#else

real, dimension(:,:), allocatable   :: fsmag_iso    ! (m^4) combination of terms for computing isotropic smag visc
real, dimension(:,:), allocatable   :: fsmag_aniso  ! (m^4) combination of terms for computing anisotropic smag visc
real, dimension(:,:,:), allocatable :: aiso_back    ! minimum allowable isotropic viscosity (m^4/s)
real, dimension(:,:,:), allocatable :: aaniso_back  ! minimum allowable anisotropic viscosity (m^4/s)
real, dimension(:,:,:), allocatable :: aiso         ! isotropic viscosity (m^4/s) averaged to U cell for diagnostics
real, dimension(:,:,:), allocatable :: visc_diverge ! viscosity (m^4/s) arising from |grad(diverge_t)|
real, dimension(:,:,:), allocatable :: ncar_rescale ! viscosity scale (cm^2/s) based on NCAR western boundary scaling 

real, dimension(:,:), allocatable   :: daur_dxur   ! 1/(dxu*dxu*dyu) (m^-3)
real, dimension(:,:), allocatable   :: daur_dyur   ! 1/(dxu*dyu*dyu) (m^-3)
real, dimension(:,:,:), allocatable :: massqc      ! (1/4)*dxu*dyu*rho_dzu (kg) time-independent quarter-cell mass
real, dimension(:,:), allocatable   :: visc_crit   ! critical value of the viscosity (m^4/sec) for linear stability 
real, dimension(:,:), allocatable   :: visc_bottom ! Laplacian viscosity at the bottom (m^2/sec)

real, dimension(:,:,:), allocatable :: stress001  !stress tensor: last index stress_xx
real, dimension(:,:,:), allocatable :: stress011  !stress tensor: last index stress_xx
real, dimension(:,:,:), allocatable :: stress101  !stress tensor: last index stress_xx
real, dimension(:,:,:), allocatable :: stress111  !stress tensor: last index stress_xx
real, dimension(:,:,:), allocatable :: stress002  !stress tensor: last index stress_xy
real, dimension(:,:,:), allocatable :: stress012  !stress tensor: last index stress_xy
real, dimension(:,:,:), allocatable :: stress102  !stress tensor: last index stress_xy
real, dimension(:,:,:), allocatable :: stress112  !stress tensor: last index stress_xy
real, dimension(:,:,:), allocatable :: tmplap1
real, dimension(:,:,:), allocatable :: tmplap2
real, dimension(:,:), allocatable   :: tmpfdelx1
real, dimension(:,:), allocatable   :: tmpfdelx2
real, dimension(:,:), allocatable   :: tmpfdely1
real, dimension(:,:), allocatable   :: tmpfdely2
real, dimension(:,:), allocatable   :: tmp1
real, dimension(:,:), allocatable   :: tmp2
real, dimension(:,:,:), allocatable   :: cos2theta
real, dimension(:,:,:), allocatable   :: sin2theta

#endif

real, dimension(:,:), allocatable :: aiso_back_obc   ! for enhancing visc next to OBC boundaries 
real, dimension(:,:), allocatable :: aaniso_back_obc ! for enhancing visc next to OBC boundaries 

! barotropic velocity (m/s) from Neptune 
real, dimension(:,:,:), allocatable :: neptune_velocity 

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()

character(len=256) :: version=&
     '=>Using: ocean_bihgen_friction.F90 ($Id: ocean_bihgen_friction.F90,v 20.0 2013/12/14 00:14:16 fms Exp $)'
character (len=128) :: tagname = &
     '$Name: tikal $'

logical :: use_this_module       = .false.
logical :: debug_this_module     = .false.
logical :: module_is_initialized = .FALSE.
logical :: have_obc              = .FALSE.
logical :: read_aiso_bih_back    = .false.

namelist /ocean_bihgen_friction_nml/ use_this_module, debug_this_module,           &
          k_smag_iso, k_smag_aniso, vel_micom_iso,                                 &
          vel_micom_aniso, eq_vel_micom_iso, eq_vel_micom_aniso, eq_lat_micom,     &
          vel_micom_bottom, bottom_5point, equatorial_zonal, equatorial_zonal_lat, &
          visc_crit_scale, read_aiso_bih_back,                                     &
          ncar_boundary_scaling, ncar_rescale_power, ncar_vconst_4, ncar_vconst_5, &
          ncar_boundary_scaling_read,                                              &
          neptune, neptune_length_eq, neptune_length_pole, neptune_depth_min,      &
          neptune_scaling, neptune_smooth, neptune_smooth_num,                     &
          visc_diverge_scaling,                                                    &
          use_side_drag_friction, side_drag_friction_scaling,                      &
          side_drag_friction_uvmag_max, side_drag_friction_max 

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_bihgen_friction_init">

! <DESCRIPTION>
! Initialize the horizontal biharmonic friction module by 
! registering fields for diagnostic output and performing some 
! numerical checks to see that viscosity is set appropriately.
! </DESCRIPTION>
!
subroutine ocean_bihgen_friction_init(Grid, Domain, Time, Ocean_options, d_time, &
                                      obc, use_bihgen_friction, debug)

  type(ocean_grid_type),    target, intent(in)    :: Grid
  type(ocean_domain_type),  target, intent(in)    :: Domain
  type(ocean_time_type),            intent(in)    :: Time
  type(ocean_options_type),         intent(inout) :: Ocean_options
  real,                             intent(in)    :: d_time
  logical,                          intent(in)    :: obc
  logical,                          intent(inout) :: use_bihgen_friction
  logical,                optional, intent(in)    :: debug

  integer :: ioun, io_status, ierr
  integer :: i, j, k
  real    :: coeff_iso, coeff_aniso, dxdy

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_bihgen_friction_mod(ocean_bihgen_friction_init): already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_bihgen_friction_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_bihgen_friction_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_bihgen_friction_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_bihgen_friction_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_bihgen_friction_nml)  
  write (stdlogunit,ocean_bihgen_friction_nml)

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
#endif

  if(use_this_module) then 
      call mpp_error(NOTE, '==> NOTE: USING ocean_bihgen_friction_mod.')
      Ocean_options%horz_bih_friction = 'Used general horizontal biharmonic friction.'
      use_bihgen_friction=.true.
  else 
      call mpp_error(NOTE, '==> NOTE: NOT using ocean_bihgen_friction_mod.')
      Ocean_options%horz_bih_friction = 'Did NOT use horizontal biharmonic friction.'
      use_bihgen_friction=.false.
      return 
  endif

  if (PRESENT(debug) .and. .not. debug_this_module) then 
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') &
    '==>Note: running with debug_this_module=.true. so will print lots of checksums.'  
  endif 

  Grd => Grid
  Dom => Domain
  nx  =  Grd%ni
  ny  =  Grd%nj

  dtime = d_time

  write(stdoutunit,'(a)') ' ' 

  write(stdoutunit,'(/a,f10.2)') &
   '==> Note from ocean_bihgen_friction_mod: using forward time step of (secs)', dtime 

  have_obc = obc
  if (have_obc) then 
     write(stdoutunit,'(/a,f10.2)') '==> Note from ocean_bihgen_friction_mod: considering obc' 
  endif 

  if (Dom%xhalo > 1 .or. Dom%yhalo > 1) then
    write (stdoutunit,'(/1x,a)') ' ==> NOTE: General biharmonic friction allows xhalo=yhalo=1.'
  endif

  if(bottom_5point) then
    write(stdoutunit,'(/)')  
    write(stdoutunit,'(/1x,a)') ' ==> NOTE: Will make horizontal friction to a 5point Laplacian on the bottom'
    write(stdoutunit,'(a)')     '     This helps alleviate numerical problems with thin bottom partial cells.'
  endif 

  if(neptune) then 
    write(stdoutunit,'(1x,a)') '==> Note: Computing biharmonic friction relative to Neptune'
    write(stdoutunit,'(5x,a,e10.5)') &
    'Equatorial length (m) for computing Neptune velocity is   ',neptune_length_eq 
    write(stdoutunit,'(5x,a,e10.5)') &
    'Polar length (m) for computing Neptune velocity is        ',neptune_length_pole 
    write(stdoutunit,'(5x,a,e10.5)') &
    'Minimum depth scale (m) for computing Neptune velocity is ',neptune_depth_min
  endif 

  if(k_smag_iso > 0.0) then 
     write( stdoutunit,'(a)')' Computing horziontal isotropic biharmonic viscosity via Smagorinsky.'
  endif
  if(k_smag_iso==0.0)  then 
    write( stdoutunit,*)' Setting horzizontal isotropic biharmonic Smagorinsky viscosity to zero.'
  endif 
  if(k_smag_aniso > 0.0) then 
     write( stdoutunit,'(a)')' Computing horzizontal anisotropic biharmonic viscosity via Smagorinsky.'
     write( stdoutunit,'(1x,a)')' ==>WARNING: anisotropic biharmonic Smagorinsky not well tested.'
  endif
  if(k_smag_aniso==0.0) then 
    write( stdoutunit,*)' Setting horzizontal anisotropic biharmonic Smagorinsky viscosity to zero.'
  endif 
  if(vel_micom_iso > 0.0) then 
     write( stdoutunit,'(a)')' Computing background horzizontal biharmonic isotropic viscosity via MICOM.'
  endif
  if(vel_micom_iso==0.0) then 
    write( stdoutunit,*)' Setting background horzizontal biharmonic isotropic viscosity to zero.'
  endif 
  if(vel_micom_aniso > 0.0) then
     write( stdoutunit,'(a)')' Computing background horzizontal anisotropic biharmonic viscosity via MICOM.'
     write( stdoutunit,'(1x,a)')' ==> WARNING: anisotropic biharmonic background viscosity not well tested.'
  endif 
  if(vel_micom_aniso==0.0) then
     write(stdoutunit,'(a)')' Setting background horziontal biharmonic anisotropic viscosity to zero.' 
  endif 
  if(k_smag_aniso > 2.0*k_smag_iso) then
     call mpp_error(FATAL, &
     '==>Error: Smag horizontal bih anisotropic visc too large. Must be < 2*isotropic-visc.')
  endif  
  if(vel_micom_aniso > 2.0*vel_micom_iso) then
    call mpp_error(FATAL, &
     '==>Error: Background bih horz aniso visc too large. Must be < 2.0*background iso visc.')
  endif  
  if(eq_lat_micom > 0) then 
    write( stdoutunit,'(a)')'Setting different background horz bih viscosity w/i equatorial zone.'
  endif 
  if(equatorial_zonal) then
    write( stdoutunit,'(a)') &
    'If using anisotropic biharmonic friction, zonally orient friction w/i latitudinal'
    write( stdoutunit,'(a)') &
    'band of width ',equatorial_zonal_lat,' degrees.'
  endif 


#ifndef MOM_STATIC_ARRAYS
  
  allocate (fsmag_iso(isd:ied,jsd:jed))
  allocate (fsmag_aniso(isd:ied,jsd:jed))
  allocate (ncar_rescale(isd:ied,jsd:jed,nk))
  allocate (aiso_back(isd:ied,jsd:jed,nk))
  allocate (aaniso_back(isd:ied,jsd:jed,nk))
  allocate (aiso(isd:ied,jsd:jed,nk)) 
  allocate (visc_diverge(isd:ied,jsd:jed,nk)) 
  allocate (daur_dxur(isd:ied,jsd:jed))
  allocate (daur_dyur(isd:ied,jsd:jed))
  allocate (massqc(isd:ied,jsd:jed,nk))
  allocate (visc_crit(isd:ied,jsd:jed))
  allocate (visc_bottom(isd:ied,jsd:jed))
  allocate (stress001(isd:ied,jsd:jed,nk))  !stress tensor: last index stress_xx
  allocate (stress011(isd:ied,jsd:jed,nk))  !stress tensor: last index stress_xx
  allocate (stress101(isd:ied,jsd:jed,nk))  !stress tensor: last index stress_xx
  allocate (stress111(isd:ied,jsd:jed,nk))  !stress tensor: last index stress_xx
  allocate (stress002(isd:ied,jsd:jed,nk))  !stress tensor: last index stress_xy
  allocate (stress012(isd:ied,jsd:jed,nk))  !stress tensor: last index stress_xy
  allocate (stress102(isd:ied,jsd:jed,nk))  !stress tensor: last index stress_xy
  allocate (stress112(isd:ied,jsd:jed,nk))  !stress tensor: last index stress_xy
  allocate (tmplap1(isd:ied,jsd:jed,nk))    
  allocate (tmplap2(isd:ied,jsd:jed,nk))    
  allocate (tmpfdelx1(isd:ied,jsd:jed))    
  allocate (tmpfdelx2(isd:ied,jsd:jed))    
  allocate (tmpfdely1(isd:ied,jsd:jed))   
  allocate (tmpfdely2(isd:ied,jsd:jed))   
  allocate (tmp1(isd:ied,jsd:jed))
  allocate (tmp2(isd:ied,jsd:jed))
  allocate (cos2theta(isc:iec,jsc:jec,nk))
  allocate (sin2theta(isc:iec,jsc:jec,nk))
  
#endif

  allocate (aiso_back_obc(isd:ied,jsd:jed))
  allocate (aaniso_back_obc(isd:ied,jsd:jed))
  allocate (visc_diverge_factor(isd:ied,jsd:jed))
  allocate (divergence_t(isd:ied,jsd:jed,nk))
 
  tmp1(:,:) = 0.0
  tmp2(:,:) = 0.0

  ! Some commonly used grid arrays 
  daur_dxur(:,:) = 0.0
  daur_dyur(:,:) = 0.0
  daur_dxur(:,:) = Grd%daur(:,:)*Grd%dxur(:,:)
  daur_dyur(:,:) = Grd%daur(:,:)*Grd%dyur(:,:)

  fsmag_iso(:,:)   = 0.0
  fsmag_aniso(:,:) = 0.0
  coeff_iso        = 0.125*(k_smag_iso/pi)**2
  coeff_aniso      = 0.125*(k_smag_aniso/pi)**2
  fsmag_iso(:,:)   = Grd%umask(:,:,1)*coeff_iso* &
                     ((2.0*Grd%dxu(:,:)*Grd%dyu(:,:))/(epsln + Grd%dxu(:,:) + Grd%dyu(:,:)))**4
  fsmag_aniso(:,:) = Grd%umask(:,:,1)*coeff_aniso* &
                     ((2.0*Grd%dxu(:,:)*Grd%dyu(:,:))/(epsln + Grd%dxu(:,:) + Grd%dyu(:,:)))**4

  aiso_back_obc(:,:)      = 0.0
  aaniso_back_obc(:,:)    = 0.0
  visc_bottom(:,:)        = 0.0
  do j=jsd,jed
    do i=isd,ied 
      visc_bottom(i,j)   = Grd%umask(i,j,1)*vel_micom_bottom* &
                           ((2.0*Grd%dxu(i,j)*Grd%dyu(i,j))/(epsln + Grd%dxu(i,j) + Grd%dyu(i,j)))
      aiso_back_obc(i,j)     = Grd%umask(i,j,1)*vel_micom_iso* &
                               ((2.0*Grd%dxu(i,j)*Grd%dyu(i,j))/(epsln + Grd%dxu(i,j) + Grd%dyu(i,j)))**3
      aaniso_back_obc(i,j)   = Grd%umask(i,j,1)*vel_micom_aniso* &
                               ((2.0*Grd%dxu(i,j)*Grd%dyu(i,j))/(epsln + Grd%dxu(i,j) + Grd%dyu(i,j)))**3
      if(abs(Grd%yu(i,j)) < eq_lat_micom) then
        aiso_back_obc(i,j)   = Grd%umask(i,j,1)*eq_vel_micom_iso* &
                               ((2.0*Grd%dxu(i,j)*Grd%dyu(i,j))/(epsln + Grd%dxu(i,j) + Grd%dyu(i,j)))**3
        aaniso_back_obc(i,j) = Grd%umask(i,j,1)*eq_vel_micom_aniso* &
                               ((2.0*Grd%dxu(i,j)*Grd%dyu(i,j))/(epsln + Grd%dxu(i,j) + Grd%dyu(i,j)))**3
      endif
    enddo  
  enddo

  aiso(:,:,:)         = 0.0
  aiso_back(:,:,:)    = 0.0
  aaniso_back(:,:,:)  = 0.0
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied 

           aiso_back(i,j,k)     = Grd%umask(i,j,k)*vel_micom_iso* &
                ((2.0*Grd%dxu(i,j)*Grd%dyu(i,j))/(epsln + Grd%dxu(i,j) + Grd%dyu(i,j)))**3
           aaniso_back(i,j,k)   = Grd%umask(i,j,k)*vel_micom_aniso* &
                ((2.0*Grd%dxu(i,j)*Grd%dyu(i,j))/(epsln + Grd%dxu(i,j) + Grd%dyu(i,j)))**3

           if(abs(Grd%yu(i,j)) < eq_lat_micom) then
               aiso_back(i,j,k)   = Grd%umask(i,j,k)*eq_vel_micom_iso* &
                    ((2.0*Grd%dxu(i,j)*Grd%dyu(i,j))/(epsln + Grd%dxu(i,j) + Grd%dyu(i,j)))**3
               aaniso_back(i,j,k) = Grd%umask(i,j,k)*eq_vel_micom_aniso* &
                    ((2.0*Grd%dxu(i,j)*Grd%dyu(i,j))/(epsln + Grd%dxu(i,j) + Grd%dyu(i,j)))**3
           endif

        enddo
     enddo
  enddo

  ! factor used for computing viscosity based on divergence 
  visc_diverge(:,:,:) = 0.0
  if(visc_diverge_scaling > 0.0) then 
     write(stdoutunit,'(/a,f10.2)') &
     '==> Note from ocean_bihgen_friction_mod: using visc_diverge_scaling for viscosity, with a value = ',visc_diverge_scaling 
  endif 
  do j=jsc,jec
     do i=isc,iec  
        visc_diverge_factor(i,j) = Grd%umask(i,j,1)*visc_diverge_scaling* &
                                   ((2.0*Grd%dxu(i,j)*Grd%dyu(i,j))/(epsln + Grd%dxu(i,j) + Grd%dyu(i,j)))**4
      enddo
  enddo
  call mpp_update_domains (visc_diverge_factor(:,:),Dom%domain2d)    


  ! rescale the background viscosities according to NCAR boundary scaling  
  if(ncar_boundary_scaling) then 
      write(stdoutunit,'(a)') ' Note: rescaling background bih viscosities so they are larger in western boundaries.'
      if(ncar_boundary_scaling_read) then 
          call ncar_boundary_scale_read(Time) 
      else 
          call ncar_boundary_scale_create(Time)
      endif
  endif

  if (read_aiso_bih_back) then
      call read_data('INPUT/aiso_bih_back.nc','aiso_bih_back',aiso_back, Dom%domain2d)
  endif  

  ! enhance background viscosity near open boundaries if needed
  if (have_obc) then 
      call ocean_obc_enhance_visc_back(aiso_back_obc, 'bih')
      call ocean_obc_enhance_visc_back(aaniso_back_obc, 'bih')
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               if(aiso_back_obc(i,j)   > aiso_back(i,j,k))   aiso_back(i,j,k)   = aiso_back_obc(i,j)
               if(aaniso_back_obc(i,j) > aaniso_back(i,j,k)) aaniso_back(i,j,k) = aaniso_back_obc(i,j)
            enddo
         enddo
      enddo
  endif

  call compute_neptune_velocity(Time)

  ! critical value of viscosity, above which 2-dim linear stability is not satisfied.
  ! visc_crit taken from equation (18.26) of Griffies book. 
  visc_crit(:,:) = 0.0
  do j=jsc,jec
    do i=isc,iec
      dxdy = 1.0/( 1.0/(Grd%dxu(i,j)*Grd%dxu(i,j)) + 1.0/(Grd%dyu(i,j)*Grd%dyu(i,j)) )
      visc_crit(i,j) =  visc_crit_scale*oneeigth*dxdy**2/(dtime+epsln)
    enddo
  enddo

  if(use_side_drag_friction) then 
     write(stdoutunit,'(a)') '==> Note from ocean_bihgen_friction: using side drag friction for cells next to land.'
     allocate (umask_next_to_land(isd:ied,jsd:jed,nk))
     umask_next_to_land(:,:,:) = 0.0
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              umask_next_to_land(i,j,k) = (1.0-Grd%umask(i+1,j,k)) + (1.0-Grd%umask(i-1,j,k)) &
                                         +(1.0-Grd%umask(i,j+1,k)) + (1.0-Grd%umask(i,j-1,k)) 
              umask_next_to_land(i,j,k) = Grd%umask(i,j,k)*min(1.0,umask_next_to_land(i,j,k))
           enddo
        enddo
     enddo 
     id_umask_next_to_land = register_static_field('ocean_model', 'umask_next_to_land_bih',&
            Grd%vel_axes_uv(1:3),'U-cell mask for cells next to land for bihgen module',   &
            'dimensionless', missing_value=missing_value, range=(/-10.0,10.0/))
     call diagnose_3d_u(Time, Grd, id_umask_next_to_land, umask_next_to_land(:,:,:))
  endif 

  id_visc_crit_bih = register_static_field ('ocean_model', 'visc_crit_bih', &
                     Grd%vel_axes_uv(1:2), 'critical viscosity', 'm^4/sec', &
                     missing_value=missing_value, range=(/0.0,1.e20/))
  call diagnose_2d_u(Time, Grd, id_visc_crit_bih, visc_crit(:,:))


  ! ensure that background viscosities are not too large 
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           if(aiso_back(i,j,k)   > visc_crit(i,j))  aiso_back(i,j,k)   = visc_crit(i,j)
           if(aaniso_back(i,j,k) > visc_crit(i,j))  aaniso_back(i,j,k) = visc_crit(i,j)
        enddo
     enddo
  enddo

  ! ensure viscosities maintain proper relative values so that friction dissipates 
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           if(aaniso_back(i,j,k) >= 2.0*aiso_back(i,j,k) .and. aaniso_back(i,j,k) > 0.0)  then 
               write(stdoutunit,'(a,i4,a,i4,a,i3,a)')'Violating bih iso/aniso constraint at (',i,',',j,')'
               aaniso_back(i,j,k) = 1.9*aiso_back(i,j,k)
           endif
        enddo
     enddo
  enddo

  ! apply U-cell masking to background viscosities; needed in particular 
  ! for the case when read_aiso_back is enabled, to remove any spurious 
  ! missing values.  
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           aiso_back(i,j,k)   = aiso_back(i,j,k)*Grd%umask(i,j,k)
           aaniso_back(i,j,k) = aaniso_back(i,j,k)*Grd%umask(i,j,k)
        enddo
     enddo
  enddo


  call mpp_update_domains (aiso_back(:,:,:),   Dom%domain2d)    
  call mpp_update_domains (aaniso_back(:,:,:), Dom%domain2d)    


  ! diagnostic output 
  id_aiso    = register_diag_field ('ocean_model', 'aiso_bih', Grd%vel_axes_uv(1:3), &
               Time%model_time,'U-cell isotropic bih visc', 'm^4/sec',               &
               missing_value=-10.0, range=(/-10.0,1.e20/),                           &
               standard_name='ocean_momentum_xy_biharmonic_diffusivity')
  id_aaniso  = register_diag_field ('ocean_model', 'aaniso_bih', Grd%vel_axes_uv(1:3), &
               Time%model_time,'U-cell  anisotropic bih visc', 'm^4/sec',              &
               missing_value=missing_value, range=(/-10.0,1.e20/))
  id_along  = register_diag_field ('ocean_model', 'along_bih', Grd%vel_axes_uv(1:3),   &
              Time%model_time,'U-cell along-stream bih visc', 'm^4/sec',               &
              missing_value=missing_value, range=(/-10.0,1.e20/))
  id_across  = register_diag_field ('ocean_model', 'across_bih', Grd%vel_axes_uv(1:3), &
               Time%model_time, 'U-cell cross-stream bih visc', 'm^4/sec',             &
               missing_value=missing_value, range=(/-10.0,1.e20/))
  id_visc_diverge = register_diag_field ('ocean_model', 'visc_diverge_bih', Grd%vel_axes_uv(1:3),    &
               Time%model_time,'U-cell biharmonic visc based on horz_diverge_t gradients', 'm^4/sec',&
               missing_value=-10.0, range=(/-10.0,1.e20/))

  id_bih_fric_u = register_diag_field ('ocean_model', 'bih_fric_u', Grd%vel_axes_uv(1:3), &
                  Time%model_time, 'Thickness and rho wghtd horz bih frict on u-zonal',   &
                  '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1.e20,1.e20/))
  id_bih_fric_v = register_diag_field ('ocean_model', 'bih_fric_v', Grd%vel_axes_uv(1:3), &
                  Time%model_time, 'Thickness and rho wghtd horz bih frict on v-merid',   &
                  '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1.e20,1.e20/))

  id_aiso_back   = register_static_field('ocean_model', 'aiso_bih_back', Grd%vel_axes_uv(1:3),   &
                    'U-cell background aiso bih visc', 'm^4/sec',                                &
                    missing_value=missing_value, range=(/-10.0,1.e20/))
  id_aaniso_back = register_static_field('ocean_model', 'aaniso_bih_back', Grd%vel_axes_uv(1:3), &
                    'U-cell background aaniso bih visc', 'm^4/sec',                              &
                    missing_value=missing_value, range=(/-10.0,1.e20/))
  id_along_back   = register_static_field('ocean_model', 'along_bih_back', Grd%vel_axes_uv(1:3), &
                    'U-cell background along-stream bih visc', 'm^4/sec',                        &
                    missing_value=missing_value, range=(/-10.0,1.e20/))
  id_across_back = register_static_field('ocean_model', 'across_bih_back', Grd%vel_axes_uv(1:3), &
                   'U-cell background cross-stream bih visc', 'm^4/sec',                         &
                   missing_value=missing_value, range=(/-10.0,1.e20/))

  call diagnose_3d_u(Time, Grd, id_aiso_back, aiso_back(:,:,:))
  call diagnose_3d_u(Time, Grd, id_aaniso_back, aaniso_back(:,:,:))
  if (id_along_back > 0) then 
     call diagnose_3d_u(Time, Grd, id_along_back, aiso_back(:,:,:)+0.5*aaniso_back(:,:,:))
  endif 
  if (id_across_back > 0) then 
     call diagnose_3d_u(Time, Grd, id_across_back, aiso_back(:,:,:)-0.5*aaniso_back(:,:,:))
  endif 

  id_horz_bih_diss = register_diag_field ('ocean_model', 'horz_bih_diss', Grd%vel_axes_uv(1:3),      &
                  Time%model_time, 'Energy dissipation from horizontal biharmonic friction', 'W/m^2',&
                  missing_value=missing_value, range=(/-1.e20,1.e20/))

  id_side_drag_friction_u = register_diag_field ('ocean_model', 'side_drag_friction_bih_u', Grd%vel_axes_uv(1:3),&
                  Time%model_time, 'u-friction due to side drag from bihgen module', 'N/m^2',                    &
                  missing_value=missing_value, range=(/-1.e20,1.e20/))

  id_side_drag_friction_v = register_diag_field ('ocean_model', 'side_drag_friction_bih_v', Grd%vel_axes_uv(1:3),&
                  Time%model_time, 'v-friction due to side drag from bihgen module', 'N/m^2',                    &
                  missing_value=missing_value, range=(/-1.e20,1.e20/))

  id_bih_plus_side_fric_u = register_diag_field ('ocean_model', 'bih_plus_side_fric_u', Grd%vel_axes_uv(1:3), &
                  Time%model_time, 'Thickness and rho wghtd horz bih frict + side friction on u-zonal',       &
                  '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1.e20,1.e20/))
  id_bih_plus_side_fric_v = register_diag_field ('ocean_model', 'bih_plus_side_fric_v', Grd%vel_axes_uv(1:3), &
                  Time%model_time, 'Thickness and rho wghtd horz bih frict + side friction on v-merid',       &
                  '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1.e20,1.e20/))

end subroutine ocean_bihgen_friction_init
! </SUBROUTINE>  NAME="ocean_bihgen_friction_init"


!#######################################################################
! <SUBROUTINE NAME="bihgen_friction">
!
! <DESCRIPTION>
! This subroutine computes the time tendency for horizontal 
! velocity (i.e., the acceleration) from horizontal biharmonic friction.  
! The algorithm is derived from a functional approach that ensures kinetic 
! energy is consistenty dissipated for all flow configurations. 
! The triad do-loops are expanded in order to enhance the 
! ability of cache-based machines to keep most of the variables 
! on-cache.  
! 
! Fundamental to the scheme are the rates of horizontal deformation  <BR/>
! horizontal tension = DT = (dy)(u/dy)_x - (dx)(v/dx)_y              <BR/>
! horizontal strain  = DS = (dx)(u/dx)_y + (dy)(v/dy)_x              <BR/>
! Units of the tension and strain are sec^-1.
!
! Four tensions and four strains are computed for each velocity point, <BR/>
! corresponding to the four triads surrounding the point.              <BR/>
! The following notation is used to distinguish the triads:            <BR/>   
! (0,1)=northwest triad  (1,1)=northeast triad,                        <BR/> 
! (0,0)=southwest triad, (1,0)=southeast triad                        
!
! A triad contributes when at least one of its velocities is             
! not a land point.  In order to obtain the correct tension           
! and strain next to boundaries, tension and strain should not be       
! masked with umask. 
!
! As shown in Griffies and Hallberg (2000), 
! a biharmonic operator with a nonconstant viscosity is guaranteed to 
! dissipate kinetic energy *only* when using the sqrt of the biharmonic
! viscosity at each of the two stages of the algorithm. 
! The sqrt approach is employed here.  
!
! </DESCRIPTION>
!
subroutine bihgen_friction(Time, Thickness, Adv_vel, Velocity, bih_viscosity, energy_analysis_step)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(in)    :: Thickness
  type(ocean_adv_vel_type),   intent(in)    :: Adv_vel
  type(ocean_velocity_type),  intent(inout) :: Velocity
  real, dimension(isd:,jsd:), intent(inout) :: bih_viscosity
  logical,                    intent(in)    :: energy_analysis_step

  real, dimension(0:1,0:1,isc:iec,jsc:jec,nk) :: aiso_smag
  real, dimension(0:1,0:1,isc:iec,jsc:jec,nk) :: aaniso_smag
  real    :: uvmag, umag, vmag, velocity_gamma
  integer :: i, j, k, n
  integer :: ip, jq, jjq, iip
  integer :: taum1, tau

  real :: u1_m10, u2_m10
  real :: u1_10,  u2_10
  real :: u1_00,  u2_00
  real :: u1_01,  u2_01
  real :: u1_0m1, u2_0m1 
  real :: dxuer_ip0, dxuer_ip1
  real :: dyunr_jq0, dyunr_jq1
  real :: usqrd, vsqrd, umagr
  real :: tension, strain, deform, delta 
  real :: tension_metric, strain_metric
  real :: grad_diverge_sq 

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, '==>Error from ocean_bihgen_friction_mod (horz_bih_friction): needs to be initialized')
  endif 

  if(.not. use_this_module) then 

      if(energy_analysis_step) then 
          do n=1,2
             do k=1,nk
                do j=jsc,jec
                   do i=isc,iec
                      Velocity%wrkv(i,j,k,n) = 0.0
                   enddo
                enddo
             enddo
          enddo
      endif

      return 
  endif

  stress001(:,:,:) = 0.0
  stress011(:,:,:) = 0.0
  stress101(:,:,:) = 0.0
  stress111(:,:,:) = 0.0
  stress002(:,:,:) = 0.0
  stress012(:,:,:) = 0.0
  stress102(:,:,:) = 0.0
  stress112(:,:,:) = 0.0
  tmplap1(:,:,:)   = 0.0
  tmplap2(:,:,:)   = 0.0
  wrk1_v(:,:,:,:)  = 0.0
  wrk2_v(:,:,:,:)  = 0.0
  wrk3_v(:,:,:,:)  = 0.0
  wrk1(:,:,:)      = 0.0
  wrk2(:,:,:)      = 0.0

  taum1 = Time%taum1
  tau   = Time%tau
  
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           massqc(i,j,k) = 0.25*Grd%dau(i,j)*Thickness%rho_dzu(i,j,k,tau)
        enddo
     enddo
  enddo

  ! divergence_t has units m/s
  divergence_t(:,:,:) = 0.0
  if(visc_diverge_scaling > 0.0) then 
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              divergence_t(i,j,k) = rho0r*Adv_vel%diverge_t(i,j,k)
           enddo
        enddo
     enddo
     call mpp_update_domains (divergence_t(:,:,:), Dom%domain2d)    
  endif 

  ! big k-loop 
  do k=1,nk

     ! Laplacian part of algorithm
     do j=jsc,jec
        do i=isc,iec

           ! compute visc_diverge using gradient that straddles U-cell northeast sides  
           grad_diverge_sq     = ((divergence_t(i+1,j,k)-divergence_t(i,j,k))*Grd%dxter(i,j))**2 &
                                +((divergence_t(i,j+1,k)-divergence_t(i,j,k))*Grd%dytnr(i,j))**2 
           visc_diverge(i,j,k) = Grd%umask(i,j,k)*visc_diverge_factor(i,j)*sqrt(grad_diverge_sq)

           tension_metric = -(Velocity%u(i,j,k,1,taum1)-neptune_velocity(i,j,1))*Grd%dh2dx(i,j) &
                            +(Velocity%u(i,j,k,2,taum1)-neptune_velocity(i,j,2))*Grd%dh1dy(i,j)  

           strain_metric  = -(Velocity%u(i,j,k,1,taum1)-neptune_velocity(i,j,1))*Grd%dh1dy(i,j) &
                            -(Velocity%u(i,j,k,2,taum1)-neptune_velocity(i,j,2))*Grd%dh2dx(i,j)  

           if(equatorial_zonal .and. abs(Grd%yu(i,j)) <= equatorial_zonal_lat) then  
             sin2theta(i,j,k) = 0.0
             cos2theta(i,j,k) = 1.0
           else 
             usqrd = (Velocity%u(i,j,k,1,taum1)-neptune_velocity(i,j,1))**2
             vsqrd = (Velocity%u(i,j,k,2,taum1)-neptune_velocity(i,j,2))**2
             umagr = 1.0/(epsln + usqrd + vsqrd)
             sin2theta(i,j,k) = 2.0*(Velocity%u(i,j,k,1,taum1)-neptune_velocity(i,j,1)) &
                                 *(Velocity%u(i,j,k,2,taum1)-neptune_velocity(i,j,2))*umagr
             cos2theta(i,j,k) = (usqrd-vsqrd)*umagr
           endif  

          ! compute stress tensor components for the four triads.  
          ! expanded do-loops are faster.
          ! dimensions[aiso_smag]=m^2/s^0.5
          ! dimensions[tension and strain]=1/s
          ! dimensions[stress]=m^2/s^1.5

           ip=0 ; dxuer_ip0 = Grd%dxuer(i+ip-1,j)
           ip=1 ; dxuer_ip1 = Grd%dxuer(i+ip-1,j)
           jq=0 ; dyunr_jq0 = Grd%dyunr(i,j+jq-1)
           jq=1 ; dyunr_jq1 = Grd%dyunr(i,j+jq-1)

           ip=-1 ; jq=0  
           u1_m10 = Velocity%u(i+ip,j+jq,k,1,taum1) - neptune_velocity(i+ip,j+jq,1)  
           u2_m10 = Velocity%u(i+ip,j+jq,k,2,taum1) - neptune_velocity(i+ip,j+jq,2)  

           ip=1  ; jq=0  
           u1_10 = Velocity%u(i+ip,j+jq,k,1,taum1) - neptune_velocity(i+ip,j+jq,1)  
           u2_10 = Velocity%u(i+ip,j+jq,k,2,taum1) - neptune_velocity(i+ip,j+jq,2)  

           ip=0  ; jq=0  
           u1_00 = Velocity%u(i+ip,j+jq,k,1,taum1) - neptune_velocity(i+ip,j+jq,1)  
           u2_00 = Velocity%u(i+ip,j+jq,k,2,taum1) - neptune_velocity(i+ip,j+jq,2) 

           ip=0  ; jq=1  
           u1_01  = Velocity%u(i+ip,j+jq,k,1,taum1) - neptune_velocity(i+ip,j+jq,1)   
           u2_01  = Velocity%u(i+ip,j+jq,k,2,taum1) - neptune_velocity(i+ip,j+jq,2) 

           ip=0  ; jq=-1 
           u1_0m1 = Velocity%u(i+ip,j+jq,k,1,taum1) - neptune_velocity(i+ip,j+jq,1)    
           u2_0m1 = Velocity%u(i+ip,j+jq,k,2,taum1) - neptune_velocity(i+ip,j+jq,2) 

           ip=0 ; jq=0 
           tension =  dxuer_ip0*(u1_00-u1_m10)-dyunr_jq0*(u2_00-u2_0m1)+tension_metric
           strain  =  dxuer_ip0*(u2_00-u2_m10)+dyunr_jq0*(u1_00-u1_0m1)+strain_metric
           delta   =  0.5*(strain*cos2theta(i,j,k) - tension*sin2theta(i,j,k))
           deform  = sqrt(tension**2 + strain**2)
           aiso_smag(ip,jq,i,j,k)    = min(visc_crit(i,j), aiso_back(i,j,k)   + fsmag_iso(i,j)*deform   + visc_diverge(i,j,k))
           aaniso_smag(ip,jq,i,j,k)  = min(visc_crit(i,j), aaniso_back(i,j,k) + fsmag_aniso(i,j)*deform + visc_diverge(i,j,k))
           aiso_smag(ip,jq,i,j,k)    = sqrt(aiso_smag(ip,jq,i,j,k))
           aaniso_smag(ip,jq,i,j,k)  = sqrt(aaniso_smag(ip,jq,i,j,k))
           stress001(i,j,k) = aiso_smag(ip,jq,i,j,k)*tension + aaniso_smag(ip,jq,i,j,k)*delta*sin2theta(i,j,k)
           stress002(i,j,k) = aiso_smag(ip,jq,i,j,k)*strain  - aaniso_smag(ip,jq,i,j,k)*delta*cos2theta(i,j,k)

           ip=1 ; jq=0 
           tension =  dxuer_ip1*(u1_10-u1_00)-dyunr_jq0*(u2_00-u2_0m1)+tension_metric
           strain  =  dxuer_ip1*(u2_10-u2_00)+dyunr_jq0*(u1_00-u1_0m1)+strain_metric
           delta   =  0.5*(strain*cos2theta(i,j,k) - tension*sin2theta(i,j,k))
           deform  = sqrt(tension**2 + strain**2)
           aiso_smag(ip,jq,i,j,k)    = min(visc_crit(i,j), aiso_back(i,j,k)   + fsmag_iso(i,j)*deform   + visc_diverge(i,j,k))
           aaniso_smag(ip,jq,i,j,k)  = min(visc_crit(i,j), aaniso_back(i,j,k) + fsmag_aniso(i,j)*deform + visc_diverge(i,j,k))
           aiso_smag(ip,jq,i,j,k)    = sqrt(aiso_smag(ip,jq,i,j,k))
           aaniso_smag(ip,jq,i,j,k)  = sqrt(aaniso_smag(ip,jq,i,j,k))
           stress101(i,j,k) = aiso_smag(ip,jq,i,j,k)*tension + aaniso_smag(ip,jq,i,j,k)*delta*sin2theta(i,j,k)
           stress102(i,j,k) = aiso_smag(ip,jq,i,j,k)*strain  - aaniso_smag(ip,jq,i,j,k)*delta*cos2theta(i,j,k)

           ip=0 ; jq=1
           tension =  dxuer_ip0*(u1_00-u1_m10)-dyunr_jq1*(u2_01-u2_00)+tension_metric
           strain  =  dxuer_ip0*(u2_00-u2_m10)+dyunr_jq1*(u1_01-u1_00)+strain_metric
           delta   =  0.5*(strain*cos2theta(i,j,k) - tension*sin2theta(i,j,k))
           deform  = sqrt(tension**2 + strain**2)
           aiso_smag(ip,jq,i,j,k)    = min(visc_crit(i,j), aiso_back(i,j,k)   + fsmag_iso(i,j)*deform   + visc_diverge(i,j,k))
           aaniso_smag(ip,jq,i,j,k)  = min(visc_crit(i,j), aaniso_back(i,j,k) + fsmag_aniso(i,j)*deform + visc_diverge(i,j,k))
           aiso_smag(ip,jq,i,j,k)    = sqrt(aiso_smag(ip,jq,i,j,k))
           aaniso_smag(ip,jq,i,j,k)  = sqrt(aaniso_smag(ip,jq,i,j,k))
           stress011(i,j,k) = aiso_smag(ip,jq,i,j,k)*tension + aaniso_smag(ip,jq,i,j,k)*delta*sin2theta(i,j,k)
           stress012(i,j,k) = aiso_smag(ip,jq,i,j,k)*strain  - aaniso_smag(ip,jq,i,j,k)*delta*cos2theta(i,j,k)

           jq=1 ; ip=1
           tension =  dxuer_ip1*(u1_10-u1_00)-dyunr_jq1*(u2_01-u2_00)+tension_metric
           strain  =  dxuer_ip1*(u2_10-u2_00)+dyunr_jq1*(u1_01-u1_00)+strain_metric
           delta   =  0.5*(strain*cos2theta(i,j,k) - tension*sin2theta(i,j,k))
           deform  = sqrt(tension**2 + strain**2)
           aiso_smag(ip,jq,i,j,k)    = min(visc_crit(i,j), aiso_back(i,j,k)   + fsmag_iso(i,j)*deform   + visc_diverge(i,j,k))
           aaniso_smag(ip,jq,i,j,k)  = min(visc_crit(i,j), aaniso_back(i,j,k) + fsmag_aniso(i,j)*deform + visc_diverge(i,j,k))
           aiso_smag(ip,jq,i,j,k)    = sqrt(aiso_smag(ip,jq,i,j,k))
           aaniso_smag(ip,jq,i,j,k)  = sqrt(aaniso_smag(ip,jq,i,j,k))
           stress111(i,j,k) = aiso_smag(ip,jq,i,j,k)*tension + aaniso_smag(ip,jq,i,j,k)*delta*sin2theta(i,j,k)
           stress112(i,j,k) = aiso_smag(ip,jq,i,j,k)*strain  - aaniso_smag(ip,jq,i,j,k)*delta*cos2theta(i,j,k)

        enddo
     enddo
  enddo  !end of k-loop

  call mpp_update_domains (stress001(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (stress011(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (stress101(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (stress111(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (stress002(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (stress012(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (stress102(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (stress112(:,:,:), Dom%domain2d, complete=.true. )    

  do k=1,nk
     ! sum the stress tensor components over the triads
     ! loops designed to reduce calls to mpp_update_domains
     ! dimensions[tmpfdelx and tmpfdely]=kg*m^2/s^1.5

     tmpfdelx1(:,:) = 0.0
     tmpfdelx2(:,:) = 0.0
     do j=jsc,jec
        do i=isd,iec
           tmpfdelx1(i,j) = (stress101(i,j,k)   + stress111(i,j,k)  )*massqc(i,j,k)    &
                +(stress001(i+1,j,k) + stress011(i+1,j,k))*massqc(i+1,j,k)
           tmpfdelx2(i,j) = (stress102(i,j,k)   + stress112(i,j,k)  )*massqc(i,j,k)    &  
                +(stress002(i+1,j,k) + stress012(i+1,j,k))*massqc(i+1,j,k)              
        enddo
     enddo

     tmpfdely1(:,:) = 0.0
     tmpfdely2(:,:) = 0.0
     do j=jsd,jec
        do i=isc,iec  
           tmpfdely1(i,j) = (stress012(i,j,k)   + stress112(i,j,k)  )*massqc(i,j,k)    &                      
                +(stress002(i,j+1,k) + stress102(i,j+1,k))*massqc(i,j+1,k) 
           tmpfdely2(i,j) = (stress011(i,j,k)   + stress111(i,j,k)  )*massqc(i,j,k)    &                      
                +(stress001(i,j+1,k) + stress101(i,j+1,k))*massqc(i,j+1,k)
        enddo
     enddo

     ! compute laplacian operator
     ! dimensions [tmplap=m/s^1.5]
     tmp1(:,:) = BDX_EU_smag(tmpfdelx1(:,:))+BDY_NU_smag(tmpfdely1(:,:))    
     tmp2(:,:) = BDX_EU_smag(tmpfdelx2(:,:))-BDY_NU_smag(tmpfdely2(:,:))    

     ! do not use rho_dzur since that is at taup1 and need to divide by rho_dau(tau)
     do j=jsc,jec
        do i=isc,iec
           tmplap1(i,j,k) = tmp1(i,j)*Grd%umask(i,j,k)/Thickness%rho_dzu(i,j,k,tau)
           tmplap2(i,j,k) = tmp2(i,j)*Grd%umask(i,j,k)/Thickness%rho_dzu(i,j,k,tau)
        enddo
     enddo
  enddo  !end of k-loop

  call mpp_update_domains (tmplap1(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (tmplap2(:,:,:), Dom%domain2d, complete=.true. )    


  do k=1,nk
     ! Second part of the iteration
     ! tmplap[m/s^1.5] replaces velocity[m/s]
     ! dimensions[aiso_smag]=m^2/s^0.5
     ! dimensions[tension and strain]=1/s^1.5
     ! dimensions[stress]=m^2/s^2
     do j=jsc,jec
        do i=isc,iec

           tension_metric = -tmplap1(i,j,k)*Grd%dh2dx(i,j) + tmplap2(i,j,k)*Grd%dh1dy(i,j)  
           strain_metric  = -tmplap1(i,j,k)*Grd%dh1dy(i,j) - tmplap2(i,j,k)*Grd%dh2dx(i,j)  

          ! compute stress tensor components for the four triads.  
          ! expanded do-loops are quicker. 

           ip=0 ; dxuer_ip0 = Grd%dxuer(i+ip-1,j)
           ip=1 ; dxuer_ip1 = Grd%dxuer(i+ip-1,j)
           jq=0 ; dyunr_jq0 = Grd%dyunr(i,j+jq-1)
           jq=1 ; dyunr_jq1 = Grd%dyunr(i,j+jq-1)

           ip=-1 ; jq=0  ; u1_m10 = tmplap1(i+ip,j+jq,k) ; u2_m10 = tmplap2(i+ip,j+jq,k)
           ip=1  ; jq=0  ; u1_10  = tmplap1(i+ip,j+jq,k) ; u2_10  = tmplap2(i+ip,j+jq,k) 
           ip=0  ; jq=0  ; u1_00  = tmplap1(i+ip,j+jq,k) ; u2_00  = tmplap2(i+ip,j+jq,k) 
           ip=0  ; jq=1  ; u1_01  = tmplap1(i+ip,j+jq,k) ; u2_01  = tmplap2(i+ip,j+jq,k)
           ip=0  ; jq=-1 ; u1_0m1 = tmplap1(i+ip,j+jq,k) ; u2_0m1 = tmplap2(i+ip,j+jq,k)

           ip=0 ; jq=0 
           tension =  dxuer_ip0*(u1_00-u1_m10)-dyunr_jq0*(u2_00-u2_0m1)+tension_metric
           strain  =  dxuer_ip0*(u2_00-u2_m10)+dyunr_jq0*(u1_00-u1_0m1)+strain_metric
           delta   =  0.5*(strain*cos2theta(i,j,k) - tension*sin2theta(i,j,k))
           stress001(i,j,k) = aiso_smag(ip,jq,i,j,k)*tension + aaniso_smag(ip,jq,i,j,k)*delta*sin2theta(i,j,k)
           stress002(i,j,k) = aiso_smag(ip,jq,i,j,k)*strain  - aaniso_smag(ip,jq,i,j,k)*delta*cos2theta(i,j,k)

           ip=1 ; jq=0 
           tension =  dxuer_ip1*(u1_10-u1_00)-dyunr_jq0*(u2_00-u2_0m1)+tension_metric
           strain  =  dxuer_ip1*(u2_10-u2_00)+dyunr_jq0*(u1_00-u1_0m1)+strain_metric
           delta   =  0.5*(strain*cos2theta(i,j,k) - tension*sin2theta(i,j,k))
           stress101(i,j,k) = aiso_smag(ip,jq,i,j,k)*tension + aaniso_smag(ip,jq,i,j,k)*delta*sin2theta(i,j,k)
           stress102(i,j,k) = aiso_smag(ip,jq,i,j,k)*strain  - aaniso_smag(ip,jq,i,j,k)*delta*cos2theta(i,j,k)

           ip=0 ; jq=1
           tension =  dxuer_ip0*(u1_00-u1_m10)-dyunr_jq1*(u2_01-u2_00)+tension_metric
           strain  =  dxuer_ip0*(u2_00-u2_m10)+dyunr_jq1*(u1_01-u1_00)+strain_metric
           delta   =  0.5*(strain*cos2theta(i,j,k) - tension*sin2theta(i,j,k))
           stress011(i,j,k) = aiso_smag(ip,jq,i,j,k)*tension + aaniso_smag(ip,jq,i,j,k)*delta*sin2theta(i,j,k)
           stress012(i,j,k) = aiso_smag(ip,jq,i,j,k)*strain  - aaniso_smag(ip,jq,i,j,k)*delta*cos2theta(i,j,k)

           jq=1 ; ip=1
           tension =  dxuer_ip1*(u1_10-u1_00)-dyunr_jq1*(u2_01-u2_00)+tension_metric
           strain  =  dxuer_ip1*(u2_10-u2_00)+dyunr_jq1*(u1_01-u1_00)+strain_metric
           delta   =  0.5*(strain*cos2theta(i,j,k) - tension*sin2theta(i,j,k))
           stress111(i,j,k) = aiso_smag(ip,jq,i,j,k)*tension + aaniso_smag(ip,jq,i,j,k)*delta*sin2theta(i,j,k)
           stress112(i,j,k) = aiso_smag(ip,jq,i,j,k)*strain  - aaniso_smag(ip,jq,i,j,k)*delta*cos2theta(i,j,k)

        enddo
     enddo
  enddo  !end of k-loop

  call mpp_update_domains (stress001(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (stress011(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (stress101(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (stress111(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (stress002(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (stress012(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (stress102(:,:,:), Dom%domain2d, complete=.false.)    
  call mpp_update_domains (stress112(:,:,:), Dom%domain2d, complete=.true. )    

  do k=1,nk
     ! sum the stress tensor components over the triads
     ! loops designed to reduce calls to mpp_update_domains
     ! dimensions[tmpfdelx and tmpfdely]=kg*m^2/s^2

     tmpfdelx1(:,:) = 0.0
     tmpfdelx2(:,:) = 0.0
     do j=jsc,jec
        do i=isd,iec
           tmpfdelx1(i,j) = (stress101(i,j,k)   + stress111(i,j,k)  )*massqc(i,j,k)    &
                +(stress001(i+1,j,k) + stress011(i+1,j,k))*massqc(i+1,j,k)
           tmpfdelx2(i,j) = (stress102(i,j,k)   + stress112(i,j,k)  )*massqc(i,j,k)    &  
                +(stress002(i+1,j,k) + stress012(i+1,j,k))*massqc(i+1,j,k)              
        enddo
     enddo

     tmpfdely1(:,:) = 0.0
     tmpfdely2(:,:) = 0.0
     do j=jsd,jec
        do i=isc,iec  
           tmpfdely1(i,j) = (stress012(i,j,k)   + stress112(i,j,k)  )*massqc(i,j,k)    &                      
                +(stress002(i,j+1,k) + stress102(i,j+1,k))*massqc(i,j+1,k) 
           tmpfdely2(i,j) = (stress011(i,j,k)   + stress111(i,j,k)  )*massqc(i,j,k)    &                      
                +(stress001(i,j+1,k) + stress101(i,j+1,k))*massqc(i,j+1,k)
        enddo
     enddo

    ! compute acceleration from horizontal biharmonic friction
    ! dimensions[tmp]=kg*/(m*s^2)
    ! dimensions[friction]=(kg/m^3)*(m^2/s^2)=N/m^2
     tmp1(:,:) = BDX_EU_smag(tmpfdelx1(:,:))+BDY_NU_smag(tmpfdely1(:,:)) 
     tmp2(:,:) = BDX_EU_smag(tmpfdelx2(:,:))-BDY_NU_smag(tmpfdely2(:,:)) 
     do j=jsc,jec
        do i=isc,iec
           wrk1_v(i,j,k,1) = -tmp1(i,j)*Grd%umask(i,j,k)
           wrk1_v(i,j,k,2) = -tmp2(i,j)*Grd%umask(i,j,k)
        enddo
     enddo

     ! reduce to 5-point laplacian at bottom to avoid problems with thin bottom partial cells
     if (bottom_5point) then
         tmp1(:,:) = BDX_EU(visc_bottom(:,:)*FMX(Thickness%rho_dzu(:,:,k,tau)) &
                    *FDX_U(Velocity%u(:,:,k,1,taum1)-neptune_velocity(:,:,1))) &
                    +BDY_NU(visc_bottom(:,:)*FMY(Thickness%rho_dzu(:,:,k,tau)) &
                    *FDY_U(Velocity%u(:,:,k,1,taum1)-neptune_velocity(:,:,1)))

         tmp2(:,:) = BDX_EU(visc_bottom(:,:)*FMX(Thickness%rho_dzu(:,:,k,tau)) &
                    *FDX_U(Velocity%u(:,:,k,2,taum1)-neptune_velocity(:,:,2))) &
                    +BDY_NU(visc_bottom(:,:)*FMY(Thickness%rho_dzu(:,:,k,tau)) &
                    *FDY_U(Velocity%u(:,:,k,2,taum1)-neptune_velocity(:,:,2)))

         do j=jsc,jec
            do i=isc,iec
               if(k==Grd%kmu(i,j)) then
                  wrk1_v(i,j,k,1) = tmp1(i,j)*Grd%umask(i,j,k)
                  wrk1_v(i,j,k,2) = tmp2(i,j)*Grd%umask(i,j,k)
               endif
            enddo
         enddo
     endif

     ! use side drag for cells next to side boundaries 
     if(use_side_drag_friction) then
        do j=jsc,jec
           do i=isc,iec
              uvmag           = sqrt(Velocity%u(i,j,k,1,taum1)**2 + Velocity%u(i,j,k,2,taum1)**2)
              uvmag           = min(uvmag,side_drag_friction_uvmag_max)
              velocity_gamma  = rho0*side_drag_friction_scaling*Velocity%cdbot_array(i,j) &
                                *uvmag*umask_next_to_land(i,j,k)
              umag            = abs(Velocity%u(i,j,k,1,taum1))
              vmag            = abs(Velocity%u(i,j,k,2,taum1))
              wrk2_v(i,j,k,1) = -min(side_drag_friction_max, velocity_gamma*umag)*sign(1.0,Velocity%u(i,j,k,1,taum1))
              wrk2_v(i,j,k,2) = -min(side_drag_friction_max, velocity_gamma*vmag)*sign(1.0,Velocity%u(i,j,k,2,taum1))
              wrk3_v(i,j,k,1) =  wrk1_v(i,j,k,1)*(1.0-umask_next_to_land(i,j,k))
              wrk3_v(i,j,k,2) =  wrk1_v(i,j,k,2)*(1.0-umask_next_to_land(i,j,k))
              wrk1_v(i,j,k,1) =  wrk2_v(i,j,k,1) + wrk3_v(i,j,k,1)
              wrk1_v(i,j,k,2) =  wrk2_v(i,j,k,2) + wrk3_v(i,j,k,2)              
            enddo
         enddo
     endif 

  enddo  !end of k-loop

  if(energy_analysis_step) then 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%wrkv(i,j,k,n) = wrk1_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo

  else ! not energy_analysis_step

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%accel(i,j,k,n) = Velocity%accel(i,j,k,n) + wrk1_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo

      ! vertically averaged viscosity at U-cell centre
      bih_viscosity(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               aiso(i,j,k) = 0.25*(  aiso_smag(0,0,i,j,k)**2   + aiso_smag(1,0,i,j,k)**2    &
                                   + aiso_smag(0,1,i,j,k)**2   + aiso_smag(1,1,i,j,k)**2)
               wrk1(i,j,k) = 0.25*(  aaniso_smag(0,0,i,j,k)**2 + aaniso_smag(1,0,i,j,k)**2  &
                                   + aaniso_smag(0,1,i,j,k)**2 + aaniso_smag(1,1,i,j,k)**2)
               bih_viscosity(i,j) = bih_viscosity(i,j)  &
               + Grd%umask(i,j,k)*Thickness%rho_dzu(i,j,k,tau)*aiso(i,j,k)
            enddo
         enddo
      enddo
      do j=jsc,jec
         do i=isc,iec
            bih_viscosity(i,j) = Grd%umask(i,j,1)*bih_viscosity(i,j)/(epsln+Thickness%mass_u(i,j,tau))
         enddo
      enddo
      call mpp_update_domains (bih_viscosity(:,:), Dom%domain2d)    

      call diagnose_3d_u(Time, Grd, id_aiso, aiso(:,:,:))
      call diagnose_3d_u(Time, Grd, id_visc_diverge, visc_diverge(:,:,:))
      call diagnose_3d_u(Time, Grd, id_aaniso, wrk1(:,:,:))

      if (id_along > 0)  call diagnose_3d_u(Time, Grd, id_along,  aiso(:,:,:)+0.5*wrk1(:,:,:))
      if (id_across > 0) call diagnose_3d_u(Time, Grd, id_across, aiso(:,:,:)-0.5*wrk1(:,:,:))

      if (id_horz_bih_diss > 0)  then
          do k=1,nk
             do j=jsd,jed
                do i=isd,ied
                   wrk2(i,j,k) = wrk2(i,j,k) - 4.0*massqc(i,j,k)*tmplap1(i,j,k)**2  &
                                             - 4.0*massqc(i,j,k)*tmplap2(i,j,k)**2 
                   wrk2(i,j,k) = wrk2(i,j,k)*Grd%daur(i,j)
                enddo
             enddo
          enddo
          call diagnose_3d_u(Time, Grd, id_horz_bih_diss, wrk2(:,:,:))
      endif 

      if(use_side_drag_friction) then
         call diagnose_3d_u(Time, Grd, id_bih_fric_u, wrk3_v(:,:,:,1))
         call diagnose_3d_u(Time, Grd, id_bih_fric_v, wrk3_v(:,:,:,2))
      else 
         call diagnose_3d_u(Time, Grd, id_bih_fric_u, wrk1_v(:,:,:,1))
         call diagnose_3d_u(Time, Grd, id_bih_fric_v, wrk1_v(:,:,:,2))
      endif

      call diagnose_3d_u(Time, Grd, id_bih_plus_side_fric_u, wrk1_v(:,:,:,1))
      call diagnose_3d_u(Time, Grd, id_bih_plus_side_fric_v, wrk1_v(:,:,:,2))
      call diagnose_3d_u(Time, Grd, id_side_drag_friction_u, wrk2_v(:,:,:,1))
      call diagnose_3d_u(Time, Grd, id_side_drag_friction_v, wrk2_v(:,:,:,2))

  endif    ! endif for energy_analysis_step


  if(debug_this_module) then
      write(stdoutunit,*) ' ' 
      write(stdoutunit,*) 'From ocean_bihgen_friction_mod: friction chksums'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('rho_dzu(tau)', Thickness%rho_dzu(COMP,:,tau)*Grd%umask(COMP,:))
      call write_chksum_3d('bihgen friction(1)', wrk1_v(COMP,:,1)*Grd%umask(COMP,:))
      call write_chksum_3d('bihgen friction(2)', wrk1_v(COMP,:,2)*Grd%umask(COMP,:))
  endif 


end subroutine bihgen_friction
! </SUBROUTINE> NAME="bihgen_friction"


!#######################################################################
! <SUBROUTINE NAME="ncar_boundary_scale_read">
!
! <DESCRIPTION>
!
! Read in the 3d ncar boundary scaling field and use this to 
! rescale the background viscosities. 
! 
! To use this routine, we need to already have generated the field
! ncar_rescale using the routine ncar_boundary_scale_create.
!
! The advantage of reading ncar_rescale is that we do not need to 
! introduce any global 2d arrays required for ncar_boundary_scale_create.     
! So the idea is to pay the price once by running ncar_boundary_scale_create,
! save ncar_rescale, then read that field in during subsequent runs through 
! ncar_boundary_scale_read.
!
! Here are the steps:
! 1/ run one time with ncar_boundary_scaling_read=.false.
! and ncar_boundary_scaling=.true. 
! Be sure that the field ncar_rescale is saved in diagnostic table.
! To ensure answers agree whether reading ncar_rescale or creating it
! during initialization, it is necessary to save ncar_rescale using the
! double precision option in the diagnostic table (packing=1). 
!
! 2/ extract field ncar_rescale from the diagnostics output
! and place into its own file INPUT/ncar_rescale.nc
! example extraction using ncks:
! ncks -v ncar_rescale 19900101.ocean_month.nc ncar_rescale.nc
!
! 3/ set ncar_boundary_scaling_read=.true. 
! and ncar_boundary_scaling=.true., and now run the model 
! reading in ncar_rescale rather than regenerating
! it during each initialization (which can be a bottleneck 
! for large models on huge processor counts).   
!
! 4/ As a check that all is fine, save ncar_rescale as a diagnostic
! for both the create and the read stage and make sure they agree.  
! Also, all checksums should agree whether reading in ncar_rescale
! or creating it each initialization, so long as the ncar_rescale.nc
! was saved with double precision  (see step 1/ above).
!
! </DESCRIPTION>
!
subroutine ncar_boundary_scale_read(Time)

  type(ocean_time_type), intent(in) :: Time

  integer :: i, j, k
  integer :: stdoutunit 
  stdoutunit=stdout() 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_bihgen_friction_mod (ncar_boundary_scale_read): module must be initialized')
  endif 

  call read_data('INPUT/ncar_rescale.nc','ncar_rescale',ncar_rescale, Dom%domain2d)

  ! rescale the background viscosities 
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           aiso_back(i,j,k)   = aiso_back(i,j,k)  *ncar_rescale(i,j,k)
           aaniso_back(i,j,k) = aaniso_back(i,j,k)*ncar_rescale(i,j,k)
        enddo
     enddo
  enddo

  id_ncar_rescale = register_static_field('ocean_model', 'ncar_rescale', Grd%vel_axes_uv(1:3),&
                    'rescaling used for the background viscosity', 'dimensionless',           &
                     missing_value=missing_value, range=(/-10.0,1.e10/))
  call diagnose_3d_u(Time, Grd, id_ncar_rescale, ncar_rescale(:,:,:))

  ! need these viscosities in the halo regions
  call mpp_update_domains (aiso_back(:,:,:),   Dom%domain2d)    
  call mpp_update_domains (aaniso_back(:,:,:), Dom%domain2d)    


end subroutine ncar_boundary_scale_read
! </SUBROUTINE>  NAME="ncar_boundary_scale_read"


!#######################################################################
! <SUBROUTINE NAME="ncar_boundary_scale_create">
!
! <DESCRIPTION>
!
!     Recale the background viscosities to be larger in the western 
!     boundary regions.  The algorithm is taken directly from the 
!     anisotropic_ncar routine in ocean_lapgen_friction.F90.
!
!   NOTE: The nearest western boundary computations are done along the
!         model i-grid lines. Therefore, viscosity based on these are 
!         only approximate in the high Northern Hemisphere when using 
!         generalized coordinates with coordinate pole(s) shifted onto 
!         land. 
!
! </DESCRIPTION>
!
subroutine ncar_boundary_scale_create(Time)

  type(ocean_time_type), intent(in) :: Time

  integer :: i, j, k
  integer :: n, ncount
  integer :: is, ie, ip1, ii
  integer :: index, indexo
  integer, dimension(nx) :: iwp
  integer, dimension(nx) :: nwbp_global

  real, dimension(nx,jsc:jec)       :: dxtn_global
  real, dimension(nx,jsc:jec)       :: kmu_global
  real, dimension(isd:ied,jsd:jed)  :: kmu_tmp
  real, dimension(isd:ied,jsd:jed)  :: ncar_rescale2d
  real, dimension(nx)               :: dist_g 

  real :: dist_max
  real :: ncar_rescale_min
  real :: huge=1e20

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_bihgen_friction_mod (ncar_velocity_scale): module must be initialized')
  endif 

  if(ncar_boundary_scaling_read) return 

  dist_max         = 1.e10  ! distance for ACC region (cm)
  dxtn_global(:,:) = 0.0
  kmu_global(:,:)  = 0.0
  kmu_tmp(:,:)     = Grd%kmu(:,:)
  ncar_rescale(:,:,:) = 0.0
  ncar_rescale2d(:,:) = 0.0

  call mpp_global_field(Dom%domain2d,kmu_tmp,kmu_global, flags=XUPDATE)  
  call mpp_global_field(Dom%domain2d,Grd%dxtn,dxtn_global, flags=XUPDATE)

  do k=1,nk
     do j=jsc,jec

        ! determine nearest western boundary
        ncount         = 0
        nwbp_global(:) = 0
        iwp(:)         = 0
        dist_g(:)      = 0.0

        do i=1,Grd%ni
           ip1 = i+1
           if(i==Grd%ni) then 
               if(Grd%cyclic_x) then 
                   ip1=1
               else
                   ip1=i  
               endif
           endif
           if(kmu_global(i,j)<k .and. kmu_global(ip1,j) >= k) then 
               ncount      = ncount+1
               iwp(ncount) = i
           endif
        enddo

        if (ncount > 0) then
            do n=1,ncount-1
               is = iwp(n)
               ie = iwp(n+1)-1
               do i=is,ie
                  nwbp_global(i)=is
               enddo
            enddo
            do i=1,Grd%ni
               if(nwbp_global(i)==0) nwbp_global(i) = iwp(ncount)
            enddo
        endif


        ! determine distance (cm) to nearest western boundary
        do i=1,Grd%ni

           index  = nwbp_global(i)
           indexo = index + ncar_vconst_5
           if ( index .eq. 0) then
               dist_g(i) = dist_max
           elseif ( i .ge. index  .and.  i .le. indexo ) then
               dist_g(i) = 0.0
           elseif ( (i .gt. indexo) ) then
               dist_g(i) = dxtn_global(i,j)+dist_g(i-1)
           elseif ( i .lt. index ) then
               if (indexo .le. Grd%ni) then
                   if (i .eq. 1) then
                       dist_g(i) = 0.0
                       do ii=indexo+1,Grd%ni
                          dist_g(i)=dxtn_global(ii,j) + dist_g(i)
                       enddo
                       dist_g(i) = dxtn_global(i,j)+dist_g(i)
                   else
                       dist_g(i) = dxtn_global(i,j)+dist_g(i-1)
                   endif
               else
                   if (i .le. (indexo - Grd%ni)) then
                       dist_g(i) = 0.0
                   else
                       dist_g(i) = dxtn_global(i,j)+dist_g(i-1)
                   endif
               endif
           endif

        enddo

        ! convert distance in MOM (m) to POP1.4 (cm)
        dist_g(:) = 100.0*dist_g(:)
        do i=isc,iec
           ncar_rescale(i,j,k) = Grd%umask(i,j,k)*(1.0+exp(-(ncar_vconst_4*dist_g(i+Dom%ioff))**2))
        enddo

     enddo ! j
  enddo    ! k

  ! the only depth dependence to ncar_rescale arises from absence or presence of 
  ! topography.  so to compute the min ncar_rescale, we only need to look at k=1.  
  ! also, to avoid getting ncar_rescale=0.0 due to land, we set ncar_rescale2d
  ! to a huge number if over land. 
  do j=jsc,jec
     do i=isc,iec
        if(Grd%umask(i,j,1)== 0.0) then 
           ncar_rescale2d(i,j) = huge
        else 
           ncar_rescale2d(i,j) = ncar_rescale(i,j,1) 
        endif 
     enddo
  enddo
  ncar_rescale_min = mpp_global_min(Dom%domain2d,ncar_rescale2d(:,:))

  ! check for error
  if(ncar_rescale_min==0.0) then
    call mpp_error(FATAL, &
    '==>Error from ocean_bihgen_friction_mod(ncar_boundary_scale): ncar_rescale_min=0.  Something wrong')
  else
    write(stdoutunit,'(a,e14.6)') 'From ncar_boundary_scale, minimum ncar_rescale =  ',ncar_rescale_min
  endif 

  ! rescale the background viscosities 
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           ncar_rescale(i,j,k) = (ncar_rescale(i,j,k)/ncar_rescale_min)**ncar_rescale_power
           aiso_back(i,j,k)    = aiso_back(i,j,k)  *ncar_rescale(i,j,k)
           aaniso_back(i,j,k)  = aaniso_back(i,j,k)*ncar_rescale(i,j,k)
        enddo
     enddo
  enddo

  id_ncar_rescale = register_static_field('ocean_model', 'ncar_rescale', Grd%vel_axes_uv(1:3),&
                    'rescaling used for the background viscosity', 'dimensionless',           &
                     missing_value=missing_value, range=(/-10.0,1.e10/))
  call diagnose_3d_u(Time, Grd, id_ncar_rescale, ncar_rescale(:,:,:))

  ! need these viscosities in the halo regions
  call mpp_update_domains (aiso_back(:,:,:),   Dom%domain2d)    
  call mpp_update_domains (aaniso_back(:,:,:), Dom%domain2d)    


end subroutine ncar_boundary_scale_create
! </SUBROUTINE>  NAME="ncar_boundary_scale_create"



!#######################################################################
! <FUNCTION NAME="BDX_EU_smag">
!
! <DESCRIPTION>
! Compute backwards Derivative in X of a quantity defined on the east 
! face of a U-cell. Slightly modified version of BDX_EU used in
! ocean_operators.F90. If input is a(i,j) then output is defined 
! at (i-1/2,j).
!
! BDX_EU_smag changes dimensions by m^-3 
!
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! field defined on the east face of a U-cell
! </IN>
!
function BDX_EU_smag(a)

  real, dimension(isd:,jsd:), intent(in) :: a
  real, dimension(isd:ied,jsd:jed)       :: BDX_EU_smag
  integer :: i, j

  do j=jsd,jed
    do i=isd+1,ied
      BDX_EU_smag(i,j) = (Grd%dyue_dxuer(i,j)*a(i,j) - Grd%dyue_dxuer(i-1,j)*a(i-1,j))*daur_dyur(i,j)
    enddo
    BDX_EU_smag(isd,j) = 0.0
  enddo

end function BDX_EU_smag
! </FUNCTION> NAME="BDX_EU_smag"


!#######################################################################
! <FUNCTION NAME="BDY_NU_smag">
!
! <DESCRIPTION>
! Compute backwards Derivative in Y of a quantity defined on the north
! face of a U-cell. Slightly modified version of BDY_EU used in
! ocean_operators.F90. If input is a(i,j) then output is defined 
! at (i,j-1/2).
!
! BDY_EU_smag changes dimensions by m^-3 
!
! </DESCRIPTION>
!
! <IN NAME="a" TYPE="real" DIM="(isd:ied,jsd:jed)">
! field defined on the north face of a U-cell
! </IN>
!
function BDY_NU_smag(a)

  real, dimension(isd:,jsd:), intent(in) :: a
  real, dimension(isd:ied,jsd:jed)       :: BDY_NU_smag
  integer :: i, j

  do j=jsd+1,jed
    do i=isd,ied
      BDY_NU_smag(i,j) = (Grd%dxun_dyunr(i,j)*a(i,j) - Grd%dxun_dyunr(i,j-1)*a(i,j-1))*daur_dxur(i,j)
    enddo
  enddo
  BDY_NU_smag(:,jsd) = 0.0

end function BDY_NU_smag
! </FUNCTION> NAME="BDY_EU_smag"


!#######################################################################
! <SUBROUTINE NAME="bihgen_viscosity_check">
!
! <DESCRIPTION>
! Subroutine to perform linear stability check for the biharmonic
! operator given a value for the horizontal biharmonic viscosity.
! </DESCRIPTION>
!
subroutine bihgen_viscosity_check

  integer :: num, i, j, k
  integer, save :: unit=6, max_num=3
  real :: fudge

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, '==>Error from ocean_bihgen_friction_mod (bihgen_viscosity_check): needs initialization')
  endif 

  fudge=1.001  ! to eliminate roundoffs causing aiso=visc_crit+epsln

  write (stdoutunit,'(//60x,a/)') ' Excessive horizontal biharmonic friction summary:'
  write (stdoutunit,'(1x,a/)')'Locations (if any) where viscosity exceeds conservative linear stability constraint'
  num = 0
  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        if (Grd%umask(i,j,k) > 0.0) then            
          if (aiso(i,j,k) > fudge*visc_crit(i,j) .and. num < max_num ) then
            num = num + 1
            write (unit,9600) 'aiso(',aiso(i,j,k), visc_crit(i,j),i,j,k,Grd%xu(i,j),Grd%yu(i,j),Grd%zt(k),mpp_pe()
          endif
        endif 
      enddo
    enddo
  enddo
  call mpp_sum (num)
  if (num > max_num) write (stdoutunit,*) ' (a max of ',max_num,' violations per pe are listed)'

9600  format(/' Warning: ',a,es16.8,' m^4/s) exceeds max value (',es16.8,') at (i,j,k) = ','(',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.0,'m, pe=',i3,')')


end subroutine bihgen_viscosity_check
! </SUBROUTINE> NAME="bihgen_viscosity_check"


!#######################################################################
! <SUBROUTINE NAME="bihgen_reynolds_check">
!
! <DESCRIPTION>
! Subroutine to compute the biharmonic grid Reynolds number.  Large 
! Reynolds numbers indicate regions where solution may experience 
! some grid noise due to lack of enough horizontal friction. 
! </DESCRIPTION>
!
subroutine bihgen_reynolds_check(Time, Velocity)

  type(ocean_time_type),     intent(in) :: Time
  type(ocean_velocity_type), intent(in) :: Velocity

  real :: rame, ramn, reyx, reyy
  real :: reynx0, reyny0, reynx,reyny, reynu,reynv, reynmu,reynmv
  integer :: ireynx,jreynx,kreynx, ireyny,jreyny,kreyny
  integer :: i, j, k, tau
  integer, save :: unit=6

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, '==>Error from ocean_bihgen_friction_mod (gen_bih_reynolds_check): nees to be initialized')
  endif 

  if(.not. use_this_module) return 

  tau = Time%tau

  ! look for max grid reynolds numbers using velocities at "tau".

  ireynx=isc; jreynx=jsc; kreynx=1; reynx=0.0
  ireyny=isc; jreyny=jsc; kreyny=1; reyny=0.0
  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        rame = 1.0/(aiso(i,j,k) + epsln)
        ramn = 1.0/(aiso(i,j,k) + epsln)

        reyx = abs(Velocity%u(i,j,k,1,tau)*Grd%dxu(i,j)**3)*rame
        if (reyx > reynx) then
          ireynx = i
          jreynx = j
          kreynx = k
          reynx  = reyx
          reynu  = Velocity%u(i,j,k,1,tau)
          reynmu = 1.0/rame
        endif
        reyy = abs(Velocity%u(i,j,k,2,tau)*Grd%dyu(i,j)**3)*ramn
        if (reyy > reyny) then
          ireyny = i
          jreyny = j
          kreyny = k
          reyny  = reyy
          reynv  = Velocity%u(i,j,k,2,tau)
          reynmv = 1.0/ramn
        endif

      enddo
    enddo
  enddo
  write (stdoutunit,'(/60x,a/)') ' Horizontal biharmonic Reynolds number summary'

  reynx0 = reynx
  reyny0 = reyny
  call mpp_max(reynx)
  call mpp_max(reyny)
  
  if (reynx == reynx0) then
    write (unit,10300) reynx, ireynx, jreynx, kreynx, &
                       Grd%xu(ireynx,jreynx), Grd%yu(ireynx,jreynx), Grd%zt(kreynx), reynu, reynmu
  endif
  
  if (reyny == reyny0) then
    write (unit,10400) reyny, ireyny, jreyny, kreyny, &
                       Grd%xu(ireyny,jreyny), Grd%yu(ireyny,jreyny), Grd%zt(kreyny), reynv, reynmv
  endif

  10300 format (1x,'Maximum zonal Re =',es9.2,' at (i,j,k) = (',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.2,'), U =',es9.2, ', mix =',e9.2)
  10400 format (1x,'Maximum merid Re =',es9.2,' at (i,j,k) = (',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.2,'), V =',es9.2, ', mix =',e9.2)


end subroutine bihgen_reynolds_check
! </SUBROUTINE> NAME="bihgen_reynolds_check"


!#######################################################################
! <SUBROUTINE NAME="compute_neptune_velocity">
!
! <DESCRIPTION>
! Compute Neptune velocity.  
!
! Method follows that of 
! Maltrud and Holloway, 2008: Implementing biharmonic neptune in a 
! global eddying ocean model, Ocean Modelling, vol. 21, pages 22-34. 
!
! March 2012
! Stephen.Griffies 
!
! </DESCRIPTION>
!
subroutine compute_neptune_velocity(Time)

  type(ocean_time_type), intent(in) :: Time
  real, dimension(isd:ied,jsd:jed)  :: neptune_fu
  real, dimension(isd:ied,jsd:jed)  :: neptune_length
  real                              :: active_cells
  integer                           :: i,j,k
  integer                           :: num_smooth

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_bihgen_friction_mod (compute_neptune_velocity): needs initialization')
  endif 

  allocate (neptune_velocity(isd:ied,jsd:jed,2))
  neptune_velocity = 0.0
  if(.not. neptune) return 

  ! length scale on U-cell point 
  neptune_length(:,:) = 0.0
  neptune_fu(:,:)     = 0.0
  do j=jsd,jed
    do i=isd,ied
      neptune_fu(i,j)     = 2.0*omega_earth*sin(Grd%phiu(i,j))
      neptune_length(i,j) = neptune_scaling                                        &
        *( neptune_length_pole                                                     &
      + 0.5*(neptune_length_eq-neptune_length_pole)*(1.0 + cos(2.0*Grd%phiu(i,j))) &
         )
    enddo
  enddo

  ! compute velocity 
  do j=jsc,jec
     do i=isc,iec
        neptune_velocity(i,j,1) = -neptune_fu(i,j)*neptune_length(i,j)*neptune_length(i,j) &
                                   *Grd%dht_dy(i,j)*Grd%umask(i,j,1)/(neptune_depth_min+Grd%hu(i,j))
        neptune_velocity(i,j,2) =  neptune_fu(i,j)*neptune_length(i,j)*neptune_length(i,j) &
                                   *Grd%dht_dx(i,j)*Grd%umask(i,j,1)/(neptune_depth_min+Grd%hu(i,j))
     enddo
  enddo
  call mpp_update_domains(neptune_velocity(:,:,1), neptune_velocity(:,:,2),&
                          Dom%domain2d,gridtype=BGRID_NE)

  ! optional smoothing
  if(neptune_smooth) then 
      do num_smooth=1,neptune_smooth_num

         k=1
         wrk1_v2d(:,:,:) = 0.0
         do j=jsc,jec
            do i=isc,iec

               if(Grd%tmask(i,j,k)==1.0) then 

                   active_cells = 4.0       +&
                        Grd%umask(i-1,j,k)  +&
                        Grd%umask(i+1,j,k)  +&
                        Grd%umask(i,j-1,k)  +&
                        Grd%umask(i,j+1,k)

                   if (active_cells > 4.0) then
                       wrk1_v2d(i,j,1) =                  &  
                         (4.0*neptune_velocity(i,j,1)    +&
                            neptune_velocity(i-1,j,1)    +&
                            neptune_velocity(i+1,j,1)    +&
                            neptune_velocity(i,j-1,1)    +&
                            neptune_velocity(i,j+1,1)) / active_cells
                       wrk1_v2d(i,j,2) =                  &  
                         (4.0*neptune_velocity(i,j,2)    +&
                            neptune_velocity(i-1,j,2)    +&
                            neptune_velocity(i+1,j,2)    +&
                            neptune_velocity(i,j-1,2)    +&
                            neptune_velocity(i,j+1,2)) / active_cells
                   else
                       wrk1_v2d(i,j,1) = neptune_velocity(i,j,1)
                       wrk1_v2d(i,j,2) = neptune_velocity(i,j,2)
                   endif

               endif

            enddo
         enddo

         do j=jsc,jec
            do i=isc,iec
               neptune_velocity(i,j,1) = wrk1_v2d(i,j,1)*Grd%umask(i,j,k)
               neptune_velocity(i,j,2) = wrk1_v2d(i,j,2)*Grd%umask(i,j,k)
            enddo
         enddo

         call mpp_update_domains(neptune_velocity(:,:,1), neptune_velocity(:,:,2),&
                                 Dom%domain2d,gridtype=BGRID_NE)

      enddo  ! enddo for number of smoothing iterations 
  endif      ! endif for smooth



  ! diagnostics 
  id_neptune_bih_u = register_static_field('ocean_model', 'neptune_bih_u',                &
                   Grd%vel_axes_uv(1:2), 'Zonal velocity from neptune biharmonic scheme', &
                   'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  call diagnose_2d_u(Time, Grd, id_neptune_bih_u, neptune_velocity(:,:,1))

  id_neptune_bih_v = register_static_field('ocean_model', 'neptune_bih_v',                     &
                   Grd%vel_axes_uv(1:2), 'Meridional velocity from neptune biharmonic scheme', &
                   'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  call diagnose_2d_u(Time, Grd, id_neptune_bih_v, neptune_velocity(:,:,2))

  id_neptune_fu   = register_static_field('ocean_model', 'neptune_fu',                            &
                    Grd%tracer_axes(1:2),'Coriolis parameter used for  neptune parameterization', &
                    '1/sec', missing_value=missing_value, range=(/-1.e3,1.e3/))
  call diagnose_2d(Time, Grd, id_neptune_fu, neptune_fu(:,:))

end subroutine compute_neptune_velocity
! </SUBROUTINE> NAME="compute_neptune_velocity"


end module ocean_bihgen_friction_mod
      
      

! Fortran-95 implementation of the Mersenne Twister 19937, following 
!   the C implementation described below (code mt19937ar-cok.c, dated 2002/2/10), 
!   adapted cosmetically by making the names more general.  
! Users must declare one or more variables of type randomNumberSequence in the calling 
!   procedure which are then initialized using a required seed. If the 
!   variable is not initialized the random numbers will all be 0. 
! For example: 
! program testRandoms 
!   use RandomNumbers
!   type(randomNumberSequence) :: randomNumbers
!   integer                    :: i
!   
!   randomNumbers = new_RandomNumberSequence(seed = 100)
!   do i = 1, 10
!     print ('(f12.10, 2x)'), getRandomReal(randomNumbers)
!   end do
! end program testRandoms
! 
! Fortran-95 implementation by 
!   Robert Pincus
!   NOAA-CIRES Climate Diagnostics Center
!   Boulder, CO 80305 
!   email: Robert.Pincus@colorado.edu
!
! This documentation in the original C program reads:
! -------------------------------------------------------------
!    A C-program for MT19937, with initialization improved 2002/2/10.
!    Coded by Takuji Nishimura and Makoto Matsumoto.
!    This is a faster version by taking Shawn Cokus's optimization,
!    Matthe Bellew's simplification, Isaku Wada's real version.
! 
!    Before using, initialize the state by using init_genrand(seed) 
!    or init_by_array(init_key, key_length).
! 
!    Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
!    All rights reserved.                          
! 
!    Redistribution and use in source and binary forms, with or without
!    modification, are permitted provided that the following conditions
!    are met:
! 
!      1. Redistributions of source code must retain the above copyright
!         notice, this list of conditions and the following disclaimer.
! 
!      2. Redistributions in binary form must reproduce the above copyright
!         notice, this list of conditions and the following disclaimer in the
!         documentation and/or other materials provided with the distribution.
! 
!      3. The names of its contributors may not be used to endorse or promote 
!         products derived from this software without specific prior written 
!         permission.
! 
!    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
!    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
!    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
!    A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
!    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
!    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
!    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
!    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
!    LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
!    NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! 
! 
!    Any feedback is very welcome.
!    http://www.math.keio.ac.jp/matumoto/emt.html
!    email: matumoto@math.keio.ac.jp
! -------------------------------------------------------------

module MersenneTwister_mod
! -------------------------------------------------------------
  implicit none
  private
  
  ! Algorithm parameters
  ! -------
  ! Period parameters
  integer, parameter :: blockSize = 624,         &
                        M         = 397,         &
                        MATRIX_A  = -1727483681, & ! constant vector a         (0x9908b0dfUL)
                        UMASK     = -2147483648_8, & ! most significant w-r bits (0x80000000UL)
                        LMASK     =  2147483647    ! least significant r bits  (0x7fffffffUL)
  ! Tempering parameters
  integer, parameter :: TMASKB= -1658038656, & ! (0x9d2c5680UL)
                        TMASKC= -272236544     ! (0xefc60000UL)
  ! -------

  ! The type containing the state variable  
  type randomNumberSequence
    integer                            :: currentElement ! = blockSize
    integer, dimension(0:blockSize -1) :: state ! = 0
  end type randomNumberSequence

  interface new_RandomNumberSequence
    module procedure initialize_scalar, initialize_vector
  end interface new_RandomNumberSequence 

  public :: randomNumberSequence
  public :: new_RandomNumberSequence, finalize_RandomNumberSequence, &
            getRandomInt, getRandomPositiveInt, getRandomReal
! -------------------------------------------------------------
contains
  ! -------------------------------------------------------------
  ! Private functions
  ! ---------------------------
  function mixbits(u, v)
    integer, intent( in) :: u, v
    integer              :: mixbits
    
    mixbits = ior(iand(u, UMASK), iand(v, LMASK))
  end function mixbits
  ! ---------------------------
  function twist(u, v)
    integer, intent( in) :: u, v
    integer              :: twist

    ! Local variable
    integer, parameter, dimension(0:1) :: t_matrix = (/ 0, MATRIX_A /)
    
    twist = ieor(ishft(mixbits(u, v), -1), t_matrix(iand(v, 1)))
    twist = ieor(ishft(mixbits(u, v), -1), t_matrix(iand(v, 1)))
  end function twist
  ! ---------------------------
  subroutine nextState(twister)
    type(randomNumberSequence), intent(inout) :: twister
    
    ! Local variables
    integer :: k
    
    do k = 0, blockSize - M - 1
      twister%state(k) = ieor(twister%state(k + M), &
                              twist(twister%state(k), twister%state(k + 1)))
    end do 
    do k = blockSize - M, blockSize - 2
      twister%state(k) = ieor(twister%state(k + M - blockSize), &
                              twist(twister%state(k), twister%state(k + 1)))
    end do 
    twister%state(blockSize - 1) = ieor(twister%state(M - 1), &
                                        twist(twister%state(blockSize - 1), twister%state(0)))
    twister%currentElement = 0

  end subroutine nextState
  ! ---------------------------
  elemental function temper(y)
    integer, intent(in) :: y
    integer             :: temper
    
    integer :: x
    
    ! Tempering
    x      = ieor(y, ishft(y, -11))
    x      = ieor(x, iand(ishft(x,  7), TMASKB))
    x      = ieor(x, iand(ishft(x, 15), TMASKC))
    temper = ieor(x, ishft(x, -18))
  end function temper
  ! -------------------------------------------------------------
  ! Public (but hidden) functions
  ! --------------------
  function initialize_scalar(seed) result(twister)
    integer,       intent(in   ) :: seed
    type(randomNumberSequence)                :: twister 
    
    integer :: i
    ! See Knuth TAOCP Vol2. 3rd Ed. P.106 for multiplier. In the previous versions, 
    !   MSBs of the seed affect only MSBs of the array state[].                       
    !   2002/01/09 modified by Makoto Matsumoto            
    
    twister%state(0) = iand(seed, -1)
    do i = 1,  blockSize - 1 ! ubound(twister%state)
       twister%state(i) = 1812433253 * ieor(twister%state(i-1), &
                                            ishft(twister%state(i-1), -30)) + i
       twister%state(i) = iand(twister%state(i), -1) ! for >32 bit machines
    end do
    twister%currentElement = blockSize
  end function initialize_scalar
  ! -------------------------------------------------------------
  function initialize_vector(seed) result(twister)
    integer, dimension(0:), intent(in) :: seed
    type(randomNumberSequence)                      :: twister 
    
    integer :: i, j, k, nFirstLoop, nWraps
    
    nWraps  = 0
    twister = initialize_scalar(19650218)
    
    nFirstLoop = max(blockSize, size(seed))
    do k = 1, nFirstLoop
       i = mod(k + nWraps, blockSize)
       j = mod(k - 1,      size(seed))
       if(i == 0) then
         twister%state(i) = twister%state(blockSize - 1)
         twister%state(1) = ieor(twister%state(1),                                 &
                                 ieor(twister%state(1-1),                          & 
                                      ishft(twister%state(1-1), -30)) * 1664525) + & 
                            seed(j) + j ! Non-linear
         twister%state(i) = iand(twister%state(i), -1) ! for >32 bit machines
         nWraps = nWraps + 1
       else
         twister%state(i) = ieor(twister%state(i),                                 &
                                 ieor(twister%state(i-1),                          & 
                                      ishft(twister%state(i-1), -30)) * 1664525) + & 
                            seed(j) + j ! Non-linear
         twister%state(i) = iand(twister%state(i), -1) ! for >32 bit machines
      end if
    end do
    
    !
    ! Walk through the state array, beginning where we left off in the block above
    ! 
    do i = mod(nFirstLoop, blockSize) + nWraps + 1, blockSize - 1
      twister%state(i) = ieor(twister%state(i),                                 &
                              ieor(twister%state(i-1),                          & 
                                   ishft(twister%state(i-1), -30)) * 1566083941) - i ! Non-linear
      twister%state(i) = iand(twister%state(i), -1) ! for >32 bit machines
    end do
    
    twister%state(0) = twister%state(blockSize - 1) 
    
    do i = 1, mod(nFirstLoop, blockSize) + nWraps
      twister%state(i) = ieor(twister%state(i),                                 &
                              ieor(twister%state(i-1),                          & 
                                   ishft(twister%state(i-1), -30)) * 1566083941) - i ! Non-linear
      twister%state(i) = iand(twister%state(i), -1) ! for >32 bit machines
    end do
    
    twister%state(0) = UMASK 
    twister%currentElement = blockSize
    
  end function initialize_vector
  ! -------------------------------------------------------------
  ! Public functions
  ! --------------------
  function getRandomInt(twister)
    type(randomNumberSequence), intent(inout) :: twister
    integer                      :: getRandomInt
    ! Generate a random integer on the interval [0,0xffffffff]
    !   Equivalent to genrand_int32 in the C code. 
    !   Fortran doesn't have a type that's unsigned like C does, 
    !   so this is integers in the range -2**31 - 2**31
    ! All functions for getting random numbers call this one, 
    !   then manipulate the result
    
    if(twister%currentElement >= blockSize) call nextState(twister)
      
    getRandomInt = temper(twister%state(twister%currentElement))
    twister%currentElement = twister%currentElement + 1
  
  end function getRandomInt
  ! --------------------
  function getRandomPositiveInt(twister)
    type(randomNumberSequence), intent(inout) :: twister
    integer                      :: getRandomPositiveInt
    ! Generate a random integer on the interval [0,0x7fffffff]
    !   or [0,2**31]
    !   Equivalent to genrand_int31 in the C code. 
    
    ! Local integers
    integer :: localInt

    localInt = getRandomInt(twister)
    getRandomPositiveInt = ishft(localInt, -1)
  
  end function getRandomPositiveInt
  ! --------------------
  function getRandomReal(twister)
    type(randomNumberSequence), intent(inout) :: twister
    double precision             :: getRandomReal
    ! Generate a random number on [0,1]
    !   Equivalent to genrand_real1 in the C code
    !   The result is stored as double precision but has 32 bit resolution
    
    integer :: localInt
    
    localInt = getRandomInt(twister)
    if(localInt < 0) then
      getRandomReal = dble(localInt + 2.0d0**32)/(2.0d0**32 - 1.0d0)
    else
      getRandomReal = dble(localInt            )/(2.0d0**32 - 1.0d0)
    end if
  end function getRandomReal
  ! --------------------
  subroutine finalize_RandomNumberSequence(twister)
    type(randomNumberSequence), intent(inout) :: twister
    
      twister%currentElement = blockSize
      twister%state(:) = 0
  end subroutine finalize_RandomNumberSequence
  ! --------------------  
end module MersenneTwister_mod

!FDOC_TAG_GFDL
module strat_netcdf_mod

use fms_mod,                   only :  write_version_number
use diag_manager_mod,          only :  register_diag_field, send_data
use time_manager_mod,          only :  time_type
use strat_cloud_utilities_mod, only :  strat_cloud_utilities_init, &
                                       diag_id_type, diag_pt_type

implicit none
private

!-----------------------------------------------------------------------
!---interfaces----------------------------------------------------------
public strat_netcdf_init, strat_netcdf, strat_netcdf_end
private diag_field_init

!----------------------------------------------------------------------
!----version number----------------------------------------------------
Character(len=128) :: Version = '$Id: strat_netcdf.F90,v 20.0 2013/12/13 23:22:17 fms Exp $'
Character(len=128) :: Tagname = '$Name: tikal $'

!-----------------------------------------------------------------------
!-------------------- diagnostics variables-----------------------------

character(len=5) :: mod_name = 'strat'
real :: missing_value = -999.


       
logical  :: module_is_initialized = .false.


CONTAINS


!#########################################################################

subroutine strat_netcdf_init (axes, Time, diag_id, diag_pt, n_diag_4d, &
                              n_diag_4d_kp1)

!------------------------------------------------------------------------
integer,             intent(in)    :: axes(4)
type(time_type),     intent(in)    :: Time
type(diag_id_type),  intent(inout) :: diag_id
type(diag_pt_type),  intent(inout) :: diag_pt
integer,             intent(out)   :: n_diag_4d, n_diag_4d_kp1

!------------------------------------------------------------------------
      if (module_is_initialized) return

!-----------------------------------------------------------------------
!    write version info to standard log.
!-----------------------------------------------------------------------
      call write_version_number(version, tagname)

!------------------------------------------------------------------------
!    make sure needed modules have been initialized.
!------------------------------------------------------------------------
      call strat_cloud_utilities_init

!------------------------------------------------------------------------
!    call diag_field_init to initialize any desired netcdf output fields.
!------------------------------------------------------------------------
      call diag_field_init (axes, Time, diag_id, diag_pt, n_diag_4d, &
                            n_diag_4d_kp1)

!-----------------------------------------------------------------------
      module_is_initialized = .true.


end subroutine strat_netcdf_init
 

!#######################################################################

subroutine strat_netcdf (diag_id, diag_pt, diag_4d, diag_4d_kp1, &
                         diag_3d, Time, is, js, kdim, mask3d)

!------------------------------------------------------------------------
type(diag_id_type),              intent(in) :: diag_id
type(diag_pt_type),              intent(in) :: diag_pt
real,dimension(:,:,:,0:),        intent(in) :: diag_4d, diag_4d_kp1
real,dimension(:,:,0:),          intent(in) :: diag_3d
type(time_type),                 intent(in) :: Time
integer,                         intent(in) :: is, js, kdim
real, dimension(:,:,:),optional, intent(in) :: mask3d


!---local variables------------------------------------------------------
      real, dimension (size(diag_4d,1), size(diag_4d,2), kdim+1) :: mask3
      logical, dimension (size(diag_4d,1), size(diag_4d,2), kdim) :: mask4
      logical :: used

!----------------------------------------------------------------------
!    set up half level mask.
!----------------------------------------------------------------------
      mask3(:,:,1:(kdim+1)) = 1.
      if (present(mask3d)) then
        where (mask3d(:,:,1:kdim) <= 0.5)
             mask3(:,:,2:(kdim+1)) = 0.
        end where
      endif
        
!-----------------------------------------------------------------------
!
!                    3-DIMENSIONAL DIAGNOSTICS
!
!-----------------------------------------------------------------------


!-----------------------------------------------------------------------
!    1) variables associated with droplet number and size:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%droplets, diag_4d(:,:,:,diag_pt%droplets),  &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%droplets_wtd, diag_4d(:,:,:,diag_pt%droplets_wtd),&
               Time, is, js, 1, mask=diag_4d(:,:,:,diag_pt%droplets) > 0.0)
      used = send_data    &
              (diag_id%rvolume, diag_4d(:,:,:,diag_pt%rvolume),   &
               Time, is, js, 1, rmask=mask3d)

!-----------------------------------------------------------------------
!    2) variables associated with cloud liquid content:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%ql_wt, diag_4d(:,:,:,diag_pt%ql_wt),   &
               Time, is, js, 1, mask=diag_4d(:,:,:,diag_pt%droplets) > 0.0)

!-----------------------------------------------------------------------
!    3) variables associated with cloud and precipitation processes:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%lsf_strat, diag_4d(:,:,:,diag_pt%lsf_strat),  &
               Time, is, js, 1, rmask=mask3d)
      used = send_data    &
              (diag_id%dcond, diag_4d(:,:,:,diag_pt%dcond),  &
               Time, is, js, 1, rmask=mask3d )
      used = send_data    &
              (diag_id%aauto, diag_4d(:,:,:,diag_pt%aauto),   &
               Time, is, js, 1, rmask=mask3d)
      used = send_data    &
              (diag_id%vfall, diag_4d(:,:,:,diag_pt%vfall),  &
               Time, is, js, 1, rmask=mask3d) 
      used = send_data   &
              (diag_id%delta_cf, diag_4d(:,:,:,diag_pt%delta_cf), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%cf_liq_init  , diag_4d(:,:,:,diag_pt%cf_liq_init  ), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%subgrid_w_variance,   &
               diag_4d(:,:,:,diag_pt%subgrid_w_variance), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%potential_droplets,   &
               diag_4d(:,:,:,diag_pt%potential_droplets), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%potential_crystals,  &
               diag_4d(:,:,:,diag_pt%potential_crystals), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%dust_berg_flag,    &
               diag_4d(:,:,:,diag_pt%dust_berg_flag), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%cf_ice_init, diag_4d(:,:,:,diag_pt%cf_ice_init), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qdt_snow_sublim,    &
               diag_4d(:,:,:,diag_pt%qdt_snow_sublim), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%snow_melt, diag_4d(:,:,:,diag_pt%snow_melt), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%rain_freeze, diag_4d(:,:,:,diag_pt%rain_freeze), &
               Time, is, js, 1, rmask=mask3d)

!-----------------------------------------------------------------------
!    4) variables associated with model convection:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%lcf_strat, diag_4d(:,:,:,diag_pt%lcf_strat),  &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%mfls_strat, diag_4d(:,:,:,diag_pt%mfls_strat), &
               Time, is, js, 1, rmask=mask3d)

!-----------------------------------------------------------------------
!    5) variables associated with ice particle number:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%nice, diag_4d(:,:,:,diag_pt%nice),   &
               Time, is, js, 1, rmask=mask3d)

!-----------------------------------------------------------------------
!    6) variables associated with precipitation and precipitation area:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%qrout, diag_4d(:,:,:,diag_pt%qrout),  &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qsout, diag_4d(:,:,:,diag_pt%qsout),   &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%rain3d, diag_4d_kp1(:,:,:,diag_pt%rain3d),  &
               Time, is, js, 1)
      used = send_data    &
              (diag_id%snow3d, diag_4d_kp1(:,:,:,diag_pt%snow3d),  &
               Time, is, js, 1)
      used = send_data   &
              (diag_id%rain_clr, diag_4d_kp1(:,:,:,diag_pt%rain_clr), &
               Time, is, js, 1, rmask=mask3)
      used = send_data   &
              (diag_id%a_rain_clr, diag_4d_kp1(:,:,:,diag_pt%a_rain_clr), &
               Time, is, js, 1, rmask=mask3)
      used = send_data   &
              (diag_id%rain_cld, diag_4d_kp1(:,:,:,diag_pt%rain_cld), &
               Time, is, js, 1, rmask=mask3)
      used = send_data   &
              (diag_id%a_rain_cld, diag_4d_kp1(:,:,:,diag_pt%a_rain_cld), &
               Time, is, js, 1,rmask=mask3)
      used = send_data   &
              (diag_id%a_precip_clr,   &
                                 diag_4d_kp1(:,:,:,diag_pt%a_precip_clr), &
               Time, is, js, 1, rmask=mask3)
      used = send_data   &
              (diag_id%a_precip_cld,    &
                                 diag_4d_kp1(:,:,:,diag_pt%a_precip_cld), &
               Time, is, js, 1,rmask=mask3)
      used = send_data   &
              (diag_id%snow_clr, diag_4d_kp1(:,:,:, diag_pt%snow_clr), &
               Time, is, js, 1, rmask=mask3)
      used = send_data   &
               (diag_id%a_snow_clr, diag_4d_kp1(:,:,:,diag_pt%a_snow_clr),&
                Time, is, js, 1, rmask=mask3)
      used = send_data   &
              (diag_id%snow_cld, diag_4d_kp1(:,:,:,diag_pt%snow_cld), &
               Time, is, js, 1, rmask=mask3)
      used = send_data   &
              (diag_id%a_snow_cld, diag_4d_kp1(:,:,:,diag_pt%a_snow_cld), &
               Time, is, js, 1, rmask=mask3)

!-----------------------------------------------------------------------
!    7) variables associated with cloud fraction:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%aall, diag_4d(:,:,:,diag_pt%aall),   &
               Time, is, js, 1, rmask=mask3d)
      used = send_data    &
              (diag_id%aliq, diag_4d(:,:,:,diag_pt%aliq),   &
               Time, is, js, 1, rmask=mask3d)
      used = send_data    &
              (diag_id%aice, diag_4d(:,:,:,diag_pt%aice),   &
               Time, is, js, 1, rmask=mask3d)
      mask4 = diag_4d(:,:,:,diag_pt%cfin) .ne. -1.e30
      used = send_data   &
              (diag_id%cfin, diag_4d(:,:,:,diag_pt%cfin), &
               Time, is, js, 1, mask=mask4)

!-----------------------------------------------------------------------
!    8) variables associated with cloud liquid time tendency:
!-----------------------------------------------------------------------
      used = send_data    &
              (diag_id%qldt_cond, diag_4d(:,:,:,diag_pt%qldt_cond), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data    &
              (diag_id%qldt_evap,  diag_4d(:,:,:,diag_pt%qldt_evap), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data    &
              (diag_id%qldt_eros, diag_4d(:,:,:,diag_pt%qldt_eros), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qldt_accr, diag_4d(:,:,:,diag_pt%qldt_accr), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qldt_auto, diag_4d(:,:,:,diag_pt%qldt_auto), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%liq_adj, diag_4d(:,:,:,diag_pt%liq_adj), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qldt_fill, diag_4d(:,:,:,diag_pt%qldt_fill), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data  &
              (diag_id%qldt_berg, diag_4d(:,:,:,diag_pt%qldt_berg), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qldt_freez, diag_4d(:,:,:,diag_pt%qldt_freez), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qldt_rime, diag_4d(:,:,:,diag_pt%qldt_rime), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qldt_destr, diag_4d(:,:,:,diag_pt%qldt_destr), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qldt_freez2, diag_4d(:,:,:,diag_pt%qldt_freez2), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qldt_sedi, diag_4d(:,:,:,diag_pt%qldt_sedi), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qldt_accrs, diag_4d(:,:,:,diag_pt%qldt_accrs), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qldt_bergs, diag_4d(:,:,:,diag_pt%qldt_bergs), &
               Time, is, js, 1, rmask=mask3d)

!-----------------------------------------------------------------------
!    9) variables associated with cloud droplet number time tendency:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%qndt_cond, diag_4d(:,:,:,diag_pt%qndt_cond), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_evap, diag_4d(:,:,:,diag_pt%qndt_evap), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_fill, diag_4d(:,:,:,diag_pt%qndt_fill), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_destr, diag_4d(:,:,:,diag_pt%qndt_destr), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_super, diag_4d(:,:,:,diag_pt%qndt_super), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_berg, diag_4d(:,:,:,diag_pt%qndt_berg), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_freez, diag_4d(:,:,:,diag_pt%qndt_freez), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_sacws, diag_4d(:,:,:,diag_pt%qndt_sacws), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data  &
              (diag_id%qndt_sacws_o, diag_4d(:,:,:,diag_pt%qndt_sacws_o), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_eros, diag_4d(:,:,:,diag_pt%qndt_eros), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_pra, diag_4d(:,:,:,diag_pt%qndt_pra), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_auto, diag_4d(:,:,:,diag_pt%qndt_auto), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_nucclim, diag_4d(:,:,:,diag_pt%qndt_nucclim), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_sedi, diag_4d(:,:,:,diag_pt%qndt_sedi), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_melt, diag_4d(:,:,:,diag_pt%qndt_melt), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_ihom, diag_4d(:,:,:,diag_pt%qndt_ihom), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_size_adj,diag_4d(:,:,:,diag_pt%qndt_size_adj),&
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qndt_fill2, diag_4d(:,:,:,diag_pt%qndt_fill2), &
               Time, is, js, 1, rmask=mask3d)

!-----------------------------------------------------------------------
!    10) variables associated with ice particle number time tendency:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%qnidt_fill, diag_4d(:,:,:,diag_pt%qnidt_fill), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data  &
              (diag_id%qnidt_nnuccd, diag_4d(:,:,:,diag_pt%qnidt_nnuccd), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qnidt_nsubi, diag_4d(:,:,:,diag_pt%qnidt_nsubi), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data  & 
              (diag_id%qnidt_nerosi, diag_4d(:,:,:,diag_pt%qnidt_nerosi), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qnidt_nprci, diag_4d(:,:,:,diag_pt%qnidt_nprci), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qnidt_nprai, diag_4d(:,:,:,diag_pt%qnidt_nprai), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qnidt_nucclim1,   &
                                  diag_4d(:,:,:,diag_pt%qnidt_nucclim1), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data  &
              (diag_id%qnidt_nucclim2,    &
                                  diag_4d(:,:,:,diag_pt%qnidt_nucclim2), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qnidt_sedi, diag_4d(:,:,:,diag_pt%qnidt_sedi), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qnidt_melt, diag_4d(:,:,:,diag_pt%qnidt_melt), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qnidt_size_adj, &
                                diag_4d(:,:,:,diag_pt%qnidt_size_adj), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qnidt_fill2, diag_4d(:,:,:,diag_pt%qnidt_fill2), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qnidt_super, diag_4d(:,:,:,diag_pt%qnidt_super), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qnidt_ihom, diag_4d(:,:,:,diag_pt%qnidt_ihom), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qnidt_destr, diag_4d(:,:,:,diag_pt%qnidt_destr), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data    &
              (diag_id%qnidt_cleanup,     &
                                  diag_4d(:,:,:,diag_pt%qnidt_cleanup), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data    &
              (diag_id%qnidt_cleanup2,     &
                                  diag_4d(:,:,:,diag_pt%qnidt_cleanup2), &
               Time, is, js, 1, rmask=mask3d)

!-----------------------------------------------------------------------
!    11) variables associated with relative humidity:
!-----------------------------------------------------------------------
      used = send_data    &
              (diag_id%rhcrit, diag_4d(:,:,:,diag_pt%rhcrit), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%rhcrit_min, diag_4d(:,:,:,diag_pt%rhcrit_min), &
               Time, is, js, 1, rmask=mask3d)
      mask4 = diag_4d(:,:,:,diag_pt%rhiin) .ne. -1.e30
      used = send_data   &
              (diag_id%rhiin, 100.*diag_4d(:,:,:,diag_pt%rhiin), &
               Time, is, js, 1, mask=mask4)
      mask4 = diag_4d(:,:,:,diag_pt%rhlin) .ne. -1.e30
      used = send_data   &
              (diag_id%rhlin, 100.*diag_4d(:,:,:,diag_pt%rhlin), &
               Time, is, js, 1, mask=mask4)

!-----------------------------------------------------------------------
!    12) variables associated with aerosol nucleation:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%imass7, diag_4d(:,:,:,diag_pt%imass7), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data    &
              (diag_id%ni_dust, diag_4d(:,:,:,diag_pt%ni_dust), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%ni_sulf, diag_4d(:,:,:,diag_pt%ni_sulf), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%ni_bc, diag_4d(:,:,:,diag_pt%ni_bc), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%ndust1, diag_4d(:,:,:,diag_pt%ndust1), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%ndust2, diag_4d(:,:,:,diag_pt%ndust2), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data    &
              (diag_id%ndust3, diag_4d(:,:,:,diag_pt%ndust3), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%ndust4, diag_4d(:,:,:,diag_pt%ndust4), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%ndust5, diag_4d(:,:,:,diag_pt%ndust5), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%sulfate, diag_4d(:,:,:,diag_pt%sulfate),  &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%seasalt_sub, diag_4d(:,:,:,diag_pt%seasalt_sub), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%seasalt_sup, diag_4d(:,:,:,diag_pt%seasalt_sup), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%om, diag_4d(:,:,:,diag_pt%om),    &
                Time, is, js, 1, rmask=mask3d)

!-----------------------------------------------------------------------
!    13) variables associated with water vapor tendency:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%rain_evap, diag_4d(:,:,:,diag_pt%rain_evap), &
               Time, is, js, 1, rmask=mask3d)

!-----------------------------------------------------------------------
!    14) variables associated with cloud ice tendency:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%qidt_dep, diag_4d(:,:,:,diag_pt%qidt_dep), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qidt_subl, diag_4d(:,:,:,diag_pt%qidt_subl), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qidt_eros, diag_4d(:,:,:,diag_pt%qidt_eros), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data  &
              (diag_id%qidt_fall, diag_4d(:,:,:,diag_pt%qidt_fall), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data  &
              (diag_id%qidt_melt, diag_4d(:,:,:,diag_pt%qidt_melt), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data  &
              (diag_id%qidt_melt2, diag_4d(:,:,:,diag_pt%qidt_melt2), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%ice_adj, diag_4d(:,:,:,diag_pt%ice_adj), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qidt_destr, diag_4d(:,:,:,diag_pt%qidt_destr), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qidt_qvdep, diag_4d(:,:,:,diag_pt%qidt_qvdep), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qidt_fill, diag_4d(:,:,:,diag_pt%qidt_fill), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qidt_auto, diag_4d(:,:,:,diag_pt%qidt_auto), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qidt_accr, diag_4d(:,:,:,diag_pt%qidt_accr), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qidt_accrs, diag_4d(:,:,:,diag_pt%qidt_accrs), &
               Time, is, js, 1, rmask=mask3d)

!-----------------------------------------------------------------------
!    15) variables associated with cloud area tendency:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%qadt_lsform, diag_4d(:,:,:,diag_pt%qadt_lsform), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qadt_lsdiss, diag_4d(:,:,:,diag_pt%qadt_lsdiss), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qadt_rhred, diag_4d(:,:,:,diag_pt%qadt_rhred), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qadt_eros, diag_4d(:,:,:,diag_pt%qadt_eros), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qadt_fill, diag_4d(:,:,:,diag_pt%qadt_fill), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qadt_super, diag_4d(:,:,:,diag_pt%qadt_super), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qadt_destr, diag_4d(:,:,:,diag_pt%qadt_destr), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qadt_limits, diag_4d(:,:,:,diag_pt%qadt_limits), &
               Time, is, js, 1, rmask=mask3d)
      used = send_data   &
              (diag_id%qadt_ahuco, diag_4d(:,:,:,diag_pt%qadt_ahuco), &
               Time, is, js, 1, rmask=mask3d)

!------------------------------------------------------------------------
!   16)  variables added by h1g with ncar M-G microphysics
!------------------------------------------------------------------------
      used = send_data ( diag_id%SA3d, diag_4d(:,:,:,diag_pt%SA3d),  &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%ST3d, diag_4d(:,:,:,diag_pt%ST3d),  &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%SQ3d, diag_4d(:,:,:,diag_pt%SQ3d),  &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%SL3d, diag_4d(:,:,:,diag_pt%SL3d),  &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%SI3d, diag_4d(:,:,:,diag_pt%SI3d),  &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%SN3d, diag_4d(:,:,:,diag_pt%SN3d),  &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%SNI3d, diag_4d(:,:,:,diag_pt%SNI3d),  &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qndt_contact_frz,    &
                          diag_4d(:,:,:,diag_pt%qndt_contact_frz), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qndt_cleanup,    &
                          diag_4d(:,:,:,diag_pt%qndt_cleanup), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qndt_cleanup2,   &
                          diag_4d(:,:,:,diag_pt%qndt_cleanup2), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qnidt_nsacwi,   &
                          diag_4d(:,:,:,diag_pt%qnidt_nsacwi), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_liquid_init,    &
                          diag_4d(:,:,:,diag_pt%qdt_liquid_init), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_ice_init,    &
                          diag_4d(:,:,:,diag_pt%qdt_ice_init), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_rain_evap,     &
                          diag_4d(:,:,:,diag_pt%qdt_rain_evap), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_snow_sublim,    &
                          diag_4d(:,:,:,diag_pt%qdt_snow_sublim), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_cond,    &
                          diag_4d(:,:,:,diag_pt%qdt_cond), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_deposition,    &
                          diag_4d(:,:,:,diag_pt%qdt_deposition), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_eros_l,   &
                          diag_4d(:,:,:,diag_pt%qdt_eros_l), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_eros_i,     &
                         diag_4d(:,:,:,diag_pt%qdt_eros_i), &
                         Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_qv_on_qi,     &
                          diag_4d(:,:,:,diag_pt%qdt_qv_on_qi), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_snow2vapor,    &
                          diag_4d(:,:,:,diag_pt%qdt_snow2vapor), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_sedi_ice2vapor,    &
                          diag_4d(:,:,:,diag_pt%qdt_sedi_ice2vapor), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_sedi_liquid2vapor,     &
                          diag_4d(:,:,:,diag_pt%qdt_sedi_liquid2vapor), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_super_sat_rm,    &
                          diag_4d(:,:,:,diag_pt%qdt_super_sat_rm), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_destr,    &
                          diag_4d(:,:,:,diag_pt%qdt_destr), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_cleanup_liquid,    &
                          diag_4d(:,:,:,diag_pt%qdt_cleanup_liquid), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%qdt_cleanup_ice,     &
                          diag_4d(:,:,:,diag_pt%qdt_cleanup_ice), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%srfrain_evap,    &
                          diag_4d(:,:,:,diag_pt%srfrain_evap ), &
                          Time, is, js, 1, rmask=mask3d )
      used = send_data ( diag_id%srfrain_accrs,     &
                          diag_4d(:,:,:,diag_pt%srfrain_accrs ), &
                          Time, is, js, 1, rmask=mask3d )
     used = send_data ( diag_id%srfrain_freez,     &
                         diag_4d(:,:,:,diag_pt%srfrain_freez ), &
                         Time, is, js, 1, rmask=mask3d )
     used = send_data ( diag_id%snow_mass_conv,   &
                        diag_3d(:,:,  diag_pt%snow_mass_conv), &
                        Time, is, js )
     used = send_data ( diag_id%neg_snow,     &
                         diag_3d(:,:,  diag_pt%neg_snow), &
                         Time, is, js )
     used = send_data ( diag_id%rain_mass_conv,    &
                         diag_3d(:,:,  diag_pt%rain_mass_conv), &
                         Time, is, js )
     used = send_data ( diag_id%neg_rain,    &
                         diag_3d(:,:,diag_pt%neg_rain), &
                         Time, is, js )
     used = send_data ( diag_id%qldt_HM_splinter,    &
                         diag_4d(:,:,:,diag_pt%qldt_HM_splinter), &
                         Time, is, js, 1, rmask=mask3d )

!-----------------------------------------------------------------------
!    17) variables associated with budget verification:
!-----------------------------------------------------------------------
     used = send_data ( diag_id%SA_imb, diag_4d(:,:,:,diag_pt%SA_imb), &
                               Time, is, js, 1, rmask=mask3d )
     used = send_data ( diag_id%ST_imb, diag_4d(:,:,:,diag_pt%ST_imb), &
                               Time, is, js, 1, rmask=mask3d )
     used = send_data ( diag_id%SQ_imb, diag_4d(:,:,:,diag_pt%SQ_imb), &
                               Time, is, js, 1, rmask=mask3d )
     used = send_data ( diag_id%SL_imb, diag_4d(:,:,:,diag_pt%SL_imb), &
                               Time, is, js, 1, rmask=mask3d )
     used = send_data ( diag_id%SI_imb, diag_4d(:,:,:,diag_pt%SI_imb), &
                               Time, is, js, 1, rmask=mask3d )
     used = send_data ( diag_id%SN_imb, diag_4d(:,:,:,diag_pt%SN_imb), &
                               Time, is, js, 1, rmask=mask3d )
     used = send_data ( diag_id%SNi_imb, diag_4d(:,:,:,diag_pt%SNi_imb), &
                               Time, is, js, 1, rmask=mask3d )
     used = send_data ( diag_id%rain_imb, diag_4d(:,:,:,diag_pt%rain_imb),&
                               Time, is, js, 1, rmask=mask3d )
     used = send_data ( diag_id%cld_liq_imb,   &
                         diag_4d(:,:,:,diag_pt%cld_liq_imb), &
                         Time, is, js, 1, rmask=mask3d )
     used = send_data ( diag_id%snow_imb,    &
                         diag_4d(:,:,:,diag_pt%snow_imb), &
                         Time, is, js, 1, rmask=mask3d )
     used = send_data ( diag_id%cld_ice_imb,     &
                         diag_4d(:,:,:,diag_pt%cld_ice_imb), &
                         Time, is, js, 1, rmask=mask3d )

!-----------------------------------------------------------------------
!
!                    COLUMN-INTEGRATED DIAGNOSTICS
!
!-----------------------------------------------------------------------


!-----------------------------------------------------------------------
!    1) variables associated with droplet number and size:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%droplets_col, diag_3d(:,:,diag_pt%droplets_col), &
               Time, is, js)
      used = send_data   &
              (diag_id%gb_droplets_col,   &
                                  diag_3d(:,:,diag_pt%gb_droplets_col),   &
               Time, is, js)
      used = send_data   &
              (diag_id%droplets_col250,   &
                                 diag_3d(:,:,diag_pt%droplets_col250),   &
               Time, is, js)

!-----------------------------------------------------------------------
!    3) variables associated with cloud and precipitation processes:
!-----------------------------------------------------------------------
      used = send_data  &
              (diag_id%sedi_ice, diag_3d(:,:,diag_pt%sedi_ice), &
               Time, is, js)
      used = send_data   &
              (diag_id%snow_melt_col, diag_3d(:,:, diag_pt%snow_melt), &
               Time, is, js)
      used = send_data   &
              (diag_id%rain_freeze_col, diag_3d(:,:, diag_pt%rain_freeze), &
               Time, is, js)
      used = send_data   &
              (diag_id%q_snow_sublim_col,    &
               diag_3d(:,:, diag_pt%qdt_snow_sublim), &
               Time, is, js)

      used = send_data   &
              (diag_id%sedi_sfc, diag_3d(:,:, diag_pt%sedi_sfc), &
               Time, is, js)

!-----------------------------------------------------------------------
!    5) variables associated with ice particle number:
!-----------------------------------------------------------------------
      used = send_data    &
              (diag_id%nice_col, diag_3d(:,:,diag_pt%nice_col),  &
               Time, is, js)
      used = send_data   &
              (diag_id%gb_nice_col, diag_3d(:,:,diag_pt%gb_nice_col),  &
               Time, is, js)

!-----------------------------------------------------------------------
!    6) variables associated with precipitation and precipitation area:
!-----------------------------------------------------------------------
      used = send_data    &
              (diag_id%qrout_col, diag_3d(:,:,diag_pt%qrout),  &
               Time, is, js)
      used = send_data   &
              (diag_id%qsout_col, diag_3d(:,:,diag_pt%qsout),  &
               Time, is, js)

!-----------------------------------------------------------------------
!    8) variables associated with cloud liquid time tendency:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%ql_cond_col, diag_3d(:,:,diag_pt%qldt_cond), &
               Time, is, js)
      used = send_data   & 
              (diag_id%ql_evap_col, diag_3d(:,:,diag_pt%qldt_evap), &
               Time, is, js)
      used = send_data   &
              (diag_id%ql_eros_col, diag_3d(:,:, diag_pt%qldt_eros), &
               Time, is, js)
      used = send_data   &
              (diag_id%ql_accr_col, diag_3d(:,:, diag_pt%qldt_accr), &
               Time, is, js)
      used = send_data   &
              (diag_id%ql_auto_col, diag_3d(:,:, diag_pt%qldt_auto), &
               Time, is, js)
      used = send_data   &
              (diag_id%ql_berg_col, diag_3d(:,:, diag_pt%qldt_berg), &
               Time, is, js)
      used = send_data   &
              (diag_id%ql_freez_col, diag_3d(:,:, diag_pt%qldt_freez), &
               Time, is, js)
      used = send_data   &
              (diag_id%ql_destr_col, diag_3d(:,:, diag_pt%qldt_destr), &
               Time, is, js)
      used = send_data   &
              (diag_id%ql_rime_col, diag_3d(:,:, diag_pt%qldt_rime), &
               Time, is, js)
      used = send_data   &
              (diag_id%ql_fill_col, diag_3d(:,:, diag_pt%qldt_fill), &
               Time, is, js)
      used = send_data   &
              (diag_id%liq_adj_col, diag_3d(:,:, diag_pt%liq_adj), &
               Time, is, js)
      used = send_data   &
              (diag_id%ql_freez2_col, diag_3d(:,:,diag_pt%qldt_freez2), &
               Time, is, js)
      used = send_data  &
              (diag_id%ql_sedi_col, diag_3d(:,:, diag_pt%qldt_sedi), &
               Time, is, js)
      used = send_data   &
              (diag_id%ql_accrs_col, diag_3d(:,:, diag_pt%qldt_accrs), &
               Time, is, js)
      used = send_data   &
              (diag_id%ql_bergs_col, diag_3d(:,:, diag_pt%qldt_bergs), &
               Time, is, js)

!-----------------------------------------------------------------------
!    9) variables associated with cloud droplet number time tendency:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%qn_cond_col, diag_3d(:,:, diag_pt%qndt_cond), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_evap_col, diag_3d(:,:, diag_pt%qndt_evap), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_fill_col, diag_3d(:,:, diag_pt%qndt_fill), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_berg_col, diag_3d(:,:, diag_pt%qndt_berg), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_destr_col, diag_3d(:,:, diag_pt%qndt_destr), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_super_col, diag_3d(:,:, diag_pt%qndt_super), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_freez_col, diag_3d(:,:, diag_pt%qndt_freez), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_sacws_col, diag_3d(:,:, diag_pt%qndt_sacws), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_sacws_o_col, diag_3d(:,:,diag_pt%qndt_sacws_o), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_eros_col, diag_3d(:,:, diag_pt%qndt_eros), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_pra_col, diag_3d(:,:, diag_pt%qndt_pra), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_auto_col, diag_3d(:,:, diag_pt%qndt_auto), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_nucclim_col, diag_3d(:,:,diag_pt%qndt_nucclim), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_sedi_col, diag_3d(:,:, diag_pt%qndt_sedi), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_melt_col, diag_3d(:,:, diag_pt%qndt_melt), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_ihom_col, diag_3d(:,:, diag_pt%qndt_ihom), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_size_adj_col,   &
                                     diag_3d(:,:,diag_pt%qndt_size_adj), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_fill2_col, diag_3d(:,:, diag_pt%qndt_fill2), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_contact_frz_col,    &
               diag_3d(:,:, diag_pt%qndt_contact_frz), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_cleanup_col,   &
               diag_3d(:,:, diag_pt%qndt_cleanup), &
               Time, is, js)
      used = send_data   &
              (diag_id%qn_cleanup2_col,    &
               diag_3d(:,:, diag_pt%qndt_cleanup2), &
               Time, is, js)

!-----------------------------------------------------------------------
!    13) variables associated with water vapor tendency:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%rain_evap_col, diag_3d(:,:, diag_pt%rain_evap), &
               Time, is, js)

!-----------------------------------------------------------------------
!    14) variables associated with cloud ice time tendency:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%qi_fall_col, diag_3d(:,:, diag_pt%qidt_fall), &
               Time, is, js)
      used = send_data   &
              (diag_id%qi_fill_col, diag_3d(:,:, diag_pt%qidt_fill), &
               Time, is, js)
      used = send_data   &
              (diag_id%qi_dep_col, diag_3d(:,:, diag_pt%qidt_dep),     &
               Time, is, js)
      used = send_data   &
              (diag_id%qi_subl_col, diag_3d(:,:, diag_pt%qidt_subl), &
               Time, is, js)
      used = send_data   &
              (diag_id%qi_eros_col, diag_3d(:,:, diag_pt%qidt_eros), &
               Time, is, js)
      used = send_data   &
              (diag_id%qi_destr_col, diag_3d(:,:, diag_pt%qidt_destr), &
               Time, is, js)
      used = send_data   &
              (diag_id%qi_qvdep_col, diag_3d(:,:, diag_pt%qidt_qvdep), &
               Time, is, js)
      used = send_data   &
              (diag_id%qi_melt_col, diag_3d(:,:, diag_pt%qidt_melt), &
               Time, is, js)
      used = send_data   &
              (diag_id%qi_melt2_col, diag_3d(:,:, diag_pt%qidt_melt2), &
               Time, is, js)
      used = send_data   &
              (diag_id%ice_adj_col,  diag_3d(:,:, diag_pt%ice_adj), &
               Time, is, js)
      used = send_data   &
              (diag_id%qi_auto_col, diag_3d(:,:, diag_pt%qidt_auto),     &
               Time, is, js)
      used = send_data   &
              (diag_id%qi_accr_col, diag_3d(:,:, diag_pt%qidt_accr),     &
               Time, is, js)
      used = send_data   &
              (diag_id%qi_accrs_col, diag_3d(:,:, diag_pt%qidt_accrs), &
               Time, is, js)

!-----------------------------------------------------------------------
!    15) variables associated with cloud area time tendency:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%qa_lsform_col, diag_3d(:,:, diag_pt%qadt_lsform),&
               Time, is, js)
      used = send_data   &
              (diag_id%qa_lsdiss_col, diag_3d(:,:, diag_pt%qadt_lsdiss),&
               Time, is, js)
      used = send_data   &
              (diag_id%qa_rhred_col, diag_3d(:,:, diag_pt%qadt_rhred), &
               Time, is, js)
      used = send_data   &
              (diag_id%qa_eros_col, diag_3d(:,:, diag_pt%qadt_eros), &
               Time, is, js)
      used = send_data   &
              (diag_id%qa_fill_col, diag_3d(:,:, diag_pt%qadt_fill), &
               Time, is, js)
      used = send_data   &
              (diag_id%qa_super_col, diag_3d(:,:, diag_pt%qadt_super), &
               Time, is, js)
      used = send_data   &
              (diag_id%qa_destr_col, diag_3d (:,:, diag_pt%qadt_destr), &
               Time, is, js)
      used = send_data   &
              (diag_id%qa_limits_col, diag_3d (:,:, diag_pt%qadt_limits), &
               Time, is, js)
      used = send_data   &
              (diag_id%qa_ahuco_col, diag_3d (:,:, diag_pt%qadt_ahuco), &
               Time, is, js)

!------------------------------------------------------------------------
!   16)  variables added by h1g with ncar M-G microphysics
!------------------------------------------------------------------------
      used = send_data ( diag_id%SA2d, diag_3d(:,:,diag_pt%SA3d),  &
                          Time, is, js )
      used = send_data ( diag_id%ST2d, diag_3d(:,:,diag_pt%ST3d),  &
                          Time, is, js )
      used = send_data ( diag_id%SQ2d, diag_3d(:,:,diag_pt%SQ3d),  &
                          Time, is, js )
      used = send_data ( diag_id%SL2d, diag_3d(:,:,diag_pt%SL3d),  &
                          Time, is, js )
      used = send_data ( diag_id%SI2d, diag_3d(:,:,diag_pt%SI3d),  &
                          Time, is, js )
      used = send_data ( diag_id%SN2d, diag_3d(:,:,diag_pt%SN3d),  &
                          Time, is, js )
      used = send_data ( diag_id%SNI2d, diag_3d(:,:,diag_pt%SNI3d),  &
                          Time, is, js )
      used = send_data (diag_id%q_liquid_init_col,  &
                  diag_3d(:,:,diag_pt%qdt_liquid_init),  Time, is, js )
      used = send_data (diag_id%q_ice_init_col,  &
                  diag_3d(:,:,diag_pt%qdt_ice_init),  Time, is, js )
      used = send_data (diag_id%q_rain_evap_col,  &
                  diag_3d(:,:,diag_pt%qdt_rain_evap),  Time, is, js )
      used = send_data (diag_id%q_cond_col,  &
                  diag_3d(:,:,diag_pt%qdt_cond),  Time, is, js )
      used = send_data (diag_id%q_deposition_col,  &
                  diag_3d(:,:,diag_pt%qdt_deposition),  Time, is, js )
      used = send_data (diag_id%q_eros_l_col,  &
                  diag_3d(:,:,diag_pt%qdt_eros_l),  Time, is, js )
      used = send_data (diag_id%q_eros_i_col,  &
                  diag_3d(:,:,diag_pt%qdt_eros_i),  Time, is, js )
      used = send_data (diag_id%q_qv_on_qi_col,  &
                  diag_3d(:,:,diag_pt%qdt_qv_on_qi),  Time, is, js )
      used = send_data (diag_id%q_sedi_ice2vapor_col,  &
                  diag_3d(:,:,diag_pt%qdt_sedi_ice2vapor),  Time, is, js )
      used = send_data (diag_id%q_sedi_liquid2vapor_col,  &
                  diag_3d(:,:,diag_pt%qdt_sedi_liquid2vapor), Time, is, js)
      used = send_data (diag_id%q_super_sat_rm_col,  &
                  diag_3d(:,:,diag_pt%qdt_super_sat_rm),  Time, is, js )
      used = send_data (diag_id%q_destr_col,  &
                  diag_3d(:,:,diag_pt%qdt_destr),  Time, is, js )
      used = send_data (diag_id%q_cleanup_liquid_col,  &
                  diag_3d(:,:,diag_pt%qdt_cleanup_liquid),  Time, is, js )
      used = send_data (diag_id%q_cleanup_ice_col,  &
                  diag_3d(:,:,diag_pt%qdt_cleanup_ice),  Time, is, js )
      used = send_data (diag_id%q_snow2vapor_col,  &
                  diag_3d(:,:,diag_pt%qdt_snow2vapor),  Time, is, js )
      used = send_data (diag_id%srfrain_accrs_col,  &
                  diag_3d(:,:,diag_pt%srfrain_accrs), Time, is, js )
      used = send_data (diag_id%srfrain_freez_col,   &
                  diag_3d(:,:,diag_pt%srfrain_freez), Time, is, js )
      used = send_data (diag_id%srfrain_evap_col,   &
                  diag_3d(:,:,diag_pt%srfrain_evap), Time, is, js )
      used = send_data (diag_id%ql_HM_splinter_col,  &
                  diag_3d(:,:,diag_pt%qldt_HM_splinter), Time, is, js )

!-----------------------------------------------------------------------
!    17) variables associated with budget verification:
!-----------------------------------------------------------------------
     used = send_data ( diag_id%SA_imb_col, diag_3d(:,:,diag_pt%SA_imb), &
                               Time, is, js )
     used = send_data ( diag_id%ST_imb_col, diag_3d(:,:,diag_pt%ST_imb), &
                               Time, is, js )
     used = send_data ( diag_id%SQ_imb_col, diag_3d(:,:,diag_pt%SQ_imb), &
                               Time, is, js )
     used = send_data ( diag_id%SL_imb_col, diag_3d(:,:,diag_pt%SL_imb), &
                               Time, is, js )
     used = send_data ( diag_id%SI_imb_col, diag_3d(:,:,diag_pt%SI_imb), &
                               Time, is, js )
     used = send_data ( diag_id%SN_imb_col, diag_3d(:,:,diag_pt%SN_imb), &
                               Time, is, js )
     used = send_data ( diag_id%SNi_imb_col, diag_3d(:,:,diag_pt%SNi_imb),&
                               Time, is, js )
     used = send_data ( diag_id%rain_imb_col,   &
                        diag_3d(:,:,diag_pt%rain_imb),&
                        Time, is, js )
     used = send_data ( diag_id%cld_liq_imb_col,   &
                        diag_3d(:,:,diag_pt%cld_liq_imb),&
                        Time, is, js )
     used = send_data ( diag_id%snow_imb_col,   &
                        diag_3d(:,:,diag_pt%snow_imb),&
                        Time, is, js )
     used = send_data ( diag_id%cld_ice_imb_col,   &
                        diag_3d(:,:,diag_pt%cld_ice_imb),&
                        Time, is, js )

!-----------------------------------------------------------------------
!    17) variables associated with ice particle number time tendency:
!-----------------------------------------------------------------------
      used = send_data   &
              (diag_id%qni_fill_col, diag_3d(:,:,diag_pt%qnidt_fill), &
               Time, is, js)
      used = send_data  &
              (diag_id%qni_nnuccd_col, diag_3d(:,:,diag_pt%qnidt_nnuccd), &
               Time, is, js)
      used = send_data   &
              (diag_id%qni_nsubi_col, diag_3d(:,:,diag_pt%qnidt_nsubi), &
               Time, is, js)
      used = send_data  & 
              (diag_id%qni_nerosi_col, diag_3d(:,:,diag_pt%qnidt_nerosi), &
               Time, is, js)
      used = send_data   &
              (diag_id%qni_nprci_col, diag_3d(:,:,diag_pt%qnidt_nprci), &
               Time, is, js)
      used = send_data   &
              (diag_id%qni_nprai_col, diag_3d(:,:,diag_pt%qnidt_nprai), &
               Time, is, js)
      used = send_data   &
              (diag_id%qni_nucclim1_col,   &
                                  diag_3d(:,:,diag_pt%qnidt_nucclim1), &
               Time, is, js)
      used = send_data  &
              (diag_id%qni_nucclim2_col,    &
                                  diag_3d(:,:,diag_pt%qnidt_nucclim2), &
               Time, is, js)
      used = send_data   &
              (diag_id%qni_sedi_col, diag_3d(:,:,diag_pt%qnidt_sedi), &
               Time, is, js)
      used = send_data   &
              (diag_id%qni_melt_col, diag_3d(:,:,diag_pt%qnidt_melt), &
               Time, is, js)
      used = send_data   &
              (diag_id%qni_size_adj_col, &
                                diag_3d(:,:,diag_pt%qnidt_size_adj), &
               Time, is, js)
      used = send_data   &
              (diag_id%qni_fill2_col, diag_3d(:,:,diag_pt%qnidt_fill2), &
               Time, is, js)
      used = send_data   &
              (diag_id%qni_super_col, diag_3d(:,:,diag_pt%qnidt_super), &
               Time, is, js)
      used = send_data   &
              (diag_id%qni_ihom_col, diag_3d(:,:,diag_pt%qnidt_ihom), &
               Time, is, js)
      used = send_data   &
              (diag_id%qni_destr_col, diag_3d(:,:,diag_pt%qnidt_destr), &
               Time, is, js)
      used = send_data    &
              (diag_id%qni_cleanup_col,     &
                                  diag_3d(:,:,diag_pt%qnidt_cleanup), &
               Time, is, js)
      used = send_data    &
              (diag_id%qni_nsacwi_col,     &
                                  diag_3d(:,:,diag_pt%qnidt_nsacwi), &
               Time, is, js)
      used = send_data    &
              (diag_id%qni_cleanup2_col,     &
                                  diag_3d(:,:,diag_pt%qnidt_cleanup2), &
               Time, is, js)

!------------------------------------------------------------------------


end subroutine strat_netcdf


!########################################################################

subroutine strat_netcdf_end

     module_is_initialized = .false.

end subroutine strat_netcdf_end


!#######################################################################


! <SUBROUTINE NAME="diag_field_init">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!         Initializes netcdf diagnostics.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call diag_field_init (axes,Time)
!
!  </TEMPLATE>
!  <IN NAME="axes" TYPE="integer">
!         Integer array containing axes integers.
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!         Time 
!  </IN>
! </SUBROUTINE>
!
!------------------------------------------------------------------------

subroutine diag_field_init (axes, Time, diag_id, diag_pt, n_diag_4d,  &
                            n_diag_4d_kp1)

!-----------------------------------------------------------------------
integer,            intent(in)    :: axes(4)
type(time_type),    intent(in)    :: Time
type(diag_id_type), intent(inout) :: diag_id
type(diag_pt_type), intent(inout) :: diag_pt
integer,            intent(out)   :: n_diag_4d, n_diag_4d_kp1

!-----------------------------------------------------------------------
!---local variables--------------------------------------------------
      integer, dimension(3) :: half = (/1,2,4/)

!-------------------------------------------------------------------------
!    register the available netcdf fields if they have been requested.
!-------------------------------------------------------------------------

!-----------------------------------------------------------------------
!
!                        3-DIMENSIONAL DIAGNOSTICS
!
!-----------------------------------------------------------------------

!------------------------------------------------------------------------
!    1) variables associated with droplet number and size:
!------------------------------------------------------------------------
      diag_id%droplets = register_diag_field (mod_name,    &
             'droplets', axes(1:3), Time,   &
             'Droplet number concentration', '/cm3',  &
             missing_value=missing_value )
      diag_id%droplets_wtd = register_diag_field (mod_name,   &
             'droplets_wtd', axes(1:3), Time,  &
             'Droplet number conc*Cld liq', 'kg/(kg*m3)',  &
             mask_variant=.true., missing_value=missing_value)
      diag_id%rvolume = register_diag_field (mod_name,   &
             'rvolume', axes(1:3), Time,   &
             'Cloud liquid mean volume radius', 'microns',       &
             missing_value=missing_value )

!------------------------------------------------------------------------
!    2) variables associated with cloud liquid content:
!------------------------------------------------------------------------
      diag_id%ql_wt = register_diag_field (mod_name,   &
             'ql_wt', axes(1:3), Time,   &
             'Cld liq for weighting droplet conc', 'kg/kg',  &
             mask_variant=.true., missing_value=missing_value)

!------------------------------------------------------------------------
!    3) variables associated with cloud and precipitation processes:
!------------------------------------------------------------------------
      diag_id%lsf_strat = register_diag_field (mod_name, &
             'lsf_strat', axes(1:3), Time, &
             'Condensation/deposition frequency from LS', 'none',   &
             missing_value=missing_value)
      diag_id%dcond = register_diag_field (mod_name,   &
             'dcond', axes(1:3), Time,    &
             'condensation/evaporation', 'kg/kg/s', &
             missing_value=missing_value)
      diag_id%aauto = register_diag_field (mod_name,   &
             'aauto', axes(1:3), Time,   &
             'Cloud fraction where autoconversion is occurring',  &
             'dimensionless',   &
             missing_value=missing_value)
      diag_id%vfall = register_diag_field (mod_name,   &
             'vfall', axes(1:3), Time,   &
             'Ice crystal fall speed', 'meters/second',          &
             missing_value=missing_value)
      diag_id%delta_cf = register_diag_field (mod_name,  &
             'delta_cf', axes(1:3), Time,   &
             'increase in cloud area due to condensation ',    &
             'dimensionless',    &
             missing_value=missing_value)
      diag_id%cf_liq_init   = register_diag_field (mod_name,   &
             'cf_liq_init', axes(1:3), Time,  &
             'adjusted large-scale liquid cloud area before physics', &
             'dimensionless',  &
             missing_value=missing_value)
      diag_id%subgrid_w_variance = register_diag_field (mod_name,  &
             'subgrid_w_variance', axes(1:3), Time,    &
             'standard  dev of subgrid vert vel distribution', 'm/s',   &
             missing_value=missing_value)
      diag_id%potential_droplets = register_diag_field (mod_name,   &
             'potential_droplets', axes(1:3), Time,   &
             'number of droplets which may be activated', '/cm3',   &
             missing_value=missing_value)
      diag_id%potential_crystals = register_diag_field (mod_name,    &
             'potential_crystals', axes(1:3), Time,    &
             'number of crystals which may be activated', '/m3',   &
             missing_value=missing_value)
      diag_id%dust_berg_flag = register_diag_field (mod_name,    &
             'dust_berg_flag', axes(1:3), Time,    &
             'frequency of active dust_berg process', 'none',   &
             missing_value=missing_value)
      diag_id%cf_ice_init = register_diag_field (mod_name,    &
             'cf_ice_init', axes(1:3), Time,   &
             'adjusted large-scale ice cloud area before physics',  &
             'dimensionless',  &
             missing_value=missing_value)
      diag_id%snow_melt = register_diag_field (mod_name, &
             'snow_melt', axes(1:3), Time, &
             'Rain water tendency from snow melting', 'kg/kg/sec',  &
             missing_value=missing_value)
      diag_id%rain_freeze = register_diag_field (mod_name, &
             'rain_freeze', axes(1:3), Time, &
             'Rain loss from rain freezing', 'kg/kg/sec',  &
             missing_value=missing_value)

!------------------------------------------------------------------------
!    4) variables associated with model convection:
!------------------------------------------------------------------------
      diag_id%lcf_strat = register_diag_field (mod_name, &
             'lcf_strat', axes(1:3), Time, & 
             'Convection frequency from LS', 'none',   &
             missing_value=missing_value)
      diag_id%mfls_strat = register_diag_field (mod_name, &
             'mfls_strat', axes(1:3), Time, &
             'Convective mass flux from LS', 'Pascal/s',  &
             missing_value=missing_value)

!------------------------------------------------------------------------
!    5) variables associated with ice particle number:
!------------------------------------------------------------------------
      diag_id%nice = register_diag_field (mod_name,   &
             'nice', axes(1:3), Time,    &
             'ice number concentration', '/cm3',   &
             missing_value=missing_value)

!------------------------------------------------------------------------
!    6) variables associated with precipitation and precipitation area:
!------------------------------------------------------------------------
      diag_id%qrout = register_diag_field (mod_name,   &
             'qrout', axes(1:3), Time,   &
             'rain mixing ratio', 'kg/kg',    &
             missing_value=missing_value)
      diag_id%qsout = register_diag_field (mod_name,    &
             'qsout', axes(1:3), Time,    &
             'snow mixing ratio', 'kg/kg',  &
             missing_value=missing_value)
      diag_id%rain3d = register_diag_field (mod_name,   &
             'rain3d', axes(half), Time,    &
             'rain rate', 'kg/m2/s',   &
             missing_value=missing_value)
      diag_id%snow3d = register_diag_field (mod_name,    &
             'snow3d', axes(half), Time,  &
             'snow rate', 'kg/m2/s',   &
             missing_value=missing_value)
      diag_id%rain_clr = register_diag_field (mod_name, &
             'rain_clr', axes(half), Time, &
             'Clear sky rain rate averaged to grid box mean', 'kg/m2/s', &
             missing_value=missing_value)
      diag_id%rain_cld = register_diag_field (mod_name, &
             'rain_cld', axes(half), Time, &
             'cloudy sky rain rate averaged to grid box mean', 'kg/m2/s', &
             missing_value=missing_value)
      diag_id%a_rain_clr = register_diag_field (mod_name, &
             'a_rain_clr', axes(half), Time, &
             'Clear sky rain fractional coverage', 'fraction',   &
             missing_value=missing_value)
      diag_id%a_rain_cld = register_diag_field (mod_name, &
             'a_rain_cld', axes(half), Time, &
             'cloudy sky rain fractional coverage', 'fraction',   &
             missing_value=missing_value)
      diag_id%a_precip_clr = register_diag_field (mod_name, &
             'a_precip_clr', axes(half), Time, &
             'Clear sky precip fractional coverage', 'fraction',   &
             missing_value=missing_value)
      diag_id%a_precip_cld = register_diag_field (mod_name, &
            'a_precip_cld', axes(half), Time, &
            'cloudy sky precip fractional coverage', 'fraction',   &
            missing_value=missing_value)
      diag_id%snow_clr = register_diag_field (mod_name, &
             'snow_clr', axes(half), Time, &
             'Clear sky snow rate averaged to grid box mean', 'kg/m2/s',  &
             missing_value=missing_value)
      diag_id%snow_cld = register_diag_field (mod_name, &
             'snow_cld', axes(half), Time, &
             'cloudy sky snow rate averaged to grid box mean', 'kg/m2/s', &
             missing_value=missing_value)
      diag_id%a_snow_clr = register_diag_field (mod_name, &
             'a_snow_clr', axes(half), Time, &
             'Clear sky snow fractional coverage', 'fraction',   &
             missing_value=missing_value)
      diag_id%a_snow_cld = register_diag_field (mod_name, &
             'a_snow_cld', axes(half), Time, &
             'cloudy sky snow fractional coverage', 'fraction',   &
             missing_value=missing_value)

!------------------------------------------------------------------------
!    7) variables associated with cloud fraction:
!------------------------------------------------------------------------
      diag_id%aall = register_diag_field (mod_name,   &
             'aall', axes(1:3), Time,    &
             'Cloud fraction for all large-scale clouds at midtimestep',  &
             'dimensionless',   &
             missing_value=missing_value)
      diag_id%aliq = register_diag_field (mod_name,   &
             'aliq', axes(1:3), Time,    &
             'Cloud fraction for large-scale liquid clouds',   &
             'dimensionless',&
             missing_value=missing_value)
      diag_id%aice = register_diag_field (mod_name,   &
             'aice', axes(1:3), Time,   &
             'Cloud fraction for large-scale ice clouds',    &
             'dimensionless',   &
             missing_value=missing_value)
      diag_id%cfin = register_diag_field (mod_name,    &
             'cfin', axes(1:3), Time,    &
             'cloud fraction at T < 268 K', 'dimensionless',   &
             mask_variant = .true., missing_value=missing_value)

!-----------------------------------------------------------------------
!    8) variables associated with cloud liquid time tendency:
!-----------------------------------------------------------------------
      diag_id%qldt_cond = register_diag_field (mod_name, &
             'qldt_cond', axes(1:3), Time, &
             'Liq water specific humidity tendency from LS condensation', &
             'kg/kg/sec',    &
             missing_value=missing_value)
      diag_id%qldt_evap = register_diag_field (mod_name, &
             'qldt_evap', axes(1:3), Time, &
             'Liq water specific humidity tendency from LS evaporation', &
             'kg/kg/sec',   &
             missing_value=missing_value)
      diag_id%qldt_eros = register_diag_field (mod_name, &
             'qldt_eros', axes(1:3), Time, &
             'Liquid water specific humidity tendency from erosion',   &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qldt_accr = register_diag_field (mod_name, &
             'qldt_accr', axes(1:3), Time, &
             'Liquid water specific humidity tendency from &
                                                    &accretion by rain', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qldt_auto = register_diag_field (mod_name, &
             'qldt_auto', axes(1:3), Time, &
             'Liq water specific humidity tendency from   &
                                                &autoconversion to rain',&
             'kg/kg/sec', missing_value=missing_value)
      diag_id%liq_adj = register_diag_field (mod_name, &
             'liq_adj', axes(1:3), Time, &
             'Liquid water specific humidity tendency from   &
                              &the removal of supersaturation',&
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qldt_fill = register_diag_field (mod_name, &
             'qldt_fill', axes(1:3), Time, &
           'Liquid water specific humidity tendency -- &      
                                       &pre-microphysics filler', &
             'kg/kg/sec',  missing_value=missing_value)
      diag_id%qldt_berg = register_diag_field (mod_name, &
             'qldt_berg', axes(1:3), Time, &
             'Liq water specific humidity tendency from Bergeron process',&
             'kg/kg/sec',    &
             missing_value=missing_value)
      diag_id%qldt_freez = register_diag_field (mod_name, &
             'qldt_freez', axes(1:3), Time, &
             'Liq water specific humidity tendency from homogen freezing',&
             'kg/kg/sec',   &
             missing_value=missing_value)
      diag_id%qldt_rime = register_diag_field (mod_name, &
             'qldt_rime', axes(1:3), Time, & 
             'Liquid water specific humidity tendency from riming',    &
             'kg/kg/sec',   &
             missing_value=missing_value)
      diag_id%qldt_destr = register_diag_field (mod_name, &
             'qldt_destr', axes(1:3), Time, &
             'Liq water specific humidity tendency from cld destruction',&
             'kg/kg/sec',   &
             missing_value=missing_value)
      diag_id%qldt_freez2 = register_diag_field (mod_name, &
             'qldt_freez2', axes(1:3), Time, &
             'Liq water spec hum tend from heterogen drop freezing ', &
             'kg/kg/sec',   &
             missing_value=missing_value)
      diag_id%qldt_sedi = register_diag_field (mod_name, &
             'qldt_sedi', axes(1:3), Time, &
             'Liq water spec hum tendency from droplet sedimentation', &
             'kg/kg/sec',   &
             missing_value=missing_value)
      diag_id%sedi_sfc = register_diag_field (mod_name, &
             'sedi_sfc', axes(1:2), Time, &
             'Liquid sedimentation flux at surface', &
             'm/sec',   &
             missing_value=missing_value)
      diag_id%qldt_accrs = register_diag_field (mod_name, &
             'qldt_accrs', axes(1:3), Time, &
             'Liq water spec hum tend from collection of    &
                                             &cloud liquid by snow ', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qldt_bergs = register_diag_field (mod_name, &
             'qldt_bergs', axes(1:3), Time, &
             'Liq water spec hum tendency from bergeron process for snow',&
             'kg/kg/sec',   &
             missing_value=missing_value)

!-----------------------------------------------------------------------
!    9) variables associated with cloud droplet number time tendency:
!-----------------------------------------------------------------------
      diag_id%qndt_cond = register_diag_field (mod_name, &
             'qndt_cond', axes(1:3), Time, &
             'Cloud droplet number tendency from LS condensation', &
             '#/kg/sec',   &
             missing_value=missing_value)
      diag_id%qndt_evap = register_diag_field (mod_name, &
             'qndt_evap', axes(1:3), Time, &
             'Cloud droplet number tendency from LS evaporation',   &
             '#/kg/sec',  &
             missing_value=missing_value)
      diag_id%qndt_fill = register_diag_field (mod_name, &
             'qndt_fill', axes(1:3), Time, &
             'Cloud droplet number tendency from filler', '#/kg/sec',   &
             missing_value=missing_value)
      diag_id%qndt_destr = register_diag_field (mod_name, &
             'qndt_destr', axes(1:3), Time, &
             'Cloud droplet number tendency from cloud destruction',   &
             '#/kg/sec', &
             missing_value=missing_value)
      diag_id%qndt_super = register_diag_field (mod_name, &
             'qndt_super', axes(1:3), Time, &
             'Cloud droplet number tendency from supersaturation removal',&
             '#/kg/sec',    &
             missing_value=missing_value)
      diag_id%qndt_berg = register_diag_field (mod_name, &
             'qndt_berg', axes(1:3), Time, &
             'Cloud droplet number tendency from Bergeron', '#/kg/sec',   &
             missing_value=missing_value)
      diag_id%qndt_freez = register_diag_field (mod_name, &
             'qndt_freez', axes(1:3), Time, &
             'Cloud droplet number tendency from heterogeneous freezing', &
             '#/kg/sec',  &
             missing_value=missing_value)
      diag_id%qndt_sacws = register_diag_field (mod_name, &
             'qndt_sacws', axes(1:3), Time, &
             'Cloud droplet number tendency from collection by snow',  &
             '#/kg/sec',&
             missing_value=missing_value)
      diag_id%qndt_sacws_o = register_diag_field (mod_name, &
             'qndt_sacws_o', axes(1:3), Time, &
             'Cld drop number tend from collection by snw   &
                                              &- one ice cat scheme', &
             '#/kg/sec', missing_value=missing_value)
      diag_id%qndt_eros = register_diag_field (mod_name, &
             'qndt_eros', axes(1:3), Time, &
             'Cloud droplet number tendency from erosion', '#/kg/sec',   &
             missing_value=missing_value)
      diag_id%qndt_pra = register_diag_field (mod_name, &
             'qndt_pra', axes(1:3), Time, &
             'Cloud droplet number tendency from collection by rain',   &
             '#/kg/sec',&
             missing_value=missing_value)
      diag_id%qndt_auto = register_diag_field (mod_name, &
             'qndt_auto', axes(1:3), Time, &
             'Cloud droplet number tendency from autoconversion',   &
             '#/kg/sec',   &
              missing_value=missing_value)
      diag_id%qndt_nucclim = register_diag_field (mod_name, &
             'qndt_nucclim', axes(1:3), Time, &
             'Cloud droplet number tendency from nucleation limiter', &
             '#/kg/sec', missing_value=missing_value)     
      diag_id%qndt_sedi = register_diag_field (mod_name, &
             'qndt_sedi', axes(1:3), Time, &
             'Cloud droplet number tendency from sedimentation',   &
             '#/kg/sec', missing_value=missing_value)  
      diag_id%qndt_melt = register_diag_field (mod_name, &
             'qndt_melt', axes(1:3), Time, &
             'Cloud droplet number tendency from melting', '#/kg/sec',   &
             missing_value=missing_value) 
      diag_id%qndt_ihom = register_diag_field (mod_name, &
             'qndt_ihom', axes(1:3), Time, &
             'Cloud drop number tend from homogeneous freezing',   &
             '#/kg/sec', missing_value=missing_value)  
      diag_id%qndt_size_adj = register_diag_field (mod_name, &
             'qndt_size_adj', axes(1:3), Time, &
             'Cloud droplet number tendency from size adjustment',  &
             '#/kg/sec', missing_value=missing_value)  
      diag_id%qndt_fill2 = register_diag_field (mod_name, &
             'qndt_fill2', axes(1:3), Time, &
             'Cloud droplet number tendency from second filler',  &
             '#/kg/sec', missing_value=missing_value)  

  !-----------------------------------------------------------------------
  !    10) variables associated with ice particle number time tendency:
  !-----------------------------------------------------------------------
      diag_id%qnidt_fill = register_diag_field (mod_name, &
             'qnidt_fill', axes(1:3), Time, &
             'Ice particle number tendency from filler', '#/kg/sec',   &
             missing_value=missing_value)  
      diag_id%qnidt_nnuccd = register_diag_field (mod_name, &
             'qnidt_nnuccd', axes(1:3), Time, &
             'Ice particle number tendency from nucleation', '#/kg/sec',  &
             missing_value=missing_value)  
      diag_id%qnidt_nsubi = register_diag_field (mod_name, &
             'qnidt_nsubi', axes(1:3), Time, &
             'Ice particle number tendency from sublimation', '#/kg/sec', &
             missing_value=missing_value)  
      diag_id%qnidt_nerosi = register_diag_field (mod_name, &
             'qnidt_nerosi', axes(1:3), Time, &
             'Ice particle number tendency from erosion', '#/kg/sec',   &
             missing_value=missing_value) 
      diag_id%qnidt_nprci = register_diag_field (mod_name, &
             'qnidt_nprci', axes(1:3), Time, &
             'Ice particle number tendency from autoconversion', &
             '#/kg/sec', missing_value=missing_value) 
      diag_id%qnidt_nprai = register_diag_field (mod_name, &
             'qnidt_nprai', axes(1:3), Time, &
             'Ice particle number tendency from accretion by snow',   &
             '#/kg/sec', missing_value=missing_value) 
      diag_id%qnidt_nucclim1 = register_diag_field (mod_name, &
             'qnidt_nucclim1', axes(1:3), Time, &
             'Ice particle number tendency from first nucleation limiter',&
             '#/kg/sec', missing_value=missing_value) 
      diag_id%qnidt_nucclim2 = register_diag_field (mod_name, &
             'qnidt_nucclim2', axes(1:3), Time, &
             'Ice particle number tendency from second nucleation &
             &limiter','#/kg/sec', missing_value=missing_value) 
      diag_id%qnidt_sedi = register_diag_field (mod_name, &
             'qnidt_sedi', axes(1:3), Time, &
             'Ice particle number tendency from sedimentation', &
             '#/kg/sec', missing_value=missing_value) 
      diag_id%qnidt_melt = register_diag_field (mod_name, &
             'qnidt_melt', axes(1:3), Time, &
             'Ice particle number tendency from melting', '#/kg/sec',  &
             missing_value=missing_value) 
      diag_id%qnidt_size_adj = register_diag_field (mod_name, &
             'qnidt_size_adj', axes(1:3), Time, &
             'Ice particle number tendency from size adjustment', &
             '#/kg/sec', missing_value=missing_value) 
      diag_id%qnidt_fill2 = register_diag_field (mod_name, &
             'qnidt_fill2', axes(1:3), Time, &
             'Ice particle number tendency from second filler', &
             '#/kg/sec', missing_value=missing_value)  
      diag_id%qnidt_super = register_diag_field (mod_name, &
             'qnidt_super', axes(1:3), Time, &
             'Ice particle number tendency from removal of   &
             &supersaturation', '#/kg/sec', missing_value=missing_value)  
      diag_id%qnidt_ihom = register_diag_field (mod_name, &
             'qnidt_ihom', axes(1:3), Time, &
             'Ice particle number tendency from homogeneous freezing', &
             '#/kg/sec', missing_value=missing_value)  
      diag_id%qnidt_destr = register_diag_field (mod_name, &
             'qnidt_destr', axes(1:3), Time, &
             'Ice particle number tendency from cloud destruction', &
             '#/kg/sec', missing_value=missing_value)  
      diag_id%qnidt_cleanup = register_diag_field (mod_name, &
             'qnidt_cleanup', axes(1:3), Time, &
             'Ice particle number tendency from cleanup', '#/kg/sec',   &
             missing_value=missing_value)  
      diag_id%qnidt_cleanup2 = register_diag_field (mod_name, &
             'qnidt_cleanup2', axes(1:3), Time, &
             'Ice particle number tendency from cleanup2', '#/kg/sec',  &
             missing_value=missing_value)  

  !-----------------------------------------------------------------------
  !    11) variables associated with relative humidity:
  !-----------------------------------------------------------------------
      diag_id%rhcrit = register_diag_field (mod_name,    &
             'rhcrit', axes(1:3), Time,   &
             'spectral avgd critical rh used for ice nuclei activation', &
             'percent', missing_value=missing_value)
      diag_id%rhcrit_min = register_diag_field (mod_name,   &
             'rhcrit_min', axes(1:3), Time,   &
             'minimum critical rh for ice nuclei activation in any  &
             &spectral band', 'percent',  missing_value=missing_value)
      diag_id%rhiin = register_diag_field (mod_name,    &
             'rhiin', axes(1:3), Time,   &
             'rh wrt ice calculated for ice nulei activation', 'percent', &
             mask_variant = .true., missing_value=missing_value)
      diag_id%rhlin = register_diag_field (mod_name,   &
             'rhlin', axes(1:3), Time,    &
             'rh wrt liquid calculated for ice nulei activation',   &
             'percent', mask_variant = .true., &
             missing_value=missing_value)

  !-----------------------------------------------------------------------
  !    12) variables associated with aerosol nucleation:
  !-----------------------------------------------------------------------
      diag_id%imass7 = register_diag_field (mod_name,   &
             'imass7', axes(1:3), Time, &
             'sub-micron dust concentration', 'ug dust /m3', &
             missing_value=missing_value)
      diag_id%ni_dust = register_diag_field (mod_name,   &
             'ni_dust', axes(1:3), Time,   &
             'number of activated dust ice nuclei', '# / m3',    &
             missing_value=missing_value)
      diag_id%ni_sulf = register_diag_field (mod_name,    &
             'ni_sulf', axes(1:3), Time,   &
             'number  of activated sulfate/seasalt ice nuclei', '# / m3', &
             missing_value=missing_value)
      diag_id%ni_bc = register_diag_field (mod_name,    &
             'ni_bc', axes(1:3), Time,   &
             'number of activated bc ice nuclei', '# / m3',   &
             missing_value=missing_value)
      diag_id%ndust1 = register_diag_field (mod_name,    &
             'ndust1', axes(1:3), Time,   &
             'number of particles in dust bin1', 'none',   &
             missing_value=missing_value)
      diag_id%ndust2 = register_diag_field (mod_name,    &
             'ndust2', axes(1:3), Time,   &
             'number of particles in dust bin2', 'none',   &
             missing_value=missing_value)
      diag_id%ndust3 = register_diag_field (mod_name,    &
             'ndust3', axes(1:3), Time,    &
             'number of particles in dust bin3', 'none',   &
             missing_value=missing_value)
      diag_id%ndust4 = register_diag_field (mod_name,    &
             'ndust4', axes(1:3), Time,  &
             'number of particles in dust bin4', 'none',   &
             missing_value=missing_value)
      diag_id%ndust5 = register_diag_field (mod_name,   &
             'ndust5', axes(1:3), Time,   &
             'number of particles in dust bin5', 'none',   &
             missing_value=missing_value)
      diag_id%sulfate = register_diag_field (mod_name,   &
             'sulfate', axes(1:3), Time,   &
             'sulfate mass concentration', 'ug so4/m3',   &
             missing_value=missing_value)
      diag_id%seasalt_sub = register_diag_field (mod_name,   &
             'seasalt_sub', axes(1:3), Time,   &
             'sub-micron sea salt mass concentration', 'ug/m3',    &
             missing_value=missing_value)
      diag_id%seasalt_sup = register_diag_field (mod_name,   &
             'seasalt_sup', axes(1:3), Time,   &
             'super-micron sea salt mass concentration', 'ug/m3', &
             missing_value=missing_value)
      diag_id%om = register_diag_field (mod_name,    &
             'OM', axes(1:3), Time,  &
             'OM mass concentration', 'ug/m3',   &
             missing_value=missing_value)

  !-----------------------------------------------------------------------
  !    13) variables associated with water vapor tendency:
  !-----------------------------------------------------------------------
      diag_id%rain_evap = register_diag_field (mod_name, &
             'rain_evap', axes(1:3), Time, &
             'Water vapor tendency from rain evaporation', 'kg/kg/sec',  &
             missing_value=missing_value)

  !-----------------------------------------------------------------------
  !    14) variables associated with cloud ice time tendency:
  !-----------------------------------------------------------------------
      diag_id%qidt_dep = register_diag_field (mod_name, &
             'qidt_dep', axes(1:3), Time, &
             'Ice water specific humidity tendency from LS deposition', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qidt_subl = register_diag_field (mod_name, &
             'qidt_subl', axes(1:3), Time, &
             'Ice water specific humidity tendency from LS sublimation', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qidt_eros = register_diag_field (mod_name, &
             'qidt_eros', axes(1:3), Time, &
             'Ice water specific humidity tendency from erosion',      &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qidt_fall = register_diag_field (mod_name, &
             'qidt_fall', axes(1:3), Time, &
             'Ice water specific humidity tendency from ice settling', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qidt_melt = register_diag_field (mod_name, &
             'qidt_melt', axes(1:3), Time, &
             'Ice water specific humidity tendency from melting to rain',&
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qidt_melt2 = register_diag_field (mod_name, &
             'qidt_melt2', axes(1:3), Time, &
             'Ice water specific humidity tendency from melting to  &
             &cloud droplets', 'kg/kg/sec', missing_value=missing_value)
      diag_id%ice_adj = register_diag_field (mod_name, &
             'ice_adj', axes(1:3), Time, &
             'Ice water specific humidity tendency from the removal &
             &of supersaturation', 'kg/kg/sec',    &
             missing_value=missing_value)
      diag_id%qidt_destr = register_diag_field (mod_name, &
             'qidt_destr', axes(1:3), Time, &
             'Ice water spec hum tendency from cloud destruction',  &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qidt_qvdep = register_diag_field (mod_name, &
             'qidt_qvdep', axes(1:3), Time, &
             'Ice water specific humidity tendency from vapor deposition',&
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qidt_fill = register_diag_field (mod_name, &
             'qidt_fill', axes(1:3), Time, &
             'Ice water specific humidity tendency -- pre-microphysics &
             & filler', 'kg/kg/sec', missing_value=missing_value)
      diag_id%qidt_auto = register_diag_field (mod_name, &
             'qidt_auto', axes(1:3), Time, &
             'Ice water specific humidity tendency from autoconversion &
             &to snow', 'kg/kg/sec', missing_value=missing_value)
      diag_id%qidt_accr = register_diag_field (mod_name, &
             'qidt_accr', axes(1:3), Time, &
             'Ice water spec hum tendency from accretion by snow', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qidt_accrs = register_diag_field (mod_name, &
             'qidt_accrs', axes(1:3), Time, &
             'Ice wat spec hum tend from selfcollection (1 class scheme)',&
             'kg/kg/sec', missing_value=missing_value)

  !-----------------------------------------------------------------------
  !    15) variables associated with cloud area time tendency:
  !-----------------------------------------------------------------------
      diag_id%qadt_lsform = register_diag_field (mod_name, &
             'qadt_lsform', axes(1:3), Time, & 
             'cloud fraction tendency from LS condensation', '1/sec',  &
             missing_value=missing_value)
      diag_id%qadt_lsdiss = register_diag_field (mod_name, &
             'qadt_lsdiss', axes(1:3), Time, &
             'cloud fraction tendency from LS dissipation', '1/sec',  &
             missing_value=missing_value)
      diag_id%qadt_rhred = register_diag_field (mod_name, &
             'qadt_rhred', axes(1:3), Time, &
             'cloud fraction tendency from RH limiter', '1/sec',   &
             missing_value=missing_value)
      diag_id%qadt_eros = register_diag_field (mod_name, &
             'qadt_eros', axes(1:3), Time, &
             'cloud fraction tendency from erosion', '1/sec',   &
             missing_value=missing_value)
      diag_id%qadt_fill = register_diag_field (mod_name, &
             'qadt_fill', axes(1:3), Time, &
             'cloud fraction tendency from filler', '1/sec',   &
             missing_value=missing_value)
      diag_id%qadt_super = register_diag_field (mod_name, &
             'qadt_super', axes(1:3), Time, &
             'cloud fraction tendency from supersaturation formation', &
             '1/sec', missing_value=missing_value)
      diag_id%qadt_destr = register_diag_field (mod_name, &
             'qadt_destr', axes(1:3), Time, &
             'cloud fraction tendency from cloud destruction', '1/sec',  &
             missing_value=missing_value)
      diag_id%qadt_limits = register_diag_field (mod_name, &
             'qadt_limits', axes(1:3), Time, &
             'cloud fraction tendency from imposing limits', '1/sec',  &
             missing_value=missing_value)
      diag_id%qadt_ahuco = register_diag_field (mod_name, &
             'qadt_ahuco', axes(1:3), Time, &
             'cloud fraction tendency from convective area restriction', &
             '1/sec', missing_value=missing_value)

  !------------------------------------------------------------------------
  !   16)  variables added by h1g with ncar M-G microphysics
  !------------------------------------------------------------------------
      diag_id%SA3d =    register_diag_field ( mod_name, &
             'SA3d',  axes(1:3), Time, &
             'Total cloud area tendency', '1/sec',  &
             missing_value=missing_value)
      diag_id%ST3d =    register_diag_field ( mod_name, &
             'ST3d',  axes(1:3), Time, &
             'Total temperature tendency', &
             'K/sec', missing_value=missing_value)
      diag_id%SQ3d =    register_diag_field ( mod_name, &
             'SQ3d',  axes(1:3), Time, &
             'Total Water vapor specific humidity tendency ', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qdt_liquid_init =    register_diag_field ( mod_name, &
             'qdt_liquid_init',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from initial  &
             &adjustment of liquid water', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qdt_ice_init =    register_diag_field ( mod_name, &
             'qdt_ice_init',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from initial &
             &adjustment of ice', &
            'kg/kg/sec', missing_value=missing_value)
      diag_id%qdt_rain_evap =    register_diag_field ( mod_name, &
             'qdt_rain_evap',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from rain  &
             &evaporation', 'kg/kg/sec', missing_value=missing_value)
      diag_id%qdt_snow_sublim  =    register_diag_field ( mod_name, &
             'qdt_snow_sublim',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from snow   &
             &sublimation', 'kg/kg/sec', missing_value=missing_value)
      diag_id%qdt_cond  =    register_diag_field ( mod_name, &
             'qdt_cond',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from LS   &
             &condensation', 'kg/kg/sec', missing_value=missing_value)
      diag_id%qdt_deposition  =    register_diag_field ( mod_name, &
             'qdt_deposition',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from LS deposition', &
             'kg/kg/sec', missing_value=missing_value               )
      diag_id%qdt_eros_l  =    register_diag_field ( mod_name, &
             'qdt_eros_l',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from liquid water &
             & erosion', 'kg/kg/sec', missing_value=missing_value)
      diag_id%qdt_eros_i  =    register_diag_field ( mod_name, &
             'qdt_eros_i',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from ice water &
             &erosion', 'kg/kg/sec', missing_value=missing_value)
      diag_id%qdt_qv_on_qi  =    register_diag_field ( mod_name, &
             'qdt_qv_on_qi',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from direct &
             &deposition on ice', 'kg/kg/sec', missing_value=missing_value)
      diag_id%qdt_snow2vapor  =    register_diag_field ( mod_name, &
             'qdt_snow2vapor',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from condensation  &
             &resulting from cooling of the air by melting snow',      &
             'kg/kg/sec', missing_value=missing_value               )
      diag_id%qdt_sedi_ice2vapor =    register_diag_field ( mod_name, &
             'qdt_sedi_ice2vapor',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from the &
             &sublimation of falling cloud ice', 'kg/kg/sec',  &
             missing_value=missing_value)
      diag_id%qdt_sedi_liquid2vapor =    register_diag_field ( mod_name, &
             'qdt_sedi_liquid2vapor',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from the evaporation &
             &of falling cloud liquid', 'kg/kg/sec', &
             missing_value=missing_value)
      diag_id%qdt_super_sat_rm   =    register_diag_field ( mod_name, &
             'qdt_super_sat_rm',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from removing super &
             &saturation', 'kg/kg/sec', missing_value=missing_value)
      diag_id%qdt_destr  =    register_diag_field ( mod_name, &
             'qdt_destr',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from Cloud &
             &Destruction', 'kg/kg/sec', missing_value=missing_value)
      diag_id%qdt_cleanup_liquid  =    register_diag_field ( mod_name, &
             'qdt_cleanup_liquid',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from cleaning up &
             &liquid cloud', 'kg/kg/sec', missing_value=missing_value)
      diag_id%qdt_cleanup_ice  =    register_diag_field ( mod_name, &
             'qdt_cleanup_ice',  axes(1:3), Time, &
             'Water vapor specific humidity tendency from cleaning up &
             &ice cloud', 'kg/kg/sec', missing_value=missing_value)
      diag_id%SL3d = register_diag_field ( mod_name, &
             'SL3d',  axes(1:3), Time, &
             'Total Liquid Water specific humidity tendency ', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%qldt_HM_splinter = register_diag_field ( mod_name, &
             'qldt_HM_splinter', axes(1:3), Time, &
             'Liquid water specific humidity tendency from H-M &
             &splintering ', 'kg/kg/sec', missing_value=missing_value)
      diag_id%SN3d =    register_diag_field ( mod_name, &
             'SN3d',  axes(1:3), Time, &
             'Total cloud drop number tendency', &
             '#/kg/sec', missing_value=missing_value)
      diag_id%qndt_contact_frz = register_diag_field ( mod_name, &
             'qndt_contact_frz', axes(1:3), Time, &
             'Cloud droplet number tendency from contact freezing of&
             & liquid water', '#/kg/sec', missing_value=missing_value)
      diag_id%qndt_cleanup = register_diag_field ( mod_name, &
             'qndt_cleanup', axes(1:3), Time, &
             'Cloud droplet number tendency from cloud cleanup', &
             '#/kg/sec', missing_value=missing_value)
      diag_id%qndt_cleanup2 = register_diag_field ( mod_name, &
             'qndt_cleanup2', axes(1:3), Time, &
             'Cloud droplet number tendency from cloud cleanup2', &
             '#/kg/sec', missing_value=missing_value)
      diag_id%SNI3d = register_diag_field ( mod_name, &
             'SNI3d',  axes(1:3), Time, &
             'Total ice crystal number tendency', &
             '#/kg/sec', missing_value=missing_value)
      diag_id%qnidt_nsacwi = register_diag_field ( mod_name, &
             'qnidt_nsacwi', axes(1:3), Time, &
             'Cloud ice tendency from HM ice multiplication', &
             '#/kg/sec', missing_value=missing_value)
      diag_id%srfrain_evap =  register_diag_field ( mod_name, &
             'srfrain_evap', axes(1:3), Time, &
             'rain water sink from evaporation', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%srfrain_accrs=  register_diag_field ( mod_name, &
             'srfrain_accrs', axes(1:3), Time, &
             'rain water sink from collection by snow', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%srfrain_freez=  register_diag_field ( mod_name, &
             'srfrain_freez', axes(1:3), Time, &
             'rain water sink from freezing', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%SI3d =    register_diag_field ( mod_name, &
             'SI3d',  axes(1:3), Time, &
             'Total Ice water specific humidity tendency ', &
             'kg/kg/sec', missing_value=missing_value)

  !------------------------------------------------------------------------
  !   17)  variables associated with budget analysis
  !------------------------------------------------------------------------
      diag_id%SA_imb =    register_diag_field ( mod_name, &
             'SA_imb',  axes(1:3), Time, &
             'difference between qa tendency and sum of individ terms', &
             '1/sec', missing_value=missing_value)
      diag_id%ST_imb =    register_diag_field ( mod_name, &
             'ST_imb',  axes(1:3), Time, &
             'difference between temp tendency and sum of individ terms', &
             'K/sec', missing_value=missing_value)
      diag_id%SQ_imb =    register_diag_field ( mod_name, &
             'SQ_imb',  axes(1:3), Time, &
             'difference between qv tendency and sum of individ terms', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%SL_imb =    register_diag_field ( mod_name, &
             'SL_imb',  axes(1:3), Time, &
             'difference between ql tendency and sum of individ terms', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%SI_imb =    register_diag_field ( mod_name, &
             'SI_imb',  axes(1:3), Time, &
             'difference between qi tendency and sum of individ terms', &
             'kg/kg/sec', missing_value=missing_value)
      diag_id%SN_imb =    register_diag_field ( mod_name, &
             'SN_imb',  axes(1:3), Time, &
             'difference between qn tendency and sum of individ terms', &
             '#/kg/sec', missing_value=missing_value)
      diag_id%SNi_imb =    register_diag_field ( mod_name, &
             'SNi_imb',  axes(1:3), Time, &
             'difference between qni tendency and sum of individ terms', &
             '#/kg/sec', missing_value=missing_value)
      diag_id%rain_imb =    register_diag_field ( mod_name, &
             'rain_imb',  axes(1:3), Time, &
             'difference between rain rate at sfc and sum of &
             &individ terms', 'kg/kg/sec', missing_value=missing_value)
      diag_id%cld_liq_imb =    register_diag_field ( mod_name, &
             'cld_liq_imb',  axes(1:3), Time, &
             'difference between ql fallout rate at sfc and sum of &
             &individ terms', 'kg/kg/sec', missing_value=missing_value)
      diag_id%snow_imb =    register_diag_field ( mod_name, &
             'snow_imb',  axes(1:3), Time, &
             'difference between snow rate at sfc and sum of &
             &individ terms', 'kg/kg/sec', missing_value=missing_value)
      diag_id%cld_ice_imb =    register_diag_field ( mod_name, &
             'cld_ice_imb',  axes(1:3), Time, &
             'difference between qi fallout rate at sfc and sum of &
             &individ terms', 'kg/kg/sec', missing_value=missing_value)

  !-----------------------------------------------------------------------
  !
  !                    COLUMN-INTEGRATED DIAGNOSTICS
  !
  !-----------------------------------------------------------------------

  !------------------------------------------------------------------------
  !    1) variables associated with droplet number and size:
  !------------------------------------------------------------------------
      diag_id%droplets_col = register_diag_field (mod_name,   &
             'droplets_col', axes(1:2), Time,   &
             'Droplet number in cloud column burden', '/cm2',   &
             missing_value=missing_value)
      diag_id%gb_droplets_col = register_diag_field (mod_name,   &
             'gb_droplets_col', axes(1:2), Time,   &
             'Droplet number grid box column burden', '/cm2',   &
             missing_value=missing_value)
      diag_id%droplets_col250 = register_diag_field (mod_name,   &
             'droplets_col250', axes(1:2), Time,   &
             'Droplet number in cloud column burden for T> 250K', '/cm2', &
             missing_value=missing_value)

  !------------------------------------------------------------------------
  !    3) variables associated with cloud and precipitation processes:
  !------------------------------------------------------------------------
      diag_id%sedi_ice = register_diag_field (mod_name, &
             'sedi_ice', axes(1:2), Time, &
             'ice sedimentation flux to surface', 'm/sec',   &
             missing_value=missing_value)
      diag_id%snow_melt_col = register_diag_field (mod_name, &
             'snow_melt_col', axes(1:2), Time, &
             'Column integrated snow melting', 'kg/m2/sec', &
             missing_value=missing_value)
      diag_id%rain_freeze_col = register_diag_field (mod_name, &
             'rain_freeze_col', axes(1:2), Time, &
             'Column integrated loss of rain from freezing', 'kg/m2/sec', &
             missing_value=missing_value)

  !------------------------------------------------------------------------
  !    5) variables associated with ice particle number:
  !------------------------------------------------------------------------
      diag_id%nice_col = register_diag_field (mod_name,   &
             'nice_col', axes(1:2), Time,   &
             'ice number in cloud column burden', '/cm2',  &
             missing_value=missing_value)
      diag_id%gb_nice_col = register_diag_field (mod_name,   &
             'gb_nice_col', axes(1:2), Time,   &
             'ice number grid box column burden', '/cm2',   &
             missing_value=missing_value)

!------------------------------------------------------------------------
!    6) variables associated with precipitation and precipitation area:
!------------------------------------------------------------------------
      diag_id%qrout_col = register_diag_field (mod_name,   &
             'rain_path', axes(1:2), Time,   &
             'rain water path from stratiform', 'kg/m2',    &
             missing_value=missing_value)
      diag_id%qsout_col = register_diag_field (mod_name,    &
             'snow_path', axes(1:2), Time,    &
             'snow water path from stratiform', 'kg/m2',  &
             missing_value=missing_value)

  !-----------------------------------------------------------------------
  !    8) variables associated with cloud liquid time tendency:
  !-----------------------------------------------------------------------
      diag_id%ql_cond_col = register_diag_field (mod_name, &
             'ql_cond_col', axes(1:2), Time, &
             'Column integrated condensation', 'kg/m2/sec',  &
             missing_value=missing_value)
      diag_id%ql_evap_col = register_diag_field (mod_name, &
             'ql_evap_col', axes(1:2), Time, &
             'Column integrated evaporation', 'kg/m2/sec', &
             missing_value=missing_value)
      diag_id%ql_eros_col = register_diag_field (mod_name, &
             'ql_eros_col', axes(1:2), Time, &
             'Column integrated liquid erosion', 'kg/m2/sec',   &
             missing_value=missing_value)
      diag_id%ql_accr_col = register_diag_field (mod_name, &
             'ql_accr_col', axes(1:2), Time, &
             'Column integrated accretion of cloud water by rain',  &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%ql_auto_col = register_diag_field (mod_name, &
             'ql_auto_col', axes(1:2), Time, &
             'Column integrated autoconversion of cloud water to rain', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%ql_berg_col = register_diag_field (mod_name, &
             'ql_berg_col', axes(1:2), Time, &
             'Column integrated Bergeron process', 'kg/m2/sec',   &
             missing_value=missing_value)
      diag_id%ql_freez_col = register_diag_field (mod_name, &
             'ql_freez_col', axes(1:2), Time, &
             'Column integrated homogeneous freezing', 'kg/m2/sec',  &
             missing_value=missing_value)
      diag_id%ql_destr_col = register_diag_field (mod_name, &
             'ql_destr_col', axes(1:2), Time, &
             'Column integrated liquid destruction', 'kg/m2/sec',   &
             missing_value=missing_value)
      diag_id%ql_rime_col = register_diag_field (mod_name, &
             'ql_rime_col', axes(1:2), Time, &
             'Column integrated riming', 'kg/m2/sec',   &
             missing_value=missing_value)
      diag_id%ql_fill_col = register_diag_field (mod_name, &
             'ql_fill_col', axes(1:2), Time, &
             'Column integrated pre-microphysics liquid filler',  &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%liq_adj_col = register_diag_field (mod_name, &
             'liq_adj_col', axes(1:2), Time, &
             'Column integrated liquid water specific humidity  &
             &tendency from supersaturation removal', 'kg/m2/sec',   &
             missing_value=missing_value)
      diag_id%ql_freez2_col = register_diag_field (mod_name, &
             'ql_freez2_col', axes(1:2), Time, &
             'Column integrated heterogeneous freezing', 'kg/m2/sec',   &
             missing_value=missing_value)
      diag_id%ql_sedi_col = register_diag_field (mod_name, &
             'ql_sedi_col', axes(1:2), Time, &
             'Column integrated sedimentation ', 'kg/m2/sec',   &
             missing_value=missing_value)
      diag_id%ql_accrs_col = register_diag_field (mod_name, &
             'ql_accrs_col', axes(1:2), Time, &
             'Column integrated cloud liquid collection by snow', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%ql_bergs_col = register_diag_field (mod_name, &
             'ql_bergs_col', axes(1:2), Time, &
             'Column integrated bergeron process for snow ', 'kg/m2/sec', &
             missing_value=missing_value)

  !-----------------------------------------------------------------------
  !    9) variables associated with cloud droplet number time tendency:
  !-----------------------------------------------------------------------
      diag_id%qn_cond_col = register_diag_field (mod_name, &
             'qn_cond_col', axes(1:2), Time, &
             'Column integrated drop number condensation', '#/m2/sec', &
             missing_value=missing_value)
      diag_id%qn_evap_col = register_diag_field (mod_name, &
             'qn_evap_col', axes(1:2), Time, &
             'Column integrated drop number evaporation', '#/m2/sec',   &
             missing_value=missing_value)
      diag_id%qn_berg_col = register_diag_field (mod_name, &
             'qn_berg_col', axes(1:2), Time, &
             'Column integrated drop number bergeron tendency',   &
             '#/m2/sec', missing_value=missing_value)
      diag_id%qn_fill_col = register_diag_field (mod_name, &
             'qn_fill_col', axes(1:2), Time, &
             'Column integrated drop number filler', '#/m2/sec',   &
             missing_value=missing_value)
      diag_id%qn_destr_col = register_diag_field (mod_name, &
             'qn_destr_col', axes(1:2), Time, &
             'Column integrated drop number destruction', '#/m2/sec', &
             missing_value=missing_value)
      diag_id%qn_super_col = register_diag_field (mod_name, &
             'qn_super_col', axes(1:2), Time, &
             'Column integrated drop number tendency from &
             &supersaturation removal', '#/m2/sec',&
             missing_value=missing_value)
      diag_id%qn_freez_col = register_diag_field (mod_name, &
             'qn_freez_col', axes(1:2), Time, &
             'Column integrated drop number tendency from &
             &heterogeneous freezing', '#/m2/sec',&
             missing_value=missing_value)
      diag_id%qn_sacws_col = register_diag_field (mod_name, &
             'qn_sacws_col', axes(1:2), Time, &
             'Column integrated drop number tendency from droplet &
             &collection by snow', '#/m2/sec',&
             missing_value=missing_value)
      diag_id%qn_sacws_o_col = register_diag_field (mod_name, &
             'qn_sacws_o_col', axes(1:2), Time, &
             'Column integrated drop number tendency from droplet &
             &collection by snow (one ice cat)', '#/m2/sec',&
             missing_value=missing_value)
      diag_id%qn_eros_col = register_diag_field (mod_name, &
             'qn_eros_col', axes(1:2), Time, &
             'Column integrated drop number tendency from cloud erosion', &
             '#/m2/sec', missing_value=missing_value)
      diag_id%qn_pra_col = register_diag_field (mod_name, &
             'qn_pra_col', axes(1:2), Time, &
             'Column integrated drop number tendency from collection &
             &by rain', '#/m2/sec', missing_value=missing_value)
      diag_id%qn_auto_col = register_diag_field (mod_name, &
             'qn_auto_col', axes(1:2), Time, &
             'Column integrated drop number tendency from autoconversion &
             &to rain', '#/m2/sec', missing_value=missing_value)
      diag_id%qn_nucclim_col = register_diag_field (mod_name, &
             'qn_nucclim_col', axes(1:2), Time, &
             'Column integrated drop number tendency from nucleation &
             &limiter', '#/m2/sec', missing_value=missing_value)
      diag_id%qn_sedi_col = register_diag_field (mod_name, &
             'qn_sedi_col', axes(1:2), Time, &
             'Column integrated drop number tendency from sedimentation &
             &of droplets', '#/m2/sec', missing_value=missing_value)
      diag_id%qn_melt_col = register_diag_field (mod_name, &
             'qn_melt_col', axes(1:2), Time, &
             'Column integrated drop number tendency from melting of ice',&
             '#/m2/sec', missing_value=missing_value)
      diag_id%qn_ihom_col = register_diag_field (mod_name, &
             'qn_ihom_col', axes(1:2), Time, &
             'Column integrated drop number tendency from homogeneous &
             &freezing of droplets', '#/m2/sec',&
             missing_value=missing_value)
      diag_id%qn_size_adj_col = register_diag_field (mod_name, &
             'qn_size_adj_col', axes(1:2), Time, &
             'Column integrated drop number tendency from droplet &
             &size adjustment', '#/m2/sec',&
             missing_value=missing_value)
      diag_id%qn_fill2_col = register_diag_field (mod_name, &
             'qn_fill2_col', axes(1:2), Time, &
             'Column integrated drop number tendency from second filler', &
             '#/m2/sec', missing_value=missing_value)
      diag_id%qn_contact_frz_col = register_diag_field (mod_name, &
             'qn_contact_frz_col', axes(1:2), Time, &
             'Column integrated drop number tendency from contact &
             &freezing', '#/m2/sec', missing_value=missing_value)
      diag_id%qn_cleanup_col = register_diag_field (mod_name, &
             'qn_cleanup_col', axes(1:2), Time, &
             'Column integrated drop number tendency from cleanup', &
             '#/m2/sec', missing_value=missing_value)
      diag_id%qn_cleanup2_col = register_diag_field (mod_name, &
             'qn_cleanup2_col', axes(1:2), Time, &
             'Column integrated drop number tendency from second cleanup',&
             '#/m2/sec', missing_value=missing_value)

!-----------------------------------------------------------------------
!    13) variables associated with water vapor tendency:
!-----------------------------------------------------------------------
      diag_id%rain_evap_col = register_diag_field (mod_name, &
             'rain_evap_col', axes(1:2), Time, &
             'Column integrated rain evaporation', 'kg/m2/sec',   &
             missing_value=missing_value)

!-----------------------------------------------------------------------
!    14) variables associated with cloud ice time tendency:
!-----------------------------------------------------------------------
      diag_id%qi_fall_col = register_diag_field (mod_name, &
             'qi_fall_col', axes(1:2), Time, &
             'Column integrated ice settling', 'kg/m2/sec',   &
             missing_value=missing_value)
      diag_id%qi_fill_col = register_diag_field (mod_name, &
             'qi_fill_col', axes(1:2), Time, &
             'Column integrated pre-microphysics ice filler', 'kg/m2/sec',&
             missing_value=missing_value)
      diag_id%qi_dep_col = register_diag_field (mod_name, &
             'qi_dep_col', axes(1:2), Time, &
             'Column integrated large-scale deposition', 'kg/m2/sec',   &
             missing_value=missing_value)
      diag_id%qi_subl_col = register_diag_field (mod_name, &
             'qi_subl_col', axes(1:2), Time, &
             'Column integrated large-scale sublimation', 'kg/m2/sec', &
             missing_value=missing_value)
      diag_id%qi_eros_col = register_diag_field (mod_name, &
             'qi_eros_col', axes(1:2), Time, &
             'Column integrated ice erosion', 'kg/m2/sec',    &
             missing_value=missing_value)
      diag_id%qi_destr_col = register_diag_field (mod_name, &
             'qi_destr_col', axes(1:2), Time, &
             'Column integrated ice destruction', 'kg/m2/sec',   &
             missing_value=missing_value)
      diag_id%qi_qvdep_col = register_diag_field (mod_name, &
             'qi_qvdep_col', axes(1:2), Time, &
             'Column integrated vapor deposition', 'kg/m2/sec',   &
             missing_value=missing_value)
      diag_id%qi_melt_col = register_diag_field (mod_name, &
             'qi_melt_col', axes(1:2), Time, &
             'Column integrated ice melting to rain', 'kg/m2/sec', &
             missing_value=missing_value)
      diag_id%qi_melt2_col = register_diag_field (mod_name, &
             'qi_melt2_col', axes(1:2), Time, &
             'Column integrated ice melting to cloud droplets',  &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%ice_adj_col = register_diag_field (mod_name, &
             'ice_adj_col', axes(1:2), Time, &
             'Column integrated ice water specific humidity tendency &
             &from the removal of supersaturation', 'kg/m2/sec',   &
             missing_value=missing_value)
      diag_id%qi_auto_col = register_diag_field (mod_name, &
             'qi_auto_col', axes(1:2), Time, &
             'Column integrated autoconversion from cloud ice to snow ', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%qi_accr_col = register_diag_field (mod_name, &
             'qi_accr_col', axes(1:2), Time, &
             'Column integrated accretion of cloud ice by snow ', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%qi_accrs_col = register_diag_field (mod_name, &
             'qi_accrs_col', axes(1:2), Time, &
             'Column integrated self collection (one class scheme)',   &
             'kg/m2/sec', missing_value=missing_value)

!-----------------------------------------------------------------------
!    15) variables associated with cloud area time tendency:
!-----------------------------------------------------------------------
      diag_id%qa_lsform_col = register_diag_field (mod_name, &
             'qa_lsform_col', axes(1:2), Time, &
             'Column integrated cloud fraction tendency from &
             &condensation', 'kg/m2/sec', missing_value=missing_value)
      diag_id%qa_lsdiss_col = register_diag_field (mod_name, &
             'qa_lsdiss_col', axes(1:2), Time, &
             'Column integrated cloud fraction tendency from dissipation',&
             'kg/m2/sec', missing_value=missing_value)
      diag_id%qa_rhred_col = register_diag_field (mod_name, &
             'qa_rhred_col', axes(1:2), Time, & 
             'Column integrated cloud fraction tendency from RH limiter', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%qa_eros_col = register_diag_field (mod_name, &
             'qa_eros_col', axes(1:2), Time, &
             'Column integrated cloud fraction tendency from erosion', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%qa_fill_col = register_diag_field (mod_name, &
             'qa_fill_col', axes(1:2), Time, &
             'Column integrated cloud fraction tendency from filler', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%qa_super_col = register_diag_field (mod_name, &
             'qa_super_col', axes(1:2), Time, &
             'Column integrated cloud fraction tendency from &
             &supersaturation removal', 'kg/m2/sec',    &
             missing_value=missing_value)
      diag_id%qa_destr_col = register_diag_field (mod_name, &
             'qa_destr_col', axes(1:2), Time, &
             'Column integrated cloud fraction tendency from destruction',&
             'kg/m2/sec', missing_value=missing_value)
      diag_id%qa_limits_col = register_diag_field (mod_name, &
             'qa_limits_col', axes(1:2), Time, &
             'Column integrated cloud fraction tendency from limits &
             &imposition', 'kg/m2/sec', missing_value=missing_value)
      diag_id%qa_ahuco_col = register_diag_field (mod_name, &
             'qa_ahuco_col', axes(1:2), Time, &
             'Column integrated cloud fraction tendency from conv &
             &area restriction', 'kg/m2/sec', &
             missing_value=missing_value)

!------------------------------------------------------------------------
!    16) variables added by h1g with ncar M-G microphysics
!------------------------------------------------------------------------
      diag_id%SA2d =    register_diag_field ( mod_name, &
             'SA2d',  axes(1:2), Time, &
             'column integrated total cld fraction tendency', &
             ' kg/ (m2 sec)', missing_value=missing_value)
      diag_id%ST2d =    register_diag_field ( mod_name, &
             'ST2d',  axes(1:2), Time, &
             'column integrated total temperature tendency', &
             'K kg/ (m2 sec)', missing_value=missing_value)
      diag_id%SQ2d =    register_diag_field ( mod_name, &
             'SQ2d',  axes(1:2), Time, &
             'Column integrated total Water vapor specific &
             &humidity tendency ', 'kg/m2/sec', &
             missing_value=missing_value)
      diag_id%SL2d = register_diag_field ( mod_name, &
             'SL2d',  axes(1:2), Time, &
             'Column integrated total Liquid Water specific humidity', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%SI2d =    register_diag_field ( mod_name, &
             'SI2d',  axes(1:2), Time, &
             'column integrated total Ice water specific humidity &
             &tendency ', 'kg/m2/sec', missing_value=missing_value)
      diag_id%SN2d =    register_diag_field ( mod_name, &
             'SN2d',  axes(1:2), Time, &
             'Column integrated total cloud drop number tendency', &
             '#/m2/sec', missing_value=missing_value)
      diag_id%SNI2d = register_diag_field ( mod_name, &
             'SNI2d',  axes(1:2), Time, &
             'Column integrated total ice crystal number tendency', &
             '#/m2/sec', missing_value=missing_value)
      diag_id%srfrain_accrs_col=  register_diag_field ( mod_name, &
             'srfrain_accrs_col', axes(1:2), Time, &
             'Column integrated rain water sink from collection by snow', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%srfrain_freez_col=  register_diag_field ( mod_name, &
             'srfrain_freez_col', axes(1:2), Time, &
             'Column integrated rain water sink from freezing', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%srfrain_evap_col=  register_diag_field ( mod_name, &
             'srfrain_evap_col', axes(1:2), Time, &
             'Column integrated rain water sink from evaporation', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%snow_mass_conv = register_diag_field ( mod_name, &
             'snow_mass_conv', axes(1:2), Time, &
             'Change necessary to surface snowfall to ensure h2o &
             & balance in column', 'kg/m2/sec',   &
             missing_value=missing_value)
      diag_id%neg_snow = register_diag_field ( mod_name, &
             'neg_snow', axes(1:2), Time, &
             'magnitude of negative snow removed in column', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%rain_mass_conv = register_diag_field ( mod_name, &
             'rain_mass_conv', axes(1:2), Time, &
             'Change necessary to surface rainfall to ensure h2o&
             & balance in column', 'kg/m2/sec',  &
             missing_value=missing_value)
      diag_id%neg_rain = register_diag_field ( mod_name, &
             'neg_rain', axes(1:2), Time, &
             'magnitude of negative rain removed in column', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_liquid_init_col  =    register_diag_field ( mod_name, &
             'q_liquid_init_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from initial adjustment of liquid cloud', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_ice_init_col  =    register_diag_field ( mod_name, &
             'q_ice_init_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from initial adjustment of ice cloud', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_rain_evap_col  =    register_diag_field ( mod_name, &
             'q_rain_evap_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from rain evaporation', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_cond_col  =    register_diag_field ( mod_name, &
             'q_cond_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from condensation of vapor', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_deposition_col  =    register_diag_field ( mod_name, &
             'q_deposition_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from deposition of vapor onto ice',   &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_eros_l_col  =    register_diag_field ( mod_name, &
             'q_eros_l_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from erosion of liquid cloud', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_eros_i_col  =    register_diag_field ( mod_name, &
             'q_eros_i_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from erosion of ice cloud', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_qv_on_qi_col  =    register_diag_field ( mod_name, &
             'q_qv_on_qi_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from direct deposition on ice', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_sedi_ice2vapor_col  =    register_diag_field ( mod_name, &
             'q_sedi_ice2vapor_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from the sublimation of falling cloud ice', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_sedi_liquid2vapor_col  =  register_diag_field ( mod_name, &
             'q_sedi_liquid2vapor_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from the evaporation of falling cloud liquid', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_super_sat_rm_col  =    register_diag_field ( mod_name, &
             'q_super_sat_rm_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from removal of supersaturation', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_destr_col  =    register_diag_field ( mod_name, &
             'q_destr_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from cloud destruction', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_cleanup_liquid_col  =    register_diag_field ( mod_name, &
             'q_cleanup_liquid_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from cleaning up liquid cloud', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_cleanup_ice_col  =    register_diag_field ( mod_name, &
             'q_cleanup_ice_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from cleaning up ice cloud', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_snow_sublim_col  =    register_diag_field ( mod_name, &
             'q_snow_sublim_col',  axes(1:2), Time, &
             'Column integrated Water vapor specific humidity tendency &
             &from sublimation of snow', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%q_snow2vapor_col  =    register_diag_field ( mod_name, &
             'q_snow2vapor_col',  axes(1:2), Time, &
             'Column integrated water vapor specific humidity tendency &
             &from condensation resulting from cooling of the air &
             &by melting snow', 'kg/m2/sec', missing_value=missing_value)
      diag_id%ql_HM_splinter_col = register_diag_field ( mod_name, &
             'ql_HM_splinter_col', axes(1:2), Time, &
             'Column integrated liquid water specific humidity tendency &
             &from H-M splintering ',  'kg/m2/sec', &
             missing_value=missing_value)

!------------------------------------------------------------------------
!   17)  variables associated with budget analysis
!------------------------------------------------------------------------
      diag_id%SA_imb_col =    register_diag_field ( mod_name, &
             'SA_imb_col',  axes(1:2), Time, &
             'difference between  column-integrated qa tendency and &
             &sum of individ terms', 'kg/ (m2 sec)', &
             missing_value=missing_value)
      diag_id%ST_imb_col =    register_diag_field ( mod_name, &
             'ST_imb_col',  axes(1:2), Time, &
             'difference between column-integrated temp tendency and &
             &sum of individ terms', 'K kg/(m2 sec)', &
             missing_value=missing_value)
      diag_id%SQ_imb_col =    register_diag_field ( mod_name, &
             'SQ_imb_col',  axes(1:2), Time, &
             'difference between column-integrated qv tendency and &
             &sum of individ terms', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%SL_imb_col =    register_diag_field ( mod_name, &
             'SL_imb_col',  axes(1:2), Time, &
             'difference between column-integrated ql tendency and &
             &sum of individ terms', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%SI_imb_col =    register_diag_field ( mod_name, &
             'SI_imb_col',  axes(1:2), Time, &
             'difference between column-integrated qi tendency and &
             &sum of individ terms', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%SN_imb_col =    register_diag_field ( mod_name, &
             'SN_imb_col',  axes(1:2), Time, &
             'difference between column-integrated qn tendency and &
             &sum of individ terms', &
             '#/m2/sec', missing_value=missing_value)
      diag_id%SNi_imb_col =    register_diag_field ( mod_name, &
             'SNi_imb_col',  axes(1:2), Time, &
             'difference between column-integrated qni tendency and &
             &sum of individ terms', &
             '#/m2/sec', missing_value=missing_value)
      diag_id%rain_imb_col =    register_diag_field ( mod_name, &
             'rain_imb_col',  axes(1:2), Time, &
             'difference between column-integrated rainfall rate and &
             &sum of individ terms', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%cld_liq_imb_col =    register_diag_field ( mod_name, &
             'cld_liq_imb_col',  axes(1:2), Time, &
             'difference between column-integrated ql fallout rate and &
             &sum of individ terms', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%snow_imb_col =    register_diag_field ( mod_name, &
             'snow_imb_col',  axes(1:2), Time, &
             'difference between column-integrated snowfall rate and &
             &sum of individ terms', &
             'kg/m2/sec', missing_value=missing_value)
      diag_id%cld_ice_imb_col =    register_diag_field ( mod_name, &
             'cld_ice_imb_col',  axes(1:2), Time, &
             'difference between column-integrated qi fallout rate and &
             &sum of individ terms', &
             'kg/m2/sec', missing_value=missing_value)

!-----------------------------------------------------------------------
!    17) variables associated with ice particle number time tendency:
!-----------------------------------------------------------------------
      diag_id%qni_fill_col = register_diag_field (mod_name, &
             'qni_fill_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from filler',&
             '#/m2/sec', missing_value=missing_value)  
      diag_id%qni_nnuccd_col = register_diag_field (mod_name, &
             'qni_nnuccd_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from &
             &nucleation', '#/m2/sec', missing_value=missing_value)  
      diag_id%qni_nsubi_col = register_diag_field (mod_name, &
             'qni_nsubi_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from &
             &sublimation', '#/m2/sec', missing_value=missing_value)  
      diag_id%qni_nerosi_col = register_diag_field (mod_name, &
             'qni_nerosi_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from &
             &erosion', '#/m2/sec', missing_value=missing_value) 
      diag_id%qni_nprci_col = register_diag_field (mod_name, &
             'qni_nprci_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from &
             &autoconversion', '#/m2/sec', missing_value=missing_value) 
      diag_id%qni_nprai_col = register_diag_field (mod_name, &
             'qni_nprai_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from &
             &accretion by snow', '#/m2/sec', missing_value=missing_value) 
      diag_id%qni_nucclim1_col = register_diag_field (mod_name, &
             'qni_nucclim1_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from first &
             &nucleation limiter', '#/m2/sec', missing_value=missing_value)
      diag_id%qni_nucclim2_col = register_diag_field (mod_name, &
             'qni_nucclim2_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from second &
             &nucleation limiter','#/m2/sec', missing_value=missing_value) 
      diag_id%qni_sedi_col = register_diag_field (mod_name, &
             'qni_sedi_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from &
             &sedimentation', '#/m2/sec', missing_value=missing_value) 
      diag_id%qni_melt_col = register_diag_field (mod_name, &
             'qni_melt_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from &
             &melting', '#/m2/sec', missing_value=missing_value) 
      diag_id%qni_size_adj_col = register_diag_field (mod_name, &
             'qni_size_adj_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from size &
             &adjustment', '#/m2/sec', missing_value=missing_value) 
      diag_id%qni_fill2_col = register_diag_field (mod_name, &
             'qni_fill2_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from second &
             &filler', '#/m2/sec', missing_value=missing_value)  
      diag_id%qni_super_col = register_diag_field (mod_name, &
             'qni_super_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from &
             &removal of supersaturation', '#/m2/sec',   &
             missing_value=missing_value)  
      diag_id%qni_ihom_col = register_diag_field (mod_name, &
             'qni_ihom_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from &
             &homogeneous freezing', '#/m2/sec', &
             missing_value=missing_value)  
      diag_id%qni_destr_col = register_diag_field (mod_name, &
             'qni_destr_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from cloud &
             &destruction', '#/m2/sec', missing_value=missing_value)  
      diag_id%qni_cleanup_col = register_diag_field (mod_name, &
             'qni_cleanup_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from &
             &cleanup', '#/m2/sec', missing_value=missing_value)  
      diag_id%qni_cleanup2_col = register_diag_field (mod_name, &
             'qni_cleanup2_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from &
             &cleanup2', '#/m2/sec', missing_value=missing_value)  
      diag_id%qni_nsacwi_col = register_diag_field (mod_name, &
             'qni_nsacwi_col', axes(1:2), Time, &
             'Column integrated ice particle number tendency from HM &
             &ice multiplication', '#/m2/sec', missing_value=missing_value)

!------------------------------------------------------------------------
!    determine the number of activated diagnostic variables on both
!    full and half levels in the vertical. thesde values will be used
!    to allocate arrays containing the activated diagnostics.
!------------------------------------------------------------------------
      n_diag_4d = 1
      n_diag_4d_kp1 = 1

!------------------------------------------------------------------------
!    1) variables associated with droplet number and size:
!------------------------------------------------------------------------
      if (diag_id%droplets  > 0) then
        diag_pt%droplets = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%droplets_wtd  > 0) then
        diag_pt%droplets_wtd = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%rvolume  > 0 ) then
        diag_pt%rvolume = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%droplets_col  > 0) then
        diag_pt%droplets_col = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%droplets_col250  > 0) then
        diag_pt%droplets_col250 = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%gb_droplets_col  > 0) then
        diag_pt%gb_droplets_col = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!------------------------------------------------------------------------
!    2) variables associated with cloud liquid content:
!------------------------------------------------------------------------
      if (diag_id%ql_wt  > 0) then
        diag_pt%ql_wt = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!------------------------------------------------------------------------
!    3) variables associated with cloud and precipitation processes:
!------------------------------------------------------------------------
      if (diag_id%lsf_strat > 0) then
        diag_pt%lsf_strat = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%dcond  > 0 ) then
        diag_pt%dcond = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%aauto  > 0) then
        diag_pt%aauto = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%vfall  > 0) then
        diag_pt%vfall = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%delta_cf  > 0 ) then
        diag_pt%delta_cf = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%cf_liq_init    > 0 ) then
        diag_pt%cf_liq_init   = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%subgrid_w_variance  > 0 ) then
        diag_pt%subgrid_w_variance = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%potential_droplets  > 0 ) then
        diag_pt%potential_droplets = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%potential_crystals  > 0 ) then
        diag_pt%potential_crystals = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%dust_berg_flag  > 0 ) then
        diag_pt%dust_berg_flag = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%cf_ice_init    > 0 ) then
        diag_pt%cf_ice_init = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%snow_melt  + diag_id%snow_melt_col > 0) then
        diag_pt%snow_melt = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%rain_freeze  + diag_id%rain_freeze_col > 0) then
        diag_pt%rain_freeze = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!------------------------------------------------------------------------
!    4) variables associated with model convection:
!------------------------------------------------------------------------
      if (diag_id%lcf_strat > 0) then
        diag_pt%lcf_strat = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%mfls_strat  > 0) then
        diag_pt%mfls_strat = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!------------------------------------------------------------------------
!    5) variables associated with ice particle number:
!------------------------------------------------------------------------
      if (diag_id%nice  > 0) then
        diag_pt%nice = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%nice_col  > 0) then
        diag_pt%nice_col = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%gb_nice_col  > 0) then
        diag_pt%gb_nice_col = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!------------------------------------------------------------------------
!    6) variables associated with precipitation and precipitation area:
!------------------------------------------------------------------------
      if (diag_id%qrout  + diag_id%qrout_col > 0) then
        diag_pt%qrout = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qsout  + diag_id%qsout_col > 0) then
        diag_pt%qsout = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%rain3d  > 0) then
        diag_pt%rain3d = n_diag_4d_kp1
        n_diag_4d_kp1 = n_diag_4d_kp1 + 1 
      end if
      if (diag_id%snow3d  > 0) then
        diag_pt%snow3d = n_diag_4d_kp1
        n_diag_4d_kp1 = n_diag_4d_kp1 + 1 
      end if
      if (diag_id%rain_clr  > 0) then
        diag_pt%rain_clr = n_diag_4d_kp1
        n_diag_4d_kp1 = n_diag_4d_kp1 + 1 
      end if
      if (diag_id%rain_cld  > 0) then
        diag_pt%rain_cld = n_diag_4d_kp1
        n_diag_4d_kp1 = n_diag_4d_kp1 + 1 
      end if
      if (diag_id%a_rain_clr  > 0) then
        diag_pt%a_rain_clr = n_diag_4d_kp1
        n_diag_4d_kp1 = n_diag_4d_kp1 + 1 
      end if
      if (diag_id%a_rain_cld  > 0) then
        diag_pt%a_rain_cld = n_diag_4d_kp1
        n_diag_4d_kp1 = n_diag_4d_kp1 + 1 
      end if
      if (diag_id%a_precip_clr  > 0) then
        diag_pt%a_precip_clr = n_diag_4d_kp1
        n_diag_4d_kp1 = n_diag_4d_kp1 + 1 
      end if
      if (diag_id%a_precip_cld  > 0) then
        diag_pt%a_precip_cld = n_diag_4d_kp1
        n_diag_4d_kp1 = n_diag_4d_kp1 + 1 
      end if
      if (diag_id%snow_clr  > 0) then
        diag_pt%snow_clr = n_diag_4d_kp1
        n_diag_4d_kp1 = n_diag_4d_kp1 + 1 
      end if
      if (diag_id%snow_cld  > 0) then
        diag_pt%snow_cld = n_diag_4d_kp1
        n_diag_4d_kp1 = n_diag_4d_kp1 + 1 
      end if
      if (diag_id%a_snow_clr  > 0) then
        diag_pt%a_snow_clr = n_diag_4d_kp1
        n_diag_4d_kp1 = n_diag_4d_kp1 + 1 
      end if
      if (diag_id%a_snow_cld  > 0) then
        diag_pt%a_snow_cld = n_diag_4d_kp1
        n_diag_4d_kp1 = n_diag_4d_kp1 + 1 
      end if

!------------------------------------------------------------------------
!    7) variables associated with cloud fraction:
!------------------------------------------------------------------------
      if (diag_id%aall  > 0) then
        diag_pt%aall = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%aliq  > 0) then
        diag_pt%aliq = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%aice  > 0) then
        diag_pt%aice = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%cfin > 0 ) then
        diag_pt%cfin = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!-----------------------------------------------------------------------
!    8) variables associated with cloud liquid time tendency:
!-----------------------------------------------------------------------
      if (diag_id%qldt_cond  + diag_id%ql_cond_col > 0) then
        diag_pt%qldt_cond = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qldt_evap  + diag_id%ql_evap_col > 0) then
        diag_pt%qldt_evap = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qldt_eros  + diag_id%ql_eros_col > 0) then
        diag_pt%qldt_eros = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qldt_accr  + diag_id%ql_accr_col > 0) then
        diag_pt%qldt_accr = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qldt_auto  + diag_id%ql_auto_col > 0) then
        diag_pt%qldt_auto = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%liq_adj  + diag_id%liq_adj_col  +   &
          diag_id%ice_adj + diag_id%ice_adj_col  > 0) then
        diag_pt%liq_adj = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
        diag_pt%ice_adj = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qldt_fill  + diag_id%ql_fill_col > 0) then
        diag_pt%qldt_fill = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qldt_berg  + diag_id%ql_berg_col > 0) then
        diag_pt%qldt_berg = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qldt_freez + diag_id%ql_freez_col > 0) then
        diag_pt%qldt_freez = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qldt_rime  + diag_id%ql_rime_col > 0) then
        diag_pt%qldt_rime = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qldt_destr + diag_id%ql_destr_col > 0) then
        diag_pt%qldt_destr = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qldt_freez2 + diag_id%ql_freez2_col > 0) then
        diag_pt%qldt_freez2 = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qldt_sedi + diag_id%ql_sedi_col > 0) then
        diag_pt%qldt_sedi = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%sedi_sfc  > 0) then
        diag_pt%sedi_sfc = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qldt_accrs + diag_id%ql_accrs_col > 0) then
        diag_pt%qldt_accrs = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qldt_bergs + diag_id%ql_bergs_col > 0) then
        diag_pt%qldt_bergs = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!-----------------------------------------------------------------------
!    9) variables associated with cloud droplet number time tendency:
!-----------------------------------------------------------------------
      if (diag_id%qndt_cond + diag_id%qn_cond_col > 0) then
        diag_pt%qndt_cond = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_evap  + diag_id%qn_evap_col > 0) then
        diag_pt%qndt_evap = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_fill + diag_id%qn_fill_col +    &
          diag_id%qldt_fill + diag_id%ql_fill_col > 0) then
        diag_pt%qndt_fill = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_destr + diag_id%qn_destr_col > 0) then
        diag_pt%qndt_destr = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_super + diag_id%qn_super_col > 0) then
        diag_pt%qndt_super = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_berg + diag_id%qn_berg_col +    &
                              diag_id%qldt_berg > 0) then
        diag_pt%qndt_berg = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_freez + diag_id%qn_freez_col > 0) then
        diag_pt%qndt_freez = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_sacws + diag_id%qn_sacws_col > 0) then
        diag_pt%qndt_sacws = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_sacws_o + diag_id%qn_sacws_o_col > 0) then
        diag_pt%qndt_sacws_o = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_eros + diag_id%qn_eros_col > 0) then
        diag_pt%qndt_eros = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_pra + diag_id%qn_pra_col > 0) then
        diag_pt%qndt_pra = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_auto + diag_id%qn_auto_col > 0) then
        diag_pt%qndt_auto = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_nucclim + diag_id%qn_nucclim_col > 0) then
        diag_pt%qndt_nucclim = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_sedi + diag_id%qn_sedi_col > 0) then
        diag_pt%qndt_sedi = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_melt + diag_id%qn_melt_col > 0) then
        diag_pt%qndt_melt = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_ihom + diag_id%qn_ihom_col > 0) then
        diag_pt%qndt_ihom = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_size_adj + diag_id%qn_size_adj_col > 0) then
        diag_pt%qndt_size_adj = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_fill2 + diag_id%qn_fill2_col > 0) then
        diag_pt%qndt_fill2 = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!-----------------------------------------------------------------------
!    10) variables associated with ice particle number time tendency:
!-----------------------------------------------------------------------
      if (diag_id%qnidt_fill + diag_id%qni_fill_col > 0) then
        diag_pt%qnidt_fill = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_nnuccd + diag_id%qni_nnuccd_col > 0) then
        diag_pt%qnidt_nnuccd = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_nsubi + diag_id%qni_nsubi_col > 0) then
        diag_pt%qnidt_nsubi = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_nerosi + diag_id%qni_nerosi_col > 0) then
        diag_pt%qnidt_nerosi = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_nprci + diag_id%qni_nprci_col > 0) then
        diag_pt%qnidt_nprci = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_nprai + diag_id%qni_nprai_col > 0) then
        diag_pt%qnidt_nprai = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_nucclim1 + diag_id%qni_nucclim1_col > 0) then
        diag_pt%qnidt_nucclim1 = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_nucclim2 + diag_id%qni_nucclim2_col > 0) then
        diag_pt%qnidt_nucclim2 = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_sedi + diag_id%qni_sedi_col > 0) then
        diag_pt%qnidt_sedi = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_melt + diag_id%qni_melt_col > 0) then
        diag_pt%qnidt_melt = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_size_adj + diag_id%qni_size_adj_col > 0) then
        diag_pt%qnidt_size_adj = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_fill2 + diag_id%qni_fill2_col > 0) then
        diag_pt%qnidt_fill2 = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_super + diag_id%qni_super_col > 0) then
        diag_pt%qnidt_super = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_ihom + diag_id%qni_ihom_col > 0) then
        diag_pt%qnidt_ihom = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_destr + diag_id%qni_destr_col > 0) then
        diag_pt%qnidt_destr = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_cleanup + diag_id%qni_cleanup_col > 0) then
        diag_pt%qnidt_cleanup = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_cleanup2 + diag_id%qni_cleanup2_col > 0) then
        diag_pt%qnidt_cleanup2 = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!-----------------------------------------------------------------------
!    11) variables associated with relative humidity:
!-----------------------------------------------------------------------
      if (diag_id%rhcrit > 0 ) then
        diag_pt%rhcrit = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%rhcrit_min > 0 ) then
        diag_pt%rhcrit_min = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%rhiin > 0 ) then
        diag_pt%rhiin = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%rhlin > 0 ) then
        diag_pt%rhlin = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!-----------------------------------------------------------------------
!    12) variables associated with aerosol nucleation:
!-----------------------------------------------------------------------
      if (diag_id%imass7 > 0 ) then
        diag_pt%imass7 = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%ni_dust > 0 ) then
        diag_pt%ni_dust = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%ni_sulf> 0 ) then
        diag_pt%ni_sulf = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%ni_bc > 0 ) then
        diag_pt%ni_bc = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%ndust1 > 0 ) then
        diag_pt%ndust1 = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%ndust2 > 0 ) then
        diag_pt%ndust2 = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%ndust3 > 0 ) then
        diag_pt%ndust3 = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%ndust4 > 0 ) then
        diag_pt%ndust4 = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%ndust5 > 0 ) then
        diag_pt%ndust5 = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%sulfate > 0) then
        diag_pt%sulfate = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%seasalt_sub  > 0) then
        diag_pt%seasalt_sub = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%seasalt_sup  > 0) then
        diag_pt%seasalt_sup = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%om  > 0) then
        diag_pt%om = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!-----------------------------------------------------------------------
!    13) variables associated with water vapor tendency:
!-----------------------------------------------------------------------
      if (diag_id%rain_evap + diag_id%rain_evap_col > 0) then
        diag_pt%rain_evap = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!-----------------------------------------------------------------------
!    14) variables associated with cloud ice time tendency:
!-----------------------------------------------------------------------
      if (diag_id%qidt_dep + diag_id%qi_dep_col > 0) then
        diag_pt%qidt_dep = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qidt_subl + diag_id%qi_subl_col > 0) then
        diag_pt%qidt_subl = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qidt_eros + diag_id%qi_eros_col > 0) then
        diag_pt%qidt_eros = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%sedi_ice  > 0) then
        diag_pt%sedi_ice = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qidt_fall + diag_id%qi_fall_col > 0) then
        diag_pt%qidt_fall = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qidt_melt + diag_id%qi_melt_col > 0) then
        diag_pt%qidt_melt = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qidt_melt2 + diag_id%qi_melt2_col > 0) then
        diag_pt%qidt_melt2 = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qidt_destr + diag_id%qi_destr_col > 0) then
        diag_pt%qidt_destr = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qidt_qvdep + diag_id%qi_qvdep_col > 0) then
        diag_pt%qidt_qvdep = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qidt_fill + diag_id%qi_fill_col > 0) then
        diag_pt%qidt_fill = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qidt_auto + diag_id%qi_auto_col > 0) then
        diag_pt%qidt_auto = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qidt_accr + diag_id%qi_accr_col > 0) then
        diag_pt% qidt_accr= n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qidt_accrs + diag_id%qi_accrs_col > 0) then
        diag_pt%qidt_accrs = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!-----------------------------------------------------------------------
!    15) variables associated with cloud area time tendency:
!-----------------------------------------------------------------------
      if (diag_id%qadt_lsform + diag_id%qa_lsform_col > 0) then
        diag_pt%qadt_lsform = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qadt_lsdiss + diag_id%qa_lsdiss_col > 0) then
        diag_pt%qadt_lsdiss = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qadt_rhred + diag_id%qa_rhred_col > 0) then
        diag_pt%qadt_rhred = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qadt_eros  + diag_id%qa_eros_col > 0) then
        diag_pt%qadt_eros = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qadt_fill + diag_id%qa_fill_col  > 0) then
        diag_pt%qadt_fill = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qadt_super + diag_id%qa_super_col > 0) then
        diag_pt%qadt_super = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qadt_destr + diag_id%qa_destr_col > 0) then
        diag_pt%qadt_destr = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qadt_limits + diag_id%qa_limits_col > 0) then
        diag_pt%qadt_limits = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qadt_ahuco + diag_id%qa_ahuco_col > 0) then
        diag_pt%qadt_ahuco = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!REV#9
!------------------------------------------------------------------------
!   16)  variables added by h1g with ncar M-G microphysics
!------------------------------------------------------------------------
      if (diag_id%SA3d  + diag_id%SA2d  > 0) then
        diag_pt%SA3d = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%ST3d  + diag_id%ST2d  > 0) then
        diag_pt%ST3d = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%SQ3d  + diag_id%SQ2d  > 0) then
        diag_pt%SQ3d = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%SL3d  + diag_id%SL2d  > 0) then
        diag_pt%SL3d = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%SI3d  + diag_id%SI2d  > 0) then
        diag_pt%SI3d = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%SN3d  + diag_id%SN2d  > 0) then
        diag_pt%SN3d = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%SNI3d  + diag_id%SNI2d  > 0) then
        diag_pt%SNI3d = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_contact_frz + diag_id%qn_contact_frz_col > 0) then
        diag_pt%qndt_contact_frz = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_cleanup + diag_id%qn_cleanup_col     > 0) then
        diag_pt%qndt_cleanup     = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qndt_cleanup2 + diag_id%qn_cleanup2_col    > 0) then
        diag_pt%qndt_cleanup2    = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qnidt_nsacwi +  diag_id%qni_nsacwi_col      > 0) then
        diag_pt%qnidt_nsacwi      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_liquid_init + diag_id%q_liquid_init_col > 0) then
        diag_pt%qdt_liquid_init  = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_ice_init +  diag_id%q_ice_init_col    > 0) then
        diag_pt%qdt_ice_init    = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_rain_evap   + diag_id%q_rain_evap_col   > 0) then
        diag_pt%qdt_rain_evap = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_cond + diag_id%q_cond_col        > 0) then
        diag_pt%qdt_cond        = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_deposition + diag_id%q_deposition_col  > 0) then
        diag_pt%qdt_deposition  = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_eros_l + diag_id%q_eros_l_col      > 0) then
        diag_pt%qdt_eros_l      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_eros_i  + diag_id%q_eros_i_col      > 0) then
        diag_pt%qdt_eros_i      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_qv_on_qi + diag_id%q_qv_on_qi_col    > 0) then
        diag_pt%qdt_qv_on_qi    = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_sedi_ice2vapor +   &
                             diag_id%q_sedi_ice2vapor_col > 0) then
        diag_pt%qdt_sedi_ice2vapor = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_sedi_liquid2vapor +   &
                  diag_id%q_sedi_liquid2vapor_col > 0) then
        diag_pt%qdt_sedi_liquid2vapor = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_super_sat_rm + diag_id%q_super_sat_rm_col   > 0) then
        diag_pt%qdt_super_sat_rm   = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_destr + diag_id%q_destr_col          > 0) then
        diag_pt%qdt_destr          = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_cleanup_liquid +    &
                              diag_id%q_cleanup_liquid_col > 0) then
        diag_pt%qdt_cleanup_liquid = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_cleanup_ice +  diag_id%q_cleanup_ice_col    > 0) then
        diag_pt%qdt_cleanup_ice    = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%srfrain_evap +  diag_id%srfrain_evap_col   > 0) then
        diag_pt%srfrain_evap       = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%rain_mass_conv     > 0) then
        diag_pt%rain_mass_conv     = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%neg_rain     > 0) then
        diag_pt%neg_rain     = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%snow_mass_conv     > 0) then
        diag_pt%snow_mass_conv     = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%neg_snow     > 0) then
        diag_pt%neg_snow     = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_snow_sublim + diag_id%q_snow_sublim_col > 0) then
        diag_pt%qdt_snow_sublim = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qdt_snow2vapor       + diag_id%q_snow2vapor_col > 0) then
        diag_pt%qdt_snow2vapor       = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%srfrain_accrs + diag_id%srfrain_accrs_col > 0) then
        diag_pt%srfrain_accrs        = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%srfrain_freez + diag_id%srfrain_freez_col > 0) then
        diag_pt%srfrain_freez        = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%qldt_HM_splinter + diag_id%ql_HM_splinter_col > 0) then
        diag_pt%qldt_HM_splinter      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
!------------------------------------------------------------------------
!   17)  variables associated with budget analysis
!------------------------------------------------------------------------
      if (diag_id%SA_imb  + diag_id%SA_imb_col > 0) then
        diag_pt%SA_imb      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%ST_imb  + diag_id%ST_imb_col > 0) then
        diag_pt%ST_imb      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%SQ_imb  + diag_id%SQ_imb_col > 0) then
        diag_pt%SQ_imb      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%SL_imb  + diag_id%SL_imb_col > 0) then
        diag_pt%SL_imb      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%SI_imb  + diag_id%SI_imb_col > 0) then
        diag_pt%SI_imb      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%SN_imb  + diag_id%SN_imb_col > 0) then
        diag_pt%SN_imb      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%SNi_imb  + diag_id%SNi_imb_col > 0) then
        diag_pt%SNi_imb      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%rain_imb  + diag_id%rain_imb_col > 0) then
        diag_pt%rain_imb      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%cld_liq_imb  + diag_id%cld_liq_imb_col > 0) then
        diag_pt%cld_liq_imb      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%snow_imb  + diag_id%snow_imb_col > 0) then
        diag_pt%snow_imb      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if
      if (diag_id%cld_ice_imb  + diag_id%cld_ice_imb_col > 0) then
        diag_pt%cld_ice_imb      = n_diag_4d
        n_diag_4d = n_diag_4d + 1 
      end if

!----------------------------------------------------------------------


end subroutine diag_field_init



!########################################################################




end module strat_netcdf_mod

module vegn_photosynthesis_mod

#include "../shared/debug.inc"

use fms_mod,            only : write_version_number, error_mesg, FATAL
use constants_mod,      only : TFREEZE 
use sphum_mod,          only : qscomp

use land_constants_mod, only : BAND_VIS, Rugas,seconds_per_year, mol_h2o, mol_air
use land_debug_mod,     only : is_watch_point
use vegn_data_mod,      only : MSPECIES, PT_C4, spdata
use vegn_tile_mod,      only : vegn_tile_type
use vegn_cohort_mod,    only : vegn_cohort_type, get_vegn_wet_frac

implicit none
private

! ==== public interfaces =====================================================
public :: vegn_photosynthesis_init
public :: vegn_photosynthesis
! ==== end of public interfaces ==============================================

! ==== module constants ======================================================
character(len=*), private, parameter :: &
   version = '$Id: vegn_photosynthesis.F90,v 20.0 2013/12/13 23:31:14 fms Exp $', &
   tagname = '$Name: tikal $', &
   module_name = 'vegn_photosynthesis'
! values for internal vegetation photosynthesis option selector
integer, parameter :: VEGN_PHOT_SIMPLE  = 1 ! zero photosynthesis
integer, parameter :: VEGN_PHOT_LEUNING = 2 ! photosynthesis according to simplified Leuning model

! ==== module variables ======================================================
integer :: vegn_phot_option = -1 ! selector of the photosynthesis option


contains


! ============================================================================
subroutine vegn_photosynthesis_init(photosynthesis_to_use)
  character(*), intent(in) :: photosynthesis_to_use

  call write_version_number(version, tagname)

  ! convert symbolic names of photosynthesis options into numeric IDs to
  ! speed up selection during run-time
  if (trim(photosynthesis_to_use)=='simple') then
     vegn_phot_option = VEGN_PHOT_SIMPLE
  else if (trim(photosynthesis_to_use)=='leuning') then
     vegn_phot_option = VEGN_PHOT_LEUNING
  else
     call error_mesg('vegn_photosynthesis_init',&
          'vegetation photosynthesis option photosynthesis_to_use="'//&
          trim(photosynthesis_to_use)//'" is invalid, use "simple" or "leuning"',&
          FATAL)
  endif

end subroutine vegn_photosynthesis_init


! ============================================================================
! compute stomatal conductance, photosynthesis and respiration
subroutine vegn_photosynthesis ( vegn, &
     PAR_dn, PAR_net, cana_q, cana_co2, p_surf, drag_q, &
     soil_beta, soil_water_supply, &
     evap_demand, stomatal_cond, psyn, resp )
  type(vegn_tile_type), intent(in) :: vegn
  real, intent(in)  :: PAR_dn   ! downward PAR at the top of the canopy, W/m2 
  real, intent(in)  :: PAR_net  ! net PAR absorbed by the canopy, W/m2
  real, intent(in)  :: cana_q   ! specific humidity in canopy air space, kg/kg
  real, intent(in)  :: cana_co2 ! co2 concentration in canopy air space, mol CO2/mol dry air
  real, intent(in)  :: p_surf   ! surface pressure
  real, intent(in)  :: drag_q   ! drag coefficient for specific humidity
  real, intent(in)  :: soil_beta
  real, intent(in)  :: soil_water_supply ! max supply of water to roots per unit
                                ! active root biomass per second, kg/(m2 s)
  real, intent(out) :: evap_demand ! evaporative water demand, kg/(m2 s)
  real, intent(out) :: stomatal_cond ! stomatal conductance, m/s(?)
  real, intent(out) :: psyn     ! net photosynthesis, mol C/(m2 s)
  real, intent(out) :: resp     ! leaf respiration, mol C/(m2 s)


  ! ---- local constants
  real, parameter :: res_scaler = 20.0    ! scaling factor for water supply

  ! ---- local vars
  type(vegn_cohort_type), pointer :: cohort
  integer :: sp ! shorthand for vegetation species
  real    :: water_supply ! water supply, mol H2O per m2 of leaves per second
  real    :: Ed ! evaporative demand, mol H2O per m2 of leaves per second
  real    :: fw, fs ! wet and snow-covered fraction of leaves

  ! get the pointer to the first (and, currently, the only) cohort
  cohort => vegn%cohorts(1)

  select case (vegn_phot_option)

  case(VEGN_PHOT_SIMPLE)
     ! beta non-unity only for "beta" models
     stomatal_cond = soil_beta / (cohort%rs_min  + (1-soil_beta)/drag_q)
     cohort%An_op  = 0
     cohort%An_cl  = 0
     psyn = 0
     resp = 0
     evap_demand   = 0

  case(VEGN_PHOT_LEUNING)
     if(cohort%lai > 0) then
        ! assign species type to local var, purely for convenience 
        sp = cohort%species
        ! recalculate the water supply to mol H20 per m2 of leaf per second
        water_supply = soil_water_supply/(mol_h2o*cohort%lai)
      
        call get_vegn_wet_frac (cohort, fw=fw, fs=fs)
        call gs_Leuning(PAR_dn, PAR_net, cohort%prog%Tv, cana_q, cohort%lai, &
             cohort%leaf_age, p_surf, water_supply, sp, cohort%pt, cana_co2, &
             cohort%extinct, fs+fw, stomatal_cond, psyn, resp, Ed)
        ! store the calculated photosythesis and fotorespiration for future use
        ! in carbon_int
        cohort%An_op  = psyn * seconds_per_year
        cohort%An_cl  = resp * seconds_per_year
        ! convert stomatal conductance, photosynthesis and leaf respiration from units
        ! per unit area of leaf to the units per unit area of land
        stomatal_cond = stomatal_cond*cohort%lai
        psyn          = psyn         *cohort%lai
        resp          = resp         *cohort%lai
        ! convert evaporative demand from mol H2O/(m2_of_leaf s) to
        ! kg/(m2_of_land s)
        evap_demand   = Ed*mol_h2o   *cohort%lai
     else
        ! no leaves means no photosynthesis and no stomatal conductance either
        cohort%An_op  = 0
        cohort%An_cl  = 0
        stomatal_cond = 0
        psyn          = 0
        resp          = 0
        evap_demand   = 0
     endif

  case default
     call error_mesg('vegn_stomatal_cond', &
          'invalid vegetation photosynthesis option', FATAL)
  end select

end subroutine vegn_photosynthesis


! ============================================================================
subroutine gs_Leuning(rad_top, rad_net, tl, ea, lai, leaf_age, &
                   p_surf, ws, pft, pt, ca, &
                   kappa, leaf_wet,  &
                   gs, apot, acl, Ed)
  real,    intent(in)    :: rad_top ! PAR dn on top of the canopy, w/m2
  real,    intent(in)    :: rad_net ! PAR net on top of the canopy, w/m2
  real,    intent(in)    :: tl   ! leaf temperature, degK
  real,    intent(in)    :: ea   ! specific humidity in the canopy air (?), kg/kg
  real,    intent(in)    :: lai  ! leaf area index
  real,    intent(in)    :: leaf_age ! age of leaf since budburst (deciduos), days
  real,    intent(in)    :: p_surf ! surface pressure, Pa
  real,    intent(in)    :: ws   ! water supply, mol H2O/(m2 of leaf s)
  integer, intent(in)    :: pft  ! species
  integer, intent(in)    :: pt   ! physiology type (C3 or C4)
  real,    intent(in)    :: ca   ! concentartion of CO2 in the canopy air space, mol CO2/mol dry air
  real,    intent(in)    :: kappa! canopy extinction coefficient (move inside f(pft))
  real,    intent(in)    :: leaf_wet ! fraction of leaf that's wet or snow-covered
  ! note that the output is per area of leaf; to get the quantities per area of
  ! land, multiply them by LAI
  real,    intent(out)   :: gs   ! stomatal conductance, m/s
  real,    intent(out)   :: apot ! net photosynthesis, mol C/(m2 s)
  real,    intent(out)   :: acl  ! leaf respiration, mol C/(m2 s)
  real,    intent(out)   :: Ed   ! evaporative demand, mol H2O/(m2 s)

  ! ---- local vars     
  ! photosynthesis
  real :: vm;
  real :: kc,ko; ! Michaelis-Menten constants for CO2 and O2, respectively
  real :: ci;
  real :: capgam; ! CO2 compensation point
  real :: f2,f3;
  real :: coef0,coef1;

  real :: Resp;

  ! conductance related
  real :: b;
  real :: ds;  ! humidity deficit, kg/kg
  real :: hl;  ! saturated specific humidity at the leaf temperature, kg/kg
  real :: do1;
  
  ! misceleneous
  real :: dum2;
  real, parameter :: light_crit = 0;
  real, parameter :: gs_lim = 0.25;

  ! new average computations
  real :: lai_eq;
  real, parameter :: rad_phot = 0.0000046 ! PAR conversion factor of J -> mol of quanta 
  real :: light_top;
  real :: par_net;
  real :: Ag;
  real :: An;
  real :: Ag_l;
  real :: Ag_rb;
  real :: anbar;
  real :: gsbar;
  real :: w_scale;
  real, parameter :: p_sea = 1.0e5 ! sea level pressure, Pa
  ! soil water stress
  real :: an_w,gs_w;

  if (is_watch_point()) then
     write(*,*) '####### gs_leuning input #######'
     __DEBUG2__(rad_top, rad_net)
     __DEBUG1__(tl)
     __DEBUG1__(ea)
     __DEBUG1__(lai)
     __DEBUG1__(leaf_age)
     __DEBUG1__(p_surf)
     __DEBUG1__(ws)
     __DEBUG1__(pft)
     __DEBUG1__(ca)
     __DEBUG1__(kappa)
     __DEBUG1__(leaf_wet)
     __DEBUG1__(pt)
     write(*,*) '####### end of ### gs_leuning input #######'
  endif

  b=0.01;
  do1=0.09 ; ! kg/kg
  if (pft < 2) do1=0.15;


  ! Convert Solar influx from W/(m^2s) to mol_of_quanta/(m^2s) PAR,
  ! empirical relationship from McCree is light=rn*0.0000046
  light_top = rad_top*rad_phot;
  par_net   = rad_net*rad_phot;
  
  ! calculate humidity deficit, kg/kg
  call qscomp(tl, p_surf, hl)
  ds = max(hl-ea,0.0)

  ! capgam=0.209/(9000.0*exp(-5000.0*(1.0/288.2-1.0/tl))); - Foley formulation, 1986

  ko=0.25   *exp(1400.0*(1.0/288.2-1.0/tl))*p_sea/p_surf;
  kc=0.00015*exp(6000.0*(1.0/288.2-1.0/tl))*p_sea/p_surf;
  vm=spdata(pft)%Vmax*exp(3000.0*(1.0/288.2-1.0/tl));
  !decrease Vmax due to aging of temperate deciduous leaves 
  !(based on Wilson, Baldocchi and Hanson (2001)."Plant,Cell, and Environment", vol 24, 571-583)
  if (spdata(pft)%leaf_age_tau>0 .and. leaf_age>spdata(pft)%leaf_age_onset) then
     vm=vm*exp(-(leaf_age-spdata(pft)%leaf_age_onset)/spdata(pft)%leaf_age_tau)
  endif

  capgam=0.5*kc/ko*0.21*0.209; ! Farquhar & Caemmerer 1982

  ! Find respiration for the whole canopy layer
  
  Resp=spdata(pft)%gamma_resp*vm*lai;
  Resp=Resp/((1.0+exp(0.4*(5.0-tl+TFREEZE)))*(1.0+exp(0.4*(tl-45.0-TFREEZE))));
  
  
  ! ignore the difference in concentrations of CO2 near
  !  the leaf and in the canopy air, rb=0.
 
  Ag_l=0.;
  Ag_rb=0.;
  Ag=0.;
  anbar=-Resp/lai;
  gsbar=b;

 
  ! find the LAI level at which gross photosynthesis rates are equal
  ! only if PAR is positive
  if ( light_top > light_crit ) then
     if (pt==PT_C4) then ! C4 species
        coef0=(1+ds/do1)/spdata(pft)%m_cond;
        ci=(ca+1.6*coef0*capgam)/(1+1.6*coef0);
        if (ci>capgam) then
           f2=vm;
           f3=18000.0*vm*ci;       
       
           dum2=min(f2,f3)
           
           ! find LAI level at which rubisco limited rate is equal to light limited rate
           lai_eq = -log(dum2/(kappa*spdata(pft)%alpha_phot*light_top))/kappa;
           lai_eq = min(max(0.0,lai_eq),lai) ! limit lai_eq to physically possible range

           ! gross photosynthesis for light-limited part of the canopy
           Ag_l   = spdata(pft)%alpha_phot * par_net &
                * (exp(-lai_eq*kappa)-exp(-lai*kappa))/(1-exp(-lai*kappa))
           ! gross photosynthesis for rubisco-limited part of the canopy
           Ag_rb  = dum2*lai_eq

           Ag=(Ag_l+Ag_rb)/ &
             ((1.0+exp(0.4*(5.0-tl+TFREEZE)))*(1.0+exp(0.4*(tl-45.0-TFREEZE))));
           An=Ag-Resp;
           anbar=An/lai;
     
           if(anbar>0.0) then
               gsbar=anbar/(ci-capgam)/coef0;
           endif
        endif ! ci>capgam
     else ! C3 species
        coef0=(1+ds/do1)/spdata(pft)%m_cond;
        coef1=kc*(1.0+0.209/ko);
        ci=(ca+1.6*coef0*capgam)/(1+1.6*coef0);
        f2=vm*(ci-capgam)/(ci+coef1);
        f3=vm/2.;
        dum2=min(f2,f3);
        if (ci>capgam) then
           ! find LAI level at which rubisco limited rate is equal to light limited rate
           lai_eq=-log(dum2*(ci+2.*capgam)/(ci-capgam)/ &
                       (spdata(pft)%alpha_phot*light_top*kappa))/kappa;
           lai_eq = min(max(0.0,lai_eq),lai) ! limit lai_eq to physically possible range

           ! gross photosynthesis for light-limited part of the canopy
           Ag_l   = spdata(pft)%alpha_phot * (ci-capgam)/(ci+2.*capgam) * par_net &
                * (exp(-lai_eq*kappa)-exp(-lai*kappa))/(1-exp(-lai*kappa))
           ! gross photosynthesis for rubisco-limited part of the canopy
           Ag_rb  = dum2*lai_eq

           Ag=(Ag_l+Ag_rb)/((1.0+exp(0.4*(5.0-tl+TFREEZE)))*(1.0+exp(0.4*(tl-45.0-TFREEZE))));
           An=Ag-Resp;
           anbar=An/lai;

           if(anbar>0.0) then
               gsbar=anbar/(ci-capgam)/coef0;
           endif
        endif ! ci>capgam
     endif
  endif ! light is available for photosynthesis
  
  an_w=anbar;
  if (an_w > 0.) then
     an_w=an_w*(1-spdata(pft)%wet_leaf_dreg*leaf_wet);
  endif
  
  gs_w=gsbar*(1-spdata(pft)%wet_leaf_dreg*leaf_wet);

  if (gs_w > gs_lim) then
      if(an_w > 0.) an_w = an_w*gs_lim/gs_w;
      gs_w = gs_lim;
  endif

#if 1
  ! find water availability
  ! diagnostic demand

  Ed=gs_w*ds*mol_air/mol_h2o;
  ! the factor mol_air/mol_h2o makes units of gs_w and humidity deficit ds compatible:
  ! ds*mol_air/mol_h2o is the humidity deficit in [mol_h2o/mol_air]

  if (Ed>ws) then
     w_scale=ws/Ed;
     gs_w=w_scale*gs_w;
     if(an_w > 0.0) an_w = an_w*w_scale;
     if(an_w < 0.0.and.gs_w >b) gs_w=b;
     if (is_watch_point()) then
        write(*,*)'#### gs is water-limited'
        __DEBUG1__(w_scale)
        __DEBUG3__(gs_w, an_w, b)
     endif
  endif
  gs=gs_w;
  apot=an_w;
  acl=-Resp/lai;
  

#else
! no water limitation on stomata
   gs=gsbar;  
   apot=anbar; 
   acl=-Resp/lai; 
#endif 

   ! finally, convert units of stomatal conductance to m/s from mol/(m2 s) by
   ! multiplying it by a volume of a mole of gas
   gs = gs * Rugas * Tl / p_surf

   if (is_watch_point()) then
      __DEBUG3__(gs, apot, acl)
   endif
end subroutine gs_Leuning

end module vegn_photosynthesis_mod

module river_mod
!-----------------------------------------------------------------------
!                   GNU General Public License                        
!                                                                      
! This program is free software; you can redistribute it and/or modify it and  
! are expected to follow the terms of the GNU General Public License  
! as published by the Free Software Foundation; either version 2 of   
! the License, or (at your option) any later version.                 
!                                                                      
! MOM is distributed in the hope that it will be useful, but WITHOUT    
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
! License for more details.                                           
!                                                                      
! For the full text of the GNU General Public License,                
! write to: Free Software Foundation, Inc.,                           
!           675 Mass Ave, Cambridge, MA 02139, USA.                   
! or see:   http://www.gnu.org/licenses/gpl.html                      
!-----------------------------------------------------------------------
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Kirsten Findell </CONTACT> 
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Zhi Liang </CONTACT> 
! <NAMELIST NAME="river_nml">
! <DATA NAME="layout" TYPE="integer, dimension(2)">
!  Processor domain layout for river model. If layout(1)*layout(2) is not equal
!  to mpp_npes, the river model layout will be assigned the layout of land model 
!  passed through river_init. 
!  </DATA> 
! <DATA NAME="do_rivers" TYPE="logical">
!   set true to run river model ( default is true). If FALSE, rivers are 
!   essentially turned off to save computing time
!  </DATA> 
! <DATA NAME="dt_slow" TYPE="real">
!   slow time step for river model. dt_slow must be integer multiplier of dt_fast passed 
!   from land model ( land model time step).
!  </DATA> 
! <DATA NAME="diag_freq" TYPE="integer">
!   Number of slow time steps between sending out diagnositics data(default is 1). Please
!   note that diagnostic output frequency ( specified in diag_table ) must be divided by 
!   diag_freq*dt_slow.
!  </DATA> 
! </NAMELIST>

#ifdef INTERNAL_FILE_NML
  use mpp_mod, only: input_nml_file
#else
  use fms_mod, only: open_namelist_file
#endif

  use mpp_mod,             only : CLOCK_SUBCOMPONENT, CLOCK_ROUTINE
  use mpp_mod,             only : mpp_error, mpp_chksum, FATAL, WARNING, NOTE, stdlog, mpp_npes
  use mpp_mod,             only : mpp_pe, stdout, mpp_chksum, mpp_max
  use mpp_mod,             only : mpp_clock_id, mpp_clock_begin, mpp_clock_end, MPP_CLOCK_DETAILED
  use mpp_domains_mod,     only : domain2d, mpp_get_compute_domain, mpp_get_global_domain 
  use mpp_domains_mod,     only : mpp_get_data_domain, mpp_update_domains, mpp_get_ntile_count
  use fms_mod,             only : write_version_number, check_nml_error, string
  use fms_mod,             only : close_file, file_exist, field_size, read_data, write_data, lowercase
  use fms_mod,             only : field_exist, CLOCK_FLAG_DEFAULT
  use fms_io_mod,          only : get_mosaic_tile_file, get_instance_filename
  use diag_manager_mod,    only : diag_axis_init, register_diag_field, register_static_field, send_data
  use time_manager_mod,    only : time_type, increment_time, get_time
  use river_type_mod,      only : river_type, Leo_Mad_trios, NO_RIVER_FLAG
  use river_physics_mod,   only : river_physics_step, river_physics_init, river_impedes_lake, &
                                  river_impedes_large_lake
  use constants_mod,       only : PI, RADIAN, tfreeze, DENS_H2O, hlf
  use stock_constants_mod, only : ISTOCK_WATER, ISTOCK_HEAT
  use land_tile_mod,       only : land_tile_type, land_tile_enum_type, &
     first_elmt, tail_elmt, next_elmt, current_tile, get_elmt_indices, &
     operator(/=)
  use land_data_mod,       only : land_data_type, land_state_type, lnd
  use lake_tile_mod,       only : num_l

  implicit none
  private

!--- version information ---------------------------------------------
  character(len=128) :: version = '$Id: river.F90,v 20.0 2013/12/13 23:29:41 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

!--- public interface ------------------------------------------------
  public :: river_init, river_end, river_type, update_river, river_stock_pe
  public :: save_river_restart

!--- namelist interface ----------------------------------------------
  logical            :: do_rivers       = .TRUE.  ! if FALSE, rivers are essentially turned off to save computing time
  real               :: dt_slow
  integer            :: diag_freq       = 1       ! Number of slow time steps between sending out diagnositics data.
  logical            :: debug_river     = .FALSE.
  logical            :: do_age          = .false.
  real               :: Somin           = 0.00005 ! There are 7 points with So = -9.999 but basinid > 0....
  real               :: outflowmean_min = 1.      ! temporary fix, should not allow zero in input file
  integer            :: num_c=0, num_species
  logical            :: land_area_called_cellarea = .false.
  logical            :: all_big_outlet_ctn0 = .false.
!Balaji
  public :: num_species !public for test_river_solo
  character(len=6),              dimension(10) :: rt_c_name
  character(len=128),            dimension(10) :: rt_source_conc_file, rt_source_flux_file
  character(len=128),            dimension(10) :: rt_source_conc_name, rt_source_flux_name
  real,                          dimension(10) :: rt_t_ref, rt_vf_ref, rt_q10, rt_kinv
  character(len=128),allocatable, dimension(:) :: source_conc_file, source_flux_file
  character(len=128),allocatable, dimension(:) :: source_conc_name, source_flux_name
  real, dimension(3) :: ave_DHG_exp = (/0.49,0.33,0.18/)  ! (/B, F, M for avg of many rivers, 15Nov05/)
  real, dimension(3) :: ave_AAS_exp = (/0.19,0.39,0.42/)  ! (/b, f, m for avg of many rivers, 15Nov05/)
  real, dimension(3) :: ave_DHG_coef = (/4.62,0.26,0.82/) ! (/A, C, K for avg of many rivers, 15Nov05/)
  real               :: sinuosity = 1.3
  real               :: channel_tau = 86400*365.25*10     ! channel geometry reflects average flow over O(10 y)
  logical :: lake_area_bug = .FALSE. ! if set to true, reverts to buggy (quebec)
      ! behavior, where by mistake cell area was used instead of land area to 
      ! compute the area of lakes.
  logical :: stop_on_mask_mismatch = .TRUE. ! if set to false, then the data mismatches (mmismatch
      ! of land and river masks, and discharges in pouints where there is no ocean) are reported,
      ! but don't cause the abort of the program. 
  namelist /river_nml/ dt_slow, diag_freq, debug_river, do_age,              &
                       Somin, outflowmean_min, num_c, rt_c_name, rt_t_ref,   &
                       rt_vf_ref, rt_q10, rt_kinv, rt_source_conc_file,      &
                       rt_source_flux_file, rt_source_conc_name,             &
                       rt_source_flux_name, ave_DHG_exp, ave_AAS_exp,        &
                       ave_DHG_coef, do_rivers, sinuosity, channel_tau,      &
                       land_area_called_cellarea, all_big_outlet_ctn0,       &
                       lake_area_bug, stop_on_mask_mismatch

  character(len=128) :: river_src_file   = 'INPUT/river_data.nc'
  character(len=128) :: river_Omean_file = 'INPUT/river_Omean.nc'
!---------------------------------------------------------------------
  logical :: module_is_initialized = .FALSE.
  integer :: isc, iec, jsc, jec                         ! compute domain decomposition 
  integer :: isd, ied, jsd, jed                         ! data domain decomposition 
  integer :: nlon, nlat                                 ! size of computational river grid 
  integer :: num_lake_lev
  integer :: id_outflowmean, id_lake_depth_sill
  integer :: id_dx, id_basin, id_So, id_depth, id_width, id_vel
  integer :: id_LWSr, id_FWSr, id_HSr, id_meltr
  integer :: i_species
  integer :: id_travel, id_elev, id_tocell
  ! ***
  ! the following id_* retained temporarily for compatibility with older diag tables
  integer :: id_storage_old, id_stordis_old, id_infloc_old, id_inflow_old, id_outflow_old
  integer :: id_lake_outflow_old, id_disw2o_old, id_outflowmean_old
  integer :: id_depth_old, id_width_old, id_vel_old
  integer :: id_r_t_rivr, id_i_t_rivr, id_o_t_rivr, id_lot_rivr, id_s_t_rivr, id_dot_rivr
  integer :: id_r_frazil, id_i_frazil, id_o_frazil, id_lofrazil, id_s_frazil, id_dofrazil
  ! ***
  integer :: maxtravel
  real    :: missing = -1.e8

  real,    parameter :: CONST_OMEAN = 80000
  integer, parameter :: num_phys = 2
  real,    parameter :: epsln = 1.e-6
  real,    parameter :: sec_in_day = 86400.

  real,  allocatable, dimension(:,:)   :: discharge2ocean_next   ! store discharge value
  real,  allocatable, dimension(:,:,:) :: discharge2ocean_next_c ! store discharge value
  integer,          allocatable, dimension(:) :: id_infloc,  id_storage, id_stordis, id_inflow
  integer,          allocatable, dimension(:) :: id_run_stor
  integer,          allocatable, dimension(:) :: id_outflow, id_removal, id_dis
  integer,          allocatable, dimension(:) :: id_lake_outflow
  character(len=4), allocatable, dimension(:) :: c_name
  character(len=8), allocatable, dimension(:) :: if_name, of_name, lo_name, do_name
  character(len=8), allocatable, dimension(:) :: st_name, sd_name, rf_name, rm_name, sr_name
  character(len=8), allocatable, dimension(:) :: c_desc
  character(len=24), allocatable, dimension(:) :: if_desc, of_desc, lo_desc, do_desc
  character(len=64), allocatable, dimension(:) :: st_desc, sd_desc, rf_desc, rm_desc, sr_desc
  character(len=7), allocatable, dimension(:) :: flux_units, store_units
  character(len=5), allocatable, dimension(:) :: conc_units
  integer                       :: num_fast_calls 
  integer                       :: slow_step = 0          ! record number of slow time step run.
  type(domain2d),          save :: domain
  type(river_type) ,       save :: River

!--- these variables are for communication purpose
  integer              :: pe
  integer, allocatable :: ncells(:)            ! number of points with each travel value

!--- clock id variable 
  integer :: slowclock, bndslowclock, physicsclock, diagclock, riverclock

contains


!#####################################################################
  subroutine river_init( land_lon, land_lat, time, dt_fast, land_domain, &
                         land_frac, id_lon, id_lat, river_land_mask )
    real,            intent(in) :: land_lon(:,:)     ! geographical lontitude of cell center
    real,            intent(in) :: land_lat(:,:)     ! geographical lattitude of cell center
    type(time_type), intent(in) :: time              ! current time
    type(time_type), intent(in) :: dt_fast           ! fast time step
    type(domain2d),  intent(in) :: land_domain       ! land domain
    real,            intent(in) :: land_frac(:,:)    ! land area fraction from land model
    integer,         intent(in) :: id_lon, id_lat    ! IDs of diagnostic axes
    logical,         intent(out):: river_land_mask(:,:) ! land mask seen by rivers

    integer              :: unit, io_status, ierr
    integer              :: sec, day, i, j
    integer              :: nxc, nyc
    character(len=128)   :: filename

    type(Leo_Mad_trios)   :: DHG_exp            ! downstream equation exponents
    type(Leo_Mad_trios)   :: DHG_coef           ! downstream equation coefficients
    type(Leo_Mad_trios)   :: AAS_exp            ! at-a-station equation exponents 

    riverclock = mpp_clock_id('update_river'           , CLOCK_FLAG_DEFAULT, CLOCK_SUBCOMPONENT)
    slowclock = mpp_clock_id('update_river_slow'       , CLOCK_FLAG_DEFAULT, CLOCK_ROUTINE)
    bndslowclock = mpp_clock_id('update_river_bnd_slow', CLOCK_FLAG_DEFAULT, CLOCK_ROUTINE)
    physicsclock = mpp_clock_id('river phys'           , CLOCK_FLAG_DEFAULT, CLOCK_ROUTINE)
    diagclock    = mpp_clock_id('river diag'           , CLOCK_FLAG_DEFAULT, CLOCK_ROUTINE)
!--- read namelist -------------------------------------------------
#ifdef INTERNAL_FILE_NML
     read (input_nml_file, nml=river_nml, iostat=io_status)
     ierr = check_nml_error(io_status, 'river_nml')
#else
    if (file_exist('input.nml')) then
      unit = open_namelist_file()
      ierr = 1;
      do while (ierr /= 0)
         read  (unit, nml=river_nml, iostat=io_status, end=10)
         ierr = check_nml_error(io_status,'river_nml')
      enddo
10    continue
      call close_file (unit)
    endif
#endif

!--- write version and namelist info to logfile --------------------
    call write_version_number(version, tagname)
    unit=stdlog()
    write(unit, river_nml)  

    if(.not.do_rivers) return ! do nothing further if the rivers are turned off

!--- check name list variables 

    if(diag_freq .le. 0) call mpp_error(FATAL,'river_mod: diag_freq should be a positive integer')

    pe      = mpp_pe()

! set up time-related values
    River % time = time
    call get_time(dt_fast, sec, day)
    River%dt_fast = day*sec_in_day+sec

    River%dt_slow = dt_slow
    River%channel_tau = channel_tau

    num_fast_calls = River%dt_slow/River%dt_fast
    num_species = num_phys + num_c
    if (do_age) num_species = num_species + 1
    River%num_species = num_species
    River%num_c = num_c
    River%do_age = do_age
    River%num_phys = num_phys

    if(River%dt_slow .lt. River%dt_fast) call mpp_error(FATAL, &
         'river_mod: river slow time step dt_slow should be no less than land model fast time step dt_fast')

    if ( mod(River%dt_slow,River%dt_fast) .ne. 0  ) call mpp_error(FATAL, &
         'river_mod: river slow time step dt_slow should be multiple of land model fast time step dt_fast')

!--- get the domain decompsition, river and land will be on the same grid and have the same domain decomposition.
    domain = land_domain
    call mpp_get_global_domain (domain, xsize=River%nlon, ysize=River%nlat)
    call mpp_get_compute_domain(domain, isc, iec, jsc, jec)
    call mpp_get_data_domain   (domain, isd, ied, jsd, jed)

!---- make sure the halo size is 1
    if( ied-iec .NE. 1 .OR. isc-isd .NE. 1 .OR. jed-jec .NE. 1 .OR. jsc-jsd .NE. 1 ) &
      call mpp_error(FATAL, "river_mod: halo size in four direction should all be 1")

    nxc = iec - isc + 1; nyc = jec - jsc + 1
    !--- make sure land_lon, land_lat, land_frac is on the compute domain
    if(size(land_lon,1) .NE. nxc .OR. size(land_lon,2) .NE. nyc ) call mpp_error(FATAL, &
        "river_mod: land_lon should be on the compute domain")
    if(size(land_lat,1) .NE. nxc .OR. size(land_lat,2) .NE. nyc ) call mpp_error(FATAL, &
        "river_mod: land_lat should be on the compute domain")
    if(size(land_frac,1) .NE. nxc .OR. size(land_frac,2) .NE. nyc ) call mpp_error(FATAL, &
        "river_mod: land_frac should be on the compute domain")

    allocate(discharge2ocean_next  (isc:iec,jsc:jec            ))
    allocate(discharge2ocean_next_c(isc:iec,jsc:jec,num_species))
    allocate(id_infloc (0:num_species), id_storage(0:num_species))
    allocate(id_inflow (0:num_species), id_outflow(0:num_species))
    allocate(id_dis    (0:num_species), id_lake_outflow (0:num_species))
    allocate(id_removal(0:num_species), id_stordis(0:num_species), id_run_stor(0:num_species))
    allocate(c_name       (0:num_species))
    allocate(if_name      (0:num_species), of_name      (0:num_species))
    allocate(rf_name      (0:num_species), rm_name      (0:num_species))
    allocate(st_name      (0:num_species), sd_name      (0:num_species),  sr_name(0:num_species))
    allocate(lo_name      (0:num_species), do_name      (0:num_species))
    allocate(c_desc       (0:num_species))
    allocate(if_desc      (0:num_species), of_desc      (0:num_species))
    allocate(rf_desc      (0:num_species), rm_desc      (0:num_species))
    allocate(st_desc      (0:num_species), sd_desc      (0:num_species),  sr_desc(0:num_species))
    allocate(lo_desc      (0:num_species), do_desc      (0:num_species))
    allocate(store_units (0:num_species), flux_units  (0:num_species))
    allocate(conc_units  (num_species))
    allocate(source_conc_file(num_species-num_c+1:num_species))
    allocate(source_flux_file(num_species-num_c+1:num_species))
    allocate(source_conc_name(num_species-num_c+1:num_species))
    allocate(source_flux_name(num_species-num_c+1:num_species))

!--- read the data from the file river_src_file -- has all static river network data
    call get_river_data(land_lon, land_lat, land_frac)
    river_land_mask = River%mask

    River%t_ref  = rt_t_ref (1:num_c)
    River%vf_ref = rt_vf_ref(1:num_c)
    River%q10    = rt_q10   (1:num_c)
    River%kinv   = rt_kinv  (1:num_c)
    source_conc_file(num_species-num_c+1:num_species) = rt_source_conc_file(1:num_c)
    source_flux_file(num_species-num_c+1:num_species) = rt_source_flux_file(1:num_c)
    source_conc_name(num_species-num_c+1:num_species) = rt_source_conc_name(1:num_c)
    source_flux_name(num_species-num_c+1:num_species) = rt_source_flux_name(1:num_c)

    c_name(0)='_h2o'
    c_desc(0)='h2o mass'
    c_name(1)='_ice'
    c_desc(1)='ice mass'
    c_name(2)='_hEt'
    c_desc(2)='sen.heat'
    if (do_age) c_name(3)='_age'
    if (do_age) c_desc(3)='mass.age'
    do i_species = num_species-num_c+1, num_species
      c_name(i_species)=trim(rt_c_name(i_species-(num_species-num_c)))
      c_desc(i_species)=c_name(i_species)
      enddo

    conc_units(1)                               = 'kg/kg'
    conc_units(2)                               = '  K  '
    if (do_age) conc_units(3)                   = 'days '
    conc_units(num_species-num_c+1:num_species) = 'kg/kg'   ! check this one

    flux_units(0)                               = 'kg/m2/s'
    flux_units(1)                               = 'kg/m2/s'
    flux_units(2)                               = 'W/m2   '
    if (do_age) flux_units(3)                   = 'kg/m2  '
    flux_units(num_species-num_c+1:num_species) = 'kg/m2/s'

    store_units(0)                              = 'kg/m2  '
    store_units(1)                              = 'kg/m2  '
    store_units(2)                              = 'J/m2   '
    if (do_age) store_units(3)                  = 'kg-s/m2'
    store_units(num_species-num_c+1:num_species)= 'kg/m2  '

    do i_species = 0, num_species
      if_name(i_species)='rv_i'//trim(c_name(i_species))
      of_name(i_species)='rv_o'//trim(c_name(i_species))
      do_name(i_species)='rv_d'//trim(c_name(i_species))
      lo_name(i_species)='rv_l'//trim(c_name(i_species))
      rf_name(i_species)='rv_r'//trim(c_name(i_species))
      rm_name(i_species)='rv_m'//trim(c_name(i_species))
      st_name(i_species)='rv_s'//trim(c_name(i_species))
      sd_name(i_species)='rv_n'//trim(c_name(i_species))
      sr_name(i_species)='rv_u'//trim(c_name(i_species))
      enddo

    do i_species = 0, num_species
      if_desc(i_species)='river inflow, '   //trim(c_desc(i_species))
      of_desc(i_species)='river outflow, '  //trim(c_desc(i_species))
      do_desc(i_species)='ocean discharge,' //trim(c_desc(i_species))
      lo_desc(i_species)='lake outflow, '   //trim(c_desc(i_species))
      rf_desc(i_species)='local runoff, '   //trim(c_desc(i_species))
      rm_desc(i_species)='river removal, '  //trim(c_desc(i_species))
      st_desc(i_species)='river storage '   //trim(c_desc(i_species))
      sd_desc(i_species)='river discharge lag (numerical) storage, ' &
                        //trim(c_desc(i_species))
      sr_desc(i_species)='river runoff lag (numerical) storage, ' &
                        //trim(c_desc(i_species))
      enddo

!--- register diag field
    call river_diag_init (id_lon, id_lat)

!--- read restart file 
    call get_instance_filename('INPUT/river.res.nc', filename)
    call get_mosaic_tile_file(trim(filename), filename, .false., domain)

    if(file_exist(trim(filename),domain) ) then
        call mpp_error(NOTE, 'river_init : Read restart files '//trim(filename))
        call read_data(filename,'storage',          River%storage,          domain)
        call read_data(filename,'storage_c',        River%storage_c,        domain)
        call read_data(filename,'discharge2ocean',  discharge2ocean_next,   domain)
        call read_data(filename,'discharge2ocean_c',discharge2ocean_next_c, domain)
        call read_data(filename,'Omean',            River%outflowmean,      domain)
        if (field_exist(filename,'depth',domain)) then 
             ! call mpp_error(WARNING, 'river_init : Reading field "depth" from '//trim(filename))
             call read_data(filename,'depth',       River%depth,            domain)
        else
             ! call mpp_error(WARNING, 'river_init : "depth" is not present in '//trim(filename))
        endif     
    else
        call mpp_error(NOTE, 'river_init : cold start, set data to 0')
        River%storage    = 0.0
        River%storage_c  = 0.0
        discharge2ocean_next   = 0.0
        discharge2ocean_next_c = 0.0
        if(file_exist(river_Omean_file)) then
           call read_data(river_Omean_file, 'Omean', River%outflowmean, domain)
        else
           River%outflowmean = CONST_OMEAN
        end if
    endif
    River%stordis_c = River%dt_slow * discharge2ocean_next_c/DENS_H2O
    River%stordis   = River%dt_slow *(discharge2ocean_next + &
                                      discharge2ocean_next_c(:,:,1))/DENS_H2O
    where(River%outflowmean .le. outflowmean_min) River%outflowmean=outflowmean_min

    maxtravel = maxval(River%travel)
    call mpp_max(maxtravel)

    call river_physics_init(River, domain, id_lon, id_lat)
    call get_Leo_Mad_params(DHG_exp, DHG_coef, AAS_exp)
    River%o_exp  = 1./ (AAS_exp%on_w + AAS_exp%on_d)
    do j = jsc, jec
       do i = isc, iec
          if ( River%reach_length(i,j) > 0.0) then
              River%o_coef(i,j) = River%outflowmean(i,j) / &
                   ((sinuosity*River%reach_length(i,j))*DHG_coef%on_w*DHG_coef%on_d &
                   *(River%outflowmean(i,j)**(DHG_exp%on_w+DHG_exp%on_d)))**River%o_exp
          endif
       enddo
    enddo
    River%d_exp  = AAS_exp%on_d
    River%d_coef = DHG_coef%on_d                        &
         *(River%outflowmean**(DHG_exp%on_d-AAS_exp%on_d))
    River%w_exp  = AAS_exp%on_w
    River%w_coef = DHG_coef%on_w                        &
         *(River%outflowmean**(DHG_exp%on_w-AAS_exp%on_w))

    num_lake_lev = num_l
    module_is_initialized = .TRUE.

  end subroutine river_init

!#####################################################################
  subroutine update_river ( runoff, runoff_c, discharge2ocean,  &
                                              discharge2ocean_c )
    real, dimension(:,:),   intent(in)  :: runoff
    real, dimension(:,:,:), intent(in)  :: runoff_c
    real, dimension(:,:),   intent(out) :: discharge2ocean
    real, dimension(:,:,:), intent(out) :: discharge2ocean_c

    integer, save :: n = 0  ! fast time step with each slow time step

    call mpp_clock_begin(riverclock)
    if (.not.do_rivers) then
        discharge2ocean = 0; discharge2ocean_c = 0
        call mpp_clock_end(riverclock)  !needed for early exit when do_rivers=.false.
        return
    endif

    discharge2ocean   = discharge2ocean_next
    discharge2ocean_c = discharge2ocean_next_c
! deplete the discharge storage pools
    River%stordis_c = River%stordis_c &
         - River%dt_fast * discharge2ocean_c/DENS_H2O
    River%stordis   = River%stordis   &
         - River%dt_fast *(discharge2ocean + &
                           discharge2ocean_c(:,:,1))/DENS_H2O

!  increment time
    River%Time = increment_time(River%Time, River%dt_fast, 0)
    n = n + 1
!--- accumulate runoff ---------------------
    River%run_stor   = River%run_stor   + runoff
    River%run_stor_c = River%run_stor_c + runoff_c

    if(n == num_fast_calls) then
        call mpp_clock_begin(slowclock)
        call update_river_slow(River%run_stor(:,:)/real(num_fast_calls), &
             River%run_stor_c(:,:,:)/real(num_fast_calls) )
        call mpp_clock_end(slowclock)       
        call mpp_clock_begin(bndslowclock)
        call update_river_bnd_slow
        call mpp_clock_end(bndslowclock)
        n = 0
        River%run_stor = 0
        River%run_stor_c = 0
    endif

    call mpp_clock_end(riverclock)

  end subroutine update_river

!#####################################################################
  subroutine update_river_slow(runoff, runoff_c)
    real, dimension(:,:),   intent(in)  :: runoff
    real, dimension(:,:,:), intent(in)  :: runoff_c

    real, dimension(isd:ied,jsd:jed) :: &
                             lake_sfc_A, lake_sfc_bot, lake_conn
    real, dimension(isd:ied,jsd:jed,num_lake_lev) :: &
                             lake_wl, lake_ws
    real, dimension(isc:iec,jsc:jec) :: &
                             lake_depth_sill, lake_width_sill, lake_backwater, &
			     lake_backwater_1, &
                             lake_whole_area, &
                             rivr_LMASS,       & ! mass of liquid water in rivers in cell
                             rivr_FMASS,       & ! mass of ice in rivers in cell
                             rivr_MELT,        & ! net mass melt in rivers in cell
                             rivr_HEAT           ! sensible heat content of rivers in cell
    real, dimension(isc:iec,jsc:jec,num_lake_lev) :: &
                             lake_T
    integer                             :: travelnow, lev
    type(Leo_Mad_trios)   :: DHG_exp
    type(Leo_Mad_trios)   :: DHG_coef
    type(Leo_Mad_trios)   :: AAS_exp
    integer i,j,k, i_next, j_next
    type(land_tile_enum_type)     :: te,ce ! last and current tile list elements
    type(land_tile_type), pointer :: tile  ! pointer to current tile
    logical :: used

    slow_step = slow_step + 1

    River%infloc   = River%land_area*runoff  /DENS_H2O
    River%infloc_c = 0
    do i_species = 1, River%num_phys
       River%infloc_c(:,:,i_species) = &
            River%land_area*runoff_c(:,:,i_species)/DENS_H2O
    enddo
    if (River%do_age) then
        i_species = 3
        River%infloc_c(:,:,i_species) = &
             River%land_area*runoff_c(:,:,i_species)/DENS_H2O
    endif
    do i_species = num_species-River%num_c+1, num_species  ! create mass flux inputs from c data
       where (River%land_area.gt.0.)  &
            River%infloc_c(:,:,i_species) = &
            River%infloc*River%source_conc(:,:,i_species)  &
            + River%source_flux(:,:,i_species)
    enddo
    River%inflow   = 0
    River%inflow_c = 0
    River%lake_outflow   = 0
    River%lake_outflow_c = 0
    River%disw2o = 0.
    River%disc2o = 0.
    River%melt   = 0.
    lake_sfc_A  = 0
    lake_sfc_bot= 0
    lake_T  = 0
    lake_wl = 0
    lake_ws = 0
    lake_depth_sill  = 0
    lake_width_sill  = 0
    lake_whole_area  = 0
    lake_conn   = 0
    lake_backwater = 0
    lake_backwater_1 = 0
     ce = first_elmt(lnd%tile_map, is=isc, js=jsc)
    te = tail_elmt (lnd%tile_map)
    do while(ce /= te)
       call get_elmt_indices(ce,i,j,k)
       tile=>current_tile(ce)  ! get pointer to current tile
       ce=next_elmt(ce)        ! advance position to the next tile
       if (.not.associated(tile%lake)) cycle
       if (lake_area_bug) then
          lake_sfc_A (i,j) = tile%frac * lnd%cellarea(i,j)
       else
          lake_sfc_A (i,j) = tile%frac * lnd%area(i,j)
       endif
       do lev = 1, num_lake_lev
         lake_T (i,j,lev)   = tile%lake%prog(lev)%T
         lake_wl(i,j,lev)   = tile%lake%prog(lev)%wl
         lake_ws(i,j,lev)   = tile%lake%prog(lev)%ws
         enddo
       lake_sfc_bot(i,j) = (sum(tile%lake%prog(:)%wl+tile%lake%prog(:)%ws) &
                               -tile%lake%prog(1)%wl-tile%lake%prog(1)%ws ) &
                                    / DENS_H2O
       lake_depth_sill(i,j)  = tile%lake%pars%depth_sill
       lake_width_sill(i,j)  = tile%lake%pars%width_sill
       lake_whole_area(i,j)  = tile%lake%pars%whole_area
       lake_conn (i,j)       = tile%lake%pars%connected_to_next
       lake_backwater(i,j)   = tile%lake%pars%backwater
       lake_backwater_1(i,j) = tile%lake%pars%backwater_1
       enddo

call mpp_update_domains (lake_sfc_A,  domain)
call mpp_update_domains (lake_sfc_bot,domain)
call mpp_update_domains (lake_wl, domain)
call mpp_update_domains (lake_ws, domain)
call mpp_update_domains (lake_conn,   domain)
   do i=isc,iec
     do j=jsc,jec
       if (River%i_tocell(i,j) /= NO_RIVER_FLAG) then
          i_next = River%i_tocell(i,j)
          j_next = River%j_tocell(i,j)
       else
          ! to avoid indices out of bounds in the lake_sfc_A check
          i_next = i; j_next=j
       endif
         
       if (lake_backwater(i,j).gt.0.5 .and. lake_sfc_A(i,j).gt.0. .and. &
                                            lake_sfc_A(i_next,j_next).gt.0. ) then
        ! because of river backwater, lake in this cell relaxes toward level of
        ! lake in next cell downstream. (river depth is still simple function
        ! of discharge though.)
         lake_depth_sill(i,j) = lake_sfc_bot(i_next,j_next) &
            +(lake_wl(i_next,j_next,1)+lake_ws(i_next,j_next,1))/DENS_H2O
       elseif (lake_backwater_1(i,j).gt.0.5) then
        ! to determine depth of backwater, lake at coastal cell has base level
        ! set to river depth in same cell
         lake_depth_sill(i,j) = lake_depth_sill(i,j) + River%depth(i,j)
       elseif (lake_conn(i,j).gt.0.5 ) then
        ! for all but furthest dowstream cell of a multi-cell lake, 
        ! relax toward level in next cell (same lake) downstream
         if (lake_conn(i_next,j_next).gt.0.5 .or. all_big_outlet_ctn0) then
             lake_depth_sill(i,j) = lake_sfc_bot(i_next,j_next) &
              +(lake_wl(i_next,j_next,1)+lake_ws(i_next,j_next,1))/DENS_H2O
         endif
       elseif (river_impedes_lake) then
         if (lake_width_sill(i,j).lt.0..or.river_impedes_large_lake) then
             ! lake level in cell relaxes toward river level in cell
             lake_depth_sill(i,j) = lake_depth_sill(i,j) + River%depth(i,j)
         endif
       endif
     enddo
   enddo

! leftovers from horizontal mixing option, now gone
!call mpp_update_domains (lake_T,  domain)
!call mpp_update_domains (lake_depth_sill, domain)
!call mpp_update_domains (lake_tau, domain)

    travelnow = maxtravel
    do travelnow = maxtravel, 0, -1
       call mpp_clock_begin(physicsclock)
!***************************************************************
       call river_physics_step (River, travelnow, &
         lake_sfc_A, lake_sfc_bot, lake_depth_sill, &
         lake_width_sill, lake_whole_area,         &
         lake_T, lake_wl, lake_ws )
!***************************************************************
       call mpp_clock_end(physicsclock)
    enddo
    ce = first_elmt(lnd%tile_map, is=isc, js=jsc)
    te = tail_elmt (lnd%tile_map)
    do while(ce /= te)
       call get_elmt_indices(ce,i,j,k)
       tile=>current_tile(ce)  ! get pointer to current tile
       ce=next_elmt(ce)        ! advance position to the next tile
       if (.not.associated(tile%lake)) cycle
       do lev = 1, num_lake_lev
         tile%lake%prog(lev)%T  = lake_T (i,j,lev)
         tile%lake%prog(lev)%wl = lake_wl(i,j,lev)
         tile%lake%prog(lev)%ws = lake_ws(i,j,lev)
         enddo
       enddo

    River%outflowmean = River%outflowmean + &
       (River%outflow-River%outflowmean)*River%dt_slow/River%channel_tau
    where(River%outflowmean .le. outflowmean_min) River%outflowmean=outflowmean_min
    call get_Leo_Mad_params(DHG_exp, DHG_coef, AAS_exp)
    do j = jsc, jec
       do i = isc, iec
          if ( River%reach_length(i,j) > 0.0) then
              River%o_coef(i,j) = River%outflowmean(i,j) / &
                   ((sinuosity*River%reach_length(i,j))*DHG_coef%on_w*DHG_coef%on_d &
                   *(River%outflowmean(i,j)**(DHG_exp%on_w+DHG_exp%on_d)))**River%o_exp
          endif
       enddo
    enddo
    River%d_coef = DHG_coef%on_d                        &
         *(River%outflowmean**(DHG_exp%on_d-AAS_exp%on_d))
    River%w_coef = DHG_coef%on_w                        &
         *(River%outflowmean**(DHG_exp%on_w-AAS_exp%on_w))

    River%stordis = River%dt_slow*River%disw2o
    do i_species = 1, num_species
      River%stordis_c(:,:,i_species) = River%dt_slow*River%disc2o(:,:,i_species)
      enddo

    rivr_FMASS = DENS_H2O * (River%storage_c(:,:,1) + River%stordis_c(:,:,1))
    rivr_LMASS = DENS_H2O * (River%storage + River%stordis) - rivr_FMASS
    rivr_MELT  = DENS_H2O *  River%melt / River%dt_slow
    rivr_HEAT  = DENS_H2O * (River%storage_c(:,:,2) + River%stordis_c(:,:,2)) &
                      - hlf*rivr_FMASS

    call mpp_clock_begin(diagclock)
  ! convert area-integrated river outputs to unit-area quantities,
  ! using land area for stores, cell area for fluxes to ocean
    if (id_LWSr > 0) then
       where (lnd%area > 0) &
            rivr_LMASS = rivr_LMASS / lnd%area
       used = send_data (id_LWSr, rivr_LMASS, River%time, mask=lnd%area>0) 
    endif
    if (id_FWSr > 0) then   
       where (lnd%area > 0) &
            rivr_FMASS = rivr_FMASS / lnd%area
       used = send_data (id_FWSr, rivr_FMASS, River%time, mask=lnd%area>0) 
    endif
    if (id_HSr > 0) then
       where (lnd%area > 0) &
            rivr_HEAT = rivr_HEAT / lnd%area
       used = send_data (id_HSr, rivr_HEAT, River%time, mask=lnd%area>0) 
    endif
    if (id_meltr > 0) then
       where (lnd%area > 0) &
            rivr_MELT = rivr_MELT / lnd%area
       used = send_data (id_meltr, rivr_MELT, River%time, mask=lnd%area>0) 
    end if
    if(mod(slow_step, diag_freq) == 0)  call river_diag(lake_depth_sill)
    call mpp_clock_end(diagclock)

  end subroutine update_river_slow

!#####################################################################

  subroutine update_river_bnd_slow

! note that land_area is not the total area of the cell, but just the land area
! within the cell, so it cannot be used to normalize fluxes to all-ocean cells.
! we need a true cell area for normalization, so river will
! just return mass flux per unit time and let land_model divide by area
    discharge2ocean_next = DENS_H2O*(River%disw2o - River%disc2o(:,:,1))

    do i_species = 1, num_species
       discharge2ocean_next_c(:,:,i_species) = DENS_H2O*River%disc2o(:,:,i_species)
    enddo

  end subroutine update_river_bnd_slow

!#####################################################################

  subroutine river_end
    integer :: outunit ! unit number for stdout

    if(.not.do_rivers) return ! do nothing further if rivers are turned off

!--- write out checksum
    outunit=stdout()
    write(outunit,*)"Chksum for storage ==> ", mpp_chksum(River%storage(isc:iec,jsc:jec))
    write(outunit,*)"Chksum for storage_c ==> ", mpp_chksum(River%storage_c(isc:iec,jsc:jec,:))
    write(outunit,*)"Chksum for discharge2ocean_next ==> ", mpp_chksum(discharge2ocean_next(isc:iec,jsc:jec))
    write(outunit,*)"Chksum for discharge2ocean_next_c ==> ", mpp_chksum(discharge2ocean_next_c(isc:iec,jsc:jec,:))

!--- release memory
    deallocate(discharge2ocean_next, discharge2ocean_next_c,&
         River%run_stor, River%run_stor_c)

    deallocate( River%lon, River%lat)
    deallocate(River%land_area ,     River%basinid        )
    deallocate(River%landfrac )
    deallocate(River%tocell )
    deallocate(River%travel )
    deallocate(River%outflow  )
    deallocate(River%inflow  )
    deallocate(River%lake_outflow)
    deallocate(River%lake_outflow_c)
    deallocate(River%storage        )
    deallocate(River%stordis        )
    deallocate(River%melt           )
    deallocate(River%disw2o        )
    deallocate(River%disc2o        )
    deallocate(River%infloc   )
    deallocate(River%reach_length    )
    deallocate(River%mask        )
    deallocate(River%So        )
    deallocate(River%depth     )
    deallocate(River%width     )
    deallocate(River%vel       )
    deallocate(River%infloc_c ,     River%storage_c ,     River%stordis_c    )
    deallocate(River%inflow_c, River%outflow_c )
    deallocate(River%removal_c )
    deallocate(River%vf_ref,River%t_ref,River%q10,River%kinv)
    deallocate(River%d_coef,River%o_coef,River%w_coef)

    module_is_initialized = .FALSE.

  end subroutine river_end


!#####################################################################
  !--- write to restart file
  subroutine save_river_restart(timestamp)
    character(*), intent(in) :: timestamp

    character(len=128) :: filename

    if(.not.do_rivers) return ! do nothing further if rivers are turned off

    filename = 'RESTART/'//trim(timestamp)//'river.res.nc'

    call write_data(filename,'storage', River%storage(isc:iec,jsc:jec), domain)
    call write_data(filename,'storage_c', River%storage_c(isc:iec,jsc:jec,:), domain)

    !--- write out discharge data
    call write_data(filename,'discharge2ocean'  ,discharge2ocean_next  (isc:iec,jsc:jec),   domain)
    call write_data(filename,'discharge2ocean_c',discharge2ocean_next_c(isc:iec,jsc:jec,:), domain)
    call write_data(filename,'Omean',            River%outflowmean,                         domain)
    call write_data(filename,'depth', River%depth, domain)
  
  end subroutine save_river_restart
  
!#####################################################################
  subroutine get_river_data(land_lon, land_lat, land_frac)
    real,            intent(in) :: land_lon(isc:,jsc:)  ! geographical lontitude of cell center
    real,            intent(in) :: land_lat(isc:,jsc:)  ! geographical lattitude of cell center
    real,            intent(in) :: land_frac(isc:,jsc:) ! land area fraction of land grid.

    integer                           :: ni, nj, i, j, siz(4), ntiles
    real, dimension(:,:), allocatable :: xt, yt, frac, glon, glat, lake_frac
    integer :: nerrors ! number of errors detected during initialization

    ntiles = mpp_get_ntile_count(domain)

    call field_size(river_src_file, 'basin', siz, domain=domain)
    ni = siz(1)
    nj = siz(2)
    if(ni .NE. River%nlon .OR. nj .NE. River%nlat) call mpp_error(FATAL, &
       "river_mod: size mismatch between river grid and land grid")

    allocate(glon(ni,nj), glat(ni, nj))
    allocate(xt(isc:iec, jsc:jec), yt(isc:iec, jsc:jec), frac(isc:iec, jsc:jec) )
    allocate(lake_frac(isc:iec, jsc:jec))

    if (ntiles == 1) then
        call read_data(river_src_file, 'x', glon, no_domain=.true.)
        call read_data(river_src_file, 'y', glat, no_domain=.true.)
      endif
    call read_data(river_src_file, 'x', xt, domain)
    call read_data(river_src_file, 'y', yt, domain) 
    call read_data(river_src_file, 'land_frac', frac, domain) 
    call read_data(river_src_file, 'lake_frac', lake_frac, domain) 
    !--- the following will be changed when the river data sets is finalized. 
    xt = land_lon
    yt = land_lat
!--- transform to radians, since land model grid use radians and compare with land grid.

    allocate(River%lon_1d    (1:ni            ) )
    allocate(River%lat_1d    (1:nj            ) )
    allocate(River%lon       (isc:iec, jsc:jec) )
    allocate(River%lat       (isc:iec, jsc:jec) )
    allocate(River%land_area  (isc:iec, jsc:jec) )     
    allocate(River%basinid   (isc:iec, jsc:jec) )
    allocate(River%landfrac  (isc:iec, jsc:jec) )
    allocate(River%mask      (isc:iec, jsc:jec) )
    allocate(River%tocell    (isc:iec, jsc:jec) )
    allocate(River%i_tocell  (isc:iec, jsc:jec) )
    allocate(River%j_tocell  (isc:iec, jsc:jec) )
    allocate(River%travel    (isd:ied, jsd:jed) )
    allocate(River%inflow    (isc:iec, jsc:jec) )
    allocate(River%outflow   (isc:iec, jsc:jec) )
    allocate(River%lake_outflow(isc:iec, jsc:jec) )
    allocate(River%storage   (isc:iec, jsc:jec) )
    allocate(River%stordis   (isc:iec, jsc:jec) )
    allocate(River%run_stor   (isc:iec, jsc:jec) )
    allocate(River%melt      (isc:iec, jsc:jec) )
    allocate(River%disw2o    (isc:iec, jsc:jec) )
    allocate(River%infloc    (isc:iec, jsc:jec))
    allocate(River%reach_length(isc:iec, jsc:jec) )
    allocate(River%So        (isc:iec, jsc:jec) )
    allocate(River%depth     (isc:iec, jsc:jec) )
    allocate(River%width    (isc:iec, jsc:jec) )
    allocate(River%vel      (isc:iec, jsc:jec) )
    allocate(River%infloc_c  (isc:iec, jsc:jec, num_species) )
    allocate(River%storage_c (isc:iec, jsc:jec, num_species) )
    allocate(River%stordis_c (isc:iec, jsc:jec, num_species) )
    allocate(River%run_stor_c (isc:iec, jsc:jec, num_species) )
    allocate(River%outflow_c (isc:iec, jsc:jec, num_species) )
    allocate(River%lake_outflow_c (isc:iec, jsc:jec, num_species) )
    allocate(River%removal_c (isc:iec, jsc:jec, num_species) )
    allocate(River%inflow_c  (isc:iec, jsc:jec, num_species) )
    allocate(River%disc2o    (isc:iec, jsc:jec, num_species))
    allocate(River%d_coef    (isc:iec, jsc:jec) )
    allocate(River%o_coef    (isc:iec, jsc:jec) )
    allocate(River%w_coef    (isc:iec, jsc:jec) )
    allocate(River%outflowmean(isc:iec, jsc:jec) )
    allocate(River%t_ref(4:num_species),River%vf_ref(4:num_species))
    allocate(River%q10  (4:num_species),River%kinv  (4:num_species))
    allocate(River%source_conc(isc:iec, jsc:jec,num_species-num_c+1:num_species))
    allocate(River%source_flux(isc:iec, jsc:jec,num_species-num_c+1:num_species))

    if(ntiles == 1) then   ! lat-lon grid, use actual grid location
       River%lon_1d(:)      = glon(:,1)
       River%lat_1d(:)      = glat(1,:)
    else                   ! cubic grid, use index.
       River%lon_1d(:)      = (/ (i, i=1,River%nlon) /)
       River%lat_1d(:)      = (/ (i, i=1,River%nlat) /)
    end if
    deallocate(glon, glat)

    River%lon(:,:)       = land_lon(:,:)
    River%lat(:,:)       = land_lat(:,:)
!!$    River%landfrac(:,:)  = land_frac(:,:)
    River%landfrac(:,:)  = frac(:,:)
    River%infloc    = 0.0
    River%infloc_c  = 0.0
    River%storage   = 0.0
    River%storage_c = 0.0
    River%stordis   = 0.0
    River%run_stor  = 0.0
    River%stordis_c = 0.0
    River%run_stor_c= 0.0
    River%removal_c = 0.0
    River%depth     = 0.
    River%width     = 0.
    River%vel       = 0.
    River%outflow   = 0.
    River%outflow_c = 0.
    River%inflow    = 0.
    River%inflow_c  = 0.
!--- read the data from the source file
    call read_data(river_src_file, 'tocell', River%tocell, domain) 

    where (River%tocell(:,:).eq.  4) River%tocell(:,:)=3
    where (River%tocell(:,:).eq.  8) River%tocell(:,:)=4
    where (River%tocell(:,:).eq. 16) River%tocell(:,:)=5
    where (River%tocell(:,:).eq. 32) River%tocell(:,:)=6
    where (River%tocell(:,:).eq. 64) River%tocell(:,:)=7
    where (River%tocell(:,:).eq.128) River%tocell(:,:)=8
    
    nerrors = 0
    do j = jsc, jec
    do i = isc, iec
!!$          if(abs(xt(i,j) - land_lon(i,j)) > epsln) call mpp_error(FATAL, &
!!$             "get_river_data: longitude mismatch between river grid and land grid")
!!$          if(abs(yt(i,j) - land_lat(i,j)) > epsln) call mpp_error(FATAL, &
!!$             "get_river_data: latitude mismatch between river grid and land grid")
!!$          if(abs(frac(i,j) - land_frac(i,j)) > epsln) call mpp_error(FATAL, &
!!$             "get_river_data: area fraction mismatch between river grid and land grid")

       ! check that river and land masks match
       if ((frac(i,j)>0).neqv.(land_frac(i,j)>0)) then
          call mpp_error(WARNING,'get_river_data: land and river masks do not match at '//&
               trim(coordinates(i,j)))
          nerrors = nerrors+1
       endif

       ! check that the rivers do not discarge in the middle of the continents
       if ((River%tocell(i,j)==0).and.(land_frac(i,j)>1.0-epsln)) then
          call mpp_error(WARNING, &
               'get_river_data: river discharges into a land point '&
               //trim(coordinates(i,j))//' where there is no ocean')
          nerrors = nerrors+1
       endif    
    end do
    end do
    
    if (nerrors>0.and.stop_on_mask_mismatch) call mpp_error(FATAL,& 
        'get_river_data: river/land mask-related mismatch detected during river data initialization')

    call read_data(river_src_file, 'basin', River%basinid, domain)
    where (River%basinid >0)
       River%mask = .true.
    elsewhere
       River%mask = .false.
    endwhere

    River%travel = 0
    call read_data(river_src_file, 'travel', River%travel(isc:iec,jsc:jec), domain)
    call mpp_update_domains(River%travel, domain) 
    call read_data(river_src_file, 'celllength', River%reach_length, domain) 
    River%reach_length = River%reach_length * River%landfrac * (1.-lake_frac)
    if (land_area_called_cellarea) then
        call read_data(river_src_file, 'cellarea', River%land_area, domain) 
      else
        call read_data(river_src_file, 'land_area', River%land_area, domain) 
      endif
!    call read_data(river_src_file, 'So', River%So, domain) 
    River%So = 0.0
    where (River%So .LT. 0.0) River%So = Somin

    do i_species = num_species-num_c+1, num_species
       if (trim(source_conc_file(i_species)).eq.'') then
           River%source_conc(:,:,i_species)=0
           if (trim(source_conc_name(i_species)).eq.'one') River%source_conc(:,:,i_species)=1
       else if (trim(source_conc_name(i_species)).ne.'') then
           call read_data(trim(source_conc_file(i_species)), trim(source_conc_name(i_species)), &
                River%source_conc(:,:,i_species), no_domain=.true.)
       else
           River%source_conc(:,:,i_species) = 0
       endif
       if (trim(source_flux_file(i_species)).eq.'') then
           River%source_flux(:,:,i_species)=0
           if (trim(source_flux_name(i_species)).eq.'one') River%source_flux(:,:,i_species)=1
       else if (trim(source_flux_name(i_species)).ne.'') then
           call read_data(trim(source_flux_file(i_species)), &
                trim(source_flux_name(i_species)), &
                River%source_flux(:,:,i_species), no_domain=.true.)
       else
           River%source_flux(:,:,i_species) = 0
       endif
    enddo

    River%source_conc = max(River%source_conc, 0.)
    River%source_flux = max(River%source_flux, 0.)
    
    deallocate(lake_frac)

  end subroutine get_river_data

!#####################################################################

  subroutine river_diag_init(id_lon, id_lat)
    integer, intent(in) :: id_lon  ! ID of land longitude (X) diag axis
    integer, intent(in) :: id_lat  ! ID of land latitude (Y) diag axis

    character(len=11)                :: mod_name = 'river'
    real, dimension(isc:iec,jsc:jec) :: tmp
    logical                          :: sent
    integer                          :: i

! regular diagnostic fields
    do i_species = 0, num_species
      id_inflow(i_species) = register_diag_field ( mod_name, if_name(i_species),       &
           (/id_lon, id_lat/), River%Time, if_desc(i_species), flux_units(i_species),    &
           missing_value=missing )
      id_outflow(i_species) = register_diag_field ( mod_name, of_name(i_species),      &
           (/id_lon, id_lat/), River%Time, of_desc(i_species), flux_units(i_species),    &
           missing_value=missing )
      id_dis(i_species)     = register_diag_field ( mod_name, do_name(i_species),       &
           (/id_lon, id_lat/), River%Time, do_desc(i_species), flux_units(i_species), &
           missing_value=missing )
      id_lake_outflow(i_species) = register_diag_field ( mod_name, lo_name(i_species),     &
           (/id_lon, id_lat/), River%Time, lo_desc(i_species), flux_units(i_species),    &
           missing_value=missing )
      id_infloc(i_species) = register_diag_field ( mod_name, rf_name(i_species),     &
           (/id_lon, id_lat/), River%Time, rf_desc(i_species), flux_units(i_species),    &
           missing_value=missing )
      id_removal(i_species) = register_diag_field ( mod_name, rm_name(i_species),     &
           (/id_lon, id_lat/), River%Time, rm_desc(i_species), flux_units(i_species),    &
           missing_value=missing )
      id_storage(i_species) = register_diag_field ( mod_name, st_name(i_species),     &
           (/id_lon, id_lat/), River%Time, st_desc(i_species), store_units(i_species),    &
           missing_value=missing )
      id_stordis(i_species) = register_diag_field ( mod_name, sd_name(i_species),     &
           (/id_lon, id_lat/), River%Time, sd_desc(i_species), store_units(i_species),    &
           missing_value=missing )
      id_run_stor(i_species) = register_diag_field ( mod_name, sr_name(i_species),     &
           (/id_lon, id_lat/), River%Time, sr_desc(i_species), store_units(i_species),    &
           missing_value=missing )
      enddo

    id_lake_depth_sill= register_diag_field ( mod_name, 'rv_dsill', (/id_lon, id_lat/), &
         River%Time, 'effective lake sill depth', 'm', missing_value=missing )
    id_outflowmean   = register_diag_field ( mod_name, 'rv_Qavg', (/id_lon, id_lat/), &
         River%Time, 'long-time average vol. flow', 'm3/s', missing_value=missing )
    id_depth     = register_diag_field ( mod_name, 'rv_depth', (/id_lon, id_lat/), &
         River%Time, 'river flow depth', 'm', missing_value=missing )
    id_width     = register_diag_field ( mod_name, 'rv_width', (/id_lon, id_lat/), &
         River%Time, 'river flow width', 'm', missing_value=missing )
    id_vel       = register_diag_field ( mod_name, 'rv_veloc', (/id_lon, id_lat/), &
         River%Time, 'river flow velocity', 'm/s', missing_value=missing )

  id_storage_old=register_diag_field(mod_name,'storage',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_s_h2o instead', store_units(0),missing_value=missing )
  id_stordis_old=register_diag_field(mod_name,'stordis',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_s_h2o instead', store_units(0),missing_value=missing )
  id_s_frazil=register_diag_field(mod_name,'s_frazil',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_s_ice instead', store_units(1),missing_value=missing )
  id_s_t_rivr=register_diag_field(mod_name,'s_t_rivr',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_s_hEt instead', store_units(2),missing_value=missing )
  id_infloc_old=register_diag_field(mod_name,'infloc',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_r_h2o instead', flux_units(0),missing_value=missing )
  id_r_frazil=register_diag_field(mod_name,'r_frazil',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_r_ice instead', flux_units(1),missing_value=missing )
  id_r_t_rivr=register_diag_field(mod_name,'r_t_rivr',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_r_hEt instead', flux_units(2),missing_value=missing )
  id_inflow_old=register_diag_field(mod_name,'inflow',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_r_h2o instead', flux_units(0),missing_value=missing )
  id_i_frazil=register_diag_field(mod_name,'i_frazil',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_r_ice instead', flux_units(1),missing_value=missing )
  id_i_t_rivr=register_diag_field(mod_name,'i_t_rivr',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_r_hEt instead', flux_units(2),missing_value=missing )
  id_outflow_old=register_diag_field(mod_name,'outflow',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_o_h2o instead', flux_units(0),missing_value=missing )
  id_o_frazil=register_diag_field(mod_name,'o_frazil',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_o_ice instead', flux_units(1),missing_value=missing )
  id_o_t_rivr=register_diag_field(mod_name,'o_t_rivr',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_o_hEt instead', flux_units(2),missing_value=missing )
  id_lake_outflow_old=register_diag_field(mod_name,'lake_outflow',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_l_h2o instead', flux_units(0),missing_value=missing )
  id_lofrazil=register_diag_field(mod_name,'lofrazil',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_l_ice instead', flux_units(1),missing_value=missing )
  id_lot_rivr=register_diag_field(mod_name,'lot_rivr',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_l_hEt instead', flux_units(2),missing_value=missing )
  id_disw2o_old=register_diag_field(mod_name,'disw2o',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_d_h2o instead', flux_units(0),missing_value=missing )
  id_dofrazil=register_diag_field(mod_name,'dofrazil',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_d_ice instead', flux_units(1),missing_value=missing )
  id_dot_rivr=register_diag_field(mod_name,'dot_rivr',(/id_lon, id_lat/), River%Time, &
      'obsolete, pls use rv_d_hEt instead', flux_units(2),missing_value=missing )

  id_outflowmean_old   = register_diag_field ( mod_name, 'flowmean', (/id_lon, id_lat/), &
       River%Time, 'obsolete, pls use rv_Qavg', 'm3/s', missing_value=missing )
  id_depth_old     = register_diag_field ( mod_name, 'depth', (/id_lon, id_lat/), &
       River%Time, 'obsolete, pls use rv_depth', 'm', missing_value=missing )
  id_width_old     = register_diag_field ( mod_name, 'width', (/id_lon, id_lat/), &
       River%Time, 'obsolete, pls use rv_width', 'm', missing_value=missing )
  id_vel_old       = register_diag_field ( mod_name, 'vel', (/id_lon, id_lat/), &
       River%Time, 'obsolete, pls use rv_veloc', 'm/s', missing_value=missing )

  ! fields that historically were in the the land_model.F90. They are registered
  ! for module 'land' to preserve compatibility with older diag tables
  id_LWSr   = register_diag_field ( 'land', 'LWSr', (/id_lon, id_lat/), &
       River%Time, 'river liquid mass storage', 'kg/m2', missing_value=-1.0e+20 )
  id_FWSr   = register_diag_field ( 'land', 'FWSr', (/id_lon, id_lat/), &
       River%Time, 'river ice mass storage', 'kg/m2', missing_value=-1.0e+20 )
  id_HSr   = register_diag_field ( 'land', 'HSr', (/id_lon, id_lat/), &
       River%Time, 'river heat storage', 'J/m2', missing_value=-1.0e+20 )
  id_meltr   = register_diag_field ( 'land', 'meltr', (/id_lon, id_lat/), &
       River%Time, 'melt in river system', 'kg/m2/s', missing_value=-1.0e+20 )

! static fields
    id_dx = register_static_field ( mod_name, 'rv_length', (/id_lon, id_lat/), &
         'river reach length', 'm', missing_value=missing )
    id_basin = register_static_field ( mod_name, 'rv_basin', (/id_lon, id_lat/), &
         'river basin id', 'none', missing_value=missing )
    id_So = register_static_field ( mod_name, 'So', (/id_lon, id_lat/), &
         'Slope', 'none', missing_value=missing )
    id_travel = register_static_field ( mod_name, 'rv_trav', (/id_lon, id_lat/), &
         'cells left to travel before reaching ocean', 'none', missing_value=missing )
    id_tocell = register_static_field ( mod_name, 'rv_dir', (/id_lon, id_lat/), &
         'outflow direction code', 'none', missing_value=missing )

    if (id_dx>0) sent=send_data(id_dx, River%reach_length, River%Time, mask=River%mask )
    if (id_basin>0) then
        tmp = River%basinid(isc:iec,jsc:jec)
        sent=send_data(id_basin, tmp, River%Time, mask=River%mask )
      end if
    if (id_So>0) sent=send_data(id_So, River%So, River%Time, mask=River%mask )
    if (id_travel>0) then
        tmp = River%travel(isc:iec,jsc:jec)
        sent=send_data(id_travel, tmp, River%Time, mask=River%mask )
      end if
    if (id_tocell>0) then
        tmp = River%tocell(isc:iec,jsc:jec)
        sent=send_data(id_tocell, tmp, River%Time, mask=River%mask )
      end if

  end subroutine river_diag_init

!#####################################################################

  subroutine river_diag(lake_depth_sill)
    real, dimension(isc:iec,jsc:jec), intent(in) :: lake_depth_sill
    logical :: used   ! logical for send_data
    real diag_factor  (isc:iec,jsc:jec)
    real diag_factor_2(isc:iec,jsc:jec)

    diag_factor = 0.
    diag_factor_2 = 0.
    where (River%land_area(isc:iec,jsc:jec).gt.0.) &
                     diag_factor=DENS_H2O/River%land_area(isc:iec,jsc:jec)
    where (River%land_area(isc:iec,jsc:jec).gt.0.) &
                     diag_factor_2=1./(River%land_area(isc:iec,jsc:jec)*River%dt_slow)

    if (id_inflow(0) > 0) used = send_data (id_inflow(0), &
            diag_factor*River%inflow(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_outflow(0) > 0) used = send_data (id_outflow(0), &
            diag_factor*River%outflow(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_storage(0) > 0) used = send_data (id_storage(0), &
            diag_factor*River%storage(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_stordis(0) > 0) used = send_data (id_stordis(0), &
            diag_factor*River%stordis(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_run_stor(0) > 0) used = send_data (id_run_stor(0), &
            River%dt_fast*River%run_stor(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_infloc(0) > 0) used = send_data (id_infloc(0), &
            diag_factor*River%infloc(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_dis(0) > 0)    used = send_data (id_dis(0), &
            diag_factor*River%disw2o(isc:iec,jsc:jec), River%Time)
    if (id_lake_outflow(0) > 0) used = send_data (id_lake_outflow(0), &
            diag_factor_2*River%lake_outflow(isc:iec,jsc:jec), River%Time, mask=River%mask )

    if (id_storage_old > 0) used = send_data (id_storage_old, &
            diag_factor*River%storage(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_stordis_old > 0) used = send_data (id_stordis_old, &
            diag_factor*River%stordis(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_infloc_old > 0) used = send_data (id_infloc_old, &
            diag_factor*River%infloc(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_inflow_old > 0) used = send_data (id_inflow_old, &
            diag_factor*River%inflow(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_outflow_old > 0) used = send_data (id_outflow_old, &
            diag_factor*River%outflow(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_lake_outflow_old > 0) used = send_data (id_lake_outflow_old, &
            diag_factor_2*River%lake_outflow(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_disw2o_old > 0)    used = send_data (id_disw2o_old, &
            diag_factor*River%disw2o(isc:iec,jsc:jec), River%Time)
    if (id_s_frazil > 0) used = send_data (id_s_frazil, &
            diag_factor*River%storage_c(isc:iec,jsc:jec,1), River%Time, mask=River%mask )
    if (id_r_frazil > 0) used = send_data (id_r_frazil, &
            diag_factor*River%infloc_c(isc:iec,jsc:jec,1), River%Time, mask=River%mask )
    if (id_i_frazil > 0) used = send_data (id_i_frazil, &
            diag_factor*River%inflow_c(isc:iec,jsc:jec,1), River%Time, mask=River%mask )
    if (id_o_frazil > 0) used = send_data (id_o_frazil, &
            diag_factor*River%outflow_c(isc:iec,jsc:jec,1), River%Time, mask=River%mask )
    if (id_lofrazil > 0) used = send_data (id_lofrazil, &
            diag_factor_2*River%lake_outflow_c(isc:iec,jsc:jec,1), River%Time, mask=River%mask )
    if (id_dofrazil > 0)    used = send_data (id_dofrazil, &
            diag_factor*River%disc2o(isc:iec,jsc:jec,1), River%Time)
    if (id_s_t_rivr > 0) used = send_data (id_s_t_rivr, &
            diag_factor*River%storage_c(isc:iec,jsc:jec,2), River%Time, mask=River%mask )
    if (id_r_t_rivr > 0) used = send_data (id_r_t_rivr, &
            diag_factor*River%infloc_c(isc:iec,jsc:jec,2), River%Time, mask=River%mask )
    if (id_i_t_rivr > 0) used = send_data (id_i_t_rivr, &
            diag_factor*River%inflow_c(isc:iec,jsc:jec,2), River%Time, mask=River%mask )
    if (id_o_t_rivr > 0) used = send_data (id_o_t_rivr, &
            diag_factor*River%outflow_c(isc:iec,jsc:jec,2), River%Time, mask=River%mask )
    if (id_lot_rivr > 0) used = send_data (id_lot_rivr, &
            diag_factor_2*River%lake_outflow_c(isc:iec,jsc:jec,2), River%Time, mask=River%mask )
    if (id_dot_rivr > 0)    used = send_data (id_dot_rivr, &
            diag_factor*River%disc2o(isc:iec,jsc:jec,2), River%Time)

    do i_species = 1, num_species
      if (id_outflow(i_species) > 0) used = send_data (id_outflow(i_species), &
        diag_factor*River%outflow_c(isc:iec,jsc:jec,i_species), River%Time, mask=River%mask )
      if (id_lake_outflow(i_species) > 0) used = send_data (id_lake_outflow(i_species), &
        diag_factor_2*River%lake_outflow_c(isc:iec,jsc:jec,i_species), River%Time, mask=River%mask )
      if (id_inflow(i_species) > 0) used = send_data (id_inflow(i_species), &
        diag_factor*River%inflow_c(isc:iec,jsc:jec,i_species), River%Time, mask=River%mask )
      if (id_storage(i_species) > 0) used = send_data (id_storage(i_species), &
        diag_factor*River%storage_c(isc:iec,jsc:jec,i_species), River%Time, mask=River%mask )
      if (id_stordis(i_species) > 0) used = send_data (id_stordis(i_species), &
        diag_factor*River%stordis_c(isc:iec,jsc:jec,i_species), River%Time, mask=River%mask )
      if (id_run_stor(i_species) > 0) used = send_data (id_run_stor(i_species), &
        River%dt_fast*River%run_stor_c(isc:iec,jsc:jec,i_species), River%Time, mask=River%mask )
      if (id_infloc(i_species) > 0) used = send_data (id_infloc(i_species), &
        diag_factor*River%infloc_c(isc:iec,jsc:jec,i_species), River%Time, mask=River%mask )
      if (id_removal(i_species) > 0) used = send_data (id_removal(i_species), &
        diag_factor*River%removal_c(isc:iec,jsc:jec,i_species), River%Time, mask=River%mask )
      if (id_dis(i_species) > 0)    used = send_data (id_dis(i_species), &
        diag_factor*River%disc2o(isc:iec,jsc:jec,i_species), River%Time)
      enddo

    if (id_lake_depth_sill > 0) used = send_data (id_lake_depth_sill, &
            lake_depth_sill, River%Time, mask=River%mask )
    if (id_outflowmean > 0) used = send_data (id_outflowmean, &
            River%outflowmean(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_width > 0) used = send_data (id_width, &
            River%width(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_depth > 0) used = send_data (id_depth, &
            River%depth(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_vel > 0) used = send_data (id_vel, &
            River%vel(isc:iec,jsc:jec), River%Time, mask=River%mask )

    if (id_outflowmean_old > 0) used = send_data (id_outflowmean_old, &
            River%outflowmean(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_width_old > 0) used = send_data (id_width_old, &
            River%width(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_depth_old > 0) used = send_data (id_depth_old, &
            River%depth(isc:iec,jsc:jec), River%Time, mask=River%mask )
    if (id_vel_old > 0) used = send_data (id_vel_old, &
            River%vel(isc:iec,jsc:jec), River%Time, mask=River%mask )

  end subroutine river_diag

!#####################################################################

  subroutine get_Leo_Mad_params(DHG_exp, DHG_coef, AAS_exp)

    type(Leo_Mad_trios), intent(inout) :: DHG_exp  ! Exponents for downstream equations
    type(Leo_Mad_trios), intent(inout) :: DHG_coef ! Coefficients for downstream equations
    type(Leo_Mad_trios), intent(inout) :: AAS_exp  ! Exponents for at-a-station equations

!!! Exponents for the downstream hydraulic geometry equations
    DHG_exp%on_w = ave_DHG_exp(1) 
    DHG_exp%on_d = ave_DHG_exp(2)
    DHG_exp%on_V = ave_DHG_exp(3)

!!! Coefficients for the downstream hydraulic geometry equations
    DHG_coef%on_w = ave_DHG_coef(1)
    DHG_coef%on_d = ave_DHG_coef(2)
    DHG_coef%on_V = ave_DHG_coef(3)

!!! Exponents for the at-a-station hydraulic geometry equations
    AAS_exp%on_w = ave_AAS_exp(1)
    AAS_exp%on_d = ave_AAS_exp(2)
    AAS_exp%on_V = ave_AAS_exp(3)

  end subroutine get_Leo_Mad_params

!#####################################################################

subroutine river_stock_pe(index, value)
integer, intent(in)  :: index
real   , intent(out) :: value ! Domain water (Kg) or heat (Joules)

value = 0.0
if (.not.do_rivers) return

select case(index)
case(ISTOCK_WATER)
  value = DENS_H2O*(sum(River%storage)+sum(River%stordis)) &
        + sum(River%run_stor*River%land_area)*River%dt_fast
case(ISTOCK_HEAT)
! heat stock not yet implemented
  value = 0
case default
! Lnd_stock_pe issues a FATAL error message if index is invalid
end select

end subroutine river_stock_pe

!#####################################################################
! returns string indicating the coordiantes of the point i,j
function coordinates(i,j) result(s); character(128) :: s
   integer, intent(in) :: i,j
   s ='('//trim(string(i))//','//trim(string(j))//')'
   if (lnd%nfaces>1) s=trim(s)//' on cubic sphere face '//string(lnd%face) 
end function coordinates

end module river_mod


#ifdef test_river_solo

program river_solo
  use mpp_mod,                  only : mpp_error, mpp_pe, mpp_root_pe, mpp_npes, FATAL
  use mpp_mod,                  only : mpp_clock_id, mpp_clock_begin, mpp_clock_end
  use mpp_domains_mod,          only : mpp_define_layout, mpp_define_domains
  use mpp_domains_mod,          only : mpp_get_compute_domain, domain2d, CYCLIC_GLOBAL_DOMAIN
  use mpp_domains_mod,          only : mpp_get_current_ntile, mpp_get_tile_id
  use mpp_io_mod,               only : mpp_open, MPP_RDONLY, MPP_NETCDF, MPP_SINGLE
  use mpp_io_mod,               only : MPP_ASCII, MPP_OVERWR, mpp_close
  use fms_mod,                  only : fms_init, fms_end, stdlog, open_namelist_file
  use fms_mod,                  only : check_nml_error, close_file, file_exist, stdout, read_data
  use fms_io_mod,               only : fms_io_exit
  use time_manager_mod,         only : time_type, increment_time, set_date, increment_date, set_time
  use time_manager_mod,         only : set_calendar_type, JULIAN, NOLEAP, THIRTY_DAY_MONTHS, NO_CALENDAR
  use time_manager_mod,         only : operator(/), operator(-), operator( + ), month_name, get_date
  use diag_manager_mod,         only : diag_manager_init, diag_manager_end
  use river_mod,                only : river_init, river_end, update_river
  use constants_mod,            only : constants_init, PI, radius
  use grid_mod,                 only : get_grid_size, get_grid_cell_vertices
  use grid_mod,                 only : get_grid_cell_centers, get_grid_cell_area, get_grid_comp_area
  use grid_mod,                 only : define_cube_mosaic, get_grid_ntiles
  use river_mod,                only : num_species


  implicit none

  real, parameter       :: CONST_RUNOFF = 200.0

!--- namelist -----------------------------------------

  integer, dimension(6) :: current_date = (/ 0, 0, 0, 0, 0, 0 /)
  character(len=16)     :: calendar = 'julian'
  integer               :: years=0, months=0, days=0, hours=0, minutes=0, seconds=0
  integer               :: dt_fast     = 0
  integer               ::layout(2) = (/1,0/)
  namelist /river_solo_nml/ current_date, dt_fast, years, months, days, &
       hours, minutes, seconds, calendar, layout

!--------------------------------------------------------------------
  type(time_type)      :: Time, Time_start, Time_end, Run_len, Time_step_fast
  integer              :: nf, num_fast_step, unit
  integer              :: yr,mon,day,hr,min,sec, calendar_type=-1
  integer              :: outunit
  real, allocatable    :: runoff(:,:), discharge(:,:)
  integer              :: initClock, mainClock, termClock, updateClock 
!Balaji
  real, allocatable :: runoff_c(:,:,:)
  real, allocatable :: discharge2ocean(:,:)
  real, allocatable :: discharge2ocean_c(:,:,:)
  real, allocatable :: liq(:,:), sol(:,:), mel(:,:), hea(:,:)

  call fms_init

  initClock = mpp_clock_id( 'Initialization' )
  mainClock = mpp_clock_id( 'Main loop' )
  termClock = mpp_clock_id( 'Termination' )
  updateClock = mpp_clock_id( 'update river')

  call mpp_clock_begin(initClock)
  call river_solo_init
  call mpp_clock_end (initClock) !end initialization

  call mpp_clock_begin(mainClock) !begin main loop
  outunit=stdout()
  do nf = 1, num_fast_step
     write(outunit,*)' at river fast time step ', nf
     call mpp_clock_begin(updateClock)
!Balaji
     call update_river( runoff, runoff_c, discharge2ocean, discharge2ocean_c, &
     liq, sol, mel, hea )
!     call update_river ( runoff, discharge )
     call mpp_clock_end (updateClock)
     Time = Time + Time_step_fast
  enddo
  call mpp_clock_end(mainClock)

  call mpp_clock_begin(termClock)
  call river_end
  call diag_manager_end(Time)
  call get_date(Time,yr,mon,day,hr,min,sec)

  if (mpp_pe() == mpp_root_pe()) then
      call mpp_open(unit, 'RESTART/river_solo.res',form=MPP_ASCII,&
           action=MPP_OVERWR,threading=MPP_SINGLE,fileset=MPP_SINGLE,nohdrs=.true.)
      write(unit,*) yr, mon, day, hr, min, sec
      write(unit,*) calendar_type 
      call mpp_close(unit)
  endif

  call fms_io_exit
  call fms_end


contains

!#######################################################################
  subroutine river_solo_init

    integer                     :: unit, ierr, io
    integer                     :: ni, nj, npes, isc, iec, jsc, jec, ntiles, tile
    type(domain2d)              :: Domain
    integer, allocatable        :: tile_ids(:)             ! mosaic tile IDs for the current PE
    real,   allocatable         :: lon(:,:), lat(:,:)
    real,   allocatable         :: area_lnd(:,:), area_lnd_cell(:,:), gfrac(:,:)
    integer                     :: date(6)
    character(len=9)            :: month

    call constants_init

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=river_solo_nml, iostat=io)
    ierr = check_nml_error(io, 'river_solo_nml')
#else
    if (file_exist('input.nml')) then
      unit = open_namelist_file ()
      ierr=1
      do while (ierr /= 0)
         read  (unit, nml=river_solo_nml, iostat=io, end=10)
         ierr = check_nml_error (io, 'river_solo_nml')
      enddo
10    continue
      call close_file (unit)
    endif
#endif

    unit=stdlog()
    write(unit, nml= river_solo_nml)

! set the calendar 
    if (calendar(1:6) == 'julian') then
        calendar_type = julian
    else if (calendar(1:6) == 'NOLEAP') then
        calendar_type = NOLEAP
    else if (calendar(1:10) == 'thirty_day') then
        calendar_type = THIRTY_DAY_MONTHS
    else if (calendar(1:11) == 'no_calendar') then
        calendar_type = NO_CALENDAR
    else if (calendar(1:1) /= ' ') then
        call mpp_error (FATAL,'==>Error from ocean_solo_mod: invalid namelist value for calendar')
    else
        call mpp_error (FATAL,'==>Error from ocean_solo_mod: no namelist value for calendar')
    endif

! get river_solo restart 
    if (file_exist('INPUT/river_solo.res')) then
        call mpp_open(unit,'INPUT/river_solo.res',form=MPP_ASCII,action=MPP_RDONLY)
        read(unit,*) date
        read(unit,*) calendar_type 
        call close_file(unit)
    endif

    call set_calendar_type (calendar_type)

    call diag_manager_init

    if (sum(current_date) <= 0) then
        call mpp_error(FATAL,'==>Error from river_solo_mod: no namelist value for current date')
    else
        Time_start  = set_date(current_date(1),current_date(2), current_date(3), &
             current_date(4),current_date(5),current_date(6))
    endif

    if (file_exist('INPUT/river_solo.res')) then
        Time_start =  set_date(date(1),date(2),date(3),date(4),date(5),date(6))
    else
        Time_start = Time_start
        date = current_date
    endif

    Time           = Time_start
    Time_end       = increment_date(Time_start, years, months, days, hours, minutes, seconds)
    Run_len        = Time_end - Time_start
    Time_step_fast = set_time(dt_fast, 0)
    num_fast_step  = Run_len/Time_step_fast

    call mpp_open (unit, 'time_stamp.out', form=MPP_ASCII, action=MPP_OVERWR,threading=MPP_SINGLE)

    month = month_name(current_date(2))
    if ( mpp_pe() == mpp_root_pe() ) write (unit,'(6i4,2x,a3)') date, month(1:3)

    call get_date (Time_end, date(1), date(2), date(3), date(4), date(5), date(6))
    month = month_name(date(2))
    if ( mpp_pe() == mpp_root_pe() ) write (unit,'(6i4,2x,a3)') date, month(1:3)

    call close_file (unit)  

!--- get the land grid and set up domain decomposition
    call get_grid_size('LND', 1, ni, nj)

    npes = mpp_npes()
!--- define domain ------------------------------------------------
    call get_grid_ntiles('LND',ntiles)
    if(layout(1)*layout(2)*ntiles .NE. npes) call mpp_define_layout((/1,ni,1,nj/),npes/ntiles,layout)
    if (ntiles==1) then
       call mpp_define_domains ((/1,ni, 1, nj/), layout, domain, &
            xflags = CYCLIC_GLOBAL_DOMAIN, whalo=1, ehalo=1, shalo=1, nhalo=1, name = 'LAND MODEL')
    else
       call define_cube_mosaic ('LND', domain, layout, halo=1 )
    endif
    call mpp_get_compute_domain(Domain, isc, iec, jsc, jec)

    allocate(tile_ids(mpp_get_current_ntile(Domain)))
    tile_ids = mpp_get_tile_id(domain)
    tile = tile_ids(1)
    deallocate(tile_ids)

!--- get grid information
    allocate( lon(isc:iec,jsc:jec), lat(isc:iec,jsc:jec) )
    allocate( area_lnd(ni,nj), area_lnd_cell(ni,nj), gfrac(ni,nj) )
    call get_grid_cell_centers ('LND', tile, lon, lat, domain)
!!$    call get_grid_cell_area    ('LND',tile, area_lnd_cell)
!!$    call get_grid_comp_area    ('LND',tile, area_lnd)

    lon = lon * PI/180.
    lat = lat * PI/180.
!!$    gfrac = area_lnd/area_lnd_cell
    gfrac = 1
    npes = mpp_npes()

    call river_init( lon, lat, Time_start, Time_step_fast, Domain, gfrac(isc:iec,jsc:jec)  )

    allocate(runoff_c(isc:iec,jsc:jec,num_species) )
    allocate(runoff(isc:iec,jsc:jec), discharge(isc:iec,jsc:jec) )
    if(file_exist("INPUT/runoff.nc")) then
       call read_data("INPUT/runoff.nc", "runoff", runoff )
    else
       runoff = CONST_RUNOFF
    end if
    if(file_exist("INPUT/runoff.nc")) then
       call read_data("INPUT/runoff.nc", "runoff_c", runoff_c )
    else
       runoff_c = CONST_RUNOFF
    end if
    allocate( discharge2ocean(isc:iec,jsc:jec) )
    allocate( discharge2ocean_c(isc:iec,jsc:jec,num_species) )

  end subroutine river_solo_init

!#####################################################################

end program river_solo

#endif test_river_solo

        module aer_ccn_act_mod

use fms_mod,             only: error_mesg, FATAL, open_namelist_file, &
                               mpp_pe, mpp_root_pe, stdlog, &
                               file_exist, write_version_number, &
                               check_nml_error, close_file
use mpp_mod,             only: input_nml_file, get_unit
use aer_ccn_act_k_mod,   only: aer_ccn_act_k, aer_ccn_act2_k, &
                               aer_ccn_act_wpdf_k, aer_ccn_act_k_init, &
                               aer_ccn_act_k_end, aer_ccn_act_wpdf_m_k

implicit none
private
    private Loading
      
    public aer_ccn_act, aer_ccn_act2, aer_ccn_act_wpdf, &
           aer_ccn_act_wpdf_m, aer_ccn_act_init, aer_ccn_act_end

!--------------------- version number ---------------------------------

character(len=128) :: version = '$Id: aer_ccn_act.F90,v 19.0 2012/01/06 20:31:34 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!---------------- private data -------------------


!-----------------------------------------------------------------------
!-------------------- namelist -----------------------------------------

logical  :: nooc = .false.   ! include organic aerosols as ccns ?
real     :: sul_concen = 0.1
real     :: low_concen = 0.1
real     :: high_concen = 1.
 !Parameters for look-up tables
 
real ::  lowup=0.3 !m/s
real ::  highup=10.

! earlier values: lowup2 = 0.001, highmass2 = 1000., highmass3 = 1000.
!real ::  lowup2=0.0001 !m/s
real ::  lowup2=0.01   !m/s
real ::  highup2=0.3
real ::  lowmass2=0.01 !ug m-3
!real ::  highmass2=1000.
real ::  highmass2=100.
real ::  lowmass3=0.01 !ug m-3
!real ::  highmass3=1000.
real ::  highmass3=100.
real ::  lowmass4=0.01 !ug m-3
real ::  highmass4=100.
real ::  lowmass5=0.01 !ug m-3
real ::  highmass5=100.
real :: lowT2=243.15 !K
real :: highT2=308.15

namelist /aer_ccn_act_nml/ nooc, sul_concen, low_concen, high_concen, &
                           lowup, highup, lowup2, highup2, lowmass2, &
                           highmass2, lowmass3, highmass3,  &
                           lowmass4, highmass4, lowmass5, highmass5, &
                           lowT2, highT2


logical :: module_is_initialized  = .false.
 
contains

subroutine aer_ccn_act (T1, P1, Updraft1, TotalMass, Drop)
real, dimension(:), intent(inout) :: TotalMass
real, intent(in) :: T1, P1, Updraft1
real, intent(inout) :: Drop
    
  integer :: tym, ier
  character(len=256) :: ermesg

  if(.not. module_is_initialized) call aer_ccn_act_init()

  tym = size (totalmass,1)

  call aer_ccn_act_k (T1, P1, Updraft1, TotalMass, tym, Drop, ier,  &
                      ermesg)
  if (ier /= 0) call error_mesg ('aer_ccn_act', ermesg, FATAL)

  
end subroutine aer_ccn_act

subroutine aer_ccn_act2 (T1, P1, Updraft1, TotalMass, mu,airdens,Nc,qc,qt,qe,tc,te,Drop)

!T1 temperature (K)
!P1 pressure (Pa)
!Updraft1 updraft velocity (m/s)
!TotalMass aerosol mass ()
!mu entrainment coef. (/s)
!airdens air density (kg/m3 air)
!Nc droplet mixing ratio (#/kg air)
!qc in-cloud vapor mixing ratio (kg water/kg air)
!qt in-cloud total water mixing ratio qc + ql (kg water/kg air)
!qe environment vapor mixing ratio (kg water/kg air)
!tc in-cloud temperature (K)
!te environment temperature (K)
!Drop droplet number concentration (#/cc)

real, dimension(:), intent(in) :: TotalMass
real, intent(in) :: T1, P1, Updraft1, mu,airdens, Nc, qc, qt, qe, tc, te
real, intent(inout) :: Drop

  integer :: tym, ier
  character(len=256) :: ermesg
        
  if(.not. module_is_initialized) call aer_ccn_act_init()
  tym = size (totalmass,1)

  call aer_ccn_act2_k (T1, P1, Updraft1, TotalMass, tym, mu,  &
                       airdens,Nc,qc,qt,qe,tc,te,Drop, ier, ermesg)
  if (ier /= 0) call error_mesg ('aer_ccn_act2', ermesg, FATAL)

end subroutine aer_ccn_act2

!-->cjg: addition
!
! Additional subroutines to compute CCN activation by integrating
! over an assumed subgrid-scale PDF of w

subroutine aer_ccn_act_wpdf(T, p, wm, wp2, totalmass, drop)

! Compute CCN activation assuming a normal distribution of w
! given by its mean (wm) and second moment (wp2)

real, intent(in)    :: T, p, wm, wp2
real, intent(inout) :: totalmass(4)
real, intent(out)   :: drop

  integer :: tym, ier
  character(len=256) :: ermesg

  if(.not. module_is_initialized) call aer_ccn_act_init()
  tym = size (totalmass,1)

   call aer_ccn_act_wpdf_k (T, p, wm, wp2, totalmass, tym,           &
                            drop, ier, ermesg)
  if (ier /= 0) call error_mesg ('aer_ccn_act_wpdf', ermesg, FATAL)

end subroutine aer_ccn_act_wpdf

!----------------------------------------------------------------------

subroutine aer_ccn_act_wpdf_m(T, p, wm, wp2, offs, totalmass, drop)


! Compute CCN activation assuming a normal distribution of w
! given by its mean (wm) and second moment (wp2)

real, intent(in)    :: T, p, wm, wp2
integer, intent(in) :: offs
real, intent(inout) :: totalmass(4)
real, intent(out)   :: drop

  integer :: tym, ier
  character(len=256) :: ermesg

  if(.not. module_is_initialized) call aer_ccn_act_init()
  tym = size (totalmass,1)

  call aer_ccn_act_wpdf_m_k (T, p, wm, wp2, offs, totalmass, tym,       &
                             drop, ier, ermesg)
  if (ier /= 0) call error_mesg ('aer_ccn_act_wpdf_m', ermesg, FATAL)

end subroutine aer_ccn_act_wpdf_m

!------------------------------------------------------------------------

subroutine aer_ccn_act_init ()

!--------------------------------------------------------------------  
!  local variables:
      
      integer   ::   unit, ierr, io, logunit
      integer, parameter :: res = 20 !
      real, dimension(res,res,res,res,res) :: droplets

      integer, parameter :: res2 = 20 !
      real, dimension(res2,res2,res2,res2,res2) :: droplets2

      if (module_is_initialized) return

!--------------------------------------------------------------------- 
!    read namelist.
!--------------------------------------------------------------------
      if ( file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
        read (input_nml_file, nml=aer_ccn_act_nml, iostat=io)
        ierr = check_nml_error(io,'aer_ccn_act_nmliostat=io')
#else
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=aer_ccn_act_nml, iostat=io,  &
               end=10)
        ierr = check_nml_error(io,'aer_ccn_act_nml')
        end do
10      call close_file (unit)   
#endif
      endif                      
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!--------------------------------------------------------------------
       call write_version_number(version, tagname)
       logunit=stdlog()
       if (mpp_pe() == mpp_root_pe() ) &
                        write (logunit, nml=aer_ccn_act_nml)

       call Loading( droplets, droplets2)

       call aer_ccn_act_k_init (droplets,   &
                      droplets2, res, res2, nooc,  &
                       sul_concen, low_concen, high_concen, &
                       lowup, highup, lowup2, highup2, lowmass2, &
                       highmass2, lowmass3, highmass3,  &
                       lowmass4, highmass4, lowmass5, highmass5, &
                      lowT2, highT2  )
       module_is_initialized  = .true.

end subroutine aer_ccn_act_init


subroutine Loading(droplets, droplets2)

real, dimension(:,:,:,:,:), intent(out) :: droplets, droplets2
real xx
integer i, j, k, l, m, unit
integer res, res2

  res = size(droplets,1)
  res2 = size(droplets2,1)
  unit = get_unit()
  open(unit, FILE='INPUT/droplets.dat')
  do k=1,res
    do i=1,res
      do j=1, res
        do l=1, res
        do m=1, res
          read(unit,*) xx
          droplets(m,l,j,i,k)=xx
        end do
        end do
      end do
    end do
  end do
  close(unit)

  unit = get_unit()
  open(unit, FILE='INPUT/droplets2.dat')
  do k=1,res2
    do i=1,res2
      do j=1, res2
        do l=1, res2
        do m=1, res2
          read(unit,*) xx
          droplets2(m,l,j,i,k)=xx
        end do
        end do
      end do
    end do
  end do
  close(unit)

end subroutine Loading


subroutine aer_ccn_act_end()

  call aer_ccn_act_k_end 
  module_is_initialized  = .false.

end subroutine aer_ccn_act_end

end module aer_ccn_act_mod

#include <fms_platform.h>
module  ocmip2_abiotic_mod
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> John P. Dunne
!</REVIEWER>
!
!<OVERVIEW>
! Ocean Carbon Model Intercomparison Study II: Abiotic module
!</OVERVIEW>
!
!<DESCRIPTION>
!       Implementation of routines to solve the OCMIP-2 Abiotic
!       simulations as outlined in the Abiotic-HOWTO documentation,
!       revision 1.7, 1999/10/05.
!</DESCRIPTION>
!
! <INFO>
! <REFERENCE>
! http://www.ipsl.jussieu.fr/OCMIP/phase2/simulations/Abiotic/HOWTO-Abiotic.html
! </REFERENCE>
!
! <REFERENCE>
! Press, W. H., S. A. Teukosky, W. T. Vetterling, B. P. Flannery, 1992. 
! Numerical Recipes in FORTRAN, Second Edition, Cambridge University Press. 
! </REFERENCE>
!
! <REFERENCE>
! Enting, I.G., T. M. L. Wigley, M. Heimann, 1994. Future Emissions 
! and concentrations of carbon dioxide: key ocean / atmosphere / 
! land analyses, CSIRO Aust. Div. Atmos. Res. Tech. Pap. No. 31, 
! 118 pp.
! </REFERENCE>
! </INFO>
!
!------------------------------------------------------------------
!
!       Module ocmip2_abiotic_mod
!
!       Implementation of routines to solve the OCMIP-2 Abiotic
!       simulations as outlined in the Abiotic-HOWTO documentation,
!       revision 1.7, 1999/10/05.
!
!------------------------------------------------------------------
!
use atmos_ocean_fluxes_mod,   only: aof_set_coupler_flux
use diag_manager_mod,         only: register_diag_field, diag_axis_init
use field_manager_mod,        only: fm_get_index
use time_manager_mod,         only: time_type
use field_manager_mod,        only: fm_field_name_len, fm_path_name_len, fm_string_len
use field_manager_mod,        only: fm_get_length, fm_get_value, fm_new_value
use fms_mod,                  only: field_exist, file_exist
use fms_io_mod,               only: register_restart_field, save_restart, restore_state
use fms_io_mod,               only: restart_file_type
use mpp_mod,                  only: stdout, stdlog, mpp_error, mpp_sum, FATAL, NOTE
use time_manager_mod,         only: get_date
use time_interp_external_mod, only: time_interp_external
use time_interp_external_mod, only: init_external_field
use mpp_domains_mod,          only: domain2d
use mpp_domains_mod,          only: mpp_global_sum, BITWISE_EXACT_SUM
use constants_mod,            only: WTMCO2

use ocean_tpm_util_mod, only: otpm_set_tracer_package, otpm_set_prog_tracer
use fm_util_mod,        only: fm_util_check_for_bad_fields, fm_util_set_value
use fm_util_mod,        only: fm_util_get_string, fm_util_get_logical, fm_util_get_integer, fm_util_get_real
use fm_util_mod,        only: fm_util_get_logical_array, fm_util_get_real_array, fm_util_get_string_array
use fm_util_mod,        only: fm_util_start_namelist, fm_util_end_namelist
use coupler_types_mod,  only: ind_alpha, ind_csurf, coupler_2d_bc_type, ind_flux
use ocean_types_mod,    only: ocean_prog_tracer_type
use ocmip2_co2calc_mod, only: ocmip2_co2calc
use ocean_types_mod,    only: ocean_grid_type, ocean_time_type
use ocean_util_mod,     only: diagnose_2d, diagnose_2d_comp, diagnose_3d_comp

implicit none

private

public  :: ocmip2_abiotic_end
public  :: ocmip2_abiotic_init
public  :: ocmip2_abiotic_flux_init
public  :: ocmip2_abiotic_sbc
public  :: ocmip2_abiotic_source
public  :: ocmip2_abiotic_start
public  :: ocmip2_abiotic_init_sfc
public  :: ocmip2_abiotic_avg_sfc
public  :: ocmip2_abiotic_sum_sfc
public  :: ocmip2_abiotic_zero_sfc
public  :: ocmip2_abiotic_sfc_end
public  :: ocmip2_abiotic_restart
public  :: ocmip2_abiotic_tracer

private :: allocate_arrays

character(len=fm_field_name_len), parameter     :: package_name = 'ocmip2_abiotic'
character(len=48), parameter                    :: mod_name = 'ocmip2_abiotic_mod'
character(len=48), parameter                    :: diag_name = 'ocean_ocmip2_abiotic'
character(len=fm_string_len), parameter         :: default_restart_file = 'ocmip2_abiotic.res.nc'
character(len=fm_string_len), parameter         :: default_local_restart_file = 'ocmip2_abiotic_local.res.nc'
character(len=fm_string_len), parameter         :: default_ice_restart_file = 'ice_ocmip2_abiotic.res.nc'
character(len=fm_string_len), parameter         :: default_ocean_restart_file = 'ocmip2_abiotic_airsea_flux.res.nc'

!  sio4_const           = SiO4 concentration (mol/kg)
!  po4_const            = PO4 concentration (mol/kg)
!  dic_global           = global annual surface mean DIC concentration
!  dic_global_wrk       = work variable used in calculation of
!                         dic_global
!  di14c_global         = global annual surface mean DI14C concentration
!  di14c_global_wrk     = work variable used in calculation of
!                         DI14C_global
!  sal_global           = surface global annual mean salinity
!                         concentration (PSU)
!  sal_global_wrk       = work variable used in calculation of
!                         sal_global
type abiotic_type

  real, _ALLOCATABLE, dimension(:,:)    :: alpha  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: csurf  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: c14surf  _NULL
  real                                  :: di14c_global = 0.0
  real, _ALLOCATABLE, dimension(:,:)    :: di14c_global_wrk  _NULL
  real                                  :: dic_global = 0.0
  real, _ALLOCATABLE, dimension(:,:)    :: dic_global_wrk  _NULL
  character(len=128)                    :: frac_14catm_file = ' '
  character(len=128)                    :: frac_14catm_name = ' '
  integer                               :: frac_14catm_id = 0
  real, _ALLOCATABLE, dimension(:,:)    :: frac_14catm  _NULL
  real                                  :: frac_14catm_const = 0.0
  character(len=fm_string_len)          :: local_restart_file
  real                                  :: global_wrk_duration = 0.0
  real, _ALLOCATABLE, dimension(:,:)    :: htotal  _NULL
  integer                               :: id_alpha = -1
  integer                               :: id_csurf = -1
  integer                               :: id_c14surf = -1
  integer                               :: id_htotal = -1
  integer                               :: id_alk = -1
  integer                               :: id_po4 = -1
  integer                               :: id_sio4 = -1
  integer                               :: id_frac_14catm = -1
  integer                               :: id_jdi14c = -1
  integer                               :: id_pco2surf = -1
  integer                               :: id_sfc_flux_co2 = -1
  integer                               :: id_sfc_flux_14co2 = -1
  integer                               :: id_vstf_di14c = -1
  integer                               :: id_vstf_dic = -1
  integer                               :: ind_di14c
  integer                               :: ind_dic
  integer                               :: ind_co2_flux
  integer                               :: ind_14co2_flux
  real, _ALLOCATABLE, dimension(:,:,:)  :: jdi14c  _NULL
  real                                  :: half_life
  real                                  :: lambda
  real                                  :: alkbar
  integer                               :: id_sc_co2 = -1
  real, _ALLOCATABLE, dimension(:,:)    :: sc_co2  _NULL
  real                                  :: sc_co2_0
  real                                  :: sc_co2_1
  real                                  :: sc_co2_2
  real                                  :: sc_co2_3
  character(len=fm_field_name_len)      :: name
  real, _ALLOCATABLE, dimension(:,:)    :: pco2surf  _NULL
  real                                  :: sal_global = 35.0
  real, _ALLOCATABLE, dimension(:,:)    :: sal_global_wrk  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: po4  _NULL
  real                                  :: po4_const
  real, _ALLOCATABLE, dimension(:,:)    :: sio4  _NULL
  real                                  :: sio4_const
  real, _ALLOCATABLE, dimension(:,:)    :: vstf_di14c  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: vstf_dic  _NULL

end type abiotic_type

logical, public :: do_ocmip2_abiotic

integer                 :: indsal
integer                 :: indtemp
integer                 :: package_index
logical                 :: module_initialized = .false.

character(len=128)      :: version = '$Id: ocmip2_abiotic.F90,v 20.0 2013/12/14 00:09:38 fms Exp $'
character(len=128)      :: tagname = '$Name: tikal $'

!       Input parameters:
!
!  htotal_in            = default value for htotal for an initial run
!  htotal_scale_lo      = scaling parameter to chose htotallo
!  htotal_scale_hi      = scaling parameter to chose htotalhi
real                                    :: htotal_in
real, allocatable, dimension(:,:)       :: htotal_scale_hi
real                                    :: htotal_scale_hi_in
real, allocatable, dimension(:,:)       :: htotal_scale_lo
real                                    :: htotal_scale_lo_in

!       Calculated parameters (with possible initial input values):
!
!  global_wrk_duration  = total time during calculation of global
!                         variables
real, allocatable, dimension(:,:)               :: sc_no_term
type(abiotic_type), allocatable, dimension(:)   :: abiotic
integer                                         :: instances

! for restart
integer                              :: num_restart = 0
type(restart_file_type), allocatable :: restart(:)

contains

!#######################################################################
! <SUBROUTINE NAME="allocate_arrays">
!
! <DESCRIPTION>
!     Dynamically allocate arrays
! </DESCRIPTION>
!
subroutine allocate_arrays(isc, iec, jsc, jec, nk, isd, ied, jsd, jed)

integer, intent(in)     :: isc
integer, intent(in)     :: iec
integer, intent(in)     :: jsc
integer, intent(in)     :: jec
integer, intent(in)     :: isd
integer, intent(in)     :: ied
integer, intent(in)     :: jsd
integer, intent(in)     :: jed
integer, intent(in)     :: nk

integer :: i, j, k, l, m, n

! global variables
allocate( sc_no_term(isc:iec,jsc:jec) )
allocate( htotal_scale_lo(isc:iec,jsc:jec) )
allocate( htotal_scale_hi(isc:iec,jsc:jec) )

! initialize some arrays
sc_no_term(:,:) = 0.0
htotal_scale_lo(:,:) = 0.0
htotal_scale_hi(:,:) = 0.0

! allocate abiotic array elements
do n = 1, instances
  allocate( abiotic(n)%htotal(isc:iec,jsc:jec) )
  allocate( abiotic(n)%csurf(isc:iec,jsc:jec) )
  allocate( abiotic(n)%c14surf(isc:iec,jsc:jec) )
  allocate( abiotic(n)%frac_14catm(isc:iec,jsc:jec) )
  allocate( abiotic(n)%alpha(isc:iec,jsc:jec) )
  allocate( abiotic(n)%pco2surf(isc:iec,jsc:jec) )
  allocate( abiotic(n)%po4(isd:ied,jsd:jed) )
  allocate( abiotic(n)%sio4(isd:ied,jsd:jed) )
  allocate( abiotic(n)%sc_co2(isc:iec,jsc:jec) )
  allocate( abiotic(n)%sal_global_wrk(isc:iec,jsc:jec) )
  allocate( abiotic(n)%jdi14c(isc:iec,jsc:jec,nk) )
enddo

! initialize abiotic array elements
do n = 1, instances

  do j = jsd, jed
    do i = isd, ied
      abiotic(n)%po4(i,j) = 0.0
      abiotic(n)%sio4(i,j) = 0.0
    enddo
  enddo
  do j = jsc, jec
    do i = isc, iec
      abiotic(n)%sc_co2(i,j) = 0.0
      abiotic(n)%htotal(i,j) = 0.0
      abiotic(n)%csurf(i,j) = 0.0
      abiotic(n)%c14surf(i,j) = 0.0
      abiotic(n)%alpha(i,j) = 0.0
      abiotic(n)%pco2surf(i,j) = 0.0
      abiotic(n)%sal_global_wrk(i,j) = 0.0
    enddo
  enddo
  do j = jsc, jec
    do i = isc, iec
      abiotic(n)%frac_14catm(i,j) = abiotic(n)%frac_14catm_const
    enddo
  enddo
  do j = jsc, jec
    do i = isc, iec
      do k = 1, nk
        abiotic(n)%jdi14c(i,j,k) = 0.0
      enddo
    enddo
  enddo

enddo

return
end subroutine  allocate_arrays
! </SUBROUTINE> NAME="allocate_arrays"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_abiotic_bbc">
!
! <DESCRIPTION>
!     calculate the surface boundary conditions
! </DESCRIPTION>
!

subroutine ocmip2_abiotic_bbc

end subroutine  ocmip2_abiotic_bbc
! </SUBROUTINE> NAME="ocmip2_abiotic_bbc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_abiotic_end">
!
! <DESCRIPTION>
!     Clean up various ABIOTIC quantities for this run.
! </DESCRIPTION>
!

subroutine ocmip2_abiotic_end(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,        &
     T_prog, grid_dat, grid_tmask, mpp_domain2d, rho_dzt, taup1)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
type(ocean_prog_tracer_type), intent(in), dimension(:)  :: T_prog
integer, intent(in)                                     :: taup1
real, dimension(isd:,jsd:), intent(in)                  :: grid_dat
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask
type(domain2d), intent(in)                              :: mpp_domain2d
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho_dzt

character(len=64), parameter    :: sub_name = 'ocmip2_abiotic_end'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer                                 :: i, j, k, n
integer                                 :: lun
character(len=fm_field_name_len+1)      :: suffix
real                                    :: total_di14c
real                                    :: total_dic
real                                    :: total_di14c_bitwise
real                                    :: total_dic_bitwise
real, dimension(isd:ied,jsd:jed,nk)     :: wrk

  integer :: stdoutunit 
  stdoutunit=stdout() 
!       integrate the total concentrations of some tracers
!       for the end of the run

!       Use taup1 time index for the start of a run, and taup1 time
!       index for the end of a run so that we are integrating the
!       same time level and should therefore get identical results
do n = 1, instances

  total_dic = 0.0
  total_di14c = 0.0

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        total_dic = total_dic +                                         &
             t_prog(abiotic(n)%ind_dic)%field(i,j,k,taup1) *            &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_di14c = total_di14c +                                     &
             t_prog(abiotic(n)%ind_di14c)%field(i,j,k,taup1) *          &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo

  call mpp_sum(total_dic)
  call mpp_sum(total_di14c)

  write (stdoutunit,*) '  Instance ', trim(abiotic(n)%name)
  write (stdoutunit,                                              &
       '(/'' Total DIC  = '',es19.12,'' Gmol-C'')')             &
       total_dic * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total DI14C  = '',es19.12,'' Gmol-C'')')           &
       total_di14c * 1.0e-09

  do k = 1, nk
    do j = jsd, jed
      do i = isd, ied
        wrk(i,j,k) =                                                            &
             t_prog(abiotic(n)%ind_dic)%field(i,j,k,taup1) *                    &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo
  total_dic_bitwise = mpp_global_sum(mpp_domain2d, wrk, BITWISE_EXACT_SUM)

  do k = 1, nk
    do j = jsd, jed
      do i = isd, ied
        wrk(i,j,k) =                                                            &
             t_prog(abiotic(n)%ind_di14c)%field(i,j,k,taup1) *                  &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo
  total_di14c_bitwise = mpp_global_sum(mpp_domain2d, wrk, BITWISE_EXACT_SUM)

  write (stdoutunit,*) '  Instance ', trim(abiotic(n)%name), ' bitwise exact sum'
  write (stdoutunit,                                              &
       '(/'' Total DIC  = '',es19.12,'' Gmol-C'')')             &
       total_dic_bitwise * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total DI14C  = '',es19.12,'' Gmol-C'')')           &
       total_di14c_bitwise * 1.0e-09

enddo

! save out additional information for a restart
write(stdoutunit,*)

write(stdoutunit,*) trim(note_header),                            &
     'Writing additional restart information for instances'

call ocmip2_abiotic_restart

write (stdoutunit,*) trim(note_header),                           &
     'Done writing additional restart information for instances'

do n = 1, instances

  write (stdoutunit,'(/1x,a,es16.9,a,a)')                         &
        'Annual, global, surface mean salinity = ',             &
        abiotic(n)%sal_global, ' (PSU) for instance ',          &
        trim(abiotic(n)%name)

enddo

return
end subroutine  ocmip2_abiotic_end
! </SUBROUTINE> NAME="ocmip2_abiotic_end"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_abiotic_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocmip2_abiotic_restart(time_stamp)
  character(len=*),             intent(in), optional :: time_stamp
  integer :: n

  do n=1, num_restart
     call save_restart(restart(n), time_stamp)
  end do

end subroutine ocmip2_abiotic_restart
! </SUBROUTINE> NAME="ocmip2_abiotic_restart"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_abiotic_sbc">
!
! <DESCRIPTION>
!     Calculate the surface boundary conditions
! </DESCRIPTION>
!

subroutine ocmip2_abiotic_sbc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,       &
     isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                                        &
     T_prog, taum1, Grid, Time, ice_ocean_boundary_fluxes)

integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: nk
integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
integer, intent(in)                                             :: isc_bnd
integer, intent(in)                                             :: iec_bnd
integer, intent(in)                                             :: jsc_bnd
integer, intent(in)                                             :: jec_bnd
type(ocean_prog_tracer_type), intent(inout), dimension(:)       :: T_prog
integer, intent(in)                                             :: taum1
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time
type(coupler_2d_bc_type), intent(in)                            :: ice_ocean_boundary_fluxes

integer :: i, j, k, n, m
integer :: i_bnd_off
integer :: j_bnd_off
integer :: kz
logical :: used

!     use the surface fluxes from the coupler
!       stf is in mol/m^2/s, flux from coupler is positive upwards
i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

do n = 1, instances
  do j = jsc, jec
    do i = isc, iec
      t_prog(abiotic(n)%ind_dic)%stf(i,j) =                                     &
            -ice_ocean_boundary_fluxes%bc(abiotic(n)%ind_co2_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
      t_prog(abiotic(n)%ind_di14c)%stf(i,j) =                                   &
            -ice_ocean_boundary_fluxes%bc(abiotic(n)%ind_14co2_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
    enddo
  enddo
enddo

! Save variables for diagnostics
do n = 1, instances
   call diagnose_2d(Time, Grid, abiotic(n)%id_sfc_flux_co2, t_prog(abiotic(n)%ind_dic)%stf(:,:))
   call diagnose_2d(Time, Grid, abiotic(n)%id_sfc_flux_14co2, t_prog(abiotic(n)%ind_di14c)%stf(:,:))
enddo

return

end subroutine  ocmip2_abiotic_sbc
! </SUBROUTINE> NAME="ocmip2_abiotic_sbc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_abiotic_flux_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the ocean-atmosphere gas fluxes
! </DESCRIPTION>
subroutine ocmip2_abiotic_flux_init

character(len=64), parameter    :: sub_name = 'ocmip2_abiotic_flux_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=256)                                      :: caller_str

  integer :: stdoutunit 
  stdoutunit=stdout() 

!       First, perform some initialization if this module has not been
!       initialized because the normal initialization routine will
!       not have been called as part of the normal ocean model
!       initialization if this is an Atmosphere pe of a coupled
!       model running in concurrent mode
if (.not. module_initialized) then
   ! Initialize the package
  package_index = otpm_set_tracer_package(package_name,            &
       restart_file = default_restart_file,                        &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')

  ! Check whether to use this package
  path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
  instances = fm_get_length(path_to_names)
  if (instances .lt. 0) then
    call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
  endif

  ! Check some things
  write (stdoutunit,*)
  if (instances .eq. 0) then
    write (stdoutunit,*) trim(note_header), ' No instances'
    do_ocmip2_abiotic = .false.
  else
    if (instances .eq. 1) then
      write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
    else
      write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
    endif
    do_ocmip2_abiotic = .true.
  endif

  module_initialized = .true.

endif


! Return if we don't want to use this package
if (.not. do_ocmip2_abiotic) then
  return
endif

if (.not. allocated(abiotic)) then

   ! allocate storage for abiotic array
  allocate ( abiotic(instances) )

  ! loop over the names, saving them into the abiotic array
  do n = 1, instances

    if (fm_get_value(path_to_names, name, index = n)) then
      abiotic(n)%name = name
    else
      write (name,*) n
      call mpp_error(FATAL, trim(error_header) //        &
           'Bad field name for index ' // trim(name))
    endif

  enddo

endif


! Set up the ocean-atmosphere gas flux fields
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

  name = abiotic(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
  else
    suffix = '_' // name
  endif

  ! Coupler fluxes
  abiotic(n)%ind_co2_flux = aof_set_coupler_flux('co2_flux' // suffix,                          &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',                               &
       mol_wt = WTMCO2, param = (/ 9.36e-07, 9.7561e-06 /),                                                      &
       ice_restart_file = default_ice_restart_file,                                             &
       ocean_restart_file = default_ocean_restart_file,                                         &
       caller = caller_str)

  abiotic(n)%ind_14co2_flux = aof_set_coupler_flux('c14o2_flux' // suffix,                      &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',                               &
       param = (/ 9.36e-07, 9.7561e-06 /),                                                      &
       ice_restart_file = default_ice_restart_file,                                             &
       ocean_restart_file = default_ocean_restart_file,                                         &
       caller = caller_str)
enddo

return

end subroutine  ocmip2_abiotic_flux_init
! </SUBROUTINE> NAME="ocmip2_abiotic_flux_init"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_abiotic_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the tracer packages
!
!       Save pointers to various "types", such as Grid and Domains.
! </DESCRIPTION>

subroutine ocmip2_abiotic_init

character(len=64), parameter    :: sub_name = 'ocmip2_abiotic_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=fm_field_name_len+3)                      :: long_suffix
logical, dimension(12)                                  :: t_mask
character(len=256)                                      :: caller_str
character(len=fm_string_len), pointer, dimension(:)     :: good_list

  integer :: stdoutunit 
  stdoutunit=stdout() 


! Initialize the package
package_index = otpm_set_tracer_package(package_name,            &
     restart_file = default_restart_file,                        &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')

! Check whether to use this package
path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
instances = fm_get_length(path_to_names)
if (instances .lt. 0) then
  call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
endif

! Check some things
write (stdoutunit,*)
if (instances .eq. 0) then
  write (stdoutunit,*) trim(note_header), ' No instances'
  do_ocmip2_abiotic = .false.
else
  if (instances .eq. 1) then
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
  else
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
  endif
  do_ocmip2_abiotic = .true.
endif

module_initialized = .true.

! Return if we don't want to use this package
if (.not. do_ocmip2_abiotic) then
  return
endif

! allocate storage for abiotic array
allocate ( abiotic(instances) )

! loop over the names, saving them into the abiotic array
do n = 1, instances

  if (fm_get_value(path_to_names, name, index = n)) then
    abiotic(n)%name = name
  else
    write (name,*) n
    call mpp_error(FATAL, trim(error_header) //        &
         'Bad field name for index ' // trim(name))
  endif

enddo

! Set up the field input
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

  name = abiotic(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // name
    long_suffix = ' (' // trim(name) // ')'
  endif

  ! DIC
  abiotic(n)%ind_dic = otpm_set_prog_tracer('dic' // suffix,            &
       package_name,                                                    &
       longname = 'DIC' // trim(long_suffix),                           &
       units = 'mol/kg', flux_units = 'mol/m^2/s',                      &
       caller = caller_str)

  ! DI14C
  abiotic(n)%ind_di14c = otpm_set_prog_tracer('di14c' // suffix,        &
       package_name,                                                    &
       longname = 'DI14C' // trim(long_suffix),                         &
       units = 'mol/kg', flux_units = 'mol/m^2/s',                      &
       caller = caller_str)

enddo

! Process the namelists

!       Add the package name to the list of good namelists, to be used
!       later for a consistency check
if (fm_new_value('/ocean_mod/GOOD/good_namelists', package_name, append = .true.) .le. 0) then
  call mpp_error(FATAL, trim(error_header) //                           &
       ' Could not add ' // trim(package_name) // ' to "good_namelists" list')
endif

! Set up the *global* namelist
call fm_util_start_namelist(package_name, '*global*', caller = caller_str, no_overwrite = .true., &
     check = .true.)

call fm_util_set_value('htotal_scale_lo_in', 0.01 )
call fm_util_set_value('htotal_scale_hi_in', 100.0)
call fm_util_set_value('htotal_in', 1.0e-08)

call fm_util_end_namelist(package_name, '*global*', caller = caller_str, check = .true.)

! Set up the instance namelists
do n = 1, instances
   ! create the instance namelist
  call fm_util_start_namelist(package_name, abiotic(n)%name, caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('sal_global', 35.0)                            ! PSU
  call fm_util_set_value('half_life', 5730.0)                           ! a
  call fm_util_set_value('alkbar', 2.310e-03)                           ! eq/kg
  call fm_util_set_value('frac_14catm_file', ' ')
  call fm_util_set_value('frac_14catm_name', ' ')
  call fm_util_set_value('frac_14catm_const', abiotic(n)%frac_14catm_const)
  call fm_util_set_value('po4_const', 5.0e-07)                          ! mol/kg
  call fm_util_set_value('sio4_const', 7.5e-06)                         ! mol/kg
  call fm_util_set_value('dic_global', 2.0e-03)                         ! mol/kg
  call fm_util_set_value('di14c_global', 2.0e-03)                       ! mol/kg
  call fm_util_set_value('local_restart_file', default_local_restart_file)

  ! New Wanninkhof numbers
  call fm_util_set_value('sc_co2_0', 2068.9)
  call fm_util_set_value('sc_co2_1', -118.63)
  call fm_util_set_value('sc_co2_2', 2.9311)
  call fm_util_set_value('sc_co2_3', -0.027)

  call fm_util_end_namelist(package_name, abiotic(n)%name, check = .true., caller = caller_str)

enddo

! Check for any errors in the number of fields in the namelists for this package
good_list => fm_util_get_string_array('/ocean_mod/GOOD/namelists/' // trim(package_name) // '/good_values',   &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
if (associated(good_list)) then
  call fm_util_check_for_bad_fields('/ocean_mod/namelists/' // trim(package_name), good_list,       &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')
  deallocate(good_list)
else
  call mpp_error(FATAL,trim(error_header) // ' Empty "' // trim(package_name) // '" list')
endif

return

end subroutine ocmip2_abiotic_init
! </SUBROUTINE> NAME="ocmip2_abiotic_init"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_abiotic_init_sfc">
!
! <DESCRIPTION>
!       Initialize surface fields for flux calculations
!
!       Note: this subroutine should be merged into ocmip2_abiotic_start
! </DESCRIPTION>

subroutine ocmip2_abiotic_init_sfc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,  &
     isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                                        &
     Ocean_fields, T_prog, rho, taum1, model_time, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: iec_bnd
integer, intent(in)                                     :: jsc_bnd
integer, intent(in)                                     :: jec_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho
integer, intent(in)                                     :: taum1
type(time_type), intent(in)                             :: model_time
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer :: i, j, m, n, nn
integer :: i_bnd_off
integer :: j_bnd_off
integer :: ind

real    :: epsln=1.0e-30

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

do n = 1, instances
   ! CO2 flux
  ind = abiotic(n)%ind_co2_flux
  if (.not. field_exist('INPUT/'//trim(Ocean_fields%bc(ind)%ocean_restart_file),    &
                        Ocean_fields%bc(ind)%field(ind_alpha)%name)) then

    call ocmip2_co2calc(isd, jsd, isc, iec, jsc, jec,         &
         grid_tmask(isd:ied,jsd:jed,1),                                 &
         t_prog(indtemp)%field(isd:ied,jsd:jed,1,taum1),                &
         t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1),                 &
         t_prog(abiotic(n)%ind_dic)%field(isd:ied,jsd:jed,1,taum1),     &
         t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1) *                &
              abiotic(n)%alkbar / abiotic(n)%sal_global,                &
         abiotic(n)%po4,                                                &
         abiotic(n)%sio4,                                               &
         htotal_scale_lo, htotal_scale_hi, abiotic(n)%htotal,           &
         co2star = abiotic(n)%csurf, alpha = abiotic(n)%alpha,          &
         pco2surf = abiotic(n)%pco2surf)

!  Compute the Schmidt number of CO2 in seawater using the 
!  formulation presented by Wanninkhof (1992, J. Geophys. Res., 97,
!  7373-7382).
    do j = jsc, jec
      do i = isc, iec
        abiotic(n)%sc_co2(i,j) =                                                &
             abiotic(n)%sc_co2_0 + t_prog(indtemp)%field(i,j,1,taum1) *         &
             (abiotic(n)%sc_co2_1 + t_prog(indtemp)%field(i,j,1,taum1) *        &
              (abiotic(n)%sc_co2_2 + t_prog(indtemp)%field(i,j,1,taum1) *       &
               abiotic(n)%sc_co2_3)) * grid_tmask(i,j,1)
        sc_no_term(i,j) = sqrt(660.0 / (abiotic(n)%sc_co2(i,j) + epsln)) * grid_tmask(i,j,1)
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =         &
             abiotic(n)%alpha(i,j) * rho(i,j,1,taum1) * sc_no_term(i,j)
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =         &
             abiotic(n)%csurf(i,j) * rho(i,j,1,taum1) * sc_no_term(i,j)
      enddo
    enddo

    ind = abiotic(n)%ind_14co2_flux

    ! calculate interpolated frac_14catm (fractionation of atmospheric 14CO2)
    if (abiotic(n)%frac_14catm_file .ne. ' ') then
      call time_interp_external(abiotic(n)%frac_14catm_id, model_time, abiotic(n)%frac_14catm)
    endif

    do j = jsc, jec
      do i = isc, iec
        abiotic(n)%c14surf(i,j) = abiotic(n)%csurf(i,j) *                       &
             t_prog(abiotic(n)%ind_di14c)%field(i,j,1,taum1) /                  &
             (t_prog(abiotic(n)%ind_dic)%field(i,j,1,taum1) + 1.0e-40)
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) = &
             abiotic(n)%alpha(i,j) * rho(i,j,1,taum1) * sc_no_term(i,j) *       &
             (1.0 + abiotic(n)%frac_14catm(i,j) * 1.0e-03)
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) = &
             abiotic(n)%c14surf(i,j) * rho(i,j,1,taum1) * sc_no_term(i,j)
      enddo
    enddo

  endif

enddo

return

end subroutine ocmip2_abiotic_init_sfc
! </SUBROUTINE> NAME="ocmip2_abiotic_init_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_abiotic_sum_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>
subroutine ocmip2_abiotic_sum_sfc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,    &
     isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                                        &
     Ocean_fields, T_prog, rho, taum1, model_time, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: iec_bnd
integer, intent(in)                                     :: jsc_bnd
integer, intent(in)                                     :: jec_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
type(ocean_prog_tracer_type), intent(in), dimension(:)  :: T_prog
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho
integer, intent(in)                                     :: taum1
type(time_type), intent(in)                             :: model_time
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer :: i, j, n, nn
integer :: i_bnd_off
integer :: j_bnd_off
integer :: ind

real    :: epsln=1.0e-30

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

do n = 1, instances

  ind = abiotic(n)%ind_co2_flux

  call ocmip2_co2calc(isd, jsd, isc, iec, jsc, jec,           &
       grid_tmask(isd:ied,jsd:jed,1),                                   &
       t_prog(indtemp)%field(isd:ied,jsd:jed,1,taum1),                  &
       t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1),                   &
       t_prog(abiotic(n)%ind_dic)%field(isd:ied,jsd:jed,1,taum1),       &
       t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1) *                  &
            abiotic(n)%alkbar / abiotic(n)%sal_global,                  &
       abiotic(n)%po4,                                                  &
       abiotic(n)%sio4,                                                 &
       htotal_scale_lo, htotal_scale_hi, abiotic(n)%htotal,             &
       co2star = abiotic(n)%csurf, alpha = abiotic(n)%alpha,            &
       pco2surf = abiotic(n)%pco2surf)

!  Compute the Schmidt number of CO2 in seawater using the 
!  formulation presented by Wanninkhof (1992, J. Geophys. Res., 97,
!  7373-7382).
  do j = jsc, jec
    do i = isc, iec
      abiotic(n)%sc_co2(i,j) =                                                  &
             abiotic(n)%sc_co2_0 + t_prog(indtemp)%field(i,j,1,taum1) *         &
             (abiotic(n)%sc_co2_1 + t_prog(indtemp)%field(i,j,1,taum1) *        &
              (abiotic(n)%sc_co2_2 + t_prog(indtemp)%field(i,j,1,taum1) *       &
               abiotic(n)%sc_co2_3)) * grid_tmask(i,j,1)
      sc_no_term(i,j) = sqrt(660.0 / (abiotic(n)%sc_co2(i,j) + epsln)) * grid_tmask(i,j,1)
      Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
           Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +      &
           abiotic(n)%alpha(i,j) * rho(i,j,1,taum1) * sc_no_term(i,j)
      Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
           Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +      &
           abiotic(n)%csurf(i,j) * rho(i,j,1,taum1) * sc_no_term(i,j)
    enddo
  enddo

  ind = abiotic(n)%ind_14co2_flux

  ! calculate interpolated frac_14catm (fractionation of atmospheric 14CO2)
  if (abiotic(n)%frac_14catm_file .ne. ' ') then
    call time_interp_external(abiotic(n)%frac_14catm_id, model_time, abiotic(n)%frac_14catm)
  endif

  do j = jsc, jec
    do i = isc, iec
      abiotic(n)%c14surf(i,j) = abiotic(n)%csurf(i,j) *                                 &
           t_prog(abiotic(n)%ind_di14c)%field(i,j,1,taum1) /                            &
           (t_prog(abiotic(n)%ind_dic)%field(i,j,1,taum1) + 1.0e-40)
      Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
           Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +      &
           abiotic(n)%alpha(i,j) * rho(i,j,1,taum1) * sc_no_term(i,j) *                                    &
           (1.0 + abiotic(n)%frac_14catm(i,j) * 1.0e-03)
      Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
           Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +      &
           abiotic(n)%c14surf(i,j) * rho(i,j,1,taum1) * sc_no_term(i,j)
    enddo
  enddo

enddo

return

end subroutine ocmip2_abiotic_sum_sfc
! </SUBROUTINE> NAME="ocmip2_abiotic_sum_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_abiotic_zero_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>

subroutine ocmip2_abiotic_zero_sfc(Ocean_fields)

type(coupler_2d_bc_type), intent(inout) :: Ocean_fields

integer         :: n
integer         :: ind

do n = 1, instances
  ind = abiotic(n)%ind_co2_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0

  ind = abiotic(n)%ind_14co2_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0
enddo

return

end subroutine ocmip2_abiotic_zero_sfc
! </SUBROUTINE> NAME="ocmip2_abiotic_zero_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_abiotic_avg_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>

subroutine ocmip2_abiotic_avg_sfc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,    &
     isc_bnd, iec_bnd, jsc_bnd, jec_bnd, Ocean_fields, Ocean_avg_kount, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: iec_bnd
integer, intent(in)                                     :: jsc_bnd
integer, intent(in)                                     :: jec_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
integer                                                 :: Ocean_avg_kount
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer :: i_bnd_off
integer :: j_bnd_off
integer :: i, j, n
integer :: ind
real    :: divid

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

divid = 1./float(Ocean_avg_kount)

do n = 1, instances

  ind = abiotic(n)%ind_co2_flux

  do j = jsc, jec
    do i = isc, iec
      if (grid_tmask(i,j,1) == 1.0) then
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
      endif
    enddo
  enddo

  ind = abiotic(n)%ind_14co2_flux

  do j = jsc, jec
    do i = isc, iec
      if (grid_tmask(i,j,1) == 1.0) then
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
      endif
    enddo
  enddo

enddo

return

end subroutine ocmip2_abiotic_avg_sfc
! </SUBROUTINE> NAME="ocmip2_abiotic_avg_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_abiotic_sfc_end">
!
! <DESCRIPTION>
!       Initialize surface fields for flux calculations
! </DESCRIPTION>

subroutine ocmip2_abiotic_sfc_end

end subroutine ocmip2_abiotic_sfc_end
! </SUBROUTINE> NAME="ocmip2_abiotic_sfc_end"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_abiotic_source">
!
! <DESCRIPTION>
!     compute the source terms for the ABIOTICs, including boundary
!     conditions (not done in setvbc, to minimize number
!     of hooks required in MOM base code)
! </DESCRIPTION>
!
subroutine ocmip2_abiotic_source(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,     &
     T_prog, taum1, Grid, Time, rho_dzt)

integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: nk
integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
type(ocean_prog_tracer_type), intent(inout), dimension(:)       :: T_prog
integer, intent(in)                                             :: taum1
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time
real, dimension(isd:,jsd:,:,:), intent(in)                      :: rho_dzt

integer :: i, j, k, n
logical :: used

! calculate the source terms for ABIOTICs

! Loop over multiple instances
do n = 1, instances
  ! DI14C

  ! compute DI14C decay
  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        abiotic(n)%jdi14c(i,j,k) = t_prog(abiotic(n)%ind_di14c)%field(i,j,k,taum1) *    &
             abiotic(n)%lambda
        t_prog(abiotic(n)%ind_di14c)%th_tendency(i,j,k) =                               &
             t_prog(abiotic(n)%ind_di14c)%th_tendency(i,j,k) -                          &
             abiotic(n)%jdi14c(i,j,k) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

enddo

! Save variables for diagnostics
do n = 1, instances
   call diagnose_2d_comp(Time, Grid, abiotic(n)%id_sc_co2, abiotic(n)%sc_co2(:,:))
   call diagnose_2d_comp(Time, Grid, abiotic(n)%id_alpha, abiotic(n)%alpha(:,:))
   call diagnose_2d_comp(Time, Grid, abiotic(n)%id_csurf, abiotic(n)%csurf(:,:))
   call diagnose_2d_comp(Time, Grid, abiotic(n)%id_c14surf, abiotic(n)%c14surf(:,:))
   call diagnose_2d_comp(Time, Grid, abiotic(n)%id_pco2surf, abiotic(n)%pco2surf(:,:))
   call diagnose_2d_comp(Time, Grid, abiotic(n)%id_htotal, abiotic(n)%htotal(:,:))
   if (abiotic(n)%id_alk .gt. 0) then
      call diagnose_2d(Time, Grid, abiotic(n)%id_alk, t_prog(indsal)%field(:,:,1,taum1) * abiotic(n)%alkbar / abiotic(n)%sal_global)
   endif
   call diagnose_2d_comp(Time, Grid, abiotic(n)%id_po4, abiotic(n)%po4(isc:iec,jsc:jec))
   call diagnose_2d_comp(Time, Grid, abiotic(n)%id_sio4, abiotic(n)%sio4(isc:iec,jsc:jec))
   call diagnose_2d_comp(Time, Grid, abiotic(n)%id_frac_14catm, abiotic(n)%frac_14catm(:,:))
   call diagnose_3d_comp(Time, Grid, abiotic(n)%id_jdi14c, abiotic(n)%jdi14c(:,:,:))
enddo

return

end subroutine  ocmip2_abiotic_source
! </SUBROUTINE> NAME="ocmip2_abiotic_source"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_abiotic_start">
!
! <DESCRIPTION>
! Initialize variables, read in namelists, calculate constants
! for a given run and allocate diagnostic arrays
! </DESCRIPTION>
!
subroutine ocmip2_abiotic_start(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,     &
     T_prog, taup1, model_time, grid_dat, grid_tmask, grid_kmt,                 &
     grid_xt, grid_yt, grid_zt, grid_zw, grid_dzt, grid_tracer_axes,            &
     mpp_domain2d, rho_dzt)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
integer, intent(in)                                     :: taup1
type(time_type), intent(in)                             :: model_time
real, dimension(isd:,jsd:), intent(in)                  :: grid_dat
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask
integer, dimension(isd:,jsd:), intent(in)               :: grid_kmt
real, dimension(isd:,jsd:), intent(in)                  :: grid_xt
real, dimension(isd:,jsd:), intent(in)                  :: grid_yt
real, dimension(nk), intent(in)                         :: grid_zt
real, dimension(nk), intent(in)                         :: grid_zw
real, dimension(nk), intent(in)                         :: grid_dzt
integer, dimension(3), intent(in)                       :: grid_tracer_axes
type(domain2d), intent(in)                              :: mpp_domain2d
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho_dzt

character(len=64), parameter    :: sub_name = 'ocmip2_abiotic_start'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

real, parameter :: sperd = 24.0 * 3600.0
real, parameter :: spery = 365.25 * sperd

integer                                         :: i, j, k, n
character(len=fm_field_name_len+1)              :: suffix
character(len=fm_field_name_len+3)              :: long_suffix
character(len=256)                              :: caller_str
real                                            :: total_di14c
real                                            :: total_dic
real                                            :: total_di14c_bitwise
real                                            :: total_dic_bitwise
real, dimension(isd:ied,jsd:jed,nk)             :: wrk
character(len=fm_string_len), allocatable       :: local_restart_file(:)
logical                                         :: fld_exist
integer                                         :: l
integer                                         :: ind
integer                                         :: id_restart

  integer :: stdoutunit 
  stdoutunit=stdout() 

write(stdoutunit,*) 
write(stdoutunit,*) trim(note_header),                     &
                  'Starting ', trim(package_name), ' module'

!       Determine indices for temperature and salinity
indtemp = fm_get_index('/ocean_mod/prog_tracers/temp')
if (indtemp .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the temperature index')
endif

indsal = fm_get_index('/ocean_mod/prog_tracers/salt')
if (indsal .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the salinity index')
endif

! dynamically allocate the global ABIOTIC arrays
call allocate_arrays(isc, iec, jsc, jec, nk, isd, ied, jsd, jed)

!       save the *global* namelist values
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

call fm_util_start_namelist(package_name, '*global*', caller = caller_str)

htotal_scale_lo_in =  fm_util_get_real   ('htotal_scale_lo_in', scalar = .true.)
htotal_scale_hi_in =  fm_util_get_real   ('htotal_scale_hi_in', scalar = .true.)
htotal_in          =  fm_util_get_real   ('htotal_in', scalar = .true.)

call fm_util_end_namelist(package_name, '*global*', caller = caller_str)
      
! set default values for htotal_scale bounds
htotal_scale_lo(:,:) = htotal_scale_lo_in
htotal_scale_hi(:,:) = htotal_scale_hi_in

!       read in the namelists for each instance
do n = 1, instances
  call fm_util_start_namelist(package_name, abiotic(n)%name, caller = caller_str)

  abiotic(n)%frac_14catm_file       = fm_util_get_string ('frac_14catm_file', scalar = .true.)
  abiotic(n)%frac_14catm_name       = fm_util_get_string ('frac_14catm_name', scalar = .true.)
  abiotic(n)%frac_14catm_const      = fm_util_get_real   ('frac_14catm_const', scalar = .true.)
  abiotic(n)%alkbar                 = fm_util_get_real   ('alkbar', scalar = .true.)
  abiotic(n)%po4_const              = fm_util_get_real   ('po4_const', scalar = .true.)
  abiotic(n)%sio4_const             = fm_util_get_real   ('sio4_const', scalar = .true.)
  abiotic(n)%local_restart_file     = fm_util_get_string ('local_restart_file', scalar = .true.)
  abiotic(n)%sal_global             = fm_util_get_real   ('sal_global', scalar = .true.)
  abiotic(n)%dic_global             = fm_util_get_real   ('dic_global', scalar = .true.)
  abiotic(n)%di14c_global           = fm_util_get_real   ('di14c_global', scalar = .true.)
  abiotic(n)%half_life              = fm_util_get_real   ('half_life', scalar = .true.)
  abiotic(n)%sc_co2_0               = fm_util_get_real   ('sc_co2_0', scalar = .true.)
  abiotic(n)%sc_co2_1               = fm_util_get_real   ('sc_co2_1', scalar = .true.)
  abiotic(n)%sc_co2_2               = fm_util_get_real   ('sc_co2_2', scalar = .true.)
  abiotic(n)%sc_co2_3               = fm_util_get_real   ('sc_co2_3', scalar = .true.)

  call fm_util_end_namelist(package_name, abiotic(n)%name, caller = caller_str)
enddo
      
do n = 1, instances

!     Open the frac_14catm (fractionation of atmospheric 14CO2) file
!
!       If the file name is blank, then the 14C fractionation is assumed to
!       be added to the atmospheric concentration
  if (abiotic(n)%frac_14catm_file .ne. ' ') then
    abiotic(n)%frac_14catm_id = init_external_field(abiotic(n)%frac_14catm_file,        &
         abiotic(n)%frac_14catm_name, domain = mpp_domain2d, use_comp_domain = .true.)
    if (abiotic(n)%frac_14catm_id .eq. 0) then
      call mpp_error(FATAL, trim(error_header) //                                       &
           ' Could not open frac_14catm_file file: ' //                                 &
           trim(abiotic(n)%frac_14catm_file) // ' for ' // trim(abiotic(n)%frac_14catm_name))
    endif
  else
    call mpp_error(NOTE, trim(error_header) //                                          &
         ' Using constant field for atmospheric 14C for instance ' // trim(abiotic(n)%name))
    do j = jsc, jec
      do i = isc, iec
        abiotic(n)%frac_14catm(i,j) = abiotic(n)%frac_14catm_const
      enddo
    enddo
  endif

enddo

!       Read in additional information for a restart.
!
!       We must process all of the instances before restoring any files
!       as all fields must be registered before the fields are
!       restored, and fields from different instances may be in the
!       same file.
!
!       Note that the restart file names here must be different from
!       those for the tracer values.
allocate(restart(instances))
allocate(local_restart_file(instances))

write(stdoutunit,*)

do n = 1, instances

   ! Set the suffix for this instance (if instance name is "_",
   ! then use a blank suffix).
  if (abiotic(n)%name(1:1) .eq. '_') then
    suffix = ' '
  else
    suffix = '_' // abiotic(n)%name
  endif

  ! Check whether we are already using this restart file, if so,
  ! we do not want to duplicate it in the list of restart files
  ! since we only read each restart file once.
  ind = 0
  do l = 1, num_restart
    if (abiotic(n)%local_restart_file == local_restart_file(l)) then
      ind = l
      exit
    endif
  end do

  if (ind .eq. 0) then
    num_restart = num_restart + 1
    ind = num_restart
    local_restart_file(ind) = trim(abiotic(n)%local_restart_file)
  end if

  ! Check whether the field already exists in the restart file.
  ! If not, then set a default value.
  fld_exist = field_exist('INPUT/' // trim(abiotic(n)%local_restart_file), 'htotal' // trim(suffix) )

  if ( fld_exist ) then
    write (stdoutunit,*) trim(note_header),                       &
         'Reading additional information for instance ',        &
         ': Initializing instance ', trim(abiotic(n)%name)
  else
    write (stdoutunit,*) trim(note_header),                       &
         'Initializing instance ', trim(abiotic(n)%name)
    abiotic(n)%htotal(:,:) = htotal_in
    ! abiotic(n)%sal_global is set via the namelist
    abiotic(n)%sal_global_wrk(:,:) = 0.0
    abiotic(n)%global_wrk_duration = 0.0
  endif

  ! Register the field for restart
  id_restart = register_restart_field(restart(ind), abiotic(n)%local_restart_file,              &
                    'htotal' // trim(suffix), abiotic(n)%htotal,                                &
                    domain=mpp_domain2d, mandatory=fld_exist )
  id_restart = register_restart_field(restart(ind), abiotic(n)%local_restart_file,              &
                    'sal_global' // trim(suffix), abiotic(n)%sal_global,                        &
                    domain = mpp_domain2d, mandatory=fld_exist )
  id_restart = register_restart_field(restart(ind), abiotic(n)%local_restart_file,              &
                    'sal_global_wrk' // trim(suffix), abiotic(n)%sal_global_wrk,                &
                    domain=mpp_domain2d, mandatory=fld_exist )
  id_restart = register_restart_field(restart(ind), abiotic(n)%local_restart_file,              &
                    'global_wrk_duration' // trim(suffix), abiotic(n)%global_wrk_duration,      &
                    domain = mpp_domain2d, mandatory=fld_exist )

enddo

! Restore the restart fields if the file exists
do l = 1, num_restart
  if (file_exist('INPUT/' // trim(local_restart_file(l)))) then
    call restore_state(restart(l))
  end if
end do

! Print the surface salinities
do n = 1, instances
  write (stdoutunit,'(/1x,a,es16.9,a,a)')                         &
        'Annual, global, surface mean salinity = ',             &
        abiotic(n)%sal_global, ' (PSU) for instance ',          &
        trim(abiotic(n)%name)
enddo

deallocate(local_restart_file)

! initialize some arrays which are held constant for this
! simulation
do n = 1, instances
  abiotic(n)%po4(:,:) = abiotic(n)%po4_const
  abiotic(n)%sio4(:,:) = abiotic(n)%sio4_const
enddo

do n = 1, instances
  if (abiotic(n)%half_life .gt. 0.0) then
    abiotic(n)%lambda = log(2.0) / (abiotic(n)%half_life * spery)
  else
    call mpp_error(FATAL,trim(error_header) // ' Half-life <= 0')
  endif
enddo

! Set up analyses

! register the instance fields
do n = 1, instances

  if (abiotic(n)%name(1:1) .eq. '_') then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // abiotic(n)%name
    long_suffix = ' (' // trim(abiotic(n)%name) // ')'
  endif

  abiotic(n)%id_sc_co2 = register_diag_field(trim(diag_name),           &
       'sc_co2' // trim(suffix), grid_tracer_axes(1:2),                 &
       model_time, 'Schmidt number - CO2' // trim(long_suffix), ' ',    &
       missing_value = -1.0e+10)
  abiotic(n)%id_alpha = register_diag_field(trim(diag_name),            &
       'alpha' // trim(suffix), grid_tracer_axes(1:2),                  &
       model_time, 'Alpha CO2' // trim(long_suffix), 'mol/kg/atm',      &
       missing_value = -1.0e+10)

  abiotic(n)%id_csurf = register_diag_field(trim(diag_name),            &
       'csurf' // trim(suffix), grid_tracer_axes(1:2),                  &
       model_time, 'CO2* water' // trim(long_suffix), 'mol/kg',         &
       missing_value = -1.0e+10)

  abiotic(n)%id_c14surf = register_diag_field(trim(diag_name),          &
       'c14surf' // trim(suffix), grid_tracer_axes(1:2),                &
       model_time, 'CO2* water' // trim(long_suffix), 'mol/kg',         &
       missing_value = -1.0e+10)

  abiotic(n)%id_pco2surf = register_diag_field(trim(diag_name),         &
       'pco2surf' // trim(suffix), grid_tracer_axes(1:2),               &
       model_time, 'Oceanic pCO2' // trim(long_suffix), 'ppm',          &
       missing_value = -1.0e+10)

  abiotic(n)%id_sfc_flux_co2 = register_diag_field(trim(diag_name),                     &
       'sfc_flux_co2' // trim(suffix), grid_tracer_axes(1:2),                           &
       model_time, 'CO2 surface flux' // trim(long_suffix), 'mol m^-2 s^-1',            &
       missing_value = -1.0e+10)

  abiotic(n)%id_sfc_flux_14co2 = register_diag_field(trim(diag_name),                   &
       'sfc_flux_14co2' // trim(suffix), grid_tracer_axes(1:2),                         &
       model_time, '14CO2 surface flux' // trim(long_suffix), 'mol m^-2 s^-1',          &
       missing_value = -1.0e+10)

  abiotic(n)%id_htotal = register_diag_field(trim(diag_name),           &
       'htotal' // trim(suffix), grid_tracer_axes(1:2),                 &
       model_time, 'H+ ion concentration' // trim(long_suffix), ' ',    &
       missing_value = -1.0e+10)

  abiotic(n)%id_alk = register_diag_field(trim(diag_name),              &
       'alk' // trim(suffix), grid_tracer_axes(1:2),                    &
       model_time, 'ALK' // trim(long_suffix), 'eq kg^-1',              &
       missing_value = -1.0e+10)

  abiotic(n)%id_po4 = register_diag_field(trim(diag_name),              &
       'po4' // trim(suffix), grid_tracer_axes(1:2),                    &
       model_time, 'PO4' // trim(long_suffix), 'mol kg^-1',             &
       missing_value = -1.0e+10)

  abiotic(n)%id_sio4 = register_diag_field(trim(diag_name),             &
       'sio4' // trim(suffix), grid_tracer_axes(1:2),                   &
       model_time, 'SiO4' // trim(long_suffix), 'mol kg^-1',            &
       missing_value = -1.0e+10)

  abiotic(n)%id_frac_14catm = register_diag_field(trim(diag_name),              &
       'frac_14catm' // trim(suffix), grid_tracer_axes(1:2),                    &
       model_time, '14C fractionation' // trim(long_suffix), ' ',               &
       missing_value = -1.0e+10)
  abiotic(n)%id_jdi14c = register_diag_field(trim(diag_name),                   &
       'jdi14c' // trim(suffix), grid_tracer_axes(1:3),                         &
       model_time, 'Restoring production' // trim(long_suffix), 'mol/kg/s',     &
       missing_value = -1.0e+10)
enddo

!       integrate the total concentrations of some tracers
!       for the start of the run

!       Use taup1 time index for the start of a run, and taup1 time
!       index for the end of a run so that we are integrating the
!       same time level and should therefore get identical results
do n = 1, instances

  total_dic = 0.0
  total_di14c = 0.0

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        total_dic = total_dic +                                 &
             t_prog(abiotic(n)%ind_dic)%field(i,j,k,taup1) *    &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_di14c = total_di14c +                             &
             t_prog(abiotic(n)%ind_di14c)%field(i,j,k,taup1) *  &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo

  call mpp_sum(total_dic)
  call mpp_sum(total_di14c)

  write (stdoutunit,*) '  Instance ', trim(abiotic(n)%name)
  write (stdoutunit,                                              &
       '(/'' Total DIC  = '',es19.12,'' Gmol-C'')')             &
       total_dic * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total DI14C  = '',es19.12,'' Gmol-C'')')           &
       total_di14c * 1.0e-09

  do k = 1, nk
    do j = jsd, jed
      do i = isd, ied
        wrk(i,j,k) =                                                            &
             t_prog(abiotic(n)%ind_dic)%field(i,j,k,taup1) *                    &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo
  total_dic_bitwise = mpp_global_sum(mpp_domain2d, wrk, BITWISE_EXACT_SUM)

  do k = 1, nk
    do j = jsd, jed
      do i = isd, ied
        wrk(i,j,k) =                                                            &
             t_prog(abiotic(n)%ind_di14c)%field(i,j,k,taup1) *                  &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo
  total_di14c_bitwise = mpp_global_sum(mpp_domain2d, wrk, BITWISE_EXACT_SUM)

  write (stdoutunit,*) '  Instance ', trim(abiotic(n)%name), ' bitwise exact sum'
  write (stdoutunit,                                              &
       '(/'' Total DIC  = '',es19.12,'' Gmol-C'')')             &
       total_dic_bitwise * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total DI14C  = '',es19.12,'' Gmol-C'')')           &
       total_di14c_bitwise * 1.0e-09

enddo

write(stdoutunit,*)
write(stdoutunit,*) trim(note_header), 'Abiotic tracer runs initialized'
write(stdoutunit,*)

return

end subroutine  ocmip2_abiotic_start
! </SUBROUTINE> NAME="ocmip2_abiotic_start"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_abiotic_tracer">
!
! <DESCRIPTION>
!     Perform things that should be done in tracer, but are done here
! in order to minimize the number of hooks necessary in the MOM4 basecode
! </DESCRIPTION>
!
subroutine ocmip2_abiotic_tracer(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,     &
     T_prog, grid_dat, grid_tmask, grid_tcella, taum1, dtts, end_of_year)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
type(ocean_prog_tracer_type), intent(in), dimension(:)  :: T_prog
real, dimension(isd:,jsd:), intent(in)                  :: grid_dat
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask
real, dimension(nk), intent(in)                         :: grid_tcella
integer, intent(in)                                     :: taum1
real, intent(in)                                        :: dtts
logical, intent(in)                                     :: end_of_year
integer :: i, j, n
real    :: temp

! accumulate global annual means
do n = 1, instances
  do j = jsc, jec
    do i = isc, iec
      abiotic(n)%sal_global_wrk(i,j) = abiotic(n)%sal_global_wrk(i,j) +         &
           t_prog(indsal)%field(i,j,1,taum1) *                                  &
           grid_tmask(i,j,1) * grid_dat(i,j) * dtts
    enddo
  enddo
  abiotic(n)%global_wrk_duration = abiotic(n)%global_wrk_duration + dtts
enddo

! calculate global means of at the end of the year
if (end_of_year) then

  do n = 1, instances
    temp = 0.0
    do j = jsc, jec
      do i = isc, iec
        temp = temp + abiotic(n)%sal_global_wrk(i,j)
      enddo
    enddo
    call mpp_sum(temp)
    abiotic(n)%sal_global = temp / abiotic(n)%global_wrk_duration / grid_tcella(1)
  enddo

  ! reset work variables to zero
  do n = 1, instances
    do j = jsc, jec
      do i = isc, iec
        abiotic(n)%sal_global_wrk(i,j) = 0.0
      enddo
    enddo
    abiotic(n)%global_wrk_duration = 0.0
  enddo

endif

return

end subroutine  ocmip2_abiotic_tracer
! </SUBROUTINE> NAME="ocmip2_abiotic_tracer"

end module  ocmip2_abiotic_mod

      real function gmean(im, jm, jfirst, jlast, q)
      use fv_pack, only: grid_weight
      implicit none

! !INPUT PARAMETERS:
      integer  im, jm                        ! Horizontal dimensions
      integer  jfirst, jlast                 ! Latitude strip
      real q(im,jfirst:jlast)            ! 2D field 

      integer i, j
      real xsum(jfirst:jlast)

          xsum = 0.
      do j=jfirst,jlast
        do i=1,im
          xsum(j) = xsum(j) + q(i,j)
        enddo
          xsum(j) = xsum(j)*grid_weight(j)
      enddo

      call par_vecsum( jm, jfirst, jlast, xsum, gmean)
      end

#include "cosp_defs.H"

module cosp_driver_mod

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


use mpp_mod,                  only: input_nml_file
use fms_mod,                  only: open_namelist_file, open_file,  &
                                    close_file, error_mesg, FATAL, &
                                    file_exist, mpp_pe, mpp_root_pe,   &
                                    check_nml_error, write_version_number, &
                                    stdlog
use sat_vapor_pres_mod,       only: compute_qs
use time_manager_mod,         only: set_date, time_type, operator (+), &
                                    operator(-), operator(<),    &
                                    operator(>), operator(<=), &
                                    operator(>=),  get_date, print_date, &
                                    get_calendar_type, NOLEAP, &
                                    assignment(=), set_time
USE MOD_COSP_TYPES,           only: cosp_config, cosp_gridbox,    &
                                    cosp_subgrid, cosp_sgradar,   &
                                    cosp_sglidar, cosp_isccp, &
#ifdef RTTOV
                                    cosp_rttov, &
#endif
                                    cosp_vgrid, cosp_radarstats,  &
                                    cosp_lidarstats, &
                                    cosp_sghydro,  cosp_misr, &
                                    construct_cosp_gridbox,  &
                                    construct_cosp_misr,  &
                                    construct_cosp_vgrid,  &
                                    construct_cosp_subgrid, &
                                    construct_cosp_sghydro, &
                                    construct_cosp_sgradar, &
                                    construct_cosp_radarstats, &
                                    construct_cosp_sglidar, &
                                    construct_cosp_lidarstats, &
                                    construct_cosp_isccp, &           
#ifdef RTTOV
                                    construct_cosp_rttov, &           
                                    free_cosp_rttov, &           
#endif
                                    free_cosp_gridbox,  &
                                    free_cosp_misr,  &
                                    free_cosp_vgrid,  &
                                    free_cosp_subgrid, &
                                    free_cosp_sghydro, &
                                    free_cosp_sgradar, &
                                    free_cosp_radarstats, &
                                    free_cosp_sglidar, &
                                    free_cosp_lidarstats, &
                                    free_cosp_isccp
USE MOD_COSP,                 only: cosp
USE MOD_COSP_IO,              only: read_cosp_output_nl,  &
                                    map_ll_to_point, map_point_to_ll
                       
use MOD_COSP_CONSTANTS,       only: PARASOL_NREFL, I_LSCLIQ, I_LSCICE, &
                                    I_CVCLIQ, I_CVCICE, I_LSGRPL, &
                                    I_LSRAIN, I_LSSNOW, I_CVRAIN, I_CVSNOW,&
                                    N_HYDRO, RTTOV_MAX_CHANNELS
use MOD_COSP_Modis_Simulator, only: COSP_MODIS, FREE_COSP_MODIS,  &
                                    CONSTRUCT_COSP_MODIS
use cosp_diagnostics_mod,     only: cosp_diagnostics_init,   &
                                    cosp_diagnostics_time_vary, &
                                    output_cosp_fields, &
                                    cosp_diagnostics_endts, &
                                    cosp_diagnostics_end
use mod_cosp_utils,           only: flip_vert_index

IMPLICIT NONE

public cosp_driver, cosp_driver_init, cosp_driver_end, cosp_driver_endts, &
       cosp_driver_time_vary

!---------------------------------------------------------------------
!----------- version number for this module --------------------------

character(len=128)  :: version =  '$Id: cosp_driver.F90,v 20.0 2013/12/13 23:15:41 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'

!---------------------------------------------------------------------
!namelist variables

character(len=512) :: finput ! Input file name, not used in FMS
character(len=512) :: cmor_nl = '   '  ! not used in FMS
integer :: overlap = 3   !  overlap type: 1=max, 2=rand, 3=max/rand
integer :: isccp_topheight = 1  
                    ! 1 = adjust top height using both a computed
                    !     infrared brightness temperature and the visible
                    !     optical depth to adjust cloud top pressure. Note
                    !     that this calculation is most appropriate to 
                    !     compare to ISCCP data during sunlit hours.
                    ! 2 = do not adjust top height, that is cloud top
                    !     pressure is the actual cloud top pressure
                    !     in the model
                    ! 3 = adjust top height using only the computed
                    !     infrared brightness temperature. Note that this
                    !     calculation is most appropriate to compare to 
                    !     ISCCP IR only algortihm (i.e. you can compare to 
                    !     nighttime ISCCP data with this option)

integer :: isccp_topheight_direction = 2   
                    !     direction for finding atmosphere pressure level
                    !     with interpolated temperature equal to the 
                    !     radiance determined cloud-top temperature
                    ! 1 = find the *lowest* altitude (highest pressure) 
                    !     level with interpolated temperature equal to the 
                    !     radiance determined cloud-top temperature
                    ! 2 = find the *highest* altitude (lowest pressure) 
                    !     level with interpolated temperature equal to the 
                    !     radiance determined cloud-top temperature
                    !     ONLY APPLICABLE IF top_height EQUALS 1 or 3

integer :: Nlr = 40 !     Number of levels in statistical outputs
integer :: Npoints_it = 20000  
                    !     Max number of gridpoints to be processed in 
                    !     one iteration
real :: radar_freq = 94.       ! CloudSat radar frequency (GHz)
real :: k2= -1.                ! |K|^2, -1=use frequency dependent default
integer :: surface_radar = 0   !  surface=1, spaceborne=0 
integer :: use_mie_tables = 0  ! use a precomputed lookup table? yes=1,no=0
integer :: use_gas_abs = 1     ! include gaseous absorption? yes=1,no=0
integer :: do_ray = 0          ! calculate/output Rayleigh refl=1, not=0
integer :: melt_lay = 0        ! melting layer model off=0, on=1
integer :: Nprmts_max_hydro = 12 
                               ! Max number of parameters for hydrometeor 
                               ! size distributions
integer :: Naero = 1           ! Number of aerosol species (Not used)
integer :: Nprmts_max_aero = 1 ! Max number of parameters for aerosol 
                               ! size distributions (Not used)
integer :: lidar_ice_type = 0  ! Ice particle shape in lidar calculations 
                               ! (0=ice-spheres ; 1=ice-non-spherical)
logical :: use_vgrid = .true.  ! Use fixed vertical grid for outputs? 
                               ! (if .true. then you need to define number 
                               ! of levels with Nlr)
logical :: csat_vgrid =.true.  ! CloudSat vertical? 
                               ! (if .true. then the CloudSat standard grid
                               ! is used for the outputs.
logical :: use_precipitation_fluxes =.true. 
                               ! True if precipitation fluxes are input 
                               ! to the algorithm
logical :: use_reff =.true.    ! True if you want effective radius to be 
                               ! used by radar simulator (always used 
                               ! by lidar)
logical :: use_input_file = .false.
logical :: produce_cmor_output_fields = .false.
real    :: emsfc_lw_nml=0.94
logical :: use_rh_wrt_liq = .true.
!-------------------------------------------------------------------------
!-------------- RTTOV inputs
!-------------------------------------------------------------------------
integer :: platform = 1    ! satellite platform
integer :: satellite = 15  ! satellite
integer :: Instrument = 0  ! instrument
integer :: Nchannels = 8   ! Number of channels to be computed
real :: ZenAng = 50.       ! Satellite Zenith Angle
real :: co2 = 5.241e-04    ! mixing ratio of trace gas
real :: ch4 = 9.139e-07    ! mixing ratio of trace gas
real :: n2o = 4.665e-07    ! mixing ratio of trace gas
real :: co = 2.098e-07     ! mixing ratio of trace gas
integer,dimension(RTTOV_MAX_CHANNELS) :: Channels = 0
                           ! Channel numbers (please be sure that 
                           ! you supply Nchannels)
real,dimension(RTTOV_MAX_CHANNELS) :: Surfem = 0.0 
                           ! Surface emissivity (please be sure that 
                           ! you supply Nchannels)

namelist/COSP_INPUT/cmor_nl,overlap,isccp_topheight, &
                    isccp_topheight_direction, &
                    use_vgrid,nlr,csat_vgrid,  &
                    npoints_it,finput, &
                    radar_freq,surface_radar,use_mie_tables, &
                    use_input_file, produce_cmor_output_fields, &
                    emsfc_lw_nml, use_rh_wrt_liq, &
                    use_gas_abs,do_ray,melt_lay,k2,Nprmts_max_hydro,  &
                    Naero,Nprmts_max_aero,lidar_ice_type, &
                    use_precipitation_fluxes,use_reff, &
                    platform,satellite,Instrument,Nchannels, &
                    Channels,Surfem,ZenAng,co2,ch4,n2o,co

! Local variables

character(len=64)  :: cosp_output_nl='cosp_output_nl.txt'
integer            :: Ncolumns ! Number of subcolumns in SCOPS
integer            :: Nlevels  ! Number of levels
type(cosp_config)  :: cfg   ! Configuration options
integer            :: geomode
real               :: emsfc_lw
double precision   :: time=1.D0
double precision   :: time_bnds(2)= (0.5D0, 1.5D0)

!---------------- End of declaration of variables --------------



contains

!######################################################################

subroutine cosp_driver_init (lonb, latb, Time_diag, axes, kd_in, ncol_in)

real, dimension(:,:),  intent(in) :: lonb, latb
type(time_type),       intent(in) :: Time_diag
integer, dimension(4), intent(in) :: axes
integer,               intent(in) :: kd_in, ncol_in

   integer :: io, unit, ierr, logunit
   integer :: imax, jmax

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=cosp_input, iostat=io)
    ierr = check_nml_error(io,"cosp_input")
#else
!---------------------------------------------------------------------
!    read namelist.
!---------------------------------------------------------------------
    if ( file_exist('input.nml')) then
       unit =  open_namelist_file ()
      ierr=1; do while (ierr /= 0)
      read  (unit, nml=cosp_input, iostat=io, end=10)
      ierr = check_nml_error(io,'cosp_input')
      enddo
10    call close_file (unit)
    endif
#endif
        
!---------------------------------------------------------------------
!    write namelist to logfile.
!---------------------------------------------------------------------
    call write_version_number(version, tagname)
    logunit = stdlog()
    if (mpp_pe() == mpp_root_pe() )    &
                        write (logunit, nml=cosp_input)

    if (use_mie_tables /= 0) then
      call error_mesg ('cosp_driver', &
            'use_mie_tables must be set to 0 currently', FATAL)
    endif

    nlevels = kd_in
    ncolumns = ncol_in 
    imax = size(lonb,1) - 1
    jmax = size(lonb,2) - 1

    call read_cosp_output_nl(cosp_output_nl,cfg)

    call cosp_diagnostics_init      &
            (imax, jmax, Time_diag, axes, nlevels, ncolumns, cfg, &
             use_vgrid, csat_vgrid, nlr)     

!---------------------------------------------------------------------
!   COSP takes a single, spacially independent value for surface
!   emissivity. it may be supplied via namelist.
!---------------------------------------------------------------------
    emsfc_lw = emsfc_lw_nml
 
!--------------------------------------------------------------------
!   variable geomode indicates that the grid (i,j) => (lon,lat)
!--------------------------------------------------------------------
    geomode = 2
 

end subroutine cosp_driver_init


!######################################################################

subroutine cosp_driver_time_vary (Time_diag)

type(time_type), intent(in)  :: Time_diag

    call cosp_diagnostics_time_vary (Time_diag)

end subroutine cosp_driver_time_vary


!######################################################################

subroutine cosp_driver_endts

    call cosp_diagnostics_endts

end subroutine cosp_driver_endts


!####################################################################

subroutine cosp_driver   &
        (lat_in, lon_in, daytime_in, phalf_plus, p_full_in, zhalf_plus,&
         z_full_in, u_wind_in, v_wind_in, mr_ozone_in, &
         T_in, sh_in, tca_in, cca_in, lsliq_in, lsice_in, ccliq_in, &
         ccice_in, fl_lsrain_in, fl_lssnow_in, fl_lsgrpl_in, &
         fl_ccrain_in,  &
         fl_ccsnow_in, reff_lsclliq_in, reff_lsclice_in,   &
         reff_lsprliq_in, reff_lsprice_in, reff_ccclliq_in,  &
         reff_ccclice_in, reff_ccprliq_in, reff_ccprice_in,  &
         skt_in, land_in, Time_diag, is, js, stoch_mr_liq_in, &
         stoch_mr_ice_in, stoch_size_liq_in, stoch_size_frz_in, &
         tau_stoch_in, lwem_stoch_in, stoch_cloud_type_in)
!--------------------------------------------------------------------
!    subroutine cosp_driver is the interface between the cosp simulator 
!    code and the AM model.
!--------------------------------------------------------------------
real, dimension(:,:),   intent(in) :: lat_in, lon_in, skt_in, land_in, &
                                      u_wind_in, v_wind_in
real, dimension(:,:), intent(in) :: daytime_in
real, dimension(:,:,:), intent(in) :: phalf_plus, p_full_in, &
        zhalf_plus, z_full_in, T_in, sh_in, &
        tca_in, cca_in, lsliq_in, lsice_in, ccliq_in, ccice_in, &
        fl_lsrain_in, fl_lssnow_in, fl_lsgrpl_in, fl_ccrain_in, &
        fl_ccsnow_in, mr_ozone_in, &
        reff_lsclliq_in, reff_lsclice_in, reff_lsprliq_in, &
        reff_lsprice_in, reff_ccclliq_in, reff_ccclice_in, &
        reff_ccprliq_in, reff_ccprice_in
real, dimension(:,:,:,:), intent(in), optional ::  &
               tau_stoch_in, lwem_stoch_in, stoch_cloud_type_in, &
               stoch_mr_liq_in, stoch_mr_ice_in, stoch_size_liq_in, &
               stoch_size_frz_in
type(time_type), intent(in) :: Time_diag

!local variables:

  integer, intent(in) :: is, js
  real, dimension(size(T_in,1)*size(T_in,2), size(T_in,3), &
                              ncolumns)  :: y3, y3a, y4, y5, y6, y7, y8
  integer :: i, j, n, l
  integer :: k

  type(cosp_gridbox) :: gbx ! Gridbox information. Input for COSP
  type(cosp_subgrid) :: sgx     ! Subgrid outputs
  type(cosp_sghydro) :: sghydro ! Subgrid condensate
  type(cosp_sgradar) :: sgradar ! Output from radar simulator
  type(cosp_sglidar) :: sglidar ! Output from lidar simulator
  type(cosp_isccp)   :: isccp   ! Output from ISCCP simulator
  type(cosp_modis)   :: modis   ! Output from MODIS simulator
  type(cosp_misr)    :: misr    ! Output from MISR simulator
#ifdef RTTOV 
  type(cosp_rttov)   :: rttov   ! Output from RTTOV 
#endif 
  type(cosp_vgrid)   :: vgrid   ! Information on vertical grid of stats
  type(cosp_radarstats) :: stradar ! Summary statistics from radar simulator
  type(cosp_lidarstats) :: stlidar ! Summary statistics from lidar simulator
  real, dimension ( size(T_in,1)*size(T_in,2), size(T_in,3)) :: &
                    fl_lsrain, &
                    fl_lssnow, fl_lsgrpl, fl_ccrain, fl_ccsnow
  real, dimension ( size(T_in,1)*size(T_in,2),    &
                                  Ncolumns, size(T_in,3)) :: &
                                                          cloud_type
  real, dimension ( size(T_in,1),size(T_in,2), size(T_in,3)) :: &
                                                p_half_in, z_half_in
  integer :: nlon,nlat,npoints

  !---------------- End of declaration of variables --------------
   
      nlon = size(T_in,1)
      nlat = size(T_in,2)
      npoints = nlon*nlat
 
 
      p_half_in(:,:,1:size(T_in,3)) = phalf_plus(:,:,2:size(T_in,3)+1)
      z_half_in(:,:,1:size(T_in,3)) = zhalf_plus(:,:,2:size(T_in,3)+1)
      if (present (tau_stoch_in)         .and. &
          present (lwem_stoch_in)        .and. &
          present (stoch_cloud_type_in)  .and. &
          present (stoch_mr_liq_in)      .and. &
          present (stoch_mr_ice_in)      .and. &
          present (stoch_size_liq_in)    .and. &
          present (stoch_size_frz_in) ) then
        sgx%cols_input_from_model = .true.
      else
        sgx%cols_input_from_model = .false.
      endif


      call construct_cosp_gridbox    &
            (time, time_bnds, radar_freq, surface_radar, use_mie_tables,  &
             use_gas_abs, do_ray, melt_lay, k2, Npoints, Nlevels,   &
             Ncolumns, N_HYDRO, Nprmts_max_hydro, Naero, Nprmts_max_aero, &
             Npoints_it, lidar_ice_type, isccp_topheight,  &
             isccp_topheight_direction,overlap, emsfc_lw,  &
             use_precipitation_fluxes, use_reff, &
             Platform, Satellite, Instrument, Nchannels, ZenAng, &
             channels(1:Nchannels), surfem(1:Nchannels), co2, ch4, n2o, co,&
             gbx)
  
      call produce_cosp_input_fields ( Npoints, Nlevels, N_hydro,  &
              lon_in, lat_in, daytime_in, p_half_in, p_full_in, z_half_in, &
              z_full_in, u_wind_in, v_wind_in, mr_ozone_in, T_in, &
              sh_in, tca_in, &
              cca_in, lsliq_in, lsice_in, ccliq_in, ccice_in,  &
              fl_lsrain_in,  &
              fl_lssnow_in, fl_lsgrpl_in, fl_ccrain_in, fl_ccsnow_in, &
              reff_lsclliq_in, reff_lsclice_in, reff_lsprliq_in, &
              reff_lsprice_in, reff_ccclliq_in, reff_ccclice_in,  &
              reff_ccprliq_in, reff_ccprice_in, tau_stoch_in,  &
              lwem_stoch_in, stoch_cloud_type_in, skt_in, land_in, &
              cloud_type, gbx)  
        
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! Define new vertical grid
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      call construct_cosp_vgrid(gbx,Nlr,use_vgrid,csat_vgrid,vgrid)
        
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! Allocate memory for other types
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      call construct_cosp_subgrid(Npoints, Ncolumns, Nlevels, sgx)

      call construct_cosp_sghydro(Npoints,Ncolumns,Nlevels,N_hydro,sghydro)

      if (sgx%cols_input_from_model) then
!---------------------------------------------------------------------
!    convert the stochastic column inputs from lon-lat to npoints, then
!    save the column values, reversing the vertical indices, into the
!    cosp_subgrid_type variables.
!---------------------------------------------------------------------
        call map_ll_to_point(nlon,nlat,npoints, &
                        x4= stoch_mr_liq_in, y3= y3  )
        call map_ll_to_point(nlon,nlat,npoints, &
                        x4= stoch_mr_ice_in   (:,:,:,:), y3= y4  )
        call map_ll_to_point(nlon,nlat,npoints, &
                        x4= stoch_size_liq_in, y3= y5  )
        call map_ll_to_point(nlon,nlat,npoints, &
                        x4= stoch_size_frz_in, y3= y6  )
        call map_ll_to_point(nlon,nlat,npoints, &
                        x4= tau_stoch_in, y3= y7  )
        call map_ll_to_point(nlon,nlat,npoints, &
                        x4= lwem_stoch_in, y3= y8  )
        call map_ll_to_point(nlon,nlat,npoints, &
                        x4= stoch_cloud_type_in(:,:,:,:), y3= y3a  )
        do l=1, NCOLUMNS
          do k=1,nlevels
            do n=1,npoints
              if (y3a(n,k,l) == 1.0) then
                sghydro%mr_hydro(n,l,nlevels-k+1,I_LSCLIQ) = y3(n,k,l)
                sghydro%mr_hydro(n,l,nlevels+1-k,I_LSCICE) = y4(n,k,l)
                if ( sghydro%mr_hydro(n,l,nlevels-k+1,I_LSCLIQ) > 0.0) then
                  sghydro%Reff(n,l,nlevels-k+1,I_LSCLIQ) = y5(n,k,l)
                else
                  sghydro%Reff(n,l,nlevels+1-k,I_LSCLIQ) = 0.0          
                endif
                if (sghydro%mr_hydro(n,l,nlevels+1-k,I_LSCICE) > 0.0) then
                  sghydro%Reff(n,l,nlevels+1-k,I_LSCICE) = y6(n,k,l)
                else
                  sghydro%Reff(n,l,nlevels+1-k,I_LSCICE) = 0.0          
                endif
              else
                sghydro%mr_hydro(n,l,nlevels+1-k,I_LSCLIQ) = 0.0          
                sghydro%mr_hydro(n,l,nlevels+1-k,I_LSCICE) = 0.0          
                sghydro%Reff(n,l,nlevels+1-k,I_LSCLIQ) = 0.0          
                sghydro%Reff(n,l,nlevels+1-k,I_LSCICE) = 0.0          
              endif
              if (y3a(n,k,l) == 2.0) then
                sghydro%mr_hydro(n,l,nlevels+1-k,I_CVCLIQ) = y3(n,k,l)
                sghydro%mr_hydro(n,l,nlevels+1-k,I_CVCICE) = y4(n,k,l)
                if (sghydro%mr_hydro(n,l,nlevels+1-k,I_CVCLIQ) > 0.0) then
                  sghydro%Reff(n,l,nlevels+1-k,I_CVCLIQ) = y5(n,k,l)
                else
                  sghydro%Reff(n,l,nlevels+1-k,I_CVCLIQ) = 0.0          
                endif
                if (sghydro%mr_hydro(n,l,nlevels+1-k,I_CVCICE) > 0.0) then
                  sghydro%Reff(n,l,nlevels+1-k,I_CVCICE) = y6(n,k,l)
                else
                  sghydro%Reff(n,l,nlevels+1-k,I_CVCICE) = 0.0          
                endif
              else
                sghydro%mr_hydro(n,l,nlevels+1-k,I_CVCLIQ) = 0.0          
                sghydro%mr_hydro(n,l,nlevels+1-k,I_CVCICE) = 0.0          
                sghydro%Reff(n,l,nlevels+1-k,I_CVCLIQ) = 0.0          
                sghydro%Reff(n,l,nlevels+1-k,I_CVCICE) = 0.0          
              endif
              sgx%dtau_col(n,l,k) = y7(n,k,l)
              sgx%dem_col(n,l,k) = y8(n,k,l)
            end do
          end do
        end do
      endif
      call construct_cosp_sgradar  &
                              (cfg,Npoints,Ncolumns,Nlevels,N_HYDRO,sgradar)
      call construct_cosp_radarstats   &
                        (cfg,Npoints,Ncolumns,vgrid%Nlvgrid,N_HYDRO,stradar)
      call construct_cosp_sglidar   &
                (cfg,Npoints,Ncolumns,Nlevels,N_HYDRO,PARASOL_NREFL,sglidar)
      call construct_cosp_lidarstats  &
          (cfg,Npoints,Ncolumns,vgrid%Nlvgrid,N_HYDRO,PARASOL_NREFL,stlidar)
      call construct_cosp_isccp  &
                               (cfg,Npoints,Ncolumns,Nlevels,isccp)
      call construct_cosp_modis    &
                                          (cfg,Npoints,Ncolumns,modis)
      call construct_cosp_misr   &
                               (cfg,Npoints,misr)
#ifdef RTTOV 
      call construct_cosp_rttov   &
                                 (Npoints,Nchannels,rttov) 
#endif
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! Call simulator
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      if (Ncolumns == 1) then
        if (gbx%use_precipitation_fluxes) then
          call error_mesg ('cosp_driver:cosp_driver', &
              'Use of precipitation fluxes not supported in&
                                & CRM mode (Ncolumns=1)', FATAL)
        endif
        if ((maxval(gbx%dtau_c) > 0.0).or.(maxval(gbx%dem_c) > 0.0)) then
          call error_mesg ('cosp_driver:cosp_driver', &
              ' dtau_c > 0.0 or dem_c > 0.0. In CRM mode (Ncolumns=1) &
             &the optical depth (emmisivity) of all clouds must be &
             &passed through dtau_s (dem_s)', FATAL)
        endif
      endif

!-------------------------------------------------------------------------
! save the grid-box mean of these fields for diagnostic output. The gbx%
! arrays will be changed to sub-column values in subroutine cosp.
!------------------------------------------------------------------------
      fl_lsrain = gbx%rain_ls
      fl_lssnow = gbx%snow_ls
      fl_lsgrpl = gbx%grpl_ls
      fl_ccrain = gbx%rain_cv
      fl_ccsnow = gbx%snow_cv
#ifdef RTTOV 
      call cosp(overlap,Ncolumns,cfg,vgrid,gbx,sgx,sgradar,sglidar,  &
                isccp,misr,modis,rttov,stradar,stlidar, sghydro, cloud_type)
#else
      call cosp(overlap,Ncolumns,cfg,vgrid,gbx,sgx,sgradar,sglidar,  &
                      isccp,misr,modis,stradar,stlidar, sghydro, cloud_type)
#endif

!-------------------------------------------------------------------------
!    define the effective size of precipitation particles in the gridbox. 
!    each subcolumn with precip type will have the same size.
!-------------------------------------------------------------------------
      gbx%Reff(:,:,I_LSRAIN) = 0.
      gbx%Reff(:,:,I_LSSNOW) = 0.
      gbx%Reff(:,:,I_LSGRPL) = 0.
      gbx%Reff(:,:,I_CVRAIN) = 0.
      gbx%Reff(:,:,I_CVSNOW) = 0.
      do l=1,Ncolumns
        gbx%Reff(:,:,I_LSRAIN) =    &
                  Max(sghydro%reff(:,l,:,I_LSRAIN), gbx%Reff(:,:,I_LSRAIN))
        gbx%Reff(:,:,I_LSSNOW) =    &
                  Max(sghydro%reff(:,l,:,I_LSSNOW), gbx%Reff(:,:,I_LSSNOW))
        gbx%Reff(:,:,I_LSGRPL) =    &
                  Max(sghydro%reff(:,l,:,I_LSGRPL), gbx%Reff(:,:,I_LSGRPL))
        gbx%Reff(:,:,I_CVRAIN) =    &
                  Max(sghydro%reff(:,l,:,I_CVRAIN), gbx%Reff(:,:,I_CVRAIN))
        gbx%Reff(:,:,I_CVSNOW) =    &
                   Max(sghydro%reff(:,l,:,I_CVSNOW), gbx%Reff(:,:,I_CVSNOW))
      end do

!-------------------------------------------------------------------------
!  return these fields to grid-box mean values for diagnostic 
!  output purposes.
!-------------------------------------------------------------------------
      gbx%rain_ls = fl_lsrain
      gbx%snow_ls = fl_lssnow
      gbx%grpl_ls = fl_lsgrpl
      gbx%rain_cv = fl_ccrain
      gbx%snow_cv = fl_ccsnow

!-------------------------------------------------------------------------
!  call output_cosp_fields to produce netcdf output of desired COSP fields.
!-------------------------------------------------------------------------
      call output_cosp_fields (nlon, nlat, npoints, geomode, stlidar, &
                               stradar, isccp, modis, misr, sgradar, &
                               sglidar, sgx, Time_diag, is, js, &
                               cloud_type, gbx, cfg, phalf_plus, zhalf_plus)

!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! Deallocate memory in derived types
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      call free_cosp_gridbox(gbx)
      call free_cosp_subgrid(sgx)
      call free_cosp_sghydro(sghydro)
      call free_cosp_sgradar(sgradar)
      call free_cosp_radarstats(stradar)
      call free_cosp_sglidar(sglidar)
      call free_cosp_lidarstats(stlidar)
      call free_cosp_isccp(isccp)
      call free_cosp_misr(misr)
      call free_cosp_modis(modis)
#ifdef RTTOV 
      call free_cosp_rttov(rttov) 
#endif
      call free_cosp_vgrid(vgrid)  

 
end subroutine cosp_driver

!#####################################################################

subroutine cosp_driver_end 

      call cosp_diagnostics_end 


end subroutine cosp_driver_end

!#####################################################################

subroutine produce_cosp_input_fields   &
        (Npnts, Nl, N_hydro, lon_in, lat_in, daytime_in, p_half_in,   &
         p_full_in, z_half_in, z_full_in, u_wind_in, v_wind_in,    &
         mr_ozone_in, T_in, sh_in, tca_in, cca_in, lsliq_in, &
         lsice_in, ccliq_in, ccice_in, fl_lsrain_in, fl_lssnow_in, &
         fl_lsgrpl_in, fl_ccrain_in, fl_ccsnow_in, reff_lsclliq_in,   &
         reff_lsclice_in, reff_lsprliq_in, reff_lsprice_in,    &
         reff_ccclliq_in, reff_ccclice_in, reff_ccprliq_in,    &
         reff_ccprice_in, tau_stoch_in, lwem_stoch_in,    &
         stoch_cloud_type_in, skt_in, land_in, cloud_type, gbx) 

!--------------------------------------------------------------------
!    subroutine produce_cosp_input_fields converts inputs from AM3 
!    to the form needed by COSP.
!--------------------------------------------------------------------

integer,                  intent(in) :: Npnts, Nl, N_hydro
real,dimension(:,:),      intent(in) :: lon_in,lat_in, skt_in, land_in,&
                                        u_wind_in, v_wind_in
real, dimension(:,:),  intent(in) :: daytime_in
real,dimension(:,:,:),    intent(in) ::    &
            p_half_in, p_full_in, z_half_in, z_full_in, T_in, sh_in,  &
            tca_in, cca_in, lsliq_in, lsice_in, ccliq_in, ccice_in, &
            fl_lsrain_in, fl_lssnow_in, fl_lsgrpl_in, fl_ccrain_in, &
            fl_ccsnow_in, mr_ozone_in, &
            reff_lsclliq_in, reff_lsclice_in, reff_lsprliq_in, &
            reff_lsprice_in, reff_ccclliq_in, reff_ccclice_in, &
            reff_ccprliq_in, reff_ccprice_in
real,dimension(:,:,:,:),intent(in)   :: tau_stoch_in, lwem_stoch_in, &
                                        stoch_cloud_type_in
real,dimension(Npnts,Ncolumns,Nl),  intent(out) :: cloud_type
type(cosp_gridbox), intent(out) :: gbx ! Gridbox information. Input for COSP

!  local variables:

     real,dimension(Npnts,Nl)             :: y2                         
     real,dimension(Npnts,Nl,Ncolumns)    :: y3,y3a                   
     real, dimension(Npnts,Nl) :: qs
     real, dimension(size(T_in,1), size(T_in,2), size(T_in,3)) :: &
              qs_in, tau_stoch_mean, lwem_stoch_mean, tau_s_in, &
              tau_c_in, lwem_s_in, lwem_c_in
     integer :: nxdir, nydir, npts
     integer :: n, i, j, k
     real :: sum_s1, sum_s2, sum_c1, sum_c2
     integer :: ctr_s, ctr_c 


!--------------------------------------------------------------------
!   define array dimensions; verify consistency.
!--------------------------------------------------------------------
     nxdir = size(lat_in,1)
     nydir = size(lat_in, 2)
     npts = nxdir*nydir
     if (npts /= Npnts) then
       call error_mesg ('cosp_driver/produce_cosp_input_fields', &
                                     'ERROR -- i*j /= npts', FATAL)
     endif
   
!---------------------------------------------------------------------
!   map the 2d lon-lat arrays to 1D (npoints).
!---------------------------------------------------------------------
   call map_ll_to_point(nxdir,nydir,npts,x2=daytime_in, y1=gbx%sunlit)
   call map_ll_to_point(nxdir,nydir,npts,x2=lat_in, y1=gbx%latitude)
   call map_ll_to_point(nxdir,nydir,npts,x2=lon_in, y1=gbx%longitude)
   call map_ll_to_point(nxdir,nydir,npts,x2=skt_in, y1=gbx%skt)
   call map_ll_to_point(nxdir,nydir,npts,x2=land_in, y1=gbx%land)
   call map_ll_to_point(nxdir,nydir,npts,x2=u_wind_in, y1=gbx%u_wind)
   call map_ll_to_point(nxdir,nydir,npts,x2=v_wind_in, y1=gbx%v_wind)

!---------------------------------------------------------------------
!   map the 3d lon-lat-k arrays to 2D (npoints,k), and flip their
!   vertical indices (index 1 nearest ground in COSP).
!---------------------------------------------------------------------
   call map_ll_to_point(nxdir,nydir,npts,x3=p_full_in, y2=y2)
   call flip_vert_index    (y2, nl,gbx%p  )

   call map_ll_to_point(nxdir,nydir,npts,x3=p_half_in, y2=y2)
   call flip_vert_index    (y2, nl,gbx%ph )

   gbx%psfc = gbx%ph(:,1)

   call map_ll_to_point(nxdir,nydir,npts,x3=z_full_in, y2=y2)
   call flip_vert_index    (y2, nl,gbx%zlev  )

   call map_ll_to_point(nxdir,nydir,npts,x3=z_half_in, y2=y2)
   call flip_vert_index    (y2, nl,gbx%zlev_half )

   call map_ll_to_point(nxdir,nydir,npts,x3=mr_ozone_in, y2=y2)
   call flip_vert_index    (y2, nl,gbx%mr_ozone )

   call map_ll_to_point(nxdir,nydir,npts,x3=T_in, y2=y2)
   call flip_vert_index    (y2, nl,gbx%T  )

   call map_ll_to_point(nxdir,nydir,npts,x3=sh_in, y2=y2)
   call flip_vert_index    (y2, nl,gbx%sh )

!---------------------------------------------------------------------
!   define surface height
!---------------------------------------------------------------------
   gbx%sfc_height(:) = gbx%zlev_half(:,1)

!--------------------------------------------------------------------
!   compute qs and then the relative humidity.
!   a limit my be imposed (nml control) to account for slightly inexact
!   values near saturation.
!--------------------------------------------------------------------
   if (use_rh_wrt_liq) then
     call compute_qs (T_in, p_full_in, qs_in, q=sh_in,  &
                                          es_over_liq = use_rh_wrt_liq)
   else
     call compute_qs (T_in, p_full_in, qs_in, q=sh_in)
   endif
   call map_ll_to_point(nxdir,nydir,npts,x3=qs_in, y2=y2)
   call flip_vert_index    (y2, nl,qs )
   gbx%q = gbx%sh/qs

   call map_ll_to_point(nxdir,nydir,npts,x3=tca_in, y2=y2 )
   call flip_vert_index    (y2, nl,gbx%tca)

   call map_ll_to_point(nxdir,nydir,npts,x3=cca_in, y2=y2 )
   call flip_vert_index    (y2, nl,gbx%cca)

   call map_ll_to_point(nxdir,nydir,npts,x3=lsliq_in, y2=y2      )
   call flip_vert_index    (y2, nl,gbx%mr_hydro(:,:,I_LSCLIQ) )

   call map_ll_to_point(nxdir,nydir,npts,x3=lsice_in, y2=y2      )
   call flip_vert_index    (y2, nl,gbx%mr_hydro(:,:,I_LSCICE) )

   call map_ll_to_point(nxdir,nydir,npts,x3=ccliq_in, y2=y2      )
   call flip_vert_index    (y2, nl,gbx%mr_hydro(:,:,I_CVCLIQ) )

   call map_ll_to_point(nxdir,nydir,npts,x3=ccice_in, y2=y2      )
   call flip_vert_index    (y2, nl,gbx%mr_hydro(:,:,I_CVCICE) )

   call map_ll_to_point(nxdir,nydir,npts,x3=fl_lsrain_in, y2=y2       )
   call flip_vert_index    (y2, nl,gbx%rain_ls)

   call map_ll_to_point(nxdir,nydir,npts,x3=fl_lssnow_in, y2=y2       )
   call flip_vert_index    (y2, nl,gbx%snow_ls)

   call map_ll_to_point(nxdir,nydir,npts,x3=fl_lsgrpl_in, y2=y2       )
   call flip_vert_index    (y2, nl,gbx%grpl_ls)

   call map_ll_to_point(nxdir,nydir,npts,x3=fl_ccrain_in, y2=y2       )
   call flip_vert_index    (y2, nl,gbx%rain_cv)

   call map_ll_to_point(nxdir,nydir,npts,x3=fl_ccsnow_in, y2=y2       )
   call flip_vert_index    (y2, nl,gbx%snow_cv)

   call map_ll_to_point(nxdir,nydir,npts,x3=reff_lsclliq_in, y2=y2   )
   call flip_vert_index    (y2, nl,gbx%reff(:,:,i_lscliq ))

   call map_ll_to_point(nxdir,nydir,npts,x3=reff_lsclice_in, y2=y2   )
   call flip_vert_index    (y2, nl,gbx%reff(:,:,i_lscice ))

   call map_ll_to_point(nxdir,nydir,npts,x3=reff_lsprliq_in, y2=y2   )
   call flip_vert_index    (y2, nl,gbx%reff(:,:,i_lsrain ))

   call map_ll_to_point(nxdir,nydir,npts,x3=reff_lsprice_in, y2=y2   )
   call flip_vert_index    (y2, nl,gbx%reff(:,:,i_lssnow ))

   call map_ll_to_point(nxdir,nydir,npts,x3=reff_ccclliq_in, y2=y2   )
   call flip_vert_index    (y2, nl,gbx%reff(:,:,i_cvcliq ))

   call map_ll_to_point(nxdir,nydir,npts,x3=reff_ccclice_in, y2=y2   )
   call flip_vert_index    (y2, nl,gbx%reff(:,:,i_cvcice ))

   call map_ll_to_point(nxdir,nydir,npts,x3=reff_ccprliq_in, y2=y2   )
   call flip_vert_index    (y2, nl,gbx%reff(:,:,i_cvrain ))

   call map_ll_to_point(nxdir,nydir,npts,x3=reff_ccprice_in, y2=y2   )
   call flip_vert_index    (y2, nl,gbx%reff(:,:,i_cvsnow ))

   gbx%reff(:,:,i_lsgrpl) = 0.0

!---------------------------------------------------------------------
!   the values of tau and lwem are passed in for each stochastic column.
!   here grid box mean values are obtained for the convective and
!   large-scale components
!---------------------------------------------------------------------

   do k=1, size(tau_stoch_in,3)
     do j=1, size(tau_stoch_in,2)
       do i=1, size(tau_stoch_in,1)
         ctr_s = 0
         ctr_c = 0
         sum_s1 = 0.
         sum_c1 = 0.
         sum_s2 = 0.
         sum_c2 = 0.
         do n=1, size(tau_stoch_in,4)
           if (stoch_cloud_type_in(i,j,k,n) == 1. ) then 
             ctr_s = ctr_s + 1
             sum_s1 = sum_s1 +  tau_stoch_in(i,j,k,n)
             sum_s2 = sum_s2 +  lwem_stoch_in(i,j,k,n)
           else if(stoch_cloud_type_in(i,j,k,n) == 2. ) then 
             ctr_c = ctr_c + 1
             sum_c1 = sum_c1 +  tau_stoch_in(i,j,k,n)
             sum_c2 = sum_c2 +  lwem_stoch_in(i,j,k,n)
           endif
         end do
         if (ctr_s > 0) then
           tau_s_in(i,j,k) = sum_s1/ctr_s
           lwem_s_in(i,j,k) = sum_s2/ctr_s
         else
           tau_s_in(i,j,k) = 0.             
           lwem_s_in(i,j,k) = 0.               
         endif
         if (ctr_c > 0) then
           tau_c_in(i,j,k) = sum_c1/ctr_c
           lwem_c_in(i,j,k) = sum_c2/ctr_c
         else
           tau_c_in(i,j,k) = 0.             
           lwem_c_in(i,j,k) = 0.               
         endif
       end do
     end do
   end do
       
   call map_ll_to_point(nxdir,nydir,npts,x3=tau_s_in(:,:,:), y2=y2)
   call flip_vert_index    (y2, nl,gbx%dtau_s )

   call map_ll_to_point(nxdir,nydir,npts,x3=tau_c_in(:,:,:), y2=y2)
   call flip_vert_index    (y2, nl,gbx%dtau_c )

   call map_ll_to_point(nxdir,nydir,npts,x3=lwem_s_in(:,:,:), y2=y2)
   call flip_vert_index    (y2, nl,gbx%dem_s)

   call map_ll_to_point(nxdir,nydir,npts,x3=lwem_c_in(:,:,:), y2=y2)
   call flip_vert_index    (y2, nl,gbx%dem_c)

!----------------------------------------------------------------------
!    stoch_cloud_type is not flipped here; it will be used in subroutine
!    cosp where it is needed with index 1 being TOA. however the
!    column and vertical indices do need to be reversed.
!----------------------------------------------------------------------
   call map_ll_to_point(nxdir,nydir,npts,  &
                        x4=stoch_cloud_type_in(:,:,:,:), y3=y3        )
   do j=1,nl
     do i=1,Ncolumns
       cloud_type(:,i,j) = y3 (:,j,i)
     end do
   end do
   
!########################################################################

end subroutine produce_cosp_input_fields



    
!#####################################################################



end module cosp_driver_mod

!
!    Diagnostics for use in the Energy Balance Model
!     diagnostic tag is 'ebm'

! Add geopotential height to diagnostic fields

! ==========================================================================================

module ebm_diagnostics_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> B.L. Samuels
!</CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  Zhi Liang
! </REVIEWER>
!<OVERVIEW>
!  Diagnostics for use in the Energy Balance Model
!</OVERVIEW>
!<DESCRIPTION>
!  Diagnostics for use in the Energy Balance Model
!</DESCRIPTION>
! <INFO>
!   diagnostic tag is 'ebm'
! </INFO>

use          fms_mod, only: write_version_number
use    constants_mod, only: RADIAN
use   transforms_mod, only: get_grid_boundaries, get_deg_lon 
use   transforms_mod, only: get_deg_lat, grid_domain
use diag_manager_mod, only: diag_axis_init, register_diag_field
use diag_manager_mod, only: register_static_field, send_data
use time_manager_mod, only: time_type

implicit none
private

public :: ebm_diagnostics_init, ebm_diagnostics_up, ebm_diagnostics_down

character(len=84), parameter :: version = '$Id: ebm_diagnostics.F90,v 11.0 2004/09/28 19:10:27 fms Exp $'
character(len=84), parameter :: tagname='$Name: tikal $'
!-----------------------------------------------------------------------
!------------------------- axis names ----------------------------------
character(len=8) :: axiset   = 'ebm'
character(len=8) :: mod_name = 'ebm'
!-----------------------------------------------------------------------
! axis and field identifiers for the diag manager
integer :: id_t, id_q, id_prec, id_lprec, id_fprec, id_dt_qg
integer :: id_olr_toa, id_olr_boa, id_ilr_surf, id_nsw_toa, id_nsw_surf

contains

!-----------------------------------------------------------------------------------------------------------------
! <SUBROUTINE NAME="ebm_diagnostics_init">
!
! <OVERVIEW>
!             setup/write netcdf metadata and static fields
! </OVERVIEW>

! <DESCRIPTION>
!             setup/write netcdf metadata and static fields
! </DESCRIPTION>

!   <TEMPLATE>
!     call  ebm_diagnostics_init(Time, lon_max, lat_max,  axis_id)
!   </TEMPLATE>

! <IN NAME="Time" TYPE="type(time_type)">
!  Current/Init time.
! </IN>

! <IN NAME="lon_max" TYPE="integer">
!  longitude of spectral atmopsheric grid
! </IN>

! <IN NAME="lat_max" TYPE="integer">
!  latitude of spectral atmopsheric grid
! </IN>

! <OUT NAME="axis_id" TYPE="integer, dimension(:)">
!  axes identifiers
! </OUT>

subroutine ebm_diagnostics_init(Time, lon_max, lat_max,  axis_id)

type(time_type),         intent(in) :: Time
integer,                 intent(in) :: lon_max, lat_max
integer, intent(out),dimension(:)   :: axis_id

real, dimension(lon_max  ) :: lon
real, dimension(lon_max+1) :: lonb
real, dimension(lat_max  ) :: lat
real, dimension(lat_max+1) :: latb

integer :: axes_2d(2)
integer :: log_unit, id_lonb, id_lon, id_latb, id_lat
integer :: namelist_unit, ierr, io
logical :: used

!--- write out version information -------------------------------------
call write_version_number(version, tagname)

call get_grid_boundaries(lonb,latb,global=.true.)
call get_deg_lon(lon)
call get_deg_lat(lat)

id_lonb=diag_axis_init('lonb', RADIAN*lonb, 'degrees_E', 'x', 'longitude edges', set_name=axiset, Domain2=grid_domain)
id_latb=diag_axis_init('latb', RADIAN*latb, 'degrees_N', 'y', 'latitude edges',  set_name=axiset, Domain2=grid_domain)
id_lon =diag_axis_init('lon', lon, 'degrees_E', 'x', 'longitude', set_name=axiset, Domain2=grid_domain, edges=id_lonb)
id_lat =diag_axis_init('lat', lat, 'degrees_N', 'y', 'latitude',  set_name=axiset, Domain2=grid_domain, edges=id_latb)

axis_id(1) = id_lon
axis_id(2) = id_lat

axes_2d = axis_id(1:2)

id_t     = register_diag_field(mod_name, 'temp'  , axes_2d, Time, 'temperature'      , 'deg_k'    ) 
id_q     = register_diag_field(mod_name, 'sphum' , axes_2d, Time, 'specific humidity', 'none'     )
id_prec  = register_diag_field(mod_name, 'prec'  , axes_2d, Time, 'precipitation'    , 'Kg/(m2-s)')
id_lprec = register_diag_field(mod_name, 'lprec',axes_2d, Time, 'rain'             , 'Kg/(m2-s)')
id_fprec = register_diag_field(mod_name, 'fprec' , axes_2d, Time, 'snow'             ,' Kg/(m2-s)')

id_dt_qg = register_diag_field(mod_name, 'dt_qg' , axes_2d, Time, 'advection'             ,' 1/s')

id_olr_toa = register_diag_field(mod_name, 'olr_toa', axes_2d, Time, 'outgoing longwave (to space)', 'W/m2')
id_olr_boa = register_diag_field(mod_name, 'olr_boa', axes_2d, Time, 'outgoing longwave (to ocean)', 'W/m2')
id_ilr_surf = register_diag_field(mod_name, 'ilr_surf', axes_2d, Time, 'incoming longwave (from ocean)', 'W/m2')
id_nsw_toa = register_diag_field(mod_name, 'nsw_toa', axes_2d, Time, 'net shortwave (toa)', 'W/m2')
id_nsw_surf = register_diag_field(mod_name, 'nsw_surf', axes_2d, Time, 'net shortwave (to ocean)', 'W/m2')

return
end subroutine ebm_diagnostics_init

! </SUBROUTINE>

! <DIAGFIELDS>
!   <NETCDF NAME="temp" UNITS="deg_K">
!     atmospheric temperature
!   </NETCDF>
!   <NETCDF NAME="shpum" UNITS="none">
!     specific humidity
!   </NETCDF>
!   <NETCDF NAME="prec" UNITS="kg/(m2 s)">
!     total precipitation per unit ocean area
!   </NETCDF>
!   <NETCDF NAME="lprec" UNITS="kg/(m2 s)">
!     rain  per unit ocean area
!   </NETCDF>
!   <NETCDF NAME="fprec" UNITS="kg/(m2 s)">
!     snow  per unit ocean area
!   </NETCDF>
!   <NETCDF NAME="dt_qg" UNITS="1/s">
!     advection 
!   </NETCDF>
!   <NETCDF NAME="olr_toa" UNITS="W/m2">
!     outgoing longwave (to space)
!   </NETCDF>
!   <NETCDF NAME="olr_boa" UNITS="W/m2">
!     outgoing longwave (to ocean)
!   </NETCDF>
!   <NETCDF NAME="ilr_surf" UNITS="W/m2">
!     incoming longwave (from ocean)
!   </NETCDF>
!   <NETCDF NAME="nsw_toa" UNITS="W/m2">
!     net shortwave (toa)
!   </NETCDF>
!   <NETCDF NAME="nsw_surf" UNITS="W/m2">
!     net shortwave (to ocean)
!   </NETCDF>
! </DIAGFIELDS>

!--------------------------------------------------------------------------------------------
! <SUBROUTINE NAME="ebm_diagnostics_up">
!
! <OVERVIEW>
!  Diagnostics passed from the "ocean" surface up thru the atmosphere
! </OVERVIEW>

! <DESCRIPTION>
!  Diagnostics passed from the "ocean" surface up thru the atmosphere
! </DESCRIPTION>

!   <TEMPLATE>
!     call  ebm_diagnostics_up(Time,tg, qg, lprec, fprec, dt_qg )
!   </TEMPLATE>
!
! <IN NAME="Time" TYPE="type(time_type)">
!  time at the current time level (tau)
! </IN>

! <IN NAME="tg" TYPE="real, dimension(:,:)" >
!  atmospheric temperature  ( deg_k )
! </IN>

! <IN NAME="qg" TYPE="real, dimension(:,:)" >
!  specific humidity ( no units )
! </IN>

! <IN NAME="lprec" TYPE="real, dimension(:,:)" >
!  liquid precipitation rate (rain) in kg/m2/s
! </IN>

! <IN NAME="fprec" TYPE="real, dimension(:,:)" >
!  frozen precipitation rate (snow) in kg/m2/s
! </IN>

! <IN NAME="dt_qg" TYPE="real, dimension(:,:)" >
!  rate of change in specific humidity (1/s)
! </IN>

subroutine ebm_diagnostics_up(Time,tg, qg, lprec, fprec, dt_qg )

type(time_type),        intent(in) :: Time
real, intent(in), dimension(:,:)   :: tg, qg, lprec, fprec, dt_qg

logical :: used


if(id_t      > 0) used = send_data(id_t      , tg          , time)
if(id_q      > 0) used = send_data(id_q      , qg          , time)
if(id_prec   > 0) used = send_data(id_prec   , lprec+fprec , time)
if(id_lprec  > 0) used = send_data(id_lprec  , lprec       , time)
if(id_fprec  > 0) used = send_data(id_fprec  , fprec       , time)
if(id_dt_qg  > 0) used = send_data(id_dt_qg  , dt_qg       , time)

return
end subroutine ebm_diagnostics_up
! </SUBROUTINE>

!--------------------------------------------------------------------------------------------
! <SUBROUTINE NAME="ebm_diagnostics_down">
!
! <OVERVIEW>
!   Diagnostics passed down from the atmosphere to the "ocean" surface
! </OVERVIEW>

! <DESCRIPTION>
!   Diagnostics passed down from the atmosphere to the "ocean" surface
! </DESCRIPTION>

!   <TEMPLATE>
!     call  ebm_diagnostics_down(Time,olr_toa,olr_boa,ilr_surf,nsw_toa,nsw_surf)
!   </TEMPLATE>
!
! <IN NAME="Time" TYPE="type(time_type)">
!  time at the current time level (tau)
! </IN>


subroutine ebm_diagnostics_down(Time,olr_toa,olr_boa,ilr_surf,nsw_toa,nsw_surf)

type(time_type), intent(in) :: Time
real, intent(in), dimension(:,:)   :: olr_toa,olr_boa,ilr_surf,nsw_toa,nsw_surf

logical :: used

if(id_olr_toa  > 0) used = send_data(id_olr_toa ,olr_toa  ,time)
if(id_olr_boa  > 0) used = send_data(id_olr_boa ,olr_boa  ,time)
if(id_ilr_surf > 0) used = send_data(id_ilr_surf,ilr_surf ,time)
if(id_nsw_toa  > 0) used = send_data(id_nsw_toa ,nsw_toa  ,time)
if(id_nsw_surf > 0) used = send_data(id_nsw_surf,nsw_surf ,time)

return
end subroutine ebm_diagnostics_down
! </SUBROUTINE>

!--------------------------------------------------------------------------------------------

end module ebm_diagnostics_mod

                        MODULE SHORTWAVE_MOD

!-----------------------------------------------------------------------

      USE  RDPARM_MOD, ONLY: LMAX,LP1,LLP1,LP2,LLP2,NB
      USE  HCONST_MOD, ONLY: DIFFCTR,GINV,O3DIFCTR,RADCON

      Use       Fms_Mod, ONLY: Error_Mesg, FATAL, &
                               write_version_number, mpp_pe, mpp_root_pe

!implicit none
private

!------- interfaces -------
      PUBLIC  SWRAD, SHORTWAVE_INIT, SHORTWAVE_END

      character(len=128) :: version = '$Id: shortwave.F90,v 10.0 2003/10/24 22:00:32 fms Exp $'
      character(len=128) :: tagname = '$Name: tikal $'
      logical            :: module_is_initialized = .false.

      integer :: IMAX
      CONTAINS

!#######################################################################

      SUBROUTINE SWRAD (NCLDS,KTOPSW,KBTMSW,PRESS,RH2O,QO3,CAMT, &
                        CUVRF,CIRRF,CIRAB,RRCO2,COSZRO,SSOLAR, &
                        SALB, FSW,DFSW,UFSW,HSW, LSFC,PSFC)

!-----------------------------------------------------------------------
!              WRAPPER FOR  SHORT WAVE RADIATION CODE
!     inserts surface albedo into appropriate cloud property arrays
!-----------------------------------------------------------------------

      INTEGER, INTENT(IN), DIMENSION(:,:)   :: NCLDS
      INTEGER, INTENT(IN), DIMENSION(:,:,:) :: KTOPSW,KBTMSW
      REAL,    INTENT(IN), DIMENSION(:,:,:) :: PRESS,RH2O,QO3
      REAL,    INTENT(IN), DIMENSION(:,:,:) :: CAMT,CUVRF,CIRRF,CIRAB
      REAL,    INTENT(IN)                   :: RRCO2
      REAL,    INTENT(IN), DIMENSION(:,:)   :: COSZRO,SSOLAR
      REAL,    INTENT(IN), DIMENSION(:,:)   :: SALB

      REAL,   INTENT(OUT), DIMENSION(:,:,:) :: FSW,DFSW,UFSW,HSW

      INTEGER, INTENT(IN), OPTIONAL, DIMENSION(:,:)   :: LSFC
         REAL, INTENT(IN), OPTIONAL, DIMENSION(:,:)   :: PSFC

!-----------------------------------------------------------------------
      REAL,DIMENSION(SIZE(CUVRF,1),SIZE(CUVRF,3)) :: CUVRF2,CIRRF2
      REAL,DIMENSION(SIZE(CAMT ,1),SIZE(CAMT ,3)) :: CAMT2

      INTEGER  i,j
!-----------------------------------------------------------------------

      IMAX=SIZE(PRESS,1)

      DO j=1,SIZE(PRESS,2)

      CUVRF2(:,:)=CUVRF(:,j,:)
      CIRRF2(:,:)=CIRRF(:,j,:)
      CAMT2 (:,:)=CAMT (:,j,:)

      DO i=1,IMAX
         IF (COSZRO(i,j) > 0.0) THEN
            CUVRF2(i,NCLDS(i,j)+2)=SALB(i,j)
            CIRRF2(i,NCLDS(i,j)+2)=SALB(i,j)
            CAMT2 (i,NCLDS(i,j)+2)=1.0
         ENDIF
      ENDDO

!----- check usage of optional arguments -------
      IOPT=0
      IF (PRESENT(LSFC)) IOPT=IOPT+1
      IF (PRESENT(PSFC)) IOPT=IOPT+2

!     ------------------
      SELECT CASE (IOPT)
!     ------------------
          CASE (0)
!     ------------------
      CALL SWRAD_ORIG (NCLDS(:,j),KTOPSW(:,j,:),KBTMSW(:,j,:), &
                       PRESS(:,j,:),RH2O(:,j,:),QO3(:,j,:),CAMT2(:,:), &
                       CUVRF2,CIRRF2,CIRAB(:,j,:),RRCO2, &
                       COSZRO(:,j),SSOLAR(:,j), &
                       FSW(:,j,:),DFSW(:,j,:),UFSW(:,j,:),HSW(:,j,:))
!     ------------------
          CASE (3)
!     ------------------
      CALL SWRAD_ORIG (NCLDS(:,j),KTOPSW(:,j,:),KBTMSW(:,j,:), &
                       PRESS(:,j,:),RH2O(:,j,:),QO3(:,j,:),CAMT2(:,:), &
                       CUVRF2,CIRRF2,CIRAB(:,j,:),RRCO2, &
                       COSZRO(:,j),SSOLAR(:,j), &
                       FSW(:,j,:),DFSW(:,j,:),UFSW(:,j,:),HSW(:,j,:), &
                       LSFC(:,j),PSFC(:,j))
!     ------------------
          CASE DEFAULT
!     ------------------
             Call Error_Mesg ('SWRAD in SHORTWAVE_MOD', &
                          'LSFC and PSFC must be used together.', FATAL)
!     ------------------
      END SELECT
!     ------------------

      ENDDO
!-----------------------------------------------------------------------

      END SUBROUTINE SWRAD
      
!#######################################################################

      SUBROUTINE SWRAD_ORIG (NCLDS,KTOPSW,KBTMSW,PRESS,RH2O,QO3,CAMT, &
                        CUVRF,CIRRF,CIRAB,RRCO2,COSZRO,SSOLAR, &
                        FSW,DFSW,UFSW,HSW,LSFC,PSFC)

!***********************************************************************
!                    SHORT WAVE RADIATION CODE
!***********************************************************************
!-----------------------------------------------------------------------
!                        INPUT PARAMETERS
!                        ----------------
!
!      NCLDS   =  NO. CLOUDS AT EACH GRID PT. 
!      KTOPSW  =  INDEX OF (FLUX LEVEL) PRESSURE OF CLOUD TOP, USED 
!                    IN THE SHORTWAVE PROGRAM 
!      KBTMSW  =  INDEX OF (FLUX LEVEL) PRESSURE OF CLOUD BOTTOM, 
!                    USED IN THE SHORTWAVE PROGRAM
!      PRESS   =  PRESSURE (CGS UNITS) AT DATA LEVELS OF MODEL
!      RH2O    =  MASS MIXING RATIO (G/G) OF H2O AT MODEL DATA LVLS.
!      QO3     =  MASS MIXING RATIO (G/G) OF O3 AT MODEL DATA LVLS. 
!      CAMT    =  CLOUD AMOUNTS OF CLOUDS (THEIR LOCATIONS ARE
!                    SPECIFIED IN THE KTOP/KBTM INDICES)
!      CUVRF   =  REFLECTIVITY OF CLOUDS IN THE VISIBLE FREQ. BAND
!                    USED IN SHORTWAVE CALCS. ONLY
!      CIRRF   =  REFLECTIVITY OF CLOUDS IN THE INFRARED FREQ. BAND 
!                    USED IN SHORTWAVE CALCS. ONLY
!      CIRAB   =  ABSORPTIVITY OF CLOUDS IN THE INFRARED FREQ. BAND 
!                    USED IN SHORTWAVE CALCS. ONLY
!      RRCO2   =  MASS MIXING RATIO (G/G) OF CO2,USED IN SHORTWAVE
!                    CALCS. ONLY (scalar)
!      COSZRO  =  ZENITH ANGLE AT GRID PT. USED ON SHORTWAVE CALCS. 
!      SSOLAR  =  TOTAL SOLAR FLUX EITHER FOR THE TIMESTEP OR AVERAGED
!                 OVER THE DAY OR YEAR,
!                 EQUALS THE SOLAR CONSTANT x NORMALIZED SOLAR FLUX
!                 (INCLUDES THE COS ZENITH ANGLE AND DAY FRACTION)
!                 (AT PRESENT,IN LY/MIN).
!
!      LSFC    =  Vertical index of the lowest model level,
!                    dimensioned by IMAX.
!      PSFC    =  Surface pressure
!
!-----------------------------------------------------------------------
!                        OUTPUT PARAMETERS
!                        -----------------
!
!      FSW     = NET RADIATION (UP-DOWN) IN CGS UNITS AT ALL
!                PRESSURE LEVELS
!     DFSW     = DOWNWARD RADIATION AT ALL PRESSURE LEVELS
!     UFSW     = UPWARD RADIATION AT ALL PRESSURE LEVELS
!      HSW     = SHORTWAVE HEATING RATES IN K/DAY FOR PRESSURE
!                LAYERS.
!
!-----------------------------------------------------------------------

      INTEGER, INTENT(IN), DIMENSION(:)   :: NCLDS
      INTEGER, INTENT(IN), DIMENSION(:,:) :: KTOPSW,KBTMSW
      REAL,    INTENT(IN), DIMENSION(:,:) :: PRESS,RH2O,QO3
      REAL,    INTENT(IN), DIMENSION(:,:) :: CAMT,CUVRF,CIRRF,CIRAB
      REAL,    INTENT(IN)                 :: RRCO2
      REAL,    INTENT(IN), DIMENSION(:)   :: COSZRO,SSOLAR

      REAL,   INTENT(OUT), DIMENSION(:,:) :: FSW,DFSW,UFSW,HSW

      INTEGER, INTENT(IN), OPTIONAL, DIMENSION(:)   :: LSFC
      REAL,    INTENT(IN), OPTIONAL, DIMENSION(:)   :: PSFC
       
!-----------------------------------------------------------------------
!                        D I M E N S I O N
!    &  NCLDS(IMAX),KTOPSW(IMAX,LP1),KBTMSW(IMAX,LP1)
!    2 ,PRESS(IMAX,LP1),RH2O(IMAX,LMAX),QO3(IMAX,LMAX)
!    3 ,CAMT(IMAX,LP1),CUVRF(IMAX,LP1),CIRRF(IMAX,LP1),CIRAB(IMAX,LP1)
!    4 ,COSZRO(IMAX),SSOLAR(IMAX),LSFC(IMAX),PSFC(IMAX)
!                        D I M E N S I O N
!    &  FSW(IMAX,LP1),DFSW(IMAX,LP1),UFSW(IMAX,LP1),HSW(IMAX,LMAX)
!-----------------------------------------------------------------------
!***********************************************************************
      LOGICAL BCLDS,BJTOP
!-----------------------------------------------------------------------
                         DIMENSION &
        BCLDS(IMAX,LP1),BJTOP(IMAX,LP1), &
        ICNT(LP1),ICNT1(LP1),IINCL(LP1),INDX4(IMAX,LP1),INDXK(IMAX), &
        IBETCL(LP1) 
!-----------------------------------------------------------------------
                         DIMENSION &
        DFN(IMAX,LP1,NB),UFN(IMAX,LP1,NB), &
        TTD(IMAX,LP1,NB),TTU(IMAX,LP1,NB), &
        PP    (IMAX,LP1),PPTOP (IMAX,LP1), &
        DP    (IMAX,LP1),DPCLD (IMAX,LP1), &
        CR    (IMAX,LP1),CT    (IMAX,LP1), &
        TDCL1 (IMAX,LP1),TDCL2 (IMAX,LP1),TUCL1 (IMAX,LP1), &
        TUCL1I(IMAX,LP1),TDCL1I(IMAX,LP1),TDCL2I(IMAX,LP1), &
        TCLU  (IMAX,LP1),TCLD  (IMAX,LP1),ALFAU (IMAX,LP1), &
        UFNCLU(IMAX,LP1),UFNCLD(IMAX,LP1), &
        DFNCLU(IMAX,LP1),DFNCLD(IMAX,LP1), &
        TEMP1(IMAX),TEMP2(IMAX),TEMP3(IMAX),TEMP4(IMAX), &
        TEMP5(IMAX),TEMP6(IMAX),ALFA (IMAX), &
        VV   (IMAX),REFL (IMAX),SECZ (IMAX),RRAY (IMAX)
!***********************************************************************
!-------DIMENSION OF VARIABLES EQUIVALENCED TO THOSE PREVIOUSLY---------
!***********************************************************************
!-----------------------------------------------------------------------
!                        D I M E N S I O N
      DIMENSION PPBOT(IMAX,LP1)
      DIMENSION DFNTOP(IMAX,NB)
      DIMENSION UD(IMAX,LP1),UR(IMAX,LP1)
!     DIMENSION UCO2(IMAX,LLP2),UO3(IMAX,LLP2),ACO2(IMAX,LLP2)
!     DIMENSION AO3(IMAX,LLP2)
      DIMENSION VTROW1(IMAX,LP1)
      DIMENSION VTROW2(IMAX,LP1),VTROW3(IMAX,LP1)
      DIMENSION FF(IMAX,LP1),FFCO2(IMAX,LP1),FFO3(IMAX,LP1)
      DIMENSION PR2(IMAX,LP1)
      DIMENSION DU(IMAX,LP1),DUCO2(IMAX,LP1),DUO3(IMAX,LP1)
      DIMENSION ADCO2(IMAX,LP1),AUCO2(IMAX,LP1),UDCO2(IMAX,LP1), URCO2(IMAX,LP1)
      DIMENSION ABSDO3(IMAX,LP1),ABSUO3(IMAX,LP1),UDO3(IMAX,LP1), URO3(IMAX,LP1)
      DIMENSION CR1D(IMAX*LP1),ALFU1D(IMAX*LP1),TCLU1D(IMAX*LP1), TCLD1D(IMAX*LP1)
!--DIMENSIONS OF LOCAL DATA VARIABLES---
      DIMENSION ABCFF(NB),PWTS(NB)
!***********************************************************************
!-----------------------------------------------------------------------
!     EQUIVALENCE (ADCO2(1,1),ACO2(1,1)),(AUCO2(1,1),ACO2(1,LP2))
!     EQUIVALENCE (UDCO2(1,1),UCO2(1,1)),(URCO2(1,1),UCO2(1,LP2))
!     EQUIVALENCE (ABSDO3(1,1),AO3(1,1)),(ABSUO3(1,1),AO3(1,LP2))
!     EQUIVALENCE (UDO3(1,1),UO3(1,1)),(URO3(1,1),UO3(1,LP2))

!     EQUIVALENCE (CR,UD),(CT,UR)
!     EQUIVALENCE (TDCL1I,ABSDO3,PPBOT),(TDCL2I,ABSUO3)
!     EQUIVALENCE (UFNCLU,UDO3),(UFNCLD,URO3)
!     EQUIVALENCE (DFNCLU,UDCO2),(DFNCLD,URCO2)
!     EQUIVALENCE (TCLU,ADCO2),(TCLD,AUCO2)
!     EQUIVALENCE (TTD(1,1,1),FF(1,1))
!     EQUIVALENCE (TTD(1,1,2),FFCO2(1,1))
!     EQUIVALENCE (TTD(1,1,3),PR2(1,1))
!     EQUIVALENCE (TTD(1,1,4),DU(1,1))
!     EQUIVALENCE (TTD(1,1,5),DUCO2(1,1))
!     EQUIVALENCE (TTD(1,1,6),DUO3(1,1))
!     EQUIVALENCE (TTD(1,1,7),VTROW1(1,1))
!     EQUIVALENCE (TTD(1,1,8),VTROW2(1,1))
!     EQUIVALENCE (TTD(1,1,9),VTROW3(1,1))
!     EQUIVALENCE (TTU(1,1,1),DFNTOP(1,1))
!     EQUIVALENCE (CR1D,CR),(ALFU1D,ALFAU),(TCLD1D,TCLD),(TCLU1D,TCLU)
!-----------------------------------------------------------------------
      DATA ABCFF /2*4.0E-5,.002,.035,.377,1.95,9.40,44.6,190./
      DATA PWTS /.5000,.1470,.0698,.1443,.0584,.0335,.0225,.0158,.0087/
      DATA CFCO2,CFO3 /508.96,466.64/
      DATA REFLO3 /1.9/
      DATA RRAYAV /0.144/
!-----------------------------------------------------------------------

      DO K=1,LP1
      DO I=1,IMAX
         FF   (I,K)=DIFFCTR
         FFCO2(I,K)=DIFFCTR
         FFO3 (I,K)=O3DIFCTR
      ENDDO
      ENDDO

!------ NOTE: converting pressures (PRESS) to CGS units -------

      DO K=2,LMAX
      DO I=1,IMAX
!CCC     PP(I,K)=0.50*(PRESS(I,K)+PRESS(I,K-1))
         PP(I,K)=5.0*(PRESS(I,K)+PRESS(I,K-1))
      ENDDO
      ENDDO

      DO I=1,IMAX
         SECZ(I)=35./SQRT(1224.*COSZRO(I)*COSZRO(I)+1.0)
!        SECZ(I)=1./COSZRO(I)
      ENDDO

      IF (.not.PRESENT(LSFC)) THEN
         DO I=1,IMAX
            PP(I,1)=0.00
            PP(I,LP1)=10.*PRESS(I,LP1)
         ENDDO
      ELSE
         DO I=1,IMAX
            PP(I,1)=0.00
            PP(I,LP1)=10.*PRESS(I,LP1)
            PP(I,LSFC(I)+1)=10.*PSFC(I)
         ENDDO
      ENDIF

      DO K=1,LMAX
      DO I=1,IMAX
         DP(I,K)=PP(I,K+1)-PP(I,K)
      ENDDO
      ENDDO

      IF (.not.PRESENT(LSFC)) THEN
         DO K=1,LMAX
         DO I=1,IMAX
!CCC        PR2(I,K)=0.50*(PP(I,K)+PP(I,K+1))/PRESS(I,LP1)
            PR2(I,K)=0.050*(PP(I,K)+PP(I,K+1))/PRESS(I,LP1)
         ENDDO
         ENDDO
      ELSE
         DO K=1,LMAX
         DO I=1,IMAX
!CCC        PR2(I,K)=0.50*(PP(I,K)+PP(I,K+1))/PSFC(I)
            PR2(I,K)=0.050*(PP(I,K)+PP(I,K+1))/PSFC(I)
         ENDDO
         ENDDO
      ENDIF

      DO K=1,LMAX
      DO I=1,IMAX
         DUO3 (I,K)=QO3 (I,K)*DP(I,K)*GINV
         DUCO2(I,K)=RRCO2    *DP(I,K)*GINV
         DU   (I,K)=RH2O(I,K)*DP(I,K)*GINV
      ENDDO
      ENDDO

      DO I=1,IMAX
         JTOP=KTOPSW(I,2) 
         DO K=1,JTOP 
            FFO3 (I,K)=SECZ(I) 
            FFCO2(I,K)=SECZ(I)
            FF   (I,K)=SECZ(I) 
         ENDDO
      ENDDO

!-----------------------------------------------------------------------
!     CALCULATE PRESSURE-WEIGHTED OPTICAL PATHS IN UNITS OF G/CM2.
!     PRESSURE WEIGHTING IS BY P**0.5 
!     UD IS THE DOWNWARD PATH,UR THE UPWARD PATH, 
!     AND THE CALCULATION IS MADE BY TAKING A PATH WITH AN ANGLE
!     OF (SECZ) FROM THE TOP OF THE ATMOSPHERE TO THE TOPMOST CLOUD,
!     THEN USING THE DIFFUSIVITY FACTOR (1.66) TO THE SURFACE AND FOR 
!     REFLECTED RADIATION. THE CODE BELOW REFLECTS THIS.
!-----------------------------------------------------------------------
!*****************************************
      IF (.not.PRESENT(LSFC)) THEN
         DO K=1,LMAX
         DO I=1,IMAX
            VTROW1(I,K)=DU   (I,K)*PR2(I,K)
            VTROW2(I,K)=DUCO2(I,K)*PR2(I,K)*CFCO2
            VTROW3(I,K)=DUO3 (I,K)*CFO3
         ENDDO
         ENDDO
      ELSE
         DO K=1,LMAX
         DO I=1,IMAX
            VTROW1(I,K)=0.00
            VTROW2(I,K)=0.00
            VTROW3(I,K)=0.00
         ENDDO
         ENDDO
         DO I=1,IMAX
            LMA=LSFC(I)
            DO K=1,LMA
               VTROW1(I,K)=DU   (I,K)*PR2(I,K)
               VTROW2(I,K)=DUCO2(I,K)*PR2(I,K)*CFCO2
               VTROW3(I,K)=DUO3 (I,K)*CFO3
            ENDDO
         ENDDO
      ENDIF
!*****************************************

      DO I=1,IMAX
         UD   (I,1)=0.00 
         UDCO2(I,1)=0.00
         UDO3 (I,1)=0.00 
      ENDDO

      DO K=2,LP1
!     DO I=1,IMAX
         UD   (:,K)=UD   (:,K-1)+VTROW1(:,K-1)*FF   (:,K) 
         UDCO2(:,K)=UDCO2(:,K-1)+VTROW2(:,K-1)*FFCO2(:,K)
         UDO3 (:,K)=UDO3 (:,K-1)+VTROW3(:,K-1)*FFO3 (:,K) 
!     ENDDO
      ENDDO

!   UDO3,URO3 ARE IN UNITS OF CM 
!   CFCO2,CFO3 IS THE CONVERSION FACTOR FROM GM/CM2 TO CM

      DO I=1,IMAX
         UR   (I,LP1)=UD   (I,LP1) 
         URCO2(I,LP1)=UDCO2(I,LP1) 
         URO3 (I,LP1)=UDO3 (I,LP1) 
      ENDDO

      DO K=LMAX,1,-1 
      DO I=1,IMAX
         UR   (I,K)=UR   (I,K+1)+VTROW1(I,K)*DIFFCTR
         URCO2(I,K)=URCO2(I,K+1)+VTROW2(I,K)*DIFFCTR
         URO3 (I,K)=URO3 (I,K+1)+VTROW3(I,K)*REFLO3 
      ENDDO
      ENDDO

!   CALCULATE WATER VAPOR TRANSMISSION FUNCTIONS FOR BANDS 2-9;
!   T.F. FOR BAND 1= T.F FOR BAND 2

      DO N=2,NB 
      DO K=1,LP1
      DO I=1,IMAX
         TTD(I,K,N)=ABCFF(N)*UD(I,K) 
         TTU(I,K,N)=ABCFF(N)*UR(I,K) 
      ENDDO
      ENDDO
      ENDDO

      DO N=2,NB
      DO K=1,LP1
      DO I=1,IMAX
         IF (TTD(I,K,N).GE.50.)  TTD(I,K,N)=50.
         IF (TTU(I,K,N).GE.50.)  TTU(I,K,N)=50.
      ENDDO
      ENDDO
      ENDDO

      DO N=2,NB
      DO K=1,LP1
      DO I=1,IMAX
         TTD(I,K,N)=-1.0*TTD(I,K,N)
         TTU(I,K,N)=-1.0*TTU(I,K,N)
      ENDDO
      ENDDO
      ENDDO

      DO N=2,NB
      DO K=1,LP1
      DO I=1,IMAX
         TTD(I,K,N)=EXP(TTD(I,K,N))
         TTU(I,K,N)=EXP(TTU(I,K,N))
      ENDDO
      ENDDO
      ENDDO

!   CALCULATE CO2 ABSORPTIONS . THEY WILL BE USED IN BANDS 2-9. 
!   SINCE THESE OCCUPY 50 PERCENT OF THE SOLAR SPECTRUM THE 
!   ABSORPTIONS WILL BE MULTIPLIED BY 2 

      DO I=1,IMAX
         ADCO2(I,1)=0.00
      ENDDO

      DO K=2,LP1
      DO I=1,IMAX
         ADCO2(I,K)=UDCO2(I,K)+0.0129
         ADCO2(I,K)=0.26*LOG(ADCO2(I,K))
         ADCO2(I,K)=EXP(ADCO2(I,K))
         ADCO2(I,K)=2.35E-3*ADCO2(I,K)-7.58265E-4 
      ENDDO
      ENDDO

      DO K=1,LMAX
      DO I=1,IMAX
         AUCO2(I,K)=URCO2(I,K)+0.0129
         AUCO2(I,K)=0.26*LOG(AUCO2(I,K))
         AUCO2(I,K)=EXP(AUCO2(I,K))
         AUCO2(I,K)=2.35E-3*AUCO2(I,K)-7.58265E-4 
      ENDDO
      ENDDO

!     DO K=2,LLP1
!     DO I=1,IMAX
!        ACO2(I,K)=UCO2(I,K)+0.0129
!     ENDDO
!     ENDDO

!     DO K=2,LLP1
!     DO I=1,IMAX
!        ACO2(I,K)=LOG(ACO2(I,K))
!     ENDDO
!     ENDDO

!     DO K=2,LLP1
!     DO I=1,IMAX
!        ACO2(I,K)=0.26*ACO2(I,K)
!     ENDDO
!     ENDDO

!     DO K=2,LLP1
!     DO I=1,IMAX
!        ACO2(I,K)=EXP(ACO2(I,K))
!     ENDDO
!     ENDDO

!     DO K=2,LLP1
!     DO I=1,IMAX
!        ACO2(I,K)=2.35E-3*ACO2(I,K)-7.58265E-4 
!     ENDDO
!     ENDDO

      DO I=1,IMAX
         AUCO2(I,LP1)=ADCO2(I,LP1) 
      ENDDO

      DO K=1,LP1 
      DO I=1,IMAX 
         ADCO2(I,K)=2.0*ADCO2(I,K) 
         AUCO2(I,K)=2.0*AUCO2(I,K) 
      ENDDO
      ENDDO

!   NOW CALCULATE OZONE ABSORPTIONS. THESE WILL BE USED IN
!   BAND 1. AS THIS OCCUPIES 50 PERCENT OF THE SOLAR SPECTRUM 
!   THE OZONE ABSORPTIONS WILL BE MULTIPLIED BY 2

      DO I=1,IMAX
         ABSDO3(I,1)=0.00 
      ENDDO

      H103P6=103.6*103.6*103.6

      DO K=2,LP1
      DO I=1,IMAX
         ABSDO3(I,K)=1.0+138.6*UDO3(I,K) 
         ABSDO3(I,K)=-0.805*LOG(ABSDO3(I,K))
         ABSDO3(I,K)=EXP(ABSDO3(I,K))
         ABSDO3(I,K)=1.082*UDO3(I,K)*ABSDO3(I,K)+ &
            0.0658*UDO3(I,K)/(1.0+H103P6*UDO3(I,K)*UDO3(I,K)*UDO3(I,K))+ &
            0.02118*UDO3(I,K)/(1.0+0.042*UDO3(I,K)+ &
            0.000323*UDO3(I,K)*UDO3(I,K))
      ENDDO
      ENDDO

      DO K=1,LMAX
      DO I=1,IMAX
         ABSUO3(I,K)=1.0+138.6*URO3(I,K) 
         ABSUO3(I,K)=-0.805*LOG(ABSUO3(I,K))
         ABSUO3(I,K)=EXP(ABSUO3(I,K))
         ABSUO3(I,K)=1.082*URO3(I,K)*ABSUO3(I,K)+ &
            0.0658*URO3(I,K)/(1.0+H103P6*URO3(I,K)*URO3(I,K)*URO3(I,K))+ &
            0.02118*URO3(I,K)/(1.0+0.042*URO3(I,K)+ &
            0.000323*URO3(I,K)*URO3(I,K))
      ENDDO
      ENDDO

!     DO K=2,LLP1
!     DO I=1,IMAX
!        AO3(I,K)=1.0+138.6*UO3(I,K) 
!     ENDDO
!     ENDDO

!     DO K=2,LLP1
!     DO I=1,IMAX
!        AO3(I,K)=LOG(AO3(I,K))
!     ENDDO
!     ENDDO

!     DO K=2,LLP1
!     DO I=1,IMAX
!        AO3(I,K)=-0.805*AO3(I,K)
!     ENDDO
!     ENDDO

!     DO K=2,LLP1
!     DO I=1,IMAX
!        AO3(I,K)=EXP(AO3(I,K)) 
!     ENDDO
!     ENDDO

!     H103P6=103.6*103.6*103.6
!     DO K=2,LLP1
!     DO I=1,IMAX 
!        AO3(I,K)=1.082*UO3(I,K)*AO3(I,K)+ 
!    &        0.0658*UO3(I,K)/(1.0+H103P6*UO3(I,K)*UO3(I,K)*UO3(I,K))+
!    &        0.02118*UO3(I,K)/(1.0+0.042*UO3(I,K)+ 
!    &        0.000323*UO3(I,K)*UO3(I,K))
!     ENDDO
!     ENDDO

      DO I=1,IMAX
         ABSUO3(I,LP1)=ABSDO3(I,LP1) 
      ENDDO

!     DO K=1,LLP2
      DO K=1,LP1
      DO I=1,IMAX 
!        AO3(I,K)=2.0*AO3(I,K)
         ABSDO3(I,K)=2.0*ABSDO3(I,K) 
         ABSUO3(I,K)=2.0*ABSUO3(I,K) 
      ENDDO
      ENDDO

!     WRITE (*,101) ((K,UD(IP,K),UR(IP,K),K=1,LP1),IP=1,IMAX) 
!     WRITE (*,105) ((K,UDO3(IP,K),URO3(IP,K),ABSDO3(IP,K), 
!    1 ABSUO3(IP,K),K=1,LP1),IP=1,IMAX) 
!     WRITE (*,105) ((K,UDCO2(IP,K),URCO2(IP,K),ADCO2(IP,K),
!    1 AUCO2(IP,K),K=1,LP1),IP=1,IMAX)

!   COMBINE ABSORPTIONS AND TRANSMISSIONS TO OBTAIN A 
!   TRANSMISSION FUNCTION FOR EACH OF THE 9 BANDS.

      DO K=1,LP1 
      DO I=1,IMAX 
         TTD(I,K,1)=TTD(I,K,2)*(1.0-ABSDO3(I,K))
      ENDDO
      ENDDO

      DO K=1,LMAX 
      DO I=1,IMAX 
         TTU(I,K,1)=TTU(I,K,2)*(1.0-ABSUO3(I,K))
      ENDDO
      ENDDO

      DO N=2,NB
      DO K=1,LP1 
      DO I=1,IMAX 
         TTD(I,K,N)=TTD(I,K,N)*(1.0-ADCO2(I,K)) 
      ENDDO
      ENDDO
      ENDDO

      DO N=1,NB
      DO I=1,IMAX 
         TTU(I,LP1,N)=TTD(I,LP1,N) 
      ENDDO
      ENDDO

      DO N=2,NB
      DO K=1,LMAX 
      DO I=1,IMAX 
         TTU(I,K,N)=TTU(I,K,N)*(1.0-AUCO2(I,K)) 
      ENDDO
      ENDDO
      ENDDO

!   IN THE 850 LOOP BELOW AND THE 855 LOOP,WE WILL SCALE DFN(IP,1,N)
!   TO UNITY. AFTER THE 850 LOOP,WE MULTIPLY BY DFN(IP,1,N) FROM THE
!   6 LOOP TO GET THE ACTUAL DFN'S AND UFN'S.
!   THE 855 LOOP=SCALED DOWNWARD FLUX ADOVE TOPMOST CLOUD(REDUN-
!   DANTLY OBTAINED TO THE GROUND) .ALSO,UFN IS INITIALIZED TO 0

      DO N=1,NB
      DO K=1,LP1
      DO I=1,IMAX
         DFN(I,K,N)=TTD(I,K,N)
         UFN(I,K,N)=0.00
      ENDDO
      ENDDO
      ENDDO
 
!***EVALUATE LOGICAL ARRAYS USED FOR CLOUD CALCULATIONS
!----BCLDS : TRUE IF KK IS < OR = TO NCLDS (NO. CLOUDS AT GRID PT I)
!----BJTOP : TRUE IF K IS < OR = TO KTOPSW(I,2) (INDEX OF TOP CLOUD,
!                    IF ANY; LP1 IS NO CLOUD AT GRID PT)
 
      DO KK=1,LP1
      DO I=1,IMAX
         BCLDS(I,KK)=KK.LE.NCLDS(I)
      ENDDO
      ENDDO

      DO K=1,LP1
      DO I=1,IMAX
         BJTOP(I,K)=K.LE.KTOPSW(I,2)
      ENDDO
      ENDDO

!---COUNT NO. OF PTS IN EACH ROW FOR WHICH BCLDS IS TRUE (ICNT)
!   AND FOR WHICH BJTOP IS TRUE (ICNT1)
 
      DO K=1,LP1
         ICNT(K)=0
         ICNT1(K)=0
         DO I=1,IMAX
            IF (BCLDS(I,K)) THEN
               ICNT(K)=ICNT(K)+1
            ENDIF
            IF (BJTOP(I,K)) THEN
               ICNT1(K)=ICNT1(K)+1
            ENDIF
         ENDDO
      ENDDO

!---FIND NO. OF CLOUD LEVELS WITH NONZERO VALUES OF ICNT
!---FIND NO. OF PRESSURE LEVELS WITH NONZERO VALUES OF ICNT1
 
      KCLDS=0
      KJTOP=0
      DO K=1,LP1
         IF (ICNT(K).GT.0) THEN
            KCLDS=KCLDS+1 
         ENDIF
         IF (ICNT1(K).GT.0) THEN
            KJTOP=KJTOP+1
         ENDIF
      ENDDO

!***IF NO CLOUDS AT ALL EXIST IN THE ROW, THE CALCULATIONS ARE
!   DRASTICALLY SIMPLIFIED.

!MPP  IF (KCLDS.EQ.0) THEN
      IF (KCLDS.EQ.-1) THEN
         DO N=1,NB

            IF (N.EQ.1) THEN
               DO I=1,IMAX
                  REFL(I)=CUVRF(I,2)
!CCCC             REFL(I)=SALB(I)
                  RRAY(I)=0.219/(1.0+0.816*COSZRO(I))
                  REFL(I)=RRAY(I)+(1.0-RRAY(I))*(1.0-RRAYAV)*REFL(I)/ &
                          (1.0-REFL(I)*RRAYAV)
                  ALFA(I)=REFL(I)
               ENDDO
            ELSE
               DO I=1,IMAX
                  ALFA(I)=CIRRF(I,2)
!CCCC             ALFA(I)=SALB(I)
               ENDDO
            ENDIF

            DO I=1,IMAX
               VV(I)=ALFA(I)*DFN(I,LP1,N)/TTU(I,LP1,N)
            ENDDO

            DO K=1,LP1
            DO I=1,IMAX
               UFN(I,K,N)=VV(I)*TTU(I,K,N)
            ENDDO
            ENDDO

         ENDDO
      ENDIF

!***********************************************************************
!     ****** COMPUTE NORMAL CASE: AT LEAST 1 PT HAS A CLOUD ******

!MPP                  IF (KCLDS.NE.0) THEN
                      IF (KCLDS.GE.0) THEN

!***********************************************************************

!---FIND  HIGHEST PRESSURE LEVEL WITH AT LEAST 1 PT BELOW TOP CLOUD
      KCLDS2=0
      DO K=1,LP1
         IF (ICNT1(K).EQ.IMAX) THEN
            KCLDS2=KCLDS2+1
         ENDIF
      ENDDO
      KCLDS2=KCLDS2+1

!    -------------------
      DO 2105 KK=1,KCLDS
!    -------------------
!---DETERMINE WHETHER A CLOUD LAYER KK HAS AT LEAST 1 GRID PT WITH A
!   "THICK CLOUD"
!---DETERMINE WHETHER THERE IS AT LEAST 1 GRID PT WHERE THE BOTTOM
!  OF CLOUD LAYER KK DOES NOT COINCIDE WITH THE TOP OF CLOUD LAYER
!  KK+1

      IINCL(KK)=0
      IBETCL(KK)=0
      DO K=KCLDS2,LP1
      DO I=1,IMAX
         IF (BCLDS(I,KK) .AND. &
           (K.GT.KTOPSW(I,KK+1) .AND. K.LT.KBTMSW(I,KK+1))) THEN
               IINCL(KK)=IINCL(KK)+1
         ENDIF
         IF (BCLDS(I,KK) .AND. &
           (K.GE.KBTMSW(I,KK+1) .AND. K.LE.KTOPSW(I,KK+2))) THEN
               IBETCL(KK)=IBETCL(KK)+1
         ENDIF
      ENDDO
      ENDDO
!    -------------------
2105  CONTINUE
!    -------------------

!***COMPUTE VISIBLE BAND GROUND REFLECTIVITY USING LACIS-HANSEN 
!   PARAMETERIZATION

      DO I=1,IMAX
         REFL(I)=CUVRF(I,NCLDS(I)+2)
!CCCC    REFL(I)=SALB(I)
      ENDDO

      DO IP=1,IMAX
         RRAY(IP)=0.219/(1.0+0.816*COSZRO(IP))
         REFL(IP)=RRAY(IP)+(1.0-RRAY(IP))*(1.0-RRAYAV)*REFL(IP)/ &
                           (1.0-REFL(IP)*RRAYAV)
      ENDDO

      DO KK=1,KCLDS
      DO I=1,IMAX
         PPTOP(I,KK)=PP(I,KTOPSW(I,KK+1)) 
         PPBOT(I,KK)=PP(I,KBTMSW(I,KK+1))
      ENDDO
      ENDDO

      DO KK=1,KCLDS
      DO I=1,IMAX
         IF (PPTOP(I,KK).NE.PPBOT(I,KK)) THEN
            DPCLD(I,KK)=1.0/(PPTOP(I,KK)-PPBOT(I,KK))
         ELSE
            DPCLD(I,KK)=0.00
         ENDIF
      ENDDO
      ENDDO

!***WE NOW OBTAIN AN INDEX FOR (I,NCLDS(I)+1-KK).WE FORCE THIS
!   INDEX TO HAVE A MINIMUM VALUE IN THE (0,IMAX) RANGE.

      DO KK=1,KCLDS+1
      DO I=1,IMAX
         IF (BCLDS(I,KK)) THEN
            INDXK(I)=KK
         ELSE
            INDXK(I)=NCLDS(I)
         ENDIF
         INDX4(I,KK)=(NCLDS(I)-INDXK(I))*IMAX+I
      ENDDO
      ENDDO

!-----------------------------------------------------------------------
!   THE REST OF THE CLOUD CALCULATION IS PERFORMED INSIDE A
!   BAND (FREQUENCY) LOOP OVER N, RUNNING FROM 1 TO NB
!-----------------------------------------------------------------------

                         DO 2301 N=1,NB

!     print *, 'NB,N=',NB,N
!-----------------------------------------------------------------------

!***INITIALIZE CR TO ZERO AND CT TO ONE***
      DO K=1,LP1
      DO I=1,IMAX
         CR(I,K)=0.00
         CT(I,K)=1.0
      ENDDO
      ENDDO

!***OBTAIN CLOUD REFLECTION AND TRANSMISSION COEFFICIENTS, FIRST FOR
!   VISIBLE BAND (N=1) THEN FOR NEAR IR BANDS (N=2-NB) 
!---FIRST, THE VISIBLE BAND:

!               ----------------
                IF (N == 1) THEN
!               ----------------

      DO KK=1,KCLDS
      DO I=1,IMAX
         IF (BCLDS(I,KK)) THEN
            CR(I,KK+1)=CUVRF(I,KK+1)*CAMT(I,KK+1)
            CT(I,KK+1)=1.0-CR(I,KK+1)
         ENDIF
      ENDDO
      ENDDO

!---USE THIS INDEX FOR SPECIFYING VISIBLE BAND GROUND ALBEDO 
!   AS REFL(I):

      DO I=1,IMAX
         CR(I,NCLDS(I)+2)=REFL(I)
      ENDDO

!               ----------------
                     ENDIF
!               ----------------

!---NOW, THE NEAR IR BANDS; HERE THE GROUND CAN BE HANDLED AS PART
!   OF THE CLOUD LOOP

!               ----------------
                IF (N > 1) THEN
!               ----------------

      DO I=1,IMAX 
          CR(I,2)=CIRRF(I,2)*CAMT(I,2)
          CT(I,2)=1.0-CAMT(I,2)*(CIRRF(I,2)+CIRAB(I,2))
      ENDDO

      DO KK=1,KCLDS
      DO I=1,IMAX
!       print *, 'I,KK,BCLDS,CIRRF,CAMT,CIRAB=',I,KK,
!    &           BCLDS(I,KK),CIRRF(I,KK+2),CAMT(I,KK+2),CIRAB(I,KK+2)
         IF (BCLDS(I,KK)) THEN
            CR(I,KK+2)=CIRRF(I,KK+2)*CAMT(I,KK+2)
            CT(I,KK+2)=1.0-CAMT(I,KK+2)*(CIRRF(I,KK+2)+CIRAB(I,KK+2))
         ENDIF
      ENDDO
      ENDDO

!               ----------------
                     ENDIF
!               ----------------

      DO K=1,LP1
      DO I=1,IMAX
         ALFAU(I,K)=0.00
      ENDDO
      ENDDO


!***FOR EXECUTION OF THE CLOUD LOOP, IT IS NECESSARY TO SEPARATE OUT
!   TRANSMISSION FCTNS AT THE TOP AND BOTTOM OF THE CLOUDS, FOR
!   EACH BAND N. THE REQUIRED QUANTITIES ARE:
!      TTD(I,KTOPSW(I,K),N)  K RUNS FROM 2 TO NCLDS(I)+2: 
!      TTD(I,KBTMSW(I,K),N)  K RUNS FROM 2 TO NCLDS(I)+1: 
!      TTU(I,KTOPSW(I,K),N)  K RUNS FROM 2 TO NCLDS(I)+2:
!      AND INVERSES OF THE ABOVE. THE ABOVE QUANTITIES ARE STORED 
!      IN TDCL1,TDCL2,TUCL1,TDCL1I,TDCL2I,TUCLI,RESPECTIVELY, AS
!      THEY HAVE MULTIPLE USE IN THE PGM.

!---COMPUTE GATHERS
      DO KK=1,KCLDS+1
      DO I=1,IMAX
         TDCL1(I,KK)=TTD(I,KTOPSW(I,KK+1),N)
         TUCL1(I,KK)=TTU(I,KTOPSW(I,KK+1),N)
      ENDDO
      ENDDO

      DO KK=1,KCLDS
      DO I=1,IMAX
         TDCL2(I,KK)=TTD(I,KBTMSW(I,KK+1),N)
      ENDDO
      ENDDO

!---COMPUTE INVERSES
      DO KK=1,KCLDS
      DO I=1,IMAX
         TDCL2I(I,KK)=1.0/TDCL2(I,KK)
      ENDDO
      ENDDO

      DO KK=1,KCLDS+1
      DO I=1,IMAX
        TDCL1I(I,KK)=1.0/TDCL1(I,KK)
        TUCL1I(I,KK)=1.0/TUCL1(I,KK)
      ENDDO
      ENDDO


!   TCLU(LL) IS TRANSMISSION FUNCTION FROM TOP OF NEXT LOWER
!   CLOUD TO TOP OF UPPER CLOUD. TCLD(LL) IS T.F. FROM TOP
!   OF NEXT LOWER CLOUD TO BOTTOM OF UPPER CLOUD. LL=NC1 IS
!   THE LOWEST BOTTOM CLOUD (THE GROUND) ; LL=1 IS THE
!   HIGHEST UPPER CLOUD. 

         TCLU = 0.0
         TCLD = 0.0
      DO KK=1,KCLDS
      DO I=1,IMAX
         TCLU(I,KK+1)=TDCL1(I,KK+1)*TDCL1I(I,KK)*CT(I,KK+1)
         TCLD(I,KK+1)=TDCL1(I,KK+1)*TDCL2I(I,KK) 
      ENDDO
      ENDDO

!***WE DEFINE TCLD (I,1) AS TTD(I,KTOPSW(I,2),N)
      DO I=1,IMAX
         TCLD(I,1)=TDCL1(I,1)
      ENDDO

      DO I=1,IMAX
         DFNCLU(I,1)=TCLD(I,1)
      ENDDO


!   THE FOLLOWING CALCULATION IS FOR ALFAT: THE RATIO BETWEEN
!   THE DOWNWARD FLUX AT THE TOP OF THE HIGHEST CLOUD (IF
!   PRESENT) OR THE GROUND TO THE UPWARD FLUX AT THE SAME
!   LEVEL, TAKING INTO ACCOUNT MULTIPLE REFLECTIONS FROM
!   CLOUDS, IF PRESENT

!  --- Reshape 2-D arrays to 1-D ---
      DO K=1,LP1
      DO I=1,IMAX
        I1=(K-1)*IMAX+I
        CR1D(I1)=CR(I,K)
        ALFU1D(I1)=ALFAU(I,K)
        TCLD1D(I1)=TCLD(I,K)
        TCLU1D(I1)=TCLU(I,K)
      ENDDO
      ENDDO

!     print *, 'KCLDS=',KCLDS

      DO KK=1,KCLDS
!     -------------

      DO I=1,IMAX
         TEMP1(I)=CR1D(INDX4(I,KK)+2*IMAX)
         TEMP2(I)=ALFU1D(INDX4(I,KK)+IMAX)
         TEMP3(I)=TCLU1D(INDX4(I,KK)+IMAX)
         TEMP4(I)=CR1D(INDX4(I,KK)+IMAX)
         TEMP5(I)=TCLD1D(INDX4(I,KK)+IMAX)
      ENDDO
!     print *, 'TEMP1=',TEMP1

      DO I=1,IMAX
         TEMP6(I)=(TEMP1(I)+TEMP2(I))*TEMP3(I)*TEMP3(I) / &
                  (1.0-(TEMP1(I)+TEMP2(I))*TEMP4(I)*TEMP5(I)*TEMP5(I))
      ENDDO
!     print *, 'TEMP6=',TEMP6

      DO I=1,IMAX
         ALFU1D(INDX4(I,KK))=TEMP6(I)
      ENDDO

!  --- Reshape 1-D array into 2-D array -----
      DO K=1,LP1
      DO I=1,IMAX
         I1=(K-1)*IMAX+I
         ALFAU(I,K)=ALFU1D(I1)
      ENDDO
      ENDDO

!     print *, 'ALFAU=',ALFAU
!     -------------
      ENDDO

!***DEFINE ALFA FROM ALFAU(I,1) AND CR(I,2):
!***ALFA IS THE SYSTEM REFLECTION COEFFICIENT ABOVE THE TOP CLOUD
!    (OR GROUND, IF NO CLOUD AT GRID PT I )

      DO I=1,IMAX
         ALFA(I)=ALFAU(I,1)+CR(I,2)
      ENDDO

!     UPWARD FLUX ABOVE TOPMOST CLOUD
      DO I=1,IMAX
         UFNCLU(I,1)=TCLD(I,1)*ALFA(I)
      ENDDO

      DO I=1,IMAX
         TEMP2(I)=TUCL1I(I,1)*UFNCLU(I,1)
      ENDDO
!     print *, 'TEMP2=',TEMP2

      DO K=1,KJTOP      
      DO I=1,IMAX
         IF (BJTOP(I,K)) THEN
            UFN(I,K,N)=TEMP2(I)*TTU(I,K,N)
         ENDIF
      ENDDO
      ENDDO
!     print *, 'UFN=',UFN

!   CALCULATE UFN AT CLOUD TOPS AND DFN AT CLOUD BOTTOMS

      DO I=1,IMAX
         VV(I)=1.0
      ENDDO

      DO KK=1,KCLDS 
!     -------------
!     print *, 'KK,KCLDS=',KK,KCLDS
!     print *, 'TCLU=',TCLU

      DO I=1,IMAX
         IF (BCLDS(I,KK)) THEN
            UFNCLU(I,KK+1)=ALFAU(I,KK)*VV(I)*TCLD(I,KK)/TCLU(I,KK+1)
            DFNCLD(I,KK)=VV(I)*TCLD(I,KK)* &
                         TCLU(I,KK+1)*TDCL2(I,KK)*TDCL1I(I,KK+1) + &
                         UFNCLU(I,KK+1)*TCLD(I,KK+1)*CR(I,KK+1)
         ELSE
            UFNCLU(I,KK+1)=UFN(I,LP1,N)
            DFNCLD(I,KK)=DFN(I,LP1,N)
         ENDIF
      ENDDO
!     print *, 'UFNCLU=',UFNCLU
!     print *, 'DFNCLD=',DFNCLD

      DO I=1,IMAX
         VV(I)=DFNCLD(I,KK)
      ENDDO

!     print *, 'VV=',VV
!     print *, 'KTOPSW(KK+2)=',KTOPSW(:,KK+2)
!     print *, 'KBTMSW(KK+1)=',KBTMSW(:,KK+1)

      DO I=1,IMAX
         UFN(I,KTOPSW(I,KK+2),N)=UFNCLU(I,KK+1)
         DFN(I,KBTMSW(I,KK+1),N)=DFNCLD(I,KK)
      ENDDO

!     -------------
      ENDDO


!     NOW OBTAIN DFN AND UFN FOR LEVELS BETWEEN THE CLOUDS
      DO 2401 KK=1,KCLDS
!---SKIP IF THERE ARE NO SPACES BETWEEN CLOUD LAYERS KK AND KK+1,
!    FOR ANY GRID PT:
      IF (IBETCL(KK).EQ.0) GO TO 2401
         DO K=KCLDS2,LP1
         DO I=1,IMAX
            IF (BCLDS(I,KK) .AND. &
               (K.GE.KBTMSW(I,KK+1) .AND. K.LE.KTOPSW(I,KK+2))) THEN
                  UFN(I,K,N)=UFNCLU(I,KK+1)*TTU(I,K,N)*TUCL1I(I,KK+1)
                  DFN(I,K,N)=DFNCLD(I,KK)*TTD(I,K,N)*TDCL2I(I,KK)
            ENDIF
         ENDDO
         ENDDO
2401  CONTINUE


!     NOW OBTAIN DOWNWARD AND UPWARD FLUXES FOR LEVELS,IF ANY,
!     BETWEEN THE TOPS AND BOTTOMS OF CLOUDS. THE ASSUMPTION OF
!     CONSTANT HEATING RATE IN THESE REGIONS IS USED.

!***OBTAIN FLUXES AT TOP AND BOTTOM OF CLOUDS
      DO 2501 KK=1,KCLDS
!---SKIP IF THERE ARE NO "THICK CLOUDS" AT ALL IN CLOUD LEVEL KK
      IF (IINCL(KK).EQ.0) GO TO 2501
!
!***OBTAIN DOWNWARD FLUXES AT CLOUD TOPS AND UPWARD FLUXES AT
!   CLOUD BOTTOMS

      IF (KK.GT.1) THEN
         DO I=1,IMAX
            DFNCLU(I,KK)=DFN(I,KTOPSW(I,KK+1),N)
         ENDDO
      ENDIF

      DO I=1,IMAX
         UFNCLD(I,KK)=UFN(I,KBTMSW(I,KK+1),N)
      ENDDO

      DO I=1,IMAX
         TEMP1(I)=(UFNCLU(I,KK)-UFNCLD(I,KK))*DPCLD(I,KK)
         TEMP2(I)=(DFNCLU(I,KK)-DFNCLD(I,KK))*DPCLD(I,KK)
      ENDDO


      DO K=KCLDS2,LP1
      DO I=1,IMAX
         IF (BCLDS(I,KK) .AND. &
             (K.GT.KTOPSW(I,KK+1) .AND. K.LT.KBTMSW(I,KK+1))) THEN
                UFN(I,K,N)=UFNCLU(I,KK)+TEMP1(I)*(PP(I,K)-PPTOP(I,KK))
                DFN(I,K,N)=DFNCLU(I,KK)+TEMP2(I)*(PP(I,K)-PPTOP(I,KK))
         ENDIF
      ENDDO
      ENDDO

2501  CONTINUE

!-----------------------------------------------------------------------

2301                           CONTINUE

!-----------------------------------------------------------------------

                                ENDIF

!***********************************************************************

!   CALCULATE ENTERING FLUX AT THE TOP
!   LOOP 860 SCALES THE DFN'S AND UFN'S TO THE CORRECT DFN(I,1,N)

      DO N=1,NB
      DO I=1,IMAX
         DFNTOP(I,N)=SSOLAR(I)*6.97667E5*PWTS(N)
!OLD     DFNTOP(I,N)=SSOLAR*6.97667E5*COSZRO(I)*TAUDAR(I)*PWTS(N)
      ENDDO
      ENDDO

      DO N=1,NB
      DO K=1,LP1
      DO I=1,IMAX
         DFN(I,K,N)=DFN(I,K,N)*DFNTOP(I,N)
         UFN(I,K,N)=UFN(I,K,N)*DFNTOP(I,N)
      ENDDO
      ENDDO
      ENDDO

!   SUM OVER BANDS

      DO K=1,LP1
      DO I=1,IMAX
         DFSW(I,K)=DFN(I,K,1)
         UFSW(I,K)=UFN(I,K,1)
      ENDDO
      ENDDO

      DO N=2,NB
      DO K=1,LP1
      DO I=1,IMAX
         DFSW(I,K)=DFSW(I,K)+DFN(I,K,N)
         UFSW(I,K)=UFSW(I,K)+UFN(I,K,N)
      ENDDO
      ENDDO
      ENDDO

      DO K=1,LP1
      DO I=1,IMAX
         FSW(I,K)=UFSW(I,K)-DFSW(I,K)
      ENDDO
      ENDDO

      DO K=1,LMAX
      DO I=1,IMAX
         HSW(I,K)=RADCON*(FSW(I,K+1)-FSW(I,K))/DP(I,K)
      ENDDO
      ENDDO

!-----------------------------------------------------------------------

      END SUBROUTINE SWRAD_ORIG

!#######################################################################
      SUBROUTINE SHORTWAVE_INIT

!------- write version number and namelist ---------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
      endif

      module_is_initialized = .true.

!---------------------------------------------------------------------

      END SUBROUTINE SHORTWAVE_INIT

!#######################################################################

      SUBROUTINE SHORTWAVE_END

      module_is_initialized = .false.

!---------------------------------------------------------------------

      END SUBROUTINE SHORTWAVE_END

!#######################################################################

      END MODULE SHORTWAVE_MOD

module vegn_cohort_mod

use constants_mod, only: PI

use land_constants_mod, only: NBANDS, &
     mol_h2o, mol_air
use vegn_data_mod, only : spdata, &
   use_mcm_masking, use_bucket, critical_root_density, &
   tg_c4_thresh, tg_c3_thresh, l_fract, fsc_liv, &
   phen_ev1, phen_ev2, cmc_eps
use vegn_data_mod, only : PT_C3, PT_C4, CMPT_ROOT, CMPT_LEAF, &
   SP_C4GRASS, SP_C3GRASS, SP_TEMPDEC, SP_TROPICAL, SP_EVERGR, &
   LEAF_OFF, LU_CROP, PHEN_EVERGREEN, PHEN_DECIDIOUS
   
implicit none
private
! ==== public interfaces =====================================================
public :: vegn_phys_prog_type
public :: vegn_cohort_type

! operations defined for cohorts
!public :: new_cohort, delete_cohort
public :: vegn_data_heat_capacity
public :: vegn_data_intrcptn_cap
public :: get_vegn_wet_frac
public :: vegn_data_cover
public :: cohort_uptake_profile
public :: cohort_root_properties
 
public :: btotal ! returns cohort total biomass
public :: c3c4   ! returns physiology type for given biomasses and conditions
public :: phenology_type ! returns type of phenology for given conditions
public :: update_species ! updates cohort physiology, phenology type, and species
public :: height_from_biomass
public :: lai_from_biomass
public :: update_bio_living_fraction
public :: update_biomass_pools
! ==== end of public interfaces ==============================================

! ==== module constants ======================================================
character(len=*), parameter :: &
     version = '$Id: vegn_cohort.F90,v 20.0 2013/12/13 23:31:00 fms Exp $', &
     tagname = '$Name: tikal $'

! ==== types =================================================================
type :: vegn_phys_prog_type
  real Wl
  real Ws
  real Tv
end type vegn_phys_prog_type

! vegn_cohort_type describes the data that belong to a vegetation cohort
type :: vegn_cohort_type
  type(vegn_phys_prog_type) :: prog

! ---- biological prognostic variables
! Currently bio prognostic variable is defined as anything that's saved in
! the restart; clearly some vars there are, strictly speaking, diagnostic,
! but saved for reproducibility (to avoid recalculation). exceptions :
! npp_previous_day is left outside, since it's obviously auxiliary; height
! is left outside
  integer :: species = 0   ! vegetation species
  real    :: bl      = 0.0 ! biomass of leaves, kg C/m2
  real    :: blv     = 0.0 ! biomass of virtual leaves (labile store), kg C/m2
  real    :: br      = 0.0 ! biomass of fine roots, kg C/m2
  real    :: bsw     = 0.0 ! biomass of sapwood, kg C/m2
  real    :: bwood   = 0.0 ! biomass of heartwood, kg C/m2

  real    :: bliving = 0.0 ! leaves, fine roots, and sapwood biomass
  integer :: status  = 0   ! growth status of plant
  real    :: leaf_age= 0.0 ! age of leaf in days since budburst

! ---- physical parameters
  real    :: height    = 0.0 ! vegetation height, m
  real    :: lai       = 0.0 ! leaf area index, m2/m2
  real    :: sai       = 0.0 ! stem area index, m2/m2
  real    :: leaf_size = 0.0 ! leaf dimension, m
  real    :: root_density = 0.0
  real    :: root_zeta    = 0.0
  real    :: rs_min       = 0.0
  real    :: leaf_refl(NBANDS) = 0.0 ! reflectance of leaf, per band
  real    :: leaf_tran(NBANDS) = 0.0 ! transmittance of leaf, per band
  real    :: leaf_emis         = 0.0 ! emissivity of leaf
  real    :: snow_crit         = 0.0 ! later parameterize this as snow_mask_fac*height

! ---- auxiliary variables 

  real    :: Wl_max  = 0.0 ! maximum liquid water content of canopy, kg/(m2 of ground)
  real    :: Ws_max  = 0.0 ! maximum soild water content of canopy, kg/(m2 of ground)
  real    :: mcv_dry = 0.0 ! heat capacity of dry canopy
  real    :: cover

  integer :: pt = 0  ! physiology type
  integer :: phent = 0 ! phenology type

  real :: b      = 0.0 ! total biomass
  real :: babove = 0.0 ! total above ground biomass
  real :: bs     = 0.0 ! structural biomass: stem + structural roots
  real :: bstem  = 0.0 ! stem biomass

  real :: gpp  = 0.0 ! gross primary productivity kg C/timestep
  real :: npp  = 0.0 ! net primary productivity kg C/timestep
  real :: npp2 = 0.0 ! temporarily stores eddy_npp
  real :: miami_npp = 0.0 ! stores miami-model npp

  real :: resp = 0.0 ! plant respiration
  real :: resl = 0.0 ! leaf respiration
  real :: resr = 0.0 ! root respiration
  real :: resg = 0.0 ! growth respiration
  real :: md   = 0.0 ! plant tissue maintenance kg C/timestep

  real :: An_op = 0.0 ! mol C/(m2 of leaf per year)
  real :: An_cl = 0.0 ! mol C/(m2 of leaf per year)
  
  real :: carbon_gain = 0.0 ! carbon gain during the month
  real :: carbon_loss = 0.0 ! carbon loss during the month
  real :: bwood_gain  = 0.0 !

  ! used in fast time scale calculations
  real :: npp_previous_day     = 0.0
  real :: npp_previous_day_tmp = 0.0

  ! lena added this for storing previous size stomatal opening and lwnet 
  ! for computing canopy air T and q at the next step
  
  real :: gs = 0.0
  real :: gb = 0.0
!moved to prog%Wl  real :: cmc;
!moved to prog%Tv  real :: tleaf ! temperature of leaves, degK

  real :: ds = 0.0

  ! new allocation fractions, Jan2 03
  real :: Pl = 0.0          ! fraction of living biomass in leaves
  real :: Pr = 0.0          ! fraction of living biomass in fine roots
  real :: Psw= 0.0          ! fraction of living biomass in sapwood
  real :: Psw_alphasw = 0.0 ! fraction of sapwood times 
                            ! retirement rate of sapwood into wood
  real :: extinct = 0.0     ! light extinction coefficient in the canopy for photosynthesis calculations
  
! in LM3V the cohort structure has a handy pointer to the tile it belongs to;
! so operations on cohort can update tile-level variables. In this code, it is
! probably impossible to have this pointer here: it needs to be of type
! "type(vegn_tile_type), pointer", which means that the vegn_cohort_mod needs to
! use vegn_tile_mod. But the vegn_tile_mod itself uses vegn_cohort_mod, and 
! this would create a circular dependency of modules, something that's 
! prohibited in FORTRAN.
!  type(vegn_tile_type), pointer :: cp
end type vegn_cohort_type

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-


! ============================================================================
subroutine vegn_data_heat_capacity ( cohort, mcv )
  type(vegn_cohort_type), intent(in)  :: cohort
  real                  , intent(out) :: mcv
  
  mcv = cohort%mcv_dry        ! later add term in vegn_pars%lai
end subroutine


! ============================================================================
subroutine vegn_data_intrcptn_cap ( cohort, vegn_Wl_max, vegn_Ws_max )
  type(vegn_cohort_type), intent(in)  :: cohort
  real                  , intent(out) :: vegn_Wl_max, vegn_Ws_max

  vegn_Wl_max = cohort%Wl_max
  vegn_Ws_max = cohort%Ws_max
end subroutine

! ============================================================================
! calculates functional dependence of wet canopy function f = x**p and its 
! derivative, but approximates it with linear function in the vicinity 
! of zero, to make sure that derivative doesn't become infinite
subroutine wet_frac(w, w_max, p, eps, f, DfDw)
  real, intent(in) :: &
       w, &     ! water content
       w_max, & ! maximum storage capacity
       p, &     ! exponent of the function
       eps      ! neighbourhood of zero where we approximate x**p with linear function
  real, intent(out) :: &
       f, & ! function value
       DfDw ! it's derivative

  if ( w > w_max ) then 
     f = 1; DfDw = 0;
  else if ( w < 0 ) then
     f = 0; DfDw = 0;
  else
     if ( w/w_max <= eps ) then
        f = eps**(p-1)*w/w_max; DfDw = eps**(p-1)/w_max
     else
        f = (w/w_max)**p;   DfDw = p/w_max*(w/w_max)**(p-1)
     endif
  endif
end subroutine wet_frac

! ============================================================================
! given amount of water and snow, returns combined fraction of covered canopy
subroutine get_vegn_wet_frac (cohort, &
     fw, DfwDwl, DfwDws, &
     fs, DfsDwl, DfsDws  )
  type(vegn_cohort_type), intent(in)  :: cohort
  real, intent(out), optional :: &
       fw, DfwDwl, DfwDws, & ! water-covered fraction of canopy and its derivatives
       fs, DfsDwl, DfsDws    ! snow-covered fraction of canopy and its derivatives

  ! ---- local vars
  integer :: sp  ! shorthand for current cohort species
  real    :: fw0 ! total water-covered fraction (without overlap)
  real    :: &   ! local variable for fractions and derivatives
       fwL, DfwDwlL, DfwDwsL, & ! water-covered fraction of canopy and its derivatives
       fsL, DfsDwlL, DfsDwsL    ! snow-covered fraction of canopy and its derivatives

  sp = cohort%species

  ! snow-covered fraction
  if(cohort%Ws_max > 0) then
     call wet_frac(cohort%prog%Ws, cohort%Ws_max, spdata(sp)%csc_pow, cmc_eps, fsL,  DfsDwsL)
  else
     fsL = 0.0; DfsDwsL=0.0
  endif
  DfsDwlL = 0
     
  ! wet fraction
  if(cohort%Wl_max > 0) then
     call wet_frac(cohort%prog%Wl, cohort%Wl_max, spdata(sp)%cmc_pow, cmc_eps, fw0, DfwDwlL)
  else
     fw0 = 0.0; DfwDwlL=0.0
  endif
  ! take into account overlap by snow
  fwL     = fw0*(1-fsL)
  DfwDwlL = DfwDwlL*(1-fsL)
  DfwDwsL = -fw0*DfsDwsL

  ! assign result to output parameters, if present
  if (present(fw))     fw = fwL
  if (present(DfwDwl)) DfwDwl = DfwDwlL
  if (present(DfwDws)) DfwDws = DfwDwsL
  if (present(fs))     fs = fsL
  if (present(DfsDwl)) DfsDwl = DfsDwlL
  if (present(DfsDws)) DfsDws = DfsDwsL
  
end subroutine


! ============================================================================
subroutine vegn_data_cover ( cohort, snow_depth, vegn_cover, &
                                         vegn_cover_snow_factor )
  type(vegn_cohort_type), intent(inout)  :: cohort
  real, intent(in)  :: snow_depth
  real, intent(out) :: vegn_cover
  real, intent(out) :: vegn_cover_snow_factor

  cohort%cover = 1 - exp(-cohort%lai)
  if (use_mcm_masking) then
     vegn_cover_snow_factor =  &
           (1 - min(1., 0.5*sqrt(max(snow_depth,0.)/cohort%snow_crit)))
     cohort%cover = cohort%cover * &
           (1 - min(1., 0.5*sqrt(max(snow_depth,0.)/cohort%snow_crit)))
  else
     vegn_cover_snow_factor =  &
           cohort%snow_crit / &
          (max(snow_depth,0.0) + cohort%snow_crit)
     cohort%cover = cohort%cover * &
           cohort%snow_crit / &
          (max(snow_depth,0.0) + cohort%snow_crit)
  endif
  vegn_cover = cohort%cover
end subroutine vegn_data_cover


! ============================================================================
! returns properties of the fine roots
subroutine cohort_root_properties(cohort, dz, vrl, K_r, r_r)
  type(vegn_cohort_type), intent(in)  :: cohort
  real, intent(in)  :: dz(:)
  real, intent(out) :: &
       vrl(:), & ! volumetric fine root length, m/m3
       K_r,    & ! root membrane permeability per unit area, kg/(m3 s)
       r_r       ! radius of fine roots, m

  integer :: sp, l
  real :: factor, z
  real :: vbr ! volumetric biomass of fine roots, kg C/m3

  sp = cohort%species

  factor = 1.0/(1.0-exp(-sum(dz)/cohort%root_zeta))
  z = 0
  do l = 1, size(dz)
     ! calculate the volumetric fine root biomass density [kgC/m3] for current layer
     ! NOTE: sum(brv*dz) must be equal to cohort%br, which is achieved by nomalizing
     ! factor
     vbr = cohort%br * &
          (exp(-z/cohort%root_zeta) - exp(-(z+dz(l))/cohort%root_zeta))*factor/dz(l)
     ! calculate the volumetric fine root length
     vrl(l) = vbr*spdata(sp)%srl

     z = z + dz(l)
  enddo

  K_r = spdata(sp)%root_perm
  r_r = spdata(sp)%root_r

end subroutine 


! ============================================================================
! calculates vertical distribution of active roots: given layer thicknesses,
! returns fraction of active roots per level
subroutine cohort_uptake_profile(cohort, dz, uptake_frac_max, vegn_uptake_term)
  type(vegn_cohort_type), intent(in)  :: cohort
  real, intent(in)  :: dz(:)
  real, intent(out) :: uptake_frac_max(:)
  real, intent(out) :: vegn_uptake_term(:)

  real, parameter :: res_scaler = mol_air/mol_h2o  ! scaling factor for water supply
  ! NOTE: there is an inconsistency there between the 
  ! units of stomatal conductance [mol/(m2 s)], and the units of humidity deficit [kg/kg],
  ! in the calculations of water demand. Since the uptake options other than LINEAR can't 
  ! use res_scaler, in this code the units of humidity deficit are converted to mol/mol,
  ! and the additional factor is introduced in res_scaler to ensure that the LINEAR uptake 
  ! gives the same results.

  integer :: l
  real    :: z, sum_rf

  if (use_bucket) then
     uptake_frac_max(1) = dz(1)
     z = dz(1)
     do l = 2, size(dz)
        if (cohort%root_density*(exp(-z/cohort%root_zeta)-&
            exp(-(z+dz(l))/cohort%root_zeta))/dz(l) > critical_root_density) &
        then
           uptake_frac_max(l) = dz(l)
        else
           uptake_frac_max(l) = 0
        endif
        z = z + dz(l)
     enddo
  else
     !linear scaling, LM3V
     z = 0
     do l = 1, size(dz)
        uptake_frac_max(l) = (exp(-z/cohort%root_zeta)    &
                - exp(-(z+dz(l))/cohort%root_zeta))
         uptake_frac_max(l) = &
                max( uptake_frac_max(l), 0.0)
        z = z + dz(l)
     enddo

  endif
  
  sum_rf = sum(uptake_frac_max)
  if(sum_rf>0) &
       uptake_frac_max(:) = uptake_frac_max(:)/sum_rf
  
  if (cohort%br <= 0) then
     vegn_uptake_term(:) = 0.0
  else   
     vegn_uptake_term(:) = uptake_frac_max(:) * &
          res_scaler * spdata(cohort%species)%dfr * cohort%br
  endif

end subroutine 


! ============================================================================
function btotal(c)
  real :: btotal ! returned value
  type(vegn_cohort_type), intent(in) :: c
  
  btotal = c%bliving+c%bwood
end function


! ============================================================================
function c3c4(c, temp, precip) result (pt)
  integer :: pt
  type(vegn_cohort_type), intent(in) :: c
  real,              intent(in) :: temp   ! temperatire, degK
  real,              intent(in) :: precip ! precipitation, ???

  real :: pc4
  
  ! Rule based on analysis of ED global output; equations from JPC, 2/02
  if(btotal(c) < tg_c4_thresh) then
    pc4=exp(-0.0421*(273.16+25.56-temp)-(0.000048*(273.16+25.5-temp)*precip));
  else
    pc4=0.0;
  endif
  
  if(pc4>0.5) then 
    pt=PT_C4
  else 
    pt=PT_C3
  endif
  
end function


! ============================================================================
! given current conditions, returns type of phenology.
function phenology_type(c, cm)
  integer :: phenology_type
  type(vegn_cohort_type), intent(in) :: c  ! cohort (not used???)
  real, intent(in) :: cm ! number of cold months
   
  real :: pe  ! prob evergreen
   
  ! GCH, Rule based on analysis of ED global output; equations from JPC, 2/02
  ! GCH, Parameters updated 2/9/02 from JPC
  pe = 1.0/(1.0+((1.0/0.00144)*exp(-0.7491*cm)));
  
  if(pe>phen_ev1 .and. pe<phen_ev2) then
     phenology_type = PHEN_EVERGREEN ! its evergreen
  else
     phenology_type = PHEN_DECIDIOUS ! its deciduous
  endif
end function


! ============================================================================
! given a cohort, climatology, and land use type, determines and updates 
! physiology type, phenology type, and species of the cohort
subroutine update_species(c, t_ann, t_cold, p_ann, cm, landuse)
  type(vegn_cohort_type), intent(inout) :: c    ! cohort to update
  real,              intent(in) :: t_ann   ! annual-mean temperature, degK
  real,              intent(in) :: t_cold  ! average temperature of the coldest month, degK
  real,              intent(in) :: p_ann   ! annual-mean precipitation, mm/yr
  real,              intent(in) :: cm      ! number of cold months
  integer,           intent(in) :: landuse ! land use type

  integer :: spp

  c%pt    = c3c4(c,t_ann,p_ann)
  c%phent = phenology_type(c, cm) 
  
  if(landuse == LU_CROP) c%phent = 0  ! crops can't be evergreen
  
  if(c%pt==PT_C4) then
     spp=SP_C4GRASS;  ! c4 grass
  else if(c%phent==1) then
     spp=SP_EVERGR;   ! evergreen non-grass
  else if(btotal(c) < tg_c3_thresh) then
     spp=SP_C3GRASS;  ! c3 grass
  else if ( t_cold > 278.16 ) then  ! ens,slm Jun 21 2003 to prohibit tropical forest in coastal cells
     spp=SP_TROPICAL; ! tropical deciduous non-grass
  else 
     spp=SP_TEMPDEC;  ! temperate deciduous non-grass
  endif

  ! reset leaf age to zero if species are chnaged
  if (spp/=c%species) c%leaf_age = 0.0

  c%species = spp
end subroutine


! ============================================================================
function height_from_biomass(btotal) result (height)
  real :: height ! returned value
  real, intent(in) :: btotal

  ! GCH, Function from JPC 2/9/02
!  height = 24.19*(1.0-exp(-0.19*(c%bliving+c%bwood)))
  height = 24.19*(1.0-exp(-0.19*btotal))
end function


! ============================================================================
function lai_from_biomass(bl,species) result (lai)
  real :: lai ! returned value
  real,    intent(in) :: bl      ! biomass of leaves, kg C/m2
  integer, intent(in) :: species ! species

  lai = bl*(spdata(species)%specific_leaf_area);   
end function


! ============================================================================
! calculates fractions of living biomass in differerent compartments
subroutine update_bio_living_fraction(c)
  type(vegn_cohort_type), intent(inout) :: c

  real    :: D  ! inverse denominator
  integer :: sp ! species, for convenience

  sp     = c%species
  D      = 1/(1 + spdata(sp)%c1 + c%height*spdata(sp)%c2)

  c%Pl   = D
  c%Pr   = spdata(sp)%c1 * D
  c%Psw  = 1 - c%Pl - c%Pr
  c%Psw_alphasw = spdata(sp)%c3 * spdata(sp)%alpha(CMPT_LEAF) * D
  
end subroutine update_bio_living_fraction


! ============================================================================
! redistribute living biomass pools in a given cohort, and update related 
! properties (height, lai, sai)
subroutine update_biomass_pools(c)
  type(vegn_cohort_type), intent(inout) :: c

  c%b      = c%bliving + c%bwood;
  c%height = height_from_biomass(c%b);
  call update_bio_living_fraction(c);
  c%bsw = c%Psw*c%bliving;
  if(c%status == LEAF_OFF) then
     c%blv = c%Pl*c%bliving + c%Pr*c%bliving;
     c%bl  = 0;
     c%br  = 0;
  else
     c%blv = 0;
     c%bl  = c%Pl*c%bliving;
     c%br  = c%Pr*c%bliving;
  endif
  c%lai = lai_from_biomass(c%bl,c%species)
  c%sai = 0.035*c%height ! Federer and Lash,1978
end subroutine 


end module vegn_cohort_mod

      Module co2int_mod

!-----------------------------------------------------------------------
!
!       CO2INT INTERPOLATES CARBON DIOXIDE TRANSMISSION FUNCTIONS
!  FROM THE 109 LEVEL GRID,FOR WHICH THE TRANSMISSION FUNCTIONS
!  HAVE BEEN PRE-CALCULATED, TO THE GRID STRUCTURE SPECIFIED BY THE
!  USER.
!
!        METHOD: 
!
!      CO2INT IS EMPLOYABLE FOR TWO PURPOSES: 1) TO OBTAIN TRANSMIS-
!  SIVITIES BETWEEN ANY 2 OF AN ARRAY OF USER-DEFINED PRESSURES; AND
!  2) TO OBTAIN LAYER-MEAN TRANSMISSIVITIES BETWEEN ANY 2 OF AN ARRAY
!  OF USER-DEFINED PRESSURE LAYERS.TO CLARIFY THESE TWO PURPOSES,SEE
!  THE DIAGRAM AND DISCUSSION BELOW.
!      CO2INT MAY BE USED TO EXECUTE ONLY ONE PURPOSE AT ONE TIME.
!
!     LET P BE AN ARRAY OF USER-DEFINED PRESSURES
!     AND PD BE USER-DEFINED PRESSURE LAYERS.
!
!       - - - - - - - - -   PD(I-1) ---
!                                     !
!       -----------------   P(I)      !  PRESSURE LAYER I  (PLM(I))
!                                     !
!       - - - - - - - - -   PD(I)  ---
!                                     !
!       -----------------   P(I+1)    !  PRESSURE LAYER I+1 (PLM(I+1))
!                                     !
!       - - - - - - - - -   PD(I+1)---
!            ...                          (THE NOTATION USED IS
!            ...                          CONSISTENT WITH THE CODE)
!            ...
!      - - - - - - - - -    PD(J-1)
!
!      -----------------    P(J)
!
!      - - - - - - - - -    PD(J)
!
!      PURPOSE 1:   THE TRANSMISSIVITY BETWEEN SPECIFIC PRESSURES
!      P(I) AND P(J) ,TAU(P(I),P(J))  IS COMPUTED BY THIS PROGRAM.
!      IN THIS MODE,THERE IS NO REFERENCE TO LAYER PRESSURES PD
!      (PD,PLM ARE NOT INPUTTED).
!
!      PURPOSE 2:   THE LAYER-MEAN TRANSMISSIVITY BETWEEN A LAYER-
!      MEAN PRESSURE PLM(J) AND PRESSURE LAYER I IS GIVEN BY
!         TAULM(PLM(I),PLM(J)). IT IS COMPUTED BY THE INTEGRAL
!
!                           PD(I)
!                           ----
!             1             !
!        -------------  *   !   TAU ( P',PLM(J) )  DP'
!        PD(I)-PD(I-1)      !
!                        ----
!                        PD(I-1)
!
!           THE LAYER-MEAN PRESSURE PLM(I) IS SPECIFIED BY THE USER.
!        FOR MANY PURPOSES,PLM WILL BE CHOSEN TO BE THE AVERAGE
!        PRESSURE IN THE LAYER-IE,PLM(I)=0.5*(PD(I-1)+PD(I)).
!           FOR LAYER-MEAN TRANSMISSIVITIES,THE USER THUS INPUTS
!        A PRESSURE ARRAY (PD) DEFINING THE PRESSURE LAYERS AND AN
!        ARRAY (PLM) DEFINING THE LAYER-MEAN PRESSURES.THE CALCULATION
!        DOES NOT DEPEND ON THE P ARRAY USED FOR PURPOSE 1 (P IS NOT
!        INPUTTED).
!
!            THE FOLLOWING PARAGRAPHS DEPICT THE UTILIZATION OF THIS
!       CODE WHEN USED TO COMPUTE TRANSMISSIVITIES BETWEEN SPECIFIC
!       PRESSURES. LATER PARAGRAPHS DESCRIBE ADDITIONAL FEATURES NEEDED
!       FOR LAYER-MEAN TRANSMISSIVITIES.
!
!          FOR A GIVEN CO2 MIXING RATIO AND STANDARD TEMPERATURE
!      PROFILE,A TABLE OF TRANSMISSION FUNCTIONS FOR A FIXED GRID
!     OF ATMOSPHERIC PRESSURES HAS BEEN PRE-CALCULATED.
!      THE STANDARD TEMPERATURE PROFILE IS COMPUTED FROM THE US
!     STANDARD ATMOSPHERE (1977) TABLE.ADDITIONALLY, THE
!     SAME TRANSMISSION FUNCTIONS HAVE BEEN PRE-CALCULATED FOR A
!     TEMPERATURE PROFILE INCREASED AND DECREASED (AT ALL LEVELS)
!     BY 25 DEGREES.
!         THIS PROGRAM READS IN THE PRESPECIFIED TRANSMISSION FUNCTIONS
!     AND A USER-SUPPLIED PRESSURE GRID (P(I)) AND CALCULATES TRANS-
!     MISSION FUNCTIONS ,TAU(P(I),P(J)), FOR ALL P(I)'S AND P(J)'S.
!     A LOGARITHMIC INTERPOLATION SCHEME IS USED.
!         THIS METHOD IS REPEATED FOR THE THREE TEMPERATURE PROFILES
!     GIVEN ABOVE .THEREFORE OUTPUTS FROM THE PROGRAM ARE THREE TABLES
!     OF TRANSMISSION FUNCTIONS FOR THE USER-SUPPLIED PRESSURE GRID.
!     THE EXISTENCE OF THE THREE TABLES PERMITS SUBSEQUENT INTERPO-
!     LATION TO A USER-SUPPLIED TEMPERATURE PROFILE USING THE METHOD
!     DESCRIBED IN THE REFERENCE.SEE LIMITATIONS SECTION IF THE
!     USER DESIRES TO OBTAIN ONLY 1 TABLE OF TRANSMISSIVITIES.
!
!     MODIFICATIONS FOR LAYER-MEAN TRANSMISSIVITIES: 
!          THE PRESSURES INPUTTED ARE THE LAYER-MEAN PRESSURES,PD,
!     AND THE LAYER-MEAN PRESSURES ,PLM. A SERIES OF TRANSMISSIVITIES
!     (TAU(P',PLM(J)) ARE COMPUTED AND THE INTEGRAL GIVEN IN THE
!     DISCUSSION OF PURPOSE 2 IS COMPUTED.FOR PLM(I) NOT EQUAL TO
!     PLM(J) SIMPSON'S RULE IS USED WITH 5 POINTS. IF PLM(I)=PLM(J)
!     (THE "NEARBY LAYER" CASE) A 49-POINT QUADRATURE IS USED FOR
!     GREATER ACCURACY.THE OUTPUT IS IN TAULM(PLM(I),PLM(J)).
!        NOTE: 
!     TAULM IS NOT A SYMMETRICAL MATRIX. FOR THE ARRAY ELEMENT
!     TAULM(PLM(I),PLM(J)),THE INNER(FIRST,MOST RAPIDLY VARYING)
!     DIMENSION IS THE VARYING LAYER-MEAN PRESSURE,PLM(I);THE OUTER
!     (SECOND) DIMENSION IS THE FIXED LAYER-MEAN PRESSURE PLM(J).
!     THUS THE ELEMENT TAULM(2,3) IS THE TRANSMISSION FUNCTION BETWEEN
!     THE FIXED PRESSURE PLM(3) AND THE PRESSURE LAYER HAVING AN AVERAGE
!     PRESSURE OF PLM(2).
!         ALSO NOTE THAT NO QUADRATURE IS PERFORMED OVER THE LAYER
!     BETWEEN THE SMALLEST NONZERO PRESSURE AND ZERO PRESSURE;
!     TAULM IS TAULM(0,PLM(J)) IN THIS CASE,AND TAULM(0,0)=1.
!
!
!             REFERENCE: 
!         S.B.FELS AND M.D.SCHWARZKOPF,"AN EFFICIENT,ACCURATE
!     ALGORITHM FOR CALCULATING CO2 15 UM BAND COOLING RATES",JOURNAL
!     OF GEOPHYSICAL RESEARCH,VOL.86,NO. C2, PP.1205-1232,1981.
!        MODIFICATIONS TO THE ALGORITHM HAVE BEEN MADE BY THE AUTHORS;
!     CONTACT S.B.F.OR M.D.S. FOR FURTHER DETAILS.A NOTE TO J.G.R.
!     IS PLANNED TO DOCUMENT THESE CHANGES.
!
!            AUTHOR:    M.DANIEL SCHWARZKOPF
!
!            DATE:      14 JULY 1983
!
!            ADDRESS: 
!
!                      G.F.D.L.
!                      P.O.BOX 308
!                      PRINCETON,N.J.08540
!                      U.S.A.
!            TELEPHONE:  (609) 452-6521
!
!            INFORMATION ON TAPE: THIS SOURCE IS THE FIRST FILE
!        ON THIS TAPE.THE SIX FILES THAT FOLLOW ARE CO2 TRANS-
!        MISSIVITIES FOR THE 500-850 CM-1 INTERVAL FOR CO2
!        CONCENTRATIONS OF 330 PPMV (1X) ,660 PPMV (2X), AND
!        1320 PPMV (4X). THE FILES ARE ARRANGED AS FOLLOWS: 
!          FILE 2   1X,CONSOLIDATED USING B(250) WEIGHTING FCTN.
!          FILE 3   1X,CONSOLIDATED WITH NO WEIGHTING FCTN.
!          FILE 4   2X,CONSOLIDATED USING B(250) WEIGHTING FCTN.
!          FILE 5   2X,CONSOLIDATED WITH NO WEIGHTING FCTN.
!          FILE 6   4X,CONSOLIDATED USING B(250) WEIGHTING FCTN.
!          FILE 7   4X,CONSOLIDATED WITH NO WEIGHTING FCTN.
!            FILES 2,4,6 ARE RECOMMENDED FOR USE IN OBTAINING
!        TRANSMISSION FUNCTIONS FOR USE IN HEATING RATE
!        COMPUTATIONS;THEY CORRESPOND TO THE TRANSMISSIVITIES
!        DISCUSSED IN THE 1980 PAPER.FILES 3,5,7 ARE PROVIDED
!        TO FACILITATE COMPARISON WITH OBSERVATION AND WITH OTHER
!        CALCULATIONS.
!
!            PROGRAM LANGUAGE: FORTRAN 1977,INCLUDING PARAMETER
!        AND PROGRAM STATEMENTS.THE PROGRAM IS WRITTEN ON A
!        CYBER 170-730.SEE THE SECTION ON LIMITATIONS FOR
!        ADAPTATIONS TO OTHER MACHINES.
!
!
!            PARAMETER INPUTS: 
!     A) NLEVLS    : NLEVLS IS AN (INTEGER) PARAMETER DENOTING
!        THE NUMBER OF NONZERO PRESSURE LEVELS FOR PURPOSE 1
!        OR THE NUMBER OF NONZERO LAYER PRESSURES NEEDED TO
!        SPECIFY THE PRESSURE LAYERS(PURPOSE 2) IN THE OUTPUT
!        GRID. FOR EXAMPLE,IN PURPOSE 1,IF P=0,100,1000,NLEVLS=2.
!        IF,IN PURPOSE 2,PD=0,100,500,1000,THE NUMBER OF NONZERO
!        PRESSURE LAYERS=2,SO NLEVLS=2
!           IN THE CODE AS WRITTEN,NLEVLS=40; THE USER SHOULD
!        CHANGE THIS VALUE TO A USER-SPECIFIED VALUE.
!     B) NLP1,NLP2 : INTEGER PARAMETERS DEFINED AS: NLP1=NLEVLS+1;
!        NLP2=NLEVLS+2.
!           SEE LIMITATIONS FOR CODE MODIFICATIONS IF PARAMETER
!        STATEMENTS ARE NOT ALLOWED ON YOUR MACHINE.
!
!            INPUTS: 
!
!     A) TRANSA    : THE 109X109 GRID OF TRANSMISSION FUNCTIONS
!            TRANSA IS A  REAL ARRAY.
!
!           TRANSA  IS READ FROM FILE 20. THIS FILE CONTAINS 3
!     RECORDS,AS FOLLOWS: 
!        1)   TRANSA, STANDARD TEMPERATURE PROFILE
!        3)   TRANSA, STANDARD TEMPERATURES + 25 DEG
!        5)   TRANSA, STANDARD TEMPERATURES - 25 DEG
!
!     B)   NMETHD: AN INTEGER WHOSE VALUE IS EITHER 1 (IF CO2INT IS
!       TO BE USED FOR PURPOSE 1) OR 2 (IF CO2INT IS TO BE USED FOR
!       PURPOSE 2).
!
!     C)     P,PD,PLM : 
!          P IS A REAL ARRAY (LENGTH NLP1) SPECIFYING THE PRESSURE
!       GRID AT WHICH TRANSMISSION FUNCTIONS ARE TO BE COMPUTED FOR
!       PURPOSE 1.THE DIMENSION  OF P IS  IN MILLIBARS.THE
!       FOLLOWING LIMITATIONS WILL BE EXPLAINED MORE
!       IN THE SECTION ON LIMITATIONS: P(1) MUST BE ZERO; P(NLP1),THE
!       LARGEST PRESSURE, MUST NOT EXCEED 1165 MILLIBARS.
!         PD IS A REAL ARRAY (LENGTH NLP2) SPECIFYING THE PRESSURE
!       LAYERS FOR WHICH LAYER-AVERAGED TRANSMISSION FUNCTIONS ARE
!       TO BE COMPUTED.THE DIMENSION OF PD IS MILLIBARS.THE LIMITATIONS
!       FOR PD ARE THE SAME AS FOR P,AND ARE GIVEN IN THE SECTION ON
!       LIMITATIONS.
!         PLM IS A REAL ARRAY (LENGTH NLP2) SPECIFYING THE LAYER-MEAN
!       PRESSURES. THE DIMENSION OF PLM IS MILLIBARS. THE LIMITATIONS
!       FOR PLM ARE THE SAME AS FOR P,AND ARE GIVEN IN THE SECTION ON
!       LIMITATIONS.PD IS READ IN BEFORE PLM.
!
!          NOTE: AGAIN,WE NOTE THAT THE USER WILL INPUT EITHER P (FOR
!       PURPOSE 1) OR PD AND PLM(FOR PURPOSE 2) BUT NOT BOTH.
!
!
!
!
!           LIMITATIONS: 
!     1)       P(1)=0.,PD(1)=0.,PLM(1)=0. THE TOP PRESSURE LEVEL
!       MUST BE ZERO,OR THE TOP PRESSURE LAYER MUST BE BOUNDED BY ZERO.
!       THE TOP LAYER-MEAN PRESSURE (PLM(1)) MUST BE ZERO; NO
!       QUADRATURE IS DONE ON THE TOP PRESSURE LAYER.EVEN IF ONE IS
!       NOT INTERESTED IN THE TRANSMISSION FUNCTION BETWEEN 0 AND P(J),
!       ONE MUST INCLUDE SUCH A LEVEL.
!     2)      PD(NLP2)=P(NLP1) IS LESS THAN OR EQUAL TO 1165 MB.
!       EXTRAPOLATION TO HIGHER PRESSURES IS NOT POSSIBLE.
!     3)      IF PROGRAM IS NOT PERMITTED ON YOUR COMPILER,
!       SIMPLY DELETE THE LINE.
!     4)      IF PARAMETER IS NOT PERMITTED,DO THE FOLLOWING: 
!            1) DELETE ALL PARAMETER STATEMENTS IN CO2INT
!            2) AT THE POINT WHERE NMETHOD IS READ IN,ADD: 
!                READ (5,202) NLEVLS
!                NLP1=NLEVLS+1
!                NLP2=NLEVLS+2
!            3) CHANGE DIMENSION AND/OR COMMON STATEMENTS DEFINING
!              ARRAYS TRNS,DELTA,P,PD,TRNFCT,PS,PDS,PLM IN CO2INT.
!              THE NUMERICAL VALUE OF (NLEVLS+1) SHOULD BE INSERTED
!              IN DIMENSION OR COMMON STATEMENTS FOR TRNS,DELTA,
!              P,TRNFCT,PS,PLM; THE NUMERICAL VALUE OF (NLEVLS+2)
!              IN DIMENSION OR COMMON STATEMENTS FOR PD,PDS.
!      5)    PARAMETER (NLEVLS=40) AND THE OTHER PARAMETER
!       STATEMENTS ARE WRITTEN IN CDC FORTRAN; ON OTHER MACHINES THE
!       SAME STATEMENT MAY BE WRITTEN DIFFERENTLY,FOR EXAMPLE AS
!       PARAMETER   NLEVLS=40
!      6) "REAL(KIND=8)" IS USED INSTEAD OF "DOUBLE PRECISION" OR 
!           "REAL*8" FOR CODE PORTABILITY.
!       REQUIREMENTS OF CDC FORTAN.
!      7) THE STATEMENT "DO 400 KKK=1,3" CONTROLS THE NUMBER OF
!       TRANSMISSIVITY OUTPUT MATRICES PORDUCED BY THE PROGRAM.TO
!       PRODUCE 1 OUTPUT MATRIX,DELETE THIS STATEMENT.
!
!-----------------------------------------------------------------------

      Use fs_profile_mod, ONLY:  pd1013,plm1013,pd810,plm810
      Use        fms_mod, ONLY:  ERROR_MESG, FATAL, WARNING, &
                                 mpp_pe, mpp_root_pe, write_version_number


implicit none
private
      Integer,Parameter :: kind_type = selected_real_kind(15,307)

      Real, Allocatable, Dimension(:,:,:,:) :: TRNS

      Real,Private, Dimension(109)     :: PA
      Real,Private, Dimension(109,109) :: TRANSA
      Real(kind_type),Private, Dimension(109)   :: XA,CA,ETA,SEXPV
      Real(kind_type),Private                   :: CORE,UEXP,SEXP

      Real(kind_type),Private :: ZERO=0.0, ONE=1.0, TWO=2.0
!-----------------------------------------------------------------------

      Public   co2int, co2int_init, co2int_end, TRNS
      Private  RCTRNS,COEINT,QUADSR,SINTR2,Qintrp,PATH

!------------ VERSION NUMBER ----------------

 character(len=128) :: version = '$Id: co2int.F90,v 13.0 2006/03/28 21:09:25 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'
 logical            :: module_is_initialized = .false.
!-----------------------------------------------------------------------

      CONTAINS

!#######################################################################

      Subroutine co2int (nlev,ir,npurp,nkkk,unit1,unit2,ratio)

      Implicit None
!-----------------------------------------------------------------------
!
!      ------------   FUNCTION INTERPOLATER ROUTINE  ------------
!
!-----------------------------------------------------------------------
      Integer, Intent(IN) :: nlev,ir,npurp,nkkk,unit1,unit2
      Real,    Intent(IN) :: ratio
!-----------------------------------------------------------------------

      Real, Dimension(nlev+1) :: p,pd

      Real     P1,P2,TRNSLO,FACT15,FACT30,ratsm,ratstd
      Integer  i,j,kk,kkk,N,NLP1,NLP2,nmeth,ncalcs
!-----------------------------------------------------------------------

      NLP1=nlev+1
      NLP2=nlev+2

!-----------------------------------------------------------------------

!------ THE FOLLOWING ARE THE INPUT FORMATS -----

 100  FORMAT (4F20.14)

!-----------------------------------------------------------------------

!     CALCULATION OF PA -THE "TABLE" OF 109 GRID PRESSURES
!     NOTE-THIS CODE MUST NOT BE CHANGED BY THE USER!!!!!!!!!

      PA(1)=0.
      FACT15=10.**(1./15.)
      FACT30=10.**(1./30.)
      PA(2)=1.0E-3
      Do i=2,76
         PA(i+1)=PA(i)*FACT15
      EndDo
      Do i=77,108
         PA(i+1)=PA(i)*FACT30
      EndDo

      If (npurp == 1) Then
         ncalcs=4
      Else If (npurp == 2) Then
         ncalcs=2
      Else If (npurp == 3) Then
         ncalcs=2
      EndIf

!-------- allocate output transmission function arrays --------
      If (Allocated(TRNS)) DeAllocate (TRNS)
                             Allocate (TRNS(NLP1,NLP1,ncalcs,nkkk))

!=======================================================================
!***do loop on no. of temp profiles for each output calc (controlled
!   by nkkk,a function of freq. range)

      Do 410 kkk=1,nkkk
!-----------------------------------------------------------------------

!***read input lbl transmission fctn tapes (the no. depends on the
!   co2 amount and is controlled by unit1, unit2, a function of ratio)

      If (unit2 == 0) Then
         read (unit1,100) ((transa(i,j),i=1,109),j=1,109)
      Else
         If (ratio > 0.5 .and. ratio < 1.0) Then
             ratsm=0.5
             ratstd=1.0
         EndIf
         If (ratio > 1.0 .and. ratio < 2.0) Then
             ratsm=1.0
             ratstd=2.0
         EndIf
         If (ratio > 2.0 .and. ratio < 4.0) Then
             ratsm=2.0
             ratstd=4.0
         EndIf
         CALL RCTRNS (unit1,unit2,RATSTD,RATSM,RATIO,IR)
      EndIf

!***define interpolation coefficients in coeint

      Do i=1,109
         TRANSA(i,i)=1.0
      EndDo
      CALL COEINT (RATIO,IR)

!=======================================================================
!***do loop on number of output calculations (controlled by ncalcs,
!   a function of calculation purpose)

      Do 400 kk=1,ncalcs
!-----------------------------------------------------------------------

!---initialize transmission fctn array  

      Do i=1,NLP1
      Do j=1,NLP1
         TRNS(j,i,kk,kkk)=1.00
      EndDo
      EndDo

!***define pressure arrays pd,p according to the calc. no. kk and
!   npurp.define nmeth (interp method to be used)

      If (kk == 1) Then
         If (npurp == 1 .or. npurp == 3) Then
            pd=pd1013; p=plm1013
            nmeth=2 
         Else
            p=plm1013
            nmeth=1
         EndIf
      EndIf 

      If (kk == 2) Then
         If (npurp == 1) Then
            p=plm1013
            nmeth=1
         EndIf
         If (npurp == 2) Then
            p=plm810
            nmeth=1
         EndIf
         If (npurp == 3) Then
            pd=pd810; p=plm810
            nmeth=2
         EndIf
      EndIf

      If (kk == 3) Then
         pd=pd810; p=plm810
         nmeth=2
      EndIf

      If (kk == 4) Then
         p=plm810
         nmeth=1
      EndIf

      If (nmeth == 1) Then
         Do i=1,NLP1
         Do j=1,i
            IF (i == j) CYCLE
            P1=P(j)
            P2=P(i)
            CALL SINTR2 (P1,P2,TRNSLO)
            TRNS(j,i,kk,kkk)=TRNSLO
         EndDo
         EndDo
         Do i=1,NLP1
         Do j=i,NLP1
            TRNS(j,i,kk,kkk)=TRNS(i,j,kk,kkk)
         EndDo
         EndDo
      Else

!   perform method 1(point) calculations for (1,i) array elements. this
!   element will be used for cts calculations and is unneeded for other
!   aspects of radiation calcs, since we assume isothermal conditions
!   above the top pressure level.

         TRNS(1,1,kk,kkk)=1.00
         Do j=2,NLP1
            P1=0.
            P2=P(j)
            CALL SINTR2 (P1,P2,TRNSLO)
            TRNS(1,j,kk,kkk)=TRNSLO
         EndDo
         Do j=1,NLP1
         Do i=2,NLP1
            N=25
            IF (i /= j) N=3
            call quadsr (N,p(j),pd(i),pd(i-1),TRNS(i,j,kk,kkk))
         EndDo
         EndDo
      EndIf

!-----------------------------------------------------------------------
 400  Continue
 410  Continue
!=======================================================================

      End Subroutine co2int

!#######################################################################

      Subroutine co2int_init
!------- write version number and namelist ---------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
      endif

      module_is_initialized = .true.

!---------------------------------------------------------------------

      End Subroutine co2int_init

!#######################################################################

      Subroutine co2int_end

      module_is_initialized = .false.
!---------------------------------------------------------------------

      End Subroutine co2int_end

!#######################################################################

      SUBROUTINE COEINT (RAT,IR)

      Implicit None
!-----------------------------------------------------------------------
!
!
!      THE TRANSMISSION FUNCTION BETWEEN P1 AND P2 IS ASSUMED TO  HAVE
!  THE FUNCTIONAL FORM
!               TAU(P1,P2)= 1.0-SQRT(C*LOG(1.0+X*PATH)),
!         WHERE
!               PATH(P1,P2)=((P1-P2)**2)*(P1+P2+CORE)/
!                           (ETA*(P1+P2+CORE)+(P1-P2))
!
!
!  THE PARAMETERS C AND X ARE FUNCTIONS OF P2, AND ARE TO BE DETERMINED,
!  WHILE CORE IS A PRESPECIFIED NUMBER.ETA IS A FUNCTION OF THE THEIR
!  PRODUCT (CX);IT IS OBTAITED ITERATIVELY. THE DERIVATION OF ALL THESE
!  VALUES WILL BE EXPLAINED IN A FORTHCOMING PAPER.
!      SUBROUTINE COEINT DETERMINES C(I) AND X(I) BY USING THE ACTUAL
!  VALUES OF TAU(P(I-2),P(I)) AND TAU(P(I-1),P(I)) AND THE PREVIOUS
!  ITERATION VALUE OF ETA.
!       DEFINE: 
!         PATHA=PATH(P(I),P(I-2),CORE,ETA)
!          PATHB=PATH(P(I),P(I-1),CORE,ETA);
!  THEN
!          R=(1-TAU(P(I),P(I-2)))/(1-TAU(P(I),P(I-1)))
!           = SQRT(LOG(1+X*PATHA)/LOG(1+X*PATHB)),
!  SO THAT
!          R**2= LOG(1+X*PATHA)/LOG(1+X*PATHB).
!  THIS EQUATION CAN BE SOLVED BY NEWTON'S METHOD FOR X AND THEN THE
!  RESULT USED TO FIND C. THIS IS REPEATED FOR EACH VALUE OF I GREATER
!  THAN 2 TO GIVE THE ARRAYS X(I) AND C(I).
!       NEWTON'S METHOD FOR SOLVING THE EQUATION
!           F(X)=0
!  MAKES USE OF THE LOOP XNEW= XOLD-F(XOLD)/F'(XOLD).
!  THIS IS ITERATED 20 TIMES, WHICH IS PROBABLY EXCESSIVE.
!  THE FIRST GUESS FOR ETA IS 3.2E-4*EXP(-P(I)/1000),WHICH HAS
!  BEEN FOUND TO BE FAIRLY REALISTIC BY EXPERIMENT; WE ITERATE 5 TIMES
!  (AGAIN,PROBABLY EXCESSIVELY) TO OBTAIN THE VALUES FOR C,X,ETA TO BE
!  USED FOR INTERPOLATION.
!     THERE ARE SEVERAL POSSIBLE PITFALLS: 
!        1) IN THE COURSE OF ITERATION, X MAY REACH A VALUE WHICH MAKES
!           1+X*PATHA NEGATIVE; IN THIS CASE THE ITERATION IS STOPPED,
!           AND AN ERROR MESSAGE IS PRINTED OUT.
!        2) EVEN IF (1) DOES NOT OCCUR, IT IS STILL POSSIBLE THAT X MAY
!           BE NEGATIVE AND LARGE ENOUGH TO MAKE
!           1+X*PATH(P(I),0,CORE,ETA) NEGATIVE. THIS IS CHECKED
!           FOR IN A FINAL LOOP, AND IF TRUE, A WARNING IS PRINTED OUT.
!
!-----------------------------------------------------------------------
      Real,    Intent(IN)  :: RAT
      Integer, Intent(IN)  :: IR
!-----------------------------------------------------------------------

      Real  PA2

      Real(kind_type) :: padi,padim,padim2,PATHA,PATHB,P0,R,REXP,XX,  &
                      ftest1,ftest2,xxlog,F1,F2,F,FPRIME,CHECK,drat
      Real(kind_type) :: PATH0(109),ETAP(109)
      Real(kind_type) :: SINV(4)
      Real(kind_type) :: small

      Integer  i,NP,LL

      Character(len=40) :: err_string

      DATA SINV /2.74992,2.12731,4.38111,.0832926/

!-----------------------------------------------------------------------

      CORE=5.000
      UEXP=0.90
      P0=0.7
      small = epsilon(CORE)

      Do i=1,109
         PA2=PA(i)*PA(i)
         SEXPV(i)=.505+2.0e-5*PA(i)+.035*(PA2-.25)/(PA2+.25)
      EndDo

      Do i=1,109
         ETA(i)=3.2e-4*EXP(-PA(i)/500.)
         ETAP(i)=ETA(i)
      EndDo

      Do NP=1,10

         Do i=3,109
            padi=pa(i)
            padim=pa(i-1)
            padim2=pa(i-2)
            SEXP=SEXPV(i)
            R=(one-TRANSA(i,i-2))/(one-TRANSA(i,i-1))
            REXP=R**(UEXP/SEXP)
            PATHA=(PATH(padi,padim2,CORE,ETA(i)))**UEXP
            PATHB=(PATH(padi,padim,CORE,ETA(i)))**UEXP
            XX=two*(PATHB*REXP-PATHA)/(PATHB*PATHB*REXP-PATHA*PATHA)
            Do LL=1,20
               ftest1=xx*patha
               ftest2=xx*pathb
!*** end iteration and solve if ftest1 is small or ftest2 is large
               If (ftest1 <= small) Then
                  xx=one
                  xa(i)=xx
                  ca(i)=(ONE-transa(i,i-2))**(uexp/sexp)/patha
                  GoTo 1011
               EndIf
               If (ftest2 >= 1.0e8) Then
                  xxlog=(Log(patha)-rexp*Log(pathb))/(rexp-ONE)
                  xx=Log(xxlog)
                  xa(i)=xx
                  ca(i)=(ONE-transa(i,i-2))**(uexp/sexp)/(xxlog+Log(patha))
                  GoTo 1011
               EndIf
               F1=Log(ONE+XX*PATHA)
               F2=Log(ONE+XX*PATHB)
               F=F1/F2-REXP
               FPRIME=(F2*PATHA/(ONE+XX*PATHA)-F1*PATHB/(ONE+XX*PATHB))/  &
                          (F2*F2)
               XX=XX-F/FPRIME
               CHECK=ONE+XX*PATHA
               If (CHECK <= 0.0) Then
                  Write  (err_string(1:37),360) i,LL,CHECK
  360             Format ('i=',i3,'LL=',i3,'CHECK=',f20.10)
                  CALL ERROR_MESG ('COEINT in CO2INT_MOD', &
                                    err_string(1:37), FATAL)
               EndIf
            EndDo

            CA(i)=(ONE-TRANSA(i,i-2))**(UEXP/SEXP)/  &
                    (Log(ONE+XX*PATHA)+small)
            XA(i)=XX
 1011    continue
         EndDo

         XA(2)=XA(3)
         XA(1)=XA(3)
         CA(2)=CA(3)
         CA(1)=CA(3)

         Do i=3,109
            padi=pa(i)
            PATH0(i)=(PATH(padi,ZERO,CORE,ETA(i)))**UEXP
            PATH0(i)=ONE+XA(i)*PATH0(i)
            If (PATH0(i) < 0.) then
               Write  (err_string(1:37),361) i
               CALL ERROR_MESG ('COEINT in CO2INT_MOD',   &
                                 err_string(1:37), WARNING)
            Endif
!del        If (PATH0(i) < 0.) Write (*,361) i,PATH0(i),XA(i)
         EndDo

         Do i=1,109
            drat=rat
            SEXP=SEXPV(i)
            ETAP(i)=ETA(i)
            ETA(i)=(SINV(IR)/drat)**(1./SEXP)*(CA(i)*XA(i))**(1./UEXP)
         EndDo

!-----------------------------------------------------------------------
!     THE ETA FORMULATION IS DETAILED IN SCHWARZKOPF AND FELS(1985).
!        THE QUANTITY SINV=(G*DELTANU)/(RCO2*D*S)
!      IN CGS UNITS,WITH D,THE DIFFUSICITY FACTOR=2, AND
!      S,THE SUM OF CO2 LINE STRENGTHS OVER THE 15UM CO2 BAND
!       ALSO,THE DENOMINATOR IS MULTIPLIED BY
!      1000 TO PERMIT USE OF MB UNITS FOR PRESSURE.
!        S IS ACTUALLY WEIGHTED BY B(250) AT 10 CM-1 WIDE INTERVALS,IN
!      ORDER TO BE CONSISTENT WITH THE METHODS USED TO OBTAIN THE LBL
!      1-BAND CONSOLIDATED TRANCMISSION FUNCTIONS.
!      FOR THE 490-850 INTERVAL (DELTANU=360,IR=1) SINV=2.74992.
!      (SLIGHTLY DIFFERENT FROM 2.7528 USED IN EARLIER VERSIONS)
!      FOR THE 490-670 INTERVAL (IR=2) SINV=2.12731
!      FOR THE 670-850 INTERVAL (IR=3) SINV=4.38111
!      FOR THE 2270-2380 INTERVAL (IR=4) SINV=0.0832926
!      SINV HAS BEEN OBTAINED USING THE 1982 AFGL CATALOG FOR CO2
!        RAT IS THE ACTUAL CO2 MIXING RATIO IN UNITS OF 330 PPMV,
!      LETTING USE OF THIS FORMULATION FOR ANY CO2 CONCENTRATION.
!-----------------------------------------------------------------------

!        Write  (*,366) (NP,i,CA(i),XA(i),ETA(i),SEXPV(i),i=1,109)
!366     Format (2i4,4e20.12)

      EndDo

 361  Format ('1+XA*PATH(PA(i),0) IS NEGATIVE,i= ',i3)
!361  Format (' **WARNING:** 1+XA*PATH(PA(i),0) IS NEGATIVE,i= ',i3,  &
!               /,20X,'PATH0(i)=',f16.6,' XA(i)=',f16.6)
!-----------------------------------------------------------------------

      END SUBROUTINE COEINT

!#######################################################################

      SUBROUTINE RCTRNS (ITAP1,ITAP2,RATSTD,RATSM,RATIO,IR)

      Implicit None
!-----------------------------------------------------------------------
!      RATSTD=VALUE OF HIGHER STD CO2 CONCENTRATION
!      RATSM=VALUE OF LOWER STD CO2 CONCENTRATION
!      RATIO=ACTUAL CO2 CONCENTRATION
!      THE 3 ABOVE QUANTITIES ARE IN UNITS OF 330 PPMV.
!-----------------------------------------------------------------------
      Integer, Intent(IN)  :: ITAP1,ITAP2
      Real,    Intent(IN)  :: RATSTD,RATSM,RATIO
      Integer, Intent(IN)  :: IR
!-----------------------------------------------------------------------

      Real :: TRNS1(109,109),TRNS2(109,109)

      Real      P1,P2,TRNSLO,TRNSPR,TRNSPM
      Integer   i,j
!-----------------------------------------------------------------------

!   READ IN TFS OF LOWER STD CO2 CONCENTRATION

      READ   (ITAP1,100) ((TRNS1(i,j),i=1,109),j=1,109)
100   FORMAT (4F20.14)

!   READ IN TFS OF HIGHER STD CO2 CONCENTRATION

      READ (ITAP2,100) ((TRANSA(i,j),i=1,109),j=1,109)

!-----------------------------------------------------------------------

!     CALL COEINT (RATSTD)
      CALL COEINT (RATSTD,IR)

      Do i=1,109
      Do j=1,i
         If (j == i) CYCLE

!  USING HIGHER CO2 CONCENTRATION,COMPUTE 1ST GUESS CO2 TFS FOR
!  ACTUAL CO2 CONCENTRATION.

         P2=(RATIO+RATSTD)*PA(i)/(2.*RATSTD) +  &
            (RATSTD-RATIO)*PA(j)/(2.*RATSTD)
         P1=(RATSTD-RATIO)*PA(i)/(2.*RATSTD) +  &
            (RATIO+RATSTD)*PA(j)/(2.*RATSTD)
         CALL SINTR2 (P1,P2,TRNSLO)
         TRNSPR=TRNSLO

!  USING HIGHER CO2 CONCENTRATION,COMPUTE 1ST GUESS CO2 TFS FOR
!  LOWER STD CO2 CONCENTRATION

         P2=(RATSM+RATSTD)*PA(i)/(2.*RATSTD) +  &
            (RATSTD-RATSM)*PA(j)/(2.*RATSTD)
         P1=(RATSTD-RATSM)*PA(i)/(2.*RATSTD) +  &
            (RATSM+RATSTD)*PA(j)/(2.*RATSTD)
         CALL SINTR2 (P1,P2,TRNSLO)
         TRNSPM=TRNSLO

!  COMPUTE TFS FOR CO2 CONCENTRATION GIVEN BY (RATIO).
!   STORE TEMPORARILY IN (TRNS2)

         TRNS2(j,i)=TRNSPR+(RATSTD-RATIO)*(TRNS1(j,i)-  &
          TRNSPM)/(RATSTD-RATSM)
         TRNS2(i,j)=TRNS2(j,i)

! WE NOW CAN OVERWRITE (TRNS1) AND STORE IN (TRNS1) THE 1ST GUESS
!  CO2 TFS FOR LOWER STD CO2 CONCENTRATION

         TRNS1(j,i)=TRNSLO
         TRNS1(i,j)=TRNSLO

      EndDo
      EndDo

!  SET DIAGONAL VALUES OF CO2 TFS TO UNITY

      Do i=1,109
         TRNS1(i,i)=1.0
         TRNS2(i,i)=1.0
      EndDo

!  NOW OUTPUT THE COMPUTED CO2 TFS FOR (RATIO) CO2 CONC. IN (TRANSA)

      Do i=1,109
      Do j=1,109
         TRANSA(j,i)=TRNS2(j,i)
      EndDo
      EndDo

!-----------------------------------------------------------------------

      END SUBROUTINE RCTRNS

!#######################################################################

      SUBROUTINE QUADSR (N,P,PD1,PD2,TRNS)

      Implicit None
!-----------------------------------------------------------------------
      Integer, Intent(IN)  :: N
      Real,    Intent(IN)  :: P,PD1,PD2
      Real,    Intent(OUT) :: TRNS
!-----------------------------------------------------------------------
!  Note:  PD1=PD(IA), PD2=PD(IA-1), P=P(JA)

      Real     WT(101)
      Real     TRNSNB,DP,PFIX,PVARY,P1,P2,TRNSLO
      Integer  i,kk,N2,N2P

      N2=2*N
      N2P=2*N+1

!------- WEIGHTS ARE CALCULATED ------
      WT(1)=1.
      Do i=1,N
         WT(2*i)=4.
         WT(2*i+1)=1.
      EndDo

      If (N > 1) Then
         Do i=2,N
            WT(2*i-1)=2.
         EndDo
      EndIf

      TRNSNB=0.
!!!!  DP=(PD(IA)-PD(IA-1))/N2
      DP=(PD1-PD2)/N2
      PFIX=P

      Do kk=1,N2P
!!!!     PVARY=PD(IA-1)+(kk-1)*DP
         PVARY=PD2+(kk-1)*DP
         IF (PVARY >= PFIX) P2=PVARY
         IF (PVARY >= PFIX) P1=PFIX
         IF (PVARY <  PFIX) P1=PVARY
         IF (PVARY <  PFIX) P2=PFIX
         CALL SINTR2 (P1,P2,TRNSLO)
         TRNSNB=TRNSNB+TRNSLO*WT(kk)
      EndDo

!!!!  TRNS(IA,JA)=TRNSNB*DP/(3.*(PD(IA)-PD(IA-1)))
      TRNS       =TRNSNB*DP/(3.*(PD1-PD2))

!-----------------------------------------------------------------------

      END SUBROUTINE QUADSR

!#######################################################################

      SUBROUTINE SINTR2 (P1,P2,TRNSLO)

      Implicit None
!-----------------------------------------------------------------------
      Real,Intent(IN)  :: P1,P2
      Real,Intent(OUT) :: TRNSLO
!-----------------------------------------------------------------------

      Real(kind_type) :: &
      p1d,p2d,padi,padip,padj,padjp,padip2,padjp2,PETA,paieta,         &
      paiet1,ETAP,PIPMPI,UP2P1,suexp,TRIP,TRI,TIJ,TIPJ,TIJP,TIPJP,     &
      UIJ,UIPJ,UIJP,UIPJP,PRODI,PRODIP,PROD,XINT,CINT,AIJ,AIJP,AIPJ,   &
      AIPJP,EIJ,EIPJ,EIJP,EIPJP,DTDJ,DTDPJ,EPIP1,EPIPP1,EPP2P1,TIP2J,  &
      TIP2JP,TI2J2,TIJP2,TIPJP2,UIP2J,UIJP2,UIPJP2,UI2J2,UIP2JP,       &
      AIJP2,AIPJP2,AIP2J,AIP2JP,AI2J2,EIP2J,EIP2JP,EIJP2,EIPJP2,       &
      EI2J2,EI,EP,EP2,EPSIL

      Integer   i,j,k,ieta

!---find indices for pa corresponding to p1 and p2 (to use for 
!   pressure interpolation

      If (p2 <= pa(1)) Then
         i=1
      EndIf

      Do k=1,108
        If (p2 > pa(k).and.p2 <= pa(k+1)) Then
           i=k
        EndIf
      EndDo

      If (p2 > pa(109)) Then
        i=108
      EndIf

      If (p1 <= pa(1)) Then
         j=1
      EndIf

      Do k=1,108
        If (p1 > pa(k) .and. p1 <= pa(k+1)) Then
           j=k
        EndIf
      EndDo

      If (p1 > pa(109)) Then
        j=108
      EndIf

!--define real(kind_type) quantities for pressures used in calc.

      p1d=p1
      p2d=p2
      padi=pa(i)
      padip=pa(i+1)
      padj=pa(j)
      padjp=pa(j+1)
      If (i < 108) padip2=pa(i+2)
      If (j < 108) padjp2=pa(j+2)

!  DETERMINE ETAP,THE VALUE OF ETA TO USE BY LINEAR INTERPOLATION
!    FOR PETA(=0.5*(P1+P2))
      PETA=p2d 

!---if peta=p2d,ieta will equal i
      ieta=i
      paieta=pa(ieta)
      paiet1=pa(ieta+1)
      ETAP=ETA(IETA)+(p2d-paieta)*(ETA(ieta+1)-ETA(IETA))/  &
             (paiet1-paieta)
      SEXP=SEXPV(IETA)+(p2d-paieta)*(SEXPV(ieta+1)-SEXPV(IETA))/  &
             (paiet1-paieta)
      PIPMPI=padip-padi
      UP2P1=(PATH(p2d,p1d,CORE,ETAP))**UEXP
      suexp=sexp/uexp

      If (i <= j) Then
        TRIP=(CA(i+1)*Log(ONE+XA(i+1)*UP2P1))**suexp
        TRI=(CA(i)*Log(ONE+XA(i)*UP2P1))**suexp
        TRNSLO=ONE-((padip-p2d)*TRI+(p2d-padi)*TRIP)/PIPMPI
      EndIf

      If (i > j) Then
         TIJ=TRANSA(i,j)
         TIPJ=TRANSA(i+1,j)
         TIJP=TRANSA(i,j+1)
         TIPJP=TRANSA(i+1,j+1)
         UIJ=(PATH(padi,padj,CORE,ETAP))**UEXP
         UIPJ=(PATH(padip,padj,CORE,ETAP))**UEXP
         UIJP=(PATH(padi,padjp,CORE,ETAP))**UEXP
         UIPJP=(PATH(padip,padjp,CORE,ETAP))**UEXP
         PRODI=CA(i)*XA(i)
         PRODIP=CA(i+1)*XA(i+1)
         PROD=((padip-p2d)*PRODI+(p2d-padi)*PRODIP)/PIPMPI
         XINT=((padip-p2d)*XA(i)+(p2d-padi)*XA(i+1))/PIPMPI
         CINT=PROD/XINT
         AIJ=(CINT*Log(ONE+XINT*UIJ))**suexp
         AIJP=(CINT*Log(ONE+XINT*UIJP))**suexp
         AIPJ=(CINT*Log(ONE+XINT*UIPJ))**suexp
         AIPJP=(CINT*Log(ONE+XINT*UIPJP))**suexp
         EIJ=TIJ+AIJ
         EIPJ=TIPJ+AIPJ
         EIJP=TIJP+AIJP
         EIPJP=TIPJP+AIPJP
         DTDJ=(EIJP-EIJ)/(padjp-padj)
         DTDPJ=(EIPJP-EIPJ)/(padjp-padj)
         EPIP1=EIJ+DTDJ*(p1d-padj)
         EPIPP1=EIPJ+DTDPJ*(p1d-padj)
         EPP2P1=((padip-p2d)*EPIP1+(p2d-padi)*EPIPP1)/PIPMPI
         TRNSLO=EPP2P1-(CINT*Log(ONE+XINT*UP2P1))**suexp
      EndIf

      If (i < 108 .and. j < 108 .and. i > j+2) Then
         TIP2J=TRANSA(i+2,j)
         TIP2JP=TRANSA(i+2,j+1)
         TI2J2=TRANSA(i+2,j+2)
         TIJP2=TRANSA(i,j+2)
         TIPJP2=TRANSA(i+1,j+2)
         UIP2J=(PATH(padip2,padj,CORE,ETAP))**UEXP
         UIJP2=(PATH(padi,padjp2,CORE,ETAP))**UEXP
         UIPJP2=(PATH(padip,padjp2,CORE,ETAP))**UEXP
         UI2J2=(PATH(padip2,padjp2,CORE,ETAP))**UEXP
         UIP2JP=(PATH(padip2,padjp,CORE,ETAP))**UEXP
         AIJP2=(CINT*Log(ONE+XINT*UIJP2))**suexp
         AIPJP2=(CINT*Log(ONE+XINT*UIPJP2))**suexp
         AIP2J=(CINT*Log(ONE+XINT*UIP2J))**suexp
         AIP2JP=(CINT*Log(ONE+XINT*UIP2JP))**suexp
         AI2J2=(CINT*Log(ONE+XINT*UI2J2))**suexp
         EIP2J=TIP2J+AIP2J
         EIP2JP=TIP2JP+AIP2JP
         EIJP2=TIJP2+AIJP2
         EIPJP2=TIPJP2+AIPJP2
         EI2J2=TI2J2+AI2J2
         CALL QINTRP(padj,padjp,padjp2,EIJ,EIJP,EIJP2,p1d,EI)
         CALL QINTRP(padj,padjp,padjp2,EIPJ,EIPJP,EIPJP2,p1d,EP)
         CALL QINTRP(padj,padjp,padjp2,EIP2J,EIP2JP,EI2J2,p1d,EP2)
         CALL QINTRP(padi,padip,padip2,EI,EP,EP2,p2d,EPSIL)
         TRNSLO=EPSIL-(CINT*Log(ONE+XINT*UP2P1))**suexp
      EndIf

!-----------------------------------------------------------------------

      END SUBROUTINE SINTR2

!#######################################################################

      Subroutine Qintrp (XM,X0,XP,FM,F0,FP,X,F)

      Implicit None
!-----------------------------------------------------------------------
      Real(kind_type), Intent(IN)  :: XM,X0,XP,FM,F0,FP,X
      Real(kind_type), Intent(OUT) :: F
!-----------------------------------------------------------------------
      Real(kind_type) :: D1,D2,B,A,DEL

      D1=(FP-F0)/(XP-X0)
      D2=(FM-F0)/(XM-X0)
      B=(D1-D2)/(XP-XM)
      A=D1-B*(XP-X0)
      DEL=(X-X0)
      F=F0+DEL*(A+DEL*B)

!-----------------------------------------------------------------------

      End Subroutine Qintrp

!#######################################################################

      FUNCTION PATH (A,B,C,E)

      Implicit None
      Real(kind_type), Intent(IN) :: A,B,C,E

      Real(kind_type) :: PEXP
      Real(kind_type) :: PATH

      PEXP=1./SEXP
      PATH=((A-B)**PEXP*(A+B+C))/(E*(A+B+C)+(A-B)**(PEXP-1.))

      END FUNCTION PATH

!#######################################################################

      End Module co2int_mod

      subroutine age_of_air(im, jm, km, jfirst, jlast, ng, time, pfull, q)

      implicit none
      integer im
      integer jm
      integer km
      integer jfirst
      integer jlast  
      integer ng

! q is the age tracer
! Need to be converted to mixing ratio (mass of tracer / dry_air-mass)
! Ignore this inconsistency for now.

      real, intent(in):: pfull(im,jfirst:jlast,km)   ! model full level
      real, intent(in):: time        ! accumulated time since init
      real, intent(inout):: q(im,jfirst-ng:jlast+ng,km)

! Local
      integer i, j, k
      real p_source      ! source level (pa)
      real ascale
      real tiny
      parameter ( tiny = 1.e-6 )
      parameter ( p_source = 75000. )
      parameter ( ascale = 5.e-6 / 60. )

!$omp parallel do private(i, j, k)
      do k=1,km
        do j=jfirst, jlast
          do i=1,im
            if( time < tiny ) then
                q(i,j,k) = 0.
            elseif( pfull(i,j,k) >= p_source ) then
                q(i,j,k) = ascale * time
            endif
          enddo
        enddo          ! j-loop
      enddo             ! k-loop

      return
      end

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: util --- parameters and interfaces for utilities\label{sec:utils}
!
! !INTERFACE:
   MODULE util
!
! !DESCRIPTION:
! This module is an encapsulation of a number of parameters used by different
! routines found in the {\tt util} directory. It should make it easier to
! read the code, since finding a line like
!
! \vspace{7mm}
!
! {\tt if (method.eq.UPSTREAM) then ...}
!
! \vspace{7mm}
!
! in a subroutine for advection methods tells you more than reading only
!
! \vspace{7mm}
!
! {\tt if (method.eq.1) then ...}

!
! \vspace{7mm}

!
! !USES:
   IMPLICIT NONE
!
! !DEFINED PARAMETERS:

!  type of advection scheme
   integer,parameter                    :: UPSTREAM       = 1
   integer,parameter                    :: P1             = 2
   integer,parameter                    :: P2             = 3
   integer,parameter                    :: Superbee       = 4
   integer,parameter                    :: MUSCL          = 5
   integer,parameter                    :: P2_PDM         = 6

!  boundary condition type
!  for diffusion scheme
   integer,parameter                    :: Dirichlet      = 0
   integer,parameter                    :: Neumann        = 1

!  boundary condition type
!  for advection schemes
   integer,parameter                    :: flux           = 1
   integer,parameter                    :: value          = 2
   integer,parameter                    :: oneSided       = 3
   integer,parameter                    :: zeroDivergence = 4

!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: util.F90,v $
!  Revision 20.0  2013/12/14 00:14:07  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:01:18  smg
!  initial cvs ci to mom5
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:33:41  smg
!  updated to gotm-2012.03.09 CVS tagged code.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1  2005-06-27 10:54:33  kbk
!  new files needed
!
!

!EOP


   end module util

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

                 module isccp_clouds_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  ds
! </REVIEWER>
! <OVERVIEW>
!    isccp_clouds partitions the model cloud fields into the isccp
!    cloud categories, by cld top height and cld optical thickness
!    and provides netcdf output.
! </OVERVIEW>
! <DESCRIPTION>
! </DESCRIPTION>


! shared modules:

use mpp_mod,                 only: input_nml_file
use fms_mod,                 only: fms_init, open_namelist_file, &
                                   write_version_number, mpp_pe, &
                                   mpp_root_pe, stdlog, file_exist,  &
                                   check_nml_error, error_mesg,   &
                                   FATAL, close_file
use time_manager_mod,        only: time_type, time_manager_init
use diag_manager_mod,        only: register_diag_field, send_data, &
                                   diag_manager_init

!--------------------------------------------------------------------

implicit none
private

!--------------------------------------------------------------------
!    isccp_clouds partitions the model cloud fields into the isccp
!    cloud categories, by cld top height and cld optical thickness
!    and provides netcdf output.
!--------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module --------------------------

character(len=128)  :: version =  '$Id: isccp_clouds.F90,v 19.0 2012/01/06 20:16:57 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!---------------------------------------------------------------------
!-------  interfaces --------

public   isccp_clouds_init, isccp_output,               &
         isccp_cloudtypes, isccp_cloudtypes_stochastic, &
         isccp_clouds_end

private          &
!   called from isccp_clouds_init:
         diag_field_init, &
!   called from isccp_cloudtypes:
         ran0


!---------------------------------------------------------------------
!-------- namelist  ---------
!
!                         ISCCP CLOUD PROCESSING
!    
!
!       top_height
!
!                      integer variable indicating whether 
!                      or not to simulate 10.5 micron brightness
!                      temperatures to adjust top heights according
!                      to the emissivity of the cloud. 
!                     
!                      1 = adjust top height using both a computed
!                          infrared brightness temperature and the
!                          visible optical depth to adjust cloud top
!                          pressure. Note that this calculation is
!                          most appropriate to compare to ISCCP data
!                          during sunlit hours.
!       
!                      2 = do not adjust top height, that is cloud top
!                          pressure is the actual cloud top pressure
!                          in the model
!       
!                      3 = adjust top height using only the computed
!                          infrared brightness temperature. Note that
!                          this calculation is most appropriate to
!                          compare to ISCCP IR only algortihm (i.e.
!                          you can compare to nighttime ISCCP data
!                          with this option)
!                      
!       ncol           number of columns used in ISCCP cloud type
!                      simulations
!                      NOTE: This parameter is ignored when using 
!                      stochastic clouds. 
! 
!       isccp_taumin   minimum optical depth ISCCP can see
!                      [ dimensionless ]
!
!       emsfclw        assumed constant fraction of longwave emissivity
!                      of the surface [ dimensionless ]
! 
!       do_sunlit_only should ISCCP diagnostics be done during sunlit
!                      hours only? [ logical ]
!
!       overlap        variable indicating which overlap assumption to 
!                      use in ISCCP processing.
!
!                      NOTE THIS HAS NO IMPACT ON ANYTHING ELSE BUT
!                      ISCCP DIAGNOSIS FROM THIS SUBROUTINE
!
!                      NOTE: This parameter is ignored when using 
!                      stochastic clouds. 
!
!                      overlap = 1. means condensate in all levels 
!                                   is treated as part of the same cloud
!                                   i.e. maximum overlap
!
!                      overlap = 2. means condensate in adjacent levels 
!                                   is treated as different clouds
!                                   i.e. random overlap
!       
!                      overlap = 3. means condensate in adjacent levels 
!                                   is treated as part of the same cloud
!                                   i.e. maximum-random overlap
!
!      minColsInhomo   Minimum number of cloudy subcolumns required
!                      to do calculation of the inhomogeneity parameter
!                      epsilon = 1 - tau**/tau_bar
!
!                      where tau_bar = linear average of tau
!
!                            tau**  = exponential of the
!                                     linear average of logarithm of tau
!
!
!----------------------------------------------------------------------

integer  ::  ncol = 50
integer  ::  top_height = 1
real     ::  isccp_taumin = 0.3
real     ::  emsfclw = 0.94
logical  ::  do_sunlit_only = .false.
integer  ::  overlap = 2
integer  ::  minColsInhomo = 3

namelist /isccp_clouds_nml /  ncol, top_height, isccp_taumin, emsfclw,&
                              do_sunlit_only, overlap, minColsInhomo

!----------------------------------------------------------------------
!----  public data -------


!----------------------------------------------------------------------
!----  private data -------

integer, parameter :: numIsccpPressureIntervals     = 7, &
                      numIsccpOpticalDepthIntervals = 7

real, parameter     :: taumin = 1.E-06  ! minimum value allowed for 
                                        ! optical depth 
                                        ! [ dimensionless ]
real                :: qmin = 1.E-06    ! small number used in a couple
                                        ! of places in the code

!----------------------------------------------------------------------
!    diagnostics variables.     
!----------------------------------------------------------------------
character(len=5)    :: mod_name = 'isccp'
real                :: missing_value = -999.

integer :: id_deep,         id_cirrostratus,  id_cirrus,           &
           id_nimbostratus, id_altostratus,   id_altocumulus,      &
           id_stratus,      id_stratocumulus, id_cumulus,          &
           id_hithin,       id_midthin,       id_lowthin,          &
           id_high,         id_mid,           id_low,              &
           id_total,        id_allclouds,                          &          
           id_pc1tau0,id_pc1tau1,id_pc1tau2,id_pc1tau3,id_pc1tau4, &
           id_pc1tau5,id_pc1tau6, &
           id_pc2tau0,id_pc2tau1,id_pc2tau2,id_pc2tau3,id_pc2tau4, &
           id_pc2tau5,id_pc2tau6, &
           id_pc3tau0,id_pc3tau1,id_pc3tau2,id_pc3tau3,id_pc3tau4, &
           id_pc3tau5,id_pc3tau6, &
           id_pc4tau0,id_pc4tau1,id_pc4tau2,id_pc4tau3,id_pc4tau4, &
           id_pc4tau5,id_pc4tau6, &
           id_pc5tau0,id_pc5tau1,id_pc5tau2,id_pc5tau3,id_pc5tau4, &
           id_pc5tau5,id_pc5tau6, &
           id_pc6tau0,id_pc6tau1,id_pc6tau2,id_pc6tau3,id_pc6tau4, &
           id_pc6tau5,id_pc6tau6, &
           id_pc7tau0,id_pc7tau1,id_pc7tau2,id_pc7tau3,id_pc7tau4, &
           id_pc7tau5,id_pc7tau6, &
           id_nisccp, id_ninhomog, id_inhomogeneity

logical :: module_is_initialized =   .false.    ! module  initialized ?


!----------------------------------------------------------------------
!----------------------------------------------------------------------


  !
  ! Overloaded procedures
  !
  interface fluxToTb
    module procedure fluxToTb_1D, fluxToTb_2D, fluxToTb_3d
  end interface ! fluxToTb
  
  interface TbToFlux
    module procedure TbToFlux_1D, TbToFlux_2D, TbToFlux_3d
  end interface ! TbToFlux
  
  interface computeRadiance
    module procedure computeRadiance_1D, computeRadiance_2D
  end interface ! computeRadiance

                        contains 



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!#####################################################################
! <SUBROUTINE NAME="isccp_clouds_init">
!  <OVERVIEW>
!    isccp_clouds_init is the constructor for isccp_clouds_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    isccp_clouds_init is the constructor for isccp_clouds_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call isccp_clouds_init (axes, Time)
!  </TEMPLATE>
!  <IN NAME="axes" TYPE="real">
!   diagnostic variable axes for netcdf files
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!   current time [ time_type(days, seconds) ]
!  </IN>
! </SUBROUTINE>
!
subroutine isccp_clouds_init (axes, Time)

!---------------------------------------------------------------------
!    isccp_clouds_init is the constructor for isccp_clouds_mod.
!------------------------------------------------------------------

integer, dimension(4),   intent(in)              :: axes
type(time_type),         intent(in)              :: Time

!---------------------------------------------------------------------
!   intent(in) variables:
!
!       axes             diagnostic variable axes
!       Time             current time [time_type(days, seconds)]
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      integer         :: unit, io, ierr, logunit

!---------------------------------------------------------------------
!   local variables:
!
!      unit     io unit for reading nml file and writing logfile
!      io       error status returned from io operation  
!      ierr     error code
!
!--------------------------------------------------------------------

!-------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return
      
!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call time_manager_init
      call diag_manager_init

!---------------------------------------------------------------------
!    read namelist.
!---------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=isccp_clouds_nml, iostat=io)
      ierr = check_nml_error(io,'isccp_clouds_nml')
#else   
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ()
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=isccp_clouds_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'isccp_clouds_nml')
        enddo
10      call close_file (unit)
      endif
#endif
 
!---------------------------------------------------------------------
!    write namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() )    &
                       write (logunit, nml=isccp_clouds_nml)
 

!-------------------------------------------------------------------
!    initialize the netcdf diagnostics provided with this module.
!-------------------------------------------------------------------
      call diag_field_init (Time, axes)

!--------------------------------------------------------------------
!    mark the module initialized.
!--------------------------------------------------------------------
      module_is_initialized= .true.

!--------------------------------------------------------------------



end subroutine isccp_clouds_init



!######################################################################
! <SUBROUTINE NAME="isccp_output">
!  <OVERVIEW>
!    subroutine isccp_diag maps the model cloud distribution to the
!    isccp cloud categories, and provides netcdf output if desired.
!  </OVERVIEW>
!  <DESCRIPTION>
!    subroutine isccp_diag maps the model cloud distribution to the
!    isccp cloud categories, and provides netcdf output if desired.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call isccp_output (is, js, fq_isccp, npoints, 
!                      inhomogeneity_parameter, ninhomog, Time)
!  </TEMPLATE>
!  <IN NAME="is, js" TYPE="integer">
!   starting/ending subdomain i,j indices of data 
!                      in the physics_window being integrated
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!   time on next timestep, used as stamp for 
!                      diagnostic output 
!  </IN>
!  <IN NAME="fq_isccp" TYPE="real">
!   matrix of fractional area covered by cloud
!                      types of a given optical depth and cloud
!                      top pressure range.  The matrix is 7x7 for
!                      7 cloud optical depths and 7 cloud top 
!                      pressure ranges
!  </IN>
!  <IN NAME="npoints" TYPE="real">
!   flag indicating whether isccp cloud is present
!                      in column (cloud + daylight needed)
!  </IN>
!  <OUT NAME="inhomogeneity_parameter" TYPE="real">
!   Cloud inhomogeneity parameter (between 0 and 1 if valid
!   point, -1. if not computed at this point [ dimensionless ]
!  </OUT>
!  <IN NAME="ninhomog" TYPE="real">
!   flag indicating cloud inhomogeneity calculations have been
!      performed [1.=True, 0.=False]
!  </IN>
! </SUBROUTINE>
!
subroutine isccp_output (is, js, fq_isccp, npoints, &
                         inhomogeneity_parameter, ninhomog, Time)

!--------------------------------------------------------------------
!    subroutine isccp_diag maps the model cloud distribution to the
!    isccp cloud categories, and provides netcdf output if desired.
!---------------------------------------------------------------------
 
integer,                      intent(in)   :: is,js
real, dimension(:,:,:,:),     intent(in)   :: fq_isccp
real, dimension(:,:),         intent(in)   :: npoints, ninhomog, &
                                              inhomogeneity_parameter
type(time_type),              intent(in)   :: Time

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      is,js           starting/ending subdomain i,j indices of data 
!                      in the physics_window being integrated
!      fq_isccp        matrix of fractional area covered by cloud
!                      types of a given optical depth and cloud
!                      top pressure range.  The matrix is 7x7 for
!                      7 cloud optical depths and 7 cloud top 
!                      pressure ranges
!      npoints         flag indicating whether isccp cloud is present
!                      in column (cloud + daylight needed)
!      Time            time on next timestep, used as stamp for 
!                      diagnostic output [ time_type (days, seconds) ]
!
!---------------------------------------------------------------------

!local variable:
     
     real, dimension(size(npoints,1),size(npoints,2)) :: tmpmat
     
     logical :: used     !  flag returned from send_data indicating
                         !  whether diag_manager_mod has received 
                         !  data that was sent

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('isccp_clouds_mod',   &
               'module has not been initialized', FATAL )
      endif

!----------------------------------------------------------------------
!    send any desired diagnostics to the diag_manager_mod.
!----------------------------------------------------------------------

      !------------------------------------------------------------
      ! do individual types
      
      used = send_data (id_pc1tau0, fq_isccp(:,:,1,1), Time, &
                        is, js )
      used = send_data (id_pc1tau1, fq_isccp(:,:,2,1), Time, &
                        is, js )
      used = send_data (id_pc1tau2, fq_isccp(:,:,3,1), Time, &
                        is, js )
      used = send_data (id_pc1tau3, fq_isccp(:,:,4,1), Time, &
                        is, js )
      used = send_data (id_pc1tau4, fq_isccp(:,:,5,1), Time, &
                        is, js )
      used = send_data (id_pc1tau5, fq_isccp(:,:,6,1), Time, &
                        is, js )
      used = send_data (id_pc1tau6, fq_isccp(:,:,7,1), Time, &
                        is, js )
      used = send_data (id_pc2tau0, fq_isccp(:,:,1,2), Time, &
                        is, js )
      used = send_data (id_pc2tau1, fq_isccp(:,:,2,2), Time, &
                        is, js )
      used = send_data (id_pc2tau2, fq_isccp(:,:,3,2), Time, &
                        is, js )
      used = send_data (id_pc2tau3, fq_isccp(:,:,4,2), Time, &
                        is, js )
      used = send_data (id_pc2tau4, fq_isccp(:,:,5,2), Time, &
                        is, js )
      used = send_data (id_pc2tau5, fq_isccp(:,:,6,2), Time, &
                        is, js )
      used = send_data (id_pc2tau6, fq_isccp(:,:,7,2), Time, &
                        is, js )
      used = send_data (id_pc3tau0, fq_isccp(:,:,1,3), Time, &
                        is, js )
      used = send_data (id_pc3tau1, fq_isccp(:,:,2,3), Time, &
                        is, js )
      used = send_data (id_pc3tau2, fq_isccp(:,:,3,3), Time, &
                        is, js )
      used = send_data (id_pc3tau3, fq_isccp(:,:,4,3), Time, &
                        is, js )
      used = send_data (id_pc3tau4, fq_isccp(:,:,5,3), Time, &
                        is, js )
      used = send_data (id_pc3tau5, fq_isccp(:,:,6,3), Time, &
                        is, js )
      used = send_data (id_pc3tau6, fq_isccp(:,:,7,3), Time, &
                        is, js )
      used = send_data (id_pc4tau0, fq_isccp(:,:,1,4), Time, &
                        is, js )
      used = send_data (id_pc4tau1, fq_isccp(:,:,2,4), Time, &
                        is, js )
      used = send_data (id_pc4tau2, fq_isccp(:,:,3,4), Time, &
                        is, js )
      used = send_data (id_pc4tau3, fq_isccp(:,:,4,4), Time, &
                        is, js )
      used = send_data (id_pc4tau4, fq_isccp(:,:,5,4), Time, &
                        is, js )
      used = send_data (id_pc4tau5, fq_isccp(:,:,6,4), Time, &
                        is, js )
      used = send_data (id_pc4tau6, fq_isccp(:,:,7,4), Time, &
                        is, js )
      used = send_data (id_pc5tau0, fq_isccp(:,:,1,5), Time, &
                        is, js )
      used = send_data (id_pc5tau1, fq_isccp(:,:,2,5), Time, &
                        is, js )
      used = send_data (id_pc5tau2, fq_isccp(:,:,3,5), Time, &
                        is, js )
      used = send_data (id_pc5tau3, fq_isccp(:,:,4,5), Time, &
                        is, js )
      used = send_data (id_pc5tau4, fq_isccp(:,:,5,5), Time, &
                        is, js )
      used = send_data (id_pc5tau5, fq_isccp(:,:,6,5), Time, &
                        is, js )
      used = send_data (id_pc5tau6, fq_isccp(:,:,7,5), Time, &
                        is, js )
      used = send_data (id_pc6tau0, fq_isccp(:,:,1,6), Time, &
                        is, js )
      used = send_data (id_pc6tau1, fq_isccp(:,:,2,6), Time, &
                        is, js )
      used = send_data (id_pc6tau2, fq_isccp(:,:,3,6), Time, &
                        is, js )
      used = send_data (id_pc6tau3, fq_isccp(:,:,4,6), Time, &
                        is, js )
      used = send_data (id_pc6tau4, fq_isccp(:,:,5,6), Time, &
                        is, js )
      used = send_data (id_pc6tau5, fq_isccp(:,:,6,6), Time, &
                        is, js )
      used = send_data (id_pc6tau6, fq_isccp(:,:,7,6), Time, &
                        is, js )
      used = send_data (id_pc7tau0, fq_isccp(:,:,1,7), Time, &
                        is, js )
      used = send_data (id_pc7tau1, fq_isccp(:,:,2,7), Time, &
                        is, js )
      used = send_data (id_pc7tau2, fq_isccp(:,:,3,7), Time, &
                        is, js )
      used = send_data (id_pc7tau3, fq_isccp(:,:,4,7), Time, &
                        is, js )
      used = send_data (id_pc7tau4, fq_isccp(:,:,5,7), Time, &
                        is, js )
      used = send_data (id_pc7tau5, fq_isccp(:,:,6,7), Time, &
                        is, js )
      used = send_data (id_pc7tau6, fq_isccp(:,:,7,7), Time, &
                        is, js )
      used = send_data (id_nisccp, npoints, Time, is, js )

      used = send_data (id_ninhomog, ninhomog, Time, is, js )
     
      used = send_data (id_inhomogeneity, inhomogeneity_parameter, &
                        Time, is, js )

      !------------------------------------------------------------
      ! do summed fields

      !do hithin
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,1:1,1:3), dim = 4), dim = 3)
      used = send_data (id_hithin, tmpmat(:,:), Time, is, js )
      !do cirrus
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,2:3,1:3), dim = 4), dim = 3)
      used = send_data (id_cirrus, tmpmat(:,:), Time, is, js )
      
      !do cirrostratus
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,4:5,1:3), dim = 4), dim = 3)
      used = send_data (id_cirrostratus, tmpmat(:,:), Time, is, js )
      
      !do deep
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,6:7,1:3), dim = 4), dim = 3)
      used = send_data (id_deep, tmpmat(:,:), Time, is, js )
      
      !do high
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,2:7,1:3), dim = 4), dim = 3)
      used = send_data (id_high, tmpmat(:,:), Time, is, js )
      
      !do midthin
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,1:1,4:5), dim = 4), dim = 3)
      used = send_data (id_midthin, tmpmat(:,:), Time, is, js )
      
      !do altocumulus
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,2:3,4:5), dim = 4), dim = 3)
      used = send_data (id_altocumulus, tmpmat(:,:), Time, is, js )
      
      !do altostratus
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,4:5,4:5), dim = 4), dim = 3)
      used = send_data (id_altostratus, tmpmat(:,:), Time, is, js )
      
      !do nimbostratus
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,6:7,4:5), dim = 4), dim = 3)
      used = send_data (id_nimbostratus, tmpmat(:,:), Time, is, js )
      
      !do mid
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,2:7,4:5), dim = 4), dim = 3)
      used = send_data (id_mid, tmpmat(:,:), Time, is, js )
      
      !do lowthin
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,1:1,6:7), dim = 4), dim = 3)
      used = send_data (id_lowthin, tmpmat(:,:), Time, is, js )
      
      !do cumulus
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,2:3,6:7), dim = 4), dim = 3)
      used = send_data (id_cumulus, tmpmat(:,:), Time, is, js )
      
      !do stratocumulus
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,4:5,6:7), dim = 4), dim = 3)
      used = send_data (id_stratocumulus, tmpmat(:,:), Time, is, js )
      
      !do stratus
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,6:7,6:7), dim = 4), dim = 3)
      used = send_data (id_stratus, tmpmat(:,:), Time, is, js )
      
      !do low
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,2:7,6:7), dim = 4), dim = 3)
      used = send_data (id_low, tmpmat(:,:), Time, is, js )
            
      !do total
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,2:7,1:7), dim = 4), dim = 3)
      used = send_data (id_total, tmpmat(:,:), Time, is, js )
             
      !do all clouds
      tmpmat(:,:) = sum(sum(fq_isccp(:,:,1:7,1:7), dim = 4), dim = 3)
      used = send_data (id_allclouds, tmpmat(:,:), Time, is, js )
       
!--------------------------------------------------------------------
         

end subroutine isccp_output


!######################################################################
! <SUBROUTINE NAME="isccp_cloudtypes">
!  <OVERVIEW>
!    isccp_cloudtypes calculates the fraction of each model grid box 
!    covered by each of the 49 ISCCP D level cloud types 
!    (i.e. stratified by optical depth and cloud top pressure) by 
!    accounting for model overlap. 
!  </OVERVIEW>
!  <DESCRIPTION>
!    isccp_cloudtypes calculates the fraction of each model grid box 
!    covered by each of the 49 ISCCP D level cloud types 
!    (i.e. stratified by optical depth and cloud top pressure) by 
!    accounting for model overlap. For further explanation see Klein 
!    and Jakob, Monthly Weather Review, (2000), vol x, pp. .
!  </DESCRIPTION>
!  <TEMPLATE>
!   call isccp_cloudtypes (sunlit, pfull, phalf, qv, at, skt, cc, &
!                          dtau_s, dem_s, fq_isccp, nisccp,&
!                          inhomogeneity_parameter, ninhomog)
!  </TEMPLATE>
!  <IN NAME="sunlit" TYPE="integer">
!   integer flag indicating whether or not a given point is sunlit
!                        [1 = True, 0 = False ]
!  </IN>
!  <IN NAME="pfull" TYPE="real">
!   pressure of full model levels, pfull(1) is top
!                        level of model, pfull(nlev) is bottom level of
!                        model
!  </IN>
!  <IN NAME="phalf" TYPE="real">
!   pressure of half model levels, phalf(1) is top
!                        of model, phalf(nlev+1) is the surface pressure
!  </IN>
!  <IN NAME="qv" TYPE="real">
!   water vapor specific humidity on model levels.
!                        used only if top_height = 1 or top_height = 3.
!  </IN>
!  <IN NAME="at" TYPE="real">
!   temperature in each model level [ deg K ]
!                        used only if top_height = 1 or top_height = 3.
!  </IN>
!  <IN NAME="skt" TYPE="real">
!   skin temperature [ deg K ]
!                        used only if top_height = 1 or top_height = 3.
!  </IN>
!  <INOUT NAME="cc" TYPE="real">
!   cloud cover in each model layer [ fraction ]
!                        this includes convective clouds if any
!                        NOTE:  This is the HORIZONTAL area of each
!                               grid box covered by clouds
!  </INOUT>
!  <INOUT NAME="dtau_s" TYPE="real">
!   mean 0.67 micron optical depth of stratiform
!                        clouds in each model level [ dimensionless ]
!                        NOTE:  this the cloud optical depth of only the
!                               cloudy part of the grid box, it is not 
!                               weighted with the 0 cloud optical depth 
!                               of the clear part of the grid box
!  </INOUT>
!  <INOUT NAME="dem_s" TYPE="real">
!   10.5 micron longwave emissivity of stratiform
!                        clouds in each model level. 
!                        used only if top_height = 1 or top_height = 3.
!                        Same note applies as in dtau. [ dimensionless ]
!  </INOUT>
!  <OUT NAME="fq_isccp" TYPE="real">
!   matrix of fractional area covered by cloud
!                       types of a given optical depth and cloud
!                       top pressure range.  The matrix is 7x7 for
!                       7 cloud optical depths and 7 cloud top 
!                       pressure ranges. [ fraction ]
!  </OUT>
!  <OUT NAME="nisccp" TYPE="real">
!   real flag indicating whether or not isccp_cloudtypes produced
!                       valid output [ 1.=True, 0.=False ]
!  </OUT>
!  <OUT NAME="inhomogeneity_parameter" TYPE="real">
!   Cloud inhomogeneity parameter (between 0 and 1 if valid
!   point, -1. if not computed at this point [ dimensionless ]
!  </OUT>
!  <IN NAME="ninhomog" TYPE="real">
!   flag indicating cloud inhomogeneity calculations have been
!      performed [1.=True, 0.=False]
!  </IN>
! </SUBROUTINE>
!
subroutine isccp_cloudtypes (sunlit, pfull, phalf, qv, at, skt, cc, &
                             dtau_s, dem_s, fq_isccp, nisccp, &
                             inhomogeneity_parameter, ninhomog)

!---------------------------------------------------------------------
!    isccp_cloudtypes calculates the fraction of each model grid box 
!    covered by each of the 49 ISCCP D level cloud types 
!    (i.e. stratified by optical depth and cloud top pressure) by 
!    accounting for model overlap. For further explanation see Klein 
!    and Jakob, Monthly Weather Review, (2000), vol x, pp. .
!
!---------------------------------------------------------------------

integer, dimension(:,:),  intent(in)      :: sunlit
real,  dimension(:,:,:),  intent(in)      :: pfull, phalf, qv, at
real,    dimension(:,:),  intent(in)      :: skt
real,  dimension(:,:,:),  intent(in)      :: cc, dtau_s, dem_s
real,dimension(:,:,:,:),  intent(out)     :: fq_isccp
!  Last two dimensions should be numIsccpOpticalDepthIntervals, numIsccpPressureIntervals (7, 7)
real,    dimension(:,:),  intent(out)     :: nisccp
real,  dimension(:,:),    intent(out)     :: inhomogeneity_parameter, &
                                             ninhomog

!--------------------------------------------------------------------
!   intent(in) variables:
!
!       sunlit           integer indicating whether or not a given
!                        point is sunlit
!       pfull            pressure of full model levels, pfull(1) is top
!                        level of model, pfull(nlev) is bottom level of
!                        model [ Pa ]
!       phalf            pressure of half model levels, phalf(1) is top
!                        of model, phalf(nlev+1) is the surface pressure
!                        [ Pa ]
!       qv               water vapor specific humidity on model levels.
!                        used only if top_height = 1 or top_height = 3.
!                        [ kg vapor / kg air ]
!       at               temperature in each model level [ deg K ]
!                        used only if top_height = 1 or top_height = 3.
!       skt              skin temperature [ deg K ]
!                        used only if top_height = 1 or top_height = 3.
!
!   intent(inout) variables:
!
!       cc               cloud cover in each model layer [ fraction ]
!                        this includes convective clouds if any
!                        NOTE:  This is the HORIZONTAL area of each
!                               grid box covered by clouds
!       dtau_s           mean 0.67 micron optical depth of stratiform
!                        clouds in each model level [ dimensionless ]
!                        NOTE:  this the cloud optical depth of only the
!                               cloudy part of the grid box, it is not 
!                               weighted with the 0 cloud optical depth 
!                               of the clear part of the grid box
!       dem_s            10.5 micron longwave emissivity of stratiform
!                        clouds in each model level. 
!                        used only if top_height = 1 or top_height = 3.
!                        Same note applies as in dtau. [ dimensionless ]
!
!       NOTE :  OPTION TO RUN WITH CONVECTIVE CLOUDS IS NOT
!               IMPLEMENTED YET
!
!       conv             convective cloud cover in each model 
!                        level (fraction) this includes convective 
!                        clouds if any
!  
!                        NOTE:  This is the HORIZONTAL area of each
!                               grid box covered by clouds
!                         
!       dtau_c           mean 0.67 micron optical depth of convective
!                        clouds in each model level
!
!                        NOTE:  this the cloud optical depth of only the
!                               cloudy part of the grid box, it is not 
!                               weighted with the 0 cloud optical depth 
!                               of the clear part of the grid box
!
!   intent(out) variable:
!
!       fq_isccp        matrix of fractional area covered by cloud
!                       types of a given optical depth and cloud
!                       top pressure range.  The matrix is 7x7 for
!                       7 cloud optical depths and 7 cloud top 
!                       pressure ranges. [ fraction ]
!
!       nisccp          integer indicating whether or not isccp diagnostics
!                       were calculated for this point
!
!       inhomogeneity_parameter
!
!                         = 1 - tau**/tau_bar
!
!                      where tau_bar = linear average of tau
!
!                            tau**  = exponential of the
!                                     linear average of logarithm of tau
!
!       ninhomog       flag indicating that the inhomogeneity 
!                      parameter was calculated
!
!---------------------------------------------------------------------
! Local variables
!   The ISCCP simulator code is vectorized over one set of input GCM grid cells
!   The input variables here are over an x-y window, so we'll loop 
!   over y. 
    integer :: nPoints, nYPoints, nLev, i, j
    real,    dimension(size(pFull, 1), nCol, size(pFull, 3)) :: frac_out, dtau, dem
    real,    dimension(size(pFull, 1),       size(pFull, 3)) :: conv, strat
    real,    dimension(size(pFull, 1),       size(pFull, 3)) :: dem_wv
    integer, dimension(size(pFull, 1))                       :: seed
    real,    dimension(size(pFull, 1), nCol)                 :: boxPtop, boxTau
    
!---------------------------------------------------------------------
    nPoints  = size(pFull, 1)
    nYPoints = size(pFull, 2) 
    nLev     = size(pFull, 3)
    
    if(.not. module_is_initialized) &
      call error_mesg("isccp_clouds_mod", "module has not been initialized", FATAL)
    
    !
    ! Don't compute statistics if do_sunlit_only flag is set and this point is in darkness
    !   (sunlit = 0).  
    !
    do j = 1, nYPoints
      if(do_sunlit_only .and. .not. any(sunlit(:, j) == 1)) then
        fq_isccp(:, j, :, :) = 0.
        nisccp(:, j) = 0
        inhomogeneity_parameter(:,j) = 0.
        ninhomog(:,j) = 0.
      else
        strat(:, :) = cc(:, j, :)
        conv (:, :) = 0.
        ! Make sure all the values are resonable
        where (strat(:, :) < 0.) strat(:, :) = 0
        where (strat(:, :) > 1.) strat(:, :) = 1.
        !
        ! Generate sub-cloud structures
        !
        seed(:) = (pfull(:, j, nlev) - int(pfull(:, j, nlev))) * 100 + 1
        call isccp_clouds_scops(strat, conv, seed, frac_out)
        
        !
        ! Take scops predictions of cloud fraction and fill in emmissivity and optical 
        !   depth arrays
        !
        where(nint(frac_out(:, :, :)) == 0)
          dem (:, :, :) = 0. 
          dtau(:, :, :) = 0. 
        elsewhere(nint(frac_out(:, :, :)) == 1)
          dem (:, :, :) = spread(dem_s (:, j, :), dim = 2, nCopies = nCol)
          dtau(:, :, :) = spread(dtau_s(:, j, :), dim = 2, nCopies = nCol) 
        end where 
        ! Make sure all the values are resonable
        where (dtau(:, :, :) < 0.) dtau(:, :, :) = 0
        where (dem (:, :, :) < 0.) dem (:, :, :) = 0
        where (dem (:, :, :) > 1.) dem (:, :, :) = 1.
        
        if(top_height == 1 .or. top_height == 3) then 
          ! 
          ! We're looking for adjusted cloud tops. Compute water vapor emissivity
          !
          call computeWaterVaporEmissivity(pfull(:, j, :), phalf(:, j, :), &
                                           qv(:, j, :),    at(:, j, :), dem_wv)
          
          ! Call Icarus...
          call isccp_clouds_icarus(dtau, pFull(:, j, :),                  & 
                      dem, dem_wv,  at(:, j, :),  skt(:, j), &
                       (/ (emsfclw, j = 1, nPoints) /),      &
                      boxtau = boxtau, boxptop = boxptop)
        else 
          ! We're asking for the real cloud tops. 
          !   We don't correct very optically thin clouds either. 
          call isccp_clouds_icarus(dtau, pFull(:, j, :),                  & 
                      boxtau = boxtau, boxptop = boxptop)
        end if 
        
        ! Compute histograms
        fq_isccp(:, j, :, :) = computeIsccpJointHistograms(boxtau, boxptop, sunlit(:, j))
        nisccp(:, j) = 1

        ! Compute inhomogeneity parameter
        inhomogeneity_parameter(:,j) = computeInhomogeneityParameter(boxtau,boxptop,sunlit(:,j))

        where(inhomogeneity_parameter(:,j)<-0.5)
              inhomogeneity_parameter(:,j) = 0.
              ninhomog(:,j) = 0.
        elsewhere
              ninhomog(:,j) = 1.
        endwhere   
        
        ! Zero out frequency histograms if the point is dark and we want statistics
        !    only for sunlit points. 
        if(do_sunlit_only) then
          where(sunlit(:, j) == 0) 
            nisccp(:, j) = 0
            inhomogeneity_parameter(:,j) = 0.
            ninhomog(:,j) = 0.
          endwhere
          do i = 1, nPoints
            if(sunlit(i, j) == 0) fq_isccp(i, j, :, :) = 0. 
          end do 
        end if 
        
      end if
    end do

end subroutine isccp_cloudtypes

!######################################################################
! <SUBROUTINE NAME="isccp_cloudtypes_stochastic">
!  <OVERVIEW>
!    isccp_cloudtypes calculates the fraction of each model grid box 
!    covered by each of the 49 ISCCP D level cloud types 
!    (i.e. stratified by optical depth and cloud top pressure). 
!    This version uses the columns generated for the McICA treatment
!    of radiation.  
!  </OVERVIEW>
!  <DESCRIPTION>
!    isccp_cloudtypes calculates the fraction of each model grid box 
!    covered by each of the 49 ISCCP D level cloud types 
!    (i.e. stratified by optical depth and cloud top pressure). 
!    For further explanation see Klein 
!    and Jakob, Monthly Weather Review, (2000), vol x, pp. .
!    This version uses the columns generated for the McICA treatment
!    of radiation; overlap is imposed in the "cloud generator" that 
!    takes the place of SCOPS, and internal inhomogeneity can be 
!    added too.  
!
!  </DESCRIPTION>
!  <TEMPLATE>
!   call isccp_cloudtypes (sunlit, pfull, phalf, qv, at, skt, cc, &
!                          dtau_s, dem_s, fq_isccp, nisccp,&
!                          inhomogeneity_parameter, ninhomog)
!  </TEMPLATE>
!  <IN NAME="sunlit" TYPE="integer">
!   integer flag indicating whether or not a given point is sunlit
!                        [1 = True, 0 = False ]
!  </IN>
!  <IN NAME="pfull" TYPE="real">
!   pressure of full model levels, pfull(1) is top
!                        level of model, pfull(nlev) is bottom level of
!                        model
!  </IN>
!  <IN NAME="phalf" TYPE="real">
!   pressure of half model levels, phalf(1) is top
!                        of model, phalf(nlev+1) is the surface pressure
!  </IN>
!  <IN NAME="qv" TYPE="real">
!   water vapor specific humidity on model levels.
!                        used only if top_height = 1 or top_height = 3.
!  </IN>
!  <IN NAME="at" TYPE="real">
!   temperature in each model level [ deg K ]
!                        used only if top_height = 1 or top_height = 3.
!  </IN>
!  <IN NAME="skt" TYPE="real">
!   skin temperature [ deg K ]
!                        used only if top_height = 1 or top_height = 3.
!  </IN>
!  <INOUT NAME="cc" TYPE="real">
!   cloud cover in each model layer [ fraction ]
!                        this includes convective clouds if any
!                        NOTE:  This is the HORIZONTAL area of each
!                               grid box covered by clouds
!  </INOUT>
!  <INOUT NAME="dtau_s" TYPE="real">
!   mean 0.67 micron optical depth of stratiform
!                        clouds in each model level [ dimensionless ]
!                        NOTE:  this the cloud optical depth of only the
!                               cloudy part of the grid box, it is not 
!                               weighted with the 0 cloud optical depth 
!                               of the clear part of the grid box
!  </INOUT>
!  <INOUT NAME="dem_s" TYPE="real">
!   10.5 micron longwave emissivity of stratiform
!                        clouds in each model level. 
!                        used only if top_height = 1 or top_height = 3.
!                        Same note applies as in dtau. [ dimensionless ]
!  </INOUT>
!  <OUT NAME="fq_isccp" TYPE="real">
!   matrix of fractional area covered by cloud
!                       types of a given optical depth and cloud
!                       top pressure range.  The matrix is 7x7 for
!                       7 cloud optical depths and 7 cloud top 
!                       pressure ranges. [ fraction ]
!  </OUT>
!  <OUT NAME="nisccp" TYPE="real">
!   real flag indicating whether or not isccp_cloudtypes produced
!                       valid output [ 1.=True, 0.=False ]
!  </OUT>
!  <OUT NAME="inhomogeneity_parameter" TYPE="real">
!   Cloud inhomogeneity parameter (between 0 and 1 if valid
!   point, -1. if not computed at this point [ dimensionless ]
!  </OUT>
!  <IN NAME="ninhomog" TYPE="real">
!   flag indicating cloud inhomogeneity calculations have been
!      performed [1.=True, 0.=False]
!  </IN>
! </SUBROUTINE>
!
subroutine isccp_cloudtypes_stochastic (sunlit, pfull, phalf, qv, at, skt, cc, &
                                        dtau_s, dem_s, fq_isccp, nisccp, &
                                        inhomogeneity_parameter, ninhomog)

!---------------------------------------------------------------------
!    isccp_cloudtypes calculates the fraction of each model grid box 
!    covered by each of the 49 ISCCP D level cloud types 
!    (i.e. stratified by optical depth and cloud top pressure).
!    For further explanation see Klein 
!    and Jakob, Monthly Weather Review, (2000), vol x, pp. .
!    This version uses the columns generated for the McICA treatment
!    of radiation; overlap is imposed in the "cloud generator" that 
!    takes the place of SCOPS, and internal inhomogeneity can be 
!    added too.  
!
!---------------------------------------------------------------------

integer, dimension(:,:),     intent(in)  :: sunlit
real,    dimension(:,:,:),   intent(in)  :: pfull, phalf, qv, at
real,    dimension(:,:),     intent(in)  :: skt
real,    dimension(:,:,:,:), intent(in)  :: cc, dtau_s, dem_s
real,    dimension(:,:,:,:), intent(out) :: fq_isccp
!  Last two dimensions should be numIsccpOpticalDepthIntervals, numIsccpPressureIntervals (7, 7)
real,    dimension(:,:),     intent(out) :: nisccp
real,  dimension(:,:),    intent(out)    :: inhomogeneity_parameter, &
                                            ninhomog      

!--------------------------------------------------------------------
!   intent(in) variables:
!
!       sunlit           integer indicating whether or not a given
!                        point is sunlit
!       pfull            pressure of full model levels, pfull(1) is top
!                        level of model, pfull(nlev) is bottom level of
!                        model [ Pa ]
!       phalf            pressure of half model levels, phalf(1) is top
!                        of model, phalf(nlev+1) is the surface pressure
!                        [ Pa ]
!       qv               water vapor specific humidity on model levels.
!                        used only if top_height = 1 or top_height = 3.
!                        [ kg vapor / kg air ]
!       at               temperature in each model level [ deg K ]
!                        used only if top_height = 1 or top_height = 3.
!       skt              skin temperature [ deg K ]
!                        used only if top_height = 1 or top_height = 3.
!
!   intent(inout) variables:
!
!       cc               cloud cover in each model layer [ fraction ]
!                        this includes convective clouds if any
!                        NOTE:  This is the HORIZONTAL area of each
!                               grid box covered by clouds
!       dtau_s           mean 0.67 micron optical depth of stratiform
!                        clouds in each model level [ dimensionless ]
!                        NOTE:  this the cloud optical depth of only the
!                               cloudy part of the grid box, it is not 
!                               weighted with the 0 cloud optical depth 
!                               of the clear part of the grid box
!       dem_s            10.5 micron longwave emissivity of stratiform
!                        clouds in each model level. 
!                        used only if top_height = 1 or top_height = 3.
!                        Same note applies as in dtau. [ dimensionless ]
!
!
!   intent(out) variable:
!
!       fq_isccp        matrix of fractional area covered by cloud
!                       types of a given optical depth and cloud
!                       top pressure range.  The matrix is 7x7 for
!                       7 cloud optical depths and 7 cloud top 
!                       pressure ranges. [ fraction ]
!
!       nisccp          integer indicating whether or not isccp diagnostics
!                       were calculated for this point
!
!       inhomogeneity_parameter
!
!                         = 1 - tau**/tau_bar
!
!                      where tau_bar = linear average of tau
!
!                            tau**  = exponential of the
!                                     linear average of logarithm of tau
!
!
!       ninhomog       flag indicating that the inhomogeneity 
!                      parameter was calculated
!
!
!---------------------------------------------------------------------
! Local variables
!   The ISCCP simulator code is vectorized over one set of input GCM grid cells
!   The input variables here are over an x-y window, so we'll loop 
!   over y. 
    integer :: nPoints, nYPoints, nLev, nColumns, i, j, col
    real,    dimension(size(cc, 1), size(cc, 4), size(cc, 3)) :: dtau, dem
    real,    dimension(size(cc, 1), size(cc, 3))              :: dem_wv
    real,    dimension(size(cc, 1), size(cc, 4))              :: boxPtop, boxTau
    
!---------------------------------------------------------------------
    nPoints  = size(cc, 1)
    nYPoints = size(cc, 2) 
    nLev     = size(cc, 3)
    nColumns = size(cc, 4)
    
    if(.not. module_is_initialized) &
      call error_mesg("isccp_clouds_mod", "module has not been initialized", FATAL)
    
    !
    ! Don't compute statistics if do_sunlit_only flag is set and this point is in darkness
    !   (sunlit = 0).  
    !
    do j = 1, nYPoints
      if(do_sunlit_only .and. .not. any(sunlit(:, j) == 1)) then
        fq_isccp(:, j, :, :) = 0.
        nisccp(:, j) = 0
        inhomogeneity_parameter(:,j) = 0.
        ninhomog(:,j) = 0.
      else
        !
        ! Reorder optical depth and emissivity arrays for this set 
        !   of Y points. In calling routines the order is x, y, lev, col; 
        !   icarus expects x, col, lev.  
        !
        do col = 1, nColumns
          dtau(:, col, :) = dtau_s(:, j, :, col)
          dem (:, col, :) = dem_s (:, j, :, col)
        end do
        !
        ! Make sure all the values are resonable
        !
        where (dtau(:, :, :) < 0.) dtau(:, :, :) = 0
        where (dem (:, :, :) < 0.) dem (:, :, :) = 0
        where (dem (:, :, :) > 1.) dem (:, :, :) = 1.
        
        if(top_height == 1 .or. top_height == 3) then 
          ! 
          ! We're looking for adjusted cloud tops. Compute water vapor emissivity
          !
          call computeWaterVaporEmissivity(pfull(:, j, :), phalf(:, j, :), &
                                           qv(:, j, :),    at(:, j, :), dem_wv)
          
          ! Call Icarus...
          call isccp_clouds_icarus(dtau, pFull(:, j, :),                  & 
                      dem, dem_wv,  at(:, j, :),  skt(:, j), &
                       (/ (emsfclw, j = 1, nPoints) /),       &
                      boxtau = boxtau, boxptop = boxptop)
        else 
          ! We're asking for the real cloud tops. 
          !   We don't correct very optically thin clouds either. 
          call isccp_clouds_icarus(dtau, pFull(:, j, :),                 & 
                      boxtau = boxtau, boxptop = boxptop)
        end if 
        
        ! Compute histograms
        fq_isccp(:, j, :, :) = computeIsccpJointHistograms(boxtau, boxptop, sunlit(:, j))
        nisccp(:, j) = 1

        ! Compute inhomogeneity parameter
        inhomogeneity_parameter(:,j) = computeInhomogeneityParameter(boxtau,boxptop,sunlit(:,j))

        where(inhomogeneity_parameter(:,j)<-0.5)
              inhomogeneity_parameter(:,j) = 0.
              ninhomog(:,j) = 0.
        elsewhere
              ninhomog(:,j) = 1.
        endwhere   
        
        ! Zero out frequency histograms if the point is dark and we want statistics
        !    only for sunlit points. 
        if(do_sunlit_only) then
          where(sunlit(:, j) == 0) 
            nisccp(:, j) = 0
            inhomogeneity_parameter(:,j) = 0.
            ninhomog(:,j) = 0.
          endwhere
          do i = 1, nPoints
            if(sunlit(i, j) == 0) fq_isccp(i, j, :, :) = 0. 
          end do 
        end if 
        
      end if
    end do

end subroutine isccp_cloudtypes_stochastic
!###################################################################

! <SUBROUTINE NAME="isccp_clouds_end">
!  <OVERVIEW>
!    isccp_clouds_end is the destructor for isccp_clouds_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    isccp_clouds_end is the destructor for isccp_clouds_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call isccp_clouds_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine isccp_clouds_end

!-------------------------------------------------------------------
!    isccp_clouds_end is the destructor for isccp_clouds_mod.
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('isccp_clouds_mod',   &
              'module has not been initialized', FATAL )
      endif

!--------------------------------------------------------------------
!    mark the module as not initialized.
!--------------------------------------------------------------------
      module_is_initialized = .false.

!--------------------------------------------------------------------



end subroutine isccp_clouds_end


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                    PRIVATE SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!####################################################################
! <SUBROUTINE NAME="diag_field_init">
!  <OVERVIEW>
!    diag_field_init registers the potential netcdf output variables
!    with diag_manager_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!    diag_field_init registers the potential netcdf output variables
!    with diag_manager_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call diag_field_init (Time, axes )
!  </TEMPLATE>
!  <IN NAME="axes" TYPE="real">
!   diagnostic variable axes for netcdf files
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!   initialization time for the netcdf output fields
!  </IN>
! </SUBROUTINE>
subroutine diag_field_init (Time, axes )

!---------------------------------------------------------------------
!    diag_field_init registers the potential netcdf output variables
!    with diag_manager_mod.
!---------------------------------------------------------------------

type(time_type), intent(in) :: Time
integer        , intent(in) :: axes(4)

!---------------------------------------------------------------------
!   intent(in) variables:
!
!       Time      initialization time for the netcdf output fields
!       axes      diagnostic variable axes
!
!---------------------------------------------------------------------


!-----------------------------------------------------------------------
!    register the isccp diagnostic fields with diag_manager_mod.
!-----------------------------------------------------------------------
       
       id_allclouds     = register_diag_field ( mod_name, &
                        'all_clouds_is', axes(1:2), Time, &
       'Cloud fraction as ISCCP would see it', 'fraction' )       
       id_total         = register_diag_field ( mod_name, &
                       'tot_cld_amt_is', axes(1:2), Time, &
       'Cloud fraction as ISCCP would see it', 'fraction' )       
       id_high          = register_diag_field ( mod_name, &
                      'high_cld_amt_is', axes(1:2), Time, &
               '    pc<440                  ', 'fraction' )       
       id_mid           = register_diag_field ( mod_name, &
                       'mid_cld_amt_is', axes(1:2), Time, &
               '440<pc<680                  ', 'fraction' )
       id_low           = register_diag_field ( mod_name, &
                       'low_cld_amt_is', axes(1:2), Time, &
               '680<pc                      ', 'fraction' )       
       id_deep          = register_diag_field ( mod_name, &
                                 'deep', axes(1:2), Time, &
               '    pc<440;    23<tau       ', 'fraction' )       
       id_cirrostratus  = register_diag_field ( mod_name, &
                                   'cs', axes(1:2), Time, &
               '    pc<440;   3.6<tau<23    ', 'fraction' )
       id_cirrus        = register_diag_field ( mod_name, &
                                   'ci', axes(1:2), Time, &
               '    pc<440;taumin<tau<3.6   ', 'fraction' )
       id_hithin        = register_diag_field ( mod_name, &
                               'hithin', axes(1:2), Time, &
               '    pc<440;     0<tau<taumin', 'fraction' )
       id_nimbostratus  = register_diag_field ( mod_name, &
                                   'ns', axes(1:2), Time, &
               '440<pc<680;    23<tau       ', 'fraction' )
       id_altostratus   = register_diag_field ( mod_name, &
                                   'as', axes(1:2), Time, &
               '440<pc<680;   3.6<tau<23    ', 'fraction' )
       id_altocumulus   = register_diag_field ( mod_name, &
                                   'ac', axes(1:2), Time, &
               '440<pc<680;taumin<tau<3.6   ', 'fraction' )
       id_midthin       = register_diag_field ( mod_name, &
                              'midthin', axes(1:2), Time, &
               '440<pc<680;     0<tau<taumin', 'fraction' )
       id_stratus       = register_diag_field ( mod_name, &
                                   'st', axes(1:2), Time, &
               '680<pc    ;    23<tau       ', 'fraction' )
       id_stratocumulus = register_diag_field ( mod_name, &
                                   'sc', axes(1:2), Time, &
               '680<pc    ;   3.6<tau<23    ', 'fraction' )
       id_cumulus       = register_diag_field ( mod_name, &
                                   'cu', axes(1:2), Time, &
               '680<pc    ;taumin<tau<3.6   ', 'fraction' )
       id_lowthin       = register_diag_field ( mod_name, &
                              'lowthin', axes(1:2), Time, &
               '680<pc    ;     0<tau<taumin', 'fraction' )
       
        id_pc1tau0 = register_diag_field ( mod_name, &
                             'pc1tau0', axes(1:2), Time, &
                      '    pc<180;     0<tau<taumin', 'fraction' )
        id_pc1tau1 = register_diag_field ( mod_name, &
                             'pc1tau1', axes(1:2), Time, &
                      '    pc<180;taumin<tau<1.3   ', 'fraction' )
        id_pc1tau2 = register_diag_field ( mod_name, &
                             'pc1tau2', axes(1:2), Time, &
                      '    pc<180;   1.3<tau<3.6   ', 'fraction' )
        id_pc1tau3 = register_diag_field ( mod_name, &
                             'pc1tau3', axes(1:2), Time, &
                     '    pc<180;   3.6<tau<9.4   ', 'fraction' )
        id_pc1tau4 = register_diag_field ( mod_name, &
                             'pc1tau4', axes(1:2), Time, &
                      '    pc<180;   9.4<tau<23    ', 'fraction' )
        id_pc1tau5 = register_diag_field ( mod_name, &
                             'pc1tau5', axes(1:2), Time, &
                      '    pc<180;    23<tau<60    ', 'fraction' )
        id_pc1tau6 = register_diag_field ( mod_name, &
                             'pc1tau6', axes(1:2), Time, &
                      '    pc<180;    60<tau       ', 'fraction' )
        id_pc2tau0 = register_diag_field ( mod_name, &
                             'pc2tau0', axes(1:2), Time, &
                      '180<pc<310;     0<tau<taumin', 'fraction' )
        id_pc2tau1 = register_diag_field ( mod_name, &
                             'pc2tau1', axes(1:2), Time, &
                      '180<pc<310;taumin<tau<1.3   ', 'fraction' )
        id_pc2tau2 = register_diag_field ( mod_name, &
                             'pc2tau2', axes(1:2), Time, &
                      '180<pc<310;   1.3<tau<3.6   ', 'fraction' )
        id_pc2tau3 = register_diag_field ( mod_name, &
                             'pc2tau3', axes(1:2), Time, &
                      '180<pc<310;   3.6<tau<9.4   ', 'fraction' )
        id_pc2tau4 = register_diag_field ( mod_name, &
                             'pc2tau4', axes(1:2), Time, &
                      '180<pc<310;   9.4<tau<23    ', 'fraction' )
        id_pc2tau5 = register_diag_field ( mod_name, &
                             'pc2tau5', axes(1:2), Time, &
                      '180<pc<310;    23<tau<60    ', 'fraction' )
        id_pc2tau6 = register_diag_field ( mod_name, &
                             'pc2tau6', axes(1:2), Time, &
                      '180<pc<310;    60<tau       ', 'fraction' )
        id_pc3tau0 = register_diag_field ( mod_name, &
                             'pc3tau0', axes(1:2), Time, &
                      '310<pc<440;     0<tau<taumin', 'fraction' )
        id_pc3tau1 = register_diag_field ( mod_name, &
                             'pc3tau1', axes(1:2), Time, &
                      '310<pc<440;taumin<tau<1.3   ', 'fraction' )
        id_pc3tau2 = register_diag_field ( mod_name, &
                             'pc3tau2', axes(1:2), Time, &
                      '310<pc<440;   1.3<tau<3.6   ', 'fraction' )
        id_pc3tau3 = register_diag_field ( mod_name, &
                             'pc3tau3', axes(1:2), Time, &
                      '310<pc<440;   3.6<tau<9.4   ', 'fraction' )
        id_pc3tau4 = register_diag_field ( mod_name, &
                             'pc3tau4', axes(1:2), Time, &
                      '310<pc<440;   9.4<tau<23    ', 'fraction' )
        id_pc3tau5 = register_diag_field ( mod_name, &
                             'pc3tau5', axes(1:2), Time, &
                      '310<pc<440;    23<tau<60    ', 'fraction' )
        id_pc3tau6 = register_diag_field ( mod_name, &
                             'pc3tau6', axes(1:2), Time, &
                      '310<pc<440;    60<tau       ', 'fraction' )
        id_pc4tau0 = register_diag_field ( mod_name, &
                             'pc4tau0', axes(1:2), Time, &
                      '440<pc<560;     0<tau<taumin', 'fraction' )
        id_pc4tau1 = register_diag_field ( mod_name, &
                             'pc4tau1', axes(1:2), Time, &
                      '440<pc<560;taumin<tau<1.3   ', 'fraction' )
        id_pc4tau2 = register_diag_field ( mod_name, &
                             'pc4tau2', axes(1:2), Time, &
                      '440<pc<560;   1.3<tau<3.6   ', 'fraction' )
        id_pc4tau3 = register_diag_field ( mod_name, &
                             'pc4tau3', axes(1:2), Time, &
                      '440<pc<560;   3.6<tau<9.4   ', 'fraction' )
        id_pc4tau4 = register_diag_field ( mod_name, &
                             'pc4tau4', axes(1:2), Time, &
                      '440<pc<560;   9.4<tau<23    ', 'fraction' )
        id_pc4tau5 = register_diag_field ( mod_name, &
                             'pc4tau5', axes(1:2), Time, &
                      '440<pc<560;    23<tau<60    ', 'fraction' )
        id_pc4tau6 = register_diag_field ( mod_name, &
                             'pc4tau6', axes(1:2), Time, &
                      '440<pc<560;    60<tau       ', 'fraction' )
        id_pc5tau0 = register_diag_field ( mod_name, &
                             'pc5tau0', axes(1:2), Time, &
                      '560<pc<680;     0<tau<taumin', 'fraction' )
        id_pc5tau1 = register_diag_field ( mod_name, &
                             'pc5tau1', axes(1:2), Time, &
                      '560<pc<680;taumin<tau<1.3   ', 'fraction' )
        id_pc5tau2 = register_diag_field ( mod_name, &
                             'pc5tau2', axes(1:2), Time, &
                      '560<pc<680;   1.3<tau<3.6   ', 'fraction' )
        id_pc5tau3 = register_diag_field ( mod_name, &
                             'pc5tau3', axes(1:2), Time, &
                      '560<pc<680;   3.6<tau<9.4   ', 'fraction' )
        id_pc5tau4 = register_diag_field ( mod_name, &
                             'pc5tau4', axes(1:2), Time, &
                      '560<pc<680;   9.4<tau<23    ', 'fraction' )
        id_pc5tau5 = register_diag_field ( mod_name, &
                             'pc5tau5', axes(1:2), Time, &
                      '560<pc<680;    23<tau<60    ', 'fraction' )
        id_pc5tau6 = register_diag_field ( mod_name, &
                             'pc5tau6', axes(1:2), Time, &
                      '560<pc<680;    60<tau       ', 'fraction' )
        id_pc6tau0 = register_diag_field ( mod_name, &
                             'pc6tau0', axes(1:2), Time, &
                      '680<pc<800;     0<tau<taumin', 'fraction' )
        id_pc6tau1 = register_diag_field ( mod_name, &
                             'pc6tau1', axes(1:2), Time, &
                     '680<pc<800;taumin<tau<1.3   ', 'fraction' )
        id_pc6tau2 = register_diag_field ( mod_name, &
                             'pc6tau2', axes(1:2), Time, &
                      '680<pc<800;   1.3<tau<3.6   ', 'fraction' )
        id_pc6tau3 = register_diag_field ( mod_name, &
                             'pc6tau3', axes(1:2), Time, &
                      '680<pc<800;   3.6<tau<9.4   ', 'fraction' )
        id_pc6tau4 = register_diag_field ( mod_name, &
                             'pc6tau4', axes(1:2), Time, &
                      '680<pc<800;   9.4<tau<23    ', 'fraction' )
        id_pc6tau5 = register_diag_field ( mod_name, &
                             'pc6tau5', axes(1:2), Time, &
                      '680<pc<800;    23<tau<60    ', 'fraction' )
        id_pc6tau6 = register_diag_field ( mod_name, &
                             'pc6tau6', axes(1:2), Time, &
                      '680<pc<800;    60<tau       ', 'fraction' )
        id_pc7tau0 = register_diag_field ( mod_name, &
                             'pc7tau0', axes(1:2), Time, &
                      '800<pc    ;     0<tau<taumin', 'fraction' )
        id_pc7tau1 = register_diag_field ( mod_name, &
                             'pc7tau1', axes(1:2), Time, &
                      '800<pc    ;taumin<tau<1.3   ', 'fraction' )
        id_pc7tau2 = register_diag_field ( mod_name, &
                             'pc7tau2', axes(1:2), Time, &
                      '800<pc    ;   1.3<tau<3.6   ', 'fraction' )
        id_pc7tau3 = register_diag_field ( mod_name, &
                             'pc7tau3', axes(1:2), Time, &
                      '800<pc    ;   3.6<tau<9.4   ', 'fraction' )
        id_pc7tau4 = register_diag_field ( mod_name, &
                             'pc7tau4', axes(1:2), Time, &
                      '800<pc    ;   9.4<tau<23    ', 'fraction' )
        id_pc7tau5 = register_diag_field ( mod_name, &
                             'pc7tau5', axes(1:2), Time, &
                      '800<pc    ;    23<tau<60    ', 'fraction' )
        id_pc7tau6 = register_diag_field ( mod_name, &
                             'pc7tau6', axes(1:2), Time, &
                      '800<pc    ;    60<tau       ', 'fraction' )
        id_nisccp = register_diag_field ( mod_name, &
                             'nisccp', axes(1:2), Time, &
                      'frequency of ISCCP calculations', 'fraction' )
       
        id_ninhomog = register_diag_field ( mod_name, &
                             'ninhomog', axes(1:2), Time, &
                      'frequency of cloud inhomogeneity calculations', &
                       'fraction' )
        
        id_inhomogeneity = register_diag_field ( mod_name, &
                      'inhomog_param', axes(1:2), Time, &
                      'Ratio of logarthmic to linear mean optical thickness', &
                       'fraction' )
       
        
!---------------------------------------------------------------------

 
end subroutine diag_field_init




!######################################################################
! <FUNCTION NAME="ran0">
!  <OVERVIEW>
!    ran0 is a platform-independent random number generator from
!    Numerical Recipes -- Mark Webb July 1999
!  </OVERVIEW>
!  <DESCRIPTION>
!    ran0 is a platform-independent random number generator from
!    Numerical Recipes -- Mark Webb July 1999
!  </DESCRIPTION>
!  <TEMPLATE>
!   x = ran0 (idum)
!  </TEMPLATE>
!  <IN NAME="idum" TYPE="real">
!   seed for random number generator
!  </IN>
! </FUNCTION>
function ran0 (idum)

!--------------------------------------------------------------------- 
!    ran0 is a platform-independent random number generator from
!    Numerical Recipes -- Mark Webb July 1999
!---------------------------------------------------------------------
       
real                    :: ran0               
integer, intent(inout)  :: idum
                                 
!--------------------------------------------------------------------
!  intent(out) variable:
!
!      ran0           random number generated by this function
!
!  intent(inout) variable:
!
!      idum           seed for random number generator
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

      integer :: ia = 16807        ! constant in random number generator
      integer :: im = 2147483647   ! constant in random number generator
      integer :: iq = 127773       ! constant in random number generator
      integer :: ir = 2836         ! constant in random number generator
      real    :: am                ! constant in random number generator
      integer :: k                 ! work variable              

!---------------------------------------------------------------------
!    define a needed  variable.
!---------------------------------------------------------------------
      am = 1.0/im

!---------------------------------------------------------------------
!    verify that the seed is valid.
!---------------------------------------------------------------------
      if (idum == 0) then
        call error_mesg ('isccp_clouds_mod', &
         'ZERO seed not allowed in ran0', FATAL)
      endif
 
!---------------------------------------------------------------------
!    compute next random number in sequence, using input value of
!    idum. return a new value of idum for use on next call.
!---------------------------------------------------------------------
      k = idum/iq
      idum = ia*(idum - k*iq) - ir*k
      if (idum < 0) idum = idum + im
      ran0 = am*idum

!---------------------------------------------------------------------


end function ran0

!######################################################################
! Pincus additions start here
! 
!######################################################################
  subroutine isccp_clouds_scops(cc, conv, seed, frac_out)
    real,    dimension(:, :), &  ! Dimensions nPoints, nLev
      intent( in) :: cc, &       !  Cloud cover in each model level (fraction) 
                                 !    NOTE:  This is the HORIZONTAL area of each grid box covered by clouds
                     conv        !  Convective cloud cover in each model level (fraction) 
                                 !    NOTE:  This is the HORIZONTAL area of each grid box covered by convective clouds
    integer, dimension(:), & ! Dimensions nPoints
      intent(inout) :: seed        !  seed value for random number generator ( see Numerical Recipes Chapter 7)
                                 !  It is recommended that the seed is set to a different value for each model
                                 !  gridbox it is called on, as it is possible that the choice of the same 
                                 !  seed value every time may introduce some statistical bias in the results, 
                                 !  particularly for low values of NCOL.

    real, dimension(:, :, :), &  ! Dimensions nPoints, nCol, nLev
      intent(out) :: frac_out    ! boxes gridbox divided up into
                                 ! Equivalent of BOX in original version, but indexed by column then row, 
                                 ! rather than by row then column
!     -----
!     Internal variables 
!     -----
    integer :: nPoints, nCol, nLev
!     -----
    integer :: ilev, ibox
    real, dimension(size(frac_out, 1), &
                  0:size(frac_out, 3)) :: tca ! total cloud cover in each model level (fraction)
                                              ! with extra layer of zeroes on top
                                              ! in this version this just contains the values input
                                              ! from cc but with an extra level
    real, dimension(size(frac_out, 1), &
                    size(frac_out, 3)) :: cca ! convective cloud cover in each model level (fraction) from conv 

    real, dimension(size(frac_out, 1), &
                    size(frac_out, 2)) :: threshold, &   ! pointer to position in gridbox
                                           maxocc,   &   ! Flag for max overlapped conv cld
                                           maxosc,   &   ! Flag for max overlapped strat cld
                                           boxpos,   &   ! ordered pointer to position in gridbox
                                           threshold_min ! minimum value to define range in with new threshold is chosen
    real, dimension(size(frac_out, 1), &
                    size(frac_out, 2)) :: ran            ! vector of random numbers
      
! ---------------------------------------------------------------------------
      nPoints = size(frac_out, 1)
      nCol    = size(frac_out, 2)
      nLev    = size(frac_out, 3)

!     -----------------------------------------------------!
!  Error checking - not needed in this version because we reset these variables in the calling routine.
!     ---------------------------------------------------!
!      call check_bounds(cc,   "cloud fraction",             0., 1.)
!      call check_bounds(conv, "convective cloud fraction",  0., 1.)

!     ---------------------------------------------------!

!     assign 2d tca array using 1d input array cc
      tca(:, 0 )   = 0.
      tca(:, 1:)   = cc(:, :)
 !     assign 2d cca array using 1d input array conv
      cca(:, :)    = conv(:, :)
      boxpos(:, :) = spread((/ (ibox - 0.5, ibox = 1, nCol) /) , &
                             dim = 1, nCopies = nPoints) / real(nCol)

!     ---------------------------------------------------!
!     Initialise output variable
!     ---------------------------------------------------!

!   Initialised frac_out to zero
      frac_out(:, :, :) = 0.
   
!     ---------------------------------------------------!
!     ALLOCATE CLOUD INTO BOXES, FOR NCOLUMNS, NLEVELS
!     frac_out is the array that contains the information 
!     where 0 is no cloud, 1 is a stratiform cloud and 2 is a
!     convective cloud
      
      !loop over vertical levels
      DO ilev = 1,nlev
!     Initialise threshold
        IF (ilev == 1) then
          ! If max overlap 
          IF (overlap == 1) then
            ! select pixels spread evenly across the gridbox
            threshold(:, :) = boxpos(:, :)
          ELSE
            DO ibox=1, ncol
              call ran0_vec(seed, ran(:, ibox))
              ! select random pixels from the non-convective
              ! part the gridbox ( some will be converted into
              ! convective pixels below )
              threshold(:,ibox) = cca(:,ilev) + (1 - cca(:,ilev)) * ran(:, ibox)
            end do
          ENDIF
        end if

        ! All versions of overlap
        where(boxpos(:, :) <= spread(cca(:, ilev), dim = 2, nCopies = nCol))
          maxocc(:, :) = 1
        elsewhere
          maxocc(:, :) = 0
        end where
        
        !
        ! Apply the overlap assumption
        !
        select case(overlap)
          case(1) ! Max overlap
            threshold_min(:, :) = spread(cca(:,ilev), dim = 2, nCopies = nCol)
            maxosc(:, :) = 1
          case(2)! Random overlap
            threshold_min(:, :) = spread(cca(:,ilev), dim = 2, nCopies = nCol)
            maxosc(:, :) = 0
          case(3)  ! Max/Random overlap
            threshold_min(:, :) = spread(max(cca(:, ilev), min(tca(:, ilev-1), tca(:, ilev))), &
                                         dim = 2, nCopies = nCol)
            where (threshold(:, :) < spread(min(tca(:, ilev-1), tca(:, ilev)), dim = 2, nCopies = nCol) .and. &
                   threshold(:, :) > spread(cca(:, ilev),                      dim = 2, nCopies = nCol)) 
              maxosc(:, :)= 1
            elsewhere
              maxosc(:, :)= 0
            end where
        end select
  
        ! Reset threshold 
        DO ibox=1,ncol
          call ran0_vec(seed, ran(:, ibox))
        end do
        threshold(:, :) = &
            !if max overlapped conv cloud     
            (    maxocc(:, :)) * ( boxpos(:, :)                                                ) +   &
            ! else
                !if max overlapped strat cloud; threshold=boxpos                       
            (1 - maxocc(:, :)) * ( (    maxosc(:, :)) * (threshold(:, :)                       ) +   &
                !else threshold_min=random[thrmin,1] 
                                   (1 - maxosc(:, :)) * (threshold_min(:, :) + &
                                                        (1 - threshold_min(:, :)) * ran(:, :) )    &
                                 )

        ! Fill frac_out with 1's where tca is greater than the threshold
        where (spread(tca(:,ilev), dim = 2, nCopies = nCol) > threshold(:, :)) 
          frac_out(:, :, ilev) = 1
        elsewhere
          frac_out(:, :,ilev) = 0
        end where               

       ! Partition boxes into stratiform and convective parts 
        where (spread(cca(:,ilev), dim = 2, nCopies = nCol) > threshold(:, :)) 
          frac_out(:, :, ilev) = 2
        end where               

    end do    !loop over nlev
      
  end subroutine isccp_clouds_scops
! -------------------------------------------------------------------
  subroutine isccp_clouds_icarus(dtau, pfull,                              & ! Required 
                    dem, dem_wv, at, skt, emsfc_lw, iTrop,    & ! Optional
                    boxtau, boxptop)
    !
    ! Required input arguments
    !
    real,    dimension(:, :, :), & ! Dimensions nPoints, nCol, nLev
      intent( in)  :: dtau         !  mean 0.67 micron optical depth of clouds in each model level
                                   !  NOTE:  this the cloud optical depth of only the cloudy part of the grid box, 
                                   !  it is not weighted with the 0 cloud optical depth of the clear part of the grid box
    real,    dimension(:, :),    &
      intent( in) :: pfull         !  pressure of full model levels (Pascals)
                                   !  pfull(npoints,1)    is    top level of model
                                   !  pfull(npoints,nlev) is bottom level of model
    !
    ! Optional input arguments - for computing radiative cloud-top pressure 
    !   All variables except itrop are needed if top_height == 1 .or. top_height == 3
    !
    real,    dimension(:, :, :), optional, & ! Dimensions nPoints, nCol, nLev
     intent( in) ::  dem         !  10.5 micron longwave emissivity of clouds in each model level.  
                                 !  Same note applies as in dtau.
   real,   dimension(:, :),      optional, & ! Dimensions nPoints, nLev
     intent( in) :: dem_wv, &    ! Water vapor emissivity.  
                    at           ! Air temperature in each model level (K)
   real,   dimension(:),         optional, &
     intent( in) :: skt, &       !  skin Temperature (K)
                    emsfc_lw     !  10.5 micron emissivity of surface (fraction)
   ! Users may supply their own tropopause height indicator
   integer, dimension(:),        optional, & ! Dimension nPoints
     intent( in) :: itrop        ! Index of the tropopause location in each column
   
    !     ------
    !     Output
    !     ------
    real, dimension(:, :), &   !  dimension nPoints, nCol
      intent(out) :: boxtau,         &   !  optical thickness in each column
                     boxptop             !  cloud top pressure (mb) in each sub-column
                  
    !     --------------------------------------------
    !     Local variables and parameters
    integer :: nPoints, nCol, nLev 
    !     ------
    integer                           ::  i, j, ilev, ibox, icycle
    real,    dimension(size(dtau, 1), &
                       size(dtau, 2)) :: tau, pTop, tb
    real,    dimension(size(dtau, 1), &
                       size(dtau, 2), &
                       size(dtau, 3)) :: dem_local
    
    ! Variables for adjusting cloud top pressure based on TOA IR radiance
    real,    dimension(size(dtau, 1)) :: fluxtop_clrsky
    real,    dimension(size(dtau, 1), &
                       size(dtau, 2)) :: emcld, fluxtop, tauir, taumin, &
                                         fluxtopinit, transmax, btcmin
    logical, dimension(size(dtau, 1), &
                       size(dtau, 2)) :: intermedTrans
  
    ! Historgram quanitities 
    integer, dimension(size(dtau, 1), &
                       size(dtau, 2)) :: levMatch
    
    ! Tropopause 
    integer, dimension(size(dtau, 1)) :: itrop_local    ! index to tropopause level
    real,    dimension(size(dtau, 1)) :: pTrop, atTrop  ! tropopause pressure, temperature
                                   
    
    !     ------
    !     Local constants
    !     ------
    real,    parameter ::  VisTauToIrTauIce = 1./2.13, VisTauToIrTauLiquid = 1./2.56, &
                           assumedFreezingTb = 260.

    ! -----------------------------------------------------------------------------------
    nPoints = size(dtau, 1); nCol    = size(dtau, 2); nLev    = size(dtau, 3)
    
    ! Error checking - not needed in this version because we ensured these values
    !   made sense in the calling routine.
!   call check_Lbound(dtau, "cloud optical depth", 0.)
!   if(present(dem)) &
!     call check_bounds(dem, "cloud emissivity",  0., 1.)
    
    ! -----------------------------------------------------------------------------------
    ! The easy part - what's the total cloud optical depth in each column? 
    ! 
    tau(:, :) = sum(dtau, dim = 3)

    ! -----------------------------------------------------------------------------------
    ! If we're adjusting cloud-top heights using the VIS and/or IR radiances 
    !    we need to know 1) the TOA radiance, and 2) the position of the tropopause 
    !    (the latter is the pressure level to which really cold clouds are assigned)
    !
    if(top_height == 1 .or. top_height == 3) then
      dem_local(:, :, :) = spread(dem_wv(:, :), dim = 2, nCopies = nCol)

      !
      ! Clear sky calculation - only need one col per GCM grid point
      !
      call computeRadiance(dem_local(:, 1, :), at, skt, emsfc_lw, fluxtop_clrsky(:))
      !
      ! Add contribution to emissivity from cloud
      !
      where(dem(:, :, :) > tiny(dem)) 
        dem_local(:, :, :) = 1. - ( (1. - dem_local(:, :, :)) * (1. -  dem(:, :, :)) )
      end where
      !
      ! And now the all-sky radiance
      !
      call computeRadiance(dem_local, at, skt, emsfc_lw, fluxtop)
    end if
    !     ---------------------------------------------------!
    ! Account for ISCCP procedures to determine cloud top temperature
  
    ! Account for partially transmitting cloud and recompute flux 
    !    ISCCP would see assuming a single layer cloud
    ! Note choice here of VisTauToIrTauIce = 1/2.13, as it is primarily ice
    !    clouds which have partial emissivity and need the adjustment 
    !
    ! If the cloud brightness temperature is greater than 260K,  the liquid cloud conversion
    !   factor is used.
    !
    ! This is discussed on pages 85-87 of the ISCCP D level documentation (Rossow et al. 1996)

    if (top_height == 1 .or. top_height == 3) then
      ! Tropoause height needed if cloud tops are to be adjusted
      !
      if(present(itrop)) then
        itrop_local(:) = itrop(:)
      else 
        call diagnoseTropPressure(pfull, at, itrop_local)
      end if
      do j = 1, nPoints
        ptrop(j)  = pfull(j, itrop_local(j)) 
        attrop(j) =    at(j, itrop_local(j))
      end do

      if (top_height == 1) then
        !compute minimum brightness temperature and optical depth
        btcmin(:, :) = spread(TbToFlux(attrop(:) - 5.), dim = 2, nCopies = nCol)
        
        !note that the initial setting of tauir(:) is needed so that
        !tauir(:) has a realistic value 
        tauir(:, :) = tau(:, :) * VisTauToIrTauIce
        transmax(:, :) = (fluxtop(:,:) - btcmin(:, :)) / &
                         (spread(fluxtop_clrsky(:), dim = 2, nCopies = nCol) - btcmin(:, :))
        taumin(:, :) = -log(max(min(transmax(:, :), 1. - spacing(1.)), tiny(transmax)))

        intermedTrans(:, :) = transmax(:, :) > tiny(transmax) .and. &
                              transmax(:, :) < 1. - spacing(1.)
        where (intermedTrans) 
          fluxtopinit(:, :) = fluxtop(:,:)
          tauir(:, :) = tau(:,:) * VisTauToIrTauIce
        end where
        
!       do icycle=1,2
!         where (tau(:,:) > tiny(tau) .and. intermedTrans) 
!            emcld(:,:) = 1. - exp(-tauir(:, :))
!            fluxtop(:,:) = fluxtopinit(:, :) - ( (1. - emcld(:,:)) * &
!                                                 spread(fluxtop_clrsky(:), dim = 2, nCopies = nCol) )
!            fluxtop(:,:) = max(tiny(fluxtop), fluxtop(:,:)/emcld(:,:))
!            tb(:, :) = fluxToTb(fluxtop(:, :))
!            where (tb(:, :) .gt. assumedFreezingTb) tauir(:, :) = tau(:,:) * VisTauToIrTauLiquid
!         end where
!       enddo

        do icycle=1,2
          do j= 1, size(tau,2)
          do i= 1, size(tau,1)
            if (tau(i,j) > tiny(tau)  .and. intermedTrans(i,j)) then
             emcld(i,j) = 1. - exp(-tauir(i, j))
             fluxtop(i,j) = fluxtopinit(i,j) - ( (1. - emcld(i,j)) * &
                      fluxtop_clrsky(i))
             fluxtop(i,j) = max(tiny(fluxtop), fluxtop(i,j)/emcld(i,j))
!            tb(i,j) = fluxToTb(fluxtop(i ,j))
              tb(i,j) = 1307.27/ log(1.+(1./fluxtop(i,j)))
             if (tb(i,j) .gt. assumedFreezingTb)  then
               tauir(i,j) = tau(i,j) * VisTauToIrTauLiquid
             endif
            endif
           end do
           end do
        enddo
      end if  
      
      where(tau(:, :) > tiny(tau)) 
        tb(:, :) = fluxToTb(fluxtop(:, :))
      elsewhere
        ! Clear sky brightness temperature
        tb(:,:) = spread(fluxToTb(fluxtop_clrsky(:)), dim = 2, nCopies = nCol)
      end where 
      
      if(top_height == 1) then
        ! Adjust the brightness temperature and optical depth of very thin clouds
        where (tau(:, :) > tiny(tau) .and. tauir(:, :) < taumin(:, :)) 
           tb(:, :) = spread(attrop(:) - 5., dim= 2, nCopies = nCol)
          tau(:, :) = taumin(:, :) / VisTauToIrTauIce
        end where
      end if
    end if
    ! -----------------------------------------------------------------------------------
    ! Determine cloud-top pressure. Three choices:
    !     Radiatively determined cloud top pressure (top_height = 1 for VIS/R;  3 for IR)
    !     Physical cloud top pressure (top_height = 2)
    
    if (top_height .eq. 1 .or. top_height .eq. 3) then  
      !segregate according to optical thickness (??? - RP)
      levmatch(:, :) = 0
      do ibox=1,ncol
        ! find lowest (?) level whose temperature
        ! most closely matches brightness temperature
        !
        do ilev = 1, nlev-1
          where((at(:,ilev) >= tb(:,ibox) .and. at(:,ilev+1) < tb(:,ibox)) .or. &
                (at(:,ilev) <= tb(:,ibox) .and. at(:,ilev+1) > tb(:,ibox)) )
            where(abs(at(:,ilev) - tb(:,ibox)) < abs(at(:,ilev+1) - tb(:,ibox)))
              levmatch(:, ibox) = ilev
            elsewhere 
              levmatch(:, ibox) = ilev + 1
            end where
          end where 
        end do

        ! If we've found a matching level use it, otherwise use the boundary value
        !  
        do j = 1, nPoints
          if(levmatch(j, ibox) >= 1) then
            ptop(j, ibox) = pfull(j, levmatch(j, ibox))
          else if (tb(j, ibox) < minval(at(j, :))) then
            levmatch(j, ibox) = itrop_local(j)
            ptop(j, ibox) = ptrop(j)
          else if (tb(j, ibox) > maxval(at(j, :))) then
            levmatch(j, ibox) = nLev
            ptop(j, ibox) = pFull(j, nLev)
          end if
        end do
      end do
      
    else !  When top_height .eq. 2
      ! The highest cloud top (clouds being where tau > 0). 
      ptop(:, :) = 0.
      do ibox = 1, nCol
        do ilev = 1, nlev
          where(ptop(:, ibox) <= 0. .and. dtau(:, ibox, ilev) > 0.)
            ptop(:, ibox) = pfull(:, ilev)
            levmatch(:,ibox) = ilev
          end where
        end do
      end do
    end if                            
          
    ! No matter how cloud top pressure is determined, 
    !   pTop and levmatch are 0 when the column is clear.   
    ! 
    where (tau(:,:) <= tiny(tau)) 
      ptop(:,:) = 0.
      levmatch(:,:) = 0      
    end where
    !     ---------------------------------------------------!
    ! Output
    !    
    boxptop(:, :) = ptop(:, :) / 100. 
    boxtau(:, :)  = tau(:, :)
    
  end subroutine isccp_clouds_icarus
  ! -------------------------------------------------------------------
  ! ------------------------------------------------------ 
  function computeIsccpJointHistograms(tau, ptop, sunlit) result(isccpJointHistogram)
    ! Dimensions nGridCell, nSubColumn 
    real, dimension(:, :),    intent( in) :: tau, ptop
    ! Dimensions nGridCell 
    integer, dimension(:),    intent( in) :: sunlit
    ! Dimensions nGridCells, nTauLevels (7), nPressureLevels(7)
    real, dimension(size(tau, 1), numIsccpOpticalDepthIntervals, numIsccpPressureIntervals) &
                                          :: isccpJointHistogram
    
    ! Local parameters
    real, dimension(numIsccpPressureIntervals + 1),      parameter ::       &
             isccpPressureBinEdges = (/ tiny(isccp_taumin),                 &
                                        180., 310., 440., 560., 680., 800., &
                                        huge(isccp_taumin) /) 
    real, dimension(numIsccpOpticalDepthIntervals + 1)             ::            &
            isccpOpticalDepthBinEdges ! Set at runtime, since isccp_taumin is variable.

    ! Local variables
    integer                     :: i, j
    logical, dimension(size(tau, 1), size(tau, 2)) &
                                :: box_cloudy
    ! --------------------
    isccpOpticalDepthBinEdges = (/ tiny(isccp_taumin),                    &
                                   isccp_taumin, 1.3, 3.6, 9.4, 23., 60., & 
                                   huge(isccp_taumin) /) 
    box_cloudy(:, :) = tau(:, :) > tiny(tau) .and. ptop(:, :) > 0 
    
    !
    ! Construct the histogram
    !
    do i = 1, numIsccpPressureIntervals 
      do j = 1, numIsccpOpticalDepthIntervals 
        isccpJointHistogram(:, i, j) = count(box_cloudy(:, :) .and.                               &
                                             tau(:, :)  >= isccpOpticalDepthBinEdges(i)     .and. &
                                             tau(:, :)  <  isccpOpticalDepthBinEdges(i + 1) .and. &
                                             pTop(:, :) >= isccpPressureBinEdges(j)         .and. &
                                             pTop(:, :) <  isccpPressureBinEdges(j + 1), dim = 2)
      end do
    end do
    isccpJointHistogram(:, :, :)  = isccpJointHistogram(:, :, :)/size(tau, 2)
  end function computeIsccpJointHistograms
  ! ------------------------------------------------------ 
  ! ------------------------------------------------------ 
  function computeInhomogeneityParameter (tau,  ptop, sunlit)  result(inhomog_number)
    ! Dimensions nGridCell, nSubColumn 
    real, dimension(:, :),    intent( in) :: tau, ptop
    ! Dimensions nGridCell 
    integer, dimension(:),    intent( in) :: sunlit
    ! Dimensions nGridCell
    real, dimension(size(tau, 1))         :: inhomog_number
    
    ! Local variables
    real,   dimension(size(tau, 1))               :: logAve, linearAve, tmp
    logical, dimension(size(tau, 1), size(tau, 2)) :: isCloudy
    integer :: i,j
    !
    ! compute linear and logarithmic averages
    
    isCloudy(:, :) = tau(:,:) > isccp_taumin .and. ptop(:, :) > 0
    
    !
    ! compute inhomogeneity parameter
    
!    where(count(isCloudy(:, :), dim = 2) > minColsInhomo)
!      logAve(:)    = sum(log(tau(:, :)), dim = 2, mask = isCloudy(:, :)) / &
!                     count(isCloudy(:, :), dim = 2)
!      linearAve(:) = sum(tau(:, :),      dim = 2, mask = isCloudy(:, :)) / &
!                     count(isCloudy(:, :), dim = 2)
!      inhomog_number(:) = 1. - ( exp(logAve(:))/linearAve(:) )        
!    elsewhere
!      inhomog_number(:) = -1.
!    endwhere
    tmp = count(isCloudy(:, :), dim = 2)
    inhomog_number(:) = -1.
    do i= 1,size(logave,1)
      if ( tmp(i) > minColsInhomo) then
      logAve(i)    = 0.0
      linearAve(i) = 0.0
        do j = 1, size(tau,2)
          if (isCloudy(i,j) ) then
            logAve(i)    = logAve(i) + log(tau(i,j))
            linearAve(i) = linearAve(i) +  tau(i,j)
          endif
        enddo
      logAve(i)    = logAve(i)   /tmp(i)
      linearAve(i) = linearAve(i)/tmp(i)
      endif
    enddo  
    do i= 1,size(logave,1)
      if ( tmp(i) > minColsInhomo) &
        inhomog_number(i) = 1. - ( exp(logAve(i))/linearAve(i) )
    enddo  
    
  end function computeInhomogeneityParameter
  ! ------------------------------------------------------   
  ! -------------------------------------------------------------------      
  subroutine computeWaterVaporEmissivity(pfull, phalf, qv, at, dem_wv)
     real, dimension(:, :), & ! nPoints, nLev
       intent( in) :: pFull, pHalf, qv, at
     real, dimension(:, :), & ! nPoints, nLev
       intent(out) :: dem_wv
     
     ! Local variables
     integer :: nPoints, nLev
     integer :: iLev
     real, dimension(size(dem_wv, 1)) :: press, dpress, atmden, rvh20, wk, rhoave, rh20s, &
                                         rfrgn, tmpexp, tauwv
    
     real, parameter :: wtmair = 28.9644, wtmh20 = 18.01534, Navo = 6.023E+23, grav = 9.806650E+02, &
                        pstd = 1.013250E+06, t0 = 296.
    ! -------------------------------------------
    nPoints = size(pFull, 1); nLev    = size(pFull, 2)

    !compute water vapor continuum emissivity
    !this treatment follows Schwarkzopf and Ramasamy
    !JGR 1999,vol 104, pages 9467-9499.
    !the emissivity is calculated at a wavenumber of 955 cm-1, 
    !or 10.47 microns 
    do ilev=1,nlev
      ! press and dpress are dyne/cm2 = Pascals *10
      press(:) = pfull(:,ilev)*10.
      dpress(:) = (phalf(:,ilev+1)-phalf(:,ilev))*10
      !atmden = g/cm2 = kg/m2 / 10 
      atmden(:) = dpress(:)/grav
      rvh20(:) = qv(:,ilev)*wtmair/wtmh20
      wk(:) = rvh20(:)*Navo*atmden(:)/wtmair
      rhoave(:) = (press(:)/pstd)*(t0/at(:,ilev))
      rh20s(:) = rvh20(:)*rhoave(:)
      rfrgn(:) = rhoave(:)-rh20s(:)
      tmpexp(:) = exp(-0.02*(at(:,ilev)-t0))
      tauwv(:) = wk(:)*1.e-20*((0.0224697*rh20s(:)*tmpexp(:)) + (3.41817e-7*rfrgn(:)) )*0.98
      dem_wv(:,ilev) = 1. - exp( -1. * tauwv(:))
    end do
  end subroutine computeWaterVaporEmissivity 
  ! -------------------------------------------------------------------
  subroutine diagnoseTropPressure(pfull, at, itrop)
    real,    dimension(:, :), intent( in) :: pFull, at
    integer, dimension(:),    intent(out) :: itrop
    
    integer                         :: nPoints, nLev
    real, dimension(size(pFull, 1)) :: attropmin
    integer                         :: ilev

    nPoints = size(pFull, 1); nLev = size(pFull, 2)
    attropmin(:) = 400.
    itrop(:)     = 1
  
    do  ilev=1,nlev
      where(pfull(:, ilev) < 40000. .and. pfull(:, ilev) > 5000. .and. &
            at(:, ilev) < attropmin(:)) 
        attropmin(:) = at(:, ilev)
        itrop(:)=ilev
      end where
    end do
  end subroutine diagnoseTropPressure 
  ! -------------------------------------------------------------------      
  ! -------------------------------------------------------------------      
  subroutine check_bounds(array, name, minAllowed, maxAllowed)
    implicit none
    ! Input variables
    real, dimension(:, :), intent( in) :: array
    character(len = *),    intent( in) :: name
    real,                  intent( in) :: minAllowed, maxAllowed
    
    ! ---------------------
    if(any(array(:, :) < minAllowed .or. array(:, :) > maxAllowed)) then
      call error_mesg ('isccp_clouds_mod', &
                       'Values in array out of bounds', FATAL)
    end if
  end subroutine check_bounds
  ! -------------------------------------------------------------------      
  subroutine check_Lbound(array, name, minAllowed)
    implicit none
    ! Input variables
    real, dimension(:, :, :), intent( in) :: array
    character(len = *),       intent( in) :: name
    real,                     intent( in) :: minAllowed
    
    ! ---------------------
    if(any(array(:, :, :) < minAllowed )) then
      call error_mesg ('isccp_clouds_mod', &
                       'Array values smaller than lower bound', FATAL)
    end if
  end subroutine check_lBound
  ! -------------------------------------------------------------------      
  ! Functions to compute brightness temperature given a 11 micron radiance
  !
  ! -------------------------------------------------------------------      
  function fluxToTb_1D(flux) result(tb)
    real, dimension(:),       intent( in) :: flux
    real, dimension(size(flux))           :: tb
    
    tb(:) = 1307.27 / log(1. + (1./flux(:)))
  end function fluxToTb_1D
  !     ---------------------------------------------------!
  function fluxToTb_2D(flux) result(tb)
    real, dimension(:, :),    intent( in) :: flux
    real, dimension(size(flux, 1), &
                    size(flux, 2))        :: tb
    
    tb(:, :) = 1307.27 / log(1. + (1./flux(:, :)))
  end function fluxToTb_2D
  !     ---------------------------------------------------!
  function fluxToTb_3D(flux) result(tb)
    real, dimension(:, :, :), intent( in) :: flux
    real, dimension(size(flux, 1), &
                    size(flux, 2), &
                    size(flux, 3))        :: tb
    
    tb(:, :, :) = 1307.27 / log(1. + (1./flux(:, :, :)))
  end function fluxToTb_3D
  ! -------------------------------------------------------------------      
  ! Functions to compute 11 micron radiance given a brightness temperature
  !
  ! -------------------------------------------------------------------      
  function TbToFlux_1D(tb) result(flux)
    real, dimension(:),       intent( in) :: tb
    real, dimension(size(tb))             :: flux
    
    flux(:) = 1. / ( exp(1307.27/tb(:)) - 1. )
  end function TbToFlux_1D
  !     ---------------------------------------------------!
  function TbToFlux_2D(tb) result(flux)
    real, dimension(:, :),    intent( in) :: tb
    real, dimension(size(tb, 1), &  
                    size(tb, 2))          :: flux
    
    flux(:, :) = 1. / ( exp(1307.27/tb(:, :)) - 1. )
  end function TbToFlux_2D
  ! ---------------------------------------------------!
  function TbToFlux_3D(tb) result(flux)
    real, dimension(:, :, :), intent( in) :: tb
    real, dimension(size(tb, 1), &
                    size(tb, 2), &
                    size(tb, 3))          :: flux
    
    flux(:, :, :) = 1. / ( exp(1307.27/tb(:, :, :)) - 1. )
  end function TbToFlux_3D
  ! -------------------------------------------------------------------      
  ! -------------------------------------------------------------------      
  subroutine computeRadiance_1D(dem, at, skt, emsfc_lw, TOAradiance)
    real,    dimension(:, :), &  ! Dimensions nPoints, nLev
      intent( in) :: dem,     &  !   10.5 micron emissivity of water vapor
                     at          !   air temperature
    real,   dimension(:),     &  ! Dimension nPoints
      intent( in) :: skt,     &  !   skin Temperature (K)
                     emsfc_lw    !   10.5 micron emissivity of surface (fraction) 
    real, dimension(:),       &  ! Dimension nPoint, nCol
      intent(out) :: TOAradiance !   10.5 micron nadir radiance at TOA
    
  !     ------
  !     Local variables and parameters
    integer :: nPoints, nLev
    !     ------
    integer ::  ilev
    real,    dimension(size(dem, 1)) :: trans_layers_above
    real,    dimension(size(dem, 1)) :: bb
                                                          
    !----------------------------------------------------------------------
    ! Computes radiance at TOA from an emitting/absorbing atmosphere
    !     TOAradiance is the 10.5 micron radiance at the top of the
    !              atmosphere
    !     trans_layers_above is the total transmissivity in the layers
    !             above the current layer
    !----------------------------------------------------------------------
  
    !initialize variables
    nPoints = size(dem, 1); nLev    = size(dem, 2)
    TOAradiance(:) = 0.; trans_layers_above(:) = 1.
  
    do ilev=1,nlev
      ! Black body emission at temperature of the layer
      bb(:) = TbToFlux(at(:,ilev))
  
      ! increase TOA flux by flux emitted from layer
      ! times total transmittance in layers above
      TOAradiance(:) = TOAradiance(:) + dem(:, ilev) * trans_layers_above(:) * bb(:)
        
      ! update trans_layers_above with transmissivity
      ! from this layer for next time around loop
      trans_layers_above(:) = trans_layers_above(:) * (1. - dem(:, ilev))
    enddo ! ilev
  
    !surface emission
    bb(:) = TbToFlux(skt(:)) 
  
    !add in surface emission
    TOAradiance(:) = TOAradiance(:) + trans_layers_above(:) * emsfc_lw(:) * bb(:)
                       
  end subroutine computeRadiance_1D
 ! -------------------------------------------------------------------      
  subroutine computeRadiance_2D(dem, at, skt, emsfc_lw, TOAradiance)
    real,    dimension(:, :, :), &  ! Dimensions nPoints, nCol, nLev
      intent( in) :: dem            !   10.5 micron emissivity of water vapor
   real,    dimension(:, :),     &  ! Dimensions nPoints, nLev
      intent( in) :: at             !   air temperature
    real,   dimension(:),        &  ! Dimension nPoints
      intent( in) :: skt,        &  !   skin Temperature (K)
                     emsfc_lw       !   10.5 micron emissivity of surface (fraction) 
    real, dimension(:, :),       &  ! Dimension nPoint, nCol
      intent(out) :: TOAradiance    !   10.5 micron nadir radiance at TOA
    
  !     ------
  !     Local variables and parameters
    integer :: nPoints, nCol, nLev 
    !     ------
    integer ::  ilev
    real,    dimension(size(dem, 1), &
                       size(dem, 2)) :: trans_layers_above
    real,    dimension(size(dem, 1)) :: bb
 
    !----------------------------------------------------------------------
    ! Computes radiance at TOA from an emitting/absorbing atmosphere
    !     TOAradiance is the 10.5 micron radiance at the top of the
    !              atmosphere
    !     trans_layers_above is the total transmissivity in the layers
    !             above the current layer
    !----------------------------------------------------------------------
  
    !initialize variables
    nPoints = size(dem, 1); nCol    = size(dem, 2); nLev    = size(dem, 3)
    TOAradiance(:, :) = 0.; trans_layers_above(:, :) = 1.
  
    do ilev=1,nlev
      ! Black body emission at temperature of the layer
      bb(:) = TbToFlux(at(:,ilev))
  
      ! increase TOA flux by flux emitted from layer
      ! times total transmittance in layers above
      TOAradiance(:,:) = TOAradiance(:,:) + &
                         dem(:,:, ilev) * trans_layers_above(:,:) * spread(bb(:), dim = 2, nCopies = nCol) 
        
      ! update trans_layers_above with transmissivity
      ! from this layer for next time around loop
      trans_layers_above(:, :) = trans_layers_above(:, :) * (1. - dem(:, :, ilev))
    enddo ! ilev
  
    !surface emission
    bb(:) = TbToFlux(skt(:)) 
  
    !add in surface emission
    TOAradiance(:,:) = TOAradiance(:,:) +  &
                       trans_layers_above(:,:) * spread(emsfc_lw(:) * bb(:), dim = 2, nCopies = nCol)
  
  end subroutine computeRadiance_2D
 ! -------------------------------------------------------------------      
  subroutine ran0_vec(idum, ran0)
    integer, dimension(:), intent(inout) :: idum
    real,    dimension(:), intent(  out) :: ran0
!     $Id: isccp_clouds.F90,v 19.0 2012/01/06 20:16:57 fms Exp $
!     Platform independent random number generator from
!     Numerical Recipies
!     Mark Webb July 1999
!     Fortran 90 implementation Robert Pincus, Dec 2003
    
    integer, parameter :: IA = 16807, IM = 2147483647,  IQ = 127773, IR = 2836
    real,    parameter :: AM = 1.0/IM
    
    integer, dimension(size(idum)) :: k

    if(any(idum(:) == 0))                  &
      call error_mesg ('isccp_clouds_mod', &
                       'idum: ZERO seed not allowed', FATAL)

    k(:) = idum(:) / IQ
    idum (:) = IA * (idum(:) - k(:) * IQ) - IR * k(:)
    where (idum(:) < 0) idum(:) = idum(:) + IM
    ran0(:) = AM * idum(:)

  end subroutine ran0_vec
!#####################################################################

                end module isccp_clouds_mod

! ============================================================================
! vegetation-related processes
! ============================================================================
module vegetation_mod

! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Christopher Milly
! </CONTACT> 

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Elena Shevliakova
! </REVIEWER>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Sergey Malyshev
! </REVIEWER>

! <OVERVIEW>
!   Module containing processes relating to vegetation.
! </OVERVIEW>

! <DESCRIPTION>
!   Vegetation type describing vegetation characteristics is defined.
!   Vegetation data is allocated and the initial value for canopy air
!   humidity is set up. Updates vegetation and boundary data on the slow
!   and fast time-scales. Deallocates vegetation data, empties memory and
!   cleans up, if necessary.
! </DESCRIPTION>

  ! things from the other modules we use in the interface part of this module
  use time_manager_mod, only: time_type, get_time
  use mpp_domains_mod,  only: domain2d, mpp_get_compute_domain
  use land_types_mod,   only: land_data_type
  use soil_mod,         only: soil_type
  use constants_mod,    only: rdgas, rvgas
  use fms_mod,          only: write_version_number, error_mesg, FATAL,      &
                              file_exist, open_restart_file, close_file,    &
                              read_data, write_data, set_domain, mpp_pe,    &
                              open_namelist_file, check_nml_error, mpp_pe,  &
                              NOTE, mpp_root_pe, mpp_error, stdlog
  use fms_io_mod,       only: get_restart_io_mode
  use sat_vapor_pres_mod, only: escomp

  use field_manager_mod,  only: MODEL_LAND
  use tracer_manager_mod, only: get_tracer_index, NO_TRACER

implicit none
private

! ==== public interfaces =====================================================
public :: vegetation_type

public :: vegetation_init              ! initialize vegetation data

public :: vegetation_end               ! finish using vegetation data

public :: update_vegetation_slow       ! slow time-scale vegetation update
public :: update_vegetation_fast_up    ! fast time-scale update of veg. state
public :: update_vegetation_fast_down  ! fast time-scale update of veg. state
public :: update_vegetation_bnd_fast
public :: update_vegetation_bnd_slow

public :: vegetation_stock_pe          ! calculate and return total amount of
                                       ! requested quantitiy per PE
! ==== end of public interfaces ==============================================

! <TYPE NAME="vegetation_type">
type vegetation_type
   private

!   <DESCRIPTION>
!      Private data type describing vegetation characteristics.
!   </DESCRIPTION>

   type(domain2d) :: domain   ! computational domain
   real           :: dt       ! fast time step, s

!   <DATA NAME="domain" TYPE="domain2d" DIM="2">
!     Computational domain
!   </DATA>
!   <DATA NAME="dt" UNITS="s" TYPE="real">
!     Fast time step
!   </DATA>

   integer :: is,ie,js,je  ! computational domain bounds
   integer :: n_tiles      ! number of tiles
!   <DATA NAME="is" TYPE="integer">
!     Computational domain bounds
!   </DATA>
!   <DATA NAME="ie" TYPE="integer">
!     Computational domain bounds
!   </DATA>
!   <DATA NAME="js" TYPE="integer">
!     Computational domain bounds
!   </DATA>
!   <DATA NAME="je" TYPE="integer">
!     Computational domain bounds
!   </DATA>
!   <DATA NAME="n_tiles" TYPE="integer">
!     Number of tiles
!   </DATA>

   logical, pointer, dimension(:,:,:) :: &
        mask =>NULL(),    & ! land mask
        bonedry =>NULL()    ! true if the "bone dry" conditions occur (evaporation
                          ! during time step larger than available water)
!   <DATA NAME="mask" TYPE="logical, pointer" DIM="3">
!     Land mask
!   </DATA>
!   <DATA NAME="bonedry" TYPE="logical, pointer" DIM="3">
!     True if the "bone dry" conditions occur (evaporation during time step
!     is larger than the available water)
!   </DATA>

   real, pointer, dimension(:,:,:) :: &
        q_ca =>NULL()       ! specific humidity of canopy air
!   <DATA NAME="q_ca" UNITS="kg/kg" TYPE="real, pointer" DIM="3">
!     Specific humidity of canopy air
!   </DATA>

   real, pointer, dimension(:,:,:) :: &
        t_surf =>NULL(),  & ! soil surface temperature, degK
        evap =>NULL(),    & ! explicit estimate of the water vapor flux
        c_surf =>NULL(),  & ! conductance between surface and canopy air
        dqsatdt =>NULL(), & ! derivative of sat. humidity over T surface
        e_q =>NULL(),     & ! implicit scheme coefficient
        f_q =>NULL(),     & ! implicit scheme coefficient
        beta =>NULL()       ! water availability for evaporation
!   <DATA NAME="t_surf" UNITS="K" TYPE="real, pointer" DIM="3">
!     Soil surface temperature
!   </DATA>
!   <DATA NAME="evap" UNITS="kg/m2/s" TYPE="real, pointer" DIM="3">
!     Explicit estimate of the water vapor flux
!   </DATA>
!   <DATA NAME="c_surf" UNITS="kg/m2/s" TYPE="real, pointer" DIM="3">
!     Conductance between surface and canopy air
!   </DATA>
!   <DATA NAME="dqsatdt" UNITS="kg/kg/degK" TYPE="real, pointer" DIM="3">
!     Derivative of sat. humidity over T surface
!   </DATA>
!   <DATA NAME="e_q" TYPE="real, pointer" DIM="3">
!     Implicit scheme coefficient
!   </DATA>
!   <DATA NAME="f_q" TYPE="real, pointer" DIM="3">
!     Implicit scheme coefficient
!   </DATA>
!   <DATA NAME="beta" TYPE="real, pointer" DIM="3">
!     Water availability for evaporation
!   </DATA>

end type vegetation_type
! </TYPE>

! some names, for information only
logical :: module_is_initialized =.FALSE.
character(len=*), private, parameter :: module_name = 'vegetation_mod'
character(len=128), private, parameter :: version     = '$Id: vegetation.F90,v 15.0 2007/08/14 04:00:20 fms Exp $'
character(len=128), private, parameter :: tagname        = '$Name: tikal $'

! module constants
real, parameter :: d622 = rdgas/rvgas
real, parameter :: d378 = 1.0-d622
real, parameter :: d608 = d378/d622

! <NAMELIST NAME="vegetation_nml">
!   <DATA NAME="klev" TYPE="integer" DEFAULT="0">
!     Soil level at which to specify frozen-soil factor for modifying beta.
!   </DATA>
!   <DATA NAME="do_netcdf_restart" TYPE="logical" DEFAULT=".true.">
!     Do netcdf restart.
!   </DATA>
! ---- namelist variables and their default values ---------------------------
integer :: klev    = 0 
logical :: do_netcdf_restart = .true.

namelist /vegetation_nml/ klev, do_netcdf_restart
! </NAMELIST>

! for diagnostics only
integer :: i 
integer, parameter :: iwatch = 38, jwatch=60


! module variables
integer :: isphum ! index of specific humidity in the tracer table

contains


! <SUBROUTINE NAME="vegetation_init">

!   <OVERVIEW>
!     Initializes vegetation data.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Allocates vegetation data and sets up initial value for canopy air
!     humidity.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call vegetation_init &
!     ( veg, gblon, gblat, garea, gfrac, time, dt_fast, dt_slow, domain, &
!     frac, mask, id_lon, id_lat )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine vegetation_init &
     ( veg, gblon, gblat, garea, gfrac, time, dt_fast, dt_slow, domain, &
     frac, mask, id_lon, id_lat )

  type(vegetation_type),intent(inout) :: veg        ! state of a particular
                                                    ! realization to initialize
  real,                 intent(in)    :: gblon(:,:) ! longitude corners of the
                                                    ! grid cells
  real,                 intent(in)    :: gblat(:,:) ! latitude corners of the
                                                    ! grid cells
  real,                 intent(in)    :: garea(:,:) ! grid cell area 
  real,                 intent(in)    :: gfrac(:,:) ! fraction of grid cell
                                                    ! covered by land 
  type(time_type),      intent(in)    :: time       ! current time
  type(time_type),      intent(in)    :: dt_fast    ! fast time step
  type(time_type),      intent(in)    :: dt_slow    ! slow time step
  type(domain2d),       intent(in)    :: domain     ! our domain
  real,                 intent(in)    :: frac(:,:,:)! fractional area of tiles
  logical,              intent(in)    :: mask(:,:,:)! land mask
  integer,              intent(in)    :: id_lon     ! ID of X (longitude) diag
                                                    ! axis
  integer,              intent(in)    :: id_lat     ! ID of Y (latitude) diag
                                                    ! axis
!   </PUBLICROUTINE>

  ! ---- local vars ---------------------------------------------------------
  integer :: unit, ierr, io     ! restart file unit
  integer :: sec, day ! components of time

  if ( file_exist( 'input.nml' ) ) then
     unit = open_namelist_file ( )
     ierr = 1
     do while ( ierr /= 0 )
        read ( unit,  nml = vegetation_nml, iostat = io, end = 10 )
        ierr = check_nml_error ( io, 'vegetation_nml' )
     enddo
10   continue
     call close_file (unit)
  endif
  call get_restart_io_mode(do_netcdf_restart)

! write version and tag information to logfile
  call write_version_number(version, tagname) 
  !  write the namelist to a log file
  if( mpp_pe()==0 ) then
     unit = stdlog( )
     write (unit, nml=vegetation_nml)
     call close_file (unit)
  endif
  ! copy specified domain to our data
  veg % domain = domain

  ! get the size of our domain
  call mpp_get_compute_domain ( veg%domain, veg%is, veg%ie, veg%js, veg%je )
  veg%n_tiles = size(frac, 3)

  ! setup time-related data
  call get_time(dt_fast, sec, day); veg%dt = day*86400.0+sec

  ! allocate data
  allocate ( &
       veg%mask    (veg%is:veg%ie, veg%js:veg%je, veg%n_tiles), &
       veg%q_ca    (veg%is:veg%ie, veg%js:veg%je, veg%n_tiles), &
       veg%evap    (veg%is:veg%ie, veg%js:veg%je, veg%n_tiles), &
       veg%t_surf  (veg%is:veg%ie, veg%js:veg%je, veg%n_tiles), &
       veg%c_surf  (veg%is:veg%ie, veg%js:veg%je, veg%n_tiles), &
       veg%dqsatdt (veg%is:veg%ie, veg%js:veg%je, veg%n_tiles), &
       veg%e_q     (veg%is:veg%ie, veg%js:veg%je, veg%n_tiles), &
       veg%f_q     (veg%is:veg%ie, veg%js:veg%je, veg%n_tiles), &
       veg%beta    (veg%is:veg%ie, veg%js:veg%je, veg%n_tiles), &
       veg%bonedry (veg%is:veg%ie, veg%js:veg%je, veg%n_tiles)  )

  veg%mask = mask

  ! set up initial value for canopy air humidity
  veg%q_ca = 0
  call set_domain ( veg%domain )

  if (file_exist('INPUT/vegetation.res.nc') .or. file_exist('INPUT/vegetation.res.tile1.nc') ) then
     if (mpp_pe() == mpp_root_pe()) call mpp_error ('vegetation_mod', &
          'Reading NetCDF formatted restart file: INPUT/vegetation.res.nc', NOTE)
     call read_data( 'INPUT/vegetation.res.nc', 'q_ca', veg%q_ca)
  else
     if (file_exist('INPUT/vegetation.res')) then
        if (mpp_pe() == mpp_root_pe()) call mpp_error ('vegetation_mod', &
             'Reading native formatted restart file.', NOTE)
        unit = open_restart_file ( 'INPUT/vegetation.res', 'read')
        call read_data  ( unit, veg%q_ca )
        call close_file ( unit )
     endif
  endif 

! initialize tracers
#ifdef LAND_BND_TRACERS
  isphum = get_tracer_index ( MODEL_LAND, 'sphum' )
  if (isphum==NO_TRACER) then
     call error_mesg('vegetation_init','no required "sphum" tracer',FATAL)
  endif
#else
  isphum = NO_TRACER
#endif

  module_is_initialized =.TRUE.

end subroutine vegetation_init
! </SUBROUTINE>


! <SUBROUTINE NAME="vegetation_end">

!   <OVERVIEW>
!      Deallocates vegetation data; empty memory and do clean-up, if
!      necessary.
!   </OVERVIEW>

!   <DESCRIPTION>
!      Deallocates vegetation data; empty memory and do clean-up, if
!      necessary.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call vegetation_end ( veg )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine vegetation_end ( veg )

  type(vegetation_type), intent(inout) :: veg ! data to finish using
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer :: unit ! restart file unit 

  ! save restart file
  call set_domain ( veg%domain )
  if( do_netcdf_restart) then
     if (mpp_pe() == mpp_root_pe()) call mpp_error ('vegetation_mod', &
          'Writing NetCDF formatted restart file: RESTART/vegetation.res.nc', NOTE)
     call write_data('RESTART/vegetation.res.nc', 'q_ca', veg%q_ca)
  else
     if (mpp_pe() == mpp_root_pe()) call mpp_error ('vegetation_mod', &
          'Writing native formatted restart file.', NOTE)
     unit = open_restart_file ( 'RESTART/vegetation.res', 'write' )
     call write_data ( unit, veg%q_ca )
     call close_file ( unit )
  endif

  ! deallocate data
  deallocate (        &
       veg%mask,      &
       veg%q_ca,      &
       veg%evap,      &
       veg%t_surf,    &
       veg%c_surf,    &
       veg%dqsatdt,   &
       veg%e_q,       &
       veg%f_q,       &
       veg%beta,      &
       veg%bonedry    )

    module_is_initialized =.FALSE.

end subroutine vegetation_end
! </SUBROUTINE>


! <SUBROUTINE NAME="update_vegetation_slow">

!   <OVERVIEW>
!     Slow time-scale vegetation update.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Slow time-scale vegetation update.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call update_vegetation_slow ( veg )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine update_vegetation_slow ( veg )

  type(vegetation_type), intent(inout) :: veg ! data to update
!   </PUBLICROUTINE>
  
  ! call diagnostics_slow ( veg )

end subroutine update_vegetation_slow
! </SUBROUTINE>


! <SUBROUTINE NAME="update_vegetation_fast_down">

!   <OVERVIEW>
!     Fast time-scale vegetation update given soil data inputs.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Fast time-scale vegetation update given soil data inputs. Calculates
!     water availability for evapotranspiration. Calculates saturated specific
!     humidity at the surface and its derivative over the surface temperature.
!     Air density is calculated here using surface q and T; in principle we
!     should use canopy q and T, but surface values are the only ones we have
!     available in this particular implementation. 
!   </DESCRIPTION>

!   <TEMPLATE>
!     call update_vegetation_fast_down( veg, soil, evap, dedq, drag_q, psurf, evap1, dedt)
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine update_vegetation_fast_down( veg, soil, evap, dedq, drag_q, psurf, evap1, dedt)

  type(vegetation_type), intent(inout) :: veg            ! data to update
  type(soil_type),       intent(in)    :: soil           ! soil data inputs
  real, intent(in)  :: &
       evap   (veg%is:veg%ie,veg%js:veg%je,veg%n_tiles),&! evaporation from the
                                                         ! surface into the atm
       drag_q (:,:,:),&                                  ! drag coefficient
       dedq   (:,:,:),&                                  ! derivative of evap
                                                         ! over q_ca
       psurf  (veg%is:veg%ie,veg%js:veg%je,veg%n_tiles)  ! surface pressure

  real, intent(out) :: &
       dedt   (:,:,:), &                                 ! derivative of evap
                                                         ! over T
       evap1  (veg%is:veg%ie,veg%js:veg%je,veg%n_tiles)  ! evaporation from
                                                         ! stomatal into sfc
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  real, dimension(veg%is:veg%ie,veg%js:veg%je,veg%n_tiles) :: &
       qsat,    &
       qsat1,   &
       rho,     &     ! canopy air density 
       fusion_factor  ! frozen-soil factor for modifying beta


  real, parameter :: del_temp = 0.1 ! temperature increment for q_sat derivative calc.

  ! save soil surface temperature for future use in update_vegetation_fast_up
  where (veg%mask)
     veg%t_surf = soil%temp(:,:,:,1)
  elsewhere
     veg%t_surf = 200.0 ! safeguards to avoid errors in escomp
  endwhere

  if (klev == 0) then
      fusion_factor= 1.
  else
      where (soil%mask)
        fusion_factor= 1. - (soil%fusion(:,:,:,klev)/soil%max_fusion(klev))
      endwhere
  endif

  ! calculate water availability for evapotranspiration
  if (soil%conserve_glacier_mass) then
      where(soil%mask .and. (.not.soil%snow>0))
        where (soil%glacier)
          veg%beta = 0.0
        elsewhere
          veg%beta = max(0.0, min(1.0, soil%water/(0.75*soil%max_water)))*  &
             fusion_factor 
        endwhere
      elsewhere
        veg%beta = 1
      endwhere
    else
      where(soil%mask .and. (.not.soil%glacier) .and. (.not.soil%snow>0))
         veg%beta = max(0.0, min(1.0, soil%water/(0.75*soil%max_water)))*  &
            fusion_factor
      elsewhere
         veg%beta = 1
      endwhere
    endif


  ! calculate saturated specific humidity at the surface and its derivative
  ! over T sfc.
  call escomp(veg%t_surf,         qsat ) ! calculate sat water vapor pressure
  call escomp(veg%t_surf+del_temp,qsat1) ! calculate sat water vapor pressure

  evap1 = 0  ! + slm, Mar 29 2002, for some reason if I do not do it, model crashes in bone_dry 
  where (soil%mask)
     ! conversion is placed here because psurf does not have to be defined 
     ! outside of land mask
     qsat   = d622*qsat /(psurf-d378*qsat ) ! convert pres. to spec. humidity
     qsat1  = d622*qsat1/(psurf-d378*qsat1) ! convert pres. to spec. humidity

     ! air density is calculated here using surface q and T; in principle
     ! we should use canopy q and T, but surface values are the only ones we
     ! have available in this particular implementation, and that should do
     rho    = psurf / (rdgas* veg%t_surf  * (1.0 + d608*veg%q_ca))

     veg%dqsatdt = (qsat1 - qsat)/del_temp
     where (soil%stomatal > 0.0)
        veg%c_surf = rho * veg%beta/(soil%stomatal+(1-veg%beta)/drag_q)
        veg%evap      = veg%c_surf * (qsat - veg%q_ca)
        evap1         = veg%evap + veg%c_surf*(evap - veg%evap)/(veg%c_surf + dedq)
        dedt          = veg%dqsatdt*veg%c_surf*(1.0-veg%c_surf/(veg%c_surf + dedq))
     elsewhere
        veg%e_q       = 1 - dedq / ( rho*drag_q )
        veg%f_q       = evap * veg%e_q / ( rho*drag_q*( 1 - veg%e_q ) ) 
        evap1         = evap + dedq * (1-veg%beta) * veg%f_q / (1-(1-veg%beta)*veg%e_q)
        dedt          =        dedq * veg%beta * veg%dqsatdt / (1-(1-veg%beta)*veg%e_q)
     endwhere

  endwhere
! pcm fixed for glacier-mass conservation. however, this will not catch cases
!     where explicit evap1 is ok but implicit evap_new is excessive. i think it
!     might be cleaner to delete this section and instead allow negative stores of
!     snow and/or soil water, as slm once suggested
  veg%bonedry = .false.
  if (soil%conserve_glacier_mass) then
     where (soil%mask)
        where ( evap1*veg%dt > soil%water+soil%snow )
           veg%bonedry = .true.
           evap1      = (soil%water+soil%snow)/veg%dt
           veg%evap   = evap1
           dedt       = 0
        endwhere
     endwhere
  else
     where (soil%mask)
        where ( (.not.soil%glacier) .and. (evap1*veg%dt > soil%water+soil%snow ) )
           veg%bonedry = .true.
           evap1      = (soil%water+soil%snow)/veg%dt
           veg%evap   = evap1
           dedt       = 0
        endwhere
     endwhere
  endif

 
  ! diagnostic output
  if (veg%is<=iwatch.and.iwatch<=veg%ie.and.veg%js<=jwatch.and.jwatch<=veg%je) then
!!$     do i = 1, size(veg%mask,3)
!!$        write(*,'(i2,2L2,100g14.4)')  i, &
!!$             veg%mask     (iwatch,jwatch,i), &
!!$             soil%glacier (iwatch,jwatch,i), &
!!$             soil%stomatal(iwatch,jwatch,i), &
!!$             soil%water   (iwatch,jwatch,i), &
!!$             veg%beta     (iwatch,jwatch,i), &
!!$             veg%t_surf   (iwatch,jwatch,i), &
!!$             veg%q_ca     (iwatch,jwatch,i), &
!!$             qsat         (iwatch,jwatch,i), &
!!$             evap         (iwatch,jwatch,i), &
!!$             evap1        (iwatch,jwatch,i)
!!$             dedt         (iwatch,jwatch,i), &
!!$             psurf        (iwatch,jwatch,i), &
!!$             veg%dqsatdt  (iwatch,jwatch,i)
!!$     enddo
  endif

end subroutine update_vegetation_fast_down
! </SUBROUTINE>


! <SUBROUTINE NAME="update_vegetation_fast_up">

!   <OVERVIEW>
!     Fast time-scale vegetation update given soil data inputs.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Fast time-scale vegetation update given soil data inputs.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call update_vegetation_fast_up( veg, soil, drag_q, evap, dedq )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine update_vegetation_fast_up( veg, soil, drag_q, evap, dedq )

  type(vegetation_type), intent(inout) :: veg  ! data to update
  type(soil_type),       intent(in)    :: soil ! soil data inputs
  real, intent(in)  :: &
       drag_q (:,:,:),  &  ! drag coefficient for atmosphere (above vegetation)
       evap   (:,:,:),  &  ! evaporation from surface into the atmosphere
       dedq   (:,:,:)      ! derivative of evap over q_ca
!   </PUBLICROUTINE>

  ! -----local variables-------------------------------------------------------
  real, dimension(veg%is:veg%ie,veg%js:veg%je,veg%n_tiles) :: &
       delta_q_ca, &    ! change in the surface humidity
       delta_t_surf     ! change in surface temperature

  where (veg%mask)
     delta_t_surf  = soil%temp(:,:,:,1) - veg%t_surf
     where ( veg%bonedry )
        delta_q_ca = (veg%evap-evap)/dedq
     elsewhere
        where ( soil%stomatal > 0.0 )
           delta_q_ca = (veg%evap - evap + veg%c_surf*veg%dqsatdt*delta_t_surf) &
                /(veg%c_surf+dedq)
        elsewhere     ! bare soil or glacier (beta=1)
           delta_q_ca = (veg%beta*veg%dqsatdt*delta_t_surf+(1-veg%beta)*veg%f_q) &
                /(1-(1-veg%beta)*veg%e_q)
        endwhere
     endwhere
     veg%q_ca = veg%q_ca + delta_q_ca
 endwhere
 
end subroutine update_vegetation_fast_up
! </SUBROUTINE>


! <SUBROUTINE NAME="update_vegetation_bnd_fast">

!   <OVERVIEW>
!      Updates vegetation boundary data on the fast time-scale.
!   </OVERVIEW>

!   <DESCRIPTION>
!      Updates vegetation boundary data on the fast time-scale.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call update_vegetation_bnd_fast ( veg, bnd )
!   </TEMPLATE>

!   <PUBLICROUTINE INTERFACE="">
subroutine update_vegetation_bnd_fast ( veg, bnd )

  type(vegetation_type), intent(in)    :: veg ! vegetation data
  type(land_data_type),  intent(inout) :: bnd ! boundary data
!   </PUBLICROUTINE>

#ifdef LAND_BND_TRACERS
  bnd%tr(:,:,:,isphum) = veg%q_ca
#else
  bnd%q_ca = veg%q_ca
#endif

end subroutine update_vegetation_bnd_fast
! </SUBROUTINE>


! <SUBROUTINE NAME="update_vegetation_bnd_slow">

!   <OVERVIEW>
!      Updates vegetation boundary data on the slow time-scale.
!   </OVERVIEW>

!   <DESCRIPTION>
!      Updates vegetation boundary data on the slow time-scale.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call update_vegetation_bnd_slow ( veg, bnd )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine update_vegetation_bnd_slow ( veg, bnd )

  type(vegetation_type), intent(in)    :: veg ! vegetation data
  type(land_data_type),  intent(inout) :: bnd ! boundary data
!   </PUBLICROUTINE>

end subroutine update_vegetation_bnd_slow
! </SUBROUTINE>

subroutine vegetation_stock_pe ( veg, index, value )
  type(vegetation_type), intent(in) :: veg ! vegetation state
  integer , intent(in)  :: index ! ID of the stock to calculate
  real    , intent(out) :: value ! calculated value of the stock
  
  value = 0 ! vegetation doesn't have any capacity
end subroutine vegetation_stock_pe

end module vegetation_mod

module auscom_ice_parameters_mod

! Set parameters for ice formation/melting

implicit none

integer :: il_out
integer :: dt_cpl
logical :: pop_icediag = .true.
logical :: do_ice = .true. !determine if ice formation should be calculated!    
logical :: do_ice_once = .true. 
           !if .t. call ice_formation only once per coupling interval
           !   .f. call ice_formation every time step!   (21/07/2008)
logical :: fixmeltT = .true.
logical :: limit_srfstress = .false.  
           !.t. in case surface stress from ice is too big, upsetting the model!
           !should not be an issue after ice-ocn stress error fixed (20090311) 
logical :: use_ioaice = .true. 
           !use aice from cice to determine if ice exists
real    :: aice_cutoff = .15
           !if ioaice >= aice_cutoff then ice exists
real    :: tlthk0 = 10.0  !top layer thickness (m) (in 'IC', akward, 20100423)
integer :: kmxice = 1     !max layer that allows for ice formation	
real    :: Tmelt = -1.0   !ice melting point (C)
real    :: Mstress = 2.0  !maximum surface stress allowed into ocn.
                          !(only applys when limit_srfstress = .t.)
real    :: icemlt_factor = 1.0  !potential ice melting reduction factor
!real    :: frazil_factor = 0.5  !ocn/ice 'time-stepping' associated factor
   ! frazil_factor is associated with the difference between ocean model 
   ! and ice model time-stepping: for mom4, two-level frog-leap is used 
   ! and frazil heat flux is calculated and accumulated with 
   ! frazil_factor = 1, which is supposed to be used for a ice model with 
   ! the same two-level time-stepping scheme such as SIS. 
   ! but cice uses forward time-stepping, which means we need 'correct' 
   ! the frazil energy by multiplying 0.5 before sending to cice.
real    :: frazil_factor = 1.0  !CH: mom4 and cice use same 2-level time-steeping!!!
real    :: sign_stflx = 1.0    !if saltflux from cice needs change sign.
logical :: iceform_adj_salt = .false.   
   ! option for adjusting salinity when frazil is calculated in mom4 using POP 
   ! approach (see comment in ice_formation_new routine)
!20110802: low background_diffusivity in the equatorial zone (defined by lat_low_bgdiff) 
!real    :: lat_low_bgdiff = 10    !degrees S/N (beyond this zone set to the 'background_diffusivity') 
!real    :: bg_diff_eq = 1.0e-6    !lowest bg_diff at equator
!

!Red Sea (2 boxes)
integer :: irs1 = 314
integer :: ire1 = 324
integer :: jrs1 = 169
integer :: jre1 = 196
integer :: irs2 = 325
integer :: ire2 = 331
integer :: jrs2 = 169
integer :: jre2 = 180
!Gulf Bay (1 box)
integer :: igs = 328
integer :: ige = 345
integer :: jgs = 189
integer :: jge = 198

!maximum depth/level
integer :: ksmax = 5        !deepest level of the Red Sea/Gulf Bay 
!
integer :: sfix_hours = 12  !do s mixing every sfix_hours.
!
logical :: redsea_gulfbay_sfix = .false.
logical :: do_sfix_now = .false.
logical :: do_sfix_at_start = .false.
logical :: chk_i2o_fields = .false.
logical :: chk_o2i_fields = .false.
! How often to dump the coupling fields if either of the above options are .true.
! The unit of time is seconds. By default fields are dumped every timestep.
integer :: chk_fields_period =  1
! The time in seconds after which the field dumps should begin.
integer :: chk_fields_start_time = 0

namelist /auscom_ice_nml/  dt_cpl, &
                   tlthk0,                              & 
                   pop_icediag,                         &
                   do_ice_once,                         & 
                   kmxice,                              & 
                   fixmeltT,                            &   
                   Tmelt,                               & 
                   limit_srfstress,                     & 
                   Mstress,                             & 
                   use_ioaice,                          & 
                   aice_cutoff,                         & 
                   icemlt_factor,                       & 
                   frazil_factor,                       & 
                   iceform_adj_salt,                    & 
                   sign_stflx,                          & 
                   redsea_gulfbay_sfix,                 & 
                   irs1, ire1, jrs1, jre1,              & 
                   irs2, ire2, jrs2, jre2,              & 
                   igs, ige, jgs, jge,                  & 
                   ksmax,                               & 
                   sfix_hours,                          &
                   do_sfix_at_start,                    &
                   chk_i2o_fields,                      &
                   chk_o2i_fields,                      &
                   chk_fields_period,                   &
                   chk_fields_start_time
integer :: int_sec

!===========================================================================
end module auscom_ice_parameters_mod

module time_manager_mod

! <CONTACT EMAIL="fms@gfdl.noaa.gov">
!   fms
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!   A software package that provides a set of simple interfaces for
!   modelers to perform computations related to time and dates.
! </OVERVIEW>

! <DESCRIPTION>
!    The changes between the lima revision and this revision are more
!    extensive that all those between antwerp and lima.
!    A brief description of these changes follows.
!
!    1) Added option to set the smallest time increment to something less than one second.
!       This is controlled by calling the pubic subroutine set_ticks_per_second.
!
!    2) Gregorian calendar fixed.
!
!    3) Optional error flag added to calling arguments of public routines.
!       This allows the using routine to terminate the program. It is likely that more
!       diagnostic information is available from the user than from time_manager alone.
!       If the error flag is present then it is the responsibility of the using
!       routine to test it and add additional information to the error message.
!
!    4) Removed the restriction that time increments be positive in routines that increment or decrement
!       time and date. The option to prohibit negative increments can be turned on via optional argument.
!
!    5) subroutine set_date_c modified to handle strings that include only hours or only hours and minutes.
!       This complies with CF convensions.
!
!    6) Made calendar specific routines private.
!       They are not used, and should not be used, by any using code.
!
!    7) Error messages made more informative.
!
!    The module defines a type that can be used to represent discrete
!    times (accurate to one second) and to map these times into dates
!    using a variety of calendars. A time is mapped to a date by
!    representing the time with respect to an arbitrary base date (refer
!    to <B>NOTES</B> section for the <LINK SRC="#base date">base date</LINK> setting).
!
!    The time_manager provides a single defined type, time_type, which is
!    used to store time and date quantities. A time_type is a positive
!    definite quantity that represents an interval of time. It can be
!    most easily thought of as representing the number of seconds in some
!    time interval. A time interval can be mapped to a date under a given
!    calendar definition by using it to represent the time that has passed
!    since some base date. A number of interfaces are provided to operate
!    on time_type variables and their associated calendars. Time intervals
!    can be as large as n days where n is the largest number represented by
!    the default integer type on a compiler. This is typically considerably
!    greater than 10 million years (assuming 32 bit integer representation)
!    which is likely to be adequate for most applications. The description
!    of the interfaces is separated into two sections. The first deals with
!    operations on time intervals while the second deals with operations
!    that convert time intervals to dates for a given calendar.

!    The smallest increment of time is referred to as a tick.
!    A tick cannot be larger than 1 second, which also is the default.
!    The number of ticks per second is set via pubic subroutine set_ticks_per_second.
!    For example, ticks_per_second = 1000  will set the tick to one millisecond.
! </DESCRIPTION>

! <DATA NAME="time_type" TYPE="derived type">
!    Derived-type data variable used to store time and date quantities. It
!    contains three PRIVATE variables: days, seconds and ticks.
! </DATA>

#include <fms_platform.h>

use constants_mod, only: rseconds_per_day=>seconds_per_day
use fms_mod, only: error_mesg, FATAL, WARNING, write_version_number, stdout

implicit none
private

! Module defines a single type
public time_type

! Operators defined on time_type
public operator(+),  operator(-),   operator(*),   operator(/),  &
       operator(>),  operator(>=),  operator(==),  operator(/=), &
       operator(<),  operator(<=),  operator(//),  assignment(=)

! Subroutines and functions operating on time_type
public set_time, increment_time, decrement_time, get_time, interval_alarm
public repeat_alarm, time_type_to_real, real_to_time_type

! List of available calendar types
public    THIRTY_DAY_MONTHS,    JULIAN,    GREGORIAN,  NOLEAP,   NO_CALENDAR, INVALID_CALENDAR

! Subroutines and functions involving relations between time and calendar
public set_calendar_type
public get_calendar_type
public set_ticks_per_second
public get_ticks_per_second
public set_date
public get_date
public increment_date
public decrement_date
public days_in_month
public leap_year
public length_of_year
public days_in_year
public month_name

public valid_calendar_types

! Subroutines for printing version number and time type
public :: time_manager_init, print_time, print_date

! The following exist only for interpolator.F90
! interpolator.F90 uses them to do a calendar conversion,
! which is also done by get_cal_time. interpolator.F90
! should be modified to use get_cal_time instead.
! After interpolator.F90 is fixed, these can be removed
! and the corresponding private routines can be renamed.
! (e.g., rename set_date_julian_private to be just set_date_julian)
public :: set_date_julian, set_date_no_leap, get_date_julian, get_date_no_leap

public :: date_to_string

!====================================================================

! Global data to define calendar type
integer, parameter :: THIRTY_DAY_MONTHS = 1,      JULIAN = 2, &
                      GREGORIAN = 3,              NOLEAP = 4, &
                      NO_CALENDAR = 0,  INVALID_CALENDAR =-1
integer, private :: calendar_type = NO_CALENDAR
integer, parameter :: max_type = 4

! Define number of days per month
integer, private :: days_per_month(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)
integer, parameter :: seconds_per_day = rseconds_per_day  ! This should automatically cast real to integer
integer, parameter :: days_in_400_year_period = 146097    ! Used only for gregorian
integer, dimension(days_in_400_year_period) :: coded_date ! Used only for gregorian
integer, dimension(400,12,31) :: date_to_day              ! Used only for gregorian
integer, parameter :: invalid_date=-1                     ! Used only for gregorian

! time_type is implemented as seconds and days to allow for larger intervals
type time_type
   private
   integer:: seconds
   integer:: days
   integer:: ticks
   integer:: dummy ! added as a workaround bug on IRIX64 (AP)
end type time_type

!======================================================================

interface operator (+);   module procedure time_plus;        end interface
interface operator (-);   module procedure time_minus;       end interface
interface operator (*);   module procedure time_scalar_mult 
                          module procedure scalar_time_mult; end interface
interface operator (/);   module procedure time_scalar_divide
                          module procedure time_divide;      end interface
interface operator (>);   module procedure time_gt;          end interface
interface operator (>=);  module procedure time_ge;          end interface
interface operator (<);   module procedure time_lt;          end interface
interface operator (<=);  module procedure time_le;          end interface
interface operator (==);  module procedure time_eq;          end interface
interface operator (/=);  module procedure time_ne;          end interface
interface operator (//);  module procedure time_real_divide; end interface
interface assignment(=);  module procedure time_assignment;  end interface

!======================================================================

interface set_time
  module procedure set_time_i, set_time_c
end interface

interface set_date
  module procedure set_date_i, set_date_c
end interface

!======================================================================

character(len=128) :: version='$Id$'
character(len=128) :: tagname='$Name$'
logical :: module_is_initialized = .false.

!======================================================================

!  A tick is the smallest increment of time.
!  That is, smallest increment of time = (1/ticks_per_second) seconds

integer :: ticks_per_second = 1

!======================================================================
contains

! First define all operations on time intervals independent of calendar

!=========================================================================
! <FUNCTION NAME="set_time">

!   <OVERVIEW>
!     Given some number of seconds and days, returns the
!     corresponding time_type.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Given some number of seconds and days, returns the
!     corresponding time_type. set_time has two forms;
!     one accepts integer input, the other a character string.
!     For the first form, there are no restrictions on the range of the inputs,
!     except that the result must be positive time.
!     e.g. days=-1, seconds=86401 is acceptable.
!     For the second form, days and seconds must both be positive.
!   </DESCRIPTION>
!   <TEMPLATE>
!     1. set_time(seconds, days, ticks, err_msg)
!   </TEMPLATE>
!   <TEMPLATE>
!     2. set_time(time_string, err_msg, allow_rounding)
!   </TEMPLATE>

!   <IN NAME="seconds" UNITS="" TYPE="integer" DIM="(scalar)">
!     A number of seconds.
!   </IN>
!   <IN NAME="days" UNITS="" TYPE="integer" DIM="(scalar)">
!     A number of days.
!   </IN>
!   <IN NAME="ticks" UNITS="" TYPE="integer, optional" DIM="(scalar)">
!     A number of ticks.
!   </IN>
!   <OUT NAME="err_msg" TYPE="character, optional" DIM="(scalar)">
!     When present, and when non-blank, a fatal error condition as been detected.
!     The string itself is an error message.
!     It is recommended that, when err_msg is present in the call
!     to this routine, the next line of code should be something
!     similar to this:
!     if(err_msg /= '') call error_mesg('my_routine','additional info: '//trim(err_msg),FATAL)
!   </OUT>
!   <IN NAME="time_string" TYPE="character">
!     Contains days and seconds separated by a single blank.
!     days must be integer, seconds may be integer or real.
!     Examples: '100 43200'  '100 43200.50'
!   </IN>
!   <IN NAME="allow_rounding"   TYPE="logical, optional" DEFAULT=".true.">
!     When .true., any fractions of a second will be rounded off to the nearest tick.
!     When .false., it is a fatal error if the second fraction cannot be exactly
!     represented by a number of ticks.
!   </IN>
!   <OUT NAME="set_time" UNITS="" TYPE="" DIM="" DEFAULT="">
!     A time interval corresponding to this number of days and seconds.
!   </OUT>

 function set_time_private(seconds, days, ticks, Time_out, err_msg)

! Returns a time interval corresponding to this number of days, seconds, and ticks.
! days, seconds and ticks may be negative, but resulting time must be positive.

! -- pjp --
! To understand why inputs may be negative,
! one needs to understand the intrinsic function "modulo".
! The expanation below is copied from a web page on fortran 90

! In addition, CEILING, FLOOR  and MODULO  have been added to Fortran 90.
! Only the last one is difficult to explain, which is most easily done with the examples from ISO (1991)

! MOD (8,5)    gives  3     MODULO (8,5)    gives  3
! MOD (-8,5)   gives -3     MODULO (-8,5)   gives  2
! MOD (8,-5)   gives  3     MODULO (8,-5)   gives -2
! MOD (-8,-5)  gives -3     MODULO (-8,-5)  gives -3

! I don't think it is difficult to explain.
! I think that is it sufficient to say this:
! "The result of modulo(n,m) has the sign of m"
! -- pjp --

 logical                       :: set_time_private
 integer, intent(in)           :: seconds, days, ticks
 type(time_type),  intent(out) :: Time_out
 character(len=*), intent(out) :: err_msg
 integer            :: seconds_new, days_new, ticks_new

 seconds_new = seconds + floor(ticks/real(ticks_per_second))
 ticks_new = modulo(ticks,ticks_per_second)
 days_new = days + floor(seconds_new/real(seconds_per_day))
 seconds_new = modulo(seconds_new,seconds_per_day)

 if ( seconds_new < 0 .or. ticks_new < 0) then
   call error_mesg('function set_time_i','Bad result for time. Contact those responsible for maintaining time_manager',FATAL)
 endif

 if(days_new < 0) then
   write(err_msg,'(a,i6,a,i6,a,i6)') 'time is negative. days=',days_new,' seconds=',seconds_new,' ticks=',ticks_new
   set_time_private = .false.
 else
   Time_out%days = days_new
   Time_out%seconds = seconds_new
   Time_out%ticks = ticks_new
   err_msg = ''
   set_time_private = .true.
 endif

 end function set_time_private
!---------------------------------------------------------------------------

 function set_time_i(seconds, days, ticks, err_msg)
 type(time_type)               :: set_time_i
 integer, intent(in)           :: seconds
 integer, intent(in), optional :: days, ticks
 character(len=*), intent(out), optional :: err_msg
 character(len=128) :: err_msg_local
 integer            :: odays, oticks

 if(.not.module_is_initialized) call time_manager_init

 odays  = 0; if(present(days))  odays  = days
 oticks = 0; if(present(ticks)) oticks = ticks
 if(present(err_msg)) err_msg = ''
 
 if(.not.set_time_private(seconds, odays, oticks, set_time_i, err_msg_local)) then
   if(error_handler('function set_time_i', trim(err_msg_local), err_msg)) return
 endif

 end function set_time_i
!---------------------------------------------------------------------------

 function set_time_c(string, err_msg, allow_rounding)

 type(time_type) :: set_time_c
 character(len=*), intent(in) :: string
 character(len=*), intent(out), optional :: err_msg
 logical, intent(in), optional :: allow_rounding

 character(len=4) :: formt='(i )'
 integer :: i1, i2, i3, day, second, tick, nsps
 character(len=32) :: string_sifted_left
 character(len=128) :: err_msg_local
 logical :: allow_rounding_local

 if(.not.module_is_initialized) call time_manager_init
 if(present(err_msg)) err_msg = ''
 allow_rounding_local=.true.; if(present(allow_rounding)) allow_rounding_local=allow_rounding

 err_msg_local = 'Form of character time stamp is incorrect. The character time stamp is: '//trim(string)

 string_sifted_left = adjustl(string)
 i1 = index(trim(string_sifted_left),' ')
 if(i1 == 0) then
   if(error_handler('function set_time_c', err_msg_local, err_msg)) return
 endif
 if(index(string,'-') /= 0 .or. index(string,':') /= 0) then
   if(error_handler('function set_time_c', err_msg_local, err_msg)) return
 endif

 i2 = index(trim(string_sifted_left),'.')
 i3 = len_trim(cut0(string_sifted_left))

 if(i2 /= 0) then ! There is no decimal point
 ! Check that decimal is on seconds (not days)
   if(i2 < i1) then
     if(error_handler('function set_time_c', err_msg_local, err_msg)) return
   endif
 endif
 write(formt(3:3),'(i1)') i1-1
 read(string_sifted_left(1:i1-1),formt) day

 if(i2 == 0) then ! There is no decimal point
   write(formt(3:3),'(i1)') i3-i1
   read(string_sifted_left(i1+1:i3),formt) second
   tick = 0
 else ! There is a decimal point
 ! nsps = spaces occupied by whole number of seconds
   nsps = i2-i1-1
   if(nsps == 0) then
     second = 0
   else
     write(formt(3:3),'(i1)') nsps
     read(string_sifted_left(i1+1:i2-1),formt) second
   endif

   if(.not.get_tick_from_string(string_sifted_left(i2:i3), err_msg_local, allow_rounding_local, tick)) then
     if(error_handler('function set_time_c', err_msg_local, err_msg)) return
   endif
 ! If tick has been rounded up to ticks_per_second, then bump up second.
   if(tick == ticks_per_second) then
     second = second + 1
     tick = 0
   endif
 endif

 if(.not.set_time_private(second, day, tick, set_time_c, err_msg_local)) then
   if(error_handler('function set_time_c', err_msg_local, err_msg)) return
 endif

 end function set_time_c
!---------------------------------------------------------------------------
! </FUNCTION>

 function get_tick_from_string(string, err_msg, allow_rounding, tick)

 logical :: get_tick_from_string
 character(len=*), intent(in) :: string
 character(len=*), intent(out) :: err_msg
 logical, intent(in) :: allow_rounding
 integer, intent(out) :: tick

 character(len=4) :: formt='(i )'
 integer :: i3, nspf, fraction, magnitude, tpsfrac

 err_msg = ''
 get_tick_from_string = .true.
 i3 = len_trim(string)
 nspf = i3 - 1 ! nspf = spaces occupied by fractional seconds, excluding decimal point
 if(nspf == 0) then
   tick = 0 ! Nothing to the right of the decimal point
 else
   write(formt(3:3),'(i1)') nspf
   read(string(2:i3),formt) fraction
   if(fraction == 0) then
     tick = 0 ! All zeros to the right of the decimal point
   else
     magnitude = 10**nspf
     tpsfrac = ticks_per_second*fraction
     if(allow_rounding) then
       tick = nint((real(tpsfrac)/magnitude))
     else 
       if(modulo(tpsfrac,magnitude) == 0) then
         tick = tpsfrac/magnitude
       else
         write(err_msg,'(a,i6)') 'Second fraction cannot be exactly represented with ticks.  '// &
                                 'fraction='//trim(string)//'  ticks_per_second=',ticks_per_second 
         get_tick_from_string = .false.
       endif
     endif 
   endif
 endif

 end function get_tick_from_string
!---------------------------------------------------------------------------
! <SUBROUTINE NAME="get_time">

!   <OVERVIEW>
!     Given a time interval, returns the corresponding seconds and days.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Given a time interval, returns the corresponding seconds and days.
!   </DESCRIPTION>
!   <TEMPLATE>
!     get_time(time, seconds, days, ticks, err_msg)
!   </TEMPLATE>

!   <IN NAME="time" TYPE="time_type">
!     A time interval. 
!   </IN>
!   <OUT NAME="seconds" UNITS="" TYPE="integer" DIM="(scalar)">
!     A number of seconds.
!   </OUT>
!   <OUT NAME="days" UNITS="" TYPE="integer" DIM="(scalar)">
!     A number of days.
!   </OUT>
!   <OUT NAME="ticks" UNITS="" TYPE="integer, optional" DIM="(scalar)">
!     A number of ticks.
!   </OUT>
!   <OUT NAME="err_msg" TYPE="character, optional" DIM="(scalar)">
!     When present, and when non-blank, a fatal error condition as been detected.
!     The string itself is an error message.
!     It is recommended that, when err_msg is present in the call
!     to this routine, the next line of code should be something
!     similar to this:
!     if(err_msg /= '') call error_mesg('my_routine','additional info: '//trim(err_msg),FATAL)
!   </OUT>

subroutine get_time(Time, seconds, days, ticks, err_msg)

! Returns days and seconds ( < 86400 ) corresponding to a time.

type(time_type), intent(in) :: Time
integer, intent(out) :: seconds
integer, intent(out), optional :: days, ticks
character(len=*), intent(out), optional :: err_msg
character(len=128) :: err_msg_local

if(.not.module_is_initialized) call time_manager_init
if(present(err_msg)) err_msg = ''

seconds = Time%seconds

if(present(ticks)) then
  ticks = Time%ticks
else
  if(Time%ticks /= 0) then
    err_msg_local = 'subroutine get_time: ticks must be present when time has a second fraction'
    if(error_handler('subroutine get_time', err_msg_local, err_msg)) return
  endif
endif

if (present(days)) then
  days = Time%days
else
  if (Time%days > (huge(seconds) - seconds)/seconds_per_day) then
    err_msg_local = 'Integer overflow in seconds. Optional argument days must be present.'
    if(error_handler('subroutine get_time', err_msg_local, err_msg)) return
  endif
  seconds = seconds + Time%days * seconds_per_day
endif

end subroutine get_time
! </SUBROUTINE>

!-------------------------------------------------------------------------
! <FUNCTION NAME="increment_time">

!   <OVERVIEW>
!      Given a time and an increment of days and seconds, returns
!      a time that adds this increment to an input time.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Given a time and an increment of days and seconds, returns
!      a time that adds this increment to an input time.
!      Increments a time by seconds and days.
!   </DESCRIPTION>
!   <TEMPLATE>
!     increment_time(time, seconds, days, ticks, err_msg, allow_neg_inc)
!   </TEMPLATE>

!   <IN NAME="time"  TYPE="time_type" DIM="(scalar)">
!      A time interval.
!   </IN>
!   <IN NAME="seconds"  TYPE="integer" DIM="(scalar)">
!     Increment of seconds.
!   </IN>
!   <IN NAME="days" UNITS="" TYPE="integer, optional" DIM="(scalar)">
!     Increment of days.
!   </IN>
!   <IN NAME="ticks"  TYPE="integer, optional" DIM="(scalar)">
!     Increment of ticks.
!   </IN>
!   <OUT NAME="increment_time"  TYPE="time_type" DIM="(scalar)">
!     A time that adds this increment to the input time.
!     A negative result is a fatal error.
!   </OUT>
!   <OUT NAME="err_msg" TYPE="character, optional" DIM="(scalar)">
!     When present, and when non-blank, a fatal error condition as been detected.
!     The string itself is an error message.
!     It is recommended that, when err_msg is present in the call
!     to this routine, the next line of code should be something
!     similar to this:
!     if(err_msg /= '') call error_mesg('my_routine','additional info: '//trim(err_msg),FATAL)
!   </OUT>
!   <IN NAME="allow_neg_inc" TYPE="logical, optional" DIM="(scalar)" DEFAULT=".true.">
!     When .false., it is a fatal error if any of the input time increments are negative.
!     This mimics the behavior of lima and earlier revisions.
!   </IN>

 function increment_time(Time, seconds, days, ticks, err_msg, allow_neg_inc)

! Increments a time by seconds, days and ticks.

 type(time_type)               :: increment_time
 type(time_type), intent(in)   :: Time
 integer, intent(in)           :: seconds
 integer, intent(in), optional :: days, ticks
 character(len=*), intent(out), optional :: err_msg
 logical, intent(in), optional :: allow_neg_inc

 integer :: odays, oticks
 character(len=128) :: err_msg_local
 logical :: allow_neg_inc_local

 odays  = 0; if(present(days))  odays  = days
 oticks = 0; if(present(ticks)) oticks = ticks
 allow_neg_inc_local=.true.; if(present(allow_neg_inc)) allow_neg_inc_local=allow_neg_inc

 if(.not.allow_neg_inc_local) then
   if(seconds < 0 .or. odays < 0 .or. oticks < 0) then
     write(err_msg_local,10) seconds, odays, oticks
     10 format('One or more time increments are negative: seconds=',i6,'  days=',i6,'  ticks=',i6)
     if(error_handler('function increment_time', err_msg_local, err_msg)) return
   endif
 endif

 if(.not.increment_time_private(Time, seconds, odays, oticks, increment_time, err_msg_local)) then
   if(error_handler('function increment_time', err_msg_local, err_msg)) return
 endif

 end function increment_time
! </FUNCTION>
!--------------------------------------------------------------------------

 function increment_time_private(Time_in, seconds, days, ticks, Time_out, err_msg)

! Increments a time by seconds, days and ticks.

 logical                       :: increment_time_private
 type(time_type),  intent(in)  :: Time_in
 integer,          intent(in)  :: seconds, days, ticks
 type(time_type),  intent(out) :: Time_out
 character(len=*), intent(out) :: err_msg

! Watch for immediate overflow on days or seconds
 if(days >= huge(days) - Time_in%days)  then
   err_msg = 'Integer overflow in days in increment_time'
   increment_time_private = .false.
   return
 endif
 if(seconds >= huge(seconds) - Time_in%seconds) then
   err_msg = 'Integer overflow in seconds in increment_time'
   increment_time_private = .false.
   return
 endif

 increment_time_private = set_time_private(Time_in%seconds+seconds, Time_in%days+days, Time_in%ticks+ticks, Time_out, err_msg)

 end function increment_time_private

!--------------------------------------------------------------------------
! <FUNCTION NAME="decrement_time">

!   <OVERVIEW>
!      Given a time and a decrement of days and seconds, returns
!      a time that subtracts this decrement from an input time. 
!   </OVERVIEW>
!   <DESCRIPTION>
!      Decrements a time by seconds and days.
!   </DESCRIPTION>
!   <TEMPLATE>
!     Decrement_time(time, seconds, days, ticks, err_msg, allow_neg_inc)
!   </TEMPLATE>

!   <IN NAME="time"  TYPE="time_type" DIM="(scalar)">
!      A time interval.
!   </IN>
!   <IN NAME="seconds"  TYPE="integer" DIM="(scalar)">
!     Decrement of seconds.
!   </IN>    
!   <IN NAME="days"  TYPE="integer, optional" DIM="(scalar)">
!     Decrement of days.
!   </IN>
!   <IN NAME="ticks"  TYPE="integer, optional" DIM="(scalar)">
!     Decrement of ticks.
!   </IN>
!   <OUT NAME="decrement_time"  TYPE="time_type">
!      A time that subtracts this decrement from an input time.
!      A negative result is a fatal error.
!   </OUT>
!   <OUT NAME="err_msg" TYPE="character, optional" DIM="(scalar)">
!     When present, and when non-blank, a fatal error condition as been detected.
!     The string itself is an error message.
!     It is recommended that, when err_msg is present in the call
!     to this routine, the next line of code should be something
!     similar to this:
!     if(err_msg /= '') call error_mesg('my_routine','additional info: '//trim(err_msg),FATAL)
!   </OUT>
!   <IN NAME="allow_neg_inc" TYPE="logical, optional" DIM="(scalar)" DEFAULT=".true.">
!     When .false., it is a fatal error if any of the input time increments are negative.
!     This mimics the behavior of lima and earlier revisions.
!   </IN>

function decrement_time(Time, seconds, days, ticks, err_msg, allow_neg_inc)

! Decrements a time by seconds, days and ticks.

type(time_type)               :: decrement_time
type(time_type), intent(in)   :: Time
integer, intent(in)           :: seconds
integer, intent(in), optional :: days, ticks
character(len=*), intent(out), optional :: err_msg
logical, intent(in), optional :: allow_neg_inc

integer            :: odays, oticks
character(len=128) :: err_msg_local
logical :: allow_neg_inc_local

odays  = 0;  if (present(days))   odays = days
oticks = 0;  if (present(ticks)) oticks = ticks
allow_neg_inc_local=.true.; if(present(allow_neg_inc)) allow_neg_inc_local=allow_neg_inc

if(.not.allow_neg_inc_local) then
  if(seconds < 0 .or. odays < 0 .or. oticks < 0) then
    write(err_msg_local,10) seconds,odays,oticks
    10 format('One or more time increments are negative: seconds=',i6,'  days=',i6,'  ticks=',i6)
    if(error_handler('function decrement_time', err_msg_local, err_msg)) return
  endif
endif

 if(.not.increment_time_private(Time, -seconds, -odays, -oticks, decrement_time, err_msg_local)) then
   if(error_handler('function decrement_time', err_msg_local, err_msg)) return
 endif

end function decrement_time
! </FUNCTION>

!--------------------------------------------------------------------------
! <FUNCTION NAME="time_gt  operator(>)">

!   <OVERVIEW>
!      Returns true if time1 > time2.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Returns true if time1 > time2.
!   </DESCRIPTION>
!   <IN NAME="time1" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <IN NAME="time2" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <OUT NAME="" UNITS="" TYPE="logical" DIM="" DEFAULT="">
!       Returns true if time1 > time2
!   </OUT>
!   <TEMPLATE>
!     time_gt(time1, time2)
!   </TEMPLATE>

function time_gt(time1, time2)

! Returns true if time1 > time2

logical :: time_gt
type(time_type), intent(in) :: time1, time2

time_gt = (time1%days > time2%days)
if(time1%days == time2%days) then
   if(time1%seconds == time2%seconds) then
      time_gt = (time1%ticks > time2%ticks)
   else
      time_gt = (time1%seconds > time2%seconds)
   endif
endif

end function time_gt
! </FUNCTION>

!--------------------------------------------------------------------------
! <FUNCTION NAME="time_ge; operator(>=)">

!   <OVERVIEW>
!      Returns true if time1 >= time2.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Returns true if time1 >= time2.
!   </DESCRIPTION>
!   <TEMPLATE>
!     time_ge(time1, time2)
!   </TEMPLATE>

!   <IN NAME="time1" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <IN NAME="time2" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <OUT NAME="" UNITS="" TYPE="logical" DIM="" DEFAULT="">
!       Returns true if time1 >= time2
!   </OUT>

function time_ge(time1, time2)

! Returns true if time1 >= time2

logical :: time_ge
type(time_type), intent(in) :: time1, time2

time_ge = (time_gt(time1, time2) .or. time_eq(time1, time2))

end function time_ge
! </FUNCTION>

!--------------------------------------------------------------------------
! <FUNCTION NAME="time_lt; operator(<)">

!   <OVERVIEW>
!      Returns true if time1 < time2.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Returns true if time1 < time2.
!   </DESCRIPTION>
!   <TEMPLATE>
!     time_lt(time1, time2)
!   </TEMPLATE>

!   <IN NAME="time1" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <IN NAME="time2" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <OUT NAME="" UNITS="" TYPE="logical" DIM="" DEFAULT="">
!       Returns true if time1 < time2
!   </OUT>

function time_lt(time1, time2)

! Returns true if time1 < time2

logical :: time_lt
type(time_type), intent(in) :: time1, time2

time_lt = (time1%days < time2%days)
if(time1%days == time2%days)then
   if(time1%seconds == time2%seconds) then
      time_lt = (time1%ticks < time2%ticks)
   else
      time_lt = (time1%seconds < time2%seconds)
   endif
endif
end function time_lt
! </FUNCTION>

!--------------------------------------------------------------------------
! <FUNCTION NAME="time_le; operator(<=)">

!   <OVERVIEW>
!      Returns true if time1 <= time2.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Returns true if time1 <= time2.
!   </DESCRIPTION>
!   <TEMPLATE>
!     time_le(time1, time2)
!   </TEMPLATE>

!   <IN NAME="time1" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <IN NAME="time2" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <OUT NAME="" UNITS="" TYPE="logical" DIM="" DEFAULT="">
!       Returns true if time1 <= time2
!   </OUT>

function time_le(time1, time2)

! Returns true if time1 <= time2

logical :: time_le
type(time_type), intent(in) :: time1, time2

time_le = (time_lt(time1, time2) .or. time_eq(time1, time2))

end function time_le
! </FUNCTION>

!--------------------------------------------------------------------------
! <FUNCTION NAME="time_eq; operator(==)">

!   <OVERVIEW>
!      Returns true if time1 == time2.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Returns true if time1 == time2.
!   </DESCRIPTION>
!   <TEMPLATE>
!     time_eq(time1, time2)
!   </TEMPLATE>

!   <IN NAME="time1" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <IN NAME="time2" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <OUT NAME="" UNITS="" TYPE="logical" DIM="" DEFAULT="">
!       Returns true if time1 == time2
!   </OUT>

function time_eq(time1, time2)

! Returns true if time1 == time2

logical :: time_eq
type(time_type), intent(in) :: time1, time2

if(.not.module_is_initialized) call time_manager_init

time_eq = (time1%seconds == time2%seconds .and. time1%days == time2%days &
     .and. time1%ticks == time2%ticks)

end function time_eq
! </FUNCTION>

!--------------------------------------------------------------------------
! <FUNCTION NAME="time_ne; operator(/=)">

!   <OVERVIEW>
!      Returns true if time1 /= time2.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Returns true if time1 /= time2.
!   </DESCRIPTION>
!   <TEMPLATE>
!     time_ne(time1, time2)
!   </TEMPLATE>

!   <IN NAME="time1" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <IN NAME="time2" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <OUT NAME="" UNITS="" TYPE="logical" DIM="" DEFAULT="">
!       Returns true if time1 /= time2
!   </OUT>

function time_ne(time1, time2)

! Returns true if time1 /= time2

logical :: time_ne
type(time_type), intent(in) :: time1, time2

time_ne = (.not. time_eq(time1, time2))

end function time_ne
! </FUNCTION>

!-------------------------------------------------------------------------
! <FUNCTION NAME="time_plus; operator(+)">

!   <OVERVIEW>
!       Returns sum of two time_types.
!   </OVERVIEW>
!   <TEMPLATE>
!     time1 + time2
!   </TEMPLATE>
!   <DESCRIPTION>
!       Returns sum of two time_types.
!   </DESCRIPTION>

!   <IN NAME="time1" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <IN NAME="time2" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <OUT NAME="" UNITS="" TYPE="time_type" DIM="" DEFAULT="">
!       Returns sum of two time_types.
!   </OUT>

function time_plus(time1, time2)

! Returns sum of two time_types

type(time_type) :: time_plus
type(time_type), intent(in) :: time1, time2

if(.not.module_is_initialized) call time_manager_init

time_plus = increment_time(time1, time2%seconds, time2%days, time2%ticks)

end function time_plus
! </FUNCTION>

!-------------------------------------------------------------------------
! <FUNCTION NAME="time_minus; operator(-)">

!   <OVERVIEW>
!       Returns difference of two time_types.
!   </OVERVIEW>
!   <DESCRIPTION>
!       Returns difference of two time_types. WARNING: a time type is positive 
!       so by definition time1 - time2  is the same as time2 - time1.
!   </DESCRIPTION>
!   <TEMPLATE>
!     time_minus(time1, time2)
!   </TEMPLATE>
!   <TEMPLATE>
!     time1 - time2
!   </TEMPLATE>

!   <IN NAME="time1" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <IN NAME="time2" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <OUT NAME="" UNITS="" TYPE="time_type" DIM="" DEFAULT="">
!       Returns difference of two time_types.
!   </OUT>

function time_minus(time1, time2)

! Returns difference of two time_types. WARNING: a time type is positive 
! so by definition time1 - time2  is the same as time2 - time1.

type(time_type) :: time_minus
type(time_type), intent(in) :: time1, time2

if(.not.module_is_initialized) call time_manager_init

if(time1 > time2) then
   time_minus = decrement_time(time1, time2%seconds, time2%days, time2%ticks)
else 
   time_minus = decrement_time(time2, time1%seconds, time1%days, time1%ticks)
endif

end function time_minus
! </FUNCTION>

!--------------------------------------------------------------------------
! <FUNCTION NAME="time_scalar_mult; operator(*)">

!   <OVERVIEW>
!       Returns time multiplied by integer factor n.
!   </OVERVIEW>
!   <DESCRIPTION>
!       Returns time multiplied by integer factor n.
!   </DESCRIPTION>
!   <TEMPLATE>
!     time_scalar_mult(time, n)
!   </TEMPLATE>

!   <IN NAME="time" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <IN NAME="n" UNITS="" TYPE="integer" DIM="">
!      A time interval.
!   </IN>
!   <OUT NAME="" UNITS="" TYPE="time_type" DIM="" DEFAULT="">
!       Returns time multiplied by integer factor n.
!   </OUT>

function time_scalar_mult(time, n)

! Returns time multiplied by integer factor n

type(time_type)             :: time_scalar_mult
type(time_type), intent(in) :: time
integer, intent(in)         :: n
integer                     :: days, seconds, ticks, num_sec
double precision            :: sec_prod, tick_prod

if(.not.module_is_initialized) call time_manager_init

! Multiplying here in a reasonable fashion to avoid overflow is tricky
! Could multiply by some large factor n, and seconds could be up to 86399
! Need to avoid overflowing integers and wrapping around to negatives
! ticks could be up to ticks_per_second-1

tick_prod = dble(time%ticks) * dble(n)
num_sec   = tick_prod/dble(ticks_per_second)
sec_prod  = dble(time%seconds) * dble(n) + num_sec
ticks     = tick_prod - num_sec * ticks_per_second

! If sec_prod is large compared to precision of double precision, things
! can go bad.  Need to warn and abort on this.
! The same is true of tick_prod but is is more likely to happen to sec_prod,
! so let's just test sec_prod. (A test of tick_prod would be necessary only
! if ticks_per_second were greater than seconds_per_day)
if(sec_prod /= 0.0) then
   if(log10(sec_prod) > precision(sec_prod) - 3) call error_mesg('time_scalar_mult', &
      'Insufficient precision to handle scalar product in time_scalar_mult; contact developer',FATAL)
end if

days = sec_prod / dble(seconds_per_day)
seconds = sec_prod - dble(days) * dble(seconds_per_day)

time_scalar_mult = set_time(seconds, time%days * n + days, ticks)

end function time_scalar_mult
! </FUNCTION>

!-------------------------------------------------------------------------
! <FUNCTION NAME="scalar_time_mult; operator(*)">

!   <OVERVIEW>
!       Returns time multiplied by integer factor n.
!   </OVERVIEW>
!   <DESCRIPTION>
!       Returns time multiplied by integer factor n.
!   </DESCRIPTION>
!   <TEMPLATE>
!     n * time
!     scalar_time_mult(n, time)
!   </TEMPLATE>

!   <IN NAME="time" UNITS="" TYPE="time_type" DIM="">A time interval.</IN>
!   <IN NAME="n" UNITS="" TYPE="integer" DIM=""> An integer. </IN>
!   <OUT NAME="" UNITS="" TYPE="time_type" DIM="" DEFAULT="">
!       Returns time multiplied by integer factor n.
!   </OUT>

function scalar_time_mult(n, time)

! Returns time multipled by integer factor n

type(time_type) :: scalar_time_mult
type(time_type), intent(in) :: time
integer, intent(in) :: n

scalar_time_mult = time_scalar_mult(time, n)

end function scalar_time_mult
! </FUNCTION>

!-------------------------------------------------------------------------
! <FUNCTION NAME="time_divide; operator(/)">

!   <OVERVIEW>
!       Returns the largest integer, n, for which time1 >= time2 * n.
!   </OVERVIEW>
!   <DESCRIPTION>
!       Returns the largest integer, n, for which time1 >= time2 * n.
!   </DESCRIPTION>
!   <TEMPLATE>
!     n = time1 / time2
!     time_divide(time1, time2)
!   </TEMPLATE>

!   <IN NAME="time1" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <IN NAME="time2" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <OUT NAME="" UNITS="" TYPE="integer" DIM="" DEFAULT="">
!       Returns the largest integer, n, for which time1 >= time2 * n.
!   </OUT>

function time_divide(time1, time2)

! Returns the largest integer, n, for which time1 >= time2 * n.

integer                     :: time_divide
type(time_type), intent(in) :: time1, time2
double precision            :: d1, d2

if(.not.module_is_initialized) call time_manager_init

! Convert time intervals to floating point days; risky for general performance?
d1 = time1%days * dble(seconds_per_day) + dble(time1%seconds) + time1%ticks/dble(ticks_per_second)
d2 = time2%days * dble(seconds_per_day) + dble(time2%seconds) + time2%ticks/dble(ticks_per_second)

! Get integer quotient of this, check carefully to avoid round-off problems.
time_divide = d1 / d2

! Verify time_divide*time2 is <= time1 and (time_divide + 1)*time2 is > time1
if(time_divide * time2 > time1 .or. (time_divide + 1) * time2 <= time1) &
   call error_mesg('time_divide',' quotient error :: notify developer',FATAL)

end function time_divide
! </FUNCTION>

!-------------------------------------------------------------------------
! <FUNCTION NAME="time_real_divide; operator(//)">

!   <OVERVIEW>
!       Returns the double precision quotient of two times.
!   </OVERVIEW>
!   <DESCRIPTION>
!       Returns the double precision quotient of two times.
!   </DESCRIPTION>
!   <TEMPLATE>
!     time1 // time2
!     time_real_divide(time1, time2)
!   </TEMPLATE>

!   <IN NAME="time1" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <IN NAME="time2" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <OUT NAME="" UNITS="" TYPE="integer" DIM="double precision" DEFAULT="">
!       Returns the double precision quotient of two times
!   </OUT>

function time_real_divide(time1, time2)

! Returns the double precision quotient of two times

double precision :: time_real_divide
type(time_type), intent(in) :: time1, time2
double precision :: d1, d2

if(.not.module_is_initialized) call time_manager_init

! Convert time intervals to floating point seconds; risky for general performance?
d1 = time1%days * dble(seconds_per_day) + dble(time1%seconds) + dble(time1%ticks)/dble(ticks_per_second)
d2 = time2%days * dble(seconds_per_day) + dble(time2%seconds) + dble(time2%ticks)/dble(ticks_per_second)

time_real_divide = d1 / d2

end function time_real_divide
! </FUNCTION>

!-------------------------------------------------------------------------
! <SUBROUTINE NAME="time_assignment; assignment(=)">

!   <OVERVIEW>
!       Assigns all components of the time_type variable on
!       RHS to same components of time_type variable on LHS.
!   </OVERVIEW>
!   <DESCRIPTION>         
!       Assigns all components of the time_type variable on
!       RHS to same components of time_type variable on LHS.
!   </DESCRIPTION> 
!   <TEMPLATE>
!     time1 = time2
!   </TEMPLATE>

!   <OUT NAME="time1" UNITS="" TYPE="time_type" DIM="">
!      A time type variable.
!   </OUT>
!   <IN NAME="time2" UNITS="" TYPE="time_type" DIM="">
!      A time type variable.
!   </IN>

subroutine time_assignment(time1, time2)
type(time_type), intent(out) :: time1
type(time_type), intent(in)  :: time2
   time1%seconds = time2%seconds
   time1%days    = time2%days
   time1%ticks   = time2%ticks
end subroutine time_assignment
! </SUBROUTINE>

!-------------------------------------------------------------------------
! <FUNCTION NAME="time_type_to_real">
!   <OVERVIEW>
!       Converts time to seconds and returns it as a real number
!   </OVERVIEW>
!   <DESCRIPTION>
!       Converts time to seconds and returns it as a real number
!   </DESCRIPTION>
!   <TEMPLATE>
!     time_type_to_real(time)
!   </TEMPLATE>
!   <IN NAME="time" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>

function time_type_to_real(time)

real(DOUBLE_KIND)           :: time_type_to_real
type(time_type), intent(in) :: time

if(.not.module_is_initialized) call time_manager_init

time_type_to_real = dble(time%days) * 86400.d0 + dble(time%seconds) + &
     dble(time%ticks)/dble(ticks_per_second)

end function time_type_to_real
! </FUNCTION>

!-------------------------------------------------------------------------
! <FUNCTION NAME="real_to_time_type">
!   <OVERVIEW>
!       Converts a real number of seconds to a time_type variable
!   </OVERVIEW>
!   <DESCRIPTION>
!       Converts a real number of seconds to a time_type variable
!   </DESCRIPTION>
!   <TEMPLATE>
!     real_to_time_type(x, err_msg)
!   </TEMPLATE>
!   <IN NAME="x" UNITS="" TYPE="real" DIM="">
!      A real number of seconds
!   </IN>
!   <OUT NAME="err_msg" TYPE="character, optional" DIM="(scalar)">
!     When present, and when non-blank, a fatal error condition as been detected.
!     The string itself is an error message.
!     It is recommended that, when err_msg is present in the call
!     to this routine, the next line of code should be something
!     similar to this:
!     if(err_msg /= '') call error_mesg('my_routine','additional info: '//trim(err_msg),FATAL)
!   </OUT>
!   <OUT NAME="real_to_time_type"  TYPE="time_type">
!   </OUT>

 function real_to_time_type(x, err_msg)
 type(time_type)  :: real_to_time_type
 real, intent(in) :: x
 character(len=*), intent(out), optional :: err_msg
 integer          :: seconds, days, ticks
 real             :: real_ticks
 character(len=128) :: err_msg_local

 if(.not.module_is_initialized) call time_manager_init

 days = floor(x/86400.)
 seconds = int(x - 86400.*days)
 real_ticks = x - int(x)
 ticks = nint(real_ticks * ticks_per_second)
 if(.not.set_time_private(seconds, days, ticks, real_to_time_type, err_msg_local)) then
   if(error_handler('function real_to_time_type', err_msg_local, err_msg)) return
 endif

 end function real_to_time_type
! </FUNCTION>

!-------------------------------------------------------------------------
! <FUNCTION NAME="time_scalar_divide; operator(/)">

!   <OVERVIEW>
!       Returns the largest time, t, for which n * t <= time.
!   </OVERVIEW>
!   <DESCRIPTION>
!       Returns the largest time, t, for which n * t <= time.
!   </DESCRIPTION>
!   <TEMPLATE>
!     time_scalar_divide(time, n)
!   </TEMPLATE>

!   <IN NAME="time" UNITS="" TYPE="time_type" DIM="">
!      A time interval.
!   </IN>
!   <IN NAME="n" UNITS="" TYPE="integer" DIM="">
!      An integer factor.
!   </IN>
!   <OUT NAME="" UNITS="" TYPE="integer" DIM="double precision" DEFAULT="">
!       Returns the largest time, t, for which n * t <= time.
!   </OUT>

function time_scalar_divide(time, n)

! Returns the largest time, t, for which n * t <= time

type(time_type) :: time_scalar_divide
type(time_type), intent(in) :: time
integer, intent(in) :: n
double precision :: d, div, dseconds_per_day, dticks_per_second
integer :: days, seconds, ticks
type(time_type) :: prod1, prod2
character(len=128) tmp1,tmp2
logical :: ltmp

! Convert time interval to floating point days; risky for general performance?
dseconds_per_day  = dble(seconds_per_day)
dticks_per_second = dble(ticks_per_second)
d = time%days*dseconds_per_day*dticks_per_second + dble(time%seconds)*dticks_per_second + dble(time%ticks)
div = d/dble(n)

days = div/(dseconds_per_day*dticks_per_second)
seconds = div/dticks_per_second - days*dseconds_per_day
ticks = div - (days*dseconds_per_day + dble(seconds))*dticks_per_second
time_scalar_divide = set_time(seconds, days, ticks)

! Need to make sure that roundoff isn't killing this
prod1 = n * time_scalar_divide
prod2 = n * (increment_time(time_scalar_divide, days=0, seconds=0, ticks=1))
if(prod1 > time .or. prod2 <= time) then
   call get_time(time, seconds, days, ticks)
   write(tmp1,20) days,seconds,ticks
   call get_time(time_scalar_divide, seconds, days, ticks)
   write(tmp2,30) n,days,seconds,ticks
   ltmp = error_handler('time_scalar_divide',' quotient error:'//trim(tmp1)//trim(tmp2))
 20 format('time=',i7,' days, ',i6,' seconds, ',i6,' ticks')
 30 format('   time divided by',i6,'=',i7,' days, ',i6,' seconds, ',i6,' ticks')
endif

end function time_scalar_divide
! </FUNCTION>

!-------------------------------------------------------------------------
! <FUNCTION NAME="interval_alarm">

!   <OVERVIEW>
!     Given a time, and a time interval, this function returns true
!     if this is the closest time step to the alarm time. 
!   </OVERVIEW>
!   <DESCRIPTION>
!      This is a specialized operation that is frequently performed in models.
!      Given a time, and a time interval, this function is true if this is the
!      closest time step to the alarm time. The actual computation is:
! 
!             if((alarm_time - time) &#60;&#61; (time_interval / 2))
! 
!      If the function is true, the alarm time is incremented by the
!      alarm_interval; WARNING, this is a featured side effect. Otherwise, the
!      function is false and there are no other effects. CAUTION: if the
!      alarm_interval is smaller than the time_interval, the alarm may fail to
!      return true ever again.  Watch
!      for problems if the new alarm time is less than time + time_interval
!   </DESCRIPTION>
!   <TEMPLATE>
!      interval_alarm(time, time_interval, alarm, alarm_interval)
!   </TEMPLATE>

!   <IN NAME="time" TYPE="time_type"> Current time.  </IN>
!   <IN NAME="time_interval" TYPE="time_type"> A time interval.  </IN>
!   <IN NAME="alarm_interval" TYPE="time_type"> A time interval. </IN>
!   <OUT NAME="interval_alarm" TYPE="logical">
!     Returns either True or false.
!   </OUT>
!   <INOUT NAME="alarm" TYPE="time_type">
!     An alarm time, which is incremented by the alarm_interval
!                   if the function is true.
!   </INOUT>

function interval_alarm(time, time_interval, alarm, alarm_interval)

! Supports a commonly used type of test on times for models.  Given the
! current time, and a time for an alarm, determines if this is the closest
! time to the alarm time given a time step of time_interval.  If this
! is the closest time (alarm - time <= time_interval/2), the function 
! returns true and the alarm is incremented by the alarm_interval.  Watch
! for problems if the new alarm time is less than time + time_interval

logical :: interval_alarm
type(time_type), intent(in) :: time, time_interval, alarm_interval
type(time_type), intent(inout) :: alarm

if((alarm - time) <= (time_interval / 2)) then
   interval_alarm = .TRUE.
   alarm = alarm + alarm_interval
else
   interval_alarm = .FALSE.
end if

end function interval_alarm
! </FUNCTION>

!--------------------------------------------------------------------------
! <FUNCTION NAME="repeat_alarm">

!   <OVERVIEW>
!      Repeat_alarm supports an alarm that goes off with
!      alarm_frequency and lasts for alarm_length. 
!   </OVERVIEW>
!   <DESCRIPTION>
!      Repeat_alarm supports an alarm that goes off with alarm_frequency and
!      lasts for alarm_length.  If the nearest occurence of an alarm time
!      is less than half an alarm_length from the input time, repeat_alarm
!      is true.  For instance, if the alarm_frequency is 1 day, and the 
!      alarm_length is 2 hours, then repeat_alarm is true from time 2300 on 
!      day n to time 0100 on day n + 1 for all n.
!   </DESCRIPTION>
!   <TEMPLATE>
!      repeat_alarm(time, alarm_frequency, alarm_length)
!   </TEMPLATE>

!   <IN NAME="time" TYPE="time_type"> Current time.  </IN>
!   <IN NAME="alarm_frequency" TYPE="time_type">
!     A time interval for alarm_frequency.
!   </IN>
!   <IN NAME="alarm_length" TYPE="time_type">
!     A time interval for alarm_length.
!   </IN>
!   <OUT NAME="repeat_alarm" TYPE="logical">
!     Returns either True or false.
!   </OUT>

function repeat_alarm(time, alarm_frequency, alarm_length)

! Repeat_alarm supports an alarm that goes off with alarm_frequency and
! lasts for alarm_length.  If the nearest occurence of an alarm time
! is less than half an alarm_length from the input time, repeat_alarm
! is true.  For instance, if the alarm_frequency is 1 day, and the 
! alarm_length is 2 hours, then repeat_alarm is true from time 2300 on 
! day n to time 0100 on day n + 1 for all n.

logical :: repeat_alarm
type(time_type), intent(in) :: time, alarm_frequency, alarm_length
type(time_type) :: prev, next

prev = (time / alarm_frequency) * alarm_frequency
next = prev + alarm_frequency
if(time - prev <= alarm_length / 2 .or. next - time <= alarm_length / 2) then
   repeat_alarm = .TRUE.
else
   repeat_alarm = .FALSE.
endif

end function repeat_alarm
! </FUNCTION>

!--------------------------------------------------------------------------

!=========================================================================
! CALENDAR OPERATIONS BEGIN HERE
!=========================================================================

! <SUBROUTINE NAME="set_calendar_type">

!   <OVERVIEW>
!     Sets the default calendar type for mapping time intervals to dates.
!   </OVERVIEW>
!   <DESCRIPTION>
!     A constant number for setting the calendar type.
!   </DESCRIPTION>
!   <TEMPLATE> set_calendar_type(type, err_msg) </TEMPLATE>

!   <IN NAME="type" TYPE="integer" DIM="(scalar)" DEFAULT="NO_CALENDAR">
!     A constant number for setting the calendar type.
!   </IN>
!   <OUT NAME="err_msg" TYPE="character, optional" DIM="(scalar)">
!     When present, and when non-blank, a fatal error condition as been detected.
!     The string itself is an error message.
!     It is recommended that, when err_msg is present in the call
!     to this routine, the next line of code should be something
!     similar to this:
!     if(err_msg /= '') call error_mesg('my_routine','additional info: '//trim(err_msg),FATAL)
!   </OUT>

subroutine set_calendar_type(type, err_msg)

! Selects calendar for default mapping from time to date. 

integer, intent(in) :: type
character(len=*), intent(out), optional :: err_msg
integer :: iday, days_this_month, year, month, day
logical :: leap
character(len=256) :: err_msg_local

if(.not.module_is_initialized) call time_manager_init()

if(present(err_msg)) err_msg = ''

if(type <  0 .or. type > max_type) then
  err_msg_local = 'Illegal calendar type'
  if(error_handler('subroutine set_calendar_type', err_msg_local, err_msg)) return
endif

if(seconds_per_day /= 86400 .and. type /= NO_CALENDAR ) then
  err_msg_local = 'Only calendar type NO_CALENDAR is allowed when seconds_per_day is not 86400.'// &
                  ' You are using '//trim(valid_calendar_types(type))//' and seconds_per_day='
  write(err_msg_local(len_trim(err_msg_local)+1:len_trim(err_msg_local)+8),'(i8)') seconds_per_day
  if(error_handler('subroutine set_calendar_type', err_msg_local, err_msg)) return
endif 

calendar_type = type

if(type == GREGORIAN) then
  date_to_day = invalid_date
  iday = 0
  do year=1,400
    leap = leap_year_gregorian_int(year)
    do month=1,12
      days_this_month = days_per_month(month)
      if(leap .and. month ==2) days_this_month = 29
      do day=1,days_this_month
        date_to_day(year,month,day) = iday
        iday = iday+1
        coded_date(iday) = day + 32*(month + 16*year)
      enddo ! do day
    enddo ! do month
  enddo ! do year
endif

end subroutine set_calendar_type
! </SUBROUTINE>

!------------------------------------------------------------------------
! <FUNCTION NAME="get_calendar_type">

!   <OVERVIEW>
!      Returns the value of the default calendar type for mapping
!      from time to date.
!   </OVERVIEW>
!   <DESCRIPTION>
!     There are no arguments in this function. It returns the value of
!     the default calendar type for mapping from time to date.
!   </DESCRIPTION>
!   <TEMPLATE>
!     get_calendar_type()
!   </TEMPLATE>

function get_calendar_type()

! Returns default calendar type for mapping from time to date.

integer :: get_calendar_type

get_calendar_type = calendar_type

end function get_calendar_type
! </FUNCTION>

!------------------------------------------------------------------------
! <SUBROUTINE NAME="set_ticks_per_second">

!   <OVERVIEW>
!     Sets the number of ticks per second.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Sets the number of ticks per second.
!   </DESCRIPTION>
!   <TEMPLATE> call set_ticks_per_second(ticks_per_second) </TEMPLATE>
!   <IN NAME="type" TYPE="integer" DIM="(scalar)" DEFAULT="1"> </IN>

subroutine set_ticks_per_second(tps)
integer, intent(in) :: tps

ticks_per_second = tps

end subroutine set_ticks_per_second

! </SUBROUTINE>

!------------------------------------------------------------------------
! <FUNCTION NAME="get_ticks_per_second">

!   <OVERVIEW>
!      Returns the number of ticks per second.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Returns the number of ticks per second.
!   </DESCRIPTION>
!   <TEMPLATE>
!     ticks_per_second = get_ticks_per_second()
!   </TEMPLATE>

function get_ticks_per_second()
integer :: get_ticks_per_second

get_ticks_per_second = ticks_per_second

end function get_ticks_per_second

! </FUNCTION>
!------------------------------------------------------------------------

!========================================================================
! START OF get_date BLOCK
! <SUBROUTINE NAME="get_date">

!   <OVERVIEW>
!      Given a time_interval, returns the corresponding date under
!      the selected calendar. 
!   </OVERVIEW>
!   <DESCRIPTION>
!      Given a time_interval, returns the corresponding date under
!      the selected calendar.
!   </DESCRIPTION>
!   <TEMPLATE>
!     get_date(time, year, month, day, hour, minute, second, tick, err_msg)
!   </TEMPLATE>
!   <IN NAME="time"    TYPE="time_type"> A time interval.</IN>
!   <OUT NAME="year"   TYPE="integer"></OUT>
!   <OUT NAME="month"  TYPE="integer"></OUT>
!   <OUT NAME="day"    TYPE="integer"></OUT>
!   <OUT NAME="hour"   TYPE="integer"></OUT>
!   <OUT NAME="minute" TYPE="integer"></OUT>
!   <OUT NAME="second" TYPE="integer"></OUT>
!   <OUT NAME="tick"   TYPE="integer, optional"></OUT>
!   <OUT NAME="err_msg" TYPE="character, optional" DIM="(scalar)">
!     When present, and when non-blank, a fatal error condition as been detected.
!     The string itself is an error message.
!     It is recommended that, when err_msg is present in the call
!     to this routine, the next line of code should be something
!     similar to this:
!     if(err_msg /= '') call error_mesg('my_routine','additional info: '//trim(err_msg),FATAL)
!   </OUT>
 subroutine get_date(time, year, month, day, hour, minute, second, tick, err_msg)

! Given a time, computes the corresponding date given the selected calendar

 type(time_type), intent(in)    :: time
 integer, intent(out)           :: second, minute, hour, day, month, year
 integer, intent(out), optional :: tick
 character(len=*), intent(out), optional :: err_msg
 character(len=128) :: err_msg_local
 integer :: tick1 

 if(.not.module_is_initialized) call time_manager_init
 if(present(err_msg)) err_msg = ''

 select case(calendar_type)
 case(THIRTY_DAY_MONTHS)
   call get_date_thirty   (time, year, month, day, hour, minute, second, tick1)
 case(GREGORIAN)
   call get_date_gregorian(time, year, month, day, hour, minute, second, tick1)
 case(JULIAN)
   call get_date_julian_private   (time, year, month, day, hour, minute, second, tick1)
 case(NOLEAP)
   call get_date_no_leap_private  (time, year, month, day, hour, minute, second, tick1)
 case(NO_CALENDAR)
   err_msg_local = 'Cannot produce a date when the calendar type is NO_CALENDAR'
   if(error_handler('subroutine get_date', err_msg_local, err_msg)) return
 case default
   err_msg_local = 'Invalid calendar type'
   if(error_handler('subroutine get_date', err_msg_local, err_msg)) return
 end select
 
 if(present(tick)) then
   tick = tick1
 else
   if(tick1 /= 0) then
     err_msg_local = 'tick must be present when time has a second fraction'
     if(error_handler('subroutine get_date', err_msg_local, err_msg)) return
   endif
 endif

 end subroutine get_date
! </SUBROUTINE>
!------------------------------------------------------------------------

 subroutine get_date_gregorian(time, year, month, day, hour, minute, second, tick)

! Computes date corresponding to time for gregorian calendar

 type(time_type), intent(in) :: time
 integer, intent(out) :: year, month, day, hour, minute, second
 integer, intent(out) :: tick
 integer :: iday, isec

 if(Time%seconds >= 86400) then ! This check appears to be unecessary.
   call error_mesg('get_date','Time%seconds .ge. 86400 in subroutine get_date_gregorian',FATAL)
 endif

 iday = mod(Time%days+1,days_in_400_year_period)
 if(iday == 0) iday = days_in_400_year_period

 year = coded_date(iday)/512
 day = mod(coded_date(iday),32)
 month = coded_date(iday)/32 - 16*year

 year = year + 400*((Time%days)/days_in_400_year_period)

 hour = Time%seconds / 3600
 isec  = Time%seconds - 3600*hour
 minute = isec / 60
 second = isec - 60*minute 
 tick = time%ticks

 end subroutine get_date_gregorian

!------------------------------------------------------------------------
 function cut0(string)
 character(len=256) :: cut0
 character(len=*), intent(in) :: string
 integer :: i

 cut0 = string

 do i=1,len(string)
   if(ichar(string(i:i)) == 0 ) then
     cut0(i:i) = ' '
   endif
 enddo

 return
 end function cut0
!------------------------------------------------------------------------

 subroutine get_date_julian_private(time, year, month, day, hour, minute, second, tick)

! Base date for Julian calendar is year 1 with all multiples of 4 
! years being leap years.

 type(time_type), intent(in) :: time
 integer, intent(out) :: second, minute, hour, day, month, year
 integer, intent(out) :: tick
 integer :: m, t, nfour, nex, days_this_month
 logical :: leap

! find number of four year periods; also get modulo number of days
 nfour = time%days / (4 * 365 + 1) 
 day = modulo(time%days, (4 * 365 + 1))

! Find out what year in four year chunk
 nex = day / 365
 if(nex == 4) then
    nex = 3
    day = 366
 else
    day=modulo(day, 365) + 1
 endif

! Is this a leap year? 
 leap = (nex == 3)

 year = 1 + 4 * nfour + nex

! find month and day
 do m = 1, 12
   month = m
   days_this_month = days_per_month(m)
   if(leap .and. m == 2) days_this_month = 29
   if(day <= days_this_month) exit
   day = day - days_this_month
 end do

! find hour,minute and second
 t = time%seconds
 hour = t / (60 * 60)
 t = t - hour * (60 * 60)
 minute = t / 60
 second = t - 60 * minute
 tick = time%ticks
 end subroutine get_date_julian_private

!------------------------------------------------------------------------
 subroutine get_date_julian(time, year, month, day, hour, minute, second)

! No need to include tick in argument list because this routine
! exists only for interpolator.F90, which does not need it.

 type(time_type), intent(in) :: time
 integer, intent(out) :: second, minute, hour, day, month, year
 integer :: tick

 call get_date_julian_private(time, year, month, day, hour, minute, second, tick)

 end subroutine get_date_julian

!------------------------------------------------------------------------

 subroutine get_date_thirty(time, year, month, day, hour, minute, second, tick)

! Computes date corresponding to time interval for 30 day months, 12
! month years.

 type(time_type), intent(in) :: time
 integer, intent(out) :: second, minute, hour, day, month, year
 integer, intent(out) :: tick
 integer :: t, dmonth, dyear

 t = time%days
 dyear = t / (30 * 12)
 year = dyear + 1
 t = t - dyear * (30 * 12)
 dmonth = t / 30
 month = 1 + dmonth
 day = t -dmonth * 30 + 1

 t = time%seconds
 hour = t / (60 * 60) 
 t = t - hour * (60 * 60)
 minute = t / 60
 second = t - 60 * minute
 tick = time%ticks

 end subroutine get_date_thirty
!------------------------------------------------------------------------

 subroutine get_date_no_leap_private(time, year, month, day, hour, minute, second, tick)

! Base date for NOLEAP calendar is year 1.

 type(time_type), intent(in) :: time
 integer, intent(out) :: second, minute, hour, day, month, year
 integer, intent(out) :: tick
 integer :: m, t

! get modulo number of days
 year = time%days / 365 + 1
 day = modulo(time%days, 365) + 1

! find month and day
 do m = 1, 12
   month = m
   if(day <= days_per_month(m)) exit
   day = day - days_per_month(m)
 end do

! find hour,minute and second
 t = time%seconds
 hour = t / (60 * 60)
 t = t - hour * (60 * 60)
 minute = t / 60
 second = t - 60 * minute
 tick = time%ticks

 end subroutine get_date_no_leap_private

!------------------------------------------------------------------------
 subroutine get_date_no_leap(time, year, month, day, hour, minute, second)

! No need to include tick in argument list because this routine
! exists only for interpolator.F90, which does not need it.

 type(time_type), intent(in) :: time
 integer, intent(out) :: second, minute, hour, day, month, year
 integer :: tick

 call get_date_no_leap_private(time, year, month, day, hour, minute, second, tick)

 end subroutine get_date_no_leap
!------------------------------------------------------------------------

! END OF get_date BLOCK
!========================================================================
! START OF set_date BLOCK
! <FUNCTION NAME="set_date">

!   <OVERVIEW>
!      Given an input date in year, month, days, etc., creates a
!      time_type that represents this time interval from the
!      internally defined base date.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Given a date, computes the corresponding time given the selected
!      date time mapping algorithm. Note that it is possible to specify
!      any number of illegal dates; these should be checked for and generate
!      errors as appropriate.
!   </DESCRIPTION>
!   <TEMPLATE>
!     1. set_date(year, month, day, hours, minute, second, tick, err_msg)
!   </TEMPLATE>
!   <TEMPLATE>
!     2. set_date_c(time_string, zero_year_warning, err_msg, allow_rounding)
!      time_string is a character string containing a date formatted
!      according to CF conventions. e.g. '1980-12-31 23:59:59.9'
!   </TEMPLATE>
!   <IN NAME="time"   TYPE="time_type"> A time interval.</IN>
!   <IN NAME="year"   TYPE="integer"></IN>
!   <IN NAME="month"  TYPE="integer"></IN>
!   <IN NAME="day"    TYPE="integer"></IN>
!   <IN NAME="hour"   TYPE="integer"></IN>
!   <IN NAME="minute" TYPE="integer"></IN>
!   <IN NAME="second" TYPE="integer"></IN>
!   <IN NAME="tick"   TYPE="integer"></IN>
!   <IN NAME="zero_year_warning"   TYPE="logical">
!     If the year number is zero, it will be silently changed to one,
!     unless zero_year_warning=.true., in which case a WARNING message
!     will also be issued.
!   </IN>
!   <IN NAME="allow_rounding"   TYPE="logical, optional" DEFAULT=".true.">
!     When .true., any fractions of a second will be rounded off to the nearest tick.
!     When .false., it is a fatal error if the second fraction cannot be exactly
!     represented by a number of ticks.
!   </IN>
!   <OUT NAME="err_msg" TYPE="character, optional" DIM="(scalar)">
!     When present, and when non-blank, a fatal error condition as been detected.
!     The string itself is an error message.
!     It is recommended that, when err_msg is present in the call
!     to this routine, the next line of code should be something
!     similar to this:
!     if(err_msg /= '') call error_mesg('my_routine','additional info: '//trim(err_msg),FATAL)
!   </OUT>
!   <OUT NAME="set_date" TYPE="time_type"> A time interval.</OUT>

 function set_date_private(year, month, day, hour, minute, second, tick, Time_out, err_msg)

! Given a date, computes the corresponding time given the selected
! date time mapping algorithm.  Note that it is possible to specify
! any number of illegal dates; these are checked for and generate
! errors as appropriate.

 logical :: set_date_private
 integer, intent(in) :: year, month, day, hour, minute, second, tick
 type(time_type) :: Time_out
 character(len=*), intent(out) :: err_msg

 if(.not.module_is_initialized) call time_manager_init

 err_msg = ''

 select case(calendar_type)
 case(THIRTY_DAY_MONTHS)
   set_date_private = set_date_thirty   (year, month, day, hour, minute, second, tick, Time_out, err_msg)
 case(GREGORIAN)
   set_date_private = set_date_gregorian(year, month, day, hour, minute, second, tick, Time_out, err_msg)
 case(JULIAN)
   set_date_private = set_date_julian_private   (year, month, day, hour, minute, second, tick, Time_out, err_msg)
 case(NOLEAP)
   set_date_private = set_date_no_leap_private  (year, month, day, hour, minute, second, tick, Time_out, err_msg)
 case (NO_CALENDAR)
   err_msg = 'Cannot produce a date when calendar type is NO_CALENDAR'
   set_date_private = .false.
 case default
   err_msg = 'Invalid calendar type'
   set_date_private = .false.
 end select

 end function set_date_private
! </FUNCTION>

!------------------------------------------------------------------------
 function set_date_i(year, month, day, hour, minute, second, tick, err_msg)
 type(time_type) :: set_date_i
 integer, intent(in) :: day, month, year
 integer, intent(in), optional :: second, minute, hour, tick
 character(len=*), intent(out), optional :: err_msg
 integer :: osecond, ominute, ohour, otick
 character(len=128) :: err_msg_local

 if(.not.module_is_initialized) call time_manager_init
 if(present(err_msg)) err_msg = ''
     
! Missing optionals are set to 0
 osecond = 0; if(present(second)) osecond = second
 ominute = 0; if(present(minute)) ominute = minute
 ohour   = 0; if(present(hour))   ohour   = hour
 otick   = 0; if(present(tick))   otick   = tick

 if(.not.set_date_private(year, month, day, ohour, ominute, osecond, otick, set_date_i, err_msg_local)) then
   if(error_handler('function set_date_i', err_msg_local, err_msg)) return
 endif

 end function set_date_i
!------------------------------------------------------------------------

 function set_date_c(string, zero_year_warning, err_msg, allow_rounding)

 ! Examples of acceptable forms of string:

 ! 1980-01-01 00:00:00
 ! 1980-01-01 00:00:00.50
 ! 1980-1-1 0:0:0
 ! 1980-1-1

 ! year number must occupy 4 spaces.
 ! months, days, hours, minutes, seconds may occupy 1 or 2 spaces
 ! year, month and day must be separated by a '-'
 ! hour, minute, second must be separated by a ':'
 ! hour, minute, second are optional. If not present then zero is assumed.
 ! second may be a real number.

 ! zero_year_warning:
 ! If the year number is zero, it will be silently changed to one,
 ! unless zero_year_warning=.true., in which case a WARNING message
 ! will also be issued

 type(time_type) :: set_date_c
 character(len=*), intent(in) :: string
 logical,          intent(in),  optional :: zero_year_warning
 character(len=*), intent(out), optional :: err_msg
 logical,          intent(in),  optional :: allow_rounding
 character(len=4) :: formt='(i )'
 logical :: correct_form, zero_year_warning_local, allow_rounding_local
 integer :: i1, i2, i3, i4, i5, i6, i7
 character(len=32) :: string_sifted_left
 integer :: year, month, day, hour, minute, second, tick
 character(len=128) :: err_msg_local
 
 if(.not.module_is_initialized) call time_manager_init()
 if(present(err_msg)) err_msg = ''
 if(present(zero_year_warning)) then
   zero_year_warning_local = zero_year_warning 
 else
   zero_year_warning_local = .true. 
 endif
 if(present(allow_rounding)) then
   allow_rounding_local = allow_rounding 
 else
   allow_rounding_local = .true. 
 endif

 string_sifted_left = adjustl(string)
 i1 = index(string_sifted_left,'-')
 i2 = index(string_sifted_left,'-',back=.true.)
 i3 = index(string_sifted_left,':')
 i4 = index(string_sifted_left,':',back=.true.)
 i5 = len_trim(cut0(string_sifted_left))
 i6 = index(string_sifted_left,'.',back=.true.)
 correct_form = (i1 > 1) ! year number must occupy at least 1 space
 correct_form = correct_form .and. (i2-i1 == 2 .or. i2-i1 == 3) ! month number must occupy 1 or 2 spaces
 if(.not.correct_form) then
   err_msg_local = 'Form of character time stamp is incorrect. The character time stamp is: '//trim(string)
   if(error_handler('function set_date_c', err_msg_local, err_msg)) return
 endif
 write(formt(3:3),'(i1)') i1-1
 read(string_sifted_left(1:i1-1),formt) year
 if(year == 0) then
   year = 1
   if(zero_year_warning_local) then
     call error_mesg('set_date_c','Year zero is invalid. Resetting year to 1', WARNING)
   endif
 endif
 write(formt(3:3),'(i1)') i2-i1-1
 read(string_sifted_left(i1+1:i2-1),formt) month
 i7 = min(i2+2,i5)
 read(string_sifted_left(i2+1:i7),'(i2)') day

 if(i3 == 0) then
! There are no minutes or seconds in the string
   minute = 0
   second = 0
   tick   = 0
   if(i5 <= i2+2) then
 !   There is no clocktime in the string at all
     hour = 0
   else
 !   The clocktime includes only hours
     read(string_sifted_left(i5-1:i5),'(i2)') hour
   endif
 else if(i3 == i4) then
 ! The string includes hours and minutes, but no seconds
   read(string_sifted_left(i3-2:i3-1),'(i2)') hour
   write(formt(3:3),'(i1)') i5-i3
   read(string_sifted_left(i3+1:i5),formt) minute
   second = 0
   tick = 0
 else
 ! The string includes hours, minutes, and seconds
   read(string_sifted_left(i3-2:i3-1),'(i2)') hour
   write(formt(3:3),'(i1)') i4-i3-1
   read(string_sifted_left(i3+1:i4-1),formt) minute
   write(formt(3:3),'(i1)') i5-i4
   if(i6 == 0) then
   ! There are no fractional seconds
     read(string_sifted_left(i4+1:i5),formt) second
     tick = 0
   else
     read(string_sifted_left(i4+1:i6-1),formt) second
     if(.not.get_tick_from_string(string_sifted_left(i6:i5), err_msg_local, allow_rounding_local, tick)) then
       if(error_handler('function set_date_c', err_msg_local, err_msg)) return
     endif
 !   If tick has been rounded up to ticks_per_second, then bump up second.
     if(tick == ticks_per_second) then
       second = second + 1
       tick = 0
     endif
   endif
 endif

 if(.not.set_date_private(year, month, day, hour, minute, second, tick, set_date_c, err_msg_local)) then
   if(error_handler('function set_date_c', err_msg_local, err_msg)) return
 endif

 end function set_date_c
!------------------------------------------------------------------------

 function set_date_gregorian(year, month, day, hour, minute, second, tick, Time_out, err_msg)
 logical :: set_date_gregorian

! Computes time corresponding to date for gregorian calendar.

 integer,          intent(in)  :: year, month, day, hour, minute, second, tick
 type(time_type),  intent(out) :: Time_out
 character(len=*), intent(out) :: err_msg
 integer :: yr1, day1

 if( .not.valid_increments(year,month,day,hour,minute,second,tick,err_msg) ) then
   set_date_gregorian = .false.
   return
 endif

 Time_out%seconds = second + 60*(minute + 60*hour)

 yr1 = mod(year,400)
 if(yr1 == 0) yr1 = 400
 day1 = date_to_day(yr1,month,day)
  if(day1 == invalid_date) then
   err_msg = 'Invalid_date. Date='//convert_integer_date_to_char(year,month,day,hour,minute,second)
   set_date_gregorian = .false.
   return
 endif

 Time_out%days = day1 + days_in_400_year_period*((year-1)/400)
 Time_out%ticks = tick
 err_msg = ''
 set_date_gregorian = .true.

 end function set_date_gregorian

!------------------------------------------------------------------------

 function set_date_julian_private(year, month, day, hour, minute, second, tick, Time_out, err_msg)
 logical :: set_date_julian_private

! Returns time corresponding to date for julian calendar.

 integer,          intent(in)  :: year, month, day, hour, minute, second, tick
 type(time_type),  intent(out) :: Time_out
 character(len=*), intent(out) :: err_msg
 integer :: ndays, m, nleapyr
 logical :: leap

 if( .not.valid_increments(year,month,day,hour,minute,second,tick,err_msg) ) then
   set_date_julian_private = .false.
   return
 endif

 if(month /= 2 .and. day > days_per_month(month)) then
   err_msg = 'Invalid date. Date='//convert_integer_date_to_char(year,month,day,hour,minute,second)
   set_date_julian_private = .false.
   return
 endif

! Is this a leap year? 
 leap = (modulo(year,4) == 0)
! compute number of complete leap years from year 1
 nleapyr = (year - 1) / 4

! Finish checking for day specication errors
 if(month == 2 .and. (day > 29 .or. ((.not. leap) .and. day > 28))) then
   err_msg = 'Invalid date. Date='//convert_integer_date_to_char(year,month,day,hour,minute,second)
   set_date_julian_private = .false.
   return
 endif

 ndays = 0
 do m = 1, month - 1
   ndays = ndays + days_per_month(m)
   if(leap .and. m == 2) ndays = ndays + 1
 enddo

 Time_out%seconds = second + 60 * (minute + 60 * hour)
 Time_out%days    = day -1 + ndays + 365*(year - nleapyr - 1) + 366*(nleapyr)
 Time_out%ticks   = tick
 err_msg = ''
 set_date_julian_private = .true.

 end function set_date_julian_private

!------------------------------------------------------------------------
 function set_date_julian(year, month, day, hour, minute, second)

! No need to include tick or err_msg in argument list because this
! routine exists only for interpolator.F90, which does not need them.

 type(time_type) :: set_date_julian
 integer, intent(in) :: year, month, day, hour, minute, second
 character(len=128) :: err_msg

 if(.not.set_date_julian_private(year, month, day, hour, minute, second, 0, set_date_julian, err_msg)) then
   call error_mesg('set_date_julian',trim(err_msg),FATAL)
 endif

 end function set_date_julian
!------------------------------------------------------------------------

 function set_date_thirty(year, month, day, hour, minute, second, tick, Time_out, err_msg)
 logical :: set_date_thirty

! Computes time corresponding to date for thirty day months.

 integer,          intent(in)  :: year, month, day, hour, minute, second, tick
 type(time_type),  intent(out) :: Time_out
 character(len=*), intent(out) :: err_msg

 if( .not.valid_increments(year,month,day,hour,minute,second,tick,err_msg) ) then
   set_date_thirty = .false.
   return
 endif

 if(day > 30) then
   err_msg = 'Invalid date. Date='//convert_integer_date_to_char(year,month,day,hour,minute,second)
   set_date_thirty = .false.
   return
 endif

 Time_out%days    = (day - 1) + 30 * ((month - 1) + 12 * (year - 1))
 Time_out%seconds = second + 60 * (minute + 60 * hour)
 Time_out%ticks   = tick
 err_msg = ''
 set_date_thirty = .true.

 end function set_date_thirty

!------------------------------------------------------------------------

 function set_date_no_leap_private(year, month, day, hour, minute, second, tick, Time_out, err_msg)
 logical :: set_date_no_leap_private

! Computes time corresponding to date for fixed 365 day year calendar.

 integer,          intent(in)  :: year, month, day, hour, minute, second, tick
 type(time_type),  intent(out) :: Time_out
 character(len=*), intent(out) :: err_msg
 integer :: ndays, m

 if( .not.valid_increments(year,month,day,hour,minute,second,tick,err_msg) ) then
   set_date_no_leap_private = .false.
   return
 endif

 if(day > days_per_month(month)) then
   err_msg = 'Invalid date. Date='//convert_integer_date_to_char(year,month,day,hour,minute,second)
   set_date_no_leap_private = .false.
   return
 endif

 ndays = 0
 do m = 1, month - 1
   ndays = ndays + days_per_month(m)
 enddo

! No need for err_msg in call to set_time because previous checks ensure positive value of time.
 Time_out = set_time(second + 60 * (minute + 60 * hour), day -1 + ndays + 365 * (year - 1), tick)
 err_msg = ''
 set_date_no_leap_private = .true.

 end function set_date_no_leap_private
!------------------------------------------------------------------------

 function set_date_no_leap(year, month, day, hour, minute, second)

! No need to include tick or err_msg in argument list because this
! routine exists only for interpolator.F90, which does not need them.

 type(time_type) :: set_date_no_leap
 integer, intent(in) :: year, month, day, hour, minute, second
 character(len=128) :: err_msg

 if(.not.set_date_no_leap_private(year, month, day, hour, minute, second, 0, set_date_no_leap, err_msg)) then
   call error_mesg('set_date_no_leap',trim(err_msg),FATAL)
 endif

 end function set_date_no_leap

!=========================================================================

 function valid_increments(year, month, day, hour, minute, second, tick, err_msg)
 logical :: valid_increments
 integer, intent(in) :: year, month, day, hour, minute, second, tick
 character(len=128), intent(out) :: err_msg

!  Check for invalid values

 err_msg = ''
 valid_increments = .true.
 if(second > 59 .or. second < 0 .or. minute > 59 .or. minute < 0 &
   .or. hour > 23 .or. hour < 0 .or. day > 31 .or. day < 1 &
   .or. month > 12 .or. month < 1 .or. year < 1) then
     err_msg = 'Invalid date. Date='//convert_integer_date_to_char(year,month,day,hour,minute,second)
     valid_increments = .false.
     return
 endif
 if(tick < 0 .or. tick >= ticks_per_second) then
   write(err_msg,'(a,i6)') 'Invalid number of ticks. tick=',tick
   valid_increments = .false.
 endif

 end function valid_increments

!=========================================================================

 function convert_integer_date_to_char(year, month, day, hour, minute, second)
 character(len=19) :: convert_integer_date_to_char
 integer, intent(in) :: year, month, day
 integer, intent(in) :: hour, minute, second

 write(convert_integer_date_to_char,10) year,month,day,hour,minute,second
 10 format(i4.4, '-', i2.2, '-', i2.2, ' ', i2.2, ':', i2.2, ':', i2.2)

 end function convert_integer_date_to_char

!=========================================================================
! END OF set_date BLOCK
!=========================================================================

! <FUNCTION NAME="increment_date">

!   <OVERVIEW>
!      Increments the date represented by a time interval and the
!      default calendar type by a number of seconds, etc. 
!   </OVERVIEW>
!   <DESCRIPTION>
!      Given a time and some date increment, computes a new time.  Depending
!      on the mapping algorithm from date to time, it may be possible to specify
!      undefined increments (i.e. if one increments by 68 days and 3 months in
!      a Julian calendar, it matters which order these operations are done and
!      we don't want to deal with stuff like that, make it an error).
!   </DESCRIPTION>
!   <TEMPLATE>
!      increment_date(time, years, months, days, hours, minutes, seconds, ticks, err_msg)
!   </TEMPLATE>
!   <IN NAME="time"    TYPE="time_type"> A time interval.</IN>
!   <IN NAME="years"   TYPE="integer">An increment of years.</IN>
!   <IN NAME="months"  TYPE="integer">An increment of months.</IN>
!   <IN NAME="days"    TYPE="integer">An increment of days.</IN>
!   <IN NAME="hours"   TYPE="integer">An increment of hours.</IN>
!   <IN NAME="minutes" TYPE="integer">An increment of minutes.</IN>
!   <IN NAME="seconds" TYPE="integer">An increment of seconds.</IN>
!   <IN NAME="ticks"   TYPE="integer">An increment of ticks.</IN>
!   <OUT NAME="err_msg" TYPE="character, optional" DIM="(scalar)">
!     When present, and when non-blank, a fatal error condition as been detected.
!     The string itself is an error message.
!     It is recommended that, when err_msg is present in the call
!     to this routine, the next line of code should be something
!     similar to this:
!     if(err_msg /= '') call error_mesg('my_routine','additional info: '//trim(err_msg),FATAL)
!   </OUT>
!   <OUT NAME="increment_date" TYPE="time_type"> A new time based on the input 
!         time interval and the calendar type.
!   </OUT>
!   <IN NAME="allow_neg_inc" TYPE="logical, optional" DIM="(scalar)" DEFAULT=".true.">
!     When .false., it is a fatal error if any of the input time increments are negative.
!     This mimics the behavior of lima and earlier revisions.
!   </IN>
!   <NOTE>
!     For all but the thirty_day_months calendar, increments to months
!     and years must be made separately from other units because of the
!     non-associative nature of addition.
!     If the result is a negative time (i.e. date before the base date)
!     it is considered a fatal error.
!   </NOTE>

 function increment_date(Time, years, months, days, hours, minutes, seconds, ticks, err_msg, allow_neg_inc)

! Given a time and some date increment, computes a new time.  Depending
! on the mapping algorithm from date to time, it may be possible to specify
! undefined increments (i.e. if one increments by 68 days and 3 months in
! a Julian calendar, it matters which order these operations are done and
! we don't want to deal with stuff like that, make it an error).

! This routine operates in one of two modes.
! 1. days, hours, minutes, seconds, ticks are incremented, years and months must be zero or absent arguments.
! 2. years and/or months are incremented, other time increments must be zero or absent arguments.

 type(time_type) :: increment_date
 type(time_type), intent(in) :: Time
 integer, intent(in), optional :: years, months, days, hours, minutes, seconds, ticks
 character(len=*), intent(out), optional :: err_msg
 logical, intent(in), optional :: allow_neg_inc

 integer :: oyears, omonths, odays, ohours, ominutes, oseconds, oticks
 character(len=128) :: err_msg_local
 logical :: allow_neg_inc_local

 if(.not.module_is_initialized) call time_manager_init
 if(present(err_msg)) err_msg = ''

! Missing optionals are set to 0
 oseconds = 0; if(present(seconds)) oseconds = seconds
 ominutes = 0; if(present(minutes)) ominutes = minutes
 ohours   = 0; if(present(hours))   ohours   = hours
 odays    = 0; if(present(days))    odays    = days
 omonths  = 0; if(present(months))  omonths  = months
 oyears   = 0; if(present(years))   oyears   = years
 oticks   = 0; if(present(ticks))   oticks   = ticks
 allow_neg_inc_local=.true.; if(present(allow_neg_inc)) allow_neg_inc_local=allow_neg_inc

 if(.not.allow_neg_inc_local) then
   if(oyears < 0 .or. omonths < 0 .or. odays < 0 .or. ohours < 0 .or. ominutes < 0 .or. oseconds < 0 .or. oticks < 0) then
     write(err_msg_local,10) oyears, omonths, odays, ohours, ominutes, oseconds, oticks
     if(error_handler('function increment_time', err_msg_local, err_msg)) return
   endif
 endif
 10 format('One or more time increments are negative: '// &
   'years=',i6,' months=',i6,' days=',i6,' hours=',i6,' minutes=',i6,' seconds=',i6,' ticks=',i6)

 if(.not.increment_date_private( &
     Time, oyears, omonths, odays, ohours, ominutes, oseconds, oticks, increment_date, err_msg_local)) then
   if(error_handler('function increment_date', err_msg_local, err_msg)) return
 endif
 
 end function increment_date

! </FUNCTION>

!=======================================================================

 function increment_date_private(Time, years, months, days, hours, minutes, seconds, ticks, Time_out, err_msg)

! Given a time and some date increment, computes a new time.  Depending
! on the mapping algorithm from date to time, it may be possible to specify
! undefined increments (i.e. if one increments by 68 days and 3 months in
! a Julian calendar, it matters which order these operations are done and
! we don't want to deal with stuff like that, make it an error).

! This routine operates in one of two modes.
! 1. days, hours, minutes, seconds, ticks are incremented, years and months must be zero or absent arguments.
! 2. years and/or months are incremented, other time increments must be zero or absent arguments.

! Negative increments are always allowed in the private version of this routine.

 logical :: increment_date_private
 type(time_type),  intent(in)  :: Time
 integer,          intent(in)  :: years, months, days, hours, minutes, seconds, ticks
 type(time_type),  intent(out) :: Time_out
 character(len=*), intent(out) :: err_msg
 integer :: cyear , cmonth , cday , chour , cminute , csecond , ctick 
 logical :: mode_1, mode_2

 err_msg = ''
 increment_date_private = .true.

 mode_1 = days /= 0 .or. hours /= 0 .or. minutes /= 0 .or. seconds /= 0 .or. ticks /= 0
 mode_2 = years /= 0 .or. months /= 0

 if(.not.mode_1 .and. .not.mode_2) then
 ! All time increments are zero
   Time_out = Time
   return
 endif

 if(mode_1 .and. mode_2) then
   err_msg = 'years and/or months must not be incremented with other time units'
   increment_date_private = .false.
   return
 endif

 if(mode_1) then
   csecond = seconds + 60 * (minutes + 60 * hours)
   increment_date_private = increment_time_private(Time, csecond, days, ticks, Time_out, err_msg)
 endif

 if(mode_2) then
 ! Convert Time to a date
   select case(calendar_type)
   case(THIRTY_DAY_MONTHS)
     call get_date_thirty   (Time, cyear, cmonth, cday, chour, cminute, csecond, ctick)
   case(NOLEAP)
     call get_date_no_leap_private  (Time, cyear, cmonth, cday, chour, cminute, csecond, ctick)
   case(JULIAN)
     call get_date_julian_private   (Time, cyear, cmonth, cday, chour, cminute, csecond, ctick)
   case(GREGORIAN)
     call get_date_gregorian(Time, cyear, cmonth, cday, chour, cminute, csecond, ctick)
   case(NO_CALENDAR)
     err_msg = 'Cannot increment a date when the calendar type is NO_CALENDAR'
     increment_date_private = .false.
     return
   case default
     err_msg = 'Invalid calendar type'
     increment_date_private = .false.
     return
   end select

 ! Add month increment
   cmonth = cmonth + months

 ! Adjust year and month number when cmonth falls outside the range 1 to 12
   cyear = cyear + floor((cmonth-1)/12.)
   cmonth = modulo((cmonth-1),12) + 1

 ! Add year increment
   cyear = cyear + years

 ! Convert this back into a time.
   select case(calendar_type)
   case(THIRTY_DAY_MONTHS)
     increment_date_private = set_date_thirty   (cyear, cmonth, cday, chour, cminute, csecond, ctick, Time_out, err_msg)
   case(NOLEAP)
     increment_date_private = set_date_no_leap_private  (cyear, cmonth, cday, chour, cminute, csecond, ctick, Time_out, err_msg)
   case(JULIAN)
     increment_date_private = set_date_julian_private   (cyear, cmonth, cday, chour, cminute, csecond, ctick, Time_out, err_msg)
   case(GREGORIAN)
     increment_date_private = set_date_gregorian(cyear, cmonth, cday, chour, cminute, csecond, ctick, Time_out, err_msg)
   end select
 endif ! if(mode_2)

 end function increment_date_private

!=========================================================================
! <FUNCTION NAME="decrement_date">

!   <OVERVIEW>
!      Decrements the date represented by a time interval and the
!      default calendar type by a number of seconds, etc. 
!   </OVERVIEW>
!   <DESCRIPTION>
!      Given a time and some date decrement, computes a new time.  Depending
!      on the mapping algorithm from date to time, it may be possible to specify
!      undefined decrements (i.e. if one decrements by 68 days and 3 months in
!      a Julian calendar, it matters which order these operations are done and
!      we don't want to deal with stuff like that, make it an error).
!   </DESCRIPTION>
!   <TEMPLATE>
!      decrement_date(time, years, months, days, hours, minutes, seconds, ticks, err_msg))
!   </TEMPLATE>
!   <IN NAME="time"    TYPE="time_type"> A time interval.</IN>
!   <IN NAME="years"   TYPE="integer">An decrement of years.</IN>
!   <IN NAME="months"  TYPE="integer">An decrement of months.</IN>
!   <IN NAME="days"    TYPE="integer">An decrement of days.</IN>
!   <IN NAME="hours"   TYPE="integer">An decrement of hours.</IN>
!   <IN NAME="minutes" TYPE="integer">An decrement of minutes.</IN>
!   <IN NAME="seconds" TYPE="integer">An decrement of seconds.</IN>
!   <IN NAME="ticks"   TYPE="integer">An decrement of ticks.</IN>
!   <OUT NAME="err_msg" TYPE="character, optional" DIM="(scalar)">
!     When present, and when non-blank, a fatal error condition as been detected.
!     The string itself is an error message.
!     It is recommended that, when err_msg is present in the call
!     to this routine, the next line of code should be something
!     similar to this:
!     if(err_msg /= '') call error_mesg('my_routine','additional info: '//trim(err_msg),FATAL)
!   </OUT>
!   <OUT NAME="decrement_date" TYPE="time_type"> A new time based on the input 
!         time interval and the calendar type.
!   </OUT>
!   <IN NAME="allow_neg_inc" TYPE="logical, optional" DIM="(scalar)" DEFAULT=".true.">
!     When .false., it is a fatal error if any of the input time increments are negative.
!     This mimics the behavior of lima and earlier revisions.
!   </IN>
!   <NOTE>
!     For all but the thirty_day_months calendar, decrements to months
!     and years must be made separately from other units because of the
!     non-associative nature of addition.
!     If the result is a negative time (i.e. date before the base date)
!     it is considered a fatal error.
!   </NOTE>

 function decrement_date(Time, years, months, days, hours, minutes, seconds, ticks, err_msg, allow_neg_inc)

 type(time_type) :: decrement_date
 type(time_type), intent(in) :: Time
 integer, intent(in), optional :: seconds, minutes, hours, days, months, years, ticks
 character(len=*), intent(out), optional :: err_msg
 logical, intent(in), optional :: allow_neg_inc

 integer :: oseconds, ominutes, ohours, odays, omonths, oyears, oticks
 character(len=128) :: err_msg_local
 logical :: allow_neg_inc_local

 if(present(err_msg)) err_msg = ''

 ! Missing optionals are set to 0
 oseconds = 0; if(present(seconds)) oseconds = seconds
 ominutes = 0; if(present(minutes)) ominutes = minutes
 ohours   = 0; if(present(hours))   ohours   = hours
 odays    = 0; if(present(days))    odays    = days
 omonths  = 0; if(present(months))  omonths  = months
 oyears   = 0; if(present(years))   oyears   = years
 oticks   = 0; if(present(ticks))   oticks   = ticks
 allow_neg_inc_local=.true.; if(present(allow_neg_inc)) allow_neg_inc_local=allow_neg_inc

 if(.not.allow_neg_inc_local) then
   if(oyears < 0 .or. omonths < 0 .or. odays < 0 .or. ohours < 0 .or. ominutes < 0 .or. oseconds < 0 .or. oticks < 0) then
     write(err_msg_local,10) oyears, omonths, odays, ohours, ominutes, oseconds, oticks
     if(error_handler('function decrement_date', err_msg_local, err_msg)) return
   endif
 endif
 10 format('One or more time increments are negative: '// &
   'years=',i6,' months=',i6,' days=',i6,' hours=',i6,' minutes=',i6,' seconds=',i6,' ticks=',i6)

 if(.not.increment_date_private( &
     Time, -oyears, -omonths, -odays, -ohours, -ominutes, -oseconds, -oticks, decrement_date, err_msg_local)) then
   if(error_handler('function decrement_date', err_msg_local, err_msg)) return
 endif

 end function decrement_date
 ! </FUNCTION>

!=========================================================================
! START days_in_month BLOCK
! <FUNCTION NAME="days_in_month">

!   <OVERVIEW>
!       Given a time interval, gives the number of days in the
!       month corresponding to the default calendar.
!   </OVERVIEW>
!   <DESCRIPTION>
!       Given a time, computes the corresponding date given the selected
!       date time mapping algorithm.
!   </DESCRIPTION>
!   <TEMPLATE> days_in_month(time) </TEMPLATE>

!   <IN NAME="time" UNITS="" TYPE="time_type" DIM="">A time interval.</IN>
!   <OUT NAME="days_in_month" UNITS="" TYPE="integer" DIM="" DEFAULT="">
!       The number of days in the month given the selected time
!       mapping algorithm.
!   </OUT>

function days_in_month(Time, err_msg)

! Given a time, computes the corresponding date given the selected
! date time mapping algorithm

integer :: days_in_month
type(time_type), intent(in) :: Time
character(len=*), intent(out), optional :: err_msg

if(.not.module_is_initialized) call time_manager_init
if(present(err_msg)) err_msg = ''

select case(calendar_type)
case(THIRTY_DAY_MONTHS)
   days_in_month = days_in_month_thirty(Time)
case(GREGORIAN)
   days_in_month = days_in_month_gregorian(Time)
case(JULIAN)
   days_in_month = days_in_month_julian(Time)
case(NOLEAP)
   days_in_month = days_in_month_no_leap(Time)
case(NO_CALENDAR)
   if(error_handler('function days_in_month', &
         'days_in_month makes no sense when the calendar type is NO_CALENDAR', err_msg)) return
case default
   if(error_handler('function days_in_month', 'Invalid calendar type', err_msg)) return
end select
end function days_in_month
! </FUNCTION>

!--------------------------------------------------------------------------

function days_in_month_gregorian(Time)

! Returns the number of days in a gregorian month.

integer :: days_in_month_gregorian
type(time_type), intent(in) :: Time
integer :: year, month, day, hour, minute, second, ticks

call get_date_gregorian(Time, year, month, day, hour, minute, second, ticks)
days_in_month_gregorian = days_per_month(month)
if(leap_year_gregorian_int(year) .and. month == 2) days_in_month_gregorian = 29

end function days_in_month_gregorian

!--------------------------------------------------------------------------
function days_in_month_julian(Time)

! Returns the number of days in a julian month.

integer :: days_in_month_julian
type(time_type), intent(in) :: Time
integer :: year, month, day, hour, minute, second, ticks

call get_date_julian_private(Time, year, month, day, hour, minute, second, ticks)
days_in_month_julian = days_per_month(month)
if(leap_year_julian(Time) .and. month == 2) days_in_month_julian = 29

end function days_in_month_julian

!--------------------------------------------------------------------------
function days_in_month_thirty(Time)

! Returns the number of days in a thirty day month (needed for transparent
! changes to calendar type).

integer :: days_in_month_thirty
type(time_type), intent(in) :: Time

days_in_month_thirty = 30

end function days_in_month_thirty

!--------------------------------------------------------------------------
function days_in_month_no_leap(Time)

! Returns the number of days in a 365 day year month.

integer :: days_in_month_no_leap
type(time_type), intent(in) :: Time
integer :: year, month, day, hour, minute, second, ticks

call get_date_no_leap_private(Time, year, month, day, hour, minute, second, ticks)
days_in_month_no_leap= days_per_month(month)

end function days_in_month_no_leap

! END OF days_in_month BLOCK
!==========================================================================
! START OF leap_year BLOCK
! <FUNCTION NAME="leap_year">

!   <OVERVIEW>
!      Returns true if the year corresponding to the input time is
!      a leap year. Always returns false for THIRTY_DAY_MONTHS and NOLEAP.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Returns true if the year corresponding to the input time is
!      a leap year. Always returns false for THIRTY_DAY_MONTHS and NOLEAP.
!   </DESCRIPTION>
!   <TEMPLATE> leap_year(time) </TEMPLATE>

!   <IN NAME="time" UNITS="" TYPE="time_type" DIM="">A time interval.</IN>
!   <OUT NAME="leap_year" UNITS="" TYPE="calendar_type" DIM="" DEFAULT="">
!      true if the year corresponding to the input time is a leap year.
!   </OUT>

function leap_year(Time, err_msg)

! Is this date in a leap year for default calendar?

logical :: leap_year
type(time_type), intent(in) :: Time
character(len=*), intent(out), optional :: err_msg

if(.not.module_is_initialized) call time_manager_init
if(present(err_msg)) err_msg=''

select case(calendar_type)
case(THIRTY_DAY_MONTHS)
   leap_year = leap_year_thirty(Time)
case(GREGORIAN)
   leap_year = leap_year_gregorian(Time)
case(JULIAN)
   leap_year = leap_year_julian(Time)
case(NOLEAP)
   leap_year = leap_year_no_leap(Time)
case default
   if(error_handler('function leap_year', 'Invalid calendar type in leap_year', err_msg)) return
end select
end function leap_year
! </FUNCTION>

!--------------------------------------------------------------------------

function leap_year_gregorian(Time)

! Is this a leap year for gregorian calendar?

logical :: leap_year_gregorian
type(time_type), intent(in) :: Time
integer :: seconds, minutes, hours, day, month, year

call get_date(Time, year, month, day, hours, minutes, seconds)
leap_year_gregorian = leap_year_gregorian_int(year)

end function leap_year_gregorian

!--------------------------------------------------------------------------

function leap_year_gregorian_int(year)
logical :: leap_year_gregorian_int
integer, intent(in) :: year

leap_year_gregorian_int = mod(year,4) == 0
leap_year_gregorian_int = leap_year_gregorian_int .and. .not.mod(year,100) == 0
leap_year_gregorian_int = leap_year_gregorian_int .or. mod(year,400) == 0

end function leap_year_gregorian_int

!--------------------------------------------------------------------------

function leap_year_julian(Time)

! Returns the number of days in a julian month.

logical :: leap_year_julian
type(time_type), intent(in) :: Time
integer :: seconds, minutes, hours, day, month, year

call get_date(Time, year, month, day, hours, minutes, seconds)
leap_year_julian = ((year / 4 * 4) == year)

end function leap_year_julian

!--------------------------------------------------------------------------

function leap_year_thirty(Time)

! No leap years in thirty day months, included for transparency. 

logical :: leap_year_thirty
type(time_type), intent(in) :: Time

leap_year_thirty = .FALSE.

end function leap_year_thirty

!--------------------------------------------------------------------------

function leap_year_no_leap(Time)

! Another tough one; no leap year returns false for leap year inquiry.

logical :: leap_year_no_leap
type(time_type), intent(in) :: Time

leap_year_no_leap = .FALSE.

end function leap_year_no_leap

!END OF leap_year BLOCK
!==========================================================================
! START OF length_of_year BLOCK
! <FUNCTION NAME="length_of_year">

!   <OVERVIEW>
!      Returns the mean length of the year in the default calendar setting. 
!   </OVERVIEW>
!   <DESCRIPTION>
!      There are no arguments in this function. It returns the mean
!      length of the year in the default calendar setting.
!   </DESCRIPTION>
!   <TEMPLATE> length_of_year() </TEMPLATE>

function length_of_year()

! What is the length of the year for the default calendar type

type(time_type) :: length_of_year

if(.not.module_is_initialized) call time_manager_init

select case(calendar_type)
case(THIRTY_DAY_MONTHS)
   length_of_year = length_of_year_thirty()
case(GREGORIAN)
   length_of_year = length_of_year_gregorian()
case(JULIAN)
   length_of_year = length_of_year_julian()
case(NOLEAP)
   length_of_year = length_of_year_no_leap()
case default
   call error_mesg('length_of_year','Invalid calendar type in length_of_year',FATAL)
end select
end function length_of_year
! </FUNCTION>

!--------------------------------------------------------------------------

function length_of_year_thirty()

type(time_type) :: length_of_year_thirty

length_of_year_thirty = set_time(0, 360)

end function length_of_year_thirty

!---------------------------------------------------------------------------

function length_of_year_gregorian()

type(time_type) :: length_of_year_gregorian
integer :: days, seconds

days = days_in_400_year_period / 400
seconds = 86400*(days_in_400_year_period/400. - days)
length_of_year_gregorian = set_time(seconds, days)

end function length_of_year_gregorian

!--------------------------------------------------------------------------

function length_of_year_julian()

type(time_type) :: length_of_year_julian

length_of_year_julian = set_time((24 / 4) * 60 * 60, 365)

end function length_of_year_julian

!--------------------------------------------------------------------------

function length_of_year_no_leap()

type(time_type) :: length_of_year_no_leap

length_of_year_no_leap = set_time(0, 365)

end function length_of_year_no_leap

!--------------------------------------------------------------------------

! END OF length_of_year BLOCK
!==========================================================================

! START OF days_in_year BLOCK
! <FUNCTION NAME="days_in_year">

!   <OVERVIEW>
!      Returns the number of days in the calendar year corresponding to
!      the date represented by time for the default calendar.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Returns the number of days in the calendar year corresponding to
!      the date represented by time for the default calendar.
!   </DESCRIPTION>
!   <TEMPLATE> days_in_year(Time) </TEMPLATE>
!   <IN NAME="Time" TYPE="time_type">A time interval.</IN>
!   <OUT>
!      The number of days in this year for the default calendar type.
!   </OUT>


function days_in_year(Time)

! What is the number of days in this year for the default calendar type

integer :: days_in_year
type(time_type), intent(in) :: Time

if(.not.module_is_initialized) call time_manager_init

select case(calendar_type)
case(THIRTY_DAY_MONTHS)
   days_in_year = days_in_year_thirty(Time)
case(GREGORIAN)
   days_in_year = days_in_year_gregorian(Time)
case(JULIAN)
   days_in_year = days_in_year_julian(Time)
case(NOLEAP)
   days_in_year = days_in_year_no_leap(Time)
case default
   call error_mesg('days_in_year','Invalid calendar type in days_in_year',FATAL)
end select
end function days_in_year
! </FUNCTION>

!--------------------------------------------------------------------------

function days_in_year_thirty(Time)

integer :: days_in_year_thirty
type(time_type), intent(in) :: Time

days_in_year_thirty = 360

end function days_in_year_thirty

!---------------------------------------------------------------------------

function days_in_year_gregorian(Time)

integer :: days_in_year_gregorian
type(time_type), intent(in) :: Time

if(leap_year_gregorian(Time)) then
  days_in_year_gregorian = 366
else
  days_in_year_gregorian = 365
endif

end function days_in_year_gregorian

!--------------------------------------------------------------------------
function days_in_year_julian(Time)

integer :: days_in_year_julian
type(time_type), intent(in) :: Time

if(leap_year_julian(Time)) then
   days_in_year_julian = 366
else
   days_in_year_julian = 365
endif

end function days_in_year_julian

!--------------------------------------------------------------------------

function days_in_year_no_leap(Time)

integer :: days_in_year_no_leap
type(time_type), intent(in) :: Time

days_in_year_no_leap = 365

end function days_in_year_no_leap

!--------------------------------------------------------------------------

! END OF days_in_year BLOCK

!==========================================================================
! <FUNCTION NAME="month_name">

!   <OVERVIEW>
!      Returns a character string containing the name of the
!      month corresponding to month number n. 
!   </OVERVIEW>
!   <DESCRIPTION>
!      Returns a character string containing the name of the
!      month corresponding to month number n. Definition is the
!      same for all calendar types. 
!   </DESCRIPTION>
!   <TEMPLATE> month_name(n) </TEMPLATE>
!   <IN NAME="n" TYPE="integer">Month number.</IN>
!   <OUT NAME="month_name" TYPE="character(len=9)">
!      The character string associated with a month.
!      All calendars have 12 months and return full
!      month names, not abreviations.
!   </OUT>

function month_name(n)

! Returns character string associated with a month, for now, all calendars
! have 12 months and will return standard names.

character (len=9) :: month_name
integer, intent(in) :: n
character (len = 9), dimension(12) :: months = (/'January  ', 'February ', &
          'March    ', 'April    ', 'May      ', 'June     ', 'July     ', &
          'August   ', 'September', 'October  ', 'November ', 'December '/) 

if(.not.module_is_initialized) call time_manager_init

if(n < 1 .or. n > 12) call error_mesg('month_name','Illegal month index',FATAL)

month_name = months(n)

end function month_name
! </FUNCTION>

!==========================================================================

 function error_handler(routine, err_msg_local, err_msg)

! The purpose of this routine is to prevent the addition of an excessive amount of code in order to implement
! the error handling scheme involving an optional error flag of type character.
! It allows one line of code to accomplish what would otherwise require 6 lines.
! A value of .true. for this function is a flag to the caller that it should immediately return to it's caller.

 logical :: error_handler
 character(len=*), intent(in) :: routine, err_msg_local
 character(len=*), intent(out), optional :: err_msg

 error_handler = .false.
 if(present(err_msg)) then
   err_msg = err_msg_local
   error_handler = .true.    
 else
   call error_mesg(trim(routine),trim(err_msg_local),FATAL)
 endif

 end function error_handler

!==========================================================================
!------------------------------------------------------------------------
! <SUBROUTINE NAME="time_manager_init">

!   <OVERVIEW>
!      Writes the version information to the log file
!   </OVERVIEW>
!   <DESCRIPTION>
!      Initialization routine.
!      Writes the version information to the log file
!   </DESCRIPTION>
!   <TEMPLATE>time_manager_init()</TEMPLATE>

subroutine time_manager_init ( )

  if (module_is_initialized) return  ! silent return if already called

  call write_version_number (version, tagname)
  module_is_initialized = .true.

end subroutine time_manager_init
! </SUBROUTINE>

!------------------------------------------------------------------------
! <SUBROUTINE NAME="print_time">

!   <OVERVIEW>
!      Prints the given time_type argument as a time (using days, seconds and ticks)
!   </OVERVIEW>
!   <DESCRIPTION>
!      Prints the given time_type argument as a time (using days, seconds and ticks)
!      NOTE: there is no check for PE number.
!   </DESCRIPTION>
!   <TEMPLATE>print_time (time,str,unit)</TEMPLATE>
!   <IN NAME="time" TYPE="time_type"> Time that will be printed. </IN>
!   <IN NAME="str" TYPE="character (len=*)" DEFAULT="TIME: or DATE:"> 
!      Character string that precedes the printed time or date.
!   </IN>
!   <IN NAME="unit" TYPE="integer">
!      Unit number for printed output. The default unit is stdout.
!   </IN>
subroutine print_time (Time,str,unit)
type(time_type)  , intent(in) :: Time
character (len=*), intent(in), optional :: str
integer          , intent(in), optional :: unit
integer :: s,d,ticks, ns,nd,nt, unit_in
character(len=19) :: fmt

! prints the time to standard output (or optional unit) as days and seconds
! NOTE: there is no check for PE number

  unit_in = stdout()
  if (present(unit)) unit_in = unit

  call get_time (Time,s,d,ticks)

! format output
! get number of digits for days and seconds strings
   nd = int(log10(real(max(1,d))))+1
   ns = int(log10(real(max(1,s))))+1
   nt = int(log10(real(max(1,ticks))))+1
   write (fmt,10) nd, ns, nt
10 format ('(a,i',i2.2,',a,i',i2.2,',a,i',i2.2,')')

  if (present(str)) then
     write (unit_in,fmt) trim(str)//' day=', d, ', sec=', s, ', ticks=', ticks
  else
     write (unit_in,fmt)       'TIME: day=', d, ', sec=', s, ', ticks=', ticks
  endif

end subroutine print_time
! </SUBROUTINE>

!------------------------------------------------------------------------
! <SUBROUTINE NAME="print_date">

!   <OVERVIEW>
!      prints the time to standard output (or optional unit) as a date.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Prints the given time_type argument as a date (using year, month, day,
!      hour, minutes, seconds and ticks). NOTE: there is no check for PE number.
!   </DESCRIPTION>
!   <TEMPLATE> print_date (time,str,unit)
!   </TEMPLATE>
!   <IN NAME="time" TYPE="time_type"> Time that will be printed. </IN>
!   <IN NAME="str" TYPE="character (len=*)" DEFAULT="TIME: or DATE:"> 
!      Character string that precedes the printed time or date.
!   </IN>
!   <IN NAME="unit" TYPE="integer">
!      Unit number for printed output. The default unit is stdout.
!   </IN>

subroutine print_date (Time,str,unit)
type(time_type)  , intent(in) :: Time
character (len=*), intent(in), optional :: str
integer          , intent(in), optional :: unit
integer :: y,mo,d,h,m,s, unit_in
character(len=9) :: mon

! prints the time to standard output (or optional unit) as a date
! NOTE: there is no check for PE number

  unit_in = stdout()
  if (present(unit)) unit_in = unit

  call get_date (Time,y,mo,d,h,m,s)
  mon = month_name(mo)
  if (present(str)) then
     write (unit_in,10) trim(str)//' ', y,mon(1:3),' ',d,' ',h,':',m,':',s
  else
     write (unit_in,10)       'DATE: ', y,mon(1:3),' ',d,' ',h,':',m,':',s
  endif
10 format (a,i4,1x,a3,4(a1,i2.2))

end subroutine print_date
! </SUBROUTINE>

!------------------------------------------------------------------------
! <FUNCTION NAME="valid_calendar_types">

!   <OVERVIEW>
!     Returns a character string that describes the
!     calendar type corresponding to the input integer.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Returns a character string that describes the
!     calendar type corresponding to the input integer.
!   </DESCRIPTION>
!   <IN NAME="ncal" TYPE="integer">
!     An integer corresponding to a valid calendar type.
!   </IN>
!   <OUT NAME="err_msg" TYPE="character, optional" DIM="(scalar)">
!     When present, and when non-blank, a fatal error condition as been detected.
!     The string itself is an error message.
!     It is recommended that, when err_msg is present in the call
!     to this routine, the next line of code should be something
!     similar to this:
!     if(err_msg /= '') call error_mesg('my_routine','additional info: '//trim(err_msg),FATAL)
!   </OUT>
!   <OUT NAME="valid_calendar_types" TYPE="character(len=24)">
!     A character string describing the calendar type.
!   </OUT>

function valid_calendar_types(ncal, err_msg)
integer, intent(in) :: ncal
character(len=*), intent(out), optional :: err_msg
character(len=24) :: valid_calendar_types
character(len=128) :: err_msg_local

if(.not.module_is_initialized) call time_manager_init

if(present(err_msg)) err_msg = ''

if(ncal == NO_CALENDAR) then
  valid_calendar_types = 'NO_CALENDAR             '
else if(ncal == THIRTY_DAY_MONTHS) then
  valid_calendar_types = 'THIRTY_DAY_MONTHS       '
else if(ncal == JULIAN) then
  valid_calendar_types = 'JULIAN                  '
else if(ncal == GREGORIAN) then
  valid_calendar_types = 'GREGORIAN               '
else if(ncal == NOLEAP) then
  valid_calendar_types = 'NOLEAP                  '
else
  write(err_msg_local,'(a,i4,a)') 'calendar type=',ncal,' is invalid.'
  if(error_handler('function valid_calendar_types', err_msg_local, err_msg)) return
endif
end function valid_calendar_types
! </FUNCTION>
!------------------------------------------------------------------------

!--- get the a character string that represents the time. The format will be 
!--- yyyymmdd.hhmmss
function date_to_string(time, err_msg)
  type(time_type),  intent(in)            :: time
  character(len=*), intent(out), optional :: err_msg
  character(len=128)                      :: err_msg_local
  character(len=15)                       :: date_to_string
  integer                                 :: yr,mon,day,hr,min,sec

  if(present(err_msg)) err_msg = ''
  call get_date(time,yr,mon,day,hr,min,sec)
  if (yr <= 9999) then
     write(date_to_string,'(I4.4,I2.2,I2.2,".",I2.2,I2.2,I2.2)') yr, mon, day, hr, min, sec
  else
     write(err_msg_local, '(a,i4.4,a)') 'year = ', yr, ' should be less than 10000'
     if(error_handler('function date_to_string', err_msg_local, err_msg)) return
  endif

end function date_to_string

end module time_manager_mod

! <INFO>

!   <TESTPROGRAM NAME="time_main2">  
!    <PRE>
!        use time_manager_mod
!        implicit none
!        type(time_type) :: dt, init_date, astro_base_date, time, final_date
!        type(time_type) :: next_rad_time, mid_date
!        type(time_type) :: repeat_alarm_freq, repeat_alarm_length
!        integer :: num_steps, i, days, months, years, seconds, minutes, hours
!        integer :: months2, length
!        real :: astro_days
!   
!   !Set calendar type
!   !    call set_calendar_type(THIRTY_DAY_MONTHS)
!        call set_calendar_type(JULIAN)
!   !    call set_calendar_type(NOLEAP)
!   
!   ! Set timestep
!        dt = set_time(1100, 0)
!   
!   ! Set initial date
!        init_date = set_date(1992, 1, 1)
!   
!   ! Set date for astronomy delta calculation
!        astro_base_date = set_date(1970, 1, 1, 12, 0, 0)
!   
!   ! Copy initial time to model current time
!        time = init_date
!   
!   ! Determine how many steps to do to run one year
!        final_date = increment_date(init_date, years = 1)
!        num_steps = (final_date - init_date) / dt
!        write(*, *) 'Number of steps is' , num_steps
!   
!   ! Want to compute radiation at initial step, then every two hours
!        next_rad_time = time + set_time(7200, 0)
!   
!   ! Test repeat alarm
!        repeat_alarm_freq = set_time(0, 1)
!        repeat_alarm_length = set_time(7200, 0)
!   
!   ! Loop through a year
!        do i = 1, num_steps
!   
!   ! Increment time
!        time = time + dt
!   
!   ! Test repeat alarm
!        if(repeat_alarm(time, repeat_alarm_freq, repeat_alarm_length)) &
!        write(*, *) 'REPEAT ALARM IS TRUE'
!   
!   ! Should radiation be computed? Three possible tests.
!   ! First test assumes exact interval; just ask if times are equal
!   !     if(time == next_rad_time) then
!   ! Second test computes rad on last time step that is <= radiation time
!   !     if((next_rad_time - time) < dt .and. time < next_rad) then
!   ! Third test computes rad on time step closest to radiation time
!         if(interval_alarm(time, dt, next_rad_time, set_time(7200, 0))) then
!           call get_date(time, years, months, days, hours, minutes, seconds)
!           write(*, *) days, month_name(months), years, hours, minutes, seconds
!   
!   ! Need to compute real number of days between current time and astro_base
!           call get_time(time - astro_base_date, seconds, days)
!           astro_days = days + seconds / 86400.
!   !       write(*, *) 'astro offset ', astro_days
!        end if
!   
!   ! Can compute daily, monthly, yearly, hourly, etc. diagnostics as for rad
!   
!   ! Example: do diagnostics on last time step of this month
!        call get_date(time + dt, years, months2, days, hours, minutes, seconds)
!        call get_date(time, years, months, days, hours, minutes, seconds)
!        if(months /= months2) then
!           write(*, *) 'last timestep of month'
!           write(*, *) days, months, years, hours, minutes, seconds
!        endif
!   
!   ! Example: mid-month diagnostics; inefficient to make things clear
!        length = days_in_month(time)
!        call get_date(time, years, months, days, hours, minutes, seconds)
!        mid_date = set_date(years, months, 1) + set_time(0, length) / 2
!   
!        if(time < mid_date .and. (mid_date - time) < dt) then
!           write(*, *) 'mid-month time'
!           write(*, *) days, months, years, hours, minutes, seconds
!        endif
!   
!        end do
!   
!    </PRE>
!   end program time_main2

!   </TESTPROGRAM>
!   <NOTE>
!     The <a name="base date">base date</a> is implicitly defined so users don't 
!     need to be concerned with it. For the curious, the base date is defined as 
!     0 seconds, 0 minutes, 0 hours, day 1, month 1, year 1
!   </NOTE>
!   <NOTE>
!     Please note that a time is a positive definite quantity.
!   </NOTE>
!   <NOTE>
!     See the <LINK SRC="TEST PROGRAM">Test Program </LINK> for a simple program 
!     that shows some of the capabilities of the time manager.
!   </NOTE>
! </INFO>

#ifdef test_time_manager
 program test
 use          mpp_mod, only: input_nml_file
 use          fms_mod, only: fms_init, fms_end, stderr
 use          fms_mod, only: open_namelist_file, check_nml_error, close_file, open_file
 use    constants_mod, only: constants_init, rseconds_per_day=>seconds_per_day
 use       fms_io_mod, only: fms_io_exit
 use time_manager_mod, only: time_type, set_date, get_date, set_time, set_calendar_type, real_to_time_type
 use time_manager_mod, only: length_of_year, leap_year, days_in_month, days_in_year, print_time
 use time_manager_mod, only: set_ticks_per_second, get_ticks_per_second
 use time_manager_mod, only: decrement_date, increment_date, get_time, increment_time, decrement_time
 use time_manager_mod, only: JULIAN, GREGORIAN, THIRTY_DAY_MONTHS, NOLEAP
 use time_manager_mod, only: operator(-), operator(+),  operator(*),  operator(/),  &
                             operator(>), operator(>=), operator(==), operator(/=), &
                             operator(<), operator(<=), operator(//), assignment(=)

 implicit none

 type(time_type) :: Time, time1, time2
 real    :: xx
 integer :: yr, mo, day, hr, min, sec, ticks
 integer :: year, month, dday, days_this_month
 integer :: days_per_month(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)
 logical :: leap
 integer :: nr, icode, nmlunit, ierr, io, nn, errunit, outunit
 character(len=256) :: err_msg, char_date
 character(len=8),  allocatable, dimension(:) :: test_time
 character(len=23), allocatable, dimension(:) :: test_date
 character(len=8) :: test_name

logical :: test1 =.true.,test2 =.true.,test3 =.true.,test4 =.true.,test5 =.true.,test6 =.true.,test7 =.true.,test8 =.true.
logical :: test9 =.true.,test10=.true.,test11=.true.,test12=.true.,test13=.true.,test14=.true.,test15=.true.,test16=.true.
logical :: test17=.true.,test18=.true.,test19=.true.

 namelist / test_nml / test1 ,test2 ,test3 ,test4 ,test5 ,test6 ,test7 ,test8,  &
                       test9 ,test10,test11,test12,test13,test14,test15,test16, &
                       test17,test18,test19

 call fms_init
 call constants_init

#ifdef INTERNAL_FILE_NML
   read (input_nml_file, test_nml, iostat=io)
   ierr = check_nml_error (io, 'test_nml')
#else
 nmlunit = open_namelist_file()
 ierr=1
 do while (ierr /= 0)
   read(nmlunit, nml=test_nml, iostat=io, end=12)
   ierr = check_nml_error (io, 'test_nml')
 enddo
 12 call close_file (nmlunit)
#endif

 outunit = open_file(file='test_time_manager.out', form='formatted', action='write')
 errunit = stderr()
 call set_ticks_per_second(10)

 !==============================================================================================
 ! Tests of set_time_i and get_time without ticks

 if(test1) then
   write(outunit,'(/,a)') '#################################  test1  #################################' 
   Time = set_time(seconds=2, days=1)
   call get_time(Time, sec, day, ticks)
   write(outunit,'(a,i2,a,i8,a,i2)') ' test1.1: days=',day,' seconds=',sec,' ticks=',ticks
   call get_time(Time, sec, day)
   write(outunit,'(a,i2,a,i8)') ' test1.2: days=',day,' seconds=',sec
   call get_time(Time, sec)
   write(outunit,'(a,i8)') ' test1.2: seconds=',sec
 endif
 !==============================================================================================
 ! Tests of set_time_i and get_time with ticks

 if(test2) then
   write(outunit,'(/,a)') '#################################  test2  #################################' 
   Time = set_time(seconds=2, days=1, ticks=5)
   call get_time(Time, sec, day, ticks)
   write(outunit,'(a,i2,a,i6,a,i2)') ' test2.1: days=',day,' seconds=',sec,' ticks=',ticks
   call get_time(Time, sec, ticks=ticks)
   write(outunit,'(a,i6,a,i2)') ' test2.2: seconds=',sec,' ticks=',ticks
   call get_time(Time, sec, day, err_msg=err_msg)
   if(err_msg /= '') then
     write(outunit,'(a)') ' test2.3 successful: '//trim(err_msg)
   else
     write(outunit,'(a,i2,a,i8)') ' test2.3 fails. days=',day,' seconds=',sec
   endif
   call get_time(Time, sec, err_msg=err_msg)
   if(err_msg /= '') then
     write(outunit,'(a)') ' test2.4 successful: '//trim(err_msg)
   else
     write(outunit,'(a,i8)') ' test2.4 fails.  seconds=',sec
   endif
 endif
 !==============================================================================================
 ! Tests of time operators
 ! Test of function scalar_time_mult is not necessary, it simply calls time_scalar_mult.
 ! Test of function time_ne is not necessary, it simply calls time_eq.
 ! Test of function time_ge is not necessary, it simply calls time_gt.
 ! Test of function time_le is not necessary, it simply calls time_lt and time_eq.
 ! Test of function time_ne is not necessary, it simply calls time_eq.

  if(test3) then
    write(outunit,'(/,a)') '#################################  test3  #################################'
 !  Test of function time_plus
    call print_time(set_time(seconds=0, days=2, ticks=5) + set_time(seconds=0, days=2, ticks=6), 'test3.1:', unit=outunit)

 !  Test of function time_minus
 !  The minus operator for time ensures a positive result. In effect is does this: abs(time1-time2)
    call print_time(set_time(seconds=0, days=2, ticks=5) - set_time(seconds=0, days=2, ticks=6), 'test3.2:', unit=outunit)

 !  Test of function time_scalar_mult.  Note that 25000*86399 is greater than huge = 2**31 - 1
    call print_time(2*set_time(seconds=0, days=2, ticks=6), 'test3.3:', unit=outunit)
    call print_time(25000*set_time(seconds=86399, days=0, ticks=0), 'test3.4:', unit=outunit)

 !  Test of function time_scalar_divide
    call print_time(set_time(seconds=0, days=60000, ticks=2)/2, 'test3.5:', unit=outunit)

 !  Test of function time_real_divide
    xx = set_time(seconds=0, days=60000, ticks=2)//set_time(seconds=86400)
    write(outunit,'("test3.6: xx=",f15.9)') xx

 !  Test of function time_divide
    nn = set_time(seconds=0, days=60000, ticks=2)//set_time(seconds=86400)
    write(outunit,'("test3.7: nn=",i6)') nn

 !  Test of function time_gt
    if(set_time(seconds=1, days=1, ticks=2) > set_time(seconds=1, days=1, ticks=1)) then
      write(outunit,'("test3.8 successful")')
    else
      write(outunit,'("test3.8 fails")')
    endif
    if(set_time(seconds=1, days=1, ticks=2) > set_time(seconds=1, days=1, ticks=2)) then
      write(outunit,'("test3.9 fails")')
    else
      write(outunit,'("test3.9 successful")')
    endif

 !  Test of function time_lt
    if(set_time(seconds=1, days=1, ticks=1) < set_time(seconds=1, days=1, ticks=2)) then
      write(outunit,'("test3.10 successful")')
    else
      write(outunit,'("test3.10 fails")')
    endif
    if(set_time(seconds=1, days=1, ticks=2) < set_time(seconds=1, days=1, ticks=2)) then
      write(outunit,'("test3.11 fails")')
    else
      write(outunit,'("test3.11 successful")')
    endif

 !  Test of function time_eq
    if(set_time(seconds=1, days=1, ticks=1) == set_time(seconds=1, days=1, ticks=1)) then
      write(outunit,'("test3.12 successful")')
    else
      write(outunit,'("test3.12 fails")')
    endif
    if(set_time(seconds=1, days=1, ticks=1) == set_time(seconds=1, days=1, ticks=2)) then
      write(outunit,'("test3.13 fails")')
    else
      write(outunit,'("test3.13 successful")')
    endif
  endif
 !==============================================================================================
 ! Tests of set_time_c

 if(test4) then
   write(outunit,'(/,a)') '#################################  test4  #################################'
   test_name = 'test4.  '
   allocate(test_time(15))
   test_time( 1: 6) = (/'1 10    ','1 10.   ','1 10.000','1  0.0  ','1   .000','1   .   '/)
   test_time( 7: 9) = (/'1 10.20 ','1 10.300','1  0.40 '/)
   test_time(10:15) = (/'1   .510','2 .50001','1.0 10.2','10.30000','10-0.40 ','10:1.510'/) ! invalid forms
   do nr=1,9
     write(test_name(7:8),'(i2.2)') nr
     Time = set_time(trim(test_time(nr)), err_msg=err_msg, allow_rounding=.false.)
     if(err_msg == '') then
       call print_time(Time, test_name//':', unit=outunit)
     else
       write(outunit,'(a)') test_name//' fails: '//trim(err_msg)
     endif
   enddo

   test_time(1:6) = (/'1   .510','2 .50001','1.0 10.2','10.30000','10-0.40 ','10:1.510'/)
   do nr=10,15
     write(test_name(7:8),'(i2.2)') nr
     Time = set_time(trim(test_time(nr)), err_msg=err_msg, allow_rounding=.false.)
     if(err_msg /= '') then
       write(outunit,'(a)') test_name//' successful: '//trim(err_msg)
     else
       write(outunit,'(a)') test_name//' fails '
     endif
   enddo
 endif

 !==============================================================================================
 ! Tests of set_date_i
 
 if(test5) then
   write(outunit,'(/,a)') '#################################  test5  #################################'
   call set_calendar_type(JULIAN)
   call print_time(set_date(1980, 1, 1, 0, 0, 0),' test5.1:', unit=outunit)
   call print_time(set_date(1980, 1, 2, 3, 4, 5, 6),' test5.2:', unit=outunit)
   call print_time(set_date(1980, 1, 2, tick=6),' test5.3:', unit=outunit)
   Time = set_date(1980, 1, 2, tick=10, err_msg=err_msg)
   if(err_msg == '') then
     write(outunit,'(a)') ' test5.4 fails'
   else
     write(outunit,'(a)') ' test5.4 successful: '//trim(err_msg)
   endif
 endif
 !==============================================================================================
 ! Tests of set_date_c

 if(test6) then
   write(outunit,'(/,a)') '#################################  test6  #################################'
   test_name = 'test6.  '
   call set_calendar_type(GREGORIAN)
   allocate(test_date(6))
   test_date(1:3) = (/' 1980-12-30 01:01:11   ',' 1980-12-30 01:01:11.50',' 1980-12-30 01:01:11.55'/)
   test_date(4:6) = (/' 1980-12-30 01:01:11.96','   1980-1-3 1:1:11     ','   1980-1-3 1:1:11.99  '/)
   do nr=1,6
     write(test_name(7:8),'(i2.2)') nr
     Time = set_date(trim(test_date(nr)), err_msg=err_msg, allow_rounding=.true., zero_year_warning=.true.)
     if(err_msg == '') then
       call print_time(Time,test_name//' successful:', unit=outunit)
     else
       write(outunit,'(a)') test_name//'fails: '//trim(err_msg)
     endif
   enddo
   call set_calendar_type(THIRTY_DAY_MONTHS)
   call print_time(set_date('1900-02-30 00:00:00'),'test6.7:', unit=outunit)
   Time = set_date('1900-01-31 00:00:00', err_msg=err_msg)
   if(err_msg == '') then
     write(outunit,'(a)') 'test6.8 fails'
   else
     write(outunit,'(a)') 'test6.8 successful '//trim(err_msg)
   endif
   call set_calendar_type(JULIAN)
   Time = set_date('1901-02-29 00:00:00', err_msg=err_msg)
   if(err_msg == '') then
     write(outunit,'(a)') 'test6.9 fails'
   else
     write(outunit,'(a)') 'test6.9 successful '//trim(err_msg)
   endif
 endif
!==============================================================================================
! Tests of decrement_date and increment_date

 if(test7) then
   write(outunit,'(/,a)') '#################################  test7  #################################'
   char_date = '1904-01-01 00:00:00'
   write(outunit,'(a)') ' Initial date='//trim(char_date)//':00'

   do nr=1,4
     write(outunit,'("=================================================================")')
     if(nr == 1) then
       call set_calendar_type(THIRTY_DAY_MONTHS)
       write(outunit,'(" THIRTY_DAY_MONTHS")')
     endif
     if(nr == 2) then
       call set_calendar_type(NOLEAP)
       write(outunit,'(" NOLEAP")')
     endif
     if(nr == 3) then
       call set_calendar_type(JULIAN)
       write(outunit,'(" JULIAN")')
     endif
     if(nr == 4) then
       call set_calendar_type(GREGORIAN)
       write(outunit,'(" GREGORIAN")')
     endif
     time1 = set_date(trim(char_date))
     do year=-1,1
       do month=-1,1
         write(outunit,'(" test of decrement_date increments: year=",i2," month=",i2)') year,month
         time2 = decrement_date(time1, year, month, err_msg=err_msg)
         if(err_msg /= '') then
           write(outunit,'(a)') 'test of decrement_date fails '//trim(err_msg)
         else
           call get_date(time2, yr, mo, day, hr, min, sec, ticks)
           write(outunit,20) yr, mo, day, hr, min, sec, ticks
         endif
       enddo
     enddo
     time1 = set_date(1, 1, 2, 1, 1, 1, 1, err_msg)
     write(outunit,'(" Initial date = 01-01-02 01:01:01:01")')
     do icode=0,242
       day   = modulo(icode/81,3) - 1
       hr    = modulo(icode/27,3) - 1
       min   = modulo(icode/9, 3) - 1
       sec   = modulo(icode/3, 3) - 1
       ticks = modulo(icode   ,3) - 1
       write(outunit,11) day, hr, min, sec, ticks
       time2 = increment_date(time1, 0, 0, day, hr, min, sec, ticks, err_msg)
       call get_date(time2, yr, mo, day, hr, min, sec, ticks)
       write(outunit,20) yr, mo, day, hr, min, sec, ticks
     enddo
   enddo
 endif

  11 format(' test of increment_date increments: day=',i2,' hr=',i2,' min=',i2,' sec=',i2,' ticks=',i2)
  20 format(' time=',i4.4, '-', i2.2, '-', i2.2, ' ', i2.2, ':', i2.2, ':', i2.2, ':', i2.2)
 !==============================================================================================
 ! Tests involving Feb 29

  if(test8) then
    write(outunit,'(/,a)') '#################################  test8  #################################'
    call set_calendar_type(THIRTY_DAY_MONTHS)
    Time = set_date('1904-02-29 00:00:00', err_msg=err_msg)
    if(err_msg == '') then
      call print_time(Time, 'test8.1 successful', unit=outunit)
    else
      write(outunit,'(a)') 'test8.1 fails: '//trim(err_msg)
    endif

    call set_calendar_type(NOLEAP)
    Time = set_date('1904-02-29 00:00:00', err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test8.2 fails'
    else
      write(outunit,'(a)') 'test8.2 successful: '//trim(err_msg)
    endif

    call set_calendar_type(GREGORIAN)
    Time = set_date('1900-02-29 00:00:00', err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test8.3 fails'
    else
      write(outunit,'(a)') 'test8.3 successful: '//trim(err_msg)
    endif
    Time = set_date('2000-02-29 00:00:00', err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test8.4 successful'
    else
      write(outunit,'(a)') 'test8.4 fails: '//trim(err_msg)
    endif

    call set_calendar_type(JULIAN)
    Time = set_date('1900-02-29 00:00:00', err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test8.5 successful'
    else
      write(outunit,'(a)') 'test8.5 fails: '//trim(err_msg)
    endif
    Time = set_date('1901-02-29 00:00:00', err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test8.6 fails'
    else
      write(outunit,'(a)') 'test8.6 successful: '//trim(err_msg)
    endif
  endif
 !==============================================================================================
 ! Tests of days_in_month

  if(test9) then
    write(outunit,'(/,a)') '#################################  test9  #################################'
    day = days_in_month(set_date('1901-02-28 00:00:00'))
    write(outunit,'(a,i4)') ' test9.1: day=',day
    day = days_in_month(set_date('1901-07-01 00:00:00'))
    write(outunit,'(a,i4)') ' test9.2: day=',day
  endif
 !==============================================================================================
 ! Tests of get_time error flag

  if(test10) then
    write(outunit,'(/,a)') '#################################  test10  #################################'
    Time = set_time(seconds=2, days=1, ticks=1)
    call get_time(Time, seconds=sec, days=day, err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test10.1 fails'
    else
      write(outunit,'(a)') 'test10.1 successful: '//trim(err_msg)
    endif
    call set_calendar_type(GREGORIAN)
    Time = set_time(seconds=2, days=1, ticks=1)
    call get_date(Time, yr, mo, day, hr, min, sec, err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test10.2 fails'
    else
      write(outunit,'(a)') 'test10.2 successful: '//trim(err_msg)
    endif
  endif
 !==============================================================================================
 ! Tests of increment_time and decrement_time
      
  if(test11) then
    write(outunit,'(/,a)') '#################################  test11  #################################'
    call print_time(increment_time(set_time(seconds=0, days=2), seconds=0, days=1),'test11.1:', unit=outunit)
    call print_time(decrement_time(set_time(seconds=0, days=2), seconds=0, days=1),'test11.2:', unit=outunit)
    call print_time(increment_time(set_time(seconds=0, days=2, ticks=5), seconds=400, days=1, ticks=14),'test11.3:', unit=outunit)
    call print_time(decrement_time(set_time(seconds=0, days=2, ticks=5), seconds=400, days=1, ticks=14),'test11.4:', unit=outunit)
  endif
 !==============================================================================================
 !  Tests of negative increments in increment_time and decrement_time

  if(test12) then
    write(outunit,'(/,a)') '#################################  test12  #################################'
    call print_time(increment_time(set_time(seconds=0, days=2), seconds=0, days=-1),'test12.1:', unit=outunit)
    call print_time(decrement_time(set_time(seconds=0, days=2), seconds=0, days=-1),'test12.2:', unit=outunit)
    call print_time(increment_time(set_time(seconds=0, days=2, ticks=5),seconds=-400,days=-1,ticks=-14),'test12.3:',unit=outunit)
    call print_time(decrement_time(set_time(seconds=0, days=2, ticks=5),seconds=-400,days=-1,ticks=-14),'test12.4:',unit=outunit)
  endif
 !==============================================================================================
 !  Test of trap for negative time

  if(test13) then
    write(outunit,'(/,a)') '#################################  test13  #################################'
    Time = set_time(seconds= 2, days=0, ticks=-21, err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test13.1 fails'
    else
      write(outunit,'(a)') 'test13.1 successful: '//trim(err_msg)
    endif
  endif
 !==============================================================================================
 !  Tests of negative seconds and/or ticks

  if(test14) then
    write(outunit,'(/,a)') '#################################  test14  #################################'
    call print_time(set_time(seconds=-86399, days=2, ticks=-10),'test14.1:', unit=outunit)
    call print_time(set_time(seconds=-86390, days=2, ticks=-95),'test14.2:', unit=outunit)
    call print_time(set_time(seconds= 86400, days=2, ticks= 95),'test14.3:', unit=outunit)
  endif
 !==============================================================================================
 !  Tests of consistency of day numbering between calendars

  if(test15) then
    write(outunit,'(/,a)') '#################################  test15  #################################'
    call set_calendar_type(GREGORIAN)
    Time = set_date(1, 1, 1)
    call get_time(Time, sec, day)
    write(outunit,10) 'GREGORIAN',day

    call set_calendar_type(JULIAN)
    Time = set_date(1, 1, 1)
    call get_time(Time, sec, day)
    write(outunit,10) 'JULIAN',day

    call set_calendar_type(THIRTY_DAY_MONTHS)
    Time = set_date(1, 1, 1)
    call get_time(Time, sec, day)
    write(outunit,10) 'THIRTY_DAY_MONTHS',day

    call set_calendar_type(NOLEAP)
    Time = set_date(1, 1, 1)
    call get_time(Time, sec, day)
    write(outunit,10) 'NOLEAP',day
  endif

  10 format(a17,' Jan 1 year 1 is day=',i6)

 !==============================================================================================
 ! Tests of error message for invalid dates

  if(test16) then
    write(outunit,'(/,a)') '#################################  test16  #################################'
    call set_calendar_type(GREGORIAN)
    Time = set_date(1900, 1, 32, err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test16.1 fails'
    else
      write(outunit,'(a)') 'test16.1 successful: '//trim(err_msg)
    endif

    Time = set_date(1900, 4, 31, err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test16.2 fails'
    else
      write(outunit,'(a)') 'test16.2 successful: '//trim(err_msg)
    endif

    Time = set_date(1900, 2, 29, err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test16.3 fails'
    else
      write(outunit,'(a)') 'test16.3 successful: '//trim(err_msg)
    endif

    call set_calendar_type(JULIAN)
    Time = set_date(1900, 1, 0, err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test16.4 fails'
    else
      write(outunit,'(a)') 'test16.4 successful: '//trim(err_msg)
    endif

    call set_calendar_type(NOLEAP)
    Time = set_date(1900, 0, 1, err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test16.5 fails'
    else
      write(outunit,'(a)') 'test16.5 successful: '//trim(err_msg)
    endif

    Time = set_date(1900, 1, 1, tick=11, err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test16.6 fails'
    else
      write(outunit,'(a)') 'test16.6 successful: '//trim(err_msg)
    endif

    call set_calendar_type(THIRTY_DAY_MONTHS)
    Time = set_date(1900, 13, 1, err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test16.7 fails'
    else
      write(outunit,'(a)') 'test16.7 successful: '//trim(err_msg)
    endif

    Time = set_date(1900, 12, 31, err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test16.8 fails'
    else
      write(outunit,'(a)') 'test16.8 successful: '//trim(err_msg)
    endif

    call set_calendar_type(JULIAN)
    Time = set_date(1900, 4, 31, err_msg=err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test16.9 fails'
    else
      write(outunit,'(a)') 'test16.9 successful: '//trim(err_msg)
    endif
  endif
 !==============================================================================================
 !  Tests of Gregorian calendar
 !  This test loops through every day of an 400 year period and writes a line to the output file for each day.

  if(test17) then
    write(outunit,'(/,a)') '#################################  test17  #################################'
    write(errunit,'(/,a)') ' ====================================================='
    write(errunit,'(a)')   '  Warning: test17 produces voluminous output.'
    write(errunit,'(a)')   '  It can be turned off with: &test_nml test17=.false./'
    write(errunit,'(a,/)') ' ====================================================='
    call set_calendar_type(GREGORIAN)
    do year=1801,2200
      leap = mod(year,4) == 0
      leap = leap .and. .not.mod(year,100) == 0
      leap = leap .or. mod(year,400) == 0
      do month=1,12
        days_this_month = days_per_month(month)
        if(leap .and. month == 2) days_this_month = 29
        do dday=1,days_this_month
          Time = set_date(year, month, dday, 0, 0, 0) 
          call get_date(Time, yr, mo, day, hr, min, sec)
          write(outunit,100) yr, mo, day, leap_year(Time), days_in_month(Time), days_in_year(Time)
        enddo
      enddo
    enddo
  endif
  100 format('yr=',i4,' mo=',i2,' day=',i2,' leap=',L1,' days_in_month=',i2,' days_in_year=',i3)
 !==============================================================================================
 !  Tests of length_of_year

  if(test18) then
    write(outunit,'(/,a)') '#################################  test18  #################################'
    call set_calendar_type(THIRTY_DAY_MONTHS)
    call print_time(length_of_year(), 'length_of_year for THIRTY_DAY_MONTHS:', unit=outunit)
    call set_calendar_type(NOLEAP)
    call print_time(length_of_year(), 'length_of_year for NOLEAP:', unit=outunit)
    call set_calendar_type(JULIAN)
    call print_time(length_of_year(), 'length_of_year for JULIAN:', unit=outunit)
    call set_calendar_type(GREGORIAN)
    call print_time(length_of_year(), 'length_of_year for GREGORIAN:', unit=outunit)
  endif
 !==============================================================================================
 !  Tests of real_to_time_type

  if(test19) then
    write(outunit,'(/,a)') '#################################  test19  #################################'
    call print_time(real_to_time_type(86401.1), 'real_to_time_type(86401.1):', unit=outunit)
    Time = real_to_time_type(-1.0, err_msg)
    if(err_msg == '') then
      write(outunit,'(a)') 'test of real_to_time_type fails'
    else
      write(outunit,'(a)') 'test successful: '//trim(err_msg)
    endif
  endif
 !==============================================================================================
  write(outunit,'(/,a)') '############################################################################'
  write(outunit,'(a,i6)') ' ticks_per_second=',get_ticks_per_second()

 call fms_io_exit
 call fms_end
 end program test
#endif

#include <fms_platform.h>

! ----------------------------------------------------------------
!                   GNU General Public License                        
! This file is a part of MOM.                                                                 
!                                                                      
! MOM is free software; you can redistribute it and/or modify it and  
! are expected to follow the terms of the GNU General Public License  
! as published by the Free Software Foundation; either version 2 of   
! the License, or (at your option) any later version.                 
!                                                                      
! MOM is distributed in the hope that it will be useful, but WITHOUT    
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
! License for more details.                                           
!                                                                      
! For the full text of the GNU General Public License,                
! write to: Free Software Foundation, Inc.,                           
!           675 Mass Ave, Cambridge, MA 02139, USA.                   
! or see:   http://www.gnu.org/licenses/gpl.html                      
!-----------------------------------------------------------------------
!
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Jennifer Simeon
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Eric Galbraith
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Daniele Bianchi
!</REVIEWER>
!
!<OVERVIEW>
! Ocean Carbon Model Intercomparison Study II: HE module
!</OVERVIEW>
!
!<DESCRIPTION>
!       Implementation of routines to solve the OCMIP-2 HE
!       simulations as outlined in the Helium-HOWTO documentation,
!       revision 1.6, 1999/04/29.
!       Modified Jan 2008 b1d. Separated atmospheric and mantle component
!       and added a factor to chance the source strength
!</DESCRIPTION>
!
! <INFO>
! <REFERENCE>
! http://www.ipsl.jussieu.fr/OCMIP/phase2/simulations/Helium/HOWTO-Helium.html
! </REFERENCE>
! </INFO>
!

module  ocmip2_he_mod

use atmos_ocean_fluxes_mod, only: aof_set_coupler_flux
use time_manager_mod,         only: get_date, time_type
use time_interp_external_mod, only: time_interp_external, init_external_field
use diag_manager_mod,   only: register_diag_field
use field_manager_mod,  only: fm_field_name_len, fm_path_name_len, fm_string_len
use field_manager_mod,  only: fm_get_length, fm_get_value, fm_new_value, fm_get_index
use fms_mod,            only: field_exist
use fms_io_mod,         only: register_restart_field, save_restart, restore_state
use fms_io_mod,         only: restart_file_type
use ocean_tpm_util_mod, only: otpm_set_tracer_package, otpm_set_prog_tracer
use fm_util_mod,        only: fm_util_check_for_bad_fields, fm_util_set_value
use fm_util_mod,        only: fm_util_get_string, fm_util_get_logical, fm_util_get_integer, fm_util_get_real
use fm_util_mod,        only: fm_util_get_logical_array, fm_util_get_real_array, fm_util_get_string_array
use fm_util_mod,        only: fm_util_start_namelist, fm_util_end_namelist
use mpp_mod,            only: stdout, stdlog, mpp_error, mpp_sum, FATAL
use coupler_types_mod,  only: ind_alpha, ind_csurf, coupler_2d_bc_type, ind_flux
use ocean_types_mod,    only: ocean_prog_tracer_type, ocean_grid_type, ocean_time_type
use mpp_domains_mod,    only: domain2d
use ocean_util_mod,     only: diagnose_2d, diagnose_2d_comp, diagnose_3d_comp

implicit none

private

public  :: ocmip2_he_bbc
public  :: ocmip2_he_end
public  :: ocmip2_he_init
public  :: ocmip2_he_flux_init
public  :: ocmip2_he_sbc
public  :: ocmip2_he_source
public  :: ocmip2_he_start
public  :: ocmip2_he_tracer
public  :: ocmip2_he_init_sfc
public  :: ocmip2_he_avg_sfc
public  :: ocmip2_he_sum_sfc
public  :: ocmip2_he_zero_sfc
public  :: ocmip2_he_sfc_end
public  :: ocmip2_he_restart

private :: allocate_arrays

character(len=fm_field_name_len), parameter     :: package_name = 'ocmip2_he'
character(len=48), parameter                    :: mod_name = 'ocmip2_he_mod'
character(len=48), parameter              :: diag_name = 'ocmip2_he'
character(len=fm_string_len), parameter   :: default_restart_file =  'ocmip2_he.res.nc'
character(len=fm_string_len), parameter   :: default_ice_restart_file   =    'ice_ocmip2_he.res.nc'
character(len=fm_string_len), parameter   :: default_ocean_restart_file =  'ocmip2_he_airsea_flux.res.nc'

integer, parameter :: max_he_rec = 1200

type he_type

  real                                  :: a1_4
  real                                  :: a2_4
  real                                  :: a3_4
  real                                  :: a4_4
  real                                  :: d1_4
  real                                  :: d2_4
  real                                  :: d3_4
  real                                  :: e1_4
  real                                  :: e2_4
  real                                  :: e3_4
  real                                  :: he4_sourcefac
  real                                  :: he3_sourcefac
  integer                               :: id_sc_3 = -1
  integer                               :: id_alpha_3_atm = -1
  integer                               :: id_alpha_3_man = -1
  integer                               :: id_sc_4 = -1
  integer                               :: id_alpha_4_atm = -1
  integer                               :: id_alpha_4_man = -1
  integer                               :: id_jhe3_man = -1
  integer                               :: id_jhe4_man = -1
  integer                               :: id_jhe_depth = -1
  integer                               :: ind_he_3_atm
  integer                               :: ind_he_3_man
  integer                               :: ind_he_4_atm
  integer                               :: ind_he_4_man
  integer                               :: ind_jhe_3_man
  integer                               :: ind_jhe_4_man
  integer                               :: ind_he_3_atm_flux
  integer                               :: ind_he_3_man_flux
  integer                               :: ind_he_4_atm_flux
  integer                               :: ind_he_4_man_flux
  character(len=fm_field_name_len)      :: name
  character(len=fm_string_len)          :: restart_file
  real, _ALLOCATABLE, dimension(:,:)    :: sc_3  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: sc_4  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: alpha_3_atm  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: alpha_3_man  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: alpha_4_atm  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: alpha_4_man  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jhe3_man _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jhe4_man _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: jhe_depth _NULL
  integer                               :: id_sfc_flux_he_3_atm = -1
  integer                               :: id_sfc_flux_he_4_atm = -1
  integer                               :: id_sfc_flux_he_3_man = -1
  integer                               :: id_sfc_flux_he_4_man = -1

end type he_type

logical, public :: do_ocmip2_he

type(he_type), allocatable, dimension(:)       :: he
integer                                         :: instances
integer                                         :: package_index
logical                                         :: module_initialized = .false.
real, allocatable, dimension(:,:)               :: sc_no_term
integer                                         :: indsal
integer                                         :: indtemp

character(len=128) :: version = '$Id: ocmip2_he.F90,v 20.0 2013/12/14 00:09:46 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

integer                               :: src_he3_id
character*128                         :: src_he3_file    
character*128                         :: src_he3_name
real, allocatable, dimension(:,:)     :: src_he3_t

integer                               :: src_he4_id
character*128                         :: src_he4_file    
character*128                         :: src_he4_name
real, allocatable, dimension(:,:)     :: src_he4_t

integer                               :: src_he_depth_id
character*128                         :: src_he_depth_file    
character*128                         :: src_he_depth_name
real, allocatable, dimension(:,:)     :: src_he_depth_t

! for restart
type(restart_file_type), allocatable :: Top_restart(:)

contains

!#######################################################################
! <SUBROUTINE NAME="allocate_arrays">
!
! <DESCRIPTION>
!     Dynamically allocate arrays
! </DESCRIPTION>
!
subroutine allocate_arrays(isc, iec, jsc, jec, nk, isd, ied, jsd, jed)

integer, intent(in)     :: isc
integer, intent(in)     :: iec
integer, intent(in)     :: jsc
integer, intent(in)     :: jec
integer, intent(in)     :: nk
integer, intent(in)     :: isd
integer, intent(in)     :: ied
integer, intent(in)     :: jsd
integer, intent(in)     :: jed

integer :: n

allocate( sc_no_term(isc:iec,jsc:jec) )
allocate( src_he3_t(isd:ied,jsd:jed) )
allocate( src_he4_t(isd:ied,jsd:jed) )
allocate( src_he_depth_t(isd:ied,jsd:jed) )

! allocate he array elements
do n = 1, instances
  allocate( he(n)%sc_3(isc:iec,jsc:jec) )
  allocate( he(n)%alpha_3_atm(isc:iec,jsc:jec) )
  allocate( he(n)%alpha_3_man(isc:iec,jsc:jec) )
  allocate( he(n)%jhe3_man(isc:iec,jsc:jec,nk) )
  allocate( he(n)%sc_4(isc:iec,jsc:jec) )
  allocate( he(n)%alpha_4_atm(isc:iec,jsc:jec) )
  allocate( he(n)%alpha_4_man(isc:iec,jsc:jec) )
  allocate( he(n)%jhe4_man(isc:iec,jsc:jec,nk) )
  allocate( he(n)%jhe_depth(isc:iec,jsc:jec) )
enddo

! initialize some arrays
sc_no_term(:,:) = 0.0
src_he3_t(:,:) = 0.0
src_he4_t(:,:) = 0.0
src_he_depth_t(:,:) = 0.0


do n = 1, instances
  he(n)%sc_3(:,:) = 0.0
  he(n)%alpha_3_atm(:,:) = 0.0
  he(n)%alpha_3_man(:,:) = 0.0
  he(n)%jhe3_man(:,:,:) = 0.0
  he(n)%sc_4(:,:) = 0.0
  he(n)%alpha_4_atm(:,:) = 0.0
  he(n)%alpha_4_man(:,:) = 0.0
  he(n)%jhe4_man(:,:,:) = 0.0
  he(n)%jhe_depth(:,:) = 0.0
enddo

return
end subroutine  allocate_arrays
! </SUBROUTINE> NAME="allocate_arrays"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_he_bbc">
!
! <DESCRIPTION>
!       Called each time-step
!     calculate the bottom boundary conditions
! </DESCRIPTION>
!

subroutine ocmip2_he_bbc

end subroutine  ocmip2_he_bbc
! </SUBROUTINE> NAME="ocmip2_he_bbc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_he_end">
!
! <DESCRIPTION>
!       Called once at the end of the run
!     Clean up various HE quantities for this run.
! </DESCRIPTION>
!
subroutine ocmip2_he_end(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,   &
     T_prog, grid_dat, grid_tmask, rho_dzt, taup1)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
integer, intent(in)                                     :: taup1
real, dimension(isd:ied,jsd:jed), intent(in)            :: grid_dat
real, dimension(isd:ied,jsd:jed,nk), intent(in)         :: grid_tmask
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho_dzt

character(len=64), parameter    :: sub_name = 'ocmip2_he_end'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer :: i, j, k, n
real    :: total_he_3_atm
real    :: total_he_4_atm
real    :: total_he_3_man
real    :: total_he_4_man

  integer :: stdoutunit 
  stdoutunit=stdout() 

!       integrate the total concentrations of some tracers
!       for the end of the run
total_he_3_atm = 0.0
total_he_3_man = 0.0
total_he_4_atm = 0.0
total_he_4_man = 0.0

!       Use tau time index for the start of a run, and taup1 time
!       index for the end of a run so that we are integrating the
!       same time level and should therefore get identical results
write (stdoutunit,*) trim(note_header),                           &
     'Global integrals at end of run'

do n = 1, instances

  do k = 1,nk
    do j = jsc, jec
      do i = isc, iec
        total_he_3_atm = total_he_3_atm +                           &
             t_prog(he(n)%ind_he_3_atm)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_he_4_atm = total_he_4_atm +                           &
             t_prog(he(n)%ind_he_4_atm)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_he_3_man = total_he_3_man +                           &
             t_prog(he(n)%ind_he_3_man)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_he_4_man = total_he_4_man +                           &
             t_prog(he(n)%ind_he_4_man)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo

  call mpp_sum(total_he_3_atm)
  call mpp_sum(total_he_4_atm)
  call mpp_sum(total_he_3_man)
  call mpp_sum(total_he_4_man)

  write (stdoutunit,*) '  Instance ', trim(he(n)%name)
  write (stdoutunit,                                              &
       '(/'' Total Atmospheric HE-3  = '',es19.12,'' mol '')')        &
       total_he_3_atm 
  write (stdoutunit,                                              &
       '(/'' Total Atmospheric HE-4  = '',es19.12,'' mol '')')        &
       total_he_4_atm 
  write (stdoutunit,                                              &
       '(/'' Total Mantle HE-3  = '',es19.12,'' mol '')')        &
       total_he_3_man 
  write (stdoutunit,                                              &
       '(/'' Total Mantle HE-4  = '',es19.12,'' mol '')')        &
       total_he_4_man 

enddo

return
end subroutine  ocmip2_he_end
! </SUBROUTINE> NAME="ocmip2_he_end"

!#######################################################################
! <SUBROUTINE NAME="ocmip2_he_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocmip2_he_restart(time_stamp)
  character(len=*),             intent(in), optional :: time_stamp
  integer :: n

  do n=1, instances
     call save_restart(Top_restart(n), time_stamp)
  end do

end subroutine ocmip2_he_restart
! </SUBROUTINE> NAME="ocmip2_he_restart"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_he_sbc">
!
! <DESCRIPTION>
!     Called each time-step
!     Calculate the surface boundary conditions
! </DESCRIPTION>
!
subroutine ocmip2_he_sbc(isc, iec, jsc, jec, &
     isc_bnd, jsc_bnd,      &
     T_prog, Grid, Time, ice_ocean_boundary_fluxes)

integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: isc_bnd
integer, intent(in)                                             :: jsc_bnd
type(ocean_prog_tracer_type), intent(inout), dimension(:)       :: T_prog
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time
type(coupler_2d_bc_type), intent(in)                            :: ice_ocean_boundary_fluxes

integer :: i_bnd_off
integer :: j_bnd_off
integer :: i, j, n
logical :: used

!     use the surface fluxes from the coupler
!       stf is in mol/m^2/s, flux from coupler is positive upwards
i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

do n = 1, instances
  do j = jsc, jec
    do i = isc, iec
       t_prog(he(n)%ind_he_3_atm)%stf(i,j) =                           &
             -ice_ocean_boundary_fluxes%bc(he(n)%ind_he_3_atm_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
       t_prog(he(n)%ind_he_4_atm)%stf(i,j) =                           &
             -ice_ocean_boundary_fluxes%bc(he(n)%ind_he_4_atm_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
       t_prog(he(n)%ind_he_3_man)%stf(i,j) =                           &
             -ice_ocean_boundary_fluxes%bc(he(n)%ind_he_3_man_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
       t_prog(he(n)%ind_he_4_man)%stf(i,j) =                           &
             -ice_ocean_boundary_fluxes%bc(he(n)%ind_he_4_man_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
    enddo
  enddo
enddo

! Save variables for diagnostics
do n = 1, instances
   call diagnose_2d(Time, Grid, he(n)%id_sfc_flux_he_3_atm, t_prog(he(n)%ind_he_3_atm)%stf(:,:))
   call diagnose_2d(Time, Grid, he(n)%id_sfc_flux_he_4_atm, t_prog(he(n)%ind_he_4_atm)%stf(:,:))
   call diagnose_2d(Time, Grid, he(n)%id_sfc_flux_he_3_man, t_prog(he(n)%ind_he_3_man)%stf(:,:))
   call diagnose_2d(Time, Grid, he(n)%id_sfc_flux_he_4_man, t_prog(he(n)%ind_he_4_man)%stf(:,:))
enddo

return

end subroutine  ocmip2_he_sbc
! </SUBROUTINE> NAME="ocmip2_he_sbc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_he_flux_init">
!
! <DESCRIPTION>
!     Called once at the beginning of the run
!     Set up any extra fields needed by the ocean-atmosphere gas fluxes
! </DESCRIPTION>

subroutine ocmip2_he_flux_init

character(len=64), parameter    :: sub_name = 'ocmip2_he_flux_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=256)                                      :: caller_str

  integer :: stdoutunit 
  stdoutunit=stdout() 

!       First, perform some initialization if this module has not been
!       initialized because the normal initialization routine will
!       not have been called as part of the normal ocean model
!       initialization if this is an Atmosphere pe of a coupled
!       model running in concurrent mode
if (.not. module_initialized) then

   ! Initialize the package
  package_index = otpm_set_tracer_package(package_name,            &
       restart_file = default_restart_file,                        &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')

  ! Check whether to use this package
  path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
  instances = fm_get_length(path_to_names)
  if (instances .lt. 0) then 
    call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
  endif

  write (stdoutunit,*)
  if (instances .eq. 0) then
    write (stdoutunit,*) trim(note_header), ' No instances'
    do_ocmip2_he = .false.
  else
    if (instances .eq. 1) then
      write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
    else
      write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
    endif
    do_ocmip2_he = .true.
  endif

  module_initialized = .true.

endif

! Return if we don't want to use this package
if (.not. do_ocmip2_he) then
  return
endif

if (.not. allocated(he)) then

   ! allocate storage for he array
  allocate ( he(instances) )

  ! loop over the names, saving them into the he array
  do n = 1, instances

    if (fm_get_value(path_to_names, name, index = n)) then
      he(n)%name = name
    else
      write (name,*) n
      call mpp_error(FATAL, trim(error_header) //        &
           'Bad field name for index ' // trim(name))
    endif

  enddo

endif

! Set up the ocean-atmosphere gas flux fields
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

  name = he(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
  else
    suffix = '_' // name
  endif

  ! Coupler fluxes

  ! NOTE: set param = (/ 1, 1 /) if reading in ocmip2 input files
  ! can reset in flux field table
  he(n)%ind_he_3_atm_flux = aof_set_coupler_flux('he_3_atm_flux' // suffix,                        &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',                               &
       param = (/ 9.36e-07, 9.7561e-06 /),                                                      &
       ice_restart_file = default_ice_restart_file,                                    &
       ocean_restart_file = default_ocean_restart_file,                                &
       caller = caller_str)

  he(n)%ind_he_4_atm_flux = aof_set_coupler_flux('he_4_atm_flux' // suffix,                        &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',                               &
       param = (/ 9.36e-07, 9.7561e-06 /),                                                      &
       ice_restart_file = default_ice_restart_file,                                    &
       ocean_restart_file = default_ocean_restart_file,                                &
       caller = caller_str)

  he(n)%ind_he_3_man_flux = aof_set_coupler_flux('he_3_man_flux' // suffix,                        &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',                               &
       param = (/ 9.36e-07, 9.7561e-06 /),                                                      &
       ice_restart_file = default_ice_restart_file,                                    &
       ocean_restart_file = default_ocean_restart_file,                                &
       caller = caller_str)

  he(n)%ind_he_4_man_flux = aof_set_coupler_flux('he_4_man_flux' // suffix,                        &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',                               &
       param = (/ 9.36e-07, 9.7561e-06 /),                                                      &
       ice_restart_file = default_ice_restart_file,                                    &
       ocean_restart_file = default_ocean_restart_file,                                &
       caller = caller_str)
enddo

return

end subroutine  ocmip2_he_flux_init
! </SUBROUTINE> NAME="ocmip2_he_flux_init"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_he_init">
!
! <DESCRIPTION>
!       Called once at the beginning of the run
!       Set up any extra fields needed by the tracer packages
!       Save pointers to various "types", such as Grid and Domains.
! </DESCRIPTION>

subroutine ocmip2_he_init

character(len=64), parameter    :: sub_name = 'ocmip2_he_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!     Schmidt number coefficients 
!       Use Wanninkhof (1992) JGR, vol 97, pp 7373-7381
!         for He-4 (and He-3)

real, parameter :: a1_4_def = 410.14
real, parameter :: a2_4_def =  20.503 
real, parameter :: a3_4_def =   0.53175 
real, parameter :: a4_4_def =   0.0060111 

! Solubility coefficients for alpha in mol/(m3 atm)
! (1) for He-4 
! after Wanninkhof (1992) JGR, vol 97, pp 7373-7381
real, parameter :: d1_4_def =  -34.6261
real, parameter :: d2_4_def =   43.0285 
real, parameter :: d3_4_def =   14.1391

real, parameter :: e1_4_def = -0.042340 
real, parameter :: e2_4_def =  0.022624 
real, parameter :: e3_4_def = -0.0033120

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=fm_string_len)                            :: string
character(len=fm_field_name_len+3)                      :: long_suffix
character(len=256)                                      :: caller_str
character(len=fm_string_len), pointer, dimension(:)     :: good_list

  integer :: stdoutunit 
  stdoutunit=stdout() 

! Check which tracer packages have been turned on

! Initialize the ocmip2 he package
package_index = otpm_set_tracer_package(package_name,                 &
     restart_file = default_restart_file,                             &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')

!       Check whether to use this package
path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
instances = fm_get_length(path_to_names)
if (instances .lt. 0) then 
  call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
endif

if (instances .eq. 0) then
  write (stdoutunit,*) trim(note_header), ' No instances'
  do_ocmip2_he = .false.
else
  if (instances .eq. 1) then
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
  else
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
  endif
  do_ocmip2_he = .true.
endif

module_initialized = .true.

! Return if we don't want to use this package,
! after changing the list back
if (.not. do_ocmip2_he) then 
  return
endif

! after reading tracer tree
!       allocate storage for he array
allocate ( he(instances) )

! loop over the names, saving them into the he array
do n = 1, instances

  if (fm_get_value(path_to_names, name, index = n)) then
    he(n)%name = name
  else
    write (name,*) n
    call mpp_error(FATAL, trim(error_header) //                 &
         ' Bad field name for index ' // trim(name))
  endif

enddo

! Set up the field input
do n = 1, instances

  name = he(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // name
    long_suffix = ' (' // trim(name) // ')'
  endif

  ! NOTE: Coupler wants fluxes in mol/m2/s for MOM4.1. jes.4jun08
  ! HE-3
  he(n)%ind_he_3_atm = otpm_set_prog_tracer('he_3_atm' // suffix, package_name,    &
       longname = 'HE-3 Atmospheric' // trim(long_suffix),                                &
       units = 'mol/kg', flux_units = 'mol/m^2/s',                             &
       caller=trim(mod_name) // '(' // trim(sub_name) // ')')

  he(n)%ind_he_3_man = otpm_set_prog_tracer('he_3_man' // suffix, package_name,    &
       longname = 'HE-3 Mantle' // trim(long_suffix),                                &
       units = 'mol/kg', flux_units = 'mol/m^2/s',                             &
       caller=trim(mod_name) // '(' // trim(sub_name) // ')')

  ! HE-4
  he(n)%ind_he_4_atm = otpm_set_prog_tracer('he_4_atm' // suffix, package_name,    &
       longname = 'HE-4 Atmospheric' // trim(long_suffix),                                &
       units = 'mol/kg', flux_units = 'mol/m^2/s',                             &
       caller=trim(mod_name) // '(' // trim(sub_name) // ')')

  he(n)%ind_he_4_man = otpm_set_prog_tracer('he_4_man' // suffix, package_name,    &
       longname = 'HE-4 Mantle' // trim(long_suffix),                                &
       units = 'mol/kg', flux_units = 'mol/m^2/s',                             &
       caller=trim(mod_name) // '(' // trim(sub_name) // ')')

enddo

! Add the package name to the list of good namelists, to be used
! later for a consistency check
if (fm_new_value('/ocean_mod/GOOD/good_namelists', package_name, append = .true.) .le. 0) then
  call mpp_error(FATAL, trim(error_header) //                           &
       ' Could not add ' // trim(package_name) // ' to "good_namelists" list')
endif

! Set up the *global* HE namelist
caller_str=trim(mod_name) // '(' // trim(sub_name) // ')'

call fm_util_start_namelist(package_name, '*global*', caller = caller_str, no_overwrite = .true., &
     check = .true.)

call fm_util_set_value('src_he_depth_file', 'INPUT/src_he_depth.nc')
call fm_util_set_value('src_he_depth_name', 'V1')

call fm_util_set_value('src_he3_file', 'INPUT/src_he3.nc')
call fm_util_set_value('src_he3_name', 'V2')

call fm_util_set_value('src_he4_file', 'INPUT/src_he4.nc')
call fm_util_set_value('src_he4_name', 'V3')


call fm_util_end_namelist(package_name, '*global*', caller = caller_str, check = .true.)

! Set up the instance HE namelists
do n = 1, instances

  call fm_util_start_namelist(package_name, he(n)%name, caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('a1_4', a1_4_def)
  call fm_util_set_value('a2_4', a2_4_def)
  call fm_util_set_value('a3_4', a3_4_def)
  call fm_util_set_value('a4_4', a4_4_def)

  call fm_util_set_value('d1_4', d1_4_def)
  call fm_util_set_value('d2_4', d2_4_def)
  call fm_util_set_value('d3_4', d3_4_def)

  call fm_util_set_value('e1_4', e1_4_def)
  call fm_util_set_value('e2_4', e2_4_def)
  call fm_util_set_value('e3_4', e3_4_def)

  ! Override the default value, 1, in the field table namelist entries
  call fm_util_set_value('he3_sourcefac', 1.0)
  call fm_util_set_value('he4_sourcefac', 1.0)

  call fm_util_set_value('restart_file', default_restart_file)

  call fm_util_end_namelist(package_name, he(n)%name, check = .true., caller = caller_str)

enddo

! Check for any errors in the number of fields in the namelists for this package
good_list => fm_util_get_string_array('/ocean_mod/GOOD/namelists/' // trim(package_name) // '/good_values',   &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
if (associated(good_list)) then
  call fm_util_check_for_bad_fields('/ocean_mod/namelists/' // trim(package_name), good_list,       &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')
  deallocate(good_list)
else
  call mpp_error(FATAL,trim(error_header) // ' Empty "' // trim(package_name) // '" list')
endif

return

end subroutine ocmip2_he_init
! </SUBROUTINE> NAME="ocmip2_he_init"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_he_init_sfc">
!
! <DESCRIPTION>
!       Called once at the beginning of the run
!       Initialize surface fields for flux calculations
!
! </DESCRIPTION>
subroutine ocmip2_he_init_sfc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,      &
     isc_bnd, jsc_bnd, Ocean_fields, T_prog, rho,            &
     taum1, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: jsc_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho
integer, intent(in)                                     :: taum1
real, dimension(isd:ied,jsd:jed,nk), intent(in)         :: grid_tmask

integer         :: i, j, n
integer         :: i_bnd_off
integer         :: j_bnd_off
integer         :: ind
real            :: sal
real            :: ta
real            :: term1, term2, term3

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd


do n = 1, instances
   ! HE flux : ATMOSPHERIC
  ind = he(n)%ind_he_3_atm_flux
  if (.not. field_exist('INPUT/'//trim(Ocean_fields%bc(ind)%ocean_restart_file),  &
                        Ocean_fields%bc(ind)%field(ind_alpha)%name)) then

!     Calculate solubilities
!       He-4 Sol: Use Wanninkhof (1992) JGR, vol 97, pp 7373-7381
!       He-3 Sol: He-4 Sol * 0.984, See Weiss, 1977; Top et al., 1987;
!                                       Fuchs et al., 1987.
!       Equation for alpha is given in volumetric units (mol/(l atm)).
!       Solubilities output in mol/(m3 * atm) 
!        molar volume = 22414 cm3/mol = 22.4e-3 m3/mol = 22.4e-3 l/mol 
  do j = jsc, jec
    do i = isc, iec
      ta = (t_prog(indtemp)%field(i,j,1,taum1) + 273.15) * 0.01
      sal = t_prog(indsal)%field(i,j,1,taum1)

      he(n)%alpha_4_atm(i,j) =                                                            &
           (exp( he(n)%d1_4 + &
                (he(n)%d2_4/ta) + & 
                (he(n)%d3_4 * (log(ta))) + &
               (sal * ((he(n)%e3_4 * ta * ta) + (he(n)%e2_4 * ta) + he(n)%e1_4))) &
             /(22.4e-3))* grid_tmask(i,j,1)

      he(n)%alpha_3_atm(i,j) = (he(n)%alpha_4_atm(i,j) * 0.984)* grid_tmask(i,j,1)

    enddo
  enddo

  ! Calculate Schmidt numbers
  ! Use Wanninkhof (1992) JGR, vol 97, pp 7373-7381
    do j = jsc, jec
      do i = isc, iec
      term1 = he(n)%a2_4 * t_prog(indtemp)%field(i,j,1,taum1)
      term2 = he(n)%a3_4 * t_prog(indtemp)%field(i,j,1,taum1)    &
                         * t_prog(indtemp)%field(i,j,1,taum1)
      term3 = he(n)%a4_4 * t_prog(indtemp)%field(i,j,1,taum1)    &
                         * t_prog(indtemp)%field(i,j,1,taum1)    &
                         * t_prog(indtemp)%field(i,j,1,taum1)

      he(n)%sc_4(i,j) = he(n)%a1_4 -                                       &
                        term1 + &
                        term2 - &
                        term3 
                       
      he(n)%sc_3(i,j) = he(n)%sc_4(i,j) / 1.15

      sc_no_term(i,j) = sqrt(660.0 / he(n)%sc_3(i,j) + 1.0e-40) * grid_tmask(i,j,1)

    Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
         he(n)%alpha_3_atm(i,j) * sc_no_term(i,j)
    Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
         t_prog(he(n)%ind_he_3_atm)%field(i,j,1,taum1)* rho(i,j,1,taum1) * sc_no_term(i,j)
      enddo
    enddo

  endif

  ! HE-3 flux : MANTLE(Equilibrates with zero atmospheric concentration)
  ind = he(n)%ind_he_3_man_flux
  if (.not. field_exist('INPUT/'//trim(Ocean_fields%bc(ind)%ocean_restart_file),  &
                        Ocean_fields%bc(ind)%field(ind_alpha)%name)) then
  ! Calculate solubilities
  do j = jsc, jec
    do i = isc, iec
      ta = (t_prog(indtemp)%field(i,j,1,taum1) + 273.15) * 0.01
      sal = t_prog(indsal)%field(i,j,1,taum1)

      he(n)%alpha_4_man(i,j) =                                                            &
           (exp( he(n)%d1_4 + &
                (he(n)%d2_4/ta) + & 
                (he(n)%d3_4 * (log(ta))) + &
               (sal * ((he(n)%e3_4 * ta * ta) + (he(n)%e2_4 * ta) + he(n)%e1_4))) &
             /(22.4e-3))* grid_tmask(i,j,1)

      he(n)%alpha_3_man(i,j) = (he(n)%alpha_4_man(i,j) * 0.984)* grid_tmask(i,j,1)

    enddo
  enddo

  ! Calculate Schmidt numbers
    do j = jsc, jec
      do i = isc, iec
      term1 = he(n)%a2_4 * t_prog(indtemp)%field(i,j,1,taum1)
      term2 = he(n)%a3_4 * t_prog(indtemp)%field(i,j,1,taum1)    &
                         * t_prog(indtemp)%field(i,j,1,taum1)
      term3 = he(n)%a4_4 * t_prog(indtemp)%field(i,j,1,taum1)    &
                         * t_prog(indtemp)%field(i,j,1,taum1)    &
                         * t_prog(indtemp)%field(i,j,1,taum1)

      he(n)%sc_4(i,j) = he(n)%a1_4 -                                       &
                        term1 + &
                        term2 - &
                        term3 
                       
      he(n)%sc_3(i,j) = he(n)%sc_4(i,j) / 1.15

      sc_no_term(i,j) = sqrt(660.0 / he(n)%sc_3(i,j) + 1.0e-40) * grid_tmask(i,j,1)

    Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
         he(n)%alpha_3_man(i,j) * sc_no_term(i,j)
    Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
         t_prog(he(n)%ind_he_3_man)%field(i,j,1,taum1)* rho(i,j,1,taum1) * sc_no_term(i,j)

      enddo
    enddo

  endif

  ! HE-4 flux ATMOSPHERIC
  ind = he(n)%ind_he_4_atm_flux
  if (.not. field_exist('INPUT/'//trim(Ocean_fields%bc(ind)%ocean_restart_file),  &
                        Ocean_fields%bc(ind)%field(ind_alpha)%name)) then
     ! Solubilities and Schmidt numbers done with He-3 flux (atmos)

     ! Set the He-4 bc values
    do j = jsc, jec
      do i = isc, iec
        sc_no_term(i,j) = sqrt(660.0 / he(n)%sc_4(i,j) + 1.0e-40)* grid_tmask(i,j,1)

    Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
         he(n)%alpha_4_atm(i,j) * sc_no_term(i,j)
    Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
         t_prog(he(n)%ind_he_4_atm)%field(i,j,1,taum1)* rho(i,j,1,taum1) * sc_no_term(i,j)
      enddo
    enddo
  endif

  ! HE-4 flux MANTLE
  ind = he(n)%ind_he_4_man_flux
  if (.not. field_exist('INPUT/'//trim(Ocean_fields%bc(ind)%ocean_restart_file),  &
                        Ocean_fields%bc(ind)%field(ind_alpha)%name)) then
     ! Solubilities and Schmidt numbers done with He-3 flux (mantle)

     ! Set the He-4 bc values
    do j = jsc, jec
      do i = isc, iec
        sc_no_term(i,j) = sqrt(660.0 / he(n)%sc_4(i,j) + 1.0e-40)* grid_tmask(i,j,1)
    Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
         he(n)%alpha_4_man(i,j) * sc_no_term(i,j)
    Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
         t_prog(he(n)%ind_he_4_man)%field(i,j,1,taum1)* rho(i,j,1,taum1) * sc_no_term(i,j)

      enddo
    enddo

  endif

enddo

return

end subroutine ocmip2_he_init_sfc
! </SUBROUTINE> NAME="ocmip2_he_init_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_he_sum_sfc">
!
! <DESCRIPTION>
!       Called for FMS coupler
!       ocean_tpm_sum_sfc: Accumulate data for the coupler
!       Sum surface fields for flux calculations
! </DESCRIPTION>
subroutine ocmip2_he_sum_sfc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,       &
     isc_bnd, jsc_bnd,                                         &
     Ocean_fields, T_prog, rho, taum1, grid_tmask, Grid, Time)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: jsc_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
type(ocean_prog_tracer_type), intent(in), dimension(:)  :: T_prog
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho
integer, intent(in)                                     :: taum1
real, dimension(isd:ied,jsd:jed,nk), intent(in)         :: grid_tmask
type(ocean_grid_type), intent(in)                       :: Grid
type(ocean_time_type), intent(in)                       :: Time

integer         :: i, j, n
integer         :: i_bnd_off
integer         :: j_bnd_off
integer         :: ind
real            :: sal
real            :: ta
logical         :: used
real            :: term1, term2, term3

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

do n = 1, instances
   ! HE flux : ATMOSPHERIC
  ind = he(n)%ind_he_3_atm_flux

!     Calculate solubilities
!       He-4 Sol: Use Wanninkhof (1992) JGR, vol 97, pp 7373-7381
!       He-3 Sol: He-4 Sol * 0.984, See Weiss, 1977; Top et al., 1987;
!                                       Fuchs et al., 1987.
!       Equation for alpha is given in volumetric units (mol/(l atm)).
!       Solubilities output in mol/(m3 * atm) 
!        molar volume = 22414 cm3/mol = 22.4e-3 m3/mol = 22.4e-3 l/mol 
  do j = jsc, jec
    do i = isc, iec
      ta = (t_prog(indtemp)%field(i,j,1,taum1) + 273.15) * 0.01
      sal = t_prog(indsal)%field(i,j,1,taum1)

      he(n)%alpha_4_atm(i,j) =                                                            &
           (exp( he(n)%d1_4 + &
                (he(n)%d2_4/ta) + & 
                (he(n)%d3_4 * (log(ta))) + &
               (sal * ((he(n)%e3_4 * ta * ta) + (he(n)%e2_4 * ta) + he(n)%e1_4))) &
             /(22.4e-3))* grid_tmask(i,j,1)

      he(n)%alpha_3_atm(i,j) = (he(n)%alpha_4_atm(i,j) * 0.984)* grid_tmask(i,j,1)
    enddo
  enddo

  ! Calculate Schmidt numbers
  ! Use Wanninkhof (1992) JGR, vol 97, pp 7373-7381
    do j = jsc, jec
      do i = isc, iec
      term1 = he(n)%a2_4 * t_prog(indtemp)%field(i,j,1,taum1)
      term2 = he(n)%a3_4 * t_prog(indtemp)%field(i,j,1,taum1)    &
                         * t_prog(indtemp)%field(i,j,1,taum1)
      term3 = he(n)%a4_4 * t_prog(indtemp)%field(i,j,1,taum1)    &
                         * t_prog(indtemp)%field(i,j,1,taum1)    &
                         * t_prog(indtemp)%field(i,j,1,taum1)

      he(n)%sc_4(i,j) = he(n)%a1_4 -                                       &
                        term1 + &
                        term2 - &
                        term3 
                       
      he(n)%sc_3(i,j) = he(n)%sc_4(i,j) / 1.15

      sc_no_term(i,j) = sqrt(660.0 / he(n)%sc_3(i,j) + 1.0e-40) * grid_tmask(i,j,1)

    Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
      Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +         &
        he(n)%alpha_3_atm(i,j) * sc_no_term(i,j)
    Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
      Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +         &
      t_prog(he(n)%ind_he_3_atm)%field(i,j,1,taum1)* rho(i,j,1,taum1) * sc_no_term(i,j)

      enddo
    enddo

  ! HE-3 flux : MANTLE(Equilibrates with zero atmospheric concentration)
  ind = he(n)%ind_he_3_man_flux

  ! Calculate solubilities
  do j = jsc, jec
    do i = isc, iec
      ta = (t_prog(indtemp)%field(i,j,1,taum1) + 273.15) * 0.01
      sal = t_prog(indsal)%field(i,j,1,taum1)

      he(n)%alpha_4_man(i,j) =                                                            &
           (exp( he(n)%d1_4 + &
                (he(n)%d2_4/ta) + & 
                (he(n)%d3_4 * (log(ta))) + &
               (sal * ((he(n)%e3_4 * ta * ta) + (he(n)%e2_4 * ta) + he(n)%e1_4))) &
             /(22.4e-3))* grid_tmask(i,j,1)

      he(n)%alpha_3_man(i,j) = (he(n)%alpha_4_man(i,j) * 0.984)* grid_tmask(i,j,1)
    enddo
  enddo

  ! Calculate Schmidt numbers
    do j = jsc, jec
      do i = isc, iec
      term1 = he(n)%a2_4 * t_prog(indtemp)%field(i,j,1,taum1)
      term2 = he(n)%a3_4 * t_prog(indtemp)%field(i,j,1,taum1)    &
                         * t_prog(indtemp)%field(i,j,1,taum1)
      term3 = he(n)%a4_4 * t_prog(indtemp)%field(i,j,1,taum1)    &
                         * t_prog(indtemp)%field(i,j,1,taum1)    &
                         * t_prog(indtemp)%field(i,j,1,taum1)

      he(n)%sc_4(i,j) = he(n)%a1_4 -                                       &
                        term1 + &
                        term2 - &
                        term3 
                       
      he(n)%sc_3(i,j) = he(n)%sc_4(i,j) / 1.15

      sc_no_term(i,j) = sqrt(660.0 / he(n)%sc_3(i,j) + 1.0e-40) * grid_tmask(i,j,1)

    Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
       Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +        &
         he(n)%alpha_3_man(i,j) * sc_no_term(i,j)
    Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
       Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +        &
         t_prog(he(n)%ind_he_3_man)%field(i,j,1,taum1)* rho(i,j,1,taum1) * sc_no_term(i,j)

      enddo
    enddo

  ! HE-4 flux ATMOSPHERIC
  ind = he(n)%ind_he_4_atm_flux

  ! Solubilities and Schmidt numbers done with He-3 flux (atmos)

  ! Set the He-4 bc values
    do j = jsc, jec
      do i = isc, iec
        sc_no_term(i,j) = sqrt(660.0 / he(n)%sc_4(i,j) + 1.0e-40)* grid_tmask(i,j,1)

    Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
         Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +      &
         he(n)%alpha_4_atm(i,j) * sc_no_term(i,j)
    Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
         Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +      &
         t_prog(he(n)%ind_he_4_atm)%field(i,j,1,taum1)* rho(i,j,1,taum1) * sc_no_term(i,j)

      enddo
    enddo

  ! HE-4 flux MANTLE
  ind = he(n)%ind_he_4_man_flux

  ! Solubilities and Schmidt numbers done with He-3 flux (mantle)

  ! Set the He-4 bc values
    do j = jsc, jec
      do i = isc, iec
        sc_no_term(i,j) = sqrt(660.0 / he(n)%sc_4(i,j) + 1.0e-40)* grid_tmask(i,j,1)
    Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
         Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +      &
         he(n)%alpha_4_man(i,j) * sc_no_term(i,j)
    Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
         Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +      &
         t_prog(he(n)%ind_he_4_man)%field(i,j,1,taum1)* rho(i,j,1,taum1) * sc_no_term(i,j)

      enddo
    enddo

enddo

! Save variables for diagnostics
do n = 1, instances
   call diagnose_2d_comp(Time, Grid, he(n)%id_alpha_3_atm, he(n)%alpha_3_atm(:,:))
   call diagnose_2d_comp(Time, Grid, he(n)%id_alpha_3_man, he(n)%alpha_3_man(:,:))
   call diagnose_2d_comp(Time, Grid, he(n)%id_sc_3, he(n)%sc_3(:,:))
   call diagnose_2d_comp(Time, Grid, he(n)%id_alpha_4_atm, he(n)%alpha_4_atm(:,:))
   call diagnose_2d_comp(Time, Grid, he(n)%id_alpha_4_man, he(n)%alpha_4_man(:,:))
   call diagnose_2d_comp(Time, Grid, he(n)%id_sc_4, he(n)%sc_4(:,:))
enddo

return

end subroutine ocmip2_he_sum_sfc
! </SUBROUTINE> NAME="ocmip2_he_sum_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_he_zero_sfc">
!
! <DESCRIPTION>
!               Zero out the fields for the coupler to allow
!               for accumulation for the next time period
! </DESCRIPTION>
subroutine ocmip2_he_zero_sfc(Ocean_fields)

type(coupler_2d_bc_type), intent(inout) :: Ocean_fields

integer         :: n
integer         :: ind

do n = 1, instances

  ind = he(n)%ind_he_3_atm_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0

  ind = he(n)%ind_he_4_atm_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0

  ind = he(n)%ind_he_3_man_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0

  ind = he(n)%ind_he_4_man_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0

enddo

return

end subroutine ocmip2_he_zero_sfc
! </SUBROUTINE> NAME="ocmip2_he_zero_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_he_avg_sfc">
!
! <DESCRIPTION>
!       Called for FMS coupler
!       ocean_tpm_avg_sfc: Take the time-mean of the fields for the coupler
!       Sum surface fields for flux calculations
! </DESCRIPTION>
subroutine ocmip2_he_avg_sfc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,       &
     isc_bnd, jsc_bnd, Ocean_fields, Ocean_avg_kount, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: jsc_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
integer                                                 :: Ocean_avg_kount
real, dimension(isd:ied,jsd:jed,nk), intent(in)         :: grid_tmask

integer :: i, j, n
integer :: i_bnd_off
integer :: j_bnd_off
integer :: ind
real    :: divid


i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

divid = 1./float(Ocean_avg_kount)

do n = 1, instances

  ind = he(n)%ind_he_3_atm_flux

  do j = jsc, jec
    do i = isc, iec
     if (Grid_tmask(i,j,1) == 1.0) then
       Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =        &
         Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
    Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
         Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
     endif
    enddo
  enddo

  ind = he(n)%ind_he_4_atm_flux

  do j = jsc, jec
    do i = isc, iec
     if (Grid_tmask(i,j,1) == 1.0) then
    Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
         Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
    Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
         Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
     endif
    enddo
  enddo

  ind = he(n)%ind_he_3_man_flux

  do j = jsc, jec
    do i = isc, iec
     if  (Grid_tmask(i,j,1) == 1.0) then
    Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
         Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
    Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
         Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
     endif
    enddo
  enddo

  ind = he(n)%ind_he_4_man_flux

  do j = jsc, jec
    do i = isc, iec
     if (Grid_tmask(i,j,1) == 1.0) then
    Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
         Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
    Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
         Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
     endif
    enddo
  enddo

enddo

return

end subroutine ocmip2_he_avg_sfc
! </SUBROUTINE> NAME="ocmip2_he_avg_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_he_sfc_end">
!
! <DESCRIPTION>
!       Called for FMS coupler
!       ocean_tpm_sfc_end: Save out fields for the restart.
! </DESCRIPTION>
subroutine ocmip2_he_sfc_end

end subroutine ocmip2_he_sfc_end
! </SUBROUTINE> NAME="ocmip2_he_sfc_end"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_he_source">
!
! <DESCRIPTION>
!     compute the source terms for the HEs, including boundary
!     conditions (not done in setvbc, to minimize number
!     of hooks required in MOM base code)
! As described by J-C Dutay et al.'s  Helium HOWTO.
! Mantle Helium has a source due to emission of helium rich waters
! along ocean ridges on the seafloor.  Globally integrated, the source
! term amounts to 1000 moles of He-3 per year. Regionally, sources are
! partitioned as a function of ridge position, length and spreading rate.
! A loss term exists in the air-sea flux of mantle helium.
!
! The loss term is calculated in the subroutine ocmip2_he_sbc.
! </DESCRIPTION>
!
subroutine ocmip2_he_source(isc, iec, jsc, jec, nk, isd, ied, jsd, jed, t_prog, &
     depth_zt, dzt, model_time, grid_tmask, Grid, Time, grid_kmt)

integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: nk
integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
type(ocean_prog_tracer_type), intent(inout), dimension(:)       :: t_prog
real, dimension(isd:ied,jsd:jed,nk), intent(in)                 :: depth_zt
real, dimension(isd:ied,jsd:jed,nk), intent(in)                 :: dzt
type(time_type), intent(in)                                     :: model_time
real, dimension(isd:ied,jsd:jed,nk), intent(in)                 :: grid_tmask
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time
integer, dimension(isd:ied,jsd:jed), intent(in)                 :: grid_kmt

character(len=64), parameter    :: sub_name = 'ocmip2_he_source'

character(len=256)                      :: caller_str
integer :: index1, index2
integer :: k,i,j,n
logical :: used

call time_interp_external(src_he3_id, model_time, src_he3_t)
call time_interp_external(src_he4_id, model_time, src_he4_t)
call time_interp_external(src_he_depth_id, model_time, src_he_depth_t)

! calculate the source terms for HEs
caller_str=trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

   call fm_util_start_namelist(package_name, he(n)%name, caller = caller_str)
   call fm_util_end_namelist(package_name, he(n)%name, caller = caller_str)

   index1 = he(n)%ind_he_3_man
   index2 = he(n)%ind_he_4_man

   ! these source factors are used to vary the global integral of helium injection
   ! as default use 1.0 * 1.064070463 which with the current source function
   ! gives a global integral flux of 500 mol/year (half the canonical for OCMIP2)

   ! Now in the field table namelist entry
   !   he(n)%he3_sourcefac = 1.0 * 1.064070463 * 0.5
   !   he(n)%he4_sourcefac = 1.0 * 1.064070463 * 0.5
    do j = jsc, jec
      do i = isc, iec
        if (src_he3_t(i,j) .gt. 0 .and. grid_tmask(i,j,1) == 1 ) then
         do k = 1, grid_kmt(i,j)

             if (k .lt. grid_kmt(i,j)) then
               if (depth_zt(i,j,k)-(dzt(i,j,k)/2) .lt. src_he_depth_t(i,j) .and. &
                   depth_zt(i,j,k)+(dzt(i,j,k)/2) .gt. src_he_depth_t(i,j)) then
                 t_prog(index1)%th_tendency(i,j,k) =  &
                                (t_prog(index1)%th_tendency(i,j,k) &
                              + src_he3_t(i,j) * he(n)%he3_sourcefac ) * grid_tmask(i,j,k)
                 t_prog(index2)%th_tendency(i,j,k) =  &
                                (t_prog(index2)%th_tendency(i,j,k) &
                              + src_he4_t(i,j) * he(n)%he4_sourcefac ) * grid_tmask(i,j,k)

                 ! Source term units for history file is mol/m2/s 
                 he(n)%jhe3_man(i,j,k)=(src_he3_t(i,j) * he(n)%he3_sourcefac)/dzt(i,j,k)
                 he(n)%jhe4_man(i,j,k)=(src_he4_t(i,j) * he(n)%he4_sourcefac)/dzt(i,j,k)
                 he(n)%jhe_depth(i,j)=depth_zt(i,j,k)

              else
                 t_prog(index1)%th_tendency(i,j,k) =  &
                                t_prog(index1)%th_tendency(i,j,k)
                 t_prog(index2)%th_tendency(i,j,k) =  &
                                t_prog(index2)%th_tendency(i,j,k)

                 he(n)%jhe3_man(i,j,k)=0
                 he(n)%jhe4_man(i,j,k)=0

              endif

            elseif (k .eq. grid_kmt(i,j)) then
               if (depth_zt(i,j,k)+(dzt(i,j,k)/2) .lt. src_he_depth_t(i,j)) then
                 t_prog(index1)%th_tendency(i,j,k) =  &
                                (t_prog(index1)%th_tendency(i,j,k) &
                              + src_he3_t(i,j) * he(n)%he3_sourcefac) &
                              * grid_tmask(i,j,k)

                 t_prog(index2)%th_tendency(i,j,k) =  &
                                (t_prog(index2)%th_tendency(i,j,k) &
                              + src_he4_t(i,j) * he(n)%he4_sourcefac) &
                              * grid_tmask(i,j,k)
                 he(n)%jhe3_man(i,j,k)=(src_he3_t(i,j) * he(n)%he3_sourcefac)/dzt(i,j,k)
                 he(n)%jhe4_man(i,j,k)=(src_he4_t(i,j) * he(n)%he4_sourcefac)/dzt(i,j,k)
                 he(n)%jhe_depth(i,j)=depth_zt(i,j,k)

               else
                 t_prog(index1)%th_tendency(i,j,k) =  &
                                t_prog(index1)%th_tendency(i,j,k)
                 t_prog(index2)%th_tendency(i,j,k) =  &
                                t_prog(index2)%th_tendency(i,j,k)

                 he(n)%jhe3_man(i,j,k)=0
                 he(n)%jhe4_man(i,j,k)=0

               endif
            endif
         enddo

       else
             t_prog(index1)%th_tendency(i,j,:) = t_prog(index1)%th_tendency(i,j,:) * grid_tmask(i,j,:)
             t_prog(index2)%th_tendency(i,j,:) = t_prog(index2)%th_tendency(i,j,:) * grid_tmask(i,j,:)
             he(n)%jhe3_man(i,j,:)=0
             he(n)%jhe4_man(i,j,:)=0
             he(n)%jhe_depth(i,j)=0

       endif

      enddo
    enddo

  ! Save variables for diagnostics
  call diagnose_3d_comp(Time, Grid, he(n)%id_jhe3_man, he(n)%jhe3_man(:,:,:))
  call diagnose_3d_comp(Time, Grid, he(n)%id_jhe4_man, he(n)%jhe4_man(:,:,:))
  call diagnose_2d_comp(Time, Grid, he(n)%id_jhe_depth, he(n)%jhe_depth(:,:))

enddo

return

end subroutine  ocmip2_he_source
! </SUBROUTINE> NAME="ocmip2_he_source"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_he_start">
!
! <DESCRIPTION>
! Initialize variables, read in namelists, calculate constants
! for a given run and allocate diagnostic arrays
! </DESCRIPTION>
!
subroutine ocmip2_he_start(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,         &
     T_prog, taup1, model_time, grid_dat, grid_tmask, grid_tracer_axes, mpp_domain2d, rho_dzt)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
integer, intent(in)                                     :: taup1
type(time_type), intent(in)                             :: model_time
real, dimension(isd:ied,jsd:jed), intent(in)            :: grid_dat
real, dimension(isd:ied,jsd:jed,nk), intent(in)         :: grid_tmask
integer, dimension(3), intent(in)                       :: grid_tracer_axes
type(domain2d), intent(in)                              :: mpp_domain2d
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho_dzt

character(len=64), parameter    :: sub_name = 'ocmip2_he_start'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

character(len=fm_field_name_len+3)      :: long_suffix
integer                                 :: i, j, k, n
character(len=fm_field_name_len+1)      :: suffix
character(len=256)                      :: caller_str
real                                    :: total_he_3_atm
real                                    :: total_he_4_atm
real                                    :: total_he_3_man
real                                    :: total_he_4_man

  integer :: stdoutunit 
  stdoutunit=stdout() 

write(stdoutunit,*) 
write(stdoutunit,*) trim(note_header),                     &
                  ' Starting ', trim(package_name), ' module'

! Determine indices for temperature and salinity
indtemp = fm_get_index('/ocean_mod/prog_tracers/temp')
if (indtemp .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the temperature index')
endif

indsal = fm_get_index('/ocean_mod/prog_tracers/salt')
if (indsal .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the salinity index')
endif

! dynamically allocate the global HE arrays
call allocate_arrays(isc, iec, jsc, jec, nk, isd, ied, jsd, jed)

! save the *global* namelist values
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

call fm_util_start_namelist(package_name, '*global*', caller = caller_str)

  src_he3_file  =  fm_util_get_string('src_he3_file', scalar = .true.)
  src_he3_name  =  fm_util_get_string('src_he3_name', scalar = .true.)
  src_he4_file  =  fm_util_get_string('src_he4_file', scalar = .true.)
  src_he4_name  =  fm_util_get_string('src_he4_name', scalar = .true.)
  src_he_depth_file  =  fm_util_get_string('src_he_depth_file', scalar = .true.)
  src_he_depth_name  =  fm_util_get_string('src_he_depth_name', scalar = .true.)


call fm_util_end_namelist(package_name, '*global*', caller = caller_str)

do n = 1, instances

  call fm_util_start_namelist(package_name, he(n)%name, caller = caller_str)

  he(n)%a1_4 =    fm_util_get_real('a1_4', scalar = .true.)
  he(n)%a2_4 =    fm_util_get_real('a2_4', scalar = .true.)
  he(n)%a3_4 =    fm_util_get_real('a3_4', scalar = .true.)
  he(n)%a4_4 =    fm_util_get_real('a4_4', scalar = .true.)

  he(n)%d1_4 =    fm_util_get_real('d1_4', scalar = .true.)
  he(n)%d2_4 =    fm_util_get_real('d2_4', scalar = .true.)
  he(n)%d3_4 =    fm_util_get_real('d3_4', scalar = .true.)

  he(n)%e1_4 =    fm_util_get_real('e1_4', scalar = .true.)
  he(n)%e2_4 =    fm_util_get_real('e2_4', scalar = .true.)
  he(n)%e3_4 =    fm_util_get_real('e3_4', scalar = .true.)

  he(n)%he4_sourcefac = fm_util_get_real('he4_sourcefac', scalar = .true.)
  he(n)%he3_sourcefac = fm_util_get_real('he3_sourcefac', scalar = .true.)

  he(n)%restart_file  = fm_util_get_string('restart_file', scalar = .true.)

  call fm_util_end_namelist(package_name, he(n)%name, caller = caller_str)

enddo

! Open up the files for boundary conditions
src_he3_id = init_external_field(src_he3_file,          &
                                     src_he3_name,          &
                                     domain = mpp_domain2d)
if (src_he3_id .eq. 0) then
  call mpp_error(FATAL, trim(error_header) //                   &
       'Could not open He-3 source file: ' //          &
       trim(src_he3_file))
endif

src_he4_id = init_external_field(src_he4_file,          &
                                     src_he4_name,          &
                                     domain = mpp_domain2d)
if (src_he4_id .eq. 0) then
  call mpp_error(FATAL, trim(error_header) //                   &
       'Could not open He-3 source file: ' //          &
       trim(src_he4_file))
endif

src_he_depth_id = init_external_field(src_he_depth_file,          &
                                     src_he_depth_name,          &
                                     domain = mpp_domain2d)
if (src_he_depth_id .eq. 0) then
  call mpp_error(FATAL, trim(error_header) //                   &
       'Could not open He-3 source file: ' //          &
       trim(src_he_depth_file))
endif

! Set up analyses

! register the fields
do n = 1, instances

  if (he(n)%name(1:1) .eq. '_') then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // he(n)%name
    long_suffix = ' (' // trim(he(n)%name) // ')'
  endif

  he(n)%id_sfc_flux_he_3_man = register_diag_field('ocean_model',                  &
       'sfc_flux_he_3_man'//trim(suffix), grid_tracer_axes(1:2),                    &
       model_time,                                                      &
       'Surface Flux - HE-3 man.'//trim(long_suffix), ' ',               &
       missing_value = -1.0e+10)

  he(n)%id_sfc_flux_he_3_atm = register_diag_field('ocean_model',                  &
       'sfc_flux_he_3_atm'//trim(suffix), grid_tracer_axes(1:2),                    &
       model_time,                                                      &
       'Surface Flux - HE-3 atm.'//trim(long_suffix), ' ',               &
       missing_value = -1.0e+10)

  he(n)%id_sfc_flux_he_4_man = register_diag_field('ocean_model',                  &
       'sfc_flux_he_4_man'//trim(suffix), grid_tracer_axes(1:2),                    &
       model_time,                                                      &
       'Surface Flux - HE-4 man.'//trim(long_suffix), ' ',               &
       missing_value = -1.0e+10)

  he(n)%id_sfc_flux_he_4_atm = register_diag_field('ocean_model',                  &
       'sfc_flux_he_4_atm'//trim(suffix), grid_tracer_axes(1:2),                    &
       model_time,                                                      &
       'Surface Flux - HE-4 atm.'//trim(long_suffix), ' ',               &
       missing_value = -1.0e+10)

  he(n)%id_sc_3 = register_diag_field('ocean_model',                  &
       'sc_3'//trim(suffix), grid_tracer_axes(1:2),                    &
       model_time,                                                      &
       'Schmidt number - HE-3'//trim(long_suffix), ' ',               &
       missing_value = -1.0e+10)

  he(n)%id_alpha_3_atm = register_diag_field('ocean_model',               &
       'alpha_3_atm'//trim(suffix), grid_tracer_axes(1:2),                 &
       model_time,                                                      &
       'Solubility HE-3 Atmospheric'//trim(long_suffix), 'mol m^-3 pptv^-1',      &
       missing_value = -1.0e+10)

  he(n)%id_alpha_3_man = register_diag_field('ocean_model',               &
       'alpha_3_man'//trim(suffix), grid_tracer_axes(1:2),                 &
       model_time,                                                      &
       'Solubility HE-3 Mantle'//trim(long_suffix), 'mol m^-3 pptv^-1',      &
       missing_value = -1.0e+10)

  he(n)%id_sc_4 = register_diag_field('ocean_model',                  &
       'sc_4'//trim(suffix), grid_tracer_axes(1:2),                    &
       model_time,                                                      &
       'Schmidt number - HE-4'//trim(long_suffix), ' ',               &
       missing_value = -1.0e+10)

  he(n)%id_alpha_4_atm = register_diag_field('ocean_model',               &
       'alpha_4_atm'//trim(suffix), grid_tracer_axes(1:2),                 &
       model_time,                                                      &
       'Solubility HE-4 Atmospheric'//trim(long_suffix), 'mol m^-3 pptv^-1',      &
       missing_value = -1.0e+10)

  he(n)%id_alpha_4_man = register_diag_field('ocean_model',               &
       'alpha_4_man'//trim(suffix), grid_tracer_axes(1:2),                 &
       model_time,                                                      &
       'Solubility HE-4 Mantle'//trim(long_suffix), 'mol m^-3 pptv^-1',      &
       missing_value = -1.0e+10)

  he(n)%id_jhe3_man = register_diag_field('ocean_model',               &
       'jhe3_man'//trim(suffix), grid_tracer_axes(1:3),                 &
       model_time,                                                      &
       'HE-3 Mantle Source term'//trim(long_suffix), 'mol m^-2 s^-1',      &
       missing_value = -1.0e+10)

  he(n)%id_jhe4_man = register_diag_field('ocean_model',               &
       'jhe4_man'//trim(suffix), grid_tracer_axes(1:3),                 &
       model_time,                                                      &
       'HE-4 Mantle Source term'//trim(long_suffix), 'mol m^-2 s^-1',      &
       missing_value = -1.0e+10)

  he(n)%id_jhe_depth = register_diag_field('ocean_model',               &
       'jhe_depth'//trim(suffix), grid_tracer_axes(1:2),                 &
       model_time,                                                      &
       'HE Injection depth'//trim(long_suffix), 'm',      &
       missing_value = -1.0e+10)

enddo

!       integrate the total concentrations of some tracers
!       for the start of the run
total_he_3_atm = 0.0
total_he_4_atm = 0.0
total_he_3_man = 0.0
total_he_4_man = 0.0

!       Use taup1 time index for the start of a run, and taup1 time
!       index for the end of a run so that we are integrating the
!       same time level and should therefore get identical results
write (stdoutunit,*) trim(note_header),                           &
     'Global integrals at start of run'

do n = 1, instances

  do k = 1,nk
    do j = jsc, jec
      do i = isc, iec
        total_he_3_atm = total_he_3_atm +                           &
             t_prog(he(n)%ind_he_3_atm)%field(i,j,k,taup1) * &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_he_4_atm = total_he_4_atm +                           &
             t_prog(he(n)%ind_he_4_atm)%field(i,j,k,taup1) *  &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_he_3_man = total_he_3_man +                           &
             t_prog(he(n)%ind_he_3_man)%field(i,j,k,taup1) *  &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_he_4_man = total_he_4_man +                           &
             t_prog(he(n)%ind_he_4_man)%field(i,j,k,taup1) *  &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo

  call mpp_sum(total_he_3_atm)
  call mpp_sum(total_he_4_atm)
  call mpp_sum(total_he_3_man)
  call mpp_sum(total_he_4_man)

  write (stdoutunit,*) '  Instance ', trim(he(n)%name)
  write (stdoutunit,                                              &
       '(/'' Total HE-3 Atmospheric  = '',es19.12,'' mol'')')        &
       total_he_3_atm 
  write (stdoutunit,                                              &
       '(/'' Total HE-4  Atmospheric= '',es19.12,'' mol'')')        &
       total_he_4_atm 
  write (stdoutunit,                                              &
       '(/'' Total HE-3 Mantle = '',es19.12,'' mol'')')        &
       total_he_3_man 
  write (stdoutunit,                                              &
       '(/'' Total HE-4 Mantle = '',es19.12,'' mol'')')        &
       total_he_4_man 

enddo

write(stdoutunit,*)
write(stdoutunit,*) trim(note_header), ' Tracer runs initialized'
write(stdoutunit,*)

return

end subroutine  ocmip2_he_start
! </SUBROUTINE> NAME="ocmip2_he_start"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_he_tracer">
!
! <DESCRIPTION>
!     Perform things that should be done in tracer, but are done here
! in order to minimize the number of hooks necessary in the MOM4 basecode
! </DESCRIPTION>
!

subroutine ocmip2_he_tracer

end subroutine  ocmip2_he_tracer
! </SUBROUTINE> NAME="ocmip2_he_tracer"

end module  ocmip2_he_mod

!VERSION NUMBER:
!  $Id: cumulus_closure_k.F90,v 19.0 2012/01/06 20:06:16 fms Exp $


!module cumulus_closure_inter_mod
!
!#include "cumulus_closure_interfaces.h"

!end module cumulus_closure_inter_mod

!######################################################################

subroutine cu_clo_cumulus_closure_k   &
         (nlev_hires, diag_unit, debug_ijt, Param, Initialized, &
          Nml, lofactor, dcape, cape_p, &
          qli0_v, qli1_v, qr_v, qt_v, env_r, ri_v, rl_v, parcel_r,   &
          env_t, parcel_t, a1, ermesg, error)

!---------------------------------------------------------------------
!    subroutine cumulus_closure calculates a_1(p_b) for closing the 
!    cumulus parameterization. see LJD notes, "Cu Closure D," 6/11/97
!---------------------------------------------------------------------
 
use donner_types_mod, only : donner_param_type, donner_nml_type, &
                             donner_initialized_type

implicit none

!---------------------------------------------------------------------
integer,                        intent(in)  :: nlev_hires
integer,                        intent(in)  :: diag_unit
logical,                        intent(in)  :: debug_ijt
type(donner_param_type),        intent(in)  :: Param
type(donner_initialized_type),  intent(in)  :: Initialized
type(donner_nml_type),          intent(in)  :: Nml    
real,                           intent(in)  :: lofactor, dcape
real,    dimension(nlev_hires), intent(in)  :: cape_p, qli0_v, qli1_v, &
                                               qr_v, qt_v, env_r, ri_v, &
                                               rl_v, parcel_r, env_t,   &
                                               parcel_t
real,                           intent(out) :: a1
character(len=*),               intent(out) :: ermesg
integer,                        intent(out) :: error

!---------------------------------------------------------------------

!----------------------------------------------------------------------
!   intent(in) variables:
! 
!        cape_p        pressure on cape grid [ Pa ]
!        qli0_v        normalized component of cumulus condensate 
!                      forcing [ kg(h2o) / (kg(air) sec) ]
!                      defined in "Cu Closure D," p. 4.
!        qli1_v        un-normalized component of cumulus condensate
!                      forcing [ kg(h2o) / (kg(air) sec) ]
!                      defined in "Cu Closure D," p. 4.
!        qr_v          normalized cumulus moisture forcing 
!                      [ kg(h2o) / (kg(air) sec) ]
!                      defined in "Cu Closure D," p. 1.
!        qt_v          normalized cumulus thermal forcing 
!                      [ deg K / sec ]
!                      defined in "Cu Closure D," p. 1.
!        env_r         large-scale water-vapor mixing ratio 
!                      [ kg (h2o) / kg(air) ]
!        ri_v          large-scale ice mixing ratio 
!                      [ kg (h2o) / kg(air) ]
!        rl_v          large-scale liquid mixing ratio 
!                      [ kg (h2o) / kg(air) ]
!        parcel_r      parcel vapor mixing ratio  
!                      [ kg (h2o) / kg(air) ]
!        env_t         large-scale temperature [ deg K ]
!        parcel_t      parcel temperature [ deg K ]
!        dcape         rate of change of convective available potential
!                      energy due to large-scale processes 
!                      [ J / (kg s) ]
!        no_precip     logical array indicating columns in which there
!                      is no precip (and thus no deep convection)
!
!   intent(out) variables:
!
!        a1            fractional area of cumulus  ensemble
!        
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!   local variables:

      real, dimension (nlev_hires)  :: rt, tden, tdena,  &
                                       dtpdta, pert_env_t, pert_env_r, &
                                       pert_parcel_t, pert_parcel_r, &
                                       parcel_r_clo, parcel_t_clo

      real     :: tau, cape_c
      logical  :: ctrig
      real     :: tdens, tdensa, ri1, ri2, rild, rile, rilf, ri2b,  &
                  sum2, rilak, rilbk, rilck, rilakm, rilbkm, rilckm, &
                  rila, rilb, rilc, ri2ak, ri2akm, ri2a, sum1, plcl, &
                  plfc, plzb, dumcoin, dumxcape
      integer  :: k     

!--------------------------------------------------------------------
!   local variables:
!
!      rt
!      ta
!      ra
!      tden
!      tdena
!      dtpdta
!      Cape_pert
!      tdens
!      tdensa
!      ri1
!      ri2
!      rild
!      rile
!      rilf
!      ri2d
!      sum2
!      rilak
!      rilbk
!      rilck
!      rilakm
!      rilbkm
!      rilckm
!      rila
!      rilb
!      rilc
!      ri2ak
!      ri2akm
!      ri2a
!      sum1
!      debug_ijt
!      perturbed
!      k       
!
!--------------------------------------------------------------------

      ermesg = ' ' ; error = 0

!--------------------------------------------------------------------
!    initialize the perturbed parcel profiles (pert_parcel_t,    
!    pert_parcel_r) and  the perturbed parcel environmental profiles to 
!    the actual parcel profiles.
!--------------------------------------------------------------------
      do k=1,nlev_hires
        pert_parcel_t(k) = env_t(k)
        pert_parcel_r(k) = env_r(k)
        pert_env_r(k)    = env_r(k)
        pert_env_t(k)    = env_t(k)
      end do

!--------------------------------------------------------------------
!    perturb lowest cape-model level mixing ratio and temperature so 
!    that one may calculate the derivative of parcel density temperature
!    w.r.t. surface large-scale density temperature. here the environ-
!    ment is made 1 deg K cooler and the mixing ratio is reduced to
!    99% of its unperturbed value.
!--------------------------------------------------------------------
      pert_env_r(1) = pert_env_r(1) - 0.01*pert_env_r(1)
      pert_env_r(1) = max(pert_env_r(1), 0.0)
      pert_env_t(1) = env_t(1) - 1.0

!---------------------------------------------------------------------
!    if this is a diagnostics column, output the environmental profiles
!    of temperature (pert_env_t) and vapor mixing ratio (pert_env_r) for 
!    the perturbed parcel, vertical profiles of pressure (cape_p), 
!    cumulus moisture forcing (qr_v), cumulus thermal forcing (qt_v), 
!    environmental moisture (env_r) and temperature (env_t) for the
!    unperturbed parcel, parcel temperature (parcel_t) and moisture 
!    (parcel_r) for the unperturbed parcel, cumulus condensate forcing 
!    (qli0 and qli1), ice condensate (ri_v) and liquid condensate (rl_v).
!---------------------------------------------------------------------
      if (debug_ijt) then 
        do k=1,nlev_hires
          write (diag_unit, '(a, i4, f19.10, f20.14, e20.12)')   &
                    'press, temp, vapor in cape: k, p,t,r = ',  &
                           k, cape_p(k), pert_env_t(k), pert_env_r(k)
        end do
        do k=1,nlev_hires
          if (qr_v(k) /= 0.0 .or. qt_v(k) /= 0.0) then
            write (diag_unit, '(a, i4, f19.10, 3e20.12, f20.14)') &
                  'in cuclo: k,p,qr,qt,r,t  =', k,  &
                     cape_p(k), qr_v(k), qt_v(k), env_r(k), env_t(k)
          endif
        end do
        do k=1,nlev_hires
          write (diag_unit, '(a, i4, f19.10, f20.14, e20.12)') &
                    'in cuclo: k,p,tpc, rpc   =', k,   &
                           cape_p(k), parcel_t(k), parcel_r(k)
        end do
        do k=1,nlev_hires
          if (qli0_v(k) /= 0.0 .or. qli1_v(k) /= 0.0 .or. &
              ri_v(k) /= 0.0 .or. rl_v(k) /= 0.0) then
              write (diag_unit, '(a, i4, f19.10, 4e20.12)')   &
                'in cuclo: k,p,qli0,qli1,ri,rl =', k,  &
                     cape_p(k), qli0_v(k), qli1_v(k), ri_v(k), rl_v(k)
          endif
        end do
      endif

      if (Nml%do_freezing_for_cape .NEQV. Nml%do_freezing_for_closure .or. &   ! kerr
          Nml%tfre_for_cape /= Nml%tfre_for_closure .or. &
          Nml%dfre_for_cape /= Nml%dfre_for_closure .or. &
          .not. (Initialized%use_constant_rmuz_for_closure) .or. &
          Nml%rmuz_for_cape /= Nml%rmuz_for_closure) then
           call don_c_displace_parcel_k   &
               (nlev_hires, diag_unit, debug_ijt, Param,  &
                Nml%do_freezing_for_closure, Nml%tfre_for_closure, &
                Nml%dfre_for_closure, Nml%rmuz_for_closure, &
                Initialized%use_constant_rmuz_for_closure,  &
                Nml%modify_closure_plume_condensate, &
                Nml%closure_plume_condensate, &
                env_t,  &
                env_r, cape_p, .false., plfc, plzb, plcl, dumcoin,  &
                dumxcape, parcel_r_clo,  parcel_t_clo, ermesg, error)
      else
        parcel_r_clo = parcel_r
        parcel_t_clo = parcel_t
      endif

!--------------------------------------------------------------------
!    call subroutine displace_parcel to determine the movement of a 
!    parcel from the lcl through the environment defined by (pert_env_t, 
!    pert_env_r).
!--------------------------------------------------------------------
      if (Nml%do_dcape) then

!--------------------------------------------------------------------
!    don't need to calculate cape when using Zhang closure 
!    (do_dcape is .true). 
!--------------------------------------------------------------------
      call don_c_displace_parcel_k   &
           (nlev_hires, diag_unit, debug_ijt, Param,   &
            Nml%do_freezing_for_closure, Nml%tfre_for_closure, &
            Nml%dfre_for_closure, Nml%rmuz_for_closure, &
            Initialized%use_constant_rmuz_for_closure, &
                Nml%modify_closure_plume_condensate, &
                Nml%closure_plume_condensate, &
            pert_env_t, &
            pert_env_r, cape_p, .false., plfc, plzb, plcl, dumcoin,  &
            dumxcape, pert_parcel_r,  pert_parcel_t, ermesg, error)
      else

!--------------------------------------------------------------------
!    if using cape relaxation closure then need to return cape value.
!--------------------------------------------------------------------
      call don_c_displace_parcel_k   &
           (nlev_hires, diag_unit, debug_ijt, Param,   &
            Nml%do_freezing_for_closure, Nml%tfre_for_closure, &
            Nml%dfre_for_closure, Nml%rmuz_for_closure, &
            Initialized%use_constant_rmuz_for_closure, &
                Nml%modify_closure_plume_condensate, &
                Nml%closure_plume_condensate, &
            pert_env_t, &
            pert_env_r, cape_p, .true., plfc, plzb, plcl, dumcoin,  &
            dumxcape, pert_parcel_r,  pert_parcel_t, ermesg, error)
     endif

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return


!---------------------------------------------------------------------
!    define quantities needed for cape relaxation closure option.
!---------------------------------------------------------------------
      if ( .not. Nml%do_dcape) then
        cape_c = Nml%cape0
        tau    = Nml%tau
        if (Nml%do_lands) then
          cape_c = Nml%cape0 * lofactor
          tau    = Nml%tau   * lofactor
        endif
      endif
      if (Nml%do_rh_trig) then
!  currently do_rh_trig forced to be .false.
!  no rh array available at current tiome in donner full.
!       rhavg=0.; dpsum=0.
!       do k = 1,sd%kmax
!         if (sd%p(k) .gt. Nml%plev0) then
!           rhavg  = rhavg + sd%rh(k)*sd%dp(k)
!           dpsum = dpsum + sd%dp(k)
!         end if
!       end do
!       rhavg = rhavg/dpsum
!       ctrig = rhavg > Nml%rhavg0
!! FOR NOW:
        ctrig= .true.
      else
        ctrig= .true.
      endif

!---------------------------------------------------------------------
!    if in a diagnostics column, output the path of the parcel (T, p
!    coordinates).
!---------------------------------------------------------------------
      if (debug_ijt) then
        do k=1,nlev_hires
          write (diag_unit, '(a, i4, f20.14, e20.12)')  &
                    'in cuclo: k,tpca,rpca= ', k,    &
                                 pert_parcel_t(k), pert_parcel_r(k)
        end do
      endif

!---------------------------------------------------------------------
!    calculate the large-scale model profile of total-water mixing 
!    ratio. 
!---------------------------------------------------------------------
      do k=1,nlev_hires
        rt(k) = env_r(k) + ri_v(k) + rl_v(k)
      end do

!----------------------------------------------------------------------
!    calculate profiles of density temperatures, in the parcel (tden) 
!    and in the perturbed parcel (tdena). condensate is not included in
!    this definition of density temperature.
!----------------------------------------------------------------------
      do k=1,nlev_hires
        tden(k)  = parcel_t_clo(k)*(1. + (parcel_r_clo(k)/Param%d622)) 
        tdena(k) = pert_parcel_t(k)*(1. + (pert_parcel_r(k)/Param%d622))
      end do

!---------------------------------------------------------------------
!    define the values of density temperature in the environment at the
!    lowest level of the standard parcel displacement case (tdens) and 
!    for the displacement within the perturbed environment (tdensa).
!---------------------------------------------------------------------
      tdens  = env_t(1)*(1. + (env_r(1)/Param%d622))
      tdensa = pert_env_t(1)*(1. + (pert_env_r(1)/Param%d622))

!----------------------------------------------------------------------
!    evaluate derivative of parcel density temperature w.r.t. cloud-base
!    level environmental density temperature.
!----------------------------------------------------------------------
      do k=1,nlev_hires
        dtpdta(k) = (tdena(k) - tden(k))/(tdensa - tdens)
      end do

!---------------------------------------------------------------------
!    if this is a diagnostics column, output the profiles of unperturbed
!    parcel density temperature (tden) and the perturbed parcel density 
!    temperature (tdena) and the derivative of parcel density temper-
!    ature w.r.t. cloud-base large-scale density temperature (dtpdta).
!------------------------------------------------------------------
      if (debug_ijt) then
        do k=1,nlev_hires
          write (diag_unit, '(a, i4, 2f20.14, e20.12)')  &
                   'in cuclo: k,tden(k),tdena(k),dtpdta(k)= ',   &
                          k,tden(k), tdena(k),dtpdta(k)
        end do
      endif

!--------------------------------------------------------------------
!    calculate the I1 and I2 integrals from p. 5 of "Cu Closure D" 
!    notes.
!--------------------------------------------------------------------
!--------------------------------------------------------------------
!    define values at the cloud-base level.
!--------------------------------------------------------------------
      rild = qt_v(1)*(Param%d622 + env_r(1))/(Param%d622*(1. + rt(1)))
      rile = env_t(1)*(1. + rl_v(1) + ri_v(1) - Param%d622)*qr_v(1)
      rile = rile/(Param%d622*((1. + rt(1))**2))
      rilf = -env_t(1)*(Param%d622 + env_r(1))*qli0_v(1)
      rilf = rilf/(Param%d622*((1. + rt(1))**2))
      ri2b = env_t(1)*(Param%d622 + env_r(1))/   &
             (Param%d622*((1. + rt(1))**2))
      ri2b = ri2b*qli1_v(1)
      if (Nml%do_freezing_for_closure .or. &
          NMl%rmuz_for_closure /= 0.0) then
        sum2 = rild + rile + rilf
      else
        sum2 = 0.
      endif


      ri1 = 0.
      ri2 = 0.
      do k=2,nlev_hires
        if (cape_p(k) == 0.) exit       
        rilak = -qt_v(k)*(Param%d622 + env_r(k))/   &
                                     (Param%d622*(1. + rt(k)))
        rilbk = -env_t(k)*  &
                   (1. + rl_v(k) + ri_v(k) - Param%d622)*qr_v(k)
        rilbk = rilbk/(Param%d622*((1. + rt(k))**2))
        rilck = env_t(k)*(Param%d622 + env_r(k))*qli0_v(k)
        rilck = rilck/(Param%d622*((1. + rt(k))**2))
        rilakm = -qt_v(k-1)*(Param%d622 + env_r(k-1))/   &
                                          (Param%d622*(1. + rt(k-1)))
        rilbkm = -env_t(k-1)*  &
                     (1. + rl_v(k-1) + ri_v(k-1) - Param%d622)*qr_v(k-1)
        rilbkm = rilbkm/(Param%d622*((1. + rt(k-1))**2))
        rilckm = env_t(k-1)*(Param%d622 + env_r(k-1))*qli0_v(k-1)
        rilckm  =rilckm/(Param%d622*((1. + rt(k-1))**2))
        rila = .5*(rilak + rilakm)
        rilb = .5*(rilbk + rilbkm)
        rilc = .5*(rilck + rilckm)
        ri2ak = env_t(k)*(Param%d622 + env_r(k))/  &
                                         (Param%d622*((1. + rt(k))**2))
        ri2ak = ri2ak*qli1_v(k)
        ri2akm = env_t(k-1)*(Param%d622 + env_r(k-1))/ &
                                  (Param%d622*((1. + rt(k-1))**2))
        ri2akm = ri2akm*qli1_v(k-1)
        ri2a = .5*(ri2ak + ri2akm)
        sum1 = rila + rilb + rilc
        ri1 = ri1 + (alog(cape_p(k-1)/cape_p(k)))*   &
                                     (sum1 + dtpdta(k)*sum2)
        ri2 = ri2 + (alog(cape_p(k-1)/cape_p(k)))*  &
                                      (ri2a - dtpdta(k)*ri2b)

!----------------------------------------------------------------------
!    if in diagnostics column, output the 
!----------------------------------------------------------------------
        if (debug_ijt) then
          write(diag_unit, '(a, i4, e20.12)')   &
                        'in cuclo: k,dtpdta(k)= ',k,dtpdta(k)
          write (diag_unit,   '(a, 3e20.12)')  &
                           'in cuclo: rila,rilb,rilc= ', rila,rilb,rilc
          write (diag_unit, '(a, 2e20.12)')  &
                         'in cuclo: ri1,ri2= ',ri1,ri2
          write (diag_unit, '(a, 2e20.12)')  &
                       'in cuclo: sum1,sum2= ',sum1,sum2
        endif
      end do

!----------------------------------------------------------------------
!    if in diagnostics column, output the 
!----------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 3e20.12)')  &
                      'in cuclo: rild,rile,rilf= ', rild, rile, rilf
        if (dcape /= 0.0) then
          write (diag_unit, '(a, e20.12)')   &
                    'in cuclo:         dcape=',  dcape     
        endif
      endif

!----------------------------------------------------------------------
!----------------------------------------------------------------------
      if (ri1 >= 0) then
        a1  = 0.
      else
        ri1 = Param%rdgas*ri1
        ri2 = Param%rdgas*ri2
        if (Nml%do_dcape .and. ctrig) then
!   Zhang closure:
          a1  = -(ri2 + dcape)/ri1
        else
          if (dumxcape > cape_c .and. ctrig) then
!   cape relaxation closure:
            a1 = -(ri2 + (dumxcape - cape_c)/tau)/ri1
          else
            a1 = 0.
          endif
        endif
      endif

!--------------------------------------------------------------------


end subroutine cu_clo_cumulus_closure_k



!######################################################################

module spectral_physics_mod

use fms_mod,               only: mpp_pe, mpp_root_pe, error_mesg, FATAL, write_version_number, set_domain, file_exist, &
                                 field_size, read_data, write_data, fms_init

use constants_mod,         only: grav, pi

use time_manager_mod,      only: time_type, set_time, get_time, operator(-), operator(/=), time_manager_init

use press_and_geopot_mod,  only: pressure_variables, compute_pressures_and_heights

use transforms_mod,        only: get_grid_boundaries, get_deg_lon, get_deg_lat, get_wts_lat, &
                                 get_grid_domain, get_lon_max, get_lat_max, grid_domain, area_weighted_global_mean

use global_integral_mod,   only: mass_weighted_global_integral

use spectral_dynamics_mod, only: get_reference_sea_level_press, get_num_levels

use physics_driver_mod,    only: physics_driver_init, physics_driver_down, physics_driver_up, physics_driver_end, &
                                 surf_diff_type, do_moist_in_phys_up, get_diff_t, get_radturbten, zero_radturbten

use moist_processes_mod,   only: moist_processes_init, moist_processes, moist_processes_end

use mcm_moist_processes_mod, only: mcm_moist_processes, mcm_moist_processes_init, mcm_moist_processes_end

use tracer_type_mod,       only: tracer_type

use  field_manager_mod,    only: MODEL_ATMOS

use tracer_manager_mod,    only: get_number_tracers, get_tracer_index, NO_TRACER

implicit none
private

public :: spectral_physics_init, spectral_physics_down, spectral_physics_up, &
          spectral_physics_end, surf_diff_type, spectral_physics_moist

character(len=128), parameter :: version = &
'$Id: spectral_physics.F90,v 13.0 2006/03/28 21:17:25 fms Exp $'

character(len=128), parameter :: tagname = &
'$Name: tikal $'

integer, parameter :: num_time_levels=2

real, allocatable, dimension(:,:      ) :: rad_lon_2d, rad_lat_2d, area_2d
real, allocatable, dimension(:,:,:    ) :: diff_cu_mo
logical, allocatable, dimension(:,:   ) :: convect
real, allocatable, dimension(:,:,:,:  ) :: diag_tracers
integer :: num_levels, num_tracers, nhum
integer :: is, ie, js, je
logical :: module_is_initialized = .false.
logical :: do_mcm_moist_processes

contains

!------------------------------------------------------------------------------------------------

subroutine spectral_physics_init(Time, axes, Surf_diff, nhum_in, p_half, do_mcm_moist_processes_in)

type(time_type), intent(in) :: Time
integer, intent(in),    dimension(:) :: axes
type(surf_diff_type), intent(inout) :: Surf_diff
integer, intent(in) :: nhum_in
real, intent(in), dimension(:,:,:) :: p_half
logical, intent(in) :: do_mcm_moist_processes_in
real, allocatable, dimension(:,:,:,:) :: grid_tracers

real, allocatable, dimension(:) :: rad_lon, rad_lat, wts_lat, lon_boundaries, lat_boundaries
real, dimension(2) :: radiation_ref_press_surf = (/ 101325., 81060. /)

real, allocatable, dimension(:,:) :: radiation_ref_press, rconvect
real, allocatable, dimension(:)   :: p_half_1d, ln_p_half_1d, shalf
real, allocatable, dimension(:)   :: p_full_1d, ln_p_full_1d, sfull

real :: reference_sea_level_press
integer :: i, j, num_diag, lon_max, lat_max
character(len=4) :: ch1, ch2, ch3, ch4, ch5, ch6
character(len=64) :: file
integer, dimension(4) :: siz
logical :: do_donner

if(module_is_initialized) return

call write_version_number(version, tagname)

call fms_init
call time_manager_init

nhum = nhum_in
do_mcm_moist_processes = do_mcm_moist_processes_in

call get_grid_domain(is, ie, js, je)
allocate(rad_lon(is:ie), rad_lat(js:je), wts_lat(js:je))
allocate(lon_boundaries(ie-is+2), lat_boundaries(je-js+2))

call get_num_levels(num_levels)
allocate(radiation_ref_press(num_levels+1,2))
allocate(p_half_1d(num_levels+1), ln_p_half_1d(num_levels+1), shalf(num_levels+1))
allocate(p_full_1d(num_levels  ), ln_p_full_1d(num_levels  ), sfull(num_levels  ))

allocate (rad_lon_2d(is:ie,js:je))
allocate (rad_lat_2d(is:ie,js:je))
allocate (   area_2d(is:ie,js:je))

call pressure_variables(p_half_1d,ln_p_half_1d,radiation_ref_press(1:num_levels,1),ln_p_full_1d,radiation_ref_press_surf(1))
call pressure_variables(p_half_1d,ln_p_half_1d,radiation_ref_press(1:num_levels,2),ln_p_full_1d,radiation_ref_press_surf(2))
radiation_ref_press(num_levels+1,:) = radiation_ref_press_surf

call get_reference_sea_level_press(reference_sea_level_press)
call pressure_variables(p_half_1d, ln_p_half_1d, p_full_1d, ln_p_full_1d, reference_sea_level_press)
shalf = p_half_1d/reference_sea_level_press
sfull = p_full_1d/reference_sea_level_press

call get_lon_max(lon_max)
call get_lat_max(lat_max)
call get_deg_lon(rad_lon)
call get_deg_lat(rad_lat)
call get_wts_lat(wts_lat)
rad_lon = pi*rad_lon/180.
rad_lat = pi*rad_lat/180.
do j=js,je
  rad_lat_2d(:,j) = rad_lat(j)
  area_2d(:,j)    = wts_lat(j)/(2.*lon_max)
enddo
do i=is,ie
  rad_lon_2d(i,:) = rad_lon(i)
enddo

call get_grid_boundaries(lon_boundaries, lat_boundaries)

call get_number_tracers(MODEL_ATMOS, num_diag=num_diag)
if(num_diag > 0) then
  call error_mesg('spectral_physics_init', &
   'This version of the spectral atmospheric model not coded to handle diagnostic tracers',FATAL)
endif
allocate (diag_tracers(is:ie,js:je,num_levels,num_diag))
diag_tracers = 0.

call get_number_tracers(MODEL_ATMOS, num_prog=num_tracers)

call set_domain(grid_domain)

if(do_mcm_moist_processes) then
  call mcm_moist_processes_init( ie-is+1, je-js+1, num_levels, axes, Time)
else
  call moist_processes_init(ie-is+1, je-js+1, num_levels, lon_boundaries, lat_boundaries, &
                            radiation_ref_press(:,1), axes, Time, do_donner)
endif

allocate(grid_tracers(is:ie, js:je, num_levels, num_tracers))
grid_tracers = 0.

call physics_driver_init(Time, lon_boundaries, lat_boundaries, axes, radiation_ref_press, grid_tracers, Surf_diff, p_half)

if(sum(grid_tracers) /= 0.) then
  call error_mesg('spectral_physics_init','This version of the spectral atmospheric model not coded to handle'// &
                  ' initialization of tracer fields by physics_driver_init',FATAL)
endif

deallocate(rad_lon, rad_lat, wts_lat, lon_boundaries, lat_boundaries, grid_tracers)
deallocate(radiation_ref_press, p_half_1d, ln_p_half_1d, shalf, p_full_1d, ln_p_full_1d, sfull)

allocate (diff_cu_mo(is:ie,js:je,num_levels))
allocate ( convect(is:ie,js:je))
file = 'INPUT/spectral_physics.res.nc'
if(file_exist(trim(file))) then
  call field_size(trim(file), 'diff_cu_mo', siz)
  if(siz(1) /= lon_max .or. siz(2) /= lat_max .or. siz(3) /= num_levels) then
    write(ch1,'(i4)') siz(1)
    write(ch2,'(i4)') siz(2)
    write(ch3,'(i4)') siz(3)
    write(ch4,'(i4)') lon_max
    write(ch5,'(i4)') lat_max
    write(ch6,'(i4)') num_levels
    call error_mesg('spectral_physics_init','Resolution of restart data is incorrect.'// &
    ' Restart data: lon_max='//ch1//', lat_max='//ch2//', num_levels='//ch3// &
    '    Should be: lon_max='//ch4//', lat_max='//ch5//', num_levels='//ch6, FATAL)
  endif
  call read_data(trim(file), 'diff_cu_mo', diff_cu_mo, grid_domain)
  allocate (rconvect(is:ie,js:je))
  call read_data(trim(file), 'convect',    rconvect,   grid_domain) ! No interface for reading/writing netcdf logicals
  where(rconvect == 1.)
    convect = .true.
  elsewhere
    convect = .false.
  endwhere
  deallocate (rconvect)
else
  diff_cu_mo = 0.
  convect = .false.
endif

module_is_initialized = .true.

return
end subroutine spectral_physics_init
!------------------------------------------------------------------------------------------------

subroutine spectral_physics_down(Time_prev, Time, Time_next, previous, current,                                   &
                        p_half, p_full, z_half, z_full, psg, ug, vg, tg, grid_tracers,                            &
                        frac_land, rough_mom, albedo, t_surf, u_star, b_star, q_star, dtau_du, dtau_dv, tau_x, tau_y, &
                        albedo_vis_dir, albedo_nir_dir, albedo_vis_dif, albedo_nir_dif,                           &
                        dt_ug, dt_vg, dt_tg, dt_tracers, flux_sw, flux_sw_dir, flux_sw_dif, flux_sw_down_vis_dir, &
                        flux_sw_down_vis_dif, flux_sw_down_total_dir, flux_sw_down_total_dif, flux_sw_vis,        &
                        flux_sw_vis_dir, flux_sw_vis_dif, flux_lw, coszen, gust, Surf_diff)

type(time_type), intent(in) :: Time_prev, Time, Time_next
integer, intent(in)         :: previous, current
real,    intent(in),    dimension(:,:,:    ) :: p_full, z_full
real,    intent(in),    dimension(:,:,:    ) :: p_half, z_half
real,    intent(in),    dimension(:,:,:    ) :: psg
real,    intent(in),    dimension(:,:,:,:  ) :: ug, vg, tg
real,    intent(inout), dimension(:,:,:,:,:) :: grid_tracers
real,    intent(in),    dimension(:,:      ) :: frac_land, rough_mom, albedo, t_surf, u_star, b_star, q_star, dtau_du, dtau_dv
real,    intent(inout), dimension(:,:      ) :: tau_x, tau_y
real,    intent(in),    dimension(:,:      ) :: albedo_vis_dir, albedo_nir_dir, albedo_vis_dif, albedo_nir_dif
real,    intent(inout), dimension(:,:,:    ) :: dt_ug, dt_vg, dt_tg
real,    intent(inout), dimension(:,:,:,:  ) :: dt_tracers
real,    intent(out),   dimension(:,:      ) :: flux_sw, flux_sw_dir, flux_sw_dif, flux_sw_down_vis_dir
real,    intent(out),   dimension(:,:      ) :: flux_sw_down_vis_dif, flux_sw_down_total_dir, flux_sw_down_total_dif
real,    intent(out),   dimension(:,:      ) :: flux_sw_vis, flux_sw_vis_dir, flux_sw_vis_dif, flux_lw, coszen, gust
type(surf_diff_type), intent(inout) :: Surf_diff

real, dimension(size(dt_tracers,4)) :: gavg_rrv
integer :: nco2

!**************************************************************************************

if(.not.module_is_initialized) then
  call error_mesg('spectral_physics_down','spectral_physics module is not initialized', FATAL)
end if

nco2 = get_tracer_index(MODEL_ATMOS, 'co2')
gavg_rrv = 0.0
if(nco2 /= NO_TRACER) then
  gavg_rrv(nco2) = mass_weighted_global_integral(grid_tracers(:,:,:,current,nco2), psg(:,:,current))/ &
                    (area_weighted_global_mean(psg(:,:,current))/grav)
endif

if(do_moist_in_phys_up()) then
  call physics_driver_down(1, ie-is+1, 1, je-js+1, Time_prev, Time, Time_next,   &
            rad_lat_2d,    rad_lon_2d,  area_2d,                                 &
                p_half,      p_full, z_half, z_full,                             &
                    ug(:,:,:,current), vg(:,:,:,current),                        &
                    tg(:,:,:,current), grid_tracers(:,:,:,current,nhum),         &
          grid_tracers(:,:,:,current,:), ug(:,:,:,previous), vg(:,:,:,previous), &
                    tg(:,:,:,previous), grid_tracers(:,:,:,previous,nhum),       &
          grid_tracers(:,:,:,previous,:),                                        &
             frac_land, rough_mom,      albedo,                                  &
               albedo_vis_dir, albedo_nir_dir, albedo_vis_dif, albedo_nir_dif,   &
                t_surf,    u_star,      b_star, q_star,                          &
               dtau_du, dtau_dv,     tau_x,       tau_y,                         &
               dt_ug,       dt_vg,         dt_tg,                                &
               dt_tracers(:,:,:,nhum), dt_tracers, flux_sw(:,:),                 &
               flux_sw_dir, flux_sw_dif, flux_sw_down_vis_dir,                   &
               flux_sw_down_vis_dif, flux_sw_down_total_dir,                     &
               flux_sw_down_total_dif, flux_sw_vis,                              &
               flux_sw_vis_dir, flux_sw_vis_dif,                                 &
               flux_lw, coszen, gust, Surf_diff, gavg_rrv)
else
  call physics_driver_down(1, ie-is+1, 1, je-js+1, Time_prev, Time, Time_next,   &
            rad_lat_2d,    rad_lon_2d,  area_2d,                                 &
                p_half,      p_full, z_half, z_full,                             &
                    ug(:,:,:,current), vg(:,:,:,current),                        &
                    tg(:,:,:,current), grid_tracers(:,:,:,current,nhum),         &
          grid_tracers(:,:,:,current,:), ug(:,:,:,previous), vg(:,:,:,previous), &
                    tg(:,:,:,previous), grid_tracers(:,:,:,previous,nhum),       &
          grid_tracers(:,:,:,previous,:),                                        &
             frac_land, rough_mom,      albedo,                                  &
               albedo_vis_dir, albedo_nir_dir, albedo_vis_dif, albedo_nir_dif,   &
                t_surf,    u_star,      b_star, q_star,                          &
               dtau_du, dtau_dv,     tau_x,       tau_y,                         &
                 dt_ug,       dt_vg,         dt_tg,                              &
                 dt_tracers(:,:,:,nhum), dt_tracers, flux_sw,                    &
               flux_sw_dir, flux_sw_dif, flux_sw_down_vis_dir,                   &
               flux_sw_down_vis_dif, flux_sw_down_total_dir,                     &
               flux_sw_down_total_dif, flux_sw_vis,                              &
               flux_sw_vis_dir, flux_sw_vis_dif,                                 &
               flux_lw, coszen, gust, Surf_diff, gavg_rrv, diff_cum_mom=diff_cu_mo, &
               moist_convect=convect)
endif

return
end subroutine spectral_physics_down
!------------------------------------------------------------------------------------------------
subroutine spectral_physics_up(Time_prev, Time, Time_next, previous, current, p_half, p_full,     &
                               z_half, z_full, wg_full, ug, vg, tg, grid_tracers,                 &
                               frac_land, dt_ug, dt_vg, dt_tg, dt_tracers, Surf_diff, lprec, fprec, gust)

type(time_type), intent(in) :: Time_prev, Time, Time_next
integer,         intent(in) :: previous, current
real, intent(in),    dimension(:,:,:    ) :: p_full, z_full, wg_full
real, intent(in),    dimension(:,:,:    ) :: p_half, z_half
real, intent(in),    dimension(:,:,:,:  ) :: ug, vg, tg
real, intent(in),    dimension(:,:,:,:,:) :: grid_tracers
real, intent(in),    dimension(:,:      ) :: frac_land
real, intent(inout), dimension(:,:,:    ) :: dt_ug, dt_vg, dt_tg
real, intent(inout), dimension(:,:,:,:  ) :: dt_tracers
type(surf_diff_type), intent(inout) :: Surf_diff
real, intent(out),   dimension(:,:) :: lprec, fprec
real, intent(inout), dimension(:,:) :: gust

if(.not.module_is_initialized) then
  call error_mesg('spectral_physics_up','spectral_physics module is not initialized', FATAL)
end if

call physics_driver_up(1, ie-is+1, 1, je-js+1, Time_prev, Time, Time_next,    &
                       rad_lat_2d, rad_lon_2d, area_2d,                       &
                       p_half, p_full, z_half, z_full,                        &
                       wg_full, ug(:,:,:,current), vg(:,:,:,current),         &
                       tg(:,:,:,current), grid_tracers(:,:,:,current,nhum),   &
                       grid_tracers(:,:,:,current,:),                         &
                       ug(:,:,:,previous), vg(:,:,:,previous),                &
                       tg(:,:,:,previous), grid_tracers(:,:,:,previous,nhum), &
                       grid_tracers(:,:,:,previous,:),                        &
                       frac_land, dt_ug, dt_vg, dt_tg,                        &
                       dt_tracers(:,:,:,nhum), dt_tracers, Surf_diff,         &
                       lprec, fprec, gust)

return
end subroutine spectral_physics_up
!------------------------------------------------------------------------------------------------
subroutine spectral_physics_moist(Time_next, delta_t, frac_land, p_half, p_full, z_half, z_full, wg_full, &
                                  tg, qg, ug, vg, tracers, lprec, fprec, gust)

type(time_type), intent(in) :: Time_next
real, intent(in)                        :: delta_t
real, intent(in),    dimension(:,:)     :: frac_land
real, intent(in),    dimension(:,:,:)   :: p_half, p_full, z_half, z_full, wg_full
real, intent(inout), dimension(:,:,:)   :: tg, qg, ug, vg
real, intent(inout), dimension(:,:,:,:) :: tracers
real, intent(inout), dimension(:,:)     :: lprec, fprec, gust
real, dimension(size(tg,1), size(tg,2), size(tg,3)) :: dt_tg, dt_qg, dt_ug, dt_vg
real, dimension(size(tracers,1), size(tracers,2), size(tracers,3), size(tracers,4)) :: dt_tracers
real, dimension(size(gust,1), size(gust,2)) :: gust_cv

dt_tg=0.; dt_qg=0.; dt_ug=0.; dt_vg=0.; dt_tracers=0.

if(do_moist_in_phys_up()) then
  if ( do_mcm_moist_processes ) then
    call error_mesg('spectral_physics_moist','do_mcm_moist_processes cannot be .true. when moist_processes'// &
                    ' is called by physics_driver_up', FATAL)
  endif
else
  if ( do_mcm_moist_processes ) then
    call mcm_moist_processes(1, ie-is+1, 1, je-js+1, Time_next, delta_t, p_half, p_full, tg, tracers(:,:,:,nhum), lprec, fprec)
  else
    call moist_processes(1, ie-is+1, 1, je-js+1, Time_next, delta_t, frac_land, p_half, p_full, z_half, z_full, wg_full, &
                         get_diff_t(), get_radturbten(),                                                                 &
                         tg, qg, tracers, ug, vg, tg, qg, tracers, ug, vg, dt_tg, dt_qg, dt_tracers, dt_ug, dt_vg,       &
                         diff_cu_mo, convect, lprec, fprec, gust_cv, area_2d, rad_lat_2d)
    gust = sqrt( gust*gust + gust_cv*gust_cv)
    call zero_radturbten()
    tg = tg + dt_tg*delta_t
    qg = qg + dt_qg*delta_t
    ug = ug + dt_ug*delta_t
    vg = vg + dt_vg*delta_t
    tracers = tracers + dt_tracers*delta_t
  endif
endif

return
end subroutine spectral_physics_moist
!------------------------------------------------------------------------------------------------

subroutine spectral_physics_end(Time)
character(len=64) :: file

type(time_type), intent(in) :: Time
real, dimension(is:ie,js:je)  :: rconvect

if(.not.module_is_initialized) return

file = 'RESTART/spectral_physics.res.nc'
call write_data(trim(file), 'diff_cu_mo', diff_cu_mo, grid_domain)
where(convect)
  rconvect = 1.
elsewhere
  rconvect = 0.
endwhere
call write_data(trim(file), 'convect', rconvect, grid_domain) ! pjp: No interface for reading/writing netcdf logicals

deallocate(rad_lon_2d, rad_lat_2d, area_2d, diff_cu_mo, convect)
call physics_driver_end(Time)
if(do_mcm_moist_processes) then
  call mcm_moist_processes_end
else
  call moist_processes_end
endif
module_is_initialized = .false.

return
end subroutine spectral_physics_end
!------------------------------------------------------------------------------------------------

end module spectral_physics_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: eqstate --- the equation of state \label{sec:eqstate}
!
! !INTERFACE:
   MODULE eqstate
!
! !DESCRIPTION:
!  Computes the density, $\mean{\rho}$, and buoyancy from the
!  salinity, $S$, the temperature, $\Theta$, and the thermodynamic
!  pressure, $P$, according to an \emph{equation of state},
!  \begin{equation}
!    \label{DefEOS}
!     \mean{\rho} = \hat{\rho} (S,\Theta,P)
!     \point
!  \end{equation}
!
!  The following remark on the thermodynamic interpretation of
!  density, temperature, and pressure is useful here.  If $\Theta$ is
!  identified with the in-situ temperature, and $P$ with the in-situ
!  pressure, then $\mean{\rho}$ will be the in-situ density.  On the
!  other hand, if $P$ is identified with the surface pressure, and
!  $\Theta$ with the potential temperature, the same equation of
!  state, \eq{DefEOS}, will yield $\mean{\rho}$ as the potential
!  density. Note that the quantity {\tt sigma\_t} found in the GOTM output
!  is simply computed from  $\mean{\rho}$ - 1000 kg m$^{-3}$, and may
!  therefore adopt different meanings.
!
!
!  At present, two different models for the equation of state ("modes"),
!  and four different "methods" how to evalute the equation of state
!  are implemented.
!
!  Modes:
!  \begin{enumerate}
!     \item The UNESCO equation of state according to \cite{FofonoffMillard83}
!     \item The \cite{JACKETTea05} equation of state
!  \end{enumerate}
!  Methods:
!  \begin{enumerate}
!     \item the full equation of state --- including pressure effects
!     \item the full equation of state --- without pressure effects
!     \item the linearised equation of state
!     \item a general linear form of the equation of state
!  \end{enumerate}

!USES:
   IMPLICIT NONE

!  default: all is private.
   private
!
! !PUBLIC MEMBER FUNCTIONS:
   public init_eqstate,eqstate1,eos_alpha,eos_beta,unesco,rho_feistel
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard & Karsten Bolding
!
!  $Log: eqstate.F90,v $
!  Revision 20.0  2013/12/14 00:14:01  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:01:18  smg
!  initial cvs ci to mom5
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:33:41  smg
!  updated to gotm-2012.03.09 CVS tagged code.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.9  2010-09-17 12:53:53  jorn
!  extensive code clean-up to ensure proper initialization and clean-up of all variables
!
!  Revision 1.8  2008-08-01 07:33:14  lars
!  modified documentation
!
!  Revision 1.7  2007-01-06 11:49:13  kbk
!  namelist file extension changed .inp --> .nml
!
!  Revision 1.6  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.5  2003/03/28 09:20:36  kbk
!  added new copyright to files
!
!  Revision 1.4  2003/03/28 08:06:33  kbk
!  removed tabs
!
!  Revision 1.3  2003/03/10 08:54:16  gotm
!  Improved documentation and cleaned up code
!
!  Revision 1.2  2001/11/27 19:44:32  gotm
!  Fixed an initialisation bug
!
!  Revision 1.1.1.1  2001/02/12 15:55:58  gotm
!  initial import into CVS
!
!EOP
!
!  private data memebers
   integer                   :: eq_state_method, eq_state_mode
   REALTYPE                  :: T0,S0,p0,dtr0,dsr0
   logical                   :: init_linearised
!
!-----------------------------------------------------------------------

   contains

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Read the namelist {\tt eqstate}
!
! !INTERFACE:
   subroutine init_eqstate(namlst)
!
! !DESCRIPTION:
!  Here, the namelist {\tt eqstate} in the namelist file {\tt gotmrun.nml}
!  is read.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, optional, intent(in)       :: namlst
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard & Karsten Bolding
!
!EOP
!
! !LOCAL VARIABLES:
   namelist /eqstate/ eq_state_mode,eq_state_method,T0,S0,p0,dtr0,dsr0
!
!-----------------------------------------------------------------------
!BOC
   LEVEL1 'init_eqstate'
   init_linearised = .true.
   if(present(namlst)) then
      read(namlst,nml=eqstate,err=80)
   end if
   return
   80 FATAL 'I could not read "eqstate" namelist'
   stop 'init_eqstate'
   end subroutine init_eqstate
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Select an equation of state
!
! !INTERFACE:
   REALTYPE function eqstate1(S,T,p,g,rho_0)
!
! !DESCRIPTION:
!  Calculates the in-situ buoyancy according to the selected method.
!  {\tt S} is salinity $S$ in psu, {\tt T} is
!  potential temperature $\theta$ in $^{\circ}$C (ITS-90), {\tt p} is
!  gauge pressure (absolute pressure - 10.1325 bar), {\tt g} is the
!  gravitational acceleration in m\,s$^{-2}$ and {\tt rho\_0} the reference
!  density in kg\,m$^{-3}$. {\tt eqstate1} is the in-situ-density
!  in kg\,m$^{-3}$.
!  For {\tt eq\_state\_method}=1, the UNESCO equation of state is used,
!  for {\tt eq\_state\_method}=2, the \cite{JACKETTea05} equation
!  of state is used. Here, some care is needed, since the UNESCO equation
!  used bar for pressure and the \cite{JACKETTea05} uses dbar for pressure.
!  For values of
!  {\tt eq\_state\_method} ranging from 1 to 4, one of the following methods
!  will be used.
!
!   \begin{enumerate}
!     \item the full equation of state for sea water
!           including pressure dependence.
!     \item the equation of state for sea water
!           with the pressure evaluated at the sea surface as
!           reference level. This is the choice
!           for computations based on potential temperature and density.
!     \item a linearised equation of state.
!           The parameters {\tt T0},
!           {\tt S0} and {\tt p0} have to be specified in the namelist.
!     \item a linear equation of state with prescribed {\tt rho0}, {\tt T0},
!           {\tt S0}, {\tt dtr0}, {\tt dsr0} according to
!           \begin{equation}
!              \label{eosLinear}
!              \rho = \rho_0 + \text{\tt dtr0} (T - T_0)
!                            + \text{\tt dsr0} (S - S_0)
!               \point
!           \end{equation}
!   \end{enumerate}

!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE,intent(in)                 :: S,T,p
   REALTYPE,optional,intent(in)        :: g,rho_0
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard & Karsten Bolding
!
!EOP
!
! !LOCAL VARIABLES:
   REALTYPE                  :: x
   REALTYPE, save            :: rh0,dtr,dsr
   REALTYPE                  :: dTT,dSS
   logical                   :: press
!
!-----------------------------------------------------------------------
!BOC
   select case (eq_state_mode)
      case(1)
         select case (eq_state_method)
            case (1)
               press=.true.
               x=unesco(S,T,p,press)
            case (2)
               press=.false.
               x=unesco(S,T,p,press)
            case (3)
               if (init_linearised) then
                  press=.true.   ! This allows for choosing potentials other than p=0
                  dTT=0.001
                  dSS=0.001
                  rh0= unesco(S0,T0,p0,press)
                  dtr=(unesco(S0,T0+0.5*dTT,p0,press)        &
                      -unesco(S0,T0-0.5*dTT,p0,press))/dTT
                  dsr=(unesco(S0+0.5*dSS,T0,p0,press)        &
                      -unesco(S0-0.5*dSS,T0,p0,press))/dSS
                  init_linearised=.false.
               end if
               x=rh0+dtr*(T-T0)+dsr*(S-S0)
            case (4)
               x=rho_0+dtr0*(T-T0)+dsr0*(S-S0)
            case default
         end select
      case(2)
         select case (eq_state_method)
            case (1)
               press=.true.
               x=rho_feistel(S,T,p*10.,press)
            case (2)
               press=.false.
               x=rho_feistel(S,T,p*10.,press)
            case (3)
               if (init_linearised) then
                  press=.true.   ! This allows for choosing potentials other than p=0
                  dTT=0.001
                  dSS=0.001
                  rh0= rho_feistel(S0,T0,p0*10.,press)
                  dtr=(rho_feistel(S0,T0+0.5*dTT,p0*10.,press)        &
                      -rho_feistel(S0,T0-0.5*dTT,p0*10.,press))/dTT
                  dsr=(rho_feistel(S0+0.5*dSS,T0,p0*10.,press)        &
                      -rho_feistel(S0-0.5*dSS,T0,p0*10.,press))/dSS
                  init_linearised=.false.
               end if
               x=rh0+dtr*(T-T0)+dsr*(S-S0)
            case (4)
               x=rho_0+dtr0*(T-T0)+dsr0*(S-S0)
            case default
         end select
      case default
   end select

   eqstate1=-g*(x-rho_0)/rho_0

   return
   end function eqstate1
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Compute thermal expansion coefficient
!
! !INTERFACE:
   REALTYPE function eos_alpha(S,T,p,g,rho_0)
!
! !DESCRIPTION:
!  Computes the thermal expansion coefficient defined by
!  \begin{equation}
!   \label{eosAlpha}
!        \alpha =
!         - \dfrac{1}{\rho_0}
!        \left( \partder{\rho_{is}}{T} \right)_S
!	 =
!        \dfrac{1}{g}
!        \left( \partder{B_{is}}{T} \right)_S
!        \comma
!  \end{equation}
!  where $B_{is}$ denotes the in-situ buoyancy. The computation is carried
!  out by a finite difference approximation of \eq{eosAlpha},
!  requiring two evaluations of the equation of state.
!  Note, that comparing \eq{eosAlpha} with \eq{eosLinear} it follows that
!  $\alpha = - \text{\tt dtr0}/\rho_0$.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE,intent(in)                 :: S,T,p
   REALTYPE,optional,intent(in)        :: g,rho_0
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
!
   REALTYPE,parameter                :: delta = 0.01
   REALTYPE                          :: buoy_a,buoy_b
!-----------------------------------------------------------------------
!BOC

      buoy_a    = eqstate1(S,T+0.5*delta,p,g,rho_0)
      buoy_b    = eqstate1(S,T-0.5*delta,p,g,rho_0)

      eos_alpha =  (buoy_a - buoy_b) / (g*delta)

   end function eos_alpha
!EOC


!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Compute saline contraction coefficient
!
! !INTERFACE:
   REALTYPE function eos_beta(S,T,p,g,rho_0)
!
! !DESCRIPTION:
!  Computes the saline contractioncoefficient defined by
!  \begin{equation}
!   \label{eosBeta}
!        \beta =
!         \dfrac{1}{\rho_0}
!        \left( \partder{\rho_{is}}{S} \right)_T
!	 =
!        - \dfrac{1}{g}
!        \left( \partder{B_{is}}{S} \right)_T
!        \comma
!  \end{equation}
!  where $B_{is}$ denotes the in-situ buoyancy. The computation is carried
!  out by a finite difference approximation of \eq{eosBeta},
!  requiring two evaluations of the equation of state.
!  Note, that comparing \eq{eosBeta} with \eq{eosLinear} it follows that
!  $\beta = \text{\tt dsr0}/\rho_0$.
!
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE,intent(in)                 :: S,T,p
   REALTYPE,optional,intent(in)        :: g,rho_0
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!EOP
!
! !LOCAL VARIABLES:
!
   REALTYPE,parameter                :: delta = 0.01
   REALTYPE                          :: buoy_a,buoy_b
!-----------------------------------------------------------------------
!BOC

      buoy_a    =   eqstate1(S+0.5*delta,T,p,g,rho_0)
      buoy_b    =   eqstate1(S-0.5*delta,T,p,g,rho_0)

      eos_beta = -(buoy_a - buoy_b) / (g*delta)

   end function eos_beta
!EOC


!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: The UNESCO equation of state
!
! !INTERFACE:
   REALTYPE function unesco(S,T,p,UNPress)
!
! !DESCRIPTION:
!  Computes the in-situ density in \eq{DefEOS} according to the
!  UNESCO equation of state for sea water (see \cite{FofonoffMillard83}).
!  The pressure
!  dependence can be switched on ({\tt UNPress=.true.}) or off
!  ({\tt UNPress=.false.}). {\tt S} is salinity $S$ in psu, {\tt T} is
!  potential temperature $\theta$ in $^{\circ}$C (ITS-90), {\tt p} is
!  gauge pressure (absolute pressure - 10.1325 bar) and
!  {\tt  unesco} is the in-situ density in kg\,m$^{-3}$.
!  The check value is {\tt unesco(35,25,1000) = 1062.53817} .
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)                :: S,T,p
   LOGICAL, intent(in)                 :: UNPress
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard & Karsten Bolding
!
!EOP
!
! !LOCAL VARIABLES:
   REALTYPE                  :: x,K
   REALTYPE                  :: T2,T3,T4,T5,S15,S2,S3,p2
!
!-----------------------------------------------------------------------
!BOC
   T2 = T*T
   T3 = T*T2
   T4 = T2*T2
   T5 = T*T4
   S15= S**1.5
   S2 = S*S
   S3 = S*S2

   x=999.842594+6.793952e-02*T-9.09529e-03*T2+1.001685e-04*T3
   x=x-1.120083e-06*T4+6.536332e-09*T5
   x=x+S*(0.824493-4.0899e-03*T+7.6438e-05*T2-8.2467e-07*T3)
   x=x+S*5.3875e-09*T4
   x=x+sqrt(S3)*(-5.72466e-03+1.0227e-04*T-1.6546e-06*T2)
   x=x+4.8314e-04*S2

     if ((UNPress).and.(p.gt.0)) then
     p2=p*p
     K= 19652.21                                         &
       +148.4206     *T          -2.327105    *T2        &
       +  1.360477E-2*T3         -5.155288E-5 *T4        &
       +  3.239908      *p       +1.43713E-3  *T *p      &
       +  1.16092E-4 *T2*p       -5.77905E-7  *T3*p      &
       +  8.50935E-5    *p2      -6.12293E-6  *T *p2     &
       +  5.2787E-8  *T2*p2                              &
       + 54.6746             *S  -0.603459    *T    *S   &
       +  1.09987E-2 *T2     *S  -6.1670E-5   *T3   *S   &
       +  7.944E-2           *S15+1.6483E-2   *T    *S15 &
       -  5.3009E-4  *T2     *S15+2.2838E-3      *p *S   &
       -  1.0981E-5  *T *p   *S  -1.6078E-6   *T2*p *S   &
       +  1.91075E-4    *p   *S15-9.9348E-7      *p2*S   &
       +  2.0816E-8  *T *p2*S    +9.1697E-10  *T2*p2*S
     x=x/(1.-p/K)
   end if

   unesco=x
   return
   end function unesco
!EOC
!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: The \cite{JACKETTea05} equation of state
!
! !INTERFACE:
   REALTYPE function rho_feistel(s,th,p,UNPress)
!
! !DESCRIPTION:
!  Computes the in-situ density in \eq{DefEOS} according to the
!  \cite{JACKETTea05} equation of state for sea water, which is based
!  on the Gibbs potential developed by \cite{FEISTEL03}. The pressure
!  dependence can be switched on ({\tt UNPress=.true.}) or off
!  ({\tt UNPress=.false.}). {\tt s} is salinity $S$ in psu, {\tt th} is
!  potential temperature $\theta$ in $^{\circ}$C (ITS-90), {\tt p} is
!  gauge pressure (absolute pressure - 10.1325 dbar) and
!  {\tt  rho\_feistel} is the in-situ density in kg\,m$^{-3}$.
!  The check value is {\tt rho\_feistel(20,20,1000) = 1017.728868019642} .
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   REALTYPE, intent(in)                :: s,th,p
   LOGICAL, intent(in)                 :: UNPress
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard & Karsten Bolding
!
!EOP
!
! !LOCAL VARIABLES:
   REALTYPE                  :: th2,sqrts,pth,anum,aden
!
!-----------------------------------------------------------------------
!BOC

th2 = th*th
sqrts = sqrt(s)


anum =          9.9984085444849347d+02 +    &
           th*( 7.3471625860981584d+00 +    &
           th*(-5.3211231792841769d-02 +    &
           th*  3.6492439109814549d-04)) +  &
            s*( 2.5880571023991390d+00 -    &
           th*  6.7168282786692355d-03 +    &
            s*  1.9203202055760151d-03)

aden =          1.0000000000000000d+00 +    &
           th*( 7.2815210113327091d-03 +    &
           th*(-4.4787265461983921d-05 +    &
           th*( 3.3851002965802430d-07 +    &
           th*  1.3651202389758572d-10))) + &
            s*( 1.7632126669040377d-03 -    &
           th*( 8.8066583251206474d-06 +    &
          th2*  1.8832689434804897d-10) +   &
        sqrts*( 5.7463776745432097d-06 +    &
          th2*  1.4716275472242334d-09))



if((UNPress).and.(p.gt.0.d0)) then

    pth = p*th

    anum = anum +        p*( 1.1798263740430364d-02 +   &
                       th2*  9.8920219266399117d-08 +   &
                         s*  4.6996642771754730d-06 -   &
                         p*( 2.5862187075154352d-08 +   &
                       th2*  3.2921414007960662d-12))

    aden = aden +        p*( 6.7103246285651894d-06 -   &
                  pth*(th2*  2.4461698007024582d-17 +   &
                         p*  9.1534417604289062d-18))

end if


rho_feistel = anum/aden


!       Note:   this function should always be run in double precision
!               (since rho is returned rather than sigma = rho-1.0d3)

   return
   end function rho_feistel
!EOC

   end module eqstate

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module implicit_mod
!||zn, pjk 5/13/99
!following vb's changes to old implicit_mod.
!implicit_init works with global fields, everything else on domain

use              fms_mod, only: error_mesg, FATAL, write_version_number

use        constants_mod, only: rdgas, radius, cp_air

use press_and_geopot_mod, only: pressure_variables

use    matrix_invert_mod, only: invert

use       transforms_mod, only: get_spec_domain

implicit none

private

public :: implicit_init, implicit_correction, implicit_end

interface linear_geopotential
   module procedure   linear_geopotential_1d, linear_geopotential_3d
end interface

interface linear_tp_tendency
   module procedure   linear_tp_tendency_1d, linear_tp_tendency_3d
end interface

logical :: module_is_initialized = .false.

character(len=128), parameter :: version = '$Id: implicit.F90,v 13.0 2006/03/28 21:17:54 fms Exp $'
character(len=128), parameter :: tagname = '$Name: tikal $'

real,    allocatable, dimension(:)   :: ref_temperature_implicit
real,    allocatable, dimension(:)   :: ref_ln_p_half, ref_ln_p_full, del_ln_p_half, del_ln_p_full
real,    allocatable, dimension(:,:) :: eigen
integer, allocatable, dimension(:,:) :: wavenumber

real :: alpha, ref_surf_p_implicit

real, allocatable, dimension(:,:)   :: div_mat
real, allocatable, dimension(:)     :: h
real, allocatable, dimension(:,:,:) :: wave_matrix
real, allocatable, dimension(:)     :: pk, bk, dpk, dbk

real :: dt = 0.0
real :: xi

integer :: num_levels, num_total_wavenumbers
character(len=64) :: vert_difference_option
integer :: ms, me, ns, ne

contains

!------------------------------------------------------------------------

subroutine implicit_init(pk_in, bk_in, ref_temperature_implicit_in, ref_surf_p_implicit_in, &
                         num_total_wavenumbers_in, eigen_in, wavenumber_in, alpha_in,       &
                         vert_difference_option_in)

real,    intent(in), dimension(:)     :: pk_in, bk_in, ref_temperature_implicit_in
real,    intent(in), dimension(0:,0:) :: eigen_in
integer, intent(in), dimension(0:,0:) :: wavenumber_in

real,    intent(in) :: ref_surf_p_implicit_in, alpha_in
integer, intent(in) :: num_total_wavenumbers_in
character(len=*), intent(in) :: vert_difference_option_in

real, dimension(size(ref_temperature_implicit_in,1)  ) :: p_full_work_1, p_full_work_2, ln_p_full_work_1, ln_p_full_work_2
real, dimension(size(ref_temperature_implicit_in,1)+1) :: p_half_work_1, p_half_work_2, ln_p_half_work_1, ln_p_half_work_2

real :: surface_p_1, eps=1.e-5
integer :: k

if(module_is_initialized) return

call write_version_number(version, tagname)

call get_spec_domain(ms, me, ns, ne)

num_levels = size(ref_temperature_implicit_in,1)
num_total_wavenumbers = num_total_wavenumbers_in

allocate(ref_temperature_implicit(num_levels))
allocate(ref_ln_p_half(num_levels+1))
allocate(ref_ln_p_full(num_levels))
allocate(del_ln_p_half(num_levels+1))
allocate(del_ln_p_full(num_levels))
allocate(div_mat(num_levels,num_levels))
allocate(wave_matrix(num_levels,num_levels,0:num_total_wavenumbers))
allocate(h(num_levels))
allocate(eigen(0:size(eigen_in,1)-1,0:size(eigen_in,2)-1))
allocate(wavenumber(0:size(eigen_in,1)-1,0:size(eigen_in,2)-1))

ref_temperature_implicit = ref_temperature_implicit_in
ref_surf_p_implicit = ref_surf_p_implicit_in
eigen         = eigen_in
wavenumber    = wavenumber_in
alpha         = alpha_in
vert_difference_option = vert_difference_option_in

allocate( pk(size(pk_in(:))),  bk(size(bk_in,1)))
allocate(dpk(num_levels  ), dbk(num_levels  ))

pk = pk_in
bk = bk_in

do k = 1,num_levels
  dpk(k) = pk(k+1) - pk(k)
  dbk(k) = bk(k+1) - bk(k)
end do

call pressure_variables(p_half_work_1, ref_ln_p_half, p_full_work_1, ref_ln_p_full, ref_surf_p_implicit)

!del_ln_p_half = dln_p_half_dps(ref_surf_p_implicit)
!del_ln_p_full = dln_p_full_dps(ref_surf_p_implicit)

!  functions dln_p_half_dps and del_ln_p_full are used nowhere else and
!  they perform very simple calculations, so it only makes the code more
!  confusing to do these calculations in functions.

do k=2,num_levels+1
  del_ln_p_half(k) = bk(k)/(pk(k)+bk(k)*ref_surf_p_implicit)
enddo

if(pk(1).eq.0.0) then
  del_ln_p_half(1) = 1.0/ref_surf_p_implicit
else
  del_ln_p_half(1) = bk(1)/(pk(1)+bk(1)*ref_surf_p_implicit)
endif

surface_p_1 = ref_surf_p_implicit*(1.0 - 0.5*eps)
call pressure_variables(p_half_work_1, ln_p_half_work_1, p_full_work_1, ln_p_full_work_1, surface_p_1)

surface_p_1 = ref_surf_p_implicit*(1.0 + 0.5*eps)
call pressure_variables(p_half_work_2, ln_p_half_work_2, p_full_work_2, ln_p_full_work_2, surface_p_1)

del_ln_p_full = (ln_p_full_work_2 - ln_p_full_work_1)/(eps*ref_surf_p_implicit)

call build_matrix

module_is_initialized = .true.

return
end subroutine implicit_init

!------------------------------------------------------------------------

subroutine build_matrix

real, dimension(num_levels) :: input, zero, dt_t
real, dimension(num_levels+1) :: zero_1
real :: dt_p

real, dimension(num_levels, num_levels) :: gamma, tau
real, dimension(num_levels) :: nu, h1, h2

integer :: k, kk, kkk

zero  = 0.0
zero_1 = 0.0

tau = 0.0
nu = 0.0
do k=1,num_levels
  input    = 0.0
  input(k) = 1.0
  
  call linear_tp_tendency(input, ref_temperature_implicit, ref_surf_p_implicit, &
                          ref_ln_p_half, ref_ln_p_full, dt_p, dt_t)
  nu(k)    = - dt_p
  tau(:,k) = - dt_t

  gamma(:,k) = linear_geopotential(input,zero_1,zero, &
                    ref_temperature_implicit, ref_ln_p_half, ref_ln_p_full)
end do

h1 = pres_grad_funct(ref_temperature_implicit, ref_ln_p_half, ref_ln_p_full, ref_surf_p_implicit)

h2 = linear_geopotential(zero,del_ln_p_half,del_ln_p_full, &
                    ref_temperature_implicit, ref_ln_p_half, ref_ln_p_full)

h = h1 + h2

do k = 1,num_levels
  do kk = 1,num_levels
    div_mat(k,kk)= h(k)*nu(kk)
    do kkk = 1,num_levels
      div_mat(k,kk)=div_mat(k,kk)+gamma(k,kkk)*tau(kkk,kk)   
    enddo
  enddo
enddo

return
end subroutine build_matrix

!-------------------------------------------------------------------------

subroutine build_wave_matrices

real :: factor, det
integer :: k, L

wave_matrix = 0.0
do L = 0,num_total_wavenumbers
  factor = xi*xi*L*(L+1)/radius**2
  do k = 1,num_levels
    wave_matrix(k,k,L) = 1.0
  end do
  wave_matrix(:,:,L) = wave_matrix(:,:,L) + factor*div_mat(:,:)
  call invert(wave_matrix(:,:,L), det)
end do

return
end subroutine build_wave_matrices

!---------------------------------------------------------------------

subroutine implicit_correction(dt_divs, dt_ts, dt_ln_ps, divs, ts, ln_ps, dt_in, previous, current)
!in parallel, wavenumber (0,0) actually means (ms,ns)
!it is necessary to use the (0:,0:) dimensioning here because of the m-n loop below
complex, intent(inout), dimension(0:,0:,:) :: dt_divs, dt_ts
complex, intent(inout), dimension(0:,0:) :: dt_ln_ps
complex, intent(in), dimension(0:,0:,:,:) :: divs, ts
complex, intent(in), dimension(0:,0:,:) :: ln_ps
real, intent(in) :: dt_in
integer,intent(in) :: previous, current

complex, dimension(0:size(divs,1)-1,0:size(divs,2)-1,size(divs,3)) :: dt_ts_temp
complex, dimension(num_levels) ::  work
complex, dimension(0:size(divs,1)-1,0:size(divs,2)-1) :: dt_ps_temp
integer :: m,n,L

if(.not.module_is_initialized) then
  call error_mesg('implicit_correction','failed to initialize implicit', FATAL)
end if

if(dt_in.ne.dt) then 
   dt = dt_in
   xi = dt*alpha
   call build_wave_matrices
end if

call adjust_dt_divs(dt_divs, dt_ts, dt_ln_ps, divs, ts, ln_ps, previous, current)

do n = 0,size(divs,2)-1
  do m = 0,size(divs,1)-1
!||zn, pjk 5/13/99, following vb's dmsm/implicit.f90
    L = wavenumber(m+ms,n+ns)
    if(L.le.num_total_wavenumbers) then
      work = matmul(wave_matrix(:,:,L),dt_divs(m,n,:))
      dt_divs(m,n,:) = work
    end if
  end do
end do

call linear_tp_tendency(dt_divs, ref_temperature_implicit, ref_surf_p_implicit, &
                        ref_ln_p_half, ref_ln_p_full, dt_ps_temp, dt_ts_temp)

dt_ts    = dt_ts    + xi*dt_ts_temp
dt_ln_ps = dt_ln_ps + xi*dt_ps_temp/ref_surf_p_implicit

return
end subroutine implicit_correction

!---------------------------------------------------------------------
subroutine adjust_dt_divs(dt_divs, dt_ts, dt_ln_ps, divs, ts, ln_ps, previous, current)
  !||zn, pjk 5/13/99, following vb's dmsm/implicit.f90. (0:,0:) -> (:,:)
complex, intent(inout), dimension(:,:,:) :: dt_divs
complex, intent(inout), dimension(:,:,:) :: dt_ts
complex, intent(inout), dimension(:,:) :: dt_ln_ps
complex, intent(in), dimension(:,:,:,:) :: divs, ts
complex, intent(in), dimension(:,:,:) :: ln_ps
integer, intent(in) :: previous, current

complex, dimension(size(ts,1),size(ts,2),size(ts,3)) :: divs_temp, ts_temp, geopot, dt_ts_temp, ln_p_full_temp
complex, dimension(size(ts,1),size(ts,2),size(ts,3)+1) :: ln_p_half_temp
complex, dimension(size(ts,1),size(ts,2)) :: ps_temp, dt_ps_temp

integer :: k

divs_temp = divs(:,:,:,previous) - divs(:,:,:,current)

call linear_tp_tendency(divs_temp, ref_temperature_implicit, ref_surf_p_implicit, &
                        ref_ln_p_half, ref_ln_p_full, dt_ps_temp, dt_ts_temp)

dt_ts    = dt_ts    + dt_ts_temp
dt_ln_ps = dt_ln_ps + dt_ps_temp/ref_surf_p_implicit

ts_temp =    ts(:,:,:,previous) -    ts(:,:,:,current) + xi*dt_ts   
ps_temp = ln_ps(:,:,  previous) - ln_ps(:,:,  current) + xi*dt_ln_ps 

ln_p_full_temp = (0.,0.)
ln_p_half_temp = (0.,0.)

geopot = linear_geopotential(ts_temp,ln_p_half_temp,ln_p_full_temp, ref_temperature_implicit, ref_ln_p_half, ref_ln_p_full) 

do k=1,num_levels
  dt_divs(:,:,k)=dt_divs(:,:,k)+eigen(ms:me,ns:ne)*(geopot(:,:,k)+h(k)*ps_temp(:,:)*ref_surf_p_implicit)
enddo

return
end subroutine adjust_dt_divs

!-----------------------------------------------------------------------

function linear_geopotential_3d(del_t, del_ln_p_half, del_ln_p_full, t, ln_p_half, ln_p_full) result (geopot)
!||zn, pjk 5/13/99, following vb's dmsm/implicit.f90. (0:,0:) -> (:,:)

complex, intent (in), dimension (:,:,:) :: del_t
complex, intent (in), dimension (:,:,:) :: del_ln_p_half
complex, intent (in), dimension (:,:,:) :: del_ln_p_full
real,    intent (in), dimension (:)       :: t
real,    intent (in), dimension (:)       :: ln_p_half
real,    intent (in), dimension (:)       :: ln_p_full

complex, dimension (size(del_t,1),size(del_t,2),size(del_t,3))   :: geopot
complex, dimension (size(del_t,1),size(del_t,2),size(del_t,3)+1) :: geopot_half

integer :: k

geopot_half(:,:,num_levels+1) = (0.,0.)

do k=num_levels,2,-1
  geopot_half(:,:,k) = geopot_half(:,:,k+1)                                &
    + rdgas*(del_t(:,:,k)*(ln_p_half(k+1)         - ln_p_half(k))    &
    +t(k)        *(del_ln_p_half(:,:,k+1) - del_ln_p_half(:,:,k)))
enddo

do k=1,num_levels
  geopot(:,:,k) = geopot_half(:,:,k+1)                                     &
    + rdgas*(del_t(:,:,k)*(ln_p_half(k+1)     - ln_p_full(k))        &
    +t(k)        *(del_ln_p_half(:,:,k+1) - del_ln_p_full(:,:,k)))
enddo

return
end function linear_geopotential_3d
!-----------------------------------------------------------------------

function linear_geopotential_1d(del_t,del_ln_p_half,del_ln_p_full, t, ln_p_half, ln_p_full) result (geopot)

real, intent (in), dimension (:) :: del_t
real, intent (in), dimension (:) :: del_ln_p_half
real, intent (in), dimension (:) :: del_ln_p_full
real, intent (in), dimension (:) :: t
real, intent (in), dimension (:) :: ln_p_half
real, intent (in), dimension (:) :: ln_p_full

real, dimension (size(del_t,1)) :: geopot

complex, dimension(0:0, 0:0, size(del_t,1)  ) :: del_t_3d, geopot_3d
complex, dimension(0:0, 0:0, size(del_t,1)+1) :: del_ln_p_half_3d
complex, dimension(0:0, 0:0, size(del_t,1)  ) :: del_ln_p_full_3d

del_t_3d(0,0,:)         = cmplx(del_t,         0.0)
del_ln_p_half_3d(0,0,:) = cmplx(del_ln_p_half, 0.0)
del_ln_p_full_3d(0,0,:) = cmplx(del_ln_p_full, 0.0)

geopot_3d = linear_geopotential(del_t_3d, del_ln_p_half_3d, del_ln_p_full_3d, t, ln_p_half, ln_p_full)

geopot = real(geopot_3d(0,0,:))

return
end function linear_geopotential_1d
!-----------------------------------------------------------------------

function pres_grad_funct(tg, ln_p_half, ln_p_full, p_surf) result(x)

real, intent (in), dimension (:) :: tg, ln_p_half, ln_p_full
real, intent (in)                :: p_surf
real, dimension (size(tg,1)) :: x

real :: dlog_1, dlog_2
integer :: k

if(trim(vert_difference_option) == 'simmons_and_burridge') then
  do k=1,size(ln_p_full,1)
    dlog_1 = ln_p_half(k+1) - ln_p_full(k)
    dlog_2 = ln_p_full(k)   - ln_p_half(k)
    x(k) = rdgas*tg(k) * (bk(k+1)*dlog_1 + bk(k)*dlog_2)/(dpk(k) + dbk(k)*p_surf)
  end do
else if(trim(vert_difference_option) == 'mcm') then
  do k=1,size(ln_p_full,1)
    x(k) = rdgas*tg(k)/p_surf
  end do
endif

return
end function pres_grad_funct
!-----------------------------------------------------------------------

subroutine linear_tp_tendency_3d (div, t_ref, p_surf_ref, ln_p_half_ref, ln_p_full_ref, dt_p_surf, dt_t)

complex, intent (in), dimension (0:,0:,:) :: div
real,    intent (in), dimension (:) :: t_ref, ln_p_half_ref, ln_p_full_ref
real,    intent (in)  :: p_surf_ref

complex, intent (out), dimension (0:,0:)   :: dt_p_surf
complex, intent (out), dimension (0:,0:,:) :: dt_t

real ::  dp, dp_inv, dlog_1, dlog_3, p_full_ref
complex , dimension(0:size(div,1)-1,0:size(div,2)-1) :: dmean, dmean_tot
complex , dimension(0:size(div,1)-1,0:size(div,2)-1,size(div,3)+1) :: vert_vel, temp

real :: kappa
integer :: k

kappa = rdgas/cp_air

dmean_tot = 0.0

if(vert_difference_option == 'simmons_and_burridge') then

  do k=1,num_levels
    dp = dpk(k) + dbk(k)*p_surf_ref
    dp_inv = 1/dp
    dlog_1 = ln_p_half_ref(k+1) - ln_p_full_ref(k)
    dlog_3 = ln_p_half_ref(k+1) - ln_p_half_ref(k)
    dmean = div(:,:,k)*dp
    dt_t(:,:,k) =  - kappa*t_ref(k)*(dmean_tot*dlog_3 + dmean*dlog_1)*dp_inv
    dmean_tot = dmean_tot + dmean
    vert_vel(:,:,k+1) = - dmean_tot
  enddo

else if (vert_difference_option == 'mcm') then

  do k=1,num_levels
    dp = dpk(k) + dbk(k)*p_surf_ref
    dmean = div(:,:,k)*dp
    p_full_ref = 0.5*(pk(k+1) + pk(k)) + 0.5*(bk(k+1) + bk(k))*p_surf_ref
    dt_t(:,:,k) = - (kappa*t_ref(k)/p_full_ref)*(dmean_tot + 0.5*dmean)
    dmean_tot = dmean_tot + dmean
    vert_vel(:,:,k+1) = - dmean_tot
  enddo

endif

dt_p_surf = - dmean_tot

do k=2,num_levels
  vert_vel(:,:,k) = vert_vel(:,:,k) + dmean_tot*bk(k)
enddo

do k=2,num_levels
  temp(:,:,k) = - vert_vel(:,:,k)*(t_ref(k) - t_ref(k-1))
enddo

temp(:,:,1)            = 0.0
temp(:,:,num_levels+1) = 0.0

do k=1,num_levels
  dp = dpk(k) + dbk(k)*p_surf_ref
  dp_inv = 1/dp
  dt_t(:,:,k) = dt_t(:,:,k) + .5*dp_inv*(temp(:,:,k+1)+temp(:,:,k))
enddo

return
end subroutine linear_tp_tendency_3d
!-----------------------------------------------------------------------

subroutine linear_tp_tendency_1d(div, t_ref, p_surf_ref, ln_p_half_ref, ln_p_full_ref, dt_p_surf, dt_t)

real, intent(in), dimension (:) :: div
real, intent(in), dimension (:) :: t_ref, ln_p_half_ref, ln_p_full_ref
real, intent(in)  :: p_surf_ref

real, intent(out) :: dt_p_surf
real, intent(out), dimension (:) :: dt_t

complex, dimension(0:0,0:0,size(div,1)) :: div_3d, dt_t_3d
complex, dimension(0:0,0:0)           :: dt_p_surf_3d

div_3d(0,0,:) = cmplx(div,0.)

call linear_tp_tendency(div_3d, t_ref, p_surf_ref, ln_p_half_ref, ln_p_full_ref, dt_p_surf_3d, dt_t_3d)

dt_t      = real(dt_t_3d(0,0,:))
dt_p_surf = real(dt_p_surf_3d(0,0))

return
end subroutine linear_tp_tendency_1d
!-----------------------------------------------------------------------
subroutine implicit_end

if(.not.module_is_initialized) return

deallocate(ref_temperature_implicit)
deallocate(ref_ln_p_half, ref_ln_p_full, del_ln_p_half, del_ln_p_full)
deallocate(div_mat, wave_matrix, h, eigen, wavenumber, pk,  bk, dpk, dbk)
module_is_initialized = .false.

return
end subroutine implicit_end
!-----------------------------------------------------------------------

end module implicit_mod

#undef DEBUG_PIK_DIAG

module ocean_pik_diag_mod
  !  
  !<CONTACT EMAIL="Stefan.Petri@pik-potsdam"> Stefan Petri
  !</CONTACT>
  !
  !<OVERVIEW>
  ! Meridional Overturning and related diagnostics. 
  !</OVERVIEW>
  !
  !<DESCRIPTION>
  ! Meridional Overturning and related diagnostics.
  ! This module computes the meridional overturning stream function for the
  ! mass transport, and sends it as vertical 2-dimensional variable
  ! to the diagnostics manager.
  ! This apporach saves signifcant disk space compared to
  ! saving the 3-D variables and calculating the overturning functions in a
  ! postprocessing / visualization step.
  !
  ! Also, this module can calculate overturning according to ocean basins.
  ! Currently that is implemented for the atlantic and the pacific basin.
  ! The selection of basin cells is based on the file INPUT/basin_mask.
  !  The basin-mask convention used at GFDL has 
  !  Southern=1.0,Atlantic=2.0,Pacific=3.0,Arctic=4.0,Indian=5.0
  !
  !
  ! First, the vertical integral for the Eulerian part is defined over
  ! the range from -H (bottom) to the level Z. However, FERRET can not
  ! deal with a vertically upward integration. Therefore, the vertical
  ! integral is splitted in the integral over the whole water column
  ! minus the integral from the surface down to the level k:
  ! -1.*val_atl[i=@sum,k=@sum] + val_atl[i=@sum,k=@rsum]. This part of
  ! the calculation is correct. Second, in the GM part, there is no
  ! need for a numerical integration over Z, because it is already
  ! done analytically. We have only to perform the zonal integral:
  ! val_atl_gm[i=@sum].
  ! The corresponding post-processing script in ferret looks like this:
  !
  ! let atl_mask if basin_mask[D=2] EQ 2 then 1.0 else 0.0
  !
  ! let val_atl    = ty_trans[D=1]*atl_mask
  ! let val_atl_gm = ty_trans_gm[D=1]*atl_mask
  !
  ! let psi_atl=-1.*val_atl[i=@sum,k=@sum]+val_atl[i=@sum,k=@rsum]+val_atl_gm[i=@sum]
  !
  ! Unfortunately, the values for ty_trans and ty_trans_gm are calculated
  ! in very different modules of mom4, and at different times in the ocean
  ! model main loop.
  !
  !   subroutine update_ocean_model()
  !     [..]
  !     call neutral_physics()
  !         call neutral_physicsX() -> ty_trans_gm ! X = A,B,C
  !     [..]
  !     call update_ocean_tracer() -> tracer overturning diag with basin masks
  !     [..]
  !     call ocean_diagnostics()
  !        call ocean_adv_vel_diagnostics()
  !           call transport_on_s() -> ty_trans
  !     [..]
  !   end subroutine
  !
  ! To avoid copying of 3D arrays, this module stores pointers to
  ! the arrays which are allocated in their respective modules.
  ! This module provides an init subroutine to be called from each of the data-contributing 
  ! modules, so that the pointers can be initialised.
  !
  !
  ! Sigh. The ty_trans is calculated in ocean_adv_vel_diag_mod::transport_on_s()
  ! _only_ if the corresponding diagnostic output is enabled in the diag_table.
  ! _And_ it is stored in a temporary field only.
  ! Thus, we copy that ty_trans calculation into here also.
  !
  ! Sigh Deeply. ty_trans_gm is calculated only if neutral_physicsB or neutral_physicsC is
  ! enabled in file input.nml , sections &ocean_nphysics_nml and &ocean_nphysicsB_nml resp.
  ! ocean_nphysicsC_nml .
  !
  !</DESCRIPTION>
  !
  !<NAMELIST NAME="ocean_pik_diag_nml">
  !  <DATA NAME="do_pik_diag" TYPE="logical">
  !  Do Meridional Overturning Circulation diagnostics.
  !  </DATA> 
  !</NAMELIST>
  !
  use constants_mod,       only: epsln
  use diag_manager_mod,    only: register_diag_field, send_data, need_data
  use fms_mod,             only: open_namelist_file, check_nml_error, close_file, write_version_number
  use fms_mod,             only: FATAL, stdout, stdlog
  use fms_mod,             only: read_data
  use mpp_mod,             only: mpp_error, mpp_max, mpp_pe
  use mpp_mod,             only: mpp_clock_id, mpp_clock_begin, mpp_clock_end, CLOCK_ROUTINE
  use mpp_domains_mod,     only: mpp_global_field, XUPDATE
  use time_manager_mod,    only: time_type, increment_time
  
  use ocean_domains_mod,    only: get_local_indices
  use ocean_parameters_mod, only: missing_value, rho0r 
  use ocean_types_mod,      only: ocean_domain_type, ocean_grid_type
  use ocean_types_mod,      only: ocean_adv_vel_type, ocean_density_type
  use ocean_types_mod,      only: ocean_prog_tracer_type, ocean_thickness_type
  use ocean_types_mod,      only: ocean_time_type, ocean_time_steps_type
  use ocean_workspace_mod,  only: wrk1 ! , wrk2, wrk1_2d
  
  implicit none
  
  private

  public ocean_pik_diag_init
  public ocean_pik_diag_init_ty_trans_gm
  public ocean_pik_diagnostics 
  public do_pik_diag

#include <ocean_memory.h>

  ! for diagnostics clocks - done by the calling module
  !integer :: id_pik_diag_clock
  
  ! for diag manager
  integer :: id_pik_diag_gmoc  = -1
  integer :: id_pik_diag_amoc  = -1
  integer :: id_pik_diag_pmoc  = -1
#ifdef DEBUG_PIK_DIAG
  ! diags for debugging
  integer :: id_pik_ty_trans = -1
  integer :: id_pik_ty_trans_globalfield = -1
  integer :: id_pik_ty_trans_atl = -1
  integer :: id_pik_ty_trans_atl_sum = -1
  integer :: id_pik_ty_trans_atl_rsum = -1
  integer :: id_pik_ty_trans_atl_upwardrsum = -1
  integer :: id_pik_ty_trans_pac = -1
  integer :: id_pik_ty_trans_pac_sum = -1
  integer :: id_pik_ty_trans_pac_rsum = -1
  integer :: id_pik_ty_trans_pac_upwardrsum = -1
  integer :: id_pik_ty_trans_gm = -1
  integer :: id_pik_ty_trans_gm_globalfield = -1
  integer :: id_pik_ty_trans_gm_atl = -1
  integer :: id_pik_ty_trans_gm_atl_sum = -1
  integer :: id_pik_ty_trans_gm_atl_sum_ijk = -1
  integer :: id_pik_diag_amoc_upward  = -1
  integer :: id_pik_diag_pmoc_upward  = -1
#endif
  
  ! for specifying transport units
  ! can either be Sv or mks
  character(len=32) :: transport_dims ='Sv (10^9 kg/s)' 
  real              :: transport_convert=1.0e-9 
  
  type(ocean_grid_type), pointer   :: Grd =>NULL()
  type(ocean_domain_type), pointer :: Dom =>NULL()
  
  
#ifdef MOM_STATIC_ARRAYS
  real, dimension(jsc:jec,nk)  :: psi
  real, dimension(isc:iec,jsc:jec)  :: basin_mask
  real, dimension(ni, jsc:jec) :: global_basin_mask
  real, dimension(ni, jsc:jec, nk) :: global_tmask
  !real, dimension(ni, jsc:jec, nk) :: global_ty_trans
  !real, dimension(ni, jsc:jec, nk) :: global_ty_trans_gm
#else
  real, dimension(:,:),   allocatable :: psi
  real, dimension(:,:),   allocatable :: basin_mask
  real, dimension(:,:),   allocatable :: global_basin_mask
  real, dimension(:,:,:), allocatable :: global_tmask
  !real, dimension(:,:,:), allocatable :: global_ty_trans
  !real, dimension(:,:,:), allocatable :: global_ty_trans_gm
#endif


  ! Here we store pointers to the data arrays that are allocated in other modules.
  ! At init time, the pointer is assigned.
  real, dimension(:,:,:), pointer :: ty_trans_gm =>NULL();

  logical :: module_is_initialized = .FALSE.
  
  character(len=128) :: version=&
       '$Id: ocean_pik_diag.F90 $'
  character (len=128) :: tagname = &
       '$Name: mom5_siena_08jun2012_smg $'
  
  ! sigh. we need this in other modules to ensure that the required
  ! calculations are actually done.
  ! Notably ocean_nphysicsX_mod::fz_terms()
  logical :: do_pik_diag   = .false.
  
  namelist /ocean_pik_diag_nml/ &
       do_pik_diag


contains

  !#######################################################################
  ! <SUBROUTINE NAME="ocean_pik_diag_init">
  !
  ! <DESCRIPTION>
  ! Initialize the ocean_pik_diag module
  ! </DESCRIPTION>
  !
  subroutine ocean_pik_diag_init(Grid, Domain, Time)
    
    type(ocean_grid_type),    target, intent(in) :: Grid
    type(ocean_domain_type),  target, intent(in) :: Domain
    type(ocean_time_type),            intent(in) :: Time
    
    integer :: ioun, io_status, ierr
    integer :: stdoutunit,stdlogunit 
    stdoutunit=stdout();stdlogunit=stdlog() 
    
    if (module_is_initialized) return
    
    module_is_initialized = .TRUE.
    
    call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_pik_diag_nml, iostat=io_status
    ierr = check_nml_error(io_status,'ocean_pik_diag_nml')
#else
    ioun = open_namelist_file()
    read(ioun, ocean_pik_diag_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_pik_diag_nml')
    call close_file(ioun)
#endif
    write (stdlogunit, ocean_pik_diag_nml)
    write (stdoutunit,'(/)')
    write (stdoutunit, ocean_pik_diag_nml)

    if (.not. do_pik_diag) return

    Dom => Domain
    Grd => Grid
    
#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
    nk = Grid%nk
    ni = Grid%ni
    allocate (psi(jsc:jec,nk))
    allocate (basin_mask(isc:iec,jsc:jec))
    allocate (global_basin_mask(Grd%ni,jsc:jec))
    allocate (global_tmask(Grid%ni, jsc:jec, nk))
    !allocate (global_ty_trans(Grid%ni, jsc:jec, nk))
    !allocate (global_ty_trans_gm(Grid%ni, jsc:jec, nk))
#endif
    
    !  For reading in a mask that selects regions of the domain 
    !  for performing gyre and overturning diagnostics. 
    !  The basin-mask convention used at GFDL has 
    !  Southern=1.0,Atlantic=2.0,Pacific=3.0,Arctic=4.0,Indian=5.0
    call read_data('INPUT/basin_mask','basin_mask',basin_mask,Domain%domain2d)
    call mpp_global_field(Dom%domain2d, basin_mask, global_basin_mask, flags=XUPDATE)
    ! for masking-out non-ocean cells
    call mpp_global_field(Dom%domain2d, Grd%tmask, global_tmask, flags=XUPDATE)

    ! register fields for diagnostic output
    ! TODO: check the axis definition - DONE: seems OK
    id_pik_diag_gmoc = register_diag_field ('ocean_model','pik_gmoc',              &
         Grid%tracer_axes_flux_y(2:3),                                             &
         Time%model_time, 'T-cell j-mass transport global',trim(transport_dims),   &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='global_ocean_meridional_overturning_mass_streamfunction')
    id_pik_diag_amoc = register_diag_field ('ocean_model','pik_amoc',              &
         Grid%tracer_axes_flux_y(2:3),                                             &
         Time%model_time, 'T-cell j-mass transport atlantic',trim(transport_dims), &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='atlantic_ocean_meridional_overturning_mass_streamfunction')
    id_pik_diag_pmoc = register_diag_field ('ocean_model','pik_pmoc',              &
         Grid%tracer_axes_flux_y(2:3),                                             &
         Time%model_time, 'T-cell j-mass transport pacific',trim(transport_dims), &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pacific_ocean_meridional_overturning_mass_streamfunction')

#ifdef DEBUG_PIK_DIAG
    write (*,*) 'pe', mpp_pe(), ': isc ',isc,' iec ',iec
    id_pik_ty_trans = register_diag_field ('ocean_model','pik_ty_trans',   &
         Grid%tracer_axes_flux_y(1:3),                                             &
         Time%model_time, 'pik version should be identical to ty_trans', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans')
    id_pik_ty_trans_globalfield = register_diag_field ('ocean_model','pik_ty_trans_globalfield',   &
         Grid%tracer_axes_flux_y(1:3),                                             &
         Time%model_time, 'pik global field version should be identical to pik_ty_trans', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans_globalfield')

    id_pik_ty_trans_atl = register_diag_field ('ocean_model','pik_ty_trans_atl',   &
         Grid%tracer_axes_flux_y(1:3),                                             &
         Time%model_time, 'pik_ty_trans*atl_mask', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans_atl')
    id_pik_ty_trans_atl_sum = register_diag_field ('ocean_model','pik_ty_trans_atl_sum',   &
         Grid%tracer_axes_flux_y(2:2), & ! must be 1-D array of length 1, not scalar
         Time%model_time, 'pik_ty_trans_atl[i=@sum,k=@sum]', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans_atl_sum')
    id_pik_ty_trans_atl_rsum = register_diag_field ('ocean_model','pik_ty_trans_atl_rsum',   &
         Grid%tracer_axes_flux_y(2:3),                                             &
         Time%model_time, 'pik_ty_trans_atl[i=@sum,k=@rsum]', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans_atl_rsum')
    id_pik_ty_trans_atl_upwardrsum = register_diag_field ('ocean_model','pik_ty_trans_atl_upwardrsum',   &
         Grid%tracer_axes_flux_y(2:3),                                             &
         Time%model_time, 'pik_ty_trans_atl[i=@sum,k=@upwardrsum]', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans_atl_upwardrsum')

    id_pik_ty_trans_pac = register_diag_field ('ocean_model','pik_ty_trans_pac',   &
         Grid%tracer_axes_flux_y(1:3),                                             &
         Time%model_time, 'pik_ty_trans*pac_mask', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans_pac')
    id_pik_ty_trans_pac_sum = register_diag_field ('ocean_model','pik_ty_trans_pac_sum',   &
         Grid%tracer_axes_flux_y(2:2), & ! must be 1-D array of length 1, not scalar
         Time%model_time, 'pik_ty_trans_pac[i=@sum,k=@sum]', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans_pac_sum')
    id_pik_ty_trans_pac_rsum = register_diag_field ('ocean_model','pik_ty_trans_pac_rsum',   &
         Grid%tracer_axes_flux_y(2:3),                                             &
         Time%model_time, 'pik_ty_trans_pac[i=@sum,k=@rsum]', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans_pac_rsum')
    id_pik_ty_trans_pac_upwardrsum = register_diag_field ('ocean_model','pik_ty_trans_pac_upwardrsum',   &
         Grid%tracer_axes_flux_y(2:3),                                             &
         Time%model_time, 'pik_ty_trans_pac[i=@sum,k=@upwardrsum]', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans_pac_upwardrsum')

    id_pik_ty_trans_gm = register_diag_field ('ocean_model','pik_ty_trans_gm',   &
         Grid%tracer_axes_flux_y(1:3),                                             &
         Time%model_time, 'pik version should be identical to ty_trans_gm', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans_gm')
    id_pik_ty_trans_gm_globalfield = register_diag_field ('ocean_model','pik_ty_trans_gm_globalfield',   &
         Grid%tracer_axes_flux_y(1:3),                                             &
         Time%model_time, 'pik global field version should be identical to pik_ty_trans_gm', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans_gm_globalfield')
    id_pik_ty_trans_gm_atl = register_diag_field ('ocean_model','pik_ty_trans_gm_atl',   &
         Grid%tracer_axes_flux_y(1:3),                                             &
         Time%model_time, 'ty_trans_gm*atl_mask', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans_gm_atl')
    id_pik_ty_trans_gm_atl_sum = register_diag_field ('ocean_model','pik_ty_trans_gm_atl_sum',   &
         Grid%tracer_axes_flux_y(2:3),                                             &
         Time%model_time, 'pik_ty_trans_gm_atl[i=@sum] via sum()', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans_gm_atl_sum')
    id_pik_ty_trans_gm_atl_sum_ijk = register_diag_field ('ocean_model','pik_ty_trans_gm_atl_sum_ijk',   &
         Grid%tracer_axes_flux_y(2:3),                                             &
         Time%model_time, 'pik_ty_trans_gm_atl[i=@sum] via loops', trim(transport_dims),                &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pik_ty_trans_gm_atl_sum_ijk')

    id_pik_diag_amoc_upward = register_diag_field ('ocean_model','pik_amoc_upward',              &
         Grid%tracer_axes_flux_y(2:3),                                             &
         Time%model_time, 'T-cell j-mass transport atlantic calculated direct upward',trim(transport_dims), &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='atlantic_ocean_meridional_overturning_mass_streamfunction_upward')

    id_pik_diag_pmoc_upward = register_diag_field ('ocean_model','pik_pmoc_upward',              &
         Grid%tracer_axes_flux_y(2:3),                                             &
         Time%model_time, 'T-cell j-mass transport pacific calculated direct upward',trim(transport_dims), &
         missing_value=missing_value, range=(/-1e9,1e9/),                          &
         standard_name='pacific_ocean_meridional_overturning_mass_streamfunction_upward')
#endif
   
    ! set ids for clocks - done by the calling module
    !id_pik_diag_clock     = mpp_clock_id('(Ocean pik_diag)'    ,grain=CLOCK_ROUTINE)
    
  end subroutine ocean_pik_diag_init
  ! </SUBROUTINE>



  !#######################################################################
  ! <SUBROUTINE NAME="ocean_pik_diag_init_ty_trans_gm">
  !
  ! <DESCRIPTION>
  ! Initialize the pointer to ty_trans_gm
  ! </DESCRIPTION>
  !
  subroutine ocean_pik_diag_init_ty_trans_gm(ty_trans_gm_in)
    real, dimension(:,:,:), target, intent(in) :: ty_trans_gm_in
    !if (.not. do_pik_diag) return
    if (ASSOCIATED(ty_trans_gm)) then
       call mpp_error(FATAL, &
            '==>Error from ocean_pik_diag.F90::ocean_pik_diag_init_ty_trans_gm : ty_trans_gm already assigned')
    endif
    ty_trans_gm => ty_trans_gm_in
  end subroutine ocean_pik_diag_init_ty_trans_gm
  ! </SUBROUTINE>
  

  !#######################################################################
  ! <SUBROUTINE NAME="calc_psi">
  !
  ! <DESCRIPTION>
  ! First, the vertical integral for the Eulerian part is defined over
  ! the range from -H (bottom) to the level Z. However, FERRET can not
  ! deal with a vertically upward integration. Therefore, the vertical
  ! integral is splitted in the integral over the whole water column
  ! minus the integral from the surface down to the level k:
  ! -1.*val_atl[i=@sum,k=@sum] + val_atl[i=@sum,k=@rsum]. This part of
  ! the calculation is correct. Second, in the GM part, there is no
  ! need for a numerical integration over Z, because it is already
  ! done analytically. We have only to perform the zonal integral:
  ! val_atl_gm[i=@sum].
  !
  !  let psi = -1.*ty_trans[i=@sum,k=@sum] + ty_trans[i=@sum,k=@rsum] + ty_trans_gm[i=@sum] 
  ! </DESCRIPTION>
  subroutine calc_psi(global_ty_trans, global_ty_trans_gm, &
#ifdef DEBUG_PIK_DIAG
       Time, &
#endif
       psi)
    real, dimension(ni,jsc:jec,nk), intent(in) :: global_ty_trans, global_ty_trans_gm
#ifdef DEBUG_PIK_DIAG
    type(ocean_time_type),        intent(in) :: Time    
#endif
    real, dimension(jsc:jec,nk), intent(out) :: psi

    integer ::  i, j, k

    ! for the following three arrays, the j-dimension is needed only for
    ! code readability and debugging output...
    real, dimension(jsc:jec) :: ty_trans_sum          ! ty_trans[i=@sum,k=@sum]
    real, dimension(jsc:jec,0:nk):: ty_trans_rsum   ! ty_trans[i=@sum,k=@rsum]
    real, dimension(jsc:jec,nk) :: ty_trans_gm_sum    ! ty_trans_gm[i=@sum]
#ifdef DEBUG_PIK_DIAG
    logical :: used
#endif

    ty_trans_rsum = 0.0
    ty_trans_sum = 0.0
    ty_trans_gm_sum(:,:) = sum(global_ty_trans_gm,1) ! sum over 1st dimension
    do j=jsc,jec
       do k=1,nk
          do i=1,ni
             ty_trans_sum(j) = ty_trans_sum(j) + global_ty_trans(i,j,k)
             ty_trans_rsum(j,k) = ty_trans_rsum(j,k) + global_ty_trans(i,j,k)
             !ty_trans_gm_sum(j,k) = ty_trans_gm_sum(j,k) + global_ty_trans_gm(i,j,k)
          end do
          ty_trans_rsum(j,k) = ty_trans_rsum(j,k) + ty_trans_rsum(j,k-1)
       end do
       do k=1,nk
          psi(j,k) = - ty_trans_sum(j) + ty_trans_rsum(j,k) + ty_trans_gm_sum(j,k)
       end do
    end do

#ifdef DEBUG_PIK_DIAG
    used = send_data(id_pik_ty_trans_atl_sum, ty_trans_sum, Time%model_time)
    used = send_data(id_pik_ty_trans_gm_atl_sum, ty_trans_gm_sum, Time%model_time)
    used = send_data(id_pik_ty_trans_atl_rsum, ty_trans_rsum(:,1:nk), Time%model_time)

    ! ferret does the rsum top-to-bottom, thus we need to calculate and subtract
    ! the 2-D-sum term ty_trans[i=@sum,k=@sum] . That is mimiced above.
    ! Here we try to do the bottom-to-top running sum, negated, and avoid the additional 2-D-sum.
    ! One major problem seems to the influence of missing-values.
    ! Ferret obeyes those, apparently missing+x = missing.
    ! That makes top-to-bottom rsum non-commutative with bottom-to-top revers-rsum,
    ! because the missing-values propagate along the summing direction.
    ! And there are more missing values near the bottom of the ocean, than at top.
    ! sigh.
    ty_trans_rsum = 0.0
    do j=jsc,jec
       do k=nk-1,1,-1
          do i=1,ni
             ty_trans_rsum(j,k) = ty_trans_rsum(j,k) - global_ty_trans(i,j,k+1)
          end do
          ty_trans_rsum(j,k) = ty_trans_rsum(j,k) - ty_trans_rsum(j,k+1)
       end do
    end do
    ty_trans_gm_sum(:,:) = sum(global_ty_trans_gm,1) ! sum over 1st dimension 
    !psi = ty_trans_rsum(:,1:nk) + ty_trans_gm_sum

    used = send_data(id_pik_ty_trans_atl_upwardrsum, ty_trans_rsum(:,1:nk), Time%model_time)
    !used = send_data(id_pik_ty_trans_gm_atl_sum_ijk, ty_trans_gm_sum, Time%model_time)
    used = send_data(id_pik_diag_amoc_upward, ty_trans_rsum(:,1:nk) + ty_trans_gm_sum, Time%model_time)
#endif
  end subroutine calc_psi
  ! </SUBROUTINE>


  !#######################################################################
  ! <SUBROUTINE NAME="diag_basin">
  !
  ! <DESCRIPTION>
  ! calculate and send to diag_manager the overturning diagnostics for one ocean basin
  ! </DESCRIPTION
  subroutine diag_basin(Time, basinnr, id_pik_diag_basin, &
#ifdef DEBUG_PIK_DIAG
       id_pik_ty_trans_basin, id_pik_ty_trans_gm_basin, &
#endif
       global_ty_trans, global_ty_trans_gm)
    type(ocean_time_type),            intent(in) :: Time
    real,                             intent(in) :: basinnr
    integer,                          intent(in) :: id_pik_diag_basin
#ifdef DEBUG_PIK_DIAG
    integer,                          intent(in) :: id_pik_ty_trans_basin, id_pik_ty_trans_gm_basin
#endif
    real, dimension(ni, jsc:jec, nk), intent(in) :: global_ty_trans, global_ty_trans_gm

    integer :: i, j
    logical :: used
    real, dimension(ni, jsc:jec, nk) :: basin_ty_trans, basin_ty_trans_gm

    if (id_pik_diag_basin <= 0) return
    
    basin_ty_trans = global_ty_trans
    basin_ty_trans_gm = global_ty_trans_gm
    do j=jsc,jec
       do i=1,ni
          if (global_basin_mask(i,j) .ne. basinnr) then
             basin_ty_trans(i,j,:) = 0.0
             basin_ty_trans_gm(i,j,:) = 0.0
          end if
       end do
    end do
#ifdef DEBUG_PIK_DIAG
    if (id_pik_ty_trans_basin > 0) &
         used = send_data (id_pik_ty_trans_basin, basin_ty_trans(isc:iec,:,:),     &
         Time%model_time, rmask=global_tmask(isc:iec,:,:))
    if (id_pik_ty_trans_gm_basin > 0) &
         used = send_data (id_pik_ty_trans_gm_basin, basin_ty_trans_gm(isc:iec,:,:), &
         Time%model_time, rmask=global_tmask(isc:iec,:,:))
#endif
    call calc_psi(basin_ty_trans, basin_ty_trans_gm, &
#ifdef DEBUG_PIK_DIAG
         Time, &
#endif
         psi)
    used = send_data(id_pik_diag_basin, psi(:,:), Time%model_time) !, is_in=jsc, js_in=1, ie_in=jec, je_in=nk)
  end subroutine diag_basin
  ! </SUBROUTINE>
  

  !#######################################################################
  ! <SUBROUTINE NAME="ocean_pik_diagnostics">
  !
  ! <DESCRIPTION>
  ! Call PIK diagnostics 
  ! </DESCRIPTION>
  subroutine ocean_pik_diagnostics(Time, Adv_vel)
    type(ocean_time_type),        intent(in) :: Time
    type(ocean_adv_vel_type),     intent(in) :: Adv_vel

    integer :: i, j, k
    logical :: used

    ! make these arrays local, for global, atlantic basin, pacific basin
    real, dimension(ni, jsc:jec, nk) :: global_ty_trans
    real, dimension(ni, jsc:jec, nk) :: global_ty_trans_gm


    if (.not. do_pik_diag) return
    if (-1 == id_pik_diag_amoc .and. -1 == id_pik_diag_gmoc .and. -1 == id_pik_diag_pmoc) return

    !call mpp_clock_begin(id_pik_diag_clock)

    if (.not. module_is_initialized) then 
       call mpp_error(FATAL, &
            '==>Error from ocean_pik_diag.F90::ocean_pik_diag_init_ty_trans_gm : needs initialization')
    endif
    if (.not. ASSOCIATED(ty_trans_gm)) then
       write (stdout(),*) 'Error: ocean_pik_diag.F90::ocean_pik_diagnostics : ty_trans_gm not assigned.', &
            ' Check that neutral_physicsB or neutral_physicsC is enabled in file input.nml ,', &
            ' sections &ocean_nphysics_nml and &ocean_nphysicsB_nml resp. ocean_nphysicsC_nml'
       call mpp_error(FATAL, &
            '==>Error from ocean_pik_diag.F90::ocean_pik_diagnostics : ty_trans_gm not assigned')
    endif

    ! calculation of ty_trans
    ! copied from ocean_adv_vel_diag.F90 :: transport_on_s()
    ! but here mask out non-ocean cells with Grd%tmask
    do k=1,nk
       do j=jsc,jec
          do i=isc,iec
             wrk1(i,j,k) = Adv_vel%vhrho_nt(i,j,k)*Grd%dxtn(i,j)*transport_convert*Grd%tmask(i,j,k)
          enddo
       enddo
    enddo
#ifdef DEBUG_PIK_DIAG
    if (id_pik_ty_trans > 0) &
         used = send_data (id_pik_ty_trans, wrk1(:,:,:), &
         Time%model_time, rmask=Grd%tmask(:,:,:), &
         is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
    if (id_pik_ty_trans_gm > 0) &
         used = send_data (id_pik_ty_trans_gm, ty_trans_gm(:,:,:), &
         Time%model_time, rmask=Grd%tmask(:,:,:), &
         is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
#endif

    ! Sigh. I think we really need this on the root PE only, but here all PEs get it.
    ! On the other hand, mppnccombine seems to work fine, maybe even requires,
    ! with having redundant slices in x direction.
    call mpp_global_field(Dom%domain2d, wrk1,        global_ty_trans,    flags=XUPDATE) 
    call mpp_global_field(Dom%domain2d, ty_trans_gm, global_ty_trans_gm, flags=XUPDATE)

    ! mask out any non-ocean cells. Dont do that on the local ty_trans_gm,
    ! because that is only ``borrowed'' via pointer association from neutral physics module
    where (global_tmask .eq. 0.0) global_ty_trans_gm = 0.0

#ifdef DEBUG_PIK_DIAG
    if (id_pik_ty_trans_globalfield > 0) &
         used = send_data (id_pik_ty_trans_globalfield, global_ty_trans(isc:iec,:,:), &
         Time%model_time, rmask=global_tmask(isc:iec,:,:))
    if (id_pik_ty_trans_gm_globalfield > 0) &
         used = send_data (id_pik_ty_trans_gm_globalfield, global_ty_trans_gm(isc:iec,:,:), &
         Time%model_time, rmask=global_tmask(isc:iec,:,:))
#else
    ! for debugging, call calc_psi() only once, for atlantic basin
    ! global overturning
    if (id_pik_diag_gmoc > 0) then
       call calc_psi(global_ty_trans, global_ty_trans_gm, psi)
       used = send_data(id_pik_diag_gmoc, psi(:,:), Time%model_time) !, is_in=jsc, js_in=1, ie_in=jec, je_in=nk)
    end if
#endif

    ! atlantic overturning
    call diag_basin(Time, 2.0, id_pik_diag_amoc, &
#ifdef DEBUG_PIK_DIAG
         id_pik_ty_trans_atl, id_pik_ty_trans_gm_atl, &
#endif
         global_ty_trans, global_ty_trans_gm)
!    if (id_pik_diag_amoc > 0) then
!       amoc_ty_trans = global_ty_trans
!       amoc_ty_trans_gm = global_ty_trans_gm
!       do j=jsc,jec
!          do i=1,ni
!             if (global_basin_mask(i,j) .ne. 2.0) then
!                amoc_ty_trans(i,j,:) = 0.0
!                amoc_ty_trans_gm(i,j,:) = 0.0
!             end if
!          end do
!       end do
!#ifdef DEBUG_PIK_DIAG
!       if (id_pik_ty_trans_atl > 0) &
!            used = send_data (id_pik_ty_trans_atl, amoc_ty_trans(isc:iec,:,:),     &
!            Time%model_time, rmask=global_tmask(isc:iec,:,:))
!       if (id_pik_ty_trans_gm_atl > 0) &
!            used = send_data (id_pik_ty_trans_gm_atl, amoc_ty_trans_gm(isc:iec,:,:), &
!            Time%model_time, rmask=global_tmask(isc:iec,:,:))
!#endif
!       call calc_psi(amoc_ty_trans, amoc_ty_trans_gm, &
!#ifdef DEBUG_PIK_DIAG
!            Time, &
!#endif
!            psi)
!       used = send_data(id_pik_diag_amoc, psi(:,:), Time%model_time) !, is_in=jsc, js_in=1, ie_in=jec, je_in=nk)
!    end if ! id_pik_diag_amoc > 0

    ! pacific overturning
    call diag_basin(Time, 3.0, id_pik_diag_pmoc, &
#ifdef DEBUG_PIK_DIAG
         id_pik_ty_trans_pac, id_pik_ty_trans_gm_pac, &
#endif
         global_ty_trans, global_ty_trans_gm)

    !call mpp_clock_end(id_pik_diag_clock)
  end subroutine ocean_pik_diagnostics
  ! </SUBROUTINE>

end module ocean_pik_diag_mod

#ifndef USE_LIMA
  subroutine init_dry_atm(mountain, kappa, grav, rg)
  use fv_pack,      only: nlon, mlat, beglat, endlat,  &
                          ak, bk, ptop,      &
                          ng_d, ng_s,  &         
                          full_phys,   &
                          d2a3d, p_var, coslon, sinlon, ighost,     &
                          cosp, sinp, cose, sine, dry_mass,  master
#ifdef MARS_GCM
    use fv_pack,   only: p_ref
#endif MARS_GCM


  use fms_mod,      only: file_exist,  error_mesg,  FATAL

#ifdef SPMD
   use mod_comm, only: mp_scatter3d
#endif
   use mpp_io_mod, only: mpp_open, mpp_close
   use mpp_io_mod, only: MPP_RDONLY, MPP_MULTI, MPP_SINGLE, MPP_NATIVE
   use fv_arrays_mod, only: fv_stack_push, fv_array_sync

!  implicit none
#include "fv_arrays.h"

  logical,  intent(in):: mountain
  real, intent(in):: kappa
  real, intent(in):: grav
  real, intent(in):: rg

  integer i,j,k,m
  integer im, jm, km
  real gmean, ftop 
  real:: slp0 = 1.E5

#include "fv_point.inc"

#ifdef POLVANI
 
! This is Lorenzo Polvani's idealized test case
 
  real, allocatable:: u_g(:,:,:), pt_g(:,:,:)
  integer :: unit

!$omp parallel do private (i, j)
  do j=jsp,jep
     do i=1,nlon
        ps(i,j) = slp0
     enddo
  enddo
  call fv_array_sync()

!$omp parallel do private (i, j, k, m)
  do k=ksp,kep
      do j=beglat,endlat
         do i=1,nlon
            v(i,j,k) = 0.
            delp(i,j,k) = ak(k+1) - ak(k) + ps(i,j) * (bk(k+1) - bk(k))
         enddo
      enddo
   enddo
   call fv_array_sync()

!Balaji: should not use unit "61"... convert to use mpp_open
   call mpp_open( unit, action=MPP_RDONLY, form=MPP_NATIVE, threading=MPP_MULTI )
   read(unit) im, jm, km
   write(*,*) im, jm, km
   if( im /= nlon .or. jm /= mlat .or. km /= nlev ) then
       call error_mesg('init_dry_atm','Dimension inconsistent', FATAL)
   endif
   allocate (  u_g(im,jm,km) )
   allocate ( pt_g(im,jm,km) )
   read(unit) u_g
   read(unit) pt_g
   call mpp_close(unit)
   do k = ksp,kep
      do j = jsd,jed
         do i =1,nlon
            u(i,j,k) = u_g(i,j,k)
            pt(i,j,k) = pt_g(i,j,k)
         end do
      end do
   end do
   call fv_array_sync
   deallocate (  u_g )
   deallocate ( pt_g )
   
! Read (u,PT) data from Palvani
!      if ( master ) then
!           if ( mlat == 91 ) then
!               open(unit=61,file='/home/sjl/ICs/ut_Polvani.N45L20',     &
!                    form='unformatted', status='old')
!           elseif ( mlat == 181 ) then
!               open(unit=61,file='/home/sjl/ICs/ut_Polvani.N90L20',     &
!                    form='unformatted', status='old')
!           elseif ( mlat == 361 ) then
!               open(unit=61,file='/home/sjl/ICs/ut_Polvani.N180L20',     &
!                    form='unformatted', status='old')
!           endif
!           read(61) im,jm,km
!           write(*,*) im, jm, km
!           if( im /= nlon .or. jm /= mlat .or. km /= nlev ) then
!               call error_mesg('init_dry_atm','Dimension inconsistent', FATAL)
!           endif
!      endif
!
!#ifdef SPMD
!      if ( master ) then
!           allocate (  u_g(im,jm,km) )
!           allocate ( pt_g(im,jm,km) )
!           read(61) u_g
!           read(61) pt_g
!           close(61)
!      endif
!! Scatter data
!        call mp_scatter3d(u_g, u, nlon, mlat, nlev, beglat, endlat,  &
!                          1, nlev, ng_d, ng_s, 0)
!        call mp_scatter3d(pt_g, pt, nlon, mlat, nlev, beglat, endlat,  &
!                          1, nlev, ng_d, ng_d, 0)
!
!      if ( master ) then
!           deallocate (  u_g )
!           deallocate ( pt_g )
!      endif
!#else
!           read(61) u
!           read(61) pt
!           close(61)
!#endif

! Initialize tracers
           q  = 0.
     do m=1,ncnst
        do j=jsp,jep
           do i=1,nlon
              q(i,j,nlev,m) = 1.
           enddo
         enddo
      enddo
      call fv_array_sync()

  call p_var(nlon, mlat, nlev, beglat, endlat, ptop, delp, ps,   &
               pe, peln, pk, pkz, kappa, q, ng_d, ncnst, .false. )

#else

#ifdef LIN2004
  real dpt, pi, dl
  real xc, yc, br, xo, yo, zo, xg, yg, zg
  real zam, prc, dist
  real u2(mlat,nlev), t2(mlat,nlev)
#ifdef use_shared_pointers
  pointer( p_u2, u2 )
  pointer( p_t2, t2 )
  call fv_stack_push( p_u2, mlat*nlev )
  call fv_stack_push( p_t2, mlat*nlev )
#endif
!$omp parallel do private (i, j)
  do j=jsp,jep
     do i=1,nlon
        ps(i,j) = slp0
     enddo
  enddo
  call fv_array_sync()

!$omp parallel do private (i, j, k, m)
  do k=ksp,kep
      do j=beglat,endlat
         do i=1,nlon
            v(i,j,k) = 0.
            delp(i,j,k) = ak(k+1) - ak(k) + ps(i,j)*(bk(k+1) - bk(k))
         enddo
      enddo
   enddo
   call fv_array_sync()

  call p_var(nlon, mlat, nlev, beglat, endlat, ptop, delp, ps,   &
               pe, peln, pk, pkz, kappa, q, ng_d, ncnst, .false. )

! Define jet and temperature as in Lin 2004, MWR
  call jet2d_symm(mlat, nlev, u2, t2, ak, bk, slp0, cosp, sinp, cose, sine)

!$omp parallel do private (i, j, k, m)
  do k=ksp,kep
      do j=beglat,endlat
         do i=1,nlon
            u(i,j,k) = u2(j,k)
         enddo
      enddo
   enddo
   call fv_array_sync()

!----------------------------------
! Define temperature perturbation 
!----------------------------------
    dpt = 2. / (slp0**(2./7.))           ! 2 deg (k) thermal bubble
    pi = 4.*atan(1.)
    yc = pi/4.            ! center in lat.
    xc = .5*pi            ! center: longitude
    br = 2.*pi / 36       ! 10 degree width
    dl = 2.*pi / real(nlon)

!
! Perturbation center location in (x, y, z) Cartensian coordinate: unit sphere
!
    xo = cos(yc) * cos(xc)
    yo = cos(yc) * sin(xc)
    zo = sin(yc)

   do k=1,nlev
      do j=beglat,endlat
         do i=1,nlon
            zam  = dl*real(i-1)
            prc = 0.5*(pe(i,k,j)+pe(i,k+1,j))
!
! Great circle distance on unit sphere
!
            xg = cosp(j) * coslon(i)
            yg = cosp(j) * sinlon(i)
            zg = sinp(j)
            dist = acos(xg*xo + yg*yo + zg*zo)
            pt(i,j,k) = t2(j,k) + pkz(i,j,k)*dpt*exp(-(dist/br)**2 )   &
                        * max(0., (prc-800.E2)/200.E2)
         enddo
      enddo
   enddo

! Initialize tracers
     q = 0.
     do m=1,ncnst
        do j=beglat, endlat
           do i=1,nlon
              q(i,j,nlev,m) = 1.
           enddo
         enddo
     enddo
#else

     ftop = gmean(nlon, mlat, beglat, endlat, phis(1,beglat))
     if(master) write(6,*) 'mean terrain height (m)=', ftop/grav

!$omp parallel do private (i, j, k, m)
     do k=ksp,kep
        do j=beglat, endlat
           do i=1,nlon
              q(i,j,k,1) = 3.E-6      ! specific humidity in the strat
           enddo
        enddo

        if( ncnst > 1 ) then
            do m=2,ncnst
               do j=beglat, endlat
                  do i=1,nlon
                     q(i,j,k,m) = 0.
                  enddo
               enddo
            enddo
        endif
     enddo

! -- TEST code for tracer mass conservation -------------
#ifdef TEST_TRACER
        q = 0.
       do j=beglat, endlat
          do i=1,nlon
             q(i,j,nlev,1) = 1.e-6
             q(i,j,nlev,2) = 1.e-12
             q(i,j,nlev,3) = 1.e-24
             q(i,j,nlev,4) = 1.
          enddo
       enddo
#endif

#ifdef MARS_GCM
  call hydro_eq(nlon, mlat, nlev, beglat, endlat, ps, phis, dry_mass,  &
                delp, ak, bk, u, v, pt, ng_d, ng_s, 0, grav, rg,   &
                p_ref, mountain, master)

!!!  call p_var(nlon, mlat, nlev, beglat, endlat, ptop, delp, ps,   &
!!!               pe, peln, pk, pkz, kappa, q, ng_d, ncnst, adjust_dry_mass)

  call p_var(nlon, mlat, nlev, beglat, endlat, ptop, delp, ps,   &
               pe, peln, pk, pkz, kappa, q, ng_d, ncnst, .false. )


#else
  call hydro_eq(nlon, mlat, nlev, beglat, endlat, ps, phis, dry_mass,  &
                delp, ak, bk, u, v, pt, ng_d, ng_s, 0, grav, rg,   &
                mountain, master)

  call p_var(nlon, mlat, nlev, beglat, endlat, ptop, delp, ps,   &
               pe, peln, pk, pkz, kappa, q, ng_d, ncnst, full_phys)
#endif MARS_GCM

  call d2a3d(u(1,beglat-ng_d,nlev), v(1,beglat-ng_d,nlev), u_srf, v_srf, &
             nlon, mlat, 1, beglat, endlat, ng_d, ng_s, coslon, sinlon)

  do j=beglat,endlat
     do i=1,nlon
        ps_bp(i,j) = ps(i,j)
     enddo
  enddo

#endif  LIN2004

#endif  POLVANI

 end subroutine init_dry_atm

#ifdef MARS_GCM
 subroutine hydro_eq(im, jm, km, beglat, endlat, ps, hs, drym,  &
                    delp, ak, bk, u, v, pt, ng_d, ng_s, ig, grav,  &
                    rg, pref, mountain, master)
#else
 subroutine hydro_eq(im, jm, km, beglat, endlat, ps, hs, drym,  &
                    delp, ak, bk, u, v, pt, ng_d, ng_s, ig, grav,  &
                    rg, mountain, master)
#endif MARS_GCM
!============================================================

   use fv_arrays_mod, only: fv_array_check, fv_array_sync
   use fv_arrays_mod, only: isp, iep, jsp, jep, ksp, kep
   use pmaxmin_mod, only: pmaxming

  implicit none
! Input:
  integer, intent(in):: im, jm, km
  integer, intent(in):: ng_d, ng_s
  integer, intent(in):: beglat, endlat, ig
  real, intent(in):: ak(km+1), bk(km+1)
  real, intent(in):: hs(im,beglat-ig:endlat+ig)
  real, intent(in):: grav, rg, drym
  logical, intent(in):: mountain
  logical, intent(in):: master
#ifdef MARS_GCM
  real, intent(in):: pref
#endif MARS_GCM

! Output
  real, intent(out)::  ps(im,beglat:endlat)
  real, intent(out)::  u(im,beglat-ng_d:endlat+ng_s,km)
  real, intent(out)::  v(im,beglat-ng_d:endlat+ng_d,km)
  real, intent(out):: pt(im,beglat-ng_d:endlat+ng_d,km)
  real, intent(out):: delp(im,beglat:endlat,km)

! Local
  integer  i,j,k
  real z1, t1, p1, t0, a0, psm, dps
  real gmean, ztop, p_top
  real gz(im,km+1)
  real ph(im,km+1)
  integer kt
  real:: mslp = 1010.6*100.

  call fv_array_check( LOC(hs) )
  call fv_array_check( LOC(ps) )
  call fv_array_check( LOC(u) )
  call fv_array_check( LOC(v) )
  call fv_array_check( LOC(pt) )
  call fv_array_check( LOC(delp) )

  t1 = 215.
  if ( mountain ) then
! First guess: Mean sel-level pressure 1010.6
#ifdef MARS_GCM 
     print *, 'Mars topo -> ps calc:  ',  pref 
     do j=beglat, endlat
         do i=1,im
            ps(i,j) = pref*exp( -hs(i,j)/( rg*190.0 ) )
         enddo
     enddo

#else

! Given p1 and z1 (250mb, 10km)
        p_top = 10.*100.
        p1 = 25000.
        z1 = 10.E3 * grav
        t0 = 280.            ! sea-level temp.
        a0 = (t1-t0)/z1
        ztop = z1 + (rg*t1)*log(p1/p_top)

     do j=beglat, endlat
        do i=1,im
!          ps(i,j) = p1*((z1+t0/a0)/(hs(i,j)+t0/a0))**(1./(a0*rg))  
           ps(i,j) = mslp*((t0/a0)/(hs(i,j)+t0/a0))**(1./(a0*rg))  
        enddo
     enddo
#endif MARS_GCM 

     psm = gmean(im, jm, beglat, endlat, ps(1,beglat))
     dps = drym - psm
     if(master) write(6,*) 'Computed mean ps=', psm
     if(master) write(6,*) 'Correction delta-ps=', dps

!$omp parallel do private (i, j)
        do j=jsp,jep
           do i=1,im
              ps(i,j) = ps(i,j) + dps
           enddo
        enddo

! Compute surface pressure
!$omp parallel do private (i, j, k, ph, gz, kt)
     do j=jsp,jep
#ifdef MARS_GCM
        do k= 1, km
           do i=1,im
              pt(i,j,k) = 190.0
           enddo
        enddo
#else
        do i=1,im
           gz(i,km+1) = hs(i,j)
        enddo

        do k=1,km+1
           do i=1,im
              ph(i,k) = ak(k) + bk(k)*ps(i,j)
           enddo
        enddo

        do k=1,km
           do i=1,im
                 pt(i,j,k) = t1
              if ( ph(i,k+1) <= p1 ) then
                 kt = k
                 gz(i,k) = ztop + rg*t1*log(p_top/ph(i,k))
              else
! Constant lapse rate region (troposphere)
                 gz(i,k) = (hs(i,j)+t0/a0)/(ph(i,k)/ph(i,km+1))**(a0*rg)  &
                         - t0/a0
              endif
           enddo
        enddo

        do k=kt+1,km
           do i=1,im
! Convert geopotential to Temperature
              pt(i,j,k) = (gz(i,k)-gz(i,k+1))/(rg*(log(ph(i,k+1)/ph(i,k))))
              pt(i,j,k) = max(min(t0, pt(i,j,k)), t1) 
           enddo
        enddo
#endif  MARS_GCM

     enddo

  else
!$omp parallel do private (i, j)
      do j=jsp,jep

#ifdef MARS
         do i=1,im
            ps(i,j) = pref
         enddo
         do k=1,km
            do i=1,im
               pt(i,j,k) = 190.0
            enddo
         enddo

!       Add a small random perturbation to the temp field at the surface
         DO i= 1, im
           pt(i,j,km)= pt(i,j,km) + 1.E-5 * cos( (i+j)*1.0 ) 
         ENDDO 
#else 
         do i=1,im
            ps(i,j) = 1.E5
         enddo
         do k=1,km
            do i=1,im
               pt(i,j,k) = t1
            enddo
         enddo
#endif MARS

      end do
    endif  !  ------- end of no-topography case ------------


    call fv_array_sync()

!$omp parallel do private (i, j, k)
      do k=ksp,kep
         do j=beglat,endlat
            do i=1,im
                  u(i,j,k) = 0.
                  v(i,j,k) = 0.
               delp(i,j,k) = ak(k+1)-ak(k) + ps(i,j)*(bk(k+1)-bk(k))
            enddo
         enddo
      enddo
      call fv_array_sync()

  call pmaxming('Computed T ', pt, im, jm, km, beglat, endlat, ng_d, ng_d, 1.)

 end subroutine hydro_eq


#ifdef LIN2004
 subroutine jet2d_symm(jm, km, u2, t2, ak, bk, p0, cosp, sinp, cose, sine)
!=========================================================================
!
! Compute 2D zonally balanced flow (U,T)
!
 use constants_mod,  only: radius, omega, grav, rdgas
 implicit none

  
 integer, intent(in):: jm, km
 real, intent(in):: p0
 real, intent(in):: ak(km+1), bk(km+1)
 real, intent(in):: cosp(jm), sinp(jm)
 real, intent(in):: cose(jm), sine(jm)

 real, intent(out):: u2(jm,km)
 real, intent(out):: t2(jm,km)

!------
! local:
!------
 real pe1(km+1)
 real up(jm,km+1)
 real ue(jm,km+1)
 real gz(jm,km+1)
 integer j, k
 real:: u0 = 35.
 real z, uz, sin2p, sin2e
 real p1, t1, t0, a0, gz1, vort
 real dp

  do k=1,km+1
     pe1(k) = ak(k) + bk(k)*p0
     z = log(p0/pe1(k))
     uz = u0*z*exp( -z**2/4. )
     do j=1,jm
!
! Y-functional form: u = u(z) * sin(theta)**2
!
        sin2p   = 2.*sinp(j)*cosp(j)
        up(j,k) = uz*sin2p**4 + 0.1*z*(uz-15.)*cosp(j)**8
     enddo

     do j=2,jm
        sin2e = 2.*sine(j)*cose(j)
        ue(j,k) = uz*sin2e**4 + 0.1*z*(uz-15.)*cosp(j)**8
     enddo
  enddo

! Compute gz at p1 (250mb)
     p1 = 250.E2
     t1 = 210.
     t0 = 260.
     a0 = -5.E-3/grav
! height at 250-mb
     gz1 = (t0/a0) / (p1/p0)**(a0*rdgas) - t0/a0

! gz at ptop = gz1 + rdgas*t1*log(p1/ptop)

     do j=1,jm
        gz(j,km+1) = 0.        ! assuming zs=0
     enddo

! j=1
     do k=1,km
        if(pe1(k) <= p1) then
           gz(1,k) = gz1 + rdgas*t1*log(p1/pe1(k))
        else
           gz(1,k) = (t0/a0)/(pe1(k)/p0)**(a0*rdgas) - t0/a0
        endif
     enddo

! Compute gz from SP to NP

     dp = 4.*atan(1.) / (jm-1)

     do k=1,km+1
        do j=2,jm
           vort  = 2.*omega*sine(j) - (up(j,k)*cosp(j) -    &
                   up(j-1,k)*cosp(j-1)) / (radius*cose(j)*dp)
           gz(j,k) = gz(j-1,k) - ue(j,k)*(radius*vort*dp +   &
                                       up(j,k)-up(j-1,k))
        enddo
     enddo

! Compute pt (temperature)
     do k=1,km
        do j=2,jm
           u2(j,k) = 0.5*(ue(j,k)+ue(j,k+1))
        enddo
        do j=1,jm
           t2(j,k) = (gz(j,k)-gz(j,k+1)) / (rdgas*(log(pe1(k+1)/pe1(k))))
        enddo
     enddo

 end subroutine jet2d_symm
#endif

#else

  subroutine init_dry_atm(mountain, kappa, grav, rg)

  use shr_kind_mod, only: r8 => shr_kind_r8
!  use fv_pack,      only: nlon, mlat, nlev, ncnst, beglat, endlat,  &
!                          ps, u, v, delp, pt, q, ak, bk, ptop,      &
!                          pe, peln, pk, pkz, ng_d, ng_s, phis,      &         
!                          ps_bp, ua, va, u_srf, v_srf, full_phys,   &
!                          d2a3d, p_var, coslon, sinlon, ighost,     &
!                          cosp, sinp, cose, sine, dry_mass,  master
  use fv_pack,      only: nlon, mlat, beglat, endlat,  &
                          ak, bk, ptop,      &
                          ng_d, ng_s,  &         
                          full_phys,  master,   &
                          p_var, ighost
  use fms_mod,      only: file_exist,  error_mesg,  FATAL

#ifdef SPMD
   use mod_comm, only: mp_scatter3d
#endif
   use mpp_io_mod, only: mpp_open, mpp_close
   use mpp_io_mod, only: MPP_RDONLY, MPP_MULTI, MPP_SINGLE, MPP_NATIVE
   use fv_arrays_mod, only: fv_stack_push, fv_array_sync

!  implicit none
#include "fv_arrays.h"

  logical,  intent(in):: mountain
  real(r8), intent(in):: kappa
  real(r8), intent(in):: grav
  real(r8), intent(in):: rg

  real(r8):: slp0 = 1.E5
  real(r8):: tref = 273.16
  real(r8):: drym = 98288.        ! Dry air mass correct for USGS
! real(r8):: drym = 98290.        ! Revised dry air mass correct for USGS
  integer i,j,k,m
  integer im, jm, km
  real(r8) gmean, ftop 

#ifdef POLVANI
 
! This is Lorenzo Polvani's idealized test case
!
  real(r8), allocatable:: u_g(:,:,:), pt_g(:,:,:)

!$omp parallel do private (i, j)
  do j=beglat, endlat
     do i=1,nlon
        ps(i,j) = slp0
     enddo
  enddo

!$omp parallel do private (i, j, k, m)
  do k=1,nlev
      do j=beglat,endlat
         do i=1,nlon
            v(i,j,k) = 0.
            delp(i,j,k) = ak(k+1) - ak(k) + ps(i,j) * (bk(k+1) - bk(k))
         enddo
      enddo
  enddo

! Read (u,PT) data from Palvani
      if ( master ) then
           if ( mlat == 91 ) then
               open(unit=61,file='/home/sjl/ICs/ut_Polvani.N45L20',     &
                    form='unformatted', status='old')
           elseif ( mlat == 181 ) then
               open(unit=61,file='/home/sjl/ICs/ut_Polvani.N90L20',     &
                    form='unformatted', status='old')
           elseif ( mlat == 361 ) then
               open(unit=61,file='/home/sjl/ICs/ut_Polvani.N180L20',     &
                    form='unformatted', status='old')
           endif
           read(61) im,jm,km
           write(*,*) im, jm, km
           if( im /= nlon .or. jm /= mlat .or. km /= nlev ) then
               call error_mesg('init_dry_atm','Dimension inconsistent', FATAL)
           endif
      endif

#ifdef SPMD
      if ( master ) then
           allocate (  u_g(im,jm,km) )
           allocate ( pt_g(im,jm,km) )
           read(61) u_g
           read(61) pt_g
           close(61)
      endif
! Scatter data
        call mp_scatter3d(u_g, u, nlon, mlat, nlev, beglat, endlat,  &
                          1, nlev, ng_d, ng_s, 0)
        call mp_scatter3d(pt_g, pt, nlon, mlat, nlev, beglat, endlat,  &
                          1, nlev, ng_d, ng_d, 0)

      if ( master ) then
           deallocate (  u_g )
           deallocate ( pt_g )
      endif
#else
           read(61) u
           read(61) pt
           close(61)
#endif

! Initialize tracers
           q  = 0.
     do m=1,ncnst
        do j=beglat, endlat
           do i=1,nlon
              q(i,j,nlev,m) = 1.
           enddo
         enddo
     enddo

  call p_var(nlon, mlat, nlev, beglat, endlat, ptop, delp, ps,   &
               pe, peln, pk, pkz, kappa, q, ng_d, ncnst, .false. )

#else

     ftop = gmean(nlon, mlat, beglat, endlat, phis(1,beglat))
     if(master) write(6,*) 'mean terrain height (m)=', ftop/grav

     call hydro_eq(nlon, mlat, nlev, beglat, endlat, ps, phis, drym,  &
                   delp, ak, bk, ighost, grav, rg, mountain, master)
     u_srf = 0.; v_srf = 0.

!$omp parallel do private (i, j, k, m)
  do k=1,nlev
      do j=beglat,endlat
         do i=1,nlon
            u(i,j,k) = 0.
            v(i,j,k) = 0.
         enddo
      enddo

! Initialize tracers
        do j=beglat, endlat
           do i=1,nlon
              q(i,j,k,1) = 3.E-6      ! specific humidity in the strat
           enddo
         enddo

     if( ncnst > 1 ) then
     do m=2,ncnst
        do j=beglat, endlat
           do i=1,nlon
              q(i,j,k,m) = 0.
           enddo
         enddo
     enddo
     endif
  enddo

! -- TEST code for tracer mass conservation -------------
#ifdef TEST_TRACER
        q = 0.
       do j=beglat, endlat
          do i=1,nlon
             q(i,j,nlev,1) = 1.
!            q(i,j,nlev,1) = 1.e-24
!            q(i,j,nlev,2) = 1.e-12
!            q(i,j,nlev,3) = 1.e-6
!            q(i,j,nlev,4) = 1.
          enddo
       enddo
#endif

  call p_var(nlon, mlat, nlev, beglat, endlat, ptop, delp, ps,   &
               pe, peln, pk, pkz, kappa, q, ng_d, ncnst, full_phys )

!$omp parallel do private (i, j, k, m)
  do k=1,nlev
      do j=beglat,endlat
         do i=1,nlon
            pt(i,j,k) = tref
         enddo
      enddo
  enddo
#endif

end subroutine init_dry_atm


subroutine hydro_eq(im, jm, km, beglat, endlat, ps, hs, drym,  &
                    delp, ak, bk, ig, grav, rg, mountain, master)
  implicit none
! Input:
  integer, intent(in):: im, jm, km
  integer, intent(in):: beglat, endlat, ig
  real, intent(in):: ak(km+1), bk(km+1)
  real, intent(in):: hs(im,beglat-ig:endlat+ig)
  real, intent(in):: grav, rg, drym
  logical, intent(in):: mountain
  logical, intent(in):: master

! Output
  real, intent(out)::  ps(im,beglat:endlat)
  real, intent(out):: delp(im,beglat:endlat,km)

! Local
      integer  i,j,k

      real z1, t1, p1, t0, a0, psm, dps
      real gmean

      if ( mountain ) then

! Given p1 and z1 (250mb, 10km)
        p1 = 25000.
        z1 = 10.E3 * grav
        t1 = 212.
        t0 = 280.            ! sea-level temp.
        a0 = (t1-t0)/z1
! Compute surface pressure
!$omp parallel do private (i, j)
        do j=beglat, endlat
           do i=1,im
              ps(i,j) = p1*((z1+t0/a0)/(hs(i,j)+t0/a0))**(1./(a0*rg))  
           enddo
        enddo

!---------
! Adjust ps
!---------
     psm = gmean(im, jm, beglat, endlat, ps(1,beglat))
     if(master) write(6,*) 'Computed mean ps=', psm
     dps = drym - psm

!$omp parallel do private (i, j)
        do j=beglat, endlat
           do i=1,im
              ps(i,j) = ps(i,j) + dps
           enddo
        enddo

      else
!$omp parallel do private (i, j)
        do j=beglat, endlat
           do i=1,im
              ps(i,j) = 1.E5
           enddo
        enddo
      endif

!$omp parallel do private (i, j, k)
      do k=1,km
         do j=beglat,endlat
            do i=1,im
               delp(i,j,k) = ak(k+1) - ak(k) + ps(i,j) * (bk(k+1) - bk(k))
            enddo
         enddo
      enddo

end subroutine hydro_eq
#endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                                   !!
!!                   GNU General Public License                      !!
!!                                                                   !!
!! This file is part of the Flexible Modeling System (FMS).          !!
!!                                                                   !!
!! FMS is free software; you can redistribute it and/or modify       !!
!! it and are expected to follow the terms of the GNU General Public !!
!! License as published by the Free Software Foundation.             !!
!!                                                                   !!
!! FMS is distributed in the hope that it will be useful,            !!
!! but WITHOUT ANY WARRANTY; without even the implied warranty of    !!
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     !!
!! GNU General Public License for more details.                      !!
!!                                                                   !!
!! You should have received a copy of the GNU General Public License !!
!! along with FMS; if not, write to:                                 !!
!!          Free Software Foundation, Inc.                           !!
!!          59 Temple Place, Suite 330                               !!
!!          Boston, MA  02111-1307  USA                              !!
!! or see:                                                           !!
!!          http://www.gnu.org/licenses/gpl.txt                      !!
!!                                                                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module horiz_interp_type_mod
! <CONTACT EMAIL="Zhi.Liang@noaa.gov"> Zhi Liang </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!     define derived data type that contains indices and weights used for subsequent 
!      interpolations.
! </OVERVIEW>

! <DESCRIPTION>
!     define derived data type that contains indices and weights used for subsequent 
!      interpolations.
! </DESCRIPTION>


use mpp_mod, only : mpp_send, mpp_recv, mpp_sync_self, mpp_error, FATAL
use mpp_mod, only : mpp_pe, mpp_root_pe, mpp_npes
use mpp_mod, only : COMM_TAG_1, COMM_TAG_2

implicit none
private


! parameter to determine interpolation method
 integer, parameter :: CONSERVE = 1
 integer, parameter :: BILINEAR = 2
 integer, parameter :: SPHERICA = 3
 integer, parameter :: BICUBIC  = 4

public :: CONSERVE, BILINEAR, SPHERICA, BICUBIC
public :: horiz_interp_type, stats, assignment(=)

interface assignment(=)
  module procedure horiz_interp_type_eq
end interface

!<PUBLICTYPE >
 type horiz_interp_type
   real,    dimension(:,:), pointer   :: faci =>NULL(), facj =>NULL()   !weights for conservative scheme
   integer, dimension(:,:), pointer   :: ilon =>NULL(), jlat =>NULL()   !indices for conservative scheme
   real,    dimension(:,:), pointer   :: area_src =>NULL()              !area of the source grid
   real,    dimension(:,:), pointer   :: area_dst =>NULL()              !area of the destination grid
   real,    dimension(:,:,:), pointer :: wti =>NULL(),wtj =>NULL()      !weights for bilinear interpolation
                                                                        !wti ist used for derivative "weights" in bicubic 
   integer, dimension(:,:,:), pointer :: i_lon =>NULL(), j_lat =>NULL() !indices for bilinear interpolation 
                                                                        !and spherical regrid
   real,    dimension(:,:,:), pointer :: src_dist =>NULL()              !distance between destination grid and 
                                                                        !neighbor source grid.
   logical, dimension(:,:), pointer   :: found_neighbors =>NULL()       !indicate whether destination grid 
                                                                        !has some source grid around it.
   real                               :: max_src_dist
   integer, dimension(:,:), pointer   :: num_found => NULL()
   integer                            :: nlon_src, nlat_src !size of source grid
   integer                            :: nlon_dst, nlat_dst !size of destination grid
   integer                            :: interp_method      !interpolation method.
                                                            !=1, conservative scheme
                                                            !=2, bilinear interpolation
                                                            !=3, spherical regrid
                                                            !=4, bicubic regrid
   real,    dimension(:,:), pointer   :: rat_x =>NULL(), rat_y =>NULL() !the ratio of coordinates of the dest grid
                                                                        ! (x_dest -x_src_r)/(x_src_l -x_src_r) and (y_dest -y_src_r)/(y_src_l -y_src_r)
   real,    dimension(:), pointer     :: lon_in =>NULL(),  lat_in =>NULL()  !the coordinates of the source grid
   logical                            :: I_am_initialized=.false.
   integer                            :: version                            !indicate conservative interpolation version with value 1 or 2
   !--- The following are for conservative interpolation scheme version 2 ( through xgrid)
   integer                            :: nxgrid                             !number of exchange grid between src and dst grid.
   integer, dimension(:), pointer     :: i_src=>NULL(), j_src=>NULL()       !indices in source grid.
   integer, dimension(:), pointer     :: i_dst=>NULL(), j_dst=>NULL()       !indices in destination grid.
   real,    dimension(:), pointer     :: area_frac_dst=>NULL()              !area fraction in destination grid.
   real,    dimension(:,:), pointer   :: mask_in=>NULL() 
 end type
!</PUBLICTYPE>

contains

!#######################################################################
!---This statistics is for bilinear interpolation and spherical regrid.
 subroutine stats ( dat, low, high, avg, miss, missing_value, mask )
 real,    intent(in)  :: dat(:,:)
 real,    intent(out) :: low, high, avg
 integer, intent(out) :: miss
 real, intent(in), optional :: missing_value
 real,    intent(in), optional :: mask(:,:)

 real :: dsum, npts, buffer_real(3)
 integer :: pe, root_pe, npes, p, buffer_int(2)

   pe = mpp_pe()
   root_pe = mpp_root_pe()
   npes = mpp_npes()

   dsum = 0.0
   miss = 0

   if (present(missing_value)) then
      miss = count(dat(:,:) == missing_value)
      low  = minval(dat(:,:), dat(:,:) /= missing_value)
      high = maxval(dat(:,:), dat(:,:) /= missing_value)
      dsum = sum(dat(:,:), dat(:,:) /= missing_value)
   else if(present(mask)) then
      miss = count(mask(:,:) <= 0.5)
      low  = minval(dat(:,:),mask=mask(:,:) > 0.5)
      high = maxval(dat(:,:),mask=mask(:,:) > 0.5)
      dsum = sum(dat(:,:), mask=mask(:,:) > 0.5)
   else
      miss = 0
      low  = minval(dat(:,:))
      high = maxval(dat(:,:))
      dsum = sum(dat(:,:))
   endif
   avg = 0.0
   
   npts = size(dat(:,:)) - miss
   if(pe == root_pe) then
      do p = 1, npes - 1  ! root_pe receive data from other pe
      ! Force use of "scalar", integer pointer mpp interface
         call mpp_recv(buffer_real(1),glen=3, from_pe=p+root_pe, tag=COMM_TAG_1)
         dsum = dsum + buffer_real(1)
         low  = min(low, buffer_real(2))
         high = max(high, buffer_real(3))
         call mpp_recv(buffer_int(1), glen=2, from_pe=p+root_pe, tag=COMM_TAG_2)
         miss = miss + buffer_int(1)
         npts = npts + buffer_int(2)
      enddo         
      if(npts == 0.) then
         print*, 'Warning: no points is valid'
      else
         avg = dsum/real(npts)
      endif
    else   ! other pe send data to the root_pe.
      buffer_real(1) = dsum
      buffer_real(2) = low
      buffer_real(3) = high
      ! Force use of "scalar", integer pointer mpp interface
      call mpp_send(buffer_real(1),plen=3,to_pe=root_pe, tag=COMM_TAG_1)
      buffer_int(1) = miss
      buffer_int(2) = npts
      call mpp_send(buffer_int(1), plen=2, to_pe=root_pe, tag=COMM_TAG_2)
    endif

    call mpp_sync_self()

    return

 end subroutine stats

!#################################################################################################################################
 subroutine horiz_interp_type_eq(horiz_interp_out, horiz_interp_in)
    type(horiz_interp_type), intent(inout) :: horiz_interp_out
    type(horiz_interp_type), intent(in)    :: horiz_interp_in

    if(.not.horiz_interp_in%I_am_initialized) then
      call mpp_error(FATAL,'horiz_interp_type_eq: horiz_interp_type variable on right hand side is unassigned')
    endif

    horiz_interp_out%faci            => horiz_interp_in%faci
    horiz_interp_out%facj            => horiz_interp_in%facj
    horiz_interp_out%ilon            => horiz_interp_in%ilon
    horiz_interp_out%jlat            => horiz_interp_in%jlat
    horiz_interp_out%area_src        => horiz_interp_in%area_src
    horiz_interp_out%area_dst        => horiz_interp_in%area_dst
    horiz_interp_out%wti             => horiz_interp_in%wti
    horiz_interp_out%wtj             => horiz_interp_in%wtj
    horiz_interp_out%i_lon           => horiz_interp_in%i_lon
    horiz_interp_out%j_lat           => horiz_interp_in%j_lat
    horiz_interp_out%src_dist        => horiz_interp_in%src_dist
    horiz_interp_out%found_neighbors => horiz_interp_in%found_neighbors
    horiz_interp_out%max_src_dist    =  horiz_interp_in%max_src_dist
    horiz_interp_out%num_found       => horiz_interp_in%num_found
    horiz_interp_out%nlon_src        =  horiz_interp_in%nlon_src
    horiz_interp_out%nlat_src        =  horiz_interp_in%nlat_src
    horiz_interp_out%nlon_dst        =  horiz_interp_in%nlon_dst
    horiz_interp_out%nlat_dst        =  horiz_interp_in%nlat_dst
    horiz_interp_out%interp_method   =  horiz_interp_in%interp_method
    horiz_interp_out%rat_x           => horiz_interp_in%rat_x
    horiz_interp_out%rat_y           => horiz_interp_in%rat_y
    horiz_interp_out%lon_in          => horiz_interp_in%lon_in
    horiz_interp_out%lat_in          => horiz_interp_in%lat_in
    horiz_interp_out%I_am_initialized = .true.
    horiz_interp_out%i_src           => horiz_interp_in%i_src
    horiz_interp_out%j_src           => horiz_interp_in%j_src
    horiz_interp_out%i_dst           => horiz_interp_in%i_dst
    horiz_interp_out%j_dst           => horiz_interp_in%j_dst
    horiz_interp_out%area_frac_dst   => horiz_interp_in%area_frac_dst
    if(horiz_interp_in%interp_method == CONSERVE) then
       horiz_interp_out%version =  horiz_interp_in%version
       if(horiz_interp_in%version==2) horiz_interp_out%nxgrid = horiz_interp_in%nxgrid
    end if

 end subroutine horiz_interp_type_eq
!#################################################################################################################################

end module horiz_interp_type_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: format_input.F90,v 20.0 2013/12/13 23:16:44 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! FORMAT_INPUT: Procedures to prepare data for input to the simulator
! Compiled/Modified:
!   08/28/2006  John Haynes (haynes@atmos.colostate.edu)
!
! irreg_to_grid (subroutine)
! order_data (subroutine)

  module format_input

  contains

! ----------------------------------------------------------------------------
! SUBROUTINE IRREG_TO_GRID
! ----------------------------------------------------------------------------
  subroutine irreg_to_grid(hgt_matrix,t_matrix,p_matrix,rh_matrix, &
    env_hgt_matrix,env_t_matrix,env_p_matrix,env_rh_matrix)
  use array_lib
  implicit none

! Purpose:
!   Linearly interpolate sounding-level data to the hydrometeor-level
!   resolution
!
! Inputs:
!   [hgt_matrix]       hydrometeor-level heights
!   [env_hgt_matrix]   sounding-level heights
!   [env_t_matrix]     sounding-level temperatures
!   [env_p_matrix]     sounding-level pressures
!   [env_rh_matrix]    sounding-level relative humidities
!
! Outputs:
!   [t_matrix]         hydrometeor-level temperatures
!   [p_matrix]         hydrometeor-level pressures
!   [rh_matrix]        hydrometeor-level relative humidities
!
! Created:
!   08/28/2006  John Haynes (haynes@atmos.colostate.edu)

! ----- INPUTS -----
  real*8, dimension(:,:), intent(in) :: &
    hgt_matrix,env_hgt_matrix,env_t_matrix,env_p_matrix,env_rh_matrix

! ----- OUTPUTS -----
  real*8, dimension(:,:), intent(out) :: &
    t_matrix,p_matrix,rh_matrix

! ----- INTERNAL -----
  integer :: nprof, i
  integer,parameter :: KR8 = selected_real_kind(15,300)

  nprof = size(hgt_matrix,1)
  do i=1,nprof
    call lin_interpolate(env_t_matrix(i,:),env_hgt_matrix(i,:), &
      t_matrix(i,:),hgt_matrix(i,:),1000._KR8)
    call lin_interpolate(env_p_matrix(i,:),env_hgt_matrix(i,:), &
      p_matrix(i,:),hgt_matrix(i,:),1000._KR8)
    call lin_interpolate(env_rh_matrix(i,:),env_hgt_matrix(i,:), &
      rh_matrix(i,:),hgt_matrix(i,:),1000._KR8)
  enddo

  end subroutine irreg_to_grid

! ----------------------------------------------------------------------------
! SUBROUTINE ORDER_DATA
! ----------------------------------------------------------------------------
  subroutine order_data(hgt_matrix,hm_matrix,p_matrix,t_matrix, &
    rh_matrix,sfc_radar,hgt_reversed)
  implicit none

! Purpose:
!   Ensure that input data is in top-down order/bottom-up order,
!   for space-based/surface based radars, respectively
!
! Inputs:
!   [hgt_matrix]   heights
!   [hm_matrix]    mixing ratios
!   [t_matrix]     temperatures
!   [p_matrix]     pressures
!   [rh_matrix]    relative humidities
!   [sfc_radar]    1=surface radar, 0=spaceborne
!
! Outputs:
!   [hgt_matrix],[hm_matrix],[p_matrix,[t_matrix],[rh_matrix] in proper
!   order for input to the radar simulator routine
!   [hgt_reversed]   T=heights were reordered,F=heights were not reordered
!
! Note:
!   The order for all profiles is assumed to the same as the first profile.
!
! Created:
!   08/28/2006  John Haynes (haynes@atmos.colostate.edu)

! ----- INPUTS -----
  integer, intent(in) :: sfc_radar

! ----- OUTPUTS -----
  real*8, dimension(:,:), intent(inout) :: &
    hgt_matrix,p_matrix,t_matrix,rh_matrix
  real*8, dimension(:,:,:), intent(inout) :: &
    hm_matrix
  logical, intent(out) :: hgt_reversed

! ----- INTERNAL -----
  integer :: ngate
  logical :: hgt_descending
  

  ngate = size(hgt_matrix,2)
  hgt_descending = hgt_matrix(1,1) > hgt_matrix(1,ngate)
      
! :: surface: heights must be ascending
! :: space-based: heights must be descending
  if ( &
     (sfc_radar == 1 .and. hgt_descending) .or.  &
     (sfc_radar == 0 .and. (.not. hgt_descending)) &
     ) &
  then

    hgt_matrix(:,:) = hgt_matrix(:,ngate:1:-1)
    hm_matrix(:,:,:) = hm_matrix(:,:,ngate:1:-1)
    p_matrix(:,:) = p_matrix(:,ngate:1:-1)
    t_matrix(:,:) = t_matrix(:,ngate:1:-1)
    rh_matrix(:,:) = rh_matrix(:,ngate:1:-1) 

    hgt_reversed = .true.
  else
    hgt_reversed = .false.
  endif

  end subroutine order_data

  end module format_input

#include <fms_platform.h>

! ----------------------------------------------------------------
!                   GNU General Public License                        
! This file is a part of MOM.                                                                 
!                                                                      
! MOM is free software; you can redistribute it and/or modify it and  
! are expected to follow the terms of the GNU General Public License  
! as published by the Free Software Foundation; either version 2 of   
! the License, or (at your option) any later version.                 
!                                                                      
! MOM is distributed in the hope that it will be useful, but WITHOUT    
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
! License for more details.                                           
!                                                                      
! For the full text of the GNU General Public License,                
! write to: Free Software Foundation, Inc.,                           
!           675 Mass Ave, Cambridge, MA 02139, USA.                   
! or see:   http://www.gnu.org/licenses/gpl.html                      
!-----------------------------------------------------------------------
!
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> John P. Dunne
!</REVIEWER>
!
!<OVERVIEW>
! Ocean Carbon Model Intercomparison Study II: Biotic module
!</OVERVIEW>
!
!<DESCRIPTION>
!       Implementation of routines to solve the OCMIP-2 Biotic
!       simulations as outlined in the Biotic-HOWTO documentation,
!       revision 1.7, 1999/10/05.
!</DESCRIPTION>
!
! <INFO>
! <REFERENCE>
! http://www.ipsl.jussieu.fr/OCMIP/phase2/simulations/Biotic/HOWTO-Biotic.html
! </REFERENCE>
!
! <REFERENCE>
! Press, W. H., S. A. Teukosky, W. T. Vetterling, B. P. Flannery, 1992. 
! Numerical Recipes in FORTRAN, Second Edition, Cambridge University Press. 
! </REFERENCE>
!
! <REFERENCE>
! Enting, I.G., T. M. L. Wigley, M. Heimann, 1994. Future Emissions 
! and concentrations of carbon dioxide: key ocean / atmosphere / 
! land analyses, CSIRO Aust. Div. Atmos. Res. Tech. Pap. No. 31, 
! 118 pp.
! </REFERENCE>
! </INFO>
!

!
!------------------------------------------------------------------
!
!       Module ocmip2_biotic_mod
!
!       Implementation of routines to solve the OCMIP-2 Biotic
!       simulations as outlined in the Biotic-HOWTO documentation,
!       revision 1.7, 1999/10/05.
!
!------------------------------------------------------------------
!
module  ocmip2_biotic_mod

use time_manager_mod,         only: time_type
use diag_manager_mod,         only: send_data, register_diag_field, diag_axis_init
use field_manager_mod,        only: fm_field_name_len, fm_path_name_len, fm_string_len
use field_manager_mod,        only: fm_get_length, fm_get_value, fm_new_value, fm_get_index
use fms_mod,                  only: field_exist, file_exist
use fms_io_mod,               only: register_restart_field, save_restart, restore_state
use fms_io_mod,               only: restart_file_type
use mpp_mod,                  only: stdout, stdlog, mpp_error, mpp_sum, FATAL
use time_manager_mod,         only: get_date
use time_interp_external_mod, only: time_interp_external, init_external_field
use mpp_domains_mod,          only: domain2d
use constants_mod,            only: WTMCO2, WTMO2

use ocean_tpm_util_mod, only: otpm_set_tracer_package, otpm_set_prog_tracer
use fm_util_mod,        only: fm_util_check_for_bad_fields, fm_util_set_value
use fm_util_mod,        only: fm_util_get_string, fm_util_get_logical, fm_util_get_integer, fm_util_get_real
use fm_util_mod,        only: fm_util_get_logical_array, fm_util_get_real_array, fm_util_get_string_array
use fm_util_mod,        only: fm_util_start_namelist, fm_util_end_namelist
use coupler_types_mod,  only: ind_alpha, ind_csurf, coupler_2d_bc_type, ind_flux
use ocean_types_mod,    only: ocean_prog_tracer_type, ocean_grid_type, ocean_time_type
use ocmip2_co2calc_mod, only: ocmip2_co2calc
use ocean_util_mod,     only: diagnose_2d, diagnose_2d_comp, diagnose_3d_comp

implicit none

private

public  :: ocmip2_biotic_bbc
public  :: ocmip2_biotic_end
public  :: ocmip2_biotic_init
public  :: ocmip2_biotic_flux_init
public  :: ocmip2_biotic_sbc
public  :: ocmip2_biotic_source
public  :: ocmip2_biotic_start
public  :: ocmip2_biotic_init_sfc
public  :: ocmip2_biotic_avg_sfc
public  :: ocmip2_biotic_sum_sfc
public  :: ocmip2_biotic_zero_sfc
public  :: ocmip2_biotic_sfc_end
public  :: ocmip2_biotic_restart

private :: allocate_arrays
private :: locate
private :: set_array

character(len=fm_field_name_len), parameter     :: package_name = 'ocmip2_biotic'
character(len=48), parameter                    :: mod_name = 'ocmip2_biotic_mod'
character(len=48), parameter                    :: diag_name = 'ocean_ocmip2_biotic'
character(len=fm_string_len), parameter         :: default_restart_file = 'ocmip2_biotic.res.nc'
character(len=fm_string_len), parameter         :: default_local_restart_file = 'ocmip2_biotic_local.res.nc'
character(len=fm_string_len), parameter         :: default_ice_restart_file = 'ice_ocmip2_biotic.res.nc'
character(len=fm_string_len), parameter         :: default_ocean_restart_file = 'ocmip2_biotic_airsea_flux.res.nc'

! coefficients for O2 saturation
real, parameter :: a_0 = 2.00907
real, parameter :: a_1 = 3.22014
real, parameter :: a_2 = 4.05010
real, parameter :: a_3 = 4.94457
real, parameter :: a_4 = -2.56847e-01
real, parameter :: a_5 = 3.88767
real, parameter :: b_0 = -6.24523e-03
real, parameter :: b_1 = -7.37614e-03
real, parameter :: b_2 = -1.03410e-02
real, parameter :: b_3 = -8.17083e-03
real, parameter :: c_0 = -4.88682e-07

!  sio2_const           = SiO2 concentration (mol/m^3)
!  add_phosphate        : if true, then add sufficient PO4 to keep
!                         the predicted PO4 the same as if no depletion
!                         or changed uptake rate were in effect

type mask_region_type
  real, dimension(:,:,:), pointer       :: mask => NULL()
  real, dimension(:), pointer           :: elon => NULL()
  real, dimension(:), pointer           :: nlat => NULL()
  real, dimension(:), pointer           :: slat => NULL()
  real, dimension(:), pointer           :: wlon => NULL()
  logical                               :: coastal_only
  real                                  :: factor
  logical, dimension(:), pointer        :: t_mask => NULL()
end type mask_region_type

type biotic_type

  logical                               :: soft_tissue_pump
  logical                               :: add_phosphate
  real                                  :: bio_tau
  real                                  :: c_2_p
  real                                  :: ca_remin_depth
  real                                  :: caco3_2_c
  real                                  :: compensation_depth
  real, _ALLOCATABLE, dimension(:,:)    :: alpha  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: csurf  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: fc  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: fca  _NULL
  character(len=fm_string_len)          :: local_restart_file
  real, _ALLOCATABLE, dimension(:,:)    :: flux_caco3  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: flux_poc  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: htotal  _NULL
  integer                               :: id_alpha = -1
  integer                               :: id_csurf = -1
  integer                               :: id_fc = -1
  integer                               :: id_fca = -1
  integer                               :: id_flux_caco3 = -1
  integer                               :: id_flux_poc = -1
  integer                               :: id_htotal = -1
  integer                               :: id_jca = -1
  integer                               :: id_jdop = -1
  integer                               :: id_jo2 = -1
  integer                               :: id_jpo4 = -1
  integer                               :: id_jpo4_add = -1
  integer                               :: id_jprod = -1
  integer                               :: id_pco2surf = -1
  integer                               :: id_sfc_flux_co2 = -1
  integer                               :: id_sfc_flux_o2 = -1
  integer                               :: id_vstf_alk = -1
  integer                               :: id_vstf_dic = -1
  integer                               :: id_vstf_dop = -1
  integer                               :: id_vstf_o2 = -1
  integer                               :: id_vstf_po4 = -1
  integer                               :: ind_alk
  integer                               :: ind_dic
  integer                               :: ind_dop
  integer                               :: ind_o2
  integer                               :: ind_po4
  integer                               :: ind_co2_flux
  integer                               :: ind_o2_flux
  real, _ALLOCATABLE, dimension(:,:,:)  :: jca  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jdop  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jo2  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jpo4  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jpo4_add  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_norm  _NULL
  real                                  :: kappa
  integer                               :: km_c
  real                                  :: martin_coeff
  real                                  :: martin_coeff_alt
  real                                  :: n_2_p
  character(len=fm_field_name_len)      :: name
  real                                  :: o2_min
  real                                  :: o_2_p
  real, _ALLOCATABLE, dimension(:,:)    :: pco2surf  _NULL
  real                                  :: r_bio_tau
  type(mask_region_type)                :: r_bio_tau_a
  type(mask_region_type)                :: nut_depl
  type(mask_region_type)                :: norm_remin
  type(mask_region_type)                :: no_caco3
  integer                               :: id_sc_co2 = -1
  integer                               :: id_sc_o2 = -1
  real, _ALLOCATABLE, dimension(:,:)    :: sc_co2  _NULL
  real                                  :: sc_co2_0
  real                                  :: sc_co2_1
  real                                  :: sc_co2_2
  real                                  :: sc_co2_3
  real, _ALLOCATABLE, dimension(:,:)    :: sc_o2  _NULL
  real                                  :: sc_o2_0
  real                                  :: sc_o2_1
  real                                  :: sc_o2_2
  real                                  :: sc_o2_3
  real                                  :: sigma
  real, _ALLOCATABLE, dimension(:,:)    :: sio2  _NULL
  real                                  :: sio2_const
  real                                  :: stp_alkalinity
  real                                  :: stp_salinity
  real                                  :: stp_temperature
  real, _ALLOCATABLE, dimension(:,:)    :: vstf_alk  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: vstf_dic  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: vstf_dop  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: vstf_o2  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: vstf_po4  _NULL
  real, _ALLOCATABLE, dimension(:)      :: zfca  _NULL
  real, _ALLOCATABLE, dimension(:)      :: zforg  _NULL
  real, _ALLOCATABLE, dimension(:)      :: zforg_alt  _NULL

end type biotic_type

logical, public :: do_ocmip2_biotic

integer                                 :: indsal
integer                                 :: indtemp
integer                                 :: package_index
logical                                 :: module_initialized = .false.

character(len=128) :: version = '$Id: ocmip2_biotic.F90,v 20.0 2013/12/14 00:09:40 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!       Input parameters:
!
!  htotal_in            = default value for htotal for an initial run
!  htotal_scale_lo      = scaling parameter to chose htotallo
!  htotal_scale_hi      = scaling parameter to chose htotalhi
real                                    :: htotal_in
real, allocatable, dimension(:,:)       :: htotal_scale_hi
real                                    :: htotal_scale_hi_in
real, allocatable, dimension(:,:)       :: htotal_scale_lo
real                                    :: htotal_scale_lo_in

! Calculated parameters (with possible initial input values):
integer                                         :: id_o2_sat
integer                                         :: km_c_max
integer                                         :: po4_star_id
real, allocatable, dimension(:,:,:)             :: po4_star_t
character*128                                   :: po4_star_file    
character*128                                   :: po4_star_name
real, allocatable, dimension(:,:)               :: sc_no_term
type(biotic_type), allocatable, dimension(:)    :: biotic
integer                                         :: instances
real, allocatable, dimension(:,:)               :: o2_saturation
real, allocatable, dimension(:)                 :: tk
real, allocatable, dimension(:)                 :: ts
real, allocatable, dimension(:)                 :: ts2
real, allocatable, dimension(:)                 :: ts3
real, allocatable, dimension(:)                 :: ts4
real, allocatable, dimension(:)                 :: ts5
real, allocatable, dimension(:)                 :: tt

! for restart
integer                              :: num_restart = 0
type(restart_file_type), allocatable :: restart(:)

contains

!#######################################################################
! <SUBROUTINE NAME="allocate_arrays">
!
! <DESCRIPTION>
!     Dynamically allocate arrays
! </DESCRIPTION>
!
subroutine allocate_arrays(isc, iec, jsc, jec, nk, isd, ied, jsd, jed)
integer, intent(in)     :: isc
integer, intent(in)     :: iec
integer, intent(in)     :: jsc
integer, intent(in)     :: jec
integer, intent(in)     :: isd
integer, intent(in)     :: ied
integer, intent(in)     :: jsd
integer, intent(in)     :: jed
integer, intent(in)     :: nk

integer :: i, j, k, l, n

allocate( sc_no_term(isc:iec,jsc:jec) )
allocate( htotal_scale_lo(isc:iec,jsc:jec) )
allocate( htotal_scale_hi(isc:iec,jsc:jec) )
allocate( o2_saturation(isc:iec,jsc:jec) )
allocate( tt(isc:iec) )
allocate( tk(isc:iec) )
allocate( ts(isc:iec) )
allocate( ts2(isc:iec) )
allocate( ts3(isc:iec) )
allocate( ts4(isc:iec) )
allocate( ts5(isc:iec) )
!allocate( po4_star_t(isd:ied,jsd:jed,km_c_max) )
!       this should be dimensioned as above, but the time_interp routine
!       requires that the array dimensions match the datasets dimensions
allocate( po4_star_t(isd:ied,jsd:jed,nk) )

! initialize some arrays
sc_no_term(:,:) = 0.0
htotal_scale_lo(:,:) = 0.0
htotal_scale_hi(:,:) = 0.0
o2_saturation(:,:) = 0.0
tt(:) = 0.0
tk(:) = 0.0
ts(:) = 0.0
ts2(:) = 0.0
ts3(:) = 0.0
ts4(:) = 0.0
ts5(:) = 0.0
po4_star_t(:,:,:) = 0.0

! allocate biotic array elements
do n = 1, instances

  allocate( biotic(n)%sc_co2(isc:iec,jsc:jec) )
  allocate( biotic(n)%sc_o2(isc:iec,jsc:jec) )
  allocate( biotic(n)%htotal(isc:iec,jsc:jec) )
  allocate( biotic(n)%csurf(isc:iec,jsc:jec) )
  allocate( biotic(n)%alpha(isc:iec,jsc:jec) )
  allocate( biotic(n)%pco2surf(isc:iec,jsc:jec) )
  allocate( biotic(n)%sio2(isd:ied,jsd:jed) )
  allocate( biotic(n)%zforg(nk) )
  allocate( biotic(n)%zforg_alt(nk) )
  allocate( biotic(n)%zfca(nk) )
  allocate( biotic(n)%jprod(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jpo4(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jdop(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jo2(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%jca(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%fc(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%fca(isc:iec,jsc:jec,nk) )
  allocate( biotic(n)%flux_poc(isc:iec,jsc:jec) )
  allocate( biotic(n)%flux_caco3(isc:iec,jsc:jec) )
  allocate( biotic(n)%nut_depl%mask(isc:iec,jsc:jec,12) )
  allocate( biotic(n)%no_caco3%mask(isc:iec,jsc:jec,12) )
  allocate( biotic(n)%norm_remin%mask(isc:iec,jsc:jec,12) )
  allocate( biotic(n)%r_bio_tau_a%mask(isc:iec,jsc:jec,12) )

  if (biotic(n)%add_phosphate) then
    allocate( biotic(n)%jprod_norm(isc:iec,jsc:jec,nk) )
    allocate( biotic(n)%jpo4_add(isc:iec,jsc:jec,nk) )
  endif

enddo

! initialize biotic array elements
do n = 1, instances

  do j = jsd, jed
    do i = isd, ied
      biotic(n)%sio2(i,j) = 0.0
      biotic(n)%sc_co2(i,j) = 0.0
      biotic(n)%sc_o2(i,j) = 0.0
    enddo
  enddo
  do j = jsc, jec
    do i = isc, iec
      biotic(n)%htotal(i,j) = 0.0
      biotic(n)%csurf(i,j) = 0.0
      biotic(n)%alpha(i,j) = 0.0
      biotic(n)%pco2surf(i,j) = 0.0
    enddo
  enddo
  do k = 1, nk
    biotic(n)%zforg(k) = 0.0
    biotic(n)%zforg_alt(k) = 0.0
    biotic(n)%zfca(k) = 0.0
  enddo
  do j = jsc, jec
    do i = isc, iec
      do k = 1, nk
        biotic(n)%jprod(i,j,k) = 0.0
        biotic(n)%jpo4(i,j,k) = 0.0
        biotic(n)%jdop(i,j,k) = 0.0
        biotic(n)%jo2(i,j,k) = 0.0
        biotic(n)%jca(i,j,k) = 0.0
        biotic(n)%fc(i,j,k) = 0.0
        biotic(n)%fca(i,j,k) = 0.0
      enddo
    enddo
  enddo
  do j = jsc, jec
    do i = isc, iec
      biotic(n)%flux_poc(i,j) = 0.0
      biotic(n)%flux_caco3(i,j) = 0.0
    enddo
  enddo
  do j = jsc, jec
    do i = isc, iec
      do l = 1, 12
        biotic(n)%nut_depl%mask(i,j,l) = 0.0
        biotic(n)%no_caco3%mask(i,j,l) = 0.0
        biotic(n)%norm_remin%mask(i,j,l) = 0.0
        biotic(n)%r_bio_tau_a%mask(i,j,l) = 0.0
      enddo
    enddo
  enddo

  if (biotic(n)%add_phosphate) then
    do j = jsc, jec
      do i = isc, iec
        do k = 1, nk
          biotic(n)%jprod_norm(i,j,k) = 0.0
          biotic(n)%jpo4_add(i,j,k) = 0.0
        enddo
      enddo
    enddo
  endif

enddo

return
end subroutine  allocate_arrays
! </SUBROUTINE> NAME="allocate_arrays"


!#######################################################################
! <SUBROUTINE NAME="locate">
!
! <DESCRIPTION>
!     After Numerical recipes:
!
!     Given an array XX of length N, and a given value of X, returns a
!     value of J such that X is between XX(J) and XX(J+1).  XX must be
!     monotonic, either increasing or decreasing. J=0 or J=N is
!     returned to indicate that X is out of range.      

!       New features:
!
!       If "period" is specified, then the array, xx, is considered
!       to be periodic with a period of "period". If "x_in" is out
!       of range, then add or subtract "period" once to attempt to 
!       make "x_in" be in range.
!
!       If "nearest" is specified, and true, then return "j" such
!       that it is the element of "xx" which is nearest to the value
!       of "x_in" (where "x_in" may have been modified by the value
!       "period", above). With this option, "j" will be in
!       the range 1 <= j <= n.
! </DESCRIPTION>
!
subroutine locate(xx , n, x_in, j, period, nearest)

integer, intent(in)             :: n
real, intent(in)                :: x_in
real, dimension(n), intent(in)  :: xx
integer, intent(out)            :: j
real, optional, intent(in)      :: period
logical, optional, intent(in)   :: nearest

integer :: jl, ju, jm
real    :: x, xt
logical :: increasing

increasing = xx(1) .lt. xx(n)

if (present(period)) then
  if (increasing) then
    ! increasing array
    if (x_in .lt. xx(1)) then
      ! original value less than start, therefore add period
      xt = x_in + period
      if (xt .gt. xx(n)) then
        ! new value greater than end
        if (abs(x_in - xx(1)) .gt. abs(xt - xx(n))) then
          ! new value closer to end than original value to start
          ! use new value
          x = xt
        else
          ! original value closer to start than new value to end
          ! use original value
          x = x_in
        endif
      else
        ! new value in range
        ! use new value
        x = xt
      endif
    elseif (x_in .gt. xx(n)) then
      ! original value greater than end, therefore subtract period
      xt = x_in - period
      if (xt .lt. xx(1)) then
        ! new value less than start
        if (abs(xt - xx(1)) .lt. abs(x_in - xx(n))) then
          ! new value closer to start than original value to end
          ! use new value
          x = xt
        else
          ! original value closer to end than new value to start
          ! use original value
          x = x_in
        endif
      else
        ! new value in range
        ! use new value
        x = xt
      endif
    else
      ! original value in range
      ! use original value
      x = x_in
    endif
  else
    ! decreasing array
    if (x_in .gt. xx(1)) then
      ! original value greater than start, therefore subtract period
      xt = x_in - period
      if (xt .lt. xx(n)) then
        ! new value less than end
        if (abs(x_in - xx(1)) .gt. abs(xt - xx(n))) then
          ! new value closer to end than original value to start
          ! use new value
          x = xt
        else
          ! original value closer to start than new value to end
          ! use original value
          x = x_in
        endif
      else
        ! new value in range
        ! use new value
        x = xt
      endif
    elseif (x_in .lt. xx(n)) then
      ! original value less than end, therefore add period
      xt = x_in + period
      if (xt .gt. xx(1)) then
        ! new value greater than start
        if (abs(xt - xx(1)) .lt. abs(x_in - xx(n))) then
          ! new value closer to start than original value to end
          ! use new value
          x = xt
        else
          ! original value closer to end than new value to start
          ! use original value
          x = x_in
        endif
      else
        ! new value in range
        ! use new value
        x = xt
      endif
    else
      ! original value in range
      ! use original value
      x = x_in
    endif
  endif
else
  ! no period specified
  ! use original value
  x = x_in
endif

jl = 0
ju = n+1
10 continue
if (ju - jl .gt. 1) then
  jm = (ju + jl) / 2
  if (increasing .eqv. (x .gt. xx(jm))) then
    jl = jm
  else
    ju = jm
  endif
  go to 10
endif
j = jl

if (present(nearest)) then
  if (nearest) then
    if (j .eq. 0) then
      j = 1
    elseif (j .lt. n) then
      if (abs(x - xx(j)) .gt. abs(x - xx(j+1))) then
        j = j + 1
      endif
    endif
  endif
endif

return
end subroutine  locate
! </SUBROUTINE> NAME="locate"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_biotic_bbc">
!
! <DESCRIPTION>
!     calculate the surface boundary conditions
! </DESCRIPTION>
!
subroutine ocmip2_biotic_bbc(isc, iec, jsc, jec, isd, ied, jsd, jed, T_prog, grid_kmt)

integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
type(ocean_prog_tracer_type), intent(inout), dimension(:)       :: T_prog
integer, dimension(isd:,jsd:), intent(in)                       :: grid_kmt

integer  :: i, j, n, kz

!   set the bottom flux of the column for phosphate to reflect a
!   regenerative flux from the sediments where the compensation
!   depth is greater than the bottom depth
do n = 1, instances
  do j = jsc, jec
    do i = isc, iec
      kz = grid_kmt(i,j)
      if (kz .lt. biotic(n)%km_c .and. kz .gt. 0) then
        t_prog(biotic(n)%ind_po4)%btf(i,j) =                    &
             -biotic(n)%flux_poc(i,j)
        t_prog(biotic(n)%ind_o2)%btf(i,j)  =                    &
             biotic(n)%o_2_p * biotic(n)%flux_poc(i,j)
        t_prog(biotic(n)%ind_dic)%btf(i,j) =                    &
             -(biotic(n)%c_2_p * (1.0 + biotic(n)%caco3_2_c) *  &
             biotic(n)%flux_poc(i,j))
        t_prog(biotic(n)%ind_alk)%btf(i,j) =                    &
             (biotic(n)%n_2_p - 2.0 * biotic(n)%c_2_p *         &
             biotic(n)%caco3_2_c) * biotic(n)%flux_poc(i,j)
      endif
    enddo
  enddo
enddo

return

end subroutine  ocmip2_biotic_bbc
! </SUBROUTINE> NAME="ocmip2_biotic_bbc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_biotic_end">
!
! <DESCRIPTION>
!     Clean up various BIOTIC quantities for this run.
! </DESCRIPTION>
!
subroutine ocmip2_biotic_end(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,        &
     T_prog, grid_dat, grid_tmask, mpp_domain2d, rho_dzt, taup1)
integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
type(ocean_prog_tracer_type), intent(in), dimension(:)  :: T_prog
integer, intent(in)                                     :: taup1
real, dimension(isd:,jsd:), intent(in)                  :: grid_dat
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask
type(domain2d), intent(in)                              :: mpp_domain2d
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho_dzt

character(len=64), parameter    :: sub_name = 'ocmip2_biotic_end'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer                                 :: i, j, k, n
character(len=fm_field_name_len+1)      :: suffix
real                                    :: total_alkalinity
real                                    :: total_dic
real                                    :: total_dop
real                                    :: total_o2
real                                    :: total_phosphate

  integer :: stdoutunit 
  stdoutunit=stdout() 

! integrate the total concentrations of some tracers
! for the end of the run
total_phosphate = 0.0
total_dop = 0.0
total_o2 = 0.0
total_dic = 0.0
total_alkalinity = 0.0

!       Use taup1 time index for the start of a run, and taup1 time
!       index for the end of a run so that we are integrating the
!       same time level and should therefore get identical results
write (stdoutunit,*) trim(note_header),                           &
     'Global integrals at end of run'

do n = 1, instances
  do k = 1,nk
    do j = jsc, jec
      do i = isc, iec
        total_phosphate = total_phosphate +                     &
             t_prog(biotic(n)%ind_po4)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_dop = total_dop +                                 &
             t_prog(biotic(n)%ind_dop)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_o2 = total_o2 +                                   &
             t_prog(biotic(n)%ind_o2)%field(i,j,k,taup1) *      &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_dic = total_dic +                                 &
             t_prog(biotic(n)%ind_dic)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_alkalinity = total_alkalinity +                   &
             t_prog(biotic(n)%ind_alk)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo

  call mpp_sum(total_phosphate)
  call mpp_sum(total_dop)
  call mpp_sum(total_o2)
  call mpp_sum(total_dic)
  call mpp_sum(total_alkalinity)

  write (stdoutunit,*) '  Instance ', trim(biotic(n)%name)
  write (stdoutunit,                                              &
       '(/'' Total phosphate  = '',es19.12,'' Gmol'')')         &
       total_phosphate * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total DOP  = '',es19.12,'' Gmol'')')               &
       total_DOP * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total O2  = '',es19.12,'' Gmol'')')                &
       total_o2 * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total DIC  = '',es19.12,'' Gmol'')')               &
       total_dic * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total alkalinity  = '',es19.12,'' Geq'')')         &
       total_alkalinity * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total phosphorous  = '',es19.12,'' Gmol'')')       &
       (total_phosphate + total_dop) * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total real O2  = '',es19.12,'' Gmol'')')           &
       (total_o2 + biotic(n)%o_2_p * total_phosphate) * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total Carbon  = '',es19.12,'' Gmol'')')            &
       (total_dic + biotic(n)%c_2_p * total_dop) * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total real alkalinity  = '',es19.12,'' Geq'')')    &
       (total_alkalinity + biotic(n)%n_2_p * total_phosphate) * 1.0e-09
enddo

! save out additional information for a restart

write(stdoutunit,*)
call ocmip2_biotic_restart

do n = 1, instances

  write(stdoutunit,*) trim(note_header),                          &
       'Writing additional restart information for instance ',  &
       trim(biotic(n)%name)

  write (stdoutunit,*) trim(note_header),                         &
       'Done writing additional restart information for instance ',&
       trim(biotic(n)%name)

enddo

return
end subroutine  ocmip2_biotic_end
! </SUBROUTINE> NAME="ocmip2_biotic_end"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_biotic_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocmip2_biotic_restart(time_stamp)
  character(len=*),             intent(in), optional :: time_stamp
  integer :: n

  do n=1, num_restart
     call save_restart(restart(n), time_stamp)
  end do

end subroutine ocmip2_biotic_restart
! </SUBROUTINE> NAME="ocmip2_biotic_restart"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_biotic_sbc">
!
! <DESCRIPTION>
!     Calculate the surface boundary conditions
! </DESCRIPTION>
subroutine ocmip2_biotic_sbc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,        &
     isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                                        &
     T_prog, taum1, Grid, Time, ice_ocean_boundary_fluxes)

integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: nk
integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
integer, intent(in)                                             :: isc_bnd
integer, intent(in)                                             :: iec_bnd
integer, intent(in)                                             :: jsc_bnd
integer, intent(in)                                             :: jec_bnd
type(ocean_prog_tracer_type), intent(inout), dimension(:)       :: T_prog
integer, intent(in)                                             :: taum1
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time
type(coupler_2d_bc_type), intent(in)                            :: ice_ocean_boundary_fluxes

integer :: i, j, n
logical :: used

!     use the surface fluxes from the coupler
!       stf is in mol/m^2/s, flux from coupler is positive upwards
do n = 1, instances
  t_prog(biotic(n)%ind_dic)%stf(isc:iec,jsc:jec) =                      &
        -ice_ocean_boundary_fluxes%bc(biotic(n)%ind_co2_flux)%field(ind_flux)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd)
  t_prog(biotic(n)%ind_o2)%stf(isc:iec,jsc:jec) =                       &
        -ice_ocean_boundary_fluxes%bc(biotic(n)%ind_o2_flux)%field(ind_flux)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd)
enddo

! Save variables for diagnostics
do n = 1, instances
   call diagnose_2d(Time, Grid, biotic(n)%id_sfc_flux_co2, t_prog(biotic(n)%ind_dic)%stf(:,:))
   call diagnose_2d(Time, Grid, biotic(n)%id_sfc_flux_o2, t_prog(biotic(n)%ind_o2)%stf(:,:))
enddo

return

end subroutine  ocmip2_biotic_sbc
! </SUBROUTINE> NAME="ocmip2_biotic_sbc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_biotic_flux_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the ocean-atmosphere gas fluxes
! </DESCRIPTION>

subroutine ocmip2_biotic_flux_init

use atmos_ocean_fluxes_mod, only: aof_set_coupler_flux

character(len=64), parameter    :: sub_name = 'ocmip2_biotic_flux_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=256)                                      :: caller_str

  integer :: stdoutunit 
  stdoutunit=stdout() 

!       First, perform some initialization if this module has not been
!       initialized because the normal initialization routine will
!       not have been called as part of the normal ocean model
!       initialization if this is an Atmosphere pe of a coupled
!       model running in concurrent mode
if (.not. module_initialized) then

   ! Initialize the package
  package_index = otpm_set_tracer_package(package_name,            &
       restart_file = default_restart_file,                        &              
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')

  ! Check whether to use this package
  path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
  instances = fm_get_length(path_to_names)
  if (instances .lt. 0) then
    call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
  endif

  ! Check some things
  write (stdoutunit,*)
  if (instances .eq. 0) then
    write (stdoutunit,*) trim(note_header), ' No instances'
    do_ocmip2_biotic = .false.
  else
    if (instances .eq. 1) then
      write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
    else
      write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
    endif
    do_ocmip2_biotic = .true.
  endif

  module_initialized = .true.

endif

! Return if we don't want to use this package
if (.not. do_ocmip2_biotic) then
  return
endif

if (.not. allocated(biotic)) then

   ! allocate storage for biotic array
  allocate ( biotic(instances) )

  ! loop over the names, saving them into the biotic array
  do n = 1, instances

    if (fm_get_value(path_to_names, name, index = n)) then
      biotic(n)%name = name
    else
      write (name,*) n
      call mpp_error(FATAL, trim(error_header) //        &
           'Bad field name for index ' // trim(name))
    endif

  enddo

endif

! Set up the ocean-atmosphere gas flux fields
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

  name = biotic(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
  else
    suffix = '_' // name
  endif

  ! Coupler fluxes
  biotic(n)%ind_co2_flux = aof_set_coupler_flux('co2_flux' // suffix,                           &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',                               &
       mol_wt = WTMCO2, param = (/ 9.36e-07, 9.7561e-06 /),                                                      &
       ice_restart_file = default_ice_restart_file,                                             &
       ocean_restart_file = default_ocean_restart_file,                                         &
       caller = caller_str)

  biotic(n)%ind_o2_flux = aof_set_coupler_flux('o2_flux' // suffix,                             &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',                               &
       mol_wt = WTMO2, param = (/ 9.36e-07, 9.7561e-06 /),                                                      &
       ice_restart_file = default_ice_restart_file,                                             &
       ocean_restart_file = default_ocean_restart_file,                                         &
       caller = caller_str)
enddo

return

end subroutine  ocmip2_biotic_flux_init
!</SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="ocmip2_biotic_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the tracer packages
!
!       Save pointers to various "types", such as Grid and Domains.
! </DESCRIPTION>

subroutine ocmip2_biotic_init

character(len=64), parameter    :: sub_name = 'ocmip2_biotic_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

real, parameter :: rho_avg = 1024.5
real, parameter :: sperd = 24.0 * 3600.0
real, parameter :: spery = 365.25 * sperd

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=fm_field_name_len+3)                      :: long_suffix
logical, dimension(12)                                  :: t_mask
character(len=256)                                      :: caller_str
character(len=fm_string_len), pointer, dimension(:)     :: good_list

  integer :: stdoutunit 
  stdoutunit=stdout() 

  ! Initialize the package
package_index = otpm_set_tracer_package(package_name,            &
     restart_file = default_restart_file,                        &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')

! Check whether to use this package
path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
instances = fm_get_length(path_to_names)
if (instances .lt. 0) then
  call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
endif

! Check some things
write (stdoutunit,*)
if (instances .eq. 0) then
  write (stdoutunit,*) trim(note_header), ' No instances'
  do_ocmip2_biotic = .false.
else
  if (instances .eq. 1) then
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
  else
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
  endif
  do_ocmip2_biotic = .true.
endif

module_initialized = .true.

! Return if we don't want to use this package
if (.not. do_ocmip2_biotic) then
  return
endif

! allocate storage for biotic array
allocate ( biotic(instances) )

! loop over the names, saving them into the biotic array
do n = 1, instances

  if (fm_get_value(path_to_names, name, index = n)) then
    biotic(n)%name = name
  else
    write (name,*) n
    call mpp_error(FATAL, trim(error_header) //        &
         'Bad field name for index ' // trim(name))
  endif

enddo

! Set up the field input
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

  name = biotic(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // name
    long_suffix = ' (' // trim(name) // ')'
  endif

  ! PO4
  biotic(n)%ind_po4 = otpm_set_prog_tracer('po4' // suffix,     &
       package_name,                                            &
       longname = 'Phosphate' // trim(long_suffix),             &
       units = 'mol/m^3', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

  ! DOP
  biotic(n)%ind_dop = otpm_set_prog_tracer('dop' // suffix,     &
       package_name,                                            &
       longname = 'DOP' // trim(long_suffix),                   &
       units = 'mol/m^3', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

  ! DIC
  biotic(n)%ind_dic = otpm_set_prog_tracer('dic' // suffix,     &
       package_name,                                            &
       longname = 'DIC' // trim(long_suffix),                   &
       units = 'mol/m^3', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

  ! O2
  biotic(n)%ind_o2 = otpm_set_prog_tracer('o2' // suffix,       &
       package_name,                                            &
       longname = 'Oxygen' // trim(long_suffix),                &
       units = 'mol/m^3', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

  ! ALK
  biotic(n)%ind_alk = otpm_set_prog_tracer('alk' // suffix,     &
       package_name,                                            &
       longname = 'Alkalinity' // trim(long_suffix),            &
       units = 'mol/m^3', flux_units = 'mol/m^2/s',             &
       caller = caller_str)

enddo

! Process the namelists

! Add the package name to the list of good namelists, to be used
! later for a consistency check
if (fm_new_value('/ocean_mod/GOOD/good_namelists', package_name, append = .true.) .le. 0) then
  call mpp_error(FATAL, trim(error_header) //                           &
       ' Could not add ' // trim(package_name) // ' to "good_namelists" list')
endif

! Set up the *global* namelist
call fm_util_start_namelist(package_name, '*global*', caller = caller_str, no_overwrite = .true., &
     check = .true.)

call fm_util_set_value('po4_star_file', 'INPUT/po4_star_ocmip2.nc')
call fm_util_set_value('po4_star_name', 'po4_star')
call fm_util_set_value('htotal_scale_lo_in', 0.01 )
call fm_util_set_value('htotal_scale_hi_in', 100.0)
call fm_util_set_value('htotal_in', 1.0e-08)

call fm_util_end_namelist(package_name, '*global*', caller = caller_str, check = .true.)

! Set up the instance namelists

t_mask(:) = .true.

do n = 1, instances
   ! create the instance namelist
  call fm_util_start_namelist(package_name, biotic(n)%name, caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('compensation_depth', 75.0)                  ! m
  call fm_util_set_value('add_phosphate', .false.)
  call fm_util_set_value('martin_coeff', 0.9)
  call fm_util_set_value('martin_coeff_alt', 0.0)
  call fm_util_set_value('ca_remin_depth', 3500.0)
  call fm_util_set_value('soft_tissue_pump', .false.)
  call fm_util_set_value('stp_temperature', 10.0)
  call fm_util_set_value('stp_salinity', 34.7)
  call fm_util_set_value('stp_alkalinity', 2370.0 * 1024.5 * 1.0e-06)    ! alkalinity is in ueq/kg, converted to eq/m^3
  call fm_util_set_value('sio2_const', 7.7e-03)                          ! mol/m^3
  call fm_util_set_value('local_restart_file', default_local_restart_file)
  call fm_util_set_value('n_2_p', 16.0)
  call fm_util_set_value('c_2_p', 117.0)
  call fm_util_set_value('o_2_p', 170.0)
  call fm_util_set_value('o2_min', 4.0 * rho_avg * 1.0e-06)
  call fm_util_set_value('bio_tau', 30.0 * sperd)
  call fm_util_set_value('sigma', 0.67)
  call fm_util_set_value('kappa', 1.0 / 0.5 / spery)
  call fm_util_set_value('caco3_2_c', 0.07)

  ! New Wanninkhof numbers
  call fm_util_set_value('sc_co2_0', 2068.9)
  call fm_util_set_value('sc_co2_1', -118.63)
  call fm_util_set_value('sc_co2_2', 2.9311)
  call fm_util_set_value('sc_co2_3', -0.027)
  call fm_util_set_value('sc_o2_0', 1929.7)
  call fm_util_set_value('sc_o2_1', -117.46)
  call fm_util_set_value('sc_o2_2', 3.116)
  call fm_util_set_value('sc_o2_3', -0.0306)

  call fm_util_end_namelist(package_name, biotic(n)%name, check = .true., caller = caller_str)

  ! create some sub-namelists
  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+norm_remin',     &
       caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('factor', 0.0)
  call fm_util_set_value('coastal_only', .false.)
  call fm_util_set_value('t_mask', t_mask, size(t_mask))
  call fm_util_set_value('wlon', 0.0, index = 0)
  call fm_util_set_value('elon', 0.0, index = 0)
  call fm_util_set_value('slat', 0.0, index = 0)
  call fm_util_set_value('nlat', 0.0, index = 0)

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+norm_remin', caller = caller_str)

  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+no_caco3',     &
       caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('factor', 0.0)
  call fm_util_set_value('coastal_only', .false.)
  call fm_util_set_value('t_mask', t_mask, size(t_mask))
  call fm_util_set_value('wlon', 0.0, index = 0)
  call fm_util_set_value('elon', 0.0, index = 0)
  call fm_util_set_value('slat', 0.0, index = 0)
  call fm_util_set_value('nlat', 0.0, index = 0)

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+no_caco3', caller = caller_str)

  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+nut_depl',     &
       caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('factor', 0.0)
  call fm_util_set_value('coastal_only', .false.)
  call fm_util_set_value('t_mask', t_mask, size(t_mask))
  call fm_util_set_value('wlon', 0.0, index = 0)
  call fm_util_set_value('elon', 0.0, index = 0)
  call fm_util_set_value('slat', 0.0, index = 0)
  call fm_util_set_value('nlat', 0.0, index = 0)

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+nut_depl', caller = caller_str)

  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+r_bio_tau_a',     &
       caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('factor', 0.0)
  call fm_util_set_value('coastal_only', .false.)
  call fm_util_set_value('t_mask', t_mask, size(t_mask))
  call fm_util_set_value('wlon', 0.0, index = 0)
  call fm_util_set_value('elon', 0.0, index = 0)
  call fm_util_set_value('slat', 0.0, index = 0)
  call fm_util_set_value('nlat', 0.0, index = 0)

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+r_bio_tau_a', caller = caller_str)

enddo

! Check for any errors in the number of fields in the namelists for this package
good_list => fm_util_get_string_array('/ocean_mod/GOOD/namelists/' // trim(package_name) // '/good_values',   &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
if (associated(good_list)) then
  call fm_util_check_for_bad_fields('/ocean_mod/namelists/' // trim(package_name), good_list,       &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')
  deallocate(good_list)
else
  call mpp_error(FATAL,trim(error_header) // ' Empty "' // trim(package_name) // '" list')
endif

return

end subroutine ocmip2_biotic_init
! </SUBROUTINE> NAME="ocmip2_biotic_init"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_biotic_init_sfc">
!
! <DESCRIPTION>
!       Initialize surface fields for flux calculations
!
!       Note: this subroutine should be merged into ocmip2_biotic_start
! </DESCRIPTION>
subroutine ocmip2_biotic_init_sfc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,   &
     isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                                        &
     Ocean_fields, T_prog, rho, taum1, model_time, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: iec_bnd
integer, intent(in)                                     :: jsc_bnd
integer, intent(in)                                     :: jec_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho
integer, intent(in)                                     :: taum1
type(time_type), intent(in)                             :: model_time
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer         :: i, j, n
integer         :: ind
real            :: epsln=1.0e-30

do n = 1, instances

  ! CO2 flux
  ind = biotic(n)%ind_co2_flux
  if (.not. field_exist('INPUT/'//trim(Ocean_fields%bc(ind)%ocean_restart_file),    &
                        Ocean_fields%bc(ind)%field(ind_alpha)%name)) then

    call ocmip2_co2calc(isd, jsd, isc, iec, jsc, jec,         &
         grid_tmask(isd:ied,jsd:jed,1),                                 &
         t_prog(indtemp)%field(isd:ied,jsd:jed,1,taum1),                &
         t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1),                 &
         t_prog(biotic(n)%ind_dic)%field(isd:ied,jsd:jed,1,taum1),      &
         t_prog(biotic(n)%ind_alk)%field(isd:ied,jsd:jed,1,taum1),      &
         t_prog(biotic(n)%ind_po4)%field(isd:ied,jsd:jed,1,taum1),      &
         biotic(n)%sio2,                                                &
         htotal_scale_lo, htotal_scale_hi, biotic(n)%htotal,            &
         co2star = biotic(n)%csurf, alpha = biotic(n)%alpha,            &
         pco2surf = biotic(n)%pco2surf)

    !  Compute the Schmidt number of CO2 in seawater using the 
    !  formulation presented by Wanninkhof (1992, J. Geophys. Res., 97,
    !  7373-7382).
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%sc_co2(i,j) =                                                 &
             biotic(n)%sc_co2_0 + t_prog(indtemp)%field(i,j,1,taum1) *          &
             (biotic(n)%sc_co2_1 + t_prog(indtemp)%field(i,j,1,taum1) *         &
              (biotic(n)%sc_co2_2 + t_prog(indtemp)%field(i,j,1,taum1) *        &
               biotic(n)%sc_co2_3)) * grid_tmask(i,j,1)
        sc_no_term(i,j) = sqrt(660.0 / (biotic(n)%sc_co2(i,j) + epsln))
      enddo
    enddo
    Ocean_fields%bc(ind)%field(ind_alpha)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) =   &
         biotic(n)%alpha(isc:iec,jsc:jec) * rho(isc:iec,jsc:jec,1,taum1) * sc_no_term(isc:iec,jsc:jec)
    Ocean_fields%bc(ind)%field(ind_csurf)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) =   &
         biotic(n)%csurf(isc:iec,jsc:jec) * rho(isc:iec,jsc:jec,1,taum1) * sc_no_term(isc:iec,jsc:jec)

  endif

  ! O2 flux
  ind = biotic(n)%ind_o2_flux
  if (.not. field_exist('INPUT/'//trim(Ocean_fields%bc(ind)%ocean_restart_file),    &
                        Ocean_fields%bc(ind)%field(ind_alpha)%name)) then

!  Compute the oxygen saturation concentration at 1 atm total
!  pressure in mol/m^3 given the temperature (t, in deg C) and
!  the salinity (s, in permil)
!
!  From Garcia and Gordon (1992), Limnology and Oceonography.
!  The formula used is from page 1310, eq (8).
!
!  *** Note: the "a3*ts^2" term (in the paper) is incorrect. ***
!  *** It shouldn't be there.                                ***
!
!  o2_saturation is defined between T(freezing) <= T <= 40 deg C and
!                                   0 permil <= S <= 42 permil
!
! check value: T = 10 deg C, S = 35 permil,
!              o2_saturation = 0.282015 mol/m^3
    do j = jsc, jec
      do i = isc, iec
        tt(i) = 298.15 - t_prog(indtemp)%field(i,j,1,taum1)
        tk(i) = 273.15 + t_prog(indtemp)%field(i,j,1,taum1)
        ts(i) = log(tt(i) / tk(i))
        ts2(i) = ts(i) * ts(i)
        ts3(i) = ts2(i) * ts(i)
        ts4(i) = ts3(i) * ts(i)
        ts5(i) = ts4(i) * ts(i)
        o2_saturation(i,j) =                                            &
             exp(a_0 + a_1*ts(i) + a_2*ts2(i) +                         &
                 a_3*ts3(i) + a_4*ts4(i) + a_5*ts5(i) +                 &
                 t_prog(indsal)%field(i,j,1,taum1) *                    &
                 (b_0 + b_1*ts(i) + b_2*ts2(i) + b_3*ts3(i) +           &
                  c_0*t_prog(indsal)%field(i,j,1,taum1)))
      enddo
    enddo

    ! convert from ml/l to mol/m^3
    do j = jsc, jec
      do i = isc, iec
        o2_saturation(i,j) = o2_saturation(i,j) * (1000.0/22391.6)
      enddo
    enddo

    !  Compute the Schmidt number of O2 in seawater using the 
    !  formulation proposed by Keeling et al. (1998, Global Biogeochem.
    !  Cycles, 12, 141-163).
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%sc_o2(i,j) =                                                  &
             biotic(n)%sc_o2_0 + t_prog(indtemp)%field(i,j,1,taum1) *           &
             (biotic(n)%sc_o2_1 + t_prog(indtemp)%field(i,j,1,taum1) *          &
              (biotic(n)%sc_o2_2 + t_prog(indtemp)%field(i,j,1,taum1) *         &
               biotic(n)%sc_o2_3)) * grid_tmask(i,j,1)
        sc_no_term(i,j) = sqrt(660.0 / (biotic(n)%sc_o2(i,j) + epsln))
      enddo
    enddo
    Ocean_fields%bc(ind)%field(ind_alpha)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) =           &
         o2_saturation(isc:iec,jsc:jec) * sc_no_term(isc:iec,jsc:jec)
    Ocean_fields%bc(ind)%field(ind_csurf)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) =           &
         t_prog(biotic(n)%ind_o2)%field(isc:iec,jsc:jec,1,taum1) * rho(isc:iec,jsc:jec,1,taum1) * sc_no_term(isc:iec,jsc:jec)

  endif
enddo

return

end subroutine ocmip2_biotic_init_sfc
! </SUBROUTINE> NAME="ocmip2_biotic_init_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_biotic_sum_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>
subroutine ocmip2_biotic_sum_sfc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,    &
     isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                                        &
     Ocean_fields, T_prog, rho, taum1, model_time, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: iec_bnd
integer, intent(in)                                     :: jsc_bnd
integer, intent(in)                                     :: jec_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
type(ocean_prog_tracer_type), intent(in), dimension(:)  :: T_prog
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho
integer, intent(in)                                     :: taum1
type(time_type), intent(in)                             :: model_time
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer         :: i, j, n
integer         :: ind
real            :: epsln=1.0e-30

do n = 1, instances

    ind = biotic(n)%ind_co2_flux

    call ocmip2_co2calc(isd, jsd, isc, iec, jsc, jec,         &
         grid_tmask(isd:ied,jsd:jed,1),                                 &
         t_prog(indtemp)%field(isd:ied,jsd:jed,1,taum1),                &
         t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1),                 &
         t_prog(biotic(n)%ind_dic)%field(isd:ied,jsd:jed,1,taum1),      &
         t_prog(biotic(n)%ind_alk)%field(isd:ied,jsd:jed,1,taum1),      &
         t_prog(biotic(n)%ind_po4)%field(isd:ied,jsd:jed,1,taum1),      &
         biotic(n)%sio2,                                                &
         htotal_scale_lo, htotal_scale_hi, biotic(n)%htotal,            &
         co2star = biotic(n)%csurf, alpha = biotic(n)%alpha,            &
         pco2surf = biotic(n)%pco2surf)

    !  Compute the Schmidt number of CO2 in seawater using the 
    !  formulation presented by Wanninkhof (1992, J. Geophys. Res., 97,
    !  7373-7382).
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%sc_co2(i,j) =                                                 &
             biotic(n)%sc_co2_0 + t_prog(indtemp)%field(i,j,1,taum1) *          &
             (biotic(n)%sc_co2_1 + t_prog(indtemp)%field(i,j,1,taum1) *         &
              (biotic(n)%sc_co2_2 + t_prog(indtemp)%field(i,j,1,taum1) *        &
               biotic(n)%sc_co2_3)) * grid_tmask(i,j,1)
        sc_no_term(i,j) = sqrt(660.0 / (biotic(n)%sc_co2(i,j) + epsln))
      enddo
    enddo
    Ocean_fields%bc(ind)%field(ind_alpha)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) =           &
         Ocean_fields%bc(ind)%field(ind_alpha)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) +      &
         biotic(n)%alpha(isc:iec,jsc:jec) * rho(isc:iec,jsc:jec,1,taum1) * sc_no_term(isc:iec,jsc:jec)
    Ocean_fields%bc(ind)%field(ind_csurf)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) =           &
         Ocean_fields%bc(ind)%field(ind_csurf)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) +      &
         biotic(n)%csurf(isc:iec,jsc:jec) * rho(isc:iec,jsc:jec,1,taum1) * sc_no_term(isc:iec,jsc:jec)

    ind = biotic(n)%ind_o2_flux

!  Compute the oxygen saturation concentration at 1 atm total
!  pressure in mol/m^3 given the temperature (t, in deg C) and
!  the salinity (s, in permil)
!
!  From Garcia and Gordon (1992), Limnology and Oceonography.
!  The formula used is from page 1310, eq (8).
!
!  *** Note: the "a3*ts^2" term (in the paper) is incorrect. ***
!  *** It shouldn't be there.                                ***
!
!  o2_saturation is defined between T(freezing) <= T <= 40 deg C and
!                                   0 permil <= S <= 42 permil
!
! check value: T = 10 deg C, S = 35 permil,
!              o2_saturation = 0.282015 mol/m^3
    do j = jsc, jec
      do i = isc, iec
        tt(i) = 298.15 - t_prog(indtemp)%field(i,j,1,taum1)
        tk(i) = 273.15 + t_prog(indtemp)%field(i,j,1,taum1)
        ts(i) = log(tt(i) / tk(i))
        ts2(i) = ts(i) * ts(i)
        ts3(i) = ts2(i) * ts(i)
        ts4(i) = ts3(i) * ts(i)
        ts5(i) = ts4(i) * ts(i)
        o2_saturation(i,j) =                                        &
             exp(a_0 + a_1*ts(i) + a_2*ts2(i) +                     &
                 a_3*ts3(i) + a_4*ts4(i) + a_5*ts5(i) +             &
                 t_prog(indsal)%field(i,j,1,taum1) *                &
                 (b_0 + b_1*ts(i) + b_2*ts2(i) + b_3*ts3(i) +       &
                  c_0*t_prog(indsal)%field(i,j,1,taum1)))
      enddo
    enddo

    ! convert from ml/l to mol/m^3
    do j = jsc, jec
      do i = isc, iec
        o2_saturation(i,j) = o2_saturation(i,j) * (1000.0/22391.6)
      enddo
    enddo

    !  Compute the Schmidt number of O2 in seawater using the 
    !  formulation proposed by Keeling et al. (1998, Global Biogeochem.
    !  Cycles, 12, 141-163).
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%sc_o2(i,j) =                                                    &
             biotic(n)%sc_o2_0 + t_prog(indtemp)%field(i,j,1,taum1) *           &
             (biotic(n)%sc_o2_1 + t_prog(indtemp)%field(i,j,1,taum1) *          &
              (biotic(n)%sc_o2_2 + t_prog(indtemp)%field(i,j,1,taum1) *         &
               biotic(n)%sc_o2_3)) * grid_tmask(i,j,1)
        sc_no_term(i,j) = sqrt(660.0 / (biotic(n)%sc_o2(i,j) + epsln))
      enddo
    enddo
    Ocean_fields%bc(ind)%field(ind_alpha)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) =           &
         Ocean_fields%bc(ind)%field(ind_alpha)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) +      &
         o2_saturation(isc:iec,jsc:jec) * sc_no_term(isc:iec,jsc:jec)
    Ocean_fields%bc(ind)%field(ind_csurf)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) =           &
         Ocean_fields%bc(ind)%field(ind_csurf)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) +      &
         t_prog(biotic(n)%ind_o2)%field(isc:iec,jsc:jec,1,taum1) * rho(isc:iec,jsc:jec,1,taum1) * sc_no_term(isc:iec,jsc:jec)

enddo

return

end subroutine ocmip2_biotic_sum_sfc
! </SUBROUTINE> NAME="ocmip2_biotic_sum_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_biotic_zero_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>

subroutine ocmip2_biotic_zero_sfc(Ocean_fields)

type(coupler_2d_bc_type), intent(inout) :: Ocean_fields

integer         :: n
integer         :: ind

do n = 1, instances

  ind = biotic(n)%ind_co2_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0

  ind = biotic(n)%ind_o2_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0

enddo

return

end subroutine ocmip2_biotic_zero_sfc
! </SUBROUTINE> NAME="ocmip2_biotic_zero_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_biotic_avg_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>
subroutine ocmip2_biotic_avg_sfc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,    &
     isc_bnd, iec_bnd, jsc_bnd, jec_bnd, Ocean_fields, Ocean_avg_kount, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: iec_bnd
integer, intent(in)                                     :: jsc_bnd
integer, intent(in)                                     :: jec_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
integer                                                 :: Ocean_avg_kount
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer         :: n
integer         :: ind
real            :: divid

divid = 1./float(Ocean_avg_kount)

do n = 1, instances

  ind = biotic(n)%ind_co2_flux

  where (grid_tmask(isc:iec,jsc:jec,1) == 1.0)
    Ocean_fields%bc(ind)%field(ind_alpha)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) =           &
         Ocean_fields%bc(ind)%field(ind_alpha)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) * divid
    Ocean_fields%bc(ind)%field(ind_csurf)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) =           &
         Ocean_fields%bc(ind)%field(ind_csurf)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) * divid
  endwhere

  ind = biotic(n)%ind_o2_flux

  where (grid_tmask(isc:iec,jsc:jec,1) == 1.0)
    Ocean_fields%bc(ind)%field(ind_alpha)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) =           &
         Ocean_fields%bc(ind)%field(ind_alpha)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) * divid
    Ocean_fields%bc(ind)%field(ind_csurf)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) =           &
         Ocean_fields%bc(ind)%field(ind_csurf)%values(isc_bnd:iec_bnd,jsc_bnd:jec_bnd) * divid
  endwhere

enddo

return

end subroutine ocmip2_biotic_avg_sfc
! </SUBROUTINE> NAME="ocmip2_biotic_avg_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_biotic_sfc_end">
!
! <DESCRIPTION>
!       Initialize surface fields for flux calculations
! </DESCRIPTION>

subroutine ocmip2_biotic_sfc_end

end subroutine ocmip2_biotic_sfc_end
! </SUBROUTINE> NAME="ocmip2_biotic_sfc_end"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_biotic_source">
!
! <DESCRIPTION>
!     compute the source terms for the BIOTICs, including boundary
!     conditions (not done in setvbc, to minimize number
!     of hooks required in MOM base code)
! </DESCRIPTION>
!
subroutine ocmip2_biotic_source(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,     &
     T_prog, taum1, grid_zw, grid_ht, grid_tmask, Grid, Time, rho_dzt)
integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: nk
integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
type(ocean_prog_tracer_type), intent(inout), dimension(:)       :: T_prog
integer, intent(in)                                             :: taum1
real, dimension(nk), intent(in)                                 :: grid_zw
real, dimension(isd:,jsd:), intent(in)                          :: grid_ht
real, dimension(isd:,jsd:,:), intent(in)                        :: grid_tmask
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time
real, dimension(isd:,jsd:,:,:), intent(in)                      :: rho_dzt

integer :: i, j, k, n
integer :: ind_po4
integer :: ind_dop
integer :: ind_dic
integer :: ind_alk
integer :: ind_o2
integer :: km_c
logical :: used
integer :: day
integer :: month
integer :: year
integer :: hour
integer :: minute
integer :: second

  integer :: stdoutunit 
  stdoutunit=stdout() 

! get the model month
call get_date(Time%model_time, year, month, day,                &
              hour, minute, second)

! calculate the source terms for BIOTICs

! calculate interpolated PO4_star
call time_interp_external(po4_star_id, Time%model_time, po4_star_t)

! Loop over multiple instances
do n = 1, instances

  ind_po4 = biotic(n)%ind_po4
  ind_dic = biotic(n)%ind_dic
  ind_dop = biotic(n)%ind_dop
  ind_o2 = biotic(n)%ind_o2
  ind_alk = biotic(n)%ind_alk
  km_c = biotic(n)%km_c

  ! Production

  ! compute PO4 restoring term and correct for partial
  ! production in the bottom box
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        if (t_prog(ind_po4)%field(i,j,k,taum1) .gt.             &
            po4_star_t(i,j,k) *                                 &
            biotic(n)%nut_depl%mask(i,j,month)) then
          biotic(n)%jprod(i,j,k) =                              &
               (t_prog(ind_po4)%field(i,j,k,taum1) -            &
                po4_star_t(i,j,k) *                             &
                biotic(n)%nut_depl%mask(i,j,month)) *           &
               biotic(n)%r_bio_tau_a%mask(i,j,month) * grid_tmask(i,j,k)
        else
          biotic(n)%jprod(i,j,k) = 0.0
        endif
      enddo
    enddo
  enddo

  do j = jsc, jec
    do i = isc, iec
      biotic(n)%jprod(i,j,km_c) = biotic(n)%jprod(i,j,km_c) *   &
           (min(grid_ht(i,j),biotic(n)%compensation_depth) - grid_zw(km_c-1)) /   &
           rho_dzt(i,j,km_c,taum1)
    enddo
  enddo

  ! Normal production (used to maintain PO4 concentrations assuming no
  ! other changes)
  if (biotic(n)%add_phosphate) then
    ! compute PO4 restoring term and correct for partial
    ! production in the bottom box
    do k = 1, km_c
      do j = jsc, jec
        do i = isc, iec
          if (t_prog(ind_po4)%field(i,j,k,taum1) .gt.           &
              po4_star_t(i,j,k)) then
            biotic(n)%jprod_norm(i,j,k) =                       &
                 (t_prog(ind_po4)%field(i,j,k,taum1) -          &
                  po4_star_t(i,j,k)) *                          &
                 biotic(n)%r_bio_tau * grid_tmask(i,j,k)
          else
            biotic(n)%jprod_norm(i,j,k) = 0.0
          endif
        enddo
      enddo
    enddo

    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jprod_norm(i,j,km_c) =                        &
             biotic(n)%jprod_norm(i,j,km_c) *                   &
             (min(grid_ht(i,j),biotic(n)%compensation_depth) - grid_zw(km_c-1)) / &
             rho_dzt(i,j,km_c,taum1)
      enddo
    enddo
  endif

  ! Particle flux
  do j = jsc, jec
    do i = isc, iec
      biotic(n)%flux_poc(i,j) = (1.0 - biotic(n)%sigma) *       &
           biotic(n)%jprod(i,j,1) * rho_dzt(i,j,1,taum1)
    enddo
  enddo

  do k = 2, km_c
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%flux_poc(i,j) = biotic(n)%flux_poc(i,j) +     &
             (1.0 - biotic(n)%sigma) * biotic(n)%jprod(i,j,k) * &
             rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  ! calculate the flux at the base of each layer below the
  ! compensation depth
  do k = km_c, nk
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%fc(i,j,k) = biotic(n)%flux_poc(i,j) *         &
             grid_tmask(i,j,k) *                                &
             (biotic(n)%norm_remin%mask(i,j,month) *            &
              biotic(n)%zforg(k) +                              &
              (1.0 - biotic(n)%norm_remin%mask(i,j,month)) *    &
              biotic(n)%zforg_alt(k))
      enddo
    enddo
  enddo

  ! Calcium Carbonate

  ! calculate the formation of CaCO3 above the compensation
  ! depth
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jca(i,j,k) =                                  &
             -biotic(n)%caco3_2_c * biotic(n)%c_2_p *           &
             (1.0 - biotic(n)%sigma) *                          &
             biotic(n)%jprod(i,j,k) * grid_tmask(i,j,k) *       &
             biotic(n)%no_caco3%mask(i,j,month)
      enddo
    enddo
  enddo

  ! calculate the flux of CaCO3 at compensation depth and at
  ! bottom of each level below
  do j = jsc, jec
    do i = isc, iec
      biotic(n)%flux_caco3(i,j) =                               &
           biotic(n)%caco3_2_c * biotic(n)%c_2_p *              &
           biotic(n)%flux_poc(i,j) * biotic(n)%no_caco3%mask(i,j,month)
    enddo
  enddo

  do k=km_c,nk
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%fca(i,j,k) = biotic(n)%flux_caco3(i,j) *      &
             biotic(n)%zfca(k) * grid_tmask(i,j,k)
      enddo
    enddo
  enddo

  ! calculate the dissolution of CaCO3 below the compensation
  ! depth
  do j = jsc, jec
    do i = isc, iec
      biotic(n)%jca(i,j,km_c) = biotic(n)%jca(i,j,km_c) +       &
           (biotic(n)%flux_caco3(i,j) * grid_tmask(i,j,km_c) -  &
            biotic(n)%fca(i,j,km_c) * grid_tmask(i,j,km_c+1)) / &
           rho_dzt(i,j,km_c,taum1)
    enddo
  enddo

  do k = km_c + 1, nk - 1
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jca(i,j,k) =                                  &
             (biotic(n)%fca(i,j,k-1) * grid_tmask(i,j,k) -      &
              biotic(n)%fca(i,j,k) * grid_tmask(i,j,k+1)) / rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  do j = jsc, jec
    do i = isc, iec
      biotic(n)%jca(i,j,nk) = biotic(n)%fca(i,j,nk-1) *         &
           grid_tmask(i,j,nk) / rho_dzt(i,j,nk,taum1)
    enddo
  enddo

  ! PO4
  if (biotic(n)%add_phosphate) then
    do k = 1, km_c
      do j = jsc, jec
        do i = isc, iec
          biotic(n)%jpo4_add(i,j,k) =                           &
               biotic(n)%jprod(i,j,k) - biotic(n)%jprod_norm(i,j,k)
        enddo
      enddo
    enddo
  endif

  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jpo4(i,j,k) = -biotic(n)%jprod(i,j,k) +       &
             biotic(n)%kappa * t_prog(ind_dop)%field(i,j,k,taum1)
      enddo
    enddo
  enddo

  do j = jsc, jec
    do i = isc, iec
      biotic(n)%jpo4(i,j,km_c) = biotic(n)%jpo4(i,j,km_c) +     &
           (biotic(n)%flux_poc(i,j) * grid_tmask(i,j,km_c) -    &
            biotic(n)%fc(i,j,km_c) * grid_tmask(i,j,km_c+1)) /  &
           rho_dzt(i,j,km_c,taum1)
    enddo
  enddo

  do k = km_c + 1, nk - 1
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jpo4(i,j,k) =                                 &
             (biotic(n)%fc(i,j,k-1) * grid_tmask(i,j,k) -       &
              biotic(n)%fc(i,j,k) * grid_tmask(i,j,k+1)) /      &
             rho_dzt(i,j,k,taum1) +                              &
             biotic(n)%kappa * t_prog(ind_dop)%field(i,j,k,taum1)
      enddo
    enddo
  enddo

  do j = jsc, jec
    do i = isc, iec
      biotic(n)%jpo4(i,j,nk) =                                  &
           biotic(n)%fc(i,j,nk-1) * grid_tmask(i,j,nk) /        &
           rho_dzt(i,j,nk,taum1) +                               &
           biotic(n)%kappa * t_prog(ind_dop)%field(i,j,nk,taum1)
    enddo
  enddo

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_po4)%th_tendency(i,j,k) =                         &
             t_prog(ind_po4)%th_tendency(i,j,k) +                    &
             biotic(n)%jpo4(i,j,k) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  if (biotic(n)%add_phosphate) then
    do k = 1, km_c
      do j = jsc, jec
        do i = isc, iec
          t_prog(ind_po4)%th_tendency(i,j,k) =                       &
               t_prog(ind_po4)%th_tendency(i,j,k) +                  &
               biotic(n)%jpo4_add(i,j,k) * rho_dzt(i,j,k,taum1)
        enddo
      enddo
    enddo
  endif

  ! DOP
  do k = 1, km_c
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jdop(i,j,k) =                                 &
             biotic(n)%sigma * biotic(n)%jprod(i,j,k) -         &
             biotic(n)%kappa * t_prog(ind_dop)%field(i,j,k,taum1)
      enddo
    enddo
  enddo

  do k = km_c + 1, nk
    do j = jsc, jec
      do i = isc, iec
        biotic(n)%jdop(i,j,k) = -biotic(n)%kappa *              &
                                t_prog(ind_dop)%field(i,j,k,taum1)
      enddo
    enddo
  enddo

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_dop)%th_tendency(i,j,k) =                         &
             t_prog(ind_dop)%th_tendency(i,j,k) +                    &
             biotic(n)%jdop(i,j,k) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  ! O2
  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        if (t_prog(ind_o2)%field(i,j,k,taum1) .gt.              &
            biotic(n)%o2_min) then
          biotic(n)%jo2(i,j,k) = -biotic(n)%o_2_p *             &
                                 biotic(n)%jpo4(i,j,k)
        else
          biotic(n)%jo2(i,j,k) = 0.0
        endif
      enddo
    enddo
  enddo

  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_o2)%th_tendency(i,j,k) =                     &
             t_prog(ind_o2)%th_tendency(i,j,k) +                &
             biotic(n)%jo2(i,j,k) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  ! DIC
  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_dic)%th_tendency(i,j,k) =                    &
             t_prog(ind_dic)%th_tendency(i,j,k) +               &
             (biotic(n)%c_2_p * biotic(n)%jpo4(i,j,k) +         &
              biotic(n)%jca(i,j,k)) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

  ! ALK
  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        t_prog(ind_alk)%th_tendency(i,j,k) =                    &
             t_prog(ind_alk)%th_tendency(i,j,k) +               &
             (-biotic(n)%n_2_p * biotic(n)%jpo4(i,j,k) +        &
              2.0 * biotic(n)%jca(i,j,k)) * rho_dzt(i,j,k,taum1)
      enddo
    enddo
  enddo

enddo

! Save variables for diagnostics
call diagnose_2d_comp(Time, Grid, id_o2_sat, o2_saturation(:,:))
do n = 1, instances
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_sc_co2, biotic(n)%sc_co2(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_sc_o2, biotic(n)%sc_o2(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_alpha, biotic(n)%alpha(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_csurf, biotic(n)%csurf(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_pco2surf, biotic(n)%pco2surf(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_flux_poc, biotic(n)%flux_poc(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_flux_caco3, biotic(n)%flux_caco3(:,:))
   call diagnose_2d_comp(Time, Grid, biotic(n)%id_htotal, biotic(n)%htotal(:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jprod, biotic(n)%jprod(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jca, biotic(n)%jca(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jpo4, biotic(n)%jpo4(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jdop, biotic(n)%jdop(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_jo2, biotic(n)%jo2(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_fc, biotic(n)%fc(:,:,:))
   call diagnose_3d_comp(Time, Grid, biotic(n)%id_fca, biotic(n)%fca(:,:,:))
   if (biotic(n)%add_phosphate) then
      if (biotic(n)%id_jpo4_add .gt. 0) then
         used = send_data(biotic(n)%id_jpo4_add,           &
              biotic(n)%jpo4_add(:,:,1:km_c),              &
              Time%model_time, rmask = Grid%tmask(isc:iec,jsc:jec,1:km_c))
      endif
  endif
enddo

return

end subroutine  ocmip2_biotic_source
! </SUBROUTINE> NAME="ocmip2_biotic_source"


!#######################################################################
! <SUBROUTINE NAME="ocmip2_biotic_start">
!
! <DESCRIPTION>
! Initialize variables, read in namelists, calculate constants
! for a given run and allocate diagnostic arrays
! </DESCRIPTION>
subroutine ocmip2_biotic_start(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,      &
     T_prog, taup1, model_time, grid_dat, grid_tmask, grid_kmt,                 &
     grid_xt, grid_yt, grid_zt, grid_zw, grid_dzt, grid_name, grid_tracer_axes, &
     mpp_domain2d, rho_dzt)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
integer, intent(in)                                     :: taup1
type(time_type), intent(in)                             :: model_time
real, dimension(isd:,jsd:), intent(in)                  :: grid_dat
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask
integer, dimension(isd:,jsd:), intent(in)               :: grid_kmt
real, dimension(isd:,jsd:), intent(in)                  :: grid_xt
real, dimension(isd:,jsd:), intent(in)                  :: grid_yt
real, dimension(:), intent(in)                          :: grid_zt
real, dimension(:), intent(in)                          :: grid_zw
real, dimension(:), intent(in)                          :: grid_dzt
character(len=*), intent(in)                            :: grid_name
integer, dimension(3), intent(in)                       :: grid_tracer_axes
type(domain2d), intent(in)                              :: mpp_domain2d
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho_dzt

character(len=64), parameter    :: sub_name = 'ocmip2_biotic_start'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

!       Global values to apply the following inhibitions
!       and depletions
!
!  coastal_only : if true, then only apply the changes in
!                 coastal boxes
!  t_mask_len   : parameter giving the number of elements in
!                 the time mask per year (eg., 12 would
!                 imply monthly)
!  t_mask_array : logical array controlling whether to apply
!                 the following inhibitions and depletions to
!                 each time-period (true means set the masks,
!                 false means use the defaults everywhere)
!  num_reg      : number of regions
!  factor       : factor by which to scale the field
!               : in the selected regions
!  wlon : western longitude of region
!  elon : eastern longitude of region
!  slat : southern latitude of region
!  nlat : northern latitude of region
!  mask(imt,jmt)  : mask array (0.0 - alternate, 1.0 - normal)
!
!       Set up a mask array using wlon,elon,nlat,slat
!       (any box with its lon,lat inside the box bounded by
!       wlon,elon,nlat,slat value in mask set to factor).
!  
integer                                         :: done
integer                                         :: i, j, k, l, n
character(len=fm_field_name_len+1)              :: suffix
character(len=fm_field_name_len+3)              :: long_suffix
character(len=256)                              :: caller_str
integer                                         :: len_w
integer                                         :: len_e
integer                                         :: len_s
integer                                         :: len_n
real                                            :: total_alkalinity
real                                            :: total_dic
real                                            :: total_dop
real                                            :: total_o2
real                                            :: total_phosphate
character(len=fm_string_len), allocatable       :: local_restart_file(:)
integer                                         :: ind
logical                                         :: fld_exist
integer                                         :: id_restart

  integer :: stdoutunit 
  stdoutunit=stdout() 

write(stdoutunit,*) 
write(stdoutunit,*) trim(note_header),                     &
                  'Starting ', trim(package_name), ' module'

! Determine indices for temperature and salinity
indtemp = fm_get_index('/ocean_mod/prog_tracers/temp')
if (indtemp .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the temperature index')
endif

indsal = fm_get_index('/ocean_mod/prog_tracers/salt')
if (indsal .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the salinity index')
endif

! dynamically allocate the global BIOTIC arrays
call allocate_arrays(isc, iec, jsc, jec, nk, isd, ied, jsd, jed)

! save the *global* namelist values
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

call fm_util_start_namelist(package_name, '*global*', caller = caller_str)

po4_star_file      =  fm_util_get_string ('po4_star_file', scalar = .true.)
po4_star_name      =  fm_util_get_string ('po4_star_name', scalar = .true.)
htotal_scale_lo_in =  fm_util_get_real   ('htotal_scale_lo_in', scalar = .true.)
htotal_scale_hi_in =  fm_util_get_real   ('htotal_scale_hi_in', scalar = .true.)
htotal_in          =  fm_util_get_real   ('htotal_in', scalar = .true.)

call fm_util_end_namelist(package_name, '*global*', caller = caller_str)
      
! Open up the PO4 file for restoring
po4_star_id = init_external_field(po4_star_file,                &
                                  po4_star_name,                &
                                  domain = mpp_domain2d)
if (po4_star_id .eq. 0) then
  call mpp_error(FATAL, trim(error_header) //                   &
       'Could not open po4_star file: ' //                      &
       trim(po4_star_file))
endif

! set default values for htotal_scale bounds
htotal_scale_lo(:,:) = htotal_scale_lo_in
htotal_scale_hi(:,:) = htotal_scale_hi_in

! read in the namelists for each instance
do n = 1, instances

  call fm_util_start_namelist(package_name, biotic(n)%name, caller = caller_str)

  biotic(n)%compensation_depth     = fm_util_get_real   ('compensation_depth', scalar = .true.)
  biotic(n)%add_phosphate          = fm_util_get_logical('add_phosphate', scalar = .true.)
  biotic(n)%martin_coeff           = fm_util_get_real   ('martin_coeff', scalar = .true.)
  biotic(n)%martin_coeff_alt       = fm_util_get_real   ('martin_coeff_alt', scalar = .true.)
  biotic(n)%ca_remin_depth         = fm_util_get_real   ('ca_remin_depth', scalar = .true.)
  biotic(n)%soft_tissue_pump       = fm_util_get_logical('soft_tissue_pump', scalar = .true.)
  biotic(n)%stp_temperature        = fm_util_get_real   ('stp_temperature', scalar = .true.)
  biotic(n)%stp_salinity           = fm_util_get_real   ('stp_salinity', scalar = .true.)
  biotic(n)%stp_alkalinity         = fm_util_get_real   ('stp_alkalinity', scalar = .true.)
  biotic(n)%sio2_const             = fm_util_get_real   ('sio2_const', scalar = .true.)
  biotic(n)%local_restart_file     = fm_util_get_string ('local_restart_file', scalar = .true.)
  biotic(n)%n_2_p                  = fm_util_get_real   ('n_2_p', scalar = .true.)
  biotic(n)%c_2_p                  = fm_util_get_real   ('c_2_p', scalar = .true.)
  biotic(n)%o_2_p                  = fm_util_get_real   ('o_2_p', scalar = .true.)
  biotic(n)%o2_min                 = fm_util_get_real   ('o2_min', scalar = .true.)
  biotic(n)%bio_tau                = fm_util_get_real   ('bio_tau', scalar = .true.)
  biotic(n)%sigma                  = fm_util_get_real   ('sigma', scalar = .true.)
  biotic(n)%kappa                  = fm_util_get_real   ('kappa', scalar = .true.)
  biotic(n)%caco3_2_c              = fm_util_get_real   ('caco3_2_c', scalar = .true.)
  biotic(n)%sc_co2_0               = fm_util_get_real   ('sc_co2_0', scalar = .true.)
  biotic(n)%sc_co2_1               = fm_util_get_real   ('sc_co2_1', scalar = .true.)
  biotic(n)%sc_co2_2               = fm_util_get_real   ('sc_co2_2', scalar = .true.)
  biotic(n)%sc_co2_3               = fm_util_get_real   ('sc_co2_3', scalar = .true.)
  biotic(n)%sc_o2_0                = fm_util_get_real   ('sc_o2_0', scalar = .true.)
  biotic(n)%sc_o2_1                = fm_util_get_real   ('sc_o2_1', scalar = .true.)
  biotic(n)%sc_o2_2                = fm_util_get_real   ('sc_o2_2', scalar = .true.)
  biotic(n)%sc_o2_3                = fm_util_get_real   ('sc_o2_3', scalar = .true.)

  call fm_util_end_namelist(package_name, biotic(n)%name, caller = caller_str)

  biotic(n)%r_bio_tau = 1.0 / biotic(n)%bio_tau

  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+norm_remin', caller = caller_str)

  biotic(n)%norm_remin%factor        =  fm_util_get_real          ('factor', scalar = .true.)
  biotic(n)%norm_remin%coastal_only  =  fm_util_get_logical       ('coastal_only', scalar = .true.)
  biotic(n)%norm_remin%wlon          => fm_util_get_real_array    ('wlon')
  biotic(n)%norm_remin%elon          => fm_util_get_real_array    ('elon')
  biotic(n)%norm_remin%slat          => fm_util_get_real_array    ('slat')
  biotic(n)%norm_remin%nlat          => fm_util_get_real_array    ('nlat')
  biotic(n)%norm_remin%t_mask        => fm_util_get_logical_array ('t_mask')

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+norm_remin', caller = caller_str)

  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+no_caco3', caller = caller_str)

  biotic(n)%no_caco3%factor          =  fm_util_get_real          ('factor', scalar = .true.)
  biotic(n)%no_caco3%coastal_only    =  fm_util_get_logical       ('coastal_only', scalar = .true.)
  biotic(n)%no_caco3%wlon            => fm_util_get_real_array    ('wlon')
  biotic(n)%no_caco3%elon            => fm_util_get_real_array    ('elon')
  biotic(n)%no_caco3%slat            => fm_util_get_real_array    ('slat')
  biotic(n)%no_caco3%nlat            => fm_util_get_real_array    ('nlat')
  biotic(n)%no_caco3%t_mask          => fm_util_get_logical_array ('t_mask')

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+no_caco3', caller = caller_str)

  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+nut_depl', caller = caller_str)

  biotic(n)%nut_depl%factor          =  fm_util_get_real          ('factor', scalar = .true.)
  biotic(n)%nut_depl%coastal_only    =  fm_util_get_logical       ('coastal_only', scalar = .true.)
  biotic(n)%nut_depl%wlon            => fm_util_get_real_array    ('wlon')
  biotic(n)%nut_depl%elon            => fm_util_get_real_array    ('elon')
  biotic(n)%nut_depl%slat            => fm_util_get_real_array    ('slat')
  biotic(n)%nut_depl%nlat            => fm_util_get_real_array    ('nlat')
  biotic(n)%nut_depl%t_mask          => fm_util_get_logical_array ('t_mask')

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+nut_depl', caller = caller_str)

  call fm_util_start_namelist(trim(package_name), trim(biotic(n)%name) // '+r_bio_tau_a', caller = caller_str)

  biotic(n)%r_bio_tau_a%factor       =  fm_util_get_real          ('factor', scalar = .true.)
  biotic(n)%r_bio_tau_a%coastal_only =  fm_util_get_logical       ('coastal_only', scalar = .true.)
  biotic(n)%r_bio_tau_a%wlon         => fm_util_get_real_array    ('wlon')
  biotic(n)%r_bio_tau_a%elon         => fm_util_get_real_array    ('elon')
  biotic(n)%r_bio_tau_a%slat         => fm_util_get_real_array    ('slat')
  biotic(n)%r_bio_tau_a%nlat         => fm_util_get_real_array    ('nlat')
  biotic(n)%r_bio_tau_a%t_mask       => fm_util_get_logical_array ('t_mask')

  call fm_util_end_namelist(trim(package_name), trim(biotic(n)%name) // '+r_bio_tau_a', caller = caller_str)

enddo

! calculate the index for the box containing the compensation depth
km_c_max = 0
do n = 1, instances
  call locate(grid_zw, nk, biotic(n)%compensation_depth,        &
              biotic(n)%km_c, nearest = .true.)
  if (grid_zw(biotic(n)%km_c) .lt.                              &
      biotic(n)%compensation_depth) then
    biotic(n)%km_c = biotic(n)%km_c + 1
  endif

  write (stdoutunit,*) trim(note_header),                         &
                     'The compensation depth for instance ',    &
                     n, ', ', biotic(n)%compensation_depth,     &
                     ' m, occurs in box ', biotic(n)%km_c ,     &
                     ' between depths ',                        &
                     grid_zw(biotic(n)%km_c-1),                 &
                     ' m and ', grid_zw(biotic(n)%km_c), ' m'
  km_c_max = max(km_c_max, biotic(n)%km_c)
enddo

! read in the norm_remin namelist data
do n = 1, instances
  if (associated(biotic(n)%norm_remin%wlon)) then
    len_w = size(biotic(n)%norm_remin%wlon)
  else
    len_w = 0
  endif
  if (associated(biotic(n)%norm_remin%elon)) then
    len_e = size(biotic(n)%norm_remin%elon)
  else
    len_e = 0
  endif
  if (associated(biotic(n)%norm_remin%slat)) then
    len_s = size(biotic(n)%norm_remin%slat)
  else
    len_s = 0
  endif
  if (associated(biotic(n)%norm_remin%nlat)) then
    len_n = size(biotic(n)%norm_remin%nlat)
  else
    len_n = 0
  endif

  if (len_e .ne. len_w .or. len_w .ne. len_s .or. len_s .ne. len_n) then
    call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal for ' // trim(biotic(n)%name))
  endif

  if (size(biotic(n)%norm_remin%t_mask) .ne. 12) then
    call mpp_error(FATAL, trim(error_header) // ' t_mask size is not 12 for ' // trim(biotic(n)%name))
  endif

  ! set all of the values to the default
  biotic(n)%norm_remin%mask(:,:,:) = 1.0

  if (len_w .gt. 0) then

    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header), 'Process norm_remin array for ', trim(biotic(n)%name)
    write (stdoutunit,*)

    ! set values for this time-level
    done = 0
    do l = 1, 12
      if (biotic(n)%norm_remin%t_mask(l)) then
        if (done .eq. 0) then

           ! set the values via the input values, saving this time index
           ! afterwards
          write (stdoutunit,*) 'Assigning month ', l
          call set_array(biotic(n)%norm_remin%mask(:,:,l),        &
                  isd, ied, jsd, jed, grid_xt, grid_yt, grid_kmt, &
                  len_w, biotic(n)%norm_remin%wlon,               &
                  biotic(n)%norm_remin%elon,                      &
                  biotic(n)%norm_remin%slat,                      &
                  biotic(n)%norm_remin%nlat,                      &
                  biotic(n)%norm_remin%factor, 1.0,               &
                  'Normal remineralization', biotic(n)%norm_remin%coastal_only)
          done = l
        else
           ! Duplicate the values for a previous time-level
          write (stdoutunit,*) 'Duplicating month ', done, ' as ', l
          biotic(n)%norm_remin%mask(:,:,l) = biotic(n)%norm_remin%mask(:,:,done)
        endif
      endif
    enddo
  endif

enddo

! read in the no_caco3 namelist data
do n = 1, instances
  if (associated(biotic(n)%no_caco3%wlon)) then
    len_w = size(biotic(n)%no_caco3%wlon)
  else
    len_w = 0
  endif
  if (associated(biotic(n)%no_caco3%elon)) then
    len_e = size(biotic(n)%no_caco3%elon)
  else
    len_e = 0
  endif
  if (associated(biotic(n)%no_caco3%slat)) then
    len_s = size(biotic(n)%no_caco3%slat)
  else
    len_s = 0
  endif
  if (associated(biotic(n)%no_caco3%nlat)) then
    len_n = size(biotic(n)%no_caco3%nlat)
  else
    len_n = 0
  endif

  if (len_e .ne. len_w .or. len_w .ne. len_s .or. len_s .ne. len_n) then
    call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal for ' // trim(biotic(n)%name))
  endif

  if (size(biotic(n)%no_caco3%t_mask) .ne. 12) then
    call mpp_error(FATAL, trim(error_header) // ' t_mask size is not 12 for ' // trim(biotic(n)%name))
  endif

  ! set all of the values to the default
  biotic(n)%no_caco3%mask(:,:,:) = 1.0

  if (len_w .gt. 0) then

    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header), 'Process no_caco3 array for ', trim(biotic(n)%name)
    write (stdoutunit,*)

    ! set values for this time-level
    done = 0
    do l = 1, 12
      if (biotic(n)%no_caco3%t_mask(l)) then
        if (done .eq. 0) then
           ! set the values via the input values, saving this time index
           ! afterwards
          write (stdoutunit,*) 'Assigning month ', l
          call set_array(biotic(n)%no_caco3%mask(:,:,l),                &
                  isd, ied, jsd, jed, grid_xt, grid_yt, grid_kmt,       &
                  len_w, biotic(n)%no_caco3%wlon,                       &
                  biotic(n)%no_caco3%elon,                              &
                  biotic(n)%no_caco3%slat,                              &
                  biotic(n)%no_caco3%nlat,                              &
                  biotic(n)%no_caco3%factor, 1.0,                       &
                  'Carbonate inhibition', biotic(n)%no_caco3%coastal_only)
          done = l
        else

           ! Duplicate the values for a previous time-level
          write (stdoutunit,*) 'Duplicating month ', done, ' as ', l
          biotic(n)%no_caco3%mask(:,:,l) = biotic(n)%no_caco3%mask(:,:,done)
        endif
      endif
    enddo
  endif

enddo

! read in the nut_depl namelist data
do n = 1, instances
  if (associated(biotic(n)%nut_depl%wlon)) then
    len_w = size(biotic(n)%nut_depl%wlon)
  else
    len_w = 0
  endif
  if (associated(biotic(n)%nut_depl%elon)) then
    len_e = size(biotic(n)%nut_depl%elon)
  else
    len_e = 0
  endif
  if (associated(biotic(n)%nut_depl%slat)) then
    len_s = size(biotic(n)%nut_depl%slat)
  else
    len_s = 0
  endif
  if (associated(biotic(n)%nut_depl%nlat)) then
    len_n = size(biotic(n)%nut_depl%nlat)
  else
    len_n = 0
  endif

  if (len_e .ne. len_w .or. len_w .ne. len_s .or. len_s .ne. len_n) then
    call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal for ' // trim(biotic(n)%name))
  endif

  if (size(biotic(n)%nut_depl%t_mask) .ne. 12) then
    call mpp_error(FATAL, trim(error_header) // ' t_mask size is not 12 for ' // trim(biotic(n)%name))
  endif

  ! set all of the values to the default
  biotic(n)%nut_depl%mask(:,:,:) = 1.0

  if (len_w .gt. 0) then

    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header), 'Process nut_depl array for ', trim(biotic(n)%name)
    write (stdoutunit,*)

    ! set values for this time-level
    done = 0
    do l = 1, 12
      if (biotic(n)%nut_depl%t_mask(l)) then
        if (done .eq. 0) then
           ! set the values via the input values, saving this time index
           ! afterwards
          write (stdoutunit,*) 'Assigning month ', l
          call set_array(biotic(n)%nut_depl%mask(:,:,l),                &
                  isd, ied, jsd, jed, grid_xt, grid_yt, grid_kmt,       &
                  len_w, biotic(n)%nut_depl%wlon,                       &
                  biotic(n)%nut_depl%elon,                              &
                  biotic(n)%nut_depl%slat,                              &
                  biotic(n)%nut_depl%nlat,                              &
                  biotic(n)%nut_depl%factor, 1.0,                       &
                  'Nutrient depletion', biotic(n)%nut_depl%coastal_only)
          done = l
        else
           ! Duplicate the values for a previous time-level
          write (stdoutunit,*) 'Duplicating month ', done, ' as ', l
          biotic(n)%nut_depl%mask(:,:,l) = biotic(n)%nut_depl%mask(:,:,done)
        endif
      endif
    enddo
  endif

enddo

! read in the r_bio_tau_a namelist data
do n = 1, instances

  if (associated(biotic(n)%r_bio_tau_a%wlon)) then
    len_w = size(biotic(n)%r_bio_tau_a%wlon)
  else
    len_w = 0
  endif
  if (associated(biotic(n)%r_bio_tau_a%elon)) then
    len_e = size(biotic(n)%r_bio_tau_a%elon)
  else
    len_e = 0
  endif
  if (associated(biotic(n)%r_bio_tau_a%slat)) then
    len_s = size(biotic(n)%r_bio_tau_a%slat)
  else
    len_s = 0
  endif
  if (associated(biotic(n)%r_bio_tau_a%nlat)) then
    len_n = size(biotic(n)%r_bio_tau_a%nlat)
  else
    len_n = 0
  endif

  if (len_e .ne. len_w .or. len_w .ne. len_s .or. len_s .ne. len_n) then
    call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal for ' // trim(biotic(n)%name))
  endif

  if (size(biotic(n)%r_bio_tau_a%t_mask) .ne. 12) then
    call mpp_error(FATAL, trim(error_header) // ' t_mask size is not 12 for ' // trim(biotic(n)%name))
  endif

  ! set all of the values to the default
  biotic(n)%r_bio_tau_a%mask(:,:,:) = 1.0

  if (len_w .gt. 0) then

    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header), 'Process r_bio_tau_a array for ', trim(biotic(n)%name)
    write (stdoutunit,*)

    ! set values for this time-level
    done = 0
    do l = 1, 12
      if (biotic(n)%r_bio_tau_a%t_mask(l)) then
        if (done .eq. 0) then
           ! set the values via the input values, saving this time index
           ! afterwards
          write (stdoutunit,*) 'Assigning month ', l
          call set_array(biotic(n)%r_bio_tau_a%mask(:,:,l),             &
                  isd, ied, jsd, jed, grid_xt, grid_yt, grid_kmt,       &
                  len_w, biotic(n)%r_bio_tau_a%wlon,                    &
                  biotic(n)%r_bio_tau_a%elon,                           &
                  biotic(n)%r_bio_tau_a%slat,                           &
                  biotic(n)%r_bio_tau_a%nlat,                           &
                  biotic(n)%r_bio_tau_a%factor, 1.0,                    &
                  'Primary production limitation', biotic(n)%r_bio_tau_a%coastal_only)
          done = l
        else
           ! Duplicate the values for a previous time-level
          write (stdoutunit,*) 'Duplicating month ', done, ' as ', l
          biotic(n)%r_bio_tau_a%mask(:,:,l) = biotic(n)%r_bio_tau_a%mask(:,:,done)
        endif
      endif
    enddo
  endif

enddo

! multiply by the restoring factor
do n = 1, instances
  biotic(n)%r_bio_tau_a%mask(:,:,:) =                                &
       biotic(n)%r_bio_tau * biotic(n)%r_bio_tau_a%mask(:,:,:)
enddo

! initialize special arrays for remineralization
do n = 1, instances
  do k = 1, nk
    biotic(n)%zforg(k) =                                        &
         (grid_zw(k) /                                          &
          biotic(n)%compensation_depth) ** (-biotic(n)%martin_coeff)
    biotic(n)%zfca(k) =                                         &
         exp(-(grid_zw(k) -                                     &
               biotic(n)%compensation_depth) / biotic(n)%ca_remin_depth)
  enddo
enddo

! initialize special arrays for alternate remineralization
do n = 1, instances
  do k = 1, nk
    biotic(n)%zforg_alt(k) = (grid_zw(k) /                      &
         biotic(n)%compensation_depth) ** (-biotic(n)%martin_coeff_alt)
  enddo
enddo

!       Read in additional information for a restart.
!
!       We must process all of the instances before restoring any files
!       as all fields must be registered before the fields are
!       restored, and fields from different instances may be in the
!       same file.
!
!       Note that the restart file names here must be different from
!       those for the tracer values.
allocate(restart(instances))
allocate(local_restart_file(instances))

write(stdoutunit,*)

do n = 1, instances

   ! Set the suffix for this instance (if instance name is "_",
   ! then use a blank suffix).
  if (biotic(n)%name(1:1) .eq. '_') then
    suffix = ' '
  else
    suffix = '_' // biotic(n)%name
  endif

  ! Check whether we are already using this restart file, if so,
  ! we do not want to duplicate it in the list of restart files
  ! since we only read each restart file once.
  ind = 0
  do l = 1, num_restart
    if (biotic(n)%local_restart_file == local_restart_file(l)) then
      ind = l
      exit
    endif
  end do

  if (ind .eq. 0) then
    num_restart = num_restart + 1
    ind = num_restart
    local_restart_file(ind) = trim(biotic(n)%local_restart_file)
  end if

  ! Check whether the field already exists in the restart file.
  ! If not, then set a default value.
  fld_exist = field_exist('INPUT/' // trim(biotic(n)%local_restart_file), 'htotal' // trim(suffix) )

  if ( fld_exist ) then
    write (stdoutunit,*) trim(note_header),                       &
         'Reading additional information for instance ',        &
         ': Initializing instance ', trim(biotic(n)%name)
  else
    write (stdoutunit,*) trim(note_header),                       &
         'Initializing instance ', trim(biotic(n)%name)
    biotic(n)%htotal(:,:) = htotal_in
  endif

  ! Register the field for restart
  id_restart = register_restart_field(restart(ind), biotic(n)%local_restart_file,       &
                    'htotal' // trim(suffix), biotic(n)%htotal,                         &
                    domain=mpp_domain2d, mandatory=fld_exist )

enddo

! Restore the restart fields if the file exists
do l = 1, num_restart
  if (file_exist('INPUT/' // trim(local_restart_file(l)))) then
    call restore_state(restart(l))
  end if
end do

deallocate(local_restart_file)

! initialize some arrays which are held constant for this
! simulation
do n = 1, instances
  biotic(n)%sio2(:,:) = biotic(n)%sio2_const
enddo

! Set up analyses

! register the global fields
suffix = '_' // package_name
long_suffix = ' (' // trim(package_name) // ')'

id_o2_sat = register_diag_field(trim(diag_name),                        &
     'o2_saturation' // trim(suffix), grid_tracer_axes(1:2),            &
     model_time, 'O2 saturation' // trim(long_suffix), 'mol/m^3/atm',   &
     missing_value = -1.0e+10)

! register the instance fields
do n = 1, instances

  if (instances .eq. 1) then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // biotic(n)%name
    long_suffix = ' (' // trim(biotic(n)%name) // ')'
  endif

  biotic(n)%id_sc_co2 = register_diag_field(trim(diag_name),                    &
       'sc_co2' // trim(suffix), grid_tracer_axes(1:2),                         &
       model_time, 'Schmidt number - CO2' // trim(long_suffix), ' ',            &
       missing_value = -1.0e+10)

  biotic(n)%id_sc_o2 = register_diag_field(trim(diag_name),                     &
       'sc_o2' // trim(suffix), grid_tracer_axes(1:2),                          &
       model_time, 'Schmidt number - O2' // trim(long_suffix), ' ',             &
       missing_value = -1.0e+10)

  biotic(n)%id_alpha = register_diag_field(trim(diag_name),                     &
       'alpha' // trim(suffix), grid_tracer_axes(1:2),                          &
       model_time, 'Alpha CO2' // trim(long_suffix), 'mol/kg/atm',              &
       missing_value = -1.0e+10)

  biotic(n)%id_csurf = register_diag_field(trim(diag_name),                     &
       'csurf' // trim(suffix), grid_tracer_axes(1:2),                          &
       model_time, 'CO2* water' // trim(long_suffix), 'mol/kg',                 &
       missing_value = -1.0e+10)

  biotic(n)%id_pco2surf = register_diag_field(trim(diag_name),                  &
       'pco2surf' // trim(suffix), grid_tracer_axes(1:2),                       &
       model_time, 'Oceanic pCO2' // trim(long_suffix), 'ppm',                  &
       missing_value = -1.0e+10)

  biotic(n)%id_flux_poc = register_diag_field(trim(diag_name),                  &
       'flux_poc' // trim(suffix), grid_tracer_axes(1:2),                       &
       model_time, 'POC flux' // trim(long_suffix), 'mol/m^2/s',                &
       missing_value = -1.0e+10)

  biotic(n)%id_flux_caco3 = register_diag_field(trim(diag_name),                &
       'flux_caco3' // trim(suffix), grid_tracer_axes(1:2),                     &
       model_time, 'CaCO3 flux' // trim(long_suffix), 'mol/m^2/s',              &
       missing_value = -1.0e+10)

  biotic(n)%id_htotal = register_diag_field(trim(diag_name),                    &
       'htotal' // trim(suffix), grid_tracer_axes(1:2),                         &
       model_time, 'H+ ion concentration' // trim(long_suffix), ' ',            &
       missing_value = -1.0e+10)

  biotic(n)%id_jprod = register_diag_field(trim(diag_name),                     &
       'jprod' // trim(suffix), grid_tracer_axes(1:3),                          &
       model_time, 'Restoring production' // trim(long_suffix), 'mol/kg/s',     &
       missing_value = -1.0e+10)

  biotic(n)%id_jca = register_diag_field(trim(diag_name),                       &
       'jca' // trim(suffix), grid_tracer_axes(1:3),                            &
       model_time, 'CaCO3 change' // trim(long_suffix), 'mol/kg/s',             &
       missing_value = -1.0e+10)

  biotic(n)%id_jpo4 = register_diag_field(trim(diag_name),                      &
       'jpo4' // trim(suffix), grid_tracer_axes(1:3),                           &
       model_time, 'PO4 source' // trim(long_suffix), 'mol/kg/s',               &
       missing_value = -1.0e+10)

  biotic(n)%id_jdop = register_diag_field(trim(diag_name),                      &
       'jdop' // trim(suffix), grid_tracer_axes(1:3),                           &
       model_time, 'DOP source' // trim(long_suffix), 'mol/kg/s',               &
       missing_value = -1.0e+10)

  biotic(n)%id_jo2 = register_diag_field(trim(diag_name),                       &
       'jo2' // trim(suffix), grid_tracer_axes(1:3),                            &
       model_time, 'O2 source' // trim(long_suffix), 'mol/kg/s',                &
       missing_value = -1.0e+10)

  biotic(n)%id_fc = register_diag_field(trim(diag_name),                        &
       'fc' // trim(suffix), grid_tracer_axes(1:3),                             &
       model_time, 'POP change' // trim(long_suffix), 'mol/m^2/s',              &
       missing_value = -1.0e+10)

  biotic(n)%id_fca = register_diag_field(trim(diag_name),                       &
       'fca' // trim(suffix), grid_tracer_axes(1:3),                            &
       model_time, 'CaCO3 change' // trim(long_suffix), 'mol/m^2/s',            &
       missing_value = -1.0e+10)

  if (biotic(n)%add_phosphate) then
    biotic(n)%id_jpo4_add = register_diag_field(trim(diag_name),                &
         'jpo4_add' // trim(suffix), grid_tracer_axes(1:3),                     &
         model_time, 'Additional phosphate' // trim(long_suffix), 'mol/kg/s',   &
         missing_value = -1.0e+10)
  endif

enddo

! integrate the total concentrations of some tracers
! for the start of the run
total_phosphate = 0.0
total_dop = 0.0
total_o2 = 0.0
total_dic = 0.0
total_alkalinity = 0.0

!       Use taup1 time index for the start of a run, and taup1 time
!       index for the end of a run so that we are integrating the
!       same time level and should therefore get identical results
write (stdoutunit,*) trim(note_header),                           &
     'Global integrals at start of run'

do n = 1, instances
  do k = 1,nk
    do j = jsc, jec
      do i = isc, iec
        total_phosphate = total_phosphate +                     &
             t_prog(biotic(n)%ind_po4)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_dop = total_dop +                                 &
             t_prog(biotic(n)%ind_dop)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_o2 = total_o2 +                                   &
             t_prog(biotic(n)%ind_o2)%field(i,j,k,taup1) *      &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_dic = total_dic +                                 &
             t_prog(biotic(n)%ind_dic)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
        total_alkalinity = total_alkalinity +                   &
             t_prog(biotic(n)%ind_alk)%field(i,j,k,taup1) *     &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo

  call mpp_sum(total_phosphate)
  call mpp_sum(total_dop)
  call mpp_sum(total_o2)
  call mpp_sum(total_dic)
  call mpp_sum(total_alkalinity)

  write (stdoutunit,*) '  Instance ', trim(biotic(n)%name)
  write (stdoutunit,                                              &
       '(/'' Total phosphate  = '',es19.12,'' Gmol'')')         &
       total_phosphate * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total DOP  = '',es19.12,'' Gmol'')')               &
       total_DOP * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total O2  = '',es19.12,'' Gmol'')')                &
       total_o2 * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total DIC  = '',es19.12,'' Gmol'')')               &
       total_dic * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total alkalinity  = '',es19.12,'' Geq'')')         &
       total_alkalinity * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total phosphorous  = '',es19.12,'' Gmol'')')       &
       (total_phosphate + total_dop) * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total real O2  = '',es19.12,'' Gmol'')')           &
       (total_o2 + biotic(n)%o_2_p * total_phosphate) * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total Carbon  = '',es19.12,'' Gmol'')')            &
       (total_dic + biotic(n)%c_2_p * total_dop) * 1.0e-09
  write (stdoutunit,                                              &
       '(/'' Total real alkalinity  = '',es19.12,'' Geq'')')    &
       (total_alkalinity + biotic(n)%n_2_p * total_phosphate) * 1.0e-09
enddo

write(stdoutunit,*)
write(stdoutunit,*) trim(note_header), 'Tracer runs initialized'
write(stdoutunit,*)

return

end subroutine  ocmip2_biotic_start
! </SUBROUTINE> NAME="ocmip2_biotic_start"

!#######################################################################
! <SUBROUTINE NAME="set_array">
!
! <DESCRIPTION>
!       Set up an array covering the model domain with a user-specified
!       value, in user-specified regions. There are a given number of
!       2-d regions specified by the values slat, nlat, wlon and elon.
!       The longitudes are for a cyclic domain, and if wlon and elon
!       are on opposite sides of the cut, the correct thing will
!       be done. Elon is considered to be east of wlon, so if elon is
!       less than wlon, then the region east of elon to the cut will be
!       filled, and the region from the cut to wlon will be filled.
!
!       After setting up the array in this routine, it may prove useful
!       to allow fine-tuning the settings via an array in a namelist.
!
!       Arguments:
!         Input:
!      num_regions = number of user-specified regions which will be
!                    filled
!
!             wlon = 1-d array of western (starting) longitudes for the
!                    rectangular regions
!
!             elon = 1-d array of eastern (ending) longitudes for the
!                    rectangular regions
!
!             slat = 1-d array of southern (starting) latitudes for the
!                    rectangular regions
!
!             nlat = 1-d array of northern (ending) latitudes for the
!                    rectangular regions
!
!                       Note: if slat >= nlat, then nothing is done
!                             for that region
!
!        set_value = the value to assign to array in the user-specified
!                    regions
!
!      unset_value = the value to assign to array outside of the
!                    user-specified regions
!
!             name = character variable used in informative messages
!
!     coastal_only = true to limit changes only to coastal points
!                    (i.e., at least one bordering point is land)
!
!         Output:
!
!            array = 2-d array which will contain the set- and unset-
!                    values. The array is assumed to have a border
!                    one unit wide on all edges, ala MOM. A cyclic
!                    boundary condition will be set if requested.
! </DESCRIPTION>
!
subroutine set_array(array, isd, ied, jsd, jed,                 &
                     xt, yt, kmt,                               &
                     num_regions, wlon_in, elon_in, slat, nlat, &
                     set_value, unset_value, name,              &
                     coastal_only)
integer, intent(in)                             :: isd
integer, intent(in)                             :: ied
integer, intent(in)                             :: jsd
integer, intent(in)                             :: jed
integer, intent(in)                             :: num_regions
real, dimension(isd:ied,jsd:jed), intent(out)   :: array
logical, intent(in)                             :: coastal_only
real, dimension(num_regions), intent(in)        :: elon_in
integer, dimension(isd:,jsd:), intent(in)       :: kmt
character(len=*), intent(in)                    :: name
real, dimension(num_regions), intent(in)        :: nlat
real, intent(in)                                :: set_value
real, dimension(num_regions), intent(in)        :: slat
real, intent(in)                                :: unset_value
real, dimension(num_regions), intent(in)        :: wlon_in
real, dimension(isd:,jsd:), intent(in)          :: xt
real, dimension(isd:,jsd:), intent(in)          :: yt

character(len=64), parameter    :: sub_name = 'set_array'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer :: i, j, n
real, dimension(:), allocatable :: wlon
real, dimension(:), allocatable :: elon

  integer :: stdoutunit 
  stdoutunit=stdout() 

! save the longitudes in case they need to be modified
allocate(wlon(num_regions))
allocate(elon(num_regions))

wlon(:) = wlon_in(:)
elon(:) = elon_in(:)

! loop over the regions, applying changes as necessary
do n = 1, num_regions

  if (nlat(n) .ge. slat(n)) then
    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header),                          &
                       trim(name), ' region: ', n

    ! make sure that all longitudes are in the range [0,360]
    do while (wlon(n) .gt. 360.0)
      wlon(n) = wlon(n) - 360.0
    enddo
    do while (wlon(n) .lt. 0.0)
      wlon(n) = wlon(n) + 360.0
    enddo
    do while (elon(n) .gt. 360.0)
      elon(n) = elon(n) - 360.0
    enddo
    do while (elon(n) .lt. 0.0)
      elon(n) = elon(n) + 360.0
    enddo
    ! if the southern and northern latitudes are the same, then
    ! find the grid box which encompasses them ...
    if (slat(n) .eq. nlat(n)) then
     call mpp_error(FATAL, trim(error_header) //                &
                    'Equal latitudes not supported')
    elseif (wlon(n) .eq. elon(n)) then
     call mpp_error(FATAL, trim(error_header) //                &
                    'Equal longitudes not supported')
    else
       ! ... else find all boxes where the center lies in the
       ! rectangular region
      do j = jsd, jed
        do i = isd, ied
          if (nlat(n) .ge. yt(i,j) .and.                        &
              slat(n) .le. yt(i,j) .and.                        &
              lon_between(xt(i,j), wlon(n), elon(n))) then
            array(i,j) = set_value
          endif
        enddo
      enddo

    endif

  endif

enddo

! if desired only apply mask to coastal regions
if (coastal_only) then
  do j = jsd, jed
    do i = isd, ied
      if (kmt(i,j) .ne. 0 .and.                         &
          array(i,j) .eq. set_value) then
         ! if all the surrounding points are ocean, then this is not
         ! a coastal point, therefore reset the mask
        if (kmt(i-1,j) .ne. 0 .and.                     &
            kmt(i+1,j) .ne. 0 .and.                     &
            kmt(i,j-1) .ne. 0 .and.                     &
            kmt(i,j+1) .ne. 0) then
          array(i,j) = unset_value
        endif
      endif
    enddo
  enddo
endif

! clean up
deallocate(wlon)
deallocate(elon)

return

contains

!       Return true if w <= x_in <= e, taking into account the
!       periodicity of longitude.
!
!       x_in    = value to test
!
!       w       = west longitude of boundary
!
!       e       = east longitude of boundary
function lon_between(x_in, w, e)

real, intent(in)                :: x_in
real, intent(in)                :: w
real, intent(in)                :: e

logical :: lon_between
real                    :: x

! Save input values so we may modify them safely
x = x_in

! make sure that all longitudes are in the range [0,360]
do while (x .gt. 360.0)
  x = x - 360.0
enddo
do while (x .lt. 0.0)
  x = x + 360.0
enddo
 
if (w .gt. e) then
  lon_between = w .le. x .or. x .le. e
else
  lon_between = w .le. x .and. x .le. e
endif

return

end function  lon_between

end subroutine  set_array
! </SUBROUTINE> NAME="set_array"

end module  ocmip2_biotic_mod

module topo_drag_mod

!=======================================================================
! TOPOGRAPHIC DRAG CLOSURE -- Garner (2005)
!=======================================================================

!-----------------------------------------------------------------------
!  Calculates horizontal velocity tendency due to topographic drag
!-----------------------------------------------------------------------

use          mpp_mod, only: input_nml_file
use          fms_mod, only: file_exist, open_namelist_file,            &
                            close_file, error_mesg, FATAL, NOTE,       &
                            mpp_pe, mpp_root_pe, stdout, stdlog,       &
                            check_nml_error, write_version_number
use       fms_io_mod, only: read_data, field_size
use       fms_io_mod, only: register_restart_field, restart_file_type
use       fms_io_mod, only: save_restart, restore_state
use    constants_mod, only: Grav, Cp_Air, Rdgas, Pi, Radian
use horiz_interp_mod, only: horiz_interp_type, horiz_interp_init, &
                            horiz_interp_new, horiz_interp, horiz_interp_del

implicit none

private

character(len=128) :: version = '$Id: topo_drag.F90,v 19.0 2012/01/06 20:27:27 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

logical :: module_is_initialized = .false.

! horizontal array size

integer :: nlon, nlat

! arrays defined by topo_drag_init:

real, allocatable, dimension(:,:) :: t11, t21, t12, t22    ! drag tensor
real, allocatable, dimension(:,:) :: hmin, hmax

! parameters:

real, parameter :: u0=1.0       ! arbitrary velocity scale for diagnostics
real, parameter :: xl=80.0e3    ! arbitrary horiz length scale for diagnostics
real, parameter :: ro=1.2       ! arbitrary density scale for diagnostics
real, parameter :: lapse=Grav/Cp_Air ! adiabatic lapse rate
real, parameter :: tiny=1.0e-8

real, parameter :: resolution=30.0 ! # of points per degree in topo datasets

integer, parameter :: ipts=360*resolution
integer, parameter :: jpts=180*resolution

!--- for netcdf restart
type(restart_file_type), save :: Top_restart

! parameters in namelist (topo_drag_nml):

real :: &
   frcrit=0.7   &      ! critical value of Froude number for nonlinear flow
  ,anonlin=7.0  &      ! amplitude of nonpropagating drag
  ,gamma=0.4    &      ! exponent in aspect ratio power law
  ,epsi=0.0     &      ! exponent in distribution power law
  ,beta=0.5     &      ! bluntness of topographic features
  ,h_frac=0.0   &      ! ratio of min to max subgrid mountain height
  ,zref_fac=1.0 &      ! adjusts level separating breaking/laminar flow
  ,no_drag_frac=0.05 & ! fraction of lower atmosphere with no breaking
  ,tboost=1.0 &        ! surface T boost to improve PBL height estimate
  ,pcut=0.0            ! high-level cutoff pressure for momentum forcing
logical :: &
   do_conserve_energy=.true. &! conserve total energy?
  ,keep_residual_flux=.true.  ! redistribute residual pseudomomentum?

NAMELIST /topo_drag_nml/                                               &
  frcrit, anonlin, beta, gamma, epsi,                                  &
  h_frac, zref_fac, no_drag_frac, tboost, pcut,                        &
  do_conserve_energy, keep_residual_flux

public topo_drag, topo_drag_init, topo_drag_end
public topo_drag_restart

contains

!#######################################################################

subroutine topo_drag                                                   &
                                     ( is, js, delt, uwnd, vwnd, atmp, &
                                           pfull, phalf, zfull, zhalf, &
                          dtaux, dtauy, dtemp, taux, tauy, taus, kbot )

integer, intent(in) :: is, js
real,    intent(in) :: delt
integer, intent(in), optional, dimension(:,:) :: kbot

! INPUT
! -----

! UWND     Zonal wind (dimensioned IDIM x JDIM x KDIM)
! VWND     Meridional wind (dimensioned IDIM x JDIM x KDIM)
! ATMP     Temperature at full levels (IDIM x JDIM x KDIM)
! PFULL    Pressure at full levels (IDIM x JDIM x KDIM)
! PHALF    Pressure at half levels (IDIM x JDIM x KDIM+1)
! ZFULL    Height at full levels (IDIM x JDIM x KDIM)
! ZHALF    Height at half levels (IDIM x JDIM x KDIM+1)

real, intent(in), dimension(:,:,:) :: uwnd, vwnd, atmp
real, intent(in), dimension(:,:,:) :: pfull, phalf, zfull, zhalf

! OUTPUT
! ------

! DTAUX,DTAUY  Tendency of the vector wind in m/s^2 (IDIM x JDIM x KDIM)
! DTEMP        Tendency of the temperature in K/s (IDIM x JDIM x KDIM)
! TAUX,TAUY    Base momentum flux in kg/m/s^2 (IDIM x JDIM) for diagnostics
! TAUS         clipped saturation momentum flux (IDIM x JDIM x KDIM) for diagnostics

real, intent(out), dimension(:,:)   :: taux, tauy
real, intent(out), dimension(:,:,:) :: dtaux, dtauy, dtemp, taus

integer, dimension(size(zfull,1),size(zfull,2)) :: ktop, kcut
real,    dimension(size(zhalf,1),size(zhalf,2),size(zhalf,3)) :: tausat

! work arrays

real, dimension(size(zfull,1),size(zfull,2)) :: taub, taul, taup, taun
real, dimension(size(zfull,1),size(zfull,2)) :: frulo, fruhi, frunl, rnorm

integer :: idim
integer :: jdim
integer :: k, kdim

  idim = size(uwnd,1)
  jdim = size(uwnd,2)
  kdim = size(uwnd,3)

! estimate height of pbl

  call get_pbl ( atmp, zfull, pfull, phalf, ktop, kcut )

! calculate base flux

  call base_flux (                                                     &
                                             is, js, uwnd, vwnd, atmp, &
                                             taux, tauy, dtaux, dtauy, &
                                               taub, taul, taup, taun, &
                                           frulo, fruhi, frunl, rnorm, &
                                            zfull, zhalf, pfull, ktop )

! calculate saturation flux profile

  call satur_flux (                                                    &
                                                     uwnd, vwnd, atmp, &
                                       taux, tauy, taup, taub, tausat, &
                                                  frulo, fruhi, frunl, &
                        dtaux, dtauy, zfull, pfull, phalf, ktop, kcut )

! calculate momentum tendency

  call topo_drag_tend (                                                &
                                               delt, uwnd, vwnd, atmp, &
                                       taux, tauy, taul, taun, tausat, &
                dtaux, dtauy, dtemp, zfull, zhalf, pfull, phalf, ktop )

! put saturation flux profile into 'taus' for diagnostics

  do k=1,kdim
     taus(:,:,k) = 0.5*rnorm(:,:)*(tausat(:,:,k) + tausat(:,:,k+1))
  enddo

! put total drag into 'taux,tauy' for diagnostics

  taup = taup - tausat(:,:,1)
  taub = (taup + taun)/taul
  taux = taux*taub
  tauy = tauy*taub

end subroutine topo_drag

!=======================================================================
                                  
subroutine base_flux (                                                 &
                                             is, js, uwnd, vwnd, atmp, &
                                             taux, tauy, dtaux, dtauy, &
                                               taub, taul, taup, taun, &
                                           frulo, fruhi, frunl, rnorm, &
                                            zfull, zhalf, pfull, ktop )

integer, intent(in) :: is, js
real, intent(in),  dimension(:,:,:) :: uwnd, vwnd, atmp
real, intent(in),  dimension(:,:,:) :: zfull, zhalf, pfull
real, intent(out), dimension(:,:)   :: taux, tauy
real, intent(out), dimension(:,:,:) :: dtaux, dtauy
real, intent(out), dimension(:,:)   :: taub, taul, taup, taun
real, intent(out), dimension(:,:)   :: frulo, fruhi, frunl, rnorm
integer, intent(in), dimension(:,:) :: ktop

integer :: i, idim, id
integer :: j, jdim, jd
integer :: k, kdim

real :: usat, bfreq2, bfreq, dphdz, vtau
real :: dzhalf, density
real :: frmin, frmax, frumin, frumax, fruclp, fru0, frusat
real :: rnormal, gterm

  idim = size(uwnd,1)
  jdim = size(uwnd,2)
  kdim = size(uwnd,3)

! compute base flux

  do j=1,jdim
     jd = js+j-1
     do i=1,idim
        id = is+i-1
        k = ktop(i,j)

        dzhalf = zfull(i,j,k-1) - zfull(i,j,k)
        density = (pfull(i,j,k) - pfull(i,j,k-1))/(Grav*dzhalf)
        bfreq2 = Grav*((atmp(i,j,k-1) - atmp(i,j,k))/dzhalf + lapse)/  & 
                  (0.5*(atmp(i,j,k-1) + atmp(i,j,k)))
        bfreq = sqrt(max(tiny, bfreq2))

        taux(i,j) = (uwnd(i,j,k)*t11(id,jd) + vwnd(i,j,k)*t21(id,jd))  &
                                                         *bfreq*density
        tauy(i,j) = (uwnd(i,j,k)*t12(id,jd) + vwnd(i,j,k)*t22(id,jd))  &
                                                         *bfreq*density
        taub(i,j) = max(tiny, sqrt(taux(i,j)**2 + tauy(i,j)**2))

!       min/max Froude numbers based on surface flow

        vtau = max(tiny, -(uwnd(i,j,k)*taux(i,j)                       &
                         + vwnd(i,j,k)*tauy(i,j))/taub(i,j))
        frmax = hmax(id,jd)*bfreq / vtau
        frmin = hmin(id,jd)*bfreq / vtau

!       linear momentum flux associated with min/max Froude numbers

        dphdz = bfreq / vtau
        usat = density/ro * vtau / sqrt(dphdz*xl)
        frusat = frcrit*usat

        frumin = frmin*usat         ! linear momentum flux
        frumax = frmax*usat
        frumax = max(frumax,frumin + tiny)
        fruclp = min(frumax,max(frumin,frusat))
        fru0 = (u0/vtau)*usat

!       total drag in linear limit

        rnormal = (frumax**(2.0*gamma - epsi)                          &
                 - frumin**(2.0*gamma - epsi))/(2.0*gamma - epsi) 
        rnormal = fru0**gamma * ro/rnormal  

        gterm = (frumax**(gamma - epsi - beta)                         &
               - fruclp**(gamma - epsi - beta))/(gamma - epsi - beta)
        gterm = gterm*frusat**beta

        taul(i,j) =                                                    &
                    (frumax**(2.0 + gamma - epsi)                      &
                   - frumin**(2.0 + gamma - epsi))/(2.0 + gamma - epsi)

!       separate propagating and nonpropagating parts of total drag

        taup(i,j) =                                                    &
                 ( (fruclp**(2.0 + gamma - epsi)                       &       
                  - frumin**(2.0 + gamma - epsi))/(2.0 + gamma - epsi) &
                                                    + frusat**2*gterm )

        taun(i,j) = anonlin*usat/(1.0 + beta)*                         &
                 ( (frumax**(1.0 + gamma - epsi)                       &
                  - fruclp**(1.0 + gamma - epsi))/(1.0 + gamma - epsi) &
                                                       - frusat*gterm )

        fruhi(i,j) = frumax
        frulo(i,j) = frumin
        frunl(i,j) = frusat
        rnorm(i,j) = rnormal

     enddo
  enddo

! wind component opposite the drag at full levels (stored as 'dtaux')

  do k=1,kdim
     do j=1,jdim
        do i=1,idim
           dtaux(i,j,k) =                                              &
             -(uwnd(i,j,k)*taux(i,j) + vwnd(i,j,k)*tauy(i,j))/taub(i,j)
        enddo
     enddo
  enddo

end subroutine base_flux

!=======================================================================

subroutine satur_flux (                                                &
                                                     uwnd, vwnd, atmp, &
                                       taux, tauy, taup, taub, tausat, &
                                                  frulo, fruhi, frunl, &
                        dtaux, dtauy, zfull, pfull, phalf, ktop, kcut )

real, intent(in),  dimension (:,:,:) :: uwnd, vwnd, atmp
real, intent(in),  dimension (:,:,:) :: dtaux, dtauy
real, intent(in),  dimension (:,:,:) :: zfull, pfull, phalf
real, intent(in),  dimension (:,:)   :: taux, tauy, taup
real, intent(out), dimension (:,:)   :: taub
real, intent(out), dimension (:,:,:) :: tausat
real, intent(in),  dimension (:,:)   :: frulo, fruhi, frunl
integer, intent(in), dimension (:,:) :: ktop, kcut

real, dimension(size(zfull,1),size(zfull,2)) :: usat

real :: dzhalf, gterm, gterm0, density
real :: bfreq2, bfreq, vtau, dphdz
real :: frumin, frumax, fruclp, frusat, frusat0, fruclp0

integer :: i, idim
integer :: j, jdim
integer :: k, kdim, k1

  idim = size(uwnd,1)
  jdim = size(uwnd,2)
  kdim = size(uwnd,3)

! get vertical profile of propagating part of momentum flux

  usat = frunl/frcrit

  do k=kdim,2,-1
     do j=1,jdim
        do i=1,idim

!          buoyancy frequency, velocity and density at half levels

           dzhalf = zfull(i,j,k-1) - zfull(i,j,k)
           density = (pfull(i,j,k) - pfull(i,j,k-1))/(Grav*dzhalf)
           bfreq2 = Grav*                                              &
                       ((atmp(i,j,k-1) - atmp(i,j,k))/dzhalf + lapse)/ & 
                   (0.5*(atmp(i,j,k-1) + atmp(i,j,k)))
           bfreq = sqrt(max(tiny, bfreq2))
           
           vtau = max(tiny, 0.5*(dtaux(i,j,k-1) + dtaux(i,j,k)))

!          min/max and critical momentum flux values at half levels

           dphdz = bfreq / vtau
           usat(i,j) = min(usat(i,j),                                  &
                      sqrt(density/ro * vtau/sqrt(dphdz*xl)))
           frusat = frcrit*usat(i,j)

           frumin = frulo(i,j)
           frumax = fruhi(i,j)
           fruclp = min(frumax,max(frumin,frusat))
           frusat0 = frunl(i,j)
           fruclp0 = min(frumax,max(frumin,frusat0))

!          propagating part of momentum flux (from WKB or EP)

           gterm0 = (frumax**(gamma - epsi - beta)                     &
                - fruclp0**(gamma - epsi - beta))/(gamma - epsi - beta)
           gterm = (fruclp0**(gamma - epsi)                            &
                               - fruclp**(gamma - epsi))/(gamma - epsi)

           tausat(i,j,k) =                                             &
                 ( (fruclp**(2.0 + gamma - epsi)                       &
                  - frumin**(2.0 + gamma - epsi))/(2.0 + gamma - epsi) &
                         + frusat**2.0*(gterm0*frusat0**beta + gterm) )
        enddo
     enddo
  enddo

! make propagating flux constant with height in zero-drag top layer

  tausat(:,:,1) = tausat(:,:,2)

  k1 = maxval(kcut)
  do k=3,k1
     where (k <= kcut)
        tausat(:,:,k) = tausat(:,:,1)
     endwhere
  enddo

! make propagating flux constant with height in zero-drag surface layer

  k1 = minval(ktop)
  do k=kdim+1,k1+1,-1
     where (k > ktop)
        tausat(:,:,k) = taup
     endwhere
  enddo

! redistribute residual forcing

  if ( keep_residual_flux ) then
     taub(:,:) = tausat(:,:,1)/(phalf(:,:,kdim+1) - phalf(:,:,1))
     do k=1,kdim
        tausat(:,:,k) = tausat(:,:,k)                                  &
                        - taub(:,:)*(phalf(:,:,kdim+1) - phalf(:,:,k))
     enddo
  endif

endsubroutine satur_flux

!=======================================================================

subroutine topo_drag_tend (                                            &
                                               delt, uwnd, vwnd, atmp, &
                                       taux, tauy, taul, taun, tausat, &
                dtaux, dtauy, dtemp, zfull, zhalf, pfull, phalf, ktop )

real, intent(in) :: delt
real, intent(in), dimension(:,:,:)   :: uwnd, vwnd, atmp
real, intent(in), dimension(:,:,:)   :: zfull, zhalf, pfull, phalf
real, intent(in), dimension(:,:)     :: taux, tauy, taul, taun
real, intent(in), dimension(:,:,:)   :: tausat
real, intent(inout),dimension(:,:,:) :: dtaux, dtauy, dtemp
integer, intent(in), dimension (:,:) :: ktop

real, parameter :: bfmin=0.7e-2, bfmax=1.7e-2  ! min/max buoyancy freq [1/s]
real, parameter :: vvmin=1.0                   ! minimum surface wind [m/s]

integer,dimension(size(zfull,1),size(zfull,2)) :: kref
real :: dzhalf, zlast, rscale, phase, bfreq, bfreq2, vtau
real :: gfac, gfac1, dp, weight, wtsum

integer :: i, idim
integer :: j, jdim
integer :: k, kdim, kr

  idim = size(uwnd,1)
  jdim = size(uwnd,2)
  kdim = size(uwnd,3)

! find reference level for non-propagating drag (z ~ pi U/N)

  do j=1,jdim
     do i=1,idim
        k = ktop(i,j)
        phase = 0.0
        zlast = zhalf(i,j,k)
        do while (phase <= Pi*zref_fac .and. k > 1)
           k = k-1
           vtau = 0.5*(dtaux(i,j,k-1) + dtaux(i,j,k))
           dzhalf = zfull(i,j,k-1) - zfull(i,j,k)
           bfreq2 = Grav*                                              &
                       ((atmp(i,j,k-1) - atmp(i,j,k))/dzhalf + lapse)/ &
                   (0.5*(atmp(i,j,k-1) + atmp(i,j,k)))
           bfreq = sqrt(max(tiny, bfreq2))
           rscale = max(bfmin, min(bfmax, bfreq))/max(vvmin, vtau)
           dzhalf = zfull(i,j,k-1) - zlast
           phase = phase + dzhalf*rscale
           zlast = zfull(i,j,k-1)
        enddo
        kref(i,j) = k
     enddo
  enddo

! CALCULATE DECELERATION DUE TO PROPAGATING DRAG (~-rho^-1 dtau/dz)

  do k=1,kdim
     do j=1,jdim
        do i=1,idim
          dp = phalf(i,j,k+1) - phalf(i,j,k)
          gfac = tausat(i,j,k+1) - tausat(i,j,k)
          gfac1 = gfac*Grav/(dp*taul(i,j))
          dtaux(i,j,k) = gfac1*taux(i,j)
          dtauy(i,j,k) = gfac1*tauy(i,j)
        enddo
     enddo
  enddo

! CALCULATE DECELERATION DUE TO NON-PROPAGATING DRAG

  do j=1,jdim
     do i=1,idim
        kr = kref(i,j)
        dp = phalf(i,j,kdim+1) - phalf(i,j,kr)
        gfac = taun(i,j)*Grav/(dp*taul(i,j))
        wtsum = 0.0
        do k=kr,kdim
           weight = pfull(i,j,k) - phalf(i,j,kr)
           wtsum = wtsum + weight
        enddo
        do k=kr,kdim
           weight = pfull(i,j,k) - phalf(i,j,kr)
           gfac1 = gfac*weight/wtsum
           dtaux(i,j,k) = dtaux(i,j,k) + gfac1*taux(i,j)
           dtauy(i,j,k) = dtauy(i,j,k) + gfac1*tauy(i,j)
        enddo
     enddo
  enddo

! CALCULATE HEATING TO CONSERVE TOTAL ENERGY

  if (do_conserve_energy) then
     dtemp = -((uwnd + 0.5*delt*dtaux)*dtaux                           &
             + (vwnd + 0.5*delt*dtauy)*dtauy)/Cp_Air
  else
     dtemp = 0.0
  endif

end subroutine topo_drag_tend

!=======================================================================

subroutine get_pbl ( atmp, zfull, pfull, phalf, ktop, kcut )

integer, intent(out), dimension(:,:) :: ktop, kcut
real, intent(in), dimension(:,:,:)   :: atmp
real, intent(in), dimension(:,:,:)   :: zfull, pfull, phalf

real, dimension(size(pfull,1),size(pfull,2)) :: pbot, tbot, zbot

integer :: i, idim
integer :: j, jdim
integer :: k, kdim

  idim = size(atmp,1)
  jdim = size(atmp,2)
  kdim = size(atmp,3)

  do j=1,jdim
     do i=1,idim
        pbot(i,j) = (1.0 - no_drag_frac)*phalf(i,j,kdim+1)
        tbot(i,j) = atmp(i,j,kdim) + tboost
        zbot(i,j) = zfull(i,j,kdim)
     enddo
  enddo

! find highest model level in no-drag surface layer

  ktop = kdim-1

  do k=kdim-2,2,-1
     where ( pfull(:,:,k) <= pbot(:,:) .and.                           &
           tbot(:,:) - atmp(:,:,k) > lapse*(zfull(:,:,k) - zbot(:,:)) )
        ktop = k
     endwhere
  enddo

! find lowest model level in no-drag top layer

  kcut = 1

  do k=2,kdim
     where ( pfull(:,:,k) <= pcut )
        kcut = k
     endwhere
  enddo

end subroutine get_pbl

!=======================================================================

subroutine topo_drag_init (lonb, latb)

real, intent(in), dimension(:,:) :: lonb, latb

character(len=128) :: msg
character(len=64)  :: restart_file='topo_drag.res.nc'
character(len=64)  :: topography_file='INPUT/postopog_2min_hp150km.nc'
character(len=64)  :: dragtensor_file='INPUT/dragelements_2min_hp150km.nc'
character(len=3)   :: tensornames(4) = (/ 't11', 't21', 't12', 't22' /)

real, parameter :: bfscale=1.0e-2      ! buoyancy frequency scale [1/s]

real, allocatable, dimension(:)   :: xdat, ydat
real, allocatable, dimension(:,:) :: zdat, zout
type (horiz_interp_type) :: Interp
real :: exponent

integer :: n
integer :: io, ierr, unit_nml, logunit
integer :: i, j
integer :: siz(4)
integer :: id_restart

  if (module_is_initialized) return

  nlon = size(lonb,1)-1
  nlat = size(latb,2)-1

! read namelist

#ifdef INTERNAL_FILE_NML
   read (input_nml_file, nml=topo_drag_nml, iostat=io)
   ierr = check_nml_error(io,'topo_drag_nml')
#else   
  if( file_exist( 'input.nml' ) ) then
     unit_nml = open_namelist_file ( )
     ierr = 1
     do while ( ierr /= 0 )
        read( unit_nml, nml = topo_drag_nml, iostat = io, end = 10 )
        ierr = check_nml_error (io, 'topo_drag_nml')
     end do
 10  call close_file ( unit_nml )
  endif
#endif

! write version number and namelist to logfile

  call write_version_number(version, tagname)
  logunit = stdlog()
  if (mpp_pe() == mpp_root_pe())                                       &
                                    write (logunit, nml=topo_drag_nml)

  allocate (t11(nlon,nlat))
  allocate (t21(nlon,nlat))
  allocate (t12(nlon,nlat))
  allocate (t22(nlon,nlat))
  allocate (hmin(nlon,nlat))
  allocate (hmax(nlon,nlat))

  if (gamma == beta + epsi) gamma = gamma + tiny

! read restart file

  id_restart = register_restart_field(Top_restart, restart_file, 't11', t11)
  id_restart = register_restart_field(Top_restart, restart_file, 't21', t21)
  id_restart = register_restart_field(Top_restart, restart_file, 't12', t12)
  id_restart = register_restart_field(Top_restart, restart_file, 't22', t22)
  id_restart = register_restart_field(Top_restart, restart_file, 'hmin', hmin)
  id_restart = register_restart_field(Top_restart, restart_file, 'hmax', hmax)
  restart_file = 'INPUT/'//trim(restart_file)
  if ( file_exist(restart_file) ) then

     if (mpp_pe() == mpp_root_pe()) then
        write ( msg, '("Reading restart file: ",a40)' ) restart_file
        call error_mesg('topo_drag_mod', msg, NOTE)
     endif
     call restore_state(Top_restart)

  else if (file_exist(topography_file) .and.                           &
           file_exist(dragtensor_file)) then

!    read and interpolate topography datasets

     if (mpp_pe() == mpp_root_pe()) then
        write ( msg, '("Reading topography file: ",a)')              &
                                                        trim(topography_file)
        call error_mesg('topo_drag_mod', msg, NOTE)
     endif

     ! check for correct field size in topography
     call field_size (topography_file, 'hpos', siz)
     if (siz(1) /= ipts .or. siz(2) /= jpts) then
         call error_mesg('topo_drag_mod', 'Field \"hpos\" in file '// &
                   trim(topography_file)//' has the wrong size', FATAL)
     endif
     
     allocate (xdat(ipts+1))
     allocate (ydat(jpts+1))
     allocate (zdat(ipts,jpts))
     allocate (zout(nlon,nlat))

     do i=1,ipts+1
        xdat(i) = (i-1)/resolution / Radian
     enddo
     do j=1,jpts+1
        ydat(j) = (-90.0 + (j-1)/resolution) / Radian
     enddo

     ! initialize horizontal interpolation
     ! Note: interp_method will be conservative for lat/lon grid
     !       and bilinear for all other grids
     call horiz_interp_init
     call horiz_interp_new ( Interp, xdat, ydat, lonb, latb )

     call read_data (topography_file, 'hpos', zdat, no_domain=.true.)

     exponent = 2.0 - gamma
     zdat = max(0.0, zdat)**exponent
     
     call horiz_interp ( Interp, zdat, zout )

     hmax = abs(zout)**(1.0/exponent) * sqrt(2.0/exponent)
     hmin = hmax*h_frac

     if (mpp_pe() == mpp_root_pe()) then
        write ( msg, '("Reading drag tensor file: ",a)')             &
                                                        trim(dragtensor_file)
        call error_mesg('topo_drag_mod', msg, NOTE)
     endif

     ! check for correct field size in tensor file
     call field_size (dragtensor_file, tensornames(1), siz)
     if (siz(1) /= ipts .or. siz(2) /= jpts) then
         call error_mesg('topo_drag_mod', 'Field \"'//tensornames(1)// &
         '\" in file '//trim(dragtensor_file)//' has the wrong size', FATAL)
     endif

     do n=1,4
        call read_data (dragtensor_file, tensornames(n), zdat, no_domain=.true.)
        call horiz_interp ( Interp, zdat, zout )
       !call horiz_interp ( zdat, xdat, ydat, lonb, latb, zout,        &
       !                                 interp_method='conservative' )
        if ( tensornames(n) == 't11' ) then
           t11 = zout/bfscale
        else if ( tensornames(n) == 't21' ) then
           t21 = zout/bfscale
        else if ( tensornames(n) == 't12' ) then
           t12 = zout/bfscale
        else if ( tensornames(n) == 't22' ) then
           t22 = zout/bfscale
        endif
     enddo

     deallocate (zdat, zout)
     call horiz_interp_del ( Interp )

  else

     call ERROR_MESG ('topo_drag_init',                                &
                'No sub-grid orography available for topo_drag', FATAL)

  endif

  module_is_initialized = .true.

end subroutine topo_drag_init

!=======================================================================

subroutine topo_drag_end

! writes static arrays to restart file

  if (mpp_pe() == mpp_root_pe() ) then
     call error_mesg('topo_drag_mod', 'Writing netCDF formatted restart file: RESTART/topo_drag.res.nc', NOTE)
  endif

  call topo_drag_restart

  module_is_initialized = .false.

end subroutine topo_drag_end

!#######################################################################
! <SUBROUTINE NAME="topo_drag_restart">
!
! <DESCRIPTION>
! write out restart file.
! Arguments: 
!   timestamp (optional, intent(in)) : A character string that represents the model time, 
!                                      used for writing restart. timestamp will append to
!                                      the any restart file name as a prefix. 
! </DESCRIPTION>
!
subroutine topo_drag_restart(timestamp)
   character(len=*), intent(in), optional :: timestamp

   call save_restart(Top_restart, timestamp)

end subroutine topo_drag_restart
! </SUBROUTINE>

!#######################################################################

endmodule topo_drag_mod

module ocean_model_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Matt Harrison
!</CONTACT>
!
!<OVERVIEW>
! Time step the ocean model using either a twolevel staggered scheme
! (the default) or threelevel leap-frog scheme (the older approach).
! Threelevel scheme remains only for legacy purposes and is not 
! recommended for normal use.   
!</OVERVIEW>
!
!<DESCRIPTION>
! Top level module for ocean model.  Contains routines for 
! initialization, termination, and update of ocean model state.
!
! Design consideration: declarations of top level ocean variables
! are private to this module and hence are only available to other routines
! through argument lists.  For instance, timestep information is passed to
! the various modules on the initialization call and stored internally
! in the respective modules.  This is a crucial design consideration sinces
! it maintains modularity and hence maintainability of the code.
!</DESCRIPTION>
!
!<NAMELIST NAME="ocean_model_nml">
!  <DATA NAME="layout" TYPE="integer">
!  Processor domain layout for ocean model. 
!  </DATA> 
!
!  <DATA NAME="io_layout" TYPE="integer, dimension(2)">
!  Processor IO domain layout for ocean model. The default value is (0,0).
!  If either io_layout(1) or (2) is 0, it will default to the number of
!  processors in the computational layout, except restart file will default 
!  to single file if fms_io_nml fileset_write is set to 'single'.  When
!  both entry of io_layout is positive, io_domain will be defined(a pointer in domain2d)
!  and number of distributed files will be layout(1)*layout(2). For example, assume 
!  the restart file is ocean_velocity.res.nc and the diagnostics file is ocean_daily.nc, 
!  if the layout = (1,2), the restart files will be ocean_velocity.res.nc.0000 and 
!  ocean_veloicity.res.nc.0001, the diagnostics files will be ocean_daily.res.nc.0000 
!  and ocean_daily.res.nc.0001. When the io_domain is defined, restart file and 
!  diagnostics file name will be controlled by the io_domain (ignoring fms_io_nml fileset_write). 
!  </DATA> 
!
!   <DATA NAME="dt_ocean"  TYPE="integer"  DEFAULT="-1">
!     Ocean model time step in seconds. 
!   </DATA>
!
!  <DATA NAME="time_tendency" TYPE="character">
!
!  Possible time stepping schemes are the following. 
!
!  1. "threelevel" has the following characteristics
!
!     leap-frog for the time tendency which means the 
!     inviscid/nondissipative processes are at time tau.  
!
!     forward for lateral mixing processes (dissipation at taum1)
!
!     implicit for vertical dissipative (with aidif = 1.0)
!
!     semi-implicit for Coriolis (with acor>0) 
!
!     Because of the need to apply time filters to suppress 
!     leap-frog splitting, the threelevel time stepping scheme
!     does not conserve total tracer content in the model.  
!
!  2. "twolevel" has the following characteristics: 
!
!     staggered 2nd order forward time tendency, which means 
!     that tracer advection, lateral tracer and velocity mixing, 
!     are at time tau. Pressure gradients are at taup1.  
!
!     Adams-Bashforth (either 2nd or 3rd order) for velocity advection  
!     Third order is default as it is more stable.  
!
!     implicit vertical mixing (with aidif = 1.0)
!
!     semi-implicit for Coriolis (with acor > 0) 
!
!     This scheme conserves total volume and tracer in the ocean model.  
!
!  </DATA> 
!
!  <DATA NAME="vertical_coordinate" TYPE="character">
!  This string determines the vertical coordinate used in MOM.
!
!  There are 3 + 3 options in MOM:
!  Depth-based Boussinesq are 'geopotential', 'zstar', 'zsigma', 
!  Pressure-based non-Boussinesq are 'pressure', 'pstar', and 'psigma'.  
!
!  The two terrain-following sigma options are not well tested in MOM, 
!  whereas the other options are standard.  The recommended Boussinesq 
!  vertical coordinate is zstar, and the recommended non-Boussineq 
!  coordinate is pstar.  The default is vertical_coordinate='zstar'.  
!  </DATA> 
!
!  <DATA NAME="horizontal_grid" TYPE="character">
!  This string determines the arrangement of variables on the 
!  discrete horizontal grid. The standard case is horizontal_grid='bgrid'.
!  However, the C-grid is being developed in MOM.  It is not yet 
!  supported for general use. Default horizontal_grid='bgrid'.  
!  </DATA> 
!
!  <DATA NAME="impose_init_from_restart" TYPE="logical">
!  Consider the following situation:  We have run the model for many years
!  and generated restarts. Time%init is then .false.  Then, we wish to start
!  a series of perturbation experiments from this restart file.  The generic
!  situation is for Time%init to then be .true. However, we need it to be 
!  .false. in MOM in order to have a proper reading of the full restart
!  information. Setting impose_init_from_restart=.true. will facilitate
!  this setup.  The default is impose_init_from_restart=.false., in which case
!  the model will run through its normal start/stop segments using restarts. 
!  </DATA> 
!
!  <DATA NAME="baroclinic_split" TYPE="integer">
!  baroclinic_split = dtts/dtuv 
!                   = (tracer time step)/(baroclinic time step)
!                   = (ocean model time step)/(baroclinic time step)
!  Transients corrupted if baroclinic_split > 1, so it is recommended
!  to use baroclinic_split=1. 
!  </DATA> 
!
!  <DATA NAME="barotropic_split" TYPE="integer">
!  Ratio barotropic_split = dtuv/dtbt
!                         = (baroclinic time step)/(barotropic time step). 
!  Must be large enough to resolve the barotropic gravity waves 
!  captured by the barotropic part of the model. 
!  Barotropic waves are dissipated when this splitting 
!  is greater than unity. Model algorithm is not fully 
!  implemented when barotropic_split=1, so user beware
!  if wishing to run an unsplit model simulation. 
!  </DATA> 
!
!  <DATA NAME="surface_height_split" TYPE="integer">
!  Ratio surface_height_split = dtts/dteta
!                             = (tracer time step)/(surface height time step)
!                             = (tracer time step)/(bottom pressure time step) 
!  Typically this split is set to unity for models where baroclinic_split=1,
!  but something larger when baroclinic_split is order 10.  dteta is the time 
!  step used for update of eta_t or pbot_t. If surface_height_split is 
!  not equal to unity, then tracer conservation properties are compromised. 
!  </DATA> 
!
!  <DATA NAME="reinitialize_thickness" TYPE="logical">
!  When initialized with a nontrivial eta field, it is 
!  necessary to reinitialize the thickness arrays.
!  </DATA> 
!
!  <DATA NAME="cmip_units" TYPE="logical">
!  For CMIP output, we need to have temperature in K (if cmip_version<=5)
!  and mass transport in kg/s.  The flag cmip_units=.true. will 
!  diagnose CMIP5-related fields with the CMIP units for sending
!  to the diagnostic manager. 
!  Default cmip_units=.false. 
!  </DATA> 
!
!  <DATA NAME="cmip_version" TYPE="integer">
!  Specifies CMIP version used when cmip_units=.true.
!  Temperature is in K if cmip_version<=5, otherwise degrees C.
!  Default cmip_version=5.
!  </DATA> 
!
!  <DATA NAME="use_blobs" TYPE="logical">
!  For using Lagrangian blobs.
!  Default use_blobs=.false.   
!  </DATA>
!  
!  <DATA NAME="introduce_blobs" TYPE="logical">
!  For the Lagrangian blobs after a model has already been running.
!  Default introduce_blobs=.false.
!  </DATA>
!  
!  <DATA NAME="use_velocity_override" TYPE="logical">
!  For over-riding the velocity field with values from
!  a file.  Note that we need separate files for
!  (u,v) read into ocean_velocity.F90, as well as 
!  (udrho,vdrho) read into ocean_barotropic.F90. 
!  Default use_velocity_override=.false.   
!  </DATA>
!  
!  <DATA NAME="debug" TYPE="logical">
!  For overall model debugging. Set true to print cksums at 
!  each timestep for debugging purposes.
!  </DATA>
!
!  <DATA NAME="mask_table" TYPE="character">
!  A text file to specify n_mask, layout and mask_list.  This table 
!  aims to reduce the number of processors that are cycling over pure 
!  land regions.  These processors will be masked out of regions that 
!  which contain all land points. 
!
!  The default file name of mask_table is "INPUT/ocean_mask_table". 
!  Please note that the file name must begin with "INPUT/". 
!
!  The first line of mask_table is the number of region to be masked out. 
!  The second line is the layout of the model. User need to set ocean_model_nml
!  variable layout to be the same as the second line of the mask table.
!  The following n_mask line will be the position of the processor to be masked out.
!
!  The mask_table could be created by tools check_mask. 
!
!  For example the mask_table will be as following if n_mask=2, layout=4,6 and 
!  the processor (1,2) and (3,6) are to be masked out. 
!     2
!     4,6
!     1,2
!     3,6
!  </DATA>
!
  
!</NAMELIST>

use fms_mod,                  only: FATAL, NOTE, WARNING, file_exist
use fms_mod,                  only: write_version_number, open_namelist_file, close_file, check_nml_error
use fms_mod,                  only: clock_flag_default
use fms_io_mod,               only: set_domain, nullify_domain, parse_mask_table
use mpp_domains_mod,          only: domain2d, BITWISE_EXACT_SUM, NON_BITWISE_EXACT_SUM
use mpp_domains_mod,          only: mpp_update_domains, BGRID_NE, CGRID_NE, mpp_get_compute_domain
use mpp_mod,                  only: input_nml_file, mpp_error, mpp_pe, mpp_root_pe, mpp_npes, mpp_chksum, stdlog, stdout
use mpp_mod,                  only: mpp_clock_id, mpp_clock_begin, mpp_clock_end
use mpp_mod,                  only: CLOCK_COMPONENT, CLOCK_SUBCOMPONENT, CLOCK_MODULE, CLOCK_ROUTINE
use stock_constants_mod,      only: ISTOCK_WATER, ISTOCK_HEAT, ISTOCK_SALT
use time_interp_external_mod, only: time_interp_external_init
use time_manager_mod,         only: JULIAN, get_date, get_time, print_time
use time_manager_mod,         only: time_type, operator( /= ), operator( < ), operator ( / )
use time_manager_mod,         only: set_time, operator(-), operator( + ), operator( == )
use time_manager_mod,         only: operator(*)

use ocean_advection_velocity_mod, only: ocean_advection_velocity_init, ocean_advection_velocity
use ocean_advection_velocity_mod, only: ocean_advection_velocity_end
use ocean_barotropic_mod,         only: ocean_barotropic_init, ocean_barotropic_end
use ocean_barotropic_mod,         only: update_ocean_barotropic
use ocean_barotropic_mod,         only: ocean_barotropic_forcing, ocean_mass_forcing
use ocean_barotropic_mod,         only: ocean_eta_smooth, ocean_pbot_smooth
use ocean_barotropic_mod,         only: eta_and_pbot_update, eta_and_pbot_diagnose, eta_and_pbot_tendency
use ocean_barotropic_mod,         only: ocean_barotropic_restart
use ocean_bbc_mod,                only: ocean_bbc_init, get_ocean_bbc
use ocean_bih_friction_mod,       only: ocean_bih_friction_init, ocean_bih_friction_end
use ocean_bih_friction_mod,       only: ocean_bih_friction_restart
use ocean_blob_mod,               only: ocean_blob_init, ocean_blob_update, ocean_blob_cell_update
use ocean_blob_mod,               only: update_L_thickness, ocean_blob_diagnose_depth, ocean_blob_end
use ocean_blob_mod,               only: init_blob_thickness, calculate_rhoT
use ocean_convect_mod,            only: ocean_convect_init
use ocean_coriolis_mod,           only: ocean_coriolis_init
use ocean_density_mod,            only: ocean_density_init, ocean_density_end
use ocean_density_mod,            only: update_ocean_density
use ocean_density_mod,            only: update_ocean_density_salinity
use ocean_density_mod,            only: ocean_density_restart, ocean_density_diag
use ocean_diagnostics_mod,        only: ocean_diag_init, ocean_diagnostics
use ocean_domains_mod,            only: ocean_domain_init, set_ocean_domain, get_local_indices
use ocean_form_drag_mod,          only: ocean_form_drag_init, compute_visc_form_drag
use ocean_grids_mod,              only: ocean_grids_init, set_ocean_grid_size 
use ocean_grids_mod,              only: set_ocean_hgrid_arrays, set_ocean_vgrid_arrays, init_grids_diag
use ocean_increment_eta_mod,      only: ocean_increment_eta_init, ocean_increment_eta_source
use ocean_increment_tracer_mod,   only: ocean_increment_tracer_init, ocean_increment_tracer_source
use ocean_increment_velocity_mod, only: ocean_increment_velocity_init, ocean_increment_velocity_source
use ocean_lap_tracer_mod,         only: ocean_lap_tracer_init
use ocean_bih_tracer_mod,         only: ocean_bih_tracer_init
use ocean_lap_friction_mod,       only: ocean_lap_friction_init, ocean_lap_friction_end
use ocean_lap_friction_mod,       only: ocean_lap_friction_restart
use ocean_mixdownslope_mod,       only: ocean_mixdownslope_init, mixdownslope
use ocean_momentum_source_mod,    only: ocean_momentum_source_init
use ocean_nphysics_mod,           only: ocean_nphysics_init, ocean_nphysics_end, neutral_physics
use ocean_nphysics_mod,           only: ocean_nphysics_restart
use ocean_nphysics_new_mod,       only: ocean_nphysics_new_init, ocean_nphysics_new_end, neutral_physics_new
use ocean_nphysics_new_mod,       only: ocean_nphysics_new_restart
use ocean_obc_mod,                only: ocean_obc_init, ocean_obc_end
use ocean_obc_mod,                only: ocean_obc_update_boundary, ocean_obc_prepare
use ocean_obc_mod,                only: ocean_obc_restart
use ocean_operators_mod,          only: ocean_operators_init
use ocean_overexchange_mod,       only: ocean_overexchange_init, overexchange
use ocean_overflow_mod,           only: ocean_overflow_init, overflow
use ocean_overflow_OFP_mod,       only: ocean_overflow_OFP_init, overflow_OFP
use ocean_passive_mod,            only: ocean_passive_tracer_init
use ocean_pressure_mod,           only: ocean_pressure_init
use ocean_rivermix_mod,           only: ocean_rivermix_init, rivermix
use ocean_riverspread_mod,        only: ocean_riverspread_init
use ocean_parameters_mod,         only: ocean_parameters_init, ocean_parameters_end 
use ocean_parameters_mod,         only: MOM_BGRID, MOM_CGRID 
use ocean_parameters_mod,         only: TWO_LEVEL, THREE_LEVEL
use ocean_parameters_mod,         only: GEOPOTENTIAL, ZSTAR, ZSIGMA, PRESSURE, PSTAR, PSIGMA
use ocean_parameters_mod,         only: DEPTH_BASED, PRESSURE_BASED
use ocean_parameters_mod,         only: QUASI_HORIZONTAL, TERRAIN_FOLLOWING
use ocean_parameters_mod,         only: VERTMIX_GOTM, cp_ocean
use ocean_sbc_mod,                only: ocean_sbc_init, initialize_ocean_sfc, ocean_sfc_end
use ocean_sbc_mod,                only: sum_ocean_sfc, avg_ocean_sfc, get_ocean_sbc, flux_adjust
use ocean_sbc_mod,                only: ocean_sfc_restart
use ocean_shortwave_mod,          only: ocean_shortwave_init, sw_source
use ocean_sigma_transport_mod,    only: ocean_sigma_transport_init, sigma_transport, ocean_sigma_transport_end
use ocean_sigma_transport_mod,    only: ocean_sigma_transport_restart
use ocean_sponges_eta_mod,        only: ocean_sponges_eta_init, sponge_eta_source
use ocean_sponges_tracer_mod,     only: ocean_sponges_tracer_init, sponge_tracer_source
use ocean_sponges_velocity_mod,   only: ocean_sponges_velocity_init, sponge_velocity_source
use ocean_submesoscale_mod,       only: ocean_submesoscale_init, submeso_restrat
use ocean_tempsalt_mod,           only: ocean_tempsalt_ideal_reinit
use ocean_thickness_mod,          only: ocean_thickness_init, ocean_thickness_init_adjust
use ocean_thickness_mod,          only: ocean_thickness_end, rho_dzt_tendency
use ocean_thickness_mod,          only: update_tcell_thickness, update_ucell_thickness
use ocean_thickness_mod,          only: update_tcell_thick_blob, update_E_thickness
use ocean_thickness_mod,          only: ocean_thickness_restart, dzt_dst_update
use ocean_topog_mod,              only: ocean_topog_init
use ocean_tracer_advect_mod,      only: ocean_tracer_advect_init, ocean_tracer_advect_end
use ocean_tracer_advect_mod,      only: ocean_tracer_advect_restart
use ocean_tracer_mod,             only: ocean_prog_tracer_init, ocean_diag_tracer_init
use ocean_tracer_mod,             only: update_ocean_tracer, ocean_tracer_end, compute_tmask_limit
use ocean_tracer_mod,             only: ocean_tracer_diagnostics_init, ocean_tracer_restart
use ocean_tracer_util_mod,        only: ocean_tracer_util_init
use ocean_tpm_mod,                only: ocean_tpm_source, ocean_tpm_bbc, ocean_tpm_tracer
use ocean_tpm_mod,                only: ocean_tpm_end, ocean_tpm_start
use ocean_tpm_mod,                only: ocean_tpm_flux_init, ocean_tpm_init_sfc
use ocean_types_mod,              only: ocean_time_type, ocean_time_steps_type
use ocean_types_mod,              only: ocean_grid_type, ocean_thickness_type
use ocean_types_mod,              only: ocean_domain_type, ice_ocean_boundary_type, ocean_public_type
use ocean_types_mod,              only: ocean_external_mode_type, ocean_adv_vel_type
use ocean_types_mod,              only: ocean_velocity_type, ocean_density_type, ocean_options_type
use ocean_types_mod,              only: ocean_prog_tracer_type, ocean_diag_tracer_type
use ocean_types_mod,              only: ocean_types_init, ocean_lagrangian_type, blob_diag_type
use ocean_util_mod,               only: ocean_util_init, write_timestamp
use ocean_velocity_advect_mod,    only: ocean_velocity_advect_init
use ocean_velocity_diag_mod,      only: pressure_conversion, energy_analysis
use ocean_velocity_mod,           only: ocean_velocity_init, ocean_velocity_end
use ocean_velocity_mod,           only: update_ocean_velocity_bgrid, update_ocean_velocity_cgrid 
use ocean_velocity_mod,           only: ocean_explicit_accel_a, ocean_explicit_accel_b, ocean_implicit_accel
use ocean_velocity_mod,           only: ocean_velocity_restart
use ocean_vert_mix_mod,           only: ocean_vert_mix_init, ocean_vert_mix_end, vert_mix_coeff
use ocean_vert_mix_mod,           only: ocean_vert_mix_restart
use ocean_vert_gotm_mod,          only: advect_gotm_compute
use ocean_workspace_mod,          only: ocean_workspace_init, wrk1
use ocean_xlandinsert_mod,        only: ocean_xlandinsert_init, xlandinsert
use ocean_xlandmix_mod,           only: ocean_xlandmix_init, xlandmix
use ocean_drifters_mod,           only: ocean_drifters_init, update_ocean_drifters, ocean_drifters_end
use wave_types_mod,               only: ocean_wave_type
use ocean_wave_mod,               only: ocean_wave_init, ocean_wave_end, ocean_wave_model
use version_mod,                  only: MOM_COMMIT_HASH

#if defined(ACCESS_CM) || defined(ACCESS_OM)
  use auscom_ice_mod, only: auscom_ice_init
  use auscom_ice_parameters_mod,  only: redsea_gulfbay_sfix, do_sfix_now
#else
  use sat_vapor_pres_mod,         only: sat_vapor_pres_init
#endif

#ifdef ENABLE_ODA
#ifdef ENABLE_ECDA
  use oda_types_mod, only : da_flux_type
  use oda_driver_ecda_mod, only : init_oda, oda, oda_end
#else
  use oda_driver_mod, only : init_oda, oda
#endif
#endif

implicit none

private


#include <ocean_memory.h>

#if defined (ENABLE_ODA) && defined (ENABLE_ECDA)
  integer :: is_sfc, ie_sfc, js_sfc, je_sfc, i_shift, j_shift, ii, jj ! snz
#endif

#ifdef MOM_STATIC_ARRAYS

  real, dimension(isd:ied,jsd:jed,nk,2) :: diff_cbt           ! diffusion coefficient at base of tracer cells (m^2/sec):  
                                                              ! n=1 for temp; n=2 for salinity and passive scalars  
  real, dimension(isd:ied,jsd:jed,nk)   :: visc_cbu           ! viscosity at base of B-grid velocity cells (m^2/sec)
  real, dimension(isd:ied,jsd:jed,nk)   :: visc_cbt           ! viscosity acting on C-grid u/v-velocity (m^2/sec)
  real, dimension(isd:ied,jsd:jed,nk)   :: gm_diffusivity     ! diffusivity from GM on T-cells (m^2/sec)
  real, dimension(isd:ied,jsd:jed,nk,2) :: visc_cbu_form_drag ! viscosity (m^2/sec) from Greatbatch form drag

  real, dimension(isd:ied,jsd:jed)      :: pme           ! mass flux per horz area of precip-evap (kg/(s*m^2))
  real, dimension(isd:ied,jsd:jed)      :: melt          ! mass flux per horz area of ice melt water (kg/(s*m^2))
  real, dimension(isd:ied,jsd:jed,2)    :: upme          ! horizontal velocity of precip minus evap (m/s)
  real, dimension(isd:ied,jsd:jed)      :: river         ! mass flux of river (runoff+calving) per horz area (kg/(s*m^2))
  real, dimension(isd:ied,jsd:jed)      :: runoff        ! mass flux of river runoff (liquid) per horz area from (kg/(s*m^2))
  real, dimension(isd:ied,jsd:jed)      :: calving       ! mass flux of calving land ice per horz area from (kg/(s*m^2))
  real, dimension(isd:ied,jsd:jed,2)    :: uriver        ! horizontal velocity from river runoff+calving
  real, dimension(isd:ied,jsd:jed)      :: patm          ! pressure at ocean top from atmosphere and/or ice (Pa) 
  real, dimension(isd:ied,jsd:jed)      :: swflx         ! short wave radiation flux (W/m^2)
  real, dimension(isd:ied,jsd:jed)      :: swflx_vis     ! visible short wave radiation flux (W/m^2)
  real, dimension(isd:ied,jsd:jed,nk)   :: sw_frac_zt    ! short wave radiation flux fraction
  real, dimension(isd:ied,jsd:jed,nk)   :: opacity       ! attenuation of visible light (1/metre)
  real, dimension(isd:ied,jsd:jed)      :: surf_blthick  ! surf boundary layer depth from vertical mixing scheme (m)
  real, dimension(isd:ied,jsd:jed)      :: bott_blthick  ! bottom boundary layer depth from sigma transport (m)
  real, dimension(isd:ied,jsd:jed)      :: rossby_radius ! rossby radius (m)
  real, dimension(isd:ied,jsd:jed,nk)   :: swheat        ! external shortwave heating source W/m^2

#else

  real, pointer, dimension(:,:,:,:) :: diff_cbt            =>NULL() ! diffusion coefficient at base of tracer cells (m^2/sec): 
                                                                    ! n=1 for temp; n=2 for salinity and passive scalars 
  real, pointer, dimension(:,:,:)   :: visc_cbu            =>NULL() ! viscosity at base of Bgrid velocity cells (m^2/sec)
  real, pointer, dimension(:,:,:)   :: visc_cbt            =>NULL() ! viscosity acting on C-grid u/v-velocity (m^2/sec)
  real, pointer, dimension(:,:,:)   :: gm_diffusivity      =>NULL() ! diffusivity for GM on T-cells (m^2/sec)
  real, pointer, dimension(:,:,:,:) :: visc_cbu_form_drag  =>NULL() ! viscosity (m^2/sec) from Greatbatch form drag

  real, pointer, dimension(:,:)     :: pme                 =>NULL() ! mass flux per horz area from precip-evap (kg/(s*m^2))
  real, pointer, dimension(:,:)     :: melt                =>NULL() ! mass flux per horz area of ice melt water (kg/(s*m^2))
  real, pointer, dimension(:,:,:)   :: upme                =>NULL() ! horizontal velocity of precip minus evap (m/s)
  real, pointer, dimension(:,:)     :: river               =>NULL() ! mass flux of river (runoff+calving) per horz area (kg/(s*m^2)) 
  real, pointer, dimension(:,:)     :: runoff              =>NULL() ! mass flux of river runoff (liquid) per horz area from (kg/(s*m^2)) 
  real, pointer, dimension(:,:)     :: calving             =>NULL() ! mass flux of calving land ice per horz area (kg/(s*m^2)) 
  real, pointer, dimension(:,:,:)   :: uriver              =>NULL() ! horizontal velocity from river (m/s)
  real, pointer, dimension(:,:)     :: patm                =>NULL() ! pressure at ocean top from sea ice and/or atmosphere (Pa) 
  real, pointer, dimension(:,:)     :: swflx               =>NULL() ! short wave radiation flux (W/m^2) 
  real, pointer, dimension(:,:)     :: swflx_vis           =>NULL() ! short wave radiation flux (W/m^2) 
  real, pointer, dimension(:,:,:)   :: sw_frac_zt          =>NULL() ! short wave radiation flux fraction
  real, pointer, dimension(:,:,:)   :: opacity             =>NULL() ! attenuation of visible light (1/metre)
  real, pointer, dimension(:,:)     :: surf_blthick        =>NULL() ! surf boundary layer depth from vertical mixing scheme (m)
  real, pointer, dimension(:,:)     :: bott_blthick        =>NULL() ! bottom boundary layer depth from sigma transport (m)
  real, pointer, dimension(:,:)     :: rossby_radius       =>NULL() ! rossby radius (m) 
  real, pointer, dimension(:,:,:)   :: swheat              =>NULL() ! external shortwave heating source W/m^2

#endif

  ! for running Time%init=.true. yet using a restart file 
  logical :: impose_init_from_restart=.false. 

  ! to initialize with a nontrivial eta or pbot (from ocean_barotropic)
  ! we then need to reinitialize the thickness arrays, since they originally
  ! assumed eta_t=0 and pbot_t=pbot0. 
  logical :: reinitialize_thickness=.false.  

  ! for running with an externally provided shortwave heating source
  logical :: ext_swheat_is_set=.false.

  ! time step related variables 
  real :: dtts=0   ! tracer timestep (seconds)
  real :: dtuv=0   ! internal mode timestep (seconds)
  real :: dtbt=0   ! external mode timestep (seconds)
  real :: dteta=0  ! ocean volume time step (eta_t) (seconds)
  real :: dtime_t  ! 2*dtts  for threelevel and dtts  for twolevel
  real :: dtime_u  ! 2*dtuv  for threelevel and dtvu  for twolevel
  real :: dtime_e  ! 2*dteta for threelevel and dteta for twolevel

  ! setting the number of prognostic and diagnostic tracers  
  ! both determined by reading field_table 
  integer :: num_prog_tracers=-1 ! (e.g., temp, salt, age)
  integer :: num_diag_tracers=-1 ! (e.g., frazil, pH) 

  ! number of ocean calls 
  integer :: num_ocean_calls 
  logical :: first_ocn_call=.true. 

  ! for setting model time steps 
  integer :: baroclinic_split    =1  ! ratio of tracer timestep dtts to baroclinic timestep dtuv
  integer :: surface_height_split=1  ! ratio of tracer timestep dtts to the eta_t (or pbot_t) timestep dteta 
  integer :: barotropic_split    =30 ! ratio of baroclinic timestep dtuv to barotropic timestep dtbt

  ! for setting how terms in the equations are time stepped
  ! select time tendency ('threelevel' or 'twolevel")
  ! tendency is an integer corresponding to choice of time tendency 
  character(len=32) :: time_tendency='twolevel' 
  integer :: tendency=0                         

  ! valid vertical coordinate options are the following:
  ! geopotential, zstar, zsigma, pressure, pstar, psigma
  character(len=32) :: vertical_coordinate='zstar' 

  ! integers corresponding to choice of vertical coordinate
  integer :: vert_coordinate         
  integer :: vert_coordinate_class
  integer :: vert_coordinate_type

  ! horizontal grid options 'bgrid' and 'cgrid' 
  character(len=32) :: horizontal_grid='bgrid'  
  integer :: horz_grid=1

  character(len=128) :: version = '$Id: ocean_model.F90,v 20.0 2013/12/14 00:10:47 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

  type(ocean_external_mode_type), save           :: Ext_mode
  type(ocean_adv_vel_type),       save           :: Adv_vel
  type(ocean_density_type),       target, save   :: Dens
  type(ocean_domain_type),        target, save   :: Domain

  type(ocean_grid_type),          target, save   :: Grid
  type(ocean_thickness_type),     target, save   :: Thickness

  type(ocean_time_type),          target, save   :: Time
  type(ocean_time_steps_type),    target, save   :: Time_steps
  type(ocean_options_type),       target, save   :: Ocean_options
  type(ocean_velocity_type),      target, save   :: Velocity

  type(ocean_lagrangian_type),    target, save   :: Lagrangian_system
  type(blob_diag_type), dimension(:), allocatable, save :: EL_diag

  type(ocean_prog_tracer_type), dimension(:), pointer, save :: T_prog =>NULL()
  type(ocean_diag_tracer_type), dimension(:), pointer, save :: T_diag =>NULL() 

  type(ocean_wave_type),          target, save   :: Waves

#if defined (ENABLE_ODA) && defined (ENABLE_ECDA)
  type(da_flux_type), target, save :: da_flux ! snz
#endif

  ! identification numbers for mpp clocks
  integer :: id_init
  integer :: id_advect
  integer :: id_vmix
  integer :: id_neutral
  integer :: id_compute_visc_form_drag
  integer :: id_submesoscale
  integer :: id_sw
  integer :: id_sponges_tracer
  integer :: id_sponges_eta
  integer :: id_sponges_velocity
  integer :: id_sigma
  integer :: id_tracer
  integer :: id_bbc
  integer :: id_sbc
  integer :: id_flux_adjust
  integer :: id_explicit_accel_a
  integer :: id_explicit_accel_b
  integer :: id_implicit_accel
  integer :: id_bottom_smooth
  integer :: id_surface_smooth
  integer :: id_eta_and_pbot_tendency
  integer :: id_eta_and_pbot_update
  integer :: id_eta_and_pbot_diagnose
  integer :: id_rho_dzt_tendency
  integer :: id_dzt_dst_update
  integer :: id_mass_forcing 
  integer :: id_barotropic_forcing
  integer :: id_barotropic_update
  integer :: id_velocity
  integer :: id_xlandinsert
  integer :: id_xlandmix
  integer :: id_overflow
  integer :: id_overflow_OFP
  integer :: id_overexchange
  integer :: id_mixdownslope
  integer :: id_blob_update
  integer :: id_blob_cell_update
  integer :: id_blob_diagnose_depth
  integer :: id_tcell_thickness_blob
  integer :: id_update_L_thickness
  integer :: id_update_E_thickness
  integer :: id_rivermix
  integer :: id_density
  integer :: id_density_diag
  integer :: id_otpm_source
  integer :: id_otpm_bbc
  integer :: id_otpm_tracer
  integer :: id_diagnostics
  integer :: id_tcell_thickness
  integer :: id_ucell_thickness
  integer :: id_update_halo_tracer
  integer :: id_update_halo_velocity
  integer :: id_oda
  integer :: id_ocean_sfc
  integer :: id_ocean_seg_end
  integer :: id_tmask_limit
  integer :: id_ocean
  integer :: id_advect_gotm
  integer :: id_increment_tracer
  integer :: id_increment_eta
  integer :: id_increment_velocity
  integer :: id_salinity
  integer :: id_wave
#if defined(ACCESS_CM) || defined(ACCESS_OM)
  integer :: id_sfix
#endif

  public ocean_model_init
  public ocean_model_end
  public update_ocean_model
  public get_ocean_domain
  public get_ocean_grid_size
  public ocean_public_type
  public ice_ocean_boundary_type
  public ocean_model_init_sfc
  public ocean_model_flux_init
  public ocean_stock_pe
  public ocean_model_restart

  ! routines for interfacing to other models 
  public mom4_get_Tsurf
  public mom4_get_Ssurf
  public mom4_get_UVsurf
  public mom4_get_thickness
  public mom4_get_density
  public mom4_get_prog_tracer
  public mom4_get_temperature_index
  public mom4_get_salinity_index
  public mom4_get_UV
  public mom4_get_dimensions
  public mom4_get_diag_axes
  public mom4_get_num_diag_tracers
  public mom4_get_num_prog_tracers
  public mom4_get_ocean_data
  public mom4_get_surface_tmask 
  public mom4_get_latlon_UV
  public mom4_set_swheat

  public    ocean_model_data_get
  interface ocean_model_data_get
    module procedure ocean_model_data1D_get 
    module procedure ocean_model_data2D_get 
  end interface

  public ice_ocn_bnd_type_chksum
  public ocean_public_type_chksum

  ! for the temperature variable 
  integer :: temp_variable=0 

  ! index for temperature (degC) and salinity (psu or g/kg) 
  integer :: index_temp =-1    
  integer :: index_salt =-1

  ! index for FAFMIP redistributed heat tracer (degC) 
  integer :: index_redist_heat=-1

  ! domain layout for parallel processors. for npe=1, layout(2)=(/1,1/)
  integer :: layout(2)=(/1,1/) 

  ! IO domain layout for parallel processors. 
  integer :: io_layout(2)=(/0,0/)   

  ! to print various cksums for debugging purposes
  logical :: debug = .false. 

  ! mask_table contains information for masking domain ( n_mask, layout and mask_list).
  character(len=128) :: mask_table = "INPUT/ocean_mask_table"

  logical :: module_is_initialized =.false.
  logical :: have_obc              =.false.   
  logical :: cmip_units            =.false.
  integer :: cmip_version          =5
  logical :: use_blobs             =.false.
  logical :: introduce_blobs       =.false.
  logical :: use_velocity_override =.false.
  logical :: do_wave               =.false.
  
  ! Namelist variables for ECDA
  real :: beta_txty = 0.0
  real :: beta_tf   = 0.0
  real :: beta_qf   = 0.0
  real :: beta_lwsw = 0.0

  type, public ::  ocean_state_type; private
     ! This type is private, and can therefore vary between different ocean models.
     ! All information entire ocean state may be contained here, although it is not
     ! necessary that this is implemented with all models.
     logical       :: is_ocean_pe = .false.       ! .true. on processors that run the ocean model.
  end type ocean_state_type

  integer :: dt_ocean = -1  ! ocean tracer timestep

  namelist /ocean_model_nml/ time_tendency, impose_init_from_restart, reinitialize_thickness,    &
                             baroclinic_split, barotropic_split, surface_height_split,           &
                             layout, io_layout, debug, vertical_coordinate, dt_ocean,            &
                             cmip_units, cmip_version, horizontal_grid,                          &
                             use_blobs, use_velocity_override, mask_table,                       &
                             introduce_blobs, beta_txty, beta_tf, beta_qf, beta_lwsw, do_wave

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_model_init">
!
! <DESCRIPTION>
! Initialize the ocean model. 
! Arguments: 
!  Ocean (inout)  - A structure containing various publicly visible ocean
!                    surface properties after initialization.
!  OS    (pointer)- A structure whose internal contents are private
!                    to ocean_model_mod that may be used to contain all
!                    information about the ocean's interior state.
!  Time_init (in) - The start time for the coupled model's calendar.
!  Time_in   (in) - The time at which to initialize the ocean model.
!  ocean_timestep (in) - Ocean model time step in seconds. If present
!                        replaces dt_ocean set in ocean_model_nml
! </DESCRIPTION>
!
subroutine ocean_model_init(Ocean, Ocean_state, Time_init, Time_in, &
                            ocean_timestep)
    type(ocean_public_type), intent(inout)  :: Ocean
    type(ocean_state_type),  pointer        :: Ocean_state
    type(time_type),         intent(in)     :: Time_init
    type(time_type),         intent(in)     :: Time_in
    integer, optional,       intent(in)     :: ocean_timestep
    
    type(time_type) :: Time_step_ocean
    integer :: secs, days, secs0, days0 
    integer :: n
    integer :: ioun, io_status, ierr
    integer :: stdoutunit,stdlogunit 

    stdoutunit=stdout()
    stdlogunit=stdlog() 

    if (mpp_pe() == mpp_root_pe()) then
        write(stdoutunit,*) MOM_COMMIT_HASH
    endif

    if (module_is_initialized) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_model_mod (ocean_model_init): module already initialized')
    endif 

    module_is_initialized = .true.

    if (associated(Ocean_state)) then
       call mpp_error(WARNING, "ocean_model_init called with an associated "// &
            "ocean_state_type structure. Model is already initialized.")
       return
    endif
    allocate(Ocean_state)
    Ocean_state%is_ocean_pe = Ocean%is_ocean_pe !This is Not utilized in MOM currently
    
    call ocean_parameters_init()
 
    ! set clock ids
    id_ocean                = mpp_clock_id( 'Ocean', flags=clock_flag_default,grain=CLOCK_COMPONENT )
    id_init                 = mpp_clock_id('(Ocean initialization) '         ,grain=CLOCK_SUBCOMPONENT)
    id_oda                  = mpp_clock_id('(Ocean ODA)'                     ,grain=CLOCK_SUBCOMPONENT)
#if defined(ACCESS_CM) || defined(ACCESS_OM)
    id_sfix                 = mpp_clock_id('(Red Sea/Gulf Bay salinity fix)',grain=CLOCK_MODULE)
#endif
    id_advect               = mpp_clock_id('(Ocean advection velocity) '     ,grain=CLOCK_MODULE)
    id_density_diag         = mpp_clock_id('(Ocean density diag) '           ,grain=CLOCK_MODULE)    
    id_density              = mpp_clock_id('(Ocean update density) '         ,grain=CLOCK_MODULE)    
    id_vmix                 = mpp_clock_id('(Ocean vertical mixing coeff) '  ,grain=CLOCK_MODULE)
    id_neutral              = mpp_clock_id('(Ocean neutral physics) '        ,grain=CLOCK_MODULE)
    id_submesoscale         = mpp_clock_id('(Ocean submesoscale restrat)'    ,grain=CLOCK_MODULE)
    id_sw                   = mpp_clock_id('(Ocean shortwave) '              ,grain=CLOCK_MODULE)
    id_sponges_eta          = mpp_clock_id('(Ocean sponges_eta) '            ,grain=CLOCK_MODULE)
    id_sponges_tracer       = mpp_clock_id('(Ocean sponges_tracer) '         ,grain=CLOCK_MODULE)
    id_sponges_velocity     = mpp_clock_id('(Ocean sponges_velocity) '       ,grain=CLOCK_MODULE)
    id_xlandinsert          = mpp_clock_id('(Ocean xlandinsert) '            ,grain=CLOCK_MODULE)
    id_xlandmix             = mpp_clock_id('(Ocean xlandmix) '               ,grain=CLOCK_MODULE)
    id_rivermix             = mpp_clock_id('(Ocean rivermix) '               ,grain=CLOCK_MODULE)
    id_overexchange         = mpp_clock_id('(Ocean overexchange) '           ,grain=CLOCK_MODULE)
    id_mixdownslope         = mpp_clock_id('(Ocean mixdownslope) '           ,grain=CLOCK_MODULE)
    id_blob_update          = mpp_clock_id('(Ocean blob update)'             ,grain=CLOCK_MODULE)
    id_blob_cell_update     = mpp_clock_id('(Ocean blob cell update)'        ,grain=CLOCK_MODULE)
    id_blob_diagnose_depth  = mpp_clock_id('(Ocean blob diagnose depth)'     ,grain=CLOCK_MODULE)
    id_overflow             = mpp_clock_id('(Ocean overflow) '               ,grain=CLOCK_MODULE)
    id_overflow_OFP         = mpp_clock_id('(Ocean overflow_OFP) '           ,grain=CLOCK_MODULE)
    id_sigma                = mpp_clock_id('(Ocean sigma transport) '        ,grain=CLOCK_MODULE)
    id_tracer               = mpp_clock_id('(Ocean tracer update) '          ,grain=CLOCK_MODULE)
    id_sbc                  = mpp_clock_id('(Ocean surface flux) '           ,grain=CLOCK_MODULE)
    id_bbc                  = mpp_clock_id('(Ocean bottom flux) '            ,grain=CLOCK_MODULE)
    id_flux_adjust          = mpp_clock_id('(Ocean restoring flux) '         ,grain=CLOCK_MODULE)
    id_otpm_source          = mpp_clock_id('(Ocean TPM source) '             ,grain=CLOCK_MODULE)
    id_otpm_bbc             = mpp_clock_id('(Ocean TPM bbc) '                ,grain=CLOCK_MODULE)
    id_otpm_tracer          = mpp_clock_id('(Ocean TPM tracer) '             ,grain=CLOCK_MODULE)
    id_explicit_accel_a     = mpp_clock_id('(Ocean explicit accel_a) '       ,grain=CLOCK_MODULE)
    id_explicit_accel_b     = mpp_clock_id('(Ocean explicit accel_b) '       ,grain=CLOCK_MODULE)
    id_implicit_accel       = mpp_clock_id('(Ocean implicit accel) '         ,grain=CLOCK_MODULE)
    id_eta_and_pbot_tendency= mpp_clock_id('(Ocean eta and pbot tendency)'   ,grain=CLOCK_MODULE)
    id_eta_and_pbot_update  = mpp_clock_id('(Ocean eta and pbot update)'     ,grain=CLOCK_MODULE)
    id_eta_and_pbot_diagnose= mpp_clock_id('(Ocean eta and pbot diagnose)'   ,grain=CLOCK_MODULE)
    id_rho_dzt_tendency     = mpp_clock_id('(Ocean rho_dzt tendency)'        ,grain=CLOCK_MODULE)
    id_dzt_dst_update       = mpp_clock_id('(Ocean dzt_dst update)'          ,grain=CLOCK_MODULE)
    id_surface_smooth       = mpp_clock_id('(Ocean surface height smooth)'   ,grain=CLOCK_MODULE)
    id_bottom_smooth        = mpp_clock_id('(Ocean bottom pressure smooth)'  ,grain=CLOCK_MODULE)
    id_mass_forcing         = mpp_clock_id('(Ocean mass forcing) '           ,grain=CLOCK_MODULE)
    id_barotropic_forcing   = mpp_clock_id('(Ocean barotropic forcing) '     ,grain=CLOCK_MODULE)
    id_barotropic_update    = mpp_clock_id('(Ocean barotropic dynamics)'     ,grain=CLOCK_MODULE)
    id_velocity             = mpp_clock_id('(Ocean velocity update) '        ,grain=CLOCK_MODULE)
    id_diagnostics          = mpp_clock_id('(Ocean diagnostics)'             ,grain=CLOCK_MODULE)
    id_tcell_thickness      = mpp_clock_id('(Ocean update T-cell thickness)' ,grain=CLOCK_MODULE)
    id_tcell_thickness_blob = mpp_clock_id('(Ocean update Total thickness)'  ,grain=CLOCK_ROUTINE)
    id_update_L_thickness   = mpp_clock_id('(Ocean update L sys. thickness)' ,grain=CLOCK_ROUTINE)
    id_update_E_thickness   = mpp_clock_id('(Ocean update E sys. thickness)' ,grain=CLOCK_ROUTINE)
    id_ucell_thickness      = mpp_clock_id('(Ocean update U-cell thickness)' ,grain=CLOCK_MODULE)
    id_update_halo_tracer   = mpp_clock_id('(Ocean tracer halo updates)'     ,grain=CLOCK_MODULE)
    id_update_halo_velocity = mpp_clock_id('(Ocean velocity halo update)'    ,grain=CLOCK_MODULE)
    id_ocean_sfc            = mpp_clock_id('(Ocean sum ocean surface)'       ,grain=CLOCK_MODULE)
    id_ocean_seg_end        = mpp_clock_id('(Ocean average state)'           ,grain=CLOCK_MODULE)
    id_tmask_limit          = mpp_clock_id('(Ocean tracer tmask limit)'      ,grain=CLOCK_MODULE)
    id_advect_gotm          = mpp_clock_id('(Ocean gotm: advection)'         ,grain=CLOCK_ROUTINE)
    id_increment_eta        = mpp_clock_id('(Ocean increment eta)'           ,grain=CLOCK_MODULE)
    id_increment_tracer     = mpp_clock_id('(Ocean increment tracer)'        ,grain=CLOCK_MODULE)
    id_increment_velocity   = mpp_clock_id('(Ocean increment velocity)'      ,grain=CLOCK_MODULE)
    id_salinity             = mpp_clock_id('(Ocean update rho_salinity)'     ,grain=CLOCK_MODULE)
    id_wave                 = mpp_clock_id('(Ocean idealized surface waves)' ,grain=CLOCK_MODULE)


    call mpp_clock_begin(id_init)
    call write_version_number(version, tagname)

    write(stdoutunit,'(/54x,a/)') '======== STARTING MOM INITIALIZATION ========'

#ifdef STATIC_MEMORY
    write(stdoutunit,*) ' '
    write(stdoutunit,*)'==>Error: MOM4.0 cpp option "STATIC_MEMORY" is now called "MOM_STATIC_ARRAYS" in MOM.'
    write(stdoutunit,*)'          Recompile code with this new name. Apologies for the inconvenience.' 
    call mpp_error(FATAL, &
     '==>Error: Change compiler option "STATIC_MEMORY" to "MOM_STATIC_ARRAYS" and then recompile.')
#endif 
#ifdef MOM4_STATIC_ARRAYS
    write(stdoutunit,*) ' '
    write(stdoutunit,*)'==>Error: MOM4p1 cpp option "MOM4_STATIC_ARRAYS" is now called "MOM_STATIC_ARRAYS" in MOM.'
    write(stdoutunit,*)'          Recompile code with this new name. Apologies for the inconvenience.' 
    call mpp_error(FATAL, &
     '==>Error: Change compiler option "MOM4_STATIC_ARRAYS" to "MOM_STATIC_ARRAYS" and then recompile.')
#endif 

#ifdef MOM_STATIC_ARRAYS
    write(stdoutunit,*) ' '
    write(stdoutunit,*)'==>NOTE: Using MOM_STATIC_ARRAYS cpp option in MOM.'
#else
    write(stdoutunit,*) ' '
    write(stdoutunit,*)'==>NOTE: Using dynamically allocated array option in MOM'
#endif 

    call time_interp_external_init()

    ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_model_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_model_nml')
#else
    ioun = open_namelist_file()
    read  (ioun, ocean_model_nml,iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_model_nml')
    call close_file (ioun)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit, ocean_model_nml)
    write (stdlogunit, ocean_model_nml)

    write (stdoutunit,'(/a,i6,a/)') ' ==>Note: Running MOM using',mpp_npes(),' computer processors.'  

    ! initialize ocean time type information

    Time%calendar  = JULIAN

    if(time_tendency=='threelevel') then 
      tendency        = THREE_LEVEL 
      Time%taum1      = 1
      Time%tau        = 2
      Time%taup1      = 3
      Time%tau_m2     = 1
      Time%tau_m1     = 2
      Time%tau_m0     = 3
      write (stdoutunit,*) ' ' 
      write (stdoutunit,*) '==>Note: Running MOM with a leap frog to discretize the time tendency.'
      write (stdoutunit,*) '         Unfortunately, this method does not conserve volume and tracer because'
      write (stdoutunit,*) '         it is necessary to use time filtering.  Use the "twolevel" scheme to conserve.'
      write (stdoutunit,*) ' '
      if (use_blobs) then
         write (stdoutunit,*) ' ' 
         write (stdoutunit,*) '==>Fatal: You are running MOM with time_tendency=threelevel and use_blobs=.true.'
         write (stdoutunit,*) '          These options are mutually exclusive.  Please choose either              '
         write (stdoutunit,*) '          time_tendency=twolevel, or use_blobs=.false.                             '
         write (stdoutunit,*) ' '
         call mpp_error(FATAL,&
              '==>Error from ocean_model_mod: time_tendency must be "twolevel" for use_blobs=.true.')

         if (introduce_blobs) then
            if(file_exist('INPUT/ocean_blobs_gridded.res.nc')) then
               write (stdoutunit,*) ' '
               Write (stdoutunit,*) '==>Fatal: You are running MOM with introduce_blobs=.true. and use_blobs=.true.'
               write (stdoutunit,*) ' But blob restart exists so blobs have already run.                           '
               write (stdoutunit,*) ' Please set introduce_blobs=.false.                                           '
               write (stdoutunit,*) ' '
               call mpp_error(FATAL,&
                    '==>Error from ocean_model_mod: introduce_blobs=.true. but blobs have been run previously')
            else
               write (stdoutunit,*) ' '
               write (stdoutunit,*) '==>Note: You are running MOM with introduce_blobs=.true. and use_blobs=.true.  '
               write (stdoutunit,*) '         Blobs are being introduced to a run that did not previously have them.'
               write (stdoutunit,*) ' '
               
            endif
         endif
      endif

    elseif(time_tendency=='twolevel') then  
      tendency        = TWO_LEVEL 
      Time%taum1      = 2
      Time%tau        = 2
      Time%taup1      = 3
      Time%tau_m2     = 1
      Time%tau_m1     = 2
      Time%tau_m0     = 3
      write (stdoutunit,*) ' ' 
      write (stdoutunit,*) &
      '==>Note: Running MOM with staggered twotime level scheme to compute time tendencies.'
      write (stdoutunit,*) &
      '         This is the default. Mass/volume and tracer are conserved with this scheme.'
      write (stdoutunit,*) ' '
    else
      call mpp_error(FATAL,&
      '==>Error from ocean_model_mod: time_tendency must be "twolevel" or "threelevel".')
    endif 

    ! If the timestep has been passed in then use it to over-ride the namelist
    ! setting. This is useful for coupled model setups -- for example it allows
    ! them to avoid setting the timestep in multiple places.
    if (present(ocean_timestep)) then
        if (dt_ocean /= -1) then
            call mpp_error(FATAL, '==>Error from ocean_model_mod: conflicting '// &
                           'values for dt_ocean, passed as an argument and in '// &
                           'ocean_model_nml.')
        endif
        dt_ocean = ocean_timestep
    endif

    if(dt_ocean .lt. 0.0) call mpp_error(FATAL,&
      '==>Error from ocean_model_mod: dt_ocean must be set to a positive integer in ocean_model_nml.')

    Time_step_ocean = set_time (dt_ocean,0)

    Time%init       = (Time_in == Time_init)
    Time%Time_init  = Time_init
    Time%Time_step  = Time_step_ocean
    Time%model_time = Time_in
    Time%itt        = 0

    call get_time(Time_step_ocean, secs, days)
    call get_time(Time_in-Time_init, secs0, days0)
    Time%itt0 = nint((days0+secs0/86400.0)/(days+secs/86400.0))

    write(stdoutunit,'(/a)')&
    ' ==>Note: Time%Time_init = time stamp at very start of the MOM experiment is given by'
    call write_timestamp(Time%Time_init)

    write(stdoutunit,'(/a)') &
    ' ==>Note: Time%model_time = time stamp at start of this leg of the MOM experiment is'
    call write_timestamp(Time%model_time)

    if(impose_init_from_restart) then 
        Time%init=.false.
        write(stdoutunit,'(/a)')&
        ' ==>Note: impose_init_from_restart=.true., so will initialize model from a restart file.'
    endif

    if(Time%init) then 
      write(stdoutunit,'(/a)')&
      ' ==>Note: Time%init=.true. =>MOM will start from user specified initial conditions.' 
    endif 
    if(.not. Time%init) then 
      write(stdoutunit,'(/a)') &
      ' ==>Note: Time%init=.false. =>MOM will start from restart conditions from previous leg of experiment.' 
    endif 

    dtts    = secs + days*86400
    dtuv    = dtts/baroclinic_split
    dteta   = dtts/surface_height_split
    dtbt    = dtuv/barotropic_split

    if(tendency==THREE_LEVEL) then 
      dtime_t = 2.0*dtts 
      dtime_u = 2.0*dtuv 
      dtime_e = 2.0*dteta
    elseif(tendency==TWO_LEVEL) then  
      dtime_t = dtts 
      dtime_u = dtuv
      dtime_e = dteta
    endif 

    Time_steps%time_tendency = time_tendency 
    Time_steps%tendency      = tendency 
    Time_steps%dtts          = dtts
    Time_steps%dtuv          = dtuv
    Time_steps%dtbt          = dtbt
    Time_steps%dteta         = dteta
    Time_steps%dtime_t       = dtime_t
    Time_steps%dtime_u       = dtime_u
    Time_steps%dtime_e       = dtime_e

    write(stdoutunit,'(/a)')' ==> Note: time steps (seconds) used for MOM' 
    write(stdoutunit,'(a,f10.2)')'  dtts  (tracer)                            = ',dtts
    write(stdoutunit,'(a,f10.2)')'  dtuv  (baroclinic)                        = ',dtuv
    write(stdoutunit,'(a,f10.2)')'  dteta (surface height or bottom pressure) = ',dteta
    write(stdoutunit,'(a,f10.2)')'  dtbt  (barotropic)                        = ',dtbt

    if(baroclinic_split < 1) then 
       call mpp_error(FATAL,&
       '==>Error from ocean_model_mod(ocean_model_init): baroclinic_split must be an integer >= 1')
    endif 
    if(baroclinic_split > 1) then 
       call mpp_error(NOTE,&
       '==>ocean_model_mod: baroclinic_split > 1 corrupts transients & can be unstable. Use with caution.')
       write(stdoutunit,'(/a/)') &
       '==>ocean_model_mod: baroclinic_split > 1 corrupts transients & can be unstable. Use with caution.'
    endif 
    if(surface_height_split < 1) then 
       call mpp_error(FATAL,&
       '==>Error from ocean_model_mod(ocean_model_init): surface_height_split must be an integer >= 1')
    endif 
    if(surface_height_split > 1) then 
       call mpp_error(NOTE, &
       '==>ocean_model_mod: surface_height_split > 1 corrupts transients. Use with caution.')
       write(stdoutunit,'(/a/)') &
       '==>ocean_model_mod: surface_height_split > 1 corrupts transients. Use with caution.'
    endif  

    if(barotropic_split < 1) then 
       call mpp_error(FATAL, &
       '==>Error from ocean_model_mod: barotropic_split must be an integer >= 1')
    endif 
    if(barotropic_split == 1) then 
       call mpp_error(WARNING, &
       '==>Warning from ocean_model_mod: barotropic_split=1 is NOT well tested in MOM.')
    endif 

    if (nint(dtuv) /= nint(dtbt)) then
        write (stdoutunit,'(/1x,a/)') &
         '==> Note: The velocity equations will be split into baroclinic and barotropic pieces.'
    endif

    ! horizontal grid choice: 
    ! if-tests on character strings are slower than  
    ! if-tests on integers. hence it is useful to 
    ! introduce the following integers 
    ! MOM_BGRID and MOM_CGRID 
    if(horizontal_grid=='cgrid') then 
      horz_grid = MOM_CGRID 
       call mpp_error(WARNING, &
       '==>Warning from ocean_model_mod: cgrid in MOM remains under active development.')
      write (stdoutunit,'(/1x,a)') &
      ' ==> Note: Using MOM with C-grid horizontal layout. Note that blobs and OBC are not yet available for C-grid.'
      write (stdoutunit,'(/1x,a)') &
      ' ==> Note: MOM C-grid remains under testing and development. Please report unphysical behavior to MOM community .'
    elseif(horizontal_grid=='bgrid') then 
      horz_grid = MOM_BGRID 
      write (stdoutunit,'(/1x,a)') &
      ' ==> Note: Using MOM with B-grid horizontal layout of variables on a grid.'
    else
       call mpp_error(FATAL, &
       '==>Error from ocean_model_mod: no valid horizontal_grid chosen. Options are bgrid and cgrid.')
    endif 
    if (use_blobs .and. horz_grid == MOM_CGRID) then
         write (stdoutunit,*) ' ' 
         write (stdoutunit,*) '==>Warning: You are running MOM with horz_grid = C-grid and use_blobs=.true.'
         write (stdoutunit,*) '            Blobs are not yet updated for C-grid; answers are not reliable' 
         write (stdoutunit,*) ' '
    endif


    ! vertical coordinate choice: 
    ! if-tests on character strings are slower than  
    ! if-tests on integers. hence it is useful to 
    ! introduce the following integers 
    ! GEOPOTENTIAL, ZSTAR, ZSIGMA, PRESSURE, PSTAR, and PSIGMA 
    if(vertical_coordinate=='geopotential') then 
      vert_coordinate       = GEOPOTENTIAL 
      vert_coordinate_class = DEPTH_BASED
      vert_coordinate_type  = QUASI_HORIZONTAL
      write (stdoutunit,'(/1x,a)') &
      ' ==> Note: Using MOM with geopotential vertical coordinate.'
      write (stdoutunit,'(1x,a/)') &
      '     Beware of vanishing top model grid cells. '
      write (stdoutunit,'(a)'    ) &
      '     The equations are Boussinesq, and so conserve volume rather than mass.'     
      write (stdoutunit,'(a/)'    ) &
      '     Use one of the pressure-like coordinates to get non-Boussinesq effects.'
    elseif(vertical_coordinate=='zstar') then    
      vert_coordinate       = ZSTAR
      vert_coordinate_class = DEPTH_BASED
      vert_coordinate_type  = QUASI_HORIZONTAL
      write (stdoutunit,'(/1x,a/)') &
      ' ==> Note: Using MOM with zstar vertical coordinate.'
      write (stdoutunit,'(a)'    )  &
      '     The equations are Boussinesq, and so conserve volume rather than mass.'     
      write (stdoutunit,'(a/)'    ) &
      '     Use one of the pressure-like coordinates to get non-Boussinesq effects.'
    elseif(vertical_coordinate=='zsigma') then    
      vert_coordinate       = ZSIGMA
      vert_coordinate_class = DEPTH_BASED
      vert_coordinate_type  = TERRAIN_FOLLOWING
      write (stdoutunit,'(/1x,a/)') &
      ' ==> Note: Using MOM with zsigma terrain following vertical coordinate.'
      write (stdoutunit,'(a)'    )  &
      '     The equations are Boussinesq, and so conserve volume rather than mass.'     
      write (stdoutunit,'(a)'    )  &
      '     Use one of the pressure-like coordinates to get non-Boussinesq effects.'
    elseif(vertical_coordinate=='pressure') then    
      vert_coordinate       = PRESSURE
      vert_coordinate_class = PRESSURE_BASED
      vert_coordinate_type  = QUASI_HORIZONTAL
      write (stdoutunit,'(/1x,a)') &
      ' ==> Note: Using MOM with pressure vertical coordinate.'
      write (stdoutunit,'(1x,a/)') &
      '     Beware of vanishing bottom and top grid cells.'
      write (stdoutunit,'(a)'    ) &
      '     The equations are non-Boussinesq.'
    elseif(vertical_coordinate=='pstar') then    
      vert_coordinate       = PSTAR
      vert_coordinate_class = PRESSURE_BASED
      vert_coordinate_type  = QUASI_HORIZONTAL
      write (stdoutunit,'(/1x,a)') &
      ' ==> Note: Using MOM with pstar vertical coordinate.'
      write (stdoutunit,'(a)'    ) &
      '     The equations are non-Boussinesq.'
    elseif(vertical_coordinate=='psigma') then    
      vert_coordinate       = PSIGMA
      vert_coordinate_class = PRESSURE_BASED
      vert_coordinate_type  = TERRAIN_FOLLOWING
      write (stdoutunit,'(/1x,a)') &
      ' ==> Note: Using MOM with psigma terrain following vertical coordinate.'
      write (stdoutunit,'(a)'    ) &
      '     The equations are non-Boussinesq.'
    else
       call mpp_error(FATAL, &
       '==>Error from ocean_model_mod: no valid vertical coordinate chosen.')
    endif 

    if(vert_coordinate_type==TERRAIN_FOLLOWING) then 
      write (stdoutunit,'(a)'    ) '     '
      write (stdoutunit,'(a)'    ) &
      '     WARNING: TERRAIN_FOLLOWING vertical coordinates are implemented in MOM'
      write (stdoutunit,'(a)'    ) &
      '     for process studies and/or regional models. They HAVE NOT been tested for'
      write (stdoutunit,'(a)'    ) &
      '     global climate simulations. The following issues have not been addressed'
      write (stdoutunit,'(a)'    ) &
      '     in the MOM implementation:'
      write (stdoutunit,'(a)'    ) &
      '     (1) Grd%tripolar=.true. has large (wrong) wrho_bt on bottom of T-cell column.'
      write (stdoutunit,'(a)'    ) &
      '     (2) neutral physics is not generalized to terrain following coordinates.'
      write (stdoutunit,'(a)'    ) &
      '     (3) The pressure gradient computation is not sophisticated, and '
      write (stdoutunit,'(a)'    ) &
      '     thus the model likely will suffer from large pressure gradient errors when '
      write (stdoutunit,'(a)'    ) &
      '     using realistic topography and coarse resolutions.'
      write (stdoutunit,'(a)'    ) &
      '     (4) The KPP scheme is unstable with non_local_kpp=.true. and it exhibits a'
      write (stdoutunit,'(a)'    ) &
      '     spurious tracer balance.'
      write (stdoutunit,'(a)'    ) &
      '     The user should thus beware that terrain following coordinates '
      write (stdoutunit,'(a)'    ) &
      '     are still largely in the development stages with MOM.'
    endif 

    if(vert_coordinate /= GEOPOTENTIAL .and. tendency==THREE_LEVEL) then 
         write(stdoutunit,'(a)') &
         '==>Error:threelevel tendency only implemented for geopotential vert_coordinate.'
         call mpp_error(FATAL, &
         'ocean_model_init: threelevel tendency only implemented for geopotential vertical coordinate.')  
    endif 

    if(horz_grid == MOM_CGRID .and. tendency==THREE_LEVEL) then 
         write(stdoutunit,'(a)') &
         '==>Error:threelevel tendency only implemented for B-grid version of MOM.'
         call mpp_error(FATAL, &
         'ocean_model_init: threelevel tendency only implemented for B-grid version of MOM.')  
    endif 
 
    ! initialize grid and domain information
    call ocean_grids_init(vert_coordinate, vert_coordinate_class, horz_grid, debug=debug)
    call set_ocean_grid_size(Grid, 'INPUT/grid_spec.nc') 
    call ocean_domain_init()

    ! read the mask_table if it exists to get n_mask, layout and mask_list
    if(file_exist(mask_table)) then
       write(stdoutunit, '(a)') '==> NOTE from ocean_model_init:  reading maskmap information from '//trim(mask_table)
       if(layout(1) == 0 .OR. layout(2) == 0 ) call mpp_error(FATAL, & 
        'ocean_model_init: ocean_model_nml layout should be set when file '//trim(mask_table)//' exists')

       allocate(Ocean%maskmap(layout(1), layout(2)))
       call parse_mask_table(mask_table, Ocean%maskmap, "ocean model")
    endif
   
    if(ASSOCIATED(Ocean%maskmap)) then
       call set_ocean_domain(Domain, Grid, layout=layout, io_layout=io_layout, maskmap=Ocean%maskmap)
    else
       call set_ocean_domain(Domain, Grid, layout=layout, io_layout=io_layout)
    end if
    call set_domain(Domain%domain2d)

    call ocean_workspace_init(Domain, Grid)
    call set_ocean_hgrid_arrays(Domain, Grid)
    call ocean_topog_init(Domain, Grid, 'INPUT/grid_spec.nc', vert_coordinate_type)
    call ocean_obc_init(have_obc, Time_steps, Domain, Grid, Ocean_options, &
          vert_coordinate, debug=debug)
    call set_ocean_vgrid_arrays(Domain, Grid, have_obc)
    call ocean_util_init(Domain, Grid)

    call init_grids_diag(Grid, Time)

    ! saved for use in the FMS coupler
    Ocean%axes(:) = Grid%tracer_axes(:) 

#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
    nk = Grid%nk

    allocate(diff_cbt(isd:ied,jsd:jed,nk,2))
    allocate(visc_cbu(isd:ied,jsd:jed,nk))
    allocate(visc_cbt(isd:ied,jsd:jed,nk))
    allocate(gm_diffusivity(isd:ied,jsd:jed,nk))
    allocate(visc_cbu_form_drag(isd:ied,jsd:jed,nk,2))
    allocate(pme(isd:ied,jsd:jed))
    allocate(melt(isd:ied,jsd:jed))
    allocate(upme(isd:ied,jsd:jed,2))
    allocate(river(isd:ied,jsd:jed))
    allocate(runoff(isd:ied,jsd:jed))
    allocate(calving(isd:ied,jsd:jed))
    allocate(uriver(isd:ied,jsd:jed,2))
    allocate(patm(isd:ied,jsd:jed))
    allocate(swflx(isd:ied,jsd:jed))    
    allocate(swflx_vis(isd:ied,jsd:jed))    
    allocate(sw_frac_zt(isd:ied,jsd:jed,nk))    
    allocate(opacity(isd:ied,jsd:jed,nk))    
    allocate(surf_blthick(isd:ied,jsd:jed))    
    allocate(bott_blthick(isd:ied,jsd:jed))    
    allocate(rossby_radius(isd:ied,jsd:jed))    
    allocate(swheat(isd:ied,jsd:jed,nk))

#endif
#if defined (ENABLE_ODA) && defined (ENABLE_ECDA)
    allocate(da_flux%u_flux(isd:ied,jsd:jed))    ! snz
    allocate(da_flux%v_flux(isd:ied,jsd:jed))    ! snz
    ! allocate(da_flux%t_flux(isd:ied,jsd:jed))    ! snz
    ! allocate(da_flux%q_flux(isd:ied,jsd:jed))    ! snz
    ! allocate(da_flux%lw_flux(isd:ied,jsd:jed))    ! snz
    ! allocate(da_flux%salt_flux(isd:ied,jsd:jed))    ! snz

    da_flux%u_flux(:,:) = 0.0 ! snz
    da_flux%v_flux(:,:) = 0.0 ! snz
    ! da_flux%t_flux(:,:) = 0.0 ! snz
    ! da_flux%q_flux(:,:) = 0.0 ! snz
    ! da_flux%lw_flux(:,:) = 0.0 ! snz
    ! da_flux%salt_flux(:,:) = 0.0 ! snz
#endif

    diff_cbt                    = 0.0
    visc_cbu                    = 0.0
    visc_cbt                    = 0.0
    gm_diffusivity              = 0.0
    visc_cbu_form_drag          = 0.0
    pme                         = 0.0
    melt                        = 0.0
    upme                        = 0.0
    river                       = 0.0
    runoff                      = 0.0
    calving                     = 0.0
    uriver                      = 0.0
    patm                        = 0.0
    swflx                       = 0.0    
    swflx_vis                   = 0.0    
    sw_frac_zt                  = 0.0    
    opacity                     = 0.0    
    surf_blthick                = 0.0
    bott_blthick                = 0.0
    rossby_radius               = 0.0
    swheat                      = 0.0

    call ocean_types_init()
    call ocean_tracer_util_init(Grid, Domain, use_blobs)
    call ocean_coriolis_init(Grid, Domain, Time, Time_steps, Ocean_options, horz_grid, debug=debug)
    call ocean_velocity_init(Grid, Domain, Time, Time_steps, Ocean_options, Velocity, &
                             horz_grid, have_obc, use_blobs, introduce_blobs, &
                             use_velocity_override, debug=debug)
    call ocean_barotropic_init(Grid, Domain, Time, Time_steps, Ocean_options, Ext_mode, have_obc,       &
                               vert_coordinate, vert_coordinate_class, horz_grid, cmip_units, use_blobs,&
                               introduce_blobs, use_velocity_override, debug=debug)    
    call ocean_thickness_init(Time, Time_steps, Domain, Grid, Ext_mode, Thickness,          &
                              vert_coordinate, vert_coordinate_class, vert_coordinate_type, &
                              use_blobs, introduce_blobs, dtime_t, debug=debug)
    call ocean_operators_init(Grid, Domain, Thickness, horz_grid)

    ! initialize prognostic tracers 
    T_prog => ocean_prog_tracer_init(Grid, Thickness, Ocean_options, Domain, Time, Time_steps, &
                                     num_prog_tracers, vert_coordinate_type, have_obc,         & 
                                     cmip_units, cmip_version, use_blobs, debug=debug)
                                     
    ! initialize diagnostic tracers 
    T_diag => ocean_diag_tracer_init(Time, Thickness, vert_coordinate_type, num_diag_tracers,&
                                     use_blobs)

    call ocean_advection_velocity_init(Grid, Domain, Time, Time_steps, Thickness, Adv_vel, &
                                       vert_coordinate_class, horz_grid, have_obc, use_blobs, &
                                       introduce_blobs, debug=debug)

    call ocean_density_init(Grid, Domain, Time, Time_steps, Thickness, T_prog(:), T_diag(:), Ocean_options, &
                            Dens, vert_coordinate, use_blobs, debug=debug)

    ! Note, this is the earliest the blob and lagrangian system initializations can be called
    allocate(EL_diag(0:num_prog_tracers))
    call ocean_blob_init(Grid, Domain, Time, T_prog, Dens, Thickness, Lagrangian_system, Ext_mode, EL_diag, &
                         Ocean_options, dtime_t, vert_coordinate_class, vert_coordinate, use_blobs, introduce_blobs)

    ! comptute total density in a grid cell 
    call calculate_rhoT(Time, Dens, Thickness)

    ! initialize diagnostics inside ocean_tracer module, which require density to already be initialized 
    call ocean_tracer_diagnostics_init(Time, Dens, T_diag, T_prog, vert_coordinate_class)

    call ocean_thickness_init_adjust(Grid, Time, Dens, Ext_mode, Thickness)

    ! For some experiments, we may wish to initialize eta or pbot
    ! with nontrivial values.  In this case we need to reinitialize the 
    ! thickness arrays, since the original initialization assumed eta=0
    ! and pbot=pbot0.
    if(have_obc .or. reinitialize_thickness) then
      write(stdoutunit,'(a)') &
       '==>Note: Reinitializing thickness to allow for nontrivial initial eta or pbot.'
      if (use_blobs) then
         call update_tcell_thick_blob(Time, Grid, Ext_mode, Dens, Thickness) 
         call update_E_thickness(Time, Grid, Thickness, Dens, Ext_mode)
      else
         call update_tcell_thickness(Time, Grid, Ext_mode, Dens, Thickness) 
      endif
      call update_ucell_thickness(Time, Grid, Ext_mode, Thickness) 
    endif 

    call ocean_pressure_init(Grid, Domain, Time, vert_coordinate, vert_coordinate_class,&
                             horz_grid, have_obc, use_blobs, debug=debug)

    call ocean_vert_mix_init(Grid, Domain, Time, Dens, Velocity, Time_steps, Ocean_options, T_prog(:), T_diag(:), &
                             vert_coordinate, vert_coordinate_class, horz_grid, have_obc, debug=debug)
    call ocean_bih_tracer_init(Grid, Domain, Time, T_prog(:), Ocean_options, dtime_t, have_obc)
    call ocean_lap_tracer_init(Grid, Domain, Time, T_prog(:), Ocean_options, dtime_t, have_obc)
    call ocean_sigma_transport_init(Grid, Domain, Time, Dens, T_prog(:), Ocean_options, &
                                    dtime_t, vert_coordinate, vert_coordinate_type, debug=debug)
    call ocean_nphysics_init(Grid, Domain, Time, Time_steps, Thickness, Dens, T_prog(:), Ocean_options, &
                             vert_coordinate_type, vert_coordinate_class, cmip_units, debug=debug)
    call ocean_nphysics_new_init(Grid, Domain, Time, Time_steps, Thickness, T_prog, Ocean_options, vert_coordinate_type)
    call ocean_submesoscale_init(Grid, Domain, Time, Dens, T_prog(:), Ocean_options, dtime_t, &
                                 vert_coordinate_class, cmip_units, debug=debug)
    call ocean_lap_friction_init(Grid, Domain, Time, Ocean_options, dtime_u, have_obc, horz_grid, debug=debug)
    call ocean_bih_friction_init(Grid, Domain, Time, Ocean_options, dtime_u, have_obc, horz_grid, debug=debug)    
    call ocean_momentum_source_init(Grid, Domain, Time, Ocean_options, debug=debug)    
    call ocean_form_drag_init(Grid, Domain, Time, Time_steps, Ocean_options, debug=debug)    
    call ocean_tracer_advect_init(Grid, Domain, Time, Dens, T_prog(:), have_obc, debug=debug)
    call ocean_velocity_advect_init(Grid, Domain, Time, have_obc, horz_grid, debug=debug)
    call ocean_convect_init(Grid, Domain, Time, Dens, T_prog(:), Ocean_options, dtime_t)
    call ocean_sbc_init(Grid, Domain, Time, T_prog(:), T_diag(:), Ocean, Dens, &
                        time_tendency, dtime_t, horz_grid)
    call ocean_bbc_init(Grid, Domain, Time, T_prog(:), Velocity, Ocean_options, vert_coordinate_type, horz_grid)
    call ocean_shortwave_init(Grid, Domain, Time, Dens, T_prog(:), vert_coordinate, Ocean_options)
    call ocean_sponges_tracer_init(Grid, Domain, Time, T_prog(:), dtime_t, Ocean_options)
    call ocean_sponges_velocity_init(Grid, Domain, Time, dtime_u, Ocean_options)
    call ocean_sponges_eta_init(Grid, Domain, Time, dtime_t, Ocean_options)
    call ocean_xlandmix_init(Grid, Domain, Time, Dens, T_prog(:), Ocean_options, dtime_t)    
    call ocean_xlandinsert_init(Grid, Domain, Time, Dens, T_prog(:), Ocean_options, dtts)    
    call ocean_riverspread_init(Grid, Domain, Ocean_options, dtime_t)
    call ocean_rivermix_init(Grid, Domain, Time, Time_steps, Dens, T_prog(:), Ocean_options, debug=debug)    
    call ocean_overexchange_init(Grid, Domain, Time, Dens, T_prog(:), Ocean_options, &
                                 vert_coordinate_type, dtime_t, debug=debug)
    call ocean_mixdownslope_init(Grid, Domain, Time, Dens, T_prog(:), Ocean_options, &
                                 vert_coordinate_type, dtime_t, debug=debug)
    call ocean_overflow_init(Grid, Domain, Time, Dens, T_prog(:), Ocean_options, &
                             vert_coordinate_type, dtime_t, debug=debug)    
    call ocean_overflow_OFP_init(Grid, Domain, Time, Dens, T_prog(:), Ocean_options, &
                             vert_coordinate_type, dtime_t, debug=debug)    
    call initialize_ocean_sfc(Time, Thickness, T_prog(:), T_diag(:), Velocity, Ocean)
    call ocean_tpm_start(Domain, Grid, T_prog(:), T_diag(:), Time, Thickness)
    call ocean_diag_init(Grid, Domain, Time, Time_steps, Thickness, T_prog(:), T_diag(:), Dens, &
                         vert_coordinate_class, horz_grid, have_obc, cmip_units, use_blobs)
    call ocean_increment_eta_init(Grid, Domain, Time)
    call ocean_increment_tracer_init(Grid, Domain, Time, T_prog(:))
    call ocean_increment_velocity_init(Grid, Domain, Time)
    call ocean_wave_init(Grid, Domain, Waves, Time, Time_steps, Ocean_options, debug)
#if defined(ACCESS_CM) || defined(ACCESS_OM)
    call auscom_ice_init(Ocean%domain, Time_steps)
#else
    call sat_vapor_pres_init()
#endif

#ifdef ENABLE_ODA    
#ifdef ENABLE_ECDA
    call init_oda(Time, Domain, Grid, T_prog(:))
#else
    call init_oda(Domain, Grid, Time, T_prog(:))
#endif
#endif

    call ocean_drifters_init(Domain, Grid, Time, T_prog(:), Velocity, Adv_vel)
    
    ! set index_temp and index_salt for this module
    ! also set index_redist_heat for FAFMIP redistributed heat tracer 
    do n= 1, num_prog_tracers
       if (T_prog(n)%name == 'temp')        index_temp        = n
       if (T_prog(n)%name == 'salt')        index_salt        = n
       if (T_prog(n)%name == 'redist_heat') index_redist_heat = n
    enddo

    ! re-initialize tempsalt according to idealized profile 
    call ocean_tempsalt_ideal_reinit(Thickness, index_temp, index_salt, T_prog(:))

    ! initialize passive tracers set according to neutral density or temperature.
    ! also initialize passive tracers to be restored to their initial values. 
    ! these tracers must be initialized after temperature and density are 
    ! initialized.  
    call ocean_passive_tracer_init(T_prog(:), T_diag(:), Dens%neutralrho(:,:,:), &
      Time%init, Time%tau, num_prog_tracers, index_temp, index_salt)

    call nullify_domain()
    call mpp_clock_end(id_init) 

#if defined (ENABLE_ODA) && defined (ENABLE_ECDA)
    call mpp_get_compute_domain(Ocean%Domain, is_sfc, ie_sfc, js_sfc, je_sfc) ! snz
#endif

    write(stdoutunit,'(/52x,a/)') '======== COMPLETED MOM INITIALIZATION ========'

  end subroutine ocean_model_init
! </SUBROUTINE> NAME="ocean_model_init"


 !#######################################################################
! <SUBROUTINE NAME="update_ocean_model">
!
! <DESCRIPTION>
! Update in time the ocean model fields. 
!   This subroutine uses the forcing in Ice_ocean_boundary to advance the
! ocean model's state from the input value of Ocean_state (which must be for
! time time_start_update) for a time interval of Ocean_coupling_time_step,
! returning the publicly visible ocean surface properties in Ocean_sfc and
! storing the new ocean properties in Ocean_state.
!
! Arguments: 
!  Ice_ocean_boundary - A structure containing the various forcing
!                                 fields coming from the ice. It is intent in.
!  Ocean_state - A structure containing the internal ocean state.
!  Ocean_sfc - A structure containing all the publicly visible ocean
!                        surface fields after a coupling time step.
!  time_start_update - The time at the beginning of the update step.
!  Ocean_coupling_time_step - The amount of time over which to advance
!                                       the ocean.

! Note: although several types are declared intent(inout), this is to allow for
!   the possibility of halo updates and to keep previously allocated memory.
!   In practice, Ice_ocean_boundary is intent in, Ocean_state is private to
!   this module and intent inout, and Ocean_sfc is intent out.
! </DESCRIPTION>
!
  subroutine update_ocean_model(Ice_ocean_boundary, Ocean_state, Ocean_sfc, &
                         time_start_update, Ocean_coupling_time_step, do_wave_in)
    type(ice_ocean_boundary_type), intent(inout) :: Ice_ocean_boundary
    type(ocean_state_type),        pointer       :: Ocean_state
    type(ocean_public_type),       intent(inout) :: Ocean_sfc
    type(time_type),               intent(in)    :: time_start_update
    type(time_type),               intent(in)    :: Ocean_coupling_time_step
    logical, optional,             intent(in)    :: do_wave_in    
    integer :: seconds, days
    integer :: num_ocn
    integer :: taum1, tau, taup1
    integer :: i, j, k, n
#if defined(ACCESS_CM) || defined(ACCESS_OM)
    integer :: stdoutunit

    stdoutunit=stdout()
#endif

    call mpp_clock_begin(id_ocean)

    if(first_ocn_call) then 
      num_ocean_calls =  Ocean_coupling_time_step / Time%Time_step 
      if ( num_ocean_calls * Time%Time_step /= Ocean_coupling_time_step ) then 
       call mpp_error(FATAL, &
       '==>Error from ocean_model_mod(update_ocean_model): cpld time step is not a multiple of the ocean time step', FATAL)
      endif
      first_ocn_call=.false.
    endif 

    !Override do_wave by the coupler value
    if(present(do_wave_in)) do_wave=do_wave_in

    ! Loop over num_ocean_calls, moved here from the coupler due to interface changes
    do num_ocn = 1,num_ocean_calls

       ! increment ocean time and time labels 
       Time%model_time = Time%model_time + Time%Time_step
       Time%itt        = Time%itt+1
       Time%itt0       = Time%itt0+1

       Time%taum1      = mod(Time%itt+0,3)+1
       Time%tau        = mod(Time%itt+1,3)+1
       Time%taup1      = mod(Time%itt+2,3)+1

       Time%tau_m2     = mod(Time%itt+0,3)+1
       Time%tau_m1     = mod(Time%itt+1,3)+1
       Time%tau_m0     = mod(Time%itt+2,3)+1

       if(tendency==TWO_LEVEL) then  
          Time%taum1 = Time%tau
       endif

       taum1 = Time%taum1
       tau   = Time%tau
       taup1 = Time%taup1


       ! initialize some fields to zero at start of the time step

       ! tracer tendency th_tendency     [units rho_dzt*tracer concentration per time]
       ! tracer source has no weighting  [units tracer concentration per time] 
       do n=1,num_prog_tracers
          do k=1,nk
             do j=jsd,jed
                do i=isd,ied
                   T_prog(n)%th_tendency(i,j,k) = 0.0
                   T_prog(n)%source(i,j,k)      = 0.0
                enddo
             enddo
          enddo
       enddo
       if (use_blobs) then
          do n=1,num_prog_tracers
             do k=1,nk
                do j=jsd,jed
                   do i=isd,ied
                      T_prog(n)%tend_blob(i,j,k) = 0.0
                   enddo
                enddo
             enddo
          enddo
          do n=0,num_prog_tracers 
             EL_diag(n)%entrainment(:,:,:) = 0.0 
             EL_diag(n)%detrainment(:,:,:) = 0.0 
             EL_diag(n)%new(:,:,:)         = 0.0 
             EL_diag(n)%dstry(:,:,:)       = 0.0 
          enddo 
       endif

       ! sources of mass and form drag vertical viscosity and gm_diffusivity 
       do k=1,nk
          do j=jsd,jed
             do i=isd,ied
                Thickness%mass_source(i,j,k) = 0.0
                visc_cbu_form_drag(i,j,k,1)  = 0.0
                visc_cbu_form_drag(i,j,k,2)  = 0.0
                gm_diffusivity(i,j,k)        = 0.0
             enddo
          enddo
       enddo
       if (use_blobs) then
          do j=jsd,jed
             do i=isd,ied
                Thickness%blob_source(i,j) = 0.0
             enddo
          enddo
       endif

       ! boundary layer thicknesses
       do j=jsd,jed
          do i=isd,ied
             surf_blthick(i,j) = 0.0
             bott_blthick(i,j) = 0.0
          enddo
       enddo

       ! Calculate diagnostic arrays for ocean density of use for plotting
       ! fields on potential density or neutral density surfaces.  Do so at 
       ! start of time step so that all subsequent fields are plotted on the 
       ! same surfaces.  
       call mpp_clock_begin(id_density_diag) 
       call ocean_density_diag(Time, T_prog(index_temp), Thickness, Dens, T_diag(:))   
       call mpp_clock_end(id_density_diag) 

       ! calculate tracer tmask_limit based on tracer values at time tau
       call mpp_clock_begin(id_tmask_limit)
       call compute_tmask_limit(Time, T_prog(1:num_prog_tracers))
       call mpp_clock_end(id_tmask_limit)

       ! update the simplified MOM version of a wave model
       call mpp_clock_begin(id_wave)
       call ocean_wave_model(Time, Waves, Ice_ocean_boundary)
       call mpp_clock_end(id_wave)

#if defined (ENABLE_ODA) && defined (ENABLE_ECDA)
       i_shift = isc - is_sfc
       j_shift = jsc - js_sfc
       do j=js_sfc, je_sfc
          jj = j + j_shift
          do i=is_sfc, ie_sfc
             ii = i + i_shift
             Ice_ocean_boundary%u_flux(i,j) = Ice_ocean_boundary%u_flux(i,j) +&
                  beta_txty*da_flux%u_flux(ii,jj)
             Ice_ocean_boundary%v_flux(i,j) = Ice_ocean_boundary%v_flux(i,j) +&
                  beta_txty*da_flux%v_flux(ii,jj)
             ! Ice_ocean_boundary%t_flux(i,j) = Ice_ocean_boundary%t_flux(i,j) +&
             !      beta_tf*da_flux%t_flux(ii,jj)
             ! Ice_ocean_boundary%q_flux(i,j) = Ice_ocean_boundary%q_flux(i,j) +&
             !      beta_qf*da_flux%q_flux(ii,jj)
             ! Ice_ocean_boundary%lw_flux(i,j) = Ice_ocean_boundary%lw_flux(i,j) +&
             !      beta_lwsw*da_flux%lw_flux(ii,jj)
             ! Ice_ocean_boundary%salt_flux(i,j) = Ice_ocean_boundary%salt_flux(i,j) +&
             !      beta_lwsw*da_flux%salt_flux(ii,jj)
          enddo
       enddo
#endif

       ! obtain surface boundary fluxes from coupler
       call mpp_clock_begin(id_sbc)
       call get_ocean_sbc(Time, Ice_ocean_boundary, Thickness, Dens, Ext_mode,       &
            T_prog(1:num_prog_tracers), Velocity, pme, melt, river, runoff, calving, &
            upme, uriver, swflx, swflx_vis, patm)
       call mpp_clock_end(id_sbc)

       ! compute "flux adjustments" (e.g., surface tracer restoring, flux correction)
       call mpp_clock_begin(id_flux_adjust)
       call flux_adjust(Time, T_diag(1:num_diag_tracers), Dens, Ext_mode, &
                        T_prog(1:num_prog_tracers), Velocity, river, melt, pme)

       call mpp_clock_end(id_flux_adjust)

       ! calculate bottom momentum fluxes and bottom tracer fluxes
       call mpp_clock_begin(id_bbc)
       call get_ocean_bbc(Time, Thickness, Dens, Velocity, T_prog(1:num_prog_tracers), Waves)
       call mpp_clock_end(id_bbc)

       ! add shortwave heating to T_prog%th_tendency 
       call mpp_clock_begin(id_sw)
       if(ext_swheat_is_set) then
          ! apply external sw heating source if it is set
          do k=1,nk-1
             do j=jsc,jec
                do i=isc,iec
                   T_prog(index_temp)%th_tendency(i,j,k) = &
                   T_prog(index_temp)%th_tendency(i,j,k) + swheat(i,j,k) / cp_ocean
                enddo
             enddo
          enddo
       else
         ! compute the sw penetration
         call sw_source(Time, Thickness, Dens, T_prog(:), T_diag(:), swflx, swflx_vis, &
                        T_prog(index_temp), sw_frac_zt, opacity)
       endif
       call mpp_clock_end(id_sw)

       ! compute vertical mixing coefficients. 
       ! if use kpp, also add nonlocal tendency to T_prog%th_tendency 
       call mpp_clock_begin(id_vmix)    
       call vert_mix_coeff(Time, Thickness, Velocity, T_prog(1:num_prog_tracers),&
            T_diag(1:num_diag_tracers), Dens, swflx, sw_frac_zt, pme,            &
            river, visc_cbu, visc_cbt, diff_cbt, surf_blthick, do_wave)
       call mpp_clock_end(id_vmix)

       ! compute ocean tendencies from tracer packages
       call mpp_clock_begin(id_otpm_source)
#if ! defined (CSIRO_BGC)
       call ocean_tpm_source(isd, ied, jsd, jed, Domain, Grid, T_prog(:), T_diag(:), &
            Time, Thickness, Dens, surf_blthick, dtts)
#else
       call ocean_tpm_source(isd, ied, jsd, jed, Domain, Grid, T_prog(:), T_diag(:), &
            Time, Thickness, Dens, surf_blthick, dtts, swflx, sw_frac_zt)
#endif
       call mpp_clock_end(id_otpm_source)

       ! set ocean surface boundary conditions for the tracer packages
       call mpp_clock_begin(id_otpm_bbc)
#if ! defined (CSIRO_BGC)
       call ocean_tpm_bbc(Domain, Grid, T_prog(:))
#else
       call ocean_tpm_bbc(Domain, Grid, T_prog(:), Time)
#endif
       call mpp_clock_end(id_otpm_bbc)

       ! add sponges to T_prog%th_tendency 
       call mpp_clock_begin(id_sponges_tracer)
       call sponge_tracer_source(Time, Thickness, T_prog(1:num_prog_tracers)) 
       call mpp_clock_end(id_sponges_tracer)

       ! add increments to T_prog%th_tendency as used in Australian OFAM/Bluelink
       call mpp_clock_begin(id_increment_tracer)
       call ocean_increment_tracer_source(Time, Thickness, T_prog(1:num_prog_tracers)) 
       call mpp_clock_end(id_increment_tracer)

       ! add cross land mixing to T_prog%th_tendency and Thickness%mass_source  
       call mpp_clock_begin(id_xlandmix)
       call xlandmix (Time, Ext_mode, Dens, Thickness, T_prog(1:num_prog_tracers))
       call mpp_clock_end(id_xlandmix)

       ! add cross land insertion to T_prog%th_tendency and Thickness%mass_source
       call mpp_clock_begin(id_xlandinsert)
       call xlandinsert (Time, Ext_mode, Dens, Thickness, T_prog(1:num_prog_tracers))
       call mpp_clock_end(id_xlandinsert)

       ! add river discharge to T_prog%th_tendency and/or enhance diff_cbt next to river mouths 
       call mpp_clock_begin(id_rivermix)
       call rivermix (Time, Thickness, Dens, T_prog(1:num_prog_tracers), river, runoff, calving, &
                      diff_cbt, index_temp, index_salt)
       call mpp_clock_end(id_rivermix)

       ! add discharge of dense shelf water into abyss to T_prog%th_tendency
       call mpp_clock_begin(id_overflow)
       call overflow (Time, Thickness, T_prog(1:num_prog_tracers), Dens, index_temp, index_salt)
       call mpp_clock_end(id_overflow)

       ! add discharge of dense shelf water into abyss to T_prog%th_tendency and mass using NCAR OFP scheme 
       call mpp_clock_begin(id_overflow_OFP)
       call overflow_OFP (Time, Thickness, T_prog(1:num_prog_tracers), &
                          Dens, index_temp, index_salt)
       call mpp_clock_end(id_overflow_OFP)

       ! add exchange of dense shelf water properties into abyss to T_prog%th_tendency
       call mpp_clock_begin(id_overexchange)
       call overexchange (Time, Thickness, T_prog(1:num_prog_tracers), Dens, index_temp, index_salt)
       call mpp_clock_end(id_overexchange)

       ! add mixing of dense shelf water properties into abyss to T_prog%th_tendency
       call mpp_clock_begin(id_mixdownslope)
       call mixdownslope (Time, Thickness, T_prog(1:num_prog_tracers), Dens, index_temp, index_salt)
       call mpp_clock_end(id_mixdownslope)
       
       ! updates positions etc. of the dynamic blob schemes; also add interactions 
       ! between the E system and the L system.
       call mpp_clock_begin(id_blob_update)
       call ocean_blob_update(Time, Thickness, T_prog, Dens, Ext_mode, Adv_vel, Velocity, Lagrangian_system, EL_diag(:))
       call mpp_clock_end(id_blob_update)

       ! add surface height smoother to T_prog%surface_smooth and Thickness%mass_source.
       ! smoother is not needed for C-grid.  
       if(vert_coordinate_class==DEPTH_BASED) then 
          call mpp_clock_begin(id_surface_smooth)
          call ocean_eta_smooth(Time, Thickness, Ext_mode, T_prog(1:num_prog_tracers))
          call mpp_clock_end(id_surface_smooth)
       endif

       ! add bottom pressure smoother to T_prog%bottom_smooth and Thickness%mass_source.
       ! smoother is not needed for C-grid.  
       if(vert_coordinate_class==PRESSURE_BASED) then 
          call mpp_clock_begin(id_bottom_smooth)
          call ocean_pbot_smooth(Time, Thickness, Ext_mode, T_prog(1:num_prog_tracers))
          call mpp_clock_end(id_bottom_smooth)
       endif
       ! get prescribed OBC data from files
       if (have_obc) call ocean_obc_prepare(Time, T_prog(1:num_prog_tracers))

       ! computed vertical integral of mass forcing used for eta and pbot update
       call mpp_clock_begin(id_mass_forcing)
       call ocean_mass_forcing(Time, Thickness, Ext_mode) 
       call mpp_clock_end(id_mass_forcing)

       ! increment used in the Australian OFAM/Bluelink eta forcing
       call mpp_clock_begin(id_increment_eta)
       call ocean_increment_eta_source(Time, Ext_mode) 
       call mpp_clock_end(id_increment_eta)

       ! add eta sponges
       call mpp_clock_begin(id_sponges_eta)
       call sponge_eta_source(Time, Ext_mode)
       call mpp_clock_end(id_sponges_eta)

       ! accumulate terms for surface height tendency or bottom pressure tendency 
       call mpp_clock_begin(id_eta_and_pbot_tendency)
       call eta_and_pbot_tendency(Time, pme, river, Ext_mode, use_blobs)
       call mpp_clock_end(id_eta_and_pbot_tendency)
       
       ! the embedded Lagrangian model requires a different order of operations
       if (use_blobs) then

          ! update ocean free surface height or bottom pressure using "big time step"
          call mpp_clock_begin(id_eta_and_pbot_update)
          call eta_and_pbot_update(Time, Ext_mode)
          call mpp_clock_end(id_eta_and_pbot_update)
          
          ! Compute Thickness%dzt_dst
          call mpp_clock_begin(id_dzt_dst_update)
          call dzt_dst_update(Time, Grid, Ext_mode, Dens, Thickness)
          call mpp_clock_end(id_dzt_dst_update)

          ! Find which grid cell a blob resides in (uses Thickness%dzt_dst)
          call mpp_clock_begin(id_blob_cell_update)
          call ocean_blob_cell_update(Time, Thickness, Dens, T_prog(:), Ext_mode, Lagrangian_system, EL_diag(:))
          call mpp_clock_end(id_blob_cell_update)

          ! compute rho_dzt tendency (a function of eta_and_pbot_tendency)
          call mpp_clock_begin(id_rho_dzt_tendency)
          call rho_dzt_tendency(Time, Grid, Ext_mode, Thickness)
          call mpp_clock_end(id_rho_dzt_tendency)

          ! compute advective velocity components on faces of T-cells and U-cells.
          ! included are Thickness%mass_source and Thickness%rho_dzt_tendency
          call mpp_clock_begin(id_advect)
          call ocean_advection_velocity(Velocity, Time, Thickness, Dens, pme, river, Adv_vel, &
                                        Lagrangian_system, use_blobs)
          call mpp_clock_end(id_advect)

          call mpp_clock_begin(id_tcell_thickness)
            ! Update the total thickness
            call mpp_clock_begin(id_tcell_thickness_blob)
              call update_tcell_thick_blob(Time, Grid, Ext_mode, Dens, Thickness) 
            call mpp_clock_end(id_tcell_thickness_blob)

            ! Update the Lagrangian system thickness
            call mpp_clock_begin(id_update_L_thickness)
              call update_L_thickness(Time, Thickness, T_prog(:), Lagrangian_system, EL_diag(:))
            call mpp_clock_end(id_update_L_thickness)

            ! Update the Eulerian system thickness
            call mpp_clock_begin(id_update_E_thickness)
              call update_E_thickness(Time, Grid, Thickness, Dens, Ext_mode)
            call mpp_clock_end(id_update_E_thickness)

          call mpp_clock_end(id_tcell_thickness)

       else !.not. use_blobs

          ! compute rho_dzt tendency (a function of eta_and_pbot_tendency)
          call mpp_clock_begin(id_rho_dzt_tendency)
          call rho_dzt_tendency(Time, Grid, Ext_mode, Thickness)
          call mpp_clock_end(id_rho_dzt_tendency)
          
          ! compute advective velocity components on faces of T-cells and U-cells.
          ! included are Thickness%mass_source and Thickness%rho_dzt_tendency
          call mpp_clock_begin(id_advect)
          call ocean_advection_velocity(Velocity, Time, Thickness, Dens, pme, river, Adv_vel, &
                                        Lagrangian_system, use_blobs)
          call mpp_clock_end(id_advect)
          
          ! update ocean free surface height or bottom pressure using "big time step"
          call mpp_clock_begin(id_eta_and_pbot_update)
          call eta_and_pbot_update(Time, Ext_mode)
          call mpp_clock_end(id_eta_and_pbot_update)
          
          ! update taup1 value of the tracer grid cell thickness.  note that after 
          ! this update, dzt and dzwt (and other Thickness%T-arrays with no 
          ! time indices) are now at time taup1.
          call mpp_clock_begin(id_tcell_thickness)
          call update_tcell_thickness(Time, Grid, Ext_mode, Dens, Thickness)
          call mpp_clock_end(id_tcell_thickness)
       
       endif !use_blobs

       ! advect tke and diss for GOTM scheme in preparation for the next time step 
       if(Ocean_options%vertmix==VERTMIX_GOTM) then 
          call mpp_clock_begin(id_advect_gotm) 
          call advect_gotm_compute(Time, Adv_vel, Thickness, pme, river)
          call mpp_clock_end(id_advect_gotm) 
       endif

       ! add tendency from sigma transport to Tracer%th_tendency
       call mpp_clock_begin(id_sigma)
       call sigma_transport(Time, Thickness, Dens, T_prog(1:num_prog_tracers), Adv_vel, bott_blthick) 
       call mpp_clock_end(id_sigma)

       ! add tendency from neutral physics to T_prog%th_tendency.
       ! also compute T_prog%K33_implicit for use in time-implicit update.
       ! note that surf_blthick is needed from vert_mix_coeff (kpp) to 
       ! define "neutral physics surface boundary layer". 
       ! also, bott_blthick is needed from sigma_transport to 
       ! define "neutral physics bottom boundary layer". 
       call mpp_clock_begin(id_neutral)
       call neutral_physics(Time, Thickness, Dens, Dens%rho(:,:,:,taum1), &
            T_prog(1:num_prog_tracers), gm_diffusivity, surf_blthick, rossby_radius)
       call neutral_physics_new(Time, Domain, Thickness, Dens, Grid, surf_blthick, &
            T_prog, rossby_radius, gm_diffusivity)
       call mpp_clock_end(id_neutral)

       ! compute form drag vertical viscosity for vertical momentum transport
       call mpp_clock_begin(id_compute_visc_form_drag)
       call compute_visc_form_drag(Time, Thickness, Velocity, Dens, &
            gm_diffusivity, surf_blthick, visc_cbu_form_drag)
       call mpp_clock_end(id_compute_visc_form_drag)

       ! add tendency from submesoscale param to T_prog%th_tendency.
       call mpp_clock_begin(id_submesoscale)
       call submeso_restrat(Time, Thickness, Dens, T_prog, surf_blthick)
       call mpp_clock_end(id_submesoscale)

       ! update to time=taup1 the value of tracer concentrations
       call mpp_clock_begin(id_tracer)
       call update_ocean_tracer(Time, Dens, Adv_vel, Thickness, pme, diff_cbt, &
            T_prog(1:num_prog_tracers), T_diag(1:num_diag_tracers), Lagrangian_system, Velocity,       &
            Ext_mode, EL_diag(:), use_blobs)
       call mpp_clock_end(id_tracer)

       ! update to time=taup1 Salinity variable used in density equations
       call mpp_clock_begin(id_salinity) 
       call update_ocean_density_salinity(T_prog, taup1, Dens)   
       call mpp_clock_end(id_salinity) 

       ! diagnose time=taup1 ocean free surface height or bottom pressure.
       ! also diagnose geodepth_zt and geodepth_zwt.
       call mpp_clock_begin(id_eta_and_pbot_diagnose)
       call eta_and_pbot_diagnose(Time, Dens, Thickness, patm, pme, river, Ext_mode, Lagrangian_system, use_blobs)
       call mpp_clock_end(id_eta_and_pbot_diagnose)

       ! diagnose the geodepth of new blobs and the depth of old blobs
       call mpp_clock_begin(id_blob_diagnose_depth)
       call ocean_blob_diagnose_depth(Time, T_prog(:), Ext_mode, Lagrangian_system)
       call mpp_clock_end(id_blob_diagnose_depth)

       ! perform extra calculations for the ocean tracer packages
       call mpp_clock_begin(id_otpm_tracer)
       call ocean_tpm_tracer(Domain, T_prog(:), T_diag(:), Grid, Time, Thickness, Dens, dtts, &
            surf_blthick, swflx_vis, opacity, diff_cbt, Velocity)
       call mpp_clock_end(id_otpm_tracer)

       ! fill processor halos for tracers(taup1).
       ! halo values are needed prior to rho(taup1) computation.
       ! note that halos for rho_salinity have been filled inside 
       ! update_ocean_density_salinity. however, those halo values 
       ! are bogus, since index_salt and index_Fdelta
       ! have yet to be properly updated. 
       call mpp_update_domains(Dens%rho_salinity(:,:,:,taup1), Domain%domain2d)
       call mpp_clock_begin(id_update_halo_tracer)
       do n=1,num_prog_tracers
          call mpp_update_domains(T_prog(n)%field(:,:,:,taup1), &
               Domain%domain2d, complete=T_prog(n)%complete)
       enddo
       do n=1,num_prog_tracers 
          if(have_obc)call ocean_obc_update_boundary(T_prog(n)%field(:,:,:,taup1), 'T')
       enddo
       call mpp_clock_end(id_update_halo_tracer)

       ! update Dens%pressure_at_depth, Dens%rho, Dens%drhodT, Dens%drhodS
       call mpp_clock_begin(id_density) 
       call update_ocean_density(Time, Thickness, T_prog(index_temp), &
            T_prog(index_salt), Ext_mode, Dens, Lagrangian_system, use_blobs)   
       ! We need to call calculate_rhoT from here so that we avoid circular dependencies
       call calculate_rhoT(Time, Dens, Thickness)
       call mpp_clock_end(id_density) 

       ! add time explicit contributions to Velocity%accel.  
       ! compute just those pieces needed to force barotropic dynamics 
       Velocity%rossby_radius(:,:) = Grid%umask(:,:,1)*rossby_radius(:,:)
       call mpp_clock_begin(id_explicit_accel_a)
       if(tendency == TWO_LEVEL) then 
          call ocean_explicit_accel_a(Velocity, Time, Adv_vel, Thickness, Dens,  &
               Lagrangian_system, Dens%rho(:,:,:,taup1), pme, river, upme, uriver)
       elseif(tendency == THREE_LEVEL) then 
          call ocean_explicit_accel_a(Velocity, Time, Adv_vel, Thickness, Dens,  &
               Lagrangian_system, Dens%rho(:,:,:,tau), pme, river, upme, uriver)
       endif
       call mpp_clock_end(id_explicit_accel_a)

    ! vertical integral of forcing used for barotropic dynamics 
    call mpp_clock_begin(id_barotropic_forcing)
    call ocean_barotropic_forcing(Time, Velocity, Ext_mode) 
    call mpp_clock_end(id_barotropic_forcing)

    ! update (udrho,vdrho) and eta_t_bar or pbot_t_bar using barotropic timesteps 
    call mpp_clock_begin(id_barotropic_update)
    call update_ocean_barotropic (Time, Dens, Thickness, Adv_vel, &
                                  Ext_mode, patm, pme, river, use_blobs)
    call mpp_clock_end(id_barotropic_update)

    ! remaining time explicit contributions to rho*dz*acceleration
    call mpp_clock_begin(id_explicit_accel_b)
    call ocean_explicit_accel_b(visc_cbu, visc_cbt, Time, Thickness, Adv_vel, Velocity)
    call mpp_clock_end(id_explicit_accel_b)

    ! compute pressure conversion diagnostic prior to updating ucell thickness 
    if(tendency == TWO_LEVEL) then 
        call pressure_conversion (Time, Thickness, Dens%rho(:,:,:,taup1),               &
                                  Dens, Ext_mode, Adv_vel, Velocity, Lagrangian_system, &
                                  vert_coordinate_class, use_blobs)
    elseif(tendency == THREE_LEVEL) then 
        call pressure_conversion (Time, Thickness, Dens%rho(:,:,:,tau),                 &
                                  Dens, Ext_mode, Adv_vel, Velocity, Lagrangian_system, &
                                  vert_coordinate_class, use_blobs)
    endif

    ! update time=taup1 value of the velocity grid cell thickness
    ! Thickness%U-arrays with no time index are now at taup1
    call mpp_clock_begin(id_ucell_thickness)
    call update_ucell_thickness(Time, Grid, Ext_mode, Thickness) 
    call mpp_clock_end(id_ucell_thickness)

    ! As used for the Australian OFAM/Bluelink increment to velocity
    call mpp_clock_begin(id_increment_velocity)
    call ocean_increment_velocity_source(Time, Thickness, Velocity)
    call mpp_clock_end(id_increment_velocity)

    ! add velocity sponges
    call mpp_clock_begin(id_sponges_velocity)
    call sponge_velocity_source(Time, Thickness, Velocity)
    call mpp_clock_end(id_sponges_velocity)

    ! density and thickness weighted acceleration from
    ! implicit vertical friction and implicit coriolis 
    call mpp_clock_begin(id_implicit_accel)
    call ocean_implicit_accel(visc_cbu, visc_cbt, visc_cbu_form_drag, Time, Thickness, Adv_vel, Velocity) 
    call mpp_clock_end(id_implicit_accel)

    ! update to time=taup1 the ocean velocity
    call mpp_clock_begin(id_velocity)
    if(horz_grid == MOM_BGRID) then 
       call update_ocean_velocity_bgrid(Time, Thickness, barotropic_split, vert_coordinate_class, Ext_mode, Velocity) 
    else 
       call update_ocean_velocity_cgrid(Time, Thickness, Adv_vel, Ext_mode, Velocity) 
    endif 
    call mpp_clock_end(id_velocity)

    ! compute energy analysis diagnostic 
    call energy_analysis (Time, Thickness, Ext_mode, Adv_vel, Dens, pme, river, upme, &
                          uriver, visc_cbu, visc_cbt, visc_cbu_form_drag, Velocity)

    ! perform some numerical diagnostics (e.g., tracer and mass conservation, CFL checks, etc.)
    call mpp_clock_begin(id_diagnostics)
    call ocean_diagnostics(Time, Thickness, T_prog(1:num_prog_tracers), T_diag(1:num_diag_tracers), &
                           Adv_vel, Ext_mode, Dens, Velocity, &
                           pme, melt, runoff, calving, visc_cbt, diff_cbt)
    call mpp_clock_end(id_diagnostics)

    ! fill halo values for the velocity field 
    call mpp_clock_begin(id_update_halo_velocity)
    if(horz_grid == MOM_BGRID) then 
       call mpp_update_domains(Velocity%u(:,:,:,1,taup1), Velocity%u(:,:,:,2,taup1), &
                              Domain%domain2d,gridtype=BGRID_NE)
    else 
       call mpp_update_domains(Velocity%u(:,:,:,1,taup1), Velocity%u(:,:,:,2,taup1), &
                              Domain%domain2d,gridtype=CGRID_NE)
    endif 

    if(have_obc) then
       call ocean_obc_update_boundary(Velocity%u(:,:,:,1,taup1), 'M','n')
       call ocean_obc_update_boundary(Velocity%u(:,:,:,2,taup1), 'M','t')
       call ocean_obc_update_boundary(Velocity%u(:,:,:,1,taup1), 'Z','t')
       call ocean_obc_update_boundary(Velocity%u(:,:,:,2,taup1), 'Z','n')
    endif
    call mpp_clock_end(id_update_halo_velocity)
    
    ! modifications to prognostic variables using ocean data assimilation 
#ifdef ENABLE_ODA
    call mpp_clock_begin(id_oda)
#ifdef ENABLE_ECDA
    call get_time(Time%model_time, seconds, days) 
    if (seconds == 0 .or. seconds == 43200 ) then 
       do j=js_sfc, je_sfc
          jj = j + j_shift
          do i=is_sfc, ie_sfc
             ii = i + i_shift
             da_flux%u_flux(ii,jj) = Ice_ocean_boundary%u_flux(i,j)
             da_flux%v_flux(ii,jj) = Ice_ocean_boundary%v_flux(i,j)
             ! da_flux%t_flux(ii,jj) = Ice_ocean_boundary%t_flux(i,j)
             ! da_flux%q_flux(ii,jj) = Ice_ocean_boundary%q_flux(i,j)
             ! da_flux%lw_flux(ii,jj) = Ice_ocean_boundary%lw_flux(i,j)
             ! da_flux%salt_flux(ii,jj) = Ice_ocean_boundary%salt_flux(i,j)
          enddo
       enddo
    end if

    call mpp_update_domains(da_flux%u_flux(:,:), da_flux%v_flux(:,:), Domain%domain2d,gridtype=BGRID_NE)
    ! call mpp_update_domains(da_flux%t_flux(:,:), Domain%domain2d)
    ! call mpp_update_domains(da_flux%q_flux(:,:), Domain%domain2d)
    ! call mpp_update_domains(da_flux%lw_flux(:,:), Domain%domain2d)
    ! call mpp_update_domains(da_flux%salt_flux(:,:), Domain%domain2d)

    call mpp_update_domains(Velocity%u(:,:,:,1,taup1), Velocity%u(:,:,:,2,taup1), Domain%domain2d,gridtype=BGRID_NE)
    do n = 1, num_prog_tracers ! snz
       call mpp_update_domains(T_prog(n)%field(:,:,:,taup1), Domain%domain2d)
    end do
    call mpp_update_domains(Ext_mode%eta_t(:,:,taup1), Domain%domain2d)

    call oda(Time, T_prog(1:num_prog_tracers), Velocity, da_flux, Ext_mode)

    call mpp_update_domains(Ext_mode%eta_t(:,:,taup1), Domain%domain2d)

    call mpp_update_domains(da_flux%u_flux(:,:), da_flux%v_flux(:,:), Domain%domain2d,gridtype=BGRID_NE)
    ! call mpp_update_domains(da_flux%t_flux(:,:), Domain%domain2d)
    ! call mpp_update_domains(da_flux%q_flux(:,:), Domain%domain2d)
    ! call mpp_update_domains(da_flux%lw_flux(:,:), Domain%domain2d)
    ! call mpp_update_domains(da_flux%salt_flux(:,:), Domain%domain2d)

    do n = 1, num_prog_tracers ! snz
       call mpp_update_domains(T_prog(n)%field(:,:,:,taup1), Domain%domain2d)
    end do
    call mpp_update_domains(Velocity%u(:,:,:,1,taup1), Velocity%u(:,:,:,2,taup1), Domain%domain2d,gridtype=BGRID_NE)
#else
    call oda(Time, T_prog(1:num_prog_tracers))
#endif
    call mpp_clock_end(id_oda)
#endif

#if defined(ACCESS_CM) || defined(ACCESS_OM)
    ! Perform horizontal mixing to fix the Red Sea and Gulf Bay salinity
    ! drift for ACCESS simulations (no SSS restoring)
    if (redsea_gulfbay_sfix .and. do_sfix_now) then
        call mpp_clock_begin(id_sfix)
        if (mpp_pe() == mpp_root_pe()) then
            call print_time(time_start_update, 'Calling redsea_gulfbay_hmix_s at runtime = ')
        endif
        call redsea_gulfbay_hmix_s(Time, Grid, Domain, Thickness, &
                                   T_prog(index_salt))
        call mpp_clock_end(id_sfix)
    endif
#endif

    call update_ocean_drifters(Velocity, Adv_vel, T_prog(:), Grid, Time)

    ! sum ocean sfc state over coupling interval
    call mpp_clock_begin(id_ocean_sfc)
    call sum_ocean_sfc(Time, Thickness, T_prog(1:num_prog_tracers), &
                       T_diag(1:num_diag_tracers), Dens, Velocity, Ocean_sfc)
    call mpp_clock_end(id_ocean_sfc)

    enddo ! {end of do no=1,num_ocean_calls}

    ! at end of coupling interval, pass averaged ocean state to other component models 
    !
       call mpp_clock_begin(id_ocean_seg_end)
       call avg_ocean_sfc(Time, Thickness, T_prog(1:num_prog_tracers), &
                          T_diag(1:num_diag_tracers), Velocity, Ocean_sfc)
       call mpp_clock_end(id_ocean_seg_end)

    call mpp_clock_end(id_ocean)

    return

  end subroutine update_ocean_model
! </SUBROUTINE> NAME="update_ocean_model"

#if defined(ACCESS_CM) || defined(ACCESS_OM)
  subroutine redsea_gulfbay_hmix_s(Time, Grid, Domain, Thickness, Salt)

  use mpp_mod,           only : mpp_sum

  use auscom_ice_parameters_mod, only : irs1, ire1, jrs1, jre1, irs2, ire2,jrs2, jre2, &
                                        igs, ige, jgs, jge, ksmax

  implicit none

  type(ocean_time_type),         intent(in) :: Time
  type(ocean_grid_type),         intent(in) :: Grid ! grid information for ocean model 
  type(ocean_domain_type),       intent(in)  :: Domain ! domain grid information for ocean model 
  type(ocean_thickness_type),    intent(in) :: Thickness
  type(ocean_prog_tracer_type),  intent(inout) :: Salt


  real :: volume = 0.0
  real :: ave_sp = 0.0

  real, dimension(:,:,:), allocatable :: salt_vol_sums  ! total salt and volume sums. Red sea salt(:,1,1) vol(:,2,1)
                                                    !                             Gulf      salt(:,1,2) vol(:,2,2)

  integer :: tau, taup1
  integer :: i, j, k

  integer :: isc, iec, jsc, jec
  integer :: isd, ied, jsd, jed

  tau   = Time%tau
  taup1 = Time%taup1

  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)

  allocate(salt_vol_sums(ksmax,2,2))
  salt_vol_sums = 0.0
  do k = 1, ksmax
    ! 
    !for Red Sea
    !
    do j=max(jrs1,jsc),min(jre1,jec)
      do i=max(irs1,isc),min(ire1,iec)
         if(Grid%tmask(i,j,k) == 1.0) then
             volume = Grid%dat(i,j) * Thickness%dzt(i,j,k)
             salt_vol_sums(k,1,1) = salt_vol_sums(k,1,1) + Salt%field(i,j,k,taup1) * volume
             salt_vol_sums(k,2,1) = salt_vol_sums(k,2,1) + volume
          endif
      enddo
    enddo
    do j=max(jrs2,jsc),min(jre2,jec)
      do i=max(irs2,isc),min(ire2,iec)
         if(Grid%tmask(i,j,k) == 1.0) then
             volume = Grid%dat(i,j) * Thickness%dzt(i,j,k)
             salt_vol_sums(k,1,1) = salt_vol_sums(k,1,1) + Salt%field(i,j,k,taup1) * volume
             salt_vol_sums(k,2,1) = salt_vol_sums(k,2,1) + volume
         endif
      enddo
    enddo
    ! 
    !for Gulf Bay
    !
    do j=max(jgs,jsc),min(jge,jec)
      do i=max(igs,isc),min(ige,iec)
         if(Grid%tmask(i,j,k) == 1.0) then
             volume = Grid%dat(i,j) * Thickness%dzt(i,j,k)
             salt_vol_sums(k,1,2) = salt_vol_sums(k,1,2) + Salt%field(i,j,k,taup1) * volume
             salt_vol_sums(k,2,2) = salt_vol_sums(k,2,2) + volume
          endif
      enddo
    enddo

  enddo   !k=1,ksmax

  call mpp_sum(salt_vol_sums, size(salt_vol_sums))

! Replace by sums
! Note that we fill to domain edge. No need to update halo

! Red Sea
  do k=1,ksmax
     if ( salt_vol_sums(k,2,1) /= 0.0 ) then
        ave_sp = salt_vol_sums(k,1,1) / salt_vol_sums(k,2,1)
        do j=max(jrs1,jsd),min(jre1,jed)
           do i=max(irs1,isd),min(ire1,ied)
              Salt%field(i,j,k,taup1) =  ave_sp * Grid%tmask(i,j,k)
           enddo
        enddo
        do j=max(jrs2,jsd),min(jre2,jed)
           do i=max(irs2,isd),min(ire2,ied)
              Salt%field(i,j,k,taup1) =  ave_sp * Grid%tmask(i,j,k)
           enddo
       enddo
    endif

!Persian gulf

    if ( salt_vol_sums(k,2,2) /= 0.0 ) then
        ave_sp = salt_vol_sums(k,1,2) / salt_vol_sums(k,2,2)
        do j=max(jgs,jsd),min(jge,jed)
           do i=max(igs,isd),min(ige,ied)
              Salt%field(i,j,k,taup1) =  ave_sp * Grid%tmask(i,j,k)
           enddo
        enddo
    endif
  enddo
   
    
  

  deallocate (salt_vol_sums)

  end subroutine redsea_gulfbay_hmix_s
#endif

!#######################################################################
! <SUBROUTINE NAME="get_ocean_grid_size">
!
! <DESCRIPTION>
! Obtain the ocean grid size. 
! </DESCRIPTION>
!
  subroutine get_ocean_grid_size(num_lon, num_lat, num_z)

    integer,           intent(out) :: num_lon, num_lat
    integer, optional, intent(out) :: num_z

    num_lon = Grid%ni
    num_lat = Grid%nj
    if (PRESENT(num_z)) num_z   = Grid%nk

    return
    
  end subroutine get_ocean_grid_size
! </SUBROUTINE> NAME="get_ocean_grid_size"

subroutine ocean_model_data2D_get(OS,Ocean, name, array2D,isc,jsc)
  type(ocean_state_type),     pointer    :: OS
  type(ocean_public_type),    intent(in) :: Ocean
  character(len=*)          , intent(in) :: name
  real, dimension(isc:,jsc:), intent(out):: array2D
  integer                   , intent(in) :: isc,jsc

  !Output array2D is allocated on the coupled model compute domain
  !Grid% and T_prog% arrays below are allocated on
  !data   domain for dynamic case
  !or
  !global domain for static  case
  !Hence we need to start copying them from Domain%isc and Domain%jsc

  select case(name)
  case('area')
      array2D(isc:iec,jsc:jec) = Ocean%area(isc:iec,jsc:jec)
  case('t_surf')
      array2D(isc:iec,jsc:jec) = Ocean%t_surf(isc:iec,jsc:jec)
  case('mask')
      array2D(isc:iec,jsc:jec) = Grid%tmask(Domain%isc:Domain%iec,Domain%jsc:Domain%jec,1)
  case('t_pme')
      array2D(isc:iec,jsc:jec) = T_prog(index_temp)%tpme(Domain%isc:Domain%iec,Domain%jsc:Domain%jec)
  case('t_runoff')
      array2D(isc:iec,jsc:jec) = T_prog(index_temp)%trunoff(Domain%isc:Domain%iec,Domain%jsc:Domain%jec)
  case('t_calving')
      array2D(isc:iec,jsc:jec) = T_prog(index_temp)%tcalving(Domain%isc:Domain%iec,Domain%jsc:Domain%jec)
  case('btfHeat')
      array2D(isc:iec,jsc:jec) = T_prog(index_temp)%conversion * T_prog(index_temp)%btf(Domain%isc:Domain%iec,Domain%jsc:Domain%jec)
  case default
      call mpp_error(FATAL,'get_ocean_grid_data2D: unknown argument name='//name)
  end select

end subroutine ocean_model_data2D_get

subroutine ocean_model_data1D_get(OS,Ocean, name, value)
  type(ocean_state_type),     pointer    :: OS
  type(ocean_public_type),    intent(in) :: Ocean
  character(len=*)          , intent(in) :: name
  real                      , intent(out):: value
  
  select case(name)
  case('c_p')
     value = cp_ocean
  case default
     call mpp_error(FATAL,'get_ocean_grid_data1D: unknown argument name='//name)
  end select
  

end subroutine ocean_model_data1D_get

!#######################################################################
! <SUBROUTINE NAME="get_ocean_domain">
!
! <DESCRIPTION>
! Obtain the ocean domain size. 
! </DESCRIPTION>
!
  subroutine get_ocean_domain(Ocean_domain)

    type(domain2d), intent(out) :: Ocean_domain

    if (.NOT. module_is_initialized) then
       call mpp_error(FATAL, &
       '==>Error in ocean_model_mod (get_ocean_domain): module is not initialized')
    endif

    Ocean_domain = Domain%domain2d

    return

  end subroutine get_ocean_domain
! </SUBROUTINE> NAME="get_ocean_domain"


!#######################################################################
! <SUBROUTINE NAME="ocean_model_init_sfc">
!
! <DESCRIPTION>
! Call ocean_tpm_init_sfc and pass it the needed arguments, most of which
! are local to the ocean model.
! </DESCRIPTION>
!
  subroutine ocean_model_init_sfc(Ocean_state, Ocean)
    type(ocean_state_type),  pointer       :: Ocean_state    
    type(ocean_public_type), intent(inout) :: Ocean

    call ocean_tpm_init_sfc(Domain, T_prog(:), Dens, Ocean, Time, Grid)
    
    return

  end subroutine ocean_model_init_sfc
! </SUBROUTINE> NAME="ocean_model_init_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_model_flux_init">
!
! <DESCRIPTION>
! Call ocean_tpm_flux_init and pass it the needed arguments, most of which
! are local to the ocean model. 
!
! Currently, no arguments are passed.
! </DESCRIPTION>
!
  subroutine ocean_model_flux_init(Ocean_state)
    type(ocean_state_type), pointer       :: Ocean_state
    
    call ocean_tpm_flux_init
    
    return

  end subroutine ocean_model_flux_init
! </SUBROUTINE> NAME="ocean_model_flux_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_model_end">
!
! <DESCRIPTION>
! Close down the ocean model 
!   This subroutine terminates the model run, saving the ocean state in a
! restart file and deallocating any data associated with the ocean.
!
! NOTE from nnz: This module keeps its own Time and does not need the Time_in argument.
! Arguments: 
!   Ocean_state (type(ocean_state_type), pointer) - A structure containing the internal ocean state.
!   Time_in     (type(time_type), intent(in))     - The model time, used for writing restarts.
!   Ocean_sfc   (type(ocean_public_type), optional, intent(inout))- An ocean_public_type structure that is to be
!                   deallocated upon termination.
! </DESCRIPTION>
!
  subroutine ocean_model_end(Ocean_sfc, Ocean_state, Time_in)
    type(ocean_state_type),            pointer       :: Ocean_state
    type(time_type),                   intent(in)    :: Time_in
    type(ocean_public_type), optional, intent(inout) :: Ocean_sfc

  integer :: stdoutunit 
  stdoutunit=stdout() 

#if defined (ENABLE_ODA) && defined (ENABLE_ECDA)
    call oda_end()
#endif

    call ocean_blob_end(Time, T_prog(:), Lagrangian_system)
    call ocean_advection_velocity_end(Time, Adv_vel, use_blobs)
    call ocean_tracer_end(Time, T_prog(:), T_diag(:), use_blobs)
    call ocean_tracer_advect_end(Time, T_prog(:))
    call ocean_nphysics_end(Time)
    call ocean_nphysics_new_end()
    call ocean_bih_friction_end(Time)
    call ocean_lap_friction_end(Time)
    call ocean_sigma_transport_end(Time)
    call ocean_tpm_end(Domain, Grid, T_prog(:), T_diag(:), Time, Thickness)
    call ocean_velocity_end(Time, Velocity, use_blobs)
    call ocean_barotropic_end(Time, Ext_mode)
    call ocean_thickness_end(Time, Grid, introduce_blobs, Thickness)
    call ocean_density_end(Time, Dens, use_blobs)
    if(have_obc) call ocean_obc_end(Time, have_obc)
    call ocean_sfc_end(Ocean_sfc)
    call ocean_vert_mix_end(Time)
    call ocean_drifters_end(Grid)
    call ocean_wave_end(Time, Waves)
    
    write (stdoutunit,'(//,1x,a)') &
    '==================Summary of completed MOM integration======================='

    call ocean_parameters_end()

    if(vert_coordinate==GEOPOTENTIAL) then 
       write(stdoutunit,'(1x,a)') &
       ' Finished MOM integration using GEOPOTENTIAL as the vertical coordinate.' 
    elseif(vert_coordinate==ZSTAR) then 
       write(stdoutunit,'(1x,a)') &
       ' Finished MOM integration using ZSTAR as the vertical coordinate.' 
    elseif(vert_coordinate==ZSIGMA) then 
       write(stdoutunit,'(1x,a)') &
       ' Finished MOM integration using ZSIGMA as the vertical coordinate.' 
    elseif(vert_coordinate==PRESSURE) then 
       write(stdoutunit,'(1x,a)') &
       ' Finished MOM integration using PRESSURE as the vertical coordinate.' 
    elseif(vert_coordinate==PSTAR) then 
       write(stdoutunit,'(1x,a)') &
       ' Finished MOM integration using PSTAR as the vertical coordinate.' 
    elseif(vert_coordinate==PSIGMA) then 
       write(stdoutunit,'(1x,a)') &
       ' Finished MOM integration using PSIGMA as the vertical coordinate.' 
    endif 

    if(horz_grid==MOM_BGRID) then  
       write (stdoutunit,'(1x,a)')  &
       ' B-grid was used for the horizontal layout of discrete variables.'
    elseif(horz_grid==MOM_CGRID) then  
       write (stdoutunit,'(1x,a)')  &
       ' C-grid was used for the horizontal layout of discrete variables.'
    endif 
    
    write (stdoutunit,'(1x,a,1x,i12)')  &
    ' number of time steps                             = ',Time%itt
    write (stdoutunit,'(1x,a,1x,i12)')  &
    ' number of prog-tracers                           = ',num_prog_tracers
    write (stdoutunit,'(1x,a,1x,i12)')  &
    ' number of diag-tracers                           = ',num_diag_tracers
    write (stdoutunit,'(1x,a,1x,i12)')  &
    ' number of i-points(ni)                           = ',Grid%ni
    write (stdoutunit,'(1x,a,1x,i12)')  &
    ' number of j-points(nj)                           = ',Grid%nj
    write (stdoutunit,'(1x,a,1x,i12)')  &
    ' number of k-points(nk)                           = ',Grid%nk
    write (stdoutunit,'(1x,a,1x,i12)')  &
    ' number of computed ocean tracer points(ni*nj*nk) = ',Grid%total_t_points
    write (stdoutunit,'(1x,a,1x,i12)')  &
    ' number of wet ocean tracer points                = ',Grid%wet_t_points
    write (stdoutunit,'(1x,a,1x,i12)')  &
    ' number of wet ocean velocity points              = ',Grid%wet_u_points

    write (stdoutunit,'(1x,a,1x,a)')     &
    ' slow motion time tendency computed using         =       ',time_tendency
    write (stdoutunit,'(1x,a,1x,a)')     &
    ' barotropic motion computed using                 = ',Time_steps%barotropic_scheme
    write (stdoutunit,'(1x,a,1x,f16.6)') &
    ' tracer time step dtts (secs)                     = ',Time_steps%dtts
    write (stdoutunit,'(1x,a,1x,f16.6)') &
    ' baroclinic velocity time step dtuv (secs)        = ',Time_steps%dtuv
    write (stdoutunit,'(1x,a,1x,f16.6)') &
    ' barotropic time step dtbt (secs)                 = ',Time_steps%dtbt
    write (stdoutunit,'(1x,a,1x,f16.6)') &
    ' implicit Coriolis parameter acor                 = ',Time_steps%acor
    write (stdoutunit,'(1x,a,1x,f16.6)') &
    ' implicit vertical mixing parameter aidif         = ',Time_steps%aidif

    write (stdoutunit,'(a)')  ' '
    write (stdoutunit,'(2x,a)')             Ocean_options%OBC
    write (stdoutunit,'(2x,a)')             Ocean_options%lagrangian_blobs
    write (stdoutunit,'(2x,a)')             Ocean_options%override_velocity
    write (stdoutunit,'(2x,a)')             Ocean_options%coriolis
    write (stdoutunit,'(2x,a)')             Ocean_options%baroclinic_tendency
    write (stdoutunit,'(2x,a)')             Ocean_options%barotropic_tendency
    write (stdoutunit,'(2x,a)')             Ocean_options%tracer_tendency
    write (stdoutunit,'(2x,a)')             Ocean_options%equation_of_state
    write (stdoutunit,'(2x,a)')             Ocean_options%temperature_variable
    write (stdoutunit,'(2x,a)')             Ocean_options%frazil_ice
    write (stdoutunit,'(2x,a)')             Ocean_options%vert_mix
    write (stdoutunit,'(2x,a)')             Ocean_options%convective_adjustment
    write (stdoutunit,'(2x,a)')             Ocean_options%tidal_wave_mix
    write (stdoutunit,'(2x,a)')             Ocean_options%tidal_drag_mix
    write (stdoutunit,'(2x,a)')             Ocean_options%bryan_lewis_mix
    write (stdoutunit,'(2x,a)')             Ocean_options%hwf_mix
    write (stdoutunit,'(2x,a)')             Ocean_options%tanh_diff_cbt
    write (stdoutunit,'(2x,a)')             Ocean_options%read_diff_cbt
    write (stdoutunit,'(2x,a)')             Ocean_options%j09_diff_cbt
    write (stdoutunit,'(2x,a)')             Ocean_options%horz_bih_tracer
    write (stdoutunit,'(2x,a)')             Ocean_options%horz_lap_tracer
    write (stdoutunit,'(2x,a)')             Ocean_options%horz_lap_friction
    write (stdoutunit,'(2x,a)')             Ocean_options%horz_bih_friction
    write (stdoutunit,'(2x,a)')             Ocean_options%momentum_source
    write (stdoutunit,'(2x,a)')             Ocean_options%form_drag
    write (stdoutunit,'(2x,a)')             Ocean_options%bottom_roughness
    write (stdoutunit,'(2x,a)')             Ocean_options%bmf_implicit
    write (stdoutunit,'(2x,a)')             Ocean_options%geothermal_heating
    write (stdoutunit,'(2x,a)')             Ocean_options%neutral_physics
    write (stdoutunit,'(2x,a)')             Ocean_options%neutral_physics_new
    write (stdoutunit,'(2x,a)')             Ocean_options%submesoscale
    write (stdoutunit,'(2x,a)')             Ocean_options%sigma_transport
    write (stdoutunit,'(2x,a)')             Ocean_options%overflow
    write (stdoutunit,'(2x,a)')             Ocean_options%overexchange
    write (stdoutunit,'(2x,a)')             Ocean_options%mixdownslope
    write (stdoutunit,'(2x,a)')             Ocean_options%shortwave
    write (stdoutunit,'(2x,a)')             Ocean_options%xlandmix
    write (stdoutunit,'(2x,a)')             Ocean_options%xlandinsert
    write (stdoutunit,'(2x,a)')             Ocean_options%rivermix
    write (stdoutunit,'(2x,a)')             Ocean_options%riverspread
    write (stdoutunit,'(2x,a)')             Ocean_options%passive_tracers
    write (stdoutunit,'(2x,a)')             Ocean_options%ocean_sponges_eta
    write (stdoutunit,'(2x,a)')             Ocean_options%ocean_sponges_tracer
    write (stdoutunit,'(2x,a)')             Ocean_options%ocean_sponges_velocity
    write (stdoutunit,'(2x,a)')             Ocean_options%fafmip_heat
    write (stdoutunit,'(2x,a/)')   '===================================================='   

    return

  end subroutine ocean_model_end
! </SUBROUTINE> NAME="ocean_model_end"

!#######################################################################
! <SUBROUTINE NAME="ocean_model_restart">
!
! <DESCRIPTION>
! write out restart file.
! </DESCRIPTION>
!
  subroutine ocean_model_restart(Ocean_state, timestamp)
     type(ocean_state_type),    pointer     :: Ocean_state
     character(len=*), intent(in), optional :: timestamp

     call ocean_tracer_restart(Time, T_prog, timestamp)
     call ocean_tracer_advect_restart(T_prog)
     call ocean_nphysics_restart(timestamp)
     call ocean_nphysics_new_restart(timestamp)
     call ocean_bih_friction_restart(timestamp)
     call ocean_lap_friction_restart(timestamp)
     call ocean_sigma_transport_restart(timestamp)
     call ocean_velocity_restart(Time, Velocity, use_blobs, timestamp)
     call ocean_barotropic_restart(Time, Ext_mode, timestamp)
     call ocean_thickness_restart(Time, Thickness, introduce_blobs, timestamp)
     call ocean_density_restart(Time, Dens, timestamp)
     if(have_obc) call ocean_obc_restart()
     call ocean_sfc_restart(timestamp)
     call ocean_vert_mix_restart(timestamp)

  end subroutine ocean_model_restart
! </SUBROUTINE> NAME="ocean_model_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_stock_pe">
!
! <DESCRIPTION>
! Returns stocks of total ocean heat and water water for conservation 
! checks.  Report here values just on a single PE. Global sums 
! are done in the coupler. 
!
! This routine is part of a group of similar routines in other 
! FMS component models that aims to quantify the conservation of 
! scalar properties between the component models when running 
! coupled models. 
! 
! </DESCRIPTION>
!
subroutine ocean_stock_pe(Ocean_state, index, value, time_index)
  type(ocean_state_type),pointer     :: Ocean_state
  integer,               intent(in)  :: index
  real,                  intent(out) :: value
  integer, optional,     intent(in)  :: time_index ! -1=previous, 0=now, or +1=next

  integer  :: i,j,k
  integer  :: itime, t_index 
  integer, parameter :: INDEX_PREV=-1, INDEX_NOW=0, INDEX_NEXT=+1

  value = 0.0

  if (.not.associated(Ocean_state)) return
  if(.not. Ocean_state%is_ocean_pe) return

  !The default t_index has to be INDEX_NEXT because stocks are evaluated after 
  !ocean update (values at taup1 are set) but before we are in the next time step.
  t_index = INDEX_NEXT 
  if(present(time_index)) t_index = time_index


  select case(t_index)

  ! note that for time_tendency=='twolevel', taum1=tau
  case (INDEX_PREV)
     itime = Time % taum1

  case (INDEX_NOW)
     itime = Time % tau

  case default
     itime = Time % taup1

  end select


  select case (index)

  ! units of kg  
  case (ISTOCK_WATER)
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               value = value + Grid%tmask(i,j,k)*Grid%dat(i,j)*Thickness%rho_dzt(i,j,k,itime)
            enddo
         enddo
      enddo

  ! units of Joule 
  case (ISTOCK_HEAT)
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               value = value + Grid%tmask(i,j,k)*Grid%dat(i,j)*Thickness%rho_dzt(i,j,k,itime) &
                               *T_prog(index_temp)%field(i,j,k,itime)
            enddo
         enddo
      enddo
      value = value*T_prog(index_temp)%conversion

   case (ISTOCK_SALT)
      ! Return the mass of the salt in the ocean on this PE in kg.
      ! The T_prog(index_salt)%conversion = 1000 converts salinity in PSU to saltinity in kg kg-1.
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               value = value + Grid%tmask(i,j,k)*Grid%dat(i,j)*Thickness%rho_dzt(i,j,k,itime) &
                               *T_prog(index_salt)%field(i,j,k,itime)
            enddo
         enddo
      enddo
      value = value*T_prog(index_salt)%conversion


  case default

      value = 0.0

  end select 


end subroutine ocean_stock_pe
! </SUBROUTINE> NAME="ocean_stock_pe"


!#######################################################################
! <SUBROUTINE NAME="mom4_get_Tsurf">
!
! <DESCRIPTION>
! Return the surface temperature in degrees K
! </DESCRIPTION>
!
subroutine mom4_get_Tsurf(Ocean, res)

  type(Ocean_public_type) :: Ocean
  real, intent(out)     :: res(Domain%isc:, Domain%jsc:)

  integer :: isc, iec, jsc, jec, i, j

  isc = Domain%isc ; iec = Domain%iec
  jsc = Domain%jsc ; jec = Domain%jec

  do j=jsc,jec
     do i=isc,iec
        res(i,j) = Ocean%t_surf(i,j)
     enddo
  enddo

end subroutine mom4_get_Tsurf
! </SUBROUTINE> NAME="mom4_get_Tsurf"


!#######################################################################
! <SUBROUTINE NAME="mom4_get_Ssurf">
!
! <DESCRIPTION>
! Return the surface salinity in psu
! </DESCRIPTION>
!
subroutine mom4_get_Ssurf(Ocean, res)

  type(Ocean_public_type) :: Ocean
  real, intent(out)     :: res(Domain%isc:, Domain%jsc:)

  integer :: isc, iec, jsc, jec, i, j

  isc = Domain%isc ; iec = Domain%iec
  jsc = Domain%jsc ; jec = Domain%jec

  do j = jsc, jec
     do i = isc, iec
        res(i,j) = Ocean%s_surf(i,j)
     enddo
  enddo

end subroutine mom4_get_Ssurf
! </SUBROUTINE> NAME="mom4_get_Ssurf"


!#######################################################################
! <SUBROUTINE NAME="mom4_get_thickness">
!
! <DESCRIPTION>
! Return thickness (in meters) of each layer.
! </DESCRIPTION>
!
subroutine mom4_get_thickness(fld)

  real, intent(out) :: fld(isc:,jsc:,:)

  integer :: i, j, k

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           fld(i,j,k) = Thickness%dzt(i,j,k)
        enddo
     enddo
  enddo
  
end subroutine mom4_get_thickness
! </SUBROUTINE> NAME="mom4_get_thickness"


!#######################################################################
! <SUBROUTINE NAME="mom4_get_density">
!
! <DESCRIPTION>
! Return density (in kg/m^3).
! </DESCRIPTION>
!
subroutine mom4_get_density(fld)

  real, intent(out) :: fld(isc:,jsc:,:)

  integer :: i, j, k, tau

  tau = Time%tau

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           fld(i,j,k) = Dens%rho(i,j,k,tau)
        enddo
     enddo
  enddo
  
end subroutine mom4_get_density
! </SUBROUTINE> NAME="mom4_get_density"


!#######################################################################
! <SUBROUTINE NAME="mom4_get_prog_tracer">
!
! <DESCRIPTION>
! Return prognostic tracer data.
! </DESCRIPTION>
!
subroutine mom4_get_prog_tracer(index, fld, units, longname)

  integer, intent(in) :: index 
  real, intent(out)   :: fld(Domain%isc:,Domain%jsc:,:)
  character(len=*), optional, intent(out)  :: units
  character(len=*), optional, intent(out)  :: longname

  integer :: i, j, k, tau

  tau = Time%tau

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           fld(i,j,k) = T_prog(index)%field(i,j,k,tau)
        enddo
     enddo
  enddo
  
  if(present(units   )) units    = T_prog(index)%units
  if(present(longname)) longname = T_prog(index)%longname
  
end subroutine mom4_get_prog_tracer
! </SUBROUTINE> NAME="mom4_get_prog_tracer"


!#######################################################################
! <SUBROUTINE NAME="mom4_get_temperature_index">
!
! <DESCRIPTION>
! Return temperature index from prognostic tracer table, which can 
! then be used to extract data.
! </DESCRIPTION>
!
subroutine mom4_get_temperature_index(index)

  integer, intent(out) :: index

  index = INDEX_TEMP
  
end subroutine mom4_get_temperature_index
! </SUBROUTINE> NAME="mom4_get_temperature_index"


!#######################################################################
! <SUBROUTINE NAME="mom4_get_salinity_index">
!
! <DESCRIPTION>
! Return salt index from prognostic tracer table, which can 
! then be used to extract data.
! </DESCRIPTION>
!
subroutine mom4_get_salinity_index(index)

  integer, intent(out) :: index

  index = INDEX_SALT
  
end subroutine mom4_get_salinity_index
! </SUBROUTINE> NAME="mom4_get_salinity_index"


!#######################################################################
! <SUBROUTINE NAME="mom4_get_dimensions">
!
! <DESCRIPTION>
! Return dimensions of data in compute domain
! </DESCRIPTION>
!
subroutine mom4_get_dimensions(isc, iec, jsc, jec, isd, ied, jsd, jed, nk_out)

  integer, optional, intent(out) :: isc ! starting x-index of compute domain
  integer, optional, intent(out) :: iec ! ending x-index of compute domain
  integer, optional, intent(out) :: jsc ! starting y-index of compute domain
  integer, optional, intent(out) :: jec ! ending y-index of compute domain

  integer, optional, intent(out) :: isd ! starting x-index of data domain
  integer, optional, intent(out) :: ied ! ending x-index of data domain
  integer, optional, intent(out) :: jsd ! starting y-index of data domain
  integer, optional, intent(out) :: jed ! ending y-index of data domain

  integer, optional, intent(out) :: nk_out  ! number of vertical levels

  if(present(isc)) isc = Domain%isc
  if(present(iec)) iec = Domain%iec
  if(present(jsc)) jsc = Domain%jsc
  if(present(jec)) jec = Domain%jec

  if(present(isd)) isd = Domain%isd
  if(present(ied)) ied = Domain%ied
  if(present(jsd)) jsd = Domain%jsd
  if(present(jed)) jed = Domain%jed

  if(present(nk_out)) nk_out = NK
  
end subroutine mom4_get_dimensions
! </SUBROUTINE> NAME="mom4_get_dimensions"


!#######################################################################
! <SUBROUTINE NAME="mom4_get_UVsurf">
!
! <DESCRIPTION>
! Return horizontal velocity vector components (u,v) on the 
! A grid (tracer-points).
!
! Note that these velocity components are oriented according to the 
! grid lines (i-lines and j-lines).  They are generally NOT mapped 
! to latitude-longitude lines, unless using a spherical coordinate 
! grid specification.  
! </DESCRIPTION>
!
subroutine mom4_get_UVsurf(Ocean, ua, va, ier)

  type(ocean_public_type)    :: Ocean
  real, dimension(Domain%isc:,Domain%jsc:), intent(out)        :: ua, va
  integer, intent(out)     :: ier  ! error code (0=ok)
  
  
  call mom4_U_to_T_2d(ub=Ocean%u_surf, &
       &              vb=Ocean%v_surf, &
       &              ua=ua, va=va, ier=ier)

end subroutine mom4_get_UVsurf
! </SUBROUTINE> NAME="mom4_get_UVsurf"


!#######################################################################
! <SUBROUTINE NAME="mom4_get_UV">
!
! <DESCRIPTION>
! Return horizontal velocity vector (u,v) (in m/s) on T points (A mesh).
!
! Note that these velocity components are oriented according to the 
! grid lines (i-lines and j-lines).  They are generally NOT mapped 
! to latitude-longitude lines, unless using a spherical coordinate 
! grid specification. 
! </DESCRIPTION>
!
subroutine mom4_get_UV(ua, va, ier)

  real, dimension(Domain%isc:, Domain%jsc:, :), intent(out) :: ua, va
  integer, intent(out) :: ier ! error code (0=ok)

  real, dimension(Domain%isc:Domain%iec, Domain%jsc:Domain%jec, nk) :: ub_tmp, vb_tmp

  integer :: i, j, k, tau

  tau   = Time%tau

  do k=1,nk

     do j=jsc,jec
        do i=isc,iec
           ub_tmp(i,j,k) = Velocity%u(i,j,k,1,tau)
           vb_tmp(i,j,k) = Velocity%u(i,j,k,2,tau)
        enddo
     enddo
     
     call mom4_U_to_T_2d(ub=ub_tmp(Domain%isc:, Domain%jsc:, k), &
          &              vb=vb_tmp(Domain%isc:, Domain%jsc:, k), &
          &              ua=ua(Domain%isc:, Domain%jsc:, k), &
          &              va=va(Domain%isc:, Domain%jsc:, k), ier=ier)

  enddo
  
end subroutine mom4_get_UV
! </SUBROUTINE> NAME="mom4_get_UV"


!#######################################################################
! <SUBROUTINE NAME="mom4_U_to_T_2d">
!
! <DESCRIPTION>
! Interpolate (u,v) velocity components from U (B-grid) to 
! T points (A-grid).
! </DESCRIPTION>
!
subroutine mom4_U_to_T_2d(ub, vb, ua, va, ier)

  real, dimension(Domain%isc:, Domain%jsc:), intent(in)  :: ub, vb
  real, dimension(Domain%isc:, Domain%jsc:), intent(out) :: ua, va
  integer, intent(out) :: ier

  integer :: isc, iec, jsc, jec, i1, j1, i, j
  real, dimension(Domain%isd:Domain%ied, Domain%jsd:Domain%jed) :: ub_tmp, vb_tmp

  ier = 0

  if( Domain%yhalo < 1 .or. Domain%xhalo < 1 ) then
     ! error; need at least one halo point
     ier = 1
     return
  endif

  isc = Domain%isc ; iec = Domain%iec
  jsc = Domain%jsc ; jec = Domain%jec

  ! For the time being we assume the input arrays to be on the compute 
  ! domain. Ideally would want to handle input arrays both on the compute
  ! and data domain. In the latter case, a copy + mpp_update can be avoided.
  if(size(ub, dim=1) /= iec-isc+1 .or. size(vb, dim=2) /= jec-jsc+1) then
     ! input arrays must be on the compute domain
     ier = 2
     return
  endif

  ub_tmp(isc:iec, jsc:jec) = ub(isc:iec, jsc:jec)
  vb_tmp(isc:iec, jsc:jec) = vb(isc:iec, jsc:jec)

  call mpp_update_domains(ub_tmp, vb_tmp, Domain%domain2d)

  do j = jsc-1, jec-1
     j1 = j + 1
     do i = isc-1, iec-1
        i1 = i + 1
        ua(i1,j1) = ( &
             & ub_tmp(i ,j ) * Grid%dtn(i1,j1) * Grid%dte(i1,j1) + &
             & ub_tmp(i1,j ) * Grid%dtn(i1,j1) * Grid%dtw(i1,j1) + &
             & ub_tmp(i1,j1) * Grid%dts(i1,j1) * Grid%dtw(i1,j1) + &
             & ub_tmp(i ,j1) * Grid%dts(i1,j1) * Grid%dte(i1,j1) &
             & ) / Grid%dat(i1,j1)
        va(i1,j1) = ( &
             & vb_tmp(i ,j ) * Grid%dtn(i1,j1) * Grid%dte(i1,j1) + &
             & vb_tmp(i1,j ) * Grid%dtn(i1,j1) * Grid%dtw(i1,j1) + &
             & vb_tmp(i1,j1) * Grid%dts(i1,j1) * Grid%dtw(i1,j1) + &
             & vb_tmp(i ,j1) * Grid%dts(i1,j1) * Grid%dte(i1,j1) &
             & ) / Grid%dat(i1,j1)
     enddo
  enddo

end subroutine mom4_U_to_T_2d
! </SUBROUTINE> NAME="mom4_U_to_T_2d"

!#######################################################################
! <SUBROUTINE NAME="mom4_get_latlon_UV">
!
!   <OVERVIEW>
!     Gets horizontal velocity components (u,v) (in m/s) on T points (A mesh) 
!     along geographical (latlon) directions in compute domain.
!   </OVERVIEW>
!   <DESCRIPTION>
!    Note that these velocity components are oriented along the 
!    geographical latitude-longitude lines.  
!
!           im,j    i,j
!  B-------B-------B-------B       y
!  |       |       |       |       ^
!  |       |    i,j|       |       |   /lon
!  |---A---|---A---|---A---|       |  /   
!  |       |       |       |     \ | /
!  |       |im,jm  |i,jm   |      \|/ rot angle
!  B-------B-------B-------B    ---X-------------> x
!  |       |       |       |      /|\
!  |       |       |       |     / | \
!  |---A---|---A---|---A---|       |  \lat  
!  |       |       |       |       |   \
!  |       |       |       |
!  B-------B-------B-------B
!
!   </DESCRIPTION>
!   <TEMPLATE>
!     use ocean_model_mod 
!     real, dimension(isc:, jsc:, :) :: u,v
!     integer :: ierr
!     call mom4_get_latlon_UV(ua, va, ierr)
!   </TEMPLATE>
!   <OUT NAME="ua"  TYPE="real, dimension(isc:, jsc:, :)" >
!     array will contain velocity component along x direction upon return
!   </OUT>
!   <OUT NAME="va"  TYPE="real, dimension(isc:, jsc:, :)" >
!     array will contain velocity component along y direction upon return
!   </OUT>
!   <OUT NAME="ierr"  TYPE="ineger" >
!     error status will be zero for success and nonzero for failure 
!   </OUT>
!
subroutine mom4_get_latlon_UV(ua, va, ier)

  real, dimension(isc:, jsc:, :), intent(out) :: ua, va
  integer, intent(out) :: ier ! error code (0=ok)

  real, dimension(isd:ied, jsd:jed) :: ub_tmp, vb_tmp

  integer :: i, j, k, im, jm, tau

  ier = 0
  tau   = Time%tau

  do k=1,nk

     ! Rotate the coordinates system to be along geographical (lat-lon) coordinates.
     ! (Passive transformation with rotation matrix).
     !
     do j=jsc,jec
        do i=isc,iec
           ub_tmp(i,j) = Grid%cos_rot(i,j)*Velocity%u(i,j,k,1,tau) &
           &           - Grid%sin_rot(i,j)*Velocity%u(i,j,k,2,tau) 
             
           vb_tmp(i,j) = Grid%sin_rot(i,j)*Velocity%u(i,j,k,1,tau) &
           &           + Grid%cos_rot(i,j)*Velocity%u(i,j,k,2,tau) 
        enddo
     enddo

     ! Fill in the halos
     call mpp_update_domains(ub_tmp, vb_tmp, Domain%domain2d)

     ! Take the average of fields at corners (B Grid) to estimate the field at center (A Grid).
     ! Try an area weighted average.

     do j = jsc, jec
        jm = j - 1
        do i = isc, iec
           im = i - 1
           ua(i,j,k) = ( &
                & ub_tmp(i ,j)  * Grid%dtn(i,j) * Grid%dte(i,j) + &
                & ub_tmp(im,j)  * Grid%dtn(i,j) * Grid%dtw(i,j) + &
                & ub_tmp(im,jm) * Grid%dts(i,j) * Grid%dtw(i,j) + &
                & ub_tmp(i ,jm) * Grid%dts(i,j) * Grid%dte(i,j) ) / Grid%dat(i,j)

           va(i,j,k) = ( &
                & vb_tmp(i ,j)  * Grid%dtn(i,j) * Grid%dte(i,j) + &
                & vb_tmp(im,j)  * Grid%dtn(i,j) * Grid%dtw(i,j) + &
                & vb_tmp(im,jm) * Grid%dts(i,j) * Grid%dtw(i,j) + &
                & vb_tmp(i ,jm) * Grid%dts(i,j) * Grid%dte(i,j) ) / Grid%dat(i,j)
        enddo
     enddo
     
  enddo !end k loop
  
end subroutine mom4_get_latlon_UV
! </SUBROUTINE> NAME="mom4_get_latlon_UV"


!#######################################################################
! <SUBROUTINE NAME="mom4_get_diag_axes">
!
! <DESCRIPTION>
! Return axes indices for diag manager.
! </DESCRIPTION>
!
subroutine mom4_get_diag_axes(axes)

  integer, intent(out) :: axes(:)

  axes(:) = Grid%tracer_axes(:)

end subroutine mom4_get_diag_axes
! </SUBROUTINE> NAME="mom4_get_diag_axes"


!#######################################################################
! <FUNCTION NAME="mom4_get_num_diag_tracers">
!   <OVERVIEW>
!     Returns the module variable num_diag_tracers   
!   </OVERVIEW>
!   <DESCRIPTION>
!     This function returns the number of ocean diagnostic tracers if not -1.
!     It send a FATAL message if num_diag_tracers is not set (i.e. is -1) 
!     before this function call.
!   </DESCRIPTION>
!   <TEMPLATE>
!     use ocean_model_mod
!     mom4_get_num_diag_tracers()
!   </TEMPLATE>
!   <IN NAME=""  TYPE="" >
!     No inputs needed.
!   </IN>
!   <OUT NAME=""  TYPE="integer" >
!     This function returns an integer. 
!   </OUT>

function mom4_get_num_diag_tracers()
  integer :: mom4_get_num_diag_tracers

  if(num_diag_tracers == -1) then
     call mpp_error(FATAL, &
     'mom4_get_num_diag_tracers: num_diag_tracers is -1, should call ocean_diag_tracer_init before this function! ')
  endif

  mom4_get_num_diag_tracers = num_diag_tracers

end function mom4_get_num_diag_tracers
! </FUNCTION> NAME="mom4_get_num_diag_tracers"


!#######################################################################
! <FUNCTION NAME="mom4_get_num_prog_tracers">
!   <OVERVIEW>
!     Returns the module variable num_prog_tracers   
!   </OVERVIEW>
!   <DESCRIPTION>
!     This function returns the number of ocean prognostic tracers if not -1.
!     It send a FATAL message if num_prog_tracers is not set (i.e. is -1) 
!     before this function call.
!   </DESCRIPTION>
!   <TEMPLATE>
!     use ocean_model_mod
!     mom4_get_num_prog_tracers()
!   </TEMPLATE>
!   <IN NAME=""  TYPE="" >
!     No inputs needed.
!   </IN>
!   <OUT NAME=""  TYPE="integer" >
!     This function returns an integer. 
!   </OUT>

function mom4_get_num_prog_tracers()
  integer :: mom4_get_num_prog_tracers

  if(num_prog_tracers == -1) then
     call mpp_error(FATAL, &
     'mom4_get_num_prog_tracers: num_prog_tracers is -1, should call ocean_prog_tracer_init before this function! ')
  endif

  mom4_get_num_prog_tracers = num_prog_tracers

end function mom4_get_num_prog_tracers
! </FUNCTION> NAME="mom4_get_num_prog_tracers"


!#######################################################################
! <SUBROUTINE NAME="mom4_get_surface_tmask">
!   <OVERVIEW>
!     Gets the pointer to 2D array Grid%tmask(:,:,1)   
!   </OVERVIEW>
!   <DESCRIPTION>
!     This subroutine gets the pointer to a 2D array with values of the tmask 
!     (land/sea mask for T cells based on s-coordinate) at the ocean surface .  
!   </DESCRIPTION>
!   <TEMPLATE>
!     use ocean_model_mod
!     real, dimension(:,:), pointer :: temp
!     call mom4_get_surface_tmask(temp)
!   </TEMPLATE>
!   <OUT NAME="surfaceTmask"  TYPE="real, dimension(:,:),pointer" >
!      pointer to 2 dimensional array of tmask at the ocean surface. 
!   </OUT>

subroutine mom4_get_surface_tmask(surfaceTmask)
  real, dimension(:,:),pointer  :: surfaceTmask

  surfaceTmask => Grid%tmask(isc:,jsc:,1)

end subroutine mom4_get_surface_tmask
! </SUBROUTINE> NAME="mom4_get_surface_tmask"


!#######################################################################
! <SUBROUTINE NAME="mom4_get_ocean_data">
!   <OVERVIEW>
!     Gets one of the 2D array data of ocean type   
!   </OVERVIEW>
!   <DESCRIPTION>
!     This subroutine gets one of the following data arrays of ocean_public_type
!     depending on the passed "name" argument, it sends a FATAL signal otherwise
!     Ocean%t_surf when name='t_surf' 
!     Ocean%s_surf when name='s_surf' 
!     Ocean%u_surf when name='u_surf' 
!     Ocean%v_surf when name='v_surf' 
!     Ocean%sea_lev when name='sea_lev' 
!     Ocean%frazil when name='frazil' 
!   </DESCRIPTION>
!   <TEMPLATE>
!     use ocean_model_mod
!     real, dimension(:,:), pointer :: temp
!     call mom4_get_ocean_data(Ocean,'s_surf',temp)
!   </TEMPLATE>
!   <IN NAME="Ocean"  TYPE="type(ocean_public_type)" >
!      ocean type
!   </IN>
!   <IN NAME="name"  TYPE="character(len=*)" >
!      one of 't_surf','s_surf','u_surf','v_surf','sea_lev','frazil'
!   </IN>
!   <OUT NAME="dataArrayPointer"  TYPE="real, dimension(:,:), pointer" >
!      pointer to 2 dimensional array corresponding to "name" argument, at the ocean surface. 
!   </OUT>

subroutine mom4_get_ocean_data(Ocean,name,dataArrayPointer)
  type(ocean_public_type), intent(in)    :: Ocean
  character(len=*), intent(in)  :: name
  real, dimension(:,:),pointer  :: dataArrayPointer
  

  select case(name)
  case('t_surf')
     if(.not.associated(Ocean%t_surf)) &
     call mpp_error(FATAL,'mom4_get_ocean_data: Ocean%t_surf is not associated!')  
     dataArrayPointer => Ocean%t_surf
  case('s_surf')
     if(.not.associated(Ocean%s_surf)) &
     call mpp_error(FATAL,'mom4_get_ocean_data: Ocean%s_surf is not associated!')  
     dataArrayPointer => Ocean%s_surf
  case('u_surf')
     if(.not.associated(Ocean%u_surf)) &
     call mpp_error(FATAL,'mom4_get_ocean_data: Ocean%u_surf is not associated!')  
     dataArrayPointer => Ocean%u_surf
  case('v_surf')
     if(.not.associated(Ocean%v_surf)) &
     call mpp_error(FATAL,'mom4_get_ocean_data: Ocean%v_surf is not associated!')  
     dataArrayPointer => Ocean%v_surf
  case('sea_lev')
     if(.not.associated(Ocean%sea_lev)) &
     call mpp_error(FATAL,'mom4_get_ocean_data: Ocean%sea_lev is not associated!') 
     dataArrayPointer => Ocean%sea_lev
  case('frazil')
     if(.not.associated(Ocean%frazil)) &
     call mpp_error(FATAL,'mom4_get_ocean_data: Ocean%frazil is not associated!')  
     dataArrayPointer => Ocean%frazil
  case default
     call mpp_error(FATAL,'mom4_get_ocean_data: unknown argument name='//name)
  end select
  

end subroutine mom4_get_ocean_data
! </SUBROUTINE> NAME="mom4_get_ocean_data"

subroutine mom4_set_swheat(swheat_input)
  real, dimension(isc:, jsc:,:), intent(in)  :: swheat_input
  
  ext_swheat_is_set=.true.
  swheat = swheat_input

end subroutine mom4_set_swheat

subroutine ocean_public_type_chksum(id, timestep, ocn)

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(ocean_public_type), intent(in) :: ocn
    integer ::   n,m, outunit 
 
    outunit = stdout()

    write(outunit,*) "BEGIN CHECKSUM(ocean_type):: ", id, timestep
    write(outunit,100) 'ocean%t_surf   ',mpp_chksum(ocn%t_surf )
    write(outunit,100) 'ocean%s_surf   ',mpp_chksum(ocn%s_surf )
    write(outunit,100) 'ocean%u_surf   ',mpp_chksum(ocn%u_surf )
    write(outunit,100) 'ocean%v_surf   ',mpp_chksum(ocn%v_surf )
    write(outunit,100) 'ocean%sea_lev  ',mpp_chksum(ocn%sea_lev)
    write(outunit,100) 'ocean%frazil   ',mpp_chksum(ocn%frazil )

    do n = 1, ocn%fields%num_bcs  !{
       do m = 1, ocn%fields%bc(n)%num_fields  !{
          write(outunit,101) 'ocean%',trim(ocn%fields%bc(n)%name), &
               trim(ocn%fields%bc(n)%field(m)%name), &
               mpp_chksum(ocn%fields%bc(n)%field(m)%values)
       enddo  !} m
    enddo  !} n
101 FORMAT("   CHECKSUM::",A6,a,'%',a," = ",Z20)


100 FORMAT("   CHECKSUM::",A20," = ",Z20)
end subroutine ocean_public_type_chksum

subroutine ice_ocn_bnd_type_chksum(id, timestep, iobt)

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(ice_ocean_boundary_type), intent(in) :: iobt
    integer ::   n,m, outunit 
 
    outunit = stdout()

    write(outunit,*) "BEGIN CHECKSUM(ice_ocean_boundary_type):: ", id, timestep
    write(outunit,100) 'iobt%u_flux         ', mpp_chksum( iobt%u_flux         )
    write(outunit,100) 'iobt%v_flux         ', mpp_chksum( iobt%v_flux         )
    write(outunit,100) 'iobt%t_flux         ', mpp_chksum( iobt%t_flux         )
    write(outunit,100) 'iobt%q_flux         ', mpp_chksum( iobt%q_flux         )
    write(outunit,100) 'iobt%salt_flux      ', mpp_chksum( iobt%salt_flux      )
    write(outunit,100) 'iobt%lw_flux        ', mpp_chksum( iobt%lw_flux        )
    write(outunit,100) 'iobt%sw_flux_vis_dir', mpp_chksum( iobt%sw_flux_vis_dir)
    write(outunit,100) 'iobt%sw_flux_vis_dif', mpp_chksum( iobt%sw_flux_vis_dif)
    write(outunit,100) 'iobt%sw_flux_nir_dir', mpp_chksum( iobt%sw_flux_nir_dir)
    write(outunit,100) 'iobt%sw_flux_nir_dif', mpp_chksum( iobt%sw_flux_nir_dif)
    write(outunit,100) 'iobt%lprec          ', mpp_chksum( iobt%lprec          )
    write(outunit,100) 'iobt%fprec          ', mpp_chksum( iobt%fprec          )
    write(outunit,100) 'iobt%runoff         ', mpp_chksum( iobt%runoff         )
    write(outunit,100) 'iobt%calving        ', mpp_chksum( iobt%calving        )
    write(outunit,100) 'iobt%p              ', mpp_chksum( iobt%p              )

100 FORMAT("   CHECKSUM::",A20," = ",Z20)
    do n = 1, iobt%fluxes%num_bcs  !{
       do m = 1, iobt%fluxes%bc(n)%num_fields  !{
          write(outunit,101) 'iobt%',trim(iobt%fluxes%bc(n)%name), &
               trim(iobt%fluxes%bc(n)%field(m)%name), &
               mpp_chksum(iobt%fluxes%bc(n)%field(m)%values)
       enddo  !} m
    enddo  !} n
101 FORMAT("   CHECKSUM::",A6,a,'%',a," = ",Z20)

end subroutine ice_ocn_bnd_type_chksum

end module ocean_model_mod

#ifdef test_mpp_io
program test
#include <fms_platform.h>

  use mpp_mod,         only : mpp_init, mpp_pe, mpp_npes, mpp_root_pe, mpp_error, mpp_sync_self
  use mpp_mod,         only : FATAL, NOTE, mpp_chksum, MPP_DEBUG, mpp_set_stack_size, MPP_CLOCK_SYNC
  use mpp_mod,         only : mpp_sync, mpp_exit, mpp_clock_begin, mpp_clock_end, mpp_clock_id
  use mpp_domains_mod, only : mpp_define_domains, mpp_domains_set_stack_size, domain1D, mpp_get_global_domain
  use mpp_domains_mod, only : domain2D, mpp_define_layout, mpp_get_domain_components, mpp_define_mosaic
  use mpp_domains_mod, only : mpp_get_memory_domain, mpp_get_compute_domain, mpp_domains_exit
  use mpp_domains_mod, only : CENTER, EAST, NORTH, CORNER, mpp_get_data_domain
  use mpp_domains_mod, only : mpp_define_io_domain, mpp_deallocate_domain
  use mpp_io_mod,      only : mpp_io_init, mpp_write_meta, axistype, fieldtype, atttype
  use mpp_io_mod,      only : MPP_RDONLY, mpp_open, MPP_OVERWR, MPP_ASCII, MPP_SINGLE
  use mpp_io_mod,      only : MPP_NETCDF, MPP_MULTI, mpp_get_atts, mpp_write, mpp_close
  use mpp_io_mod,      only : mpp_get_info, mpp_get_axes, mpp_get_fields, mpp_get_times
  use mpp_io_mod,      only : mpp_read, mpp_io_exit

#ifdef INTERNAL_FILE_NML
  USE mpp_mod, ONLY: input_nml_file
#endif

  implicit none

#ifdef use_netCDF
#include <netcdf.inc>
#endif

  !--- namelist definition
  integer           :: nx=128, ny=128, nz=40, nt=2
  integer           :: halo=2, stackmax=1500000, stackmaxd=500000
  logical           :: debug=.FALSE.  
  character(len=64) :: file='test', iospec='-F cachea'
  integer           :: layout(2) = (/0,0/)
  integer           :: ntiles_x=1, ntiles_y=1  ! total number of tiles will be ntiles_x*ntiles_y,
                                               ! the grid size for each tile will be (nx/ntiles_x, ny/ntiles_y) 
                                               ! set ntiles > 1 to test the efficiency of mpp_io.
  integer           :: io_layout(2) = (/0,0/)  ! set io_layout to divide each tile into io_layout(1)*io_layout(2)
                                               ! group and write out data from the root pe of each group.
  integer           :: pack_size = 1

  namelist / test_mpp_io_nml / nx, ny, nz, nt, halo, stackmax, stackmaxd, debug, file, iospec, &
                               ntiles_x, ntiles_y, layout, io_layout

  integer        :: pe, npes, io_status
  type(domain2D) :: domain

  integer            :: tks_per_sec
  integer            :: i,j,k, unit=7
  integer            :: id_single_tile_mult_file
  integer            :: id_mult_tile, id_single_tile_with_group, id_mult_tile_with_group
  logical            :: opened
  character(len=64)  :: varname

  real               :: time
  type(axistype)     :: x, y, z, t
  type(fieldtype)    :: f
  type(domain1D)     :: xdom, ydom
  integer(LONG_KIND) :: rchk, chk
  real(DOUBLE_KIND)                  :: doubledata = 0.0
  real                               :: realarray(4)

  call mpp_init() 
  pe = mpp_pe()
  npes = mpp_npes()

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, test_mpp_io_nml, iostat=io_status)
#else
  do
     inquire( unit=unit, opened=opened )
     if( .NOT.opened )exit
     unit = unit + 1
     if( unit.EQ.100 )call mpp_error( FATAL, 'Unable to locate unit number.' )
  end do
  open( unit=unit, file='input.nml', iostat=io_status)
  read( unit,test_mpp_io_nml, iostat=io_status )
  close(unit)
#endif

      if (io_status > 0) then
         call mpp_error(FATAL,'=>test_mpp_io: Error reading input.nml')
      endif


  call SYSTEM_CLOCK( count_rate=tks_per_sec )
  if( debug )then
      call mpp_io_init(MPP_DEBUG)
  else
      call mpp_io_init()
  end if
  call mpp_set_stack_size(stackmax)
  call mpp_domains_set_stack_size(stackmaxd)

  if( pe.EQ.mpp_root_pe() )then
      print '(a,6i6)', 'npes, nx, ny, nz, nt, halo=', npes, nx, ny, nz, nt, halo
      print *, 'Using NEW domaintypes and calls...'
  end if

  write( file,'(a,i3.3)' )trim(file), npes

! determine the pack_size
  pack_size = size(transfer(doubledata, realarray))
  if( pack_size .NE. 1 .AND. pack_size .NE. 2) call mpp_error(FATAL,'test_mpp_io: pack_size should be 1 or 2')  

  if(ntiles_x == 1 .and. ntiles_y == 1 .and. io_layout(1) == 1 .and. io_layout(2) == 1) then
     call test_netcdf_io('Simple')
     call test_netcdf_io('Symmetry_T_cell')
     call test_netcdf_io('Symmetry_E_cell')
     call test_netcdf_io('Symmetry_N_cell')
     call test_netcdf_io('Symmetry_C_cell')
     call test_netcdf_io('Symmetry_T_cell_memory')
     call test_netcdf_io('Symmetry_E_cell_memory')
     call test_netcdf_io('Symmetry_N_cell_memory')
     call test_netcdf_io('Symmetry_C_cell_memory')
  else
     if(io_layout(1) <1 .OR. io_layout(2) <1) call mpp_error(FATAL, &
            "program test_mpp_io: both elements of test_mpp_io_nml variable io_layout must be positive integer")
     if(ntiles_x <1 .OR. ntiles_y <1) call mpp_error(FATAL, &
            "program test_mpp_io: mpp_io_nml variable ntiles_x and ntiles_y must be positive integer")
     if(mod(nx, ntiles_x) .NE. 0) call mpp_error(FATAL, &
            "program test_mpp_io: nx must be divided by ntiles_x")
     if(mod(ny, ntiles_y) .NE. 0) call mpp_error(FATAL, &
            "program test_mpp_io: ny must be divided by ntiles_y")
     if(mod(npes, ntiles_x*ntiles_y) .NE. 0) call mpp_error(FATAL, &
            "program test_mpp_io: npes should be divided by ntiles = ntiles_x*ntiles_y ")
     if(layout(1) * layout(2) .NE. npes) call mpp_error(FATAL, &
            "program test_mpp_io: npes should equal to layout(1)*layout(2)" )
     if(mod(layout(1), io_layout(1)) .NE. 0 ) call mpp_error(FATAL, &
            "program test_mpp_io: layout(1) must be divided by io_layout(1)")
     if(mod(layout(2), io_layout(2)) .NE. 0 )call mpp_error(FATAL, &
            "program test_mpp_io: layout(2) must be divided by io_layout(2)")

     id_single_tile_mult_file = mpp_clock_id('Single Tile Multiple File', flags=MPP_CLOCK_SYNC)
     call mpp_clock_begin(id_single_tile_mult_file)
     call test_netcdf_io_mosaic('Single_tile_mult_file', layout, 1, 1, (/1,1/) )
     call mpp_clock_end(id_single_tile_mult_file)

     if(io_layout(1) >1 .OR. io_layout(2) > 1) then
        id_single_tile_with_group = mpp_clock_id('Single Tile With Group', flags=MPP_CLOCK_SYNC)
        call mpp_clock_begin(id_single_tile_with_group)
        call test_netcdf_io_mosaic('Single_tile_with_group', layout, 1, 1, io_layout)
        call mpp_clock_end(id_single_tile_with_group)
     endif

     id_mult_tile  = mpp_clock_id('Multiple Tile', flags=MPP_CLOCK_SYNC)
     call mpp_clock_begin(id_mult_tile)
     if(ntiles_x > 1 .OR. ntiles_y > 1) then
        call test_netcdf_io_mosaic('Mult_tile', layout, ntiles_x, ntiles_y, (/1,1/))
     else
        call test_netcdf_io_mosaic('Mult_tile', layout, io_layout(1), io_layout(2), (/1,1/) )
     endif
     call mpp_clock_end(id_mult_tile)

     if( (io_layout(1) >1 .OR. io_layout(2) > 1) .AND. (ntiles_x >1 .OR. ntiles_y > 1) ) then
        id_mult_tile_with_group = mpp_clock_id('Multiple Tile With Group', flags=MPP_CLOCK_SYNC)
        call mpp_clock_begin(id_mult_tile_with_group)
        call test_netcdf_io_mosaic('Mult_tile_with_group', layout, ntiles_x, ntiles_y, io_layout)
        call mpp_clock_end(id_mult_tile_with_group)
     endif
  endif

  call mpp_io_exit()
  call mpp_domains_exit()
  call mpp_exit()

  contains

  !------------------------------------------------------------------

  subroutine test_netcdf_io(type)
  character(len=*), intent(in) :: type
  integer :: ndim, nvar, natt, ntime
  integer :: is, ie, js, je, isd, ied, jsd, jed, ism, iem, jsm, jem
  integer :: position, msize(2), ioff, joff, nxg, nyg
  logical :: symmetry
  type(atttype),          allocatable :: atts(:)
  type(fieldtype),        allocatable :: vars(:)
  type(axistype),         allocatable :: axes(:)
  real,                   allocatable :: tstamp(:)
  real, dimension(:,:,:), allocatable :: data, gdata, rdata

  !--- determine the shift and symmetry according to type, 
  select case(type)
  case('Simple')
     position = CENTER; symmetry = .false.
  case('Symmetry_T_cell', 'Symmetry_T_cell_memory')
     position = CENTER; symmetry = .true.
  case('Symmetry_E_cell', 'Symmetry_E_cell_memory')
     position = EAST;   symmetry = .true.
  case('Symmetry_N_cell', 'Symmetry_N_cell_memory')
     position = NORTH;  symmetry = .true.
  case('Symmetry_C_cell', 'Symmetry_C_cell_memory')
     position = CORNER; symmetry = .true.
  case default
     call mpp_error(FATAL, "type = "//type//" is not a valid test type")
  end select

!define domain decomposition
  call mpp_define_layout( (/1,nx,1,ny/), npes, layout )
  if(index(type,"memory") == 0) then  
     call mpp_define_domains( (/1,nx,1,ny/), layout, domain, xhalo=halo, yhalo=halo, symmetry = symmetry )
  else  ! on memory domain
     msize(1) = nx/layout(1) + 2*halo + 2
     msize(2) = ny/layout(2) + 2*halo + 2
     call mpp_define_domains( (/1,nx,1,ny/), layout, domain, xhalo=halo, yhalo=halo, symmetry = symmetry, &
                              memory_size = msize )
  end if

  call mpp_get_compute_domain( domain, is,  ie,  js,  je, position=position  )
  call mpp_get_data_domain   ( domain, isd, ied, jsd, jed, position=position )
  call mpp_get_memory_domain ( domain, ism, iem, jsm, jem, position=position )
  call mpp_get_global_domain ( domain, xsize=nxg, ysize=nyg, position=position )
  call mpp_get_domain_components( domain, xdom, ydom )

!define global data array
  allocate( gdata(nxg,nyg,nz) )
  gdata = 0.
  do k = 1,nz
     do j = 1,nyg
        do i = 1,nxg
           gdata(i,j,k) = k + i*1e-3 + j*1e-6
        end do
     end do
  end do

  ioff = ism - isd; joff = jsm - jsd
  allocate( data(ism:iem,jsm:jem,nz) )
  data = 0
  data(is+ioff:ie+ioff,js+joff:je+joff,:) = gdata(is:ie,js:je,:)

!tests

!sequential write: single-threaded formatted: only if small
  if( nx*ny*nz*nt.LT.1000 .AND. index(type,"memory") .NE. 0 )then
      if( pe.EQ.mpp_root_pe() )print *, 'sequential write: single-threaded formatted'
!here the only test is a successful write: please look at test.txt for verification.
      call mpp_open( unit, trim(file)//'s.txt', action=MPP_OVERWR, form=MPP_ASCII, threading=MPP_SINGLE )
      call mpp_write_meta( unit, x, 'X', 'km', 'X distance', domain=xdom, data=(/(i-1.,i=1,nxg)/) )
      call mpp_write_meta( unit, y, 'Y', 'km', 'Y distance', domain=ydom, data=(/(i-1.,i=1,nyg)/) )
      call mpp_write_meta( unit, z, 'Z', 'km', 'Z distance',              data=(/(i-1.,i=1,nz)/) )
      call mpp_write_meta( unit, t, 'T', 'sec', 'Time' )
      call mpp_write_meta( unit, f, (/x,y,z,t/), 'Data', 'metres', 'Random data' )
      call mpp_write( unit, x )
      call mpp_write( unit, y )
      call mpp_write( unit, z )
      do i = 0,nt-1
         time = i*10.
         call mpp_write( unit, f, domain, data, time )
      end do
      call mpp_close(unit)
  end if

!netCDF distributed write
  if( pe.EQ.mpp_root_pe() )print *, 'netCDF distributed write'
  call mpp_open( unit, trim(type)//"_"//trim(file)//'d', action=MPP_OVERWR, &
                 form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_MULTI )
  call mpp_write_meta( unit, x, 'X', 'km', 'X distance', 'X', domain=xdom, data=(/(i-1.,i=1,nxg)/) )
  call mpp_write_meta( unit, y, 'Y', 'km', 'Y distance', 'Y', domain=ydom, data=(/(i-1.,i=1,nyg)/) )
  call mpp_write_meta( unit, z, 'Z', 'km', 'Z distance', 'Z', data=(/(i-1.,i=1,nz)/) )
  call mpp_write_meta( unit, t, 'T', 'sec', 'Time', 'T' )
  call mpp_write_meta( unit, f, (/x,y,z,t/), 'Data', 'metres', 'Random data', pack=pack_size )
  call mpp_write( unit, x )
  call mpp_write( unit, y )
  call mpp_write( unit, z )
  do i = 0,nt-1
     time = i*10.
     call mpp_write( unit, f, domain, data, time )
  end do
  call mpp_close(unit)
  
!netCDF single-threaded write
  if( pe.EQ.mpp_root_pe() )print *, 'netCDF single-threaded write'
  call mpp_open( unit, trim(type)//"_"//trim(file)//'s', action=MPP_OVERWR, form=MPP_NETCDF, threading=MPP_SINGLE )

  call mpp_write_meta( unit, x, 'X', 'km', 'X distance', 'X', domain=xdom, data=(/(i-1.,i=1,nxg)/) )

  call mpp_write_meta( unit, y, 'Y', 'km', 'Y distance', 'Y', domain=ydom, data=(/(i-1.,i=1,nyg)/) )
  call mpp_write_meta( unit, z, 'Z', 'km', 'Z distance', 'Z',              data=(/(i-1.,i=1,nz)/) )
  call mpp_write_meta( unit, t, 'T', 'sec', 'Time', 'T' )
  call mpp_write_meta( unit, f, (/x,y,z,t/), 'Data', 'metres', 'Random data', pack=pack_size )

  call mpp_write( unit, x )
  call mpp_write( unit, y )
  call mpp_write( unit, z )

  do i = 0,nt-1
     time = i*10.
     call mpp_write( unit, f, domain, data, time)
  end do
  call mpp_close(unit)
  allocate( rdata(is:ie,js:je,nz) )

!netCDF multi-threaded read
  if( pe.EQ.mpp_root_pe() )print *, 'netCDF multi-threaded read'
  call mpp_sync()
  call mpp_open( unit, trim(type)//"_"//trim(file)//'s', action=MPP_RDONLY,  &
                 form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE )
  call mpp_get_info( unit, ndim, nvar, natt, ntime )
  allocate( atts(natt) )
  allocate( axes(ndim) )
  allocate( vars(nvar) )
  allocate( tstamp(ntime) )
  call mpp_get_atts ( unit, atts(:) )
  call mpp_get_axes ( unit, axes(:) )
  call mpp_get_fields ( unit, vars(:) )
  call mpp_get_times( unit, tstamp(:) )

  call mpp_get_atts(vars(1),name=varname)

  if( varname.NE.'Data' )call mpp_error( FATAL, 'File being read is not the expected one.' )
  call mpp_read( unit, vars(1), domain, rdata, 1 )
  rchk = mpp_chksum(rdata(is:ie,js:je,:))
  chk  = mpp_chksum( data(is+ioff:ie+ioff,js+joff:je+joff,:))
  if( pe.EQ.mpp_root_pe() )print '(a,2z18)', trim(type)//' checksum=', rchk, chk
  if( rchk == chk ) then
      if( pe.EQ.mpp_root_pe() )call mpp_error( NOTE, trim(type)//': single-fileset: data comparison are OK.' )
  else
      call mpp_error( FATAL, 'Checksum error on multi-threaded/single-fileset netCDF read for type ' &
               //trim(type) )
  end if

  deallocate( atts, axes, vars, tstamp )

!netCDF distributed read
  if( pe.EQ.mpp_root_pe() )print *, 'netCDF multi-threaded read'
  call mpp_sync()               !wait for previous write to complete
  call mpp_open( unit, trim(type)//"_"//trim(file)//'d', action=MPP_RDONLY,  &
                 form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_MULTI )
  call mpp_get_info( unit, ndim, nvar, natt, ntime )
  allocate( atts(natt) )
  allocate( axes(ndim) )
  allocate( vars(nvar) )
  allocate( tstamp(ntime) )
  call mpp_get_atts ( unit, atts(:) )
  call mpp_get_axes ( unit, axes(:) )
  call mpp_get_fields ( unit, vars(:) )
  call mpp_get_times( unit, tstamp(:) )

  call mpp_get_atts(vars(1),name=varname)
  rdata = 0

  if( varname.NE.'Data' )call mpp_error( FATAL, 'File being read is not the expected one.' )

  call mpp_read( unit, vars(1), domain, rdata, 1 )

  rchk = mpp_chksum(rdata(is:ie,js:je,:))
  chk  = mpp_chksum( data(is+ioff:ie+ioff,js+joff:je+joff,:))
  if( pe.EQ.mpp_root_pe() )print '(a,2z18)', trim(type)//' checksum=', rchk, chk
  if( rchk == chk ) then
      if( pe.EQ.mpp_root_pe() )call mpp_error( NOTE, trim(type)//': multi-fileset: data comparison are OK.' )
  else
      call mpp_error( FATAL, 'Checksum error on multi-threaded/multi-fileset netCDF read for type ' &
           //trim(type) )
  end if

  deallocate( atts, axes, vars, tstamp )

  deallocate( rdata, gdata, data)

  end subroutine test_netcdf_io


  subroutine test_netcdf_io_mosaic(type, layout, ntiles_x, ntiles_y, io_layout)
  character(len=*), intent(in) :: type
  integer,          intent(in) :: layout(:)
  integer,          intent(in) :: io_layout(:)
  integer,          intent(in) :: ntiles_x, ntiles_y

  integer                              :: ndim, nvar, natt, ntime
  integer                              :: isc, iec, jsc, jec, nlon, nlat, n, i, j
  integer                              :: my_tile, ncontacts, npes_per_tile, ntiles
  integer, dimension(:),   allocatable :: tile1, istart1, iend1, jstart1, jend1
  integer, dimension(:),   allocatable :: tile2, istart2, iend2, jstart2, jend2
  integer, dimension(:),   allocatable :: pe_start, pe_end
  integer, dimension(:,:), allocatable :: layout2D, global_indices
  character(len=64)                    :: output_file
  logical                              :: is_root_pe
  real, dimension(:,:,:), allocatable  :: data, rdata
  type(fieldtype), save                :: vars(1)
  integer                              :: id_clock_read, id_clock_write

  ! first get number of tiles of this mosaic. when there is one tile,
  ! the file will be read/write using distributed file.
  ! when there is more than one tile, single fileset will be used
  npes = mpp_npes()
  
  id_clock_read  = mpp_clock_id(trim(type)//" read", flags=MPP_CLOCK_SYNC)
  id_clock_write = mpp_clock_id(trim(type)//" write", flags=MPP_CLOCK_SYNC)

  ncontacts = 0
  ntiles = ntiles_x*ntiles_y

  npes_per_tile = npes/ntiles
  my_tile       = mpp_pe()/npes_per_tile + 1
  is_root_pe = .false.
  if(mpp_pe() == (my_tile-1)*npes_per_tile ) is_root_pe = .true.

  allocate(layout2D(2,ntiles), global_indices(4,ntiles), pe_start(ntiles), pe_end(ntiles) )
  !--- for simplify purpose, we assume all the tiles have the same size.
  do n = 1, ntiles
     pe_start(n) = (n-1)*npes_per_tile
     pe_end(n)   = n*npes_per_tile-1
  end do
  if(ntiles>1) then
     nlon = nx/ntiles_x
     nlat = ny/ntiles_y
  else
     nlon = nx
     nlat = ny
  endif
  
  do n = 1, ntiles
     global_indices(:,n) = (/1,nlon,1,nlat/)
     layout2D(1,n)         = layout(1)/ntiles_x
     layout2D(2,n)         = layout(2)/ntiles_y
  end do

  call mpp_define_mosaic(global_indices, layout2D, domain, ntiles, ncontacts, tile1, tile2, &
                         istart1, iend1, jstart1, jend1, istart2, iend2, jstart2, jend2, pe_start, pe_end, &
                         name = type)
  call mpp_get_compute_domain( domain, isc,  iec,  jsc,  jec  )
  call mpp_get_domain_components(domain, xdom, ydom)
  allocate( data (isc:iec,jsc:jec,nz) )
  allocate( rdata(isc:iec,jsc:jec,nz) )
  do k = 1,nz
     do j = jsc, jec
        do i = isc, iec
           data(i,j,k)  = k + i*1e-3 + j*1e-6
        enddo
     enddo
  enddo

  !--- netcdf distribute write if ntiles = 1, otherwise single-thread write
  output_file = type
  select case(type)
  case("Single_tile_single_file")
     call mpp_open( unit, output_file, action=MPP_OVERWR, form=MPP_NETCDF, threading=MPP_SINGLE, fileset=MPP_SINGLE )
  case("Single_tile_mult_file")
     call mpp_open( unit, output_file, action=MPP_OVERWR, form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_MULTI )
  case("Mult_tile")
     write(output_file, '(a,I4.4)') type//'.tile', my_tile
     call mpp_open( unit, output_file, action=MPP_OVERWR, form=MPP_NETCDF, threading=MPP_SINGLE, is_root_pe=is_root_pe )
  case("Single_tile_with_group")
     call mpp_define_io_domain(domain, io_layout)
     call mpp_open( unit, output_file, action=MPP_OVERWR, form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_MULTI, domain=domain)
  case("Mult_tile_with_group")
     write(output_file, '(a,I4.4)') type//'.tile', my_tile
     call mpp_define_io_domain(domain, io_layout)
     call mpp_open( unit, output_file, action=MPP_OVERWR, form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_MULTI, domain=domain)

  case default
     call mpp_error(FATAL, "program test_mpp_io: invaid value of type="//type)
  end select  

  call mpp_write_meta( unit, x, 'X', 'km', 'X distance', 'X', domain=xdom, data=(/(i-1.,i=1,nlon)/) )
  call mpp_write_meta( unit, y, 'Y', 'km', 'Y distance', 'Y', domain=ydom, data=(/(i-1.,i=1,nlat)/) )
  call mpp_write_meta( unit, z, 'Z', 'km', 'Z distance', 'Z', data=(/(i-1.,i=1,nz)/) )
  call mpp_write_meta( unit, t, 'T', 'sec', 'Time', 'T' )
  call mpp_write_meta( unit, f, (/x,y,z,t/), 'Data', 'metres', 'Random data', pack=pack_size )
  call mpp_write( unit, x )
  call mpp_write( unit, y )
  call mpp_write( unit, z )
  call mpp_clock_begin(id_clock_write)
  do i = 0,nt-1
     time = i*10.
     call mpp_write( unit, f, domain, data, time )
  end do
  call mpp_clock_end(id_clock_write)
  call mpp_close(unit)
  
  call mpp_sync()               !wait for previous write to complete

  select case(type)
  case("Single_tile_single_file")
     call mpp_open( unit, output_file, action=MPP_RDONLY, form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE )
  case("Single_tile_mult_file")
     call mpp_open( unit, output_file, action=MPP_RDONLY, form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_MULTI )
  case("Mult_tile")
     call mpp_open( unit, output_file, action=MPP_RDONLY, form=MPP_NETCDF, threading=MPP_MULTI, &
         fileset=MPP_SINGLE, is_root_pe=is_root_pe )
  case("Single_tile_with_group", "Mult_tile_with_group")
     call mpp_open( unit, output_file, action=MPP_RDONLY, form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_MULTI, domain=domain)
  case default
     call mpp_error(FATAL, "program test_mpp_io: invaid value of type="//type)
  end select  

  call mpp_get_info( unit, ndim, nvar, natt, ntime )
  call mpp_get_fields ( unit, vars(:) )
  call mpp_get_atts(vars(1),name=varname)

  if( varname.NE.'Data' )call mpp_error( FATAL, 'File being read is not the expected one.' )
  call mpp_clock_begin(id_clock_read)
  do i = 0,nt-1
     call mpp_read( unit, vars(1), domain, rdata, 1 )
  enddo
  call mpp_clock_end(id_clock_read)
  rchk = mpp_chksum(rdata)
  chk  = mpp_chksum( data)
  if( pe.EQ.mpp_root_pe() )print '(a,2z18)', trim(type)//' checksum=', rchk, chk
  if( rchk == chk ) then
      if( pe.EQ.mpp_root_pe() )call mpp_error( NOTE, trim(type)//': data comparison are OK.' )
  else
      call mpp_error( FATAL, 'Checksum error on netCDF read for type ' &
               //trim(type) )
  end if

!  deallocate( vars)

  deallocate( rdata, data)
  call mpp_deallocate_domain(domain)

  end subroutine test_netcdf_io_mosaic

end program test

#else
module null_mpp_io_test
end module
#endif

!-----------------------------------------------------------------------
! Copyright 2011 NOAA Geophysical Fluid Dynamics Lab, Princeton, NJ
! This program is distributed under the terms of the GNU General Public
! License. See the file COPYING contained in this directory
!
!  This program aggregates vertical data by pressure levels
!
!-----------------------------------------------------------------------
 
program run_pressure_interp

use netcdf

use    plev_constants_mod, only: GRAV, RDGAS, RVGAS

use pinterp_utilities_mod, only: copy_axis, copy_variable,  &
                                 set_verbose_level,         &
                                 define_new_variable,       &
                                 error_handler
use pressure_interp_mod


implicit none

!-----------------------------------------------------------------------

integer, parameter :: MAX_PLEVS = 200
integer, parameter :: MAX_FIELD_NAMES = 300
integer, parameter :: MAX_AXIS_NAMES  =  50
integer, parameter :: header_buffer_val = 16384
integer            ::  blksz = 65536  ! blksz must be writable for nf__create

 character(len=256)           ::  in_file_name, out_file_name
!character(len=NF90_MAX_NAME) ::  in_file_name, out_file_name
  real, dimension(MAX_PLEVS) :: pout
character(len=NF90_MAX_NAME) ::    ps_name = 'ps',     &
                                zsurf_name = 'zsurf',  &
                                 temp_name = 'temp',   &
                                sphum_name = 'sphum',  &
                                   bk_name = 'bk',     &
                                   pk_name = 'pk',     &
                                  res_name = 'res',    &
                                 hght_name = 'hght',   &
                                  slp_name = 'slp'

 character(len=NF90_MAX_NAME) :: pres_name_out = 'level'
!character(len=NF90_MAX_NAME) :: time_name_out = 'time'   ! not used

 character(len=NF90_MAX_NAME), dimension(MAX_FIELD_NAMES) :: field_names

type field_type
   character(len=NF90_MAX_NAME) :: name
   integer                      :: varid_in, varid_out, ndim, xtype
   integer                      :: dimids(NF90_MAX_VAR_DIMS), &
                                   dimlen(NF90_MAX_VAR_DIMS)
   integer                      :: y_axis, z_axis
   real                         :: pack(2), missval_in, unpkd_missval_in, missval_out, unpkd_missval_out
   logical                      :: static, skip, do_avg, do_pack, do_miss_in, do_miss_out
end type

type axis_type
   character(len=NF90_MAX_NAME) :: name_in, name_out
   integer                      :: varid_in, varid_out
   integer                      :: dimlen, start(1)
end type

type(field_type) :: Fields(MAX_FIELD_NAMES)
type(axis_type)  :: Axes(MAX_AXIS_NAMES)

logical :: mask_extrap = .false.
logical :: unpack = .false.  ! not implemented
integer :: verbose     = 1

logical :: do_all_3d_fields = .false.
logical :: do_all_fields = .false.
logical :: use_default_missing_value = .false.

logical :: allow_zero_topog = .false.
logical :: allow_zero_sphum = .false.

integer :: time_beg=1, time_end=0, time_inc=1

!#######################################################################
!         -------- NAMELIST -------
!
!  in_file_name = input file name/path
!               must contain atmospheric dynamics fields (required)
!
!  out_file_name = output file name/path
!
!  field_names = additional fields (up to 40) for output
!                (dynamics files are searched for these names)
!
!         pout = output pressure levels (max 200), in pascals
!
!--- specify these names for the following output fields ---
!         sphum_name = specific humidity
!--------------------------------------------------------
!
!  mask_extrap = set points below the bottom level to the missing value
!
!  use_default_missing_value = use the NetCDF default for missing/fill value
!                              for all fields
!
!   verbose   = integer verbose flag
!
!-----------------------------------------------------------------------
!
!  *** NOTES ***
!
!    1)  currently only ONE input atmospheric file and ONE output file
!        are allowed
!
!    2)  the namelist file must be passed to the program by
!        redirection: e.g., a.out < namelist
!
!#######################################################################

namelist /names/ temp_name, sphum_name, hght_name, slp_name, &
                 ps_name, zsurf_name, bk_name, pk_name 

namelist /input/ in_file_name, out_file_name,  field_names,  pout, &
                 do_all_fields,  do_all_3d_fields,                 &
                 mask_extrap,                          &
                 time_beg, time_end, time_inc,                     &
                 allow_zero_topog, allow_zero_sphum,               &
                 use_default_missing_value, verbose

!----- axis names -----

!character(len=NF90_MAX_NAME) :: xmass_in = 'lon',  &
!                                ymass_in = 'lat',  &
!character(len=NF90_MAX_NAME) :: pfull_in = 'pfull', &
!                                phalf_in = 'phalf', &
!                                time_in  = 'time'


character(len=NF90_MAX_NAME) :: xmass_in, ymass_in
character(len=NF90_MAX_NAME) :: pfull_in, time_in

character(len=NF90_MAX_NAME) :: xmass_out, ymass_out
character(len=NF90_MAX_NAME) :: edge_name
character(len=NF90_MAX_NAME) :: attname
character(len=NF90_MAX_NAME) :: file_title

integer :: dimids_mass(4)
!-----------------------------------------------------------------------

integer :: ncid_in, ncid_out
type (pres_interp_type) :: Interp(2)


character(len=NF90_MAX_NAME) :: version
character(len=NF90_MAX_NAME) :: time_avg_info
character(len=NF90_MAX_NAME) :: cell_methods
character(len=NF90_MAX_NAME) :: name_time_bounds, name_time_average

logical    :: do_time_average, do_time_bounds
character(len=NF90_MAX_NAME) :: avg_name = 'average'
character(len=8) :: avg_subnames(3) = (/ '_T1', '_T2', '_DT' /)

logical    :: temp_present, sphum_present
logical    :: exists

logical :: do_temp  = .false.
logical :: do_sphum = .false.
logical :: do_zsurf = .false.
logical :: do_hght  = .false.
logical :: do_slp   = .false.

logical :: need_zsurf, need_temp, need_sphum

integer :: varid_res,      varid_pout
integer :: varid_bk,       varid_pk,     &
           varid_temp_in,  varid_sphum_in, &
           varid_zsurf_in, varid_ps_in

integer :: varid_hght_out, varid_slp_out

integer :: varid_time_in,        varid_time_out
integer :: varid_time_bounds_in, varid_time_bounds_out
integer :: varid_tavg_in(3),     varid_tavg_out(3)

integer :: index_ps, index_zsurf, index_temp, index_sphum

integer :: istat, ivar, itime, otime, i, n, kv, attnum, numatts, recdim,  &
           nlon, nlat, nlev, ndim, dimids(NF90_MAX_VAR_DIMS), dimid, naxes, dimid_tbnds
integer :: nlev_out, start(4), kount(4), ntimes, num_field_names
integer :: itime_beg, itime_end, itime_inc
integer :: isg, ieg, jsg, jeg, is, ie, js, je
real    :: mval_hght, mval_slp
real(8) :: time, time_bnds(2)
logical :: done, do_phalf
integer :: idim, nlen
integer :: unit, ierr, io, in_format, cmode
real, allocatable :: axisdata(:)

real, allocatable, dimension(:)     :: bk, pk
real, allocatable, dimension(:,:)   :: res
real, allocatable, dimension(:,:,:) :: zsurf, ps

real, parameter :: tlapse = 6.5e-3
real, parameter :: tref   = 288.
real, parameter :: ginv = 1./GRAV
real, parameter :: gorg = GRAV / (RDGAS*tlapse)
real, parameter :: mrgog = -1./gorg
real, parameter :: d608 = (RVGAS-RDGAS)/RDGAS
real, parameter :: pref = 101325.
real, parameter :: rgog = RDGAS*tlapse/GRAV

!#######################################################################

!--------- initialize namelist variable and then read namelist ---------

      do i=1,len(out_file_name);  out_file_name(i:i) = ' '; enddo
      do i=1,len( in_file_name);   in_file_name(i:i) = ' '; enddo
      pout = 0.0

      do ivar = 1, MAX_FIELD_NAMES
         do i=1,NF90_MAX_NAME; field_names(ivar)(i:i) = ' '; enddo
      enddo

      inquire (file='plev.input.nml',exist=exists)
      if (exists) then
         open (10, file='plev.input.nml')
         read (10, nml=input, end=1, err=1)
      1  close (10)
         !write (*,input)
      endif

         do i = 1, MAX_PLEVS
            if (pout(i) < 1.e-6) exit
            nlev_out = i
         enddo
 
!     ---- count the number of field names ----
         num_field_names = 0
      do ivar = 1, MAX_FIELD_NAMES
         if (field_names(ivar)(1:1) == ' ') exit
         num_field_names = ivar
      enddo

      call set_verbose_level (verbose)

  ! create version string (may replace with CVS $Id: run_pressure_interp.F90,v 20.0 2013/12/14 00:29:42 fms Exp $)
    version = 'pressure level interpolator, version 3.0'
    if (precision(ps) == precision(time)) then
        version = trim(version)//', precision=double'
    else
        version = trim(version)//', precision=float'
    endif

!-----------------------------------------------------------------------
!----------------------- loop through files ----------------------------
!-----------------------------------------------------------------------
!   --- if any file name has no length then terminate the program ---
      
     if (  in_file_name(1:1) == ' ' .or.   &
          out_file_name(1:1) == ' ' )  call error_handler  &
           ('must specifiy atmospheric and output file names')

!-----------------------------------------------------------------------
!-----------------  get input file information -------------------------

    !--- opening input files ---
     istat = NF90_OPEN (trim(in_file_name), NF90_NOWRITE, ncid_in, blksz)
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)

    !--- get the time axis identifier ---
     istat = NF90_INQUIRE ( ncid_in, nattributes=numatts, unlimiteddimid=recdim,formatnum=in_format )
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)

!    --------- set flags for special computed fields --------

     if (verbose > 1) print *, 'num_field_names=',num_field_names
     do i = 1, num_field_names
        if (verbose > 1) print *, 'field_name=',trim(field_names(i))
        if (field_names(i) ==  hght_name) then
            do_hght  = .true.; cycle; endif
        if (field_names(i) ==   slp_name) then
            do_slp   = .true.; cycle; endif
     enddo

!    ------- check to see if required fields are in atmos file -------

     call check_fields ( ncid_in )

!-----------------------------------------------------------------------
!--- get the size of the vertical axis ---
     istat = NF90_INQUIRE_VARIABLE (ncid_in, varid_bk, ndims=ndim, dimids=dimids)
     if (istat /= NF90_NOERR) call error_handler ('getting dimids for '//trim(bk_name), ncode=istat)
     istat = NF90_INQUIRE_DIMENSION (ncid_in, dimids(1), len=nlev)
     if (istat /= NF90_NOERR) call error_handler ('getting dim length for '//trim(bk_name), ncode=istat)
     nlev = nlev-1

    !--- get the names of the input horizontal mass axes ---
     istat = NF90_INQUIRE_VARIABLE (ncid_in, varid_ps_in, ndims=ndim, dimids=dimids)
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)

     if (ndim /= 3) call error_handler ('variable '//trim(ps_name)//&
                                    &' must have three dimensions: x,y,t')

    !--- size and name of input horizontal mass axes ---
     istat = NF90_INQUIRE_DIMENSION (ncid_in, dimids(1), name=xmass_in, len=nlon)
     if (istat /= NF90_NOERR) call error_handler ('getting name and length of first mass dimension', ncode=istat)
     istat = NF90_INQUIRE_DIMENSION (ncid_in, dimids(2), name=ymass_in, len=nlat)
     if (istat /= NF90_NOERR) call error_handler ('getting name and length of second mass dimension', ncode=istat)
     istat = NF90_INQUIRE_DIMENSION (ncid_in, dimids(3), name=time_in)
     if (istat /= NF90_NOERR) call error_handler ('getting name of last mass dimension (time)', ncode=istat)

!-----------------------------------------------------------------------
!--- set output fields using all input fields ---

     if (do_all_fields .or. do_all_3d_fields) then
         call set_all_field_names ( ncid_in, field_names, num_field_names )
     endif

!--- error: if there were no requested fields ---
     if (num_field_names == 0) call error_handler &
                               ('no field names have been selected')

!--- set flags for special non-computed fields ---

     if (verbose > 1) print *, 'num_field_names=',num_field_names
     do i = 1, num_field_names
        if (verbose > 1) print *, 'field_name=',trim(field_names(i))
        if (field_names(i) == sphum_name) then
            if (sphum_present) do_sphum = .true.; cycle; endif
        if (field_names(i) ==  temp_name) then
            if (temp_present)  do_temp  = .true.; cycle; endif
        if (field_names(i) == zsurf_name) then
            do_zsurf = .true.; cycle; endif
     enddo

!-----------------------------------------------------------------------

     isg = 1;   ieg = nlon; jsg = 1;   jeg = nlat
     is  = isg; ie  = ieg;  js  = jsg; je  = jeg

!    ---- allocate space ----

     allocate (bk(nlev+1), pk(nlev+1))
     allocate (res  (is:ie,js:je),    &
               zsurf(is:ie,js:je,1),  &
               ps   (is:ie,js:je,1)   )

!    ---- read vert coord variables and set up vert coord ----

     istat = NF90_GET_VAR (ncid_in, varid_bk, bk)
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)
     if (varid_pk > 0) then
        istat = NF90_GET_VAR (ncid_in, varid_pk, pk)
        if (istat /= NF90_NOERR) call error_handler (ncode=istat)
     else
        pk = 0.0
     endif

!-----------------------------------------------------------------------
!----------------- output file header info -----------------------------
     if (in_format==NF90_FORMAT_NETCDF4) then
        cmode = NF90_NETCDF4
     elseif (in_format==NF90_FORMAT_NETCDF4_CLASSIC) then
        cmode=IOR(NF90_NETCDF4,NF90_CLASSIC_MODEL)
     elseif (in_format==NF90_FORMAT_64BIT) then
        cmode=IOR(NF90_CLOBBER,NF90_64BIT_OFFSET)
     elseif (in_format==NF90_FORMAT_CLASSIC) then
        cmode=IOR(NF90_CLOBBER,NF90_CLASSIC_MODEL)
     else
        call error_handler ('Unknown netCDF format')
     endif

     istat = NF90_CREATE (trim(out_file_name), cmode, ncid_out, chunksize=blksz)
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)

   ! copy global attributes
     do attnum = 1, numatts
        ! get name
        istat = NF90_INQ_ATTNAME (ncid_in, NF90_GLOBAL, attnum, attname)
        if (istat /= NF90_NOERR) call error_handler (ncode=istat)
        ! change global filename attribute
        if (trim(attname) == 'filename') then
            istat = NF90_PUT_ATT (ncid_out, NF90_GLOBAL, 'filename', trim(out_file_name))
            if (istat /= NF90_NOERR) call error_handler (ncode=istat)
        ! append to history attribute
        else if (trim(attname) == 'history') then
           !istat = NF90_INQUIRE_ATTRIBUTE (ncid_in, NF90_GLOBAL, trim(attname), len=nc)
           !istat = NF90_GET_ATT (ncid_in, NF90_GLOBAL, 'history', history)
        else    
            ! copy all others
            istat = NF90_COPY_ATT (ncid_in, NF90_GLOBAL, attname, ncid_out, NF90_GLOBAL)
            if (istat /= NF90_NOERR) call error_handler ('copying global attributes', &
                                                          ncode=istat)
        endif   
     enddo
     ! add comment attribute
     istat = NF90_PUT_ATT (ncid_out, NF90_GLOBAL, 'comment', trim(version))
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)

!-----------------------------------------------------------------------
!------------------ generate axes for output file ----------------------

    xmass_out = xmass_in;  ymass_out = ymass_in

    !---- copy mass axes ----
     naxes = 1
     call copy_axis_information (ncid_in, xmass_in, ncid_out, (/isg,ieg,is,ie/), Axes(naxes), &
                                 dimid_out=dimids_mass(1), name_out=xmass_out, name_edges=edge_name)
         ! copy edge axis if available
         if (edge_name(1:1) .ne. ' ') then
             naxes = naxes + 1
             call copy_axis_information (ncid_in, edge_name, ncid_out, (/isg,ieg+1,is,ie+1/), Axes(naxes))
         endif

     naxes = naxes + 1
     call copy_axis_information (ncid_in, ymass_in, ncid_out, (/jsg,jeg,js,je/), Axes(naxes), &
                                 dimid_out=dimids_mass(2), name_out=ymass_out, name_edges=edge_name)
         ! copy edge axis if available
         if (edge_name(1:1) .ne. ' ') then
             naxes = naxes + 1
             call copy_axis_information (ncid_in, edge_name, ncid_out, (/jsg,jeg+1,js,je+1/), Axes(naxes))
         endif

!    -------- vertical axis (convert to mb) -------

   ! define new output pressure dimension and variable
     istat = NF90_DEF_DIM (ncid_out, trim(pres_name_out), nlev_out, dimids_mass(3))
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)
     istat = NF90_DEF_VAR (ncid_out, trim(pres_name_out), NF90_REAL4, (/dimids_mass(3)/), varid_pout)
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)
   ! attributes for this axis
     istat = NF90_PUT_ATT (ncid_out, varid_pout, 'units', 'hPa')
     if (istat /= NF90_NOERR) call error_handler ('putting attributes for pout dimension', ncode=istat)
     istat = NF90_PUT_ATT (ncid_out, varid_pout, 'long_name', 'pressure')
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)
     istat = NF90_PUT_ATT (ncid_out, varid_pout, 'cartesian_axis', 'Z')
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)
     istat = NF90_PUT_ATT (ncid_out, varid_pout, 'axis', 'Z') ! for CF compliance
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)
     istat = NF90_PUT_ATT (ncid_out, varid_pout, 'positive', 'down')
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)

   ! copy the time axis
   ! get variable identifiers and length
     call copy_axis (ncid_in, time_in, ncid_out, dimids_mass(4), &
                     varid_time_in, varid_time_out, ntimes)

   ! set up time axis indexing
     itime_beg = time_beg
     itime_end = time_end
     itime_inc = time_inc
     if (itime_end == 0 .or. itime_end > ntimes) itime_end = ntimes
     if (itime_beg <= 0) itime_beg = 1
     if (itime_inc <= 0) itime_inc = 1
    !if (itime_beg < itime_end) itime_end = itime_beg  ! process at least one time level


   ! check for time averaging "bounds"
   ! make sure axis is copied (time axis already copied)
     do i=1,NF90_MAX_NAME;  name_time_bounds(i:i) = ' '; enddo
     do i=1,NF90_MAX_NAME;  cell_methods(i:i) = ' '    ; enddo
     istat = NF90_GET_ATT (ncid_in, varid_time_in, 'bounds', name_time_bounds)
     if (istat /= NF90_NOERR) then
         istat = NF90_GET_ATT (ncid_in, varid_time_in, 'climatology', name_time_bounds)
     endif
     if (istat == NF90_NOERR) then
         if (verbose > 1) print *, 'name_time_bounds=',trim(name_time_bounds)
         istat = NF90_INQ_VARID (ncid_in, trim(name_time_bounds), varid_time_bounds_in)
         if (istat /= NF90_NOERR) call error_handler ('getting varid for time bounds', ncode=istat)
         istat = NF90_INQUIRE_VARIABLE (ncid_in, varid_time_bounds_in, ndims=ndim, dimids=dimids)
         if (istat /= NF90_NOERR) call error_handler ('getting dimensions for time bounds', ncode=istat)
         if (ndim == 1 .or. ndim == 2) then
             istat = NF90_INQUIRE_DIMENSION (ncid_in, dimids(1), name=edge_name)
             if (istat == NF90_NOERR) then
                 naxes = naxes + 1
                 call copy_axis_information (ncid_in, edge_name, ncid_out, (/1,1,1,1/), &
                                             Axes(naxes), dimid_out=dimid_tbnds)
             endif
         else
             call error_handler ('number of dimensions not consistent for '//trim(name_time_bounds))
         endif
         ! get cell methods for new variables
         istat = NF90_GET_ATT (ncid_in, varid_ps_in, 'cell_methods', cell_methods)
         do_time_bounds = .true.
     else
         do_time_bounds = .false.
     endif

!-----------------------------------------------------------------------
!-------------- define new variables for output file -----------------

!  ---- geopotential height ----

if (do_hght) then
   mval_hght = -1000.
   if (use_default_missing_value) mval_hght = NF90_FILL_REAL4

   call define_new_variable ( ncid_out, 'hght', NF90_REAL4, dimids_mass, varid_hght_out, &
                              units='m', long_name='height', missing_value=mval_hght,    &
                              time_avg_info=time_avg_info, cell_methods=cell_methods)
   
endif

!  ---- sea level pressure ----

if (do_slp) then
   mval_slp = -1.
   if (use_default_missing_value) mval_slp = NF90_FILL_REAL4

   call define_new_variable ( ncid_out, 'slp', NF90_REAL4,                      &
                              (/dimids_mass(1),dimids_mass(2),dimids_mass(4)/), &
                              varid_slp_out, units='hPa', long_name='sea level pressure', &
                              missing_value=mval_slp, time_avg_info=time_avg_info,   &
                              cell_methods=cell_methods)
endif

!-----------------------------------------------------------------------
!---- copy variable info for other fields ------

    Fields(:)%varid_in = 0
    Fields(:)%y_axis = 0
    Fields(:)%z_axis = 0
    Fields(:)%static = .false.   ! only allowing 2d static fields
    do_phalf = .false.

    do i = 1, num_field_names

       call copy_variable_information ( field_names(i), ncid_in, ncid_out, Fields(i) )

       ! save index for special fields
       if (trim(field_names(i)) == trim(   ps_name)) index_ps    = i
       if (trim(field_names(i)) == trim(zsurf_name)) index_zsurf = i
       if (trim(field_names(i)) == trim( temp_name)) index_temp  = i
       if (trim(field_names(i)) == trim(sphum_name)) index_sphum = i

       ! check valid fields for half levels then go to end of loop
       if (.not.Fields(i)%skip) then
           if (Fields(i)%z_axis == 2) do_phalf = .true.
           cycle
       endif

       if (trim(field_names(i)) == trim( hght_name)) cycle
       if (trim(field_names(i)) == trim(  slp_name)) cycle
       print *, 'WARNING: unable to process field '//trim(field_names(i))
    enddo

!-----------------------------------------------------------------------
!---- input variable only are needed to process some field ----
!---- check to see if these variables are in the field_names list ----

      if (.not.field_name_present(ps_name,field_names,num_field_names)) then
          num_field_names = num_field_names + 1
          index_ps = num_field_names
          call get_input_variable_info ( ps_name, ncid_in, Fields(num_field_names) )
      endif

      if (need_zsurf) then
          if (.not.field_name_present(zsurf_name,field_names,num_field_names)) then
              num_field_names = num_field_names + 1
              index_zsurf = num_field_names
              call get_input_variable_info ( zsurf_name, ncid_in, Fields(num_field_names) )
          endif
      endif

      if (need_temp) then
          if (.not.field_name_present(temp_name,field_names,num_field_names)) then
              num_field_names = num_field_names + 1
              index_temp = num_field_names
              call get_input_variable_info ( temp_name, ncid_in, Fields(num_field_names) )
          endif
      endif

      if (need_sphum) then
          if (.not.field_name_present(sphum_name,field_names,num_field_names)) then
              num_field_names = num_field_names + 1
              index_sphum = num_field_names
              call get_input_variable_info ( sphum_name, ncid_in, Fields(num_field_names) )
          endif
      endif

!-----------------------------------------------------------------------
! ---- copy variable info for time averaging -----

      if (do_time_bounds) then
          call copy_variable ( ncid_in, trim(name_time_bounds), ncid_out,    &
                               (/dimid_tbnds,dimids_mass(4)/), varid_time_bounds_out )
      endif

      if (do_time_average) then
          do i = 1, 3
             name_time_average = trim(avg_name)//trim(avg_subnames(i))
             istat = NF90_INQ_VARID (ncid_in, trim(name_time_average), varid_tavg_in(i))
             if (istat /= NF90_NOERR) call error_handler (ncode=istat)
             call copy_variable ( ncid_in, trim(name_time_average), ncid_out,    &
                                  (/dimids_mass(4)/), varid_tavg_out(i) )
          enddo
       endif
          
!-----------------------------------------------------------------------
! ---- write header info for output file ----

      istat = NF90_ENDDEF (ncid_out,header_buffer_val,4,0,4)
      if (istat /= NF90_NOERR) call error_handler (ncode=istat)

!-----------------------------------------------------------------------
!------------ read and write static axis data -------------

       do idim = 1, naxes
          if (Axes(idim)%varid_in < 0) cycle
          nlen = Axes(idim)%dimlen
          allocate (axisdata(nlen))
          istat = NF90_GET_VAR (ncid_in, Axes(idim)%varid_in, axisdata, start=Axes(idim)%start)
          if (istat /= NF90_NOERR) call error_handler ('getting axis data for var='//trim(Axes(idim)%name_in), ncode=istat)
          istat = NF90_PUT_VAR (ncid_out, Axes(idim)%varid_out, axisdata)
          if (istat /= NF90_NOERR) call error_handler ('putting axis data for var='//trim(Axes(idim)%name_out), ncode=istat)
          deallocate (axisdata)
       enddo
        ! output pressure levels in millibars
          istat = NF90_PUT_VAR (ncid_out, varid_pout, pout(1:nlev_out)*0.01)
          if (istat /= NF90_NOERR) call error_handler ('putting axis data for var='//trim(pres_name_out), ncode=istat)

!-----------------------------------------------------------------------
!------------ first time: read constant fields -------------------------

       start(1:3) = (/ is, js, 1 /)
       istat = NF90_INQ_VARID (ncid_in, trim(res_name), varid_res)
       if ( istat == NF90_NOERR ) then
          istat = NF90_GET_VAR (ncid_in, varid_res, res, start=start(1:2))
          if (istat /= NF90_NOERR) call error_handler (ncode=istat)
       else
          res = 1.0
       endif
       if (need_zsurf .or. do_zsurf) then
          call read_variable (ncid_in, Fields(index_zsurf), zsurf, start=start(1:2))
       else
          zsurf = 0.0
       endif
       if (do_zsurf) then
          call write_variable (ncid_out, Fields(index_zsurf), zsurf)
       endif
!      --- eta coord fix ----
       if (count(res > 1.0001) > 0) zsurf = 0.0

!-----------------------------------------------------------------------
!      ---- read/write static fields ----

    do i = 1, num_field_names
       if ( Fields(i)%skip )         cycle
       if ( .not.Fields(i)%static )  cycle
       if (trim(Fields(i)%name) == trim(zsurf_name)) cycle
       call read_write_static (ncid_in, ncid_out, is, ie, js, je, Fields(i))
    enddo

!-----------------------------------------------------------------------
!-------------------- loop through time axis ---------------------------
!-----------------------------------------------------------------------

      otime = 0
      do itime = itime_beg, itime_end, itime_inc
          otime = otime+1
          if ( verbose > 0 ) then
              if (itime == otime) then
                 print '(a,i8)', 'itime =', itime
              else
                 print '(a,2i8)', 'itime, otime =', itime, otime
              endif
          endif

!---------------- read/write time level --------------

          istat =  NF90_GET_VAR (ncid_in, varid_time_in, time, start=(/itime/))
          if (istat /= NF90_NOERR) call error_handler ('getting time coord value', &
                                                       ncode=istat)

          istat =  NF90_PUT_VAR (ncid_out, varid_time_out, time, start=(/otime/))
          if (istat /= NF90_NOERR) call error_handler ('putting time coord value', &
                                                       ncode=istat)

!-----------------------------------------------------------------------
!-------------- interpolation setup ------------------------------------

     !---- surface pressure ----

          start(1:3) = (/ is, js, itime /)
          call read_variable (ncid_in, Fields(index_ps), ps, start=start(1:3))
          ps(is:ie,js:je,1) = ps(is:ie,js:je,1) * res

!-----------------------------------------------------------------------
!----------------- mass field interpolation ---------------------

!     ---- interpolation initialization for mass fields ------

     call interp_field_setup ( ncid_in, ncid_out, bk, pk,   &
                               is, js, itime, otime,        &
                               ps(is:ie,js:je,1),           &
                               zsurf(:,:,1), pout(1:nlev_out) )

!     ---- interpolation of mass fields ----

     do i = 1, num_field_names
        if ( Fields(i)%skip   )    cycle
        if ( Fields(i)%static )    cycle
        if ( Fields(i)%y_axis /= nlat ) cycle

        kv = max(1,Fields(i)%z_axis)
        if ( verbose > 1 ) then
           print *, 'Interp field = ',trim(Fields(i)%name)
        endif

!     ---- interpolation of mass fields ----
        call interp_field ( ncid_in, ncid_out, Interp(kv),  &
                            is, js, itime, otime, Fields(i) )

     enddo

!     ---- free up allocated space ----
                    call pres_interp_free (Interp(1))
      if (do_phalf) call pres_interp_free (Interp(2))

!-----------------------------------------------------------------------
!   ---- copy time average data ----

    if (do_time_bounds) then
        istat = NF90_GET_VAR (ncid_in,  varid_time_bounds_in,  time_bnds(:), start=(/1,itime/))
        if (istat /= NF90_NOERR) call error_handler ('getting time_bounds', ncode=istat)
        istat = NF90_PUT_VAR (ncid_out, varid_time_bounds_out, time_bnds(:), start=(/1,otime/))
        if (istat /= NF90_NOERR) call error_handler ('putting time_bounds', ncode=istat)
    endif

    if (do_time_average) then
        do i = 1, 3
           istat = NF90_GET_VAR (ncid_in,  varid_tavg_in(i),  time_bnds(1), start=(/itime/))
           if (istat /= NF90_NOERR) call error_handler ('getting tavg_info', ncode=istat)
           istat = NF90_PUT_VAR (ncid_out, varid_tavg_out(i), time_bnds(1), start=(/otime/))
           if (istat /= NF90_NOERR) call error_handler ('putting tavg_info', ncode=istat)
        enddo
    endif

!-----------------------------------------------------------------------

   enddo  ! end of time loop

!-----------------------------------------------------------------------

       istat = NF90_CLOSE (ncid_in)
       if (istat /= NF90_NOERR) call error_handler (ncode=istat)
       istat = NF90_CLOSE (ncid_out)
       if (istat /= NF90_NOERR) call error_handler (ncode=istat)

!-----------------------------------------------------------------------

contains

!#######################################################################

   subroutine interp_field_setup ( ncid_in, ncid_out, bk, pk, &
                                   is, js, itime, otime, ps,  &
                                   zsurf, pout )

   integer, intent(in) :: ncid_in, ncid_out
   real,    intent(in) :: bk(:), pk(:)
   integer, intent(in) :: is, js, itime, otime
   real   , intent(in) :: ps(:,:), zsurf(:,:), pout(:)

 real, dimension(size(ps,1),size(ps,2),size(bk(:))-1) :: &
            temp_in, sphum_in, mask_in, pfull, hght_in
 real, dimension(size(ps,1),size(ps,2),size(bk(:)))   :: phalf
 real, dimension(size(ps,1),size(ps,2),size(pout)) ::  &
                         temp_out, hght_out, sphum_out
 real   , dimension(size(ps,1),size(ps,2)) :: zbot, tbot, pbot, slp
 integer, dimension(size(ps,1),size(ps,2)) :: kbot
   character(len=NF90_MAX_NAME) :: name
   integer :: start(4), kount(4), ndim, ivar, nlev, kb, kr, i, j, k
   real    :: sig


      do k = 1, size(bk(:))
         phalf(:,:,k) = pk(k) + bk(k)*ps(:,:)
      enddo
      call compute_pres_full (pk, bk, phalf, pfull)

  !---- read in temperature data ----
   if (do_temp .or. need_temp) then
       start = (/ is, js, 1, itime /)
       call read_variable (ncid_in, Fields(index_temp), temp_in, start)
      !---- mask ----
       call set_up_input_mask (ncid_in, Fields(index_temp), temp_in, mask_in, kbot)
   endif

  !---- read in specific humidity data ----
   if (do_sphum .or. need_sphum) then
       if (sphum_present) then
           start = (/ is, js, 1, itime /)
           call read_variable (ncid_in, Fields(index_sphum), sphum_in, start)
          !---- mask ----
           if (.not.do_temp) &
           call set_up_input_mask (ncid_in, Fields(index_sphum), sphum_in, mask_in, kbot)
       else
           sphum_in = 0.0
       endif
   endif

  !---- interpolation setup for standard full pressure levels -----
   if (do_hght) then
       if ( verbose > 1 ) print *, 'Computing field = hght'
      !---- geopotential height (in meters) -----
       call compute_height ( zsurf, temp_in, sphum_in, pfull, phalf, hght_in, mask_in)
      !---- interpolate temp, sphum, hght ----
       if ( verbose > 1 ) then
           print *, 'Interp field = ',trim(Fields(index_temp)%name)
           print *, 'Interp field = ',trim(Fields(index_sphum)%name)
       endif
       Interp(1) = pres_interp_init ( pfull, pout, kbot,   &
                                      tin=temp_in,  tout=temp_out,  &
                                      zin=hght_in,  zout=hght_out,  &
                                      qin=sphum_in, qout=sphum_out, &
                                      use_extrap=.not.mask_extrap   )
   else if ((do_temp.and.do_sphum).and.(.not.do_hght)) then
       if ( verbose > 1 ) then
           print *, 'Interp field = ',trim(Fields(index_temp)%name)
           print *, 'Interp field = ',trim(Fields(index_sphum)%name)
       endif
      !---- interpolate temp, sphum ----
       Interp(1) = pres_interp_init ( pfull, pout, kbot,   &
                                      tin=temp_in,  tout=temp_out,  &
                                      qin=sphum_in, qout=sphum_out, &
                                      use_extrap=.not.mask_extrap   )
   else if ((do_temp).and.(.not.do_hght)) then
       if ( verbose > 1 ) print *, 'Interp field = ',trim(Fields(index_temp)%name)
      !---- interpolate temp ----
       Interp(1) = pres_interp_init ( pfull, pout, kbot,   &
                                      tin=temp_in,  tout=temp_out,  &
                                      use_extrap=.not.mask_extrap   )
   else if ((do_sphum).and.(.not.do_hght)) then
       if ( verbose > 1 ) print *, 'Interp field = ',trim(Fields(index_sphum)%name)
      !---- interpolate sphum ----
       Interp(1) = pres_interp_init ( pfull, pout, kbot,   &
                                      qin=sphum_in, qout=sphum_out, &
                                      use_extrap=.not.mask_extrap   )
   else
      !---- initialize only (need kbot) ----
       start = (/ is, js, 1, itime /)
       call read_and_set_up_mask (ncid_in, start, mask_in, kbot)
       Interp(1) = pres_interp_init ( pfull, pout, kbot,   &
                                      use_extrap=.not.mask_extrap   )
   endif
   
  !---- interpolation setup for standard full pressure levels -----
   if (do_phalf) then
       Interp(2) = pres_interp_init ( phalf, pout, kbot )
   endif

! ---- write out data ----

     !start = (/ is, js,  1, otime /)
      start = (/  1,  1,  1, otime /)

!     ---- temperature ----

   if (do_temp) then
      if ( verbose > 1 ) print *, 'Writing field = ',trim(Fields(index_temp)%name)
      if (Fields(index_temp)%do_miss_out) then
          call mask_data (Fields(index_temp)%unpkd_missval_out, Interp(1)%mask, temp_out)
      endif
      call write_variable (ncid_out, Fields(index_temp), temp_out, start)
   endif

!        ---- specific humidity ----

   if (do_sphum) then
      if ( verbose > 1 ) print *, 'Writing field = ',trim(Fields(index_sphum)%name)
      if (Fields(index_sphum)%do_miss_out) then
          call mask_data (Fields(index_sphum)%unpkd_missval_out, Interp(1)%mask, sphum_out)
      endif
      call write_variable (ncid_out, Fields(index_sphum), sphum_out, start)
   endif

!        ---- height ----

   if (do_hght) then
      if ( verbose > 1 ) print *, 'Writing field = hght'
      call mask_data (mval_hght, Interp(1)%mask, hght_out)
      istat = NF90_PUT_VAR (ncid_out, varid_hght_out, hght_out, start)
      if (istat /= NF90_NOERR) call error_handler ('putting hght data', ncode=istat)
   endif

!        ---- sea level pressure ----

   if (do_slp) then
     if ( verbose > 1 ) print *, 'Computing field = slp'
     do j = 1, size(ps,2)
     do i = 1, size(ps,1)
        kb = kbot(i,j)
        pbot(i,j) = phalf(i,j,kb+1)

        if ( abs(zsurf(i,j)) > 0.0001 ) then

!            ---- get ref level for temp (as in spectral model) ----
             do k = 1, kb
                sig = pfull(i,j,k)/pbot(i,j)
                if ( sig > 0.8 ) then
                     kr = k
                     exit
                endif
             enddo

            !zbot(i,j) = zhalf(i,j,kb+1)
!!!          tbot(i,j) = tref - tlapse*zbot(i,j)           ! original
             tbot(i,j) = temp_in(i,j,kr) * sig ** mrgog    ! spectral
             slp(i,j) = 0.01 * pbot(i,j) *  &
                       ( 1.0 + tlapse * zsurf(i,j) / tbot(i,j) ) ** gorg
                      !( 1.0 + tlapse * zbot(i,j) / tbot(i,j) ) ** gorg
        else
             slp(i,j) = pbot(i,j) * 0.01
        endif
     enddo
     enddo

     if ( verbose > 1 ) print *, 'Writing field = slp'
     start(1:3) = (/ is, js, otime /)
     istat = NF90_PUT_VAR (ncid_out, varid_slp_out, slp, start)
     if (istat /= NF90_NOERR) call error_handler ('putting slp data', ncode=istat)
   endif


   end subroutine interp_field_setup

!#######################################################################

   subroutine interp_field ( ncid_in, ncid_out, Interp, is, js, itime, otime, Field )

   integer               , intent(in) :: ncid_in, ncid_out
   type(pres_interp_type), intent(in) :: Interp
   integer               , intent(in) :: is, js, itime, otime
   type(field_type)      , intent(in) :: Field

   real, dimension(Interp%nx,Interp%ny,Interp%kx) :: data_in
   real, dimension(Interp%nx,Interp%ny,Interp%nz) :: data_out

   integer :: start_in(4), start_out(4), istat

!     ---- skip fields have been processed in the initialization routine
       if (trim(Field%name) == trim(temp_name))  return
       if (trim(Field%name) == trim(sphum_name)) return

!     ---- read in data ----

       start_in (1:3) = (/ is, js, 1 /)
      !start_out(1:3) = (/ is, js, 1 /)
       start_out(1:3) = (/  1,  1, 1 /)
       start_in (Field%ndim) = itime
       start_out(Field%ndim) = otime

!     ---- check horiz axis lengths ----

      !if ( Field%dimlen(1) /= Interp%nx .or. Field%dimlen(2) /= Interp%ny ) then
      !    print *, 'x,y=',Field%dimlen(1),Interp%nx,Field%dimlen(2),Interp%ny
      !    call error_handler (   &
      !      'horizontal coordinate resolution inconsistent, var = '//trim(Field%name))
      !endif


!  ------ 2-d or 3-d data allowed -----

 select case ( Field%ndim )

   case (4)
!     ---- check vert axis length ----
     if ( Field%dimlen(3) /= Interp%kx ) print *, trim(Field%name)
     if ( Field%dimlen(3) /= Interp%kx ) call error_handler (    &
                'vertical coordinate resolution inconsistent')
     call read_variable (ncid_in, Field, data_in, start_in(1:4))
!    ---- interpolation ----
     call pres_interp (Interp, data_in, data_out)
     if (Field%do_miss_out) &
     call mask_data (Field%unpkd_missval_out, Interp%mask, data_out)
!    ---- write out data ----
     call write_variable (ncid_out, Field, data_out, start_out(1:4))

   case (3)
     call read_variable (ncid_in, Field, data_in(:,:,1:1), start_in(1:3))
     call write_variable (ncid_out, Field, data_in(:,:,1:1), start_out(1:3))

   case default
     print *, 'ERROR: only 2-d or 3-d fields allowed'
     stop

 end select



 end subroutine interp_field

!#######################################################################

  subroutine mask_data (mval, mask, data)

   real            , intent(in)    :: mval
   logical         , intent(in)    :: mask(:,:,:)
   real            , intent(inout) :: data(:,:,:)

     if (.not.mask_extrap) return
     where (mask) data = mval

  end subroutine mask_data

!#######################################################################

 subroutine check_fields ( ncid )

   integer, intent(in) :: ncid

   integer :: id(6), ierr, iwarn, i
   integer :: avg(6), istat(6)
   character(len=NF90_MAX_NAME), dimension(6) :: names

!-----------------------------------------------------------------------

     names = (/ bk_name, pk_name, zsurf_name, ps_name, temp_name, sphum_name /)

     need_zsurf = .false.
     need_temp  = .false.
     need_sphum = .false.

     id = 0

   ! get variable index for all important fields
     do i = 1, 6
       istat(i) = NF90_INQ_VARID (ncid, trim(names(i)), id(i))
     enddo

!------ perform checks ------

       ierr  = 0
       iwarn = 0

    ! minimum: bk, ps (, pk)
      if (istat(1) /= NF90_NOERR) then
          print *, 'ERROR: required field does not exist: ',trim(names(1))
          ierr = 1
      endif
      if (istat(2) /= NF90_NOERR) then
          print *, 'WARNING: required field does not exist: ',trim(names(2))
          iwarn = 1
      endif
      if (istat(4) /= NF90_NOERR) then
          print *, 'ERROR: required field does not exist: ',trim(names(4))
          ierr = 1
      else
          ! check if time average to be done
          avg(4) = NF90_INQUIRE_ATTRIBUTE (ncid, id(4), 'time_avg_info')
      endif
    ! time averaging for all variable must be consistent
    ! initialize all variables to surf pres value
      avg(5:6) = avg(4)

    ! surf height & temperature
      temp_present = .false.;  if (istat(5) == NF90_NOERR ) temp_present = .true.
      if (do_hght .or. do_slp) then
          if (istat(3) /= NF90_NOERR) then
              if (allow_zero_topog) then
                  print *, 'NOTE: field does not exist: ',trim(names(3)),' = 0 assumed'
              else
                  print *, 'ERROR: required field does not exist: ',trim(names(3))
                  ierr = 1
                  do_hght = .false.
                  do_slp  = .false.
              endif
          else
              need_zsurf = .true.
          endif
          if (temp_present) then
              avg(5) = NF90_INQUIRE_ATTRIBUTE (ncid, id(5), 'time_avg_info')
              need_temp = .true.
          else
              print *, 'ERROR: required field does not exist: ',trim(names(5))
              ierr = 1
              do_hght = .false.
              do_slp  = .false.
          endif
      endif

    ! specific humidity
      sphum_present = .false.;  if (istat(6) == NF90_NOERR ) sphum_present = .true.
      if (do_hght) then
          if (sphum_present) then
              avg(6) = NF90_INQUIRE_ATTRIBUTE (ncid, id(6), 'time_avg_info')
              need_sphum = .true.
          else
              if (allow_zero_sphum) then
                  print *, 'NOTE: field does not exist: ',trim(names(6)),' = 0 assumed'
              else
                  print *, 'ERROR: required field does not exist: ',trim(names(6))
                  ierr = 1
                  do_hght = .false.
              endif
          endif
      
      endif


   ! set variable identifiers in the input file
      varid_bk       = id(1)
      varid_pk       = id(2)
      varid_zsurf_in = id(3)
      varid_ps_in    = id(4)
      varid_temp_in  = id(5)
      varid_sphum_in = id(6)

      if ( ierr  /= 0 ) call error_handler ('run_pressure_interp')
      if ( iwarn /= 0 ) print *, 'WARNING: run_pressure_interp'
             
!-----------------------------------------------------------------------
   ! check time averaging flag for consistency
     do i = 5, 6
        if (avg(4) /= avg(i)) call error_handler ('inconsistent time averages')
     enddo

    ! set averaging flag for program ----
      do_time_average = avg(4) == NF90_NOERR

    ! set metadata time average string
      do i=1,NF90_MAX_NAME;  time_avg_info(i:i) = ' '; enddo
      if (do_time_average) then
         time_avg_info = trim(avg_name)//trim(avg_subnames(1))//','// &
                         trim(avg_name)//trim(avg_subnames(2))//','// &
                         trim(avg_name)//trim(avg_subnames(3))
      endif
      
 end subroutine check_fields

!#######################################################################

 subroutine set_all_field_names ( ncid, field_names, num_field_names )

   integer,          intent(in)    :: ncid
   character(len=*), intent(inout) :: field_names(:)
   integer,          intent(inout) :: num_field_names

   character(len=NF90_MAX_NAME) :: name
   integer :: ivar, idim, rdim, nvar, ndim, i, istat
   integer :: dimids(NF90_MAX_VAR_DIMS), axlen(NF90_MAX_VAR_DIMS)
   logical :: static, threed

   if ( num_field_names >= MAX_FIELD_NAMES ) return

   istat = NF90_INQUIRE (ncid, nvariables=nvar, unlimiteddimid=rdim)
   if (istat /= NF90_NOERR) call error_handler (ncode=istat)

     do ivar = 1, nvar

        ! get number and names of dimensions
        istat = NF90_INQUIRE_VARIABLE (ncid, ivar, name=name, ndims=ndim, dimids=dimids)
        if (istat /= NF90_NOERR) call error_handler (ncode=istat)
        ! get dimension lengths
        do idim = 1, ndim
           istat = NF90_INQUIRE_DIMENSION (ncid, dimids(idim), len=axlen(idim))
           if (istat /= NF90_NOERR) call error_handler (ncode=istat)
        enddo

!     ----  has this name been specified already? ----
       if (field_name_present(name,field_names,num_field_names)) cycle

!     ---- skip surface pressure and topography fields ----
        if ( trim(name) == 'res') cycle    ! for eta coordinate

!     ---- must be 2-d, 3-d, or 4-d field ----
        static = dimids(ndim) .ne. rdim
        threed = .false.
!!!del  if (static) cycle   ! will not allow static for now (see below)

!     ---- skip 3-d fields if flag set ----

        select case (ndim)
          case (4)
            if (static) cycle   ! not possible
            threed = .true. 
          case (3)
           !if (.not.static .and. do_all_3d_fields) cycle
            if (static) threed = .true.
            if (.not.static .and. .not.do_all_fields) cycle
           !if (static) cycle           ! no 3d static fields allowed
          case (2)
            if (.not.static) cycle
            if (.not.do_all_fields) cycle
          case default
            cycle
        end select

!     ---- axes must have correct size ----
        if (axlen(1) /= nlon .or.  axlen(2) /= nlat)   cycle
        if (threed) then
        if (axlen(3) /= nlev .and. axlen(3) /= nlev+1) cycle
        endif

!     ---- output this field ----
        num_field_names = num_field_names + 1
        field_names(num_field_names) = name
        if ( num_field_names == MAX_FIELD_NAMES ) return

     enddo

 end subroutine set_all_field_names

!#######################################################################

 function field_name_present ( name, field_names, num_field_names ) 
 character(len=*), intent(in) :: name, field_names(:)
 integer,          intent(in) :: num_field_names
 logical :: field_name_present
 integer :: i

     field_name_present = .false.

    !----  has this name been specified already? ----
     do i = 1, num_field_names
        if (trim(name) == trim(field_names(i))) then
           field_name_present = .true.
           return
        endif
     enddo

 end function field_name_present

!#######################################################################

 function skip_field_name ( field_name )

   character(len=NF90_MAX_NAME), intent(in) :: field_name
   logical :: skip_field_name
   integer :: i

!  ------ skip fields that are written separately ------

       !skip_field_name = .false.

       !if (trim(field_name) == trim(sphum_name)) then
       !    skip_field_name = .true.; return; endif
       !if (trim(field_name) ==  trim(temp_name)) then
       !    skip_field_name = .true.; return; endif
       !if (trim(field_name) == trim(zsurf_name)) then
       !    skip_field_name = .true.; return; endif

        if (trim(field_name) ==  trim(hght_name)) then
            skip_field_name = .true.; return; endif
        if (trim(field_name) ==   trim(slp_name)) then
            skip_field_name = .true.; return; endif

 end function skip_field_name

!#######################################################################

 subroutine get_input_variable_info ( name, ncid_in, Field )

   character(len=NF90_MAX_NAME), intent(in)    :: name
   integer          ,       intent(in)    :: ncid_in
   type(field_type) ,       intent(inout) :: Field
   logical :: answer
   integer :: rdim, zcoord, idim
   integer :: i, istat, ipack, ioffs, imiss, ifill
   real    :: mval, fval

 ! reset skip flag
 ! skip all fields unless properties are acceptable
   Field%skip = .true.
   Field%varid_in = 0

 ! skip certain field names
   if (trim(name) == trim(hght_name))  return
   if (trim(name) == trim(slp_name))   return

 ! get time axis id
   istat = NF90_INQUIRE (ncid_in, unlimiteddimid=rdim)
   if (istat /= NF90_NOERR) call error_handler (ncode=istat)
 ! get variable id 
   istat = NF90_INQ_VARID (ncid_in, trim(name), Field%varid_in)

 ! proceed if this variable exists
   if (istat /= NF90_NOERR) return

       if (verbose > 2) print *, 'getting input variable info, name=',trim(name)

       ! get number and names of dimensions
       istat = NF90_INQUIRE_VARIABLE (ncid_in, Field%varid_in, name=Field%name, &
                        xtype=Field%xtype, ndims=Field%ndim, dimids=Field%dimids)
       if (istat /= NF90_NOERR) call error_handler (ncode=istat)
       ! get dimension lengths
       do idim = 1, Field%ndim
          istat = NF90_INQUIRE_DIMENSION (ncid_in, Field%dimids(idim), len=Field%dimlen(idim))
          if (istat /= NF90_NOERR) call error_handler (ncode=istat)
       enddo
       Field%static = Field%dimids(Field%ndim) .ne. rdim
       Field%z_axis = 0
       Field%y_axis = 0

     ! check time averaging
       istat = NF90_INQUIRE_ATTRIBUTE (ncid_in, Field%varid_in, 'time_avg_info')
       Field%do_avg = istat == NF90_NOERR

     ! get packing attributes of input data
       ipack = NF90_GET_ATT (ncid_in, Field%varid_in, 'scale_factor', Field%pack(1))
       ioffs = NF90_GET_ATT (ncid_in, Field%varid_in, 'add_offset',   Field%pack(2))
       if (ipack == NF90_NOERR .and. ioffs == NF90_NOERR) then
           Field%do_pack = .true.
       else
           Field%do_pack = .false.
           Field%pack = (/1.,0./)
       endif

     ! get missing value attribute or fill value attribute
     ! NOTE: conversion of missing value data type to default real type
       imiss = NF90_GET_ATT (ncid_in, Field%varid_in, 'missing_value', mval)
       ifill = NF90_GET_ATT (ncid_in, Field%varid_in, '_FillValue',    fval)
       if (imiss == NF90_NOERR) then
          Field%do_miss_in = .true.
          Field%missval_in = mval
       else if (ifill == NF90_NOERR) then
          Field%do_miss_in = .true.
          Field%missval_in = fval
       else
          Field%do_miss_in = .false.
          Field%missval_in = 0.
       endif

     ! unpack input missing value (for comparison with unpacked data)
       Field%unpkd_missval_in = Field%missval_in
       if (Field%do_miss_in .and. Field%do_pack) then
           Field%unpkd_missval_in = Field%unpkd_missval_in*Field%pack(1) + Field%pack(2)
       endif

       Field%skip = .false.

 end subroutine get_input_variable_info

!#######################################################################

 subroutine copy_variable_information ( name, ncid_in, ncid_out, Field )

   character(len=NF90_MAX_NAME), intent(in)    :: name
   integer          ,       intent(in)    :: ncid_in, ncid_out
   type(field_type) ,       intent(inout) :: Field
   logical :: answer
   integer :: rdim, zcoord, idim
   integer :: i, istat, ipack, ioffs, imiss, ifill
   integer :: dimids(4)
   real    :: mval, fval

   call get_input_variable_info ( name, ncid_in, Field )

   if (Field%skip) return
   Field%skip = .true.
   zcoord = 0

   ! set output missing value

     Field%do_miss_out = Field%do_miss_in
     Field%missval_out = Field%missval_in

     if (use_default_missing_value) then
         if (Field%xtype == NF90_REAL8) Field%missval_out = NF90_FILL_REAL8
         if (Field%xtype == NF90_REAL4) Field%missval_out = NF90_FILL_REAL4
         if (Field%xtype == NF90_INT)   Field%missval_out = NF90_FILL_INT
         if (Field%xtype == NF90_INT2)  Field%missval_out = NF90_FILL_INT2
     endif

     ! unpack output missing value (for comparison with unpacked data)
       Field%unpkd_missval_out = Field%missval_out
       if (Field%do_miss_out .and. Field%do_pack) then
           Field%unpkd_missval_out = Field%unpkd_missval_out*Field%pack(1) + Field%pack(2)
       endif

   ! do not process fields with one dimension
     if (Field%ndim == 1) return

   !---- check horizontal dimensions (again) ---
     if (Field%ndim >= 2) then
         if (Field%dimlen(1) /= nlon .or. Field%dimlen(2) /= nlat) then
               if (Field%ndim == 2 .and. Field%static) return
               if (Field%ndim >= 3)                    return
         endif
     endif

   ! set dimension identifiers for output file

     if (Field%dimlen(2) == nlat)   dimids = dimids_mass

   !---- copy input variable metadata to output file ----

     select case (Field%ndim)
       case (4)
            if (Field%dimlen(3) == nlev)   zcoord = 1
            if (Field%dimlen(3) == nlev+1) zcoord = 2
            if (zcoord == 0) return
            if (Field%static) return   ! 4d static fields not allowed
            call copy_variable ( ncid_in, trim(name), ncid_out, &
                                 dimids, Field%varid_out,       &
                                 missvalue=Field%missval_out  )
       case (3)
          if (Field%static) then
            if (Field%dimlen(3) == nlev)   zcoord = 1
            if (Field%dimlen(3) == nlev+1) zcoord = 2
            if (zcoord == 0) return
            return               ! no 3d static fields allowed
            call copy_variable ( ncid_in, trim(name), ncid_out, &
                                 dimids(1:3), Field%varid_out,  &
                                 missvalue=Field%missval_out )
          else
             !---- 2d non-static field ----
             if (Field%do_miss_in) then
                call copy_variable ( ncid_in, trim(name), ncid_out,      &
                      (/dimids(1),dimids(2),dimids(4)/), Field%varid_out,&
                      missvalue=Field%missval_out )
             else
                call copy_variable ( ncid_in, trim(name), ncid_out,      &
                      (/dimids(1),dimids(2),dimids(4)/), Field%varid_out )
             endif
          endif
       case(2)
          !---- 2d static field ----
          if (Field%static) then
             if (Field%do_miss_in) then
                call copy_variable ( ncid_in, trim(name), ncid_out, &
                                     dimids(1:2), Field%varid_out,  &
                                     missvalue=Field%missval_out    )
             else
                call copy_variable ( ncid_in, trim(name), ncid_out, &
                                     dimids(1:2), Field%varid_out   )
             endif
          endif
       case default
            return
     end select

     Field%skip = .false.
     Field%y_axis = Field%dimlen(2)
     Field%z_axis = zcoord

 end subroutine copy_variable_information

!#######################################################################

 subroutine copy_axis_information (ncid_in, name_in, ncid_out, decomp, &
                                   Axis, dimid_out, name_out, name_edges)

 integer,          intent(in)    :: ncid_in, ncid_out, decomp(4)
 character(len=*), intent(in)    :: name_in
 type(axis_type),  intent(inout) :: Axis
 integer,          intent(out), optional :: dimid_out
 character(len=*), intent(out), optional :: name_out, name_edges

 integer :: varid_in, varid_out, dimlen_out, dimlen_in, did_out

   if (verbose > 2) print *, 'COPYING, name_in=',trim(name_in)

   if (decomp(1) == decomp(3) .and. decomp(2) == decomp(4)) then
      ! global domain indices == compute domain indices
      call copy_axis ( ncid_in, name_in, ncid_out, did_out, varid_in, varid_out, &
                       dimlen_out, name_out=name_out, name_edges=name_edges)
   else
      dimlen_in = decomp(4)-decomp(3)+1
      call copy_axis ( ncid_in, name_in, ncid_out, did_out, varid_in, varid_out, dimlen_out, &
                       dimlen_in=dimlen_in, name_out=name_out, name_edges=name_edges)
   endif

   Axis%name_in   = name_in
   Axis%name_out  = name_in
   if (present(name_out)) Axis%name_out  = name_out
   Axis%varid_in  = varid_in 
   Axis%varid_out = varid_out
   Axis%dimlen    = dimlen_out
   Axis%start     = (/decomp(3)/)

   if (present(dimid_out)) dimid_out = did_out

 end subroutine copy_axis_information

!#######################################################################

 subroutine set_up_input_mask (ncid, Field, data, mask, kbot)

   integer,          intent(in)  :: ncid
   type(field_type), intent(in)  :: Field
   real,             intent(in)  :: data(:,:,:)
   real,             intent(out) :: mask(:,:,:)
   integer,          intent(out) :: kbot(:,:)

   integer :: k, nlev

!     ----- set up mask and bottom level index -----

      nlev = size(data,3)

      kbot = nlev
      mask = 1.0

      if (Field%do_miss_in) then
         where ( data == Field%unpkd_missval_in )
                 mask = 0.0
         elsewhere
                 mask = 1.0
         endwhere

         do k = nlev, 1, -1
            if (count(mask(:,:,k) < 0.5) == 0) exit
            where (mask(:,:,k) < 0.5) kbot(:,:) = k-1
         enddo
      endif

 end subroutine set_up_input_mask

!#######################################################################

 subroutine read_and_set_up_mask (ncid, start, mask, kbot)

   integer,           intent(in)  :: ncid, start(4)
   real,              intent(out) :: mask(:,:,:)
   integer,           intent(out) :: kbot(:,:)

   character(len=NF90_MAX_NAME) :: name
   real,  dimension(size(mask,1),size(mask,2),size(mask,3)) :: values
   integer :: ivar, nvar, istat
   logical :: done
   type(field_type) :: Field

     done = .false.

   ! get number of variables and time axis id
     istat = NF90_INQUIRE (ncid, nvariables=nvar)
     if (istat /= NF90_NOERR) call error_handler (ncode=istat)

     do ivar = 1, nvar
        istat = NF90_INQUIRE_VARIABLE ( ncid, ivar, name=name )
        if (istat /= NF90_NOERR) call error_handler (ncode=istat)
        call get_input_variable_info ( name, ncid, Field )

      ! find first 3d mass field
        if (Field%ndim <= 2) cycle
        if (Field%ndim <= 3 .and. .not.Field%static) cycle
        if (Field%ndim == 4 .and.      Field%static) cycle

      ! must have mass dimension lengths and full vertical levels
        if (Field%dimlen(1) /= nlon .or. Field%dimlen(2) /= nlat .or. Field%dimlen(3) /= nlev) cycle

      ! must have input missing value
        if (.not.Field%do_miss_in) cycle

        call read_variable     (ncid, Field, values, start )
        call set_up_input_mask (ncid, Field, values, mask, kbot)
        done = .true.
        exit

     enddo

     if (.not.done) then
        mask = 1.0
        kbot = nlev
     endif

 end subroutine read_and_set_up_mask

!#######################################################################

 subroutine read_write_static (ncid_in, ncid_out, is, ie, js, je, Field)
   integer         , intent(in) :: ncid_in, ncid_out, is, ie, js, je
   type(field_type), intent(in) :: Field

   real :: values(is:ie,js:je,1)

 ! read and write static fields that are on the mass grid (nlon x nlat)

 ! read data
   call read_variable ( ncid_in, Field, values, start=(/is, js/))

 ! write data
   call write_variable ( ncid_out, Field, values)

 end subroutine read_write_static

!#######################################################################

 subroutine read_variable ( ncid, Field, values, start )
 integer,           intent(in)  :: ncid
 type(field_type),  intent(in)  :: Field
 real,              intent(out) :: values(:,:,:)
 integer, optional, intent(in)  :: start(:)

 integer :: ndim, nd, begin(4)

 ! number of dimensions (less the time dimension)
   ndim = Field%ndim
   if (.not.Field%static) ndim = ndim-1

 ! start indices
   nd    = Field%ndim
   begin = 1
   if (present(start)) then
       nd = size(start)
       begin(1:nd) = start
   endif

   select case (ndim)
      case(1)
          istat = NF90_GET_VAR (ncid, Field%varid_in, values(:,1,1), start=begin(1:nd))
          if (istat /= NF90_NOERR) call error_handler ('getting 1d var='//trim(Field%name), ncode=istat)
      case(2)
          istat = NF90_GET_VAR (ncid, Field%varid_in, values(:,:,1), start=begin(1:nd))
          if (istat /= NF90_NOERR) call error_handler ('getting 2d var='//trim(Field%name), ncode=istat)
      case(3)
          istat = NF90_GET_VAR (ncid, Field%varid_in, values(:,:,:), start=begin(1:nd))
          if (istat /= NF90_NOERR) call error_handler ('getting 3d var='//trim(Field%name), ncode=istat)
      case default
          call error_handler ('invalid number of dimensions in read_variable, var='//trim(Field%name))
   end select

 ! unpack values
   if (Field%do_pack) then
       if (Field%do_miss_in) then
           where (values .ne. Field%missval_in)
                 values = values*Field%pack(1) + Field%pack(2)
           elsewhere
                 values = Field%unpkd_missval_in
           endwhere
       else
           values = values*Field%pack(1) + Field%pack(2)
       endif
   endif

 end subroutine read_variable

!#######################################################################

 subroutine write_variable ( ncid, Field, values, start )
 integer,           intent(in)    :: ncid
 type(field_type),  intent(in)    :: Field
 real,              intent(inout) :: values(:,:,:)
 integer, optional, intent(in)    :: start(:)

 integer :: ndim, nd, begin(4)

 ! pack values (overwrite input data)
   if (Field%do_pack) then
       if (Field%do_miss_out) then
           where (values .ne. Field%unpkd_missval_out)
               values = nint((values-Field%pack(2))/Field%pack(1))
           elsewhere
               values = Field%missval_out
           endwhere
       else
           values = nint((values-Field%pack(2))/Field%pack(1))
       endif
   endif

 ! number of dimensions (less the time dimension)
   ndim = Field%ndim
   if (.not.Field%static) ndim = ndim-1

 ! start indices
   nd    = Field%ndim
   begin = 1
   if (present(start)) then
       nd = size(start)
       begin(1:nd) = start
   endif

   select case (ndim)
      case(1)
          istat = NF90_PUT_VAR (ncid, Field%varid_out, values(:,1,1), start=begin(1:nd))
          if (istat /= NF90_NOERR) call error_handler ('putting 1d var='//trim(Field%name), ncode=istat)
      case(2)
          istat = NF90_PUT_VAR (ncid, Field%varid_out, values(:,:,1), start=begin(1:nd))
          if (istat /= NF90_NOERR) call error_handler ('putting 2d var='//trim(Field%name), ncode=istat)
      case(3)
          istat = NF90_PUT_VAR (ncid, Field%varid_out, values(:,:,:), start=begin(1:nd))
          if (istat /= NF90_NOERR) call error_handler ('putting 3d var='//trim(Field%name), ncode=istat)
      case default
          call error_handler ('invalid number of dimensions in write_variable, var='//trim(Field%name))
   end select

 end subroutine write_variable

!#######################################################################

 subroutine compute_pres_full (pk, bk, ph, pf)
 real, intent(in)  :: pk(:), bk(:), ph(:,:,:)
 real, intent(out) :: pf(:,:,:)
 real, dimension(size(pf,1),size(pf,2))            :: dp, lpf
 real, dimension(size(pf,1),size(pf,2),size(ph,3)) :: lph
 integer :: k, nlev

 nlev = size(pf,3)
 
 ! compute p*logp at half levels
   where (ph(:,:,1) > 0.)
      lph(:,:,1) = ph(:,:,1) * log(ph(:,:,1))
   elsewhere
      lph(:,:,1) = 0.0
   endwhere
   lph(:,:,2:nlev+1) = ph(:,:,2:nlev+1) * log(ph(:,:,2:nlev+1))

! compute pressure at full levels
  do k = 1, nlev
      dp(:,:) = ph(:,:,k+1)-ph(:,:,k)
      lpf(:,:) = (lph(:,:,k+1)-lph(:,:,k))/dp(:,:) - 1.0
      pf(:,:,k) = exp((lph(:,:,k+1)-lph(:,:,k))/dp(:,:) - 1.0)
  enddo

 end subroutine compute_pres_full

!#######################################################################

 subroutine compute_height ( zsurf, temp, sphum, pfull, phalf, zfull, mask)
 real, intent(in),  dimension(:,:)   :: zsurf
 real, intent(in),  dimension(:,:,:) :: temp, sphum, pfull, phalf
 real, intent(out), dimension(:,:,:) :: zfull
 real, intent(in),  optional         :: mask(:,:,:)
 real, dimension(size(temp,1),size(temp,2)) ::  wta, wtb, vt, zb, zt, &
                                                lpb, lpt, lpf
 integer :: k
 logical :: flag

! flag for zero ptop
flag = count(phalf(:,:,1)<=0.) > 0

! vertical integration (bottom to top)
 zb(:,:) = zsurf(:,:)*GRAV
 lpb(:,:) = log(phalf(:,:,size(zfull,3)+1))
 do k = size(zfull,3), 1, -1
    lpf = log(pfull(:,:,k))
    wtb = lpb - lpf
    ! check for ptop=0
    if (k == 1 .and. flag) then
       wta = wtb
    else
       lpt = log(phalf(:,:,k))
       wta = lpf - lpt
    endif

    vt = temp(:,:,k)*(1.0+d608*sphum(:,:,k))*RDGAS ! virtual temperature * Rgas
    zt = zb + vt*(wta+wtb)
    zfull(:,:,k) = (zb + vt*wtb)/GRAV
    if (present(mask)) then
       where (mask(:,:,k) < 0.01)
          zt = GRAV*tref*(1.0-(pfull(:,:,k)/pref)**rgog)/tlapse
          zfull(:,:,k) = 0.5*(zt+zb)/GRAV
       endwhere
    endif
    zb  = zt
    lpb = lpt
 enddo

 end subroutine compute_height

!#######################################################################

end program run_pressure_interp

module bgrid_change_grid_mod

! interpolates data between grids

use bgrid_horiz_mod, only: horiz_grid_type
use         fms_mod, only: error_mesg, FATAL, WARNING, &
                           mpp_pe, mpp_root_pe
implicit none
private

 public :: change_grid

 interface change_grid
    module procedure change_grid_2d, change_grid_2flds_2d, &
                     change_grid_3d, change_grid_2flds_3d
 end interface

! Grid identifiers for the four basic horizontal grids:
!
!     TEMP_GRID = temperature (mass) grid
!     WIND_GRID = velocity (momentum) grid
!     UFLX_GRID = zonal mass flux grid; grid points are located
!                  between temperature points along the x-axis
!     VFLX_GRID = meridional mass flux grid; grid points are located
!                  between temperature points along the y-axis
!
! Grid boxes with the same (i,j) indexing have the following
! proximity to one another:
!
!         VFLX(i,j)   WIND(i,j)
!
!         TEMP(i,j)   UFLX(i,j)

 integer, parameter, public :: TEMP_GRID=101, WIND_GRID=102, &
                               UFLX_GRID=104, VFLX_GRID=105

! identifiers for the type of interpolation weighting
 integer, public, parameter :: AREA = 1, EQUAL = 2

!----------------------------------------------------------------
!------ private data -------

! indexing for interpolation weights array
  integer, parameter :: SOUTH = 1, NORTH = 2

! module variables (used between internal interfaces)
  integer :: ilb, iub, jlb, jub
  real, pointer :: weights(:,:) =>NULL()
  integer :: option

contains

!##############################################################################
! Routine to interpolate one field

subroutine change_grid_3d ( Hgrid, grid_inp, grid_out, data_inp, data_out, &
                            weight, mask_inp )

! Arguments
!    Hgrid    = horizontal grid constants
!    grid_inp = grid identifier for the input grid
!    grid_out = grid identifier for the output grid
!    data_inp = input data
!    data_out = output data
! Optional
!    weight = integer flag that type of interpolation
!               weight=AREA for area weighting (the default) or
!               weight=EQUAL for simple 4-pt (or 2pt) averaging
!    mask_inp = grid box mask (typically for step-coordinate model)

type(horiz_grid_type), intent(in) :: Hgrid
integer, intent(in)  :: grid_inp, grid_out
real,    intent(in)  :: data_inp(Hgrid%ilb:,Hgrid%jlb:,:)
real,    intent(out) :: data_out(Hgrid%ilb:,Hgrid%jlb:,:)
integer, intent(in), optional :: weight
real,    intent(in), optional :: mask_inp(Hgrid%ilb:,Hgrid%jlb:,:)

  call set_options ( Hgrid, grid_inp, grid_out, weight )

  select case (option)
    ! velocity grid to temperature grid
    case (1)
        call vel_to_tmp   ( data_inp, data_out, mask=mask_inp )
    case (2)
        call tmp_to_vel   ( data_inp, data_out, mask=mask_inp )
    case (3)
        call vflx_to_uflx ( data_inp, data_out, mask=mask_inp )
    case (4)
        call uflx_to_vflx ( data_inp, data_out, mask=mask_inp )
    case (5)
        if (present(mask_inp)) call mask_warning
        call tmp_to_uflx  ( data_inp, data_out )
    case (6)
        if (present(mask_inp)) call mask_warning
        call tmp_to_vflx  ( data_inp, data_out )
  end select

  nullify (weights)

end subroutine change_grid_3d

!##############################################################################
! Routine to interpolate two fields (on the same grid) at a time

subroutine change_grid_2flds_3d ( Hgrid, grid_inp, grid_out, data_inp1, data_inp2, &
                                         data_out1, data_out2, weight, mask_inp )

! Arguments
!    Hgrid    = horizontal grid constants
!    grid_inp = grid identifier for the input grids
!    grid_out = grid identifier for the output grids
!    data_inp1 = input data for field 1
!    data_inp2 = input data for field 2
!    data_out1 = output data for field 1
!    data_out2 = output data for field 2
! Optional
!    weight = integer flag that type of interpolation
!               weight=AREA for area weighting (the default) or
!               weight=EQUAL for simple 4-pt (or 2pt) averaging
!    mask_inp = grid box mask (typically for step-coordinate model)

type(horiz_grid_type), intent(in) :: Hgrid
integer, intent(in)  :: grid_inp, grid_out
real,    intent(in)  :: data_inp1(Hgrid%ilb:,Hgrid%jlb:,:), &
                        data_inp2(Hgrid%ilb:,Hgrid%jlb:,:)
real,    intent(out) :: data_out1(Hgrid%ilb:,Hgrid%jlb:,:), &
                        data_out2(Hgrid%ilb:,Hgrid%jlb:,:)
integer, intent(in), optional :: weight
real,    intent(in), optional :: mask_inp(Hgrid%ilb:,Hgrid%jlb:,:)

  call set_options ( Hgrid, grid_inp, grid_out, weight )

  select case (option)
    ! velocity grid to temperature grid
    case (1)
        call vel_to_tmp   ( data_inp1, data_out1, data_inp2, data_out2, mask=mask_inp )
    case (2)
        call tmp_to_vel   ( data_inp1, data_out1, data_inp2, data_out2, mask=mask_inp )
    case (3)
        call vflx_to_uflx ( data_inp1, data_out1, data_inp2, data_out2, mask=mask_inp )
    case (4)
        call uflx_to_vflx ( data_inp1, data_out1, data_inp2, data_out2, mask=mask_inp )
    case (5)
        if (present(mask_inp)) call mask_warning
        call tmp_to_uflx  ( data_inp1, data_out1, data_inp2, data_out2 )
    case (6)
        if (present(mask_inp)) call mask_warning
        call tmp_to_vflx  ( data_inp1, data_out1, data_inp2, data_out2 )
  end select

  nullify (weights)

end subroutine change_grid_2flds_3d

!##############################################################################
! ############## private grid-to-grid interpolation interfaces ##############
!##############################################################################

subroutine vel_to_tmp ( idat1, odat1, idat2, odat2, mask )
real,    intent(in)  :: idat1(ilb:,jlb:,:)
real,    intent(out) :: odat1(ilb:,jlb:,:)
real,    intent(in),  optional :: idat2(ilb:,jlb:,:)
real,    intent(out), optional :: odat2(ilb:,jlb:,:)
real,    intent(in),  optional :: mask (ilb:,jlb:,:)

integer :: i, j, k
real, dimension(ilb:iub) :: savg1, navg1, savg2, navg2, smask, nmask

!--------------------------------------------------------------------
! velocity grid to temperature grid
! south and west boundaries not computed
!----------------------------------------

   do k = 1, size(idat1,3)

      ! compute x-average along southernmost row before starting j-loop
      do i = ilb+1, iub
         savg1(i) = idat1(i-1,jlb,k)+idat1(i,jlb,k)
      enddo
      if (present(idat2)) then
         do i = ilb+1, iub
            savg2(i) = idat2(i-1,jlb,k)+idat2(i,jlb,k)
         enddo
      endif
      if (present(mask)) then
         do i = ilb+1, iub
            smask(i) = (mask(i-1,jlb,k)+mask(i,jlb,k))*0.25
         enddo
      endif

      ! loop over latitudes
      do j = jlb+1, jub

         ! compute x-average for north boxes in 4pt average
         do i = ilb+1, iub
            navg1(i) = idat1(i-1,j,k)+idat1(i,j,k)
         enddo
         if (present(idat2)) then
            do i = ilb+1, iub
               navg2(i) = idat2(i-1,j,k)+idat2(i,j,k)
            enddo
         endif
         if (present(mask)) then
            do i = ilb+1, iub
               nmask(i) = (mask(i-1,j,k)+mask(i,j,k))*0.25
            enddo
         endif

         ! compute 4pt average - then update south average with north average
         do i = ilb+1, iub
            odat1(i,j,k) = savg1(i) * weights(j,SOUTH) + &
                           navg1(i) * weights(j,NORTH)
            savg1(i) = navg1(i)
         enddo
         if (present(idat2)) then
            do i = ilb+1, iub
               odat2(i,j,k) = savg2(i) * weights(j,SOUTH) + &
                              navg2(i) * weights(j,NORTH)
               savg2(i) = navg2(i)
            enddo
         endif
         ! apply weighting for masked grid boxes
         if (present(mask)) then
            do i = ilb+1, iub
               if (smask(i)+nmask(i) > 0.) then
                   odat1(i,j,k) = odat1(i,j,k)/(smask(i)+nmask(i))
                   if (present(idat2)) odat2(i,j,k) = odat2(i,j,k)/(smask(i)+nmask(i))
               else
                   odat1(i,j,k) = 0.
                   if (present(idat2)) odat2(i,j,k) = 0.
               endif
               smask(i) = nmask(i)
            enddo
         endif

      enddo ! end j-loop
   enddo ! end k-loop

 ! bogus data at non-computed grid boxes
   odat1(:,jlb,:) = 1.e20
   odat1(ilb,:,:) = 1.e20
   if (present(odat2)) then
       odat2(:,jlb,:) = 1.e20
       odat2(ilb,:,:) = 1.e20
   endif

end subroutine vel_to_tmp

!##############################################################################

subroutine tmp_to_vel ( idat1, odat1, idat2, odat2, mask )
real,    intent(in)  :: idat1(ilb:,jlb:,:)
real,    intent(out) :: odat1(ilb:,jlb:,:)
real,    intent(in),  optional :: idat2(ilb:,jlb:,:)
real,    intent(out), optional :: odat2(ilb:,jlb:,:)
real,    intent(in),  optional :: mask (ilb:,jlb:,:)

integer :: i, j, k
real, dimension(ilb:iub) :: savg1, navg1, savg2, navg2, smask, nmask

!--------------------------------------------------------------------
! temperature grid to velocity grid
! north and east boundaries not computed

   do k = 1, size(idat1,3)

      ! compute x-average along southernmost row before starting j-loop
      do i = ilb, iub-1
         savg1(i) = idat1(i,jlb,k)+idat1(i+1,jlb,k)
      enddo
      if (present(idat2)) then
         do i = ilb, iub-1
            savg2(i) = idat2(i,jlb,k)+idat2(i+1,jlb,k)
         enddo
      endif
      if (present(mask)) then
         do i = ilb, iub-1
            smask(i) = (mask(i,jlb,k)+mask(i+1,jlb,k))*0.25
         enddo
      endif

      ! loop over latitudes
      do j = jlb, jub-1

         ! compute x-average for north boxes in 4pt average
         do i = ilb, iub-1
            navg1(i) = idat1(i,j+1,k)+idat1(i+1,j+1,k)
         enddo
         if (present(idat2)) then
            do i = ilb, iub-1
               navg2(i) = idat2(i,j+1,k)+idat2(i+1,j+1,k)
            enddo
         endif
         if (present(mask)) then
            do i = ilb, iub-1
               nmask(i) = (mask(i,j+1,k)+mask(i+1,j+1,k))*0.25
            enddo
         endif

         ! compute 4pt average - then update south average with north average
         do i = ilb, iub-1
            odat1(i,j,k) = savg1(i) * weights(j,SOUTH) + &
                           navg1(i) * weights(j,NORTH)
            savg1(i) = navg1(i)
         enddo
         if (present(idat2)) then
            do i = ilb, iub-1
               odat2(i,j,k) = savg2(i) * weights(j,SOUTH) + &
                              navg2(i) * weights(j,NORTH)
               savg2(i) = navg2(i)
            enddo
         endif
         ! apply weighting for masked grid boxes
         if (present(mask)) then
            do i = ilb, iub-1
               if (smask(i)+nmask(i) > 0.) then
                   odat1(i,j,k) = odat1(i,j,k)/(smask(i)+nmask(i))
                   if (present(idat2)) odat2(i,j,k) = odat2(i,j,k)/(smask(i)+nmask(i))
               else
                   odat1(i,j,k) = 0.
                   if (present(idat2)) odat2(i,j,k) = 0.
               endif
               smask(i) = nmask(i)
            enddo
         endif

      enddo ! end j-loop
   enddo ! end k-loop

 ! bogus data at non-computed grid boxes
   odat1(:,jub,:) = 1.e20
   odat1(iub,:,:) = 1.e20
   if (present(odat2)) then
       odat2(:,jub,:) = 1.e20
       odat2(iub,:,:) = 1.e20
   endif

end subroutine tmp_to_vel

!##############################################################################

subroutine vflx_to_uflx ( idat1, odat1, idat2, odat2, mask )
real,    intent(in)  :: idat1(ilb:,jlb:,:)
real,    intent(out) :: odat1(ilb:,jlb:,:)
real,    intent(in),  optional :: idat2(ilb:,jlb:,:)
real,    intent(out), optional :: odat2(ilb:,jlb:,:)
real,    intent(in),  optional :: mask (ilb:,jlb:,:)

integer :: i, j, k
real, dimension(ilb:iub) :: savg1, navg1, savg2, navg2, smask, nmask

!--------------------------------------------------------------------
! velocity grid to temperature grid
! south and east boundaries not computed
!----------------------------------------

   do k = 1, size(idat1,3)

      ! compute x-average along southernmost row before starting j-loop
      do i = ilb, iub-1
         savg1(i) = idat1(i,jlb,k)+idat1(i+1,jlb,k)
      enddo
      if (present(idat2)) then
         do i = ilb, iub-1
            savg2(i) = idat2(i,jlb,k)+idat2(i+1,jlb,k)
         enddo
      endif
      if (present(mask)) then
         do i = ilb, iub-1
            smask(i) = (mask(i,jlb,k)+mask(i+1,jlb,k))*0.25
         enddo
      endif

      ! loop over latitudes
      do j = jlb+1, jub

         ! compute x-average for north boxes in 4pt average
         do i = ilb, iub-1
            navg1(i) = idat1(i,j,k)+idat1(i+1,j,k)
         enddo
         if (present(idat2)) then
            do i = ilb, iub-1
               navg2(i) = idat2(i,j,k)+idat2(i+1,j,k)
            enddo
         endif
         if (present(mask)) then
            do i = ilb, iub-1
               nmask(i) = (mask(i,j,k)+mask(i+1,j,k))*0.25
            enddo
         endif

         ! compute 4pt average - then update south average with north average
         do i = ilb, iub-1
            odat1(i,j,k) = savg1(i) * weights(j,SOUTH) + &
                           navg1(i) * weights(j,NORTH)
            savg1(i) = navg1(i)
         enddo
         if (present(idat2)) then
            do i = ilb, iub-1
               odat2(i,j,k) = savg2(i) * weights(j,SOUTH) + &
                              navg2(i) * weights(j,NORTH)
               savg2(i) = navg2(i)
            enddo
         endif
         ! apply weighting for masked grid boxes
         if (present(mask)) then
            do i = ilb, iub-1
               if (smask(i)+nmask(i) > 0.) then
                   odat1(i,j,k) = odat1(i,j,k)/(smask(i)+nmask(i))
                   if (present(idat2)) odat2(i,j,k) = odat2(i,j,k)/(smask(i)+nmask(i))
               else
                   odat1(i,j,k) = 0.
                   if (present(idat2)) odat2(i,j,k) = 0.
               endif
               smask(i) = nmask(i)
            enddo
         endif

      enddo ! end j-loop
   enddo ! end k-loop

 ! bogus data at non-computed grid boxes
   odat1(:,jlb,:) = 1.e20
   odat1(iub,:,:) = 1.e20
   if (present(odat2)) then
       odat2(:,jlb,:) = 1.e20
       odat2(iub,:,:) = 1.e20
   endif

end subroutine vflx_to_uflx

!##############################################################################

subroutine uflx_to_vflx ( idat1, odat1, idat2, odat2, mask )
real,    intent(in)  :: idat1(ilb:,jlb:,:)
real,    intent(out) :: odat1(ilb:,jlb:,:)
real,    intent(in),  optional :: idat2(ilb:,jlb:,:)
real,    intent(out), optional :: odat2(ilb:,jlb:,:)
real,    intent(in),  optional :: mask (ilb:,jlb:,:)

integer :: i, j, k
real, dimension(ilb:iub) :: savg1, navg1, savg2, navg2, smask, nmask

!--------------------------------------------------------------------
! uflx points to vflx points
! north and west boundaries are not computed

   do k = 1, size(idat1,3)

      ! compute x-average along southernmost row before starting j-loop
      do i = ilb+1, iub
         savg1(i) = idat1(i-1,jlb,k)+idat1(i,jlb,k)
      enddo
      if (present(idat2)) then
         do i = ilb+1, iub
            savg2(i) = idat2(i-1,jlb,k)+idat2(i,jlb,k)
         enddo
      endif
      if (present(mask)) then
         do i = ilb+1, iub
            smask(i) = (mask(i-1,jlb,k)+mask(i,jlb,k))*0.25
         enddo
      endif

      ! loop over latitudes
      do j = jlb, jub-1

         ! compute x-average for north boxes in 4pt average
         do i = ilb+1, iub
            navg1(i) = idat1(i-1,j+1,k)+idat1(i,j+1,k)
         enddo
         if (present(idat2)) then
            do i = ilb+1, iub
               navg2(i) = idat2(i-1,j+1,k)+idat2(i,j+1,k)
            enddo
         endif
         if (present(mask)) then
            do i = ilb+1, iub
               nmask(i) = (mask(i-1,j+1,k)+mask(i,j+1,k))*0.25
            enddo
         endif

         ! compute 4pt average - then update south average with north average
         do i = ilb+1, iub
            odat1(i,j,k) = savg1(i) * weights(j,SOUTH) + &
                           navg1(i) * weights(j,NORTH)
            savg1(i) = navg1(i)
         enddo
         if (present(idat2)) then
            do i = ilb+1, iub
               odat2(i,j,k) = savg2(i) * weights(j,SOUTH) + &
                              navg2(i) * weights(j,NORTH)
               savg2(i) = navg2(i)
            enddo
         endif
         ! apply weighting for masked grid boxes
         if (present(mask)) then
            do i = ilb+1, iub
               if (smask(i)+nmask(i) > 0.) then
                   odat1(i,j,k) = odat1(i,j,k)/(smask(i)+nmask(i))
                   if (present(idat2)) odat2(i,j,k) = odat2(i,j,k)/(smask(i)+nmask(i))
               else
                   odat1(i,j,k) = 0.
                   if (present(idat2)) odat2(i,j,k) = 0.
               endif
               smask(i) = nmask(i)
            enddo
         endif

      enddo ! end j-loop
   enddo ! end k-loop

 ! bogus data at non-computed grid boxes
   odat1(:,jub,:) = 1.e20
   odat1(ilb,:,:) = 1.e20
   if (present(odat2)) then
       odat2(:,jub,:) = 1.e20
       odat2(ilb,:,:) = 1.e20
   endif

end subroutine uflx_to_vflx

!##############################################################################

subroutine tmp_to_uflx ( idat1, odat1, idat2, odat2 )
real,    intent(in)  :: idat1(ilb:,jlb:,:)
real,    intent(out) :: odat1(ilb:,jlb:,:)
real,    intent(in),  optional :: idat2(ilb:,jlb:,:)
real,    intent(out), optional :: odat2(ilb:,jlb:,:)

integer :: i, j, k
real, dimension(ilb:iub) :: avg1, avg2

!--------------------------------------------------------------------
! temperature points to uflx points
! east boundary not computed

   do k = 1, size(odat1,3)
      do j = jlb, jub

         do i = ilb, iub-1
            avg1(i) = (idat1(i,j,k)+idat1(i+1,j,k))*0.5
         enddo
         do i = ilb, iub-1
            odat1(i,j,k) = avg1(i)
         enddo
         if (present(idat2)) then
            do i = ilb, iub-1
               avg2(i) = (idat2(i,j,k)+idat2(i+1,j,k))*0.5
            enddo
            do i = ilb, iub-1
               odat2(i,j,k) = avg2(i)
            enddo
         endif

      enddo ! end j-loop
   enddo ! end k-loop

 ! bogus data at non-computed grid boxes
   odat1(iub,:,:) = 1.e20
   if (present(odat2)) odat2(iub,:,:) = 1.e20

end subroutine tmp_to_uflx

!##############################################################################

subroutine tmp_to_vflx ( idat1, odat1, idat2, odat2 )
real,    intent(in)  :: idat1(ilb:,jlb:,:)
real,    intent(out) :: odat1(ilb:,jlb:,:)
real,    intent(in),  optional :: idat2(ilb:,jlb:,:)
real,    intent(out), optional :: odat2(ilb:,jlb:,:)

integer :: i, j, k
real, dimension(jlb:jub) :: avg1, avg2

!--------------------------------------------------------------------
! temperature points to vflx points
! north boundary not computed

   do k = 1, size(idat1,3)
      do i = ilb, iub

         do j = jlb, jub-1
            avg1(j) = (idat1(i,j  ,k)*weights(j,SOUTH) + &
                       idat1(i,j+1,k)*weights(j,NORTH))*2.0
         enddo
         do j = jlb, jub-1
            odat1(i,j,k) = avg1(j)
         enddo
         if (present(idat2)) then
            do j = jlb, jub-1
               avg2(j) = (idat2(i,j  ,k)*weights(j,SOUTH) + &
                          idat2(i,j+1,k)*weights(j,NORTH))*2.0
            enddo
            do j = jlb, jub-1
               odat2(i,j,k) = avg2(j)
            enddo
         endif

      enddo ! end i-loop
   enddo ! end k-loop

 ! bogus data at non-computed grid boxes
   odat1(:,jub,:) = 1.e20
   if (present(odat2)) odat1(:,jub,:) = 1.e20

end subroutine tmp_to_vflx

!##############################################################################

subroutine set_options ( Hgrid, grid_inp, grid_out, weight )
type(horiz_grid_type), intent(in) :: Hgrid
integer, intent(in)  :: grid_inp, grid_out
integer, intent(in), optional :: weight
logical :: use_area_weight

  option = 0
! valid 4pt interpolations
  if (  grid_inp == WIND_GRID .and. grid_out == TEMP_GRID ) option = 1
  if (  grid_inp == TEMP_GRID .and. grid_out == WIND_GRID ) option = 2
  if (  grid_inp == VFLX_GRID .and. grid_out == UFLX_GRID ) option = 3
  if (  grid_inp == UFLX_GRID .and. grid_out == VFLX_GRID ) option = 4
! valid 2pt interpolations
  if (  grid_inp == TEMP_GRID .and. grid_out == UFLX_GRID ) option = 5
  if (  grid_inp == TEMP_GRID .and. grid_out == VFLX_GRID ) option = 6
! error condition (no need to check later)
  if (option == 0) &
      call error_mesg ('change_grid', 'invalid grid change specified', FATAL)

! weighting flag (area or equal weighting of grid boxes)
  use_area_weight = .true.
  if (present(weight)) then
     if (weight == AREA) then
         use_area_weight = .true.
     else if (weight == EQUAL) then
         use_area_weight = .false.
     else
         call error_mesg ('change_grid', 'invalid value of area_weight', FATAL)
     endif
  endif

! assign pointer for weighting
! will nullify after averaging
  if (use_area_weight) then
     if (option == 1 .or. option == 3) weights => Hgrid%Interp%tmpwts
     if (option == 2 .or. option == 4) weights => Hgrid%Interp%velwts
     if (option == 5)                  weights => Hgrid%Interp%nowts
     if (option == 6)                  weights => Hgrid%Interp%velwts
  else
     weights => Hgrid%Interp%nowts
  endif

! horizontal array limits
  ilb = Hgrid%ilb;  iub = Hgrid%iub
  jlb = Hgrid%jlb;  jub = Hgrid%jub

end subroutine set_options

!##############################################################################
! prints warning message that mask was not used

subroutine mask_warning
   if (mpp_pe() == mpp_root_pe()) &
       call error_mesg ('bgrid_change_grid', 'optional mask argument &
              &not used for this type of grid interpolation', WARNING)
end subroutine mask_warning

!##############################################################################
! overloaded interfaces
!----------------------------------------------------

subroutine change_grid_2d ( Hgrid, grid_inp, grid_out, data_inp, data_out, weight )
type(horiz_grid_type), intent(in) :: Hgrid
integer, intent(in)  :: grid_inp, grid_out
real,    intent(in)  :: data_inp(Hgrid%ilb:,Hgrid%jlb:)
real,    intent(out) :: data_out(Hgrid%ilb:,Hgrid%jlb:)
integer, intent(in), optional :: weight
real :: idat3(size(data_inp,1),size(data_inp,2),1)
real :: odat3(size(data_out,1),size(data_out,2),1)

  idat3(:,:,1) = data_inp
  call change_grid_3d ( Hgrid, grid_inp, grid_out, idat3, odat3, weight )
  data_out = odat3(:,:,1)

end subroutine change_grid_2d

!----------------------------------------------------

subroutine change_grid_2flds_2d ( Hgrid, grid_inp, grid_out, data_inp1, data_inp2, &
                                         data_out1, data_out2, weight )
type(horiz_grid_type), intent(in) :: Hgrid
integer, intent(in)  :: grid_inp, grid_out
real,    intent(in)  :: data_inp1(Hgrid%ilb:,Hgrid%jlb:), &
                        data_inp2(Hgrid%ilb:,Hgrid%jlb:)
real,    intent(out) :: data_out1(Hgrid%ilb:,Hgrid%jlb:), &
                        data_out2(Hgrid%ilb:,Hgrid%jlb:)
integer, intent(in), optional :: weight
real :: idat1_3d(size(data_inp1,1),size(data_inp1,2),1)
real :: idat2_3d(size(data_inp2,1),size(data_inp2,2),1)
real :: odat1_3d(size(data_out1,1),size(data_out1,2),1)
real :: odat2_3d(size(data_out2,1),size(data_out2,2),1)

  idat1_3d(:,:,1) = data_inp1
  idat2_3d(:,:,1) = data_inp2
  call change_grid_2flds_3d ( Hgrid, grid_inp, grid_out, idat1_3d, idat2_3d, &
                               odat1_3d, odat2_3d, weight )
  data_out1 = odat1_3d(:,:,1)
  data_out2 = odat2_3d(:,:,1)

end subroutine change_grid_2flds_2d

!##############################################################################

end module bgrid_change_grid_mod

module MG_microp_3D_mod

  ! --- external modules ---

  use              fms_mod, only :  file_exist, open_namelist_file, close_file,    &
                                    error_mesg, FATAL, check_nml_error
  use     time_manager_mod, only :  time_type, get_time, set_date

  implicit none


  ! --- available public interfaces ---
  public  MG_microp_3D_init, MG_microp_3D, MG_microp_3D_end
        
contains

! NULL routines return error if called but not compiled for clubb
subroutine MG_microp_3D_init(axes,Time,idim,jdim,kdim)

  ! --- calling arguments ---
  integer, intent (in)        :: axes(4)          ! x,y,z,z_half axes types
  integer, intent (in)        :: idim,jdim,kdim   ! dimensions
  type(time_type), intent(in) :: Time             ! time
    call error_mesg('MG_microp_3D_init','Not compiled with -DCLUBB',FATAL)
end subroutine MG_microp_3D_init
!##############################################################################


!##############################################################################
subroutine MG_microp_3D( Time, is, ie, js, je, lon, lat, dtcloud,              &
                         pfull3d, phalf3d, zhalf3d, LAND,                      &
                         T3d, qv3d, ql3d, qi3d, qa3d, qn3d, qni3d, ahuco3d,    &
                         dcond_ls_liquid, dcond_ls_ice,                        &
                         Ndrop_act_CLUBB, Icedrop_act_CLUBB,                   &
                         ndust, rbar_dust,                                     &
                         ST3d, SQ3d, SL3d, SI3d, SA3d, SN3d, SNi3d,            &
                         rain3d, snow3d, surfrain, surfsnow,                   &
                         do_clubb,  qcvar_clubb, MASK3d,                       &
                         lsc_snow, lsc_rain, lsc_snow_size, lsc_rain_size )

  ! --- calling arguments ---
  type(time_type), intent (in)                         :: Time
  integer, intent (in)                                 :: is,ie,js,je
  real, intent (in),    dimension(:,:)                 :: lon,lat
  real, intent (in)                                    :: dtcloud
  real, intent (in),    dimension(:,:,:)               :: pfull3d,phalf3d
  real, intent (in),    dimension(:,:,:)               :: zhalf3d
  real, intent (in),    dimension(:,:)                 :: LAND
  real, intent (in),    dimension(:,:,:)               :: T3d,qv3d,ql3d,qi3d,qa3d,qn3d,qni3d
  real, intent (in),    dimension(:,:,:)               :: ahuco3d
  real, intent (in),    dimension(:,:,:)               :: dcond_ls_liquid,dcond_ls_ice
  real, intent (in),    dimension(:,:,:)               :: Ndrop_act_CLUBB,Icedrop_act_CLUBB
  real, intent (in),    dimension(:,:,:)               :: ndust, rbar_dust
  real, intent (out),   dimension(:,:,:)               :: ST3d,SQ3d,SL3d,SI3d,SA3d,SN3d,SNi3d
  real, intent (out),   dimension(:,:,:)               :: rain3d,snow3d
  real, intent (out),   dimension(:,:)                 :: surfrain,surfsnow

  integer, intent (in),  optional                      :: do_clubb
  real, intent (in),  optional, dimension(:,:,:)       :: qcvar_clubb
  real, intent (in),  optional, dimension(:,:,:)       :: MASK3d
  real, intent (out), optional, dimension(:,:,:)       :: lsc_snow,      &
                                                          lsc_rain,      &
                                                          lsc_snow_size, &
                                                          lsc_rain_size
    call error_mesg('MG_microp_3D','Not compiled with -DCLUBB',FATAL)
end subroutine MG_microp_3D
!##############################################################################


!##############################################################################
subroutine MG_microp_3D_end()
    call error_mesg('MG_microp_3D_end','Not compiled with -DCLUBB',FATAL)
end subroutine MG_microp_3D_end
!##############################################################################

end module MG_microp_3D_mod

module ocean_frazil_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen Griffies 
!</CONTACT>
!
!<CONTACT EMAIL="Russell.Fiedler@csiro.au"> R.A.S. Fiedler
!</CONTACT>
!
!<CONTACT EMAIL="David.Jackett@csiro.au"> David Jackett
!</CONTACT>
!
!<OVERVIEW>
! This module computes the heating of seawater due to 
! frazil ice formation.
!</OVERVIEW>
!
!<DESCRIPTION>
! Frazil can generally form at any vertical level, although 
! it is common for climate models to assume it is formed 
! only at k=1.  In this case, pressure is assumed to be 
! atmospheric for purposes of computing the freezing 
! temperature of seawater.  
!
! The freezing temperature of seawater is computed one of two 
! possible ways: 
!
! (1) simple way uses a linear function of salinity
! and assumes zero (i.e. atmospheric) pressure,
!
! tfreeze(deg C) = a1*salinity(psu)
! with a1 = -0.054 
!
! (2) accurate way uses a nonlinear function of 
! salinity(psu) and gauge pressure(dbar), where 
! gauge pressure=absolute pressure - 10.1325 dbar.
!
! tfreeze (deg C) = tf_num/tf_den
! tf_num  =  a0 + s*(a1 + sqrt(s)*(a2 + sqrt(s)*a3)) + p*(a4 + p*(a5 + s*a6)) 
! tf_dem  =  b0 + p*(b1 + p*b2) + s*s*sqrt(s)*b3
!
! check value : fp_theta(35,200,'air-sat')  = -2.076426227617581 deg C
!               fp_theta(35,200,'air-free') = -2.074408175943127 deg C
!
! This method results in a more accurate freezing 
! temperature than the simpler approach.  It is also 
! important for ice-shelf modelling to include a 
! pressure dependence when the shelf penetrates
! into the water column. 
!
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! IOC, SCOR and IAPSO, 2010: The international thermodynamic equation of 
! seawater - 2010: Calculation and use of thermodynamic properties.  
! Intergovernmental Oceanographic Commission, Manuals and Guides No. 56,
! UNESCO (English), 196 pp.  Available from http://www.TEOS-10.org.
! See sections 3.33 and 3.34 of this TEOS-10 Manual.
! </REFERENCE>
!
! <REFERENCE>
! "Updated algorithms for density, potential temperature,
! conservative temperature and freezing temperature of 
! seawater", Jackett, McDougall, Feistel, Wright, and Griffies
! Journal of Atmospheric and Oceanic Technology, in press 2005. 
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_frazil_nml">
!
!<DATA NAME="use_this_module" TYPE="logical">
! If true, then compute frazil heating. 
!</DATA> 
!<DATA NAME="debug_this_module" TYPE="logical">
! For debugging this module
!</DATA> 
!
!<DATA NAME="frazil_factor" UNITS="dimensionless" TYPE="real">
! This factor accounts for possibly different time stepping used 
! in the sea ice model relative to the ocean model.  If sea-ice 
! and ocean use same time stepping schemes, then frazil_factor=1.0.
! If sea-ice uses a twolevel scheme and ocean a threelevel leap-frog,
! then frazil_factor=0.5. Default is 1.0 since the GFDL sea ice model 
! SIS uses  a two-level time stepping scheme and MOM defaults to 
! a staggered two-level scheme. 
!</DATA> 
!
!<DATA NAME="freezing_temp_simple" TYPE="logical">
! To use the simplified freezing point temperature of seawater,
! as used in MOM4.0. 
! </DATA> 
!<DATA NAME="freezing_temp_accurate_preteos10" TYPE="logical">
! To use the accurate freezing point temperature of seawater,
! which is a nonlinear function of salinity and pressure. 
!</DATA> 
!<DATA NAME="freezing_temp_accurate_teos10" TYPE="logical">
! To use the accurate freezing point temperature of seawater 
! according to TEOS-10, which is a nonlinear function of  
! salinity and pressure. 
! This equation is recommended for use with ice-shelf modelling.  
!</DATA> 
!
!<DATA NAME="frazil_only_in_surface" TYPE="logical">
! For typical case where compute frazil heating only in 
! the surface grid cell.  Will assume the gauge 
! pressure is zero in this case when computing freezing
! temperature.  
!</DATA> 
!
!</NAMELIST>

use constants_mod,     only: epsln 
use diag_manager_mod,  only: register_diag_field
use fms_mod,           only: open_namelist_file, check_nml_error, close_file
use fms_mod,           only: FATAL, NOTE, stdout, stdlog
use mpp_mod,           only: input_nml_file, mpp_error 
use mpp_domains_mod,   only: mpp_global_sum, NON_BITWISE_EXACT_SUM

use ocean_domains_mod,    only: get_local_indices
use ocean_parameters_mod, only: missing_value, cp_ocean
use ocean_parameters_mod, only: TWO_LEVEL, THREE_LEVEL
use ocean_tpm_util_mod,   only: otpm_set_diag_tracer
use ocean_types_mod,      only: ocean_grid_type, ocean_domain_type, ocean_thickness_type
use ocean_types_mod,      only: ocean_time_type, ocean_time_steps_type, ocean_options_type
use ocean_types_mod,      only: ocean_prog_tracer_type, ocean_diag_tracer_type, ocean_density_type
use ocean_workspace_mod,  only: wrk1_2d, wrk1
use ocean_util_mod,       only: diagnose_2d, diagnose_3d, diagnose_sum

#if defined(ACCESS_CM) || defined(ACCESS_OM)
use auscom_ice_parameters_mod, only: pop_icediag, do_ice
use auscom_ice_mod,            only: AQICE
use auscom_ice_mod,            only: auscom_ice_formation_new
use auscom_ice_mod,            only: auscom_ice_formation_new_redist
use diag_manager_mod,          only: send_data
#endif

implicit none

private 

#include <ocean_memory.h>

logical :: module_initialized = .false.

character(len=256) :: version='CVS $$'
character(len=256) :: tagname='Tag $Name: tikal $'

type(ocean_grid_type), pointer   :: Grd =>NULL()
type(ocean_domain_type), pointer :: Dom =>NULL()

integer :: index_frazil=-1
integer :: index_temp=-1
integer :: index_salt=-1

! for FAFMIP heat tracers 
integer :: index_frazil_redist=-1
integer :: index_redist_heat  =-1

integer :: tendency
real    :: dtimer
real    :: cp_ocean_r

! for diagnostics 
logical :: used
integer :: id_frazil_2d=-1
integer :: id_frazil_3d=-1
integer :: id_frazil_3d_int_z=-1
integer :: id_total_ocean_frazil=-1
integer :: id_temp_freeze=-1
! for FAFMIP heat tracers 
integer :: id_frazil_redist_2d=-1
integer :: id_frazil_redist_3d=-1

! for ascii output
integer :: unit=6

! Fraction of air saturation 
! Now either 0 or 1. do we want to change this?
real :: saturation_fraction

! coefficients in freezing temperature with preTEOS10 
real :: a0, a1, a2, a3, a4, a5, a6
real :: b0, b1, b2, b3
real :: c1, c2

! for TEOS10 freezing temperature 
real,parameter  ::  v0 =  0.017947064327968736d0
real,parameter  ::  v1 =  -6.076099099929818d0
real,parameter  ::  v2 =   4.883198653547851d0
real,parameter  ::  v3 =  -11.88081601230542d0
real,parameter  ::  v4 =   13.34658511480257d0
real,parameter  ::  v5 =  -8.722761043208607d0
real,parameter  ::  v6 =   2.082038908808201d0
real,parameter  ::  v7 =  -7.389420998107497d0
real,parameter  ::  v8 =  -2.110913185058476d0
real,parameter  ::  v9 =   0.2295491578006229d0
real,parameter  ::  v10 = -0.9891538123307282d0
real,parameter  ::  v11 = -0.08987150128406496d0
real,parameter  ::  v12 =  0.3831132432071728d0
real,parameter  ::  v13 =  1.054318231187074d0
real,parameter  ::  v14 =  1.065556599652796d0
real,parameter  ::  v15 = -0.7997496801694032d0
real,parameter  ::  v16 =  0.3850133554097069d0
real,parameter  ::  v17 = -2.078616693017569d0
real,parameter  ::  v18 =  0.8756340772729538d0
real,parameter  ::  v19 = -2.079022768390933d0
real,parameter  ::  v20 =  1.596435439942262d0
real,parameter  ::  v21 =  0.1338002171109174d0
real,parameter  ::  v22 =  1.242891021876471d0


public compute_frazil_heating
public ocean_frazil_init
private compute_frazil_redist_heating 

! nml defaults 
logical :: use_this_module         = .false.
logical :: debug_this_module       = .false.
logical :: freezing_temp_simple    = .false.
logical :: freezing_temp_preteos10 = .false.
logical :: freezing_temp_teos10    = .false.
logical :: air_saturated_water     = .true. 
logical :: frazil_only_in_surface  = .true. 
real    :: frazil_factor           = 1.0

namelist /ocean_frazil_nml/ use_this_module, debug_this_module,                                  &
                            freezing_temp_simple, freezing_temp_preteos10, freezing_temp_teos10, &
                            frazil_factor, air_saturated_water, frazil_only_in_surface

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_frazil_init">
!
! <DESCRIPTION>
! Initialization code for the frazil diagnostic tracer.
! </DESCRIPTION>
!
subroutine ocean_frazil_init (Domain, Grid, Time, Time_steps, Ocean_options, &
                              itemp, isalt, iredist, debug)  
   
  type(ocean_domain_type),     intent(in), target   :: Domain
  type(ocean_grid_type),       intent(in), target   :: Grid
  type(ocean_time_type),       intent(in)           :: Time
  type(ocean_time_steps_type), intent(in)           :: Time_steps
  type(ocean_options_type),    intent(inout)        :: Ocean_options
  integer,                     intent(in)           :: itemp
  integer,                     intent(in)           :: isalt
  integer,                     intent(in)           :: iredist 
  logical,                     intent(in), optional :: debug

  integer :: ierr, ioun, io_status
  integer :: num_freeze
  real    :: s, sqrts, press
  real    :: tf_num, tf_den
  real    :: tfreeze, tfreeze_check 

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if (module_initialized) then
    call mpp_error(FATAL, '==>Error: ocean_frazil_mod: module already initialized')
  endif

  write( stdlogunit,'(/a/)') trim(version)

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_frazil_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_frazil_nml')
#else
  ioun = open_namelist_file()
  read  (ioun, ocean_frazil_nml,iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_frazil_nml')
  call close_file (ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit, ocean_frazil_nml)  
  write (stdlogunit, ocean_frazil_nml)

  if(.not. use_this_module) then 
      write(stdoutunit,'(a)') &
      '==>Note: NOT running with frazil. Be sure there is no frazil entry in field_table.'  
      call mpp_error(NOTE, '==>Note: ocean_frazil_mod: NOT using frazil heating.')
      Ocean_options%frazil_ice = 'Did NOT use frazil sea ice formation.'
      return 
  endif 

  if (PRESENT(debug) .and. .not. debug_this_module) then
    debug_this_module = debug
  endif 

  call mpp_error(NOTE, '==>Note from ocean_frazil_mod: USING frazil heating.')
  if(debug_this_module) then 
      write(stdoutunit,'(a)') '==>Note: running with debug_this_module=.true.'  
  endif

  num_freeze = 0
  if(freezing_temp_simple) then 
      write(stdoutunit,'(a)') &
      '==>Note: Using simple equation for seawater freezing temperature.'
      num_freeze = num_freeze + 1 
  endif
  if(freezing_temp_preteos10) then 
      write(stdoutunit,'(a)') &
      '==>Note: Using preTEOS10 equation for seawater freezing temperature.'
      if(air_saturated_water) then 
         write(stdoutunit,'(a)') &
         '==>Note: Assuming seawater is saturated w/ air for freezing temperature calculation.'
      endif 
      num_freeze = num_freeze + 1 
  endif
  if(freezing_temp_teos10) then 
      write(stdoutunit,'(a)') &
      '==>Note: Using TEOS10 equation for seawater freezing temperature.'
      if(air_saturated_water) then 
         write(stdoutunit,'(a)') &
         '==>Note: Assuming seawater is saturated w/ air for freezing temperature calculation.'
      endif 
      num_freeze = num_freeze + 1 
  endif
  if(num_freeze > 1) then 
      call mpp_error(FATAL, &
      '==>Error from ocean_frazil_mod: Choose only one freezing equation for frazil heating.')
  endif 
  if(num_freeze == 0) then 
      call mpp_error(FATAL, &
      '==>Error from ocean_frazil_mod: Choose one freezing equation for frazil heating.')
  endif 

  if(frazil_only_in_surface) then
      write(stdoutunit,'(a)') &
      'Assuming that frazil forms only in the surface(k=1) ocean grid cell.'
      write(stdoutunit,'(a)') &
      'Setting gauge pressure to zero when computing seawater freezing temperature.'
      Ocean_options%frazil_ice = 'Frazil sea ice formed through heat exchange only in ocean surface.'
  endif
  if(.not. frazil_only_in_surface) then
      if(freezing_temp_simple) then 
          call mpp_error(FATAL, &
               '==>Error from ocean_frazil_mod: Cannot choose simple freezing temp when have frazil forming at depths k > 1.')
      else 
          write(stdoutunit,'(a)') &
          'Assuming that frazil can form in any ocean grid cell, including cells beneath surface.'
          Ocean_options%frazil_ice = 'Frazil sea ice anywhere in ocean column with an accurate freezing temp equation.'
      endif
  endif

  index_frazil = otpm_set_diag_tracer('frazil',                                       &
     caller='ocean_frazil_mod/ocean_frazil_init',                                     &
     longname='frazil heating', units='J/m^2',                                        &
     conversion=1.0, offset=0.0, min_tracer=0.0, max_tracer=1.e20,                    &
     min_range=-10.0, max_range=100.0, const_init_tracer=.true.,const_init_value=0.0, &
     restart_file='ocean_frazil.res.nc' )

  ! The diagnostic tracer "frazil_redist" is only used for FAFMIP simulations.  
  if(iredist > 0) then
    write(stdoutunit,'(a)') &
    'Initializing frazil_redist heat diagnostic tracer for FAFMIP purposes.'
    index_frazil_redist = otpm_set_diag_tracer('frazil_redist',                         &
       caller='ocean_frazil_mod/ocean_frazil_init',                                     &
       longname='frazil redistributed heat field heating', units='J/m^2',               &
       conversion=1.0, offset=0.0, min_tracer=0.0, max_tracer=1.e20,                    &
       min_range=-10.0, max_range=100.0, const_init_tracer=.true.,const_init_value=0.0, &
       restart_file='ocean_frazil_redist.res.nc' )
  else
    write(stdoutunit,'(a)') &
          'NOT Initializing frazil_redist heat diagnostic tracer for FAFMIP purposes.'
  endif

  tendency          = Time_steps%tendency
  dtimer            = 1.0/(Time_steps%dtime_t + epsln)
  cp_ocean_r        = 1.0/cp_ocean
  index_salt        = isalt
  index_temp        = itemp
  index_redist_heat = iredist 

  Grd => Grid
  Dom => Domain

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Dom, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk=Grd%nk
#endif 

  write(stdoutunit,'(/a,f5.2)') '==>Note from ocean_frazil_mod: using frazil_factor= ',frazil_factor
  if(tendency ==TWO_LEVEL .and. frazil_factor==0.5) then 
      call mpp_error(FATAL,&
      '==>ocean_sbc_mod: with 2-level tendencies for MOM and SIS, set frazil_factor==1.0 ')
      write(stdoutunit,'(/a)') &
      '==>Error in ocean_sbc_mod: SIS is two-time ice level model.  You are also running'
      write(stdoutunit,'(a) ') &
      '  MOM with two-time level scheme. In this case, frazil_factor==1.0 must be set.'
      write(stdoutunit,'(a/) ')&
       '  With another ice model w/ different time stepping, set frazil_factor accordingly.'
  endif
  if(tendency ==THREE_LEVEL .and. frazil_factor==1.0) then 
      call mpp_error(FATAL,&
      '==>ocean_frazil_mod: with 3-level tendency for MOM and 2-level for SIS, set frazil_factor==.50 ')
      write(stdoutunit,'(/a)') &
      '==>Error in ocean_sbc_mod: SIS is two-time level ice model.  You are running MOM'
      write(stdoutunit,'(a) ') &
      '   with three-time level leap-frog. In this case, frazil_factor==.50 should be set.'
      write(stdoutunit,'(a/) ') &
      '   With another ice model w/ different time stepping, set frazil_factor accordingly.'
  endif


  ! coefficients in the preTEOS10 freezing point of seawater
  ! assume prognostic temperature variable is potential temp
  ! note that TEOS10 coefficients set as parameters above. 
  a0 =  2.5180516744541290e-03 
  a1 = -5.8545863698926184e-02
  a2 =  2.2979985780124325e-03
  a3 = -3.0086338218235500e-04
  a4 = -7.0023530029351803e-04
  a5 =  8.4149607219833806e-09
  a6 =  1.1845857563107403e-11

  b0 =  1.0000000000000000e+00
  b1 = -3.8493266309172074e-05
  b2 =  9.1686537446749641e-10
  b3 =  1.3632481944285909e-06

  if(air_saturated_water) then 
      saturation_fraction=1.0
      if(freezing_temp_preteos10) then 
          c1 = -2.5180516744541290e-03 
          c2 =  1.428571428571429e-05
          tfreeze_check = -2.076426227617581
      elseif(freezing_temp_teos10) then 
          c1 = 0.014289763856964d0
          c2 = 0.05700064989972d0
          tfreeze_check = -2.062635500704721
      endif
  else 
      saturation_fraction = 0.0
      c1 = 0.0
      c2 = 0.0
      if (freezing_temp_preteos10) then
          tfreeze_check = -2.074408175943127
      elseif(freezing_temp_teos10) then 
          tfreeze_check = -2.060735134187700
      endif
  endif


  if( freezing_temp_simple) then 
     a1 = -0.054
  elseif(freezing_temp_preteos10) then
     s       = 35.0
     press   = 200.0
     sqrts   = sqrt(s)
     tf_num  = a0 + s*(a1 + sqrts*(a2 + sqrts*a3)) + press*(a4 + press*(a5 + s*a6)) 
     tf_den  = b0 + press*(b1 + press*b2) + s*s*sqrts*b3 
     tfreeze = tf_num/tf_den + (c1 + s*c2) 
     write(stdoutunit,'(a,e24.16)')'Check value for freezing temperature(C) at (35psu,200dbar) = ',tfreeze 
     write(stdoutunit,'(a,e24.16)')'This value differs from published check value by ', tfreeze-tfreeze_check    
  elseif(freezing_temp_teos10 ) then
     s       = 1.e-2*35.0
     press   = 1.e-4*200.0
     sqrts   = sqrt(s)
     tfreeze =  v0 &
                + s*(v1 + sqrts*(v2 + sqrts*(v3 + sqrts*(v4 + sqrts*(v5 + v6*sqrts)))))         &
                + press*(v7 + press*(v8 + v9*press))                                            &
                + s*press*(v10 + press*(v12 + press*(v15 + v21*s)) + s*(v13 + v17*press+ v19*s) &
                + sqrts*(v11 + press*(v14 + v18*press)  + s*(v16 + v20*press+ v22*s)))         &
                - saturation_fraction*(1e-3)*(2.4 - c1*s)*(1 + c2*(1d0 - s/35.16504d0))
     write(stdoutunit,'(a,e24.16)')'Check value for freezing temperature(C) at (35psu,200dbar) = ',tfreeze
     write(stdoutunit,'(a,e24.16)')'This value differs from published check value by ', tfreeze-tfreeze_check
  endif 


  ! when ice forms only in k=1 cell, only require frazil saved as 2d field 
  id_frazil_2d = register_diag_field ('ocean_model', 'frazil_2d', Grd%tracer_axes(1:2), &
         Time%model_time, 'ocn frazil heat flux from the top level over time step', 'W/m^2', &
         missing_value=missing_value, range=(/-1.e10,1.e10/))  

  ! when ice forms at any depth, require frazil to be saved as 3d field
  id_frazil_3d = register_diag_field ('ocean_model', 'frazil_3d', Grd%tracer_axes(1:3), &
         Time%model_time, 'ocn frazil heat flux over time step', 'W/m^2',               &
         missing_value=missing_value, range=(/-1.e10,1.e10/))  
  id_frazil_3d_int_z = register_diag_field ('ocean_model', 'frazil_3d_int_z', Grd%tracer_axes(1:2), &
         Time%model_time, 'Vertical sum of ocn frazil heat flux over time step', 'W/m^2', &
         missing_value=missing_value, range=(/-1.e10,1.e10/))
  id_total_ocean_frazil = register_diag_field ('ocean_model', 'total_ocean_frazil', &
         Time%model_time, 'total ocean heating from frazil', 'Watts/1e15', &
         missing_value=missing_value, range=(/-1.e4,1.e4/))

  ! for FAFMIP frazil diagnostic tracer 
  id_frazil_redist_2d = register_diag_field ('ocean_model','frazil_redist_2d',Grd%tracer_axes(1:2), &
        Time%model_time, 'ocn frazil redist heat flux over time step (for FAFMIP)', 'W/m^2',        &
        missing_value=missing_value, range=(/-1.e10,1.e10/))
  id_frazil_redist_3d = register_diag_field ('ocean_model', 'frazil_redist_3d', Grd%tracer_axes(1:3), &
         Time%model_time, 'ocn frazil heat flux over time step (for FAFMIP)', 'W/m^2',                &
         missing_value=missing_value, range=(/-1.e10,1.e10/))  
   
  id_temp_freeze = register_diag_field ('ocean_model', 'temp_freeze', Grd%tracer_axes(1:3), &
         Time%model_time, 'freezing temperature of seawater', 'deg C',                      &
         missing_value=missing_value, range=(/-1.e10,1.e10/))  

end subroutine ocean_frazil_init  
! </SUBROUTINE> NAME="ocean_frazil_init">


!#######################################################################
! <SUBROUTINE NAME="compute_frazil_heating">
!
! <DESCRIPTION>
! Compute ocean heating due to formation of frazil-ice (Joules/m^2)
!
! Note that "frazil_factor" accounts for possibly different time 
! stepping used in ocean model and the sea ice model.  With MOM 
! using a leap-frog, and the GFDL ocean model SIS using forward,
! then frazil_factor=0.5. If use recommended tendency=twolevel 
! in MOM, then frazil_factor=1.0
!
! </DESCRIPTION>
!
subroutine compute_frazil_heating (Time, Thickness, Dens, T_prog, T_diag)

  type(ocean_time_type),        intent(in)    :: Time 
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_diag_tracer_type), intent(inout) :: T_diag(:)

  integer  :: i,j,k
  integer  :: taup1, tau
  real     :: tf_num, tf_den, tfreeze
  real     :: s, sqrts
  real     :: press 

  if(.not. use_this_module) return

#if defined(ACCESS_CM) || defined(ACCESS_OM)
  if (pop_icediag) then
!In FAFMIP runs we need to call this routine first as it is possibe to change
!the salinity.
    if(index_frazil_redist > 0) then
     call compute_frazil_redist_heating(Time, Thickness, Dens, T_prog, T_diag)
    endif 

    if ( do_ice ) then
      T_diag(index_frazil)%field = 0.0
      call auscom_ice_formation_new(Time,T_prog,Thickness, T_diag(index_frazil) )
    endif
    T_diag(index_frazil)%field=T_diag(index_frazil)%field * Grd%tmask
    if (id_frazil_2d > 0) then 
      used = send_data(id_frazil_2d, T_diag(index_frazil)%field(:,:,1)*dtimer, &
           Time%model_time, rmask=Grd%tmask(:,:,1), &
           is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
    endif
    if (id_frazil_3d > 0) then 
      used = send_data(id_frazil_3d, T_diag(index_frazil)%field(:,:,:)*dtimer, &
           Time%model_time, rmask=Grd%tmask(:,:,:), &
           is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
    endif

    if (id_frazil_3d_int_z > 0 .or. id_total_ocean_frazil > 0) then
       wrk1_2d(:,:) = 0.0
       do k=1,nk
          wrk1_2d(:,:) = wrk1_2d(:,:) +  T_diag(index_frazil)%field(:,:,k)*dtimer
       enddo
       if (id_frazil_3d_int_z > 0) then
          used = send_data(id_frazil_3d_int_z, wrk1_2d(:,:), &
               Time%model_time, rmask=Grd%tmask(:,:,1), &
               is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
       endif
       if (id_total_ocean_frazil > 0) then
        call diagnose_sum(Time, Grd, Dom, id_total_ocean_frazil, wrk1_2d, 1e-15)
       endif
    endif

    return
  endif
#endif

  taup1 = Time%taup1
  tau   = Time%tau

  if(freezing_temp_simple) then 

     k=1
      do j=jsc,jec
         do i=isc,iec 
            T_diag(index_frazil)%field(i,j,k) = 0.0
            if(Grd%tmask(i,j,k) > 0.0) then 
                tfreeze = a1*Dens%rho_salinity(i,j,k,taup1)
                if(T_prog(index_temp)%field(i,j,k,taup1) < tfreeze) then  
                    T_diag(index_frazil)%field(i,j,k) = &
                         (tfreeze-T_prog(index_temp)%field(i,j,k,taup1)) &
                         *Thickness%rho_dzt(i,j,k,taup1)*cp_ocean*frazil_factor 
                    T_prog(index_temp)%field(i,j,k,taup1) = tfreeze
                endif
            endif
#if defined(ACCESS_CM) || defined(ACCESS_OM)
            AQICE(i,j)=AQICE(i,j) - T_diag(index_frazil)%field(i,j,k)
            !'-' is required in routine ice_heatflux for merge operation.
#endif
         enddo
      enddo
      
  elseif(freezing_temp_preteos10) then  

      if(frazil_only_in_surface) then 
          k=1     
          do j=jsc,jec
             do i=isc,iec 
                T_diag(index_frazil)%field(i,j,k) = 0.0
                if(Grd%tmask(i,j,k) > 0.0) then 
                    s       = T_prog(index_salt)%field(i,j,k,taup1)              
                    sqrts   = sqrt(s)
                    tf_num  = a0 + s*(a1 + sqrts*(a2 + sqrts*a3))
                    tf_den  = b0 + s*s*sqrts*b3 
                    tfreeze = tf_num/tf_den  + (c1 + s*c2) 
                    if(T_prog(index_temp)%field(i,j,k,taup1) < tfreeze) then 
                        T_diag(index_frazil)%field(i,j,k) = &
                             (tfreeze-T_prog(index_temp)%field(i,j,k,taup1)) &
                             *Thickness%rho_dzt(i,j,k,taup1)*cp_ocean*frazil_factor 
                        T_prog(index_temp)%field(i,j,k,taup1) = tfreeze
                    endif
                endif
#if defined(ACCESS_CM) || defined(ACCESS_OM)
                AQICE(i,j)=AQICE(i,j) - T_diag(index_frazil)%field(i,j,1)
                !'-' is required in routine ice_heatflux for merge operation.
#endif
             enddo
          enddo

      else 
#if defined(ACCESS_CM) || defined(ACCESS_OM)
       do j=jsc,jec
             do i=isc,iec
                do k=1,nk
#else
          do k=1,nk 
             do j=jsc,jec
                do i=isc,iec 
#endif
                   T_diag(index_frazil)%field(i,j,k) = 0.0
                   if(Grd%tmask(i,j,k) > 0.0) then 
                       s       = Dens%rho_salinity(i,j,k,taup1)
                       press   = Dens%pressure_at_depth(i,j,k)              
                       sqrts   = sqrt(s)
                       tf_num  = a0 + s*(a1 + sqrts*(a2 + sqrts*a3)) + press*(a4 + press*(a5 + s*a6)) 
                       tf_den  = b0 + press*(b1 + press*b2) + s*s*sqrts*b3 
                       tfreeze = tf_num/tf_den + (c1 + s*c2) 
                       if(T_prog(index_temp)%field(i,j,k,taup1) < tfreeze) then 
                           T_diag(index_frazil)%field(i,j,k) = &
                                (tfreeze-T_prog(index_temp)%field(i,j,k,taup1)) &
                                *Thickness%rho_dzt(i,j,k,taup1)*cp_ocean*frazil_factor 
                           T_prog(index_temp)%field(i,j,k,taup1) = tfreeze
                       endif
                   endif
#if defined(ACCESS_CM) || defined(ACCESS_OM)
                   AQICE(i,j)=AQICE(i,j) - T_diag(index_frazil)%field(i,j,k)
                   !'-' is required in routine ice_heatflux for merge operation.
#endif
                enddo
             enddo
          enddo

      endif

  else  ! teos10 

      if(frazil_only_in_surface) then 
          k=1
          do j=jsc,jec
             do i=isc,iec
                T_diag(index_frazil)%field(i,j,k) = 0.0
                if(Grd%tmask(i,j,k) > 0.0) then
                    s       = 1.d-2*Dens%rho_salinity(i,j,k,taup1)
                    sqrts   = sqrt(s)
                    tfreeze =  v0 &
                               + s*(v1 + sqrts*(v2 + sqrts*(v3 + sqrts*(v4 + sqrts*(v5 + v6*sqrts)))))  &
                               - saturation_fraction*(1e-3)*(2.4 - c1*s)*(1 + c2*(1.d0 - s/35.16504d0))
                    if(T_prog(index_temp)%field(i,j,k,taup1) < tfreeze) then
                        T_diag(index_frazil)%field(i,j,k) = &
                             (tfreeze-T_prog(index_temp)%field(i,j,k,taup1)) &
                             *Thickness%rho_dzt(i,j,k,taup1)*cp_ocean*frazil_factor
                        T_prog(index_temp)%field(i,j,k,taup1) = tfreeze
                    endif
                endif
             enddo
          enddo

      else

         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  T_diag(index_frazil)%field(i,j,k) = 0.0
                  if(Grd%tmask(i,j,k) > 0.0) then
                     s       = 1.d-2*Dens%rho_salinity(i,j,k,taup1)
                     sqrts   = sqrt(s)
                     press   = Dens%pressure_at_depth(i,j,k)              
                     tfreeze =  v0 &
                                + s*(v1 + sqrts*(v2 + sqrts*(v3 + sqrts*(v4 + sqrts*(v5 + v6*sqrts)))))         &
                                + press*(v7 + press*(v8 + v9*press))                                            &
                                + s*press*(v10 + press*(v12 + press*(v15 + v21*s)) + s*(v13 + v17*press+ v19*s) &
                                + sqrts*(v11 + press*(v14 + v18*press)  + s*(v16 + v20*press+ v22*s)))          &
                                - saturation_fraction*(1e-3)*(2.4 - c1*s)*(1 + c2*(1d0 - s/35.16504d0))
                     if(T_prog(index_temp)%field(i,j,k,taup1) < tfreeze) then
                         T_diag(index_frazil)%field(i,j,k) = &
                              (tfreeze-T_prog(index_temp)%field(i,j,k,taup1)) &
                              *Thickness%rho_dzt(i,j,k,taup1)*cp_ocean*frazil_factor
                         T_prog(index_temp)%field(i,j,k,taup1) = tfreeze
                     endif
                  endif
               enddo
            enddo
         enddo
     endif

  endif  ! endif for freezing_temp_simple


  if (id_frazil_2d > 0) then
     call diagnose_2d(Time, Grd, id_frazil_2d, T_diag(index_frazil)%field(:,:,1)*dtimer)
  endif
  if (id_frazil_3d > 0) then
     call diagnose_3d(Time, Grd, id_frazil_3d, T_diag(index_frazil)%field(:,:,:)*dtimer)
  endif
  if (id_frazil_3d_int_z > 0 .or. id_total_ocean_frazil > 0) then
     wrk1_2d(:,:) = 0.0
     do k=1,nk
        wrk1_2d(:,:) = wrk1_2d(:,:) +  T_diag(index_frazil)%field(:,:,k)*dtimer
     enddo
     if (id_frazil_3d_int_z > 0) then
        call diagnose_2d(Time, Grd, id_frazil_3d_int_z, wrk1_2d(:,:))
     end if
     if (id_total_ocean_frazil > 0) then
        call diagnose_sum(Time, Grd, Dom, id_total_ocean_frazil, wrk1_2d, 1e-15)
     end if
  endif

  if(id_temp_freeze > 0) then 
     wrk1(:,:,:) =0.0
     if(freezing_temp_simple) then 
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec 
                 wrk1(i,j,k) = a1*T_prog(index_salt)%field(i,j,k,taup1)*Grd%tmask(i,j,k)
              enddo
           enddo
        enddo
     else 
        do k=1,nk 
           do j=jsc,jec
              do i=isc,iec 
                 if(Grd%tmask(i,j,k) > 0.0) then 
                    s       = T_prog(index_salt)%field(i,j,k,taup1)
                    press   = Dens%pressure_at_depth(i,j,k)              
                    sqrts   = sqrt(s)
                    tf_num  = a0 + s*(a1 + sqrts*(a2 + sqrts*a3)) + press*(a4 + press*(a5 + s*a6)) 
                    tf_den  = b0 + press*(b1 + press*b2) + s*s*sqrts*b3 
                    wrk1(i,j,k) = tf_num/tf_den + (c1 + s*c2) 
                 endif
              enddo
           enddo
        enddo
     endif
     call diagnose_3d(Time, Grd, id_temp_freeze, wrk1(:,:,:))
  endif

  if(index_frazil_redist > 0) then
     call compute_frazil_redist_heating(Time, Thickness, Dens, T_prog, T_diag)
  endif 

end subroutine compute_frazil_heating
! </SUBROUTINE> NAME="compute_frazil_heating">


!#######################################################################
! <SUBROUTINE NAME="compute_frazil_redist_heating">
!
! <DESCRIPTION>
! Compute ocean heating due to formation of frazil-ice (Joules/m^2)
! for the FAFMIP redistributed heat tracer.  
!
! Note that "frazil_factor" accounts for possibly different time 
! stepping used in ocean model and the sea ice model.  With MOM 
! using a leap-frog, and the GFDL ocean model SIS using forward,
! then frazil_factor=0.5. If use recommended tendency=twolevel 
! in MOM, then frazil_factor=1.0
!
! Note: unsure if the ACCESS ifedf options have been properly
! handled. Need ACCESS developers to check.  
! </DESCRIPTION>
!
subroutine compute_frazil_redist_heating (Time, Thickness, Dens, T_prog, T_diag)

  type(ocean_time_type),        intent(in)    :: Time 
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_diag_tracer_type), intent(inout) :: T_diag(:)

  integer  :: i,j,k
  integer  :: taup1, tau
  real     :: tf_num, tf_den, tfreeze
  real     :: s, sqrts
  real     :: press 

  if(.not. use_this_module) return 

#if defined(ACCESS_CM) || defined(ACCESS_OM)
  if (pop_icediag) then
    if ( do_ice ) then
      T_diag(index_frazil_redist)%field = 0.0
!Saliniy is unchanged on return from this routine. 
      call auscom_ice_formation_new_redist(Time,T_prog,Thickness, T_diag(index_frazil_redist) )
    endif
    T_diag(index_frazil_redist)%field=T_diag(index_frazil_redist)%field * Grd%tmask
    if (id_frazil_redist_2d > 0) then 
      used = send_data(id_frazil_redist_2d, T_diag(index_frazil_redist)%field(:,:,1)*dtimer, &
           Time%model_time, rmask=Grd%tmask(:,:,1), &
           is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
    endif
    if (id_frazil_redist_3d > 0) then 
      used = send_data(id_frazil_redist_3d, T_diag(index_frazil_redist)%field(:,:,:)*dtimer, &
           Time%model_time, rmask=Grd%tmask(:,:,:), &
           is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
    endif
  
    return
  endif
#endif

  taup1 = Time%taup1
  tau   = Time%tau

  if(freezing_temp_simple) then 

     k=1
      do j=jsc,jec
         do i=isc,iec 
            T_diag(index_frazil_redist)%field(i,j,k) = 0.0
            if(Grd%tmask(i,j,k) > 0.0) then 
                tfreeze = a1*Dens%rho_salinity(i,j,k,taup1)
                if(T_prog(index_redist_heat)%field(i,j,k,taup1) < tfreeze) then  
                    T_diag(index_frazil_redist)%field(i,j,k) = &
                         (tfreeze-T_prog(index_redist_heat)%field(i,j,k,taup1)) &
                         *Thickness%rho_dzt(i,j,k,taup1)*cp_ocean*frazil_factor 
                    T_prog(index_redist_heat)%field(i,j,k,taup1) = tfreeze
                endif
            endif
         enddo
      enddo

  elseif(freezing_temp_preteos10) then  

      if(frazil_only_in_surface) then 
          k=1     
          do j=jsc,jec
             do i=isc,iec 
                T_diag(index_frazil_redist)%field(i,j,k) = 0.0
                if(Grd%tmask(i,j,k) > 0.0) then 
                    s       = T_prog(index_salt)%field(i,j,k,taup1)              
                    sqrts   = sqrt(s)
                    tf_num  = a0 + s*(a1 + sqrts*(a2 + sqrts*a3))
                    tf_den  = b0 + s*s*sqrts*b3 
                    tfreeze = tf_num/tf_den  + (c1 + s*c2) 
                    if(T_prog(index_redist_heat)%field(i,j,k,taup1) < tfreeze) then 
                        T_diag(index_frazil_redist)%field(i,j,k) = &
                             (tfreeze-T_prog(index_redist_heat)%field(i,j,k,taup1)) &
                             *Thickness%rho_dzt(i,j,k,taup1)*cp_ocean*frazil_factor 
                        T_prog(index_redist_heat)%field(i,j,k,taup1) = tfreeze
                    endif
                endif
             enddo
          enddo

      else 
#if defined(ACCESS_CM) || defined(ACCESS_OM)
       do j=jsc,jec
             do i=isc,iec
                do k=1,nk
#else
          do k=1,nk 
             do j=jsc,jec
                do i=isc,iec 
#endif
                   T_diag(index_frazil_redist)%field(i,j,k) = 0.0
                   if(Grd%tmask(i,j,k) > 0.0) then 
                       s       = Dens%rho_salinity(i,j,k,taup1)
                       press   = Dens%pressure_at_depth(i,j,k)              
                       sqrts   = sqrt(s)
                       tf_num  = a0 + s*(a1 + sqrts*(a2 + sqrts*a3)) + press*(a4 + press*(a5 + s*a6)) 
                       tf_den  = b0 + press*(b1 + press*b2) + s*s*sqrts*b3 
                       tfreeze = tf_num/tf_den + (c1 + s*c2) 
                       if(T_prog(index_redist_heat)%field(i,j,k,taup1) < tfreeze) then 
                           T_diag(index_frazil_redist)%field(i,j,k) = &
                                (tfreeze-T_prog(index_redist_heat)%field(i,j,k,taup1)) &
                                *Thickness%rho_dzt(i,j,k,taup1)*cp_ocean*frazil_factor 
                           T_prog(index_redist_heat)%field(i,j,k,taup1) = tfreeze
                       endif
                   endif
                enddo
             enddo
          enddo

      endif

  else  ! teos10 

      if(frazil_only_in_surface) then 
          k=1
          do j=jsc,jec
             do i=isc,iec
                T_diag(index_frazil_redist)%field(i,j,k) = 0.0
                if(Grd%tmask(i,j,k) > 0.0) then
                    s       = 1.d-2*Dens%rho_salinity(i,j,k,taup1)
                    sqrts   = sqrt(s)
                    tfreeze =  v0 &
                               + s*(v1 + sqrts*(v2 + sqrts*(v3 + sqrts*(v4 + sqrts*(v5 + v6*sqrts)))))  &
                               - saturation_fraction*(1e-3)*(2.4 - c1*s)*(1 + c2*(1.d0 - s/35.16504d0))
                    if(T_prog(index_redist_heat)%field(i,j,k,taup1) < tfreeze) then
                        T_diag(index_frazil_redist)%field(i,j,k) = &
                             (tfreeze-T_prog(index_redist_heat)%field(i,j,k,taup1)) &
                             *Thickness%rho_dzt(i,j,k,taup1)*cp_ocean*frazil_factor
                        T_prog(index_redist_heat)%field(i,j,k,taup1) = tfreeze
                    endif
                endif
             enddo
          enddo

      else

         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  T_diag(index_frazil_redist)%field(i,j,k) = 0.0
                  if(Grd%tmask(i,j,k) > 0.0) then
                     s       = 1.d-2*Dens%rho_salinity(i,j,k,taup1)
                     sqrts   = sqrt(s)
                     press   = Dens%pressure_at_depth(i,j,k)              
                     tfreeze =  v0 &
                                + s*(v1 + sqrts*(v2 + sqrts*(v3 + sqrts*(v4 + sqrts*(v5 + v6*sqrts)))))         &
                                + press*(v7 + press*(v8 + v9*press))                                            &
                                + s*press*(v10 + press*(v12 + press*(v15 + v21*s)) + s*(v13 + v17*press+ v19*s) &
                                + sqrts*(v11 + press*(v14 + v18*press)  + s*(v16 + v20*press+ v22*s)))          &
                                - saturation_fraction*(1e-3)*(2.4 - c1*s)*(1 + c2*(1d0 - s/35.16504d0))
                     if(T_prog(index_redist_heat)%field(i,j,k,taup1) < tfreeze) then
                         T_diag(index_frazil_redist)%field(i,j,k) = &
                              (tfreeze-T_prog(index_redist_heat)%field(i,j,k,taup1)) &
                              *Thickness%rho_dzt(i,j,k,taup1)*cp_ocean*frazil_factor
                         T_prog(index_redist_heat)%field(i,j,k,taup1) = tfreeze
                     endif
                  endif
               enddo
            enddo
         enddo
     endif

  endif  ! endif for freezing_temp_simple


  if (id_frazil_redist_2d > 0) then
     call diagnose_2d(Time, Grd, id_frazil_redist_2d, T_diag(index_frazil_redist)%field(:,:,1)*dtimer)
  endif
  if (id_frazil_redist_3d > 0) then
     call diagnose_3d(Time, Grd, id_frazil_redist_3d, T_diag(index_frazil_redist)%field(:,:,:)*dtimer)
  endif
 

end subroutine compute_frazil_redist_heating
! </SUBROUTINE> NAME="compute_frazil_redist_heating">


     
end module ocean_frazil_mod

module land_constants_mod

use constants_mod, only : rdgas, rvgas, wtmair

implicit none
private

! ==== public interfaces =====================================================
integer, public, parameter :: &
     NBANDS   = 2, & ! number of spectral bands for short-wave radiation calculations
     BAND_VIS = 1, & ! visible radiation (wavelenght range?)
     BAND_NIR = 2    ! near infra-red radiation (wavelenght range?)

real, public, parameter :: d622 = rdgas/rvgas
real, public, parameter :: d378 = 1.0-d622
real, public, parameter :: d608 = d378/d622

real, public, parameter :: Rugas = 8.314472 ! universal gas constant, J K-1 mol-1

real, public, parameter :: seconds_per_year = 86400.0*365.0
real, public, parameter :: mol_C = 12.0e-3 ! molar mass of carbon, kg
real, public, parameter :: mol_air = wtmair/1000.0 ! molar mass of air, kg
real, public, parameter :: mol_CO2 = 44.00995e-3 ! molar mass of CO2,kg
real, public, parameter :: mol_h2o = 18.0e-3 ! molar mass of water, kg
! ==== end of public interfaces ==============================================

! ==== module constants ======================================================
character(len=*), parameter :: &
     version = '$Id: land_constants.F90,v 17.0 2009/07/21 03:02:18 fms Exp $', &
     tagname = '$Name: tikal $'

end module

module bgrid_horiz_diff_mod

!=======================================================================
!
!                    linear horizontal mixing
!               with option for any order accuracy
!
!=======================================================================

use mpp_mod, only: input_nml_file 
use bgrid_horiz_mod      , only: horiz_grid_type
use bgrid_masks_mod      , only: grid_mask_type
use bgrid_prog_var_mod   , only: prog_var_type, var_init
use bgrid_halo_mod       , only: update_halo, vel_flux_boundary, &
                                 EAST, NORTH, NOPOLE, POLEONLY,  &
                                 TEMP, UWND, VWND
use bgrid_change_grid_mod, only: change_grid, TEMP_GRID, WIND_GRID

use         fms_mod, only:  error_mesg, FATAL, write_version_number,         &
                            open_namelist_file, check_nml_error, close_file, &
                            mpp_clock_id, mpp_clock_begin, mpp_clock_end,    &
                            MPP_CLOCK_SYNC, CLOCK_MODULE, file_exist,        &
                            mpp_pe, mpp_root_pe, uppercase, stdlog
use   constants_mod, only:  RADIUS

use  field_manager_mod, only: MODEL_ATMOS, parse
use tracer_manager_mod, only: query_method, get_tracer_names, get_number_tracers

implicit none
private

!--------- public interfaces ----------

public   horiz_diff, horiz_diff_init

!-----------------------------------------------------------------------
!  namelist bgrid_horiz_diff_nml

!  damp_scheme_wind   Determines how horizontal damping coefficients
!  damp_scheme_temp    vary with latitude.  Possible values are: 0,1,2,3.
!                  [0 = no damping; 1 = coeff are uniform with latitude;
!                       2 = coeffs vary as 1/(dx**2+dy**2);
!                       3 = coeffs vary as 1/(dx**2);
!                       4 = same as scheme 1 but with scheme 2 applied
!                       poleward of reflat]
!                      Notes: Schemes 2-4 provide increased damping in
!                      higher latitudes. Temperature and tracers are 
!                      controlled using "damp_scheme_temp".

   integer :: damp_scheme_temp = 1
   integer :: damp_scheme_wind = 1

!  reflat       Latitude cutoff (in degrees) at which increased
!               high latitude damping is applied.  Equatorward of
!               this latitude uniform damping (scheme=1) is applied;
!               poleward of this latitude enhanced damping (scheme=2)
!               is applied.  This variable is only used when
!               damp_scheme_wind=4 or damp_scheme_temp=4.

   real :: reflat = 85.
 
!  damp_order_wind      The horizontal damping order for momentum,
!  damp_order_temp       temperature, and default order for all 
!  damp_order_tracer     prognostic tracers. Only even numbers are allowed.

   integer :: damp_order_wind   = 4   ! use: 0, 2, 4,....
   integer :: damp_order_temp   = 4
   integer :: damp_order_tracer = 4

!  damp_coeff_wind      The horizontal damping coefficients for
!  damp_coeff_temp        momentum, temperature, and default value for
!  damp_coeff_tracer      all prognostic tracers. Only positive values
!                         are allowed.

   real    :: damp_coeff_wind   = 0.35  
   real    :: damp_coeff_temp   = 0.35  
   real    :: damp_coeff_tracer = 0.35

!  slope_corr_wind      The topography slope correction for horizontal
!  slope_corr_temp        damping of momentum, temperature, and default
!  slope_corr_tracer      for all prognostic tracers. 

   real, dimension(4) :: slope_corr_wind   = (/0.,0.,0.,0./)
   real, dimension(4) :: slope_corr_temp   = (/0.,0.,0.,0./)
   real, dimension(4) :: slope_corr_tracer = (/0.,0.,0.,0./)

namelist /bgrid_horiz_diff_nml/ damp_scheme_temp, damp_scheme_wind,      &
                    damp_order_wind, damp_order_temp, damp_order_tracer, &
                    damp_coeff_wind, damp_coeff_temp, damp_coeff_tracer, &
                    slope_corr_wind, slope_corr_temp, slope_corr_tracer, &
                    reflat

!-----------------------------------------------------------------------
!--------- private data ----------

! control parameters for horizontal damping
! set via the namelist or field table
 type hdiff_control_type
     integer, pointer :: order(:) =>NULL()
     real   , pointer :: coeff(:) =>NULL()
     real   , pointer :: slope(:,:) =>NULL()
     logical, pointer :: do_slope_adj(:) =>NULL()
     logical       :: do_damping, do_slope_adj_temp
     integer       :: damping_scheme_wind, damping_scheme_temp
     real, dimension(:),   pointer :: areahx =>NULL(), &
                                      areahy =>NULL(), &
                                      areavx =>NULL(), &
                                      areavy => NULL()
     real, dimension(:,:), pointer :: wth => NULL(), &
                                      wtv =>NULL()
 end type hdiff_control_type

 type(hdiff_control_type), save :: Control

 integer  :: nlev ! number of model levels

 character(len=128) :: version='$Id: bgrid_horiz_diff.F90,v 19.0 2012/01/06 19:54:01 fms Exp $'
 character(len=128) :: tagname='$Name: tikal $'
 logical :: do_log = .true.

!  timing data
 integer :: id_total
 logical :: do_clock_init = .true.

!-----------------------------------------------------------------------

contains

!#######################################################################

 subroutine horiz_diff ( Hgrid, Masks, nplev, dt, dpde, pres, Var, Var_dt )

!-----------------------------------------------------------------------
!
!   Hgrid  = horizontal grid constants
!   Masks  = grid masking constants for eta coordinate
!   nplev  = number of "pure" pressure levels at the top of the model
!   dt     = adjustment time step
!   dpde   = pressure weight for model layers
!   pres   = pressure at full model levels
!   Var    = prognostic variables at the last updated time level
!   Var_dt = tendency of prognostic variables since the last
!            updated time level
!
!-----------------------------------------------------------------------

type(horiz_grid_type), intent(inout)  :: Hgrid
type (grid_mask_type),    intent(in)  :: Masks

integer,                intent(in)    :: nplev
  real,                 intent(in)    :: dt
  real,                 intent(in)    :: dpde(Hgrid%ilb:,Hgrid%jlb:,:),&
                                         pres(Hgrid%ilb:,Hgrid%jlb:,:)
  type (prog_var_type), intent(in)    :: Var
  type (prog_var_type), intent(inout) :: Var_dt

!-----------------------------------------------------------------------

  real, dimension(Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub,       &
                  size(dpde,3)) :: hkew3, hkns3, hkew, hkns, &
                                   hcew, hcns, dat, vdat, hdac

  real, dimension(Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub, &
                     size(dpde,3),3) :: pterms

  real    :: dt_inv, hsign, xcoeff, ycoeff
  integer :: i, j, k, n, is, ie, js, je, ntp

!=======================================================================
!  --- should damping be done ??? ----

   if ( .not. Control%do_damping    ) return
   if ( Control%damping_scheme_wind+Control%damping_scheme_temp == 0 ) return
   call mpp_clock_begin (id_total)

!-----------------------------------------------------------------------
!       --- check the horizontal dimensions of the input array ---

      nlev = size(dpde,3)

    if (size(dpde,1) /= Hgrid%isize .or.               &
        size(dpde,2) /= Hgrid%jsize ) call error_mesg  &
       ('bgrid_horiz_diff', 'input array has the wrong dimensions.', FATAL)

!   ---- time step related values ----

    dt_inv  = 1./dt

!   ---- initialize flux weights ----

    hkew3 = 0.0;  hkns3 = 0.0

!-----------------------------------------------------------------------
!-------------setup temperature and tracer damping ---------------------
!-----------------------------------------------------------------------
   ntp = count( Control%order(1:Var_dt%ntrace) > 0 )
   if (Control%order(0) > 0 .or. ntp > 0) then

      ! compute grid indiecs
      is = Hgrid%Tmp%is;  ie = Hgrid%Tmp%ie
      js = Hgrid%Tmp%js;  je = Hgrid%Tmp%je

      do j = js, je
         hdac(:,j,:) = Hgrid%Tmp%rarea(j)
      enddo
      do k = nplev+1, nlev
      do j = js, je
         hdac(:,j,k) = hdac(:,j,k) / (2.0*dpde(:,j,k))
      enddo
      enddo

!     ----- mass-weighted fluxes -----
      do j = js-1, je
         hkew3(:,j,1:nplev) = Control%areahx(j)
         hkns3(:,j,1:nplev) = Control%areahy(j)
      enddo

      do k = nplev+1, nlev
      do j = js-1, je
      do i = is-1, ie
         hkew3(i,j,k) = Control%areahx(j) * (dpde(i,j,k)+dpde(i+1,j,k))
         hkns3(i,j,k) = Control%areahy(j) * (dpde(i,j,k)+dpde(i,j+1,k))
      enddo
      enddo
      enddo

!     ----- mask out fluxes below step-mountain ----

    if (.not.Masks%sigma) then
       do k = 1, nlev
       do j = js-1, je
       do i = is-1, ie
          hkew3(i,j,k) = hkew3(i,j,k)*Masks%Tmp%mask(i,j,k)*Masks%Tmp%mask(i+1,j,k)
          hkns3(i,j,k) = hkns3(i,j,k)*Masks%Tmp%mask(i,j,k)*Masks%Tmp%mask(i,j+1,k)
       enddo
       enddo
       enddo
          hdac(:,js:je,:) = hdac(:,js:je,:) * Masks%Tmp%mask(:,js:je,:)
    endif

!-----------------------------------------------------------------------
!----- slope adjustment ------------------------------------------------

      if ( Control % do_slope_adj_temp ) then
         call slope_correction_init ( Hgrid, Masks, nplev, pres, pterms )
      else
         hcew = 0.0
         hcns = 0.0
      endif

!-----------------------------------------------------------------------
!------------------temperature damping----------------------------------

      if (Control%order(0) > 0) then

         ! setting up flux weights - limit to 1/8
         do k = 1, nlev
         do j = Hgrid%jlb, Hgrid%jub
            xcoeff = min(0.125,Control%coeff(0)*Control%wth(j,1))
            ycoeff = min(0.125,Control%coeff(0)*Control%wth(j,2))
            hkew(:,j,k) = hkew3(:,j,k) * xcoeff
            hkns(:,j,k) = hkns3(:,j,k) * ycoeff
         enddo
         enddo

         dat  = Var%t + dt*Var_dt%t
!        --- slope adjustent ---
         if ( Control%do_slope_adj(0) ) &
         call slope_correction ( Hgrid, Masks, nplev, Control%slope(:,0), &
                                 pterms, dat, hcew, hcns )
         call diff_mass (Hgrid, dat, hcew, hcns, hkew, hkns, hdac,  &
                         Control%order(0))
         hsign = 1.; if (mod(Control%order(0),4) == 0) hsign = -1.
         Var_dt%t = Var_dt%t + hsign * dt_inv * dat

      endif

!-----------------------------------------------------------------------
!------------ tracer damping (prognostic tracers only) ---------------

      if (ntp > 0) then

         do n = 1, Var_dt%ntrace

            ! setting up flux weights - limit to 1/8
            do k = 1, nlev
            do j = Hgrid%jlb, Hgrid%jub
               xcoeff = min(0.125,Control%coeff(n)*Control%wth(j,1))
               ycoeff = min(0.125,Control%coeff(n)*Control%wth(j,2))
               hkew(:,j,k) = hkew3(:,j,k) * xcoeff
               hkns(:,j,k) = hkns3(:,j,k) * ycoeff
            enddo
            enddo

            if (Control%order(n) == 0) cycle
            dat  = Var%r(:,:,:,n) + dt*Var_dt%r(:,:,:,n)
           !--- slope adjustent ---
            if ( Control%do_slope_adj(n) ) &
            call slope_correction ( Hgrid, Masks, nplev, Control%slope(:,n), &
                                    pterms, dat, hcew, hcns )
            call diff_mass (Hgrid, dat, hcew, hcns, hkew, hkns, &
                            hdac, Control%order(n))
            hsign = 1.; if (mod(Control%order(n),4) == 0) hsign = -1.
            Var_dt%r(:,:,:,n) = Var_dt%r(:,:,:,n) + hsign * dt_inv * dat
         enddo

      endif

   endif
!-----------------------------------------------------------------------
!***********************************************************************
!-----------------setup momentum damping -------------------------------

   if (Control%order(-1) > 0) then

      is = Hgrid%Vel%is;  ie = Hgrid%Vel%ie
      js = Hgrid%Vel%js;  je = Hgrid%Vel%je

      call change_grid (Hgrid, TEMP_GRID, WIND_GRID, &
                        dpde(:,:,nplev+1:nlev), vdat(:,:,nplev+1:nlev))
      call update_halo (Hgrid, UWND, vdat(:,:,nplev+1:nlev), &
                        halos=EAST+NORTH, flags=NOPOLE)

      do j = js, je
         hdac(:,j,:) = Hgrid%Vel%rarea(j)
      enddo
      do k = nplev+1, nlev
         hdac(:,js:je,k) = hdac(:,js:je,k) / (2.*vdat(:,js:je,k))
      enddo

!     ----- mass-weighted fluxes -----
      do j = js, je+1
         hkew3(:,j,1:nplev) = Control%areavx(j)
         hkns3(:,j,1:nplev) = Control%areavy(j)
      enddo

      do k = nplev+1, nlev
      do j = js, je+1
      do i = is, ie+1
         hkew3(i,j,k) = Control%areavx(j)*(vdat(i,j,k)+vdat(i-1,j,k))
         hkns3(i,j,k) = Control%areavy(j)*(vdat(i,j,k)+vdat(i,j-1,k))
      enddo
      enddo
      enddo

!     ----- mask out fluxes below step-mountain ----

    if (.not.Masks%sigma) then
       do k = 1, nlev
       do j = js, je+1
       do i = is, ie+1
          hkew3(i,j,k) = hkew3(i,j,k)*Masks%Vel%mask(i,j,k)*Masks%Vel%mask(i-1,j,k)
          hkns3(i,j,k) = hkns3(i,j,k)*Masks%Vel%mask(i,j,k)*Masks%Vel%mask(i,j-1,k)
       enddo
       enddo
       enddo
          hdac(:,js:je,:) = hdac(:,js:je,:) * Masks%Tmp%mask(:,js:je,:)
    endif

!-----------------------------------------------------------------------
!----- slope adjustment setup ------

    if ( Control % do_slope_adj(-1) ) then
!      ---- pressure at velocity points ----
       vdat(:,:,1:nplev) = pres(:,:,1:nplev)
       call change_grid ( Hgrid, TEMP_GRID, WIND_GRID, &
                          pres(:,:,nplev+1:nlev), vdat(:,:,nplev+1:nlev) )
       call update_halo (Hgrid, UWND, vdat(:,:,nplev+1:nlev), &
                                        halos=EAST+NORTH, flags=NOPOLE)

       call vel_slope_correction_init ( Hgrid, Masks, nplev, &
                                        Control%slope(:,-1), &
                                        vdat, pterms         )
    endif

!-----------------------------------------------------------------------

      ! setting up flux weights - limit to 1/8
      do k = 1, nlev
      do j = js, je+1
         xcoeff = min(0.125,Control%coeff(-1)*Control%wtv(j,1))
         ycoeff = min(0.125,Control%coeff(-1)*Control%wtv(j,2))
         hkew(:,j,k) = hkew3(:,j,k) * xcoeff
         hkns(:,j,k) = hkns3(:,j,k) * ycoeff
      enddo
      enddo
      ! zero-out cross polar fluxes
      call vel_flux_boundary (Hgrid, hkns)

!-----------------------------------------------------------------------
!-------------------------momentum damping------------------------------

       dat = Var%u + dt*Var_dt%u
      vdat = Var%v + dt*Var_dt%v
      if ( Control % do_slope_adj(-1) ) then
         if (Masks%sigma) then
             call diff_vel (Hgrid, dat,vdat, hkew,hkns, hdac,  &
                            Control%order(-1), pterms)
         else
             call diff_vel (Hgrid, dat,vdat, hkew,hkns, hdac,  &
                            Control%order(-1), pterms, Masks%Vel%kbot)
         endif
      else
         call diff_vel (Hgrid, dat,vdat, hkew,hkns, hdac,  &
                        Control%order(-1))
      endif
      hsign = 1.; if (mod(Control%order(-1),4) == 0) hsign = -1.
      Var_dt%u = Var_dt%u + hsign * dt_inv *  dat
      Var_dt%v = Var_dt%v + hsign * dt_inv * vdat

   endif

   call mpp_clock_end (id_total)

!-----------------------------------------------------------------------

 end subroutine horiz_diff

!#######################################################################
!#######################################################################

 subroutine diff_mass (Hgrid, rdat, hcew, hcns, hkew, hkns, hdac, &
                       order)

!----------------------------------------------------------------------
!
!        diff_mass is a private interface that performs multiple
!        2nd order lapacians.
!
!----------------------------------------------------------------------

   type(horiz_grid_type), intent(inout) :: Hgrid
   integer, intent(in)    :: order
   real   , intent(inout), dimension(Hgrid%ilb:Hgrid%iub, &
                                     Hgrid%jlb:Hgrid%jub, &
                                     nlev) :: rdat
   real   , intent(in),    dimension(Hgrid%ilb:Hgrid%iub, &
                                     Hgrid%jlb:Hgrid%jub, &
                                     nlev) :: hcew, hcns, &
                                              hkew, hkns, hdac

!----------------------------------------------------------------------
!  hcew, hcns are weighted corrections to the diffusive fluxes for
!  sloping sigma surfaces
!----------------------------------------------------------------------

   real, dimension(Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub) :: &
              rew, rns
   integer :: i, j, k, n, is, ie, js, je, nordr

!-----------------------------------------------------------------------

   is = Hgrid%Tmp%is;  ie = Hgrid%Tmp%ie
   js = Hgrid%Tmp%js;  je = Hgrid%Tmp%je

!-----------------------------------------------------------------------
!------------loop for order of damping scheme-------------------------

   do n = 1, order/2

        do k = 1, nlev

!------------------contributions (fluxes) ------------------------------

     if ( n == 1 ) then
        do j = js-1, je
        do i = is-1, ie
           rew(i,j) = (rdat(i+1,j,k)-rdat(i,j,k)+hcew(i,j,k))*hkew(i,j,k)
           rns(i,j) = (rdat(i,j+1,k)-rdat(i,j,k)+hcns(i,j,k))*hkns(i,j,k)
        enddo
        enddo
     else
        do j = js-1, je
        do i = is-1, ie
           rew(i,j) = (rdat(i+1,j,k)-rdat(i,j,k))*hkew(i,j,k)
           rns(i,j) = (rdat(i,j+1,k)-rdat(i,j,k))*hkns(i,j,k)
        enddo
        enddo
     endif

!-----------------------------------------------------------------------

     do j = js, je
     do i = is, ie
        rdat(i,j,k)=(rew(i,j)-rew(i-1,j)+rns(i,j)-rns(i,j-1)) &
                    *hdac(i,j,k)
     enddo
     enddo

     enddo

!-----------------------------------------------------------------------
!---- update all halo rows ? ----
!   do not update on last pass, halos will updated in the main program

     if ( n < order/2 ) then
         call update_halo (Hgrid, TEMP, rdat)
     endif

!-----------------------------------------------------------------------

   enddo

!-----------------------------------------------------------------------

 end subroutine diff_mass

!#######################################################################

 subroutine diff_vel (Hgrid, udat, vdat, vkew, vkns, hdac, order, terms, kbot)

!----------------------------------------------------------------------
!
!        diff_vel is a private interface that performs multiple
!        2nd order lapacians for the momentum components.
!
!----------------------------------------------------------------------

   type(horiz_grid_type), intent(inout) :: Hgrid
   integer, intent(in)    :: order
   real   , intent(inout), dimension(Hgrid%ilb:Hgrid%iub, &
                                     Hgrid%jlb:Hgrid%jub, &
                                     nlev) :: udat, vdat
   real   , intent(in),    dimension(Hgrid%ilb:Hgrid%iub, &
                                     Hgrid%jlb:Hgrid%jub, &
                                     nlev) :: vkew, vkns, hdac
   real   , intent(in),    dimension(Hgrid%ilb:Hgrid%iub, &
                                     Hgrid%jlb:Hgrid%jub, &
                                     nlev, 3), optional :: terms
   integer, intent(in),    dimension(Hgrid%ilb:Hgrid%iub,  &
                                     Hgrid%jlb:Hgrid%jub), &
                                               optional :: kbot

!----------------------------------------------------------------------

   real, dimension(Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub) ::  &
              uew, uns, vew, vns, dudp, dvdp, ucew, ucns, vcew, vcns
   integer :: i, j, k, n, is, ie, js, je, k1, k2

!-----------------------------------------------------------------------

   is = Hgrid%Vel%is;  ie = Hgrid%Vel%ie
   js = Hgrid%Vel%js;  je = Hgrid%Vel%je

!------------loop for order of damping scheme---------------------------

   do n = 1, order/2

      do k = 1, nlev

!------------------contributions (fluxes) ------------------------------

      if ( n == 1 .and. present(terms) ) then

        k1 = max(k-1,1)
        if (present(kbot)) then
           do j = Hgrid%jlb, Hgrid%jub
           do i = Hgrid%ilb, Hgrid%iub
              k2 = min(k+1,kbot(i,j))
              dudp(i,j) = (udat(i,j,k2)-udat(i,j,k1))*terms(i,j,k,1)
              dvdp(i,j) = (vdat(i,j,k2)-vdat(i,j,k1))*terms(i,j,k,1)
           enddo
           enddo
        else
           k2 = min(k+1,nlev)
           dudp(:,:) = (udat(:,:,k2)-udat(:,:,k1))*terms(:,:,k,1)
           dvdp(:,:) = (vdat(:,:,k2)-vdat(:,:,k1))*terms(:,:,k,1)
        endif

        do j = js, je+1
        do i = is, ie+1
!          ---- slope correction terms ----
           ucew(i,j) = (dudp(i,j)+dudp(i-1,j))*terms(i,j,k,2)
           ucns(i,j) = (dudp(i,j)+dudp(i,j-1))*terms(i,j,k,3)
           vcew(i,j) = (dvdp(i,j)+dvdp(i-1,j))*terms(i,j,k,2)
           vcns(i,j) = (dvdp(i,j)+dvdp(i,j-1))*terms(i,j,k,3)

           uew(i,j) = (udat(i,j,k)-udat(i-1,j  ,k)+ucew(i,j))*vkew(i,j,k)
           uns(i,j) = (udat(i,j,k)-udat(i  ,j-1,k)+ucns(i,j))*vkns(i,j,k)
           vew(i,j) = (vdat(i,j,k)-vdat(i-1,j  ,k)+vcew(i,j))*vkew(i,j,k)
           vns(i,j) = (vdat(i,j,k)-vdat(i  ,j-1,k)+vcns(i,j))*vkns(i,j,k)
        enddo
        enddo

      else

        do j = js, je+1
        do i = is, ie+1
           uew(i,j) = (udat(i,j,k)-udat(i-1,j  ,k))*vkew(i,j,k)
           uns(i,j) = (udat(i,j,k)-udat(i  ,j-1,k))*vkns(i,j,k)
           vew(i,j) = (vdat(i,j,k)-vdat(i-1,j  ,k))*vkew(i,j,k)
           vns(i,j) = (vdat(i,j,k)-vdat(i  ,j-1,k))*vkns(i,j,k)
        enddo
        enddo

      endif

!-----------------------------------------------------------------------
      do j = js, je
      do i = is, ie
        udat(i,j,k) = (uew(i+1,j  )-uew(i,j)+ &
                       uns(i  ,j+1)-uns(i,j))*hdac(i,j,k)
        vdat(i,j,k) = (vew(i+1,j  )-vew(i,j)+ &
                       vns(i  ,j+1)-vns(i,j))*hdac(i,j,k)
      enddo
      enddo

      enddo
!-----------------------------------------------------------------------
!---- update all halo rows ? ----
!   do not update on last pass, halos will updated in the main program

      if ( n < order/2 ) then
         call update_halo (Hgrid, UWND, udat)
         call update_halo (Hgrid, VWND, vdat)
      endif

!-----------------------------------------------------------------------

   enddo

!-----------------------------------------------------------------------

 end subroutine diff_vel

!#######################################################################

 subroutine horiz_diff_init ( Hgrid )

!-----------------------------------------------------------------------
!       initialization of horizontal damping coefficients
!-----------------------------------------------------------------------

 type(horiz_grid_type), intent(in) :: Hgrid ! horizontal grid constants

!-----------------------------------------------------------------------

real    :: eps = 1.e-6
integer :: j

 integer            :: n, nv, order, ntrace, unit, ierr, io, logunit
 real               :: coeff, slope(4)
 character(len=128) :: scheme, params, tname

!-----------------------------------------------------------------------
! read namelist
   if (file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
       read (input_nml_file, nml=bgrid_horiz_diff_nml, iostat=io)
       ierr = check_nml_error(io,'bgrid_horiz_diff_nml')
#else
       unit = open_namelist_file ( )
       ierr=1; do while (ierr /= 0)
          read (unit, nml=bgrid_horiz_diff_nml, iostat=io, end=5)
          ierr = check_nml_error (io, 'bgrid_horiz_diff_nml')
       enddo
 5     call close_file (unit)
#endif
   endif

   logunit = stdlog()
   if (do_log) then
      call write_version_number(version, tagname)
      if (mpp_pe() == mpp_root_pe()) write (logunit, nml=bgrid_horiz_diff_nml)
      do_log = .false.
   endif

   call get_number_tracers ( MODEL_ATMOS, num_prog=ntrace )

   allocate ( Control%order        (-1:ntrace), &
              Control%coeff        (-1:ntrace), &
              Control%do_slope_adj (-1:ntrace), &
              Control%slope      (4,-1:ntrace)  )

 ! defaults
   Control%order = 4
   Control%coeff = .35
   Control%slope =  0.

 ! namelist arguments
   Control%order  (-1) = damp_order_wind
   Control%coeff  (-1) = damp_coeff_wind
   Control%slope(:,-1) = slope_corr_wind

   Control%order  (0) = damp_order_temp
   Control%coeff  (0) = damp_coeff_temp
   Control%slope(:,0) = slope_corr_temp

   Control%order  (1:ntrace) = damp_order_tracer
   Control%coeff  (1:ntrace) = damp_coeff_tracer
   Control%slope(:,1:ntrace) = spread(slope_corr_tracer,2,ntrace)

 ! set the damping scheme (check for errors below)
   Control % damping_scheme_wind = damp_scheme_wind
   Control % damping_scheme_temp = damp_scheme_temp

 ! process tracer table information for horizontal damping methods
   do n = 1, ntrace
      if (query_method('diff_horiz', MODEL_ATMOS, n, scheme, params)) then
          if (uppercase(trim(scheme)) /= 'LINEAR' .and. uppercase(trim(scheme)) /= 'NONE') &
              call error_mesg  ('bgrid_horiz_diff_mod',  &
                            'invalid damping method, '//uppercase(trim(scheme)), FATAL)
          if (parse(params,'order', order) == 1) Control%order(n) = order
          if (uppercase(trim(scheme)) == 'NONE') Control%order(n) = 0
          if (parse(params,'coeff', coeff) == 1) Control%coeff(n) = coeff
          nv = parse(params,'slope', slope)
          Control%slope (1:nv,n) = slope(1:nv)
      endif
      if (mpp_pe() == mpp_root_pe()) then
         call get_tracer_names (MODEL_ATMOS, n, tname)
         write (logunit,10) n, trim(tname), Control%order(n), Control%coeff(n), Control%slope(:,n)
      10 format (i3, a24, ', Order=',i2, ', Coeff=',f10.5, ', Slope=',4f10.5)
      endif
   enddo

 ! error checking
   do n = -1, ntrace
     !-- order
      if (Control%order(n) < 0 .or. mod(Control%order(n),2) /= 0) &
          call error_mesg ('bgrid_horiz_diff_mod', 'invalid damping order', FATAL)
     !-- non-dimension, normalized coefficient
      if (Control%coeff(n) < 0. .or. Control%coeff(n) > 1.) call error_mesg &
                   ('bgrid_horiz_diff_mod', 'invalid damping coeff', FATAL)
     !-- slope correction weights
      if (minval(Control%slope(:,n)) < 0. .or. maxval(Control%slope(:,n)) > 1.) &
            call error_mesg ('bgrid_horiz_diff_mod', 'invalid slope correction coeff', FATAL)
   enddo

 ! set flags
   Control%do_damping        = maxval(Control%order) > 0
   Control%do_slope_adj_temp = .false.
   do n = -1, ntrace
     Control%do_slope_adj(n) = maxval(Control%slope(:, n)) > 1.e-6
     ! set flag for temp OR tracer slope adjustment
     if (n >= 0 .and. Control%do_slope_adj(n)) Control%do_slope_adj_temp = .true.
   enddo

!-----------------------------------------------------------------------
!----- pre-compute metric terms ------

     allocate ( Control%areahx (Hgrid%jlb:Hgrid%jub), &
                Control%areahy (Hgrid%jlb:Hgrid%jub), &
                Control%areavx (Hgrid%jlb:Hgrid%jub), &
                Control%areavy (Hgrid%jlb:Hgrid%jub), &
                Control%wth    (Hgrid%jlb:Hgrid%jub,2), &
                Control%wtv    (Hgrid%jlb:Hgrid%jub,2)  )

!    ---- areas averaged along axes ----

     do j = Hgrid%Tmp%jsd, Hgrid%Tmp%jed-1
        Control%areahx(j) = 0.5*(Hgrid%Tmp%area(j)+Hgrid%Tmp%area(j))
        Control%areahy(j) = 0.5*(Hgrid%Tmp%area(j)+Hgrid%Tmp%area(j+1))
     enddo

     do j = Hgrid%Vel%jsd+1, Hgrid%Vel%jed
        Control%areavx(j) = 0.5*(Hgrid%Vel%area(j)+Hgrid%Vel%area(j))
        Control%areavy(j) = 0.5*(Hgrid%Vel%area(j)+Hgrid%Vel%area(j-1))
     enddo


!    ---- damping weight of x and y axis varies ----
!    ---- depending which damping scheme is used ----

     call damp_scheme_init ( Hgrid, WIND_GRID, &
                             Control%damping_scheme_wind, Control%wtv )
     call damp_scheme_init ( Hgrid, TEMP_GRID, &
                             Control%damping_scheme_temp, Control%wth )

! initialize code sections for performance timing 

  if (do_clock_init) then
     id_total = mpp_clock_id ('BGRID: horiz_diff (TOTAL)', &
                      flags=MPP_CLOCK_SYNC, grain=CLOCK_MODULE)
     do_clock_init = .false. 
  endif

!-----------------------------------------------------------------------

 end subroutine horiz_diff_init

!#######################################################################

 subroutine damp_scheme_init ( Hgrid, grid, scheme, weights )
 type(horiz_grid_type), intent(in) :: Hgrid
 integer, intent(in)  :: grid, scheme
 real,    intent(out) :: weights(Hgrid%jlb:Hgrid%jub,2)
 
 real, dimension(Hgrid%jlb:Hgrid%jub) :: dx2
 real    :: dxdy2eq, dx2eq, dy2, factor2
 integer :: j
 

!    ---- damping weight of x and y axis varies ----
!    ---- depending which damping scheme is used ----
!
!      scheme 1:   equal/constant
!      scheme 2:   function of diagonal grid distance
!      scheme 3:   function of x-axis grid distance
!

  select case (scheme)

!   ---- uniform damping ----
    case (1)
       weights = 0.125

    case (2:5)
       dx2=0.0
       if (grid == TEMP_GRID) then
       do j = Hgrid%jlb, Hgrid%jub-1
             dx2(j) = Hgrid%Tmp%dx(j)**2
       enddo
             dy2 = Hgrid%Tmp%dy**2
       else if (grid == WIND_GRID) then
       do j = Hgrid%jlb+1, Hgrid%jub
             dx2(j) = Hgrid%Vel%dx(j)**2
       enddo
             dy2 = Hgrid%Vel%dy**2
       else
          ! error condition needed
       endif

       ! function of diagonal distance (poleward of reflat)
       if (scheme == 2 .or. scheme == 4) then
           factor2 = 1./cos(reflat*acos(0.)/90.)**2
           dxdy2eq = RADIUS**2*(Hgrid%dlm**2+Hgrid%dph**2)
           weights(:,1) = 0.125*max(1.,dxdy2eq/(factor2*dx2+dy2))
           if (scheme == 2) then
               weights(:,2) = weights(:,1)
           else
               weights(:,2) = 0.125
           endif
       endif

       ! function of x-distance 
       if (scheme == 3 .or. scheme == 5) then
           dx2eq = (RADIUS*Hgrid%dlm*cos(reflat*acos(0.)/90.))**2
           where (dx2 /= 0.0) weights(:,1) = 0.125*max(1.,dx2eq/dx2)
           if (scheme == 3) then
               weights(:,2) = weights(:,1)
           else
               weights(:,2) = 0.125
           endif
       endif


    case default

       call error_mesg ('bgrid_horiz_diff_mod', 'invalid damping scheme', &
                         FATAL)

  end select

 end subroutine damp_scheme_init

!#######################################################################

 subroutine slope_correction_init ( Hgrid, Masks, nplev, pres, terms )

  type(horiz_grid_type), intent(in)  :: Hgrid
  type (grid_mask_type), intent(in)  :: Masks
  integer,               intent(in)  :: nplev
  real,                  intent(in)  :: pres (Hgrid%ilb:,Hgrid%jlb:,:)
  real,                  intent(out) :: terms(Hgrid%ilb:,Hgrid%jlb:,:,:)
  integer :: i, j, k, k1, k2, nlev

!  initialization of pressure terms for the sigma slope correction
!  these pressure terms do not change between mass variables
!  may want make weight a function of variable and/or level
!      USE ONE-HALF OF SPECIFIED WEIGHT AT LOWEST LEVEL

   nlev = size(pres,3)

   do k = nplev+1, nlev
     !--- reciprocal of vert gradient ---
      k1 = max(k-1,1)
      if (Masks%sigma) then
         k2 = min(k+1,nlev)
         terms(:,:,k,1) = 1.0/(pres(:,:,k2)-pres(:,:,k1))
      else
         do j = Hgrid%jlb, Hgrid%jub
         do i = Hgrid%ilb, Hgrid%iub
            k2 = min(k+1,Masks%Tmp%kbot(i,j))
            if (k2 > k1) then
              terms(i,j,k,1) = 1.0/(pres(i,j,k2)-pres(i,j,k1))
            else
              terms(i,j,k,1) = 0.0
            endif
         enddo
         enddo
      endif

!     --- horiz gradients (flip sign) ---
      do j = Hgrid%jlb, Hgrid%jub-1
      do i = Hgrid%ilb, Hgrid%iub-1
           terms(i,j,k,2) = (pres(i,j,k)-pres(i+1,j,k))
           terms(i,j,k,3) = (pres(i,j,k)-pres(i,j+1,k))
      enddo
      enddo
   enddo

 end subroutine slope_correction_init

!#######################################################################

 subroutine vel_slope_correction_init ( Hgrid, Masks, nplev, weights, pres, terms )

  type(horiz_grid_type), intent(in)  :: Hgrid
  type (grid_mask_type), intent(in)  :: Masks
  integer,               intent(in)  :: nplev
  real,                  intent(in)  :: weights(4)
  real,                  intent(in)  :: pres (Hgrid%ilb:,Hgrid%jlb:,:)
  real,                  intent(out) :: terms(Hgrid%ilb:,Hgrid%jlb:,:,:)
  real    :: wt2
  integer :: i, j, k, k1, k2, ks, nlev, isd, ied, jsd, jed
  real :: dp(size(pres,1),size(pres,2))

!  initialization of pressure terms for the sigma slope correction
!  these pressure terms do not change between mass variables
!  may want make weight a function of variable and/or level
!      USE ONE-HALF OF SPECIFIED WEIGHT AT LOWEST LEVEL

   nlev = size(pres,3)
   isd = Hgrid%Vel%isd; ied = Hgrid%Vel%ied
   jsd = Hgrid%Vel%jsd; jed = Hgrid%Vel%jed

   do k = 1, nplev
      terms(:,:,k,:) = 0.0
   enddo

   do k = nplev+1, nlev
      k1 = max(k-1,1)
      if (Masks%sigma) then
          k2 = min(k+1,nlev)
          dp = (pres(:,:,k2)-pres(:,:,k1))
      else
          do j = Hgrid%jlb, Hgrid%jub
          do i = Hgrid%ilb, Hgrid%iub
             k2 = min(k+1,Masks%Vel%kbot(i,j))
             dp(i,j) = (pres(i,j,k2)-pres(i,j,k1))
          enddo
          enddo
      endif
     !--- reciprocal of vert gradient ---
      where (dp > 0.)
        terms(:,:,k,1) = 1.0/dp
      elsewhere
        terms(:,:,k,1) = 1.e30 ! these values should not be used where it counts
      endwhere

!     --- horiz gradients (flip sign) ---
      ks = max(1,k-nlev+4)
      wt2  = 0.5*weights(ks)
      do j = Hgrid%jlb+1, Hgrid%jub
      do i = Hgrid%ilb+1, Hgrid%iub
           terms(i,j,k,2) = wt2*(pres(i-1,j,k)-pres(i,j,k))
           terms(i,j,k,3) = wt2*(pres(i,j-1,k)-pres(i,j,k))
      enddo
      enddo
   enddo

 end subroutine vel_slope_correction_init

!#######################################################################

 subroutine slope_correction ( Hgrid, Masks, nplev, weights, terms, temp, cew, cns )

  type(horiz_grid_type), intent(in)  :: Hgrid
  type (grid_mask_type), intent(in)  :: Masks
  integer,               intent(in)  :: nplev
  real,                  intent(in)  :: weights(4)
  real,                  intent(in)  :: terms(Hgrid%ilb:,Hgrid%jlb:,:,:)
  real,                  intent(in)  :: temp (Hgrid%ilb:,Hgrid%jlb:,:)
  real,                  intent(out) :: cew  (Hgrid%ilb:,Hgrid%jlb:,:),&
                                        cns  (Hgrid%ilb:,Hgrid%jlb:,:)
  integer :: i, j, k, k1, k2, ks, nlev
  real :: wt2
  real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub) :: dtdp

!  computes weighted-corrections for the slope of sigma surfaces
!  to east-west and north-south fluxes of field temp

 ! check for no correction
   do k = 1, 4
      if (weights(k) > 1.e-6) go to 10
   enddo
   cew = 0.0; cns = 0.0
   return

10 nlev = size(temp,3)

   do k = 1, nplev
      cew(:,:,k) = 0.0
      cns(:,:,k) = 0.0
   enddo

   do k = nplev+1, nlev
      k1 = max(k-1,1)
      if (Masks%sigma) then
         k2 = min(k+1,nlev) ! one-sided derivative at surface
         dtdp(:,:) = (temp(:,:,k2)-temp(:,:,k1))*terms(:,:,k,1)
      else
         do j = Hgrid%jlb, Hgrid%jub
         do i = Hgrid%ilb, Hgrid%iub
            k2 = min(k+1,Masks%Tmp%kbot(i,j))
            dtdp(i,j) = (temp(i,j,k2)-temp(i,j,k1))*terms(i,j,k,1)
         enddo
         enddo
      endif

      ks = max(1,k-nlev+4)
      wt2  = 0.5*weights(ks)
      do j = Hgrid%jlb, Hgrid%jub-1
      do i = Hgrid%ilb, Hgrid%iub-1
           ! note: terms are grouped for reproducibility with previous version
           cew(i,j,k) = (dtdp(i,j)+dtdp(i+1,j))*(terms(i,j,k,2)*wt2)
           cns(i,j,k) = (dtdp(i,j)+dtdp(i,j+1))*(terms(i,j,k,3)*wt2)
      enddo
      enddo
   enddo

 end subroutine slope_correction

!#######################################################################

end module bgrid_horiz_diff_mod

module grids_util_mod
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">Z. Liang </CONTACT>
  ! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">S. M. Griffies</REVIEWER>


  !<OVERVIEW>
  ! <TT>grids_util_mod</TT> contains some public interface used by several modules in
  !  generate_ocean_grid package. 
  !</OVERVIEW>

  use fms_mod,       only : stdout, string
  use mpp_mod,       only : mpp_pe, mpp_npes, mpp_root_pe, mpp_error, mpp_chksum, FATAL, NOTE 
  use mpp_io_mod,    only : mpp_open, MPP_OVERWR, MPP_NETCDF, MPP_SINGLE, axistype, fieldtype
  use mpp_io_mod,    only : mpp_write_meta, mpp_write, mpp_close
  use constants_mod, only : PI

  implicit none
  private

  public :: make_axis, gcell, get_file_unit, write_field_meta, write_field_data, set_grid

  !--- public interface ------------------------------------------------
  ! <INTERFACE NAME="write_field_data">
  !   <OVERVIEW>
  !     Write data to corresponding grid file. 
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     For the purpose of generating higher resolution grid. There is a
  !     2 GB limit of each grid file. The interface will allow the grid information
  !     be stored at multiple files.
  !   </DESCRIPTION>
  !   <IN NAME="filename" TYPE= "character(len=*)">
  !    The name of the grid file to be generated. If the grid file is 
  !    over 2 GB limit, it will break into several files with file name filename,
  !    filename2, filename3 ....
  !   </IN>
  !   <IN NAME="fieldname" TYPE= "character(len=*)">
  !    name of the field to be written into the file filename
  !   </IN>
  !   <IN NAME="fielddata" TYPE= "real, dimension(:,:) or dimension(:,:,:)">
  !    data of fieldname to be written to the file filename.
  !   </IN>
  ! </INTERFACE>
  !
  interface write_field_data
     module procedure  write_field_data_2d
     module procedure  write_field_data_3d
  end interface write_field_data

  real, dimension(:), allocatable :: xt, yt, xc, yc
  integer                         :: ni, nj               ! grid size
  logical                         :: is_root_pe = .false. ! to indicate if current pe is root pe.

  real, parameter :: max_file_size = 4294967295.  !The maximum size in bytes for any one file. 
                                                  ! With NetCDF3, this  should be 2 Gb or less. 
                                                  ! the reason using real number is the maximum integer.
  real, parameter    :: tolr = 1.0e-4

  integer, parameter :: max_fields = 300    ! can be increased if needed
  integer, parameter :: max_files = 50      ! can be increased if needed
  integer            :: num_files = 0       ! if >= 0, means a series file will be created.
  integer            :: num_fields = 0      ! number of fields written to the file.


  character(len=128)   :: opened_files(0:max_files) = ''
  integer              :: files_unit(0:max_files) = 0
  type(axistype),save  :: axis_xt(0:max_files), axis_yt(0:max_files)
  type(axistype),save  :: axis_xc(0:max_files), axis_yc(0:max_files)
  type(axistype),save  :: axis_v(0:max_files)
  type(fieldtype),save :: flds(max_fields)
  character(len=128)   :: flds_name(max_fields)
  integer              :: file_num(max_fields) = -1

contains

   !#######################################################################
  ! <SUBROUTINE NAME="gcell">
  !   <OVERVIEW>
  !     grid cell construction.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     A domain is composed of one or more regions: Build "num" T cells with resolution 
  !     "deltat(n) n=1,num" within the domain composed of regions bounded by "bounds".
  !     Also construct "num" C-cells of resolution "deltau(n) n=1,num" with the relation 
  !     between T and U cells given by: deltat(n) = 0.5*(deltau(n-1) + deltau(n)).
  !     Resolution may be constant or smoothly varying within each region AND there must 
  !     be an integral number of grid cells within each region. The domain is the sum of all regions.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call gcell (maxlen, n_bounds, bounds, d_bounds, nbpts, num, deltat, deltau, stretch)
  !   </TEMPLATE>
  !   <IN NAME="maxlen" TYPE="integer" >
  !     maximum length of "deltat" and "deltau"
  !   </IN>
  !   <IN NAME="n_bounds" TYPE="integer" >
  !     number of bounds needed to define the regions
  !   </IN>
  !   <IN NAME="bounds" TYPE="real, dimension(n_bounds)" >
  !     latitude, longitude, or depth at each bound
  !   </IN>
  !   <IN NAME="d_bounds" TYPE="real, dimension(n_bounds)" >
  !     delta (resolution) at each of the "bounds"
  !   </IN>
  !   <IN NAME="nbpts" TYPE="integer" >
  !     number of extra boundary cells to add to the domain. (usually one at the beginning and end)
  !   </IN>
  !   <IN NAME="stretch" TYPE="real" >
  !     stretching factor for last region (should only be used in the vertical) to provide
  !     increased stretching of grid points. "stretch" = 1.0 gives no increased stretching.
  !     "stretch" = 1.2 gives increased stretching...etc
  !   </IN>
  !   <IN NAME="debug" TYPE="logical, optional" >
  !      flag that controls standard output.
  !   </IN>
  !   <OUT NAME="num" TYPE="integer" >
  !     total number of grid cells within the domain
  !   </OUT>
  !   <OUT NAME="deltat" TYPE="real, dimension(1-nbpts:maxlen)" >
  !     resolution of T grid cells: n=1,num
  !   </OUT>
  !   <OUT NAME="deltau" TYPE="real, dimension(1-nbpts:maxlen)" >
  !     resolution of C grid cells: n=1,num
  !   </OUT>
  ! </SUBROUTINE>
  subroutine gcell (region, bnd1, bnd2, dbnd1, dbnd2, num, ntotal, maxlen, deltau)
    integer, intent(in)             :: region
    real,    intent(in)             :: bnd1, bnd2, dbnd1, dbnd2
    integer, intent(out)            :: num
    integer, intent(in)             :: ntotal, maxlen
    real, dimension(1:maxlen), intent(out) :: deltau

    real    :: avg_res, chg_res, wid, an, err, d_new, del
    integer :: m, i

    avg_res = 0.5*(dbnd1 + dbnd2)
    chg_res = dbnd2 - dbnd1
    wid = abs(bnd2 - bnd1)
    an  = wid/avg_res
    m   = nint(an)
    err = wid - avg_res * m

    if( abs(err) > tolr ) then
       write(stdout(),*) "==>Error: non integral number of cells in region #", region, &
            ", average resolution within region =",avg_res,                            &
            ", this implies ",an," grid cells, Change grid specifications ",           &
            "via table, Here is some help..."
       if(m>1) then
          d_new = (2.0*wid)/(m-1) - dbnd1;
          write(stdout(),*) "Note: to get ",m-1," grid cells within region ",region, &
               ", change resolution from ",dbnd2," to ",d_new
       endif

       d_new = (2.0*wid)/m - dbnd1
       write(stdout(),*)"Note: to get ",m," grid cells within region ",region, &
            ", change resolution from ",dbnd2," to ",d_new      
       d_new = (2.0*wid)/(m+1) - dbnd1
       write(stdout(),*)"Note: to get ",m+1," grid cells within region ",region, &
            ", change resolution from ",dbnd2," to ",d_new

       call mpp_error(FATAL);
    endif

    if(ntotal+m > maxlen) call mpp_error(FATAL, "grids_util_mod: maxlen exceeded in gcell, "// &
                                      "increase size of maxlen in hgrid_mod or vgrid_mod")

    ! Calculate resolution of corner cells: "deltau"
    ! T grid points will be centered in these cells

    do i = 1, m
       del = avg_res - 0.5*chg_res*cos((PI/m)*(i-0.5))
       deltau(i) = del
    enddo

    num = m

    return

  end subroutine gcell

!///////////////////////////////////////////////////////////
!/
!/ Make_axis
!/ define horizontal grid resolution and axis data
!/
!///////////////////////////////////////////////////////////

subroutine make_axis(cart, maxlen, num_regions,bounds,delta,corners,centers, &
                     num, square_grid, extend_square_grid )
    character(len=1),       intent(in) :: cart
    integer,                intent(in) :: maxlen
    integer,             intent(inout) :: num_regions
    real,  dimension(:), intent(inout) :: bounds, delta
    real, dimension(0:), intent(inout) :: corners, centers
    integer,             intent(inout) :: num
    logical,                intent(in) :: square_grid, extend_square_grid

  integer:: i, n, m, ii
  real   :: delta_corners(maxlen)

  if(cart == 'Y') then  
     if(square_grid) then
        call iso_grid (maxlen, num_regions, bounds, delta, num, corners, centers, extend_square_grid)
        return
     endif
   endif

   !--- bounds should increase monotonically
   do n = 2, num_regions
      if( bounds(n-1) .gt. bounds(n)) then
         do m=1,num_regions
            write (stdout(),'(i3,f10.5)') m, bounds(m)
         end do
         call mpp_error(FATAL, &
              ' grids_util_mod: longitude boundaries with cart = '// cart //&
              'do not increase monotonically ')
      endif
   enddo

  num = 0;
  do n = 2, num_regions
    write(stdout(),*) " region # ",n," going from ",bounds(n-1)," (res=",delta(n-1), &
           ") to ",bounds(n)," (res=",delta(n),")"
    
    call gcell (n, bounds(n-1), bounds(n), delta(n-1), delta(n), m, num, maxlen, delta_corners)

    !*********************************************************************
    !   Build the grid points on a "B" grid. The T and C
    !   cells are staggered in the horizontal but at the same level in
    !   the vertical. However, the W cells (for vertical
    !   advection velocities at the bottoms of the C and T cells) are
    !   staggered in the vertical with respect to C and T cells.
    !   (no extra boundary point at the start)
    !*********************************************************************/
    corners(num) = bounds(n-1)

    do i = 1, m
      ii = num+i
      corners(ii) = corners(ii-1) + delta_corners(i)
    enddo
    num = num+m
  enddo

  corners(num) = bounds(num_regions)
  corners(num+1) = 2*corners(num) - corners(num-1)
  centers(0) = bounds(1) - 0.5*delta(1)

  do i = 1, num+1
     centers(i) = 2.0*corners(i-1) - centers(i-1)
  enddo 

  return   

end subroutine make_axis

  !#######################################################################
  subroutine iso_grid (maxlen, nylats, y_lat, dy_lat, nj, corners, centers, extend_square_grid)
    ! compute latitude resolution of grid cells to match the convergence
    ! of meridians.
    ! 
    ! inputs:
    !
    ! maxlen   = maximum length of "dytdeg0" and "dyudeg0"
    ! nylats   = should equal 2 (defines one region)
    ! dy_lat   = latitudinal resolution of grid cell on equator
    ! y_lat(1) = southern boundary of the domain (it will be adjusted
    !            to fit an integral number of cells)
    ! y_lat(2) = northern boundary of the domain (it will be adjusted
    !            to fit an integral number of cells)
    !
    ! outputs:
    !
    ! nj      = number of grid cells
    ! yt0     = latitude of point within T cell (degrees)
    ! yu0     = latitude of point within U cell (degrees)

    integer,                   intent(in)    :: maxlen, nylats
    integer,                   intent(out)   :: nj
    real, dimension(nylats),   intent(inout) :: y_lat
    real, dimension(nylats),   intent(in)    :: dy_lat
    real, dimension(0:maxlen), intent(out)   :: corners, centers
    logical,                   intent(in)    :: extend_square_grid
    !--- local variables -------------------------------------------------
    integer,                    parameter :: jmaxlat = 1000, lenjmax = 2*jmaxlat+1
    real, dimension(-jmaxlat-1:jmaxlat+1) :: dusq, dtsq, usq, tsq 
    real,                    dimension(2) :: y_bound, dy_bound
    integer                               :: n, n1, n2, nps, npn, j1, jmts, jmtn, j
    real                                  :: pole1, pole2, wid, stretch, D2R
    !---------------------------------------------------------------------

    D2R = PI/180.

    if (nylats .gt. 2) then
       call mpp_error(FATAL,'grids_util_mod: when hgrid_nml "square_grid"=true, hgrid_nml "nylats"= ' &
                 //trim(string(nylats))//' should eqaul 2')
    endif

    if (dy_lat(1) .ne. dy_lat(2)) then
       call mpp_error(FATAL,'grids_util_mod: nml dy_lat(1)= '//trim(string(dy_lat(1)))// &
             ' must equal dy_lat(2)= '//trim(string(dy_lat(2)))//' when hgrid_nml "square_grid"=true')
    endif
    if ((abs(y_lat(1)) > 89.9999) .or. (abs(y_lat(2)) > 89.9999)) then
       call mpp_error(FATAL,'grids_util_mod: Cannot specify hgrid_nml "ylat" = 90 deg ' &
                     //'when hgrid_nml "square_grid"=true ')
    endif

    ! build a square grid

    usq(0)  = 0.0
    dusq(0) = dy_lat(1)
    tsq(1)  = 0.5*dusq(0)
    tsq(0)  = -tsq(1)
    dtsq(1) = dusq(0)*cos(tsq(1)*D2R)
    dtsq(0) = dtsq(1)
    do n=1,jmaxlat
       dusq(n)   = 2.0*dtsq(n) - dusq(n-1)
       usq(n)    = tsq(n) + 0.5*dusq(n)
       if (tsq(n) .lt. 90.0) then
          tsq(n+1)  = tsq(n) + dusq(n)
          dtsq(n+1) = dusq(0)*cos(tsq(n+1)*D2R)
       else
          tsq(n+1)  = tsq(n)
          dtsq(n+1) = 0.0
       endif
    enddo
    do n=-1,-jmaxlat,-1
       dusq(n) = dusq(-n)
       usq(n)  = -usq(-n)
       dtsq(n) = dtsq(-(n-1)) 
       tsq(n)  = -tsq(-(n-1))
    enddo

    ! pick out cells between bounding latitudes

    n1 = -jmaxlat
    n2 = jmaxlat
    do n=0,jmaxlat
       if (usq(n) > y_lat(2)) then
          n2 = n
          exit
       endif
    enddo
    do n=0,-jmaxlat,-1
       if (usq(n) < y_lat(1)) then
          n1 = n+1
          exit
       endif
    enddo

    ! re-define bounding latitudes to match square boundaries
    y_lat(1) = usq(n1-1)
    y_lat(2) = usq(n2)  

    do n=n1,n2
       write(stdout(),*) 'n=',n,' tsq=',tsq(n),', dyt=',dtsq(n)
    enddo
    if (n1 .eq. -jmaxlat .or. n2 .eq. jmaxlat) then
       call mpp_error(FATAL,'hgrid_mod: Need to increase jmaxlat to reach the max latitude')
    endif

    if (extend_square_grid) then

       ! extend square grid in southern hemisphere to South pole

       ! set south pole (pole1) to skip over land in antarctica
       pole1 = -80.0
       stretch = 1.0
       wid = (y_lat(1) - pole1)
       nps = nint(wid/dusq(n1)) - 1
       y_bound(1) = pole1
       y_bound(2) = y_lat(1)
       dy_bound(1) = 2.0*wid/nps - dusq(n1)
       dy_bound(2) = dusq(n1)
       j1 = n1-nps
       call gcell(1, y_bound(1), y_bound(2), dy_bound(1), dy_bound(2), jmts, 0, maxlen, dtsq(j1) ) 
       dusq(j1) = 2*dtsq(j1)-dy_bound(1)
       do n = 1, jmts-1
          dusq(j1+n) = 2*dtsq(j1+n)-dusq(j1+n-1)
       enddo

       ! construct latitude of T and U grid points
       do n=n1-1, n1-jmts+1, -1
          tsq(n) = tsq(n+1) - dusq(n)
          usq(n) = tsq(n+1) - 0.5*dusq(n)
          write(stdout(),*)'extended n=',n,' usq=',usq(n),'tsq=',tsq(n), 'dyt=',dusq(n)
       enddo

       n1 = n1 - jmts + 1

       ! extend square grid to North pole

       pole2 = 90.0
       npn = nint((pole2 - y_lat(2))/dusq(n2)) - 1
       wid = (pole2 - y_lat(2))
       y_bound(1) = y_lat(2)
       y_bound(2) = pole2
       dy_bound(1) = dusq(n2)
       dy_bound(2) = 2.0*wid/npn - dusq(n2)

       call gcell(1, y_bound(1), y_bound(2), dy_bound(1), dy_bound(2), jmtn, 0, maxlen, dtsq(n2+1) ) 
       dusq(n2+1) = 2*dtsq(n2+1)-dy_bound(1)

       do n = 1, jmtn-1
          dusq(n2+n) = 2*dtsq(n2+n)-dusq(n2+n-1)
       enddo

       ! construct latitude of T and U grid points
       do n = n2+1, n2+jmtn-1
          tsq(n) = tsq(n-1) + dusq(n)
          usq(n) = tsq(n) + 0.5*dusq(n)
          write(stdout(),*)'extended n=',n,' usq=',usq(n),'tsq=',tsq(n), 'dyt=',dusq(n)
       enddo
       n2 = n2 + jmtn - 1
       ! re-define bounding latitudes to match extended boundaries

       y_lat(1) = pole1
       y_lat(2) = pole2 
    endif
    nj = n2 - n1 + 1

    do j=1,nj
       corners(j)     = usq(j+n1-1)
       centers(j)     = tsq(j+n1-1)
    enddo
    
    corners(0) = 2*centers(1) - corners(1)
    centers(0) = 2*corners(0) - centers(1)

    centers(nj+1) = 2*corners(nj)-centers(nj)
    corners(nj+1) = 2*centers(nj+1)- corners(nj)

  end subroutine iso_grid


  !#######################################################################
  ! This function is only for global meta and vgrid. So get_file_unit should 
  ! always linked to file opened_file(0)
  ! <FUNCTION NAME="get_file_unit">
  !   <OVERVIEW>
  !    returns the io unit corresponding to filename.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !    If the file filename is already open, return the io unit of this 
  !    opened file. Otherwise will open the file and return the io unit.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     get_file_unit(filename)
  !   </TEMPLATE>
  !   <IN NAME="filename" TYPE= "character(len=*)">
  !    The name of the grid file to be generated.
  !   </IN>

  function get_file_unit(filename)   
    character(len=*), intent(in) :: filename
    integer                      :: get_file_unit

    if(.not. is_root_pe) return

    if(trim(opened_files(0)) == trim(filename) ) then 
          get_file_unit = files_unit(0)
          return
    endif

    !--- if file is not opened, open the file

    call mpp_open(get_file_unit, trim(filename), MPP_OVERWR,MPP_NETCDF, &
          threading=MPP_SINGLE,  fileset=MPP_SINGLE )

   files_unit(num_files) = get_file_unit
   opened_files(num_files) = trim(filename)

  end function get_file_unit
  ! </FUNCTION>
  !#####################################################################
  ! <SUBROUTINE NAME="write_field_meta">
  !   <OVERVIEW>
  !    Write meta data of a field to a netcdf file.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !    It will check if the grid file will over the 2 GB limit. If do, will open 
  !    a new file with name filename? (? is 1, 2, 3 ....) and write axis metadata
  !    to the new file.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !    call write_field_meta(filename, fieldname, units, field_longname, fielddim, x_pos, y_pos)
  !   </TEMPLATE>
  !   <IN NAME="filename" TYPE= "character(len=*)">
  !    The name of the grid file to be generated. If the grid file is 
  !    over 2 GB limit, it will break into several files with file name filename,
  !    filename1, filename2, filename3 ....
  !   </IN>
  !   <IN NAME="fieldname" TYPE= "character(len=*)">
  !    name of the field to be written into the file filename
  !   </IN>
  !   <IN NAME="units" TYPE= "character(len=*)">
  !    units of field fieldname.
  !   </IN>
  !   <IN NAME="field_longname" TYPE= "character(len=*)">
  !    longname of fielname.
  !   </IN>
  !   <IN NAME="fielddim" TYPE= "integer">
  !    Indicate the dimension of fieldname. fielddim should be either 2 or 3. 
  !   </IN>
  !   <IN NAME="x_pos, y_pos" TYPE= "character(len=1)">
  !    To indicate the cell position. its value can be "T" or "C".
  !   </IN>
  subroutine write_field_meta(filename, fieldname, units, field_longname, fielddim, x_pos, y_pos)
    character(len=*),           intent(in) :: filename, fieldname
    character(len=*),           intent(in) :: units, field_longname
    integer,                    intent(in) :: fielddim
    character(len=1), intent(in), optional :: x_pos, y_pos

    character(len=128) :: curr_file, basename
    logical            :: is_first_field 
    integer            :: unit, fieldsize, length
    type(axistype)     :: axis_x, axis_y
    logical, save      :: do_write_axis = .true.
    real, save         :: size_in_file = 20000.0

    if(.not. is_root_pe) return

    curr_file = filename
    num_fields = num_fields + 1
    flds_name(num_fields) = trim(fieldname)

    if(num_fields ==1) is_first_field = .true.

    if(size_in_file .gt. max_file_size) then   ! 
       num_files = num_files + 1
       if(num_files .gt. max_files) call mpp_error(FATAL, &
           'grids_util_mod: number of files is over max_files, increase max_files ')

    endif

    if(num_files .gt. 0) then
       length = len_trim(filename)
       if(filename(length-2:length) == '.nc') then
          basename = filename(1:length-3)
       else
          basename = filename(1:length)
       endif
       if(num_files < 10)  then   ! num_files should be less than 100
          write(curr_file, '(a,i1,a)')trim(basename), num_files, '.nc'
       else
          write(curr_file, '(a,i2,a)')trim(basename), num_files, '.nc'
       endif
    endif

    if(trim(opened_files(num_files)) == curr_file) then  ! the file is already opened
       unit = files_unit(num_files)
    else   ! need to open the file and write out axis meta.
       call mpp_open(unit, trim(curr_file), MPP_OVERWR,MPP_NETCDF, &
            threading=MPP_SINGLE,  fileset=MPP_SINGLE )

       opened_files(num_files) = trim(curr_file)
       files_unit(num_files) = unit
       do_write_axis = .true.
    endif
    file_num(num_fields) = num_files
    if(do_write_axis) then
       !--- write axis meta -------------------------------------------
       call mpp_write_meta(unit, axis_xt(num_files),'grid_x_T','degree_east','Nominal Longitude of T-cell center', &
            cartesian ='X', data = xt )
       call mpp_write_meta(unit, axis_yt(num_files),'grid_y_T','degree_north','Nominal Latitude of T-cell center', &
            cartesian ='Y', data = yt )
       call mpp_write_meta(unit, axis_xc(num_files),'grid_x_C','degree_east','Nominal Longitude of C-cell center', &
            cartesian ='X', data = xc )
       call mpp_write_meta(unit, axis_yc(num_files),'grid_y_C','degree_north','Nominal Latitude of C-cell center', &
            cartesian ='Y', data = yc )
       call mpp_write_meta(unit, axis_v(num_files), 'vertex', 'none ',        &
            'Vertex position from southwest couterclockwise', data = (/1.,2.,3.,4./) )   
       do_write_axis = .false.
       !--- open a new file, set size_in_file to 20000
       size_in_file = 20000.

    endif

    if(present(x_pos)) then
      if (x_pos .ne. 'T' .and. x_pos .ne. 'C')  &
        call mpp_error(FATAL,'grids_util_mod: x_pos should be either "T" or "C" ')
    endif

    if(present(y_pos)) then
        if (y_pos .ne. 'T' .and. y_pos .ne. 'C') &
        call mpp_error(FATAL,'grids_util_mod: x_pos should be either "T" or "C" ')
    endif

    axis_x = axis_xt(num_files)
    if(present(x_pos))then
       if( x_pos == 'C') axis_x = axis_xc(num_files)
    endif
    axis_y = axis_yt(num_files)
    if(present(y_pos))then
       if(y_pos == 'C') axis_y = axis_yc(num_files)
    endif
    !--- write out field meta
    if(fielddim==2) then
       fieldsize = 8*ni*nj
       call mpp_write_meta(unit, flds(num_fields), (/axis_x, axis_y/), fieldname, units, field_longname, pack=1) 
    else if(fielddim==3) then
       fieldsize = 32*ni*nj
       call mpp_write_meta(unit, flds(num_fields), (/axis_x, axis_y,axis_v(num_files)/), &
            fieldname, units, field_longname, pack=1) 
    else
       call mpp_error(FATAL, 'grids_util_mod: dimension of field '//trim(fieldname)//' should be either 2 or 3')
    endif

    size_in_file = size_in_file + fieldsize


  end subroutine write_field_meta
  !  </SUBROUTINE>
  !#####################################################################
  !  <SUBROUTINE NAME="write_field_data_2d" INTERFACE="write_field_data">
  !  <IN NAME="filename" TYPE= "character(len=*)"> </IN>
  !   <IN NAME="fieldname" TYPE= "character(len=*)"> </IN>
  !   <IN NAME="fielddata" TYPE= "real, dimension(:,:)"> </IN>
  !<PUBLICROUTINE INTERFACE="write_field_data">
  subroutine write_field_data_2d(filename, fieldname, fielddata)
  !</PUBLICROUTINE>
    character(len=*),     intent(in) :: filename, fieldname
    real, dimension(:,:), intent(in) :: fielddata             
    integer                          :: n, k
    logical                          :: is_first_field, is_last_field

    if(.not. is_root_pe) return

    is_first_field = .false.
    is_last_field = .false.
    do n = 1, num_fields
       if(trim(flds_name(n)) == trim(fieldname)) then
          k = file_num(n)
          if(n ==1) then
             is_first_field = .true.
          else
             if(file_num(n) .ne. file_num(n-1)) then
                is_first_field = .true.
             endif
          endif
          if(n == max_fields) then
             is_last_field = .true.
          else
             if(file_num(n) .ne. file_num(n+1)) is_last_field = .true.
          endif

          ! if current field is the first field in a file, need to writ out axis data
          if(is_first_field ) then 
             call mpp_write(files_unit(k), axis_xt(k) )
             call mpp_write(files_unit(k), axis_yt(k) )
             call mpp_write(files_unit(k), axis_xc(k) )
             call mpp_write(files_unit(k), axis_yc(k) )
             call mpp_write(files_unit(k), axis_v(k) )
          endif

          !--- data should be already on global domain
          if(size(fielddata,1) .ne. ni .or. size(fielddata,2) .ne. nj ) then
             call mpp_error(FATAL,'grids_util_mod: data of field '//trim(fieldname)//' is not on global domain')
          endif

          call mpp_write(files_unit(k), flds(n), fielddata)
          if(is_last_field) call mpp_close(files_unit(k))

          return
       endif
    enddo

    !--- if fieldname is not found in the array flds_name, abort the program
    call mpp_error(FATAL,'grids_util_mod: file '//trim(filename)// &
         ' does not contain meta data of field '//trim(fieldname))

  end subroutine write_field_data_2d
  !  </SUBROUTINE>

  !#####################################################################
  !  <SUBROUTINE NAME="write_field_data_3d" INTERFACE="write_field_data">
  !   <IN NAME="fielddata" TYPE= "real, dimension(:,:,:)"> </IN>
  subroutine write_field_data_3d(filename, fieldname, fielddata)
    character(len=*),       intent(in) :: filename, fieldname
    real, dimension(:,:,:), intent(in) :: fielddata             
    integer                            :: n, k
    logical                            :: is_first_field, is_last_field

    if(.not. is_root_pe) return

    is_first_field = .false.
    is_last_field = .false.
    do n = 1, num_fields
       if(trim(flds_name(n)) == trim(fieldname)) then
             k = file_num(n)
          if(n ==1) then
             is_first_field = .true.
          else
             if(file_num(n) .ne. file_num(n-1)) then
                is_first_field = .true.
             endif
          endif 
        if(n == max_fields) then
           is_last_field = .true.
        else
           if(file_num(n) .ne. file_num(n+1)) is_last_field = .true.
        endif
           
          ! if current field is the first field in a file, need to writ out axis data
          if(is_first_field) then 
             call mpp_write(files_unit(k), axis_xt(k) )
             call mpp_write(files_unit(k), axis_xt(k) )
             call mpp_write(files_unit(k), axis_xc(k) )
             call mpp_write(files_unit(k), axis_yc(k) )
             call mpp_write(files_unit(k), axis_v(k) )
          endif
          call mpp_write(files_unit(k), flds(n), fielddata)
          if(is_last_field) call mpp_close(files_unit(k))

          return
        endif
     enddo

     !--- if fieldname is not found in the array flds_name, abort the program
     call mpp_error(FATAL,'grids_util_mod: file '//trim(filename)// &
          ' does not contain meta data of field '//trim(fieldname))

  end subroutine write_field_data_3d
  !  </SUBROUTINE>

  !#####################################################################
  ! <SUBROUTINE NAME="set_grid">

  !   <OVERVIEW>
  !    set the axis grid information.
  !   </OVERVIEW>     
  !   <TEMPLATE>
  !    call set_grid(grid_xt, grid_yt, grid_xc, grid_yc)
  !   </TEMPLATE>
  !   <IN NAME="grid_xt, grid_yt" TYPE="real, dimension(:)">
  !    longitude and latitude of the T-cell grid.
  !   </IN>
  !   <IN NAME="grid_xc, grid_yc" TYPE="real, dimension(:)">
  !    longitude and latitude of the C-cell grid.
  !   </IN>
  subroutine set_grid(grid_xt, grid_yt, grid_xc, grid_yc)
    real, dimension(:), intent(in) :: grid_xt, grid_yt, grid_xc, grid_yc


    ni = size(grid_xt(:))
    nj = size(grid_yt(:))

    allocate(xt(ni), yt(nj), xc(ni), yc(nj))
    xt = grid_xt
    yt = grid_yt
    xc = grid_xc
    yc = grid_yc 

    if(mpp_pe() == mpp_root_pe()) is_root_pe = .true.

  end subroutine set_grid
  !  </SUBROUTINE>
  !#####################################################################

end module grids_util_mod

module sat_vapor_pres_mod

!-----------------------------------------------------------------------
!
!                 saturation vapor pressure lookup
!                 saturation vapor specific humidity calculation
!                 saturation vapor mixing ratio calculation
!
!      routines for computing the saturation vapor pressure (es),
!      the specific humidity (qs) and vapor mixing ratio (mrs) at
!      a specified relative humidity, the derivatives of es, qs and mrs 
!      with respect to temperature, and initialization of the 
!      look-up table.
!
!-----------------------------------------------------------------------
!
!                               usage
!                               -----
!
!              call lookup_es  (temp, es, err_msg)
!
!              call lookup_des (temp, des, err_msg)
!
!              call lookup_es_des (temp, es, des, err_msg)
!
!              call lookup_es2 (temp, es, err_msg)
!
!              call lookup_des2 (temp, des, err_msg)
!
!              call lookup_es2_des2 (temp, es, des, err_msg)
!
!              call compute_qs (temp, press, qs, q, hc, dqsdT, esat, 
!                               err_msg, es_over_liq)
!
!              call compute_mrs (temp, press, mrs, mr, hc, dmrsdT, esat,
!                                err_msg, es_over_liq)
!
!    arguments
!    ---------
!      temp    intent in       temperature in degrees kelvin
!      es      intent out      saturation vapor pressure in Pascals
!      des     intent out      derivative of saturation vapor pressure
!                              with respect to temperature 
!                              (Pascals/degree)
!      press   intent in       atmospheric pressure in Pascals
!      qs      intent out      specific humidity at relative humidity hc
!                              (kg(vapor) / kg(moist air)
!      mrs     intent out      mixing ratio at relative humidity hc     
!                              (kg(vapor) / kg(dry air)
!
!   optional arguments
!   ------------------
!      q       intent in       vapor specific humidity
!                              (kg(vapor) / kg(moist air)
!      hc      intent in       relative humidity at which output
!                              fields are desired: default is 100 %
!      dqsdT   intent out      derivative of saturation specific 
!                              humidity with respect to temperature 
!                              (kg(vapor) / kg(moist air) /degree)
!      mr      intent in       vapor mixing ratio        
!                              (kg(vapor) / kg(dry air)
!      dmrsdT  intent out      derivative of saturation mixing ratio
!                              with respect to temperature 
!                              (kg(vapor) / kg(dry air) /degree)
!      esat    intent out      saturation vapor pressure
!                              (Pascals)
!      err_msg intent out      character string to hold error message
!      es_over_liq
!              intent  in      use es table wrt liquid only
!
!-----------------------------------------------------------------------

! <CONTACT EMAIL="Bruce.Wyman@noaa.gov">
!   Bruce Wyman
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!   Routines for determining the saturation vapor pressure 
!   (<TT>ES</TT>), saturation vapor specific humidity and saturation 
!   vapor mixing ratio, and their derivatives with respect to 
!   temperature.
! </OVERVIEW>

! <DESCRIPTION>
!   This module contains routines for determining the saturation vapor
!   pressure (<TT>ES</TT>) from lookup tables constructed using equations given
!   in the Smithsonian tables.  The <TT>ES</TT> lookup tables are valid between
!   -160C and +100C (approx 113K to 373K).

!   The values of <TT>ES</TT> are computed over ice from -160C to -20C,
!   over water from 0C to 100C, and a blended value (over water and ice)
!   from -20C to 0C.

!   Routines are also included to calculate the saturation specific
!   humidity and saturation mixing ratio for vapor, and their deriv-
!   atives with respect to temperature.  By default, the values returned
!   are those at saturation; optionally, values of q and mr at a spec-
!   ified relative humidity may instead be returned. Two forms are 
!   available; the approximate form that has been traditionally used in 
!   GCMs, and an exact form provided by SJ Lin in which saturation is 
!   reached while maintaining constant pressure and temperature.

!   This version was written for non-vector machines.
!   See the <LINK SRC="#NOTES">notes</LINK> section for details on vectorization.

! </DESCRIPTION>

! <PUBLIC>
!   Description summarizing public interface.
! </PUBLIC>

 use         constants_mod, only:  TFREEZE, RDGAS, RVGAS, HLV, ES0
 use        fms_mod, only:  write_version_number, stdout, stdlog, mpp_pe, mpp_root_pe, &
                            mpp_error, FATAL, fms_error_handler, open_namelist_file,   &
                            error_mesg, &
                            file_exist, check_nml_error
 use     mpp_io_mod, only:  mpp_close
 use        mpp_mod, only: input_nml_file
 use  sat_vapor_pres_k_mod, only:  sat_vapor_pres_init_k, lookup_es_k, &
                                   lookup_des_k, lookup_es_des_k, &
                                   lookup_es2_k,  &
                                   lookup_des2_k, lookup_es2_des2_k, &
                                   lookup_es3_k,  &
                                   lookup_des3_k, lookup_es3_des3_k, &
                                   compute_qs_k, compute_mrs_k

implicit none
private

 public :: lookup_es, lookup_des, sat_vapor_pres_init
 public :: lookup_es2, lookup_des2, lookup_es2_des2
 public :: lookup_es3, lookup_des3, lookup_es3_des3
 public :: lookup_es_des, compute_qs, compute_mrs
!public :: compute_es
 public :: escomp, descomp ! for backward compatibility
                           ! use lookup_es, lookup_des instead

!-----------------------------------------------------------------------
 
! <INTERFACE NAME="lookup_es">

!   <OVERVIEW>
!     For the given temperatures, returns the saturation vapor pressures.
!   </OVERVIEW>
!   <DESCRIPTION>
!     For the given temperatures these routines return the
!     saturation vapor pressure (esat). The return values are derived from
!     lookup tables (see notes below).
!   </DESCRIPTION>
!   <TEMPLATE>
!     call lookup_es( temp, esat, err_msg )
!   </TEMPLATE>
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Temperature in degrees Kelvin.
!   </IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Saturation vapor pressure in pascals.
!             May be a scalar, 1d, 2d, or 3d array.
!             Must have the same order and size as temp.
!   </OUT>
!   <OUT NAME="err_msg" UNITS="      " TYPE="character">
!     Character string containing error message to be returned to
!     calling routine.
!   </OUT>
!   <ERROR MSG="table overflow, nbad=##" STATUS="FATAL">
!     Temperature(s) provided to the saturation vapor pressure lookup
!          are outside the valid range of the lookup table (-160 to 100 deg C).
!          This may be due to a numerical instability in the model.
!          Information should have been printed to standard output to help
!          determine where the instability may have occurred.
!          If the lookup table needs a larger temperature range,
!          then parameters in the module header must be modified.
!   </ERROR> *

 interface lookup_es
   module procedure lookup_es_0d, lookup_es_1d, lookup_es_2d, lookup_es_3d
 end interface
! for backward compatibility (to be removed soon)
 interface escomp
   module procedure lookup_es_0d, lookup_es_1d, lookup_es_2d, lookup_es_3d
 end interface
! </INTERFACE>
!-----------------------------------------------------------------------
! <INTERFACE NAME="lookup_des">

!   <OVERVIEW>
!     For the given temperatures, returns the derivative of saturation vapor pressure
!     with respect to temperature.
!   </OVERVIEW>
!   <DESCRIPTION>
!     For the given temperatures these routines return the derivative of esat w.r.t.
!     temperature (desat). The return values are derived from
!     lookup tables (see notes below).
!   </DESCRIPTION>
!   <TEMPLATE>
!     call lookup_des( temp, desat )
!   </TEMPLATE>
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Temperature in degrees Kelvin.
!   </IN>
!   <OUT NAME="desat" UNITS="pascal" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Derivative of saturation vapor pressure w.r.t. temperature
!                 in pascals/degree. May be a scalar, 1d, 2d, or 3d array.
!                 Must have the same order and size as temp.
!   </OUT>
!   <OUT NAME="err_msg" UNITS="      " TYPE="character">
!     Character string containing error message to be returned to
!     calling routine.
!   </OUT>
!   <ERROR MSG="table overflow, nbad=##" STATUS="FATAL">
!     Temperature(s) provided to the saturation vapor pressure lookup
!          are outside the valid range of the lookup table (-160 to 100 deg C).
!          This may be due to a numerical instability in the model.
!          Information should have been printed to standard output to help
!          determine where the instability may have occurred.
!          If the lookup table needs a larger temperature range,
!          then parameters in the module header must be modified.
!   </ERROR> *

 interface lookup_des
   module procedure lookup_des_0d, lookup_des_1d, lookup_des_2d, lookup_des_3d
 end interface
! </INTERFACE>
! for backward compatibility (to be removed soon)
 interface descomp
   module procedure lookup_des_0d, lookup_des_1d, lookup_des_2d, lookup_des_3d
 end interface

!-----------------------------------------------------------------------
 
! <INTERFACE NAME="lookup_es_des">

!   <OVERVIEW>
!     For the given temperatures, returns the saturation vapor pressure 
!     and the derivative of saturation vapor pressure with respect to
!     temperature.
!   </OVERVIEW>
!   <DESCRIPTION>
!     For the given temperatures these routines return the
!     saturation vapor pressure (esat) and the derivative of esat w.r.t
!     temperature (desat). The return values are derived from
!     lookup tables (see notes below).
!   </DESCRIPTION>
!   <TEMPLATE>
!     call lookup_es_des( temp, esat, desat, err_msg )
!   </TEMPLATE>
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Temperature in degrees Kelvin.
!   </IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Saturation vapor pressure in pascals.
!             May be a scalar, 1d, 2d, or 3d array.
!             Must have the same order and size as temp.
!   </OUT>
!   <OUT NAME="desat" UNITS="pascal/ degree" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Derivative of saturation vapor pressure w.r.t. temperature
!                 in pascals/degree. May be a scalar, 1d, 2d, or 3d array.
!                 Must have the same order and size as temp.
!   </OUT>
!   <OUT NAME="err_msg" UNITS="      " TYPE="character">
!     Character string containing error message to be returned to
!     calling routine.
!   </OUT>
!   <ERROR MSG="table overflow, nbad=##" STATUS="FATAL">
!     Temperature(s) provided to the saturation vapor pressure lookup
!          are outside the valid range of the lookup table (-160 to 100 deg C).
!          This may be due to a numerical instability in the model.
!          Information should have been printed to standard output to help
!          determine where the instability may have occurred.
!          If the lookup table needs a larger temperature range,
!          then parameters in the module header must be modified.
!   </ERROR> *

 interface lookup_es_des
   module procedure lookup_es_des_0d, lookup_es_des_1d, lookup_es_des_2d, lookup_es_des_3d
 end interface

 interface lookup_es2
   module procedure lookup_es2_0d, lookup_es2_1d, lookup_es2_2d, lookup_es2_3d
 end interface
 
 interface lookup_des2
   module procedure lookup_des2_0d, lookup_des2_1d, lookup_des2_2d, lookup_des2_3d
 end interface

 interface lookup_es2_des2
   module procedure lookup_es2_des2_0d, lookup_es2_des2_1d, lookup_es2_des2_2d, lookup_es2_des2_3d
 end interface


 interface lookup_es3
   module procedure lookup_es3_0d, lookup_es3_1d, lookup_es3_2d, lookup_es3_3d
 end interface
 
 interface lookup_des3
   module procedure lookup_des3_0d, lookup_des3_1d, lookup_des3_2d, lookup_des3_3d
 end interface

 interface lookup_es3_des3
   module procedure lookup_es3_des3_0d, lookup_es3_des3_1d, lookup_es3_des3_2d, lookup_es3_des3_3d
 end interface

!-----------------------------------------------------------------------
 
! <INTERFACE NAME="compute_qs">

!   <OVERVIEW>
!     For the given temperatures, pressures and optionally vapor 
!     specific humidity, returns the specific humidity at saturation 
!     (optionally at relative humidity hc instead of at saturation) and
!     optionally the derivative of saturation specific humidity w.r.t.
!     temperature, and the saturation vapor pressure.
!   </OVERVIEW>
!   <DESCRIPTION>
!     For the input temperature and pressure these routines return the
!     specific humidity (qsat) at saturation (unless optional argument
!     hc is used to specify the relative humidity at which qsat should
!     apply) and, if desired, the derivative of qsat w.r.t temperature 
!     (dqsdT) and / or the saturation vapor pressure (esat). If the 
!     optional input argument specific humidity (q) is present, the 
!     exact expression for qs is used; if q is not present the tradit-
!     ional form (valid at saturation) is used. if the optional qsat 
!     derivative argument is present, the derivative of qsat w.r.t. 
!     temperature will also be returned, defined consistent with the 
!     expression used for qsat. The return values are derived from 
!     lookup tables (see notes below).
!   </DESCRIPTION>
!   <TEMPLATE>
!     call compute_qs( temp, press, qsat, q, hc, dqsdT, esat, err_msg )
!   </TEMPLATE>
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Temperature in degrees Kelvin.
!   </IN>
!   <IN NAME="press" UNIT="Pascals" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Air pressure in Pascals.
!   </IN>
!   <OUT NAME="qsat" UNITS="kg(vapor) / kg(moist air)" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Specific humidity in kg (vapor) / kg (moist air)
!             May be a scalar, 1d, 2d, or 3d array.
!             Must have the same order and size as temp.
!   </OUT>
!   <IN NAME="q" UNIT="kg(vapor) / kg (moist air)" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Vapor specific humidity in kg (vapor) / kg (moist air).
!     If present, exact formulation for qsat and dqsdT will be used.
!   </IN>
!   <IN NAME="hc" UNIT="fraction" TYPE="real" DIM="(scalar)">
!     Relative humidity at which output variables are desired.
!     If not present, values will apply at saturation.
!   </IN>
!   <OUT NAME="dqsdT" UNITS="kg(vapor) / kg(moist air) / degree" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Derivative of saturation specific humidity w.r.t. temperature
!                 in kg(vapor) / kg(moist air) / degree. May be a 
!                 scalar, 1d, 2d, or 3d array.
!                 Must have the same order and size as temp.
!   </OUT>
!   <OUT NAME="esat" UNITS="Pascals" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Saturation vapor pressure. May be a scalar, 1d, 2d, or 3d array.
!                 Must have the same order and size as temp.
!   </OUT>
!   <OUT NAME="err_msg" UNITS="      " TYPE="character">
!     Character string containing error message to be returned to
!     calling routine.
!   </OUT>
!   <ERROR MSG="table overflow, nbad=##" STATUS="FATAL">
!     Temperature(s) provided to the saturation vapor pressure lookup
!          are outside the valid range of the lookup table (-160 to 100 deg C).
!          This may be due to a numerical instability in the model.
!          Information should have been printed to standard output to help
!          determine where the instability may have occurred.
!          If the lookup table needs a larger temperature range,
!          then parameters in the module header must be modified.
!   </ERROR> *

 interface compute_qs
   module procedure compute_qs_0d, compute_qs_1d, compute_qs_2d, compute_qs_3d
 end interface

!-----------------------------------------------------------------------
 
! <INTERFACE NAME="compute_mrs">

!   <OVERVIEW>
!     For the given temperatures, pressures and optionally vapor 
!     mixing ratio, returns the  vapor mixing ratio at saturation 
!     (optionally at relative humidity hc instead of at saturation) and
!     optionally the derivative of saturation vapor mixing ratio w.r.t.
!     temperature, and the saturation vapor pressure.
!   </OVERVIEW>
!   <DESCRIPTION>
!     For the input temperature and pressure these routines return the
!     vapor mixing ratio (mrsat) at saturation (unless optional argument
!     hc is used to specify the relative humidity at which mrsat should
!     apply) and, if desired, the derivative of mrsat w.r.t temperature 
!     (dmrsdT) and / or the saturation vapor pressure (esat). If the 
!     optional input argument specific humidity (mr) is present, the 
!     exact expression for mrs is used; if qr is not present the tradit-
!     ional form (valid at saturation) is used. if the optional mrsat 
!     derivative argument is present, the derivative of mrsat w.r.t. 
!     temperature will also be returned, defined consistent with the 
!     expression used for mrsat. The return values are derived from 
!     lookup tables (see notes below).
!   </DESCRIPTION>
!   <TEMPLATE>
!     call compute_mrs( temp, press, mrsat, mr, hc, dmrsdT, esat, 
!                       err_msg )
!   </TEMPLATE>
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Temperature in degrees Kelvin.
!   </IN>
!   <IN NAME="press" UNIT="Pascals" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Air pressure in Pascals.
!   </IN>
!   <OUT NAME="mrsat" UNITS="kg(vapor) / kg (dry air)" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Vapor mixing ratio in kg (vapor) / kg (dry air)
!             May be a scalar, 1d, 2d, or 3d array.
!             Must have the same order and size as temp.
!   </OUT>
!   <IN NAME="mr" UNIT="kg(vapor) / kg (dry air)" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Vapor mixing ratio in kg (vapor) / kg (dry air).
!     If present, exact formulation for mrsat and dmrsdT will be used.
!   </IN>
!   <IN NAME="hc" UNIT="fraction" TYPE="real" DIM="(scalar)">
!     Relative humidity at which output variables are desired.
!     If not present, values will apply at saturation.
!   </IN>
!   <OUT NAME="dmrsdT" UNITS="kg(vapor) / kg(dry air) / degree" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Derivative of saturation vapor mixing ratio w.r.t. temperature
!                 in kg(vapor) / kg(dry air) / degree. May be a 
!                 scalar, 1d, 2d, or 3d array.
!                 Must have the same order and size as temp.
!   </OUT>
!   <OUT NAME="esat" UNITS="Pascals" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Saturation vapor pressure. May be a scalar, 1d, 2d, or 3d array.
!                 Must have the same order and size as temp.
!   </OUT>
!   <OUT NAME="err_msg" UNITS="      " TYPE="character">
!     Character string containing error message to be returned to
!     calling routine.
!   </OUT>
!   <ERROR MSG="table overflow, nbad=##" STATUS="FATAL">
!     Temperature(s) provided to the saturation vapor pressure lookup
!          are outside the valid range of the lookup table (-160 to 100 deg C).
!          This may be due to a numerical instability in the model.
!          Information should have been printed to standard output to help
!          determine where the instability may have occurred.
!          If the lookup table needs a larger temperature range,
!          then parameters in the module header must be modified.
!   </ERROR> *

 interface compute_mrs
   module procedure compute_mrs_0d, compute_mrs_1d, compute_mrs_2d, compute_mrs_3d
 end interface

!-----------------------------------------------------------------------
! <INTERFACE NAME="compute_es">

!   <OVERVIEW>
!     For the given temperatures, computes the saturation vapor pressures. 
!   </OVERVIEW>
!   <DESCRIPTION>
!     Computes saturation vapor pressure for the given temperature using
!     the equations given in the Smithsonian Meteorological Tables.
!     Between -20C and 0C a blended value over ice and water is returned.
!   </DESCRIPTION>
!   <TEMPLATE>
!     es = compute_es ( temp )
!   </TEMPLATE>
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Temperature in degrees Kelvin.
!   </IN>
!   <OUT NAME="es" UNITS="pascal" TYPE="real" DIM="(scalar),(:),(:,:),(:,:,:)">
!     Saturation vapor pressure in pascals.
!             May be a scalar, 1d, 2d, or 3d array.
!             Must have the same order and size as temp.
!   </OUT>

!interface compute_es
!  module procedure compute_es_0d, compute_es_1d, compute_es_2d, compute_es_3d
!end interface
! </INTERFACE>
!-----------------------------------------------------------------------
 interface temp_check
   module procedure temp_check_1d, temp_check_2d, temp_check_3d
 end interface

 interface show_all_bad
   module procedure show_all_bad_0d, show_all_bad_1d, show_all_bad_2d, show_all_bad_3d
 end interface
!-----------------------------------------------------------------------
!  cvs version and tag name

 character(len=128) :: version = '$Id$'
 character(len=128) :: tagname = '$Name$'

 logical :: module_is_initialized = .false.

!-----------------------------------------------------------------------
!  parameters for use in computing qs and mrs

 real, parameter    :: EPSILO = RDGAS/RVGAS
 real, parameter    :: ZVIR = RVGAS/RDGAS - 1.0

!-----------------------------------------------------------------------
!  parameters for table size and resolution

 integer :: tcmin = -160  ! minimum temperature (degC) in lookup table
 integer :: tcmax =  100  ! maximum temperature (degC) in lookup table
 integer :: esres =  10   ! table resolution (increments per degree)
 integer :: nsize  ! (tcmax-tcmin)*esres+1    !  lookup table size
 integer :: nlim   ! nsize-1

!-----------------------------------------------------------------------
!  variables needed by temp_check
 real :: tmin, dtinv, teps

! The default values below preserve the behavior of omsk and earlier revisions.
 logical :: show_bad_value_count_by_slice=.true.
 logical :: show_all_bad_values=.false.
 logical :: use_exact_qs = .false.
 logical :: do_simple             =.false.
 logical :: construct_table_wrt_liq = .false.
 logical :: construct_table_wrt_liq_and_ice = .false.

 namelist / sat_vapor_pres_nml / show_bad_value_count_by_slice, show_all_bad_values, &
                                 use_exact_qs, do_simple, &
                                 construct_table_wrt_liq, &
                                 construct_table_wrt_liq_and_ice

contains

!#######################################################################
! <SUBROUTINE NAME="lookup_es_0d" INTERFACE="lookup_es">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(scalar)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es_0d ( temp, esat, err_msg )

 real, intent(in)  :: temp
 real, intent(out) :: esat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es_k(temp, esat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es_0d',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es_0d

!#######################################################################

! <SUBROUTINE NAME="lookup_es_1d" INTERFACE="lookup_es">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es_1d ( temp, esat, err_msg )

 real, intent(in)  :: temp(:)
 real, intent(out) :: esat(:)
 character(len=*), intent(out), optional :: err_msg

 character(len=54) :: err_msg_local
 integer :: nbad
!-----------------------------------------------

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es_k(temp, esat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es_1d',err_msg_local,err_msg)) return
   endif

!-----------------------------------------------

 end subroutine lookup_es_1d

!#######################################################################

! <SUBROUTINE NAME="lookup_es_2d" INTERFACE="lookup_es">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es_2d ( temp, esat, err_msg )

 real, intent(in)  :: temp(:,:)
 real, intent(out) :: esat(:,:)
 character(len=*), intent(out), optional :: err_msg

 character(len=54) :: err_msg_local
 integer :: nbad
!-----------------------------------------------

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es_k(temp, esat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es_2d',err_msg_local,err_msg)) return
   endif

!-----------------------------------------------

 end subroutine lookup_es_2d

!#######################################################################

! <SUBROUTINE NAME="lookup_es_3d" INTERFACE="lookup_es">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:,:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:,:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es_3d ( temp, esat, err_msg )

 real, intent(in)  :: temp(:,:,:)
 real, intent(out) :: esat(:,:,:)
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_tmp

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es_k(temp, esat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_tmp,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es_3d',err_msg_tmp,err_msg)) return
   endif

 end subroutine lookup_es_3d


!#######################################################################
! <SUBROUTINE NAME="lookup_es2_0d" INTERFACE="lookup_es2">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(scalar)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es2_0d ( temp, esat, err_msg )

 real, intent(in)  :: temp
 real, intent(out) :: esat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es2_k(temp, esat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es2',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es2_0d

!#######################################################################

! <SUBROUTINE NAME="lookup_es2_1d" INTERFACE="lookup_es2">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es2_1d ( temp, esat, err_msg )

 real, intent(in)  :: temp(:)
 real, intent(out) :: esat(:)
 character(len=*), intent(out), optional :: err_msg

 character(len=54) :: err_msg_local
 integer :: nbad
!-----------------------------------------------

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es2_k(temp, esat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es2',err_msg_local,err_msg)) return
   endif

!-----------------------------------------------

 end subroutine lookup_es2_1d

!#######################################################################

! <SUBROUTINE NAME="lookup_es2_2d" INTERFACE="lookup_es2">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es2_2d ( temp, esat, err_msg )

 real, intent(in)  :: temp(:,:)
 real, intent(out) :: esat(:,:)
 character(len=*), intent(out), optional :: err_msg

 character(len=54) :: err_msg_local
 integer :: nbad
!-----------------------------------------------

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es2_k(temp, esat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es2',err_msg_local,err_msg)) return
   endif

!-----------------------------------------------

 end subroutine lookup_es2_2d

!#######################################################################

! <SUBROUTINE NAME="lookup_es2_3d" INTERFACE="lookup_es2">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:,:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:,:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es2_3d ( temp, esat, err_msg )

 real, intent(in)  :: temp(:,:,:)
 real, intent(out) :: esat(:,:,:)
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_tmp

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es2_k(temp, esat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_tmp,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es2',err_msg_tmp,err_msg)) return
   endif

 end subroutine lookup_es2_3d


!#######################################################################
! <SUBROUTINE NAME="lookup_es3_0d" INTERFACE="lookup_es3">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(scalar)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es3_0d ( temp, esat, err_msg )

 real, intent(in)  :: temp
 real, intent(out) :: esat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es3_k(temp, esat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es3',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es3_0d

!#######################################################################

! <SUBROUTINE NAME="lookup_es3_1d" INTERFACE="lookup_es3">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es3_1d ( temp, esat, err_msg )

 real, intent(in)  :: temp(:)
 real, intent(out) :: esat(:)
 character(len=*), intent(out), optional :: err_msg

 character(len=54) :: err_msg_local
 integer :: nbad
!-----------------------------------------------

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es3_k(temp, esat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es3',err_msg_local,err_msg)) return
   endif

!-----------------------------------------------

 end subroutine lookup_es3_1d

!#######################################################################

! <SUBROUTINE NAME="lookup_es3_2d" INTERFACE="lookup_es3">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es3_2d ( temp, esat, err_msg )

 real, intent(in)  :: temp(:,:)
 real, intent(out) :: esat(:,:)
 character(len=*), intent(out), optional :: err_msg

 character(len=54) :: err_msg_local
 integer :: nbad
!-----------------------------------------------

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es3_k(temp, esat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es3',err_msg_local,err_msg)) return
   endif

!-----------------------------------------------

 end subroutine lookup_es3_2d

!#######################################################################

! <SUBROUTINE NAME="lookup_es3_3d" INTERFACE="lookup_es3">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:,:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:,:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es3_3d ( temp, esat, err_msg )

 real, intent(in)  :: temp(:,:,:)
 real, intent(out) :: esat(:,:,:)
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_tmp

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es3_k(temp, esat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_tmp,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es3',err_msg_tmp,err_msg)) return
   endif

 end subroutine lookup_es3_3d


!#######################################################################
!  routines for computing derivative of es
!#######################################################################

! <SUBROUTINE NAME="lookup_des_0d" INTERFACE="lookup_des">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="desat" UNITS="pascal" TYPE="real" DIM="(scalar)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_des_0d ( temp, desat, err_msg )

 real, intent(in)  :: temp
 real, intent(out) :: desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_des_k( temp, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_des_0d',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_des_0d

!#######################################################################

! <SUBROUTINE NAME="lookup_des_1d" INTERFACE="lookup_des">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:)"></IN>
!   <OUT NAME="desat" UNITS="pascal" TYPE="real" DIM="(:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_des_1d ( temp, desat, err_msg )

 real, intent(in)  :: temp (:)
 real, intent(out) :: desat(:)
 character(len=*), intent(out), optional :: err_msg

 character(len=54) :: err_msg_local
 integer :: nbad
!-----------------------------------------------

   if (.not.module_is_initialized) call sat_vapor_pres_init
   if(present(err_msg)) err_msg=''

   call lookup_des_k(temp, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_des_1d',err_msg_local,err_msg)) return
   endif
!-----------------------------------------------

 end subroutine lookup_des_1d

!#######################################################################

! <SUBROUTINE NAME="lookup_des_2d" INTERFACE="lookup_des">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:)"></IN>
!   <OUT NAME="desat" UNITS="pascal" TYPE="real" DIM="(:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_des_2d ( temp, desat, err_msg )

 real, intent(in)  :: temp (:,:)
 real, intent(out) :: desat(:,:)
 character(len=*), intent(out), optional :: err_msg

 character(len=54) :: err_msg_local
 integer :: nbad
!-----------------------------------------------
   
   if (.not.module_is_initialized) call sat_vapor_pres_init
   
   call lookup_des_k(temp, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_des_2d',err_msg_local,err_msg)) return
   endif
!-----------------------------------------------

 end subroutine lookup_des_2d

!#######################################################################
! <SUBROUTINE NAME="lookup_des_3d" INTERFACE="lookup_des">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:,:)"></IN>
!   <OUT NAME="desat" UNITS="pascal" TYPE="real" DIM="(:,:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_des_3d ( temp, desat, err_msg )

 real, intent(in)  :: temp (:,:,:)
 real, intent(out) :: desat(:,:,:)
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_tmp

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_des_k( temp, desat, nbad )

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg=''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_tmp,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_des_3d',err_msg_tmp,err_msg)) return
   endif

 end subroutine lookup_des_3d


! <SUBROUTINE NAME="lookup_des2_0d" INTERFACE="lookup_des2">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="desat" UNITS="pascal" TYPE="real" DIM="(scalar)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_des2_0d ( temp, desat, err_msg )

 real, intent(in)  :: temp
 real, intent(out) :: desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_des2_k( temp, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_des2',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_des2_0d

!#######################################################################

! <SUBROUTINE NAME="lookup_des2_1d" INTERFACE="lookup_des2">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:)"></IN>
!   <OUT NAME="desat" UNITS="pascal" TYPE="real" DIM="(:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_des2_1d ( temp, desat, err_msg )

 real, intent(in)  :: temp (:)
 real, intent(out) :: desat(:)
 character(len=*), intent(out), optional :: err_msg

 character(len=54) :: err_msg_local
 integer :: nbad
!-----------------------------------------------

   if (.not.module_is_initialized) call sat_vapor_pres_init
   if(present(err_msg)) err_msg=''

   call lookup_des2_k(temp, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_des2',err_msg_local,err_msg)) return
   endif
!-----------------------------------------------

 end subroutine lookup_des2_1d

!#######################################################################

! <SUBROUTINE NAME="lookup_des2_2d" INTERFACE="lookup_des2">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:)"></IN>
!   <OUT NAME="desat" UNITS="pascal" TYPE="real" DIM="(:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_des2_2d ( temp, desat, err_msg )

 real, intent(in)  :: temp (:,:)
 real, intent(out) :: desat(:,:)
 character(len=*), intent(out), optional :: err_msg

 character(len=54) :: err_msg_local
 integer :: nbad
!-----------------------------------------------
   
   if (.not.module_is_initialized) call sat_vapor_pres_init
   
   call lookup_des2_k(temp, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_des2',err_msg_local,err_msg)) return
   endif
!-----------------------------------------------

 end subroutine lookup_des2_2d

!#######################################################################
! <SUBROUTINE NAME="lookup_des2_3d" INTERFACE="lookup_des2">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:,:)"></IN>
!   <OUT NAME="desat" UNITS="pascal" TYPE="real" DIM="(:,:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_des2_3d ( temp, desat, err_msg )

 real, intent(in)  :: temp (:,:,:)
 real, intent(out) :: desat(:,:,:)
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_tmp

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_des2_k( temp, desat, nbad )

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg=''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_tmp,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_des2',err_msg_tmp,err_msg)) return
   endif

 end subroutine lookup_des2_3d


! <SUBROUTINE NAME="lookup_des3_0d" INTERFACE="lookup_des3">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="desat" UNITS="pascal" TYPE="real" DIM="(scalar)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_des3_0d ( temp, desat, err_msg )

 real, intent(in)  :: temp
 real, intent(out) :: desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_des3_k( temp, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_des3',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_des3_0d

!#######################################################################

! <SUBROUTINE NAME="lookup_des3_1d" INTERFACE="lookup_des3">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:)"></IN>
!   <OUT NAME="desat" UNITS="pascal" TYPE="real" DIM="(:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_des3_1d ( temp, desat, err_msg )

 real, intent(in)  :: temp (:)
 real, intent(out) :: desat(:)
 character(len=*), intent(out), optional :: err_msg

 character(len=54) :: err_msg_local
 integer :: nbad
!-----------------------------------------------

   if (.not.module_is_initialized) call sat_vapor_pres_init
   if(present(err_msg)) err_msg=''

   call lookup_des3_k(temp, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_des3',err_msg_local,err_msg)) return
   endif
!-----------------------------------------------

 end subroutine lookup_des3_1d

!#######################################################################

! <SUBROUTINE NAME="lookup_des3_2d" INTERFACE="lookup_des3">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:)"></IN>
!   <OUT NAME="desat" UNITS="pascal" TYPE="real" DIM="(:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_des3_2d ( temp, desat, err_msg )

 real, intent(in)  :: temp (:,:)
 real, intent(out) :: desat(:,:)
 character(len=*), intent(out), optional :: err_msg

 character(len=54) :: err_msg_local
 integer :: nbad
!-----------------------------------------------
   
   if (.not.module_is_initialized) call sat_vapor_pres_init
   
   call lookup_des3_k(temp, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_des3',err_msg_local,err_msg)) return
   endif
!-----------------------------------------------

 end subroutine lookup_des3_2d

!#######################################################################
! <SUBROUTINE NAME="lookup_des3_3d" INTERFACE="lookup_des3">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:,:)"></IN>
!   <OUT NAME="desat" UNITS="pascal" TYPE="real" DIM="(:,:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_des3_3d ( temp, desat, err_msg )

 real, intent(in)  :: temp (:,:,:)
 real, intent(out) :: desat(:,:,:)
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_tmp

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_des3_k( temp, desat, nbad )

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg=''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_tmp,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_des3',err_msg_tmp,err_msg)) return
   endif

 end subroutine lookup_des3_3d

!========================================================================================================

!#######################################################################

! <SUBROUTINE NAME="lookup_es_des_0d" INTERFACE="lookup_es_des">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(scalar)"></OUT>
!   <OUT NAME="desat" UNITS="pascal / degree" TYPE="real" DIM="(scalar)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es_des_0d ( temp, esat, desat, err_msg )

 real, intent(in)  :: temp
 real, intent(out) :: esat, desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es_des_k(temp, esat, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es_des_0d',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es_des_0d

!#######################################################################

! <SUBROUTINE NAME="lookup_es_des_1d" INTERFACE="lookup_es_des">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:)"></OUT>
!   <OUT NAME="desat" UNITS="pascal / degree" TYPE="real" DIM="(:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es_des_1d ( temp, esat, desat, err_msg )

 real, dimension(:), intent(in)  :: temp
 real, dimension(:), intent(out) :: esat, desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es_des_k(temp, esat, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es_des_1d',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es_des_1d

!#######################################################################

! <SUBROUTINE NAME="lookup_es_des_2d" INTERFACE="lookup_es_des">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:,:)"></OUT>
!   <OUT NAME="desat" UNITS="pascal / degree" TYPE="real" DIM="(:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es_des_2d ( temp, esat, desat, err_msg )

 real, dimension(:,:), intent(in)  :: temp
 real, dimension(:,:), intent(out) :: esat, desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es_des_k(temp, esat, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es_des_2d',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es_des_2d

!#######################################################################

! <SUBROUTINE NAME="lookup_es_des_3d" INTERFACE="lookup_es_des">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:,:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:,:,:)"></OUT>
!   <OUT NAME="desat" UNITS="pascal / degree" TYPE="real" DIM="(:,:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es_des_3d ( temp, esat, desat, err_msg )

 real, dimension(:,:,:), intent(in)  :: temp
 real, dimension(:,:,:), intent(out) :: esat, desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es_des_k(temp, esat, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es_des_3d',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es_des_3d

!#######################################################################
!#######################################################################

! <SUBROUTINE NAME="lookup_es2_des2_0d" INTERFACE="lookup_es2_des2">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(scalar)"></OUT>
!   <OUT NAME="desat" UNITS="pascal / degree" TYPE="real" DIM="(scalar)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es2_des2_0d ( temp, esat, desat, err_msg )

 real, intent(in)  :: temp
 real, intent(out) :: esat, desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es2_des2_k(temp, esat, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es2_des2',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es2_des2_0d

!#######################################################################

! <SUBROUTINE NAME="lookup_es2_des2_1d" INTERFACE="lookup_es2_des2">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:)"></OUT>
!   <OUT NAME="desat" UNITS="pascal / degree" TYPE="real" DIM="(:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es2_des2_1d ( temp, esat, desat, err_msg )

 real, dimension(:), intent(in)  :: temp
 real, dimension(:), intent(out) :: esat, desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es2_des2_k(temp, esat, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es2_des2',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es2_des2_1d

!#######################################################################

! <SUBROUTINE NAME="lookup_es2_des2_2d" INTERFACE="lookup_es2_des2">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:,:)"></OUT>
!   <OUT NAME="desat" UNITS="pascal / degree" TYPE="real" DIM="(:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es2_des2_2d ( temp, esat, desat, err_msg )

 real, dimension(:,:), intent(in)  :: temp
 real, dimension(:,:), intent(out) :: esat, desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es2_des2_k(temp, esat, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es2_des2',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es2_des2_2d

!#######################################################################

! <SUBROUTINE NAME="lookup_es2_des2_3d" INTERFACE="lookup_es2_des2">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:,:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:,:,:)"></OUT>
!   <OUT NAME="desat" UNITS="pascal / degree" TYPE="real" DIM="(:,:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es2_des2_3d ( temp, esat, desat, err_msg )

 real, dimension(:,:,:), intent(in)  :: temp
 real, dimension(:,:,:), intent(out) :: esat, desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es2_des2_k(temp, esat, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es2_des2',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es2_des2_3d


!#######################################################################
!#######################################################################

! <SUBROUTINE NAME="lookup_es3_des3_0d" INTERFACE="lookup_es3_des3">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(scalar)"></OUT>
!   <OUT NAME="desat" UNITS="pascal / degree" TYPE="real" DIM="(scalar)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es3_des3_0d ( temp, esat, desat, err_msg )

 real, intent(in)  :: temp
 real, intent(out) :: esat, desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es3_des3_k(temp, esat, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es3_des3',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es3_des3_0d

!#######################################################################

! <SUBROUTINE NAME="lookup_es3_des3_1d" INTERFACE="lookup_es3_des3">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:)"></OUT>
!   <OUT NAME="desat" UNITS="pascal / degree" TYPE="real" DIM="(:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es3_des3_1d ( temp, esat, desat, err_msg )

 real, dimension(:), intent(in)  :: temp
 real, dimension(:), intent(out) :: esat, desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es3_des3_k(temp, esat, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es3_des3',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es3_des3_1d

!#######################################################################

! <SUBROUTINE NAME="lookup_es3_des3_2d" INTERFACE="lookup_es3_des3">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:,:)"></OUT>
!   <OUT NAME="desat" UNITS="pascal / degree" TYPE="real" DIM="(:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es3_des3_2d ( temp, esat, desat, err_msg )

 real, dimension(:,:), intent(in)  :: temp
 real, dimension(:,:), intent(out) :: esat, desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es3_des3_k(temp, esat, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es3_des3',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es3_des3_2d

!#######################################################################

! <SUBROUTINE NAME="lookup_es3_des3_3d" INTERFACE="lookup_es3_des3">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:,:)"></IN>
!   <OUT NAME="esat" UNITS="pascal" TYPE="real" DIM="(:,:,:)"></OUT>
!   <OUT NAME="desat" UNITS="pascal / degree" TYPE="real" DIM="(:,:,:)"></OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine lookup_es3_des3_3d ( temp, esat, desat, err_msg )

 real, dimension(:,:,:), intent(in)  :: temp
 real, dimension(:,:,:), intent(out) :: esat, desat
 character(len=*), intent(out), optional :: err_msg

 integer :: nbad
 character(len=128) :: err_msg_local

   if (.not.module_is_initialized) call sat_vapor_pres_init

   call lookup_es3_des3_k(temp, esat, desat, nbad)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_local,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('lookup_es3_des3',err_msg_local,err_msg)) return
   endif

 end subroutine lookup_es3_des3_3d

!#######################################################################

! <SUBROUTINE NAME="compute_qs_0d" INTERFACE="compute_qs">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(SCALAR)"></IN>
!   <IN NAME="press UNIT="Pascals" TYPE="real" DIM="(SCALAR)"></IN>
!   <OUT NAME="qsat" UNITS="kg(vapor)/kg(moist air)" TYPE="real" DIM="(SCALAR)"></OUT>
!   <IN NAME="q" UNIT="kg(vapor)/kg(moistair)" TYPE="real" DIM="(SCALAR)"></IN>
!   <IN NAME="hc" UNIT="fraction" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="dqsdT" UNIT="kg(vapor)/kg(moistair)/ degree Kelvin" TYPE="real" DIM="(SCALAR)"></OUT>
!   <OUT NAME="esat" UNITS="Pascals" TYPE="real" DIM="(scalar)"> </OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine compute_qs_0d ( temp, press, qsat, q, hc, dqsdT, esat, &
                            err_msg, es_over_liq, es_over_liq_and_ice )

 real, intent(in)                        :: temp, press
 real, intent(out)                       :: qsat
 real, intent(in),              optional :: q, hc
 real, intent(out),             optional :: dqsdT, esat
 character(len=*), intent(out), optional :: err_msg
 logical,intent(in),            optional :: es_over_liq
 logical,intent(in),            optional :: es_over_liq_and_ice

 integer :: nbad
 character(len=128) :: err_msg_tmp

   if (.not.module_is_initialized) call sat_vapor_pres_init

   if (present(es_over_liq)) then
     if (.not. (construct_table_wrt_liq)) then
       call error_mesg ('compute_qs', &
          'requesting es wrt liq, but that table not constructed', &
                                                                FATAL)
     endif
   endif
   if (present(es_over_liq_and_ice)) then
     if (.not. (construct_table_wrt_liq_and_ice)) then
       call error_mesg ('compute_qs', &
      'requesting es wrt liq and ice, but that table not constructed', &
                                                                FATAL)
     endif
   endif

   call compute_qs_k (temp, press,  EPSILO, ZVIR, qsat, nbad, q, hc, &
                       dqsdT, esat, es_over_liq, es_over_liq_and_ice)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_tmp,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('compute_qs',err_msg_tmp,err_msg)) return
   endif

 end subroutine compute_qs_0d
 
!#######################################################################

! <SUBROUTINE NAME="compute_qs_1d" INTERFACE="compute_qs">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:)"></IN>
!   <IN NAME="press UNIT="Pascals" TYPE="real" DIM="(:)"></IN>
!   <OUT NAME="qsat" UNITS="kg(vapor)/kg(moist air)" TYPE="real" DIM="(:)"></OUT>
!   <IN NAME="q" UNIT="kg(vapor)/kg(moistair)" TYPE="real" DIM="(:)"></IN>
!   <IN NAME="hc" UNIT="fraction" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="dqsdT" UNIT="kg(vapor)/kg(moistair)/ degree Kelvin" TYPE="real" DIM="(:)"></OUT>
!   <OUT NAME="esat" UNITS="Pascals" TYPE="real" DIM="(:)"> </OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine compute_qs_1d ( temp, press, qsat, q, hc, dqsdT, esat, &
                            err_msg, es_over_liq, es_over_liq_and_ice )

 real, intent(in)                        :: temp(:), press(:)
 real, intent(out)                       :: qsat(:)
 real, intent(in),              optional :: q(:)
real,  intent(in),              optional :: hc
 real, intent(out),             optional :: dqsdT(:), esat(:)
 character(len=*), intent(out), optional :: err_msg
 logical,intent(in),            optional :: es_over_liq
 logical,intent(in),            optional :: es_over_liq_and_ice

 integer :: nbad
 character(len=128) :: err_msg_tmp

   if (.not.module_is_initialized) call sat_vapor_pres_init

   if (present(es_over_liq)) then
     if (.not. (construct_table_wrt_liq)) then
       call error_mesg ('compute_qs', &
          'requesting es wrt liq, but that table not constructed', &
                                                                FATAL)
     endif
   endif
   if (present(es_over_liq_and_ice)) then
     if (.not. (construct_table_wrt_liq_and_ice)) then
       call error_mesg ('compute_qs', &
      'requesting es wrt liq and ice, but that table not constructed', &
                                                                FATAL)
     endif
   endif

!  call compute_qs_k (temp, press,  EPSILO, ZVIR, qsat, nbad, q, dqsdT)
   call compute_qs_k (temp, press,  EPSILO, ZVIR, qsat, nbad, q, hc, &
                       dqsdT, esat, es_over_liq, es_over_liq_and_ice)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_tmp,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('compute_qs',err_msg_tmp,err_msg)) return
   endif

 end subroutine compute_qs_1d


!#######################################################################

! <SUBROUTINE NAME="compute_qs_2d" INTERFACE="compute_qs">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:)"></IN>
!   <IN NAME="press UNIT="Pascals" TYPE="real" DIM="(:,:)"></IN>
!   <OUT NAME="qsat" UNITS="kg(vapor)/kg(moist air)" TYPE="real" DIM="(;,:)"></OUT>
!   <IN NAME="q" UNIT="kg(vapor)/kg(moistair)" TYPE="real" DIM="(:,:)"></IN>
!   <IN NAME="hc" UNIT="fraction" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="dqsdT" UNIT="kg(vapor)/kg(moistair)/ degree Kelvin" TYPE="real" DIM="(:,:)"></OUT>
!   <OUT NAME="esat" UNITS="Pascals" TYPE="real" DIM="(:,:)"> </OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine compute_qs_2d ( temp, press, qsat, q, hc, dqsdT, esat, &
                            err_msg, es_over_liq, es_over_liq_and_ice )

 real, intent(in)                        :: temp(:,:), press(:,:)
 real, intent(out)                       :: qsat(:,:)
 real, intent(in),              optional :: q(:,:)
 real, intent(in),              optional :: hc      
 real, intent(out),             optional :: dqsdT(:,:), esat(:,:)
 character(len=*), intent(out), optional :: err_msg
 logical,intent(in),            optional :: es_over_liq
 logical,intent(in),            optional :: es_over_liq_and_ice

 integer :: nbad
 character(len=128) :: err_msg_tmp

   if (.not.module_is_initialized) call sat_vapor_pres_init

   if (present(es_over_liq)) then
     if (.not. (construct_table_wrt_liq)) then
       call error_mesg ('compute_qs', &
          'requesting es wrt liq, but that table not constructed', &
                                                                FATAL)
     endif
   endif
   if (present(es_over_liq_and_ice)) then
     if (.not. (construct_table_wrt_liq_and_ice)) then
       call error_mesg ('compute_qs', &
      'requesting es wrt liq and ice, but that table not constructed', &
                                                                FATAL)
     endif
   endif

!  call compute_qs_k (temp, press,  EPSILO, ZVIR, qsat, nbad, q, dqsdT)
   call compute_qs_k (temp, press,  EPSILO, ZVIR, qsat, nbad, q, hc, &
                       dqsdT, esat, es_over_liq, es_over_liq_and_ice)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_tmp,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('compute_qs',err_msg_tmp,err_msg)) return
   endif

 end subroutine compute_qs_2d

!#######################################################################

! <SUBROUTINE NAME="compute_qs_3d" INTERFACE="compute_qs">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:,:)"></IN>
!   <IN NAME="press UNIT="Pascals" TYPE="real" DIM="(:,:,:)"></IN>
!   <OUT NAME="qsat" UNITS="kg(vapor)/kg(moist air)" TYPE="real" DIM="(;,:,:)"></OUT>
!   <IN NAME="q" UNIT="kg(vapor)/kg(moistair)" TYPE="real" DIM="(:,:,:)"></IN>
!   <IN NAME="hc" UNIT="fraction" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="dqsdT" UNIT="kg(vapor)/kg(moistair)/ degree Kelvin" TYPE="real" DIM="(:,:,:)"></OUT>
!   <OUT NAME="esat" UNITS="Pascals" TYPE="real" DIM="(:,:,:)"> </OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine compute_qs_3d ( temp, press, qsat, q, hc, dqsdT, esat, &
                            err_msg, es_over_liq, es_over_liq_and_ice )

 real, intent(in)                        :: temp(:,:,:), press(:,:,:)
 real, intent(out)                       :: qsat(:,:,:)
 real, intent(in),              optional :: q(:,:,:)
 real, intent(in),              optional :: hc           
 real, intent(out),             optional :: dqsdT(:,:,:), esat(:,:,:)
 character(len=*), intent(out), optional :: err_msg
 logical,intent(in),            optional :: es_over_liq
 logical,intent(in),            optional :: es_over_liq_and_ice

 integer :: nbad
 character(len=128) :: err_msg_tmp

   if (.not.module_is_initialized) call sat_vapor_pres_init

   if (present(es_over_liq)) then
     if (.not. (construct_table_wrt_liq)) then
       call error_mesg ('compute_qs', &
          'requesting es wrt liq, but that table not constructed', &
                                                                FATAL)
     endif
   endif
   if (present(es_over_liq_and_ice)) then
     if (.not. (construct_table_wrt_liq_and_ice)) then
       call error_mesg ('compute_qs', &
      'requesting es wrt liq and ice, but that table not constructed', &
                                                                FATAL)
     endif
   endif

!  call compute_qs_k (temp, press,  EPSILO, ZVIR, qsat, nbad, q, dqsdT)
   call compute_qs_k (temp, press,  EPSILO, ZVIR, qsat, nbad, q, hc, &
                       dqsdT, esat, es_over_liq, es_over_liq_and_ice)


   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_tmp,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('compute_qs',err_msg_tmp,err_msg)) return
   endif

 end subroutine compute_qs_3d

!#######################################################################
!#######################################################################

! <SUBROUTINE NAME="compute_mrs_0d" INTERFACE="compute_mrs">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(SCALAR)"></IN>
!   <IN NAME="press" UNIT="Pascals" TYPE="real" DIM="(SCALAR)"></IN>
!   <OUT NAME="mrsat" UNITS="kg(vapor)/kg(dry air)" TYPE="real" DIM="(SCALAR</OUT>
!   <IN NAME="mr" UNIT="kg(vapor)/kg(dry air)" TYPE="real" DIM="(SCALAR)"></IN>
!   <IN NAME="hc" UNIT="fraction" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="dmrsdT" UNIT="kg(vapor)/kg(dry air)/ degree Kelvin" TYPE="real" DIM="(SCALAR)"></OUT>
!   <OUT NAME="esat" UNITS="Pascals" TYPE="real" DIM="(scalar)"> </OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine compute_mrs_0d ( temp, press, mrsat, mr, hc, dmrsdT, esat, &
                            err_msg, es_over_liq, es_over_liq_and_ice )

 real, intent(in)                        :: temp, press             
 real, intent(out)                       :: mrsat
 real, intent(in),              optional :: mr, hc
 real, intent(out),             optional :: dmrsdT, esat
 character(len=*), intent(out), optional :: err_msg
 logical,intent(in),            optional :: es_over_liq
 logical,intent(in),            optional :: es_over_liq_and_ice

 integer :: nbad
 character(len=128) :: err_msg_tmp

   if (.not.module_is_initialized) call sat_vapor_pres_init

   if (present(es_over_liq)) then
     if (.not. (construct_table_wrt_liq)) then
       call error_mesg ('compute_mrs', &
          'requesting es wrt liq, but that table not constructed', &
                                                                FATAL)
     endif
   endif
   if (present(es_over_liq_and_ice)) then
     if (.not. (construct_table_wrt_liq_and_ice)) then
       call error_mesg ('compute_qs', &
      'requesting es wrt liq and ice, but that table not constructed', &
                                                                FATAL)
     endif
   endif

   call compute_mrs_k (temp, press, EPSILO, ZVIR, mrsat, nbad, mr,  &
                     hc, dmrsdT, esat, es_over_liq, es_over_liq_and_ice)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_tmp,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('compute_mrs',err_msg_tmp,err_msg)) return
   endif

 end subroutine compute_mrs_0d

!#######################################################################
!#######################################################################

! <SUBROUTINE NAME="compute_mrs_1d" INTERFACE="compute_mrs">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:)"></IN>
!   <IN NAME="press" UNIT="Pascals" TYPE="real" DIM="(:)"></IN>
!   <OUT NAME="mrsat" UNITS="kg(vapor)/kg(dry air)" TYPE="real" DIM="(:)"></OUT>
!   <IN NAME="mr" UNIT="kg(vapor)/kg(dry air)" TYPE="real" DIM="(:)"></IN>
!   <IN NAME="hc" UNIT="fraction" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="dmrsdT" UNIT="kg(vapor)/kg(dry air)/ degree Kelvin" TYPE="real" DIM="(:)"></OUT>
!   <OUT NAME="esat" UNITS="Pascals" TYPE="real" DIM="(:)"> </OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine compute_mrs_1d ( temp, press, mrsat, mr, hc, dmrsdT, esat,&
                            err_msg, es_over_liq, es_over_liq_and_ice )

 real, intent(in)                        :: temp(:), press(:)       
 real, intent(out)                       :: mrsat(:)
 real, intent(in),              optional :: mr(:)
 real, intent(in),              optional :: hc     
 real, intent(out),             optional :: dmrsdT(:), esat(:)
 character(len=*), intent(out), optional :: err_msg
 logical,intent(in),            optional :: es_over_liq
 logical,intent(in),            optional :: es_over_liq_and_ice

 integer :: nbad
 character(len=128) :: err_msg_tmp

   if (.not.module_is_initialized) call sat_vapor_pres_init

   if (present(es_over_liq)) then
     if (.not. (construct_table_wrt_liq)) then
       call error_mesg ('compute_mrs', &
          'requesting es wrt liq, but that table not constructed', &
                                                                FATAL)
     endif
   endif
   if (present(es_over_liq_and_ice)) then
     if (.not. (construct_table_wrt_liq_and_ice)) then
       call error_mesg ('compute_qs', &
      'requesting es wrt liq and ice, but that table not constructed', &
                                                                FATAL)
     endif
   endif

!  call compute_mrs_k (temp, press, EPSILO, ZVIR, mrsat,  &
!                                                     nbad, mr, dmrsdT)
   call compute_mrs_k (temp, press, EPSILO, ZVIR, mrsat, nbad, mr,  &
                     hc, dmrsdT, esat, es_over_liq, es_over_liq_and_ice)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_tmp,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('compute_mrs',err_msg_tmp,err_msg)) return
   endif

 end subroutine compute_mrs_1d

!#######################################################################

! <SUBROUTINE NAME="compute_mrs_2d" INTERFACE="compute_mrs">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:)"></IN>
!   <IN NAME="press" UNIT="Pascals" TYPE="real" DIM="(:,:)"></IN>
!   <OUT NAME="mrsat" UNITS="kg(vapor)/kg(dry air)" TYPE="real" DIM="(:,:)"></OUT>
!   <IN NAME="mr" UNIT="kg(vapor)/kg(dry air)" TYPE="real" DIM="(:,:)"></IN>
!   <IN NAME="hc" UNIT="fraction" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="dmrsdT" UNIT="kg(vapor)/kg(dry air)/ degree Kelvin" TYPE="real" DIM="(:,:)"></OUT>
!   <OUT NAME="esat" UNITS="Pascals" TYPE="real" DIM="(:,:)"> </OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine compute_mrs_2d ( temp, press, mrsat, mr, hc, dmrsdT, esat,&
                            err_msg, es_over_liq, es_over_liq_and_ice )

 real, intent(in)                        :: temp(:,:), press(:,:)    
 real, intent(out)                       :: mrsat(:,:)
 real, intent(in),              optional :: mr(:,:)
 real, intent(in),              optional :: hc         
 real, intent(out),             optional :: dmrsdT(:,:), esat(:,:)
 character(len=*), intent(out), optional :: err_msg
 logical,intent(in),            optional :: es_over_liq
 logical,intent(in),            optional :: es_over_liq_and_ice

 integer :: nbad
 character(len=128) :: err_msg_tmp

   if (.not.module_is_initialized) call sat_vapor_pres_init

   if (present(es_over_liq)) then
     if (.not. (construct_table_wrt_liq)) then
       call error_mesg ('compute_mrs', &
          'requesting es wrt liq, but that table not constructed', &
                                                                FATAL)
     endif
   endif
   if (present(es_over_liq_and_ice)) then
     if (.not. (construct_table_wrt_liq_and_ice)) then
       call error_mesg ('compute_qs', &
      'requesting es wrt liq and ice, but that table not constructed', &
                                                                FATAL)
     endif
   endif

!  call compute_mrs_k (temp, press, EPSILO, ZVIR, mrsat,  &
!                                                     nbad, mr, dmrsdT)
   call compute_mrs_k (temp, press, EPSILO, ZVIR, mrsat, nbad, mr,  &
                     hc, dmrsdT, esat, es_over_liq, es_over_liq_and_ice)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_tmp,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('compute_mrs',err_msg_tmp,err_msg)) return
   endif

 end subroutine compute_mrs_2d

!#######################################################################

! <SUBROUTINE NAME="compute_mrs_3d" INTERFACE="compute_mrs">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:,:)"></IN>
!   <IN NAME="press" UNIT="Pascals" TYPE="real" DIM="(:,:,:)"></IN>
!   <OUT NAME="mrsat" UNITS="kg(vapor)/kg(dry air)" TYPE="real" DIM="(:,:,:)"></OUT>
!   <IN NAME="mr" UNIT="kg(vapor)/kg(dry air)" TYPE="real" DIM="(:,:,:)"></IN>
!   <IN NAME="hc" UNIT="fraction" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="dmrsdT" UNIT="kg(vapor)/kg(dry air)/ degree Kelvin" TYPE="real" DIM="(:,:,:)"></OUT>
!   <OUT NAME="esat" UNITS="Pascals" TYPE="real" DIM="(:,:,:)"> </OUT>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>
! </SUBROUTINE>
 subroutine compute_mrs_3d ( temp, press, mrsat, mr, hc, dmrsdT, esat,&
                            err_msg, es_over_liq, es_over_liq_and_ice )

 real, intent(in)                        :: temp(:,:,:), press(:,:,:)  
 real, intent(out)                       :: mrsat(:,:,:)
 real, intent(in),              optional :: mr(:,:,:)
 real, intent(in),              optional :: hc           
 real, intent(out),             optional :: dmrsdT(:,:,:), esat(:,:,:)
 character(len=*), intent(out), optional :: err_msg
 logical,intent(in),            optional :: es_over_liq
 logical,intent(in),            optional :: es_over_liq_and_ice

 integer :: nbad
 character(len=128) :: err_msg_tmp

   if (.not.module_is_initialized) call sat_vapor_pres_init

   if (present(es_over_liq)) then
     if (.not. (construct_table_wrt_liq)) then
       call error_mesg ('compute_mrs', &
          'requesting es wrt liq, but that table not constructed', &
                                                                FATAL)
     endif
   endif
   if (present(es_over_liq_and_ice)) then
     if (.not. (construct_table_wrt_liq_and_ice)) then
       call error_mesg ('compute_qs', &
      'requesting es wrt liq and ice, but that table not constructed', &
                                                                FATAL)
     endif
   endif

!  call compute_mrs_k (temp, press, EPSILO, ZVIR, mrsat,   &
!                                                    nbad, mr, dmrsdT)
   call compute_mrs_k (temp, press, EPSILO, ZVIR, mrsat, nbad, mr,  &
                     hc, dmrsdT, esat, es_over_liq, es_over_liq_and_ice)

   if ( nbad == 0 ) then
     if(present(err_msg)) err_msg = ''
   else
     if(show_bad_value_count_by_slice) call temp_check ( temp )
     if(show_all_bad_values) call show_all_bad ( temp )
     write(err_msg_tmp,'(a47,i7)') 'saturation vapor pressure table overflow, nbad=', nbad
     if(fms_error_handler('compute_mrs',err_msg_tmp,err_msg)) return
   endif

 end subroutine compute_mrs_3d


!#######################################################################

!#######################################################################

! <SUBROUTINE NAME="sat_vapor_pres_init">

!   <OVERVIEW>
!     Initializes the lookup tables for saturation vapor pressure. 
!   </OVERVIEW>
!   <DESCRIPTION>
!     Initializes the lookup tables for saturation vapor pressure.
!     This routine will be called automatically the first time
!     <B>lookup_es</B> or <B>lookup_des</B> is called,
!     the user does not need to call this routine.
!     There are no arguments.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call sat_vapor_pres_init
!   </TEMPLATE>
!   <OUT NAME="err_msg" TYPE="character">  </OUT>

! </SUBROUTINE>
 subroutine sat_vapor_pres_init(err_msg)

!  =================================================================
!  +                                                               +
!  +             construction of the es table                      +
!  +                                                               +
!  + this table is constructed from es equations from the          +
!  + smithsonian tables.  the es input is computed from values     +
!  + (in one-tenth of a degree increments) of es over ice          +
!  + from -153c to 0c and values of es over water from 0c to 102c. +
!  + output table contains these data interleaved with their       +
!  + derivatives with respect to temperature except between -20c   +
!  + and 0c where blended (over water and over ice) es values and  +
!  + derivatives are calculated.                                   +
!  +   note: all es computation is done in pascals                 +
!  =================================================================

  character(len=*), intent(out), optional :: err_msg
  character(len=128) :: err_msg_local
  integer :: unit, ierr, io

! return silently if this routine has already been called
  if (module_is_initialized) return

!---- read namelist input ----
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, sat_vapor_pres_nml, iostat=io)
      ierr = check_nml_error(io,'sat_vapor_pres_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file ( )
     ierr=1; do while (ierr /= 0)
        read  (unit, nml=sat_vapor_pres_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'sat_vapor_pres_nml')
     enddo
10   call mpp_close (unit)
  endif
#endif

! write version number and namelist to log file
  call write_version_number (version, tagname)
  unit = stdlog()
  if (mpp_pe() == mpp_root_pe()) write (unit, nml=sat_vapor_pres_nml)

  if(do_simple) then
    tcmin = -173
    tcmax =  350  
  endif
  nsize = (tcmax-tcmin)*esres+1 
  nlim  = nsize-1
  call sat_vapor_pres_init_k(nsize, real(tcmin), real(tcmax), TFREEZE, HLV, &
                             RVGAS, ES0, err_msg_local, use_exact_qs, do_simple, &
                             construct_table_wrt_liq, &
                             construct_table_wrt_liq_and_ice, &
                             teps, tmin, dtinv)
  if ( err_msg_local == '' ) then
     if(present(err_msg)) err_msg = ''
  else
     if(fms_error_handler('sat_vapor_pres_init',err_msg_local,err_msg)) return
  endif

  module_is_initialized = .true.

end subroutine sat_vapor_pres_init

!#######################################################################
!#######################################################################
!-------------------------------------------------------------------
!                Computation of the es values
!
!   Saturation vapor pressure (es) values are computed from
!   equations in the Smithsonian meteorological tables page 350.
!   For temperatures < 0C, sat vapor pres is computed over ice.
!   For temperatures > -20C, sat vapor pres is computed over water.
!   Between -20C and 0C the returned value is blended (over water
!   and over ice).  All sat vapor pres values are returned in pascals.
!
!   Reference:  Smithsonian meteorological tables, page 350.
!-------------------------------------------------------------------

! <FUNCTION NAME="compute_es_1d" INTERFACE="compute_es">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:)"></IN>
!   <OUT NAME="es" UNITS="pascal" TYPE="real" DIM="(:)"></OUT>
! </FUNCTION>
!function compute_es_1d (tem) result (es)
!real, intent(in) :: tem(:)
!real :: es(size(tem,1))

!es = compute_es_k(tem, TFREEZE)

!end function compute_es_1d
!--------------------------------------------------------

! <FUNCTION NAME="compute_es_0d" INTERFACE="compute_es">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(scalar)"></IN>
!   <OUT NAME="es" UNITS="pascal" TYPE="real" DIM="(scalar)"></OUT>
! </FUNCTION>
!function compute_es_0d (tem) result (es)
!real, intent(in) :: tem
!real :: es
!real, dimension(1) :: tem1, es1

!  tem1(1) = tem
!  es1 = compute_es_1d (tem1)
!  es = es1(1)

!end function compute_es_0d

!--------------------------

! <FUNCTION NAME="compute_es_2d" INTERFACE="compute_es">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:)"></IN>
!   <OUT NAME="es" UNITS="pascal" TYPE="real" DIM="(:,:)"></OUT>
! </FUNCTION>
!function compute_es_2d (tem) result (es)
!real, intent(in) :: tem(:,:)
!real, dimension(size(tem,1),size(tem,2)) :: es
!integer :: j

!   do j = 1, size(tem,2)
!     es(:,j) = compute_es_1d (tem(:,j))
!   enddo

!end function compute_es_2d

!--------------------------
! <FUNCTION NAME="compute_es_3d" INTERFACE="compute_es">
!   <IN NAME="temp" UNIT="degrees Kelvin" TYPE="real" DIM="(:,:,:)"></IN>
!   <OUT NAME="es" UNITS="pascal" TYPE="real" DIM="(:,:,:)"></OUT>
! </FUNCTION>
!function compute_es_3d (tem) result (es)
!real, intent(in) :: tem(:,:,:)
!real, dimension(size(tem,1),size(tem,2),size(tem,3)) :: es
!integer :: j, k

!   do k = 1, size(tem,3)
!   do j = 1, size(tem,2)
!     es(:,j,k) = compute_es_1d (tem(:,j,k))
!   enddo
!   enddo

!end function compute_es_3d

!#######################################################################

 function check_1d ( temp ) result ( nbad )
 real   , intent(in)  :: temp(:)
 integer :: nbad, ind, i

   nbad = 0
   do i = 1, size(temp,1)
     ind = int(dtinv*(temp(i)-tmin+teps))
     if (ind < 0 .or. ind > nlim) nbad = nbad+1
   enddo

 end function check_1d

!------------------------------------------------

 function check_2d ( temp ) result ( nbad )
 real   , intent(in)  :: temp(:,:)
 integer :: nbad
 integer :: j

    nbad = 0
    do j = 1, size(temp,2)
      nbad = nbad + check_1d ( temp(:,j) )
    enddo
 end function check_2d

!#######################################################################

 subroutine temp_check_1d ( temp )
 real   , intent(in) :: temp(:)
 integer :: i, unit

   unit = stdout()
   write(unit,*) 'Bad temperatures (dimension 1): ', (check_1d(temp(i:i)),i=1,size(temp,1))

 end subroutine temp_check_1d

!--------------------------------------------------------------

 subroutine temp_check_2d ( temp )
 real   , intent(in) :: temp(:,:)
 integer :: i, j, unit

   unit = stdout()
   write(unit,*) 'Bad temperatures (dimension 1): ', (check_1d(temp(i,:)),i=1,size(temp,1))
   write(unit,*) 'Bad temperatures (dimension 2): ', (check_1d(temp(:,j)),j=1,size(temp,2))

 end subroutine temp_check_2d

!--------------------------------------------------------------

 subroutine temp_check_3d ( temp )
 real, intent(in)  :: temp(:,:,:)
 integer :: i, j, k, unit

   unit = stdout()
   write(unit,*) 'Bad temperatures (dimension 1): ', (check_2d(temp(i,:,:)),i=1,size(temp,1))
   write(unit,*) 'Bad temperatures (dimension 2): ', (check_2d(temp(:,j,:)),j=1,size(temp,2))
   write(unit,*) 'Bad temperatures (dimension 3): ', (check_2d(temp(:,:,k)),k=1,size(temp,3))

 end subroutine temp_check_3d

!#######################################################################

subroutine show_all_bad_0d ( temp )
 real   , intent(in) :: temp
 integer :: ind, unit

 unit = stdout()
 ind = int(dtinv*(temp-tmin+teps))
 if (ind < 0 .or. ind > nlim) then
   write(unit,'(a,e10.3,a,i6)') 'Bad temperature=',temp,' pe=',mpp_pe()
 endif
 
 end subroutine show_all_bad_0d

!--------------------------------------------------------------

 subroutine show_all_bad_1d ( temp )
 real   , intent(in) :: temp(:)
 integer :: i, ind, unit

 unit = stdout()
 do i=1,size(temp)
   ind = int(dtinv*(temp(i)-tmin+teps))
   if (ind < 0 .or. ind > nlim) then
     write(unit,'(a,e10.3,a,i7,a,i6)') 'Bad temperature=',temp(i),'  at i=',i,' pe=',mpp_pe()
   endif
 enddo

 end subroutine show_all_bad_1d

!--------------------------------------------------------------

 subroutine show_all_bad_2d ( temp )
 real   , intent(in) :: temp(:,:)
 integer :: i, j, ind, unit

 unit = stdout()
 do j=1,size(temp,2)
 do i=1,size(temp,1)
   ind = int(dtinv*(temp(i,j)-tmin+teps))
   if (ind < 0 .or. ind > nlim) then
     write(unit,'(a,e10.3,a,i4,a,i4,a,i6)') 'Bad temperature=',temp(i,j),'  at i=',i,' j=',j,' pe=',mpp_pe()
   endif
 enddo
 enddo

 end subroutine show_all_bad_2d

!--------------------------------------------------------------

 subroutine show_all_bad_3d ( temp )
 real, intent(in)  :: temp(:,:,:)
 integer :: i, j, k, ind, unit

 unit = stdout()
 do k=1,size(temp,3)
 do j=1,size(temp,2)
 do i=1,size(temp,1)
   ind = int(dtinv*(temp(i,j,k)-tmin+teps))
   if (ind < 0 .or. ind > nlim) then
     write(unit,'(a,e10.3,a,i4,a,i4,a,i4,a,i6)') 'Bad temperature=',temp(i,j,k),'  at i=',i,' j=',j,' k=',k,' pe=',mpp_pe()
   endif
 enddo
 enddo
 enddo

 end subroutine show_all_bad_3d

!#######################################################################
end module sat_vapor_pres_mod
!#######################################################################

! <INFO>

!   <REFERENCE>            
!     Smithsonian Meteorological Tables Page 350.
!   </REFERENCE>

!   <BUG>                  
!     No error checking is done to make sure that the size of the
!     input and output fields match.
!   </BUG>

!   <NOTE>
!     1. <B>Vectorization</B><BR/>
!        To create a vector version the lookup routines need to be modified.
!    The local variables: tmp, del, ind, should be changed to arrays
!    with the same size and order as input array temp.
!
!     2. <B>Construction of the <TT>ES</TT> tables</B><BR/>
!         The tables are constructed using the saturation vapor pressure (<TT>ES</TT>)
!    equations in the Smithsonian tables. The tables are valid between
!    -160C to +100C with increments at 1/10 degree. Between -160C and -20C
!    values of <TT>ES</TT> over ice are used, between 0C and 100C values of<TT> ES</TT>
!    over water are used, between -20C and 0C blended values of <TT>ES</TT>
!    (over water and over ice) are used.
!
!    There are three tables constructed: <TT>ES</TT>, first derivative 
!       (<TT>ES'</TT>), and
!    second derivative (<TT>ES</TT>'').  The ES table is constructed directly from
!    the equations in the Smithsonian tables. The <TT>ES</TT>' table is constructed
!    by bracketing temperature values at +/- 0.01 degrees. The <TT>ES</TT>'' table
!    is estimated by using centered differencing of the <TT>ES</TT>' table.
!
!     3. <B>Determination of <TT>es</TT> and <TT>es'</TT> from lookup tables</B><BR/>
!         Values of the saturation vapor pressure (<TT>es</TT>) and the 
!    derivative (<TT>es'</TT>) are determined at temperature (T) from the lookup 
!    tables (<TT>ES</TT>, <TT>ES'</TT>, <TT>ES''</TT>)
!    using the following formula.
!<PRE>
!    es (T) = ES(t) + ES'(t) * dt + 0.5 * ES''(t) * dt**2
!    es'(T) = ES'(t) + ES''(t) * dt
!
!    where     t = lookup table temperature closest to T
!             dt = T - t
!</PRE>
!
!     4. Internal (private) parameters<BR/>
!       These parameters can be modified to increase/decrease the size/range
!    of the lookup tables.
!<PRE>
!!    tcmin   The minimum temperature (in deg C) in the lookup tables.
!!              [integer, default: tcmin = -160]
!!
!!    tcmax   The maximum temperature (in deg C) in the lookup tables.
!!              [integer, default: tcmin = +100]
!!</PRE>
!!   </NOTE>
!
!!   <TESTPROGRAM NAME="test_sat_vapor_pres">
!<PRE>
!use sat_vapor_pres_mod
!implicit none
!
!integer, parameter :: ipts=500, jpts=100, kpts=50, nloop=1
!real, dimension(ipts,jpts,kpts) :: t,es,esn,des,desn
!integer :: n
!
!! generate temperatures between 120K and 340K
!  call random_number (t)
!  t = 130. + t * 200.
!
!! initialize the tables (optional)
!  call sat_vapor_pres_init
!
!! compute actual es and "almost" actual des
!   es = compute_es  (t)
!  des = compute_des (t)
!
!do n = 1, nloop
!! es and des
!  call lookup_es  (t, esn)
!  call lookup_des (t,desn)
!enddo
!
!! terminate, print deviation from actual
!  print *, 'size=',ipts,jpts,kpts,nloop
!  print *, 'err es  = ', sum((esn-es)**2)
!  print *, 'err des = ', sum((desn-des)**2)
!
!contains
!
!!----------------------------------
!! routine to estimate derivative
!
! function compute_des (tem) result (des)
! real, intent(in) :: tem(:,:,:)
! real, dimension(size(tem,1),size(tem,2),size(tem,3)) :: des,esp,esm
! real, parameter :: tdel = .01
!    esp = compute_es (tem+tdel)
!    esm = compute_es (tem-tdel)
!    des = (esp-esm)/(2*tdel)
! end function compute_des
!!----------------------------------
!
!end program test_sat_vapor_pres
!</PRE>
!   </TESTPROGRAM>
! </INFO>

module ensemble_manager_mod


  use fms_mod, only : open_namelist_file,close_file,check_nml_error
  use mpp_mod, only : mpp_npes, stdout, stdlog, mpp_error, FATAL
  use mpp_mod, only : mpp_pe, mpp_declare_pelist
  use mpp_mod, only : input_nml_file
  use fms_io_mod, only       : set_filename_appendix 

  IMPLICIT NONE

  private

  integer, parameter :: MAX_ENSEMBLE_SIZE = 100


  integer, allocatable, dimension(:,:) :: ensemble_pelist
  integer, allocatable, dimension(:,:) :: ensemble_pelist_ocean
  integer, allocatable, dimension(:,:) :: ensemble_pelist_atmos
  integer, allocatable, dimension(:,:) :: ensemble_pelist_land
  integer, allocatable, dimension(:,:) :: ensemble_pelist_ice
  integer, allocatable, dimension(:)   :: ensemble_pelist_ocean_filter
  integer, allocatable, dimension(:)   :: ensemble_pelist_atmos_filter
  integer, allocatable, dimension(:)   :: ensemble_pelist_land_filter
  integer, allocatable, dimension(:)   :: ensemble_pelist_ice_filter

  integer :: ensemble_size = 1
  integer :: ensemble_id = 1
  integer :: pe, total_npes_pm=0,ocean_npes_pm=0,atmos_npes_pm=0 
  integer :: land_npes_pm=0,ice_npes_pm=0 

  public :: ensemble_manager_init, get_ensemble_id, get_ensemble_size, get_ensemble_pelist
  public :: ensemble_pelist_setup
  public :: get_ensemble_filter_pelist
contains  

  subroutine ensemble_manager_init()


    integer :: i, io_status, ioun, npes, ierr

    namelist /ensemble_nml/ ensemble_size

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, ensemble_nml, iostat=io_status)
#else
    ioun = open_namelist_file()
    read(ioun,nml=ensemble_nml,iostat = io_status)
    call close_file(ioun)
#endif
    ierr = check_nml_error(io_status, 'ensemble_nml')

    if(ensemble_size < 1) call mpp_error(FATAL, &
       'ensemble_manager_mod: ensemble_nml variable ensemble_size must be a positive integer')
    if(ensemble_size > max_ensemble_size)  call mpp_error(FATAL, &
       'ensemble_manager_mod: ensemble_nml variable ensemble_size should be no larger than MAX_ENSEMBLE_SIZE, '// &
       'change ensemble_size or increase MAX_ENSEMBLE_SIZE')

    pe = mpp_pe()
    npes = mpp_npes()
    total_npes_pm = npes/ensemble_size
    if (mod(npes, total_npes_pm) /= 0) call mpp_error(FATAL,'ensemble_size must be divis by npes')

    call mpp_declare_pelist((/(i,i=0,npes-1)/),'_ens0') ! for ensemble driver

  end subroutine ensemble_manager_init

  function get_ensemble_id()
    integer :: get_ensemble_id
    get_ensemble_id = ensemble_id
  end function get_ensemble_id

  function get_ensemble_size()

    integer, dimension(6) :: get_ensemble_size

    get_ensemble_size(1) = ensemble_size
    get_ensemble_size(2) = total_npes_pm
    get_ensemble_size(3) = ocean_npes_pm
    get_ensemble_size(4) = atmos_npes_pm
    get_ensemble_size(5) = land_npes_pm
    get_ensemble_size(6) = ice_npes_pm

  end function get_ensemble_size


  subroutine get_ensemble_pelist(pelist, name)

    integer, intent(inout) :: pelist(:,:)
    character(len=*), intent(in), optional  :: name

    if (size(pelist,1) < ensemble_size) &
         call mpp_error(FATAL,'get_ensemble_pelist: size of pelist 1st index < ensemble_size')

    if(present(name)) then
       select case(name)
       case('ocean')
          if (size(pelist,2) < ocean_npes_pm)&
               call mpp_error(FATAL,'get_ensemble_pelist: size of pelist 2nd index < ocean_npes_pm') 
          pelist = 0       
          pelist(1:ensemble_size,1:ocean_npes_pm) = &
               ensemble_pelist_ocean(1:ensemble_size,1:ocean_npes_pm)

       case('atmos')
          if (size(pelist,2) < atmos_npes_pm)&
               call mpp_error(FATAL,'get_ensemble_pelist: size of pelist 2nd index < atmos_npes_pm') 
          pelist = 0       
          pelist(1:ensemble_size,1:atmos_npes_pm) = &
               ensemble_pelist_atmos(1:ensemble_size,1:atmos_npes_pm)

       case('land')
          if (size(pelist,2) < land_npes_pm)&
               call mpp_error(FATAL,'get_ensemble_pelist: size of pelist 2nd index < land_npes_pm') 
          pelist = 0       
          pelist(1:ensemble_size,1:land_npes_pm) = &
               ensemble_pelist_land(1:ensemble_size,1:land_npes_pm)

       case('ice')
          if (size(pelist,2) < ice_npes_pm)&
               call mpp_error(FATAL,'get_ensemble_pelist: size of pelist 2nd index < ice_npes_pm') 
          pelist = 0       
          pelist(1:ensemble_size,1:ice_npes_pm) = &
               ensemble_pelist_ice(1:ensemble_size,1:ice_npes_pm)

       case default
          call mpp_error(FATAL,'get_ensemble_pelist: unknown argument name='//name)
       end select
    else
       if (size(pelist,2) < total_npes_pm)&
            call mpp_error(FATAL,'get_ensemble_pelist: size of pelist 2nd index < total_npes_pm') 
       pelist = 0       
       pelist(1:ensemble_size,1:total_npes_pm) = &
            ensemble_pelist(1:ensemble_size,1:total_npes_pm)
    endif

    return
  end subroutine get_ensemble_pelist

  subroutine get_ensemble_filter_pelist(pelist, name)

    integer, intent(inout) :: pelist(:)
    character(len=*), intent(in)  :: name

    select case(name)
    case('ocean')
       if (size(pelist) < ensemble_size * ocean_npes_pm)&
            call mpp_error(FATAL,'get_ensemble_filter_pelist: size of pelist argument < ensemble_size * ocean_npes_pm') 
       pelist = 0       
       pelist(1:ensemble_size*ocean_npes_pm) = &
            ensemble_pelist_ocean_filter(1:ensemble_size*ocean_npes_pm)

    case('atmos')
       if (size(pelist) < ensemble_size * atmos_npes_pm)&
            call mpp_error(FATAL,'get_ensemble_filter_pelist: size of pelist argument < ensemble_size * atmos_npes_pm') 
       pelist = 0       
       pelist(1:ensemble_size*atmos_npes_pm) = &
            ensemble_pelist_atmos_filter(1:ensemble_size*atmos_npes_pm)

    case('land')
       if (size(pelist) < ensemble_size * land_npes_pm)&
            call mpp_error(FATAL,'get_ensemble_filter_pelist: size of pelist argument < ensemble_size * land_npes_pm') 
       pelist = 0       
       pelist(1:ensemble_size*land_npes_pm) = &
            ensemble_pelist_land_filter(1:ensemble_size*land_npes_pm)

    case('ice')
       if (size(pelist) < ensemble_size * ice_npes_pm)&
            call mpp_error(FATAL,'get_ensemble_filter_pelist: size of pelist argument < ensemble_size * ice_npes_pm') 
       pelist = 0       
       pelist(1:ensemble_size*ice_npes_pm) = &
            ensemble_pelist_ice_filter(1:ensemble_size*ice_npes_pm)

    case default
       call mpp_error(FATAL,'get_ensemble_filter_pelist: unknown argument name='//name)
    end select


    return
  end subroutine get_ensemble_filter_pelist

!nnz: I think the following block of code should be contained in a subroutine
!     to consolidate and ensure the consistency of declaring the various pelists.

  subroutine ensemble_pelist_setup(concurrent, atmos_npes, ocean_npes, land_npes, ice_npes, &
                                   Atm_pelist, Ocean_pelist, Land_pelist, Ice_pelist)    
    logical, intent(in)                  :: concurrent
    integer, intent(in)                  :: atmos_npes, ocean_npes
    integer, intent(in)                  :: land_npes, ice_npes
    integer, dimension(:), intent(inout) :: Atm_pelist, Ocean_pelist
    integer, dimension(:), intent(inout) :: Land_pelist, Ice_pelist
    integer           :: atmos_pe_start, atmos_pe_end, ocean_pe_start, ocean_pe_end
    integer           :: land_pe_start, land_pe_end, ice_pe_start, ice_pe_end
    character(len=10) :: pelist_name, text
    integer           :: npes, n, m ,i

    npes = total_npes_pm

    ! make sure land_npes and ice_npes are not greater than atmos_npes
    if(land_npes > atmos_npes) call mpp_error(FATAL, 'ensemble_manager_mod: land_npes > atmos_npes')
    if(ice_npes  > atmos_npes) call mpp_error(FATAL, 'nsemble_manager_mod: ice_npes > atmos_npes')

    allocate(ensemble_pelist(ensemble_size,total_npes_pm))
    allocate(ensemble_pelist_ocean(1:ensemble_size, 1:ocean_npes) )
    allocate(ensemble_pelist_atmos(1:ensemble_size, 1:atmos_npes) )
    allocate(ensemble_pelist_land (1:ensemble_size, 1:land_npes) )
    allocate(ensemble_pelist_ice  (1:ensemble_size, 1:ice_npes) )

    atmos_pe_start = 0
    ocean_pe_start = 0
    land_pe_start = 0
    ice_pe_start = 0
    if( concurrent .OR. atmos_npes+ocean_npes == npes )then
       ocean_pe_start = ensemble_size*atmos_npes
    endif
    do n=1,ensemble_size
       atmos_pe_end = atmos_pe_start + atmos_npes - 1
       ocean_pe_end = ocean_pe_start + ocean_npes - 1
       land_pe_end  = land_pe_start  + land_npes  - 1
       ice_pe_end   = ice_pe_start   + ice_npes   - 1
       ensemble_pelist_atmos(n, 1:atmos_npes) = (/(i,i=atmos_pe_start,atmos_pe_end)/)
       ensemble_pelist_ocean(n, 1:ocean_npes) = (/(i,i=ocean_pe_start,ocean_pe_end)/)
       ensemble_pelist_land (n, 1:land_npes) = (/(i,i=land_pe_start, land_pe_end)/)
       ensemble_pelist_ice  (n, 1:ice_npes) = (/(i,i=ice_pe_start,  ice_pe_end)/)
       ensemble_pelist(n, 1:atmos_npes)       = ensemble_pelist_atmos(n, 1:atmos_npes)
       if( concurrent .OR. atmos_npes+ocean_npes == npes ) &
            ensemble_pelist(n, atmos_npes+1:npes)  = ensemble_pelist_ocean(n, 1:ocean_npes)
       if(ANY(ensemble_pelist(n,:) == pe)) ensemble_id = n
       write(pelist_name,'(a,i2.2)')  '_ens',n
       call mpp_declare_pelist(ensemble_pelist(n,:), trim(pelist_name))
       atmos_pe_start = atmos_pe_end + 1
       ocean_pe_start = ocean_pe_end + 1
       land_pe_start  = atmos_pe_start 
       ice_pe_start   = atmos_pe_start 
    enddo

    Atm_pelist(:)   = ensemble_pelist_atmos(ensemble_id,:)
    Ocean_pelist(:) = ensemble_pelist_ocean(ensemble_id,:)
    Land_pelist(:)  = ensemble_pelist_land (ensemble_id,:)
    Ice_pelist(:)   = ensemble_pelist_ice  (ensemble_id,:)

    !    write(pelist_name,'(a,i2.2)')  '_ocn_ens',ensemble_id
    !    call mpp_declare_pelist(Ocean%pelist , trim(pelist_name) )

    !    write(pelist_name,'(a,i2.2)')  '_atm_ens',ensemble_id
    !    call mpp_declare_pelist(Atm%pelist , trim(pelist_name) )
    !
    !nnz: The above is sufficient for non-concurrent mode.
    !     BUT
    !     For atmosphere_init to work in ensemble, concurrent mode 
    !     the following Atm_pelist should be declared (per ensemble member)
    !     instead of the above Atm%pelist!
    !     
    !   allocate( Atm_pelist(1:ensemble_size, 1:atmos_npes) )
    !   do n=1,ensemble_size
    !       do i=1, atmos_npes
    !          Atm_pelist(n, i) = ensemble_pelist(n, i)
    !       enddo
    !       write(pelist_name,'(a,i2.2)')  '_atm_ens',n
    !       call mpp_declare_pelist(Atm_pelist(n,:) , trim(pelist_name) )
    !    enddo
    !
    !     The way I understand this with the help of Totalview is:
    !     With mpp_declare_pelist(Atm%pelist)
    !     When we are in fv_arrays_init when mp_init(comID) is called
    !     comID is the same for the atmospheric PE's for both ensemble members
    !     since peset(5)%id is the same (7) for those PE's, so the PE count is double what it should be inside
    !     mp_init().
    !     It is also true that for Ocean PE's, peset(4)%id is the same (6) for Ocean PE's in both ensemble members
    !     but for Ocean it is not a problem because Ocean is not trying to create new communicators
    !     from this peset whereas ATM does (vis mp_init).
    !
    !     Who sets peset(i)%id ? Can it be modified to assign different %id for the two subsets.
    !     peset(i)%id = 0 for Ocean PE's on ATM pesets and for ATM PE's on Ocean pesets.  
    !
    !     With mpp_declare_pelist(Atm_pelist(n,:)) n=1,...,ensemble_size
    !     we get separate pesets for each ATM ensemble member and each with a different %id and mp_init is cured. 
    !
    !     There is also a matter of precedence. If we have both calls
    !     call mpp_declare_pelist(Atm%pelist , trim(pelist_name) )
    !     and
    !     call mpp_declare_pelist(Atm_pelist(n,:) , trim(pelist_name) )
    !     then concurrent run fails because with call mpp_set_current_pelist( Atm%pelist   )
    !     peset(i) is searched for i=1,2,... and the first pelist that matches argument, its peset is set as current. 
    !
    !     To be consistent with ATM and OCEAN we can do the following 
    !     (eventhough mpp_declare_pelist(Ocean%pelist) is adequate right now.) 

    if( concurrent )then
       do n=1,ensemble_size
          write(pelist_name,'(a,i2.2)')  'atm_ens',n
          call mpp_declare_pelist(ensemble_pelist_atmos(n,:) , trim(pelist_name) )
          write(pelist_name,'(a,i2.2)')  'ocn_ens',n
          call mpp_declare_pelist(ensemble_pelist_ocean(n,:) , trim(pelist_name) )
          write(pelist_name,'(a,i2.2)')  'lnd_ens',n
          call mpp_declare_pelist(ensemble_pelist_land(n,:) , trim(pelist_name) )
          write(pelist_name,'(a,i2.2)')  'ice_ens',n
          call mpp_declare_pelist(ensemble_pelist_ice(n,:) , trim(pelist_name) )
       enddo
    else
       write(pelist_name,'(a,i2.2)')  'atm_ens',ensemble_id
       call mpp_declare_pelist(Atm_pelist , trim(pelist_name) )
       write(pelist_name,'(a,i2.2)')  'ocn_ens',ensemble_id
       call mpp_declare_pelist(Ocean_pelist , trim(pelist_name) )
       write(pelist_name,'(a,i2.2)')  'lnd_ens',ensemble_id
       call mpp_declare_pelist(Land_pelist , trim(pelist_name) )
       write(pelist_name,'(a,i2.2)')  'ice_ens',ensemble_id
       call mpp_declare_pelist(Ice_pelist , trim(pelist_name) )
    endif

    ocean_npes_pm = ocean_npes
    atmos_npes_pm = atmos_npes  
    land_npes_pm  = land_npes
    ice_npes_pm   = ice_npes  

    !Declare pelist of all Ocean, Atmos, Land and Ice pes across all ensembles ( filters )
    allocate(ensemble_pelist_ocean_filter(ensemble_size * ocean_npes_pm))
    allocate(ensemble_pelist_atmos_filter(ensemble_size * atmos_npes_pm))
    allocate(ensemble_pelist_land_filter (ensemble_size * land_npes_pm))
    allocate(ensemble_pelist_ice_filter  (ensemble_size * ice_npes_pm))
    do n=1,ensemble_size
       do m=1,ocean_npes_pm
          i=(n-1)*ocean_npes_pm + m
          ensemble_pelist_ocean_filter(i) = ensemble_pelist_ocean(n,m)
       enddo
       do m=1,atmos_npes_pm
          i=(n-1)*atmos_npes_pm + m
          ensemble_pelist_atmos_filter(i) = ensemble_pelist_atmos(n,m)
       enddo
       do m=1,land_npes_pm
          i=(n-1)*land_npes_pm + m
          ensemble_pelist_land_filter(i)  = ensemble_pelist_land(n,m)
       enddo
       do m=1,ice_npes_pm
          i=(n-1)*ice_npes_pm + m
          ensemble_pelist_ice_filter(i)   = ensemble_pelist_ice(n,m)
       enddo
    enddo
    
    write(pelist_name,'(a)')  'ocn_filter'
    call mpp_declare_pelist(ensemble_pelist_ocean_filter, trim(pelist_name) )

    write(pelist_name,'(a)')  'atm_filter'
    call mpp_declare_pelist(ensemble_pelist_atmos_filter, trim(pelist_name) )

    write(pelist_name,'(a)')  'lnd_filter'
    call mpp_declare_pelist(ensemble_pelist_land_filter,  trim(pelist_name) )

    write(pelist_name,'(a)')  'ice_filter'
    call mpp_declare_pelist(ensemble_pelist_ice_filter,   trim(pelist_name) )

    !
    !Rename output files to identify the ensemble
    !If ensemble_size=1 do not rename files so that the same coupler
    !can be used for non-ensemble experiments
    !
    if (ensemble_size > 1) then       
       write( text,'(a,i2.2)' ) 'ens_', ensemble_id    
       !Append ensemble_id to the restart filenames
       call set_filename_appendix(trim(text)) 
    endif   
    
  end subroutine ensemble_pelist_setup


end module ensemble_manager_mod

program regrid_2d
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">M.J. Harrison </CONTACT>
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">Zhi Liang</CONTACT>
  ! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">Bonnie Samuels</REVIEWER>
  !
  !<DESCRIPTION>
  ! regrid 2-d lat-lon gridded data to logically rectangular grid
  ! described by grid descriptor file.  If two fields are specified 
  ! for regridding, it is assumed that they represent vector components.
  ! Rotation to the local grid direction on the target grid will be performed.
  !
  !</DESCRIPTION>
  !

  use mpp_mod,          only : mpp_error, mpp_pe,  mpp_npes, mpp_root_pe, mpp_chksum
  use mpp_mod,          only : FATAL, WARNING, stdout, stdlog
  use mpp_io_mod,       only : mpp_open, mpp_close, mpp_read, mpp_write, mpp_write_meta
  use mpp_io_mod,       only : mpp_copy_meta, axistype, fieldtype, atttype
  use mpp_io_mod,       only : mpp_get_atts, mpp_get_info, mpp_get_fields, mpp_get_times
  use mpp_io_mod,       only : mpp_get_axes, mpp_get_axis_data
  use mpp_io_mod,       only : MPP_RDONLY, MPP_NETCDF, MPP_MULTI, MPP_SINGLE, MPP_OVERWR
  use mpp_io_mod,       only : mpp_get_att_name, mpp_get_att_char, mpp_get_att_type, mpp_get_att_real
  use mpp_domains_mod,  only : mpp_update_domains, mpp_define_domains, mpp_global_field
  use mpp_domains_mod,  only : domain2d, mpp_define_layout, mpp_get_compute_domain
  use mpp_domains_mod,  only : mpp_domains_set_stack_size
  use horiz_interp_mod, only : horiz_interp_new, horiz_interp, horiz_interp_end, horiz_interp_type
  use axis_utils_mod,   only : get_axis_cart
  use fms_mod,          only : fms_init, fms_end, open_namelist_file, close_file, file_exist
  use fms_mod,          only : check_nml_error, write_version_number, lowercase
  use constants_mod,    only : constants_init, PI

  implicit none

  !--- namelist interface
  !<NAMELIST NAME="regrid_2d_nml">
  ! <DATA NAME="src_file" TYPE="character(len=128)" DEFAULT="src_file.nc">
  !  Name of input file containing grid and data to be regridded.
  ! </DATA>
  ! <DATA NAME="src_field_name" TYPE="character(len=128),dimension(2)" >
  !  Name of input field(s).
  ! </DATA>
  ! <DATA NAME="dest_field_name" TYPE="character(len=128),dimension(2)" >
  !  Name of output field(s). If it is not specified in the namelist, it will 
  !  get the value from src_field_name
  ! </DATA>
  ! <DATA NAME="dest_grid" TYPE="character(len=128)" DEFAULT="dest_grid.nc">
  !  Name of grid descriptor file containing target grid information.
  ! </DATA>
  ! <DATA NAME="dest_file"  TYPE="character(len=128)" DEFAULT="dest_file.nc">
  !  Name of output file.
  ! </DATA>
  ! <DATA NAME="numfields"  TYPE="integer" DEFAULT="1">
  !  Number of fields (1 or 2). If numfields=2, then the fields are assumed
  !  to represent vector components.
  ! </DATA>
  ! <DATA NAME="dest_grid_type"  TYPE="character(len=1)" DEFAULT="T">
  !  Name of target grid type.  Valid choices are (T)racer and (C)orner
  ! </DATA>
  ! <DATA NAME="stop_crit"  TYPE="character(len=1),dimension(2)" DEFAULT="0.001">
  !  The stopping criteria when extrapping data onto missing points.
  ! </DATA>
  ! <DATA NAME="apply_dest_mask"  TYPE="logical" DEFAULT="true">
  !  flag to indicate if the land/sea mask of destination grid will be applied 
  !  on the output dest_file. when true, land/sea mask of destination grid will 
  !  be applied on the output dest_file. When false, the output data will be 
  !  global data. Default is true. 
  ! </DATA>
  ! <DATA NAME="vector_field"  TYPE="logical" DEFAULT="False">
  !  True if fields are vector components.
  ! </DATA>
  ! <DATA NAME="level"  TYPE="integer" DEFAULT="1">
  !  Vertical level from the source grid if one exists.  
  ! </DATA>
  ! <DATA NAME="num_nbrs"  TYPE="integer" DEFAULT="10">
  ! Number of nearest neighbors for regridding  
  ! </DATA>
  ! <DATA NAME="max_dist"  TYPE="integer" DEFAULT="0.17" UNITS="radians">
  !  Maximum radial influence for regridding.
  ! </DATA>
  ! <DATA NAME="scale_factor" TYPE="real,dimension(2) ">
  ! scaling factor for data (e.g. -1 to flip sign or 0.01 to convert from centimeters)
  ! </DATA>
  !<DATA NAME="interp_method"  TYPE= "character(len=20)" >
  !  specifying the remapping method when remampping data onto current grid.
  !  Its value can be "spherical" or " bilinear". "spherical" interpolation is a 
  !  inverse distance weighted interpolation algorithm. Default value is "bilinear". 
  !  "bilinear" interpolation is recommanded, since bilinear interpolation will provide 
  !  more smooth results than "spherical" interpolation (especially when interpolating 
  !  from coarse grid to fine grid). Plus bilinear interpolation is much more efficiency 
  !  than "spherical interpolation". 
  ! </DATA>
  !</NAMELIST>
  character(len=128) :: src_file = 'src_file.nc'
  character(len=128) :: dest_grid = 'dest_grid.nc'
  character(len=128) :: dest_file = 'dest_file.nc'
  character(len=128) :: src_field_name(2) 
  character(len=128) :: dest_field_name(2) = ''
  real               :: stop_crit(2)       = 0.005 
  character(len=1)   :: dest_grid_type = 'T'
  integer            :: numfields = 1
  integer            :: level = 1
  integer            :: num_nbrs = 5
  real               :: max_dist = 0.1
  real               :: scale_factor(2) = 1.0
  logical            :: vector_field=.false.
  logical            :: apply_dest_mask = .true.
  character(len=20)  :: interp_method = "bilinear"

  namelist /regrid_2d_nml/ src_file, src_field_name, dest_field_name, dest_file, dest_grid, &
       dest_grid_type, numfields, scale_factor, vector_field,level, num_nbrs, max_dist,     &
       apply_dest_mask, stop_crit, interp_method

  !---------------------------------------------------------------------
  integer            :: src_unit, dst_grid_unit
  integer            :: ni_src, nj_src, ni_dst, nj_dst, ntime_src
  type(axistype)     :: time_axis, axes_dst(2)
  type(fieldtype)    :: field_lon_dst, field_lat_dst, src_field(2)
  character(len=16)  :: y_boundary_type
  character(len=128) :: title
  logical            :: time_axis_exists = .false.
  real, parameter    :: tol = 1.e-10   ! tolerance for detecting missing values
  real, parameter    :: max_val=1.e20
  real, parameter    :: rel_coef = 0.9
  integer, parameter :: max_iter = 2000
  logical            :: is_cyclic = .true.  ! we suppose the source data is always global data.
  real               :: missing(2) = -1e20
  real               :: D2R
  logical            :: do_extrap
  type(atttype), dimension(:), allocatable :: global_atts
  real, dimension(:),          allocatable :: time_in
  real, dimension(:),          allocatable :: lon_src, lat_src
  real, dimension(:,:),        allocatable :: lon_dst, lat_dst
  real, dimension(:,:),        allocatable :: sin_rot, cos_rot
  real, dimension(:,:),        allocatable :: mask_dst
  real, dimension(:,:,:,:),    allocatable :: data_dst, data_src

  !--- version information variables
  character(len=128) :: version='CVS $Id: regrid_2d.f90,v 20.0 2013/12/14 00:31:09 fms Exp $'
  character(len=128) :: tagname='Tag $Name: tikal $'

  ! --- Begin of the program

  ! --- call fms_init, which will call mpp_init, mpp_io_init, mpp_domains_init
  call fms_init
  call constants_init

  !--- call regrid_2d initialization routine
  call regrid_2d_init

  !--- read the dest_grid file
  call read_dst_grid

  !--- read src_file
  call read_src_file

  !--- remap data from src grid to dest grid
  call remap_data

  !--- write out  metadata and data to output file dest_file
  if(mpp_pe() == mpp_root_pe() ) call write_dst_file

  call regrid_2d_end

  call fms_end

contains

  !#####################################################################
  ! --- read the namelist and write the version and namelist to logfile. Also
  ! --- write the namelist to standard output
  subroutine regrid_2d_init

    integer :: io_status, unit, ierr, n

    D2R = PI/180.0
    ! --- read namelist ------------------------------------------------

    if(file_exist('input.nml')) then
       unit = open_namelist_file()
       read (unit,regrid_2d_nml,IOSTAT=io_status)
       write (stdout(),'(/)')
       write (stdout(),regrid_2d_nml)  
       ierr = check_nml_error(io_status, 'regrid_2d_nml')
       call close_file(unit)
    else
       call mpp_error(FATAL, 'regrid_2d: file input.nml does not exist' )
    endif

    if (numfields.ne.2.and.vector_field) &
         call mpp_error(FATAL,'regrid_2d: 2 components of vector field not specified')
    if (numfields == 2.and..not.vector_field) &
         call mpp_error(FATAL,'regrid_2d: only 1 scalar at a time')
    if (numfields .gt. 2) call mpp_error(FATAL,'regrid_2d: more than 2 fields specified')
    if (numfields .le. 0) call mpp_error(FATAL,'regrid_2d: No field specified')
    if (dest_grid_type .ne. 'T' .and. dest_grid_type .ne. 'C') &
         call mpp_error(FATAL,'regrid_2d: nml dest_grid_type = '//dest_grid_type//', should be either T or C')

    !--- if dest_field_name is not defined in the namelist, get it from src_field_name
    do n = 1, numfields
       if(trim(dest_field_name(n)) == '') dest_field_name(n) = trim(src_field_name(n))
    enddo 
 
    !--- write version information
    call write_version_number(version, tagname)

  end subroutine regrid_2d_init

  !#####################################################################
  !--- open grid file and store grid info
  subroutine read_dst_grid

    integer                                    :: ndim, nvar, natt, ntime, i
    integer                                    :: len1, siz_in(3)
    logical                                    :: found_xt, found_yt, found_wet
    logical                                    :: found_xc, found_yc, found_angle
    character(len=32)                          :: name
    real, dimension(:,:),          allocatable :: angle
    type(axistype), allocatable, dimension(:)  :: axes
    type(fieldtype), allocatable, dimension(:) :: fields

    if(.not. file_exist(trim(dest_grid)) ) &
         call mpp_error(FATAL, 'regrid_2d: file '//trim(dest_grid)//' does not exist')

    call mpp_open(dst_grid_unit, trim(dest_grid),&
         action=MPP_RDONLY, form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE)

    call mpp_get_info(dst_grid_unit, ndim, nvar, natt, ntime)

    allocate(fields(nvar), global_atts(natt), axes(ndim) )
    call mpp_get_axes(dst_grid_unit, axes)
    call mpp_get_atts(dst_grid_unit, global_atts)
    call mpp_get_fields(dst_grid_unit,fields)

    do i=1,natt
       if (trim(mpp_get_att_name(global_atts(i))) == 'y_boundary_type') &
               y_boundary_type = trim(mpp_get_att_char(global_atts(i)))
       if (trim(mpp_get_att_name(global_atts(i))) == 'filename') &
               title = trim(mpp_get_att_char(global_atts(i)))
    enddo

    write(stdout(),*) 'Retrieving input grid information ...'
    write(stdout(),*) 'Input grid name: ',trim(title)
    write(stdout(),*) 'y_boundary_type: ',trim(y_boundary_type)

    !--------------------------------------------------------------------
    ! get output grid information
    !--------------------------------------------------------------------
    ni_dst=0; nj_dst=0
    do i=1,ndim
       call mpp_get_atts(axes(i),name=name,len=len1)
       select case (trim(name))
       case ('grid_x_T')
          ni_dst = len1
       case ('grid_y_T')
          nj_dst = len1
       end select
    enddo
    if(ni_dst==0) call mpp_error(FATAL,'regrid_2d: file '//trim(dest_grid)//' does not contain axis grid_x_T')
    if(nj_dst==0) call mpp_error(FATAL,'regrid_2d: file '//trim(dest_grid)//' does not contain axis grid_y_T')

    allocate(lon_dst(ni_dst,nj_dst), lat_dst(ni_dst,nj_dst) )
    allocate(mask_dst(ni_dst,nj_dst) )

    found_xt = .FALSE.;  found_yt = .FALSE.; found_wet   = .FALSE.
    found_xc = .FALSE.;  found_yc = .FALSE.; found_angle = .FALSE.
    do i=1,nvar
       call mpp_get_atts(fields(i),name=name,ndim=ndim)
       !--- get the land/sea mask
       if(trim(name) == 'wet') then
          found_wet = .true.
          call mpp_read(dst_grid_unit,fields(i),mask_dst)
       endif
       if(dest_grid_type == 'T') then
       select case (trim(name))
       case ('x_T')
          found_xt = .true.
          call mpp_read(dst_grid_unit,fields(i),lon_dst)
          field_lon_dst = fields(i)
          call mpp_get_atts(fields(i),axes=axes_dst)
       case ('y_T')
          found_yt = .true.
          call mpp_read(dst_grid_unit,fields(i),lat_dst)
          field_lat_dst = fields(i)           
       end select
       else if ( dest_grid_type == 'C' ) then
          select case (trim(name))
          case ('x_C')
             found_xc = .true.
             call mpp_read(dst_grid_unit,fields(i),lon_dst)
             field_lon_dst = fields(i)
             call mpp_get_atts(fields(i),axes=axes_dst)
          case('y_C')
             found_yc = .true.
             call mpp_read(dst_grid_unit,fields(i),lat_dst)
             field_lat_dst = fields(i)
          case('angle_C')
             found_angle = .true.
             allocate(angle(ni_dst,nj_dst), sin_rot(ni_dst,nj_dst), cos_rot(ni_dst,nj_dst) )
             call mpp_read(dst_grid_unit,fields(i),angle)
             sin_rot = sin(angle*D2R)
             cos_rot = cos(angle*D2R)
             deallocate(angle)
          end select
       endif
    enddo
    if(dest_grid_type == 'T') then
       if(.not.found_xt) call mpp_error(FATAL,'regrid_2d: field x_T is not in the file '//trim(dest_grid) )
       if(.not.found_yt) call mpp_error(FATAL,'regrid_2d: field y_T is not in the file '//trim(dest_grid) )    
             else
       if(.not.found_xc) call mpp_error(FATAL,'regrid_2d: field x_C is not in the file '//trim(dest_grid) )
       if(.not.found_yc) call mpp_error(FATAL,'regrid_2d: field y_C is not in the file '//trim(dest_grid) )    
       if(.not.found_angle) call mpp_error(FATAL,'regrid_2d: field angle_C is not in the file '//trim(dest_grid) )
             endif
!    kienert@pik-potsdam.de: changed the next lines so that regridding onto a dest. grid without field 'wet' is possible
!    if apply_dest_mask is false
    if(.not.found_wet) then
	if(apply_dest_mask) then 
		call mpp_error(FATAL,'regrid_2d: field wet is not in the file '//trim(dest_grid) )
    	endif
    endif

    if(.not. apply_dest_mask) mask_dst = 1.0  ! will get global data

    deallocate(fields, axes)    

  end subroutine read_dst_grid

  !#####################################################################
  !--- read source grid and source data from src_file
  subroutine read_src_file

    integer                                    :: ndim, nvar, natt, n
    integer                                    :: nt, i, j, k, jj, len1, nk_src
    logical                                    :: flip_y, found_src_field(2)
    character(len=1)                           :: cart
    character(len=32)                          :: name
    real, dimension(:),           allocatable  :: tmp1d 
    real, dimension(:,:),         allocatable  :: tmp 
    real, dimension(:,:,:),       allocatable  :: tmp3d 
    type(axistype), allocatable, dimension(:)  :: axes
    type(fieldtype), allocatable, dimension(:) :: fields


    if(.not. file_exist(trim(src_file)) ) &
         call mpp_error(FATAL, 'regrid_2d: file '//trim(src_file)//' does not exist')

    call mpp_open(src_unit, trim(src_file),&
         action=MPP_RDONLY, form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE)
    call mpp_get_info(src_unit, ndim, nvar, natt, ntime_src)

    allocate(fields(nvar))
    call mpp_get_fields(src_unit, fields)

    if (numfields > nvar) call mpp_error(FATAL,'not enough fields in file')
    found_src_field = .FALSE.
    do n=1,numfields
       do i=1,nvar
          call mpp_get_atts(fields(i),name=name)
          if (lowercase(trim(src_field_name(n))) == lowercase(trim(name))) then
             found_src_field(n) = .true.
             src_field(n) = fields(i)
             write(stdout(),*) 'Interpolating src field : ',trim(name), ' to ocean model grid'
          endif
       end do
    enddo

    do n=1,numfields 
       if(.not. found_src_field(n)) call mpp_error(FATAL, 'regrid_2d: field '&
            //trim(src_field_name(n))//' is not in the file '//trim(src_file) )
    enddo

    !--- get the src grid
    call mpp_get_atts(src_field(1),ndim=ndim)
    allocate(axes(ndim))
    call mpp_get_atts(src_field(1),axes=axes)
    flip_y = .false.
    ni_src=0; nj_src=0; nk_src=1; ntime_src = 1
    do j=1,ndim
       call mpp_get_atts(axes(j),len=len1)
       call get_axis_cart(axes(j),cart)
       select case (cart)
       case ('X')
          ni_src = len1
          allocate(lon_src(ni_src))
          call mpp_get_axis_data(axes(j),lon_src)
       case('Y')
          nj_src = len1
          allocate(lat_src(nj_src))
          call mpp_get_axis_data(axes(j),lat_src)
          if (lat_src(2) < lat_src(1)) then
             flip_y = .true.
             allocate(tmp1d(nj_src))
             tmp1d=lat_src
             do jj=1,nj_src
                lat_src(jj)=tmp1d(nj_src-jj+1)
             enddo
             deallocate(tmp1d)
          endif
       case('Z')
          nk_src = len1
       case ('T')
          ntime_src = len1
          time_axis_exists = .true.
          allocate(time_in(ntime_src))
          call mpp_get_times(src_unit, time_in)
          time_axis = axes(j)
       end select
    enddo

    if(ni_src==0) call mpp_error(FATAL,'regrid_2d: file ' &
         //trim(src_file)//' does not contain axis with cartesian attributes = "X" ')
    if(nj_src==0) call mpp_error(FATAL,'regrid_2d: file '&
         //trim(src_file)//' does not contain axis with cartesian attributes = "Y" ')

    allocate(data_src(ni_src,nj_src,2,ntime_src) )
    allocate(tmp3d(ni_src,nj_src,nk_src), tmp(ni_src,nj_src))

    !--------------------------------------------------------------------
    ! loop through source fields 
    !--------------------------------------------------------------------
    do n=1, numfields
       !--- get the missing value
       call mpp_get_atts(src_field(n),missing=missing(n) )
       if (level > nk_src) call mpp_error(FATAL,'selected level exceeds size of input array')
       if (nk_src > 1) write(*,*) 'warning: selecting level ',level,' from 3d array'
       do nt=1,ntime_src
          call mpp_read(src_unit,src_field(n), tmp3d,nt)

          tmp=tmp3d(:,:,level)
          !--- set up the mask of source data
          if(n==1 .and. nt == 1) then
             do_extrap = .false.
             do j = 1, nj_src
                do i = 1, ni_src
                   if( abs(tmp(i,j) - missing(n)) <= tol ) then
                      do_extrap = .true.
                   endif
                enddo
             enddo
          endif
           
          if (flip_y) then
             do j =1, nj_src
                data_src(:,j,n,nt)=tmp(:,nj_src-j+1)* scale_factor(n)
             enddo
          else
             data_src(:,:,n,nt) = tmp(:,:)* scale_factor(n)
          endif
       enddo

    enddo

    deallocate(fields, axes, tmp, tmp3d)   


  end subroutine read_src_file

  !#####################################################################
  !--- remap data from src grid to destination grid.
  subroutine remap_data

    integer                           :: ndivs, i, j, n, nt, l
    integer                             :: isc, iec, jsc, jec, layout(2) = (/1,0/)
    real                                :: tmp_x, tmp_y
    type(domain2d)                      :: Domain
    type(horiz_interp_type)             :: Interp
    real, dimension(:,:), allocatable :: tmp_src, tmp_dst

    !--- decompose model grid points
    !--- mapping can get expensive so we distribute the task at this level
    ndivs = mpp_npes()
    call mpp_define_layout ((/1,ni_dst,1,nj_dst/), ndivs, layout)
    call mpp_define_domains((/1,ni_dst,1,nj_dst/),layout, Domain,xhalo=0,yhalo=0)  
    call mpp_get_compute_domain (Domain, isc, iec, jsc, jec)

    call horiz_interp_new(Interp, lon_src*D2R, lat_src*D2R, lon_dst(isc:iec,jsc:jec)*D2R, &
         lat_dst(isc:iec,jsc:jec)*D2R, interp_method = trim(interp_method),                &
         num_nbrs = num_nbrs, max_dist=max_dist, grid_at_center = .true. )

    allocate(data_dst(ni_dst,nj_dst,numfields,ntime_src))
    allocate(tmp_src(ni_src, nj_src), tmp_dst(isc:iec,jsc:jec) )

    call mpp_domains_set_stack_size(2*ni_dst*nj_dst)
    do n=1, numfields
       do l=1,ntime_src
          if(do_extrap) then
             call extrap(data_src(:,:,n,l), tmp_src(:,:), stop_crit(n), missing(n)*scale_factor(n), is_cyclic ) 
             call horiz_interp(Interp, tmp_src(:,:), tmp_dst )
          else
             call horiz_interp(Interp, data_src(:,:,n,l), tmp_dst)
          endif
          !--- apply the mask to destination data
          do j = jsc, jec
             do i = isc, iec
                if(mask_dst(i,j) < 0.5) tmp_dst(i,j) = missing(n)
             enddo
          enddo
          call mpp_global_field(Domain,tmp_dst, data_dst(:,:,n,l) )
       enddo
    enddo

    deallocate(tmp_src, tmp_dst)

    call horiz_interp_end

    if (vector_field) then
          do nt=1,ntime_src
          do j=1,nj_dst
             do i=1,ni_dst
                if(mask_dst(i,j) >= 0.5) then 
                   tmp_x = cos_rot(i,j)*data_dst(i,j,1,nt)+sin_rot(i,j)*data_dst(i,j,2,nt)
                   tmp_y = -1.*sin_rot(i,j)*data_dst(i,j,1,nt)+cos_rot(i,j)*data_dst(i,j,2,nt)
                   data_dst(i,j,1,nt) = tmp_x
                   data_dst(i,j,2,nt) = tmp_y
                endif
             enddo
          enddo
          if (y_boundary_type == 'fold_north_edge' .and. dest_grid == 'c') then
             do i=1,ni_dst/2
                if(mask_dst(i,nj_dst) >= 0.5) then 
                   data_dst(i,nj_dst,1,nt) = -1.*data_dst(ni_dst-i,nj_dst,1,nt)
                   data_dst(i,nj_dst,2,nt) = -1.*data_dst(ni_dst-i,nj_dst,2,nt)
                endif
             enddo
          endif
       enddo
    endif

    !--- apply the destination mask to the 

    !--- write out chksum for parallel checking
    if(mpp_pe()==mpp_root_pe()) then
       write(stdout(),*)'NOTE: Chksum for after-regrid data ', mpp_chksum(data_dst, (/mpp_root_pe()/) )
    endif

  end subroutine remap_data

  !#####################################################################
  !--- write remapped data to file dest_file
  subroutine write_dst_file

    type(fieldtype)    :: dest_field(2)
    integer            :: unit, i, j, n
    character(len=32)  :: units
    character(len=128) :: longname
    !--------------------------------------------------------------------
    ! write output file metadata
    !--------------------------------------------------------------------

    call mpp_open(unit, trim(dest_file),MPP_OVERWR,MPP_NETCDF,threading=MPP_SINGLE,&
         fileset=MPP_SINGLE)
    !
    ! write global atts, will be changed in the future. The reason is we 
    ! need to rename regrid_2d.f90 to regrid_2d.F90
    !
!!$    do i=1,size(global_atts(:))
!!$       if (global_atts(i)%name == 'title') then
!!$          global_atts(i)%catt = 'SBC field interpolated to ocean grid'
!!$          global_atts(i)%len = 36
!!$       endif
!!$    end do

    !
    ! write axis metadata
    !
    do i=1,size(axes_dst(:))
       call mpp_copy_meta(unit,axes_dst(i))
    end do

    if (time_axis_exists) then
       call mpp_copy_meta(unit, time_axis)
    endif

    !
    ! write variable metadata
    !
    call mpp_copy_meta(unit,field_lon_dst,axes=axes_dst)
    call mpp_copy_meta(unit,field_lat_dst,axes=axes_dst)

    do n = 1, numfields
       call mpp_get_atts(src_field(n),units=units,longname=longname)
       if (time_axis_exists) then 
          call mpp_write_meta(unit, dest_field(n), (/axes_dst(1),axes_dst(2), time_axis/), &
               trim(dest_field_name(n)), units,longname, missing=missing(n), pack=1)
       else
          call mpp_write_meta(unit, dest_field(n), (/axes_dst(1),axes_dst(2)/), &
               trim(dest_field_name(n)), units,longname, missing=missing(n), pack=1)
       endif
    enddo

    ! write axis data

    do i=1,size(axes_dst(:))
       call mpp_write(unit,axes_dst(i))
    end do

    ! write variable data

    call mpp_write(unit, field_lon_dst,lon_dst)
    call mpp_write(unit, field_lat_dst,lat_dst)

    do j=1, ntime_src
       do n=1,numfields
    if (time_axis_exists) then 
             call mpp_write(unit, dest_field(n), data_dst(:,:,n,j),time_in(j))
          else
             call mpp_write(unit, dest_field(n), data_dst(:,:,n,1)) 
          endif
          enddo
       enddo

    call mpp_close(dst_grid_unit)
    call mpp_close(src_unit)
    call mpp_close(unit)

  end subroutine write_dst_file

  !#####################################################################
  !--- release the memory
  subroutine regrid_2d_end

    deallocate( lon_src, lat_src, lon_dst, lat_dst)
  deallocate(data_dst, data_src, mask_dst)
  if(time_axis_exists) deallocate(time_in)
    if(dest_grid_type == 'C') deallocate(sin_rot, cos_rot)
  end subroutine regrid_2d_end

  !#####################################################################
  subroutine extrap(data_in, data_out, crit, missing_value, is_cyclic )
    real, dimension(:,:),    intent(in) :: data_in
    real, dimension(:,:),   intent(out) :: data_out
    real,                    intent(in) :: crit, missing_value 
    logical,                 intent(in) :: is_cyclic 
    real                                :: resmax, initial_guess = 0.0
    integer                             :: ni, nj, i, j, n

    real, dimension(0:size(data_in,1)+1, 0:size(data_in,2)+1) :: tmp
    real, dimension(size(data_in,1), size(data_in,2) )        :: sor, res

    real, dimension(size(data_in,1), size(data_in,2) )        :: cfn, cfs, cfe, cfw, cfc
    real                                                      :: latp, latm, cstr, csm, csj
    real, dimension(size(data_in,1))                          :: dxu, dxt
    real, dimension(size(data_in,2))                          :: dyu, dyt

    ni = size(data_in,1)
    nj = size(data_in,2)

    ! construct grid factors for a sphere
    do j=1,nj-1
       dyu(j) = lat_src(j+1)-lat_src(j)
    enddo
    dyu(nj) = dyu(nj-1)
    do j=2,nj
       dyt(j) = 0.5*(dyu(j)+dyu(j-1))
    enddo
    dyt(1) = dyt(2)
    do i=1,ni-1
       dxu(i) = lon_src(i+1)-lon_src(i)
    enddo
    dxu(ni) = dxu(ni-1)
    do i=2,ni
       dxt(i) = 0.5*(dxu(i)+dxu(i-1))
    enddo
    dxt(1) = dxt(2)
    do j= 1, nj
       if (j == nj) then
          latp = lat_src(j) + 0.5*(lat_src(j) - lat_src(j-1))
       else
          latp = 0.5*(lat_src(j) + lat_src(j+1))
       endif
       if (j == 1) then
          latm = lat_src(j) - 0.5*(lat_src(j+1) - lat_src(j))
       else
          latm = 0.5*(lat_src(j) + lat_src(j-1))
       endif
       csj  = cos(latp*pi/180.0)
       csm  = cos(latm*pi/180.0)
       cstr = 1.0/cos(lat_src(j)*pi/180.)       
       do i= 1,ni
          cfn(i,j) = csj*cstr/(dyt(j)*dyu(j))
          cfs(i,j) = csm*cstr/(dyt(j)*dyu(max(j-1,1)))
          cfe(i,j) = cstr**2/(dxu(i)*dxt(i))
          cfw(i,j) = cstr**2/(dxu(max(i-1,1))*dxt(i))
          cfc(i,j) = 1.0/(cfn(i,j)+cfs(i,j)+cfe(i,j)+cfw(i,j))
          cfn(i,j) = cfn(i,j)*cfc(i,j)
          cfs(i,j) = cfs(i,j)*cfc(i,j)
          cfe(i,j) = cfe(i,j)*cfc(i,j)
          cfw(i,j) = cfw(i,j)*cfc(i,j)         
       enddo
    enddo

    tmp = 0.0
    do j= 1, nj
       do i= 1, ni
          if(abs(data_in(i,j) - missing_value) <= tol ) then
             tmp(i,j) = initial_guess
             sor(i,j) = rel_coef
          else
             tmp(i,j)=data_in(i,j)
             sor(i,j) = 0.0
          endif
       enddo
    enddo

    call fill_boundaries(tmp, is_cyclic)

    ! iterate
    n=1
    do            
       resmax=0.0
       do j= 1, nj
          do i= 1, ni
             res(i,j) = cfw(i,j)*tmp(i-1,j) + cfe(i,j)*tmp(i+1,j) + cfs(i,j)*tmp(i,j-1) + cfn(i,j)*tmp(i,j+1) - tmp(i,j)
          enddo
       enddo

       do j= 1, nj
          do i= 1, ni
             res(i,j) = res(i,j)*sor(i,j)
             tmp(i,j)=tmp(i,j)+res(i,j)
             resmax = max(abs(res(i,j)),resmax)
          enddo
       enddo

       if(resmax .le. crit .or. n > max_iter) then
          data_out(:,:) = tmp(1:ni,1:nj)
          exit
       endif

       !--- update boundaries

       call fill_boundaries(tmp, is_cyclic)

       n=n+1

    enddo

    if(mpp_pe() == mpp_root_pe() ) write(stdout(),'(a,i6,a)') 'Stopped after ',n,' iterations'
    if(mpp_pe() == mpp_root_pe() ) write(stdout(),'(a,f10.4)') 'maxres= ',resmax

  end subroutine extrap

  !#####################################################################


  subroutine fill_boundaries(data, is_cyclic)

    real, dimension(0:,0:), intent(inout) :: data
    logical,                   intent(in) :: is_cyclic
    integer :: i,j, ni, nj

    ni = size(data,1) - 2
    nj = size(data,2) - 2

    if(is_cyclic) then
       data(0,1:nj) = data(ni,1:nj)
       data(ni+1,1:nj) = data(1,1:nj)
    endif

    return

  end subroutine fill_boundaries

  !#####################################################################

end program regrid_2d

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: cosp_isccp_simulator.F90,v 20.0 2013/12/13 23:15:44 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2
 
#endif

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

MODULE MOD_COSP_ISCCP_SIMULATOR
  USE MOD_COSP_CONSTANTS
  USE MOD_COSP_TYPES
  IMPLICIT NONE

CONTAINS


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!-------------- SUBROUTINE COSP_ISCCP_SIMULATOR -----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_ISCCP_SIMULATOR(gbx,sgx,y)
  
  ! Arguments
  type(cosp_gridbox),intent(in) :: gbx  ! Gridbox info
  type(cosp_subgrid),intent(in) :: sgx  ! Subgridbox info
  type(cosp_isccp),intent(inout) :: y   ! ISCCP simulator output
  
  ! Local variables 
  integer :: Nlevels,Npoints
  real :: pfull(gbx%Npoints, gbx%Nlevels)
  real :: phalf(gbx%Npoints, gbx%Nlevels + 1)
  real :: qv(gbx%Npoints, gbx%Nlevels)
  real :: cc(gbx%Npoints, gbx%Nlevels)
  real :: conv(gbx%Npoints, gbx%Nlevels)
  real :: dtau_s(gbx%Npoints, gbx%Nlevels)
  real :: dtau_c(gbx%Npoints, gbx%Nlevels)
  real :: at(gbx%Npoints, gbx%Nlevels)
  real :: dem_s(gbx%Npoints, gbx%Nlevels)
  real :: dem_c(gbx%Npoints, gbx%Nlevels)
  real :: frac_out(gbx%Npoints, gbx%Ncolumns, gbx%Nlevels)
  integer :: sunlit(gbx%Npoints)
  
  Nlevels = gbx%Nlevels
  Npoints = gbx%Npoints
  ! Flip inputs. Levels from TOA to surface
  pfull  = gbx%p(:,Nlevels:1:-1) 
  phalf(:,1)         = 0.0 ! Top level
  phalf(:,2:Nlevels+1) = gbx%ph(:,Nlevels:1:-1)
  qv     = gbx%sh(:,Nlevels:1:-1) 
  cc     = 0.999999*gbx%tca(:,Nlevels:1:-1) 
  conv   = 0.999999*gbx%cca(:,Nlevels:1:-1) 
  dtau_s = gbx%dtau_s(:,Nlevels:1:-1) 
  dtau_c = gbx%dtau_c(:,Nlevels:1:-1) 
  at     = gbx%T(:,Nlevels:1:-1) 
  dem_s  = gbx%dem_s(:,Nlevels:1:-1) 
  dem_c  = gbx%dem_c(:,Nlevels:1:-1) 
  frac_out(1:Npoints,:,1:Nlevels) = sgx%frac_out(1:Npoints,:,Nlevels:1:-1)
  sunlit = int(gbx%sunlit)
#ifdef COSP_GFDL
  if (sgx%cols_input_from_model) then
    call icarus(0,0,gbx%npoints,sunlit,gbx%nlevels,gbx%ncolumns, &
            pfull,phalf,qv,cc,conv,dtau_s,dtau_c, &
            gbx%isccp_top_height,gbx%isccp_top_height_direction, &
            gbx%isccp_overlap,frac_out, &
            gbx%skt,gbx%isccp_emsfc_lw,at,dem_s,dem_c,y%fq_isccp,y%totalcldarea, &
            y%meanptop,y%meantaucld,y%meanalbedocld, &
            y%meantb,y%meantbclr,y%boxtau,y%boxptop, &
            sgx%dtau_col, sgx%dem_col)
  else
    call icarus(0,0,gbx%npoints,sunlit,gbx%nlevels,gbx%ncolumns, &
            pfull,phalf,qv,cc,conv,dtau_s,dtau_c, &
            gbx%isccp_top_height,gbx%isccp_top_height_direction, &
            gbx%isccp_overlap,frac_out, &
            gbx%skt,gbx%isccp_emsfc_lw,at,dem_s,dem_c,y%fq_isccp,y%totalcldarea, &
            y%meanptop,y%meantaucld,y%meanalbedocld, &
            y%meantb,y%meantbclr,y%boxtau,y%boxptop)
   endif
#else
    call icarus(0,0,gbx%npoints,sunlit,gbx%nlevels,gbx%ncolumns, &
            pfull,phalf,qv,cc,conv,dtau_s,dtau_c, &
            gbx%isccp_top_height,gbx%isccp_top_height_direction, &
            gbx%isccp_overlap,frac_out, &
            gbx%skt,gbx%isccp_emsfc_lw,at,dem_s,dem_c,y%fq_isccp,y%totalcldarea, &
            y%meanptop,y%meantaucld,y%meanalbedocld, &
            y%meantb,y%meantbclr,y%boxtau,y%boxptop)
#endif

  ! Flip outputs. Levels from surface to TOA
  ! --- (npoints,tau=7,pressure=7)
  y%fq_isccp(:,:,:) = y%fq_isccp(:,:,7:1:-1)
     
 
  ! Check if there is any value slightly greater than 1
  where ((y%totalcldarea > 1.0-1.e-5) .and. (y%totalcldarea < 1.0+1.e-5))
    y%totalcldarea = 1.0
  endwhere
              
END SUBROUTINE COSP_ISCCP_SIMULATOR

END MODULE MOD_COSP_ISCCP_SIMULATOR

!FDOC_TAG_GFDL
module strat_cloud_legacy_mod

!-----------------------------------------------------------------------
! NOTE: 10/7/10 -- RSH
! This is equivalent to the version of strat_cloud.F90 which existed
! before mods to include an option for double-moment microphysics (coded
! by m. salzmann) were added. 
!
! This version is equivalent to that which was used in CM3 AR5 experiments.
! Treatment of internal diagnostics and the namelist within the module has
! been changed to be compatible with that used in the revised version of 
! strat_cloud_mod, so that this code may be cleanly accessed from 
! strat_cloud_mod while being in its own module, thus reducing compilation
! time.
!
! Addition of the double moment mods required some code changes which 
! result in model answer changes when the code is optimized (-O2). However,
! when the atmos_phys library is compiled with -O0 and  -fltconsistency,
! the results of an AM3 integration using the revised code (available in 
! strat_cloud.F90) and this legacy version, may be seen to be identical. 
!-----------------------------------------------------------------------
 
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Stephen Klein
! </CONTACT>
!/"/>q
! <OVERVIEW>
!   Code to compute time tendencies of stratiform clouds and
! diagnoses
!   rain and snow flux with prognostic scheme.
!   
! </OVERVIEW>
! <DESCRIPTION>
!
!
!       The prognostic scheme returns the time tendencies of liquid,
!       ice, and saturated volume fraction that are suspended in 
!       stratiform clouds.  The scheme diagnoses the fluxes of rain
!       and snow in saturated and unsaturated areas.
!
!       The prognostic cloud scheme is responsible for determing
!       cloud volume fractions, condensed water tendencies, and
!       the stratiform precipitation rate.  It includes processes
!       for evaporation, condensation, deposition, and sublimation
!       of cloud water, conversion of cloud water to precipitation,
!       evaporation of falling precipitation, the bergeron-findeisan 
!       process, freezing of cloud liquid, accretion of cloud water 
!       by precipitation, and melting of falling precipitation.
!
!       This scheme is based on the experience the author had 
!       at the ECMWF in 1997. The saturated volume fraction formalism 
!       and type of solution follow directly from the scheme of Tiedtke
!       (1993): Monthly Weather Review, Volume 121, pages 3040-3061.
!       The form of most of the microphysics follows Rotstayn , 1997:
!       Quart. J. Roy. Met. Soc. vol 123, pages 1227-1282. The partial
!       precipitation area formulism follows Jakob and Klein, 2000:
!       Quart. J. Roy. Met. Soc. vol 126, pages 2525-2544. 
!
!       The statistical cloud scheme treatment, which is used as
!       a replacement for the Tiedtke cloud fraction scheme, is based
!       on a number of publications: Tompkins, A., 2002: J. Atmos. 
!       Sci., 59, 1917-1942, Klein et al., 2005: J. Geophys. Res., 
!       110, D15S06, doi:10.1029/2004JD005017. 
! </DESCRIPTION>
!

! <DATASET NAME="strat_cloud.res">
!   native format of the restart file
! </DATASET>
! <DATASET NAME="strat_cloud.res.nc">
!   netcdf format of the restart file
! </DATASET>


! <INFO>
!   <REFERENCE>           
!The saturation volume fraction formalism comes from:
!
!Tiedtke, M., 1993: Representation of clouds in large-scale models.
! Mon. Wea. Rev., 121, 3040-3061.
!
! </REFERENCE>
!   <REFERENCE>           
!The form of most of the microphysics follows:
!
!Rotstayn, L., 1997: A physically based scheme for the treatment of
! stratiform clouds and precipitation in large-scale models. I:
! Description and evaluation of microphysical processes. Quart. J.
! Roy. Met. Soc. 123, 1227-1282. 
! </REFERENCE>
!   <COMPILER NAME="">     </COMPILER>
!   <PRECOMP FLAG="">      </PRECOMP>
!   <LOADER FLAG="">       </LOADER>
!   <TESTPROGRAM NAME="">  </TESTPROGRAM>
!   <BUG>                  </BUG>
!   <NOTE> 
!1. qmin should be chosen such that the range of {qmin, max(qa,ql
!,qi)} is resolved by the precision of the numbers used. (default =
! 1.E-10)
!   </NOTE>

!   <NOTE> 
!2. Dmin will be MACHINE DEPENDENT and occur when
!   </NOTE>

!   <NOTE> 
!a. 1. -exp(-Dmin) = 0. instead of Dmin in the limit of very small
! Dmin
!   </NOTE>

!AND

!   <NOTE> 
!b. 1. - exp(-D) < D for all D > Dmin
!   </NOTE>
!   <FUTURE>               </FUTURE>

! </INFO>

  use  sat_vapor_pres_mod, only :  compute_qs
  use beta_dist_mod,        only: beta_dist_init, beta_dist_end, &
                                  incomplete_beta
  use  aer_ccn_act_mod,    only : aer_ccn_act_wpdf, aer_ccn_act_init
  use  aer_in_act_mod,     only : Jhete_dep
  use  mpp_mod,            only : mpp_clock_id, mpp_clock_begin, &
                                  mpp_clock_end, CLOCK_LOOP

  use             fms_mod, only :  file_exist, open_namelist_file,&
       & error_mesg, FATAL, NOTE, mpp_pe, mpp_root_pe, close_file,&
       & read_data, write_data, check_nml_error, write_version_number&
       &, stdlog, open_restart_file, open_ieee32_file, mpp_error
  use  fms_io_mod,         only :  get_restart_io_mode, &
                                   register_restart_field, restart_file_type, &
                                   save_restart, restore_state, get_mosaic_tile_file
  use  constants_mod,      only :  rdgas,rvgas,hlv,hlf,hls, cp_air&
       &,grav,tfreeze,dens_h2o
  use  cloud_rad_mod,      only :  cloud_rad_init
  use  diag_manager_mod,   only :  register_diag_field, send_data
  use  time_manager_mod,   only :  time_type, get_date, get_time
   use cloud_generator_mod, only :  do_cloud_generator, &
                                   cloud_generator_init, &
                                   compute_overlap_weighting
  
  use  rad_utilities_mod,  only : aerosol_type


  use strat_cloud_utilities_mod,  &
                            only: strat_cloud_utilities_init, &
                                  diag_id_type, diag_pt_type, &
                                  strat_nml_type, atmos_state_type, &
                                  particles_type


  implicit none
  private

  integer, private :: sc_loop, sc_pre_loop, sc_post_loop

  public  strat_cloud_legacy, strat_cloud_legacy_init,  &
          strat_cloud_legacy_end
 private  aerosol_effects, ppm2m_sak, kmppm_sak, steepz_sak,  &
          cloud_clear_xfer





  !        
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  !              GLOBAL STORAGE VARIABLES
  !
  !     radturbten    The sum of radiation and turbulent tendencies
  !                   for each grid box. (K/sec)
  !


  !
  !     ------ data for cloud averaging code ------
  !

  real,    allocatable, dimension (:,:,:) :: qlsum, qisum, cfsum
  integer, allocatable, dimension (:,:)   :: nsum
  !
  !     ------ constants used by the scheme -------
  !


  real, parameter :: d608 = (rvgas-rdgas) / rdgas
  real, parameter :: d622 = rdgas / rvgas
  real, parameter :: d378 = 1. - d622
  !        
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  !
  !       DECLARE CONSTANTS AND SET DEFAULT VALUES FOR PARAMETERS OF 
  !       THE SCHEME
  !
  !
  !
  !                  PHYSICAL CONSTANTS USED IN THE SCHEME
  !
  !
  !         constant              definition                  unit
  !       ------------   -----------------------------   ---------------
  !
  !           grav       gravitational acceleration      m/(s*s)
  !
  !           hlv        latent heat of vaporization     J/kg condensate
  !
  !           hlf        latent heat of fusion           J/kg condensate
  !
  !           hls        latent heat of sublimation      J/kg condensate
  !
  !           rdgas      gas constant of dry air         J/kg air/K
  !
  !           rvgas      gas constant of water vapor     J/kg air/K
  !
  !           cp_air     specific heat of air at         J/kg air/K
  !                      constant pressure
  !
  !           d622       rdgas divided by rvgas          dimensionless
  !
  !           d378       One minus d622                  dimensionless
  !
  !           tfreeze    Triple point of water           K
  !
  !           dens_h2o   Density of pure liquid          kg/(m*m*m)
  !
  !
  !
  !
  !                          PARAMETERS OF THE SCHEME 
  !
  !
  !         parameter              definition                  unit
  !       ------------   -----------------------------   ---------------
  !
  !
  !       rho_ice        mass density of ice crystals    kg/(m*m*m)
  !
  !       ELI            collection efficiency of        dimensionless
  !                      cloud liquid by falling ice
  !
  !
  !       do_average     Average stratiform cloud properties
  !                      before computing clouds used by radiation?
  !
  !       overlap        value of the overlap parameter
  !                      from cloud rad
  !                      overlap = 1 is maximum-random
  !                      overlap = 2 is random
  !
  
  real,   parameter :: rho_ice        =  100.
  real,   parameter :: ELI            =  0.7
  logical           :: do_average     =  .false.
  integer           :: overlap        =  2

  !
  !-----------------------------------------------------------------------
  !-------------------- diagnostics fields -------------------------------



  !--- for netcdf restart
  type(restart_file_type), pointer, save :: Str_restart => NULL()
  type(restart_file_type), pointer, save :: Til_restart => NULL()
  logical                                :: in_different_file = .false.

 !----------------------------------------------------------

  character(len=5) :: mod_name = 'strat'
  real :: missing_value = -999.


real :: U00, rthresh, var_limit, sea_salt_scale, om_to_oc,  N_land, &
          N_ocean, U_evap, eros_scale, eros_scale_c, eros_scale_t, &
          mc_thresh, diff_thresh, qmin, Dmin, efact, vfact, cfact, &
          iwc_crit,  vfall_const2, vfall_exp2, qthalfwidth, N_min, &
          num_mass_ratio1, num_mass_ratio2
 
   logical :: do_netcdf_restart, u00_profile, use_kk_auto, &
              use_online_aerosol,  use_sub_seasalt, eros_choice, &
              super_choice, tracer_advec, do_old_snowmelt, retain_cm3_bug, do_pdf_clouds, &
              do_liq_num, do_dust_berg, pdf_org, do_ice_nucl_wpdf, debugo
 
   integer :: num_strat_pts,  betaP, nsublevels, kmap, kord, &
              super_ice_opt, isamp, jsamp, ksamp

   character(len=64) :: microphys_scheme

  !       max_strat_pts  maximum number of strat pts
  !                      for instantaneous output
  !
  integer, parameter:: max_strat_pts = 5
  integer,dimension(2,max_strat_pts) :: strat_pts = 0

       
  !        
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  !
  !       DECLARE VERSION NUMBER OF SCHEME
  !

  Character(len=128) :: Version = '$Id: strat_cloud_legacy.F90,v 20.0 2013/12/13 23:22:13 fms Exp $'
  Character(len=128) :: Tagname = '$Name: tikal $'
   logical            :: module_is_initialized = .false.
  integer, dimension(1) :: restart_versions = (/ 1 /)
  integer               :: vers


  logical  :: cloud_generator_on

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  !
  !       The module contains the following subroutines:
  !
  !       strat_cloud_legacy_init  initializes module.
  !
  !       strat_cloud_legacy calculations of the cloud scheme are performed
  !                     here.
  !
  !       strat_cloud_end    closes out module.
  !


CONTAINS





!#######################################################################

subroutine strat_cloud_legacy_init (do_pdf_clouds)

logical,     intent(in) :: do_pdf_clouds

      if (module_is_initialized) return

!-----------------------------------------------------------------------
!    write version number to output file.
!-----------------------------------------------------------------------
      call write_version_number(version, tagname)

!-----------------------------------------------------------------------
!    make sure needed modules have been initialized.
!-----------------------------------------------------------------------
      call strat_cloud_utilities_init
      if (do_pdf_clouds) call beta_dist_init
      call cloud_generator_init
      cloud_generator_on = do_cloud_generator()

!-----------------------------------------------------------------------
!    mark this module initialized.
!-----------------------------------------------------------------------
      module_is_initialized = .true.

end subroutine strat_cloud_legacy_init
 

!#######################################################################


! <SUBROUTINE NAME="strat_cloud_legacy">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!       
!  </DESCRIPTION>
!  <TEMPLATE>
!   call strat_cloud_legacy( 
!              cloud_generator_on,Nml,  &
!              diag_id, diag_pt, n_diag_4d, n_diag_4d_kp1,  &
!              Time,is,ie,js,je,dtcloud,pfull,phalf,radturbten2,&
!              T,qv,ql,qi,qa,omega,Mc,diff_t,LAND,              &
!              ST,SQ,SL,SI,SA,rain3d,snow3d,snowclr3d,surfrain,     &
!              surfsnow,qrat,ahuco,limit_conv_cloud_frac,MASK, &
!              qn, Aerosol, SN)
!
!  </TEMPLATE>
!  <IN NAME="Time" TYPE="time_type">
!         Time
!  </IN>
!  <IN NAME="is" TYPE="integer">
!         Indice of starting point in the longitude direction of the slab being passed to strat_cloud
!  </IN>
!  <IN NAME="ie" TYPE="integer">
!         Indice of ending point in the longitude direction of the slab being passed 
!  </IN>
!  <IN NAME="js" TYPE="integer">
!         Indice of starting point in the latitude direction of the slab being passed
!  </IN>
!  <IN NAME="je" TYPE="integer">
!         Indice of ending point in the latitude direction of the slab being passed 
!  </IN>
!  <IN NAME="dtcloud" TYPE="real">
!         Physics time step (sec)
!  </IN>
!  <IN NAME="pfull" TYPE="real">
!         Pressure on model full levels (Pa)
!  </IN>
!  <IN NAME="phalf" TYPE="real">
!         Pressure on model half levels (Pa)
!  </IN>
!  <IN NAME="radturbten2" TYPE="real">
!         Sum of the tendencies of temperature from turbulence and radiation schemes (K/s)
!  </IN>
!  <IN NAME="T" TYPE="real">
!         Temperature (K)         
!  </IN>
!  <IN NAME="qv" TYPE="real">
!         Water vapor specific humidity (kg vapor/kg air)
!  </IN>
!  <IN NAME="ql" TYPE="real">
!         Grid-box mean liquid water specific humidity (kg liquid/kg air)
!  </IN>
!  <IN NAME="qi" TYPE="real">
!         Grid-box mean ice water specific humidity (kg ice/kg air)
!  </IN>
!  <IN NAME="qa" TYPE="real">
!         Cloud fraction (3d array and a prognostic variable) (fraction)
!  </IN>
!  <IN NAME="qn" TYPE="real">
!         Cloud droplet number (3d array and a prognostic variable) (#/kg air)
!  </IN>
!  <IN NAME="omega" TYPE="real">
!         Vertical pressure velocity (Pa/sec)
!  </IN>
!  <IN NAME="Mc" TYPE="real">
!         Cumulus mass flux (defined positive as upward) (kg air/m2/sec)
!  </IN>
!  <IN NAME="diff_t" TYPE="real">
!         Vertical diffusion coefficient for temperature and tracer from vertical diffusion scheme (m2/sec) 
!  </IN>
!  <IN NAME="LAND" TYPE="real">
!         Fraction of surface that contains land (fraction)
!  </IN>
!  <OUT NAME="ST" TYPE="real">
!         Change in temperature due to strat_cloud (K) 
!  </OUT>
!  <OUT NAME="SQ" TYPE="real">
!         Change in water vapor due to strat_cloud (kg vapor/kg air) 
!  </OUT>
!  <OUT NAME="SL" TYPE="real">
!         Change in cloud liquid due to strat_cloud (kg liquid/kg air)
!  </OUT>
!  <OUT NAME="SI" TYPE="real">
!         Change in cloud ice due to strat_cloud (kg ice/kg air)
!  </OUT>
!  <OUT NAME="SA" TYPE="real">
!         Change in cloud fraction due to strat_cloud (fraction)
!  </OUT>
!  <OUT NAME="SN" TYPE="real">
!         Change in cloud droplet number due to strat_cloud (fraction)
!  </OUT>
!  <OUT NAME="surfrain" TYPE="real">
!         Surface rain fall over time step dtcloud (kg liquid/m2)
!  </OUT>
!  <OUT NAME="surfsnow" TYPE="real">
!         Surface snow fall over time step dtcloud (kg ice/m2)
!  </OUT>
!  <OUT NAME="rain3d" TYPE="real">
!         3D rain fall over time step dtcloud (kg liquid/m2)
!  </OUT>
!  <OUT NAME="snow3d" TYPE="real">
!         3D snow fall over time step dtcloud (kg ice/m2)
!  </OUT>
!  <IN NAME="qrat" TYPE="real">
!         Ratio of large-scale specific humidity to specific humidity in 
!         environment outside convective system (from donner_deep) 
!         
!         Will be equal to 1 for all normal AM2 operations (i.e. donner_deep is not activated)              
!         
!         Note that index 1 is nearest ground
!
!  </IN>
!  <IN NAME="ahuco" TYPE="real">
!         The fraction of the grid box containing either cumulus cells 
!         or the mesoscale circulation (from donner_deep).
!
!         Will be equal to 0 for all normal AM2 operations 
!         (i.e. donner_deep is not activated)              
!         
!         Note that index 1 is nearest ground
!
!  </IN>
!  <IN NAME="MASK" TYPE="real">
!         Optional input real array indicating the point is above the surface
!         if equal to 1.0 and indicating the point is below the surface if 
!         equal to 0.
!
!         Used only in eta vertical coordinate model.
!  </IN>
! </SUBROUTINE>
!


subroutine strat_cloud_legacy( Nml,  &
       diag_id, diag_pt, n_diag_4d, n_diag_4d_kp1,  &
        diag_4d, diag_4d_kp1, diag_3d, &
      Time,is,ie,js,je,dtcloud,pfull,phalf,radturbten2,&
    T,qv,ql,qi,qa,omega,Mc,diff_t,LAND,              &
    ST,SQ,SL,SI,SA,f_snow_berg,rain3d,snow3d,snowclr3d,surfrain,     &
    surfsnow,qrat,ahuco,limit_conv_cloud_frac,MASK, &
    qn, Aerosol, SN)


  !        
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !
  !
  !
  !       VARIABLES
  !
  !
  !
  !       ------
  !       INPUT:
  !       ------
  !
  !         variable              definition                  unit
  !       ------------   -----------------------------   ---------------
  !
  !       Time           time type variable 
  !
  !       is,ie          starting and ending i indices 
  !                      for data window
  !
  !       js,je          starting and ending j indices 
  !                      for data window
  !
  !       dtcloud        time between this call and      s
  !                      the next call to strat_cloud
  !
  !       pfull          pressure at full model levels   Pa
  !                      IMPORTANT NOTE: p(j)<p(j+1)
  !
  !       phalf          pressure at half model levels   Pa
  !                      phalf(j)<pfull(j)<phalf(j+1)
  !
  !       T              temperature                     K
  !
  !       qv             specific humidity of water      kg vapor/kg air
  !                      vapor
  !
  !       ql             specific humidity of cloud      kg condensate/
  !                      liquid                          kg air
  !
  !       qi             specific humidity of cloud      kg condensate/
  !                      ice                             kg air
  !
  !       qa             saturated volume fraction       fraction
  !
  !       qn             cloud droplet number            #/kg air
  !
  !       qrat           ratio of large-scale spec       fraction
  !                      humidity to spec humidity
  !                      in environment outside
  !                      convective system (from
  !                      donner_deep) 
  !                      index 1 nearest ground
  !
  !       ahuco          fraction, cell+meso, from       fraction
  !                      donner_deep
  !                      index 1 nearest ground
  !
  !       omega          vertical pressure velocity      Pa/s
  !
  !       Mc             Cumulus mass flux defined       kg/(m*m)/s
  !                      on full levels
  !
  !       diff_t         Vertical diffusion coefficient  (m*m)/s
  !                      for temperature and tracer
  !
  !       LAND           the fraction of the grid box    fraction
  !                      covered by land
  !                               
  !
  !       -------
  !       OUTPUT:
  !       -------
  !
  !         variable              definition                  unit
  !       ------------   -----------------------------   ---------------
  !
  !       ST             temperature change due to       K
  !                      all stratiform processes
  !
  !       SQ             water vapor change due to       kg vapor/kg air
  !                      all stratiform processes
  !
  !       SL             cloud liquid change due to      kg condensate/
  !                      all stratiform processes        kg air
  !
  !       SI             cloud ice change due to         kg condensate/
  !                      all stratiform processes        kg air
  !
  !       SA             saturated volume fraction       fraction
  !                      change due to all stratiform 
  !                      processes
  !
  !       SN             cloud droplet number            #/kg air
  !                      change due to all stratiform 
  !                      processes
  !
  !       surfrain       rain that falls through the     kg condensate/
  !                      bottom of the column over       (m*m)
  !                      the time dtcloud
  !
  !       surfsnow       snow that falls through the     kg condensate/
  !                      bottom of the column over       (m*m)
  !                      the time dtcloud
  !
  !       rain3d         rain that falls through the     kg condensate/
  !                      each of the model layer         (m*m)/sec
  !
  !       snow3d         snow that falls through the     kg condensate/
  !                      each of the model layer         (m*m)/sec
  !
  !
  !       ---------------
  !       optional INPUT:
  !       ---------------
  !
  !         variable              definition                  unit
  !       ------------   -----------------------------   ---------------
  !
  !
  !       MASK           real array indicating the 
  !                      point is above the surface
  !                      if equal to 1.0 and 
  !                      indicating the point is below
  !                      the surface if equal to 0.
  !
  !       -------------------
  !       INTERNAL VARIABLES:
  !       -------------------
  !
  !         variable              definition                  unit
  !       ------------   -----------------------------   ---------------
  !
  !       kdim           number of vertical levels
  !
  !       j              model vertical level being 
  !                      processed
  !
  !       ipt,jpt        i and j point indice used only
  !                      in instantaneous diag-
  !                      nostic output
  !
  !       i,unit,nn      temporary integers used in
  !                      instantaneous diagnostic
  !                      output.
  !
  !       inv_dtcloud    1 / dtcloud                     1/sec
  !
  !       airdens        air density                     kg air/(m*m*m)
  !
  !       qs             saturation specific humidity    kg vapor/kg air
  !
  !       dqsdT          T derivative of qs              kg vapor/kg air/K
  !
  !       gamma          (L/cp)*dqsdT                    dimensionless
  !
  !       rain_clr       grid mean flux of rain enter-   kg condensate/
  !                      ing the grid box from above     (m*m)/s
  !                      and entering the unsaturated 
!                      portion of the grid box
!
!       rain_cld       grid mean flux of rain enter-   kg condensate/
!                      ing the grid box from above     (m*m)/s
!                      and entering the saturated 
!                      portion of the grid box
!
!       a_rain_clr     fraction of grid box occupied   fraction
!                      by rain_clr
!
!       a_rain_cld     fraction of grid box occupied   fraction
!                      by rain_cld
!
!       snow_cld       flux of ice entering the        kg condensate/
!                      saturated portion of the        (m*m)/s
!                      grid box from above by means
!                      of gravitational settling 
!
!       snow_clr       flux of ice outside of cloud    kg condensate/
!                      entering the unsaturated        (m*m)/s
!                      portion of the grid box from      
!                      above
!
!       a_snow_clr     area fraction of grid box       fraction
!                      covered by snow flux in
!                      unsaturated air
!
!       a_snow_cld     area fraction of grid box       fraction
!                      covered by the snow flux in
!                      saturated air
!
!       deltpg         pressure thickness of grid box  kg air/(m*m)
!                      divided by gravity
!
!       U              grid box relative humidity      fraction
!
!       U00p           critical relative humidity      fraction
!                      which is a function of pressure 
!
!       dqs_ls         change in saturation specific   kg vapor/kg air
!                      due to large-scale processes,
!                      such as large-scale vertical
!                      motion, compensating convective
!                      mass flux, or radiative cooling
!
!       da_ls          change in saturated volume      fraction
!                      fraction due to large-scale
!                      processes
!
!       C_dt           product of A and dtcloud in     dimensionless in 
!                      in the analytic integration     qa integration
!                      of the qa equation, or C and
!                      dtcloud in the analytic         kg condensate/
!                      integration of the ql and qi    kg air in ql or 
!                      equations.                      qi integration
!
!       D_dt           product of B and dtcloud in     dimensionless in
!                      in the analytic integration     qa, ql, and qi
!                      of the qa equation, or D and    integration
!                      dtcloud in the analytic         
!                      integration of the ql and qi    
!                      equations.                      
!
!       qceq           equilibrium value of cloud      dimensionless or
!                      fraction or cloud condensate    kg condensate /
!                      that the analytic integration   kg air
!                      approaches                      
!
!       qcbar          mean value of cloud fraction    dimensionless or
!                      or cloud condensate over the    kg condensate /
!                      t0 to t0 + dtcloud interval     kg air
!
!       qc0            value of cloud fraction or      dimensionless or
!                      cloud condensate at the         kg condensate /
!                      initial time                    kg air
!        
!       qc1            value of cloud fraction or      dimensionless or
!                      cloud condensate at the final   kg condensate /
!                      time                            kg air
!       
!       D1_dt          first sink in either ql or qi   dimensionless
!                      equation. This is analogous to
!                      D_dt.  In ql equation, this 
!                      sink represents the conversion
!                      of cloud liquid to rain. In the
!                      qi equation it represents the
!                      settling of ice crystals.
!
!       D2_dt          second sink in ql or qi         dimensionless
!                      equation. This is analogous 
!                      to D_dt. In ql equation this
!                      sink represents the conversion
!                      of cloud liquid to ice. In the
!                      qi equation this sink 
!                      represents the melting of 
!                      cloud ice into rain.
!
!       D_eros         Sink in ql, qi and qa equation  dimensionless
!                      due to turbulent erosion of
!                      cloud sides
! 
!       ql_upd         updated value of ql             kg condensate/
!                                                      kg air
!       
!       qi_upd         updated value of qi             kg condensate/
!                                                      kg air
!
!       qa_upd         updated value of qa             fraction
!
!       qa_mean        qa + SA; semi-implicit          fraction
!                      saturated volume fraction
!
!       qa_mean_lst    qa_mean of the level above      fraction
!
!       ql_mean        ql + positive increment         kg condensate/
!                      of ql; i.e. a sort of           kg air
!                      intermediate ql
!
!       qi_mean        ql + positive increment         kg condensate/
!                      of qi; i.e. a sort of           kg air
!                      intermediate qi
!
!       dcond_ls       change in condensate due to     kg condensate/
!                      non-convective condensation.    kg air
!                      After phase determination,
!                      this variable refers only to
!                      liquid condensation.
!
!       dcond_ls_ice   change in ice due to            kg condensate/
!                      non-convective condensation.    kg air
!
!       da_cld2clr     fraction of the area in which   fraction
!                      rain/snow in saturated volume 
!                      above falls into unsaturated 
!                      volume in the current layer.
!
!       da_clr2cld     as in da_cld2clr except for     fraction
!                      the transfer from unsaturated
!                      to saturated volume
!
!       dprec_cld2clr  grid mean flux that is trans-   kg condensate/
!                      ferred from rain/snow in        (m*m)/s
!                      saturated volume to rain/snow 
!                      in unsaturated volume at layer 
!                      interfaces.
!
!       dprec_clr2cld  as in dprec_cld2clr except for  kg condensate/
!                      the transfer from unsaturated   (m*m)/s
!                      to saturated volume.
!
!       N              fixed number of cloud drops     1/(m*m*m)
!                      per unit volume in liquid
!                      clouds
!     
!       rad_liq        mean volume radius of liquid    microns
!                      cloud drops
!
!       A_plus_B       sum of vapor diffusion factor   m*s/kg
!                      and thermal conductivity factor
!                      which is used in various 
!                      microphysical formula for the 
!                      evaporation of rain and snow
!
!       Vfall          fall speed of ice crystals      m/s
!
!       lamda_f        slope factor in the SIZE        1/m
!                      distribution of ice crystals
!
!       U_clr          relative humidity in the clear  fraction
!                      portion of the grid box.
!
!       tmp1,tmp2,tmp3 temporary numbers used at 
!                      several points within the
!                      subroutine
!
!
!                STATISTICAL CLOUD SCHEME VARIABLES
!
!       qag            equilibrium value of cloud      dimensionless 
!                      fraction for statistical 
!                      cloud scheme           
!
!       qcg            equilibrium value of cloud      kg condensate /
!                      condensate that PDF clouds      kg air
!                      wants                          
!
!       qcg_ice        equilibrium value of cloud      kg condensate /
!                      ice condensate that PDF clouds  kg air
!                      wants
!
!       qvg            equilibrium value of water      kg vapor /
!                      vapor in the clear portion      kg air
!                      of the grid box that PDF 
!                      clouds wants                          
!
!       qtbar          total water specific humidity   kg water /
!                      which is equal to the sum of    kg air
!                      liquid water, ice water, and
!                      water vapor
!
!       deltaQ         the width of the total water    kg water /
!                      subgrid distribution (= qtmax   kg air
!                      minus qtmin)
!
!       qtmin          the minimum value to the total  kg water /
!                      sub-grid scale distribution     kg air
!
!       qs_norm        the difference between the      dimensionless
!                      saturation specific humidity    
!                      and qtmin normalized by deltaQ
!
!       icbp           the value of the incomplete     dimensionless
!                      beta function evaluated with
!                      x=qs_norm, p=betaP, and q=betaP
!
!       icbp1          the value of the incomplete     dimensionless
!                      beta function evaluated with                  
!                      x=qs_norm, p=betaP+1, and 
!                      q=betaP
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!


!        
!       user Interface variables
!       ------------------------
!

        type(strat_nml_type), intent(in)  :: Nml
       TYPE(diag_id_type), intent(inout) :: diag_id
       TYPE(diag_pt_type), intent(inout) :: diag_pt
       integer, intent(in) :: n_diag_4d, n_diag_4d_kp1
     real, dimension(:,:,:,0:), intent(inout) :: diag_4d, diag_4d_kp1
     real, dimension(:,:,0:),   intent(inout) :: diag_3d
        type(time_type), intent (in)           :: Time
        integer, intent (in)                   :: is,ie,js,je
        real, intent (in)                      :: dtcloud
        real, intent (in),    dimension(:,:,:) :: pfull,phalf
        real, intent (in),    dimension(:,:,:) :: T,qv,ql,qi,qa,omega
        real, intent (in),    dimension(:,:,:) :: Mc, diff_t
        real, intent (in),    dimension(:,:,:) :: qrat,ahuco
        logical, intent(in)                    :: limit_conv_cloud_frac
        real, intent (in),    dimension(:,:)   :: LAND
        real, intent (in),    dimension(:,:,:) :: radturbten2
        real, intent (out),   dimension(:,:,:) :: ST,SQ,SL,SI,SA
        real, intent (out),   dimension(:,:)   :: surfrain,surfsnow
        real, intent (in), optional, dimension(:,:,:) :: MASK
        real, intent (in),  optional, dimension(:,:,:) :: qn
        real, intent (out),   dimension(:,:,:) :: f_snow_berg
        real, intent (out),   dimension(:,:,:) :: rain3d
        real, intent (out),   dimension(:,:,:) :: snow3d
        real, intent (out),   dimension(:,:,:) :: snowclr3d
        type(aerosol_type), intent (in), optional      :: Aerosol  
        real, intent (out), optional, dimension(:,:,:) :: SN

!
!       Internal variables
!       ------------------
!

        integer                                        :: idim,jdim,kdim
        integer                                        :: id,jd,ns
        integer                                        :: j,ipt,jpt
        integer                                        :: i,unit,nn        
        real                                           :: inv_dtcloud, Si0
        real                                           :: icbp, icbp1, pnorm
        real, dimension(size(T,1),size(T,2),size(T,3)) :: airdens
        real, dimension(size(T,1),size(T,2),size(T,3)) :: qs,dqsdT
        real, dimension(size(T,1),size(T,2),size(T,3)) :: gamma
        real, dimension(size(T,1),size(T,2),size(T,3)) :: A_plus_B
        real, dimension(4,size(T,1),size(T,2),size(T,3)) :: qta4,qtqsa4
        real, dimension(size(T,1),size(T,2),size(T,3)) :: delp
        real, dimension(size(T,1),size(T,2))   :: rain_clr,rain_cld
        real, dimension(size(T,1),size(T,2))   :: a_rain_clr,a_rain_cld
        real, dimension(size(T,1),size(T,2))   :: snow_clr,snow_cld
        real, dimension(size(T,1),size(T,2))   :: a_snow_clr,a_snow_cld
        real, dimension(size(T,1),size(T,2))   :: deltpg,U,U00p
        real, dimension(size(T,1),size(T,2))   :: dqs_ls,da_ls
!rab        real, dimension(size(T,1),size(T,2))   :: C_dt, D_dt
        real, dimension(size(T,1),size(T,2))   :: D1_dt,D2_dt,D_eros
        real, dimension(size(T,1),size(T,2))   :: qcg_ice, qvg
!rab        real, dimension(size(T,1),size(T,2))   :: qceq, qcbar, qcg, qag
        real, dimension(size(T,1),size(T,2))   :: qcg, qag
!rab        real, dimension(size(T,1),size(T,2))   :: qagtmp,qcgtmp,qvgtmp
!rab        real, dimension(size(T,1),size(T,2))   :: qc1, qc0
        real, dimension(size(T,1),size(T,2))   :: ql_upd,qi_upd,qa_upd, qn_upd
        real, dimension(size(T,1),size(T,2))   :: ql_mean,qi_mean, qn_mean
        real, dimension(size(T,1),size(T,2))   :: qa_mean,qa_mean_lst
        real, dimension(size(T,1),size(T,2))   :: dcond_ls,dcond_ls_ice
        real, dimension(size(T,1),size(T,2))   :: N,rad_liq, N3D_col
!       real, dimension(size(T,1),size(T,2),size(T,3)) :: N3D, &
        real, dimension(size(T,1),size(T,2),size(T,3)) ::      &
                                                        concen_dust_sub
        real, dimension(size(T,1),size(T,2))   :: Vfall,iwc,lamda_f
        real, dimension(size(T,1),size(T,2))   :: U_clr
        real, dimension(size(T,1),size(T,2))   :: tmp1,tmp2,tmp3,tmp5, delta_cf,drop1,crystal
        real, dimension(size(T,1),size(T,2))   :: sum_freeze, sum_rime, &
                                                  sum_berg
        real, dimension(size(T,1),size(T,2))   :: qtbar,deltaQ
        real, dimension(size(T,1),size(T,2))   :: qtmin,qs_norm          

        logical :: used
        integer            :: k
        real               :: thickness, up_strat, wp2 ! cjg
        real, dimension(size(T,1),size(T,2),size(T,3),4) :: totalmass1
!rab - variables necessary to clean up strat_cloud....
        real               :: freeze_pt, tmp1s, tmp2s, tmp3s, snow_fact
        real               :: qc0s, qc1s, qceqs, qcbars, C_dts, D_dts
        real               :: qagtmps,qcgtmps,qvgtmps
        real               :: qldt_sum

!       real, allocatable, dimension(:,:,:,:) :: diag_4d, diag_4d_kp1              
!       real, allocatable, dimension(:,:,:) :: diag_3d        
        real, dimension(size(T,1),size(T,2),size(T,3)) :: deltpg_3d

        integer :: n8
     call mpp_clock_begin(sc_pre_loop)

    do_netcdf_restart = Nml%do_netcdf_restart
    U00 = Nml%U00 
    U00_profile = Nml%U00_profile 
    rthresh = Nml%rthresh 
    use_kk_auto = Nml%use_kk_auto 
    var_limit = Nml%var_limit 
    use_online_aerosol = Nml%use_online_aerosol 
    sea_salt_scale = Nml%sea_salt_scale 
    om_to_oc = Nml%om_to_oc 
    N_land = Nml%N_land 
    use_sub_seasalt = Nml%use_sub_seasalt 
    N_ocean = Nml%N_ocean 
    U_evap = Nml%U_evap 
    eros_scale = Nml%eros_scale 
    eros_choice = Nml%eros_choice
    eros_scale_t = Nml%eros_scale_t 
    eros_scale_c = Nml%eros_scale_c 
    mc_thresh = Nml%mc_thresh 
    diff_thresh = Nml%diff_thresh 
    super_choice = Nml%super_choice 
    tracer_advec = Nml%tracer_advec 
    qmin = Nml%qmin 
    Dmin = Nml%Dmin 
    num_strat_pts = Nml%num_strat_pts 
    if (num_strat_pts > 0) then
      strat_pts(:,1:) = Nml%strat_pts(:,1:) 
    endif
    efact = Nml%efact 
    vfact = Nml%vfact 
    cfact = Nml%cfact 
    do_old_snowmelt = Nml%do_old_snowmelt 
    retain_cm3_bug  = Nml%retain_cm3_bug  
    do_pdf_clouds = Nml%do_pdf_clouds 
    betaP = Nml%betaP 
    iwc_crit = Nml%iwc_crit 
    vfall_const2 = Nml%vfall_const2
    vfall_exp2 = Nml%vfall_exp2 
    qthalfwidth = Nml%qthalfwidth 
    nsublevels = Nml%nsublevels 
    kmap = Nml%kmap 
    kord = Nml%kord
    do_liq_num = Nml%do_liq_num 
    do_dust_berg = Nml%do_dust_berg 
    N_min = Nml%N_min 
    num_mass_ratio1 = Nml%num_mass_ratio1 
    num_mass_ratio2 = Nml%num_mass_ratio2 
    microphys_scheme = Nml%microphys_scheme
    super_ice_opt = Nml%super_ice_opt 
    pdf_org = Nml%pdf_org 
    do_ice_nucl_wpdf = Nml%do_ice_nucl_wpdf 
    debugo = Nml%debugo 
    isamp = Nml%isamp 
    jsamp = Nml%jsamp 
    ksamp = Nml%ksamp

!-----------------------------------------------------------------------
!       
!
     if (.not.module_is_initialized) then
       call error_mesg('strat_cloud_legacy','strat_cloud_legacy is not initialized',FATAL)
     endif





     if (diag_id%ql_wt > 0) then
       diag_4d(:,:,:,diag_pt%ql_wt) = ql
     endif
!-----------------------------------------------------------------------
!
!       initialize select variables to zero. The variables reset
!       are:
!
!       (1) changes of prognostic variables
!
!       (2) variables dealing with the rain/snow fluxes. 
!
!       (3) qa_mean of the level above the top level.
!        
!       (4) diagnostic output fields

        ST = 0.
        SQ = 0.
        SL = 0.
        SI = 0.
        SA = 0.
        if (present(SN)) SN = 0.
   
        rain_cld   = 0.
        rain_clr   = 0.
        a_rain_cld = 0.
        a_rain_clr = 0.
        snow_cld   = 0.
        snow_clr   = 0.
        a_snow_clr = 0.
        a_snow_cld = 0.
        
        qa_mean_lst= 0.

        dcond_ls      = 0.
        dcond_ls_ice  = 0.
        qcg           = 0.
        qcg_ice       = 0.
        
        
                     
!-----------------------------------------------------------------------
!
!       Determine dimensions of slab

        idim = SIZE(T,1)
        jdim = SIZE(T,2)
        kdim = SIZE(T,3)
        
!-----------------------------------------------------------------------
!
!       compute inverse time step

        inv_dtcloud = 1.0 / dtcloud

!-----------------------------------------------------------------------
!
!       Calculate saturation specific humidity and its temperature 
!       derivative, and thermal conductivity plus vapor diffusivity
!       factor.
!
!       These are calculated according to the formulas:
!
!   (1)  qs   = d622*esat/ [pfull  -  (1.-d622)*esat]
!
!   (2) dqsdT = d622*pfull*(desat/dT)/[pfull-(1.-d622)*esat]**2.
!
!   (3) gamma = (L/cp) * dqsdT
!       
!       where d622 = rdgas/rvgas; esat = saturation vapor pressure;
!       and desat/dT is the temperature derivative of esat.
!       Note that in the calculation of gamma, 
!
!            {             hlv          for T > tfreeze             }
!       L =  { 0.05*(T-tfreeze+20.)*hlv + 0.05*(tfreeze-T)*hls      }
!            {                          for tfreeze-20.< T < tfreeze}
!            {             hls          for T < tfreeze-20.         }
!
!       This linear form is chosen because at tfreeze-20. es = esi, and
!       at tfreeze, es = esl, with linear interpolation in between.
!
!       The conductivity/diffusivity factor, A_plus_B is given by:
!
!   (4) A_plus_B =   { (hlv/Ka/T)*((hlv/rvgas/T)-1.) } + 
!
!                    { (rvgas*T/chi*esat) }
!
!       where Ka is the thermal conductivity of air = 0.024 J/m/s/K
!       and chi is the diffusitivy of water vapor in air which is
!       given by
!
!   (5) chi = 2.21 E-05 (m*m)/s  * (1.E+05)/pfull
!
!       where p is the pressure in Pascals.
!    
!
!       Note that qs, dqsdT, and gamma do not have their proper values
!       until all of the following code has been executed.  That
!       is qs and dqsdT are used to store intermediary results
!       in forming the full solution.

        !calculate water saturated vapor pressure from table
        !and store temporarily in the variable gamma
        !calculate qs and dqsdT
        if (do_pdf_clouds) then 
             call compute_qs( T-((hlv*ql+hls*qi)/cp_air), pfull, qs, &
                             dqsdT=dqsdT, esat=gamma )
        else
             call compute_qs( T, pfull, qs, dqsdT=dqsdT, esat=gamma )
        end if
                     
        !compute A_plus_B
        A_plus_B = ( (hlv/0.024/T) * ((hlv/rvgas/T)-1.) ) +            &
           (rvgas*T*pfull/2.21/gamma)  
         
        !calculate gamma
        if (do_pdf_clouds) then
        gamma = dqsdT *(min(1.,max(0.,0.05*(T-((hlv*ql+hls*qi)/cp_air) &
                                             -tfreeze+20.)))*hlv +     &
                        min(1.,max(0.,0.05*(tfreeze -T+((hlv*ql+hls*qi)&
                                              /cp_air)   )))*hls)/cp_air
        else
        gamma = dqsdT *(min(1.,max(0.,0.05*(T-tfreeze+20.)))*hlv +     &
                        min(1.,max(0.,0.05*(tfreeze -T   )))*hls)/cp_air
        end if             
!-----------------------------------------------------------------------
!
!       Calculate air density

!       airdens = pfull / (rdgas * T * (1. + d608*qv  - ql - qi) )
        airdens = pfull / (rdgas * T * (1.   - ql - qi) )
        where (qrat .gt. 0.) 
             airdens = pfull / (rdgas * T *(1.+(d608*qv/qrat)-ql-qi) )
        end where

!-----------------------------------------------------------------------
!
!       Assign cloud droplet number based on land or ocean point.
        
        N = N_land*LAND + N_ocean*(1.-LAND)

!---------------------------------------------------------------------
!   call aerosol_effects to include impact of aerosols on the cloud
!   droplet number and the bergeron process, if these effects activated.
!---------------------------------------------------------------------
        if (do_liq_num .or. do_dust_berg) then
       call aerosol_effects (is, js, Time, phalf, airdens, T, &
                            diag_4d, diag_id, diag_pt,          &
                            concen_dust_sub, totalmass1, Aerosol, mask)
        endif


!-----------------------------------------------------------------------
!
!       Is a sub-vertical grid scale distribution going to be neededed?  
!       If yes, then do ppm fits
!
        if (do_pdf_clouds) then
        
        !initialize quantities
        do j = 1, kdim
             delp(:,:,j) = phalf(:,:,j+1)-phalf(:,:,j)
        enddo     
        qta4(1,:,:,:) = max(qmin,qv+ql+qi)
        qtqsa4(1,:,:,:) = qta4(1,:,:,:)-qs
        
        if (nsublevels.gt.1) then
            do id = 1,idim
                call ppm2m_sak(qta4(:,id,:,:),delp(id,:,:),kdim,kmap,1,jdim,0,kord)
                call ppm2m_sak(qtqsa4(:,id,:,:),delp(id,:,:),kdim,kmap,1,jdim,0,kord)
            enddo                
        else
            qta4(2,:,:,:) = qta4(1,:,:,:)
            qta4(3,:,:,:) = qta4(1,:,:,:)
            qta4(4,:,:,:) = 0.
            qtqsa4(2,:,:,:) = qtqsa4(1,:,:,:)
            qtqsa4(3,:,:,:) = qtqsa4(1,:,:,:)
            qtqsa4(4,:,:,:) = 0.   
        end if

        end if  !end of do_pdf_clouds section

!rab - statements moved outside of large loop
!      they have no bearing on the overall cloud physics
!      they are merely diagnostic values
!
     if (.not. do_pdf_clouds) then

      if (max(diag_id%qadt_fill,diag_id%qa_fill_col) > 0) then
        where (qa .le. qmin) 
!         qadt_fill = -qa * inv_dtcloud
          diag_4d(:,:,:,diag_pt%qadt_fill) = -qa * inv_dtcloud
        endwhere
      endif

      if (max(diag_id%qidt_fill,diag_id%qi_fill_col) > 0) then
        where (qi.le.qmin .or. qa.le.qmin) 
!         qidt_fill = -qi * inv_dtcloud
          diag_4d(:,:,:,diag_pt%qidt_fill) = -qi * inv_dtcloud
        endwhere
      endif

        if (.not. do_liq_num) then
!a        N3D = 0.
          diag_4d(:,:,:,diag_pt%droplets) = 0.
          if (max(diag_id%qldt_fill,diag_id%ql_fill_col) > 0) then
            where (ql .le. qmin .or. qa .le. qmin) 
!             qldt_fill = -ql * inv_dtcloud
              diag_4d(:,:,:,diag_pt%qldt_fill) = -ql * inv_dtcloud
            endwhere
          endif
        else
!a        N3D = qn*airdens*1.e-6
          diag_4d(:,:,:,diag_pt%droplets) = qn(:,:,:)*airdens(:,:,:)*1.e-6
!         if (diag_id%debug1_3d > 0) debug1 = min(qa,1.)
          if (diag_id%cf_liq_init   > 0) diag_4d(:,:,:,diag_pt%cf_liq_init  ) = min(qa,1.)
          do j=1,kdim
           do k=1,jdim
            do i=1,idim
             if (ql(i,k,j).le.qmin .or. qa(i,k,j).le.qmin .or. qn(i,k,j).le.qmin) then
!a            N3D(i,k,j) = 0.
              diag_4d(i,k,j,diag_pt%droplets) = 0.
!             if (max(diag_id%qldt_fill,diag_id%ql_fill_col) > 0) qldt_fill(i,k,j) = -ql(i,k,j) * inv_dtcloud
              if (max(diag_id%qldt_fill,diag_id%ql_fill_col) > 0) diag_4d(i,k,j,diag_pt%qldt_fill) = -ql(i,k,j) * inv_dtcloud
!             if (max(diag_id%qndt_fill,diag_id%qn_fill_col) > 0) qndt_fill(i,k,j) = -qn(i,k,j) * inv_dtcloud
              if (max(diag_id%qndt_fill,diag_id%qn_fill_col, &
                           diag_id%qldt_fill,diag_id%ql_fill_col) > 0)  &
               diag_4d(i,k,j,diag_pt%qndt_fill) = -qn(i,k,j) * inv_dtcloud
!             if (diag_id%debug1_3d > 0) debug1(i,k,j) = 0.
              if (diag_id%cf_liq_init   > 0) diag_4d(i,k,j,diag_pt%cf_liq_init  ) = 0.
             endif
            enddo
           enddo
          enddo
        endif

     else

      if (max(diag_id%qidt_fill,diag_id%qi_fill_col) > 0) then 
        where (qi .le. qmin) 
!         qidt_fill = -qi * inv_dtcloud
          diag_4d(:,:,:,diag_pt%qidt_fill) = -qi * inv_dtcloud
        endwhere
      endif

        if (.not. do_liq_num) then
!a        N3D = 0.
          diag_4d(:,:,:,diag_pt%droplets) = 0.
          if (max(diag_id%qldt_fill,diag_id%ql_fill_col) > 0) then
            where (ql .le. qmin) 
!             qldt_fill = -ql * inv_dtcloud
              diag_4d(:,:,:,diag_pt%qldt_fill) = -ql * inv_dtcloud
            endwhere
          endif
        else
!a        N3D = qn*airdens*1.e-6
          diag_4d(:,:,:,diag_pt%droplets) = qn(:,:,:)*airdens(:,:,:)*1.e-6
!         if (diag_id%debug1_3d   > 0) debug1 = min(qa,1.)
          if (diag_id%cf_liq_init     > 0) diag_4d(:,:,:,diag_pt%cf_liq_init  ) = min(qa,1.)
          do j=1,kdim
           do k=1,jdim
            do i=1,idim
             if (ql(i,k,j).le.qmin .or. qn(i,k,j).le.qmin) then
!a            N3D(i,k,j) = 0.
              diag_4d(i,k,j,diag_pt%droplets) = 0.
!             if (max(diag_id%qldt_fill,diag_id%ql_fill_col) > 0) qldt_fill(i,k,j) = -ql(i,k,j) * inv_dtcloud
              if (max(diag_id%qldt_fill,diag_id%ql_fill_col) > 0) diag_4d(i,k,j,diag_pt%qldt_fill) = -ql(i,k,j) * inv_dtcloud
! Should this just be diag_id%qndt_fill  + diag_id%qn_fill_col ?
!ORIGINAL:    if (diag_id%qldt_fill  > 0) &
              if (max(diag_id%qndt_fill,diag_id%qn_fill_col, &
                           diag_id%qldt_fill,diag_id%ql_fill_col) > 0)  &
!                           qndt_fill(i,k,j) = -qn(i,k,j) * inv_dtcloud
                            diag_4d(i,k,j,diag_pt%qndt_fill) = -qn(i,k,j) * inv_dtcloud
!             if (diag_id%debug1_3d    > 0) debug1(i,k,j) = 0.
              if (diag_id%cf_liq_init      > 0) diag_4d(i,k,j,diag_pt%cf_liq_init  ) = 0.
             endif
            enddo
           enddo
          enddo
        endif
     endif
!rab - end of statements moved outside large loop

!a   diag_4d(:,:,:, diag_pt%droplets) = N3D
!    diag_4d(:,:,:, diag_pt%droplets_wtd) = N3D*ql
     call mpp_clock_end(sc_pre_loop)
     call mpp_clock_begin(sc_loop)
!-----------------------------------------------------------------------
!
!       Enter the large loop over vertical levels.  Level 1 is the top
!       level of the column and level kdim is the bottom of the model.
!       If MASK is present, each column may not have kdim valid levels.
!
        rain3d = 0.
        snow3d = 0.
        snowclr3d = 0.

        DO j = 1, kdim

        sum_freeze = 0.
        sum_rime = 0.
        sum_berg = 0.
        f_snow_berg(:,:,j) = 0.
       
!-----------------------------------------------------------------------
!
!       Calculate pressure thickness of level and relative humidity 

        !calculate difference in pressure across the grid box divided
        !by gravity
        deltpg = (phalf(:,:,j+1)-phalf(:,:,j))/grav
         
        !calculate GRID box mean relative humidity 
        !       U = min(max(0.,qv(:,:,j)/qs(:,:,j)),1.)
 
        U = 0.
        where (qrat(:,:,j) .gt. 0.)
           U = min(max(0.,(qv(:,:,j)/(qrat(:,:,j)*qs(:,:,j)))),1.)
        end where
        
!-----------------------------------------------------------------------
!
!       Account for the fact that other processes may have created
!       negative tracer or extremely small values of tracer fields.
!       The general reason for the extremely small values of the 
!       tracer fields is due to vertical diffusion, advection of 
!       condensate or cumulus induced subsidence (also a form of 
!       advection) of condensate.
!
!       In this step any values of the prognostic variables which are 
!       less than qmin are reset to zero, while conserving total 
!       moisture.
!
!       Note that this is done slightly different for the Tiedtke
!       cloud fraction than it is for pdf clouds. In the former, 
!       the filling requires that cloud liquid, cloud ice, and 
!       cloud fraction are greater than qmin. For PDF clouds, 
!       cloud fraction need not be considered since it is diagnosed
!       below from the PDF clouds
!
    if (.not. do_pdf_clouds) then

        do k=1,jdim
         do i=1,idim
          qa_upd(i,k) = qa(i,k,j)      
          qi_upd(i,k) = qi(i,k,j)      
          ql_upd(i,k) = ql(i,k,j)      

          if (qa(i,k,j) .le. qmin) then
             SA(i,k,j)   = SA(i,k,j) - qa(i,k,j)
             qa_upd(i,k) = 0.
          end if
!       Correct for qa > RH, which is not permitted under the 
!       assumption that the cloudy air is saturated and the temperature 
!       inside and outside of the cloud are about the same.
          if (qa_upd(i,k) .gt. U(i,k)) then
!            if (max(diag_id%qadt_rhred,diag_id%qa_rhred_col) > 0 ) qadt_rhred(i,k,j) = (qa_upd(i,k)-U(i,k)) * inv_dtcloud
             if (max(diag_id%qadt_rhred,diag_id%qa_rhred_col) > 0 ) diag_4d(i,k,j,diag_pt%qadt_rhred) = (qa_upd(i,k)-U(i,k)) * inv_dtcloud
             SA(i,k,j)   = SA(i,k,j) + U(i,k) - qa_upd(i,k)
             qa_upd(i,k) = U(i,k)      
          end if
        
          if (.not. do_liq_num) then
            if (ql(i,k,j) .le. qmin .or. qa(i,k,j) .le. qmin) then
             SL(i,k,j)   = SL(i,k,j) - ql(i,k,j)
             SQ(i,k,j)   = SQ(i,k,j) + ql(i,k,j)
             ST(i,k,j)   = ST(i,k,j) - hlv*ql(i,k,j)/cp_air
             ql_upd(i,k) = 0.
            end if
          else
            qn_upd(i,k) = qn(i,k,j)
            if (ql(i,k,j) .le. qmin .or. qa(i,k,j) .le. qmin .or. qn(i,k,j) .le. qmin) then
             SL(i,k,j)   = SL(i,k,j) - ql(i,k,j)
             SQ(i,k,j)   = SQ(i,k,j) + ql(i,k,j)
             ST(i,k,j)   = ST(i,k,j) - hlv*ql(i,k,j)/cp_air
             SN(i,k,j)   = SN(i,k,j) - qn(i,k,j)
             ql_upd(i,k) = 0.
             qn_upd(i,k) = 0.
            endif
          endif

          if (qi(i,k,j) .le. qmin .or. qa(i,k,j) .le. qmin) then
             SI(i,k,j)   = SI(i,k,j) - qi(i,k,j)
             SQ(i,k,j)   = SQ(i,k,j) + qi(i,k,j)
             ST(i,k,j)   = ST(i,k,j) - hls*qi(i,k,j)/cp_air
             qi_upd(i,k) = 0.
          endif
         enddo
        enddo
        
    else

        do k=1,jdim
         do i=1,idim
          ql_upd(i,k) = ql(i,k,j)
          qi_upd(i,k) = qi(i,k,j)

          if (.not. do_liq_num) then
           if (ql(i,k,j) .le. qmin) then
             SL(i,k,j)   = SL(i,k,j) - ql(i,k,j)
             SQ(i,k,j)   = SQ(i,k,j) + ql(i,k,j)
             ST(i,k,j)   = ST(i,k,j) - hlv*ql(i,k,j)/cp_air
             ql_upd(i,k) = 0.
           endif
          else
           qn_upd(i,k) = qn(i,k,j)
           if (ql(i,k,j) .le. qmin .or. qn(i,k,j) .le. qmin) then
             SL(i,k,j)   = SL(i,k,j) - ql(i,k,j)
             SQ(i,k,j)   = SQ(i,k,j) + ql(i,k,j)
             ST(i,k,j)   = ST(i,k,j) - hlv*ql(i,k,j)/cp_air
             SN(i,k,j)   = SN(i,k,j) - qn(i,k,j)
             ql_upd(i,k) = 0.
             qn_upd(i,k) = 0.
           endif
          endif

          if (qi(i,k,j) .le. qmin) then
             SI(i,k,j)   = SI(i,k,j) - qi(i,k,j)
             SQ(i,k,j)   = SQ(i,k,j) + qi(i,k,j)
             ST(i,k,j)   = ST(i,k,j) - hls*qi(i,k,j)/cp_air
             qi_upd(i,k) = 0.
          endif
         end do
        end do
        
    end if !for do_pdf_clouds
        
        
!----------------------------------------------------------------------!
!                                                                      !
!                                                                      !
!                                                                      !
!                 NON-CONVECTIVE CONDENSATION                          !
!                                                                      !
!                                                                      !
!                                                                      !
!                         METHOD 1                                     !
!                                                                      !
!                                                                      !
!                  TIEDTKE (1993) CLOUD FRACTION                       !
!                                                                      !
!       ANALYTIC INTEGRATION OF SATURATED VOLUME FRACTION EQUATION     !
!                                                                      !
!                                                                      !
!
!       Do non-convective condensation following Tiedtke, pages 3044-5.
!       In this formulation stratiform clouds are only formed/destroyed 
!       when there is upward or downward motion to support/destroy it. 
!
!       The first step is to compute the change in qs due to large-
!       scale processes, dqs_ls.   In Tiedtke, it has contributions from 
!       large-scale uplift, convection induced compensating subsidence,
!       turbulence cooling and radiative cooling.  dqs_ls has the form:
!
!               (((omega+ grav*Mc)/airdens/cp)+radturbten)*dqsdT*dtcloud
!   (6) dqs_ls= --------------------------------------------------------
!                  1.  +   ( qa +  (da_ls/2.) ) * gamma
!
!       Here da_ls is the increase in cloud fraction due to non-
!       convective processes.  Because this increase is also a function
!       of dqs_ls, a quadratic equation must be solved for dqs_ls in
!       the case that da_ls is not equal to zero.
!
!       Note that if the PDF cloud scheme is active the Tiedtke large-
!       scale condensation is bypassed.

    if (.not.do_pdf_clouds) then

     do k=1,jdim
      do i=1,idim
        dqs_ls(i,k) =(((omega(i,k,j)+grav*Mc(i,k,j))/airdens(i,k,j)/cp_air)+&
                 radturbten2(i,k,j))*dtcloud*dqsdT(i,k,j)

        !compute pressure dependent U00 following ECMWF formula if 
        !desired
        U00p(i,k) = U00
        if (u00_profile) then
             if (pfull(i,k,j) .gt. 0.8*phalf(i,k,KDIM+1)) then
                    U00p(i,k) = U00 + (1.-U00)* &
                         (((pfull(i,k,j)-(0.8*phalf(i,k,KDIM+1))) &
                                    /    (0.2*phalf(i,k,KDIM+1)) )**2.)
             endif
        end if       

!ljd
!       modify u00p to account for humidity in convective system
!       See "Tiedtke u00 adjustment" notes, 10/22/02
!ljd
 
        u00p(i,k)=u00p(i,k)+(1.-u00p(i,k))*ahuco(i,k,j)

        if (dqs_ls(i,k).le.0. .and. U(i,k).ge.U00p(i,k) .and. qa_upd(i,k).lt.1.) then
             tmp1s = sqrt( (1.+qa_upd(i,k)*gamma(i,k,j))**2. - (1.-qa_upd(i,k)) * &
                    (1.-qa_upd(i,k))*gamma(i,k,j)*dqs_ls(i,k)/qs(i,k,j)/         &
                    max(1.-U(i,k),qmin) ) - (1.+qa_upd(i,k)*gamma(i,k,j))
             tmp1s = -1. * tmp1s / ((1.-qa_upd(i,k))*(1.-qa_upd(i,k))*gamma(i,k,j)/&
                    qs(i,k,j)/max(1.-U(i,k),qmin)/2.)
             dqs_ls(i,k) = min(tmp1s,dqs_ls(i,k)/(1.+0.5*(1.+qa_upd(i,k))*gamma(i,k,j)))
        else
             dqs_ls(i,k) = dqs_ls(i,k)/(1.+qa_upd(i,k)*gamma(i,k,j))
        endif
      
!       The next step is to compute the change in saturated volume
!       fraction due to non-convective condensation, da_ls.   This 
!       occurs in two conditions:
!
!       (a)  dqs_ls < 0. and U00 < U < 1., where U00 is the threshold
!            relative humidity for non-convective condensation. Note 
!            that if U is greater than or equal to 1., ideally qa = 1,
!            and da_ls = 0.  However this may not be the case for 
!            numerical reasons so this must be assured after analytic 
!            integration of the qa equation.
!
!            For these cases the change in saturated volume fraction is:
!
!   (7)      da_ls = - (1.-qa)*(1.-qa)*dqs_ls/2./qs/(1.-U)
!
!            This formula arises from the assumption that vapor is uni-
!            formly distributed in the range [qv_clr - (qs - qv_clr),qs]
!            where qv_clr is the amount of vapor in the unsaturated 
!            volume and is given from the following equation:
!
!   (8)      qv  =   qa * qs      +   (1.-qa) * qv_clr
!          
!            Implicit in equation (7) is the following assumption:
!            As qsat changes, the distribution of qv+ql+qi 
!            remains constant.  That is as qsat rises, portions where
!            qv+ql+qi > qsat+dqsat remain saturated.  This can only
!            occur if it is assumed that ql+qi evaporate-sublimate or
!            condense-deposit to keep qv = qsat. 
!
!       (b)  dqs_ls > 0.  Ideally some portion of the cloud should
!            evaporate however this is not accounted for at present.
!            

        !compute formula for da_ls
!       where (dqs_ls .le. 0. .and. U .ge. U00p)
!            da_ls = -0.5 * (1.-qa_upd) * (1.-qa_upd) * dqs_ls /       &
!             qs(:,:,j) / max(1.-U,qmin)
!       elsewhere
!            da_ls = 0.
!       end where 
 
        da_ls(i,k) = 0.
        if ((dqs_ls(i,k).le.0. .and. U(i,k).ge.U00p(i,k)) .and. &
              (qa_upd(i,k)+ahuco(i,k,j).le.1.)) then
             da_ls(i,k) = -0.5 * (1.-qa_upd(i,k)-ahuco(i,k,j)) * (1.-qa_upd(i,k)-    &
                ahuco(i,k,j))    * dqs_ls(i,k)/   qs(i,k,j) / max(1.-U(i,k),qmin)
        endif
      enddo
     enddo

!       Turbulent erosion of clouds
!
!       As in Tiedtke (1993) this is calculated using the eros_scale
!       parameter as:
!
!   (9) dql/dt    =  - qa * eros_scale * (qs - qv) * (ql/ ql+qi )
!
!  (10) dqi/dt    =  - qa * eros_scale * (qs - qv) * (qi/ ql+qi )
!
!  (11) dqa/dt    =  - qa * eros_scale * (qs - qv) * (qa/ ql+qi )
!
!       for which the erosion sink term (B in equation 13) is
!
!  (12) B = qa * eros_scale * (qs - qv) / (ql + qi)  
!
!
!       Theory for eros_scale
!
!       If eros_choice equals false, then a single erosion time scale
!       is used in all conditions (eros_scale).  If eros_choice equals
!       true then it is assumed that the timescale for turbulent 
!       evaporation is a function of the conditions in the grid box.  
!       Specifically, if the flow is highly turbulent then the scale is 
!       short, and eros_scale is large.  Likewise if convection is 
!       occurring, then it is assumed that the erosion term is larger 
!       than backround conditions. 
!
!       Here are the typical values for the timescales and the 
!       switches used:
!
!         Mixing type      eros_scale (sec-1)          Indicator
!       ----------------   ------------------     --------------------
!
!       Background            1.e-06              always present
!       Convective layers     5.e-06              Mc > Mc_thresh
!       Turbulent  layers     5.e-05              diff_t > diff_thresh
!

     do k=1,jdim
      do i=1,idim
        !Background erosion scale
        tmp2s = eros_scale

        !Do enhanced erosion in convective or turbulent layers?
        !
        !              IMPORTANT NOTE
        !                
        !Note that convection is considered first, so that if 
        !turbulence and convection occur in the same layer, the
        !erosion rate for turbulence is selected.                
        !
        
        if (eros_choice) then
             !Enhanced erosion in convective layers
             if (Mc(i,k,j) .gt. mc_thresh) tmp2s = eros_scale_c
        
             !Enhanced erosion in turbulent layers
             if (diff_t(i,k,j).gt.diff_thresh  .or.  &
                 diff_t(i,k,min(j+1,KDIM)).gt.diff_thresh) &
                   tmp2s = eros_scale_t
        end if   !for erosion choice

        if (ql_upd(i,k) .gt. qmin .or. qi_upd(i,k) .gt. qmin) then
          D_eros(i,k)=qa_upd(i,k) * tmp2s * dtcloud * qs(i,k,j) *      &
                      (1.-U(i,k)) / (qi_upd(i,k) + ql_upd(i,k))
          if (pfull(i,k,j) .gt. 400.e02) then
             D_eros(i,k)=D_eros(i,k)+efact*D_eros(i,k)*((pfull(i,k,kdim)-  &
                       pfull(i,k,j))/(pfull(i,k,kdim)-400.e02))
          else
             D_eros(i,k)=D_eros(i,k)+efact*D_eros(i,k)
          endif
        else
          D_eros(i,k) = 0.
        endif
      enddo
     enddo
     
!    
!       The next step is to analytically integrate the saturated volume
!       fraction equation.  This follows the Tiedtke approach
!
!       The qa equation is written in the form:
!
!  (13) dqa/dt    =   (1.-qa) * A   -  qa * B 
!
!       Note that over the physics time step, A, B are assumed to be 
!       constants.
!
!       Defining qa(t) = qa0 and qa(t+dtcloud) = qa1, the analytic
!       solution of the above equation is:
!
!  (14) qa1 = qaeq -  (qaeq - qa0) * exp (-(A+B)*dtcloud)
! 
!       where qaeq is the equilibrium cloud fraction that is approached
!       with an time scale of 1/(A+B),
!
!  (15) qaeq  =  A/(A+B)
!
!
!       To diagnose the magnitude of each of the right hand terms of
!       (13) integrated over the time step, define the average cloud
!       fraction in the interval t to t + dtcloud qabar as:
!
!  (16) qabar  = qaeq - [ (qa1-qa0) / ( dtcloud * (A+B) ) ]
! 
!       from which the magnitudes of the A and B terms integrated
!       over the time step are:
!
!       A * (1-qabar)    and    -B * (qabar)
!
!       Additional notes on this analytic integration:
!
!       1.   For large-scale cloud formation or destruction from 
!            the dqs_ls term the contributions to A or B are defined
!            from:
!
!  (19)      A_ls * (1. - qa) = da_ls / dtcloud      if da_ls >= 0.
! 
!  (20)      B_ls * qa        = da_ls / dtcloud      if da_ls < 0.
!
!       2.   Note that to reduce the number of variables, the following
!            equivalency exists:
!
!               Ql or Qi equation              Qa equation
!             --------------------         -------------------
! 
!                     C_dt                        A_dt
!                     D_dt                        B_dt
!                     qceq                        qaeq
!                     qcbar                       qabar
!                     qc1                         qa1
!                     qc0                         qa0
!
!       3.   Qa goes to zero only in the case of ql and qi less than or
!            equal to qmin; see 'cloud destruction code' near the end of 
!            this loop over levels.
!
     do k=1,jdim
      do i=1,idim
        !compute C_dt; This is assigned to the large-scale source term
        !following (18). Reset D_dt.
        C_dts = da_ls(i,k)/max((1.-qa_upd(i,k)),qmin)
        D_dts = D_eros(i,k)
  
        !do analytic integration      
        qc0s   = qa_upd(i,k)
        if ( (C_dts.gt.Dmin) .or. (D_dts.gt.Dmin) ) then
             qceqs  = C_dts  / (C_dts + D_dts)
             qc1s   = qceqs - (qceqs - qc0s) * exp ( -1.*(C_dts+D_dts) )
             qcbars = qceqs - ((qc1s - qc0s)/ (C_dts + D_dts))
        else
             qceqs  = qc0s   
             qc1s   = qc0s   
             qcbars = qc0s  
        endif

        !set total tendency term and update cloud fraction    
        if (limit_conv_cloud_frac) then
!RSH     limit cloud area to be no more than that which is not being
!        taken by convective clouds
          qc1s = MIN(qc1s, 1.0 -ahuco(i,k,j))
        endif
        SA(i,k,j)  = SA(i,k,j) + qc1s - qc0s
        qa_upd(i,k)     = qc1s
        
!       if (max(diag_id%qadt_lsform,diag_id%qa_lsform_col) > 0) qadt_lsform(i,k,j) =  C_dts * (1.-qcbars) * inv_dtcloud 
        if (max(diag_id%qadt_lsform,diag_id%qa_lsform_col) > 0) diag_4d(i,k,j,diag_pt%qadt_lsform) =  C_dts * (1.-qcbars) * inv_dtcloud 
!       if (max(diag_id%qadt_eros,diag_id%qa_eros_col)  > 0) qadt_eros  (i,k,j) =  D_dts *     qcbars  * inv_dtcloud
        if (max(diag_id%qadt_eros,diag_id%qa_eros_col)  > 0) diag_4d(i,k,j,diag_pt%qadt_eros) =  D_dts *     qcbars  * inv_dtcloud
        delta_cf(i,k) = C_dts * (1.-qcbars)

!       The next step is to calculate the change in condensate
!       due to non-convective condensation, dcond_ls. Note that this is
!       not the final change but is used only to apportion condensate
!       change between phases. According to Tiedtke 1993 this takes the
!       form:
!
!  (21) dcond_ls = -1. * (qa +  0.5*da_ls) * dqs_ls
!
!       Here the 0.5*da_ls represents using a midpoint cloud fraction.
!       This is accomplished by using the variable qcbar.

        dcond_ls(i,k) = -1. * qcbars * dqs_ls(i,k)
      enddo
     enddo
            

!----------------------------------------------------------------------!
!                                                                      !
!                                                                      !
!                                                                      !
!                 NON-CONVECTIVE CONDENSATION                          !
!                                                                      !
!                                                                      !
!                                                                      !
!                         METHOD 2                                     !
!                                                                      !
!                                                                      !
!                STATISTICAL CLOUD FRACTION                            !
!                                                                      !
!                                                                      !

    else                   !for doing PDF cloud scheme
    

        !set Tiedtke erosion term to zero            
        D_eros = 0.
        
        !compute pdf cloud fraction and condensate
        ! 
        !Note that the SYMMETRIC beta distribution is used here.
        !
        !
        ! Initialize grid-box mean values of cloud fraction (qag),
        ! cloud condensate(qcg), and clear sky water vapor (qvg)

        qcg = 0.
        qvg = 0.
        qag = 0.
        
        !Create loop over sub-levels within a grid box
        do ns = 1, nsublevels
        
             !calculate normalized vertical level
             ! 0. = top of gridbox
             ! 1. = bottom of gridbox
        
             pnorm =  (real(ns) - 0.5 )/real(nsublevels)
        
             !First step is to calculating the minimum (qtmin)
             !of the total water distribution and 
             !the width of the qt distribution (deltaQ)
             !
             !For diagnostic variance this is set to (1.-qthalfwidth)*qtbar
             !and 2*qthalfwidth*qtbar, respectively, where qtbar is the
             !mean total water in the grid box.        
             !
             !

             qtbar = qta4(2,:,:,j)+pnorm*( (qta4(3,:,:,j)-qta4(2,:,:,j)) + &
                                       qta4(4,:,:,j)*(1-pnorm) )
             
             qtbar = max(qmin,qtbar)
             deltaQ = 2.*qthalfwidth*qtbar
             qtmin = (1.-qthalfwidth)*qtbar
        
             !From this the variable normalized saturation specific
             !humidity qs_norm is calculated.
             !
             !  qs_norm = (qs(Tl) - qtmin)/(qtmax-qtmin)
             !
             !          = 0.5  - (qtbar - qs(Tl))/deltaQ
             !
             !Note that if qs_norm > 1., the grid box is fully clear.
             !If qs_norm < 0., the grid box is fully cloudy.
        
             qs_norm = qtqsa4(2,:,:,j)+  &
                       pnorm*( (qtqsa4(3,:,:,j)-qtqsa4(2,:,:,j)) + &
                       qtqsa4(4,:,:,j)*(1-pnorm) )
      
             qs_norm = 0.5 - ( qs_norm/deltaQ )
             
             !Calculation of cloud fraction (qagtmp), cloud condensate 
             !(qcgtmp), and water vapor in clear air part of the grid 
             !box (qvgtmp)
             !
             !Formulas (from Tompkins, and personal derivations):
             !
             !  Define icbp  = incomplete_beta(qs_norm,p,q)
             !         icbp1 = incomplete_beta(qs_norm,p+1,q)
             !
             !  qagtmp = 1. - icbp
             !
             !  qcgtmp = aThermo * {  (qtbar-qtmin)*(1.-icbp1) - 
             !                       qs_norm*deltaQ*(1.-icbp ) }
             !
             !
             !  qvgtmp = qtmin + (p/(p+q))*(icbp1/icbp)*deltaQ
             !
             !  
             ! where aThermo = 1./(1.+(L/cp)*dqsdT)
             !
             ! note that in the qvg formula below the factor of 0.5
             ! is equal to (p/(p+q)).
             !

             do jd = 1,jdim
             do id = 1,idim
        
             if (qs_norm(id,jd).le.1.) then
                 
                 icbp = incomplete_beta(max(0.,qs_norm(id,jd)), &
                                      p = betaP    , q = betaP)
                 icbp1= incomplete_beta(max(0.,qs_norm(id,jd)), &
                                      p = betaP + 1, q = betaP)
                 qagtmps = 1.-icbp
                 qcgtmps = (qtbar(id,jd)-qtmin(id,jd))*(1.-icbp1)&
                               - qs_norm(id,jd)*deltaQ(id,jd)*(1.-icbp)    
                 qcgtmps = qcgtmps/(1.+gamma(id,jd,j))
                 qvgtmps = qtmin(id,jd) + &
                               0.5*(icbp1/max(icbp,qmin))*deltaQ(id,jd)
             
                 !bound very very small cloud fractions which may
                 !cause negative cloud condensates due to roundoff 
                 !errors or similar errors in the beta table lookup.
                 if((qagtmps.lt.0.).or.(qcgtmps.le.0.))then
                      qagtmps = 0.
                      qcgtmps = 0.
                      qvgtmps = qtbar(id,jd)
                 end if
                 
             else             
                 qagtmps = 0.
                 qcgtmps = 0.
                 qvgtmps = qtbar(id,jd)             
             end if
    
             !sum vertically
             !
             !note special averaging of clear-sky water vapor
             !this is weighting clear-sky relative humidity by the 
             !clear-sky fraction
         
             qag(id,jd) = qag(id,jd) + qagtmps
             qcg(id,jd) = qcg(id,jd) + qcgtmps
             qvg(id,jd) = qvg(id,jd)+(1.-qagtmps)*min(max(qvgtmps/max(qmin, &
                       (qtbar(id,jd)+((qs_norm(id,jd)-0.5)*deltaQ(id,jd)))),0.),1.)
        
             !compute grid-box average cloud fraction, cloud condensate
             !and water vapor
        
             if (nsublevels.gt.1 .and. ns.eq.nsublevels) then
                  qag(id,jd) = qag(id,jd) / real(nsublevels)
                  qcg(id,jd) = qcg(id,jd) / real(nsublevels)
             
                  !note special averaging of clear-sky water vapor
                  if ((1.-qag(id,jd)).gt.qmin) then
                      qvg(id,jd) =qvg(id,jd)/real(nsublevels)/&
                                  (1.-qag(id,jd))
                      qvg(id,jd) =qvg(id,jd) * qs(id,jd,j)
                  else
                      qvg(id,jd) = qs(id,jd,j)
                  end if
             elseif (nsublevels.eq.1) then
                  ! for nsublevels = 1, qag and qcg already hold their
                  ! final values
                  qvg(id,jd) = qvgtmps
             end if
             enddo
             enddo
             
        enddo !for number of sublevels loop
             
        !do adjustment of cloud fraction
!rab        qc0 = qa(:,:,j)
!rab        qc1 = qag

        !set total tendency term and update cloud fraction    
        SA(:,:,j)  = SA(:,:,j) + qag - qa(:,:,j)
        qa_upd     = qag

!       if (max(diag_id%qadt_lsform,diag_id%qa_lsform_col) > 0) qadt_lsform(:,:,j) =  max(qag-qa(:,:,j),0.) * inv_dtcloud 
        if (max(diag_id%qadt_lsform,diag_id%qa_lsform_col) > 0) diag_4d(:,:,j,diag_pt%qadt_lsform) =  max(qag-qa(:,:,j),0.) * inv_dtcloud 
!       if (max(diag_id%qadt_lsdiss,diag_id%qa_lsdiss_col) > 0) qadt_lsdiss(:,:,j) =  max(qa(:,:,j)-qag,0.) * inv_dtcloud
        if (max(diag_id%qadt_lsdiss,diag_id%qa_lsdiss_col) > 0) diag_4d(:,:,j,diag_pt%qadt_lsdiss) =  max(qa(:,:,j)-qag,0.) * inv_dtcloud

        !define da_ls and delta_cf needed when do_liq_num = .true. (cjg)
        da_ls = max(qag-qa(:,:,j),0.)
        delta_cf = max(qag-qa(:,:,j),0.)

        !compute large-scale condensation / evaporation
        dcond_ls = qcg - (ql_upd + qi_upd)

    end if    !for doing PDF clouds

!       The next step is the apportionment on the non-convective 
!       condensation between liquid and ice phases. Following the
!       suggestion of Rostayn (2000), all condensation at temperatures
!       greater than -40C is in liquid form as ice nuclei are generally 
!       limited in the atmosphere. The droplets may subsequently be 
!       converted to ice by the Bergeron-Findeisan mechanism.  
!
!       One problem with this formulation is that the proper saturation
!       vapor pressure is not used for cold clouds as it should be
!       liquid saturation in the case of first forming liquid, but
!       change to ice saturation as the cloud glaciates.  The current
!       use of ice saturation beneath -20C thus crudely mimics the
!       result that nearly all stratiform clouds are glaciated for
!       temperatures less than -15C.
!
!       In the case of large-scale evaporation (dcond_ls<0.), it is
!       assumed that cloud liquid will evaporate faster than cloud
!       ice because if both are present in the same volume the
!       saturation vapor pressure over the droplet is higher than 
!       that over the ice crystal.
!
!       The fraction of large-scale condensation that is liquid
!       is stored in the temporary variable tmp1.   

        do k=1,jdim
         do i=1,idim
          !assume liquid fractionation 
          tmp1s = 1.

          if (dcond_ls(i,k) .ge. 0.) then

           !For cases of cloud condensation where temperatures are
           !less than -40C create only ice
           if (T(i,k,j) .lt. tfreeze-40.) then
             tmp1s = 0.
           endif

          else

           if (qi_upd(i,k).gt.qmin) then

            if (ql_upd(i,k).gt.qmin) then
             !For cases of cloud evaporation of mixed phase clouds
             !set liquid evaporation to preferentially occur first
             tmp1s = min(-1.*dcond_ls(i,k),ql_upd(i,k))/max(-1.*dcond_ls(i,k),qmin)
            else
             !do evaporation of pure ice cloud
             tmp1s = 0.
            endif

           endif

          endif
          !calculate partitioning among liquid and ice to dcond_ls
          dcond_ls_ice(i,k) = (1.-tmp1s) * dcond_ls(i,k)
          dcond_ls(i,k)     = tmp1s * dcond_ls(i,k)      
         enddo
        enddo

!       The next step is to compute semi-implicit qa,ql,qi which are 
!       used in many of the formulas below.  This gives a somewhat 
!       implicitness to the scheme. In this calculation an estimate 
!       is made of what the cloud fields would be in the absence of 
!       cloud microphysics and cloud erosion.
!
!       In the case of the Tiedtke cloud scheme, the mean cloud 
!       condensate is incremented if large-scale condensation is 
!       occuring. For cloud fraction, the value from the analytic 
!       integration above is used.
!
!       For the statistical cloud scheme these are set equal to the
!       values diagnosed from the beta-distribution apart from the
!       corrections for mixed phase clouds.

        qa_mean = qa_upd
        if (.not. do_pdf_clouds) then
             ql_mean = ql_upd + max(dcond_ls    ,0.)        
             qi_mean = qi_upd + max(dcond_ls_ice,0.)
        else
             ql_mean = max(ql_upd + dcond_ls    ,qmin)
             qi_mean = max(qi_upd + dcond_ls_ice,qmin)  
        end if
        if (do_liq_num) then 
!yim's CCN activation
          do k = 1,jdim
            do i = 1,idim
              if ( da_ls(i,k) > 0.0 ) then
                up_strat = -1.*(((omega(i,k,j)+grav*Mc(i,k,j))/ &
                                           airdens(i,k,j)/grav) + &
                                  radturbten2(i,k,j)*cp_air/grav)
                          
!-->cjg: modification
!               call aer_ccn_act (T(i,k,j), pfull(i,k,j), up_strat, &
!                                 totalmass1(i,k,j,:), drop1(i,k))
                thickness = deltpg(i,k) / airdens(i,k,j)
                wp2 = 2.0/(3.0*0.548**2)* &
                      (0.5*(diff_t(i,k,j) + diff_t(i,k,min(j+1,KDIM)))/&
                                                         thickness )**2
                wp2 = MAX (wp2, var_limit**2)
!rab take care of it when writing diags....
!rab                debug2(i,k,j) = wp2**0.5
!               if (diag_id%debug2_3d > 0) debug2(i,k,j) = wp2
                if (diag_id%subgrid_w_variance > 0 .and. up_strat > 0.0) diag_4d(i,k,j,diag_pt%subgrid_w_variance) = wp2
                call aer_ccn_act_wpdf (T(i,k,j), pfull(i,k,j), &
                                       up_strat, wp2,    &
                                       totalmass1(i,k,j,:), drop1(i,k))
!               if (diag_id%debug3_3d > 0) debug3(i,k,j) = drop1(i,k)
                if (diag_id%potential_droplets > 0 .and. up_strat > 0.0) diag_4d(i,k,j,diag_pt%potential_droplets) = drop1(i,k)
!               if (diag_id%debug2_3d > 0) debug2(i,k,j) = 1.
!<--cjg: end of modification
                qn_mean(i,k) = qn_upd(i,k) + max(delta_cf(i,k),0.)*  &
                               drop1(i,k)*1.e6/airdens(i,k,j)
              else
                drop1(i,k) = 0.                
                qn_mean(i,k) = qn_upd(i,k)
                if (diag_id%subgrid_w_variance > 0) diag_4d(i,k,j,diag_pt%subgrid_w_variance) =  0.0
                if (diag_id%potential_droplets > 0) diag_4d(i,k,j,diag_pt%potential_droplets) = 0.0        
              endif
            end do
          end do        
        endif


    
        !compute diagnostics for cloud fraction
!       if (diag_id%aall > 0) areaall(:,:,j) = qa_mean
        if (diag_id%aall > 0) diag_4d(:,:,j, diag_pt%aall) = qa_mean
!       if (diag_id%aliq > 0 .or. diag_id%rvolume > 0) then
        if (max(diag_id%aliq,diag_id%rvolume) > 0) then
!             where (ql_mean .gt. qmin) arealiq(:,:,j) = qa_mean
              where (ql_mean .gt. qmin) diag_4d(:,:,j,diag_pt%aliq) = qa_mean
        end if
!       if (diag_id%aice > 0 .or. diag_id%vfall > 0) then
        if (max(diag_id%aice,diag_id%vfall) > 0) then
!             where (qi_mean .gt. qmin) areaice(:,:,j) = qa_mean
              where (qi_mean .gt. qmin) diag_4d(:,:,j,diag_pt%aice) = qa_mean
        end if              

  
!-----                                                            -----! 
!                                                                      !
!                                  END OF                              !
!                                                                      !
!                        NON-CONVECTIVE CONDENSATION                   !
!                                                                      !
!                                 SECTION                              !
!                                                                      !
!                                                                      !
!                                                                      !
!----------------------------------------------------------------------!



!-----------------------------------------------------------------------
!
!
!
!            TRANSFER OF RAIN FLUXES AND SNOW FLUXES BETWEEN 
!      
!           SATURATED AND UNSATURATED PORTIONS OF THE GRID BOX
!
!                           AT LAYER INTERFACES
!                           
!
!       Do transfer of rain and snow fluxes between clear and cloud 
!       portions of the grid box. This formulism follows the rain/snow
!       parameterization developed by Jakob and Klein (2000).  It 
!       treats the grid mean flux of rain and snow separately according 
!       to the portion that exists in unsaturated air and the portion 
!       that exists in saturated air.  At the top of each level, some 
!       precipitation that was in unsaturated air in the levels above 
!       may enter saturated air and vice versa. These transfers are 
!       calculated here under an assumption for the overlap between 
!       precipitation area and saturated area at the same and adjacent 
!       levels.
!
!       For rain, the area of the grid box in which rain in saturated 
!       air of the level above enters unsaturated air in the current 
!       level is called da_cld2clr and is given by 
!       maximum(a_rain_cld - qa , 0.) in the case of maximum overlap of
!       rain_cld and qa, but equal to a_rain_cld*(1.-qa) in the case of
!       random overlap of cloud and precipitation. The grid mean flux of 
!       rain which is transfered from saturated air to unsaturated air 
!       is given by rain_cld*da_cld2clr/a_rain_cld.
!
!       The area of the grid box where rain in unsaturated air of the
!       level above enters saturated air in the current level is
!       called da_clr2cld and is given by
!       maximum(0.,mininum(a_rain_clr,qa(j)-qa(j-1))) in the case of
!       maximum overlap of cloud and rain_clr, but equal to a_rain_clr*
!       qa for the case of random overlap of cloud and precipitation.  
!       The grid mean flux of rain transfered from unsaturated air to 
!       saturated air is given by rain_clr*da_clr2cld/a_rain_clr.
!
!       NOTE: the overlap assumption used is set by the namelist 
!             variable in cloud_rad
!
!       Overlap values are:      1  = maximum
!                                2  = random
!
!       If cloud_generator is on, the overlap choice is taken from
!       there, by computing a quantity alpha, which is weighting 
!       between maximum and random overlap solutions.
!
!                alpha = 1 ---> maximum,
!                alpha = 0 ---> random
!
!       alpha is stored in tmp3.
!       tmp1 has the maximum overlap solution
!       tmp2 has the random overlap solution
       
!
        if (cloud_generator_on) then
             if (j.gt.1) then
                  tmp3 = compute_overlap_weighting(qa_mean_lst,qa_mean,&
                         pfull(:,:,j-1),pfull(:,:,j))
                  tmp3 = min(1.,max(0.,tmp3))       
             else
                  tmp3 = 0.0
             end if
        end if      
!
!
!       Rain transfers are done first
!

        call cloud_clear_xfer (cloud_generator_on, tmp3, qa_mean, qa_mean_lst, a_rain_clr, a_rain_cld, rain_clr, rain_cld)
!
!       Snow transfers are done second, in a manner exactly like that
!       done for the rain fluxes
!

        call cloud_clear_xfer (cloud_generator_on, tmp3, qa_mean, qa_mean_lst, a_snow_clr, a_snow_cld, snow_clr, snow_cld)

   
               
!-----------------------------------------------------------------------
!
!
!                        MELTING OF CLEAR SKY SNOW FLUX
!
!
!       Melting of falling ice to rain occurs when T > tfreeze. The 
!       amount of melting is limited to the melted amount that would 
!       cool the temperature to tfreeze.
!
!       In the snowmelt bug version, the temperature of melting was 
!       tfreeze + 2. like the original Tiedtke (1993) paper, instead of 
!       tfreeze.

        snow_fact=0.
        if (do_old_snowmelt) snow_fact=2.
     do k=1,jdim
      do i=1,idim
        !compute grid mean change in snow flux to cool the
        !grid box to tfreeze and store in temporary variable tmp1
        tmp1s = cp_air*(T(i,k,j)-tfreeze-snow_fact)*deltpg(i,k)*inv_dtcloud/hlf
        
        ! If snow_clr > tmp1, then the amount of snow melted is
        ! limited to tmp1, otherwise melt snow_clr.  The amount
        ! melted is stored in tmp2
        tmp2s = max(min(snow_clr(i,k),tmp1s),0.)     

        ST(i,k,j) = ST(i,k,j) - hlf*tmp2s*dtcloud/deltpg(i,k)/cp_air                
        rain_clr(i,k)  = rain_clr(i,k) + tmp2s
        
        !raise a_rain_clr to a_snow_clr IF AND only IF melting occurs
        !and a_rain_clr < a_snow_clr
        if (tmp2s .gt. 0. .and. a_snow_clr(i,k) .gt. qmin)  &
             a_rain_clr(i,k) = max(a_rain_clr(i,k),a_snow_clr(i,k))

        ! If all of the snow has melted, then zero out a_snow_clr
        if (snow_clr(i,k).lt.tmp1s .and. a_snow_clr(i,k).gt.qmin) then
             snow_clr(i,k) = 0.
             a_snow_clr(i,k) = 0.
        else
             snow_clr(i,k) = snow_clr(i,k) - tmp2s          
        endif

!       if (max(diag_id%snow_melt,diag_id%snow_melt_col) > 0) snow_melt(i,k,j) = tmp2s/deltpg(i,k)             
        if (max(diag_id%snow_melt,diag_id%snow_melt_col) > 0) diag_4d(i,k,j,diag_pt%snow_melt) = tmp2s/deltpg(i,k)             
             
!-----------------------------------------------------------------------
!
!
!                        MELTING OF CLOUDY SKY SNOW FLUX
!
!
!       Melting of falling ice to rain occurs when T > tfreeze. The 
!       amount of melting is limited to the melted amount that would 
!       cool the temperature to tfreeze.
!

        if (.not.do_old_snowmelt) then

        !compute grid mean change in snow flux to cool the
        !grid box to tfreeze and store in temporary variable tmp1
        !
        !note that tmp1 already has the value of this variable 
        !from the clear-sky melt calculation, so one does not need
        !to repeat the calculation here.
        !
        !However, note that clear-sky snow melt may have already 
        !reduced the temperature of the grid box - this snow melt is in 
        !variable tmp2 from lines above. Thus the amount that one
        !can melt is less.
        
        tmp1s = tmp1s - tmp2s
        
        ! If snow_cld > tmp1, then the amount of snow melted is
        ! limited to tmp1, otherwise melt snow_cld.  The amount
        ! melted is stored in tmp2
        tmp2s = max(min(snow_cld(i,k),tmp1s),0.)     

        ST(i,k,j) = ST(i,k,j) - hlf*tmp2s*dtcloud/deltpg(i,k)/cp_air                
        rain_cld(i,k)  = rain_cld(i,k) + tmp2s
        
        !raise a_rain_cld to a_snow_cld IF AND only IF melting occurs
        !and a_rain_cld < a_snow_cld
        if (tmp2s .gt. 0. .and. a_snow_cld(i,k) .gt. qmin) &
             a_rain_cld(i,k) = max(a_rain_cld(i,k),a_snow_cld(i,k))

        ! If all of the snow has melted, then zero out a_snow_cld
        if (snow_cld(i,k).lt.tmp1s .and. a_snow_cld(i,k).gt.qmin) then
             snow_cld(i,k) = 0.
             a_snow_cld(i,k) = 0.
        else
             snow_cld(i,k) = snow_cld(i,k) - tmp2s          
        endif

!       if (max(diag_id%snow_melt,diag_id%snow_melt_col) > 0) snow_melt(i,k,j) =  snow_melt(i,k,j) + &
!                                               tmp2s/deltpg(i,k)
        if (max(diag_id%snow_melt,diag_id%snow_melt_col) > 0) diag_4d(i,k,j,diag_pt%snow_melt) =  diag_4d(i,k,j,diag_pt%snow_melt) + &
                                                tmp2s/deltpg(i,k)

        end if  !for snowmelt bugfix
       enddo
      enddo
                            
!----------------------------------------------------------------------!
!
!
!              COMPUTE SLOPE FACTOR FOR ICE MICROPHYSICS                  
!
!       [The following microphysics follows that of Rotstayn (1997)]
!       The number concentration of ice crystals of diameter D in the
!       SIZE interval D to D+dD is assumed to be 
!       distributed as in a Marshall Palmer distribution :
!
!  (22) N(D)dD = Nof * Exp( - lamda_f * D)
!
!       The slope factor and intercept are not assumed to be constant,
!       but the slope factor is
!
!  (23) lamda_f = 1.6X10^(3.+0.023(tfreeze-T))
!
!       Integration of (22) over all particle sizes with a constant
!       density of ice crystals , rho_ice, and assumed spherical shape
!       yields a relationship between the intercept parameter and qi
!
!  (24) Nof = airdens*qi_local*(lamda_f^4)/pi*rho_ice
!       
!
!       For the calculation of riming and sublimation of snow, 
!       lamda_f is needed, so it is calculated here.
!
!       Also qi_mean is updated here with the flux of ice that falls 
!       into the cloudy portion of the grid box from above. This permits
!       the Bergeron and riming process to know about the ice that falls
!       into the grid box in the same time step.

        !Increment qi_mean by the ice flux entering the
        !the grid box. To convert ice_flux to units of condensate by
        !multiply by dtcloud and dividing by the mass per unit area 
        !of the grid box. Implicit here is the assumption that the
        !ice entering the cloud will be spread instantaneously over
        !all of the cloudy area.
        qi_mean = qi_mean + snow_cld*dtcloud/deltpg        

        !snow falling into cloud reduces the amount that
        !falls out of cloud: a loss of cloud ice from settling
        !is defined to be positive
!       if (max(diag_id%qidt_fall,diag_id%qi_fall_col) > 0) qidt_fall(:,:,j)= -1.*snow_cld/deltpg
        if (max(diag_id%qidt_fall,diag_id%qi_fall_col) > 0) diag_4d(:,:,j,diag_pt%qidt_fall)= -1.*snow_cld/deltpg
         
        !compute lamda_f
        lamda_f = 1.6 * 10**(3.+0.023*(tfreeze-T(:,:,j)))
        

!----------------------------------------------------------------------!
!                                                                      !
!                                                                      !
!                                                                      !
!                       LIQUID PHASE MICROPHYSICS                      !
!                                                                      !
!                                 AND                                  !
!                                                                      !
!                  ANALYTIC INTEGRATION OF QL EQUATION                 !
!                                                                      !
!                                                                      !
!                                                                      !
!       Accretion
!
!       The parameterization of collection of cloud liquid drops by
!       rain drops follows the parameterization of Rotstayn (1997).
!       The parameterization starts with the continous-collection 
!       equation of drops by a rain drop of diameter D, falling with
!       speed V(D).   The fall speed of rain drops is taken from
!       Gunn and Kinzer(1949):
!
!  (25) V(D) = 141.4 (m**0.5,s-1) * sqrt(D) * (rho_ref/airdens)**0.5
!
!       where D is the radius of the rain drops in meters. Here
!       rho_ref is a reference air density.  This formula is generally
!       good for 1 mm < D < 4 mm.
!
!       The distribution of rain drops by SIZE follows a Marshall-
!       Palmer distribution:
!
!  (26) N(D) dD = Nor * Exp (- lamda *D)
!
!       where N(D)dD is the number of rain drops with SIZE D in the
!       interval D to D+dD, Nor is the intercept (assumed fixed at
!       8E+04 (1/m*m*m*m).  lamda is the slope intercept parameter
!       and with (21) it can be shown that lamda is a function of
!       the rain rate.
!
!       With these assumptions the local rate of accretion of cloud
!       liquid reduces to:
!
!  (27) dl/dt_local = - CB*Eco*((rain_rate_local/dens_h2o)**(7/9))*
!                        
!                       (rho_ref/airdens)**(1/9)   * ql_local
!
!       where CB is the accretion constant:
! 
!       CB = 65.772565 [(m)**(-7/9)] * [(s)**(-2/9)]
!
!       AND Eco is the collection efficiency of a cloud droplet by a 
!       rain droplet.   A good fit to the Table 8.2 of Rogers and Yau 
!       (1988) for rain drops between SIZE 1mm and 3mm is:
!
!  (28) Eco = rad_liq**2 / (rad_liq**2 + 20.5 microns**2) .
!
!       In generalizing to grid mean conditions (27) becomes:
!
!  (29) dl/dt = - (arain_cld/qa_mean) * CB * Eco * 
!
!                 [(rain_cld/a_rain_cld/dens_h2o)**(7/9)] * ql
!        
!       Note that the very weak dependence on air density is
!       neglected at this point.
!
!       The particle sizes are computed from the following equation
!
!  (30) rad_liq = (3*airdens*ql/(4*pi*liq_dens*qa*N)^(1/3)
!
!       
!       For numerical treatment we write (25) as:
!
!       dl/dt = - D_acc * l 
!
!       and if we do so:
!
!  (31) D_acc   =  (arain_cld/qa_mean) * CB * Eco * 
!
!                 [(rain_cld/a_rain_cld/dens_h2o)**(7/9)] 
!
!       In the work below, D_acc is added to D1_dt, the first processes
!       contributing to the depletion of cloud liquid in the analytic
!       integration.  D1_dt represents the conversion of liquid to rain.

        if (.not. do_liq_num) then
        !compute rad_liq.  The constant below is equal to  
        !1.E+06 * (3/4*pi)^(1/3), where the 1E+06 is
        !the factor to convert meters to microns.
        
          rad_liq= 620350.49 *( (airdens(:,:,j)*ql_mean/ &
                        max(qa_mean,qmin)/N/dens_h2o)**(1./3.))

        !do not let very small cloud fractions contribution to
        !autoconversion or accretion
          where (qa_mean .le. qmin) rad_liq = 0.
        else        
!yim The 1st place droplet number is used
          rad_liq= 620350.49 *( (ql_mean/max(qn_mean,qmin)/dens_h2o)**(1./3.))
          !do not let very small cloud fractions contribution to
          !autoconversion or accretion
          where (qa_mean .le. qmin .or. qn_upd .le.qmin) rad_liq = 0.
        endif
        
!       if (diag_id%rvolume > 0) rvolume(:,:,j) = rad_liq*arealiq(:,:,j)
!       if (diag_id%rvolume > 0) rvolume(:,:,j) = rad_liq*diag_4d(:,:,j,diag_pt%aliq)
!       if (diag_id%rvolume > 0) diag_4d(:,:,j,diag_pt%rvolume) = rad_liq*arealiq(:,:,j)
        if (diag_id%rvolume > 0) diag_4d(:,:,j,diag_pt%rvolume) = rad_liq*diag_4d(:,:,j,diag_pt%aliq)

        !compute accretion D term
        D1_dt =  dtcloud * 65.772565 * (a_rain_cld/max(qa_mean,qmin))* &
                 ( rad_liq*rad_liq / (rad_liq*rad_liq+20.5) ) *        &
                 ((rain_cld/max(a_rain_cld,qmin)/dens_h2o)**(7./9.))
            
!       if (max(diag_id%qldt_accr,diag_id%ql_accr_col)  > 0) qldt_accr(:,:,j) = D1_dt
        if (max(diag_id%qldt_accr,diag_id%ql_accr_col)  > 0) diag_4d(:,:,j,diag_pt%qldt_accr) = D1_dt
    
!       Autoconversion
!
!       The autoconversion parameterization follow that of Manton
!       and Cotton (1977).  This formula has been used in Chen and
!       Cotton (1987) and is used in the CSIRO GCM (Rotstayn 1997)
!       and the LMD GCM (Boucher, Le Treut and Baker 1995).  In this
!       formulation the time rate of change of grid mean liquid is
!
!  (32) dl/dt= -CA * qa * [(ql/qa)^(7/3)] * [(N*dens_h2o)^(-1/3)] 
!
!               * H(rad_liq - rthresh)
!
!       where N is the number of cloud droplets per cubic metre,
!       rthresh is a particle radius threshold needed to for autoconv-
!       ersion to occur, H is the Heaviside function, and CA is
!       a constant which is:
!
!  (33) CA =  0.104 * grav * Ec * (airdens)^(4/3) / mu 
!        
!       where grav is gravitational acceleration, Ec is the collection
!       efficiency, airdens is the density of air, and mu is the 
!       dynamic viscosity of air.   This constant is evaluated 
!       ignoring the temperature dependence of mu and with a fixed 
!       airdens of 1 kg/m3.
!
!       With   Ec = 0.55        (standard choice - see references)
!            grav = 9.81        m/(s*s)
!         airdens = 1.00        kg air/(m*m*m)
!              mu = 1.717  E-05 kg condensate/(m*s) 
!
!              CA = 32681. [(kg air)^(4/3)]/kg liq/m/s
!
!
!       For numerical treatment we write (32) as:
!
!       dl/dt = - D_aut * l 
!
!       and if we do so:
!
!  (34) D_aut   =   CA * [(N*dens_h2o)^(-1/3)] * [(ql/qa)^(4/3)] * &
!                   H(r-rthresh)
!
!       In the work below, D_aut is temporarily stored in the variable
!       tmp1 before being added to D1_dt.  D1_dt represents the 
!       conversion of liquid to rain.
!
!       Following Rotstayn, autoconversion is limited to the amount that
!       would reduce the local liquid cloud condensate to the critical
!       value at which autoconversion begins. This limiter is likely to
!       be invoked frequently and is computed from
!
!  (35) D_dt = log( (rad_liq/rthresh)**3. )
!
!       This limiter is stored in tmp2.
!
!
!
!       -------------------------------------------------
!
!       Khairoutdinov and Kogan (2000) Autoconversion
!
!       Reference: Khairoutdinov, M. and Y. Kogan, 2000: A new cloud 
!                  physics parameterization in a large-eddy simulation
!                  model of marine stratocumulus. Mon. Wea. Rev., 128,
!                  229-243.
!
!       If the namelist parameter use_kk_auto = true, then the 
!       Khairoutdinov and Kogan (KK) autoconversion parameterization
!       is used in place of the Manton and Cotton formula described
!       above.
!
!       In SI units this formula is:
!
!  (32A) dl/dt= -CA * qa * [(ql/qa)^(2.47)] * [(N)^(-1.79)] 
!
!
!       where N is the number of cloud droplets per cubic metre
!       and CA is a constant which is:
!
!  (33A) CA =  7.4188E+13 (kg condensate/kg air)**(-1.47)
!                         (# drops/meters**3)**(1.79)
!                         seconds**(-1) 
!        
!       For numerical treatment we write (32A) as:
!
!       dl/dt = - D_aut * l 
!
!       and if we do so:
!
!  (34A) D_aut   =   CA * [(N)^(-1.79)] * [(ql/qa)^(1.47)]
!

        if (do_liq_num) then
          if (use_kk_auto) then
!*************************yim's version based on Khairoutdinov and Kogan (2000)
!The second place N is used
          tmp1 = dtcloud * 1350. *  &
        (1.e-6*max(qn_mean*airdens(:,:,j),max(qa_mean,qmin)*N_min))**(-1.79)*  &
         (ql_mean)**(1.47)*max(qa_mean,qmin)**(0.32)
!         tmp1 = dtcloud * 1350. *  &
!                (1.e-6*max(qn_mean,N_min)*airdens(:,:,j))**(-1.79)*  &
!                (ql_mean)**(1.47)*max(qa_mean,qmin)**(0.32)
!**************************
          else
!yim fall back to M & C using qn
             !compute autoconversion sink as in (34)
             tmp1 = 32681. * dtcloud * ((max(qn_mean,qmin)*airdens(:,:,j)*dens_h2o)**(-1./3.))*       &
                       (ql_mean**(4./3.))/max(qa_mean,qmin)
  
             !compute limiter as in (35)
             tmp2 =max(3*log(max(rad_liq,qmin)/rthresh),0.)
  
             !limit autoconversion to the limiter
             tmp1 = min(tmp1,tmp2)
          endif
       else
        if ( use_kk_auto ) then
             tmp1 = 0.
             !compute autoconversion sink as in (34A)
             where (ql_mean.gt.qmin)
                  tmp1 = 7.4188E+13 * dtcloud *  (N**(-1.79))*         &
                    ((ql_mean/max(qa_mean,qmin))**(1.47))
             endwhere
        else
             !compute autoconversion sink as in (34)
             tmp1 = 32681. * dtcloud * ((N*dens_h2o)**(-1./3.))*       &
                    ((ql_mean/max(qa_mean,qmin))**(4./3.))
        
             !compute limiter as in (35)
             tmp2 =max(3*log(max(rad_liq,qmin)/rthresh),0.)

             !limit autoconversion to the limiter
             tmp1 = min(tmp1,tmp2)

        endif
        endif


        !add autoconversion to D1_dt
        D1_dt = D1_dt + tmp1

        !auto conversion will change a_rain_cld upto area of cloud
        where (tmp1 .gt. Dmin) a_rain_cld = qa_mean

!       if (max(diag_id%qldt_auto,diag_id%ql_auto_col) > 0) qldt_auto(:,:,j) = tmp1        
        if (max(diag_id%qldt_auto,diag_id%ql_auto_col) > 0) diag_4d(:,:,j,diag_pt%qldt_auto) = tmp1        

        if ( diag_id%aauto > 0 ) then
!            where ( rad_liq .gt. rthresh ) areaautocv(:,:,j) = qa_mean       
             where ( rad_liq .gt. rthresh ) diag_4d(:,:,j,diag_pt%aauto) = qa_mean       
        end if
        

!       Bergeron-Findeisan Process 
!
!       where ice and liquid coexist, the differential saturation
!       vapor pressure between liquid and ice phases encourages
!       the growth of ice crystals at the expense of liquid droplets.
!
!       Rotstayn (2000) derive an equation for the growth of ice by
!       starting with the vapor deposition equation for an ice crystal
!       and write it in terms of ice specific humidity as:
!
!                 {(Ni/airdens)**2/3}*7.8
!  (36) dqi/dt =  ------------------------  X [(esl-esi)/esi] X
!                 [rhoice**1/3]* A_plus_B
!
!                 ((max(qi,Mio*Ni/airdens))**(1/3))*
!
!       Here Ni is the ice crystal number which is taken from the 
!       parameterization of Meyers et al. :
!
!  (37) Ni = 1000 * exp( (12.96* [(esl-esi)/esi]) - 0.639 )
!
!       The use of the maximum operator assumed that there is a 
!       background ice crystal always present on which deposition can 
!       occur.  Mio is an initial ice crystal mass taken to be 10-12kg.
!
!       Figure 9.3 of Rogers and Yau (1998) shows the nearly linear
!       variation of [(esl-esi)/esi] from 0. at 273.16K to 0.5 at 
!       233.16K.  Analytically this is parameterized as (tfreeze-T)/80.
!
!
!       Generalizing (36) to grid mean conditions and writing it in 
!       terms of a loss of cloud liquid yields:
!
!                  (1000*exp((12.96*(tfreeze-T)/80)-0.639)/airdens)**2/3
!  (38) dql/dt = - ----------------------------------------------------- 
!                           [rhoice**1/3]* A_plus_B * ql
!
!       *qa*7.8*((max(qi/qa,Mio*Ni/airdens))**(1/3))*[(tfreeze-T)/80]*ql
!
!       Note that the density of ice is set to 700 kg m3 the value 
!       appropriate for pristine ice crystals.  This value is 
!       necessarily different than the value of ice used in the riming 
!       and sublimation part of the code which is for larger particles 
!       which have much lower densities.
        
        if (do_dust_berg) then
        crystal=0.
        do k = 1,jdim
                do i = 1,idim
                if ( (T(i,k,j) .lt. tfreeze) .and. (ql_mean(i,k) .gt. qmin)      &
                                        .and. (qa_mean(i,k) .gt. qmin))         then
                                Si0=1+0.0125*(tfreeze-T(i,k,j))
                                call Jhete_dep(T(i,k,j),Si0,concen_dust_sub(i,k,j),crystal(i,k))
!                               if (diag_id%debug4_3d > 0) debug4(i,k,j) = 1.                                      
                                if (diag_id%dust_berg_flag > 0) diag_4d(i,k,j,diag_pt%dust_berg_flag) = 1.                                      
                endif
                end do
          end do

!        if (max(diag_id%qndt_cond,diag_id%qn_cond_col) > 0) qndt_cond(:,:,j) = crystal
         if (max(diag_id%qndt_cond,diag_id%qn_cond_col) > 0) diag_4d(:,:,j, diag_pt%qndt_cond) = crystal
         if (max(diag_id%qndt_evap,diag_id%qn_evap_col) > 0) then
!          qndt_evap(:,:,j) = 0.
           diag_4d(:,:,j,diag_pt%qndt_evap) = 0.
           where (T(:,:,j).lt.tfreeze .and. ql_mean.gt.qmin .and. qa_mean.gt.qmin)              
!           qndt_evap(:,:,j) = 1.e-3*exp((12.96*0.0125*(tfreeze-T(:,:,j)))-0.639)
            diag_4d(:,:,j,diag_pt%qndt_evap) = 1.e-3*exp((12.96*0.0125*(tfreeze-T(:,:,j)))-0.639)
           end where
         endif
 
       !do Bergeron process
       D2_dt = 0.0
       where (T(:,:,j) .lt. tfreeze .and. ql_mean .gt. qmin .and. qa_mean .gt. qmin)              
             D2_dt =  dtcloud * qa_mean * ((1.e6*crystal(:,:)/airdens(:,:,j))**(2./ &
                      3.))* 7.8* ((max(qi_mean/qa_mean,1.E-12*1.e6*   &
                      crystal(:,:)     &
                      /airdens(:,:,j)))**(1./3.))*0.0125*              &
                      (tfreeze-T(:,:,j))/((700.**(1./3.))*       &
                      A_plus_B(:,:,j)*ql_mean)
       end where

    else
        !do Bergeron process
        D2_dt = 0.0        
        where (T(:,:,j) .lt. tfreeze .and. ql_mean .gt. qmin .and. qa_mean .gt. qmin)           
             D2_dt =  dtcloud * qa_mean * ((cfact*1000.*exp((12.96*0.0125*   &
                      (tfreeze-T(:,:,j)))-0.639)/airdens(:,:,j))**(2./ &
                      3.))* 7.8* ((max(qi_mean/qa_mean,1.E-12*cfact*1000.*   &
                      exp((12.96*0.0125*(tfreeze-T(:,:,j)))-0.639)     &
                      /airdens(:,:,j)))**(1./3.))*0.0125*              &
                      (tfreeze-T(:,:,j))/((700.**(1./3.))*             &
                      A_plus_B(:,:,j)*ql_mean)
        end where

      endif

        sum_berg = D2_dt
!       if (max(diag_id%qldt_berg,diag_id%ql_berg_col) > 0) qldt_berg(:,:,j) = D2_dt
        if (max(diag_id%qldt_berg,diag_id%ql_berg_col) > 0) diag_4d(:,:,j,diag_pt%qldt_berg) = D2_dt
       
!       Accretion of cloud liquid by ice ('Riming')
!       
!       [The below follows Rotstayn]
!       Accretion of cloud liquid by ice ('Riming') is derived in
!       the same way as the accretion of cloud liquid by rain. That
!       is the continous-collection equation for the growth of an
!       ice crystal is integrated over all ice crystal sizes. This
!       calculation assumes all crystals fall at the mass weighted
!       fall speed, Vfall.  This yields the following equation after
!       accounting for the area of the interaction
!
!  (39) dql/dt = -  ( a_snow_cld / qa/a_snow_cld ) *
!                   ( ELI * lamda_f * snow_cld / 2/ rho_ice ) * ql 
!
!
!       Note that in the version with the snowmelt bug, riming was
!       prevented when temperatures were in excess of freezing.

        !add in accretion of cloud liquid by ice
        tmp1 = 0.0
        if (do_old_snowmelt) then
             where ((a_snow_cld.gt.qmin) .and. (ql_mean.gt.qmin) .and. &
                    (   qa_mean.gt.qmin) .and. (T(:,:,j) .lt. tfreeze) )            
                 tmp1 = dtcloud*0.5*ELI*lamda_f*snow_cld/qa_mean/rho_ice              
             end where
        else
             where ((a_snow_cld.gt.qmin) .and. (ql_mean.gt.qmin) .and. &
                    (   qa_mean.gt.qmin) )            
                 tmp1 = dtcloud*0.5*ELI*lamda_f*snow_cld/qa_mean/rho_ice              
             end where
        end if        
        
        D2_dt = D2_dt + tmp1

        sum_rime = tmp1
!       if (max(diag_id%qldt_rime,diag_id%ql_rime_col) > 0) qldt_rime(:,:,j) = tmp1
        if (max(diag_id%qldt_rime,diag_id%ql_rime_col) > 0) diag_4d(:,:,j,diag_pt%qldt_rime) = tmp1

!       Freezing of cloud liquid to cloud ice occurs when
!       the temperature is less than -40C. At these very cold temper-
!       atures it is assumed that homogenous freezing of cloud liquid
!       droplets will occur.   To accomplish this numerically in one 
!       time step:
!
!  (40) D*dtcloud =  ln( ql / qmin ).
!
!       With this form it is guaranteed that if this is the only
!       process acting that ql = qmin after one integration.
!
               
        !do homogeneous freezing
        where ( T(:,:,j).lt.tfreeze-40..and.(ql_mean.gt.qmin).and.     &
               (qa_mean.gt.qmin))
             D2_dt = log ( ql_mean / qmin )
        end where
        
          do k=1,jdim
           do i=1,idim
             if (T(i,k,j).lt.(tfreeze-40.).and.(ql_mean(i,k).gt.qmin)    &
               .and.(qa_mean(i,k).gt.qmin)) then
               sum_freeze(i,k) = D2_dt(i,k)
               sum_rime(i,k) = 0.
               sum_berg(i,k) = 0.
             endif
           enddo
          enddo

        if (max(diag_id%qldt_freez,diag_id%qldt_rime,diag_id%qldt_berg,diag_id%ql_freez_col,  &
                diag_id%ql_rime_col,diag_id%ql_berg_col) > 0) then
          do k=1,jdim
           do i=1,idim
             if (T(i,k,j).lt.(tfreeze-40.).and.(ql_mean(i,k).gt.qmin)    &
               .and.(qa_mean(i,k).gt.qmin)) then
               if (max(diag_id%qldt_freez,diag_id%ql_freez_col) > 0) diag_4d(i,k,j,diag_pt%qldt_freez) = D2_dt(i,k)
               if (max(diag_id%qldt_rime,diag_id%ql_rime_col) > 0) diag_4d(i,k,j,diag_pt%qldt_rime ) = 0.
               if (max(diag_id%qldt_berg,diag_id%ql_berg_col) > 0) diag_4d(i,k,j,diag_pt%qldt_berg ) = 0.     
             endif
           enddo
          enddo
        end if
  
! For BC aerosol in-cloud scavenging:
          do k=1,jdim
           do i=1,idim
             qldt_sum = sum_berg(i,k) + sum_freeze(i,k) + sum_rime(i,k)
             if (qldt_sum > 0.) f_snow_berg(i,k,j) = sum_berg(i,k)/qldt_sum
           enddo
          enddo

!       Analytic integration of ql equation
!
!
!       The next step is to analytically integrate the cloud liquid
!       condensate equation.  This follows the Tiedtke approach.
!
!       The qc equation is written in the form:
!
!  (41) dqc/dt    =   C   -  qc * D   
!
!       Note that over the physics time step, C and D are assumed to 
!       be constants.
!
!       Defining qc(t) = qc0 and qc(t+dtcloud) = qc1, the analytic
!       solution of the above equation is:
!
!  (42) qc1 = qceq -  (qceq - qc0) * exp (-D*dtcloud)
! 
!       where qceq is the equilibrium cloud condensate that is approached
!       with an time scale of 1/D,
!
!  (43) qceq  =   C / D 
!
!
!       To diagnose the magnitude of each of the right hand terms of
!       (41) integrated over the time step, define the average cloud
!       condensate in the interval t to t + dtcloud qcbar as:
!
!  (44) qcbar  = qceq - [ (qc1-qc0) / ( dtcloud * D ) ]
! 
!       from which the magnitudes of the C and D terms integrated
!       over the time step are:
!
!       C   and   -D * (qcbar)
!   
!
!       Additional notes on this analytic integration:
!
!       1.   Because of finite machine precision it is required that
!            D*dt is greater than a minimum value.  This minimum
!            alue occurs where 1. - exp(-D*dt) = 0. instead of 
!            D*dt.  This value will be machine dependent. See discussion
!            at top of code for Dmin.
!

        !C_dt is set to large-scale condensation. Sink of cloud liquid 
        !is set to the sum of D1 (liquid to rain component), and D2 
        !(liquid to ice component), D_eros (erosion), and large-scale 
        !evaporation (note use of ql mean).        

        do k=1,jdim
        do i=1,idim
        C_dts = max(dcond_ls(i,k),0.)
        D_dts = D1_dt(i,k) + D2_dt(i,k) + D_eros(i,k) +                                &
               (max(-1.*dcond_ls(i,k),0.)/max(ql_mean(i,k),qmin)) 
                             
        !do analytic integration      
        qc0s   = ql_upd(i,k)
        if ( D_dts.gt.Dmin ) then
             qceqs  = C_dts   /  D_dts
             qc1s   = qceqs - (qceqs - qc0s) * exp ( -1.* D_dts )
             qcbars = qceqs - ((qc1s - qc0s)/ D_dts)
        else
             qceqs  = qc0s + C_dts   
             qc1s   = qc0s + C_dts
             qcbars = qc0s + 0.5*C_dts
        endif

        !set total tendency term and update cloud
        !Note that the amount of SL calculated here is stored in tmp1.
        SL(i,k,j)  = SL(i,k,j) + qc1s - qc0s
        ql_upd(i,k)     = qc1s

        !compute the amount each term contributes to the change     
!rab        Dterm  = -D_dt *      qcbar

!       Apportion SL between various processes.  This is necessary to
!       account for how much the temperature changes due to various
!       phase changes.   For example:
!
!       liquid to ice   = (D2/D)*(-Dterm)
!
!       liquid to rain  = (D1/D)*(-Dterm) 
!
!       (no phase change but needed to know how much to increment 
!        rainflux)
!
!       vapor to liquid = - { ((-dcond_ls/ql_mean)+D_eros)/D}*(-Dterm) 
!                        where dcond_ls < 0 
!                                  
!                         but
!
!                        dcond_ls  -(D_eros/D)*(-Dterm)
!                        where dcond_ls > 0
!

        !initialize tmp2 to hold (-Dterm)/D
!rab        tmp2 = -Dterm/max(D_dt,Dmin)

   if (Nml%retain_cm3_bug) then
        tmp2(i,k) = D_dts*qcbars/max(D_dts,Dmin)
   else
        if ( D_dts.gt.Dmin ) then
        tmp2(i,k) = D_dts*qcbars/max(D_dts,Dmin)
        else
        tmp2(i,k) = 0.
        endif
   endif
        
        !do phase changes from large-scale processes and boundary
        !layer condensation/evaporation
 
        ST(i,k,j) = ST(i,k,j) + (hlv*max(dcond_ls(i,k),0.)/cp_air) -          &
             (hlv*(max(-1.*dcond_ls(i,k),0.) /max(ql_mean(i,k),qmin))*tmp2(i,k)/cp_air)
   
        SQ(i,k,j) = SQ(i,k,j) -      max(dcond_ls(i,k),0.)     +            &
                  (max(-1.*dcond_ls(i,k),0.) /max(ql_mean(i,k),qmin))*tmp2(i,k)
            
        !add in liquid to ice and cloud erosion to temperature tendency
        ST(i,k,j) = ST(i,k,j) + (hlf*D2_dt(i,k)-hlv*D_eros(i,k))*tmp2(i,k)/cp_air

        !cloud evaporation adds to water vapor
        SQ(i,k,j) = SQ(i,k,j) + D_eros(i,k)*tmp2(i,k)
             
        !add conversion of liquid to rain to the rainflux
        rain_cld(i,k) = rain_cld(i,k) +D1_dt(i,k)*tmp2(i,k)*deltpg(i,k)*inv_dtcloud
     
        !save liquid converted to ice into tmp3 and increment qi_mean
        tmp3(i,k)    = tmp2(i,k)*D2_dt(i,k)
        qi_mean(i,k) = qi_mean(i,k) + tmp3(i,k)
        enddo
        enddo
     
        
        if (do_liq_num) then
!******************************************************************

!       Analytic integration of qn equation
!
!       The qn equation is written in the form:
!
!  (m1) dqc/dt    =   (1 - qabar) * A * qc^   -  qc * D
!                 =   C - qc * D
!
!       where  qc^ is the large-scale qn calculated from the
!       activation parameterization.   Note that over the physics
!       time step, C and D are assumed to be constants.
!
!       Defining qc(t) = qc0 and qc(t+dtcloud) = qc1, the analytic
!       solution of the above equation is:
!
!  (m2) qc1 = qceq -  (qceq - qc0) * exp (-D*dtcloud)
! 
!       where qceq is the equilibrium cloud droplet number that is approached
!       with an time scale of 1/D,
!
!  (m3) qceq  = C / D
!
!
!       To diagnose the magnitude of each of the right hand terms of
!       (m1) integrated over the time step, define the average cloud
!       condensate in the interval t to t + dtcloud qcbar as:
!
!  (m4) qcbar  = qceq - [ (qc1-qc0) / ( dtcloud * D ) ]
! 
!       from which the magnitudes of the C and D terms integrated
!       over the time step are:
!
!       C and -D * (qcbar)
!

!Calculate C_dt
!       C_dt=max(tmp5,0.)*drop1*1.e6/airdens(:,:,j)
!For replying the review, substract autoconversion
!        D_dt = D1_dt + D2_dt + D_eros 

        !do analytic integration      
!       where ( (D_dt.gt.Dmin) ) 
!            qc0   = qn_upd
!            qceq  = C_dt  / max(D_dt, Dmin)
!            qc1   = qceq - (qceq - qc0) * exp ( -1.* D_dt )
!            qcbar = qceq - ((qc1 - qc0)/ max(D_dt, Dmin))
!       elsewhere
!            qc0   = qn_upd
!            qceq  = qc0 + C_dt   
!            qc1   = qc0 + C_dt
!            qcbar = qc0 + 0.5*C_dt
!       end where

!        if (max(diag_id%qndt_cond,diag_id%qn_cond_col) > 0) qndt_cond(:,:,j) = 0.
         if (max(diag_id%qndt_cond,diag_id%qn_cond_col) > 0) diag_4d(:,:,j,diag_pt%qndt_cond) = 0.

          do k=1,jdim
            do i=1,idim
!Calculate C_dt
              C_dts=max(delta_cf(i,k),0.)*drop1(i,k)*1.e6/airdens(i,k,j)
              D_dts =  num_mass_ratio1*D1_dt(i,k) + (num_mass_ratio2*D2_dt(i,k) + D_eros(i,k))
              qc0s = qn_upd(i,k)
              if (D_dts > Dmin) then
                qceqs = C_dts / D_dts
                qc1s  = qceqs - (qceqs - qc0s)* exp(-1.*D_dts)
                qcbars = qceqs - ((qc1s -qc0s)/D_dts)
              else
                qceqs  = qc0s + C_dts
                qc1s   = qc0s + C_dts
                qcbars = qc0s + 0.5*C_dts
              endif
        !set total tendency term and update cloud
        !Note that the amount of SN calculated here is stored in tmp1.
              SN(i,k,j)  = SN(i,k,j) + qc1s - qc0s
              qn_upd(i,k)     = qc1s


        !compute the amount each term contributes to the change 
!        where ( C_dt .gt. 0 )
!                Cterm  =  C_dt             
!                Dterm  =  D_dt *      qcbar 
!        elsewhere
!                Cterm  =  0.             
!                Dterm  =  D_dt *      qcbar 
!        end where

         if (max(diag_id%qndt_cond,diag_id%qn_cond_col) > 0) then
!         if ( C_dts.gt. 0 ) qndt_cond(i,k,j)  =  C_dts
          if ( C_dts.gt. 0 ) diag_4d(i,k,j,diag_pt%qndt_cond)  =  C_dts
         endif

!        if (max(diag_id%qndt_evap,diag_id%qn_evap_col) > 0) qndt_evap(i,k,j) = D_dts * qcbars !Dterm
         if (max(diag_id%qndt_evap,diag_id%qn_evap_col) > 0) diag_4d(i,k,j,diag_pt%qndt_evap) = D_dts * qcbars !Dterm
            end do
          end do

        endif  ! (do_liq_num)

!****************************************************************************


!
!       diagnostics for cloud liquid tendencies
!       

!       if (max(diag_id%qldt_cond,diag_id%ql_cond_col) > 0) qldt_cond(:,:,j)  = max(dcond_ls,0.) *inv_dtcloud
        if (max(diag_id%qldt_cond,diag_id%ql_cond_col) > 0) diag_4d(:,:,j,diag_pt%qldt_cond)  = max(dcond_ls,0.) *inv_dtcloud
!       if (max(diag_id%qldt_evap,diag_id%ql_evap_col) > 0) qldt_evap(:,:,j)  = (max(0.,-1.*dcond_ls )/max(ql_mean,   &
        if (max(diag_id%qldt_evap,diag_id%ql_evap_col) > 0) diag_4d(:,:,j,diag_pt%qldt_evap)  = (max(0.,-1.*dcond_ls )/max(ql_mean,   &
                                 qmin))           *tmp2*inv_dtcloud
!       if (max(diag_id%qldt_accr,diag_id%ql_accr_col) > 0) qldt_accr(:,:,j)  = qldt_accr (:,:,j)*tmp2*inv_dtcloud
        if (max(diag_id%qldt_accr,diag_id%ql_accr_col) > 0) diag_4d(:,:,j,diag_pt%qldt_accr)  = diag_4d(:,:,j,diag_pt%qldt_accr)*tmp2*inv_dtcloud
!       if (max(diag_id%qldt_auto,diag_id%ql_auto_col) > 0) qldt_auto(:,:,j)  = qldt_auto (:,:,j)*tmp2*inv_dtcloud
        if (max(diag_id%qldt_auto,diag_id%ql_auto_col) > 0) diag_4d(:,:,j,diag_pt%qldt_auto)  = diag_4d(:,:,j,diag_pt%qldt_auto )*tmp2*inv_dtcloud
!       if (max(diag_id%qldt_eros,diag_id%ql_eros_col) > 0) qldt_eros(:,:,j)  = D_eros           *tmp2*inv_dtcloud 
!       if (max(diag_id%qldt_berg,diag_id%ql_berg_col) > 0) qldt_berg(:,:,j)  = qldt_berg (:,:,j)*tmp2*inv_dtcloud
        if (max(diag_id%qldt_berg,diag_id%ql_berg_col) > 0) diag_4d(:,:,j,diag_pt%qldt_berg)  = diag_4d(:,:,j,diag_pt%qldt_berg )*tmp2*inv_dtcloud
!       if (max(diag_id%qldt_rime,diag_id%ql_rime_col) > 0) qldt_rime(:,:,j)  = qldt_rime (:,:,j)*tmp2*inv_dtcloud
        if (max(diag_id%qldt_rime,diag_id%ql_rime_col) > 0) diag_4d(:,:,j,diag_pt%qldt_rime)  = diag_4d(:,:,j,diag_pt%qldt_rime )*tmp2*inv_dtcloud
!       if (max(diag_id%qldt_freez,diag_id%ql_freez_col) > 0) qldt_freez(:,:,j) = qldt_freez(:,:,j)*tmp2*inv_dtcloud
        if (max(diag_id%qldt_freez,diag_id%ql_freez_col) > 0) diag_4d(:,:,j,diag_pt%qldt_freez) = diag_4d(:,:,j,diag_pt%qldt_freez)*tmp2*inv_dtcloud
!       if (max(diag_id%qndt_cond,diag_id%qn_cond_col) > 0) qndt_cond(:,:,j)  = qndt_cond(:,:,j)*inv_dtcloud 
        if (max(diag_id%qndt_cond,diag_id%qn_cond_col) > 0) diag_4d(:,:,j,diag_pt%qndt_cond)  = diag_4d(:,:,j,diag_pt%qndt_cond)*inv_dtcloud 
!       if (max(diag_id%qndt_evap,diag_id%qn_evap_col) > 0) qndt_evap(:,:,j)  = qndt_evap(:,:,j)*inv_dtcloud 
        if (max(diag_id%qndt_evap,diag_id%qn_evap_col) > 0) diag_4d(:,:,j,diag_pt%qndt_evap)  = diag_4d(:,:,j,diag_pt%qndt_evap)*inv_dtcloud 

!       if (max(diag_id%qldt_cond,diag_id%ql_cond_col) > 0) diag_4d(:,:,j,diag_pt%qldt_cond)  = max(dcond_ls,0.) *inv_dtcloud
!       if (max(diag_id%qldt_evap,diag_id%ql_evap_col) > 0) diag_4d(:,:,j,      diag_pt%qldt_evap)  = (max(0.,-1.*dcond_ls )/max(ql_mean,   &
!                                qmin))           *tmp2*inv_dtcloud
!       if (max(diag_id%qldt_accr,diag_id%ql_accr_col) > 0) diag_4d(:,:,j,      diag_pt%qldt_accr)  = qldt_accr (:,:,j)
!       if (max(diag_id%qldt_auto,diag_id%ql_auto_col) > 0) diag_4d(:,:,j,      diag_pt%qldt_auto)  = qldt_auto (:,:,j)
        if (max(diag_id%qldt_eros,diag_id%ql_eros_col) > 0) diag_4d(:,:,j,      diag_pt%qldt_eros)  = D_eros           *tmp2*inv_dtcloud 
!       if (max(diag_id%qldt_berg,diag_id%ql_berg_col) > 0) diag_4d(:,:,j,      diag_pt%qldt_berg)  = qldt_berg (:,:,j)
!       if (max(diag_id%qldt_rime,diag_id%ql_rime_col) > 0) diag_4d(:,:,j,      diag_pt%qldt_rime)  = qldt_rime (:,:,j)
!       if (max(diag_id%qldt_freez,diag_id%ql_freez_col) > 0) diag_4d(:,:,j,diag_pt%qldt_freez) = qldt_freez(:,:,j)
!       if (max(diag_id%qndt_cond,diag_id%qn_cond_col) > 0) diag_4d(:,:,j,      diag_pt%qndt_cond)  = qndt_cond(:,:,j) 
!       if (max(diag_id%qndt_evap,diag_id%qn_evap_col) > 0) diag_4d(:,:,j,      diag_pt%qndt_evap)  = qndt_evap(:,:,j) 
        


!-----                                                            -----! 
!                                                                      !
!                                END OF                                !
!                                                                      !
!                       LIQUID PHASE MICROPHYSICS                      !
!                                                                      !
!                                 AND                                  !
!                                                                      !
!                  ANALYTIC INTEGRATION OF QL EQUATION                 !
!                                                                      !
!                               SECTION                                !
!                                                                      !
!                                                                      !
!                                                                      !
!----------------------------------------------------------------------!
!----------------------------------------------------------------------!
!                                                                      !
!                                                                      !
!                                                                      !
!                        ICE PHASE MICROPHYSICS                        !
!                                                                      !
!                                 AND                                  !
!                                                                      !
!                  ANALYTIC INTEGRATION OF QI EQUATION                 !
!                                                                      !
!                                                                      !
!                                                                      !
!       Ice settling
!
!       Ice settling is treated as in Heymsfield Donner 1990. 
!       The mass weighted fall speed is parameterized as in equation
!       #49.
!
!       In terms of the analytic integration with respect qi of Tiedtke,
!       the flux in from the top of the grid layer is equated to the
!       source term, and the flux out of the bottom of the layer is 
!       equated to the sink term:
!
!  (47) C_dt =  snow_cld * dtcloud * grav / deltp
!
!  (48) D_dt =  airdens * grav * Vfall * dtcloud / deltp
!
!       All ice crystals are assumed to fall with the same fall speed
!       which is given as in Heymsfield and Donner (1990) as:
!
!  (49) Vfall = 3.29 * ( (airdens*qi_mean/qa_mean)**0.16)
!
!       which is the formula in Heymsfield and Donner.  Note however
!       that because this is uncertain, sensitivity runs will be made
!       with different formulations. Note that when Vfall is computed 
!       the source incremented qi, qi_mean, is used.  This gives some 
!       implicitness to the scheme.

        !compute Vfall
        iwc = airdens(:,:,j)*qi_mean/max(qa_mean,qmin)
        where (iwc >= iwc_crit)
           Vfall = vfact*3.29 * iwc**0.16
        elsewhere
           Vfall = vfact*vfall_const2 * iwc**vfall_exp2
        end where

!       if (diag_id%vfall > 0) vfalldiag(:,:,j) = Vfall(:,:)*areaice(:,:,j)
!       if (diag_id%vfall > 0) vfalldiag(:,:,j) = Vfall(:,:)*diag_4d(:,:,j,diag_pt%aice)
!       if (diag_id%vfall > 0) diag_4d(:,:,j,diag_pt%vfall) = Vfall(:,:)*areaice(:,:,j)
        if (diag_id%vfall > 0) diag_4d(:,:,j,diag_pt%vfall) = Vfall(:,:)*diag_4d(:,:,j,diag_pt%aice)

        !add to ice source the settling ice flux from above
        !also note that tmp3 contains the source
        !of liquid converted to ice from above
        tmp3 = tmp3 + snow_cld*dtcloud/deltpg
        
        !Compute settling of ice. The result is multiplied by 
        !dtcloud/deltp to convert to units of D_dt.  
        !Note that if tracers are not advected then this is done
        !relative to the local vertical motion.
        if (tracer_advec) then
             tmp1 = 0.
        else
             tmp1 = omega(:,:,j)
        end if 
        
        where (qi_mean .gt. qmin .and. qa_mean .gt. qmin)
             D1_dt      = max(0.,((airdens(:,:,j)*Vfall)+(tmp1/grav))* &
                          dtcloud/deltpg )
             a_snow_cld = qa_mean     
        elsewhere
             D1_dt      = 0.
             snow_cld   = 0.
             a_snow_cld = 0.    
        end where 

        
!       Melting of in-cloud ice
!
!       Melting occurs where the temperature is greater than Tfreezing. 
!       This is an instaneous process such that no stratiform ice will
!       remain in the grid at the end of the timestep. 
!       No ice settles out of the grid box (i.e. D1 is set to zero) when
!       the amount of ice to be melted is less than that that would
!       bring the grid box to the freezing point.
!
!       The ice that melts becomes rain.  This is because if an ice
!       crystal of dimension ~100 microns and mass density of 100 kg/m2
!       melts it will become a droplet of SIZE 40 microns which is 
!       clearly a drizzle SIZE drop.  Ice crystals at temperatures near 
!       freezing are assumed to be this large, consistent with the 
!       assumption of particle SIZE temperature dependence.
!

        !compute grid mean change in cloud ice to cool the
        !grid box to 0C and store in temporary variable tmp1
        tmp1 = cp_air*(T(:,:,j)-tfreeze)/hlf

        ! If qi_mean > tmp1, then the amount of ice melted is
        ! limited to tmp1, otherwise melt all qi_mean.  The amount
        ! melted is stored in tmp2
        tmp2  = max(min(qi_mean,tmp1),0.)     
        D2_dt = max(0.,log(max(qi_mean,qmin)/max(qi_mean-tmp2,qmin)))
            
        !melting of ice creates area to a_rain_cld
        where (D2_dt .gt. Dmin) 
             a_rain_cld = qa_mean
        endwhere
                  
        !If all of the ice can melt, then don't permit any ice to fall
        !out of the grid box and set a_snow_cld to zero.
        where (qi_mean .lt. tmp1 .and. qi_mean .gt. qmin) 
             D1_dt = 0.
             snow_cld = 0.
             a_snow_cld = 0.
        end where
         
!       Analytic integration of qi equation
!
!       This repeats the procedure done for the ql equation.
!       See above notes for detail.

        !At this point C_dt already includes the source of cloud ice 
        !falling from above as well as liquid converted to ice. 
        !Therefore add in large_scale deposition.
        !
        !Compute D_dt which has contributions from D1_dt (ice settling)
        !and D2_dt (ice melting), D_eros (cloud erosion), and large-
        !scale sublimation (note use of qi mean).

      do k=1,jdim
       do i=1,idim
        C_dts = tmp3(i,k) + max(dcond_ls_ice(i,k),0.)
        D_dts =  D1_dt(i,k) + D2_dt(i,k) + D_eros(i,k) +                               &
                (max(-1.*dcond_ls_ice(i,k),0.)/max(qi_mean(i,k),qmin))
        
        !do analytic integration      
        qc0s   = qi_upd(i,k)
        if ( D_dts.gt.Dmin ) then
             qceqs  = C_dts / D_dts
             qc1s   = qceqs - (qceqs - qc0s) * exp ( -1.* D_dts )
             qcbars = qceqs - ((qc1s - qc0s)/D_dts)
        else
             qceqs  = qc0s + C_dts   
             qc1s   = qc0s + C_dts
             qcbars = qc0s + 0.5*C_dts
        endif

        !set total tendency term and update cloud
        !Note that the amount of SL calculated here is stored in tmp1.
        SI(i,k,j)  = SI(i,k,j) + qc1s - qc0s
        qi_upd(i,k)     = qc1s

        !compute the amount each term contributes to the change     
!rab        Dterm  = -D_dt *          qcbar 
      
!       Apportion SI between various processes.  This is necessary to
!       account for how much the temperature and water vapor changes 
!       due to various phase changes.   For example:
!
!       ice settling = (D1/D)*(-Dterm)*deltp/grav/dtcloud
!                     
!       vapor to ice =
!           -{ ((-dcond_ls_ice/qi_mean)+D_eros)/ D }*(-Dterm) 
!           where dcond_ls_ice  < 0. 
!
!           but
!       
!           dcond_ls_ice -(D_eros/D)* (-Dterm)
!
!           where dcond_ls_ice > 0.
!       
!       melting of ice = (D2/D)*(-Dterm)*deltp/grav/dtcloud
!

        !initialize tmp2 to hold (-Dterm)/D
!rab        tmp2 = -Dterm/max(D_dt,Dmin)
   if (Nml%retain_cm3_bug) then
        tmp2s = D_dts*qcbars/max(D_dts,Dmin)
   else
        if ( D_dts.gt.Dmin ) then
        tmp2s = D_dts*qcbars/max(D_dts,Dmin)
        else
        tmp2s = 0.
        endif
   endif
        
        !do phase changes from large-scale processes 
        ST(i,k,j) = ST(i,k,j) +  hls*max(dcond_ls_ice(i,k),0.)/cp_air -    &
         hls*(max(-1.*dcond_ls_ice(i,k),0.)/max(qi_mean(i,k),qmin))*tmp2s/cp_air
       
        SQ(i,k,j) = SQ(i,k,j) -      max(dcond_ls_ice(i,k),0.)    +         &
             (max(-1.*dcond_ls_ice(i,k),0.)/max(qi_mean(i,k),qmin))*tmp2s
     
        !cloud erosion changes temperature and vapor
        ST(i,k,j) = ST(i,k,j) - hls*D_eros(i,k)* tmp2s/cp_air
        SQ(i,k,j) = SQ(i,k,j) +     D_eros(i,k)* tmp2s

        !add settling ice flux to snow_cld 
        snow_cld(i,k) = D1_dt(i,k)*tmp2s*deltpg(i,k)*inv_dtcloud
       
        !add melting of ice to temperature tendency
        ST(i,k,j) = ST(i,k,j) - hlf*D2_dt(i,k)*tmp2s/cp_air

        !add melting of ice to the rainflux
        rain_cld(i,k) = rain_cld(i,k) + D2_dt(i,k)*tmp2s*deltpg(i,k)*inv_dtcloud

!
!       diagnostics for cloud ice tendencies
!       
        
!       if (max(diag_id%qidt_dep,diag_id%qi_dep_col) > 0) &
!               qidt_dep (i,k,j) = max(dcond_ls_ice(i,k),0.)*inv_dtcloud
        if (max(diag_id%qidt_dep,diag_id%qi_dep_col) > 0) &
                diag_4d(i,k,j,diag_pt%qidt_dep ) = max(dcond_ls_ice(i,k),0.)*inv_dtcloud
!       if (max(diag_id%qidt_subl,diag_id%qi_subl_col) > 0) &
!               qidt_subl(i,k,j) = (max(0.,-1.*dcond_ls_ice(i,k))/ &
!                       max(qi_mean(i,k),qmin))*tmp2s*inv_dtcloud
        if (max(diag_id%qidt_subl,diag_id%qi_subl_col) > 0) &
                diag_4d(i,k,j,diag_pt%qidt_subl) = (max(0.,-1.*dcond_ls_ice(i,k))/ &
                        max(qi_mean(i,k),qmin))*tmp2s*inv_dtcloud
!       if (max(diag_id%qidt_melt,diag_id%qi_melt_col) > 0) &
!               qidt_melt(i,k,j) = D2_dt(i,k) *tmp2s*inv_dtcloud
        if (max(diag_id%qidt_melt,diag_id%qi_melt_col) > 0) &
                diag_4d(i,k,j,diag_pt%qidt_melt) = D2_dt(i,k) *tmp2s*inv_dtcloud
!       if (max(diag_id%qidt_eros,diag_id%qi_eros_col) > 0) &
!               qidt_eros(i,k,j) = D_eros(i,k)*tmp2s*inv_dtcloud       
        if (max(diag_id%qidt_eros,diag_id%qi_eros_col) > 0) &
                diag_4d(i,k,j,diag_pt%qidt_eros) = D_eros(i,k)*tmp2s*inv_dtcloud       

        if (max(diag_id%lsf_strat,diag_id%lcf_strat,diag_id%mfls_strat) > 0) then
            tmp1s = max(dcond_ls_ice(i,k),0.)*inv_dtcloud
!RSH BUGFIX 6/25/10:
!           if ( (qldt_cond(i,k,j) + tmp1s) .gt. 0. ) lsf_strat(:,:,j) = 1.
!           if ( (qldt_cond(i,k,j) + tmp1s) .gt. 0. ) diag_4d(:,:,j, diag_pt%lsf_strat) = 1.
!           if ( (qldt_cond(i,k,j) + tmp1s) .gt. 0. ) lsf_strat(i,k,j) = 1.
!           if ( (qldt_cond(i,k,j) + tmp1s) .gt. 0. ) diag_4d(i,k,j, diag_pt%lsf_strat) = 1.
!           if ( (diag_4d(i,k,j,diag_pt%qldt_cond) + tmp1s) .gt. 0. ) lsf_strat(i,k,j) = 1.
            if ( (diag_4d(i,k,j,diag_pt%qldt_cond) + tmp1s) .gt. 0. ) diag_4d(i,k,j, diag_pt%lsf_strat) = 1.
        endif
       enddo
      enddo

        
!-----                                                            -----! 
!                                                                      !
!                                END OF                                !
!                                                                      !
!                        ICE PHASE MICROPHYSICS                        !
!                                                                      !
!                                 AND                                  !
!                                                                      !
!                  ANALYTIC INTEGRATION OF QI EQUATION                 !
!                                                                      !
!                                 SECTION                              !
!                                                                      !
!                                                                      !
!                                                                      !
!----------------------------------------------------------------------!



!-----------------------------------------------------------------------
!
!
!
!                       RAIN EVAPORATION
!                           
!
!       Rain evaporation is derived by integration of the growth 
!       equation of a droplet over the assumed Marshall-Palmer 
!       distribution of rain drops (equation #22).  This leads to the 
!       following formula:
!
!  (50) dqv/dt_local =  56788.636 * {rain_rate/dens_h2o}^(11/18) *(1-U)/
!
!                      ( SQRT(airdens)* A_plus_B)
!
!       Numerically this equation integrated by use of time-centered
!       values for qs and qv.   This leads to the solution:
!
!  (51) qv_clr(t+1)-qv_clr(t) = K3 *[qs(t)-qv_clr(t)]/
!                               {1.+0.5*K3*(1+gamma)}
!       where 
!
!       K3= 56788.636 * dtcloud * {rain_rate_local/dens_h2o}^(11/18) /
!           ( SQRT(airdens)* A_plus_B * qs)
!
!       and gamma is given by (3). Note that in (51), it is made 
!       explicit that it is the vapor concentration in the unsaturated 
!       part of the grid box that is used in the rain evaporation 
!       formula.
!
!       Now there are several limiters to this formula. First,
!       you cannot evaporate more than is available in a time step.
!       The amount available for evaporation locally is 
!       (rain_clr/a_rain_clr)*(grav*dtcloud/deltp).   Second, to
!       avoid supersaturating the box or exceeding the critical
!       relative humidity above which rain does not evaporate, 
!       the amount of evaporation is limited.
!
!       Finally rain evaporation occurs only if the relative humidity
!       in the unsaturated portion of the grid box, U_clr, is less
!       then a threshold, U_evap.   U_evap, will not necessarily be
!       one.   For example, stratiform precipitation in convective
!       regions rarely saturates subcloud air because of the presence
!       of downdrafts.  If the convection scheme does not have down-
!       drafts then it doesn't make sense to allow the sub-cloud layer
!       to saturate. U_clr may be solved from (8) as:
!
!  (52) U_clr = ( U - qa ) / (1. - qa)
!
!       Some variables are temporarily stored in tmp1.
!
!       Note that for pdf clouds the relative humidity in the clear part
!       of the grid box can be calculated exactly from the beta distr-
!       ibution. 

      do k=1,jdim
       do i=1,idim
        !compute U_clr
        if (.not. do_pdf_clouds) then 
             U_clr(i,k) =  (U(i,k)-qa_mean(i,k))/max((1.-qa_mean(i,k)),qmin)
        else
             U_clr(i,k) = qvg(i,k)/qs(i,k,j)
        end if
        
        !keep U_clr > 0. and U_clr < 1.
        U_clr(i,k) = min(max(U_clr(i,k),0.),1.)
        
        !compute K3
        tmp1s = 56788.636 * dtcloud * ((rain_clr(i,k)/max(a_rain_clr(i,k),qmin)/  &
             dens_h2o)**(11./18.))/SQRT(airdens(i,k,j))/A_plus_B(i,k,j)&
             /qs(i,k,j)

        !compute local change in vapor mixing ratio due to 
        !rain evaporation
        tmp1s = tmp1s*qs(i,k,j)*(1.-U_clr(i,k))/(1.+0.5*tmp1s*(1.+gamma(i,k,j)))

        !limit change in qv to the amount that would raise the relative
        !humidity to U_evap in the clear portion of the grid box
        tmp1s = min(tmp1s,((1.-qa_mean(i,k))/max(a_rain_clr(i,k),qmin))*qs(i,k,j)* &
               max(0.,U_evap-U_clr(i,k))/(1.+(U_evap*(1.-qa_mean(i,k))+qa_mean(i,k))* &
               gamma(i,k,j)) )
        
        !do limiter by amount available
        tmp1s= tmp1s*a_rain_clr(i,k)*deltpg(i,k)*inv_dtcloud
        tmp2s= max(min(rain_clr(i,k),tmp1s),0.)
    
        SQ(i,k,j) = SQ(i,k,j) +     tmp2s*dtcloud/deltpg(i,k)
        ST(i,k,j) = ST(i,k,j) - hlv*tmp2s*dtcloud/deltpg(i,k)/cp_air
        
        !if all of the rain evaporates set things to zero.    
        if (tmp1s.gt.rain_clr(i,k).and.a_rain_clr(i,k).gt.qmin) then
             rain_clr(i,k) = 0.
             a_rain_clr(i,k) = 0.
        else
             rain_clr(i,k) = rain_clr(i,k) - tmp2s   
        endif
        
!       if (max(diag_id%rain_evap,diag_id%rain_evap_col) > 0) rain_evap(i,k,j) = tmp2s/deltpg(i,k)
        if (max(diag_id%rain_evap,diag_id%rain_evap_col) > 0) diag_4d(i,k,j,diag_pt%rain_evap) = tmp2s/deltpg(i,k)
!rab       enddo 
!rab      enddo 

!-----------------------------------------------------------------------
!
!
!
!                              SNOW SUBLIMATION
!                           
!
!       Sublimation of cloud ice
!
!       [The following follows Rotstayn (1997)]
!       Given the assumptions of the Marshall-Palmer distribution of
!       ice crystals (18), the crystal growth equation as a function
!       of the humidity of the air and the diffusivity of water vapor
!       and thermal conductivity of air is integrated over all crystal
!       sizes.   This yields:
!
!  (53) dqi/dt_local = - a_snow_clr* K3 * (qs - qv_clr)
!
!       where the leading factor of a_snow_clr is the portion of the
!       grid box undergoing sublimation. K3 is given by
!
!  (54) K3 = (4/(pi*rho_air*qs*rho_ice*A_plus_B))*
!            ((snow_clr/a_snow_clr/3.29)**1.16 ) *
!           [ 0.65*lamda_f^2 + 
!             198.92227 * (airdens)^0.5 * 
!             ((snow_clr/a_snow_clr)**(1/14.5)) * lamda_f^(3/2) ]
!
!       Note that equation (53) is identical to equation (30) of 
!       Rotstayn.
!
!       Numerically this is integrated as in rain evaporation.


!rab      do k=1,jdim
!rab       do i=1,idim
        !compute K3
        tmp1s = dtcloud * (4./3.14159/rho_ice/airdens(i,k,j)/           &
               A_plus_B(i,k,j)/qs(i,k,j))*((snow_clr(i,k)/max(a_snow_clr(i,k),   &
               qmin)/3.29)**(1./1.16))*(0.65*lamda_f(i,k)*lamda_f(i,k) +         &
               198.92227*lamda_f(i,k)*SQRT(airdens(i,k,j)*lamda_f(i,k))*         &
               ( (snow_clr(i,k)/max(a_snow_clr(i,k),qmin))**(1./14.5) )  )

        !compute local change in vapor mixing ratio due to 
        !snow sublimation
        tmp1s = tmp1s*qs(i,k,j)*(1.-U_clr(i,k))/(1.+0.5*tmp1s*(1.+gamma(i,k,j)))

        !limit change in qv to the amount that would raise the relative
        !humidity to U_evap in the clear portion of the grid box
        tmp1s = min(tmp1s,((1.-qa_mean(i,k))/max(a_snow_clr(i,k),qmin))*qs(i,k,j)* &
               max(0.,U_evap-U_clr(i,k))/(1.+(U_evap*(1.-qa_mean(i,k))+qa_mean(i,k))* &
               gamma(i,k,j)) )
        
        !do limiter by amount available
        tmp1s= tmp1s*a_snow_clr(i,k)*deltpg(i,k)*inv_dtcloud
        tmp2s= max(min(snow_clr(i,k),tmp1s),0.)
    
        SQ(i,k,j) = SQ(i,k,j) +     tmp2s*dtcloud/deltpg(i,k)
        ST(i,k,j) = ST(i,k,j) - hls*tmp2s*dtcloud/deltpg(i,k)/cp_air
        
        !if all of the snow sublimates set things to zero.    
        if (tmp1s.gt.snow_clr(i,k).and.a_snow_clr(i,k).gt.qmin) then
             snow_clr(i,k) = 0.
             a_snow_clr(i,k) = 0.
        else
             snow_clr(i,k) = snow_clr(i,k) - tmp2s     
        endif
         
!       if (max(diag_id%snow_subl,diag_id%snow_subl_col) > 0) snow_subl(i,k,j) = tmp2s/deltpg(i,k)
        if (max(diag_id%qdt_snow_sublim,diag_id%q_snow_sublim_col) > 0) diag_4d(i,k,j,diag_pt%qdt_snow_sublim) = tmp2s/deltpg(i,k)
       enddo 
      enddo 

!-----------------------------------------------------------------------
!
!       Adjustment to try to prevent negative water vapor. Adjustment
!       will not remove more condensate than available. Cloud amount
!       is not adjusted. This is left for the remainder of the
!       desctruction code. (cjg)

!       if (max(diag_id%qadt_destr,diag_id%qa_destr_col) > 0) qadt_destr(:,:,j) = qadt_destr(:,:,j) + SA(:,:,j)*inv_dtcloud
        if (max(diag_id%qadt_destr,diag_id%qa_destr_col) > 0) diag_4d(:,:,j,diag_pt%qadt_destr) = diag_4d(:,:,j,diag_pt%qadt_destr) + SA(:,:,j)*inv_dtcloud
!       if (max(diag_id%qldt_destr,diag_id%ql_destr_col) > 0) qldt_destr(:,:,j) = qldt_destr(:,:,j) + SL(:,:,j)*inv_dtcloud
        if (max(diag_id%qldt_destr,diag_id%ql_destr_col) > 0) diag_4d(:,:,j,diag_pt%qldt_destr) = diag_4d(:,:,j,diag_pt%qldt_destr) + SL(:,:,j)*inv_dtcloud
!       if (max(diag_id%qidt_destr,diag_id%qi_destr_col) > 0) qidt_destr(:,:,j) = qidt_destr(:,:,j) + SI(:,:,j)*inv_dtcloud
        if (max(diag_id%qidt_destr,diag_id%qi_destr_col) > 0) diag_4d(:,:,j,diag_pt%qidt_destr) = diag_4d(:,:,j,diag_pt%qidt_destr) + SI(:,:,j)*inv_dtcloud
!       if (max(diag_id%qndt_destr,diag_id%qn_destr_col) > 0) qndt_destr(:,:,j) = qndt_destr(:,:,j) + SN(:,:,j)*inv_dtcloud
        if (max(diag_id%qndt_destr,diag_id%qn_destr_col) > 0) diag_4d(:,:,j,diag_pt%qndt_destr) = diag_4d(:,:,j,diag_pt%qndt_destr) + SN(:,:,j)*inv_dtcloud

        do k=1,jdim
         do i=1,idim
          tmp1s = qv(i,k,j) + SQ(i,k,j)
          tmp2s = 0.0
          tmp3s = 0.0
          if ( tmp1s.lt.0.0 ) then
           if (T(i,k,j).le.tfreeze-40.) then
            tmp2s = min( -tmp1s, ql_upd(i,k) )        ! liquid to evaporate
            tmp3s = min( -tmp1s-tmp2s, qi_upd(i,k) )   ! ice to sublimate
           else
            tmp3s = min( -tmp1s, qi_upd(i,k) )        ! ice to sublimate
            tmp2s = min( -tmp1s-tmp3s, ql_upd(i,k) )   ! liquid to evaporate
           end if
           ql_upd(i,k) = ql_upd(i,k) - tmp2s
           qi_upd(i,k) = qi_upd(i,k) - tmp3s
           SL(i,k,j) = SL(i,k,j) - tmp2s
           SI(i,k,j) = SI(i,k,j) - tmp3s
           SQ(i,k,j) = SQ(i,k,j) + tmp2s + tmp3s
           ST(i,k,j) = ST(i,k,j) - hlv*tmp2s/cp_air - hls*tmp3s/cp_air
          end if
         enddo
        enddo

!-----------------------------------------------------------------------
!       Cloud Destruction occurs where both ql and qi are .le. qmin, 
!       or if qa is .le. qmin. In this case, ql, qi, and qa are set to 
!       zero conserving moisture and energy.

        if (.not.do_liq_num) then
          do k=1,jdim
           do i=1,idim
            if ((ql_upd(i,k) .le. qmin .and. qi_upd(i,k) .le. qmin)               &
               .or. (qa_upd(i,k) .le. qmin)) then
             SL(i,k,j) = SL(i,k,j) - ql_upd(i,k)
             SI(i,k,j) = SI(i,k,j) - qi_upd(i,k)
             SQ(i,k,j) = SQ(i,k,j) + ql_upd(i,k) + qi_upd(i,k)
             ST(i,k,j) = ST(i,k,j) - (hlv*ql_upd(i,k) + hls*qi_upd(i,k))/cp_air
             SA(i,k,j) = SA(i,k,j) - qa_upd(i,k)
             ql_upd(i,k) = 0.0
             qi_upd(i,k) = 0.0
             qa_upd(i,k) = 0.0
            endif
           enddo
          enddo
        else
          do k=1,jdim
           do i=1,idim
            if ((ql_upd(i,k) .le. qmin .and. qi_upd(i,k) .le. qmin)               &
               .or. (qa_upd(i,k) .le. qmin)) then
             SL(i,k,j) = SL(i,k,j) - ql_upd(i,k)
             SI(i,k,j) = SI(i,k,j) - qi_upd(i,k)
             SQ(i,k,j) = SQ(i,k,j) + ql_upd(i,k) + qi_upd(i,k)
             ST(i,k,j) = ST(i,k,j) - (hlv*ql_upd(i,k) + hls*qi_upd(i,k))/cp_air
             SA(i,k,j) = SA(i,k,j) - qa_upd(i,k)
             SN(i,k,j) = SN(i,k,j) - qn_upd(i,k)
             ql_upd(i,k) = 0.0
             qi_upd(i,k) = 0.0
             qa_upd(i,k) = 0.0
             qn_upd(i,k) = 0.0
            endif
           enddo
          enddo
        endif  

!       if (max(diag_id%qadt_destr,diag_id%qa_destr_col) > 0) qadt_destr(:,:,j) = qadt_destr(:,:,j) - SA(:,:,j)*inv_dtcloud
        if (max(diag_id%qadt_destr,diag_id%qa_destr_col) > 0) diag_4d(:,:,j,diag_pt%qadt_destr) = diag_4d(:,:,j,diag_pt%qadt_destr) - SA(:,:,j)*inv_dtcloud
!       if (max(diag_id%qldt_destr,diag_id%ql_destr_col) > 0) qldt_destr(:,:,j) = qldt_destr(:,:,j) - SL(:,:,j)*inv_dtcloud
        if (max(diag_id%qldt_destr,diag_id%ql_destr_col) > 0) diag_4d(:,:,j,diag_pt%qldt_destr) = diag_4d(:,:,j,diag_pt%qldt_destr) - SL(:,:,j)*inv_dtcloud
!       if (max(diag_id%qidt_destr,diag_id%qi_destr_col) > 0) qidt_destr(:,:,j) = qidt_destr(:,:,j) - SI(:,:,j)*inv_dtcloud
        if (max(diag_id%qidt_destr,diag_id%qi_destr_col) > 0) diag_4d(:,:,j,diag_pt%qidt_destr) = diag_4d(:,:,j,diag_pt%qidt_destr) - SI(:,:,j)*inv_dtcloud
!       if (max(diag_id%qndt_destr,diag_id%qn_destr_col) > 0) qndt_destr(:,:,j) = qndt_destr(:,:,j) - SN(:,:,j)*inv_dtcloud
        if (max(diag_id%qndt_destr,diag_id%qn_destr_col) > 0) diag_4d(:,:,j,diag_pt%qndt_destr) = diag_4d(:,:,j,diag_pt%qndt_destr) - SN(:,:,j)*inv_dtcloud

!-----------------------------------------------------------------------
!
!       Adjustment.  Due to numerical errors in detrainment or advection
!       sometimes the current state of the grid box may be super-
!       saturated. Under the assumption that the temperature is constant
!       in the grid box and that q <= qs, the excess vapor is condensed. 
!       
!       What happens to the condensed water vapor is determined by the
!       namelist parameter super_choice.
!
!       If super_choice = .false. (default), then the condensed water is
!       is added to the precipitation fluxes.  If super_choice = .true.,
!       then the condensed water is added to the cloud condensate field.
!       Note that in this case the cloud fraction is raised to one.
!
!       The phase partitioning depends on super_choice; if super_choice
!       is false then at T < -20C, snow is produced.  If super_choice
!       is true, then at T < -40C, ice is produced.  The latter choice 
!       is consistent with that done in the large-scale condensation
!       section above.        
!
!       If pdf clouds are operating then this section is bypassed - 
!       as statistical clouds should remove supersaturation according
!       to the beta distribution used.
             
        if (.not.do_pdf_clouds) then
               
!       Old code

!       !estimate current qs
!       tmp2 = qs(:,:,j)+dqsdT(:,:,j)*ST(:,:,j)
!
!       !compute excess over saturation
!       tmp1 = max(0.,qv(:,:,j)+SQ(:,:,j)-tmp2)/(1.+gamma(:,:,j))
 
!       New more accurate version

!RSH 9/18/09: should be within the super_choice if block:
        ! updated temperature in tmp1
        tmp1 = T(:,:,j) + ST(:,:,j)

        ! updated qs in tmp2, updated gamma in tmp3, updated dqsdT in tmp5
        call compute_qs(tmp1, pfull(:,:,j), tmp2, dqsdT=tmp5)
 
        tmp3 = tmp5 *(min(1.,max(0.,0.05*(tmp1-tfreeze+20.)))*hlv +     &
                      min(1.,max(0.,0.05*(tfreeze -tmp1   )))*hls)/cp_air


        !compute excess over saturation
        tmp1 = max(0.,qv(:,:,j)+SQ(:,:,j)-tmp2)/(1.+tmp3)

!rab - save off tmp1 for diagnostic ice/liq adjustment fields in liq_adj array
!       if (max(diag_id%ice_adj,diag_id%ice_adj_col,diag_id%liq_adj,diag_id%liq_adj_col) .gt. 0) &
!              liq_adj(:,:,j) = tmp1*inv_dtcloud
        if (max(diag_id%ice_adj,diag_id%ice_adj_col,diag_id%liq_adj,diag_id%liq_adj_col) .gt. 0) &
               diag_4d(:,:,j,diag_pt%liq_adj) = tmp1*inv_dtcloud

        !change vapor content
        SQ(:,:,j)=SQ(:,:,j)-tmp1

        if (super_choice) then
        
             ! Put supersaturation into cloud

             !cloud fraction source diagnostic
             if (max(diag_id%qadt_super,diag_id%qa_super_col) > 0) then
               where (tmp1 .gt. 0.)
!                qadt_super(:,:,j)  = (1.-qa_upd) * inv_dtcloud
                 diag_4d(:,:,j,diag_pt%qadt_super)  = (1.-qa_upd) * inv_dtcloud
               endwhere
             endif

!yim 11/7/07
             if (do_liq_num) then
               do k=1,jdim
                 do i=1,idim
                   if (T(i,k,j) > tfreeze - 40. .and. &
                        tmp1(i,k) > 0.0) then
                     qn_upd(i,k) = qn_upd(i,k) + drop1(i,k)*1.0e6/  &
                                    airdens(i,k,j)*(1. - qa_upd(i,k))
                     SN(i,k,j) = SN(i,k,j) + drop1(i,k)*1.e6/  &
                                   airdens(i,k,j)*(1.-qa_upd(i,k))
                     if (max(diag_id%qndt_super,diag_id%qn_super_col) > 0)  &
!                       qndt_super(i,k,j) = qndt_super(i,k,j) +   &
                        diag_4d(i,k,j,diag_pt%qndt_super) = diag_4d(i,k,j,diag_pt%qndt_super) +   &
                                                drop1(i,k)*1.e6 / &
                            airdens(i,k,j)*(1.-qa_upd(i,k))*inv_dtcloud
                     endif
                  end do
               end do
!                    if (max(diag_id%qndt_super,diag_id%qn_super_col) > 0)  &
!               diag_4d(:,:,j,diag_pt%qndt_super) = qndt_super(:,:,j)
             endif

             !add in excess to cloud condensate, change cloud area and 
             !increment temperature
             do k=1,jdim
              do i=1,idim
               if(tmp1(i,k).gt.0) then
                if (T(i,k,j) .le. tfreeze-40.)then
                  qi_upd(i,k)   = qi_upd(i,k) + tmp1(i,k)
                  SI(i,k,j) = SI(i,k,j) + tmp1(i,k)
                  ST(i,k,j) = ST(i,k,j) + hls*tmp1(i,k)/cp_air
                else   ! where (T(i,k,j) .gt. tfreeze-40.)
                  ql_upd(i,k)   = ql_upd(i,k) + tmp1(i,k)
                  SL(i,k,j) = SL(i,k,j) + tmp1(i,k)
                  ST(i,k,j) = ST(i,k,j) + hlv*tmp1(i,k)/cp_air        
                endif
                if (limit_conv_cloud_frac) then
                  tmp2s = ahuco(i,k,j)
                else
                  tmp2s = 0.
                endif
                SA(i,k,j) = SA(i,k,j) + (1.-qa_upd(i,k)-tmp2s)
                qa_upd(i,k) = 1. - tmp2s
               endif
              enddo
             enddo

        else

             !Put supersaturation into precip

             !add in excess to precipitation fluxes, change their area 
             !and increment temperature
             do k=1,jdim
              do i=1,idim
               if(tmp1(i,k).gt.0) then
                if (T(i,k,j) .le. tfreeze-20.) then
                  snow_cld(i,k) = snow_cld(i,k) + qa_mean(i,k) *tmp1(i,k)*deltpg(i,k)*inv_dtcloud
                  snow_clr(i,k) = snow_clr(i,k) + (1.-qa_mean(i,k))*tmp1(i,k)*deltpg(i,k)*      &
                                                             inv_dtcloud
                  a_snow_cld(i,k) = qa_mean(i,k)
                  a_snow_clr(i,k) = 1.-qa_mean(i,k)
                  ST(i,k,j)  = ST(i,k,j) + hls*tmp1(i,k)/cp_air
                else   ! where (T(i,k,j) .gt. tfreeze-20.)
                  rain_cld(i,k) = rain_cld(i,k) + qa_mean(i,k) *tmp1(i,k)*deltpg(i,k)*inv_dtcloud
                  rain_clr(i,k) = rain_clr(i,k) + (1.-qa_mean(i,k))*tmp1(i,k)*deltpg(i,k)*      &
                                                             inv_dtcloud
                  a_rain_cld(i,k) = qa_mean(i,k)
                  a_rain_clr(i,k) = 1.-qa_mean(i,k)
                  ST(i,k,j)  = ST(i,k,j) + hlv*tmp1(i,k)/cp_air
                endif
               endif
              enddo
             enddo

        end if !super choice
        
        end if !for do_pdf_clouds
                      
!-----------------------------------------------------------------------
!       Final clean up to remove numerical noise
!

!       if (max(diag_id%qadt_destr,diag_id%qa_destr_col) > 0) qadt_destr(:,:,j) = qadt_destr(:,:,j) + SA(:,:,j)*inv_dtcloud
        if (max(diag_id%qadt_destr,diag_id%qa_destr_col) > 0) diag_4d(:,:,j,diag_pt%qadt_destr) = diag_4d(:,:,j,diag_pt%qadt_destr) + SA(:,:,j)*inv_dtcloud
!       if (max(diag_id%qldt_destr,diag_id%ql_destr_col) > 0) qldt_destr(:,:,j) = qldt_destr(:,:,j) + SL(:,:,j)*inv_dtcloud
        if (max(diag_id%qldt_destr,diag_id%ql_destr_col) > 0) diag_4d(:,:,j,diag_pt%qldt_destr) = diag_4d(:,:,j,diag_pt%qldt_destr) + SL(:,:,j)*inv_dtcloud
!       if (max(diag_id%qidt_destr,diag_id%qi_destr_col) > 0) qidt_destr(:,:,j) = qidt_destr(:,:,j) + SI(:,:,j)*inv_dtcloud
        if (max(diag_id%qidt_destr,diag_id%qi_destr_col) > 0) diag_4d(:,:,j,diag_pt%qidt_destr) = diag_4d(:,:,j,diag_pt%qidt_destr) + SI(:,:,j)*inv_dtcloud
!       if (max(diag_id%qndt_destr,diag_id%qn_destr_col) > 0) qndt_destr(:,:,j) = qndt_destr(:,:,j) + SN(:,:,j)*inv_dtcloud
        if (max(diag_id%qndt_destr,diag_id%qn_destr_col) > 0) diag_4d(:,:,j,diag_pt%qndt_destr) = diag_4d(:,:,j,diag_pt%qndt_destr) + SN(:,:,j)*inv_dtcloud

        do k=1,jdim
         do i=1,idim
          ql_upd(i,k) = ql(i,k,j) + SL(i,k,j)
          if ( abs(ql_upd(i,k)) .le. qmin  &
                .and. qv(i,k,j)+SQ(i,k,j)+ql_upd(i,k) > 0.0 ) then
            SL(i,k,j) = -ql(i,k,j)
            SQ(i,k,j) = SQ(i,k,j) + ql_upd(i,k)
            ST(i,k,j) = ST(i,k,j) - hlv*ql_upd(i,k)/cp_air
            ql_upd(i,k) = 0.0
          endif

          qi_upd(i,k) = qi(i,k,j) + SI(i,k,j)
          if ( abs(qi_upd(i,k)) .le. qmin  &
                .and. qv(i,k,j)+SQ(i,k,j)+qi_upd(i,k) > 0.0 ) then
            SI(i,k,j) = -qi(i,k,j)
            SQ(i,k,j) = SQ(i,k,j) + qi_upd(i,k)
            ST(i,k,j) = ST(i,k,j) - hls*qi_upd(i,k)/cp_air
            qi_upd(i,k) = 0.0
          endif

          qa_upd(i,k) = qa(i,k,j) + SA(i,k,j)
          if ( abs(qa_upd(i,k)) .le. qmin ) then
            SA(i,k,j) = -qa(i,k,j)
            qa_upd(i,k) = 0.0
          endif
         enddo
        enddo

!       if (max(diag_id%qadt_destr,diag_id%qa_destr_col) > 0) qadt_destr(:,:,j) = qadt_destr(:,:,j) - SA(:,:,j)*inv_dtcloud
        if (max(diag_id%qadt_destr,diag_id%qa_destr_col) > 0) diag_4d(:,:,j,diag_pt%qadt_destr) = diag_4d(:,:,j,diag_pt%qadt_destr) - SA(:,:,j)*inv_dtcloud
!       if (max(diag_id%qldt_destr,diag_id%ql_destr_col) > 0) qldt_destr(:,:,j) = qldt_destr(:,:,j) - SL(:,:,j)*inv_dtcloud
        if (max(diag_id%qldt_destr,diag_id%ql_destr_col) > 0) diag_4d(:,:,j,diag_pt%qldt_destr) = diag_4d(:,:,j,diag_pt%qldt_destr) - SL(:,:,j)*inv_dtcloud
!       if (max(diag_id%qidt_destr,diag_id%qi_destr_col) > 0) qidt_destr(:,:,j) = qidt_destr(:,:,j) - SI(:,:,j)*inv_dtcloud
        if (max(diag_id%qidt_destr,diag_id%qi_destr_col) > 0) diag_4d(:,:,j,diag_pt%qidt_destr) = diag_4d(:,:,j,diag_pt%qidt_destr) - SI(:,:,j)*inv_dtcloud
!       if (max(diag_id%qndt_destr,diag_id%qn_destr_col) > 0) qndt_destr(:,:,j) = qndt_destr(:,:,j) - SN(:,:,j)*inv_dtcloud
        if (max(diag_id%qndt_destr,diag_id%qn_destr_col) > 0) diag_4d(:,:,j,diag_pt%qndt_destr) = diag_4d(:,:,j,diag_pt%qndt_destr) - SN(:,:,j)*inv_dtcloud

!-----------------------------------------------------------------------
!
!       Save qa_mean of current level into qa_mean_lst.   This is used
!       in transferring rain and snow fluxes between levels.

        qa_mean_lst = qa_mean
        
!-----------------------------------------------------------------------
!
!       add the ice falling out from cloud to qidt_fall
        
!       if (max(diag_id%qidt_fall,diag_id%qi_fall_col) > 0) qidt_fall(:,:,j) = qidt_fall(:,:,j) +    & 
!                                        (snow_cld/deltpg)
        if (max(diag_id%qidt_fall,diag_id%qi_fall_col) > 0) diag_4d(:,:,j,diag_pt%qidt_fall) = diag_4d(:,:,j,diag_pt%qidt_fall) +    & 
                                         (snow_cld/deltpg)
        
!-----------------------------------------------------------------------
!
!       save profiles of rain and snow 
!
        rain3d(:,:,j+1) = rain_clr(:,:) + rain_cld(:,:)
        snow3d(:,:,j+1) = snow_clr(:,:) + snow_cld(:,:)
        snowclr3d(:,:,j+1) = snow_clr(:,:)

!-----------------------------------------------------------------------
!
!       Save rain and snow diagnostics

!       if (diag_id%rain_clr   > 0) rain_clr_diag(:,:,j+1)     = rain_clr
!       if (diag_id%rain_cld   > 0) rain_cld_diag(:,:,j+1)     = rain_cld
!       if (diag_id%a_rain_clr > 0) a_rain_clr_diag(:,:,j+1)   = a_rain_clr
!       if (diag_id%a_rain_cld > 0) a_rain_cld_diag(:,:,j+1)   = a_rain_cld
!       if (diag_id%snow_clr   > 0) snow_clr_diag(:,:,j+1)     = snow_clr
!       if (diag_id%snow_cld   > 0) snow_cld_diag(:,:,j+1)     = snow_cld
!       if (diag_id%a_snow_clr > 0) a_snow_clr_diag(:,:,j+1)   = a_snow_clr
!       if (diag_id%a_snow_cld > 0) a_snow_cld_diag(:,:,j+1)   = a_snow_cld
!       if (diag_id%a_precip_clr > 0) a_precip_clr_diag(:,:,j+1) = max(a_rain_clr,a_snow_clr)
!       if (diag_id%a_precip_cld > 0) a_precip_cld_diag(:,:,j+1) = max(a_rain_cld,a_snow_cld)
        if (diag_id%rain_clr   > 0) diag_4d_kp1(:,:,j+1,diag_pt%rain_clr)     = rain_clr
        if (diag_id%rain_cld   > 0) diag_4d_kp1(:,:,j+1,diag_pt%rain_cld)     = rain_cld
        if (diag_id%a_rain_clr > 0) diag_4d_kp1(:,:,j+1,diag_pt%a_rain_clr)   = a_rain_clr
        if (diag_id%a_rain_cld > 0) diag_4d_kp1(:,:,j+1,diag_pt%a_rain_cld)   = a_rain_cld
        if (diag_id%snow_clr   > 0) diag_4d_kp1(:,:,j+1,diag_pt%snow_clr)     = snow_clr
        if (diag_id%snow_cld   > 0) diag_4d_kp1(:,:,j+1,diag_pt%snow_cld)     = snow_cld
        if (diag_id%a_snow_clr > 0) diag_4d_kp1(:,:,j+1,diag_pt%a_snow_clr)   = a_snow_clr
        if (diag_id%a_snow_cld > 0) diag_4d_kp1(:,:,j+1,diag_pt%a_snow_cld)   = a_snow_cld
        if (diag_id%a_precip_clr > 0) diag_4d_kp1(:,:,j+1,diag_pt%a_precip_clr) = max(a_rain_clr,a_snow_clr)
        if (diag_id%a_precip_cld > 0) diag_4d_kp1(:,:,j+1,diag_pt%a_precip_cld) = max(a_rain_cld,a_snow_cld)

!-----------------------------------------------------------------------
!
!
!       Put rain and ice fluxes into surfrain and surfsnow if the
!       grid point is at the bottom of a column.   If MASK is not
!       present then this code is executed only if j .eq. kdim.
!       IF MASK is present some grid points may be beneath ground. 
!       If a given grid point is at the bottom of the column then
!       the surface values of rain and snow must be created.
!       Also if the MASK is present then the code forces all tenden-
!       cies below ground to be zero. Note that MASK = 1. equals above
!       ground point, MASK = 0. equals below ground point.

        if (present(MASK)) then

             !zero out all tendencies below ground
             ST(:,:,j)=MASK(:,:,j)*ST(:,:,j)
             SQ(:,:,j)=MASK(:,:,j)*SQ(:,:,j)
             SL(:,:,j)=MASK(:,:,j)*SL(:,:,j)
             SI(:,:,j)=MASK(:,:,j)*SI(:,:,j)
             SA(:,:,j)=MASK(:,:,j)*SA(:,:,j)
             if (do_liq_num) then
               SN(:,:,j)=MASK(:,:,j)*SN(:,:,j)
             endif
 
             if (j .lt. kdim) then
                  
                  !bottom of true points in columns which contain some
                  !dummy points
                  where(MASK(:,:,j) .eq. 1. .and. MASK(:,:,j+1) .eq. 0.)
                       surfrain = dtcloud*(rain_clr+rain_cld)
                       surfsnow = dtcloud*(snow_clr+snow_cld)
                       rain_clr = 0.
                       rain_cld = 0.
                       snow_clr = 0.
                       snow_cld = 0.
                       a_rain_clr = 0.
                       a_rain_cld = 0.
                       a_snow_clr = 0.
                       a_snow_cld = 0.
                  end where

             else

                  !bottom of column for those columns which contain no
                  !dummy points
                  where(MASK(:,:,j) .eq. 1.)
                       surfrain = dtcloud*(rain_clr+rain_cld)
                       surfsnow = dtcloud*(snow_clr+snow_cld)
                       rain_clr = 0.
                       rain_cld = 0.
                       snow_clr = 0.
                       snow_cld = 0.
                       a_rain_clr = 0.
                       a_rain_cld = 0.
                       a_snow_clr = 0.
                       a_snow_cld = 0.                  
                  end where

             end if

        else

             !do code if we are at bottom of column
             if (j .eq. kdim) then
                  surfrain = dtcloud*(rain_clr+rain_cld)
                  surfsnow = dtcloud*(snow_clr+snow_cld)
             end if

        end if 
                  

!-----------------------------------------------------------------------
!
!       END LOOP OVER VERTICAL LEVELS
!

        enddo
     call mpp_clock_end(sc_loop)
     call mpp_clock_begin(sc_post_loop)




!-----------------------------------------------------------------------
!
!       INSTANTANEOUS OUTPUT DIAGNOSTICS
!
     
        if (num_strat_pts > 0) then
         do nn=1,num_strat_pts
          if (strat_pts(1,nn) >= is .and. strat_pts(1,nn) <= ie .and.  &
             strat_pts(2,nn) >= js .and. strat_pts(2,nn) <= je) then
                ipt=strat_pts(1,nn); jpt=strat_pts(2,nn)
                i=ipt-is+1; j=jpt-js+1
                unit = open_ieee32_file ('strat.data', action='append')
                write (unit) ipt,jpt,     ql(i,j,:)+SL(i,j,:)
                write (unit) ipt,jpt,     qi(i,j,:)+SI(i,j,:)
                write (unit) ipt,jpt,     qa(i,j,:)+SA(i,j,:)
                write (unit) ipt,jpt,      T(i,j,:)+ST(i,j,:) 
                write (unit) ipt,jpt,     qv(i,j,:)+SQ(i,j,:)
                write (unit) ipt,jpt,     pfull(i,j,:)
                call close_file(unit)
          endif
         enddo
        endif


!-----------------------------------------------------------------------
!
!       DIAGNOSTICS
!
!rab - perform the assignments for ice/liq adjustments diagnostics
        if (max(diag_id%ice_adj,diag_id%ice_adj_col,diag_id%liq_adj,diag_id%liq_adj_col) .gt. 0) then
          freeze_pt=40.
          if (.not. super_choice) freeze_pt=20.
          where (T .le. tfreeze-freeze_pt)
!          ice_adj = liq_adj
           diag_4d(:,:,:,diag_pt%ice_adj) = diag_4d(:,:,:,diag_pt%liq_adj)
!          liq_adj = 0.
           diag_4d(:,:,:,diag_pt%liq_adj) = 0.
          endwhere
        endif

        if ( diag_id%droplets_wtd > 0 ) then
!a   diag_4d(:,:,:, diag_pt%droplets_wtd) = N3D*ql
     diag_4d(:,:,:, diag_pt%droplets_wtd) =   &
                           diag_4d(:,:,:,diag_pt%droplets)*ql(:,:,:)
        endif

        if ( diag_id%subgrid_w_variance > 0 ) then
!         debug2=debug2**0.5
!         diag_4d(:,:,:,diag_pt%debug2_3d) = debug2
          diag_4d(:,:,:,diag_pt%subgrid_w_variance) = diag_4d(:,:,:,diag_pt%subgrid_w_variance)**0.5
        endif

      
!RSH BUGFIX 6/25/10
!  j is undefined here
        if ( max(diag_id%lcf_strat,diag_id%mfls_strat) > 0 ) then
!         where (omega(:,:,j)+grav*Mc(:,:,j) .lt. 0 .and. lsf_strat(:,:,j) .eq.1)
!            lcf_strat(:,:,j) = 1.
!            diag_4d(:,:,j,diag_pt%lcf_strat) = lcf_strat(:,:,j)
!            mfls_strat(:,:,j) = omega(:,:,j)+grav*Mc(:,:,j)
!            diag_4d(:,:,j,diag_pt%mfls_strat) = mfls_strat(:,:,j)
!         where (omega(:,:,:)+grav*Mc(:,:,:) .lt. 0 .and. lsf_strat(:,:,:) .eq.1)
          where (omega(:,:,:)+grav*Mc(:,:,:) .lt. 0 .and. diag_4d(:,:,:,diag_pt%lsf_strat) .eq.1)
!            lcf_strat(:,:,:) = 1.
!            diag_4d(:,:,:,diag_pt%lcf_strat) = lcf_strat(:,:,:)
             diag_4d(:,:,:,diag_pt%lcf_strat) = 1.0               
!            mfls_strat(:,:,:) = omega(:,:,:)+grav*Mc(:,:,:)
!            diag_4d(:,:,:,diag_pt%mfls_strat) = mfls_strat(:,:,:)
             diag_4d(:,:,:,diag_pt%mfls_strat) = omega(:,:,:)+grav*Mc(:,:,:)
          end where
        end if

       do k = 1, kdim
         do j=1,jdim
           do i=1,idim
             deltpg_3d(i,j,k) = (phalf(i,j,k+1)-phalf(i,j,k))/grav
             if (present(MASK)) then
               deltpg_3d(i,j,k)=deltpg_3d(i,j,k)*MASK(i,j,k)
             endif
           end do
         end do
       end do

        !-------write out column integrated diagnostics------!
!GENERIC FORM:
          do n8=1, n_diag_4d
             do j = kdim, 1, -1
!                 diag_3d(:,:,diag_pt%qldt_evap) = diag_3d(:,:,diag_pt%qldt_evap) &
!                                         + diag_4d(:,:,j,diag_pt%qldt_evap)*deltpg_3d(:,:,j) 
                  diag_3d(:,:,n8) = diag_3d(:,:,n8) &
                                  + diag_4d(:,:,j,n8)*deltpg_3d(:,:,j) 
             enddo
             enddo

!SPECIAL CASES:
!yim: in-cloud droplet column burden

        if (diag_id%droplets_col > 0) then
          if (present (qn)) then
            if (do_liq_num ) then
              N3D_col(:,:) = 0.
              do k = 1, kdim
                do j=1,jdim
                  do i=1,idim
!                   deltpg(i,j) = (phalf(i,j,k+1)-phalf(i,j,k))/grav
!                   if (present(MASK)) then
!                     deltpg(i,j)=deltpg(i,j)*MASK(i,j,k)
!                   endif
                    if (ql(i,j,k) > qmin .and. &
                        qa(i,j,k) > qmin .and. &
                        qn(i,j,k) > qmin ) then      
                      if (qa(i,j,k) > 0.05) then
                       N3D_col(i,j) = N3D_col(i,j) + qn(i,j,k)*  &
!                                     airdens(i,j,k)*deltpg(i,j)*  &
!RSH 12/22/11 fix as per email from yim 11/3/11:
!                                     airdens(i,j,k)*deltpg_3d(i,j,k)*  &
!                                     1.e-6/min(qa(i,j,k),1.)
!RSH 12/22/11
!NOTE still differs from new strat_cloud code in that is appplied to 
! input fields rather than output fields
                                                     deltpg_3d(i,j,k)*  &
                                      1.e-4/min(qa(i,j,k),1.)
                       endif
                    endif
                  end do
                end do
              end do
              diag_3d(:,:,diag_pt%droplets_col) = N3D_col
            endif
          endif
        endif




     call mpp_clock_end(sc_post_loop)
        
!-----------------------------------------------------------------------
!
!
!       end of subroutine



end subroutine strat_cloud_legacy


!#####################################################################

subroutine strat_cloud_legacy_end (do_pdf_clouds)

logical,     intent(in) :: do_pdf_clouds

      if (do_pdf_clouds) call beta_dist_end

      module_is_initialized = .false.

end subroutine strat_cloud_legacy_end
 

!#####################################################################

subroutine aerosol_effects (is, js, Time, phalf, airdens, T, diag_4d, &
                            diag_id, diag_pt, &
                            concen_dust_sub, totalmass1, Aerosol, mask)

type(diag_id_type), intent(in) :: diag_id
type(diag_pt_type), intent(in) :: diag_pt
integer, intent (in)                   :: is,js
type(time_type), intent (in)           :: Time
real, dimension(:,:,:), intent(in )   :: phalf, airdens, T 
real, dimension(:,:,:,0:), intent(inout )   :: diag_4d           
real, dimension(:,:,:), intent(out)        :: concen_dust_sub
real, dimension(:,:,:,:), intent(out)            :: totalmass1
type(aerosol_type), intent (in), optional      :: Aerosol  
real, intent (in), optional, dimension(:,:,:) :: mask

      real, dimension(size(T,1),size(T,2),size(T,3)) :: pthickness
      real, dimension(size(T,1),size(T,2),size(T,3)) :: concen, &
                                    concen_all_sub, &
                                    concen_ss_sub, concen_ss_sup,&
                                    concen_om, concen_na, concen_an
      integer  :: i,j,k,  na , s
      integer  :: idim, jdim, kdim
      logical :: used

      idim = size(T,1)
      jdim = size(T,2)
      kdim = size(T,3)

      concen_dust_sub(:,:,:) = 0.
      totalmass1(:,:,:,:) = 0.

      if (diag_id%sulfate > 0) then
        concen_an(:,:,:) = 0.
        concen_na(:,:,:) = 0.
        concen(:,:,:) = 0.
      endif

      if (use_online_aerosol) then
        concen_ss_sub(:,:,:) = 0.
        concen_ss_sup(:,:,:) = 0.
        concen_all_sub(:,:,:) = 0.
      endif

      do k = 1,kdim
        do j = 1,jdim
          do i = 1,idim
            if (phalf(i,j,k) < 1.0) then
              pthickness(i,j,k) = (phalf(i,j,k+1) - phalf(i,j,k))/&
                                               grav/airdens(i,j,k)
            else
              pthickness(i,j,k) = log(phalf(i,j,k+1)/ &
                            phalf(i,j,k))*8.314*T(i,j,k)/(9.8*0.02888)
            end if
          end do
        end do
      end do

     if (present (Aerosol)) then
       if (do_liq_num) then
         if (use_online_aerosol) then
           do na = 1,size(Aerosol%aerosol,4)               
             if (trim(Aerosol%aerosol_names(na)) == 'so4' .or. &
                 trim(Aerosol%aerosol_names(na)) == 'so4_anthro' .or.&
                 trim(Aerosol%aerosol_names(na)) == 'so4_natural')  &
                                                                 then
               do k = 1,kdim
                 do j = 1,jdim
                   do i = 1,idim
                     totalmass1(i,j,k,1) = totalmass1(i,j,k,1) + &
                                           Aerosol%aerosol(i,j,k,na)
                   end do
                 end do
               end do
             else if(trim(Aerosol%aerosol_names(na)) == 'omphilic' .or.&
                     trim(Aerosol%aerosol_names(na)) == 'omphobic') &
                                                                 then
               do k = 1,kdim
                 do j = 1,jdim
                   do i = 1,idim
                     totalmass1(i,j,k,4) = totalmass1(i,j,k,4) +  &
                                           Aerosol%aerosol(i,j,k,na)
                   end do
                 end do
               end do
             else if(trim(Aerosol%aerosol_names(na)) == 'seasalt1' .or.&
                     trim(Aerosol%aerosol_names(na)) == 'seasalt2') &
                                                                   then
               do k = 1,kdim
                 do j = 1,jdim
                   do i = 1,idim
                     concen_ss_sub(i,j,k) = concen_ss_sub(i,j,k) +  &
                                            Aerosol%aerosol(i,j,k,na)
                   end do
                 end do
               end do
             else if(trim(Aerosol%aerosol_names(na)) == 'seasalt3' .or.&
                     trim(Aerosol%aerosol_names(na)) == 'seasalt4' .or.&
                     trim(Aerosol%aerosol_names(na)) == 'seasalt5')  &
                                                                  then
               do k = 1,kdim
                 do j = 1,jdim
                   do i = 1,idim
                     concen_ss_sup(i,j,k) = concen_ss_sup(i,j,k) +  &
                                            Aerosol%aerosol(i,j,k,na)
                   end do
                 end do
               end do
             else if(trim(Aerosol%aerosol_names(na)) == 'bcphilic' .or.&
                     trim(Aerosol%aerosol_names(na)) == 'bcphobic' .or.&
                     trim(Aerosol%aerosol_names(na)) == 'dust1' .or.&
                     trim(Aerosol%aerosol_names(na)) == 'dust2' .or.&
                     trim(Aerosol%aerosol_names(na)) == 'dust3')  &
                                                                  then
               do k = 1,kdim
                 do j = 1,jdim
                   do i = 1,idim
                     concen_all_sub(i,j,k) = concen_all_sub(i,j,k) +  &
                                             Aerosol%aerosol(i,j,k,na)
                   end do
                 end do
               end do
             endif
             if (do_dust_berg) then
               if (trim(Aerosol%aerosol_names(na)) == 'dust1' .or. &
                   trim(Aerosol%aerosol_names(na)) == 'dust2' .or. &
                   trim( Aerosol%aerosol_names(na)) == 'dust3') then
                 do k = 1,kdim
                   do j = 1,jdim
                     do i = 1,idim
                       concen_dust_sub(i,j,k) =    &
                                           concen_dust_sub(i,j,k) +   &
                                              Aerosol%aerosol(i,j,k,na)
                     end do
                   end do
                 end do
               endif
             endif
           end do
           do k = 1,kdim
             do j = 1,jdim
               do i = 1,idim
                 totalmass1(i,j,k,3) = concen_ss_sub(i,j,k)
                 totalmass1(i,j,k,2) = concen_all_sub(i,j,k) + &
                                       totalmass1(i,j,k,4) + &
                                       concen_ss_sub(i,j,k)
               end do
             end do
           end do
           if (use_sub_seasalt) then
           else
             do k = 1,kdim
               do j = 1,jdim
                 do i = 1,idim
                   totalmass1(i,j,k,3) = concen_ss_sub(i,j,k) +  &
                                                  concen_ss_sup(i,j,k)
                 end do
               end do
             end do
           endif

           if (diag_id%sulfate > 0) then
             do k = 1,kdim
               do j = 1,jdim
                 do i = 1,idim
                   concen(i,j,k) = 0.7273*totalmass1(i,j,k,1)/  &
                                       pthickness(i,j,k)*1.0e9
                 end do
               end do
             end do
           endif
         
           do k = 1,kdim
             do j = 1,jdim
               do i = 1,idim
                 concen_ss_sub(i,j,k) = concen_ss_sub(i,j,k)/  &
                                              pthickness(i,j,k)*1.0e9
                 concen_ss_sup(i,j,k) = concen_ss_sup(i,j,k)/  &
                                              pthickness(i,j,k)*1.0e9
               end do
             end do
           end do

         else  ! (use_online_aerosol)
           if (do_dust_berg) then
!     YMice submicron dust (NO. 14 to NO. 18)
             do s = 14,18
               do k = 1,kdim
                 do j = 1,jdim
                   do i = 1,idim
                     concen_dust_sub(i,j,k) = concen_dust_sub(i,j,k)+ &
                                              Aerosol%aerosol(i,j,k,s)
                   end do
                 end do
               end do
             end do
           endif

           if (diag_id%sulfate > 0) then
             do k = 1,kdim
               do j = 1,jdim
                 do i = 1,idim
!     anthro. and natural sulfate concentration (ug so4/m3)
                   concen_an(i,j,k) = 0.7273*Aerosol%aerosol(i,j,k,1)/&
                                                pthickness(i,j,k)*1.0e9
                   concen_na(i,j,k) = 0.7273*Aerosol%aerosol(i,j,k,2)/&
                                                pthickness(i,j,k)*1.0e9
                   concen(i,j,k) = concen_an(i,j,k) + concen_na(i,j,k)
                 end do
               end do
             end do
           endif

           do k = 1,kdim
             do j = 1,jdim
               do i = 1,idim
!offline
! NO. 1 natural Sulfate; NO. 2 anthro. sulfate; NO. 3 Sea Salt; NO. 4 Or        ganics
                 totalmass1(i,j,k,1) = Aerosol%aerosol(i,j,k,2)
                 totalmass1(i,j,k,2) = Aerosol%aerosol(i,j,k,1)
                 totalmass1(i,j,k,3) = sea_salt_scale*  &
                                       Aerosol%aerosol(i,j,k,5)
                 totalmass1(i,j,k,4) = om_to_oc*  &
                                       Aerosol%aerosol(i,j,k,3)
               end do
             end do
           end do
         endif ! (use_online_aerosol)

         do na = 1, 4
           do k = 1,kdim
             do j = 1,jdim
               do i = 1,idim
                 totalmass1(i,j,k,na) = totalmass1(i,j,k,na)/  &
                                        pthickness(i,j,k)*1.0e9*1.0e-12
               end do
             end do
           end do
         end do
         if (do_dust_berg) then
           do k = 1,kdim
             do j = 1,jdim
               do i = 1,idim
! submicron dust concentration (ug/m3) (NO. 2 to NO. 4)
                 concen_dust_sub(i,j,k) = concen_dust_sub(i,j,k)/ &
                                              pthickness(i,j,k)*1.0e9 
               end do
             end do
           end do
         endif


         if (diag_id%sulfate > 0) then
           diag_4d(:,:,:,diag_pt%sulfate) = concen (:,:,:)
         endif
         if (use_online_aerosol) then
           if (diag_id%seasalt_sub > 0) then
             diag_4d(:,:,:,diag_pt%seasalt_sub) = concen_ss_sub
           endif
           if (diag_id%seasalt_sup > 0) then
             diag_4d(:,:,:,diag_pt%seasalt_sup) = concen_ss_sup
           endif
         endif




         if (diag_id%om > 0) then
           do k = 1,kdim
             do j = 1,jdim
               do i = 1,idim
                 concen_om(i,j,k) = totalmass1(i,j,k,2)*1.0e12
                 diag_4d(i,j,k,diag_pt%om) = concen_om(i,j,k)
               end do
             end do
           end do
!          used = send_data (diag_id%om, diag_4d(:,:,:,diag_pt%om), Time, is, js, 1,&
!                            rmask=mask )
         endif
       endif  ! (do_liq_num)
     endif ! (Present(Aerosol))

!----------------------------------------------------------------------


end subroutine aerosol_effects


!#######################################################################
!#######################################################################




!----------------------------------------------------------------------- 
!BOP
! !ROUTINE:  ppm2m_sak --- Piecewise parabolic method for fields
!
! !INTERFACE:
 subroutine ppm2m_sak(a4, delp, km, kmap, i1, i2, iv, kord)

 implicit none

! !INPUT PARAMETERS:
 integer, intent(in):: iv      ! iv =-1: winds
                               ! iv = 0: positive definite scalars
                               ! iv = 1: others
 integer, intent(in):: i1      ! Starting longitude
 integer, intent(in):: i2      ! Finishing longitude
 integer, intent(in):: km      ! vertical dimension
 integer, intent(in):: kmap    ! partial remap to start
 integer, intent(in):: kord    ! Order (or more accurately method no.):
                               ! 
 real, intent(in):: delp(i1:i2,km)     ! layer pressure thickness

! !INPUT/OUTPUT PARAMETERS:
 real, intent(inout):: a4(4,i1:i2,km)  ! Interpolated values

! !DESCRIPTION:
!
!   Perform the piecewise parabolic method 
! 
! !REVISION HISTORY: 
!   ??.??.??    Lin        Creation
!   02.04.04    Sawyer     Newest release from FVGCM
! 
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
! local arrays:
      real   dc(i1:i2,km)
      real   h2(i1:i2,km)
      real delq(i1:i2,km)
      real  df2(i1:i2,km)
      real   d4(i1:i2,km)

! local scalars:
      integer i, k, km1, lmt
      integer it
      real fac
      real a1, a2, c1, c2, c3, d1, d2
      real qmax, qmin, cmax, cmin
      real qm, dq, tmp
      real qmp, pmp
      real lac

      km1 = km - 1
       it = i2 - i1 + 1

      do k=max(2,kmap-2),km
         do i=i1,i2
            delq(i,k-1) =   a4(1,i,k) - a4(1,i,k-1)
              d4(i,k  ) = delp(i,k-1) + delp(i,k)
         enddo
      enddo
 
      do k=max(2,kmap-2),km1
         do i=i1,i2
            c1  = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
            c2  = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
            tmp = delp(i,k)*(c1*delq(i,k) + c2*delq(i,k-1)) /      &
                                    (d4(i,k)+delp(i,k+1))
            qmax = max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1)) - a4(1,i,k)
            qmin = a4(1,i,k) - min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))
             dc(i,k) = sign(min(abs(tmp),qmax,qmin), tmp)
            df2(i,k) = tmp
         enddo
      enddo

!-----------------------------------------------------------
! 4th order interpolation of the provisional cell edge value
!-----------------------------------------------------------

      do k=max(3,kmap), km1
      do i=i1,i2
        c1 = delq(i,k-1)*delp(i,k-1) / d4(i,k)
        a1 = d4(i,k-1) / (d4(i,k) + delp(i,k-1))
        a2 = d4(i,k+1) / (d4(i,k) + delp(i,k))
        a4(2,i,k) = a4(1,i,k-1) + c1 + 2./(d4(i,k-1)+d4(i,k+1)) *    &
                  ( delp(i,k)*(c1*(a1 - a2)+a2*dc(i,k-1)) -          &
                                delp(i,k-1)*a1*dc(i,k  ) )
      enddo
      enddo

      if(km>8 .and. kord>3) call steepz_sak(i1, i2, km, kmap, a4, df2, dc, delq, delp, d4)

! Area preserving cubic with 2nd deriv. = 0 at the boundaries
! Top
      if ( kmap <= 2 ) then
      do i=i1,i2
         d1 = delp(i,1)
         d2 = delp(i,2)
         qm = (d2*a4(1,i,1)+d1*a4(1,i,2)) / (d1+d2)
         dq = 2.*(a4(1,i,2)-a4(1,i,1)) / (d1+d2)
         c1 = 4.*(a4(2,i,3)-qm-d2*dq) / ( d2*(2.*d2*d2+d1*(d2+3.*d1)) )
         c3 = dq - 0.5*c1*(d2*(5.*d1+d2)-3.*d1**2)
         a4(2,i,2) = qm - 0.25*c1*d1*d2*(d2+3.*d1)
         a4(2,i,1) = d1*(2.*c1*d1**2-c3) + a4(2,i,2)
         dc(i,1) =  a4(1,i,1) - a4(2,i,1)
! No over- and undershoot condition
         cmax = max(a4(1,i,1), a4(1,i,2))
         cmin = min(a4(1,i,1), a4(1,i,2))
         a4(2,i,2) = max(cmin,a4(2,i,2))
         a4(2,i,2) = min(cmax,a4(2,i,2))
      enddo
      endif

! Bottom
! Area preserving cubic with 2nd deriv. = 0 at the surface
      do i=i1,i2
         d1 = delp(i,km)
         d2 = delp(i,km1)
         qm = (d2*a4(1,i,km)+d1*a4(1,i,km1)) / (d1+d2)
         dq = 2.*(a4(1,i,km1)-a4(1,i,km)) / (d1+d2)
         c1 = (a4(2,i,km1)-qm-d2*dq) / (d2*(2.*d2*d2+d1*(d2+3.*d1)))
         c3 = dq - 2.0*c1*(d2*(5.*d1+d2)-3.*d1**2)
         a4(2,i,km) = qm - c1*d1*d2*(d2+3.*d1)
         a4(3,i,km) = d1*(8.*c1*d1**2-c3) + a4(2,i,km)
         dc(i,km) = a4(3,i,km) -  a4(1,i,km)
! No over- and under-shoot condition
         cmax = max(a4(1,i,km), a4(1,i,km1))
         cmin = min(a4(1,i,km), a4(1,i,km1))
         a4(2,i,km) = max(cmin,a4(2,i,km))
         a4(2,i,km) = min(cmax,a4(2,i,km))
      enddo

      do k=max(1,kmap),km1
         do i=i1,i2
            a4(3,i,k) = a4(2,i,k+1)
         enddo
      enddo

! Enforce monotonicity of the "slope" within the top layer
      if ( kmap <= 2 ) then
      do i=i1,i2
         if ( a4(2,i,1) * a4(1,i,1) <= 0. ) then 
              a4(2,i,1) = 0.
                dc(i,1) = a4(1,i,1)
         endif
         if ( dc(i,1) * (a4(2,i,2) - a4(1,i,1)) <= 0. ) then
! Setting DC==0 will force piecewise constant distribution after
! calling kmppm_sak
              dc(i,1) = 0.
         endif
      enddo
      endif

! Enforce constraint on the "slope" at the surface

      do i=i1,i2
         if( a4(3,i,km) * a4(1,i,km) <= 0. ) then
!            a4(3,i,km) = 0.
!              dc(i,km) =  -a4(1,i,km)
               dc(i,km) = 0.
         endif
         if( dc(i,km) * (a4(1,i,km) - a4(2,i,km)) <= 0. ) then
             dc(i,km) = 0.
         endif
      enddo
 
!-----------------------------------------------------------
! f(s) = AL + s*[(AR-AL) + A6*(1-s)]         ( 0 <= s  <= 1 )
!-----------------------------------------------------------
! Top 2 and bottom 2 layers always use monotonic mapping
      if ( kmap <= 2 ) then
      do k=1,2
         do i=i1,i2
            a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
         enddo
            call kmppm_sak(dc(i1,k), a4(1,i1,k), it, 0)
      enddo
      endif

      if(kord >= 7) then
!-----------------------
! Huynh's 2nd constraint
!-----------------------
      do k=max(2,kmap-1), km1
         do i=i1,i2
! Method#1
!           h2(i,k) = delq(i,k) - delq(i,k-1)
! Method#2
!           h2(i,k) = 2.*(dc(i,k+1)/delp(i,k+1) - dc(i,k-1)/delp(i,k-1))
!    &               / ( delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)) )
!    &               * delp(i,k)**2
! Method#3
            h2(i,k) = dc(i,k+1) - dc(i,k-1)
         enddo
      enddo

      if( kord == 7 ) then
         fac = 1.5           ! original quasi-monotone
      else
         fac = 0.125         ! full monotone
      endif

      do k=max(3,kmap), km-2
        do i=i1,i2
! Right edges
!        qmp   = a4(1,i,k) + 2.0*delq(i,k-1)
!        lac   = a4(1,i,k) + fac*h2(i,k-1) + 0.5*delq(i,k-1)
!
         pmp   = 2.*dc(i,k)
         qmp   = a4(1,i,k) + pmp
         lac   = a4(1,i,k) + fac*h2(i,k-1) + dc(i,k)
         qmin  = min(a4(1,i,k), qmp, lac)
         qmax  = max(a4(1,i,k), qmp, lac)
         a4(3,i,k) = min(max(a4(3,i,k), qmin), qmax)
! Left  edges
!        qmp   = a4(1,i,k) - 2.0*delq(i,k)
!        lac   = a4(1,i,k) + fac*h2(i,k+1) - 0.5*delq(i,k)
!
         qmp   = a4(1,i,k) - pmp
         lac   = a4(1,i,k) + fac*h2(i,k+1) - dc(i,k)
         qmin  = min(a4(1,i,k), qmp, lac)
         qmax  = max(a4(1,i,k), qmp, lac)
         a4(2,i,k) = min(max(a4(2,i,k), qmin), qmax)
! Recompute A6
         a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
        enddo
! Additional constraint to ensure positivity when kord=7
         if (iv == 0 .and. kord == 7) then
             call kmppm_sak(dc(i1,k), a4(1,i1,k), it, 2)
         endif
      enddo

      else
 
         lmt = kord - 3
         lmt = max(0, lmt)
         if (iv == 0) lmt = min(2, lmt)

      do k=max(3,kmap), km-2
      if( kord /= 4) then
         do i=i1,i2
            a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
         enddo
      endif
         call kmppm_sak(dc(i1,k), a4(1,i1,k), it, lmt)
      enddo
      endif

      do k=km1,km
         do i=i1,i2
            a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
         enddo
         call kmppm_sak(dc(i1,k), a4(1,i1,k), it, 0)
      enddo
!EOC
 end subroutine ppm2m_sak
!-----------------------------------------------------------------------

!----------------------------------------------------------------------- 
!BOP
! !ROUTINE:  kmppm_sak --- Perform piecewise parabolic method in vertical
!
! !INTERFACE:
 subroutine kmppm_sak(dm, a4, itot, lmt)

 implicit none

! !INPUT PARAMETERS:
      real, intent(in):: dm(*)     ! the linear slope
      integer, intent(in) :: itot      ! Total Longitudes
      integer, intent(in) :: lmt       ! 0: Standard PPM constraint
                                       ! 1: Improved full monotonicity constraint (Lin)
                                       ! 2: Positive definite constraint
                                       ! 3: do nothing (return immediately)
! !INPUT/OUTPUT PARAMETERS:
      real, intent(inout) :: a4(4,*)   ! PPM array
                                           ! AA <-- a4(1,i)
                                           ! AL <-- a4(2,i)
                                           ! AR <-- a4(3,i)
                                           ! A6 <-- a4(4,i)

! !DESCRIPTION:
!
! !REVISION HISTORY: 
!    00.04.24   Lin       Last modification
!    01.03.26   Sawyer    Added ProTeX documentation
!    02.04.04   Sawyer    Incorporated newest FVGCM version
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:

      real, parameter:: r12 = 1./12.
      real qmp
      real da1, da2, a6da
      real fmin
      integer i

! Developer: S.-J. Lin, NASA-GSFC
! Last modified: Apr 24, 2000

      if ( lmt == 3 ) return

      if(lmt == 0) then
! Standard PPM constraint
      do i=1,itot
      if(dm(i) == 0.) then
         a4(2,i) = a4(1,i)
         a4(3,i) = a4(1,i)
         a4(4,i) = 0.
      else
         da1  = a4(3,i) - a4(2,i)
         da2  = da1**2
         a6da = a4(4,i)*da1
         if(a6da < -da2) then
            a4(4,i) = 3.*(a4(2,i)-a4(1,i))
            a4(3,i) = a4(2,i) - a4(4,i)
         elseif(a6da > da2) then
            a4(4,i) = 3.*(a4(3,i)-a4(1,i))
            a4(2,i) = a4(3,i) - a4(4,i)
         endif
      endif
      enddo

      elseif (lmt == 1) then

! Improved full monotonicity constraint (Lin 2003)
! Note: no need to provide first guess of A6 <-- a4(4,i)
      do i=1, itot
           qmp = 2.*dm(i)
         a4(2,i) = a4(1,i)-sign(min(abs(qmp),abs(a4(2,i)-a4(1,i))), qmp)
         a4(3,i) = a4(1,i)+sign(min(abs(qmp),abs(a4(3,i)-a4(1,i))), qmp)
         a4(4,i) = 3.*( 2.*a4(1,i) - (a4(2,i)+a4(3,i)) )
      enddo

      elseif (lmt == 2) then

! Positive definite constraint
      do i=1,itot
      if( abs(a4(3,i)-a4(2,i)) < -a4(4,i) ) then
      fmin = a4(1,i)+0.25*(a4(3,i)-a4(2,i))**2/a4(4,i)+a4(4,i)*r12
         if( fmin < 0. ) then
         if(a4(1,i)<a4(3,i) .and. a4(1,i)<a4(2,i)) then
            a4(3,i) = a4(1,i)
            a4(2,i) = a4(1,i)
            a4(4,i) = 0.
         elseif(a4(3,i) > a4(2,i)) then
            a4(4,i) = 3.*(a4(2,i)-a4(1,i))
            a4(3,i) = a4(2,i) - a4(4,i)
         else
            a4(4,i) = 3.*(a4(3,i)-a4(1,i))
            a4(2,i) = a4(3,i) - a4(4,i)
         endif
         endif
      endif
      enddo

      endif

!EOC
 end subroutine kmppm_sak
!-----------------------------------------------------------------------

!----------------------------------------------------------------------- 
!BOP
! !ROUTINE:  steepz_sak --- Calculate attributes for PPM
!
! !INTERFACE:
 subroutine steepz_sak(i1, i2, km, kmap, a4, df2, dm, dq, dp, d4)

   implicit none

! !INPUT PARAMETERS:
      integer, intent(in) :: km                   ! Total levels
      integer, intent(in) :: kmap                 ! 
      integer, intent(in) :: i1                   ! Starting longitude
      integer, intent(in) :: i2                   ! Finishing longitude
      real, intent(in) ::  dp(i1:i2,km)       ! grid size
      real, intent(in) ::  dq(i1:i2,km)       ! backward diff of q
      real, intent(in) ::  d4(i1:i2,km)       ! backward sum:  dp(k)+ dp(k-1) 
      real, intent(in) :: df2(i1:i2,km)       ! first guess mismatch
      real, intent(in) ::  dm(i1:i2,km)       ! monotonic mismatch

! !INPUT/OUTPUT PARAMETERS:
      real, intent(inout) ::  a4(4,i1:i2,km)  ! first guess/steepened

!
! !DESCRIPTION:
!   This is complicated stuff related to the Piecewise Parabolic Method
!   and I need to read the Collela/Woodward paper before documenting
!   thoroughly.
!
! !REVISION HISTORY: 
!   ??.??.??    Lin?       Creation
!   01.03.26    Sawyer     Added ProTeX documentation
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer i, k
      real alfa(i1:i2,km)
      real    f(i1:i2,km)
      real  rat(i1:i2,km)
      real  dg2

! Compute ratio of dq/dp
      do k=max(2,kmap-1),km
         do i=i1,i2
            rat(i,k) = dq(i,k-1) / d4(i,k)
         enddo
      enddo

! Compute F
      do k=max(2,kmap-1),km-1
         do i=i1,i2
            f(i,k) =   (rat(i,k+1) - rat(i,k))                          &
                     / ( dp(i,k-1)+dp(i,k)+dp(i,k+1) )
         enddo
      enddo

      do k=max(3,kmap),km-2
         do i=i1,i2
         if(f(i,k+1)*f(i,k-1)<0. .and. df2(i,k)/=0.) then
            dg2 = (f(i,k+1)-f(i,k-1))*((dp(i,k+1)-dp(i,k-1))**2          &
                   + d4(i,k)*d4(i,k+1) )
            alfa(i,k) = max(0., min(0.5, -0.1875*dg2/df2(i,k))) 
         else
            alfa(i,k) = 0.
         endif
         enddo
      enddo

      do k=max(4,kmap+1),km-2
         do i=i1,i2
            a4(2,i,k) = (1.-alfa(i,k-1)-alfa(i,k)) * a4(2,i,k) +         &
                        alfa(i,k-1)*(a4(1,i,k)-dm(i,k))    +             &
                        alfa(i,k)*(a4(1,i,k-1)+dm(i,k-1))
         enddo
      enddo

!EOC
 end subroutine steepz_sak
!-----------------------------------------------------------------------

        subroutine cloud_clear_xfer ( cloud_generator_on,tmp3, qa_mean, qa_mean_lst, a_clr, a_cld, clr, cld)
        logical, intent(in) :: cloud_generator_on
        real, dimension(:,:), intent(in) :: tmp3, qa_mean, qa_mean_lst
        real, dimension(:,:), intent(inout) :: a_clr, a_cld, clr, cld
        real :: cld2clr, clr2cld, prec_cld2clr, prec_clr2cld, tmp1, tmp2
        integer :: k,i,kdim,idim

        idim = size(tmp3,1)
        kdim = size(tmp3,2)

        do k=1,kdim
         do i=1,idim
        !-------------------------------
        !compute cloud to clear transfer
          if (overlap .eq. 1)                                            &
             cld2clr= min(a_cld(i,k),max(0.,a_cld(i,k) - qa_mean(i,k))   )

          if (overlap .eq. 2)                                            &
             cld2clr= min(a_cld(i,k),max(0.,a_cld(i,k)*(1.-qa_mean(i,k))))

          if (cloud_generator_on) then
             tmp1 =      min(a_cld(i,k),max(0.,a_cld(i,k) - qa_mean(i,k))   )
             tmp2 =      min(a_cld(i,k),max(0.,a_cld(i,k)*(1.-qa_mean(i,k))))
             cld2clr=min(a_cld(i,k),max(0.,tmp3(i,k)*tmp1+(1.-tmp3(i,k))*tmp2))
          end if

        !-------------------------------
        !compute clear to cloud transfer
          if (overlap .eq. 1)                                            &
             clr2cld = min(max(qa_mean(i,k)-qa_mean_lst(i,k),0.),a_clr(i,k))
          if (overlap .eq. 2)                                            &
             clr2cld = min(max( a_clr(i,k)*qa_mean(i,k),0.),a_clr(i,k))

          if (cloud_generator_on) then
             tmp1 =       min(max(qa_mean(i,k)-qa_mean_lst(i,k),0.),a_clr(i,k))
             tmp2 =       min(max( a_clr(i,k)*qa_mean(i,k),0.),a_clr(i,k))
             clr2cld=min(a_clr(i,k),max(0.,tmp3(i,k)*tmp1+(1.-tmp3(i,k))*tmp2))
          end if

        !---------------------------------
        !calculate precipitation transfers
          prec_cld2clr = cld(i,k)*(cld2clr/max(a_cld(i,k),qmin))
          prec_clr2cld = clr(i,k)*(clr2cld/max(a_clr(i,k),qmin))

        !----------------
        !add in transfers
          a_clr(i,k) = a_clr(i,k) + cld2clr - clr2cld
          a_cld(i,k) = a_cld(i,k) - cld2clr + clr2cld
          clr(i,k)   = clr(i,k) + prec_cld2clr - prec_clr2cld
          cld(i,k)   = cld(i,k) - prec_cld2clr + prec_clr2cld
         enddo
        enddo

        end subroutine cloud_clear_xfer

!

!#######################################################################
!#######################################################################



end module strat_cloud_legacy_mod

#include <fms_platform.h>

! ============================================================================
! River-related processes
! ============================================================================

! ---- useful macro definitions ----------------------------------------------
#define __ERROR__(message) \
call print_error_mesg(mod_name,message,FATAL,file_name,__LINE__)
#define __NOTE__(message) \
call print_error_mesg(mod_name,message,NOTE,file_name,__LINE__)
#define __ASSERT__(x, message) \
if(.NOT.(x))call print_error_mesg(mod_name,message,FATAL,file_name,__LINE__)

module rivers_mod

! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Christopher Milly
! </CONTACT> 

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Elena Shevliakova
! </REVIEWER>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Sergey Malyshev
! </REVIEWER>

! <OVERVIEW>
!   Module containing processes relating to the rivers.
! </OVERVIEW>

! <DESCRIPTION>
!   Allocates river data and sets river destination indices. Includes tests
!   for checking whether points are coastal. Updates the state of the rivers
!   and runoff on the fast and slow time-scales. River boundary data is
!   updated on the slow time-scale. Given the local runoff field, calculates
!   the local portion of discharge.
!
!   Initializes diagnostics and sends the diagnostic field output for the
!   slow time-scale river fields and static fields to the diagnostic manager.
! </DESCRIPTION>

  use time_manager_mod,    only: time_type, get_time, increment_time

  use diag_manager_mod,    only: diag_axis_init, register_diag_field,      &
                                 register_static_field, send_data

  use mpp_mod,             only: mpp_sum, mpp_send, mpp_recv, mpp_npes,    &
                                 mpp_sync_self

  use mpp_domains_mod,     only: domain2d, mpp_get_compute_domain,         &
                                 mpp_get_global_domain, mpp_global_field
  use mpp_io_mod,          only: mpp_open, MPP_RDONLY

  use fms_mod,             only: open_namelist_file, stdlog, error_mesg, FATAL, NOTE, &
                                 file_exist, close_file, check_nml_error,mpp_pe,      &
                                 mpp_root_pe, write_version_number, stderr

  use constants_mod,       only: pi

  use land_types_mod,      only: land_data_type
 
  use land_properties_mod, only: regrid_discrete_field

  use numerics_mod,        only: bisect, is_latlon


implicit none
private


! ==== public interfaces =====================================================
public :: rivers_type        

public :: rivers_init        ! initialize rivers module
public :: rivers_end         ! finishing actions 

public :: update_rivers_fast ! fast time-scale update of state
public :: update_rivers_slow ! slow time-scale update of state

public :: update_rivers_bnd_slow
! ==== end of public interfaces ==============================================

! <TYPE NAME="rivers_type">

!   <DESCRIPTION>
!     Describes the domain and physical properties of the rivers.
!   </DESCRIPTION>

type rivers_type
   private

!   <DATA NAME="domain" TYPE="domain2d" DIM="2">
!     Computational domain
!   </DATA>

!   <DATA NAME="is" TYPE="integer">
!     Computational domain bounds
!   </DATA>

!   <DATA NAME="ie" TYPE="integer">
!     Computational domain bounds
!   </DATA>

!   <DATA NAME="js" TYPE="integer">
!     Computational domain bounds
!   </DATA>

!   <DATA NAME="je" TYPE="integer">
!     Computational domain bounds
!   </DATA>

!   <DATA NAME="gnlon" TYPE="integer">
!     Size of global grid
!   </DATA>

!   <DATA NAME="gnlat" TYPE="integer">
!     Size of global grid
!   </DATA>

   type(domain2d)   :: domain      ! our domain
   integer :: is,ie,js,je          ! computational domain bounds
   integer :: gnlon, gnlat         ! size of global grid

!   <DATA NAME="i_dest" TYPE="integer, pointer" DIM="2">
!     Longitude destination indices
!   </DATA>

!   <DATA NAME="j_dest" TYPE="integer, pointer" DIM="2">
!     Latitude destination indices
!   </DATA>

!   <DATA NAME="warea" UNITS="m2" TYPE="real, pointer" DIM="2">
!     Area covered by water per grid cell
!   </DATA>

!   <DATA NAME="larea" UNITS="m2" TYPE="real, pointer" DIM="2">
!     Area of land per grid cell
!   </DATA>

   integer, _ALLOCATABLE :: i_dest(:,:) _NULL ! lon dst indices
   integer, _ALLOCATABLE :: j_dest(:,:) _NULL  ! lat dst indices
   real,    _ALLOCATABLE :: warea(:,:) _NULL  ! area covered by water per grid cell
   real,    _ALLOCATABLE :: larea(:,:) _NULL  ! area of land per grid cell

!   <DATA NAME="discharge" UNITS="kg/m2/s" TYPE="real, pointer" DIM="2">
!     Water discharge
!   </DATA>

!   <DATA NAME="discharge_snow" UNITS="kg/m2/s" TYPE="real, pointer" DIM="2">
!     Snow discharge
!   </DATA>

   real,    _ALLOCATABLE :: discharge     (:,:) _NULL ! water discharge
   real,    _ALLOCATABLE :: discharge_snow(:,:) _NULL ! snow discharge
   
!   <DATA NAME="time" UNITS="s" TYPE="time_type">
!     Current time
!   </DATA>

!   <DATA NAME="dt" UNITS="s" TYPE="real">
!     Fast time step
!   </DATA>

!   <DATA NAME="dt_slow" UNITS="s" TYPE="real">
!     Slow time step
!   </DATA>

   type(time_type)  :: time         ! current time
   real             :: dt           ! fast time step, s
   real             :: dt_slow      ! slow time step, s
end type rivers_type
! </TYPE>

! ---- module constants -----------------------------------------------------
! some names, for information only
character(len=*), parameter :: mod_name = 'rivers'
character(len=*), parameter :: file_name = __FILE__
character(len=128), parameter :: version  = '$Id: rivers.F90,v 19.0 2012/01/06 20:39:34 fms Exp $'
character(len=128), parameter :: tagname      = '$Name: tikal $'


! <NAMELIST NAME="rivers_nml">

!   <DATA NAME="use_single_basin" TYPE="logical" DEFAULT=".false.">
!     If true, all river discharge goes to a single point
!   </DATA>

!   <DATA NAME="i_dest0" TYPE="integer" DEFAULT="1">
!     Destination point longitude index
!   </DATA>

!   <DATA NAME="j_dest0" TYPE="integer" DEFAULT="1">
!     Destination point latitude index
!   </DATA>

!   <DATA NAME="min_water_frac" TYPE="real" DEFAULT="1e-4">
!     Minimum water area fraction for the point to be a
!     valid discharge destination
!   </DATA>

!   <DATA NAME="min_land_frac" TYPE="real" DEFAULT="1e-4">
!     "Land" for discharge destination calculations
!   </DATA>

logical :: use_single_basin = .false. ! if true, all river discharge goes to 
                                      ! a single point
integer :: i_dest0 = 1 ! dst point lon index
integer :: j_dest0 = 1 ! dst point lat index
real    :: min_water_frac = 1e-4 ! min water area fraction for the point to be valid 
                          ! discharge destination
real    :: min_land_frac  = 1e-4 ! min land fraction for the cell to be considered 
                          ! "land" for discharge destination calculations
! </NAMELIST>


namelist/rivers_nml/ use_single_basin, i_dest0, j_dest0, &
     min_land_frac, min_water_frac

! ---- diagnostic field ids --------------------------------------------------
integer :: id_discharge, id_discharge_snow
integer :: id_adis_water,id_adis_snow ! area-weighted discharges
integer :: id_dcount, id_dest,  id_basin
logical :: module_is_initialized =.FALSE.

contains  ! ******************************************************************


! <SUBROUTINE NAME="rivers_init">

!   <OVERVIEW>
!     Initializes rivers data instance.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Initializes rivers data instance.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call rivers_init ( Rivers, gblon, gblat, garea, gfrac, time, dt_fast,
!        dt_slow, domain, id_lon, id_lat )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine rivers_init &
     ( Rivers, gblon, gblat, garea, gfrac, time, dt_fast, dt_slow, domain, &
     id_lon, id_lat )

  type(rivers_type), intent(inout) :: Rivers     ! data to initialize
  real,            intent(in)      :: gblon(:,:) ! lon corners of the grid cells
  real,            intent(in)      :: gblat(:,:) ! lat corners of the grid cells
  real,            intent(in)      :: garea(:,:) ! total area of each grid cell
  real,            intent(in)      :: gfrac(:,:) ! fraction of the cell covered by land
  type(time_type), intent(in)      :: time       ! current time
  type(time_type), intent(in)      :: dt_fast    ! fast time step
  type(time_type), intent(in)      :: dt_slow    ! slow time step
  type(domain2d),  intent(in)      :: domain     ! our domain
  integer,         intent(in)      :: id_lon     ! ID of land longitude (X) diag axis
  integer,         intent(in)      :: id_lat     ! ID of land latitude (Y) diag axis
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer :: unit                 ! unit number for i/o
  integer :: io                   ! status code for i/o
  integer :: ierr                 ! error code
  integer :: sec, day             ! components of time
  integer :: logunit

  ! copy domain
  Rivers%domain = domain

  ! get boundaries of our domain
  call mpp_get_compute_domain & 
       ( Rivers%domain, Rivers%is,Rivers%ie,Rivers%js,Rivers%je )

  ! and the size of global domain
  Rivers%gnlon = size(gblon,1)-1
  Rivers%gnlat = size(gblat,2)-1

  ! set up time-related values
  rivers % time = time
  call get_time(dt_fast, sec, day); rivers%dt      = day*86400.0+sec
  call get_time(dt_slow, sec, day); rivers%dt_slow = day*86400.0+sec

  ! read namelist
  if (file_exist('input.nml')) then
     unit = open_namelist_file ()
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=rivers_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'rivers_nml')
     enddo
10   continue
     call close_file (unit)
  endif

  ! write the namelist to the log file
  if ( mpp_pe() == mpp_root_pe() )  then
     call write_version_number(version, tagname)
     logunit = stdlog()
     write (logunit, nml=rivers_nml)
  endif

  ! allocate data
  allocate( &
       Rivers%i_dest(size(garea,1),size(garea,2)), &
       Rivers%j_dest(size(garea,1),size(garea,2)), &
       Rivers%larea (size(garea,1),size(garea,2)), &
       Rivers%warea (Rivers%is:Rivers%ie,Rivers%js:Rivers%je), &
       Rivers%discharge     (Rivers%is:Rivers%ie,Rivers%js:Rivers%je), &
       Rivers%discharge_snow(Rivers%is:Rivers%ie,Rivers%js:Rivers%je), &
       stat = ierr)
  __ASSERT__(ierr==0,"Cannot allocate river data")

  Rivers%larea = garea*gfrac
  Rivers%warea = garea(Rivers%is:Rivers%ie,Rivers%js:Rivers%je)  & 
       * (1-gfrac(Rivers%is:Rivers%ie,Rivers%js:Rivers%je))

  if(use_single_basin) then
     Rivers%i_dest = i_dest0
     Rivers%j_dest = j_dest0
  else
     call init_routing ( gblon, gblat, gfrac, &
           1,size(gfrac,1), 1,size(gfrac,2), &
           Rivers%i_dest, Rivers%j_dest )
  endif

  call init_rivers_diag ( id_lon, id_lat, Time )

  call diag_static ( Rivers )

  Rivers%discharge      = 0;
  Rivers%discharge_snow = 0;
       
  module_is_initialized =.TRUE. 

!   <ERROR MSG="Cannot allocate river data" STATUS="FATAL">
!   </ERROR>

end subroutine rivers_init
! </SUBROUTINE>


! <SUBROUTINE NAME="rivers_end">

!   <OVERVIEW>
!     Deallocates rivers data instance.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Deallocates rivers data instance.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call rivers_end(Rivers)
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine rivers_end(Rivers)

  type(rivers_type), intent(inout) :: Rivers ! data to deallocate/finish
!   </PUBLICROUTINE>

  ! insert saving of restart file here, if necessary
  module_is_initialized =.FALSE.
  ! release memory
  deallocate (               &
       Rivers%i_dest,        &
       Rivers%j_dest,        &
       Rivers%warea,         &
       Rivers%larea,         &
       Rivers%discharge,     &
       rivers%discharge_snow  )

end subroutine rivers_end
! </SUBROUTINE>


! <SUBROUTINE NAME="init_routing">

!   <OVERVIEW>
!     Sets river destination indices.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Sets river destination indices.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call init_routing ( glonb, glatb, gfrac, is,ie, js,je, i_dest,j_dest ) 
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine init_routing ( glonb, glatb, gfrac, is,ie, js,je, i_dest,j_dest )

  real,    intent(in)  :: glonb(:,:)          ! lon corners of the global grid
  real,    intent(in)  :: glatb(:,:)          ! lat corners of the global grid
  real,    intent(in)  :: gfrac(:,:)          ! global array of land fractional area
  integer, intent(in)  :: is,ie,js,je         ! boundaries of our domain

  integer, intent(out) :: i_dest(is:ie,js:je) ! lon index of dest points
  integer, intent(out) :: j_dest(is:ie,js:je) ! lat index of dest points
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer :: unit               ! unit number for i/o
  integer :: ierr               ! error code
  character(80) :: input_format ! input format of the data
  integer :: n_lon_in, n_lat_in ! number of lat and lon in input grid
  real    :: wb_degrees         ! western boundary of input greed, degrees

  real    :: wb, sb             ! western and southern bounds of input data
  real    :: dx, dy             ! size of input grid cells

  integer :: i, j, n, ii        ! various iterators
  integer :: n_dest             ! number of dest points in the list
  logical :: match              ! true if dest point has been found in the list
  integer :: &
       i_dest_bad, j_dest_bad, &! dest point which falls on land
       i_dest_new, j_dest_new   ! redirected dest point

  integer :: next_i, next_j     ! coordinates of next redir. point to try
  integer :: gnlon, gnlat       ! size of the global grid
  real    :: lon, lat           ! work values for destination calculations

  integer, allocatable :: input_1(:,:), input_2(:,:) ! input buffers
  integer, allocatable :: route_input(:,:)
  integer, allocatable :: route_compact(:,:), route_list(:)

  integer, allocatable :: route(:,:)

  ! path to find redirection points
  integer, parameter :: n_didj = 80
  integer, parameter :: di(n_didj) = &
      (/ -4, 4,-4, 4,-4, 4,-3, 3, 4,-4, 3,-3,-2, 2,-4, 4,-4, 4,-2, 2, &
          3,-3, 3,-3,-1, 1, 4,-4,-4, 4,-1, 1, 0, 0,-4, 4,             &
          2,-3, 3,-3, 3,-3, 2,-2,                                     &
          1,-1, 3,-3,-3, 3, 1,-1, 3,-3, 0, 0,                         &
         -2, 2,-2, 2,-1, 1, 2,-2,-2, 2,-1, 1, 0, 0,-2, 2,             &
          1,-1, 1,-1, 1,-1, 0, 0/)

  integer, parameter :: dj(n_didj) = &
      (/  4,-4,-4, 4, 3,-3,-4, 4, 3,-3,-4, 4, 4,-4,-2, 2,-2,-2,-4, 4, &
          3,-3,-3, 3,-4, 4,-1, 1,-1, 1, 4,-4,-4, 4, 0, 0,             &
          3,-2,-2, 2, 2,-2,-3, 3,                                     &
         -3, 3, 1,-1, 1,-1, 3,-3, 0, 0, 3,-3,                         &
          2,-2,-2, 2,-2, 2,-1, 1,-1, 1, 2,-2,-2, 2, 0, 0,             &
          1,-1,-1, 1, 0, 0, 1,-1/)

  ! diagnostics-only variables
  integer, dimension(:,:), allocatable :: moved_to ! moved river destination points
  integer, dimension(:,:), allocatable :: bad_dest ! array of bad river destination points -- the ones that
                                                   ! was impossible to reroute to coastal points
                                                   ! was impossible to reroute to coastal points
  integer, dimension(size(gfrac,1),size(gfrac, 2)) :: &
       g_moved_to       ! same as above, but gathered from all 
                        ! processors (only used on root processor)
  integer :: pe         ! processor index, for diagnostic gathering
  integer :: ip, npes, root_pe
  logical :: periodic
  integer :: logunit, errunit

  ! size of the global grid
  gnlon = size(gfrac, 1)
  gnlat = size(gfrac, 2)

  allocate(moved_to(gnlon,gnlat),bad_dest(gnlon,gnlat))  ! Want SGI symmetric memory for send buffers

  ! first read and re-grid pointers as with other fields
  if (.not.file_exist("INPUT/river_destination_field")) &
     call error_mesg('init_routing', &
     "Cannot find file INPUT/river_destination_field: provide this file or set use_single_basin = .true. in rivers_nml", FATAL)
! <ERROR MSG="Cannot find file INPUT/river_destination_field: provide this file or set use_single_basin = .true. in rivers_nml" STATUS="FATAL">
!   The namelist settings request the river destination field to be read, but the file 
!   cannot be found. Either provide this file, or change module namelist parameters so 
!   it is not necessary. To do the latter, set use_single_basin = .true. in the namelist rivers_nml.
! </ERROR>
  call mpp_open (unit, 'INPUT/river_destination_field', action = MPP_RDONLY)
  read (unit,*) n_lon_in, n_lat_in, wb_degrees
  read (unit,*) input_format
  allocate ( input_1     (n_lon_in, n_lat_in), &
             input_2     (n_lon_in, n_lat_in), &
             route_input (n_lon_in, n_lat_in), &
             stat = ierr )
  __ASSERT__(ierr==0, "Cannot allocate buffers")
!   <ERROR MSG="Cannot allocate buffers" STATUS="FATAL">
!   </ERROR>

  do j=1,n_lat_in
     read(unit,input_format) (input_1(i,j),i=1,n_lon_in)
  end do
  do j=1,n_lat_in
     read(unit,input_format) (input_2(i,j),i=1,n_lon_in)
  end do
  call close_file(unit)

  ! __NOTE__("Data input DONE")

  route_input = input_1 + n_lon_in*(input_2-1)
  deallocate ( input_1, input_2 )

  ! set the parameters of input grid
  wb = pi*wb_degrees/180.    ! western boundary
  sb = -pi/2                 ! southern boundary
  
  dx = 2.*pi/float(n_lon_in) ! lon size of the cell
  dy = pi/float(n_lat_in)    ! lat size of the cell

  ! compact the range of indices appearing in the routing array, for
  ! quicker processing by regrid_discrete_field. (outer 'if' skips ocean cells,
  ! which just point to themselves, and which are many in number.)
  
  allocate ( route_compact ( n_lon_in,n_lat_in ), &
             route_list    ( n_lon_in*n_lat_in ), &
             stat = ierr)
  __ASSERT__(ierr==0,"Cannot allocate buffers for route compacting")
!   <ERROR MSG="Cannot allocate buffers for route compacting" STATUS="FATAL">
!   </ERROR>

  n_dest        = 0
  route_compact = 0
  route_list    = 0
  do i = 1, n_lon_in
     do j = 1, n_lat_in
        if ( route_input(i,j) /= i+n_lon_in*(j-1) ) then
           match = .FALSE.; n = 0
           do while ( (.not.match) .and. (n < n_dest) )
              n = n+1
              match = (route_input(i,j)==route_list(n))
           enddo
           if (.not.match) then
              n_dest = n_dest + 1
              route_list(n_dest) = route_input(i,j)
              where (route_input==route_input(i,j))  &
                   route_compact = n_dest
           endif
        endif
     enddo
  enddo

  ! write(*,*) "PE=",mpp_pe(),"N_DEST=",n_dest  
   
  allocate ( route (is:ie,js:je), &
             stat = ierr )

  __ASSERT__(ierr==0,"Cannot allocate routing table")
!   <ERROR MSG="Cannot allocate routing table" STATUS="FATAL">    
!   </ERROR>

! NOTE regrid_discrete_field also needs to be changed to use gfrac instead of gland

  route = 0
  call regrid_discrete_field ( &
       route_compact,  wb, sb, dx, dy, &
       glonb(is:ie+1,js:je+1), glatb(is:ie+1,js:je+1), &
       n_dest, (gfrac(is:ie,js:je)>0), route )

  do i = 1, n_lon_in
     do j = 1, n_lat_in
        __ASSERT__(route_compact(i,j)>=0, "Route_compact index below zero")
!   <ERROR MSG="Route_compact index below zero" STATUS="FATAL">
!   </ERROR>
        __ASSERT__(route_compact(i,j)<=n_dest, "Route_compact index above n_dest")
!   <ERROR MSG="Route_compact index above n_dest" STATUS="FATAL">
!   </ERROR>

     enddo
  enddo
  deallocate (route_input,          &
              route_compact         )

  ! __NOTE__("Regridding DONE")

  !-------- then adjust values of pointers to be consistent with new grid
  ! (next code inefficiently fails to take full advantage of new compact array,
  ! but it should do the job for now. we could operate on the short list
  ! of destinations instead of the full array of destinations.)

  ! extract destination info for land cells
  do i = is,ie
     do j = js,je
        if (route(i,j)/=0) then
           __ASSERT__(route(i,j)>=0,      "Route index below zero")
!   <ERROR MSG="Route index below zero" STATUS="FATAL">
!   </ERROR>
           __ASSERT__(route(i,j)<=n_dest, "Route index above n_dest")
!   <ERROR MSG="Route index above n_dest" STATUS="FATAL">
!   </ERROR>
           i_dest(i,j) = mod(route_list(route(i,j))-1,n_lon_in)+1
           j_dest(i,j) = 1+(route_list(route(i,j))-i_dest(i,j))/n_lon_in
        else
           i_dest(i,j) = i
           j_dest(i,j) = j
        endif
     enddo
  enddo
  deallocate (route_list)

  ! __NOTE__("destinations CALCULATED")

  ! convert input-grid indices to model-grid indices (valid values only
  ! for land points)
  periodic = is_latlon(glonb,glatb)
  do i = is,ie
     do j = js,je
        ! For each point in the local domain (nlon, nlat), find the 
        ! corresponding index in the global domain by searching over the 
        ! entire global domain. This is necessary since the destination point 
        ! for a point in a local domain may fall outside of the local domain 
        ! (but not outside the global domain).
        lon = wb + (float(i_dest(i,j))-0.5)*dx ! grid is 0-centered
        lat = sb + (float(j_dest(i,j))-0.5)*dy

        i_dest(i,j) = bisect ( glonb(:,1), lon, periodic=periodic)
        j_dest(i,j) = bisect ( glatb(1,:), lat )
     enddo
  enddo

  ! __NOTE__("Conversion to dest grid DONE")

  ! clean up diagnostic arrays
  bad_dest = 0
  moved_to = 0

  ! clean up where last step made some destinations be land points (and
  ! assign destinations for ocean cells, though this may never be needed).
  ! Use gland rather than land where i_dest, j_dest are subscripts:
  ! Use gnlon, gnlat when checking whether destination points are in valid range.
  ! For ocean points, use is+i-1 rather than i, etc.

  do i = is,ie
     do j = js,je
        if (gfrac(i,j).lt.(1.0-min_water_frac)) then
           ! (i,j) is a (partly) ocean cell, direct own runoff to self
           i_dest(i,j) = i
           j_dest(i,j) = j
        else if ( .not.is_coastal(i_dest(i,j),j_dest(i,j),gfrac) ) then
           ! (i,j) is an all-land cell whose runoff is directed to an all-land 
           !   cell or to a non-coastal all-ocean cell. this is no good, so we 
           !   need to change it
           i_dest_bad = i_dest(i,j)
           j_dest_bad = j_dest(i,j)
           i_dest_new = i_dest_bad
           j_dest_new = j_dest_bad
           ! find closest coastal cell to redirect runoff to. to avoid branching 
           ! out of loop, currently search all possibilities, over-writing from 
           ! most distant to least distant
           do ii = 1, size(di(:))
              next_i = modulo ( i_dest(i,j)+di(ii)+gnlon-1, gnlon ) + 1
              next_j = max ( min ( j_dest(i,j)+dj(ii),gnlat ), 1 )
              if ( is_coastal(next_i,next_j,gfrac) ) then
                 ! found a new destination that is OK
                 i_dest_new = next_i
                 j_dest_new = next_j
              endif
           enddo
           ! change runoff destination to new location
           where (i_dest == i_dest(i,j) .and. j_dest == j_dest(i,j))
              i_dest = i_dest_new
              j_dest = j_dest_new
           endwhere
           ! check if we indeed found a coastal-cell destination for river in the end
           if ( .not. is_coastal(i_dest(i,j), j_dest(i,j), gfrac) ) then
              bad_dest(i_dest(i,j),j_dest(i,j)) = bad_dest(i_dest(i,j),j_dest(i,j))+1
           else
              moved_to(i_dest_bad, j_dest_bad) = j_dest_new*size(gfrac,1)+i_dest_new-1
           endif
        endif
     enddo
  enddo

  deallocate (route)


  ! --- re-routing problem diagnostic section --------------------------------
 
  ! gather bad destination points information from all processors
  call mpp_sum(bad_dest, size(bad_dest(:,:)))

  npes    = mpp_npes()
  root_pe = mpp_root_pe()
  if ( mpp_pe() == root_pe ) then
     ! gather re-routing diagnostics from all processors
     g_moved_to = moved_to
     do ip = 0, npes-1
        pe = ip + root_pe
        if (pe/=mpp_pe()) then 
           ! Force use of "scalar", integer pointer mpp interface
           call mpp_recv(moved_to(1,1),glen=size(moved_to,1)*size(moved_to,2),from_pe=pe)
           where (g_moved_to == 0) g_moved_to = moved_to
        endif
     enddo

     ! print out bad destination points
     logunit = stdlog()
     errunit = stderr()
     do j = 1, size(bad_dest,2)
        do i = 1, size(bad_dest,1)
           if(bad_dest(i,j)/=0) then
              write(logunit,"(a,i4,a,i3,x,i3,a)")             &
                   'ERROR :: RUNOFF SINK FOR ',bad_dest(i,j), &
                   ' CELLS (AT',i,j,') IS NOT NEAR COAST'
              write(errunit,"(a,i4,a,i3,x,i3,a)") &
                   'ERROR :: RUNOFF SINK FOR ',bad_dest(i,j),  &
                   ' CELLS (AT',i,j,') IS NOT NEAR COAST'
!   <ERROR MSG="Runoff sink is not near coast" STATUS="ERROR">
!   </ERROR>
           endif
        enddo
     enddo

     ! print out re-routing information
     do j = 1, size(moved_to,2)
        do i = 1, size(moved_to,1)
           if(g_moved_to(i,j)/=0) &
              write(logunit,"(a,i3,x,i3,a,i3,x,i3,a)")                         &
              'NOTE :: RUNOFF SINK RE-ROUTED FROM LAND OR OCEAN CELL (',        &
              i,j, ') TO COASTAL CELL (',                                       &
              mod(g_moved_to(i,j),size(gfrac,1))+1, g_moved_to(i,j)/size(gfrac,1), ')'
        enddo
     enddo

!   <ERROR MSG="Runoff sink re-routed from land or ocean cell to coastal cell" STATUS="NOTE">
!   </ERROR>

  else
     ! Force use of "scalar", integer pointer mpp interface
     call mpp_send(moved_to(1,1),plen=size(moved_to,1)*size(moved_to,2),to_pe=root_pe)
     call mpp_sync_self()
  endif

  deallocate(moved_to,bad_dest)

  ! __NOTE__("init_routing DONE")

end subroutine init_routing
! </SUBROUTINE>


! <FUNCTION NAME="is_coastal">

!   <OVERVIEW>
!     Tests whether a point is a coastal point.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Returns true if and only if point (i,j) is a coastal point on the map gfrac.
!   </DESCRIPTION>

!   <TEMPLATE>
!     value=is_coastal(i, j, gfrac)
!   </TEMPLATE>

!   <PUBLICROUTINE>
logical function is_coastal(i, j, gfrac)

  integer, intent(in) :: i, j       ! coordinates of the point in question
  real,    intent(in) :: gfrac(:,:) ! fractional area of the land
!   </PUBLICROUTINE>

  ! ---- local vars ---------------------------------------------------------
  integer ip,in, jp,jn ! coordinates of surrounding points

  ! find coordinates of surrounding points
  ip = i-1; if (ip<1) ip = size(gfrac, 1)
  in = i+1; if (in>size(gfrac,1)) in = 1
  jp = max(1, j-1); 
  jn = min(size(gfrac,2), j+1)

  is_coastal = gfrac(i,j) < (1.0-min_water_frac) .and.( &
       gfrac(i ,j ) > min_land_frac .or. &
       gfrac(in,j ) > min_land_frac .or. &
       gfrac(ip,j ) > min_land_frac .or. &
       gfrac(i ,jn) > min_land_frac .or. &
       gfrac(i ,jp) > min_land_frac      )
           
end function is_coastal
! </FUNCTION>


! <SUBROUTINE NAME="init_rivers_diag">

!   <OVERVIEW>
!     Initializes diagnostics for rivers module.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Initializes diagnostics for rivers module.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call init_rivers_diag ( id_lon, id_lat, Time)
!   </TEMPLATE>

!   <PUBLICROUTINE INTERFACE="">
subroutine init_rivers_diag ( id_lon, id_lat, Time)

  integer,         intent(in) :: id_lon  ! ID of land longitude (X) diag axis
  integer,         intent(in) :: id_lat  ! ID of land latitude (Y) diag axis
  type(time_type), intent(in) :: Time    ! current time
!   </PUBLICROUTINE>

  ! regular diagnostic fields
  id_discharge     = register_diag_field (                        &
       mod_name, 'discharge', (/id_lon, id_lat/),                 &
       Time, 'discharge', 'kg/s', missing_value=-999.0            )
  id_discharge_snow = register_diag_field (                       &
       mod_name, 'discharge_snow',  (/id_lon, id_lat/),           &
       Time,  'discharge of snow',   'kg/s', missing_value=-999.0 )
  id_adis_water = register_diag_field (                              &
       mod_name, 'discharge_aw', (/id_lon, id_lat/),  Time,         &
       'water discharge per unit ocean area',                     &
       'kg/(m2 s)', missing_value=-999.0       )
  id_adis_snow = register_diag_field (                              &
       mod_name, 'discharge_snow_aw',  (/id_lon, id_lat/), Time,     &
       'snow discharge per unit ocean area',                      &
       'kg/(m2 s)', missing_value=-999.0 )

  ! static fields
  id_dcount = register_static_field ( &
       mod_name, 'dcount', (/id_lon, id_lat/), &
       'count of cells which route into this destination point', 'none', missing_value=0.0 )
  id_dest = register_static_field ( &
       mod_name, 'dest', (/id_lon, id_lat/), &
       'destination points', 'none', missing_value=0.0 )
  id_basin = register_static_field ( &
       mod_name, 'basin', (/id_lon, id_lat/), &
       'river basins', 'none', missing_value=0.0 )

end subroutine init_rivers_diag
! </SUBROUTINE>


! <DIAGFIELDS>
!   <NETCDF NAME="discharge" UNITS="kg/s">
!     Discharge
!   </NETCDF>
!   <NETCDF NAME="discharge_snow" UNITS="kg/s">
!     Snow Discharge
!   </NETCDF>
!   <NETCDF NAME="discharge_aw" UNITS="kg/(m2 s)">
!     Water discharge per unit ocean area
!   </NETCDF>
!   <NETCDF NAME="discharge_snow_aw" UNITS="kg/(m2 s)">
!     Snow discharge per unit ocean area
!   </NETCDF>
!   <NETCDF NAME="dest" UNITS="dimensionless">
!     Destination points
!   </NETCDF>
!   <NETCDF NAME="basin" UNITS="dimensionless">
!     River basins
!   </NETCDF>
! </DIAGFIELDS>


! <SUBROUTINE NAME="update_rivers_fast">

!   <OVERVIEW>
!     Fast time-scale update of state.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Updates state of the rivers and runoff on the fast time-scale.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call update_rivers_fast ( Rivers )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine update_rivers_fast ( Rivers )

  type(rivers_type), intent(inout) :: Rivers ! data to update
!   </PUBLICROUTINE>

  !  increment time
  rivers%Time = increment_time(rivers%Time, int(rivers%dt), 0)

end subroutine update_rivers_fast
! </SUBROUTINE>


! <SUBROUTINE NAME="calc_discharge">

!   <OVERVIEW>
!     Given local runoff field, calculates local portion of discharge.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Given local runoff field, calculates local portion of discharge. Both
!     runoff and discharge fields are of local domain size.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call calc_discharge ( rivers, runoff, discharge )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine calc_discharge ( rivers, runoff, discharge )

  type(rivers_type), intent(in)  :: rivers                           ! data to update
  real,              intent(in)  :: runoff(rivers%is:,rivers%js:)    ! runoff, kg/m2/s
  real,              intent(out) :: discharge(rivers%is:,rivers%js:) ! resulting discharge, kg/s
!   </PUBLICROUTINE>

  ! ---- local vars --------------------------------------------------------
  integer :: i,j  ! iterators
  ! global runoff fields of water and snow, respectively
! real    :: g_runoff(rivers%gnlon,rivers%gnlat) 
  real,allocatable,save :: g_runoff(:,:) 
  logical,save :: first_time=.true.
  
  if(first_time)then
    first_time = .false.
    ALLOCATE(g_runoff(rivers%gnlon,rivers%gnlat))
  endif
  ! clean up the fields and set up local valued
  discharge = 0
  g_runoff  = 0
  g_runoff ( rivers%is:rivers%ie,rivers%js:rivers%je ) = runoff
  ! obtain the global field
  call mpp_sum ( g_runoff, rivers%gnlon*rivers%gnlat )
  ! 
  do i = lbound(g_runoff,1),ubound(g_runoff,1)
     do j = lbound(g_runoff,2),ubound(g_runoff,2)
        if ( rivers%is<=rivers%i_dest(i,j).and.rivers%i_dest(i,j)<=rivers%ie.and.&
             rivers%js<=rivers%j_dest(i,j).and.rivers%j_dest(i,j)<=rivers%je ) &

             discharge(rivers%i_dest(i,j),rivers%j_dest(i,j)) = &
             discharge(rivers%i_dest(i,j),rivers%j_dest(i,j)) + g_runoff(i,j)*rivers%larea(i,j)
     enddo
  enddo
  
end subroutine calc_discharge
! </SUBROUTINE>


! <SUBROUTINE NAME="update_rivers_slow">

!   <OVERVIEW>
!     Slow time-scale update of state.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Updates state of the rivers and runoff on the slow time-scale.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call update_rivers_slow ( rivers, runoff_w, runoff_s )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine update_rivers_slow ( rivers, runoff_w, runoff_s )

  type(rivers_type), intent(inout) :: rivers         ! river data to update
  real,              intent(in)    :: runoff_w(:,:)  ! runoff of liquid water, kg/(m2 s)
  real,              intent(in)    :: runoff_s(:,:)  ! snow runoff,  kg/(m2 s)
!   </PUBLICROUTINE>  

  call calc_discharge ( rivers, runoff_w, rivers%discharge )
  call calc_discharge ( rivers, runoff_s, rivers%discharge_snow )
  ! may be it is more effective to exchange both fields at once: less memory-
  ! efficient, though

  call diag_slow ( rivers )
   
end subroutine update_rivers_slow
! </SUBROUTINE>


! <SUBROUTINE NAME="update_rivers_bnd_slow">

!   <OVERVIEW>
!     Updates the river boundary data on the slow time-scale.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Updates the river boundary data on the slow time-scale.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call update_rivers_bnd_slow ( rivers, bnd )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine update_rivers_bnd_slow ( rivers, bnd )

  type(rivers_type),    intent(in)    :: rivers  ! river data to update
  type(land_data_type), intent(inout) :: bnd     ! land boundary data
!   </PUBLICROUTINE>

  bnd % discharge      = rivers % discharge
  bnd % discharge_snow = rivers % discharge_snow
  
  where ( rivers%warea > 0.0 )
     ! adjust partial-ocean-cell discharge values for area fraction
     ! and recalculate to kg/(m2 s)
     bnd % discharge      = bnd % discharge      / rivers%warea
     bnd % discharge_snow = bnd % discharge_snow / rivers%warea
  elsewhere
     bnd % discharge      = 0
     bnd % discharge_snow = 0
  endwhere

end subroutine update_rivers_bnd_slow
! </SUBROUTINE>


! <SUBROUTINE NAME="diag_slow">

!   <OVERVIEW>
!     Diagnostic field output of the slow time-scale variables.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Diagnostic field output of the slow time-scale variables.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call diag_slow ( rivers )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine diag_slow ( rivers )

  type(rivers_type), intent(in) :: rivers  ! river data to update
!   </PUBLICROUTINE>

  ! ---- local vars ---------------------------------------------------------
  logical :: used
  real    :: x(rivers%is:rivers%ie, rivers%js:rivers%je)

  if (id_discharge > 0) &
     used = send_data (id_discharge, rivers%discharge, rivers%Time)
  if (id_discharge_snow > 0) &
     used = send_data (id_discharge_snow, rivers%Discharge_snow, rivers%Time)
  if (id_adis_water > 0) then
     x=0
     where ( rivers%warea > 0.0 ) &
          x = rivers%discharge      / rivers%warea
     used = send_data (id_adis_water, x, rivers%Time)
  endif
  if (id_adis_snow  > 0) then
     x=0
     where ( rivers%warea > 0.0 ) &
          x = rivers%discharge_snow / rivers%warea
     used = send_data (id_adis_snow, x, rivers%Time)
  endif

end subroutine diag_slow
! </SUBROUTINE>


! <SUBROUTINE NAME="diag_static">

!   <OVERVIEW>
!     Static diagnostic fields output.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Static diagnostic fields output.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call diag_static ( rivers )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine diag_static ( rivers )

  type(rivers_type), intent(in) :: rivers  ! river data
!   </PUBLICROUTINE>

  ! ---- local vars ---------------------------------------------------------
  logical :: used
  integer :: i,j

  integer, allocatable :: &
       dcount(:,:), &  ! count of cells which route into this destination cell
       dpoint(:,:), &  ! destination point map
       basin (:,:)     ! basin number

  integer :: nbasins   ! current number of basins
  integer :: id, jd    ! indices of current dest point

  ! + slm Apr 09 2002
  if( id_dest > 0.or.id_basin>0 ) then
     ! allocate global destination points arrays
     allocate( &
          dcount( lbound(rivers%i_dest,1):ubound(rivers%i_dest,1),    &
                  lbound(rivers%i_dest,2):ubound(rivers%i_dest,2)  ), &
          dpoint( lbound(rivers%i_dest,1):ubound(rivers%i_dest,1),    &
                  lbound(rivers%i_dest,2):ubound(rivers%i_dest,2)  ), &
          basin ( lbound(rivers%i_dest,1):ubound(rivers%i_dest,1),    &
                  lbound(rivers%i_dest,2):ubound(rivers%i_dest,2)  )  )

     ! clean up the arrays of destination points, basins, and the number of
     ! river basins
     dcount  = 0
     dpoint  = 0
     basin   = 0
     nbasins = 0

     do j = lbound(rivers%i_dest,2),ubound(rivers%i_dest,2)
        do i = lbound(rivers%i_dest,1),ubound(rivers%i_dest,1)
           id = rivers%i_dest(i,j); jd = rivers%j_dest(i,j)
           if (id /= i.or.jd/=j) then  ! point does not discharge to itself => it is not ocean
              if(dpoint(id,jd).eq.0) then
                 ! we have not encountered this destination point before,
                 ! add a basin
                 nbasins       = nbasins+1
                 dpoint(id,jd) = nbasins
              endif
              basin(i,j) = dpoint(id,jd)
              dcount(id,jd) = dcount(id,jd) + 1
           endif
        enddo
     enddo
     if (id_dcount > 0) &
          used = send_data (id_dcount, &
          dcount(rivers%is:rivers%ie, rivers%js:rivers%je)*1.0, rivers%time)
     if (id_dest > 0) &
          used = send_data (id_dest, &
          dpoint(rivers%is:rivers%ie, rivers%js:rivers%je)*1.0, rivers%time)
     if (id_basin > 0) &
          used = send_data (id_basin, &
          basin(rivers%is:rivers%ie, rivers%js:rivers%je)*1.0, rivers%time)
     ! clean up after ourselves
     deallocate(dpoint, basin )
  endif
  ! - slm Apr 09 2002

end subroutine diag_static
! </SUBROUTINE>


! <SUBROUTINE NAME="print_error_mesg">

!   <OVERVIEW>
!     Reports error, including file name and line.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Reports error, including file name and line.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call print_error_mesg(mod_name, message, mode, file, line)
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine print_error_mesg(mod_name, message, mode, file, line)

  character(len=*), intent(in) :: mod_name   ! module name
  character(len=*), intent(in) :: message    ! error message
  integer,          intent(in) :: mode       ! error mode
  character(len=*), intent(in) :: file       ! file containing error
  integer,          intent(in) :: line       ! line number or error
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  character(len=512) :: mesg
  write(mesg,'("File ",a," Line ",i4.4," :: ",a)')&
       file, line, trim(message)
  call error_mesg(mod_name, mesg, mode)

end subroutine
! </SUBROUTINE>


end module rivers_mod

module ocean_lap_tracer_mod
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Thickness weighted and density weighted time tendency 
! for tracer from lateral laplacian diffusion.  
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes lateral laplacian diffusion of a tracer.
! There are two main options.
!
! (1) The lateral tracer fluxes can be aligned with the z-coordinate surfaces,
! in which case the fluxes must be approximated if (i) we use non-geopotential
! vertical coordinates, (ii) next to partial bottom step topography.
! This form of the diffusion is not recommended since it can lead to 
! the creation of spurious extrema.  
!
! (2) The lateral tracer fluxes can be aligned surfaces of constant vertical 
! coordinate. In this case the fluxes are no longer strictly "horizontal."
! However, the operator is simpler and it ensures that no suprious
! extrema are created. It is for this reason that the simpler operator
! is preferred.   
!  
! The diffusivity used to determine the strength of the tendency can be 
! a general function of space yet it is constant in time.  A namelist 
! option exists that determines this diffusivity as a local function 
! of the grid spacing. 
!</DESCRIPTION>
!
! <INFO>
!
! <NOTE>
! The numerical implementation requires no calls to mpp_update_domains.  
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_lap_tracer_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is false.
!  </DATA> 
!
!  <DATA NAME="horz_z_diffuse" TYPE="logical">
!  To compute diffusion along surfaces of constant depth.
!  This operation must necessarily be approximate for the two 
!  cases (i) non-geopotential vertical coordinates, (2)
!  next to partial bottom step topography.  There are cases where
!  use of this operator can lead to spurious creation of extrema
!  due to truncation errors associated with the "slope" term.
!  For most cases where lateral diffusion is required, we 
!  will want it to be "diffusive" in the sense that no extrema are
!  created.  So the default is horz_z_diffuse=.false.
!  The option to use horz_z_diffuse=.true. is maintained for 
!  legacy purposes alone.  
!  </DATA> 
!  <DATA NAME="horz_s_diffuse" TYPE="logical">
!  To compute diffusion along surfaces of constant vertical s-coordinate. 
!  This operation is ensured of obtaining a smoothing operator
!  that does not create extrema. It is the default for this 
!  reason. 
!  </DATA> 
!
!  <DATA NAME="alap" UNITS="m^2/sec" TYPE="real">
!  This is the value for the space-time constant Laplacian diffusivity. 
!  </DATA> 
!
!  <DATA NAME="tracer_mix_micom" TYPE="logical">
!  If .true., then the diffusivity is set according to a velocity scale times
!  the grid spacing. It is based on an approach recommended by 
!  Eric Chassignet that is used in the Miami Isopycnal Model (MICOM).  
!  </DATA> 
!  <DATA NAME="vel_micom" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM diffusivity. 
!  </DATA> 
!
!  <DATA NAME="read_diffusivity_mask" TYPE="logical">
!  Allows for reading of a mask that to apply diffusivity
!  only in selected regions.
!  Default read_diffusivity_mask=.false.
!  </DATA>
!
!  <DATA NAME="verbose_init" TYPE="logical">
!  For verbose writes during initialization 
!  </DATA> 
!</NAMELIST>
!
use constants_mod,       only: epsln
use diag_manager_mod,    only: register_diag_field, register_static_field
use fms_mod,             only: write_version_number, open_namelist_file, close_file, check_nml_error
use fms_mod,             only: FATAL, NOTE, stdout, stdlog, read_data
use mpp_domains_mod,     only: mpp_update_domains, CGRID_NE
use mpp_mod,             only: input_nml_file, mpp_error

use ocean_domains_mod,    only: get_local_indices, set_ocean_domain
use ocean_obc_mod,        only: store_ocean_obc_tracer_flux, ocean_obc_enhance_diff_back
use ocean_operators_mod,  only: FMX, FMY, FDX_ZT, FDY_ZT, BDX_ET, BDY_NT
use ocean_operators_mod,  only: FDX_T, FDY_T
use ocean_parameters_mod, only: missing_value
use ocean_types_mod,      only: ocean_grid_type, ocean_domain_type, ocean_time_type
use ocean_types_mod,      only: ocean_thickness_type, ocean_prog_tracer_type, ocean_options_type
use ocean_workspace_mod,  only: wrk1
use ocean_util_mod,       only: diagnose_3d

implicit none

private

public ocean_lap_tracer_init
public lap_tracer

real    :: alap              = 0.0e3  ! tracer diffusivity (m^2/sec)
real    :: vel_micom         = 0.0    ! constant velocity scale (m/s) for setting micom diffusivity  
logical :: tracer_mix_micom  =.false. ! if true, diffusivity made a function of the grid spacing
logical :: verbose_init      =.true.  ! for verbose writes during initialization 

! for diagnostics 
logical :: used
integer :: id_ah_laplacian=-1
integer, dimension(:), allocatable  :: id_xflux_diff
integer, dimension(:), allocatable  :: id_yflux_diff
integer, dimension(:), allocatable  :: id_h_diffuse

real, dimension(:,:,:), allocatable :: diff_cet ! diffusivity for eastern face of T cell (m^2/s)
real, dimension(:,:,:), allocatable :: diff_cnt ! diffusivity for northern face of T cell (m^2/s)
real, dimension(:,:,:), allocatable :: diffusivity_mask ! 3d mask to selectively apply diffusion

character(len=128) :: version=&
     '$Id: ocean_lap_tracer.F90,v 20.0 2013/12/14 00:14:20 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_domain_type), save    :: Dom_flux

real, dimension(:,:,:), allocatable :: fx, fy
integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk
integer :: num_prog_tracers      = 0

logical :: use_this_module       = .false.
logical :: horz_z_diffuse        = .false.
logical :: horz_s_diffuse        = .true.
logical :: read_diffusivity_mask = .false.
logical :: module_is_initialized = .FALSE.
logical :: have_obc=.false.

namelist /ocean_lap_tracer_nml/ use_this_module, alap, tracer_mix_micom, vel_micom, verbose_init, &
                                read_diffusivity_mask, horz_z_diffuse, horz_s_diffuse

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_lap_tracer_init">
!
! <DESCRIPTION>
! Initialize the laplacian diffusion module by 
! registering fields for diagnostic output and performing some 
! numerical checks to see that diffusivity is set appropriately.
! </DESCRIPTION>
!
subroutine ocean_lap_tracer_init(Grid, Domain, Time, T_prog, Ocean_options, dtime, obc, tmask_sigma)

  type(ocean_grid_type),     target, intent(in)    :: Grid
  type(ocean_domain_type),   target, intent(in)    :: Domain
  type(ocean_time_type),             intent(in)    :: Time
  type(ocean_prog_tracer_type),      intent(inout) :: T_prog(:)
  type(ocean_options_type),          intent(inout) :: Ocean_options
  real,                              intent(in)    :: dtime
  logical,                           intent(in)    :: obc
  real,                    optional, intent(in)    :: tmask_sigma(Domain%isc:Domain%iec,Domain%jsc:Domain%jec)

  integer :: ioun, io_status, i, j, k, n, ierr
  
  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error from ocean_lap_tracer_init: module already initialized')
  endif 

  module_is_initialized = .TRUE.

  have_obc = obc

  num_prog_tracers = size(T_prog(:))

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_lap_tracer_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_lap_tracer_nml')
#else
  ioun  = open_namelist_file()
  read (ioun,ocean_lap_tracer_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status, 'ocean_lap_tracer_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_lap_tracer_nml)  
  write (stdlogunit,ocean_lap_tracer_nml)

  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
 
  if(use_this_module) then 
      write(stdoutunit,*)'==>Note from ocean_lap_tracer_mod: Using this module.'
      Ocean_options%horz_lap_tracer = 'Used horizontal laplacian tracer mixing option.'
  else
      write(stdoutunit,*)'==>Note from ocean_lap_tracer_mod: NOT using this module.'
      Ocean_options%horz_lap_tracer = 'Did NOT use horizontal laplacian tracer mixing.'
      return 
  endif

  if(alap > 0 .or. (tracer_mix_micom .and. vel_micom > 0)) then 
      write (stdoutunit,'(/1x,a)') ' ==> Warning: laplacian diffusion generally contributes to unphysically'
      write (stdoutunit,'(7x,a)') 'large diapycnal mixing. Such may be damaging for longer simulations.'
      write (stdoutunit,'(7x,a)') 'It is recommended that the tracer diffusivity be set to zero, and one'
      write (stdoutunit,'(7x,a)') 'instead uses a neutral physics.'
  endif

  if(horz_z_diffuse) then 
      write(stdoutunit,*)'==>Warning: Computing laplacian tracer diffusion along constant geoptoential surfaces.'
      write(stdoutunit,*)'   This operator can create spurious extrema where s-surfaces deviate from z-surfaces.'
      write(stdoutunit,*)'   For this reason, the alternative horz_s_diffuse=.true. is recommended.'
  endif

  if(horz_s_diffuse) then 
      write(stdoutunit,*)'==>Note: Computing lateral tracer diffusion along constant s-surfaces.'
      write(stdoutunit,*)'   This operator will always smooth tracer fields and will not produce extrema.'
  endif

  if(horz_s_diffuse .and. horz_z_diffuse) then 
      write(stdoutunit,'(a)')'==>Error from ocean_lap_tracer_mod: use one of horz_s_diffuse and horz_z_diffuse.'
      write(stdoutunit,'(a)')'   Presently, both are set true and this is not allowed. '
      call mpp_error(FATAL,'==>Error from ocean_lap_tracer_mod: use one of horz_s_diffuse and horz_z_diffuse.')
  endif

  if(.not. horz_s_diffuse .and. .not. horz_z_diffuse) then 
      write(stdoutunit,*)'==>Warning from ocean_lap_tracer_mod: use_this_module=.true.'
      write(stdoutunit,*)'   However, both horz_s_diffuse and horz_z_diffuse are .false.'
      write(stdoutunit,*)'   So will not produce any lateral tracer diffusion.'
  endif


  write(stdoutunit,'(/a,f10.2)')'==> Note from ocean_lap_tracer_mod: using forward time step (secs)', dtime 

  Dom => Domain
  Grd => Grid

  call set_ocean_domain(Dom_flux, Grid, name='horz diff flux', maskmap=Dom%maskmap)

  allocate (diff_cet(isd:ied,jsd:jed,nk))
  allocate (diff_cnt(isd:ied,jsd:jed,nk))
  allocate (fx(isd:ied,jsd:jed,nk))
  allocate (fy(isd:ied,jsd:jed,nk))  

  diff_cet(:,:,:) = alap
  diff_cnt(:,:,:) = alap
  fx = 0.0
  fy = 0.0
  
  ! Micom background diffusivity
  ! Space scale set by grid size
  ! Velocity scale input via namelist 
  if(tracer_mix_micom) then
    do k=1,nk
      diff_cet(:,:,k) = vel_micom*(2.0*Grd%dxt(:,:)*Grd%dyte(:,:)/(Grd%dxt(:,:)+Grd%dyte(:,:)))
      diff_cnt(:,:,k) = vel_micom*(2.0*Grd%dxtn(:,:)*Grd%dyt(:,:)/(Grd%dxtn(:,:)+Grd%dyt(:,:)))
    enddo
    if(verbose_init) then 
      do j=jsc,jec
        write (stdoutunit,'(a,i4,a,e14.7,a)') &
        ' MICOM Laplacian diffusivity at (isc,',j,',1) = ',diff_cet(isc,j,1),' m^2/s'
      enddo
    endif 
  endif 

  ! enhance background diffusion near open boundaries if needed
  if (have_obc) call ocean_obc_enhance_diff_back(diff_cet, diff_cnt)
  
  if(PRESENT(tmask_sigma)) then 
     do j=jsc,jec
        do i=isc,iec
           if(tmask_sigma(i,j) > 0.0) then   
              k = Grd%kmt(i,j)
              diff_cet(i,j,k) = diff_cet(i,j,k)*(1.0-tmask_sigma(i,j))
              diff_cnt(i,j,k) = diff_cnt(i,j,k)*(1.0-tmask_sigma(i,j))
           endif
        enddo
     enddo
  endif

  ! apply diffusivity in selected regions
  if(read_diffusivity_mask) then
      allocate (diffusivity_mask(isd:ied,jsd:jed,nk))
      call read_data('INPUT/tracer_diffusivity_mask.nc','diffusivity_mask', diffusivity_mask, Domain%domain2d)
      write (stdoutunit,*) '==>ocean_lap_tracer_mod: Completed read of 3d tracer diffusivity mask.'
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               diff_cet(i,j,k) = diff_cet(i,j,k)*diffusivity_mask(i,j,k)
               diff_cnt(i,j,k) = diff_cnt(i,j,k)*diffusivity_mask(i,j,k)
            enddo
         enddo
      enddo
  endif

  call mpp_update_domains (diff_cet(:,:,:), Dom%domain2d)
  call mpp_update_domains (diff_cnt(:,:,:), Dom%domain2d)

  id_ah_laplacian = register_static_field ('ocean_model', 'ah_laplacian',&
                    Grd%tracer_axes(1:3),'static laplacian diffusivity', &
                    'm^2/sec', missing_value=missing_value, range=(/-10.0,1.e20/))
  call diagnose_3d(Time, Grd, id_ah_laplacian, diff_cet(:,:,:))

  ! register for diagnostics manager 
  allocate (id_xflux_diff(num_prog_tracers))
  allocate (id_yflux_diff(num_prog_tracers))
  allocate (id_h_diffuse(num_prog_tracers))
  id_xflux_diff = -1
  id_yflux_diff = -1
  id_h_diffuse  = -1

  do n=1,num_prog_tracers

     if (trim(T_prog(n)%name) == 'temp') then
         id_xflux_diff(n) = register_diag_field ('ocean_model',          &
              trim(T_prog(n)%name)//'_xflux_diff', Grd%tracer_axes(1:3), &
              Time%model_time, 'i-diffusive heat flux', 'Watt',          &
              missing_value=missing_value, range=(/-1.e16,1.e16/))
         id_yflux_diff(n) = register_diag_field ('ocean_model',          &
              trim(T_prog(n)%name)//'_yflux_diff', Grd%tracer_axes(1:3), &
              Time%model_time, 'j-diffusive heat flux', 'Watt',          &
              missing_value=missing_value, range=(/-1.e16,1.e16/))         
         id_h_diffuse(n) = register_diag_field ('ocean_model',          &
              trim(T_prog(n)%name)//'_h_diffuse', Grd%tracer_axes(1:3), &
              Time%model_time, 'horz-diffusion of heat', 'Watt/m^2',    &
              missing_value=missing_value, range=(/-1.e16,1.e16/))         
     else
         id_xflux_diff(n) = register_diag_field ('ocean_model',                       &
         trim(T_prog(n)%name)//'_xflux_diff', Grd%tracer_axes(1:3),                   &
              Time%model_time, 'i-diffusive flux of '//trim(T_prog(n)%name), 'kg/sec',&
              missing_value=missing_value, range=(/-1.e10,1.e10/))
         id_yflux_diff(n) = register_diag_field ('ocean_model',                       &
         trim(T_prog(n)%name)//'_yflux_diff', Grd%tracer_axes(1:3),                   &
              Time%model_time, 'j-diffusive flux of '//trim(T_prog(n)%name), 'kg/sec',&
              missing_value=missing_value, range=(/-1.e10,1.e10/))         
         id_h_diffuse(n) = register_diag_field ('ocean_model',                            &
         trim(T_prog(n)%name)//'_h_diffuse', Grd%tracer_axes(1:3),                        &
              Time%model_time, 'horz-diffusion of '//trim(T_prog(n)%name), 'kg/(sec*m^2)',&
              missing_value=missing_value, range=(/-1.e10,1.e10/))         
     endif

  enddo

  
end subroutine ocean_lap_tracer_init
! </SUBROUTINE>  NAME="ocean_lap_tracer_init"


!#######################################################################
! <SUBROUTINE NAME="lap_tracer">
!
! <DESCRIPTION>
! This function computes the thickness weighted and density weighted
! time tendency for tracer from lateral laplacian diffusion. 
! </DESCRIPTION>
!
subroutine lap_tracer (Time, Thickness, Tracer, ntracer, diag_flag)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: Tracer
  integer,                      intent(in)    :: ntracer
  logical,            optional, intent(in)    :: diag_flag 
  logical                                     :: send_diagnostics 

  real, dimension(isd:ied,jsd:jed,2)  :: tracr
  integer                             :: i, j, k
  integer                             :: tau, taum1
 
  if(.not. use_this_module) return 

  ! assume send_diagnostics=.true., unless diag_flag says it is false.
  if (PRESENT(diag_flag)) then 
    send_diagnostics = diag_flag
  else 
    send_diagnostics = .true.
  endif 

  if (.not. module_is_initialized ) then 
     call mpp_error(FATAL, '==>Error from ocean_lap_tracer_mod (lap_tracer): must be initialized')
  endif 

  taum1 = Time%taum1
  tau   = Time%tau

  ! fx = flux component through "eastern"  face of T-cells at level k
  ! fy = flux component through "northern" face of T-cells at level k

  if(horz_z_diffuse) then 

      ! tracr(:,:,1) = Tracer%field at level k-1
      ! tracr(:,:,2) = Tracer%field at level k

      tracr(:,:,1) = Tracer%field(:,:,1,taum1)
      do k=1,nk
         tracr(:,:,2) = Tracer%field(:,:,k,taum1)
         fx(:,:,k)    = diff_cet(:,:,k)*FDX_ZT(tracr(:,:,1:2),k)*FMX(Thickness%rho_dzt(:,:,k,tau)*Grd%tmask(:,:,k))
         fy(:,:,k)    = diff_cnt(:,:,k)*FDY_ZT(tracr(:,:,1:2),k)*FMY(Thickness%rho_dzt(:,:,k,tau)*Grd%tmask(:,:,k))
         tracr(:,:,1) = tracr(:,:,2)
      enddo

  elseif(horz_s_diffuse) then 

      do k=1,nk
         tracr(:,:,1) = Tracer%field(:,:,k,taum1)
         fx(:,:,k)    = diff_cet(:,:,k)*FDX_T(tracr(:,:,1))*FMX(Thickness%rho_dzt(:,:,k,tau)*Grd%tmask(:,:,k))
         fy(:,:,k)    = diff_cnt(:,:,k)*FDY_T(tracr(:,:,1))*FMY(Thickness%rho_dzt(:,:,k,tau)*Grd%tmask(:,:,k))
      enddo

  endif

  if(Grd%tripolar) call mpp_update_domains(fx, fy, Dom_flux%domain2d, gridtype=CGRID_NE)

  do k=1,nk
     wrk1(:,:,k) = (BDX_ET(fx(:,:,k)) + BDY_NT(fy(:,:,k)))
     do j=jsc,jec
        do i=isc,iec
           Tracer%th_tendency(i,j,k) = Tracer%th_tendency(i,j,k) + Grd%tmask(i,j,k)*wrk1(i,j,k)
        enddo
     enddo
  enddo

  ! send fluxes to diag_manager 
  ! minus sign is due to MOM-convention for physics fluxes. 
  if(send_diagnostics) then 

      if (id_xflux_diff(ntracer) > 0) then
          do k=1,nk
            fx(:,:,k) = fx(:,:,k)*Grd%dyte(:,:)
          enddo
          call diagnose_3d(Time, Grd, id_xflux_diff(ntracer), -1.0*fx(:,:,:)*Tracer%conversion)
      endif
      if (id_yflux_diff(ntracer) > 0) then
          do k=1,nk
            fy(:,:,k) = fy(:,:,k)*Grd%dxtn(:,:)
          enddo
          call diagnose_3d(Time, Grd, id_yflux_diff(ntracer), -1.0*fy(:,:,:)*Tracer%conversion)
      endif
      if (id_h_diffuse(ntracer) > 0) then
         call diagnose_3d(Time, Grd, id_h_diffuse(ntracer), wrk1(:,:,:)*Tracer%conversion)
      endif

  endif

  if (have_obc) then 
     call store_ocean_obc_tracer_flux(Time, Tracer, -1.0*fx, ntracer, 'z', 'dif')
     call store_ocean_obc_tracer_flux(Time, Tracer, -1.0*fy, ntracer, 'm', 'dif')
  endif
  
end subroutine lap_tracer
! </SUBROUTINE> NAME="lap_tracer"

end module ocean_lap_tracer_mod
      
      

module ocean_shortwave_csiro_mod
!
!<CONTACT EMAIL="Russell.Fiedler@csiro.au"> Russell Fiedler 
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</REVIEWER>
!
!<OVERVIEW>
! This module returns thickness and density weighted temperature 
! tendency [kg/m^3 * deg C *m/sec] from penetrative shortwave heating.
!</OVERVIEW>
!
!<DESCRIPTION>
! Compute thickness and density weighted tendency [deg C *m/sec *kg/m^3]
! of temperature associated with penetrative shortwave heating in the upper
! ocean. Generally penetration is taken as a function of monthly optical 
! properties of the upper ocean, where optical properties are read 
! in from a file of climatological data.
!
! This module ussumes a simple single exponential decay law. The e-folding 
! depth may vary spatially and temporaly.  This routine is commonly 
! used by researchers at CSIRO Marine and Atmospheric Research in 
! Australia.  It has been optimized for vector peformance in 
! June 2003 on the Australian NEC computer. 
! </DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! Jerlov (1968)
! Optical Oceanography
! Elsevier Press
! </REFERENCE>
!
! <REFERENCE>
! Morel and Antoine (1994)
! Heating rate in the upper ocean in relation to its bio-optical state 
! Journal of Physical Oceanography vol 24 pages 1652-1664
! </REFERENCE>
!
! <REFERENCE>
! Paulson and Simpson (1977)
! Irradiance measurements in the upper ocean
! Journal of Physical Oceanography vol 7 pages 952-956
! </REFERENCE>
!
! <REFERENCE>
! Rosati and Miyakoda (1988)
! A General Circulation Model for Upper Ocean Simulation
! Journal of Physical Oceanography vol 18 pages 1601-1626.
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_shortwave_csiro_nml">
!  <DATA NAME="use_this_module=" TYPE="logical">
!  Must be .true. to run with module. Default is false.
!  </DATA> 
!
!  <DATA NAME="read_depth" TYPE="logical">
!  If .true. then read in e folding depth for radiation attenuation. 
!  </DATA> 
!  <DATA NAME="sw_frac_top" TYPE="real">
!  The fraction of shortwave radiation that should be incorporated into 
!  the sw_source array at k=1.  The generic treatment in MOM is to assume
!  that shortwave radiation is already contained inside the 
!  T_prog(index_temp)%stf field. Hence, to avoid   
!  double counting, sw_frac(k=0)=sw_frac_top should=0.0.
!  If one removes shortwave from stf, then set sw_frac_top=1.0.
!  </DATA> 
!  <DATA NAME="zmax_pen" UNITS="meter" TYPE="real">
!   Maximum depth of penetration of shortwave radiation. 
!   Below this depth, shortwave penetration is exponentially 
!   small and so is ignored.
!  </DATA>
!  <DATA NAME="depth_default" UNITS="mg/m^3" TYPE="real">
!   Default efolding depth = 20m.
!  </DATA>
!  <DATA NAME="enforce_sw_frac" TYPE="logical">
!  To ensure the shortwave fraction is monotonically decreasing with depth. 
!  </DATA> 
!  <DATA NAME="sw_pen_fixed_depths" TYPE="logical">
!  To compute penetration assuming fixed depths via Grd%zw(k) depths.
!  This is strictly incorrect when have undulating free surface or 
!  generatlized vertical coordinates.  This option is here for purposes
!  of legacy, as this was done in MOM4.0 versions. The default is .false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging purposes.
!  </DATA> 
!</NAMELIST>

use axis_utils_mod,           only: frac_index
use field_manager_mod,        only: fm_get_index
use fms_mod,                  only: write_version_number, open_namelist_file
use fms_mod,                  only: close_file, check_nml_error
use fms_mod,                  only: stdout, stdlog, FATAL, NOTE
use mpp_mod,                  only: input_nml_file, mpp_error, mpp_max, mpp_min
use mpp_mod,                  only: mpp_clock_id, mpp_clock_begin, mpp_clock_end
use mpp_mod,                  only: CLOCK_ROUTINE
use time_interp_external_mod, only: time_interp_external, init_external_field

use ocean_domains_mod,        only: get_local_indices
use ocean_types_mod,          only: ocean_time_type, ocean_domain_type, ocean_grid_type
use ocean_types_mod,          only: ocean_prog_tracer_type, ocean_thickness_type, ocean_options_type
use ocean_types_mod,          only: ocean_diag_tracer_type

implicit none

private

! clock ids
integer :: id_sw_pen

integer :: sbc_opt
logical :: verbose_flag=.false.

#include <ocean_memory.h>
  

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

character(len=128)  :: version='$Id: ocean_shortwave_csiro.F90,v 20.0 2013/12/14 00:16:16 fms Exp $'
character (len=128) :: tagname = '$Name: tikal $'

! F_vis is the amount of light in the shortwave verses the long wave.
! F_vis=0.54 on sunny days and F_vis=0.60 on cloudy days. 
real, public :: F_vis=0.57

real, public, allocatable, dimension(:,:) :: ssw_atten_depth  !  Attenuation depth for ssw (m)

public  ocean_shortwave_csiro_init
public  sw_source_csiro
private sw_pen

logical :: use_this_module        = .false.
logical :: read_depth             = .false.
logical :: module_is_initialized  = .FALSE.
logical :: debug_this_module      = .false. 
logical :: enforce_sw_frac        = .true. 
logical :: sw_pen_fixed_depths    = .false. 

real :: depth_default = 20.0  ! (m) default  efolding length
real :: zmax_pen      = 120.0 ! maximum depth (m) of solar penetration. 
                              ! below, penetration is exponentially small and so is ignored
real :: sw_frac_top   = 0.0   ! set to 1.0 if do not have shortwave radiation inside of T_prog(index_temp)%stf.

namelist /ocean_shortwave_csiro_nml/ use_this_module, read_depth, depth_default, &
                               zmax_pen, sw_frac_top, debug_this_module,         &
                               enforce_sw_frac, sw_pen_fixed_depths 

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_shortwave_csiro_init">
!
! <DESCRIPTION>
! Initialization for the shortwave module
! </DESCRIPTION>
  subroutine ocean_shortwave_csiro_init(Grid, Domain, Time, Ocean_options)

    type(ocean_grid_type),    intent(in), target :: Grid
    type(ocean_domain_type),  intent(in), target :: Domain
    type(ocean_time_type),    intent(in)         :: Time
    type(ocean_options_type), intent(inout)      :: Ocean_options

    integer :: unit, io_status, ierr, i, j
#ifdef MOM_STATIC_ARRAYS    
    real, dimension(isd:ied,jsd:jed)   :: depth_data
#else
    real, allocatable, dimension(:,:)  :: depth_data
#endif
  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 


    if ( module_is_initialized ) return
    
    module_is_initialized = .TRUE.

    call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_shortwave_csiro_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_shortwave_csiro_nml')
#else
    unit = open_namelist_file()
    read(unit, ocean_shortwave_csiro_nml,iostat=io_status)
    ierr = check_nml_error(io_status, 'ocean_shortwave_csiro_nml')
    call close_file(unit)
#endif
    write (stdoutunit,'(/)')
    write(stdoutunit,ocean_shortwave_csiro_nml)    
    write(stdlogunit,ocean_shortwave_csiro_nml)

    Dom => Domain
    Grd => Grid

#ifndef MOM_STATIC_ARRAYS    
    call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
    nk = Grid%nk
#endif 

#ifndef MOM_STATIC_ARRAYS    
    allocate( depth_data(isd:ied,jsd:jed))
#endif
    allocate(ssw_atten_depth(isd:ied,jsd:jed))
    ssw_atten_depth(:,:) = depth_default

    ! even for use_this_module=.false., we need to have ssw_atten_depth
    if(use_this_module) then 
      call mpp_error(NOTE, '==>Note: USING shortwave_csiro_mod.')
      Ocean_options%shortwave = 'Used the shortwave penetration from the CSIRO formulaton.'
    else 
      call mpp_error(NOTE, '==>Note: NOT using shortwave_csiro_mod.')
      Ocean_options%shortwave = 'Did NOT use any shortwave penetration option.'
      return 
    endif 

    ! set clock ids     
    id_sw_pen = mpp_clock_id('(Ocean shortwave penetrate) ' ,grain=CLOCK_ROUTINE)

    if(read_depth) then 

        call mpp_error(NOTE,&
         '==>Note: Reading in attenuation length scale from data file for shortwave penetration.')

        sbc_opt = init_external_field('INPUT/ssw_atten_depth','ssw_atten_depth',domain=Domain%domain2d)
        if (sbc_opt == -1) call mpp_error(FATAL,&
        '==>Error in ocean_shortwave_csiro_mod: failure to find ssw_atten_depth data file')

        ! update depth in case of restart
        depth_data = 0.0
        call time_interp_external(sbc_opt, Time%model_time, depth_data, verbose=debug_this_module)
        do j=jsc,jec
           do i=isc,iec
              ssw_atten_depth(i,j) = depth_data(i,j)
           enddo
        enddo

    else
        call mpp_error(NOTE, '==>Note: Setting depth=depth_default in shortwave_csiro_init.')
    endif

    if(sw_frac_top==0.0) then 
        write(stdoutunit,*) &
        '=>Note: computing solar shortwave penetration. Assume stf has sw-radiation field'
        write(stdoutunit,*) &
        '  included.  Hence, solar shortwave penetration effects placed in sw_source will '
        write(stdoutunit,*) &
        '  subtract out the effects of shortwave at k=1 to avoid double-counting.'
    elseif(sw_frac_top==1.0) then 
        write(stdoutunit,*) &
        '=>Note: computing solar shortwave penetration. Assume stf does not have sw-radiation'
        write(stdoutunit,*) &
        ' field included.  Shortwave penetration effects are placed completely in sw_source.'
        write(stdoutunit,*) &
        ' This is not the standard approach used in MOM.'
    elseif(sw_frac_top/=1.0 .and. sw_frac_top/=0.0) then 
        write(stdoutunit,*) &
        '=>Note: Computing solar shortwave penetration. Assume a portion of sw-effects are'
        write(stdoutunit,*) &
        '  included in stf and a portion in sw_source.  Are you sure you wish to do this?'
    endif

    if(enforce_sw_frac) then  
        write(stdoutunit,*) &
        '=>Note: enforce_sw_frac=.true. enforcing monotonic decrease of sw_frac with depth.'
    else 
        write(stdoutunit,*) &
        '=>Note: enforce_sw_frac=.false. non-monotonic sw_frac w/ some penetration profiles.'
    endif

    if(sw_pen_fixed_depths) then
        write(stdoutunit,*) &
        ' ==>Warning: sw_pen_fixed_depths=.true. is unsuitable for time varying thicknesses.'
        write(stdoutunit,*)&
        '             Time varying thicknesses are the norm in MOM, so recommend'
        write(stdoutunit,*) &
        '             setting sw_pen_fixed_depths=.false.  However, to reproduce MOM4.0'
        write(stdoutunit,*) &
        '             algorithm, then set sw_pen_fixed_depths=.true.' 
    endif

#ifndef MOM_STATIC_ARRAYS
    deallocate(depth_data)
#endif


end subroutine ocean_shortwave_csiro_init
! </SUBROUTINE> NAME="ocean_shortwave_csiro_init"



!#######################################################################
! <SUBROUTINE NAME="sw_source_csiro">
!
! <DESCRIPTION>
! Add short wave penetrative heating to T_prog(index_temp)%th_tendency.
!
! Note that the divergence of shortwave for the first
! level "div_sw(0)" is compensating for the effect of having
! the shortwave component already included in the total
! surface tracer flux "stf(i,j,temp)"
!
! </DESCRIPTION>
subroutine sw_source_csiro (Time, Thickness, T_diag, swflx, index_irr, Temp, sw_frac_zt)

  type(ocean_time_type),         intent(in)    :: Time
  type(ocean_thickness_type),    intent(in)    :: Thickness
  type(ocean_diag_tracer_type),   intent(inout) :: T_diag(:)
  real, dimension(isd:,jsd:) ,   intent(in)    :: swflx
  integer,                        intent(in)    :: index_irr
  type(ocean_prog_tracer_type),  intent(inout) :: Temp
  real, dimension(isd:,jsd:,:),  intent(inout) :: sw_frac_zt

  real, dimension(isd:ied,jsd:jed,0:nk)  :: sw_frac_zw
  real, dimension(isd:ied,jsd:jed)       :: zt_sw
  real, dimension(isd:ied,jsd:jed)       :: zw_sw
  real, dimension(isd:ied,jsd:jed)       :: depth_data
  real, dimension(isd:ied,jsd:jed)       :: sw_fk_zt  ! sw radiation fractional deacy on t-grid 
  real, dimension(isd:ied,jsd:jed)       :: sw_fk_zw  ! sw radiation fractional deacy on w-grid 

  real    :: div_sw 
  integer :: i, j, k

  ! zero out the wrk1 array used to diagnose heating from shortwave 
  Temp%wrk1(:,:,:) = 0.0

  if (.not. use_this_module) return 

  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_shortwave_csiro_mod (sw_source_csiro): module must be initialized ')
  endif 

  if (read_depth) then
    depth_data=0.0
    call time_interp_external(sbc_opt, Time%model_time, depth_data, verbose=debug_this_module)
    do j=jsc,jec
      do i=isc,iec
        ssw_atten_depth(i,j) = depth_data(i,j)
      enddo
    enddo
  endif

  ! zero out the fractional decay 
  sw_fk_zt(:,:) = 0.0
  sw_fk_zw(:,:) = 0.0

  ! only compute 3-D sw_fract for ocean regions shallower than zmax_pen 
  zw_sw=0.0
  zt_sw=0.0
  sw_frac_zw(:,:,0) = sw_frac_top

  do k=1,nk-1

     if(sw_pen_fixed_depths) then 

         if(Grd%zw(k) <= zmax_pen) then 
             zw_sw(isc:iec,jsc:jec) = Grd%zw(k)
             call sw_pen(zw_sw, sw_fk_zw)
             zt_sw(isc:iec,jsc:jec) = Grd%zt(k)
             call sw_pen(zt_sw, sw_fk_zt)
         else
             sw_fk_zt(:,:) = 0.0
             sw_fk_zw(:,:) = 0.0
         endif

     else 

         do j=jsc,jec
            do i=isc,iec
               zw_sw(i,j) = Thickness%depth_zwt(i,j,k)
               zt_sw(i,j) = Thickness%depth_zt(i,j,k)
            enddo
         enddo
         call sw_pen(zw_sw, sw_fk_zw)
         call sw_pen(zt_sw, sw_fk_zt)  

     endif

     sw_frac_zt(:,:,k) = sw_fk_zt(:,:)
     sw_frac_zw(:,:,k) = sw_fk_zw(:,:)

  enddo

  if(enforce_sw_frac) then   
      do k=2,nk-1
         do j=jsc,jec
            do i=isc,iec
               sw_frac_zt(i,j,k) = min(sw_frac_zt(i,j,k),sw_frac_zt(i,j,k-1))
            enddo
         enddo
      enddo
  endif

  ! when chlorophyll is being read through T_diag (not from climatology).
  ! note that this irradiance tracer is only used in MOM for purpose of 
  ! diagnostics, such as in in the residency time module.  It is NOT used
  ! by the ocean biogeochemistry, which actually computes its own irradiance
  ! as a function of the opacity.  
  if (index_irr > 0) then 
      do k=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               T_diag(index_irr)%field(i,j,k) = swflx(i,j) * sw_frac_zt(i,j,k) 
            enddo
         enddo
      enddo
  endif

  ! compute and load heating rate.
  do k=1,nk-1
    do j=jsc,jec
      do i=isc,iec
        div_sw           = sw_frac_zw(i,j,k-1) - sw_frac_zw(i,j,k)*Grd%tmask(i,j,k+1)
        Temp%wrk1(i,j,k) = Grd%tmask(i,j,k)*swflx(i,j)*div_sw
      enddo
    enddo
  enddo

end subroutine sw_source_csiro
! </SUBROUTINE> NAME="sw_source_csiro"


!#######################################################################
! <SUBROUTINE NAME="sw_pen">
!
! <DESCRIPTION>
!  Absorbtion of shortwave radiation in the water assumes energy partitions
!  represented by a single exponential:
!
!  The exponentialsrepresents a parameterization of the
!  attenuation coefficient for light between 300 um and 750 um in the following
!  form:
!
!	E(z) = E(0) * exp(z/efold))
!       with z < 0 the ocean depth 
!
!  The "efold" s the efolding depth of the long and short
!  visable and ultra violet light.
!  efold will vary between 30 m in oligotrophic waters and 4 m in coastal
!  regions. 
!
!  If the thickness of the first ocean level "dzt(1)" is 50 meters,
!  then shortwave penetration does not do much. However, for finer 
!  vertical resolution, such as dzt(1) = 10 meters commonly used
!  in ocean climate models, the effect of shortwave heating can
!  be significant. This can be particularly noticable in the summer
!  hemisphere.
!
! </DESCRIPTION>
!
! <INFO>
!
! <NOTE>
!  The terms contributing to sw_fk(i,j) are depth independent
! </NOTE> 
!
! <NOTE>
!  Simpson and Dickey (1981) and others have argued between one and 
!  two exponentials for light between 300 um and 750 um.  
!  With vertical grid resolution of 5 meters or finer
!  for the upper 20 meters, a second exponential will make a difference.
! </NOTE> 
!
! </INFO>
!
subroutine sw_pen (z_sw, sw_fk)

  real, intent(in),    dimension(isd:,jsd:) :: z_sw     ! vertical depth
  real, intent(inout), dimension(isd:,jsd:) :: sw_fk    ! sw fractional decay

! flag for setting k of bottom of boundary layer           
  logical :: keep_going(isd:iec)                            
! introducing kb as 1d vector improves vector performance  
  integer, dimension(isc:iec) :: kb   
  integer, dimension(isc:iec) :: kb_old   

  real    :: swmax, swmin
  integer :: i, j, k

  integer :: stdoutunit 
  stdoutunit=stdout() 

  call mpp_clock_begin(id_sw_pen)  

  if(.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_shortwave_csiro_mod (sw_pen): module must be initialized')
  endif 

  ! split the i,j loops to allow vectorization in j-loop 
  do j=jsc,jec

     ! compute kb
     k = 0
     kb(:)=nk                                   
     keep_going(:) = .true.
     do while (k < nk .and. any(keep_going(:))) 
        k = k+1
        do  i=isc,iec
           if (z_sw(i,j) <= Grd%zw(k) .and.  keep_going(i)) then   
               kb(i) = k
               keep_going(i) = .false.
           endif
        enddo
     enddo
     do i=isc,iec
       kb(i)=min(kb(i)+1,nk)
     enddo

     ! check with older (non-vectorized) method for kb calculation
     if(debug_this_module) then 
         do i=isc,iec 
            kb_old(i) = ceiling(frac_index(z_sw(i,j), (/0.,Grd%zw(1:nk)/)))
            kb_old(i) = min(kb_old(i),nk)
         enddo
         do i=isc,iec 
            if(kb(i) - kb_old(i) /= 0) then 
                write(stdoutunit,*) &
                'In sw_pen, kb computed two ways: kbnew(',i+Dom%ioff,',',j+Dom%joff,')= ', kb(i), &
                ' kbold(',i+Dom%ioff,',',j+Dom%joff,')= ',kb_old(i)
            endif
         enddo
     endif

     ! compute shortwave fraction based on sinle exponential 
     ! note that 0.02 and 60.0 provide a floor and ceiling which 
     ! keep sw_fk between 0.0 and 1.0.  These values are dependent
     ! on details of the coefficients used in the exponential. 
     ! If the coefficients change, then the floor/ceiling needs 
     ! to be reevaluated. shortwave fraction set to zero for 
     ! depths greater than zmax_pen.
     do i=isc,iec

        if ( z_sw(i,j) > zmax_pen .or. Grd%tmask(i,j,kb(i)) == 0) then
            sw_fk(i,j) = 0.0
        else

            sw_fk(i,j) =   F_vis  * exp( -z_sw(i,j)/ssw_atten_depth(i,j) ) 
        endif

     enddo  ! i-loop finish 

  enddo  ! j-loop finish

  if(debug_this_module) then 
      swmax=maxval(sw_fk(isc:iec,jsc:jec))
      call mpp_max(swmax);write(stdoutunit,*)'In ocean_shortwave_csiro (sw_pen): max sw_fk=',swmax
      swmin=maxval(sw_fk(isc:iec,jsc:jec))
      call mpp_min(swmin);write(stdoutunit,*)'In ocean_shortwave_csiro (sw_pen): min sw_fk=',swmin
  endif
  call mpp_clock_end(id_sw_pen)

end subroutine sw_pen
! </SUBROUTINE> NAME="sw_pen"


end module ocean_shortwave_csiro_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL
 
!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: radar_simulator_types.F90,v 20.0 2013/12/13 23:16:52 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2
 
#endif

  module radar_simulator_types

! Collection of common variables and types
! Part of QuickBeam v1.03 by John Haynes
! http://reef.atmos.colostate.edu/haynes/radarsim

  integer, parameter ::       &
  maxhclass = 20         ,& ! max number of hydrometeor classes
  nd = 85           ,& ! number of discrete particles  
  nRe_types = 250        ! number or Re size bins allowed in N and Z_scaled look up table

  real*8, parameter ::        &
  dmin = 0.1                 ,& ! min size of discrete particle
  dmax = 10000.                    ! max size of discrete particle
   
  integer, parameter :: &
  mt_nfreq = 5              , &
  mt_ntt = 39               , &    ! num temperatures in table
  mt_nf   = 14          , &   ! number of ice fractions in table  
  mt_nd = 85                   ! num discrete mode-p drop sizes in table


! ---- hydrometeor class type -----  
  
  type class_param
    real*8,  dimension(maxhclass) :: p1,p2,p3,dmin,dmax,apm,bpm,rho
    integer, dimension(maxhclass) :: dtype,col,cp,phase
    logical, dimension(maxhclass,nRe_types) :: scaled
    logical, dimension(maxhclass,mt_ntt,nRe_types) :: z_flag
    real*8,  dimension(maxhclass,mt_ntt,nRe_types) :: Ze_scaled,Zr_scaled,kr_scaled
    real*8,  dimension(maxhclass,nd,nRe_types) :: fc, rho_eff
    integer, dimension(maxhclass,nd,nRe_types) :: ifc
    integer, dimension(maxhclass) :: idd
  end type class_param

! ----- mie table structure -----
  
  type mie
    real*8 :: freq(mt_nfreq), tt(mt_ntt), f(mt_nf), D(mt_nd)
    real*8, dimension(mt_nd,mt_ntt,mt_nf,mt_nfreq) :: qext, qbsca
    integer :: phase(mt_ntt)
  end type mie

  real*8, dimension(:), allocatable :: &
    mt_qext, mt_qbsca         ! extincion/backscatter efficiency
  
  real*8 :: &
    mt_ttl(20), &        ! liquid temperatures (C)
    mt_tti(19)           ! ice temperatures (C)

  integer*4 :: &
    cnt_liq, &           ! liquid temperature count
    cnt_ice              ! ice temperature count

  end module radar_simulator_types

module horiz_interp_bicubic_mod

  use mpp_mod,               only: mpp_error, FATAL, stdout, mpp_pe, mpp_root_pe
  use fms_mod,               only: write_version_number
  use horiz_interp_type_mod, only: horiz_interp_type
  use constants_mod,         only: PI

  
 implicit none

! This module delivers methods for bicubic interpolation from a
! coarse regular grid on a fine regular grid.
! Subroutines
!
!       bcuint
!       bcucof
! 
! are methods taken from
!
!       W. H. Press, S. A. Teukolski, W. T. Vetterling and B. P. Flannery,
!       Numerical Recipies in FORTRAN, The Art of Scientific Computing.
!       Cambridge University Press, 1992
!       
! written by
!       martin.schmidt@io-warnemuende.de (2004)
! revied by
!       martin.schmidt@io-warnemuende.de (2004)
!
! Version 1.0.0.2005-07-06
! The module is thought to interact with MOM-4. 
! Alle benotigten Felder werden extern von MOM verwaltet, da sie
! nicht fur alle interpolierten Daten die gleiche Dimension haben mussen.

   private
   
   public  :: horiz_interp_bicubic, horiz_interp_bicubic_new, horiz_interp_bicubic_del, fill_xy
   public  :: horiz_interp_bicubic_init   

  interface horiz_interp_bicubic_new
    module procedure horiz_interp_bicubic_new_1d
    module procedure horiz_interp_bicubic_new_1d_s
  end interface

   character(len=128) :: version="$Id$"
   character(len=128) :: tagname = '$Name$'
   logical            :: module_is_initialized = .FALSE.
   integer            :: verbose_bicubic = 0
   
!     Grid variables
!     xc, yc : co-ordinates of the coarse grid
!     xf, yf : co-ordinates of the fine grid
!     fc     : variable to be interpolated at the coarse grid
!     dfc_x  : x-derivative of fc at the coarse grid 
!     dfc_y  : y-derivative of fc at the coarse grid 
!     dfc_xy : x-y-derivative of fc at the coarse grid 
!     ff     : variable to be interpolated at the fine grid
!     dff_x  : x-derivative of fc at the fine grid 
!     dff_y  : y-derivative of fc at the fine grid 
!     dff_xy : x-y-derivative of fc at the fine grid 
      

   logical            :: initialized_bicubic = .false.
   
   
   real, save         :: missing = -1e33 
   real               :: tpi  
 
   interface fill_xy
      module procedure fill_xy
   end interface

   
   contains

  !#######################################################################
  !  <SUBROUTINE NAME="horiz_interp_bicubic_init">
  !  <OVERVIEW>
  !     writes version number and tag name to logfile.out
  !  </OVERVIEW>
  !  <DESCRIPTION>       
  !     writes version number and tag name to logfile.out
  !  </DESCRIPTION>

  subroutine horiz_interp_bicubic_init

     if(module_is_initialized) return
     call write_version_number (version, tagname)
     module_is_initialized = .true.
     tpi = 2.0*PI

  end subroutine horiz_interp_bicubic_init

  !  </SUBROUTINE>

  !#######################################################################
  ! <SUBROUTINE NAME="horiz_interp_bicubic_new">

  !   <OVERVIEW>
  !      Initialization routine.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !      Allocates space and initializes a derived-type variable
  !      that contains pre-computed interpolation indices and weights.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call horiz_interp_bicubic_new ( Interp, lon_in, lat_in, lon_out, lat_out, verbose_bicubic, src_modulo )

  !   </TEMPLATE>
  !   
  !   <IN NAME="lon_in" TYPE="real, dimension(:,:)" UNITS="radians">
  !      Longitude (in radians) for source data grid. 
  !   </IN>

  !   <IN NAME="lat_in" TYPE="real, dimension(:,:)" UNITS="radians">
  !      Latitude (in radians) for source data grid.
  !   </IN>

  !   <IN NAME="lon_out" TYPE="real, dimension(:,:)" UNITS="radians" >
  !      Longitude (in radians) for source data grid. 
  !   </IN>

  !   <IN NAME="lat_out" TYPE="real, dimension(:,:)" UNITS="radians" >
  !      Latitude (in radians) for source data grid. 
  !   </IN>

  !   <IN NAME="src_modulo" TYPE="logical, optional">
  !      logical variable to indicate if the boundary condition along zonal boundary
  !      is cyclic or not. When true, the zonal boundary condition is cyclic.
  !   </IN>

  !   <IN NAME="verbose_bicubic" TYPE="integer, optional" >
  !      flag for the amount of print output.
  !   </IN>

  !   <INOUT NAME="Interp" TYPE="type(horiz_interp_type)" >
  !      A derived-type variable containing indices and weights used for subsequent 
  !      interpolations. To reinitialize this variable for a different grid-to-grid 
  !      interpolation you must first use the "horiz_interp_bicubic_del" interface.
  !   </INOUT>

  subroutine horiz_interp_bicubic_new_1d_s ( Interp, lon_in, lat_in, lon_out, lat_out, &
       verbose, src_modulo )

    !-----------------------------------------------------------------------
    type(horiz_interp_type), intent(inout) :: Interp
    real, intent(in),  dimension(:)        :: lon_in , lat_in
    real, intent(in),  dimension(:,:)      :: lon_out, lat_out
    integer, intent(in),          optional :: verbose
    logical, intent(in),          optional :: src_modulo
    integer                                :: i, j, ip1, im1, jp1, jm1 
    logical                                :: src_is_modulo
    integer                                :: nlon_in, nlat_in, nlon_out, nlat_out
    integer                                :: jcl, jcu, icl, icu, jj
    real                                   :: xz, yz
    integer                                :: unit
  
    if(present(verbose)) verbose_bicubic = verbose
    src_is_modulo = .false. 
    if (present(src_modulo)) src_is_modulo = src_modulo

    if(size(lon_out,1) /= size(lat_out,1) .or. size(lon_out,2) /= size(lat_out,2) ) &
         call mpp_error(FATAL,'horiz_interp_bilinear_mod: when using bilinear ' // &
         'interplation, the output grids should be geographical grids')    

    !--- get the grid size 
    nlon_in  = size(lon_in)   ; nlat_in  = size(lat_in)
    nlon_out = size(lon_out,1); nlat_out = size(lat_out,2)
    Interp%nlon_src = nlon_in;  Interp%nlat_src = nlat_in
    Interp%nlon_dst = nlon_out; Interp%nlat_dst = nlat_out
!   use wti(:,:,1) for x-derivative, wti(:,:,2) for y-derivative, wti(:,:,3) for xy-derivative  
    allocate ( Interp%wti    (nlon_in, nlat_in, 3) )
    allocate ( Interp%lon_in (nlon_in) )
    allocate ( Interp%lat_in (nlat_in) )
    allocate ( Interp%rat_x  (nlon_out, nlat_out) )
    allocate ( Interp%rat_y  (nlon_out, nlat_out) )
    allocate ( Interp%i_lon  (nlon_out, nlat_out, 2) )
    allocate ( Interp%j_lat  (nlon_out, nlat_out, 2) )
    
    Interp%lon_in = lon_in
    Interp%lat_in = lat_in

    if ( verbose_bicubic > 0 ) then
       unit = stdout()
       write (unit,'(/,"Initialising bicubic interpolation, interface horiz_interp_bicubic_new_1d_s")')
       write (unit,'(/," Longitude of coarse grid points (radian): xc(i) i=1, ",i4)') Interp%nlon_src
       write (unit,'(1x,10f10.4)') (Interp%lon_in(jj),jj=1,Interp%nlon_src)
       write (unit,'(/," Latitude of coarse grid points (radian):  yc(j) j=1, ",i4)') Interp%nlat_src
       write (unit,'(1x,10f10.4)') (Interp%lat_in(jj),jj=1,Interp%nlat_src)
       do i=1, Interp%nlat_dst
         write (unit,*)
         write (unit,'(/," Longitude of fine grid points (radian): xf(i) i=1, ",i4)') Interp%nlat_dst
         write (unit,'(1x,10f10.4)') (lon_out(jj,i),jj=1,Interp%nlon_dst)
       enddo
       do i=1, Interp%nlon_dst 
         write (unit,*)
         write (unit,'(/," Latitude of fine grid points (radian):  yf(j) j=1, ",i4)') Interp%nlon_dst
         write (unit,'(1x,10f10.4)') (lat_out(i,jj),jj=1,Interp%nlat_dst)
       enddo
    endif  
      

!---------------------------------------------------------------------------
!     Find the x-derivative. Use central differences and forward or
!     backward steps at the boundaries
    
    do j=1,nlat_in
      do i=1,nlon_in
        ip1=min(i+1,nlon_in)
        im1=max(i-1,1)
        Interp%wti(i,j,1) = 1./(Interp%lon_in(ip1)-Interp%lon_in(im1))
      enddo
    enddo
      
      
!---------------------------------------------------------------------------
     
!     Find the y-derivative. Use central differences and forward or
!     backward steps at the boundaries
      do j=1,nlat_in
        jp1=min(j+1,nlat_in)
        jm1=max(j-1,1)
        do i=1,nlon_in
          Interp%wti(i,j,2) = 1./(Interp%lat_in(jp1)-Interp%lat_in(jm1))
        enddo
      enddo
   
!---------------------------------------------------------------------------
     
!     Find the xy-derivative. Use central differences and forward or
!     backward steps at the boundaries
      do j=1,nlat_in
        jp1=min(j+1,nlat_in)
        jm1=max(j-1,1)
        do i=1,nlon_in
          ip1=min(i+1,nlon_in)
          im1=max(i-1,1)
          Interp%wti(i,j,3) = 1./((Interp%lon_in(ip1)-Interp%lon_in(im1))*(Interp%lat_in(jp1)-Interp%lat_in(jm1)))
        enddo
      enddo
!---------------------------------------------------------------------------
!     Now for each point at the dest-grid find the boundary points of 
!     the source grid
      do j=1, nlat_out
        do i=1,nlon_out
          yz  = lat_out(i,j)
          xz  = lon_out(i,j)

          jcl = 0
          jcu = 0
          if( yz .le. Interp%lat_in(1) ) then
             jcl = 1
             jcu = 1
          else if( yz .ge. Interp%lat_in(nlat_in) ) then
             jcl = nlat_in
             jcu = nlat_in
          else
             jcl = indl(Interp%lat_in, yz) 
             jcu = indu(Interp%lat_in, yz)
          endif

          icl = 0
          icu = 0
          !--- cyclic condition, do we need to use do while
          if( xz .gt. Interp%lon_in(nlon_in) ) xz = xz - tpi
          if( xz .le. Interp%lon_in(1) ) xz = xz + tpi
          if( xz .ge. Interp%lon_in(nlon_in) ) then
            icl = nlon_in
            icu = 1
            Interp%rat_x(i,j) = (xz - Interp%lon_in(icl))/(Interp%lon_in(icu) - Interp%lon_in(icl) + tpi)
          else 
            icl = indl(Interp%lon_in, xz) 
            icu = indu(Interp%lon_in, xz) 
            Interp%rat_x(i,j) = (xz - Interp%lon_in(icl))/(Interp%lon_in(icu) - Interp%lon_in(icl))
          endif
          Interp%j_lat(i,j,1) = jcl
          Interp%j_lat(i,j,2) = jcu
          Interp%i_lon(i,j,1) = icl 
          Interp%i_lon(i,j,2) = icu 
          if(jcl == jcu) then
             Interp%rat_y(i,j) = 0.0
          else
             Interp%rat_y(i,j) = (yz - Interp%lat_in(jcl))/(Interp%lat_in(jcu) - Interp%lat_in(jcl))
          endif
!          if(yz.gt.Interp%lat_in(jcu)) call mpp_error(FATAL, ' horiz_interp_bicubic_new_1d_s: yf < ycl, no valid boundary point')
!          if(yz.lt.Interp%lat_in(jcl)) call mpp_error(FATAL, ' horiz_interp_bicubic_new_1d_s: yf > ycu, no valid boundary point')
!          if(xz.gt.Interp%lon_in(icu)) call mpp_error(FATAL, ' horiz_interp_bicubic_new_1d_s: xf < xcl, no valid boundary point')
!          if(xz.lt.Interp%lon_in(icl)) call mpp_error(FATAL, ' horiz_interp_bicubic_new_1d_s: xf > xcu, no valid boundary point')
        enddo
      enddo
  end subroutine horiz_interp_bicubic_new_1d_s
  ! </SUBROUTINE>
  subroutine horiz_interp_bicubic_new_1d ( Interp, lon_in, lat_in, lon_out, lat_out, &
       verbose, src_modulo )

    !-----------------------------------------------------------------------
    type(horiz_interp_type), intent(inout) :: Interp
    real, intent(in),  dimension(:)        :: lon_in , lat_in
    real, intent(in),  dimension(:)        :: lon_out, lat_out
    integer, intent(in),          optional :: verbose
    logical, intent(in),          optional :: src_modulo
    integer                                :: i, j, ip1, im1, jp1, jm1 
    logical                                :: src_is_modulo
    integer                                :: nlon_in, nlat_in, nlon_out, nlat_out
    integer                                :: jcl, jcu, icl, icu, jj
    real                                   :: xz, yz
    integer                                :: unit

    if(present(verbose)) verbose_bicubic = verbose
    src_is_modulo = .false. 
    if (present(src_modulo)) src_is_modulo = src_modulo

    !--- get the grid size 
    nlon_in  = size(lon_in) ; nlat_in  = size(lat_in)
    nlon_out = size(lon_out); nlat_out = size(lat_out)
    Interp%nlon_src = nlon_in;  Interp%nlat_src = nlat_in
    Interp%nlon_dst = nlon_out; Interp%nlat_dst = nlat_out
    allocate ( Interp%wti     (nlon_in, nlat_in, 3) )
    allocate ( Interp%lon_in  (nlon_in) )
    allocate ( Interp%lat_in  (nlat_in) )
    allocate ( Interp%rat_x   (nlon_out, nlat_out) )
    allocate ( Interp%rat_y   (nlon_out, nlat_out) )
    allocate ( Interp%i_lon   (nlon_out, nlat_out, 2) )
    allocate ( Interp%j_lat   (nlon_out, nlat_out, 2) )
    
    Interp%lon_in = lon_in
    Interp%lat_in = lat_in

    if ( verbose_bicubic > 0 ) then
       unit = stdout()
       write (unit,'(/,"Initialising bicubic interpolation, interface horiz_interp_bicubic_new_1d")')
       write (unit,'(/," Longitude of coarse grid points (radian): xc(i) i=1, ",i4)') Interp%nlon_src
       write (unit,'(1x,10f10.4)') (Interp%lon_in(jj),jj=1,Interp%nlon_src)
       write (unit,'(/," Latitude of coarse grid points (radian):  yc(j) j=1, ",i4)') Interp%nlat_src
       write (unit,'(1x,10f10.4)') (Interp%lat_in(jj),jj=1,Interp%nlat_src)
       write (unit,*)
       write (unit,'(/," Longitude of fine grid points (radian): xf(i) i=1, ",i4)') Interp%nlat_dst
       write (unit,'(1x,10f10.4)') (lon_out(jj),jj=1,Interp%nlon_dst)
       write (unit,'(/," Latitude of fine grid points (radian):  yf(j) j=1, ",i4)') Interp%nlon_dst
       write (unit,'(1x,10f10.4)') (lat_out(jj),jj=1,Interp%nlat_dst)
    endif  
      

!---------------------------------------------------------------------------
!     Find the x-derivative. Use central differences and forward or
!     backward steps at the boundaries
    
    do j=1,nlat_in
      do i=1,nlon_in
        ip1=min(i+1,nlon_in)
        im1=max(i-1,1)
        Interp%wti(i,j,1) = 1./(lon_in(ip1)-lon_in(im1))
      enddo
    enddo
      
      
!---------------------------------------------------------------------------
     
!     Find the y-derivative. Use central differences and forward or
!     backward steps at the boundaries
      do j=1,nlat_in
        jp1=min(j+1,nlat_in)
        jm1=max(j-1,1)
        do i=1,nlon_in
          Interp%wti(i,j,2) = 1./(lat_in(jp1)-lat_in(jm1))
        enddo
      enddo
   
!---------------------------------------------------------------------------
     
!     Find the xy-derivative. Use central differences and forward or
!     backward steps at the boundaries
      do j=1,nlat_in
        jp1=min(j+1,nlat_in)
        jm1=max(j-1,1)
        do i=1,nlon_in
          ip1=min(i+1,nlon_in)
          im1=max(i-1,1)
          Interp%wti(i,j,3) = 1./((lon_in(ip1)-lon_in(im1))*(lat_in(jp1)-lat_in(jm1)))
        enddo
      enddo
!---------------------------------------------------------------------------
!     Now for each point at the dest-grid find the boundary points of 
!     the source grid
      do j=1, nlat_out
        yz  = lat_out(j)
        jcl = 0
        jcu = 0
        if( yz .le. lat_in(1) ) then
           jcl = 1
           jcu = 1
        else if( yz .ge. lat_in(nlat_in) ) then
           jcl = nlat_in
           jcu = nlat_in
        else
           jcl = indl(lat_in, yz) 
           jcu = indu(lat_in, yz)
        endif
        do i=1,nlon_out
          xz = lon_out(i)
          icl = 0
          icu = 0
         !--- cyclic condition, do we need to use do while
          if( xz .gt. lon_in(nlon_in) ) xz = xz - tpi
          if( xz .le. lon_in(1) ) xz = xz + tpi
          if( xz .ge. lon_in(nlon_in) ) then
            icl = nlon_in
            icu = 1
            Interp%rat_x(i,j) = (xz - Interp%lon_in(icl))/(Interp%lon_in(icu) - Interp%lon_in(icl) + tpi)
          else 
            icl = indl(lon_in, xz) 
            icu = indu(lon_in, xz) 
            Interp%rat_x(i,j) = (xz - Interp%lon_in(icl))/(Interp%lon_in(icu) - Interp%lon_in(icl))
          endif
          icl = indl(lon_in, xz) 
          icu = indu(lon_in, xz) 
          Interp%j_lat(i,j,1) = jcl
          Interp%j_lat(i,j,2) = jcu
          Interp%i_lon(i,j,1) = icl 
          Interp%i_lon(i,j,2) = icu 
          if(jcl == jcu) then
             Interp%rat_y(i,j) = 0.0
          else
             Interp%rat_y(i,j) = (yz - Interp%lat_in(jcl))/(Interp%lat_in(jcu) - Interp%lat_in(jcl))
          endif
!          if(yz.gt.lat_in(jcu)) call mpp_error(FATAL, ' horiz_interp_bicubic_new_1d: yf < ycl, no valid boundary point')
!          if(yz.lt.lat_in(jcl)) call mpp_error(FATAL, ' horiz_interp_bicubic_new_1d: yf > ycu, no valid boundary point')
!          if(xz.gt.lon_in(icu)) call mpp_error(FATAL, ' horiz_interp_bicubic_new_1d: xf < xcl, no valid boundary point')
!          if(xz.lt.lon_in(icl)) call mpp_error(FATAL, ' horiz_interp_bicubic_new_1d: xf > xcu, no valid boundary point')
        enddo
      enddo

  end subroutine horiz_interp_bicubic_new_1d
   
  subroutine horiz_interp_bicubic( Interp, data_in, data_out, verbose, mask_in, mask_out, missing_value, missing_permit)
    type (horiz_interp_type), intent(in)        :: Interp
    real, intent(in),  dimension(:,:)           :: data_in
    real, intent(out), dimension(:,:)           :: data_out
    integer, intent(in),               optional :: verbose
    real, intent(in),  dimension(:,:), optional :: mask_in
    real, intent(out), dimension(:,:), optional :: mask_out
    real, intent(in),                  optional :: missing_value
    integer, intent(in),               optional :: missing_permit
    real :: yz, ycu, ycl
    real :: xz, xcu, xcl
    real :: val, val1, val2
    real, dimension(4) :: y, y1, y2, y12
    integer :: icl, icu, jcl, jcu
    integer :: iclp1, icup1, jclp1, jcup1
    integer :: iclm1, icum1, jclm1, jcum1
    integer :: i,j
         
    if ( present(verbose) ) verbose_bicubic = verbose
!    fill_in = .false.
!    if ( present(fill) ) fill_in = fill
!   use dfc_x and dfc_y as workspace      
!    if ( fill_in ) call fill_xy(fc(ics:ice,jcs:jce), ics, ice, jcs, jce, maxpass=2)
!    where ( data_in .le. missing ) data_in(:,:) = 0.
!!  
    do j=1, Interp%nlat_dst
      do i=1, Interp%nlon_dst
        yz  = Interp%rat_y(i,j)
        xz  = Interp%rat_x(i,j)
        jcl = Interp%j_lat(i,j,1)
        jcu = Interp%j_lat(i,j,2)
        icl = Interp%i_lon(i,j,1)
        icu = Interp%i_lon(i,j,2)
        if( icl > icu ) then
          iclp1 = icu
          icum1 = icl
          xcl = Interp%lon_in(icl)
          xcu = Interp%lon_in(icu)+tpi
        else
          iclp1 = min(icl+1,Interp%nlon_src)
          icum1 = max(icu-1,1)
          xcl = Interp%lon_in(icl)
          xcu = Interp%lon_in(icu)
        endif
        iclm1 = max(icl-1,1)
        icup1 = min(icu+1,Interp%nlon_src)
        jclp1 = min(jcl+1,Interp%nlat_src)
        jclm1 = max(jcl-1,1)
        jcup1 = min(jcu+1,Interp%nlat_src)
        jcum1 = max(jcu-1,1)
        ycl = Interp%lat_in(jcl)
        ycu = Interp%lat_in(jcu)
!        xcl = Interp%lon_in(icl)
!        xcu = Interp%lon_in(icu)
        y(1)  =  data_in(icl,jcl)
        y(2)  =  data_in(icu,jcl)
        y(3)  =  data_in(icu,jcu)
        y(4)  =  data_in(icl,jcu)
        y1(1) = ( data_in(iclp1,jcl) - data_in(iclm1,jcl) ) * Interp%wti(icl,jcl,1)
        y1(2) = ( data_in(icup1,jcl) - data_in(icum1,jcl) ) * Interp%wti(icu,jcl,1)
        y1(3) = ( data_in(icup1,jcu) - data_in(icum1,jcu) ) * Interp%wti(icu,jcu,1)
        y1(4) = ( data_in(iclp1,jcu) - data_in(iclm1,jcu) ) * Interp%wti(icl,jcu,1)
        y2(1) = ( data_in(icl,jclp1) - data_in(icl,jclm1) ) * Interp%wti(icl,jcl,2)
        y2(2) = ( data_in(icu,jclp1) - data_in(icu,jclm1) ) * Interp%wti(icu,jcl,2)
        y2(3) = ( data_in(icu,jcup1) - data_in(icu,jcum1) ) * Interp%wti(icu,jcu,2)
        y2(4) = ( data_in(icl,jcup1) - data_in(icl,jcum1) ) * Interp%wti(icl,jcu,2)
        y12(1)= ( data_in(iclp1,jclp1) + data_in(iclm1,jclm1) - data_in(iclm1,jclp1) &
                - data_in(iclp1,jclm1) ) * Interp%wti(icl,jcl,3)
        y12(2)= ( data_in(icup1,jclp1) + data_in(icum1,jclm1) - data_in(icum1,jclp1) &
                - data_in(icup1,jclm1) ) * Interp%wti(icu,jcl,3)
        y12(3)= ( data_in(icup1,jcup1) + data_in(icum1,jcum1) - data_in(icum1,jcup1) &
                - data_in(icup1,jcum1) ) * Interp%wti(icu,jcu,3)
        y12(4)= ( data_in(iclp1,jcup1) + data_in(iclm1,jcum1) - data_in(iclm1,jcup1) &
                - data_in(iclp1,jcum1) ) * Interp%wti(icl,jcu,3)
        
        call bcuint(y,y1,y2,y12,xcl,xcu,ycl,ycu,xz,yz,val,val1,val2) 
        data_out   (i,j) = val
        if(present(mask_out)) mask_out(i,j) = 1.
!!        dff_x(i,j) = val1
!!        dff_y(i,j) = val2
      enddo
    enddo
  return
  end subroutine horiz_interp_bicubic
     
   
!---------------------------------------------------------------------------
     
   subroutine bcuint(y,y1,y2,y12,x1l,x1u,x2l,x2u,t,u,ansy,ansy1,ansy2)
      real ansy,ansy1,ansy2,x1l,x1u,x2l,x2u,y(4),y1(4),y12(4),y2(4)
!     uses bcucof
      integer i
      real t,u,c(4,4)
      call bcucof(y,y1,y2,y12,x1u-x1l,x2u-x2l,c)
      ansy=0.
      ansy2=0.
      ansy1=0.
      do i=4,1,-1
        ansy=t*ansy+((c(i,4)*u+c(i,3))*u+c(i,2))*u+c(i,1)
!        ansy2=t*ansy2+(3.*c(i,4)*u+2.*c(i,3))*u+c(i,2)
!        ansy1=u*ansy1+(3.*c(4,i)*t+2.*c(3,i))*t+c(2,i)
      enddo
!      ansy1=ansy1/(x1u-x1l) ! could be used for accuracy checks
!      ansy2=ansy2/(x2u-x2l) ! could be used for accuracy checks
      return
!  (c) copr. 1986-92 numerical recipes software -3#(-)f.
   end subroutine bcuint
!---------------------------------------------------------------------------
     
   subroutine bcucof(y,y1,y2,y12,d1,d2,c)
      real d1,d2,c(4,4),y(4),y1(4),y12(4),y2(4)
      integer i,j,k,l
      real d1d2,xx,cl(16),wt(16,16),x(16)
      save wt
      data wt/1., 0., -3., 2., 4*0., -3., 0., 9., -6., 2., 0., -6., 4., 8*0., &
              3., 0., -9., 6., -2., 0., 6., -4., 10*0., 9., -6., 2*0., -6., &
              4., 2*0., 3., -2., 6*0., -9., 6., 2*0., 6., -4., 4*0., 1., 0., &
              -3., 2., -2., 0., 6., -4., 1., 0., -3., 2., 8*0., -1., 0., 3., &
              -2., 1., 0., -3., 2., 10*0., -3., 2., 2*0., 3., -2., 6*0., 3., &
              -2., 2*0., -6., 4., 2*0., 3., -2., 0., 1., -2., 1., 5*0., -3., &
              6., -3., 0., 2., -4., 2., 9*0., 3., -6., 3., 0., -2., 4., -2., &
              10*0., -3., 3., 2*0., 2., -2., 2*0., -1., 1., 6*0., 3., -3., &
              2*0., -2., 2., 5*0., 1., -2., 1., 0., -2., 4., -2., 0., 1., -2., &
              1., 9*0., -1., 2., -1., 0., 1., -2., 1., 10*0., 1., -1., 2*0., &
              -1., 1., 6*0., -1., 1., 2*0., 2., -2., 2*0., -1., 1./

      d1d2=d1*d2
      do i=1,4
        x(i)=y(i)
        x(i+4)=y1(i)*d1
        x(i+8)=y2(i)*d2
        x(i+12)=y12(i)*d1d2
      enddo
      do i=1,16
        xx=0.
        do k=1,16
          xx=xx+wt(i,k)*x(k)
        enddo
        cl(i)=xx
      enddo
      l=0
      do i=1,4
        do j=1,4
          l=l+1
          c(i,j)=cl(l)
        enddo
      enddo
      return
!  (c) copr. 1986-92 numerical recipes software -3#(-)f.
   end subroutine bcucof

!-----------------------------------------------------------------------

    function indl(xc, xf) 
! find the lower neighbour of xf in field xc, return is the index      
    real, intent(in) :: xc(1:)
    real, intent(in) :: xf
    integer             :: indl
    integer             :: ii
       indl = 1
       do ii=1, size(xc)
         if(xc(ii).gt.xf) return
         indl = ii
       enddo
       call mpp_error(FATAL,'Error in indl')
    return
    end function indl

!-----------------------------------------------------------------------
      
    function indu(xc, xf) 
! find the upper neighbour of xf in field xc, return is the index      
    real, intent(in) :: xc(1:)
    real, intent(in) :: xf
    integer             :: indu
    integer             :: ii
       do ii=1, size(xc)
         indu = ii
         if(xc(ii).gt.xf) return
       enddo
       call mpp_error(FATAL,'Error in indu')
    return
    end function indu
    
!-----------------------------------------------------------------------

    subroutine fill_xy(fi, ics, ice, jcs, jce, mask, maxpass)
      integer, intent(in)        :: ics,ice,jcs,jce
      real, intent(inout)        :: fi(ics:ice,jcs:jce)
      real, intent(in), optional :: mask(ics:ice,jcs:jce)
      integer, intent(in)        :: maxpass
      real                       :: work_old(ics:ice,jcs:jce)
      real                       :: work_new(ics:ice,jcs:jce)
      logical :: ready
      real    :: blank = -1.e30
      real    :: tavr
      integer :: ipass = 0
      integer :: inl, inr, jnl, jnu, i, j, is, js,  iavr
      
      
      ready = .false.

      work_new(:,:) = fi(:,:)
      work_old(:,:) = work_new(:,:)
      ipass = 0
      if ( present(mask) ) then
         do while (.not.ready)
           ipass = ipass+1
           ready = .true.
           do j=jcs, jce
             do i=ics, ice
               if (work_old(i,j).le.blank) then
                 tavr=0.
                 iavr=0
                 inl = max(i-1,ics)
                 inr = min(i+1,ice)
                 jnl = max(j-1,jcs)
                 jnu = min(j+1,jce)
                 do js=jnl,jnu
                   do is=inl,inr
                     if (work_old(is,js) .ne. blank .and. mask(is,js).ne.0.) then
                       tavr = tavr + work_old(is,js)
                       iavr = iavr+1
                     endif
                   enddo
                 enddo
                 if (iavr.gt.0) then
                   if (iavr.eq.1) then
! spreading is not allowed if the only valid neighbor is a corner point
! otherwise an ill posed cellular automaton is established leading to
! a spreading of constant values in diagonal direction
! if all corner points are blanked the valid neighbor must be a direct one
! and spreading is allowed
                     if (work_old(inl,jnu).eq.blank.and.&
                         work_old(inr,jnu).eq.blank.and.&
                         work_old(inr,jnl).eq.blank.and.&
                         work_old(inl,jnl).eq.blank) then
                           work_new(i,j)=tavr/iavr
                           ready = .false.
                     endif
                  else
                    work_new(i,j)=tavr/iavr
                    ready = .false.
                  endif
                endif
              endif
            enddo ! j
          enddo   ! i
! save changes made during this pass to work_old
          work_old(:,:)=work_new(:,:)
          if(ipass.eq.maxpass) ready=.true.
        enddo !while (.not.ready)
        fi(:,:) = work_new(:,:)
      else
         do while (.not.ready)
           ipass = ipass+1
           ready = .true.
           do j=jcs, jce
             do i=ics, ice
               if (work_old(i,j).le.blank) then
                 tavr=0.
                 iavr=0
                 inl = max(i-1,ics)
                 inr = min(i+1,ice)
                 jnl = max(j-1,jcs)
                 jnu = min(j+1,jce)
                 do is=inl,inr
                   do js=jnl,jnu
                     if (work_old(is,js).gt.blank) then
                       tavr = tavr + work_old(is,js)
                       iavr = iavr+1
                     endif
                   enddo
                 enddo
                 if (iavr.gt.0) then
                   if (iavr.eq.1) then
! spreading is not allowed if the only valid neighbor is a corner point
! otherwise an ill posed cellular automaton is established leading to
! a spreading of constant values in diagonal direction
! if all corner points are blanked the valid neighbor must be a direct one
! and spreading is allowed
                     if (work_old(inl,jnu).le.blank.and. &
                         work_old(inr,jnu).le.blank.and. &
                         work_old(inr,jnl).le.blank.and. &
                         work_old(inl,jnl).le.blank) then
                           work_new(i,j)=tavr/iavr
                           ready = .false.
                     endif
                  else
                    work_new(i,j)=tavr/iavr
                    ready = .false.
                  endif
                endif
              endif
            enddo ! j
          enddo   ! i
! save changes made during this pass to work_old
          work_old(:,:)=work_new(:,:)
          if(ipass.eq.maxpass) ready=.true.
        enddo !while (.not.ready)
        fi(:,:) = work_new(:,:)
      endif
      return
    end subroutine fill_xy      

  subroutine horiz_interp_bicubic_del( Interp )

    type (horiz_interp_type), intent(inout) :: Interp

    if(associated(Interp%rat_x))  deallocate ( Interp%rat_x )
    if(associated(Interp%rat_y))  deallocate ( Interp%rat_y )
    if(associated(Interp%lon_in)) deallocate ( Interp%lon_in )
    if(associated(Interp%lat_in)) deallocate ( Interp%lat_in )
    if(associated(Interp%i_lon))  deallocate ( Interp%i_lon )
    if(associated(Interp%j_lat))  deallocate ( Interp%j_lat )
    if(associated(Interp%wti))    deallocate ( Interp%wti )

  end subroutine horiz_interp_bicubic_del

end module horiz_interp_bicubic_mod

       

                    module sea_esf_rad_mod

! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   smf
! </REVIEWER>
! <REVIEWER EMAIL="">
!   
! </REVIEWER>
! <OVERVIEW>
!   Code to initialize, commpute, and clean up radiation calculation. 
! </OVERVIEW>
! <DESCRIPTION>
!   The radiation component that initializes, deployes, and ends longwave,
!   shortwave, and diagnostics calculation in the FMS model.
! </DESCRIPTION>

!  shared modules:

use mpp_mod,              only: input_nml_file
use fms_mod,              only: open_namelist_file, fms_init, &
                                mpp_pe, mpp_root_pe, stdlog, &
                                file_exist, write_version_number, &
                                check_nml_error, error_mesg, &
                                FATAL, close_file, &
                                mpp_clock_id, mpp_clock_begin, &
                                mpp_clock_end, CLOCK_ROUTINE, &
                                CLOCK_MODULE
use time_manager_mod,     only: time_manager_init, time_type

!  shared radiation package modules:

use rad_utilities_mod,    only: rad_utilities_init, Rad_control, &
                                radiative_gases_type, & 
                                cldrad_properties_type, &
                                cld_specification_type,  &
                                astronomy_type, atmos_input_type, &
                                surface_type, lw_diagnostics_type, &
                                aerosol_diagnostics_type, &
                                cld_space_properties_type, &
                                lw_table_type, &
                                aerosol_type, aerosol_properties_type,&
                                sw_output_type, lw_output_type, &
                                Sw_control, Lw_parameters

!   radiation package modules:

use radiation_diag_mod,   only: radiation_diag_init,   &
                                radiation_diag_driver, &
                                radiation_diag_end
use longwave_driver_mod,  only: longwave_driver_init,   &
                                longwave_driver_time_vary, &
                                longwave_driver, &
                                longwave_driver_endts, &
                                longwave_driver_end
use shortwave_driver_mod, only: shortwave_driver_init,  &
                                shortwave_driver,  &
                                shortwave_driver_end

!----------------------------------------------------------------------

implicit none 
private 

!-----------------------------------------------------------------------
!    sea_esf_rad_mod is the driver for the sea_esf_rad radiation 
!    package.
!-----------------------------------------------------------------------


!-----------------------------------------------------------------------
!------------ version number for this module ---------------------------

character(len=128) :: version = '$Id: sea_esf_rad.F90,v 19.0 2012/01/06 20:23:33 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'


!--------------------------------------------------------------------
!-- interfaces -----

public       &
            sea_esf_rad_init, sea_esf_rad, sea_esf_rad_time_vary,  &
            sea_esf_rad_endts,  sea_esf_rad_end


private      &

! called from sea_esf_rad:
             deallocate_arrays


!---------------------------------------------------------------------
!--- namelist ---

logical :: dummy


namelist /sea_esf_rad_nml/   &
                            dummy

!---------------------------------------------------------------------
!---- public data ----


!---------------------------------------------------------------------
!---- private data ----


logical :: module_is_initialized = .false.    ! module initialized ?
integer :: longwave_clock, shortwave_clock    ! timing clocks


!---------------------------------------------------------------------
!---------------------------------------------------------------------



                         contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!######################################################################
! <SUBROUTINE NAME="sea_esf_rad_init">
!   <OVERVIEW>
!     Routine to initialize the radiation calculation
!   </OVERVIEW>
!   <DESCRIPTION>
!     This routine initializes the utilities and radiation utilities
!     modules. Then it reads in the radiation namelist from the input
!     namelist file and log the namelist in an output log file.
!   </DESCRIPTION>
!   <TEMPLATE>
!     CALL sea_esf_rad_init (lonb, latb, pref_r)
!   </TEMPLATE>
!
!   <IN NAME="lonb" TYPE="real">
!     2d array of model longitudes at cell corners in [radians]
!   </IN>
!   <IN NAME="latb" TYPE="real">
!     2d array of model latitudes at cell corners in [radians]
!   </IN>
!   <IN NAME="pref_r" TYPE="real">
!     Array containing two reference pressure profiles 
!     on the radiation grid for use in defining 
!     transmission functions in [pascals]
!   </IN>
! </SUBROUTINE>
subroutine sea_esf_rad_init (lonb, latb, pref_r)

!---------------------------------------------------------------------
!   sea_esf_rad_init is the constructor for sea_esf_rad_mod.
!---------------------------------------------------------------------

real, dimension(:,:),    intent(in)  :: lonb, latb
real, dimension(:,:),    intent(in)  :: pref_r

!---------------------------------------------------------------------
!   intent(in) variables:
!
!       lonb      2d array of model longitudes at cell corners 
!                 [radians]
!       latb      2d array of model latitudes at cell corners 
!                 [radians]
!       pref_r    array containing two reference pressure profiles 
!                 on the radiation grid for use in defining 
!                 transmission functions 
!                 [pascals]
!
!----------------------------------------------------------------------

!-------------------------------------------------------------------
!  local variables

      integer                           :: unit, io, ierr, logunit
      type(lw_table_type)               :: Lw_tables

!---------------------------------------------------------------------
!  local variables:
!
!        unit            io unit number used for namelist file
!        ierr            error code
!        io              error status returned from io operation
!        end
!        Lw_tables
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return

!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call rad_utilities_init
      call time_manager_init

!-----------------------------------------------------------------------
!    read namelist.
!-----------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=sea_esf_rad_nml, iostat=io)
      ierr = check_nml_error(io,'sea_esf_rad_nml')
#else   
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=sea_esf_rad_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'sea_esf_rad_nml')
        end do
10      call close_file (unit)
      endif
#endif

!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                           write (logunit, nml=sea_esf_rad_nml)

!---------------------------------------------------------------------
!    initialize the modules called by this module.
!---------------------------------------------------------------------
      call longwave_driver_init  (latb, lonb, pref_r, Lw_tables)
      call shortwave_driver_init (latb, pref_r)
      call radiation_diag_init   (latb, lonb, Lw_tables)

!---------------------------------------------------------------------
!    initialize clocks to time various modules called by this module.
!---------------------------------------------------------------------
      longwave_clock =      &
                  mpp_clock_id ('   Physics_down: Radiation: lw', &
                        grain=CLOCK_ROUTINE)
      shortwave_clock =     &
                  mpp_clock_id ('   Physics_down: Radiation: sw', &
                        grain=CLOCK_ROUTINE)

!-------------------------------------------------------------------
!    mark the module as initialized.
!-------------------------------------------------------------------
      module_is_initialized = .true.

!-------------------------------------------------------------------



end subroutine sea_esf_rad_init


!####################################################################
 
subroutine sea_esf_rad_time_vary (Time, Rad_gases_tv)

!----------------------------------------------------------------------
type(time_type), intent(in)  :: Time
type(radiative_gases_type), intent(inout) :: Rad_gases_tv

 
      call longwave_driver_time_vary (Time, Rad_gases_tv)
 

end subroutine sea_esf_rad_time_vary
 

!#######################################################################        ######

subroutine sea_esf_rad_endts (Rad_gases_tv)
 
type(radiative_gases_type), intent(in) :: Rad_gases_tv
 
    call longwave_driver_endts (Rad_gases_tv)

end subroutine sea_esf_rad_endts 



!#####################################################################
! <SUBROUTINE NAME="sea_esf_rad">
!   
!   <OVERVIEW>
!     The radiation component interface of the climate model
!   </OVERVIEW>
!   <DESCRIPTION>
!     This subroutine calls longwave radiation computation subroutine, 
!     shortwave radiation computation subroutine, radiation diagnostics
!     computation routine, and finally it deallocates all previously
!     allocated memory spaces of temporary arrays.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call sea_esf_rad (is, ie, js, je, Atmos_input, Surface, Astro, Rad_gases, &
!    Aerosol, Cldrad_props, Cld_spec, Cld_diagnostics, Lw_output, Sw_output)
!   </TEMPLATE>
!
!   <IN NAME="is" TYPE="integer">
!     Starting subdomain i indice of data in the physics window being
!     modeled (longitudinal)
!   </IN>
!   <IN NAME="js" TYPE="integer">
!     Starting subdomain j indice of data in the physics window being
!     modeled (latitudinal)
!   </IN>
!   <IN NAME="ie" TYPE="integer">
!     Ending subdomain i indice of data in the physics window being
!     modeled  (longitudinal)
!   </IN>
!   <IN NAME="je" TYPE="integer">
!     Ending subdomain j indice of data in the physics window being
!     modeled (latitudinal)
!   </IN>
!   <IN NAME="Atmos_input" TYPE="atmos_input_type">
!     Atmos_input_type variable containing the atmospheric
!     input fields on the radiation grid 
!   </IN>
!   <IN NAME="Astro" TYPE="astronomy_type">
!     Astronomy_type variable containing the astronomical
!     input fields on the radiation grid  
!   </IN>
!   <IN NAME="Rad_gases" TYPE="radiative_gases_type">
!     Radiative_gases_type variable containing the radiative 
!     gas input fields on the radiation grid 
!   </IN>
!   <IN NAME="Aerosol" TYPE="aerosol_type">
!     Aerosol input data to the shortwave radiation calculation
!   </IN>
!   <IN NAME="Cldrad_props" TYPE="cldrad_properties_type">
!     The cloud radiative property input fields on the
!     radiation grid
!   </IN>
!   <IN NAME="Cld_diagnostics" TYPE="cld_diagnostics_type">
!     The cloud diagnostics input fields on the radiation grid
!   </IN>
!   <INOUT NAME="Lw_output" TYPE="lw_output_type">
!     The longwave radiation calculation result
!   </INOUT>
!   <INOUT NAME="Sw_output" TYPE="sw_output_type">
!     The shortwave radiation calculation result
!   </INOUT>
!   <IN NAME="Surface" TYPE="surface_type">
!    Surface data as boundary condition to radiation
!   </IN>
!   <IN NAME="Cld_spec" TYPE="cld_specification_type">
!    Cloud specification data as initial condition to radiation
!   </IN>
! </SUBROUTINE>

subroutine sea_esf_rad (is, ie, js, je, Rad_time, Atmos_input, Surface,&
                        Astro, Rad_gases, Aerosol, Aerosol_props,    &
                        Cldrad_props, Cld_spec, Lw_output, Sw_output, &
                        Aerosol_diags, r)

!-----------------------------------------------------------------------
!     sea_esf_rad calls the modules which calculate the long- and short-
!     wave radiational heating terms and fluxes and the radiation diag-
!     nostics module which provides radiation package diagnostics.
!-----------------------------------------------------------------------

integer,                      intent(in)     :: is, ie, js, je
type(time_type),              intent(in)     :: Rad_time
type(atmos_input_type),       intent(in)     :: Atmos_input
type(surface_type),           intent(in)     :: Surface     
type(astronomy_type),         intent(in)     :: Astro
type(radiative_gases_type),   intent(inout)  :: Rad_gases
type(aerosol_type),           intent(in)     :: Aerosol      
type(aerosol_properties_type),intent(inout)  :: Aerosol_props
type(cldrad_properties_type), intent(in)     :: Cldrad_props
type(cld_specification_type), intent(in)     :: Cld_spec       
type(lw_output_type), dimension(:), intent(inout)  :: Lw_output
type(sw_output_type), dimension(:), intent(inout)  :: Sw_output 
type(aerosol_diagnostics_type), intent(inout)  :: Aerosol_diags
real, dimension(:,:,:,:),     intent(inout)  :: r
!---------------------------------------------------------------------
!  intent(in) variables:
!
!      is,ie,js,je   starting/ending subdomain i,j indices of data in 
!                    the physics_window being integrated
!      Rad_time      time at which the climatologically-determined, 
!                    time-varying input fields to radiation should 
!                    apply    
!                    [ time_type, days and seconds]
!      Atmos_input   atmospheric input fields          
!                    [ atmos_input_type ]
!      Surface       surface variables 
!                    [ surface_type ]
!      Astro         astronomical input fields            
!                    [ astronomy_type ]
!      Rad_gases     radiative gas input fields   
!                    [ radiative_gases_type ]
!      Aerosol       aerosol input fields 
!                    [ aerosol_type ]
!      Cldrad_props  cloud radiative property input fields
!                    [ cldrad_properties_type ]
!      Cld_spec      cloud specification input fields 
!                    [ cld_specification_type ]
!
!  intent(out) variables:
!
!      Aerosol_props aerosol radiative properties
!                    [ aerosol_properties_type ]
!      Lw_output     longwave radiation output data from the sea_esf_rad
!                    radiation package
!                    [ lw_output_type ]
!      Sw_output     shortwave radiation output data from the
!                    sea_esf_rad radiation package 
!                    [ sw_output_type ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables

      type(lw_diagnostics_type)         :: Lw_diagnostics
      type(cld_space_properties_type)   :: Cldspace_rad

!---------------------------------------------------------------------
!   local variables
!
!         Lw_diagnostics      used to hold desired diagnostics from 
!                             longwave_driver_mod so they may be passed
!                             to radiation_diag_mod
!                             [ lw_diagnostics_type ]
!         Cldspace_rad        used to hold output from bulk sw routine
!                             so that it may be passed to the 
!                             radiation_diag_mod    
!                             [ cld_space_properties_type ]
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('sea_esf_rad_mod',   &
              'module has not been initialized', FATAL )
      endif

!----------------------------------------------------------------------
!    compute longwave radiation.
!----------------------------------------------------------------------
    if (Rad_control%do_lw_rad) then
      call mpp_clock_begin (longwave_clock)
      call longwave_driver (is, ie, js, je, Rad_time, Atmos_input,  &
                            Rad_gases, Aerosol, Aerosol_props,   &
                            Cldrad_props, Cld_spec, Aerosol_diags, &
                            Lw_output, Lw_diagnostics)
      call mpp_clock_end (longwave_clock)
    endif

!----------------------------------------------------------------------
!    compute shortwave radiation.
!----------------------------------------------------------------------
    if (Rad_control%do_sw_rad) then
      call mpp_clock_begin (shortwave_clock)
      call shortwave_driver (is, ie, js, je, Atmos_input, Surface,  &
                             Astro, Aerosol, Aerosol_props, Rad_gases, &
                             Cldrad_props, Cld_spec, Sw_output,   &
                             Cldspace_rad, Aerosol_diags, r)
      call mpp_clock_end (shortwave_clock)
    endif

!--------------------------------------------------------------------
!    call radiation_diag_driver to compute radiation diagnostics at 
!    desired points.
!--------------------------------------------------------------------
    if (Rad_control%do_sw_rad .and. Rad_control%do_lw_rad) then
      call radiation_diag_driver (is, ie, js, je, Atmos_input, Surface,&
                                  Astro, Rad_gases, Cldrad_props,   &
                                  Cld_spec, Sw_output, Lw_output, &
                                  Lw_diagnostics, Cldspace_rad)
    endif

!---------------------------------------------------------------------
!    call deallocate_arrays to deallocate the array components of the 
!    local derived-type variables.
!---------------------------------------------------------------------
      call deallocate_arrays (Lw_diagnostics, Cldspace_rad)

!--------------------------------------------------------------------

end subroutine sea_esf_rad




!###################################################################
! <SUBROUTINE NAME="sea_esf_rad_end">
! 
!   <OVERVIEW>
!     Ends radiation calculation.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This subroutine ends longwave, shortwave, and radiation
!     diagnostics calculation.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call sea_esf_rad_end
!   </TEMPLATE>
! </SUBROUTINE>

subroutine sea_esf_rad_end
 
!-------------------------------------------------------------------
!    sea_esf_rad_end is the destructor for the sea_esf_rad module.
!-------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('sea_esf_rad_mod',   &
              'module has not been initialized', FATAL )
      endif

!--------------------------------------------------------------------
!    close out the modules initialized by this module.
!--------------------------------------------------------------------
      call longwave_driver_end
      call shortwave_driver_end
      call radiation_diag_end
 
!--------------------------------------------------------------------
!    mark the module as uninitialized.
!--------------------------------------------------------------------
      module_is_initialized = .false.

!--------------------------------------------------------------------


end subroutine sea_esf_rad_end


!####################################################################
      

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                    PRIVATE SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!####################################################################
! <SUBROUTINE NAME="deallocate_arrays">
!  
!   <OVERVIEW>
!     A routine to deallocate arrays allocated temporarily during
!     radiation calculation.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This subroutine deallocates arrays used in longwave 
!     diagnostics and cloud space parameters used in the
!     lacis-hansen formulation.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call deallocate_arrays (Lw_diagnostics, Cldspace_rad)
!   </TEMPLATE>
!
!   <IN NAME="Lw_diagnostics" TYPE="lw_diagnostics_type">
!     Desired diagnostics from longwave_driver
!     so they may be passed to radiation_diag_mod
!   </IN>
!   <IN NAME="Cldspace_rad" TYPE="cld_space_properties_type">
!     Cld_space_properties_type variable which
!     holds lacis-hansen sw cloud-radiation
!     variables in cloud-space, rather than 
!     k-space, as the third dimension.
!   </IN>
! </SUBROUTINE>

subroutine deallocate_arrays (Lw_diagnostics, Cldspace_rad)

!---------------------------------------------------------------------
!    deallocate_arrays deallocates the array cpomponents of local
!    derived-type variables.
!---------------------------------------------------------------------

type(lw_diagnostics_type),       intent(inout)   :: Lw_diagnostics
type(cld_space_properties_type), intent(inout)   :: Cldspace_rad

!---------------------------------------------------------------------
!  intent(inout) variables:
!
!         Lw_diagnostics      lw_diagnostics_type variable to hold
!                             desired diagnostics from longwave_driver
!                             so they may be passed to 
!                             radiation_diag_mod
!         Cldspace_rad        cld_space_properties_type variable which
!                             holds lacis-hansen sw cloud-radiation
!                             variables in cloud-space, rather than 
!                             k-space, as the third dimension.
!
!----------------------------------------------------------------------

!--------------------------------------------------------------------
!    deallocate the components of Lw_diagnostics.
!--------------------------------------------------------------------
    if (Rad_control%do_lw_rad) then
      deallocate (Lw_diagnostics%flx1e1)
      deallocate (Lw_diagnostics%fluxn )
      deallocate (Lw_diagnostics%cts_out)
      deallocate (Lw_diagnostics%cts_outcf)
      deallocate (Lw_diagnostics%gxcts )
      deallocate (Lw_diagnostics%excts )
      deallocate (Lw_diagnostics%exctsn)
      deallocate (Lw_diagnostics%fctsg )
      if (Lw_parameters%nbtrge > 0) then
        deallocate (Lw_diagnostics%flx1e1f)
      endif
      if (Rad_control%do_totcld_forcing) then
        deallocate (Lw_diagnostics%fluxncf)
      endif
   endif

!--------------------------------------------------------------------
!    deallocate the components of Cldspace_rad. these arrays are only
!    allocated when the lh sw code is called with clouds present; 
!    therefore one must test for pointer association before deallo-
!    cating the memory.
!--------------------------------------------------------------------
   if (Rad_control%do_sw_rad) then
      if (Sw_control%do_lhsw) then
        if (associated ( Cldspace_rad%camtswkc) ) then
          deallocate (Cldspace_rad%camtswkc )
          deallocate (Cldspace_rad%cirabswkc )
          deallocate (Cldspace_rad%cirrfswkc )
          deallocate (Cldspace_rad%cvisrfswkc )
          deallocate (Cldspace_rad%ktopswkc )
          deallocate (Cldspace_rad%kbtmswkc )
        endif
      endif
    endif

!--------------------------------------------------------------------


end subroutine deallocate_arrays 


!####################################################################



                 end module sea_esf_rad_mod

      module MO_READ_SIM_CHM_MOD

      use mpp_mod,    only : mpp_error, FATAL
      use mpp_io_mod, only : mpp_open, MPP_RDONLY, MPP_ASCII,MPP_MULTI, &
                             MPP_SINGLE, mpp_close

implicit none
character(len=128), parameter :: version     = '$Id: mo_read_sim_chm.F90,v 19.0 2012/01/06 20:34:02 fms Exp $'
character(len=128), parameter :: tagname     = '$Name: tikal $'
logical                       :: module_is_initialized = .false.

      CONTAINS
        
      subroutine READ_SIM_CHM( sim_data_flsp, &
                               sim_file_cnt )
!--------------------------------------------------------
!            ... Initialize chemistry modules
!--------------------------------------------------------

      use CHEM_MODS_MOD,     only : explicit, implicit, rodas, grpcnt, &
                                nadv_mass, adv_mass, pcnstm1, &
                                drydep_cnt, drydep_lst, &
                                srfems_cnt, srfems_lst, &
                                hetcnt, het_lst, extcnt, extfrc_lst, &
                                rxt_alias_cnt, rxt_alias_lst, rxt_alias_map, &
                                ngrp, grp_mem_cnt, grp_lst
      use M_TRACNAME_MOD,    only : tracnam, natsnam

      implicit none

!--------------------------------------------------------
!            ... Dummy args
!--------------------------------------------------------
      integer, intent(out) :: sim_file_cnt
      character(len=32), intent(in) :: sim_data_flsp

!--------------------------------------------------------
!            ... Local variables
!--------------------------------------------------------
      integer, parameter :: inst = 1, avrg = 2
      integer, parameter :: max_hst_ind = 17
      integer  ::  ios, funit
      character(len=128) :: msg

!     funit = NAVU()
!--------------------------------------------------------
!            ... Open chem input unit
!--------------------------------------------------------
!     OPEN( unit = funit, &
!           file = TRIM( sim_data_flsp ), &
!           status = 'old', &
!           recl   = 2048, &
!           iostat = ios )
!     if( ios /= 0 ) then
!        write(*,*) ' READ_SIM_CHM: Failed to open file ',TRIM( sim_data_flsp )
!        write(*,*) ' Error code = ',ios
!        call ENDRUN
!     end if
      
      call mpp_open( funit, trim(sim_data_flsp), MPP_RDONLY,MPP_ASCII, threading = MPP_MULTI, &
                     fileset=MPP_SINGLE, recl = 2048)

        
!--------------------------------------------------------
!        ... Read map info from data file
!--------------------------------------------------------
      if( explicit%clscnt > 0 ) then
         read(funit,'(4i4)',iostat=ios) explicit%cls_rxt_cnt
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read explicit cls_rxt_cnt; error = ', ios
            call ENDRUN(msg)
         end if
         read(funit,'(20i4)',iostat=ios) explicit%clsmap
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read explicit clscnt; error = ', ios
            call ENDRUN(msg)
         end if
      end if
      if( implicit%clscnt > 0 ) then
         read(funit,'(4i4)',iostat=ios) implicit%cls_rxt_cnt
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read implicit cls_rxt_cnt; error = ', ios
            call ENDRUN(msg)
         end if
         read(funit,'(20i4)',iostat=ios) implicit%clsmap
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read implicit clscnt; error = ', ios
            call ENDRUN(msg)
         end if
         read(funit,'(20i4)',iostat=ios) implicit%permute
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read implicit permute; error = ', ios
            call ENDRUN(msg)
         end if
         read(funit,'(20i4)',iostat=ios) implicit%diag_map
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read implicit diag_map; error = ', ios
            call ENDRUN(msg)
         end if
      end if
      if( rodas%clscnt > 0 ) then
         read(funit,'(4i4)',iostat=ios) rodas%cls_rxt_cnt
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read rodas cls_rxt_cnt; error = ', ios
            call ENDRUN(msg)
         end if
         read(funit,'(20i4)',iostat=ios) rodas%clsmap
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read rodas clscnt; error = ', ios
            call ENDRUN(msg)
         end if
         read(funit,'(20i4)',iostat=ios) rodas%permute
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read rodas permute; error = ', ios
            call ENDRUN(msg)
         end if
         read(funit,'(20i4)',iostat=ios) rodas%diag_map
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read rodas diag_map; error = ', ios
            call ENDRUN(msg)
         end if
      end if
      if( pcnstm1 > 0 ) then
         read(funit,*,iostat=ios) adv_mass(:pcnstm1)
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read adv_mass; error = ', ios
            call ENDRUN(msg)
         end if
      end if
      if( grpcnt > 0 ) then
         read(funit,*,iostat=ios) nadv_mass(:grpcnt)
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read nadv_mass; error = ', ios
            call ENDRUN(msg)
         end if
      end if
      if( pcnstm1 > 0 ) then
         read(funit,'(10a8)',iostat=ios) tracnam(:pcnstm1)
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read tracnam; error = ', ios
            call ENDRUN(msg)
         end if
      end if
      if( grpcnt > 0 ) then
         read(funit,'(i4)',iostat=ios) ngrp
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read ngrp; error = ',ios
            call ENDRUN(msg)
         end if
         allocate( grp_mem_cnt(ngrp),stat=ios )
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to allocate grp_mem_cnt; error = ',ios
            call ENDRUN(msg)
         end if
         allocate( grp_lst(ngrp),stat=ios )
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to allocate grp_lst; error = ',ios
            call ENDRUN(msg)
         end if
         read(funit,'(20i4)',iostat=ios) grp_mem_cnt(:ngrp)
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read grp_mem_cnt; error = ',ios
            call ENDRUN(msg)
         end if
         read(funit,'(10a8)',iostat=ios) grp_lst(:ngrp)
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read grp_lst; error = ',ios
            call ENDRUN(msg)
         end if
         read(funit,'(10a8)',iostat=ios) natsnam(1:grpcnt)
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read natsnam; error = ',ios
            call ENDRUN(msg)
         end if
      end if
      read(funit,'(i4)',iostat=ios) srfems_cnt
      if( ios /= 0 ) then
         write(msg,*) 'READ_SIM_CHM: Failed to read srfems_cnt; error = ',ios
            call ENDRUN(msg)
         end if
      if( srfems_cnt > 0 ) then
         allocate( srfems_lst(srfems_cnt),stat=ios )
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to allocate srfems_lst; error = ',ios
            call ENDRUN(msg)
         end if
         read(funit,'(10a8)',iostat=ios) srfems_lst(1:srfems_cnt)
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read srfems_lst; error = ',ios
            call ENDRUN(msg)
         end if
      end if
      read(funit,'(i4)',iostat=ios) drydep_cnt
      if( ios /= 0 ) then
         write(msg,*) 'READ_SIM_CHM: Failed to read drydep_cnt; error = ',ios
            call ENDRUN(msg)
      end if
      if( drydep_cnt > 0 ) then
         allocate( drydep_lst(drydep_cnt),stat=ios )
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to allocate drydep_lst; error = ',ios
            call ENDRUN(msg)
         end if
         read(funit,'(10a8)',iostat=ios) drydep_lst(1:drydep_cnt)
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read drydep_lst; error = ',ios
            call ENDRUN(msg)
         end if
      end if
      if( hetcnt > 0 ) then
         read(funit,'(10a8)',iostat=ios) het_lst(1:hetcnt)
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read het_lst; error = ',ios
            call ENDRUN(msg)
         end if
      end if
      if( extcnt > 0 ) then
         read(funit,'(10a8)',iostat=ios) extfrc_lst(1:extcnt)
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read extfrc_lst; error = ',ios
            call ENDRUN(msg)
         end if
      end if
      read(funit,'(i4)',iostat=ios) rxt_alias_cnt
      if( ios /= 0 ) then
         write(msg,*) 'READ_SIM_CHM: Failed to read rxt_alias_cnt; error = ',ios
            call ENDRUN(msg)
      end if
      if( rxt_alias_cnt > 0 ) then
         allocate( rxt_alias_lst(rxt_alias_cnt),stat=ios )
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to allocate rxt_alias_lst; error = ',ios
            call ENDRUN(msg)
         end if
         allocate( rxt_alias_map(rxt_alias_cnt),stat=ios )
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to allocate rxt_alias_map; error = ',ios
            call ENDRUN(msg)
         end if
         read(funit,'(5a16)',iostat=ios) rxt_alias_lst(1:rxt_alias_cnt)
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read rxt_alias_lst; error = ',ios
            call ENDRUN(msg)
         end if
         read(funit,'(20i4)',iostat=ios) rxt_alias_map(1:rxt_alias_cnt)
         if( ios /= 0 ) then
            write(msg,*) 'READ_SIM_CHM: Failed to read rxt_alias_map; error = ',ios
            call ENDRUN(msg)
      end if
      end if

!     read(funit,'(i4)',iostat=ios) moz_file_cnt
!     if( ios /= 0 ) then
!        write(msg,*) 'READ_SIM_CHM: Failed to read moz_file_cnt; error = ',ios
!            call ENDRUN(msg)
!     end if
!     sim_file_cnt = MAX( moz_file_cnt,match_file_cnt )
!     do file = 1,moz_file_cnt
!        read(funit,'(10i4)',iostat=ios) hfile(file)%histout_cnt(:,:)
!        if( ios /= 0 ) then
!           write(msg,*) 'READ_SIM_CHM: Failed to read histout_cnt for file ',file,'; error = ',ios
!            call ENDRUN(msg)
!        end if
!     end do

!     do file = 1,sim_file_cnt
!        do k = 1,hstdim
!            if( hstinst(file)%list(k) == ' ' ) then
!               exit
!            end if
!        end do
!        hfile(file)%match_cnt(1) = k - 1
!        do k = 1,hstdim
!            if( hsttimav(file)%list(k) == ' ' ) then
!               exit
!            end if
!        end do
!        hfile(file)%match_cnt(2) = k - 1
!        do i = inst,avrg
!           moz_cnt(i) = SUM( hfile(file)%histout_cnt(:,i) )
!        end do
!        hfile(file)%mxoutflds = MAX( hfile(file)%match_cnt(1)+moz_cnt(1), &
!                                     hfile(file)%match_cnt(2)+moz_cnt(2) )
!        ALLOCATE( minst(hfile(file)%mxoutflds), mtimav(hfile(file)%mxoutflds), stat=astat )
!        if( astat /= 0 ) then
!           write(msg,*) 'READ_SIM_CHM: Failed to allocate minst,mtimav; error = ',astat
!            call ENDRUN(msg)
!        end if
!        ALLOCATE( hfile(file)%outinst(hfile(file)%mxoutflds), &
!                  hfile(file)%outtimav(hfile(file)%mxoutflds), stat=astat )
!        if( astat /= 0 ) then
!           write(msg,*) 'READ_SIM_CHM: Failed to allocate outinst,outtimav for file ',file,'; error = ',astat
!            call ENDRUN(msg)
!        end if
!        minst(:)  = 0
!        mtimav(:) = 0
!        if( hfile(file)%match_cnt(1) > 0 ) then
!           hfile(file)%outinst(:hfile(file)%match_cnt(1)) = hstinst(file)%list(:hfile(file)%match_cnt(1))
!        end if
!        if( hfile(file)%match_cnt(2) > 0 ) then
!           hfile(file)%outtimav(:hfile(file)%match_cnt(2)) = hsttimav(file)%list(:hfile(file)%match_cnt(2))
!        end if

!        do i = inst,avrg
!           end = hfile(file)%match_cnt(i)
!            endi = 0
!           do k = 1,max_hst_ind
!               if( hfile(file)%histout_cnt(k,i) /= 0 ) then
!                  start  = end + 1
!                  end    = start + hfile(file)%histout_cnt(k,i) - 1
!                  starti = endi + 1
!                  endi   = starti + hfile(file)%histout_cnt(k,i) - 1
!                  hfile(file)%histout_ind(k,i) = starti
!                  if( i == inst ) then
!                    read(funit,'(4a32)',iostat=ios) hfile(file)%outinst(start:end)
!                    read(funit,'(20i4)',iostat=ios) minst(starti:endi)
!                  else if( i == avrg ) then
!                    read(funit,'(4a32)',iostat=ios) hfile(file)%outtimav(start:end)
!                    read(funit,'(20i4)',iostat=ios) mtimav(starti:endi)
!                  end if
!               end if
!           end do
!            if( endi > 0 ) then
!               if( i == inst ) then
!                  ALLOCATE( hfile(file)%hist_inst(end), stat=astat )
!                  if( astat /= 0 ) then
!                     write(msg,*) ' READ_SIM_CHM: Failed to allocate hist_ind for file ',file,'; error = ',astat
!                     call ENDRUN(msg)
!                  end if
!                  hfile(file)%hist_inst(:end-hfile(file)%match_cnt(i)) = &
!                           hfile(file)%outinst(hfile(file)%match_cnt(i)+1:end)
!                  ALLOCATE( hfile(file)%inst_map(endi), stat=astat )
!                  if( astat /= 0 ) then
!                     write(msg,*) ' READ_SIM_CHM: Failed to allocate inst_map for file ',file,'; error = ',astat
!                    call ENDRUN(msg)
!                  end if
!                  hfile(file)%inst_map(:endi) = minst(:endi)
!               else if( i == avrg ) then
!                  ALLOCATE( hfile(file)%hist_timav(end), stat=astat )
!                  if( astat /= 0 ) then
!                     write(msg,*) ' READ_SIM_CHM: Failed to allocate hist_timav for file ',file,'; error = ',astat
!                     call ENDRUN(msg)
!                  end if
!                  hfile(file)%hist_timav(:end-hfile(file)%match_cnt(i)) = &
!                         hfile(file)%outtimav(hfile(file)%match_cnt(i)+1:end)
!                  ALLOCATE( hfile(file)%timav_map(endi), stat=astat )
!                  if( astat /= 0 ) then
!                     write(msg,*) ' READ_SIM_CHM: Failed to allocate timav_map for file ',file,'; error = ',astat
!                     call ENDRUN(msg)
!                  end if
!                  hfile(file)%timav_map(:endi) = mtimav(:endi)
!               end if
!            end if
!        end do
!         DEALLOCATE( minst, mtimav )
!     end do
!     read(funit,'(i3)') ndiags

      call mpp_close( funit )

!      write(*,*) '---------------------------------------------------------------------------------'
!      write(*,*) ' '

      end subroutine READ_SIM_CHM

      subroutine ENDRUN(msg)
         character(len=128), intent(in) :: msg
         call mpp_error(FATAL, msg)
      end subroutine ENDRUN        

      end module MO_READ_SIM_CHM_MOD

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                                   !!
!!                   GNU General Public License                      !!
!!                                                                   !!
!! This file is part of the Flexible Modeling System (FMS).          !!
!!                                                                   !!
!! FMS is free software; you can redistribute it and/or modify it    !!
!! under the terms of the GNU General Public License as published by !!
!! the Free Software Foundation, either version 3 of the License, or !!
!! (at your option) any later version.                               !!
!!                                                                   !!
!! FMS is distributed in the hope that it will be useful,            !!
!! but WITHOUT ANY WARRANTY; without even the implied warranty of    !!
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the      !!
!! GNU General Public License for more details.                      !!
!!                                                                   !!
!! You should have received a copy of the GNU General Public License !!
!! along with FMS. if not, see: http://www.gnu.org/licenses/gpl.txt  !!
!!                                                                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mixed_layer_mod

!
! Implementation of mixed layer boundary condition
!

use            fms_mod, only: set_domain, write_version_number, &
                              mpp_pe, mpp_root_pe, error_mesg, FATAL, WARNING

use            fms_mod, only: stdlog, check_nml_error, close_file,&
                              open_namelist_file, stdout, file_exist, &
                              read_data, write_data, open_file, &
                              nullify_domain, lowercase

use  field_manager_mod, only: MODEL_ATMOS

use tracer_manager_mod, only: get_tracer_names, get_number_tracers

use      constants_mod, only: HLV, PI, RHO_CP, CP_AIR 

use   diag_manager_mod, only: register_diag_field, send_data

use   time_manager_mod, only: time_type

use     transforms_mod, only: get_deg_lat, grid_domain

use      vert_diff_mod, only: surf_diff_type

implicit none
private
!=================================================================================================================================

character(len=128) :: version= &
'$Id: mixed_layer.F90,v 20.0 2013/12/13 23:25:40 fms Exp $'
      
character(len=128) :: tagname= &
'$Name: tikal $'
character(len=128), parameter :: mod_name='mixed_layer'

!=================================================================================================================================

public :: mixed_layer_init, mixed_layer, mixed_layer_end

!=================================================================================================================================

logical :: evaporation = .true.
real    :: qflux_amp = 0.0
real    :: qflux_width = 16.0  ! width of qflux region in degrees
real    :: depth = 40.0
logical :: load_qflux = .false.


namelist/mixed_layer_nml/ evaporation, qflux_amp, depth, qflux_width, load_qflux

!=================================================================================================================================


logical :: module_is_initialized =.false.
logical :: used

integer :: iter, nhum
integer, dimension(4) :: axes
integer ::                                                                    &
     id_t_surf,            &   ! surface temperature
     id_flux_lhe,          &   ! latent heat flux at surface
     id_flux_oceanq,       &   ! oceanic Q flux 
     id_flux_t                 ! sensible heat flux at surface

real, allocatable, dimension(:,:)   ::                                        &
     ocean_qflux,           &   ! Q-flux 
     rad_lat_2d                 ! latitude in radians 

real, allocatable, dimension(:)   :: deg_lat

real, allocatable, dimension(:,:)   ::                                        &
     gamma_t,               &   ! Used to calculate the implicit
     gamma_q,               &   ! correction to the diffusion in
     fn_t,                  &   ! the lowest layer
     fn_q,                  &   ! 
     en_t,                  &   !
     en_q,                  &   !
     alpha_t,               &   !
     alpha_q,               &   !
     alpha_lw,              &   !
     beta_t,                &   !
     beta_q,                &   !
     beta_lw,               &   !
     t_surf_dependence,     &   !
     corrected_flux,        &   !
     eff_heat_capacity,     &   ! Effective heat capacity
     delta_t_surf               ! Increment in surface temperature

real inv_cp_air

!=================================================================================================================================
contains
!=================================================================================================================================

subroutine mixed_layer_init(is, ie, js, je, num_levels, t_surf, axes, Time)

type(time_type), intent(in)       :: Time
real, intent(out), dimension(:,:) :: t_surf
integer, intent(in), dimension(4) :: axes
integer, intent(in) :: is, ie, js, je, num_levels 

integer :: j
real    :: rad_qwidth
integer:: ierr, io, unit, num_tr, n
character(32) :: tr_name

if(module_is_initialized) return

call write_version_number(version, tagname)

unit = open_namelist_file ()
ierr=1
do while (ierr /= 0)
  read  (unit, nml=mixed_layer_nml, iostat=io, end=10)
  ierr = check_nml_error (io, 'mixed_layer_nml')
enddo
10 call close_file (unit)

if ( mpp_pe() == mpp_root_pe() ) write (stdlog(), nml=mixed_layer_nml)

call get_number_tracers (MODEL_ATMOS, num_prog=num_tr)
do n = 1,num_tr
   call get_tracer_names( MODEL_ATMOS, n, tr_name )
   if(lowercase(tr_name)=='sphum') then
      nhum = n
   endif
enddo

allocate(rad_lat_2d              (is:ie, js:je))
allocate(ocean_qflux             (is:ie, js:je))
allocate(deg_lat                 (js:je))
allocate(gamma_t                 (is:ie, js:je))
allocate(gamma_q                 (is:ie, js:je))
allocate(en_t                    (is:ie, js:je))
allocate(en_q                    (is:ie, js:je))
allocate(fn_t                    (is:ie, js:je))
allocate(fn_q                    (is:ie, js:je))
allocate(alpha_t                 (is:ie, js:je))
allocate(alpha_q                 (is:ie, js:je))
allocate(alpha_lw                (is:ie, js:je))
allocate(beta_t                  (is:ie, js:je))
allocate(beta_q                  (is:ie, js:je))
allocate(beta_lw                 (is:ie, js:je))
allocate(delta_t_surf            (is:ie, js:je))
allocate(eff_heat_capacity       (is:ie, js:je))
allocate(corrected_flux          (is:ie, js:je))
allocate(t_surf_dependence       (is:ie, js:je))
!
!see if restart file exists for the surface temperature
!
if (file_exist('INPUT/mixed_layer.res.nc')) then

   call nullify_domain()
   call read_data(trim('INPUT/mixed_layer.res'), 't_surf',   t_surf, grid_domain)

else if (file_exist('INPUT/swamp.res')) then
         unit = open_file (file='INPUT/swamp.res', &
                           form='native', action='read')
         call read_data (unit, t_surf)
         call close_file (unit)
  call error_mesg('mixed_layer','mixed_layer restart file not found, using swamp restart file', WARNING)
else
  call error_mesg('mixed_layer','mixed_layer restart file not found', WARNING)
endif

id_t_surf = register_diag_field(mod_name, 't_surf',        &
                                axes(1:2), Time, 'surface temperature','K')
id_flux_t = register_diag_field(mod_name, 'flux_t',        &
                                axes(1:2), Time, 'sensible heat flux up at surface','watts/m2')
id_flux_lhe = register_diag_field(mod_name, 'flux_lhe',        &
                                 axes(1:2), Time, 'latent heat flux up at surface','watts/m2')
id_flux_oceanq = register_diag_field(mod_name, 'flux_oceanq',        &
                                 axes(1:2), Time, 'oceanic Q-flux','watts/m2')

! latitude will be needed for oceanic q flux
call get_deg_lat(deg_lat)
do j=js,je
  rad_lat_2d(:,j) = deg_lat(j)*PI/180.
enddo

! calculate ocean Q flux
rad_qwidth = qflux_width*PI/180.
ocean_qflux = qflux_amp*(1-2.*rad_lat_2d**2/rad_qwidth**2) * &
        exp(- ((rad_lat_2d)**2/(rad_qwidth)**2))

! load Q flux 
if (load_qflux) then
  call read_data('INPUT/ocean_qflux.nc', 'ocean_qflux',  ocean_qflux)
endif

inv_cp_air = 1.0 / CP_AIR 

module_is_initialized = .true.

return
end subroutine mixed_layer_init

!=================================================================================================================================

subroutine mixed_layer (                                               &
     Time,                                                             &
     t_surf,                                                           &
     flux_t,                                                           &
     flux_q,                                                           &
     flux_r,                                                           &
     dt,                                                               &
     net_surf_sw_down,                                                 &
     surf_lw_down,                                                     &
     Tri_surf,                                                         &
     dhdt_surf,                                                        &
     dedt_surf,                                                        &
     dedq_surf,                                                        &
     drdt_surf,                                                        &
     dhdt_atm,                                                         &
     dedq_atm)         

! ---- arguments -----------------------------------------------------------
type(time_type), intent(in)       :: Time
real, intent(in),  dimension(:,:) :: &
     net_surf_sw_down, surf_lw_down
real, intent(in), dimension(:,:) :: &
     flux_t,    flux_q,     flux_r
real, intent(inout), dimension(:,:) :: t_surf
real, intent(in), dimension(:,:) :: &
   dhdt_surf, dedt_surf, dedq_surf, &
   drdt_surf, dhdt_atm, dedq_atm  
real, intent(in) :: dt
type(surf_diff_type), intent(inout) :: Tri_surf

if(.not.module_is_initialized) then
  call error_mesg('mixed_layer','mixed_layer module is not initialized',FATAL)
endif

! Need to calculate the implicit changes to the lowest level delta_q and delta_t
! - see the discussion in vert_diff.tech.ps
                                                                                                                                    
! Care is needed to differentiate between the sensible heat flux and the
! diffusive flux of temperature
                                                                                                                                    
gamma_t = 1.0 / (1.0 - Tri_surf%dtmass * (Tri_surf%dflux_t + dhdt_atm * inv_cp_air))
gamma_q = 1.0 / (1.0 - Tri_surf%dtmass * (Tri_surf%dflux_tr(:,:,nhum) + dedq_atm))
                                                                                                                                 
fn_t = gamma_t * (Tri_surf%delta_t + Tri_surf%dtmass * flux_t * inv_cp_air)
fn_q = gamma_q * (Tri_surf%delta_tr(:,:,nhum) + Tri_surf%dtmass * flux_q)
                                                                                                                                 
en_t = gamma_t * Tri_surf%dtmass * dhdt_surf * inv_cp_air
en_q = gamma_q * Tri_surf%dtmass * dedt_surf
                                                                                                                                    
!
! Note flux_sw doesn't depend on surface or lowest layer values
! Note drdt_atm is not used - should be fixed
!
alpha_t = flux_t * inv_cp_air + dhdt_atm * inv_cp_air * fn_t
alpha_q = flux_q + dedq_atm * fn_q
alpha_lw = flux_r
                                                                                                                                 
beta_t = dhdt_surf * inv_cp_air + dhdt_atm * inv_cp_air * en_t
beta_q = dedt_surf + dedq_atm * en_q
beta_lw = drdt_surf

!
! Implement mixed layer surface boundary condition
!
corrected_flux = - net_surf_sw_down - surf_lw_down + alpha_t * CP_AIR + alpha_lw + ocean_qflux
t_surf_dependence = beta_t * CP_AIR + beta_lw


if (evaporation) then
  corrected_flux = corrected_flux + alpha_q * HLV
  t_surf_dependence = t_surf_dependence + beta_q * HLV
endif

!
! Now update the mixed layer surface temperature using an implicit step
!
eff_heat_capacity = depth * RHO_CP + t_surf_dependence * dt

if (any(eff_heat_capacity .eq. 0.0))  then 
  write(*,*) 'mixed_layer: error', eff_heat_capacity
  call error_mesg('mixed_layer', 'Avoiding division by zero',fatal)
end if

delta_t_surf = - corrected_flux  * dt / eff_heat_capacity

t_surf = t_surf + delta_t_surf
                                                                                                                                    
!
! Finally calculate the increments for the lowest atmospheric layer
!
Tri_surf%delta_t = fn_t + en_t * delta_t_surf
Tri_surf%delta_tr(:,:,nhum) = fn_q + en_q * delta_t_surf


!
! Note:
! When using an implicit step there is not a clearly defined flux for a given timestep
!
if(id_t_surf > 0) used = send_data(id_t_surf, t_surf, Time)
if(id_flux_t > 0) used = send_data(id_flux_t, flux_t, Time)
if(id_flux_lhe > 0) used = send_data(id_flux_lhe, HLV * flux_q, Time)
if(id_flux_oceanq > 0)   used = send_data(id_flux_oceanq, ocean_qflux, Time)

end subroutine mixed_layer

!=================================================================================================================================

subroutine mixed_layer_end(t_surf)

real, intent(inout), dimension(:,:) :: t_surf
integer:: unit

if(.not.module_is_initialized) return

! write a restart file for the surface temperature
call nullify_domain()
call write_data(trim('RESTART/mixed_layer.res'), 't_surf',   t_surf, grid_domain)

module_is_initialized = .false.

end subroutine mixed_layer_end

!=================================================================================================================================

end module mixed_layer_mod

module vegn_harvesting_mod

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only : write_version_number, string, error_mesg, FATAL, NOTE, &
     mpp_pe, write_version_number, file_exist, close_file, &
     check_nml_error, stdlog, mpp_root_pe
use mpp_io_mod, only : axistype, mpp_get_atts, mpp_get_axis_data, &
     mpp_open, mpp_close, MPP_RDONLY, MPP_WRONLY, MPP_ASCII
use vegn_data_mod, only : &
     N_LU_TYPES, LU_PAST, LU_CROP, LU_NTRL, LU_SCND, &
     HARV_POOL_PAST, HARV_POOL_CROP, HARV_POOL_CLEARED, HARV_POOL_WOOD_FAST, &
     HARV_POOL_WOOD_MED, HARV_POOL_WOOD_SLOW, &
     agf_bs, fsc_liv, fsc_wood
use vegn_tile_mod, only : &
     vegn_tile_type
use vegn_cohort_mod, only : &
     vegn_cohort_type, update_biomass_pools

implicit none
private

! ==== public interface ======================================================
public :: vegn_harvesting_init
public :: vegn_harvesting_end

public :: vegn_harvesting

public :: vegn_graze_pasture
public :: vegn_harvest_cropland
public :: vegn_cut_forest
! ==== end of public interface ===============================================

! ==== module constants =====================================================
character(len=*), parameter   :: &
     version = '$Id: vegn_harvesting.F90,v 20.0 2013/12/13 23:31:12 fms Exp $', &
     tagname = '$Name: tikal $', &
     module_name = 'vegn_harvesting_mod'
real, parameter :: ONETHIRD = 1.0/3.0

! ==== module data ==========================================================

! ---- namelist variables ---------------------------------------------------
logical :: do_harvesting       = .TRUE.  ! if true, then harvesting of crops and pastures is done
real :: grazing_intensity      = 0.25    ! fraction of biomass removed each time by grazing
real :: grazing_residue        = 0.1     ! fraction of the grazed biomass transferred into soil pools
real :: frac_wood_wasted_harv  = 0.25    ! fraction of wood wasted while harvesting
real :: frac_wood_wasted_clear = 0.25    ! fraction of wood wasted while clearing land for pastures or crops
logical :: waste_below_ground_wood = .TRUE. ! If true, all the wood below ground (1-agf_bs fraction of bwood 
        ! and bsw) is wasted. Old behavior assumed this to be FALSE.
real :: frac_wood_fast         = ONETHIRD ! fraction of wood consumed fast
real :: frac_wood_med          = ONETHIRD ! fraction of wood consumed with medium speed
real :: frac_wood_slow         = ONETHIRD ! fraction of wood consumed slowly
real :: crop_seed_density      = 0.1     ! biomass of seeds left after crop harvesting, kg/m2
namelist/harvesting_nml/ do_harvesting, grazing_intensity, grazing_residue, &
     frac_wood_wasted_harv, frac_wood_wasted_clear, waste_below_ground_wood, &
     frac_wood_fast, frac_wood_med, frac_wood_slow, &
     crop_seed_density

contains ! ###################################################################

! ============================================================================
subroutine vegn_harvesting_init
  integer :: unit, ierr, io

  call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=harvesting_nml, iostat=io)
  ierr = check_nml_error(io, 'harvesting_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file ( )
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=harvesting_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'harvesting_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif
  
  if (mpp_pe() == mpp_root_pe()) then
     unit=stdlog()
     write(unit, nml=harvesting_nml)
  endif

  if (frac_wood_fast+frac_wood_med+frac_wood_slow/=1.0) then
     call error_mesg('vegn_harvesting_init', &
          'sum of frac_wood_fast, frac_wood_med, and frac_wood_slow must be 1.0',&
          FATAL)
  endif
end subroutine vegn_harvesting_init


! ============================================================================
subroutine vegn_harvesting_end
end subroutine vegn_harvesting_end


! ============================================================================
! harvest vegetation in a tile
subroutine vegn_harvesting(vegn)
  type(vegn_tile_type), intent(inout) :: vegn

  if (.not.do_harvesting) &
       return ! do nothing if no harvesting requested

  select case(vegn%landuse)
  case(LU_PAST)  ! pasture
     call vegn_graze_pasture    (vegn)
  case(LU_CROP)  ! crop
     call vegn_harvest_cropland (vegn)
  end select
end subroutine


! ============================================================================
subroutine vegn_graze_pasture(vegn)
  type(vegn_tile_type), intent(inout) :: vegn

  ! ---- local vars 
  real ::  bdead0, balive0, btotal0; ! initial combined biomass pools
  real ::  bdead1, balive1, btotal1; ! updated combined biomass pools
  type(vegn_cohort_type), pointer :: cc ! shorthand for the current cohort
  integer :: i

  balive0 = 0 ; bdead0 = 0 ;
  balive1 = 0 ; bdead1 = 0 ;

  ! update biomass pools for each cohort according to harvested fraction
  do i = 1,vegn%n_cohorts
     cc=>vegn%cohorts(i)
     ! calculate total biomass pools for the patch
     balive0 = balive0 + cc%bl + cc%blv + cc%br
     bdead0  = bdead0  + cc%bwood + cc%bsw
     ! only potential leaves are consumed
     vegn%harv_pool(HARV_POOL_PAST) = vegn%harv_pool(HARV_POOL_PAST) + &
          cc%bliving*cc%Pl*grazing_intensity*(1-grazing_residue) ;
     cc%bliving = cc%bliving - cc%bliving*cc%Pl*grazing_intensity;

     ! redistribute leftover biomass between biomass pools
     call update_biomass_pools(cc);
 
     ! calculate new combined vegetation biomass pools
     balive1 = balive1 + cc%bl + cc%blv + cc%br
     bdead1  = bdead1  + cc%bwood + cc%bsw
  enddo
  btotal0 = balive0 + bdead0
  btotal1 = balive1 + bdead1

  ! update intermediate soil carbon pools
  vegn%fsc_pool = vegn%fsc_pool + &
       (fsc_liv*(balive0-balive1)+fsc_wood*(bdead0-bdead1))*grazing_residue;
  vegn%ssc_pool = vegn%ssc_pool + &
       ((1-fsc_liv)*(balive0-balive1)+ (1-fsc_wood)*(bdead0-bdead1))*grazing_residue;
end subroutine vegn_graze_pasture


! ================================================================================
subroutine vegn_harvest_cropland(vegn)
  type(vegn_tile_type), intent(inout) :: vegn

  ! ---- local vars
  type(vegn_cohort_type), pointer :: cc ! pointer to the current cohort
  real :: fraction_harvested;    ! fraction of biomass harvested this time
  real :: bdead, balive, btotal; ! combined biomass pools
  integer :: i
  
  balive = 0 ; bdead = 0
  ! calculate initial combined biomass pools for the patch
  do i = 1, vegn%n_cohorts
     cc=>vegn%cohorts(i)
     ! calculate total biomass pools for the patch
     balive = balive + cc%bl + cc%blv + cc%br
     bdead  = bdead  + cc%bwood + cc%bsw
  enddo
  btotal = balive+bdead;

  ! calculate harvested fraction: cut everything down to seed level
  fraction_harvested = MIN(MAX((btotal-crop_seed_density)/btotal,0.0),1.0);

  ! update biomass pools for each cohort according to harvested fraction
  do i = 1, vegn%n_cohorts
     cc=>vegn%cohorts(i)
     ! use for harvest only aboveg round living biomass and waste the correspondent below living and wood
     vegn%harv_pool(HARV_POOL_CROP) = vegn%harv_pool(HARV_POOL_CROP) + &
          cc%bliving*(cc%Pl + cc%Psw*agf_bs)*fraction_harvested;
     vegn%fsc_pool = vegn%fsc_pool + fraction_harvested*(fsc_liv*cc%bliving*cc%Pr + &
          fsc_wood*(cc%bwood + cc%bliving*cc%Psw*(1-agf_bs)));
     vegn%ssc_pool = vegn%ssc_pool + fraction_harvested*((1-fsc_liv)*cc%bliving*cc%Pr + &
          (1-fsc_wood)*(cc%bwood + cc%bliving*cc%Psw*(1-agf_bs)));

     cc%bliving = cc%bliving * (1-fraction_harvested);
     cc%bwood   = cc%bwood   * (1-fraction_harvested);
     ! redistribute leftover biomass between biomass pools
     call update_biomass_pools(cc);
  enddo
end subroutine vegn_harvest_cropland


! ============================================================================
! for now cutting forest is the same as harvesting cropland --
! we basically cut down everything, leaving only seeds
subroutine vegn_cut_forest(vegn, new_landuse)
  type(vegn_tile_type), intent(inout) :: vegn
  integer, intent(in) :: new_landuse ! new land use type that gets assigned to
                                     ! the tile after the wood harvesting

  ! ---- local vars
  type(vegn_cohort_type), pointer :: cc ! pointer to the current cohort
  real :: frac_harvested;        ! fraction of biomass harvested this time
  real :: frac_wood_wasted       ! fraction of wood wasted during transition
  real :: wood_harvested         ! anount of harvested wood, kgC/m2
  real :: bdead, balive, btotal; ! combined biomass pools
  real :: delta
  integer :: i
  
  balive = 0 ; bdead = 0
  ! calculate initial combined biomass pools for the patch
  do i = 1, vegn%n_cohorts
     cc=>vegn%cohorts(i)
     ! calculate total biomass pools for the patch
     balive = balive + cc%bl + cc%blv + cc%br
     bdead  = bdead  + cc%bwood + cc%bsw
  enddo
  btotal = balive+bdead;

  ! calculate harvested fraction: cut everything down to seed level
  frac_harvested = MIN(MAX((btotal-crop_seed_density)/btotal,0.0),1.0);

  ! define fraction of wood wasted, based on the transition type
  if (new_landuse==LU_SCND) then
     frac_wood_wasted = frac_wood_wasted_harv
  else
     frac_wood_wasted = frac_wood_wasted_clear
  endif
  ! take into accont that all wood below ground is wasted; also the fraction
  ! of waste calculated above is lost from the above-ground part of the wood
  if (waste_below_ground_wood) then
     frac_wood_wasted = (1-agf_bs) + agf_bs*frac_wood_wasted
  endif

  ! update biomass pools for each cohort according to harvested fraction
  do i = 1, vegn%n_cohorts
     cc => vegn%cohorts(i)

     ! calculate total amount of harvested wood, minus the wasted part
     wood_harvested = (cc%bwood+cc%bsw)*frac_harvested*(1-frac_wood_wasted)

     ! distribute harvested wood between pools
     if (new_landuse==LU_SCND) then
        ! this is harvesting, distribute between 3 different wood pools 
        vegn%harv_pool(HARV_POOL_WOOD_FAST) = vegn%harv_pool(HARV_POOL_WOOD_FAST) &
             + wood_harvested*frac_wood_fast
        vegn%harv_pool(HARV_POOL_WOOD_MED) = vegn%harv_pool(HARV_POOL_WOOD_MED) &
             + wood_harvested*frac_wood_med
        vegn%harv_pool(HARV_POOL_WOOD_SLOW) = vegn%harv_pool(HARV_POOL_WOOD_SLOW) &
             + wood_harvested*frac_wood_slow
     else
        ! this is land clearance: everything goes into "cleared" pool
        vegn%harv_pool(HARV_POOL_CLEARED) = vegn%harv_pool(HARV_POOL_CLEARED) &
             + wood_harvested
     endif

     ! distribute wood and living biomass between fast and slow intermediate 
     ! soil carbon pools according to fractions specified thorough the namelists
     delta = (cc%bwood+cc%bsw)*frac_harvested*frac_wood_wasted;
     if(delta<0) call error_mesg('vegn_cut_forest', &
          'harvested amount of dead biomass ('//string(delta)//' kgC/m2) is below zero', &
          FATAL)
     vegn%ssc_pool = vegn%ssc_pool + delta*(1-fsc_wood);
     vegn%fsc_pool = vegn%fsc_pool + delta*   fsc_wood ;

     delta = balive * frac_harvested;
     if(delta<0) call error_mesg('vegn_cut_forest', &
          'harvested amount of live biomass ('//string(delta)//' kgC/m2) is below zero', &
          FATAL)
     vegn%ssc_pool = vegn%ssc_pool + delta*(1-fsc_liv) ;
     vegn%fsc_pool = vegn%fsc_pool + delta*   fsc_liv  ;

     cc%bliving = cc%bliving*(1-frac_harvested);
     cc%bwood   = cc%bwood*(1-frac_harvested);
     ! redistribute leftover biomass between biomass pools
     call update_biomass_pools(cc);
  enddo
end subroutine vegn_cut_forest

end module 

module fms_mod

! <CONTACT EMAIL="Bruce.Wyman@noaa.gov">
!   Bruce Wyman
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!   The fms module provides routines that are commonly used
!   by most FMS modules.
! </OVERVIEW>

! <DESCRIPTION>
!   Here is a summary of the functions performed by routines
!     in the fms module.
!
!   1. Output module version numbers to a common (<TT>log</TT>) file
!     using a common format.<BR/>
!   2. Open specific types of files common to many FMS modules.
!     These include namelist files, restart files, and 32-bit IEEE
!     data files. There also is a matching interface to close the files.
!     If other file types are needed the <TT>mpp_open</TT> and <TT>mpp_close</TT>
!     interfaces in module <LINK SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/shared/mpp/mpp_io.html">mpp_io</LINK> must be used.<BR/>
!    3. Read and write distributed data to simple native unformatted files.
!     This type of file (called a restart file) is used to checkpoint
!     model integrations for a subsequent restart of the run.<BR/>
!    4. For convenience there are several routines published from
!     the <LINK SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/shared/mpp/mpp.html">mpp</LINK> module. These are routines for getting processor
!     numbers, commonly used I/O unit numbers, error handling, and timing sections of code.
! </DESCRIPTION>

!-----------------------------------------------------------------------
!
!         A collection of commonly used routines.
!
!  The routines are primarily I/O related, however, there also
!  exists several simple miscellaneous utility routines.
!
!-----------------------------------------------------------------------
!
!  file_exist         Checks the existence of the given file name.
!
!  check_nml_error    Checks the iostat argument that is returned after
!                     reading a namelist and determines if the error
!                     code is valid.
!
!  write_version_number  Prints to the log file (or a specified unit)
!                        the (cvs) version id string and (cvs) tag name.
!
!  error_mesg          Print notes, warnings and error messages, 
!                      terminates program for error messages.
!                      (use error levels NOTE,WARNING,FATAL)
!
!  open_namelist_file  Opens namelist file for reading only.
!
!  open_restart_file   Opens a file that will be used for reading or writing
!                      restart files with native unformatted data.
!
!  open_ieee32_file    Opens a file that will be used for reading or writing
!                      unformatted 32-bit ieee data.
!
!  close_file          Closes a file that was opened using 
!                      open_namelist_file, open_restart_file, or
!                      open_ieee32_file.
!
!  set_domain          Call this routine to internally store in fms_mod the
!                      domain2d data type prior to calling the distributed
!                      data I/O routines read_data and write_data.
!
!  read_data           Reads distributed data from a single threaded file.
!
!  write_data          Writes distributed data to a single threaded file.
!
!  fms_init            Initializes the fms module and also the
!                      mpp_io module (which initializes all mpp mods).
!                      Will be called automatically if the user does
!                      not call it.
!
!  fms_end             Calls mpp exit routines.
!
!  lowercase           Convert character strings to all lower case
!
!  uppercase           Convert character strings to all upper case
!
!  monotonic_array     Determines if the real input array has
!                      monotonically increasing or decreasing values.
!
!  string_array_index  Match the input character string to a string
!                      in an array/list of character strings.
!
!-----------------------------------------------------------------------
!---- published routines from mpp_mod ----
!
!   mpp_error, NOTE, WARNING, FATAL
!   mpp_error_state
!   mpp_pe, mpp_npes, mpp_root_pe
!   stdin, stdout, stderr, stdlog
!   mpp_chksum
!
!   mpp_clock_id, mpp_clock_begin , mpp_clock_end
!   MPP_CLOCK_SYNC, MPP_CLOCK_DETAILED
!   CLOCK_COMPONENT, CLOCK_SUBCOMPONENT, CLOCK_MODULE_DRIVER, 
!   CLOCK_MODULE, CLOCK_ROUTINE, CLOCK_LOOP, CLOCK_INFRA
!
!-----------------------------------------------------------------------

use          mpp_mod, only:  mpp_error, NOTE, WARNING, FATAL,    &
                             mpp_set_warn_level,                 &
                             mpp_transmit, ALL_PES,              &
                             mpp_pe, mpp_npes, mpp_root_pe,      &
                             mpp_sync, mpp_chksum,               &
                             mpp_clock_begin, mpp_clock_end,     &
                             mpp_clock_id, mpp_init, mpp_exit,   &
                             MPP_CLOCK_SYNC, MPP_CLOCK_DETAILED, &
                             CLOCK_COMPONENT, CLOCK_SUBCOMPONENT,&
                             CLOCK_MODULE_DRIVER, CLOCK_MODULE,  &
                             CLOCK_ROUTINE, CLOCK_LOOP,          &
                             CLOCK_INFRA, mpp_clock_set_grain,   &
                             mpp_set_stack_size,                 &
                             stdin, stdout, stderr, stdlog,      &
                             mpp_error_state, lowercase,         &
                             uppercase, mpp_broadcast, input_nml_file

use  mpp_domains_mod, only:  domain2D, mpp_define_domains, &
                             mpp_update_domains, GLOBAL_DATA_DOMAIN, &
                             mpp_domains_init, mpp_domains_exit,     &
                             mpp_global_field, mpp_domains_set_stack_size,  &
                             mpp_get_compute_domain, mpp_get_global_domain, &
                             mpp_get_data_domain

use       mpp_io_mod, only:  mpp_io_init, mpp_open, mpp_close,         &
                       MPP_ASCII, MPP_NATIVE, MPP_IEEE32, MPP_NETCDF,  &
                       MPP_RDONLY, MPP_WRONLY, MPP_APPEND, MPP_OVERWR, &
                       MPP_SEQUENTIAL, MPP_DIRECT,                     &
                       MPP_SINGLE, MPP_MULTI, MPP_DELETE, mpp_io_exit, &
                       fieldtype, mpp_get_atts, mpp_get_info, mpp_get_fields

use fms_io_mod, only : fms_io_init, fms_io_exit, field_size, &
                       read_data, write_data, read_compressed, read_distributed, &
                       open_namelist_file, open_restart_file, open_ieee32_file, close_file, &
                       set_domain, get_domain_decomp, nullify_domain, &
                       open_file, open_direct_file, string, get_mosaic_tile_grid, &
                       get_mosaic_tile_file, get_global_att_value, file_exist, field_exist

use memutils_mod, only: print_memuse_stats, memutils_init
use constants_mod, only: constants_version=>version, constants_tagname=>tagname !pjp: PI not computed


implicit none
private

! routines for initialization and termination of module
public :: fms_init, fms_end

! routines for opening/closing specific types of file
public :: open_namelist_file, open_restart_file, &
          open_ieee32_file, close_file, &
          open_file, open_direct_file

! routines for reading/writing distributed data
public :: set_domain, read_data, write_data, read_compressed, read_distributed
public :: get_domain_decomp, field_size, nullify_domain
public :: get_global_att_value

! routines for get mosaic information
public :: get_mosaic_tile_grid, get_mosaic_tile_file

! miscellaneous i/o routines
public :: file_exist, check_nml_error, field_exist,     &
          write_version_number, error_mesg, fms_error_handler

! miscellaneous utilities (non i/o)
public :: lowercase, uppercase, string,        &
          string_array_index, monotonic_array

! public mpp interfaces
public :: mpp_error, NOTE, WARNING, FATAL, &
          mpp_error_state,                 &
          mpp_pe, mpp_npes, mpp_root_pe,   &
          stdin, stdout, stderr, stdlog,   &
          mpp_chksum
public :: mpp_clock_id, mpp_clock_begin, mpp_clock_end
public :: MPP_CLOCK_SYNC, MPP_CLOCK_DETAILED
public :: CLOCK_COMPONENT, CLOCK_SUBCOMPONENT, &
          CLOCK_MODULE_DRIVER, CLOCK_MODULE,   &
          CLOCK_ROUTINE, CLOCK_LOOP, CLOCK_INFRA

!Balaji
!this is published by fms and applied to any initialized clocks
!of course you can go and set the flag to SYNC or DETAILED by hand
integer, public :: clock_flag_default

! Namelist read error values
  TYPE nml_errors_type
     INTEGER :: multipleNMLSinFile
     INTEGER :: badType1
     INTEGER :: badType2
     INTEGER :: missingVar
     INTEGER :: NotInFile
  END TYPE nml_errors_type
  TYPE(nml_errors_type), SAVE :: nml_errors


!------ namelist interface -------
!------ adjustable severity level for warnings ------

  logical           :: read_all_pe   = .true.
  character(len=16) :: clock_grain = 'NONE', clock_flags='NONE'
  character(len=8)  :: warning_level = 'warning'
  character(len=64) :: iospec_ieee32 = '-N ieee_32'
  integer           :: stack_size = 0
  integer           :: domains_stack_size = 0
  logical, public   :: print_memory_usage = .FALSE.

!------ namelist interface -------

! <NAMELIST NAME="fms_nml">
!   <DATA NAME="clock_grain"  TYPE="character"  DEFAULT="'NONE'">
!     The level of clock granularity used for performance timing sections
!     of code. Possible values in order of increasing detail are:
!     'NONE', 'COMPONENT', 'SUBCOMPONENT', 'MODULE_DRIVER', 'MODULE', 'ROUTINE',
!     'LOOP', and 'INFRA'.  Code sections are defined using routines in MPP 
!     module: mpp_clock_id, mpp_clock_begin, and mpp_clock_end.
!     The fms module makes these routines public.
!     A list of timed code sections will be printed to STDOUT.
!     See the <LINK SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/shared/mpp/mpp.html">MPP</LINK>
!     module for more details.
!   </DATA>
!   <DATA NAME="clock_flags"  TYPE="character"  DEFAULT="'NONE'">
!     Possible values are 'NONE', 'SYNC', or 'DETAILED'.
!     SYNC will give accurate information on load balance of the clocked
!     portion of code.
!     DETAILED also turns on detailed message-passing performance diagnosis.
!     Both SYNC and DETAILED will  work correctly on innermost clock nest
!     and distort outer clocks, and possibly the overall code time.
!     See the <LINK SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/shared/mpp/mpp.html">MPP</LINK>
!     module for more details.
!   </DATA>
!   <DATA NAME="read_all_pe"  TYPE="logical"  DEFAULT="true">
!     Read global data on all processors extracting local part needed (TRUE) or
!     read global data on PE0 and broadcast to all PEs (FALSE).
!   </DATA>
!   <DATA NAME="warning_level"  TYPE="character"  DEFAULT="'warning'">
!     Sets the termination condition for the WARNING flag to interfaces
!     error_mesg/mpp_error. set warning_level = 'fatal' (program crashes for
!     warning messages) or 'warning' (prints warning message and continues).
!   </DATA>
!   <DATA NAME="iospec_ieee32"  TYPE="character"  DEFAULT="'-N ieee_32'">
!     iospec flag used with the open_ieee32_file interface.
!   </DATA>
!   <DATA NAME="stack_size"  TYPE="integer"  DEFAULT="0">
!     The size in words of the MPP user stack. If stack_size > 0, the following
!     MPP routine is called: call mpp_set_stack_size (stack_size). If stack_size
!     = 0 (default) then the default size set by mpp_mod is used.
!   </DATA>
!   <DATA NAME="domains_stack_size" TYPE="integer"  DEFAULT="0">
!     The size in words of the MPP_DOMAINS user stack. If
!     domains_stack_size > 0, the following MPP_DOMAINS routine is called:
!     call mpp_domains_set_stack_size (domains_stack_size). If
!     domains_stack_size = 0 (default) then the default size set by
!     mpp_domains_mod is used. 
!   </DATA>
!   <DATA NAME="print_memory_usage"  TYPE="logical"  DEFAULT=".FALSE.">
!     If set to .TRUE., memory usage statistics will be printed at various
!     points in the code. It is used to study memory usage, e.g to detect
!     memory leaks.
!   </DATA>
! </NAMELIST>

  namelist /fms_nml/  read_all_pe, clock_grain, clock_flags,    &
                      warning_level, iospec_ieee32, &
                      stack_size, domains_stack_size, &
                      print_memory_usage

!   ---- private data for check_nml_error ----

   integer, private :: num_nml_error_codes, nml_error_codes(20)
   logical, private :: do_nml_error_init = .true.
   private  nml_error_init


!  ---- version number -----

  character(len=128) :: version = '$Id$'
  character(len=128) :: tagname = '$Name$'

  logical :: module_is_initialized = .FALSE.


contains

!#######################################################################

! <SUBROUTINE NAME="fms_init">

!   <OVERVIEW>
!     Initializes the FMS module and also calls the initialization routines for all
!     modules in the MPP package. Will be called automatically if the user does
!     not call it. 
!   </OVERVIEW>
!   <DESCRIPTION>
!      Initialization routine for the fms module. It also calls initialization routines
!      for the mpp, mpp_domains, and mpp_io modules. Although this routine
!      will be called automatically by other fms_mod routines, users should
!      explicitly call fms_init. If this routine is called more than once it will
!      return silently. There are no arguments.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call fms_init ( )
!   </TEMPLATE>


!   <ERROR MSG="invalid entry for namelist variable warning_level" STATUS="FATAL">
!     The namelist variable warning_level must be either 'fatal' or 'warning'
!     (case-insensitive). 
!   </ERROR>
!   <ERROR MSG="invalid entry for namelist variable clock_grain" STATUS="FATAL">
!     The namelist variable clock_grain must be one of the following values:
!     'NONE', 'COMPONENT', 'SUBCOMPONENT', 'MODULE_DRIVER', 'MODULE', 'ROUTINE',
!     'LOOP', or 'INFRA' (case-insensitive). 
!   </ERROR>

! initializes the fms module/package
! also calls mpp initialization routines and reads fms namelist

subroutine fms_init (localcomm )
 integer, intent(in), optional :: localcomm
 integer :: unit, ierr, io

    if (module_is_initialized) return    ! return silently if already called
    module_is_initialized = .true.
!---- initialize mpp routines ----
    if(present(localcomm)) then
       call mpp_init(localcomm=localcomm)
    else
       call mpp_init()
    endif
    call mpp_domains_init
    call fms_io_init

!---- read namelist input ----

    call nml_error_init  ! first initialize namelist iostat error codes

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, fms_nml, iostat=io)
      ierr = check_nml_error(io,'fms_nml')
#else
    if (file_exist('input.nml')) then
       unit = open_namelist_file ( )
       ierr=1; do while (ierr /= 0)
          read  (unit, nml=fms_nml, iostat=io, end=10)
          ierr = check_nml_error(io,'fms_nml')  ! also initializes nml error codes
       enddo
 10    call mpp_close (unit)
    endif
#endif

!---- define mpp stack sizes if non-zero -----

    if (        stack_size > 0) call         mpp_set_stack_size (        stack_size)
    if (domains_stack_size > 0) call mpp_domains_set_stack_size (domains_stack_size)

!---- set severity level for warnings ----

    select case( trim(lowercase(warning_level)) )
    case( 'fatal' )  
        call mpp_set_warn_level ( FATAL )
    case( 'warning' )
        call mpp_set_warn_level ( WARNING )
    case default
        call error_mesg ( 'fms_init',  &
             'invalid entry for namelist variable warning_level', FATAL )
    end select

!--- set granularity for timing code sections ---

    select case( trim(uppercase(clock_grain)) )
    case( 'NONE' )
        call mpp_clock_set_grain (0)
    case( 'COMPONENT' )
        call mpp_clock_set_grain (CLOCK_COMPONENT)
    case( 'SUBCOMPONENT' )
        call mpp_clock_set_grain (CLOCK_SUBCOMPONENT)
    case( 'MODULE_DRIVER' )
        call mpp_clock_set_grain (CLOCK_MODULE_DRIVER)
    case( 'MODULE' )
        call mpp_clock_set_grain (CLOCK_MODULE)
    case( 'ROUTINE' )
        call mpp_clock_set_grain (CLOCK_ROUTINE)
    case( 'LOOP' )
        call mpp_clock_set_grain (CLOCK_LOOP)
    case( 'INFRA' )
        call mpp_clock_set_grain (CLOCK_INFRA)
    case default
        call error_mesg ( 'fms_init',  &
             'invalid entry for namelist variable clock_grain', FATAL )
    end select
!Balaji
    select case( trim(uppercase(clock_flags)) )
    case( 'NONE' )
       clock_flag_default = 0
    case( 'SYNC' )
       clock_flag_default = MPP_CLOCK_SYNC
    case( 'DETAILED' )
       clock_flag_default = MPP_CLOCK_DETAILED
    case default
       call error_mesg ( 'fms_init',  &
            'invalid entry for namelist variable clock_flags', FATAL )
   end select

!--- write version info and namelist to logfile ---

    call write_version_number (version, tagname)
    if (mpp_pe() == mpp_root_pe()) then
      unit = stdlog()
      write (unit, nml=fms_nml)
      write (unit,*) 'nml_error_codes=', nml_error_codes(1:num_nml_error_codes)
    endif

    call memutils_init( print_memory_usage )
    call print_memuse_stats('fms_init')

    call write_version_number (constants_version,constants_tagname)

end subroutine fms_init
! </SUBROUTINE>

!#######################################################################


! <SUBROUTINE NAME="fms_end">

!   <OVERVIEW>
!     Calls the termination routines for all modules in the MPP package.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Termination routine for the fms module. It also calls destructor routines
!      for the mpp, mpp_domains, and mpp_io modules. If this routine is called
!      more than once it will return silently. There are no arguments. 
!   </DESCRIPTION>
!   <TEMPLATE>
!     call fms_end ( )
!   </TEMPLATE>

! terminates the fms module/package
! also calls mpp destructor routines

subroutine fms_end ( )

    if (.not.module_is_initialized) return  ! return silently
!    call fms_io_exit  ! now called from coupler_end
    call mpp_io_exit
    call mpp_domains_exit
    call mpp_exit
    module_is_initialized =.FALSE.

end subroutine fms_end
! </SUBROUTINE>


!#######################################################################
! <SUBROUTINE NAME="error_mesg">

!   <OVERVIEW>
!     Print notes, warnings and error messages; terminates program for warning 
!     and error messages. (use error levels NOTE,WARNING,FATAL, see example below)
!   </OVERVIEW>
!   <DESCRIPTION>
!     Print notes, warnings and error messages; and terminates the program for 
!     error messages. This routine is a wrapper around mpp_error, and is provided 
!     for backward compatibility. This module also publishes mpp_error,
!      <B>users should try to use the mpp_error interface</B>. 
!   </DESCRIPTION>
!   <TEMPLATE>
!     call error_mesg ( routine, message, level )
!   </TEMPLATE>

!   <IN NAME="routine"  TYPE="character" >
!     Routine name where the warning or error has occurred.
!   </IN>
!   <IN NAME="message"  TYPE="character" >
!     Warning or error message to be printed.
!   </IN>
!   <IN NAME="level"  TYPE="integer" >
!     Level of severity; set to NOTE, WARNING, or FATAL Termination always occurs 
!     for FATAL, never for NOTE, and is settable for WARNING (see namelist).
!   </IN>
!   <NOTE>
!
!     Examples:
!     <PRE>
!        use fms_mod, only: error_mesg, FATAL, NOTE

!        call error_mesg ('fms_mod', 'initialization not called', FATAL)
!        call error_mesg ('fms_mod', 'fms_mod message', NOTE)
!     </PRE>
!   </NOTE>
! wrapper for the mpp error handler
! users should try to use the mpp_error interface

 subroutine error_mesg (routine, message, level)
  character(len=*), intent(in) :: routine, message
  integer,          intent(in) :: level

!  input:
!      routine   name of the calling routine (character string)
!      message   message written to output   (character string)
!      level     set to NOTE, MESSAGE, or FATAL (integer)

    if (.not.module_is_initialized) call fms_init ( )
    call mpp_error ( routine, message, level )

 end subroutine error_mesg
! </SUBROUTINE>

!#######################################################################
! <FUNCTION NAME="fms_error_handler">

!   <OVERVIEW>
!     Facilitates the control of fatal error conditions
!   </OVERVIEW>
!   <DESCRIPTION>
!     When err_msg is present, message is copied into err_msg
!     and the function returns a value of .true.
!     Otherwise calls mpp_error to terminate execution.
!     The intended use is as shown below.
!   </DESCRIPTION>
!   <TEMPLATE>
!     if(fms_error_handler(routine, message, err_msg)) return
!   </TEMPLATE>
!   <IN NAME="routine"  TYPE="character">
!     Routine name where the fatal error has occurred.
!   </IN>
!   <IN NAME="message"  TYPE="character">
!     fatal error message to be printed.
!   </IN>
!   <OUT NAME="fms_error_handler"  TYPE="logical">
!     .true.  when err_msg is present
!     .false. when err_msg is not present
!   </OUT>
!   <OUT NAME="err_msg"  TYPE="character">
!     When err_msg is present: err_msg = message
!   </OUT>

 function fms_error_handler(routine, message, err_msg)

 logical :: fms_error_handler
 character(len=*), intent(in) :: routine, message
 character(len=*), intent(out), optional :: err_msg

 fms_error_handler = .false.
 if(present(err_msg)) then
   err_msg = message
   fms_error_handler = .true.
 else
   call mpp_error(trim(routine),trim(message),FATAL)
 endif

 end function fms_error_handler
! </FUNCTION>

!#######################################################################
! <FUNCTION NAME="check_nml_error">

!   <OVERVIEW>
!     Checks the iostat argument that is returned after reading a namelist 
!     and determines if the error code is valid. 
!   </OVERVIEW>
!   <DESCRIPTION>
!     The FMS allows multiple namelist records to reside in the same file. 
!     Use this interface to check the iostat argument that is returned after 
!     reading a record from the namelist file. If an invalid iostat value 
!     is detected this routine will produce a fatal error. See the NOTE below.
!   </DESCRIPTION>
!   <TEMPLATE>
!     check_nml_error ( iostat, nml_name )
!   </TEMPLATE>

!   <IN NAME="iostat"  TYPE="integer" >
!     The iostat value returned when reading a namelist record.
!   </IN>
!   <IN NAME="nml_name"  TYPE="character" >
!     The name of the namelist. This name will be printed if an error is 
!     encountered, otherwise the name is not used.
!   </IN>
!   <OUT NAME=""  TYPE="integer" >
!     This function returns the input iostat value (integer) if it is an 
!     allowable error code. If the iostat error code is not
!     allowable, an error message is printed and the program terminated.
!   </OUT>
!   <NOTE>
!     Some compilers will return non-zero iostat values when reading through 
!     files with multiple namelist. This routine
!     will try skip these errors and only terminate for true namelist errors.
!
!     Examples
!
!       The following example checks if a file exists, reads a namelist input 
!       from that file, and checks for errors in that
!       namelist. When the correct namelist is read and it has no errors the 
!       routine check_nml_error will return zero and the while loop will exit. 
!       This code segment should be used to read namelist files. 
!       <PRE>
!          integer :: unit, ierr, io
!
!          if ( file_exist('input.nml') ) then
!              unit = open_namelist_file ( )
!              ierr=1
!              do while (ierr > 0)
!                read  (unit, nml=moist_processes_nml, iostat=io)
!                ierr = check_nml_error(io,'moist_processes_nml')
!              enddo
!              call close_file (unit)
!          endif
!       </PRE>
!   </NOTE>

!   <ERROR MSG="Unknown error while reading namelist ...., (IOSTAT = ####)" STATUS="FATAL">
!     There was an error reading the namelist specified. Carefully examine all namelist and variables 
!     for anything incorrect (e.g. malformed, hidden characters).
!   </ERROR>
!   <ERROR MSG="Unknown namelist, or mistyped namelist variable in namelist ...., (IOSTAT = ####)" STATUS="FATAL">
!     The name list given doesn't exist in the namelist file, or a variable in the namelist is mistyped or isn't a 
!     namelist variable.
!   </ERROR>

! used to check the iostat argument that is
! returned after reading a namelist
! see the online documentation for how this routine might be used
  INTEGER FUNCTION check_nml_error(IOSTAT, NML_NAME)
    INTEGER, INTENT(in) :: IOSTAT
    CHARACTER(len=*), INTENT(in) :: NML_NAME

    CHARACTER(len=256) :: err_str

    IF ( .NOT.module_is_initialized) CALL fms_init()

    check_nml_error = IOSTAT

    ! Return on valid IOSTAT values
    IF ( IOSTAT <= 0 .OR.&
       & IOSTAT == nml_errors%multipleNMLSinFile .OR.&
       & IOSTAT == nml_errors%NotInFile) RETURN

    ! Everything else is a FATAL
    IF ( (IOSTAT == nml_errors%badType1 .OR. IOSTAT == nml_errors%badType2) .OR. IOSTAT == nml_errors%missingVar ) THEN
       WRITE (err_str,*) 'Unknown namelist, or mistyped namelist variable in namelist ',TRIM(NML_NAME),', (IOSTAT = ',IOSTAT,')'
       CALL error_mesg ('check_nml_error in fms_mod', err_str, FATAL)
       CALL mpp_sync()
    ELSE
       WRITE (err_str,*) 'Unknown error while reading namelist ',TRIM(NML_NAME),', (IOSTAT = ',IOSTAT,')'
       CALL error_mesg ('check_nml_error in fms_mod', err_str, FATAL)
       CALL mpp_sync()
    END IF
  END FUNCTION check_nml_error
! </FUNCTION>

!-----------------------------------------------------------------------
!   private routine for initializing allowable error codes

  SUBROUTINE nml_error_init
    ! Determines the IOSTAT error value for some common Namelist errors.
    ! Also checks if the compiler returns a non-zero status if there are 
    ! multiple namelist records in a single file.
    INTEGER, PARAMETER :: unit_begin = 20, unit_end = 1024
    INTEGER :: fileunit, io_stat
    INTEGER, DIMENSION(5) :: nml_iostats
    LOGICAL :: opened

    ! Variables for sample namelists
    INTEGER :: i1 = 1, i2 = 2
    REAL :: r1 = 1.0, r2 = 2.0
    LOGICAL :: l1 = .FALSE.
    NAMELIST /a_nml/ i1, r1
    NAMELIST /b_nml/ i2, r2, l1
    NAMELIST /badType1_nml/ i1, r1
    NAMELIST /badType2_nml/ i1, r1
    NAMELIST /missingVar_nml/ i2, r2
    NAMELIST /not_in_file_nml/ i2, r2

    ! Initialize the sample namelist variables
    i1 = 1
    i2 = 2
    r1 = 1.0
    r2 = 2.0
    l1 = .FALSE.

    ! Create a dummy namelist file
    IF ( mpp_pe() == mpp_root_pe() ) THEN
       ! Find a free file unit for a scratch file
       file_opened: DO fileunit = unit_begin, unit_end
          INQUIRE(UNIT=fileunit, OPENED=opened)
          IF ( .NOT.opened ) EXIT file_opened
       END DO file_opened

#if defined(__PGI) || defined(_CRAYFTN)
       OPEN (UNIT=fileunit, FILE='_read_error.nml', IOSTAT=io_stat)
#else
       OPEN (UNIT=fileunit, STATUS='SCRATCH', IOSTAT=io_stat)
#endif

       ! Write sample namelist to the SCRATCH file.
       WRITE (UNIT=fileunit, NML=a_nml, IOSTAT=io_stat)
       WRITE (UNIT=fileunit, NML=b_nml, IOSTAT=io_stat)
       WRITE (UNIT=fileunit, IOSTAT=io_stat, FMT='(/,"&badType1_nml  i1=1, r1=''bad'' /",/)')
       WRITE (UNIT=fileunit, IOSTAT=io_stat, FMT='(/,"&badType2_nml  i1=1, r1=.true. /",/)')
       WRITE (UNIT=fileunit, IOSTAT=io_stat, FMT='(/,"&missingVar_nml  i2=1, r2=1.0e0, l1=.true. /",/)')

       ! Rewind for reading
       REWIND(UNIT=fileunit)

       ! Read the second namelist from the file -- check for namelist bug
       READ (UNIT=fileunit, NML=b_nml, IOSTAT=nml_iostats(1))
       REWIND(UNIT=fileunit)

       ! Read in bad type 1 --- Some compilers treat the string cast differently
       READ (UNIT=fileunit, NML=badType1_nml, IOSTAT=nml_iostats(2))
       REWIND(UNIT=fileunit)

       ! Read in bad type 2
       READ (UNIT=fileunit, NML=badType2_nml, IOSTAT=nml_iostats(3))
       REWIND(UNIT=fileunit)

       ! Read in missing variable/misstyped
       READ (UNIT=fileunit, NML=missingVar_nml, IOSTAT=nml_iostats(4))
       REWIND(UNIT=fileunit)

       ! Code for namelist not in file
       READ (UNIT=fileunit, NML=not_in_file_nml, IOSTAT=nml_iostats(5))

       ! Done, close file
       CLOSE (UNIT=fileunit)

       ! Some compilers don't handle the type casting as well as we would like.
       IF ( nml_iostats(2) * nml_iostats(3) .EQ. 0 ) THEN
          IF ( nml_iostats(2) .NE. 0 .AND. nml_iostats(3) .EQ. 0 ) THEN
             nml_iostats(3) = nml_iostats(2)
          ELSE IF ( nml_iostats(2) .EQ. 0 .AND. nml_iostats(3) .NE.0 ) THEN
             nml_iostats(2) = nml_iostats(3)
          ELSE 
             nml_iostats(2) = nml_iostats(4)
             nml_iostats(2) = nml_iostats(4)
          END IF
       END IF
    END IF

    ! Broadcast nml_errors
    CALL mpp_broadcast(nml_iostats,5,mpp_root_pe())
    nml_errors%multipleNMLSinFile = nml_iostats(1)
    nml_errors%badType1 = nml_iostats(2)
    nml_errors%badType2 = nml_iostats(3)
    nml_errors%missingVar = nml_iostats(4)
    nml_errors%NotInFile = nml_iostats(5)

    do_nml_error_init = .FALSE.
  END SUBROUTINE nml_error_init

!#######################################################################
! <SUBROUTINE NAME="write_version_number">

!   <OVERVIEW>
!     Prints to the log file (or a specified unit) the (cvs) version id string and
!     (cvs) tag name.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Prints to the log file (stdlog) or a specified unit the (cvs) version id string
!      and (cvs) tag name.
!   </DESCRIPTION>
!   <TEMPLATE>
!    call write_version_number ( version [, tag, unit] )
!   </TEMPLATE>

!   <IN NAME="version" TYPE="character(len=*)">
!    string that contains routine name and version number.
!   </IN>
!   <IN NAME="tag" TYPE="character(len=*)">
!    The tag/name string, this is usually the Name string
!    returned by CVS when checking out the code.
!   </IN>
!   <IN NAME="unit" TYPE="integer">
!    The Fortran unit number of an open formatted file. If this unit number 
!    is not supplied the log file unit number is used (stdlog). 
!   </IN>
! prints module version number to the log file of specified unit number

 subroutine write_version_number (version, tag, unit)

!   in:  version = string that contains routine name and version number
!
!   optional in:
!        tag = cvs tag name that code was checked out with
!        unit    = alternate unit number to direct output  
!                  (default: unit=stdlog)

   character(len=*), intent(in) :: version
   character(len=*), intent(in), optional :: tag 
   integer,          intent(in), optional :: unit 

   integer :: logunit 

   if (.not.module_is_initialized) call fms_init ( )

     logunit = stdlog()
     if (present(unit)) then
         logunit = unit
     else    
       ! only allow stdlog messages on root pe
         if ( mpp_pe() /= mpp_root_pe() ) return
     endif   

     if (present(tag)) then
         write (logunit,'(/,80("="),/(a))') trim(version), trim(tag)
     else    
         write (logunit,'(/,80("="),/(a))') trim(version)
     endif   

 end subroutine write_version_number
! </SUBROUTINE>

!#######################################################################


! <FUNCTION NAME="string_array_index">

!   <OVERVIEW>
!     match the input character string to a string
!     in an array/list of character strings
!   </OVERVIEW>
!   <DESCRIPTION>
!      Tries to find a match for a character string in a list of character strings.
!      The match is case sensitive and disregards blank characters to the right of
!      the string. 
!   </DESCRIPTION>
!   <TEMPLATE>
!      string_array_index ( string, string_array [, index] )
!   </TEMPLATE>

!   <IN NAME="string"  TYPE="character(len=*), scalar" >
!     Character string of arbitrary length.
!   </IN>
!   <IN NAME="string_array"  TYPE="character(len=*)" DIM="(:)">
!     Array/list of character strings.
!   </IN>
!   <OUT NAME="index"  TYPE="integer" >
!     The index of string_array where the first match was found. If
!            no match was found then index = 0.
!   </OUT>
!   <OUT NAME="string_array_index"  TYPE="logical" >
!     If an exact match was found then TRUE is returned, otherwise FALSE is returned.
!   </OUT>
!   <NOTE>
!     Examples
!      <PRE>
!       string = "def"
!       string_array = (/ "abcd", "def ", "fghi" /)

!       string_array_index ( string, string_array, index )

!       Returns: TRUE, index = 2
!      </PRE>
!   </NOTE>
! match the input character string to a string
! in an array/list of character strings

function string_array_index ( string, string_array, index ) result (found)
character(len=*),  intent(in)  :: string, string_array(:)
integer, optional, intent(out) :: index
logical :: found
integer :: i

! initialize this function to false
! loop thru string_array and exit when a match is found

  found = .false.
  if (present(index)) index = 0

  do i = 1, size(string_array(:))
    ! found a string match ?
    if ( trim(string) == trim(string_array(i)) ) then
         found = .true.
         if (present(index)) index = i
         exit
    endif
  enddo

end function string_array_index
! </FUNCTION>

!#######################################################################

! <FUNCTION NAME="monotonic_array">

!   <OVERVIEW>
!     Determines if a real input array has monotonically increasing or
!     decreasing values.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Determines if the real input array has monotonically increasing or
!     decreasing values.
!   </DESCRIPTION>
!   <TEMPLATE>
!     monotonic_array ( array [, direction] )
!   </TEMPLATE>

!   <IN NAME="array"  TYPE="real" DIM="(:)">
!     An array of real values. If the size(array) < 2 this function
!     assumes the array is not monotonic, no fatal error will occur.
!   </IN>
!   <OUT NAME="direction"  TYPE="integer" >
!     If the input array is:
!                >> monotonic (small to large) then direction = +1.
!                >> monotonic (large to small) then direction = -1.
!                >> not monotonic then direction = 0. 
!   </OUT>
!   <OUT NAME="monotonic_array"  TYPE="logical" >
!     If the input array of real values either increases or decreases monotonically
!      then TRUE is returned, otherwise FALSE is returned. 
!   </OUT>
! determines if the real input array has
! monotonically increasing or decreasing values

function monotonic_array ( array, direction )
real,    intent(in)            :: array(:)
integer, intent(out), optional :: direction
logical :: monotonic_array
integer :: i

! initialize
  monotonic_array = .false.
  if (present(direction)) direction = 0

! array too short
  if ( size(array(:)) < 2 ) return

! ascending
  if ( array(1) < array(size(array(:))) ) then
     do i = 2, size(array(:))
       if (array(i-1) < array(i)) cycle
       return
     enddo
     monotonic_array = .true.
     if (present(direction)) direction = +1

! descending
  else
     do i = 2, size(array(:))
       if (array(i-1) > array(i)) cycle
       return
     enddo
     monotonic_array = .true.
     if (present(direction)) direction = -1
  endif

end function monotonic_array
! </FUNCTION>

end module fms_mod
! <INFO>
!   <BUG>              
!     Namelist error checking may not work correctly with some compilers.
!
!     Users should beware when mixing Fortran reads and read_data calls. If a
!     Fortran read follows read_data and namelist variable read_all_pe = FALSE
!     (not the default), then the code will fail. It is safest if Fortran reads 
!     precede calls to read_data.
!   </BUG>
!   <ERROR MSG="unexpected EOF" STATUS="FATAL">
!     An unexpected end-of-file was encountered in a read_data call.
!     You may want to use the optional end argument to detect the EOF. 
!   </ERROR>
!   <NOTE>
!     1) If the <B>MPP</B> or <B>MPP_DOMAINS</B> stack size is exceeded the
!     program will terminate after printing the required size. 
!   
!     2) When running on a very small number of processors or for high
!     resolution models the default domains_stack_size will
!     probably be insufficient. 
!
!     3) The following performance routines in the <B>MPP</B> module are published by this module.
!<PRE>
!        mpp_clock_id, mpp_clock_begin, mpp_clock_end
!</PRE>
!        and associated parameters that are published:
!<PRE>
!        MPP_CLOCK_SYNC, MPP_CLOCK_DETAILED, CLOCK_COMPONENT, CLOCK_SUBCOMPONENT,
!        CLOCK_MODULE_DRIVER, CLOCK_MODULE, CLOCK_ROUTINE, CLOCK_LOOP, CLOCK_INFRA
!</PRE>
!
!     4) Here is an example of how to time a section of code.<BR/>
!<PRE>
!          use fms_mod, only: mpp_clock_id, mpp_clock_begin, &
!                             mpp_clock_end. MPP_CLOCK_SYNC, &
!                             CLOCK_MODULE_DRIVER
!          integer :: id_mycode
!
!          id_mycode = mpp_clock_id ('mycode loop', flags=MPP_CLOCK_SYNC, grain=CLOCK_MODULE_DRIVER)
!          call mpp_clock_begin (id_mycode)
!                        :
!                        :
!           ~~ this code will be timed ~~ 
!                        :
!                        :
!          call mpp_clock_end (id_mycode)
! </PRE>
!        Note: <TT>CLOCK_MODULE_DRIVER</TT> can be replaced with
!        CLOCK_COMPONENT, CLOCK_SUBCOMPONENT, CLOCK_MODULE_DRIVER, CLOCK_MODULE, CLOCK_ROUTINE,
!        CLOCK_LOOP, or CLOCK_INFRA.
!        
!   </NOTE>
!   <FUTURE>           
!     NetCDF facilities for reading and writing restart files and (IEEE32) 
!       data files.
!    </FUTURE>
!    <FUTURE>
!     May possible split the FMS module into two modules. 
!
!      i.general utilities (FMS_MOD) <BR/>
!     ii.I/O utilities (FMS_IO_MOD) 
!    </FUTURE>
! </INFO>

module amip_interp_mod


! <CONTACT EMAIL="Bruce.Wyman@noaa.gov">
!   Bruce Wyman
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!   Provides observed SST and ice mask data sets that have been
!   interpolated onto your model's grid.
! </OVERVIEW>

! <DESCRIPTION>
! Three possible data sets are available:
!
!     1)  <LINK SRC="http://www-pcmdi.llnl.gov/amip">AMIP 1</LINK>        from Jan 1979 to Jan 1989 (2 deg x 2 deg)<BR/>
!     2)  <LINK SRC="amip_interp.rey_oi.txt">Reynolds OI</LINK>   from Nov 1981 to Jan 1999 (1 deg x 1 deg)<BR/>
!     3)  <LINK SRC="ftp://podaac.jpl.nasa.gov/pub/sea_surface_temperature/reynolds/rsst/doc/rsst.html">Reynolds EOF</LINK>  from Jan 1950 to Dec 1998 (2 deg x 2 deg)<BR/><BR/>
!
!     All original data are observed monthly means. This module
!     interpolates linearly in time between pairs of monthly means.
!     Horizontal interpolation is done using the horiz_interp module.
!
!     When a requested date falls outside the range of dates available
!     a namelist option allows for use of the climatological monthly
!     mean values which are computed from all of the data in a particular
!     data set.
! </DESCRIPTION>

! <DATASET NAME="AMIP 1">
!   from Jan 1979 to Jan 1989 (2 deg x 2 deg).
! </DATASET>
! <DATASET NAME="Reynolds OI">
!   from Nov 1981 to Jan 1999 (1 deg x 1 deg)
!             The analysis uses in situ and satellite SST's plus
!             SST's simulated by sea-ice cover.
! </DATASET>
! <DATASET NAME="Reynolds EOF">
!   from Jan 1950 to Dec 1998 (2 deg x 2 deg)
!             NCEP Reynolds Historical Reconstructed Sea Surface Temperature
!             The analysis uses both in-situ SSTs and satellite derived SSTs
!             from the NOAA Advanced Very High Resolution Radiometer.
!             In-situ data is used from 1950 to 1981, while both AVHRR derived
!             satellite SSTs and in-situ data are used from 1981 to the
!             end of 1998.
!
! Note: The data set used by this module have been reformatted as 32-bit IEEE.
!   The data values are packed into 16-bit integers.
!
!   The data sets are read from the following files:
!
!         amip1           INPUT/amip1_sst.data
!         reynolds_io     INPUT/reyoi_sst.data
!         reynolds_eof    INPUT/reynolds_sst.data
! </DATASET>
!-----------------------------------------------------------------------

use  time_interp_mod, only: time_interp, fraction_of_year

use time_manager_mod, only: time_type, operator(+), operator(>), &
                             get_date, set_time, set_date

! add by JHC
use get_cal_time_mod, only: get_cal_time
use mpp_io_mod, only : mpp_open, mpp_read, MPP_RDONLY, MPP_NETCDF, & 
                       MPP_MULTI, MPP_SINGLE, mpp_close, mpp_get_times
! end add by JHC

use  horiz_interp_mod, only: horiz_interp_init, horiz_interp,  &
                             horiz_interp_new, horiz_interp_del, &
                             horiz_interp_type, assignment(=)

use           fms_mod, only: file_exist, error_mesg, write_version_number,  &
                             NOTE, WARNING, FATAL, stdlog, check_nml_error, &
                             open_namelist_file, open_ieee32_file,          &
                             mpp_pe, close_file, lowercase, mpp_root_pe,    &
                             NOTE, mpp_error, fms_error_handler
use        fms_io_mod, only: read_data, field_size ! add by JHC     
use     constants_mod, only: TFREEZE, pi
use      platform_mod, only: R4_KIND, I2_KIND
use mpp_mod,           only: input_nml_file

implicit none
private

!-----------------------------------------------------------------------
!----------------- Public interfaces -----------------------------------

public amip_interp_init, get_amip_sst, get_amip_ice, amip_interp_new, &
       amip_interp_del, amip_interp_type, assignment(=)

!-----------------------------------------------------------------------
!----------------- Public Data -----------------------------------
integer :: i_sst = 1200
integer :: j_sst = 600
real, parameter:: big_number = 1.E30
logical :: forecast_mode = .false.
real, allocatable, dimension(:,:) ::  sst_ncep, sst_anom

public i_sst, j_sst, sst_ncep, sst_anom, forecast_mode, use_ncep_sst

!-----------------------------------------------------------------------
!--------------------- private below here ------------------------------

!  ---- version number -----

character(len=128) :: version = '$Id$'
character(len=128) :: tagname = '$Name$'

   real, allocatable:: temp1(:,:), temp2(:,:)
! add by JHC
   real, allocatable, dimension(:,:) :: tempamip
! end add by JHC
!-----------------------------------------------------------------------
!------ private defined data type --------

type date_type
   sequence
   integer :: year, month, day
end type

interface assignment(=)
  module procedure  amip_interp_type_eq
end interface

interface operator (==)
   module procedure date_equals
end interface

interface operator (/=)
   module procedure date_not_equals
end interface

interface operator (>)
   module procedure date_gt
end interface

! <INTERFACE NAME="amip_interp_new">
!   <OVERVIEW>
!     Function that initializes data needed for the horizontal
!         interpolation between the sst grid and model grid. The 
!         returned variable of type amip_interp_type is needed when
!         calling get_amip_sst and get_amip_ice.
!   </OVERVIEW>
!   <DESCRIPTION>
!      Function that initializes data needed for the horizontal
!         interpolation between the sst grid and model grid. The 
!         returned variable of type amip_interp_type is needed when
!         calling get_amip_sst and get_amip_ice.
!   </DESCRIPTION>
!   <IN NAME="lon">
!     Longitude in radians of the model's grid box edges (1d lat/lon grid case)
!     or at grid box mid-point (2d case for arbitrary grids).
!   </IN>
!   <IN NAME="lat">
!     Latitude in radians of the model's grid box edges (1d lat/lon grid case)
!     or at grid box mid-point (2d case for arbitrary grids).
!   </IN>
!   <IN NAME="mask">
!     A mask for the model grid.
!   </IN>
!   <IN NAME="use_climo">
!     Flag the specifies that monthly mean climatological values will be used.
!   </IN>
!   <IN NAME="use_annual">
!     Flag the specifies that the annual mean climatological
!              will be used.  If both use_annual = use_climo = true,
!              then use_annual = true will be used.
!   </IN>
!   <IN NAME="interp_method">
!     specify the horiz_interp scheme. = "conservative" means conservative scheme, 
!     = "bilinear" means  bilinear interpolation.
!   </IN>
!   <OUT NAME="Interp">
!     A defined data type variable needed when calling get_amip_sst and get_amip_ice.
!   </OUT>
!   <TEMPLATE>
!     Interp = amip_interp_new ( lon, lat, mask, use_climo, use_annual, interp_method )
!   </TEMPLATE>

!   <NOTE>
!     This function may be called to initialize multiple variables
!     of type amip_interp_type.  However, there currently is no
!     call to release the storage used by this variable.
!   </NOTE>
!   <NOTE>
!     The size of input augment mask must be a function of the size
!     of input augments lon and lat. The first and second dimensions
!     of mask must equal (size(lon,1)-1, size(lat,2)-1).
!   </NOTE>

!   <ERROR MSG="the value of the namelist parameter DATA_SET being used is not allowed" STATUS="FATAL">
!     Check the value of namelist variable DATA_SET.
!   </ERROR>
!   <ERROR MSG="requested input data set does not exist" STATUS="FATAL">
!     The data set requested is valid but the data does not exist in
!      the INPUT subdirectory. You may have requested amip2 data which
!      has not been officially set up.
!      See the section on DATA SETS to properly set the data up.
!   </ERROR>
!   <ERROR MSG="use_climo mismatch" STATUS="FATAL">
!     The namelist variable date_out_of_range = 'fail' and the amip_interp_new
!     argument use_climo = true.  This combination is not allowed.
!   </ERROR>
!   <ERROR MSG="use_annual(climo) mismatch" STATUS="FATAL">
!     The namelist variable date_out_of_range = 'fail' and the amip_interp_new
!     argument use_annual = true.  This combination is not allowed.
!   </ERROR>
interface amip_interp_new
   module procedure amip_interp_new_1d
   module procedure amip_interp_new_2d
end interface
! </INTERFACE>


!-----------------------------------------------------------------------
!----- public data type ------
! <DATA NAME="amip_interp_type"  TYPE="type (horiz_interp_type)"  >
!   All variables in this data type are PRIVATE. It contains information
!   needed by the interpolation module (exchange_mod) and buffers data.
! </DATA>
type amip_interp_type
   private
   type (horiz_interp_type) :: Hintrp, Hintrp2 ! add by JHC
   real, pointer            ::    data1(:,:) =>NULL(), &
                                  data2(:,:) =>NULL()
   type (date_type)         ::    Date1,       Date2
   logical                  :: use_climo, use_annual
   logical                  :: I_am_initialized=.false.
end type

!-----------------------------------------------------------------------
!  ---- resolution/grid variables ----

   integer :: mobs, nobs
   real, allocatable :: lon_bnd(:), lat_bnd(:)

!  ---- global unit & date ----

   integer, parameter :: maxc = 128
   integer :: unit
   character(len=maxc) :: file_name_sst, file_name_ice

   type (date_type) :: Curr_date = date_type( -99, -99, -99 )
   type (date_type) :: Date_end  = date_type( -99, -99, -99 )

   real             :: tice_crit_k
   integer(I2_KIND) ::  ice_crit

   logical :: module_is_initialized = .false.

!-----------------------------------------------------------------------
!---- namelist ----

! <NAMELIST NAME="amip_interp_nml">
!   <DATA NAME="data_set" TYPE="character(len=24)" DEFAULT="data_set = 'amip1'">
!     Name/type of SST data that will be used.
!  <BR/>
!        Possible values (case-insensitive) are: <BR/>
!                          1) amip1<BR/>
!                          2) reynolds_eof<BR/>
!                          3) reynolds_oi<BR/>
!        See the <LINK SRC="amip_interp.html#DATA SETS">data set </LINK>section for more on these data.
!   </DATA>

!   <DATA NAME="date_out_of_range" TYPE="character(len=16)" DEFAULT="date_out_of_range = 'fail'">
!     Controls the use of climatological monthly mean data when
!     the requested date falls outside the range of the data set.<BR/>
!     Possible values are:
!     <PRE>
!   fail      - program will fail if requested date is prior
!               to or after the data set period.
!   initclimo - program uses climatological requested data is
!               prior to data set period and will fail if
!               requested date is after data set period.
!   climo     - program uses climatological data anytime.
!    </PRE>
!   </DATA>

!   <DATA NAME="tice_crit" TYPE="real" DEFAULT="tice_crit = -1.80">
!     Freezing point of sea water in degC or degK.
!   </DATA>
!   <DATA NAME="verbose" TYPE="integer" DEFAULT="verbose = 0">
!     Controls printed output, 0 <= verbose <= 3
!   </DATA>

!---- additional parameters for controlling zonal prescribed sst ----
!---- these parameters only have an effect when use_zonal=.true. ----
!   <DATA NAME="use_zonal" TYPE="logical" DEFAULT=".false.">
!     Flag to selected zonal sst or data set.
!   </DATA>
!   <DATA NAME="teq" TYPE="real" DEFAULT="teq=305.">
!     sst at the equator.
!   </DATA>
!   <DATA NAME="tdif" TYPE="real" DEFAULT="tdif=50.">
!     Equator to pole sst difference.
!   </DATA>
!   <DATA NAME="tann" TYPE="real" DEFAULT="tann=20.">
!     Amplitude of annual cycle.
!   </DATA>
!   <DATA NAME="tlag" TYPE="real" DEFAULT="tlag=0.875">
!     Offset for time of year (for annual cycle).
!   </DATA>

!   <DATA NAME="amip_date" TYPE="integer(3)" DEFAULT="/-1,-1,-1/">
!     Single calendar date in integer "(year,month,day)" format
!     that is used only if set with year>0, month>0, day>0. 
!     If used, model calendar date is replaced by this date, 
!     but model time of day is still used to determine ice/sst.
!     Used for repeating-single-day (rsd) experiments.
!   </DATA>

!   <DATA NAME="sst_pert" TYPE="real" DEFAULT="sst_pert=0.">
!     Temperature perturbation in degrees Kelvin added onto the SST.
!                The perturbation is globally-uniform (even near sea-ice).
!                It is only used when abs(sst_pert) > 1.e-4.  SST perturbation runs
!                may be useful in accessing model sensitivities.
!   </DATA>
 character(len=24) :: data_set = 'amip1'   !  use 'amip1'
                                           !      'amip2'
                                           !      'reynolds_eof'
                                           !      'reynolds_oi'
                                           !      'hurrell'
                                           ! add by JHC:  
                                           !      'daily', when "use_daily=.T."

 character(len=16) :: date_out_of_range = 'fail'  !  use 'fail'
                                                  !      'initclimo'
                                                  !      'climo' 

 real    :: tice_crit    = -1.80       !  in degC or degK
 integer :: verbose      = 0           !  0 <= verbose <= 3

!parameters for prescribed zonal sst option
 logical :: use_zonal    = .false.
 real :: teq  = 305.
 real :: tdif = 50.
 real :: tann = 20.
 real :: tlag = 0.875


!amip date for repeating single day (rsd) option
 integer :: amip_date(3)=(/-1,-1,-1/)

!global temperature perturbation used for sensitivity experiments
 real :: sst_pert = 0.

! add by JHC
 character(len=6) :: sst_pert_type = 'fixed'  ! use 'random' or 'fixed'
 logical :: do_sst_pert = .false. 
 logical :: use_daily = .false. ! if '.true.', give 'data_set = 'daily''
! end add by JHC

! SJL: During nudging:   use_ncep_sst = .T.;  no_anom_sst = .T.
!      during forecast:  use_ncep_sst = .T.;  no_anom_sst = .F.
! For seasonal forecast: use_ncep_ice = .F.

 logical :: use_ncep_sst = .false.
 logical ::  no_anom_sst = .true.
 logical :: use_ncep_ice = .false.
 logical :: interp_oi_sst = .false.       ! changed to false for regular runs

 namelist /amip_interp_nml/ use_ncep_sst, no_anom_sst, use_ncep_ice,  tice_crit, &
                            interp_oi_sst, data_set, date_out_of_range,          &
                            use_zonal, teq, tdif, tann, tlag, amip_date,         &
                            ! add by JHC
                            sst_pert, sst_pert_type, do_sst_pert,                &
                            use_daily,                                           &
                            ! end add by JHC
                            verbose, i_sst, j_sst, forecast_mode
! </NAMELIST>


!-----------------------------------------------------------------------

contains

!#######################################################################
! <SUBROUTINE NAME="get_amip_sst" INTERFACE="get_amip_sst">
!   <IN NAME="Time" TYPE="time_type" ></IN>
!   <OUT NAME="sst" TYPE="real" DIM="(:,:)"> </OUT>                  
!   <INOUT NAME="Interp" TYPE="amip_interp_type"> </INOUT>
! </SUBROUTINE>

! modified by JHC
subroutine get_amip_sst (Time, Interp, sst, err_msg, lon_model, lat_model)
!subroutine get_amip_sst (Time, Interp, sst, err_msg)

   type (time_type),         intent(in)    :: Time
   type (amip_interp_type),  intent(inout) :: Interp
   real,                     intent(out)   ::  sst(:,:)
   character(len=*), optional, intent(out) :: err_msg

   real, dimension(mobs,nobs) :: sice

    integer :: year1, year2, month1, month2
    real    :: fmonth
    type (date_type) :: Date1, Date2, Udate1, Udate2

    type(time_type) :: Amip_Time
    integer :: tod(3),dum

! add by JHC
    real,    intent(in), dimension(:,:), optional :: lon_model, lat_model
    real :: pert
    integer :: i, j, mobs_sst, nobs_sst 
    integer :: jhctod(6)
    type (time_type) :: Udate
    character(len=4) :: yyyy
    integer :: nrecords, ierr, k, yr, mo, dy
    integer :: siz(4)
    integer, dimension(:), allocatable :: ryr, rmo, rdy
    character(len=30) :: time_unit
    real, dimension(:), allocatable :: timeval
    character(len=maxc) :: ncfilename
! end add by JHC


    if(present(err_msg)) err_msg = ''
    if(.not.Interp%I_am_initialized) then
      if(fms_error_handler('get_amip_sst','The amip_interp_type variable is not initialized',err_msg)) return
    endif

!-----------------------------------------------------------------------
!----- compute zonally symetric sst ---------------

    if ( use_ncep_sst .and. forecast_mode ) no_anom_sst = .false.

    if (all(amip_date>0)) then
       call get_date(Time,dum,dum,dum,tod(1),tod(2),tod(3))
       Amip_Time = set_date(amip_date(1),amip_date(2),amip_date(3),tod(1),tod(2),tod(3))
    else
       Amip_Time = Time
    endif

! add by JHC
if ( .not.use_daily ) then 
! end add by JHC

   if ( .not. allocated(temp1) ) allocate (temp1(mobs,nobs))
   if ( .not. allocated(temp2) ) allocate (temp2(mobs,nobs))

   if (use_zonal) then
      call zonal_sst (Amip_Time, sice, temp1)
      call horiz_interp ( Interp%Hintrp, temp1, sst )
   else

!-----------------------------------------------------------------------
!---------- get new observed sea surface temperature -------------------

! ---- time interpolation for months -----
     call time_interp (Amip_Time, fmonth, year1, year2, month1, month2)
! ---- force climatology ----
     if (Interp % use_climo) then
         year1=0; year2=0
     endif
     if (Interp % use_annual) then
          year1=0;  year2=0
         month1=0; month2=0
     endif
! ---------------------------

     Date1 = date_type( year1, month1, 0 )
     Date2 = date_type( year2, month2, 0 )

!  -- open/rewind file --
     unit = -1
!-----------------------------------------------------------------------


      if (Date1 /= Interp % Date1) then
!       ---- use Date2 for Date1 ----
          if (Date1 == Interp % Date2) then
              Interp % Date1 = Interp % Date2
              Interp % data1 = Interp % data2
              temp1(:,:) = temp2(:,:)   ! SJL BUG fix: June 24, 2011
          else
              call read_record ('sst', Date1, Udate1, temp1)
              if ( use_ncep_sst .and. (.not. no_anom_sst) ) then
                   temp1(:,:) = temp1(:,:) + sst_anom(:,:)
              endif
              call horiz_interp ( Interp%Hintrp, temp1, Interp%data1 )
              call clip_data ('sst', Interp%data1)
             Interp % Date1 = Date1
          endif
      endif

!-----------------------------------------------------------------------

      if (Date2 /= Interp % Date2) then
          call read_record ('sst', Date2, Udate2, temp2)
          if ( use_ncep_sst .and. (.not. no_anom_sst) ) then
               temp2(:,:) = temp2(:,:) + sst_anom(:,:)
          endif
          call horiz_interp ( Interp%Hintrp, temp2, Interp%data2 )
          call clip_data ('sst', Interp%data2)
          Interp % Date2 = Date2
      endif

!   ---- if the unit was opened, close it and print dates ----

        if (unit /= -1) then
           call close_file (unit)
           if (verbose > 0 .and. mpp_pe() == 0)         &
                                 call print_dates (Amip_Time,   &
                                  Interp % Date1, Udate1,  &
                                  Interp % Date2, Udate2, fmonth)
        endif

!-----------------------------------------------------------------------
!---------- time interpolation (between months) of sst's ---------------
!-----------------------------------------------------------------------
    sst = Interp % data1 + fmonth * (Interp % data2 - Interp % data1)

!-------------------------------------------------------------------------------
! SJL mods for NWP and TCSF ---
!      Nudging runs: (Note: NCEP SST updated only every 6-hr)
!      Compute SST anomaly from global SST datasets for subsequent forecast runs
!-------------------------------------------------------------------------------
    if ( use_ncep_sst .and. no_anom_sst ) then
         sst_anom(:,:) = sst_ncep(:,:) - (temp1(:,:) + fmonth*(temp2(:,:) - temp1(:,:)) )
         call horiz_interp ( Interp%Hintrp, sst_ncep, sst )
         call clip_data ('sst', sst)
    endif

!!! DEBUG CODE
!          call get_date(Amip_Time,jhctod(1),jhctod(2),jhctod(3),jhctod(4),jhctod(5),jhctod(6))
!          if (mpp_pe() == 0) then 
!             write (*,200) 'JHC: use_daily = F, AMIP_Time: ',jhctod(1),jhctod(2),jhctod(3),jhctod(4),jhctod(5),jhctod(6)
!             write (*,300) 'JHC: use_daily = F, interped SST: ', sst(1,1),sst(5,5),sst(10,10)
!          endif
!!! END DEBUG CODE


  endif

! add by JHC
else
    call get_date(Amip_Time,jhctod(1),jhctod(2),jhctod(3),jhctod(4),jhctod(5),jhctod(6))
     if (mpp_pe() == mpp_root_pe()) write(*,200) 'amip_interp_mod: use_daily = T, Amip_Time = ',jhctod(1),jhctod(2),jhctod(3),jhctod(4),jhctod(5),jhctod(6) 
 
    yr = jhctod(1); mo = jhctod(2); dy = jhctod(3)
   
    write (yyyy,'(i4)') jhctod(1)

    file_name_sst = 'INPUT/' // 'sst.day.mean.'//yyyy//'.v2.nc'
    ncfilename = trim(file_name_sst)
    time_unit = 'days since 1978-01-01 00:00:00'

    mobs_sst = 1440;  nobs_sst = 720 
 
    call set_sst_grid_edges_daily(mobs_sst, nobs_sst)
    call horiz_interp_new ( Interp%Hintrp2, lon_bnd, lat_bnd, &
                             lon_model, lat_model, interp_method="bilinear" )


    if ( (.NOT. file_exist(ncfilename))  ) call mpp_error ('amip_interp_mod', &
             'cannot find daily SST input data file: '//trim(ncfilename), NOTE)

    if (file_exist(ncfilename)) then
        if (mpp_pe() == mpp_root_pe()) call mpp_error ('amip_interp_mod', &
             'Reading NetCDF formatted daily SST from: '//trim(ncfilename), NOTE)

        call field_size(ncfilename, 'TIME', siz)
        nrecords = siz (1)
        if (nrecords < 1) call mpp_error('amip_interp_mod', &
                           'Invalid number of SST records in daily SST data file: '//trim(ncfilename), FATAL)
        allocate(timeval(nrecords), ryr(nrecords), rmo(nrecords), rdy(nrecords))

        call mpp_open( unit, ncfilename, MPP_RDONLY, MPP_NETCDF, MPP_MULTI, MPP_SINGLE )
        call mpp_get_times(unit, timeval)
        call mpp_close(unit)

!!! DEBUG CODE
!          if (mpp_pe() == 0) then 
!             print *, 'JHC: nrecords = ', nrecords
!             print *, 'JHC: TIME = ', timeval
!          endif
!!! END DEBUG CODE

        ierr = 1
        do k = 1, nrecords

          Udate = get_cal_time (timeval(k), time_unit, 'julian')
          call get_date(Udate,jhctod(1),jhctod(2),jhctod(3),jhctod(4),jhctod(5),jhctod(6))
          ryr(k) = jhctod(1); rmo(k) = jhctod(2); rdy(k) = jhctod(3)

          if ( yr == ryr(k) .and. mo == rmo(k) .and. dy == rdy (k) ) ierr = 0
          if (ierr==0) exit

        enddo
!!! DEBUG CODE
             if (mpp_pe() == 0) then 
             print *, 'JHC: k =', k 
             print *, 'JHC: ryr(k) rmo(k) rdy(k)',ryr(k), rmo(k), rdy(k) 
             print *, 'JHC:  yr     mo     dy   ',yr, mo, dy 
          endif
!!! END DEBUG CODE
        if (ierr .ne. 0) call mpp_error('amip_interp_mod', &
                         'Model time is out of range not in SST data: '//trim(ncfilename), FATAL)
    endif ! if(file_exist(ncfilename))
     

   !---- read NETCDF data ----
     if ( .not. allocated(tempamip) ) allocate (tempamip(mobs_sst,nobs_sst))

     if (file_exist(ncfilename)) then
          call read_data(ncfilename, 'SST', tempamip, timelevel=k, no_domain=.true.)
          tempamip = tempamip + TFREEZE

!!! DEBUG CODE
!          if (mpp_pe() == 0) then 
!             print*, 'JHC: TFREEZE = ', TFREEZE
!             print*, lbound(sst)
!             print*, ubound(sst)
!             print*, lbound(tempamip)
!             print*, ubound(tempamip)
!             write(*,300) 'JHC: tempamip : ', tempamip(100,100), tempamip(200,200), tempamip(300,300)
!          endif
!!! END DEBUG CODE

          call horiz_interp ( Interp%Hintrp2, tempamip, sst )
          call clip_data ('sst', sst)

     endif 

!!! DEBUG CODE
!          if (mpp_pe() == 400) then 
!             write(*,300)'JHC: use_daily = T, daily SST: ', sst(1,1),sst(5,5),sst(10,10)
!             print *,'JHC: use_daily = T, daily SST: ', sst
!          endif
!!! END DEBUG CODE

200 format(a35, 6(i5,1x))
300 format(a35, 3(f7.3,2x))

endif
! end add by JHC

! add by JHC: add on non-zero sea surface temperature perturbation (namelist option)
!             This perturbation may be useful in accessing model sensitivities

 if ( do_sst_pert ) then
      
      if ( trim(sst_pert_type) == 'fixed' ) then
          sst = sst + sst_pert
      else if ( trim(sst_pert_type) == 'random' ) then
          call random_seed()
!!! DEBUG CODE
!    	  if (mpp_pe() == 0) then
!             print*, 'mobs = ', mobs	
!             print*, 'nobs = ', nobs	
!             print*, lbound(sst)
!             print*, ubound(sst)
!          endif
!!! END DEBUG CODE
          do i = 1, size(sst,1)
          do j = 1, size(sst,2)
             call random_number(pert)
             sst (i,j) = sst (i,j) + sst_pert*((pert-0.5)*2)
          end do
          end do
      endif

  endif
! end add by JHC
   
!-----------------------------------------------------------------------

 end subroutine get_amip_sst


!#######################################################################
! <SUBROUTINE NAME="get_amip_ice" INTERFACE="get_amip_ice">
!   <IN NAME="Time"  TYPE="time_type"  > </IN>
!   <OUT NAME="ice" TYPE="real" DIM="(:,:)"> </OUT>                  
!   <INOUT NAME="Interp" TYPE="amip_interp_type"> </INOUT>
! </SUBROUTINE>

subroutine get_amip_ice (Time, Interp, ice, err_msg)

   type (time_type),         intent(in)    :: Time
   type (amip_interp_type),  intent(inout) :: Interp
   real,                     intent(out)   :: ice(:,:)
   character(len=*), optional, intent(out) :: err_msg

    real, dimension(mobs,nobs) :: sice, temp

    integer :: year1, year2, month1, month2
    real    :: fmonth
    type (date_type) :: Date1, Date2, Udate1, Udate2

    type(time_type) :: Amip_Time
    integer :: tod(3),dum

    if(present(err_msg)) err_msg = ''
    if(.not.Interp%I_am_initialized) then
      if(fms_error_handler('get_amip_ice','The amip_interp_type variable is not initialized',err_msg)) return
    endif

!-----------------------------------------------------------------------
!----- compute zonally symetric sst ---------------


    if (any(amip_date>0)) then

       call get_date(Time,dum,dum,dum,tod(1),tod(2),tod(3))

       Amip_Time = set_date(amip_date(1),amip_date(2),amip_date(3),tod(1),tod(2),tod(3))

    else

       Amip_Time = Time
       
    endif
       

if (use_zonal) then
   call zonal_sst (Amip_Time, sice, temp)
   call horiz_interp ( Interp%Hintrp, sice, ice )
else

!-----------------------------------------------------------------------
!---------- get new observed sea surface temperature -------------------

! ---- time interpolation for months -----

   call time_interp (Amip_Time, fmonth, year1, year2, month1, month2)
   
! ---- force climatology ----
   if (Interp % use_climo) then
       year1=0; year2=0
   endif
   if (Interp % use_annual) then
        year1=0;  year2=0
       month1=0; month2=0
   endif
! ---------------------------

   Date1 = date_type( year1, month1, 0 )
   Date2 = date_type( year2, month2, 0 )

   unit = -1
!-----------------------------------------------------------------------

    if (Date1 /= Interp % Date1) then
!       ---- use Date2 for Date1 ----
        if (Date1 == Interp % Date2) then
            Interp % Date1 = Interp % Date2
            Interp % data1 = Interp % data2
        else
!-- SJL -------------------------------------------------------------
! Can NOT use ncep_sst to determine sea_ice For seasonal forecast
! Use climo sea ice for seasonal runs
            if ( use_ncep_sst .and. use_ncep_ice ) then
               where ( sst_ncep <= (TFREEZE+tice_crit) )
                   sice = 1.
               elsewhere
                   sice = 0.
               endwhere
            else
               call read_record ('ice', Date1, Udate1, sice)
            endif
!--------------------------------------------------------------------
            call horiz_interp ( Interp%Hintrp, sice, Interp%data1 )
            call clip_data ('ice', Interp%data1)
            Interp % Date1 = Date1
        endif
    endif

!-----------------------------------------------------------------------

    if (Date2 /= Interp % Date2) then

!-- SJL -------------------------------------------------------------
            if ( use_ncep_sst .and. use_ncep_ice ) then
               where ( sst_ncep <= (TFREEZE+tice_crit) )
                   sice = 1.
               elsewhere
                   sice = 0.
               endwhere
            else
               call read_record ('ice', Date2, Udate2, sice)
            endif
!--------------------------------------------------------------------
        call horiz_interp ( Interp%Hintrp, sice, Interp%data2 )
        call clip_data ('ice', Interp%data2)
        Interp % Date2 = Date2

    endif

!   ---- if the unit was opened, close it and print dates ----

      if (unit /= -1) then
         call close_file (unit)
         if (verbose > 0 .and. mpp_pe() == 0)         &
                               call print_dates (Amip_Time,   &
                                Interp % Date1, Udate1,  &
                                Interp % Date2, Udate2, fmonth)
      endif

!-----------------------------------------------------------------------
!---------- time interpolation (between months) ------------------------
!-----------------------------------------------------------------------

   ice = Interp % data1 + fmonth * (Interp % data2 - Interp % data1)

endif

!-----------------------------------------------------------------------

 end subroutine get_amip_ice



!#######################################################################

! <FUNCTION NAME="amip_interp_new_1d" INTERFACE="amip_interp_new">

!   <IN NAME="lon" TYPE="real" DIM="(:)"> </IN>
!   <IN NAME="lat" TYPE="real" DIM="(:)"> </IN>
!   <IN NAME="mask" TYPE="logical" DIM="(:,:)"> </IN>
!   <IN NAME="use_climo" TYPE="logical" DEFAULT="use_climo = .false."> </IN>
!   <IN NAME="use_annual" TYPE="logical" DEFAULT="use_annual = .false."> </IN>
!   <IN NAME="interp_method" TYPE="character(len=*), optional" DEFAULT="interp_method = conservative"></IN>
!   <OUT NAME="Interp" TYPE="amip_interp_type"> </OUT>

 function amip_interp_new_1d ( lon , lat , mask , use_climo, use_annual, &
                                interp_method ) result (Interp)

 real,    intent(in), dimension(:)   :: lon, lat
 logical, intent(in), dimension(:,:) :: mask
 character(len=*), intent(in), optional       :: interp_method
 logical, intent(in), optional       :: use_climo, use_annual

   type (amip_interp_type) :: Interp

   if(.not.module_is_initialized) call amip_interp_init

   Interp % use_climo  = .false.
   if (present(use_climo)) Interp % use_climo  = use_climo
   Interp % use_annual = .false.
   if (present(use_annual)) Interp % use_annual  = use_annual

   if ( date_out_of_range == 'fail' .and. Interp%use_climo ) &
      call error_mesg ('amip_interp_new_1d', 'use_climo mismatch', FATAL)

   if ( date_out_of_range == 'fail' .and. Interp%use_annual ) &
      call error_mesg ('amip_interp_new_1d', 'use_annual(climo) mismatch', FATAL)

   Interp % Date1 = date_type( -99, -99, -99 )
   Interp % Date2 = date_type( -99, -99, -99 )

!-----------------------------------------------------------------------
!   ---- initialization of horizontal interpolation ----

    call horiz_interp_new ( Interp%Hintrp, lon_bnd, lat_bnd, &
                             lon, lat, interp_method= interp_method )

    allocate ( Interp % data1 (size(lon(:))-1,size(lat(:))-1), &
               Interp % data2 (size(lon(:))-1,size(lat(:))-1)  )

    Interp%I_am_initialized = .true.

   end function amip_interp_new_1d
! </FUNCTION>

!#######################################################################
! <FUNCTION NAME="amip_interp_new_2d" INTERFACE="amip_interp_new">
!   <IN NAME="lon" TYPE="real" DIM="(:,:)"> </IN>
!   <IN NAME="lat" TYPE="real" DIM="(:,:)"> </IN>
!   <IN NAME="mask" TYPE="logical" DIM="(:,:)"> </IN>
!   <IN NAME="use_climo" TYPE="logical" DEFAULT="use_climo = .false."> </IN>
!   <IN NAME="use_annual" TYPE="logical" DEFAULT="use_annual = .false."> </IN>
!   <IN NAME="interp_method" TYPE="character(len=*), optional" DEFAULT="interp_method = conservative "></IN>
!   <OUT NAME="Interp" TYPE="amip_interp_type"> </OUT>

 function amip_interp_new_2d ( lon , lat , mask , use_climo, use_annual, &
                                interp_method ) result (Interp)

 real,    intent(in), dimension(:,:)   :: lon, lat
 logical, intent(in), dimension(:,:) :: mask
 character(len=*), intent(in), optional :: interp_method
 logical, intent(in), optional       :: use_climo, use_annual

   type (amip_interp_type) :: Interp

   if(.not.module_is_initialized) call amip_interp_init

   Interp % use_climo  = .false.
   if (present(use_climo)) Interp % use_climo  = use_climo
   Interp % use_annual = .false.
   if (present(use_annual)) Interp % use_annual  = use_annual

   if ( date_out_of_range == 'fail' .and. Interp%use_climo ) &
      call error_mesg ('amip_interp_new_2d', 'use_climo mismatch', FATAL)

   if ( date_out_of_range == 'fail' .and. Interp%use_annual ) &
      call error_mesg ('amip_interp_new_2d', 'use_annual(climo) mismatch', FATAL)

   Interp % Date1 = date_type( -99, -99, -99 )
   Interp % Date2 = date_type( -99, -99, -99 )

!-----------------------------------------------------------------------
!   ---- initialization of horizontal interpolation ----

   call horiz_interp_new ( Interp%Hintrp, lon_bnd, lat_bnd, &
                           lon, lat, interp_method = interp_method)

   allocate ( Interp % data1 (size(lon,1),size(lat,2)), &
              Interp % data2 (size(lon,1),size(lat,2))) 

   Interp%I_am_initialized = .true.

   end function amip_interp_new_2d
! </FUNCTION>

!#######################################################################

 subroutine amip_interp_init()

   integer :: unit,io,ierr

!-----------------------------------------------------------------------

    call horiz_interp_init

!   ---- read namelist ----

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, amip_interp_nml, iostat=io)
    ierr = check_nml_error(io,'amip_interp_nml')
#else
    if ( file_exist('input.nml')) then
       unit = open_namelist_file( )
       ierr=1; do while (ierr /= 0)
       read  (unit, nml=amip_interp_nml, iostat=io, end=10)
       ierr = check_nml_error(io,'amip_interp_nml')
       enddo
  10   call close_file (unit)
    endif
#endif

!  ----- write namelist/version info -----
    call write_version_number (version, tagname)

    unit = stdlog ( )
    if (mpp_pe() == 0) then
        write (unit,nml=amip_interp_nml)
    endif
    call close_file (unit)

    if ( .not. use_ncep_sst ) interp_oi_sst = .false.

!   ---- freezing point of sea water in deg K ---

    tice_crit_k = tice_crit
    if ( tice_crit_k < 200. ) tice_crit_k = tice_crit_k + TFREEZE
    ice_crit = nint((tice_crit_k-TFREEZE)*100.)

!   ---- set up file dependent variable ----
!   ----   global file name   ----
!   ----   grid box edges     ----
!   ---- initialize zero size grid if not pe 0 ------

    if (lowercase(trim(data_set)) == 'amip1') then
        file_name_sst = 'INPUT/' // 'amip1_sst.data'
        file_name_ice = 'INPUT/' // 'amip1_sst.data'
        mobs = 180;  nobs = 91
        call set_sst_grid_edges_amip1
        if (mpp_pe() == 0) &
        call error_mesg ('amip_interp_init', 'using AMIP 1 sst', NOTE)
        Date_end = date_type( 1989, 1, 0 )
    else if (lowercase(trim(data_set)) == 'amip2') then
        file_name_sst = 'INPUT/' // 'amip2_sst.data'
        file_name_ice = 'INPUT/' // 'amip2_ice.data'
        mobs = 360;  nobs = 180
        call set_sst_grid_edges_oi
!       --- specfied min for amip2 ---
        tice_crit_k = 271.38
        if (mpp_pe() == 0) &
        call error_mesg ('amip_interp_init', 'using AMIP 2 sst', NOTE)
        Date_end = date_type( 1996, 3, 0 )
    else if (lowercase(trim(data_set)) == 'hurrell') then
        file_name_sst = 'INPUT/' // 'hurrell_sst.data'
        file_name_ice = 'INPUT/' // 'hurrell_ice.data'
        mobs = 360;  nobs = 180
        call set_sst_grid_edges_oi
!       --- specfied min for hurrell ---
        tice_crit_k = 271.38
        if (mpp_pe() == 0) &
        call error_mesg ('amip_interp_init', 'using HURRELL sst', NOTE)
        Date_end = date_type( 2011, 8, 16 ) ! updated by JHC
! add by JHC
    else if (lowercase(trim(data_set)) == 'daily') then
        file_name_sst = 'INPUT/' // 'hurrell_sst.data'
        file_name_ice = 'INPUT/' // 'hurrell_ice.data'
        mobs = 360;  nobs = 180 
        call set_sst_grid_edges_oi
        if (mpp_pe() == 0) &
        call error_mesg ('amip_interp_init', 'using AVHRR daily sst', NOTE)
        Date_end = date_type( 2011, 8, 16 )
! end add by JHC
    else if (lowercase(trim(data_set)) == 'reynolds_eof') then
        file_name_sst = 'INPUT/' // 'reynolds_sst.data'
        file_name_ice = 'INPUT/' // 'reynolds_sst.data'
        mobs = 180;  nobs = 90
        call set_sst_grid_edges_oi
        if (mpp_pe() == 0) &
        call error_mesg ('amip_interp_init',  &
             'using NCEP Reynolds Historical Reconstructed SST', NOTE)
        Date_end = date_type( 1998, 12, 0 )
    else if (lowercase(trim(data_set)) == 'reynolds_oi') then
        file_name_sst = 'INPUT/' // 'reyoi_sst.data'
        file_name_ice = 'INPUT/' // 'reyoi_sst.data'
!--- Added by SJL ---------------------------------------------- 
        if ( use_ncep_sst ) then
             mobs = i_sst;  nobs = j_sst
            if (.not. allocated (sst_ncep)) then
                allocate (sst_ncep(i_sst,j_sst))
                sst_ncep(:,:) = big_number
            endif
            if (.not. allocated (sst_anom)) then
                allocate (sst_anom(i_sst,j_sst))
                sst_anom(:,:) = big_number
            endif
        else
             mobs = 360;    nobs = 180
        endif
!--- Added by SJL ---------------------------------------------- 
        call set_sst_grid_edges_oi
        if (mpp_pe() == 0) &
        call error_mesg ('amip_interp_init', 'using Reynolds OI SST', &
                                                                NOTE)
        Date_end = date_type( 1999, 1, 0 )
    else
        call error_mesg ('amip_interp_init', 'the value of the &
        &namelist parameter DATA_SET being used is not allowed', FATAL)
    endif

    if (verbose > 1 .and. mpp_pe() == 0) &
              print *, 'ice_crit,tice_crit_k=',ice_crit,tice_crit_k

!  --- check existence of sst data file ??? ---

    if (.not.file_exist(trim(file_name_sst)) .and. .not.file_exist(trim(file_name_sst)//'.nc')) then
      call error_mesg ('amip_interp_init', &
            'Neither '//trim(file_name_sst)//' or '//trim(file_name_sst)//'.nc exists', FATAL)
    endif
    if (.not.file_exist(trim(file_name_ice)) .and. .not.file_exist(trim(file_name_ice)//'.nc')) then
      call error_mesg ('amip_interp_init', &
            'Neither '//trim(file_name_ice)//' or '//trim(file_name_ice)//'.nc exists', FATAL)
    endif

    module_is_initialized = .true.

 end subroutine amip_interp_init

!#######################################################################

! <SUBROUTINE NAME="amip_interp_del">

!   <OVERVIEW>
!     Call this routine for all amip_interp_type variables created by amip_interp_new.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Call this routine for all amip_interp_type variables created by amip_interp_new.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call amip_interp_del (Interp)
!   </TEMPLATE>
!   <INOUT NAME="Interp" TYPE="amip_interp_type">
!     A defined data type variable initialized by amip_interp_new
!            and used when calling get_amip_sst and get_amip_ice.
!   </INOUT>

   subroutine amip_interp_del (Interp)
   type (amip_interp_type), intent(inout) :: Interp

     if(associated(Interp%data1)) deallocate(Interp%data1)
     if(associated(Interp%data2)) deallocate(Interp%data2)
     if(allocated(lon_bnd))       deallocate(lon_bnd)
     if(allocated(lat_bnd))       deallocate(lat_bnd)
     call horiz_interp_del ( Interp%Hintrp )

     Interp%I_am_initialized = .false.

   end subroutine amip_interp_del
!#######################################################################

! </SUBROUTINE>

!#######################################################################

   subroutine set_sst_grid_edges_amip1

   integer :: i, j
   real    :: hpie, dlon, dlat, wb, sb

      allocate ( lon_bnd(mobs+1), lat_bnd(nobs+1) )

! ---- compute grid edges (do only once) -----

      hpie = 0.5*pi

      dlon = 4.*hpie/float(mobs);  wb = -0.5*dlon
      do i = 1, mobs+1
          lon_bnd(i) = wb + dlon * float(i-1)
      enddo
          lon_bnd(mobs+1) = lon_bnd(1) + 4.*hpie

      dlat = 2.*hpie/float(nobs-1);  sb = -hpie + 0.5*dlat
      lat_bnd(1) = -hpie;  lat_bnd(nobs+1) = hpie
      do j = 2, nobs
          lat_bnd(j) = sb + dlat * float(j-2)
      enddo

   end subroutine set_sst_grid_edges_amip1

!#######################################################################
   subroutine set_sst_grid_edges_oi

   integer :: i, j
   real    :: hpie, dlon, dlat, wb, sb

! add by JHC
      if(allocated(lon_bnd))       deallocate(lon_bnd)
      if(allocated(lat_bnd))       deallocate(lat_bnd)
! end add by JHC
      allocate ( lon_bnd(mobs+1), lat_bnd(nobs+1) )

! ---- compute grid edges (do only once) -----

      hpie = 0.5*pi

      dlon = 4.*hpie/float(mobs);  wb = 0.0
          lon_bnd(1) = wb
      do i = 2, mobs+1
          lon_bnd(i) = wb + dlon * float(i-1)
      enddo
          lon_bnd(mobs+1) = lon_bnd(1) + 4.*hpie

      dlat = 2.*hpie/float(nobs);  sb = -hpie
      lat_bnd(1) = sb;  lat_bnd(nobs+1) = hpie
      do j = 2, nobs
          lat_bnd(j) = sb + dlat * float(j-1)
      enddo

   end subroutine set_sst_grid_edges_oi
!#######################################################################
! add by JHC
   subroutine set_sst_grid_edges_daily(mobs_sst, nobs_sst)

   integer :: i, j, mobs_sst, nobs_sst
   real    :: hpie, dlon, dlat, wb, sb

      if(allocated(lon_bnd))       deallocate(lon_bnd)
      if(allocated(lat_bnd))       deallocate(lat_bnd)
      allocate ( lon_bnd(mobs_sst+1), lat_bnd(nobs_sst+1) )

! ---- compute grid edges (do only once) -----

      hpie = 0.5*pi

      dlon = 4.*hpie/float(mobs_sst);  wb = 0.0
          lon_bnd(1) = wb
      do i = 2, mobs_sst+1
          lon_bnd(i) = wb + dlon * float(i-1)
      enddo
          lon_bnd(mobs_sst+1) = lon_bnd(1) + 4.*hpie

      dlat = 2.*hpie/float(nobs_sst);  sb = -hpie
      lat_bnd(1) = sb;  lat_bnd(nobs_sst+1) = hpie
      do j = 2, nobs_sst
          lat_bnd(j) = sb + dlat * float(j-1)
      enddo

   end subroutine set_sst_grid_edges_daily
! end add by JHC
!#######################################################################


   subroutine a2a_bilinear(nx, ny, dat1, n1, n2, dat2)
   integer, intent(in):: nx, ny
   integer, intent(in):: n1, n2
   real, intent(in) :: dat1(nx,ny)
   real, intent(out):: dat2(n1,n2)      ! output interpolated data

! local:
  real:: lon1(nx), lat1(ny)
  real:: lon2(n1), lat2(n2)
  real:: dx1, dy1, dx2, dy2
  real:: xc, yc
  real:: a1, b1, c1, c2, c3, c4
  integer i1, i2, jc, i0, j0, it, jt
  integer i,j


!-----------------------------------------------------------
! * Interpolate from "FMS" 1x1 SST data grid to a finer grid
!                     lon: 0.5, 1.5, ..., 359.5
!                     lat: -89.5, -88.5, ... , 88.5, 89.5
!-----------------------------------------------------------

! INput Grid
  dx1 = 360./real(nx)
  dy1 = 180./real(ny)

  do i=1,nx
     lon1(i) = 0.5*dx1 + real(i-1)*dx1
  enddo
  do j=1,ny
     lat1(j) = -90. + 0.5*dy1 + real(j-1)*dy1
  enddo

! OutPut Grid:
  dx2 = 360./real(n1)
  dy2 = 180./real(n2)

  do i=1,n1
     lon2(i) = 0.5*dx2 + real(i-1)*dx2
  enddo
  do j=1,n2
     lat2(j) = -90. + 0.5*dy2 + real(j-1)*dy2
  enddo

  jt = 1
  do 5000 j=1,n2

     yc = lat2(j)
     if ( yc<lat1(1) ) then
            jc = 1
            b1 = 0.
     elseif ( yc>lat1(ny) ) then
            jc = ny-1
            b1 = 1.
     else
          do j0=jt,ny-1
          if ( yc>=lat1(j0) .and. yc<=lat1(j0+1) ) then
               jc = j0
               jt = j0
               b1 = (yc-lat1(jc)) / dy1
               go to 222
          endif
          enddo
     endif
222  continue

     it = 1
     do i=1,n1
        xc = lon2(i)
       if ( xc>lon1(nx) ) then
            i1 = nx;     i2 = 1
            a1 = (xc-lon1(nx)) / dx1
       elseif ( xc<lon1(1) ) then
            i1 = nx;     i2 = 1
            a1 = (xc+360.-lon1(nx)) / dx1
       else
            do i0=it,nx-1
            if ( xc>=lon1(i0) .and. xc<=lon1(i0+1) ) then
               i1 = i0;  i2 = i0+1
               it = i0
               a1 = (xc-lon1(i1)) / dx1
               go to 111
            endif
            enddo
       endif
111    continue

! Debug code:
       if ( a1<-0.001 .or. a1>1.001 .or.  b1<-0.001 .or. b1>1.001 ) then
            write(*,*) i,j,a1, b1
            call mpp_error(FATAL,'a2a bilinear interpolation')
       endif

       c1 = (1.-a1) * (1.-b1)
       c2 =     a1  * (1.-b1)
       c3 =     a1  *     b1
       c4 = (1.-a1) *     b1

! Bilinear interpolation:
       dat2(i,j) = c1*dat1(i1,jc) + c2*dat1(i2,jc) + c3*dat1(i2,jc+1) + c4*dat1(i1,jc+1)

     enddo   !i-loop

5000 continue   ! j-loop

   end subroutine a2a_bilinear

!#######################################################################

! <SUBROUTINE NAME="get_sst_grid_size">

!   <OVERVIEW>
!     Returns the size (i.e., number of longitude and latitude
!         points) of the observed data grid.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Returns the size (i.e., number of longitude and latitude
!         points) of the observed data grid.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call get_sst_grid_size (nlon, nlat)
!   </TEMPLATE>
!   <OUT NAME="nlon" TYPE="integer">
!     The number of longitude points (first dimension) in the
!        observed data grid.  For AMIP 1 nlon = 180, and the Reynolds nlon = 360.
!   </OUT>
!   <OUT NAME="nlat" TYPE="integer">
!     The number of latitude points (second dimension) in the
!        observed data grid.  For AMIP 1 nlon = 91, and the Reynolds nlon = 180.
!   </OUT>
!   <ERROR MSG="have not called amip_interp_new" STATUS="FATAL">
!     Must call amip_interp_new before get_sst_grid_size.
!   </ERROR>

   subroutine get_sst_grid_size (nlon, nlat)

   integer, intent(out) :: nlon, nlat

      if ( .not.module_is_initialized ) call amip_interp_init

      nlon = mobs;  nlat = nobs

   end subroutine get_sst_grid_size
! </SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="get_sst_grid_boundary">

!   <OVERVIEW>
!     Returns the grid box boundaries of the observed data grid.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Returns the grid box boundaries of the observed data grid.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call get_sst_grid_boundary (blon, blat, mask)
!   </TEMPLATE>
!   <OUT NAME="blon" TYPE="real" DIM="(:)">
!     The grid box edges (in radians) for longitude points of the
!        observed data grid. The size of this argument must be nlon+1.
!   </OUT>
!   <OUT NAME="blat" TYPE="real" DIM="(:)">
!     The grid box edges (in radians) for latitude points of the
!        observed data grid. The size of this argument must be nlat+1.
!   </OUT>
!   <ERROR MSG="have not called amip_interp_new" STATUS="FATAL">
!     Must call amip_interp_new before get_sst_grid_boundary.
!   </ERROR>
!   <ERROR MSG="invalid argument dimensions" STATUS="FATAL">
!     The size of the output argument arrays do not agree with
!      the size of the observed data. See the documentation for
!      interfaces get_sst_grid_size and get_sst_grid_boundary.
!   </ERROR>

   subroutine get_sst_grid_boundary (blon, blat, mask)

   real,    intent(out) :: blon(:), blat(:)
   logical, intent(out) :: mask(:,:)

      if ( .not.module_is_initialized ) call amip_interp_init

! ---- check size of argument(s) ----

      if (size(blon(:)) /= mobs+1 .or. size(blat(:)) /= nobs+1)   &
      call error_mesg ('get_sst_grid_boundary in amip_interp_mod',  &
                       'invalid argument dimensions', FATAL)

! ---- return grid box edges -----

      blon = lon_bnd
      blat = lat_bnd

! ---- masking (data exists at all points) ----

      mask = .true.


   end subroutine get_sst_grid_boundary
! </SUBROUTINE>

!#######################################################################

   subroutine read_record (type, Date, Adate, dat)

     character(len=*), intent(in)  :: type
     type (date_type), intent(in)  :: Date
     type (date_type), intent(inout) :: Adate
     real,             intent(out) :: dat(mobs,nobs)
     real :: tmp_dat(360,180)

     real   (R4_KIND) :: dat4(mobs,nobs)
     integer(I2_KIND) :: idat(mobs,nobs)
     integer :: nrecords, yr, mo, dy, ierr, k
     integer, dimension(:), allocatable :: ryr, rmo, rdy
     character(len=38)   :: mesg
     character(len=maxc) :: ncfilename, ncfieldname

    !---- set file and field name for NETCDF data sets ----

        ncfieldname = 'sst'
     if(type(1:3) == 'sst') then
        ncfilename = trim(file_name_sst)//'.nc'
     else if(type(1:3) == 'ice') then
        ncfilename = trim(file_name_ice)//'.nc'
        if (lowercase(trim(data_set)) == 'amip2' .or. &
            lowercase(trim(data_set)) == 'hurrell' .or. & 
            lowercase(trim(data_set)) == 'daily') ncfieldname = 'ice' ! modified by JHC
     endif

    !---- make sure IEEE format file is open ----

     if ( (.NOT. file_exist(ncfilename))  ) then

       ! rewind condition (if unit is open)
        if (unit /= -1 .and. Curr_date % year == 0 .and.   &
             date % month <= Curr_date % month ) then
           if (verbose > 1 .and. mpp_pe() == 0)  &
                print *, ' rewinding unit = ', unit
           rewind unit
        endif

        if (unit == -1) then
           if (type(1:3) == 'sst') then
              unit = open_ieee32_file (file_name_sst, 'read')
           else if (type(1:3) == 'ice') then
              unit = open_ieee32_file (file_name_ice, 'read')
           endif
        endif

     endif

     dy = 0 ! only processing monthly data

     if (verbose > 2 .and. mpp_pe() == 0)  &
          print *, 'looking for date = ', Date

    !---- check dates in NETCDF file -----

     ! This code can handle amip1, reynolds, or reyoi type SST data files in netCDF format
     if (file_exist(ncfilename)) then
        if (mpp_pe() == mpp_root_pe()) call mpp_error ('amip_interp_mod', &
             'Reading NetCDF formatted input data file: '//trim(ncfilename), NOTE)
        call read_data (ncfilename, 'nrecords', nrecords, no_domain=.true.)
        if (nrecords < 1) call mpp_error('amip_interp_mod', &
                           'Invalid number of SST records in SST datafile: '//trim(ncfilename), FATAL)
        allocate(ryr(nrecords), rmo(nrecords), rdy(nrecords))
        call read_data(ncfilename, 'yr', ryr, no_domain=.true.)
        call read_data(ncfilename, 'mo', rmo, no_domain=.true.)
        call read_data(ncfilename, 'dy', rdy, no_domain=.true.)
        ierr = 1
        do k = 1, nrecords
          yr = ryr(k);  mo = rmo(k)
          Adate = date_type( yr, mo, 0)
          Curr_date = Adate
          if (verbose > 2 .and. mpp_pe() == 0)  &
                print *, '....... checking   ', Adate
          if (Date == Adate) ierr = 0 
          if (yr == 0 .and. mo == Date%month) ierr = 0
          if (ierr == 0) exit
        enddo
        if (ierr .ne. 0) call mpp_error('amip_interp_mod', &
                         'Model time is out of range not in SST data: '//trim(ncfilename), FATAL)
        deallocate(ryr, rmo, rdy)
       !PRINT *, 'New SST data: ', k, yr, mo, dy, Date%year, Date%month, Date%day, ryr(1), rmo(1)

    !---- check dates in IEEE file -----

     else
        if (mpp_pe() == mpp_root_pe()) call mpp_error ('amip_interp_mod', &
             'Reading native formatted input data file: '//trim(data_set), NOTE)
        k = 0
        do
           k = k + 1
           if (lowercase(trim(data_set)) == 'amip2' .or. lowercase(trim(data_set)) == 'hurrell') then
              read (unit, end=10)  yr, mo,     dat4
              dat=dat4
           else
              read (unit, end=10)  yr, mo, dy, idat
           endif
           !new     read (unit, end=10)  yr, mo, dy
           Adate = date_type( yr, mo, dy )
           Curr_date = Adate
           if (verbose > 2 .and. mpp_pe() == 0)  &
                print *, '....... checking   ', Adate
           
           !     --- found date ---
           if (Date == Adate)                    exit
           if (Date%month == mo .and. Date%day == dy .and. Date%year == yr ) exit
           !     --- otherwise use monthly climo ---
           if (yr == 0 .and. Date % month == mo) exit
           
           !     --- skip this data record ---
           !new  if (lowercase(trim(data_set)) /= 'amip2') read (unit)
        enddo
        
        !     --- read data ---
        !new  if (lowercase(trim(data_set)) /= 'amip2') read (unit) idat
        
        !   --- check if climo used when not wanted ---
        
     endif ! if(file_exist(ncfilename))
     
   !---- check if climatological data should be used ----

     if (yr == 0 .or. mo == 0) then
        ierr = 0
        if (date_out_of_range == 'fail' )               ierr = 1
        if (date_out_of_range == 'initclimo' .and.  &
             Date > Date_end )   ierr = 1
        if (ierr /= 0) call error_mesg &
             ('read_record in amip_interp_mod', &
             'climo data read when NO climo data requested', FATAL)
     endif

   !---- read NETCDF data ----

     if (file_exist(ncfilename)) then
         if ( interp_oi_sst ) then
              call read_data(ncfilename, ncfieldname, tmp_dat, timelevel=k, no_domain=.true.)
!     interpolate tmp_dat(360, 180) ---> dat(mobs,nobs) (to enable SST anom computation)
              if ( mobs/=360 .or. nobs/=180 ) then
                   call a2a_bilinear(360, 180, tmp_dat, mobs, nobs, dat)
              else
                   dat(:,:) = tmp_dat(:,:)
              endif
         else
              call read_data(ncfilename, ncfieldname, dat, timelevel=k, no_domain=.true.)
         endif
        idat =  nint(dat*100.) ! reconstruct packed data for reproducibity
     endif

   !---- unpacking of data ----

     if (type(1:3) == 'ice') then
        !---- create fractional [0,1] ice mask
        if (lowercase(trim(data_set)) /= 'amip2' .and. lowercase(trim(data_set)) /= 'hurrell') then
               where ( idat <= ice_crit )
                   dat = 1.
               elsewhere
                   dat = 0.
               endwhere
        else
           dat = dat*0.01
        endif
     else if (type(1:3) == 'sst') then
        !---- unpack sst ----
        if (lowercase(trim(data_set)) /= 'amip2' .and. lowercase(trim(data_set)) /= 'hurrell') then
               dat = real(idat)*0.01 + TFREEZE
        endif
     endif


     return

10   write (mesg, 20) unit
     call error_mesg ('read_record in amip_interp_mod', mesg, FATAL)

20   format ('end of file reading unit ',i2,' (sst data)')

   end subroutine read_record

!#######################################################################

   subroutine clip_data (type, dat)

   character(len=*), intent(in)    :: type
   real,             intent(inout) :: dat(:,:)

   if (type(1:3) == 'ice') then
       dat = min(max(dat,0.0),1.0)
   else if (type(1:3) == 'sst') then
       dat = max(tice_crit_k,dat)
   endif

   end subroutine clip_data

!#######################################################################

function date_equals (Left, Right) result (answer)
type (date_type), intent(in) :: Left, Right
logical :: answer

   if (Left % year  == Right % year  .and.  &
       Left % month == Right % month .and.  &
       Left % day   == Right % day ) then
           answer = .true. 
   else
           answer = .false.
   endif

end function date_equals

!#######################################################################

function date_not_equals (Left, Right) result (answer)
type (date_type), intent(in) :: Left, Right
logical :: answer

   if (Left % year  == Right % year  .and.  &
       Left % month == Right % month .and.  &
       Left % day   == Right % day ) then
           answer = .false.
   else
           answer = .true. 
   endif

end function date_not_equals

!#######################################################################

function date_gt (Left, Right) result (answer)
type (date_type), intent(in) :: Left, Right
logical :: answer
integer :: i, dif(3)

   dif(1) = Left%year  - Right%year
   dif(2) = Left%month - Right%month
   dif(3) = Left%day   - Right%day
   answer = .false.
   do i = 1, 3
     if (dif(i) == 0) cycle
     if (dif(i)  < 0) exit
     if (dif(i)  > 0) then
         answer = .true.
         exit
     endif
   enddo

end function date_gt

!#######################################################################

subroutine print_dates (Time, Date1, Udate1,  &
                              Date2, Udate2, fmonth)

   type (time_type), intent(in) :: Time
   type (date_type), intent(in) :: Date1, Udate1, Date2, Udate2
   real,             intent(in) :: fmonth

   integer :: year, month, day, hour, minute, second

   call get_date (Time, year, month, day, hour, minute, second)

   write (*,10) year,month,day, hour,minute,second
   write (*,20) fmonth
   write (*,30) Date1, Udate1
   write (*,40) Date2, Udate2

10 format (/,' date(y/m/d h:m:s) = ',i4,2('/',i2.2),1x,2(i2.2,':'),i2.2)
20 format (' fmonth = ',f9.7)
30 format (' date1(y/m/d) = ',i4,2('/',i2.2),6x, &
                    'used = ',i4,2('/',i2.2),6x  )
40 format (' date2(y/m/d) = ',i4,2('/',i2.2),6x, &
                    'used = ',i4,2('/',i2.2),6x  )
     
end subroutine print_dates

!#######################################################################

subroutine zonal_sst (Time, ice, sst)

   type (time_type), intent(in)  :: Time
   real,             intent(out) :: ice(mobs,nobs), sst(mobs,nobs)

   real    :: tpi, fdate, eps, ph, sph, sph2, ts
   integer :: j

! namelist needed
!
!  teq  = sst at equator
!  tdif = equator to pole sst difference
!  tann = amplitude of annual cycle
!  tlag = offset for time of year (for annual cycle)
!

    tpi = 2.0*pi

    fdate = fraction_of_year (Time)

    eps = sin( tpi*(fdate-tlag) ) * tann

    do j = 1, nobs

        ph  = 0.5*(lat_bnd(j)+lat_bnd(j+1))
       sph  = sin(ph)
       sph2 = sph*sph

       ts = teq - tdif*sph2 - eps*sph

       sst(:,j) = ts

    enddo

    where ( sst < tice_crit_k )
       ice = 1.0
       sst = tice_crit_k
    elsewhere
       ice  = 0.0
    endwhere


end subroutine zonal_sst

!#######################################################################

subroutine amip_interp_type_eq(amip_interp_out, amip_interp_in)
    type(amip_interp_type), intent(inout) :: amip_interp_out
    type(amip_interp_type), intent(in)    :: amip_interp_in

    if(.not.amip_interp_in%I_am_initialized) then
      call mpp_error(FATAL,'amip_interp_type_eq: amip_interp_type variable on right hand side is unassigned')
    endif

    amip_interp_out%Hintrp     =  amip_interp_in%Hintrp
    amip_interp_out%data1      => amip_interp_in%data1
    amip_interp_out%data2      => amip_interp_in%data2
    amip_interp_out%Date1      =  amip_interp_in%Date1
    amip_interp_out%Date2      =  amip_interp_in%Date2
    amip_interp_out%Date1      =  amip_interp_in%Date1
    amip_interp_out%Date2      =  amip_interp_in%Date2
    amip_interp_out%use_climo  =  amip_interp_in%use_climo
    amip_interp_out%use_annual =  amip_interp_in%use_annual
    amip_interp_out%I_am_initialized = .true.

end subroutine amip_interp_type_eq

!#######################################################################

end module amip_interp_mod
! <INFO>

!   <FUTURE> 
!     Add AMIP 2 data set.
!
!     Other data sets (or extend current data sets).
!   </FUTURE>

! </INFO>

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: icarus.F90,v 20.0 2013/12/13 23:16:02 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

#ifdef COSP_GFDL
      SUBROUTINE ICARUS(          &
     &     debug,                 &
     &     debugcol,              &
     &     npoints,               &
     &     sunlit,                &
     &     nlev,                  &
     &     ncol,                  &
     &     pfull,                 &
     &     phalf,                 &
     &     qv,                    &
     &     cc,                    &
     &     conv,                  &
     &     dtau_s,                &
     &     dtau_c,                &
     &     top_height,            &
     &     top_height_direction,  &
     &     overlap,               &
     &     frac_out,              &
     &     skt,                   &
     &     emsfc_lw,              &
     &     at,                    &
     &     dem_s,                 &
     &     dem_c,                 &
     &     fq_isccp,              &
     &     totalcldarea,          &
     &     meanptop,              &
     &     meantaucld,            &
     &     meanalbedocld,         &
     &     meantb,                &
     &     meantbclr,             &
     &     boxtau,                &
     &     boxptop,               &
     &     dtau_col,              &
     &     dem_col                &
     &)
#else
      SUBROUTINE ICARUS(
     &     debug,
     &     debugcol,
     &     npoints,
     &     sunlit,
     &     nlev,
     &     ncol,
     &     pfull,
     &     phalf,
     &     qv,
     &     cc,
     &     conv,
     &     dtau_s,
     &     dtau_c,
     &     top_height,
     &     top_height_direction,
     &     overlap,
     &     frac_out,
     &     skt,
     &     emsfc_lw,
     &     at,
     &     dem_s,
     &     dem_c,
     &     fq_isccp,
     &     totalcldarea,
     &     meanptop,
     &     meantaucld,
     &     meanalbedocld,
     &     meantb,
     &     meantbclr,
     &     boxtau,
     &     boxptop
     &)
#endif

#ifndef COSP_GFDL
!$Id: icarus.F90,v 20.0 2013/12/13 23:16:02 fms Exp $
#endif

! *****************************COPYRIGHT****************************
! (c) 2009, Lawrence Livermore National Security Limited Liability 
! Corporation.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without 
! modification, are permitted provided that the
! following conditions are met:
! 
!     * Redistributions of source code must retain the above 
!       copyright  notice, this list of conditions and the following 
!       disclaimer.
!     * Redistributions in binary form must reproduce the above 
!       copyright notice, this list of conditions and the following 
!       disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Lawrence Livermore National Security 
!       Limited Liability Corporation nor the names of its 
!       contributors may be used to endorse or promote products
!       derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
! A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
! OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
! SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
! LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
! THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
! 
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************

#ifdef COSP_GFDL
use mpp_mod,only: get_unit
use fms_mod,only: stdlog, error_mesg, FATAL
#endif
      implicit none

!     NOTE:   the maximum number of levels and columns is set by
!             the following parameter statement

      INTEGER ncolprint
      
!     -----
!     Input 
!     -----

      INTEGER npoints       !  number of model points in the horizontal
      INTEGER nlev          !  number of model levels in column
      INTEGER ncol          !  number of subcolumns

      INTEGER sunlit(npoints) !  1 for day points, 0 for night time

      REAL pfull(npoints,nlev)
                       !  pressure of full model levels (Pascals)
                  !  pfull(npoints,1) is top level of model
                  !  pfull(npoints,nlev) is bot of model

      REAL phalf(npoints,nlev+1)
                  !  pressure of half model levels (Pascals)
                  !  phalf(npoints,1) is top of model
                  !  phalf(npoints,nlev+1) is the surface pressure

      REAL qv(npoints,nlev)
                  !  water vapor specific humidity (kg vapor/ kg air)
                  !         on full model levels

      REAL cc(npoints,nlev)   
                  !  input cloud cover in each model level (fraction) 
                  !  NOTE:  This is the HORIZONTAL area of each
                  !         grid box covered by clouds

      REAL conv(npoints,nlev) 
                  !  input convective cloud cover in each model
                  !   level (fraction) 
                  !  NOTE:  This is the HORIZONTAL area of each
                  !         grid box covered by convective clouds

      REAL dtau_s(npoints,nlev) 
                  !  mean 0.67 micron optical depth of stratiform
                !  clouds in each model level
                  !  NOTE:  this the cloud optical depth of only the
                  !  cloudy part of the grid box, it is not weighted
                  !  with the 0 cloud optical depth of the clear
                  !         part of the grid box

      REAL dtau_c(npoints,nlev) 
                  !  mean 0.67 micron optical depth of convective
                !  clouds in each
                  !  model level.  Same note applies as in dtau_s.

      INTEGER overlap                   !  overlap type
                              !  1=max
                              !  2=rand
                              !  3=max/rand

      INTEGER top_height                !  1 = adjust top height using both a computed
                                        !  infrared brightness temperature and the visible
                              !  optical depth to adjust cloud top pressure. Note
                              !  that this calculation is most appropriate to compare
                              !  to ISCCP data during sunlit hours.
                                        !  2 = do not adjust top height, that is cloud top
                                        !  pressure is the actual cloud top pressure
                                        !  in the model
                              !  3 = adjust top height using only the computed
                              !  infrared brightness temperature. Note that this
                              !  calculation is most appropriate to compare to ISCCP
                              !  IR only algortihm (i.e. you can compare to nighttime
                              !  ISCCP data with this option)

      INTEGER top_height_direction ! direction for finding atmosphere pressure level
                                 ! with interpolated temperature equal to the radiance
				 ! determined cloud-top temperature
				 !
				 ! 1 = find the *lowest* altitude (highest pressure) level
				 ! with interpolated temperature equal to the radiance
				 ! determined cloud-top temperature
				 !
				 ! 2 = find the *highest* altitude (lowest pressure) level
				 ! with interpolated temperature equal to the radiance 
				 ! determined cloud-top temperature
				 ! 
				 ! ONLY APPLICABLE IF top_height EQUALS 1 or 3
				 !				 !
				 ! 1 = old setting: matches all versions of 
				 ! ISCCP simulator with versions numbers 3.5.1 and lower
				 !
				 ! 2 = default setting: for version numbers 4.0 and higher
!
!     The following input variables are used only if top_height = 1 or top_height = 3
!
      REAL skt(npoints)                 !  skin Temperature (K)
      REAL emsfc_lw                     !  10.5 micron emissivity of surface (fraction)                                            
      REAL at(npoints,nlev)                   !  temperature in each model level (K)
      REAL dem_s(npoints,nlev)                !  10.5 micron longwave emissivity of stratiform
                              !  clouds in each
                                        !  model level.  Same note applies as in dtau_s.
      REAL dem_c(npoints,nlev)                  !  10.5 micron longwave emissivity of convective
                              !  clouds in each
                                        !  model level.  Same note applies as in dtau_s.

      REAL frac_out(npoints,ncol,nlev) ! boxes gridbox divided up into
                              ! Equivalent of BOX in original version, but
                              ! indexed by column then row, rather than
                              ! by row then column

#ifdef COSP_GFDL
       REAL, optional :: dtau_col(npoints,ncol,nlev)
                              ! tau values obtained from model
                              ! stochastic columns

       REAL, optional :: dem_col(npoints,ncol,nlev)
                              ! lw emissivity values obtained
                              ! from model stochastic columns
 

#endif


!     ------
!     Output
!     ------

      REAL fq_isccp(npoints,7,7)        !  the fraction of the model grid box covered by
                                        !  each of the 49 ISCCP D level cloud types

      REAL totalcldarea(npoints)        !  the fraction of model grid box columns
                                        !  with cloud somewhere in them.  NOTE: This diagnostic
					! does not count model clouds with tau < isccp_taumin
                              ! Thus this diagnostic does not equal the sum over all entries of fq_isccp.
			      ! However, this diagnostic does equal the sum over entries of fq_isccp with
			      ! itau = 2:7 (omitting itau = 1)
      
      
      ! The following three means are averages only over the cloudy areas with tau > isccp_taumin.  
      ! If no clouds with tau > isccp_taumin are in grid box all three quantities should equal zero.      
                              
      REAL meanptop(npoints)            !  mean cloud top pressure (mb) - linear averaging
                                        !  in cloud top pressure.
                              
      REAL meantaucld(npoints)          !  mean optical thickness 
                                        !  linear averaging in albedo performed.
      
      real meanalbedocld(npoints)        ! mean cloud albedo
                                        ! linear averaging in albedo performed
					
      real meantb(npoints)              ! mean all-sky 10.5 micron brightness temperature
      
      real meantbclr(npoints)           ! mean clear-sky 10.5 micron brightness temperature
      
      REAL boxtau(npoints,ncol)         !  optical thickness in each column
      
      REAL boxptop(npoints,ncol)        !  cloud top pressure (mb) in each column
                              
                                                                                          
!
!     ------
!     Working variables added when program updated to mimic Mark Webb's PV-Wave code
!     ------

      REAL dem(npoints,ncol),bb(npoints)     !  working variables for 10.5 micron longwave 
                              !  emissivity in part of
                              !  gridbox under consideration

      REAL ptrop(npoints)
      REAL attrop(npoints)
      REAL attropmin (npoints)
      REAL atmax(npoints)
      REAL btcmin(npoints)
      REAL transmax(npoints)

      INTEGER i,j,ilev,ibox,itrop(npoints)
      INTEGER ipres(npoints)
      INTEGER itau(npoints),ilev2
      INTEGER acc(nlev,ncol)
      INTEGER match(npoints,nlev-1)
      INTEGER nmatch(npoints)
      INTEGER levmatch(npoints,ncol)
      
      !variables needed for water vapor continuum absorption
      real fluxtop_clrsky(npoints),trans_layers_above_clrsky(npoints)
      real taumin(npoints)
      real dem_wv(npoints,nlev), wtmair, wtmh20, Navo, grav, pstd, t0
      real press(npoints), dpress(npoints), atmden(npoints)
      real rvh20(npoints), wk(npoints), rhoave(npoints)
      real rh20s(npoints), rfrgn(npoints)
      real tmpexp(npoints),tauwv(npoints)
      
#ifdef COSP_GFDL
      character(len=1) :: cchar(6),cchar_realtops(6)
#else
      character*1 cchar(6),cchar_realtops(6)
#endif
      integer icycle
      REAL tau(npoints,ncol)
      LOGICAL box_cloudy(npoints,ncol)
      REAL tb(npoints,ncol)
      REAL ptop(npoints,ncol)
      REAL emcld(npoints,ncol)
      REAL fluxtop(npoints,ncol)
      REAL trans_layers_above(npoints,ncol)
      real isccp_taumin,fluxtopinit(npoints),tauir(npoints)
      REAL albedocld(npoints,ncol)
      real boxarea
      integer debug       ! set to non-zero value to print out inputs
                    ! with step debug
      integer debugcol    ! set to non-zero value to print out column
                    ! decomposition with step debugcol
      integer rangevec(npoints),rangeerror

      integer index1(npoints),num1,jj,k1,k2
#ifdef COSP_GFDL
      integer   funit, logunit
#endif
      real rec2p13,tauchk,logp,logp1,logp2,atd
      real output_missing_value

#ifdef COSP_GFDL
      character(len=10) :: ftn09
#else
      character*10 ftn09
#endif
      
      DATA isccp_taumin / 0.3 /
      DATA output_missing_value / -1.E+30 /
      DATA cchar / ' ','-','1','+','I','+'/
      DATA cchar_realtops / ' ',' ','1','1','I','I'/

!     ------ End duplicate definitions common to wrapper routine

      tauchk = -1.*log(0.9999999)
      rec2p13=1./2.13

      ncolprint=0

#ifdef COSP_GFDL
      logunit = stdlog()
#endif
      if ( debug.ne.0 ) then
          j=1
#ifdef COSP_GFDL
          write(logunit,'(a10)') 'j='
          write(logunit,'(8I10)') j
          write(logunit,'(a10)') 'debug='
          write(logunit,'(8I10)') debug
          write(logunit,'(a10)') 'debugcol='
          write(logunit,'(8I10)') debugcol
          write(logunit,'(a10)') 'npoints='
          write(logunit,'(8I10)') npoints
          write(logunit,'(a10)') 'nlev='
          write(logunit,'(8I10)') nlev
          write(logunit,'(a10)') 'ncol='
          write(logunit,'(8I10)') ncol
          write(logunit,'(a11)') 'top_height='
          write(logunit,'(8I10)') top_height
          write(logunit,'(a21)') 'top_height_direction='
          write(logunit,'(8I10)') top_height_direction
          write(logunit,'(a10)') 'overlap='
          write(logunit,'(8I10)') overlap
          write(logunit,'(a10)') 'emsfc_lw='
          write(logunit,'(8f10.2)') emsfc_lw
        do j=1,npoints,debug
          write(logunit,'(a10)') 'j='
          write(logunit,'(8I10)') j
          write(logunit,'(a10)') 'sunlit='
          write(logunit,'(8I10)') sunlit(j)
          write(logunit,'(a10)') 'pfull='
          write(logunit,'(8f10.2)') (pfull(j,i),i=1,nlev)
          write(logunit,'(a10)') 'phalf='
          write(logunit,'(8f10.2)') (phalf(j,i),i=1,nlev+1)
          write(logunit,'(a10)') 'qv='
          write(logunit,'(8f10.3)') (qv(j,i),i=1,nlev)
          write(logunit,'(a10)') 'cc='
          write(logunit,'(8f10.3)') (cc(j,i),i=1,nlev)
          write(logunit,'(a10)') 'conv='
          write(logunit,'(8f10.2)') (conv(j,i),i=1,nlev)
          write(logunit,'(a10)') 'dtau_s='
          write(logunit,'(8g12.5)') (dtau_s(j,i),i=1,nlev)
          write(logunit,'(a10)') 'dtau_c='
          write(logunit,'(8f10.2)') (dtau_c(j,i),i=1,nlev)
          write(logunit,'(a10)') 'skt='
          write(logunit,'(8f10.2)') skt(j)
          write(logunit,'(a10)') 'at='
          write(logunit,'(8f10.2)') (at(j,i),i=1,nlev)
          write(logunit,'(a10)') 'dem_s='
          write(logunit,'(8f10.3)') (dem_s(j,i),i=1,nlev)
          write(logunit,'(a10)') 'dem_c='
          write(logunit,'(8f10.3)') (dem_c(j,i),i=1,nlev)
        enddo
#else
          write(6,'(a10)') 'j='
          write(6,'(8I10)') j
          write(6,'(a10)') 'debug='
          write(6,'(8I10)') debug
          write(6,'(a10)') 'debugcol='
          write(6,'(8I10)') debugcol
          write(6,'(a10)') 'npoints='
          write(6,'(8I10)') npoints
          write(6,'(a10)') 'nlev='
          write(6,'(8I10)') nlev
          write(6,'(a10)') 'ncol='
          write(6,'(8I10)') ncol
          write(6,'(a11)') 'top_height='
          write(6,'(8I10)') top_height
	  write(6,'(a21)') 'top_height_direction='
          write(6,'(8I10)') top_height_direction
          write(6,'(a10)') 'overlap='
          write(6,'(8I10)') overlap
          write(6,'(a10)') 'emsfc_lw='
          write(6,'(8f10.2)') emsfc_lw
        do j=1,npoints,debug
          write(6,'(a10)') 'j='
          write(6,'(8I10)') j
          write(6,'(a10)') 'sunlit='
          write(6,'(8I10)') sunlit(j)
          write(6,'(a10)') 'pfull='
          write(6,'(8f10.2)') (pfull(j,i),i=1,nlev)
          write(6,'(a10)') 'phalf='
          write(6,'(8f10.2)') (phalf(j,i),i=1,nlev+1)
          write(6,'(a10)') 'qv='
          write(6,'(8f10.3)') (qv(j,i),i=1,nlev)
          write(6,'(a10)') 'cc='
          write(6,'(8f10.3)') (cc(j,i),i=1,nlev)
          write(6,'(a10)') 'conv='
          write(6,'(8f10.2)') (conv(j,i),i=1,nlev)
          write(6,'(a10)') 'dtau_s='
          write(6,'(8g12.5)') (dtau_s(j,i),i=1,nlev)
          write(6,'(a10)') 'dtau_c='
          write(6,'(8f10.2)') (dtau_c(j,i),i=1,nlev)
          write(6,'(a10)') 'skt='
          write(6,'(8f10.2)') skt(j)
          write(6,'(a10)') 'at='
          write(6,'(8f10.2)') (at(j,i),i=1,nlev)
          write(6,'(a10)') 'dem_s='
          write(6,'(8f10.3)') (dem_s(j,i),i=1,nlev)
          write(6,'(a10)') 'dem_c='
          write(6,'(8f10.3)') (dem_c(j,i),i=1,nlev)
        enddo
#endif
      endif

!     ---------------------------------------------------!

      if (ncolprint.ne.0) then
      do j=1,npoints,1000
#ifdef COSP_GFDL
        write(logunit,'(a10)') 'j='
        write(logunit,'(8I10)') j
#else
        write(6,'(a10)') 'j='
        write(6,'(8I10)') j
#endif
      enddo
      endif

      if (top_height .eq. 1 .or. top_height .eq. 3) then 

      do j=1,npoints 
          ptrop(j)=5000.
          attropmin(j) = 400.
          atmax(j) = 0.
          attrop(j) = 120.
          itrop(j) = 1
      enddo 

      do 12 ilev=1,nlev
        do j=1,npoints 
#ifdef COSP_GFDL
          if (pfull(j,ilev) .lt. 40000. .and. &
     &          pfull(j,ilev) .gt.  5000. .and. &
     &          at(j,ilev) .lt. attropmin(j)) then
#else
         if (pfull(j,ilev) .lt. 40000. .and.
     &          pfull(j,ilev) .gt.  5000. .and.
     &          at(j,ilev) .lt. attropmin(j)) then
#endif
                ptrop(j) = pfull(j,ilev)
                attropmin(j) = at(j,ilev)
                attrop(j) = attropmin(j)
                itrop(j)=ilev
           end if
        enddo
12    continue

      do 13 ilev=1,nlev
        do j=1,npoints 
#ifdef COSP_GFDL
           if (at(j,ilev) .gt. atmax(j) .and.    &
     &              ilev  .ge. itrop(j)) atmax(j)=at(j,ilev)
#else
           if (at(j,ilev) .gt. atmax(j) .and.
     &              ilev  .ge. itrop(j)) atmax(j)=at(j,ilev)
#endif
        enddo
13    continue

      end if


      if (top_height .eq. 1 .or. top_height .eq. 3) then
          do j=1,npoints
              meantb(j) = 0.
	      meantbclr(j) = 0. 
          end do
      else
          do j=1,npoints
              meantb(j) = output_missing_value
       	      meantbclr(j) = output_missing_value
          end do
      end if
      
!     -----------------------------------------------------!

!     ---------------------------------------------------!

      do ilev=1,nlev
        do j=1,npoints

          rangevec(j)=0

          if (cc(j,ilev) .lt. 0. .or. cc(j,ilev) .gt. 1.) then
!           error = cloud fraction less than zero
!           error = cloud fraction greater than 1
            rangevec(j)=rangevec(j)+1
          endif

          if (conv(j,ilev) .lt. 0. .or. conv(j,ilev) .gt. 1.) then
!           ' error = convective cloud fraction less than zero'
!           ' error = convective cloud fraction greater than 1'
            rangevec(j)=rangevec(j)+2
          endif

          if (dtau_s(j,ilev) .lt. 0.) then
!           ' error = stratiform cloud opt. depth less than zero'
            rangevec(j)=rangevec(j)+4
          endif

          if (dtau_c(j,ilev) .lt. 0.) then
!           ' error = convective cloud opt. depth less than zero'
            rangevec(j)=rangevec(j)+8
          endif

          if (dem_s(j,ilev) .lt. 0. .or. dem_s(j,ilev) .gt. 1.) then
!             ' error = stratiform cloud emissivity less than zero'
!             ' error = stratiform cloud emissivity greater than 1'
            rangevec(j)=rangevec(j)+16
          endif

          if (dem_c(j,ilev) .lt. 0. .or. dem_c(j,ilev) .gt. 1.) then
!             ' error = convective cloud emissivity less than zero'
!             ' error = convective cloud emissivity greater than 1'
              rangevec(j)=rangevec(j)+32
          endif
        enddo

        rangeerror=0
        do j=1,npoints
            rangeerror=rangeerror+rangevec(j)
        enddo

#ifdef COSP_GFDL
        if (rangeerror.ne.0) then
              write (logunit,*) 'Input variable out of range'
              write (logunit,*) 'rangevec:'
              write (logunit,*) rangevec
              call error_mesg('ICARUS','Input variable out of range',FATAL)

        endif
#else
        if (rangeerror.ne.0) then 
              write (6,*) 'Input variable out of range'
              write (6,*) 'rangevec:'
              write (6,*) rangevec
              call flush(6)
              STOP
        endif
#endif
      enddo

!
!     ---------------------------------------------------!

      
!
!     ---------------------------------------------------!
!     COMPUTE CLOUD OPTICAL DEPTH FOR EACH COLUMN and
!     put into vector tau
 
      !initialize tau and albedocld to zero
      do 15 ibox=1,ncol
        do j=1,npoints 
            tau(j,ibox)=0.
          albedocld(j,ibox)=0.
          boxtau(j,ibox)=output_missing_value
          boxptop(j,ibox)=output_missing_value
          box_cloudy(j,ibox)=.false.
        enddo
15    continue

      !compute total cloud optical depth for each column     
#ifdef COSP_GFDL
    if (present(dtau_col)     ) then
        do ilev=1,nlev
            !increment tau for each of the boxes
            do ibox=1,ncol
              do j=1,npoints
                tau(j,ibox)=tau(j,ibox) &
      &                     + dtau_col(j,ibox,ilev)
              enddo
            enddo ! ibox
        enddo ! ilev

     else
      do ilev=1,nlev
            !increment tau for each of the boxes
            do ibox=1,ncol
              do j=1,npoints 
                 if (frac_out(j,ibox,ilev).eq.1) then
                        tau(j,ibox)=tau(j,ibox)   &
     &                     + dtau_s(j,ilev)
                 endif
                 if (frac_out(j,ibox,ilev).eq.2) then
                        tau(j,ibox)=tau(j,ibox)   &
     &                     + dtau_c(j,ilev)
                 end if
              enddo
            enddo ! ibox
      enddo ! ilev
     endif
#else
      do ilev=1,nlev
            !increment tau for each of the boxes
            do ibox=1,ncol
              do j=1,npoints 
                 if (frac_out(j,ibox,ilev).eq.1) then
                        tau(j,ibox)=tau(j,ibox)
     &                     + dtau_s(j,ilev)
                 endif
                 if (frac_out(j,ibox,ilev).eq.2) then
                        tau(j,ibox)=tau(j,ibox)
     &                     + dtau_c(j,ilev)
                 end if
              enddo
            enddo ! ibox
      enddo ! ilev
#endif
          if (ncolprint.ne.0) then

#ifdef COSP_GFDL
              do j=1,npoints ,1000
                write(logunit,'(a10)') 'j='
                write(logunit,'(8I10)') j
                write(logunit,'(i2,1X,8(f7.2,1X))')  &
     &          ilev,                                &
     &          (tau(j,ibox),ibox=1,ncolprint)
              enddo
#else
              do j=1,npoints ,1000
                write(6,'(a10)') 'j='
                write(6,'(8I10)') j
                write(6,'(i2,1X,8(f7.2,1X))') 
     &          ilev,
     &          (tau(j,ibox),ibox=1,ncolprint)
              enddo
#endif
          endif 
!
!     ---------------------------------------------------!



!     
!     ---------------------------------------------------!
!     COMPUTE INFRARED BRIGHTNESS TEMPERUATRES
!     AND CLOUD TOP TEMPERATURE SATELLITE SHOULD SEE
!
!     again this is only done if top_height = 1 or 3
!
!     fluxtop is the 10.5 micron radiance at the top of the
!              atmosphere
!     trans_layers_above is the total transmissivity in the layers
!             above the current layer
!     fluxtop_clrsky(j) and trans_layers_above_clrsky(j) are the clear
!             sky versions of these quantities.

      if (top_height .eq. 1 .or. top_height .eq. 3) then


        !----------------------------------------------------------------------
        !    
        !             DO CLEAR SKY RADIANCE CALCULATION FIRST
        !
        !compute water vapor continuum emissivity
        !this treatment follows Schwarkzopf and Ramasamy
        !JGR 1999,vol 104, pages 9467-9499.
        !the emissivity is calculated at a wavenumber of 955 cm-1, 
        !or 10.47 microns 
        wtmair = 28.9644
        wtmh20 = 18.01534
        Navo = 6.023E+23
        grav = 9.806650E+02
        pstd = 1.013250E+06
        t0 = 296.
#ifdef COSP_GFDL
        if (ncolprint .ne. 0) &
     &         write(logunit,*)  'ilev   pw (kg/m2)   tauwv(j)      dem_wv'
#else
        if (ncolprint .ne. 0) 
     &         write(6,*)  'ilev   pw (kg/m2)   tauwv(j)      dem_wv'
#endif
        do 125 ilev=1,nlev
          do j=1,npoints 
               !press and dpress are dyne/cm2 = Pascals *10
               press(j) = pfull(j,ilev)*10.
               dpress(j) = (phalf(j,ilev+1)-phalf(j,ilev))*10
               !atmden = g/cm2 = kg/m2 / 10 
               atmden(j) = dpress(j)/grav
               rvh20(j) = qv(j,ilev)*wtmair/wtmh20
               wk(j) = rvh20(j)*Navo*atmden(j)/wtmair
               rhoave(j) = (press(j)/pstd)*(t0/at(j,ilev))
               rh20s(j) = rvh20(j)*rhoave(j)
               rfrgn(j) = rhoave(j)-rh20s(j)
               tmpexp(j) = exp(-0.02*(at(j,ilev)-t0))
#ifdef COSP_GFDL
               tauwv(j) = wk(j)*1.e-20*(          &
     &           (0.0224697*rh20s(j)*tmpexp(j)) + &
     &                (3.41817e-7*rfrgn(j)) )*0.98
#else
               tauwv(j) = wk(j)*1.e-20*( 
     &           (0.0224697*rh20s(j)*tmpexp(j)) + 
     &                (3.41817e-7*rfrgn(j)) )*0.98
#endif
               dem_wv(j,ilev) = 1. - exp( -1. * tauwv(j))
          enddo
               if (ncolprint .ne. 0) then
               do j=1,npoints ,1000
#ifdef COSP_GFDL
               write(logunit,'(a10)') 'j='
               write(logunit,'(8I10)') j
               write(logunit,'(i2,1X,3(f8.3,3X))') ilev,                 &
     &           qv(j,ilev)*(phalf(j,ilev+1)-phalf(j,ilev))/(grav/100.), &
     &           tauwv(j),dem_wv(j,ilev)
#else
               write(6,'(a10)') 'j='
               write(6,'(8I10)') j
               write(6,'(i2,1X,3(f8.3,3X))') ilev,
     &           qv(j,ilev)*(phalf(j,ilev+1)-phalf(j,ilev))/(grav/100.),
     &           tauwv(j),dem_wv(j,ilev)
#endif
               enddo
             endif
125     continue

        !initialize variables
        do j=1,npoints 
          fluxtop_clrsky(j) = 0.
          trans_layers_above_clrsky(j)=1.
        enddo

        do ilev=1,nlev
          do j=1,npoints 
 
            ! Black body emission at temperature of the layer

              bb(j)=1 / ( exp(1307.27/at(j,ilev)) - 1. )
              !bb(j)= 5.67e-8*at(j,ilev)**4

              ! increase TOA flux by flux emitted from layer
              ! times total transmittance in layers above

#ifdef COSP_GFDL
                fluxtop_clrsky(j) = fluxtop_clrsky(j) &
     &            + dem_wv(j,ilev)*bb(j)*trans_layers_above_clrsky(j)
#else
                fluxtop_clrsky(j) = fluxtop_clrsky(j) 
     &            + dem_wv(j,ilev)*bb(j)*trans_layers_above_clrsky(j) 
#endif
            
                ! update trans_layers_above with transmissivity
              ! from this layer for next time around loop

#ifdef COSP_GFDL
                trans_layers_above_clrsky(j)= &
     &            trans_layers_above_clrsky(j)*(1.-dem_wv(j,ilev))
#else
                trans_layers_above_clrsky(j)=
     &            trans_layers_above_clrsky(j)*(1.-dem_wv(j,ilev))
#endif
                   

          enddo   
            if (ncolprint.ne.0) then
             do j=1,npoints ,1000
#ifdef COSP_GFDL
              write(logunit,'(a10)') 'j='
              write(logunit,'(8I10)') j
              write (logunit,'(a)') 'ilev:'
              write (logunit,'(I2)') ilev

              write (logunit,'(a)') &
     &        'emiss_layer,100.*bb(j),100.*f,total_trans:'
              write (logunit,'(4(f7.2,1X))') dem_wv(j,ilev),100.*bb(j), &
     &             100.*fluxtop_clrsky(j),trans_layers_above_clrsky(j)
#else
              write(6,'(a10)') 'j='
              write(6,'(8I10)') j
              write (6,'(a)') 'ilev:'
              write (6,'(I2)') ilev
    
              write (6,'(a)') 
     &        'emiss_layer,100.*bb(j),100.*f,total_trans:'
              write (6,'(4(f7.2,1X))') dem_wv(j,ilev),100.*bb(j),
     &             100.*fluxtop_clrsky(j),trans_layers_above_clrsky(j)
#endif
             enddo   
            endif

        enddo   !loop over level
        
        do j=1,npoints 
          !add in surface emission
          bb(j)=1/( exp(1307.27/skt(j)) - 1. )
          !bb(j)=5.67e-8*skt(j)**4

#ifdef COSP_GFDL
          fluxtop_clrsky(j) = fluxtop_clrsky(j) + emsfc_lw * bb(j) &
     &     * trans_layers_above_clrsky(j)
#else
          fluxtop_clrsky(j) = fluxtop_clrsky(j) + emsfc_lw * bb(j) 
     &     * trans_layers_above_clrsky(j)
#endif
     
          !clear sky brightness temperature
          meantbclr(j) = 1307.27/(log(1.+(1./fluxtop_clrsky(j))))
	  
        enddo

        if (ncolprint.ne.0) then
        do j=1,npoints ,1000
#ifdef COSP_GFDL
          write(logunit,'(a10)') 'j='
          write(logunit,'(8I10)') j
          write (logunit,'(a)') 'id:'
          write (logunit,'(a)') 'surface'
 
          write (logunit,'(a)') 'emsfc,100.*bb(j),100.*f,total_trans:'
          write (logunit,'(5(f7.2,1X))') emsfc_lw,100.*bb(j), &
     &      100.*fluxtop_clrsky(j), &
     &       trans_layers_above_clrsky(j), meantbclr(j)
#else
          write(6,'(a10)') 'j='
          write(6,'(8I10)') j
          write (6,'(a)') 'id:'
          write (6,'(a)') 'surface'

          write (6,'(a)') 'emsfc,100.*bb(j),100.*f,total_trans:'
          write (6,'(5(f7.2,1X))') emsfc_lw,100.*bb(j),
     &      100.*fluxtop_clrsky(j),
     &       trans_layers_above_clrsky(j), meantbclr(j)
#endif
        enddo
      endif
    

        !
        !           END OF CLEAR SKY CALCULATION
        !
        !----------------------------------------------------------------



        if (ncolprint.ne.0) then

        do j=1,npoints ,1000
#ifdef COSP_GFDL
            write(logunit,'(a10)') 'j='
            write(logunit,'(8I10)') j
            write (logunit,'(a)') 'ts:'
            write (logunit,'(8f7.2)') (skt(j),ibox=1,ncolprint)

            write (logunit,'(a)') 'ta_rev:'
            write (logunit,'(8f7.2)') &
     &       ((at(j,ilev2),ibox=1,ncolprint),ilev2=1,nlev)
#else
            write(6,'(a10)') 'j='
            write(6,'(8I10)') j
            write (6,'(a)') 'ts:'
            write (6,'(8f7.2)') (skt(j),ibox=1,ncolprint)
    
            write (6,'(a)') 'ta_rev:'
            write (6,'(8f7.2)') 
     &       ((at(j,ilev2),ibox=1,ncolprint),ilev2=1,nlev)
#endif

        enddo
        endif 
        !loop over columns 
        do ibox=1,ncol
          do j=1,npoints
            fluxtop(j,ibox)=0.
            trans_layers_above(j,ibox)=1.
          enddo
        enddo

        do ilev=1,nlev
              do j=1,npoints 
                ! Black body emission at temperature of the layer

              bb(j)=1 / ( exp(1307.27/at(j,ilev)) - 1. )
              !bb(j)= 5.67e-8*at(j,ilev)**4
              enddo

            do ibox=1,ncol
              do j=1,npoints 

#ifdef COSP_GFDL
         if (present(dem_col)     ) then
               ! emissivity for point in this layer
                if (frac_out(j,ibox,ilev).eq.1 .or. &
     &              frac_out(j,ibox,ilev).eq.2) then
                dem(j,ibox)= 1. - &
     &          ( (1. - dem_wv(j,ilev)) * (1. -  dem_col(j,ibox,ilev)) )
                else
                dem(j,ibox)=  dem_wv(j,ilev)
                end if

         else
              ! emissivity for point in this layer
                if (frac_out(j,ibox,ilev).eq.1) then
                dem(j,ibox)= 1. - &
     &             ( (1. - dem_wv(j,ilev)) * (1. -  dem_s(j,ilev)) )
                else if (frac_out(j,ibox,ilev).eq.2) then
                dem(j,ibox)= 1. - &
     &             ( (1. - dem_wv(j,ilev)) * (1. -  dem_c(j,ilev)) )
                else
                dem(j,ibox)=  dem_wv(j,ilev)
                end if

         endif
#else
              ! emissivity for point in this layer
                if (frac_out(j,ibox,ilev).eq.1) then
                dem(j,ibox)= 1. - 
     &             ( (1. - dem_wv(j,ilev)) * (1. -  dem_s(j,ilev)) )
                else if (frac_out(j,ibox,ilev).eq.2) then
                dem(j,ibox)= 1. - 
     &             ( (1. - dem_wv(j,ilev)) * (1. -  dem_c(j,ilev)) )
                else
                dem(j,ibox)=  dem_wv(j,ilev)
                end if
#endif
                

                ! increase TOA flux by flux emitted from layer
              ! times total transmittance in layers above

#ifdef COSP_GFDL
                fluxtop(j,ibox) = fluxtop(j,ibox) &
     &            + dem(j,ibox) * bb(j)           &
     &            * trans_layers_above(j,ibox)
#else
                fluxtop(j,ibox) = fluxtop(j,ibox) 
     &            + dem(j,ibox) * bb(j)
     &            * trans_layers_above(j,ibox) 
#endif
            
                ! update trans_layers_above with transmissivity
              ! from this layer for next time around loop

#ifdef COSP_GFDL
                trans_layers_above(j,ibox)= &
     &            trans_layers_above(j,ibox)*(1.-dem(j,ibox))
#else
                trans_layers_above(j,ibox)=
     &            trans_layers_above(j,ibox)*(1.-dem(j,ibox))
#endif

              enddo ! j
            enddo ! ibox

            if (ncolprint.ne.0) then
              do j=1,npoints,1000
#ifdef COSP_GFDL
              write (logunit,'(a)') 'ilev:'
              write (logunit,'(I2)') ilev

              write(logunit,'(a10)') 'j='
              write(logunit,'(8I10)') j
              write (logunit,'(a)') 'emiss_layer:'
              write (logunit,'(8f7.2)') (dem(j,ibox),ibox=1,ncolprint)
 
              write (logunit,'(a)') '100.*bb(j):'
              write (logunit,'(8f7.2)') (100.*bb(j),ibox=1,ncolprint)
 
              write (logunit,'(a)') '100.*f:'
              write (logunit,'(8f7.2)') &
     &         (100.*fluxtop(j,ibox),ibox=1,ncolprint)

              write (logunit,'(a)') 'total_trans:'
              write (logunit,'(8f7.2)') &
     &          (trans_layers_above(j,ibox),ibox=1,ncolprint)
#else
              write (6,'(a)') 'ilev:'
              write (6,'(I2)') ilev
    
              write(6,'(a10)') 'j='
              write(6,'(8I10)') j
              write (6,'(a)') 'emiss_layer:'
              write (6,'(8f7.2)') (dem(j,ibox),ibox=1,ncolprint)
        
              write (6,'(a)') '100.*bb(j):'
              write (6,'(8f7.2)') (100.*bb(j),ibox=1,ncolprint)
        
              write (6,'(a)') '100.*f:'
              write (6,'(8f7.2)') 
     &         (100.*fluxtop(j,ibox),ibox=1,ncolprint)
        
              write (6,'(a)') 'total_trans:'
              write (6,'(8f7.2)') 
     &          (trans_layers_above(j,ibox),ibox=1,ncolprint)
#endif
            enddo
          endif

        enddo ! ilev


          do j=1,npoints 
            !add in surface emission
            bb(j)=1/( exp(1307.27/skt(j)) - 1. )
            !bb(j)=5.67e-8*skt(j)**4
          end do

        do ibox=1,ncol
          do j=1,npoints 

            !add in surface emission

#ifdef COSP_GFDL
            fluxtop(j,ibox) = fluxtop(j,ibox) &
     &         + emsfc_lw * bb(j)             &
     &         * trans_layers_above(j,ibox)
#else
            fluxtop(j,ibox) = fluxtop(j,ibox) 
     &         + emsfc_lw * bb(j) 
     &         * trans_layers_above(j,ibox) 
#endif
            
          end do
        end do

        !calculate mean infrared brightness temperature
        do ibox=1,ncol
          do j=1,npoints 
            meantb(j) = meantb(j)+1307.27/(log(1.+(1./fluxtop(j,ibox))))
	  end do
        end do
	  do j=1, npoints
	    meantb(j) = meantb(j) / real(ncol)
	  end do        

        if (ncolprint.ne.0) then

          do j=1,npoints ,1000
#ifdef COSP_GFDL
          write(logunit,'(a10)') 'j='
          write(logunit,'(8I10)') j
          write (logunit,'(a)') 'id:'
          write (logunit,'(a)') 'surface'

          write (logunit,'(a)') 'emiss_layer:'
          write (logunit,'(8f7.2)') (dem(1,ibox),ibox=1,ncolprint)
 
          write (logunit,'(a)') '100.*bb(j):'
          write (logunit,'(8f7.2)') (100.*bb(j),ibox=1,ncolprint)
 
          write (logunit,'(a)') '100.*f:'
          write (logunit,'(8f7.2)') (100.*fluxtop(j,ibox),ibox=1,ncolprint)
 
          write (logunit,'(a)') 'meantb(j):'
          write (logunit,'(8f7.2)') (meantb(j),ibox=1,ncolprint)
#else
          write(6,'(a10)') 'j='
          write(6,'(8I10)') j
          write (6,'(a)') 'id:'
          write (6,'(a)') 'surface'

          write (6,'(a)') 'emiss_layer:'
          write (6,'(8f7.2)') (dem(1,ibox),ibox=1,ncolprint)
    
          write (6,'(a)') '100.*bb(j):'
          write (6,'(8f7.2)') (100.*bb(j),ibox=1,ncolprint)
    
          write (6,'(a)') '100.*f:'
          write (6,'(8f7.2)') (100.*fluxtop(j,ibox),ibox=1,ncolprint)
          
	  write (6,'(a)') 'meantb(j):'
          write (6,'(8f7.2)') (meantb(j),ibox=1,ncolprint)
#endif
      
          end do
      endif
    
        !now that you have the top of atmosphere radiance account
        !for ISCCP procedures to determine cloud top temperature

        !account for partially transmitting cloud recompute flux 
        !ISCCP would see assuming a single layer cloud
        !note choice here of 2.13, as it is primarily ice
        !clouds which have partial emissivity and need the 
        !adjustment performed in this section
        !
      !If it turns out that the cloud brightness temperature
      !is greater than 260K, then the liquid cloud conversion
        !factor of 2.56 is used.
      !
        !Note that this is discussed on pages 85-87 of 
        !the ISCCP D level documentation (Rossow et al. 1996)
           
          do j=1,npoints  
            !compute minimum brightness temperature and optical depth
            btcmin(j) = 1. /  ( exp(1307.27/(attrop(j)-5.)) - 1. ) 
          enddo 
        do ibox=1,ncol
          do j=1,npoints  
#ifdef COSP_GFDL
            transmax(j) = (fluxtop(j,ibox)-btcmin(j)) &
     &                /(fluxtop_clrsky(j)-btcmin(j))
#else
            transmax(j) = (fluxtop(j,ibox)-btcmin(j))
     &                /(fluxtop_clrsky(j)-btcmin(j))
#endif
          !note that the initial setting of tauir(j) is needed so that
          !tauir(j) has a realistic value should the next if block be
          !bypassed
            tauir(j) = tau(j,ibox) * rec2p13
            taumin(j) = -1. * log(max(min(transmax(j),0.9999999),0.001))

          enddo 

          if (top_height .eq. 1) then
            do j=1,npoints  
#ifdef COSP_GFDL
              if (transmax(j) .gt. 0.001 .and. &
     &          transmax(j) .le. 0.9999999) then
#else
              if (transmax(j) .gt. 0.001 .and. 
     &          transmax(j) .le. 0.9999999) then
#endif
                fluxtopinit(j) = fluxtop(j,ibox)
              tauir(j) = tau(j,ibox) *rec2p13
              endif
            enddo
            do icycle=1,2
              do j=1,npoints  
                if (tau(j,ibox) .gt. (tauchk            )) then 
#ifdef COSP_GFDL
                if (transmax(j) .gt. 0.001 .and. &
     &            transmax(j) .le. 0.9999999) then
                  emcld(j,ibox) = 1. - exp(-1. * tauir(j)  )
                  fluxtop(j,ibox) = fluxtopinit(j) -   &
     &              ((1.-emcld(j,ibox))*fluxtop_clrsky(j))
                  fluxtop(j,ibox)=max(1.E-06, &
     &              (fluxtop(j,ibox)/emcld(j,ibox)))
                  tb(j,ibox)= 1307.27 &
     &              / (log(1. + (1./fluxtop(j,ibox))))              
#else
                if (transmax(j) .gt. 0.001 .and. 
     &            transmax(j) .le. 0.9999999) then
                  emcld(j,ibox) = 1. - exp(-1. * tauir(j)  )
                  fluxtop(j,ibox) = fluxtopinit(j) -   
     &              ((1.-emcld(j,ibox))*fluxtop_clrsky(j))
                  fluxtop(j,ibox)=max(1.E-06,
     &              (fluxtop(j,ibox)/emcld(j,ibox)))
                  tb(j,ibox)= 1307.27
     &              / (log(1. + (1./fluxtop(j,ibox))))
#endif
                  if (tb(j,ibox) .gt. 260.) then
                  tauir(j) = tau(j,ibox) / 2.56
                  end if                   
                end if
                end if
              enddo
            enddo
                
          endif
        
          do j=1,npoints
            if (tau(j,ibox) .gt. (tauchk            )) then 
                !cloudy box 
		!NOTE: tb is the cloud-top temperature not infrared brightness temperature 
		!at this point in the code
                tb(j,ibox)= 1307.27/ (log(1. + (1./fluxtop(j,ibox))))
                if (top_height.eq.1.and.tauir(j).lt.taumin(j)) then
                         tb(j,ibox) = attrop(j) - 5. 
                   tau(j,ibox) = 2.13*taumin(j)
                end if
            else
                !clear sky brightness temperature
                tb(j,ibox) = meantbclr(j)
            end if
          enddo ! j
        enddo ! ibox

        if (ncolprint.ne.0) then

          do j=1,npoints,1000
#ifdef COSP_GFDL
          write(logunit,'(a10)') 'j='
          write(logunit,'(8I10)') j
 
          write (logunit,'(a)') 'attrop:'
          write (logunit,'(8f7.2)') (attrop(j))
 
          write (logunit,'(a)') 'btcmin:'
          write (logunit,'(8f7.2)') (btcmin(j))

          write (logunit,'(a)') 'fluxtop_clrsky*100:'
          write (logunit,'(8f7.2)') &
     &      (100.*fluxtop_clrsky(j))

          write (logunit,'(a)') '100.*f_adj:'
          write (logunit,'(8f7.2)') (100.*fluxtop(j,ibox),ibox=1,ncolprint)

          write (logunit,'(a)') 'transmax:'
          write (logunit,'(8f7.2)') (transmax(ibox),ibox=1,ncolprint)

          write (logunit,'(a)') 'tau:'
          write (logunit,'(8f7.2)') (tau(j,ibox),ibox=1,ncolprint)

          write (logunit,'(a)') 'emcld:'
          write (logunit,'(8f7.2)') (emcld(j,ibox),ibox=1,ncolprint)

          write (logunit,'(a)') 'total_trans:'
          write (logunit,'(8f7.2)') &
     &        (trans_layers_above(j,ibox),ibox=1,ncolprint)

          write (logunit,'(a)') 'total_emiss:'
          write (logunit,'(8f7.2)') &
     &        (1.0-trans_layers_above(j,ibox),ibox=1,ncolprint)

          write (logunit,'(a)') 'total_trans:'
          write (logunit,'(8f7.2)') &
     &        (trans_layers_above(j,ibox),ibox=1,ncolprint)

          write (logunit,'(a)') 'ppout:'
          write (logunit,'(8f7.2)') (tb(j,ibox),ibox=1,ncolprint)
#else
          write(6,'(a10)') 'j='
          write(6,'(8I10)') j

          write (6,'(a)') 'attrop:'
          write (6,'(8f7.2)') (attrop(j))
    
          write (6,'(a)') 'btcmin:'
          write (6,'(8f7.2)') (btcmin(j))
    
          write (6,'(a)') 'fluxtop_clrsky*100:'
          write (6,'(8f7.2)') 
     &      (100.*fluxtop_clrsky(j))

          write (6,'(a)') '100.*f_adj:'
          write (6,'(8f7.2)') (100.*fluxtop(j,ibox),ibox=1,ncolprint)
    
          write (6,'(a)') 'transmax:'
          write (6,'(8f7.2)') (transmax(ibox),ibox=1,ncolprint)
    
          write (6,'(a)') 'tau:'
          write (6,'(8f7.2)') (tau(j,ibox),ibox=1,ncolprint)
    
          write (6,'(a)') 'emcld:'
          write (6,'(8f7.2)') (emcld(j,ibox),ibox=1,ncolprint)
    
          write (6,'(a)') 'total_trans:'
          write (6,'(8f7.2)') 
     &        (trans_layers_above(j,ibox),ibox=1,ncolprint)
    
          write (6,'(a)') 'total_emiss:'
          write (6,'(8f7.2)') 
     &        (1.0-trans_layers_above(j,ibox),ibox=1,ncolprint)
    
          write (6,'(a)') 'total_trans:'
          write (6,'(8f7.2)') 
     &        (trans_layers_above(j,ibox),ibox=1,ncolprint)
    
          write (6,'(a)') 'ppout:'
          write (6,'(8f7.2)') (tb(j,ibox),ibox=1,ncolprint)
#endif
          enddo ! j
      endif

      end if

!     ---------------------------------------------------!

!     
!     ---------------------------------------------------!
!     DETERMINE CLOUD TOP PRESSURE
!
!     again the 2 methods differ according to whether
!     or not you use the physical cloud top pressure (top_height = 2)
!     or the radiatively determined cloud top pressure (top_height = 1 or 3)
!

      !compute cloud top pressure
      do 30 ibox=1,ncol
        !segregate according to optical thickness
        if (top_height .eq. 1 .or. top_height .eq. 3) then  
          !find level whose temperature
          !most closely matches brightness temperature
          do j=1,npoints 
            nmatch(j)=0
          enddo
          do 29 k1=1,nlev-1
	    if (top_height_direction .eq. 2) then
	      ilev = nlev - k1 
	    else
	      ilev = k1
	    end if
            !cdir nodep
            do j=1,npoints 
	     if (ilev .ge. itrop(j)) then
#ifdef COSP_GFDL
              if ((at(j,ilev)   .ge. tb(j,ibox) .and. &
     &          at(j,ilev+1) .le. tb(j,ibox)) .or. &
     &          (at(j,ilev) .le. tb(j,ibox) .and. &
     &          at(j,ilev+1) .ge. tb(j,ibox))) then
#else
              if ((at(j,ilev)   .ge. tb(j,ibox) .and. 
     &          at(j,ilev+1) .le. tb(j,ibox)) .or.
     &          (at(j,ilev) .le. tb(j,ibox) .and. 
     &          at(j,ilev+1) .ge. tb(j,ibox))) then 
#endif
                nmatch(j)=nmatch(j)+1
		match(j,nmatch(j))=ilev
              end if  
	     end if                         
            enddo
29        continue

          do j=1,npoints 
            if (nmatch(j) .ge. 1) then
              k1 = match(j,nmatch(j))
	      k2 = k1 + 1
              logp1 = log(pfull(j,k1))
              logp2 = log(pfull(j,k2))
	      atd = max(tauchk,abs(at(j,k2) - at(j,k1)))
              logp=logp1+(logp2-logp1)*abs(tb(j,ibox)-at(j,k1))/atd
              ptop(j,ibox) = exp(logp)
#ifdef COSP_GFDL
              if(abs(pfull(j,k1)-ptop(j,ibox)) .lt. &
     &            abs(pfull(j,k2)-ptop(j,ibox))) then
#else
	      if(abs(pfull(j,k1)-ptop(j,ibox)) .lt.
     &            abs(pfull(j,k2)-ptop(j,ibox))) then
#endif
                 levmatch(j,ibox)=k1
              else
                 levmatch(j,ibox)=k2
              end if   
            else
              if (tb(j,ibox) .le. attrop(j)) then
                ptop(j,ibox)=ptrop(j)
                levmatch(j,ibox)=itrop(j)
              end if
              if (tb(j,ibox) .ge. atmax(j)) then
                ptop(j,ibox)=pfull(j,nlev)
                levmatch(j,ibox)=nlev
              end if                                
            end if
          enddo ! j

        else ! if (top_height .eq. 1 .or. top_height .eq. 3) 
 
          do j=1,npoints     
            ptop(j,ibox)=0.
          enddo
          do ilev=1,nlev
            do j=1,npoints     
#ifdef COSP_GFDL
              if ((ptop(j,ibox) .eq. 0. ) &
     &           .and.(frac_out(j,ibox,ilev) .ne. 0)) then
#else
              if ((ptop(j,ibox) .eq. 0. )
     &           .and.(frac_out(j,ibox,ilev) .ne. 0)) then
#endif
                ptop(j,ibox)=phalf(j,ilev)
              levmatch(j,ibox)=ilev
              end if
            end do
          end do
        end if                            
          
        do j=1,npoints
          if (tau(j,ibox) .le. (tauchk            )) then
            ptop(j,ibox)=0.
            levmatch(j,ibox)=0      
          endif 
        enddo

30    continue
              
!
!
!     ---------------------------------------------------!


!     
!     ---------------------------------------------------!
!     DETERMINE ISCCP CLOUD TYPE FREQUENCIES
!
!     Now that ptop and tau have been determined, 
!     determine amount of each of the 49 ISCCP cloud
!     types
!
!     Also compute grid box mean cloud top pressure and
!     optical thickness.  The mean cloud top pressure and
!     optical thickness are averages over the cloudy 
!     area only. The mean cloud top pressure is a linear
!     average of the cloud top pressures.  The mean cloud
!     optical thickness is computed by converting optical
!     thickness to an albedo, averaging in albedo units,
!     then converting the average albedo back to a mean
!     optical thickness.  
!

      !compute isccp frequencies

      !reset frequencies
      do 38 ilev=1,7
      do 38 ilev2=1,7
        do j=1,npoints ! 
             if (sunlit(j).eq.1 .or. top_height .eq. 3) then 
                fq_isccp(j,ilev,ilev2)= 0.
	     else
	        fq_isccp(j,ilev,ilev2)= output_missing_value
	     end if
        enddo
38    continue

      !reset variables need for averaging cloud properties
      do j=1,npoints 
        if (sunlit(j).eq.1 .or. top_height .eq. 3) then 
             totalcldarea(j) = 0.
             meanalbedocld(j) = 0.
             meanptop(j) = 0.
             meantaucld(j) = 0.
	else
             totalcldarea(j) = output_missing_value
             meanalbedocld(j) = output_missing_value
             meanptop(j) = output_missing_value
             meantaucld(j) = output_missing_value
	end if
      enddo ! j

      boxarea = 1./real(ncol)
     
      do 39 ibox=1,ncol
        do j=1,npoints 

#ifdef COSP_GFDL
          if (tau(j,ibox) .gt. (tauchk            ) &
     &      .and. ptop(j,ibox) .gt. 0.) then
#else
          if (tau(j,ibox) .gt. (tauchk            )
     &      .and. ptop(j,ibox) .gt. 0.) then
#endif
              box_cloudy(j,ibox)=.true.
          endif

          if (box_cloudy(j,ibox)) then

              if (sunlit(j).eq.1 .or. top_height .eq. 3) then

                boxtau(j,ibox) = tau(j,ibox)

		if (tau(j,ibox) .ge. isccp_taumin) then
		   totalcldarea(j) = totalcldarea(j) + boxarea
		
                   !convert optical thickness to albedo
#ifdef COSP_GFDL
                    albedocld(j,ibox) &
     &             = (tau(j,ibox)**0.895)/((tau(j,ibox)**0.895)+6.82)

                   !contribute to averaging
                   meanalbedocld(j) = meanalbedocld(j)  &
     &                                +albedocld(j,ibox)*boxarea
#else
                   albedocld(j,ibox)
     &		   = (tau(j,ibox)**0.895)/((tau(j,ibox)**0.895)+6.82)
         
                   !contribute to averaging
                   meanalbedocld(j) = meanalbedocld(j) 
     &                                +albedocld(j,ibox)*boxarea
#endif

                end if

            endif

          endif

          if (sunlit(j).eq.1 .or. top_height .eq. 3) then 

           if (box_cloudy(j,ibox)) then
          
              !convert ptop to millibars
              ptop(j,ibox)=ptop(j,ibox) / 100.
            
              !save for output cloud top pressure and optical thickness
              boxptop(j,ibox) = ptop(j,ibox)
    
              if (tau(j,ibox) .ge. isccp_taumin) then
	      	meanptop(j) = meanptop(j) + ptop(j,ibox)*boxarea
              end if		

              !reset itau(j), ipres(j)
              itau(j) = 0
              ipres(j) = 0

              !determine optical depth category
#ifdef COSP_GFDL
              if (tau(j,ibox) .lt. isccp_taumin) then
                  itau(j)=1
              else if (tau(j,ibox) .ge. isccp_taumin &
     &          .and. tau(j,ibox) .lt. 1.3) then
                itau(j)=2
              else if (tau(j,ibox) .ge. 1.3 &
     &          .and. tau(j,ibox) .lt. 3.6) then
                itau(j)=3
              else if (tau(j,ibox) .ge. 3.6 &
     &          .and. tau(j,ibox) .lt. 9.4) then
                  itau(j)=4
              else if (tau(j,ibox) .ge. 9.4 &
     &          .and. tau(j,ibox) .lt. 23.) then
                  itau(j)=5
              else if (tau(j,ibox) .ge. 23. &
     &          .and. tau(j,ibox) .lt. 60.) then
                  itau(j)=6
              else if (tau(j,ibox) .ge. 60.) then
                  itau(j)=7
              end if

              !determine cloud top pressure category
              if (    ptop(j,ibox) .gt. 0.   &
     &          .and.ptop(j,ibox) .lt. 180.) then
                 ipres(j)=1
              else if(ptop(j,ibox) .ge. 180. &
     &          .and.ptop(j,ibox) .lt. 310.) then
                  ipres(j)=2
              else if(ptop(j,ibox) .ge. 310. &
     &          .and.ptop(j,ibox) .lt. 440.) then
                  ipres(j)=3
              else if(ptop(j,ibox) .ge. 440. &
     &          .and.ptop(j,ibox) .lt. 560.) then
                  ipres(j)=4
              else if(ptop(j,ibox) .ge. 560. &
     &          .and.ptop(j,ibox) .lt. 680.) then
                  ipres(j)=5
              else if(ptop(j,ibox) .ge. 680. &
     &          .and.ptop(j,ibox) .lt. 800.) then
                  ipres(j)=6
              else if(ptop(j,ibox) .ge. 800.) then
                  ipres(j)=7
              end if
#else
              if (tau(j,ibox) .lt. isccp_taumin) then
                  itau(j)=1
              else if (tau(j,ibox) .ge. isccp_taumin
     &                                    
     &          .and. tau(j,ibox) .lt. 1.3) then
                itau(j)=2
              else if (tau(j,ibox) .ge. 1.3 
     &          .and. tau(j,ibox) .lt. 3.6) then
                itau(j)=3
              else if (tau(j,ibox) .ge. 3.6 
     &          .and. tau(j,ibox) .lt. 9.4) then
                  itau(j)=4
              else if (tau(j,ibox) .ge. 9.4 
     &          .and. tau(j,ibox) .lt. 23.) then
                  itau(j)=5
              else if (tau(j,ibox) .ge. 23. 
     &          .and. tau(j,ibox) .lt. 60.) then
                  itau(j)=6
              else if (tau(j,ibox) .ge. 60.) then
                  itau(j)=7
              end if

              !determine cloud top pressure category
              if (    ptop(j,ibox) .gt. 0.  
     &          .and.ptop(j,ibox) .lt. 180.) then
                  ipres(j)=1
              else if(ptop(j,ibox) .ge. 180.
     &          .and.ptop(j,ibox) .lt. 310.) then
                  ipres(j)=2
              else if(ptop(j,ibox) .ge. 310.
     &          .and.ptop(j,ibox) .lt. 440.) then
                  ipres(j)=3
              else if(ptop(j,ibox) .ge. 440.
     &          .and.ptop(j,ibox) .lt. 560.) then
                  ipres(j)=4
              else if(ptop(j,ibox) .ge. 560.
     &          .and.ptop(j,ibox) .lt. 680.) then
                  ipres(j)=5
              else if(ptop(j,ibox) .ge. 680.
     &          .and.ptop(j,ibox) .lt. 800.) then
                  ipres(j)=6
              else if(ptop(j,ibox) .ge. 800.) then
                  ipres(j)=7
              end if 
#endif

              !update frequencies
              if(ipres(j) .gt. 0.and.itau(j) .gt. 0) then
#ifdef COSP_GFDL
              fq_isccp(j,itau(j),ipres(j))= &
     &          fq_isccp(j,itau(j),ipres(j))+ boxarea
#else
              fq_isccp(j,itau(j),ipres(j))=
     &          fq_isccp(j,itau(j),ipres(j))+ boxarea
#endif
              end if

            end if

          end if
                       
        enddo ! j
39    continue
      
      !compute mean cloud properties
      do j=1,npoints 
        if (totalcldarea(j) .gt. 0.) then
	  ! code above guarantees that totalcldarea > 0 
	  ! only if sunlit .eq. 1 .or. top_height = 3 
	  ! and applies only to clouds with tau > isccp_taumin
          meanptop(j) = meanptop(j) / totalcldarea(j)
          meanalbedocld(j) = meanalbedocld(j) / totalcldarea(j)
          meantaucld(j) = (6.82/((1./meanalbedocld(j))-1.))**(1./0.895)
	else
	  ! this code is necessary so that in the case that totalcldarea = 0.,
	  ! that these variables, which are in-cloud averages, are set to missing
	  ! note that totalcldarea will be 0. if all the clouds in the grid box have
	  ! tau < isccp_taumin 
	  meanptop(j) = output_missing_value
          meanalbedocld(j) = output_missing_value
          meantaucld(j) = output_missing_value
        end if
      enddo ! j
!
!     ---------------------------------------------------!

!     ---------------------------------------------------!
!     OPTIONAL PRINTOUT OF DATA TO CHECK PROGRAM
!
      if (debugcol.ne.0) then
!     
         do j=1,npoints,debugcol

            !produce character output
            do ilev=1,nlev
              do ibox=1,ncol
                   acc(ilev,ibox)=0
              enddo
            enddo

            do ilev=1,nlev
              do ibox=1,ncol
                   acc(ilev,ibox)=frac_out(j,ibox,ilev)*2
#ifdef COSP_GFDL
                   if (levmatch(j,ibox) .eq. ilev) &
     &                 acc(ilev,ibox)=acc(ilev,ibox)+1
#else
                   if (levmatch(j,ibox) .eq. ilev) 
     &                 acc(ilev,ibox)=acc(ilev,ibox)+1
#endif
              enddo
            enddo

             !print test

          write(ftn09,11) j
11        format('ftn09.',i4.4)
#ifdef COSP_GFDL 
          funit = get_unit()
          open(funit, FILE=ftn09, FORM='FORMATTED')

             write(funit,'(a1)') ' '
             write(funit,'(10i5)')  &
     &                  (ilev,ilev=5,nlev,5)
             write(funit,'(a1)') ' '

             do ibox=1,ncol
               write(funit,'(40(a1),1x,40(a1))')                &
     &           (cchar_realtops(acc(ilev,ibox)+1),ilev=1,nlev) &
     &           ,(cchar(acc(ilev,ibox)+1),ilev=1,nlev)
             end do
             close(funit)
#else
          open(9, FILE=ftn09, FORM='FORMATTED')

             write(9,'(a1)') ' '
             write(9,'(10i5)')
     &                  (ilev,ilev=5,nlev,5)
             write(9,'(a1)') ' '
             
             do ibox=1,ncol
               write(9,'(40(a1),1x,40(a1))')
     &           (cchar_realtops(acc(ilev,ibox)+1),ilev=1,nlev) 
     &           ,(cchar(acc(ilev,ibox)+1),ilev=1,nlev) 
             end do
             close(9)
#endif

             if (ncolprint.ne.0) then
#ifdef COSP_GFDL
               write(logunit,'(a1)') ' '
                    write(logunit,'(a2,1X,5(a7,1X),a50)') &
     &                  'ilev',                           &
     &                  'pfull','at',                     &
     &                  'cc*100','dem_s','dtau_s',        &
     &                  'cchar'

!               do 4012 ilev=1,nlev
!                    write(logunit,'(60i2)') (box(i,ilev),i=1,ncolprint)
!                   write(logunit,'(i2,1X,5(f7.2,1X),50(a1))')
!     &                  ilev,
!     &                  pfull(j,ilev)/100.,at(j,ilev),
!     &                  cc(j,ilev)*100.0,dem_s(j,ilev),dtau_s(j,ilev)
!     &                  ,(cchar(acc(ilev,ibox)+1),ibox=1,ncolprint)
!4012           continue
               write (logunit,'(a)') 'skt(j):'
               write (logunit,'(8f7.2)') skt(j)

               write (logunit,'(8I7)') (ibox,ibox=1,ncolprint)
               
               write (logunit,'(a)') 'tau:'
               write (logunit,'(8f7.2)') (tau(j,ibox),ibox=1,ncolprint)

               write (logunit,'(a)') 'tb:'
               write (logunit,'(8f7.2)') (tb(j,ibox),ibox=1,ncolprint)

               write (logunit,'(a)') 'ptop:'
               write (logunit,'(8f7.2)') (ptop(j,ibox),ibox=1,ncolprint)
#else
               write(6,'(a1)') ' '
                    write(6,'(a2,1X,5(a7,1X),a50)') 
     &                  'ilev',
     &                  'pfull','at',
     &                  'cc*100','dem_s','dtau_s',
     &                  'cchar'

!               do 4012 ilev=1,nlev
!                    write(6,'(60i2)') (box(i,ilev),i=1,ncolprint)
!                   write(6,'(i2,1X,5(f7.2,1X),50(a1))') 
!     &                  ilev,
!     &                  pfull(j,ilev)/100.,at(j,ilev),
!     &                  cc(j,ilev)*100.0,dem_s(j,ilev),dtau_s(j,ilev)
!     &                  ,(cchar(acc(ilev,ibox)+1),ibox=1,ncolprint)
!4012           continue
               write (6,'(a)') 'skt(j):'
               write (6,'(8f7.2)') skt(j)
                                      
               write (6,'(8I7)') (ibox,ibox=1,ncolprint)
            
               write (6,'(a)') 'tau:'
               write (6,'(8f7.2)') (tau(j,ibox),ibox=1,ncolprint)
    
               write (6,'(a)') 'tb:'
               write (6,'(8f7.2)') (tb(j,ibox),ibox=1,ncolprint)
    
               write (6,'(a)') 'ptop:'
               write (6,'(8f7.2)') (ptop(j,ibox),ibox=1,ncolprint)
#endif
             endif 
    
        enddo
       
      end if 

      return
      end 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                                   !!
!!                   GNU General Public License                      !!
!!                                                                   !!
!! This file is part of the Flexible Modeling System (FMS).          !!
!!                                                                   !!
!! FMS is free software; you can redistribute it and/or modify it    !!
!! under the terms of the GNU General Public License as published by !!
!! the Free Software Foundation, either version 3 of the License, or !!
!! (at your option) any later version.                               !!
!!                                                                   !!
!! FMS is distributed in the hope that it will be useful,            !!
!! but WITHOUT ANY WARRANTY; without even the implied warranty of    !!
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the      !!
!! GNU General Public License for more details.                      !!
!!                                                                   !!
!! You should have received a copy of the GNU General Public License !!
!! along with FMS. if not, see: http://www.gnu.org/licenses/gpl.txt  !!
!!                                                                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module surface_flux_mod
!
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">GFDL </CONTACT>
!
!
! <OVERVIEW>
!  Driver program for the calculation of fluxes on the exchange grids. 
! </OVERVIEW>
!
! <DESCRIPTION>
!
! </DESCRIPTION>
!
! ============================================================================

use             fms_mod, only: FATAL, close_file, mpp_pe, mpp_root_pe, write_version_number
use             fms_mod, only: file_exist, check_nml_error, open_namelist_file, stdlog
use   monin_obukhov_mod, only: mo_drag, mo_profile
use  sat_vapor_pres_mod, only: escomp, descomp
use       constants_mod, only: cp_air, hlv, stefan, rdgas, rvgas, grav, vonkarm
use             mpp_mod, only: input_nml_file
use             mpp_mod, only: mpp_clock_id, mpp_clock_begin, mpp_clock_end, CLOCK_LOOP

implicit none
private

! ==== public interface ======================================================
public  surface_flux
! ==== end of public interface ===============================================

! <INTERFACE NAME="surface_flux">
!   <OVERVIEW>
!   For the calculation of fluxes on the exchange grids. 
!   </OVERVIEW>
!   <DESCRIPTION>
!   For the calculation of fluxes on the exchange grids. 
!   </DESCRIPTION>
!
!  <IN NAME="t_atm" TYPE="real, dimension(:)" UNITS="Kelvin">
!  Air temp lowest atmospheric level.  
!  </IN>
!  <IN NAME="q_atm" TYPE="real, dimension(:)" UNITS="dimensionless">
!  Mixing ratio at lowest atmospheric level (kg/kg).  
!  </IN>
!  <IN NAME="u_atm" TYPE="real, dimension(:)" UNITS="m/s">
!  Zonal wind velocity at lowest atmospheric level.       
!  </IN>
!  <IN NAME="v_atm" TYPE="real, dimension(:)" UNITS="m/s">
!  Meridional wind velocity at lowest atmospheric level.    
!  </IN>
!  <IN NAME="p_atm" TYPE="real, dimension(:)" UNITS="Pascal">
!  Pressure lowest atmospheric level.    
!  </IN>
!  <IN NAME="z_atm" TYPE="real, dimension(:)" UNITS="m" >
!  Height lowest atmospheric level. 
!  </IN>
!  <IN NAME="p_surf" TYPE="real, dimension(:)" UNITS="Pascal">
!   Pressure at the earth's surface
!  </IN>
!  <IN NAME="t_surf" TYPE="real, dimension(:)" UNITS="Kelvin">
!   Temp at the earth's surface
!  </IN>
!  <IN NAME="t_ca" TYPE="real, dimension(:)" UNITS="Kelvin">
!   Air temp at the canopy 
!  </IN>
!  <OUT NAME="q_surf" TYPE="real, dimension(:)" UNITS="dimensionless">
!  Mixing ratio at earth surface (kg/kg). 
!  </OUT>
!  <IN NAME="u_surf" TYPE="real, dimension(:)" UNITS="m/s">
!  Zonal wind velocity at earth surface.   
!  </IN>
!  <IN NAME="v_surf" TYPE="real, dimension(:)" UNITS="m/s">
!  Meridional wind velocity at earth surface. 
!  </IN>
!  <IN NAME="rough_mom" TYPE="real, dimension(:)" UNITS="m">
!  Momentum roughness length
!  </IN>
!  <IN NAME="rough_heat" TYPE="real, dimension(:)" UNITS="m">
!  Heat roughness length
!  </IN>
!  <IN NAME="rough_moist" TYPE="real, dimension(:)" UNITS="m">
! <Moisture roughness length
!  </IN>
!  <IN NAME="rough_scale" TYPE="real, dimension(:)" UNITS="dimensionless" >
!  Scale factor used to topographic roughness calculation
!  </IN>
!  <IN NAME="gust" TYPE="real, dimension(:)"  UNITS="m/s">
!   Gustiness factor 
!  </IN>
!  <OUT NAME="flux_t" TYPE="real, dimension(:)" UNITS="W/m^2">
!  Sensible heat flux 
!  </OUT>
!  <OUT NAME="flux_q" TYPE="real, dimension(:)" UNITS="kg/(m^2 s)">
!  Evaporative water flux 
!  </OUT>
!  <OUT NAME="flux_r" TYPE="real, dimension(:)" UNITS="W/m^2">
!  Radiative energy flux 
!  </OUT>
!  <OUT NAME="flux_u" TYPE="real, dimension(:)" UNITS="Pa">
!  Zonal momentum flux 
!  </OUT>
!  <OUT NAME="flux_v" TYPE="real, dimension(:)" UNITS="Pa">
! Meridional momentum flux 
!  </OUT>
!  <OUT NAME="cd_m" TYPE="real, dimension(:)" UNITS="dimensionless">
!  Momentum exchange coefficient 
!  </OUT>
!  <OUT NAME="cd_t" TYPE="real, dimension(:)" UNITS="dimensionless">
!  Heat exchange coefficient 
!  </OUT>
!  <OUT NAME="cd_q" TYPE="real, dimension(:)" UNITS="dimensionless">
!  Moisture exchange coefficient 
!  </OUT>
!  <OUT NAME="w_atm" TYPE="real, dimension(:)" UNITS="m/s">
!  Absolute wind at the lowest atmospheric level
!  </OUT>
!  <OUT NAME="u_star" TYPE="real, dimension(:)" UNITS="m/s">
!  Turbulent velocity scale 
!  </OUT>
!  <OUT NAME="b_star" TYPE="real, dimension(:)" UNITS="m/s^2">
!  Turbulent buoyant scale
!  </OUT>
!  <OUT NAME="q_star" TYPE="real, dimension(:)" UNITS="dimensionless">
!  Turbulent moisture scale
!  </OUT>
!  <OUT NAME="dhdt_surf" TYPE="real, dimension(:)" UNITS="(W/m^2)/K">
!  Sensible heat flux temperature sensitivity
!  </OUT>
!  <OUT NAME="dedt_surf" TYPE="real, dimension(:)" UNITS="1/K">
!   Moisture flux temperature sensitivity 
!  </OUT>
!  <OUT NAME="dedq_surf" TYPE="real, dimension(:)" UNITS="(kg/m^2)/s">
!  Moisture flux humidity sensitivity  
!  </OUT>
!  <OUT NAME="drdt_surf" TYPE="real, dimension(:)" UNITS="(W/m^2)/K">
!  Radiative energy flux temperature sensitivity 
!  </OUT>
!  <OUT NAME="dhdt_atm" TYPE="real, dimension(:)" UNITS="(W/m^2)/K">
!  Derivative of sensible heat flux over temp at the lowest atmos level.
!  </OUT>
!  <OUT NAME="dedq_atm" TYPE="real, dimension(:)" UNITS="(kg/m^2/sec)/K">
!  Derivative of water vapor flux over temp at the lowest atmos level.
!  </OUT>
!  <OUT NAME="dtaudu_atm" TYPE="real, dimension(:)" UNITS="Pa/(m/s)">
!  Derivative of zonal wind stress w.r.t the lowest level zonal 
!  wind speed of the atmos
!  </OUT>
!  <OUT NAME="dtaudv_atm" TYPE="real, dimension(:)" UNITS="Pa/(m/s)">
!  Derivative of meridional wind stress w.r.t the lowest level meridional 
!  wind speed of the atmos
!  </OUT>
!  <OUT NAME="dt" TYPE="real">
!  Time step (it is not used presently)
!  </OUT>
!  <IN NAME="land" TYPE="logical, dimension(:)">
!  Indicates where land exists (true if exchange cell is on land). 
!  </IN>
!  <IN NAME="seawater" TYPE="logical, dimension(:)">
!  Indicates where liquid ocean water exists 
!  (true if exchange cell is on liquid ocean water). 
!  </IN>
!  <IN NAME="avail" TYPE="logical, dimension(:)">
!  True where the exchange cell is active.  
!  </IN>


interface surface_flux
!    module procedure surface_flux_0d
    module procedure surface_flux_1d
    module procedure surface_flux_2d  
end interface
! </INTERFACE>

!-----------------------------------------------------------------------

character(len=*), parameter :: version = '$Id: surface_flux.F90,v 20.0 2013/12/13 23:27:45 fms Exp $'
character(len=*), parameter :: tagname = '$Name: tikal $'
   
logical :: do_init = .true.

real, parameter :: d622   = rdgas/rvgas
real, parameter :: d378   = 1.-d622
real, parameter :: hlars  = hlv/rvgas
real, parameter :: gcp    = grav/cp_air
real, parameter :: kappa  = rdgas/cp_air
real            :: d608   = d378/d622
      ! d608 set to zero at initialization if the use of 
      ! virtual temperatures is turned off in namelist
      
      
! ---- namelist with default values ------------------------------------------
! <NAMELIST NAME="surface_flux_nml">
!   <DATA NAME="no_neg_q"  TYPE="logical"  DEFAULT=".false.">
!    If q_atm_in (specific humidity) is negative (because of numerical truncation),  
!    then override with 0. 
!   </DATA>
!   <DATA NAME="use_virtual_temp"  TYPE="logical"  DEFAULT=".true.">
!    If true, use virtual potential temp to calculate the stability of the surface layer.
!    if false, use potential temp.
!   </DATA>
!   <DATA NAME="alt_gustiness"  TYPE="logical"  DEFAULT=".false.">
!   An alternative formulation for gustiness calculation. 
!   A minimum bound on the wind speed used influx calculations, with the bound 
!   equal to gust_const 
!   </DATA>
!   <DATA NAME="old_dtaudv"  TYPE="logical"  DEFAULT=".false.">
!   The derivative of surface wind stress w.r.t. the zonal wind and
!   meridional wind are approximated by the same tendency.
!   </DATA>
!   <DATA NAME="use_mixing_ratio"  TYPE="logical"  DEFAULT=".false.">
!   An option to provide capability to run the Manabe Climate form of the 
!   surface flux (coded for legacy purposes). 
!   </DATA>
!   <DATA NAME="gust_const"  TYPE=""  DEFAULT="1.0">
!    Constant for alternative gustiness calculation.
!   </DATA>
!   <DATA NAME="gust_min"  TYPE=""  DEFAULT="0.0">
!    Minimum gustiness used when alt_gustiness = false.
!   </DATA>
!   <DATA NAME="ncar_ocean_flux"  TYPE="logical"  DEFAULT=".false.">
!    Use NCAR climate model turbulent flux calculation described by
!    Large and Yeager, NCAR Technical Document, 2004
!   </DATA>
!   <DATA NAME="ncar_ocean_flux_orig"  TYPE="logical"  DEFAULT=".false.">
!    Use NCAR climate model turbulent flux calculation described by
!    Large and Yeager, NCAR Technical Document, 2004, using the original
!    GFDL implementation, which contains a bug in the specification of 
!    the exchange coefficient for the sensible heat.  This option is available
!    for legacy purposes, and is not recommended for new experiments.   
!   </DATA>
!   <DATA NAME="raoult_sat_vap"  TYPE="logical"  DEFAULT=".false.">
!    Reduce saturation vapor pressures to account for seawater salinity.
!   </DATA>
! </NAMELIST>

logical :: no_neg_q              = .false.  ! for backwards compatibility
logical :: use_virtual_temp      = .true. 
logical :: alt_gustiness         = .false.
logical :: old_dtaudv            = .false.
logical :: use_mixing_ratio      = .false.
real    :: gust_const            =  1.0
real    :: gust_min              =  0.0
logical :: ncar_ocean_flux       = .false.
logical :: ncar_ocean_flux_orig  = .false. ! for backwards compatibility 
logical :: raoult_sat_vap        = .false.
logical :: do_simple             = .false.


namelist /surface_flux_nml/ no_neg_q,             &
                            use_virtual_temp,     &
                            alt_gustiness,        &
                            gust_const,           &
                            gust_min,             &
                            old_dtaudv,           &
                            use_mixing_ratio,     &
                            ncar_ocean_flux,      &
                            ncar_ocean_flux_orig, &
                            raoult_sat_vap,       &
                            do_simple       
   
integer :: id_clock_escomp = 0, id_clock_mo_drag = 0


contains


! ============================================================================
! <SUBROUTINE NAME="surface_flux_1d" INTERFACE="surface_flux">
!  <IN NAME="t_atm" TYPE="real, dimension(:)"> </IN>
!  <IN NAME="q_atm" TYPE="real, dimension(:)"> </IN>
!  <IN NAME="u_atm" TYPE="real, dimension(:)"> </IN>
!  <IN NAME="v_atm" TYPE="real, dimension(:)"> </IN>
!  <IN NAME="p_atm" TYPE="real, dimension(:)"> </IN>
!  <IN NAME="z_atm" TYPE="real, dimension(:)"> </IN>
!  <IN NAME="p_surf" TYPE="real, dimension(:)"> </IN>
!  <IN NAME="t_surf" TYPE="real, dimension(:)"> </IN>
!  <IN NAME="t_ca" TYPE="real, dimension(:)"> </IN>
!  <OUT NAME="q_surf" TYPE="real, dimension(:)"> </OUT>
!  <IN NAME="u_surf" TYPE="real, dimension(:)"> </IN>
!  <IN NAME="v_surf" TYPE="real, dimension(:)"> </IN>
!  <IN NAME="rough_mom" TYPE="real, dimension(:)"> </IN>
!  <IN NAME="rough_heat" TYPE="real, dimension(:)"> </IN>
!  <IN NAME="rough_moist" TYPE="real, dimension(:)"> </IN>
!  <IN NAME="rough_scale" TYPE="real, dimension(:)"> </IN>
!  <IN NAME="gust" TYPE="real, dimension(:)"> </IN>
!  <OUT NAME="flux_t" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="flux_q" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="flux_r" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="flux_u" TYPE="real, dimension(:)"></OUT>
!  <OUT NAME="flux_v" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="cd_m" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="cd_t" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="cd_q" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="w_atm" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="u_star" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="b_star" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="q_star" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="dhdt_surf" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="dedt_surf" TYPE="real, dimension(:)"></OUT>
!  <OUT NAME="dedq_surf" TYPE="real, dimension(:)"></OUT>
!  <OUT NAME="drdt_surf" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="dhdt_atm" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="dedq_atm" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="dtaudu_atm" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="dtaudv_atm" TYPE="real, dimension(:)"> </OUT>
!  <OUT NAME="dt" TYPE="real"> </OUT>
!  <IN NAME="land" TYPE="logical, dimension(:)"> </IN>
!  <IN NAME="seawater" TYPE="logical, dimension(:)"> </IN>
!  <IN NAME="avail" TYPE="logical, dimension(:)"> </IN>


!<PUBLICROUTINE INTERFACE="surface_flux">
subroutine surface_flux_1d (                                           &
     t_atm,     q_atm_in,   u_atm,     v_atm,     p_atm,     z_atm,    &
     p_surf,    t_surf,     t_ca,      q_surf,                         &
     u_surf,    v_surf,                                                &
     rough_mom, rough_heat, rough_moist, rough_scale, gust,            &
     flux_t, flux_q, flux_r, flux_u, flux_v,                           &
     cd_m,      cd_t,       cd_q,                                      &
     w_atm,     u_star,     b_star,     q_star,                        &
     dhdt_surf, dedt_surf,  dedq_surf,  drdt_surf,                     &
     dhdt_atm,  dedq_atm,   dtaudu_atm, dtaudv_atm,                    &
     dt,        land,      seawater,     avail  )
!</PUBLICROUTINE>
!  slm Mar 28 2002 -- remove agument drag_q since it is just cd_q*wind
! ============================================================================
  ! ---- arguments -----------------------------------------------------------
  logical, intent(in), dimension(:) :: land,  seawater, avail
  real, intent(in),  dimension(:) :: &
       t_atm,     q_atm_in,   u_atm,     v_atm,              &
       p_atm,     z_atm,      t_ca,                          &
       p_surf,    t_surf,     u_surf,    v_surf,  &
       rough_mom, rough_heat, rough_moist,  rough_scale, gust
  real, intent(out), dimension(:) :: &
       flux_t,    flux_q,     flux_r,    flux_u,  flux_v,    &
       dhdt_surf, dedt_surf,  dedq_surf, drdt_surf,          &
       dhdt_atm,  dedq_atm,   dtaudu_atm,dtaudv_atm,         &
       w_atm,     u_star,     b_star,    q_star,             &
       cd_m,      cd_t,       cd_q
  real, intent(inout), dimension(:) :: q_surf
  real, intent(in) :: dt

  ! ---- local constants -----------------------------------------------------
  ! temperature increment and its reciprocal value for comp. of derivatives
  real, parameter:: del_temp=0.1, del_temp_inv=1.0/del_temp

  ! ---- local vars ----------------------------------------------------------
  real, dimension(size(t_atm(:))) ::                          &
       thv_atm,  th_atm,   tv_atm,    thv_surf,            &
       e_sat,    e_sat1,   q_sat,     q_sat1,    p_ratio,  &
       t_surf0,  t_surf1,  u_dif,     v_dif,               &
       rho_drag, drag_t,    drag_m,   drag_q,    rho,      &
       q_atm,    q_surf0,  dw_atmdu,  dw_atmdv,  w_gust

  integer :: i, nbad


  if (do_init) call surface_flux_init

  !---- use local value of surf temp ----

  t_surf0 = 200.   !  avoids out-of-bounds in es lookup 
  where (avail)
     where (land)
        t_surf0 = t_ca
     elsewhere
        t_surf0 = t_surf
     endwhere
  endwhere

  t_surf1 = t_surf0 + del_temp

  call mpp_clock_begin(id_clock_escomp)
  call escomp ( t_surf0, e_sat  )  ! saturation vapor pressure
  call escomp ( t_surf1, e_sat1 )  ! perturbed  vapor pressure
  call mpp_clock_end(id_clock_escomp)

  if(use_mixing_ratio) then
    ! surface mixing ratio at saturation
    q_sat   = d622*e_sat /(p_surf-e_sat )  
    q_sat1  = d622*e_sat1/(p_surf-e_sat1)  
  elseif(do_simple) then                  !rif:(09/02/09)
    q_sat   = d622*e_sat / p_surf
    q_sat1  = d622*e_sat1/ p_surf   
  else
    ! surface specific humidity at saturation
    q_sat   = d622*e_sat /(p_surf-d378*e_sat )  
    q_sat1  = d622*e_sat1/(p_surf-d378*e_sat1)     
  endif

  ! initilaize surface air humidity according to surface type
  where (land)
     q_surf0 = q_surf ! land calculates it
  elsewhere
     q_surf0 = q_sat  ! everything else assumes saturated sfc humidity
  endwhere

  if (raoult_sat_vap) where (seawater) q_surf0 = 0.98 * q_surf0

  ! check for negative atmospheric humidities
  where(avail) q_atm = q_atm_in
  if(no_neg_q) then
     where(avail .and. q_atm_in < 0.0) q_atm = 0.0
  endif

  ! generate information needed by monin_obukhov
  where (avail)
     p_ratio = (p_surf/p_atm)**kappa

     tv_atm  = t_atm  * (1.0 + d608*q_atm)     ! virtual temperature
     th_atm  = t_atm  * p_ratio                ! potential T, using p_surf as refernce
     thv_atm = tv_atm * p_ratio                ! virt. potential T, using p_surf as reference 
     thv_surf= t_surf0 * (1.0 + d608*q_surf0 ) ! surface virtual (potential) T
!     thv_surf= t_surf0                        ! surface virtual (potential) T -- just for testing tun off the q_surf

     u_dif = u_surf - u_atm                    ! velocity components relative to surface
     v_dif = v_surf - v_atm
  endwhere

  if(alt_gustiness) then
     do i = 1, size(avail)
        if (.not.avail(i)) cycle
        w_atm(i) = max(sqrt(u_dif(i)**2 + v_dif(i)**2), gust_const)
        ! derivatives of surface wind w.r.t. atm. wind components
        if(w_atm(i) > gust_const) then
           dw_atmdu(i) = u_dif(i)/w_atm(i)
           dw_atmdv(i) = v_dif(i)/w_atm(i)
        else
           dw_atmdu(i) = 0.0
           dw_atmdv(i) = 0.0
        endif
     enddo
  else
     if (gust_min > 0.0) then 
       where(avail)
         w_gust = max(gust,gust_min) ! minimum gustiness
       end where
     else
       where(avail)
         w_gust = gust
       end where
     endif  
           
     where(avail) 
        w_atm = sqrt(u_dif*u_dif + v_dif*v_dif + w_gust*w_gust)
        ! derivatives of surface wind w.r.t. atm. wind components
        dw_atmdu = u_dif/w_atm
        dw_atmdv = v_dif/w_atm
     endwhere
  endif

  !  monin-obukhov similarity theory 
  call mpp_clock_begin(id_clock_mo_drag)
  call mo_drag (thv_atm, thv_surf, z_atm,                  &
       rough_mom, rough_heat, rough_moist, w_atm,          &
       cd_m, cd_t, cd_q, u_star, b_star, avail             )
  call mpp_clock_end(id_clock_mo_drag)

  ! override with ocean fluxes from NCAR calculation
  if (ncar_ocean_flux .or. ncar_ocean_flux_orig) then
    call  ncar_ocean_fluxes (w_atm, th_atm, t_surf0, q_atm, q_surf0, z_atm, &
                             seawater, cd_m, cd_t, cd_q, u_star, b_star     )
  end if

  where (avail)
     ! scale momentum drag coefficient on orographic roughness
     cd_m = cd_m*(log(z_atm/rough_mom+1)/log(z_atm/rough_scale+1))**2
     ! surface layer drag coefficients
     drag_t = cd_t * w_atm
     drag_q = cd_q * w_atm
     drag_m = cd_m * w_atm

     ! density
     rho = p_atm / (rdgas * tv_atm)  

     ! sensible heat flux
     rho_drag = cp_air * drag_t * rho
     flux_t = rho_drag * (t_surf0 - th_atm)  ! flux of sensible heat (W/m**2)
     dhdt_surf =  rho_drag                   ! d(sensible heat flux)/d(surface temperature)
     dhdt_atm  = -rho_drag*p_ratio           ! d(sensible heat flux)/d(atmos temperature)

     ! evaporation
     rho_drag  =  drag_q * rho
     flux_q    =  rho_drag * (q_surf0 - q_atm) ! flux of water vapor  (Kg/(m**2 s))

     where (land)
        dedq_surf = rho_drag
        dedt_surf = 0
     elsewhere
        dedq_surf = 0
        dedt_surf =  rho_drag * (q_sat1 - q_sat) *del_temp_inv
     endwhere
        
     dedq_atm  = -rho_drag   ! d(latent heat flux)/d(atmospheric mixing ratio)

     q_star = flux_q / (u_star * rho)             ! moisture scale
     ! ask Chris and Steve K if we still want to keep this for diagnostics
     q_surf = q_atm + flux_q / (rho*cd_q*w_atm)   ! surface specific humidity

     ! upward long wave radiation
     flux_r    =   stefan*t_surf**4               ! (W/m**2)
     drdt_surf = 4*stefan*t_surf**3               ! d(upward longwave)/d(surface temperature)

     ! stresses
     rho_drag   = drag_m * rho
     flux_u     = rho_drag * u_dif   ! zonal      component of stress (Nt/m**2)
     flux_v     = rho_drag * v_dif   ! meridional component of stress 

  elsewhere
     ! zero-out un-available data in output only fields
     flux_t     = 0.0
     flux_q     = 0.0
     flux_r     = 0.0
     flux_u     = 0.0
     flux_v     = 0.0
     dhdt_surf  = 0.0
     dedt_surf  = 0.0
     dedq_surf  = 0.0
     drdt_surf  = 0.0
     dhdt_atm   = 0.0
     dedq_atm   = 0.0
     u_star     = 0.0
     b_star     = 0.0
     q_star     = 0.0
     q_surf     = 0.0
     w_atm      = 0.0
  endwhere

  ! calculate d(stress component)/d(atmos wind component)
  dtaudu_atm = 0.0
  dtaudv_atm = 0.0
  if (old_dtaudv) then
     where(avail)
        dtaudv_atm = -rho_drag
        dtaudu_atm = -rho_drag
     endwhere
  else
     where(avail)
        dtaudu_atm = -cd_m*rho*(dw_atmdu*u_dif + w_atm)
        dtaudv_atm = -cd_m*rho*(dw_atmdv*v_dif + w_atm)
     endwhere
  endif

end subroutine surface_flux_1d
! </SUBROUTINE>

!#######################################################################

subroutine surface_flux_0d (                                                 &
     t_atm_0,     q_atm_0,      u_atm_0,     v_atm_0,   p_atm_0, z_atm_0,    &
     p_surf_0,    t_surf_0,     t_ca_0,      q_surf_0,                       &
     u_surf_0,    v_surf_0,                                                  &
     rough_mom_0, rough_heat_0, rough_moist_0, rough_scale_0, gust_0,        &
     flux_t_0,    flux_q_0,     flux_r_0,    flux_u_0,  flux_v_0,            &
     cd_m_0,      cd_t_0,       cd_q_0,                                      &
     w_atm_0,     u_star_0,     b_star_0,     q_star_0,                      &
     dhdt_surf_0, dedt_surf_0,  dedq_surf_0,  drdt_surf_0,                   &
     dhdt_atm_0,  dedq_atm_0,   dtaudu_atm_0, dtaudv_atm_0,                  &
     dt,          land_0,       seawater_0,  avail_0  )

  ! ---- arguments -----------------------------------------------------------
  logical, intent(in) :: land_0,  seawater_0, avail_0
  real, intent(in) ::                                                  &
       t_atm_0,     q_atm_0,      u_atm_0,     v_atm_0,                &
       p_atm_0,     z_atm_0,      t_ca_0,                              &
       p_surf_0,    t_surf_0,     u_surf_0,    v_surf_0,               &
       rough_mom_0, rough_heat_0, rough_moist_0, rough_scale_0, gust_0
  real, intent(out) ::                                                 &
       flux_t_0,    flux_q_0,     flux_r_0,    flux_u_0,  flux_v_0,    &
       dhdt_surf_0, dedt_surf_0,  dedq_surf_0, drdt_surf_0,            &
       dhdt_atm_0,  dedq_atm_0,   dtaudu_atm_0,dtaudv_atm_0,           &
       w_atm_0,     u_star_0,     b_star_0,    q_star_0,               &
       cd_m_0,      cd_t_0,       cd_q_0
  real, intent(inout) :: q_surf_0
  real, intent(in)    :: dt

  ! ---- local vars ----------------------------------------------------------
  logical, dimension(1) :: land,  seawater, avail
  real, dimension(1) :: &
       t_atm,     q_atm,      u_atm,     v_atm,              &
       p_atm,     z_atm,      t_ca,                          &
       p_surf,    t_surf,     u_surf,    v_surf,             &
       rough_mom, rough_heat, rough_moist,  rough_scale, gust
  real, dimension(1) :: &
       flux_t,    flux_q,     flux_r,    flux_u,  flux_v,    &
       dhdt_surf, dedt_surf,  dedq_surf, drdt_surf,          &
       dhdt_atm,  dedq_atm,   dtaudu_atm,dtaudv_atm,         &
       w_atm,     u_star,     b_star,    q_star,             &
       cd_m,      cd_t,       cd_q
  real, dimension(1) :: q_surf


  avail = .true.

  t_atm(1)       = t_atm_0
  q_atm(1)       = q_atm_0
  u_atm(1)       = u_atm_0
  v_atm(1)       = v_atm_0
  p_atm(1)       = p_atm_0
  z_atm(1)       = z_atm_0
  t_ca(1)        = t_ca_0
  p_surf(1)      = p_surf_0
  t_surf(1)      = t_surf_0
  u_surf(1)      = u_surf_0
  v_surf(1)      = v_surf_0
  rough_mom(1)   = rough_mom_0
  rough_heat(1)  = rough_heat_0
  rough_moist(1) = rough_moist_0
  rough_scale(1) = rough_scale_0
  gust(1)        = gust_0
  q_surf(1)      = q_surf_0
  land(1)        = land_0
  seawater(1)    = seawater_0
  avail(1)       = avail_0

  call surface_flux_1d (                                                 &
       t_atm,     q_atm,      u_atm,     v_atm,     p_atm,     z_atm,    &
       p_surf,    t_surf,     t_ca,      q_surf,                         &
       u_surf,    v_surf,                                                &
       rough_mom, rough_heat, rough_moist, rough_scale, gust,            &
       flux_t, flux_q, flux_r, flux_u, flux_v,                           &
       cd_m,      cd_t,       cd_q,                                      &
       w_atm,     u_star,     b_star,     q_star,                        &
       dhdt_surf, dedt_surf,  dedq_surf,  drdt_surf,                     &
       dhdt_atm,  dedq_atm,   dtaudu_atm, dtaudv_atm,                    &
       dt,        land,      seawater, avail  )

  flux_t_0     = flux_t(1)
  flux_q_0     = flux_q(1)
  flux_r_0     = flux_r(1)
  flux_u_0     = flux_u(1)
  flux_v_0     = flux_v(1)
  dhdt_surf_0  = dhdt_surf(1)
  dedt_surf_0  = dedt_surf(1)
  dedq_surf_0  = dedq_surf(1)
  drdt_surf_0  = drdt_surf(1)
  dhdt_atm_0   = dhdt_atm(1)
  dedq_atm_0   = dedq_atm(1)
  dtaudu_atm_0 = dtaudu_atm(1)
  dtaudv_atm_0 = dtaudv_atm(1)
  w_atm_0      = w_atm(1)
  u_star_0     = u_star(1)
  b_star_0     = b_star(1)
  q_star_0     = q_star(1)
  q_surf_0     = q_surf(1)
  cd_m_0       = cd_m(1)
  cd_t_0       = cd_t(1)
  cd_q_0       = cd_q(1)

end subroutine surface_flux_0d

subroutine surface_flux_2d (                                           &
     t_atm,     q_atm_in,   u_atm,     v_atm,     p_atm,     z_atm,    &
     p_surf,    t_surf,     t_ca,      q_surf,                         &
     u_surf,    v_surf,                                                &
     rough_mom, rough_heat, rough_moist, rough_scale, gust,            &
     flux_t,    flux_q,     flux_r,    flux_u,    flux_v,              &
     cd_m,      cd_t,       cd_q,                                      &
     w_atm,     u_star,     b_star,     q_star,                        &
     dhdt_surf, dedt_surf,  dedq_surf,  drdt_surf,                     &
     dhdt_atm,  dedq_atm,   dtaudu_atm, dtaudv_atm,                    &
     dt,        land,       seawater,  avail  )

  ! ---- arguments -----------------------------------------------------------
  logical, intent(in), dimension(:,:) :: land,  seawater, avail
  real, intent(in),  dimension(:,:) :: &
       t_atm,     q_atm_in,   u_atm,     v_atm,              &
       p_atm,     z_atm,      t_ca,                          &
       p_surf,    t_surf,     u_surf,    v_surf,             &
       rough_mom, rough_heat, rough_moist, rough_scale, gust
  real, intent(out), dimension(:,:) :: &
       flux_t,    flux_q,     flux_r,    flux_u,  flux_v,    &
       dhdt_surf, dedt_surf,  dedq_surf, drdt_surf,          &
       dhdt_atm,  dedq_atm,   dtaudu_atm,dtaudv_atm,         &
       w_atm,     u_star,     b_star,    q_star,             &
       cd_m,      cd_t,       cd_q
  real, intent(inout), dimension(:,:) :: q_surf
  real, intent(in) :: dt

  ! ---- local vars -----------------------------------------------------------
  integer :: j

  do j = 1, size(t_atm,2)
     call surface_flux_1d (                                           &
          t_atm(:,j),     q_atm_in(:,j),   u_atm(:,j),     v_atm(:,j),     p_atm(:,j),     z_atm(:,j),    &
          p_surf(:,j),    t_surf(:,j),     t_ca(:,j),      q_surf(:,j),                                   &
          u_surf(:,j),    v_surf(:,j),                                                                    &
          rough_mom(:,j), rough_heat(:,j), rough_moist(:,j), rough_scale(:,j), gust(:,j),                 &
          flux_t(:,j),    flux_q(:,j),     flux_r(:,j),    flux_u(:,j),    flux_v(:,j),                   &
          cd_m(:,j),      cd_t(:,j),       cd_q(:,j),                                                     &
          w_atm(:,j),     u_star(:,j),     b_star(:,j),     q_star(:,j),                                  &
          dhdt_surf(:,j), dedt_surf(:,j),  dedq_surf(:,j),  drdt_surf(:,j),                               &
          dhdt_atm(:,j),  dedq_atm(:,j),   dtaudu_atm(:,j), dtaudv_atm(:,j),                              &
          dt,             land(:,j),       seawater(:,j),  avail(:,j)  )
  end do
end subroutine surface_flux_2d


! ============================================================================
!  Initialization of the surface flux module--reads the nml.     
!
subroutine surface_flux_init

! ---- local vars ----------------------------------------------------------
  integer :: unit, ierr, io

  ! read namelist
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, surface_flux_nml, iostat=io)
      ierr = check_nml_error(io,'surface_flux_nml')
#else
  if ( file_exist('input.nml')) then
     unit = open_namelist_file ()
     ierr=1; 
     do while (ierr /= 0)
        read  (unit, nml=surface_flux_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'surface_flux_nml')
     enddo
10   call close_file (unit)
  endif
#endif

  ! write version number
  call write_version_number(version, tagname)

  unit = stdlog()
  if ( mpp_pe() == mpp_root_pe() )  write (unit, nml=surface_flux_nml)
  
  if(.not. use_virtual_temp) d608 = 0.0
  
  do_init = .false.

  id_clock_escomp = mpp_clock_id('SFC boundary layer sur_flux_escomp', grain=CLOCK_LOOP)
  id_clock_mo_drag = mpp_clock_id('SFC boundary layer sur_flux_mo_drag', grain=CLOCK_LOOP)  

end subroutine surface_flux_init



!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! Over-ocean fluxes following Large and Yeager (used in NCAR models)           !
! Original  code: GFDL.Climate.Model.Info
! Update Jul2007: GFDL.Climate.Model.Info (ch and ce exchange coeff bugfix)  
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
!
subroutine ncar_ocean_fluxes (u_del, t, ts, q, qs, z, avail, &
                              cd, ch, ce, ustar, bstar       )
real   , intent(in)   , dimension(:) :: u_del, t, ts, q, qs, z
logical, intent(in)   , dimension(:) :: avail
real   , intent(inout), dimension(:) :: cd, ch, ce, ustar, bstar

  real :: cd_n10, ce_n10, ch_n10, cd_n10_rt    ! neutral 10m drag coefficients
  real :: cd_rt                                ! full drag coefficients @ z
  real :: zeta, x2, x, psi_m, psi_h            ! stability parameters
  real :: u, u10, tv, tstar, qstar, z0, xx, stab
  integer, parameter :: n_itts = 2
  integer               i, j

  if(ncar_ocean_flux_orig) then

      do i=1,size(u_del(:))
         if (avail(i)) then
             tv = t(i)*(1+0.608*q(i));
             u = max(u_del(i), 0.5);                                 ! 0.5 m/s floor on wind (undocumented NCAR)
             u10 = u;                                                ! first guess 10m wind

             cd_n10 = (2.7/u10+0.142+0.0764*u10)/1e3;                ! L-Y eqn. 6a
             cd_n10_rt = sqrt(cd_n10);
             ce_n10 =                     34.6 *cd_n10_rt/1e3;       ! L-Y eqn. 6b
             stab = 0.5 + sign(0.5,t(i)-ts(i))
             ch_n10 = (18.0*stab+32.7*(1-stab))*cd_n10_rt/1e3;       ! L-Y eqn. 6c

             cd(i) = cd_n10;                                         ! first guess for exchange coeff's at z
             ch(i) = ch_n10;
             ce(i) = ce_n10;
             do j=1,n_itts                                           ! Monin-Obukhov iteration
                cd_rt = sqrt(cd(i));
                ustar(i) = cd_rt*u;                                   ! L-Y eqn. 7a
                tstar    = (ch(i)/cd_rt)*(t(i)-ts(i));                ! L-Y eqn. 7b
                qstar    = (ce(i)/cd_rt)*(q(i)-qs(i));                ! L-Y eqn. 7c
                bstar(i) = grav*(tstar/tv+qstar/(q(i)+1/0.608));
                zeta     = vonkarm*bstar(i)*z(i)/(ustar(i)*ustar(i)); ! L-Y eqn. 8a
                zeta     = sign( min(abs(zeta),10.0), zeta );         ! undocumented NCAR
                x2 = sqrt(abs(1-16*zeta));                            ! L-Y eqn. 8b
                x2 = max(x2, 1.0);                                    ! undocumented NCAR
                x = sqrt(x2);

                if (zeta > 0) then
                    psi_m = -5*zeta;                                    ! L-Y eqn. 8c
                    psi_h = -5*zeta;                                    ! L-Y eqn. 8c
                else
                    psi_m = log((1+2*x+x2)*(1+x2)/8)-2*(atan(x)-atan(1.0)); ! L-Y eqn. 8d
                    psi_h = 2*log((1+x2)/2);                                ! L-Y eqn. 8e
                end if

                u10 = u/(1+cd_n10_rt*(log(z(i)/10)-psi_m)/vonkarm);       ! L-Y eqn. 9
                cd_n10 = (2.7/u10+0.142+0.0764*u10)/1e3;                  ! L-Y eqn. 6a again
                cd_n10_rt = sqrt(cd_n10);
                ce_n10 = 34.6*cd_n10_rt/1e3;                              ! L-Y eqn. 6b again
                stab = 0.5 + sign(0.5,zeta)
                ch_n10 = (18.0*stab+32.7*(1-stab))*cd_n10_rt/1e3;         ! L-Y eqn. 6c again
                z0 = 10*exp(-vonkarm/cd_n10_rt);                          ! diagnostic

                xx = (log(z(i)/10)-psi_m)/vonkarm;
                cd(i) = cd_n10/(1+cd_n10_rt*xx)**2;                       ! L-Y 10a
                xx = (log(z(i)/10)-psi_h)/vonkarm;
                ch(i) = ch_n10/(1+ch_n10*xx/cd_n10_rt)**2;                !     10b (this code is wrong)  
                ce(i) = ce_n10/(1+ce_n10*xx/cd_n10_rt)**2;                !     10c (this code is wrong)
             end do
         end if
      end do

  else

      do i=1,size(u_del(:))
         if (avail(i)) then
             tv = t(i)*(1+0.608*q(i));
             u = max(u_del(i), 0.5);                                 ! 0.5 m/s floor on wind (undocumented NCAR)
             u10 = u;                                                ! first guess 10m wind

             cd_n10 = (2.7/u10+0.142+0.0764*u10)/1e3;                ! L-Y eqn. 6a
             cd_n10_rt = sqrt(cd_n10);
             ce_n10 =                     34.6 *cd_n10_rt/1e3;       ! L-Y eqn. 6b
             stab = 0.5 + sign(0.5,t(i)-ts(i))
             ch_n10 = (18.0*stab+32.7*(1-stab))*cd_n10_rt/1e3;       ! L-Y eqn. 6c

             cd(i) = cd_n10;                                         ! first guess for exchange coeff's at z
             ch(i) = ch_n10;
             ce(i) = ce_n10;
             do j=1,n_itts                                           ! Monin-Obukhov iteration
                cd_rt = sqrt(cd(i));
                ustar(i) = cd_rt*u;                                   ! L-Y eqn. 7a
                tstar    = (ch(i)/cd_rt)*(t(i)-ts(i));                ! L-Y eqn. 7b
                qstar    = (ce(i)/cd_rt)*(q(i)-qs(i));                ! L-Y eqn. 7c
                bstar(i) = grav*(tstar/tv+qstar/(q(i)+1/0.608));
                zeta     = vonkarm*bstar(i)*z(i)/(ustar(i)*ustar(i)); ! L-Y eqn. 8a
                zeta     = sign( min(abs(zeta),10.0), zeta );         ! undocumented NCAR
                x2 = sqrt(abs(1-16*zeta));                            ! L-Y eqn. 8b
                x2 = max(x2, 1.0);                                    ! undocumented NCAR
                x = sqrt(x2);

                if (zeta > 0) then
                    psi_m = -5*zeta;                                    ! L-Y eqn. 8c
                    psi_h = -5*zeta;                                    ! L-Y eqn. 8c
                else
                    psi_m = log((1+2*x+x2)*(1+x2)/8)-2*(atan(x)-atan(1.0)); ! L-Y eqn. 8d
                    psi_h = 2*log((1+x2)/2);                                ! L-Y eqn. 8e
                end if

                u10 = u/(1+cd_n10_rt*(log(z(i)/10)-psi_m)/vonkarm);       ! L-Y eqn. 9
                cd_n10 = (2.7/u10+0.142+0.0764*u10)/1e3;                  ! L-Y eqn. 6a again
                cd_n10_rt = sqrt(cd_n10);
                ce_n10 = 34.6*cd_n10_rt/1e3;                              ! L-Y eqn. 6b again
                stab = 0.5 + sign(0.5,zeta)
                ch_n10 = (18.0*stab+32.7*(1-stab))*cd_n10_rt/1e3;         ! L-Y eqn. 6c again
                z0 = 10*exp(-vonkarm/cd_n10_rt);                          ! diagnostic

                xx = (log(z(i)/10)-psi_m)/vonkarm;
                cd(i) = cd_n10/(1+cd_n10_rt*xx)**2;                       ! L-Y 10a
                xx = (log(z(i)/10)-psi_h)/vonkarm;
                ch(i) = ch_n10/(1+ch_n10*xx/cd_n10_rt)*sqrt(cd(i)/cd_n10) ! 10b (corrected code)
                ce(i) = ce_n10/(1+ce_n10*xx/cd_n10_rt)*sqrt(cd(i)/cd_n10) ! 10c (corrected code)
             end do
         end if
      end do

  endif

end subroutine ncar_ocean_fluxes


end module surface_flux_mod

                   module bgrid_advection_mod

!-----------------------------------------------------------------------
!
!            performs vertical and horizontal advection
!              and negative tracer borrowing/filling
!
!-----------------------------------------------------------------------
!--------------------------- modules -----------------------------------
!-----------------------------------------------------------------------
use bgrid_horiz_mod       , only: horiz_grid_type
use bgrid_vert_mod        , only: vert_grid_type, compute_pres_depth
use bgrid_masks_mod       , only: grid_mask_type
use bgrid_prog_var_mod    , only: prog_var_type
use bgrid_polar_filter_mod, only: pfilt_control_type, polar_filter, &
                                  polar_filter_wind, TGRID
use bgrid_halo_mod        , only: update_halo, vel_flux_boundary,   &
                                  EAST, WEST, SOUTH, NORTH, NOPOLE, &
                                  TEMP, UWND, VWND, WIND, POLEONLY
use bgrid_change_grid_mod , only: change_grid, EQUAL, AREA, &
                                  UFLX_GRID, VFLX_GRID, TEMP_GRID, WIND_GRID
use vert_advection_mod    , only: vert_advection, vert_advection_end, &
                                  SECOND_CENTERED, FOURTH_CENTERED, &
                                  SECOND_CENTERED_WTS, FOURTH_CENTERED_WTS, &
                                  FINITE_VOLUME_LINEAR, FINITE_VOLUME_PARABOLIC, &
                                  FLUX_FORM, WEIGHTED_TENDENCY
!!!use horiz_advection_mod   , only: horiz_advection, &
!!!                                  FINITE_VOLUME_LINEAR_HORIZ=>FINITE_VOLUME_LINEAR, &
!!!                                  FINITE_VOLUME_PARABOLIC_HORIZ=>FINITE_VOLUME_PARABOLIC

use fms_mod, only: error_mesg, FATAL, write_version_number,      &
                   file_exist, open_namelist_file,               &
                   check_nml_error, close_file,                  &
                   mpp_pe, mpp_root_pe, stdlog, uppercase,       &
                   mpp_clock_id, mpp_clock_begin, mpp_clock_end, &
                   MPP_CLOCK_SYNC, CLOCK_MODULE, CLOCK_ROUTINE, CLOCK_LOOP
use mpp_mod, only: input_nml_file, mpp_max
use  field_manager_mod, only: MODEL_ATMOS, parse
use tracer_manager_mod, only: query_method, get_tracer_names, get_number_tracers
!-----------------------------------------------------------------------

implicit none
private

 public :: advection_init, advection, advection_end

!-----------------------------------------------------------------------
!------------ namelist: bgrid_advection_nml -------------

!  vert_advec_scheme_wind      The vertical advection scheme.
!  vert_advec_scheme_temp      Possible values are NONE, SECOND_CENTERED, FOURTH_CENTERED,
!  vert_advec_scheme_tracer    FINITE_VOLUME_LINEAR, or FINITE_VOLUME_PARABOLIC.
!                              Using finite volume schemes for momentum has not been
!                              tested and may produce poor results.

   character(len=24) ::  vert_advec_scheme_wind   = 'SECOND_CENTERED'
   character(len=24) ::  vert_advec_scheme_temp   = 'SECOND_CENTERED'
   character(len=24) ::  vert_advec_scheme_tracer = 'SECOND_CENTERED'

!  horiz_advec_scheme_wind     The horizontal advection scheme.
!  horiz_advec_scheme_temp     Possible values are NONE, SECOND_CENTERED, FOURTH_CENTERED.
!  horiz_advec_scheme_tracer

   character(len=24) :: horiz_advec_scheme_wind   = 'SECOND_CENTERED'
   character(len=24) :: horiz_advec_scheme_temp   = 'SECOND_CENTERED'
   character(len=24) :: horiz_advec_scheme_tracer = 'SECOND_CENTERED'

!  advec_weight_wind     Weights used for modified Euler-backward time differencing
!  advec_weight_temp     (i.e., when the scheme is SECOND_CENTERED or FOURTH_CENTERED).
!  advec_weight_tracer        0.0 = full Euler-forward (not recommended)
!                             1.0 = full Euler-backward

   real :: advec_weight_wind   = 0.7
   real :: advec_weight_temp   = 0.7
   real :: advec_weight_tracer = 0.7

!  num_fill_pass      The number of successive repetitions of the tracer borrowing scheme.
!                     This value applies to both the horizontal and vertical schemes.

   integer :: num_fill_pass = 1

!  temporary undocumented developer flags

logical :: compute_vert_wind_flux = .false.
character(len=16) ::  vert_vel_flux =  'area_weight'
character(len=16) :: horiz_vel_flux = 'equal_weight'

namelist /bgrid_advection_nml/ horiz_advec_scheme_wind,   vert_advec_scheme_wind,   &
                               horiz_advec_scheme_temp,   vert_advec_scheme_temp,   &
                               horiz_advec_scheme_tracer, vert_advec_scheme_tracer, &
                               advec_weight_wind, advec_weight_temp, advec_weight_tracer, &
                               num_fill_pass    ,&
                               compute_vert_wind_flux, vert_vel_flux, horiz_vel_flux

!-----------------------------------------------------------------------
!----- private data -----

! derived-type containing tracer filling parameters
 type trfill_control_type
    integer, pointer :: fill_scheme(:) =>NULL(), &
                        npass_horiz(:) =>NULL(), &
                        npass_vert(:)  =>NULL()
 end type trfill_control_type

! derived-type containing advection parameters
 type advec_control_type
    type(trfill_control_type) :: Fill
    integer, pointer  :: scheme(:,:) =>NULL()
    real   , pointer  :: weight(:) =>NULL()
    logical  ::  do_mask4_tmp, do_mask4_vel, &
                 do_finite_volume_tmp, do_finite_volume_trs
 end type advec_control_type

 integer, parameter :: NONE = 7000, &  ! may apply to advection or filling
            ! filling schemes
              EQUAL_BORROW  = 8005, & 
              BOTTOM_BORROW = 8006, &  ! not implemented
              GLOBAL_BORROW = 8007     ! not implemented

! advection control parameters
! set via values in namelist or field table
 type(advec_control_type),save :: Control

 real, parameter :: c4  = -1./6.       ! weights for 4th order centered schemes
 real, parameter :: c2  = 1. - 2.*c4

 logical :: do_log = .true.
 logical :: stability_check = .false.  ! perform stability check for horizontal
                                       ! finite volume (Lin-Rood) schemes

!  performance timing info
 integer :: id_tmp, id_trs, id_vel, id_fill
 logical :: do_clock_init = .true. 

 character(len=128) :: version='$Id: bgrid_advection.F90,v 19.0 2012/01/06 19:52:53 fms Exp $'
 character(len=128) :: tagname='$Name: tikal $'

!-----------------------------------------------------------------------

contains

!#######################################################################

subroutine advection ( Pfilt, Hgrid, Vgrid, Masks,   &
                       pfilt_opt, dt, dpde_old, dpde,         &
                       few, fns, etadot, u, v, t, Var, Var_dt )

type(pfilt_control_type), intent(in) :: Pfilt
type(horiz_grid_type), intent(inout) :: Hgrid
type (vert_grid_type), intent(in)    :: Vgrid
type (grid_mask_type), intent(in)    :: Masks
              integer, intent(in)    :: pfilt_opt
                 real, intent(in)    :: dt
real, intent(in), dimension(Hgrid%ilb:,Hgrid%jlb:,:) ::  &
                                            dpde_old, dpde, u, v, t
real, intent(inout), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: &
                                            few, fns, etadot
type (prog_var_type), intent(in)    :: Var
type (prog_var_type), intent(inout) :: Var_dt

!-----------------------------------------------------------------------
!
!  Pfilt    = polar filter constants
!  Hgrid    = horizontal grid constants
!  Vgrid    = vertical grid constants
!  Masks    = grid masking constants
!  pf_opt   = polar filter option flag
!  dt       = adjustment time step
!  dpde_old = pressure thickness of model layers at the end of the
!              last advective time step
!  dpde     = current pressure thickness of model layers
!  few, fns = zonal, meridional mass fluxes (Pa-m2/s)
!              (a summation since the last call to advection)
!  etadot   = vertical mass flux (Pa/s) (summation since the last call to advection)
!  u, v, t  = prognostic variables at the end of the last advective time
!              step, note that tracers have not been updated since the last
!              advective time step, therefore, r = Var%r + dt*Var_dt%r
!  Var      = prognostic variables at the end of the last dynamics time
!              step, current values would be, uc = Var%u + dt*Var_dt%u
!  Var_dt   = prognostic variable tendencies, accumulated since the
!              variable were updated in Var
!
!-----------------------------------------------------------------------
  real, dimension(Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub,  &
                  Vgrid%nlev) :: dpdt, dpde_xy, r, uc, vc
  real, dimension(Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub,  &
                  Vgrid%nlev,2) :: mask4
  integer :: i, j, k, n, is, ie, js, je
!-----------------------------------------------------------------------

!  ---- update halos for fluxes ----

   call update_halo (Hgrid, TEMP, few)
   call update_halo (Hgrid, VWND, fns)

!  ---- compute pressure tendency in each layer ----

   dpdt = (dpde - dpde_old) / dt

! ---- stability diagnostic (CFL for horizontal finite volume schemes) ----
   if (stability_check) call stability_diag ( Hgrid, dt, few, dpde_old, dpde )

!-----------------------------------------------------------------------
!------------------ advection of mass fields ---------------------------
!-----------------------------------------------------------------------

!------ initialize fourth-order mask ----

   if (Control%do_mask4_tmp) &
         call mask4_init (Hgrid, 1, Masks%sigma, Masks%Tmp%mask, mask4)

 ! compute wind components for horizontal finite-volume advection schemes
   if (Control%do_finite_volume_tmp .or. Control%do_finite_volume_trs) then
        call compute_advecting_wind (Hgrid, dpde_old, dpde, few, fns, uc, vc)
   else
        uc = 0.
        vc = 0.
   endif

!------ temperature advection ------

   call mpp_clock_begin (id_tmp)
   if (Masks%sigma) then
       call advect_mass (Hgrid, Pfilt, Control % scheme(:,0), &
                         Control % weight(0), pfilt_opt,      &
                         dt, dpdt, dpde, few, fns, etadot,    &
                         uc, vc, Var%t, t, Var_dt%t)
   else
       call advect_mass (Hgrid, Pfilt, Control % scheme(:,0), &
                         Control % weight(0), pfilt_opt,      &
                         dt, dpdt, dpde, few, fns, etadot,    &
                         uc, vc, Var%t, t, Var_dt%t,          &
                         mask=Masks%Tmp%mask, mask4=mask4)
   endif
   call mpp_clock_end   (id_tmp)

!------ tracer advection -----------
!  (need to pass all tracers to update pressure tendency part)

   call mpp_clock_begin (id_trs)
   do n = 1, Var_dt%ntrace

      r = Var%r(:,:,:,n) + dt*Var_dt%r(:,:,:,n)

      if (Masks%sigma) then
          call advect_mass (Hgrid, Pfilt, Control%scheme(:,n),   &
                            Control % weight(n),                 &
                            pfilt_opt, dt, dpdt, dpde,           &
                            few, fns, etadot, uc, vc,            &
                            Var%r(:,:,:,n), r, Var_dt%r(:,:,:,n) )
      else
          call advect_mass (Hgrid, Pfilt, Control%scheme(:,n),   &
                            Control % weight(n),                 &
                            pfilt_opt, dt, dpdt, dpde,           &
                            few, fns, etadot, uc, vc,            &
                            Var%r(:,:,:,n), r, Var_dt%r(:,:,:,n),&
                            mask=Masks%Tmp%mask, mask4=mask4     )
      endif

   enddo
   call mpp_clock_end   (id_trs)

!------ tracer hole filling -------
!  (remove negative tracer values with vert/horiz borrowing)

     call mpp_clock_begin (id_fill)
     call vert_borrow ( dt, dpde, Var%r(:,:,:,1:Var_dt%ntrace), &
                               Var_dt%r(:,:,:,1:Var_dt%ntrace), &
                                  iters = Control % Fill % npass_vert  )

     if (Masks%sigma) then
         call horiz_borrow ( Hgrid, dt, dpde,                 &
                                Var%r(:,:,:,1:Var_dt%ntrace), &
                             Var_dt%r(:,:,:,1:Var_dt%ntrace), &
                               iters = Control % Fill % npass_horiz  )
     else
         call horiz_borrow ( Hgrid, dt, dpde,                 &
                                Var%r(:,:,:,1:Var_dt%ntrace), &
                             Var_dt%r(:,:,:,1:Var_dt%ntrace), &
                                mask = Masks%Tmp%mask,        &
                               iters = Control % Fill % npass_horiz  )
     endif
     call mpp_clock_end   (id_fill)

!-----------------------------------------------------------------------
!------------------ advection of momentum fields -----------------------
!-----------------------------------------------------------------------

   call mpp_clock_begin (id_vel)

   is = Hgrid % Vel % is;  ie = Hgrid % Vel % ie
   js = Hgrid % Vel % js;  je = Hgrid % Vel % je

  !--- mass fluxes between velocity points ---

   if (trim(horiz_vel_flux(1:5)) == 'equal') then
      call change_grid (Hgrid, UFLX_GRID, VFLX_GRID, few, few, weight=EQUAL)
      call change_grid (Hgrid, VFLX_GRID, UFLX_GRID, fns, fns, weight=EQUAL)
   else
      call change_grid (Hgrid, UFLX_GRID, VFLX_GRID, few, few, weight=AREA)
      call change_grid (Hgrid, VFLX_GRID, UFLX_GRID, fns, fns, weight=AREA)
   endif

 ! compute vertical flux for momentum from horizonal momentum fluxes
   if (compute_vert_wind_flux) then
       call compute_etadot_vel (Hgrid, Vgrid, Masks, few, fns, etadot )
   endif

 ! no flux across pole
   call vel_flux_boundary (Hgrid, fns)

  !--- interpolate mass fields to momentum grid ---
   if (.not.compute_vert_wind_flux) then
       if (trim(vert_vel_flux(1:4)) == 'area') then
          call change_grid (Hgrid, TEMP_GRID, WIND_GRID, etadot, etadot, weight=AREA)
       else
          call change_grid (Hgrid, TEMP_GRID, WIND_GRID, etadot, etadot, weight=EQUAL)
       endif
   endif
   ! always area-weighted (the default)
   call change_grid (Hgrid, TEMP_GRID, WIND_GRID, dpde, dpde_xy)
   call change_grid (Hgrid, TEMP_GRID, WIND_GRID, dpdt,    dpdt)


 ! advection of momentum
 ! determine whether step-mountain mask are needed
   if (Control%do_mask4_vel .and. .not.Masks%sigma) then
       call mask4_init (Hgrid, 2, Masks%sigma, Masks%Vel%mask, mask4)

       call advect_vel (Hgrid, Pfilt, Control % scheme(:,-1), &
                        Control % weight(-1),                 &
                        pfilt_opt, dt, dpdt, dpde_xy,         &
                        few, fns, etadot, Var%u, Var%v, u, v, &
                        Var_dt%u, Var_dt%v,                   &
                        mask=Masks%Vel%mask, mask4=mask4)
   else
       ! sigma case
       call advect_vel (Hgrid, Pfilt, Control % scheme(:,-1), &
                        Control % weight(-1),                 &
                        pfilt_opt, dt, dpdt, dpde_xy,         &
                        few, fns, etadot, Var%u, Var%v, u, v, &
                        Var_dt%u, Var_dt%v)
   endif

   call mpp_clock_end (id_vel)
!-----------------------------------------------------------------------
!------ done with fluxes - zero-out ??? -------

   few    = 0.0
   fns    = 0.0
   etadot = 0.0

!-----------------------------------------------------------------------

end subroutine advection

!#######################################################################

subroutine advect_mass ( Hgrid, Pfilt, scheme, coeff, fopt, dt, &
                         dpdt, dpn, few, fns, fud, uc, vc,      &
                         ro, r, r_dt, mask, mask4 )

  type(horiz_grid_type),    intent(inout) :: Hgrid
  type(pfilt_control_type), intent(in) :: Pfilt
  integer,                  intent(in) :: scheme(2)
  integer,                  intent(in) :: fopt
  real, intent(in)                     :: coeff, dt
  real, intent(in),  dimension(Hgrid%ilb:,Hgrid%jlb:,:)   :: dpdt, dpn,&
                                           few, fns, fud, ro, r, uc, vc
  real, intent(inout), dimension(Hgrid%ilb:,Hgrid%jlb:,:)   :: r_dt
  real, intent(in),    dimension(Hgrid%ilb:,Hgrid%jlb:,:),   optional :: mask
  real, intent(in),    dimension(Hgrid%ilb:,Hgrid%jlb:,:,:), optional :: mask4

!-----------------------------------------------------------------------

  real, dimension(Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub,  &
                  size(r,3)) :: rst, rst_dt, rst_dt_v, rdpdt

  real    :: rcoef
  integer :: pass, npass, j, k
  integer :: vert_scheme, horiz_scheme
  integer, parameter :: FINITE_VOLUME = 1234567 !can not match other numbers?

!-----------------------------------------------------------------------

 ! set the vertical and horizontal differencing scheme
    horiz_scheme = scheme(1)
     vert_scheme = scheme(2)
 ! rename horizontal finite volume schemes to correct horizontal name
 !  if (horiz_scheme == FINITE_VOLUME_LINEAR)    horiz_scheme = FINITE_VOLUME_LINEAR_HORIZ
 !  if (horiz_scheme == FINITE_VOLUME_PARABOLIC) horiz_scheme = FINITE_VOLUME_PARABOLIC_HORIZ

!-----------------------------------------------------------------------

   rst = ro + dt * r_dt  ! use updated value
   rdpdt = r*dpdt
   rcoef = coeff

                      npass = 1
   if (rcoef > 1.e-4) npass = 2
 ! no advection, psdt correction only
   if (vert_scheme ==  NONE) then
       rst_dt_v = 0.0
       if (horiz_scheme == NONE) npass = 1
   endif
 ! both vert and horiz are using finite volume
   if ( (vert_scheme == FINITE_VOLUME_LINEAR .or.       &
         vert_scheme == FINITE_VOLUME_PARABOLIC) .and.  &
       (horiz_scheme == FINITE_VOLUME_LINEAR .or. &
        horiz_scheme == FINITE_VOLUME_PARABOLIC) ) then
      !(horiz_scheme == FINITE_VOLUME_LINEAR_HORIZ .or. &
      ! horiz_scheme == FINITE_VOLUME_PARABOLIC_HORIZ) ) then
          npass = 2
          rcoef = 1.
   endif

   do pass = 1, npass

     !---- vertical tendency ----
         ! finite volume schemes on pass 1 only
      if (vert_scheme == SECOND_CENTERED .or. vert_scheme == SECOND_CENTERED_WTS .or. &
          vert_scheme == FOURTH_CENTERED .or. vert_scheme == FOURTH_CENTERED_WTS .or. &
        ((vert_scheme == FINITE_VOLUME_LINEAR .or. &
          vert_scheme == FINITE_VOLUME_PARABOLIC) .and. pass == 1)) then
         call vert_advection ( dt, fud, dpn, rst, rst_dt_v,   &
                               mask=mask, scheme=vert_scheme, &
                               form=FLUX_FORM, flags=WEIGHTED_TENDENCY )
      endif

     !---- horizontal tendency ----

      if (horiz_scheme == SECOND_CENTERED) then
         call advect_mass_horiz_2nd (Hgrid, few, fns, rst, rst_dt)
         if ( fopt >= 1 ) call polar_filter (Pfilt, rst_dt, TGRID, mask)
         call update_halo (Hgrid, TEMP, rst_dt)

      else if (horiz_scheme == FOURTH_CENTERED) then
         call advect_mass_horiz_4th (Hgrid, few, fns, rst, rst_dt, mask4)
         if ( fopt >= 1 ) call polar_filter (Pfilt, rst_dt, TGRID, mask)
         call update_halo (Hgrid, TEMP, rst_dt)

    ! compute horizontal finite volume scheme on 2nd pass
      else if ((horiz_scheme == FINITE_VOLUME_LINEAR .or. &
                horiz_scheme == FINITE_VOLUME_PARABOLIC) .and. pass == 2) then
        ! temporary error check
         call error_mesg ('bgrid_advection_mod', &
                          'horizontal finite volume schemes &
                          &are not implemented with this release', FATAL)
        !call horiz_advection ( Hgrid%Tmp%Domain, dt, Hgrid%Tmp%dx, Hgrid%Tmp%dy, &
        !                       uc, vc, few, fns, rst, rst_dt, scheme=horiz_scheme )
       ! halos updated by finite volume scheme
       ! need update only poles (model b.c. differs)
         call update_halo (Hgrid, TEMP, rst_dt, flags=POLEONLY)

      else
            rst_dt = 0.0
      endif
      

     !---- combine vertical and horizontal tendencies ----
     !---- adjust for pressure tendency ----
        rst_dt = (rst_dt + rst_dt_v - rdpdt) / dpn
      ! apply step-mountain mask?
        if (present(mask)) rst_dt = rst_dt*mask

     !---- compute new value or return tendency ----
        if (pass < npass) then
            rst = ro + dt * (r_dt + rcoef*rst_dt)
        else
            r_dt = r_dt + rst_dt
        endif

   enddo

!-----------------------------------------------------------------------

end subroutine advect_mass

!#######################################################################

subroutine advect_vel ( Hgrid, Pfilt, scheme, coeff, fopt, dt,  &
                        dpdt, dpn, few, fns, fud,               &
                        uo, vo, u, v, u_dt, v_dt, mask, mask4  )

  type(horiz_grid_type),    intent(inout) :: Hgrid
  type(pfilt_control_type), intent(in) :: Pfilt
  integer,                  intent(in) :: scheme(2)
  integer,                  intent(in) :: fopt
  real, intent(in)                     :: coeff, dt
  real, intent(in),  dimension(Hgrid%ilb:,Hgrid%jlb:,:)   :: dpdt, dpn,&
                                           few, fns, fud, uo, vo, u, v
  real, intent(inout), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: u_dt, v_dt
  real, intent(in),    dimension(Hgrid%ilb:,Hgrid%jlb:,:),   optional :: mask
  real, intent(in),    dimension(Hgrid%ilb:,Hgrid%jlb:,:,:), optional :: mask4

!-----------------------------------------------------------------------

  real, dimension(Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub,  &
                  size(u,3)) :: ust_dt, ust_dt_v, &
                                vst_dt, vst_dt_v
! store ust & vst components together to create larger halo updates
  real, dimension(Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub,  &
                  size(u,3),2) :: uvst
  integer, parameter :: UCOMP=1, VCOMP=2

  integer :: vert_scheme, horiz_scheme
  integer :: pass, npass, i, j, k, is, ie, js, je, nlev

!-----------------------------------------------------------------------

 ! set the vertical differencing scheme
   horiz_scheme = scheme(1)
    vert_scheme = scheme(2)

!-----------------------------------------------------------------------

   is = Hgrid%Vel%is; ie = Hgrid%Vel%ie
   js = Hgrid%Vel%js; je = Hgrid%Vel%je
   nlev = size(u,3)

   uvst(:,:,:,UCOMP) = uo + dt * u_dt   ! use updated values
   uvst(:,:,:,VCOMP) = vo + dt * v_dt

 ! tendency halos are not up-to-date
 ! need to update halos
   call update_halo ( Hgrid, WIND, uvst )

                      npass = 1
   if (coeff > 1.e-4) npass = 2

   do pass = 1, npass

     !---- vertical tendency ----
         ! finite volume schemes on pass 1 only
      if (vert_scheme == SECOND_CENTERED .or. vert_scheme == SECOND_CENTERED_WTS .or. &
          vert_scheme == FOURTH_CENTERED .or. vert_scheme == FOURTH_CENTERED_WTS .or. &
        ((vert_scheme == FINITE_VOLUME_LINEAR .or. &
          vert_scheme == FINITE_VOLUME_PARABOLIC) .and. pass == 1)) then
          call vert_advection ( dt, fud, dpn, uvst(:,:,:,UCOMP), ust_dt_v, &
                                mask=mask, scheme=vert_scheme,             &
                                form=FLUX_FORM, flags=WEIGHTED_TENDENCY )
          call vert_advection ( dt, fud, dpn, uvst(:,:,:,VCOMP), vst_dt_v, &
                                mask=mask, scheme=vert_scheme,             &
                                form=FLUX_FORM, flags=WEIGHTED_TENDENCY )
      else if (vert_scheme == NONE .and. pass == 1) then
          ust_dt_v = 0.0
          vst_dt_v = 0.0
      endif

     !---- horizontal tendency ----
      if (horiz_scheme == SECOND_CENTERED) then
        call advect_vel_horiz_2nd (Hgrid, few, fns, uvst(:,:,:,UCOMP), &
                                   uvst(:,:,:,VCOMP), ust_dt, vst_dt   )
      
      else if (horiz_scheme == FOURTH_CENTERED) then
        call advect_vel_horiz_4th (Hgrid, few, fns,         &
                               uvst(:,:,:,UCOMP), uvst(:,:,:,VCOMP), &
                               ust_dt, vst_dt, mask4 )
      endif
      
     ! polar filter horizontal tendency
        if (fopt >= 2) then
           call polar_filter_wind (Pfilt, ust_dt, vst_dt, mask)
        endif

     !---- combine vertical and horizontal tendencies ----
     !---- adjust for pressure tendency ----
      do k = 1, nlev
      do j = js, je
      do i = is, ie
         ust_dt(i,j,k) = (ust_dt(i,j,k) + ust_dt_v(i,j,k) - &
                       u(i,j,k)*dpdt(i,j,k)) / dpn(i,j,k)
         vst_dt(i,j,k) = (vst_dt(i,j,k) + vst_dt_v(i,j,k) - &
                       v(i,j,k)*dpdt(i,j,k)) / dpn(i,j,k)
      enddo
      enddo
      enddo
    ! apply step-mountain mask?
      if (present(mask)) then
        do k = 1, nlev
        ust_dt(is:ie,js:je,k) = ust_dt(is:ie,js:je,k)*mask(is:ie,js:je,k)
        vst_dt(is:ie,js:je,k) = vst_dt(is:ie,js:je,k)*mask(is:ie,js:je,k)
        enddo
      endif

     !---- compute new value or return tendency ----
      if (pass < npass) then
         do k = 1, nlev
         do j = js, je
         do i = is, ie
           uvst(i,j,k,UCOMP) = uo(i,j,k) + dt * (u_dt(i,j,k) + coeff*ust_dt(i,j,k))
           uvst(i,j,k,VCOMP) = vo(i,j,k) + dt * (v_dt(i,j,k) + coeff*vst_dt(i,j,k))
         enddo
         enddo
         enddo
         call update_halo (Hgrid, WIND, uvst)
      else
         do k = 1, nlev
         do j = js, je
         do i = is, ie
           u_dt(i,j,k) = u_dt(i,j,k) + ust_dt(i,j,k)
           v_dt(i,j,k) = v_dt(i,j,k) + vst_dt(i,j,k)
         enddo
         enddo
         enddo
       ! NOTE: halos not updated for output tendencies
       !  do this in the dynamical core for efficiency
      endif
   
   enddo

!-----------------------------------------------------------------------

end subroutine advect_vel

!#######################################################################

 subroutine advect_mass_horiz_2nd (Hgrid, few, fns, r, rdt)

  type(horiz_grid_type),    intent(in) :: Hgrid
  real, intent(in),  dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: few, fns, r
  real, intent(out), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: rdt

  real, dimension(Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub) :: frew, frns
  integer :: i, j, k

! second order centered differencing on B-grid temperature grid
! constant grid spacing assumed
! minimum halo size = 1

      do k = 1, size(r,3)

       !--- horizontal fluxes ---
        do j = Hgrid%Tmp%js-1, Hgrid%Tmp%je
        do i = Hgrid%Tmp%is-1, Hgrid%Tmp%ie
          frew(i,j) = few(i,j,k) * (r(i+1,j,k) + r(i,j,k))
          frns(i,j) = fns(i,j,k) * (r(i,j+1,k) + r(i,j,k))
        enddo
        enddo

       !--- horizontal advective tendency ---
        do j = Hgrid%Tmp%js, Hgrid%Tmp%je
        do i = Hgrid%Tmp%is, Hgrid%Tmp%ie
           rdt(i,j,k) = -0.5*Hgrid%Tmp%rarea(j)*       &
                           ((frew(i  ,j)+frns(i,j  ))  &
                           -(frew(i-1,j)+frns(i,j-1)))
        enddo
        enddo

      enddo

 end subroutine advect_mass_horiz_2nd

!#######################################################################

 subroutine advect_mass_horiz_4th (Hgrid, few, fns, r, rdt, mask4)

  type(horiz_grid_type),    intent(inout) :: Hgrid
  real, intent(in),  dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: few, fns, r
  real, intent(out), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: rdt
  real, intent(in),  dimension(Hgrid%ilb:,Hgrid%jlb:,:,:), optional :: &
                                                           mask4

  real, dimension(Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub, &
                  size(r,3)) :: rew, rns, frew, frns
  real, dimension(Hgrid%ilb:Hgrid%iub) :: x2, x4
  real, dimension(Hgrid%ilb:Hgrid%iub) :: y2, y4
  integer :: i, j, k, is, ie, js, je

! fourth order centered differencing on B-grid temperature grid
! constant grid spacing assumed
! assumed halo size = 1

   is = Hgrid % Tmp % is;  ie = Hgrid % Tmp % ie
   js = Hgrid % Tmp % js;  je = Hgrid % Tmp % je

      rns(:,Hgrid%jub,:) = 0.0
      do k = 1, size(r,3)
        do j = Hgrid%jlb,Hgrid%jub
        do i = Hgrid%ilb,Hgrid%iub-1
           rew(i,j,k) = r(i+1,j,k)+r(i,j,k)
        enddo
        enddo
        do j = Hgrid%jlb,Hgrid%jub-1
        do i = Hgrid%ilb,Hgrid%iub
           rns(i,j,k) = r(i,j+1,k)+r(i,j,k)
        enddo
        enddo
      enddo
      ! assumed halosize = 1
      call update_halo (Hgrid,TEMP,rew,halos=EAST)
      call update_halo (Hgrid,UWND,rns,halos=NORTH+NOPOLE)

!     ---- horizontal fluxes ----

      if (present(mask4)) then
         frew=0.0;  frns=0.0
         do k = 1, size(r,3)
           do j = js,          je
           do i = Hgrid%ilb+1, ie
             x4(i) = mask4(i,j,k,1)
             x2(i) = 1.0 - 2.*x4(i)
             frew(i,j,k) = few(i,j,k) * ( x2(i) * rew(i,j,k) &
                          + x4(i) * (rew(i-1,j,k) + rew(i+1,j,k)) )
           enddo
           enddo
           do j = Hgrid%jlb+1, je
           do i = is,          ie
             y4(i) = mask4(i,j,k,2)
             y2(i) = 1.0 - 2.*y4(i)
             frns(i,j,k) = fns(i,j,k) * ( y2(i) * rns(i,j,k) &
                          + y4(i) * (rns(i,j-1,k) + rns(i,j+1,k)) )
           enddo
           enddo
         enddo
      else
         frew=0.0;  frns=0.0
         do k = 1, size(r,3)
           do j = js,          je
           do i = Hgrid%ilb+1, ie
             frew(i,j,k) = few(i,j,k) * ( c2 * rew(i,j,k) &
                          + c4 * (rew(i-1,j,k) + rew(i+1,j,k)) )
           enddo
           enddo
           do j = Hgrid%jlb+1, je
           do i = is,          ie
             frns(i,j,k) = fns(i,j,k) * ( c2 * rns(i,j,k) &
                          + c4 * (rns(i,j-1,k) + rns(i,j+1,k)) )
           enddo
           enddo
         enddo
      endif

      ! assumed halosize = 1
      call update_halo (Hgrid,TEMP,frew,halos=WEST)
      call update_halo (Hgrid,VWND,frns,halos=SOUTH)

!     ---- horizontal advective tendency ----

      do k = 1, size(r,3)
      do j = js, je
      do i = is, ie
         rdt(i,j,k) = -0.5*Hgrid%Tmp%rarea(j)*           &
                         ((frew(i  ,j,k)+frns(i,j  ,k))  &
                         -(frew(i-1,j,k)+frns(i,j-1,k)))
      enddo
      enddo
      enddo


 end subroutine advect_mass_horiz_4th

!#######################################################################

 subroutine advect_vel_horiz_2nd (Hgrid, few, fns, u, v, udt, vdt)

  type(horiz_grid_type),    intent(in) :: Hgrid
  real, intent(in),  dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: few, fns, &
                                                            u, v
  real, intent(out), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: udt, vdt

  real, dimension(Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub) :: &
                                             fuew, funs, fvew, fvns
  integer :: i, j, k

! second order centered differencing on B-grid momentum grid
! constant grid spacing assumed
! minimum halo size = 1

     do k = 1, size(u,3)

          !--- horizontal fluxes ---
           do j = Hgrid%Vel%js, Hgrid%Vel%je
           do i = Hgrid%Vel%is, Hgrid%Vel%ie+1
             fuew(i,j) = few(i,j,k) * (u(i-1,j,k) + u(i,j,k))
             fvew(i,j) = few(i,j,k) * (v(i-1,j,k) + v(i,j,k))
           enddo
           enddo
           do j = Hgrid%Vel%js, Hgrid%Vel%je+1
           do i = Hgrid%Vel%is, Hgrid%Vel%ie
             funs(i,j) = fns(i,j,k) * (u(i,j-1,k) + u(i,j,k))
             fvns(i,j) = fns(i,j,k) * (v(i,j-1,k) + v(i,j,k))
           enddo
           enddo

          !--- horizontal advective tendency ----
           do j = Hgrid%Vel%js, Hgrid%Vel%je
           do i = Hgrid%Vel%is, Hgrid%Vel%ie
              udt(i,j,k) = -0.5*Hgrid%Vel%rarea(j)*       &
                              ((fuew(i+1,j)+funs(i,j+1))  &
                              -(fuew(i  ,j)+funs(i,j  )))
              vdt(i,j,k) = -0.5*Hgrid%Vel%rarea(j)*       &
                              ((fvew(i+1,j)+fvns(i,j+1))  &
                              -(fvew(i  ,j)+fvns(i,j  )))
           enddo
           enddo

     enddo

 end subroutine advect_vel_horiz_2nd

!#######################################################################

 subroutine advect_vel_horiz_4th (Hgrid, few, fns, u, v, udt, vdt, &
                                  mask4)

  type(horiz_grid_type),    intent(inout) :: Hgrid
  real, intent(in),  dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: few, fns, u, v
  real, intent(out), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: udt, vdt
  real, intent(in),  dimension(Hgrid%ilb:,Hgrid%jlb:,:,:), optional :: &
                                                           mask4

! compress u & v components into 4th dimension
! this will create larger and more efficient halo updates
  real, dimension(Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub, &
                  size(u,3),2) :: uvew, uvns, fuvew, fuvns
  integer, parameter :: UCOMP=1, VCOMP=2

  real, dimension(Hgrid%ilb:Hgrid%iub) :: x2, x4
  real, dimension(Hgrid%ilb:Hgrid%iub) :: y2, y4
  real :: z2, z4
  integer :: i, j, k, is, ie, js, je

! fourth order centered differencing on B-grid momentum grid
! constant grid spacing assumed
! assumed halo size = 1

   is = Hgrid % Vel % is;  ie = Hgrid % Vel % ie
   js = Hgrid % Vel % js;  je = Hgrid % Vel % je


      do k = 1, size(u,3)
        do j = Hgrid%jlb  ,Hgrid%jub
        do i = Hgrid%ilb+1,Hgrid%iub
           uvew(i,j,k,UCOMP) = u(i-1,j,k)+u(i,j,k)
           uvew(i,j,k,VCOMP) = v(i-1,j,k)+v(i,j,k)
        enddo
        enddo
        do j = Hgrid%jlb+1,Hgrid%jub
        do i = Hgrid%ilb  ,Hgrid%iub
           uvns(i,j,k,UCOMP) = u(i,j-1,k)+u(i,j,k)
           uvns(i,j,k,VCOMP) = v(i,j-1,k)+v(i,j,k)
        enddo
        enddo
      enddo
      ! assumed halosize = 1
      call update_halo (Hgrid,WIND,uvew,halos=WEST)
      call update_halo (Hgrid,TEMP,uvns,halos=SOUTH)


     !---- horizontal fluxes ----

      if (present(mask4)) then
         do k = 1, size(u,3)
           do j = js, je
           do i = is, Hgrid%iub-1
             x4(i) = mask4(i,j,k,1)
             x2(i) = 1.0 - 2.*x4(i)
             fuvew(i,j,k,UCOMP) = few(i,j,k) * ( x2(i) * uvew(i,j,k,UCOMP) &
                            + x4(i) * (uvew(i-1,j,k,UCOMP) + uvew(i+1,j,k,UCOMP)) )
             fuvew(i,j,k,VCOMP) = few(i,j,k) * ( x2(i) * uvew(i,j,k,VCOMP) &
                            + x4(i) * (uvew(i-1,j,k,VCOMP) + uvew(i+1,j,k,VCOMP)) )
           enddo
           enddo
           do j = js, Hgrid%jub-1
           do i = is, ie
             y4(i) = mask4(i,j,k,2)
             y2(i) = 1.0 - 2.*y4(i)
             fuvns(i,j,k,UCOMP) = fns(i,j,k) * ( y2(i) * uvns(i,j,k,UCOMP) &
                                + y4(i) * (uvns(i,j-1,k,UCOMP) + uvns(i,j+1,k,UCOMP)) )
             fuvns(i,j,k,VCOMP) = fns(i,j,k) * ( y2(i) * uvns(i,j,k,VCOMP) &
                                + y4(i) * (uvns(i,j-1,k,VCOMP) + uvns(i,j+1,k,VCOMP)) )
           enddo
           enddo
         enddo
      else
         do k = 1, size(u,3)
           do j = js, je
           do i = is, Hgrid%iub-1
             fuvew(i,j,k,UCOMP) = few(i,j,k) * ( c2 * uvew(i,j,k,UCOMP) &
                            + c4 * (uvew(i-1,j,k,UCOMP) + uvew(i+1,j,k,UCOMP)) )
             fuvew(i,j,k,VCOMP) = few(i,j,k) * ( c2 * uvew(i,j,k,VCOMP) &
                            + c4 * (uvew(i-1,j,k,VCOMP) + uvew(i+1,j,k,VCOMP)) )
           enddo
           enddo
           do j = js, Hgrid%jub-1
           ! second order near poles
             z4 = c4
             if (j <= Hgrid%Vel%jsg+1) z4 = 0.
             if (j >= Hgrid%Vel%jeg  ) z4 = 0.
             z2 = 1.-2.*z4
           do i = is, ie
             fuvns(i,j,k,UCOMP) = fns(i,j,k) * ( z2 * uvns(i,j,k,UCOMP) &
                                + z4 * (uvns(i,j-1,k,UCOMP) + uvns(i,j+1,k,UCOMP)) )
             fuvns(i,j,k,VCOMP) = fns(i,j,k) * ( z2 * uvns(i,j,k,VCOMP) &
                                + z4 * (uvns(i,j-1,k,VCOMP) + uvns(i,j+1,k,VCOMP)) )
           enddo
           enddo
         enddo
      endif
      ! assumed halosize = 1
      call update_halo (Hgrid,WIND,fuvew,halos=EAST)
      call update_halo (Hgrid,TEMP,fuvns,halos=NORTH)

     !---- horizontal advective tendency ----

      do k = 1, size(u,3)
      do j = js, je
      do i = is, ie
         udt(i,j,k) = -0.5*Hgrid%Vel%rarea(j)*                        &
                        ((fuvew(i+1,j,k,UCOMP)+fuvns(i,j+1,k,UCOMP))  &
                        -(fuvew(i  ,j,k,UCOMP)+fuvns(i,j  ,k,UCOMP)))
         vdt(i,j,k) = -0.5*Hgrid%Vel%rarea(j)*                        &
                        ((fuvew(i+1,j,k,VCOMP)+fuvns(i,j+1,k,VCOMP))  &
                        -(fuvew(i  ,j,k,VCOMP)+fuvns(i,j  ,k,VCOMP)))
      enddo
      enddo
      enddo


 end subroutine advect_vel_horiz_4th

!#######################################################################
! computes advecting wind for horizontal finite-volume advection

 subroutine compute_advecting_wind ( Hgrid, dpo, dpn, few, fns, uc, vc )
 type(horiz_grid_type), intent(inout) :: Hgrid
 real, intent(in),  dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: dpo, dpn, few, fns
 real, intent(out), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: uc, vc

 real :: dp
 integer :: i, j, k

   do k = 1, size(uc,3)
   do j = Hgrid%jlb, Hgrid%jub
   do i = Hgrid%ilb, Hgrid%iub-1
     dp = (dpo(i,j,k)+dpn(i,j,k)+dpo(i+1,j,k)+dpn(i+1,j,k))*0.25
     uc(i,j,k) = few(i,j,k)/(dp*Hgrid%Tmp%dy)
   enddo
   enddo
   enddo

   do k = 1, size(uc,3)
   do j = Hgrid%jlb, Hgrid%jub-1
   do i = Hgrid%ilb, Hgrid%iub
     dp = (dpo(i,j,k)+dpn(i,j,k)+dpo(i,j+1,k)+dpn(i,j+1,k))*0.25
     vc(i,j,k) = fns(i,j,k)/(dp*Hgrid%Vel%dx(j))
   enddo
   enddo
   enddo

   call update_halo ( Hgrid, TEMP, uc, halos=EAST )
   call update_halo ( Hgrid, VWND, vc, halos=NORTH )

 end subroutine compute_advecting_wind

!#######################################################################
!--- stability diagnostic (CFL for horizontal finite volume scheme) ----

 subroutine stability_diag ( Hgrid, dt, few, dpo, dpn )
 type(horiz_grid_type), intent(inout) :: Hgrid
 real, intent(in)                     :: dt
 real, intent(in), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: few, dpo, dpn

 real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub) :: uc
 real    :: cflmax, cfl, dpa
 integer :: i, j, k

    cflmax = 0.
    do k = 1, size(few,3)
     ! compute zonal wind
       do j = Hgrid%Tmp%js  , Hgrid%Tmp%je
       do i = Hgrid%Tmp%is-1, Hgrid%Tmp%ie
         dpa = (dpo(i,j,k)+dpn(i,j,k)+dpo(i+1,j,k)+dpn(i+1,j,k))*0.25
         uc(i,j) = few(i,j,k)/(dpa*Hgrid%Tmp%dy)
       enddo     
       enddo   
       do j = Hgrid%Tmp%js, Hgrid%Tmp%je
       do i = Hgrid%Tmp%is, Hgrid%Tmp%ie
          cfl = abs(uc(i,j)-uc(i-1,j))*dt/Hgrid%Tmp%dx(j)
          cflmax = max(cflmax,cfl)
       enddo      
       enddo   
    enddo   
    call mpp_max (cflmax)
    if (mpp_pe() == mpp_root_pe()) then
        if (cflmax > 1.0) then
            print *, 'x-axis stability violated, cfl = ', cflmax
        endif       
    endif       

 end subroutine stability_diag

!#######################################################################

 subroutine mask4_init (Hgrid, grid, sigma, mask, mask4)

 type(horiz_grid_type), intent(inout) :: Hgrid
 integer, intent(in)                                      :: grid
 logical, intent(in)                                      :: sigma
 real, intent(in),   dimension(Hgrid%ilb:,Hgrid%jlb:,:)   :: mask
 real, intent(out),  dimension(Hgrid%ilb:,Hgrid%jlb:,:,:) :: mask4
 real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub, &
                 size(mask,3)) :: mew, mns

 integer :: i,j,k,is,ie,js,je,n


! horizontal masks

  select case (grid)

  case (1)
     if (sigma) then
        mask4(:,:,:,1:2) = c4
     else

      ! initialize
        mask4 = 0.0
        mns(:,Hgrid%jub,:) = 0.0

        do k = 1, size(mask,3)
          do j = Hgrid%jlb,Hgrid%jub
          do i = Hgrid%ilb,Hgrid%iub-1
             mew(i,j,k) = mask(i+1,j,k)*mask(i,j,k)
          enddo
          enddo
          do j = Hgrid%jlb,Hgrid%jub-1
          do i = Hgrid%ilb,Hgrid%iub
             mns(i,j,k) = mask(i,j+1,k)*mask(i,j,k)
          enddo
          enddo
        enddo
        ! assumed halosize = 1
        call update_halo (Hgrid,TEMP,mew,halos=EAST)
        call update_halo (Hgrid,UWND,mns,halos=NORTH,flags=NOPOLE)

         do k = 1, size(mask,3)
         ! x-axis
           do j = Hgrid%Tmp%js, Hgrid%Tmp%je
           do i = Hgrid%ilb+1,  Hgrid%Tmp%ie
             !mask4(i,j,k,1) = mew(i-1,j,k)<.01 .or. mew(i,j,k)<.01 .or. mew(i+1,j,k)<.01
             !mask4(i,j,k,1) = mew(i-1,j,k) * mew(i,j,k) * mew(i+1,j,k)
              mask4(i,j,k,1) = c4 * mew(i-1,j,k) * mew(i+1,j,k)
           enddo
           enddo
         ! y-axis
           do j = Hgrid%jlb+1,  Hgrid%Tmp%je
           do i = Hgrid%Tmp%is, Hgrid%Tmp%ie
             !mask4(i,j,k,2) = mns(i,j-1,k)<.01 .or. mns(i,j,k)<.01 .or. mns(i,j-1,k)<.01
             !mask4(i,j,k,2) = mns(i,j-1,k) * mns(i,j,k) * mns(i,j+1,k)
              mask4(i,j,k,2) = c4 * mns(i,j-1,k) * mns(i,j+1,k)
           enddo
           enddo
         enddo
     endif

  case (2)
     if (sigma) then
        mask4(:,:,:,1:2) = c4
        mns = 1.0
     else
      ! initialize
        mask4 = 0.0
        do k = 1, size(mask,3)
          do j = Hgrid%jlb  ,Hgrid%jub
          do i = Hgrid%ilb+1,Hgrid%iub
             mew(i,j,k) = mask(i-1,j,k)*mask(i,j,k)
          enddo
          enddo
          do j = Hgrid%jlb+1,Hgrid%jub
          do i = Hgrid%ilb  ,Hgrid%iub
             mns(i,j,k) = mask(i,j-1,k)*mask(i,j,k)
          enddo
          enddo
        enddo
        ! assumed halosize = 1
        call update_halo (Hgrid,UWND,mew,halos=WEST)
        call update_halo (Hgrid,TEMP,mns,halos=SOUTH,flags=NOPOLE)
      endif
    ! use second order in meridional direction near poles
      call vel_flux_boundary (Hgrid,mns)

      if (.not.sigma) then
        do k = 1, size(mask,3)
          do j = Hgrid%Vel%js, Hgrid%Vel%je
          do i = Hgrid%Vel%is, Hgrid%iub-1
             mask4(i,j,k,1) = c4 * mew(i-1,j,k) * mew(i+1,j,k)
          enddo
          enddo
        enddo
      endif

      do k = 1, size(mask,3)
        do j = Hgrid%Vel%js, Hgrid%jub-1
        do i = Hgrid%Vel%is, Hgrid%Vel%ie
           mask4(i,j,k,2) = c4 * mns(i,j-1,k) * mns(i,j+1,k)
        enddo
        enddo
      enddo

  end select


 end subroutine mask4_init

!#######################################################################
! initialization routine

  subroutine advection_init ( Hgrid )

! INPUT:  Hgrid = horizontal grid constants
! RESULT: reads bgrid_advection_nml namelist
!         defines advection control parameters (stored in advec_control_type)

  type(horiz_grid_type), intent(in) :: Hgrid

 real    :: wt
 integer :: n, m, np, ntrace, unit, ierr, io, logunit
 character(len=32)  :: advec_methods(2) = (/ 'advec_horiz', 'advec_vert ' /)
 character(len=128) :: scheme, params, name
!-----------------------------------------------------------------------
! read namelist
   if (file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
       read (input_nml_file, nml=bgrid_advection_nml, iostat=io)
       ierr = check_nml_error(io,'bgrid_advection_nml')
#else
       unit = open_namelist_file ( )
       ierr=1; do while (ierr /= 0)
          read (unit, nml=bgrid_advection_nml, iostat=io, end=5)
          ierr = check_nml_error (io, 'bgrid_advection_nml')
       enddo
 5     call close_file (unit)
#endif
   endif
   logunit = stdlog()
! write version, namelist info to log file
   if (do_log) then
      call write_version_number(version, tagname)
      if (mpp_pe() == mpp_root_pe()) write (logunit, nml=bgrid_advection_nml)
      do_log = .false.
   endif

 ! determine the number of prognostic tracers
   call get_number_tracers ( MODEL_ATMOS, num_prog=ntrace )

 ! allocate space for the control parameters
   allocate ( Control%scheme (2,-1:ntrace), &
              Control%weight   (-1:ntrace)  )
   allocate ( Control%Fill%fill_scheme (ntrace), &
              Control%Fill%npass_horiz (ntrace), &
              Control%Fill%npass_vert  (ntrace)  )

 ! set namelist values of control parameters

   Control%scheme(1,-1) = set_advec_scheme( horiz_advec_scheme_wind )
   Control%scheme(2,-1) = set_advec_scheme(  vert_advec_scheme_wind )
   Control%weight  (-1) = advec_weight_wind
   Control%scheme(1, 0) = set_advec_scheme( horiz_advec_scheme_temp )
   Control%scheme(2, 0) = set_advec_scheme(  vert_advec_scheme_temp )
   Control%weight  ( 0) = advec_weight_temp
 do n = 1, ntrace
   Control%scheme(1, n) = set_advec_scheme( horiz_advec_scheme_tracer )
   Control%scheme(2, n) = set_advec_scheme(  vert_advec_scheme_tracer )
   Control%weight  ( n) = advec_weight_tracer
   ! parameters for tracer filling/borrowing
   Control%Fill%npass_horiz(n) = num_fill_pass
   Control%Fill%npass_vert (n) = num_fill_pass
   Control%Fill%fill_scheme(n) = NONE
 enddo
   ! currently only one possible filling scheme
   if (maxval(Control%Fill%npass_horiz) > 0 .or. maxval(Control%Fill%npass_vert) > 0) &
                            Control%Fill%fill_scheme = EQUAL_BORROW

 ! process tracer table information for advection methods
   do n = 1, ntrace
      do m = 1, 2
         if (query_method(trim(advec_methods(m)), MODEL_ATMOS, n, scheme, params)) then
             Control%scheme(m,n) = set_advec_scheme( scheme )
             ! parse e-b weight
             if (Control%scheme(m,n) == SECOND_CENTERED .or. &
                 Control%scheme(m,n) == FOURTH_CENTERED) then
                   if (parse(params,'wt', wt) == 1) Control%weight(n) = wt
             endif
         endif
      enddo
   enddo

 ! error check for all Euler weights
   do n = -1, ntrace
        if (Control%weight(n) < 0.0 .or. Control%weight(n) > 1.0) &
                          call error_mesg ('bgrid_advection_mod', &
                            'E-B weight out of range [0,1]', FATAL)
   enddo

 ! process tracer table information for filling method
   do n = 1, ntrace
      if (query_method('filling', MODEL_ATMOS, n, scheme, params)) then
          if (uppercase(trim(scheme)) == 'LOCAL') then
              Control%Fill%fill_scheme(n) = EQUAL_BORROW
              Control%Fill%npass_horiz(n) = 1
              Control%Fill%npass_vert (n) = 1
         !else if (uppercase(trim(scheme)) == 'GLOBAL') then
         !    Control%Fill%fill_scheme(n) = GLOBAL_BORROW
          else if (uppercase(trim(scheme)) == 'NONE') then
              Control%Fill%fill_scheme(n) = NONE
              Control%Fill%npass_horiz(n) = 0
              Control%Fill%npass_vert (n) = 0
          else
              call error_mesg ('bgrid_advection_mod',  &
                   'invalid filling scheme, '//uppercase(trim(scheme)), FATAL)
          endif
         ! parse number of filling passes
           if (Control%Fill%fill_scheme(n) == EQUAL_BORROW) then
              if (parse(params,'hp', np) == 1) Control%Fill%npass_horiz(n) = np
              if (parse(params,'vp', np) == 1) Control%Fill%npass_vert (n) = np
           endif
      endif
   enddo

 ! print results
   if (mpp_pe() == mpp_root_pe()) then
           write (logunit,10) 'momentum', &
                 (trim(echo_advec_scheme(Control%scheme(m,-1))),m=1,2), Control%weight(-1)
           write (logunit,10) 'temperature', &
                 (trim(echo_advec_scheme(Control%scheme(m, 0))),m=1,2), Control%weight( 0)
      do n = 1, ntrace
           call get_tracer_names (MODEL_ATMOS, n, name)
           write (logunit,11) n, trim(name), &
                    ( trim(echo_advec_scheme(Control%scheme(m,n))),m=1,2), &
                                             Control%weight(n),            &
                                             Control%Fill%npass_horiz(n),  &
                                             Control%Fill%npass_vert(n)
        10 format (3x, a24, ', HORIZ=',a24, ', VERT=',a24, ', wt=',f7.3)
        11 format (i3, a24, ', HORIZ=',a24, ', VERT=',a24, ', wt=',f7.3, &
                   ', hp=',i2, ', vp=',i2)
      enddo
   endif

 ! check if fourth order centered horizontal scheme
   Control%do_mask4_vel = Control%scheme(1,-1) == FOURTH_CENTERED
   Control%do_mask4_tmp = .false.
   do n = 0, ntrace
     if (Control%scheme(1,n) == FOURTH_CENTERED) then
        Control%do_mask4_tmp = .true.
        exit
     endif
   enddo
 ! check if finite_volume horizontal scheme for temperature
     if (Control%scheme(1,0) == FINITE_VOLUME_LINEAR .or. &
         Control%scheme(1,0) == FINITE_VOLUME_PARABOLIC) then
         Control%do_finite_volume_tmp = .true.
     else
         Control%do_finite_volume_tmp = .false.
     endif
 ! check if finite_volume horizontal scheme for tracers
   Control%do_finite_volume_trs = .false.
   do n = 1, ntrace
     if (Control%scheme(1,n) == FINITE_VOLUME_LINEAR .or. &
         Control%scheme(1,n) == FINITE_VOLUME_PARABOLIC) then
         Control%do_finite_volume_trs = .true.
         exit
     endif
   enddo
 ! error checks
 ! many horizontal schemes are not support with this release
   do n = -1, ntrace
     if (Control%scheme(1,n) == FINITE_VOLUME_LINEAR    .or. &
         Control%scheme(1,n) == FINITE_VOLUME_PARABOLIC .or. &
         Control%scheme(1,n) == SECOND_CENTERED_WTS     .or. &
         Control%scheme(1,n) == FOURTH_CENTERED_WTS   ) then
         call error_mesg ('bgrid_advection_mod',  &
                   'advection scheme not supported', FATAL)
     endif
   enddo

! initialize code sections for performance timing 

  if (do_clock_init) then
    id_tmp  = mpp_clock_id ('BGRID: temperature advection', &
                        flags=MPP_CLOCK_SYNC, grain=CLOCK_ROUTINE)
    id_trs  = mpp_clock_id ('BGRID: tracer advection',      &
                        flags=MPP_CLOCK_SYNC, grain=CLOCK_ROUTINE)
    id_vel  = mpp_clock_id ('BGRID: momentum advection',    &
                        flags=MPP_CLOCK_SYNC, grain=CLOCK_ROUTINE)
    id_fill = mpp_clock_id ('BGRID: tracer borrowing',    &
                        flags=MPP_CLOCK_SYNC, grain=CLOCK_ROUTINE)
    do_clock_init = .false. 
  endif

!-----------------------------------------------------------------------

  end subroutine advection_init

!#######################################################################

 subroutine advection_end

  ! terminate vertical advection module
    call vert_advection_end

  ! terminate finite-volume advection module
  ! if (Control%do_finite_volume_tmp .or. Control%do_finite_volume_trs) then
  !     call horiz_advection_end
  ! endif   

  ! free up memory used (although not much)
    deallocate ( Control%scheme, Control%weight, &
                 Control%Fill%fill_scheme,       &       
                 Control%Fill%npass_horiz,       &       
                 Control%Fill%npass_vert         )       

 end subroutine advection_end

!#######################################################################
! converts character string names to integer parameters
! checks for all valid names, otherwise produces an error

 function set_advec_scheme ( scheme ) result ( advec_scheme )
 character(len=*), intent(in)  :: scheme
 integer                       :: advec_scheme

      if (uppercase(trim(scheme)) == 'SECOND_CENTERED') then
          advec_scheme = SECOND_CENTERED
      else if (uppercase(trim(scheme)) == 'FOURTH_CENTERED') then
          advec_scheme = FOURTH_CENTERED
      else if (uppercase(trim(scheme)) == 'FOURTH_CENTERED_WTS') then
          advec_scheme = FOURTH_CENTERED_WTS
      else if (uppercase(trim(scheme)) == 'SECOND_CENTERED_WTS') then
          advec_scheme = SECOND_CENTERED_WTS
      else if (uppercase(trim(scheme)) == 'FINITE_VOLUME_LINEAR') then
          advec_scheme = FINITE_VOLUME_LINEAR
      else if (uppercase(trim(scheme)) == 'FINITE_VOLUME_PARABOLIC') then
          advec_scheme = FINITE_VOLUME_PARABOLIC
      else if (uppercase(trim(scheme)) == 'NONE') then
          advec_scheme = NONE
      else
          call error_mesg ('bgrid_advection_mod',  &
               'invalid advection scheme, '//uppercase(trim(scheme)), FATAL)
      endif

 end function set_advec_scheme
!-----------------------------------------------
! converts integer parameter values to character string names
! checks for all valid schemes, otherwise produces an error

 function echo_advec_scheme ( scheme_number ) result ( scheme_name )
 integer, intent(in)  :: scheme_number
 character(len=24)    :: scheme_name

   select case (scheme_number)
       case(NONE)
            scheme_name = 'none                    '
       case(SECOND_CENTERED)
            scheme_name = 'second_centered         '
       case(FOURTH_CENTERED)
            scheme_name = 'fourth_centered         '
       case(SECOND_CENTERED_WTS)
            scheme_name = 'second_centered_wts     '
       case(FOURTH_CENTERED_WTS)
            scheme_name = 'fourth_centered_wts     '
       case(FINITE_VOLUME_LINEAR)
            scheme_name = 'finite_volume_linear    '
       case(FINITE_VOLUME_PARABOLIC)
            scheme_name = 'finite_volume_parabolic '
       case default
            call error_mesg  ('bgrid_advection_mod', &
                     'invalid advection scheme number', FATAL)
   end select

 end function echo_advec_scheme

!#######################################################################
!         routines to minimize negative tracer values 
!        conservative horizontal and vertical borrowing
!#######################################################################

subroutine horiz_borrow (Hgrid, dt, dpde, var, var_dt, mask, iters)

!-----------------------------------------------------------------------
!
!       removes negative values by borrowing from horizontal
!       neighbors.  (usually for specific humidity or tke )
!
!-----------------------------------------------------------------------
   type(horiz_grid_type), intent(inout)                      :: Hgrid
   real, intent(in)                                          :: dt
   real, intent(in),    dimension(Hgrid%ilb:,Hgrid%jlb:,:)   :: dpde
   real, intent(in),    dimension(Hgrid%ilb:,Hgrid%jlb:,:,:) :: var
   real, intent(inout), dimension(Hgrid%ilb:,Hgrid%jlb:,:,:) :: var_dt
   real, intent(in),    dimension(Hgrid%ilb:,Hgrid%jlb:,:), optional :: mask
integer, intent(in),    dimension(:),                       optional :: iters
!-----------------------------------------------------------------------
!  ( note:   0.0 < flt <= 0.125 )
   real, parameter :: flt  = 0.125
   real, parameter :: flt4 = flt*0.25
   real, parameter :: rmin = 0.0
!-----------------------------------------------------------------------

   real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub,size(var,3)) ::  &
                                hew, hns, radp, few, fns, rcur, rdif

   real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub) :: rew, rns
   real, dimension(Hgrid%jlb:Hgrid%jub) :: areax, areay

integer :: i, j, k, n, is, ie, js, je, nlev, ntrace, knt, mxknt(size(var,4))
!-----------------------------------------------------------------------

   mxknt = 1;  if (present(iters)) mxknt = iters
   if (maxval(mxknt) == 0) return

   nlev   = size(var,3)
   ntrace = size(var,4)

   is = Hgrid%Tmp%is;  ie = Hgrid%Tmp%ie
   js = Hgrid%Tmp%js;  je = Hgrid%Tmp%je

!-----------------------------------------------------------------------
!------ compute flux coeff common to all variables -------

   do j = js-1, je
     areax(j) = Hgrid%Tmp%area(j)+Hgrid%Tmp%area(j)
     areay(j) = Hgrid%Tmp%area(j)+Hgrid%Tmp%area(j+1)
   enddo

   do k = 1, nlev
   do j = js-1, je
   do i = is-1, ie
     hew(i,j,k) = areax(j)*(dpde(i,j,k)+dpde(i+1,j,k))
     hns(i,j,k) = areay(j)*(dpde(i,j,k)+dpde(i,j+1,k))
   enddo
   enddo
   enddo
 ! apply step-mountain mask?
   if (present(mask)) then
       do k = 1, nlev
       do j = js-1, je
       do i = is-1, ie
         hew(i,j,k) = hew(i,j,k)*mask(i,j,k)*mask(i+1,j,k)
         hns(i,j,k) = hns(i,j,k)*mask(i,j,k)*mask(i,j+1,k)
       enddo
       enddo
       enddo
   endif

   do k = 1, nlev
   do j = js, je
     radp(:,j,k) = flt4/(Hgrid%Tmp%area(j)*dpde(:,j,k))
   enddo
   enddo

!-----------------------------------------------------------------------
!---- tracer loop -----
!---- store current value of tracer in rcur ----

   do n = 1, ntrace

      rcur(:,:,:) = var(:,:,:,n) + var_dt(:,:,:,n)*dt

!---- iteration loop -----

      few = 0.0;  fns = 0.0

   do knt = 1, mxknt(n)

!--------------2-nd order lat/lon contributions-------------------------

!     --- do borrowing where adjacent values have opposite sign ---
!            but do not turn off fluxes previously turned on

      do k = 1, nlev
         do j = js-1, je
         do i = is-1, ie
            ! east-west fluxes
            if ((rcur(i+1,j,k) <  rmin .and. rcur(i,j,k) >= rmin) .or. &
                (rcur(i+1,j,k) >= rmin .and. rcur(i,j,k) <  rmin))     &
            few(i,j,k) = hew(i,j,k)
            rew(i,j) = (rcur(i+1,j,k)-rcur(i,j,k))*few(i,j,k)
            ! north-south fluxes
            if ((rcur(i,j+1,k) <  rmin .and. rcur(i,j,k) >= rmin) .or. &
                (rcur(i,j+1,k) >= rmin .and. rcur(i,j,k) <  rmin))     &
            fns(i,j,k) = hns(i,j,k)
            rns(i,j) = (rcur(i,j+1,k)-rcur(i,j,k))*fns(i,j,k)
         enddo
         enddo

         do j = js, je
         do i = is, ie
            rdif(i,j,k) = (rew(i,j)-rew(i-1,j)+ &
                           rns(i,j)-rns(i,j-1))*radp(i,j,k)
         enddo
         enddo
      enddo

     !---- halo update (assumed that halo size = 1) ----

      call update_halo (Hgrid, TEMP, rdif)

     !---- update current value of tracer ----

      rcur(:,:,:) = rcur(:,:,:) + rdif(:,:,:)

!-----------------------------------------------------------------------
   enddo ! iteration loop
!-----------------------------------------------------------------------

     !---- return the tendency -----

      var_dt(:,:,:,n) = (rcur(:,:,:) - var(:,:,:,n)) / dt

!-----------------------------------------------------------------------
   enddo ! tracer loop
!-----------------------------------------------------------------------

end subroutine horiz_borrow

!#######################################################################

   subroutine vert_borrow (dt, dpde, var, var_dt, iters)

!-----------------------------------------------------------------------
!
!  This removes negative specific humidity/mixing ratios by borrowing
!  from the grid boxes immediately above and below. If not enough
!  is available to fill the negative then a negative will remain.
!
!-----------------------------------------------------------------------
   real, intent(in)    :: dt, dpde(:,:,:), var(:,:,:,:)
   real, intent(inout) :: var_dt(:,:,:,:)
integer, intent(in), optional :: iters(:)
!-----------------------------------------------------------------------
   real, dimension(size(var,3)) :: deficit, surplus, rdpdt
   real :: divid, ratio_dn, ratio_up, var_dp
   integer :: i, j, k, n, m, nlev, num_iters(size(var,4)), num, num_var
!-----------------------------------------------------------------------

   num_iters = 4; if (present(iters)) num_iters = iters
   if (maxval(num_iters) == 0) return

   num_var = size(var,4)
   if (num_var == 0) return
   nlev = size(var,3)

!---- variable loop and iteration loop -----

 do n = 1, num_var
 do m = 1, num_iters(n)

!---- existing negatives will not be corrected ----

   do j = 1, size(var,2)
   do i = 1, size(var,1)

   do k = 1, nlev
      var_dp = (var(i,j,k,n)+dt*var_dt(i,j,k,n))*dpde(i,j,k)
      deficit(k) = min(var_dp,0.0)
      surplus(k) = max(var_dp,0.0)
      rdpdt(k) = 1./(dpde(i,j,k)*dt)
   enddo

!---- top level ----

   if (deficit(1) < 0.0) then
      divid = max(-surplus(2)/deficit(1),1.0)
      ratio_dn = surplus(2)/divid
      var_dt(i,j,1,n) = var_dt(i,j,1,n) + ratio_dn*rdpdt(1)
      var_dt(i,j,2,n) = var_dt(i,j,2,n) - ratio_dn*rdpdt(2)
      surplus(2) = max(surplus(2)-ratio_dn,0.)
   endif

!---- interior levels ----

   do k = 2, nlev-1
     if (deficit(k) < 0.0) then
       divid = max(-(surplus(k-1)+surplus(k+1))/deficit(k),1.0)
       ratio_up = surplus(k-1)/divid
       ratio_dn = surplus(k+1)/divid
       var_dt(i,j,k,n)   = var_dt(i,j,k,n)+(ratio_up+ratio_dn)*rdpdt(k)
       var_dt(i,j,k-1,n) = var_dt(i,j,k-1,n)-ratio_up*rdpdt(k-1)
       var_dt(i,j,k+1,n) = var_dt(i,j,k+1,n)-ratio_dn*rdpdt(k+1)
       surplus(k+1) = max(surplus(k+1)-ratio_dn,0.)
     endif
   enddo

!---- bottom level ----

   if (deficit(nlev) < 0.0) then
      divid = max(-surplus(nlev-1)/deficit(nlev),1.0)
      ratio_up = surplus(nlev-1)/divid
      var_dt(i,j,nlev  ,n) = var_dt(i,j,nlev  ,n)+ratio_up*rdpdt(nlev)
      var_dt(i,j,nlev-1,n) = var_dt(i,j,nlev-1,n)-ratio_up*rdpdt(nlev-1)
   endif

 enddo
 enddo

 enddo
 enddo

!-----------------------------------------------------------------------

   end subroutine vert_borrow

!#######################################################################

subroutine compute_etadot_vel ( Hgrid, Vgrid, Masks, few, fns, etadot )
!subroutine compute_etadot_vel ( Hgrid, Vgrid, Masks, res, few, fns, etadot )

type(horiz_grid_type), intent(in) :: Hgrid
type (vert_grid_type), intent(in) :: Vgrid
type (grid_mask_type), intent(in) :: Masks
!real, intent(in),  dimension(Hgrid%ilb:,Hgrid%jlb:)   :: res
real, intent(in),  dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: few, fns
real, intent(out), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: etadot

real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub) :: sdiv
integer :: i, j, k, is, ie, js, je, nlev

! this code will not work with the eta coordinate
! the variable res need to be added as an argument
  if (.not.Masks%sigma) call error_mesg  ('bgrid_advection_mod', &
      'etadot cannot be recomputed for the eta coordinate', FATAL)


  is = Hgrid%Vel%is;  ie = Hgrid%Vel%ie
  js = Hgrid%Vel%js;  je = Hgrid%Vel%je
  nlev = size(few,3)

  etadot = 0.
  sdiv   = 0.

  do k = 1, nlev

      ! vertical integral of divergence at velocity points
      ! only need etadot for velocity compute domain
      do j = js, je
      do i = is, ie
         sdiv(i,j) = sdiv(i,j) + ((few(i+1,j,k)+fns(i,j+1,k))-  &  
                                  (few(i  ,j,k)+fns(i,j  ,k)))  &
                                 *Hgrid%Vel%rarea(j)
      enddo   
      enddo   

      if (k < nlev) etadot(:,:,k+1) = -sdiv(:,:)

   enddo

   ! finally include d(ps)/dt term
   do k = 2, nlev
     !etadot(:,:,k) = etadot(:,:,k) + sdiv(:,:)*res(:,:)*Vgrid%eta(k))
      etadot(:,:,k) = etadot(:,:,k) + sdiv(:,:)*Vgrid%eta(k)
      if (.not.Masks%sigma) etadot(:,:,k) = etadot(:,:,k)*Masks%Vel%mask(:,:,k)
   enddo

end subroutine compute_etadot_vel

!#######################################################################

end module bgrid_advection_mod

module cloud_generator_mod

!   shared modules:
  use sat_vapor_pres_mod, only: compute_qs
  use constants_mod,      only: hlv, hls, cp_air, tfreeze, &
                                rvgas, rdgas
  use mpp_mod,            only: input_nml_file
  use fms_mod,            only: open_namelist_file, mpp_pe,       &
                                mpp_root_pe, stdlog,              &
                                write_version_number, file_exist, &
                                check_nml_error, error_mesg,      &
                                FATAL, close_file
  use random_numbers_mod, only: randomNumberStream,        &
                                getRandomNumbers
  use beta_dist_mod,      only: beta_dist_init, beta_dist_end, &
                                incomplete_beta, beta_deviate
!--------------------------------------------------------------------
  !
  ! Given a profile of cloud fraction, produce a set of columns indicating 
  !   the presence or absence of cloud consistent with one of four overlap  
  !   assumptions: random, maximum, maximum-random, and one allowing 
  !   the rank correlation of the variable to be specified between layers.
  ! The module uses a random number generation module which can be used to wrap
  !   an arbitrary random number generator. The module defines a type that keeps 
  !   the state (the seed, a generator indicator, or whatever).  
  ! Each function takes cloud fraction as a function of height. You can either supply 
  !   a vector or a 3D array of dimensions (nX, ny, nLevels); in either case the 
  !   first element in the level dimension is the highest model layer. 
  ! Each function returns an array nSamples by nLevels long, where nLevels
  !   is determined by the size of the cloud fraction array. 
  ! The neighbor-to-neighbor correlation routine takes an additional 
  !   parameters described below. 
  !
!--------------------------------------------------------------------
  implicit none
  private

!---------------------------------------------------------------------
!----------- version number for this module --------------------------

character(len=128)  :: version =  '$Id: cloud_generator.F90,v 19.0 2012/01/06 20:02:09 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'

!---------------------------------------------------------------------
!-------  interfaces --------

  interface genRandomOverlapSamples
    module procedure genRandomOverlapSamples_1D, genRandomOverlapSamples_3D
  end interface ! genRandomOverlapSamples
  
  interface genMaximumOverlapSamples
    module procedure genMaximumOverlapSamples_1D, genMaximumOverlapSamples_3D
  end interface ! genMaximumOverlapSamples
  
  interface genMaxRanOverlapSamples
    module procedure genMaxRanOverlapSamples_1D, genMaxRanOverlapSamples_3D
  end interface ! genMaxRanOverlapSamples
  
  interface genWeightedOverlapSamples
    module procedure genWeightedOverlapSamples_1D, genWeightedOverlapSamples_3D
  end interface ! genWeightedOverlapSamples
  
  public :: cloud_generator_init, &
            cloud_generator_end,  &
            generate_stochastic_clouds, &
            do_cloud_generator,   &
            compute_overlap_weighting
  
!---------------------------------------------------------------------
!-------- namelist  ---------

  ! Minimum values for cloud fraction, water, ice contents
  !   Taken from cloud_rad. Perhaps these should be namelist parameters? 
  real, parameter :: qcmin = 1.E-10, qamin = 1.E-2
  
  ! Pressure scale height - for converting pressure differentials to height
  real, parameter :: pressureScaleHeight = 7.3 ! km
  
  ! Overlap parameter: 1 - Maximum, 2 - Random, 3 - Maximum/Random,
  !                    4 - Exponential
  integer         :: defaultOverlap = 2 
  real            :: overlapLengthScale = 2.0  ! km
  ! These control the option to pull cloud condensate from a symmetric  
  !    beta distribution with p = q = betaP, adjusting 
  !    the upper and lower bounds of the ditribution to match 
  !    cloud fraction and cloud condensate. 
  logical         :: do_inhomogeneous_clouds = .false. 
  integer         :: betaP = 5

  !The following apply for pdf cloud scheme
  !
  ! qthalfwidth defines the fraction of qtbar (mean total water in the
  ! grid box) that the maximum and minimum of the distribution differ 
  ! from qtbar. That is, total water at the sub-grid scale may take on 
  ! values anywhere between (1.-qthalfwidth)*qtbar and (1.+qthalfwidth)*
  ! qtbar
  !
  logical         :: do_pdf_clouds = .false.
  real            :: qthalfwidth = 0.1  
  
  ! The following apply for ppm vertical interpolation if done.
  !
  !      nsublevels      This is the number of sub-levels to be used
  !                      for sub-grid scale vertical structure to
  !                      clouds. If equal to 1, then no vertical
  !                      sub-grid scale structure is calculated.
  !
  !      kmap, kord      Quantities related to the PPM vertical inter-
  !                      polation calculation.
  !
  integer           :: nsublevels     = 1
  integer           :: kmap           = 1
  integer           :: kord           = 7
  
namelist /cloud_generator_nml/  defaultOverlap, overlapLengthScale, &
                                  do_inhomogeneous_clouds, betaP,     &
                                  do_pdf_clouds, qthalfwidth, nsublevels, &
                                  kmap,kord

!----------------------------------------------------------------------
!----  private data -------

logical :: module_is_initialized = .false.  ! module is initialized ?
logical :: cloud_generator_on    = .false.  ! is module being operated?

!----------------------------------------------------------------------

                              contains 
                              
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                              
!######################################################################
subroutine cloud_generator_init


!---------------------------------------------------------------------
!    cloud_generator_init is the constructor for 
!    cloud_generator_mod.

!----------------------------------------------------------------------
!   local variables:
      integer   ::   unit, ierr, io, logunit

!--------------------------------------------------------------------
!   local variables:
!
!      unit     io unit for reading nml file and writing logfile
!      ierr     error code
!      io       error status returned from io operation  
!
!--------------------------------------------------------------------

      if (.not. module_is_initialized) then
!---------------------------------------------------------------------
!    read namelist.         
!---------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
        read (input_nml_file, nml=cloud_generator_nml, iostat=io)
        ierr = check_nml_error(io,"cloud_generator_nml")
#else
        if (file_exist('input.nml')) then
          unit =  open_namelist_file ( )
          ierr=1; do while (ierr /= 0)
          read (unit, nml=cloud_generator_nml, iostat=io, end=10) 
          ierr = check_nml_error (io, 'cloud_generator_nml')
          enddo                       
10        call close_file (unit)      
        endif                         
#endif
!----------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
        call write_version_number(version, tagname)
        logunit = stdlog()
        if (mpp_pe() == mpp_root_pe() ) &
                   write (logunit, nml=cloud_generator_nml)
                   
!-----------------------------------------------------------------------
!    do_inhomogeneous_clouds and do_pdf_clouds cannot be 
!    simultaneously true
!-----------------------------------------------------------------------
        if (do_inhomogeneous_clouds .and. do_pdf_clouds) then
          call error_mesg ( 'cloud_generator_mod', &
           'do_inhomogeneous_clouds and do_pdf_clouds cannot'//&
           'be simultaneously true', FATAL)
        endif
!-----------------------------------------------------------------------
!    qthalfwidth must be greater than 0.
!-----------------------------------------------------------------------
        if (qthalfwidth .lt. 1.e-03) then
          call error_mesg ( 'cloud_generator_mod', &
           'qthalfwidth must be greater than 0.001', FATAL)
        endif

!---------------------------------------------------------------------
!    Initialize the beta distribution module if we're going to need it. 
!---------------------------------------------------------------------
        if(do_inhomogeneous_clouds .or. do_pdf_clouds) &
             call beta_dist_init

!---------------------------------------------------------------------
!    mark the module as initialized.
!---------------------------------------------------------------------
        module_is_initialized = .true.
        cloud_generator_on    = .true.
     end if

end subroutine cloud_generator_init
!----------------------------------------------------------------------
!----------------------------------------------------------------------
subroutine generate_stochastic_clouds(streams, ql, qi, qa, qn, qni,    &
                                      overlap, pFull, pHalf, & 
                                      temperature, qv,&
                                      cld_thickness, &
                                      ql_stoch, qi_stoch, qa_stoch, &
                                      qn_stoch, qni_stoch)
!--------------------------------------------------------------------
!   intent(in) variables:
!
  type(randomNumberStream), &
           dimension(:, :),     intent(inout) :: streams
  ! Dimension nx, ny, nz
  real,    dimension(:, :, :),    intent( in) :: ql, qi, qa, qn, qni
  integer,                     optional, &
                                  intent( in) :: overlap
  real,    dimension(:, :, :), optional, &
                                 intent( in)  :: pFull, temperature, qv
  ! Dimension nx, ny, nz+1
  real,    dimension(:, :, :), optional, &
                                 intent( in)  :: pHalf                  
  ! Dimension nx, ny, nz, nCol = nBands
  integer, dimension(:, :, :, :), intent(out) :: cld_thickness 
  real,    dimension(:, :, :, :), intent(out) :: ql_stoch, qi_stoch, &
                                                 qa_stoch, qn_stoch, &
                                                 qni_stoch
  ! ---------------------------------------------------------
  ! Local variables
  real,    dimension(size(ql_stoch, 1), &
                     size(ql_stoch, 2), &
                     size(ql_stoch, 3)) :: qa_local, ql_local, qi_local
  real,    dimension(size(ql_stoch, 1), &
                     size(ql_stoch, 2), &
                     size(ql_stoch, 3)) :: heightDifference, &
                                           overlapWeighting  ! 1 for max, 0 for random
                         
  real,    dimension(size(ql_stoch, 1), &
                     size(ql_stoch, 2), &
                     size(ql_stoch, 3), &
                     size(ql_stoch, 4)) :: pdfRank ! continuously from 0 to 1
                                  
  ! These arrays could be declared allocatable and used only when 
  !    do_inhomogeneous_clouds OR do_pdf_clouds is true. 
  real,    dimension(size(ql_stoch, 1), &  ! Quantities for estimating condensate variability
                     size(ql_stoch, 2), &  !   from a beta distribution
                     size(ql_stoch, 3)) :: aThermo, qlqcRatio, qs_norm, &
                                           deltaQ, qs

  real,    dimension(size(ql_stoch, 1), &
                     size(ql_stoch, 2), &
                     size(ql_stoch, 3), &
                     size(ql_stoch, 4)) :: qc_stoch !stochastic condensate
  real,    dimension(4,                 &
                     size(ql_stoch,1),  &
                     size(ql_stoch,2),  &
                     size(ql_stoch,3)) :: qta4,qtqsa4 !used for ppm
  real,    dimension(size(ql_stoch,1),  &
                     size(ql_stoch,2),  &
                     size(ql_stoch,3)) :: delp !used for ppm
  real,    dimension(size(ql_stoch,1),  &
                     size(ql_stoch,2),  &
                     size(ql_stoch,4)) :: qctmp, qatmp !temporary summing 
                                                       !variables
                                   
  real    :: pnorm   !fraction of level- used for ppm interpolation    
  real    :: tmpr  
  integer :: nLev, nCol
  integer :: overlapToUse
  integer :: i, j, k, n, ns
 
  ! ---------------------------------------------------------

  nLev = size(ql_stoch, 3)
  nCol = size(ql_stoch, 4)
  
  !
  ! Normally, we use the overlap specified in the namelist for this module, but
  !   this can be overridden with an optional argument. 
  !
  if(present(overlap)) then
    overlapToUse = overlap
  else
    overlapToUse = defaultOverlap
  end if
  
  !
  ! Ensure that cloud fraction, water vapor, and water and ice contents are 
  ! in bounds
  !
  !   After similar code in cloud_summary3
  !
  qa_local(:,:,:) = 0.
  do k=1, nLev
       do j=1, size(qa_stoch,2)
       do i=1, size(qa_stoch,1)
         if (qa(i,j,k) > qamin .and. ql(i,j,k) > qcmin) then
           qa_local(i,j,k) = qa(i,j,k)
           ql_local(i,j,k) = ql(i,j,k)
         else
           ql_local(i,j,k) = 0.0           
         endif
         if (qa(i,j,k) > qamin .and. qi(i,j,k) > qcmin) then
           qa_local(i,j,k) = qa(i,j,k)
           qi_local(i,j,k) = qi(i,j,k)
         else
           qi_local(i,j,k) = 0.0           
         endif
       end do
       end do
  end do

  
  !
  ! Apply overlap assumption
  !
   if (overlapToUse == 2) then
      pdfRank(:, :, :, :) = genRandomOverlapSamples( qa_local(:, :, :), nCol, streams(:, :))
   else if (overlapToUse == 1) then
      pdfRank(:, :, :, :) = genMaximumOverlapSamples(qa_local(:, :, :), nCol, streams(:, :))
   else if (overlapToUse == 3) then
      pdfRank(:, :, :, :) = genMaxRanOverlapSamples( qa_local(:, :, :), nCol, streams(:, :))
   else if (overlapToUse == 4) then
      if(.not. present(pFull)) call error_mesg("cloud_generator_mod", &
                                               "Need to provide pFull when using overlap = 4", FATAL)
      !
      ! Height difference from hydrostatic equation with fixed scale height for T = 250 K
      !
      heightDifference(:, :, :nLev-1) = (log(pFull(:, :, 2:nLev)) - log(pFull(:, :, 1:nLev-1))) * &
                                         pressureScaleHeight 
      heightDifference(:, :, nLev) = heightDifference(:, :, nLev-1)
      !
      ! Overlap is weighted between max and random with parameter overlapWeighting (0 = random, 
      !    1 = max), which decreases exponentially with the separation distance. 
      !
      overlapWeighting(:, :, :) = exp( - heightDifference(:, :, :) / overlapLengthScale )
      pdfRank(:, :, :, :) = genWeightedOverlapSamples(qa_local(:, :, :),         &
                                                      overlapWeighting(:, :, :), & 
                             nCol, streams(:, :))
    else
      call error_mesg("cloud_generator_mod", "unknown overlap parameter", FATAL)
     
     endif



  
  if(.not. do_inhomogeneous_clouds .and. .not. do_pdf_clouds) then
    !
    ! The clouds are uniform, so every cloudy cell at a given level 
    !   gets the same ice and/or liquid concentration (subject to a minumum). 
    ! We're looking for in-cloud ice and water contents, so we 
    !   divide by cloud fraction
    !  
    do n=1,nCol
      do k=1,nLev
       do j=1, size(qa_stoch,2)
       do i=1, size(qa_stoch,1)
!  a "true" for the following test indicates the presence of cloudiness
         if (pdfRank(i,j,k,n) > (1.-qa_local(i,j,k))) then
           cld_thickness(i,j,k,n   ) = 1.
           qa_stoch(i,j,k,n   ) = 1. 
           ql_stoch(i,j,k,n   ) = ql_local(i,j,k)/qa_local(i,j,k)
           qi_stoch(i,j,k,n   ) = qi_local(i,j,k)/qa_local(i,j,k)
         else
           cld_thickness(i,j,k,n   ) = 0.
           qa_stoch(i,j,k,n   ) = 0. 
           ql_stoch(i,j,k,n   ) = 0.                              
           qi_stoch(i,j,k,n   ) = 0.                              
         endif
        end do
        end do
        end do
        end do
           

  end if
  
  if (do_inhomogeneous_clouds) then
    if(.not. present(pFull) .or. .not. present(temperature)) &
      call error_mesg("cloud_generator_mod",                 &
      "Need to provide pFull and temperature when using inhomogenous clouds", FATAL)
    !
    ! Assume that total water in each grid cell follows a symmetric beta distribution with  
    !   exponents p=q set in the namelist. Determine the normalized amount of condensate 
    !   (qc - qmin)/(qmax - qmin) from the incomplete beta distribution at the pdf rank. 
    !   Convert to physical units based on three equations
    !   qs_norm = (qs - qmin)/(qmax - qmin)
    !   qa = 1. - betaIncomplete(qs_norm, p, q)
    !   qc_mean/(qmax - qmin) = aThermo( p/(p+q) (1 - betaIncomplete(qs_norm, p+1, q)) - 
    !                                    qs_norm * (1 - cf) )
    !   The latter equation comes from integrating aThermo * (qtot - qsat) times a beta distribution 
    !   from qsat to qmax; see, for example, from Tompkins 2002 (Eq. 14), but including a thermodynamic 
    !   term aThermo = 1/(1 + L/cp dqs/dt) evaluated at the "frozen temperature", as per SAK. 
    !   
    where (qa_local(:, :, :) > qamin) 
      qlqcRatio(:, :, :) = ql_local(:, :, :) / (ql_local(:, :, :) + qi_local(:, :, :))
    elsewhere
      qlqcRatio(:, :, :) = 1 ! Shouldn't be used. 
    end where
    call computeThermodynamics(temperature, pFull, ql, qi, aThermo)

    qs_norm(:, :, :) = 1. ! This assignment is made so the values of qs_norm 
                          ! are always valid; in practice these should be masked out 
  ! in the regions below. 
    where(qa_local(:, :, :) < qamin)
      !
      ! Not cloudy, so deltaQ is irrelevant
      !
      qs_norm(:, :, :) = 1. 
      deltaQ(:, :, :) = 0.
    elsewhere
      !
      ! Hey, is this the right test for fully cloudy conditions? Is cloud fraction ever 1.? 
      !
      where (qa_local(:, :, :) >= 1.) 
        !
        ! In fully cloudy conditions we don't have any information about the bounds
        !   of the total water distribution. We arbitrarily set the lower bound to qsat.
        !   For a symmetric distribution the upper bound to qsat plus twice the amount of 
        !   condensate. 
        !
          qs_norm(:, :, :) = 0.
        deltaQ(:, :, :) = (2/aThermo(:, :, :)) * &
                          (ql_local(:, :, :) + qi_local(:, :, :)) / qa_local(:, :, :)
        ! qMin(:, :, :) = qsat(:, :, :)
      elsewhere 
        !
        ! Partially cloudy conditions - diagnose width of distribution from mean 
        !   condensate amount and cloud fraction. 
        !   The factor 1/2 = p/(p+q)
        !
        qs_norm(:, :, :) = beta_deviate(1. - qa_local(:, :, :), p = betaP, q = betaP)
        deltaQ(:, :, :) =                                                               &
          (ql_local(:, :, :) + qi_local(:, :, :)) /                                     &
          (aThermo(:, :, :) * ((1./2. * (1. - incomplete_beta(qs_norm(:, :, :),         &
                                                          p = betaP + 1, q = betaP))) - &
                               qs_norm(:, :, :) * qa_local(:, :, :) ))
        ! qMin(:, :, :) = qsat(:, :, :) - qs_norm(:, :, :) * deltaQ(:, :, :)
      end where 
    end where
  
    do n=1,nCol
      do k=1,nLev
       do j=1, size(qa_stoch,2)
       do i=1, size(qa_stoch,1)
!  a "true" for the following test indicates the presence of cloudiness
         if (pdfRank(i,j,k,n) > (1.-qa_local(i,j,k))) then
           cld_thickness(i,j,k,n   ) = 1.
           qa_stoch(i,j,k,n   ) = 1. 
      !
      ! Hey, do we need to account for cloud fraction here, as we do in the homogeneous case? 
      !   Also, does this seem like the right way to go from the mean to individual samples? 
      !
      qc_stoch(i, j, k, n) = aThermo(i,j,k  ) * deltaQ(i,j,k  ) * &
            (beta_deviate(pdfRank(i,j,k,n   ), p = betaP, q = betaP) - &
                   qs_norm(i,j,k) ) 
      ! 
      ! The proportion of ice and water in each sample is the same as the mean proportion.  
      !
           ql_stoch(i,j,k,n   ) = qc_stoch(i,j,k,n)* qlqcRatio(i,j,k)
           qi_stoch(i,j,k,n   ) = qc_stoch(i,j,k,n)*   &
                                     (1.-qlqcRatio(i,j,k))
         else
           cld_thickness(i,j,k,n   ) = 0.
           qa_stoch(i,j,k,n   ) = 0. 
           ql_stoch(i,j,k,n   ) = 0.                              
           qi_stoch(i,j,k,n   ) = 0.                              
         endif
        end do
        end do
        end do
        end do
           
  end if 

  if (do_pdf_clouds) then
    if(.not. present(pFull) .or. .not. present(temperature) .or. &
       .not. present(qv)    .or. .not. present(pHalf)) &

      call error_mesg("cloud_generator_mod",                 &
      "Need to provide pFull, pHalf, temperature and water vapor when using pdf clouds", FATAL)
    !
    ! Assume that total water in each grid cell follows a symmetric beta distribution with  
    !   exponents p=q set in the namelist. In contrast to the procedure for inhomogen-
    !   eous clouds, here the distribution is known (either from prognostic variance)
    !   or from diagnostic variance. In this case one can directly determine
    !   the cloud condensate from:
    !   
    !   qc = aThermo * (qt -qs) =
    !      = aThermo * deltaQ * (beta_deviate(pdfRank,p,q) - qsnorm)
    !
    !   Note that the qlqcRatio needs to be defined in the case that there is no
    !   cloud in the grid box from what enters this subroutine (qa_local) yet there
    !   is condensate diagnosed in this routine. The formula that weights the
    !   saturation vapor pressure as a function of temperature is used.
    
       
    where (qa_local(:, :, :) > qamin) 
      qlqcRatio(:, :, :) = ql_local(:, :, :) / (ql_local(:, :, :) + qi_local(:, :, :))
    elsewhere
      qlqcRatio(:, :, :) = min(1., max(0., 0.05*(temperature(:,:,:)-tfreeze+20.))) 
    end where
    call computeThermodynamics(temperature, pFull, ql, qi, aThermo, qs)

    !Compute ppm interpolation - if nsublevels > 1
    do k = 1, nLev
         delp(:,:,k) = pHalf(:,:,k+1)-pHalf(:,:,k)
    enddo     
    qta4(1,:,:,:) = max(qcmin,qv+ql_local+qi_local)
    qtqsa4(1,:,:,:) = qta4(1,:,:,:)-qs
        
    if (nsublevels.gt.1) then
        do i=1, size(qa_stoch,1)
            call ppm2m_sak(qta4(:,i,:,:),delp(i,:,:),nLev,kmap,1,&
                       size(qa_stoch,2),0,kord)
            call ppm2m_sak(qtqsa4(:,i,:,:),delp(i,:,:),nLev,kmap,1,&
                       size(qa_stoch,2),0,kord)
        enddo                
    else
        qta4(2,:,:,:) = qta4(1,:,:,:)
        qta4(3,:,:,:) = qta4(1,:,:,:)
        qta4(4,:,:,:) = 0.
        qtqsa4(2,:,:,:) = qtqsa4(1,:,:,:)
        qtqsa4(3,:,:,:) = qtqsa4(1,:,:,:)
        qtqsa4(4,:,:,:) = 0.   
    end if
    
    !loop over vertical levels       
    do k=1, nLev
         
        !initialize summing variable
        qctmp(:,:,:) = 0.         
        qatmp(:,:,:) = 0.
        
        !Create loop over sub-levels within a grid box
        do ns = 1, nsublevels
             
             !calculate normalized vertical level
             ! 0. = top of gridbox
             ! 1. = bottom of gridbox
        
             pnorm =  (real(ns) - 0.5 )/real(nsublevels)
             
             !First step is to calculating the 
             !the width of the qt distribution (deltaQ)
             deltaQ(:,:,k) = max(qcmin, &
                          qta4(2,:,:,k)+pnorm*( (qta4(3,:,:,k)- &
                          qta4(2,:,:,k)) +  qta4(4,:,:,j)*(1-pnorm) ) )
             deltaQ(:,:,k) = 2.*qthalfwidth*deltaQ(:,:,k)
             
             !From this the variable normalized saturation specific
             !humidity qs_norm is calculated.
             !
             !  qs_norm = (qs(Tl) - qtmin)/(qtmax-qtmin)
             !
             !          = 0.5  - (qtbar - qs(Tl))/deltaQ
             !
             !Note that if qs_norm > 1., the grid box is fully clear.
             !If qs_norm < 0., the grid box is fully cloudy.
             qs_norm(:,:,k) = qtqsa4(2,:,:,k)+  &
                       pnorm*( (qtqsa4(3,:,:,k)-qtqsa4(2,:,:,k)) + &
                       qtqsa4(4,:,:,k)*(1-pnorm) )
             qs_norm(:,:,k) = 0.5 - ( qs_norm(:,:,k)/deltaQ(:,:,k) )
             
             do j=1, size(qa_stoch,2)
             do i=1, size(qa_stoch,1)             
             do n=1,nCol
       
                  if (qs_norm(i,j,k).lt.1.) then
                      tmpr =           aThermo(i,j,k  ) * &
                                        deltaQ(i,j,k  ) * &
                               (beta_deviate(pdfRank(i,j,k,n   ), &
                                          p = betaP, q = betaP) - &
                                       qs_norm(i,j,k) )
                      if (tmpr.gt.qcmin) then                 
                          qctmp(i, j, n) = qctmp(i, j, n) + tmpr
                          qatmp(i, j, n) = qatmp(i, j, n) + 1.
                      end if           
                  end if
                  
             enddo !for nCol
             enddo !for i
             enddo !for j
             
        enddo !for ns (nsublevels)
         
        !produce vertical average qc
        do j=1, size(qa_stoch,2)
        do i=1, size(qa_stoch,1)
        do n=1, nCol
            
             qctmp(i,j,n) = qctmp(i,j,n) / real (nsublevels)
             qa_stoch(i,j,k,n) = qatmp(i,j,n) / real (nsublevels)
             if (qctmp(i,j,n).le.qcmin) then
                  cld_thickness(i,j,k,n) = 0.
                  qa_stoch(i,j,k,n) = 0.
                  qc_stoch(i,j,k,n) = 0.
                  ql_stoch(i,j,k,n) = 0.
                  qi_stoch(i,j,k,n) = 0.
             else
                  qc_stoch(i,j,k,n) = qctmp(i,j,n)             
                  cld_thickness(i,j,k,n) = 1.
                  !qa_stoch(i,j,k,n) = 1.          
       
                  ! 
                  ! The proportion of ice and water in each 
                  ! sample is the same as the mean proportion.  
                  !
                  ql_stoch(i,j,k,n   ) = qc_stoch(i,j,k,n)* &
                                        qlqcRatio(i,j,k)
                  qi_stoch(i,j,k,n   ) = qc_stoch(i,j,k,n)* &
                                     (1.-qlqcRatio(i,j,k))
             end if !for column containing cloud
             
        enddo !for nCol
        enddo !for i
        enddo !for j 
        
    end do !for k (vertical loop)
           
  end if  ! for do_pdf_clouds


  ! Create qn_stoch - the stochastic cloud droplet number
  ! 
  do n=1,nCol
  do k=1,nLev
  do j=1, size(qa_stoch,2)
  do i=1, size(qa_stoch,1)
    if (ql_stoch(i,j,k,n)>qcmin .and. qa_stoch(i,j,k,n)>qcmin) then
      qn_stoch(i,j,k,n) = qa_stoch(i,j,k,n)* &
                          max(0.,qn(i,j,k)/max(qcmin,qa(i,j,k)))
      !note that qa is compared to qcmin to minimize the impact of the
      !limiters on calculating the in-cloud cloud droplet number
    else
      qn_stoch(i,j,k,n) = 0.                           
    endif
  end do
  end do
  end do
  end do


!cms++
  ! Create qni_stoch - the stochastic cloud ice number
  ! 
  do n=1,nCol
  do k=1,nLev
  do j=1, size(qa_stoch,2)
  do i=1, size(qa_stoch,1)
    if (qi_stoch(i,j,k,n)>qcmin .and. qa_stoch(i,j,k,n)>qcmin) then
      qni_stoch(i,j,k,n) = qa_stoch(i,j,k,n)* &
                          max(0.,qni(i,j,k)/max(qcmin,qa(i,j,k)))
      !note that qa is compared to qcmin to minimize the impact of the
      !limiters on calculating the in-cloud cloud ice number
    else
      qni_stoch(i,j,k,n) = 0.                           
    endif
  end do
  end do
  end do
  end do
!cms--

end subroutine generate_stochastic_clouds

  ! ---------------------------------------------------------
  !  Function to return the weighting between maximum and random overlap 
  !    given the pressure difference 
  ! 
  !  Note pPlus is the pressure at a higher altitude
  !  (i.e. pPlus < pMinus)
  ! ---------------------------------------------------------
function compute_overlap_weighting(qaPlus, qaMinus, pPlus, pMinus) result(weighting)
  real, dimension(:, :), intent( in) :: qaPlus, qaMinus, pPlus, pMinus
  real, dimension(size(pPlus, 1), &
                  size(pPlus, 2))    :: weighting
        
  select case(defaultOverlap)
    case(1) ! Maximum overlap
      weighting(:, :) = 1.
    case(2) ! Random overlap
      weighting(:, :) = 0.
    case(3) ! Maximum-random
      where(qaPlus(:, :) > qamin) 
        weighting(:, :) = 1.
      elsewhere
        weighting(:, :) = 0.
      end where
    case(4)
      !
      ! Overlap is weighted between max and random with parameter overlapWeighting (0 = random, 
      !    1 = max), which decreases exponentially with the separation distance. 
      !
      weighting(:, :) = exp(-abs(log(pMinus(:, :)) - log(pPlus(:, :))) * &
                              pressureScaleHeight / overlapLengthScale)
    case default 
      call error_mesg("cloud_generator_mod", "unknown overlap parameter", FATAL)
    end select
      
end function compute_overlap_weighting



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                     PRIVATE SUBROUTINES
!  These generate cloud samples according to specific overlap rules.  
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  subroutine computeThermodynamics(temperature, pressure, ql, qi, aThermo, qs)
    real, dimension(:, :, :), intent( in) :: temperature, pressure, ql, qi
    real, dimension(:, :, :), intent(out) :: aThermo
    real, dimension(:, :, :), optional, intent(out) :: qs
        
    real, parameter :: d608 = (rvgas - rdgas)/rdgas, &
                       d622 = rdgas/rvgas,           &
                       d378 = 1. - d622
    
    ! Compute saturation mixing ratio and gamma = 1/(1 + L/cp dqs/dT) evaluated
    !   at the ice water temperature
    ! Taken from strat_cloud_mod
    
    ! Local variables
    real, dimension(size(temperature, 1), &
                    size(temperature, 2), &
                    size(temperature, 3)) :: Tl, L, dqsdT,qsloc
    
    !
    ! Ice water temperature - ql and qi are grid cell means
    !
    Tl(:, :, :) =  temperature(:, :, :) -       &
                   (hlv/cp_air) * ql(:, :, :) - &
                   (hls/cp_air) * qi(:, :, :)
  
    !calculate qs and dqsdT
    call compute_qs (Tl, pressure,  qsloc, dqsdT = dqsdT)
    if (present(qs)) then
       qs = qsloc
    endif
 
    ! Latent heat of phase change, varying from that of water to ice with temperature.
    ! 
    L(:, :, :) = (min(1., max(0., 0.05*(temperature(:, :, :) - tfreeze + 20.)))*hlv + &
                  min(1., max(0., 0.05*(tfreeze - temperature(:, :, :)      )))*hls)
    aThermo(:, :, :) = 1./ (1. + L(:, :, :)/cp_air * dqsdT(:, :, :)) 
    
  end subroutine computeThermodynamics
  ! ---------------------------------------------------------
  ! Random overlap - the value is chosen randomly from the distribution at 
  !   every height. 
  ! ---------------------------------------------------------
  function genRandomOverlapSamples_1D(cloudFraction, nSamples, stream) &
           result(randomValues)
    real,    dimension(:),    intent(in   ) :: cloudFraction
    integer,                  intent(in   ) :: nSamples
    type(randomNumberStream), intent(inout) :: stream
    real,    dimension(size(cloudFraction), nSamples) &
                                            :: randomValues
    ! -------------------
    call getRandomNumbers(stream, randomValues)
  end  function genRandomOverlapSamples_1D
  ! ---------------------------------------------------------
  function genRandomOverlapSamples_3D(cloudFraction, nSamples, stream) &
           result(randomValues)
    real,    dimension(:, :, :),    intent(in   ) :: cloudFraction
    integer,                        intent(in   ) :: nSamples
    type(randomNumberStream), &
             dimension(:, :),       intent(inout) :: stream
    real,    dimension(size(cloudFraction, 1), &
                       size(cloudFraction, 2), &
                       size(cloudFraction, 3), &
                       nSamples)                  :: randomValues
    ! Local variables
    integer :: i, j
    ! -------------------
    do j = 1, size(cloudFraction, 2)
      do i = 1, size(cloudFraction, 1)
        call getRandomNumbers(stream(i, j), randomValues(i, j, :, :))
      end do
    end do
  end  function genRandomOverlapSamples_3D
  ! ---------------------------------------------------------

  ! ---------------------------------------------------------
  ! Maximum overlap - the position in the PDF is the same 
  !   at every height in a given column (though it varies from 
  !   column to column). 
  ! ---------------------------------------------------------

  function genMaximumOverlapSamples_1D(cloudFraction, nSamples, stream) &
           result(randomValues)
    real,    dimension(:),    intent(in   ) :: cloudFraction
    integer,                  intent(in   ) :: nSamples
    type(randomNumberStream), intent(inout) :: stream
    real,     dimension(size(cloudFraction), nSamples) &
                                            :: randomValues
    
    
    ! -------------------
    call getRandomNumbers(stream, randomValues(1, :))
    randomValues(:, :)  = spread(randomValues(1, :), &
                                 dim = 1, nCopies = size(cloudFraction))
  end  function genMaximumOverlapSamples_1D
  ! ---------------------------------------------------------
  function genMaximumOverlapSamples_3D(cloudFraction, nSamples, stream) &
           result(randomValues)
    real,    dimension(:, :, :),    intent(in   ) :: cloudFraction
    integer,                        intent(in   ) :: nSamples
    type(randomNumberStream), &
             dimension(:, :),       intent(inout) :: stream
    real,    dimension(size(cloudFraction, 1), &
                       size(cloudFraction, 2), &
                       size(cloudFraction, 3), &
                       nSamples)                  :: randomValues
    ! -------------------
    ! Local variables
    integer :: i, j, nX, nY, nLev
    ! -------------------
    nX   = size(cloudFraction, 1); nY  = size(cloudFraction, 2)
    nLev = size(cloudFraction, 3)
    
    do j = 1, nY
      do i = 1, nX
        call getRandomNumbers(stream(i, j), randomValues(i, j, 1, :))
      end do
    end do 
    randomValues(:, :, :, :)  = spread(randomValues(:, :, 1, :), dim = 3, nCopies = nLev)

  end  function genMaximumOverlapSamples_3D
  ! ---------------------------------------------------------
  
  ! ---------------------------------------------------------
  ! Meximum-random overlap. 
  ! Within each column, the value in the top layer is chosen 
  !   at random. We then walk down one layer at a time. If the layer above is cloudy
  !   we use the same random deviate in this layer; otherwise
  !   we choose a new value. 
  ! ---------------------------------------------------------
  
  function genMaxRanOverlapSamples_1D(cloudFraction, nSamples, stream) &
           result(randomValues)
    real,    dimension(:),    intent(in   ) :: cloudFraction
    integer,                  intent(in   ) :: nSamples
    type(randomNumberStream), intent(inout) :: stream
    real,    dimension(size(cloudFraction), nSamples) &
                                            :: randomValues
    ! Local variables
    integer                                 :: level
    
    ! -------------------
    call getRandomNumbers(stream, randomValues)
    do level = 2, size(cloudFraction)
      where(randomValues(:, level - 1) > 1. - cloudFraction(level - 1))
        randomValues(level, :) = randomValues(level - 1, :)
      elsewhere
        randomValues(level, :) = randomValues(level, :) * (1. - cloudFraction(level - 1))
      end where
    end do
  end  function genMaxRanOverlapSamples_1D
  ! ---------------------------------------------------------
  function genMaxRanOverlapSamples_3D(cloudFraction, nSamples, stream) &
           result(randomValues)
    real,    dimension(:, :, :),    intent(in   ) :: cloudFraction
    integer,                        intent(in   ) :: nSamples
    type(randomNumberStream), &
             dimension(:, :),       intent(inout) :: stream
    real,    dimension(size(cloudFraction, 1), &
                       size(cloudFraction, 2), &
                       size(cloudFraction, 3), &
                       nSamples)                  :: randomValues
    ! -------------------
    ! Local variables
    integer :: i, j, level, nX, nY, nLev
    ! -------------------
    nX   = size(cloudFraction, 1); nY  = size(cloudFraction, 2)
    nLev = size(cloudFraction, 3)
    
    do j = 1, nY
      do i = 1, nX
        call getRandomNumbers(stream(i, j), randomValues(i, j, :, :))
      end do
    end do 
              
    do level = 2, nLev
      where(randomValues(:, :, level - 1, :) > &
            spread(1. - cloudFraction(:, :, level - 1), dim = 3, nCopies = nSamples))
        randomValues(:, :, level, :) = randomValues(:, :, level - 1, :)
      elsewhere
        randomValues(:, :, level, :) = randomValues(:, :, level, :) * &
                                       spread(1. - cloudFraction(:, :, level - 1), &
                                              dim = 3, nCopies = nSamples)
      end where
    end do
  end  function genMaxRanOverlapSamples_3D
  ! ---------------------------------------------------------
  
  ! Neighbor to neighbor rank correlation, which gives exponential dependence 
  !   of rank correlation if the correlation is fixed. The correlation coefficient 
  !   is the array alpha. 
  ! Two streams of random numbers are generated. The first corresponds to the postion in 
  !   the PDF, and the second is used to enforce the correlation . If the value of 
  !   the second stream at one level in one column is less than alpha at that level, 
  !   the same relative position in the PDF is chosen in the lower layer as the upper.  
  ! ---------------------------------------------------------
  function genWeightedOverlapSamples_1D(cloudFraction, alpha, nSamples, stream) &
           result(randomValues)
    real,    dimension(:),    intent(in   ) :: cloudFraction, alpha
    integer,                  intent(in   ) :: nSamples
    type(randomNumberStream), intent(inout) :: stream
    real,    dimension(size(cloudFraction), nSamples) &
                                            :: randomValues
    
    ! Local variables
    real, dimension(size(cloudFraction), nSamples) :: randomValues2
    integer                                        :: level
    
    ! -------------------
    call getRandomNumbers(stream, randomValues)
    call getRandomNumbers(stream, randomValues2)
    
    do level = 1, size(cloudFraction) - 1 
      where(randomValues2(level + 1, :) < alpha(level)) &
        randomValues(level + 1, :) = randomValues(level, :)
    end do   
  end  function genWeightedOverlapSamples_1D
  ! ---------------------------------------------------------
  function genWeightedOverlapSamples_3D(cloudFraction, alpha, nSamples, stream) &
           result(randomValues)
    real,    dimension(:, :, :), intent(in   ) :: cloudFraction, alpha
    integer,                     intent(in   ) :: nSamples
    type(randomNumberStream), &
             dimension(:, :),    intent(inout) :: stream
    real,    dimension(size(cloudFraction, 1), &
                       size(cloudFraction, 2), &
                       size(cloudFraction, 3), &
                       nSamples)               :: randomValues
     
    ! Local variables
    real, dimension(size(cloudFraction, 1), &
                    size(cloudFraction, 2), &
                    size(cloudFraction, 3), &
                                  nSamples) :: randomValues2
    integer                                 :: i, j, nX, nY, nLev, level
    
    ! -------------------
    nX   = size(cloudFraction, 1); nY  = size(cloudFraction, 2)
    nLev = size(cloudFraction, 3)
    
    do j = 1, nY
      do i = 1, nX
        call getRandomNumbers(stream(i, j), randomValues (i, j, :, :))
      end do
    end do 
    do j = 1, nY
      do i = 1, nX
        call getRandomNumbers(stream(i, j), randomValues2(i, j, :, :))
      end do
    end do 
     
    do level = 1, nLev - 1
      where(randomValues2(:, :, level + 1, :) < spread(alpha(:, :, level),           &
                                                       dim = 3, nCopies = nSamples)) &
        randomValues(:, :, level + 1, :) = randomValues(:, :, level, :)
    end do
  end  function genWeightedOverlapSamples_3D
  ! ---------------------------------------------------------

  subroutine cloud_generator_end       
  !----------------------------------------------------------------------
  !    cloud_generator_end is the destructor for cloud_generator_mod.
  !----------------------------------------------------------------------
          
  !---------------------------------------------------------------------
  !    be sure module has been initialized.
  !---------------------------------------------------------------------
        if (.not. module_is_initialized ) then
          call error_mesg ('cloud_generator_mod',   &
               'module has not been initialized', FATAL )
        endif
        
        if(do_inhomogeneous_clouds .or. do_pdf_clouds) &
             call beta_dist_end
  !---------------------------------------------------------------------
  !    mark the module as not initialized.
  !---------------------------------------------------------------------
        module_is_initialized = .false.
  end subroutine cloud_generator_end
  !--------------------------------------------------------------------

  !--------------------------------------------------------------------
  !
  !  Function to report if the cloud generator is being used. 
  !
  function do_cloud_generator()
    logical :: do_cloud_generator
    
    do_cloud_generator = cloud_generator_on
  end function do_cloud_generator
  !--------------------------------------------------------------------

!----------------------------------------------------------------------- 
!BOP
! !ROUTINE:  ppm2m_sak --- Piecewise parabolic method for fields
!
! !INTERFACE:
 subroutine ppm2m_sak(a4, delp, km, kmap, i1, i2, iv, kord)

 implicit none

! !INPUT PARAMETERS:
 integer, intent(in):: iv      ! iv =-1: winds
                               ! iv = 0: positive definite scalars
                               ! iv = 1: others
 integer, intent(in):: i1      ! Starting longitude
 integer, intent(in):: i2      ! Finishing longitude
 integer, intent(in):: km      ! vertical dimension
 integer, intent(in):: kmap    ! partial remap to start
 integer, intent(in):: kord    ! Order (or more accurately method no.):
                               ! 
 real, intent(in):: delp(i1:i2,km)     ! layer pressure thickness

! !INPUT/OUTPUT PARAMETERS:
 real, intent(inout):: a4(4,i1:i2,km)  ! Interpolated values

! !DESCRIPTION:
!
!   Perform the piecewise parabolic method 
! 
! !REVISION HISTORY: 
!   ??.??.??    Lin        Creation
!   02.04.04    Sawyer     Newest release from FVGCM
! 
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
! local arrays:
      real   dc(i1:i2,km)
      real   h2(i1:i2,km)
      real delq(i1:i2,km)
      real  df2(i1:i2,km)
      real   d4(i1:i2,km)

! local scalars:
      integer i, k, km1, lmt
      integer it
      real fac
      real a1, a2, c1, c2, c3, d1, d2
      real qmax, qmin, cmax, cmin
      real qm, dq, tmp
      real qmp, pmp
      real lac

      km1 = km - 1
       it = i2 - i1 + 1

      do k=max(2,kmap-2),km
         do i=i1,i2
            delq(i,k-1) =   a4(1,i,k) - a4(1,i,k-1)
              d4(i,k  ) = delp(i,k-1) + delp(i,k)
         enddo
      enddo
 
      do k=max(2,kmap-2),km1
         do i=i1,i2
            c1  = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
            c2  = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
            tmp = delp(i,k)*(c1*delq(i,k) + c2*delq(i,k-1)) /      &
                                    (d4(i,k)+delp(i,k+1))
            qmax = max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1)) - a4(1,i,k)
            qmin = a4(1,i,k) - min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))
             dc(i,k) = sign(min(abs(tmp),qmax,qmin), tmp)
            df2(i,k) = tmp
         enddo
      enddo

!-----------------------------------------------------------
! 4th order interpolation of the provisional cell edge value
!-----------------------------------------------------------

      do k=max(3,kmap), km1
      do i=i1,i2
        c1 = delq(i,k-1)*delp(i,k-1) / d4(i,k)
        a1 = d4(i,k-1) / (d4(i,k) + delp(i,k-1))
        a2 = d4(i,k+1) / (d4(i,k) + delp(i,k))
        a4(2,i,k) = a4(1,i,k-1) + c1 + 2./(d4(i,k-1)+d4(i,k+1)) *    &
                  ( delp(i,k)*(c1*(a1 - a2)+a2*dc(i,k-1)) -          &
                                delp(i,k-1)*a1*dc(i,k  ) )
      enddo
      enddo

      if(km>8 .and. kord>3) call steepz_sak(i1, i2, km, kmap, a4, df2, dc, delq, delp, d4)

! Area preserving cubic with 2nd deriv. = 0 at the boundaries
! Top
      if ( kmap <= 2 ) then
      do i=i1,i2
         d1 = delp(i,1)
         d2 = delp(i,2)
         qm = (d2*a4(1,i,1)+d1*a4(1,i,2)) / (d1+d2)
         dq = 2.*(a4(1,i,2)-a4(1,i,1)) / (d1+d2)
         c1 = 4.*(a4(2,i,3)-qm-d2*dq) / ( d2*(2.*d2*d2+d1*(d2+3.*d1)) )
         c3 = dq - 0.5*c1*(d2*(5.*d1+d2)-3.*d1**2)
         a4(2,i,2) = qm - 0.25*c1*d1*d2*(d2+3.*d1)
         a4(2,i,1) = d1*(2.*c1*d1**2-c3) + a4(2,i,2)
         dc(i,1) =  a4(1,i,1) - a4(2,i,1)
! No over- and undershoot condition
         cmax = max(a4(1,i,1), a4(1,i,2))
         cmin = min(a4(1,i,1), a4(1,i,2))
         a4(2,i,2) = max(cmin,a4(2,i,2))
         a4(2,i,2) = min(cmax,a4(2,i,2))
      enddo
      endif

! Bottom
! Area preserving cubic with 2nd deriv. = 0 at the surface
      do i=i1,i2
         d1 = delp(i,km)
         d2 = delp(i,km1)
         qm = (d2*a4(1,i,km)+d1*a4(1,i,km1)) / (d1+d2)
         dq = 2.*(a4(1,i,km1)-a4(1,i,km)) / (d1+d2)
         c1 = (a4(2,i,km1)-qm-d2*dq) / (d2*(2.*d2*d2+d1*(d2+3.*d1)))
         c3 = dq - 2.0*c1*(d2*(5.*d1+d2)-3.*d1**2)
         a4(2,i,km) = qm - c1*d1*d2*(d2+3.*d1)
         a4(3,i,km) = d1*(8.*c1*d1**2-c3) + a4(2,i,km)
         dc(i,km) = a4(3,i,km) -  a4(1,i,km)
! No over- and under-shoot condition
         cmax = max(a4(1,i,km), a4(1,i,km1))
         cmin = min(a4(1,i,km), a4(1,i,km1))
         a4(2,i,km) = max(cmin,a4(2,i,km))
         a4(2,i,km) = min(cmax,a4(2,i,km))
      enddo

      do k=max(1,kmap),km1
         do i=i1,i2
            a4(3,i,k) = a4(2,i,k+1)
         enddo
      enddo

! Enforce monotonicity of the "slope" within the top layer
      if ( kmap <= 2 ) then
      do i=i1,i2
         if ( a4(2,i,1) * a4(1,i,1) <= 0. ) then 
              a4(2,i,1) = 0.
                dc(i,1) = a4(1,i,1)
         endif
         if ( dc(i,1) * (a4(2,i,2) - a4(1,i,1)) <= 0. ) then
! Setting DC==0 will force piecewise constant distribution after
! calling kmppm_sak
              dc(i,1) = 0.
         endif
      enddo
      endif

! Enforce constraint on the "slope" at the surface

      do i=i1,i2
         if( a4(3,i,km) * a4(1,i,km) <= 0. ) then
!            a4(3,i,km) = 0.
!              dc(i,km) =  -a4(1,i,km)
               dc(i,km) = 0.
         endif
         if( dc(i,km) * (a4(1,i,km) - a4(2,i,km)) <= 0. ) then
             dc(i,km) = 0.
         endif
      enddo
 
!-----------------------------------------------------------
! f(s) = AL + s*[(AR-AL) + A6*(1-s)]         ( 0 <= s  <= 1 )
!-----------------------------------------------------------
! Top 2 and bottom 2 layers always use monotonic mapping
      if ( kmap <= 2 ) then
      do k=1,2
         do i=i1,i2
            a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
         enddo
            call kmppm_sak(dc(i1,k), a4(1,i1,k), it, 0)
      enddo
      endif

      if(kord >= 7) then
!-----------------------
! Huynh's 2nd constraint
!-----------------------
      do k=max(2,kmap-1), km1
         do i=i1,i2
! Method#1
!           h2(i,k) = delq(i,k) - delq(i,k-1)
! Method#2
!           h2(i,k) = 2.*(dc(i,k+1)/delp(i,k+1) - dc(i,k-1)/delp(i,k-1))
!    &               / ( delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)) )
!    &               * delp(i,k)**2
! Method#3
            h2(i,k) = dc(i,k+1) - dc(i,k-1)
         enddo
      enddo

      if( kord == 7 ) then
         fac = 1.5           ! original quasi-monotone
      else
         fac = 0.125         ! full monotone
      endif

      do k=max(3,kmap), km-2
        do i=i1,i2
! Right edges
!        qmp   = a4(1,i,k) + 2.0*delq(i,k-1)
!        lac   = a4(1,i,k) + fac*h2(i,k-1) + 0.5*delq(i,k-1)
!
         pmp   = 2.*dc(i,k)
         qmp   = a4(1,i,k) + pmp
         lac   = a4(1,i,k) + fac*h2(i,k-1) + dc(i,k)
         qmin  = min(a4(1,i,k), qmp, lac)
         qmax  = max(a4(1,i,k), qmp, lac)
         a4(3,i,k) = min(max(a4(3,i,k), qmin), qmax)
! Left  edges
!        qmp   = a4(1,i,k) - 2.0*delq(i,k)
!        lac   = a4(1,i,k) + fac*h2(i,k+1) - 0.5*delq(i,k)
!
         qmp   = a4(1,i,k) - pmp
         lac   = a4(1,i,k) + fac*h2(i,k+1) - dc(i,k)
         qmin  = min(a4(1,i,k), qmp, lac)
         qmax  = max(a4(1,i,k), qmp, lac)
         a4(2,i,k) = min(max(a4(2,i,k), qmin), qmax)
! Recompute A6
         a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
        enddo
! Additional constraint to ensure positivity when kord=7
         if (iv == 0 .and. kord == 7) then
             call kmppm_sak(dc(i1,k), a4(1,i1,k), it, 2)
         endif
      enddo

      else
 
         lmt = kord - 3
         lmt = max(0, lmt)
         if (iv == 0) lmt = min(2, lmt)

      do k=max(3,kmap), km-2
      if( kord /= 4) then
         do i=i1,i2
            a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
         enddo
      endif
         call kmppm_sak(dc(i1,k), a4(1,i1,k), it, lmt)
      enddo
      endif

      do k=km1,km
         do i=i1,i2
            a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
         enddo
         call kmppm_sak(dc(i1,k), a4(1,i1,k), it, 0)
      enddo
!EOC
 end subroutine ppm2m_sak
!-----------------------------------------------------------------------

!----------------------------------------------------------------------- 
!BOP
! !ROUTINE:  kmppm_sak --- Perform piecewise parabolic method in vertical
!
! !INTERFACE:
 subroutine kmppm_sak(dm, a4, itot, lmt)

 implicit none

! !INPUT PARAMETERS:
      real, intent(in):: dm(*)     ! the linear slope
      integer, intent(in) :: itot      ! Total Longitudes
      integer, intent(in) :: lmt       ! 0: Standard PPM constraint
                                       ! 1: Improved full monotonicity constraint (Lin)
                                       ! 2: Positive definite constraint
                                       ! 3: do nothing (return immediately)
! !INPUT/OUTPUT PARAMETERS:
      real, intent(inout) :: a4(4,*)   ! PPM array
                                           ! AA <-- a4(1,i)
                                           ! AL <-- a4(2,i)
                                           ! AR <-- a4(3,i)
                                           ! A6 <-- a4(4,i)

! !DESCRIPTION:
!
! !REVISION HISTORY: 
!    00.04.24   Lin       Last modification
!    01.03.26   Sawyer    Added ProTeX documentation
!    02.04.04   Sawyer    Incorporated newest FVGCM version
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:

      real, parameter:: r12 = 1./12.
      real qmp
      real da1, da2, a6da
      real fmin
      integer i

! Developer: S.-J. Lin, NASA-GSFC
! Last modified: Apr 24, 2000

      if ( lmt == 3 ) return

      if(lmt == 0) then
! Standard PPM constraint
      do i=1,itot
      if(dm(i) == 0.) then
         a4(2,i) = a4(1,i)
         a4(3,i) = a4(1,i)
         a4(4,i) = 0.
      else
         da1  = a4(3,i) - a4(2,i)
         da2  = da1**2
         a6da = a4(4,i)*da1
         if(a6da < -da2) then
            a4(4,i) = 3.*(a4(2,i)-a4(1,i))
            a4(3,i) = a4(2,i) - a4(4,i)
         elseif(a6da > da2) then
            a4(4,i) = 3.*(a4(3,i)-a4(1,i))
            a4(2,i) = a4(3,i) - a4(4,i)
         endif
      endif
      enddo

      elseif (lmt == 1) then

! Improved full monotonicity constraint (Lin 2003)
! Note: no need to provide first guess of A6 <-- a4(4,i)
      do i=1, itot
           qmp = 2.*dm(i)
         a4(2,i) = a4(1,i)-sign(min(abs(qmp),abs(a4(2,i)-a4(1,i))), qmp)
         a4(3,i) = a4(1,i)+sign(min(abs(qmp),abs(a4(3,i)-a4(1,i))), qmp)
         a4(4,i) = 3.*( 2.*a4(1,i) - (a4(2,i)+a4(3,i)) )
      enddo

      elseif (lmt == 2) then

! Positive definite constraint
      do i=1,itot
      if( abs(a4(3,i)-a4(2,i)) < -a4(4,i) ) then
      fmin = a4(1,i)+0.25*(a4(3,i)-a4(2,i))**2/a4(4,i)+a4(4,i)*r12
         if( fmin < 0. ) then
         if(a4(1,i)<a4(3,i) .and. a4(1,i)<a4(2,i)) then
            a4(3,i) = a4(1,i)
            a4(2,i) = a4(1,i)
            a4(4,i) = 0.
         elseif(a4(3,i) > a4(2,i)) then
            a4(4,i) = 3.*(a4(2,i)-a4(1,i))
            a4(3,i) = a4(2,i) - a4(4,i)
         else
            a4(4,i) = 3.*(a4(3,i)-a4(1,i))
            a4(2,i) = a4(3,i) - a4(4,i)
         endif
         endif
      endif
      enddo

      endif

!EOC
 end subroutine kmppm_sak
!-----------------------------------------------------------------------

!----------------------------------------------------------------------- 
!BOP
! !ROUTINE:  steepz_sak --- Calculate attributes for PPM
!
! !INTERFACE:
 subroutine steepz_sak(i1, i2, km, kmap, a4, df2, dm, dq, dp, d4)

   implicit none

! !INPUT PARAMETERS:
      integer, intent(in) :: km                   ! Total levels
      integer, intent(in) :: kmap                 ! 
      integer, intent(in) :: i1                   ! Starting longitude
      integer, intent(in) :: i2                   ! Finishing longitude
      real, intent(in) ::  dp(i1:i2,km)       ! grid size
      real, intent(in) ::  dq(i1:i2,km)       ! backward diff of q
      real, intent(in) ::  d4(i1:i2,km)       ! backward sum:  dp(k)+ dp(k-1) 
      real, intent(in) :: df2(i1:i2,km)       ! first guess mismatch
      real, intent(in) ::  dm(i1:i2,km)       ! monotonic mismatch

! !INPUT/OUTPUT PARAMETERS:
      real, intent(inout) ::  a4(4,i1:i2,km)  ! first guess/steepened

!
! !DESCRIPTION:
!   This is complicated stuff related to the Piecewise Parabolic Method
!   and I need to read the Collela/Woodward paper before documenting
!   thoroughly.
!
! !REVISION HISTORY: 
!   ??.??.??    Lin?       Creation
!   01.03.26    Sawyer     Added ProTeX documentation
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer i, k
      real alfa(i1:i2,km)
      real    f(i1:i2,km)
      real  rat(i1:i2,km)
      real  dg2

! Compute ratio of dq/dp
      do k=max(2,kmap-1),km
         do i=i1,i2
            rat(i,k) = dq(i,k-1) / d4(i,k)
         enddo
      enddo

! Compute F
      do k=max(2,kmap-1),km-1
         do i=i1,i2
            f(i,k) =   (rat(i,k+1) - rat(i,k))                          &
                     / ( dp(i,k-1)+dp(i,k)+dp(i,k+1) )
         enddo
      enddo

      do k=max(3,kmap),km-2
         do i=i1,i2
         if(f(i,k+1)*f(i,k-1)<0. .and. df2(i,k)/=0.) then
            dg2 = (f(i,k+1)-f(i,k-1))*((dp(i,k+1)-dp(i,k-1))**2          &
                   + d4(i,k)*d4(i,k+1) )
            alfa(i,k) = max(0., min(0.5, -0.1875*dg2/df2(i,k))) 
         else
            alfa(i,k) = 0.
         endif
         enddo
      enddo

      do k=max(4,kmap+1),km-2
         do i=i1,i2
            a4(2,i,k) = (1.-alfa(i,k-1)-alfa(i,k)) * a4(2,i,k) +         &
                        alfa(i,k-1)*(a4(1,i,k)-dm(i,k))    +             &
                        alfa(i,k)*(a4(1,i,k-1)+dm(i,k-1))
         enddo
      enddo

!EOC
 end subroutine steepz_sak
!----------------------------------------------------------------------- 

end module cloud_generator_mod

module fill_module
!-----------------------------------------------------------------------
!BOP
!
     implicit none
! !MODULE: fill_module --- utilities for filling in nagative values
!
! !PUBLIC MEMBER FUNCTIONS:
      public filew, fillxy, fillz, pfix

!
! !DESCRIPTION:
!
! !REVISION HISTORY:
!   99.03.01   Lin        Creation
!   01.02.14   Lin        Routines coalesced into this module
!   01.03.26   Sawyer     Added ProTeX documentation
!
!EOP
!-----------------------------------------------------------------------

contains

!-----------------------------------------------------------------------
!BOP
! !IROUTINE: fillxy --- Fill from east, west, north and south neighbors
!
! !INTERFACE: 
 subroutine fillxy(q, im, jm, jfirst, jlast, acap, cosp, acosp)

 integer, intent(in):: im           ! Longitudes
 integer, intent(in):: jm           ! Total latitudes
 integer, intent(in):: jfirst       ! Starting latitude
 integer, intent(in):: jlast        ! Finishing latitude

 real , intent(in):: acap 
 real , intent(in):: cosp(jm)
 real , intent(in):: acosp(jm) 
 
 real , intent(inout):: q(im,jfirst:jlast) ! Field to adjust

!
! LOCAL VARIABLES:
  integer ipx, i,j
  real :: tiny = 1.e-40

  call filew(q,im,jm,jfirst,jlast,acap,ipx,tiny, cosp(2), cosp(3))

!  if(ipx.ne.0) then
! Fill zonally
!     call xfix(q,IM,JM,tiny,qt)
!  endif

!EOC
 end subroutine fillxy

!-----------------------------------------------------------------------
!BOP
! !IROUTINE: filew --- Fill from east and west neighbors; essentially
!                      performing local flux adjustment
!
! !INTERFACE: 
 subroutine filew(q, im, jm, jfirst, jlast, acap, ipx, tiny, cosp2, cosp3)

! !INPUT PARAMETERS:
 integer im                  ! Longitudes
 integer jm                  ! Total latitudes
 integer jfirst              ! Starting latitude
 integer jlast               ! Finishing latitude

 real  tiny               ! A small number to pump up value
 real  acap               ! 1/(polar cap area)
 real  cosp2              ! cosine(lat) at j=2
 real  cosp3              ! cosine(lat) at j=3

! !INPUT/OUTPUT PARAMETERS:
 real  q(im,jfirst:jlast) ! Field to adjust

! !OUTPUT PARAMETERS:
 integer ipx                 ! Flag:  0 if Q not change, 1 if changed

! !DESCRIPTION:
!   Check for "bad" data and fill from east and west neighbors
!
! !REVISION HISTORY:
!   99.10.01   Lin        Creation
!   07.30.01   Lin        Improvement
!
!EOP
!-----------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
 real  d0, d1, d2
 real  qtmp(jfirst:jlast,im)

 integer i, j, jm1, ip2
 integer j1, j2

 jm1 = jm-1
 j1 = max( jfirst,  2 )
 j2 = min( jlast, jm1 )

  ipx = 0
  do j=jfirst,jlast
     do i=1,im
        if( q(i,j) < 0. ) then
            ipx = 1
            go to 444
        endif
     enddo
  enddo

  if ( ipx == 0 ) return

! Copy & swap direction for vectorization.
444   do i=1,im
         do j=j1,j2
            qtmp(j,i) = q(i,j)
         enddo
      enddo

 
  do i=2,im-1
     do j=j1,j2
        if(qtmp(j,i) < 0.) then
! west
           d0 = max(0.,qtmp(j,i-1))
           d1 = min(-qtmp(j,i),d0)
           qtmp(j,i-1) = qtmp(j,i-1) - d1
           qtmp(j,i) = qtmp(j,i) + d1
! east
           d0 = max(0.,qtmp(j,i+1))
           d2 = min(-qtmp(j,i),d0)
           qtmp(j,i+1) = qtmp(j,i+1) - d2
           qtmp(j,i) = qtmp(j,i) + d2 + tiny
        endif
    enddo
  enddo
 
     i=1
  do j=j1,j2
     if(qtmp(j,i) < 0.) then
! west
        d0 = max(0.,qtmp(j,im))
        d1 = min(-qtmp(j,i),d0)
        qtmp(j,im) = qtmp(j,im) - d1
        qtmp(j,i) = qtmp(j,i) + d1
! east
        d0 = max(0.,qtmp(j,i+1))
        d2 = min(-qtmp(j,i),d0)
        qtmp(j,i+1) = qtmp(j,i+1) - d2
        qtmp(j,i) = qtmp(j,i) + d2 + tiny
      endif
  enddo

     i=im
  do j=j1,j2
     if(qtmp(j,i) < 0.) then
! west
        d0 = max(0.,qtmp(j,i-1))
        d1 = min(-qtmp(j,i),d0)
        qtmp(j,i-1) = qtmp(j,i-1) - d1
        qtmp(j,i) = qtmp(j,i) + d1
! east
        d0 = max(0.,qtmp(j,1))
        d2 = min(-qtmp(j,i),d0)
        qtmp(j,1) = qtmp(j,1) - d2
        qtmp(j,i) = qtmp(j,i) + d2 + tiny
     endif
  enddo

!-----------
! Final pass
!-----------
    do i=1,im-1
       do j=j1,j2
          if (qtmp(j,i) < 0. ) then
! Take mass from east (essentially adjusting fx(i+1,j))
              qtmp(j,i+1) = qtmp(j,i+1) + qtmp(j,i)
              qtmp(j,i) = 0.
          endif
       enddo
    enddo

    do i=im,2,-1
       do j=j1,j2
          if (qtmp(j,i) < 0. ) then
! Take mass from west (essentially adjusting fx(i,j))
              qtmp(j,i-1) = qtmp(j,i-1) + qtmp(j,i)
              qtmp(j,i) = 0.
          endif
       enddo
    enddo

    do j=j1,j2
       do i=1,im
          q(i,j) = qtmp(j,i)
       enddo
    enddo
 
! Check Poles.

 if ( jfirst == 1 ) then
      ip2 = 0
      if(q(1,1) < 0.) then
         call pfix(q(1,2),q(1,1),im,ipx,acap,cosp2)
      else
! Check the latitude next to the SP
         do i=1,im
            if(q(i,2) < 0.) then
               ip2 = 1
               go to 322
            endif
         enddo
322      continue
         if(ip2.ne.0) call pfix(q(1,2),q(1,1),im,ipx,acap,cosp2)
      endif
 endif
 
 if ( jlast == jm ) then
      if(q(1,jm) < 0.) then
         call pfix(q(1,jm1),q(1,jm),im,ipx,acap,cosp2)
      else
! Check the latitude next to the NP
              ip2 = 0
         do i=1,im
            if(q(i,jm1) < 0.) then
               ip2 = 1
               go to 323
            endif
         enddo
323      continue
         if(ip2.ne.0) call pfix(q(1,jm1),q(1,jm),im,ipx,acap,cosp2)
      endif
 endif

!EOC
 end subroutine filew
!-----------------------------------------------------------------------



!-----------------------------------------------------------------------
!BOP
! !IROUTINE: fillz --- Fill from neighbors below and above
!
! !INTERFACE: 
 subroutine fillz(im, km, nq, q, dp)

! !INPUT PARAMETERS:
   integer,  intent(in):: im                ! No. of longitudes
   integer,  intent(in):: km                ! No. of levels
   integer,  intent(in):: nq                ! Total number of tracers

   real , intent(in)::  dp(im,km)       ! pressure thickness
! !INPUT/OUTPUT PARAMETERS:
   real , intent(inout) :: q(im,km,nq)   ! tracer mixing ratio

! !DESCRIPTION:
!   Check for "bad" data and fill from east and west neighbors
!
! !BUGS:
!   Currently this routine only performs the east-west fill algorithm.
!   This is because the N-S fill is very hard to do in a reproducible
!   fashion when the problem is decomposed by latitudes.
!
! !REVISION HISTORY:
!   00.04.01   Lin        Creation
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
   integer i, k, ic
   real  qup, qly, dup

   do ic=1,nq
! Top layer
      do i=1,im
         if( q(i,1,ic) < 0.) then
             q(i,2,ic) = q(i,2,ic) + q(i,1,ic)*dp(i,1)/dp(i,2)
             q(i,1,ic) = 0.
          endif
      enddo

! Interior
      do k=2,km-1
         do i=1,im
         if( q(i,k,ic) < 0. ) then
! Borrow from above
             qup =  q(i,k-1,ic)*dp(i,k-1)
             qly = -q(i,k  ,ic)*dp(i,k  )
             dup =  min( 0.75*qly, qup )        !borrow no more than 75% from top
             q(i,k-1,ic) = q(i,k-1,ic) - dup/dp(i,k-1) 
! Borrow from below: q(i,k,ic) is still negative at this stage
             q(i,k+1,ic) = q(i,k+1,ic) + (dup-qly)/dp(i,k+1) 
             q(i,k  ,ic) = 0.
          endif
          enddo
      enddo
 
! Bottom layer
      k = km
      do i=1,im
         if( q(i,k,ic) < 0.) then
! Borrow from above
             qup =  q(i,k-1,ic)*dp(i,k-1)
             qly = -q(i,k  ,ic)*dp(i,k  )
             dup =  min( qly, qup )
             q(i,k-1,ic) = q(i,k-1,ic) - dup/dp(i,k-1) 
             q(i,k,ic) = 0.
          endif
      enddo
   enddo
end subroutine fillz
!-----------------------------------------------------------------------


!-----------------------------------------------------------------------
!
 subroutine pfix(q, qp, im, ipx, acap, cosp2)

 integer im                  ! Longitudes
 real  acap               ! ???
 real  cosp2              ! ???

 real  q(im)              ! Latitude-level field to adjust
 real  qp(im)             ! Second latitude-level field to adjust (usually pole)

! !OUTPUT PARAMETERS:
 integer ipx                 ! Flag:  0 if Q not change, 1 if changed


! !LOCAL VARIABLES:
 integer i
 real  summ, sump, pmean
 
   summ = 0.
   sump = 0.
   do i=1,im
     summ = summ + q(i)
     sump = sump + qp(i)
   enddo
 
   sump = sump/im
   pmean = (sump*acap + summ*cosp2) / (acap + cosp2*im)
 
   do i=1,im
      q(i) = pmean
      qp(i) = pmean
   enddo
 
   if( qp(1) < 0. ) then
      ipx = 1
   endif

!EOC
 end subroutine pfix
!-----------------------------------------------------------------------

end module fill_module

MODULE shr_kind_mod

   !----------------------------------------------------------------------------
   ! precision/kind constants add data public
   !----------------------------------------------------------------------------
   public
   integer,parameter :: SHR_KIND_R8 = selected_real_kind(12) ! 8 byte real
   integer,parameter :: SHR_KIND_R4 = selected_real_kind( 6) ! 4 byte real
   integer,parameter :: SHR_KIND_RN = kind(1.0)              ! native real
   integer,parameter :: SHR_KIND_I8 = selected_int_kind (13) ! 8 byte integer
   integer,parameter :: SHR_KIND_I4 = selected_int_kind ( 6) ! 4 byte integer
   integer,parameter :: SHR_KIND_IN = kind(1)                ! native integer

END MODULE shr_kind_mod

module land_tile_mod

use fms_mod, only : error_mesg, FATAL

use land_constants_mod, only : NBANDS
use glac_tile_mod, only : &
     glac_tile_type, new_glac_tile, delete_glac_tile, glac_is_selected, &
     glac_tiles_can_be_merged, merge_glac_tiles, get_glac_tile_tag, &
     glac_tile_stock_pe, glac_tile_heat
use lake_tile_mod, only : &
     lake_tile_type, new_lake_tile, delete_lake_tile, lake_is_selected, &
     lake_tiles_can_be_merged, merge_lake_tiles, get_lake_tile_tag, &
     lake_tile_stock_pe, lake_tile_heat
use soil_tile_mod, only : &
     soil_tile_type, new_soil_tile, delete_soil_tile, soil_is_selected, &
     soil_tiles_can_be_merged, merge_soil_tiles, get_soil_tile_tag, &
     soil_tile_stock_pe, soil_tile_carbon, soil_tile_heat
use cana_tile_mod, only : &
     cana_tile_type, new_cana_tile, delete_cana_tile, cana_is_selected, &
     cana_tiles_can_be_merged, merge_cana_tiles, get_cana_tile_tag, &
     cana_tile_stock_pe, cana_tile_carbon, cana_tile_heat
use vegn_tile_mod, only : &
     vegn_tile_type, new_vegn_tile, delete_vegn_tile, vegn_is_selected, &
     vegn_tiles_can_be_merged, merge_vegn_tiles, get_vegn_tile_tag, &
     vegn_tile_stock_pe, vegn_tile_carbon, vegn_tile_heat
use snow_tile_mod, only : &
     snow_tile_type, new_snow_tile, delete_snow_tile, snow_is_selected, &
     snow_tiles_can_be_merged, merge_snow_tiles, get_snow_tile_tag, &
     snow_tile_stock_pe, snow_tile_heat
use land_tile_selectors_mod, only : tile_selector_type, &
     SEL_SOIL, SEL_VEGN, SEL_LAKE, SEL_GLAC, SEL_SNOW, SEL_CANA
use tile_diag_buff_mod, only : &
     diag_buff_type, new_diag_buff, delete_diag_buff

implicit none
private
! ==== public interfaces =====================================================
public :: land_tile_type
public :: land_tile_list_type
public :: land_tile_enum_type
public :: diag_buff_type

! operations with tile
public :: new_land_tile, delete_land_tile
public :: land_tiles_can_be_merged, merge_land_tiles

public :: get_tile_tags ! returns the tags of the sub-model tiles
public :: get_tile_water ! returns liquid and frozen water masses
public :: land_tile_carbon ! returns total carbon in the tile
public :: land_tile_heat ! returns tile heat content

! operations with tile lists and tile list enumerators
public :: land_tile_list_init, land_tile_list_end
public :: first_elmt, tail_elmt
public :: operator(==), operator(/=) ! comparison of two enumerators
public :: next_elmt, prev_elmt ! enumerator advance operations
public :: current_tile ! returns pointer to the tile at a position
public :: insert  ! inserts a tile at a given position, or appends it to a list
public :: erase   ! erases tile at current position
public :: remove  ! removes tile at current position, but does not delete it
public :: get_elmt_indices ! returns i,j,k of current element

public :: empty   ! returns true if the list of tiles is empty
public :: nitems  ! count of items in list

public :: tile_is_selected

public :: print_land_tile_info
public :: print_land_tile_statistics
! ==== end of public interfaces ==============================================
interface new_land_tile
   module procedure land_tile_ctor
   module procedure land_tile_copy_ctor
end interface

interface first_elmt
   module procedure land_tile_list_begin_0d
   module procedure land_tile_list_begin_2d
end interface
interface tail_elmt
   module procedure land_tile_list_end_0d
   module procedure land_tile_list_end_2d
end interface

interface operator(==)
   module procedure enums_are_equal
end interface
interface operator(/=)
   module procedure enums_are_not_equal
end interface

interface insert
   module procedure insert_at_position, insert_in_list
end interface
interface remove
   module procedure remove_at_position, remove_all_from_list
end interface
interface erase
   module procedure erase_at_position, erase_all_from_list
end interface
interface nitems
   module procedure n_items_in_list
end interface


! ==== module constants ======================================================
character(len=*), parameter :: &
     version = '$Id: land_tile.F90,v 20.0 2013/12/13 23:29:28 fms Exp $', &
     tagname = '$Name: tikal $'

! ==== data types ============================================================
! land_tile_type describes the structure of the land model tile; basically
! it is a container for tile-specific data, plus some information common to 
! all of them: fraction of tile area, etc.
type :: land_tile_type
   integer :: tag = 0   ! defines type of the tile 

   real    :: frac      ! fractional tile area, dimensionless
   type(glac_tile_type), pointer :: glac => NULL() ! glacier model data
   type(lake_tile_type), pointer :: lake => NULL() ! lake model data
   type(soil_tile_type), pointer :: soil => NULL() ! soil model data
   type(snow_tile_type), pointer :: snow => NULL() ! snow data
   type(cana_tile_type), pointer :: cana => NULL() ! canopy air data
   type(vegn_tile_type), pointer :: vegn => NULL() ! vegetation model data

   type(diag_buff_type), pointer :: diag => NULL() ! diagnostic data storage
   
   ! data that are carried over from the previous time step
   real :: Sg_dir(NBANDS), Sg_dif(NBANDS) ! fractions of downward direct and 
       ! diffuse short-wave radiation absorbed by ground and snow
   real :: Sv_dir(NBANDS), Sv_dif(NBANDS) ! fractions of downward direct and 
       ! diffuse radiation absorbed by the vegetation.
   real :: land_refl_dir(NBANDS), land_refl_dif(NBANDS)
   
   real :: land_d, land_z0m, land_z0s
   real :: surf_refl_lw ! long-wave reflectivity of the ground surface (possibly snow-covered)
   real :: vegn_refl_lw ! black background long-wave reflectivity of the vegetation canopy
   real :: vegn_tran_lw ! black background long-wave transmissivity of the vegetation canopy

   real :: lwup     = 200.0  ! upward long-wave flux from the entire land (W/m2), the result of
           ! the implicit time step -- used in update_bc_fast to return to the flux exchange.
   real :: e_res_1  = 0.0 ! energy residual in canopy air EB equation
   real :: e_res_2  = 0.0 ! energy residual in canopy EB equation
   real :: runon_l  = 0.0 ! water discharged by rivers into the tile, kg/(m2 s)
   real :: runon_s  = 0.0 ! snow discharged by rivers into the tile, kg/(m2 s)
   real :: runon_H  = 0.0 ! heat carried by water discharged by rivers into the tile, W/m2
   real :: runon_Hl  = 0.0 ! heat carried by water discharged by rivers into the tile, W/m2
   real :: runon_Hs  = 0.0 ! heat carried by water discharged by rivers into the tile, W/m2
end type land_tile_type

! tile_list_type provides a container for the tiles
type :: land_tile_list_type
   private
   type(land_tile_list_node_type), pointer :: head => NULL()
end type land_tile_list_type

! land_tile_enum_type provides a enumerator of tiles -- a data structure
! that allows to walk through all tiles in a container (or a 2D array of 
! containers) without bothering with details of container implementation
type :: land_tile_enum_type
   private
   type(land_tile_list_type), pointer :: &
        tiles(:,:) => NULL()  ! pointer to array of tiles to walk -- may be disassociated
   integer :: i=0,j=0 ! indices in the above array
   integer :: k=0     ! number of the current tile in its container
   integer :: io,jo   ! offsets of indices (to keep track of non-1 ubounds of tiles array)
   type(land_tile_list_node_type), pointer :: node => NULL() ! pointer to the current container node
end type land_tile_enum_type

! private type -- used internally to implement tile lists
type :: land_tile_list_node_type
   type(land_tile_list_node_type), pointer :: prev => NULL()
   type(land_tile_list_node_type), pointer :: next => NULL()
   type(land_tile_type), pointer :: data => NULL()
end type land_tile_list_node_type

! ==== module data ===========================================================
integer :: n_created_land_tiles = 0 ! total number of created tiles
integer :: n_deleted_land_tiles = 0 ! total number of deleted tiles


contains 

! #### land_tile_type and operations #########################################

! ============================================================================
! tile constructor: given a list of sub-model tile tags, creates a land tile
! calls sub-tile constructors from individual component models
function land_tile_ctor(frac,glac,lake,soil,vegn,tag) result(tile)
  real   , optional, intent(in) :: frac ! fractional area of tile
  integer, optional, intent(in) :: &
               glac,lake,soil,vegn ! kinds of respective tiles
  integer, optional, intent(in) :: tag  ! general tile tag
  type(land_tile_type), pointer :: tile ! return value

  ! ---- local vars
  integer :: glac_, lake_, soil_, vegn_
  
  ! initialize internal variables
  glac_ = -1 ; if(present(glac)) glac_ = glac
  lake_ = -1 ; if(present(lake)) lake_ = lake
  soil_ = -1 ; if(present(soil)) soil_ = soil
  vegn_ = -1 ; if(present(vegn)) vegn_ = vegn
  
  allocate(tile)
  ! fill common fields
  tile%frac = 0.0 ; if(present(frac)) tile%frac = frac
  tile%tag  = 0   ; if(present(tag))  tile%tag  = tag

  ! create sub-model tiles
  tile%cana => new_cana_tile()
  if(glac_>=0) tile%glac => new_glac_tile(glac_)
  if(lake_>=0) tile%lake => new_lake_tile(lake_)
  tile%snow => new_snow_tile()
  if(soil_>=0) tile%soil => new_soil_tile(soil_)
  if(vegn_>=0) tile%vegn => new_vegn_tile(vegn_)

  ! create a buffer for diagnostic output
  tile%diag=>new_diag_buff()

  ! increment total number of created files for tile statistics
  n_created_land_tiles = n_created_land_tiles + 1

end function land_tile_ctor


! ============================================================================
function land_tile_copy_ctor(t) result(tile)
  type(land_tile_type), intent(in) :: t    ! tile to copy
  type(land_tile_type), pointer :: tile ! return value

  allocate(tile)
  tile = t ! copy all non-pointer members
  if (associated(t%glac)) tile%glac=>new_glac_tile(t%glac)
  if (associated(t%lake)) tile%lake=>new_lake_tile(t%lake)
  if (associated(t%soil)) tile%soil=>new_soil_tile(t%soil)
  if (associated(t%snow)) tile%snow=>new_snow_tile(t%snow)
  if (associated(t%cana)) tile%cana=>new_cana_tile(t%cana)
  if (associated(t%vegn)) tile%vegn=>new_vegn_tile(t%vegn)

  if (associated(t%diag)) tile%diag=>new_diag_buff(t%diag)
end function land_tile_copy_ctor


! ============================================================================
! tile destructor -- releases memory occupied by the tile;
! calls sub-model tile destructors to free the memory of the components
subroutine delete_land_tile(tile)
  type(land_tile_type), pointer :: tile ! tile to delete

  if (.not.associated(tile)) return

  if (associated(tile%glac)) call delete_glac_tile(tile%glac)
  if (associated(tile%lake)) call delete_lake_tile(tile%lake)
  if (associated(tile%soil)) call delete_soil_tile(tile%soil)
  if (associated(tile%snow)) call delete_snow_tile(tile%snow)
  if (associated(tile%cana)) call delete_cana_tile(tile%cana)
  if (associated(tile%vegn)) call delete_vegn_tile(tile%vegn)
  
  ! deallocate diagnostic storage
  call delete_diag_buff(tile%diag)

  ! release the tile memory
  deallocate(tile)
  
  ! increment the number of deleted files for tile statistics
  n_deleted_land_tiles = n_deleted_land_tiles + 1

end subroutine delete_land_tile


! ============================================================================
! returns tags of the component model tiles
subroutine get_tile_tags(tile,land,glac,lake,soil,snow,cana,vegn)
   type(land_tile_type), intent(in)  :: tile
   integer, optional,    intent(out) :: land,glac,lake,soil,snow,cana,vegn

   if(present(land)) land=tile%tag
   if(present(glac)) then
      glac=-HUGE(glac)
      if (associated(tile%glac)) glac=get_glac_tile_tag(tile%glac)
   endif
   if(present(lake)) then
      lake=-HUGE(lake)
      if (associated(tile%lake)) lake=get_lake_tile_tag(tile%lake)
   endif
   if(present(soil)) then
      soil=-HUGE(soil)
      if (associated(tile%soil)) soil=get_soil_tile_tag(tile%soil)
   endif
   if(present(snow)) then
      snow=-HUGE(snow)
      if (associated(tile%snow)) snow=get_snow_tile_tag(tile%snow)
   endif
   if(present(cana)) then
      cana=-HUGE(cana)
      if (associated(tile%cana)) cana=get_cana_tile_tag(tile%cana)
   endif
   if(present(vegn)) then
      vegn=-HUGE(vegn)
      if (associated(tile%vegn)) vegn=get_vegn_tile_tag(tile%vegn)
   endif
end subroutine


! ============================================================================
! returns totals water and ice masses associated with tile
subroutine get_tile_water(tile, lmass, fmass)
  type(land_tile_type), intent(in) :: tile
  real, intent(out) :: lmass, fmass ! liquid and solid water masses, kg/m2

  ! ---- local vars
  real :: lm, fm

  lmass = 0; fmass = 0
  if (associated(tile%cana)) then
     call cana_tile_stock_pe(tile%cana, lm, fm)
     lmass = lmass+lm ; fmass = fmass + fm
  endif
  if (associated(tile%glac)) then
     call glac_tile_stock_pe(tile%glac, lm, fm)
     lmass = lmass+lm ; fmass = fmass + fm
  endif
  if (associated(tile%lake)) then
     call lake_tile_stock_pe(tile%lake, lm, fm)
     lmass = lmass+lm ; fmass = fmass + fm
  endif
  if (associated(tile%soil)) then
     call soil_tile_stock_pe(tile%soil, lm, fm)
     lmass = lmass+lm ; fmass = fmass + fm
  endif
  if (associated(tile%snow)) then
     call snow_tile_stock_pe(tile%snow, lm, fm)
     lmass = lmass+lm ; fmass = fmass + fm
  endif
  if (associated(tile%vegn)) then
     call vegn_tile_stock_pe(tile%vegn, lm, fm)
     lmass = lmass+lm ; fmass = fmass + fm
  endif

end subroutine


! ============================================================================
! returns total tile carbon, kg C/m2
function land_tile_carbon(tile) result(carbon) ; real carbon
  type(land_tile_type), intent(in) :: tile

  carbon = 0
  if (associated(tile%cana)) &
     carbon = carbon + cana_tile_carbon(tile%cana)
  if (associated(tile%vegn)) &
     carbon = carbon + vegn_tile_carbon(tile%vegn)
  if (associated(tile%soil)) &
     carbon = carbon + soil_tile_carbon(tile%soil)
end function 


! ============================================================================
! returns total heat content of the tile
function land_tile_heat(tile) result(heat) ; real heat
  type(land_tile_type), intent(in) :: tile

  heat = 0
  if (associated(tile%cana)) &
       heat = heat+cana_tile_heat(tile%cana)
  if (associated(tile%glac)) &
       heat = heat+glac_tile_heat(tile%glac)
  if (associated(tile%lake)) &
       heat = heat+lake_tile_heat(tile%lake)
  if (associated(tile%soil)) &
       heat = heat+soil_tile_heat(tile%soil)
  if (associated(tile%snow)) &
       heat = heat+snow_tile_heat(tile%snow)
  if (associated(tile%vegn)) &
       heat = heat+vegn_tile_heat(tile%vegn)
end function


! ============================================================================
! returns true if two land tiles can be merged 
function land_tiles_can_be_merged(tile1,tile2) result (answer)
   logical :: answer ! returned value
   type(land_tile_type), intent(in) :: tile1, tile2
   
   ! make sure that the two tiles have the same components. For 
   ! uniformity every component is checked, even though snow and
   ! cana are always present in current design
   answer = (associated(tile1%glac).eqv.associated(tile2%glac)).and. &
            (associated(tile1%lake).eqv.associated(tile2%lake)).and. &
            (associated(tile1%soil).eqv.associated(tile2%soil)).and. &
            (associated(tile1%snow).eqv.associated(tile2%snow)).and. &
            (associated(tile1%cana).eqv.associated(tile2%cana)).and. &
            (associated(tile1%vegn).eqv.associated(tile2%vegn))
     
   if (answer.and.associated(tile1%glac)) &
      answer = answer.and.glac_tiles_can_be_merged(tile1%glac,tile2%glac)
   if (answer.and.associated(tile1%lake)) &
      answer = answer.and.lake_tiles_can_be_merged(tile1%lake,tile2%lake)
   if (answer.and.associated(tile1%soil)) &
      answer = answer.and.soil_tiles_can_be_merged(tile1%soil,tile2%soil)
   if (answer.and.associated(tile1%cana)) &
      answer = answer.and.cana_tiles_can_be_merged(tile1%cana,tile2%cana)
   if (answer.and.associated(tile1%snow)) &
      answer = answer.and.snow_tiles_can_be_merged(tile1%snow,tile2%snow)
   if (answer.and.associated(tile1%vegn)) &
      answer = answer.and.vegn_tiles_can_be_merged(tile1%vegn,tile2%vegn)
   
end function

! ============================================================================
! merges the two tiles, putting merged state into the second tile. The first
! tile is unchanged
subroutine merge_land_tiles(tile1,tile2)
  type(land_tile_type), intent(in)    :: tile1
  type(land_tile_type), intent(inout) :: tile2

  ! ---- local vars
  real :: x1,x2

  if(associated(tile1%glac)) &
       call merge_glac_tiles(tile1%glac, tile1%frac, tile2%glac, tile2%frac)
  if(associated(tile1%lake)) &
       call merge_lake_tiles(tile1%lake, tile1%frac, tile2%lake, tile2%frac)
  if(associated(tile1%soil)) &
       call merge_soil_tiles(tile1%soil, tile1%frac, tile2%soil, tile2%frac)
  
  if(associated(tile1%cana)) &
       call merge_cana_tiles(tile1%cana, tile1%frac, tile2%cana, tile2%frac)
  if(associated(tile1%snow)) &
       call merge_snow_tiles(tile1%snow, tile1%frac, tile2%snow, tile2%frac)

  if(associated(tile1%vegn)) &
       call merge_vegn_tiles(tile1%vegn, tile1%frac, tile2%vegn, tile2%frac)

  ! calculate normalized weights
  x1 = tile1%frac/(tile1%frac+tile2%frac)
  x2 = 1.0 - x1

#define __MERGE__(field) tile2%field = x1*tile1%field + x2*tile2%field
  __MERGE__(lwup)
  __MERGE__(e_res_1)
  __MERGE__(e_res_2)
  __MERGE__(runon_l)
  __MERGE__(runon_s)
  __MERGE__(runon_H)
  __MERGE__(runon_Hl)
  __MERGE__(runon_Hs)
#undef __MERGE__

  tile2%frac = tile1%frac + tile2%frac
end subroutine

! #### tile container ########################################################

! ============================================================================
! tile list constructor: initializes essential innards of tile collection
! for future use. In current implementation, it is safe to call this function
! on a tile list more then once
subroutine land_tile_list_init(list)
  type(land_tile_list_type), intent(inout) :: list

  if (.not.associated(list%head)) then
     allocate(list%head)
     list%head%prev=>list%head
     list%head%next=>list%head
  endif
end subroutine land_tile_list_init

! ============================================================================
! tile list destructor: destroys the list of tiles. NOTE that it also destroys
! all the tiles that are still in the list.
subroutine land_tile_list_end(list)
  type(land_tile_list_type), intent(inout) :: list

  if(associated(list%head)) then
     call erase(list)
     deallocate(list%head)
  endif
end subroutine land_tile_list_end

! ============================================================================
subroutine check_tile_list_inited(list)
  type(land_tile_list_type), intent(in) :: list

  if (.not.associated(list%head)) &
     call error_mesg('land_tile_mod','tile container was not initialized before use', FATAL)
     
end subroutine


! ============================================================================
! returns true is the list is empty
function empty(list)
  logical empty
  type(land_tile_list_type), intent(in) :: list

  empty = .not.associated(list%head)
  if (.not.empty) &
       empty = associated(list%head%next,list%head)

end function empty

! ============================================================================
! returns the number of items currently stored in the list
function n_items_in_list(list) result (n)
  type(land_tile_list_type), intent(in) :: list
  integer :: n

  type(land_tile_list_node_type), pointer :: node

  n=0; 
  if(.not.associated(list%head)) return

  node => list%head%next
  do while ( .not.(associated(node,list%head)) )
     n = n+1
     node => node%next
  enddo
end function n_items_in_list

! ============================================================================
subroutine insert_in_list(tile,list)
  type(land_tile_type),           pointer :: tile
  type(land_tile_list_type), intent(inout) :: list

  call insert_at_position(tile,tail_elmt(list))

end subroutine insert_in_list


! ============================================================================
subroutine remove_all_from_list(list)
  type(land_tile_list_type), intent(inout) :: list
  
  type(land_tile_enum_type) :: ce
  ce=first_elmt(list)
  do while(ce/=tail_elmt(list))
     call remove_at_position(ce)
  enddo
end subroutine remove_all_from_list


! ============================================================================
subroutine erase_all_from_list(list)
  type(land_tile_list_type), intent(inout) :: list
  
  type(land_tile_enum_type) :: ce
  ce=first_elmt(list)
  do while(ce/=tail_elmt(list))
     call erase_at_position(ce)
  enddo
end subroutine erase_all_from_list



! #### tile container enumerator #############################################

! ============================================================================
! returns enumerator pointing to the first element of the container
function land_tile_list_begin_0d(list) result(ce)
  type(land_tile_enum_type) :: ce  ! return value
  type(land_tile_list_type), intent(in) :: list

  call check_tile_list_inited(list)
  ce%node=>list%head%next
  ce%i = 1 ; ce%j = 1 ; ce%k = 1 
end function


! ============================================================================
! returns enumerator pointing to the first element of the 2D array of 
! containers 
function land_tile_list_begin_2d(tiles, is, js) result(ce)
  type(land_tile_enum_type) :: ce  ! return value
  type(land_tile_list_type), intent(in), target :: tiles(:,:)
  integer, intent(in), optional :: is,js ! origin of the array
  
  integer :: i,j

  ! list up pointer to the array of containers
  ce%tiles=>tiles

  ! initialize offsets of indices
  ce%io = 0; ce%jo = 0;
  if(present(is)) ce%io = is-lbound(tiles,1)
  if(present(js)) ce%jo = js-lbound(tiles,2)

  ! initialize current position in the array of containers -- find
  ! first non-empty container and list the pointer to the current
  ! container node
  ce%k = 1
  do j = lbound(tiles,2),ubound(tiles,2)
  do i = lbound(tiles,1),ubound(tiles,1)
     call check_tile_list_inited(tiles(i,j))
     ce%node => tiles(i,j)%head%next
     ce%i = i ; ce%j = j
     if(associated(ce%node%data)) return
  enddo
  enddo
end function


! ============================================================================
! returns enumerator pointing to the end of container: actually the next element 
! behind the last element of the container
function land_tile_list_end_0d(list) result (ce)
  type(land_tile_enum_type) :: ce ! return value
  type(land_tile_list_type), intent(in) :: list
  
  call check_tile_list_inited(list)
  ce%node=>list%head
  ce%i = 1 ; ce%j = 1 ; ce%k = nitems(list)+1
end function


! ============================================================================
! returns enumerator pointing to the end of 2D array of containers: actually 
! the next element behind the last element of the last container
function land_tile_list_end_2d(tiles,is,js) result (ce)
  type(land_tile_enum_type) :: ce ! return value
  type(land_tile_list_type), intent(in), target :: tiles(:,:)
  integer, intent(in), optional :: is,js ! lower boundaries of the array

  ! list up pointer to the array of containers
  ce%tiles=>tiles

  ! initialize offsets of indices
  ce%io = 0; ce%jo = 0;
  if(present(is)) ce%io = is-lbound(tiles,1)
  if(present(js)) ce%jo = js-lbound(tiles,2)

  ! initialize current position in the array of containers 
  ce%i = ubound(tiles,1)
  ce%j = ubound(tiles,2)
  ce%k = nitems(tiles(ce%i,ce%j))+1

  ! list the pointer to the current tile
  call check_tile_list_inited(tiles(ce%i,ce%j))
  ce%node=>tiles(ce%i,ce%j)%head

end function


! ============================================================================
! returns enumerator pointing to the next element of the container.
function next_elmt(pos0) result(ce)
  type(land_tile_enum_type) :: ce ! return value
  type(land_tile_enum_type), intent(in) :: pos0

  integer :: is,ie,js,je

  ce = pos0
  ce%node => ce%node%next ; ce%k = ce%k+1
  if(associated(ce%tiles)) then
     is = lbound(ce%tiles,1); ie = ubound(ce%tiles,1)
     js = lbound(ce%tiles,2); je = ubound(ce%tiles,2)
     do while(.not.associated(ce%node%data))
        ce%k = 1; ! reset tile index
        if(ce%i<ie)then
           ce%i = ce%i+1
        else if(ce%j<je) then
           ce%i = is
           ce%j = ce%j + 1
        else
           return
        endif
        call check_tile_list_inited(ce%tiles(ce%i,ce%j))
        ce%node => ce%tiles(ce%i,ce%j)%head%next
     enddo
  endif
end function


! ============================================================================
! returns enumerator pointing to the previous element of the container.
function prev_elmt(pos0) result(ce)
  type(land_tile_enum_type) :: ce ! return value
  type(land_tile_enum_type), intent(in) :: pos0

  integer :: is,ie,js,je

  ce = pos0
  ce%node => ce%node%prev ; ce%k = ce%k - 1
  if(associated(ce%tiles)) then
     is = lbound(ce%tiles,1); ie = ubound(ce%tiles,1)
     js = lbound(ce%tiles,2); je = ubound(ce%tiles,2)
     do while(.not.associated(ce%node%data))
        ce%k = 1; ! reset tile index
        if(ce%i>is)then
           ce%i = ce%i - 1
        else if(ce%j>js) then
           ce%i = ie
           ce%j = ce%j - 1
        else
           return
        endif
        call check_tile_list_inited(ce%tiles(ce%i,ce%j))
        ce%node => ce%tiles(ce%i,ce%j)%head%prev
        ce%k    =  nitems(ce%tiles(ce%i,ce%j))
     enddo
  endif

end function

! ============================================================================
! returns TRUE if both enums refer to the same list node (and, therefore, tile)
! or if both do not refer to anything. 
function enums_are_equal(pos1,pos2) result(ret)
  logical :: ret ! return value
  type(land_tile_enum_type), intent(in) :: pos1,pos2
  
  if(associated(pos1%node)) then
     ret = associated(pos1%node,pos2%node)
  else
     ret = .not.associated(pos2%node)
  endif
end function enums_are_equal

! ============================================================================
! returns TRUE if two enumerators are not equal
function enums_are_not_equal(pos1,pos2) result(ret)
  logical :: ret ! return value
  type(land_tile_enum_type), intent(in) :: pos1,pos2

  ret=.not.enums_are_equal(pos1,pos2)
end function enums_are_not_equal

! ============================================================================
! returns pointer to the tile currently addressed by the enumerator
function current_tile(ce) result(ptr)
  type(land_tile_type), pointer :: ptr ! return value
  type(land_tile_enum_type), intent(in) :: ce 

  ptr => ce%node%data
end function 

! ============================================================================
! returns indices corresponding to the enumerator; for enumerator associated
! with a single tile list (not with 2D array of lists) returned i and j are 
! equal to 1
subroutine get_elmt_indices(ce,i,j,k)
  type(land_tile_enum_type), intent(in) :: ce 
  integer, intent(out), optional :: i,j,k

  if (present(i)) i = ce%i+ce%io
  if (present(j)) j = ce%j+ce%jo
  if (present(k)) k = ce%k

end subroutine

! ============================================================================
! inserts tile at the position indicated by enumerator: in fact right in front 
! of it. 
subroutine insert_at_position(tile,ce)
  type(land_tile_type),         pointer :: tile
  type(land_tile_enum_type), intent(in) :: ce

  ! local vars
  type(land_tile_list_node_type), pointer :: node,n,p

  allocate(node)
  node%data=>tile

  n=>ce%node  ; p=>n%prev

  node%next=>n ; node%prev=>p
  n%prev=>node ; p%next=>node
  
end subroutine insert_at_position

! ============================================================================
subroutine remove_at_position(enum)
  type(land_tile_enum_type), intent(inout) :: enum

  type(land_tile_list_node_type),pointer :: n,p
  type(land_tile_enum_type) :: next
  
  if(.not.associated(enum%node)) &
     call error_mesg('remove_at_position','attempt to remove tail element of a list', FATAL)

  next = next_elmt(enum)
  
  n => enum%node%next
  p => enum%node%prev

  n%prev=>p ; p%next=>n
  deallocate(enum%node)
  
  enum=next
  if(enum%k>1) enum%k = enum%k-1

end subroutine remove_at_position

! ============================================================================
subroutine erase_at_position(ce)
  type(land_tile_enum_type), intent(inout) :: ce

  type(land_tile_type), pointer :: tile

  tile=>current_tile(ce)
  call remove_at_position(ce)
  call delete_land_tile(tile)

end subroutine erase_at_position


! ============================================================================
function tile_is_selected(tile, sel)
! returns true if the tile fits specified selector
  logical :: tile_is_selected
  type(land_tile_type)    , intent(in) :: tile
  type(tile_selector_type), intent(in) :: sel

  tile_is_selected = .FALSE.
  select case(sel%tag)
  case(SEL_SOIL)
     if(associated(tile%soil)) & 
          tile_is_selected = soil_is_selected(tile%soil,sel)
  case(SEL_VEGN)
     if(associated(tile%vegn)) &
          tile_is_selected = vegn_is_selected(tile%vegn,sel)
  case(SEL_LAKE)
     if(associated(tile%lake)) &
          tile_is_selected = lake_is_selected(tile%lake,sel)
  case(SEL_GLAC)
     if(associated(tile%glac)) &
          tile_is_selected = glac_is_selected(tile%glac,sel)
  case(SEL_SNOW)
     if(associated(tile%snow)) &
          tile_is_selected = snow_is_selected(tile%snow,sel)
  case(SEL_CANA)
     if(associated(tile%cana)) &
          tile_is_selected = cana_is_selected(tile%cana,sel)
  case default
     tile_is_selected=.true.
  end select

end function tile_is_selected


! ============================================================================
subroutine print_land_tile_info(tile)
  type(land_tile_type), intent(in) :: tile
  
  write(*,'("(tag =",i3,", frac =",f7.4)',advance='no') tile%tag, tile%frac
  if(associated(tile%lake)) write(*,'(a,i3)',advance='no')', lake =',tile%lake%tag
  if(associated(tile%soil)) write(*,'(a,i3)',advance='no')', soil =',tile%soil%tag
  if(associated(tile%glac)) write(*,'(a,i3)',advance='no')', glac =',tile%glac%tag
  if(associated(tile%snow)) write(*,'(a,i3)',advance='no')', snow =',tile%snow%tag
  if(associated(tile%cana)) write(*,'(a)',advance='no')', cana'
  if(associated(tile%vegn)) write(*,'(a)',advance='no')', vegn'
  write(*,'(")")',advance='no')
  
end subroutine


! ============================================================================
subroutine print_land_tile_statistics()
  write(*,*)'Total number of created land_tiles =',n_created_land_tiles
  write(*,*)'Total number of deleted land_tiles =',n_deleted_land_tiles
end subroutine

end module land_tile_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: Update time scale ratio
!
! !INTERFACE:
   subroutine r_ratio(nlev)
!
! !DESCRIPTION:
! This routine updates the ratio $r$ of the dissipation
! time scales as defined in \eq{DefR}.
!
! !USES:
  use turbulence,  only:     tke,eps,kb,epsb
  use turbulence,  only:     r

  IMPLICIT NONE
!
! !INPUT PARAMETERS:
  integer, intent(in)        :: nlev
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: r_ratio.F90,v $
!  Revision 20.0  2013/12/14 00:13:51  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:54  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1  2005-06-27 10:54:33  kbk
!  new files needed
!
!
!EOP
!-----------------------------------------------------------------------
!BOC

!KBK   r = kb/epsb*eps/tke
   r = kb*eps/(epsb*tke)

   return
end subroutine r_ratio

!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module water_borrowing_mod

use        fms_mod, only: mpp_pe, mpp_root_pe, write_version_number, error_mesg, FATAL

use transforms_mod, only: get_grid_domain

implicit none
private

public :: water_borrowing

character(len=128), parameter :: version = '$Id: water_borrowing.F90,v 10.0 2003/10/24 22:01:01 fms Exp $'
character(len=128), parameter :: tagname = '$Name: tikal $'
logical :: entry_to_logfile_done = .false.

contains

subroutine water_borrowing(dt_qg, qg, current, p_half, delta_t)

real,    intent(inout), dimension(:,:,:) :: dt_qg
real,    intent(in),    dimension(:,:,:) :: qg
integer, intent(in)                      :: current
real,    intent(in),    dimension(:,:,:) :: p_half
real,    intent(in)                      :: delta_t

integer :: num_lon, num_lat, num_levels, ibeg, iend, inc, i, j, k, is, ie, js, je
real :: neighboring_water, total_water, ratio
real, dimension(size(qg,1), size(qg,3)) :: dp

if(.not.entry_to_logfile_done) then
  call write_version_number(version, tagname)
  entry_to_logfile_done = .true.
endif

call get_grid_domain(is, ie, js, je)
num_lon = size(qg,1); num_lat = size(qg,2); num_levels = size(qg,3)

if(is /= 1 .or. ie /= num_lon) then
  call error_mesg('water_borrowing', &
           'hole filling requires that entire latitude circle resides on same processor', FATAL)
endif

do j=1,num_lat
  dp = p_half(:,j,2:num_levels+1) - p_half(:,j,1:num_levels)
  do k=1,num_levels
    if(mod(current,2) == 0) then
      ibeg=1; iend=num_lon; inc=1
    else
      ibeg=num_lon; iend=1; inc=-1
    endif
    do i=ibeg,iend,inc
      if(qg(i,j,k) >= 0.) cycle
      if(i == 1) then
        neighboring_water = qg(num_lon,j,k)*dp(num_lon,k)
      else
        neighboring_water = qg(i-1,j,k)*dp(i-1,k)
      endif
      if(i == num_lon) then
        neighboring_water = neighboring_water + qg(1,j,k)*dp(1,k)
      else
        neighboring_water = neighboring_water + qg(i+1,j,k)*dp(i+1,k)
      endif
      if(k /= 1) then
        neighboring_water = neighboring_water + qg(i,j,k-1)*dp(i,k-1)
      endif
      if(k /= num_levels) then
        neighboring_water = neighboring_water + qg(i,j,k+1)*dp(i,k+1)
      endif
      total_water = neighboring_water + qg(i,j,k)*dp(i,k)
      if(total_water > 0.) then
        ratio = total_water/neighboring_water
        dt_qg(i,j,k) = dt_qg(i,j,k) - qg(i,j,k)/delta_t
        if(i == 1) then
          dt_qg(num_lon,j,k) = dt_qg(num_lon,j,k) + (ratio - 1)*qg(num_lon,j,k)/delta_t
        else
          dt_qg(i-1,j,k) = dt_qg(i-1,j,k) + (ratio - 1)*qg(i-1,j,k)/delta_t
        endif
        if(i == num_lon) then
          dt_qg(1,j,k)   = dt_qg(1,j,k  ) + (ratio - 1)*qg(1,j,k  )/delta_t
        else
          dt_qg(i+1,j,k) = dt_qg(i+1,j,k) + (ratio - 1)*qg(i+1,j,k)/delta_t
        endif
        if(k /= 1) then
          dt_qg(i,j,k-1) = dt_qg(i,j,k-1) + (ratio - 1)*qg(i,j,k-1)/delta_t
        endif
        if(k /= num_levels) then
          dt_qg(i,j,k+1) = dt_qg(i,j,k+1) + (ratio - 1)*qg(i,j,k+1)/delta_t
        endif
      endif
!     if(total_water < 0. .and. neighboring_water > 0.) then

!!!!!!!  Put all neighboring water into water hole and zero out neighboring water (pjp)

!       dt_qg(i,j,k) = dt_qg(i,j,k) + neighboring_water/(dp(i,k)*delta_t)
!       if(i == 1) then
!         dt_qg(num_lon,j,k) = dt_qg(num_lon,j,k) - qg(num_lon,j,k)/delta_t
!       else
!         dt_qg(i-1,j,k) = dt_qg(i-1,j,k) - qg(i-1,j,k)/delta_t
!       endif
!       if(i == num_lon) then
!         dt_qg(1,j,k)   = dt_qg(1,j,k  ) - qg(1,j,k  )/delta_t
!       else
!         dt_qg(i+1,j,k) = dt_qg(i+1,j,k) - qg(i+1,j,k)/delta_t
!       endif
!       if(k /= 1) then
!         dt_qg(i,j,k-1) = dt_qg(i,j,k-1) - qg(i,j,k-1)/delta_t
!       endif
!       if(k /= num_levels) then
!         dt_qg(i,j,k+1) = dt_qg(i,j,k+1) - qg(i,j,k+1)/delta_t
!       endif
!     endif
    enddo
  enddo
enddo

return
end subroutine water_borrowing

end module water_borrowing_mod

 subroutine par_vecsum(jm, jfirst, jlast, InVector, te0)

! !ROUTINE: par_vecsum --- Calculate vector sum bit-wise consistently

#ifdef SPMD
      use mod_comm, only : mp_sum1d
#ifdef use_shared_pointers
      use fv_arrays_mod, only: fv_thread_bcast
#endif
#endif
      implicit none
! Input:
      integer jm                   ! global latitudes
      integer jfirst               ! first latitude on this PE
      integer jlast                ! last latitude on this PE
      real, intent(in):: InVector(jfirst:jlast)  ! input vector to be summed

! OUTPUT:
      real, intent(out):: te0   ! sum of all vector entries
! Local
      integer j

#ifdef SPMD 
      call mp_sum1d(jm, jfirst, jlast, InVector, te0)
#ifdef use_shared_pointers
      call fv_thread_bcast(te0)
#endif
#else
      te0 = 0.0
      do j=1,jm
        te0 = te0 + InVector(j)
      enddo
#endif

 end subroutine par_vecsum

#ifdef TEST_HORIZ_INTERP
!z1l: currently only test bilinear interpolation.

program test

  use mpp_mod,          only : mpp_error, mpp_pe,  mpp_npes, mpp_root_pe
  use mpp_mod,          only : FATAL, stdout, stdlog
  use mpp_io_mod,       only : mpp_open, mpp_close, mpp_read
  use mpp_io_mod,       only : axistype, fieldtype
  use mpp_io_mod,       only : mpp_get_info, mpp_get_fields, mpp_get_times
  use mpp_io_mod,       only : mpp_get_axes, mpp_get_axis_data, mpp_get_atts
  use mpp_io_mod,       only : MPP_RDONLY, MPP_NETCDF, MPP_MULTI, MPP_SINGLE, MPP_OVERWR
  use mpp_io_mod,       only : mpp_get_att_name, mpp_get_att_char, mpp_get_att_type, mpp_get_att_real
  use mpp_io_mod,       only : mpp_write_meta, axistype, fieldtype, mpp_write, mpp_close 
  use mpp_domains_mod,  only : mpp_update_domains, mpp_define_domains, domain1d
  use mpp_domains_mod,  only : domain2d, mpp_define_layout, mpp_get_compute_domain
  use mpp_domains_mod,  only : mpp_get_domain_components
  use horiz_interp_mod, only : horiz_interp_new, horiz_interp, horiz_interp_end, horiz_interp_type
  use horiz_interp_mod, only : horiz_interp_init
  use axis_utils_mod,   only : get_axis_cart
  use fms_io_mod,       only : read_data, write_data
  use fms_io_mod,       only : field_size, fms_io_exit
  use fms_mod,          only : fms_init, fms_end, open_namelist_file, close_file, file_exist, field_exist
  use fms_mod,          only : check_nml_error, write_version_number, lowercase
  use constants_mod,    only : constants_init, PI
  use horiz_interp_mod, only : horiz_interp_new, horiz_interp, horiz_interp_end, horiz_interp_type

implicit none

  character(len=256) :: src_file = ""
  character(len=256) :: dst_grid = "INPUT/grid_spec.nc"
  character(len=256) :: field_name = ""
  character(len=256) :: dst_file = "output.nc"
  logical            :: new_missing_handle = .false.
  character(len=256) :: interp_method = "bilinear"

  real, allocatable, dimension(:)            :: x_src, y_src
  real, allocatable, dimension(:,:)          :: x_dst, y_dst
  type(axistype), allocatable, dimension(:)  :: axes
  type(fieldtype), allocatable, dimension(:) :: fields
  type(domain2d)                             :: Domain
  integer :: unit, ierr, io, src_unit, src_field_index, nk
  integer :: nx_src, ny_src, nx_dst, ny_dst, is, ie, js, je
  real    :: missing_value
  integer :: n, ntimes

  namelist /test_horiz_interp_nml/ src_file, field_name, dst_file, dst_grid, new_missing_handle, &
           interp_method

  call fms_init
  call horiz_interp_init
  call constants_init

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, test_horiz_interp_nml, iostat=io)
  ierr = check_nml_error(io, 'test_horiz_interp_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file ( )
     ierr=1
     do while (ierr /= 0)
        read(unit, nml=test_horiz_interp_nml, iostat=io, end=10)
        ierr = check_nml_error(io, 'test_horiz_interp_nml')
     enddo
10   call close_file (unit)
  endif
#endif


  if( .not. file_exist(src_file) ) call mpp_error(FATAL, &
       "test_horiz_interp: src_file = "//trim(src_file)//" does not exist")
  if( .not. field_exist(src_file, field_name) ) call mpp_error(FATAL, &
       "test_horiz_interp: field_name = "//trim(field_name)//" does not exist in file "//trim(src_file) )


  ! reading the grid information and missing value from src_file
  call mpp_open(src_unit, trim(src_file), &
         action=MPP_RDONLY, form=MPP_NETCDF, threading=MPP_MULTI, fileset=MPP_SINGLE)
  call read_src_file()

  ! reading the dst_grid file
  call read_dst_grid()

  !--- currently only test for first time level. The following will read the input data,
  !--- do the remapping and write out data
  call process_data()
  
  call mpp_close(src_unit)

  call fms_io_exit

  call fms_end()

contains


  ! read the input data, do the remapping and write out data
  subroutine process_data()
     real, allocatable, dimension(:,:,:) :: src_data, dst_data
     type(horiz_interp_type)             :: Interp
     type(axistype)     :: xaxis, yaxis, zaxis, taxis
     type(domain1D)     :: xdom, ydom
     type(fieldtype)    :: field
     real    :: D2R
     integer :: k, i

     call mpp_get_domain_components( domain, xdom, ydom )
     !--- set up meta data
     call mpp_open(unit,dst_file,action=MPP_OVERWR,form=MPP_NETCDF,threading=MPP_MULTI, fileset=MPP_MULTI)
     call mpp_write_meta( unit, xaxis, 'lon', 'none', 'X index', 'X', domain=xdom, data=(/(i-1.,i=1,nx_dst)/) )
     call mpp_write_meta( unit, yaxis, 'lat', 'none', 'Y index', 'Y', domain=ydom, data=(/(i-1.,i=1,ny_dst)/) )
     call mpp_write_meta( unit, zaxis, 'level', 'none', 'Z index', 'Z', data=(/(i-1.,i=1,nk)/) )
     call mpp_write_meta( unit, taxis, 'time', 'none', 'T index', 'T' )
     call mpp_write_meta( unit, field, (/xaxis, yaxis, zaxis, taxis/), field_name, 'none', 'none')
     call mpp_write( unit, xaxis )
     call mpp_write( unit, yaxis )
     call mpp_write( unit, zaxis )


     D2R = PI/180.

     allocate(src_data(nx_src,ny_src,nk))
     allocate(dst_data(is:ie,js:je,nk))

     call horiz_interp_new(Interp, x_src*D2R, y_src*D2R, x_dst*D2R, y_dst*D2R, &
          interp_method = trim(interp_method), grid_at_center = .true. )    

     do n = 1, ntimes
        call mpp_read(src_unit,fields(src_field_index),src_data, tindex=n)

        do k = 1, nk
           call horiz_interp(interp, src_data(:,:,k), dst_data(:,:,k), &
                missing_value=missing_value, new_missing_handle=new_missing_handle)
        enddo
        call mpp_write(unit, field, domain, dst_data, n*1.0)
     enddo

     call mpp_close(unit)
     deallocate(src_data, dst_data)
  
  end subroutine process_data


  subroutine read_dst_grid
    integer :: layout(2), start(4), nread(4)
    character(len=256) :: tile_file
    integer :: i, j, siz(4)
    real, allocatable :: tmp(:,:)

    if (field_exist(dst_grid, "gridfiles" )) then
       call read_data(dst_grid, "gridfiles", tile_file)
       tile_file = 'INPUT/'//trim(tile_file)
    else
       call mpp_error(FATAL, "test_horiz_interp: field gridfiles does not exist in file "//trim(dst_grid) )
    endif

    call field_size(tile_file, "x", siz)
    nx_dst = (siz(1)-1)/2
    ny_dst = (siz(2)-1)/2

    if(layout(1)*layout(2) .NE. mpp_npes() ) then
       call mpp_define_layout( (/1,nx_dst,1,ny_dst/), mpp_npes(), layout )
    end if

    call mpp_define_domains( (/1,nx_dst,1,ny_dst/), layout, Domain, name='test_data_override')

    call mpp_get_compute_domain(Domain, is, ie, js, je)

    allocate(tmp(2*is-1:2*ie+1,2*js-1:2*je+1))
    allocate(x_dst(is:ie,js:je), y_dst(is:ie,js:je))
 
    start = 1; nread = 1
    start(1) = 2*is-1; nread(1) = 2*(ie-is+1)+1
    start(2) = 2*js-1; nread(2) = 2*(je-js+1)+1

    call read_data(tile_file, "x", tmp, start, nread, domain) 
    do j = js, je
       do i = is, ie
          x_dst(i,j) = tmp(2*i,2*j)
       enddo
    enddo
    call read_data(tile_file, "y", tmp, start, nread, domain)   
    do j = js, je
       do i = is, ie
          y_dst(i,j) = tmp(2*i,2*j)
       enddo
    enddo

    deallocate(tmp)

  end subroutine read_dst_grid

  subroutine read_src_file

    integer                                    :: ndim, nvar, natt, n
    integer                                    :: nt, i, j, k, jj, len1
    character(len=1)                           :: cart
    character(len=32)                          :: name

    call mpp_get_info(src_unit, ndim, nvar, natt, ntimes)
    
    allocate(fields(nvar))
    call mpp_get_fields(src_unit, fields)
    src_field_index = 0
    do i=1,nvar
       call mpp_get_atts(fields(i),name=name)
       if (lowercase(trim(field_name)) == lowercase(trim(name))) then
             src_field_index = i
       endif
    enddo
    if(src_field_index == 0) call mpp_error(FATAL, 'test_horiz_interp: field '&
            //trim(field_name)//' is not in the file '//trim(src_file) )
    !--- get the src grid
    call mpp_get_atts(fields(src_field_index),ndim=ndim)
    allocate(axes(ndim))
    call mpp_get_atts(fields(src_field_index),axes=axes)
    nx_src=0; ny_src=0; nk=1
    do j=1,ndim
       call mpp_get_atts(axes(j),len=len1)
       call get_axis_cart(axes(j),cart)
       select case (cart)
       case ('X')
          nx_src = len1
          allocate(x_src(nx_src))
          call mpp_get_axis_data(axes(j),x_src)
       case('Y')
          ny_src = len1
          allocate(y_src(ny_src))
          call mpp_get_axis_data(axes(j),y_src)
       case('Z')
          nk = len1
       end select
    enddo
    if(nx_src==0) call mpp_error(FATAL,'test_horiz_interp: file ' &
         //trim(src_file)//' does not contain axis with cartesian attributes = "X" ')
    if(ny_src==0) call mpp_error(FATAL,'test_horiz_interp: file '&
         //trim(src_file)//' does not contain axis with cartesian attributes = "Y" ')

    !--- get the missing value
    call mpp_get_atts(fields(src_field_index),missing=missing_value)

  end subroutine read_src_file


end program test

#else
module null_test_horiz_interp
end module  

#endif 

module platform_mod
!platform-dependent settings
#include <fms_platform.h>
  public
  integer, parameter :: r8_kind=DOUBLE_KIND, r4_kind=FLOAT_KIND, &
                        c8_kind=DOUBLE_KIND, c4_kind=FLOAT_KIND, &
                        l8_kind=LONG_KIND, l4_kind=INT_KIND, &
                        i8_kind=LONG_KIND, i4_kind=INT_KIND, i2_kind=SHORT_KIND
!could additionally define things like OS, compiler...: useful?
end module platform_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: Diffusion schemes --- grid centers\label{sec:diffusionMean}
!
! !INTERFACE:
   subroutine diff_center(N,dt,cnpar,posconc,h,Bcup,Bcdw, &
                          Yup,Ydw,nuY,Lsour,Qsour,Taur,Yobs,Y)
!
! !DESCRIPTION:
! This subroutine solves the one-dimensional diffusion equation
! including source terms,
!  \begin{equation}
!   \label{YdiffCenter}
!    \partder{Y}{t}
!    = \partder{}{z} \left( \nu_Y \partder{Y}{z} \right)
!    - \frac{1}{\tau_R}(Y-Y_{obs})
!    + Y L_{\text{sour}} + Q_{\text{sour}}
!    \comma
!  \end{equation}
! for al variables defined at the centers of the grid cells, and
! a diffusion coefficient $\nu_Y$ defined at the faces.
! Relaxation with time scale $\tau_R$ towards observed values
! $Y_{\text{obs}}$ is possible. $L_{\text{sour}}$ specifies a
! linear source term, and $Q_{\text{sour}}$ a constant source term.
! Central differences are used to discretize the problem
! as discussed in \sect{SectionNumericsMean}. The diffusion term,
! the linear source term, and the linear part arising from the
! relaxation term are treated
! with an implicit method, whereas the constant source term is treated
! fully explicit.
!
! The input parameters {\tt Bcup} and {\tt Bcdw} specify the type
! of the upper and lower boundary conditions, which can be either
! Dirichlet or Neumann-type. {\tt Bcup} and {\tt Bcdw} must have integer
! values corresponding to the parameters {\tt Dirichlet} and {\tt Neumann}
! defined in the module {\tt util}, see \sect{sec:utils}.
! {\tt Yup} and {\tt Ydw} are the values of the boundary conditions at
! the surface and the bottom. Depending on the values of {\tt Bcup} and
! {\tt Bcdw}, they represent either fluxes or prescribed values.
! The integer {\tt posconc} indicates if a quantity is
! non-negative by definition ({\tt posconc}=1, such as for concentrations)
! or not ({\tt posconc}=0). For {\tt posconc}=1 and negative
! boundary fluxes, the source term linearisation according to
! \cite{Patankar80} is applied.
!
! Note that fluxes \emph{entering} a boundary cell are counted positive
! by convention. The lower and upper position for prescribing these fluxes
! are located at the lowest und uppermost grid faces with index "0" and
! index "N", respectively. If values are prescribed, they are located at
! the centers with index "1" and index "N", respectively.
!
! !USES:
   use util,          only  : Dirichlet, Neumann
   use mtridiagonal

   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer,  intent(in)                :: N

!  time step (s)
   REALTYPE, intent(in)                :: dt

!  "implicitness" parameter
   REALTYPE, intent(in)                :: cnpar

!  1: non-negative concentration, 0: else
   integer, intent(in)                 :: posconc

!  layer thickness (m)
   REALTYPE, intent(in)                :: h(0:N)

!  type of upper BC
   integer,  intent(in)                :: Bcup

!  type of lower BC
   integer,  intent(in)                :: Bcdw

!  value of upper BC
   REALTYPE, intent(in)                :: Yup

!  value of lower BC
   REALTYPE, intent(in)                :: Ydw

!  diffusivity of Y
   REALTYPE, intent(in)                :: nuY(0:N)

!  linear source term
!  (treated implicitly)
   REALTYPE, intent(in)                :: Lsour(0:N)

!  constant source term
!  (treated explicitly)
   REALTYPE, intent(in)                :: Qsour(0:N)

!  relaxation time (s)
   REALTYPE, intent(in)                :: Taur(0:N)

!  observed value of Y
   REALTYPE, intent(in)                :: Yobs(0:N)
!
! !INPUT/OUTPUT PARAMETERS:
   REALTYPE                            :: Y(0:N)
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: diff_center.F90,v $
!  Revision 20.0  2013/12/14 00:13:59  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:01:18  smg
!  initial cvs ci to mom5
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:33:41  smg
!  updated to gotm-2012.03.09 CVS tagged code.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.5  2010-09-17 12:53:52  jorn
!  extensive code clean-up to ensure proper initialization and clean-up of all variables
!
!  Revision 1.4  2005-11-17 09:58:20  hb
!  explicit argument for positive definite variables in diff_center()
!
!  Revision 1.3  2005/11/03 20:56:55  hb
!  Source term linearisation now fully explicit again, reversion to old method
!
!  Revision 1.2  2005/09/16 13:54:02  lars
!  added missing IMPLICIT NONE
!
!  Revision 1.1  2005/06/27 10:54:33  kbk
!  new files needed
!
!
!EOP
!
! !LOCAL VARIABLES:
   integer                   :: i
   REALTYPE                  :: a,c,l
!
!-----------------------------------------------------------------------
!BOC
!
!  set up matrix
   do i=2,N-1
      c     = 2.0*dt*nuY(i)  /(h(i)+h(i+1))/h(i)
      a     = 2.0*dt*nuY(i-1)/(h(i)+h(i-1))/h(i)
      l     =     dt*Lsour(i)

      cu(i) =-cnpar*c
      au(i) =-cnpar*a
      bu(i) = _ONE_ + cnpar*(a + c) - l
      du(i) = (_ONE_ - (_ONE_-cnpar)*(a + c))*Y(i)                  &
            + (_ONE_ - cnpar)*( a*Y(i-1) + c*Y(i+1) ) + dt*Qsour(i)
   end do

!   set up upper boundary condition
   select case(Bcup)
   case(Neumann)
      a     = 2.0*dt*nuY(N-1)/(h(N)+h(N-1))/h(N)
      l     = dt*Lsour(N)

      au(N) =-cnpar*a
      if (posconc .eq. 1 .and. Yup.lt._ZERO_) then ! Patankar (1980) trick
         bu(N) =  _ONE_ - au(N) - l  - dt*Yup/Y(N)/h(N)
         du(N) = Y(N) + dt*Qsour(N)   &
               + (_ONE_ - cnpar)*a*(Y(N-1)-Y(N))
      else
         bu(N) =  _ONE_ - au(N) - l
         du(N) = Y(N) + dt*(Qsour(N)+Yup/h(N))   &
               + (_ONE_ - cnpar)*a*(Y(N-1)-Y(N))
      end if
   case(Dirichlet)
      au(N) = _ZERO_
      bu(N) = _ONE_
      du(N) = Yup
   case default
      FATAL 'invalid boundary condition type for upper boundary'
      stop  'diff_center.F90'
   end select

!   set up lower boundary condition
   select case(Bcdw)
   case(Neumann)
      c     = 2.0*dt*nuY(1)/(h(1)+h(2))/h(1)
      l     = dt*Lsour(1)

      cu(1) =-cnpar*c
      if (posconc.eq.1 .and. Ydw.lt._ZERO_) then ! Patankar (1980) trick
         bu(1) = _ONE_ - cu(1) - l - dt*Ydw/Y(1)/h(1)
         du(1) = Y(1) + dt*(Qsour(1))   &
               + (_ONE_ - cnpar)*c*(Y(2)-Y(1))
      else
         bu(1) = _ONE_ - cu(1) - l
         du(1) = Y(1) + dt*(Qsour(1)+Ydw/h(1))   &
               + (_ONE_ - cnpar)*c*(Y(2)-Y(1))
      end if
   case(Dirichlet)
      cu(1) = _ZERO_
      bu(1) = _ONE_
      du(1) = Ydw
   case default
      FATAL 'invalid boundary condition type for lower boundary'
      stop  'diff_center.F90'
   end select

!  relaxation to observed value
   if (minval(Taur).lt.1.E10) then
      do i=1,N
         bu(i)=bu(i)+dt/Taur(i)
         du(i)=du(i)+dt/Taur(i)*Yobs(i)
      end do
   end if

!  solve linear system
   call tridiagonal(N,1,N,Y)

   return
   end subroutine diff_center
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module bgrid_vert_mod

!-----------------------------------------------------------------------
!
!     allocates memory and initializes vertical grid constants
!
!     contains interfaces for computing pressure and height
!
!-----------------------------------------------------------------------

use constants_mod, only: GRAV, RDGAS, RVGAS
use       fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL,       &
                         write_version_number, stdlog,                 &
                         mpp_clock_id, mpp_clock_begin, mpp_clock_end, &
                         MPP_CLOCK_SYNC, CLOCK_ROUTINE, CLOCK_LOOP

implicit none
private

!-----------------------------------------------------------------------
!  public derived data type (vert_grid_type)
!  -----------------------------------------
!    nlev  = number of vertical levels (integer)
!    nplev = number of pure pressure levels at the top of the model,
!            will equal zero when not using hybrid coordinate (integer)
!
!    deta  = sigma (aka eta) thicknesses of model layers
!    eta   = sigma (aka eta, bk) values at model layer interfaces (half levels)
!    peta  = reference pressure (pk) values at model layer interfaces
!    dpeta = reference pressure thicknesses of model layers
!
!    **** Note: pfull, phalf, fhalf are based on a SLP=101325. ****
!    pfull = pressure profile at model levels (full levels)
!    phalf = pressure profile at model layer interfaces (half levels)
!    fhalf = profile of geopotental height at half levels
!
!    wta,wtb = weights used to determine values at model levels
!                (based on pressure profile, useful for hybrid coord)
!    
!    psmin  = minimum allowable surface pressure to avoid negative
!             mass in a model layer (important for hybrid coord)
!    hybrid = logical flag (true for hybrid coordinate)
!    pzero  = logical flag (true for pres = 0 at top of model)
!    pref,tref,gamma = reference values for computing fhalf
!
!
!  public interfaces
!  -----------------
!    vert_grid_init        - initializes vert_grid_type data
!
!    compute_pres_depth    - computes pressure depth (mass) of model layers
!    compute_pres_full     - computes pressure at full model levels
!    compute_pres_half     - computes pressure at half model levels
!    compute_height        - computes geopotential height (in meters) at half model levels
!    compute_geop_height   - computes geopotential height (in m2/s2)
!    compute_pres_weights  - computes wta & wtb
!    compute_pressure      - computes pressure at full and half levels
!    compute_height_bottom - computes height at the lowest model level
!
!-----------------------------------------------------------------------
!------- interfaces -------

public  vert_grid_init, compute_geop_height, compute_height,   &
        compute_pres_depth, compute_pres_full, compute_pres_half, &
        compute_pres_weights, compute_pressures, compute_height_bottom

!------- public defined data type -------

public  vert_grid_type

type vert_grid_type
   integer                     :: nlev, nplev
   real, pointer, dimension(:) :: deta =>NULL(),  &
                                  eta =>NULL(),  &
                                  fhalf =>NULL(),  &
                                  dpeta =>NULL(), &
                                  pfull =>NULL(), &
                                  phalf =>NULL(), &
                                  peta =>NULL(), &
                                  wta =>NULL(), &
                                  wtb =>NULL()
   real                        :: pref, tref, gamma, psmin
   logical                     :: hybrid, pzero
end type vert_grid_type

!-----------------------------------------------------------------------

  real, parameter :: d608 = (RVGAS-RDGAS)/RDGAS
  real, parameter :: ginv = 1./GRAV

!------ parameters for eta coordinate reference surface heights --------

  real, parameter :: pref = 101325., tref = 288., gamma = 0.0065

!------ parameters for performance timing of code sections -----

  logical :: do_clock_init = .true.
  integer, dimension(7) :: id
  character(len=16), dimension(7) :: &
            names = (/ 'comp_pres_depth ', &
                       'comp_pres_full  ', &
                       'comp_pressures  ', &
                       'comp_pres_half  ', &
                       'comp_pres_wghts ', &
                       'comp_geop_hght  ', &
                       'comp_height_btm ' /)

!-----------------------------------------------------------------------
 character(len=128) :: version =  '$Id: bgrid_vert.F90,v 19.0 2012/01/06 19:55:18 fms Exp $'
 character(len=128) :: tagname =  '$Name: tikal $'
!-----------------------------------------------------------------------

contains

!#######################################################################

subroutine vert_grid_init ( Vgrid, eta, peta, verbose )

!-----------------------------------------------------------------------
!   Vgrid = vertical grid constants
!   eta   = sigma (aka eta,bk) values at model layer interfaces
!             the number of model levels will be "size(eta)-1"
!   peta  = reference pressures (aka pk) at model layer interfaces
!             if specified and non-zero then hybrid coord is used
!             default: peta=0.
!   verbose = controls the amount of printed output
!               possible values are verbose=0,1,2
!               default: verbose=1
!-----------------------------------------------------------------------

  type(vert_grid_type), intent(inout) :: Vgrid
  real,    intent (in)                ::  eta(:)
  real,    intent (in), optional      :: peta(:)
  integer, intent (in), optional      :: verbose

!-----------------------------------------------------------------------
integer :: k, nlev, lverbose, logunit
real    :: rgog
real, dimension(size(eta(:)))   :: lphalf, pres
real, dimension(size(eta(:))-1) :: lpfull

!-----------------------------------------------------------------------

   lverbose = 1;  if (present(verbose)) lverbose = verbose

!--------------derived vertical constants-------------------------------

      nlev = size(eta(:)) - 1
      allocate (Vgrid% deta(nlev), Vgrid% eta(nlev+1),  &
                Vgrid%dpeta(nlev), Vgrid%pfull(nlev), Vgrid%peta(nlev+1),  &
                Vgrid%wta  (nlev), Vgrid%wtb  (nlev), &
                Vgrid%phalf(nlev+1), Vgrid% fhalf(nlev+1))

      Vgrid % nlev = nlev

!--------- set-up eta values and hybrid pressure levels ----------
!--------- note: eta(1) and eta(nlev+1) have set values -----
!--------- also note: peta(nlev+1) = 0.0 -----

        Vgrid % eta(1)      = 0.0
        Vgrid % eta(nlev+1) = 1.0
        Vgrid % eta(2:nlev) = eta(2:nlev)

        Vgrid % peta = 0.0
        if (present(peta)) Vgrid % peta(1:nlev) = peta(1:nlev)

      do k = 1, nlev
        Vgrid %  deta(k) =  Vgrid %  eta(k+1) - Vgrid %  eta(k)
        Vgrid % dpeta(k) =  Vgrid % peta(k+1) - Vgrid % peta(k)
        Vgrid % pfull(k) =  0.0
        Vgrid % wta  (k) =  0.0
        Vgrid % wtb  (k) =  0.0
      enddo

!----------- is this a hybrid coordinate ??? -----

      Vgrid % hybrid = .false.

      do k = 1, nlev+1
         if ( Vgrid % peta(k) > 0.0 ) then
              Vgrid % hybrid = .true.
              exit
         endif
      enddo

!----------- find lowest pure pressure level --------------

      Vgrid % nplev = 0

      do k = 1, nlev
         if ( Vgrid % deta(k) > 0.0 ) exit
         Vgrid % nplev = k
      enddo

!     ---- need average pressure in these layers ----

      Vgrid % pzero = .true.

     !if ( Vgrid % nplev >= 1 ) then
         Vgrid % phalf(:) = Vgrid%peta(:) + Vgrid%eta(:)*pref
         if ( Vgrid % phalf(1) <= epsilon(Vgrid % phalf) ) then
            lphalf(1) = 0.0
            lphalf(2:) = log(Vgrid % phalf(2:))
         else
            lphalf(:) = log(Vgrid % phalf(:))
            Vgrid % pzero = .false.
         endif

         do k = 1, nlev
            lpfull(k) = (Vgrid%phalf(k+1)*lphalf(k+1) - Vgrid%phalf(k)*lphalf(k)) &
                        / (Vgrid%phalf(k+1)-Vgrid%phalf(k)) - 1.0
            Vgrid % pfull(k) = exp(lpfull(k))
            Vgrid % wtb  (k) = lphalf(k+1) - lpfull(k)
            Vgrid % wta  (k) = lpfull(k)   - lphalf(k)
         enddo
         if (Vgrid % pzero) Vgrid % wta(1) =Vgrid % wtb(1)

     !endif

!----------- find the minimum allowable surface pressure ------

      Vgrid % psmin = 0.0

      do k = 1, nlev
         if ( Vgrid % deta(k) > 0.0 )  Vgrid % psmin =  &
               max ( Vgrid % psmin, -Vgrid % dpeta(k)/Vgrid % deta(k) )
      enddo


!---------- set-up eta coordinate geopotential heights -------------

      rgog = RDGAS*gamma/GRAV

      do k=1,nlev
        pres(k) = Vgrid%peta(k) + Vgrid%eta(k)*pref
        Vgrid % fhalf(k) = GRAV*tref*(1.0-(pres(k)/pref)**rgog)/gamma
      enddo
        Vgrid % fhalf(nlev+1) = 0.0

        Vgrid % pref  = pref
        Vgrid % tref  = tref
        Vgrid % gamma = gamma

!--- write version info to logfile ---
   call write_version_number(version, tagname)

!--- optional output of coordinate values ----
   logunit= stdlog()
   if (mpp_pe() == mpp_root_pe()) then
       if (lverbose > 0) then
           write (logunit,*) 'Number of vertical levels =', Vgrid%nlev
           write (logunit,*) 'Approxiamte model level locations in pascals:'
           write (logunit,*) '  Full levels = ', Vgrid%pfull
           write (logunit,*) '  Half levels = ', Vgrid%phalf
           if (Vgrid%hybrid) &
           write (logunit,*) 'Hybrid coordinate with minimum allowable surface pressure =', Vgrid%psmin
       endif
       if (lverbose > 1) then
           write (logunit,*) 'INPUT VALUES:'
           write (logunit,*) '  eta =', Vgrid%eta
           write (logunit,*) '  peta =', Vgrid%peta
           write (logunit,*) 'OTHER VALUES:'
           write (logunit,*) '  deta =', Vgrid%deta
           write (logunit,*) '  dpeta =', Vgrid%dpeta
           write (logunit,*) '  nplev =', Vgrid%nplev
       endif
   endif

! initialize code sections for performance timing 
   if (do_clock_init) then
      do k = 1, size(id(:))
         id(k) = mpp_clock_id ('BGRID: vert ('//trim(names(k))//')', &
                               flags=MPP_CLOCK_SYNC, grain=CLOCK_LOOP)
      enddo
      do_clock_init = .false. 
   endif

!-----------------------------------------------------------------------

end subroutine vert_grid_init

!#######################################################################

subroutine compute_pres_depth (Vgrid, pssl, pdepth)

!--------------------------------------------------------
! Compute the pressure depth (mass) of model layers
!
!   Vgrid = vertical grid constants
!   pssl   = pressure at eta=1
!   pdepth = pressure depth of model layers
!--------------------------------------------------------

  type(vert_grid_type), intent(in)  :: Vgrid
       real           , intent(in)  :: pssl(:,:)
       real           , intent(out) :: pdepth(:,:,:)

       integer :: k, kp, ke

!-----------------------------------------------------------------------
  call mpp_clock_begin (id(1))

  kp = Vgrid % nplev
  ke = Vgrid % nlev

  if (size(pdepth,3) /= ke) call error_mesg (  &
                              'compute_pres_depth in bgrid_vert_mod', &
                              'incorrect dimension 3 for pdepth', FATAL)

! --- check for zero/negative depth layers ---

  if (Vgrid % hybrid) then
      if (minval(pssl) <= Vgrid % psmin) call error_mesg  &
                 ('compute_pres_depth in bgrid_vert_mod',  &
                  'pressure depth <= 0.0', FATAL)
  endif

! --- compute depth ---

  do k = 1, kp
    pdepth(:,:,k) = Vgrid % dpeta(k)
  enddo
    
  do k = kp+1, ke
    pdepth(:,:,k) = Vgrid % dpeta(k) + Vgrid % deta(k) * pssl(:,:)
  enddo

  call mpp_clock_end (id(1))

end subroutine compute_pres_depth

!#######################################################################

subroutine compute_pres_full (Vgrid, pssl, pfull, phalf, dpde)

!--------------------------------------------------------
! Compute the pressure at full model levels (plus options)
!
!   Vgrid = vertical grid constants
!   pssl  = pressure at eta=1
!   pfull = pressure at model levels
!   phalf = pressure at model layer interfaces (half levels)
!   dpde  = pressure depth of model layers
!--------------------------------------------------------

  type(vert_grid_type), intent(in)  :: Vgrid
  real                , intent(in)  :: pssl(:,:)
  real                , intent(out) :: pfull(:,:,:)
  real, optional      , intent(in)  :: phalf(:,:,:), dpde(:,:,:)

   real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)+1) :: ph
   real, dimension(size(pfull,1),size(pfull,2),size(pfull,3))   :: dp
   integer :: k, kp, ke
!-----------------------------------------------------------------------
!      compute the pressure at full model levels
!-----------------------------------------------------------------------
  call mpp_clock_begin (id(2))

  kp = Vgrid % nplev
  ke = Vgrid % nlev

  if (size(pfull,3) /= ke) call error_mesg (  &
                               'compute_pres_full in bgrid_vert_mod', &
                               'incorrect dimension 3 for pfull', FATAL)

!--- set or compute optional arguments ---

  if (present(phalf)) then
      ph = phalf
  else
      call compute_pres_half (Vgrid, pssl, ph)
  endif

  if (present(dpde)) then
      dp = dpde
  else
      call compute_pres_depth (Vgrid, pssl, dp)
  endif

!--- compute p*logp at half levels ---

  if ( Vgrid % pzero ) then
       ph(:,:,1) = 0.0
       ph(:,:,2:ke+1) = ph(:,:,2:ke+1) * log(ph(:,:,2:ke+1))
  else
       ph(:,:,:) = ph(:,:,:) * log(ph(:,:,:))
  endif

!--- compute pressure at full levels ---

  do k = 1, kp
    pfull(:,:,k) = Vgrid % pfull(k)
  enddo

  do k = kp+1, ke
    pfull(:,:,k) = exp( (ph(:,:,k+1)-ph(:,:,k))/dp(:,:,k) - 1.0 )
  enddo
    
  call mpp_clock_end (id(2))

end subroutine compute_pres_full

!#######################################################################

subroutine compute_pressures (Vgrid, pssl, phalf, pfull, dpde, wta, wtb)

!--------------------------------------------------------
! Compute the pressures, layer depths, and weights
!
!   Vgrid   = vertical grid constants
!   pssl    = pressure at eta=1
!   phalf   = pressure at model layer interfaces (half levels)
!   pfull   = pressure at model levels (full levels)
!   dpde    = pressure depth (mass) of model layers
!   wta,wtb = weights for computing data at model levels
!--------------------------------------------------------

  type(vert_grid_type), intent(in)  :: Vgrid
  real                , intent(in)  :: pssl(:,:)
  real                , intent(out) :: phalf(:,:,:), pfull(:,:,:)
  real, optional      , intent(out) :: dpde(:,:,:)
  real, optional      , intent(out) :: wta(:,:,:), wtb(:,:,:)

  real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)+1) :: ph,lph
  real, dimension(size(pfull,1),size(pfull,2),size(pfull,3))   :: dp,lpf
  integer :: k, kp, ke
!-----------------------------------------------------------------------

  kp = Vgrid % nplev
  ke = Vgrid % nlev

  if (size(pfull,3) /= ke) call error_mesg (  &
                               'compute_pressures in bgrid_vert_mod', &
                               'incorrect dimension 3 for pfull', FATAL)

!--- set or compute optional arguments ---

  call compute_pres_half (Vgrid, pssl, ph)
  phalf = ph

  call compute_pres_depth (Vgrid, pssl, dp)
  if (present(dpde))  dpde = dp

! do not include time for previous calls
  call mpp_clock_begin (id(3))

!--- compute p*logp at half levels ---

  if ( Vgrid % pzero ) then
      lph(:,:,1) = 0.0
       ph(:,:,1) = 0.0
      lph(:,:,2:ke+1) = log(ph(:,:,2:ke+1))
       ph(:,:,2:ke+1) = ph(:,:,2:ke+1) * lph(:,:,2:ke+1)
  else
      lph(:,:,:) = log(ph(:,:,:))
       ph(:,:,:) = ph(:,:,:) * lph(:,:,:)
  endif

!--- compute pressure at full levels ---

  do k = 1, kp
    pfull(:,:,k) = Vgrid % pfull(k)
  enddo

! if (present(wta) .or. present(wtb)) then
!   do k = 1, kp
!     lpf(:,:,k) = log(pfull(:,:,k))
!   enddo
! endif

  do k = kp+1, ke
    lpf(:,:,k) = (ph(:,:,k+1)-ph(:,:,k))/dp(:,:,k) - 1.0
    pfull(:,:,k) = exp( lpf(:,:,k) )
  enddo
    
!--- compute weights at full levels ---

   if (present(wtb)) then
      do k = 1, kp
        wtb(:,:,k) = Vgrid % wtb(k)
      enddo
      do k = kp+1, size(wtb,3)
        wtb(:,:,k) = lph(:,:,k+1) - lpf(:,:,k)
      enddo
   endif

   if (present(wta)) then
      do k = 1, kp
        wta(:,:,k) = Vgrid % wta(k)
      enddo
      do k = kp+1, size(wta,3)
        wta(:,:,k) = lpf(:,:,k) - lph(:,:,k)
      enddo
      if (Vgrid % pzero .and. kp == 0) wta(:,:,1) = wtb(:,:,1)
   endif

  call mpp_clock_end (id(3))

end subroutine compute_pressures

!#######################################################################

subroutine compute_pres_half (Vgrid, pssl, phalf)

!-------------------------------------------------------------
! Compute the pressure at the interface between model layers
!
!   Vgrid = vertical grid constants
!   pssl  = pressure at eta=1
!   phalf = pressure at model layer interfaces (half levels)
!-------------------------------------------------------------

  type(vert_grid_type), intent(in)  :: Vgrid
       real           , intent(in)  :: pssl(:,:)
       real           , intent(out) :: phalf(:,:,:)

       integer :: k, kp, ke

!-----------------------------------------------------------------------
  call mpp_clock_begin (id(4))

  kp = Vgrid % nplev + 1
  ke = Vgrid % nlev + 1

  if (size(phalf,3) /= ke) call error_mesg (  &
                               'compute_pres_half in bgrid_vert_mod', &
                               'incorrect dimension 3 for phalf', FATAL)

! pure pressure layers
  do k = 1, kp
    phalf(:,:,k) = Vgrid % peta(k)
  enddo
    
! sigma/pressure layers
  do k = kp+1, ke
    phalf(:,:,k) = Vgrid % peta(k) + Vgrid % eta(k) * pssl(:,:)
  enddo

  call mpp_clock_end (id(4))

end subroutine compute_pres_half

!#######################################################################

subroutine compute_pres_weights ( Vgrid, phalf, pfull, wta, wtb )

!------------------------------------------------------------
! Compute the weights for determining data at model levels
!
!   Vgrid   = vertical grid constants
!   phalf   = pressure at model layer interfaces (half levels)
!   pfull   = pressure at model levels (full levels)
!   wta,wtb = weights for computing data at model levels
!------------------------------------------------------------

 type(vert_grid_type), intent(in)  :: Vgrid
 real, intent(in)  :: phalf(:,:,:), pfull(:,:,:)
 real, intent(out) :: wta(:,:,:), wtb(:,:,:)

 real, dimension(size(phalf,1),size(phalf,2),size(phalf,3)) :: logph
 real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) :: logpf
 integer :: k, kp, kx, ks

  call mpp_clock_begin (id(5))

   kp = Vgrid % nplev
   kx = size(pfull,3)

   ! start indexing at 2 if ptop=0
   if (Vgrid%pzero) then
       ks = max(2,kp+1)
   else
       ks = kp+1
   endif

   logph(:,:,ks  :kx+1) = log(phalf(:,:,ks  :kx+1))
   logpf(:,:,kp+1:kx  ) = log(pfull(:,:,kp+1:kx  ))

 ! weights for half level below
   do k = 1, kp
     wtb(:,:,k) = Vgrid % wtb(k)
   enddo
   do k = kp+1, kx
     wtb(:,:,k) = logph(:,:,k+1) - logpf(:,:,k)
   enddo

 ! weights for half level above
   if (Vgrid%pzero .and. kp == 0) wta(:,:,1) = wtb(:,:,1)
   do k = 1, kp
     wta(:,:,k) = Vgrid % wta(k)
   enddo
   do k = ks, kx
     wta(:,:,k) = logpf(:,:,k) - logph(:,:,k)
   enddo

  call mpp_clock_end (id(5))

end subroutine compute_pres_weights

!#######################################################################

subroutine compute_geop_height (Vgrid, fssl, vtemp, wta, wtb, &
                                zfull, zhalf, mask)

!-----------------------------------------------------------------
! Compute the geopotential height at full (and half) model levels
!
!   Vgrid   = vertical grid constants
!   fssl    = geopotential height at eta=1
!   vtemp   = layer mean virtual temperature (at full model levels)
!   wta,wtb = weights for computing data at full model levels
!   zfull   = geop height (m2/s2) at model levels (full levels)
!   zhalf   = geop height (m2/s2) at model layer interfaces (half levels)
!   mask    = grid box mask for eta coordinate topography
!------------------------------------------------------------


    type(vert_grid_type), intent(in)   :: Vgrid
    real, intent(in), dimension(:,:)   :: fssl
    real, intent(in), dimension(:,:,:) :: vtemp, wta, wtb
    real, intent(out)                  :: zfull(:,:,:)
    real, intent(out), optional        :: zhalf(:,:,:)
    real, intent(in),  optional        :: mask(:,:,:)

       integer :: k, klev
       real, dimension(size(vtemp,1),size(vtemp,2)) :: zb, zt, rt

!-----------------------------------------------------------------------
  call mpp_clock_begin (id(6))

  klev = Vgrid % nlev

  if (size(zfull,3) /= klev) call error_mesg (  &
                               'compute_geop_height in bgrid_vert_mod', &
                               'incorrect dimension 3 for zfull', FATAL)

  if (present(zhalf)) then
     if (size(zhalf,3) /= klev+1) call error_mesg (  &
                               'compute_geop_height in bgrid_vert_mod', &
                               'incorrect dimension 3 for zhalf', FATAL)
  endif

      zb(:,:) = fssl(:,:)
      if (present(zhalf)) zhalf(:,:,klev+1) = zb(:,:)

!------- vertical integration loop (bottom to top) ----------

      do k = klev, 1, -1

         rt(:,:) = RDGAS * vtemp(:,:,k)
         zt(:,:) = zb(:,:) + rt(:,:) * (wta(:,:,k)+wtb(:,:,k))
         zfull(:,:,k) = zb(:,:) + rt(:,:) * wtb(:,:,k)
         ! eta/step-mountain option
         if (present(mask)) then
            where (mask(:,:,k) < 0.5)
                zt(:,:) = Vgrid % fhalf(k) ! use reference height profile
                zfull(:,:,k) = 0.5*(Vgrid % fhalf(k)+Vgrid % fhalf(k+1))
            endwhere
         endif
         zb(:,:) = zt(:,:)
         if (present(zhalf)) zhalf(:,:,k) = zb(:,:)

      enddo

  call mpp_clock_end (id(6))

end subroutine compute_geop_height

!#######################################################################

subroutine compute_height (Vgrid, fssl, temp, sphum, pfull, phalf, &
                           zfull, zhalf, mask)

!-----------------------------------------------------------------------
! Compute the geopotential height (in meters) at full and half model levels.
!
!   Vgrid   = vertical grid constants
!   fssl    = geopotential height at eta=1
!   temp    = layer mean temperature (at full model levels)
!   sphum   = layer mean specific humidity (at full model levels)
!   pfull   = pressure at model levels (full levels)
!   phalf   = pressure at model layer interfaces (half levels)
!   zfull   = geop height (in meters) at model levels (full levels)
!   zhalf   = geop height (in meters) at model layer interfaces (half levels)
!   mask    = grid box mask for eta coordinate topography
!
! Assumes that specific humidity is used to compute virtual temperature.
!-----------------------------------------------------------------------

   type(vert_grid_type), intent(in)    :: Vgrid
   real, intent(in),  dimension(:,:)   :: fssl
   real, intent(in),  dimension(:,:,:) :: temp, sphum, pfull, phalf
   real, intent(out), dimension(:,:,:) :: zfull, zhalf
   real, intent(in),  optional         :: mask(:,:,:)

   real, dimension(size(temp,1),size(temp,2),size(temp,3)) ::  &
                                                   wta, wtb, vtemp

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

  call compute_pres_weights ( Vgrid, phalf, pfull, wta, wtb )

  vtemp = temp * (1.0+d608*sphum)  ! WARNING: also computed in bgrid core
                                   !   potential exists for future problems!!!

  if (present(mask)) then
     call compute_geop_height ( Vgrid, fssl, vtemp, wta, wtb, &
                                zfull, zhalf, mask )
  else
     call compute_geop_height ( Vgrid, fssl, vtemp, wta, wtb, &
                                zfull, zhalf )
  endif

  zfull = zfull * ginv
  zhalf = zhalf * ginv

end subroutine compute_height

!#######################################################################

subroutine compute_height_bottom ( Vgrid, pssl, tbot, qbot,  &
                                   zbot, pbot, kbot )

!-----------------------------------------------------------------------
! Compute the height above surface (in meters) of the lowest model level.
!
!   Vgrid   = vertical grid constants
!   pssl    = pressure at eta=1
!   tbot    = mean temperature of lowest model layer
!   qbot    = mean specific humidity of lowest model layer
!
!   zbot    = height above surface (in meters) of the lowest model level
!   pbot    = pressure at lowest model level
!
!   mask    = grid box mask for eta coordinate topography
!

   type(vert_grid_type), intent(in)  :: Vgrid
   real, intent(in),  dimension(:,:) :: pssl, tbot, qbot
   real, intent(out), dimension(:,:) :: zbot, pbot
   integer, intent(in),  optional    :: kbot(:,:)

   real, dimension(size(pssl,1),size(pssl,2)) :: rt, dp, phb, pht, &
                                                 lphb, lpht, lpf
   integer :: i, j, kb

!  ----- pressure at top and bottom interface of bottom level -----

   call mpp_clock_begin (id(7))

 ! compute half level pressure at the "top" and "bottom" of lowest model layer
   if (present(kbot)) then
      do j = 1, size(pssl,2)
      do i = 1, size(pssl,1)
         kb = kbot(i,j)
         pht(i,j) = Vgrid%peta(kb  ) + Vgrid%eta(kb  )*pssl(i,j)
         phb(i,j) = Vgrid%peta(kb+1) + Vgrid%eta(kb+1)*pssl(i,j)
      enddo
      enddo
   else
         kb = Vgrid%nlev
         pht(:,:) = Vgrid%peta(kb+1) + Vgrid%eta(kb+1)*pssl(:,:)
         phb(:,:) = Vgrid%peta(kb  ) + Vgrid%eta(kb  )*pssl(:,:)
   endif

 ! compute log(pressure at lowest level)
   dp = phb - pht
   lphb = log(phb)
   lpht = log(pht)
   lpf = (phb*lphb-pht*lpht)/dp -1
   
 ! compute virtual temperature using specific humidity
   rt = ginv*RDGAS * (tbot * (1.+d608*qbot))
   zbot = rt * (lphb-lpf)
   pbot = exp(lpf)

   call mpp_clock_end (id(7))

end subroutine compute_height_bottom

!#######################################################################

end module bgrid_vert_mod

! ============================================================================
! top-level core of the Land Dynamics (LaD) model code
! ============================================================================
module land_model_mod

#include "shared/debug.inc"
#include "shared/concat.inc"

use time_manager_mod, only : time_type, get_time, increment_time, time_type_to_real, &
     operator(+)
use mpp_domains_mod, only : domain2d, mpp_get_ntile_count

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use mpp_mod, only : mpp_max, mpp_sum
use fms_mod, only : write_version_number, error_mesg, FATAL, WARNING, NOTE, mpp_pe, &
     mpp_root_pe, file_exist, check_nml_error, close_file, &
     stdlog, stderr, mpp_clock_id, mpp_clock_begin, mpp_clock_end, string, &
     stdout, CLOCK_FLAG_DEFAULT, CLOCK_COMPONENT, CLOCK_ROUTINE
use field_manager_mod, only : MODEL_LAND
use data_override_mod, only : data_override
use diag_manager_mod, only : diag_axis_init, register_static_field, &
     register_diag_field, send_data
use constants_mod, only : radius, hlf, hlv, hls, tfreeze, pi, rdgas, rvgas, cp_air, &
     stefan
use astronomy_mod, only : diurnal_solar
use sphum_mod, only : qscomp
use tracer_manager_mod, only : NO_TRACER

use land_constants_mod, only : NBANDS, BAND_VIS, BAND_NIR, mol_air, mol_C, mol_co2
use glacier_mod, only : read_glac_namelist, glac_init, glac_end, glac_get_sfc_temp, &
     glac_radiation, glac_diffusion, glac_step_1, glac_step_2, save_glac_restart
use lake_mod, only : read_lake_namelist, lake_init, lake_end, lake_get_sfc_temp, &
     lake_radiation, lake_diffusion, lake_step_1, lake_step_2, save_lake_restart
use soil_mod, only : read_soil_namelist, soil_init, soil_end, soil_get_sfc_temp, &
     soil_radiation, soil_diffusion, soil_step_1, soil_step_2, soil_step_3, &
     save_soil_restart
use snow_mod, only : read_snow_namelist, snow_init, snow_end, snow_get_sfc_temp, &
     snow_radiation, snow_diffusion, snow_get_depth_area, snow_step_1, snow_step_2, &
     save_snow_restart
use vegetation_mod, only : read_vegn_namelist, vegn_init, vegn_end, vegn_get_cover, &
     vegn_radiation, vegn_diffusion, vegn_step_1, vegn_step_2, vegn_step_3, &
     update_vegn_slow, save_vegn_restart
use cana_tile_mod, only : canopy_air_mass, canopy_air_mass_for_tracers, cana_tile_heat
use canopy_air_mod, only : read_cana_namelist, cana_init, cana_end, cana_state,&
     cana_step_1, cana_step_2, cana_radiation, cana_roughness, &
     save_cana_restart
use river_mod, only : river_init, river_end, update_river, river_stock_pe, &
     save_river_restart
use topo_rough_mod, only : topo_rough_init, topo_rough_end, update_topo_rough
use soil_tile_mod, only : soil_cover_cold_start, soil_tile_stock_pe, &
                          soil_tile_heat
use vegn_tile_mod, only : vegn_cover_cold_start, vegn_data_rs_min, &
                          update_derived_vegn_data, vegn_tile_stock_pe, &
                          vegn_tile_heat
use lake_tile_mod, only : lake_cover_cold_start, lake_tile_stock_pe, &
                          lake_tile_heat
use glac_tile_mod, only : glac_pars_type, glac_cover_cold_start, &
                          glac_tile_stock_pe, glac_tile_heat
use snow_tile_mod, only : snow_tile_stock_pe, snow_tile_heat
use land_numerics_mod, only : ludcmp, lubksb, nearest, &
     horiz_remap_type, horiz_remap_new, horiz_remap, horiz_remap_del, &
     horiz_remap_print
use land_io_mod, only : read_land_io_namelist, input_buf_size
use land_tile_mod, only : land_tile_type, land_tile_list_type, &
     land_tile_enum_type, new_land_tile, insert, nitems, &
     first_elmt, tail_elmt, next_elmt, current_tile, operator(/=), &
     get_elmt_indices, get_tile_tags, land_tile_carbon
use land_data_mod, only : land_data_type, atmos_land_boundary_type, &
     land_state_type, land_data_init, land_data_end, lnd, &
     dealloc_land2cplr, realloc_land2cplr, &
     dealloc_cplr2land, realloc_cplr2land, &
     land_data_type_chksum, atm_lnd_bnd_type_chksum
use nf_utils_mod,  only : nfu_inq_var, nfu_inq_dim, nfu_get_var
use land_utils_mod, only : put_to_tiles_r0d_fptr
use land_tile_io_mod, only : print_netcdf_error, create_tile_out_file, &
    read_tile_data_r0d_fptr, write_tile_data_r0d_fptr, &
    write_tile_data_i0d_fptr, get_input_restart_name
use land_tile_diag_mod, only : tile_diag_init, tile_diag_end, &
    register_tiled_diag_field, send_tile_data, dump_tile_diag_fields, &
    add_tiled_diag_field_alias, &
    OP_AVERAGE, OP_SUM
use land_debug_mod, only : land_debug_init, land_debug_end, set_current_point, &
     is_watch_point, get_watch_point, check_temp_range, current_face, &
     get_current_point
use static_vegn_mod, only : write_static_vegn
use land_transitions_mod, only : &
     land_transitions_init, land_transitions_end, land_transitions, &
     save_land_transitions_restart
use stock_constants_mod, only: ISTOCK_WATER, ISTOCK_HEAT, ISTOCK_SALT

implicit none
private

! ==== public interfaces =====================================================
public land_model_init          ! initialize the land model
public land_model_end           ! finish land model calculations
public land_model_restart       ! saves the land model restart(s)
public update_land_model_fast   ! time-step integration
public update_land_model_slow   ! time-step integration
public atmos_land_boundary_type ! data from coupler to land
public land_data_type           ! data from land to coupler
public land_data_type_chksum    ! routine to print checksums for land_data_type
public atm_lnd_bnd_type_chksum  ! routine to print checksums for atmos_land_boundary_type

public :: Lnd_stock_pe          ! return stocks of conservative quantities
! ==== end of public interfaces ==============================================

! ==== module constants ======================================================
character(len=*), parameter :: &
     module_name = 'land', &
     version     = '$Id: land_model.F90,v 20.0 2013/12/13 23:29:26 fms Exp $', &
     tagname     = '$Name: tikal $'

! ==== module variables ======================================================

! ---- namelist --------------------------------------------------------------
logical :: use_old_conservation_equations  = .false.
logical :: lm2                             = .false.
logical :: do_age                          = .false.
logical :: give_stock_details              = .false.
logical :: use_tfreeze_in_grnd_latent      = .false.
logical :: use_atmos_T_for_precip_T        = .false.
logical :: use_atmos_T_for_evap_T          = .false.
real    :: cpw = 1952.  ! specific heat of water vapor at constant pressure
real    :: clw = 4218.  ! specific heat of water (liquid)
real    :: csw = 2106.  ! specific heat of water (ice)
real    :: min_sum_lake_frac = 1.e-8
real    :: min_frac = 0.0 ! minimum fraction of soil, lake, and glacier that is not discarded on cold start
real    :: gfrac_tol         = 1.e-6
real    :: discharge_tol = -1.e20
real    :: con_fac_large = 1.e6
real    :: con_fac_small = 1.e-6
integer :: num_c = 0
real    :: tau_snow_T_adj = -1.0 ! time scale of snow temperature adjustment
              ! for the snow-free surface (s); negative means no adjustment
logical :: prohibit_negative_canopy_water = .FALSE. ! if true, then in case of negative canopy
              ! water the evaporation is fixed and the equations are re-solved.
              ! Default retrievs old behavior.
character(16) :: nearest_point_search = 'global' ! specifies where to look for
              ! nearest points for missing data, "global" or "face"
logical :: print_remapping = .FALSE. ! if true, full land cover remapping
              ! information is printed on the cold start
integer :: layout(2) = (/0,0/)
integer :: io_layout(2) = (/0,0/)
namelist /land_model_nml/ use_old_conservation_equations, &
                          lm2, do_age, give_stock_details, &
                          use_tfreeze_in_grnd_latent, &
                          use_atmos_T_for_precip_T, &
                          use_atmos_T_for_evap_T, &
                          cpw, clw, csw, min_sum_lake_frac, min_frac, &
                          gfrac_tol, discharge_tol, &
                          con_fac_large, con_fac_small, num_c, &
                          tau_snow_T_adj, prohibit_negative_canopy_water, &
                          nearest_point_search, print_remapping, &
                          layout, io_layout
! ---- end of namelist -------------------------------------------------------

logical  :: module_is_initialized = .FALSE.
logical  :: stock_warning_issued  = .FALSE.
logical  :: update_cana_co2 ! if false, cana_co2 is not updated during the model run.
character(len=256) :: grid_spec_file="INPUT/grid_spec.nc" 
real     :: delta_time ! duration of main land time step (s)
integer  :: num_species
integer  :: num_phys = 2
real,    allocatable :: frac           (:,:)    ! fraction of land in cells
logical, allocatable :: river_land_mask(:,:), missing_rivers(:,:)
real,    allocatable :: no_riv(:,:)

! ---- diag field IDs --------------------------------------------------------
integer :: &
 ! COLUMN        VEGN        SNOW      GLAC/LAKE/SOIL  CANOPY-AIR  RIVER
  id_VWS,                                               id_VWSc,           &
  id_LWS,      id_LWSv,     id_LWSs,     id_LWSg,                          &
  id_FWS,      id_FWSv,     id_FWSs,     id_FWSg,                          &
  id_HS,       id_HSv,      id_HSs,      id_HSg,        id_HSc,            &
  id_precip,                                                               &
  id_hprec,                                                                &
  id_lprec,    id_lprecv,   id_lprecs,   id_lprecg,                        &
  id_hlprec,   id_hlprecv,  id_hlprecs,  id_hlprecg,                       &
  id_fprec,    id_fprecv,   id_fprecs,                                     &
  id_hfprec,   id_hfprecv,  id_hfprecs,                                    &
  id_evap,                                                                 &
  id_hevap,                                                                &
  id_levap,    id_levapv,   id_levaps,   id_levapg,                        &
  id_hlevap,   id_hlevapv,  id_hlevaps,  id_hlevapg,                       &
  id_fevap,    id_fevapv,   id_fevaps,   id_fevapg,                        &
  id_hfevap,   id_hfevapv,  id_hfevaps,  id_hfevapg,                       &
  id_runf,                                                                 &
  id_hrunf,                                                                &
  id_lrunf,                 id_lrunfs,   id_lrunfg,                        &
  id_hlrunf,                id_hlrunfs,  id_hlrunfg,                       &
  id_frunf,                 id_frunfs,                                     &
  id_hfrunf,                id_hfrunfs,                                    &
  id_melt,     id_meltv,    id_melts,    id_meltg,                         &
  id_fsw,      id_fswv,     id_fsws,     id_fswg,                          &
  id_flw,      id_flwv,     id_flws,     id_flwg,                          &
  id_sens,     id_sensv,    id_senss,    id_sensg,                         &
!
  id_e_res_1,  id_e_res_2,  id_cd_m,     id_cd_t,                          &
  id_cellarea, id_landarea, id_landfrac, id_no_riv,                        &
  id_geolon_t, id_geolat_t,                                                &
  id_frac,     id_area,     id_ntiles,                                     &
  id_dis_liq,  id_dis_ice,  id_dis_heat, id_dis_sink,                      &
  id_z0m,      id_z0s,      id_con_g_h,                                    &
  id_transp,                id_wroff,    id_sroff,                         &
  id_htransp,  id_huptake,  id_hroff,    id_gsnow,    id_gequil,           &
  id_grnd_flux,                                                            &
  id_soil_water_supply,     id_levapg_max,                                 &
  id_water,    id_snow,                                                    &
  id_Trad,     id_Tca,      id_qca,      id_qco2,     id_qco2_dvmr,        &
  id_swdn_dir, id_swdn_dif, id_swup_dir, id_swup_dif, id_lwdn,             &
  id_fco2,                                                                 &
  id_vegn_cover,    id_cosz,                                               &
  id_albedo_dir,    id_albedo_dif,                                         &
  id_vegn_refl_dir, id_vegn_refl_dif, id_vegn_refl_lw,                     &
  id_vegn_tran_dir, id_vegn_tran_dif, id_vegn_tran_lw,                     &
  id_vegn_sctr_dir,                                                        &
  id_subs_refl_dir, id_subs_refl_dif, id_subs_emis, id_grnd_T, id_total_C

! ---- global clock IDs
integer :: landClock, landFastClock, landSlowClock


! ==== NetCDF declarations ===================================================
include 'netcdf.inc'
#define __NF_ASRT__(x) call print_netcdf_error((x),__FILE__,__LINE__)

contains


! ============================================================================
subroutine land_model_init &
     (cplr2land, land2cplr, time_init, time, dt_fast, dt_slow)
! initialize land model using grid description file as an input. This routine
! reads land grid boundaries and area of land from a grid description file

! NOTES: theoretically, the grid description file can specify any regular
! rectangular grid for land, not just lon/lat grid. Therefore the variables
! "xbl" and "ybl" in NetCDF grid spec file are not necessarily lon and lat
! boundaries of the grid.
!   However, at this time the module land_properties assumes that grid _is_
! lon/lat and therefore the entire module also have to assume that the land 
! grid is lon/lat.
!   lon/lat grid is also assumed for the diagnostics, but this is probably not
! so critical. 
  type(atmos_land_boundary_type), intent(inout) :: cplr2land ! boundary data
  type(land_data_type)          , intent(inout) :: land2cplr ! boundary data
  type(time_type), intent(in) :: time_init ! initial time of simulation (?)
  type(time_type), intent(in) :: time      ! current time
  type(time_type), intent(in) :: dt_fast   ! fast time step
  type(time_type), intent(in) :: dt_slow   ! slow time step

  ! ---- local vars ----------------------------------------------------------
  integer :: ncid, varid
  integer :: unit, ierr, io
  integer :: id_lon, id_lat, id_band     ! IDs of land diagnostic axes
  logical :: used                        ! return value of send_data diagnostics routine
  integer :: i,j,k
  type(land_tile_type), pointer :: tile
  type(land_tile_enum_type) :: ce, te
  character(len=256) :: restart_file_name
  logical :: restart_exists
  ! IDs of local clocks
  integer :: landInitClock

  module_is_initialized = .TRUE.

  ! [1] print out version number
  call write_version_number(version, tagname)

  ! initialize land model clocks
  landClock      = mpp_clock_id('Land'               ,CLOCK_FLAG_DEFAULT,CLOCK_COMPONENT)
  landFastClock  = mpp_clock_id('Update-Land-Fast'   ,CLOCK_FLAG_DEFAULT,CLOCK_ROUTINE)
  landSlowClock  = mpp_clock_id('Update-Land-Slow'   ,CLOCK_FLAG_DEFAULT,CLOCK_ROUTINE)
  landInitClock  = mpp_clock_id('Land init'          ,CLOCK_FLAG_DEFAULT,CLOCK_ROUTINE)

  call mpp_clock_begin(landInitClock)

  ! [ ] initialize land debug output
  call land_debug_init()

  ! [ ] initialize tile-specific diagnostics internals
  call tile_diag_init()

  ! [2] read namelists
  ! [2.1] read land model namelist
#ifdef INTERNAL_FILE_NML
     read (input_nml_file, nml=land_model_nml, iostat=io)
     ierr = check_nml_error(io, 'land_model_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file ( )
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=land_model_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'land_model_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif
  if (mpp_pe() == mpp_root_pe()) then
     unit = stdlog()
     write (unit, nml=land_model_nml)
     call close_file (unit)
  endif
  ! [2.2] read sub-model namelists: then need to be read before initialization
  ! because they can affect the way cover and tiling is initialized on cold start.
  call read_land_io_namelist()
  call read_soil_namelist()
  call read_vegn_namelist()
  call read_lake_namelist()
  call read_glac_namelist()
  call read_snow_namelist()
  call read_cana_namelist()

  ! [ ] initialize land state data, including grid geometry and processor decomposition
  call land_data_init(layout, io_layout, time, dt_fast, dt_slow)
  delta_time  = time_type_to_real(lnd%dt_fast) ! store in a module variable for convenience

  ! calculate land fraction
  allocate(frac(lnd%is:lnd%ie,lnd%js:lnd%je))
  frac = lnd%area/lnd%cellarea

  ! [5] initialize tiling
  call get_input_restart_name('INPUT/land.res.nc',restart_exists,restart_file_name)
  if(restart_exists) then
     call error_mesg('land_model_init',&
          'reading NetCDF restart "'//trim(restart_file_name)//'"',&
          NOTE)
     ! read map of tiles -- retrieve information from 
     call land_cover_warm_start(restart_file_name,lnd)
     ! initialize land model data
     __NF_ASRT__(nf_open(restart_file_name,NF_NOWRITE,ncid))
     if (nf_inq_varid(ncid,'lwup',varid)==NF_NOERR) &
          call read_tile_data_r0d_fptr(ncid,'lwup',land_lwup_ptr)
     if (nf_inq_varid(ncid,'e_res_1',varid)==NF_NOERR) &
          call read_tile_data_r0d_fptr(ncid,'e_res_1',land_e_res_1_ptr)
     if (nf_inq_varid(ncid,'e_res_2',varid)==NF_NOERR) &
          call read_tile_data_r0d_fptr(ncid,'e_res_2',land_e_res_2_ptr)
     __NF_ASRT__(nf_close(ncid))
  else
     ! initialize map of tiles -- construct it by combining tiles
     ! from component models
     call error_mesg('land_model_init',&
          'cold-starting land cover map',&
          NOTE)
     call land_cover_cold_start(lnd)
  endif

  ! [6] initialize land model diagnostics -- must be before *_data_init so that
  ! *_data_init can write static fields if necessary
  call land_diag_init( lnd%coord_glonb, lnd%coord_glatb, lnd%coord_glon, lnd%coord_glat, time, lnd%domain, &
       id_lon, id_lat, id_band )
  ! set the land diagnostic axes ids for the flux exchange
  land2cplr%axes = (/id_lon,id_lat/)
  ! send some static diagnostic fields to output
  if ( id_cellarea > 0 ) used = send_data ( id_cellarea, lnd%cellarea, lnd%time )
  if ( id_landarea > 0 ) used = send_data ( id_landarea, lnd%area, lnd%time )
  if ( id_landfrac > 0 ) used = send_data ( id_landfrac, frac,     lnd%time )
  if ( id_geolon_t > 0 ) used = send_data ( id_geolon_t, lnd%lon*180.0/PI, lnd%time )
  if ( id_geolat_t > 0 ) used = send_data ( id_geolat_t, lnd%lat*180.0/PI, lnd%time )

  ! [7] initialize individual sub-models
  num_species = num_phys + num_c
  if (do_age) num_species = num_species + 1

  call soil_init ( id_lon, id_lat, id_band )
  call vegn_init ( id_lon, id_lat, id_band )
  call lake_init ( id_lon, id_lat )
  call glac_init ( id_lon, id_lat )
  call snow_init ( id_lon, id_lat )
  call cana_init ( id_lon, id_lat )
  call topo_rough_init( lnd%time, lnd%lonb, lnd%latb, &
       lnd%domain, id_lon, id_lat)
  allocate (river_land_mask(lnd%is:lnd%ie,lnd%js:lnd%je))
  allocate ( missing_rivers(lnd%is:lnd%ie,lnd%js:lnd%je))
  allocate ( no_riv        (lnd%is:lnd%ie,lnd%js:lnd%je))
  call river_init( lnd%lon, lnd%lat, &
                   lnd%time, lnd%dt_fast, lnd%domain,     &
                   frac, &
                   id_lon, id_lat,                        &
                   river_land_mask                        )
  missing_rivers = frac.gt.0. .and. .not.river_land_mask
  no_riv = 0.
  where (missing_rivers) no_riv = 1.
  if ( id_no_riv > 0 ) used = send_data( id_no_riv, no_riv, lnd%time )
  call land_transitions_init (id_lon, id_lat) 
  ! [8] initialize boundary data
  ! [8.1] allocate storage for the boundary data 
  call realloc_land2cplr ( land2cplr )
  call realloc_cplr2land ( cplr2land )
  ! [8.2] set the land mask to FALSE everywhere -- update_land_bc_fast
  ! will set it to true where necessary
  land2cplr%mask = .FALSE.
  land2cplr%tile_size = 0.0
  ! [8.3] get the current state of the land boundary for the coupler
  ce = first_elmt(lnd%tile_map,                  &
              is=lbound(cplr2land%t_flux,1), &
              js=lbound(cplr2land%t_flux,2)  )
  te = tail_elmt(lnd%tile_map)
  do while(ce /= te)
     ! calculate indices of the current tile in the input arrays;
     ! assume all the cplr2land components have the same lbounds
     call get_elmt_indices(ce,i,j,k)
     ! set this point coordinates as current for debug output
     call set_current_point(i,j,k)
     ! get pointer to current tile
     tile => current_tile(ce)
     ! advance enumerator to the next tile
     ce=next_elmt(ce)

     call update_land_bc_fast (tile, i,j,k, land2cplr, is_init=.true.)
  enddo

  ! [8.4] update topographic roughness scaling
  call update_land_bc_slow( land2cplr )

  ! mask error checking
  do j=lnd%js,lnd%je
  do i=lnd%is,lnd%ie
     if(frac(i,j)>0.neqv.ANY(land2cplr%mask(i,j,:))) then
        call error_mesg('land_model_init','masks are not equal',FATAL)
     endif
  enddo
  enddo

  ! [9] check the properties of co2 exchange with the atmosphere and set appropriate
  ! flags
  if (canopy_air_mass_for_tracers==0.and.lnd%ico2==NO_TRACER) then
     call error_mesg('land_model_init', &
          'canopy_air_mass_for_tracers is set to zero, and CO2 exchange with the atmosphere is not set up: '// &
          'canopy air CO2 concentration will not be updated',NOTE)
     update_cana_co2 = .FALSE.
  else
     update_cana_co2 = .TRUE.
  end if

  call mpp_clock_end(landInitClock)

end subroutine land_model_init


! ============================================================================
subroutine land_model_end (cplr2land, land2cplr)
  type(atmos_land_boundary_type), intent(inout) :: cplr2land
  type(land_data_type)          , intent(inout) :: land2cplr

  ! ---- local vars
  
  module_is_initialized = .FALSE.

  call error_mesg('land_model_end','writing NetCDF restart',NOTE)
  call land_model_restart()

  ! we still want to call the *_end procedures for component models, even
  ! if the number of tiles in this domain is zero, in case they are doing 
  ! something else besides saving the restart, of if they want to save
  ! restart anyway
  call land_transitions_end()
  call glac_end ()
  call lake_end ()
  call soil_end ()
  call snow_end ()
  call vegn_end ()
  call cana_end ()
  call topo_rough_end()
  call river_end()

  deallocate(frac)
  deallocate(river_land_mask, missing_rivers, no_riv)
  call dealloc_land2cplr(land2cplr, dealloc_discharges=.TRUE.)
  call dealloc_cplr2land(cplr2land)

  call tile_diag_end()

  ! deallocate tiles
  call land_data_end()

  ! finish up the land debugging diagnostics
  call land_debug_end
  
end subroutine land_model_end


! ============================================================================
! write land model restarts 
subroutine land_model_restart(timestamp)
  character(*), intent(in), optional :: timestamp ! timestamp to add to the file name
  
  ! ---- local vars
  integer :: tile_dim_length ! length of tile dimension in output files 
                             ! global max of number of tiles per gridcell 
  integer :: i,j,k
  integer :: unit ! netcdf id of the restart file
  character(256) :: timestamp_

  ! [1] count all land tiles and determine the length of tile dimension
  ! sufficient for the current domain
  tile_dim_length = 0
  do j = lnd%js, lnd%je
  do i = lnd%is, lnd%ie
     k = nitems(lnd%tile_map(i,j))
     tile_dim_length = max(tile_dim_length,k)
  enddo
  enddo

  ! [2] calculate the tile dimension length by taking the max across all domains
  call mpp_max(tile_dim_length)
  if (tile_dim_length==0) then
     call error_mesg('land_model_restart',&
       'No land points exist (tile_dim_length=0), therefore no land restarts will be saved',&
       WARNING)
     return
  endif
   
  ! [3] create tile output file
  timestamp_=''
  if (present(timestamp)) then
     if(trim(timestamp)/='') timestamp_=trim(timestamp)//'.'
  endif
  call create_tile_out_file(unit,'RESTART/'//trim(timestamp_)//'land.res.nc', &
       lnd%coord_glon, lnd%coord_glat, land_tile_exists, tile_dim_length)
     
  ! [4] write data fields
  ! write fractions and tile tags
  call write_tile_data_r0d_fptr(unit,'frac',land_frac_ptr,'fractional area of tile')
  call write_tile_data_i0d_fptr(unit,'glac',glac_tag_ptr,'tag of glacier tiles')
  call write_tile_data_i0d_fptr(unit,'lake',lake_tag_ptr,'tag of lake tiles')
  call write_tile_data_i0d_fptr(unit,'soil',soil_tag_ptr,'tag of soil tiles')
  call write_tile_data_i0d_fptr(unit,'vegn',vegn_tag_ptr,'tag of vegetation tiles')
  ! write the upward long-wave flux 
  call write_tile_data_r0d_fptr(unit,'lwup',land_lwup_ptr,'upward long-wave flux')
  ! write energy residuals
  call write_tile_data_r0d_fptr(unit,'e_res_1',land_e_res_1_ptr,&
       'energy residual in canopy air energy balance equation', 'W/m2')
  call write_tile_data_r0d_fptr(unit,'e_res_2',land_e_res_2_ptr,&
       'energy residual in canopy energy balance equation', 'W/m2')
  
  ! [5] close file
  __NF_ASRT__(nf_close(unit))

  ! [6] save component models' restarts
  call save_land_transitions_restart(timestamp_)
  call save_glac_restart(tile_dim_length,timestamp_)
  call save_lake_restart(tile_dim_length,timestamp_)
  call save_soil_restart(tile_dim_length,timestamp_)
  call save_snow_restart(tile_dim_length,timestamp_)
  call save_vegn_restart(tile_dim_length,timestamp_)
  call save_cana_restart(tile_dim_length,timestamp_)
  call save_river_restart(timestamp_)

end subroutine land_model_restart

! ============================================================================
subroutine land_cover_cold_start(lnd)
  type(land_state_type), intent(inout) :: lnd

  ! ---- local vars
  real, dimension(:,:,:), pointer :: &
       glac, soil, lake, vegn ! arrays of fractions for respective sub-models
  logical, dimension(lnd%ie-lnd%is+1,lnd%je-lnd%js+1) :: &
       land_mask, valid_data, invalid_data
  integer :: iwatch,jwatch,kwatch,face
  integer :: i,j
  integer :: ps,pe ! boundaries of PE list for remapping
  type(horiz_remap_type) :: map

  ! calculate the global land mask
  land_mask = lnd%area > 0

  ! get the global maps of fractional covers for each of the sub-models
  glac=>glac_cover_cold_start(land_mask,lnd%lonb,lnd%latb)
  lake=>lake_cover_cold_start(land_mask,lnd%lonb,lnd%latb,lnd%domain)
  soil=>soil_cover_cold_start(land_mask,lnd%lonb,lnd%latb)
  vegn=>vegn_cover_cold_start(land_mask,lnd%lonb,lnd%latb)

  ! remove any input lake fraction in coastal cells
  where (frac.lt. 1.-gfrac_tol) lake(:,:,1) = 0.
  ! NOTE that the lake area in the coastal cells can be set to non-zero
  ! again by the "ground fraction reconciliation code" below. Strictly
  ! speaking the above line of code should be replaced with the section
  ! commented out with "!-zero" below, but we preserve the old way to avoid
  ! backward incompatibility with older runs. This needs updating in the
  ! future when the decision about what to do with lakes in coastal cells is
  ! made.

  ! reconcile ground fractions with the land mask within compute domain
  valid_data = land_mask.and.(sum(glac,3)+sum(lake,3)+sum(soil,3)>0)
  invalid_data = land_mask.and..not.valid_data

  call get_watch_point(iwatch,jwatch,kwatch,face)
  if (face==lnd%face.and.(lnd%is<=iwatch.and.iwatch<=lnd%ie).and.(lnd%js<=jwatch.and.jwatch<=lnd%je)) then
     write(*,*)'###### land_cover_cold_start: input data #####'
     write(*,'(99(a,i4.2,x))')'iwatch=',iwatch,'jwatch=',jwatch,'face=',lnd%face
     write(*,'(99(a,g23.16,x))')'lon=',lnd%lon(iwatch,jwatch)*180/PI,'lat=',lnd%lat(iwatch,jwatch)*180/PI
     ! calculate local compute domain indices; we assume glac,lake,soil,vegn all
     ! have the same lbounds
     i = iwatch-lnd%is+lbound(glac,1); j = jwatch-lnd%js+lbound(glac,2)
     __DEBUG2__(lnd%is,lnd%js)
     write(*,'(a,99(a,i4.2,x))')'local indices:','i=',i,'j=',j
     __DEBUG3__(frac(iwatch,jwatch),land_mask(i,j),valid_data(i,j))
     __DEBUG1__(glac(i,j,:))
     __DEBUG1__(lake(i,j,:))
     __DEBUG1__(soil(i,j,:))
     __DEBUG1__(vegn(i,j,:))
  endif

  if (trim(nearest_point_search)=='global') then
     ps=0 ; pe=size(lnd%pelist)-1
  else if (trim(nearest_point_search)=='face') then
     ! this assumes that the number of PEs is divisible by the number of
     ! mosaic faces. lnd%pelist starts with 0
     ps = size(lnd%pelist)/lnd%nfaces*(lnd%face-1)
     pe = size(lnd%pelist)/lnd%nfaces*lnd%face - 1
  else
     call error_mesg('land_cover_cold_start',&
          'option nearest_point_search="'//trim(nearest_point_search)//&
          '" is illegal, use "global" or "face"',&
          FATAL)
  endif
  call horiz_remap_new(invalid_data,valid_data,lnd%lon,lnd%lat,lnd%domain,&
          lnd%pelist(ps:pe),map)
  if (print_remapping) call horiz_remap_print(map,'land cover remap:')
  call horiz_remap(map,lnd%domain,glac)
  call horiz_remap(map,lnd%domain,lake)
  call horiz_remap(map,lnd%domain,soil)
  call horiz_remap_del(map)

!-zero  ! remove any input lake fraction in coastal cells
!-zero  do j = lnd%js,lnd%je
!-zero  do i = lnd%is,lnd%ie
!-zero     call set_current_point(i,j,1)
!-zero     if (frac(i,j) < 1-gfrac_tol) then
!-zero        lake(i,j,:) = 0.0
!-zero        if(is_watch_point())then
!-zero           write(*,*)'###### land_cover_cold_start: lake fraction is set to zero #####'
!-zero        endif
!-zero     endif
!-zero  enddo
!-zero  enddo
  
  ! reconcile vegetation fractions with the land mask within compute domain
  valid_data = sum(vegn,3) > 0
  invalid_data = .FALSE.
  do j = 1,size(land_mask,2)
  do i = 1,size(land_mask,1)
     if(.not.land_mask(i,j)) cycle ! skip ocean points
     if(valid_data(i,j)) cycle ! don't need to do anything with valid points
     if(sum(glac(i,j,:))+sum(lake(i,j,:))>=1) &
          cycle                ! skip points fully covered by glaciers or lakes
     invalid_data(i,j)=.TRUE.
  enddo
  enddo
  call horiz_remap_new(invalid_data,valid_data,lnd%lon,lnd%lat,lnd%domain,&
       lnd%pelist(ps:pe),map)
  if (print_remapping) call horiz_remap_print(map,'vegetation cover remap:')
  call horiz_remap(map,lnd%domain,vegn)
  call horiz_remap_del(map)
  
  ! create tiles
  do j = 1,size(land_mask,2)
  do i = 1,size(land_mask,1)
     if(.not.land_mask(i,j)) cycle ! skip ocean points
     call set_current_point(i+lnd%is-1,j+lnd%js-1,1)
     call land_cover_cold_start_0d &
          (lnd%tile_map(i+lnd%is-1,j+lnd%js-1),glac(i,j,:),lake(i,j,:),soil(i,j,:),vegn(i,j,:))
     if(nitems(lnd%tile_map(i+lnd%is-1,j+lnd%js-1))==0) then
        call error_mesg('land_cover_cold_start',&
             'No tiles were created for a valid land point at i='&
             //trim(string(lnd%is+i-1))//' j='//trim(string(lnd%js+j-1))//' face='//trim(string(lnd%face)), FATAL)
     endif
  enddo
  enddo

  deallocate(glac,lake,soil,vegn)
  
end subroutine land_cover_cold_start

! ============================================================================
subroutine land_cover_cold_start_0d (set,glac0,lake0,soil0,vegn0)
  type(land_tile_list_type), intent(inout) :: set 
  real, dimension(:)       , intent(in) :: &
       glac0,lake0,soil0,vegn0 ! fractions of area

  ! ---- local vars
  real :: glac(size(glac0(:))), lake(size(lake0(:))), &
          soil(size(soil0(:))), vegn(size(vegn0(:)))
  type(land_tile_type), pointer :: tile
  integer :: i,j,k
  real :: factor ! normalizing factor for the tile areas
  real :: frac
  type(land_tile_enum_type) :: first_non_vegn ! position of first non-vegetated tile in the list

  glac = glac0; lake = lake0; soil = soil0; vegn = vegn0
  if (sum(glac)>1) &
       glac=glac/sum(glac)
  if (sum(lake)+sum(glac)>1)&
       lake = lake*(1-sum(glac))/sum(lake)
  if (sum(lake)<min_sum_lake_frac) lake=0
  if (sum(soil)+sum(glac)+sum(lake)>1)&
       soil = soil*(1-sum(lake)-sum(glac))/sum(soil)
  ! make sure that the sum of the fractions of the soil, lake, and glaciers are 
  ! either one or zero
  factor = sum(soil)+sum(glac)+sum(lake)
  if(factor>0)then
     glac = glac/factor
     lake = lake/factor
     soil = soil/factor
  endif

  ! remove soil/glac/lake fractions that are too small
  if (min_frac>0) then
     where (glac<min_frac) glac = 0
     where (lake<min_frac) lake = 0
     where (soil<min_frac) soil = 0
     ! do the renormalization again
     factor = sum(soil)+sum(glac)+sum(lake)
     if(factor>0)then
	glac = glac/factor
	lake = lake/factor
	soil = soil/factor
     endif
  endif

  if(is_watch_point()) then
     write(*,*)'#### land_cover_cold_start_0d input data ####'
     __DEBUG1__(glac0)
     __DEBUG1__(lake0)
     __DEBUG1__(soil0)
     __DEBUG1__(vegn0)
     __DEBUG1__(factor)
     write(*,*)'#### land_cover_cold_start_0d renormlaized fractions ####'
     __DEBUG1__(glac)
     __DEBUG1__(lake)
     __DEBUG1__(soil)
     __DEBUG1__(vegn)
  endif

  do i = 1,size(glac)
     if (glac(i)>0) then
        tile => new_land_tile(frac=glac(i),glac=i)
        call insert(tile,set)
        if(is_watch_point()) then
           write(*,*)'created glac tile: frac=',glac(i),' tag=',i
        endif
     endif
  enddo
  do i = 1,size(lake)
     if (lake(i)>0) then
        tile => new_land_tile(frac=lake(i),lake=i)
        call insert(tile,set)
        if(is_watch_point()) then
           write(*,*)'created lake tile: frac=',lake(i),' tag=',i
        endif
     endif
  enddo

  factor = sum(soil)*sum(vegn)
  if (factor/=0) factor = 1/factor
  factor = factor*(1-sum(glac)-sum(lake))
  ! vegetation tiles, if any, are inserted in front of non-vegetated tiles;
  ! this really doesn't matter except for the static vegetation override
  ! case with the data saved by lm3v -- there the vegetation tiles are
  ! in front, so it works more consistently where lad2 has more than 
  ! one tile (e.g. glac/soil or lake/soil), if lad2 vegetation tiles are 
  ! also in front of the list. 
  first_non_vegn=first_elmt(set)
  do i = 1,size(soil)
  do j = 1,size(vegn)
     frac = soil(i)*vegn(j)*factor
     if(frac>0) then
        tile  => new_land_tile(frac=frac,soil=i,vegn=j)
        call insert(tile,first_non_vegn)
        if(is_watch_point()) then
           write(*,*)'created soil tile: frac=', frac, ' soil tag=',i, ' veg tag=',j
        endif
     endif
  enddo
  enddo

end subroutine land_cover_cold_start_0d

! ============================================================================
! reads the land restart file and restores the tiling structure from this file
subroutine land_cover_warm_start ( restart_file_name, lnd )
  character(len=*), intent(in) :: restart_file_name
  type(land_state_type), intent(inout) :: lnd
    
  ! ---- local vars
  integer, allocatable :: idx(:) ! compressed tile index
  integer, allocatable :: glac(:), lake(:), soil(:), snow(:), cana(:), vegn(:) ! tile tags
  real,    allocatable :: frac(:) ! fraction of land covered by tile
  integer :: ncid ! unit number of the input file
  integer :: ntiles    ! total number of land tiles in the input file
  integer :: bufsize   ! size of the input buffer
  integer :: dimids(1) ! id of tile dimension
  character(NF_MAX_NAME) :: tile_dim_name ! name of the tile dimension and respective variable
  integer :: i,j,k,it
  type(land_tile_type), pointer :: tile;
  integer :: start, count ! slab for reading
  ! netcdf variable IDs
  integer :: id_idx, id_frac, id_glac, id_lake, id_soil, id_vegn
  
  __NF_ASRT__(nf_open(restart_file_name,NF_NOWRITE,ncid))
  ! allocate the input data
  __NF_ASRT__(nfu_inq_var(ncid,'frac',id=id_frac,varsize=ntiles,dimids=dimids))
   ! allocate input buffers for compression index and the variable
  bufsize=min(input_buf_size,ntiles)
  allocate(idx (bufsize), glac(bufsize), lake(bufsize), soil(bufsize), &
           snow(bufsize), cana(bufsize), vegn(bufsize), frac(bufsize)  )
  ! get the name of the fist (and only) dimension of the variable 'frac' -- this
  ! is supposed to be the compressed dimension, and associated variable will
  ! hold the compressed indices
  __NF_ASRT__(nfu_inq_dim(ncid,dimids(1),name=tile_dim_name))
  __NF_ASRT__(nfu_inq_var(ncid,tile_dim_name,id=id_idx))
  ! get the IDs of the varables to read
  __NF_ASRT__(nfu_inq_var(ncid,'glac',id=id_glac))
  __NF_ASRT__(nfu_inq_var(ncid,'lake',id=id_lake))
  __NF_ASRT__(nfu_inq_var(ncid,'soil',id=id_soil))
  __NF_ASRT__(nfu_inq_var(ncid,'vegn',id=id_vegn))
  
  do start = 1,ntiles,bufsize
    count = min(bufsize,ntiles-start+1)
    ! read the compressed tile indices
    __NF_ASRT__(nf_get_vara_int(ncid,id_idx,(/start/),(/count/),idx))
    ! read input data -- fractions and tags
    __NF_ASRT__(nf_get_vara_double(ncid,id_frac,(/start/),(/count/),frac))
    __NF_ASRT__(nf_get_vara_int(ncid,id_glac,(/start/),(/count/),glac))
    __NF_ASRT__(nf_get_vara_int(ncid,id_lake,(/start/),(/count/),lake))
    __NF_ASRT__(nf_get_vara_int(ncid,id_soil,(/start/),(/count/),soil))
    __NF_ASRT__(nf_get_vara_int(ncid,id_vegn,(/start/),(/count/),vegn))
  
    ! create tiles
    do it = 1,count
       k = idx(it)
       if (k<0) cycle ! skip negative indices
       i = modulo(k,lnd%nlon)+1; k = k/lnd%nlon
       j = modulo(k,lnd%nlat)+1; k = k/lnd%nlat
       k = k + 1
       if (i<lnd%is.or.i>lnd%ie) cycle
       if (j<lnd%js.or.j>lnd%je) cycle
       ! the size of the tile set at the point (i,j) must be equal to k
       tile=>new_land_tile(frac=frac(it),&
                glac=glac(it),lake=lake(it),soil=soil(it),vegn=vegn(it))
       call insert(tile,lnd%tile_map(i,j))
    enddo
  enddo
  __NF_ASRT__(nf_close(ncid))
  deallocate(idx, glac, lake, soil, snow, cana, vegn, frac)
end subroutine


! ============================================================================
subroutine update_land_model_fast ( cplr2land, land2cplr )
  type(atmos_land_boundary_type), intent(in)    :: cplr2land
  type(land_data_type)          , intent(inout) :: land2cplr

  ! ---- local vars 
  real :: fco2_0,Dfco2Dq , & ! co2 flux from canopy air to the atmosphere
       ISa_dn_dir(NBANDS), & ! downward direct sw radiation at the top of the canopy
       ISa_dn_dif(NBANDS), & ! downward diffuse sw radiation at the top of the canopy
       cana_q

  ! variables for stock calculations
  real :: &
     cana_VMASS, cana_HEAT,             &
     vegn_LMASS, vegn_FMASS, vegn_HEAT, &
     snow_LMASS, snow_FMASS, snow_HEAT, &
     subs_LMASS, subs_FMASS, subs_HEAT, &
     glac_LMASS, glac_FMASS, glac_HEAT, &
     lake_LMASS, lake_FMASS, lake_HEAT, &
     soil_LMASS, soil_FMASS, soil_HEAT 

  real, dimension(lnd%is:lnd%ie,lnd%js:lnd%je) :: &
       runoff,           & ! total (liquid+snow) runoff accumulated over tiles in cell
       runoff_snow,      & ! runoff snow accumulated over tiles in cell
       runoff_heat,      & ! runoff heat accumulated over tiles in cell
       heat_frac_liq,    & ! fraction of runoff heat in liquid
       discharge_l,      & ! discharge of liquid water to ocean
       discharge_sink      ! container to collect small/negative values for later accounting
  real, dimension(lnd%is:lnd%ie,lnd%js:lnd%je,num_species) :: &
       runoff_c,         & ! runoff of tracers accumulated over tiles in cell
       discharge_c         ! discharge of tracers to ocean
  logical :: used          ! return value of send_data diagnostics routine
  real, allocatable :: runoff_1d(:),runoff_snow_1d(:),runoff_heat_1d(:)
  integer :: i,j,k     ! lon, lat, and tile indices
  integer :: i_species ! river tracer iterator
  integer :: i1        ! index used to iterate over grid cells efficiently
  integer :: is,ie,js,je ! horizontal bounds of the override buffer
  type(land_tile_enum_type) :: ce, te ! tile enumarator
  type(land_tile_type), pointer :: tile ! pointer to current tile
  
  ! variables for data override
  real, allocatable :: phot_co2_data(:,:)  ! buffer for data
  logical           :: phot_co2_overridden ! flag indicating successful override
  

  ! start clocks
  call mpp_clock_begin(landClock)
  call mpp_clock_begin(landFastClock)

  ! to avoid output of static vegetation after the transitions worked and
  ! changed the tiling structure, static vegetation output is done here.
  call write_static_vegn()

  ! override data at the beginning of the time step
  is=lbound(cplr2land%t_flux,1) ; ie = is+size(cplr2land%t_flux,1)-1
  js=lbound(cplr2land%t_flux,2) ; je = js+size(cplr2land%t_flux,2)-1
  allocate(phot_co2_data(is:ie,js:je))
  call data_override('LND','phot_co2',phot_co2_data,lnd%time, &
       override=phot_co2_overridden)
  
  ! clear the runoff values, for accumulation over the tiles
  runoff = 0 ; runoff_snow = 0 ; runoff_heat = 0  ; runoff_c = 0

  ! main tile loop
!$OMP parallel do schedule(dynamic) default(shared) private(i1,i,j,k,ce,te,tile,fco2_0,Dfco2Dq,ISa_dn_dir,ISa_dn_dif)
  do i1 = 0,(ie-is+1)*(je-js+1)-1
     i = mod(i1,ie-is+1)+is
     j = i1/(ie-is+1)+js
!     __DEBUG4__(is,js,i-is+lnd%is,j-js+lnd%js)
     ce = first_elmt(lnd%tile_map(i-is+lnd%is,j-js+lnd%js))
     te = tail_elmt (lnd%tile_map(i-is+lnd%is,j-js+lnd%js))
     k = 0 
     do while (ce/=te)
        k = k+1 ; tile=>current_tile(ce) ; ce = next_elmt(ce)
   
        ! set this point coordinates as current for debug output
        call set_current_point(i-is+lnd%is,j-js+lnd%js,k)
   
        if (lnd%ico2/=NO_TRACER) then
           fco2_0  = cplr2land%tr_flux(i,j,k, lnd%ico2)
           Dfco2Dq = cplr2land%dfdtr  (i,j,k, lnd%ico2)
        else
           fco2_0  = 0
           Dfco2Dq = 0
        endif
        ISa_dn_dir(BAND_VIS) = cplr2land%sw_flux_down_vis_dir(i,j,k)
        ISa_dn_dir(BAND_NIR) = cplr2land%sw_flux_down_total_dir(i,j,k)&
                              -cplr2land%sw_flux_down_vis_dir(i,j,k)
        ISa_dn_dif(BAND_VIS) = cplr2land%sw_flux_down_vis_dif(i,j,k)
        ISa_dn_dif(BAND_NIR) = cplr2land%sw_flux_down_total_dif(i,j,k)&
                              -cplr2land%sw_flux_down_vis_dif(i,j,k)
   
        call update_land_model_fast_0d(tile, i,j,k, land2cplr, &
           cplr2land%lprec(i,j,k),  cplr2land%fprec(i,j,k), cplr2land%tprec(i,j,k), &
           cplr2land%t_flux(i,j,k), cplr2land%dhdt(i,j,k), &
           cplr2land%tr_flux(i,j,k, lnd%isphum), cplr2land%dfdtr(i,j,k, lnd%isphum), &
           fco2_0, Dfco2Dq, &
           ISa_dn_dir, ISa_dn_dif, cplr2land%lwdn_flux(i,j,k), &
           cplr2land%ustar(i,j,k), cplr2land%p_surf(i,j,k), cplr2land%drag_q(i,j,k), &
           phot_co2_overridden, phot_co2_data(i,j),&
           runoff(i,j), runoff_heat(i,j), runoff_snow(i,j) &
        )
        ! some of the diagnostic variables are sent from here, purely for coding 
        ! convenince: the compute domain-level 2d and 3d vars are generaly not 
        ! available inside update_land_model_fast_0d, so the diagnostics for those 
        ! was left here.
        call send_tile_data(id_area, tile%frac*lnd%area(i,j),        tile%diag)
        call send_tile_data(id_z0m,  land2cplr%rough_mom(i,j,k),     tile%diag)
        call send_tile_data(id_z0s,  land2cplr%rough_heat(i,j,k),    tile%diag)
        call send_tile_data(id_Trad, land2cplr%t_surf(i,j,k),        tile%diag)
        call send_tile_data(id_Tca,  land2cplr%t_ca(i,j,k),          tile%diag)
        call send_tile_data(id_qca,  land2cplr%tr(i,j,k,lnd%isphum), tile%diag)
	call send_tile_data(id_cd_m, cplr2land%cd_m(i,j,k),          tile%diag)
	call send_tile_data(id_cd_t, cplr2land%cd_t(i,j,k),          tile%diag)
     enddo
  enddo
  
  ! set values of tracer fluxes
  runoff_c(:,:,1) = runoff_snow
  runoff_c(:,:,2) = runoff_heat
  do i_species = num_phys+1, num_species
    runoff_c(:,:,i_species) = 0        ! age, species
    enddo

!=================================================================================
  ! update river state
  call update_river(runoff, runoff_c, discharge_l, discharge_c)
!=================================================================================

  discharge_l = discharge_l/lnd%cellarea
  do i_species = 1, num_species
    discharge_c(:,:,i_species) =  discharge_c(:,:,i_species)/lnd%cellarea
    enddo

  ! pass through to ocean the runoff that was not seen by river module because of land_frac diffs.
  ! need to multiply by gfrac to spread over whole cell
  where (missing_rivers) discharge_l = (runoff-runoff_c(:,:,1))*frac
  do i_species = 1, num_species
    where (missing_rivers) &
     discharge_c(:,:,i_species) = runoff_c(:,:,i_species)*frac
  enddo

  ! don't send negatives or insignificant values to ocean. put them in the sink instead.
  ! this code does not seem necessary, and default discharge_tol value should be used.
  discharge_sink = 0.
  where (discharge_l.le.discharge_tol)
      discharge_sink = discharge_sink + discharge_l
      discharge_l    = 0.
    endwhere
  where (discharge_c(:,:,1).le.discharge_tol)
      discharge_sink     = discharge_sink + discharge_c(:,:,1)
      discharge_c(:,:,1) = 0.
    endwhere

  ! find phase partitioning ratio for discharge sensible heat flux
  where (discharge_l.gt.0. .or. discharge_c(:,:,1).gt.0.)
      heat_frac_liq = clw*discharge_l / (clw*discharge_l+csw*discharge_c(:,:,1))
    elsewhere
      heat_frac_liq = 1.
    endwhere

  ! scale up fluxes sent to ocean to compensate for non-ocean fraction of discharge cell.
  ! split heat into liquid and solid streams
  where (frac.lt.1.) 
      land2cplr%discharge           = discharge_l        / (1-frac)
      land2cplr%discharge_snow      = discharge_c(:,:,1) / (1-frac)
      land2cplr%discharge_heat      = heat_frac_liq*discharge_c(:,:,2) / (1-frac)
      land2cplr%discharge_snow_heat =               discharge_c(:,:,2) / (1-frac) &
                                     - land2cplr%discharge_heat
    endwhere

  ce = first_elmt(lnd%tile_map,                  &
              is=lbound(cplr2land%t_flux,1), &
              js=lbound(cplr2land%t_flux,2)  )
  te = tail_elmt(lnd%tile_map)
  do while(ce /= te)
     call get_elmt_indices(ce,i,j,k)
     tile => current_tile(ce)
     ce=next_elmt(ce)
     cana_VMASS = 0. ;                   cana_HEAT = 0.
     vegn_LMASS = 0. ; vegn_FMASS = 0. ; vegn_HEAT = 0.
     snow_LMASS = 0. ; snow_FMASS = 0. ; snow_HEAT = 0.
     subs_LMASS = 0. ; subs_FMASS = 0. ; subs_HEAT = 0.
     glac_LMASS = 0. ; glac_FMASS = 0. ; glac_HEAT = 0.
     lake_LMASS = 0. ; lake_FMASS = 0. ; lake_HEAT = 0.
     soil_LMASS = 0. ; soil_FMASS = 0. ; soil_HEAT = 0.
     if (associated(tile%cana)) then
         call cana_state( tile%cana, cana_q=cana_q )
         cana_VMASS = canopy_air_mass*cana_q
         cana_HEAT  = cana_tile_heat(tile%cana)
       endif
     if (associated(tile%vegn)) then
         call vegn_tile_stock_pe(tile%vegn, vegn_LMASS, vegn_FMASS)
         vegn_HEAT = vegn_tile_heat(tile%vegn)
       endif
     if(associated(tile%snow)) then
         call snow_tile_stock_pe(tile%snow, snow_LMASS, snow_FMASS)
         snow_HEAT = snow_tile_heat(tile%snow)
     endif
     if (associated(tile%glac)) then
         call glac_tile_stock_pe(tile%glac, subs_LMASS, subs_FMASS)
         subs_HEAT  = glac_tile_heat(tile%glac)
         glac_LMASS = subs_LMASS
         glac_FMASS = subs_FMASS
         glac_HEAT  = subs_HEAT
       else if (associated(tile%lake)) then
         call lake_tile_stock_pe(tile%lake, subs_LMASS, subs_FMASS)
         subs_HEAT  = lake_tile_heat(tile%lake)
         lake_LMASS = subs_LMASS
         lake_FMASS = subs_FMASS
         lake_HEAT  = subs_HEAT
       else if (associated(tile%soil)) then
         call soil_tile_stock_pe(tile%soil, subs_LMASS, subs_FMASS)
         subs_HEAT  = soil_tile_heat(tile%soil)
         soil_LMASS = subs_LMASS
         soil_FMASS = subs_FMASS
         soil_HEAT  = subs_HEAT
       endif

     call send_tile_data(id_VWS,  cana_VMASS, tile%diag)
     call send_tile_data(id_VWSc, cana_VMASS, tile%diag)
     call send_tile_data(id_LWS,  vegn_LMASS+snow_LMASS+subs_LMASS, tile%diag)
     call send_tile_data(id_LWSv, vegn_LMASS, tile%diag)
     call send_tile_data(id_LWSs, snow_LMASS, tile%diag)
     call send_tile_data(id_LWSg, subs_LMASS, tile%diag)
     call send_tile_data(id_FWS,  vegn_FMASS+snow_FMASS+subs_FMASS, tile%diag)
     call send_tile_data(id_FWSv, vegn_FMASS, tile%diag)
     call send_tile_data(id_FWSs, snow_FMASS, tile%diag)
     call send_tile_data(id_FWSg, subs_FMASS, tile%diag)
     call send_tile_data(id_HS,  vegn_HEAT+snow_HEAT+subs_HEAT+cana_HEAT, tile%diag)
     call send_tile_data(id_HSv, vegn_HEAT, tile%diag)
     call send_tile_data(id_HSs, snow_HEAT, tile%diag)
     call send_tile_data(id_HSg, subs_HEAT, tile%diag)
     call send_tile_data(id_HSc, cana_HEAT, tile%diag)
     call send_tile_data(id_water, subs_LMASS+subs_FMASS, tile%diag)
     call send_tile_data(id_snow,  snow_LMASS+snow_FMASS, tile%diag)
     enddo

  ! advance land model time
  lnd%time = lnd%time + lnd%dt_fast

  ! send the accumulated diagnostics to the output
  call dump_tile_diag_fields(lnd%tile_map, lnd%time)

  if (id_dis_liq > 0)  used = send_data (id_dis_liq,  discharge_l,        lnd%time) 
  if (id_dis_ice > 0)  used = send_data (id_dis_ice,  discharge_c(:,:,1), lnd%time) 
  if (id_dis_heat > 0) used = send_data (id_dis_heat, discharge_c(:,:,2), lnd%time) 
  if (id_dis_sink > 0) used = send_data (id_dis_sink, discharge_sink,     lnd%time) 

  ! deallocate override buffer
  deallocate(phot_co2_data)

  call mpp_clock_end(landFastClock)
  call mpp_clock_end(landClock)
end subroutine update_land_model_fast


! ============================================================================
subroutine update_land_model_fast_0d(tile, i,j,k, land2cplr, &
   precip_l, precip_s, atmos_T, &
   Ha0, DHaDTc, Ea0, DEaDqc, fco2_0, Dfco2Dq,&
   ISa_dn_dir, ISa_dn_dif, ILa_dn, &
   ustar, p_surf, drag_q, &
   phot_co2_overridden, phot_co2_data, &
   runoff, runoff_heat, runoff_snow &
   )
  type (land_tile_type), pointer :: tile
  type(land_data_type), intent(inout) :: land2cplr
  integer, intent(in) :: i,j,k ! coordinates
  real, intent(in) :: &
       precip_l, precip_s, & ! liquid and solid precipitation, kg/(m2 s)
       atmos_T, &        ! incoming precipitation temperature (despite its name), deg K
       Ha0,   DHaDTc, &  ! sensible heat flux from the canopy air to the atmosphere 
       Ea0,   DEaDqc, &  ! water vapor flux from canopy air to the atmosphere
       fco2_0,Dfco2Dq,&  ! co2 flux from canopy air to the atmosphere
       ISa_dn_dir(NBANDS), & ! downward direct sw radiation at the top of the canopy
       ISa_dn_dif(NBANDS), & ! downward diffuse sw radiation at the top of the canopy
       ILa_dn,             & ! downward lw radiation at the top of the canopy
       ustar,              & ! friction velocity, m/s
       p_surf,             & ! surface pressure, Pa
       drag_q,             & !
       phot_co2_data         ! data input for the CO2 for photosynthesis

  logical, intent(in):: phot_co2_overridden
  real, intent(inout) :: &
        runoff, runoff_heat, runoff_snow

  ! ---- local constants
  ! indices of variables and equations for implicit time stepping solution :
  integer, parameter :: iqc=1, iTc=2, iTv=3, iwl=4, iwf=5

  ! ---- local vars 
  real :: A(5,5),B0(5),B1(5),B2(5) ! implicit equation matrix and right-hand side vectors
  real :: A00(5,5),B10(5),B00(5) ! copy of the above, only for debugging
  integer :: indx(5) ! permutation vector
  ! linearization coefficients of various fluxes between components of land
  ! surface scheme
  real :: &
       G0,    DGDTg,  &  ! ground heat flux 
       Hv0,   DHvDTv,   DHvDTc, & ! sens heat flux from vegetation
       Et0,   DEtDTv,   DEtDqc,   DEtDwl,   DEtDwf,  & ! transpiration
       Eli0,  DEliDTv,  DEliDqc,  DEliDwl,  DEliDwf, & ! evaporation of intercepted water
       Esi0,  DEsiDTv,  DEsiDqc,  DEsiDwl,  DEsiDwf, & ! sublimation of intercepted snow
       Hg0,   DHgDTg,   DHgDTc, & ! linearization of the sensible heat flux from ground
       Eg0,   DEgDTg,   DEgDqc, DEgDpsig, & ! linearization of evaporation from ground
       flwv0,  DflwvDTg,  DflwvDTv,& ! linearization of net LW radiation to the canopy
       flwg0,  DflwgDTg,  DflwgDTv,& ! linearization of net LW radiation to the canopy
       vegn_drip_l, vegn_drip_s, & ! drip rate of water and snow, respectively, kg/(m2 s)
       vegn_lai
  
  ! increments of respective variables over time step, results of the implicit
  ! time step:
  real :: delta_qc, delta_Tc, delta_Tv, delta_wl, delta_ws, delta_Tg, delta_psig
  real :: flwg ! updated value of long-wave ground energy balance
  real :: vegn_emis_lw, surf_emis_lw ! emissivities of ground and surface
  real :: vegn_emsn,    surf_emsn    ! emission by vegetation and surface, respectively
  real :: denom ! denominator in the LW radiative balance calculations
  real :: sum0, sum1

  real :: &
       grnd_T, gT, & ! ground temperature and its value used for sensible heat advection
       vegn_T, vT, & ! vegetation (canopy) temperature
       cana_T, cT, & ! canopy air temperature
       evap_T, eT, & ! temperature assigned to vapor going between land and atmosphere
       soil_uptake_T, & ! average temperature of water taken up by the vegetation
       vegn_Wl,  vegn_Ws, & ! water and snow mass of the canopy
       vegn_ifrac, & ! intercepted fraction of liquid or frozen precipitation
       vegn_hcap,      & ! vegetation heat capacity, including intercepted water and snow
       vegn_fco2, & ! co2 flux from the vegetation, kg CO2/(m2 s)
       hlv_Tv, hlv_Tu, & ! latent heat of vaporization at vegn and uptake temperatures, respectively 
       hls_Tv, &         ! latent heat of sublimation at vegn temperature
       grnd_rh,        & ! explicit relative humidity at ground surface
       grnd_rh_psi,    & ! psi derivative of relative humidity at ground surface
       grnd_liq, grnd_ice, grnd_subl, &
       grnd_tf, &  ! temperature of freezing on the ground
       grnd_latent, &
       grnd_flux, &
       grnd_E_min, &
       grnd_E_max, &
       soil_E_min, &
       soil_E_max, &
       soil_beta, &
       RSv(NBANDS), & ! net short-wave radiation balance of the canopy, W/m2
       con_g_h, con_g_v, & ! turbulent cond. between ground and canopy air, for heat and vapor respectively
       snow_area, &
       cana_q, & ! specific humidity of canopy air
       cana_co2, & ! co2 moist mixing ratio in canopy air, kg CO2/kg wet air
       cana_co2_mol, & ! co2 dry mixing ratio in canopy air, mol CO2/mol dry air
       fswg, evapg, sensg, &
       subs_G, subs_G2, Mg_imp, snow_G_Z, snow_G_TZ, &
       snow_avrg_T, delta_T_snow,  & ! vertically-average snow temperature and it's change due to s
       vegn_ovfl_l,  vegn_ovfl_s,  & ! overflow of liquid and solid water from the canopy
       vegn_ovfl_Hl, vegn_ovfl_Hs, & ! heat flux from canopy due to overflow
       delta_fprec, & ! correction of below-canopy solid precip in case it's average T > tfreeze 

       hprec,              & ! sensible heat flux carried by precipitation
       hevap,              & ! sensible heat flux carried by total evapotranspiration
       land_evap,          & ! total vapor flux from land to atmosphere
       land_sens,          & ! turbulent sensible heat flux from land to atmosphere
       vegn_flw,vegn_sens,snow_sens,snow_levap,snow_fevap,snow_melt,&
       snow_lprec, snow_hlprec,snow_lrunf,vegn_levap,vegn_fevap,vegn_uptk,&
       vegn_fsw, vegn_melt,vegn_lprec,vegn_fprec,vegn_hlprec,vegn_hfprec,&
       precip_T,pT,snow_fsw,snow_flw,snow_frunf,snow_hlrunf,&
       snow_hfrunf,subs_fsw,subs_flw,subs_sens,&
       subs_DT, subs_M_imp, subs_evap, snow_Tbot, snow_Cbot, snow_C, subs_levap,&
       subs_fevap,subs_melt,subs_lrunf,subs_hlrunf,&
       subs_Ttop,subs_Ctop, subs_subl, new_T
  real :: soil_water_supply ! supply of water to roots, per unit active root biomass, kg/m2
  real :: snow_T, snow_rh, snow_liq, snow_ice, snow_subl
  integer :: ii, jj ! indices for debug output
  integer :: ierr
  logical :: conserve_glacier_mass, snow_active, redo_leaf_water
  integer :: canopy_water_step
  real :: subs_z0m, subs_z0s, snow_z0m, snow_z0s, grnd_z0s

  soil_uptake_T = tfreeze ! just to avoid using un-initialized values
  soil_water_supply = 0.0
  if (associated(tile%glac)) then
     call glac_step_1 ( tile%glac, &
          grnd_T, grnd_rh, grnd_liq, grnd_ice, grnd_subl, grnd_tf, &
          snow_G_Z, snow_G_TZ, conserve_glacier_mass  )
     grnd_E_min = -HUGE(grnd_E_min)
     grnd_E_max =  HUGE(grnd_E_max)
     grnd_rh_psi = 0
  else if (associated(tile%lake)) then
     call lake_step_1 ( ustar, p_surf, &
          lnd%lat(i,j), tile%lake, &
          grnd_T, grnd_rh, grnd_liq, grnd_ice, grnd_subl, grnd_tf, &
          snow_G_Z, snow_G_TZ)
     grnd_E_min = -HUGE(grnd_E_min)
     grnd_E_max =  HUGE(grnd_E_max)
     grnd_rh_psi = 0
  else if (associated(tile%soil)) then
     call soil_step_1 ( tile%soil, tile%vegn, tile%diag, &
          grnd_T, soil_uptake_T, soil_beta, soil_water_supply, soil_E_min, soil_E_max, &
          grnd_rh, grnd_rh_psi, grnd_liq, grnd_ice, grnd_subl, grnd_tf, &
          snow_G_Z, snow_G_TZ)
     grnd_E_min = soil_E_min
     grnd_E_max = soil_E_max
     grnd_liq = 0 ! sorry, but solver cannot handle implicit melt anymore
     grnd_ice = 0 ! sorry, but solver cannot handle implicit melt anymore
                  ! no big loss, it's just the surface layer anyway
  else
     call get_current_point(face=ii)
     call error_mesg('update_land_model_fast','none of the surface tiles exist at ('//&
          trim(string(i))//','//trim(string(j))//','//trim(string(k))//&
          ', face='//trim(string(ii))//')',FATAL)
  endif

  subs_subl = grnd_subl

  call snow_step_1 ( tile%snow, snow_G_Z, snow_G_TZ, &
       snow_active, snow_T, snow_rh, snow_liq, snow_ice, &
       snow_subl, snow_area, G0, DGDTg )
  if (snow_active) then
     grnd_T    = snow_T;   grnd_rh   = snow_rh;   grnd_liq  = snow_liq
     grnd_rh_psi = 0
     grnd_ice  = snow_ice; grnd_subl = snow_subl; grnd_tf   = tfreeze
     grnd_E_min = -HUGE(grnd_E_min)
     grnd_E_max =  HUGE(grnd_E_max)
  endif

  call cana_state(tile%cana, cana_T, cana_q, cana_co2)

  if (associated(tile%vegn)) then
  ! Calculate net short-wave radiation input to the vegetation
     RSv    = tile%Sv_dir*ISa_dn_dir + tile%Sv_dif*ISa_dn_dif
     call soil_diffusion(tile%soil, subs_z0s, subs_z0m)
     call snow_diffusion(tile%snow, snow_z0s, snow_z0m)
     grnd_z0s = exp( (1-snow_area)*log(subs_z0s) + snow_area*log(snow_z0s))
     
     ! cana_co2 is moist mass mixing ratio [kg CO2/kg wet air], convert it to dry
     ! volumetric mixing ratio [mol CO2/mol dry air] 
     cana_co2_mol = cana_co2*mol_air/mol_CO2/(1-cana_q)
     if (phot_co2_overridden) cana_co2_mol = phot_co2_data
     call vegn_step_1 ( tile%vegn, tile%soil, tile%diag, &
        p_surf, &
        ustar, &
        drag_q, &
        ISa_dn_dir+ISa_dn_dif, RSv, precip_l, precip_s, &
        tile%land_d, tile%land_z0s, tile%land_z0m, grnd_z0s, & 
        soil_beta, soil_water_supply,&
        cana_T, cana_q, cana_co2_mol, &
        ! output
        con_g_h, con_g_v, &
        vegn_T, vegn_Wl, vegn_Ws, & ! temperature, water and snow mass on the canopy
        vegn_ifrac, vegn_lai, &
        vegn_drip_l, vegn_drip_s,& 
        vegn_hcap, & ! total vegetation heat capacity (including intercepted water/snow)
        Hv0,   DHvDTv,   DHvDTc,            & 
        Et0,   DEtDTv,   DEtDqc,   DEtDwl,   DEtDwf,  & 
        Eli0,  DEliDTv,  DEliDqc,  DEliDwl,  DEliDwf, & 
        Esi0,  DEsiDTv,  DEsiDqc,  DEsiDwl,  DEsiDwf  ) 
	if (LM2) then
	   con_g_h = con_g_h * con_fac_large
	   if (snow_active) then
	      con_g_v = con_g_v * con_fac_large
	   else
              con_g_v = con_g_v * con_fac_small
	   endif
	endif
  else
     RSv    = 0
     con_g_h = con_fac_large ; con_g_v = con_fac_large
     if(associated(tile%glac).and.conserve_glacier_mass.and..not.snow_active) &
          con_g_v = con_fac_small
     vegn_T  = cana_T ; vegn_Wl = 0 ; vegn_Ws = 0
     vegn_ifrac  = 0 ; vegn_lai    = 0
     vegn_drip_l = 0 ; vegn_drip_s = 0
     vegn_hcap = 1.0
     Hv0 =0;  DHvDTv =0;  DHvDTc=0;
     Et0 =0;  DEtDTv =0;  DEtDqc=0;   DEtDwl=0;   DEtDwf=0
     Eli0=0;  DEliDTv=0;  DEliDqc=0;  DEliDwl=0;  DEliDwf=0 
     Esi0=0;  DEsiDTv=0;  DEsiDqc=0;  DEsiDwl=0;  DEsiDwf=0
  endif
  ! calculate net shortwave for ground and canopy
  fswg     = SUM(tile%Sg_dir*ISa_dn_dir + tile%Sg_dif*ISa_dn_dif)
  vegn_fsw = SUM(RSv)
  
  call cana_step_1 (tile%cana, p_surf, con_g_h, con_g_v,   &
       grnd_t, grnd_rh, grnd_rh_psi, &
       Hg0,  DHgDTg, DHgDTc, Eg0, DEgDTg, DEgDqc, DEgDpsig)

! [X.X] using long-wave optical properties, calculate the explicit long-wave 
!       radiative balances and their derivatives w.r.t. temperatures
  vegn_emis_lw = 1 - tile%vegn_refl_lw - tile%vegn_tran_lw
  surf_emis_lw = 1 - tile%surf_refl_lw

  denom = 1-tile%vegn_refl_lw*tile%surf_refl_lw

  vegn_emsn = vegn_emis_lw * stefan * vegn_T**4
  surf_emsn = surf_emis_lw * stefan * grnd_T**4

  flwv0 = ILa_dn * vegn_emis_lw*(1+tile%vegn_refl_lw*tile%surf_refl_lw/denom) &
       + vegn_emsn * (tile%surf_refl_lw*vegn_emis_lw/denom-2) &
       + surf_emsn * vegn_emis_lw/denom
  DflwvDTg = vegn_emis_lw/denom                      * surf_emis_lw * stefan * 4 * grnd_T**3
  DflwvDTv = (tile%surf_refl_lw*vegn_emis_lw/denom-2)* vegn_emis_lw * stefan * 4 * vegn_T**3

  flwg0 = (ILa_dn*tile%vegn_tran_lw + vegn_emsn)*(1-tile%surf_refl_lw)/denom &
       - surf_emsn*(1-tile%vegn_refl_lw)/denom
  DflwgDTg = -(1-tile%vegn_refl_lw)/denom * surf_emis_lw * stefan * 4 * grnd_T**3
  DflwgDTv =  (1-tile%surf_refl_lw)/denom * vegn_emis_lw * stefan * 4 * vegn_T**3

! [X.0] calculate the latent heats of vaporization at appropriate temperatures
  if (use_tfreeze_in_grnd_latent) then
    grnd_latent = hlv + hlf*grnd_subl
  else
    grnd_latent = hlv + (cpw-clw)*(grnd_T-tfreeze) &
               + (hlf + (clw-csw)*(grnd_T-tfreeze)) * grnd_subl
  endif
  if (use_atmos_T_for_precip_T) then
    precip_T = atmos_T
  else
    precip_T = cana_T
  endif
  if (use_atmos_T_for_evap_T) then
    evap_T = atmos_T
  else
    evap_T = cana_T
  endif
  if (use_old_conservation_equations) then
    hlv_Tv = hlv       - (cpw-clw)*tfreeze + cpw*vegn_T
    hls_Tv = hlv + hlf - (cpw-csw)*tfreeze + cpw*vegn_T
    hlv_Tu = hlv       - (cpw-clw)*tfreeze + cpw*vegn_T - clw*soil_uptake_T
    pT = precip_T
    cT = cana_T
    eT = evap_T
    gT = grnd_T
    vT = vegn_T
  else
    hlv_Tv = hlv    + cpw*(vegn_T-tfreeze)
    hls_Tv = hlf    + hlv_Tv
    hlv_Tu = hlv_Tv - clw*(soil_uptake_T-tfreeze)
    pT = precip_T-tfreeze
    cT = cana_T-tfreeze
    eT = evap_T-tfreeze
    gT = grnd_T-tfreeze
    vT = vegn_T-tfreeze
  endif

  do canopy_water_step = 1,2
     if(is_watch_point()) then
        write(*,*)'#### input data for the matrix ####'
        __DEBUG1__(delta_time)
        __DEBUG4__(vegn_T,vT,vegn_Wl,vegn_Ws)
        __DEBUG3__(grnd_T,gT,grnd_rh)
        __DEBUG3__(cana_T,cT,cana_q)
        __DEBUG2__(evap_T,eT)
        __DEBUG2__(vegn_emis_lw,surf_emis_lw)
        __DEBUG2__(vegn_emsn,surf_emsn)
        __DEBUG4__(precip_l, vegn_drip_l, pT, precip_T)
        __DEBUG2__(precip_s, vegn_drip_s)
        __DEBUG2__(vegn_ifrac, vegn_lai)
        __DEBUG1__(ILa_dn)
        __DEBUG2__(ISa_dn_dir(1),ISa_dn_dir(2))
        __DEBUG2__(ISa_dn_dif(1),ISa_dn_dif(2))
        __DEBUG2__(fswg, vegn_fsw)
        __DEBUG1__(vegn_hcap)
        __DEBUG3__(hlv_Tv, hlv_Tu, hls_Tv)
        __DEBUG2__(G0, DGDTg)
        __DEBUG2__(Ha0, DHaDTc)
        __DEBUG2__(Ea0, DEaDqc)
        __DEBUG3__(Hv0, DHvDTv, DHvDTc)
        __DEBUG5__(Et0,  DEtDTv,  DEtDqc,  DEtDwl,  DEtDwf)
        __DEBUG5__(Eli0, DEliDTv, DEliDqc, DEliDwl, DEliDwf)
        __DEBUG5__(Esi0, DEsiDTv, DEsiDqc, DEsiDwl, DEsiDwf)
        __DEBUG3__(Hg0, DHgDTg, DHgDTc)
        __DEBUG3__(Eg0, DEgDTg, DEgDqc)
        __DEBUG3__(flwv0, DflwvDTg, DflwvDTv)
        __DEBUG3__(flwg0, DflwgDTg, DflwgDTv)
        __DEBUG2__(tile%e_res_1,tile%e_res_2)
     endif

! [X.1] form the system of equations for implicit scheme, such that A*X = B1*delta_Tg+B2*delta_psig+B0
! [X.1.1] equation of canopy air mass balance
     A(iqc,iqc) = canopy_air_mass/delta_time-DEtDqc-DEliDqc-DEsiDqc-DEgDqc+DEaDqc
     A(iqc,iTc) = 0
     A(iqc,iTv) = -DEtDTv-DEliDTv-DEsiDTv
     A(iqc,iwl) = -DEtDwl-DEliDwl-DEsiDwl
     A(iqc,iwf) = -DEtDwf-DEliDwf-DEsiDwf
     B0(iqc)  = Esi0+Eli0+Et0+Eg0-Ea0
     B1(iqc)  = DEgDTg
     B2(iqc)  = DEgDpsig
! [X.1.2] equation of canopy air energy balance
#ifdef USE_DRY_CANA_MASS
     A(iTc,iqc) = canopy_air_mass*cpw*cT/delta_time &
#else
     A(iTc,iqc) = canopy_air_mass*(cpw-cp_air)*cT/delta_time &
#endif
       - cpw*vT*(DEtDqc+DEliDqc+DEsiDqc) - cpw*gT*DEgDqc + cpw*eT*DEaDqc
#ifdef USE_DRY_CANA_MASS
     A(iTc,iTc) = canopy_air_mass*cp_air/delta_time-DHvDTc-DHgDTc+DHaDTc
#else
     A(iTc,iTc) = canopy_air_mass*(cp_air+cana_q*(cpw-cp_air))/delta_time-DHvDTc-DHgDTc+DHaDTc
#endif
     A(iTc,iTv) = -DHvDTv-cpw*vT*(DEtDTv+DEliDTv+DEsiDTv)
     A(iTc,iwl) =        -cpw*vT*(DEtDwl+DEliDwl+DEsiDwl)
     A(iTc,iwf) =        -cpw*vT*(DEtDwf+DEliDwf+DEsiDwf)
     B0(iTc)  = Hv0 + Hg0 - Ha0 + cpw*(vT*(Et0+Eli0+Esi0)+gT*Eg0-eT*Ea0) - tile%e_res_1
     B1(iTc)  = DHgDTg + cpw*gT*DEgDTg
     B2(iTc)  =          cpw*gT*DEgDpsig
! [X.1.3] equation of canopy energy balance
     A(iTv,iqc) = hlv_Tu*DEtDqc + hlv_Tv*DEliDqc + hls_Tv*DEsiDqc
     A(iTv,iTc) = DHvDTc
     A(iTv,iTv) = vegn_hcap/delta_time-DflwvDTv + DHvDTv + &
          hlv_Tu*DEtDTv + hlv_Tv*DEliDTv + hls_Tv*DEsiDTv + clw*vegn_drip_l + csw*vegn_drip_s
     A(iTv,iwl) = clw*vT/delta_time + hlv_Tu*DEtDwl + hlv_Tv*DEliDwl + hls_Tv*DEsiDwl
     A(iTv,iwf) = csw*vT/delta_time + hlv_Tu*DEtDwf + hlv_Tv*DEliDwf + hls_Tv*DEsiDwf
     B0(iTv)  = vegn_fsw + flwv0 - Hv0 - hlv_Tu*Et0 - Hlv_Tv*Eli0 - hls_Tv*Esi0 &
          + clw*precip_l*vegn_ifrac*pT + csw*precip_s*vegn_ifrac*pT &
          - clw*vegn_drip_l*vT - csw*vegn_drip_s*vT - tile%e_res_2
     B1(iTv)  = DflwvDTg
     B2(iTv)  = 0
! [X.1.4] equation of intercepted liquid water mass balance
     A(iwl,iqc) = DEliDqc
     A(iwl,iTc) = 0
     A(iwl,iTv) = DEliDTv
     A(iwl,iwl) = 1.0/delta_time + DEliDwl
     A(iwl,iwf) = DEliDwf
     B0(iwl)  = -Eli0 + precip_l*vegn_ifrac - vegn_drip_l
     B1(iwl)  = 0
     B2(iwl)  = 0
! [X.1.5] equation of intercepted frozen water mass balance
     A(iwf,iqc) = DEsiDqc
     A(iwf,iTc) = 0
     A(iwf,iTv) = DEsiDTv
     A(iwf,iwl) = DEsiDwl
     A(iwf,iwf) = 1.0/delta_time + DEsiDwf
     B0(iwf)  = -Esi0 + precip_s*vegn_ifrac - vegn_drip_s
     B1(iwf)  = 0
     B2(iwf)  = 0
! [X.1.6] if LAI becomes zero (and, therefore, all fluxes from vegetation and their 
! derivatives must be zero too) we get a degenerate case. Still, the drip may be non-zero
! because some water may remain from before leaf drop, and non-zero energy residual can be
! carried over from the previous time step.
! To prevent temperature from going haywire in those cases, we simply replace the equations 
! of canopy energy and mass balance with the following:
! vegn_T + delta_Tv = cana_T + delta_Tc
! delta_Wl = -vegn_drip_l*delta_time
! delta_Ws = -vegn_drip_s*delta_time
! the residual vegn_Wl and vegn_Ws, if any, are taken care of by the overflow calculations 
     if(vegn_hcap==0) then
        ! vegn_T + delta_Tv = cana_T + delta_Tc
        A(iTv,:)   = 0
        A(iTv,iTc) = -1
        A(iTv,iTv) = +1
        B0(iTv) = cana_T - vegn_T
        B1(iTv) = 0
        ! delta_Wl = -vegn_drip_l*delta_time
        A(iwl,:)   = 0
        A(iwl,iwl) = 1
        B0(iwl) = -vegn_drip_l*delta_time
        B1(iwl) = 0
        ! delta_Ws = -vegn_drip_s*delta_time
        A(iwf,:)   = 0
        A(iwf,iwf) = 1
        B0(iwf) = -vegn_drip_s*delta_time
        B1(iwf) = 0
     endif

     if(is_watch_point()) then
        write(*,*)'#### A, B0, B1, B2 ####'
        do ii = 1, size(A,1)
           write(*,'(99g23.16)')(A(ii,jj),jj=1,size(A,2)),B0(ii),B1(ii),B2(ii)
        enddo
     endif

     A00 = A
     B00 = B0
     B10 = B1

! [X.2] solve the system for free terms and delta_Tg and delta_psig terms, getting
!       linear equation for delta_Tg and delta_psig
     call ludcmp(A,indx, ierr)
     if (ierr/=0)&
          write(*,*) 'Matrix is singular',i,j,k
     call lubksb(A,indx,B0)
     call lubksb(A,indx,B1)
     call lubksb(A,indx,B2)

     if(is_watch_point()) then
        write(*,*)'#### solution: B0, B1, B2 ####'
        do ii = 1, size(A,1)
           __DEBUG3__(B0(ii),B1(ii),B2(ii))
        enddo
!!$        write(*,*)'#### solution check ####'
!!$        do ii = 1, size(A,1)
!!$           sum0 = 0; sum1 = 0;
!!$           do jj = 1, size(A,2)
!!$              sum0 = sum0 + A00(ii,jj)*B0(jj)
!!$              sum1 = sum1 + A00(ii,jj)*B1(jj)
!!$           enddo
!!$           write(*,'(99g)')sum0-B00(ii),sum1-B10(ii)
!!$        enddo
     endif
! the result of this solution is a set of expressions for delta_xx in terms
! of delta_Tg and delta_psig: 
! delta_xx(i) = B0(i) + B1(i)*delta_Tg + B2(i)*delta_psig. Note that A, B0, B1 and B2
! are destroyed in the process: A is replaced with LU-decomposition, and
! B0, B1, B2 are replaced with solutions

     ! solve the non-linear equation for energy balance at the surface.

     call land_surface_energy_balance( &
          grnd_T, grnd_liq, grnd_ice, grnd_latent, grnd_Tf, grnd_E_min, &
          grnd_E_max, fswg, &
          flwg0 + b0(iTv)*DflwgDTv, DflwgDTg + b1(iTv)*DflwgDTv, b2(iTv)*DflwgDTv, &
          Hg0   + b0(iTc)*DHgDTc,   DHgDTg   + b1(iTc)*DHgDTc,   b2(iTc)*DHgDTc,   &
          Eg0   + b0(iqc)*DEgDqc,   DEgDTg   + b1(iqc)*DEgDqc,   DEgDpsig + b2(iqc)*DEgDqc,   &
          G0,                       DGDTg, &
          ! output
          delta_Tg, delta_psig, Mg_imp )

! [X.5] calculate final value of other tendencies
     delta_qc = B0(iqc) + B1(iqc)*delta_Tg + B2(iqc)*delta_psig
     delta_Tc = B0(iTc) + B1(iTc)*delta_Tg + B2(iTc)*delta_psig
     delta_Tv = B0(iTv) + B1(iTv)*delta_Tg + B2(iTv)*delta_psig
     delta_wl = B0(iwl) + B1(iwl)*delta_Tg + B2(iwl)*delta_psig
     delta_ws = B0(iwf) + B1(iwf)*delta_Tg + B2(iwf)*delta_psig

! [X.6] calculate updated values of energy balance components used in further 
!       calculations
     flwg       = flwg0 + DflwgDTg*delta_Tg + DflwgDTv*delta_Tv
     evapg      = Eg0   + DEgDTg*delta_Tg   + DEgDpsig*delta_psig + DEgDqc*delta_qc
     sensg      = Hg0   + DHgDTg*delta_Tg   + DHgDTc*delta_Tc
     grnd_flux  = G0    + DGDTg*delta_Tg
     vegn_sens  = Hv0   + DHvDTv*delta_Tv   + DHvDTc*delta_Tc
     vegn_levap = Eli0  + DEliDTv*delta_Tv  + DEliDqc*delta_qc + DEliDwl*delta_wl + DEliDwf*delta_ws
     vegn_fevap = Esi0  + DEsiDTv*delta_Tv  + DEsiDqc*delta_qc + DEsiDwl*delta_wl + DEsiDwf*delta_ws
     vegn_uptk  = Et0   + DEtDTv*delta_Tv   + DEtDqc*delta_qc  + DEtDwl*delta_wl  + DEtDwf*delta_ws
     vegn_flw   = flwv0 + DflwvDTv*delta_Tv + DflwvDTg*delta_Tg
     land_evap  = Ea0   + DEaDqc*delta_qc
     land_sens  = Ha0   + DHaDTc*delta_Tc
! [X.7] calculate energy residuals due to cross-product of time tendencies
#ifdef USE_DRY_CANA_MASS
     tile%e_res_1 = canopy_air_mass*cpw*delta_qc*delta_Tc/delta_time
#else
     tile%e_res_1 = canopy_air_mass*(cpw-cp_air)*delta_qc*delta_Tc/delta_time
#endif
     tile%e_res_2 = delta_Tv*(clw*delta_Wl+csw*delta_Ws)/delta_time
! calculate the final value upward long-wave radiation flux from the land, to be 
! returned to the flux exchange.
     tile%lwup = ILa_dn - vegn_flw - flwg 

     if(is_watch_point())then
        write(*,*)'#### ground balance'
        __DEBUG2__(fswg,flwg)
        __DEBUG2__(sensg,evapg*grnd_latent)
        __DEBUG1__(grnd_flux)
        __DEBUG1__(Mg_imp)
        write(*,*)'#### implicit time steps'
        __DEBUG3__(delta_Tg, grnd_T,  grnd_T+delta_Tg )
        __DEBUG1__(delta_psig                         )
        __DEBUG3__(delta_qc, cana_q,  cana_q+delta_qc )
        __DEBUG3__(delta_Tc, cana_T,  cana_T+delta_Tc )
        __DEBUG3__(delta_Tv, vegn_T,  vegn_T+delta_Tv )
        __DEBUG3__(delta_wl, vegn_Wl, vegn_Wl+delta_wl)
        __DEBUG3__(delta_ws, vegn_Ws, vegn_Ws+delta_ws)
        __DEBUG2__(tile%e_res_1, tile%e_res_2)
        write(*,*)'#### resulting fluxes'
        __DEBUG4__(flwg, evapg, sensg, grnd_flux)
        __DEBUG3__(vegn_levap,vegn_fevap,vegn_uptk)
        __DEBUG2__(vegn_sens,vegn_flw)
        __DEBUG1__(Ea0+DEaDqc*delta_qc)
        __DEBUG2__(tile%cana%prog%q,cana_q)
     endif

     if (.not.prohibit_negative_canopy_water) exit ! do no corrections
     redo_leaf_water = .FALSE.
     if (vegn_Wl+delta_wl<0) then
        redo_leaf_water = .TRUE.
        Eli0 = vegn_Wl/delta_time + precip_l*vegn_ifrac - vegn_drip_l 
        DEliDTv = 0.0;  DEliDqc = 0.0
        DEliDwl = 0.0;  DEliDwf = 0.0
     endif
     if (vegn_Ws+delta_ws<0) then
        redo_leaf_water = .TRUE.
        Esi0 = vegn_Ws/delta_time + precip_s*vegn_ifrac - vegn_drip_s
        DEsiDTv = 0.0;  DEsiDqc = 0.0
        DEsiDwl = 0.0;  DEsiDwf = 0.0
     endif
     if (.not.redo_leaf_water) exit ! from loop
  enddo ! canopy_water_step
  
  call cana_step_2 ( tile%cana, delta_Tc, delta_qc )

  if(associated(tile%vegn)) then
     call vegn_step_2 ( tile%vegn, tile%diag, &
          delta_Tv, delta_wl, delta_ws, &
          vegn_melt,  &
          vegn_ovfl_l,   vegn_ovfl_s, &
          vegn_ovfl_Hl, vegn_ovfl_Hs )
     ! calculate total amount of liquid and solid precipitation below the canopy
     vegn_lprec  = (1-vegn_ifrac)*precip_l + vegn_drip_l + vegn_ovfl_l
     vegn_fprec  = (1-vegn_ifrac)*precip_s + vegn_drip_s + vegn_ovfl_s
     ! calculate heat carried by liquid and solid precipitation below the canopy
     vegn_hlprec = clw*((1-vegn_ifrac)*precip_l*(precip_T-tfreeze) &
                      + vegn_drip_l*(vegn_T+delta_Tv-tfreeze)) &
                      + vegn_ovfl_Hl
     vegn_hfprec = csw*((1-vegn_ifrac)*precip_s*(precip_T-tfreeze) &
                      + vegn_drip_s*(vegn_T+delta_Tv-tfreeze)) &
                      + vegn_ovfl_Hs
     ! make sure the temperature of the snow falling below canopy is below freezing
     ! this correction was introduced in an attempt to fix the problem with fictitious 
     ! heat accumulating in near-zero-mass snow; however it does not seem to make a 
     ! difference.
     if(vegn_hfprec>0)then
        ! solid precipitation from vegetation carries positive energy -- we can't have
        ! that, because that would bring snow T above tfreeze, so convert excess to 
        ! liquid
        delta_fprec = min(vegn_fprec,vegn_hfprec/hlf)
        vegn_fprec = vegn_fprec - delta_fprec
        vegn_lprec = vegn_lprec + delta_fprec
        vegn_hfprec = vegn_hfprec - hlf*delta_fprec
        ! we don't need to correct the vegn_hlprec since the temperature of additional
        ! liquid precip is tfreeze, and therefore its contribution to vegn_hlprec is
        ! exactly zero
     endif
     ! possibly we need to correct for the opposite situation: negative energy carried
     ! by liquid precipitation.
  else
     vegn_lprec  = precip_l
     vegn_fprec  = precip_s
     vegn_hlprec = precip_l*clw*(precip_T-tfreeze)
     vegn_hfprec = precip_s*csw*(precip_T-tfreeze)
     ! the fields below are only used in diagnostics
     vegn_melt   = 0
     vegn_fsw    = 0
  endif

  call snow_step_2 ( tile%snow, &
       snow_subl, vegn_lprec, vegn_fprec, vegn_hlprec, vegn_hfprec, &
       delta_Tg, Mg_imp, evapg, fswg, flwg, sensg, &
       use_tfreeze_in_grnd_latent, &
       ! output:
       subs_DT, subs_M_imp, subs_evap, subs_fsw, subs_flw, subs_sens, &
       snow_fsw, snow_flw, snow_sens, &
       snow_levap, snow_fevap, snow_melt, &
       snow_lprec, snow_hlprec, snow_lrunf, snow_frunf, &
       snow_hlrunf, snow_hfrunf, snow_Tbot, snow_Cbot, snow_C, snow_avrg_T )
  if(is_watch_point()) then
     write(*,*) 'subs_M_imp', subs_M_imp
  endif

  if (snow_active) then
     subs_G = snow_G_Z+snow_G_TZ*subs_DT
  else
     subs_G = 0
  endif
     
  if (associated(tile%glac)) then
     call glac_step_2 &
          ( tile%glac, tile%diag, subs_subl, snow_lprec, snow_hlprec, &
          subs_DT, subs_M_imp, subs_evap, &
          subs_levap, subs_fevap, &
          subs_melt, subs_lrunf, subs_hlrunf, subs_Ttop, subs_Ctop )
  else if (associated(tile%lake)) then
     call lake_step_2 &
          ( tile%lake, tile%diag, subs_subl, snow_lprec, snow_hlprec, &
          subs_DT, subs_M_imp, subs_evap, &
          use_tfreeze_in_grnd_latent, subs_levap, subs_fevap, &
          subs_melt, subs_Ttop, subs_Ctop )
     subs_lrunf = 0.
     subs_hlrunf = 0.
  else if (associated(tile%soil)) then
     call soil_step_2 &
          ( tile%soil, tile%vegn, tile%diag, subs_subl, snow_lprec, snow_hlprec, &
          vegn_uptk, subs_DT, subs_M_imp, subs_evap, &
          use_tfreeze_in_grnd_latent, &
          ! output:
          subs_levap, subs_fevap, &
          subs_melt, subs_lrunf, subs_hlrunf, subs_Ttop, subs_Ctop )
  endif
     
! TEMP FIX: MAIN PROG SHOULD NOT TOUCH CONTENTS OF PROG VARS. ******
! ALSO, DIAGNOSTICS IN COMPONENT MODULES SHOULD _FOLLOW_ THIS ADJUSTMENT******
  if (LM2) then
     tile%snow%T = subs_Ttop
     subs_G2 = 0.
  else
     if (sum(tile%snow%ws(:))>0)then
        new_T = (subs_Ctop*subs_Ttop +snow_Cbot*snow_Tbot) &
                        / (subs_Ctop+snow_Cbot)
        tile%snow%T(size(tile%snow%T)) = new_T
        if(associated(tile%glac)) tile%glac%prog(1)%T = new_T
        if(associated(tile%lake)) tile%lake%prog(1)%T = new_T
        if(associated(tile%soil)) tile%soil%prog(1)%T = new_T
        subs_G2 = subs_Ctop*(new_T-subs_Ttop)/delta_time
     else
        if(tau_snow_T_adj>=0) then
           delta_T_snow = subs_Ctop*(subs_Ttop-snow_avrg_T)/&
                (subs_Ctop*tau_snow_T_adj/delta_time+subs_Ctop+snow_C)
           tile%snow%T(:) = snow_avrg_T + delta_T_snow

           new_T = subs_Ttop-snow_C/subs_Ctop*delta_T_snow
           if(associated(tile%glac)) tile%glac%prog(1)%T = new_T
           if(associated(tile%lake)) tile%lake%prog(1)%T = new_T
           if(associated(tile%soil)) tile%soil%prog(1)%T = new_T
           subs_G2 = subs_Ctop*(new_T-subs_Ttop)/delta_time
        else
           subs_G2 = 0.
        endif
     endif
  endif

  vegn_fco2 = 0
  if (associated(tile%vegn)) then
     ! do the calculations that require updated land surface prognostic variables
     call vegn_step_3 (tile%vegn, tile%soil, tile%cana%prog%T, precip_l+precip_s, &
          vegn_fco2, tile%diag)
     ! if vegn is present, then soil must be too
     call soil_step_3(tile%soil, tile%diag)
  endif
  ! update co2 concentration in the canopy air. It would be more consistent to do that
  ! in the same place and fashion as the rest of prognostic variables: that is, have the
  ! vegn_step_1 (and perhaps other *_step_1 procedures) calculate fluxes and their
  ! derivatives, then solve the linear equation(s), and finally have cana_step_2 update
  ! the concentration.
  if(update_cana_co2) then
     tile%cana%prog%co2 = tile%cana%prog%co2 + &
          (vegn_fco2 - fco2_0)/(canopy_air_mass_for_tracers/delta_time+Dfco2Dq)
  endif
  if(is_watch_point())then
     __DEBUG1__(tile%cana%prog%co2)
     __DEBUG3__(fco2_0,Dfco2Dq,vegn_fco2)
  endif
  
  call update_land_bc_fast (tile, i,j,k, land2cplr)

  runoff      = runoff      + (snow_frunf  + subs_lrunf  + snow_lrunf )*tile%frac
  runoff_heat = runoff_heat + (snow_hfrunf + subs_hlrunf + snow_hlrunf)*tile%frac
  runoff_snow = runoff_snow + snow_frunf*tile%frac
  hprec = (clw*precip_l+csw*precip_s)*(precip_T-tfreeze)
  hevap = cpw*land_evap*(evap_T-tfreeze)

  ! ---- diagnostic section ----------------------------------------------
  call send_tile_data(id_frac,    tile%frac,                          tile%diag)
  call send_tile_data(id_ntiles,  1.0,                                tile%diag)     
  call send_tile_data(id_precip,  precip_l+precip_s,                  tile%diag)
  call send_tile_data(id_hprec,   hprec,                              tile%diag)
  call send_tile_data(id_lprec,   precip_l,                           tile%diag)
  call send_tile_data(id_lprecv,  precip_l-vegn_lprec,                tile%diag)
  call send_tile_data(id_lprecs,  vegn_lprec-snow_lprec,              tile%diag)
  call send_tile_data(id_lprecg,  snow_lprec,                         tile%diag)
  call send_tile_data(id_hlprec,  clw*precip_l*(precip_T-tfreeze),    tile%diag)
  call send_tile_data(id_hlprecv, clw*precip_l*(precip_T-tfreeze)-vegn_hlprec, &
                                                                      tile%diag)
  call send_tile_data(id_hlprecs, vegn_hlprec-snow_hlprec,            tile%diag)
  call send_tile_data(id_hlprecg, snow_hlprec,                        tile%diag)
  call send_tile_data(id_fprec,   precip_s,                           tile%diag)
  call send_tile_data(id_fprecv,  precip_s-vegn_fprec,                tile%diag)
  call send_tile_data(id_fprecs,  vegn_fprec,                         tile%diag)
  call send_tile_data(id_hfprec,  csw*precip_s*(precip_T-tfreeze),    tile%diag)
  call send_tile_data(id_hfprecv, csw*precip_s*(precip_T-tfreeze)-vegn_hfprec, &
                                                                      tile%diag)
  call send_tile_data(id_hfprecs, vegn_hfprec,                        tile%diag)
  call send_tile_data(id_evap,    land_evap,                          tile%diag)
  call send_tile_data(id_hevap,   hevap,                              tile%diag)
  call send_tile_data(id_levap,   vegn_levap+snow_levap+subs_levap+vegn_uptk, &
                                                                      tile%diag)
  call send_tile_data(id_levapv,  vegn_levap,                         tile%diag)
  call send_tile_data(id_levaps,  snow_levap,                         tile%diag)
  call send_tile_data(id_levapg,  subs_levap,                         tile%diag)
  call send_tile_data(id_hlevap,  cpw*vegn_levap*(vegn_T-tfreeze) &
                                    +cpw*snow_levap*(snow_T-tfreeze) &
                                    +cpw*subs_levap*(grnd_T-tfreeze), tile%diag)
  call send_tile_data(id_hlevapv, cpw*vegn_levap*(vegn_T-tfreeze),    tile%diag)
  call send_tile_data(id_hlevaps, cpw*snow_levap*(snow_T-tfreeze),    tile%diag)
  call send_tile_data(id_hlevapg, cpw*subs_levap*(grnd_T-tfreeze),    tile%diag)
  call send_tile_data(id_fevap,   vegn_fevap+snow_fevap+subs_fevap,   tile%diag)
  call send_tile_data(id_fevapv,  vegn_fevap,                         tile%diag)
  call send_tile_data(id_fevaps,  snow_fevap,                         tile%diag)
  call send_tile_data(id_fevapg,  subs_fevap,                         tile%diag)
  call send_tile_data(id_hfevap,  cpw*vegn_fevap*(vegn_T-tfreeze) &
                                    +cpw*snow_fevap*(snow_T-tfreeze) &
                                    +cpw*subs_fevap*(grnd_T-tfreeze), tile%diag)
  call send_tile_data(id_hfevapv, cpw*vegn_fevap*(vegn_T-tfreeze),    tile%diag)
  call send_tile_data(id_hfevaps, cpw*snow_fevap*(snow_T-tfreeze),    tile%diag)
  call send_tile_data(id_hfevapg, cpw*subs_fevap*(grnd_T-tfreeze),    tile%diag)
  call send_tile_data(id_runf,    snow_lrunf+snow_frunf+subs_lrunf,   tile%diag)
  call send_tile_data(id_hrunf,   snow_hlrunf+snow_hfrunf+subs_hlrunf,tile%diag)
  call send_tile_data(id_lrunf,   snow_lrunf+subs_lrunf,              tile%diag)
  call send_tile_data(id_lrunfs,  snow_lrunf,                         tile%diag)
  call send_tile_data(id_lrunfg,  subs_lrunf,                         tile%diag)
  call send_tile_data(id_hlrunf,  snow_hlrunf+subs_hlrunf,            tile%diag)
  call send_tile_data(id_hlrunfs, snow_hlrunf,                        tile%diag)
  call send_tile_data(id_hlrunfg, subs_hlrunf,                        tile%diag)
  call send_tile_data(id_frunf,   snow_frunf,                         tile%diag)
  call send_tile_data(id_frunfs,  snow_frunf,                         tile%diag)
  call send_tile_data(id_hfrunf,  snow_hfrunf,                        tile%diag)
  call send_tile_data(id_hfrunfs, snow_hfrunf,                        tile%diag)
  call send_tile_data(id_melt,    vegn_melt+snow_melt+subs_melt,      tile%diag)
  call send_tile_data(id_meltv,   vegn_melt,                          tile%diag)
  call send_tile_data(id_melts,   snow_melt,                          tile%diag)
  call send_tile_data(id_meltg,   subs_melt,                          tile%diag)
  call send_tile_data(id_fsw,     vegn_fsw+snow_fsw+subs_fsw,         tile%diag)
  call send_tile_data(id_fswv,    vegn_fsw,                           tile%diag)
  call send_tile_data(id_fsws,    snow_fsw,                           tile%diag)
  call send_tile_data(id_fswg,    subs_fsw,                           tile%diag)
  call send_tile_data(id_flw,     vegn_flw+snow_flw+subs_flw,         tile%diag)
  call send_tile_data(id_flwv,    vegn_flw,                           tile%diag)
  call send_tile_data(id_flws,    snow_flw,                           tile%diag)
  call send_tile_data(id_flwg,    subs_flw,                           tile%diag)
  call send_tile_data(id_sens,    land_sens,                          tile%diag)
  call send_tile_data(id_sensv,   vegn_sens,                          tile%diag)
  call send_tile_data(id_senss,   snow_sens,                          tile%diag)
  call send_tile_data(id_sensg,   subs_sens,                          tile%diag)
  call send_tile_data(id_e_res_1, tile%e_res_1,                       tile%diag)
  call send_tile_data(id_e_res_2, tile%e_res_2,                       tile%diag)
  call send_tile_data(id_con_g_h, con_g_h,                            tile%diag)
  call send_tile_data(id_transp,  vegn_uptk,                          tile%diag)
  call send_tile_data(id_wroff,   snow_lrunf+subs_lrunf,              tile%diag)
  call send_tile_data(id_sroff,   snow_frunf,                         tile%diag)
  call send_tile_data(id_htransp, cpw*vegn_uptk*(vegn_T-tfreeze),     tile%diag)
  call send_tile_data(id_huptake, clw*vegn_uptk*(soil_uptake_T-tfreeze), &
                                                                      tile%diag)
  call send_tile_data(id_hroff,   snow_hlrunf+subs_hlrunf+snow_hfrunf, &
                                                                      tile%diag)
  call send_tile_data(id_gsnow,   subs_G,                             tile%diag)
  call send_tile_data(id_gequil,  subs_G2,                            tile%diag)
  call send_tile_data(id_grnd_flux, grnd_flux,                        tile%diag)
  call send_tile_data(id_soil_water_supply, soil_water_supply,        tile%diag)
  if(grnd_E_max.lt.0.5*HUGE(grnd_E_Max)) &
      call send_tile_data(id_levapg_max, grnd_E_max,                  tile%diag)
  call send_tile_data(id_qco2,    tile%cana%prog%co2,                 tile%diag)
  call send_tile_data(id_qco2_dvmr,&
       tile%cana%prog%co2*mol_air/mol_co2/(1-tile%cana%prog%q),       tile%diag)
  call send_tile_data(id_fco2,    vegn_fco2*mol_C/mol_co2,            tile%diag)
  call send_tile_data(id_swdn_dir, ISa_dn_dir,                        tile%diag)
  call send_tile_data(id_swdn_dif, ISa_dn_dif,                        tile%diag)
  call send_tile_data(id_swup_dir, ISa_dn_dir*tile%land_refl_dir,     tile%diag)
  call send_tile_data(id_swup_dif, ISa_dn_dif*tile%land_refl_dif,     tile%diag)
  call send_tile_data(id_lwdn,     ILa_dn,                            tile%diag)
  call send_tile_data(id_subs_emis,surf_emis_lw,                      tile%diag)

  if (id_total_C > 0) &
      call send_tile_data(id_total_C, land_tile_carbon(tile),         tile%diag)
end subroutine update_land_model_fast_0d


! ============================================================================
subroutine update_land_model_slow ( cplr2land, land2cplr )
  type(atmos_land_boundary_type), intent(inout) :: cplr2land
  type(land_data_type)          , intent(inout) :: land2cplr

  ! ---- local vars
  integer :: i,j,k
  type(land_tile_type), pointer :: tile
  type(land_tile_enum_type) :: ce, te

  call mpp_clock_begin(landClock)
  call mpp_clock_begin(landSlowClock)

  call land_transitions( lnd%time )
  call update_vegn_slow( )
  ! send the accumulated diagnostics to the output
  call dump_tile_diag_fields(lnd%tile_map, lnd%time)

  ! land_transitions may have changed the number of tiles per grid cell: reallocate 
  ! boundary conditions, if necessary
  call realloc_cplr2land( cplr2land )
  call realloc_land2cplr( land2cplr )
  ! set the land mask to FALSE everywhere -- update_land_bc_fast will set it to 
  ! true where necessary
  land2cplr%mask = .FALSE.
  land2cplr%tile_size = 0.0

  ! get the current state of the land boundary for the coupler
  ce = first_elmt(lnd%tile_map,                  &
              is=lbound(cplr2land%t_flux,1), &
              js=lbound(cplr2land%t_flux,2)  )
  te = tail_elmt(lnd%tile_map)
  do while(ce /= te)
     ! calculate indices of the current tile in the input arrays;
     ! assume all the cplr2land components have the same lbounds
     call get_elmt_indices(ce,i,j,k)
     ! set this point coordinates as current for debug output
     call set_current_point(i,j,k)
     ! get pointer to current tile
     tile => current_tile(ce)
     ! advance enumerator to the next tile
     ce=next_elmt(ce)

     call update_land_bc_fast (tile, i,j,k, land2cplr, is_init=.true.)
  enddo

  call update_land_bc_slow( land2cplr )

  call mpp_clock_end(landClock)
  call mpp_clock_end(landSlowClock)
end subroutine update_land_model_slow


! ============================================================================
! solve for surface temperature. ensure that melt does not exceed available
! snow or soil ice (which would create energy-balance problems). also ensure
! that melt and temperature are consistent and that evaporation from liquid
! soil water does not exceed exfiltration rate limit, if one is supplied.
! because the possible combinations of active constraints has multiplied
! greatly, we do not allow phase change for any surface (i.e., soil) at which
! we might apply a constraint on Eg.
subroutine land_surface_energy_balance ( &
     ! surface parameters
     grnd_T,          & ! ground temperature
     grnd_liq, grnd_ice, & ! amount of water available for freeze or melt on the surface, kg/m2
     grnd_latent,     & ! specific heat of vaporization for the ground
     grnd_Tf,         & ! ground freezing temperature
     grnd_E_min,      & ! Eg floor of 0 if condensation is prohibited
     grnd_E_max,      & ! exfiltration rate limit, kg/(m2 s)
     ! components of the ground energy balance linearization. Note that those
     ! are full derivatives, which include the response of the other surface
     ! scheme parameters to the change in ground temperature.
     fswg,            & ! net short-wave
     flwg0, DflwgDTg, DflwgDpsig, & ! net long-wave
     Hg0,   DHgDTg,   DHgDpsig,   & ! sensible heat
     Eg0,   DEgDTg,   DEgDpsig,   & ! latent heat
     G0,    DGDTg,    & ! sub-surface heat 
     delta_Tg,        & ! surface temperature change for the time step
     delta_psig,      & 
     Mg_imp          )  ! implicit melt, kg/m2

  real, intent(in) :: & 
     grnd_T,          & ! ground temperature
     grnd_liq, grnd_ice, & ! amount of water available for freeze or melt on the surface
     grnd_latent,     & ! specific heat of vaporization for the ground
     grnd_Tf,         & ! ground freezing temperature
     grnd_E_min,      & ! Eg floor of 0 if condensation is prohibited
     grnd_E_max,      & ! exfiltration rate limit, kg/(m2 s)
     fswg,            & ! net short-wave
     flwg0, DflwgDTg, DflwgDpsig, & ! net long-wave
     Hg0,   DHgDTg,   DHgDpsig,   & ! sensible heat
     Eg0,   DEgDTg,   DEgDpsig,   & ! latent heat
     G0,    DGDTg                   ! sub-surface heat 
  real, intent(out) :: &
     delta_Tg,        & ! change in surface temperature
     delta_psig,      & ! change in surface soil-water matric head
     Mg_imp             ! mass of surface ice melted (or water frozen) during the 
                        ! time step, kg/m2

  real :: grnd_B     ! surface energy balance
  real :: grnd_DBDTg ! full derivative of grnd_B w.r.t. surface temperature
  real :: grnd_DBDpsig ! full derivative of grnd_B w.r.t. surface soil-water matric head
  real :: grnd_E_force, Eg_trial, Eg_check, determinant

  grnd_B      = fswg + flwg0      - Hg0      - grnd_latent*Eg0      - G0
  grnd_DBDTg  =        DflwgDTg   - DHgDTg   - grnd_latent*DEgDTg   - DGDTg
  grnd_DBDpsig =       DflwgDpsig - DHgDpsig - grnd_latent*DEgDpsig

  if(is_watch_point())then
     write(*,*)'#### ground balance input'
     __DEBUG1__(grnd_T)
     __DEBUG2__(grnd_liq, grnd_ice)
     __DEBUG1__(grnd_latent)
     __DEBUG1__(grnd_Tf)
     __DEBUG1__(grnd_E_min)
     __DEBUG1__(grnd_E_max)
     __DEBUG1__(fswg)
     __DEBUG3__(flwg0, DflwgDTg,DflwgDpsig)
     __DEBUG3__(Hg0,   DHgDTg,  DHgDpsig  )
     __DEBUG3__(Eg0,   DEgDTg,  DEgDpsig  )
     __DEBUG2__(G0,    DGDTg)
     write(*,*)'#### end of ground balance input'
     __DEBUG3__(grnd_B, grnd_DBDTg, grnd_DBDpsig)
  endif

  ! determine the ground temperature change under the assumptions that
  ! (1) no phase change occurs at surface (always true for soil now), and
  ! (2) delta_psig is zero (always true for snow, lake, glacier now)
  delta_Tg = - grnd_B/grnd_DBDTg
  delta_psig = 0
  ! calculate phase change on the ground, if necessary
  if     (grnd_ice>0.and.grnd_T+delta_Tg>grnd_Tf) then ! melt > 0
     Mg_imp =  min(grnd_ice,  grnd_DBDTg*(grnd_Tf-grnd_T-delta_Tg)*delta_time/hlf)
  elseif (grnd_liq>0.and.grnd_T+delta_Tg<grnd_Tf) then ! melt < 0
     Mg_imp = -min(grnd_liq, -grnd_DBDTg*(grnd_Tf-grnd_T-delta_Tg)*delta_time/hlf)
  else
     Mg_imp = 0
  endif
  ! adjust temperature change for the phase change
  delta_Tg = -(grnd_B - Mg_imp*hlf/delta_time)/grnd_DBDTg
  Eg_trial = Eg0 + DEgDTg*delta_Tg

  if(is_watch_point())then
     write(*,*)'#### ground balance solution with psig constant:'
     __DEBUG2__(grnd_B, grnd_DBDTg)
     __DEBUG3__(Mg_imp, delta_Tg, delta_psig)
     __DEBUG3__(grnd_E_min, Eg_trial, grnd_E_max)
  endif

  ! Solution above (assuming no change in psig) is acceptable if 
  ! it does not imply unacceptable value of Eg. this is always
  ! true for lake, glacier, snow. If implied Eg is outside prescribed
  ! bounds (a possibility only for soil), then Eg is set at bound (grnd_E_force)
  ! and the required Tg and psig are found. To accomplish this,
  ! we solve the system
  ! grnd_B + grnd_DBDTg*delta_Tg + grnd_DBDpsig*delta_psig = 0
  ! Eg0    +     DEgDTg*delta_Tg +     DEgDpsig*delta_psig = grnd_E_force
  ! There is no need to revisit the solution for phase change, which
  ! is only done explicitly for soil.

  if (Eg_trial.lt.grnd_E_min .or. Eg_trial.gt.grnd_E_max) then
      grnd_E_force = max(grnd_E_min, Eg_trial)
      grnd_E_force = min(grnd_E_max, grnd_E_force)
      determinant = grnd_DBDTg*DEgDpsig-grnd_DBDpsig*DEgDTg
      delta_Tg   = - (DEgDpsig*grnd_B + grnd_DBDpsig*(grnd_E_force-Eg0))/determinant
      delta_psig =   (DEgDTg  *grnd_B + grnd_DBDTg  *(grnd_E_force-Eg0))/determinant
      Eg_check = Eg0 + DEgDTg*delta_Tg + DEgDpsig*delta_psig
      Mg_imp = 0
         if(is_watch_point())then
            write(*,*)'#### trial solution violated Eg limit, new soln:'
            __DEBUG2__(grnd_B,grnd_DBDTg)
            __DEBUG3__(Mg_imp,delta_Tg,delta_psig)
            __DEBUG3__(grnd_E_min, Eg_check, grnd_E_max)
         endif
    endif
end subroutine land_surface_energy_balance


! ============================================================================
subroutine update_land_bc_fast (tile, i,j,k, land2cplr, is_init)
  type(land_tile_type), intent(inout) :: tile
  integer             , intent(in) :: i,j,k
  type(land_data_type), intent(inout) :: land2cplr
  logical, optional :: is_init

  ! ---- local vars
  real :: &
         grnd_T, subs_z0m, subs_z0s, &
                 snow_z0s, snow_z0m, &
         snow_area, snow_depth

  real :: subs_refl_dir(NBANDS), subs_refl_dif(NBANDS) ! direct and diffuse albedos
  real :: subs_refl_lw ! reflectance for thermal radiation
  real :: snow_refl_dir(NBANDS), snow_refl_dif(NBANDS) ! direct and diffuse albedos of snow
  real :: snow_refl_lw ! snow reflectance for thermal radiation
  real :: snow_emis ! snow emissivity
  real :: grnd_emis ! ground emissivity
  ! NOTE :  grnd_emis is used only to satisfy xxxx_radiation interfaces; its value is ignored, but
  ! 1-refl is used instead. snow_emis is used in the the vegn_radiation, but it shouldn't be since
  ! properties of intercepted snowpack are, in general, different from the snow on the ground 
  real :: snow_area_rad ! "snow area for radiation calculations" -- introduced
                        ! to reproduce lm2 behavior
  real :: vegn_refl_lw, vegn_tran_lw ! reflectance and transmittance of vegetation for thermal radiation
  real :: vegn_refl_dif(NBANDS), vegn_tran_dif(NBANDS) ! reflectance and transmittance of vegetation for diffuse light
  real :: vegn_refl_dir(NBANDS), vegn_tran_dir(NBANDS) ! reflectance and transmittance of vegetation for direct light
  real :: vegn_tran_dir_dir(NBANDS) ! (?)
  real :: &
         vegn_Tv,     &
         vegn_cover,  &
         vegn_height, vegn_lai, vegn_sai, vegn_d_leaf, cana_co2
  logical :: do_update

  real :: cosz    ! cosine of solar zenith angle
  real :: fracday ! daytime fraction of time interval
  real :: rrsun   ! earth-sun distance (r) relative to semi-major axis
                  ! of orbital ellipse (a) : (a/r)**2
  integer :: face ! for debugging
  vegn_Tv = 0

  do_update = .not.present(is_init)

  ! on initialization the albedos are calculated for the current time step ( that is, interval
  ! lnd%time, lnd%time+lnd%dt_fast); in the course of the run this subroutine is called
  ! at the end of time step (but before time is advanced) to calculate the radiative properties 
  ! for the _next_ time step
  if (do_update) then
     call diurnal_solar(lnd%lat(i,j), lnd%lon(i,j), lnd%time+lnd%dt_fast, &
          cosz, fracday, rrsun, lnd%dt_fast)
  else
     call diurnal_solar(lnd%lat(i,j), lnd%lon(i,j), lnd%time, &
          cosz, fracday, rrsun, lnd%dt_fast)
  endif
  
  if (associated(tile%glac)) then
     call glac_radiation(tile%glac, cosz, subs_refl_dir, subs_refl_dif, subs_refl_lw, grnd_emis)
     call glac_diffusion(tile%glac, subs_z0s, subs_z0m )
  else if (associated(tile%lake)) then
     call lake_radiation(tile%lake, cosz, subs_refl_dir, subs_refl_dif, subs_refl_lw, grnd_emis)
     call lake_diffusion(tile%lake, subs_z0s, subs_z0m )
  else if (associated(tile%soil)) then
     call soil_radiation(tile%soil, cosz, subs_refl_dir, subs_refl_dif, subs_refl_lw, grnd_emis)
     call soil_diffusion(tile%soil, subs_z0s, subs_z0m )
  else
     call get_current_point(face=face)
     call error_mesg('update_land_model_fast','none of the surface tiles exist at ('//&
             trim(string(i))//','//trim(string(j))//','//trim(string(k))//&
             ', face='//trim(string(face))//')',FATAL)
  endif

  call snow_radiation ( tile%snow%T(1), cosz, snow_refl_dir, snow_refl_dif, snow_refl_lw, snow_emis)
  call snow_get_depth_area ( tile%snow, snow_depth, snow_area )
  call snow_diffusion ( tile%snow, snow_z0s, snow_z0m )

  if (associated(tile%vegn)) then
     call update_derived_vegn_data(tile%vegn)
     ! USE OF SNOWPACK RAD PROPERTIES FOR INTERCEPTED SNOW IS ERRONEOUS,
     ! NEEDS TO BE CHANGED. TEMPORARY.
     call vegn_radiation ( tile%vegn, cosz, snow_depth, snow_refl_dif, snow_emis, &
                   vegn_refl_dif, vegn_tran_dif, &
                   vegn_refl_dir, vegn_tran_dir, vegn_tran_dir_dir, &
                   vegn_refl_lw, vegn_tran_lw)
     ! (later see if we can remove vegn_cover from c-a-radiation...) TEMPORARY
     call vegn_get_cover ( tile%vegn, snow_depth, vegn_cover)
     call vegn_diffusion ( tile%vegn, vegn_cover, vegn_height, vegn_lai, vegn_sai, vegn_d_leaf)
  else
     ! set radiative properties for null vegetation
     vegn_refl_dif     = 0
     vegn_tran_dif     = 1
     vegn_refl_dir     = 0
     vegn_tran_dir     = 0
     vegn_tran_dir_dir = 1
     vegn_refl_lw      = 0 
     vegn_tran_lw      = 1
     ! set cover for null vegetation
     vegn_cover        = 0
     ! set other parameters for null vegetation
     vegn_height       = 0
     vegn_lai          = 0
     vegn_sai          = 0
     vegn_d_leaf       = 0
  endif

  ! store the values of long-wave optical properties to be used in the update_land_model_fast
  tile%surf_refl_lw = subs_refl_lw  + (snow_refl_lw  - subs_refl_lw ) * snow_area
  tile%vegn_refl_lw = vegn_refl_lw
  tile%vegn_tran_lw = vegn_tran_lw

  
  if(is_watch_point()) then
     write(*,*) '#### update_land_bc_fast ### checkpoint 1 ####'
     __DEBUG3__(cosz, fracday, rrsun)
     __DEBUG2__(vegn_lai,vegn_sai)
     __DEBUG1__(subs_refl_dif)
     __DEBUG1__(subs_refl_dir)
     __DEBUG1__(vegn_refl_dif)
     __DEBUG1__(vegn_tran_dif)
     __DEBUG1__(vegn_refl_dir)
     __DEBUG1__(vegn_tran_dir)
     __DEBUG1__(vegn_tran_dir_dir)
     __DEBUG2__(vegn_refl_lw,vegn_tran_lw)
     write(*,*) '#### update_land_bc_fast ### end of checkpoint 1 ####'
  endif

  snow_area_rad = snow_area
  if (lm2) then
     if(associated(tile%glac)                    ) snow_area_rad = 0
     if(associated(tile%soil).and.vegn_cover>0.01) snow_area_rad = 1
  endif

  call cana_radiation( lm2, &
       subs_refl_dir, subs_refl_dif, subs_refl_lw, &
       snow_refl_dir, snow_refl_dif, snow_refl_lw, &
       snow_area_rad,  &
       vegn_refl_dir, vegn_refl_dif, vegn_tran_dir, vegn_tran_dif, &
       vegn_tran_dir_dir, vegn_refl_lw, vegn_tran_lw, &
       vegn_cover, &
       tile%Sg_dir, tile%Sg_dif, tile%Sv_dir, tile%Sv_dif, &
       tile%land_refl_dir, tile%land_refl_dif )

  call cana_roughness( lm2, &
     subs_z0m, subs_z0s, &
     snow_z0m, snow_z0s, snow_area, &
     vegn_cover,  vegn_height, vegn_lai, vegn_sai, &
     tile%land_d, tile%land_z0m, tile%land_z0s, &
     associated(tile%lake).or.associated(tile%glac))

  if(is_watch_point()) then
     write(*,*) '#### update_land_bc_fast ### checkpoint 2 ####'
     write(*,*) 'Sg_dir', tile%Sg_dir
     write(*,*) 'Sg_dif', tile%Sg_dif
     write(*,*) 'Sv_dir', tile%Sv_dir
     write(*,*) 'Sv_dif', tile%Sv_dif
     write(*,*) 'land_albedo_dir', tile%land_refl_dir
     write(*,*) 'land_albedo_dif', tile%land_refl_dif
     write(*,*) 'land_z0m', tile%land_z0m
     write(*,*) '#### update_land_bc_fast ### end of checkpoint 2 ####'
  endif

  land2cplr%t_surf         (i,j,k) = tfreeze
  land2cplr%t_ca           (i,j,k) = tfreeze
  land2cplr%tr             (i,j,k, lnd%isphum) = 0.0
  land2cplr%albedo         (i,j,k) = 0.0
  land2cplr%albedo_vis_dir (i,j,k) = 0.0
  land2cplr%albedo_nir_dir (i,j,k) = 0.0
  land2cplr%albedo_vis_dif (i,j,k) = 0.0
  land2cplr%albedo_nir_dif (i,j,k) = 0.0
  land2cplr%rough_mom      (i,j,k) = 0.1
  land2cplr%rough_heat     (i,j,k) = 0.1

  ! Calculate radiative surface temperature. lwup can't be calculated here
  ! based on the available temperatures because it's a result of the implicit 
  ! time step: lwup = lwup0 + DlwupDTg*delta_Tg + ..., so we have to carry it
  ! from the update_land_fast 
  ! Consequence: since update_landbc_fast is called once at the very beginning of 
  ! every run (before update_land_fast is called) lwup from the previous step 
  ! must be stored in the in the restart for reproducibility
  land2cplr%t_surf(i,j,k) = ( tile%lwup/stefan ) ** 0.25

  if (associated(tile%glac)) call glac_get_sfc_temp(tile%glac, grnd_T)
  if (associated(tile%lake)) call lake_get_sfc_temp(tile%lake, grnd_T)
  if (associated(tile%soil)) call soil_get_sfc_temp(tile%soil, grnd_T)
  if (snow_area > 0)         call snow_get_sfc_temp(tile%snow, grnd_T)

  ! set the boundary conditions for the flux exchange
  land2cplr%mask           (i,j,k) = .TRUE.
  land2cplr%tile_size      (i,j,k) = tile%frac

  call cana_state ( tile%cana, land2cplr%t_ca(i,j,k), &
                               land2cplr%tr(i,j,k,lnd%isphum), cana_co2)
!  land2cplr%t_ca           (i,j,k) = tile%cana%prog%T
!  land2cplr%tr             (i,j,k,lnd%isphum) = tile%cana%prog%q
  if(lnd%ico2/=NO_TRACER) then
     land2cplr%tr(i,j,k,lnd%ico2) = cana_co2
  endif
  land2cplr%albedo_vis_dir (i,j,k) = tile%land_refl_dir(BAND_VIS)
  land2cplr%albedo_nir_dir (i,j,k) = tile%land_refl_dir(BAND_NIR)
  land2cplr%albedo_vis_dif (i,j,k) = tile%land_refl_dif(BAND_VIS)
  land2cplr%albedo_nir_dif (i,j,k) = tile%land_refl_dif(BAND_NIR)
  land2cplr%albedo         (i,j,k) = SUM(tile%land_refl_dir + tile%land_refl_dif)/4 ! incorrect, replace with proper weighting later
  land2cplr%rough_mom      (i,j,k) = tile%land_z0m
  land2cplr%rough_heat     (i,j,k) = tile%land_z0s

  if(is_watch_point()) then
     write(*,*)'#### update_land_bc_fast ### output ####'
     write(*,*)'land2cplr%mask',land2cplr%mask(i,j,k)
     write(*,*)'land2cplr%tile_size',land2cplr%tile_size(i,j,k)
     write(*,*)'land2cplr%t_surf',land2cplr%t_surf(i,j,k)
     write(*,*)'land2cplr%t_ca',land2cplr%t_ca(i,j,k)
     write(*,*)'land2cplr%albedo',land2cplr%albedo(i,j,k)
     write(*,*)'land2cplr%rough_mom',land2cplr%rough_mom(i,j,k)
     write(*,*)'land2cplr%rough_heat',land2cplr%rough_heat(i,j,k)
     write(*,*)'land2cplr%tr',land2cplr%tr(i,j,k,:)
     write(*,*)'#### update_land_bc_fast ### end of output ####'
  endif

  ! ---- diagnostic section
  call send_tile_data(id_vegn_cover, vegn_cover, tile%diag)
  call send_tile_data(id_cosz, cosz, tile%diag)
  call send_tile_data(id_albedo_dir, tile%land_refl_dir, tile%diag)
  call send_tile_data(id_albedo_dif, tile%land_refl_dif, tile%diag)
  call send_tile_data(id_vegn_refl_dir, vegn_refl_dir,     tile%diag)
  call send_tile_data(id_vegn_refl_dif, vegn_refl_dif, tile%diag)
  call send_tile_data(id_vegn_refl_lw,  vegn_refl_lw, tile%diag)
  call send_tile_data(id_vegn_tran_dir, vegn_tran_dir_dir, tile%diag)
  call send_tile_data(id_vegn_tran_dif, vegn_tran_dif, tile%diag)
  call send_tile_data(id_vegn_tran_lw,  vegn_tran_lw, tile%diag)
  call send_tile_data(id_vegn_sctr_dir, vegn_tran_dir,     tile%diag)
  call send_tile_data(id_subs_refl_dir, subs_refl_dir, tile%diag)
  call send_tile_data(id_subs_refl_dif, subs_refl_dif, tile%diag)
  call send_tile_data(id_grnd_T,     grnd_T,     tile%diag)

  ! --- debug section
  call check_temp_range(land2cplr%t_ca(i,j,k),'update_land_bc_fast','T_ca',lnd%time)

end subroutine update_land_bc_fast


! ============================================================================
subroutine update_land_bc_slow (land2cplr)
  type(land_data_type), intent(inout) :: land2cplr

  ! ---- local vars 
  integer :: i,j,k,face ! coordinates of the watch point, for debug printout

  call update_topo_rough(land2cplr%rough_scale)
  where (land2cplr%mask) &
       land2cplr%rough_scale = max(land2cplr%rough_mom,land2cplr%rough_scale)
  call get_watch_point(i,j,k,face)
  if ( lnd%face==face.and.             &
       lnd%is<=i.and.i<=lnd%ie.and.    &
       lnd%js<=j.and.j<=lnd%je.and.    &
       k<=size(land2cplr%rough_scale,3)) then
     write(*,*)'#### update_land_bc_slow ### output ####'
     write(*,*)'land2cplr%rough_scale',land2cplr%rough_scale(i,j,k)
     write(*,*)'#### update_land_bc_slow ### end of output ####'
  endif
    
end subroutine update_land_bc_slow


! ============================================================================
subroutine Lnd_stock_pe(bnd,index,value)

type(land_data_type), intent(in)  :: bnd 
integer             , intent(in)  :: index
real                , intent(out) :: value ! Domain water (Kg) or heat (Joules)

integer :: i,j,n
type(land_tile_enum_type)     :: ce,te
type(land_tile_type), pointer :: tile
character(len=128) :: message
integer :: is,ie,js,je
real :: area_factor, river_value
! *_twd are tile water densities (kg water per m2 of tile)
real twd_gas_cana,               twd_liq_glac, twd_sol_glac, &
     twd_liq_lake, twd_sol_lake, twd_liq_soil, twd_sol_soil, &
     twd_liq_snow, twd_sol_snow, twd_liq_vegn, twd_sol_vegn
! *_gcwd are grid-cell water densities (kg water per m2 of land in grid cell)
real gcwd_cana, gcwd_glac, gcwd_lake, gcwd_soil, gcwd_snow, gcwd_vegn
! v_* are global masses of water
real v_cana, v_glac, v_lake, v_soil, v_snow, v_vegn
real cana_q, a_globe

value = 0.0
v_cana = 0.
v_glac = 0.
v_lake = 0.
v_soil = 0.
v_snow = 0.
v_vegn = 0.
if(.not.bnd%pe) return
is = lnd%is
ie = lnd%ie
js = lnd%js
je = lnd%je

! The following is a dirty getaround
if(lnd%cellarea(is,js) < 1.0) then
  area_factor = 4*pi*radius**2 ! lnd%area is fraction of globe
else
  area_factor = 1.0 ! lnd%area is actual area (m**2)
endif

select case(index)
case(ISTOCK_WATER)
  do j = js, je
  do i = is, ie
    ce = first_elmt(lnd%tile_map(i,j))
    te = tail_elmt (lnd%tile_map(i,j))
    gcwd_cana = 0.0; gcwd_glac = 0.0; gcwd_lake = 0.0
    gcwd_soil = 0.0; gcwd_snow = 0.0; gcwd_vegn = 0.0
    do while(ce /= te)
      tile => current_tile(ce)
      twd_gas_cana = 0.0
      twd_liq_glac = 0.0 ; twd_sol_glac = 0.0
      twd_liq_lake = 0.0 ; twd_sol_lake = 0.0
      twd_liq_soil = 0.0 ; twd_sol_soil = 0.0
      twd_liq_snow = 0.0 ; twd_sol_snow = 0.0
      twd_liq_vegn = 0.0 ; twd_sol_vegn = 0.0
      if(associated(tile%cana)) then
        call cana_state ( tile%cana, cana_q=cana_q )
        twd_gas_cana = canopy_air_mass*cana_q
        endif
      if(associated(tile%glac)) &
        call glac_tile_stock_pe(tile%glac, twd_liq_glac, twd_sol_glac)
      if(associated(tile%lake)) &
        call lake_tile_stock_pe(tile%lake, twd_liq_lake, twd_sol_lake)
      if(associated(tile%soil)) &
        call soil_tile_stock_pe(tile%soil, twd_liq_soil, twd_sol_soil)
      if(associated(tile%snow)) &
        call snow_tile_stock_pe(tile%snow, twd_liq_snow, twd_sol_snow)
      if(associated(tile%vegn)) &
        call vegn_tile_stock_pe(tile%vegn, twd_liq_vegn, twd_sol_vegn)
      gcwd_cana = gcwd_cana +  twd_gas_cana                 * tile%frac
      gcwd_glac = gcwd_glac + (twd_liq_glac + twd_sol_glac) * tile%frac
      gcwd_lake = gcwd_lake + (twd_liq_lake + twd_sol_lake) * tile%frac
      gcwd_soil = gcwd_soil + (twd_liq_soil + twd_sol_soil) * tile%frac
      gcwd_snow = gcwd_snow + (twd_liq_snow + twd_sol_snow) * tile%frac
      gcwd_vegn = gcwd_vegn + (twd_liq_vegn + twd_sol_vegn) * tile%frac
      ce=next_elmt(ce)
    enddo
    v_cana = v_cana + gcwd_cana * lnd%area(i,j)*area_factor
    v_glac = v_glac + gcwd_glac * lnd%area(i,j)*area_factor
    v_lake = v_lake + gcwd_lake * lnd%area(i,j)*area_factor
    v_soil = v_soil + gcwd_soil * lnd%area(i,j)*area_factor
    v_snow = v_snow + gcwd_snow * lnd%area(i,j)*area_factor
    v_vegn = v_vegn + gcwd_vegn * lnd%area(i,j)*area_factor
  enddo
  enddo
  value  = v_cana + v_glac + v_lake + v_soil + v_snow + v_vegn
a_globe = 4. * pi * radius**2
case(ISTOCK_HEAT)
  if(.not.stock_warning_issued) then
    call error_mesg('Lnd_stock_pe','Heat stock not yet implemented',NOTE)
    stock_warning_issued = .true.
  endif
! do j = js, je
! do i = is, ie
!   ce = first_elmt(lnd%tile_map(i,j))
!   te = tail_elmt (lnd%tile_map(i,j))
!   grid_cell_heat_density = 0.0
!   do while(ce /= te)
!     tile => current_tile(ce)
!     tile_heat_density = 0.0
!     if(associated(tile%soil)) then
!       do n=1, size(tile%soil%prog)
!       tile_heat_density = tile_heat_density + (tile%soil%prog(n)%T-tfreeze)* &
!                  (tile%soil%heat_capacity_dry(n)*dz(n) + &
!                   clw*tile%soil%prog(n)%wl             + &
!                   csw*tile%soil%prog(n)%ws)
!       enddo
!       tile_heat_density = tile_heat_density + clw*soil%prog(1)%groundwater*(soil%prog(1)%groundwater_T-tfreeze) ! Why is this outside n loop?
!     endif
!     grid_cell_heat_density = grid_cell_heat_density + tile_heat_density * tile%frac
!     ce=next_elmt(ce)
!   enddo
!   grid_cell_heat = grid_cell_heat_density * lnd%area(i,j)*area_factor
!   value = value + grid_cell_heat
! enddo
! enddo
case(ISTOCK_SALT)
  if(.not.stock_warning_issued) then
    call error_mesg('Lnd_stock_pe','Salt stock not yet implemented',NOTE)
    stock_warning_issued = .true.
  endif
case default
  write(message,'(i2,a,i2,a,i2,a,i2,a)') &
  index,' is an invalid stock index. Must be ISTOCK_WATER or ISTOCK_HEAT or ISTOCK_SALT (',ISTOCK_WATER,' or ',ISTOCK_HEAT,' or ', ISTOCK_SALT,')'
  call error_mesg('Lnd_stock_pe',message,FATAL)
end select

call river_stock_pe(index, river_value)
value = value + river_value

if (index.eq.ISTOCK_WATER.and.give_stock_details) then
    call mpp_sum(river_value, pelist=lnd%pelist)
    call mpp_sum(v_cana, pelist=lnd%pelist)
    call mpp_sum(v_glac, pelist=lnd%pelist)
    call mpp_sum(v_lake, pelist=lnd%pelist)
    call mpp_sum(v_soil, pelist=lnd%pelist)
    call mpp_sum(v_snow, pelist=lnd%pelist)
    call mpp_sum(v_vegn, pelist=lnd%pelist)
    write (message,'(a,f10.5)') 'total land storage:',v_cana/a_globe+v_glac/a_globe+ &
        v_lake/a_globe+v_soil/a_globe+v_snow/a_globe+v_vegn/a_globe+river_value/a_globe
    call error_mesg('Lnd_stock_pe',message,NOTE)
    write (message,'(a,7f10.5)') '...canopy air:',v_cana/a_globe
    call error_mesg('Lnd_stock_pe',message,NOTE)
    write (message,'(a,7f10.5)') '......glacier:',v_glac/a_globe
    call error_mesg('Lnd_stock_pe',message,NOTE)
    write (message,'(a,7f10.5)') '.........lake:',v_lake/a_globe
    call error_mesg('Lnd_stock_pe',message,NOTE)
    write (message,'(a,7f10.5)') '.........soil:',v_soil/a_globe
    call error_mesg('Lnd_stock_pe',message,NOTE)
    write (message,'(a,7f10.5)') '.........snow:',v_snow/a_globe
    call error_mesg('Lnd_stock_pe',message,NOTE)
    write (message,'(a,7f10.5)') '.........vegn:',v_vegn/a_globe
    call error_mesg('Lnd_stock_pe',message,NOTE)
    write (message,'(a,7f10.5)') '.......rivers:',river_value/a_globe
    call error_mesg('Lnd_stock_pe',message,NOTE)
endif

end subroutine Lnd_stock_pe


! ============================================================================
! initialize horizontal axes for land grid so that all sub-modules can use them,
! instead of creating their own
subroutine land_diag_init(clonb, clatb, clon, clat, time, domain, &
     id_lon, id_lat, id_band)
  real, intent(in) :: &
       clonb(:), clatb(:), & ! longitudes and latitudes of grid cells vertices,
                             ! specified for the global grid
       clon(:),  clat(:)     ! lon and lat of respective grid cell centers
  type(time_type), intent(in) :: time ! initial time for diagnostic fields
  type(domain2d), intent(in)  :: domain
  integer, intent(out) :: &
       id_lon, id_lat, id_band   ! IDs of respective diag. manager axes

  ! ---- local vars ----------------------------------------------------------
  integer :: id_lonb, id_latb ! IDs for cell boundaries
  integer :: nlon, nlat       ! sizes of respective axes
  integer :: axes(2)          ! array of axes for 2-D fields
  integer :: i

  nlon = size(clon)
  nlat = size(clat)

  if(mpp_get_ntile_count(lnd%domain)==1) then
     ! grid has just one tile, so we assume that the grid is regular lat-lon
     ! define longitude axes and its edges
     id_lonb = diag_axis_init ( &
          'lonb', clonb, 'degrees_E', 'X', 'longitude edges', &
          set_name='land', domain2=domain )
     id_lon  = diag_axis_init (                                                &
          'lon',  clon, 'degrees_E', 'X',  &
          'longitude', set_name='land',  edges=id_lonb, domain2=domain )

     ! define latitude axes and its edges
     id_latb = diag_axis_init ( &
          'latb', clatb, 'degrees_N', 'Y', 'latitude edges',  &
          set_name='land',  domain2=domain   )
     id_lat = diag_axis_init (                                                &
          'lat',  clat, 'degrees_N', 'Y', &
          'latitude', set_name='land', edges=id_latb, domain2=domain   )
  else
     id_lon = diag_axis_init ( 'grid_xt', (/(real(i),i=1,nlon)/), 'degrees_E', 'X', &
          'T-cell longitude', set_name='land',  domain2=domain, aux='geolon_t' )
     id_lat = diag_axis_init ( 'grid_yt', (/(real(i),i=1,nlat)/), 'degrees_N', 'Y', &
          'T-cell latitude', set_name='land',  domain2=domain, aux='geolat_t' )
  endif
  id_band = diag_axis_init (                                                &
       'band',  (/1.0,2.0/), 'unitless', 'Z', &
       'spectral band', set_name='land' )

  ! set up an array of axes, for convenience
  axes = (/id_lon, id_lat/)

  ! register auxilary coordinate variables

  id_geolon_t = register_static_field ( module_name, 'geolon_t', axes, &
       'longitude of grid cell centers', 'degrees_E', missing_value = -1.0e+20 )
  id_geolat_t = register_static_field ( module_name, 'geolat_t', axes, &
       'latitude of grid cell centers', 'degrees_N', missing_value = -1.0e+20 )

  ! register static diagnostic fields

  id_cellarea = register_static_field ( module_name, 'cell_area', axes, &
       'total area in grid cell', 'm2', missing_value=-1.0 )
  id_landarea = register_static_field ( module_name, 'land_area', axes, &
       'land area in grid cell', 'm2', missing_value=-1.0 )
  id_landfrac = register_static_field ( module_name, 'land_frac', axes, &
       'fraction of land in grid cell','unitless', missing_value=-1.0 ) 
  id_no_riv = register_static_field ( module_name, 'no_riv', axes, &
       'indicator of land without rivers','unitless', missing_value=-1.0 ) 

  ! register regular (dynamic) diagnostic fields

  id_VWS = register_tiled_diag_field ( module_name, 'VWS', axes, time, &
             'vapor storage on land', 'kg/m2', missing_value=-1.0e+20 )
  id_VWSc    = register_tiled_diag_field ( module_name, 'VWSc', axes, time, &
             'vapor mass in canopy air', 'kg/m2', missing_value=-1.0e+20 )
  id_LWS = register_tiled_diag_field ( module_name, 'LWS', axes, time, &
             'liquid storage on land', 'kg/m2', missing_value=-1.0e+20 )
  id_LWSv    = register_tiled_diag_field ( module_name, 'LWSv', axes, time, &
             'liquid interception storage', 'kg/m2', missing_value=-1.0e+20 )
  id_LWSs    = register_tiled_diag_field ( module_name, 'LWSs', axes, time, &
             'liquid storage in snowpack', 'kg/m2', missing_value=-1.0e+20 )
  id_LWSg    = register_tiled_diag_field ( module_name, 'LWSg', axes, time, &
             'liquid ground storage', 'kg/m2', missing_value=-1.0e+20 )
  id_FWS = register_tiled_diag_field ( module_name, 'FWS', axes, time, &
             'frozen storage on land', 'kg/m2', missing_value=-1.0e+20 )
  id_FWSv    = register_tiled_diag_field ( module_name, 'FWSv', axes, time, &
             'frozen interception storage', 'kg/m2', missing_value=-1.0e+20 )
  id_FWSs    = register_tiled_diag_field ( module_name, 'FWSs', axes, time, &
             'frozen storage in snowpack', 'kg/m2', missing_value=-1.0e+20 )
  id_FWSg    = register_tiled_diag_field ( module_name, 'FWSg', axes, time, &
             'frozen ground storage', 'kg/m2', missing_value=-1.0e+20 )
  id_HS = register_tiled_diag_field ( module_name, 'HS', axes, time, &
             'land heat storage', 'J/m2', missing_value=-1.0e+20 )
  id_HSv     = register_tiled_diag_field ( module_name, 'HSv', axes, time, &
             'interception heat storage', 'J/m2', missing_value=-1.0e+20 )
  id_HSs     = register_tiled_diag_field ( module_name, 'HSs', axes, time, &
             'heat storage in snowpack', 'J/m2', missing_value=-1.0e+20 )
  id_HSg     = register_tiled_diag_field ( module_name, 'HSg', axes, time, &
             'ground heat storage', 'J/m2', missing_value=-1.0e+20 )
  id_HSc     = register_tiled_diag_field ( module_name, 'HSc', axes, time, &
             'canopy-air heat storage', 'J/m2', missing_value=-1.0e+20 )

  id_dis_liq   = register_diag_field ( module_name, 'dis_liq', axes, &
       time, 'liquid discharge to ocean', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_dis_ice   = register_diag_field ( module_name, 'dis_ice', axes, &
       time, 'ice discharge to ocean', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_dis_heat   = register_diag_field ( module_name, 'dis_heat', axes, &
       time, 'heat of mass discharge to ocean', 'W/m2', missing_value=-1.0e+20 )
  id_dis_sink   = register_diag_field ( module_name, 'dis_sink', axes, &
       time, 'burial rate of small/negative discharge', 'kg/(m2 s)', missing_value=-1.0e+20 )

  id_precip = register_tiled_diag_field ( module_name, 'precip', axes, time, &
             'precipitation rate', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_hprec = register_tiled_diag_field ( module_name, 'hprec', axes, time, &
             'sensible heat of precipitation', 'W/m2', missing_value=-1.0e+20 )
  id_lprec = register_tiled_diag_field ( module_name, 'lprec_l', axes, time, &
             'rainfall to land', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_lprecv = register_tiled_diag_field ( module_name, 'lprecv', axes, time, &
             'net rainfall to vegetation', 'kg/(m2 s)', missing_value=-1.0e+20)
  id_lprecs = register_tiled_diag_field ( module_name, 'lprecs', axes, time, &
             'rainfall to snow, minus drainage', 'kg/(m2 s)', missing_value=-1.0e+20)
  id_lprecg = register_tiled_diag_field ( module_name, 'lprecg', axes, time, &
             'effective rainfall to ground sfc', 'kg/(m2 s)', missing_value=-1.0e+20)
  id_hlprec  = register_tiled_diag_field ( module_name, 'hlprec', axes, time, &
             'total liq precipitation heat', 'W/m2', missing_value=-1.0e+20)
  id_hlprecv = register_tiled_diag_field ( module_name, 'hlprecv', axes, time, &
             'net liq heat to vegetation', 'W/m2', missing_value=-1.0e+20)
  id_hlprecs = register_tiled_diag_field ( module_name, 'hlprecs', axes, time, &
             'net liq heat to snow', 'W/m2', missing_value=-1.0e+20)
  id_hlprecg = register_tiled_diag_field ( module_name, 'hlprecg', axes, time, &
             'net liq heat to ground sfc', 'W/m2', missing_value=-1.0e+20)
  id_fprec = register_tiled_diag_field ( module_name, 'fprec_l', axes, time, &
             'snowfall to land', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_fprecv = register_tiled_diag_field ( module_name, 'fprecv', axes, time, &
             'net snowfall to vegetation', 'kg/(m2 s)', missing_value=-1.0e+20)
  id_fprecs = register_tiled_diag_field ( module_name, 'fprecs', axes, time, &
             'effective snowfall to snowpack', 'kg/(m2 s)', missing_value=-1.0e+20)
  id_hfprec = register_tiled_diag_field ( module_name, 'hfprec', axes, time, &
             'sens heat of snowfall', 'W/m2', missing_value=-1.0e+20)
  id_hfprecv = register_tiled_diag_field ( module_name, 'hfprecv', axes, time, &
             'net sol heat to vegetation', 'W/m2', missing_value=-1.0e+20)
  id_hfprecs = register_tiled_diag_field ( module_name, 'hfprecs', axes, time, &
             'net sol heat to snow', 'W/m2', missing_value=-1.0e+20)
  id_evap = register_tiled_diag_field ( module_name, 'evap', axes, time, &
             'vapor flux up from land', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_hevap = register_tiled_diag_field ( module_name, 'hevap', axes, time, &
             'sensible heat of evap', 'W/m2', missing_value=-1.0e+20 )
  id_levap   = register_tiled_diag_field ( module_name, 'levap', axes, time, &
             'vapor flux from all liq (inc Tr)', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_levapv = register_tiled_diag_field ( module_name, 'levapv', axes, time, &
             'vapor flux leaving intercepted liquid', 'kg/(m2 s)', missing_value=-1.0e+20)
  id_levaps = register_tiled_diag_field ( module_name, 'levaps', axes, time, &
             'vapor flux leaving snow liquid', 'kg/(m2 s)', missing_value=-1.0e+20)
  id_levapg = register_tiled_diag_field ( module_name, 'levapg', axes, time, &
             'vapor flux from ground liquid', 'kg/(m2 s)', missing_value=-1.0e+20)
  id_hlevap = register_tiled_diag_field ( module_name, 'hlevap', axes, time, &
             'vapor flux heat from liq source', 'W/m2', missing_value=-1.0e+20)
  id_hlevapv = register_tiled_diag_field ( module_name, 'hlevapv', axes, time, &
             'vapor heat from liq interc', 'W/m2', missing_value=-1.0e+20)
  id_hlevaps = register_tiled_diag_field ( module_name, 'hlevaps', axes, time, &
             'vapor heat from snow liq', 'W/m2', missing_value=-1.0e+20)
  id_hlevapg = register_tiled_diag_field ( module_name, 'hlevapg', axes, time, &
             'vapor heat from ground liq', 'W/m2', missing_value=-1.0e+20)
  id_fevap   = register_tiled_diag_field ( module_name, 'fevap', axes, time, &
             'vapor flux from all ice', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_fevapv = register_tiled_diag_field ( module_name, 'fevapv', axes, time, &
             'vapor flux leaving vegn ice', 'kg/(m2 s)', missing_value=-1.0e+20)
  id_fevaps = register_tiled_diag_field ( module_name, 'fevaps', axes, time, &
             'vapor flux leaving snow ice', 'kg/(m2 s)', missing_value=-1.0e+20)
  id_fevapg = register_tiled_diag_field ( module_name, 'fevapg', axes, time, &
             'vapor flux leaving ground ice', 'kg/(m2 s)', missing_value=-1.0e+20)
  id_hfevap = register_tiled_diag_field ( module_name, 'hfevap', axes, time, &
             'vapor flux heat from solid source', 'W/m2', missing_value=-1.0e+20)
  id_hfevapv = register_tiled_diag_field ( module_name, 'hfevapv', axes, time, &
             'vapor heat from sol interc', 'W/m2', missing_value=-1.0e+20)
  id_hfevaps = register_tiled_diag_field ( module_name, 'hfevaps', axes, time, &
             'vapor heat from snow sol', 'W/m2', missing_value=-1.0e+20)
  id_hfevapg = register_tiled_diag_field ( module_name, 'hfevapg', axes, time, &
             'vapor heat from ground sol', 'W/m2', missing_value=-1.0e+20)
  id_runf   = register_tiled_diag_field ( module_name, 'runf', axes, time, &
             'total runoff', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_hrunf   = register_tiled_diag_field ( module_name, 'hrunf', axes, time, &
             'sensible heat of total runoff', 'W/m2', missing_value=-1.0e+20 )
  id_lrunf   = register_tiled_diag_field ( module_name, 'lrunf', axes, time, &
             'total rate of liq runoff', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_lrunfs  = register_tiled_diag_field ( module_name, 'lrunfs', axes, time, &
             'rate of liq runoff via calving', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_lrunfg  = register_tiled_diag_field ( module_name, 'lrunfg', axes, time, &
             'rate of liq runoff, ground', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_hlrunf  = register_tiled_diag_field ( module_name, 'hlrunf', axes, time, &
             'heat of liq runoff', 'W/m2', missing_value=-1.0e+20 )
  id_hlrunfs  = register_tiled_diag_field ( module_name, 'hlrunfs', axes, time, &
             'heat of liq runoff from snow pack', 'W/m2', missing_value=-1.0e+20 )
  id_hlrunfg  = register_tiled_diag_field ( module_name, 'hlrunfg', axes, time, &
             'heat of liq surface runoff', 'W/m2', missing_value=-1.0e+20 )
  id_frunf   = register_tiled_diag_field ( module_name, 'frunf', axes, time, &
             'total rate of solid runoff', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_frunfs  = register_tiled_diag_field ( module_name, 'frunfs', axes, time, &
             'rate of solid calving', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_hfrunf  = register_tiled_diag_field ( module_name, 'hfrunf', axes, time, &
             'heat of total ice runoff', 'W/m2', missing_value=-1.0e+20 )
  id_hfrunfs  = register_tiled_diag_field ( module_name, 'hfrunfs', axes, time, &
             'heat of sol snow runoff', 'W/m2', missing_value=-1.0e+20 )
  id_melt    = register_tiled_diag_field ( module_name, 'melt', axes, time, &
             'total rate of melt', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_meltv   = register_tiled_diag_field ( module_name, 'meltv', axes, time, &
             'rate of melt, interception', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_melts   = register_tiled_diag_field ( module_name, 'melts', axes, time, &
             'rate of snow melt', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_meltg   = register_tiled_diag_field ( module_name, 'meltg', axes, time, &
             'rate of substrate thaw', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_fsw     = register_tiled_diag_field ( module_name, 'fsw', axes, time, &
             'net sw rad to land', 'W/m2', missing_value=-1.0e+20 )
  id_fswv    = register_tiled_diag_field ( module_name, 'fswv', axes, time, &
             'net sw rad to vegetation', 'W/m2', missing_value=-1.0e+20 )
  id_fsws    = register_tiled_diag_field ( module_name, 'fsws', axes, time, &
             'net sw rad to snow', 'W/m2', missing_value=-1.0e+20 )
  id_fswg    = register_tiled_diag_field ( module_name, 'fswg', axes, time, &
             'net sw rad to ground', 'W/m2', missing_value=-1.0e+20 )
  id_flw     = register_tiled_diag_field ( module_name, 'flw', axes, time, &
             'net lw rad to land', 'W/m2', missing_value=-1.0e+20 )
  id_flwv    = register_tiled_diag_field ( module_name, 'flwv', axes, time, &
             'net lw rad to vegetation', 'W/m2', missing_value=-1.0e+20 )
  id_flws    = register_tiled_diag_field ( module_name, 'flws', axes, time, &
             'net lw rad to snow', 'W/m2', missing_value=-1.0e+20 )
  id_flwg    = register_tiled_diag_field ( module_name, 'flwg', axes, time, &
             'net lw rad to ground', 'W/m2', missing_value=-1.0e+20 )
  id_cd_m    = register_tiled_diag_field ( module_name, 'cd_m', axes, time, &
       'drag coefficient for momentum', missing_value=-1e20)
  id_cd_t    = register_tiled_diag_field ( module_name, 'cd_t', axes, time, &
       'drag coefficient for heat and tracers', missing_value=-1e20)
  id_sens    = register_tiled_diag_field ( module_name, 'sens', axes, time, &
             'sens heat flux from land', 'W/m2', missing_value=-1.0e+20 )
  id_sensv   = register_tiled_diag_field ( module_name, 'sensv', axes, time, &
             'sens heat flux from vegn', 'W/m2', missing_value=-1.0e+20 )
  id_senss   = register_tiled_diag_field ( module_name, 'senss', axes, time, &
             'sens heat flux from snow', 'W/m2', missing_value=-1.0e+20 )
  id_sensg   = register_tiled_diag_field ( module_name, 'sensg', axes, time, &
             'sens heat flux from ground', 'W/m2', missing_value=-1.0e+20 )
  id_e_res_1 = register_tiled_diag_field ( module_name, 'e_res_1', axes, time, &
       'canopy air energy residual due to nonlinearities', 'W/m2', missing_value=-1e20)
  id_e_res_2 = register_tiled_diag_field ( module_name, 'e_res_2', axes, time, &
       'canopy energy residual due to nonlinearities', 'W/m2', missing_value=-1e20)
  id_frac = register_tiled_diag_field(module_name,'frac', axes,&
       time, 'fraction of land area', 'unitless', missing_value=-1.0, op=OP_SUM )
  id_area = register_tiled_diag_field(module_name,'area', axes,&
       time, 'area in the grid cell', 'm2', missing_value=-1.0, op=OP_SUM )
  id_ntiles = register_tiled_diag_field(module_name,'ntiles',axes,  &
       time, 'number of tiles', 'unitless', missing_value=-1.0, op=OP_SUM)
  id_z0m     = register_tiled_diag_field ( module_name, 'z0m', axes, time, &
             'momentum roughness of land', 'm', missing_value=-1.0e+20 )
  id_z0s     = register_tiled_diag_field ( module_name, 'z0s', axes, time, &
             'scalar roughness of land', 'm', missing_value=-1.0e+20 )
  id_con_g_h = register_tiled_diag_field ( module_name, 'con_g_h', axes, time, &
       'conductance for sensible heat between ground surface and canopy air', &
       'm/s', missing_value=-1.0 )
  id_transp  = register_tiled_diag_field ( module_name, 'transp', axes, time, &
             'transpiration; = uptake by roots', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_wroff = register_tiled_diag_field ( module_name, 'wroff', axes, time, &
             'rate of liquid runoff to rivers', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_sroff = register_tiled_diag_field ( module_name, 'sroff', axes, time, &
             'rate of solid runoff to rivers', 'kg/(m2 s)', missing_value=-1.0e+20 )
  id_htransp = register_tiled_diag_field ( module_name, 'htransp', axes, time, &
             'heat of transpired vapior', 'W/m2', missing_value=-1.0e+20 )
  id_huptake = register_tiled_diag_field ( module_name, 'huptk', axes, time, &
             'heat of soil water uptake', 'W/m2', missing_value=-1.0e+20 )
  id_hroff = register_tiled_diag_field ( module_name, 'hroff', axes, time, &
             'sensible heat of runoff', 'W/m2', missing_value=-1.0e+20 )
  id_gsnow   = register_tiled_diag_field ( module_name, 'gsnow', axes, time, &
             'sens heat into ground from snow', 'W/m2', missing_value=-1.0e+20 )
  call add_tiled_diag_field_alias ( id_gsnow, module_name, 'gflux', axes, time, &
             'obsolete, please use "gsnow" instead', 'W/m2', missing_value=-1.0e+20 )
  id_gequil   = register_tiled_diag_field ( module_name, 'gequil', axes, time, &
             'snow-subs equilibration flux', 'W/m2', missing_value=-1.0e+20 )
  id_grnd_flux = register_tiled_diag_field ( module_name, 'grnd_flux', axes, time, &
             'sensible heat into ground from surface', 'W/m2', missing_value=-1.0e+20 )
  id_soil_water_supply = register_tiled_diag_field ( module_name, 'soil_water_supply', axes, time, &
       'maximum rate of soil water supply to vegetation', 'kg/(m2 s)', missing_value=-1e20)
  id_levapg_max = register_tiled_diag_field ( module_name, 'Eg_max', axes, time, &
             'soil_water limit on vapor flux from ground liquid', 'kg/(m2 s)', missing_value=-1.0e+20)
  id_water = register_tiled_diag_field ( module_name, 'water', axes, time, &
             'column-integrated soil water', 'kg/m2', missing_value=-1.0e+20 )
  id_snow = register_tiled_diag_field ( module_name, 'snow', axes, time, &
             'column-integrated snow water', 'kg/m2', missing_value=-1.0e+20 )
  id_Trad    = register_tiled_diag_field ( module_name, 'Trad', axes, time, &
             'radiative sfc temperature', 'degK', missing_value=-1.0e+20 )
  id_Tca     = register_tiled_diag_field ( module_name, 'Tca', axes, time, &
             'canopy-air temperature', 'degK', missing_value=-1.0e+20 )
  id_qca     = register_tiled_diag_field ( module_name, 'qca', axes, time, &
             'canopy-air specific humidity', 'kg/kg', missing_value=-1.0 )
  id_qco2    = register_tiled_diag_field ( module_name, 'qco2', axes, time, &
             'canopy-air CO2 moist mass mixing ratio', 'kg/kg', missing_value=-1.0 )
  id_qco2_dvmr = register_tiled_diag_field ( module_name, 'qco2_dvmr', axes, time, &
             'canopy-air CO2 dry volumetric mixing ratio', 'mol CO2/mol air', missing_value=-1.0 )
  id_fco2    = register_tiled_diag_field ( module_name, 'fco2', axes, time, &
             'flux of CO2 to canopy air', 'kg C/(m2 s)', missing_value=-1.0 )
  id_swdn_dir = register_tiled_diag_field ( module_name, 'swdn_dir', (/id_lon,id_lat,id_band/), time, &
       'downward direct short-wave radiation flux to the land surface', 'W/m2', missing_value=-999.0)
  id_swdn_dif = register_tiled_diag_field ( module_name, 'swdn_dif', (/id_lon,id_lat,id_band/), time, &
       'downward diffuse short-wave radiation flux to the land surface', 'W/m2', missing_value=-999.0)
  id_swup_dir = register_tiled_diag_field ( module_name, 'swup_dir', (/id_lon,id_lat,id_band/), time, &
       'direct short-wave radiation flux reflected by the land surface', 'W/m2', missing_value=-999.0)
  id_swup_dif = register_tiled_diag_field ( module_name, 'swup_dif', (/id_lon,id_lat,id_band/), time, &
       'diffuse short-wave radiation flux reflected by the land surface', 'W/m2', missing_value=-999.0)
  id_lwdn = register_tiled_diag_field ( module_name, 'lwdn', axes, time, &
       'downward long-wave radiation flux to the land surface', 'W/m2', missing_value=-999.0)
  id_vegn_cover = register_tiled_diag_field ( module_name, 'vegn_cover', axes, time, &
             'fraction covered by vegetation', missing_value=-1.0 )
  id_cosz = register_tiled_diag_field ( module_name, 'coszen', axes, time, &
       'cosine of zenith angle', missing_value=-2.0 )
  id_albedo_dir = register_tiled_diag_field ( module_name, 'albedo_dir', &
       (/id_lon,id_lat,id_band/), time, &
       'land surface albedo for direct light', missing_value=-1.0 )
  id_albedo_dif = register_tiled_diag_field ( module_name, 'albedo_dif', &
       (/id_lon,id_lat,id_band/), time, &
       'land surface albedo for diffuse light', missing_value=-1.0 )
  id_vegn_refl_dir = register_tiled_diag_field(module_name, 'vegn_refl_dir', &
       (/id_lon, id_lat, id_band/), time, &
       'black-background canopy reflectivity for direct light',missing_value=-1.0)
  id_vegn_refl_dif = register_tiled_diag_field(module_name, 'vegn_refl_dif', &
       (/id_lon, id_lat, id_band/), time, &
       'black-background canopy reflectivity for diffuse light',missing_value=-1.0)
  id_vegn_refl_lw = register_tiled_diag_field ( module_name, 'vegn_refl_lw', axes, time, &
       'canopy reflectivity for thermal radiation', missing_value=-1.0)
  id_vegn_tran_dir = register_tiled_diag_field(module_name, 'vegn_tran_dir', &
       (/id_lon, id_lat, id_band/), time, &
       'part of direct light that passes through canopy unscattered',missing_value=-1.0)
  id_vegn_tran_dif = register_tiled_diag_field(module_name, 'vegn_tran_dif', &
       (/id_lon, id_lat, id_band/), time, &
       'black-background canopy transmittance for diffuse light',missing_value=-1.0)
  id_vegn_tran_lw = register_tiled_diag_field ( module_name, 'vegn_tran_lw', axes, time, &
       'canopy transmittance for thermal radiation', missing_value=-1.0)
  id_vegn_sctr_dir = register_tiled_diag_field(module_name, 'vegn_sctr_dir', &
       (/id_lon, id_lat, id_band/), time, &
       'part of direct light scattered downward by canopy',missing_value=-1.0)
  id_subs_refl_dir = register_tiled_diag_field(module_name, 'subs_refl_dir', &
       (/id_lon, id_lat, id_band/), time, &
       'substrate reflectivity for direct light',missing_value=-1.0)
  id_subs_refl_dif = register_tiled_diag_field(module_name, 'subs_refl_dif', &
       (/id_lon, id_lat, id_band/), time, &
       'substrate reflectivity for diffuse light',missing_value=-1.0)
  id_subs_emis = register_tiled_diag_field(module_name, 'subs_emis', &
       (/id_lon, id_lat/), time, &
       'substrate emissivity for long-wave radiation',missing_value=-1.0)
  id_grnd_T = register_tiled_diag_field ( module_name, 'Tgrnd', axes, time, &
       'ground surface temperature', 'degK', missing_value=-1.0 )
  id_total_C = register_tiled_diag_field ( module_name, 'Ctot', axes, time, &
       'total land carbon', 'kg C/m2', missing_value=-1.0 )
end subroutine land_diag_init

! the code below defines the accessor routines that are used to access fields of the 
! tile data structure in collective operations, like restart i/o. Fore example, a statement
! DEFINE_LAND_ACCESSOR_0D(real,lwup)
! defines a function "land_lwup_ptr" that, given a tile, returns a pointer to the field
! called "lwup" in this tile. The procedure implementing a collective operation would
! enumerate all the tiles within the domain, call accessor routine for each of them, and
! get or set the value pointed to by the accessor routine.
#define DEFINE_LAND_ACCESSOR_0D(xtype,x) subroutine CONCAT3(land_,x,_ptr(t,p));\
type(land_tile_type),pointer::t;xtype,pointer::p;p=>NULL();if(associated(t))p=>t%x;end subroutine

DEFINE_LAND_ACCESSOR_0D(real,frac)
DEFINE_LAND_ACCESSOR_0D(real,lwup)
DEFINE_LAND_ACCESSOR_0D(real,e_res_1)
DEFINE_LAND_ACCESSOR_0D(real,e_res_2)

! ============================================================================
! tile existence detector: returns a logical value indicating wether component
! model tile exists or not
logical function land_tile_exists(tile)
  type(land_tile_type), pointer :: tile
  land_tile_exists = associated(tile)
end function land_tile_exists

#define DEFINE_TAG_ACCESSOR(x) subroutine  CONCAT2(x,_tag_ptr(t,p));\
type(land_tile_type),pointer::t;integer,pointer::p;p=>NULL();if(associated(t))\
then;if (associated(t%x)) p=>t%x%tag;endif;end subroutine

DEFINE_TAG_ACCESSOR(glac)
DEFINE_TAG_ACCESSOR(lake)
DEFINE_TAG_ACCESSOR(soil)
DEFINE_TAG_ACCESSOR(vegn)

end module land_model_mod
   

module topography_mod

! <CONTACT EMAIL="Bruce.Wyman@noaa.gov">
!   Bruce Wyman
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!   Routines for creating land surface topography fields and land-water masks
!   for latitude-longitude grids.
! </OVERVIEW>

! <DESCRIPTION>
!   This module generates realistic mountains and land-water masks
!   on a specified latitude-longitude grid by interpolating from the
!   1/6 degree Navy mean topography and percent water data sets.
!   The fields that can be generated are mean and standard deviation
!   of topography within the specified grid boxes; and land-ocean (or
!   water) mask and land-ocean (or water) fractional area.
!
!   The interpolation scheme conserves the area-weighted average
!   of the input data by using module horiz_interp.
!
!   The interfaces get_gaussian_topog and gaussian_topog_init are documented in <LINK SRC="gaussian_topog.html">gaussian_topog_mod</LINK>.
! </DESCRIPTION>

use gaussian_topog_mod, only: gaussian_topog_init, get_gaussian_topog
use   horiz_interp_mod, only: horiz_interp_type, horiz_interp_new, &
                              horiz_interp, horiz_interp_del

use            fms_mod, only: file_exist, check_nml_error,               &
                              open_namelist_file, close_file, stdlog,    &
                              mpp_pe, mpp_root_pe, write_version_number, &
                              open_ieee32_file, error_mesg, FATAL, NOTE, &
                              mpp_error
use         fms_io_mod, only: read_data
use      constants_mod, only: PI
use            mpp_mod, only: input_nml_file

implicit none
private

public :: topography_init,                 &
          get_topog_mean, get_topog_stdev, &
          get_ocean_frac, get_ocean_mask,  &
          get_water_frac, get_water_mask,  &
          gaussian_topog_init, get_gaussian_topog

interface get_topog_mean
  module procedure get_topog_mean_1d, get_topog_mean_2d
end interface
interface get_topog_stdev
  module procedure get_topog_stdev_1d, get_topog_stdev_2d
end interface
interface get_ocean_frac
  module procedure get_ocean_frac_1d, get_ocean_frac_2d
end interface
interface get_ocean_mask
  module procedure get_ocean_mask_1d, get_ocean_mask_2d
end interface
interface get_water_frac
  module procedure get_water_frac_1d, get_water_frac_2d
end interface
interface get_water_mask
  module procedure get_water_mask_1d, get_water_mask_2d
end interface

!-----------------------------------------------------------------------
! <NAMELIST NAME="topography_nml">
!   <DATA NAME="topog_file" TYPE="character" DEFAULT="DATA/navy_topography.data">
!       Name of topography file.
!   </DATA>
!   <DATA NAME="water_file" TYPE="character" DEFAULT="DATA/navy_pctwater.data">
!       Name of percent water file.
!   </DATA>

   character(len=128) :: topog_file = 'DATA/navy_topography.data', &
                         water_file = 'DATA/navy_pctwater.data'
   namelist /topography_nml/ topog_file, water_file
! </NAMELIST>

!-----------------------------------------------------------------------
! --- resolution of the topography data set ---
! <DATASET NAME="">
!   This module uses the 1/6 degree U.S. Navy mean topography
!   and percent water data sets.
!
!   These data sets have been re-formatted to separate 32-bit IEEE files.
!   The names of these files is specified by the <LINK SRC="#NAMELIST">namelist</LINK> input.
!
!The format for both files is as follows:
! <PRE>
!     record = 1    nlon, nlat
!     record = 2    blon, blat
!     record = 3    data
! </PRE>
!where:
! <PRE>
!     nlon, nlat = The number of longitude and latitude points
!                  in the horizontal grid.  For the 1/6 degree
!                  data sets this is 2160 x 1080. [integer]
!     blon, blat = The longitude and latitude grid box boundaries in degrees.
!                     [real :: blon(nlon+1), blat(nlat+1)]
!
!     data       = The topography or percent water data.
!                    [real :: data(nlon,nlat)]
! </PRE>
! </DATASET>
  integer :: unit
  integer :: ipts, jpts
  integer, parameter :: COMPUTE_STDEV = 123  ! use this flag to
                                             !   compute st dev

!-----------------------------------------------------------------------

 character(len=128) :: version = '$Id$'
 character(len=128) :: tagname = '$Name$'

 logical :: module_is_initialized = .FALSE.

!-----------------------------------------------------------------------

 contains

!#######################################################################

   subroutine topography_init ()

     if ( module_is_initialized ) return

     call write_version_number (version,tagname)
     call read_namelist
     module_is_initialized = .TRUE.

   end subroutine topography_init

!#######################################################################

! <FUNCTION NAME="get_topog_mean">

!   <OVERVIEW>
!     Returns a "realistic" mean surface height field. 
!   </OVERVIEW>
!   <DESCRIPTION>
!     Returns realistic mountains on a latitude-longtude grid.
!     The returned field is the mean topography for the given grid boxes.
!     Computed using a conserving area-weighted interpolation.
!     The current input data set is the 1/6 degree Navy mean topography.
!   </DESCRIPTION>
!   <TEMPLATE>
!     flag = <B>get_topog_mean</B> ( blon, blat, zmean )
!   </TEMPLATE>

!   <IN NAME="blon" TYPE="real" DIM="(:)">
!     The longitude (in radians) at grid box boundaries.
!   </IN>
!   <IN NAME="blat" TYPE="real" DIM="(:)">
!     The latitude (in radians) at grid box boundaries.
!   </IN>
!   <OUT NAME="zmean" UNIT=" meter" TYPE="real" DIM="(:,:)">
!     The mean surface height (meters).
!     The size of this field must be size(blon)-1 by size(blat)-1.
!   </OUT>
!   <OUT NAME="get_topog_mean" TYPE="logical">
!     A logical value of TRUE is returned if the surface height field
!     was successfully created. A value of FALSE may be returned if the
!     input topography data set was not readable.
!   </OUT>

!   <ERROR MSG="shape(zmean) is not equal to (/size(blon)-1,size(blat)-1/))" STATUS="FATAL">
!     Check the input grid size and output field size.
!   </ERROR>

 function get_topog_mean_1d (blon, blat, zmean)

   real, intent(in),  dimension(:)   :: blon, blat
   real, intent(out), dimension(:,:) :: zmean
   logical :: get_topog_mean_1d

!-----------------------------------------------------------------------
   if (.not. module_is_initialized) call topography_init()

   if ( any(shape(zmean(:,:)) /= (/size(blon(:))-1,size(blat(:))-1/)) ) &
        call error_mesg('get_topog_mean_1d','shape(zmean) is not&
            & equal to (/size(blon)-1,size(blat)-1/))', FATAL)

   if ( open_topog_file(topog_file) ) then
       call interp_topog_1d ( blon, blat, zmean )
       get_topog_mean_1d = .true.
   else
       get_topog_mean_1d = .false.
   endif

!-----------------------------------------------------------------------

 end function get_topog_mean_1d

!############################################################

 function get_topog_mean_2d (blon, blat, zmean)

   real, intent(in),  dimension(:,:) :: blon, blat
   real, intent(out), dimension(:,:) :: zmean
   logical :: get_topog_mean_2d

!-----------------------------------------------------------------------
   if (.not. module_is_initialized) call topography_init()

   if ( any(shape(zmean(:,:)) /= (/size(blon,1)-1,size(blon,2)-1/)) .or. &
        any(shape(zmean(:,:)) /= (/size(blat,1)-1,size(blat,2)-1/)) ) &
        call error_mesg('get_topog_mean_2d','shape(zmean) is not&
            & equal to (/size(blon,1)-1,size(blon,2)-1/))', FATAL)

   if ( open_topog_file(topog_file) ) then
       call interp_topog_2d ( blon, blat, zmean )
       get_topog_mean_2d = .true.
   else
       get_topog_mean_2d = .false.
   endif

!-----------------------------------------------------------------------

 end function get_topog_mean_2d

! </FUNCTION>
!#######################################################################

! <FUNCTION NAME="get_topog_stdev">

!   <OVERVIEW>
!     Returns a standard deviation of higher resolution topography with 
!     the given model grid boxes. 
!   </OVERVIEW>
!   <DESCRIPTION>
!     Returns the standard deviation of the "finer" input topography data set,
!     currently the Navy 1/6 degree mean topography data, within the
!     boundaries of the given input grid.
!   </DESCRIPTION>
!   <TEMPLATE>
!     flag = <B>get_topog_stdev</B> ( blon, blat, stdev )
!   </TEMPLATE>
!   <IN NAME="blon" TYPE="real" DIM="(:)">
!     The longitude (in radians) at grid box boundaries.
!   </IN>
!   <IN NAME="blat" TYPE="real" DIM="(:)">
!     The latitude (in radians) at grid box boundaries.
!   </IN>
!   <OUT NAME="stdev" UNITS="meter" TYPE="real" DIM="(:,:)">
!     The standard deviation of surface height (in meters) within
!     given input model grid boxes.
!     The size of this field must be size(blon)-1 by size(blat)-1.
!   </OUT>
!   <OUT NAME="get_topog_stdev" TYPE="logical">
!     A logical value of TRUE is returned if the output field was
!     successfully created. A value of FALSE may be returned if the
!     input topography data set was not readable.
!   </OUT>

 function get_topog_stdev_1d (blon, blat, stdev)

   real, intent(in),  dimension(:)   :: blon, blat
   real, intent(out), dimension(:,:) :: stdev
   logical :: get_topog_stdev_1d

!-----------------------------------------------------------------------
   if (.not. module_is_initialized) call topography_init()

   if ( any(shape(stdev(:,:)) /= (/size(blon(:))-1,size(blat(:))-1/)) ) &
       call error_mesg('get_topog_stdev','shape(stdev) is not&
            & equal to (/size(blon)-1,size(blat)-1/))', FATAL)

   if ( open_topog_file(topog_file) ) then
       call interp_topog_1d ( blon, blat, stdev, flag=COMPUTE_STDEV )
       get_topog_stdev_1d = .true.
   else
       get_topog_stdev_1d = .false.
   endif

!-----------------------------------------------------------------------

 end function get_topog_stdev_1d

!#######################################################################

 function get_topog_stdev_2d (blon, blat, stdev)

   real, intent(in),  dimension(:,:) :: blon, blat
   real, intent(out), dimension(:,:) :: stdev
   logical :: get_topog_stdev_2d

!-----------------------------------------------------------------------
   if (.not. module_is_initialized) call topography_init()

   if ( any(shape(stdev(:,:)) /= (/size(blon,1)-1,size(blon,2)-1/)) .or. &
        any(shape(stdev(:,:)) /= (/size(blat,1)-1,size(blat,2)-1/)) ) &
        call error_mesg('get_topog_stdev_2d','shape(stdev) is not&
            & equal to (/size(blon,1)-1,size(blon,2)-1/))', FATAL)

   if ( open_topog_file(topog_file) ) then
       call interp_topog_2d ( blon, blat, stdev, flag=COMPUTE_STDEV )
       get_topog_stdev_2d = .true.
   else
       get_topog_stdev_2d = .false.
   endif

!-----------------------------------------------------------------------

 end function get_topog_stdev_2d

! </FUNCTION>
!#######################################################################

! <FUNCTION NAME="get_ocean_frac">

!   <OVERVIEW>
!      Returns fractional area covered by ocean in a grid box.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Returns fractional area covered by ocean in the given model grid boxes.
!   </DESCRIPTION>
!   <TEMPLATE>
!     flag = <B>get_ocean_frac</B> ( blon, blat, ocean_frac )
!   </TEMPLATE>

!   <IN NAME="blon" UNITS="radians" TYPE="real" DIM="(:)">
!     The longitude (in radians) at grid box boundaries.
!   </IN>
!   <IN NAME="blat" UNITS="radians" TYPE="real" DIM="(:)">
!     The latitude (in radians) at grid box boundaries.
!   </IN>
!   <OUT NAME="ocean_frac" TYPE="real" DIM="(:,:)">
!     The fractional amount (0 to 1) of ocean in a grid box.
!     The size of this field must be size(blon)-1 by size(blat)-1.
!   </OUT>
!   <OUT NAME="get_ocean_frac" TYPE="logical">
!     A logical value of TRUE is returned if the output field
!     was successfully created. A value of FALSE may be returned
!     if the Navy 1/6 degree percent water data set was not readable.
!   </OUT>

 function get_ocean_frac_1d (blon, blat, ocean_frac)

 real, intent(in),  dimension(:)   :: blon, blat
 real, intent(out), dimension(:,:) :: ocean_frac
 logical :: get_ocean_frac_1d

!-----------------------------------------------------------------------
   if (.not. module_is_initialized) call topography_init()

   if ( any(shape(ocean_frac(:,:)) /= (/size(blon(:))-1,size(blat(:))-1/)) ) &
        call error_mesg('get_ocean_frac','shape(ocean_frac) is not&
                 & equal to (/size(blon)-1,size(blat)-1/))', FATAL)

   if ( open_topog_file(water_file) ) then
       call interp_water_1d ( blon, blat, ocean_frac, do_ocean=.true. )
       get_ocean_frac_1d = .true.
   else
       get_ocean_frac_1d = .false.
   endif

!-----------------------------------------------------------------------

 end function get_ocean_frac_1d

!#######################################################################

 function get_ocean_frac_2d (blon, blat, ocean_frac)

 real, intent(in),  dimension(:,:) :: blon, blat
 real, intent(out), dimension(:,:) :: ocean_frac
 logical :: get_ocean_frac_2d

!-----------------------------------------------------------------------
   if (.not. module_is_initialized) call topography_init()

   if ( any(shape(ocean_frac(:,:)) /= (/size(blon,1)-1,size(blon,2)-1/)) .or. &
        any(shape(ocean_frac(:,:)) /= (/size(blat,1)-1,size(blat,2)-1/)) ) &
        call error_mesg('get_ocean_frac_2d','shape(ocean_frac) is not&
            & equal to (/size(blon,1)-1,size(blon,2)-1/))', FATAL)

   if ( open_topog_file(water_file) ) then
       call interp_water_2d ( blon, blat, ocean_frac, do_ocean=.true. )
       get_ocean_frac_2d = .true.
   else
       get_ocean_frac_2d = .false.
   endif

!-----------------------------------------------------------------------

 end function get_ocean_frac_2d

! </FUNCTION>
!#######################################################################
! <FUNCTION NAME="get_ocean_mask">

!   <OVERVIEW>
!     Returns a land-ocean mask in a grid box.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Returns a land-ocean mask in the given model grid boxes.
!   </DESCRIPTION>
!   <TEMPLATE>
!     flag = <B>get_ocean_mask</B> ( blon, blat, ocean_mask )
!   </TEMPLATE>

!   <IN NAME="blon" UNITS="radians" TYPE="real" DIM="(:)">
!     The longitude (in radians) at grid box boundaries.
!   </IN>
!   <IN NAME="blat" UNITS="radians" TYPE="real" DIM="(:)">
!     The latitude (in radians) at grid box boundaries.
!   </IN>
!   <OUT NAME="ocean_frac" TYPE="real" DIM="(:,:)">
!     The fractional amount (0 to 1) of ocean in a grid box.
!     The size of this field must be size(blon)-1 by size(blat)-1.
!   </OUT>
!   <OUT NAME="get_ocean_mask" TYPE="logical">
!     A logical value of TRUE is returned if the output field
!     was successfully created. A value of FALSE may be returned
!     if the Navy 1/6 degree percent water data set was not readable.
!   </OUT>

 function get_ocean_mask_1d (blon, blat, ocean_mask)

 real   , intent(in),  dimension(:)   :: blon, blat
 logical, intent(out), dimension(:,:) :: ocean_mask
 logical :: get_ocean_mask_1d

 real, dimension(size(ocean_mask,1),size(ocean_mask,2)) :: ocean_frac
!-----------------------------------------------------------------------
   if (.not. module_is_initialized) call topography_init()

 if ( get_ocean_frac(blon, blat, ocean_frac) ) then
   where (ocean_frac > 0.50)
     ocean_mask = .true.
   elsewhere
     ocean_mask = .false.
   end where
   get_ocean_mask_1d = .true.
 else
   get_ocean_mask_1d = .false.
 endif

!-----------------------------------------------------------------------

 end function get_ocean_mask_1d

!#######################################################################

 function get_ocean_mask_2d (blon, blat, ocean_mask)

 real   , intent(in),  dimension(:,:) :: blon, blat
 logical, intent(out), dimension(:,:) :: ocean_mask
 logical :: get_ocean_mask_2d

 real, dimension(size(ocean_mask,1),size(ocean_mask,2)) :: ocean_frac
!-----------------------------------------------------------------------
   if (.not. module_is_initialized) call topography_init()

 if ( get_ocean_frac(blon, blat, ocean_frac) ) then
   where (ocean_frac > 0.50)
     ocean_mask = .true.
   elsewhere
     ocean_mask = .false.
   end where
   get_ocean_mask_2d = .true.
 else
   get_ocean_mask_2d = .false.
 endif

!-----------------------------------------------------------------------

 end function get_ocean_mask_2d

! </FUNCTION>
!#######################################################################
! <FUNCTION NAME="get_water_frac">

!   <OVERVIEW>
!     Returns fractional area covered by water.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Returns the percent of water in a grid box.
!   </DESCRIPTION>
!   <TEMPLATE>
!     flag = <B>get_water_frac</B> ( blon, blat, water_frac )
!   </TEMPLATE>

!   <IN NAME="blon" UNITS="radians" TYPE="real" DIM="(:)">
!     The longitude (in radians) at grid box boundaries.
!   </IN>
!   <IN NAME="blat" UNITS="radians" TYPE="real" DIM="(:)">
!     The latitude (in radians) at grid box boundaries.
!   </IN>
!   <OUT NAME="water_frac" TYPE="real" DIM="(:,:)">
!     The fractional amount (0 to 1) of water in a grid box.
!     The size of this field must be size(blon)-1 by size(blat)-1.
!   </OUT>
!   <OUT NAME="get_water_frac" TYPE="logical">
!     A logical value of TRUE is returned if the output field
!     was successfully created. A value of FALSE may be returned
!     if the Navy 1/6 degree percent water data set was not readable.
!   </OUT>
!   <ERROR MSG="shape(water_frac) is not equal to (/size(blon)-1,size(blat)-1/))" STATUS="FATAL">
!      Check the input grid size and output field size.
!   </ERROR>

 function get_water_frac_1d (blon, blat, water_frac)

 real, intent(in),  dimension(:)   :: blon, blat
 real, intent(out), dimension(:,:) :: water_frac
 logical :: get_water_frac_1d

!-----------------------------------------------------------------------
   if (.not. module_is_initialized) call topography_init()

   if ( any(shape(water_frac(:,:)) /= (/size(blon(:))-1,size(blat(:))-1/)) ) &
        call error_mesg('get_water_frac_1d','shape(water_frac) is not&
                 & equal to (/size(blon)-1,size(blat)-1/))', FATAL)

   if ( open_topog_file(water_file) ) then
       call interp_water_1d ( blon, blat, water_frac )
       get_water_frac_1d = .true.
   else
       get_water_frac_1d = .false.
   endif

!-----------------------------------------------------------------------

 end function get_water_frac_1d

!#######################################################################

 function get_water_frac_2d (blon, blat, water_frac)

 real, intent(in),  dimension(:,:) :: blon, blat
 real, intent(out), dimension(:,:) :: water_frac
 logical :: get_water_frac_2d

!-----------------------------------------------------------------------
   if (.not. module_is_initialized) call topography_init()

   if ( any(shape(water_frac(:,:)) /= (/size(blon,1)-1,size(blon,2)-1/)) .or. &
        any(shape(water_frac(:,:)) /= (/size(blat,1)-1,size(blat,2)-1/)) ) &
        call error_mesg('get_water_frac_2d','shape(water_frac) is not&
            & equal to (/size(blon,1)-1,size(blon,2)-1/))', FATAL)

   if ( open_topog_file(water_file) ) then
       call interp_water_2d ( blon, blat, water_frac )
       get_water_frac_2d = .true.
   else
       get_water_frac_2d = .false.
   endif

!-----------------------------------------------------------------------

 end function get_water_frac_2d

! </FUNCTION>
!#######################################################################
! <FUNCTION NAME="get_water_mask">

!   <OVERVIEW>
!     Returns a land-water mask in a grid box.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Returns a land-water mask in the given model grid boxes.
!   </DESCRIPTION>
!   <TEMPLATE>
!     flag = <B>get_water_mask</B> ( blon, blat, water_mask )
!   </TEMPLATE>

!   <IN NAME="blon" UNITS="radians" TYPE="real" DIM="(:)">
!     The longitude (in radians) at grid box boundaries.
!   </IN>
!   <IN NAME="blat" UNITS="radians" TYPE="real" DIM="(:)">
!     The latitude (in radians) at grid box boundaries.
!   </IN>
!   <OUT NAME="water_mask" TYPE="real" DIM="(:,:)">
!     A binary mask for water (true) or land (false).
!     The size of this field must be size(blon)-1 by size(blat)-1.
!   </OUT>
!   <OUT NAME="get_water_mask" TYPE="logical">
!     A logical value of TRUE is returned if the output field
!     was successfully created. A value of FALSE may be returned
!     if the Navy 1/6 degree percent water data set was not readable.
!   </OUT>

 function get_water_mask_1d (blon, blat, water_mask)

 real   , intent(in),  dimension(:)   :: blon, blat
 logical, intent(out), dimension(:,:) :: water_mask
 logical :: get_water_mask_1d

 real, dimension(size(water_mask,1),size(water_mask,2)) :: water_frac
!-----------------------------------------------------------------------
   if (.not. module_is_initialized) call topography_init()

 if ( get_water_frac(blon, blat, water_frac) ) then
   where (water_frac > 0.50)
     water_mask = .true.
   elsewhere
     water_mask = .false.
   end where
   get_water_mask_1d = .true.
 else
   get_water_mask_1d = .false.
 endif

!-----------------------------------------------------------------------

 end function get_water_mask_1d

!#######################################################################

 function get_water_mask_2d (blon, blat, water_mask)

 real   , intent(in),  dimension(:,:) :: blon, blat
 logical, intent(out), dimension(:,:) :: water_mask
 logical :: get_water_mask_2d

 real, dimension(size(water_mask,1),size(water_mask,2)) :: water_frac
!-----------------------------------------------------------------------
   if (.not. module_is_initialized) call topography_init()

 if ( get_water_frac(blon, blat, water_frac) ) then
   where (water_frac > 0.50)
     water_mask = .true.
   elsewhere
     water_mask = .false.
   end where
   get_water_mask_2d = .true.
 else
   get_water_mask_2d = .false.
 endif

!-----------------------------------------------------------------------

 end function get_water_mask_2d

! </FUNCTION>

!#######################################################################
!##################   private interfaces below here   ##################
!#######################################################################

 function open_topog_file ( filename )
 character(len=*), intent(in) :: filename
 logical :: open_topog_file
 real    :: r_ipts, r_jpts
 integer :: namelen

 namelen = len(trim(filename))
  if ( file_exist(filename) .AND. filename(namelen-2:namelen) == '.nc') then
     if (mpp_pe() == mpp_root_pe()) call mpp_error ('topography_mod', &
            'Reading NetCDF formatted input data file: '//filename, NOTE)
     call read_data(filename, 'ipts', r_ipts, no_domain=.true.)
     call read_data(filename, 'jpts', r_jpts, no_domain=.true.)
     ipts = nint(r_ipts)
     jpts = nint(r_jpts)
     open_topog_file = .true.
  else
     if ( file_exist(filename) ) then
        if (mpp_pe() == mpp_root_pe()) call mpp_error ('topography_mod', &
             'Reading native formatted input data file: '//filename, NOTE)
        unit = open_ieee32_file (trim(filename), 'read')
        read (unit) ipts, jpts
        open_topog_file = .true.
     else
        open_topog_file = .false.
     endif
  endif

 end function open_topog_file

!#######################################################################

 subroutine interp_topog_1d ( blon, blat, zout, flag )
 real   , intent(in)  :: blon(:), blat(:)
 real   , intent(out) :: zout(:,:)
 integer, intent(in), optional :: flag

 real :: xdat(ipts+1), ydat(jpts+1)
 real :: zdat(ipts,jpts)
 real :: zout2(size(zout,1),size(zout,2))

    call input_data ( topog_file, xdat, ydat, zdat )

    call horiz_interp ( zdat, xdat, ydat, blon, blat, zout )

! compute standard deviation if necessary
    if (present(flag)) then
       if (flag == COMPUTE_STDEV) then
           zdat = zdat*zdat
           call horiz_interp ( zdat, xdat, ydat, blon, blat, zout2 )
           zout = zout2 - zout*zout
           where (zout > 0.0)
             zout = sqrt ( zout )
           elsewhere
             zout = 0.0
           endwhere
       endif
    endif

 end subroutine interp_topog_1d

!#######################################################################

 subroutine interp_topog_2d ( blon, blat, zout, flag )
 real   , intent(in)  :: blon(:,:), blat(:,:)
 real   , intent(out) :: zout(:,:)
 integer, intent(in), optional :: flag

 real :: xdat(ipts+1), ydat(jpts+1)
 real :: zdat(ipts,jpts)
 real :: zout2(size(zout,1),size(zout,2))
 integer :: js, je
 type (horiz_interp_type) :: Interp

    call input_data ( topog_file, xdat, ydat, zdat )
    call find_indices ( minval(blat), maxval(blat), ydat, js, je )

    call horiz_interp_new ( Interp, xdat, ydat(js:je+1), blon, blat )
    call horiz_interp     ( Interp, zdat(:,js:je), zout )

! compute standard deviation if necessary
    if (present(flag)) then
       if (flag == COMPUTE_STDEV) then
           zdat = zdat*zdat
           call horiz_interp ( Interp, zdat(:,js:je), zout2 )
           zout = zout2 - zout*zout
           where (zout > 0.0)
             zout = sqrt ( zout )
           elsewhere
             zout = 0.0
           endwhere
       endif
    endif

    call horiz_interp_del ( Interp )

 end subroutine interp_topog_2d

!#######################################################################

 subroutine find_indices ( ybeg, yend, ydat, js, je )
 real,    intent(in)  :: ybeg, yend, ydat(:)
 integer, intent(out) :: js, je
 integer :: j

   js = 1
   do j = 1, size(ydat(:))-1
      if (ybeg >= ydat(j) .and. ybeg <= ydat(j+1)) then
         js = j
         exit
      endif
   enddo

   je = size(ydat(:))-1
   do j = js, size(ydat(:))-1
      if (yend >= ydat(j) .and. yend <= ydat(j+1)) then
         je = j
         exit
      endif
   enddo

   !print '(a,i2,2(a,f10.5),2(a,i4))', "PE=",mpp_pe(),"  phs=",ybeg,"  phn=",yend,"  js=",js,"  je=",je

 end subroutine find_indices

!#######################################################################

 subroutine input_data ( ifile, xdat, ydat, zdat )
 character(len=*), intent(in) :: ifile
 real, intent(out) :: xdat(ipts+1), ydat(jpts+1), zdat(ipts,jpts)
 integer :: nc

   nc = len_trim(ifile)

! note: ipts,jpts,unit are global

  if ( file_exist(trim(ifile)) .AND. ifile(nc-2:nc) == '.nc') then
     call read_data(trim(ifile), 'xdat', xdat, no_domain=.true.)
     call read_data(trim(ifile), 'ydat', ydat, no_domain=.true.)
     call read_data(trim(ifile), 'zdat', zdat, no_domain=.true.)
  else
    read (unit) xdat, ydat    ! read lon/lat edges in radians
    read (unit) zdat          ! read land surface height in meters
    call close_file (unit)
 endif

 end subroutine input_data

!#######################################################################

 subroutine interp_water_1d ( blon, blat, zout, do_ocean )
 real   , intent(in)  :: blon(:), blat(:)
 real   , intent(out) :: zout(:,:)
 logical, intent(in), optional :: do_ocean

 real :: xdat(ipts+1), ydat(jpts+1), zdat(ipts,jpts)

    call input_data ( water_file, xdat, ydat, zdat )

! only use designated ocean points
    if (present(do_ocean)) then
        if (do_ocean) call determine_ocean_points (zdat)
    endif

! interpolate onto output grid
    call horiz_interp ( zdat, xdat, ydat, blon, blat, zout )

 end subroutine interp_water_1d

!#######################################################################

 subroutine interp_water_2d ( blon, blat, zout, do_ocean )
 real   , intent(in)  :: blon(:,:), blat(:,:)
 real   , intent(out) :: zout(:,:)
 logical, intent(in), optional :: do_ocean

 real :: xdat(ipts+1), ydat(jpts+1), zdat(ipts,jpts)

    call input_data ( water_file, xdat, ydat, zdat )

! only use designated ocean points
    if (present(do_ocean)) then
        if (do_ocean) call determine_ocean_points (zdat)
    endif

! interpolate onto output grid
    call horiz_interp ( zdat, xdat, ydat, blon, blat, zout )

 end subroutine interp_water_2d

!#######################################################################

 subroutine determine_ocean_points ( pctwater )
 real, intent(inout) :: pctwater(:,:)
 logical :: ocean(size(pctwater,1),size(pctwater,2))
 integer :: i, j, m, n, im, ip, jm, jp, new 

 real :: ocean_pct_crit = .500

  ! resolution of the grid
    m = size(pctwater,1)
    n = size(pctwater,2)

  ! the 1/6 degree navy percent water data set
  ! designates ocean grid boxes as 100 percent water
  ! all other grid boxes have <= 99 percent water

  ! set a mask for ocean grid boxes
    ocean = (pctwater > .999) 
    new = count(ocean)

  ! set land grid boxes that have sufficient amount of water
  ! to ocean grid boxes when they are adjacent to ocean points
  ! iterate until there are no new ocean points
    do 
    if (new == 0) exit 
    new = 0 

       do j = 1, n
       do i = 1, m
          if (.not.ocean(i,j) .and. pctwater(i,j) > ocean_pct_crit) then
             im = i-1; ip = i+1; jm = j-1; jp = j+1
             if (im == 0)   im = m  
             if (ip == m+1) ip = 1
             if (jm == 0)   jm = 1
             if (jp == n+1) jp = n
           ! check the 8 grid boxes that surround this grid box
             if (ocean(im,j ) .or. ocean(ip,j ) .or. ocean(i ,jm) .or. ocean(i ,jp) .or. &
                 ocean(im,jm) .or. ocean(ip,jm) .or. ocean(ip,jp) .or. ocean(im,jp)) then
                 ocean(i,j) = .true.
                 new = new + 1
             endif
          endif
       enddo
       enddo
      !print *, 'new=',new

    enddo

  ! final step is to elimate water percentage if land
    where (.not.ocean) pctwater = 0.

 end subroutine determine_ocean_points

!#######################################################################
! reads the namelist file, write namelist to log file, 
! and initializes constants

subroutine read_namelist

   integer :: unit, ierr, io

!  read namelist

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, topography_nml, iostat=io)
      ierr = check_nml_error(io,'topography_nml')
#else
   if ( file_exist('input.nml')) then
      unit = open_namelist_file ( )
      ierr=1; do while (ierr /= 0)
         read  (unit, nml=topography_nml, iostat=io, end=10)
         ierr = check_nml_error(io,'topography_nml')
      enddo
 10   call close_file (unit)
   endif
#endif

!  write version and namelist to log file

   if (mpp_pe() == mpp_root_pe()) then
     unit = stdlog()
     write (unit, nml=topography_nml)
   endif

end subroutine read_namelist

!#######################################################################

end module topography_mod

! <INFO>

!   <TESTPROGRAM NAME="">  
!  
!  To run this program you will need the topography and percent water
!  data sets and use the following namelist (in file input.nml).
!  
!   &amp;gaussian_topog_nml
!     height = 5000., 3000., 3000., 3000.,
!     olon   =   90.,  255.,  285.,    0.,
!     olat   =   45.,   45.,  -15.,  -90.,
!     wlon   =   15.,   10.,    5.,  180.,
!     wlat   =   15.,   25.,   25.,   20., /
!  
!  program test
!  
!  ! test program for topography and gaussian_topog modules
!  <PRE>  
!  use topography_mod
!  implicit none
!  
!  integer, parameter :: nlon=24, nlat=18
!  real :: x(nlon), y(nlat), xb(nlon+1), yb(nlat+1), z(nlon,nlat)
!  real :: hpi, rtd
!  integer :: i,j
!  logical :: a
!  
!  ! gaussian mountain parameters
!  real, parameter :: ht=4000.
!  real, parameter :: x0=90., y0=45. ! origin in degrees
!  real, parameter :: xw=15., yw=15. ! half-width in degees
!  real, parameter :: xr=30., yr= 0. ! ridge-width in degrees
!  
!  ! create lat/lon grid in radians
!    hpi = acos(0.0)
!    rtd = 90./hpi ! rad to deg
!    do i=1,nlon
!      xb(i) = 4.*hpi*real(i-1)/real(nlon)
!    enddo
!      xb(nlon+1) = xb(1)+4.*hpi
!      yb(1) = -hpi
!    do j=2,nlat
!      yb(j) = yb(j-1) + 2.*hpi/real(nlat)
!    enddo
!      yb(nlat+1) = hpi
!  ! mid-point of grid boxes
!    x(1:nlon) = 0.5*(xb(1:nlon)+xb(2:nlon+1))
!    y(1:nlat) = 0.5*(yb(1:nlat)+yb(2:nlat+1))
!  ! test topography_mod routines
!    a = get_topog_mean(xb,yb,z)
!    call printz ('get_topog_mean')
!  
!    a = get_water_frac(xb,yb,z)
!    z = z*100. ! in percent
!    call printz ('get_water_frac')
!  
!    a = get_ocean_frac(xb,yb,z)
!    z = z*100. ! in percent
!    call printz ('get_ocean_frac')
!  
!  ! test gaussian_topog_mod routines
!    a = .true.
!    z = get_gaussian_topog(x,y,ht,x0,y0,xw,yw,xr,yr)
!    call printz ('get_gaussian_topog')
!  
!    call gaussian_topog_init (x,y,z)
!    call printz ('gaussian_topog_init')
!  
!  contains
!  
!  ! simple printout of topog/water array
!    subroutine printz (lab)
!    character(len=*), intent(in) :: lab
!     if (a) then
!        print '(/a)', trim(lab)
!     else
!        print '(/a)', 'no data available: '//trim(lab)
!        return
!     endif
!      ! print full grid
!        print '(3x,25i5)', (nint(x(i)*rtd),i=1,nlon)
!      do j=nlat,1,-1
!        print '(i3,25i5)', nint(y(j)*rtd), (nint(z(i,j)),i=1,nlon)
!      enddo
!    end subroutine printz
!  
!  end program test
!   </PRE>
!   </TESTPROGRAM>

!   <BUG>                  
!      Water mask produces some possible erroneous water points along
!      the coast of Antarctic (at about 90W).
!   </BUG>

!   <FUTURE>Use of netcdf data sets. </FUTURE>
!   <FUTURE>Incorporate other topography and ocean data sets. </FUTURE>
! 
! </INFO>

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: llnl_stats.F90,v 20.0 2013/12/13 23:16:06 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) 2008, Lawrence Livermore National Security Limited Liability Corporation.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list 
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Lawrence Livermore National Security Limited Liability Corporation 
!       nor the names of its contributors may be used to endorse or promote products derived from 
!       this software without specific prior written permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

MODULE MOD_LLNL_STATS
  USE MOD_COSP_CONSTANTS
  IMPLICIT NONE

CONTAINS

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!-------------------- FUNCTION COSP_CFAD ------------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
FUNCTION COSP_CFAD(Npoints,Ncolumns,Nlevels,Nbins,x,xmin,xmax,bmin,bwidth)
   ! Input arguments
   integer,intent(in) :: Npoints,Ncolumns,Nlevels,Nbins
   real,dimension(Npoints,Ncolumns,Nlevels),intent(in) :: x
   real,intent(in) :: xmin,xmax 
   real,intent(in) :: bmin,bwidth
   
   real,dimension(Npoints,Nbins,Nlevels) :: cosp_cfad
   ! Local variables
   integer :: i, j, k
   integer :: ibin
   
   !--- Input arguments
   ! Npoints: Number of horizontal points
   ! Ncolumns: Number of subcolumns
   ! Nlevels: Number of levels
   ! Nbins: Number of x axis bins
   ! x: variable to process (Npoints,Ncolumns,Nlevels)
   ! xmin: minimum value allowed for x
   ! xmax: minimum value allowed for x
   ! bmin: mimumum value of first bin
   ! bwidth: bin width
   !
   ! Output: 2D histogram on each horizontal point (Npoints,Nbins,Nlevels)
   
   cosp_cfad = 0.0
   ! bwidth intervals in the range [bmin,bmax=bmin+Nbins*hwidth]
   ! Valid x values smaller than bmin and larger than bmax are set 
   ! into the smallest bin and largest bin, respectively.
   do j = 1, Nlevels, 1
      do k = 1, Ncolumns, 1
         do i = 1, Npoints, 1
            if (x(i,k,j) == R_GROUND) then
               cosp_cfad(i,:,j) = R_UNDEF
            elseif ((x(i,k,j) >= xmin) .and. (x(i,k,j) <= xmax)) then 
               ibin = ceiling((x(i,k,j) - bmin)/bwidth)
               if (ibin > Nbins) ibin = Nbins
               if (ibin < 1)     ibin = 1
               cosp_cfad(i,ibin,j) = cosp_cfad(i,ibin,j) + 1.0 
            end if
         enddo  !i
      enddo  !k
   enddo  !j
   where ((cosp_cfad /= R_UNDEF).and.(cosp_cfad /= 0.0)) cosp_cfad = cosp_cfad / Ncolumns
END FUNCTION COSP_CFAD

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------- SUBROUTINE COSP_LIDAR_ONLY_CLOUD -----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_LIDAR_ONLY_CLOUD(Npoints,Ncolumns,Nlevels,beta_tot,beta_mol,Ze_tot,lidar_only_freq_cloud,tcc)
   ! Input arguments
   integer,intent(in) :: Npoints,Ncolumns,Nlevels
   real,dimension(Npoints,Nlevels),intent(in) :: beta_mol   ! Molecular backscatter
   real,dimension(Npoints,Ncolumns,Nlevels),intent(in) :: beta_tot   ! Total backscattered signal
   real,dimension(Npoints,Ncolumns,Nlevels),intent(in) :: Ze_tot     ! Radar reflectivity
   ! Output arguments
   real,dimension(Npoints,Nlevels),intent(out) :: lidar_only_freq_cloud
   real,dimension(Npoints),intent(out) :: tcc
   
   ! local variables
   real :: sc_ratio
   real :: s_cld, s_att
!      parameter (S_cld = 3.0)  ! Previous thresold for cloud detection
   parameter (S_cld = 5.0)  ! New (dec 2008) thresold for cloud detection
   parameter (s_att = 0.01)
   integer :: flag_sat !first saturated level encountered from top
   integer :: flag_cld !cloudy column
   integer :: pr,i,j
   
   lidar_only_freq_cloud = 0.0
   tcc = 0.0
   do pr=1,Npoints
     do i=1,Ncolumns
       flag_sat = 0
       flag_cld = 0
       do j=Nlevels,1,-1 !top->surf
        sc_ratio = beta_tot(pr,i,j)/beta_mol(pr,j)
!         if ((pr == 1).and.(j==8)) print *, pr,i,j,sc_ratio,Ze_tot(pr,i,j)
        if ((sc_ratio .le. s_att) .and. (flag_sat .eq. 0)) flag_sat = j
        if (Ze_tot(pr,i,j) .lt. -30.) then  !radar can't detect cloud
         if ( (sc_ratio .gt. s_cld) .or. (flag_sat .eq. j) ) then  !lidar sense cloud
!             if ((pr == 1).and.(j==8)) print *, 'L'
            lidar_only_freq_cloud(pr,j)=lidar_only_freq_cloud(pr,j)+1. !top->surf
            flag_cld=1
         endif
        else  !radar sense cloud (z%Ze_tot(pr,i,j) .ge. -30.)
!            if ((pr == 1).and.(j==8)) print *, 'R'
           flag_cld=1
        endif
       enddo !levels
       if (flag_cld .eq. 1) tcc(pr)=tcc(pr)+1.
     enddo !columns
!      if (tcc(pr) > Ncolumns) then
!      print *, 'tcc(',pr,'): ', tcc(pr)
!      tcc(pr) = Ncolumns
!      endif
   enddo !points
   lidar_only_freq_cloud=lidar_only_freq_cloud/Ncolumns
   tcc=tcc/Ncolumns

END SUBROUTINE COSP_LIDAR_ONLY_CLOUD
END MODULE MOD_LLNL_STATS

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! rot_mod - rotates a spherical coordinate system, from M. Eby via MOM         !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
module rot_mod

  use mpp_mod,        only: stdout
  use axis_utils_mod, only: nearest_index

  implicit none
  private
  public rot_intrp_sclr, rot_intrp_vctr, rotate, psir, thetar, phir
  ! rotation angles set in ice_grid

  real               :: psir = 0.0, thetar = 0.0, phir = 0.0

  integer            :: warns  = 0 ! > 0 allows #warns warnings from interpolator


contains

  subroutine rot_intrp_vctr (g, xg, yg, ig, jg, r, xr, yr, ir, jr, &
       psir, thetar, phir)
    !
    !=======================================================================
    !     interpolate vector data from an geographic data grid to a
    !     rotated model grid
    !
    !     input
    !     psir, thetar, phir = Euler angles defining rotation
    !     g  = vector on geographic data grid
    !     xg = longitude of data points on geographic data grid
    !     yg = latitude of data points on geographic data grid
    !     ig = number of longitudes in geographic data grid 
    !     jg = number of latitudes in geographic data grid 
    !     xr = longitude of points on rotated model grid
    !     yr = latitude of points on rotated model grid
    !     ir = number of longitudes in rotated model grid 
    !     jr = number of latitudes in rotated model grid 
    !
    !     output
    !     r  = vector on rotated model grid
    !
    !     internal
    !     (rln,rlt) = (longitude,latitude) in rotated coordinates
    !     (gln,glt) = (longitude,latitude) in geographic coordinates
    !     xg(iw) = point on the geographic grid to the west of (gln,glt)
    !     xg(ie) = point on the geographic grid to the east of (gln,glt)
    !     yg(js) = point on the geographic grid to the south of (gln,glt)
    !     yg(jn) = point on the geographic grid to the north of (gln,glt)
    !
    !=======================================================================
    !
  integer                  :: ig, jg, ir, jr
  real, dimension(ig,jg,2) ::  g
  real, dimension(ig     ) :: xg
  real, dimension(   jg  ) :: yg
    real, dimension(ir,jr,2) ::  r
  real, dimension(ir     ) :: xr
  real, dimension(   jr  ) :: yr
  real                     :: psir, thetar, phir

    integer                  :: i, j
    real                     :: rad, a, angle, vmag, glt, gln, rlt, rln
    !
    rad = acos(-1.)/180.
    !
    ! interpolate vector components as scalers on rotated model grid 
    !
    call rot_intrp_sclr (g(1,1,1), xg, yg, ig, jg, r(1,1,1), xr, yr, ir, jr, &
         psir, thetar, phir)
    call rot_intrp_sclr (g(1,1,2), xg, yg, ig, jg, r(1,1,2), xr, yr, ir, jr, &
         psir, thetar, phir)
    !
    ! correct vector direction
    !
    do j=1,jr
       do i=1,ir
          vmag = sqrt(r(i,j,1)**2 + r(i,j,2)**2)
          if (vmag .gt. 0.) then 
             a = r(i,j,1)/vmag
             a = min(a, 1.)
             a = max(a, -1.)
             a = acos(a)
             if (r(i,j,2) .lt. 0.) a = -a
             call rotate (yr(j), xr(i), -psir, -thetar, -phir, glt, gln)
             call rotvec(glt, gln, phir, thetar, psir, angle)
             a = a + angle*rad
             r(i,j,1) = vmag*cos(a)
             r(i,j,2) = vmag*sin(a)
          else
             r(i,j,1) = 0.
             r(i,j,2) = 0.
          endif
       enddo
    enddo
    !
    return
  end subroutine rot_intrp_vctr


  subroutine rot_intrp_sclr (g, xg, yg, ig, jg, r, xr, yr, &
       ir, jr, psir, thetar, phir    )
    !
    !=======================================================================
    !     interpolate scaler data from an geographic data grid to a 
    !     rotated model grid
    !
    !     input
    !     psir, thetar, phir = Euler angles defining rotation
    !     g  = scaler on geographic data grid
    !     xg = longitude of data points on geographic data grid
    !     yg = latitude of data points on geographic data grid
    !     ig = number of longitudes in on geographic data grid 
    !     jg = number of latitudes in on geographic data grid 
    !     xr = longitude of points on rotated model grid
    !     yr = latitude of points on rotated model grid
    !     ir = number of longitudes in rotated model grid 
    !     jr = number of latitudes in rotated model grid 
    !
    !     output
    !     r  = scaler on rotated model grid
    !
    !     internal
    !     (rln,rlt) = (longitude,latitude) in rotated coordinates
    !     (gln,glt) = (longitude,latitude) in geographic coordinates
    !     xg(iw) = point on the geographic grid to the west of (gln,glt)
    !     xg(ie) = point on the geographic grid to the east of (gln,glt)
    !     yg(js) = point on the geographic grid to the south of (gln,glt)
    !     yg(jn) = point on the geographic grid to the north of (gln,glt)
    !
    !=======================================================================
    !
    integer                :: ig, jg, ir, jr, outunit
    real                   :: psir, thetar, phir
    real, dimension(ig,jg) :: g
    real, dimension(ig   ) :: xg
    real, dimension(   jg) :: yg
    real, dimension(ir,jr) :: r
    real, dimension(ir   ) :: xr
    real, dimension(   jr) :: yr

    real    :: rln, rlt, gln, glt
    integer :: i, j, iw, ie, js, jn, istrt, jstrt, iend, jend, ln_err, lt_err
    real    :: epsln, glt_min, glt_max, gln_min, gln_max, del, wtw, wte, wts, wtn
    !
    epsln = 1.e-10
    glt_min = 90.
    glt_max = -90.
    gln_min = 360.
    gln_max = -360.
    ln_err = 0
    lt_err = 0
    !
    !     find longitude points of data within interval [0., 360.]
    istrt = 1
    do i=2,ig
       if (xg(i-1) .lt. 0. .and. xg(i) .ge. 0.) istrt = i
    enddo
    iend = ig
    do i=2,ig
       if (xg(i-1) .lt. 360. .and. xg(i) .ge. 360.) iend = i
    enddo
    !
    !     find latitude points of data within interval [-90., 90.]
    jstrt = 1
    do j=2,jg
       if (yg(j-1) .lt. -90. .and. yg(j) .ge. -90.) jstrt = j
    enddo
    jend = jg
    do j=2,jg
       if (yg(j-1) .lt. 90. .and. yg(j) .ge. 90.) jend = j
    enddo
    !
    !     interpolate data to model grid 
    !
    do j=1,jr
       do i=1,ir
          call rotate (yr(j), xr(i), -psir, -thetar, -phir, glt, gln)
          if (gln .lt. 0.) gln = gln + 360.
          if (gln .ge. 360.) gln = gln - 360.
          glt_min = min(glt,glt_min)
          glt_max = max(glt,glt_max)
          gln_min = min(gln,gln_min)
          gln_max = max(gln,gln_max)
          !
          iw = nearest_index (gln, xg(istrt:iend) ) + istrt - 1
          if (xg(iw) .gt. gln) iw = iw - 1
          ie = iw + 1
          if (iw .ge. istrt .and. ie .le. iend) then
             del = xg(ie) - xg(iw)
             wtw = (xg(ie) - gln)/del
          else
             !     east or west of the last data value. this could be because a
             !     cyclic condition is needed or the dataset is too small. in either 
             !     case apply a cyclic condition
             ln_err = 1
             iw = iend
             ie = istrt
             del = xg(ie) + 360. + epsln - xg(iw) 
             if (xg(ie) .ge. gln) then
                wtw = (xg(ie) - gln)/del
             else
                wtw = (xg(ie) + 360. + epsln - gln)/del
             endif
          endif
          wte = 1. - wtw
          !
          js = nearest_index (glt, yg(jstrt:jend) ) + jstrt - 1
          if (yg(js) .gt. glt) js = max(js - 1,jstrt)
          jn = min(js + 1,jend)
          if (yg(jn) .ne. yg(js) .and. yg(js) .le. glt) then
             wts = (yg(jn) - glt)/(yg(jn) - yg(js))
          else
             !     north or south of the last data value. this could be because a
             !     pole is not included in the data set or the dataset is too small.
             !     in either case extrapolate north or south
             lt_err = 1
             wts = 1.
          endif
          wtn = 1. - wts
          !
          r(i,j) = g(ie,jn)*wte*wtn + g(ie,js)*wte*wts &
               + g(iw,jn)*wtw*wtn + g(iw,js)*wtw*wts
          !
       enddo
    enddo
    !
    outunit = stdout()
    if (ln_err .eq. 1 .and. warns > 0) then
       write (outunit,'(/,(1x,a))')                                      &
            '==> Warning: the geographic data set does not extend far   ', &
            '             enough east or west - a cyclic boundary       ', &
            '             condition was applied. check if appropriate   '
       write (outunit,'(/,(1x,a,2f8.2))')                                &
            '    data required between longitudes:', gln_min, gln_max,     &
            '      data set is between longitudes:', xg(istrt), xg(iend)
       warns = warns - 1
    endif
    !
    if (lt_err .eq. 1 .and. warns > 0) then
       write (outunit,'(/,(1x,a))')                                     &
            '==> Warning: the geographic data set does not extend far   ',&
            '             enough north or south - extrapolation from    ',&
            '             the nearest data was applied. this may create ',&
            '             artificial gradients near a geographic pole   ' 
       write (outunit,'(/,(1x,a,2f8.2))')                             &
            '    data required between latitudes:', glt_min, glt_max,   &
            '      data set is between latitudes:', yg(jstrt), yg(jend)
       warns = warns - 1
    endif
    !
    return
  end subroutine rot_intrp_sclr


  subroutine rotate (glt, gln, phir, thetar, psir, rlt, rln)
    real :: glt, gln, phir, thetar, psir, rlt, rln
    !
    !=======================================================================
    !     subroutine rotate takes a geographic latitude and longitude and 
    !     finds the the equivalent latitude and longitude on a rotated grid.
    !     when going from a geographic grid to a rotated grid, all of the 
    !     defined rotation angles given to rotate by the calling program 
    !     are positive, but when going from a rotated grid back to the 
    !     geographic grid, the calling program must reverse the angle order 
    !     (phir and psir are switched) and all of the angles made negative.
    !
    !     the first rotation angle phir is defined as a rotation about the
    !     original z axis. the second rotation angle thetar is defined as a
    !     rotation about the new x axis. the final rotation angle psir is
    !     defined as a rotation about the new z axis. these rotation angles
    !     are just the Euler angles as defined in "classical mechanics"
    !     Goldstein (1951).
    !
    !     author:   M. Eby            e-mail eby@uvic.ca
    !=======================================================================
    !
    !     g...  = geographic value
    !     r...  = rotated value
    !     ...lt = latitude (or equivalent spherical coordinate)
    !     ...ln = longitude (or equivalent spherical coordinate)
    !     ...x  = x coordinate
    !     ...y  = y coordinate
    !     ...z  = z coordinate
    !     psir, thetar, phir = Euler angles defining rotation
    !
    real rad, gx, gy, gz, phis, thetas, rx, ry, rz
    !     define rad for conversion to radians.
    rad = acos(-1.)/180.
    !
    !     convert latitude and longitude to spherical coordinates
    thetas = gln
    if (thetas .gt. 180.) thetas = thetas - 360.
    if (thetas .lt. -180.) thetas = thetas + 360.
    phis = (90. - glt)*rad
    thetas = thetas*rad
    !
    !     translate point into Cartesian coordinates for rotation.
    gx = sin(phis)*cos(thetas)
    gy = sin(phis)*sin(thetas)
    gz = cos(phis)
    !
    !     rotate the point (gx, gy, gz) about the z axis by phir then the x
    !     axis by thetar and finally about the z axis by psir.
    ! 
    rx = gx*(cos(psir)*cos(phir) - cos(thetar)*sin(phir)*sin(psir)) + &
         gy*(cos(psir)*sin(phir) + cos(thetar)*cos(phir)*sin(psir)) + &
         gz*sin(psir)*sin(thetar)
    !
    ry = gx*(-sin(psir)*cos(phir) - cos(thetar)*sin(phir)*cos(psir)) + &
         gy*(-sin(psir)*sin(phir) + cos(thetar)*cos(phir)*cos(psir)) + &
         gz*(cos(psir)*sin(thetar))
    !
    rz = gx*(sin(thetar)*sin(phir)) + gy*(-sin(thetar)*cos(phir)) +  &
         gz*(cos(thetar))
    !
    !     convert rotated point back to spherical coordinates
    !
    !     check for rounding error (arccos(x): abs(x) must be .le. 1)
    rz = min(rz, 1.)
    rz = max(rz, -1.)
    rlt = acos(rz)
    !     if point is at a pole set rotated longitude equal to initial.
    if (rlt .le. 0. .or. rlt .ge. 180.*rad) then
       rln = thetas
    else
       !     if rln lies between -135 and -45 or between 45 and 135 degrees
       !     it is more accurate to use an arccos calculation.
       if (abs(rx/sin(rlt)) .lt. cos(45.*rad)) then
          rln = rx/sin(rlt)
          !     check for rounding error (arccos(x): abs(x) must be .le. 1)
          rln = min(rln, 1.)
          rln = max(rln, -1.)
          rln = acos(rln)
          !     arccos will give rln between 0 and 180 degrees.  if the point
          !     is negative in y, rln must be equal to negative rln.
          if (ry .lt. 0.) rln = -rln
       else
          !     if rln lies between -45 and 45 or between 135 and -135 degrees
          !     it is more accurate to use an arcsin calculation.
          rln = ry/sin(rlt)
          !     check for rounding error (arcsin(x): abs(x) must be .le. 1)
          rln = min(rln, 1.)
          rln = max(rln, -1.)
          rln = asin(rln)
          !     arcsin will give rln between -90 and 90 degrees. if the point
          !     is negative in x, rln must be equal to 180 degrees minus rln.
          if (rx .lt. 0.) rln = 180.*rad - rln
       endif
    endif
    !
    !     convert back to degrees of latitude and longitude.
    rlt = 90. - rlt/rad
    rln = rln/rad
    if (rln .gt. 180.) rln = rln - 360.
    if (rln .le. -180.) rln = rln + 360.
    !
    return
  end subroutine rotate

  subroutine rotvec (glt, gln, phir, thetar, psir, angle)
    real :: glt, gln, phir, thetar, psir, angle

    real rad, delta, rlt, rln, rlth, rlnh, glth, glnh, dst, t
    !
    !=======================================================================
    !     subroutine rotvec takes a geographic latitude and longitude and 
    !     finds the the vector rotation angle angle (in degrees) for a 
    !     vector on the rotated grid. when going from the geographic to a 
    !     rotated grid, all of the defined rotation angles given to rotvec 
    !     by the calling program are positive, but when going from a 
    !     rotated grid back to the geographic grid, the calling program 
    !     must reverse the angle order (phir and psir are switched) and all 
    !     of the angles made negative. if a pole is detected then an angle 
    !     of zero is returned.
    !
    !     rotvec rotates the point defining the head of a very short north
    !     or south pointing geographic vector. the angle between this 
    !     vector and a similar direction vector defined in the new grid is 
    !     calculated using the law of cosines. the accuracy of this 
    !     calculation depends on the size of the direction vector (delta) 
    !     and the precision of the computation. the smaller the vector the 
    !     more accurate the calculation but then the more precision 
    !     required. double precision is strongly recommended.
    !
    !     author:   M. Eby            e-mail eby@uvic.ca
    !=======================================================================
    !
    ! include "stdunits.h"
    !     if gx and gy are vector components at glt and gln, the corrected 
    !     vector components rx and ry at rlt and rln can be calculated as 
    !     follows:
    !
    !  rad = acos(-1.)/180.
    !  call rotate (rlt, rln, -psir, -thetar, -phir, glt, gln)
    !  call get_vector (glt, gln, gx, gy)   ! some routine to get vector
    !  r = sqrt(gx**2 + gy**2)
    !  if (r .gt. 0.) then 
    !    a = gx/r
    !    a = min(a, 1.)
    !    a = max(a, -1.)
    !    a = acos(a)
    !    if (gy .lt. 0.) a = -a
    !    call rotvec(glt, gln, phir, thetar, psir, angle)
    !    a = a + angle*rad
    !    rx = r*cos(a)
    !    ry = r*sin(a)
    !  endif
    !
    ! g...   = geographic value
    ! r...   = rotated value
    ! ...lt  = latitude
    ! ...ln  = longitude
    ! ...lth = latitude of head of vector
    ! ...lnh = longitude of head of vector
    ! dst    = distance between heads of vectors
    ! delta  = length of vector
    ! angle  = angle to rotate vectors back to original orientation
    ! psir, thetar, phir = Euler angles defining rotation
    !
    ! define multiplier rad for conversion to radians.
    rad = acos(-1.)/180.
    !
    ! define length of direction vector (single precision may require a 
    ! longer and thus less accurate vector length).
    delta = 0.001
    !
    ! if the base is in the north of the geographic grid use a south 
    ! pointing vector to avoid any possibility of going over the pole.
    if (glt .ge. 0.) delta = -delta
    !
    ! find the base of the direction vectors in the rotated grid.
    call rotate (glt, gln, phir, thetar, psir, rlt, rln)
    !
    ! if base in the rotated grid is near a pole return an angle of zero
    if (abs(rlt) .ge. 90.-abs(delta)) then
       angle = 0.
       return
    endif
    !
    ! find the head of the geographic grid direction vector in the 
    ! rotated grid.
    call rotate (glt+delta, gln, phir, thetar, psir, glth, glnh)
    !
    ! if the base is in opposite hemispheres switch the vector
    ! direction for better accuracy.
    if (glt*rlt .lt. 0) delta = -delta
    !
    ! find the head of the rotated grid direction vector.
    rlth = rlt + delta
    rlnh = rln
    !
    ! find the distance between the heads of the direction vectors.
    call dist (glth, glnh, rlth, rlnh, dst)
    !
    ! find the angle between direction vectors with the law of cosines.
    delta = abs(delta)
    angle = (cos(dst)-cos(delta)**2)/(sin(delta)**2)
    angle = min(angle, 1.)
    angle = max(angle, -1.)
    angle = acos(angle)/rad
    t = abs(delta)
    !
    ! adjust the angle if the direction vectors are opposite.
    if (glt*rlt .lt. 0) angle = 180. - angle
    ! determine the sign of the angle by checking the offset longitudes.
    if (glnh+360. .gt. rlnh+360.) angle = -angle
    ! change sign if the original direction vector was pointing south.
    if (glt .ge. 0.) angle = -angle
    !
    return
  end subroutine rotvec


  subroutine dist (lat1, lng1, lat2, lng2, dst)
    !
    !=======================================================================
    !     subroutine dist calculates the arc distance between two 
    !     points given their latitudes and longitudes
    !=======================================================================
    !
    real lat1, lng1, lat2, lng2, dst, rad
    !
    !     define multiplier rad for conversion to radians.
    rad = acos(-1.)/180.
    !
    !     check input.
    lat1 = min(lat1, 90.)
    lat1 = max(lat1, -90.)
    if (lng1 .lt. 0.) lng1 = lng1 + 360.
    if (lng1 .gt. 360.) lng1 = lng1 - 360.
    lat2 = min(lat2, 90.)
    lat2 = max(lat2, -90.)
    if (lng2 .lt. 0.) lng2 = lng2 + 360.
    if (lng2 .gt. 360.) lng2 = lng2 - 360.
    !
    dst = sin(lat1*rad)*sin(lat2*rad)+cos(lat1*rad) &
         *cos(lat2*rad)*cos((lng1-lng2)*rad)
    dst = min(dst, 1.)
    dst = max(dst, -1.)
    dst = (acos(dst)/rad)
    return
  end subroutine dist

end module rot_mod

! The include file fms_platform.h will handle the conversion of POINTER to ALLOCATABLE arrays
! for derived type members. The conversion affects performance only and should not change 
! any numeric result. It is limited to member arrays that are used within MOM only
! and to arrays that are never associated (=>) with another array.

! Fortran 90 requires array members of derived type to have the POINTER attribute. 
! However, most Fortran 95 compilers now also support ALLOCATABLE array components 
! (a Fortran 2003 feature). This avoids the aliasing problem afflicting pointers. 
! Some compilers may require an additional switch (e.g. -fno-alias) to fully exploit
! the performance benefit of the conversion.
!
! Macros used from fms_platform.h:
! _ALLOCATABLE maps to either POINTER  or ALLOCATABLE
! _NULL        maps to either =>NULL() or "nothing"
#include <fms_platform.h>

module ocean_types_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Matt Harrison
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
! S. M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! This module contains type declarations and default values for ocean model.
!</OVERVIEW>
!
!<DESCRIPTION>
! This module contains type declarations and default values for ocean model.
! Multiple model realizations need to be distinguished by
! an ensemble_id for use by the diag_manager.
!</DESCRIPTION>
!
  use coupler_types_mod,only: coupler_2d_bc_type
  use field_manager_mod,only: fm_field_name_len, fm_string_len
  use fms_mod,          only: write_version_number
  use mpp_domains_mod,  only: domain2d
  use mpp_mod,          only: FATAL, mpp_error
  use time_manager_mod, only: time_type

  implicit none

  private

  logical :: module_is_initialized=.false.
  character(len=128) :: version = &
     '$Id: ocean_types.F90,v 20.0 2013/12/14 00:12:37 fms Exp $'
  character (len=128) :: tagname = &
     '$Name: tikal $'


  type, public :: obc_flux
     real, _ALLOCATABLE, dimension(:,:) :: flux  _NULL   ! flux through a boundary 
  end type obc_flux

  type, public :: ocean_time_steps_type
     character(len=32)  :: time_tendency      ! either "twolevel" or "threelevel" 
     character(len=32)  :: barotropic_scheme  ! for diagnostic printout 
     integer :: tendency ! either "TWO_LEVEL" or "THREE_LEVEL"
     real    :: aidif    ! aidif=1.0 for fully implicit vertical mixing and 0.0 for fully explicit
     real    :: acor     ! acor=0.0 for explicit Coriolis, 0.5 <= acor <= 1.0 for semi-implicit
     real    :: dtts     ! tracer timestep (seconds)
     real    :: dtuv     ! internal mode timestep (seconds)
     real    :: dtbt     ! barotropic timestep (seconds)
     real    :: dteta    ! ocean volume time step (eta_t) (seconds)
     real    :: dtime_t  ! 2*dtts  if threelevel, 1*dtts  if twolevel
     real    :: dtime_u  ! 2*dtuv  if threelevel, 1*dtuv  if twolevel
     real    :: dtime_e  ! 2*dteta if threelevel, 1*dteta if twolevel
     real    :: robert_asselin_param ! parameter used for time filtering with leap-frog scheme 
  end type ocean_time_steps_type

  type, public :: ocean_options_type
     integer            :: vertmix
     character(len=128) :: vert_mix
     character(len=72)  :: tidal_wave_mix
     character(len=72)  :: tidal_drag_mix
     character(len=128) :: leewave_mix
     character(len=72)  :: bryan_lewis_mix
     character(len=72)  :: hwf_mix
     character(len=72)  :: tanh_diff_cbt
     character(len=72)  :: read_diff_cbt
     character(len=72)  :: j09_diff_cbt
     character(len=72)  :: horz_bih_tracer
     character(len=72)  :: horz_lap_tracer
     character(len=72)  :: horz_lap_friction
     character(len=72)  :: horz_bih_friction
     character(len=128) :: coriolis
     character(len=72)  :: momentum_source
     character(len=72)  :: form_drag
     character(len=128) :: bottom_roughness
     character(len=72)  :: bmf_implicit
     character(len=72)  :: geothermal_heating
     character(len=72)  :: OBC
     character(len=72)  :: override_velocity
     character(len=72)  :: baroclinic_tendency
     character(len=72)  :: barotropic_tendency
     character(len=72)  :: tracer_tendency
     character(len=72)  :: equation_of_state
     character(len=72)  :: temperature_variable
     character(len=128) :: frazil_ice
     character(len=72)  :: convective_adjustment
     character(len=72)  :: neutral_physics
     character(len=72)  :: neutral_physics_new
     character(len=72)  :: submesoscale
     character(len=72)  :: sigma_transport
     character(len=72)  :: lagrangian_blobs
     character(len=128) :: overexchange
     character(len=72)  :: mixdownslope
     character(len=72)  :: overflow
     character(len=72)  :: overflow_OFP
     character(len=72)  :: shortwave
     character(len=72)  :: xlandmix
     character(len=128) :: xlandinsert
     character(len=72)  :: rivermix 
     character(len=72)  :: riverspread
     character(len=72)  :: passive_tracers
     character(len=72)  :: ocean_sponges_eta
     character(len=72)  :: ocean_sponges_tracer
     character(len=72)  :: ocean_sponges_velocity
     character(len=72)  :: ocean_ideal_surf_wave
     character(len=72)  :: fafmip_heat
  end type ocean_options_type



#include <ocean_memory.h>


#ifdef MOM_STATIC_ARRAYS
!################################################################################################

  type, public :: ocean_thickness_type

     integer :: method       ! energetic or finite volume  

     real, dimension(isd:ied,jsd:jed,nk,3) :: rho_dzt   ! rho(kg/m^3)*thickness (m) of T cell at 3 times
     real, dimension(isd:ied,jsd:jed,nk,2) :: rho_dzten ! rho(kg/m^3)*thickness (m) at east/north face of T-cell
     real, dimension(isd:ied,jsd:jed,nk)   :: rho_dztr  ! 1.0/(rho*dzt) at time taup1
     real, dimension(isd:ied,jsd:jed,nk,3) :: rho_dzu   ! rho (kg/m^3) * thickness (m) of U cell at 3 times
     real, dimension(isd:ied,jsd:jed,nk)   :: rho_dzur  ! 1.0/(rho*dzu) at time taup1

     real, dimension(isd:ied,jsd:jed,nk)   :: rho_dzt_tendency ! rho_dzt tendency (kg/m^3)*(m/s)

     real, dimension(isd:ied,jsd:jed)      :: sea_lev     ! eta_t + patm/(rho0*grav) - eta_geoid - eta_tide (m) at time taup1 for coupler 
     real, dimension(isd:ied,jsd:jed,nk)   :: dzt         ! thickness (m) of T cell at time tau/taup1
     real, dimension(isd:ied,jsd:jed,nk,2) :: dzten       ! thickness (m) of east/north face of T cell at time tau/taup1
     real, dimension(isd:ied,jsd:jed,nk)   :: dzu         ! thickness (m) of U cell at time tau/taup1
     real, dimension(isd:ied,jsd:jed,0:nk) :: dzwt        ! vertical distance (m) between T points at tau/taup1 
     real, dimension(isd:ied,jsd:jed,0:nk) :: dzwu        ! vertical distance (m) between U points at tau/taup1

     real, dimension(isd:ied,jsd:jed,nk)   :: dztup       ! distance (m) from T-cell point to top of T-cell 
     real, dimension(isd:ied,jsd:jed,nk)   :: dztlo       ! distance (m) from T-cell point to bottom of T-cell 

     real, dimension(isd:ied,jsd:jed,nk)   :: geodepth_zt ! vertical distance (m) from z=0 to T-point 
     real, dimension(isd:ied,jsd:jed,nk)   :: depth_zt    ! vertical distance (m) from column top to T-point 
     real, dimension(isd:ied,jsd:jed,nk)   :: depth_zwt   ! vertical distance (m) from column top to T-bottom 
     real, dimension(isd:ied,jsd:jed,nk)   :: depth_zu    ! vertical distance (m) from column top to U-point
     real, dimension(isd:ied,jsd:jed,nk)   :: depth_zwu   ! vertical distance (m) from column top to U-bottom

     real, dimension(isd:ied,jsd:jed,nk)   :: depth_st    ! s-distance to T-point
     real, dimension(isd:ied,jsd:jed,nk)   :: depth_swt   ! s-distance to T-bottom
     real, dimension(isd:ied,jsd:jed,nk)   :: dst         ! vertical increment of s-coordinate on T-cell 
     real, dimension(isd:ied,jsd:jed,0:nk) :: dswt        ! s-coordinate T-point increment at time tau 
     real, dimension(isd:ied,jsd:jed,nk)   :: dzt_dst     ! specific thickness (metre/s-coordinate) on T-cell 

     real, dimension(isd:ied,jsd:jed,nk)   :: dstup       ! s-distance (s-units) from T-cell point to top of T-cell 
     real, dimension(isd:ied,jsd:jed,nk)   :: dstlo       ! s-distance (s-units) from T-cell point to bottom of T-cell 

     real, dimension(isd:ied,jsd:jed)      :: pbot0       ! reference bottom pressure (Pa) 
     real, dimension(isd:ied,jsd:jed)      :: pbot0r      ! inverse of reference bottom pressure (1/Pa) 

     real, dimension(isd:ied,jsd:jed,nk)   :: mass_source ! mass source (kg/m^3)*(m/sec) 
     real, dimension(isd:ied,jsd:jed,3)    :: mass_u      ! mass per area (kg/m^2) in a velocity column 
     real, dimension(isd:ied,jsd:jed,2)    :: mass_en     ! vertical sum rho_dzten (kg/m^2) 
     real, dimension(isd:ied,jsd:jed,3)    :: thicku      ! thickness on U-cell (metre) from z=eta_u to z=-H.
     real, dimension(isd:ied,jsd:jed,2)    :: thicken     ! sum of dzten (metre)


     ! The following arrays are never allocated with MOM_STATIC_ARRAYS,
     ! but they need to be declared allocatable in order to compile. 
     real, dimension(:,:,:,:), _ALLOCATABLE :: rho_dztL     _NULL ! L system contribution to rho_dztT (3 time levels)
     real, dimension(:,:,:,:), _ALLOCATABLE :: rho_dztT     _NULL ! rho(kg/m^3)*thickness (m) of T cell at 3 times (total)
     real, dimension(:,:,:,:), _ALLOCATABLE :: rho_dzuL     _NULL ! L system contribution to rho_dzuT (3 time levels)
     real, dimension(:,:,:,:), _ALLOCATABLE :: rho_dzuT     _NULL ! rho (kg/m^3) * thickness (m) of U cell at 3 times (total)
     real, dimension(:,:,:),   _ALLOCATABLE :: dztL         _NULL ! L system contribution to dztT
     real, dimension(:,:,:,:), _ALLOCATABLE :: dztT         _NULL ! thickness (m) of T cell at time tau/taup1
     real, dimension(:,:,:),   _ALLOCATABLE :: dzuL         _NULL ! L system contribution to dzuT
     real, dimension(:,:,:),   _ALLOCATABLE :: dzuT         _NULL ! thickness (m) of U cell at time tau/taup1
     real, dimension(:,:,:),   _ALLOCATABLE :: dzwtL        _NULL ! L system contribution to dzwtT
     real, dimension(:,:,:),   _ALLOCATABLE :: dzwtT        _NULL ! vertical distance (m) between T points at tau/taup1
     real, dimension(:,:,:),   _ALLOCATABLE :: dzwuL        _NULL ! L system contribution to dzwuT
     real, dimension(:,:,:),   _ALLOCATABLE :: dzwuT        _NULL ! vertical distance (m) between U points at tau/taup1
     real, dimension(:,:,:),   _ALLOCATABLE :: dztupL       _NULL ! L system contribution to dztupT
     real, dimension(:,:,:),   _ALLOCATABLE :: dztupT       _NULL ! distance (m) from T-cell point to top of T-cell 
     real, dimension(:,:,:),   _ALLOCATABLE :: dztloL       _NULL ! L system contribution to dztloT
     real, dimension(:,:,:),   _ALLOCATABLE :: dztloT       _NULL ! distance (m) from T-cell point to bottom of T-cell
     real, dimension(:,:,:),   _ALLOCATABLE :: mass_uT      _NULL ! mass per area (kg/m^2) in a velocity column
     real, dimension(:,:,:),   _ALLOCATABLE :: geodepth_zwt _NULL ! vert distance (m) from z=0 to bottom of T-cell
     real, dimension(:,:),     _ALLOCATABLE :: blob_source _NULL  ! mass source (sink) for the L system (E system)

  end type ocean_thickness_type


  type, public :: ocean_grid_type
     character(len=32) :: name

     ! geometry and topology and rotation
     logical                           :: cyclic_x         ! true if domain is cyclic in the i direction
     logical                           :: cyclic_y         ! true if domain is cyclic in the j direction
     logical                           :: tripolar         ! folded connectivity at "top" row in bipolar Arctic 
     logical                           :: mosaic           ! true when using a mosaic grid 
     logical                           :: beta_plane       ! beta plane Cartesian 
     logical                           :: f_plane          ! f-plane Cartesian
     real                              :: f_plane_latitude ! latitude where f_plane is centered  
     real, dimension(isd:ied,jsd:jed)  :: f                ! coriolis parameter at u-cell points (sec^-1)
     real, dimension(isd:ied,jsd:jed)  :: fstar            ! horizontal coriolis parameter at u-cell points (sec^-1)
     real, dimension(isd:ied,jsd:jed)  :: beta             ! df/dy at u-cell points (1/(sec*m))     
     real, dimension(isd:ied,jsd:jed)  :: beta_eff         ! beta plus topographic beta at u-cell (1/(sec*m))

     ! vertical grid information (time independent) 
     integer                             :: nk     ! number of vertical grid points 
     integer, dimension(isd:ied,jsd:jed) :: kmt    ! number of t-levels
     integer, dimension(isd:ied,jsd:jed) :: kmu    ! number of u-levels

     real, dimension(nk)                 :: zt     ! full cell depth (m) from surface to level k T-cell 
     real, dimension(nk)                 :: zw     ! full cell depth (m) from surface to bottom of k T-cell  
     real, dimension(nk)                 :: dzt    ! initial vertical resolution of T or U grid cells (m) 
     real, dimension(nk)                 :: dztlo  ! distance (m) from T-cell point to bottom of T-cell
     real, dimension(nk)                 :: dztup  ! distance (m) from T-cell point to top of T-cell
     real, dimension(0:nk)               :: dzw    ! initial vertical resolution of W grid cells (m) 
     real, dimension(0:nk)               :: dzwr   ! reciprocal of dzw (W cell vertical resolution)

     real, dimension(nk)                 :: st     ! full cell s-depth from surface to level k T-cell 
     real, dimension(nk)                 :: sw     ! full cell s-depth from surface to bottom of k T-cell  
     real, dimension(nk)                 :: dst    ! initial vertical s-resolution of T or U grid cells (m) 
     real, dimension(nk)                 :: dstlo  ! s-distance (s-units) from T-cell point to bottom of T-cell
     real, dimension(nk)                 :: dstup  ! s-distance (s-units) from T-cell point to top of T-cell
     real, dimension(0:nk)               :: dsw    ! initial vertical s-resolution of W grid cells (m) 

     real, dimension(nk,0:1)             :: fracdz ! fractional distance between grid point and cell top/bot 
     real, dimension(isd:ied,jsd:jed)    :: ht     ! depth to bottom of ocean (m) on t-cells from z=0 
     real, dimension(isd:ied,jsd:jed)    :: htr    ! inverse depth to bottom of ocean (m^-1) on t-cells
     real, dimension(isd:ied,jsd:jed)    :: hu     ! depth to bottom of ocean (m) on u-cells from z=0
     real, dimension(isd:ied,jsd:jed)    :: dht_dx ! d(ht)/dx on u-cells (m/m)
     real, dimension(isd:ied,jsd:jed)    :: dht_dy ! d(ht)/dy on u-cells (m/m)
     real, dimension(isd:ied,jsd:jed)    :: gradH  ! sqrt(dht_dx**2+dht_dyx**2) on u-cells (m/m)

     ! horizontal grid information (time independent)
     integer                          :: ni, nj     ! number of global points in the two horizontal directions
     real, dimension(isd:ied,jsd:jed) :: xt         ! longitude of the T grid points in degrees.
     real, dimension(isd:ied,jsd:jed) :: xu         ! longitude of the U grid points in degrees.
     real, dimension(isd:ied,jsd:jed) :: yt         ! latitude of the T grid points in degrees.
     real, dimension(isd:ied,jsd:jed) :: yu         ! latitude of the U grid points in degrees.
     real, dimension(isd:ied,jsd:jed) :: phiu       ! latitude of U grid point in radians
     real, dimension(isd:ied,jsd:jed) :: phit       ! latitude of T grid point in radians
     real, dimension(isd:ied,jsd:jed) :: h1t        ! metric factors in i grid direction
     real, dimension(isd:ied,jsd:jed) :: h1u        ! metric factors in j grid jirection
     real, dimension(isd:ied,jsd:jed) :: h2t        ! metric factors in i grid direction
     real, dimension(isd:ied,jsd:jed) :: h2u        ! metric factors in j grid jirection
     real, dimension(isd:ied,jsd:jed) :: dh2dx      ! (1/delta_y)*d(delta_y)/dx (1/m)
     real, dimension(isd:ied,jsd:jed) :: dh1dy      ! (1/delta_x)*d(delta_x)/dy (1/m)
     real, dimension(isd:ied,jsd:jed) :: dxt        ! longitudinal width of T-cells at grid point (m)
     real, dimension(isd:ied,jsd:jed) :: dxu        ! longitudinal width of U-cells at grid point (m)
     real, dimension(isd:ied,jsd:jed) :: dyt        ! latitudinal width of T-cells at grid point (m) 
     real, dimension(isd:ied,jsd:jed) :: dyu        ! latitudinal width of U-cells at grid point (m)
     real, dimension(isd:ied,jsd:jed) :: dau        ! area of U-cells (m^2)
     real, dimension(isd:ied,jsd:jed) :: dat        ! area of T-cells (m^2)
     real, dimension(isd:ied,jsd:jed) :: dat_frac   ! fraction of total wet area occuped by a T-cell (dimensionless)
     real, dimension(isd:ied,jsd:jed) :: dxte       ! long-width between grid points at i+1 and i in T-cells (m)
     real, dimension(isd:ied,jsd:jed) :: dxtn       ! long-width of north face of T-cells (m)
     real, dimension(isd:ied,jsd:jed) :: dyte       ! lat-width of east face of T-cells (m)
     real, dimension(isd:ied,jsd:jed) :: dytn       ! lat-width between grid points at j+1 and j in T-cells (m)
     real, dimension(isd:ied,jsd:jed) :: dxue       ! long-width between grid points at i+1 and i in U-cells (m)
     real, dimension(isd:ied,jsd:jed) :: dxun       ! long-width of north face of U-cells (m)
     real, dimension(isd:ied,jsd:jed) :: dyue       ! lat-width of east face of U-cells (m)
     real, dimension(isd:ied,jsd:jed) :: dyun       ! lat-width between grid points at j+1 and j in U-cells (m)
     real, dimension(isd:ied,jsd:jed) :: datnr      ! reciprocal area at north face of T-cell
     real, dimension(isd:ied,jsd:jed) :: dater      ! reciprocal area at east face of T-cell
     real, dimension(isd:ied,jsd:jed) :: dun        ! width from grid point to north face of U-cells (m)
     real, dimension(isd:ied,jsd:jed) :: dus        ! width from grid point to south face of U-cells (m)
     real, dimension(isd:ied,jsd:jed) :: duw        ! width from grid point to west  face of U-cells (m)
     real, dimension(isd:ied,jsd:jed) :: due        ! width from grid point to east  face of U-cells (m)
     real, dimension(isd:ied,jsd:jed) :: dtn        ! width from grid point to north face of T-cells (m)
     real, dimension(isd:ied,jsd:jed) :: dts        ! width from grid point to south face of T-cells (m)
     real, dimension(isd:ied,jsd:jed) :: dtw        ! width from grid point to west  face of T-cells (m)
     real, dimension(isd:ied,jsd:jed) :: dte        ! width from grid point to east  face of T-cells (m)
     real, dimension(isd:ied,jsd:jed) :: dxtr       ! 1/dxt
     real, dimension(isd:ied,jsd:jed) :: dxur       ! 1/dxu
     real, dimension(isd:ied,jsd:jed) :: dytr       ! 1/dyt
     real, dimension(isd:ied,jsd:jed) :: dyur       ! 1/dyu
     real, dimension(isd:ied,jsd:jed) :: daur       ! 1/[area of U-cells (m^2)]
     real, dimension(isd:ied,jsd:jed) :: datr       ! 1/[area of T-cells (m^2)]
     real, dimension(isd:ied,jsd:jed) :: dxter      ! 1/dxte
     real, dimension(isd:ied,jsd:jed) :: dyter      ! 1/dyte
     real, dimension(isd:ied,jsd:jed) :: dxtnr      ! 1/dxtn
     real, dimension(isd:ied,jsd:jed) :: dytnr      ! 1/dytn
     real, dimension(isd:ied,jsd:jed) :: dxuer      ! 1/dxue
     real, dimension(isd:ied,jsd:jed) :: dxunr      ! 1/dxun
     real, dimension(isd:ied,jsd:jed) :: dyuer      ! 1/dyue
     real, dimension(isd:ied,jsd:jed) :: dyunr      ! 1/dyun
     real, dimension(isd:ied,jsd:jed) :: dyue_dxuer ! dyue/dxue 
     real, dimension(isd:ied,jsd:jed) :: dxun_dyunr ! dxun/dyun
     real, dimension(isd:ied,jsd:jed) :: dxt_dxter  ! dxt/dxte
     real, dimension(isd:ied,jsd:jed) :: dxte_dxtr  ! dxte/dxt
     real, dimension(isd:ied,jsd:jed) :: dxt_dxtnr  ! dxt/dxtn
     real, dimension(isd:ied,jsd:jed) :: dxtn_dxtr  ! dxtn/dxt
     real, dimension(isd:ied,jsd:jed) :: dyt_dyter  ! dyt/dyte
     real, dimension(isd:ied,jsd:jed) :: dyte_dytr  ! dyte/dyt
     real, dimension(isd:ied,jsd:jed) :: dyt_dytnr  ! dyt/dytn
     real, dimension(isd:ied,jsd:jed) :: dytn_dytr  ! dytn/dyt

     ! land/sea masks 
     real, dimension(isd:ied,jsd:jed)      :: obc_tmask   ! land/sea mask for T cell diagnostics with OBC 
     real, dimension(isd:ied,jsd:jed)      :: obc_umask   ! land/sea mask for B-grid U cell diagnostics with OBC
     real, dimension(isd:ied,jsd:jed,nk)   :: mask        ! land/sea tmask or umask depending on C/B grids 
     real, dimension(isd:ied,jsd:jed,nk)   :: tmask       ! land/sea mask for T cells based on s-coordinate
     real, dimension(isd:ied,jsd:jed,nk)   :: umask       ! land/sea mask for B-grid U cells based on s-coordinate
     real, dimension(isd:ied,jsd:jed,nk,2) :: tmasken     ! land/sea mask for east/north face of t-cell based on s-coordinate
     real, dimension(isd:ied,jsd:jed,nk)   :: tmask_depth ! based on depth-based vert_coordinate
     real, dimension(isd:ied,jsd:jed,nk)   :: umask_depth ! based on depth-based vert_coordinate

     ! grid areas and volumes 
     real                 :: tcellv    ! initial T cell volume m^3 (entire resting ocean)
     real                 :: ucellv    ! initial U cell volume m^3 (entire resting ocean)
     real                 :: tcellsurf ! T cell surface area (k=1) in bitwise reproducible form
     real                 :: ucellsurf ! U cell surface area (k=1) in bitwise reproducible form
     real, dimension(nk)  :: tcella    ! T cell surface area m^2 (entire ocean)
     real, dimension(nk)  :: ucella    ! U cell surface area m^2 (entire ocean)

     ! model grid information
     integer :: wet_t_points   ! total number of wet tracer points 
     integer :: wet_u_points   ! total number of wet B-grid velocity points 
     integer :: total_t_points ! total number of wet or dry tracer points  

     ! sine and cosine of rotation angles (clockwise) of velocity for tripolar 
     real, dimension(isd:ied,jsd:jed) :: sin_rot  
     real, dimension(isd:ied,jsd:jed) :: cos_rot  

     ! 1-d grid coordinates for COARDS NetCDF files
     real, dimension(ni) :: grid_x_t  
     real, dimension(nj) :: grid_y_t 
     real, dimension(ni) :: grid_x_u  
     real, dimension(nj) :: grid_y_u  

     ! axes id for diagnostic manager 
     integer, dimension(3)  :: tracer_axes        
     integer, dimension(3)  :: vel_axes_uv         
     integer, dimension(3)  :: vel_axes_u
     integer, dimension(3)  :: vel_axes_v
     integer, dimension(3)  :: vel_axes_wu    
     integer, dimension(3)  :: vel_axes_wt    
     integer, dimension(3)  :: tracer_axes_wt 
     integer, dimension(3)  :: tracer_axes_flux_x  
     integer, dimension(3)  :: tracer_axes_flux_y  
     integer, dimension(3)  :: vel_axes_flux_x    
     integer, dimension(3)  :: vel_axes_flux_y    

     ! axes id for diagnostic manager, appropriate
     ! when with to remap native vertical fields 
     ! to depth or pressure levels.  Appropropriate
     ! when vert_coordinate == ZSIGMA or PSIGMA, or other 
     ! vertical coordinats whose iso-surfaces are 
     ! not quasi-horizontal 
     integer, dimension(3)  :: tracer_axes_depth        
     integer, dimension(3)  :: vel_axes_uv_depth
     integer, dimension(3)  :: vel_axes_u_depth
     integer, dimension(3)  :: vel_axes_v_depth
     integer, dimension(3)  :: vel_axes_wu_depth    
     integer, dimension(3)  :: vel_axes_wt_depth
     integer, dimension(3)  :: tracer_axes_wt_depth
     integer, dimension(3)  :: tracer_axes_flux_x_depth
     integer, dimension(3)  :: tracer_axes_flux_y_depth
     integer, dimension(3)  :: vel_axes_flux_x_depth
     integer, dimension(3)  :: vel_axes_flux_y_depth

  end type ocean_grid_type


  type, public :: ocean_domain_type
     type(domain2d) :: domain2d           ! fms variable, used by mpp routines
     integer :: isc, iec, jsc, jec        ! computational domain indices 
     integer :: isd, ied, jsd, jed        ! local indices including halo, consistent with domain2d
     integer :: isg, ieg, jsg, jeg        ! global indices
     integer :: isa, iea, jsa, jea        ! active indices (for minimizing comm2d calls)
     integer :: xhalo, yhalo              ! halo sizes 
     integer :: xflags, yflags, layout(2) ! options to mpp_define_domains
     integer :: ioff , joff               ! index offset for absolute indices if MOM_STATIC_ARRAYS (0 otherwise)
     integer :: io_layout(2)              ! options to define io_domain.
     integer :: x_cyclic_offset           ! offset applied to x-direction cyclic boundary condition
     integer :: y_cyclic_offset           ! offset applied to y-direction cyclic boundary condition
     logical, pointer :: maskmap(:,:) =>NULL() ! option to mpp_define_domains
  end type ocean_domain_type

  type, public :: ocean_time_type
     type(time_type) :: model_time     ! fms variable
     type(time_type) :: Time_step      ! time step for tracers (and for ocean model)
     type(time_type) :: Time_init      ! time of initial conditions 
     integer :: calendar               ! calendar type defined by time_manager_mod
     logical :: init                   ! true at beginning of run (initial condition time)
     integer :: itt                    ! timestep counter measured relative to time at restart 
     integer :: itt0                   ! timestep counter measured relative to initial condition time
     integer :: taum1, tau, taup1      ! time level indices
     integer :: tau_m2, tau_m1, tau_m0 ! time level indices for Adams-Bashforth velocity advection and coriolis 
  end type ocean_time_type

  type, public :: ocean_adv_vel_type
     real, dimension(isd:ied,jsd:jed,nk)   :: uhrho_et   ! rho_dzu * advect vel (kg/(m*s)) on i-face of T-cell
     real, dimension(isd:ied,jsd:jed,nk)   :: vhrho_nt   ! rho*dzu * advect vel (kg/(m*s)) on j-face of T-cell
     real, dimension(isd:ied,jsd:jed,nk)   :: uhrho_eu   ! remapped uhrho_et (kg/(m*s)) onto i-face of U-cell
     real, dimension(isd:ied,jsd:jed,nk)   :: vhrho_nu   ! remapped vhrho_nt (kg/(m*s)) onto j-face of U-cell
     real, dimension(isd:ied,jsd:jed,0:nk) :: wrho_bt    ! rho * vertical advect vel (kg/(m^2*s)) on T-bottom
     real, dimension(isd:ied,jsd:jed,0:nk) :: wrho_bu    ! remapped wrho_bt onto U-bottom
     real, dimension(isd:ied,jsd:jed,nk)   :: diverge_t  ! divergence on T-cell of horiz momentum per mass (kg/m3)*(m/s)
     real, dimension(isd:ied,jsd:jed,nk)   :: diverge_u  ! divergence on U-cell of horiz momentum per mass (kg/m3)*(m/s)
  end type ocean_adv_vel_type

  type , public :: ocean_density_type
     logical                               :: use_teos10           ! for using the TEOS-2010 equation of state recommendations 
     real, dimension(isd:ied,jsd:jed,nk,3) :: rho                  ! in situ density (kg/m^3) at time levels
     real, dimension(isd:ied,jsd:jed,nk,3) :: rho_salinity         ! salinity used in rho calculations (psu or g/kg) at time levels
     real, dimension(isd:ied,jsd:jed,nk)   :: rho_dztr_tau         ! rho_dztr at time tau 1/(kg/m^3) (for diagnostic uses) 
     real, dimension(isd:ied,jsd:jed,nk)   :: rho_fresh            ! in situ fresh water density (kg/m^3) at tau   
     real, dimension(isd:ied,jsd:jed,nk)   :: pressure_at_depth    ! hydrostatic pressure (including patm)
     real, dimension(isd:ied,jsd:jed,nk)   :: drhodT               ! partial rho wrt theta (kg/(m^3 C)
     real, dimension(isd:ied,jsd:jed,nk)   :: drhodS               ! partial rho wrt salinity (kg/(m^3 psu)
     real, dimension(isd:ied,jsd:jed,nk)   :: dpotrhodT            ! partial potrho wrt theta (kg/(m^3 C)
     real, dimension(isd:ied,jsd:jed,nk)   :: dpotrhodS            ! partial potrho wrt salinity (kg/(m^3 psu)
     real, dimension(isd:ied,jsd:jed,nk)   :: dpotrhodP            ! partial potrho wrt pressure (kg/(m^3 psu)
     real, dimension(isd:ied,jsd:jed,nk)   :: drhodP               ! partial rho wrt pressure (kg/(m^3 Pa)
     real, dimension(isd:ied,jsd:jed,nk)   :: drhodz_wt            ! d(neutral density)/dz (kg/m^4) at W-point
     real, dimension(isd:ied,jsd:jed,nk)   :: drhodz_zt            ! d(neutral density)/dz (kg/m^4) at T-point
     real, dimension(isd:ied,jsd:jed,nk)   :: drhodx_zt            ! d(neutral density)/dx (kg/m^4) at T-point
     real, dimension(isd:ied,jsd:jed,nk)   :: drhody_zt            ! d(neutral density)/dy (kg/m^4) at T-point
     real, dimension(isd:ied,jsd:jed,nk)   :: drhodz_diag          ! regularized drhodz_zt for diagnostics 
     real, dimension(isd:ied,jsd:jed,nk)   :: dTdz_zt              ! partial theta wrt z  (C/m) at T-point
     real, dimension(isd:ied,jsd:jed,nk)   :: dSdz_zt              ! partial salinity wrt z  (psu/m) at T-point
     real, dimension(isd:ied,jsd:jed,nk)   :: potrho               ! potential density (kg/m^3)
     real, dimension(isd:ied,jsd:jed,nk)   :: neutralrho           ! neutral density (kg/m^3)
     real, dimension(isd:ied,jsd:jed,nk)   :: watermass_factor        ! ratio (|grad nrho|/|grad local ref potrho|) / delta(gamma)
     real, dimension(isd:ied,jsd:jed,nk)   :: stratification_factor   ! rho*Area(h) / gamma_{,h}, w/ h=direction w/ max gamma strat
     real, dimension(isd:ied,jsd:jed)      :: mld_subduction          ! depth mixed layer base (m) for subduction diagnostics 
     integer, dimension(3)                 :: potrho_axes             ! axis ids for diagnosing potential density 
     integer, dimension(3)                 :: potrho_axes_flux_x      ! axis ids for diagnosing x-flux
     integer, dimension(3)                 :: potrho_axes_flux_y      ! axis ids for diagnosing y-flux
     integer, dimension(3)                 :: neutralrho_axes         ! axis ids for diagnosing neutral density 
     integer, dimension(3)                 :: neutralrho_axes_flux_x  ! axis ids for diagnosing x-flux 
     integer, dimension(3)                 :: neutralrho_axes_flux_y  ! axis ids for diagnosing y-flux 
     integer, dimension(3)                 :: theta_axes              ! axis ids for potential temperature 
     integer, dimension(3)                 :: theta_axes_flux_x       ! axis ids for diagnosing x-flux 
     integer, dimension(3)                 :: theta_axes_flux_y       ! axis ids for diagnosing y-flux 

     real, _ALLOCATABLE, dimension(:)      :: theta_ref     _NULL  ! partition vertical into theta classes 
     real, _ALLOCATABLE, dimension(:)      :: theta_bounds  _NULL  ! bounds for theta classes 
     real, _ALLOCATABLE, dimension(:)      :: potrho_ref _NULL     ! partition vertical into potrho classes 
     real, _ALLOCATABLE, dimension(:)      :: potrho_bounds _NULL  ! bounds for potrho classes 
     real, _ALLOCATABLE, dimension(:)      :: neutralrho_ref _NULL ! partition vertical into neutral density classes 
     real, _ALLOCATABLE, dimension(:)      :: neutralrho_bounds _NULL ! bounds for neutral density classes 

     ! The following array is never allocated with MOM_STATIC_ARRAYS,
     ! but it must be declared allocatable in order to compile. 
     real, _ALLOCATABLE, dimension(:,:,:)  :: rhoT              _NULL ! combined L and E in situ density (kg/m^3)

  end type ocean_density_type

  
  type, public :: ocean_prog_tracer_type
     character(len=32)  :: name
     character(len=128) :: units
     character(len=128) :: type
     character(len=128) :: longname

     logical :: use_only_advection     ! for testing purposes, evolve using ONLY advection
     logical :: neutral_physics_limit  ! neutral physics reduce to horz diffusion if tracer out of bounds
     logical :: complete               ! to determine if ready to do mpp updates

     integer :: sfc_flux_id=-1         ! index for time_interp_external
     integer :: horz_advect_scheme=-1  ! id for horizontal advection scheme
     integer :: vert_advect_scheme=-1  ! id for vertical advection scheme
     integer :: ppm_hlimiter=1         ! Limiter for use with PPM in horizontal
     integer :: ppm_vlimiter=1         ! Limiter for use with PPM in vertical
     integer :: mdt_scheme=4           ! Version of Multi-Dim. Modified Daru & Tenaud (MDMDT)

     type(obc_flux), _ALLOCATABLE, dimension(:) :: otf   _NULL ! flux through open boundaries, allocate nobc

     real, dimension(isd:ied,jsd:jed,nk,3) :: field            ! tracer concentration at 3 time levels
     real, dimension(isd:ied,jsd:jed,nk)   :: th_tendency      ! thickness weighted tracer tendency
     real, dimension(isd:ied,jsd:jed,nk)   :: tendency         ! for diagnostics: tendency concentration [concentration/sec]
     real, dimension(isd:ied,jsd:jed,nk)   :: source           ! tracer source [=tracer concentration per time]
     real, dimension(isd:ied,jsd:jed,nk)   :: wrk1             ! work array
     real, dimension(isd:ied,jsd:jed,nk)   :: tmask_limit      ! to limit advection &/or neutral physics fluxes 
     real, dimension(isd:ied,jsd:jed,nk)   :: K33_implicit     ! m^2/sec vert-diffusivity from neutral diffusion 
     real, dimension(isd:ied,jsd:jed,nk)   :: radiation        ! radiation absorbed within a cell [W/m^2]
     real, dimension(isd:ied,jsd:jed)      :: stf              ! surface tracer flux [rho*m/sec*tracer concen]
     real, dimension(isd:ied,jsd:jed)      :: btf              ! bottom tracer flux [rho*m/sec*tracer concen]
     real, dimension(isd:ied,jsd:jed)      :: tpme             ! tracer concentration in precip-evap
     real, dimension(isd:ied,jsd:jed)      :: triver           ! tracer concentration in river(=runoff+calving) water  
     real, dimension(isd:ied,jsd:jed)      :: trunoff          ! tracer concentration in liquid runoff from land  
     real, dimension(isd:ied,jsd:jed)      :: tcalving       ! tracer concentration in frozen runoff from land (e.g., calving ice)
     real, dimension(isd:ied,jsd:jed) :: runoff_tracer_flux  ! tracer flux in liquid runoff (e.g., kg*degC/(m^2 s) for temp)  
     real, dimension(isd:ied,jsd:jed) :: calving_tracer_flux ! tracer flux in solid  runoff (e.g., kg*psu/(m^2 s)  for salinity)
     real, dimension(isd:ied,jsd:jed) :: riverdiffuse        ! sets where to enhance diff_cbt according to rivers
     real, dimension(isd:ied,jsd:jed) :: eta_smooth          ! tendency [tracer*(kg/m^3)*(m/s)] from eta_t smoother  
     real, dimension(isd:ied,jsd:jed) :: pbot_smooth         ! tendency [tracer*(kg/m^3)*(m/s)] from pbot_t smoother 

     ! variables for prather second order moment advection
     logical :: psom_limit                             ! controls whether a limiter is placed on the prather flux
     real, dimension(:,:,:), _ALLOCATABLE :: s0  _NULL ! zeroth moment (mean)
     real, dimension(:,:,:), _ALLOCATABLE :: sx  _NULL ! 1st moment in i direction
     real, dimension(:,:,:), _ALLOCATABLE :: sxx _NULL ! 2nd moment in i direction
     real, dimension(:,:,:), _ALLOCATABLE :: sy  _NULL ! 1st moment in j direction
     real, dimension(:,:,:), _ALLOCATABLE :: syy _NULL ! 2nd moment in j direction
     real, dimension(:,:,:), _ALLOCATABLE :: sz  _NULL ! 1st moment in k direction
     real, dimension(:,:,:), _ALLOCATABLE :: szz _NULL ! 2nd moment in k direction
     real, dimension(:,:,:), _ALLOCATABLE :: sxy _NULL ! 2nd moment for coupling the i and j directions
     real, dimension(:,:,:), _ALLOCATABLE :: sxz _NULL ! 2nd moment for coupling the i and k directions
     real, dimension(:,:,:), _ALLOCATABLE :: syz _NULL ! 2nd moment for coupling the j and k directions

     ! The following arrays are never allocated with MOM_STATIC_ARRAYS,
     ! but they need to be declared allocatable in order to compile. 
     real, _ALLOCATABLE, dimension(:,:,:)   :: fieldT     _NULL ! Total tracer concentration
     real, _ALLOCATABLE, dimension(:,:,:,:) :: sum_blob   _NULL ! tracer content [concentration*kg] from the L system
     real, _ALLOCATABLE, dimension(:,:,:)   :: tend_blob  _NULL ! blob contribution to dat*th_tendency

     real                                  :: conversion         ! conversion of dimensions  
     real                                  :: offset             ! offset in dimensions (e.g., Celsius to Kelvin)
     real                                  :: min_tracer         ! min acceptable value--model stopped if less
     real                                  :: max_tracer         ! max acceptable value--model stopped if greater
     real                                  :: min_range          ! min value used for calls to diagnostic manager 
     real                                  :: max_range          ! max value used for calls to diagnostic manager 
     real                                  :: min_tracer_limit   ! min value used to limit quicker and neutral fluxes
     real                                  :: max_tracer_limit   ! max value used to limit quicker and neutral fluxes 
     real                                  :: min_flux_range     ! min and max values used for flux diagnostics
     real                                  :: max_flux_range     ! min and max values used for flux diagnostics
     real                                  :: const_init_value   ! value used for constant tracer init
     logical                               :: const_init_tracer  ! false (default) if the tracer must exist in the restart file
                                                                 !   otherwise will initialize with const_init_value
     character(len=128)                    :: flux_units         ! units for the tracer flux
     character(len=128)                    :: restart_file       ! name for restart file
  end type ocean_prog_tracer_type
  
  type, public :: ocean_diag_tracer_type
     character(len=32)  :: name
     character(len=128) :: units, type
     character(len=128) :: longname
     real, dimension(isd:ied,jsd:jed,nk) :: field              ! tracer concentration at single time level 
     real :: conversion                                        ! conversion from model dimensions to others 
     real :: offset                                            ! offset in dimensions (e.g., Celsius to Kelvin)
     real :: min_tracer, max_tracer                            ! min and max acceptable values used to error check 
     real :: min_range, max_range                              ! min and max values used for diagnostics
     logical :: const_init_tracer                              ! false (default) if the tracer must exist in the restart file
                                                               !   otherwise will initialize with const_init_value
     character(len=128) :: restart_file                        ! name for restart file
     real               :: const_init_value                    ! to initialize tracer when constant_init_tracer
  end type ocean_diag_tracer_type


  type, public :: ocean_velocity_type
     logical                                 :: bmf_implicit    ! is true when time stepping bmf implicitly
     real, dimension(isd:ied,jsd:jed,nk,2,3) :: u               ! horz velocity (m/s) in i,j directions at 3 time levels
     real, dimension(isd:ied,jsd:jed,2)      :: smf             ! momentum flux per mass into ocean surface at uv point (N/m^2)
     real, dimension(isd:ied,jsd:jed,2)      :: smf_bgrid       ! momentum flux per mass into ocean surface at Bgrid uv point (N/m^2)
     real, dimension(isd:ied,jsd:jed,2)      :: smf_cgrid       ! momentum flux per mass into ocean surface at Cgrid u/v points (N/m^2)
     real, dimension(isd:ied,jsd:jed,2)      :: bmf             ! momentum flux per mass into ocean bottom  (N/m^2)
     real, dimension(isd:ied,jsd:jed)        :: ustar           ! surface friction velocity (m/s)
     real, dimension(isd:ied,jsd:jed)        :: gamma           ! dimensionful bottom drag coefficient (kg/(m^2 sec))
     real, dimension(isd:ied,jsd:jed)        :: langmuirfactor  ! dimensionless langmuir turbulence enhancement factor (non dimensional)
     real, dimension(isd:ied,jsd:jed)        :: u10             ! 10m wind speed (m/s)
     real, dimension(isd:ied,jsd:jed)        :: ustoke          ! x-dir surface stokes drift (m/s)
     real, dimension(isd:ied,jsd:jed)        :: vstoke          ! y-dir surface stokes drift (m/s)
     real, dimension(isd:ied,jsd:jed)        :: wavlen          ! wave length (m)
     real, dimension(isd:ied,jsd:jed)        :: cdbot_array     ! dimensionless static bottom drag coefficient
     real, dimension(isd:ied,jsd:jed)        :: current_wave_stress !wave-current bottom stress for sediment dynamics (N/m^2)
     real, dimension(isd:ied,jsd:jed)        :: rossby_radius   ! first baroclinic rossby radius (m)
     real, dimension(isd:ied,jsd:jed)        :: stokes_depth    ! depth scale (m) used for exponential decay of surface wave Stokes velocity
     real, dimension(isd:ied,jsd:jed,nk,2)   :: stokes_drift    ! Stokes drift velocity (m/s) from surface wave model 
     real, dimension(isd:ied,jsd:jed,nk,2)   :: stokes_force    ! Coriolis force from Stokes drift (N/m^2)
     real, dimension(isd:ied,jsd:jed,nk,2)   :: press_force     ! thickness*density weighted (i,j)-directed press force (N/m^2)
     real, dimension(isd:ied,jsd:jed,nk,2)   :: accel           ! thickness*density weighted (i,j)-directed acceleration (N/m^2)
     real, dimension(isd:ied,jsd:jed,nk,2)   :: vfrict_impl     ! thickness*density weighted vertical friction (N/m^2)
     real, dimension(isd:ied,jsd:jed,nk,2)   :: source          ! thickness*density weighted velocity source/sink (N/m^2)
     real, dimension(isd:ied,jsd:jed,nk,2)   :: wrkv            ! work array
     real, dimension(isd:ied,jsd:jed,nk,2,3) :: advection       ! thickness weighted tendency by velocity advect (N/m^2)
     real, dimension(isd:ied,jsd:jed,nk,2,3) :: coriolis        ! thickness weighted tendency by Cgrid coriolis force (N/m^2)
     real, dimension(isd:ied,jsd:jed,2)      :: lap_friction_bt ! friction just on barotropic velocity (N/m^2)
     real, dimension(isd:ied,jsd:jed,2)      :: bih_friction_bt ! friction just on barotropic velocity (N/m^2)
  end type ocean_velocity_type


  type, public :: ocean_external_mode_type  
     real, dimension(isd:ied,jsd:jed,3)   :: eta_t        ! surface height on tracer cell center (m) 
     real, dimension(isd:ied,jsd:jed,3)   :: eta_u        ! surface height on velocity cell center  (m) 
     real, dimension(isd:ied,jsd:jed,3)   :: eta_t_bar    ! surface height on tracer cell time avg over ext-mode time steps (m) 
     real, dimension(isd:ied,jsd:jed)     :: deta_dt      ! surface height time tendency on t-cell (m/s)

     real, dimension(isd:ied,jsd:jed,3)   :: pbot_t         ! bottom pressure on tracer cell center (Pa) 
     real, dimension(isd:ied,jsd:jed,3)   :: pbot_u         ! bottom pressure on velocity cell center (Pa) 
     real, dimension(isd:ied,jsd:jed,3)   :: anompb         ! pbot_t-rho0*grav*ht = anomalous bottom pressure (Pa)
     real, dimension(isd:ied,jsd:jed,3)   :: anompb_bar     ! pbot_t-rho0*grav*ht (Pa) time avg over ext-mode time steps 
     real, dimension(isd:ied,jsd:jed)     :: dpbot_dt       ! bottom pressure time tendency on tracer cell (Pa/s)

     real, dimension(isd:ied,jsd:jed)     :: patm_u           ! atmospheric pressure on velocity cell (Pa)
     real, dimension(isd:ied,jsd:jed,3)   :: patm_t           ! atmospheric pressure on tracer cell (Pa)
     real, dimension(isd:ied,jsd:jed)     :: patm_for_sea_lev ! atmospheric pressure on tracer cell (Pa) passed to coupler
     real, dimension(isd:ied,jsd:jed)     :: dpatm_dt         ! atmospheric pressure time tendency on tracer cell (Pa/s)

     real, dimension(isd:ied,jsd:jed,3)   :: conv_rho_ud_t  ! convergence of sum_k(rho*dzt*u) on T-cell (kg/m^3)*(m/s)
     real, dimension(isd:ied,jsd:jed,2,3) :: udrho          ! vertically integrated and rho weighted horz velocity (kg/m^3)*(m^2/s)
     real, dimension(isd:ied,jsd:jed,2)   :: forcing_bt     ! depth integrated time change of velocity (without coriolis)
     real, dimension(isd:ied,jsd:jed)     :: ps             ! surface pressure (pressure at z=0 due to eta_t) at time tau
     real, dimension(isd:ied,jsd:jed,2)   :: grad_ps        ! rho0r * surface pressure gradient at time tau
     real, dimension(isd:ied,jsd:jed,2)   :: grad_anompb    ! gradient of anompb (Pa/m) on U-point

     real, dimension(isd:ied,jsd:jed,2)   :: press_force    ! pressure force/area (N/m^2) updated each barotropic time step 

     real, dimension(isd:ied,jsd:jed)     :: source         ! density weighted vertical integral of mass source (kg/m^2/sec)
     real, dimension(isd:ied,jsd:jed)     :: eta_smooth     ! (kg/m^3)*(m/s) from eta_t smoother  
     real, dimension(isd:ied,jsd:jed)     :: pbot_smooth    ! (kg/m^3)*(m/s) from pbot_t smoother 

     real, dimension(isd:ied,jsd:jed,3)   :: eta_nonbouss   ! diagnosed eta (m) including steric effects
     real, dimension(isd:ied,jsd:jed,3)   :: eta_nonsteric  ! diagnosed piece of eta_nonbouss (m) from non-steric effects 
     real, dimension(isd:ied,jsd:jed,3)   :: eta_steric     ! diagnosed eta_nonbouss (m) from steric effects 
     real, dimension(isd:ied,jsd:jed,3)   :: eta_dynamic    ! diagnosed eta_nonbouss (m) from "dynamic" effects 
     real, dimension(isd:ied,jsd:jed,3)   :: eta_water      ! diagnosed eta_nonbouss (m) from water forcing at boundaries
     real, dimension(isd:ied,jsd:jed,3)   :: eta_source     ! diagnosed eta_nonbouss (m) from source term 
     real, dimension(isd:ied,jsd:jed,3)   :: eta_surf_temp  ! diagnosed eta_nonbouss (m) arising from surface temp flux
     real, dimension(isd:ied,jsd:jed,3)   :: eta_surf_salt  ! diagnosed eta_nonbouss (m) arising from surface salt flux
     real, dimension(isd:ied,jsd:jed,3)   :: eta_surf_water ! diagnosed eta_nonbouss (m) arising from surface water flux
     real, dimension(isd:ied,jsd:jed,3)   :: eta_bott_temp  ! diagnosed eta_nonbouss (m) arising from bottom temp flux

     ! The following arrays are never allocated with MOM_STATIC_ARRAYS,
     ! but they need to be declared allocatable in order to compile. 
     real, _ALLOCATABLE, dimension(:,:)   :: conv_blob  _NULL ! water column divergence of the L system


  end type ocean_external_mode_type


  ! types used by neutral physics 
  type, public :: tracer_2d_type
     real, dimension(isd:ied,jsd:jed)     :: field
  end type tracer_2d_type

  type, public :: tracer_3d_0_nk_type
    real, dimension(isd:ied,jsd:jed,0:nk) :: field
  end type tracer_3d_0_nk_type

  type, public :: tracer_3d_1_nk_type
    real, dimension(isd:ied,jsd:jed,nk)   :: field
  end type tracer_3d_1_nk_type


  ! for gotm vertical mixing scheme 
  type, public :: ocean_gotm_type
     character(len=32)  :: name
     character(len=32)  :: units
     character(len=128) :: longname
     real               :: min_value   ! minimum value
     real               :: max_value   ! maximum value
     real, dimension(isd:ied,jsd:jed,nk,2) :: field  ! scalar at 2 time levels
  end type ocean_gotm_type

  ! advection tendency for GOTM scalar fields 
  type, public :: advect_gotm_type              
    real, dimension(isc-2:iec+2,jsc-2:jec+2,nk) :: field
  end type advect_gotm_type


#else
!############################################################################################
! not MOM_STATIC_ARRAYS

  type, public :: ocean_thickness_type
     integer :: method       ! energetic or finite volume  

     real, dimension(:,:,:,:), _ALLOCATABLE :: rho_dzt   _NULL ! E system contribution to rho_dztT (3 time levels)
     real, dimension(:,:,:,:), _ALLOCATABLE :: rho_dzten _NULL ! rho*dz at east/north face of T-cell
     real, dimension(:,:,:),   _ALLOCATABLE :: rho_dztr  _NULL ! 1.0/(rho*dzt) at time taup1 (E system)
     real, dimension(:,:,:,:), _ALLOCATABLE :: rho_dztL  _NULL ! L system contribution to rho_dztT (3 time levels)
     real, dimension(:,:,:,:), _ALLOCATABLE :: rho_dztT  _NULL ! rho(kg/m^3)*thickness (m) of T cell at 3 times (total)

     real, dimension(:,:,:,:), _ALLOCATABLE :: rho_dzu   _NULL ! E system contribution to rho_dzuT (3 time levels)
     real, dimension(:,:,:),   _ALLOCATABLE :: rho_dzur  _NULL ! 1.0/(rho*dzu) at time taup1 (E system)
     real, dimension(:,:,:,:), _ALLOCATABLE :: rho_dzuL  _NULL ! L system contribution to rho_dzuT (3 time levels)
     real, dimension(:,:,:,:), _ALLOCATABLE :: rho_dzuT  _NULL ! rho (kg/m^3) * thickness (m) of U cell at 3 times (total)

     real, dimension(:,:,:),   _ALLOCATABLE :: rho_dzt_tendency _NULL ! rho_dzt tendency (kg/m^3)*(m/s)

     real, dimension(:,:),     _ALLOCATABLE :: sea_lev _NULL ! eta_t + patm/(rho0*grav) - eta_geoid - eta_tide (m) at time taup1 for coupler 

     real, dimension(:,:,:),   _ALLOCATABLE :: dzt    _NULL ! E system contribution to dztT
     real, dimension(:,:,:,:), _ALLOCATABLE :: dzten  _NULL ! E system contribution to dzt at east/north face of T-cell
     real, dimension(:,:,:),   _ALLOCATABLE :: dztL   _NULL ! L system contribution to dztT
     real, dimension(:,:,:,:), _ALLOCATABLE :: dztT   _NULL ! thickness (m) of T cell at time tau/taup1

     real, dimension(:,:,:),   _ALLOCATABLE :: dzu    _NULL ! E system contribution to dzuT
     real, dimension(:,:,:),   _ALLOCATABLE :: dzuL   _NULL ! L system contribution to dzuT
     real, dimension(:,:,:),   _ALLOCATABLE :: dzuT   _NULL ! thickness (m) of U cell at time tau/taup1

     real, dimension(:,:,:),   _ALLOCATABLE :: dzwt   _NULL ! E system contribution to dzwtT
     real, dimension(:,:,:),   _ALLOCATABLE :: dzwtL  _NULL ! L system contribution to dzwtT
     real, dimension(:,:,:),   _ALLOCATABLE :: dzwtT  _NULL ! vertical distance (m) between T points at tau/taup1

     real, dimension(:,:,:),   _ALLOCATABLE :: dzwu   _NULL ! E system contribution to dzwuT
     real, dimension(:,:,:),   _ALLOCATABLE :: dzwuL  _NULL ! L system contribution to dzwuT
     real, dimension(:,:,:),   _ALLOCATABLE :: dzwuT  _NULL ! vertical distance (m) between U points at tau/taup1

     real, dimension(:,:,:),   _ALLOCATABLE :: dztup  _NULL ! E system contribution to dztupT
     real, dimension(:,:,:),   _ALLOCATABLE :: dztupL _NULL ! L system contribution to dztupT
     real, dimension(:,:,:),   _ALLOCATABLE :: dztupT _NULL ! distance (m) from T-cell point to top of T-cell 

     real, dimension(:,:,:),   _ALLOCATABLE :: dztlo  _NULL ! E system contribution to dztloT
     real, dimension(:,:,:),   _ALLOCATABLE :: dztloL _NULL ! L system contribution to dztloT
     real, dimension(:,:,:),   _ALLOCATABLE :: dztloT _NULL ! distance (m) from T-cell point to bottom of T-cell

     real, dimension(:,:,:),   _ALLOCATABLE :: geodepth_zt  _NULL ! vert distance (m) from z=0 to T-point
     real, dimension(:,:,:),   _ALLOCATABLE :: geodepth_zwt _NULL ! vert distance (m) from z=0 to bottom of T-cell
     real, dimension(:,:,:),   _ALLOCATABLE :: depth_zt     _NULL ! vert distance (m) from column top to T-point
     real, dimension(:,:,:),   _ALLOCATABLE :: depth_zwt    _NULL ! vert distance (m) from column top to T-bottom
     real, dimension(:,:,:),   _ALLOCATABLE :: depth_zu     _NULL ! vert distance (m) from column top to U-point
     real, dimension(:,:,:),   _ALLOCATABLE :: depth_zwu    _NULL ! vert distance (m) from column top to U-bottom

     real, dimension(:,:,:),   _ALLOCATABLE :: depth_st    _NULL ! s-distance to T cell grid point
     real, dimension(:,:,:),   _ALLOCATABLE :: depth_swt   _NULL ! s-distance to T cell grid bottom
     real, dimension(:,:,:),   _ALLOCATABLE :: dst         _NULL ! s-increment of T-cell at time tau 
     real, dimension(:,:,:),   _ALLOCATABLE :: dswt        _NULL ! s-increment of T-point at time tau 
     real, dimension(:,:,:),   _ALLOCATABLE :: dzt_dst     _NULL ! T-cell specific thickness (m/s-coordinate)

     real, dimension(:,:,:),   _ALLOCATABLE :: dstlo       _NULL ! s-distance (s-units) from T-cell point to top of T-cell 
     real, dimension(:,:,:),   _ALLOCATABLE :: dstup       _NULL ! s-distance (s-units) from T-cell point to bottom of T-cell 

     real, dimension(:,:),     _ALLOCATABLE :: pbot0       _NULL ! reference bottom pressure (Pa) 
     real, dimension(:,:),     _ALLOCATABLE :: pbot0r      _NULL ! inverse of reference bottom pressure (1/Pa) 

     real, dimension(:,:,:),   _ALLOCATABLE :: mass_source _NULL ! mass source (kg/m^3)*(m/sec)  
     real, dimension(:,:),     _ALLOCATABLE :: blob_source _NULL ! mass source (sink) for the L system (E system)
     real, dimension(:,:,:),   _ALLOCATABLE :: mass_u      _NULL ! mass per area (kg/m^2) in a velocity column
     real, dimension(:,:,:),   _ALLOCATABLE :: mass_en     _NULL ! vertical sum rho_dzten (kg/m^2) 
     real, dimension(:,:,:),   _ALLOCATABLE :: mass_uT     _NULL ! mass per area (kg/m^2) in a velocity column
     real, dimension(:,:,:),   _ALLOCATABLE :: thicku      _NULL ! thickness on U-cell (metre) from z=eta_u to z=-H.
     real, dimension(:,:,:),   _ALLOCATABLE :: thicken     _NULL ! sum of dzten (metre)

  end type ocean_thickness_type


  type, public :: ocean_grid_type
     character(len=32) :: name

     ! geometry and topology and rotation
     logical                            :: cyclic_x          ! true if domain is cyclic in the i direction
     logical                            :: cyclic_y          ! true if domain is cyclic in the j direction
     logical                            :: tripolar          ! folded connectivity at "top" row w/i bipolar Arctic 
     logical                            :: mosaic            ! true when using a mosaic grid 
     logical                            :: beta_plane        ! beta plane Cartesian 
     logical                            :: f_plane           ! f-plane Cartesian
     real                               :: f_plane_latitude  ! latitude where f_plane is centered  
     real, dimension(:,:), _ALLOCATABLE :: f        _NULL ! coriolis parameter at u-cell points (sec^-1)
     real, dimension(:,:), _ALLOCATABLE :: fstar    _NULL ! horizontal coriolis parameter at u-cell points (sec^-1)
     real, dimension(:,:), _ALLOCATABLE :: beta     _NULL ! df/dy at u-cell points (1/(sec*m))     
     real, dimension(:,:), _ALLOCATABLE :: beta_eff _NULL ! df/dy plus topographic beta at u-cell (1/(sec*m))

     ! vertical grid information (time independent) 
     integer                               :: nk           ! number of vertical grid points 
     integer, dimension(:,:), _ALLOCATABLE :: kmt    _NULL ! number of t-levels
     integer, dimension(:,:), _ALLOCATABLE :: kmu    _NULL ! number of u-levels

     real,    dimension(:),   _ALLOCATABLE :: zt     _NULL ! distance from surface to grid point in level k (m) 
     real,    dimension(:),   _ALLOCATABLE :: zw     _NULL ! distance from surface down to bottom of level k (m) 
     real,    dimension(:),   _ALLOCATABLE :: dzt    _NULL ! initial vertical resolution of T or U grid cells (m) 
     real,    dimension(:),   _ALLOCATABLE :: dztlo  _NULL ! z-distance (m) from T-cell point to bottom of T-cell
     real,    dimension(:),   _ALLOCATABLE :: dztup  _NULL ! z-distance (m) from T-cell point to top of T-cell
     real,    dimension(:),   _ALLOCATABLE :: dzw    _NULL ! initial vertical resolution of W grid cells (m) 
     real,    dimension(:),   _ALLOCATABLE :: dzwr   _NULL ! reciprocal of dzw (W cell vertical resolution)

     real,    dimension(:),   _ALLOCATABLE :: st     _NULL ! s-distance from surface to grid point in level k  
     real,    dimension(:),   _ALLOCATABLE :: sw     _NULL ! s-distance from surface down to bottom of level k  
     real,    dimension(:),   _ALLOCATABLE :: dst    _NULL ! initial s-vertical resolution of T or U grid cells 
     real,    dimension(:),   _ALLOCATABLE :: dstlo  _NULL ! s-distance (s-units) from T-cell point to bottom of T-cell
     real,    dimension(:),   _ALLOCATABLE :: dstup  _NULL ! s-distance (s-units) from T-cell point to top of T-cell
     real,    dimension(:),   _ALLOCATABLE :: dsw    _NULL ! initial s-vertical resolution of W grid cells

     real,    dimension(:,:), _ALLOCATABLE :: fracdz _NULL ! fractional distance between grid point & cell top/bot 
     real,    dimension(:,:), _ALLOCATABLE :: ht     _NULL ! depth to bottom of ocean (m) on t-cells
     real,    dimension(:,:), _ALLOCATABLE :: htr    _NULL ! inverse depth to bottom of ocean (m^-1) on t-cells  
     real,    dimension(:,:), _ALLOCATABLE :: hu     _NULL ! depth to bottom of ocean (m) on u-cells  
     real,    dimension(:,:), _ALLOCATABLE :: dht_dx _NULL ! d(ht)/dx on u-cells (m/m) 
     real,    dimension(:,:), _ALLOCATABLE :: dht_dy _NULL ! d(ht)/dy on u-cells (m/m) 
     real,    dimension(:,:), _ALLOCATABLE :: gradH  _NULL ! sqrt(dht_dx**2+dht_dyx**2) on u-cells (m/m)

     ! horizontal grid information (time independent)
     integer                            :: ni, nj           ! global points in the two horizontal directions
     real, dimension(:,:), _ALLOCATABLE :: xt         _NULL ! longitude of the T grid points in degrees
     real, dimension(:,:), _ALLOCATABLE :: xu         _NULL ! longitude of the U grid points in degrees
     real, dimension(:,:), _ALLOCATABLE :: yt         _NULL ! latitude of the T grid points in degrees
     real, dimension(:,:), _ALLOCATABLE :: yu         _NULL ! latitude of the U grid points in degrees
     real, dimension(:,:), _ALLOCATABLE :: phiu       _NULL ! latitude of U grid point in radians
     real, dimension(:,:), _ALLOCATABLE :: phit       _NULL ! latitude of T grid point in radians
     real, dimension(:,:), _ALLOCATABLE :: h1t        _NULL ! metric factors in i grid direction
     real, dimension(:,:), _ALLOCATABLE :: h1u        _NULL ! metric factors in j grid jirection
     real, dimension(:,:), _ALLOCATABLE :: h2t        _NULL ! metric factors in i grid direction
     real, dimension(:,:), _ALLOCATABLE :: h2u        _NULL ! metric factors in j grid jirection
     real, dimension(:,:), _ALLOCATABLE :: dh2dx      _NULL ! (1/delta_y)*d(delta_y)/dx (1/m)
     real, dimension(:,:), _ALLOCATABLE :: dh1dy      _NULL ! (1/delta_x)*d(delta_x)/dy (1/m)
     real, dimension(:,:), _ALLOCATABLE :: dxt        _NULL ! longitudinal width of T-cells at grid point (m)
     real, dimension(:,:), _ALLOCATABLE :: dxu        _NULL ! longitudinal width of U-cells at grid point (m)
     real, dimension(:,:), _ALLOCATABLE :: dyt        _NULL ! latitudinal width of T-cells at grid point (m) 
     real, dimension(:,:), _ALLOCATABLE :: dyu        _NULL ! latitudinal width of U-cells at grid point (m)
     real, dimension(:,:), _ALLOCATABLE :: dau        _NULL ! area of U-cells (m^2)
     real, dimension(:,:), _ALLOCATABLE :: dat        _NULL ! area of T-cells (m^2)
     real, dimension(:,:), _ALLOCATABLE :: dat_frac   _NULL ! fraction of total wet area occuped by a T-cell (dimensionless)
     real, dimension(:,:), _ALLOCATABLE :: dxte       _NULL ! i-width between i+1 and i points in T-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: dxtn       _NULL ! i-width of north face of T-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: dyte       _NULL ! j-width of east  face of T-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: dytn       _NULL ! j-width between j+1 and j points in T-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: dxue       _NULL ! i-width between i+1 and i points in U-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: dxun       _NULL ! i-width of north face of U-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: dyue       _NULL ! j-width of east  face of U-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: dyun       _NULL ! j-width between j+1 and j points in U-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: datnr      _NULL ! reciprocal area at north face of T-cell
     real, dimension(:,:), _ALLOCATABLE :: dater      _NULL ! reciprocal area at east face of T-cell
     real, dimension(:,:), _ALLOCATABLE :: dun        _NULL ! width from grid point to north face of U-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: dus        _NULL ! width from grid point to south face of U-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: duw        _NULL ! width from grid point to west  face of U-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: due        _NULL ! width from grid point to east  face of U-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: dtn        _NULL ! width from grid point to north face of T-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: dts        _NULL ! width from grid point to south face of T-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: dtw        _NULL ! width from grid point to west  face of T-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: dte        _NULL ! width from grid point to east  face of T-cells (m)
     real, dimension(:,:), _ALLOCATABLE :: dxtr       _NULL ! 1/dxt
     real, dimension(:,:), _ALLOCATABLE :: dxur       _NULL ! 1/dxu
     real, dimension(:,:), _ALLOCATABLE :: dytr       _NULL ! 1/dyt
     real, dimension(:,:), _ALLOCATABLE :: dyur       _NULL ! 1/dyu
     real, dimension(:,:), _ALLOCATABLE :: daur       _NULL ! 1/[area of U-cells (m^2)]
     real, dimension(:,:), _ALLOCATABLE :: datr       _NULL ! 1/[area of T-cells (m^2)]
     real, dimension(:,:), _ALLOCATABLE :: dxter      _NULL ! 1/dxte
     real, dimension(:,:), _ALLOCATABLE :: dyter      _NULL ! 1/dyte
     real, dimension(:,:), _ALLOCATABLE :: dxtnr      _NULL ! 1/dxtn
     real, dimension(:,:), _ALLOCATABLE :: dytnr      _NULL ! 1/dytn
     real, dimension(:,:), _ALLOCATABLE :: dxuer      _NULL ! 1/dxue
     real, dimension(:,:), _ALLOCATABLE :: dxunr      _NULL ! 1/dxun
     real, dimension(:,:), _ALLOCATABLE :: dyuer      _NULL ! 1/dyue
     real, dimension(:,:), _ALLOCATABLE :: dyunr      _NULL ! 1/dyun
     real, dimension(:,:), _ALLOCATABLE :: dyue_dxuer _NULL ! dyue/dxue 
     real, dimension(:,:), _ALLOCATABLE :: dxun_dyunr _NULL ! dxun/dyun
     real, dimension(:,:), _ALLOCATABLE :: dxt_dxter  _NULL ! dxt/dxte
     real, dimension(:,:), _ALLOCATABLE :: dxte_dxtr  _NULL ! dxte/dxt
     real, dimension(:,:), _ALLOCATABLE :: dxt_dxtnr  _NULL ! dxt/dxtn
     real, dimension(:,:), _ALLOCATABLE :: dxtn_dxtr  _NULL ! dxtn/dxt
     real, dimension(:,:), _ALLOCATABLE :: dyt_dyter  _NULL ! dyt/dyte
     real, dimension(:,:), _ALLOCATABLE :: dyte_dytr  _NULL ! dyte/dyt
     real, dimension(:,:), _ALLOCATABLE :: dyt_dytnr  _NULL ! dyt/dytn
     real, dimension(:,:), _ALLOCATABLE :: dytn_dytr  _NULL ! dytn/dyt

     ! land/sea masks 
     real, dimension(:,:),     _ALLOCATABLE :: obc_tmask   _NULL ! land/sea mask for T cell diagnostics with OBC 
     real, dimension(:,:),     _ALLOCATABLE :: obc_umask   _NULL ! land/sea mask for U cell diagnostics with OBC
     real, dimension(:,:,:),   _ALLOCATABLE :: mask        _NULL ! land/sea tmask or umask depending on C/B grids 
     real, dimension(:,:,:),   _ALLOCATABLE :: tmask       _NULL ! land/sea mask for T cells based on s-coordinate
     real, dimension(:,:,:),   _ALLOCATABLE :: umask       _NULL ! land/sea mask for U cells based on s-coordinate
     real, dimension(:,:,:,:), _ALLOCATABLE :: tmasken     _NULL ! land/sea mask for east/north of t-cell based on s-coordinate
     real, dimension(:,:,:),   _ALLOCATABLE :: tmask_depth _NULL ! based on depth-based vert_coordinate
     real, dimension(:,:,:),   _ALLOCATABLE :: umask_depth _NULL ! based on depth-based vert_coordinate

     ! grid areas and volumes 
     real                              :: tcellv          ! initial T cell volume m^3 (entire ocean) 
     real                              :: ucellv          ! initial U cell volume m^3 (entire ocean)
     real                              :: tcellsurf       ! T cell surface area (k=1) (bitwise reproducible)
     real                              :: ucellsurf       ! U cell surface area (k=1) (bitwise reproducible)
     real, dimension(:), _ALLOCATABLE  :: tcella   _NULL  ! T cell surface area m^2 (entire ocean)
     real, dimension(:), _ALLOCATABLE  :: ucella   _NULL  ! U cell surface area m^2 (entire ocean)

     ! model grid information
     integer :: wet_t_points   ! total number of wet tracer points 
     integer :: wet_u_points   ! total number of wet velocity points 
     integer :: total_t_points ! total number of wet or dry tracer points  

     ! sine and cosine of rotation angles (clockwise) of velocity for tripolar 
     real, dimension(:,:), _ALLOCATABLE :: sin_rot  _NULL  
     real, dimension(:,:), _ALLOCATABLE :: cos_rot  _NULL  

     ! 1-d grid coordinates for COARDS NetCDF files
     real, dimension(:), _ALLOCATABLE  :: grid_x_t _NULL 
     real, dimension(:), _ALLOCATABLE  :: grid_y_t _NULL 
     real, dimension(:), _ALLOCATABLE  :: grid_x_u _NULL 
     real, dimension(:), _ALLOCATABLE  :: grid_y_u _NULL 

     ! axes id for diagnostic manager 
     integer, dimension(3)  :: tracer_axes        
     integer, dimension(3)  :: vel_axes_uv         
     integer, dimension(3)  :: vel_axes_u
     integer, dimension(3)  :: vel_axes_v         
     integer, dimension(3)  :: vel_axes_wu    
     integer, dimension(3)  :: vel_axes_wt    
     integer, dimension(3)  :: tracer_axes_wt 
     integer, dimension(3)  :: tracer_axes_flux_x  
     integer, dimension(3)  :: tracer_axes_flux_y  
     integer, dimension(3)  :: vel_axes_flux_x    
     integer, dimension(3)  :: vel_axes_flux_y    

     ! axes id for diagnostic manager, appropriate
     ! when with to remap native vertical fields 
     ! to depth or pressure levels.  Appropropriate
     ! when vert_coordinate == ZSIGMA or PSIGMA, or other 
     ! vertical coordinats whose iso-surfaces are 
     ! not quasi-horizontal 
     integer, dimension(3)  :: tracer_axes_depth        
     integer, dimension(3)  :: vel_axes_uv_depth
     integer, dimension(3)  :: vel_axes_u_depth
     integer, dimension(3)  :: vel_axes_v_depth
     integer, dimension(3)  :: vel_axes_wu_depth    
     integer, dimension(3)  :: vel_axes_wt_depth
     integer, dimension(3)  :: tracer_axes_wt_depth
     integer, dimension(3)  :: tracer_axes_flux_x_depth
     integer, dimension(3)  :: tracer_axes_flux_y_depth
     integer, dimension(3)  :: vel_axes_flux_x_depth
     integer, dimension(3)  :: vel_axes_flux_y_depth


  end type ocean_grid_type
  
  type, public :: ocean_domain_type
     type(domain2d) :: domain2d           ! fms variable, used by mpp routines
     integer :: isc, iec, jsc, jec        ! computational domain indices 
     integer :: isd, ied, jsd, jed        ! local indices, consistent with domain2d
     integer :: isg, ieg, jsg, jeg        ! global indices
     integer :: isa, iea, jsa, jea        ! active indices (for minimizing comm2d calls)
     integer :: xhalo, yhalo              ! halo sizes 
     integer :: xflags, yflags, layout(2) ! options to mpp_define_domains
     integer :: ioff, joff                ! offset to get absolute indices when MOM_STATIC_ARRAYS (0 otherwise)
     integer :: io_layout(2)              ! options to define io_domain.
     integer :: x_cyclic_offset           ! offset applied to x-direction cyclic boundary condition
     integer :: y_cyclic_offset           ! offset applied to y-direction cyclic boundary condition
     logical, pointer :: maskmap(:,:) =>NULL() ! option to mpp_define_domains
  end type ocean_domain_type

  type, public :: ocean_time_type
     type(time_type) :: model_time     ! fms variable
     type(time_type) :: time_step      ! ocean tracer timestep
     type(time_type) :: Time_init      ! time of initial conditions 
     integer :: calendar               ! calendar type defined by time_manager_mod
     logical :: init                   ! true at beginning of run (initial condition time)
     integer :: itt                    ! timestep counter measured relative to time at restart 
     integer :: itt0                   ! timestep counter measured relative to initial condition time
     integer :: taum1, tau, taup1      ! time level indices
     integer :: tau_m2, tau_m1, tau_m0 ! time level indices for Adams-Bashforth velocity advection and coriolis 
  end type ocean_time_type

  type, public :: ocean_adv_vel_type
     real, _ALLOCATABLE, dimension(:,:,:)  :: uhrho_et   _NULL ! rho_dzu weight advect vel (kg/(m*s)) on T-cell i-face
     real, _ALLOCATABLE, dimension(:,:,:)  :: vhrho_nt   _NULL ! rho_dzu weight advect vel (kg/(m*s)) on T-cell j-face
     real, _ALLOCATABLE, dimension(:,:,:)  :: uhrho_eu   _NULL ! remapped uhrho_et (kg/(m*s)) onto i-face of U-cell
     real, _ALLOCATABLE, dimension(:,:,:)  :: vhrho_nu   _NULL ! remapped vhrho_nt (kg/(m*s)) onto j-face of U-cell
     real, _ALLOCATABLE, dimension(:,:,:)  :: wrho_bt    _NULL ! rho weight (kg/(m^2*s)) vert advect vel on T-bottom
     real, _ALLOCATABLE, dimension(:,:,:)  :: wrho_bu    _NULL ! remapped wrho_bt onto U-bottom
     real, _ALLOCATABLE, dimension(:,:,:)  :: diverge_t  _NULL ! divergence on T-cell of horiz momentum per mass (kg/m3)*(m/s)
     real, _ALLOCATABLE, dimension(:,:,:)  :: diverge_u  _NULL ! divergence on U-cell of horiz momentum per mass (kg/m3)*(m/s)
  end type ocean_adv_vel_type


  type, public ::  ocean_density_type
     logical                                :: use_teos10              ! for using the TEOS-2010 equation of state recommendations 
     real, _ALLOCATABLE, dimension(:,:,:,:) :: rho               _NULL ! in situ density (kg/m^3) at time levels
     real, _ALLOCATABLE, dimension(:,:,:,:) :: rho_salinity      _NULL ! salinity used in density calculations (psu or g/kg) 
     real, _ALLOCATABLE, dimension(:,:,:)   :: rho_dztr_tau      _NULL ! rho_dztr at time tau 1/(kg/m^3) (for diagnostic uses) 
     real, _ALLOCATABLE, dimension(:,:,:)   :: rhoT              _NULL ! combined L and E in situ density (kg/m^3)
     real, _ALLOCATABLE, dimension(:,:,:)   :: rho_fresh         _NULL ! in situ fresh water density (kg/m^3) at tau
     real, _ALLOCATABLE, dimension(:,:,:)   :: pressure_at_depth _NULL ! hydrostatic pressure (including patm)
     real, _ALLOCATABLE, dimension(:,:,:)   :: drhodT            _NULL ! partial rho wrt theta (kg/(m^3 C)
     real, _ALLOCATABLE, dimension(:,:,:)   :: drhodS            _NULL ! partial rho wrt salinity (kg/(m3 psu)
     real, _ALLOCATABLE, dimension(:,:,:)   :: dpotrhodT         _NULL ! partial potrho wrt theta (kg/(m^3 C)
     real, _ALLOCATABLE, dimension(:,:,:)   :: dpotrhodS         _NULL ! partial potrho wrt salinity (kg/(m3 psu)
     real, _ALLOCATABLE, dimension(:,:,:)   :: dpotrhodP         _NULL ! partial potrho wrt pressure (kg/(m3 psu)
     real, _ALLOCATABLE, dimension(:,:,:)   :: drhodP            _NULL ! partial rho wrt pressure (kg/(m3 Pa)
     real, _ALLOCATABLE, dimension(:,:,:)   :: drhodz_wt         _NULL ! d(neutral rho)/dz (kg/m^4) at W-point
     real, _ALLOCATABLE, dimension(:,:,:)   :: drhodz_zt         _NULL ! d(neutral rho)/dz (kg/m^4) at T-point
     real, _ALLOCATABLE, dimension(:,:,:)   :: drhodx_zt         _NULL ! d(neutral rho)/dx (kg/m^4) at T-point
     real, _ALLOCATABLE, dimension(:,:,:)   :: drhody_zt         _NULL ! d(neutral rho)/dy (kg/m^4) at T-point
     real, _ALLOCATABLE, dimension(:,:,:)   :: drhodz_diag       _NULL ! regularized drhodz_zt for diagnostics 
     real, _ALLOCATABLE, dimension(:,:,:)   :: dTdz_zt           _NULL ! partial theta wrt z  (C/m) at T-point
     real, _ALLOCATABLE, dimension(:,:,:)   :: dSdz_zt           _NULL ! partial salinity wrt z  (psu/m) at T-point
     real, _ALLOCATABLE, dimension(:,:,:)   :: potrho            _NULL ! potential density (kg/m^3)
     real, _ALLOCATABLE, dimension(:,:,:)   :: neutralrho        _NULL ! neutral density (kg/m^3)
     real, _ALLOCATABLE, dimension(:,:,:)   :: watermass_factor      _NULL ! ratio |grad nrho|/|grad local ref potrho|*/delta(gamma)
     real, _ALLOCATABLE, dimension(:,:,:)   :: stratification_factor _NULL ! ratio |grad nrho|/|grad local ref potrho|*/delta(gamma)
     real, _ALLOCATABLE, dimension(:,:)     :: mld_subduction        _NULL ! depth mixed layer base (m) for subduction diagnostics 
     real, _ALLOCATABLE, dimension(:)       :: theta_ref             _NULL ! partition vertical into theta classes 
     real, _ALLOCATABLE, dimension(:)       :: theta_bounds          _NULL ! bounds for theta classes 
     real, _ALLOCATABLE, dimension(:)       :: potrho_ref            _NULL ! partition vertical into potrho classes 
     real, _ALLOCATABLE, dimension(:)       :: potrho_bounds         _NULL ! bounds for potrho classes 
     real, _ALLOCATABLE, dimension(:)       :: neutralrho_ref        _NULL ! partition vertical into neutral density classes 
     real, _ALLOCATABLE, dimension(:)       :: neutralrho_bounds     _NULL ! bounds for neutral density classes 
     integer, dimension(3)                  :: potrho_axes             ! axis ids for diagnosing potential density 
     integer, dimension(3)                  :: potrho_axes_flux_x          ! axis ids for diagnosing x-flux
     integer, dimension(3)                  :: potrho_axes_flux_y          ! axis ids for diagnosing y-flux
     integer, dimension(3)                  :: neutralrho_axes         ! axis ids for diagnosing neutral density 
     integer, dimension(3)                  :: neutralrho_axes_flux_x      ! axis ids for diagnosing x-flux 
     integer, dimension(3)                  :: neutralrho_axes_flux_y      ! axis ids for diagnosing y-flux 
     integer, dimension(3)                  :: theta_axes              ! axis ids for potential temperature 
     integer, dimension(3)                  :: theta_axes_flux_x           ! axis ids for diagnosing x-flux 
     integer, dimension(3)                  :: theta_axes_flux_y           ! axis ids for diagnosing y-flux 
  end type ocean_density_type
  
  type, public :: ocean_prog_tracer_type
     character(len=32)  :: name
     character(len=128) :: units
     character(len=128) :: type
     character(len=128) :: longname

     logical :: use_only_advection      ! for testing purposes, evolve using ONLY advection
     logical :: neutral_physics_limit   ! revert neutral physics to horz diffusion where tracer out of bounds
     logical :: complete                ! to determine if ready to do mpp updates

     integer :: sfc_flux_id=-1          ! index for time_interp_external
     integer :: horz_advect_scheme=-1   ! id for horizontal advection scheme
     integer :: vert_advect_scheme=-1   ! id for vertical advection scheme
     integer :: id_obc                  ! id to identify tracer in OBC-subroutines
     integer :: ppm_hlimiter=1          ! Limiter for use with PPM in horizontal
     integer :: ppm_vlimiter=1          ! Limiter for use with PPM in vertical
     integer :: mdt_scheme=4            ! Version of Multi-Dim. Modified Daru & Tenaud (MDMDT)

     real, _ALLOCATABLE, dimension(:,:,:,:) :: field          _NULL ! tracer concentration at 3 time levels (E system)
     real, _ALLOCATABLE, dimension(:,:,:)   :: fieldT         _NULL ! Total tracer concentration
     real, _ALLOCATABLE, dimension(:,:,:)   :: th_tendency    _NULL ! thickness weighted tracer tendency
     real, _ALLOCATABLE, dimension(:,:,:)   :: tendency       _NULL ! for diagnostics: tendency concentration [concentration/sec]
     real, _ALLOCATABLE, dimension(:,:,:)   :: source         _NULL ! tracer source [=tracer concentration per time]
     real, _ALLOCATABLE, dimension(:,:)     :: eta_smooth     _NULL ! tendency from eta_t smoother  
     real, _ALLOCATABLE, dimension(:,:)     :: pbot_smooth    _NULL ! tendency from pbot_t smoother  

     real, _ALLOCATABLE, dimension(:,:,:)   :: wrk1                _NULL ! work array
     real, _ALLOCATABLE, dimension(:,:,:)   :: tmask_limit         _NULL ! to limit advective and/or neutral physics flux
     real, _ALLOCATABLE, dimension(:,:,:)   :: K33_implicit        _NULL ! m^2/sec vert-diffusivity from neutral diffusion 
     real, _ALLOCATABLE, dimension(:,:,:)   :: radiation           _NULL ! radiation absorbed within a cell [W/m^2]
     real, _ALLOCATABLE, dimension(:,:)     :: stf                 _NULL ! surface tracer flux [rho*m/sec*tracer concen]
     real, _ALLOCATABLE, dimension(:,:)     :: btf                 _NULL ! bottom tracer flux [rho*m/sec*tracer concen]
     real, _ALLOCATABLE, dimension(:,:)     :: tpme                _NULL ! tracer concentration in precip-evap
     real, _ALLOCATABLE, dimension(:,:)     :: triver              _NULL ! tracer concentration in river(=runoff+calving) 
     real, _ALLOCATABLE, dimension(:,:)     :: trunoff             _NULL ! tracer concentration in river runoff 
     real, _ALLOCATABLE, dimension(:,:)     :: tcalving            _NULL ! tracer concentration in calving lang ice
     real, _ALLOCATABLE, dimension(:,:)     :: runoff_tracer_flux  _NULL ! flux in liquid runoff (e.g., kg*degC/(m^2 s) for temp)
     real, _ALLOCATABLE, dimension(:,:)     :: calving_tracer_flux _NULL ! flux in solid runoff (e.g., kg*psu/(m^2 s) for salt)
     real, _ALLOCATABLE, dimension(:,:)     :: riverdiffuse        _NULL ! where to enhance diff_cbt according to rivers
     real, _ALLOCATABLE, dimension(:,:)     :: flux_int            _NULL ! integrated sfc tracer flux for diagnostics
     real, _ALLOCATABLE, dimension(:,:,:,:) :: sum_blob            _NULL ! tracer content [concentration*kg] from the L system
     real, _ALLOCATABLE, dimension(:,:,:)   :: tend_blob           _NULL ! blob contribution to dat*th_tendency

     ! variables for prather second order moment advection
     logical :: psom_limit                             ! controls whether a limiter is placed on the prather flux
     real, dimension(:,:,:), _ALLOCATABLE :: s0  _NULL ! zeroth moment (mean)
     real, dimension(:,:,:), _ALLOCATABLE :: sx  _NULL ! 1st moment in i direction
     real, dimension(:,:,:), _ALLOCATABLE :: sxx _NULL ! 2nd moment in i direction
     real, dimension(:,:,:), _ALLOCATABLE :: sy  _NULL ! 1st moment in j direction
     real, dimension(:,:,:), _ALLOCATABLE :: syy _NULL ! 2nd moment in j direction
     real, dimension(:,:,:), _ALLOCATABLE :: sz  _NULL ! 1st moment in k direction
     real, dimension(:,:,:), _ALLOCATABLE :: szz _NULL ! 2nd moment in k direction
     real, dimension(:,:,:), _ALLOCATABLE :: sxy _NULL ! 2nd moment for coupling the i and j directions
     real, dimension(:,:,:), _ALLOCATABLE :: sxz _NULL ! 2nd moment for coupling the i and k directions
     real, dimension(:,:,:), _ALLOCATABLE :: syz _NULL ! 2nd moment for coupling the j and k directions

     type(obc_flux), _ALLOCATABLE, dimension(:) :: otf      _NULL ! flux through open boundaries, allocate nobc

     real                              :: conversion            ! conversion between  dimensions  
     real                              :: offset                ! offset in dimensions (e.g., Celsius to Kelvin)
     real                              :: min_tracer            ! min acceptable value used for error checking 
     real                              :: max_tracer            ! max acceptable value used for error checking 
     real                              :: min_range             ! min value used for calls to diagnostic manager
     real                              :: max_range             ! max value used for calls to diagnostic manager
     real                              :: min_tracer_limit      ! min value used to limit quicker & neutral fluxes
     real                              :: max_tracer_limit      ! max value used to limit quicker & neutral fluxes 
     real                              :: min_flux_range        ! min and max values used for flux diagnostics
     real                              :: max_flux_range        ! min and max values used for flux diagnostics
     real                              :: const_init_value      ! value used to initialize constant tracer
     logical                           :: const_init_tracer     ! false (default) if the tracer must exist in the restart file
                                                                !   otherwise will initialize with const_init_value
     character(len=128)                :: flux_units            ! units for the tracer flux
     character(len=128)                :: restart_file          ! name for restart file
  end type ocean_prog_tracer_type

  type, public :: ocean_diag_tracer_type
     character(len=32)  :: name
     character(len=128) :: units, type
     character(len=128) :: longname
     real, dimension(:,:,:), pointer  :: field       ! tracer concentration at single time level 
     real :: conversion                              ! conversion between dimensions  
     real :: offset                                  ! offset in dimensions (e.g., Celsius to Kelvin)
     real :: min_tracer, max_tracer                  ! min and max acceptable values used for error checking 
     real :: min_range, max_range                    ! min and max values used for diagnostics
     logical :: const_init_tracer                    ! false (default) if the tracer must exist in the restart file
                                                     !   otherwise will initialize with const_init_value
     character(len=128) :: restart_file              ! name for restart file
     real               :: const_init_value          ! value used to initialize constant tracer
  end type ocean_diag_tracer_type

  type, public :: ocean_velocity_type
     logical                                  :: bmf_implicit      ! is true when time stepping bmf implicitly
     real, _ALLOCATABLE, dimension(:,:,:,:,:) :: u               _NULL ! horz velocity (m/s) in i,j directions at 3 time levels
     real, _ALLOCATABLE, dimension(:,:,:)     :: smf             _NULL ! momentum flux into ocn surface (N/m^2) at uv point
     real, _ALLOCATABLE, dimension(:,:,:)     :: smf_bgrid       _NULL ! momentum flux into ocn surface (N/m^2) at Bgrid uv point
     real, _ALLOCATABLE, dimension(:,:,:)     :: smf_cgrid       _NULL ! momentum flux into ocn surface (N/m^2) at Cgrid u/v points
     real, _ALLOCATABLE, dimension(:,:,:)     :: bmf             _NULL ! momentum flux per mass into ocean bottom  (N/m^2)
     real, _ALLOCATABLE, dimension(:,:)       :: ustar           _NULL ! surface friction velocity (m/s)
     real, _ALLOCATABLE, dimension(:,:)       :: gamma           _NULL ! dimensionful bottom drag coefficient (kg/(m^2 sec))
     real, _ALLOCATABLE, dimension(:,:)       :: langmuirfactor  _NULL ! Langmuir turbulence enhancement factor
     real, _ALLOCATABLE, dimension(:,:)       :: u10             _NULL ! 10m wind speed (m/s)
     real, _ALLOCATABLE, dimension(:,:)       :: ustoke          _NULL ! x-dir surface stokes drift
     real, _ALLOCATABLE, dimension(:,:)       :: vstoke          _NULL ! y-dir surface stokes drift
     real, _ALLOCATABLE, dimension(:,:)       :: wavlen          _NULL ! wave length
     real, _ALLOCATABLE, dimension(:,:)       :: cdbot_array     _NULL ! dimensionless static bottom drag coefficient
     real, _ALLOCATABLE, dimension(:,:)       :: current_wave_stress _NULL !wave-current bottom stress for sediment dynamics (N/m^2)
     real, _ALLOCATABLE, dimension(:,:)       :: rossby_radius   _NULL ! first baroclinic rossby radius (m)
     real, _ALLOCATABLE, dimension(:,:)       :: stokes_depth    _NULL ! depth scale (m) for exp decay of surface wave Stokes vel
     real, _ALLOCATABLE, dimension(:,:,:,:)   :: stokes_drift    _NULL ! Stokes drift velocity (m/s) from surface wave model 
     real, _ALLOCATABLE, dimension(:,:,:,:)   :: stokes_force    _NULL ! Coriolis force from Stokes drift velocity (N/m2)
     real, _ALLOCATABLE, dimension(:,:,:,:)   :: press_force     _NULL ! rho*dz*horz (i,j)-directed press force (N/m^2)
     real, _ALLOCATABLE, dimension(:,:,:,:)   :: accel           _NULL ! rho*dz*velocity (i,j)-directed acceleration (N/m^2)
     real, _ALLOCATABLE, dimension(:,:,:,:)   :: vfrict_impl     _NULL ! rho*dz*vertical friction (N/m^2)
     real, _ALLOCATABLE, dimension(:,:,:,:)   :: source          _NULL ! thickness*density weighted velocity source/sink (N/m^2)
     real, _ALLOCATABLE, dimension(:,:,:,:)   :: wrkv            _NULL ! work array 
     real, _ALLOCATABLE, dimension(:,:,:,:,:) :: advection       _NULL ! rho*dz*velocity advection tendency (N/m^2)
     real, _ALLOCATABLE, dimension(:,:,:,:,:) :: coriolis        _NULL ! rho*dz*velocity Cgrid coriolis tendency (N/m^2)
     real, _ALLOCATABLE, dimension(:,:,:)     :: lap_friction_bt _NULL ! friction just on barotropic (N/m^2)
     real, _ALLOCATABLE, dimension(:,:,:)     :: bih_friction_bt _NULL ! friction just on barotropic (N/m^2)
  end type ocean_velocity_type


  type, public :: ocean_external_mode_type
     real, _ALLOCATABLE, dimension(:,:,:)   :: eta_t        _NULL ! surface height on tracer cell center (m) 
     real, _ALLOCATABLE, dimension(:,:,:)   :: eta_u        _NULL ! surface height on tracer cell center (m)
     real, _ALLOCATABLE, dimension(:,:,:)   :: eta_t_bar    _NULL ! eta_t time averaged over ext-mode time steps (m)
     real, _ALLOCATABLE, dimension(:,:)     :: deta_dt      _NULL ! surface height time tendency on t-cell (m/s)

     real, _ALLOCATABLE, dimension(:,:,:)   :: pbot_t     _NULL ! bottom pressure on tracer cell center (Pa) 
     real, _ALLOCATABLE, dimension(:,:,:)   :: pbot_u     _NULL ! bottom pressure on velocity cell center (Pa) 
     real, _ALLOCATABLE, dimension(:,:,:)   :: anompb     _NULL ! pbot_t_rho0*grav*ht (Pa) = anomalous bottom pressure (m^2/s^2)
     real, _ALLOCATABLE, dimension(:,:,:)   :: anompb_bar _NULL ! pbot_t-rho0*grav*ht (Pa) time avg over ext-mode time steps 
     real, _ALLOCATABLE, dimension(:,:)     :: dpbot_dt   _NULL ! bottom pressure time tendency on tracer cell (Pa/s)

     real, _ALLOCATABLE, dimension(:,:,:)   :: patm_t           _NULL ! ice plus atmospheric press on tracer cell (Pa)
     real, _ALLOCATABLE, dimension(:,:)     :: patm_for_sea_lev _NULL ! ice plus atmospheric press on tracer cell, to coupler (Pa)
     real, _ALLOCATABLE, dimension(:,:)     :: patm_u           _NULL ! ice plus atmospheric press on velocity cell (Pa)
     real, _ALLOCATABLE, dimension(:,:)     :: dpatm_dt         _NULL ! time tendency of patm on T-cell(Pa/s)

     real, _ALLOCATABLE, dimension(:,:,:)   :: forcing_bt _NULL ! depth integrated forcing of barotropic (w/o coriolis)
     real, _ALLOCATABLE, dimension(:,:,:,:) :: udrho      _NULL ! vertically integrated & rho wghted horz velocity (kg/m^3)*(m^2/s)
     real, _ALLOCATABLE, dimension(:,:,:)   :: conv_rho_ud_t  _NULL ! convergence of sum_k(rho*dzt*u) on T-cell (kg/m^3)*(m/s)
     real, _ALLOCATABLE, dimension(:,:)     :: ps             _NULL ! surface pressure (pressure at z=0 due to eta_t) at time tau
     real, _ALLOCATABLE, dimension(:,:,:)   :: grad_ps        _NULL ! rho0r * horizontal surface pressure gradient at time tau
     real, _ALLOCATABLE, dimension(:,:,:)   :: grad_anompb    _NULL ! gradient of anompb (Pa/m)
     real, _ALLOCATABLE, dimension(:,:,:)   :: press_force    _NULL ! pressure force/area (N/m^2) updated each barotropic time step  

     real, _ALLOCATABLE, dimension(:,:)     :: conv_blob      _NULL ! water column divergence of the L system

     real, _ALLOCATABLE, dimension(:,:)     :: source         _NULL ! density weighted vertical integral of mass source (kg/m^2/sec)
     real, _ALLOCATABLE, dimension(:,:)     :: eta_smooth     _NULL ! (kg/m^3)*(m/s) from eta_t smoother 
     real, _ALLOCATABLE, dimension(:,:)     :: pbot_smooth    _NULL ! (kg/m^3)*(m/s) from pbot_t smoother 

     real, _ALLOCATABLE, dimension(:,:,:)   :: eta_nonbouss   _NULL ! diagnosed eta (m) including steric effects
     real, _ALLOCATABLE, dimension(:,:,:)   :: eta_nonsteric  _NULL ! diagnosed piece of eta_nonbouss (m) from non-steric effects 
     real, _ALLOCATABLE, dimension(:,:,:)   :: eta_steric     _NULL ! diagnosed eta_nonbouss (m) from steric effects 
     real, _ALLOCATABLE, dimension(:,:,:)   :: eta_dynamic    _NULL ! diagnosed eta_nonbouss (m) from "dynamic" effects 
     real, _ALLOCATABLE, dimension(:,:,:)   :: eta_water      _NULL ! diagnosed eta_nonbouss (m) from water forcing at boundaries 
     real, _ALLOCATABLE, dimension(:,:,:)   :: eta_source     _NULL ! diagnosed eta_nonbouss (m) from source term  
     real, _ALLOCATABLE, dimension(:,:,:)   :: eta_surf_temp  _NULL ! diagnosed eta_nonbouss (m) arising from surface temp flux
     real, _ALLOCATABLE, dimension(:,:,:)   :: eta_surf_salt  _NULL ! diagnosed eta_nonbouss (m) arising from surface salt flux
     real, _ALLOCATABLE, dimension(:,:,:)   :: eta_surf_water _NULL ! diagnosed eta_nonbouss (m) arising from surface water flux
     real, _ALLOCATABLE, dimension(:,:,:)   :: eta_bott_temp  _NULL ! diagnosed eta_nonbouss (m) arising from bottom temp flux
  end type ocean_external_mode_type


  ! types used by neutral physics 
  type, public :: tracer_2d_type
    real, _ALLOCATABLE, dimension(:,:)   :: field  _NULL
  end type tracer_2d_type

  type, public :: tracer_3d_0_nk_type
    real, _ALLOCATABLE, dimension(:,:,:) :: field  _NULL
  end type tracer_3d_0_nk_type

  type, public :: tracer_3d_1_nk_type
    real, _ALLOCATABLE, dimension(:,:,:) :: field  _NULL
  end type tracer_3d_1_nk_type


  ! for gotm vertical mixing scheme 
  type, public :: ocean_gotm_type
     character(len=32)  :: name
     character(len=32)  :: units
     character(len=128) :: longname
     real               :: min_value ! minimum value
     real               :: max_value ! maximum value
     real, _ALLOCATABLE, dimension(:,:,:,:) :: field  _NULL ! scalar at 2 time levels
  end type ocean_gotm_type

  ! advection tendency for GOTM scalar fields 
  type, public  :: advect_gotm_type  
    real, dimension(:,:,:), pointer :: field => NULL() 
  end type advect_gotm_type


#endif
!############################################################################################
! end of STATIC_MEMORY

  type, public :: ocean_lagrangian_type
     real, _ALLOCATABLE, dimension(:,:,:) :: rho_dztlo _NULL ! L system denisty*volume/dat
     real, _ALLOCATABLE, dimension(:,:,:) :: rho_dztup _NULL ! L system denisty*volume/dat
     real, _ALLOCATABLE, dimension(:,:,:) :: conv_blob _NULL ! the convergence of blobs in a water column; 
                                                             ! used for surface height and bottom pressure
  end type ocean_lagrangian_type


  type, public :: ice_ocean_boundary_type
     real, pointer, dimension(:,:) :: u_flux          =>NULL() ! i-directed wind stress into ocean (Pa) 
     real, pointer, dimension(:,:) :: v_flux          =>NULL() ! j-directed wind stress into ocean (Pa) 
     real, pointer, dimension(:,:) :: t_flux          =>NULL() ! sensible heat flux into ocean (W/m2) 
     real, pointer, dimension(:,:) :: q_flux          =>NULL() ! specific humidity flux (kg/m2/s)
     real, pointer, dimension(:,:) :: salt_flux       =>NULL() ! salt flux (kg/m2/s)
     real, pointer, dimension(:,:) :: lw_flux         =>NULL() ! long wave radiation (W/m2)
     real, pointer, dimension(:,:) :: sw_flux_vis_dir =>NULL() ! direct visible sw radiation (W/m2)
     real, pointer, dimension(:,:) :: sw_flux_vis_dif =>NULL() ! diffuse visible sw radiation (W/m2) 
     real, pointer, dimension(:,:) :: sw_flux_nir_dir =>NULL() ! direct near IR sw radiation (W/m2)
     real, pointer, dimension(:,:) :: sw_flux_nir_dif =>NULL() ! diffuse near IR sw radiation (W/m2) 
     real, pointer, dimension(:,:) :: lprec           =>NULL() ! mass flux of liquid precip (kg/m2/s)
     real, pointer, dimension(:,:) :: fprec           =>NULL() ! mass flux of frozen precip (kg/m2/s)
     real, pointer, dimension(:,:) :: runoff          =>NULL() ! mass flux of liquid runoff (kg/m2/s) 
     real, pointer, dimension(:,:) :: calving         =>NULL() ! mass flux of frozen runoff (kg/m2/s) 
     real, pointer, dimension(:,:) :: runoff_hflx     =>NULL() ! heat flux, relative to 0C, of liquid land water into ocean (W/m2) 
     real, pointer, dimension(:,:) :: calving_hflx    =>NULL() ! heat flux, relative to 0C, of frozen land water into ocean (W/m2) 
     real, pointer, dimension(:,:) :: p               =>NULL() ! pressure of overlying sea ice and atmosphere (Pa)
     real, pointer, dimension(:,:) :: mi              =>NULL() ! mass of overlying sea ice 
     real, pointer, dimension(:,:) :: langmuirfactor  =>NULL() ! langmuir turbulence boost factor (non-dimensional)
     real, pointer, dimension(:,:) :: ustoke          =>NULL() ! x-dir surface stokes drift
     real, pointer, dimension(:,:) :: vstoke          =>NULL() ! y-dir surface stokes drift
     real, pointer, dimension(:,:) :: wavlen          =>NULL() ! wave length
#if defined(ACCESS_CM) || defined(ACCESS_OM)
     real, pointer, dimension(:,:) :: aice             =>NULL() !  ice fraction
     real, pointer, dimension(:,:) :: mh_flux          =>NULL() ! heat flux from melting ice (W/m^2)
     real, pointer, dimension(:,:) :: wfimelt          =>NULL() ! water flux from melting ice (kg/m^2/s)
     real, pointer, dimension(:,:) :: wfiform          =>NULL() ! water flux from forming ice (kg/m^2/s)
     real, pointer, dimension(:,:) :: licefw           =>null() ! waterflux into ocean (kg/m2/s) off Antarctica and Greenland
     real, pointer, dimension(:,:) :: liceht           =>null() ! heatflux due to land ice melt (W/m2)
#endif
#if defined(ACCESS_CM)
     real, pointer, dimension(:,:) :: co2              =>NULL() ! co2
#endif
     real, pointer, dimension(:,:) :: wnd              =>NULL() ! wind speed
     integer :: xtype                                          ! REGRID, REDIST or DIRECT

     type(coupler_2d_bc_type)      :: fluxes                   ! array of fields used for additional tracers
  end type ice_ocean_boundary_type


  ! for communication with FMS coupler and ESMF coupler 
  type, public ::  ocean_public_type 
     type(domain2d) :: Domain

     ! ESMF requires these arrays to be pointers 
     real, pointer, dimension(:,:)    :: t_surf  =>NULL() ! SST on t-cell (degrees Kelvin)
     real, pointer, dimension(:,:)    :: s_surf  =>NULL() ! SSS on t-cell (psu)
     real, pointer, dimension(:,:)    :: u_surf  =>NULL() ! i-directed surface ocean velocity on u-cell (m/s)
     real, pointer, dimension(:,:)    :: v_surf  =>NULL() ! j-directed surface ocean velocity on u-cell (m/s)
     real, pointer, dimension(:,:)    :: sea_lev =>NULL() ! eta_t + patm/(rho0*grav) - eta_geoid - eta_tide (m) 
     real, pointer, dimension(:,:)    :: frazil  =>NULL() ! accumulated heating (J/m^2) from 
                                                          ! frazil formation in the ocean 
     real, pointer, dimension(:,:)    :: area    =>NULL() ! T-cell area.
#if defined(ACCESS_CM) || defined(ACCESS_OM)
     real, pointer, dimension(:,:,:)  :: gradient =>NULL() ! x/y slopes of sea surface.
#endif
#if defined(ACCESS_CM)
     real, pointer, dimension(:,:)    :: co2     =>NULL() ! co2 ( )
     real, pointer, dimension(:,:)    :: co2flux =>NULL() ! co2 flux ()
#endif
     logical, pointer, dimension(:,:) :: maskmap =>NULL()! A pointer to an array indicating which
                                                         ! logical processors are actually used for
                                                         ! the ocean code. The other logical
                                                         ! processors would be all land points and
                                                         ! are not assigned to actual processors.
                                                         ! This need not be assigned if all logical
                                                         ! processors are used.
     integer, pointer, dimension(:) :: pelist  =>NULL()  ! Used for flux-exchange.
     integer                        :: avg_kount         ! Used for accumulating averages - can be omitted?
     logical                        :: is_ocean_pe       ! .true. on processors that run the ocean model.
     integer, dimension(3)          :: axes              ! for diagnostics     
     type(coupler_2d_bc_type)       :: fields            ! array of fields used for additional tracers
  end type ocean_public_type

type, public :: ocean_blob_type
   ! Note that if an allocatable array is added, free_blob_memory in the ocean_blob_util module 
   ! must be edited to ensure complete deallocation of blobs occurs
   integer :: i, j, k         ! blobs current tracer grid box
   integer :: m, kdw          ! indices for the overflow scheme
   integer :: kup             ! indices for the overflow scheme
   integer :: hash, number    ! for sorting blobs
   integer :: model_steps     ! number of Eulerian model steps
   integer :: nsteps          ! total number of steps
   logical :: sink            ! whether the blob sinks or rises
   logical :: new             ! if the blob is newly created
   real    :: h1, h2          ! stretching coefficients
   real    :: lat, lon        ! current horizontal location of blob
   real    :: depth, geodepth ! current depth of blob
   real    :: st
   real    :: mass            ! current mass of blob
   real    :: density         ! current density of a blob
   real    :: densityr        ! 1./density
   real    :: volume          ! current volume of a blob
   real    :: height          ! height of the blob (m)
   real    :: step            ! time step size
   real    :: blob_time       ! blob time relative to last E system time step
   real    :: ent             ! entrainment velocity (m/s)
   real    :: det             ! detrainment velocity (m/s)
   real    :: richardson      ! Richardson number
   real    :: drag            ! Rayleigh drag coefficient (1/s)
   real    :: gprime          ! The reduced gravity (for diagnostics; m/s^2)
   real    :: age             ! Age of the blob (for diagnostics; seconds)
   integer :: nfrac_steps     ! number of fractional steps taken in one E step
   type(ocean_blob_type), pointer :: next ! next blob in the list
   type(ocean_blob_type), pointer :: prev ! previous blob in the list
   real,    _ALLOCATABLE, dimension(:)   :: tracer      ! current tracer content of blob
   real,    _ALLOCATABLE, dimension(:)   :: field       ! current tracer concentration of blob
   real,                  dimension(3)   :: v           ! blob's velocity (u,v,w)
   integer, _ALLOCATABLE, dimension(:)   :: di, dj, dk  ! grid cells where properties need to be communicated to E system
   real                                  :: dmass       ! change in mass
   real,    _ALLOCATABLE, dimension(:)   :: dtracer     ! change in tracer
   real,    _ALLOCATABLE, dimension(:,:) :: entrainment ! changes due to entrainment
   real,    _ALLOCATABLE, dimension(:,:) :: detrainment ! changes due to detrainment
   real,    _ALLOCATABLE, dimension(:)   :: mass_in(:)  ! mass into a grid cell
   real,    _ALLOCATABLE, dimension(:)   :: mass_out(:) ! mass out of a grid cell
end type ocean_blob_type

type, public :: blob_grid_type
   integer :: nk_nj                           ! nk*nj
   integer :: pe_this, pe_E, pe_W, pe_N, pe_S ! MPI PE identifiers
   integer :: pe_NE, pe_NW, pe_SE, pe_SW      ! MPI PE identifiers
   real,    _ALLOCATABLE, dimension(:,:,:) :: ht
   real,    _ALLOCATABLE, dimension(:,:,:) :: hu
   integer, _ALLOCATABLE, dimension(:,:,:) :: uidx
   integer, _ALLOCATABLE, dimension(:,:,:) :: tidx
   integer, _ALLOCATABLE, dimension(:)     :: it
   integer, _ALLOCATABLE, dimension(:)     :: jt
   integer, _ALLOCATABLE, dimension(:)     :: iu
   integer, _ALLOCATABLE, dimension(:)     :: ju
   real,    _ALLOCATABLE, dimension(:)     :: minlon
   real,    _ALLOCATABLE, dimension(:)     :: maxlon
   real,    _ALLOCATABLE, dimension(:)     :: minlat
   real,    _ALLOCATABLE, dimension(:)     :: maxlat
end type blob_grid_type

type, public :: blob_diag_type
   real, _ALLOCATABLE, dimension(:,:,:) :: entrainment
   real, _ALLOCATABLE, dimension(:,:,:) :: detrainment
   real, _ALLOCATABLE, dimension(:,:,:) :: new
   real, _ALLOCATABLE, dimension(:,:,:) :: dstry
end type blob_diag_type



public ocean_types_init
 
contains 


!#######################################################################
! <SUBROUTINE NAME="ocean_types_init">
!
! <DESCRIPTION>
! Initialize the ocean types. 
! </DESCRIPTION>
!
  subroutine ocean_types_init()

    if (module_is_initialized) then 
       call mpp_error( FATAL, '==>Error: ocean_types_init: module already initialized')
    endif
    module_is_initialized = .true.

    call write_version_number(version, tagname)

    return

  end subroutine ocean_types_init
! </SUBROUTINE> NAME="ocean_types_init"


end module ocean_types_mod

module spectral_dynamics_mod

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use                fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, NOTE, FATAL, write_version_number, stdlog, &
                                  close_file, open_restart_file, file_exist, set_domain,                      &
                                  read_data, write_data, check_nml_error, lowercase, uppercase, mpp_npes,     &
                                  field_size

use          constants_mod, only: rdgas, rvgas, grav, cp_air, omega, radius, pi

use       time_manager_mod, only: time_type, get_time, set_time, get_calendar_type, NO_CALENDAR, &
                                  get_date, interval_alarm, operator( - ), operator( + )

use      field_manager_mod, only: MODEL_ATMOS, parse

use     tracer_manager_mod, only: get_number_tracers, query_method, get_tracer_index, get_tracer_names, NO_TRACER

use       diag_manager_mod, only: diag_axis_init, register_diag_field, register_static_field, send_data

use         transforms_mod, only: transforms_init,         transforms_end,            &
                                  get_grid_boundaries,     area_weighted_global_mean, &
                                  compute_gradient_cos,    trans_spherical_to_grid,   &
                                  trans_grid_to_spherical, divide_by_cos,             &
                                  triangular_truncation,   rhomboidal_truncation,     &
                                  compute_laplacian,       get_eigen_laplacian,       &
                                  get_spherical_wave,      get_sin_lat,               &
                                  vor_div_from_uv_grid,    uv_grid_from_vor_div,      &
                                  horizontal_advection,    get_grid_domain,           &
                                  get_spec_domain,         grid_domain,               &
                                  spectral_domain,         get_deg_lon, get_deg_lat

use     vert_advection_mod, only: vert_advection, SECOND_CENTERED, FOURTH_CENTERED, VAN_LEER_LINEAR, FINITE_VOLUME_PARABOLIC, &
                                  ADVECTIVE_FORM

use           implicit_mod, only: implicit_init, implicit_end, implicit_correction

use   press_and_geopot_mod, only: press_and_geopot_init, press_and_geopot_end, &
                                  pressure_variables, compute_geopotential, compute_pressures_and_heights

use   spectral_damping_mod, only: spectral_damping_init, spectral_damping_end, compute_spectral_damping, &
                                  compute_spectral_damping_vor, compute_spectral_damping_div

use           leapfrog_mod, only: leapfrog, leapfrog_2level_A, leapfrog_2level_B

use       fv_advection_mod, only: fv_advection_init, fv_advection_end, a_grid_horiz_advection
                                  
use    water_borrowing_mod, only: water_borrowing

use    global_integral_mod, only: mass_weighted_global_integral

use spectral_init_cond_mod, only: spectral_init_cond

use        tracer_type_mod, only: tracer_type, tracer_type_version, tracer_type_tagname

use every_step_diagnostics_mod, only: every_step_diagnostics_init, every_step_diagnostics, every_step_diagnostics_end

use        mpp_domains_mod, only: mpp_global_field

use       polvani_2004_mod, only: polvani_2004
use       polvani_2007_mod, only: polvani_2007, polvani_2007_tracer_init, get_polvani_2007_tracers
use   jablonowski_2006_mod, only: jablonowski_2006

!===============================================================================================
implicit none
private
!===============================================================================================

public :: spectral_dynamics_init, spectral_dynamics, spectral_dynamics_end, get_num_levels
public :: get_use_virtual_temperature, get_reference_sea_level_press, get_surf_geopotential
public :: get_pk_bk, complete_robert_filter, complete_update_of_future
public :: get_axis_id, spectral_diagnostics, get_initial_fields

!===============================================================================================

character(len=128), parameter :: version = '$Id: spectral_dynamics.F90,v 19.0 2012/01/06 20:35:46 fms Exp $'
character(len=128), parameter :: tagname = '$Name: tikal $'

!===============================================================================================
! variables needed for diagnostics
integer :: id_ps, id_u, id_v, id_t, id_vor, id_div, id_omega, id_wspd, id_slp
integer :: id_pres_full, id_pres_half, id_zfull, id_zhalf, id_vort_norm, id_EKE
integer :: id_uu, id_vv, id_tt, id_omega_omega, id_uv, id_omega_t
integer, allocatable, dimension(:) :: id_tr
real :: gamma, expf, expf_inverse
character(len=8) :: mod_name = 'dynamics'
integer, dimension(4) :: axis_id
!===============================================================================================

integer, parameter :: num_time_levels = 2

logical :: module_is_initialized = .false.
logical :: dry_model
logical :: robert_complete_for_tracers=.true., robert_complete_for_fields=.true. ! Needed only for error checks during code development

type(time_type) :: Time_step, Alarm_time, Alarm_interval ! Used to determine when it is time to print global integrals.

real,    allocatable, dimension(:) :: sin_lat, coriolis
real,    allocatable, dimension(:) :: pk, bk, dpk, dbk

complex, allocatable, dimension(:,:,:,:)   :: vors, divs, ts ! last dimension is for time level
complex, allocatable, dimension(:,:,:  )   :: ln_ps          ! last dimension is for time level
complex, allocatable, dimension(:,:,:,:,:) :: spec_tracers   ! 4'th dimension is for time level, last dimension is for tracer number

real, allocatable, dimension(:,:,:    ) :: psg               ! last dimension is for time level
real, allocatable, dimension(:,:,:,:  ) :: ug, vg, tg        ! last dimension is for time level
real, allocatable, dimension(:,:,:,:,:) :: grid_tracers      ! 4'th dimension is for time level, last dimension is for tracer number
real, allocatable, dimension(:,:      ) :: surf_geopotential
real, allocatable, dimension(:,:,:    ) :: vorg, divg        ! no time levels needed

integer, allocatable, dimension(:) :: tracer_vert_advect_scheme

real    :: virtual_factor, dt_real
integer :: pe, npes, num_tracers, nhum, t_vert_advect_scheme, uv_vert_advect_scheme, step_number
real    :: mean_energy_previous, mean_water_previous, mean_surf_press_previous
integer :: ms, me, ns, ne, is, ie, js, je
integer :: previous, current, future

character(len=32), parameter :: default_representation = 'spectral'
character(len=32), parameter :: default_advect_vert    = 'second_centered'
character(len=32), parameter :: default_hole_filling   = 'off'

!===============================================================================================
! namelist variables

logical :: do_mass_correction     = .true. , &
           do_water_correction    = .true. , &
           do_energy_correction   = .true. , &
           use_virtual_temperature= .false., &
           use_implicit           = .true.,  &
           triang_trunc           = .true.

integer :: damping_order       = 2, &
           damping_order_vor   =-1, &
           damping_order_div   =-1, &
           lon_max             = 128, & ! T42
           lat_max             = 64,  & ! T42
           num_fourier         = 42,  & ! T42
           num_spherical       = 43,  & ! T42
           fourier_inc         = 1,   &
           num_levels          = 18,  &
           num_steps           = 1

integer, dimension(2) ::  print_interval=(/1,0/)

character(len=64) :: vert_coord_option      = 'even_sigma',   &
                     damping_option         = 'resolution_dependent', &
                     vert_advect_uv         = default_advect_vert,    &
                     vert_advect_t          = default_advect_vert,    &
                     vert_difference_option = 'simmons_and_burridge', &
                     initial_state_option   = 'quiescent'

real    :: damping_coeff       = 1.15740741e-4, & ! (one tenth day)**-1
           damping_coeff_vor   = -1., &
           damping_coeff_div   = -1., &
           eddy_sponge_coeff   =  0., &
           zmu_sponge_coeff    =  0., &
           zmv_sponge_coeff    =  0., &
           robert_coeff        = .04, &
           alpha_implicit      = .5,  &
           longitude_origin    =  0., &
           scale_heights       =  4., &
           surf_res            = .1,  &
           p_press             = .1,  &
           p_sigma             = .3,  &
           exponent            = 2.5, &
         ocean_topog_smoothing = .93, &
           initial_sphum       = 0.0, &
     reference_sea_level_press =  101325.
!===============================================================================================

real, dimension(2) :: valid_range_t = (/100.,500./)

namelist /spectral_dynamics_nml/ use_virtual_temperature, damping_option,                            &
                                 damping_order, damping_coeff, damping_order_vor, damping_coeff_vor, &
                                 damping_order_div, damping_coeff_div, do_mass_correction,           &
                                 do_water_correction, do_energy_correction, vert_advect_uv,          &
                                 vert_advect_t, use_implicit, longitude_origin, robert_coeff,        &
                                 alpha_implicit, vert_difference_option,                             &
                                 reference_sea_level_press, lon_max, lat_max, num_levels,            &
                                 num_fourier, num_spherical, fourier_inc, triang_trunc,              &
                                 vert_coord_option, scale_heights, surf_res,      &
                                 p_press, p_sigma, exponent, ocean_topog_smoothing, initial_sphum,   &
                                 valid_range_t, eddy_sponge_coeff, zmu_sponge_coeff, zmv_sponge_coeff, &
                                 print_interval, num_steps, initial_state_option
                                 
contains

!===============================================================================================

subroutine spectral_dynamics_init(Time, Time_step_in, tracer_attributes, dry_model_out, nhum_out, ocean_mask)

type(time_type), intent(in) :: Time, Time_step_in
type(tracer_type), intent(inout), dimension(:) :: tracer_attributes
logical, intent(out) :: dry_model_out
integer, intent(out) :: nhum_out
logical, optional, intent(in), dimension(:,:) :: ocean_mask

integer :: num_total_wavenumbers, unit, k, seconds, days, ierr, io, ntr, nsphum, nmix_rat
logical :: south_to_north = .true.
real    :: ref_surf_p_implicit, robert_coeff_tracers

real,    allocatable, dimension(:,:) :: eigen
integer, allocatable, dimension(:,:) :: wavenumber
real,    allocatable, dimension(:)   :: glon_bnd, glat_bnd, ref_temperature_implicit
character(len=32) :: scheme, params
character(len=128) :: tname, longname, units

! < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < >

if(module_is_initialized) return

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=spectral_dynamics_nml, iostat=io)
    ierr = check_nml_error(io, 'spectral_dynamics_nml')
#else
    unit = open_namelist_file()
    ierr=1
    do while (ierr /= 0)
      read(unit, nml=spectral_dynamics_nml, iostat=io, end=20)
      ierr = check_nml_error (io, 'spectral_dynamics_nml')
    enddo
20  call close_file (unit)
#endif

call write_version_number(version, tagname)
if(mpp_pe() == mpp_root_pe()) write (stdlog(), nml=spectral_dynamics_nml)
call write_version_number(version, tagname)

Time_step  = Time_step_in
Alarm_interval = set_time(print_interval(2), print_interval(1))
Alarm_time = Time + Alarm_interval

if(damping_order_vor == -1 ) damping_order_vor = damping_order
if(damping_order_div == -1 ) damping_order_div = damping_order
if(damping_coeff_vor == -1.) damping_coeff_vor = damping_coeff
if(damping_coeff_div == -1.) damping_coeff_div = damping_coeff

call check_dynamics_nml

if(uppercase(trim(vert_advect_uv)) == 'SECOND_CENTERED') then
  uv_vert_advect_scheme = SECOND_CENTERED
else if(uppercase(trim(vert_advect_uv)) == 'FOURTH_CENTERED') then
  uv_vert_advect_scheme = FOURTH_CENTERED
else if(uppercase(trim(vert_advect_uv)) == 'VAN_LEER_LINEAR') then
  uv_vert_advect_scheme = VAN_LEER_LINEAR
else if(uppercase(trim(vert_advect_uv)) == 'FINITE_VOLUME_PARABOLIC') then
  uv_vert_advect_scheme = FINITE_VOLUME_PARABOLIC
else
  call error_mesg('spectral_dynamics_init','"'//trim(vert_advect_uv)//'"'//' is not a valid value for vert_advect_uv.', FATAL)
endif

if(uppercase(trim(vert_advect_t)) == 'SECOND_CENTERED') then
  t_vert_advect_scheme = SECOND_CENTERED
else if(uppercase(trim(vert_advect_t)) == 'FOURTH_CENTERED') then
  t_vert_advect_scheme = FOURTH_CENTERED
else if(uppercase(trim(vert_advect_t)) == 'VAN_LEER_LINEAR') then
  t_vert_advect_scheme = VAN_LEER_LINEAR
else if(uppercase(trim(vert_advect_t)) == 'FINITE_VOLUME_PARABOLIC') then
  t_vert_advect_scheme = FINITE_VOLUME_PARABOLIC
else
  call error_mesg('spectral_dynamics_init','"'//trim(vert_advect_t)//'"'//' is not a valid value for vert_advect_t.', FATAL)
endif

! transforms_init must be called before the remaining 
! restart data can be read or the fields can be allocated.
! This is because transforms_init calls spec_mpp_init,
! which is where domains are determined.

call transforms_init(radius, lat_max, lon_max, num_fourier, fourier_inc, num_spherical, south_to_north=south_to_north, &
                     triang_trunc=triang_trunc, longitude_origin=longitude_origin)

call get_grid_domain(is, ie, js, je)
call get_spec_domain(ms, me, ns, ne)
call get_number_tracers(MODEL_ATMOS, num_prog=num_tracers)
call allocate_fields

do ntr=1,num_tracers

  call get_tracer_names(MODEL_ATMOS, ntr, tname, longname, units)
  tracer_attributes(ntr)%name = lowercase(tname)

  if(query_method('numerical_representation', MODEL_ATMOS, ntr, scheme)) then
    tracer_attributes(ntr)%numerical_representation = scheme
  else
    tracer_attributes(ntr)%numerical_representation = default_representation
  endif

  if(query_method('advect_vert', MODEL_ATMOS, ntr, scheme)) then
    tracer_attributes(ntr)%advect_vert = scheme
  else
    tracer_attributes(ntr)%advect_vert = default_advect_vert
  endif

  if(query_method('hole_filling', MODEL_ATMOS, ntr, scheme)) then
    tracer_attributes(ntr)%hole_filling = scheme
  else
    tracer_attributes(ntr)%hole_filling = default_hole_filling
  endif

  if(query_method('robert_filter', MODEL_ATMOS, ntr, scheme, params)) then
    if(uppercase(scheme) == 'OFF') then
      tracer_attributes(ntr)%robert_coeff = 0.0
    else
      if(parse(params,'robert_coeff', robert_coeff_tracers) == 1) then
        tracer_attributes(ntr)%robert_coeff = robert_coeff_tracers
      else
        tracer_attributes(ntr)%robert_coeff = robert_coeff
      endif
    endif
  else
    tracer_attributes(ntr)%robert_coeff = robert_coeff
  endif

  if(trim(tracer_attributes(ntr)%numerical_representation) == 'spectral') then
    tracer_attributes(ntr)%advect_horiz = 'spectral'
  else if(trim(tracer_attributes(ntr)%numerical_representation) == 'grid') then
    tracer_attributes(ntr)%advect_horiz = 'van_leer'
  else
    call error_mesg('spectral_dynamics_init',trim(tracer_attributes(ntr)%numerical_representation)// &
           ' is an invalid numerical_representation', FATAL)
  endif

  if(trim(tracer_attributes(ntr)%numerical_representation) == 'grid') then
    if(trim(tracer_attributes(ntr)%hole_filling) == 'on') then
      call error_mesg('spectral_dynamics_init','Warning: hole_filling scheme = on will be ignored for grid tracer '// &
      tracer_attributes(ntr)%name,NOTE)
    endif
  endif

enddo

nsphum   = get_tracer_index(MODEL_ATMOS, 'sphum')
nmix_rat = get_tracer_index(MODEL_ATMOS, 'mix_rat')

if(nsphum == NO_TRACER) then
  if(nmix_rat == NO_TRACER) then
    nhum = 0
    dry_model = .true.
  else
    nhum = nmix_rat 
    dry_model = .false.
  endif
else
  if(nmix_rat == NO_TRACER) then
    nhum = nsphum
    dry_model = .false.
  else
    call error_mesg('spectral_dynamics_init','sphum and mix_rat cannot both be specified as tracers at the same time', FATAL)
  endif
endif
dry_model_out = dry_model
nhum_out = nhum

allocate(tracer_vert_advect_scheme(num_tracers))

do ntr=1,num_tracers
  if(uppercase(trim(tracer_attributes(ntr)%advect_vert)) == 'SECOND_CENTERED') then
    tracer_vert_advect_scheme(ntr) = SECOND_CENTERED
  else if(uppercase(trim(tracer_attributes(ntr)%advect_vert)) == 'FOURTH_CENTERED') then
    tracer_vert_advect_scheme(ntr) = FOURTH_CENTERED
  else if(uppercase(trim(tracer_attributes(ntr)%advect_vert)) == 'VAN_LEER_LINEAR') then
    tracer_vert_advect_scheme(ntr) = VAN_LEER_LINEAR
  else if(uppercase(trim(tracer_attributes(ntr)%advect_vert)) == 'FINITE_VOLUME_PARABOLIC') then
    tracer_vert_advect_scheme(ntr) = FINITE_VOLUME_PARABOLIC
  else
    call error_mesg('spectral_dynamics_init',trim(tracer_attributes(ntr)%advect_vert)// &
         ' is not a valid vertical advection scheme for tracers. Check your field_table.', FATAL)
  endif
enddo

call read_restart_or_do_coldstart(tracer_attributes, ocean_mask)

call press_and_geopot_init(pk, bk, use_virtual_temperature, vert_difference_option)

call spectral_diagnostics_init(Time)

call every_step_diagnostics_init(Time, lon_max, lat_max, num_levels, reference_sea_level_press)

if(do_water_correction .and. .not.do_mass_correction) then
  call error_mesg('spectral_dynamics_init', 'water_correction requires mass_correction', FATAL)
endif

if(do_energy_correction .and. .not.do_mass_correction) then
  call error_mesg('spectral_dynamics_init', 'energy_correction requires mass_correction', FATAL)
endif

pe   = mpp_pe()
npes = mpp_npes()

if(triang_trunc) then
  num_total_wavenumbers = num_spherical - 1
else
  num_total_wavenumbers = num_spherical - 1 + fourier_inc*num_fourier
end if

if(use_virtual_temperature) then
  virtual_factor = (rvgas/rdgas) - 1.0
end if

allocate (sin_lat (js:je))
allocate (coriolis(js:je))

call get_sin_lat (sin_lat)

coriolis = 2*omega*sin_lat

allocate (glon_bnd (lon_max + 1))
allocate (glat_bnd (lat_max + 1))

call get_grid_boundaries(glon_bnd, glat_bnd, global=.true.)
call fv_advection_init  (lon_max, lat_max, glat_bnd, 360./fourier_inc)

deallocate (glat_bnd)
deallocate (glon_bnd)

allocate(dpk(size(pk,1)-1))
allocate(dbk(size(bk,1)-1))

do k=1,size(pk,1)-1
  dpk(k) = pk(k+1) - pk(k)
  dbk(k) = bk(k+1) - bk(k)
enddo

call spectral_damping_init(damping_coeff, damping_order, damping_option, num_fourier, num_spherical, &
                           num_levels, eddy_sponge_coeff, zmu_sponge_coeff, zmv_sponge_coeff,        &
                           damping_coeff_vor=damping_coeff_vor, damping_order_vor=damping_order_vor, &
                           damping_coeff_div=damping_coeff_div, damping_order_div=damping_order_div)

if(use_implicit) then
  allocate(wavenumber(0:num_fourier,0:num_spherical))
  allocate(     eigen(0:num_fourier,0:num_spherical))
  allocate (ref_temperature_implicit(num_levels))
  ref_temperature_implicit(:) = 300.
  ref_surf_p_implicit = reference_sea_level_press

  call get_spherical_wave(wavenumber)
  call get_eigen_laplacian(eigen)

  call implicit_init(pk, bk, ref_temperature_implicit, ref_surf_p_implicit, num_total_wavenumbers, &
                     eigen, wavenumber, alpha_implicit, vert_difference_option)

  deallocate(eigen, wavenumber, ref_temperature_implicit)
endif

call set_domain(grid_domain)

call get_time(Time_step, seconds, days)
dt_real = 86400*days + seconds

module_is_initialized = .true.
return
end subroutine spectral_dynamics_init

!===============================================================================================
subroutine read_restart_or_do_coldstart(tracer_attributes, ocean_mask)

! For backward compatibility, this routine has the capability
! to read native data restart files written by inchon code.

type(tracer_type), intent(inout), dimension(:) :: tracer_attributes
logical, optional, intent(in), dimension(:,:) :: ocean_mask

integer :: m, n, k, nt, ntr
integer, dimension(4) :: siz
real, dimension(ms:me, ns:ne, num_levels) :: real_part, imag_part
character(len=64) :: file, tr_name
character(len=4) :: ch1,ch2,ch3,ch4,ch5,ch6

file = 'INPUT/spectral_dynamics.res.nc'
if(file_exist(trim(file))) then
  call field_size(trim(file), 'vors_real', siz)
  if(num_fourier /= siz(1)-1 .or. num_spherical /= siz(2)-1 .or. num_levels /= siz(3)) then
    write(ch1,'(i4)') siz(1)-1
    write(ch2,'(i4)') siz(2)-1
    write(ch3,'(i4)') siz(3)
    write(ch4,'(i4)') num_fourier
    write(ch5,'(i4)') num_spherical
    write(ch6,'(i4)') num_levels
    call error_mesg('spectral_dynamics_init','Resolution of restart data does not match resolution specified on namelist.'// &
    ' Restart data: num_fourier='//ch1//', num_spherical='//ch2//', num_levels='//ch3// &
       '  Namelist: num_fourier='//ch4//', num_spherical='//ch5//', num_levels='//ch6, FATAL)
  endif
  call field_size(trim(file), 'ug', siz)
  if(lon_max /= siz(1) .or. lat_max /= siz(2)) then
    write(ch1,'(i4)') siz(1)
    write(ch2,'(i4)') siz(2)
    write(ch3,'(i4)') lon_max
    write(ch4,'(i4)') lat_max
    call error_mesg('spectral_dynamics_init','Resolution of restart data does not match resolution specified on namelist.'// &
    ' Restart data: lon_max='//ch1//', lat_max='//ch2//'  Namelist: lon_max='//ch3//', lat_max='//ch4, FATAL)
  endif
  call read_data(trim(file), 'previous', previous, no_domain=.true.)
  call read_data(trim(file), 'current',  current,  no_domain=.true.)
  call read_data(trim(file), 'pk', pk, no_domain=.true.)
  call read_data(trim(file), 'bk', bk, no_domain=.true.)
  do nt=1,num_time_levels
    call read_data(trim(file), 'vors_real',  real_part, spectral_domain, timelevel=nt)
    call read_data(trim(file), 'vors_imag',  imag_part, spectral_domain, timelevel=nt)
    do k=1,num_levels; do n=ns,ne; do m=ms,me
      vors(m,n,k,nt) = cmplx(real_part(m,n,k),imag_part(m,n,k))
    enddo; enddo; enddo
    call read_data(trim(file), 'divs_real',  real_part, spectral_domain, timelevel=nt)
    call read_data(trim(file), 'divs_imag',  imag_part, spectral_domain, timelevel=nt)
    do k=1,num_levels; do n=ns,ne; do m=ms,me
      divs(m,n,k,nt) = cmplx(real_part(m,n,k),imag_part(m,n,k))
    enddo; enddo; enddo
    call read_data(trim(file), 'ts_real',  real_part, spectral_domain, timelevel=nt)
    call read_data(trim(file), 'ts_imag',  imag_part, spectral_domain, timelevel=nt)
    do k=1,num_levels; do n=ns,ne; do m=ms,me
      ts(m,n,k,nt) = cmplx(real_part(m,n,k),imag_part(m,n,k))
    enddo; enddo; enddo
    call read_data(trim(file), 'ln_ps_real', real_part(:,:,1), spectral_domain, timelevel=nt)
    call read_data(trim(file), 'ln_ps_imag', imag_part(:,:,1), spectral_domain, timelevel=nt)
    do n=ns,ne; do m=ms,me
      ln_ps(m,n,nt) = cmplx(real_part(m,n,1),imag_part(m,n,1))
    enddo; enddo
    call read_data(trim(file), 'ug',   ug(:,:,:,nt), grid_domain, timelevel=nt)
    call read_data(trim(file), 'vg',   vg(:,:,:,nt), grid_domain, timelevel=nt)
    call read_data(trim(file), 'tg',   tg(:,:,:,nt), grid_domain, timelevel=nt)
    call read_data(trim(file), 'psg', psg(:,:,  nt), grid_domain, timelevel=nt)
    do ntr = 1,num_tracers
      tr_name = trim(tracer_attributes(ntr)%name)
      call read_data(trim(file), trim(tr_name), grid_tracers(:,:,:,nt,ntr), grid_domain, timelevel=nt)
      if(uppercase(trim(tracer_attributes(ntr)%numerical_representation)) == 'SPECTRAL') then
        call read_data(trim(file), trim(tr_name)//'_real', real_part, spectral_domain, timelevel=nt)
        call read_data(trim(file), trim(tr_name)//'_imag', imag_part, spectral_domain, timelevel=nt)
        do k=1,num_levels; do n=ns,ne; do m=ms,me
          spec_tracers(m,n,k,nt,ntr) = cmplx(real_part(m,n,k),imag_part(m,n,k))
        enddo; enddo; enddo
      endif
    enddo ! loop over tracers
  enddo ! loop over time levels
  call read_data(trim(file), 'vorg', vorg, grid_domain)
  call read_data(trim(file), 'divg', divg, grid_domain)
  call read_data(trim(file), 'surf_geopotential', surf_geopotential, grid_domain)
else if(file_exist('INPUT/spectral_dynamics.res')) then
  call error_mesg('spectral_dynamics_init', &
              'Binary restart file, INPUT/spectral_dynamics.res, is not supported by this version of spectral_dynamics.f90',FATAL)
else
  do ntr = 1,num_tracers
    if(trim(tracer_attributes(ntr)%name) == 'sphum') then
      grid_tracers(:,:,:,:,ntr) = initial_sphum
    else if(trim(tracer_attributes(ntr)%name) == 'mix_rat') then
      grid_tracers(:,:,:,:,ntr) = 0.
    else
      grid_tracers(:,:,:,:,ntr) = 0.
    endif   
  enddo

  previous = 1
  current  = 1
  if(initial_state_option == 'quiescent' .or. initial_state_option == 'input') then
    call spectral_init_cond(initial_state_option, tracer_attributes, reference_sea_level_press, triang_trunc, use_virtual_temperature,&
                            vert_coord_option, vert_difference_option, scale_heights, surf_res, p_press, p_sigma,  &
                            exponent, ocean_topog_smoothing, pk, bk,                                               &
                            vors(:,:,:,1), divs(:,:,:,1), ts(:,:,:,1), ln_ps(:,:,1), ug(:,:,:,1), vg(:,:,:,1),     &
                            tg(:,:,:,1), psg(:,:,1), vorg, divg, grid_tracers(:,:,:,1,:), surf_geopotential, ocean_mask)
  else if(initial_state_option == 'polvani_2004') then
    call polvani_2004(reference_sea_level_press, triang_trunc, vert_difference_option, pk, bk, &
                 vors(:,:,:,1), divs(:,:,:,1), ts(:,:,:,1), ln_ps(:,:,1), ug(:,:,:,1),  vg(:,:,:,1), &
                 tg(:,:,:,1), psg(:,:,1), vorg, divg, surf_geopotential)
  else if(initial_state_option == 'polvani_2007') then
    call polvani_2007(triang_trunc, vert_difference_option, pk, bk, &
                 vors(:,:,:,1), divs(:,:,:,1), ts(:,:,:,1), ln_ps(:,:,1), ug(:,:,:,1),  vg(:,:,:,1), &
                 tg(:,:,:,1), psg(:,:,1), vorg, divg, surf_geopotential)
    call get_polvani_2007_tracers(grid_tracers(:,:,:,1,:))
  else if(initial_state_option == 'jablonowski_2006') then
    call jablonowski_2006(reference_sea_level_press, triang_trunc, vert_coord_option, vert_difference_option, &
                 scale_heights, surf_res, p_press, p_sigma, exponent, pk, bk, &
                 vors(:,:,:,1), divs(:,:,:,1), ts(:,:,:,1), ln_ps(:,:,1), ug(:,:,:,1),  vg(:,:,:,1), &
                 tg(:,:,:,1), psg(:,:,1), vorg, divg, surf_geopotential)
  else
    call error_mesg('spectral_dynamics_init', trim(initial_state_option)//' is not a valid value of initial_state_option', FATAL)
  end if

  vors (:,:,:,2) = vors (:,:,:,1)
  divs (:,:,:,2) = divs (:,:,:,1)
  ts   (:,:,:,2) = ts   (:,:,:,1)
  ln_ps(:,:,  2) = ln_ps(:,:,  1)
  ug   (:,:,:,2) = ug   (:,:,:,1)
  vg   (:,:,:,2) = vg   (:,:,:,1)
  tg   (:,:,:,2) = tg   (:,:,:,1)
  psg  (:,:,  2) = psg  (:,:,  1)
  grid_tracers(:,:,:,2,:) = grid_tracers(:,:,:,1,:)

  do ntr = 1,num_tracers
    call trans_grid_to_spherical(grid_tracers(:,:,:,1,ntr), spec_tracers(:,:,:,1,ntr))
    spec_tracers(:,:,:,2,ntr) = spec_tracers(:,:,:,1,ntr)
  enddo
endif

return
end subroutine read_restart_or_do_coldstart
!===============================================================================================

subroutine allocate_fields

allocate (psg    (is:ie, js:je,             num_time_levels))
allocate (ug     (is:ie, js:je, num_levels, num_time_levels))
allocate (vg     (is:ie, js:je, num_levels, num_time_levels))
allocate (tg     (is:ie, js:je, num_levels, num_time_levels))

allocate (ln_ps(ms:me, ns:ne,             num_time_levels))
allocate ( vors(ms:me, ns:ne, num_levels, num_time_levels))
allocate ( divs(ms:me, ns:ne, num_levels, num_time_levels))
allocate (   ts(ms:me, ns:ne, num_levels, num_time_levels))

allocate (pk(num_levels+1), bk(num_levels+1))

allocate (vorg(is:ie, js:je, num_levels))
allocate (divg(is:ie, js:je, num_levels))

allocate (surf_geopotential(is:ie, js:je))

allocate (grid_tracers(is:ie, js:je, num_levels, num_time_levels, num_tracers))
allocate (spec_tracers(ms:me, ns:ne, num_levels, num_time_levels, num_tracers))

! Filling allocatable arrays with zeros immediately after allocation facilitates code debugging
psg=0.; ug=0.; vg=0.; tg=0.
ln_ps=cmplx(0.,0.); vors=cmplx(0.,0.); divs=cmplx(0.,0.); ts=cmplx(0.,0.); spec_tracers=cmplx(0.,0.)
pk=0.; bk=0.; vorg=0.; divg=0.; surf_geopotential=0.; grid_tracers=0.

return
end subroutine allocate_fields
!===============================================================================================
subroutine check_dynamics_nml

character(len=8)  :: ch_tmp1
character(len=16) :: ch_tmp2
integer :: itmp

!  Check for invalid values and incompatible combinations of namelist variables

if(num_fourier <= 0) then
  write(ch_tmp1,'(i8)') num_fourier
  call error_mesg('check_dynamics_nml',ch_tmp1//'is an invalid value for num_fourier.', FATAL)
endif

if(num_spherical <= 0) then
  write(ch_tmp1,'(i8)') num_spherical
  call error_mesg('check_dynamics_nml',ch_tmp1//'is an invalid value for num_spherical.', FATAL)
endif

if(fourier_inc <= 0) then
  write(ch_tmp1,'(i8)') fourier_inc
  call error_mesg('check_dynamics_nml',ch_tmp1//'is an invalid value for fourier_inc.', FATAL)
endif

if(num_levels <= 0) then
  write(ch_tmp1,'(i8)') num_levels
  call error_mesg('check_dynamics_nml',ch_tmp1//'is an invalid value for num_levels.', FATAL)
endif

if(lon_max < 3*num_fourier+1) then
  write(ch_tmp1,'(i8)') lon_max
  write(ch_tmp2,'(i8)') num_fourier
  call error_mesg('check_dynamics_nml','number of longitude points is too small for number of fourier waves.&
                  & lon_max='//ch_tmp1//'  num_fourier='//ch_tmp2, FATAL)
endif

if (triang_trunc) then
  itmp = 3
else
  itmp = 5
endif
if(2*lat_max < itmp*(num_spherical-1)+1) then
  write(ch_tmp1,'(i8)') lat_max
  write(ch_tmp2,'(i8)') num_spherical
  call error_mesg('check_dynamics_nml','number of latitude points is too small for number of meridional waves.&
                  &  lat_max='//ch_tmp1//'  num_spherical='//ch_tmp2, FATAL)
endif

if(damping_order < 0) then
  write(ch_tmp1,'(i8)') damping_order
  call error_mesg('check_dynamics_nml',ch_tmp1//' is an invalid value for damping_order.', FATAL)
endif

if(damping_order_vor < 0) then
  write(ch_tmp1,'(i8)') damping_order_vor
  call error_mesg('check_dynamics_nml',ch_tmp1//' is an invalid value for damping_order_vor.', FATAL)
endif

if(damping_order_div < 0) then
  write(ch_tmp1,'(i8)') damping_order_div
  call error_mesg('check_dynamics_nml',ch_tmp1//' is an invalid value for damping_order_div.', FATAL)
endif

if(damping_coeff < 0.) then
  write(ch_tmp2,'(e16.8)') damping_coeff
  call error_mesg('check_dynamics_nml',ch_tmp2//' is an invalid value for damping_coeff.', FATAL)
endif

if(damping_coeff_vor < 0.) then
  write(ch_tmp2,'(e16.8)') damping_coeff_vor
  call error_mesg('check_dynamics_nml',ch_tmp2//' is an invalid value for damping_coeff_vor.', FATAL)
endif

if(damping_coeff_div < 0.) then
  write(ch_tmp2,'(e16.8)') damping_coeff_div
  call error_mesg('check_dynamics_nml',ch_tmp2//' is an invalid value for damping_coeff_div.', FATAL)
endif

if(robert_coeff < 0. .or. robert_coeff > 1.) then
  write(ch_tmp2,'(1pe16.8)') robert_coeff
  call error_mesg('check_dynamics_nml',ch_tmp2//' is an invalid value for robert_coeff.', FATAL)
endif

if((do_energy_correction .or. do_water_correction) .and. .not.do_mass_correction) then
  call error_mesg('check_dynamics_nml','.not.do_mass_correction must be .true. when either & 
           &do_energy_correction or do_water_correction is .true.', FATAL)
endif

return

end subroutine check_dynamics_nml
!===============================================================================================
subroutine get_initial_fields(ug_out, vg_out, tg_out, psg_out, grid_tracers_out)
real, intent(out), dimension(:,:,:)   :: ug_out, vg_out, tg_out
real, intent(out), dimension(:,:)     :: psg_out
real, intent(out), dimension(:,:,:,:) :: grid_tracers_out

if(.not.module_is_initialized) then
  call error_mesg('get_initial_fields','dynamics has not been initialized',FATAL)
endif

if(previous /= 1 .or. current /= 1) then
  call error_mesg('get_initial_fields','This routine may be called only to get the&
                  & initial values after a cold_start',FATAL)
endif

ug_out  =  ug(:,:,:,1)
vg_out  =  vg(:,:,:,1)
tg_out  =  tg(:,:,:,1)
psg_out = psg(:,:,  1)
grid_tracers_out = grid_tracers(:,:,:,1,:)

end subroutine get_initial_fields
!===============================================================================================

subroutine spectral_dynamics(Time, psg_final, ug_final, vg_final, tg_final, tracer_attributes, grid_tracers_final, &
                             time_level_out, dt_psg, dt_ug, dt_vg, dt_tg, dt_tracers, wg_full, p_full, p_half, z_full)

type(time_type),  intent(in) :: Time
real, intent(out), dimension(is:, js:      ) :: psg_final
real, intent(out), dimension(is:, js:, :   ) :: ug_final, vg_final, tg_final
real, intent(out), dimension(is:, js:, :,:,:) :: grid_tracers_final
type(tracer_type),intent(inout), dimension(:) :: tracer_attributes
integer, intent(in)                           :: time_level_out

real, intent(inout), dimension(is:, js:      ) :: dt_psg
real, intent(inout), dimension(is:, js:, :   ) :: dt_ug, dt_vg, dt_tg
real, intent(inout), dimension(is:, js:, :, :) :: dt_tracers
real, intent(out),   dimension(is:, js:, :   ) :: wg_full, p_full
real, intent(out),   dimension(is:, js:, :   ) :: p_half
real, intent(in),    dimension(is:, js:, :   ) :: z_full

! < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < >

type(time_type) :: Time_diag

complex, dimension(ms:me, ns:ne              ) :: dt_ln_ps
complex, dimension(ms:me, ns:ne, num_levels  ) :: dt_vors, dt_divs, dt_ts, phis_plus_ke
real   , dimension(is:ie, js:je, num_levels  ) :: virtual_t, dp, dt_grid_tmp
real   , dimension(is:ie, js:je              ) :: dx_psg, dy_psg, ln_psg, dt_ln_psg
real   , dimension(is:ie, js:je, num_levels  ) :: phig_full, ln_p_full, phig_full_plus_ke
real   , dimension(is:ie, js:je, num_levels+1) :: phig_half, ln_p_half, wg

real, dimension(is:ie, js:je                         ) :: dt_psg_tmp
real, dimension(is:ie, js:je, num_levels             ) :: dt_ug_tmp, dt_vg_tmp, dt_tg_tmp
real, dimension(is:ie, js:je, num_levels, num_tracers) :: dt_tracers_tmp

integer :: j, k, time_level, seconds, days
real    :: delta_t

! < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < > < >

if(.not.module_is_initialized) then
  call error_mesg('spectral_dynamics','dynamics has not been initialized ', FATAL)
endif

step_loop: do step_number=1,num_steps

if(previous == current) then
  delta_t = dt_real/num_steps
else
  delta_t = 2*dt_real/num_steps
endif
if(num_time_levels == 2) then
  future = 3 - current
else
  call error_mesg('spectral_dynamics','Do not know how to set time pointers when num_time_levels does not equal 2',FATAL)
endif

dt_psg_tmp = dt_psg
dt_ug_tmp  = dt_ug
dt_vg_tmp  = dt_vg
dt_tg_tmp  = dt_tg
dt_tracers_tmp = dt_tracers

call initialize_corrections(dt_ug, dt_vg, dt_tg, dt_tracers, delta_t)

call pressure_variables (p_half, ln_p_half, p_full, ln_p_full, psg(:,:,current))

call compute_pressure_gradient  (ln_ps(:,:,current), psg(:,:,current), dx_psg, dy_psg)

if (use_virtual_temperature .and. .not.dry_model) then
  virtual_t = tg(:,:,:,current)*(1.0 + virtual_factor*grid_tracers(:,:,:,current,nhum))
else
  virtual_t = tg(:,:,:,current)
endif

call four_in_one (divg, ug(:,:,:,current), vg(:,:,:,current), virtual_t, psg(:,:,current), &
   ln_p_half, ln_p_full, p_full, dx_psg, dy_psg, dt_psg_tmp, wg, wg_full, dt_tg_tmp, dt_ug_tmp, dt_vg_tmp)

if(dry_model) then
  call compute_geopotential(tg(:,:,:,current), ln_p_half, ln_p_full, surf_geopotential, phig_full, phig_half)
else
  call compute_geopotential(tg(:,:,:,current), ln_p_half, ln_p_full, surf_geopotential, phig_full, phig_half, &
                            grid_tracers(:,:,:,current,nhum))
endif

dt_ln_psg = dt_psg_tmp/psg(:,:,current)
call trans_grid_to_spherical(dt_ln_psg, dt_ln_ps)

dp = p_half(:,:,2:num_levels+1) - p_half(:,:,1:num_levels)

if(uv_vert_advect_scheme == SECOND_CENTERED .or.  uv_vert_advect_scheme == FOURTH_CENTERED)         time_level=current
if(uv_vert_advect_scheme == VAN_LEER_LINEAR .or.  uv_vert_advect_scheme == FINITE_VOLUME_PARABOLIC) time_level=previous
call vert_advection(delta_t, wg, dp, ug(:,:,:,time_level), dt_grid_tmp, scheme=uv_vert_advect_scheme, form=ADVECTIVE_FORM)
dt_ug_tmp = dt_ug_tmp + dt_grid_tmp
call vert_advection(delta_t, wg, dp, vg(:,:,:,time_level), dt_grid_tmp, scheme=uv_vert_advect_scheme, form=ADVECTIVE_FORM)
dt_vg_tmp = dt_vg_tmp + dt_grid_tmp

if(t_vert_advect_scheme == SECOND_CENTERED .or.  t_vert_advect_scheme == FOURTH_CENTERED)         time_level=current
if(t_vert_advect_scheme == VAN_LEER_LINEAR .or.  t_vert_advect_scheme == FINITE_VOLUME_PARABOLIC) time_level=previous
call vert_advection(delta_t, wg, dp, tg(:,:,:,time_level),  dt_grid_tmp, scheme=t_vert_advect_scheme, form=ADVECTIVE_FORM)
dt_tg_tmp = dt_tg_tmp + dt_grid_tmp

call horizontal_advection(ts(:,:,:,current), ug(:,:,:,current), vg(:,:,:,current), dt_tg_tmp)
call trans_grid_to_spherical(dt_tg_tmp, dt_ts)

do k=1,num_levels
  do j = js,je
    dt_ug_tmp(:,j,k) = dt_ug_tmp(:,j,k) + (vorg(:,j,k) + coriolis(j))*vg(:,j,k,current)
    dt_vg_tmp(:,j,k) = dt_vg_tmp(:,j,k) - (vorg(:,j,k) + coriolis(j))*ug(:,j,k,current)
  enddo
enddo

call vor_div_from_uv_grid(dt_ug_tmp, dt_vg_tmp, dt_vors, dt_divs, triang = triang_trunc)

phig_full_plus_ke = phig_full + .5*(ug(:,:,:,current)**2 + vg(:,:,:,current)**2)
call trans_grid_to_spherical(phig_full_plus_ke, phis_plus_ke)
dt_divs = dt_divs - compute_laplacian(phis_plus_ke)

if(use_implicit) call implicit_correction (dt_divs, dt_ts, dt_ln_ps, divs, ts, ln_ps, delta_t, previous, current)

call compute_spectral_damping_vor (vors(:,:,:,previous), dt_vors, delta_t)
call compute_spectral_damping_div (divs(:,:,:,previous), dt_divs, delta_t)
call compute_spectral_damping     (ts  (:,:,:,previous), dt_ts,   delta_t)

if(.not.robert_complete_for_fields) then
  call error_mesg('spectral_dynamics','robert_complete_for_fields should be .true.',FATAL)
endif
if(.not.robert_complete_for_tracers) then
  call error_mesg('spectral_dynamics','robert_complete_for_tracers should be .true.',FATAL)
endif

if(step_number == num_steps) then
  call leapfrog_2level_A(ln_ps, dt_ln_ps, previous, current, future, delta_t, robert_coeff)
  call leapfrog_2level_A(vors,  dt_vors,  previous, current, future, delta_t, robert_coeff)
  call leapfrog_2level_A(divs,  dt_divs,  previous, current, future, delta_t, robert_coeff)
  call leapfrog_2level_A(ts,    dt_ts,    previous, current, future, delta_t, robert_coeff)
  robert_complete_for_fields = .false.
else
  call leapfrog         (ln_ps, dt_ln_ps, previous, current, future, delta_t, robert_coeff)
  call leapfrog         (vors , dt_vors , previous, current, future, delta_t, robert_coeff)
  call leapfrog         (divs , dt_divs , previous, current, future, delta_t, robert_coeff)
  call leapfrog         (ts   , dt_ts   , previous, current, future, delta_t, robert_coeff)
  robert_complete_for_fields = .true.
endif

call trans_spherical_to_grid(divs(:,:,:,future), divg)
call trans_spherical_to_grid(vors(:,:,:,future), vorg)
call uv_grid_from_vor_div(vors(:,:,:,future), divs(:,:,:,future), ug(:,:,:,future), vg(:,:,:,future))
call trans_spherical_to_grid(ts   (:,:,:,future), tg(:,:,:,future))
call trans_spherical_to_grid(ln_ps(:,:,  future), ln_psg)
psg(:,:,future) = exp(ln_psg)

if(minval(tg(:,:,:,future)) < valid_range_t(1) .or. maxval(tg(:,:,:,future)) > valid_range_t(2)) then
  call error_mesg('spectral_dynamics','temperatures out of valid range', FATAL)
endif

call update_tracers(tracer_attributes, dt_tracers_tmp, wg, p_half, delta_t)

call compute_corrections(delta_t, tracer_attributes)

previous = current
current  = future

call get_time(Time, seconds, days)
seconds = seconds + step_number*int(dt_real/2)
Time_diag = set_time(seconds, days)
call every_step_diagnostics( &
     Time_diag, psg(:,:,current), ug(:,:,:,current), vg(:,:,:,current), tg(:,:,:,current), grid_tracers(:,:,:,:,:), current)

enddo step_loop

psg_final = psg(:,:,  current)
ug_final  =  ug(:,:,:,current)
vg_final  =  vg(:,:,:,current)
tg_final  =  tg(:,:,:,current)
grid_tracers_final(:,:,:,time_level_out,:) = grid_tracers(:,:,:,current,:)

return
end subroutine spectral_dynamics

!================================================================================

subroutine four_in_one(divg, u_grid, v_grid, t_grid, p_surf, ln_p_half, ln_p_full, p_full, &
                       dx_psg, dy_psg, dt_psg, wg, wg_full, dt_tg, dt_ug, dt_vg)

real, intent(in),    dimension(:,:,:) :: divg, u_grid, v_grid, t_grid, ln_p_full, p_full
real, intent(in),    dimension(:,:  ) :: p_surf, dx_psg, dy_psg
real, intent(inout), dimension(:,:  ) :: dt_psg
real, intent(out),   dimension(:,:,:) :: wg_full
real, intent(out),   dimension(:,:,:) :: wg
real, intent(in),    dimension(:,:,:) :: ln_p_half
real, intent(inout), dimension(:,:,:) :: dt_tg, dt_ug, dt_vg

!  wg is dimensioned (is:ie, js:je, num_levels+1)
!  wg(:,:,k) = downward mass flux/per unit area across the K+1/2
!  cell boundary. This is the "vertical velocity" in the hybrid coordinate system.
!  When vertical coordinate is pure sigma: wg = psg*d(sigma)/dt

real, dimension(is:ie, js:je) :: dp, dp_inv, dlog_1, dlog_2, dlog_3, dmean, dmean_tot
real, dimension(is:ie, js:je) :: x1, x2, x3, x4, x5, p_surf_inv

real :: kappa
integer :: k

kappa = rdgas/cp_air
   
dmean_tot = 0.

if(vert_difference_option == 'simmons_and_burridge') then
  do k = 1,num_levels
    dp = dpk(k) + dbk(k)*p_surf
    dp_inv = 1/dp
    dlog_1 = ln_p_half(:,:,k+1) - ln_p_full(:,:,k)
    dlog_2 = ln_p_full(:,:,k)   - ln_p_half(:,:,k)
    dlog_3 = ln_p_half(:,:,k+1) - ln_p_half(:,:,k)
    x1 = (bk(k+1)*dlog_1 + bk(k)*dlog_2)*dp_inv
    x2 = x1*dx_psg
    x3 = x1*dy_psg
    dt_ug(:,:,k) = dt_ug(:,:,k) - rdgas*t_grid(:,:,k)*x2
    dt_vg(:,:,k) = dt_vg(:,:,k) - rdgas*t_grid(:,:,k)*x3
    dmean = divg(:,:,k)*dp + dbk(k)*(u_grid(:,:,k)*dx_psg + v_grid(:,:,k)*dy_psg)
    x4 = (dmean_tot*dlog_3 + dmean*dlog_1)*dp_inv
    x5 = x4 - u_grid(:,:,k)*x2 - v_grid(:,:,k)*x3
    dt_tg(:,:,k) = dt_tg(:,:,k) - kappa*t_grid(:,:,k) * x5
    wg_full(:,:,k) = -x5*p_full(:,:,k)
    dmean_tot = dmean_tot + dmean
    wg(:,:,k+1) = - dmean_tot
  enddo
else if(vert_difference_option == 'mcm') then
  p_surf_inv = 1.0/p_surf
  do k = 1,num_levels
    dp = dpk(k) + dbk(k)*p_surf
    x2 = dx_psg*p_surf_inv
    x3 = dy_psg*p_surf_inv
    dt_ug(:,:,k) = dt_ug(:,:,k) - rdgas*t_grid(:,:,k)*x2
    dt_vg(:,:,k) = dt_vg(:,:,k) - rdgas*t_grid(:,:,k)*x3
    dmean = divg(:,:,k)*dp + dbk(k)*(u_grid(:,:,k)*dx_psg + v_grid(:,:,k)*dy_psg)
    x4 = (dmean_tot + 0.5*dmean)/p_full(:,:,k)
    x5 = x4 - u_grid(:,:,k)*x2 - v_grid(:,:,k)*x3
    dt_tg(:,:,k) = dt_tg(:,:,k) - kappa*t_grid(:,:,k) * x5
    wg_full(:,:,k) = -x5*p_full(:,:,k)
    dmean_tot = dmean_tot + dmean
    wg(:,:,k+1) = - dmean_tot
  enddo
endif

dt_psg = dt_psg - dmean_tot

do k = 2,num_levels
  wg(:,:,k) = wg(:,:,k) + dmean_tot*bk(k)
enddo

wg(:,:,1           ) = 0.0
wg(:,:,num_levels+1) = 0.0

return
end subroutine four_in_one

!================================================================================

subroutine update_tracers(tracer_attributes, dt_tr, wg, p_half, delta_t)

type(tracer_type), intent(inout), dimension(:) :: tracer_attributes
real   , intent(inout), dimension(:,:,:,:) :: dt_tr
real   , intent(in   ), dimension(:,:,:  ) :: wg, p_half
real   , intent(in   )  :: delta_t

complex, dimension(ms:me, ns:ne, num_levels) :: dt_trs
real,    dimension(is:ie, js:je, num_levels) :: dp, dt_tmp, tr_future
integer :: ntr, time_level

dp = p_half(:,:,2:num_levels+1) - p_half(:,:,1:num_levels)

do ntr = 1, num_tracers
  if(trim(tracer_attributes(ntr)%numerical_representation) == 'spectral') then
    call horizontal_advection(spec_tracers(:,:,:,current,ntr), ug(:,:,:,current), vg(:,:,:,current), dt_tr(:,:,:,ntr))
    if(tracer_vert_advect_scheme(ntr) == SECOND_CENTERED .or. &
       tracer_vert_advect_scheme(ntr) == FOURTH_CENTERED)         time_level=current
    if(tracer_vert_advect_scheme(ntr) == VAN_LEER_LINEAR .or. &
       tracer_vert_advect_scheme(ntr) == FINITE_VOLUME_PARABOLIC) time_level=previous
    call vert_advection(delta_t, wg, dp, grid_tracers(:,:,:,time_level,ntr), dt_tmp, &
                     scheme=tracer_vert_advect_scheme(ntr), form=ADVECTIVE_FORM)
    dt_tr(:,:,:,ntr) = dt_tr(:,:,:,ntr) + dt_tmp
    if(trim(tracer_attributes(ntr)%hole_filling) == 'on') then
      call water_borrowing (dt_tr(:,:,:,ntr), grid_tracers(:,:,:,previous,ntr), current, p_half, delta_t)
    endif
    call trans_grid_to_spherical  (dt_tr(:,:,:,ntr), dt_trs)
    call compute_spectral_damping (spec_tracers(:,:,:,previous,ntr), dt_trs, delta_t)
    if(step_number == num_steps) then
      call leapfrog_2level_A(spec_tracers(:,:,:,:,ntr),dt_trs,previous,current,future,delta_t,tracer_attributes(ntr)%robert_coeff)
      robert_complete_for_tracers = .false.
    else
      call leapfrog(spec_tracers(:,:,:,:,ntr),dt_trs,previous,current,future,delta_t,tracer_attributes(ntr)%robert_coeff)
      robert_complete_for_tracers = .true.
    endif
    call trans_spherical_to_grid  (spec_tracers(:,:,:,future,ntr), grid_tracers(:,:,:,future,ntr))
  else if(trim(tracer_attributes(ntr)%numerical_representation) == 'grid') then
    tr_future = grid_tracers(:,:,:,previous,ntr) + delta_t*dt_tr(:,:,:,ntr)
    dt_tr(:,:,:,ntr) = 0.0
    call a_grid_horiz_advection (ug(:,:,:,current), vg(:,:,:,current), tr_future, delta_t, dt_tr(:,:,:,ntr))
    tr_future = tr_future + delta_t*dt_tr(:,:,:,ntr)
    dp = p_half(:,:,2:num_levels+1) - p_half(:,:,1:num_levels)
    call vert_advection(delta_t, wg, dp, tr_future, dt_tmp, scheme=tracer_vert_advect_scheme(ntr), form=ADVECTIVE_FORM)
    tr_future = tr_future + delta_t*dt_tmp
    if(step_number == num_steps) then
      grid_tracers(:,:,:,current,ntr) = grid_tracers(:,:,:,current,ntr) + &
      tracer_attributes(ntr)%robert_coeff*(grid_tracers(:,:,:,previous,ntr) - 2.0*grid_tracers(:,:,:,current,ntr))
      robert_complete_for_tracers = .false.
    else
      grid_tracers(:,:,:,current,ntr) = grid_tracers(:,:,:,current,ntr) + &
      tracer_attributes(ntr)%robert_coeff*(grid_tracers(:,:,:,previous,ntr) - 2.0*grid_tracers(:,:,:,current,ntr) + tr_future)
      robert_complete_for_tracers = .true.
    endif
    grid_tracers(:,:,:,future,ntr) = tr_future
  else
    call error_mesg('update_tracers',trim(tracer_attributes(ntr)%numerical_representation)// &
           ' is an invalid numerical_representation', FATAL)
  endif
enddo

return
end subroutine update_tracers

!=================================================================================================

subroutine compute_pressure_gradient(ln_ps, psg, dx_psg, dy_psg)

complex, intent(in ), dimension(:,:) :: ln_ps
real   , intent(in ), dimension(:,:) :: psg
real   , intent(out), dimension(:,:) :: dx_psg, dy_psg

complex, dimension(ms:me, ns:ne) :: dx_ln_ps, dy_ln_ps

call compute_gradient_cos(ln_ps, dx_ln_ps, dy_ln_ps)
call trans_spherical_to_grid(dx_ln_ps, dx_psg)
call trans_spherical_to_grid(dy_ln_ps, dy_psg)
dx_psg = psg*dx_psg
dy_psg = psg*dy_psg
call divide_by_cos(dx_psg)
call divide_by_cos(dy_psg)

return
end subroutine compute_pressure_gradient 

!===================================================================================

subroutine compute_corrections(delta_t, tracer_attributes)

real,              intent(in   )               :: delta_t
type(tracer_type), intent(inout), dimension(:) :: tracer_attributes

real :: mass_correction_factor, temperature_correction, water_correction_factor
real :: mean_surf_press_tmp,    mean_energy_tmp,        mean_water_tmp

if(do_mass_correction) then
  mean_surf_press_tmp = area_weighted_global_mean(psg(:,:,future))
  mass_correction_factor = mean_surf_press_previous/mean_surf_press_tmp
  psg(:,:,future) = mass_correction_factor*psg(:,:,future)
  if(ms == 0 .and. ns == 0) then
    ln_ps(0,0,future) = ln_ps(0,0,future) + sqrt(2.)*log(mass_correction_factor)
  endif
endif

if(do_energy_correction) then
  mean_energy_tmp = mass_weighted_global_integral( &
          0.5*(ug(:,:,:,future)**2 + vg(:,:,:,future)**2) + cp_air*tg(:,:,:,future), psg(:,:,future))
  temperature_correction = grav*(mean_energy_previous - mean_energy_tmp)/(cp_air*mean_surf_press_previous)
  tg(:,:,:,future) = tg(:,:,:,future) + temperature_correction
  if(ms == 0 .and. ns == 0) then
    ts(0,0,:,future) = ts(0,0,:,future) + sqrt(2.)*temperature_correction
  endif
endif

if(do_water_correction) then
  if(dry_model) then
    call error_mesg('compute_corrections','do_water_correction must be .false. in a dry model (default is .true.)', FATAL)
  else
    mean_water_tmp  = mass_weighted_global_integral(grid_tracers(:,:,:,future,nhum), psg(:,:,future))
    if(mean_water_tmp > 0.) then
      water_correction_factor = mean_water_previous/mean_water_tmp
      grid_tracers(:,:,:,future,nhum) = water_correction_factor*grid_tracers(:,:,:,future,nhum)
      if(tracer_attributes(nhum)%numerical_representation == 'spectral') then
        spec_tracers(:,:,:,future,nhum) = water_correction_factor*spec_tracers(:,:,:,future,nhum)
      endif
    endif
  endif
endif

return
end subroutine compute_corrections 

!===================================================================================

subroutine initialize_corrections(dt_ug, dt_vg, dt_tg, dt_tracers, delta_t)

real,    intent(in), dimension(:,:,:)   :: dt_ug, dt_vg, dt_tg
real,    intent(in), dimension(:,:,:,:) :: dt_tracers
real,    intent(in) :: delta_t

real, dimension(is:ie, js:je, num_levels) :: energy

if(do_mass_correction) then
  mean_surf_press_previous = area_weighted_global_mean(psg(:,:,previous))
endif

if(do_energy_correction) then
   energy  =  0.5*((ug(:,:,:,previous)+dt_ug*delta_t)**2 + (vg(:,:,:,previous)+dt_vg*delta_t)**2)   &
               +cp_air*(tg(:,:,:,previous)+dt_tg*delta_t)
   mean_energy_previous = mass_weighted_global_integral( energy, psg(:,:,previous))

   energy  =  0.5*((ug(:,:,:,current)+dt_ug*delta_t)**2 + (vg(:,:,:,current)+dt_vg*delta_t)**2)   &
               +cp_air*(tg(:,:,:,current)+dt_tg*delta_t)
endif

if(do_water_correction) then
  if(dry_model) then
    call error_mesg('initialize_corrections','do_water_correction must be .false. in a dry model&
                     & (default is .true.)', FATAL)
  else
    mean_water_previous = &
      mass_weighted_global_integral(grid_tracers(:,:,:,previous,nhum) + delta_t*dt_tracers(:,:,:,nhum), psg(:,:,previous))
  endif
endif

return
end subroutine initialize_corrections 

!================================================================================

subroutine get_surf_geopotential(surf_geopotential_out)
real, intent(out), dimension(:,:) :: surf_geopotential_out
character(len=64) :: chtmp='shape(surf_geopotential)=              should be                '

if(.not.module_is_initialized) then
  call error_mesg('get_surf_geopotential', 'spectral_dynamics_init has not been called.', FATAL)
endif

if(any(shape(surf_geopotential_out) /= shape(surf_geopotential))) then
  write(chtmp(26:37),'(3i4)') shape(surf_geopotential_out)
  write(chtmp(50:61),'(3i4)') shape(surf_geopotential)
  call error_mesg('get_surf_geopotential', 'surf_geopotential has wrong shape. '//chtmp, FATAL)
endif

surf_geopotential_out = surf_geopotential

return
end subroutine get_surf_geopotential
!================================================================================
subroutine get_reference_sea_level_press(reference_sea_level_press_out)
real, intent(out) :: reference_sea_level_press_out

if(.not.module_is_initialized) then
  call error_mesg('get_reference_sea_level_press', 'spectral_dynamics_init has not been called.', FATAL)
endif

reference_sea_level_press_out = reference_sea_level_press

return
end subroutine get_reference_sea_level_press
!================================================================================
subroutine get_use_virtual_temperature(use_virtual_temperature_out)
logical, intent(out) :: use_virtual_temperature_out

if(.not.module_is_initialized) then
  call error_mesg('get_use_virtual_temperature', 'spectral_dynamics_init has not been called.', FATAL)
endif

use_virtual_temperature_out = use_virtual_temperature

return
end subroutine get_use_virtual_temperature
!================================================================================
subroutine get_num_levels(num_levels_out)
integer, intent(out) :: num_levels_out

if(.not.module_is_initialized) then
  call error_mesg('get_num_levels', 'spectral_dynamics_init has not been called.', FATAL)
endif

num_levels_out = num_levels

return
end subroutine get_num_levels
!================================================================================
subroutine get_pk_bk(pk_out, bk_out)
real, intent(out), dimension(:) :: pk_out, bk_out
character(len=32) :: chtmp='size(pk)=      size(bk)=        '

if(.not.module_is_initialized) then
  call error_mesg('get_pk_bk', 'spectral_dynamics_init has not been called.', FATAL)
endif
if(size(pk_out,1) /= size(bk_out,1)) then
  write(chtmp(10:13),'(i4)') size(pk_out,1)
  write(chtmp(25:28),'(i4)') size(bk_out,1)
  call error_mesg('get_pk_bk', 'size(pk) is not equal to size(bk). '//chtmp, FATAL)
endif

pk_out = pk
bk_out = bk

return
end subroutine get_pk_bk
!================================================================================
subroutine complete_update_of_future(psg_in, ug_in, vg_in, tg_in, tracer_attributes, grid_tracers_in)

real,              intent(in), dimension(:,:    ) :: psg_in
real,              intent(in), dimension(:,:,:  ) :: ug_in, vg_in, tg_in
type(tracer_type), intent(in), dimension(:      ) :: tracer_attributes
real,              intent(in), dimension(:,:,:,:) :: grid_tracers_in
real, dimension(size(psg,1), size(psg,2)) :: ln_psg
integer :: ntr

! The time level pointers may be confusing here.
! The future level of the fields are passed to this routine in atmosphere_up,
! and they are loaded into the current level here.
! The reason for this is that the time level pointers in atmosphere_mod have
! not yet been updated, but they have been updated for spectral_dyanmics_mod
! (in Subroutine spectral_dynamics.) The result is that future in
! atmosphere_up points to the same time level as current in this routine.

!----------------------------------------------------------------------------

psg(:,:,  current) = psg_in
ug (:,:,:,current) = ug_in
vg (:,:,:,current) = vg_in
tg (:,:,:,current) = tg_in
grid_tracers(:,:,:,current,:) = grid_tracers_in

call vor_div_from_uv_grid(ug(:,:,:,current), vg(:,:,:,current), vors(:,:,:,current), divs(:,:,:,current), triang=triang_trunc)
call trans_spherical_to_grid(vors(:,:,:,current), vorg)
call trans_spherical_to_grid(divs(:,:,:,current), divg)
ln_psg = alog(psg(:,:,current))
call trans_grid_to_spherical(ln_psg, ln_ps(:,:,current))
call trans_grid_to_spherical(tg_in,  ts(:,:,:,current))
do ntr=1,num_tracers
  if(uppercase(trim(tracer_attributes(ntr)%numerical_representation)) == 'SPECTRAL') then
    call trans_grid_to_spherical(grid_tracers(:,:,:,current,ntr), spec_tracers(:,:,:,current,ntr))
  endif
enddo

return
end subroutine complete_update_of_future
!================================================================================
subroutine complete_robert_filter(tracer_attributes)
type(tracer_type), intent(inout), dimension(:) :: tracer_attributes
integer :: ntr

if(robert_complete_for_fields) then
  call error_mesg('complete_robert_filter','This routine should not be called when robert_complete_for_fields=.true.',FATAL)
endif
call leapfrog_2level_B(ln_ps, previous, current, robert_coeff)
call leapfrog_2level_B(vors,  previous, current, robert_coeff)
call leapfrog_2level_B(divs,  previous, current, robert_coeff)
call leapfrog_2level_B(ts,    previous, current, robert_coeff)
robert_complete_for_fields=.true.

if(num_tracers > 0 .and. robert_complete_for_tracers) then
  call error_mesg('complete_robert_filter','This routine should not be called when robert_complete_for_tracers=.true.',FATAL)
endif

do ntr = 1, num_tracers
  if(uppercase(trim(tracer_attributes(ntr)%numerical_representation)) == 'SPECTRAL') then
    call leapfrog_2level_B(spec_tracers(:,:,:,:,ntr), previous, current, tracer_attributes(ntr)%robert_coeff)
  else
    call leapfrog_2level_B(grid_tracers(:,:,:,:,ntr), previous, current, tracer_attributes(ntr)%robert_coeff)
  endif
  robert_complete_for_tracers=.true.
enddo

return
end subroutine complete_robert_filter
!================================================================================

subroutine spectral_dynamics_end(tracer_attributes, Time)

type(tracer_type), intent(in), dimension(:) :: tracer_attributes
type(time_type), intent(in), optional :: Time
integer :: ntr, nt
character(len=64) :: file, tr_name

if(.not.module_is_initialized) return

file='RESTART/spectral_dynamics.res'
call write_data(trim(file), 'previous', previous, no_domain=.true.)
call write_data(trim(file), 'current',  current,  no_domain=.true.)
call write_data(trim(file), 'pk', pk, no_domain=.true.)
call write_data(trim(file), 'bk', bk, no_domain=.true.)
do nt=1,num_time_levels
  call write_data(trim(file), 'vors_real',   real(vors (:,:,:,nt)), spectral_domain)
  call write_data(trim(file), 'vors_imag',  aimag(vors (:,:,:,nt)), spectral_domain)
  call write_data(trim(file), 'divs_real',   real(divs (:,:,:,nt)), spectral_domain)
  call write_data(trim(file), 'divs_imag',  aimag(divs (:,:,:,nt)), spectral_domain)
  call write_data(trim(file), 'ts_real',     real(ts   (:,:,:,nt)), spectral_domain)
  call write_data(trim(file), 'ts_imag',    aimag(ts   (:,:,:,nt)), spectral_domain)
  call write_data(trim(file), 'ln_ps_real',  real(ln_ps(:,:,  nt)), spectral_domain)
  call write_data(trim(file), 'ln_ps_imag', aimag(ln_ps(:,:,  nt)), spectral_domain)
  call write_data(trim(file), 'ug',   ug(:,:,:,nt), grid_domain)
  call write_data(trim(file), 'vg',   vg(:,:,:,nt), grid_domain)
  call write_data(trim(file), 'tg',   tg(:,:,:,nt), grid_domain)
  call write_data(trim(file), 'psg', psg(:,:,  nt), grid_domain)
  do ntr = 1,num_tracers
    tr_name = trim(tracer_attributes(ntr)%name)
    call write_data(trim(file), trim(tr_name), grid_tracers(:,:,:,nt,ntr), grid_domain)
    if(uppercase(trim(tracer_attributes(ntr)%numerical_representation)) == 'SPECTRAL') then
      call write_data(trim(file), trim(tr_name)//'_real',  real(spec_tracers(:,:,:,nt,ntr)), spectral_domain)
      call write_data(trim(file), trim(tr_name)//'_imag', aimag(spec_tracers(:,:,:,nt,ntr)), spectral_domain)
    endif
  enddo
enddo
call write_data(trim(file), 'vorg', vorg, grid_domain)
call write_data(trim(file), 'divg', divg, grid_domain)
call write_data(trim(file), 'surf_geopotential', surf_geopotential, grid_domain)

deallocate(ug, vg, tg, psg)
deallocate(sin_lat, coriolis)
deallocate(pk, bk, dpk, dbk)
deallocate(ln_ps, vors, divs, ts)
deallocate(vorg, divg)
deallocate(surf_geopotential)
deallocate(spec_tracers, grid_tracers)

if(use_implicit) call implicit_end
call spectral_damping_end
call fv_advection_end
call every_step_diagnostics_end(Time)
call spectral_diagnostics_end
call press_and_geopot_end
call transforms_end
call set_domain(grid_domain)
module_is_initialized = .false.

return
end subroutine spectral_dynamics_end
!===================================================================================
subroutine spectral_diagnostics_init(Time)

type(time_type), intent(in) :: Time
real, dimension(lon_max  ) :: lon
real, dimension(lon_max+1) :: lonb
real, dimension(lat_max  ) :: lat
real, dimension(lat_max+1) :: latb
real, dimension(num_levels)   :: p_full, ln_p_full
real, dimension(num_levels+1) :: p_half, ln_p_half
integer, dimension(3) :: axes_3d_half, axes_3d_full
integer :: id_lonb, id_latb, id_phalf, id_lon, id_lat, id_pfull
integer :: id_pk, id_bk, id_zsurf, ntr
real :: rad_to_deg
logical :: used
real,dimension(2) :: vrange
character(len=128) :: tname, longname, units

vrange = (/ -400., 400. /)

rad_to_deg = 180./pi
call get_grid_boundaries(lonb,latb,global=.true.)
call get_deg_lon(lon)
call get_deg_lat(lat)

id_lonb=diag_axis_init('lonb', rad_to_deg*lonb, 'degrees_E', 'x', 'longitude edges', set_name=mod_name, Domain2=grid_domain)
id_latb=diag_axis_init('latb', rad_to_deg*latb, 'degrees_N', 'y', 'latitude edges',  set_name=mod_name, Domain2=grid_domain)
id_lon =diag_axis_init('lon', lon, 'degrees_E', 'x', 'longitude', set_name=mod_name, Domain2=grid_domain, edges=id_lonb)
id_lat =diag_axis_init('lat', lat, 'degrees_N', 'y', 'latitude',  set_name=mod_name, Domain2=grid_domain, edges=id_latb)

call pressure_variables(p_half, ln_p_half, p_full, ln_p_full, reference_sea_level_press)
p_half = .01*p_half
p_full = .01*p_full
id_phalf = diag_axis_init('phalf',p_half,'hPa','z','approx half pressure level',direction=-1,set_name=mod_name)
id_pfull = diag_axis_init('pfull',p_full,'hPa','z','approx full pressure level',direction=-1,set_name=mod_name,edges=id_phalf)

axes_3d_half = (/ id_lon, id_lat, id_phalf /)
axes_3d_full = (/ id_lon, id_lat, id_pfull /)
axis_id(1) = id_lon
axis_id(2) = id_lat
axis_id(3) = id_pfull
axis_id(4) = id_phalf

id_pk = register_static_field(mod_name, 'pk', (/id_phalf/), 'vertical coordinate pressure values', 'pascals')
id_bk = register_static_field(mod_name, 'bk', (/id_phalf/), 'vertical coordinate sigma values', 'none')
id_zsurf = register_static_field(mod_name, 'zsurf', (/id_lon,id_lat/), 'geopotential height at the surface', 'm')

if(id_pk    > 0) used = send_data(id_pk, pk, Time)
if(id_bk    > 0) used = send_data(id_bk, bk, Time)
if(id_zsurf > 0) used = send_data(id_zsurf, surf_geopotential/grav, Time)

id_ps  = register_diag_field(mod_name, &
      'ps', (/id_lon,id_lat/),       Time, 'surface pressure',             'pascals')

id_u   = register_diag_field(mod_name, &
      'ucomp',   axes_3d_full,       Time, 'zonal wind component',         'm/sec',      range=vrange)

id_v   = register_diag_field(mod_name, &
      'vcomp',   axes_3d_full,       Time, 'meridional wind component',    'm/sec',      range=vrange)

id_uu  = register_diag_field(mod_name, &
      'ucomp_sq',axes_3d_full,       Time, 'zonal wind squared',           '(m/sec)**2', range=(/0.,vrange(2)**2/))

id_vv  = register_diag_field(mod_name, &
      'vcomp_sq',axes_3d_full,       Time, 'meridional wind squared',      '(m/sec)**2', range=(/0.,vrange(2)**2/))

id_uv  = register_diag_field(mod_name, &
      'ucomp_vcomp', axes_3d_full, Time, 'zonal wind * meridional wind', '(m/sec)**2', range=(/-vrange(2)**2,vrange(2)**2/))

id_omega_t = register_diag_field(mod_name, &
      'omega_temp',axes_3d_full,     Time, 'dp/dt * temperature',          'Pa*K/sec')

id_wspd= register_diag_field(mod_name, &
      'wspd',    axes_3d_full,       Time, 'wind speed',                   'm/sec',      range=(/0.,vrange(2)/))

id_t   = register_diag_field(mod_name, &
      'temp',    axes_3d_full,       Time, 'temperature',                  'deg_k',      range=valid_range_t)

id_tt  = register_diag_field(mod_name, &
      'temp_sq', axes_3d_full,       Time, 'temperature squared',          'deg_k**2',   range=(/0.,valid_range_t(2)**2/))

id_vor = register_diag_field(mod_name, &
      'vor',     axes_3d_full,       Time, 'vorticity',                    'sec**-1')

id_div = register_diag_field(mod_name, &
      'div',     axes_3d_full,       Time, 'divergence',                   'sec**-1')

id_omega  = register_diag_field(mod_name, &
      'omega',   axes_3d_full,       Time, 'dp/dt vertical velocity',      'Pa/sec')

id_omega_omega = register_diag_field(mod_name, &
      'omega_sq',axes_3d_full,       Time, 'omega squared',                '(Pa/sec)**2')

id_pres_full = register_diag_field(mod_name, &
      'pres_full',    axes_3d_full,       Time, 'pressure at full model levels', 'pascals')

id_pres_half = register_diag_field(mod_name, &
      'pres_half',    axes_3d_half,       Time, 'pressure at half model levels', 'pascals')

id_zfull   = register_diag_field(mod_name, &
      'height',  axes_3d_full,       Time, 'geopotential height at full model levels','m')

id_zhalf   = register_diag_field(mod_name, &
      'height_half',  axes_3d_half,  Time, 'geopotential height at half model levels','m')

id_slp = register_diag_field(mod_name, &
      'slp',(/id_lon,id_lat/),       Time, 'sea level pressure',           'pascals')

if(id_slp > 0) then
  gamma = 0.006
  expf = rdgas*gamma/grav
  expf_inverse = 1./expf
endif

allocate(id_tr(num_tracers))
do ntr=1,num_tracers
  call get_tracer_names(MODEL_ATMOS, ntr, tname, longname, units)
  id_tr(ntr) = register_diag_field(mod_name, tname, axes_3d_full, Time, longname, units)
enddo

id_vort_norm = register_diag_field(mod_name, 'vort_norm', Time, 'vorticity norm', '1/(m*sec)')
id_EKE       = register_diag_field(mod_name, 'EKE', Time, 'eddy kinetic energy', 'J/m^2')

return
end subroutine spectral_diagnostics_init
!===================================================================================
subroutine spectral_diagnostics(Time, p_surf, u_grid, v_grid, t_grid, wg_full, tr_grid, time_level)

type(time_type), intent(in) :: Time
real, intent(in), dimension(is:, js:)          :: p_surf
real, intent(in), dimension(is:, js:, :)       :: u_grid, v_grid, t_grid, wg_full
real, intent(in), dimension(is:, js:, :, :, :) :: tr_grid
integer, intent(in) :: time_level

real, dimension(is:ie, js:je, num_levels)    :: ln_p_full, p_full, z_full, worka3d, workb3d
real, dimension(is:ie, js:je, num_levels+1)  :: ln_p_half, p_half, z_half
real, dimension(is:ie, js:je)                :: t_low, slp, worka2d, workb2d
complex, dimension(ms:me, ns:ne, num_levels) :: vor_spec, div_spec
complex, dimension(ms:me, ns:ne)             :: vorx, vory
logical :: used
integer :: ntr, i, j, k
character(len=8) :: err_msg_1, err_msg_2
real, dimension(lon_max, lat_max) :: work_global
real :: vort_norm, EKE

if(id_ps  > 0)    used = send_data(id_ps,  p_surf, Time)
if(id_u   > 0)    used = send_data(id_u,   u_grid, Time)
if(id_v   > 0)    used = send_data(id_v,   v_grid, Time)
if(id_t   > 0)    used = send_data(id_t,   t_grid, Time)
if(id_vor > 0)    used = send_data(id_vor, vorg, Time)
if(id_div > 0)    used = send_data(id_div, divg, Time)
if(id_omega > 0)  used = send_data(id_omega, wg_full, Time)

if(id_zfull > 0 .or. id_zhalf > 0) then
  call compute_pressures_and_heights(t_grid, p_surf, surf_geopotential, z_full, z_half, p_full, p_half)
else if(id_pres_half > 0 .or. id_pres_full > 0 .or. id_slp > 0) then
  call pressure_variables(p_half, ln_p_half, p_full, ln_p_full, p_surf)
endif

if(id_zfull > 0)   used = send_data(id_zfull,      z_full, Time)
if(id_zhalf > 0)   used = send_data(id_zhalf,      z_half, Time)
if(id_pres_full>0) used = send_data(id_pres_full,  p_full, Time)
if(id_pres_half>0) used = send_data(id_pres_half,  p_half, Time)

if(id_wspd > 0) then
  worka3d = sqrt(u_grid**2 + v_grid**2)
  used = send_data(id_wspd, worka3d, Time)
endif
if(id_uu > 0) then
  worka3d = u_grid**2
  used = send_data(id_uu, worka3d, Time)
endif
if(id_vv > 0) then
  worka3d = v_grid**2
  used = send_data(id_vv, worka3d, Time)
endif
if(id_uv > 0) then
  worka3d = u_grid*v_grid
  used = send_data(id_uv, worka3d, Time)
endif
if(id_tt > 0) then
  worka3d = t_grid**2
  used = send_data(id_tt, worka3d, Time)
endif
if(id_omega_omega > 0) then
  worka3d = wg_full*wg_full
  used = send_data(id_omega_omega, worka3d, Time)
endif
if(id_omega_t > 0) then
  worka3d = wg_full*t_grid
  used = send_data(id_omega_t, worka3d, Time)
endif

if(size(tr_grid,5) /= num_tracers) then
  write(err_msg_1,'(i8)') size(tr_grid,5)
  write(err_msg_2,'(i8)') num_tracers
  call error_mesg('spectral_diagnostics','size(tracers)='//err_msg_1//' Should be='//err_msg_2, FATAL)
endif
do ntr=1,num_tracers
  if(id_tr(ntr) > 0) used = send_data(id_tr(ntr), tr_grid(:,:,:,time_level,ntr), Time)
enddo

if(id_slp > 0) then
  do j=js,je
    do i=is,ie
      do k=1,num_levels
        if(p_full(i,j,k)/p_surf(i,j) > .8) goto 20
      enddo
      call error_mesg('spectral_diagnostics','No sigma values .gt. 0.8  Cannot compute slp',FATAL)
20    continue
      t_low(i,j) = t_grid(i,j,k)*(p_full(i,j,k)/p_surf(i,j))**(-expf)
      slp(i,j) = p_surf(i,j)*((t_low(i,j) + gamma*surf_geopotential(i,j)/grav)/t_low(i,j))**expf_inverse
    enddo
  enddo
  used = send_data(id_slp, slp, Time)
endif

if(interval_alarm(Time, Time_step, Alarm_time, Alarm_interval)) then
  call global_integrals(Time, p_surf, u_grid, v_grid, t_grid, wg_full, tr_grid(:,:,:,time_level,:))
endif

if(id_vort_norm > 0) then
  call vor_div_from_uv_grid(u_grid(:,:,num_levels), v_grid(:,:,num_levels), &
                            vor_spec(:,:,num_levels), div_spec(:,:,num_levels), triang=triang_trunc)
  call compute_gradient_cos(vor_spec(:,:,num_levels), vorx, vory)
  call trans_spherical_to_grid(vorx, worka2d)
  call trans_spherical_to_grid(vory, workb2d)
  call divide_by_cos(worka2d)
  call divide_by_cos(workb2d)
  worka2d = sqrt(worka2d**2 + workb2d**2)
  call mpp_global_field(grid_domain, worka2d, work_global)
  vort_norm = maxval(work_global)
  used = send_data(id_vort_norm, vort_norm, Time)
endif
if(id_EKE > 0) then
  call vor_div_from_uv_grid(u_grid, v_grid, vor_spec, div_spec, triang=triang_trunc)
  if(ms == 0) then
    vor_spec(0,:,:) = cmplx(0.0,0.0)
    div_spec(0,:,:) = cmplx(0.0,0.0)
  endif
  call uv_grid_from_vor_div(vor_spec, div_spec, worka3d, workb3d)
  EKE = mass_weighted_global_integral(.5*(worka3d**2 + workb3d**2), p_surf)
  used = send_data(id_EKE, EKE, Time)
endif

return
end subroutine spectral_diagnostics
!===================================================================================
subroutine global_integrals(Time, p_surf, u_grid, v_grid, t_grid, wg_full, tr_grid)
type(time_type), intent(in) :: Time
real, intent(in), dimension(is:ie, js:je)                          :: p_surf
real, intent(in), dimension(is:ie, js:je, num_levels)              :: u_grid, v_grid, t_grid, wg_full
real, intent(in), dimension(is:ie, js:je, num_levels, num_tracers) :: tr_grid
integer :: year, month, days, hours, minutes, seconds
character(len=4), dimension(12) :: month_name

month_name=(/' Jan',' Feb',' Mar',' Apr',' May',' Jun',' Jul',' Aug',' Sep',' Oct',' Nov',' Dec'/)

if(mpp_pe() == mpp_root_pe()) then
  if(get_calendar_type() == NO_CALENDAR) then
    call get_time(Time, seconds, days)
    write(*,100) days, seconds
  else
    call get_date(Time, year, month, days, hours, minutes, seconds)
    write(*,200) year, month_name(month), days, hours, minutes, seconds
  endif
endif
100 format(' Integration completed through',i6,' days',i6,' seconds')
200 format(' Integration completed through',i5,a4,i3,2x,i2,':',i2,':',i2)

end subroutine global_integrals
!===================================================================================
function get_axis_id()
integer, dimension(4) :: get_axis_id

if(.not.module_is_initialized) then
  call error_mesg('get_axis_id','spectral_diagnostics_init has not been called.', FATAL)
endif
get_axis_id = axis_id
return
end function get_axis_id
!===================================================================================
subroutine spectral_diagnostics_end

if(.not.module_is_initialized) return

deallocate(id_tr)

return
end subroutine spectral_diagnostics_end
!===================================================================================

end module spectral_dynamics_mod

!VERSION NUMBER:
!  $Id: donner_cape_k.F90,v 19.0 2012/01/06 20:06:18 fms Exp $

!module donner_cape_inter_mod

!#include "donner_cape_interfaces.h"

!end module donner_cape_inter_mod

!####################################################################

subroutine don_c_def_conv_env_k          &
         (isize, jsize, nlev_lsm, nlev_hires, Nml, Param, Initialized, &
          Col_diag,    &
          temp, mixing_ratio, pfull, lag_cape_temp, lag_cape_vapor,    &
          lag_cape_press, current_displ, cbmf, Don_cape, Don_conv, ermesg, error)

!---------------------------------------------------------------------
!   subroutine don_c_def_conv_env_k manages the 
!   determination of the stability of moist ascent in each model column,
!   calculating various quantities which define the movement of the 
!   parcel in the given column. 
!---------------------------------------------------------------------

use donner_types_mod, only : donner_nml_type, donner_param_type, &
                             donner_column_diag_type, donner_cape_type,&
                             donner_initialized_type, &
                             donner_conv_type
implicit none

!----------------------------------------------------------------------
integer,                       intent(in)    :: isize, jsize, nlev_lsm, &
                                                nlev_hires
type(donner_nml_type),         intent(in)    :: Nml      
type(donner_param_type),       intent(in)    :: Param
type(donner_initialized_type),       intent(in)    :: Initialized
type(donner_column_diag_type), intent(in)    :: Col_diag
real,    dimension(isize,jsize,nlev_lsm),                    &
                               intent(in)    :: temp, mixing_ratio,  &
                                                pfull, lag_cape_temp, &
                                                lag_cape_vapor, &
                                                lag_cape_press
real,    dimension(isize,jsize),                             &
                               intent(in)    :: current_displ, cbmf 
type(donner_cape_type),        intent(inout) :: Don_cape
type(donner_conv_type),        intent(inout) :: Don_conv
character(len=*),              intent(out)   :: ermesg
integer,                       intent(out)   :: error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!     isize          x-direction size of the current physics window
!     jsize          y-direction size of the current physics window
!     nlev_lsm       number of model layers in large-scale model
!     nlev_hires     number of model layers in hi-res cloud model
!                    of the donner deep convection parameterization
!     Nml            donner_nml_type variable containing the donner_nml
!                    variables that are needed outsied of donner_deep_mod
!     Param          donner_param_type variable containingthe parameters
!                    of the donner deep convection parameterization
!     Col_diag       donner_column_diagtype variable containing the
!                    information defining the columns fro which diagnos-
!                    tics are desired.
!     temp           temperature field at model levels [ deg K ]
!     mixing_ratio   vapor mixing ratio field at model levels 
!                    [ kg(h20) / kg(dry air) ]
!     pfull          pressure field on model full levels [ Pa ]
!     lag_cape_temp  temperature field used in lag-time cape 
!                    calculation [ deg K ]
!     lag_cape_vapor vapor mixing ratio field used in lag-time
!                    cape calculation [ kg(h2o) / kg(dry air) ]
!     lag_cape_press model full-level pressure field used in 
!                    lag-time cape calculation  [ Pa ]
!     current_displ  low-level parcel displacement to use in cape
!                    calculation on this step [ Pa ]
!     cbmf
!
!   intent(out) variables:
!
!     ermesg         character string containing any error message
!                    that is returned from a kernel subroutine
!
!   intent(inout) variables:
!
!     Don_cape       donner_cape type derived type variable containing 
!                    diagnostics and intermediate results related to 
!                    the cape calculation associated with the donner 
!                    convection parameterization
!     Don_conv       donner_conv_type derived type variable containing 
!                    diagnostics and intermediate results describing 
!                    the nature of the convection produced by the 
!                    donner parameterization
!
!---------------------------------------------------------------------

!----------------------------------------------------------------------
!   local variables:

      real,    dimension (isize, jsize, nlev_lsm) :: mid_cape_temp, &
                                                     mid_cape_vapor
      logical, dimension (isize, jsize)           :: no_convection
      integer                                     :: lowest_bl_index
      integer                                     :: i, j, k, n

!----------------------------------------------------------------------
!   local variables:
!     
!    mid_cape_temp       temperature field to be used in the cape 
!                        calculation using current time level values
!                        [ deg K ]
!    mid_cape_vapor      vapor mixing ratio field to be used in the cape
!                        calculation using current time level values
!                        [ kg(h2o) / kg (dry air) ]
!    no_convection       logical indicating columns in which cape calc-
!                        ulation may be skipped because low-level parcel
!                        displacement is downward 
!    lowest_bl_index     k index of topmost level within the surface 
!                        boundary layer (no local time variation of the
!                        temperature and moisture profiles is allowed 
!                        within the sbl) (index 1 at top of model) 
!    i, j, k, n          do-loop indices
!                        
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!    initialize the character string which will contain any error mes-
!    sages returned through this subroutine.
!---------------------------------------------------------------------
       ermesg = ' ' ; error = 0

!---------------------------------------------------------------------
!    define the vertical index of the highest level within the surface
!    boundary layer (lowest_bl_index).
!---------------------------------------------------------------------
      lowest_bl_index = nlev_lsm - Nml%model_levels_in_sfcbl + 1

!--------------------------------------------------------------------
!    if in diagnostics window, write message indicating lag-time cape
!    calculation is being done.
!--------------------------------------------------------------------
      if (Col_diag%in_diagnostics_window) then
        do n=1,Col_diag%ncols_in_window
          write (Col_diag%unit_dc(n), ' (//, a)')  &
              '               CAPE calculation for LAG time profile'
        end do
      endif
        
!--------------------------------------------------------------------
!    define a flag array which will be .true. when deep convection is
!    precluded in the column due to downward motion at the lowest model
!    level at the current time (no_convection).
!--------------------------------------------------------------------
      if (Nml%use_llift_criteria) then
        no_convection(:,:) = (current_displ(:,:) >= 0.0)
      else
        no_convection(:,:) = (current_displ(:,:) >  0.0)
      end if
      do j=1,jsize
        do i=1,isize
          if (Initialized%using_unified_closure .and.    &
                                             cbmf(i,j) == 0.) then
            no_convection(i,j) = .true.
          endif
        end do
      end do

!---------------------------------------------------------------------
!    call don_c_cape_calculation_driver_k with the lag-time-based 
!    profiles to define the lcl, the moist adiabat, convective inhibition
!    and cape for a parcel displaced upwards from the lowest model level.
!---------------------------------------------------------------------
      call don_c_cape_calculation_driver_k  &
           (isize, jsize, nlev_lsm, nlev_hires, Col_diag, Param, Nml, &
            lag_cape_temp, lag_cape_vapor, lag_cape_press,  &
            no_convection, Don_cape, ermesg, error)
 
!----------------------------------------------------------------------
!    if an error message was returned from the kernel routine, return
!    to the calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!---------------------------------------------------------------------
!    call don_c_cape_diagnostics_k to output the cape calculation 
!    diagnostics.
!---------------------------------------------------------------------
      call don_c_cape_diagnostics_k   &
           (isize, jsize, nlev_lsm, nlev_hires, Col_diag,  &
            Don_cape, no_convection, ermesg, error)
 
!----------------------------------------------------------------------
!    if an error message was returned from the kernel routine, return
!    to the calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return
  
!--------------------------------------------------------------------
!    save the values of cape and column integrated water vapor returned
!    from this calculation as the lag-time values of these quantities.
!    the convection parameterization requires the time-tendency of both
!    of these quantities.
!--------------------------------------------------------------------
      Don_cape%qint_lag (:,:) = Don_cape%qint(:,:)
      Don_cape%xcape_lag(:,:) = Don_cape%xcape(:,:)

!--------------------------------------------------------------------
!    if this is a diagnostics window, output a message indicating that 
!    the current-time cape calculation is beginning.
!--------------------------------------------------------------------
      if (Col_diag%in_diagnostics_window) then
        do n=1,Col_diag%ncols_in_window
          write (Col_diag%unit_dc(n), ' (//,  a)')  &
              '               CAPE calculation for CURRENT time profile'
        end do
      endif     

!--------------------------------------------------------------------
!    define the temperature and mixing ratio fields to be used in de-
!    termining the current-time cape sounding values at all levels 
!    above the surface boundary layer. they are the model values as 
!    input from the calling routine.
!--------------------------------------------------------------------
      do k=1,lowest_bl_index-1         
        mid_cape_temp(:,:,k)  = temp(:,:,k)
        mid_cape_vapor(:,:,k) = mixing_ratio(:,:,k)
      end do

!--------------------------------------------------------------------
!    in the surface boundary layer, use the temperature and water vapor
!    values used in the lag-time calculation of cape (the catendb clo-
!    sure). this prevents the production of cape time tendencies  
!    resulting from temporal noise from the surface boundary layer. 
!--------------------------------------------------------------------
      do k=lowest_bl_index, nlev_lsm
        mid_cape_temp(:,:,k) = lag_cape_temp(:,:,k)
        mid_cape_vapor(:,:,k) = lag_cape_vapor(:,:,k)
      end do

!---------------------------------------------------------------------
!    call don_c_cape_calculation_driver_k with the current-time-
!    based profiles to define the lcl, the moist adiabat, convective 
!    inhibition and cape for a parcel displaced upwards from the lowest 
!    model level.
!---------------------------------------------------------------------
      call don_c_cape_calculation_driver_k  &
           (isize, jsize, nlev_lsm, nlev_hires, Col_diag, Param, Nml, &
            mid_cape_temp, mid_cape_vapor, pfull,  &
            no_convection, Don_cape, ermesg, error)
 
!----------------------------------------------------------------------
!    if an error message was returned from the kernel routine, return
!    to the calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!---------------------------------------------------------------------
!    call don_c_cape_diagnostics_k to output the cape calculation 
!    diagnostics.
!---------------------------------------------------------------------
      call don_c_cape_diagnostics_k   &
           (isize, jsize, nlev_lsm, nlev_hires, Col_diag,  &
            Don_cape, no_convection, ermesg, error)
 
!----------------------------------------------------------------------
!    if an error message was returned from the kernel routine, return
!    to the calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!---------------------------------------------------------------------


end subroutine don_c_def_conv_env_k



!#######################################################################

subroutine don_c_cape_calculation_driver_k  &
         (isize, jsize, nlev_lsm, nlev_hires, Col_diag, Param, Nml, &
          temperature, mixing_ratio, pfull, no_convection, Don_cape, &
          ermesg, error)

!--------------------------------------------------------------------
!    subroutine cape_calculation_driver defines high-resolution atmos-
!    pheric temperature and vapor mixing ratio profiles equivalent to 
!    those in the large-scale model, and determines the parameters 
!    defining parcel movement within this environment.
!--------------------------------------------------------------------

use donner_types_mod,only : donner_column_diag_type, donner_param_type,&
                            donner_cape_type, donner_nml_type

implicit none

!--------------------------------------------------------------------
integer,                               intent(in)    :: isize, jsize,  &
                                                        nlev_lsm, &
                                                        nlev_hires
type(donner_column_diag_type),         intent(in)    :: Col_diag
type(donner_param_type),               intent(in)    :: Param
type(donner_nml_type),                 intent(in)    :: Nml  
real, dimension(isize,jsize,nlev_lsm), intent(in)    :: temperature,  &
                                                        mixing_ratio, &
                                                        pfull
logical, dimension(isize,jsize),       intent(in)    :: no_convection
type(donner_cape_type),                intent(inout) ::  Don_cape
character(len=*),                      intent(out)   :: ermesg
integer,                               intent(out)   :: error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      temperature      temperature profile on large-scale model grid 
!                       that is to be used for the cape calculation 
!                       [ deg K ]
!      mixing_ratio     water vapor mixing ratio profile on the large-
!                       scale model grid that is to be used in the cape 
!                       calculation [ kg(h2o) / kg(dry air) ]
!      pfull            large-scale model full-level pressure profile 
!                       [ Pa ]
!      no_convection    logical indicating if convection is precluded 
!                       from column because of lowest-level downward 
!                       motion
!
!   intent(inout) variables:
!
!     Don_cape          donner_cape type derived type variable contain-
!                       ing diagnostics and intermediate results related
!                       to the cape calculation associated with the 
!                       donner convection parameterization
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

       logical :: debug_ijt     ! logical indicating if diagnostics are
                                ! desired in current column
       integer  :: diag_unit    ! unit number for diagnostic output for
                                ! current column
       integer  :: i, j, n      ! do-loop indices

      ermesg = ' ' ; error = 0

!---------------------------------------------------------------------
!    loop over columns in physics window.
!------------------------------------------------------------------
      do j=1,jsize
        do i=1,isize

!---------------------------------------------------------------------
!    if deep convection is not precluded in this column, continue the
!    calculation; if deep convection is precluded in this column, 
!    the variables contained in Don_cape will retain the values prev-
!    iously given them on initialization.
!---------------------------------------------------------------------
          if (.not. no_convection(i,j)) then

!---------------------------------------------------------------------
!    define a logical variable indicating if diagnostics are to be
!    produced for this column. if so, define the unit number for the
!    output file (diag_unit).
!---------------------------------------------------------------------
            debug_ijt = .false.
            if (Col_diag%in_diagnostics_window) then
               do n=1,Col_diag%ncols_in_window
                 if (j == Col_diag%j_dc(n) .and.     &
                     i == Col_diag%i_dc(n)) then
                   debug_ijt = .true.
                   diag_unit = Col_diag%unit_dc(n)
                   exit
                 endif
               end do
            endif

!--------------------------------------------------------------------
!    call generate_cape_sounding to produce a high-resolution atmos-
!    pheric sounding to be used to evaluate cape.
!--------------------------------------------------------------------
            call don_c_generate_cape_sounding_k &
                 (nlev_lsm, nlev_hires, temperature(i,j,:),   &
                  mixing_ratio(i,j,:), pfull(i,j,:),   &
                  Don_cape%model_t(i,j,:), Don_cape%model_r(i,j,:), &
                  Don_cape%model_p(i,j,:), Don_cape%cape_p(i,j,:), &
                  Don_cape%env_t(i,j,:), Don_cape%env_r(i,j,:), ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
            if (error /= 0 ) return

!--------------------------------------------------------------------
!    call displace_parcel to calculate the behavior of a parcel moving
!    upwards in the model column defined by Don_cape%cape_p, 
!    Don_cape%env_t and Don_cape%env_r.
!--------------------------------------------------------------------
            call don_c_displace_parcel_k   &
                 (nlev_hires, diag_unit, debug_ijt, Param,    &
                  Nml%do_freezing_for_cape, Nml%tfre_for_cape, &
                  Nml%dfre_for_cape, Nml%rmuz_for_cape, &
!      the following value of .true. corresponds to the dummy argument 
!      use_constant_rmuz. it currently must be .true. for this call to  
!      displace_parcel; it may be false when displace_parcel is called
!      for a closure calculation.
                  .true., &  ! (use_constant_rmuz)
!      the following value corresponds to dummy argument 
!      carry_condensate.  it currently must be set to .false. for cape
!      calculations used to determine the presence of convection; it 
!      may be set true in calls to displace_parcel used for closure
!      calculations.
                   .false., &  ! (carry_condensate)
                 Nml%closure_plume_condensate, & ! (is not used when 
                                                 ! carry_condensate
                                                 ! is .false.)
                  Don_cape%env_t(i,j,:), Don_cape%env_r(i,j,:), &
                  Don_cape%cape_p(i,j,:), .true.,  &
                  Don_cape%plfc(i,j), Don_cape%plzb(i,j),  &
                  Don_cape%plcl(i,j), Don_Cape%coin(i,j),   &
                  Don_cape%xcape(i,j), Don_cape%parcel_r(i,j,:), &
                  Don_cape%parcel_t(i,j,:), ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
            if (error /= 0 ) return

!---------------------------------------------------------------------
!   call integrate_vapor to produce the column integral of water vapor.
!--------------------------------------------------------------------
            call don_c_integrate_vapor_k  &
                 (nlev_hires, Param, Don_cape%env_r(i,j,:),  &
                  Don_cape%cape_p(i,j,:), Don_cape%qint(i,j), ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
            if (error /= 0 ) return
          endif
        end do
      end do

!--------------------------------------------------------------------



end subroutine don_c_cape_calculation_driver_k 


!###################################################################

subroutine don_c_displace_parcel_k   &
         (nlev_hires, diag_unit, debug_ijt, Param, do_freezing, &
          tfreezing, dfreezing, rmuz, use_constant_rmuz, &
          carry_condensate, condensate_carried, env_t, env_r,  &
          cape_p, coin_present, plfc, plzb, plcl, coin, xcape,       &
          parcel_r, parcel_t, ermesg, error)

!----------------------------------------------------------------------
!    displace_parcel moves a parcel upwards from the lowest model level
!    (istart) in an environment defined by env_t, env_r and cape_p, 
!    determining the critical transition levels during its ascent (plfc,
!    plzb, plcl), its temperature (parcel_t) and mixing ratio (parcel_r)
!    at each pressure level (cape_p) during its ascent, and if desired,
!    calculating the associated energy integrals for the parcel 
!    (xcape, coin).
!---------------------------------------------------------------------

use donner_types_mod, only:  donner_param_type 
implicit none

!---------------------------------------------------------------------
integer,                       intent(in)  :: nlev_hires
integer,                       intent(in)  :: diag_unit
logical,                       intent(in)  :: debug_ijt
type(donner_param_type),       intent(in)  :: Param
logical,                       intent(in)  :: do_freezing, &
                                              use_constant_rmuz, &
                                              carry_condensate
real,                          intent(in)  :: tfreezing, dfreezing, &
                                              rmuz, condensate_carried
real,   dimension(nlev_hires), intent(in)  :: env_t, env_r, cape_p
logical,                       intent(in)  :: coin_present
real,                          intent(out) :: plfc, plzb, plcl
real,                          intent(out) :: coin, xcape
real,   dimension(nlev_hires), intent(out) :: parcel_r, parcel_t   
character(len=*),              intent(out) :: ermesg
integer,                       intent(out) :: error

!--------------------------------------------------------------------
!  intent(in) variables:
!
!      debug_ijt    logical indicating if diagnostics are desired for
!                   current column
!      diag_unit    i/o unit number for diagnostics file
!      env_t        envirionmental temperature field, index 1 nearest
!                   the surface [ deg K ]
!      env_r        envirionmental vapor mixing ratio field, index 1 
!                   nearest the surface [ kg(h2o) / kg(dry air) ]
!      cape_p       pressure profile, index 1 nearest the surface  
!                   [ Pa ]
!
!   intent(out) variables:
!
!      plfc         pressure at level of free convection [ Pa ]
!      plzb         pressure at level of zero buoyancy [ Pa ]
!      plcl         pressure at lifting condensation level [ Pa ]
!      parcel_r     vapor mixing ratio in parcel. it is set to the
!                   environmental value below level ISTART. index 1 
!                   is level nearest earth's surface.
!      parcel_t     temperature in parcel. it is set to the environ-
!                   mental value below level ISTART. index 1 is level 
!                   nearest earth's surface.
!
!   intent(out), optional:
!
!      coin         convective inhibition -- energy required to lift 
!                   parcel from level ISTART to the level of free 
!                   convection. if parcel becomes buoyant below lcl, 
!                   coin can be < 0.  [ Joules / kg ]
!      xcape        convective available potential energy -- energy 
!                   released as parcel moves from level of free 
!                   convection to level of zero buoyancy [ Joules / kg ]
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:

      real, dimension(nlev_hires)     ::     env_tv, parcel_tv, dtdp, &
                                             delt, sum_xcape, &
                                             rc, fact1, fact2, fact3
      integer ::  klcl, klfc, klzb
      real    ::  tlcl, rlcl
      logical ::  cape_exit
      integer  :: k

      ermesg = ' ' ; error = 0


!--------------------------------------------------------------------
!  define parcel departure point values. convert mixing ratio to 
!  specific humidity.
!--------------------------------------------------------------------
      parcel_t(1:Param%istart) = env_t(1:Param%istart)
      parcel_r(1:Param%istart) = env_r(1:Param%istart)

      call don_c_calculate_lcl_k   &
           (nlev_hires, Param,             &
             parcel_t(Param%istart),   cape_p,   &
                          env_r, env_t, parcel_r, parcel_t, plcl,  &
                          tlcl, rlcl, klcl, cape_exit, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

      if (.not. cape_exit) then

!--------------------------------------------------------------------
!   if in debug mode, print out info on lcl in debug column.
!--------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, f19.10,i4, f20.14, e20.12)')  &
                           'in cape: plcl,klcl,tlcl,rlcl= ',   &
                             plcl    , klcl, tlcl, rlcl       
          write (diag_unit      , '(a, f19.10)')   &
                              'in cape: p(klcl)= ',  cape_p(klcl)
        endif
      else

!---------------------------------------------------------------------
!   if lcl not found, stop calculations in this column.
!---------------------------------------------------------------------
        plfc  = 0.0     
        plzb  = 0.0  
        coin  = 0.0
        xcape = 0.0
        return
      endif

!-------------------------------------------------------------------
!   calculate temperature along saturated adiabat, starting at p(klcl)
!   and a temperature tp to find the level of free convection and
!   the level of zero buoyancy. 
!--------------------------------------------------------------------
      call don_c_define_moist_adiabat_k  &
           (nlev_hires, klcl, Param, parcel_t(klcl), cape_p, env_r, &
            env_t, do_freezing, tfreezing, dfreezing, rmuz,  &
            use_constant_rmuz, carry_condensate, condensate_carried, &
            parcel_t, parcel_r, plfc, plzb, klfc, klzb,  &
            parcel_tv, env_tv, dtdp, rc, fact1, fact2, fact3, cape_exit,&
            ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return


      if (debug_ijt) then
        do k=klcl, klzb+1
          if (.not. (cape_exit)) then
            if  (k == klzb+1) then
            else
              write (diag_unit, '(a, i4, 2f20.14)')  &
                        'in cape: k,tv,tve= ',k,parcel_tv(k), env_tv(k)          
            endif
          else
            write (diag_unit, '(a, i4, 2f20.14)')  &
                        'in cape: k,tv,tve= ',k,parcel_tv(k), env_tv(k)          
          endif
          if (.not. cape_exit) then
            if (k == klzb ) then
              write (diag_unit, '(a, i4, 2f19.10)')  &
                                  'in cape: klzb,plzb,p(klzb)= ',  &
                                   klzb, plzb, cape_p(klzb)
            endif
          endif
          if (k /= klzb+1 .or. cape_exit) then
            if ( k == klzb .and. .not. cape_exit) then 
            else
              write (diag_unit, '(a, 3f17.10)')  &
                   'in cape: fact1,fact2,rc= ',fact1(k), fact2(k),rc(k)
              write (diag_unit, '(a, 2f17.10)') &
                           'in cape: fact1,fact3= ',fact1(k),fact3(k)
              write (diag_unit, '(a, f17.10)')  &
                            'in cape: dtdp= ',dtdp(k)
              write (diag_unit, '(a,  2f20.14)') &
                             'in cape: tc,t= ',parcel_t(k+1), env_t(k+1)
              write (diag_unit, '(a, f19.10, 2e20.12)') &
                   'in cape: p,r,rs= ',cape_p(k+1), env_r(k+1),   &
                                                         parcel_r(k+1)  
            endif
          endif
        end do
      endif
      if (cape_exit)  then
        coin  = 0.0
        xcape = 0.0
        return
      endif

!--------------------------------------------------------------------
!   if this was a call to calculate perturbed profile, bypass cape and
!   cin calculation, since only the tpc and rpc profiles are needed.
!--------------------------------------------------------------------
      if (coin_present) then

!-------------------------------------------------------------------
!   calculate convective inhibition.
!--------------------------------------------------------------------
        call don_c_calculate_cin_k   &
             (nlev_hires, diag_unit, debug_ijt, Param,  cape_p,  &
              parcel_r, env_r, parcel_t, env_t, plfc, cape_exit,   &
              coin, env_tv, parcel_tv, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (error /= 0 ) return

        if (.not. cape_exit) then
          if (debug_ijt) then
            do k=Param%istart,nlev_hires  
              if (parcel_tv(k) /= 0.0) then
                write (diag_unit, '(a, i4, 2f20.14)')  &
                            'in cape: k,tvc,tve= ', k,  &
                         parcel_tv(k), env_tv(k)
              endif
            end do
          endif
        else
          xcape = 0.
          return
        endif

!-------------------------------------------------------------------
!   if desired, print out lfc k index and pressure.
!-------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, i4, f19.10)')  &
                    'in cape: klfc, p(klfc)= ', klfc, cape_p(klfc)
        endif

        call don_c_calculate_cape_k   &
             (nlev_hires, klfc, Param, plzb, cape_p, parcel_r, env_r,   &
              parcel_t, env_t, xcape, delt, sum_xcape, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (error /= 0 ) return

!---------------------------------------------------------------------
!   print out cape and cape contribution from this level.
!---------------------------------------------------------------------
        if (debug_ijt) then
          do k=1, size(parcel_t(:))
            if (delt(k) /= 0.0) then
              write (diag_unit, '(a,i4, 2f12.8)')  &
                    'in cape: k,delt,xcape= ',k, delt(k), sum_xcape(k)  
            endif
          end do
        endif

!--------------------------------------------------------------------
!  print out diagnostics (cape, cin, tot), if desired.
!--------------------------------------------------------------------
        if (debug_ijt) then
          if (coin /= 0.0 .or. &
              xcape /= 0.0) then
            write (diag_unit      , '(a, f12.6, a)')  &
                      'in cape: cin= ',coin                ,' J/kg'
            write (diag_unit      , '(a, f12.6, a)')  &
                      'in cape: xcape= ',xcape    ,  ' J/kg'
            write (diag_unit      , '(a, f12.6, a)')  &
                       'in cape: tot= ',xcape - coin     ,' J/kg'
          endif
        endif

!--------------------------------------------------------------------
!  check for error in cape calculation. stop execution if present.
!--------------------------------------------------------------------
        if (xcape        .lt. 0.) then            
          ermesg =  ' xcape error -- value < 0.0 '
          error  = 1
        endif
      endif  ! (present(coin))

!---------------------------------------------------------------------


end subroutine don_c_displace_parcel_k

!#####################################################################

subroutine don_c_define_moist_adiabat_k  &
         (nlev_hires, klcl, Param, starting_temp, press, env_r,  &
          env_t, do_freezing, tfreezing, dfreezing, rmuz_constant, &
          use_constant_rmuz, carry_condensate, condensate_carried, &
          parcel_t, parcel_r, plfc, plzb, klfc, &
          klzb, parcel_tv, env_tv, dtdp, rc, fact1, fact2, fact3, &
          cape_exit, ermesg, error)

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------

use donner_types_mod, only : donner_param_type 
use sat_vapor_pres_k_mod, only: compute_mrs_k

implicit none 

!----------------------------------------------------------------------
integer,                      intent(in)    :: nlev_hires, klcl
type(donner_param_type),      intent(in)    :: Param
real,                         intent(in)    :: starting_temp
real, dimension(nlev_hires),  intent(in)    :: press, env_r, env_t
logical,                      intent(in)    :: do_freezing,  &
                                               use_constant_rmuz, &
                                               carry_condensate
real,                         intent(in)    :: tfreezing, dfreezing, &
                                               rmuz_constant, &
                                               condensate_carried
real, dimension(nlev_hires),  intent(inout) :: parcel_t, parcel_r     
real,                         intent(out)   :: plfc, plzb 
integer,                      intent(out)   :: klfc, klzb
real, dimension(nlev_hires),  intent(out)   :: parcel_tv, env_tv, dtdp, &
                                               rc, fact1, fact2, fact3
logical,                      intent(out)   :: cape_exit
character(len=*),             intent(out)   :: ermesg
integer,                      intent(out)   :: error

      real     :: es_v_s, qe_v_s, rs_v_s, qs_v_s, pb, tp_s
      real,dimension(nlev_hires)     :: rmuz, z, fact7
      real     :: dz
      real     :: hlvls
      logical  :: capepos_s 
      integer  :: ieqv_s
      integer  :: k, nbad
      logical  :: not_all_frozen    
      real     :: cumulative_freezing, prev_cufr
      real     :: available_cd, r_at_cb, condensate_to_freeze
      logical  :: first_freezing_level

      ermesg = ' ' ; error = 0

      plfc = 0.0     
      plzb = 0.0  
      klfc = nlev_hires - 1
      klzb = nlev_hires - 1
      capepos_s = .false.
      cape_exit = .false.
      tp_s = starting_temp
      z = 0.

      first_freezing_level = .true.
      fact7 = 0.
      not_all_frozen = .true.
      prev_cufr = 0.
      if (carry_condensate .and. do_freezing) then
        do k=klcl,nlev_hires-1
          if (env_t(k) < tfreezing .and. not_all_frozen) then
            cumulative_freezing = (tfreezing-env_t(k))/dfreezing
            if (cumulative_freezing >= 1.0) then
              cumulative_freezing = 1.0         
              not_all_frozen = .false.
            endif
            fact7(k) = cumulative_freezing - prev_cufr  
            prev_cufr = cumulative_freezing
            if (.not. not_all_frozen) exit
          endif
        end do
      endif
          
!-------------------------------------------------------------------
!    calculate temperature along saturated adiabat, starting at p(klcl)
!    and a temperature tp to find the level of free convection and
!    the level of zero buoyancy. 
!--------------------------------------------------------------------
      do k=klcl,nlev_hires-1

!--------------------------------------------------------------------
!    if pressure has gone below the minimum at which deep convection 
!    is allowed, set flag to end calculation in this column.
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!    define saturation vapor pressure for the parcel.
!--------------------------------------------------------------------
        call compute_mrs_k (tp_s, press(k), Param%D622, Param%D608, &
                            rs_v_s, nbad,  esat = es_v_s)

!---------------------------------------------------------------------
!    save the cloud base r so that the condensate available when 
!    reaching the level where freezing begins may be determined. 
!---------------------------------------------------------------------
        if (k == klcl) then
          r_at_cb = rs_v_s
        endif
        if ( first_freezing_level) then
          available_cd = r_at_cb - rs_v_s
        endif
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (nbad /= 0) then
          ermesg = 'subroutine don_c_define_moist_adiabat_k: Temperatures out of range of esat table'
          error  = 1
          return
        endif

!--------------------------------------------------------------------
!    define the environmental and parcel virtual temperature and specific
!    humidity.
!--------------------------------------------------------------------
        qe_v_s = env_r(k)/(1. + env_r(k))
        env_tv(k) = env_t(k)*(1.+ Param%D608*qe_v_s   )
        qs_v_s = rs_v_s/(1. + rs_v_s)
        parcel_tv(k) = tp_s*(1. + Param%D608*qs_v_s   )

!--------------------------------------------------------------------
!    determine whether the parcel temperature is cooler or warmer than 
!    the environment.
!--------------------------------------------------------------------
        call don_u_numbers_are_equal_k  &
             (parcel_tv(k), env_tv(k), ermesg, error, ieqv_s)
   
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (error /= 0 ) return

!---------------------------------------------------------------------
!    integrate parcel upward, finding level of free convection and 
!    level of zero buoyancy.
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!    determine if the level of free convection has been reached. 
!-------------------------------------------------------------------
        if ((ieqv_s >= 0) .and. (.not. capepos_s)) then
          capepos_s    = .true.
          plfc = press(k)  
          klfc = k
        endif

!-------------------------------------------------------------------
!   determine if the level of zero buoyancy has been reached.  if so,
!   set flag so that calculation will be ended in this column.
!-------------------------------------------------------------------
        if ((ieqv_s < 0) .and. (capepos_s)) then
          klzb = k
          plzb = (press(k) + press(k-1))/2.
          parcel_t(k+1:nlev_hires) = env_t(k+1:nlev_hires)
          parcel_r(k+1:nlev_hires) = env_r(k+1:nlev_hires)
          exit

!---------------------------------------------------------------------
!   if not, continue moving parcel up pseudo-adiabat to next cape-
!   calculation pressure level. define new parcel temperature and
!   mixing ratio at this level; if temperature is colder than allowed,
!   end integration.
!-------------------------------------------------------------------
        else   !  (cape is pos, parcel warmer than env)
          klzb    = 0
          if (do_freezing) then
            if (tp_s .gt. tfreezing) then
              hlvls = Param%hlv
            else if (tp_s .le. (tfreezing - dfreezing)) then
              hlvls = Param%hls
            else
              hlvls = (tfreezing - tp_s)*Param%hls + &
                      (tp_s - (tfreezing -dfreezing))*Param%hlv
              hlvls = hlvls/dfreezing 
            endif
          else
            hlvls = Param%hlv
          endif
          rc(k) = (1. - qs_v_s)*Param%rdgas + qs_v_s*Param%rvgas
          pb = 0.5*(press(k) + press(k+1))

!---------------------------------------------------------------------
!     define the entrainment coefficient (rmuz) [ m (-1) ] .
!     z is the height above cloud base [ m ] .
!     dz is the height increment for the current layer.
!---------------------------------------------------------------------
          if (use_constant_rmuz) then
            rmuz(k) = rmuz_constant
          else
            if (k == klcl)  then
              rmuz(klcl) = rmuz_constant
              z(klcl) = 0.  
            else
              dz = - alog((press(k)/press(k-1)))*Param%rdgas*  &
                    parcel_tv(k)/Param%grav
              z(k) = z(k-1) + dz
              rmuz(k) = rmuz_constant/( 1.0 + rmuz_constant*z(k))
            endif
          endif

          fact1(k) = Param%rdgas/Param%cp_air
          fact2(k) = parcel_tv(k) + (hlvls*rs_v_s/rc(k))
          fact1(k) = fact1(k)*fact2(k) +                  &
                     Param%rdgas*env_tv(k)*rmuz(k)*(tp_s-env_t(k)   &
                    + (hlvls*(rs_v_s-env_r(k))/Param%cp_air))/Param%grav
          fact3(k) = Param%d622*(hlvls**2)*es_v_s/    &
                     (Param%cp_air*pb*Param%rvgas*(parcel_tv(k)**2))
          fact3(k) = 1. + fact3(k)

!---------------------------------------------------------------------
!    calculate the term associated with the freezing of condensate 
!    carried along in the plume (fact7).  condensate_to_freeze is the
!    amount of condensate present at the level where freezing begins.
!    it is proportionately frozen over the specified range of freezing. 
!    term may be optionally included when cape is 
!    computed for cumulus closure determination.
!---------------------------------------------------------------------
          if (fact7(k) /= 0.0 .and. first_freezing_level) then
            condensate_to_freeze =    &
                                 MIN(available_cd, condensate_carried)
            first_freezing_level = .false.
          endif
          fact7(k) = Param%hlf*fact7(k)*condensate_to_freeze/  &
                    (Param%cp_air*alog(press(k+1)/press(k)))
          dtdp(k) = (fact1(k) + fact7(k))/fact3(k)
          tp_s    = tp_s + dtdp(k)*alog(press(k+1)/press(k))
          if (tp_s < Param%tmin)  then
            cape_exit = .true.
            parcel_t(k+1) = tp_s
            parcel_r(k+1) = rs_v_s
            parcel_t(k+2:nlev_hires) = env_t(k+2:nlev_hires)
            parcel_r(k+2:nlev_hires) = env_r(k+2:nlev_hires)
            exit  ! exit k loop
          else
            parcel_t(k+1) = tp_s   
            parcel_r(k+1) = rs_v_s   
          endif
        endif   !  (ieq < 0, capepos)
      end do   ! k loop


!-------------------------------------------------------------------


end subroutine don_c_define_moist_adiabat_k



!####################################################################

subroutine don_c_calculate_cin_k    &
         (nlev_hires, diag_unit, debug_ijt, Param, press, parcel_r,   &
          env_r, parcel_t, env_t, plfc, cape_exit, coin,   &
          env_tv, parcel_tv, ermesg, error)

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------

use donner_types_mod, only : donner_param_type

implicit none

!----------------------------------------------------------------------
integer,                     intent(in)  :: nlev_hires
integer,                     intent(in)  :: diag_unit
logical,                     intent(in)  :: debug_ijt            
type(donner_param_type),     intent(in)  :: Param
real, dimension(nlev_hires), intent(in)  :: press, parcel_r, env_r,   &
                                            parcel_t, env_t
real,                        intent(in)  :: plfc
logical,                     intent(out) :: cape_exit
real,                        intent(out) :: coin
real,dimension(nlev_hires),  intent(out) :: env_tv, parcel_tv
character(len=*),            intent(out) :: ermesg
integer,                     intent(out) :: error

      real      ::   rbc, rbe, qc, qe, tvc_v_s, tve_v_s, delt
      integer   ::   ieqv_s
      integer   ::   k

!----------------------------------------------------------------------
      ermesg = ' ' ; error = 0
      coin = 0.
      cape_exit = .false.

      parcel_tv(1:Param%istart) = 0.
      env_tv(1:Param%istart) = 0.

!-------------------------------------------------------------------
!   calculate convective inhibition.
!--------------------------------------------------------------------
      do k=Param%istart,nlev_hires-1

!------------------------------------------------------------------
!   determine if sounding fails to produce a level of free convection.
!   if so, set flag to avoid cape calculation. If desired, print out
!   columns where lcl exists, but no lfc. No cin exists above the lfc,
!   and the lfc if it exists must be below UPPER_LIMIT_FOR_LFC.
!------------------------------------------------------------------
        if (press(k+1) <= Param%upper_limit_for_lfc) then
          cape_exit    = .true.
          exit   ! exit k loop
        endif

!--------------------------------------------------------------------
!    define the specific humidity and virtual temperature of the
!    parcel and environment.
!--------------------------------------------------------------------
        rbc = (parcel_r(k) + parcel_r(k+1))/2.
        rbe = (env_r(k) + env_r(k+1))/2.
        qc = rbc/(1. + rbc)
        qe = rbe/(1. + rbe)
        tvc_v_s  = (parcel_t(k) + parcel_t(k+1))/2.
        tve_v_s  = (env_t(k) + env_t(k+1))/2.
        tvc_v_s  = tvc_v_s*(1. + Param%d608*qc)
        tve_v_s  = tve_v_s*(1. + Param%d608*qe)

        env_tv(k) = tve_v_s
        parcel_tv(k) = tvc_v_s

!---------------------------------------------------------------------
!   determine whether the parcel temperature is cooler or warmer than 
!   the environment.
!--------------------------------------------------------------------
        call don_u_numbers_are_equal_k   &
             (tvc_v_s, tve_v_s, ermesg, error, ieqv_s )
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (error /= 0 ) return

!---------------------------------------------------------------------
!   add the contribution to cin from this pressure layer.
!---------------------------------------------------------------------
        if ((ieqv_s < 0) .or.      &
            (press(k) > plfc))  then
          delt  = Param%rdgas*(tvc_v_s - tve_v_s)*   &
                      alog(press(k)/press(k+1))
          coin = coin - delt   
        else

!------------------------------------------------------------------
!   determine if sounding fails to produce a level of free convection.
!   if so, set flag to avoid cape calculation. If desired, print out
!   columns where lcl exists, but no lfc.
!------------------------------------------------------------------
          parcel_tv(k+1:nlev_hires) = 0.0
          env_tv(k+1:nlev_hires) = 0.0
          exit
        endif
      end do  ! k loop

!--------------------------------------------------------------------


end subroutine don_c_calculate_cin_k



!######################################################################

subroutine don_c_calculate_cape_k  &
         (nlev_hires, klfc, Param,plzb, press, parcel_r, env_r, &
          parcel_t, env_t, xcape, delt, sum_xcape, ermesg, error)

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------

use donner_types_mod, only : donner_param_type

implicit none 

!----------------------------------------------------------------------
integer,                     intent(in)  :: nlev_hires, klfc
type(donner_param_type),     intent(in)  :: Param
real,                        intent(in)  :: plzb
real, dimension(nlev_hires), intent(in)  :: press, parcel_r, env_r,   &
                                            parcel_t, env_t
real,                        intent(out) :: xcape
real, dimension(nlev_hires), intent(out) :: delt, sum_xcape      
character(len=*),            intent(out) :: ermesg
integer,                     intent(out) :: error

      real    :: rbc, rbe, qc, qe, tvc_v_s, tve_v_s
      integer :: ieqv_s
      integer :: k

      ermesg = ' ' ; error = 0

      xcape = 0.
      delt(1:klfc) = 0.0
      sum_xcape(1:klfc) = 0.0

!--------------------------------------------------------------------
!  calculate convective available potential energy.
!--------------------------------------------------------------------
      do k=klfc,nlev_hires-1

!--------------------------------------------------------------------
!  define flag to indicate which columns are actively computing cape.
!-------------------------------------------------------------------
        if (press(k+1) > plzb) then

!--------------------------------------------------------------------
!  define virtual temperature and specific humidity of parcel and 
!  environment.
!-------------------------------------------------------------------
          rbc = (parcel_r(k)+parcel_r(k+1))/2.
          rbe = (env_r(k)+env_r(k+1))/2.
          qc = rbc/(1. + rbc)
          qe = rbe/(1. + rbe)
          tvc_v_s = (parcel_t(k)+parcel_t(k+1))/2.
          tve_v_s = (env_t(k)+env_t(k+1))/2.
          tvc_v_s = tvc_v_s*(1. + Param%d608*qc)
          tve_v_s = tve_v_s*(1. + Param%d608*qe)

!--------------------------------------------------------------------
!   determine whether the parcel temperature is cooler or warmer than 
!   the environment.
!--------------------------------------------------------------------
          call don_u_numbers_are_equal_k   &
               (tvc_v_s, tve_v_s, ermesg, error, ieqv_s)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (error /= 0 ) return


!---------------------------------------------------------------------
!   add the contribution to column cape from this pressure layer.
!---------------------------------------------------------------------
          if (ieqv_s >= 0) then
            delt(k) = Param%rdgas*(tvc_v_s - tve_v_s)*    &
                      alog(press(k)/press(k+1))
            sum_xcape(k) = sum_xcape(k-1) + delt(k)   
          endif

!---------------------------------------------------------------------
!   print out cape and cape contribution from this level.
!---------------------------------------------------------------------
        else
          delt(k:nlev_hires) = 0.0
          sum_xcape(k:nlev_hires) = sum_xcape(k-1)
          xcape = sum_xcape(k-1)
          exit
        endif
      end do  ! end of k loop

!-----------------------------------------------------------------------


end subroutine don_c_calculate_cape_k



!######################################################################

subroutine don_c_generate_cape_sounding_k   &
         (nlev_lsm, nlev_hires, temp, mixing_ratio, pfull, model_t, &
          model_r, model_p, cape_p, env_t, env_r, ermesg, error)  

implicit none

!-------------------------------------------------------------------
!    subroutine generate_cape_sounding reverses the vertical index and
!    saves the input temperature (temp) and vapor mixing ratio 
!    (mixing_ratio) fields on the large-scale model pressure grid 
!    (pfull) as model_t, model_r and model_p. these output variables
!    have index 1 nearest the surface, while the input fields have index
!    1 nearest the upper boundary. after reversal, the fields are 
!    interpolated onto an enhanced vertical grid defined by cape_p, 
!    producing output fields of temperature (env_t) and mixing ratio 
!    (env_r) on the enhanced grid. these fields also have index 1 near-
!    est the surface.
!-------------------------------------------------------------------

integer,                     intent(in)  :: nlev_lsm, nlev_hires
real, dimension(nlev_lsm),   intent(in)  :: temp, mixing_ratio, pfull
real, dimension(nlev_lsm),   intent(out) :: model_t, model_r, model_p
real, dimension(nlev_hires), intent(out) :: cape_p, env_t, env_r
character(len=*),            intent(out) :: ermesg
integer,                     intent(out) :: error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!      temperature      temperature profile on large-scale model grid 
!                       that is to be used for the cape calculation 
!                       [ deg K ]
!      mixing_ratio     water vapor mixing ratio profile on the large-
!                       scale model grid that is to be used in the cape 
!                       calculation [ kg(h2o) / kg(dry air) ]
!      pfull            large-scale model full-level pressure profile 
!                       [ Pa ]
!
!   intent(out) variables:
!
!      model_t          large-scale model temperature field with vert-
!                       ical index 1 nearest the surface [ deg K ]
!      model_r          large-scale model vapor mixing ratio field with
!                       vertical index 1 nearest the surface 
!                       [ kg(h2o) /kg(dry air) ]
!      model_p          large-scale model pressure field with vertical
!                       index 1 nearest the surface [ Pa ]
!      cape_p           high-resolution pressure profile used for cape 
!                       calculation. index 1 nearest surface.  [ Pa ]
!      env_t            high-resolution temperature profile used for 
!                       cape calculation. index 1 nearest surface. 
!                       [ deg K ]
!      env_r            high-resolution vapor mixing ratio profile used
!                       for cape calculation. index 1 nearest thea
!                       surface. [ kg(h2o) / kg(dry air) ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      real     :: dp     ! pressure difference between levels in 
                         ! high-resolution model [ Pa ]
      integer  :: k      ! do-loop indices


      ermesg = ' ' ; error = 0

!--------------------------------------------------------------------
!    create arrays of moisture, temperature and pressure having vertical
!    index 1 being closest to the surface. require that the mixing ratio
!    be non-negative.
!--------------------------------------------------------------------
      do k=1,nlev_lsm
        model_r(nlev_lsm+1-k) = amax1 (mixing_ratio(k), 0.0e00)
        model_t(nlev_lsm+1-k) = temp (k)
        model_p(nlev_lsm+1-k) = pfull(k)
      end do

!-------------------------------------------------------------------
!   define the vertical resolution of the convection parameterization
!   grid. define the top level pressure in that grid to be zero.
!   interpolate to define the pressure levels of that grid.
!-------------------------------------------------------------------
      dp = (model_p(1) - model_p(nlev_lsm))/(nlev_hires-1)
      cape_p(nlev_hires) = 0.
      do k=1,nlev_hires-1
        cape_p(k) = model_p(1) - (k-1)*dp     
      end do

!--------------------------------------------------------------------
!   call map_lo_res_col_to_hi_res_col to interpolate the large-scale
!   model grid values of temperature and vapor mixing ratio to the vert-
!   ical grid to be used for the cape calculation. ensure that the 
!   vapor mixing ratio field is positive-definite.
!--------------------------------------------------------------------
      call don_u_lo1d_to_hi1d_k    &
           (nlev_lsm, nlev_hires, model_t, model_p, cape_p,   &
            env_t, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

      call don_u_lo1d_to_hi1d_k    &
           (nlev_lsm, nlev_hires, model_r, model_p, cape_p,    &
            env_r, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

      do k=1,nlev_hires
         env_r(k) = MAX(env_r(k), 0.0)
      end do

!--------------------------------------------------------------------


end subroutine don_c_generate_cape_sounding_k

!#####################################################################

subroutine don_c_integrate_vapor_k   &
           (nlev_hires, Param, env_r, cape_p, qint, ermesg, error)

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
use donner_types_mod, only : donner_param_type

implicit none

!----------------------------------------------------------------------
integer,                      intent(in)  :: nlev_hires
type(donner_param_type),      intent(in)  :: Param
real, dimension(nlev_hires),  intent(in)  :: env_r, cape_p
real,                         intent(out) :: qint            
character(len=*),             intent(out) :: ermesg
integer,                      intent(out) :: error

      integer  ::  k
      real     ::  sum

      ermesg= ' ' ; error = 0

      sum  = env_r(1)*(cape_p(1) - cape_p(2))
      do k=2,nlev_hires-1
        sum = sum + env_r(k)*0.5*(cape_p(k-1) - cape_p(k+1))
      end do
      sum = sum + env_r(nlev_hires)*    &
                             (cape_p(nlev_hires-1) - cape_p(nlev_hires))
      qint = sum/Param%grav 

!---------------------------------------------------------------------


end subroutine don_c_integrate_vapor_k



!#####################################################################


subroutine don_c_cape_diagnostics_k   &
         (isize, jsize, nlev_lsm, nlev_hires, Col_diag, Don_cape,  &
          exit_flag, ermesg, error)

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------

use donner_types_mod, only : donner_column_diag_type, donner_cape_type

implicit none

!----------------------------------------------------------------------
integer,                         intent(in)    :: isize, jsize,   &
                                                  nlev_lsm, nlev_hires
type(donner_column_diag_type),   intent(in)    :: Col_diag
type(donner_cape_type),          intent(inout) :: Don_cape
logical, dimension(isize,jsize), intent(in)    :: exit_flag
character(len=*),                intent(out)   :: ermesg
integer,                         intent(out)   :: error


      integer  :: idiag, jdiag, unitdiag
      integer  :: n, k

      ermesg= ' ' ; error = 0

      
!---------------------------------------------------------------------
!    if desired, print out debug quantities.
!---------------------------------------------------------------------
      if (Col_diag%in_diagnostics_window) then
        do n=1,Col_diag%ncols_in_window
          idiag = Col_diag%i_dc(n)
          jdiag = Col_diag%j_dc(n)
          unitdiag = Col_diag%unit_dc(n)
          if ( .not. exit_flag(idiag, jdiag)) then
            if (Don_cape%plfc(idiag,jdiag) /= 0.0 .and.  &
                Don_cape%plzb(idiag,jdiag) /= 0.0 ) then
              do k=1,nlev_lsm - Col_diag%kstart+1 
                write (unitdiag, '(a, i4, f20.14, e20.12, e15.5)') &
                       'calculate_cape input profiles:&
                        & k,temp, mixing ratio, pressure',  k,  &
                        Don_cape%model_t(idiag,jdiag,k), &
                        Don_cape%model_r(idiag,jdiag,k), &
                        Don_cape%model_p(idiag,jdiag,k)
               end do
               write (Col_diag%unit_dc(n), '(a, 2f19.10)')  &
                         'in donner_deep: plfc,plzb= ',  &
                          Don_cape%plfc(idiag,jdiag),  & 
                          Don_cape%plzb(idiag,jdiag)
            endif 
            write (unitdiag, '(a, 3f19.10)')  &
                     'in donner_deep: plcl,coin,xcape= ',   &
                     Don_cape%plcl(idiag,jdiag),  &
                     Don_cape%coin(idiag,jdiag),   &
                     Don_cape%xcape(idiag,jdiag)
            if (Don_cape%plfc(idiag,jdiag) /= 0.0 .and.  &
                Don_cape%plzb(idiag,jdiag) /= 0.0 ) then
              do k=1,nlev_hires              
                write (unitdiag, '(a, i4, f19.10)') &
                  'in donner_deep: k,cape_p= ',k,  &
                      Don_cape%cape_p(idiag,jdiag,k)
                write (unitdiag, '(a, i4, 2f20.14)')  &
                   'in donner_deep: k,tcape,tpca= ',k,   &
                    Don_cape%env_t(idiag,jdiag,k),   &
                    Don_cape%parcel_t(idiag,jdiag,k)
                write (unitdiag, '(a, i4, 2e20.12)')  &
                    'in donner_deep: k,rcape,rpca= ',k,   &
                    Don_cape%env_r(idiag,jdiag,k),    &
                    Don_cape%parcel_r(idiag,jdiag,k)
                if (Don_cape%cape_p(idiag,jdiag,k) <     &
                    Don_cape%plzb(idiag,jdiag))  exit
              end do
            endif
            write (unitdiag, '(a, f20.10)')  &
               'integrate_vapor: qint= ',    &
                   Don_cape%qint(idiag,jdiag)  
          endif 
        end do  ! (n loop)
      endif

!---------------------------------------------------------------------



end subroutine don_c_cape_diagnostics_k 


!####################################################################

subroutine don_c_calculate_lcl_k    &
         (nlev_hires, Param, starting_temp, press, env_r, env_t, &
          parcel_r, parcel_t, plcl, tlcl, rlcl, klcl, cape_exit, ermesg, error)

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------

use donner_types_mod, only :  donner_param_type
use sat_vapor_pres_k_mod, only: compute_qs_k

implicit none

!---------------------------------------------------------------------
integer,                     intent(in)    :: nlev_hires
type(donner_param_type),     intent(in)    :: Param
real,                        intent(in)    :: starting_temp
real, dimension(nlev_hires), intent(in)    :: press, env_r, env_t 
real, dimension(nlev_hires), intent(inout) :: parcel_r, parcel_t      
real,                        intent(out)   :: plcl, tlcl, rlcl
integer,                     intent(out)   :: klcl
logical,                     intent(out)   :: cape_exit
character(len=*),            intent(out)   :: ermesg
integer,                     intent(out)   :: error

      real     :: qs_v_s, dtdp_v_s, dt_v_s, cp_v_s, q_ve_s, tp_s
      integer  :: ieqv_s       
      integer  :: k, nbad
      
!----------------------------------------------------------------------
!----------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!----------------------------------------------------------------------
!----------------------------------------------------------------------
      q_ve_s    = parcel_r(Param%istart)/( 1. + parcel_r(Param%istart))
      cp_v_s    = Param%cp_air*(1. +             &
                             ((Param%cp_vapor/Param%cp_air) - 1.)*q_ve_s)
      plcl = 0.0     
      klcl = nlev_hires - 1
      cape_exit = .false.
      tp_s = starting_temp

!--------------------------------------------------------------------
!  move the parcel upwards to find the lcl in the column.
!--------------------------------------------------------------------
      do k=Param%istart,nlev_hires  ! k loop to find lcl

!--------------------------------------------------------------------
!  if the temperature and pressure are still within limits, continue 
!  parcel movement. determine saturation specific humidity for parcels 
!  at this level.
!---------------------------------------------------------------------
        if (tp_s >= Param%tmin .and.      &
            press(k) >= Param%upper_limit_for_lcl) then
          call compute_qs_k (tp_s, press(k), Param%d622, Param%d608, &
                             qs_v_s, nbad, q = q_ve_s)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (nbad /= 0) then
            ermesg = 'subroutine don_c_calculate_lcl_k: Temperatures out of range of esat table'
            error  = 1
          endif

!--------------------------------------------------------------------
!  check if the parcel is now saturated.
!---------------------------------------------------------------------
          call don_u_numbers_are_equal_k  &
               (qs_v_s, q_ve_s, ermesg, error, ieqv_s)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (error /= 0 ) return

!--------------------------------------------------------------------
!   if saturation is exact or if parcel is super-saturated at its 
!   starting level, save pressure, temp, mixing ratio and cloud base 
!   level. exit vertical loop.
!--------------------------------------------------------------------
          if ( (ieqv_s ==  0) .or. &
               (ieqv_s < 0 .and. k == Param%istart)) then
            plcl = press(k)  
            rlcl = env_r(k)
            tlcl = env_t(k)
            klcl = k
            exit
          endif

!--------------------------------------------------------------------
!   if parcel is super-saturated, define cloud-base pressure, temp 
!   and mixing ratio as the average value between the current level
!   and the next lower level, and this level as the cloud base level.
!   exit the column.
!--------------------------------------------------------------------
          if (ieqv_s < 0) then
            plcl = (press(k) + press(k-1))/2.
            tlcl = (env_t(k) + env_t(k-1))/2.
            rlcl = (env_r(k) + env_r(k-1))/2.
            klcl = k
            exit

!---------------------------------------------------------------------
!    if the parcel remains unsaturated at this level and the top of the 
!    model has not been reached, move parcel along dry adiabat to next 
!    pressure level. define temperature at this level; verify that it 
!    is warmer than tmin. save parcel temperature and mixing ratio at 
!    this next higher level.
!---------------------------------------------------------------------
          else  ! (ieqv_s < 0) 
            if (k < nlev_hires) then
              dtdp_v_s = Param%rdgas*tp_s/cp_v_s   
              dt_v_s = dtdp_v_s*alog( press(k+1)/press(k))
              tp_s = tp_s + dt_v_s    
              if (tp_s < Param%tmin)  then
                cape_exit = .true.
                parcel_t(k+1:nlev_hires) = env_t(k+1:nlev_hires)
                parcel_r(k+1:nlev_hires) = env_r(k+1:nlev_hires)
                exit
              else  
                parcel_t(k+1) = tp_s   
                parcel_r(k+1) = parcel_r(Param%istart)
              endif

!-------------------------------------------------------------------
!    if have reached top of model, set flag to stop integration in this
!    column.
!-------------------------------------------------------------------
            else
              cape_exit    = .true.
            endif
          endif ! (ieqv_s < 0)

!--------------------------------------------------------------------
!    if either parcel temperature or pressure is below cutoff values,
!    set remainder of parcel sounding to the environment and stop 
!    searching in this column.
!--------------------------------------------------------------------
        else
          parcel_t(k+1:nlev_hires) = env_t(k+1:nlev_hires)
          parcel_r(k+1:nlev_hires) = env_r(k+1:nlev_hires)
          cape_exit = .true.
        endif
      end do   ! k loop to find lcl

!------------------------------------------------------------------


end subroutine don_c_calculate_lcl_k



!#####################################################################

      module MO_FPHOTO_MOD
!----------------------------------------------------------------------
!        ... Read FAST-JX Photolysis rates and pass them to chemdr
!            June. 1st, 2010
!            Junfeng.Liu
!----------------------------------------------------------------------
      use mpp_mod,              only : mpp_error
      use fms_mod,              only : write_version_number,    &
                                       mpp_pe,                  &
                                       mpp_root_pe,             &
                                       mpp_clock_begin, mpp_clock_end, &
                                       mpp_clock_id, CLOCK_MODULE, &
                                       error_mesg, FATAL
      use tracer_manager_mod,   only : get_tracer_index,   &
                                       get_number_tracers, &
                                       get_tracer_names,   &
                                       get_tracer_indices
      use field_manager_mod,    only : MODEL_ATMOS       
      use MO_FASTJX_MOD,        only : JVN_, fastjx_init, fastjx_end, fastjx_photo
      use sat_vapor_pres_mod, only : compute_qs      
         
      implicit none
      private
      public :: fprate_init, fphoto

      character(len=128)            :: version     = '$Id: mo_fphoto.F90,v 19.0 2012/01/06 20:33:54 fms Exp $'
      character(len=128)            :: tagname     = '$Name: tikal $'

      integer ::  fastjx_clock
      integer, parameter :: jdim     = JVN_     ! number of fastjx species 62
      integer ::  indexer(jdim)                 ! index corresponding to AM3 J order 
      
      integer ::  jno_ndx, jpooh_ndx, jc2h5ooh_ndx, jc3h7ooh_ndx, jrooh_ndx, &
                  jch3co3h_ndx, jmpan_ndx, jmacr_a_ndx, jmacr_b_ndx, jonitr_ndx, &
                  jxooh_ndx, jisopooh_ndx, jglyald_ndx, jhyac_ndx, jch3ooh_ndx, &
                  jh2o2_ndx, jpan_ndx, jch3cho_ndx, &
                  jn2o5_ndx, jo3p_ndx, jno2_ndx, jno3_ndx, &
                  jclono2_ndx, jhocl_ndx, jcl2o2_ndx, jbrono2_ndx, jhobr_ndx, &
                  jbrcl_ndx, jbro_ndx, jcl2_ndx, jh2o_ndx, jn2o_ndx, jhno3_ndx, &
!jul++
                  jmek_ndx, jbigald_ndx, jglyoxal_ndx, jalkooh_ndx, jmekooh_ndx, &
                  jtolooh_ndx, jterpooh_ndx, jacet_ndx, jmgly_ndx
      integer ::  jh2o2a_ndx, jhno2_ndx, jo3a_ndx , jo1d_ndx 
      integer ::  so4_ndx, bc1_ndx, bc2_ndx, oc1_ndx, oc2_ndx, soa_ndx, &
                  ssa_ndx(5), dust_ndx(5)   
!jul--
      integer ::  ox_ndx, o3_ndx, nqa, nqi, nql, nqq
 
      integer, parameter :: & 
         TAB_NDX_JO2            = 1, &
         TAB_NDX_JO3            = 2, & 
         TAB_NDX_JO1D           = 3, & 
         TAB_NDX_JNO            = 4, & 
         TAB_NDX_JH2COa         = 5, & 
         TAB_NDX_JH2COb         = 6, & 
         TAB_NDX_JH2O2          = 7, & 
         TAB_NDX_JCH3OOH        = 8, & 
         TAB_NDX_JNO2           = 9, & 
         TAB_NDX_JNO3           = 10, & 
         TAB_NDX_JN2O5          = 11, & 
         TAB_NDX_JHNO2          = 12, & 
         TAB_NDX_JHNO3          = 13, & 
         TAB_NDX_JHNO4          = 14, & 
         TAB_NDX_JClNO3a        = 15, & 
         TAB_NDX_JClNO3b        = 16, & 
         TAB_NDX_JCl2           = 17, & 
         TAB_NDX_JHOCl          = 18, & 
         TAB_NDX_JOClO          = 19, & 
         TAB_NDX_JCl2O2         = 20, & 
         TAB_NDX_JClO           = 21, & 
         TAB_NDX_JBrO           = 22, & 
         TAB_NDX_JBrNO3         = 23, & 
         TAB_NDX_JHOBr          = 24, & 
         TAB_NDX_JBrCl          = 25, & 
         TAB_NDX_JN2O           = 26, & 
         TAB_NDX_JCFCl3         = 27, & 
         TAB_NDX_JCF2Cl2        = 28, & 
         TAB_NDX_JF113          = 29, & 
         TAB_NDX_JF114          = 30, & 
         TAB_NDX_JF115          = 31, & 
         TAB_NDX_JCCl4          = 32, & 
         TAB_NDX_JCH3Cl         = 33, & 
         TAB_NDX_JMeCCl3        = 34, & 
         TAB_NDX_JCH2Cl2        = 35, & 
         TAB_NDX_JCHF2Cl        = 36, & 
         TAB_NDX_JF123          = 37, & 
         TAB_NDX_JF141b         = 38, & 
         TAB_NDX_JF142b         = 39, & 
         TAB_NDX_JCH3Br         = 40, & 
         TAB_NDX_JH1211         = 41, & 
         TAB_NDX_JH1301         = 42, & 
         TAB_NDX_JH2402         = 43, & 
         TAB_NDX_JCH2Br2        = 44, & 
         TAB_NDX_JCHBr3         = 45, & 
         TAB_NDX_JCH3I          = 46, & 
         TAB_NDX_JCF3I          = 47, & 
         TAB_NDX_JOCS           = 48, & 
         TAB_NDX_JPAN           = 49, & 
         TAB_NDX_JCH3NO3        = 50, &  
         TAB_NDX_JActAld        = 51, &  
         TAB_NDX_JMeVK          = 52, &  
         TAB_NDX_JMeAcr         = 53, &  
         TAB_NDX_JGlyAld        = 54, &  
         TAB_NDX_JMEKeto        = 55, &  
         TAB_NDX_JEAld          = 56, &  
         TAB_NDX_JMGlyxl        = 57, &  
         TAB_NDX_JGlyxla        = 58, &  
         TAB_NDX_JGlyxlb        = 59, &  
         TAB_NDX_JAcet_a        = 60, &  
         TAB_NDX_JAcet_b        = 61, &  
         TAB_NDX_JHYAC          = 62  
!      logical :: use_tdep_jvals, use_solar_cycle
         real                   :: o3_column_top  !
         logical                :: module_is_initialized = .false.
      CONTAINS
     
      
!--------------------------------------------------      
! <SUBROUTINE NAME="fprate_init">
!   <OVERVIEW>
!     Initialize FAST-JX photolysis rate calculation, must be called after chemini
!   </OVERVIEW>
!   <DESCRIPTION>
!     This subroutine initializes the calculation of FASTJX photolysis rates
!     from the TUV lookup table
!   </DESCRIPTION>
!   <TEMPLATE>
!     call fprate_init( o3_column_top_in)
!   </TEMPLATE>
!   <IN NAME="o3_column_top_in" TYPE="real">
!     Ozone column above model top (DU)
!   </IN>

  subroutine fprate_init(o3_column_top_in)
!----------------------------------------------------------------------
!     ... Initialize FAST-JX module 
!----------------------------------------------------------------------        
      use mo_chem_utls_mod,  only : get_spc_ndx, get_rxt_ndx   

      implicit none
!----------------------------------------------------------------------
!        ... Dummy args
!----------------------------------------------------------------------
      real,             intent(in) :: o3_column_top_in !(DU)

!----------------------------------------------------------------------
!        ... Local variables
!----------------------------------------------------------------------
      integer    :: it500, it200, izen, ialb, idob
      integer    :: ios
      integer    :: unit
      character(len=128) :: msg     
      
      if (module_is_initialized) return

!-------------------------------------------------------------------------
!     write version number and tagname to stdlog.
!-------------------------------------------------------------------------
      call write_version_number(version, tagname)

      indexer(TAB_NDX_JO2)      = get_rxt_ndx( 'jo2' )
      indexer(TAB_NDX_JO3)      = get_rxt_ndx( 'jo3p' ) 
      indexer(TAB_NDX_JO1D)     = get_rxt_ndx( 'jo1d' ) 
      indexer(TAB_NDX_JNO)      = get_rxt_ndx( 'jno' )       !!
      indexer(TAB_NDX_JH2COa)   = get_rxt_ndx( 'jch2o_a' ) 
      indexer(TAB_NDX_JH2COb)   = get_rxt_ndx( 'jch2o_b' ) 
      indexer(TAB_NDX_JH2O2)    = get_rxt_ndx( 'jh2o2' ) 
      indexer(TAB_NDX_JCH3OOH)  = get_rxt_ndx( 'jch3ooh' )
      indexer(TAB_NDX_JNO2)     = get_rxt_ndx( 'jno2' ) 
      indexer(TAB_NDX_JNO3)     = get_rxt_ndx( 'jno3' ) 
      indexer(TAB_NDX_JN2O5)    = get_rxt_ndx( 'jn2o5' )       
      indexer(TAB_NDX_JHNO2)    = get_rxt_ndx( 'jhno2' )    
      indexer(TAB_NDX_JHNO3)    = get_rxt_ndx( 'jhno3' ) 
      indexer(TAB_NDX_JHNO4)    = get_rxt_ndx( 'jho2no2' ) 
      
      indexer(TAB_NDX_JClNO3a)  = get_rxt_ndx( 'jclono2' )   !!
      indexer(TAB_NDX_JClNO3b)  = 0       !get_rxt_ndx( 'j' )  
      indexer(TAB_NDX_JCl2)     = get_rxt_ndx( 'jcl2' ) 
      indexer(TAB_NDX_JHOCl)    = get_rxt_ndx( 'jhocl' ) 
      indexer(TAB_NDX_JOClO)    = 0       !get_rxt_ndx( 'j' )
      indexer(TAB_NDX_JCl2O2)   = get_rxt_ndx( 'jcl2o2' ) 
      indexer(TAB_NDX_JClO)     = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JBrO)     = get_rxt_ndx( 'jbro' )      !!
      indexer(TAB_NDX_JBrNO3)   = get_rxt_ndx( 'jbrono2' ) 
      indexer(TAB_NDX_JHOBr)    = get_rxt_ndx( 'jhobr' ) 
      indexer(TAB_NDX_JBrCl)    = get_rxt_ndx( 'jbrcl' ) 
      
      indexer(TAB_NDX_JN2O)     = get_rxt_ndx( 'jn2o' ) 
      
      indexer(TAB_NDX_JCFCl3)   = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JCF2Cl2)  = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JF113)    = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JF114)    = 0       !get_rxt_ndx( 'j' )
      indexer(TAB_NDX_JF115)    = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JCCl4)    = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JCH3Cl)   = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JMeCCl3)  = 0       !get_rxt_ndx( 'j' )
      indexer(TAB_NDX_JCH2Cl2)  = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JCHF2Cl)  = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JF123)    = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JF141b)   = 0       !get_rxt_ndx( 'j' )
      indexer(TAB_NDX_JF142b)   = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JCH3Br)   = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JH1211)   = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JH1301)   = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JH2402)   = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JCH2Br2)  = 0       !get_rxt_ndx( 'j' )
      indexer(TAB_NDX_JCHBr3)   = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JCH3I)    = 0       !get_rxt_ndx( 'j' )
      indexer(TAB_NDX_JCF3I)    = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JOCS)     = 0       !get_rxt_ndx( 'j' )
     
      indexer(TAB_NDX_JPAN)     = get_rxt_ndx( 'jpan' )
      indexer(TAB_NDX_JCH3NO3)  = 0       !get_rxt_ndx( 'j' )  
      indexer(TAB_NDX_JActAld)  = get_rxt_ndx( 'jch3cho' ) 
      indexer(TAB_NDX_JMeVK)    = get_rxt_ndx( 'jmvk' )  
      indexer(TAB_NDX_JMeAcr)   = get_rxt_ndx( 'jmacr_a' ) 
      indexer(TAB_NDX_JGlyAld)  = get_rxt_ndx( 'jglyald' )  
      indexer(TAB_NDX_JMEKeto)  = get_rxt_ndx( 'jmek' )     !!
      indexer(TAB_NDX_JEAld)    = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JMGlyxl)  = get_rxt_ndx( 'jmgly' )  
      indexer(TAB_NDX_JGlyxla)  = get_rxt_ndx( 'jglyoxal' )  !!??
      indexer(TAB_NDX_JGlyxlb)  = 0       !get_rxt_ndx( 'j' )  
      indexer(TAB_NDX_JAcet_a)  = get_rxt_ndx( 'jacet' )  
      indexer(TAB_NDX_JAcet_b)  = 0       !get_rxt_ndx( 'j' ) 
      indexer(TAB_NDX_JHYAC)    = get_rxt_ndx( 'jhyac' )             
      
    if (mpp_pe() == mpp_root_pe()) &
      write(*,*)'fphoto_init: indexer',indexer     
      
!-----------------------------------------------------------------
!           ... these indices are the additional ones which don't read directly from the table
!-----------------------------------------------------------------
      jh2o_ndx     = get_rxt_ndx( 'jh2o' )
      jpooh_ndx    = get_rxt_ndx( 'jpooh' )
      jch3co3h_ndx = get_rxt_ndx( 'jch3co3h' )
      jmpan_ndx    = get_rxt_ndx( 'jmpan' )
      jmacr_b_ndx  = get_rxt_ndx( 'jmacr_b' )      
      jc2h5ooh_ndx = get_rxt_ndx( 'jc2h5ooh' )
      jc3h7ooh_ndx = get_rxt_ndx( 'jc3h7ooh' )      
      jrooh_ndx    = get_rxt_ndx( 'jrooh' )      
      jxooh_ndx    = get_rxt_ndx( 'jxooh' )
      jonitr_ndx   = get_rxt_ndx( 'jonitr' )
      jisopooh_ndx = get_rxt_ndx( 'jisopooh' )
      jbigald_ndx  = get_rxt_ndx( 'jbigald' )      
      jalkooh_ndx  = get_rxt_ndx( 'jalkooh' )      
      jmekooh_ndx  = get_rxt_ndx( 'jmekooh' )
      jtolooh_ndx  = get_rxt_ndx( 'jtolooh' )
      jterpooh_ndx = get_rxt_ndx( 'jterpooh' )      
!      
      jno_ndx      = get_rxt_ndx( 'jno' )
      jmacr_a_ndx  = get_rxt_ndx( 'jmacr_a' )
      jglyald_ndx  = get_rxt_ndx( 'jglyald' )
      jhyac_ndx    = get_rxt_ndx( 'jhyac' )
      jch3ooh_ndx  = get_rxt_ndx( 'jch3ooh' )
      jh2o2_ndx    = get_rxt_ndx( 'jh2o2' )
      jpan_ndx     = get_rxt_ndx( 'jpan' )
      jch3cho_ndx  = get_rxt_ndx( 'jch3cho' )
      jn2o5_ndx    = get_rxt_ndx( 'jn2o5' )
      jo3p_ndx     = get_rxt_ndx( 'jo3p' )
      jno2_ndx     = get_rxt_ndx( 'jno2' )
      jno3_ndx     = get_rxt_ndx( 'jno3' )
      jclono2_ndx  = get_rxt_ndx( 'jclono2' )
      jhocl_ndx    = get_rxt_ndx( 'jhocl' )
      jcl2o2_ndx   = get_rxt_ndx( 'jcl2o2' )
      jbrono2_ndx  = get_rxt_ndx( 'jbrono2' )
      jhobr_ndx    = get_rxt_ndx( 'jhobr' )
      jbrcl_ndx    = get_rxt_ndx( 'jbrcl' )
      jbro_ndx     = get_rxt_ndx( 'jbro' )
      jcl2_ndx     = get_rxt_ndx( 'jcl2' )
!
      jn2o_ndx     = get_rxt_ndx( 'jn2o' )
      jhno3_ndx    = get_rxt_ndx( 'jhno3' )
!jul++
      jacet_ndx         = get_rxt_ndx( 'jacet' ) 
      jmgly_ndx         = get_rxt_ndx( 'jmgly' )
      jmek_ndx          = get_rxt_ndx( 'jmek' )
      jglyoxal_ndx      = get_rxt_ndx( 'jglyoxal' )
      jhno2_ndx    = get_rxt_ndx( 'jhno2' )
      jo1d_ndx     = get_rxt_ndx( 'jo1d' )
        
!jul--  

      o3_ndx = get_tracer_index(MODEL_ATMOS,'o3')
      if(  o3_ndx <1 )then
        o3_ndx = get_tracer_index(MODEL_ATMOS,'OX')      
      end if
      so4_ndx     = get_tracer_index(MODEL_ATMOS,'so4')
      bc1_ndx     = get_tracer_index(MODEL_ATMOS,'bcphob')
      bc2_ndx     = get_tracer_index(MODEL_ATMOS,'bcphil')
      oc1_ndx     = get_tracer_index(MODEL_ATMOS,'omphob')
      oc2_ndx     = get_tracer_index(MODEL_ATMOS,'omphil')
      soa_ndx     = get_tracer_index(MODEL_ATMOS,'SOA')
      ssa_ndx(1)    = get_tracer_index(MODEL_ATMOS,'ssalt1')
      ssa_ndx(2)    = get_tracer_index(MODEL_ATMOS,'ssalt2')
      ssa_ndx(3)    = get_tracer_index(MODEL_ATMOS,'ssalt3')
      ssa_ndx(4)    = get_tracer_index(MODEL_ATMOS,'ssalt4')
      ssa_ndx(5)    = get_tracer_index(MODEL_ATMOS,'ssalt5')
      dust_ndx(1)   = get_tracer_index(MODEL_ATMOS,'dust1')
      dust_ndx(2)   = get_tracer_index(MODEL_ATMOS,'dust2') 
      dust_ndx(3)   = get_tracer_index(MODEL_ATMOS,'dust3')
      dust_ndx(4)   = get_tracer_index(MODEL_ATMOS,'dust4')
      dust_ndx(5)   = get_tracer_index(MODEL_ATMOS,'dust5')
       
      nqa = get_tracer_index(MODEL_ATMOS,'cld_amt')
      nqi = get_tracer_index(MODEL_ATMOS,'ice_wat')
      nql = get_tracer_index(MODEL_ATMOS,'liq_wat')
      nqq = get_tracer_index(MODEL_ATMOS,'sphum')
      
      if(  o3_ndx <1 )   call error_mesg ('ATMOS: fphoto','Failed to find O3_ndx', FATAL)
      if(  so4_ndx <1 )  call error_mesg ('ATMOS: fphoto','Failed to find so4_ndx', FATAL)
      if(  bc1_ndx <1 )  call error_mesg ('ATMOS: fphoto','Failed to find bc1_ndx', FATAL)
      if(  bc2_ndx <1 )  call error_mesg ('ATMOS: fphoto','Failed to find bc2_ndx', FATAL)
      if(  oc1_ndx <1 )  call error_mesg ('ATMOS: fphoto','Failed to find oc1_ndx', FATAL)
      if(  oc2_ndx <1 )  call error_mesg ('ATMOS: fphoto','Failed to find oc2_ndx', FATAL)
      if(  soa_ndx <1 )  call error_mesg ('ATMOS: fphoto','Failed to find soa_ndx', FATAL)
      if(  ssa_ndx(1) <1 )  call error_mesg ('ATMOS: fphoto','Failed to find ssa1_ndx', FATAL)
      if(  ssa_ndx(2) <1 )  call error_mesg ('ATMOS: fphoto','Failed to find ssa2_ndx', FATAL)
      if(  ssa_ndx(3) <1 )  call error_mesg ('ATMOS: fphoto','Failed to find ssa3_ndx', FATAL)
      if(  ssa_ndx(4) <1 )  call error_mesg ('ATMOS: fphoto','Failed to find ssa4_ndx', FATAL)
      if(  ssa_ndx(5) <1 )  call error_mesg ('ATMOS: fphoto','Failed to find ssa5_ndx', FATAL)
      if(  dust_ndx(1) <1 )  call error_mesg ('ATMOS: fphoto','Failed to find dust1_ndx', FATAL)
      if(  dust_ndx(2) <1 )  call error_mesg ('ATMOS: fphoto','Failed to find dust2_ndx', FATAL)
      if(  dust_ndx(3) <1 )  call error_mesg ('ATMOS: fphoto','Failed to find dust3_ndx', FATAL)
      if(  dust_ndx(4) <1 )  call error_mesg ('ATMOS: fphoto','Failed to find dust4_ndx', FATAL)
      if(  dust_ndx(5) <1 )  call error_mesg ('ATMOS: fphoto','Failed to find dust5_ndx', FATAL)
      
      
      if(  nqa <1 )  call error_mesg ('ATMOS: fphoto','Failed to find cld_amt_ndx', FATAL)
      if(  nqi <1 )  call error_mesg ('ATMOS: fphoto','Failed to find ice_wat_ndx', FATAL)
      if(  nql <1 )  call error_mesg ('ATMOS: fphoto','Failed to find liq_wat_ndx', FATAL)
!      if(  nqq <1 )  call error_mesg ('ATMOS: fphoto','Failed to find c_ndx', FATAL)
        
      
      
      if (mpp_pe() == mpp_root_pe() ) write(*,*) 'fphoto:nqa,nqi,nql,nqq= ',nqa,nqi,nql,nqq
!      use_tdep_jvals   = use_tdep_jvals_in
      o3_column_top    = o3_column_top_in * 2.6867E+20/1.e4 !DU -> molec/cm2
!      jno_scale_factor = jno_scale_factor_in

      fastjx_clock = mpp_clock_id( 'Tropchem: Fast_JX', &
           grain=CLOCK_MODULE )

      call fastjx_init
      module_is_initialized = .true.

      end subroutine fprate_init
! </SUBROUTINE>


! <SUBROUTINE NAME="FPHOTO">
!   <OVERVIEW>
!     Calculate FAST-JX photolysis rates
!   </OVERVIEW>
!   <DESCRIPTION>
!     Calculate photolysis rates from FAST-JX codes
!   </DESCRIPTION>
!   <TEMPLATE>
!     call PHOTO( photos, pmid, pdel, temper, zmid, col_dens, coszen,  & 
!                 srf_alb, lwc, clouds, esfact, solar_phase, plonl )
!   </TEMPLATE>
!   <IN NAME="photos" TYPE="real" DIM="(:,:,:)">
!     Photodissociation rates (s^-1)
!   </IN>
!   <IN NAME="pmid" TYPE="real" DIM="(:,:)">
!     Full level pressures (Pa)
!   </IN>
!   <IN NAME="pdel" TYPE="real" DIM="(:,:)">
!     Half level (interface) pressures (Pa)
!   </IN>
!   <IN NAME="temper" TYPE="real" DIM="(:,:)">
!     Full level temperatures (K)
!   </IN>
!   <IN NAME="zmid" TYPE="real" DIM="(:,:)">
!     Full level absolute geopotential altitudes (km)
!   </IN>
!   <IN NAME="col_dens" TYPE="real" DIM="(:,:,:)">
!     Column densities
!   </IN>
!   <IN NAME="coszen" TYPE="real" DIM="(:)">
!     Cosine of solar zenith angle
!   </IN>
!   <IN NAME="srf_alb" TYPE="real" DIM="(:)">
!     Surface albedo
!   </IN>
!   <IN NAME="lwc" TYPE="real" DIM="(:,:)">
!     Cloud liquid water content (kg/kg)
!   </IN>
!   <IN NAME="clouds" TYPE="real" DIM="(:,:)">
!     Cloud fraction
!   </IN>
!   <IN NAME="esfact" TYPE="real">
!     Earth-sun distance factor
!   </IN>
!   <IN NAME="solar_phase" TYPE="real">
!     Solar cycle phase (1=max, 0=min)
!   </IN>
!   <IN NAME="plonl" TYPE="integer">
!     Size of longitude dimension
!   </IN>
      subroutine FPHOTO( photos, &
                         pmid, &         ! pfull
                         pdel, &
                         temper, &       !tfull
                         zmid, &
                         col_dens, &
                         coszen,  & 
                         srf_alb, &
                         j_ndx,&
                         lwc, &
                         clouds, &
                         esfact, &
                         solar_phase, &
                         plonl, &
                         use_lsc_in_fastjx, &
                         phalf,&
                         zhalf,&
                         pwt , &
                         qfld, &
                         r  )

      use CHEM_MODS_MOD, only : ncol_abs, phtcnt
      use time_manager_mod, only : time_type      

      implicit none

!-----------------------------------------------------------------
!           ... Dummy arguments
!-----------------------------------------------------------------
!      type(time_type), intent(in) :: Time             ! time
      integer, intent(in) :: plonl, j_ndx              ! lat index
      logical, intent(in) :: use_lsc_in_fastjx         ! are lsc clouds
                                                       ! seen in fastjx ?
      real,    intent(in) :: esfact, &                 ! earth sun distance factor
                             solar_phase               ! solar cycle phase (1=max, 0=min)
      real,    intent(in) :: col_dens(:,:,:), &        ! column densities
                             coszen(:), &              ! solar zenith angle
                             srf_alb(:), &             ! surface albedo
                             lwc(:,:), &               ! liquid water content (mass mr)
!                            lwc_water(:,:),&          ! water cloud (Kg/Kg)
!                     lwc_ice(:,:),&                   ! ice cloud (Kg/Kg)
                             clouds(:,:), &            ! cloud fraction
                             pmid(:,:), &              ! midpoint pressure in pascals
                             pdel(:,:), &              ! del pressure about midpoint in pascals
                             zmid(:,:), &              ! midpoint height
                             temper(:,:), &            ! midpoint temperature
                             phalf(:,:),&              ! pressure at boundaries (pa)
                             zhalf(:,:),&              ! boundary hight (m)
                             pwt(:,:) , &              ! air column density (Kg/m2)
                             qfld(:,:), &              ! specific humnidity (Kg/Kg)
                             r(:,:,:)                  ! tracers' concentrtaions             
      real,   intent(out) :: photos(:,:,:)             ! photodissociation rates (s-1)
!-----------------------------------------------------------------
!            ... Local variables
!-----------------------------------------------------------------
      integer, parameter   ::  naero = 16   ! number of aerosol type
      integer, parameter   ::  ncloud = 2   ! number of aerosol type
      
      integer  ::  i,j, k, m                 ! indicies
      integer  ::  plev
!      integer, dimension(size(zmid,2)) :: &
!                   fac1, &                ! work space for J(no) calc
!                   fac2, &                ! work space for J(no) calc
!                   colo3, &               ! vertical o3 column density
!                   zarg, &                ! vertical height array
!                   pline, &               ! vertical pressure array
!                   tline, &               ! vertical temperature array
!                   cld_line, &            ! vertical cloud array
!                   lwc_line, &            ! vertical lwc array
!                   eff_alb, &             ! effective albedo from cloud modifications
!                   cld_mult               ! clould multiplier
      integer, dimension(plonl,size(zmid,2),ncloud) :: clouds_ndx ! cloud type index
      real, dimension(plonl,size(zmid,2),ncloud) :: clouds_lwc, clouds_fraction ! cloud liquid water contains (KG/KG)    
      integer, dimension(plonl,size(zmid,2),naero)    :: aeron ! aerosol type index
      real, dimension(plonl,size(zmid,2),naero) :: aerop        ! aerosol path (g/m2) 
                     

      real, dimension(plonl,size(zmid,2))       :: XO3          ! O3 (VMR)

    
      real, dimension(plonl,size(zmid,2)) :: &
                   tmp, &                        ! wrk array
                   tmp_jch3ooh, &                ! wrk array
                   tmp_jpan, &                   ! wrk array
                   tmp_jh2o2, &                  ! wrk array
                   tmp_jch3cho, &                ! wrk array
                   tmp_jmacr_a, &                ! wrk array
                   tmp_jn2o_200, &               ! wrk array
                   tmp_jn2o_250, &               ! wrk array
                   tmp_jn2o_300, &               ! wrk array
                   tmp_jn2o5_225, &              ! wrk array
                   tmp_jn2o5_250, &              ! wrk array
                   tmp_jn2o5_300, &              ! wrk array
                   tmp_jhno3_200, &              ! wrk array
                   tmp_jhno3_250, &              ! wrk array
                   tmp_jhno3_300, &              ! wrk array
                   tmp_jclono2_200, &            ! wrk array
                   tmp_jclono2_250, &            ! wrk array
                   tmp_jclono2_300, &            ! wrk array
                   wgt200, wgt225, wgt250, wgt300, &     ! wrk array
                   tmp_jno, &
                   tmp_jglyxlb, &
                   tmp_jo1d   !jul++
   
      real*8    :: prates(size(zmid,2),jdim)        ! photorates matrix
      real, dimension(SIZE(temper,1),SIZE(temper,2)) :: relhum                   ! relative humidity

      call mpp_clock_begin (fastjx_clock)

!-------------check model initialization -------------------------------

      if (.not. module_is_initialized) &
            call error_mesg ('ATMOS: fphoto','fprate_init must be called first.', FATAL)
#ifdef USE_MPI
!----------------------------------------------------------------------
!        ... All compute nodes wait for masternode to acquire file
!----------------------------------------------------------------------
!     call MPI_BARRIER( mpi_comm_comp, ios )
!     if( ios /= MPI_SUCCESS ) then
!        write(*,*) 'PRATE_INIT: Mpi barrier failed; error = ',ios
!        call ENDRUN
!     end if
#endif
      j = j_ndx
      plev = SIZE(zmid,2)
!-----------------------------------------------------------------
!        ... Zero all photorates
!-----------------------------------------------------------------
      do m = 1,max(1,phtcnt)
         do k = 1,plev
            photos(:,k,m) = 0.
         end do
      end do
      
      XO3 = r(:,:,o3_ndx)
      
      do k = 1,plev
         tmp_jch3ooh(:,k)     = 0.
         tmp_jpan(:,k)        = 0.
         tmp_jh2o2(:,k)       = 0.
         tmp_jch3cho(:,k)     = 0.
         tmp_jmacr_a(:,k)     = 0.
         tmp_jno(:,k)         = 0.
         tmp_jn2o_200(:,k)    = 0.
         tmp_jn2o_250(:,k)    = 0.
         tmp_jn2o_300(:,k)    = 0.
         tmp_jn2o5_225(:,k)   = 0.
         tmp_jn2o5_250(:,k)   = 0.
         tmp_jn2o5_300(:,k)   = 0.
         tmp_jhno3_200(:,k)   = 0.
         tmp_jhno3_250(:,k)   = 0.
         tmp_jhno3_300(:,k)   = 0.
         tmp_jclono2_200(:,k) = 0.
         tmp_jclono2_250(:,k) = 0.
         tmp_jclono2_300(:,k) = 0.
         tmp_jglyxlb(:,k)     = 0.
         tmp_jo1d(:,k)     = 0. !jul++
      end do

!-----------------------------------------------------------------
!        ... Calc relative humidity
!-----------------------------------------------------------------            
      do k =1, plev
         call rh_calc( pmid(:,k), temper(:,k), qfld(:,k), relhum(:,k) )
      end do
!-----------------------------------------------------------------
!        ... Assign clouds info
!-----------------------------------------------------------------
      
      clouds_lwc(:,:,:) = 0.
      clouds_fraction(:,:,:) = 0.

      if(use_lsc_in_fastjx)then
         clouds_lwc(:,:,1)      = max(0.,r(:,:, nql))  
         clouds_lwc(:,:,2)      = max(0.,r(:,:, nqi))  
         clouds_fraction(:,:,1) = r(:,:, nqa)       
      end if
      
   
      clouds_fraction(:,:,1) = max( 0.,min( 1.,clouds_fraction(:,:,1) ) )
      clouds_fraction(:,:,2) = clouds_fraction(:,:,1)
!  assign cloud index
      clouds_ndx(:,:,1) = 9          !C1, r_eff=12um
      where (temper(:,:) > 233.15)   !>-40C
         clouds_ndx(:,:,2) = 12      !Ice-Hexagonal
      elsewhere
         clouds_ndx(:,:,2) = 13      !Ice-Irregular
      endwhere 
!-----------------------------------------------------------------
!        ... Assign aerosols info
!-----------------------------------------------------------------
      call set_aerosol_mc(r(:,:,:),pwt(:,:),relhum(:,:), aerop(:,:,:),aeron(:,:,:))  ! aerop: g/m2
      do i = 1,plonl
!           if (mpp_pe() == mpp_root_pe()  ) then 
!       write(*,*)'Fphoto: ilon,jlat: ', i,j_ndx
!   endif
   call fastjx_photo(    coszen(i), &
                         esfact, &
                         phalf(i,:),&
                         zhalf(i,:),& 
                         pmid(i,:),&
                         temper(i,:),&
                         XO3(i,:),  &
                         pwt(i,:) , &
                         clouds_lwc(i,:,:),  &
                         clouds_fraction(i,:,:), &
                         clouds_ndx(i,:,:) ,&
                         qfld(i,:), &
                         srf_alb(i), &
                         aerop(i,:,:), &
                         aeron(i,:,:), &
                         o3_column_top, &
                         prates &
                         )

            prates(:,:) = max(0., prates(:,:)) 
            do m = 1,jdim         
                  if( indexer(m) > 0 ) then
                    photos(i,:,indexer(m)) = prates(:,m)
                  else
                     select case( m )
                        case( TAB_NDX_JNO )
                           tmp_jno(i,:) = prates(:,m)
                        case( TAB_NDX_JCH3OOH )
                           tmp_jch3ooh(i,:) = prates(:,m)
                        case( TAB_NDX_JH2O2 )
                           tmp_jh2o2(i,:) = prates(:,m)
                        case( TAB_NDX_JActAld )
                           tmp_jch3cho(i,:) = prates(:,m)
                        case( TAB_NDX_JPAN )
                           tmp_jpan(i,:) = prates(:,m)
                        case( TAB_NDX_JMeAcr )
                           tmp_jmacr_a(i,:) = prates(:,m)
                        case( TAB_NDX_JGlyxlb)
                           tmp_jglyxlb(i,:) = prates(:,m)
                        case( TAB_NDX_JO1D)  !jul++
                           tmp_jo1d(i,:) = prates(:,m)
   
!                        case( TAB_NDX_JN2O_200 )
!                           tmp_jn2o_200(i,:) = esfact *prates(m,:) * cld_mult(:)
!                        case( TAB_NDX_JN2O_250 )
!                           tmp_jn2o_250(i,:) = esfact *prates(m,:) * cld_mult(:)
!                        case( TAB_NDX_JN2O_300 )
!                           tmp_jn2o_300(i,:) = esfact *prates(m,:) * cld_mult(:)
!                        case( TAB_NDX_JN2O5_225 )
!                           tmp_jn2o5_225(i,:) = esfact *prates(m,:) * cld_mult(:)
!                        case( TAB_NDX_JN2O5_250 )
!                           tmp_jn2o5_250(i,:) = esfact *prates(m,:) * cld_mult(:)
!                        case( TAB_NDX_JN2O5_300 )
!                           tmp_jn2o5_300(i,:) = esfact *prates(m,:) * cld_mult(:)
!                        case( TAB_NDX_JHNO3_200 )
!                           tmp_jhno3_200(i,:) = esfact *prates(m,:) * cld_mult(:)
!                        case( TAB_NDX_JHNO3_250 )
!                           tmp_jhno3_250(i,:) = esfact *prates(m,:) * cld_mult(:)
!                        case( TAB_NDX_JHNO3_300 )
!                           tmp_jhno3_300(i,:) = esfact *prates(m,:) * cld_mult(:)
!                        case( TAB_NDX_JCLONO2_200 )
!                           tmp_jclono2_200(i,:) = esfact *prates(m,:) * cld_mult(:)
!                        case( TAB_NDX_JCLONO2_250 )
!                           tmp_jclono2_250(i,:) = esfact *prates(m,:) * cld_mult(:)
!                        case( TAB_NDX_JCLONO2_300 )
!                           tmp_jclono2_300(i,:) = esfact *prates(m,:) * cld_mult(:)
                     end select
                  end if
           end do
      end do !i
        

!      jh2o_ndx     = get_rxt_ndx( 'jh2o' )      
!      jpooh_ndx    = get_rxt_ndx( 'jpooh' )
!      jch3co3h_ndx = get_rxt_ndx( 'jch3co3h' )
!      jmpan_ndx    = get_rxt_ndx( 'jmpan' )
!      jmacr_b_ndx  = get_rxt_ndx( 'jmacr_b' )      
!      jc2h5ooh_ndx = get_rxt_ndx( 'jc2h5ooh' )
!      jc3h7ooh_ndx = get_rxt_ndx( 'jc3h7ooh' )      
!      jrooh_ndx    = get_rxt_ndx( 'jrooh' )      
!      jxooh_ndx    = get_rxt_ndx( 'jxooh' )
!      jonitr_ndx   = get_rxt_ndx( 'jonitr' )
!      jisopooh_ndx = get_rxt_ndx( 'jisopooh' )
!      jbigald_ndx  = get_rxt_ndx( 'jbigald' )      
!      jalkooh_ndx  = get_rxt_ndx( 'jalkooh' )      
!      jmekooh_ndx  = get_rxt_ndx( 'jmekooh' )
!      jtolooh_ndx  = get_rxt_ndx( 'jtolooh' )
!      jterpooh_ndx = get_rxt_ndx( 'jterpooh' )      
        
      
      
      if( jch3ooh_ndx > 0 ) then
         tmp(:,:) = photos(:,:,jch3ooh_ndx)
      else
         tmp(:,:) = tmp_jch3ooh(:,:)
      end if
      
      if( jpooh_ndx > 0 ) then
         photos(:,:,jpooh_ndx)    = tmp(:,:)
      end if
      
      if( jc2h5ooh_ndx > 0 ) then
         photos(:,:,jc2h5ooh_ndx) = tmp(:,:)
      end if
      
      if( jc3h7ooh_ndx > 0 ) then
         photos(:,:,jc3h7ooh_ndx) = tmp(:,:)
      end if
      
      if( jrooh_ndx > 0 ) then
         photos(:,:,jrooh_ndx)    = tmp(:,:)
      end if
      
      if( jxooh_ndx > 0 ) then
        photos(:,:,jxooh_ndx)    = tmp(:,:)
      end if
      
      if( jisopooh_ndx > 0 ) then
         photos(:,:,jisopooh_ndx) = tmp(:,:)
      end if
      
!jul++
      if( jalkooh_ndx > 0 ) then
         photos(:,:,jalkooh_ndx) = tmp(:,:)
      end if
      
      if( jmekooh_ndx > 0 ) then
         photos(:,:,jmekooh_ndx) = tmp(:,:)
      end if
      
      if( jtolooh_ndx > 0 ) then
         photos(:,:,jtolooh_ndx) = tmp(:,:)
      end if
      
      if( jterpooh_ndx > 0 ) then
         photos(:,:,jterpooh_ndx) = tmp(:,:)
      end if
      
       
!      if( jmek_ndx > 0 ) then
!         if( jacet_ndx > 0 ) then
!            photos(:,:,jmek_ndx) = photos(:,:,jacet_ndx)
!!         end if
!      end if
      if( jbigald_ndx > 0 ) then
         if( jno2_ndx > 0 ) then
            photos(:,:,jbigald_ndx) = 0.2 * photos(:,:,jno2_ndx)
         end if
      end if      
!      if( jglyoxal_ndx > 0 ) then
!         if( jmgly_ndx > 0 ) then
!            photos(:,:,jglyoxal_ndx) = photos(:,:,jmgly_ndx)
!         end if
 !     end if       
!jul--         
      
      if( jch3co3h_ndx > 0 ) then
         if( jh2o2_ndx > 0 ) then
            photos(:,:,jch3co3h_ndx) = .28 * photos(:,:,jh2o2_ndx)
         else
            photos(:,:,jch3co3h_ndx) = .28 * tmp_jh2o2(:,:)
         end if
      end if
      
      if( jmpan_ndx > 0 ) then
         if( jpan_ndx > 0 ) then
            photos(:,:,jmpan_ndx)    = photos(:,:,jpan_ndx)
         else
            photos(:,:,jmpan_ndx)    = tmp_jpan(:,:)
         end if
      end if
      
!      if( jmacr_a_ndx > 0 ) then
!         photos(:,:,jmacr_a_ndx)  = .5 * photos(:,:,jmacr_a_ndx)
!      end if
      if( jmacr_b_ndx > 0 ) then
         if( jmacr_a_ndx > 0 ) then
            photos(:,:,jmacr_b_ndx)  = photos(:,:,jmacr_a_ndx)
         else
            photos(:,:,jmacr_b_ndx)  = .5 * tmp_jmacr_a(:,:)
         end if
      end if
      if( jonitr_ndx > 0 ) then
         if( jch3cho_ndx > 0 ) then
            photos(:,:,jonitr_ndx)   = photos(:,:,jch3cho_ndx)
         else
            photos(:,:,jonitr_ndx)   = tmp_jch3cho(:,:)
         end if
      end if
      
!      if( jglyald_ndx > 0 ) then
!         if( jch3cho_ndx > 0 ) then
!            photos(:,:,jglyald_ndx)  = 3. * photos(:,:,jch3cho_ndx)
!         else
!            photos(:,:,jglyald_ndx)   = 3. *tmp_jch3cho(:,:)
 !        end if
!      end if
      if( jh2o_ndx > 0 ) then
         if( jno_ndx > 0 ) then
            photos(:,:,jh2o_ndx) = 0.1*photos(:,:,jno_ndx)
         else
            photos(:,:,jh2o_ndx) = 0.1*tmp_jno(:,:)
         end if
      end if
      
! be careful here about glyoxala and b in fastjx, here add both      
!      if( jglyoxal_ndx > 0 ) then
!            photos(:,:,jglyoxal_ndx) = photos(:,:,jglyoxal_ndx)+tmp_jglyxlb(:,:)
!      end if
      
      
      
!      if (mpp_pe() == mpp_root_pe()) &
!      write(*,*)'fphoto: photoes',photos(1,1,:)
     
!      if( jn2o_ndx > 0 .and. use_tdep_jvals ) then
!         wgt200(:,:)  = MIN( 1.,MAX( 0.,(250.-temper(:,:))/50. ) )
!         wgt300(:,:)  = MIN( 1.,MAX( 0.,(temper(:,:)-250.)/50. ) )
!         wgt250(:,:)  = 1. - wgt200(:,:) - wgt300(:,:)
!         photos(:,:,jn2o_ndx)    = wgt200(:,:)*tmp_jn2o_200(:,:) + &
!                                   wgt250(:,:)*tmp_jn2o_250(:,:) + &
!                                   wgt300(:,:)*tmp_jn2o_300(:,:)
!      end if
!      if( jn2o5_ndx > 0 .and. use_tdep_jvals ) then
!         wgt225(:,:)  = MIN( 1.,MAX( 0.,(250.-temper(:,:))/25. ) )
!         wgt300(:,:)  = MIN( 1.,MAX( 0.,(temper(:,:)-250.)/50. ) )
!         wgt250(:,:)  = 1. - wgt225(:,:) - wgt300(:,:)
!         photos(:,:,jn2o5_ndx)   = wgt225(:,:)*tmp_jn2o5_225(:,:) + &
!                                   wgt250(:,:)*tmp_jn2o5_250(:,:) + &
!                                   wgt300(:,:)*tmp_jn2o5_300(:,:)
!      end if
!      if( jhno3_ndx > 0 .and. use_tdep_jvals ) then
!         wgt200(:,:)  = MIN( 1.,MAX( 0.,(250.-temper(:,:))/50. ) )
!         wgt300(:,:)  = MIN( 1.,MAX( 0.,(temper(:,:)-250.)/50. ) )
!         wgt250(:,:)  = 1. - wgt200(:,:) - wgt300(:,:)
!         photos(:,:,jhno3_ndx)   = wgt200(:,:)*tmp_jhno3_200(:,:) + &
!                                   wgt250(:,:)*tmp_jhno3_250(:,:) + &
!                                   wgt300(:,:)*tmp_jhno3_300(:,:)
!      end if
!      if( jclono2_ndx > 0 .and. use_tdep_jvals ) then
!         wgt200(:,:)  = MIN( 1.,MAX( 0.,(250.-temper(:,:))/50. ) )
!         wgt300(:,:)  = MIN( 1.,MAX( 0.,(temper(:,:)-250.)/50. ) )
!         wgt250(:,:)  = 1. - wgt200(:,:) - wgt300(:,:)
!         photos(:,:,jclono2_ndx) = wgt200(:,:)*tmp_jclono2_200(:,:) + &
!                                   wgt250(:,:)*tmp_jclono2_250(:,:) + &
!                                   wgt300(:,:)*tmp_jclono2_300(:,:)
!      end if


      call mpp_clock_end (fastjx_clock)

      end subroutine FPHOTO
! </SUBROUTINE>



subroutine set_aerosol_mc(r,pwt,rh,aerop,aeron)
!----------------------------------------------------------------
!     set aerosol information for fast-jx calculation
!----------------------------------------------------------------
      implicit none
      real, intent(in)          :: r(:,:,:)     !species
      real, intent(in)          :: pwt(:,:), &  !air column mass (kg/m2)
                                   rh(:,:)      !relative humidity
      real, intent(inout)       :: aerop(:,:,:) !aerosol mass column (g/m2)
      integer, intent(out)      :: aeron(:,:,:) !aerosol category index, see am3_scat.dat

!-----------------------------------------------------------------
!     local parameter variables
!-----------------------------------------------------------------

      integer,  parameter :: nso4bc=702, nbcphil=18, nocphob =1, nocphil=21, nssalt=130, ndust=8
      integer,  parameter :: nso4bc_vol = 27, nso4bc_rh = 26, nssalt_rh = 26
      integer,  parameter :: so4bc_rh1(nso4bc_rh)=(/30,35,40,45,50,55,60,65,70,75,80,82,84,86,88,90,91,92,93,94,95,96,97,98,99,100/)
      integer,  parameter :: so4bc_vol1(nso4bc_vol)=(/100,98,96,94,92,90,88,86,84,82,80,75,70,65,60,55,50,45,40,35,30,25,20,15,10,5,0/)
      integer,  parameter :: bcphil_rh1(nbcphil)=(/0,70,75,80,82,84,86,88,90,91,92,93,94,95,96,97,98,99/)
      integer,  parameter :: ocphil_rh1(nocphil)=(/0,55,60,65,70,75,80,82,84,86,88,90,91,92,93,94,95,96,97,98,99/)
      integer,  parameter :: ssalt_rh1(nssalt_rh)=(/0,47,50,55,60,65,70,72,74,76,78,80,82,84,86,88,90,91,92,93,94,95,96,97,98,99/)
      
      real,  parameter    :: denso4 = 1.74, denbc = 1.0, denocphob = 1.0, denocphil = 1.5 
      real,  parameter    :: denssalt(5) = (/0.078222,0.3580154,0.7310735, 1.125,    2.2774594/)
      real,  parameter    :: dendust(8) = (/2.5,     2.5,     2.5,     2.5,     2.6,    2.6,    2.6,     2.6  /)
      real,  parameter   ::  fractiondust(8) = (/ 0.01053,0.08421,0.25263,0.65263,1.,1.,1.,1. /)
!-----------------------------------------------------------------
!     local variables
!-----------------------------------------------------------------

      real, dimension(size(r,1),size(r,2))      ::      so4, &          ! ammonium sulfate (VMR)
                                                        bc1, &          ! Hydrophobic carbon (MMR)
                                                        bc2, &          ! Hydrophilic carbon (MMR)
!                                                       oc1, &
!                                                       oc2, &
!                                                       soa, &
!                                                       ssa1, &
!                                                       ssa2, &
!                                                       ssa3, &
!                                                       ssa4, &
!                                                       ssa5, &
!                                                       dust11, &               ! dust1 (MMR)
!                                                       dust12, &               ! dust1 (MMR)
!                                                       dust13, &               ! dust1 (MMR)
!                                                       dust14, &               ! dust1 (MMR)
!                                                       dust1, &                ! dust1 (MMR)
!                                                       dust2, &                ! dust2 (MMR) 
!                                                       dust3, &                ! dust3 (MMR)
!                                                       dust4, &                        ! dust4 (MMR)
!                                                       dust5, &                        ! dust4 (MMR)
                                                        v1, v2, relhum

      integer   :: i, j, kd, id,   st1, naero
      integer, dimension(size(r,1),size(r,2))   :: ivol, irh
      
      
      id =size(r,1)
      kd =size(r,2)
      naero = size(aerop,3)

!----------------------------------------------------------------
!     SO4 + BC internal mixing
!----------------------------------------------------------------
      so4(:,:) = r(:,:,so4_ndx)*132./28.97     !VMR => MMR
      bc1(:,:) = r(:,:,bc1_ndx)
      bc2(:,:) = r(:,:,bc2_ndx)
      relhum(:,:) = rh(:,:) *100.
!      if (mpp_pe() == mpp_root_pe() ) then 
!             write(*,*) 'fphoto: so4=',so4(2,:) 
!             write(*,*) 'fphoto: bc1=',bc1(2,:) 
!             write(*,*) 'fphoto: bc2=',bc2(2,:)    
!      end if
      
      
      v1(:,:) = so4(:,:)/denso4
      v2(:,:) = (bc1(:,:)+bc2(:,:))/denbc
      v1(:,:) = v1(:,:)/(v1(:,:)+v2(:,:))*100.
!      if (mpp_pe() == mpp_root_pe() ) then 
!             write(*,*) 'fphoto: v1=',v1(2,:)      
!      end if     
      
      ivol(:,:) = 0
      irh(:,:)  = 0
      call find_indx2(so4bc_vol1(:),v1(:,:),ivol(:,:))
      call find_indx(so4bc_rh1(:), relhum(:,:), irh(:,:))
!      if (mpp_pe() == mpp_root_pe() ) then 
!             write(*,*) 'fphoto: ivol=',ivol(2,:)      
!             write(*,*) 'fphoto: irh=',irh(2,:)        
!      end if        
      aeron(:,:,1) = (ivol(:,:)-1)*nso4bc_rh + irh(:,:)
      aerop(:,:,1) = so4(:,:)+bc1(:,:)+bc2(:,:)
!----------------------------------------------------------------
!     OC 
!----------------------------------------------------------------
!     --phobic
      st1 = nso4bc + nbcphil 
      aeron(:,:,2) = st1 + 1
      aerop(:,:,2) = r(:,:,oc1_ndx)      
!     --philic      
      st1 = st1 + nocphob
      irh(:,:)  = 0
      call find_indx(ocphil_rh1(:), relhum(:,:), irh(:,:))
      aeron(:,:,3) = st1+ irh(:,:)
      aerop(:,:,3) = r(:,:,oc2_ndx) + r(:,:,soa_ndx)
!----------------------------------------------------------------
!     sea salt
!----------------------------------------------------------------
      st1 = st1 + nocphil
      irh(:,:)  = 0
      call find_indx(ssalt_rh1(:), relhum(:,:), irh(:,:))      
      do i= 1, 5
         aeron(:,:,3+i) = st1 + (i-1)*nssalt_rh + irh(:,:) 
         aerop(:,:,3+i) = r(:,:,ssa_ndx(i))          
      end do
!----------------------------------------------------------------
!     dust
!----------------------------------------------------------------
      st1 = st1 + nssalt
      do i= 1, 4
         aeron(:,:,8+i) = st1 + i
         aerop(:,:,8+i) = r(:,:,dust_ndx(1)) *  fractiondust(i)        
      end do      
      do i= 5, 8
         aeron(:,:,8+i) = st1 + i
         aerop(:,:,8+i) = r(:,:,dust_ndx(i-3))        
      end do      
!----------------------------------------------------------------
!     convert mmr to g/m2
!----------------------------------------------------------------    
      do i=1, naero  
         aerop(:,:,i) =aerop(:,:,i) *pwt(:,:)*1000.
      end do
end subroutine set_aerosol_mc




subroutine find_indx(t,tt, it)
  implicit none

  integer, intent(in)   :: t(:)         ! defined categories
  real, intent(in)      :: tt(:,:)      ! model simulated values
  integer, intent(out)  :: it(:,:)      ! index

  
  integer            :: N_ ! number of parameters
  integer               :: i
  real, dimension(size(t,1)-1)          :: dt 
  
  
  N_ = size(t,1)
  
  do i = 1, N_-1
      dt(i) = (t(i+1)-t(i))/2.      
  end do
  
  where (tt(:,:) .le. t(1) + dt(1)  )
      it(:,:) = 1
  endwhere
      
  where (tt(:,:) .gt. t(N_-1) + dt(N_-1)  )
      it(:,:) = N_
  endwhere
  
  do i=1,N_-2
        where(tt(:,:) .gt. t(i) + dt(i) .and. tt(:,:) .le. t(i+1) + dt(i+1)) 
         it(:,:) = i+1
        endwhere      
  end do

end subroutine find_indx



subroutine find_indx2(t,tt, it)
  implicit none

  integer, intent(in)   :: t(:)         ! defined categories
  real, intent(in)      :: tt(:,:)      ! model simulated values
  integer, intent(out)  :: it(:,:)      ! index

  
  integer       :: N_    ! number of parameters
  integer       :: i
  real, dimension(size(t,1)-1)          :: dt 
  
  
  N_ = size(t,1)
  
  do i = 1, N_-1
      dt(i) = (t(i+1)-t(i))/2.      
  end do
  
  where (tt(:,:) .ge. t(1) + dt(1)  )
      it(:,:) = 1
  endwhere
      
  where (tt(:,:) .lt. t(N_-1) + dt(N_-1)  )
      it(:,:) = N_
  endwhere
  
  do i=1,N_-2
        where(tt(:,:) .lt. t(i) + dt(i) .and. tt(:,:) .ge. t(i+1) + dt(i+1)) 
        it(:,:) = i+1
        endwhere      
  end do

end subroutine find_indx2

!      subroutine endrun(msg)

!      character(len=128), intent(in) :: msg
!      call mpp_error(FATAL, msg)
      
!      end subroutine endrun        



subroutine rh_calc(pmid, temp, sh, rh)
              
        implicit none
        
        real, intent(in), dimension(:) :: pmid, temp, sh
        real, intent(out), dimension(:) :: rh
        
        real, dimension(size(temp)) :: esat
!-----------------------------------------------------------------------
!       Calculate RELATIVE humidity.
!       This is calculated according to the formula:
!
!       RH   = qv / (epsilon*esat/ [pfull  -  (1.-epsilon)*esat])
!
!       Where epsilon = Rdgas/RVgas = d622
!
!       and where 1- epsilon = d378
!
!       Note that rh does not have its proper value
!       until all of the following code has been executed.  That
!       is, rh is used to store intermediary results
!       in forming the full solution.
!-----------------------------------------------------------------------
        
!-----------------------------------------------------------------------
!calculate water saturated specific humidity
!-----------------------------------------------------------------------
        call compute_qs (temp, pmid, rh, q = sh)
        
!-----------------------------------------------------------------------
!calculate rh
!-----------------------------------------------------------------------
        rh(:)= sh(:) / rh(:)
        
end subroutine rh_calc




end module MO_FPHOTO_MOD

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!
! xgrid_mod - implements exchange grids.  An exchange grid is the grid whose
!             boundary set is the union of the boundaries of the participating
!             grids.  The exchange grid is the coarsest grid that is a 
!             refinement of each of the participating grids.  Every exchange
!             grid cell is a subarea of one and only one cell in each of the
!             participating grids.  The exchange grid has two purposes:
!
!               (1) The exchange cell areas are used as weights for
!                   conservative interpolation between model grids.
!
!               (2) Computation of surface fluxes takes place on it,
!                   thereby using the finest scale data obtainable.
!
!             The exchange cells are the 2D intersections between cells of the
!             participating grids.  They are computed elsewhere and are
!             read here from a NetCDF grid file as a sequence of quintuples
!             (i and j on each of two grids and the cell area).
!
!             Each processing element (PE) computes a subdomain of each of the
!             participating grids as well as a subset of the exchange cells.
!             The geographic regions corresponding to these subdomains will,
!             in general, not be the same so communication must occur between
!             the PEs.  The scheme for doing this is as follows.  A distinction
!             is drawn between the participating grids.  There is a single
!             "side 1" grid and it does not have partitions (sub-grid surface
!             types).  There are one or more "side 2" grids and they may have
!             more than 1 partition.  In standard usage, the atmosphere grid is
!             on side 1 and the land and sea ice grids are on side 2.  The set
!             of exchange cells computed on a PE corresponds to its side 2
!             geographic region(s).  Communication between the PEs takes place
!             on the side 1 grid.  Note:  this scheme does not generally allow
!             reproduction of answers across varying PE counts.  This is
!             because, in the side 1 "get", exchange cells are first summed
!             locally onto a side 1 grid, then these side 1 contributions are
!             further summed after they have been communicated to their target
!             PE.  For the make_exchange_reproduce option, a special side 1 get
!             is used.  This get communicates individual exchange cells.  The
!             cells are summed in the order they appear in the grid spec. file.
!                                    Michael Winton (Michael.Winton@noaa.gov) Oct 2001
!
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
module xgrid_mod

! <CONTACT EMAIL="Michael.Winton@noaa.gov">
!   Michael Winton
! </CONTACT>
! <CONTACT EMAIL="Zhi.Liang@noaa.gov">
!   Zhi Liang
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!    <TT>xgrid_mod</TT> implements exchange grids for coupled models running on
!     multiple processors.  An exchange grid is formed from the union of
!     the bounding lines of the two (logically rectangular) participating
!     grids.  The exchange grid is therefore the coarsest grid that is a
!     refinement of both participating grids.  Exchange grids are used for
!     two purposes by coupled models:  (1) conservative interpolation of fields
!     between models uses the exchange grid cell areas as weights and
!     (2) the surface flux calculation takes place on the exchange grid thereby
!     using the finest scale data available.  <TT>xgrid_mod</TT> uses a NetCDF grid
!     specification file containing the grid cell overlaps in combination with
!     the <LINK SRC="ftp://ftp.gfdl.gov/pub/vb/mpp/mpp_domains.F90">
!     <TT>mpp_domains</TT></LINK> domain decomposition information to determine 
!     the grid and processor connectivities.
! </OVERVIEW>

! <DESCRIPTION>
!     <TT>xgrid_mod</TT> is initialized with a list of model identifiers (three characters
!     each), a list of <TT>mpp_domains</TT> domain data structures, and a grid specification
!     file name.  The first element in the lists refers to the "side one" grid.
!     The remaining elements are on "side two".  Thus, there may only be a single
!     side one grid and it is further restricted to have no partitions (sub-grid
!     areal divisions).  In standard usage, the atmosphere model is on side one
!     and the land and sea ice models are on side two.  <TT>xgrid_mod</TT> performs
!     interprocessor communication on the side one grid.  Exchange grid variables
!     contain no data for zero sized partitions.  The size and format of exchange
!     grid variables change every time the partition sizes or number of partitions
!     are modified with a <TT>set_frac_area</TT> call on a participating side two grid.
!     Existing exchange grid variables cannot be properly interpreted after
!     that time; new ones must be allocated and assigned with the <TT>put_to_xgrid</TT>
!     call.
! </DESCRIPTION>

! <DATA NAME="xmap_type"  TYPE=""  >
!   The fields of xmap_type are all private.
! </DATA>

! <DATASET NAME="">
!     <TT>xgrid_mod</TT> reads a NetCDF grid specification file to determine the
!     grid and processor connectivities.  The exchange grids are defined
!     by a sequence of quintuples:  the <TT>i/j</TT> indices of the intersecting
!     cells of the two participating grids and their areal overlap.
!     The names of the five fields are generated automatically from the
!     three character ids of the participating grids.  For example, if
!     the side one grid id is "ATM" and the side two grid id is "OCN",
!     <TT>xgrid_mod</TT> expects to find the following five fields in the grid
!     specification file:  <TT>I_ATM_ATMxOCN, J_ATM_ATMxOCN, I_OCN_ATMxOCN,
!     J_OCN_ATMxOCN, and AREA_ATMxOCN</TT>.  These fields may be generated
!     by the <TT>make_xgrids</TT> utility.
! </DATASET>

#include <fms_platform.h>

use       fms_mod,   only: file_exist, open_namelist_file, check_nml_error,  &
                           error_mesg, close_file, FATAL, NOTE, stdlog,      &
                           write_version_number, read_data, field_exist,     &
                           field_size, lowercase, string,                    &
                           get_mosaic_tile_grid
use     fms_io_mod,  only: get_var_att_value
use mpp_mod,         only: mpp_npes, mpp_pe, mpp_root_pe, mpp_send, mpp_recv, &
                           mpp_sync_self, stdout, mpp_max, EVENT_RECV,        &
                           mpp_get_current_pelist, mpp_clock_id, mpp_min,     &
                           mpp_alltoall,                                      &
                           mpp_clock_begin, mpp_clock_end, MPP_CLOCK_SYNC,    &
                           COMM_TAG_1, COMM_TAG_2, COMM_TAG_3, COMM_TAG_4,    &
                           COMM_TAG_5, COMM_TAG_6, COMM_TAG_7, COMM_TAG_8,    &
                           COMM_TAG_9, COMM_TAG_10
use mpp_mod,         only: input_nml_file, mpp_set_current_pelist, mpp_sum, mpp_sync
use mpp_domains_mod, only: mpp_get_compute_domain, mpp_get_compute_domains, &
                           Domain2d, mpp_global_sum, mpp_update_domains,    &
                           mpp_modify_domain, mpp_get_data_domain, XUPDATE, &
                           YUPDATE, mpp_get_current_ntile, mpp_get_tile_id, &
                           mpp_get_ntile_count, mpp_get_tile_list,          &
                           mpp_get_global_domain, Domain1d,                 &
                           mpp_deallocate_domain, mpp_define_domains,       &
                           mpp_get_domain_npes, mpp_get_domain_root_pe,     &
                           mpp_domain_is_initialized, mpp_broadcast_domain, &
                           mpp_get_domain_pelist, mpp_compute_extent
use mpp_io_mod,      only: mpp_open, MPP_MULTI, MPP_SINGLE, MPP_OVERWR
use constants_mod,   only: PI, RADIUS
use mosaic_mod,          only: get_mosaic_xgrid, get_mosaic_xgrid_size, &
                               get_mosaic_ntiles, get_mosaic_ncontacts, &
                               get_mosaic_contact, get_mosaic_grid_sizes

use stock_constants_mod, only: ISTOCK_TOP, ISTOCK_BOTTOM, ISTOCK_SIDE, STOCK_NAMES, &
                               STOCK_UNITS, NELEMS, stocks_file, stock_type
use gradient_mod,        only: gradient_cubic

implicit none
private

public xmap_type, setup_xmap, set_frac_area, put_to_xgrid, get_from_xgrid, &
       xgrid_count, some, conservation_check, xgrid_init, &
       AREA_ATM_SPHERE, AREA_LND_SPHERE, AREA_OCN_SPHERE, &
       AREA_ATM_MODEL, AREA_LND_MODEL, AREA_OCN_MODEL, &
       get_ocean_model_area_elements, grid_box_type,   &
       get_xmap_grid_area

!--- paramters that determine the remapping method
integer, parameter :: FIRST_ORDER        = 1
integer, parameter :: SECOND_ORDER       = 2
integer, parameter :: VERSION1           = 1 ! grid spec file
integer, parameter :: VERSION2           = 2 ! mosaic grid file
integer, parameter :: MAX_FIELDS         = 80

! <NAMELIST NAME="xgrid_nml">
!   <DATA NAME="make_exchange_reproduce" TYPE="logical"  DEFAULT=".false.">
!     Set to .true. to make <TT>xgrid_mod</TT> reproduce answers on different
!     numbers of PEs.  This option has a considerable performance impact.
!   </DATA>
!   <DATA NAME="interp_method" TYPE="character(len=64)"  DEFAULT=" 'first_order' ">
!     exchange grid interpolation method. It has two options: 
!     "first_order", "second_order".
!   </DATA>
!   <DATA NAME="xgrid_log" TYPE="logical"  DEFAULT=" .false. ">
!     Outputs exchange grid information to xgrid.out.<pe> for debug/diag purposes.
!   </DATA>
!   <DATA NAME="nsubset" TYPE="integer" DEFAULT="0">
!     number of processors to read exchange grid information. Those processors that read
!     the exchange grid information will send data to other processors to prepare for flux exchange.
!     Default value is 0. When nsubset is 0, each processor will read part of the exchange grid 
!     information. The purpose of this namelist is to improve performance of setup_xmap when running
!     on highr processor count and solve receiving size mismatch issue on high processor count.
!     Try to set nsubset = mpp_npes/MPI_rank_per_node.
!   </DATA>
logical :: make_exchange_reproduce = .false. ! exactly same on different # PEs
logical :: xgrid_log = .false. 
character(len=64) :: interp_method = 'first_order'
logical :: debug_stocks = .false. 
logical :: xgrid_clocks_on = .false.
logical :: monotonic_exchange = .false.
integer :: nsubset = 0 ! 0 means mpp_npes()
logical :: do_alltoall = .true.
logical :: do_alltoallv = .false.
namelist /xgrid_nml/ make_exchange_reproduce, interp_method, debug_stocks, xgrid_log, xgrid_clocks_on, &
    monotonic_exchange, nsubset, do_alltoall, do_alltoallv
! </NAMELIST>
logical :: init = .true.
integer :: remapping_method

! Area elements used inside each model
real, allocatable, dimension(:,:) :: AREA_ATM_MODEL, AREA_LND_MODEL, AREA_OCN_MODEL
! Area elements based on a the spherical model used by the ICE layer
real, allocatable, dimension(:,:) :: AREA_ATM_SPHERE, AREA_LND_SPHERE, AREA_OCN_SPHERE

! <INTERFACE NAME="put_to_xgrid">

!   <OVERVIEW>
!     Scatters data from model grid onto exchange grid.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Scatters data from model grid onto exchange grid.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call put_to_xgrid(d, grid_id, x, xmap, remap_order)
!   </TEMPLATE>
!   <IN NAME="d"  TYPE="real"  > </IN>
!   <IN NAME="grid_id"  TYPE=" character(len=3)"  > </IN>
!   <INOUT NAME="x"  TYPE="real"  > </INOUT>
!   <INOUT NAME="xmap"  TYPE="xmap_type"  > </INOUT>
!   <IN NAME="remap_method" TYPE="integer,optional">
!     exchange grid interpolation method. It has four possible values: 
!     FIRST_ORDER (=1), SECOND_ORDER(=2). Default value is FIRST_ORDER.
!   </IN>
interface put_to_xgrid
  module procedure put_side1_to_xgrid
  module procedure put_side2_to_xgrid
end interface
! </INTERFACE>

! <INTERFACE NAME="get_from_xgrid">

!   <OVERVIEW>
!     Sums data from exchange grid to model grid.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Sums data from exchange grid to model grid.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call get_from_xgrid(d, grid_id, x, xmap)
!   </TEMPLATE>
!   <IN NAME="x"  TYPE="real"  > </IN>
!   <IN NAME="grid_id"  TYPE=" character(len=3)"  > </IN>
!   <OUT NAME="d"  TYPE="real"  > </OUT>
!   <INOUT NAME="xmap"  TYPE="xmap_type"  > </INOUT>
interface get_from_xgrid
  module procedure get_side1_from_xgrid
  module procedure get_side2_from_xgrid
end interface
! </INTERFACE>

! <INTERFACE NAME="conservation_check">

!   <OVERVIEW>
!     Returns three numbers which are the global sum of a variable.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Returns three numbers which are the global sum of a
!     variable (1) on its home model grid, (2) after interpolation to the other
!     side grid(s), and (3) after re_interpolation back onto its home side grid(s).
!     Conservation_check must be called by all PEs to work properly.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call conservation_check(d, grid_id, xmap,remap_order)
!   </TEMPLATE>
!   <IN NAME="d"  TYPE="real" DIM="(:,:)" > </IN>
!   <IN NAME="grid_id"  TYPE="character(len=3)"  > </IN>
!   <INOUT NAME="xmap"  TYPE="xmap_type"  > </INOUT>
!   <OUT NAME="" TYPE="real" DIM="3">The global sum of a variable.</OUT>
!   <IN NAME="remap_method" TYPE="integer,optional">
!   </IN>
interface conservation_check
  module procedure conservation_check_side1
  module procedure conservation_check_side2
end interface
! </INTERFACE>

type xcell_type
  integer :: i1, j1, i2, j2 ! indices of cell in model arrays on both sides
  integer :: recv_pos       ! position in the receive buffer.
  integer :: pe             ! other side pe that has this cell
  integer :: tile           ! tile index of side 1 mosaic.
  real    :: area           ! geographic area of exchange cell
!  real    :: area1_ratio     !(= x_area/grid1_area), will be added in the future to improve efficiency
!  real    :: area2_ratio     !(= x_area/grid2_area), will be added in the future to improve efficiency
  real    :: di, dj         ! Weight for the gradient of flux
  real    :: scale
end type xcell_type

type grid_box_type
   real, dimension(:,:),   pointer :: dx     => NULL()
   real, dimension(:,:),   pointer :: dy     => NULL()
   real, dimension(:,:),   pointer :: area   => NULL()
   real, dimension(:),     pointer :: edge_w => NULL()
   real, dimension(:),     pointer :: edge_e => NULL()
   real, dimension(:),     pointer :: edge_s => NULL()
   real, dimension(:),     pointer :: edge_n => NULL()
   real, dimension(:,:,:), pointer :: en1    => NULL()
   real, dimension(:,:,:), pointer :: en2    => NULL()
   real, dimension(:,:,:), pointer :: vlon   => NULL()
   real, dimension(:,:,:), pointer :: vlat   => NULL()
end type grid_box_type

type grid_type
  character(len=3)                :: id                               ! grid identifier
  integer                         :: npes                             ! number of processor on this grid.
  logical                         :: on_this_pe                       ! indicate the domain is defined on this pe
  integer                         :: root_pe                          ! indicate the root pe of the domain
  integer, pointer, dimension(:)  :: pelist                           ! pelist of the domain
  integer                         :: ntile                            ! number of tiles in mosaic
  integer                         :: ni, nj                           ! max of global size of all the tiles
  integer, pointer, dimension(:)  :: tile =>NULL()                    ! tile id ( pe index )
  integer, pointer, dimension(:)  :: is =>NULL(), ie =>NULL()         ! domain - i-range (pe index)
  integer, pointer, dimension(:)  :: js =>NULL(), je =>NULL()         ! domain - j-range (pe index)
  integer, pointer                :: is_me =>NULL(),  ie_me =>NULL()  ! my domain - i-range
  integer, pointer                :: js_me =>NULL(),  je_me =>NULL()  ! my domain - j-range
  integer                         :: isd_me, ied_me                   ! my data domain - i-range
  integer                         :: jsd_me, jed_me                   ! my data domain - j-range
  integer                         :: nxd_me, nyd_me                   ! data domain size
  integer                         :: nxc_me, nyc_me                   ! compute domain size
  integer, pointer                :: tile_me                          ! my tile id
  integer                         :: im , jm , km                     ! global domain range
  real, pointer, dimension(:)     :: lon =>NULL(), lat =>NULL()       ! center of global grids
  real, pointer, dimension(:,:)   :: geolon=>NULL(), geolat=>NULL()   ! geographical grid center
  real, pointer, dimension(:,:,:) :: frac_area =>NULL()               ! partition fractions
  real, pointer, dimension(:,:)   :: area =>NULL()                    ! cell area
  real, pointer, dimension(:,:)   :: area_inv =>NULL()                ! 1 / area for normalization
  integer                         :: first, last                      ! xgrid index range
  integer                         :: first_get, last_get              ! xgrid index range for get_2_from_xgrid
  integer                         :: size                             ! # xcell patterns
  type(xcell_type), pointer       :: x(:) =>NULL()                    ! xcell patterns
  integer                         :: size_repro                       ! # side 1 patterns for repro
  type(xcell_type), pointer       :: x_repro(:) =>NULL()              ! side 1 patterns for repro
  type(Domain2d)                  :: domain                           ! used for conservation checks
  type(Domain2d)                  :: domain_with_halo                 ! used for second order remapping
  logical                         :: is_latlon                        ! indicate if the grid is lat-lon grid or not.
  type(grid_box_type)             :: box                              ! used for second order remapping.
end type grid_type

type x1_type
  integer :: i, j
  real    :: area   ! (= geographic area * frac_area)
!  real    :: area_ratio !(= x1_area/grid1_area) ! will be added in the future to improve efficiency
  real    :: di, dj ! weight for the gradient of flux
  integer :: tile           ! tile index of side 1 mosaic.
  integer :: pos
end type x1_type

type x2_type
  integer :: i, j, k, pos
  real    :: area   ! geographic area of exchange cell
!  real    :: area_ratio !(=x2_area/grid2_area )  ! will be added in the future to improve efficiency
end type x2_type

type overlap_type
   integer          :: count
   integer          :: pe
   integer          :: buffer_pos
   integer, _ALLOCATABLE :: i(:) _NULL
   integer, _ALLOCATABLE :: j(:) _NULL
   integer, _ALLOCATABLE :: g(:) _NULL
   integer, _ALLOCATABLE :: xLoc(:) _NULL
   integer, _ALLOCATABLE :: tile(:) _NULL
   real,    _ALLOCATABLE :: di(:) _NULL
   real,    _ALLOCATABLE :: dj(:) _NULL
end type overlap_type

type comm_type
  integer                         :: nsend, nrecv
  integer                         :: sendsize, recvsize
  integer,            pointer, dimension(:) :: unpack_ind=>NULL()
  type(overlap_type), pointer, dimension(:) :: send=>NULL()
  type(overlap_type), pointer, dimension(:) :: recv=>NULL()  
end type comm_type

type xmap_type
  private
  integer :: size            ! # of exchange grid cells with area > 0 on this pe
  integer :: size_put1       ! # of exchange grid cells for put_1_to_xgrid
  integer :: size_get2       ! # of exchange grid cells for get_2_to_xgrid
  integer :: me, npes, root_pe
  logical, pointer, dimension(:) :: your1my2  =>NULL()! true if side 1 domain on
                                                      ! indexed pe overlaps side 2
                                                      ! domain on this pe
  logical, pointer, dimension(:) :: your2my1 =>NULL() ! true if a side 2 domain on
                                                      ! indexed pe overlaps side 1
                                                      ! domain on this pe
  integer, pointer, dimension(:) :: your2my1_size=>NULL() ! number of exchange grid of 
                                                          ! a side 2 domain on
                                                          ! indexed pe overlaps side 1
                                                          ! domain on this pe

  type (grid_type), pointer, dimension(:) :: grids =>NULL() ! 1st grid is side 1;
                                                            ! rest on side 2
  !
  ! Description of the individual exchange grid cells (index is cell #)
  !
  type(x1_type), pointer, dimension(:) :: x1 =>NULL() ! side 1 info
  type(x1_type), pointer, dimension(:) :: x1_put =>NULL() ! side 1 info
  type(x2_type), pointer, dimension(:) :: x2 =>NULL() ! side 2 info
  type(x2_type), pointer, dimension(:) :: x2_get =>NULL() ! side 2 info

  integer, pointer, dimension(:) :: send_count_repro =>NULL()
  integer, pointer, dimension(:) :: recv_count_repro  =>NULL()
  integer                        :: send_count_repro_tot ! sum(send_count_repro)
  integer                        :: recv_count_repro_tot ! sum(recv_count_repro)
  integer :: version                                  ! version of xgrids. version=VERSION! is for grid_spec file 
                                                      ! and version=VERSION2 is for mosaic grid.
  integer, pointer, dimension(:) :: ind_get1 =>NULL() ! indx for side1 get and side2 put.
  integer, pointer, dimension(:) :: ind_put1 =>NULL() ! indx for side1 put and side 2get.
  type(comm_type), pointer       :: put1 =>NULL()      ! for put_1_to_xgrid
  type(comm_type), pointer       :: get1 =>NULL()      ! for get_1_from_xgrid
  type(comm_type), pointer       :: get1_repro =>NULL()! for get_1_from_xgrid_repro
end type xmap_type

!-----------------------------------------------------------------------
 character(len=128) :: version = '$Id$'
 character(len=128) :: tagname = '$Name$'

 real, parameter                              :: EPS = 1.0e-10
 real, parameter                              :: LARGE_NUMBER = 1.e20
 logical :: module_is_initialized = .FALSE.
 integer :: id_put_1_to_xgrid_order_1 = 0
 integer :: id_put_1_to_xgrid_order_2 = 0
 integer :: id_get_1_from_xgrid = 0
 integer :: id_get_1_from_xgrid_repro = 0
 integer :: id_get_2_from_xgrid = 0
 integer :: id_put_2_to_xgrid = 0
 integer :: id_setup_xmap = 0
 integer :: id_load_xgrid1, id_load_xgrid2, id_load_xgrid3
 integer :: id_load_xgrid4, id_load_xgrid5
 integer :: id_load_xgrid, id_set_comm, id_regen, id_conservation_check


 ! The following is for nested model
 integer :: nnest=0, tile_nest, tile_parent
 integer :: is_nest=0, ie_nest=0, js_nest=0, je_nest=0
 integer :: is_parent=0, ie_parent=0, js_parent=0, je_parent=0 

 ! The following is required to compute stocks of water, heat, ...

  interface stock_move
     module procedure stock_move_3d, stock_move_2d
  end interface

  public stock_move, stock_type, stock_print, get_index_range, stock_integrate_2d
  public FIRST_ORDER, SECOND_ORDER

contains

!#######################################################################

logical function in_box(i, j, is, ie, js, je)
integer :: i, j, is, ie, js, je

  in_box = (i>=is) .and. (i<=ie) .and. (j>=js) .and. (j<=je)
end function in_box

!#######################################################################

! <SUBROUTINE NAME="xgrid_init">

!   <OVERVIEW>
!     Initialize the xgrid_mod. 
!   </OVERVIEW>
!   <DESCRIPTION>
!     Initialization routine for the xgrid module. It reads the xgrid_nml,  
!     writes the version information and xgrid_nml to the log file.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call xgrid_init ( )
!   </TEMPLATE>
!   <OUT NAME="remap_method" TYPE="integer">
!     exchange grid interpolation method. It has four possible values: 
!     FIRST_ORDER (=1), SECOND_ORDER(=2).
!   </OUT>
subroutine xgrid_init(remap_method) 
  integer, intent(out) :: remap_method

  integer :: unit, ierr, io, out_unit

  if (module_is_initialized) return
  module_is_initialized = .TRUE.


#ifdef INTERNAL_FILE_NML
      read (input_nml_file, xgrid_nml, iostat=io)
      ierr = check_nml_error ( io, 'xgrid_nml' )
#else
  if ( file_exist( 'input.nml' ) ) then
      unit = open_namelist_file ( )
      ierr = 1
      do while ( ierr /= 0 )
        read ( unit,  nml = xgrid_nml, iostat = io, end = 10 )
        ierr = check_nml_error ( io, 'xgrid_nml' )
      enddo
  10 continue
      call close_file ( unit )
  endif
#endif

!--------- write version number and namelist ------------------
  call write_version_number (version, tagname)

  unit = stdlog ( )
  out_unit = stdout()
  if ( mpp_pe() == mpp_root_pe() ) write (unit,nml=xgrid_nml)
  call close_file (unit)

!--------- check interp_method has suitable value
!--- when monotonic_exchange is true, interp_method must be second order.

  select case(trim(interp_method))
  case('first_order')
     remap_method = FIRST_ORDER
     if( monotonic_exchange ) call error_mesg('xgrid_mod', &
         'xgrid_nml monotonic_exchange must be .false. when interp_method = first_order', FATAL)  
     write(out_unit,*)"NOTE from xgrid_mod: use first_order conservative exchange"
  case('second_order')
     if(monotonic_exchange) then
        write(out_unit,*)"NOTE from xgrid_mod: use monotonic second_order conservative exchange"
     else
        write(out_unit,*)"NOTE from xgrid_mod: use second_order conservative exchange"
     endif
     remap_method = SECOND_ORDER
  case default
     call error_mesg('xgrid_mod', ' nml interp_method = ' //trim(interp_method)// &
      ' is not a valid namelist option', FATAL)
  end select

  if(xgrid_clocks_on) then
     id_put_1_to_xgrid_order_1 = mpp_clock_id("put_1_to_xgrid_order_1", flags=MPP_CLOCK_SYNC)
     id_put_1_to_xgrid_order_2 = mpp_clock_id("put_1_to_xgrid_order_2", flags=MPP_CLOCK_SYNC)
     id_get_1_from_xgrid       = mpp_clock_id("get_1_from_xgrid", flags=MPP_CLOCK_SYNC) 
     id_get_1_from_xgrid_repro = mpp_clock_id("get_1_from_xgrid_repro", flags=MPP_CLOCK_SYNC)
     id_get_2_from_xgrid       = mpp_clock_id("get_2_from_xgrid", flags=MPP_CLOCK_SYNC) 
     id_put_2_to_xgrid         = mpp_clock_id("put_2_to_xgrid", flags=MPP_CLOCK_SYNC) 
     id_setup_xmap             = mpp_clock_id("setup_xmap", flags=MPP_CLOCK_SYNC) 
     id_set_comm               = mpp_clock_id("set_comm") 
     id_regen                  = mpp_clock_id("regen") 
     id_conservation_check     = mpp_clock_id("conservation_check")
     id_load_xgrid             = mpp_clock_id("load_xgrid") 
     id_load_xgrid1            = mpp_clock_id("load_xgrid1")
     id_load_xgrid2            = mpp_clock_id("load_xgrid2")
     id_load_xgrid3            = mpp_clock_id("load_xgrid3")
     id_load_xgrid4            = mpp_clock_id("load_xgrid4")
     id_load_xgrid5            = mpp_clock_id("load_xgrid5")
  endif

  remapping_method = remap_method

end subroutine xgrid_init
! </SUBROUTINE>

!#######################################################################

subroutine load_xgrid (xmap, grid, grid_file, grid1_id, grid_id, tile1, tile2, use_higher_order)
type(xmap_type), intent(inout)         :: xmap
type(grid_type), intent(inout)         :: grid
character(len=*), intent(in)           :: grid_file
character(len=3), intent(in)           :: grid1_id, grid_id
integer,          intent(in)           :: tile1, tile2
logical,        intent(in)             :: use_higher_order

  integer, pointer,       dimension(:)   :: i1=>NULL(), j1=>NULL()
  integer, pointer,       dimension(:)   :: i2=>NULL(), j2=>NULL()            
  real,    pointer,       dimension(:)   :: di=>NULL(), dj=>NULL()
  real,    pointer,       dimension(:)   :: area =>NULL()     
  integer, pointer,       dimension(:)   :: i1_tmp=>NULL(), j1_tmp=>NULL()
  integer, pointer,       dimension(:)   :: i2_tmp=>NULL(), j2_tmp=>NULL()
  real,    pointer,       dimension(:)   :: di_tmp=>NULL(), dj_tmp=>NULL()
  real,    pointer,       dimension(:)   :: area_tmp =>NULL()
  integer, pointer,       dimension(:)   :: i1_side1=>NULL(), j1_side1=>NULL()
  integer, pointer,       dimension(:)   :: i2_side1=>NULL(), j2_side1=>NULL()            
  real,    pointer,       dimension(:)   :: di_side1=>NULL(), dj_side1=>NULL()
  real,    pointer,       dimension(:)   :: area_side1 =>NULL()    

  real,    allocatable, dimension(:,:) :: tmp
  real,    allocatable, dimension(:)   :: send_buffer, recv_buffer
  type (grid_type),   pointer, save    :: grid1 =>NULL()
  integer                              :: l, ll, ll_repro, p, siz(4), nxgrid, size_prev
  type(xcell_type),   allocatable      :: x_local(:)
  integer                              :: size_repro, out_unit
  logical                              :: scale_exist = .false.
  logical                              :: is_distribute = .false.
  real,    allocatable,   dimension(:) :: scale
  real                                 :: garea
  integer                              :: npes, isc, iec, nxgrid_local, pe, nxgrid_local_orig
  integer                              :: nxgrid1, nxgrid2, nset1, nset2, ndivs, cur_ind
  integer                              :: pos, nsend, nrecv, l1, l2, n, mypos, m
  integer                              :: start(4), nread(4)
  logical                              :: found
  character(len=128)                   :: attvalue
  integer, dimension(0:xmap%npes-1)    :: pelist
  logical, dimension(0:xmap%npes-1)    :: subset_rootpe
  integer, dimension(0:xmap%npes-1)    :: nsend1, nsend2, nrecv1, nrecv2
  integer, dimension(0:xmap%npes-1)    :: send_cnt, recv_cnt
  integer, dimension(0:xmap%npes-1)    :: send_buffer_pos, recv_buffer_pos
  integer, dimension(0:xmap%npes-1)    :: ibegin, iend, pebegin, peend
  integer, dimension(2*xmap%npes)      :: ibuf1, ibuf2
  integer, dimension(0:xmap%npes-1)    :: pos_x, y2m1_size
  integer, allocatable,   dimension(:) :: y2m1_pe
  integer, pointer, save               :: iarray(:), jarray(:)
  integer, allocatable, save           :: pos_s(:)
  integer, pointer,       dimension(:) :: iarray2(:)=>NULL(), jarray2(:)=>NULL()
  logical                              :: last_grid
  integer                              :: nxgrid1_old

  scale_exist = .false.
  grid1 => xmap%grids(1)
  out_unit = stdout()
  npes     = xmap%npes
  pe       = mpp_pe()
  mypos = mpp_pe()-mpp_root_pe()

  call mpp_get_current_pelist(pelist)
  !--- make sure npes = pelist(npes-1) - pelist(0) + 1
  if( npes .NE. pelist(npes-1) - pelist(0) + 1 ) then
     print*, "npes =", npes, ", pelist(npes-1)=", pelist(npes-1), ", pelist(0)=", pelist(0)
     call error_mesg('xgrid_mod', 'npes .NE. pelist(npes-1) - pelist(0)', FATAL)
  endif

  select case(xmap%version)
  case(VERSION1)
     call field_size(grid_file, 'AREA_'//grid1_id//'x'//grid_id, siz)
     nxgrid = siz(1);
     if(nxgrid .LE. 0) return
  case(VERSION2)
     !--- max_size is the exchange grid size between super grid.
     nxgrid = get_mosaic_xgrid_size(grid_file)
     if(nxgrid .LE. 0) return
  end select

  !--- define a domain to read exchange grid.
  if(nxgrid > npes) then
     ndivs = npes
     if(nsubset >0 .AND. nsubset < npes) ndivs = nsubset     
     call mpp_compute_extent( 1, nxgrid, ndivs, ibegin, iend)
     if(npes == ndivs) then
        p = mpp_pe()-mpp_root_pe()
        isc = ibegin(p)
        iec = iend(p)
        subset_rootpe(:) = .true.
     else
        isc = 0; iec = -1
        call mpp_compute_extent(pelist(0), pelist(npes-1), ndivs, pebegin, peend)
        do n = 0, ndivs-1
           if(pe == pebegin(n)) then
              isc = ibegin(n)
              iec = iend(n)
              exit
           endif
        enddo
        cur_ind = 0
        subset_rootpe(:) = .false.

        do n = 0, npes-1
           if(pelist(n) == pebegin(cur_ind)) then
              subset_rootpe(n) = .true.
              cur_ind = cur_ind+1
              if(cur_ind == ndivs) exit
           endif
        enddo
     endif
     is_distribute = .true.
  else
     is_distribute = .false.
     isc = 1; iec = nxgrid
  endif

  nset1 = 5
  nset2 = 5
  if(use_higher_order) then
     nset1 = nset1 + 2
     nset2 = nset2 + 2
  end if
  if(scale_exist) nset2 = nset1 + 1

  call mpp_clock_begin(id_load_xgrid1)
  if(iec .GE. isc) then
     nxgrid_local = iec - isc + 1
     allocate(i1_tmp(isc:iec), j1_tmp(isc:iec), i2_tmp(isc:iec), j2_tmp(isc:iec), area_tmp(isc:iec) )
     if(use_higher_order) allocate(di_tmp(isc:iec), dj_tmp(isc:iec))

     start = 1; nread = 1

     select case(xmap%version)
     case(VERSION1)
        start(1) = isc; nread(1) = nxgrid_local
        allocate(tmp(nxgrid_local,1))
        call read_data(grid_file, 'I_'//grid1_id//'_'//grid1_id//'x'//grid_id, tmp, start, nread, no_domain=.TRUE.)
        i1_tmp = tmp(:,1)
        call read_data(grid_file, 'J_'//grid1_id//'_'//grid1_id//'x'//grid_id, tmp, start, nread, no_domain=.TRUE.)
        j1_tmp = tmp(:,1)
        call read_data(grid_file, 'I_'//grid_id//'_'//grid1_id//'x'//grid_id, tmp, start, nread, no_domain=.TRUE.)
        i2_tmp = tmp(:,1)
        call read_data(grid_file, 'J_'//grid_id//'_'//grid1_id//'x'//grid_id, tmp, start, nread, no_domain=.TRUE.)
        j2_tmp = tmp(:,1)
        call read_data(grid_file, 'AREA_'//grid1_id//'x'//grid_id, tmp, start, nread, no_domain=.TRUE.)
        area_tmp = tmp(:,1)
        if(use_higher_order) then
           call read_data(grid_file, 'DI_'//grid1_id//'x'//grid_id, tmp, start, nread, no_domain=.TRUE.)
           di_tmp = tmp(:,1)
           call read_data(grid_file, 'DJ_'//grid1_id//'x'//grid_id, tmp, start, nread, no_domain=.TRUE.)
           dj_tmp = tmp(:,1)
        end if
        deallocate(tmp)
     case(VERSION2)
        nread(1) = 2; start(2) = isc; nread(2) = nxgrid_local
        allocate(tmp(2, isc:iec))
        call read_data(grid_file, "tile1_cell", tmp, start, nread, no_domain=.TRUE.)
        i1_tmp(isc:iec) = tmp(1, isc:iec)
        j1_tmp(isc:iec) = tmp(2, isc:iec)
        call read_data(grid_file, "tile2_cell", tmp, start, nread, no_domain=.TRUE.)
        i2_tmp(isc:iec) = tmp(1, isc:iec)
        j2_tmp(isc:iec) = tmp(2, isc:iec)
        if(use_higher_order) then
           call read_data(grid_file, "tile1_distance", tmp, start, nread, no_domain=.TRUE.)
           di_tmp(isc:iec) = tmp(1, isc:iec)
           dj_tmp(isc:iec) = tmp(2, isc:iec)
        end if
        start = 1; nread = 1
        start(1) = isc; nread(1) = nxgrid_local
        deallocate(tmp)
        allocate(tmp(isc:iec,1) )
        call read_data(grid_file, "xgrid_area", tmp(:,1:1), start, nread, no_domain=.TRUE.)
        ! check the units of "xgrid_area 
        call get_var_att_value(grid_file, "xgrid_area", "units", attvalue)
        if( trim(attvalue) == 'm2' ) then
           garea = 4.0*PI*RADIUS*RADIUS;
           area_tmp = tmp(:,1)/garea
        else if( trim(attvalue) == 'none' ) then
           area_tmp = tmp(:,1)
        else 
           call error_mesg('xgrid_mod', 'In file '//trim(grid_file)//', xgrid_area units = '// &
                trim(attvalue)//' should be "m2" or "none"', FATAL)
        endif

        !--- if field "scale" exist, read this field. Normally this 
        !--- field only exist in landXocean exchange grid cell.
        if(grid1_id == 'LND' .AND. grid_id == 'OCN') then
           if(field_exist(grid_file, "scale")) then
              allocate(scale(isc:iec))
              write(out_unit, *)"NOTE from load_xgrid(xgrid_mod): field 'scale' exist in the file "// &
                   trim(grid_file)//", this field will be read and the exchange grid cell area will be multiplied by scale"
              call read_data(grid_file, "scale", tmp, start, nread, no_domain=.TRUE.)
              scale = tmp(:,1)
              scale_exist = .true.
           endif
        endif
        deallocate(tmp)
     end select

     !---z1l: The following change is for the situation that some processor is masked out.
     !---loop through all the pe to see if side 1 and side of each exchange grid is on some processor
     nxgrid_local_orig = nxgrid_local
     allocate(i1(isc:iec), j1(isc:iec), i2(isc:iec), j2(isc:iec), area(isc:iec) )
     if(use_higher_order) allocate(di(isc:iec), dj(isc:iec))
     pos = isc-1

     do l = isc, iec
        found = .false.
        !--- first check if the exchange grid is on one of side 1 processor
        do p = 0, npes - 1
           if(grid1%tile(p) == tile1) then
              if (in_box(i1_tmp(l), j1_tmp(l), grid1%is(p), grid1%ie(p), grid1%js(p), grid1%je(p)))  then
                 found = .true.
                 exit
              endif
           endif
        enddo
        !--- Then check if the exchange grid is on one of side 2 processor
        if( found ) then
           do p = 0, npes - 1
              if(grid%tile(p) == tile2) then
                 if (in_box(i2_tmp(l), j2_tmp(l), grid%is(p), grid%ie(p), grid%js(p), grid%je(p)))  then
                    pos = pos+1
                    i1(pos) = i1_tmp(l)
                    j1(pos) = j1_tmp(l)
                    i2(pos) = i2_tmp(l)
                    j2(pos) = j2_tmp(l)
                    area(pos) = area_tmp(l)
                    if(use_higher_order) then
                       di(pos) = di_tmp(l)
                       dj(pos) = dj_tmp(l)
                    endif
                    exit
                 endif
              endif
           enddo
        endif
     enddo

     deallocate(i1_tmp, i2_tmp, j1_tmp, j2_tmp, area_tmp)
     if(use_higher_order) deallocate( di_tmp, dj_tmp)
     iec = pos
     if(iec .GE. isc) then
        nxgrid_local = iec - isc + 1
     else
        nxgrid_local = 0
     endif


  else
     nxgrid_local = 0
     nxgrid_local_orig = 0
  endif

  call mpp_clock_end(id_load_xgrid1)

  if(is_distribute) then
     !--- Since the xgrid is distributed according to side 2 grid. Send all the xgrid to its own side 2. 
     !--- Also need to send the xgrid to its own side 1 for the reproducing ability between processor count.
     !--- first find out number of points need to send to other pe and fill the send buffer.
     nsend1(:) = 0; nrecv1(:) = 0
     nsend2(:) = 0; nrecv2(:) = 0
     ibuf1(:) = 0; ibuf2(:) = 0

     call mpp_clock_begin(id_load_xgrid2)

     if(nxgrid_local>0) then
        allocate( send_buffer(nxgrid_local * (nset1+nset2)) )
        pos = 0
        do p = 0, npes - 1
           send_buffer_pos(p) = pos
           if(grid%tile(p) == tile2) then
              do l = isc, iec
                 if (in_box(i2(l), j2(l), grid%is(p), grid%ie(p), grid%js(p), grid%je(p)))  then
                    nsend2(p) = nsend2(p) + 1
                    send_buffer(pos+1) = i1(l)
                    send_buffer(pos+2) = j1(l)
                    send_buffer(pos+3) = i2(l)
                    send_buffer(pos+4) = j2(l)
                    send_buffer(pos+5) = area(l)
                    if(use_higher_order) then
                       send_buffer(pos+6) = di(l)
                       send_buffer(pos+7) = dj(l)
                    endif
                    if(scale_exist) send_buffer(pos+nset2) = scale(l)
                    pos = pos + nset2
                 endif
              enddo
           endif
           if(grid1%tile(p) == tile1) then
              do l = isc, iec
                 if (in_box(i1(l), j1(l), grid1%is(p), grid1%ie(p), grid1%js(p), grid1%je(p)))  then
                    nsend1(p) = nsend1(p) + 1
                    send_buffer(pos+1) = i1(l)
                    send_buffer(pos+2) = j1(l)
                    send_buffer(pos+3) = i2(l)
                    send_buffer(pos+4) = j2(l)
                    send_buffer(pos+5) = area(l)
                    if(use_higher_order) then
                       send_buffer(pos+6) = di(l)
                       send_buffer(pos+7) = dj(l)
                    endif
                    pos = pos + nset1
                 endif
              enddo
           endif
        enddo
     endif
     call mpp_clock_end(id_load_xgrid2)

     !--- send the size of the data on side 1 to be sent over.
     call mpp_clock_begin(id_load_xgrid3)

     if (do_alltoall) then
        do p = 0, npes-1
                ibuf1(2*p+1) = nsend1(p)
                ibuf1(2*p+2) = nsend2(p)
        enddo
        call mpp_alltoall(ibuf1, 2, ibuf2, 2)
     else
        do n = 0, npes-1
           p = mod(mypos+npes-n, npes)
           if(.not. subset_rootpe(p)) cycle
           call mpp_recv( ibuf2(2*p+1), glen=2, from_pe=pelist(p), block=.FALSE., tag=COMM_TAG_1)
        enddo

        if(nxgrid_local_orig>0) then
           do n = 0, npes-1
              p = mod(mypos+n, npes)
              ibuf1(2*p+1) = nsend1(p)
              ibuf1(2*p+2) = nsend2(p)
              call mpp_send( ibuf1(2*p+1), plen=2, to_pe=pelist(p), tag=COMM_TAG_1)
           enddo
        endif
        call mpp_sync_self(check=EVENT_RECV)
     endif
     do p = 0, npes-1
        nrecv1(p) = ibuf2(2*p+1)
        nrecv2(p) = ibuf2(2*p+2)
     enddo

     if(.not. do_alltoall) call mpp_sync_self()
     call mpp_clock_end(id_load_xgrid3)
     call mpp_clock_begin(id_load_xgrid4)
     pos = 0
     do p = 0, npes - 1
        recv_buffer_pos(p) = pos
        pos = pos + nrecv1(p) * nset1 + nrecv2(p) * nset2
     end do

     !--- now get the data
     nxgrid1 = sum(nrecv1)
     nxgrid2 = sum(nrecv2)
     if(nxgrid1>0 .OR. nxgrid2>0) allocate(recv_buffer(nxgrid1*nset1+nxgrid2*nset2))

     if (do_alltoallv) then
        ! Construct the send and receive counters
        send_cnt(:) = nset1 * nsend1(:) + nset2 * nsend2(:)
        recv_cnt(:) = nset1 * nrecv1(:) + nset2 * nrecv2(:)

        call mpp_alltoall(send_buffer, send_cnt, send_buffer_pos, &
                          recv_buffer, recv_cnt, recv_buffer_pos)
     else
        do n = 0, npes-1
           p = mod(mypos+npes-n, npes)
           nrecv = nrecv1(p)*nset1+nrecv2(p)*nset2
           if(nrecv==0) cycle
           pos = recv_buffer_pos(p)
           call mpp_recv(recv_buffer(pos+1), glen=nrecv, from_pe=pelist(p), &
                         block=.FALSE., tag=COMM_TAG_2)
        end do

        do n = 0, npes-1
           p = mod(mypos+n, npes)
           nsend = nsend1(p)*nset1 + nsend2(p)*nset2
           if(nsend==0) cycle
           pos = send_buffer_pos(p)
           call mpp_send(send_buffer(pos+1), plen=nsend, to_pe=pelist(p), &
                         tag=COMM_TAG_2)
        end do
        call mpp_sync_self(check=EVENT_RECV)
     end if
     call mpp_clock_end(id_load_xgrid4)
     !--- unpack buffer.
     if( nxgrid_local>0) then
        deallocate(i1,j1,i2,j2,area)
     endif 

     allocate(i1(nxgrid2), j1(nxgrid2))
     allocate(i2(nxgrid2), j2(nxgrid2))
     allocate(area(nxgrid2))
     allocate(i1_side1(nxgrid1), j1_side1(nxgrid1))
     allocate(i2_side1(nxgrid1), j2_side1(nxgrid1))
     allocate(area_side1(nxgrid1))
     if(use_higher_order) then
        if(nxgrid_local>0) deallocate(di,dj)
        allocate(di      (nxgrid2), dj      (nxgrid2))
        allocate(di_side1(nxgrid1), dj_side1(nxgrid1))
     endif
     if(scale_exist) then
        if(nxgrid_local>0)deallocate(scale)
        allocate(scale(nxgrid2))
     endif
     pos = 0
     l1 = 0; l2 = 0
     do p = 0,npes-1
        do n = 1, nrecv2(p)
           l2 = l2+1
           i1(l2) = recv_buffer(pos+1)
           j1(l2) = recv_buffer(pos+2)
           i2(l2) = recv_buffer(pos+3)
           j2(l2) = recv_buffer(pos+4)
           area(l2) = recv_buffer(pos+5)
           if(use_higher_order) then
              di(l2) = recv_buffer(pos+6)
              dj(l2) = recv_buffer(pos+7)
           endif
           if(scale_exist)scale(l2) = recv_buffer(pos+nset2)
           pos = pos + nset2
        enddo
        do n = 1, nrecv1(p)
           l1 = l1+1
           i1_side1(l1) = recv_buffer(pos+1)
           j1_side1(l1) = recv_buffer(pos+2)
           i2_side1(l1) = recv_buffer(pos+3)
           j2_side1(l1) = recv_buffer(pos+4)
           area_side1(l1) = recv_buffer(pos+5)
           if(use_higher_order) then
              di_side1(l1) = recv_buffer(pos+6)
              dj_side1(l1) = recv_buffer(pos+7)
           endif
           pos = pos + nset1
        enddo
     enddo
     call mpp_sync_self()
     if(allocated(send_buffer)) deallocate(send_buffer)
     if(allocated(recv_buffer)) deallocate(recv_buffer)

  else
     nxgrid1 = nxgrid
     nxgrid2 = nxgrid
     i1_side1 => i1; j1_side1 => j1
     i2_side1 => i2; j2_side1 => j2
     area_side1 => area
     if(use_higher_order) then
        di_side1 => di
        dj_side1 => dj
     endif
  endif

  call mpp_clock_begin(id_load_xgrid5)


  size_prev = grid%size

  if(grid%tile_me == tile2) then
     do l=1,nxgrid2
        if (in_box(i2(l), j2(l), grid%is_me, grid%ie_me, grid%js_me, grid%je_me) ) then
           grid%size = grid%size + 1
           ! exclude the area overlapped with parent grid 
           if( grid1_id .NE. "ATM" .OR. tile1 .NE. tile_parent .OR.  &
                   .NOT. in_box(i1(l), j1(l), is_parent, ie_parent, js_parent, je_parent) ) then
              grid%area(i2(l),j2(l)) = grid%area(i2(l),j2(l))+area(l)
           endif
           do p=0,xmap%npes-1
              if(grid1%tile(p) == tile1) then
                 if (in_box(i1(l), j1(l), grid1%is(p), grid1%ie(p), &
                      grid1%js(p), grid1%je(p))) then
                    xmap%your1my2(p) = .true.
                 end if
              end if
           end do
        end if
     end do
  end if

  if(grid%size > size_prev) then
     if(size_prev > 0) then ! need to extend data
        allocate(x_local(size_prev))
        x_local = grid%x
        if(ASSOCIATED(grid%x)) deallocate(grid%x)
        allocate( grid%x( grid%size ) )
        grid%x(1:size_prev) = x_local
        deallocate(x_local)
     else
        allocate( grid%x( grid%size ) )
        grid%x%di = 0.0; grid%x%dj = 0.0
     end if
  end if

  ll = size_prev
  if( grid%tile_me == tile2 ) then ! me is tile2
     do l=1,nxgrid2
        if (in_box(i2(l), j2(l), grid%is_me, grid%ie_me, grid%js_me, grid%je_me)) then
           ! insert in this grids cell pattern list and add area to side 2 area
           ll = ll + 1
           grid%x(ll)%i1   = i1(l); grid%x(ll)%i2   = i2(l)
           grid%x(ll)%j1   = j1(l); grid%x(ll)%j2   = j2(l)
           grid%x(ll)%tile = tile1
           grid%x(ll)%area = area(l)
           if(scale_exist) then
              grid%x(ll)%scale = scale(l)
           else
              grid%x(ll)%scale = 1.0
           endif
           if(use_higher_order) then
              grid%x(ll)%di  = di(l)
              grid%x(ll)%dj  = dj(l)
           end if

           if (make_exchange_reproduce) then
              do p=0,xmap%npes-1
                 if(grid1%tile(p) == tile1) then
                    if (in_box(i1(l), j1(l), grid1%is(p), grid1%ie(p), &
                         grid1%js(p), grid1%je(p))) then
                       grid%x(ll)%pe = p + xmap%root_pe
                    end if
                 end if
              end do
           end if ! make_exchange reproduce
        end if
     end do
  end if

  if(grid%id == xmap%grids(size(xmap%grids(:)))%id) then
     last_grid = .true.
  else 
     last_grid = .false.
  endif

  size_repro = 0
  if(grid1%tile_me == tile1) then
     if(associated(iarray)) then
        nxgrid1_old = size(iarray(:))
     else
        nxgrid1_old = 0
     endif

     allocate(y2m1_pe(nxgrid1))
     if(.not. last_grid ) allocate(pos_s(0:xmap%npes-1))
     y2m1_pe = -1
     if(nxgrid1_old > 0) then
        do p=0,xmap%npes-1
           y2m1_size(p) = xmap%your2my1_size(p)
        enddo
     else
        y2m1_size = 0
     endif

     do l=1,nxgrid1
        if (in_box(i1_side1(l), j1_side1(l), grid1%is_me, grid1%ie_me, grid1%js_me, grid1%je_me) ) then
           grid1%area(i1_side1(l),j1_side1(l)) = grid1%area(i1_side1(l),j1_side1(l))+area_side1(l)
           do p=0,xmap%npes-1
              if (grid%tile(p) == tile2) then
                 if (in_box(i2_side1(l), j2_side1(l), grid%is(p), grid%ie(p), grid%js(p), grid%je(p)))  then
                    xmap%your2my1(p) = .true.
                    y2m1_pe(l) = p
                    y2m1_size(p) = y2m1_size(p) + 1
                 endif
              endif
           enddo
           size_repro = size_repro + 1
        endif
     enddo
     pos_x = 0
     do p = 1, npes-1
        pos_x(p) = pos_x(p-1) + y2m1_size(p-1)
     enddo

     if(.not. last_grid) pos_s(:) = pos_x(:)

     if(nxgrid1_old > 0) then
        y2m1_size(:) = xmap%your2my1_size(:)
        iarray2 => iarray
        jarray2 => jarray
        allocate(iarray(nxgrid1+nxgrid1_old), jarray(nxgrid1+nxgrid1_old))
        ! copy the i-j index
        do p=0,xmap%npes-1
           do n = 1, xmap%your2my1_size(p)
              iarray(pos_x(p)+n) = iarray2(pos_s(p)+n)
              jarray(pos_x(p)+n) = jarray2(pos_s(p)+n)
           enddo
        enddo    
        deallocate(iarray2, jarray2)        
     else
        allocate(iarray(nxgrid1), jarray(nxgrid1))
        iarray(:) = 0
        jarray(:) = 0
        y2m1_size(:) = 0
     endif

     do l=1,nxgrid1
        p = y2m1_pe(l)
        if(p<0) cycle
        found = .false.
        if(y2m1_size(p) > 0) then
           pos = pos_x(p)+y2m1_size(p)
           if( i1_side1(l) == iarray(pos) .AND. j1_side1(l) == jarray(pos) ) then
              found = .true.
           else
              !---may need to replace with a fast search algorithm
              do n = 1, y2m1_size(p)
                 pos = pos_x(p)+n
                 if(i1_side1(l) == iarray(pos) .AND. j1_side1(l) == jarray(pos)) then
                    found = .true.
                    exit
                 endif
              enddo
           endif
        endif
        if( (.NOT. found) .OR. monotonic_exchange ) then
           y2m1_size(p) = y2m1_size(p)+1
           pos = pos_x(p)+y2m1_size(p)
           iarray(pos) = i1_side1(l)
           jarray(pos) = j1_side1(l)
        endif
     end do
     xmap%your2my1_size(:) =  y2m1_size(:)
     deallocate(y2m1_pe)
     if(last_grid) then
        deallocate(iarray, jarray)
        if(allocated(pos_s)) deallocate(pos_s)
     end if
  end if

  if (grid1%tile_me == tile1 .and. size_repro > 0) then
     ll_repro = grid%size_repro
     grid%size_repro = ll_repro + size_repro
     if(ll_repro > 0) then  ! extend data
        allocate(x_local(ll_repro))
        x_local = grid%x_repro
        if(ASSOCIATED(grid%x_repro)) deallocate(grid%x_repro)
        allocate( grid%x_repro(grid%size_repro ) )
        grid%x_repro(1:ll_repro) = x_local
        deallocate(x_local)
     else
        allocate( grid%x_repro( grid%size_repro ) )
        grid%x_repro%di = 0.0; grid%x_repro%dj = 0.0
     end if
     do l=1,nxgrid1
        if (in_box(i1_side1(l),j1_side1(l), grid1%is_me,grid1%ie_me, grid1%js_me,grid1%je_me) ) then
           ll_repro = ll_repro + 1
           grid%x_repro(ll_repro)%i1   = i1_side1(l); grid%x_repro(ll_repro)%i2   = i2_side1(l)
           grid%x_repro(ll_repro)%j1   = j1_side1(l); grid%x_repro(ll_repro)%j2   = j2_side1(l)
           grid%x_repro(ll_repro)%tile = tile1
           grid%x_repro(ll_repro)%area = area_side1(l)
           if(use_higher_order) then
              grid%x_repro(ll_repro)%di  = di_side1(l)
              grid%x_repro(ll_repro)%dj  = dj_side1(l)
           end if

           do p=0,xmap%npes-1
              if(grid%tile(p) == tile2) then
                 if (in_box(i2_side1(l), j2_side1(l), grid%is(p), grid%ie(p), &
                      grid%js(p), grid%je(p))) then
                    grid%x_repro(ll_repro)%pe = p + xmap%root_pe
                 end if
              end if
           end do
        end if ! make_exchange_reproduce
     end do
  end if

  deallocate(i1, j1, i2, j2, area)
  if(use_higher_order) deallocate(di, dj)
  if(scale_exist) deallocate(scale)
  if(is_distribute) then
     deallocate(i1_side1, j1_side1, i2_side1, j2_side1, area_side1)
     if(use_higher_order) deallocate(di_side1, dj_side1)
  endif  

  i1=>NULL(); j1=>NULL(); i2=>NULL(); j2=>NULL()
  call mpp_clock_end(id_load_xgrid5)



end subroutine load_xgrid

!#######################################################################
!
! get_grid - read the center point of the grid from grid_spec.nc.
!          - only the grid at the side 1 is needed, so we only read 
!          - atm and land grid
!
!

subroutine get_grid(grid, grid_id, grid_file, grid_version)
  type(grid_type), intent(inout) :: grid
  character(len=3), intent(in)   :: grid_id
  character(len=*), intent(in)   :: grid_file
  integer,          intent(in)   :: grid_version

  real, dimension(grid%im) :: lonb
  real, dimension(grid%jm) :: latb
  real, allocatable        :: tmpx(:,:), tmpy(:,:)
  real                     :: d2r
  integer                  :: is, ie, js, je, nlon, nlat, siz(4), i, j
  integer                  :: start(4), nread(4), isc2, iec2, jsc2, jec2

  d2r = PI/180.0

  call mpp_get_compute_domain(grid%domain, is, ie, js, je)

  select case(grid_version)
  case(VERSION1)
     allocate(grid%lon(grid%im), grid%lat(grid%jm))
     if(grid_id == 'ATM') then
        call read_data(grid_file, 'xta', lonb)
        call read_data(grid_file, 'yta', latb)

        if(.not. allocated(AREA_ATM_MODEL)) then
           allocate(AREA_ATM_MODEL(is:ie, js:je))
           call get_area_elements(grid_file, 'AREA_ATM_MODEL', grid%domain, AREA_ATM_MODEL)
        endif
        if(.not. allocated(AREA_ATM_SPHERE)) then
           allocate(AREA_ATM_SPHERE(is:ie, js:je))
           call get_area_elements(grid_file, 'AREA_ATM', grid%domain, AREA_ATM_SPHERE)
        endif
     else if(grid_id == 'LND') then
        call read_data(grid_file, 'xtl', lonb)
        call read_data(grid_file, 'ytl', latb)
        if(.not. allocated(AREA_LND_MODEL)) then
           allocate(AREA_LND_MODEL(is:ie, js:je))
           call get_area_elements(grid_file, 'AREA_LND_MODEL', grid%domain, AREA_LND_MODEL)
        endif
        if(.not. allocated(AREA_LND_SPHERE)) then
           allocate(AREA_LND_SPHERE(is:ie, js:je))
           call get_area_elements(grid_file, 'AREA_LND', grid%domain, AREA_LND_SPHERE)
        endif
     else if(grid_id == 'OCN' ) then
        if(.not. allocated(AREA_OCN_SPHERE)) then
           allocate(AREA_OCN_SPHERE(is:ie, js:je))
           call get_area_elements(grid_file, 'AREA_OCN', grid%domain, AREA_OCN_SPHERE)
        endif
     endif
     !--- second order remapping suppose second order
     if(grid_id == 'LND' .or. grid_id == 'ATM') then
        grid%lon   = lonb * d2r
        grid%lat   = latb * d2r
     endif
     grid%is_latlon = .true.
  case(VERSION2)
     call field_size(grid_file, 'area', siz)
     nlon = siz(1); nlat = siz(2)
     if( mod(nlon,2) .NE. 0) call error_mesg('xgrid_mod',  &
          'flux_exchange_mod: atmos supergrid longitude size can not be divided by 2', FATAL)
     if( mod(nlat,2) .NE. 0) call error_mesg('xgrid_mod',  &
          'flux_exchange_mod: atmos supergrid latitude size can not be divided by 2', FATAL)
     nlon = nlon/2
     nlat = nlat/2
     if(nlon .NE. grid%im .OR. nlat .NE. grid%jm) call error_mesg('xgrid_mod', &
         'grid size in tile_file does not match the global grid size', FATAL)

     if( grid_id == 'LND' .or. grid_id == 'ATM'  .or. grid_id == 'WAV' ) then
        isc2 = 2*grid%is_me-1; iec2 = 2*grid%ie_me+1
        jsc2 = 2*grid%js_me-1; jec2 = 2*grid%je_me+1
        allocate(tmpx(isc2:iec2, jsc2:jec2) )
        allocate(tmpy(isc2:iec2, jsc2:jec2) )   
        start = 1; nread = 1          
        start(1) = isc2; nread(1) = iec2 - isc2 + 1
        start(2) = jsc2; nread(2) = jec2 - jsc2 + 1 
        call read_data(grid_file, 'x', tmpx, start, nread, no_domain=.TRUE.)
        call read_data(grid_file, 'y', tmpy, start, nread, no_domain=.TRUE.)      
        if(is_lat_lon(tmpx, tmpy) ) then
           deallocate(tmpx, tmpy)
           start = 1; nread = 1
           start(2) = 2; nread(1) = nlon*2+1
           allocate(tmpx(nlon*2+1, 1), tmpy(1, nlat*2+1))
           call read_data(grid_file, "x", tmpx, start, nread, no_domain=.TRUE.)    
           allocate(grid%lon(grid%im), grid%lat(grid%jm))
           do i = 1, grid%im
              grid%lon(i) = tmpx(2*i,1) * d2r
           end do
           start = 1; nread = 1
           start(1) = 2; nread(2) = nlat*2+1
           call read_data(grid_file, "y", tmpy, start, nread, no_domain=.TRUE.)    
           do j = 1, grid%jm
              grid%lat(j) = tmpy(1, 2*j) * d2r
           end do
           grid%is_latlon = .true.
        else
           allocate(grid%geolon(grid%isd_me:grid%ied_me, grid%jsd_me:grid%jed_me))
           allocate(grid%geolat(grid%isd_me:grid%ied_me, grid%jsd_me:grid%jed_me))
           grid%geolon = 1e10
           grid%geolat = 1e10
           !--- area_ocn_sphere, area_lnd_sphere, area_atm_sphere is not been defined.
           do j = grid%js_me,grid%je_me
              do i = grid%is_me,grid%ie_me
                 grid%geolon(i, j) = tmpx(i*2,j*2)*d2r
                 grid%geolat(i, j) = tmpy(i*2,j*2)*d2r
              end do
           end do
           call mpp_update_domains(grid%geolon, grid%domain)
           call mpp_update_domains(grid%geolat, grid%domain)
           grid%is_latlon = .false.
        end if
        deallocate(tmpx, tmpy)
     end if     
  end select

  return

end subroutine get_grid
  
!#######################################################################
! Read the area elements from NetCDF file
subroutine get_area_elements(file, name, domain, data)
  character(len=*), intent(in) :: file
  character(len=*), intent(in) :: name
  type(domain2d),   intent(in) :: domain
  real, intent(out)            :: data(:,:)

  if(field_exist(file, name)) then
     call read_data(file, name, data, domain)
  else
     call error_mesg('xgrid_mod', 'no field named '//trim(name)//' in grid file '//trim(file)// &
                     ' Will set data to negative values...', NOTE)
     ! area elements no present in grid_spec file, set to negative values....
     data = -1.0
  endif    

end subroutine get_area_elements

!#######################################################################
! Read the OCN model area elements from NetCDF file
! <SUBROUTINE NAME="get_ocean_model_area_elements">

!   <OVERVIEW>
!      Read Ocean area element data.
!   </OVERVIEW>
!   <DESCRIPTION>
!      If available in the NetCDF file, this routine will read the 
!      AREA_OCN_MODEL field and load the data into global AREA_OCN_MODEL.
!      If not available, then the array AREA_OCN_MODEL will be left
!      unallocated. Must be called by all PEs.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call get_ocean_model_area_elements(ocean_domain, grid_file)
!   </TEMPLATE>

!   <IN NAME="ocean_domain" TYPE="type(Domain2d)"> </IN>
!   <IN NAME="grid_file" TYPE="character(len=*)" > </IN>
subroutine get_ocean_model_area_elements(domain, grid_file)

  type(Domain2d), intent(in) :: domain
  character(len=*), intent(in) :: grid_file
  integer :: is, ie, js, je

  if(allocated(AREA_OCN_MODEL)) return

  call mpp_get_compute_domain(domain, is, ie, js, je)
  ! allocate even if ie<is, ... in which case the array will have zero size
  ! but will still return .T. for allocated(...)
  allocate(AREA_OCN_MODEL(is:ie, js:je))
  if(ie < is .or. je < js ) return


  if(field_exist(grid_file, 'AREA_OCN_MODEL') )then
     call read_data(grid_file, 'AREA_OCN_MODEL', AREA_OCN_MODEL, domain)
  else
     deallocate(AREA_OCN_MODEL)
  endif


end subroutine get_ocean_model_area_elements
! </SUBROUTINE>
!#######################################################################

! <SUBROUTINE NAME="setup_xmap">

!   <OVERVIEW>
!      Sets up exchange grid connectivity using grid specification file and
!      processor domain decomposition. 
!   </OVERVIEW>
!   <DESCRIPTION>
!      Sets up exchange grid connectivity using grid specification file and
!      processor domain decomposition. Initializes xmap.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call setup_xmap(xmap, grid_ids, grid_domains, grid_file, atm_grid)
!   </TEMPLATE>

!   <IN NAME="grid_ids" TYPE="character(len=3)" DIM="(:)"> </IN>
!   <IN NAME="grid_domains" TYPE="type(Domain2d)" DIM="(:)"> </IN>
!   <IN NAME="grid_file" TYPE="character(len=*)" > </IN>
!   <IN NAME="atmos_grid" TYPE="type(grid_box_type),optional" > </IN>
!   <OUT NAME="xmap" TYPE="xmap_type"  > </OUT>

subroutine setup_xmap(xmap, grid_ids, grid_domains, grid_file, atm_grid)
  type (xmap_type),                        intent(inout) :: xmap
  character(len=3), dimension(:),            intent(in ) :: grid_ids
  type(Domain2d), dimension(:),              intent(in ) :: grid_domains
  character(len=*),                          intent(in ) :: grid_file
  type(grid_box_type), optional,             intent(in ) :: atm_grid

  integer :: g,     p, send_size, recv_size, i, siz(4)
  integer :: unit, nxgrid_file, i1, i2, i3, tile1, tile2, j
  integer :: nxc, nyc, out_unit
  type (grid_type), pointer, save :: grid =>NULL(), grid1 =>NULL()
  real, dimension(3) :: xxx
  real, dimension(:,:), allocatable   :: check_data
  real, dimension(:,:,:), allocatable :: check_data_3D
  character(len=256)                  :: xgrid_file, xgrid_name
  character(len=256)                  :: tile_file, mosaic_file
  character(len=256)                  :: mosaic1, mosaic2, contact
  character(len=256)                  :: tile1_name, tile2_name
  character(len=256),     allocatable :: tile1_list(:), tile2_list(:)
  integer                             :: npes, npes2
  integer,                allocatable :: pelist(:)
  type(domain2d), save                :: domain2
  logical :: use_higher_order = .false.

  call mpp_clock_begin(id_setup_xmap)

  if(interp_method .ne. 'first_order')  use_higher_order = .true.

  out_unit = stdout()
  xmap%me   = mpp_pe  ()
  xmap%npes = mpp_npes()
  xmap%root_pe = mpp_root_pe()

  allocate( xmap%grids(1:size(grid_ids(:))) )

  allocate ( xmap%your1my2(0:xmap%npes-1), xmap%your2my1(0:xmap%npes-1) )
  allocate ( xmap%your2my1_size(0:xmap%npes-1) )

  xmap%your1my2 = .false.; xmap%your2my1 = .false.;
  xmap%your2my1_size = 0

!  check the exchange grid file version to be used by checking the field in the file
  if(field_exist(grid_file, "AREA_ATMxOCN" ) ) then
     xmap%version = VERSION1
  else if(field_exist(grid_file, "ocn_mosaic_file" ) ) then
     xmap%version = VERSION2
  else
     call error_mesg('xgrid_mod', 'both AREA_ATMxOCN and ocn_mosaic_file does not exist in '//trim(grid_file), FATAL)
  end if

  if(xmap%version==VERSION1) then
     call error_mesg('xgrid_mod', 'reading exchange grid information from grid spec file', NOTE)
  else
     call error_mesg('xgrid_mod', 'reading exchange grid information from mosaic grid file', NOTE)
  end if

  call mpp_clock_begin(id_load_xgrid)
  do g=1,size(grid_ids(:))
     grid => xmap%grids(g)
     if (g==1) grid1 => xmap%grids(g)
     grid%id     = grid_ids    (g)
     grid%domain = grid_domains(g)
     grid%on_this_pe = mpp_domain_is_initialized(grid_domains(g))
     allocate ( grid%is(0:xmap%npes-1), grid%ie(0:xmap%npes-1) )
     allocate ( grid%js(0:xmap%npes-1), grid%je(0:xmap%npes-1) )
     allocate ( grid%tile(0:xmap%npes-1) )
     grid%npes   = 0
     grid%ni = 0
     grid%nj = 0
     grid%is = 0
     grid%ie = -1
     grid%js = 0
     grid%je = -1
     grid%tile = -1

     select case(xmap%version)
     case(VERSION1)
        grid%ntile = 1
     case(VERSION2)
        call read_data(grid_file, lowercase(grid_ids(g))//'_mosaic_file', mosaic_file)
        grid%ntile = get_mosaic_ntiles('INPUT/'//trim(mosaic_file))
     end select

     if( g == 1 .AND. grid_ids(1) == 'ATM' ) then 
        if( .NOT. grid%on_this_pe ) call error_mesg('xgrid_mod', 'ATM domain is not defined on some processor' ,FATAL)
     endif
     grid%npes =  mpp_get_domain_npes(grid%domain)
     if( xmap%npes > grid%npes .AND. g == 1 .AND. grid_ids(1) == 'ATM' ) then
        call mpp_broadcast_domain(grid%domain, domain2)
     else if(xmap%npes > grid%npes) then
        call mpp_broadcast_domain(grid%domain)
        grid%npes =  mpp_get_domain_npes(grid%domain)
     endif

     npes = grid%npes
     allocate(grid%pelist(0:npes-1))
     call mpp_get_domain_pelist(grid%domain, grid%pelist)
     grid%root_pe = mpp_get_domain_root_pe(grid%domain)

     call mpp_get_data_domain(grid%domain, grid%isd_me, grid%ied_me, grid%jsd_me, grid%jed_me, &
                              xsize=grid%nxd_me, ysize=grid%nyd_me)
     call mpp_get_global_domain(grid%domain, xsize=grid%ni, ysize=grid%nj)

     if( grid%root_pe == xmap%root_pe ) then
        call mpp_get_compute_domains(grid%domain,  xbegin=grid%is(0:npes-1), xend=grid%ie(0:npes-1), &
                                     ybegin=grid%js(0:npes-1), yend=grid%je(0:npes-1) )
        call mpp_get_tile_list(grid%domain, grid%tile(0:npes-1))
        if( xmap%npes > npes .AND. g == 1 .AND. grid_ids(1) == 'ATM' ) then
           call mpp_get_compute_domains(domain2, xbegin=grid%is(npes:xmap%npes-1), xend=grid%ie(npes:xmap%npes-1), &
                                        ybegin=grid%js(npes:xmap%npes-1), yend=grid%je(npes:xmap%npes-1) )
           call mpp_get_tile_list(domain2, grid%tile(npes:xmap%npes-1))
        endif
     else
        npes2 = xmap%npes-npes
        call mpp_get_compute_domains(domain2,  xbegin=grid%is(0:npes2-1), xend=grid%ie(0:npes2-1), &
                                     ybegin=grid%js(0:npes2-1), yend=grid%je(0:npes2-1) )
        call mpp_get_compute_domains(grid%domain, xbegin=grid%is(npes2:xmap%npes-1), xend=grid%ie(npes2:xmap%npes-1), &
                                     ybegin=grid%js(npes2:xmap%npes-1), yend=grid%je(npes2:xmap%npes-1) )
        call mpp_get_tile_list(domain2, grid%tile(0:npes2-1))
        call mpp_get_tile_list(grid%domain, grid%tile(npes2:xmap%npes-1))
     endif
     if( xmap%npes > grid%npes .AND. g == 1 .AND. grid_ids(1) == 'ATM' ) then
        call mpp_deallocate_domain(domain2)
     endif
     npes = grid%npes
     if(  g == 1 .AND. grid_ids(1) == 'ATM' ) npes = xmap%npes
     do p = 0, npes-1
        if(grid%tile(p) > grid%ntile .or. grid%tile(p) < 1) call error_mesg('xgrid_mod', &
                 'tile id should between 1 and ntile', FATAL)
     end do

     grid%im = grid%ni
     grid%jm = grid%nj
     call mpp_max(grid%ni)
     call mpp_max(grid%nj)
    
     grid%is_me => grid%is(xmap%me-xmap%root_pe); grid%ie_me => grid%ie(xmap%me-xmap%root_pe)
     grid%js_me => grid%js(xmap%me-xmap%root_pe); grid%je_me => grid%je(xmap%me-xmap%root_pe)
     grid%nxc_me = grid%ie_me - grid%is_me + 1
     grid%nyc_me = grid%je_me - grid%js_me + 1
     grid%tile_me => grid%tile(xmap%me-xmap%root_pe)

     grid%km = 1

     if( grid%on_this_pe ) then
        allocate( grid%area    (grid%is_me:grid%ie_me, grid%js_me:grid%je_me) )
        allocate( grid%area_inv(grid%is_me:grid%ie_me, grid%js_me:grid%je_me) )
        grid%area       = 0.0
        grid%size       = 0
        grid%size_repro = 0
     endif
    
     ! get the center point of the grid box
     select case(xmap%version)
     case(VERSION1)
        if( grid%npes .NE. xmap%npes ) then
           call error_mesg('xgrid_mod', ' grid%npes .NE. xmap%npes ', FATAL)
        endif
        call get_grid(grid, grid_ids(g), grid_file, xmap%version)
     case(VERSION2)
        allocate(pelist(0:xmap%npes-1))
        call mpp_get_current_pelist(pelist)
        if( grid%on_this_pe ) then
           call mpp_set_current_pelist(grid%pelist)
           call get_mosaic_tile_grid(tile_file, 'INPUT/'//trim(mosaic_file), grid%domain)
           call get_grid(grid, grid_ids(g), tile_file, xmap%version)
        endif
        call mpp_set_current_pelist(pelist)
        deallocate(pelist) 
        ! read the contact information from mosaic_file to check if atmosphere is nested model
        if( g == 1 .AND. grid_ids(1) == 'ATM' ) then
           nnest = get_nest_contact('INPUT/'//trim(mosaic_file), tile_nest, tile_parent, is_nest, &
                ie_nest, js_nest, je_nest, is_parent, ie_parent, js_parent, je_parent)         
        endif       
     end select

     if( use_higher_order .AND. grid%id == 'ATM') then
        if( nnest > 0 ) call error_mesg('xgrid_mod', 'second_order is not supported for nested coupler', FATAL)
        if( grid%is_latlon ) then
           call mpp_modify_domain(grid%domain, grid%domain_with_halo, whalo=1, ehalo=1, shalo=1, nhalo=1)
           call mpp_get_data_domain(grid%domain_with_halo, grid%isd_me, grid%ied_me, grid%jsd_me, grid%jed_me, &
                              xsize=grid%nxd_me, ysize=grid%nyd_me) 
        else
           if(.NOT. present(atm_grid)) call error_mesg('xgrid_mod', 'when first grid is "ATM", atm_grid should be present', FATAL)
           if(grid%is_me-grid%isd_me .NE. 1 .or. grid%ied_me-grid%ie_me .NE. 1 .or.               &
              grid%js_me-grid%jsd_me .NE. 1 .or. grid%jed_me-grid%je_me .NE. 1 ) call error_mesg( &
              'xgrid_mod', 'for non-latlon grid (cubic grid), the halo size should be 1 in all four direction', FATAL)
           if(.NOT.( ASSOCIATED(atm_grid%dx) .AND. ASSOCIATED(atm_grid%dy) .AND. ASSOCIATED(atm_grid%edge_w) .AND.    &
                ASSOCIATED(atm_grid%edge_e) .AND. ASSOCIATED(atm_grid%edge_s) .AND. ASSOCIATED(atm_grid%edge_n) .AND. &
                ASSOCIATED(atm_grid%en1) .AND. ASSOCIATED(atm_grid%en2) .AND. ASSOCIATED(atm_grid%vlon) .AND.         &
                ASSOCIATED(atm_grid%vlat) ) )  call error_mesg( &
            'xgrid_mod', 'for non-latlon grid (cubic grid), all the fields in atm_grid data type should be allocated', FATAL)
           nxc = grid%ie_me  - grid%is_me  + 1
           nyc = grid%je_me  - grid%js_me  + 1
           if(size(atm_grid%dx,1) .NE. nxc .OR. size(atm_grid%dx,2) .NE. nyc+1)               &
                call error_mesg('xgrid_mod', 'incorrect dimension size of atm_grid%dx', FATAL)
           if(size(atm_grid%dy,1) .NE. nxc+1 .OR. size(atm_grid%dy,2) .NE. nyc)               &
                call error_mesg('xgrid_mod', 'incorrect dimension sizeof atm_grid%dy', FATAL)
           if(size(atm_grid%area,1) .NE. nxc .OR. size(atm_grid%area,2) .NE. nyc)             &
                call error_mesg('xgrid_mod', 'incorrect dimension size of atm_grid%area', FATAL)
           if(size(atm_grid%edge_w(:)) .NE. nyc+1 .OR. size(atm_grid%edge_e(:)) .NE. nyc+1)    &
                call error_mesg('xgrid_mod', 'incorrect dimension size of atm_grid%edge_w/edge_e', FATAL)
           if(size(atm_grid%edge_s(:)) .NE. nxc+1 .OR. size(atm_grid%edge_n(:)) .NE. nxc+1)    &
                call error_mesg('xgrid_mod', 'incorrect dimension size of atm_grid%edge_s/edge_n', FATAL)
           if(size(atm_grid%en1,1) .NE. 3 .OR. size(atm_grid%en1,2) .NE. nxc .OR. size(atm_grid%en1,3) .NE. nyc+1) & 
                call error_mesg( 'xgrid_mod', 'incorrect dimension size of atm_grid%en1', FATAL)
           if(size(atm_grid%en2,1) .NE. 3 .OR. size(atm_grid%en2,2) .NE. nxc+1 .OR. size(atm_grid%en2,3) .NE. nyc) &
                call error_mesg( 'xgrid_mod', 'incorrect dimension size of atm_grid%en2', FATAL)
           if(size(atm_grid%vlon,1) .NE. 3 .OR. size(atm_grid%vlon,2) .NE. nxc .OR. size(atm_grid%vlon,3) .NE. nyc)   &
                call error_mesg('xgrid_mod', 'incorrect dimension size of atm_grid%vlon', FATAL)
           if(size(atm_grid%vlat,1) .NE. 3 .OR. size(atm_grid%vlat,2) .NE. nxc .OR. size(atm_grid%vlat,3) .NE. nyc)   &
                call error_mesg('xgrid_mod', 'incorrect dimension size of atm_grid%vlat', FATAL)
           allocate(grid%box%dx    (grid%is_me:grid%ie_me,   grid%js_me:grid%je_me+1 ))
           allocate(grid%box%dy    (grid%is_me:grid%ie_me+1, grid%js_me:grid%je_me   ))
           allocate(grid%box%area  (grid%is_me:grid%ie_me,   grid%js_me:grid%je_me   ))
           allocate(grid%box%edge_w(grid%js_me:grid%je_me+1))
           allocate(grid%box%edge_e(grid%js_me:grid%je_me+1))
           allocate(grid%box%edge_s(grid%is_me:grid%ie_me+1))
           allocate(grid%box%edge_n(grid%is_me:grid%ie_me+1))
           allocate(grid%box%en1   (3, grid%is_me:grid%ie_me,   grid%js_me:grid%je_me+1 ))
           allocate(grid%box%en2   (3, grid%is_me:grid%ie_me+1, grid%js_me:grid%je_me   ))
           allocate(grid%box%vlon  (3, grid%is_me:grid%ie_me,   grid%js_me:grid%je_me   ))
           allocate(grid%box%vlat  (3, grid%is_me:grid%ie_me,   grid%js_me:grid%je_me   ))
           grid%box%dx     = atm_grid%dx
           grid%box%dy     = atm_grid%dy
           grid%box%area   = atm_grid%area
           grid%box%edge_w = atm_grid%edge_w
           grid%box%edge_e = atm_grid%edge_e
           grid%box%edge_s = atm_grid%edge_s
           grid%box%edge_n = atm_grid%edge_n
           grid%box%en1    = atm_grid%en1
           grid%box%en2    = atm_grid%en2
           grid%box%vlon   = atm_grid%vlon
           grid%box%vlat   = atm_grid%vlat
        end if
     end if

     if (g>1) then
        if(grid%on_this_pe) then
           allocate( grid%frac_area(grid%is_me:grid%ie_me, grid%js_me:grid%je_me, grid%km) )
           grid%frac_area = 1.0
        endif

        ! load exchange cells, sum grid cell areas, set your1my2/your2my1
        select case(xmap%version)
        case(VERSION1)
           call load_xgrid (xmap, grid, grid_file, grid_ids(1), grid_ids(g), 1, 1, use_higher_order)
        case(VERSION2)
           select case(grid_ids(1))
           case( 'ATM' )
              xgrid_name = 'a'
           case( 'LND' )
              xgrid_name = 'l'
           case( 'WAV' )
              xgrid_name = 'w'
           case default 
              call error_mesg('xgrid_mod', 'grid_ids(1) should be ATM, LND or WAV', FATAL)
           end select
           select case(grid_ids(g))
           case( 'LND' )
              xgrid_name = trim(xgrid_name)//'Xl_file'
           case( 'OCN' )
              xgrid_name = trim(xgrid_name)//'Xo_file'
           case( 'WAV' )
              xgrid_name = trim(xgrid_name)//'Xw_file'
           case default 
              call error_mesg('xgrid_mod', 'grid_ids(g) should be LND, OCN or WAV', FATAL)
           end select       
           ! get the tile list for each mosaic
           call read_data(grid_file, lowercase(grid_ids(1))//'_mosaic_file', mosaic1) 
           call read_data(grid_file, lowercase(grid_ids(g))//'_mosaic_file', mosaic2) 
           mosaic1 = 'INPUT/'//trim(mosaic1)
           mosaic2 = 'INPUT/'//trim(mosaic2)
           allocate(tile1_list(grid1%ntile), tile2_list(grid%ntile) )
           do j = 1, grid1%ntile
              call read_data(mosaic1, 'gridtiles', tile1_list(j), level=j)
           end do
           do j = 1, grid%ntile
              call read_data(mosaic2, 'gridtiles', tile2_list(j), level=j)
           end do
           if(field_exist(grid_file, xgrid_name)) then
              call field_size(grid_file, xgrid_name, siz)
              nxgrid_file = siz(2)
              ! loop through all the exchange grid file
              do i = 1, nxgrid_file
                 call read_data(grid_file, xgrid_name, xgrid_file, level = i)
                 xgrid_file = 'INPUT/'//trim(xgrid_file) 
                 if( .NOT. file_exist(xgrid_file) )call error_mesg('xgrid_mod', &
                      'file '//trim(xgrid_file)//' does not exist, check your xgrid file.', FATAL)

                 ! find the tile number of side 1 and side 2 mosaic, which is contained in field contact
                 call read_data(xgrid_file, "contact", contact)
                 i1 = index(contact, ":")
                 i2 = index(contact, "::")
                 i3 = index(contact, ":", back=.true. )
                 if(i1 == 0 .OR. i2 == 0) call error_mesg('xgrid_mod', &
                      'field contact in file '//trim(xgrid_file)//' should contains ":" and "::" ', FATAL)
                 if(i1 == i3) call error_mesg('xgrid_mod', &
                      'field contact in file '//trim(xgrid_file)//' should contains two ":"', FATAL)
                 tile1_name = contact(i1+1:i2-1)
                 tile2_name = contact(i3+1:len_trim(contact))
                 tile1 = 0; tile2 = 0
                 do j = 1, grid1%ntile
                    if( tile1_name == tile1_list(j) ) then
                       tile1 = j
                       exit
                    end if
                 end do
                 do j = 1, grid%ntile
                    if( tile2_name == tile2_list(j) ) then
                       tile2 = j
                       exit
                    end if
                 end do
                 if(tile1 == 0) call error_mesg('xgrid_mod', &
                      trim(tile1_name)//' is not a tile of mosaic '//trim(mosaic1), FATAL)
                 if(tile2 == 0) call error_mesg('xgrid_mod', &
                      trim(tile2_name)//' is not a tile of mosaic '//trim(mosaic2), FATAL)

                 call load_xgrid (xmap, grid, xgrid_file, grid_ids(1), grid_ids(g), tile1, tile2, &
                                  use_higher_order)
              end do
           endif
           deallocate(tile1_list, tile2_list)
        end select
        if(grid%on_this_pe) then
           grid%area_inv = 0.0;
           where (grid%area>0.0) grid%area_inv = 1.0/grid%area
        endif
     end if
  end do

  call mpp_clock_end(id_load_xgrid)

  grid1%area_inv = 0.0;
  where (grid1%area>0.0)
     grid1%area_inv = 1.0/grid1%area
  end where

  xmap%your1my2(xmap%me-xmap%root_pe) = .false. ! this is not necessarily true but keeps
  xmap%your2my1(xmap%me-xmap%root_pe) = .false. ! a PE from communicating with itself

  if (make_exchange_reproduce) then
     allocate( xmap%send_count_repro(0:xmap%npes-1) )
     allocate( xmap%recv_count_repro(0:xmap%npes-1) )
     xmap%send_count_repro = 0
     xmap%recv_count_repro = 0
     do g=2,size(xmap%grids(:))
        do p=0,xmap%npes-1
           if(xmap%grids(g)%size >0) &
                xmap%send_count_repro(p) = xmap%send_count_repro(p) &
                +count(xmap%grids(g)%x      (:)%pe==p+xmap%root_pe)
           if(xmap%grids(g)%size_repro >0) &
                xmap%recv_count_repro(p) = xmap%recv_count_repro(p) &
                +count(xmap%grids(g)%x_repro(:)%pe==p+xmap%root_pe)
        end do
     end do
     xmap%send_count_repro_tot = sum(xmap%send_count_repro)
     xmap%recv_count_repro_tot = sum(xmap%recv_count_repro)
  else
     xmap%send_count_repro_tot = 0
     xmap%recv_count_repro_tot = 0
  end if

  if (xgrid_log) then
    call mpp_open( unit, 'xgrid.out', action=MPP_OVERWR, threading=MPP_MULTI, &
         fileset=MPP_MULTI, nohdrs=.TRUE. )  

    write( unit,* )xmap%grids(:)%id, ' GRID: PE ', xmap%me, ' #XCELLS=', &
       xmap%grids(2:size(xmap%grids(:)))%size, ' #COMM. PARTNERS=', &
       count(xmap%your1my2), '/', count(xmap%your2my1), &
       pack((/(p+xmap%root_pe,p=0,xmap%npes-1)/), xmap%your1my2),  &
       '/', pack((/(p+xmap%root_pe,p=0,xmap%npes-1)/), xmap%your2my1)
    call close_file (unit)
  endif

  allocate( xmap%x1(1:sum(xmap%grids(2:size(xmap%grids(:)))%size)) )
  allocate( xmap%x2(1:sum(xmap%grids(2:size(xmap%grids(:)))%size)) )
  allocate( xmap%x1_put(1:sum(xmap%grids(2:size(xmap%grids(:)))%size)) )
  allocate( xmap%x2_get(1:sum(xmap%grids(2:size(xmap%grids(:)))%size)) )

  !--- The following will setup indx to be used in regen
  allocate(xmap%get1, xmap%put1)
  call mpp_clock_begin(id_set_comm)

  call set_comm_get1(xmap)

  call set_comm_put1(xmap)

  if(make_exchange_reproduce) then
    allocate(xmap%get1_repro)
    call set_comm_get1_repro(xmap)
  endif

  call mpp_clock_end(id_set_comm)

  call mpp_clock_begin(id_regen)
  call regen(xmap)
  call mpp_clock_end(id_regen)

  call mpp_clock_begin(id_conservation_check)

  xxx = conservation_check(grid1%area*0.0+1.0, grid1%id, xmap)
  write(out_unit,* )"Checked data is array of constant 1"
  write(out_unit,* )grid1%id,'(',xmap%grids(:)%id,')=', xxx 

  do g=2,size(xmap%grids(:))
     xxx = conservation_check(xmap%grids(g)%frac_area*0.0+1.0, xmap%grids(g)%id, xmap )
     write( out_unit,* )xmap%grids(g)%id,'(',xmap%grids(:)%id,')=', xxx 
  enddo
  ! create an random number 2d array
  if(grid1%id == "ATM") then
     allocate(check_data(size(grid1%area,1), size(grid1%area,2)))
     call random_number(check_data)

     !--- second order along both zonal and meridinal direction
     xxx = conservation_check(check_data, grid1%id, xmap,  remap_method = remapping_method )
     write( out_unit,* ) &
          "Checked data is array of random number between 0 and 1 using "//trim(interp_method)
     write( out_unit,* )grid1%id,'(',xmap%grids(:)%id,')=', xxx 

     deallocate(check_data)
     do g=2,size(xmap%grids(:))
        allocate(check_data_3d(size(xmap%grids(g)%frac_area,1),size(xmap%grids(g)%frac_area,2), &
             size(xmap%grids(g)%frac_area,3) )) 
        call random_number(check_data_3d)
        xxx = conservation_check(check_data_3d, xmap%grids(g)%id, xmap,  remap_method = remapping_method )
        write( out_unit,* )xmap%grids(g)%id,'(',xmap%grids(:)%id,')=', xxx
        deallocate( check_data_3d)
     end do
  endif
  call mpp_clock_end(id_conservation_check)

  call mpp_clock_end(id_setup_xmap)

end subroutine setup_xmap
! </SUBROUTINE>

!----------------------------------------------------------------------------
! currently we are assuming there is only one nest region
function get_nest_contact(mosaic_file, tile_nest_out, tile_parent_out, is_nest_out, &
                          ie_nest_out, js_nest_out, je_nest_out, is_parent_out, &
                          ie_parent_out, js_parent_out, je_parent_out)
character(len=*), intent(in) :: mosaic_file
integer,         intent(out) :: tile_nest_out, tile_parent_out
integer,         intent(out) :: is_nest_out, ie_nest_out
integer,         intent(out) :: js_nest_out, je_nest_out
integer,         intent(out) :: is_parent_out, ie_parent_out
integer,         intent(out) :: js_parent_out, je_parent_out
integer                      :: get_nest_contact
!--- local variables
integer                            :: ntiles, ncontacts, n, t1, t2
integer                            :: nx1_contact, ny1_contact
integer                            :: nx2_contact, ny2_contact
integer, allocatable, dimension(:) :: nx, ny
integer, allocatable, dimension(:) :: tile1, tile2
integer, allocatable, dimension(:) :: istart1, iend1, jstart1, jend1
integer, allocatable, dimension(:) :: istart2, iend2, jstart2, jend2

  tile_nest_out = 0; tile_parent_out = 0
  is_nest_out   = 0; ie_nest_out     = 0
  js_nest_out   = 0; je_nest_out     = 0
  is_parent_out = 0; ie_parent_out   = 0
  js_parent_out = 0; je_parent_out   = 0
  get_nest_contact = 0

  ! first read the contact information
  ntiles = get_mosaic_ntiles(mosaic_file)
  if( ntiles == 1 ) return
  allocate(nx(ntiles), ny(ntiles))  
  call get_mosaic_grid_sizes(mosaic_file, nx, ny)

  ncontacts = get_mosaic_ncontacts(mosaic_file)
  if(ncontacts == 0) return
  allocate(tile1(ncontacts), tile2(ncontacts))
  allocate(istart1(ncontacts), iend1(ncontacts))
  allocate(jstart1(ncontacts), jend1(ncontacts))
  allocate(istart2(ncontacts), iend2(ncontacts))
  allocate(jstart2(ncontacts), jend2(ncontacts))

  call get_mosaic_contact( mosaic_file, tile1, tile2, istart1, iend1, jstart1, jend1, &
                           istart2, iend2, jstart2, jend2)

  do n = 1, ncontacts
    if( tile1(n) == tile2(n) ) cycle ! same tile could not be nested 

    nx1_contact = iend1(n)-istart1(n)+1
    ny1_contact = jend1(n)-jstart1(n)+1
    nx2_contact = iend2(n)-istart2(n)+1
    ny2_contact = jend2(n)-jstart2(n)+1
    t1 = tile1(n);
    t2 = tile2(n);
    ! For nesting, the contact index of one tile must match its global domain 
    if( (nx(t1) .NE. nx1_contact .OR. ny(t1) .NE. ny1_contact ) .AND. &
        (nx(t2) .NE. nx2_contact .OR. ny(t2) .NE. ny2_contact ) ) cycle
    if(nx1_contact == nx2_contact .AND. ny1_contact == ny2_contact) then
      call error_mesg('xgrid_mod', 'There is no refinement for the overlapping region', FATAL)
    endif

    get_nest_contact = get_nest_contact + 1
    if(get_nest_contact>1) then
       call error_mesg('xgrid_mod', 'only support one nest region, contact developer' ,FATAL)
    endif
    if(nx2_contact*ny2_contact > nx1_contact*ny1_contact) then
      is_nest_out     = istart2(n);
      ie_nest_out     = iend2  (n);
      js_nest_out     = jstart2(n);
      je_nest_out     = jend2  (n);
      tile_nest_out   = tile2  (n);
      is_parent_out   = istart1(n);
      ie_parent_out   = iend1  (n);
      js_parent_out   = jstart1(n);
      je_parent_out   = jend1  (n);
      tile_parent_out = tile1  (n);
    else 
      is_nest_out     = istart1(n);
      ie_nest_out     = iend1  (n);
      js_nest_out     = jstart1(n);
      je_nest_out     = jend1  (n);
      tile_nest_out   = tile1  (n);
      is_parent_out   = istart2(n);
      ie_parent_out   = iend2  (n);
      js_parent_out   = jstart2(n);
      je_parent_out   = jend2  (n);
      tile_parent_out = tile2  (n);
    endif
  enddo

  deallocate(nx, ny, tile1, tile2)
  deallocate(istart1, iend1, jstart1, jend1)
  deallocate(istart2, iend2, jstart2, jend2)


  return
  
end function get_nest_contact

!#######################################################################
subroutine set_comm_get1_repro(xmap)
  type (xmap_type), intent(inout) :: xmap
  integer, dimension(xmap%npes) :: pe_ind, cnt
  integer, dimension(0:xmap%npes-1) :: send_ind, recv_ind, pl
  integer :: npes, nsend, nrecv, mypos
  integer :: m, p, pos, n, g, l
  type(comm_type), pointer, save :: comm => NULL()

  comm => xmap%get1_repro
  npes = xmap%npes

  nrecv = 0
  mypos = mpp_pe() - mpp_root_pe()
  do m=0,npes-1 
    p = mod(mypos+npes-m, npes)
    if( xmap%recv_count_repro(p) > 0 ) then
      nrecv = nrecv + 1
      pe_ind(nrecv) = p
    endif
  enddo

  comm%nrecv = nrecv
  if( nrecv > 0 ) then
    allocate(comm%recv(nrecv))
    pos = 0
    do n = 1, nrecv
      p = pe_ind(n)
      comm%recv(n)%count = xmap%recv_count_repro(p)
      comm%recv(n)%pe = p + xmap%root_pe
      comm%recv(n)%buffer_pos = pos 
      pos = pos + comm%recv(n)%count
    enddo
  endif


  ! send information
  nsend = 0
  mypos = mpp_pe() - mpp_root_pe()
  do m=0,xmap%npes-1 
    p = mod(mypos+m, npes)
    if( xmap%send_count_repro(p) > 0 ) then
      nsend = nsend + 1
      pe_ind(nsend) = p
      send_ind(p) = nsend
    endif
  enddo

  comm%nsend = nsend
  if( nsend > 0 ) then
     allocate(comm%send(nsend))
     pos = 0
     cnt(:) = 0
     do n = 1, nsend
        p = pe_ind(n)
        comm%send(n)%count = xmap%send_count_repro(p)
        comm%send(n)%pe = p + xmap%root_pe 
        comm%send(n)%buffer_pos = pos
        pos = pos + comm%send(n)%count
        allocate(comm%send(n)%i(comm%send(n)%count))
        allocate(comm%send(n)%j(comm%send(n)%count))
        allocate(comm%send(n)%g(comm%send(n)%count))
        allocate(comm%send(n)%xLoc(comm%send(n)%count))
     enddo

     do g=2,size(xmap%grids(:))
        do l=1,xmap%grids(g)%size ! index into this side 2 grid's patterns
           p = xmap%grids(g)%x(l)%pe-xmap%root_pe 
           n = send_ind(p)
           cnt(n) = cnt(n) + 1
           pos = cnt(n)
           comm%send(n)%i(pos) = xmap%grids(g)%x(l)%i2
           comm%send(n)%j(pos) = xmap%grids(g)%x(l)%j2
           comm%send(n)%g(pos) = g
        enddo
     enddo
     !--- make sure the count is correct
     do n = 1, nsend
        if( comm%send(n)%count .NE. cnt(n) ) call error_mesg('xgrid_mod', &
             'comm%send(n)%count .NE. cnt(n)', FATAL)
     enddo
   endif

   !--- set up the recv_pos for unpack the data.
   pl(:) = 1
   do g=2,size(xmap%grids(:))
      do l=1,xmap%grids(g)%size_repro ! index into side1 grid's patterns
         p = xmap%grids(g)%x_repro(l)%pe-xmap%root_pe
         xmap%grids(g)%x_repro(l)%recv_pos = pl(p)
         pl(p) = pl(p) + 1
      end do
   end do



end subroutine set_comm_get1_repro

!#######################################################################
subroutine set_comm_get1(xmap)
  type (xmap_type), intent(inout) :: xmap
  type (grid_type), pointer, save :: grid1 =>NULL()
  integer, allocatable :: send_size(:)
  integer, allocatable :: recv_size(:)
  integer              :: max_size, g, npes, l, ll, nset, m
  integer              :: i1, j1, tile1, p, n, pos, buffer_pos, mypos
  integer              :: nsend, nrecv, rbuf_size, sbuf_size, msgsize
  logical              :: found
  real,    allocatable :: recv_buf(:), send_buf(:)
  real,    allocatable :: diarray(:), djarray(:)
  integer, allocatable :: iarray(:), jarray(:), tarray(:)
  integer, allocatable :: pos_x(:), pelist(:), size_pe(:), pe_side1(:)
  integer              :: recv_buffer_pos(0:xmap%npes)
  integer              :: send_buffer_pos(0:xmap%npes)
  type(comm_type), pointer, save :: comm => NULL()

  max_size = 0
  do g=2,size(xmap%grids(:))
    max_size = max_size + xmap%grids(g)%size
  enddo
  comm => xmap%get1
  grid1 => xmap%grids(1)
  comm%nsend = 0
  comm%nrecv = 0
  npes = xmap%npes

  allocate(pelist(0:npes-1))
  call mpp_get_current_pelist(pelist)
  allocate(send_size(0:npes-1))
  allocate(recv_size(0:npes-1))
  allocate(size_pe(0:npes-1))
  allocate(pos_x(0:npes-1))
  size_pe = 0
  send_size = 0
  recv_size = 0

  if(max_size > 0) then
     allocate(pe_side1(max_size))
     allocate(xmap%ind_get1(max_size))

     !--- find the recv_indx
     ll = 0 
     do g=2,size(xmap%grids(:))
        do l=1,xmap%grids(g)%size
           i1 = xmap%grids(g)%x(l)%i1
           j1 = xmap%grids(g)%x(l)%j1
           tile1 = xmap%grids(g)%x(l)%tile
           do p=0,npes-1
              if(grid1%tile(p) == tile1) then
                 if(in_box(i1, j1, grid1%is(p), grid1%ie(p), grid1%js(p), grid1%je(p))) then
                    size_pe(p) = size_pe(p) + 1     
                    exit
                 endif
              endif
           enddo
           if( p == npes ) then
              call error_mesg('xgrid_mod', 'tile is not in grid1%tile(:)', FATAL)
           endif
           ll = ll + 1
           pe_side1(ll) = p
        enddo
     enddo

     pos_x = 0
     do p = 1, npes-1
        pos_x(p) = pos_x(p-1) + size_pe(p-1)
     enddo

     !---find the send size for get_1_from_xgrid
     allocate(iarray(max_size))
     allocate(jarray(max_size))
     allocate(tarray(max_size))
     if(monotonic_exchange) then
        allocate(diarray(max_size))
        allocate(djarray(max_size))        
     endif

     ll = 0

     do g=2,size(xmap%grids(:))
        do l=1,xmap%grids(g)%size
           i1 = xmap%grids(g)%x(l)%i1
           j1 = xmap%grids(g)%x(l)%j1
           tile1 = xmap%grids(g)%x(l)%tile
           ll = ll + 1
           p = pe_side1(ll)

           found = .false.
           if(send_size(p) > 0) then
              if( i1 == iarray(pos_x(p)+send_size(p)) .AND. j1 == jarray(pos_x(p)+send_size(p)) &
                   .AND. tile1 == tarray(pos_x(p)+send_size(p))) then
                 found = .true.
                 n = send_size(p)
              else
                 !---may need to replace with a fast search algorithm
                 do n = 1, send_size(p)
                    if(i1 == iarray(pos_x(p)+n) .AND. j1 == jarray(pos_x(p)+n) .AND. tile1 == tarray(pos_x(p)+n)) then
                       found = .true.
                       exit
                    endif
                 enddo
              endif
           endif
           if( (.NOT. found) .OR. monotonic_exchange ) then
              send_size(p) = send_size(p)+1
              pos = pos_x(p)+send_size(p)
              iarray(pos) = i1
              jarray(pos) = j1
              tarray(pos) = tile1
              if(monotonic_exchange) then
                 diarray(pos) = xmap%grids(g)%x(l)%di
                 djarray(pos) = xmap%grids(g)%x(l)%dj
              endif
              n = send_size(p)
           endif
           xmap%ind_get1(ll) = n
        enddo
     enddo

     pos_x = 0
     do p = 1, npes-1
        pos_x(p) = pos_x(p-1) + send_size(p-1)
     enddo

     ll = 0
     do g=2,size(xmap%grids(:))
        do l=1,xmap%grids(g)%size
           ll = ll + 1
           p = pe_side1(ll)  
           xmap%ind_get1(ll) = pos_x(p) + xmap%ind_get1(ll)
        enddo
     enddo
  endif

  mypos = mpp_pe()-mpp_root_pe()
 
  ! send/recv for get_1_from_xgrid_recv
  recv_size(:) = xmap%your2my1_size(:)
  nsend = count( send_size> 0)  
  comm%nsend = nsend
  if(nsend>0) then
     allocate(comm%send(nsend))
     comm%send(:)%count = 0
  endif

  pos = 0
  do p = 0, npes-1
     send_buffer_pos(p) = pos
     pos = pos + send_size(p)
  enddo

  pos = 0
  comm%sendsize = 0
  do n = 0, npes-1
     p = mod(mypos+n, npes)
     if(send_size(p)>0) then
        pos = pos + 1
        allocate(comm%send(pos)%i(send_size(p)))
        comm%send(pos)%buffer_pos = send_buffer_pos(p)
        comm%send(pos)%count = send_size(p)
        comm%send(pos)%pe = pelist(p)
        comm%sendsize = comm%sendsize + send_size(p)
     endif
  enddo

  nset = 3
  if(monotonic_exchange) nset = 5
  rbuf_size = sum(recv_size)*nset
  sbuf_size = sum(send_size)*nset
  if(rbuf_size>0) allocate(recv_buf(rbuf_size))
  if(sbuf_size>0) allocate(send_buf(sbuf_size))

  pos = 0
  do n = 0, npes-1
     p = mod(mypos+npes-n, npes)
     if(recv_size(p) ==0) cycle
     msgsize = recv_size(p)*nset
     call mpp_recv(recv_buf(pos+1), glen=msgsize, from_pe=pelist(p), block=.false., tag=COMM_TAG_4)
     pos = pos + msgsize
  enddo

  pos_x = 0
  do p = 1, npes-1
     pos_x(p) = pos_x(p-1) + size_pe(p-1)
  enddo
  ll = 0
  pos = 0
  do n = 0, npes-1
     p = mod(mypos+n, npes)
     do l = 1, send_size(p)
        send_buf(pos+1) = iarray(pos_x(p)+l)
        send_buf(pos+2) = jarray(pos_x(p)+l)
        send_buf(pos+3) = tarray(pos_x(p)+l)
        if(monotonic_exchange) then
           send_buf(pos+4) = diarray(pos_x(p)+l)
           send_buf(pos+5) = djarray(pos_x(p)+l)
        endif
        pos = pos + nset
     enddo
  enddo

  pos = 0
  do n = 0, npes-1
     p = mod(mypos+n, npes)
     if(send_size(p) ==0) cycle
     msgsize = send_size(p)*nset
     call mpp_send(send_buf(pos+1), plen=msgsize, to_pe=pelist(p), tag=COMM_TAG_4 )
     pos = pos + msgsize
  enddo

  call mpp_sync_self(check=EVENT_RECV)
  nrecv = count(recv_size>0)
  comm%nrecv = nrecv
  comm%recvsize = 0

  if(nrecv >0) then
     allocate(comm%recv(nrecv))
     comm%recv(:)%count = 0
     !--- set up the buffer pos for each receiving
     buffer_pos = 0
     do p = 0, npes-1
        recv_buffer_pos(p) = buffer_pos
        buffer_pos = buffer_pos +  recv_size(p)
     enddo
     pos = 0
     buffer_pos = 0        
     do m=0,npes-1
        p = mod(mypos+npes-m, npes)
        if(recv_size(p)>0) then
           pos = pos + 1
           allocate(comm%recv(pos)%i(recv_size(p)))
           allocate(comm%recv(pos)%j(recv_size(p)))
           allocate(comm%recv(pos)%tile(recv_size(p)))
           comm%recv(pos)%buffer_pos = recv_buffer_pos(p)
           comm%recv(pos)%pe = pelist(p)
           comm%recv(pos)%count = recv_size(p)
           comm%recvsize = comm%recvsize + recv_size(p)
           if(monotonic_exchange) then
              allocate(comm%recv(pos)%di(recv_size(p)))
              allocate(comm%recv(pos)%dj(recv_size(p)))
           endif
           do n = 1, recv_size(p)
              comm%recv(pos)%i(n) = recv_buf(buffer_pos+1) - grid1%is_me + 1
              comm%recv(pos)%j(n) = recv_buf(buffer_pos+2) - grid1%js_me + 1
              comm%recv(pos)%tile(n) = recv_buf(buffer_pos+3) 
              if(monotonic_exchange) then
                 comm%recv(pos)%di(n) = recv_buf(buffer_pos+4) 
                 comm%recv(pos)%dj(n) = recv_buf(buffer_pos+5) 
              endif
              buffer_pos = buffer_pos + nset
           enddo
        endif
     enddo
     allocate(comm%unpack_ind(nrecv))
     pos = 0
     do p = 0, npes-1
        if(recv_size(p)>0) then
           pos = pos + 1
           do m = 1, nrecv
              if(comm%recv(m)%pe == pelist(p)) then
                 comm%unpack_ind(pos) = m
                 exit
              endif
           enddo
        endif
     enddo
  endif
  call mpp_sync_self()

  if(allocated(send_buf) ) deallocate(send_buf)
  if(allocated(recv_buf) ) deallocate(recv_buf)
  if(allocated(pelist)   ) deallocate(pelist)
  if(allocated(pos_x)    ) deallocate(pos_x)
  if(allocated(pelist)   ) deallocate(pelist)
  if(allocated(iarray)   ) deallocate(iarray)
  if(allocated(jarray)   ) deallocate(jarray)
  if(allocated(tarray)   ) deallocate(tarray)
  if(allocated(size_pe)  ) deallocate(size_pe)

end subroutine set_comm_get1

!###############################################################################
subroutine set_comm_put1(xmap)
  type (xmap_type), intent(inout) :: xmap
  type (grid_type), pointer, save :: grid1 =>NULL()
  integer, allocatable :: send_size(:)
  integer, allocatable :: recv_size(:)
  integer              :: max_size, g, npes, l, ll, m, mypos
  integer              :: i1, j1, tile1, p, n, pos, buffer_pos
  integer              :: nsend, nrecv, msgsize, nset, rbuf_size, sbuf_size
  logical              :: found
  real,    allocatable :: recv_buf(:), send_buf(:)
  real,    allocatable :: diarray(:), djarray(:)
  integer, allocatable :: iarray(:), jarray(:), tarray(:)
  integer, allocatable :: pos_x(:), pelist(:), size_pe(:), pe_put1(:)
  integer              :: root_pe, recvsize, sendsize
  integer              :: recv_buffer_pos(0:xmap%npes)
  type(comm_type), pointer, save :: comm => NULL()


  comm => xmap%put1
  if(nnest == 0 .OR. xmap%grids(1)%id .NE. 'ATM' ) then
     comm%nsend    = xmap%get1%nrecv
     comm%nrecv    = xmap%get1%nsend   
     comm%sendsize = xmap%get1%recvsize
     comm%recvsize = xmap%get1%sendsize    
     comm%send     => xmap%get1%recv
     comm%recv     => xmap%get1%send
     xmap%ind_put1 => xmap%ind_get1 
    return
  endif

  max_size = 0
  do g=2,size(xmap%grids(:))
     max_size = max_size + xmap%grids(g)%size
  enddo
  grid1 => xmap%grids(1)
  comm%nsend = 0
  comm%nrecv = 0
  npes = xmap%npes
  allocate(pelist(0:npes-1))
  call mpp_get_current_pelist(pelist)
  allocate(send_size(0:npes-1))
  allocate(recv_size(0:npes-1))
  allocate(size_pe(0:npes-1))
  allocate(pos_x(0:npes-1))
  size_pe = 0
  send_size = 0
  recv_size = 0

  if(max_size > 0) then
     allocate(pe_put1(max_size))
     allocate(xmap%ind_put1(max_size))

     !--- find the recv_indx
     ll = 0 
     do g=2,size(xmap%grids(:))
        do l=1,xmap%grids(g)%size
           i1 = xmap%grids(g)%x(l)%i1
           j1 = xmap%grids(g)%x(l)%j1
           tile1 = xmap%grids(g)%x(l)%tile
           do p=0,npes-1
              if(grid1%tile(p) == tile1) then
                 if(in_box(i1, j1, grid1%is(p), grid1%ie(p), grid1%js(p), grid1%je(p))) then
                    size_pe(p) = size_pe(p) + 1     
                    exit
                 endif
              endif
           enddo
           ll = ll + 1
           pe_put1(ll) = p
        enddo
     enddo

     pos_x = 0
     do p = 1, npes-1
        pos_x(p) = pos_x(p-1) + size_pe(p-1)
     enddo

     !---find the send size for get_1_from_xgrid
     allocate(iarray(max_size))
     allocate(jarray(max_size))
     allocate(tarray(max_size))
     if(monotonic_exchange) then
        allocate(diarray(max_size))
        allocate(djarray(max_size))        
     endif

     ll = 0

     do g=2,size(xmap%grids(:))
        do l=1,xmap%grids(g)%size
           i1 = xmap%grids(g)%x(l)%i1
           j1 = xmap%grids(g)%x(l)%j1
           tile1 = xmap%grids(g)%x(l)%tile
           ll = ll + 1
           p = pe_put1(ll)

           found = .false.
           if(send_size(p) > 0) then
              if( i1 == iarray(pos_x(p)+send_size(p)) .AND. j1 == jarray(pos_x(p)+send_size(p)) &
                   .AND. tile1 == tarray(pos_x(p)+send_size(p))) then
                 found = .true.
                 n = send_size(p)
              else
                 !---may need to replace with a fast search algorithm
                 do n = 1, send_size(p)
                    if(i1 == iarray(pos_x(p)+n) .AND. j1 == jarray(pos_x(p)+n) .AND. tile1 == tarray(pos_x(p)+n)) then
                       found = .true.
                       exit
                    endif
                 enddo
              endif
           endif
           if( (.NOT. found) .OR. monotonic_exchange ) then
              send_size(p) = send_size(p)+1
              pos = pos_x(p)+send_size(p)
              iarray(pos) = i1
              jarray(pos) = j1
              tarray(pos) = tile1
              if(monotonic_exchange) then
                 diarray(pos) = xmap%grids(g)%x(l)%di
                 djarray(pos) = xmap%grids(g)%x(l)%dj
              endif
              n = send_size(p)
           endif
           xmap%ind_put1(ll) = n
        enddo
     enddo

     pos_x = 0
     do p = 1, npes-1
        pos_x(p) = pos_x(p-1) + send_size(p-1)
     enddo

     ll = 0
     do g=2,size(xmap%grids(:))
        do l=1,xmap%grids(g)%size
           i1 = xmap%grids(g)%x(l)%i1
           j1 = xmap%grids(g)%x(l)%j1
           tile1 = xmap%grids(g)%x(l)%tile
           ll = ll + 1
           p = pe_put1(ll)  
           xmap%ind_put1(ll) = pos_x(p) + xmap%ind_put1(ll)
        enddo
     enddo
  endif

  mypos = mpp_pe()-mpp_root_pe()
  do n = 0, npes-1
     p = mod(mypos+npes-n, npes)
     call mpp_recv(recv_size(p), glen=1, from_pe=pelist(p), block=.false., tag=COMM_TAG_5)
  enddo

  !--- send data
  do n = 0, npes-1
     p = mod(mypos+n, npes)
     call mpp_send(send_size(p), plen=1, to_pe=pelist(p), tag=COMM_TAG_5)
  enddo

  call mpp_sync_self(check=EVENT_RECV)
  call mpp_sync_self()

  !--- recv for put_1_to_xgrid
  nrecv = count( send_size> 0)  
  comm%nrecv = nrecv
  if(nrecv>0) then
     allocate(comm%recv(nrecv))
     comm%recv(:)%count = 0
  endif
  pos = 0
  comm%recvsize = 0
  do p = 0, npes-1
     recv_buffer_pos(p) = pos
     pos = pos + send_size(p)
  enddo

  pos = 0
  do n = 0, npes-1
     p = mod(mypos+npes-n, npes)
     if(send_size(p)>0) then
        pos = pos + 1
        allocate(comm%recv(pos)%i(send_size(p)))
        comm%recv(pos)%buffer_pos = recv_buffer_pos(p)
        comm%recv(pos)%count = send_size(p)
        comm%recv(pos)%pe = pelist(p)
        comm%recvsize = comm%recvsize + send_size(p)
     endif
  enddo

  nset = 3
  if(monotonic_exchange) nset = 5
  rbuf_size = sum(recv_size)*nset
  sbuf_size = sum(send_size)*nset
  if(rbuf_size>0) allocate(recv_buf(rbuf_size))
  if(sbuf_size>0) allocate(send_buf(sbuf_size))

  pos = 0
  do n = 0, npes-1
     p = mod(mypos+npes-n, npes)
     if(recv_size(p) ==0) cycle
     msgsize = recv_size(p)*nset
     call mpp_recv(recv_buf(pos+1), glen=msgsize, from_pe=pelist(p), block=.false., tag=COMM_TAG_6)
     pos = pos + msgsize
  enddo

  pos_x = 0
  do p = 1, npes-1
     pos_x(p) = pos_x(p-1) + size_pe(p-1)
  enddo
  ll = 0
  pos = 0
  do n = 0, npes-1
     p = mod(mypos+n, npes)
     do l = 1, send_size(p)
        send_buf(pos+1) = iarray(pos_x(p)+l)
        send_buf(pos+2) = jarray(pos_x(p)+l)
        send_buf(pos+3) = tarray(pos_x(p)+l)
        if(monotonic_exchange) then
           send_buf(pos+4) = diarray(pos_x(p)+l)
           send_buf(pos+5) = djarray(pos_x(p)+l)
        endif
        pos = pos + nset
     enddo
  enddo

  pos = 0
  do n = 0, npes-1
     p = mod(mypos+n, npes)
     if(send_size(p) ==0) cycle
     msgsize = send_size(p)*nset
     call mpp_send(send_buf(pos+1), plen=msgsize, to_pe=pelist(p), tag=COMM_TAG_6 )
     pos = pos + msgsize
  enddo

  call mpp_sync_self(check=EVENT_RECV)
  nsend = count(recv_size>0)
  comm%nsend = nsend
  comm%sendsize = 0

  if(nsend >0) then
     allocate(comm%send(nsend))
     comm%send(:)%count = 0
     pos = 0
     buffer_pos = 0
     do m=0,npes-1
        p = mod(mypos+npes-m, npes)
        if(recv_size(p)>0) then
           pos = pos + 1
           allocate(comm%send(pos)%i(recv_size(p)))
           allocate(comm%send(pos)%j(recv_size(p)))
           allocate(comm%send(pos)%tile(recv_size(p)))
           comm%send(pos)%pe = pelist(p)
           comm%send(pos)%count = recv_size(p)
           comm%sendsize = comm%sendsize + recv_size(p)
           if(monotonic_exchange) then
              allocate(comm%send(pos)%di(recv_size(p)))
              allocate(comm%send(pos)%dj(recv_size(p)))
           endif
           do n = 1, recv_size(p)
              comm%send(pos)%i(n) = recv_buf(buffer_pos+1) - grid1%is_me + 1
              comm%send(pos)%j(n) = recv_buf(buffer_pos+2) - grid1%js_me + 1
              comm%send(pos)%tile(n) = recv_buf(buffer_pos+3) 
              if(monotonic_exchange) then
                 comm%send(pos)%di(n) = recv_buf(buffer_pos+4) 
                 comm%send(pos)%dj(n) = recv_buf(buffer_pos+5) 
              endif
              buffer_pos = buffer_pos + nset
           enddo
        endif
     enddo
  endif

  call mpp_sync_self()
  if(allocated(send_buf) ) deallocate(send_buf)
  if(allocated(recv_buf) ) deallocate(recv_buf)
  if(allocated(pelist)   ) deallocate(pelist)
  if(allocated(pos_x)    ) deallocate(pos_x)
  if(allocated(pelist)   ) deallocate(pelist)
  if(allocated(iarray)   ) deallocate(iarray)
  if(allocated(jarray)   ) deallocate(jarray)
  if(allocated(tarray)   ) deallocate(tarray)
  if(allocated(size_pe)  ) deallocate(size_pe)

end subroutine set_comm_put1


!###############################################################################
subroutine regen(xmap)
type (xmap_type), intent(inout) :: xmap

  integer              :: g, l, k, max_size
  integer              :: i1, j1, i2, j2, p
  integer              :: tile1
  integer              :: ll
  logical              :: overlap_with_nest
  integer              :: cnt(xmap%get1%nsend)
  integer              :: i,j,n,xloc,pos,nsend,m,npes, mypos
  integer              :: send_ind(0:xmap%npes-1)

  max_size = 0

  do g=2,size(xmap%grids(:))
    max_size = max_size + xmap%grids(g)%size * xmap%grids(g)%km
  end do

  if (max_size>size(xmap%x1(:))) then
    deallocate(xmap%x1)
    deallocate(xmap%x2)
    allocate( xmap%x1(1:max_size) )
    allocate( xmap%x2(1:max_size) )
  endif


  do g=2,size(xmap%grids(:))
    xmap%grids(g)%first = 1
    xmap%grids(g)%last  = 0
  end do  

  xmap%size = 0
  ll = 0
  do g=2,size(xmap%grids(:))
     xmap%grids(g)%first = xmap%size + 1;
     
     do l=1,xmap%grids(g)%size
        i1 = xmap%grids(g)%x(l)%i1
        j1 = xmap%grids(g)%x(l)%j1
        i2 = xmap%grids(g)%x(l)%i2
        j2 = xmap%grids(g)%x(l)%j2
        tile1 = xmap%grids(g)%x(l)%tile
        ll = ll + 1
        do k=1,xmap%grids(g)%km
           if (xmap%grids(g)%frac_area(i2,j2,k)/=0.0) then
              xmap%size = xmap%size+1
              xmap%x1(xmap%size)%pos  = xmap%ind_get1(ll)
              xmap%x1(xmap%size)%i    = xmap%grids(g)%x(l)%i1
              xmap%x1(xmap%size)%j    = xmap%grids(g)%x(l)%j1
              xmap%x1(xmap%size)%tile = xmap%grids(g)%x(l)%tile
              xmap%x1(xmap%size)%area = xmap%grids(g)%x(l)%area &
                   *xmap%grids(g)%frac_area(i2,j2,k)
              xmap%x1(xmap%size)%di   = xmap%grids(g)%x(l)%di 
              xmap%x1(xmap%size)%dj   = xmap%grids(g)%x(l)%dj 
              xmap%x2(xmap%size)%i    = xmap%grids(g)%x(l)%i2
              xmap%x2(xmap%size)%j    = xmap%grids(g)%x(l)%j2
              xmap%x2(xmap%size)%k    = k
              xmap%x2(xmap%size)%area = xmap%grids(g)%x(l)%area * xmap%grids(g)%x(l)%scale 
           end if
        end do
     end do
     xmap%grids(g)%last = xmap%size
  end do


  if (max_size>size(xmap%x1_put(:))) then
    deallocate(xmap%x1_put)
    allocate( xmap%x1_put(1:max_size) )
  endif
  if (max_size>size(xmap%x2_get(:))) then
    deallocate(xmap%x2_get)
    allocate( xmap%x2_get(1:max_size) )
  endif

  do g=2,size(xmap%grids(:))
    xmap%grids(g)%first_get = 1
    xmap%grids(g)%last_get  = 0
  end do  

  xmap%size_put1 = 0
  xmap%size_get2 = 0
  ll = 0
  do g=2,size(xmap%grids(:))
     xmap%grids(g)%first_get = xmap%size_get2 + 1;
     
     do l=1,xmap%grids(g)%size
        i1 = xmap%grids(g)%x(l)%i1
        j1 = xmap%grids(g)%x(l)%j1
        i2 = xmap%grids(g)%x(l)%i2
        j2 = xmap%grids(g)%x(l)%j2
        tile1 = xmap%grids(g)%x(l)%tile
        ll = ll + 1
        overlap_with_nest = .false.
        if(  xmap%grids(1)%id == "ATM" .AND. tile1 == tile_parent .AND. &
             in_box(i1, j1, is_parent, ie_parent, js_parent, je_parent) ) overlap_with_nest = .true.
        do k=1,xmap%grids(g)%km
           if (xmap%grids(g)%frac_area(i2,j2,k)/=0.0) then
              xmap%size_put1 = xmap%size_put1+1
              xmap%x1_put(xmap%size_put1)%pos  = xmap%ind_put1(ll)
              xmap%x1_put(xmap%size_put1)%i    = xmap%grids(g)%x(l)%i1
              xmap%x1_put(xmap%size_put1)%j    = xmap%grids(g)%x(l)%j1
              xmap%x1_put(xmap%size_put1)%tile = xmap%grids(g)%x(l)%tile
              xmap%x1_put(xmap%size_put1)%area = xmap%grids(g)%x(l)%area &
                   *xmap%grids(g)%frac_area(i2,j2,k)
              xmap%x1_put(xmap%size_put1)%di   = xmap%grids(g)%x(l)%di 
              xmap%x1_put(xmap%size_put1)%dj   = xmap%grids(g)%x(l)%dj 
              if( .not. overlap_with_nest) then
                 xmap%size_get2 = xmap%size_get2+1
                 xmap%x2_get(xmap%size_get2)%i    = xmap%grids(g)%x(l)%i2
                 xmap%x2_get(xmap%size_get2)%j    = xmap%grids(g)%x(l)%j2
                 xmap%x2_get(xmap%size_get2)%k    = k
                 xmap%x2_get(xmap%size_get2)%area = xmap%grids(g)%x(l)%area * xmap%grids(g)%x(l)%scale 
                 xmap%x2_get(xmap%size_get2)%pos  = xmap%size_put1
              endif
           end if
        end do
     end do
     xmap%grids(g)%last_get = xmap%size_get2
  end do

  !---set up information for get_1_from_xgrid_repro
  if (make_exchange_reproduce) then
  if (xmap%get1_repro%nsend > 0) then
     xloc = 0
     nsend = 0
     npes = xmap%npes
     mypos = mpp_pe() - mpp_root_pe()
     cnt(:) = 0
     do m=0,npes-1 
        p = mod(mypos+m, npes)
        if( xmap%send_count_repro(p) > 0 ) then
          nsend = nsend + 1
          send_ind(p) = nsend
        endif
     enddo
     do g=2,size(xmap%grids(:))
        do l=1,xmap%grids(g)%size ! index into this side 2 grid's patterns
           i = xmap%grids(g)%x(l)%i2
           j = xmap%grids(g)%x(l)%j2
           p = xmap%grids(g)%x(l)%pe-xmap%root_pe 
           n = send_ind(p) 
           cnt(n) = cnt(n) + 1
           pos = cnt(n) 
           xmap%get1_repro%send(n)%xLoc(pos) = xloc
           xloc = xloc + count(xmap%grids(g)%frac_area(i,j,:)/=0.0)
        enddo
     enddo
  endif
  endif

end subroutine regen

!#######################################################################

! <SUBROUTINE NAME="set_frac_area">

!   <OVERVIEW>
!     Changes sub-grid portion areas and/or number.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Changes sub-grid portion areas and/or number.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call set_frac_area(f, grid_id, xmap)
!   </TEMPLATE>

!   <IN NAME="f" TYPE="real" DIM="(:,:,:)"> </IN>
!   <IN NAME="grid_id" TYPE="character(len=3)" > </IN>
!   <INOUT NAME="xmap"  TYPE="xmap_type"  > </INOUT>

subroutine set_frac_area(f, grid_id, xmap)
real, dimension(:,:,:), intent(in   ) :: f
character(len=3),       intent(in   ) :: grid_id
type (xmap_type),       intent(inout) :: xmap

  integer :: g
  type(grid_type), pointer, save :: grid =>NULL()

  if (grid_id==xmap%grids(1)%id) call error_mesg ('xgrid_mod',  &
                                   'set_frac_area called on side 1 grid', FATAL)
  do g=2,size(xmap%grids(:))
    grid => xmap%grids(g)
    if (grid_id==grid%id) then
      if (size(f,3)/=size(grid%frac_area,3)) then
        deallocate (grid%frac_area)
        grid%km = size(f,3);
        allocate( grid%frac_area(grid%is_me:grid%ie_me, grid%js_me:grid%je_me, &
                                                                      grid%km) )
      end if
      grid%frac_area = f;
      call regen(xmap)
      return;
    end if
  end do

  call error_mesg ('xgrid_mod', 'set_frac_area: could not find grid id', FATAL)

end subroutine  set_frac_area
! </SUBROUTINE>



!#######################################################################

! <FUNCTION NAME="xgrid_count">

!   <OVERVIEW>
!     Returns current size of exchange grid variables.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Returns current size of exchange grid variables.
!   </DESCRIPTION>
!   <TEMPLATE>
!     xgrid_count(xmap)
!   </TEMPLATE>

!   <IN NAME="xmap" TYPE="xmap_type" > </IN>
!   <OUT NAME="xgrid_count"  TYPE="integer"  > </OUT>

integer function xgrid_count(xmap)
type (xmap_type), intent(inout) :: xmap

  xgrid_count = xmap%size
end function xgrid_count
! </FUNCTION>

!#######################################################################

! <SUBROUTINE NAME="put_side1_to_xgrid" INTERFACE="put_to_xgrid">
!   <IN NAME="d"  TYPE="real" DIM="(:,:)" > </IN>
!   <IN NAME="grid_id"  TYPE=" character(len=3)"  > </IN>
!   <INOUT NAME="x"  TYPE="real" DIM="(:)" > </INOUT>
!   <INOUT NAME="xmap"  TYPE="xmap_type"  > </INOUT>
!   <IN NAME="remap_method" TYPE="integer,optional"></IN>

subroutine put_side1_to_xgrid(d, grid_id, x, xmap, remap_method, complete)
  real, dimension(:,:), intent(in   )    :: d
  character(len=3),     intent(in   )    :: grid_id
  real, dimension(:),   intent(inout)    :: x
  type (xmap_type),     intent(inout)    :: xmap
  integer, intent(in), optional          :: remap_method
  logical, intent(in), optional          :: complete

  logical                                         :: is_complete, set_mismatch
  integer                                         :: g, method
  character(len=2)                                :: text
  integer,                                   save :: isize=0
  integer,                                   save :: jsize=0
  integer,                                   save :: lsize=0
  integer,                                   save :: xsize=0
  integer,                                   save :: method_saved=0
  character(len=3),                          save :: grid_id_saved=""
  integer(LONG_KIND), dimension(MAX_FIELDS), save :: d_addrs=-9999
  integer(LONG_KIND), dimension(MAX_FIELDS), save :: x_addrs=-9999
  
  if (grid_id==xmap%grids(1)%id) then
     method = FIRST_ORDER      ! default
     if(present(remap_method)) method = remap_method
     is_complete = .true.
     if(present(complete)) is_complete=complete
     lsize = lsize + 1
     if( lsize > MAX_FIELDS ) then
        write( text,'(i2)' ) MAX_FIELDS
        call error_mesg ('xgrid_mod',  'MAX_FIELDS='//trim(text)//' exceeded for group put_side1_to_xgrid', FATAL)
     endif
     d_addrs(lsize) = LOC(d)
     x_addrs(lsize) = LOC(x)  
   
     if(lsize == 1) then
        isize = size(d,1)
        jsize = size(d,2)
        xsize = size(x(:))
        method_saved = method
        grid_id_saved = grid_id
     else
        set_mismatch = .false.
        set_mismatch = set_mismatch .OR. (isize /= size(d,1))
        set_mismatch = set_mismatch .OR. (jsize /= size(d,2))
        set_mismatch = set_mismatch .OR. (xsize /= size(x(:)))
        set_mismatch = set_mismatch .OR. (method_saved /= method)
        set_mismatch = set_mismatch .OR. (grid_id_saved /= grid_id)
        if(set_mismatch)then
           write( text,'(i2)' ) lsize
           call error_mesg ('xgrid_mod', 'Incompatible field at count '//text//' for group put_side1_to_xgrid', FATAL )
        endif
     endif

     if(is_complete) then
        !--- when exchange_monotonic is true and the side 1 ia atm, will always use monotonic second order conservative.
        if(monotonic_exchange .AND. grid_id == 'ATM') then
           call put_1_to_xgrid_order_2(d_addrs, x_addrs, xmap, isize, jsize, xsize, lsize)
        else if(method == FIRST_ORDER) then
           call put_1_to_xgrid_order_1(d_addrs, x_addrs, xmap, isize, jsize, xsize, lsize)
        else 
           if(grid_id .NE. 'ATM') call error_mesg ('xgrid_mod',  &
                "second order put_to_xgrid should only be applied to 'ATM' model, "//&
                "contact developer", FATAL)
           call put_1_to_xgrid_order_2(d_addrs, x_addrs, xmap, isize, jsize, xsize, lsize)
        endif

        d_addrs = -9999
        x_addrs = -9999
        isize   = 0
        jsize   = 0
        xsize   = 0
        lsize   = 0
        method_saved = 0
        grid_id_saved = ""
     endif
     return
  end if

  do g=2,size(xmap%grids(:))
    if (grid_id==xmap%grids(g)%id)    &
      call error_mesg ('xgrid_mod',  &
                       'put_to_xgrid expects a 3D side 2 grid', FATAL)
  end do

  call error_mesg ('xgrid_mod', 'put_to_xgrid: could not find grid id', FATAL)

end subroutine put_side1_to_xgrid
! </SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="put_side2_to_xgrid" INTERFACE="put_to_xgrid">
!   <IN NAME="d"  TYPE="real" DIM="(:,:,:)" > </IN>
!   <IN NAME="grid_id"  TYPE=" character(len=3)"  > </IN>
!   <INOUT NAME="x"  TYPE="real" DIM="(:)" > </INOUT>
!   <INOUT NAME="xmap"  TYPE="xmap_type"  > </INOUT>

subroutine put_side2_to_xgrid(d, grid_id, x, xmap)
real, dimension(:,:,:), intent(in   ) :: d
character(len=3),       intent(in   ) :: grid_id
real, dimension(:),     intent(inout) :: x
type (xmap_type),       intent(inout) :: xmap

  integer :: g

  if (grid_id==xmap%grids(1)%id) &
    call error_mesg ('xgrid_mod',  &
                     'put_to_xgrid expects a 2D side 1 grid', FATAL)

  do g=2,size(xmap%grids(:))
    if (grid_id==xmap%grids(g)%id) then
         call put_2_to_xgrid(d, xmap%grids(g), x, xmap)
      return;
    end if
  end do

  call error_mesg ('xgrid_mod', 'put_to_xgrid: could not find grid id', FATAL)

end subroutine put_side2_to_xgrid
! </SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="get_side1_from_xgrid" INTERFACE="get_from_xgrid">
!   <IN NAME="x"  TYPE="real" DIM="(:)" > </IN>
!   <IN NAME="grid_id"  TYPE=" character(len=3)"  > </IN>
!   <OUT NAME="d"  TYPE="real" DIM="(:,:)" > </OUT>
!   <INOUT NAME="xmap"  TYPE="xmap_type"  > </INOUT>

subroutine get_side1_from_xgrid(d, grid_id, x, xmap, complete)
  real, dimension(:,:), intent(  out) :: d
  character(len=3),     intent(in   ) :: grid_id
  real, dimension(:),   intent(in   ) :: x
  type (xmap_type),     intent(inout) :: xmap
  logical, intent(in), optional     :: complete

  logical                                         :: is_complete, set_mismatch
  integer                                         :: g
  character(len=2)                                :: text
  integer,                                   save :: isize=0
  integer,                                   save :: jsize=0
  integer,                                   save :: lsize=0
  integer,                                   save :: xsize=0
  character(len=3),                          save :: grid_id_saved=""
  integer(LONG_KIND), dimension(MAX_FIELDS), save :: d_addrs=-9999
  integer(LONG_KIND), dimension(MAX_FIELDS), save :: x_addrs=-9999

  if (grid_id==xmap%grids(1)%id) then
     is_complete = .true.
     if(present(complete)) is_complete=complete
     lsize = lsize + 1
     if( lsize > MAX_FIELDS ) then
        write( text,'(i2)' ) MAX_FIELDS
        call error_mesg ('xgrid_mod',  'MAX_FIELDS='//trim(text)//' exceeded for group get_side1_from_xgrid', FATAL)
     endif
     d_addrs(lsize) = LOC(d)
     x_addrs(lsize) = LOC(x)  

     if(lsize == 1) then
        isize = size(d,1)
        jsize = size(d,2)
        xsize = size(x(:))
        grid_id_saved = grid_id
     else
        set_mismatch = .false.
        set_mismatch = set_mismatch .OR. (isize /= size(d,1))
        set_mismatch = set_mismatch .OR. (jsize /= size(d,2))
        set_mismatch = set_mismatch .OR. (xsize /= size(x(:)))
        set_mismatch = set_mismatch .OR. (grid_id_saved /= grid_id)
        if(set_mismatch)then
           write( text,'(i2)' ) lsize
           call error_mesg ('xgrid_mod', 'Incompatible field at count '//text//' for group get_side1_from_xgrid', FATAL )
        endif
     endif

     if(is_complete) then
        if (make_exchange_reproduce) then
           call get_1_from_xgrid_repro(d_addrs, x_addrs, xmap, xsize, lsize)
        else
           call get_1_from_xgrid(d_addrs, x_addrs, xmap, isize, jsize, xsize, lsize)
        end if
        d_addrs = -9999
        x_addrs = -9999
        isize   = 0
        jsize   = 0
        xsize   = 0
        lsize   = 0
        grid_id_saved = ""
     endif
     return;
  end if
  
  do g=2,size(xmap%grids(:))
    if (grid_id==xmap%grids(g)%id) &
      call error_mesg ('xgrid_mod',  & 
                       'get_from_xgrid expects a 3D side 2 grid', FATAL)
  end do
  
  call error_mesg ('xgrid_mod', 'get_from_xgrid: could not find grid id', FATAL)

end subroutine get_side1_from_xgrid
! </SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="get_side2_from_xgrid" INTERFACE="get_from_xgrid">
!   <IN NAME="x"  TYPE="real" DIM="(:)" > </IN>
!   <IN NAME="grid_id"  TYPE=" character(len=3)"  > </IN>
!   <OUT NAME="d"  TYPE="real" DIM="(:,:,:)" > </OUT>
!   <INOUT NAME="xmap"  TYPE="xmap_type"  > </INOUT>

subroutine get_side2_from_xgrid(d, grid_id, x, xmap)
real, dimension(:,:,:), intent(  out) :: d
character(len=3),       intent(in   ) :: grid_id
real, dimension(:),     intent(in   ) :: x
type (xmap_type),       intent(in   ) :: xmap

  integer :: g

  if (grid_id==xmap%grids(1)%id) &
    call error_mesg ('xgrid_mod',  &
                     'get_from_xgrid expects a 2D side 1 grid', FATAL)
  
  do g=2,size(xmap%grids(:))
    if (grid_id==xmap%grids(g)%id) then
      call get_2_from_xgrid(d, xmap%grids(g), x, xmap)
      return;
    end if
  end do
  
  call error_mesg ('xgrid_mod', 'get_from_xgrid: could not find grid id', FATAL)

end subroutine get_side2_from_xgrid
! </SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="some">

!   <OVERVIEW>
!     Returns logical associating exchange grid cells with given side two grid.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Returns logical associating exchange grid cells with given side two grid.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call some(xmap, some_arr, grid_id)
!   </TEMPLATE>

!   <IN NAME="xmap"  TYPE="xmap_type"  ></IN>
!   <IN NAME="grid_id"  TYPE="character(len=3)"  ></IN>
!   <OUT NAME="some_arr"  TYPE="logical" DIM="(xmap%size)" >
!     logical associating exchange grid cells with given side 2 grid.
!   </OUT>

subroutine some(xmap, some_arr, grid_id)
type (xmap_type),           intent(in) :: xmap
character(len=3), optional, intent(in) :: grid_id
logical, dimension(:), intent(out) :: some_arr

  integer :: g

  if (.not.present(grid_id)) then

    if(xmap%size > 0) then
       some_arr = .true.
    else 
       some_arr = .false.
    end if
    return;
  end if

  if (grid_id==xmap%grids(1)%id) &
    call error_mesg ('xgrid_mod', 'some expects a side 2 grid id', FATAL)
  
  do g=2,size(xmap%grids(:))
    if (grid_id==xmap%grids(g)%id) then
      some_arr = .false.
      some_arr(xmap%grids(g)%first:xmap%grids(g)%last) = .true.;
      return;
    end if
  end do
  
  call error_mesg ('xgrid_mod', 'some could not find grid id', FATAL)

end subroutine some
! </SUBROUTINE>

!#######################################################################

subroutine put_2_to_xgrid(d, grid, x, xmap)
type (grid_type),                                intent(in) :: grid
real, dimension(grid%is_me:grid%ie_me, &
                grid%js_me:grid%je_me, grid%km), intent(in) :: d
real, dimension(:    ), intent(inout) :: x
type (xmap_type),       intent(in   ) :: xmap

  integer                 ::   l
  call mpp_clock_begin(id_put_2_to_xgrid)

  do l=grid%first,grid%last
    x(l) = d(xmap%x2(l)%i,xmap%x2(l)%j,xmap%x2(l)%k)
  end do

  call mpp_clock_end(id_put_2_to_xgrid)
end subroutine put_2_to_xgrid

!#######################################################################

subroutine get_2_from_xgrid(d, grid, x, xmap)
type (grid_type),                                intent(in ) :: grid
real, dimension(grid%is_me:grid%ie_me, &
                grid%js_me:grid%je_me, grid%km), intent(out) :: d
real, dimension(:),     intent(in   ) :: x
type (xmap_type),       intent(in   ) :: xmap

  integer                 :: l, k

  call mpp_clock_begin(id_get_2_from_xgrid)

  d = 0.0
  do l=grid%first_get,grid%last_get
    d(xmap%x2_get(l)%i,xmap%x2_get(l)%j,xmap%x2_get(l)%k) = &
            d(xmap%x2_get(l)%i,xmap%x2_get(l)%j,xmap%x2_get(l)%k) + xmap%x2_get(l)%area*x(xmap%x2_get(l)%pos)
  end do
  !
  !  normalize with side 2 grid cell areas
  !
  do k=1,size(d,3)
    d(:,:,k) = d(:,:,k) * grid%area_inv
  end do

  call mpp_clock_end(id_get_2_from_xgrid)

end subroutine get_2_from_xgrid

!#######################################################################

subroutine put_1_to_xgrid_order_1(d_addrs, x_addrs, xmap, isize, jsize, xsize, lsize)
  integer(LONG_KIND), dimension(:), intent(in) :: d_addrs
  integer(LONG_KIND), dimension(:), intent(in) :: x_addrs
  type (xmap_type),              intent(inout) :: xmap
  integer,                          intent(in) :: isize, jsize, xsize, lsize

  integer                         :: i, j, p, buffer_pos, msgsize
  integer                         :: from_pe, to_pe, pos, n, l, count
  integer                         :: ibegin, istart, iend, start_pos
  type (comm_type), pointer, save :: comm =>NULL()
  real                            :: recv_buffer(xmap%put1%recvsize*lsize)
  real                            :: send_buffer(xmap%put1%sendsize*lsize)
  real                            :: unpack_buffer(xmap%put1%recvsize)

  real, dimension(isize, jsize)   :: d
  real, dimension(xsize)          :: x
  pointer(ptr_d, d)
  pointer(ptr_x, x)

  call mpp_clock_begin(id_put_1_to_xgrid_order_1)

  !--- pre-post receiving
  comm => xmap%put1
  do p = 1, comm%nrecv
     msgsize = comm%recv(p)%count*lsize
     from_pe = comm%recv(p)%pe
     buffer_pos = comm%recv(p)%buffer_pos*lsize
     call mpp_recv(recv_buffer(buffer_pos+1), glen=msgsize, from_pe = from_pe, block=.false., tag=COMM_TAG_7)
  enddo

  !--- send the data
  buffer_pos = 0
  do p = 1, comm%nsend
     msgsize = comm%send(p)%count*lsize
     to_pe = comm%send(p)%pe
     pos = buffer_pos
     do l = 1, lsize
        ptr_d = d_addrs(l)
        do n = 1, comm%send(p)%count
           pos = pos + 1
           i = comm%send(p)%i(n)
           j = comm%send(p)%j(n)
           send_buffer(pos) = d(i,j)
        enddo
     enddo
     call mpp_send(send_buffer(buffer_pos+1), plen=msgsize, to_pe = to_pe, tag=COMM_TAG_7 )
     buffer_pos = buffer_pos + msgsize
  enddo

  call mpp_sync_self(check=EVENT_RECV)

  !--- unpack the buffer
  if( lsize == 1) then
     ptr_x = x_addrs(1)
     do l=1,xmap%size_put1
        x(l) =  recv_buffer(xmap%x1_put(l)%pos)
     end do
  else
     start_pos = 0
!$OMP parallel do default(none) shared(lsize,x_addrs,comm,recv_buffer,xmap) &
!$OMP                          private(ptr_x,count,ibegin,istart,iend,pos,unpack_buffer)
     do l = 1, lsize
        ptr_x = x_addrs(l)
        do p = 1, comm%nrecv
           count = comm%recv(p)%count
           ibegin = comm%recv(p)%buffer_pos*lsize + 1
           istart = ibegin + (l-1)*count
           iend = istart + count - 1
           pos = comm%recv(p)%buffer_pos
           do n = istart, iend
              pos = pos + 1
              unpack_buffer(pos) = recv_buffer(n)
           enddo
        enddo
        do i=1,xmap%size_put1
           x(i) =  unpack_buffer(xmap%x1_put(i)%pos)
        end do    
     enddo
  endif

  call mpp_sync_self()

  call mpp_clock_end(id_put_1_to_xgrid_order_1)

end subroutine put_1_to_xgrid_order_1

!#######################################################################


subroutine put_1_to_xgrid_order_2(d_addrs, x_addrs, xmap, isize, jsize, xsize, lsize)
  integer(LONG_KIND), dimension(:), intent(in) :: d_addrs
  integer(LONG_KIND), dimension(:), intent(in) :: x_addrs
  type (xmap_type),              intent(inout) :: xmap
  integer,                          intent(in) :: isize, jsize, xsize, lsize

  !: NOTE: halo size is assumed to be 1 in setup_xmap
  real, dimension(0:isize+1, 0:jsize+1, lsize) :: tmp
  real, dimension(isize,     jsize,     lsize) :: tmpx, tmpy
  real, dimension(isize,     jsize,     lsize) :: d_bar_max, d_bar_min
  real, dimension(isize,     jsize,     lsize) :: d_max, d_min
  real                            :: d_bar
  integer                         :: i, is, ie, im, j, js, je, jm, ii, jj
  integer                         :: p, l, ioff, joff, isd, jsd
  type (grid_type), pointer, save :: grid1 =>NULL()
  type (comm_type), pointer, save :: comm  =>NULL()
  integer                         :: buffer_pos, msgsize, from_pe, to_pe, pos, n
  integer                         :: ibegin, count, istart, iend
  real                            :: recv_buffer(xmap%put1%recvsize*lsize*3)
  real                            :: send_buffer(xmap%put1%sendsize*lsize*3)
  real                            :: unpack_buffer(xmap%put1%recvsize*3)
  logical                         :: on_west_edge, on_east_edge, on_south_edge, on_north_edge
  real, dimension(isize, jsize)   :: d
  real, dimension(xsize)          :: x
  pointer(ptr_d, d)
  pointer(ptr_x, x)

  call mpp_clock_begin(id_put_1_to_xgrid_order_2)
  grid1 => xmap%grids(1)

  is = grid1%is_me;   ie = grid1%ie_me
  js = grid1%js_me;   je = grid1%je_me
  isd = grid1%isd_me
  jsd = grid1%jsd_me

!$OMP parallel do default(none) shared(lsize,tmp,d_addrs,isize,jsize) private(ptr_d)
  do l = 1, lsize
     tmp(:,:,l) = LARGE_NUMBER
     ptr_d = d_addrs(l)
     tmp(1:isize,1:jsize,l) = d(:,:)
  enddo

  if(grid1%is_latlon) then
     call mpp_update_domains(tmp,grid1%domain_with_halo)
!$OMP parallel do default(none) shared(lsize,tmp,grid1,is,ie,js,je,isd,jsd,tmpx,tmpy)
     do l = 1, lsize
        tmpy(:,:,l) = grad_merid_latlon(tmp(:,:,l), grid1%lat, is, ie, js, je, isd, jsd)
        tmpx(:,:,l) = grad_zonal_latlon(tmp(:,:,l), grid1%lon, grid1%lat, is, ie, js, je, isd, jsd)
     enddo
  else
     call mpp_update_domains(tmp,grid1%domain)
     on_west_edge  = (is==1)
     on_east_edge  = (ie==grid1%im)
     on_south_edge = (js==1)
     on_north_edge = (je==grid1%jm)
!$OMP parallel do default(none) shared(lsize,tmp,grid1,tmpx,tmpy, &
!$OMP                                  on_west_edge,on_east_edge,on_south_edge,on_north_edge)
     do l = 1, lsize
        call gradient_cubic(tmp(:,:,l), grid1%box%dx, grid1%box%dy, grid1%box%area,   &
                            grid1%box%edge_w, grid1%box%edge_e, grid1%box%edge_s,     &
                            grid1%box%edge_n, grid1%box%en1, grid1%box%en2,           &
                            grid1%box%vlon, grid1%box%vlat, tmpx(:,:,l), tmpy(:,:,l), &
                            on_west_edge, on_east_edge, on_south_edge, on_north_edge)
     enddo
  end if     

  !--- pre-post receiving
  buffer_pos = 0
  comm => xmap%put1
  do p = 1, comm%nrecv
     msgsize = comm%recv(p)%count*lsize
     buffer_pos = comm%recv(p)%buffer_pos*lsize
     if(.NOT. monotonic_exchange) then
        msgsize = msgsize*3
        buffer_pos = buffer_pos*3
     endif
     from_pe = comm%recv(p)%pe
     call mpp_recv(recv_buffer(buffer_pos+1), glen=msgsize, from_pe = from_pe, block=.false., tag=COMM_TAG_8)
  enddo

  !--- compute d_bar_max and d_bar_min.
  if(monotonic_exchange) then
!$OMP parallel do default(none) shared(lsize,isize,jsize,d_bar_max,d_bar_min,d_max,d_min,tmp)
     do l = 1, lsize
        do j = 1, jsize
           do i = 1, isize
              d_bar_max(i,j,l) = -LARGE_NUMBER
              d_bar_min(i,j,l) =  LARGE_NUMBER
              d_max    (i,j,l) = -LARGE_NUMBER
              d_min    (i,j,l) =  LARGE_NUMBER          
              do jj = j-1, j+1
                 do ii = i-1, i+1
                    if(tmp(i,j,l) .NE. LARGE_NUMBER) then
                       if(tmp(i,j,l) > d_bar_max(i,j,l)) d_bar_max(i,j,l) = tmp(i,j,l)
                       if(tmp(i,j,l) < d_bar_min(i,j,l)) d_bar_min(i,j,l) = tmp(i,j,l)
                    endif
                 enddo
              enddo
           enddo
        enddo
     enddo
  endif

  !--- send the data
  buffer_pos = 0
  if(monotonic_exchange) then
     pos = 0
     do p = 1, comm%nsend
        msgsize = comm%send(p)%count*lsize
        to_pe = comm%send(p)%pe
        do l = 1, lsize
           ptr_d = d_addrs(l)
           do n = 1, comm%send(p)%count
              pos = pos + 1
              i = comm%send(p)%i(n)
              j = comm%send(p)%j(n)
              send_buffer(pos) = d(i,j) + tmpy(i,j,l)*comm%send(p)%dj(n) + tmpx(i,j,l)*comm%send(p)%di(n)
              if(send_buffer(pos) > d_max(i,j,l)) d_max(i,j,l) = send_buffer(pos)
              if(send_buffer(pos) < d_min(i,j,l)) d_min(i,j,l) = send_buffer(pos)              
           enddo
        enddo
     enddo

     do p = 1, comm%nsend
        msgsize = comm%send(p)%count*lsize
        to_pe = comm%send(p)%pe
        pos = buffer_pos
        do l = 1, lsize
           ptr_d = d_addrs(l)
           do n = 1, comm%send(p)%count
              pos = pos + 1
              i = comm%send(p)%i(n)
              j = comm%send(p)%j(n)           
              d_bar = d(i,j)
              if( d_max(i,j,l) > d_bar_max(i,j,l) ) then
                 send_buffer(pos) = d_bar + ((send_buffer(pos)-d_bar)/(d_max(i,j,l)-d_bar)) * (d_bar_max(i,j,l)-d_bar)
              else if( d_min(i,j,l) < d_bar_min(i,j,l) ) then
                 send_buffer(pos) = d_bar + ((send_buffer(pos)-d_bar)/(d_min(i,j,l)-d_bar)) * (d_bar_min(i,j,l)-d_bar)
              endif
           enddo
        enddo        
        call mpp_send(send_buffer(buffer_pos+1), plen=msgsize, to_pe = to_pe, tag=COMM_TAG_8 )
        buffer_pos = buffer_pos + msgsize
     enddo
  else
     do p = 1, comm%nsend
        msgsize = comm%send(p)%count*lsize*3
        to_pe = comm%send(p)%pe
        pos = buffer_pos
        do l = 1, lsize
           ptr_d = d_addrs(l)
           do n = 1, comm%send(p)%count
              pos = pos + 3
              i = comm%send(p)%i(n)
              j = comm%send(p)%j(n)
              send_buffer(pos-2) = d(i,j)
              send_buffer(pos-1) = tmpy(i,j,l)
              send_buffer(pos  ) = tmpx(i,j,l)
           enddo
        enddo
        call mpp_send(send_buffer(buffer_pos+1), plen=msgsize, to_pe = to_pe, tag=COMM_TAG_8 )
        buffer_pos = buffer_pos + msgsize
     enddo
  endif

  call mpp_sync_self(check=EVENT_RECV)

  !--- unpack the buffer
  if(monotonic_exchange) then
     if( lsize == 1) then
        ptr_x = x_addrs(1)
        do l=1,xmap%size_put1
           pos = xmap%x1_put(l)%pos
           x(l) =  recv_buffer(pos)
        end do
     else
        do l = 1, lsize
           ptr_x = x_addrs(l)
           pos = 0
           do p = 1, comm%nsend
              count = comm%send(p)%count
              ibegin = comm%recv(p)%buffer_pos*lsize + 1
              istart = ibegin + (l-1)*count
              iend = istart + count - 1
              pos = comm%recv(p)%buffer_pos
              do n = istart, iend
                 pos = pos + 1
                 unpack_buffer(pos) = recv_buffer(n)
              enddo
           enddo
           do i=1,xmap%size_put1
              pos = xmap%x1_put(i)%pos
              x(i) =  unpack_buffer(pos)
           end do
        enddo
     endif
  else
     if( lsize == 1) then
        ptr_x = x_addrs(1)
!$OMP parallel do default(none) shared(xmap,recv_buffer,ptr_x) private(pos)
        do l=1,xmap%size_put1
           pos = xmap%x1_put(l)%pos
           x(l) = recv_buffer(3*pos-2) + recv_buffer(3*pos-1)*xmap%x1_put(l)%dj + recv_buffer(3*pos)*xmap%x1_put(l)%di
        end do
     else
!$OMP parallel do default(none) shared(lsize,comm,xmap,recv_buffer,x_addrs) &
!$OMP                          private(ptr_x,pos,ibegin,istart,iend,count,unpack_buffer)
        do l = 1, lsize
           ptr_x = x_addrs(l)
           pos = 0
           ibegin = 1
           do p = 1, comm%nrecv
              count = comm%recv(p)%count*3
              ibegin = comm%recv(p)%buffer_pos*lsize*3 + 1
              istart = ibegin + (l-1)*count
              iend = istart + count - 1
              pos =  comm%recv(p)%buffer_pos*3
              do n = istart, iend
                 pos = pos + 1
                 unpack_buffer(pos) = recv_buffer(n)
              enddo
           enddo
           do i=1,xmap%size_put1
              pos = xmap%x1_put(i)%pos
              x(i) = unpack_buffer(3*pos-2) + unpack_buffer(3*pos-1)*xmap%x1_put(i)%dj + unpack_buffer(3*pos)*xmap%x1_put(i)%di
           end do
        enddo
     endif
  endif

  call mpp_sync_self()
  call mpp_clock_end(id_put_1_to_xgrid_order_2)

end subroutine put_1_to_xgrid_order_2

!#######################################################################

subroutine get_1_from_xgrid(d_addrs, x_addrs, xmap, isize, jsize, xsize, lsize)
  integer(LONG_KIND), dimension(:), intent(in) :: d_addrs
  integer(LONG_KIND), dimension(:), intent(in) :: x_addrs
  type (xmap_type),              intent(inout) :: xmap
  integer,                          intent(in) :: isize, jsize, xsize, lsize

  real, dimension(xmap%size), target :: dg(xmap%size, lsize)
  integer                            :: i, j, l, p, n, m
  integer                            :: msgsize, buffer_pos, pos
  integer                            :: istart, iend, count
  real              , pointer, save  :: dgp =>NULL()
  type  (grid_type) , pointer, save  :: grid1 =>NULL()
  type  (comm_type) , pointer, save  :: comm  =>NULL()
  type(overlap_type), pointer, save  :: send => NULL()
  type(overlap_type), pointer, save  :: recv => NULL()
  real                               :: recv_buffer(xmap%get1%recvsize*lsize*3)
  real                               :: send_buffer(xmap%get1%sendsize*lsize*3)
  real                               :: unpack_buffer(xmap%get1%recvsize*3)
  real                               :: d(isize,jsize)
  real, dimension(xsize)             :: x
  pointer(ptr_d, d)
  pointer(ptr_x, x)

  call mpp_clock_begin(id_get_1_from_xgrid)

  comm => xmap%get1
  grid1 => xmap%grids(1)

  do p = 1, comm%nrecv
     recv => comm%recv(p)
     msgsize = recv%count*lsize
     buffer_pos = recv%buffer_pos*lsize
     call mpp_recv(recv_buffer(buffer_pos+1), glen=msgsize, from_pe = recv%pe, block=.false., tag=COMM_TAG_9)
  enddo

  dg = 0.0;
!$OMP parallel do default(none) shared(lsize,xmap,dg,x_addrs) private(dgp,ptr_x)
  do l = 1, lsize
     ptr_x = x_addrs(l)
     do i=1,xmap%size
        dgp => dg(xmap%x1(i)%pos,l)
        dgp =  dgp + xmap%x1(i)%area*x(i)
     enddo
  enddo


  !--- send the data
  buffer_pos = 0
  istart = 1
  do p = 1, comm%nsend
     send => comm%send(p)
     msgsize = send%count*lsize
     pos = buffer_pos
     istart = send%buffer_pos+1
     iend = istart + send%count - 1
     do l = 1, lsize
        do n = istart, iend
           pos = pos + 1
           send_buffer(pos) = dg(n,l)
        enddo
     enddo
     call mpp_send(send_buffer(buffer_pos+1), plen=msgsize, to_pe = send%pe, tag=COMM_TAG_9 )
     buffer_pos = buffer_pos + msgsize
     istart = iend + 1
  enddo

  call mpp_sync_self(check=EVENT_RECV)

  !--- unpack the buffer
  do l = 1, lsize
     ptr_d = d_addrs(l)
     d = 0.0
  enddo
  !--- To bitwise reproduce old results, first copy the data onto its own pe.

  do p = 1, comm%nrecv
     recv => comm%recv(p)
     count = recv%count
     buffer_pos = recv%buffer_pos*lsize
     if( recv%pe == xmap%me ) then
!$OMP parallel do default(none) shared(lsize,recv,recv_buffer,buffer_pos,d_addrs,count) &
!$OMP                          private(ptr_d,i,j,pos)
        do l = 1, lsize
           pos = buffer_pos + (l-1)*count
           ptr_d = d_addrs(l)
           do n = 1,count
              i = recv%i(n)
              j = recv%j(n)
              pos = pos + 1
              d(i,j) = recv_buffer(pos) 
           enddo
        enddo
        exit
     endif
  enddo

  pos = 0
  do m = 1, comm%nrecv
     p = comm%unpack_ind(m)
     recv => comm%recv(p)
     if( recv%pe == xmap%me ) then
        cycle
     endif
     buffer_pos = recv%buffer_pos*lsize
!$OMP parallel do default(none) shared(lsize,recv,recv_buffer,buffer_pos,d_addrs) &
!$OMP                          private(ptr_d,i,j,pos)
     do l = 1, lsize
        pos = buffer_pos + (l-1)*recv%count
        ptr_d = d_addrs(l)
        do n = 1, recv%count
           i = recv%i(n)
           j = recv%j(n)
           pos = pos + 1
           d(i,j) = d(i,j) + recv_buffer(pos) 
        enddo
     enddo
  enddo

  !
  ! normalize with side 1 grid cell areas
  !
!$OMP parallel do default(none) shared(lsize,d_addrs,grid1) private(ptr_d)
  do l = 1, lsize
     ptr_d = d_addrs(l)
     d = d * grid1%area_inv
  enddo
  call mpp_sync_self()
  call mpp_clock_end(id_get_1_from_xgrid)

end subroutine get_1_from_xgrid

!#######################################################################

subroutine get_1_from_xgrid_repro(d_addrs, x_addrs, xmap, xsize, lsize)
  integer(LONG_KIND), dimension(:), intent(in) :: d_addrs
  integer(LONG_KIND), dimension(:), intent(in) :: x_addrs
  type (xmap_type),              intent(inout) :: xmap
  integer,                          intent(in) :: xsize, lsize

  integer                            :: g, i, j, k, p, l, n, l2, m, l3
  integer                            :: msgsize, buffer_pos, pos
  type (grid_type), pointer, save :: grid =>NULL()
  type(comm_type),  pointer, save :: comm => NULL()
  type(overlap_type), pointer, save  :: send => NULL()
  type(overlap_type), pointer, save  :: recv => NULL()
    integer,  dimension(0:xmap%npes-1) :: pl, ml
  real                               :: recv_buffer(xmap%recv_count_repro_tot*lsize)
  real                               :: send_buffer(xmap%send_count_repro_tot*lsize)
  real                               :: d(xmap%grids(1)%is_me:xmap%grids(1)%ie_me, &
                                          xmap%grids(1)%js_me:xmap%grids(1)%je_me)
  real, dimension(xsize)             :: x
  pointer(ptr_d, d)
  pointer(ptr_x, x)

  call mpp_clock_begin(id_get_1_from_xgrid_repro)
  comm => xmap%get1_repro
  !--- pre-post receiving
  do p = 1, comm%nrecv
     recv => comm%recv(p)
     msgsize = recv%count*lsize
     buffer_pos = recv%buffer_pos*lsize
     call mpp_recv(recv_buffer(buffer_pos+1), glen=msgsize, from_pe = recv%pe, block=.false., tag=COMM_TAG_10)
     n = recv%pe -xmap%root_pe
     pl(n) = buffer_pos 
     ml(n) = recv%count
  enddo

  !pack the data
  send_buffer(:) = 0.0
!$OMP parallel do default(none) shared(lsize,x_addrs,comm,xmap,send_buffer) &
!$OMP                          private(ptr_x,i,j,g,l2,pos,send)
  do p = 1, comm%nsend
     pos = comm%send(p)%buffer_pos*lsize
     send => comm%send(p)
     do l = 1,lsize
        ptr_x = x_addrs(l)
        do n = 1, send%count
           i = send%i(n)
           j = send%j(n)
           g = send%g(n)
           l2 = send%xloc(n)
           pos = pos + 1
           do k =1, xmap%grids(g)%km
             if(xmap%grids(g)%frac_area(i,j,k)/=0.0) then
              l2 = l2+1
              send_buffer(pos) = send_buffer(pos) + xmap%x1(l2)%area *x(l2)
             endif
           enddo
         enddo
      enddo
   enddo

  do p =1, comm%nsend
     buffer_pos = comm%send(p)%buffer_pos*lsize
     msgsize = comm%send(p)%count*lsize
     call mpp_send(send_buffer(buffer_pos+1), plen=msgsize, to_pe=comm%send(p)%pe, tag=COMM_TAG_10)
  enddo

  do l = 1, lsize
     ptr_d = d_addrs(l)
     d = 0
  enddo

  call mpp_sync_self(check=EVENT_RECV)

!$OMP parallel do default(none) shared(lsize,d_addrs,xmap,recv_buffer,pl,ml) &
!$OMP                          private(ptr_d,grid,i,j,p,pos)
  do l = 1, lsize
     ptr_d = d_addrs(l)
     do g=2,size(xmap%grids(:))
        grid => xmap%grids(g)
        do l3=1,grid%size_repro ! index into side1 grid's patterns
           i = grid%x_repro(l3)%i1
           j = grid%x_repro(l3)%j1
           p = grid%x_repro(l3)%pe-xmap%root_pe
           pos = pl(p) + (l-1)*ml(p) + grid%x_repro(l3)%recv_pos
           d(i,j) = d(i,j) + recv_buffer(pos)
        end do
     end do
     ! normalize with side 1 grid cell areas
     d = d * xmap%grids(1)%area_inv
  enddo

  call mpp_sync_self()       

  call mpp_clock_end(id_get_1_from_xgrid_repro)

end subroutine get_1_from_xgrid_repro

!#######################################################################

! <FUNCTION NAME="conservation_check_side1" INTERFACE="conservation_check">
!   <IN NAME="d"  TYPE="real" DIM="(:,:)" > </IN>
!   <IN NAME="grid_id"  TYPE="character(len=3)"  > </IN>
!   <INOUT NAME="xmap"  TYPE="xmap_type"  > </INOUT>
!   <OUT NAME="conservation_check_side1" TYPE="real" DIM="dimension(3)" > </OUT>
!   <IN NAME="remap_method" TYPE="integer,optional"></IN>
! conservation_check - returns three numbers which are the global sum of a
! variable (1) on its home model grid, (2) after interpolation to the other
! side grid(s), and (3) after re_interpolation back onto its home side grid(s).
!
function conservation_check_side1(d, grid_id, xmap,remap_method) ! this one for 1->2->1
real, dimension(:,:),    intent(in   ) :: d
character(len=3),        intent(in   ) :: grid_id
type (xmap_type),        intent(inout) :: xmap
real, dimension(3)                     :: conservation_check_side1
integer, intent(in), optional :: remap_method


  real, dimension(xmap%size) :: x_over, x_back
  real, dimension(size(d,1),size(d,2)) :: d1
  real, dimension(:,:,:), allocatable  :: d2
  integer                              :: g
  type (grid_type), pointer, save      :: grid1 =>NULL(), grid2 =>NULL()

  grid1 => xmap%grids(1)
  conservation_check_side1 = 0.0
  if(grid1%tile_me .NE. tile_nest) conservation_check_side1(1) = sum(grid1%area*d)
!  if(grid1%tile_me .NE. tile_parent .OR. grid1%id .NE. "ATM") &
!      conservation_check_side1(1) = sum(grid1%area*d) 

  call put_to_xgrid (d, grid1%id, x_over, xmap, remap_method)    ! put from side 1
  do g=2,size(xmap%grids(:))
    grid2 => xmap%grids(g)
    if(grid2%on_this_pe) then
      allocate (d2 (grid2%is_me:grid2%ie_me, grid2%js_me:grid2%je_me,  grid2%km) )
    endif
    call get_from_xgrid (d2, grid2%id, x_over, xmap) ! get onto side 2's
    if(grid2%on_this_pe) then
       conservation_check_side1(2) = conservation_check_side1(2) + sum( grid2%area * sum(grid2%frac_area*d2,DIM=3) )
    endif
    call put_to_xgrid (d2, grid2%id, x_back, xmap) ! put from side 2's
    if(allocated(d2))deallocate (d2)
  end do
  call get_from_xgrid(d1, grid1%id, x_back, xmap)  ! get onto side 1
  if(grid1%tile_me .NE. tile_nest) conservation_check_side1(3) = sum(grid1%area*d1)
!  if(grid1%tile_me .NE. tile_parent .OR. grid1%id .NE. "ATM") &
!     conservation_check_side1(3) = sum(grid1%area*d1)
  call mpp_sum(conservation_check_side1,3)

end function conservation_check_side1
! </FUNCTION>

!#######################################################################
!
! conservation_check - returns three numbers which are the global sum of a
! variable (1) on its home model grid, (2) after interpolation to the other
! side grid(s), and (3) after re_interpolation back onto its home side grid(s).
!
! <FUNCTION NAME="conservation_check_side2" INTERFACE="conservation_check">
!   <IN NAME="d"  TYPE="real" DIM="(:,:,:)" > </IN>
!   <IN NAME="grid_id"  TYPE="character(len=3)"  > </IN>
!   <INOUT NAME="xmap"  TYPE="xmap_type"  > </INOUT>
!   <OUT NAME="conservation_check_side2" TYPE="real" DIM="dimension(3)" > </OUT>

function conservation_check_side2(d, grid_id, xmap,remap_method) ! this one for 2->1->2
real, dimension(:,:,:), intent(in   )  :: d
character(len=3),       intent(in   )  :: grid_id
type (xmap_type),       intent(inout)  :: xmap
real, dimension(3)                     :: conservation_check_side2
integer, intent(in), optional :: remap_method


  real, dimension(xmap%size) :: x_over, x_back
  real, dimension(:,:  ), allocatable :: d1
  real, dimension(:,:,:), allocatable :: d2
  integer                             :: g
  type (grid_type), pointer, save     :: grid1 =>NULL(), grid2 =>NULL()

  grid1 => xmap%grids(1)
  conservation_check_side2 = 0.0
  do g = 2,size(xmap%grids(:))
    grid2 => xmap%grids(g)
    if (grid_id==grid2%id) then
      if(grid2%on_this_pe) then
         conservation_check_side2(1) = sum( grid2%area * sum(grid2%frac_area*d,DIM=3) )
      endif
      call put_to_xgrid(d, grid_id, x_over, xmap)  ! put from this side 2
    else
      call put_to_xgrid(0.0 * grid2%frac_area, grid2%id, x_over, xmap) ! zero rest
    end if
  end do

  allocate ( d1(size(grid1%area,1),size(grid1%area,2)) )
  call get_from_xgrid(d1, grid1%id, x_over, xmap)  ! get onto side 1
  if(grid1%tile_me .NE. tile_nest)conservation_check_side2(2) = sum(grid1%area*d1)
  call put_to_xgrid(d1,  grid1%id, x_back, xmap,remap_method)   ! put from side 1
  deallocate ( d1 )

  conservation_check_side2(3) = 0.0;
  do g = 2,size(xmap%grids(:))
    grid2 => xmap%grids(g)
    if(grid2%on_this_pe) then
       allocate ( d2 ( size(grid2%frac_area, 1), size(grid2%frac_area, 2),  &
                                                 size(grid2%frac_area, 3) ) )
    endif
    call get_from_xgrid(d2,  grid2%id, x_back, xmap) ! get onto side 2's
    conservation_check_side2(3) = conservation_check_side2(3) + sum( grid2%area * sum(grid2%frac_area*d2,DIM=3) )
    if(allocated(d2) )deallocate ( d2 )
  end do
  call mpp_sum(conservation_check_side2, 3)  

end function conservation_check_side2
! </FUNCTION>

!******************************************************************************
! This routine is used to get the grid area of component model with id.
subroutine get_xmap_grid_area(id, xmap, area)
  character(len=3),     intent(in   ) :: id
  type (xmap_type),     intent(inout) :: xmap
  real, dimension(:,:), intent(out  ) :: area
  integer                             :: g
  logical                             :: found

   found = .false.
   do g = 1, size(xmap%grids(:))
      if (id==xmap%grids(g)%id ) then
         if(size(area,1) .NE. size(xmap%grids(g)%area,1) .OR. size(area,2) .NE. size(xmap%grids(g)%area,2) ) &
           call error_mesg("xgrid_mod", "size mismatch between area and xmap%grids(g)%area", FATAL)
         area = xmap%grids(g)%area
         found = .true.
         exit
      end if
   end do

   if(.not. found) call error_mesg("xgrid_mod", id//" is not found in xmap%grids id", FATAL)

end subroutine get_xmap_grid_area

!#######################################################################

! This function is used to calculate the gradient along zonal direction.
! Maybe need to setup a limit for the gradient. The grid is assumeed 
! to be regular lat-lon grid

function grad_zonal_latlon(d, lon, lat, is, ie, js, je, isd, jsd) 

  integer,                    intent(in) :: isd, jsd
  real, dimension(isd:,jsd:), intent(in) :: d
  real, dimension(:),         intent(in) :: lon
  real, dimension(:),         intent(in) :: lat
  integer,                    intent(in) :: is, ie, js, je 
  real, dimension(is:ie,js:je)           :: grad_zonal_latlon
  real                                   :: dx, costheta
  integer                                :: i, j, ip1, im1

  !  calculate the gradient of the data on each grid
  do i = is, ie
     if(i == 1) then
        ip1 = i+1; im1 = i
     else if(i==size(lon(:)) ) then
        ip1 = i; im1 = i-1
     else
        ip1 = i+1; im1 = i-1
     endif
     dx = lon(ip1) - lon(im1)
     if(abs(dx).lt.EPS )  call error_mesg('xgrids_mod(grad_zonal_latlon)', 'Improper grid size in lontitude', FATAL)
     if(dx .gt. PI)  dx = dx - 2.0* PI
     if(dx .lt. -PI) dx = dx + 2.0* PI
     do j = js, je
        costheta = cos(lat(j))
        if(abs(costheta) .lt. EPS) call error_mesg('xgrids_mod(grad_zonal_latlon)', 'Improper latitude grid', FATAL)
        grad_zonal_latlon(i,j) = (d(ip1,j)-d(im1,j))/(dx*costheta)
     enddo
  enddo

  return

end function grad_zonal_latlon

!#######################################################################

! This function is used to calculate the gradient along meridinal direction.
! Maybe need to setup a limit for the gradient. regular lat-lon grid are assumed

function grad_merid_latlon(d, lat, is, ie, js, je, isd, jsd) 
  integer,                    intent(in) :: isd, jsd
  real, dimension(isd:,jsd:), intent(in) :: d
  real, dimension(:),         intent(in) :: lat
  integer,                    intent(in) :: is, ie, js, je 
  real, dimension(is:ie,js:je)           :: grad_merid_latlon
  real                                   :: dy
  integer                                :: i, j, jp1, jm1

  !  calculate the gradient of the data on each grid
  do j = js, je
     if(j == 1) then
        jp1 = j+1; jm1 = j
     else if(j == size(lat(:)) ) then
        jp1 = j;   jm1 = j-1
     else
        jp1 = j+1; jm1 = j-1
     endif
     dy = lat(jp1) - lat(jm1)
     if(abs(dy).lt.EPS) call error_mesg('xgrids_mod(grad_merid_latlon)', 'Improper grid size in latitude', FATAL)

     do i = is, ie
        grad_merid_latlon(i,j) = (d(i,jp1) - d(i,jm1))/dy
     enddo
  enddo

  return
end function grad_merid_latlon

!#######################################################################
subroutine get_index_range(xmap, grid_index, is, ie, js, je, km)

  type(xmap_type), intent(in)     :: xmap
  integer, intent(in)             :: grid_index
  integer, intent(out)            :: is, ie, js, je, km

  is = xmap % grids(grid_index) % is_me
  ie = xmap % grids(grid_index) % ie_me
  js = xmap % grids(grid_index) % js_me
  je = xmap % grids(grid_index) % je_me
  km = xmap % grids(grid_index) % km
  
end subroutine get_index_range
!#######################################################################

subroutine stock_move_3d(from, to, grid_index, data, xmap, &
     & delta_t, from_side, to_side, radius, verbose, ier)

  ! this version takes rank 3 data, it can be used to compute the flux on anything but the 
  ! first grid, which typically is on the atmos side.
  ! note that "from" and "to" are optional, the stocks will be subtracted, resp. added, only
  ! if these are present.

  use mpp_mod, only : mpp_sum
  use mpp_domains_mod, only : domain2D, mpp_redistribute, mpp_get_compute_domain

  type(stock_type), intent(inout), optional :: from, to
  integer, intent(in)             :: grid_index        ! grid index
  real, intent(in)                :: data(:,:,:)  ! data array is 3d
  type(xmap_type), intent(in)     :: xmap
  real, intent(in)                :: delta_t
  integer, intent(in)             :: from_side, to_side ! ISTOCK_TOP, ISTOCK_BOTTOM, or ISTOCK_SIDE
  real, intent(in)                :: radius       ! earth radius
  character(len=*), intent(in), optional      :: verbose
  integer, intent(out)            :: ier

  real    :: from_dq, to_dq

  ier = 0
  if(grid_index == 1) then
     ! data has rank 3 so grid index must be > 1
     ier = 1
     return
  endif

  if(.not. associated(xmap%grids) ) then
     ier = 2
     return
  endif

     from_dq = delta_t * 4.0*PI*radius**2 * sum( sum(xmap%grids(grid_index)%area * &
          & sum(xmap%grids(grid_index)%frac_area * data, DIM=3), DIM=1))
     to_dq = from_dq

  ! update only if argument is present.
  if(present(to  )) to   % dq(  to_side) = to   % dq(  to_side) + to_dq
  if(present(from)) from % dq(from_side) = from % dq(from_side) - from_dq

  if(present(verbose).and.debug_stocks) then
     call mpp_sum(from_dq)
     call mpp_sum(to_dq)
     from_dq = from_dq/(4.0*PI*radius**2)
     to_dq   = to_dq  /(4.0*PI*radius**2)
     if(mpp_pe()==mpp_root_pe()) then
        write(stocks_file,'(a,es19.12,a,es19.12,a)') verbose, from_dq,' [*/m^2]'
     endif
  endif

end subroutine stock_move_3d

!...................................................................

subroutine stock_move_2d(from, to, grid_index, data, xmap, &
     & delta_t, from_side, to_side, radius, verbose, ier)

  ! this version takes rank 2 data, it can be used to compute the flux on the atmos side
  ! note that "from" and "to" are optional, the stocks will be subtracted, resp. added, only
  ! if these are present.

  use mpp_mod, only : mpp_sum
  use mpp_domains_mod, only : domain2D, mpp_redistribute, mpp_get_compute_domain

  type(stock_type), intent(inout), optional :: from, to
  integer, optional, intent(in)   :: grid_index
  real, intent(in)                :: data(:,:)    ! data array is 2d
  type(xmap_type), intent(in)     :: xmap
  real, intent(in)                :: delta_t
  integer, intent(in)             :: from_side, to_side ! ISTOCK_TOP, ISTOCK_BOTTOM, or ISTOCK_SIDE
  real, intent(in)                :: radius       ! earth radius
  character(len=*), intent(in)    :: verbose
  integer, intent(out)            :: ier

  real    :: to_dq, from_dq

  ier = 0

  if(.not. associated(xmap%grids) ) then
     ier = 3
     return
  endif

  if( .not. present(grid_index) .or. grid_index==1 ) then

     ! only makes sense if grid_index == 1
     from_dq = delta_t * 4.0*PI*radius**2 * sum(sum(xmap%grids(1)%area * data, DIM=1))
     to_dq = from_dq

  else

     ier = 4
     return

  endif

  ! update only if argument is present.
  if(present(to  )) to   % dq(  to_side) = to   % dq(  to_side) + to_dq
  if(present(from)) from % dq(from_side) = from % dq(from_side) - from_dq

  if(debug_stocks) then
     call mpp_sum(from_dq)
     call mpp_sum(to_dq)
     from_dq = from_dq/(4.0*PI*radius**2)
     to_dq   = to_dq  /(4.0*PI*radius**2)
     if(mpp_pe()==mpp_root_pe()) then
        write(stocks_file,'(a,es19.12,a,es19.12,a)') verbose, from_dq,' [*/m^2]'
     endif
  endif

end subroutine stock_move_2d

!#######################################################################
subroutine stock_integrate_2d(data, xmap, delta_t, radius, res, ier)

  ! surface/time integral of a 2d array

  use mpp_mod, only : mpp_sum

  real, intent(in)                :: data(:,:)    ! data array is 2d
  type(xmap_type), intent(in)     :: xmap
  real, intent(in)                :: delta_t
  real, intent(in)                :: radius       ! earth radius
  real, intent(out)               :: res
  integer, intent(out)            :: ier

  ier = 0
  res = 0.0

  if(.not. associated(xmap%grids) ) then
     ier = 6
     return
  endif

  res = delta_t * 4.0*PI*radius**2 * sum(sum(xmap%grids(1)%area * data, DIM=1))

end subroutine stock_integrate_2d
!#######################################################################

!#######################################################################



subroutine stock_print(stck, Time, comp_name, index, ref_value, radius, pelist)

  use mpp_mod, only : mpp_pe, mpp_root_pe, mpp_sum
  use time_manager_mod, only : time_type, get_time
  use diag_manager_mod, only : register_diag_field,send_data

  type(stock_type), intent(in)  :: stck
  type(time_type), intent(in)   :: Time
  character(len=*)              :: comp_name
  integer, intent(in)           :: index     ! to map stock element (water, heat, ..) to a name
  real, intent(in)              :: ref_value ! the stock value returned by the component per PE
  real, intent(in)              :: radius
  integer, intent(in), optional :: pelist(:)

  integer, parameter :: initID = -2 ! initial value for diag IDs. Must not be equal to the value 
  ! that register_diag_field returns when it can't register the filed -- otherwise the registration 
  ! is attempted every time this subroutine is called

  real :: f_value, c_value, planet_area
  character(len=80) :: formatString
  integer :: iday, isec, hours
  integer :: diagID, compInd
  integer, dimension(NELEMS,4), save :: f_valueDiagID = initID
  integer, dimension(NELEMS,4), save :: c_valueDiagID = initID
  integer, dimension(NELEMS,4), save :: fmc_valueDiagID = initID

  real :: diagField
  logical :: used
  character(len=30) :: field_name, units

  f_value = sum(stck % dq)
  c_value = ref_value      - stck % q_start
  if(present(pelist)) then
     call mpp_sum(f_value, pelist=pelist)
     call mpp_sum(c_value, pelist=pelist)
  else
     call mpp_sum(f_value)
     call mpp_sum(c_value)
  endif

  if(mpp_pe() == mpp_root_pe()) then
     ! normalize to 1 earth m^2
     planet_area = 4.0*PI*radius**2
     f_value       = f_value     / planet_area
     c_value       = c_value     / planet_area

     if(comp_name == 'ATM') compInd = 1
     if(comp_name == 'LND') compInd = 2
     if(comp_name == 'ICE') compInd = 3
     if(comp_name == 'OCN') compInd = 4


     if(f_valueDiagID(index,compInd) == initID) then
        field_name = trim(comp_name) // trim(STOCK_NAMES(index))
        field_name  = trim(field_name) // 'StocksChange_Flux'
        units = trim(STOCK_UNITS(index))
        f_valueDiagID(index,compInd) = register_diag_field('stock_print', field_name, Time, &
             units=units)
     endif

     if(c_valueDiagID(index,compInd) == initID) then
        field_name = trim(comp_name) // trim(STOCK_NAMES(index))
        field_name = trim(field_name) // 'StocksChange_Comp'
        units = trim(STOCK_UNITS(index))
        c_valueDiagID(index,compInd) = register_diag_field('stock_print', field_name, Time, &
             units=units)
     endif

     if(fmc_valueDiagID(index,compInd) == initID) then
        field_name = trim(comp_name) // trim(STOCK_NAMES(index))
        field_name = trim(field_name) // 'StocksChange_Diff'
        units = trim(STOCK_UNITS(index))
        fmc_valueDiagID(index,compInd) = register_diag_field('stock_print', field_name, Time, &
             units=units)
     endif

     DiagID=f_valueDiagID(index,compInd)
     diagField = f_value
     if (DiagID > 0)  used = send_data(DiagID, diagField, Time)
     DiagID=c_valueDiagID(index,compInd)
     diagField = c_value
     if (DiagID > 0)  used = send_data(DiagID, diagField, Time)
     DiagID=fmc_valueDiagID(index,compInd)
     diagField = f_value-c_value
     if (DiagID > 0)  used = send_data(DiagID, diagField, Time)


     call get_time(Time, isec, iday)
     hours = iday*24 + isec/3600
     formatString = '(a,a,a,i16,2x,es22.15,2x,es22.15,2x,es22.15)'
     write(stocks_file,formatString) trim(comp_name),STOCK_NAMES(index),STOCK_UNITS(index) &
          ,hours,f_value,c_value,f_value-c_value

  endif


end subroutine stock_print


!###############################################################################
 function is_lat_lon(lon, lat)
    real, dimension(:,:), intent(in) :: lon, lat
    logical                          :: is_lat_lon
    integer                          :: i, j, nlon, nlat, num

    is_lat_lon = .true.
    nlon = size(lon,1)
    nlat = size(lon,2)
    LOOP_LAT: do j = 1, nlat
       do i = 2, nlon
          if(lat(i,j) .NE. lat(1,j)) then
             is_lat_lon = .false.
             exit LOOP_LAT
          end if
       end do
    end do LOOP_LAT

    if(is_lat_lon) then
       LOOP_LON: do i = 1, nlon
          do j = 2, nlat
             if(lon(i,j) .NE. lon(i,1)) then
                is_lat_lon = .false.
                exit LOOP_LON
             end if
          end do
       end do LOOP_LON
    end if

    num = 0
    if(is_lat_lon) num = 1
    call mpp_min(num)
    if(num == 1) then
       is_lat_lon = .true.
    else
       is_lat_lon = .false.
    end if

    return
 end function is_lat_lon


end module xgrid_mod


! <INFO>

!   <REFERENCE>   
!      A <LINK SRC="http://www.gfdl.noaa.gov/~mw/docs/grid_coupling.html"> guide </LINK>to grid coupling in FMS.
!   </REFERENCE>
!   <REFERENCE>
!      A simple xgrid <LINK SRC="http://www.gfdl.gov/~mw/docs/xgrid_example.f90.txt"> example. </LINK>
!   </REFERENCE>

! </INFO>


!======================================================================================
! standalone unit test


#ifdef _XGRID_MAIN
! to compile on Altix:
! setenv FMS /net2/ap/regression/ia64/10-Aug-2006/CM2.1U_Control-1990_E1.k_dyn30pe/exec
! ifort -fpp -r8 -i4 -g -check all -D_XGRID_MAIN -I $FMS xgrid.f90 $FMS/stock_constants.o $FMS/fms*.o $FMS/mpp*.o $FMS/constants.o $FMS/time_manager.o $FMS/memutils.o $FMS/threadloc.o -L/usr/local/lib -lnetcdf -L/usr/lib -lmpi -lsma
! mpirun -np 30 a.out
program main
  use mpp_mod
  use fms_mod
  use mpp_domains_mod
  use xgrid_mod, only : xmap_type, setup_xmap, stock_move, stock_type, get_index_range
  use stock_constants_mod, only : ISTOCK_TOP, ISTOCK_BOTTOM, ISTOCK_SIDE, ISTOCK_WATER, ISTOCK_HEAT, NELEMS
  use constants_mod, only       : PI
  implicit none

  type(xmap_type)  :: xmap_sfc, xmap_runoff
  integer          :: npes, pe, root, i, nx, ny, ier
  integer          :: patm_beg, patm_end, pocn_beg, pocn_end
  integer          :: is, ie, js, je, km, index_ice, index_lnd
  integer          :: layout(2)
  type(stock_type), save :: Atm_stock(NELEMS), Ice_stock(NELEMS), &
       &                    Lnd_stock(NELEMS), Ocn_stock(NELEMS)
  type(domain2D)   :: Atm_domain, Ice_domain, Lnd_domain, Ocn_domain
  logical, pointer :: maskmap(:,:)
  real, allocatable :: data2d(:,:), data3d(:,:,:)
  real              :: dt, dq_tot_atm, dq_tot_ice, dq_tot_lnd, dq_tot_ocn



  call fms_init

  npes   = mpp_npes()
  pe     = mpp_pe()
  root   = mpp_root_pe()
  patm_beg = 0
  patm_end = npes/2 - 1
  pocn_beg = patm_end + 1
  pocn_end = npes - 1

  if(npes /= 30) call mpp_error(FATAL,'must run unit test on 30 pes')

  call mpp_domains_init ! (MPP_DEBUG)

  call mpp_declare_pelist( (/ (i, i=patm_beg, patm_end) /), 'atm_lnd_ice pes' ) 
  call mpp_declare_pelist( (/ (i, i=pocn_beg, pocn_end) /), 'ocn pes' ) 

  index_ice = 2 ! 2nd exchange grid
  index_lnd = 3 ! 3rd exchange grid

  dt = 1.0

  if(pe < 15) then

     call mpp_set_current_pelist( (/ (i, i=patm_beg, patm_end) /) )

     ! Lnd
     nx = 144
     ny = 90
     layout = (/ 5, 3 /)
     call mpp_define_domains( (/1,nx, 1,ny/), layout, Lnd_domain, &
          & xflags = CYCLIC_GLOBAL_DOMAIN, name = 'LAND MODEL' )

     ! Atm
     nx = 144
     ny = 90
     layout = (/1, 15/)
     call mpp_define_domains( (/1,nx, 1,ny/), layout, Atm_domain)

     ! Ice
     nx = 360
     ny = 200
     layout = (/15, 1/)
     call mpp_define_domains( (/1,nx, 1,ny/), layout, Ice_domain, name='ice_nohalo' )

     ! Build exchange grid
     call setup_xmap(xmap_sfc, (/ 'ATM', 'OCN', 'LND' /), &
          &                    (/ Atm_domain, Ice_domain, Lnd_domain /), &
          &                    "INPUT/grid_spec.nc")

!  call setup_xmap(xmap_sfc, (/ 'LND', 'OCN' /), &
!       &                    (/  Lnd_domain, Ice_domain /), &
!       &                    "INPUT/grid_spec.nc")


     ! Atm -> Ice

     i = index_ice

     call get_index_range(xmap=xmap_sfc, grid_index=i, is=is, ie=ie, js=js, je=je, km=km)

     allocate(data3d(is:ie, js:je, km))
     data3d(:,:,1   ) = 1.0/(4.0*PI)
     data3d(:,:,2:km) = 0.0
     call stock_move(from=Atm_stock(ISTOCK_WATER), to=Ice_stock(ISTOCK_WATER), &
          & grid_index=i, data=data3d, xmap=xmap_sfc, &
          & delta_t=dt, from_side=ISTOCK_BOTTOM, to_side=ISTOCK_TOP, radius=1.0, ier=ier)
     deallocate(data3d)

     ! Atm -> Lnd

     i = index_lnd

     call get_index_range(xmap=xmap_sfc, grid_index=i, is=is, ie=ie, js=js, je=je, km=km)
     
     allocate(data3d(is:ie, js:je, km))
     data3d(:,:,1   ) = 1.0/(4.0*PI)
     data3d(:,:,2:km) = 0.0
     call stock_move(from=Atm_stock(ISTOCK_WATER), to=Lnd_stock(ISTOCK_WATER), &
          & grid_index=i, data=data3d, xmap=xmap_sfc, &
          & delta_t=dt, from_side=ISTOCK_BOTTOM, to_side=ISTOCK_TOP, radius=1.0, ier=ier)
     deallocate(data3d)

  else ! pes: 15...29

     call mpp_set_current_pelist( (/ (i, i=pocn_beg, pocn_end) /) )

     ! Ocn
     nx = 360
     ny = 200
     layout = (/ 5, 3 /)
     call mpp_define_domains( (/1,nx,1,ny/), layout, Ocn_domain, name='ocean model')

  endif

  ! Ice -> Ocn (same grid different layout)

  i = index_ice

  if( pe < pocn_beg ) then 

     call get_index_range(xmap=xmap_sfc, grid_index=i, is=is, ie=ie, js=js, je=je, km=km)

     allocate(data3d(is:ie, js:je, km))
     data3d(:,:,1   ) = 1.0/(4.0*PI)
     data3d(:,:,2:km) = 0.0
  else
     is = 0
     ie = 0
     js = 0
     je = 0
     km = 0
     allocate(data3d(is:ie, js:je, km))
  endif

  call stock_move(from=Ice_stock(ISTOCK_WATER), to=Ocn_stock(ISTOCK_WATER), &
       & grid_index=i, data=data3d(:,:,1), xmap=xmap_sfc, &
       & delta_t=dt, from_side=ISTOCK_BOTTOM, to_side=ISTOCK_TOP, radius=1.0, ier=ier)
  deallocate(data3d)

  ! Sum across sides and PEs

  dq_tot_atm = sum(Atm_stock(ISTOCK_WATER)%dq)
  call mpp_sum(dq_tot_atm)

  dq_tot_lnd = sum(Lnd_stock(ISTOCK_WATER)%dq)
  call mpp_sum(dq_tot_lnd)

  dq_tot_ice = sum(Ice_stock(ISTOCK_WATER)%dq)
  call mpp_sum(dq_tot_ice)

  dq_tot_ocn = sum(Ocn_stock(ISTOCK_WATER)%dq)
  call mpp_sum(dq_tot_ocn)

  if(pe==root) then
     write(*,'(a,4f10.7,a,e10.2)') ' Total delta_q(water) Atm/Lnd/Ice/Ocn: ', &
          & dq_tot_atm, dq_tot_lnd, dq_tot_ice, dq_tot_ocn, &
          & ' residue: ', dq_tot_atm + dq_tot_lnd + dq_tot_ice + dq_tot_ocn
  endif

 
end program main
! end of _XGRID_MAIN
#endif

module climap_albedo_mod

!=======================================================================
!
!  Routines for obtaining land surface albedos from the CLIMAP data set
!
!=======================================================================

use  horiz_interp_mod, only:  horiz_interp

use           fms_mod, only:  open_ieee32_file, &
                              error_mesg, FATAL, file_exist,  &
                              check_nml_error, open_namelist_file,     &
                              close_file, mpp_pe, mpp_root_pe, &
                              write_version_number, stdlog, read_data, &
                              NOTE, mpp_error
use     constants_mod, only:  PI

implicit none
private

!=======================================================================

    public  get_climap_albedo,     get_climap_glacier
    public  get_climap_albedo_mcm, get_climap_glacier_mcm

!--------------------- version number ----------------------------------

character(len=128) :: version = '$Id: climap_albedo.F90,v 15.0 2007/08/14 04:00:26 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
logical :: do_init = .true.

!=======================================================================

CONTAINS

!#######################################################################

subroutine get_climap_albedo (lonb, latb, n, albedo)

real   , intent(in) , dimension(:,:) :: lonb, latb
integer, intent(in)                  :: n
real   , intent(out), dimension(:,:) :: albedo
  
integer, parameter :: nlon = 180, nlat = 90

real :: pi, sb, wb, dx, dy
real, dimension(nlon, nlat) :: alb
integer :: unit, nn
character(len=32) :: lvltag
!------- write version number and namelist ---------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
      endif
   do_init = .false.


pi = 4.0*atan(1.0)
sb = -pi/2.0               ! southern boundary of albedo data grid
wb = 0.0                   ! western  boundary of albedo data grid
dx = 2.0*pi/float(nlon)    ! longitudinal grid size of albedo data grid
dy = pi/float(nlat)        ! latitudinal  grid size of albedo data grid

if(n < 10)  write(lvltag, 1201) n
if(n >= 10) write(lvltag, 1202) n
if(n >= 100) write(lvltag, 1203) n
1201 format(i1)
1202 format(i2)
1203 format(i3)
if (file_exist('INPUT/albedo.data.nc') ) then
   if (mpp_pe() == mpp_root_pe()) call mpp_error ('climap_albedo_mod', &
            'Reading NetCDF formatted input data file: INPUT/albedo.data.nc', NOTE)
    call read_data('INPUT/albedo.data.nc', 'albedo_'//trim(lvltag), alb, no_domain=.true.)
    call horiz_interp_wrapper (alb,wb,sb,dx,dy,lonb,latb,albedo)
else
   if (file_exist('INPUT/albedo.data')) then
!    unit = open_file (file='INPUT/albedo.data',  &
!                      form='ieee32', action='read')
      if (mpp_pe() == mpp_root_pe()) call mpp_error ('climap_albedo_mod', &
            'Reading native formatted input data file: INPUT/albedo.data', NOTE)
      unit = open_ieee32_file (file='INPUT/albedo.data', action='read')
      do nn = 1, n
         read (unit,end=99,err=98)  alb
      end do
      call horiz_interp_wrapper (alb,wb,sb,dx,dy,lonb,latb,albedo)
      call close_file (unit)
   else
      call error_mesg ('get_climap_albedos',  &
           'eof, albedo.data file does not exist?', FATAL)
   endif
endif

return

!-----------------------------------------------------------------------
  98  call error_mesg ('get_climap_albedos',  &
                       'error in reading albedo.data file', FATAL)

  99  call error_mesg ('get_climap_albedos',  &
                'unexpected EOR when reading albedo.data file', FATAL)
!-----------------------------------------------------------------------

end subroutine get_climap_albedo

!#######################################################################

subroutine get_climap_glacier (lonb, latb, crit_albedo, glacier)

real, intent(in), dimension(:,:)     :: lonb, latb
real, intent(in)                     :: crit_albedo
logical, intent(out), dimension(:,:) :: glacier

real, dimension(size(lonb,1)-1,size(latb,2)-1) :: alb_dry

!----- read third record (max snow albedo) ------

call get_climap_albedo(lonb, latb, 3, alb_dry)

glacier = .false.
where(alb_dry >= crit_albedo) glacier = .true.

return

end subroutine get_climap_glacier

!#######################################################################

subroutine get_climap_albedo_mcm (lonb, latb, nlong, nlatg, is, ie, js, je, n, &
                                  albedo)

real   , intent(in) , dimension(:,:) :: lonb, latb
integer, intent(in)                  :: nlong, nlatg, is, ie, js, je, n
real   , intent(out), dimension(:,:) :: albedo
  
real :: pi, sb, wb, dx, dy
real, dimension(nlong, nlatg) :: alb
integer :: unit, nn, i, j

!--- write version id to logfile ---
if (do_init) then
   if (mpp_pe() == mpp_root_pe()) &
   call write_version_number(version, tagname)
   do_init = .false.


endif
if (file_exist('INPUT/ss_albedo.data')) then
!    unit = open_file (file='INPUT/ss_albedo.data',form='ieee32', action='read')
    unit = open_ieee32_file (file='INPUT/ss_albedo.data', action='read')
    do nn = 1, n
      read (unit,end=99,err=98)  alb
    end do
    do j=js,je
     do i=is,ie
      albedo(i-is+1,j-js+1) = alb(i,j)
     enddo
    enddo
    call close_file (unit)

else
    call error_mesg ('get_climap_albedo_mcm',  &
           'eof, ss_albedo.data file does not exist?', FATAL)
endif

return

!-----------------------------------------------------------------------
  98  call error_mesg ('get_climap_albedo_mcm',  &
                       'error in reading ss_albedo.data file', FATAL)

  99  call error_mesg ('get_climap_albedo_mcm',  &
                'unexpected EOR when reading ss_albedo.data file', FATAL)
!-----------------------------------------------------------------------

end subroutine get_climap_albedo_mcm

!#######################################################################

subroutine get_climap_glacier_mcm (lonb, latb, nlong, nlatg, is, ie, js, je, &
                                  crit_albedo, glacier)

real   , intent(in), dimension(:,:)     :: lonb, latb
integer, intent(in)                     :: nlong, nlatg, is, ie, js, je
real   , intent(in)                     :: crit_albedo
logical, intent(out), dimension(:,:)    :: glacier

real, dimension(size(lonb,1)-1,size(latb,2)-1) :: alb_dry

!----- read albedo ------

call get_climap_albedo_mcm(lonb, latb, nlong, nlatg, is, ie, js, je, 1, alb_dry)

glacier = .false.
where(alb_dry >= crit_albedo) glacier = .true.

return

end subroutine get_climap_glacier_mcm

!#######################################################################

subroutine horiz_interp_wrapper (data_in, wb, sb, dx, dy, lonb_out, latb_out, data_out)
real   , intent(in),  dimension(:,:) :: data_in, lonb_out, latb_out
real   , intent(in)                  :: wb, sb, dx, dy
real   , intent(out), dimension(:,:) :: data_out
real    :: lonb_in(size(data_in,1)+1), latb_in(size(data_in,2)+1), tpi
integer :: i, j, nx, ny

     nx = size(data_in,1)
     ny = size(data_in,2)
     tpi = 2.*PI

     ! longitude boundaries
     do i = 1, nx+1
       lonb_in(i) = wb + float(i-1)*dx
     enddo
       if (abs(lonb_in(nx+1)-lonb_in(1)-tpi) < epsilon(lonb_in)) &
               lonb_in(nx+1)=lonb_in(1)+tpi

     ! latitude boundaries
     do j = 2, ny
       latb_in(j) = sb + float(j-1)*dy
     enddo
       latb_in(1)    = -0.5*PI
       latb_in(ny+1) =  0.5*PI

     call horiz_interp (data_in, lonb_in, latb_in, &
                                 lonb_out, latb_out, data_out)

end subroutine horiz_interp_wrapper

!#######################################################################

end module climap_albedo_mod

module land_data_mod

use mpp_mod           , only : mpp_get_current_pelist, mpp_pe
use constants_mod     , only : PI
use mpp_domains_mod   , only : domain2d, mpp_get_compute_domain, &
     mpp_define_layout, mpp_define_domains, mpp_define_io_domain, &
     mpp_get_current_ntile, mpp_get_tile_id, CYCLIC_GLOBAL_DOMAIN, &
     mpp_get_io_domain, mpp_get_pelist, mpp_get_layout
use mpp_mod,            only : mpp_chksum
use fms_mod           , only : write_version_number, mpp_npes, &
                               error_mesg, FATAL, stdout
use time_manager_mod  , only : time_type
use tracer_manager_mod, only : register_tracers, get_tracer_index, NO_TRACER
use field_manager_mod , only : MODEL_LAND
use grid_mod          , only : get_grid_ntiles, get_grid_size, get_grid_cell_vertices, &
     get_grid_cell_centers, get_grid_cell_area, get_grid_comp_area, &
     define_cube_mosaic
use land_tile_mod     , only : land_tile_type, land_tile_list_type, &
     land_tile_list_init, land_tile_list_end, nitems

implicit none
private

! ==== public interfaces =====================================================
public :: land_data_init
public :: land_data_end
public :: lnd            ! global data 

public :: atmos_land_boundary_type ! container for information passed from the 
                         ! atmosphere to land
public :: land_data_type ! container for information passed from land to 
                         ! the atmosphere
! both hold information on land grid (that is, after flux exchange translated 
! it from the atmosphere)
public land_data_type_chksum    ! routine to print checksums for land_data_type
public atm_lnd_bnd_type_chksum  ! routine to print checksums for atmos_land_boundary_type

public :: dealloc_land2cplr ! deallocates a land_data_type structure
public :: realloc_land2cplr ! allocates a land_data_type members for current 
                            ! number of tiles
public :: dealloc_cplr2land ! deallocates an atmos_land_boundary_type structure
public :: realloc_cplr2land ! allocates an atmos_land_boundary_type members 
                            ! for current number of tiles
! NOTE: realloc_* procedures can be called regardless of the current state
! of the argument data structures, since they deallocate data first.

public :: land_state_type
! ==== end of public interfaces ==============================================

! ---- module constants ------------------------------------------------------
character(len=*), parameter :: &
     module_name = 'land_data_mod', &
     version     = '$Id: land_data.F90,v 20.0 2013/12/13 23:29:24 fms Exp $', &
     tagname     = '$Name: tikal $'

! init_value is used to fill most of the allocated boundary condition arrays.
! It is supposed to be double-precision signaling NaN, to trigger a trap when
! the program is compiled with trapping non-initialized values.  
! See http://ftp.uniovi.es/~antonio/uned/ieee754/IEEE-754references.html
real, parameter :: init_value = Z'FFF0000000000001'

! ---- types -----------------------------------------------------------------
type :: atmos_land_boundary_type
   ! data passed from the coupler to the surface
   real, dimension(:,:,:), pointer :: & ! (lon, lat, tile)
        t_flux    => NULL(), &   ! sensible heat flux, W/m2
        lw_flux   => NULL(), &   ! net longwave radiation flux, W/m2
        lwdn_flux => NULL(), &   ! downward longwave radiation flux, W/m2
        sw_flux   => NULL(), &   ! net shortwave radiation flux, W/m2
        swdn_flux => NULL(), &   ! downward shortwave radiation flux, W/m2
        lprec     => NULL(), &   ! liquid precipitation rate, kg/(m2 s)
        fprec     => NULL(), &   ! frozen precipitation rate, kg/(m2 s)
        tprec     => NULL(), &   ! temperature of precipitation, degK
   ! components of downward shortwave flux, W/m2  
        sw_flux_down_vis_dir   => NULL(), & ! visible direct 
        sw_flux_down_total_dir => NULL(), & ! total direct
        sw_flux_down_vis_dif   => NULL(), & ! visible diffuse
        sw_flux_down_total_dif => NULL(), & ! total diffuse
   ! derivatives of the fluxes
        dhdt      => NULL(), &   ! sensible w.r.t. surface temperature
        dhdq      => NULL(), &   ! sensible w.r.t. surface humidity
        drdt      => NULL(), &   ! longwave w.r.t. surface radiative temperature 
   !
        cd_m      => NULL(), &   ! drag coefficient for momentum, dimensionless
        cd_t      => NULL(), &   ! drag coefficient for tracers, dimensionless
        ustar     => NULL(), &   ! turbulent wind scale, m/s
        bstar     => NULL(), &   ! turbulent buoyancy scale, m/s
        wind      => NULL(), &   ! abs wind speed at the bottom of the atmos, m/s
        z_bot     => NULL(), &   ! height of the bottom atmospheric layer above the surface, m
        drag_q    => NULL(), &   ! product of cd_q by wind
        p_surf    => NULL()      ! surface pressure, Pa

   real, dimension(:,:,:,:), pointer :: & ! (lon, lat, tile, tracer)
        tr_flux => NULL(),   &   ! tracer flux, including water vapor flux
        dfdtr   => NULL()        ! derivative of the flux w.r.t. tracer surface value, 
                                 ! including evap over surface specific humidity

   integer :: xtype             !REGRID, REDIST or DIRECT
end type atmos_land_boundary_type


type :: land_data_type
   ! data passed from the surface to the coupler
   logical :: pe ! data presence indicator for stock calculations
   real, pointer, dimension(:,:,:)   :: &  ! (lon, lat, tile)
        tile_size      => NULL(),  & ! fractional coverage of cell by tile, dimensionless
        t_surf         => NULL(),  & ! ground surface temperature, degK
        t_ca           => NULL(),  & ! canopy air temperature, degK
        albedo         => NULL(),  & ! broadband land albedo [unused?]
        albedo_vis_dir => NULL(),  & ! albedo for direct visible radiation
        albedo_nir_dir => NULL(),  & ! albedo for direct NIR radiation 
        albedo_vis_dif => NULL(),  & ! albedo for diffuse visible radiation 
        albedo_nir_dif => NULL(),  & ! albedo for diffuse NIR radiation
        rough_mom      => NULL(),  & ! surface roughness length for momentum, m
        rough_heat     => NULL(),  & ! roughness length for tracers and heat, m
        rough_scale    => NULL()     ! topographic scaler for momentum drag, m

   real, pointer, dimension(:,:,:,:)   :: &  ! (lon, lat, tile, tracer)
        tr    => NULL()              ! tracers, including canopy air specific humidity

   ! NOTE that in contrast to most of the other fields in this structure, the discharges
   ! hold data per-gridcell, rather than per-tile basis. This, and the order of updates,
   ! have implications for the data reallocation procedure.
   real, pointer, dimension(:,:) :: &  ! (lon, lat)
     discharge           => NULL(),  & ! liquid water flux from land to ocean
     discharge_heat      => NULL(),  & ! sensible heat of discharge (0 C datum)
     discharge_snow      => NULL(),  & ! solid water flux from land to ocean
     discharge_snow_heat => NULL()     ! sensible heat of discharge_snow (0 C datum)

   logical, pointer, dimension(:,:,:):: &
        mask => NULL()               ! true if land

   integer :: axes(2)        ! IDs of diagnostic axes
   type(domain2d) :: domain  ! our computation domain
   logical, pointer :: maskmap(:,:) 
   integer, pointer, dimension(:) :: pelist
end type land_data_type


! land_state_type combines the general information about state of the land model:
! domain, coordinates, time steps, etc. There is only one variable of this type,
! and it is public in this module.
type :: land_state_type
   integer        :: is,ie,js,je ! compute domain boundaries
   integer        :: nlon,nlat   ! size of global grid
   integer        :: ntprog      ! number of prognostic tracers
   integer        :: isphum      ! index of specific humidity in tracer table
   integer        :: ico2        ! index of carbon dioxide in tracer table
   type(time_type):: dt_fast     ! fast (physical) time step
   type(time_type):: dt_slow     ! slow time step
   type(time_type):: time        ! current time

   real, pointer  :: lon (:,:), lat (:,:) ! domain grid center coordinates, radian
   real, pointer  :: lonb(:,:), latb(:,:) ! domain grid vertices, radian
   real, pointer  :: area(:,:)  ! land area per grid cell, m2
   real, pointer  :: cellarea(:,:)  ! grid cell area, m2
   real, pointer  :: coord_glon(:), coord_glonb(:) ! longitudes for use in diag axis and such, degrees East
   real, pointer  :: coord_glat(:), coord_glatb(:) ! latitudes for use in diag axis and such, degrees North

   ! map of tiles
   type(land_tile_list_type), pointer :: tile_map(:,:)
   
   type(domain2d) :: domain ! our domain -- should be the last since it simplifies
                            ! debugging in totalview
   integer :: nfaces ! number of mosaic faces
   integer :: face  ! the current mosaic face
   integer, allocatable :: pelist(:) ! list of processors that run land model
   integer, allocatable :: io_pelist(:) ! list of processors in our io_domain
   ! if io_domain was not defined, then there is just one element in this
   ! array, and it's equal to current PE
   integer :: io_id     ! suffix in the distributed files.
   logical :: append_io_id ! if FALSE, io_id is not appended to the file names
                           ! (for the case io_layout = 1,1)
end type land_state_type

! ---- public module variables -----------------------------------------------
type(land_state_type),save :: lnd


! ---- private module variables ----------------------------------------------
logical :: module_is_initialized =.FALSE.


#define __DEALLOC__(x) if (associated(x)) deallocate(x)

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-



! ============================================================================
subroutine land_data_init(layout, io_layout, time, dt_fast, dt_slow)
  integer, intent(inout) :: layout(2) ! layout of our domains
  integer, intent(inout) :: io_layout(2) ! layout for land model io
  type(time_type), intent(in) :: &
       time,    & ! current model time
       dt_fast, & ! fast (physical) time step
       dt_slow    ! slow time step

  ! ---- local vars
  integer :: nlon, nlat ! size of global grid in lon and lat directions
  integer :: ntiles     ! number of tiles in the mosaic grid 
  integer :: ntracers, ndiag ! non-optional output from register_tracers
  integer, allocatable :: tile_ids(:) ! mosaic tile IDs for the current PE
  integer :: i,j
  type(domain2d), pointer :: io_domain ! our io_domain
  integer :: n_io_pes(2) ! number of PEs in our io_domain along x and y
  integer :: io_id(1)

  ! write the version and tag name to the logfile
  call write_version_number(version, tagname)

  ! define the processor layout information according to the global grid size 
  call get_grid_ntiles('LND',ntiles)
  lnd%nfaces = ntiles
  call get_grid_size('LND',1,nlon,nlat)
  ! set the size of global grid
  lnd%nlon = nlon; lnd%nlat = nlat
  if( layout(1)==0 .AND. layout(2)==0 ) &
       call mpp_define_layout( (/1,nlon,1,nlat/), mpp_npes()/ntiles, layout )
  if( layout(1)/=0 .AND. layout(2)==0 )layout(2) = mpp_npes()/(layout(1)*ntiles)
  if( layout(1)==0 .AND. layout(2)/=0 )layout(1) = mpp_npes()/(layout(2)*ntiles)

  ! define land model domain
  if (ntiles==1) then
     call mpp_define_domains ((/1,nlon, 1, nlat/), layout, lnd%domain, xhalo=1, yhalo=1,&
          xflags = CYCLIC_GLOBAL_DOMAIN, name = 'LAND MODEL')
  else
     call define_cube_mosaic ('LND', lnd%domain, layout, halo=1)
  endif

  ! define io domain
  call mpp_define_io_domain(lnd%domain, io_layout)

  ! set up list of processors for collective io: only the first processor in this
  ! list actually writes data, the rest just send the data to it.
  io_domain=>mpp_get_io_domain(lnd%domain)
  if (associated(io_domain)) then
     call mpp_get_layout(io_domain,n_io_pes)
     allocate(lnd%io_pelist(n_io_pes(1)*n_io_pes(2)))
     call mpp_get_pelist(io_domain,lnd%io_pelist)
     io_id = mpp_get_tile_id(io_domain)
     lnd%io_id = io_id(1)
  else
     allocate(lnd%io_pelist(1))
     lnd%io_pelist(1) = mpp_pe()
     lnd%io_id        = mpp_pe()
  endif
  lnd%append_io_id = (io_layout(1)/=1.or.io_layout(2)/=1)
     

  ! get the domain information
  call mpp_get_compute_domain(lnd%domain, lnd%is,lnd%ie,lnd%js,lnd%je)

  ! get the mosaic tile number for this processor: this assumes that there is only one
  ! mosaic tile per PE.
  allocate(tile_ids(mpp_get_current_ntile(lnd%domain)))
  tile_ids = mpp_get_tile_id(lnd%domain)
  lnd%face = tile_ids(1)
  deallocate(tile_ids)

  allocate(lnd%tile_map (lnd%is:lnd%ie, lnd%js:lnd%je))

  allocate(lnd%lonb    (lnd%is:lnd%ie+1, lnd%js:lnd%je+1))
  allocate(lnd%latb    (lnd%is:lnd%ie+1, lnd%js:lnd%je+1))
  allocate(lnd%lon     (lnd%is:lnd%ie,   lnd%js:lnd%je))
  allocate(lnd%lat     (lnd%is:lnd%ie,   lnd%js:lnd%je))
  allocate(lnd%area    (lnd%is:lnd%ie,   lnd%js:lnd%je))
  allocate(lnd%cellarea(lnd%is:lnd%ie,   lnd%js:lnd%je))
  allocate(lnd%coord_glon(nlon), lnd%coord_glonb(nlon+1))
  allocate(lnd%coord_glat(nlat), lnd%coord_glatb(nlat+1))

  ! initialize coordinates
  call get_grid_cell_vertices('LND',lnd%face,lnd%coord_glonb,lnd%coord_glatb)
  call get_grid_cell_centers ('LND',lnd%face,lnd%coord_glon, lnd%coord_glat)
  call get_grid_cell_area    ('LND',lnd%face,lnd%cellarea, domain=lnd%domain)
  call get_grid_comp_area    ('LND',lnd%face,lnd%area,     domain=lnd%domain)
  
  ! set local coordinates arrays -- temporary, till such time as the global arrays
  ! are not necessary
  call get_grid_cell_vertices('LND',lnd%face,lnd%lonb,lnd%latb, domain=lnd%domain)
  call get_grid_cell_centers ('LND',lnd%face,lnd%lon, lnd%lat, domain=lnd%domain)
  ! convert coordinates to radian; note that 1D versions stay in degrees
  lnd%lonb = lnd%lonb*pi/180.0 ; lnd%lon = lnd%lon*pi/180.0
  lnd%latb = lnd%latb*pi/180.0 ; lnd%lat = lnd%lat*pi/180.0
  
  ! initialize land tile map
  do j = lnd%js,lnd%je
  do i = lnd%is,lnd%ie
     call land_tile_list_init(lnd%tile_map(i,j))
  enddo
  enddo

  ! initialize land model tracers, if necessary
  ! register land model tracers and find specific humidity
  call register_tracers ( MODEL_LAND, ntracers, lnd%ntprog, ndiag )
  lnd%isphum = get_tracer_index ( MODEL_LAND, 'sphum' )
  if (lnd%isphum==NO_TRACER) then
     call error_mesg('land_model_init','no required "sphum" tracer',FATAL)
  endif
  lnd%ico2 = get_tracer_index ( MODEL_LAND, 'co2' )
  ! NB: co2 might be absent, in this case ico2 == NO_TRACER

  ! initialize model's time-related parameters
  lnd%time    = time
  lnd%dt_fast = dt_fast
  lnd%dt_slow = dt_slow

  ! initialize the land model processor list
  allocate(lnd%pelist(0:mpp_npes()-1))
  call mpp_get_current_pelist(lnd%pelist)

end subroutine land_data_init

! ============================================================================
subroutine land_data_end()

  integer :: i,j
  
  module_is_initialized = .FALSE.

  ! deallocate land tile map here. 
  do j = lnd%js,lnd%je
  do i = lnd%is,lnd%ie
     call land_tile_list_end(lnd%tile_map(i,j))
  enddo
  enddo

  ! deallocate grid data
  deallocate(lnd%lonb, lnd%latb, lnd%lon, lnd%lat,&
       lnd%area, lnd%cellarea,&
       lnd%coord_glonb, lnd%coord_glon, &
       lnd%coord_glatb, lnd%coord_glat, &       
       lnd%tile_map,&
       lnd%pelist, lnd%io_pelist)

end subroutine land_data_end


! ============================================================================
! allocates boundary data for land domain and current number of tiles
subroutine realloc_land2cplr ( bnd )
  type(land_data_type), intent(inout) :: bnd     ! data to allocate

  ! ---- local vars
  integer :: n_tiles

  call dealloc_land2cplr(bnd, dealloc_discharges=.FALSE.)

  bnd%domain = lnd%domain
  n_tiles = max_n_tiles()


  ! allocate data according to the domain boundaries
  allocate( bnd%mask(lnd%is:lnd%ie,lnd%js:lnd%je,n_tiles) )

  allocate( bnd%tile_size(lnd%is:lnd%ie,lnd%js:lnd%je,n_tiles) )
  allocate( bnd%t_surf(lnd%is:lnd%ie,lnd%js:lnd%je,n_tiles) )
  allocate( bnd%t_ca(lnd%is:lnd%ie,lnd%js:lnd%je,n_tiles) )
  allocate( bnd%tr(lnd%is:lnd%ie,lnd%js:lnd%je,n_tiles,lnd%ntprog) )
  allocate( bnd%albedo(lnd%is:lnd%ie,lnd%js:lnd%je,n_tiles) )
  allocate( bnd%albedo_vis_dir(lnd%is:lnd%ie,lnd%js:lnd%je,n_tiles) )
  allocate( bnd%albedo_nir_dir(lnd%is:lnd%ie,lnd%js:lnd%je,n_tiles) )
  allocate( bnd%albedo_vis_dif(lnd%is:lnd%ie,lnd%js:lnd%je,n_tiles) )
  allocate( bnd%albedo_nir_dif(lnd%is:lnd%ie,lnd%js:lnd%je,n_tiles) )
  allocate( bnd%rough_mom(lnd%is:lnd%ie,lnd%js:lnd%je,n_tiles) )
  allocate( bnd%rough_heat(lnd%is:lnd%ie,lnd%js:lnd%je,n_tiles) )
  allocate( bnd%rough_scale(lnd%is:lnd%ie,lnd%js:lnd%je,n_tiles) )

  bnd%mask              = .FALSE.
  bnd%tile_size         = init_value
  bnd%t_surf            = init_value
  bnd%t_ca              = init_value
  bnd%tr                = init_value
  bnd%albedo            = init_value
  bnd%albedo_vis_dir    = init_value
  bnd%albedo_nir_dir    = init_value
  bnd%albedo_vis_dif    = init_value
  bnd%albedo_nir_dif    = init_value
  bnd%rough_mom         = init_value
  bnd%rough_heat        = init_value
  bnd%rough_scale       = init_value

  ! in contrast to the rest of the land boundary condition fields, discharges 
  ! are specified per grid cell, not per tile; therefore they should not be 
  ! re-allocated when the number of tiles changes. In fact, they must not be
  ! changed at all here because their values are assigned in update_land_model_fast,
  ! not in update_land_bc_*, and therefore would be lost if re-allocated.
  if (.not.associated(bnd%discharge)) then
     allocate( bnd%discharge          (lnd%is:lnd%ie,lnd%js:lnd%je) )
     allocate( bnd%discharge_heat     (lnd%is:lnd%ie,lnd%js:lnd%je) )
     allocate( bnd%discharge_snow     (lnd%is:lnd%ie,lnd%js:lnd%je) )
     allocate( bnd%discharge_snow_heat(lnd%is:lnd%ie,lnd%js:lnd%je) )

     ! discharge and discaharge_snow must be, in contrast to the rest of the boundary
     ! values, filled with zeroes. The reason is because not all of the usable elements
     ! are updated by the land model (only coastal points are).
     bnd%discharge           = 0.0
     bnd%discharge_heat      = 0.0
     bnd%discharge_snow      = 0.0
     bnd%discharge_snow_heat = 0.0
  endif
end subroutine realloc_land2cplr


! ============================================================================
! deallocates boundary data memory
! NOTE that the discharges should be deallocated only at the final clean-up
! stage; during the model run they should be preserved unchanged even when
! other fields are reallocated.
subroutine dealloc_land2cplr ( bnd, dealloc_discharges )
  type(land_data_type), intent(inout) :: bnd  ! data to de-allocate
  logical, intent(in) :: dealloc_discharges

  __DEALLOC__( bnd%tile_size )
  __DEALLOC__( bnd%tile_size )
  __DEALLOC__( bnd%t_surf )
  __DEALLOC__( bnd%t_ca )
  __DEALLOC__( bnd%tr )
  __DEALLOC__( bnd%albedo )
  __DEALLOC__( bnd%albedo_vis_dir )
  __DEALLOC__( bnd%albedo_nir_dir )
  __DEALLOC__( bnd%albedo_vis_dif )
  __DEALLOC__( bnd%albedo_nir_dif )
  __DEALLOC__( bnd%rough_mom )
  __DEALLOC__( bnd%rough_heat )
  __DEALLOC__( bnd%rough_scale )
  __DEALLOC__( bnd%mask )

  if (dealloc_discharges) then
     __DEALLOC__( bnd%discharge           )
     __DEALLOC__( bnd%discharge_heat      )
     __DEALLOC__( bnd%discharge_snow      )
     __DEALLOC__( bnd%discharge_snow_heat )
  end if

end subroutine dealloc_land2cplr


! ============================================================================
! allocates boundary data for land domain and current number of tiles;
! initializes data for data override.
! NOTE: previously the body of the procedure was in the flux_exchange_init,
! currently it is called from land_model_init
subroutine realloc_cplr2land( bnd )
  type(atmos_land_boundary_type), intent(inout) :: bnd

  ! ---- local vars
  integer :: kd

  call dealloc_cplr2land(bnd)

  ! allocate data according to the domain boundaries
  kd = max_n_tiles()

  allocate( bnd%t_flux(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%lw_flux(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%sw_flux(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%lprec(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%fprec(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%tprec(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%dhdt(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%dhdq(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%drdt(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%p_surf(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%tr_flux(lnd%is:lnd%ie,lnd%js:lnd%je,kd,lnd%ntprog) )
  allocate( bnd%dfdtr(lnd%is:lnd%ie,lnd%js:lnd%je,kd,lnd%ntprog) )

  allocate( bnd%lwdn_flux(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%swdn_flux(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%sw_flux_down_vis_dir(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%sw_flux_down_total_dir(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%sw_flux_down_vis_dif(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%sw_flux_down_total_dif(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%cd_t(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%cd_m(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%bstar(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%ustar(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%wind(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )
  allocate( bnd%z_bot(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )

  allocate( bnd%drag_q(lnd%is:lnd%ie,lnd%js:lnd%je,kd) )

  bnd%t_flux                 = init_value
  bnd%lw_flux                = init_value
  bnd%sw_flux                = init_value
  bnd%lprec                  = init_value
  bnd%fprec                  = init_value
  bnd%tprec                  = init_value
  bnd%dhdt                   = init_value
  bnd%dhdq                   = init_value
  bnd%drdt                   = init_value
  bnd%p_surf                 = init_value
  bnd%tr_flux                = init_value
  bnd%dfdtr                  = init_value

  bnd%lwdn_flux              = init_value
  bnd%swdn_flux              = init_value
  bnd%sw_flux_down_vis_dir   = init_value
  bnd%sw_flux_down_total_dir = init_value
  bnd%sw_flux_down_vis_dif   = init_value
  bnd%sw_flux_down_total_dif = init_value
  bnd%cd_t                   = init_value
  bnd%cd_m                   = init_value
  bnd%bstar                  = init_value
  bnd%ustar                  = init_value
  bnd%wind                   = init_value
  bnd%z_bot                  = init_value

  bnd%drag_q                 = init_value

end subroutine realloc_cplr2land


! ============================================================================
subroutine dealloc_cplr2land( bnd )
  type(atmos_land_boundary_type), intent(inout) :: bnd

  __DEALLOC__( bnd%t_flux )
  __DEALLOC__( bnd%lw_flux )
  __DEALLOC__( bnd%sw_flux )
  __DEALLOC__( bnd%lprec )
  __DEALLOC__( bnd%fprec )
  __DEALLOC__( bnd%dhdt )
  __DEALLOC__( bnd%dhdq )
  __DEALLOC__( bnd%drdt )
  __DEALLOC__( bnd%p_surf )
  __DEALLOC__( bnd%lwdn_flux )
  __DEALLOC__( bnd%swdn_flux )
  __DEALLOC__( bnd%sw_flux_down_vis_dir )
  __DEALLOC__( bnd%sw_flux_down_total_dir )
  __DEALLOC__( bnd%sw_flux_down_vis_dif )
  __DEALLOC__( bnd%sw_flux_down_total_dif )
  __DEALLOC__( bnd%cd_t )
  __DEALLOC__( bnd%cd_m )
  __DEALLOC__( bnd%bstar )
  __DEALLOC__( bnd%ustar )
  __DEALLOC__( bnd%wind )
  __DEALLOC__( bnd%z_bot )
  __DEALLOC__( bnd%tr_flux )
  __DEALLOC__( bnd%dfdtr )

end subroutine dealloc_cplr2land

! ============================================================================
! get max number of tiles in the domain
function max_n_tiles() result(n)
  integer :: n
  integer :: i,j

  n=1
  do j=lnd%js,lnd%je
  do i=lnd%is,lnd%ie
     n=max(n, nitems(lnd%tile_map(i,j)))
  enddo
  enddo

end function 


! ===========================================================================
!  Prints checksums of the various fields in the atmos_land_boundary_type.
subroutine atm_lnd_bnd_type_chksum(id, timestep, albt)
    character(len=*), intent(in) :: id  ! Label to differentiate where this 
                      ! routine is being called from.
    integer         , intent(in) :: timestep ! An integer to indicate which 
                      ! timestep this routine is being called for.
    type(atmos_land_boundary_type), intent(in) :: albt
    integer ::   n, outunit
    
    outunit = stdout()

    write(outunit,*) 'BEGIN CHECKSUM(atmos_land_boundary_type):: ', id, timestep
    write(outunit,100) 'albt%t_flux                ', mpp_chksum( albt%t_flux)
    write(outunit,100) 'albt%lw_flux               ', mpp_chksum( albt%lw_flux)
    write(outunit,100) 'albt%lwdn_flux             ', mpp_chksum( albt%lwdn_flux)
    write(outunit,100) 'albt%sw_flux               ', mpp_chksum( albt%sw_flux)
    write(outunit,100) 'albt%swdn_flux               ', mpp_chksum( albt%swdn_flux)
    write(outunit,100) 'albt%lprec                 ', mpp_chksum( albt%lprec)
    write(outunit,100) 'albt%fprec                 ', mpp_chksum( albt%fprec)
    write(outunit,100) 'albt%tprec                 ', mpp_chksum( albt%tprec)
    write(outunit,100) 'albt%sw_flux_down_vis_dir  ', mpp_chksum( albt%sw_flux_down_vis_dir)
    write(outunit,100) 'albt%sw_flux_down_total_dir', mpp_chksum( albt%sw_flux_down_total_dir)
    write(outunit,100) 'albt%sw_flux_down_vis_dif  ', mpp_chksum( albt%sw_flux_down_vis_dif)
    write(outunit,100) 'albt%sw_flux_down_total_dif', mpp_chksum( albt%sw_flux_down_total_dif)
    write(outunit,100) 'albt%dhdt                  ', mpp_chksum( albt%dhdt)
    write(outunit,100) 'albt%dhdq                  ', mpp_chksum( albt%dhdq)
    write(outunit,100) 'albt%drdt                  ', mpp_chksum( albt%drdt)
    write(outunit,100) 'albt%cd_m                  ', mpp_chksum( albt%cd_m)
    write(outunit,100) 'albt%cd_t                  ', mpp_chksum( albt%cd_t)
    write(outunit,100) 'albt%ustar                 ', mpp_chksum( albt%ustar)
    write(outunit,100) 'albt%bstar                 ', mpp_chksum( albt%bstar)
    write(outunit,100) 'albt%wind                  ', mpp_chksum( albt%wind)
    write(outunit,100) 'albt%z_bot                 ', mpp_chksum( albt%z_bot)
    write(outunit,100) 'albt%drag_q                ', mpp_chksum( albt%drag_q)
    write(outunit,100) 'albt%p_surf                ', mpp_chksum( albt%p_surf)
    do n = 1,size(albt%tr_flux,4)
    write(outunit,100) 'albt%tr_flux               ', mpp_chksum( albt%tr_flux(:,:,:,n))
    enddo
    do n = 1,size(albt%dfdtr,4)
    write(outunit,100) 'albt%dfdtr                 ', mpp_chksum( albt%dfdtr(:,:,:,n))
    enddo

100 FORMAT("CHECKSUM::",A32," = ",Z20)

end subroutine atm_lnd_bnd_type_chksum


! ===========================================================================
!  Prints checksums of the various fields in the land_data_type.
subroutine land_data_type_chksum(id, timestep, land)
    character(len=*), intent(in) :: id ! Label to differentiate where this 
        ! routine in being called from.
    integer         , intent(in) :: timestep ! An integer to indicate which
        ! timestep this routine is being called for.
    type(land_data_type), intent(in) :: land
    integer ::   n, outunit
    
    outunit = stdout()

    write(outunit,*) 'BEGIN CHECKSUM(land_data_type):: ', id, timestep
    write(outunit,100) 'land%tile_size         ',mpp_chksum(land%tile_size)
    write(outunit,100) 'land%t_surf            ',mpp_chksum(land%t_surf)
    write(outunit,100) 'land%t_ca              ',mpp_chksum(land%t_ca)
    write(outunit,100) 'land%albedo            ',mpp_chksum(land%albedo)
    write(outunit,100) 'land%albedo_vis_dir    ',mpp_chksum(land%albedo_vis_dir)
    write(outunit,100) 'land%albedo_nir_dir    ',mpp_chksum(land%albedo_nir_dir)
    write(outunit,100) 'land%albedo_vis_dif    ',mpp_chksum(land%albedo_vis_dif)
    write(outunit,100) 'land%albedo_nir_dif    ',mpp_chksum(land%albedo_nir_dif)
    write(outunit,100) 'land%rough_mom         ',mpp_chksum(land%rough_mom)
    write(outunit,100) 'land%rough_heat        ',mpp_chksum(land%rough_heat)
    write(outunit,100) 'land%rough_scale       ',mpp_chksum(land%rough_scale)

    do n = 1, size(land%tr,4)
    write(outunit,100) 'land%tr                ',mpp_chksum(land%tr(:,:,:,n))
    enddo
    write(outunit,100) 'land%discharge         ',mpp_chksum(land%discharge)
    write(outunit,100) 'land%discharge_snow    ',mpp_chksum(land%discharge_snow)
    write(outunit,100) 'land%discharge_heat    ',mpp_chksum(land%discharge_heat)


100 FORMAT("CHECKSUM::",A32," = ",Z20)
end subroutine land_data_type_chksum

end module land_data_mod

module pft_module
#ifndef USE_LIMA
  use ecmfft
  implicit none
   private
   public pft2d, pft2d_phys, pft_init, pft_end
!
   integer ifax(13)             ! FFT internal information
   real, allocatable :: trigs(:)
   real, allocatable :: sc(:), se(:)
   real, allocatable :: damp(:,:,:)
   integer js2g0

! if "SGI_FFT" is defined SGI's FFT library will be used (instead of the
! default FFT f77 code from ECMWF)
! (Need to link to SGI library with  "-lcomplib.sgimath" )

! if "ALT_PFT" is defined the prognostic winds on the D grid will be directly
! filtered (instead of the tendencies), and there will be 2 less calls
! to pft2d. However, the faster algebraic 3-pt filter will not be used.

! Programmer: S.-J. Lin, NOAA/GFDL, Princeton, NJ
 
CONTAINS

!-----------------------------------------------------------------------
!BOP
! !IROUTINE: pft_init --- Calculate algebraic and FFT polar filters
!
! !INTERFACE: 
 subroutine pft_init(im, jm, beglat, endlat, ighost, cosp, cose, print_msg)

! !USES:

! !INPUT PARAMETERS:
      integer, intent(in):: im        ! Global X dimension
      integer, intent(in):: jm        ! Global Y dimension
      integer, intent(in):: beglat, endlat
      integer, intent(in):: ighost    ! Normally 0
      real, intent(in)::   cosp(jm)            ! cosine array
      real, intent(in)::   cose(jm)            ! cosine array

      logical, intent(in)::  print_msg

! !DESCRIPTION:
!
!   Compute coefficients for the 3-point algebraic and the FFT
!   polar filters.
!
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer ipft1, ipft2
      integer jn1g1                   ! j north limit ghosted 1 (starts jm)
      integer i, j
      real    ycrit               ! critical value
      real    lat_s
      real  dl, coszc, cutoff, phi, dmp, rat
      real  pi

      cutoff = 1.e-20
      pi = 4.d0 * datan(1.d0)

      ipft1 = max(2, beglat-ighost)
      js2g0 = max(2, beglat)

      ipft2 = min(jm-1, endlat+ighost)
      jn1g1 = min(jm,   endlat+1)

      allocate( sc(ipft1:ipft2) )
      allocate( se(js2g0:jn1g1) )
      allocate( damp(im,ipft1:jn1g1,2) )
      allocate( trigs(3*im/2+1) )

      call fftfax(im, trigs)

!---------------------------------------------
! Determine ycrit such that effective DX >= DY
!---------------------------------------------
      rat = float(im)/float(2*(jm-1))
      ycrit = acos( min(0.81, rat) ) * (180./pi)

      if(print_msg) then
         write(6,*) 'Initializing polar filter .........'
#ifdef ALT_PFT
         write(6,*) 'Starting latitude for FFT pft=', ycrit
#else
         write(6,*) 'Starting latitude for algebraic pft=', ycrit
#endif
      endif

      coszc = cos(ycrit*pi/180.)

! INIT fft polar coefficients:
      dl = pi/dble(im)

      do j=ipft1, ipft2
         do i=1,im
            damp(i,j,1) = 1.
         enddo
      enddo

      do j=js2g0,jn1g1
         do i=1,im
            damp(i,j,2) = 1.
         enddo
      enddo

!************
! Cell center
!************
      do j=ipft1, ipft2
         sc(j) = (coszc/cosp(j))**2

#ifdef ALT_PFT
         if(sc(j) > 1.) then
#else
         if(sc(j) > 1. .and. sc(j) <= 2.0) then
            sc(j) =  1. +  (sc(j)-1.)/(sc(j)+1.)
         elseif(sc(j) > 2. .and. sc(j) <= 4.) then
            sc(j) =  1. +  sc(j)/(8.-sc(j))
            sc(j) = min(2., sc(j))
            lat_s = acos(cosp(j+1))*180/pi
         elseif(sc(j) > 4. ) then
#endif

! FFT filter
         do i=1,im/2
            phi = dl * i
            dmp = min((cosp(j)/coszc)/sin(phi), 1.)**2
            if(dmp < cutoff) dmp = 0.
            damp(2*i-1,j,1) = dmp
            damp(2*i  ,j,1) = dmp
         enddo

         endif
      enddo

#if ( !defined ALT_PFT )
!     if(print_msg) write(6,*) 'Switching to FFT at latitude =', lat_s
#endif

!************
! Cell edges
!************
      do j=js2g0,jn1g1
         se(j) = (coszc/cose(j))**2

#ifdef ALT_PFT
         if( se(j) > 1. ) then
#else
         if(se(j) > 1. .and. se(j) <= 2.0 ) then
            se(j) =  1. +  (se(j)-1.)/(se(j)+1.)
         elseif(se(j) > 2. .and. se(j) <= 4.) then
            se(j) =  1. +  se(j)/(8.-se(j))
            se(j) = min(2., se(j))
         elseif(se(j) > 4. ) then
#endif
! FFT
            do i=1,im/2
               phi = dl * i
               dmp = min((cose(j)/coszc)/sin(phi), 1.)**2
               if(dmp < cutoff) dmp = 0.
               damp(2*i-1,j,2) = dmp
               damp(2*i  ,j,2) = dmp
            enddo
         endif
      enddo
!EOC
 end subroutine pft_init
!-----------------------------------------------------------------------


 subroutine pft_end

   deallocate( trigs )
   deallocate( sc )
   deallocate( se )
   deallocate( damp )

 end subroutine pft_end


!-----------------------------------------------------------------------
!BOP
! !IROUTINE: pft2d --- Two-dimensional fast Fourier transform
!
! !INTERFACE: 
 subroutine pft2d(p, im, jp, q1, q2, igrid)

! !USES:

! !INPUT PARAMETERS:
      integer, intent(in):: im     ! Total X dimension
      integer, intent(in):: jp     ! Total Y dimension
      integer, intent(in):: igrid  ! 1: cell center; 2: edge

! !INPUT/OUTPUT
      real, intent(inout)::  p(im,jp)           ! Array to be polar filtered
      real, intent(inout):: q1( im+2, *)        ! Work array
      real, intent(inout):: q2(*)               ! Work array

! !DESCRIPTION:
!
!   Perform a two-dimensional fast Fourier transformation.
!
! !REVISION HISTORY:
!EOP
!-----------------------------------------------------------------------
!BOC
! !LOCAL VARIABLES:
      real s(jp)             ! 3-point algebraic filter
      real ptmp(0:im+1)
      integer jf(jp)
      real     rsc, bt 
      integer i, j, n, nj


      if ( igrid == 1 ) then
         do j=1,jp
            s(j) = sc(j+js2g0-1)
         enddo
      else
         do j=1,jp
            s(j) = se(j+js2g0-1)
         enddo
      endif

      nj = 0       ! Number of latitudes to be filtered by zonal FFT

      do j=1,jp

#ifdef ALT_PFT
      if(s(j) > 1.01) then
#else
      if(s(j) > 1.01 .and. s(j) <= 2.) then

         rsc = 1./s(j)
         bt  = 0.5*(s(j)-1.)

         do i=1,im
            ptmp(i) = p(i,j)
         enddo
           ptmp(   0) = ptmp(im)
           ptmp(im+1) = ptmp(1)

         do i=1,im
            p(i,j) = rsc * ( ptmp(i) + bt*(ptmp(i-1)+ptmp(i+1)) )
         enddo

      elseif(s(j) > 2.) then
#endif

! Packing for FFT 
           nj  = nj + 1
         jf(nj) = j

         do i=1,im
            q1(i,nj) = p(i,j)
         enddo
            q1(im+1,nj) = 0.
            q1(im+2,nj) = 0.

      endif
      enddo

      if( nj == 0) return

      call rfftmlt(q1, q2, 1, im+2, im, nj, -1)

      do n=1,nj
         do i=5,im+2
            q1(i,n) = q1(i,n) * damp(i-2,jf(n)+js2g0-1, igrid)
         enddo
      enddo

      call rfftmlt(q1, q2, 1, im+2, im, nj, 1)

      do n=1,nj
         do i=1,im
            p(i,jf(n)) = q1(i,n)
         enddo
      enddo
!EOC
 end subroutine pft2d

 subroutine pft2d_phys(p, im, jp)
! This is a very weak zonal filter for filtering the 
! tendencies from the physics

! !INPUT PARAMETERS:
    integer, intent(in):: im     ! Total X dimension
    integer, intent(in):: jp     ! Total Y dimension

! !INPUT/OUTPUT PARAMETERS:
    real, intent(inout):: p(im,jp)  ! Array to be polar filtered

! !LOCAL VARIABLES:
    real ptmp(0:im+1)
    real rsc, bt 
    integer  i, j

    do j=1,jp
      if(sc(js2g0+j-1) > 1.01 ) then
         rsc =  1./ min(2., sc(js2g0+j-1))
         bt  = 0.5*(min(2., sc(js2g0+j-1))-1.)
         do i=1,im
            ptmp(i) = p(i,j)
         enddo
           ptmp(   0) = ptmp(im)
           ptmp(im+1) = ptmp(1)

         do i=1,im
            p(i,j) = rsc * ( ptmp(i) + bt*(ptmp(i-1)+ptmp(i+1)) )
         enddo
      endif
    enddo

 end subroutine pft2d_phys
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
! !IROUTINE: rfftmlt --- Apply fast Fourier transform
!
! !INTERFACE: 
 subroutine rfftmlt(a,work,inc,jump,n,lot,isign)


! !DESCRIPTION:
!
!   Apply the fast Fourier transform.  If CPP token SGI_FFT is
!   set, SGI libraries will be used.  Otherwise the Fortran code
!   is inlined.
!
! !REVISION HISTORY:
!
!   99.11.24   Sawyer       Added wrappers for SGI
!   01.03.26   Sawyer       Added ProTeX documentation
!
!EOP
!-----------------------------------------------------------------------
!BOC

      integer jump, inc, n, lot, isign
#ifdef SGI_FFT
! Need to link to SGI library with  "-lcomplib.sgimath"
!
      real   a(jump,lot)
      real   work(1)                       ! Not used; here for plug reason
! Local
      integer*4 iisign,in,iinc,ijump,ilot
      integer i, j
      real scale

!-----convert to i4
      iisign = isign
      iinc = inc
      ijump = jump
      in = n
      ilot = lot

      if( iisign < 0 ) then
!-----forward
          call dzfftm1du (iisign,in,ilot,a,iinc,ijump,trigs)

      elseif( iisign > 0 ) then
!-----backward
          call zdfftm1du (iisign,in,ilot,a,iinc,ijump,trigs)

          scale = 1.0/float(n)
          do j=1,lot
             do i=1,jump
                a(i,j) = scale*a(i,j)
             enddo
          enddo
      endif
#else
!
! Default f77 version
!
      real a(jump*lot)
      real work((n+1)*lot)
      integer nfax, nx, ink, ibase, i, j, k, l, ia, ib, nb, m
      integer la, nh, jbase,igo
 
!     SUBROUTINE "FFT991" - MULTIPLE REAL/HALF-COMPLEX PERIODIC
!     FAST FOURIER TRANSFORM
 
!     SAME AS FFT99 EXCEPT THAT ORDERING OF DATA CORRESPONDS TO
!     THAT IN MRFFT2
 
!     PROCEDURE USED TO CONVERT TO HALF-LENGTH COMPLEX TRANSFORM
!     IS GIVEN BY COOLEY, LEWIS AND WELCH (J. SOUND VIB., VOL. 12
!     (1970), 315-337)
 
!     A IS THE ARRAY CONTAINING INPUT AND OUTPUT DATA
!     WORK IS AN AREA OF SIZE (N+1)*LOT
!     TRIGS IS A PREVIOUSLY PREPARED LIST OF TRIG FUNCTION VALUES
!     IFAX IS A PREVIOUSLY PREPARED LIST OF FACTORS OF N/2
!     INC IS THE INCREMENT WITHIN EACH DATA 'VECTOR'
!         (E.G. INC=1 FOR CONSECUTIVELY STORED DATA)
!     JUMP IS THE INCREMENT BETWEEN THE START OF EACH DATA VECTOR
!     N IS THE LENGTH OF THE DATA VECTORS
!     LOT IS THE NUMBER OF DATA VECTORS
!     ISIGN = +1 FOR TRANSFORM FROM SPECTRAL TO GRIDPOINT
!           = -1 FOR TRANSFORM FROM GRIDPOINT TO SPECTRAL
 
!     ORDERING OF COEFFICIENTS:
!         A(0),B(0),A(1),B(1),A(2),B(2),...,A(N/2),B(N/2)
!         WHERE B(0)=B(N/2)=0; (N+2) LOCATIONS REQUIRED
!
!     ORDERING OF DATA:
!         X(0),X(1),X(2),...,X(N-1)
!
!     VECTORIZATION IS ACHIEVED ON CRAY BY DOING THE TRANSFORMS IN
!     PARALLEL
 
!     *** N.B. N IS ASSUMED TO BE AN EVEN NUMBER
!
!     DEFINITION OF TRANSFORMS:
!     -------------------------
 
!     ISIGN=+1: X(J)=SUM(K=0,...,N-1)(C(K)*EXP(2*I*J*K*PI/N))
!         WHERE C(K)=A(K)+I*B(K) AND C(N-K)=A(K)-I*B(K)
!
!     ISIGN=-1: A(K)=(1/N)*SUM(J=0,...,N-1)(X(J)*COS(2*J*K*PI/N))
!               B(K)=-(1/N)*SUM(J=0,...,N-1)(X(J)*SIN(2*J*K*PI/N))
 
      nfax=ifax(1)
      nx=n+1
      nh=n/2
      ink=inc+inc
      if (isign==+1) go to 30
 
!     IF NECESSARY, TRANSFER DATA TO WORK AREA
      igo=50
      if (mod(nfax,2)==1) goto 40
      ibase=1
      jbase=1
      do 20 l=1,lot
      i=ibase
      j=jbase
!DIR$ IVDEP
      do 10 m=1,n
      work(j)=a(i)
      i=i+inc
      j=j+1
   10 continue
      ibase=ibase+jump
      jbase=jbase+nx
   20 continue
 
      igo=60
      go to 40
 
!     PREPROCESSING (ISIGN=+1)
 
   30 continue
      call fft99a(a,work,trigs,inc,jump,n,lot)
      igo=60
 
!     COMPLEX TRANSFORM
 
   40 continue
      ia=1
      la=1
      do 80 k=1,nfax
      if (igo==60) go to 60
   50 continue
      call vpassm(a(ia),a(ia+inc),work(1),work(2),trigs,     &
                  ink,2,jump,nx,lot,nh,ifax(k+1),la)
      igo=60
      go to 70
   60 continue
      call vpassm(work(1),work(2),a(ia),a(ia+inc),trigs,     &
                  2,ink,nx,jump,lot,nh,ifax(k+1),la)
      igo=50
   70 continue
      la=la*ifax(k+1)
   80 continue
 
      if (isign==-1) go to 130
 
!     IF NECESSARY, TRANSFER DATA FROM WORK AREA
      if (mod(nfax,2)==1) go to 110
      ibase=1
      jbase=1
      do 100 l=1,lot
      i=ibase
      j=jbase
!DIR$ IVDEP
      do 90 m=1,n
      a(j)=work(i)
      i=i+1
      j=j+inc
   90 continue
      ibase=ibase+nx
      jbase=jbase+jump
  100 continue
 
!     FILL IN ZEROS AT END
  110 continue
      ib=n*inc+1
!DIR$ IVDEP
      do 120 l=1,lot
      a(ib)=0.0
      a(ib+inc)=0.0
      ib=ib+jump
  120 continue
      go to 140
 
!     POSTPROCESSING (ISIGN=-1):
 
  130 continue
      call fft99b(work,a,trigs,inc,jump,n,lot)
 
  140 continue
#endif
!EOC
 end subroutine rfftmlt



 subroutine fftfax (n, trigs)

 integer n
#ifdef SGI_FFT
 real    trigs(1)
! local
 integer*4 nn

   nn=n
   call dzfftm1dui (nn,trigs)
#else
 real trigs(3*n/2+1)
 integer:: mode=3
 integer i

    call fax (ifax, n, mode)
    i = ifax(1)
    if (ifax(i+1) > 5 .or. n <= 4) ifax(1) = -99
    if (ifax(1) <= 0 ) then
        write(6,*) ' set99 -- invalid n'
        stop 'set99'
    endif
    call fftrig (trigs, n, mode)
#endif
 end subroutine fftfax

!
! Add Lima code here.
!
#else
  use ecmfft
!BOP
!
! !PUBLIC MEMBER FUNCTIONS:
   public pft2d, pft2d_phys, pft_init, rfftmlt, fftfax 
!
! !DESCRIPTION:
!
!      This module provides fast-Fourier transforms
!
!      \begin{tabular}{|l|l|} \hline \hline
!         pft2d     &  \\ \hline
!         pft\_cf   &  \\ \hline
!         rfftmlt   &  \\ \hline
!         fftfax    &  \\ \hline
!                                \hline
!      \end{tabular}
!
! !REVISION HISTORY:
!   01.01.30   Lin        Integrated into this module
!   01.03.26   Sawyer     Added ProTeX documentation
!
!EOP
!-----------------------------------------------------------------------

CONTAINS

!-----------------------------------------------------------------------
!BOP
! !IROUTINE: pft2d --- Two-dimensional fast Fourier transform
!
! !INTERFACE: 
 subroutine pft2d(p, s, damp, im,  jp, ifax, trigs, q1, q2)
  implicit none

! !USES:

! !INPUT PARAMETERS:
      integer im                   ! Total X dimension
      integer jp                   ! Total Y dimension
      integer ifax(13)             ! FFT internal information
      real   s(jp)             ! 3-point algebraic filter
      real  damp(im,jp)        ! FFT damping coefficients
      real trigs(3*im/2+1)

! !INPUT/OUTPUT PARAMETERS:
      real q1( im+2, *)        ! Work array
      real q2(*)               ! Work array
      real  p(im,jp)           ! Array to be polar filtered

! !DESCRIPTION:
!
!   Perform a two-dimensional fast Fourier transformation.
!
! !REVISION HISTORY:
!   01.01.30   Lin          Put into this module
!   01.03.26   Sawyer       Added ProTeX documentation
!   02.04.05   Sawyer       Integrated newest FVGCM version
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      real rsc, bt 
      integer  i, j, n, nj

!Local Auto arrays:
      real ptmp(0:im+1)
!!!      real q1(  im+2, jp)
!!!      real q2( (im+1)*jp )
      integer  jf(jp)

      nj = 0

      do 200 j=1,jp

#ifdef ALT_PFT
      if(s(j) > 1.01) then
#else
      if(s(j) > 1.01 .and. s(j) <= 2.) then

         rsc = 1./s(j)
         bt  = 0.5*(s(j)-1.)

         do i=1,im
            ptmp(i) = p(i,j)
         enddo
           ptmp(   0) = p(im,j)
           ptmp(im+1) = p(1 ,j)

         do i=1,im
            p(i,j) = rsc * ( ptmp(i) + bt*(ptmp(i-1)+ptmp(i+1)) )
         enddo

      elseif(s(j) > 4.) then
#endif

! Packing for FFT 
           nj  = nj + 1
         jf(nj) = j

         do i=1,im
            q1(i,nj) = p(i,j)
         enddo
            q1(im+1,nj) = 0.
            q1(im+2,nj) = 0.

      endif
200   continue

      if( nj == 0) return
      call rfftmlt(q1,  q2, trigs, ifax, 1, im+2, im, nj, -1)

      do n=1,nj
         do i=5,im+2
            q1(i,n) = q1(i,n) * damp(i-2,jf(n))
         enddo
      enddo

      call rfftmlt(q1, q2, trigs, ifax, 1, im+2, im, nj, 1)

      do n=1,nj
         do i=1,im
            p(i,jf(n)) = q1(i,n)
         enddo
      enddo
!EOC
 end subroutine pft2d

 subroutine pft2d_phys(p, s, im,  jp)
  implicit none
! This is a very weak zonal filter for filtering the 
! tendencies from the physics

! !INPUT PARAMETERS:
    integer, intent(in):: im     ! Total X dimension
    integer, intent(in):: jp     ! Total Y dimension
    real, intent(in):: s(jp)     ! 3-point algebraic filter

! !INPUT/OUTPUT PARAMETERS:
    real, intent(inout):: p(im,jp)  ! Array to be polar filtered

! !LOCAL VARIABLES:
    real ptmp(0:im+1)
    real rsc, bt 
    integer  i, j

    do j=1,jp
      if(s(j) > 1.01 ) then
         rsc = 1./ min(2., s(j))
         bt  = 0.5*(min(2.,s(j))-1.)
         do i=1,im
            ptmp(i) = p(i,j)
         enddo
           ptmp(   0) = p(im,j)
           ptmp(im+1) = p(1 ,j)

         do i=1,im
            p(i,j) = rsc * ( ptmp(i) + bt*(ptmp(i-1)+ptmp(i+1)) )
         enddo
      endif
    enddo

 end subroutine pft2d_phys
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
! !IROUTINE: pft_init --- Calculate algebraic and FFT polar filters
!
! !INTERFACE: 
 subroutine pft_init(im, jm, js2g0, jn1g1, sc, se, dc, de,          &
                     cosp, cose, ycrit, ipft1, ipft2)
  implicit none

! !USES:

! !INPUT PARAMETERS:
      integer im                      ! Total X dimension
      integer jm                      ! Total Y dimension
      integer js2g0                   ! j south limit ghosted 0 (SP: from 2)
      integer jn1g1                   ! j north limit ghosted 1 (starts jm)
      integer ipft1, ipft2
      real    cosp(jm)            ! cosine array
      real    cose(jm)            ! cosine array
      real    ycrit               ! critical value

! !OUTPUT PARAMETERS:
      real    sc(ipft1:ipft2)     ! Algebric filter at center
      real    se(js2g0:jn1g1)     ! Algebric filter at edge

      real    dc(im,ipft1:ipft2)  ! FFT filter at center
      real    de(im,js2g0:jn1g1)  ! FFT filter at edge

! !DESCRIPTION:
!
!   Compute coefficients for the 3-point algebraic and the FFT
!   polar filters.
!
! !REVISION HISTORY:
!
!   99.01.01   Lin          Creation
!   99.08.20   Sawyer/Lin   Changes for SPMD mode
!   01.01.30   Lin          Put into this module
!   01.03.26   Sawyer       Added ProTeX documentation
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer i, j
      real  dl, coszc, cutoff, phi, damp
      real  pi

      pi = 4.d0 * datan(1.d0)

      coszc = cos(ycrit*pi/180.)

! INIT fft polar coefficients:
      dl = pi/dble(im)
      cutoff = 1.e-20

      do j=ipft1, ipft2
         do i=1,im
            dc(i,j) = 1.
         enddo
      enddo

      do j=js2g0,jn1g1
         do i=1,im
            de(i,j) = 1.
         enddo
      enddo

!     write(6,*) 'Initializing 3-point polar filter coefficients:'

!************
! Cell center
!************
      do j=ipft1, ipft2
            sc(j) = (coszc/cosp(j))**2

#ifdef ALT_PFT
         if(sc(j) > 1.) then
#else
         if(sc(j) > 1. .and. sc(j) <= 2.0) then
            sc(j) =  1. +  (sc(j)-1.)/(sc(j)+1.)
         elseif(sc(j) > 2. .and. sc(j) <= 4.) then
            sc(j) =  1. +  sc(j)/(8.-sc(j))
            sc(j) = min(2., sc(j))
         elseif(sc(j) > 4. ) then
#endif

! FFT filter
         do i=1,im/2
            phi = dl * i
            damp = min((cosp(j)/coszc)/sin(phi), 1.)**2
            if(damp < cutoff) damp = 0.
            dc(2*i-1,j) = damp
            dc(2*i  ,j) = damp
         enddo

         endif
      enddo

!************
! Cell edges
!************
      do j=js2g0,jn1g1
            se(j) = (coszc/cose(j))**2

#ifdef ALT_PFT
         if( se(j) > 1. ) then
#else
         if(se(j) > 1. .and. se(j) <= 2.0 ) then
            se(j) =  1. +  (se(j)-1.)/(se(j)+1.)
         elseif(se(j) > 2. .and. se(j) <= 4.) then
            se(j) =  1. +  se(j)/(8.-se(j))
            se(j) = min(2., se(j))
         elseif(se(j) > 4. ) then
#endif
! FFT
            do i=1,im/2
               phi = dl * i
               damp = min((cose(j)/coszc)/sin(phi), 1.)**2
               if(damp < cutoff) damp = 0.
               de(2*i-1,j) = damp
               de(2*i  ,j) = damp
            enddo
         endif
      enddo
!EOC
 end subroutine pft_init
!-----------------------------------------------------------------------


!-----------------------------------------------------------------------
!BOP
! !IROUTINE: rfftmlt --- Apply fast Fourier transform
!
! !INTERFACE: 
 subroutine rfftmlt(a,work,trigs,ifax,inc,jump,n,lot,isign)


! !DESCRIPTION:
!
!   Apply the fast Fourier transform.  If CPP token SGI_FFT is
!   set, SGI libraries will be used.  Otherwise the Fortran code
!   is inlined.
!
! !REVISION HISTORY:
!
!   99.11.24   Sawyer       Added wrappers for SGI
!   01.03.26   Sawyer       Added ProTeX documentation
!
!EOP
!-----------------------------------------------------------------------
!BOC


#ifdef SGI_FFT
!
! WS 99.11.24 : Added SGI wrappers
!
      integer inc, jump, n, lot, isign
      real   a(jump,lot)
      real   trigs(1)
      real   work(1)                       ! Not used; here for plug reason
      integer ifax(*)
! Local
      integer*4 iisign,in,iinc,ijump,ilot
      integer i, j
      real scale

!-----convert to i4
      iisign = isign
      iinc = inc
      ijump = jump
      in = n
      ilot = lot

      if( iisign < 0 ) then
!-----forward
          call dzfftm1du (iisign,in,ilot,a,iinc,ijump,trigs)
       endif

      if( iisign > 0 ) then
!-----backward
          call zdfftm1du (iisign,in,ilot,a,iinc,ijump,trigs)

          scale = 1.0/float(n)
          do j=1,lot
             do i=1,jump
                a(i,j) = scale*a(i,j)
             enddo
          enddo
       endif
#else
!
! Default f77 version
!
      real a(jump*lot)
      real work((n+1)*lot)
      real trigs(3*n/2+1)
      integer ifax(13)
 
!     SUBROUTINE "FFT991" - MULTIPLE REAL/HALF-COMPLEX PERIODIC
!     FAST FOURIER TRANSFORM
 
!     SAME AS FFT99 EXCEPT THAT ORDERING OF DATA CORRESPONDS TO
!     THAT IN MRFFT2
 
!     PROCEDURE USED TO CONVERT TO HALF-LENGTH COMPLEX TRANSFORM
!     IS GIVEN BY COOLEY, LEWIS AND WELCH (J. SOUND VIB., VOL. 12
!     (1970), 315-337)
 
!     A IS THE ARRAY CONTAINING INPUT AND OUTPUT DATA
!     WORK IS AN AREA OF SIZE (N+1)*LOT
!     TRIGS IS A PREVIOUSLY PREPARED LIST OF TRIG FUNCTION VALUES
!     IFAX IS A PREVIOUSLY PREPARED LIST OF FACTORS OF N/2
!     INC IS THE INCREMENT WITHIN EACH DATA 'VECTOR'
!         (E.G. INC=1 FOR CONSECUTIVELY STORED DATA)
!     JUMP IS THE INCREMENT BETWEEN THE START OF EACH DATA VECTOR
!     N IS THE LENGTH OF THE DATA VECTORS
!     LOT IS THE NUMBER OF DATA VECTORS
!     ISIGN = +1 FOR TRANSFORM FROM SPECTRAL TO GRIDPOINT
!           = -1 FOR TRANSFORM FROM GRIDPOINT TO SPECTRAL
 
!     ORDERING OF COEFFICIENTS:
!         A(0),B(0),A(1),B(1),A(2),B(2),...,A(N/2),B(N/2)
!         WHERE B(0)=B(N/2)=0; (N+2) LOCATIONS REQUIRED
!
!     ORDERING OF DATA:
!         X(0),X(1),X(2),...,X(N-1)
!
!     VECTORIZATION IS ACHIEVED ON CRAY BY DOING THE TRANSFORMS IN
!     PARALLEL
 
!     *** N.B. N IS ASSUMED TO BE AN EVEN NUMBER
!
!     DEFINITION OF TRANSFORMS:
!     -------------------------
 
!     ISIGN=+1: X(J)=SUM(K=0,...,N-1)(C(K)*EXP(2*I*J*K*PI/N))
!         WHERE C(K)=A(K)+I*B(K) AND C(N-K)=A(K)-I*B(K)
!
!     ISIGN=-1: A(K)=(1/N)*SUM(J=0,...,N-1)(X(J)*COS(2*J*K*PI/N))
!               B(K)=-(1/N)*SUM(J=0,...,N-1)(X(J)*SIN(2*J*K*PI/N))
 
      nfax=ifax(1)
      nx=n+1
      nh=n/2
      ink=inc+inc
      if (isign==+1) go to 30
 
!     IF NECESSARY, TRANSFER DATA TO WORK AREA
      igo=50
      if (mod(nfax,2)==1) goto 40
      ibase=1
      jbase=1
      do 20 l=1,lot
      i=ibase
      j=jbase
!DIR$ IVDEP
      do 10 m=1,n
      work(j)=a(i)
      i=i+inc
      j=j+1
   10 continue
      ibase=ibase+jump
      jbase=jbase+nx
   20 continue
 
      igo=60
      go to 40
 
!     PREPROCESSING (ISIGN=+1)
 
   30 continue
      call fft99a(a,work,trigs,inc,jump,n,lot)
      igo=60
 
!     COMPLEX TRANSFORM
 
   40 continue
      ia=1
      la=1
      do 80 k=1,nfax
      if (igo==60) go to 60
   50 continue
      call vpassm(a(ia),a(ia+inc),work(1),work(2),trigs,     &
                  ink,2,jump,nx,lot,nh,ifax(k+1),la)
      igo=60
      go to 70
   60 continue
      call vpassm(work(1),work(2),a(ia),a(ia+inc),trigs,     &
                  2,ink,nx,jump,lot,nh,ifax(k+1),la)
      igo=50
   70 continue
      la=la*ifax(k+1)
   80 continue
 
      if (isign==-1) go to 130
 
!     IF NECESSARY, TRANSFER DATA FROM WORK AREA
      if (mod(nfax,2)==1) go to 110
      ibase=1
      jbase=1
      do 100 l=1,lot
      i=ibase
      j=jbase
!DIR$ IVDEP
      do 90 m=1,n
      a(j)=work(i)
      i=i+1
      j=j+inc
   90 continue
      ibase=ibase+nx
      jbase=jbase+jump
  100 continue
 
!     FILL IN ZEROS AT END
  110 continue
      ib=n*inc+1
!DIR$ IVDEP
      do 120 l=1,lot
      a(ib)=0.0
      a(ib+inc)=0.0
      ib=ib+jump
  120 continue
      go to 140
 
!     POSTPROCESSING (ISIGN=-1):
 
  130 continue
      call fft99b(work,a,trigs,inc,jump,n,lot)
 
  140 continue
#endif
!EOC
 end subroutine rfftmlt
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!BOP
! !IROUTINE: fftfax --- Initialize FFT
!
! !INTERFACE: 
 subroutine fftfax (n, ifax, trigs)

! !USES:


! !DESCRIPTION:
!
!   Initialize the fast Fourier transform.  If CPP token SGI_FFT is
!   set, SGI libraries will be used.  Otherwise the Fortran code
!   is inlined.
!
! !REVISION HISTORY:
!
!   99.11.24   Sawyer       Added wrappers for SGI
!   01.03.26   Sawyer       Added ProTeX documentation
!
!EOP
!-----------------------------------------------------------------------
!BOC

#ifdef SGI_FFT
      real    trigs(1)
      integer ifax(*)
      integer n
! local
      integer*4 nn

      nn=n
      call dzfftm1dui (nn,trigs)
#else
       integer ifax(13)
       real trigs(3*n/2+1)
 
! MODE 3 IS USED FOR REAL/HALF-COMPLEX TRANSFORMS.  IT IS POSSIBLE
! TO DO COMPLEX/COMPLEX TRANSFORMS WITH OTHER VALUES OF MODE, BUT
! DOCUMENTATION OF THE DETAILS WERE NOT AVAILABLE WHEN THIS ROUTINE
! WAS WRITTEN.
 
      data mode /3/
      call fax (ifax, n, mode)
      i = ifax(1)
      if (ifax(i+1) > 5 .or. n <= 4) ifax(1) = -99
      if (ifax(1) <= 0 ) then
        write(6,*) ' set99 -- invalid n'
        stop 'set99'
      endif
      call fftrig (trigs, n, mode)
#endif
!EOC
 end subroutine fftfax
!-----------------------------------------------------------------------
#endif

end module pft_module

! End of Lima pft_module

module write_ocean_data_mod

 use mpp_io_mod, only : fieldtype, axistype, mpp_open,&
      MPP_OVERWR, MPP_NETCDF, MPP_MULTI, MPP_SINGLE,&
      mpp_write_meta, mpp_write, mpp_close
 use mpp_mod, only : mpp_error, FATAL
 use oda_types_mod, only : missing_value
 use oda_types_mod, only : ocean_profile_type, max_levels_file
 use time_manager_mod, only : time_type, get_time, set_date, operator ( - )

 implicit none

 private
 
 type(fieldtype), save :: lon_field, lat_field, time_field, data_t_field, data_s_field, &
      project_field,probe_field,ref_inst_field, fix_depth_field, database_id_field,&
      profile_flag_field, profile_flag_s_field, temp_err_field, salt_err_field, &
      flag_t_field, flag_s_field, ocn_vehicle_field,&
      depth_field, nvar_field, lon_index_field, lat_index_field, &
      yyyy_field, mmdd_field, link_field

 integer, parameter :: ref_yr=1900, ref_mon=1, ref_day=1,&
                       ref_hr=0, ref_min=0, ref_sec=0,max_files=1000

 integer :: ref_seconds, ref_days, chid, wmo_id

 integer,save :: nvar_out

 integer, save :: sta_num(max_files), unit_num(max_files), nfiles
 
 type(time_type) :: ref_time, time

 logical :: module_is_initialized=.false.
 
 public :: open_profile_file, write_profile, close_profile_file, &
      write_ocean_data_init
 
#include <netcdf.inc>
 
contains

function open_profile_file(name, nvar, grid_lon, grid_lat,thread,fset)

  character(len=*), intent(in) :: name
  integer, intent(in), optional :: nvar
  real, dimension(:), optional, intent(in) :: grid_lon, grid_lat
  integer, intent(in), optional :: thread, fset

  integer :: i, open_profile_file, unit
  integer :: threading, fileset  
  character(len=128) :: units, time_units
  real, dimension(max_levels_file) :: array

type(axistype) :: depth_axis, station_axis, lon_axis, lat_axis

threading=MPP_MULTI
fileset=MPP_SINGLE

if (PRESENT(thread)) threading=thread
if (PRESENT(fset)) fileset=fset

ref_time = set_date(ref_yr, ref_mon, ref_day, ref_hr, ref_min, ref_sec)
call get_time(ref_time, ref_seconds, ref_days)
call mpp_open(unit, trim(name), action=MPP_OVERWR, form=MPP_NETCDF,&
              threading=threading, fileset=fileset)

open_profile_file = unit

nfiles=nfiles+1

if (nfiles > max_files) call mpp_error(FATAL,'max number of profiles exceeded&
     &in module write_ocean_data, increase param : max_files')

unit_num(nfiles) = unit


nvar_out = 2
if (PRESENT(nvar)) nvar_out = nvar

if (PRESENT(grid_lon) .and. PRESENT(grid_lat)) then
   call mpp_write_meta(unit, lon_axis, 'grid_longitude','degrees_E',&
        'observational grid longitude',cartesian='X',sense=1,data=grid_lon)

   call mpp_write_meta(unit, lat_axis, 'grid_latitude','degrees_N',&
        'observational grid latitude', cartesian='Y',sense=1,data=grid_lat)
endif

!call mpp_write_meta(unit,depth_axis,'depth_index','none','depth index',&
!                  cartesian='Z',sense=-1)!,data=(/(float(i),i=1,max_levels_file)/))
!pgf90 complains about the above. This is a compiler bug. Workaround:
array = (/(float(i),i=1,max_levels_file)/)
call mpp_write_meta(unit,depth_axis,'depth_index','none','depth index',&
                    cartesian='Z',sense=-1,data=array)

call mpp_write_meta(unit,station_axis,'station_index','none',&
                    'station index', cartesian='T',sense=1)

if (PRESENT(grid_lon) .and. PRESENT(grid_lat)) then
   call mpp_write_meta(unit, lon_index_field, (/station_axis/),&
        'longitude_index','none','longitude_index', missing=missing_value)
   call mpp_write_meta(unit, lat_index_field, (/station_axis/),&
        'latitude_index','none','latitude_index',missing=missing_value)
endif

call mpp_write_meta(unit,nvar_field,(/station_axis/),&
     'nvar','none','temp (1) or temp and salt (2)')

call mpp_write_meta(unit,lon_field,(/station_axis/),&
                   'longitude','degrees_E','longitude',&
                    min=-1.0,max=361.0)

call mpp_write_meta(unit,lat_field,(/station_axis/),&
                   'latitude','degrees_N','latitude',&
                    min=-91.0,max=91.0)

call mpp_write_meta(unit,profile_flag_field,(/station_axis/),&
                   'profile_flag','none','profile_flag',&
                   min=0.0,max=10.0,missing=missing_value)


if (nvar_out .eq. 2) call mpp_write_meta(unit,profile_flag_s_field,(/station_axis/),&
                   'profile_flag_s','none','profile_flag for salt',&
                    min=0.0,max=10.0,missing=missing_value)


write(time_units,'(a,i4.4,a,i2.2,a,i2.2,a)')  'days since ',ref_yr,'-',ref_mon,'-',ref_day,' 00:00:00'

call mpp_write_meta(unit,time_field,(/station_axis/),&
                   'time',trim(time_units),'time')

call mpp_write_meta(unit,yyyy_field,(/station_axis/),&
     'yyyy','none','yyyy')

call mpp_write_meta(unit,mmdd_field,(/station_axis/),&
                   'mmdd','none','mmdd')



units='deg_C'
call mpp_write_meta(unit,temp_err_field,(/station_axis/),&
                   'temp_error',trim(units),'measurement error of temperature',missing=missing_value)

units='g/kg'
if (nvar_out .eq. 2) call mpp_write_meta(unit,salt_err_field,(/station_axis/),&
                   'salt_error',trim(units),'measurement error of salinity',missing=missing_value)

call mpp_write_meta(unit,project_field,(/station_axis/),&
     'project','none','see NODC codes')

call mpp_write_meta(unit,probe_field,(/station_axis/),&
     'probe','none','see NODC codes')

call mpp_write_meta(unit,ref_inst_field,(/station_axis/),&
     'ref_inst','none','see NODC codes')

call mpp_write_meta(unit,fix_depth_field,(/station_axis/),&
     'fix_depth','none','see NODC codes')

call mpp_write_meta(unit,database_id_field,(/station_axis/),&
     'database_id','none','see NODC codes')

call mpp_write_meta(unit,ocn_vehicle_field,(/station_axis/),&
     'ocn_vehicle','none','see NODC codes')

call mpp_write_meta(unit,link_field,(/station_axis/),&
     'link','none','partial_profile flag')


 units='degrees_C'
 call mpp_write_meta(unit,data_t_field,(/depth_axis,station_axis/),&
              'temp',trim(units),'in-situ temperature',&
                min=-10.0,max=50.0,missing=missing_value)

 units='g/kg'
 if (nvar_out .eq. 2) call mpp_write_meta(unit,data_s_field,(/depth_axis,station_axis/),&
                   'salt',trim(units),'salinity',&
                    min=0.0,max=50.0,missing=missing_value)

call mpp_write_meta(unit,depth_field,(/depth_axis,station_axis/),&
                   'depth','meters','depth of obs',&
                    min=0.0,max=7000.0,missing=missing_value)



call mpp_write_meta(unit,flag_t_field,(/depth_axis,station_axis/),&
     'temp_flag','none','temperature level flag (see NODC codes)',missing=missing_value)

if (nvar_out .eq. 2) call mpp_write_meta(unit,flag_s_field,(/depth_axis,station_axis/),&
     'salt_flag','none','salinity level flag (see NODC codes)',missing=missing_value)



call mpp_write(unit, depth_axis)

if (PRESENT(grid_lon).and.PRESENT(grid_lat)) then
   call mpp_write(unit, lon_axis)
   call mpp_write(unit, lat_axis)
endif

end function open_profile_file


subroutine write_profile(unit,profile)

use mpp_domains_mod, only : domain2d,mpp_get_compute_domain, &
                            mpp_get_data_domain
use mpp_mod, only : mpp_pe

integer, intent(in) :: unit
type(ocean_profile_type), intent(in) :: profile

real, dimension(max_levels_file) :: data_t, data_s, depth
integer :: levels, secs, days, i, j, nlinks
real :: profile_flag, profile_flag_s, days_since, error, nvar, station
real :: tmp_s
real, dimension(max_levels_file) :: flag_t, flag_s
logical :: grid_ptr = .false.
integer :: findex
integer :: isc,iec,jsc,jec,isd,ied,jsd,jed
logical :: debug=.false.

! find file index from file unit list

findex=-1
do i=1,nfiles
   if (unit_num(i) .eq. unit) then
       findex=i
       exit
   endif
enddo

if (findex .eq. -1) call mpp_error(FATAL,'Attempt write to unopened file in&
     &write_ocean_data_mod:write_profile_data')


sta_num(findex)=sta_num(findex)+1

station=sta_num(findex)

levels = min(profile%levels,max_levels_file)
data_t=missing_value;data_s=missing_value;depth=missing_value
flag_t=missing_value;flag_s=missing_value
data_t(1:levels)=profile%data_t(1:levels)
flag_t(1:levels)=profile%flag_t(1:levels)

if (ASSOCIATED(profile%Model_Grid)) grid_ptr = .true.


if (grid_ptr) then
    call mpp_get_compute_domain(profile%Model_Grid%Dom, isc, iec, jsc, jec)
    if (floor(profile%i_index) .lt. isc .or. floor(profile%i_index) .gt. iec) return
    if (floor(profile%j_index) .lt. jsc .or. floor(profile%j_index) .gt. jec) return    
endif

if (profile%nvar == 2) then
    data_s(1:levels)   = profile%data_s(1:levels)
    flag_s(1:levels)=profile%flag_s(1:levels)
endif
  
depth(1:levels)=profile%depth(1:levels) 
time = profile%time - ref_time
call get_time(time, secs, days)
days_since = days + secs/86400.


 nvar = profile%nvar
 call mpp_write(unit,nvar_field,nvar,station)
 call mpp_write(unit,data_t_field,data_t,station)
 if (nvar_out .eq. 2) call mpp_write(unit,data_s_field,data_s,station)
 call mpp_write(unit,depth_field,depth,station)
 call mpp_write(unit,project_field,profile%project,station)
 call mpp_write(unit,probe_field,profile%probe,station)
 call mpp_write(unit,ref_inst_field,profile%ref_inst,station)
 call mpp_write(unit,fix_depth_field,profile%fix_depth,station)
 call mpp_write(unit,ocn_vehicle_field,profile%ocn_vehicle,station)
 call mpp_write(unit,database_id_field,profile%database_id,station)
 profile_flag = profile%profile_flag
 call mpp_write(unit,profile_flag_field,profile_flag,station)
 profile_flag = profile%profile_flag_s
 if (nvar_out .eq. 2) call mpp_write(unit,profile_flag_s_field,profile_flag,station) 
 call mpp_write(unit,lon_field,profile%lon,station)
 call mpp_write(unit,lat_field,profile%lat,station)
 call mpp_write(unit,time_field,days_since,station)
 tmp_s = real(profile%yyyy)
 call mpp_write(unit,yyyy_field,tmp_s,station)
 tmp_s = real(profile%mmdd)
 call mpp_write(unit,mmdd_field,tmp_s,station) 
 call mpp_write(unit,temp_err_field,profile%temp_err,station)
 if (nvar_out .eq. 2) call mpp_write(unit,salt_err_field,profile%salt_err,station)
 nlinks = 0

 if (profile%levels .gt. max_levels_file) then
     nlinks = ceiling(float(profile%levels)/float(max_levels_file)) - 1
 endif

 if (nlinks .gt. 0) then
     call mpp_write(unit,link_field,1.,station)
 else
     call mpp_write(unit,link_field,0.,station)
 endif

if (profile%i_index .ne. -1.0 .and. profile%j_index .ne. -1.0) then
   call mpp_write(unit, lon_index_field,profile%i_index)
   call mpp_write(unit, lat_index_field,profile%j_index)
endif

do i = 1, nlinks
   sta_num(findex)=sta_num(findex)+1
   station=sta_num(findex)
   if (i.eq.nlinks) then
       levels = mod(profile%levels,max_levels_file)
       if (levels .eq. 0) levels = max_levels_file
   else
       levels = max_levels_file
   endif
   data_t = missing_value; data_s = missing_value; depth = missing_value
   flag_t=missing_value;flag_s=missing_value
   
   data_t(1:levels)=profile%data_t((max_levels_file*i)+1:(max_levels_file*i)+levels)
   flag_t(1:levels)=profile%flag_t((max_levels_file*i)+1:(max_levels_file*i)+levels)    

   if (profile%nvar == 2) then
       data_s(1:levels)   = profile%data_s((max_levels_file*i)+1:(max_levels_file*i)+levels)
       flag_s(1:levels)= profile%flag_s((max_levels_file*i)+1:(max_levels_file*i)+levels)

   endif
       
       
   depth(1:levels)=profile%depth((max_levels_file*i)+1:(max_levels_file*i)+levels)

   call mpp_write(unit,nvar_field,nvar,station)   
   call mpp_write(unit,data_t_field,data_t,station)
   if (nvar_out .eq. 2) call mpp_write(unit,data_s_field,data_s,station)
   call mpp_write(unit,depth_field,depth,station)
   
   call mpp_write(unit,project_field,profile%project,station)
   call mpp_write(unit,probe_field,profile%probe,station)
   call mpp_write(unit,ref_inst_field,profile%ref_inst,station)
   call mpp_write(unit,fix_depth_field,profile%fix_depth,station)
   call mpp_write(unit,ocn_vehicle_field,profile%ocn_vehicle,station)
   call mpp_write(unit,database_id_field,profile%database_id,station)
   profile_flag = profile%profile_flag
   call mpp_write(unit,profile_flag_field,profile_flag,station)
   profile_flag = profile%profile_flag_s
   if (nvar_out .eq. 2)   call mpp_write(unit,profile_flag_s_field,profile_flag,station) 
   call mpp_write(unit,lon_field,profile%lon,station)
   call mpp_write(unit,lat_field,profile%lat,station)
   call mpp_write(unit,time_field,days_since,station)
   tmp_s = real(profile%yyyy)
   call mpp_write(unit,yyyy_field,tmp_s,station)
   tmp_s = real(profile%mmdd)
   call mpp_write(unit,mmdd_field,tmp_s,station)   
   call mpp_write(unit,temp_err_field,profile%temp_err,station)
   if (nvar_out .eq. 2)   call mpp_write(unit,salt_err_field,profile%salt_err,station)

   if (profile%i_index .ne. -1.0 .and. profile%j_index .ne. -1.0) then
       call mpp_write(unit, lon_index_field,profile%i_index)
       call mpp_write(unit, lat_index_field,profile%j_index)
   endif

   if (i .lt. nlinks) then
       call mpp_write(unit,link_field,1.,station)
   else
       call mpp_write(unit,link_field,0.,station)
   endif
   
enddo

end subroutine write_profile

subroutine close_profile_file(unit)

  integer, intent(in) :: unit

  call mpp_close(unit)

end subroutine close_profile_file

subroutine write_ocean_data_init()

  module_is_initialized=.true.

  sta_num=0;unit_num=0;nfiles=0

  return
  
end subroutine write_ocean_data_init

end module write_ocean_data_mod
  
  

                    module mcm_moist_processes_mod

! MS: Cleaned up moist_processes_op_mod from PJK and renamed it
!     mcm_moist_processes_mod. Deleted unused options and set the default values
!     of the namelist options to agree with supersource values.

!-----------------------------------------------------------------------
!
!         interface module for moisture processes
!         ---------------------------------------
!             moist convective adjustment
!             rel humidity cloud scheme 
!             Diagnostic cloud scheme 
!
!-----------------------------------------------------------------------

use             fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, &
                               write_version_number, stdlog, close_file, &
                               open_namelist_file, file_exist, check_nml_error

use     lscale_cond_mod, only: lscale_cond, lscale_cond_init

use     mcm_mca_lsc_mod, only: mcm_mca_lsc

use  sat_vapor_pres_mod, only: lookup_es

use    time_manager_mod, only: time_type

use    diag_manager_mod, only: register_diag_field, send_data

use         dry_adj_mod, only: dry_adj, dry_adj_init

use       rh_clouds_mod, only: rh_clouds_init, rh_clouds_end, rh_clouds_sum

use      diag_cloud_mod, only: diag_cloud_init, diag_cloud_end, diag_cloud_sum

use   diag_integral_mod, only: diag_integral_field_init, sum_diag_integral_field

use       constants_mod, only: grav, rdgas, rvgas

implicit none
private

!-----------------------------------------------------------------------
!-------------------- public data/interfaces ---------------------------

   public   mcm_moist_processes, mcm_moist_processes_init, mcm_moist_processes_end

!-----------------------------------------------------------------------
!-------------------- private data -------------------------------------

   logical           :: module_is_initialized=.false.
   

   real, parameter :: d622 = rdgas/rvgas
   real, parameter :: d378 = 1.-d622

!--------------------- version number ----------------------------------
   character(len=128) :: version = '$Id: mcm_moist_processes.F90,v 10.0 2003/10/24 22:00:58 fms Exp $'
   character(len=128) :: tagname = '$Name: tikal $'
!-----------------------------------------------------------------------
!-------------------- namelist data (private) --------------------------

   logical :: do_mca=.false., do_lsc=.false.,  &
              do_dryadj=.true.,               &
              do_rh_clouds=.true., do_diag_clouds=.false.

!------ tracer mapping for stratiform cloud scheme ------

   integer :: nql=0, nqi=0, nqa=0

!  MS mod (use the supersource value for pdepth)
!! real :: pdepth = 150.e2
   real :: pdepth = 4250.
   real :: tfreeze = 273.16

!---------------- namelist variable definitions ------------------------
!
!   do_mca   = switch to turn on/off moist convective adjustment;
!                [logical, default: do_mca=true];
!              disabled for mcm_moist_processes.
!   do_lsc   = switch to turn on/off large scale condensation
!                [logical, default: do_lsc=true];
!              disabled for mcm_moist_processes.
! do_rh_clouds = switch to turn on/off simple relative humidity cloud scheme
!                [logical, default: do_rh_clouds=true ]
! do_diag_clouds = switch to turn on/off (Gordon's) diagnostic cloud scheme
!                [logical, default: do_diag_clouds=false ]
!  do_dryadj = switch to turn on/off dry adjustment scheme
!                [logical, default: do_dryadj=true ]
!   pdepth   = boundary layer depth in pascals for determining mean
!                temperature tfreeze (used for snowfall determination)
!   tfreeze  = mean temperature used for snowfall determination (deg k)
!                [real, default: tfreeze=273.16]
!   notes: 1) do_mca  option is disabled for mcm_moist_processes.
!          2) do_lsc  option is disabled for mcm_moist_processes.
!             setting do_mca=.true. or do_lsc=.true. in the namelist will
!             cause error stop.
!          3) pdepth and tfreeze are used to determine liquid vs. solid
!             precipitation for mca, lsc, and ras schemes.
!
!-----------------------------------------------------------------------

namelist /mcm_moist_processes_nml/ do_mca, do_lsc, do_dryadj, pdepth, &
                                   tfreeze, do_rh_clouds, do_diag_clouds

!-----------------------------------------------------------------------
!-------------------- diagnostics fields -------------------------------

integer :: id_tdt_conv, id_qdt_conv, id_prec_conv, id_snow_conv, &
           id_tdt_ls  , id_qdt_ls  , id_prec_ls  , id_snow_ls  , &
           id_precip  , id_tdt_dadj, id_rh

character(len=5) :: mod_name = 'moist'

real :: missing_value = -999.

!-----------------------------------------------------------------------

contains

!#######################################################################

subroutine mcm_moist_processes (is, ie, js, je, Time, dt,            &
                                phalf, pfull, t, q, lprec, fprec) ! PJK Mod

!-----------------------------------------------------------------------
!
!    in:  is,ie      starting and ending i indices for window
!
!         js,je      starting and ending j indices for window
!
!         Time       time used for diagnostics [time_type]
!
!         dt         time step (from t(n-1) to t(n+1) if leapfrog)
!                    in seconds   [real]
!
!         phalf      pressure at half levels in pascals
!                      [real, dimension(nlon,nlat,nlev+1)]
!
!         pfull      pressure at full levels in pascals
!                      [real, dimension(nlon,nlat,nlev)]
!
!         t, q       temperature (t) [deg k] and specific humidity
!                    of water vapor (q) [kg/kg] at full model levels,
!                    at the current time step if leapfrog scheme
!                      [real, dimension(nlon,nlat,nlev)]
!
!   out:  lprec      liquid precipitiaton rate (rain) in kg/m2/s
!                      [real, dimension(nlon,nlat)]
!
!         fprec      frozen precipitation rate (snow) in kg/m2/s
!                      [real, dimension(nlon,nlat)]
! 
!-----------------------------------------------------------------------
integer,         intent(in)              :: is,ie,js,je
type(time_type), intent(in)              :: Time
   real, intent(in)                      :: dt
   real, intent(in) , dimension(:,:,:)   :: phalf, pfull
   real, intent(inout),dimension(:,:,:)  :: t, q                         ! PJK
   real, intent(out), dimension(:,:)     :: lprec, fprec

!-----------------------------------------------------------------------
real, dimension(size(t,1),size(t,2),size(t,3)) :: tin,qin,ttnd,qtnd
real, dimension(size(t,1),size(t,2))           :: tsnow,snow
logical,dimension(size(t,1),size(t,2))         :: coldT

real, dimension(size(t,1),size(t,2),size(t,3)) :: RH
real, dimension(size(t,1),size(t,2))           :: rain, precip
integer unit

integer :: i, j, k, ix, jx, kx
real    :: dtinv
logical :: used
!-----------------------------------------------------------------------

! The following local quantitities are used exclusively for diagnostic clouds
!      LGSCLDELQ  Averaged rate of change in mix ratio due to lg scale precip 
!               at full model levels  
!               (dimensioned IX x JX x KX)
!      CNVCNTQ  Accumulated count of change in mix ratio due to conv precip 
!               at full model levels  
!               (dimensioned IX x JX x KX)
!      CONVPRC  Accumulated conv precip rate summed over all
!               full model levels (mm/day )
!               (dimensioned IX x JX)

real, dimension(size(t,1),size(t,2),size(t,3)) :: lgscldelq,cnvcntq
real, dimension(size(t,1),size(t,2)) :: convprc

!-----------------------------------------------------------------------

      if (.not.module_is_initialized) call error_mesg ('mcm_moist_processes',  &
                     'mcm_moist_processes_init has not been called.', FATAL)

!-----------------------------------------------------------------------
!-------- input array size and position in global storage --------------

      ix=size(t,1); jx=size(t,2); kx=size(t,3)

!-----------------------------------------------------------------------

      dtinv=1./dt
      lprec=0.0; fprec=0.0; precip=0.0

      tin (:,:,:)=t(:,:,:)
      qin (:,:,:)=q(:,:,:)

!----------------- mean temp in lower atmosphere -----------------------
!----------------- used for determination of rain vs. snow -------------
!----------------- use input temp ? ------------------------------------

   call tempavg (pdepth, phalf, t, tsnow)

   where (tsnow <= tfreeze)
          coldT=.TRUE.
   elsewhere
          coldT=.FALSE.
   endwhere
      
!-----------------------------------------------------------------------
!***********************************************************************
!----------------- dry adjustment scheme -------------------------------

if (do_dryadj) then

         call dry_adj (tin, pfull, phalf, ttnd)
         tin=tin+ttnd
         ttnd=ttnd*dtinv

!------------- diagnostics for dt/dt_dry_adj ---------------------------
     if ( id_tdt_dadj > 0 ) then
        used = send_data ( id_tdt_dadj, ttnd, Time, is, js, 1)
     endif
! ----------------------------------------------------------------------
end if

!-----------------------------------------------------------------------
!***********************************************************************
!----------------- moist convective adjustment -------------------------

!----------------- supersource moist convective adjustment and large-scale condensation

!-----------------------------------------------------------------------

!  TK mod:
!  call mcm_mca_lsc(tin,qin,phalf,ttnd,qtnd,rain,snow)
   call mcm_mca_lsc(tin,qin,phalf,ttnd,qtnd,rain,snow, RH)


   !pass RH to rh_clouds_sum
   call rh_clouds_sum (is, js, RH)
   

!------- update input values and compute tendency -------
                    
      tin=tin+ttnd;    qin=qin+qtnd
      ttnd=ttnd*dtinv; qtnd=qtnd*dtinv
      rain=rain*dtinv; snow=snow*dtinv
      
!------- add on tendency ----------
!    tdt=tdt+ttnd; qdt=qdt+qtnd


!------- save total precip and snow ---------
      lprec=lprec+rain
      fprec=fprec+snow
      precip=precip+rain+snow
!------- compute rh clouds if desired ------
! Deleted; see TK NOTE above. RH calculation now done in mcm_mca_lsc
!    if (do_rh_clouds) then
!          
!          !calculate relative humidity
!          call rh_calc(pfull,tin,qin,RH,mask)
!          
!          !pass RH to rh_clouds_sum
!          call rh_clouds_sum (is, js, RH)
!           
!    end if

!-----------------------------------------------------------------------
!***********************************************************************
!--------------- DIAGNOSTICS FOR CONVECTIVE SCHEME ---------------------
!-----------------------------------------------------------------------
!------- diagnostics for tdt_conv -------
      if ( id_tdt_conv > 0 ) then
        used = send_data ( id_tdt_conv, ttnd, Time, is, js, 1)
      endif
!------- diagnostics for qdt_conv -------
      if ( id_qdt_conv > 0 ) then
        used = send_data ( id_qdt_conv, qtnd, Time, is, js, 1)
      endif
!------- diagnostics for precip -------
      if ( id_prec_conv > 0 ) then
        used = send_data ( id_prec_conv, rain+snow, Time, is, js )
      endif
!------- diagnostics for snow -------
      if ( id_snow_conv > 0 ) then
        used = send_data ( id_snow_conv, snow, Time, is, js )
      endif

!-----------------------------------------------------------------------
                      if (do_diag_clouds) then
!  capture convective precip and convective spec hum changes (and calculate, 
!  convective spec hum counter) which are needed as predictors 
!  for Gordon's diagnostic clouds
      where (qtnd(:,:,:) < 0.0)
            cnvcntq (:,:,:) = 1.0
      else where
            cnvcntq (:,:,:) = 0.0
      end where
      convprc = precip
                      endif

!-----------------------------------------------------------------------
!***********************************************************************
!--------------------- GENERAL DIAGNOSTICS -----------------------------
!-----------------------------------------------------------------------

!------- diagnostics for total precip -------
   if ( id_precip > 0 ) then
        used = send_data ( id_precip, precip, Time, is, js )
   endif


!-----------------------------------------------------------------------
!------- diagnostics for relative humidity -------

   if ( id_rh > 0 ) then
      if (.not.(do_rh_clouds.or.do_diag_clouds)) &
          call rh_calc (pfull,tin,qin,RH)
      used = send_data ( id_rh, RH*100., Time, is, js, 1 )
   endif

!-----------------------------------------------------------------------
!---- accumulate global integral of precipiation (mm/day) -----

call sum_diag_integral_field ('prec', precip*86400., is, js)

!-----------------------------------------------------------------------
  t = tin                          ! PJK
  q = qin                          ! PJK
end subroutine mcm_moist_processes

!#######################################################################

subroutine mcm_moist_processes_init ( id, jd, kd, axes, Time )

!-----------------------------------------------------------------------
integer,         intent(in) :: id, jd, kd, axes(4)
type(time_type), intent(in) :: Time
!-----------------------------------------------------------------------
!
!      input
!     --------
!
!      id, jd        number of horizontal grid points in the global
!                    fields along the x and y axis, repectively.
!                      [integer]
!
!      kd            number of vertical points in a column of atmosphere
!-----------------------------------------------------------------------

integer  unit,io,ierr,nt
!-----------------------------------------------------------------------

       if ( module_is_initialized ) return

       if ( file_exist('input.nml')) then

         unit = open_namelist_file()
         ierr=1; do while (ierr /= 0)
            read  (unit, nml=mcm_moist_processes_nml, iostat=io, end=10)
            ierr = check_nml_error(io,'mcm_moist_processes_nml')
         enddo
  10     call close_file (unit)

!------------------- dummy checks --------------------------------------

         if ( do_lsc ) call error_mesg   &
                   ('mcm_moist_processes_init ',  &
                    'do_lsc is not an option in mcm_moist_processes', FATAL)
         if ( do_mca ) call error_mesg   &
                   ('mcm_moist_processes_init ',  &
                    'do_mca is not an option in mcm_moist_processes', FATAL)

      endif

!--------- write namelist ------------------

      call write_version_number(version, tagname)
      if(mpp_pe() == mpp_root_pe()) write (stdlog(), nml=mcm_moist_processes_nml)

!------------ initialize various schemes ----------

      if (do_dryadj) call dry_adj_init ()
      if (do_rh_clouds)  call rh_clouds_init (id,jd,kd)     ! PJK: added
!----- initialize quantities for global integral package -----

   call diag_integral_field_init ('prec', 'f6.3')

!----- initialize quantities for diagnostics output -----

   call diag_field_init ( axes, Time )


   module_is_initialized = .true.

!-----------------------------------------------------------------------

end subroutine mcm_moist_processes_init

!#######################################################################

subroutine mcm_moist_processes_end

integer  unit
!-----------------------------------------------------------------------

      if ( .not.module_is_initialized ) return

!----------------close various schemes-----------------

      if (do_rh_clouds)   call rh_clouds_end
      if (do_diag_clouds) call diag_cloud_end

!-----------------------------------------------------------------------

      module_is_initialized = .false.

end subroutine mcm_moist_processes_end

!#######################################################################

      subroutine tempavg (pdepth,phalf,temp,tsnow)

!-----------------------------------------------------------------------
!
!    computes a mean atmospheric temperature for the bottom
!    "pdepth" pascals of the atmosphere.
!
!   input:  pdepth     atmospheric layer in pa.
!           phalf      pressure at model layer interfaces
!           temp       temperature at model layers
!
!   output:  tsnow     mean model temperature in the lowest
!                      "pdepth" pascals of the atmosphere
!
!-----------------------------------------------------------------------
      real, intent(in)  :: pdepth
      real, intent(in) , dimension(:,:,:) :: phalf,temp
      real, intent(out), dimension(:,:)   :: tsnow
!-----------------------------------------------------------------------
 real, dimension(size(temp,1),size(temp,2)) :: prsum, done, pdel, pdep
 real  sumdone
 integer  k
!-----------------------------------------------------------------------

      tsnow=0.0; prsum=0.0; done=1.0; pdep=pdepth

      do k=size(temp,3),1,-1

         pdel(:,:)=(phalf(:,:,k+1)-phalf(:,:,k))*done(:,:)

         where ((prsum(:,:)+pdel(:,:))  >  pdep(:,:))
            pdel(:,:)=pdepth-prsum(:,:)
            done(:,:)=0.0
            pdep(:,:)=0.0
         endwhere

         tsnow(:,:)=tsnow(:,:)+pdel(:,:)*temp(:,:,k)
         prsum(:,:)=prsum(:,:)+pdel(:,:)

         sumdone=sum(done(:,:))
         if (sumdone < 1.e-4) exit

      enddo

         tsnow(:,:)=tsnow(:,:)/prsum(:,:)

!-----------------------------------------------------------------------

      end subroutine tempavg

!#######################################################################

      subroutine rh_calc(pfull,T,qv,RH)

        IMPLICIT NONE


        REAL, INTENT (IN),    DIMENSION(:,:,:) :: pfull,T,qv
        REAL, INTENT (OUT),   DIMENSION(:,:,:) :: RH

        REAL, DIMENSION(SIZE(T,1),SIZE(T,2),SIZE(T,3)) :: esat
        
!-----------------------------------------------------------------------
!       Calculate RELATIVE humidity.
!       This is calculated according to the formula:
!
!       RH   = qv / (epsilon*esat/ [pfull  -  (1.-epsilon)*esat])
!
!       Where epsilon = Rdgas/RVgas = d622
!
!       and where 1- epsilon = d378
!
!       Note that RH does not have its proper value
!       until all of the following code has been executed.  That
!       is, RH is used to store intermediary results
!       in forming the full solution.

        !calculate water saturated vapor pressure from table
        !and store temporarily in the variable esat
        call lookup_es(t(:,:,:),esat(:,:,:))
        
        !calculate denominator in qsat formula
        rh(:,:,:) = pfull(:,:,:)-d378*esat(:,:,:)
     
        !limit denominator to esat, and thus qs to epsilon
        !this is done to avoid blow up in the upper stratosphere
        !where pfull ~ esat
        rh(:,:,:) = max(rh(:,:,:),esat(:,:,:)) 
        
        !calculate rh
        rh(:,:,:)=qv(:,:,:)/(d622*esat(:,:,:)/rh(:,:,:))
      

END SUBROUTINE rh_calc



!#######################################################################

subroutine diag_field_init ( axes, Time )

  integer,         intent(in) :: axes(4)
  type(time_type), intent(in) :: Time

  integer, dimension(3) :: half = (/1,2,4/)

!------------ initializes diagnostic fields in this module -------------

   id_tdt_conv = register_diag_field ( mod_name, &
     'tdt_conv', axes(1:3), Time, &
     'Temperature tendency from Manabe Climate Model conv adj',     'deg_K/s',  &
                        missing_value=missing_value               )

   id_qdt_conv = register_diag_field ( mod_name, &
     'qdt_conv', axes(1:3), Time, &
     'Mixing ratio tendency from Manabe Climate Model conv adj',   'kg/kg/s',  &
                        missing_value=missing_value               )

   id_prec_conv = register_diag_field ( mod_name, &
     'prec_conv', axes(1:2), Time, &
    'Precipitation rate from Manabe Climate Model conv adj',       'kg/m2/s' )

   id_snow_conv = register_diag_field ( mod_name, &
     'snow_conv', axes(1:2), Time, &
    'Frozen precip rate from Manabe Climate Model conv adj',       'kg/m2/s' )

   id_precip = register_diag_field ( mod_name, &
     'precip', axes(1:2), Time, &
     'Total precipitation rate',                     'kg/m2/s' )

   id_tdt_dadj = register_diag_field ( mod_name, &
     'tdt_dadj', axes(1:3), Time, &
   'Temperature tendency from dry conv adj',       'deg_K/s',  &
                        missing_value=missing_value               )

   id_rh = register_diag_field ( mod_name, &
     'rh', axes(1:3), Time, &
         'relative humidity',                            'percent',  & 
                        missing_value=missing_value               )

!-----------------------------------------------------------------------

end subroutine diag_field_init

!#######################################################################

                 end module mcm_moist_processes_mod

module tropchem_driver_mod
!
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Larry W. Horowitz
! </CONTACT>

! <OVERVIEW>
!     This code calculates tracer tendencies due to tropospheric chemistry
! </OVERVIEW>

! <DESCRIPTION>
!
! This code calculates chemical production and loss of tracers due
! to tropospheric chemistry. It also includes dry deposition, upper
! boundary conditions, emissions. Off-line sulfate concentrations are
! read in for use in calculating heterogeneous reaction rates (if SO4
! is not included as a tracer).
!
! This module is only activated if do_tropchem=T in tropchem_driver_nml
!
! </DESCRIPTION>


!-----------------------------------------------------------------------

use                    mpp_mod, only : input_nml_file 
use                    fms_mod, only : file_exist,   &
                                       field_exist, &
                                       write_version_number, &
                                       mpp_pe,  &
                                       mpp_root_pe, &
                                       lowercase,   &
                                       open_namelist_file, &
                                       close_file,   &
                                       stdlog, &
                                       check_nml_error, &
                                       error_mesg, &
                                       FATAL, &
                                       WARNING, &
                                       NOTE
use           time_manager_mod, only : time_type, &
                                       get_date, &
                                       set_date, &
                                       set_time, &
                                       days_in_year, &
                                       real_to_time_type, &
                                       time_type_to_real, &
                                       operator(+), operator(-)
use           diag_manager_mod, only : send_data,            &
                                       register_diag_field,  &
                                       register_static_field, &
                                       get_base_time
use         tracer_manager_mod, only : get_tracer_index,     &
                                       get_tracer_names,     &
                                       query_method,         &
                                       check_if_prognostic,  &
                                       NO_TRACER
use          field_manager_mod, only : MODEL_ATMOS,          &
                                       parse
use atmos_tracer_utilities_mod, only : dry_deposition
use              constants_mod, only : grav, rdgas, WTMAIR, WTMH2O, AVOGNO, &
                                       PI, DEG_TO_RAD, SECONDS_PER_DAY
use                    mpp_mod, only : mpp_clock_id,         &
                                       mpp_clock_begin,      &
                                       mpp_clock_end
use           interpolator_mod, only : interpolate_type,     &
                                        interpolate_type_eq, &
                                       interpolator_init,    &
                                    obtain_interpolator_time_slices, &
                                    unset_interpolator_time_flag, &
                                       interpolator_end,     &
                                       interpolator,         &
                                       query_interpolator,   &
                                       init_clim_diag,       &
                                       CONSTANT,             &
                                       INTERP_WEIGHTED_P  
use            time_interp_mod, only : time_interp_init, time_interp
use              mo_chemdr_mod, only : chemdr
use             mo_chemini_mod, only : chemini
use             M_TRACNAME_MOD, only : tracnam         
use                MO_GRID_MOD, only : pcnstm1 
use              CHEM_MODS_MOD, only : phtcnt, gascnt
use               MOZ_HOOK_MOD, only : moz_hook_init
use   strat_chem_utilities_mod, only : strat_chem_utilities_init, &
                                       strat_chem_dcly_dt, &
                                       strat_chem_dcly_dt_time_vary, &
                                       strat_chem_dcly_dt_endts, &
                                       strat_chem_get_aerosol, &
                                       psc_type, &
                                       strat_chem_get_h2so4, &
                                       strat_chem_get_psc, &
                                       strat_chem_destroy_psc, &
                                       strat_chem_psc_sediment, &
                                       strat_chem_get_extra_h2o
use           mo_chem_utls_mod, only : get_spc_ndx
use          atmos_sulfate_mod, only : atmos_sulfate_init, &
                                       atmos_sulfate_time_vary, &
                                       atmos_DMS_emission
use       esfsw_parameters_mod, only: Solar_spect, esfsw_parameters_init 
use astronomy_mod,         only : diurnal_solar, universal_time
use horiz_interp_mod, only: horiz_interp_type, horiz_interp_init, &
                            horiz_interp_new, horiz_interp
use fms_io_mod, only: read_data


implicit none

private

!-----------------------------------------------------------------------
!     ... interfaces
!-----------------------------------------------------------------------
public  tropchem_driver, tropchem_driver_init,  &
        tropchem_driver_time_vary, tropchem_driver_endts

!-----------------------------------------------------------------------
!     ...  declare type that will store the field infomation for the 
!          emission file
!-----------------------------------------------------------------------
type,public :: field_init_type
   character(len=64), pointer :: field_names(:)
end type field_init_type


!-----------------------------------------------------------------------
!     ... namelist
!-----------------------------------------------------------------------
integer, parameter :: maxinv = 100
real               :: relaxed_dt = SECONDS_PER_DAY*10.,     & ! relaxation timescale (sec) for the upper boundary values
                      relaxed_dt_lbc = SECONDS_PER_DAY*10., & ! relaxation timescale (sec) for the lower boundary values
                      ub_pres = 100.e2,               & ! pressure (Pa) above which to apply chemical upper boundary conditions
                      lb_pres = 950.e2                  ! pressure (Pa) below which to apply chemical lower boundary conditions
character(len=64)  :: file_sulfate = 'sulfate.nc',    & ! NetCDF file for sulfate concentrations
                      file_conc = 'conc_all.nc',      & ! NetCDF file for tracer concentrations (initial and fixed)
                      file_emis_1 = 'emissions.',     & ! NetCDF file name (beginning) for emissions
                      file_emis_2 = '.nc',            & ! NetCDF file name (end) for emissions
                      file_emis3d_1 = 'emissions3d.', & ! NetCDF file name (beginning) for 3-D emissions
                      file_emis3d_2 = '.nc',          & ! NetCDF file name (end) for 3-D emissions
                      file_ub = 'ub_vals.nc'            ! NetCDF file for chemical upper boundary conditions
character(len=64)  :: file_dry = 'depvel.nc',         & ! NetCDF file for dry deposition velocities
                      file_aircraft = 'aircraft.nc',  & ! NetCDF file for aircraft emissions
                      file_jval_lut = 'jvals.v5',     & ! ascii file for photolysis rate lookup table
                      file_jval_lut_min = ''            ! ascii file for photolysis rate LUT (for solar min)
character(len=10), dimension(maxinv) :: inv_list =''    ! list of invariant (fixed) tracers
real               :: lght_no_prd_factor = 1.           ! lightning NOx scale factor
real               :: strat_chem_age_factor = 1.        ! scale factor for age of air
real               :: strat_chem_dclydt_factor = 1.     ! scale factor for dcly/dt
logical            :: do_tropchem = .false.             ! Do tropospheric chemistry?
logical            :: use_tdep_jvals = .false.          ! Use explicit temperature dependence for photolysis rates
real               :: o3_column_top = 10.               ! O3 column above model top (DU)
real               :: jno_scale_factor = 1.             ! scale factor for NO photolysis rate (jNO)
logical            :: repartition_water_tracers = .false. ! Allow PSC scheme to act on total water (vapor+condensed)
logical            :: allow_negative_cosz = .false.     ! Allow negative values for cosine of solar zenith angle
logical            :: allow_psc_settling_type1 = .false.! Allow Type-I (NAT) PSCs to settle
logical            :: allow_psc_settling_type2 = .false.! Allow Type-II (ice) PSCs to settle
logical            :: force_cly_conservation = .false.  ! Force chemical conservation of Cly
logical            :: rescale_cly_components = .false.  ! Rescale individual Cly components to total Cly VMR
logical            :: set_min_h2o_strat = .false.       ! Don't allow total water concentration in the stratosphere to fall below 2*CH4_trop
character(len=64)  :: ch4_filename = 'ch4_gblannualdata'! Methane timeseries filename
real               :: ch4_scale_factor = 1.             ! Methane scale factor to convert to VMR (mol/mol)
character(len=64)  :: cfc_lbc_filename = 'chemlbf'      ! Input file for CFC lower boundary conditions
logical            :: time_varying_cfc_lbc = .true.     ! Allow time variation of CFC lower boundary conditions
integer, dimension(6) :: cfc_lbc_dataset_entry = (/ 1, 1, 1, 0, 0, 0 /) ! Entry date for CFC lower boundary condition file
real               :: Tdaily_clim = 297.                ! climatological T for use in MEGAN gamma_age calc
real               :: Pdaily_clim = 420.                ! climatological PPFD for MEGAN light correction 
!++amf/van
integer, parameter :: nveg=5, npft=17, nmos=12          ! number of vegetation types, pfts, and months
!--amf/van
integer            :: verbose = 3                       ! level of diagnostic output
logical            :: retain_cm3_bugs = .false.         ! retain bugs present in code used in CM3
logical            :: do_fastjx_photo = .false.         ! use fastjx routine ?
character(len=32)   :: clouds_in_fastjx = 'lsc_only'    ! nature of clouds seen in fastjx calculation; may currently be 'none' or 'lsc_only' (default)
logical            :: check_convergence = .false.       ! if T, non-converged chem tendencies will not be used
 
namelist /tropchem_driver_nml/    &
                               relaxed_dt, &
                               relaxed_dt_lbc, &
                               ub_pres, &
                               lb_pres, &
                               file_sulfate, &
                               file_conc, &
                               file_emis_1, &
                               file_emis_2, &
                               file_emis3d_1, &
                               file_emis3d_2, &
                               file_ub, &
                               file_dry, &
                               inv_list, & 
                               file_aircraft,&
                               lght_no_prd_factor, &
                               strat_chem_age_factor, &
                               strat_chem_dclydt_factor, &
                               do_tropchem, &
                               use_tdep_jvals, &
                               file_jval_lut, &
                               file_jval_lut_min, &
                               o3_column_top, &
                               jno_scale_factor, &
                               repartition_water_tracers, &
                               allow_negative_cosz, &
                               allow_psc_settling_type1, &
                               allow_psc_settling_type2, &
                               force_cly_conservation, &
                               rescale_cly_components, &
                               set_min_h2o_strat, &
                               ch4_filename, &
                               ch4_scale_factor, &
                               cfc_lbc_filename, &
                               time_varying_cfc_lbc, &
                               cfc_lbc_dataset_entry, &
                               Tdaily_clim, &
                               Pdaily_clim, &
                               verbose,   &
                               retain_cm3_bugs, &
                               do_fastjx_photo, &
                               clouds_in_fastjx, &
                               check_convergence
                              

character(len=7), parameter :: module_name = 'tracers'
real, parameter :: g_to_kg    = 1.e-3,    & !conversion factor (kg/g)
                   m2_to_cm2  = 1.e4,     & !conversion factor (cm2/m2)
                   twopi      = 2.*PI
real, parameter :: emis_cons = WTMAIR * g_to_kg * m2_to_cm2 / AVOGNO
logical, dimension(pcnstm1) :: has_emis = .false., &      ! does tracer have surface emissions?
                               has_emis3d = .false., &    ! does tracer have 3-D emissions?
                               has_xactive_emis = .false., & ! does tracer have interactive emissions?
                               diurnal_emis = .false., &   ! diurnally varying emissions?
                               diurnal_emis3d = .false.    ! diurnally varying 3-D emissions?

type(interpolate_type),dimension(pcnstm1), save :: inter_emis, &
                                                   inter_emis3d, &
                                                   inter_aircraft_emis
type(interpolate_type), save :: airc_default
type(field_init_type),dimension(pcnstm1) :: emis_field_names, &
                                            emis3d_field_names
logical, dimension(pcnstm1) :: has_ubc = .false., &
                               has_lbc = .false., &
                               fixed_lbc_time = .false.
type(time_type), dimension(pcnstm1) :: lbc_entry
logical, dimension(pcnstm1) :: has_airc = .false.
character(len=64),dimension(pcnstm1) :: ub_names, airc_names
real, parameter :: small = 1.e-50
integer :: sphum_ndx=0, cl_ndx=0, clo_ndx=0, hcl_ndx=0, hocl_ndx=0, clono2_ndx=0, &
           cl2o2_ndx=0, cl2_ndx=0, clno2_ndx=0, br_ndx=0, bro_ndx=0, hbr_ndx=0, &
           hobr_ndx=0, brono2_ndx=0, brcl_ndx=0, &
           hno3_ndx=0, o3_ndx=0, &
           no_ndx=0, no2_ndx=0, no3_ndx=0, n_ndx=0, n2o5_ndx=0, ho2no2_ndx=0, &
           pan_ndx=0, onit_ndx=0, mpan_ndx=0, isopno3_ndx=0, onitr_ndx=0, &
           extinct_ndx=0, noy_ndx=0, cly_ndx=0, bry_ndx=0, ch4_ndx=0, &
           dms_ndx=0
logical :: do_interactive_h2o = .false.         ! Include chemical sources/sinks of water vapor?
real, parameter :: solarflux_min = 1.09082, &   ! solar minimum flux (band 18) [W/m2]
                   solarflux_max = 1.14694      ! solar maximum flux (band 18) [W/m2]

!-----------------------------------------------------------------------
!     ... identification numbers for diagnostic fields
!-----------------------------------------------------------------------
integer :: id_sul, id_temp, id_dclydt, id_dbrydt, id_dclydt_chem, &
           id_psc_sat, id_psc_nat, id_psc_ice, id_volc_aer, &
           id_imp_slv_nonconv, id_srf_o3, id_coszen, id_h2o_chem
integer :: inqa, inql, inqi !index of the three water species(nqa, nql, nqi)
integer :: age_ndx ! index of age tracer
logical :: module_is_initialized=.false.
logical :: use_lsc_in_fastjx

integer, dimension(pcnstm1) :: indices, id_prod, id_loss, id_chem_tend, &
                               id_emis, id_emis3d, id_xactive_emis, &
                               id_ub, id_lb, id_airc
integer :: id_so2_emis_cmip, id_nh3_emis_cmip
integer :: id_co_emis_cmip, id_no_emis_cmip
integer :: id_co_emis_cmip2, id_no_emis_cmip2
integer :: id_so2_emis_cmip2, id_nh3_emis_cmip2
integer :: id_glaiage, id_gtemp, id_glight, id_tsfc, id_fsds, id_ctas, id_cfsds
integer :: isop_oldmonth = 0
logical :: newmonth            
logical :: has_ts_avg = .true.   ! currently reading in from monthly mean files.
integer, dimension(phtcnt)  :: id_jval
integer, dimension(gascnt)  :: id_rate_const
integer :: id_prodox, id_lossox ! for production and loss of ox.(jmao,1/1/2011)

type(interpolate_type), save :: conc       ! used to read in the concentration of OH and CH4
type(interpolate_type), save :: sulfate    ! used to read in the data for sulate
type(interpolate_type), save :: ub_default ! used for the upper bound data
type(interpolate_type),dimension(pcnstm1), save :: ub

type :: lb_type
   real, dimension(:), pointer :: gas_value
   type(time_type), dimension(:), pointer :: gas_time
end type lb_type
type(lb_type), dimension(pcnstm1) :: lb

type(interpolate_type), save :: drydep_data_default
integer :: clock_id,ndiag

real, allocatable, dimension(:,:,:) :: ecisop, pctpft   !emission capacities, % pft
real, allocatable, dimension(:,:,:,:) :: mlai ! monthly lai for each pft (could eventually tie to LM3)
real, allocatable, dimension(:,:) :: emisop_month !isop emissions with monthly lai & age gammas applied
real, allocatable, dimension(:,:) :: diag_gamma_lai_age   ! for combined lai and age gammas
real, allocatable, dimension(:,:) :: diag_gamma_light, diag_gamma_temp  ! for gamma light / T
real, allocatable, dimension(:,:) :: diag_climtas, diag_climfsds ! climatological tas and fsds

!if set up to read from restart file, then these would be 2D arrays.. for now, use mm clim. values
!real, allocatable, dimension(:,:) :: ts_avg   ! surface air T, averaged over some period (K) 
!real, allocatable, dimension(:,:) :: fsds_avg  ! avg shortwave down in visible (W/m2) 

!monthly mean sfc air T and sw down at surface, from C. Wiedinmyer 2/18/09 - Sheffield inputs (Princeton)
! CW provided 1948-2000; current input files take 1980-2000 average
real, allocatable, dimension(:,:,:) :: ts_avg  ! climatological monthly mean surface air T
real, allocatable, dimension(:,:,:) :: fsds_avg  ! climat. montly mean total shortwave down (W/m2)

type (horiz_interp_type), save :: Interp


!---- version number ---------------------------------------------------
character(len=128), parameter :: version     = '$Id: tropchem_driver.F90,v 20.0 2013/12/13 23:25:19 fms Exp $'
character(len=128), parameter :: tagname     = '$Name: tikal $'
!-----------------------------------------------------------------------

contains


!#######################################################################

! <SUBROUTINE NAME="tropchem_driver">
!   <OVERVIEW>
!     Tropospheric chemistry driver.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This subroutine calculates the sources and sinks of tracers
!     due to tropospheric chemistry. It is called from atmos_tracer_driver.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call tropchem_driver (lon, lat, land, pwt, r, chem_dt,           &
!                           Time, phalf, pfull, t, is, ie, js, je, dt, &
!                           z_half, z_full, q, tsurf, albedo, coszen,  &
!                           area, w10m, flux_sw_down_vis_dir, flux_sw_down_vis_dif, &
!                           half_day, &
!                           Time_next, rdiag,  kbot)
!   </TEMPLATE>
!   <IN NAME="lon" TYPE="real" DIM="(:,:)">
!     The longitudes for the local domain.
!   </IN>
!   <IN NAME="lat" TYPE="real" DIM="(:,:)">
!     The latitudes for the local domain.
!   </IN>
!   <IN NAME="land" TYPE="real" DIM="(:,:)">
!     The latitudes for the local domain.
!   </IN>
!   <IN NAME="pwt" TYPE="real" DIM="(:,:,:)">
!     Pressure weighting (air mass) for each layer (kg/m2)
!   </IN>
!   <IN NAME="r" TYPE="real" DIM="(:,:,:,:)">
!     Tracer mixing ratios (tropchem tracers in VMR)
!   </IN>
!   <IN NAME="Time, Time_next" TYPE="time_type">
!     Model time
!   </IN>
!   <IN NAME="phalf" TYPE="real" DIM="(:,:,:)">
!     Pressure on the model half levels (Pa)
!   </IN>
!   <IN NAME="pfull" TYPE="real" DIM="(:,:,:)">
!     Pressure on the model full levels (Pa)
!   </IN>
!   <IN NAME="t" TYPE="real" DIM="(:,:,:)">
!     Temperature.
!   </IN>
!   <IN NAME="is, js" TYPE="integer">
!     Local domain start indices
!   </IN>
!   <IN NAME="ie, je" TYPE="integer">
!     Local domain end indices
!   </IN>
!   <IN NAME="dt" TYPE="real">
!     Model physics timestep (s)
!   </IN>
!   <IN NAME="z_half" TYPE="real" DIM="(:,:,:)">
!     Height at model half levels (m)
!   </IN>
!   <IN NAME="z_full" TYPE="real" DIM="(:,:,:)">
!     Height at model full levels (m)
!   </IN>
!   <IN NAME="q" TYPE="real" DIM="(:,:,:)">
!     Specific humidity (kg/kg)
!   </IN>
!   <IN NAME="tsurf" TYPE="real" DIM="(:,:)">
!     Surface temperature (K)
!   </IN>
!   <IN NAME="albedo" TYPE="real" DIM="(:,:)">
!     Surface albedo
!   </IN>
!   <IN NAME="coszen" TYPE="real" DIM="(:,:)">
!     Cosine of the solar zenith angle
!   </IN>
!   <IN NAME="area" TYPE="real" DIM="(:,:)">
!     Grid box area (m^2)
!   </IN>
!   <IN NAME="w10m" TYPE="real" DIM="(:,:)">
!     Windspeed at 10m (m/s)
!   </IN>
!   <IN NAME="flux_sw_down_vis_dir" TYPE="real" DIM="(:,:)">
!     Surface downward visible radiation (W/m2)
!   </IN>
!   <IN NAME="flux_sw_down_vis_dif" TYPE="real" DIM="(:,:)">
!     Surface downward visible radiation (W/m2)
!   </IN>
!   <IN NAME="half_day" TYPE="real" DIM="(:,:)">
!     Half-day length  (dimensionless; 0 to pi)
!   </IN>
!   <OUT NAME="chem_dt" TYPE="real" DIM="(:,:,:,:)">
!     Tracer tendencies from tropospheric chemistry (VMR/s)
!   </OUT>
!   <INOUT NAME="rdiag" TYPE="real" DIM="(:,:,:,:)">
!     Diagnostic tracer mixing ratios (tropchem tracers in VMR),
!     updated on output
!   </INOUT>
!   <IN NAME="kbot" TYPE="integer, optional" DIM="(:,:)">
!     Integer array describing which model layer intercepts the surface.
!   </IN>

subroutine tropchem_driver( lon, lat, land, ocn_flx_fraction, pwt, r, chem_dt,                 &
                            Time, phalf, pfull, t, is, ie, js, je, dt,       &
                            z_half, z_full, q, tsurf, albedo, coszen, rrsun, &
                            area, w10m, flux_sw_down_vis_dir, flux_sw_down_vis_dif, &
                            half_day, &
                            Time_next, rdiag,  kbot )

!-----------------------------------------------------------------------
   real, intent(in),    dimension(:,:)            :: lon, lat
   real, intent(in),    dimension(:,:)            :: land    ! land fraction
   real, intent(in),    dimension(:,:)            :: ocn_flx_fraction ! grid box fraction over which DMS flux from ocean occurs
   real, intent(in),    dimension(:,:,:)          :: pwt
   real, intent(in),    dimension(:,:,:,:)        :: r
   real, intent(out),   dimension(:,:,:,:)        :: chem_dt
   type(time_type), intent(in)                    :: Time, Time_next     
   integer, intent(in)                            :: is, ie, js, je
   real, intent(in),    dimension(:,:,:)          :: phalf,pfull,t
   real, intent(in)                               :: dt      ! timestep (s)
   real, intent(in),    dimension(:,:,:)          :: z_half  ! height in meters at half levels
   real, intent(in),    dimension(:,:,:)          :: z_full  ! height in meters at full levels
   real, intent(in),    dimension(:,:,:)          :: q       ! specific humidity at current time step (kg/kg)
   real, intent(in),    dimension(:,:)            :: tsurf   ! surface temperature (K)
   real, intent(in),    dimension(:,:)            :: albedo  ! surface albedo
   real, intent(in),    dimension(:,:)            :: coszen  ! cosine of solar zenith angle
   real, intent(in)                               :: rrsun   ! earth-sun distance factor (r_avg/r)^2
   real, intent(in),    dimension(:,:)            :: area    ! grid box area (m^2)
   real, intent(in),    dimension(:,:)            :: w10m    ! wind speed at 10m (m/s)
   real, intent(in), dimension(:,:)               :: flux_sw_down_vis_dir !W/m2 direct visible sfc flux
   real, intent(in), dimension(:,:)               :: flux_sw_down_vis_dif !W/m2 diffuse visible sfc flux
   real, intent(in), dimension(:,:)               :: half_day! half-day length (0 to pi)   
   real, intent(inout), dimension(:,:,:,:)        :: rdiag   ! diagnostic tracer concentrations
   integer, intent(in),  dimension(:,:), optional :: kbot
!-----------------------------------------------------------------------
   real, dimension(size(r,1),size(r,2),size(r,3)) :: sulfate_data
!   real, dimension(size(r,1),size(r,2),size(r,3)) :: ub_temp,rno
   real, dimension(size(r,1),size(r,2),size(r,3),maxinv) :: inv_data
   real, dimension(size(r,1),size(r,2)) :: emis
   real, dimension(size(r,1),size(r,2), pcnstm1) :: emisz
   real, dimension(size(r,1),size(r,2),size(r,3)) :: emis3d, xactive_emis
   real, dimension(size(r,1),size(r,2),size(r,3)) :: age, cly0, cly, cly_ratio, &
                                                     bry, dclydt, dbrydt, noy, &
                                                     extinct, strat_aerosol
   real, dimension(size(r,1),size(r,2),size(r,3),3) :: psc_vmr_save, dpsc_vmr
   real, dimension(size(r,1),size(r,2)) :: tsfcair, pwtsfc, flux_sw_down_vis
   integer :: i,j,k,n,kb,id,jd,kd,ninv,ntp, index1, index2
!  integer :: nno,nno2
   integer :: inv_index
   integer :: plonl
   logical :: used
   real :: scale_factor, frac
   real,  dimension(size(r,1),size(r,3)) :: pdel, h2so4, h2o_temp, qlocal, cloud_water
   real, dimension(size(r,1),size(r,2),size(r,3),pcnstm1)  :: r_temp, r_in, emis_source, r_ub, airc_emis
   real, dimension(size(r,1),size(r,2),size(r,3)) :: tend_tmp, extra_h2o
   real, dimension(pcnstm1) :: r_lb
   real, dimension(size(land,1), size(land,2)) :: oro ! 0 and 1 rep. of land
   real, dimension(size(r,1),size(r,2)) :: coszen_local, fracday_local
   real :: rrsun_local
   real, dimension(size(r,1),size(r,2),size(r,3),pcnstm1) :: prod, loss
!  add new arrays for ox budget (jmao,1/1/2011)
   real, dimension(size(r,1),size(r,2),size(r,3)):: prodox, lossox
   real, dimension(size(r,1),size(r,2),size(r,3),phtcnt) :: jvals
   real, dimension(size(r,1),size(r,2),size(r,3),gascnt) :: rate_constants
   real, dimension(size(r,1),size(r,2),size(r,3)) :: imp_slv_nonconv
   real :: solar_phase
   type(psc_type) :: psc
   type(time_type) :: lbc_Time
!-----------------------------------------------------------------------

!<ERROR MSG="tropchem_driver_init must be called first." STATUS="FATAL">
!   Tropchem_driver_init needs to be called before tracer_driver.
!</ERROR>
   if (.not. module_is_initialized)  &
      call error_mesg ('Tropchem_driver','tropchem_driver_init must be called first.', FATAL)

   ntp = size(r,4)
   plonl = size(r,1)

   where(land(:,:) >= 0.5)
      oro(:,:) = 1.
   elsewhere
      oro(:,:) = 0.
   endwhere

   id=size(r,1); jd=size(r,2); kd=size(r,3)
   
   ninv=0
   do n = 1, size(inv_list)
      if(inv_list(n) /= '') then
         ninv = ninv + 1
      else
         exit
      end if
   end do
 
   emis_source(:,:,:,:) = 0.0
   airc_emis(:,:,:,:) = 0.0

   tsfcair(:,:) = t(:,:,kd)
   pwtsfc(:,:) = t(:,:,kd)
   do n = 1, pcnstm1
!-----------------------------------------------------------------------
!     ... read in the surface emissions, using interpolator
!-----------------------------------------------------------------------
      if (has_emis(n)) then
         call read_2D_emis_data( inter_emis(n), emis, Time, Time_next, &
                                 emis_field_names(n)%field_names, &
                                 diurnal_emis(n), coszen, half_day, lon, &
                                 is, js, id_emis(n) )
         if (tracnam(n) == 'NO') then
           emisz(:,:,n) = emis(:,:)
           if (id_no_emis_cmip > 0) then
             used = send_data(id_no_emis_cmip,emis*1.0e04*0.030/AVOGNO, &
                                  Time_next, &
                                                  is_in=is,js_in=js)
           endif
         endif
         if (tracnam(n) == 'CO') then
           emisz(:,:,n) = emis(:,:)
           if (id_co_emis_cmip > 0) then
             used = send_data(id_co_emis_cmip,emis*1.0e04*0.028/AVOGNO,Time_next, &
                                                  is_in=is,js_in=js)
           endif
         endif
         if (tracnam(n) == 'SO2') then
           emisz(:,:,n) = emis(:,:)
           if (id_so2_emis_cmip > 0) then
             used = send_data(id_so2_emis_cmip,emis*1.0e04*0.064/AVOGNO,Time_next, &
                                                  is_in=is,js_in=js)
           endif
         endif
         if (tracnam(n) == 'NH3') then
           emisz(:,:,n) = emis(:,:)
           if (id_nh3_emis_cmip > 0) then
             used = send_data(id_nh3_emis_cmip,emis*1.0e04*0.017/AVOGNO,Time_next, &
                                                  is_in=is,js_in=js)
           endif
         endif

         if (present(kbot)) then
            do j=1,jd
               do i=1,id
                  kb=kbot(i,j)
                  emis_source(i,j,kb,n) = emis(i,j)/pwt(i,j,kb) * emis_cons
               end do
            end do
         else
            emis_source(:,:,kd,n) = emis(:,:)/pwt(:,:,kd) * emis_cons
         end if
      end if

!-----------------------------------------------------------------------
!     ... read in the 3-D emissions, using interpolator
!-----------------------------------------------------------------------
      if (has_emis3d(n)) then
         call read_3D_emis_data( inter_emis3d(n), emis3d, Time, Time_next,phalf, &
                                 emis3d_field_names(n)%field_names, &
                                 diurnal_emis3d(n), coszen, half_day, lon, &
                                 is, js, id_emis3d(n) )
      
         emis_source(:,:,:,n) = emis_source(:,:,:,n) &
                              + emis3d(:,:,:)/pwt(:,:,:) * emis_cons
         if (tracnam(n) == 'SO2') then
           do k=1, size(emis3d,3)
           emisz(:,:,n) = emisz(:,:,n) + emis3d(:,:,k)
           end do
         endif
         if (tracnam(n) == 'NO') then
           do k=1, size(emis3d,3)
           emisz(:,:,n) = emisz(:,:,n) + emis3d(:,:,k)
           end do
         endif
         if (tracnam(n) == 'CO') then
           do k=1, size(emis3d,3)
           emisz(:,:,n) = emisz(:,:,n) + emis3d(:,:,k)
           end do
         endif
         if (tracnam(n) == 'NH3') then
           do k=1, size(emis3d,3)
           emisz(:,:,n) = emisz(:,:,n) + emis3d(:,:,k)
           end do
         endif
      end if

!-----------------------------------------------------------------------
!     ... calculate interactive emissions
!-----------------------------------------------------------------------
!     if (has_xactive_emis(n)) then
      if ( has_xactive_emis(n) .or. id_xactive_emis(n)>0 ) then
         select case (trim(tracnam(n)))
         case ('ISOP')

            flux_sw_down_vis = flux_sw_down_vis_dir+flux_sw_down_vis_dif

            call calc_xactive_isop ( n, Time, Time_next, lon, lat, oro, pwtsfc, is, js, &
                 area, land, tsfcair, flux_sw_down_vis, &
                 coszen, emis, id_gamma_lai_age=id_glaiage, &
                 id_gamma_temp=id_gtemp, id_gamma_light=id_glight, &
                 id_tsfcair=id_tsfc, id_fsdvd=id_fsds, &
                 id_climtas=id_ctas, id_climfsds=id_cfsds, id_emis_diag=id_xactive_emis(n) )
            if (has_xactive_emis(n)) then
               if (present(kbot)) then
                  do j=1,jd
                     do i=1,id
                        kb=kbot(i,j)

                        emis_source(i,j,kb,n) = emis_source(i,j,kb,n) &
                                              + emis(i,j)/pwt(i,j,kb)*emis_cons

                     end do
                  end do
               else
                  emis_source(:,:,kd,n) = emis_source(:,:,kd,n) &
                                        + emis(:,:)/pwt(:,:,kd) * emis_cons
               end if
            end if
         case ('DMS')
            call calc_xactive_emis( n, Time, Time_next,lon, lat, pwt, is, ie, js, je, &
                 area, land, ocn_flx_fraction,tsurf, w10m, xactive_emis, &
                 kbot=kbot, id_emis_diag=id_xactive_emis(n) )
            if (has_xactive_emis(n)) then
               emis_source(:,:,:,n) = emis_source(:,:,:,n) + xactive_emis(:,:,:)
            end if
         case default
            if (has_xactive_emis(n)) then
            call error_mesg ('tropchem_driver','Interactive emissions not defined for species: '//trim(tracnam(n)), FATAL)
            end if
         end select
      end if

!-----------------------------------------------------------------------
!     ... read in the aircraft emissions
!-----------------------------------------------------------------------
      if(has_airc(n)) then
         call interpolator( inter_aircraft_emis(n), Time, phalf, &
                            airc_emis(:,:,:,n), trim(airc_names(n)),is,js)
         if(id_airc(n) > 0)&
              used = send_data(id_airc(n),airc_emis(:,:,:,n),Time_next, is_in=is, js_in=js)
    
         if (tracnam(n) == 'CO') then
           do k=1, size(emis3d,3)
           emisz(:,:,n) = emisz(:,:,n) + airc_emis(:,:,k,n)
           end do
         endif
         if (tracnam(n) == 'NO') then
           do k=1, size(emis3d,3)
           emisz(:,:,n) = emisz(:,:,n) + airc_emis(:,:,k,n)
           end do
         endif
         if (tracnam(n) == 'SO2') then
           do k=1, size(emis3d,3)
           emisz(:,:,n) = emisz(:,:,n) + airc_emis(:,:,k,n)
           end do
         endif
         if (tracnam(n) == 'NH3') then
           do k=1, size(emis3d,3)
           emisz(:,:,n) = emisz(:,:,n) + airc_emis(:,:,k,n)
           end do
         endif
         airc_emis(:,:,:,n) = airc_emis(:,:,:,n)/pwt(:,:,:)*emis_cons
!     end if
      end if
         if (tracnam(n) == 'NO') then
           if (id_no_emis_cmip2 > 0) then
             used = send_data(id_no_emis_cmip2,emisz(:,:,n)*1.0e04*0.030/AVOGNO,Time_next, &
                                                 is_in=is,js_in=js)
           endif
         endif
         if (tracnam(n) == 'CO') then
           if (id_co_emis_cmip2 > 0) then
             used = send_data(id_co_emis_cmip2,emisz(:,:,n)*1.0e04*0.028/AVOGNO,Time_next, &
                                                 is_in=is,js_in=js)
           endif
         endif
         if (tracnam(n) == 'SO2') then
           if (id_so2_emis_cmip2 > 0) then
             used = send_data(id_so2_emis_cmip2,emisz(:,:,n)*1.0e04*0.064/AVOGNO,Time_next, &
                                                 is_in=is,js_in=js)
           endif
         endif
         if (tracnam(n) == 'NH3') then
           if (id_nh3_emis_cmip2 > 0) then
             used = send_data(id_nh3_emis_cmip2,emisz(:,:,n)*1.0e04*0.017/AVOGNO,Time_next, &
                                                  is_in=is,js_in=js)
           endif
         endif
   end do

!-----------------------------------------------------------------------
!     ... read in the concentrations of "invariant" (i.e., prescribed)
!         species
!-----------------------------------------------------------------------
   do n = 1,ninv
      call interpolator( conc, Time, phalf, inv_data(:,:,:,n), &
                         trim(inv_list(n)), is, js)
      inv_index = get_tracer_index( MODEL_ATMOS, trim(inv_list(n)) ) - ntp
      rdiag(:,:,:,inv_index) = inv_data(:,:,:,n)
   end do
      
!-----------------------------------------------------------------------
!     ... read in the sulfate aerosol concentrations
!-----------------------------------------------------------------------
   call interpolator(sulfate, Time, phalf, sulfate_data, 'sulfate', is,js)
   used = send_data(id_sul, sulfate_data, Time_next, is_in=is, js_in=js)

!  call mpp_clock_begin(clock_id)

   chem_dt(:,:,:,:) =0.
    
!-----------------------------------------------------------------------
!     ... assign concentrations of prognostic (r) and diagnostic (rdiag)
!         species to r_temp
!-----------------------------------------------------------------------
   do n = 1,pcnstm1
      if(indices(n) <= ntp) then
         r_temp(:,:,:,n) = r(:,:,:,indices(n))
      else
         r_temp(:,:,:,n) = rdiag(:,:,:,indices(n)-ntp)
      end if
   end do

!-----------------------------------------------------------------------
!     ... convert to H2O VMR
!-----------------------------------------------------------------------
   if (sphum_ndx > 0) then
      r_temp(:,:,:,sphum_ndx) = r_temp(:,:,:,sphum_ndx) * WTMAIR / WTMH2O
   end if

!-----------------------------------------------------------------------
!     ... convert volcanic aerosol extinction into aerosol surface area
!-----------------------------------------------------------------------
   if (extinct_ndx > 0 .and. extinct_ndx <= ntp) then
      extinct(:,:,:) = r(:,:,:,extinct_ndx)
   else if (extinct_ndx > ntp) then
      extinct(:,:,:) = rdiag(:,:,:,extinct_ndx-ntp)
   else
      extinct(:,:,:) = 0.
   end if
   call strat_chem_get_aerosol( extinct, strat_aerosol )

!-----------------------------------------------------------------------
!     ... get age of air
!-----------------------------------------------------------------------
   if(age_ndx > 0 .and. age_ndx <= ntp) then
      age(:,:,:) = r(:,:,:,age_ndx)
   else
      age(:,:,:) = 0.
   end if

!-----------------------------------------------------------------------
!     ... Chemical families
!-----------------------------------------------------------------------
   cly0(:,:,:) = 0.
   if (cl_ndx>0) then
      cly0(:,:,:) = cly0(:,:,:) + r_temp(:,:,:,cl_ndx)
   end if
   if (clo_ndx>0) then
      cly0(:,:,:) = cly0(:,:,:) + r_temp(:,:,:,clo_ndx)
   end if
   if (hcl_ndx>0) then
      cly0(:,:,:) = cly0(:,:,:) + r_temp(:,:,:,hcl_ndx)
   end if
   if (hocl_ndx>0) then
      cly0(:,:,:) = cly0(:,:,:) + r_temp(:,:,:,hocl_ndx)
   end if
   if (clono2_ndx>0) then
      cly0(:,:,:) = cly0(:,:,:) + r_temp(:,:,:,clono2_ndx)
   end if
   if (cl2o2_ndx>0) then
      cly0(:,:,:) = cly0(:,:,:) + r_temp(:,:,:,cl2o2_ndx)*2
   end if
   if (cl2_ndx>0) then
      cly0(:,:,:) = cly0(:,:,:) + r_temp(:,:,:,cl2_ndx)*2
   end if
   if (clno2_ndx>0) then
      cly0(:,:,:) = cly0(:,:,:) + r_temp(:,:,:,clno2_ndx)
   end if
   if (brcl_ndx>0) then
      cly0(:,:,:) = cly0(:,:,:) + r_temp(:,:,:,brcl_ndx)
   end if

!-----------------------------------------------------------------------
!     ... cosine of solar zenith angle
!-----------------------------------------------------------------------
   if (allow_negative_cosz) then
      call diurnal_solar( lat, lon, Time, coszen_local, fracday_local, &
                          rrsun_local, dt_time=real_to_time_type(dt), &
                          allow_negative_cosz=.true. )
   else
      coszen_local(:,:) = coszen(:,:)
      rrsun_local = rrsun
   end if

   r_temp(:,:,:,:) = MAX(r_temp(:,:,:,:),small)
  
   do j = 1,jd
      do k = 1,kd
         pdel(:,k) = phalf(:,j,k+1) - phalf(:,j,k)
      end do
      qlocal(:,:) = q(:,j,:)
      
!-----------------------------------------------------------------------
!     ... get stratospheric h2so4
!-----------------------------------------------------------------------
      call strat_chem_get_h2so4( pfull(:,j,:), age(:,j,:), h2so4 )

!-----------------------------------------------------------------------
!     ... compute PSC amounts
!-----------------------------------------------------------------------
      if (sphum_ndx>0) then
         h2o_temp(:,:) = r_temp(:,j,:,sphum_ndx)
      else
         h2o_temp(:,:) = qlocal(:,:) * WTMAIR/WTMH2O
      end if
      cloud_water(:,:) = MAX(r(:,j,:,inql)+r(:,j,:,inqi),0.)
      if (repartition_water_tracers) then
         h2o_temp(:,:) = h2o_temp(:,:) + cloud_water(:,:) * WTMAIR/WTMH2O
      end if
      if (set_min_h2o_strat) then
         call strat_chem_get_extra_h2o( h2o_temp, age(:,j,:), r_temp(:,j,:,ch4_ndx), Time, extra_h2o(:,j,:) )
         h2o_temp(:,:) = h2o_temp(:,:) + extra_h2o(:,j,:)
      end if

      call strat_chem_get_psc( t(:,j,:), pfull(:,j,:), &
                               r_temp(:,j,:,hno3_ndx), h2o_temp(:,:), &
                               h2so4, strat_aerosol(:,j,:), psc, psc_vmr_out=psc_vmr_save(:,j,:,:) )

      if (repartition_water_tracers) then
         cloud_water(:,:) = MAX(0.,cloud_water(:,:) - psc_vmr_save(:,j,:,3)*WTMH2O/WTMAIR) ! reduce cloud_water by amount of type-II PSC
         h2o_temp(:,:) = h2o_temp(:,:) - cloud_water(:,:) * WTMAIR/WTMH2O                  ! remaining water is present as vapor
      end if
      if (sphum_ndx>0) then
         r_temp(:,j,:,sphum_ndx) = h2o_temp(:,:)
      end if
      qlocal(:,:) = h2o_temp(:,:) * WTMH2O/WTMAIR
      r_in(:,j,:,:) = r_temp(:,j,:,:)

!-----------------------------------------------------------------------
!     ... get solar cycle phase (use radiation band #18)
!-----------------------------------------------------------------------
      solar_phase = Solar_spect%solflxbandref(Solar_spect%nbands)
      solar_phase = (solar_phase-solarflux_min)/(solarflux_max-solarflux_min)

!-----------------------------------------------------------------------
!     ... call chemistry driver
!-----------------------------------------------------------------------
      call chemdr(r_temp(:,j,:,:),             & ! species volume mixing ratios (VMR)
                  r(:,j,:,:),                  &
                  phalf(:,j,:),                & ! pressure at boundaries (Pa)
                  pwt(:,j,:) ,                 & ! column air density (Kg/m2)  
                  do_fastjx_photo,             & ! true = use fastjx photo
                  use_lsc_in_fastjx,           & ! use lsc clouds in fastjx
                  j,                           & ! j
!                 0,                           & ! time step index
                  Time_next,                   & ! time
                  lat(:,j),                    & ! latitude
                  lon(:,j),                    & ! longitude
                  dt,                          & ! timestep in seconds
                  phalf(:,j,SIZE(phalf,3)),    & ! surface press ( pascals )  
                  phalf(:,j,1),                & ! model top pressure (pascals)
                  pfull(:,j,:),                & ! midpoint press ( pascals )
                  pdel,                        & ! delta press across midpoints
!                 oro(:,j),                    & ! surface orography flag
!                 tsurf(:,j),                  & ! surface temperature
                  z_full(:,j,:),               & ! height at midpoints ( m )
                  z_half(:,j,:),               & ! height at interfaces ( m )
                  MAX(r(:,j,:,inqa),0.),       & ! cloud fraction
                  cloud_water(:,:),            & ! total cloud water (kg/kg)
                  t(:,j,:),                    & ! temperature
                  inv_data(:,j,:,:),           & ! invariant species
                  qlocal(:,:),                 & ! specific humidity ( kg/kg )
                  albedo(:,j),                 & ! surface albedo
                  coszen_local(:,j),           & ! cosine of solar zenith angle
                  rrsun_local,                 & ! earth-sun distance factor
                  prod(:,j,:,:),               & ! chemical production rate
                  loss(:,j,:,:),               & ! chemical loss rate
                  jvals(:,j,:,:),              & ! photolysis rates (s^-1)
                  rate_constants(:,j,:,:),     & ! kinetic rxn rate constants (cm^3 molec^-1 s^-1 for 2nd order)
                  sulfate_data(:,j,:),         & ! sulfate aerosol
                  psc,                         & ! polar stratospheric clouds (PSCs)
                  do_interactive_h2o,          & ! include h2o sources/sinks?
                  solar_phase,                 & ! solar cycle phase (1=max, 0=min)
                  imp_slv_nonconv(:,j,:),      & ! flag for non-convergence of implicit solver
                  plonl,                       & ! number of longitudes
                  prodox(:,j,:),               & ! production of ox(jmao,1/1/2011)
                  lossox(:,j,:),               & ! loss of ox(jmao,1/1/2011)
                  retain_cm3_bugs, check_convergence)

      call strat_chem_destroy_psc( psc )

   end do

   r_temp(:,:,:,:) = MAX( r_temp(:,:,:,:), small )
   if (allow_psc_settling_type1 .or. allow_psc_settling_type2) then
      call strat_chem_psc_sediment( psc_vmr_save, pfull, dt, dpsc_vmr )
      if (.not. allow_psc_settling_type1) dpsc_vmr(:,:,:,2) = 0.
      if (.not. allow_psc_settling_type2) dpsc_vmr(:,:,:,3) = 0.
   end if

!-----------------------------------------------------------------------
!     ... output diagnostics
!-----------------------------------------------------------------------
   do n = 1,pcnstm1
      if(id_prod(n)>0) then
         used = send_data(id_prod(n),prod(:,:,:,n),Time_next,is_in=is,js_in=js)
      end if
      if(id_loss(n)>0) then
         used = send_data(id_loss(n),loss(:,:,:,n),Time_next,is_in=is,js_in=js)
      end if
      
      if (n == sphum_ndx) then
         scale_factor = WTMAIR/WTMH2O
! add PSC ice back to H2O
!         if (repartition_water_tracers) then
!           r_temp(:,:,:,n) = r_temp(:,:,:,n) + &
!                             MAX( 0.,psc_vmr_save(:,:,:,3) - MAX(r(:,:,:,inql)+r(:,:,:,inqi),0.)*scale_factor ) + &
!                             dpsc_vmr(:,:,:,3)
!        else
!           r_temp(:,:,:,n) = r_temp(:,:,:,n) + psc_vmr_save(:,:,:,3)+dpsc_vmr(:,:,:,3)
!        end if
!        if (set_min_h2o_strat) then
!           r_temp(:,:,:,n) = MAX( r_temp(:,:,:,n) - extra_h2o(:,:,:), small )
!        end if
      else
         scale_factor = 1.
      end if

!     if (n == hno3_ndx) then
!        r_temp(:,:,:,n) = r_temp(:,:,:,n) + psc_vmr_save(:,:,:,2)+dpsc_vmr(:,:,:,2) ! add PSC NAT back to gas-phase HNO3
!     end if

!-----------------------------------------------------------------------
!     ... compute tendency
!-----------------------------------------------------------------------
      tend_tmp(:,:,:) = ( r_temp(:,:,:,n) - r_in(:,:,:,n) )/dt
      if(indices(n) <= ntp) then
!-----------------------------------------------------------------------
!     ... prognostic species
!-----------------------------------------------------------------------
!        tend_tmp(:,:,:) = ( r_temp(:,:,:,n) - MAX(r(:,:,:,indices(n))*scale_factor,small) )/dt
         chem_dt(:,:,:,indices(n)) = airc_emis(:,:,:,n) + emis_source(:,:,:,n) + tend_tmp(:,:,:)
      else
!-----------------------------------------------------------------------
!     ... diagnostic species
!-----------------------------------------------------------------------
!        tend_tmp(:,:,:) = ( r_temp(:,:,:,n) - MAX(rdiag(:,:,:,indices(n)-ntp)*scale_factor,small) )/dt
         rdiag(:,:,:,indices(n)-ntp) = r_temp(:,:,:,n)
      end if
!-----------------------------------------------------------------------
!     ... output diagnostic tendency
!-----------------------------------------------------------------------
      if(id_chem_tend(n)>0) then
         used = send_data( id_chem_tend(n), tend_tmp(:,:,:), Time_next, is_in=is,js_in=js)
      end if
     
!-----------------------------------------------------------------------
!     ... apply upper boundary condition
!-----------------------------------------------------------------------
      if(has_ubc(n)) then
         call interpolator(ub(n), Time, phalf, r_ub(:,:,:,n), trim(ub_names(n)), is, js)
         if(id_ub(n)>0) then
            used = send_data(id_ub(n), r_ub(:,:,:,n), Time_next, is_in=is, js_in=js)
         end if
         where (pfull(:,:,:) < ub_pres)            
            chem_dt(:,:,:,indices(n)) = (r_ub(:,:,:,n) - r(:,:,:,indices(n))) / relaxed_dt
         endwhere
      end if

!-----------------------------------------------------------------------
!     ... apply lower boundary condition
!-----------------------------------------------------------------------
      if(has_lbc(n)) then
         if (fixed_lbc_time(n)) then
            lbc_Time = lbc_entry(n)
         else
            lbc_Time = Time
         end if
         call time_interp( lbc_Time, lb(n)%gas_time(:), frac, index1, index2 )
         r_lb(n) = lb(n)%gas_value(index1) + frac*( lb(n)%gas_value(index2) - lb(n)%gas_value(index1) )
         if(id_lb(n)>0) then
            used = send_data(id_lb(n), r_lb(n), Time_next)
         end if
         where (pfull(:,:,:) > lb_pres)
            chem_dt(:,:,:,indices(n)) = (r_lb(n) - r(:,:,:,indices(n))) / relaxed_dt_lbc
         endwhere
      end if

   end do
!-----------------------------------------------------------------------
!     ...send ox budget(jmao,1/1/2011)
!-----------------------------------------------------------------------
   if(id_prodox>0) then
      used = send_data(id_prodox, prodox(:,:,:), Time_next, is_in=is, js_in=js)
   end if
   if(id_lossox>0) then
      used = send_data(id_lossox, lossox(:,:,:), Time_next, is_in=is, js_in=js)
   end if
!-----------------------------------------------------------------------
!     ... surface concentration diagnostics
!-----------------------------------------------------------------------
      if ( o3_ndx>0 ) then
         used = send_data(id_srf_o3, r_temp(:,:,size(r_temp,3),o3_ndx), Time_next, is_in=is, js_in=js)
      end if

   
!-----------------------------------------------------------------------
!     ... special case(nox = no + no2)
!-----------------------------------------------------------------------
!  nno = get_tracer_index(MODEL_ATMOS,'no')
!  nno2 = get_tracer_index(MODEL_ATMOS,'no2')
!  if((nno /= 0) .and. (nno2 /= 0)) then
!     rno(:,:,:) = r(:,:,:,nno)/ MAX((r(:,:,:,nno) + r(:,:,:,nno2)),1.e-30)
     
!     call interpolator(ub, Time,phalf,ub_temp,'nox',is,js)

!     where(pfull(:,:,:) < ub_pres)
!        chem_dt(:,:,:,nno) =((rno(:,:,:)*ub_temp(:,:,:))-r(:,:,:,nno)) / relaxed_dt
!        chem_dt(:,:,:,nno2) = (((1.-rno(:,:,:))*ub_temp(:,:,:))-r(:,:,:,nno2)) / &
!             relaxed_dt
!     endwhere
!  end if

!-----------------------------------------------------------------------
!     ... Chemical families (Cly)
!-----------------------------------------------------------------------
   cly(:,:,:) = 0.
   if (cl_ndx>0) then
      cly(:,:,:) = cly(:,:,:) + r_temp(:,:,:,cl_ndx)
   end if
   if (clo_ndx>0) then
      cly(:,:,:) = cly(:,:,:) + r_temp(:,:,:,clo_ndx)
   end if
   if (hcl_ndx>0) then
      cly(:,:,:) = cly(:,:,:) + r_temp(:,:,:,hcl_ndx)
   end if
   if (hocl_ndx>0) then
      cly(:,:,:) = cly(:,:,:) + r_temp(:,:,:,hocl_ndx)
   end if
   if (clono2_ndx>0) then
      cly(:,:,:) = cly(:,:,:) + r_temp(:,:,:,clono2_ndx)
   end if
   if (cl2o2_ndx>0) then
      cly(:,:,:) = cly(:,:,:) + r_temp(:,:,:,cl2o2_ndx)*2
   end if
   if (cl2_ndx>0) then
      cly(:,:,:) = cly(:,:,:) + r_temp(:,:,:,cl2_ndx)*2
   end if
   if (clno2_ndx>0) then
      cly(:,:,:) = cly(:,:,:) + r_temp(:,:,:,clno2_ndx)
   end if
   if (brcl_ndx>0) then
      cly(:,:,:) = cly(:,:,:) + r_temp(:,:,:,brcl_ndx)
   end if

!-----------------------------------------------------------------------
!     ... Cly chemical tendency diagnostic
!-----------------------------------------------------------------------
   if (id_dclydt_chem>0) then
      used = send_data(id_dclydt_chem, (cly(:,:,:)-cly0(:,:,:))/dt, Time_next, is_in=is, js_in=js)
   end if

!-----------------------------------------------------------------------
!     ... Cly conservation
!-----------------------------------------------------------------------
   if (force_cly_conservation .or. rescale_cly_components) then
      if (rescale_cly_components) then
         cly_ratio(:,:,:) = r(:,:,:,cly_ndx) / MAX( cly(:,:,:), small )
         cly(:,:,:) = r(:,:,:,cly_ndx)
      else if (force_cly_conservation) then
         cly_ratio(:,:,:) = cly0(:,:,:) / MAX( cly(:,:,:), small )
         cly(:,:,:) = cly0(:,:,:)
      end if
      if (cl_ndx>0) then
         r_temp(:,:,:,cl_ndx) = r_temp(:,:,:,cl_ndx) * cly_ratio(:,:,:)
      end if
      if (clo_ndx>0) then
         r_temp(:,:,:,clo_ndx) = r_temp(:,:,:,clo_ndx) * cly_ratio(:,:,:)
      end if
      if (hcl_ndx>0) then
         r_temp(:,:,:,hcl_ndx) = r_temp(:,:,:,hcl_ndx) * cly_ratio(:,:,:)
      end if
      if (hocl_ndx>0) then
         r_temp(:,:,:,hocl_ndx) = r_temp(:,:,:,hocl_ndx) * cly_ratio(:,:,:)
      end if
      if (clono2_ndx>0) then
         r_temp(:,:,:,clono2_ndx) = r_temp(:,:,:,clono2_ndx) * cly_ratio(:,:,:)
      end if
      if (cl2o2_ndx>0) then
         r_temp(:,:,:,cl2o2_ndx) = r_temp(:,:,:,cl2o2_ndx) * cly_ratio(:,:,:)
      end if
      if (cl2_ndx>0) then
         r_temp(:,:,:,cl2_ndx) = r_temp(:,:,:,cl2_ndx) * cly_ratio(:,:,:)
      end if
      if (clno2_ndx>0) then
         r_temp(:,:,:,clno2_ndx) = r_temp(:,:,:,clno2_ndx) * cly_ratio(:,:,:)
      end if
      if (brcl_ndx>0) then
         r_temp(:,:,:,brcl_ndx) = r_temp(:,:,:,brcl_ndx) * cly_ratio(:,:,:)
      end if
   end if

!-----------------------------------------------------------------------
!     ... Chemical families (Bry, NOy)
!-----------------------------------------------------------------------
   bry(:,:,:) = 0.
   noy(:,:,:) = 0.
   if (clono2_ndx>0) then
      noy(:,:,:) = noy(:,:,:) + r_temp(:,:,:,clono2_ndx)
   end if
   if (br_ndx>0) then
      bry(:,:,:) = bry(:,:,:) + r_temp(:,:,:,br_ndx)
   end if
   if (bro_ndx>0) then
      bry(:,:,:) = bry(:,:,:) + r_temp(:,:,:,bro_ndx)
   end if
   if (hbr_ndx>0) then
      bry(:,:,:) = bry(:,:,:) + r_temp(:,:,:,hbr_ndx)
   end if
   if (hobr_ndx>0) then
      bry(:,:,:) = bry(:,:,:) + r_temp(:,:,:,hobr_ndx)
   end if
   if (brono2_ndx>0) then
      bry(:,:,:) = bry(:,:,:) + r_temp(:,:,:,brono2_ndx)
      noy(:,:,:) = noy(:,:,:) + r_temp(:,:,:,brono2_ndx)
   end if
   if (brcl_ndx>0) then
      bry(:,:,:) = bry(:,:,:) + r_temp(:,:,:,brcl_ndx)
   end if
   if (n_ndx>0) then
      noy(:,:,:) = noy(:,:,:) + r_temp(:,:,:,n_ndx)
   end if
   if (no_ndx>0) then
      noy(:,:,:) = noy(:,:,:) + r_temp(:,:,:,no_ndx)
   end if
   if (no2_ndx>0) then
      noy(:,:,:) = noy(:,:,:) + r_temp(:,:,:,no2_ndx)
   end if
   if (no3_ndx>0) then
      noy(:,:,:) = noy(:,:,:) + r_temp(:,:,:,no3_ndx)
   end if
   if (hno3_ndx>0) then
      noy(:,:,:) = noy(:,:,:) + r_temp(:,:,:,hno3_ndx)
   end if
   if (n2o5_ndx>0) then
      noy(:,:,:) = noy(:,:,:) + r_temp(:,:,:,n2o5_ndx)*2
   end if
   if (ho2no2_ndx>0) then
      noy(:,:,:) = noy(:,:,:) + r_temp(:,:,:,ho2no2_ndx)
   end if
   if (pan_ndx>0) then
      noy(:,:,:) = noy(:,:,:) + r_temp(:,:,:,pan_ndx)
   end if
   if (mpan_ndx>0) then
      noy(:,:,:) = noy(:,:,:) + r_temp(:,:,:,mpan_ndx)
   end if
   if (onit_ndx>0) then
      noy(:,:,:) = noy(:,:,:) + r_temp(:,:,:,onit_ndx)
   end if
   if (isopno3_ndx>0) then
      noy(:,:,:) = noy(:,:,:) + r_temp(:,:,:,isopno3_ndx)
   end if
   if (onitr_ndx>0) then
      noy(:,:,:) = noy(:,:,:) + r_temp(:,:,:,onitr_ndx)
   end if

!-----------------------------------------------------------------------
!     ... stratospheric Cly and Bry source
!-----------------------------------------------------------------------
   if(age_ndx > 0 .and. age_ndx <= ntp) then
      call strat_chem_dcly_dt(Time, phalf, is, js, age, cly, bry, dclydt, dbrydt)
      do k = 1,kd
         where( coszen(:,:) > 0. )
            dclydt(:,:,k) = 2*dclydt(:,:,k)
            dbrydt(:,:,k) = 2*dbrydt(:,:,k)
         elsewhere
            dclydt(:,:,k) = 0.
            dbrydt(:,:,k) = 0.
         end where
      end do
   else
      dclydt(:,:,:) = 0.
      dbrydt(:,:,:) = 0.
   end if
   if (cl_ndx>0) then
      chem_dt(:,:,:,indices(cl_ndx)) = chem_dt(:,:,:,indices(cl_ndx)) + dclydt(:,:,:)
      used = send_data(id_dclydt, dclydt, Time_next, is_in=is, js_in=js)
   end if
   if (br_ndx>0) then
      chem_dt(:,:,:,indices(br_ndx)) = chem_dt(:,:,:,indices(br_ndx)) + dbrydt(:,:,:)
      used = send_data(id_dbrydt, dbrydt, Time_next, is_in=is, js_in=js)
   end if
   
!-----------------------------------------------------------------------
!     ... Set diagnostic tracers for chemical families
!-----------------------------------------------------------------------
   if (noy_ndx > ntp) then
      rdiag(:,:,:,noy_ndx-ntp) = noy(:,:,:)
   end if
   if (cly_ndx > ntp) then
      rdiag(:,:,:,cly_ndx-ntp) = cly(:,:,:) + dclydt(:,:,:)*dt
   else if (cly_ndx > 0) then
      chem_dt(:,:,:,cly_ndx) = dclydt(:,:,:)
   end if
   if (bry_ndx > ntp) then
      rdiag(:,:,:,bry_ndx-ntp) = bry(:,:,:) + dbrydt(:,:,:)*dt
   end if

!-----------------------------------------------------------------------
!     ... Photolysis rates
!-----------------------------------------------------------------------
   do n = 1,phtcnt
      if(id_jval(n)>0) then
         used = send_data(id_jval(n),jvals(:,:,:,n),Time_next,is_in=is,js_in=js)
      end if
   end do

!-----------------------------------------------------------------------
!     ... Kinetic reaction rates
!-----------------------------------------------------------------------
   do n = 1,gascnt
      if(id_rate_const(n)>0) then
         used = send_data(id_rate_const(n),rate_constants(:,:,:,n),Time_next,is_in=is,js_in=js)
      end if
   end do

!-----------------------------------------------------------------------
!     ... Output diagnostics
!-----------------------------------------------------------------------
   used = send_data(id_volc_aer, strat_aerosol, Time_next, is_in=is, js_in=js)
   used = send_data(id_psc_sat, psc_vmr_save(:,:,:,1), Time_next, is_in=is, js_in=js)
   used = send_data(id_psc_nat, psc_vmr_save(:,:,:,2), Time_next, is_in=is, js_in=js)
   used = send_data(id_psc_ice, psc_vmr_save(:,:,:,3), Time_next, is_in=is, js_in=js)
   if (id_h2o_chem>0) then
      if (sphum_ndx>0) then
         used = send_data(id_h2o_chem, r_temp(:,:,:,sphum_ndx), Time_next, is_in=is, js_in=js)
      else
         used = send_data(id_h2o_chem, q(:,:,:)*WTMAIR/WTMH2O, Time_next, is_in=is, js_in=js)
      end if
   end if      
   used = send_data(id_coszen, coszen_local(:,:), Time_next, is_in=is, js_in=js)
   used = send_data(id_imp_slv_nonconv,imp_slv_nonconv(:,:,:),Time_next,is_in=is,js_in=js)

!-----------------------------------------------------------------------
!     ... convert H2O VMR tendency to specific humidity tendency
!-----------------------------------------------------------------------
   if (sphum_ndx > 0) then
      n = indices(sphum_ndx)
      chem_dt(:,:,:,n) = chem_dt(:,:,:,n) * WTMH2O / WTMAIR
!     chem_dt(:,:,:,n) = 0.
   end if

!  call mpp_clock_end(clock_id)
   
!-----------------------------------------------------------------------
    
end subroutine tropchem_driver
!</SUBROUTINE>

!#######################################################################

! <FUNCTION NAME="tropchem_driver_init">
!   <OVERVIEW>
!     Initializes the tropospheric chemistry driver.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This subroutine initializes the tropospheric chemistry module.
!     It is called from atmos_tracer_driver_init.
!     Data sets are read in for dry deposition, upper boundary conditions,
!     and emissions. Off-line sulfate concentrations are also read in for
!     use in calculating heterogeneous reaction rates (if SO4 is not
!     included as a tracer).
!   </DESCRIPTION>
!   <TEMPLATE>
!     Ltropchem = tropchem_driver_init( r, mask, axes, Time, &
!                                       lonb_mod, latb_mod, phalf, &
!                                       drydep_data )
!   </TEMPLATE>
!   <IN NAME="mask" TYPE="real, optional" DIM="(:,:,:)">
!      optional mask that designates which grid points
!      are above (1) or below (0) the ground
!   </IN>
!   <IN NAME="axes" TYPE="integer" DIM="(4)">
!     The axes relating to the tracer array
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="lonb_mod" TYPE="real" DIM="(:,:)">
!     The longitude corners for the local domain.
!   </IN>
!   <IN NAME="latb_mod" TYPE="real" DIM="(:,:)">
!     The latitude corners for the local domain.
!   </IN>
!   <IN NAME="phalf" TYPE="real" DIM="(:,:,:)">
!     Pressure on the model half levels (Pa)
!   </IN>
!   <OUT NAME="drydep_data" TYPE="interpolate_type" DIM="(:)">
!     Tracer dry deposition velocities
!   </OUT>
!   <OUT NAME="Ltropchem" TYPE="logical">
!     Do tropospheric chemistry? (Output as function value)
!   </OUT>
!   <INOUT NAME="r" TYPE="real" DIM="(:,:,:,:)">
!     Tracer mixing ratios (tropchem tracers in VMR)
!   </INOUT>

function tropchem_driver_init( r, mask, axes, Time, &
                               lonb_mod, latb_mod, phalf, &
                               drydep_data ) result(Ltropchem)

!-----------------------------------------------------------------------
!
!   r    = tracer fields dimensioned as (nlon,nlat,nlev,ntrace)
!   mask = optional mask (0. or 1.) that designates which grid points
!          are above (=1.) or below (=0.) the ground dimensioned as
!          (nlon,nlat,nlev).
!
!-----------------------------------------------------------------------
   real, intent(inout), dimension(:,:,:,:) :: r
   real, intent(in),    dimension(:,:,:), optional :: mask
   type(time_type), intent(in) :: Time
   integer        , intent(in) :: axes(4)
   real, intent(in), dimension(:,:) :: lonb_mod
   real, intent(in), dimension(:,:) :: latb_mod
   real, intent(in),dimension(:,:,:) :: phalf
   type(interpolate_type), intent(out) :: drydep_data(:)

   logical :: Ltropchem
   integer :: flag_file, flag_spec, flag_fixed
   integer :: n,i
   integer :: ierr, io, logunit
   character(len=64) :: nc_file,filename,specname
   character(len=256) :: control=''
   character(len=64) :: name=''
   type(interpolate_type) :: init_conc
   character(len=64),dimension(pcnstm1) :: emis_files = '', &
                                           emis3d_files = '', &
                                           conc_files = '', &
                                           ub_files = '', &
                                           lb_files = '', &
                                           dry_files, &
                                           wet_ind, &
                                           conc_names, &
                                           dry_names, &
                                           airc_files
   logical :: tracer_initialized

   integer :: unit
   character(len=16) ::  fld

   integer :: flb, series_length, year, diy
   real :: input_time
   real :: scale_factor, extra_seconds, fixed_year
   type(time_type) :: Year_t
!
!-----------------------------------------------------------------------
!
   if (module_is_initialized) return

!-----------------------------------------------------------------------
!     ... write version number
!-----------------------------------------------------------------------
   call write_version_number(version, tagname)
    
!-----------------------------------------------------------------------
!     ... read namelist
!-----------------------------------------------------------------------
   if(file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=tropchem_driver_nml, iostat=io)
      ierr = check_nml_error(io,'tropchem_driver_nml')
#else
      unit = open_namelist_file('input.nml')
      ierr=1; do while (ierr /= 0)
      read(unit, nml = tropchem_driver_nml, iostat=io, end=10)
      ierr = check_nml_error (io, 'tropchem_driver_nml')
      end do
10    call close_file(unit)
#endif
   end if
  
   logunit = stdlog()
   if(mpp_pe() == mpp_root_pe()) then       
      write(logunit, nml=tropchem_driver_nml)
      verbose = verbose + 1
   end if

   Ltropchem = do_tropchem
   if (.not. Ltropchem) then
      return
   end if
      
!-------------------------------------------------------------------------
!     ... Make sure input value for clouds_in_fastjx is a valid option.
!-------------------------------------------------------------------------
   if (trim(clouds_in_fastjx) == 'none') then
     use_lsc_in_fastjx = .false.
   else if (trim(clouds_in_fastjx) == 'lsc_only') then
     use_lsc_in_fastjx = .true.
   else
     call error_mesg ('tropchem_driver_init', &
                     ' invalid string for clouds_in_fastjx', FATAL)
   endif

!-----------------------------------------------------------------------
!     ... Setup sulfate input/interpolation
!-----------------------------------------------------------------------
   call interpolator_init( sulfate, trim(file_sulfate), lonb_mod, latb_mod, &
                           data_out_of_bounds=(/CONSTANT/),      &
                           vert_interp=(/INTERP_WEIGHTED_P/) )

!-----------------------------------------------------------------------
!     ... Initialize chemistry driver
!-----------------------------------------------------------------------
   call chemini( file_jval_lut, file_jval_lut_min, use_tdep_jvals, &
                 o3_column_top, jno_scale_factor, verbose,   &
                 retain_cm3_bugs, do_fastjx_photo)
   
!-----------------------------------------------------------------------
!     ... set initial value of indices
!-----------------------------------------------------------------------
   indices(:) = 0
   do i=1,pcnstm1
      n = get_tracer_index(MODEL_ATMOS, tracnam(i))
      if (trim(tracnam(i)) == 'H2O') then
         if (n <= 0) then
            n = get_tracer_index(MODEL_ATMOS, 'sphum')
         end if
         sphum_ndx = i
         do_interactive_h2o = .true.
      end if
      if (n >0) then
         indices(i) = n
         if (indices(i) > 0 .and. mpp_pe() == mpp_root_pe()) then 
            write(*,30) tracnam(i),indices(i)
            write(logunit,30) trim(tracnam(i)),indices(i)
         end if
      else
!<ERROR MSG="Tropospheric chemistry tracer not found in field table" STATUS="WARNING">
!   A tropospheric chemistry tracer was not included in the field table
!</ERROR>
         call error_mesg ('tropchem_driver_init', trim(tracnam(i)) // ' is not found', WARNING)
      end if
   end do
30 format (A,' was initialized as tracer number ',i3)

   cl_ndx     = get_spc_ndx('Cl')
   clo_ndx    = get_spc_ndx('ClO')
   hcl_ndx    = get_spc_ndx('HCl')
   hocl_ndx   = get_spc_ndx('HOCl')
   clono2_ndx = get_spc_ndx('ClONO2')
   cl2o2_ndx  = get_spc_ndx('Cl2O2')
   cl2_ndx    = get_spc_ndx('Cl2')
   clno2_ndx  = get_spc_ndx('ClNO2')
   br_ndx     = get_spc_ndx('Br')
   bro_ndx    = get_spc_ndx('BrO')
   hbr_ndx    = get_spc_ndx('HBr')
   hobr_ndx   = get_spc_ndx('HOBr')
   brono2_ndx = get_spc_ndx('BrONO2')
   brcl_ndx   = get_spc_ndx('BrCl')
   hno3_ndx   = get_spc_ndx('HNO3')
   no_ndx     = get_spc_ndx('NO')
   no2_ndx    = get_spc_ndx('NO2')
   no3_ndx    = get_spc_ndx('NO3')
   n_ndx      = get_spc_ndx('N')
   n2o5_ndx   = get_spc_ndx('N2O5')
   ho2no2_ndx = get_spc_ndx('HO2NO2')
   pan_ndx    = get_spc_ndx('PAN')
   onit_ndx   = get_spc_ndx('ONIT')
   mpan_ndx   = get_spc_ndx('MPAN')
   isopno3_ndx= get_spc_ndx('ISOPNO3')
   onitr_ndx  = get_spc_ndx('ONITR')
   o3_ndx     = get_spc_ndx('O3')
   ch4_ndx    = get_spc_ndx('CH4')
   dms_ndx    = get_spc_ndx('DMS')

   extinct_ndx = get_tracer_index(MODEL_ATMOS, 'Extinction')
   noy_ndx     = get_tracer_index(MODEL_ATMOS, 'NOy')
   cly_ndx     = get_tracer_index(MODEL_ATMOS, 'Cly')
   bry_ndx     = get_tracer_index(MODEL_ATMOS, 'Bry')

!-----------------------------------------------------------------------
!     ... Check Cly settings
!-----------------------------------------------------------------------
   if (rescale_cly_components) then
      if (cly_ndx == NO_TRACER .or. .not. check_if_prognostic(MODEL_ATMOS,cly_ndx)) then
         call error_mesg ('tropchem_driver_init', &
                          'rescale_cly_components=T requires Cly to be registered as a prognostic tracer', FATAL)
      end if
      if (force_cly_conservation) then
         call error_mesg ('tropchem_driver_init', &
                          'rescale_cly_components=T incompatible with force_cly_conservation=T setting', FATAL)
      end if
   end if

!-----------------------------------------------------------------------
!     ... Setup dry deposition
!-----------------------------------------------------------------------
   call tropchem_drydep_init( dry_files, dry_names, &
                              lonb_mod, latb_mod, &
                              drydep_data )

!-----------------------------------------------------------------------
!     ... Setup upper boundary condition data
!-----------------------------------------------------------------------
   call interpolator_init( ub_default, trim(file_ub), lonb_mod, latb_mod, &
                           data_out_of_bounds=(/CONSTANT/),          &
                           vert_interp=(/INTERP_WEIGHTED_P/) )

!-----------------------------------------------------------------------
!     ... Set up concentration input/interpolation
!-----------------------------------------------------------------------
   call interpolator_init( conc, trim(file_conc), lonb_mod, latb_mod, &
                           data_out_of_bounds=(/CONSTANT/),&
                           vert_interp=(/INTERP_WEIGHTED_P/) )

!-----------------------------------------------------------------------
!     ... Set up aircraft emissions interpolation
!-----------------------------------------------------------------------
   call interpolator_init( airc_default, trim(file_aircraft), lonb_mod, latb_mod,&
                           data_out_of_bounds=(/CONSTANT/), &
                           vert_interp=(/INTERP_WEIGHTED_P/))

!-----------------------------------------------------------------------
!     ... Setup emissions input/interpolation
!-----------------------------------------------------------------------
   do i = 1,pcnstm1
      nc_file = trim(file_emis_1)//lowercase(trim(tracnam(i)))//trim(file_emis_2)
      call init_emis_data( inter_emis(i), MODEL_ATMOS, 'emissions', indices(i), nc_file, &
                           lonb_mod, latb_mod, emis_field_names(i), &
                           has_emis(i), diurnal_emis(i), axes, Time )
      if( has_emis(i) ) emis_files(i) = trim(nc_file)
        
!-----------------------------------------------------------------------
!     ... Vertically-distributed emissions
!-----------------------------------------------------------------------
      nc_file = trim(file_emis3d_1)//lowercase(trim(tracnam(i)))//trim(file_emis3d_2)
      call init_emis_data( inter_emis3d(i), MODEL_ATMOS, 'emissions3d', indices(i), nc_file, &
                           lonb_mod, latb_mod, emis3d_field_names(i), &
                           has_emis3d(i), diurnal_emis3d(i), axes, Time )
      if( has_emis3d(i) ) emis3d_files(i) = trim(nc_file)

!-----------------------------------------------------------------------
!     ... Interactive emissions
!-----------------------------------------------------------------------
      call init_xactive_emis( MODEL_ATMOS, 'xactive_emissions', indices(i), tracnam(i), &
                              axes, Time, lonb_mod, latb_mod, phalf, &
                              has_xactive_emis(i), id_xactive_emis(i), mask )

!-----------------------------------------------------------------------
!     ... Upper boundary condition
!-----------------------------------------------------------------------
      if( query_method('upper_bound', MODEL_ATMOS,indices(i),name,control) ) then
         if( trim(name)=='file' ) then
            flag_file = parse(control, 'file',filename)
            flag_spec = parse(control, 'name',specname)

            if( flag_file > 0 .and. trim(filename) /= trim(file_ub) ) then
               ub_files(i) = trim(filename)
               call interpolator_init(ub(i), trim(filename), lonb_mod, latb_mod, &
                       data_out_of_bounds=(/CONSTANT/),          &
                       vert_interp=(/INTERP_WEIGHTED_P/))
            else
               ub_files(i) = trim(file_ub)
               ub(i) = ub_default
            end if
            if(flag_spec > 0) then
               ub_names(i) = trim(specname)
            else
               ub_names(i) = trim(lowercase(tracnam(i)))
            end if

            has_ubc(i) = .true.
              
         end if
      end if

!-----------------------------------------------------------------------
!     ... Lower boundary condition
!-----------------------------------------------------------------------
      lbc_entry(i) = get_base_time()     
      if( query_method('lower_bound', MODEL_ATMOS,indices(i),name,control) ) then
         if( trim(name)=='file' ) then
            flag_file = parse(control, 'file', filename)
            flag_spec = parse(control, 'factor', scale_factor)
            flag_fixed = parse(control, 'fixed_year', fixed_year)
            if( flag_file > 0 ) then
               lb_files(i) = 'INPUT/' // trim(filename)
               if( file_exist(lb_files(i)) ) then
                  flb = open_namelist_file( lb_files(i) )
                  read(flb, FMT='(i12)') series_length
                  allocate( lb(i)%gas_value(series_length), &
                            lb(i)%gas_time(series_length) )
!---------------------------------------------------------------------
!    convert the time stamps of the series to time_type variables.     
!---------------------------------------------------------------------
                  do n = 1,series_length
                     read (flb, FMT = '(2f12.4)') input_time, lb(i)%gas_value(n)
                     year = INT(input_time)
                     Year_t = set_date(year,1,1,0,0,0)
                     diy = days_in_year (Year_t)
                     extra_seconds = (input_time - year)*diy*SECONDS_PER_DAY 
                     lb(i)%gas_time(n) = Year_t + set_time(NINT(extra_seconds), 0)
                  end do
                  if (flag_spec > 0) then
                     lb(i)%gas_value(:) = lb(i)%gas_value(:) * scale_factor
                  end if
                  call close_file( flb )
                  if( flag_fixed > 0 ) then
                     fixed_lbc_time(i) = .true.
                     year = INT(fixed_year)
                     Year_t = set_date(year,1,1,0,0,0)
                     diy = days_in_year (Year_t)
                     extra_seconds = (fixed_year - year)*diy*SECONDS_PER_DAY 
                     lbc_entry(i) = Year_t + set_time(NINT(extra_seconds), 0)
                  end if
               else
                  call error_mesg ('tropchem_driver_init', &
                                   'Failed to find input file '//trim(lb_files(i)), FATAL)
               end if
            else
               call error_mesg ('tropchem_driver_init', 'Tracer '//trim(lowercase(tracnam(i)))// &
                                ' has lower_bound specified without a filename', FATAL)
            end if
            has_lbc(i) = .true.
         end if
      end if

!-----------------------------------------------------------------------
!     ... Initial conditions
!-----------------------------------------------------------------------
      tracer_initialized = .false.
      if ( field_exist('INPUT/atmos_tracers.res.nc', lowercase(tracnam(i))) .or. &
           field_exist('INPUT/fv_tracer.res.nc', lowercase(tracnam(i))) .or. &
           field_exist('INPUT/tracer_'//trim(lowercase(tracnam(i)))//'.res', lowercase(tracnam(i))) ) then
         tracer_initialized = .true.
      end if

      if(.not. tracer_initialized) then
         if( query_method('init_conc',MODEL_ATMOS,indices(i),name,control) ) then
            if( trim(name) == 'file' ) then
               flag_file = parse(control, 'file',filename)
               flag_spec = parse(control, 'name',specname)

               if( flag_file>0 .and. trim(filename) /= trim(file_conc) ) then
                  conc_files(i) = trim(filename)
                  call interpolator_init( init_conc,trim(filename),lonb_mod,latb_mod,&
                                          data_out_of_bounds=(/CONSTANT/), &
                                          vert_interp=(/INTERP_WEIGHTED_P/) )
               else
                  conc_files(i) = trim(file_conc)
                  init_conc = conc
               end if
                  
               if( flag_spec > 0 ) then
                  conc_names(i) = trim(lowercase(specname))
                  specname = lowercase(specname)
               else
                  conc_names(i) = trim(lowercase(tracnam(i)))
                  specname = trim(lowercase(tracnam(i)))
               end if
                  
               call interpolator(init_conc, Time, phalf,r(:,:,:,indices(i)),trim(specname))
            end if
         end if
      end if
             
!-----------------------------------------------------------------------
!     ... Aircraft emissions
!-----------------------------------------------------------------------
      if( query_method('aircraft_emis',MODEL_ATMOS,indices(i),name,control) ) then
         has_airc(i) = .true.
         if( trim(name) == 'file' ) then
            flag_file = parse(control,'file',filename)
            flag_spec = parse(control,'name',specname)

            if( flag_file >0 .and. trim(filename) /= trim(lowercase(file_aircraft)) ) then
               airc_files(i) = trim(filename)
               call interpolator_init( inter_aircraft_emis(i),trim(filename), lonb_mod, latb_mod, &
                                       data_out_of_bounds=(/CONSTANT/), &
                                       vert_interp=(/INTERP_WEIGHTED_P/) )
            else
               airc_files(i) = trim(file_aircraft)
               inter_aircraft_emis(i) = airc_default
            end if
               
            if( flag_spec >0 ) then
               airc_names(i) = trim(specname)
            else
               airc_names(i) = trim(lowercase(tracnam(i)))
            end if
         end if
      end if

             
!-----------------------------------------------------------------------
!     ... Wet deposition
!-----------------------------------------------------------------------
      if( query_method('wet_deposition',MODEL_ATMOS,indices(i),name,control) ) then
         wet_ind(i) = 'This species has wet deposition'
      else
         wet_ind(i) = ''
      end if
         
   end do
   
!-----------------------------------------------------------------------
!     ... Print out settings for tracer
!-----------------------------------------------------------------------
   if( mpp_pe() == mpp_root_pe() ) then
      write(logunit,*) '---------------------------------------------------------------------------------------'
      do i = 1,pcnstm1
         write(logunit,*) 'The tracname index is ',i
         write(logunit,*) 'The tracname is ',tracnam(i)
         if(check_if_prognostic(MODEL_ATMOS,indices(i))) then
            write(logunit,*) 'This is a prognostic tracer.'
         else
            write(logunit,*) 'This is a diagnostic tracer.'
         end if
         if(has_emis(i)) then
            write(logunit,*)'Emissions from file: ',trim(emis_files(i))
         end if
         if(has_emis3d(i)) then
            write(logunit,*)'3-D Emissions from file: ',trim(emis3d_files(i))
         end if
         if(has_ubc(i)) then
            write(logunit,*)'Upper BC from file: ',trim(ub_files(i)), &
                             ', with the name of ',trim(ub_names(i))
         end if
         if(has_lbc(i)) then
            write(logunit,*)'Lower BC from file: ',trim(lb_files(i))
            if (fixed_lbc_time(i)) then
               write(logunit,*) '... with fixed year'
            end if
         end if
         if(conc_files(i) /= '') then
            write(logunit,*)'Concentration from file: ',trim(conc_files(i)), &
                             ', with the name of ',trim(conc_names(i))
         end if
         if(dry_files(i) /= '') then
            write(logunit,*)'Dry deposition velocity from file: ',trim(dry_files(i)), &
                             ' with the name of '//trim(dry_names(i))
         end if
         if(wet_ind(i) /= '') then
            write(logunit,*) wet_ind(i)
         end if
         if(has_airc(i)) then
            write(logunit,*)'Aircraft emissions from file: ',trim(airc_files(i)), &
                             ' with the name of '//trim(airc_names(i))
         end if
         write(logunit,*) '---------------------------------------------------------------------------------------'
      end do
   end if


!-----------------------------------------------------------------------
!     ... Get the index number for the cloud variables
!-----------------------------------------------------------------------
   inqa = get_tracer_index(MODEL_ATMOS,'cld_amt') ! cloud fraction
   inql = get_tracer_index(MODEL_ATMOS,'liq_wat') ! cloud liquid specific humidity
   inqi = get_tracer_index(MODEL_ATMOS,'ice_wat') ! cloud ice water specific humidity
      
   age_ndx = get_tracer_index(MODEL_ATMOS,'age')  ! age tracer

!-----------------------------------------------------------------------
!     ... Call the chemistry hook init routine
!-----------------------------------------------------------------------
   call moz_hook_init( lght_no_prd_factor, Time, axes, verbose )

!-----------------------------------------------------------------------
!     ... Initializations for stratospheric chemistry
!-----------------------------------------------------------------------
!++lwh
   if (set_min_h2o_strat) then
      if (ch4_ndx>0) then
         if (.not. has_lbc(ch4_ndx)) then
            call error_mesg ('Tropchem_driver','set_min_h2o_strat=T, but LBC not set for CH4', FATAL)
         end if
      else
         call error_mesg ('Tropchem_driver','set_min_h2o_strat=T, but CH4 not included in chemistry solver', FATAL)
      end if
   end if
   call strat_chem_utilities_init( lonb_mod, latb_mod, &
                                   strat_chem_age_factor, strat_chem_dclydt_factor, &
                                   set_min_h2o_strat, ch4_filename, ch4_scale_factor, &
                                   fixed_lbc_time(ch4_ndx), lbc_entry(ch4_ndx), &
                                   cfc_lbc_filename, time_varying_cfc_lbc, cfc_lbc_dataset_entry )
!--lwh
   id_dclydt      = register_diag_field( module_name, 'cly_chem_dt', axes(1:3), Time, 'cly_chem_dt', 'VMR/s' )
   id_dclydt_chem = register_diag_field( module_name, 'cly_chem_dt_diag', axes(1:3), Time, 'cly_chem_dt_diag', 'VMR/s' )
   id_dbrydt      = register_diag_field( module_name, 'bry_chem_dt', axes(1:3), Time, 'bry_chem_dt', 'VMR/s' )

   id_volc_aer = register_diag_field( module_name, 'volc_aer_SA', axes(1:3), Time, 'volcanic_aerosol_surface_area', 'cm2/cm3' )
   id_psc_sat  = register_diag_field( module_name, 'psc_sat', axes(1:3), Time, 'psc_sat', 'VMR' )
   id_psc_nat  = register_diag_field( module_name, 'psc_nat', axes(1:3), Time, 'psc_nat', 'VMR' )
   id_psc_ice  = register_diag_field( module_name, 'psc_ice', axes(1:3), Time, 'psc_ice', 'VMR' )
   id_h2o_chem = register_diag_field( module_name, 'h2o_chem', axes(1:3), Time, 'h2o_chem', 'VMR' )

!-----------------------------------------------------------------------
!     ... Initialize additional diagnostics
!-----------------------------------------------------------------------
   id_sul = register_diag_field( module_name, 'sulfate', axes(1:3), Time, 'sulfate', 'VMR' )
   id_coszen = register_diag_field( module_name, 'coszen_tropchem', axes(1:2), Time, &
                                             'cosine_sza_tropchem', 'none' )
   id_imp_slv_nonconv = register_diag_field( module_name, 'imp_slv_nonconv', axes(1:3), Time, &
                                             'tropchem_implicit_solver_not_converged', 'VMR' )
   id_srf_o3 = register_diag_field( module_name, 'o3_srf', axes(1:2), Time, 'o3_srf', 'VMR' )

!-----------------------------------------------------------------------
!     ... Register diagnostic fields for species tendencies
!-----------------------------------------------------------------------
   id_co_emis_cmip =     &
        register_diag_field( module_name, 'co_emis_cmip', axes(1:2), &
                             Time, 'co_emis_cmip', 'kg/m2/s')
   id_no_emis_cmip =     &
        register_diag_field( module_name, 'no_emis_cmip', axes(1:2), &
                            Time, 'no_emis_cmip', 'kg/m2/s')  
   id_so2_emis_cmip =     &
        register_diag_field( module_name, 'so2_emis_cmip', axes(1:2), &
                             Time, 'so2_emis_cmip', 'kg/m2/s')
   id_nh3_emis_cmip =     &
        register_diag_field( module_name, 'nh3_emis_cmip', axes(1:2), &
                            Time, 'nh3_emis_cmip', 'kg/m2/s')  

   id_co_emis_cmip2 =     &
        register_diag_field( module_name, 'co_emis_cmip2', axes(1:2), &
                             Time, 'co_emis_cmip2', 'kg/m2/s')
   id_no_emis_cmip2 =     &
        register_diag_field( module_name, 'no_emis_cmip2', axes(1:2), &
                            Time, 'no_emis_cmip2', 'kg/m2/s')  
   id_so2_emis_cmip2 =     &
        register_diag_field( module_name, 'so2_emis_cmip2', axes(1:2), &
                             Time, 'so2_emis_cmip2', 'kg/m2/s')
   id_nh3_emis_cmip2 =     &
        register_diag_field( module_name, 'nh3_emis_cmip2', axes(1:2), &
                            Time, 'nh3_emis_cmip2', 'kg/m2/s')  
!--for Ox(jmao,1/1/2011)
   id_prodox = register_diag_field( module_name, 'Ox_prod', axes(1:3), &
        Time, 'Ox_prod','VMR/s')
   id_lossox = register_diag_field( module_name, 'Ox_loss', axes(1:3), &
        Time, 'Ox_loss','VMR/s')

   do i=1,pcnstm1
      id_chem_tend(i) = register_diag_field( module_name, trim(tracnam(i))//'_chem_dt', axes(1:3), &
                                             Time, trim(tracnam(i))//'_chem_dt','VMR/s' )
      id_prod(i) = register_diag_field( module_name, trim(tracnam(i))//'_prod', axes(1:3), &
                                        Time, trim(tracnam(i))//'_prod','VMR/s')
      id_loss(i) = register_diag_field( module_name, trim(tracnam(i))//'_loss', axes(1:3), &
                                        Time, trim(tracnam(i))//'_loss','VMR/s')
      if( has_emis(i) ) then
         id_emis(i) = register_diag_field( module_name, trim(tracnam(i))//'_emis', axes(1:2), &
                                           Time, trim(tracnam(i))//'_emis', 'molec/cm2/s')
      else
         id_emis(i) = 0
      end if
      if( has_emis3d(i) ) then
         id_emis3d(i) = register_diag_field( module_name, trim(tracnam(i))//'_emis3d', axes(1:3), &
                                             Time, trim(tracnam(i))//'_emis3d', 'molec/cm2/s')
      else
         id_emis3d(i) = 0
      end if
!     if( has_xactive_emis(i) ) then
         select case (trim(tracnam(i)))
         case ('ISOP')
               id_glaiage = register_diag_field( module_name, 'gamma_lai_age', axes(1:2), &
                    Time, 'gamma_lai_age', 'unitless' )
               id_gtemp = register_diag_field( module_name, 'gamma_temp', axes(1:2), &
                    Time, 'gamma_temp', 'unitless' )
               id_glight = register_diag_field( module_name, 'gamma_light', axes(1:2), &
                    Time, 'gamma_light', 'unitless' )
               id_tsfc = register_diag_field( module_name, 'tsfcair', axes(1:2), &
                    Time, 'tsfcair', 'K' )
               id_fsds = register_diag_field( module_name, 'fsdvd', axes(1:2), &
                    Time, 'fsdvd', 'W/m2' )
               id_ctas = register_diag_field( module_name, 'clim_tas', axes(1:2), &
                    Time, 'clim_tas', 'K' )
               id_cfsds = register_diag_field( module_name, 'clim_fsds', axes(1:2), &
                    Time, 'clim_fsds', 'umol/m2/s PAR' )
         case default
         end select
!     else
!        id_xactive_emis(i) = 0
!     end if
      if( has_ubc(i) ) then
         id_ub(i) = register_diag_field( module_name, trim(tracnam(i))//'_up', axes(1:3), &
                                         Time, trim(tracnam(i))//'_up','VMR' )
      else
         id_ub(i) = 0
      end if
      if( has_lbc(i) ) then
         id_lb(i) = register_diag_field( module_name, trim(tracnam(i))//'_lbc', &
                                         Time, trim(tracnam(i))//'_lbc','VMR' )
      else
         id_lb(i) = 0
      end if
      if( has_airc(i) ) then
         id_airc(i) = register_diag_field( module_name, trim(tracnam(i))//'_airc_emis', axes(1:3), &
                                           Time, trim(tracnam(i))//'_airc_emis','molec/cm2/s' )
      else
         id_airc(i) = 0
      end if
   end do

!-----------------------------------------------------------------------
!     ... Register diagnostic fields for photolysis rates
!-----------------------------------------------------------------------
   do i=1,phtcnt
      write(fld,'(''jval_'',I3.3,8x)') i
      id_jval(i) = register_diag_field( module_name, TRIM(fld), axes(1:3), Time, TRIM(fld),'1/s')
   end do

!-----------------------------------------------------------------------
!     ... Register diagnostic fields for kinetic rate constants
!-----------------------------------------------------------------------
   do i=1,gascnt
      write(fld,'(''k_rxn'',I3.3,8x)') i
      id_rate_const(i) = register_diag_field( module_name, TRIM(fld), axes(1:3), Time, TRIM(fld),'cm3/molec/s')
   end do

!-----------------------------------------------------------------------
!     ... initialize time_interp
!-----------------------------------------------------------------------
   call time_interp_init
      

!-----------------------------------------------------------------------
!     ... initialize esfsw_parameters
!-----------------------------------------------------------------------
   call esfsw_parameters_init

!-----------------------------------------------------------------------
!     ... initialize mpp clock id
!-----------------------------------------------------------------------
!  clock_id = mpp_clock_id('Chemistry')
      
   module_is_initialized = .true.
      
      
!-----------------------------------------------------------------------
      
end function tropchem_driver_init
!</FUNCTION>
 
!#####################################################################

subroutine tropchem_driver_time_vary (Time)

type(time_type), intent(in) :: Time

      integer :: yr, mo,day, hr,min, sec
      integer :: n

      do n=1, size(inter_emis,1)
        if (has_emis(n)) then
          call obtain_interpolator_time_slices (inter_emis(n), Time)
        endif
      end do

      do n=1, size(inter_emis3d,1)
        if (has_emis3d(n)) then
          call obtain_interpolator_time_slices (inter_emis3d(n), Time)
        endif
      end do

      do n=1, size(inter_aircraft_emis,1)
        if (has_airc(n)) then
          call obtain_interpolator_time_slices   &
                                         (inter_aircraft_emis(n), Time)
        endif
      end do

      call obtain_interpolator_time_slices (conc, Time)

      call obtain_interpolator_time_slices (sulfate, Time)

      do n=1, size(ub,1)
        if (has_ubc(n)) then
          call obtain_interpolator_time_slices (ub(n), Time)
        endif
      end do

      call strat_chem_dcly_dt_time_vary (Time)

!----------------------------------------------------------------------
!    determine if this time step starts a new month; if so, then
!    new interactive isoprene emission data is needed, and the 
!    necessary flag is set.
!----------------------------------------------------------------------
      do n=1,pcnstm1
        if ( has_xactive_emis(n) .or. id_xactive_emis(n)>0 ) then
          select case (trim(tracnam(n)))
            case ('ISOP')
              call get_date(Time,yr,mo,day,hr,min,sec)  !model GMT
              newmonth = ( mo /= isop_oldmonth )
              if (newmonth) then
                isop_oldmonth = mo
              endif
            case ('DMS')
              call atmos_sulfate_time_vary (Time)
            case default
          end select
        endif
      end do
             

end subroutine tropchem_driver_time_vary 
      



!#####################################################################

subroutine tropchem_driver_endts


      integer :: n

      do n=1, size(inter_emis,1)
        if (has_emis(n)) then
          call unset_interpolator_time_flag(inter_emis(n))
         endif
      end do

      do n=1, size(inter_emis3d,1)
        if (has_emis3d(n)) then
         call unset_interpolator_time_flag(inter_emis3d(n))
        endif
      end do

      do n=1, size(inter_aircraft_emis,1)
        if (has_airc(n)) then
          call unset_interpolator_time_flag(inter_aircraft_emis(n))
        endif
      end do

      call unset_interpolator_time_flag(conc)           
      call unset_interpolator_time_flag(sulfate)         

      do n=1, size(ub,1)
        if (has_ubc(n)) then
          call unset_interpolator_time_flag(ub(n))
        endif
      end do

      call strat_chem_dcly_dt_endts               



end subroutine tropchem_driver_endts


!######################################################################

subroutine tropchem_driver_end

!-----------------------------------------------------------------------
!     ... initialize mpp clock id
!-----------------------------------------------------------------------
      
   module_is_initialized = .false.
      
      
!-----------------------------------------------------------------------
      
end subroutine tropchem_driver_end

!#######################################################################

! <SUBROUTINE NAME="read_2D_emis_data">
!   <OVERVIEW>
!     Read emissions file
!   </OVERVIEW>
!   <DESCRIPTION>
!     Reads tracer surface emissions from a NetCDF file
!   </DESCRIPTION>
!   <TEMPLATE>
!     call read_2D_emis_data( emis_type, emis, Time, &
!                             field_names, &
!                             Ldiurnal, coszen, half_day, lon, &
!                             is, js, id_emis_diag ) 
!   </TEMPLATE>

subroutine read_2D_emis_data( emis_type, emis, Time, Time_next, &
                              field_names, &
                              Ldiurnal, coszen, half_day, lon, &
                              is, js, id_emis_diag )
    
   type(interpolate_type),intent(inout) :: emis_type
   real, dimension(:,:),intent(out) :: emis
   type(time_type),intent(in) :: Time, Time_next
   character(len=*),dimension(:), intent(in) :: field_names
   logical, intent(in) :: Ldiurnal
   real, dimension(:,:), intent(in) :: coszen, half_day, lon
   integer, intent(in) :: is, js
   integer, intent(in),optional :: id_emis_diag ! id for diagnostic


   integer :: i, j, k
   logical :: used
   real, dimension(size(emis,1),size(emis,2)) :: temp_data
   real :: diurnal_scale_factor, gmt, iso_on, iso_off, dayfrac
   real :: local_angle, factor_tmp

   emis(:,:) = 0.
   temp_data(:,:) = 0.
   do k = 1,size(field_names)
      call interpolator(emis_type,Time,temp_data,field_names(k),is,js)
      emis(:,:) = emis(:,:) + temp_data(:,:)
   end do

   if (Ldiurnal) then
      do j=1,size(emis,2)
      do i=1,size(emis,1)
         if( coszen(i,j) < 0. ) then
            diurnal_scale_factor = 0.
         else
            iso_off = .8 * half_day(i,j)
            iso_on  = -iso_off
            dayfrac = iso_off/PI
            gmt = universal_time(Time)
            local_angle = gmt + lon(i,j) - PI
            if (local_angle >= PI) local_angle = local_angle - twopi
            if (local_angle < -PI) local_angle = local_angle + twopi
            if( local_angle >= iso_off .or. local_angle <= iso_on ) then
               diurnal_scale_factor = 0.
            else
               factor_tmp = local_angle - iso_on
               factor_tmp = factor_tmp / MAX(2.*iso_off,1.e-6)
               diurnal_scale_factor = 2. / dayfrac * (sin(PI*factor_tmp))**2
            end if
         end if
         emis(i,j) = emis(i,j) * diurnal_scale_factor
      end do
      end do
   end if

   if (present(id_emis_diag)) then
      if (id_emis_diag > 0) then
         used = send_data(id_emis_diag,emis,Time_next,is_in=is,js_in=js)
      end if
   end if
end subroutine read_2D_emis_data
!</SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="read_3D_emis_data">
!   <OVERVIEW>
!     Read emissions file
!   </OVERVIEW>
!   <DESCRIPTION>
!     Reads tracer 3-D emissions from a NetCDF file
!   </DESCRIPTION>
!   <TEMPLATE>
!     call read_3D_emis_data( emis_type, emis, Time, phalf, &
!                             field_names, &
!                             Ldiurnal, coszen, half_day, lon, &
!                             is, js, id_emis_diag ) 
!   </TEMPLATE>

subroutine read_3D_emis_data( emis_type, emis, Time, Time_next, phalf, &
                              field_names, &
                              Ldiurnal, coszen, half_day, lon, &
                              is, js, id_emis_diag )
    
   type(interpolate_type),intent(inout) :: emis_type
   real, dimension(:,:,:),intent(in) :: phalf
   real, dimension(:,:,:),intent(out) :: emis
   type(time_type),intent(in) :: Time, Time_next
   character(len=*),dimension(:), intent(in) :: field_names
   logical, intent(in) :: Ldiurnal
   real, dimension(:,:), intent(in) :: coszen, half_day, lon
   integer, intent(in) :: is, js
   integer, intent(in),optional :: id_emis_diag ! id for diagnostic


   integer :: i, j, k
   logical :: used
   real, dimension(size(emis,1),size(emis,2),size(emis,3)) :: temp_data
   real :: diurnal_scale_factor, gmt, iso_on, iso_off, dayfrac
   real :: local_angle, factor_tmp

   emis(:,:,:) = 0.
   temp_data(:,:,:) = 0.
   do k = 1,size(field_names)
      call interpolator(emis_type,Time,phalf,temp_data,field_names(k),is,js)
      emis(:,:,:) = emis(:,:,:) + temp_data(:,:,:)
   end do
   if (Ldiurnal) then
      do j=1,size(emis,2)
      do i=1,size(emis,1)
         if( coszen(i,j) < 0. ) then
            diurnal_scale_factor = 0.
         else
            iso_off = .8 * half_day(i,j)
            iso_on  = -iso_off
            dayfrac = iso_off/PI
            gmt = universal_time(Time)
            local_angle = gmt + lon(i,j) + PI
            if (local_angle >= PI) local_angle = local_angle - twopi
            if (local_angle < -PI) local_angle = local_angle + twopi
            if( local_angle >= iso_off .or. local_angle <= iso_on ) then
               diurnal_scale_factor = 0.
            else
               factor_tmp = local_angle - iso_on
               factor_tmp = factor_tmp / MAX(2.*iso_off,1.e-6)
               diurnal_scale_factor = 2. / dayfrac * (sin(PI*factor_tmp))**2
            end if
         end if
         emis(i,j,:) = emis(i,j,:) * diurnal_scale_factor
      end do
      end do
   end if

   if (present(id_emis_diag)) then
      if (id_emis_diag > 0) then
         used = send_data(id_emis_diag,emis,Time_next,is_in=is,js_in=js)
      end if
   end if
end subroutine read_3D_emis_data
!</SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="calc_xactive_emis">
!   <OVERVIEW>
!     Calculates interactive emissions
!   </OVERVIEW>
!   <DESCRIPTION>
!     Calculates interactive emissions
!   </DESCRIPTION>
!   <TEMPLATE>
!     call calc_xactive_emis( index, emis, Time, is, js, id_emis_diag ) 
!   </TEMPLATE>

subroutine calc_xactive_emis( index, Time, Time_next, lon, lat, pwt, is, ie, js, je, &
                              area, land, ocn_flx_fraction, tsurf, w10m, emis, &
                              kbot, id_emis_diag )
    
   integer,intent(in) :: index
   type(time_type),intent(in) :: Time, Time_next
   real, intent(in), dimension(:,:) :: lon, lat
   real, intent(in), dimension(:,:,:) :: pwt
   integer, intent(in) :: is, ie, js, je
   real, intent(in), dimension(:,:) :: area    ! grid box area (m^2)
   real, intent(in), dimension(:,:) :: land    ! land fraction
   real, intent(in), dimension(:,:) :: ocn_flx_fraction 
   real, intent(in), dimension(:,:) :: tsurf   ! surface temperature (K)
   real, intent(in), dimension(:,:) :: w10m    ! wind speed at 10m (m/s)
   real, dimension(:,:,:),intent(out) :: emis  ! VMR/s
   integer, intent(in), dimension(:,:), optional :: kbot
   integer, intent(in),optional :: id_emis_diag ! id for diagnostic

   logical :: used

   
   if (index == dms_ndx) then
      call atmos_DMS_emission( lon, lat, area, ocn_flx_fraction, tsurf, w10m, pwt, &
                               emis, Time, Time_next, is, ie, js, je, kbot )
   else
      call error_mesg ('calc_xactive_emis', &
                       'Interactive emissions not defined for species: '//trim(tracnam(index)), FATAL)
   end if

   if (present(id_emis_diag)) then
      if (id_emis_diag > 0) then
         used = send_data( id_emis_diag, emis, Time_next, is_in=is, js_in=js)
      end if
   end if
end subroutine calc_xactive_emis
!</SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="init_emis_data">
!   <OVERVIEW>
!     Open emissions file
!   </OVERVIEW>
!   <DESCRIPTION>
!     Opens NetCDF file of tracer surface emissions for reading,
!     and set up interpolation to model grid/time
!   </DESCRIPTION>
!   <TEMPLATE>
!     call init_emis_data( emis_type, model, method_type, index, file_name, &
!                          lonb_mod, latb_mod, field_type, flag, diurnal )
!   </TEMPLATE>

subroutine init_emis_data( emis_type, model, method_type, index, file_name, &
                           lonb_mod, latb_mod, field_type, flag, diurnal, &
                           axes, Time )
    
   type(interpolate_type),intent(inout) :: emis_type
   integer, intent(in) :: model,index
   character(len=*),intent(in) :: method_type
   character(len=*),intent(inout) ::file_name
   real,intent(in),dimension(:,:) :: lonb_mod,latb_mod
   type(field_init_type),intent(out) :: field_type
   logical, intent(out) :: flag, diurnal
   integer        , intent(in)  :: axes(4)
   type(time_type), intent(in)  :: Time
    
   character(len=64) :: name, control
   integer :: nfields
   integer :: flag_name, flag_file, flag_diurnal
   character(len=64) :: emis_name, emis_file, control_diurnal

   flag = .false.
   diurnal = .false.
   control = ''
   if( query_method(trim(method_type),model,index,name,control) ) then
      if( trim(name) == 'file' ) then
         flag = .true.
         flag_file = parse(control, 'file', emis_file)
         flag_name = parse(control, 'name', emis_name)
         flag_diurnal = parse(control, 'diurnal', control_diurnal)
         if(flag_file > 0) then
            file_name = emis_file
         else if (flag_name > 0) then
            select case (trim(method_type))
               case ('emissions3d')
                  file_name  = trim(file_emis3d_1)//trim(emis_name)//trim(file_emis3d_2)
               case default
                  file_name  = trim(file_emis_1)//trim(emis_name)//trim(file_emis_2)
            end select
         end if
         diurnal = (flag_diurnal > 0)

         call interpolator_init( emis_type, trim(file_name), &
                                 lonb_mod, latb_mod,  &
                                 data_out_of_bounds=(/CONSTANT/), &
                                 vert_interp=(/INTERP_WEIGHTED_P/) )
         call query_interpolator(emis_type,nfields=nfields)
         allocate(field_type%field_names(nfields))
         call query_interpolator(emis_type,field_names=field_type%field_names)
      end if
   end if
end subroutine init_emis_data
!</SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="init_xactive_emis">
!   <OVERVIEW>
!     Set up interactive emission calculations
!   </OVERVIEW>
!   <DESCRIPTION>
!     Set up interactive emission calculations
!   </DESCRIPTION>
!   <TEMPLATE>
!     call init_xactive_emis( model, method_type, index, species, &
!                             axes, Time, lonb_mod, latb_mod, phalf, &
!                             flag, mask )
!   </TEMPLATE>

subroutine init_xactive_emis( model, method_type, index, species, &
                              axes, Time, lonb_mod, latb_mod, phalf, &
                              flag, id_xemis, mask )
    
   integer,         intent(in)  :: model, index
   character(len=*),intent(in)  :: method_type, species
   integer        , intent(in)  :: axes(4)
   type(time_type), intent(in)  :: Time
   real,            intent(in), dimension(:,:)   :: lonb_mod,latb_mod
   real,            intent(in), dimension(:,:,:) :: phalf
   real,            intent(in), dimension(:,:,:), optional :: mask
   logical,         intent(out) :: flag
   integer,         intent(out) :: id_xemis
    
   character(len=64) :: name, control
   integer :: nhalf, nfull

   flag = .false.
   control = ''
   nhalf = SIZE(phalf,3)
   nfull = nhalf - 1

   flag = query_method(trim(method_type),model,index,name,control)
   
!  if (flag) then
      select case (trim(species))
         case ('DMS')
            id_xemis = &
               register_diag_field( module_name, trim(species)//'_xactive_emis', axes(1:3), &
                                    Time, trim(species)//'_xactive_emis', 'VMR/s')
            if (flag .or. id_xemis>0) then
               call atmos_sulfate_init( lonb_mod, latb_mod, nfull, axes, Time, mask )
            end if
         case ('ISOP')
            id_xemis = &
               register_diag_field( module_name, trim(species)//'_xactive_emis', axes(1:2), &
                                    Time, trim(species)//'_xactive_emis', 'molecules/cm2/s')
            if (flag .or. id_xemis>0) then
               call isop_xactive_init( lonb_mod, latb_mod, axes )
            end if
         case default
            if (flag) then
               call error_mesg ('init_xactive_emis','Interactive emissions not defined for species: '//trim(species), FATAL)
            else
               id_xemis = 0
            end if
      end select
!  end if

end subroutine init_xactive_emis
!</SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="isop_xactive_init">
!   <OVERVIEW>
!     Initialize interactive isoprene emissions
!   </OVERVIEW>
!   <DESCRIPTION>
!     Initialize interactive isoprene emissions: read in emission capacities,
!     LAI for each pft, percentage pft in each grid cell, climatological (1980-2000)
!     monthly mean surface air temp + downward short wave radiation from 
!     Sheffield et al., J. clim, 2006  (obtained from Christine Wiedinmyer, NCAR,
!     Feb, 2009.  Also allocate and initialize arrays needed for diagnostics, etc.
!     Updated to MEGAN v2.1 amf/van
!   </DESCRIPTION>
!   <TEMPLATE>
!     call isop_xactive_init( lonb_mod, latb_mod, axes )
!   </TEMPLATE>

subroutine isop_xactive_init( lonb, latb, axes )

  real, intent(in), dimension(:,:)   :: lonb,latb
  integer        , intent(in)  :: axes(4)
  integer :: nlon, nlat, i, m
!parameters for input file
!number of vegetation types for emission capacities

!++amf/van updated to megan2.1 nveg = 5 types above
! integer, parameter :: nveg=6, npft=17, nmos=12
!--amf/van
  integer, parameter :: nlonin = 720, nlatin = 360
  integer, parameter :: metlonin = 360, metlatin= 180
  real, dimension(nlonin) :: inlon, lonpft, lonlai
  real, dimension(nlatin) :: inlat, latpft, latlai
  real, dimension(nlonin+1) :: inlone, lonpfte, lonlaie
  real, dimension(nlatin+1) :: inlate, latpfte, latlaie
  real, dimension(metlonin) :: metlon
  real, dimension(metlatin) :: metlat
  real, dimension(metlonin+1) :: metlone
  real, dimension(metlatin+1) :: metlate
  integer, dimension(npft) :: pft
  integer, dimension(nmos) :: mos
  real :: edgew,edges,edgen,edgee,dlon,dlat
  character(len=19), parameter :: ecfile = 'INPUT/megan.ISOP.nc'       ! amf/van
  character(len=25), parameter :: laifile = 'INPUT/mksrf_lai.060929.nc'
  character(len=25), parameter :: pftfile = 'INPUT/mksrf_pft.060929.nc'
  character(len=35), parameter :: tasfile = 'INPUT/tas_monthly_clim_1980-2000.nc'
  character(len=37), parameter :: dswfile = 'INPUT/dswrf_monthly_clim_1980-2000.nc'
  character(len=3) :: vegnames(nveg) = (/ 'ntr', 'btr', 'crp', 'grs', 'shr' /)    !amf/van
  character(len=5) :: pftnames(npft) = (/ 'pft01','pft02','pft03','pft04','pft05','pft06', &
       'pft07','pft08','pft09','pft10','pft11','pft12','pft13','pft14','pft15','pft16','pft17' /)
  character(len=5) :: lainames(npft) = (/ 'lai01','lai02','lai03','lai04','lai05','lai06', &
       'lai07','lai08','lai09','lai10','lai11','lai12','lai13','lai14','lai15','lai16','lai17' /)
  character(len=5) :: tasnames(nmos) = (/ 'tas01','tas02','tas03','tas04','tas05','tas06', &
       'tas07','tas08','tas09','tas10','tas11','tas12' /)
  character(len=5) :: dswnames(nmos) = (/ 'dsw01','dsw02','dsw03','dsw04','dsw05','dsw06', &
       'dsw07','dsw08','dsw09','dsw10','dsw11','dsw12' /)
  integer :: id_ec(nveg), id_pft(npft), id_lai(npft), id_tas(nmos), id_dsw(nmos)  
  real, dimension(nlonin,nlatin) :: datain
  real, dimension(nlonin,nlatin,npft) :: datapft
  real, dimension(nlonin,nlatin,npft,nmos) :: datalai
  real, dimension(metlonin,metlatin,nmos) :: tas, dswrf
  logical :: used

  nlon = size(lonb,1)-1
  nlat = size(latb,2)-1

!allocate dimensions of array for storing emission capacities (model grid)
  allocate(ecisop(nlon,nlat,nveg))
  allocate(pctpft(nlon,nlat,npft))
  allocate(mlai(nlon,nlat,npft,nmos))      ! monthly mean LAI
  allocate(emisop_month(nlon,nlat))        ! emission capacities adjusted w/ monthly gamma_lai and gamma_age
  allocate(diag_gamma_lai_age(nlon,nlat))
  allocate(diag_gamma_light(nlon,nlat))
  allocate(diag_gamma_temp(nlon,nlat))
  allocate(diag_climtas(nlon,nlat))
  allocate(diag_climfsds(nlon,nlat))
  allocate(ts_avg(nlon,nlat,nmos))
  allocate(fsds_avg(nlon,nlat,nmos))

!Initalize arrays
  emisop_month(:,:) = 0.
  diag_gamma_lai_age(:,:) = 0.
  diag_gamma_light(:,:) = 0.
  diag_gamma_temp(:,:) = 0.
  diag_climtas(:,:) = 0.
  diag_climfsds(:,:) = 0.
! always get gamma age / gamma lai at start of run.
! newmonth = .true.     

!  --- check existence of input file containing isoprene emission capacities --------
  if (file_exist(ecfile)) then
      
!set up for input grid
     if(mpp_pe() == mpp_root_pe()) call error_mesg ('isop_xactive_init',  &
          'Reading NetCDF formatted input file: iso_bvoc.nc', NOTE)
      
! amf/van -- new file only has lat lon centers, not boundaries...
!read in lat & lon boundaries from input file and convert to radians
!no.domain = true tells it all fields are in one global file (as opposed to e.g., one per cube face)
     call read_data (ecfile, 'lon', inlon, no_domain=.true.)
     call read_data (ecfile, 'lat', inlat, no_domain=.true.)
     inlon = inlon*DEG_TO_RAD
     inlat = inlat*DEG_TO_RAD
     dlat = inlat(2)-inlat(1)
     dlon = inlon(2)-inlon(1)
     inlone(1:nlonin) = inlon-(dlon/2.)
     inlone(nlonin+1) = inlon(nlonin)+(dlon/2.)
     inlate(1:nlatin) = inlat-(dlat/2.)
     inlate(nlatin+1) = inlat(nlatin)+(dlat/2.)

!     print*, 'lat,lon edges for new megan.isop.nc file: ', inlate, inlone
     
     call horiz_interp_init
     call horiz_interp_new ( Interp, inlone, inlate, lonb, latb )

! loop over vegnames
     do i = 1, nveg 
!register diagnostic field
        id_ec(i) = register_static_field( 'tracers', vegnames(i), axes(1:2), &
             vegnames(i), 'molec/cm2/s')
!read this field
        call read_data (ecfile, vegnames(i), datain, no_domain=.true.)
        call horiz_interp (Interp, datain, ecisop(:,:,i), verbose=verbose)
!send data to diagnostic
        if (id_ec(i) > 0) then
           used = send_data(id_ec(i),ecisop(:,:,i)) 
        endif
     end do
    
  else 
     print*, 'what is ecfile ', ecfile
     call error_mesg ('isop_xactive_init',  &
          'ecfile does not exist.', FATAL)
  endif

!  --- check existence of input file containing % pft --------
  if (file_exist(pftfile)) then
      
!set up for input grid
     if(mpp_pe() == mpp_root_pe()) call error_mesg ('isop_xactive_init',  &
          'Reading NetCDF formatted input file: mksrf_pft.060929.nc', NOTE)
      
!read in lat & lon from input file, get boundaries and convert to radians
     call read_data (pftfile, 'lon', lonpft, no_domain=.true.)
     call read_data (pftfile, 'lat', latpft, no_domain=.true.)
     call read_data (pftfile, 'EDGEW', edgew, no_domain=.true.)
     call read_data (pftfile, 'EDGES', edges, no_domain=.true.)
     call read_data (pftfile, 'EDGEE', edgee, no_domain=.true.)
     call read_data (pftfile, 'EDGEN', edgen, no_domain=.true.)

     lonpfte(1) = edgew
     latpfte(1) = edges
     latpfte(nlatin+1) = edgen
     lonpfte(nlonin+1) = edgee
     
     dlon = 2.*(lonpft(1)-edgew)
     dlat = 2.*(latpft(1)-edges)

     do i = 2, nlatin 
        latpfte(i) = latpfte(i-1)+dlat
     end do

     do i = 2, nlonin
        lonpfte(i) = lonpfte(i-1)+dlon
     end do     

     lonpfte = lonpfte*DEG_TO_RAD
     latpfte = latpfte*DEG_TO_RAD
     
     call horiz_interp_init
     call horiz_interp_new ( Interp, lonpfte, latpfte, lonb, latb )

     call read_data (pftfile, 'pft', pft, no_domain=.true.)

!read pct_pft field 
     call read_data (pftfile, 'PCT_PFT', datapft, no_domain=.true.)

! loop over vegnames
     do i = 1, npft       
!register diagnostic field
        id_pft(i) = register_static_field( 'tracers', pftnames(i), axes(1:2), &
             pftnames(i), 'unitless')
        call horiz_interp (Interp, datapft(:,:,i), pctpft(:,:,i), verbose=verbose)
!send data to diagnostic
        if (id_pft(i) > 0) then
           used = send_data(id_pft(i),pctpft(:,:,i)) 
        endif
     end do
!scale pctpft from percentage to fraction 
     pctpft(:,:,:) = .01 * pctpft(:,:,:)
    
  else 
     call error_mesg ('isop_xactive_init',  &
          'pftfile does not exist.', FATAL)
  endif

!  --- check existence of input file containing monthly lai, for each pft --------
  if (file_exist(laifile)) then
      
!set up for input grid
     if(mpp_pe() == mpp_root_pe()) call error_mesg ('isop_xactive_init',  &
          'Reading NetCDF formatted input file: mksrf_lai.060929.nc', NOTE)
      
!read in lat & lon from input file, get boundaries and convert to radians
     call read_data (laifile, 'lon', lonlai, no_domain=.true.)
     call read_data (laifile, 'lat', latlai, no_domain=.true.)

! get lat/lon edges
     lonlaie(1) = edgew
     latlaie(1) = edges
     latlaie(nlatin+1) = edgen
     lonlaie(nlonin+1) = edgee
     
     dlon = 2.*(lonlai(1)-edgew)
     dlat = 2.*(latlai(1)-edges)

     do i = 2, nlatin 
        latlaie(i) = latlaie(i-1)+dlat
     end do

     do i = 2, nlonin
        lonlaie(i) = lonlaie(i-1)+dlon
     end do     

     lonlaie = lonlaie*DEG_TO_RAD
     latlaie = latlaie*DEG_TO_RAD
     
     call horiz_interp_init
     call horiz_interp_new ( Interp, lonlaie, latlaie, lonb, latb )

! read in pft and time dimensions from lai file
     call read_data (laifile, 'time', mos, no_domain=.true.)

! loop over vegnames
     do i = 1, npft 
        call read_data (laifile,lainames(i),datalai(:,:,i,:), no_domain=.true.)
        do m = 1, nmos
            call horiz_interp (Interp, datalai(:,:,i,m), mlai(:,:,i,m), verbose=verbose)
!store diagnostics for one month only - choose July for now
            if (m .eq. 7) then 
!register diagnostic field
               id_lai(i) = register_static_field( 'tracers', lainames(i), axes(1:2), &
                    lainames(i), 'unitless')
!send data to diagnostic
               if (id_lai(i) > 0) then
                  used = send_data(id_lai(i),mlai(:,:,i,m))
               endif
            endif
         end do
      end do
    
   else 
      call error_mesg ('isop_xactive_init',  &
           'laifile does not exist', FATAL)
   endif

!  --- check existence of input file containing climatological (1980-2000) monthly air surface temp --------
  if (file_exist(tasfile)) then
      
!set up for input grid
     if(mpp_pe() == mpp_root_pe()) call error_mesg ('isop_xactive_init',  &
          'Reading NetCDF formatted input file: tas_monthly_clim_1980-2000.nc', NOTE)
      
!read in lat & lon from input file, get boundaries and convert to radians
     call read_data (tasfile, 'lon', metlon, no_domain=.true.)
     call read_data (tasfile, 'lat', metlat, no_domain=.true.)
     
     dlon = 0.5*(metlon(1)-metlon(2))
     dlat = 0.5*(metlat(2)-metlat(1))

     do i = 1, metlatin 
        metlate(i) = metlat(i)-dlat
     end do

     metlate(metlatin+1) = metlat(metlatin)+dlat

     do i = 1, metlonin
        metlone(i) = metlon(i)-dlon
     end do     
     metlone(metlonin+1) = metlon(metlonin)+dlon

     metlone = metlone*DEG_TO_RAD
     metlate = metlate*DEG_TO_RAD
     
     call horiz_interp_init
     call horiz_interp_new ( Interp, metlone, metlate, lonb, latb )

     call read_data (tasfile, 'time', mos, no_domain=.true.) 
     call read_data (tasfile,'tas_clim', tas(:,:,:), no_domain=.true.)
        
     do m = 1, nmos
        call horiz_interp (Interp, tas(:,:,m), ts_avg(:,:,m), verbose=verbose) 
!register diagnostic field
        id_tas(m) = register_static_field( 'tracers', tasnames(m), axes(1:2), &
             tasnames(m), 'unitless')
!send data to diagnostic
        if (id_tas(m) > 0) then
           used = send_data(id_tas(m),ts_avg(:,:,m))
        endif
     end do
  else 
     call error_mesg ('isop_xactive_init',  &
          tasfile, NOTE)
     call error_mesg ('isop_xactive_init',  &
          'tasfile does not exist', FATAL)

  endif

!  --- check existence of input file containing climatological (1980-2000) monthly surface down SW radiation --------
  if (file_exist(dswfile)) then
      
!set up for input grid
     if(mpp_pe() == mpp_root_pe()) call error_mesg ('isop_xactive_init',  &
          'Reading NetCDF formatted input file: dswrf_monthly_clim_1980-2000.nc', NOTE)
      
!read in lat & lon from input file, get boundaries and convert to radians
     call read_data (dswfile, 'lon', metlon, no_domain=.true.)
     call read_data (dswfile, 'lat', metlat, no_domain=.true.)
     
     dlon = 0.5*(metlon(1)-metlon(2))
     dlat = 0.5*(metlat(2)-metlat(1))

     do i = 1, metlatin 
        metlate(i) = metlat(i)-dlat
     end do

     metlate(metlatin+1) = metlat(metlatin)+dlat

     do i = 1, metlonin
        metlone(i) = metlon(i)-dlon
     end do     
     metlone(metlonin+1) = metlon(metlonin)+dlon

     metlone = metlone*DEG_TO_RAD
     metlate = metlate*DEG_TO_RAD
     
     call horiz_interp_init
     call horiz_interp_new ( Interp, metlone, metlate, lonb, latb )

     call read_data (dswfile, 'time', mos, no_domain=.true.)
     call read_data (dswfile,'dswrf_clim', dswrf(:,:,:), no_domain=.true.)
        
     do m = 1, nmos
        call horiz_interp (Interp, dswrf(:,:,m), fsds_avg(:,:,m), verbose=verbose)
!register diagnostic field
        id_dsw(m) = register_static_field( 'tracers', dswnames(m), axes(1:2), &
             dswnames(m), 'unitless')
!send data to diagnostic
        if (id_dsw(m) > 0) then
           used = send_data(id_dsw(m),fsds_avg(:,:,m))
        endif
     end do
    
  else 
     call error_mesg ('isop_xactive_init',  &
          'dswfile does not exist', FATAL)
  endif

end subroutine isop_xactive_init

!</SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="calc_xactive_isop">
!   <OVERVIEW>
!     Calculates interactive isoprene emissions
!   </OVERVIEW>
!   <DESCRIPTION>
!     Calculates interactive isoprene emissions using algorithms from 
!      PCEEA MEGAN model in Guenther, ACP, 2006.
!      Note - gamma soil moisture is assumed constant (at one)
!   </DESCRIPTION>
!   <TEMPLATE>
!     call calc_xactive_isop( index, Time, lon, lat, oro, pwtsfc, is, js, &
!                              area, land, tsfcair, flux_sw_down_vis, &
!                              coszen, emis,   id_gamma_lai_age, &
!                                 id_gamma_temp, id_gamma_light, &
!                                 id_tsfcair, id_fsdvd, id_climtas, id_climfsds, id_emis_diag ) 
!   </TEMPLATE>
             
subroutine calc_xactive_isop( index, Time, Time_next,lon, lat, oro, pwtsfc, is, js, &
                              area, land, tsfcair, flux_sw_down_vis, &
                              coszen, emis,   id_gamma_lai_age, &
                              id_gamma_temp, id_gamma_light, id_tsfcair, &
                              id_fsdvd, id_climtas, id_climfsds, id_emis_diag ) 
    
   integer,intent(in) :: index
   type(time_type),intent(in) :: Time, Time_next
   real, intent(in), dimension(:,:) :: lon, lat
   real, intent(in), dimension(:,:) :: pwtsfc
   integer, intent(in) :: is, js 
   real, intent(in), dimension(:,:) :: area    ! grid box area (m^2)
   real, intent(in), dimension(:,:) :: land    ! land fraction
   real, intent(in), dimension(:,:) :: oro     ! land = 1; ocean = 0
   real, intent(in), dimension(:,:) :: tsfcair   ! surface temperature (K)
   real, intent(in), dimension(:,:) :: flux_sw_down_vis !W/m2 visible (direct+diffuse) sfc flux
   real, intent(in), dimension(:,:) :: coszen  ! cosine of solar zenith angle
   real, dimension(:,:),intent(out) :: emis  ! 
   integer, intent(in), optional :: id_gamma_lai_age, id_gamma_temp, id_gamma_light
   integer, intent(in), optional :: id_climtas, id_climfsds
   integer, intent(in), optional :: id_emis_diag, id_tsfcair
   integer, intent(in),optional ::  id_fsdvd ! id for diagnostic
   real    :: calday
   type(time_type) :: Year_t
   integer :: yr, mo, day, hr, min, sec
   logical :: used
   integer :: ie, je

   ie = is + size(land,1) -1
   je = js + size(land,2) -1

   call get_date(Time,yr,mo,day,hr,min,sec)  !model GMT

!update gamma age and gamma once per month
   if (newmonth) then 
!     if( mpp_pe() == mpp_root_pe() ) then 
!        print *, 'pts_proc, oldmonth', pts_processed, isop_oldmonth
!        print *, 'time', yr,mo,day,hr,min,sec
!        print*, 'AMF calc_xactive_isop: calling get_monthly_gammas'
!        print*, 'id_gamma_lai_age = ', id_gamma_lai_age
!        print*, 'sum(diag_gamma_lai_age', sum(diag_gamma_lai_age(:,:))
!     end if
      
      call get_monthly_gammas( lon, lat, oro, is, js, mo, &
                               id_gamma_lai_age )
!     if( mpp_pe() == mpp_root_pe() ) then 
!        print *, 'pts_proc, oldmonth AFTER', pts_processed, isop_oldmonth
!        print*, 'AMF calc_xactive_isop: after call to  get_monthly_gammas'
!        print*, 'id_gamma_lai_age = ', id_gamma_lai_age
!        print*, 'AMF sum(diag_gamma_lai_age)', sum(diag_gamma_lai_age(:,:))
!     end if

   end if

!Get Julian date (fraction) = calday
   Year_t = set_date(yr,1,1,0,0,0)
   calday = time_type_to_real( Time-Year_t) / SECONDS_PER_DAY

!  if( mpp_pe() == mpp_root_pe() ) then
!     print*, 'AMF: calday = ', calday
!  end if

! get isoprene emissions for this timestep
   call get_isop_emis( lon, lat, is, js, calday, mo, tsfcair, flux_sw_down_vis, &
                       coszen, area, pwtsfc, emis )

!accumulate isoprene emissions in diagnostic - units should be molec/cm2/s
   if (present(id_emis_diag)) then
      if (id_emis_diag > 0) then
         used = send_data( id_emis_diag, emis, Time_next, is_in=is, js_in=js)
      end if
   end if

! also store sw visible direct at surface and surface air temperature diagnostics
   if (present(id_fsdvd)) then 
      if (id_fsdvd > 0) then 
         used = send_data( id_fsdvd, flux_sw_down_vis, Time_next, is_in=is, js_in=js)
      end if
   end if

   if (present(id_tsfcair)) then 
      if (id_tsfcair > 0) then 
         used = send_data( id_tsfcair, tsfcair, Time_next, is_in=is, js_in=js)
      end if
   end if

   if (present(id_gamma_light)) then 
      if (id_gamma_light > 0) then 
         used = send_data( id_gamma_light, diag_gamma_light(is:ie,js:je), Time_next, is_in=is, js_in=js)
      end if
   end if

   if (present(id_gamma_temp)) then 
      if (id_gamma_temp > 0) then 
         used = send_data( id_gamma_temp, diag_gamma_temp(is:ie,js:je), Time_next, is_in=is, js_in=js)
      end if
   end if

   if (present(id_climtas)) then 
      if (id_climtas > 0) then 
         used = send_data( id_climtas, diag_climtas(is:ie,js:je), Time_next, is_in=is, js_in=js)
      end if
   end if

   if (present(id_climfsds)) then 
      if (id_climfsds > 0) then 
         used = send_data( id_climfsds, diag_climfsds(is:ie,js:je), Time_next, is_in=is, js_in=js)
      end if
   end if

!store combined diagnostic of gamma_lai * gamma_age, summed over each vegetation type
   if (present(id_gamma_lai_age)) then
      if (id_gamma_lai_age > 0) then
!         if( mpp_pe() == mpp_root_pe() ) then 
!            print*, 'AMF calc_xactive_isop: after call to send_data for glaiage'
!            print*, 'id_gamma_lai_age = ', id_gamma_lai_age
!            print*, 'sum(diag_gamma_lai_age', sum(diag_gamma_lai_age(:,:))
!         end if
         used = send_data( id_gamma_lai_age, diag_gamma_lai_age(is:ie,js:je), Time_next, is_in=is, js_in=js)
              
      end if
   end if

end subroutine calc_xactive_isop

!</SUBROUTINE>



!#######################################################################

! <SUBROUTINE NAME="get_isop_emis">
!   <OVERVIEW>
!     Get isop emissions for this time step
!   </OVERVIEW>
!   <DESCRIPTION>
!     amf Feb 2009
!     This subroutine calculates isoprene emissions according to
!     the MEGAN PCEEA model [Guenther et al., ACP 6, 3181-3210, 2006.]
!     as implemented in mozart4_v4.5 by J.-F. Lamarque and G. Pfister
!     (bvoc_emissions mozart routine)
!   </DESCRIPTION>
!   <TEMPLATE>
!     get_isop_emis( lon, lat, is, js, calday, mo, tsfcair, flux_sw_down_vis, &
!                          coszen, area, pwtsfc, emis )
!   </TEMPLATE>
!   <IN NAME="lon" TYPE="real" DIM="(:,:)">
!      longitude value for each i,j grid cell 
!   </IN>
!   <IN NAME="lat" TYPE="real" DIM="(:,:)">
!      latitude value for each i,j grid cell 
!   </IN>
!   <IN NAME="is" TYPE="integer">
!      beginning i for location of this group of 
!      grid cells within global grid, used in diag manager 
!   </IN>
!   <IN NAME="js" TYPE="integer">
!      beginning j for location of this group of 
!      grid cells within global grid, used in diag manager 
!   </IN>
!   <IN NAME="calday" TYPE="real">
!      Fractional Julian day of year (model GMT)
!   </IN>
!   <IN NAME="mo" TYPE="integer">
!     current month
!   </IN>
!   <IN NAME="tsfcair" TYPE="real" DIM="(:,:)">
!      surface air temperature (K)
!   </IN>
!   <IN NAME="flux_sw_down_vis" TYPE="real" DIM="(:,:)">
!      downward visible shortwave radiation (W/m2)
!   </IN>
!   <IN NAME="coszen" TYPE="real" DIM="(:,:)">
!     Cosine of the solar zenith angle
!   </IN>
!   <IN NAME="area" TYPE="real" DIM="(:,:)">
!     Grid cell area (m^2)
!   </IN>
!   <IN NAME="pwtsfc" TYPE="real" DIM="(:,:)">
!     kg/m2 of air in the surface layer
!   </IN>
!   <IN NAME="emis" TYPE="real" DIM="(:,:)">
!     isoprene emissions for this timestep
!     (molec/cm2/s)
!   </IN>

subroutine get_isop_emis( lon, lat, is, js, calday, mo, tsfcair, flux_sw_down_vis, &
                          coszen, area, pwtsfc, emis )
!-------------------------------------------------------------------------------------
!       ... biogenic voc isoprene emissions
!-------------------------------------------------------------------------------------  

      implicit none

      real, intent(in), dimension(:,:) :: lon, lat
      integer, intent(in) :: is, js, mo  
      real, intent(in)    :: calday          
      real, intent(in), dimension(:,:)  :: coszen     
      real, intent(in), dimension(:,:)  :: tsfcair        ! surface temperature
      real, intent(in), dimension(:,:)  :: flux_sw_down_vis !W/m2 direct visible sfc flux
      real, intent(in), dimension(:,:)  :: area      ! grid box area (m^2)
      real, intent(in), dimension(:,:)  :: pwtsfc    ! kg/m2 air in surface layer
      real, intent(out), dimension(:,:) :: emis      ! output emissions for this time step

!-------------------------------------------------------------------------------------
!       ... local variables
!-------------------------------------------------------------------------------------
      real, parameter :: ctm1   =  80.   ! p 3192 Guenther et al ACP 2006
      real, parameter :: ctm2   = 200.   ! same as above
      real, parameter :: const0 = 4.766    ! to convert W/m2 to micromoles/m2/s for PAR (C. Wiedinmyer, 2/18/09)
      real, parameter :: rho_iso = 0.96  ! to account for deposition to canopy
      real, parameter :: gamma_sm = 1.   ! soil moisture - eventually estimate as f(sm, wilting point)

      integer :: i, j, nlon, nlat
      real    :: ppfd, x, Eopt, Ptoa, phi
      real    :: Topt
      real    :: fac_par, fac_tmp
      real    :: Tdaily, Pdaily 
      real    :: t_diff
    
      nlon = size(lon,1)
      nlat = size(lat,2)
      do j = 1,nlat
         do i = 1,nlon

!-------------------------------------------------------------------------------------
!       ... PAR correction
!                Guenther et al ACP 2006 Eqns 11, 12, 13
!           Note - this does not include separation of sunny/shady - could add.
!-------------------------------------------------------------------------------------
!Currently tests to see if we have read in the climatological surface air & downward shortwave
! could eventually change to use values saved during run (e.g., previous week to month values for
! each grid cell)
!Note the factor of 0.5 to convert from total shortwave to PPFD
! vs. AM3 which has visible component available.
         if( has_ts_avg ) then  
            Pdaily =  fsds_avg(i+is-1,j+js-1,mo) * const0 * 0.5 
            Tdaily  = ts_avg(i+is-1,j+js-1,mo)
         else
            Pdaily = Pdaily_clim * const0 * 0.5
            Tdaily = Tdaily_clim
         end if
         ppfd   = flux_sw_down_vis(i,j) * const0

         Ptoa = 3000. + 99.* cos( twopi*(calday - 10.)/365. )    !Guenther et al Eqn 13


! Guenther eqns 11a/b 
         if (coszen(i,j) <= 0.) then 
            fac_par = 0.   
         else
            phi = ppfd / (coszen(i,j)*Ptoa)   ! Eqn 12

!-------------------------------------------------------------------------------------
!  phi can get > 1 and then fac_par gets negative with the above equation
!  set phi=1 if phi> 1 as recommended by Alex (MZ4 code)
!-------------------------------------------------------------------------------------
            phi = min( phi,1. )   
            !Eqn 11b - note typo in MZ4 - 2.49 instead of 2.46
            fac_par = coszen(i,j)*(2.46 * (1. + .0005 *(Pdaily - 400.))*phi - .9*phi*phi) 
         end if

!-------------------------------------------------------------------------------------
!       ... temperature correction  equation 14
!           Topt from equation 8
!           p. 3192 Guenther et al 2006
!-------------------------------------------------------------------------------------
         t_diff  = Tdaily - Tdaily_clim
         Topt    = 313. + 0.6*t_diff                     !Eqn 8
         x       = (tsfcair(i,j) - Topt)/(tsfcair(i,j)*Topt*.00831)
         Eopt    = 1.75 * exp( .08*t_diff )
!Eqn 14 --  gammaT
         fac_tmp = Eopt * (ctm2 * exp( ctm1*x ))/(ctm2 - ctm1*(1. - exp( ctm2*x )))  

!-------------------------------------------------------------------------------------
!     emisop_month contains regridded potential emissions including 
!                  application of gamma LAI and gamma AGE for this month 
!     ... change units from microg/m2/h to mol/cm2/s
!      units of MZ4 input file incorrectly labled as mol/cm2/s... 
!-------------------------------------------------------------------------------------
         emis(i,j) = emisop_month(i+is-1,j+js-1) * fac_par * fac_tmp *  2.46e8
         diag_gamma_temp(i+is-1,j+js-1) = fac_tmp
         diag_gamma_light(i+is-1,j+js-1) = fac_par
         diag_climtas(i+is-1,j+js-1) = Tdaily
         diag_climfsds(i+is-1,j+js-1) = Pdaily

!        if( mpp_pe() == mpp_root_pe() ) then
!           print*, 'AMF: i,j,gt,gl,emis = ', i,j,fac_tmp,fac_par, emis(i,j)
!           print*, 'AMF: calday = ', calday
!        endif
      end do !lon
   end do !lat

!-------------------------------------------------------------------------------------
!        AMF - apply uniform canopy deposition and soil moisture corrections
!              from Guenther et al 2006 - could eventually parameterize these
!                    (neither included in MZ4)
!-------------------------------------------------------------------------------------
   emis(:,:) =  emis(:,:) * rho_iso * gamma_sm 

end subroutine get_isop_emis
!</SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="get_monthly_gammas">
!   <OVERVIEW>
!     Each month, update isoprene emissions to include scaling from 
!     gamma_age and gamma_lai
!   </OVERVIEW>
!   <DESCRIPTION>
!     amf Feb 2009
!     This subroutine calculates gamma_age and gamma_lai and applies them
!     for each LAI and PFT, aggregating to the 6 vegetation types for the
!     isoprene emission capacities, following
!     the MEGAN PCEEA model [Guenther et al., ACP 6, 3181-3210, 2006.]
!     as implemented in mozart4_v4.5 by J.-F. Lamarque and G. Pfister
!     (interp_map_bvoc mozart routine)
!   </DESCRIPTION>
!   <TEMPLATE>
!     get_monthly_gammas( lon, lat, oro, is, js, &
!                                   month, id_gamma_lai_age )  
!   </TEMPLATE>

!removed fsds since not used... 
subroutine get_monthly_gammas( lon, lat, oro, is, js, &
                                   month, id_gamma_lai_age )

      implicit none

      real, intent(in), dimension(:,:) :: lon, lat
      real, intent(in), dimension(:,:) :: oro     ! land = 1; ocean = 0
      integer, intent(in) :: is, js    
      integer, intent(in)      :: month
      integer, intent(in),optional :: id_gamma_lai_age  !id for diagnostic
  
!-------------------------------------------------------------------------------------
!       ... local variables
!-------------------------------------------------------------------------------------
      integer                  :: i, j, n, nlon, nlat, nl, nu
      integer                  :: ie, je
      integer                  :: pft_li(nveg)
      integer                  :: pft_lu(nveg)
!      real                     :: wrk_area  
      real                     :: total_iso
      real                     :: work_iso(nveg)    !amf/van
      real                     :: ts_wrk
      real                     :: total_work_gamma

!++amf/van
      real                     :: work_gamma(nveg)  ! for diagnostic
      real                     :: lai_fac(npft)  ! npft = 17 (mksrf files)
      real                     :: lai_work(npft,nmos)
      logical                  :: age_work(npft)
!--amf/van

      nlon = size(lon,1)
      nlat = size(lat,2)
      ie = is + nlon -1
      je = js + nlat -1

!       if( mpp_pe() == mpp_root_pe() ) then 
!          print*, 'AMF get_monthly_gammas: made it here'
!       end if
      
!++amf/van
      age_work(:) = .true.
      age_work((/2,3,5,6,10/)) = .false.

! hardwired indices for matching pfts to ecs 
! pfts 2-4   fine leaf 
! pfts 5-9   broadleaf
! pfts 10-12 shrubs 
! pfts 13-15 grass
! pfts 16-17 crops

      pft_li(:) = (/ 2,5,10,13,16 /)
      pft_lu(1:nveg-1) = (/ 4,9,12,15 /)
      pft_lu(nveg) = npft
!--amf/van
      do j = js,je 
         do i = is,ie 
            total_iso = 0. 
            total_work_gamma = 0.
            if (has_ts_avg) then
              ts_wrk = ts_avg(i,j,month)
            end if

!-----------------------------------------------------------------
!       ... no emissions for ocean grid point 
!-----------------------------------------------------------------
            if( oro(i-is+1,j-js+1) .eq. 1 ) then
                
!++amv/van
            lai_work(:,:) = mlai(i,j,:,:)
            lai_fac(:) = calc_gamma_lai_age( lai_work, ts_wrk, month, age_work)

            do n = 1, nveg
              nl = pft_li(n)  !beginning index for the pfts that fall within this veg type for n types in ecisop
              nu = pft_lu(n)  !end index
              work_iso(n) = dot_product( lai_fac (nl:nu), pctpft(i,j,nl:nu)) * ecisop(i,j,n)
              work_gamma(n) = dot_product( lai_fac (nl:nu), pctpft(i,j,nl:nu))
            end do
            total_work_gamma = total_work_gamma + sum(work_gamma)
            total_iso = total_iso + sum(work_iso)
        
!--amf/van
              emisop_month(i,j) = total_iso
              diag_gamma_lai_age(i,j) = total_work_gamma
!             if( mpp_pe() == mpp_root_pe() ) then
!                print*, 'AMF: i,j,oro, work_iso, emis ', i,j,oro(i,j), work_iso, emisop_month(i,j)
!             end if
          end if ! land box
        end do !lon
      end do !lat

end subroutine get_monthly_gammas
!</SUBROUTINE


!#######################################################################

! <FUNCTION NAME="calc_gamma_lai_age">
!   <OVERVIEW>
!     Monthly exchange ratio from MEGAN
!   </OVERVIEW>
!   <DESCRIPTION>
!     amf Feb 2009
!     This subroutine calculates gamma_age and gamma_lai according to
!     the MEGAN PCEEA model [Guenther et al., ACP 6, 3181-3210, 2006.]
!     as implemented in mozart4_v4.5 by J.-F. Lamarque and G. Pfister
!     (their fac_lai function)
!   </DESCRIPTION>
!   <TEMPLATE>
!     work_iso  = calc_gamma_lai_age( clai, ts_wrk, month, doage )
!   </TEMPLATE>
!   <IN NAME="clai" TYPE="real" DIM="(:)">
!      12 monthly values for lai for current grid cell
!   </IN>
!   <IN NAME="ts_wrk" TYPE="real">
!     the climatological monthly mean surface T for this i, j, m (K)
!   </IN>
!   <IN NAME="month" TYPE="integer">
!     current month
!   </IN>
!   <IN NAME="doage" TYPE="integer">
!     1 = calculate gamma age; 0 = don't
!   </IN>


function calc_gamma_lai_age(clai, ts_wrk, month, doage )

!AMF - COULD ADD OPTION TO USE AVERAGE TS AND FSDS OVER
! PAST MONTH /WEEKS -- would need to save to restart file  
! NOTE - MZ4 FAC_LAI DOESN"T SEEM TO USE FSDS_AVG, NOR DOES IT IN GUENTHER'S EQNS, 
! SO ELIMINATE FROM THIS FUNCTION

  implicit none

  logical, intent(in) :: doage(:)         !calculate gamma_age?,  amf/van
  integer, intent(in) :: month            !current month index
  real, intent(in) :: ts_wrk              ! currently = climatological sfc T for ea i,j,m
  real, intent(in) :: clai(:,:)           ! monthly lai for this grid cell,   amf/van
  
!-------------------------------------------------------------------------------------
!       ... local variables
!-------------------------------------------------------------------------------------
! ggp: equations 18 and 19 from Guenther et al. include a dependence of ti and tm on temperature
! of preceding timestep (i.e. month here); not considered here. 
! ggp/lamar: instead of using a constant ti and tm, it can be calculated based on information 
! of monthly average temperature
!-------------------------------------------------------------------------------------

!! amf: time step in days btw previous month's LAI and current month's LAI (p3192 guenther)
      integer, parameter :: t(12) = (/ 31,31,28,31,30,31,30,31,31,30,31,30 /)

      integer :: n
      integer :: mnthm1
      real    :: x
      real    :: wrk
      real    :: gamma
      real    :: lai_n, lai_p      ! amf/van
      real    :: Fnew
      real    :: Fgro
      real    :: Fmat
      real    :: Fsen              ! amf/van
      real    :: ti, tm  ! ti = # days btw budbreak and induction of isoprene emissions
                         ! tm = # days btw budbreak + initiation of peak isop emissions rates

!-------------------------------------------------------------------------------------
!       ... function declarations
!-------------------------------------------------------------------------------------
      real    :: calc_gamma_lai_age(npft)    ! amf/van

      if( month > 1 ) then      ! amf/van
         mnthm1 = month - 1
      else
         mnthm1 = 12
      end if

!-------------------------------------------------------------------------------------
!       ... calculations following equations 17&18 in Guenther et al. [2006]
!           -- getting terms needed for gamma age
!-------------------------------------------------------------------------------------
      if( has_ts_avg ) then
         if( ts_wrk <= 303. ) then
            ti = 5. + 0.7*(300. - ts_wrk)                     !eqn 18a (see corrigendum)
         else        
            ti = 2.9                                          ! eqn 18b (corrigendum)
         end if
      else
         ti = 5. + 0.7*(300. - Tdaily_clim)                   ! Tdaily_clim in tropchem_driver_nml
      end if
      tm = 2.3*ti                                             ! Eq 19 

!++amf/van
      calc_gamma_lai_age(1) = 0.
      do n = 2, npft
       if (doage(n)) then
        Fnew = 0.
        Fgro = 0.
        Fmat = 0.
        Fsen = 0.
        lai_n = clai(n, month)
        lai_p = clai(n, mnthm1)
        if( lai_n == lai_p ) then                  !previous LAI = current LAI  - p.392 G06
         Fmat = 0.8
         Fsen = 0.1
         Fgro = 0.1
      else if( lai_p > lai_n ) then              !LAip > LAIc
         Fsen = (lai_p - lai_n) / lai_p
         Fmat = 1. - Fsen
      else if( lai_p < lai_n ) then              !LAIp < LAIc
         Fsen = 0.
         x    = lai_p/lai_n
!--amf/van
         wrk  = 1. - x                                        ! = Fnew
         if( t(month) <= tm ) then
            Fmat =  x                                         ! Eqn 17c
         else
            Fmat = x + (((t(month) - tm)/t(month) ) * wrk)    ! Eqn 17d
         end if
         if( t(month) <= ti ) then
            Fnew = wrk                                        ! Eqn 17a
            Fgro = 1. - (Fnew + Fmat)                         ! Eqn 17e
         else
            Fnew = (ti/t(month)) * wrk                        ! Eqn 17b
            Fgro = 1. - (Fnew + Fmat)                         ! Eqn 17e
         end if
      end if

!-------------------------------------------------------------------------------------
!       ... equations 15 and 16 in Guenther et al. [2006]
!            -- get gamma age
!-------------------------------------------------------------------------------------
      gamma   = .05*Fnew + .6*Fgro + 1.125*Fmat + Fsen   !!  Eq 16
      else
        gamma   = 1.
      end if

!-------------------------------------------------------------------------------------
!     gamma_age ("gamma" below) * gamma_lai where gamma_lai is from Eqn 15 
!-------------------------------------------------------------------------------------
      calc_gamma_lai_age(n) = gamma * .49 * clai(n,month) / sqrt( 1. + 0.2 * clai(n, month)*clai(n, month) )

      end do
  

end function calc_gamma_lai_age

!</FUNCTION>
!############################################################################

! <SUBROUTINE NAME="tropchem_drydep_init">
!   <OVERVIEW>
!     Open dry deposition file
!   </OVERVIEW>
!   <DESCRIPTION>
!     Opens NetCDF file of tracer dry deposition velocities for reading,
!     and set up interpolation to model grid/time
!   </DESCRIPTION>
!   <TEMPLATE>
!     call tropchem_drydep_init( dry_files, dry_names, &
!                                lonb_mod, latb_mod, &
!                                drydep_data )
!   </TEMPLATE>

subroutine tropchem_drydep_init( dry_files, dry_names, &
                                 lonb_mod, latb_mod, &
                                 drydep_data )

!-----------------------------------------------------------------------

   real,                   intent(in),  dimension(:,:) :: lonb_mod, latb_mod
   character(len=64),      intent(out), dimension(:) :: dry_files, dry_names
   type(interpolate_type), intent(out)               :: drydep_data(:)

!-----------------------------------------------------------------------

   integer :: i
   integer :: flag_file, flag_spec
   character(len=64) :: filename,specname
   character(len=64) :: name='', control=''

!-----------------------------------------------------------------------

!---------- Set interpolator type for dry deposition
   call interpolator_init( drydep_data_default, trim(file_dry), lonb_mod, latb_mod, &
                           data_out_of_bounds=(/CONSTANT/), &
                           vert_interp=(/INTERP_WEIGHTED_P/))

   do i = 1,pcnstm1
      dry_files(i) = ''
      dry_names(i) = ''
      if( query_method('dry_deposition',MODEL_ATMOS,indices(i),name,control) )then
         if( trim(name) == 'file' ) then
            flag_file = parse(control, 'file',filename)
            flag_spec = parse(control, 'name',specname)
            if(flag_file > 0 .and. trim(filename) /= trim(file_dry)) then
               dry_files(i) = trim(filename)
               call interpolator_init( drydep_data(indices(i)), trim(filename), lonb_mod, latb_mod,&
                                       data_out_of_bounds=(/CONSTANT/), &
                                       vert_interp=(/INTERP_WEIGHTED_P/))
            else
               dry_files(i) = trim(file_dry)
               drydep_data(indices(i)) = drydep_data_default

            end if
            if(flag_spec >0) then
               dry_names(i) = trim(specname)
            else
               dry_names(i) = trim(lowercase(tracnam(i)))
            end if
         end if
      end if
   end do

end subroutine tropchem_drydep_init
!</SUBROUTINE>

!############################################################################
end module tropchem_driver_mod

module ocean_blob_util_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="m.bates@student.unsw.edu.au"> Michael L. Bates
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! This module contains subroutines that are common (or are likely to 
! need be common to future implementations) to some or all of the 
! various modules that run the Lagrangian blob scheme.
!</OVERVIEW>
!
!<DESCRIPTION>
! This module contains subroutines that are common (or may be common
! in a future implementation) to some of the modules that make up the
! blobs framework.
!
! Some of the subroutines contained herein perform tasks such as 
! performing checksums, checking a linked lists for very small blobs 
! (and deleting them), inserting blobs into a list, a bunch of routines 
! for writing blob restart and history files, grid cell search algorithms, 
! buffer manipulations, computations etc.
!
! The module has no namelist.  All potential namelist variables are
! controlled through the ocean_blob_mod namelist.
!</DESCRIPTION>
!
!<INFO>
! <REFERENCE>
! Cormen, T. H, Leiserson, C. E. Rivest, R. L., Stein, C. (2001) Introduction
! to Algorithms.  The MIT Press.
! </REFERENCE>
!
! <REFERENCE>
! Shepard, D. (1968) A two-dimensional interpolation function for 
! irregularly-spaced data.  In: Proceedings of the 1968 23rd ACM national
! conference. ACM '68. ACM, New York, NY, USA, pp. 517-524.
! </REFERENCE>
!
! <REFERENCE>
! Murray, R. J. (1996) Explicit generation of orthogonal grids for
! ocean models.  Journal of Computational Physics 126, 251-273.
! </REFERENCE>
!
!</INFO>


use constants_mod,   only: rad_to_deg, epsln
use fms_mod,         only: error_mesg, FATAL, WARNING, stdout, stderr, mpp_error
use fms_mod,         only: read_data
use mpp_domains_mod, only: mpp_global_sum, mpp_get_neighbor_pe, mpp_update_domains
use mpp_domains_mod, only: mpp_get_current_ntile, mpp_get_tile_id
use mpp_domains_mod, only: NORTH, SOUTH, EAST, WEST
use mpp_mod,         only: mpp_sum, NULL_PE
use grid_mod,        only: get_grid_cell_vertices, get_grid_size

use ocean_parameters_mod, only: onehalf, rho0r, grav, omega_earth
use ocean_parameters_mod, only: GEOPOTENTIAL, ZSTAR, DEPTH_BASED
use ocean_types_mod,      only: ocean_thickness_type, ocean_lagrangian_type
use ocean_types_mod,      only: ocean_prog_tracer_type, ocean_time_type
use ocean_types_mod,      only: ocean_blob_type, ocean_grid_type, ocean_external_mode_type
use ocean_types_mod,      only: ocean_domain_type, ocean_density_type, blob_grid_type
use ocean_workspace_mod,  only: wrk1, wrk2
use ocean_util_mod,       only: write_chksum_3d, write_chksum_3d_int

implicit none

include 'netcdf.inc'

private

integer :: vert_coordinate_class
integer :: vert_coordinate

! set module types
type(ocean_grid_type),   pointer :: Grd   => NULL()
type(ocean_domain_type), pointer :: Dom   => NULL()
type(ocean_domain_type), pointer :: Bdom  => NULL()
type(blob_grid_type),    pointer :: Info  => NULL()
real, dimension(:,:,:),  pointer :: ht    => NULL()
real, dimension(:,:,:),  pointer :: hu    => NULL()

real, dimension(:,:,:,:), allocatable :: vert_t
real, dimension(:,:,:), allocatable :: ij_im1j, im1jm1_im1j, ij_ijm1, im1jm1_ijm1
real, dimension(:,:,:), allocatable :: t_im1jm1, t_ijm1, t_ij, t_im1j
real, dimension(:,:), allocatable :: xt, xu
real, dimension(:,:), allocatable :: yt, yu
real, dimension(:,:), allocatable :: datdtime_r ! 1./(Grd%dat*dtime)
integer, dimension(9) :: im, jm
integer, dimension(5) :: it, jt
integer, dimension(4) :: iu, ju
integer :: nig,njg,ni,nip1
real :: grav_rho0r
real :: two_omega
real :: dtimer
real :: grav_dtimer

public blob_util_init
public blob_chksum
public lagrangian_system_chksum
public E_and_L_totals
public blob_delete
public insert_blob
public count_blob
public put_att
public inq_var
public get_double
public get_int
public put_double
public put_int
public def_var
public blob_util_end
public write_blobs
public check_ijcell
public check_kcell
public kill_blob
public free_blob_memory
public hashfun
public unlink_blob
public allocate_interaction_memory
public reallocate_interaction_memory
public interp_tcoeff
public interp_ucoeff
public check_cyclic

! variables that are read in during init
integer :: index_temp
integer :: index_salt
integer :: global_sum_flag
integer :: num_prog_tracers
logical :: bitwise_reproduction
logical :: debug_this_module
logical :: really_debug
integer :: isd,ied,jsd,jed
integer :: isc,iec,jsc,jec
integer :: isg,ieg,jsg,jeg
integer :: nk
integer :: isbd, iebd, jsbd, jebd
real    :: blob_small_mass

contains

!######################################################################
! <SUBROUTINE NAME="blob_util_init">
!
! <DESCRIPTION>
! Initialises this module.
! </DESCRIPTION>
!
subroutine blob_util_init(Grid, Domain, PE_info, Blob_domain, &
                          sum_flag, num_tracers, itemp, isalt,   &
                          small_mass, dtime, bitwise, ver_coordinate_class,&
                          ver_coordinate, debug, debug_lots)

  type(ocean_grid_type),   intent(in), target :: Grid
  type(ocean_domain_type), intent(in), target :: Domain
  type(ocean_domain_type), intent(in), target :: Blob_domain
  type(blob_grid_type),    intent(in), target :: PE_info
  integer,                 intent(in)         :: sum_flag
  integer,                 intent(in)         :: num_tracers
  integer,                 intent(in)         :: itemp
  integer,                 intent(in)         :: isalt
  real,                    intent(in)         :: small_mass
  real,                    intent(in)         :: dtime
  logical,                 intent(in)         :: bitwise
  integer,                 intent(in)         :: ver_coordinate_class
  integer,                 intent(in)         :: ver_coordinate
  logical,                 intent(in)         :: debug
  logical,                 intent(in)         :: debug_lots

  real, dimension(:,:), allocatable :: dxte, dxue, dytn, dyun, verticies
  real, dimension(:,:), allocatable :: lon_vert, lat_vert
  integer, dimension(:), allocatable :: tile_ids
  integer :: tile, nlon, nlat
  integer :: stdoutunit
  integer :: nfstatus, gsfile, x_vert_t_id, y_vert_t_id, ni, nj
  integer :: i,j,m, iscii,jscjj
  integer :: ii(4), jj(4)
  logical :: do_wst_bnd, do_est_bnd, do_nth_bnd, do_sth_bnd
  logical :: other_vars
  character(len=128) :: filename

  stdoutunit = stdout()

  write (stdoutunit, '(/,a)') 'Note from ocean_blob_util_mod: Initialising ocean_blob_util_mod'

  Grd  => Grid
  Dom  => Domain
  Bdom => Blob_domain
  Info => PE_info

  isd=Dom%isd; ied=Dom%ied; jsd=Dom%jsd; jed=Dom%jed
  isc=Dom%isc; iec=Dom%iec; jsc=Dom%jsc; jec=Dom%jec
  isg=Dom%isg; ieg=Dom%ieg; jsg=Dom%jsg; jeg=Dom%jeg
  ni = Grd%ni; nk = Grd%nk
  nip1 = ni+1

  nig = ieg-(isg-1); njg = jeg-(jsg-1)
  isbd=Bdom%isd; iebd=Bdom%ied; jsbd=Bdom%jsd; jebd=Bdom%jed

  index_temp            = itemp
  index_salt            = isalt
  num_prog_tracers      = num_tracers
  global_sum_flag       = sum_flag
  bitwise_reproduction  = bitwise
  blob_small_mass       = small_mass
  debug_this_module     = debug
  really_debug          = debug_lots
  vert_coordinate_class = ver_coordinate_class
  vert_coordinate       = ver_coordinate

  ! handy constants
  grav_rho0r  = grav*rho0r
  two_omega   = 2 * omega_earth
  dtimer      = 1./dtime
  grav_dtimer = grav*dtimer

  !1: (i,j)
  !2: (i+1,j), 3: (i+1,j+1), 4: (i,j+1), 5: (i-1,j+1)
  !6: (i-1,j), 7: (i-1,j-1), 8: (i,j-1), 9: (i+1,j-1)
  im(1)= 0; jm(1)= 0
  im(2)= 1; jm(2)= 0
  im(3)= 1; jm(3)= 1
  im(4)= 0; jm(4)= 1
  im(5)=-1; jm(5)= 1
  im(6)=-1; jm(6)= 0
  im(7)=-1; jm(7)=-1
  im(8)= 0; jm(8)=-1
  im(9)= 1; jm(9)=-1

  allocate(xt(isbd:iebd, jsbd:jebd))
  allocate(yt(isbd:iebd, jsbd:jebd))
  allocate(xu(isbd:iebd, jsbd:jebd))
  allocate(yu(isbd:iebd, jsbd:jebd))

  xt(isc:iec, jsc:jec) = Grd%xt(isc:iec, jsc:jec)
  yt(isc:iec, jsc:jec) = Grd%yt(isc:iec, jsc:jec)
  xu(isc:iec, jsc:jec) = Grd%xu(isc:iec, jsc:jec)
  yu(isc:iec, jsc:jec) = Grd%yu(isc:iec, jsc:jec)
  call mpp_update_domains(xt(:,:), Bdom%domain2d, complete=.false.)
  call mpp_update_domains(yt(:,:), Bdom%domain2d, complete=.false.)
  call mpp_update_domains(xu(:,:), Bdom%domain2d, complete=.false.)
  call mpp_update_domains(yu(:,:), Bdom%domain2d, complete=.true.)

  ! For cyclic boundary conditions, we need to adjust the halo values
  ! for lon and lat so that the lon and lat are always monotonic
  ! on the one processor to make the calculations for the point location
  ! scheme a bit easier.
  if (Grd%cyclic_x) then 
     do_wst_bnd = .false.
     do_est_bnd = .false.
     do j=jsc,jec
        if (xt(iec+1,j) < xt(iec,  j)) do_est_bnd=.true.
        if (xt(isc,  j) < xt(isc-1,j)) do_wst_bnd=.true.
     enddo

     allocate(dxte(isbd:iebd,jsbd:jebd))
     allocate(dxue(isbd:iebd,jsbd:jebd))
     dxte(isc:iec,jsc:jec) = Grd%dxte(isc:iec,jsc:jec)
     dxue(isc:iec,jsc:jec) = Grd%dxue(isc:iec,jsc:jec)
     call mpp_update_domains(dxte(:,:), Bdom%domain2d)
     call mpp_update_domains(dxue(:,:), Bdom%domain2d)
        
     if (do_wst_bnd) then
        xt(isc-1,jsc:jec) = &
          xt(isc  ,jsc:jec) - rad_to_deg*2*dxte(isc-1,jsc:jec)/(Info%ht(isc  ,jsc:jec,1)+Info%ht(isc-1,jsc:jec,1))
        xt(isc-2,jsc:jec) = &
          xt(isc-1,jsc:jec) - rad_to_deg*2*dxte(isc-2,jsc:jec)/(Info%ht(isc-1,jsc:jec,1)+Info%ht(isc-2,jsc:jec,1))
        xu(isc-1,jsc:jec) = &
          xu(isc  ,jsc:jec) - rad_to_deg*2*dxue(isc-1,jsc:jec)/(Info%hu(isc  ,jsc:jec,2)+Info%hu(isc-1,jsc:jec,2))
        xu(isc-2,jsc:jec) = & 
          xu(isc-1,jsc:jec) - rad_to_deg*2*dxue(isc-2,jsc:jec)/(Info%hu(isc-1,jsc:jec,2)+Info%hu(isc-2,jsc:jec,2))
        
        ! Take care of the corners
        if(Info%pe_NW /= NULL_PE) then
           xt(isc-1,jed:jebd) = &
             xt(isc  ,jed:jebd) - rad_to_deg*2*dxte(isc-1,jed:jebd)/(Info%ht(isc  ,jed:jebd,1)+Info%ht(isc-1,jed:jebd,1))
           xt(isc-2,jed:jebd) = &
             xt(isc-1,jed:jebd) - rad_to_deg*2*dxte(isc-2,jed:jebd)/(Info%ht(isc-1,jed:jebd,1)+Info%ht(isc-2,jed:jebd,1))
           xu(isc-1,jed:jebd) = &
             xu(isc  ,jed:jebd) - rad_to_deg*2*dxue(isc-1,jed:jebd)/(Info%hu(isc  ,jed:jebd,2)+Info%hu(isc-1,jed:jebd,2))
           xu(isc-2,jed:jebd) = &
             xu(isc-1,jed:jebd) - rad_to_deg*2*dxue(isc-2,jed:jebd)/(Info%hu(isc-1,jed:jebd,2)+Info%hu(isc-2,jed:jebd,2))
        endif
        if(Info%pe_SW /= NULL_PE) then
           xt(isc-1,jsbd:jsd) = &
             xt(isc  ,jsbd:jsd) - rad_to_deg*2*dxte(isc-1,jsbd:jsd)/(Info%ht(isc  ,jsbd:jsd,1)+Info%ht(isc-1,jsbd:jsd,1))
           xt(isc-2,jsbd:jsd) = &
             xt(isc-1,jsbd:jsd) - rad_to_deg*2*dxte(isc-2,jsbd:jsd)/(Info%ht(isc-1,jsbd:jsd,1)+Info%ht(isc-2,jsbd:jsd,1))
           xu(isc-1,jsbd:jsd) = &
             xu(isc  ,jsbd:jsd) - rad_to_deg*2*dxue(isc-1,jsbd:jsd)/(Info%hu(isc  ,jsbd:jsd,2)+Info%hu(isc-1,jsbd:jsd,2))
           xu(isc-2,jsbd:jsd) = &
             xu(isc-1,jsbd:jsd) - rad_to_deg*2*dxue(isc-2,jsbd:jsd)/(Info%hu(isc-1,jsbd:jsd,2)+Info%hu(isc-2,jsbd:jsd,2))
        endif
     endif

     if (do_est_bnd) then
        xt(iec+1,jsc:jec) = &
          xt(iec  ,jsc:jec) + rad_to_deg*2*dxte(iec  ,jsc:jec)/(Info%ht(iec  ,jsc:jec,1)+Info%ht(iec+1,jsc:jec,1))
        xt(iec+2,jsc:jec) = &
          xt(iec+1,jsc:jec) + rad_to_deg*2*dxte(iec+1,jsc:jec)/(Info%ht(iec+1,jsc:jec,1)+Info%ht(iec+2,jsc:jec,1))
        xu(iec+1,jsc:jec) = &
          xu(iec  ,jsc:jec) + rad_to_deg*2*dxue(iec  ,jsc:jec)/(Info%hu(iec  ,jsc:jec,2)+Info%hu(iec+1,jsc:jec,2))
        xu(iec+2,jsc:jec) = &
          xu(iec+1,jsc:jec) + rad_to_deg*2*dxue(iec+1,jsc:jec)/(Info%hu(iec+1,jsc:jec,2)+Info%hu(iec+2,jsc:jec,2))

        ! Take care of the corners
        if(Info%pe_NE /= NULL_PE) then
           xt(iec+1,jed:jebd) = &
             xt(iec  ,jed:jebd) + rad_to_deg*2*dxte(iec  ,jed:jebd)/(Info%ht(iec  ,jed:jebd,1)+Info%ht(iec+1,jed:jebd,1))
           xt(iec+2,jed:jebd) = &
             xt(iec+1,jed:jebd) + rad_to_deg*2*dxte(iec+1,jed:jebd)/(Info%ht(iec+1,jed:jebd,1)+Info%ht(iec+2,jed:jebd,1))
           xu(iec+1,jed:jebd) = &
             xu(iec  ,jed:jebd) + rad_to_deg*2*dxue(iec  ,jed:jebd)/(Info%hu(iec  ,jed:jebd,2)+Info%hu(iec+1,jed:jebd,2))
           xu(iec+2,jed:jebd) = &
             xu(iec+1,jed:jebd) + rad_to_deg*2*dxue(iec+1,jed:jebd)/(Info%hu(iec+1,jed:jebd,2)+Info%hu(iec+2,jed:jebd,2))
        endif
        if(Info%pe_SE /= NULL_PE) then
           xt(iec+1,jsbd:jsd) = &
             xt(iec  ,jsbd:jsd) + rad_to_deg*2*dxte(iec  ,jsbd:jsd)/(Info%ht(iec  ,jsbd:jsd,1)+Info%ht(iec+1,jsbd:jsd,1))
           xt(iec+2,jsbd:jsd) = &
             xt(iec+1,jsbd:jsd) + rad_to_deg*2*dxte(iec+1,jsbd:jsd)/(Info%ht(iec+1,jsbd:jsd,1)+Info%ht(iec+2,jsbd:jsd,1))
           xu(iec+1,jsbd:jsd) = &
             xu(iec  ,jsbd:jsd) + rad_to_deg*2*dxue(iec  ,jsbd:jsd)/(Info%hu(iec  ,jsbd:jsd,2)+Info%hu(iec+1,jsbd:jsd,2))
           xu(iec+2,jsbd:jsd) = &
             xu(iec+1,jsbd:jsd) + rad_to_deg*2*dxue(iec+1,jsbd:jsd)/(Info%hu(iec+1,jsbd:jsd,2)+Info%hu(iec+2,jsbd:jsd,2))
        endif
     endif

     deallocate(dxte)
     deallocate(dxue)
  endif

  if (Grd%cyclic_y .or. Grd%tripolar) then
     do_nth_bnd = .false.
     do_sth_bnd = .false.
     do i=isc,iec
        if (yt(i,jec+1) < yt(i,jec)  ) do_nth_bnd=.true.
        if (yt(i,jsc)   < yt(i,jsc-1)) do_sth_bnd=.true.
     enddo
     
     allocate(dytn(isbd:iebd,jsbd:jebd))
     allocate(dyun(isbd:iebd,jsbd:jebd))
     dytn(isc:iec,jsc:jec) = Grd%dytn(isc:iec,jsc:jec)
     dyun(isc:iec,jsc:jec) = Grd%dyun(isc:iec,jsc:jec)
     call mpp_update_domains(dytn(:,:), Bdom%domain2d)
     call mpp_update_domains(dyun(:,:), Bdom%domain2d)

     if (do_sth_bnd .and. .not. Grd%tripolar) then
        ! The tripolar grid has a solid southern boundary, so, we only want to alter the halos at the northern boundary
        yt(isc:iec,jsc-1) = &
          yt(isc:iec,jsc  ) - rad_to_deg*2*dytn(isc:iec,jsc-1)/(Info%ht(isc:iec,jsc  ,1)+Info%ht(isc:iec,jsc-1,1))
        yt(isc:iec,jsc-2) = &
          yt(isc:iec,jsc-1) - rad_to_deg*2*dytn(isc:iec,jsc-2)/(Info%ht(isc:iec,jsc-1,1)+Info%ht(isc:iec,jsc-2,1))
        yu(isc:iec,jsc-1) = &
          yu(isc:iec,jsc  ) - rad_to_deg*2*dyun(isc:iec,jsc-1)/(Info%hu(isc:iec,jsc  ,2)+Info%hu(isc:iec,jsc-1,2))
        yu(isc:iec,jsc-2) = &
          yu(isc:iec,jsc-1) - rad_to_deg*2*dyun(isc:iec,jsc-2)/(Info%hu(isc:iec,jsc-1,2)+Info%hu(isc:iec,jsc-2,2))

        ! Do the corners
        if (Info%pe_SW /= NULL_PE) then
           yt(isbd:isd,jsc-1) = &
             yt(isbd:isd,jsc  ) - rad_to_deg*2*dytn(isbd:isd,jsc-1)/(Info%ht(isbd:isd,jsc  ,1)+Info%ht(isbd:isd,jsc-1,1))
           yt(isbd:isd,jsc-2) = &
             yt(isbd:isd,jsc-1) - rad_to_deg*2*dytn(isbd:isd,jsc-2)/(Info%ht(isbd:isd,jsc-1,1)+Info%ht(isbd:isd,jsc-2,1))
           yu(isbd:isd,jsc-1) = &
             yu(isbd:isd,jsc  ) - rad_to_deg*2*dyun(isbd:isd,jsc-1)/(Info%hu(isbd:isd,jsc  ,2)+Info%hu(isbd:isd,jsc-1,2))
           yu(isbd:isd,jsc-2) = &
             yu(isbd:isd,jsc-1) - rad_to_deg*2*dyun(isbd:isd,jsc-2)/(Info%hu(isbd:isd,jsc-1,2)+Info%hu(isbd:isd,jsc-2,2))
        endif
        if (Info%pe_SE /= NULL_PE) then
           yt(ied:iebd,jsc-1) = &
             yt(ied:iebd,jsc  ) - rad_to_deg*2*dytn(ied:iebd,jsc-1)/(Info%ht(ied:iebd,jsc  ,1)+Info%ht(ied:iebd,jsc-1,1))
           yt(ied:iebd,jsc-2) = &
             yt(ied:iebd,jsc-1) - rad_to_deg*2*dytn(ied:iebd,jsc-2)/(Info%ht(ied:iebd,jsc-1,1)+Info%ht(ied:iebd,jsc-2,1))
           yu(ied:iebd,jsc-1) = &
             yu(ied:iebd,jsc  ) - rad_to_deg*2*dyun(ied:iebd,jsc-1)/(Info%hu(ied:iebd,jsc  ,2)+Info%hu(ied:iebd,jsc-1,2))
           yu(ied:iebd,jsc-2) = &
             yu(ied:iebd,jsc-1) - rad_to_deg*2*dyun(ied:iebd,jsc-2)/(Info%hu(ied:iebd,jsc-1,2)+Info%hu(ied:iebd,jsc-2,2))
        endif

     endif
     if (do_nth_bnd) then
        yt(isc:iec,jec+1) = &
          yt(isc:iec,jec  ) + rad_to_deg*2*dytn(isc:iec,jsc  )/(Info%ht(isc:iec,jec  ,1)+Info%ht(isc:iec,jec+1,1))
        yt(isc:iec,jec+2) = &
          yt(isc:iec,jec+1) + rad_to_deg*2*dytn(isc:iec,jsc+1)/(Info%ht(isc:iec,jec+1,1)+Info%ht(isc:iec,jec+2,1))
        yu(isc:iec,jec+1) = &
          yu(isc:iec,jec  ) + rad_to_deg*2*dyun(isc:iec,jsc  )/(Info%hu(isc:iec,jec  ,2)+Info%hu(isc:iec,jec+1,2))
        yu(isc:iec,jec+2) = &
          yu(isc:iec,jec+1) + rad_to_deg*2*dyun(isc:iec,jsc+1)/(Info%hu(isc:iec,jec+1,2)+Info%hu(isc:iec,jec+2,2))

        ! Do the corners
        if (Info%pe_NW /= NULL_PE) then
           yt(isbd:isd,jec+1) = &
             yt(isbd:isd,jec  ) + rad_to_deg*2*dytn(isbd:isd,jsc  )/(Info%ht(isbd:isd,jec  ,1)+Info%ht(isbd:isd,jec+1,1))
           yt(isbd:isd,jec+2) = &
             yt(isbd:isd,jec+1) + rad_to_deg*2*dytn(isbd:isd,jsc+1)/(Info%ht(isbd:isd,jec+1,1)+Info%ht(isbd:isd,jec+2,1))
           yu(isbd:isd,jec+1) = &
             yu(isbd:isd,jec  ) + rad_to_deg*2*dyun(isbd:isd,jsc  )/(Info%hu(isbd:isd,jec  ,2)+Info%hu(isbd:isd,jec+1,2))
           yu(isbd:isd,jec+2) = &
             yu(isbd:isd,jec+1) + rad_to_deg*2*dyun(isbd:isd,jsc+1)/(Info%hu(isbd:isd,jec+1,2)+Info%hu(isbd:isd,jec+2,2))
        endif
        if (Info%pe_NE /= NULL_PE) then
           yt(ied:iebd,jec+1) = &
             yt(ied:iebd,jec  ) + rad_to_deg*2*dytn(ied:iebd,jsc  )/(Info%ht(ied:iebd,jec  ,1)+Info%ht(ied:iebd,jec+1,1))
           yt(ied:iebd,jec+2) = &
             yt(ied:iebd,jec+1) + rad_to_deg*2*dytn(ied:iebd,jsc+1)/(Info%ht(ied:iebd,jec+1,1)+Info%ht(ied:iebd,jec+2,1))
           yu(ied:iebd,jec+1) = &
             yu(ied:iebd,jec  ) + rad_to_deg*2*dyun(ied:iebd,jsc  )/(Info%hu(ied:iebd,jec  ,2)+Info%hu(ied:iebd,jec+1,2))
           yu(ied:iebd,jec+2) = &
             yu(ied:iebd,jec+1) + rad_to_deg*2*dyun(ied:iebd,jsc+1)/(Info%hu(ied:iebd,jec+1,2)+Info%hu(ied:iebd,jec+2,2))
        endif
     endif
     deallocate(dytn)
     deallocate(dyun)
  endif
     
  allocate( datdtime_r(isd:ied,jsd:jed) )
  datdtime_r(:,:) = Grd%datr(:,:)/dtime

  ! Calculate the vectors of the sides of grid cells (in 
  ! the horizontal) for the point location scheme.
  allocate( vert_t(2,4,isd:ied,jsd:jed) )

  allocate(tile_ids(mpp_get_current_ntile(Dom%domain2d)))
  tile_ids = mpp_get_tile_id(Dom%domain2d)
  tile = tile_ids(1)    ! Assume one tile per PE
  deallocate(tile_ids)

  call get_grid_size('OCN', tile, nlon, nlat)
  allocate(lon_vert(nlon+1, nlat+1))
  allocate(lat_vert(nlon+1, nlat+1))

  call get_grid_cell_vertices('OCN', tile, lon_vert, lat_vert)

  ! In this grid configuration, we derive the verticies from a 2d configuration
  ! with shape (isc:iec+1,jsc:jec+1).
  ! The verticies with the bottom left hand corner corresponding to i,j
  !
  !     4     3
  !     +-----+
  !     | i,j |
  !     +-----+
  !     1     2
  !
  ! 1==(i,j); 2==(i+1,j); 3==(i+1,j+1); 4==(i,j+1)

  call mpp_update_domains(lon_vert(:,:), Dom%domain2d)
  vert_t(1, 1, isc:iec, jsc:jec) = lon_vert(isc:iec, jsc:jec)
  vert_t(1, 2, isc:iec, jsc:jec) = lon_vert((1+isc):(1+iec), jsc:jec)
  vert_t(1, 3, isc:iec, jsc:jec) = lon_vert((1+isc):(1+iec), (1+jsc):(1+jec))
  vert_t(1, 4, isc:iec, jsc:jec) = lon_vert(isc:iec, (1+jsc):(1+jec))

  call mpp_update_domains(lat_vert(:,:), Dom%domain2d)
  vert_t(2, 1, isc:iec, jsc:jec) = lat_vert(isc:iec, jsc:jec)
  vert_t(2, 2, isc:iec, jsc:jec) = lat_vert((1+isc):(1+iec), jsc:jec)
  vert_t(2, 3, isc:iec, jsc:jec) = lat_vert((1+isc):(1+iec), (1+jsc):(1+jec))
  vert_t(2, 4, isc:iec, jsc:jec) = lat_vert(isc:iec, (1+jsc):(1+jec))

  deallocate(lon_vert)
  deallocate(lat_vert)

  ! Now fill/get the values in the halos
  if (Info%pe_E==NULL_PE)  vert_t(:,:,ied,jsc:jec) = 0.0
  if (Info%pe_N==NULL_PE)  vert_t(:,:,isc:iec,jed) = 0.0
  if (Info%pe_W==NULL_PE)  vert_t(:,:,isd,jsc:jec) = 0.0
  if (Info%pe_S==NULL_PE)  vert_t(:,:,isc:iec,jsd) = 0.0
  if (Info%pe_NE==NULL_PE) vert_t(:,:,ied,jed)     = 0.0
  if (Info%pe_NW==NULL_PE) vert_t(:,:,isd,jed)     = 0.0
  if (Info%pe_SW==NULL_PE) vert_t(:,:,isd,jsd)     = 0.0
  if (Info%pe_SE==NULL_PE) vert_t(:,:,ied,jsd)     = 0.0

  ! The verticies are indexed from southwest, anticlockwise
  !                  4-----3
  !                  |     |
  !                  |  T  |
  !                  |     |
  !                  1-----2

  !Pre calculate some of the vectors for the point location scheme
  !See notes for details
  allocate( ij_im1j(    2,isd:ied,jsd:jed) )
  allocate( im1jm1_ijm1(2,isd:ied,jsd:jed) )
  allocate( ij_ijm1(    2,isd:ied,jsd:jed) )
  allocate( im1jm1_im1j(2,isd:ied,jsd:jed) )

  allocate( t_im1j(     2,isd:ied,jsd:jed) )
  allocate( t_ij(       2,isd:ied,jsd:jed) )
  allocate( t_ijm1(     2,isd:ied,jsd:jed) )
  allocate( t_im1jm1(   2,isd:ied,jsd:jed) )

  !North vector: U(i  ,j  )=>U(i-1,j  ), aka 3=>4
  ij_im1j(    :,isd:ied,jsd:jed) = vert_t(:,4,isd:ied,jsd:jed) - vert_t(:,3,isd:ied,jsd:jed)

  !South vector: U(i-1,j-1)=>U(i-1,j  ), aka 1=>2
  im1jm1_ijm1(:,isd:ied,jsd:jed) = vert_t(:,2,isd:ied,jsd:jed) - vert_t(:,1,isd:ied,jsd:jed)

  !East vector:  U(i  ,j  )=>U(i  ,j-1), aka 3=>2
  ij_ijm1(    :,isd:ied,jsd:jed) = vert_t(:,2,isd:ied,jsd:jed) - vert_t(:,3,isd:ied,jsd:jed)

  !West vector:  U(i-1,j-1)=>U(i-1,j  ), aka 1=>4
  im1jm1_im1j(:,isd:ied,jsd:jed) = vert_t(:,4,isd:ied,jsd:jed) - vert_t(:,1,isd:ied,jsd:jed)

  !T(i,j)=>U(i-1,j-1)
  t_im1jm1(1,isd:ied,jsd:jed) = vert_t(1,1,isd:ied,jsd:jed) - Grd%xt(isd:ied,jsd:jed)
  t_im1jm1(2,isd:ied,jsd:jed) = vert_t(2,1,isd:ied,jsd:jed) - Grd%yt(isd:ied,jsd:jed)

  !T(i,j)=>U(i  ,j-1)
  t_ijm1(1,isd:ied,jsd:jed) = vert_t(1,2,isd:ied,jsd:jed) - Grd%xt(isd:ied,jsd:jed)
  t_ijm1(2,isd:ied,jsd:jed) = vert_t(2,2,isd:ied,jsd:jed) - Grd%yt(isd:ied,jsd:jed)

  !T(i,j)=>U(i  ,j  )
  t_ij(1,isd:ied,jsd:jed) = vert_t(1,3,isd:ied,jsd:jed) - Grd%xt(isd:ied,jsd:jed)
  t_ij(2,isd:ied,jsd:jed) = vert_t(2,3,isd:ied,jsd:jed) - Grd%yt(isd:ied,jsd:jed)

  !T(i,j)=>U(i-1,j  )
  t_im1j(1,isd:ied,jsd:jed) = vert_t(1,4,isd:ied,jsd:jed) - Grd%xt(isd:ied,jsd:jed)
  t_im1j(2,isd:ied,jsd:jed) = vert_t(2,4,isd:ied,jsd:jed) - Grd%yt(isd:ied,jsd:jed)

  allocate(Info%maxlon(jsc:jec))
  allocate(Info%minlon(jsc:jec))
  allocate(Info%maxlat(isc:iec))
  allocate(Info%minlat(isc:iec))

  do j=jsc,jec
     Info%minlon(j) = minval(vert_t(1,:,isc:iec,j))
     Info%maxlon(j) = maxval(vert_t(1,:,isc:iec,j))
  enddo
  do i=isc,iec
     Info%minlat(i) = minval(vert_t(2,:,i,jsc:jec))
     Info%maxlat(i) = maxval(vert_t(2,:,i,jsc:jec))
  enddo

end subroutine blob_util_init
! </SUBROUTINE>  NAME="blob_util_init"


!######################################################################
! <SUBROUTINE NAME="blob_chksum">
!
! <DESCRIPTION>
! Performs global sums and checksums for all blob types (for diagnostic
! purposes).  
! </DESCRIPTION>
!
subroutine blob_chksum(T_prog, head_static_free, head_static_bott, &
                       head_dynamic_free, head_dynamic_bott, blob_counter)

  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  type(ocean_blob_type),        pointer    :: head_static_free
  type(ocean_blob_type),        pointer    :: head_static_bott
  type(ocean_blob_type),        pointer    :: head_dynamic_free
  type(ocean_blob_type),        pointer    :: head_dynamic_bott
  integer, dimension(isc:iec,jsc:jec,nk), intent(in) :: blob_counter

  type(ocean_blob_type), pointer                       :: this=>NULL()
  real, dimension(isd:ied,jsd:jed,nk,num_prog_tracers) :: grdtracer, grdfield
  real, dimension(isd:ied,jsd:jed,nk)    :: grdlat, grdlon, grddepth, grdgeodepth
  real, dimension(isd:ied,jsd:jed,nk)    :: grdu, grdv, grdw, grdent
  real, dimension(isd:ied,jsd:jed,nk)    :: grdmass, grddens, grdvolume
  real, dimension(isd:ied,jsd:jed,nk)    :: grdh1, grdh2, grdstep, grdst
  integer, dimension(isd:ied,jsd:jed,nk) :: grdhash, grdnum 
  integer, dimension(isd:ied,jsd:jed,nk) :: grdnsteps, grdmsteps
  integer, dimension(isd:ied,jsd:jed,nk) :: grdi, grdj, grdk
  integer           :: tmpi
  integer           :: i, j, k, p, n, nblobs
  character(len=28) :: tname
  character(len=28) :: fname
  character(len=*), parameter :: fmti="(a,x,i25)"
  character(len=*), parameter :: fmte="(a,x,es25.18)"
  integer :: stdoutunit

  real :: tmpr

  stdoutunit=stdout()

  grdlat(:,:,:)      = 0.0
  grdlon(:,:,:)      = 0.0
  grddepth(:,:,:)    = 0.0
  grdgeodepth(:,:,:) = 0.0
  grdst(:,:,:)       = 0.0
  grdmass(:,:,:)     = 0.0
  grddens(:,:,:)     = 0.0
  grdvolume(:,:,:)   = 0.0
  grdu(:,:,:)        = 0.0
  grdv(:,:,:)        = 0.0
  grdw(:,:,:)        = 0.0
  grdent(:,:,:)      = 0.0
  grdh1(:,:,:)       = 0.0
  grdh2(:,:,:)       = 0.0
  grdstep(:,:,:)     = 0.0
  grdtracer(:,:,:,:) = 0.0
  grdfield(:,:,:,:)  = 0.0
  grdhash(:,:,:)     = 0
  grdnum(:,:,:)      = 0
  grdnsteps(:,:,:)   = 0
  grdmsteps(:,:,:)   = 0
  grdi(:,:,:)        = 0
  grdj(:,:,:)        = 0
  grdk(:,:,:)        = 0
  nblobs             = 0 !number of blobs

  do p=1,4
     nullify(this)
     if(p==1 .and. associated(head_static_free))  this=>head_static_free
     if(p==2 .and. associated(head_static_bott))  this=>head_static_bott
     if(p==3 .and. associated(head_dynamic_free)) this=>head_dynamic_free
     if(p==4 .and. associated(head_dynamic_bott)) this=>head_dynamic_bott

     if (associated(this)) then
        fullcycle: do
           i = this%i - Dom%ioff
           j = this%j - Dom%joff
           k = this%k

           if (isc<=i .and. i<=iec .and. jsc<=j .and. j<=jec) then
              grdlat(i,j,k)      = grdlat(i,j,k)      + this%lat
              grdlon(i,j,k)      = grdlon(i,j,k)      + this%lon
              grddepth(i,j,k)    = grddepth(i,j,k)    + this%depth
              grdgeodepth(i,j,k) = grdgeodepth(i,j,k) + this%geodepth
              grdst(i,j,k)       = grdst(i,j,k)       + this%st
              grdmass(i,j,k)     = grdmass(i,j,k)     + this%mass
              grddens(i,j,k)     = grddens(i,j,k)     + this%density
              grdvolume(i,j,k)   = grdvolume(i,j,k)   + this%volume
              grdu(i,j,k)        = grdu(i,j,k)        + this%v(1)
              grdv(i,j,k)        = grdv(i,j,k)        + this%v(2)
              grdw(i,j,k)        = grdw(i,j,k)        + this%v(3)
              grdent(i,j,k)      = grdent(i,j,k)      + this%ent
              grdh1(i,j,k)       = grdh1(i,j,k)       + this%h1
              grdh2(i,j,k)       = grdh2(i,j,k)       + this%h2
              grdhash(i,j,k)     = grdhash(i,j,k)     + this%hash
              grdnum(i,j,k)      = grdnum(i,j,k)      + this%number
              grdstep(i,j,k)     = grdstep(i,j,k)     + this%step
              grdnsteps(i,j,k)   = grdnsteps(i,j,k)   + this%nsteps
              grdmsteps(i,j,k)   = grdmsteps(i,j,k)   + this%model_steps
              grdi(i,j,k)        = grdi(i,j,k)        + this%i
              grdj(i,j,k)        = grdj(i,j,k)        + this%j
              grdk(i,j,k)        = grdk(i,j,k)        + this%k
              nblobs             = nblobs + 1
              do n=1,num_prog_tracers
                 grdtracer(i,j,k,n) = grdtracer(i,j,k,n) + this%tracer(n)
                 if (p==3.or.p==4) grdfield(i,j,k,n)  = grdfield(i,j,k,n) + this%field(n)
              enddo
           endif

           this=>this%next
           if(.not. associated(this)) exit fullcycle
        enddo fullcycle
     endif
  enddo

  
  call mpp_sum(nblobs)

  write(stdoutunit, fmti)    'total number of blobs               =', nblobs

  tmpi = sum(blob_counter(:,:,:))
  call mpp_sum(tmpi)
  write(stdoutunit, fmti) 'global number of blobs for all time =', tmpi

  tmpr = mpp_global_sum(Dom%domain2d, grdmass(isc:iec,jsc:jec,1:nk),global_sum_flag)
  write(stdoutunit, fmte) 'global mass of blobs                =', tmpr
  do n=1,num_prog_tracers
     tmpr = mpp_global_sum(Dom%domain2d, grdtracer(isc:iec,jsc:jec,1:nk,n),global_sum_flag)
     if(n==index_temp) then
             write(stdoutunit, fmte) 'global heat content of blobs        =', tmpr
     else
        tname = trim(T_prog(n)%name)//' content of blobs'
        fname = trim(T_prog(n)%name)//' concentration of blobs'
        write(stdoutunit, fmte) 'global '//tname(:)//' =', tmpr
     endif
  enddo

  call write_chksum_3d_int('blob counter', blob_counter(COMP,1:nk))
  call write_chksum_3d('blob latitude', grdlat(COMP,1:nk))  
  call write_chksum_3d('blob longitude', grdlon(COMP,1:nk))
  call write_chksum_3d('blob depth', grddepth(COMP,1:nk))
  call write_chksum_3d('blob geodepth', grdgeodepth(COMP,1:nk))
  call write_chksum_3d('blob vertical coord. (st)', grdst(COMP,1:nk))
  call write_chksum_3d('blob mass', grdmass(COMP,1:nk))
  call write_chksum_3d('blob density', grddens(COMP,1:nk))
  call write_chksum_3d('blob volume', grdvolume(COMP,1:nk))
  call write_chksum_3d('blob zonal velocity', grdu(COMP,1:nk))
  call write_chksum_3d('blob meridional velocity', grdv(COMP,1:nk))
  call write_chksum_3d('blob vertical velocity', grdw(COMP,1:nk))
  call write_chksum_3d('blob entrainment velocity', grdent(COMP,1:nk))
  call write_chksum_3d('stretching function 1', grdh1(COMP,1:nk))
  call write_chksum_3d('stretching function 2', grdh2(COMP,1:nk))
  call write_chksum_3d_int('blob number', grdnum(COMP,1:nk))
  call write_chksum_3d('blob step size', grdstep(COMP,1:nk))
  call write_chksum_3d_int('number of blob steps', grdnsteps(COMP,1:nk))
  call write_chksum_3d_int('number of E system steps', grdmsteps(COMP,1:nk))
  call write_chksum_3d_int('zonal cell index (i)', grdi(COMP,1:nk))
  call write_chksum_3d_int('meridional cell index (j)', grdj(COMP,1:nk))
  call write_chksum_3d_int('depth cell index (k)', grdk(COMP,1:nk))
  do n=1,num_prog_tracers    
     if (n==index_temp) then
        call write_chksum_3d('blob heat content', grdtracer(COMP,1:nk,n))
        call writE_chksum_3d('blob temp concentration', grdfield(COMP,1:nk,n))
     else
        tname = trim(T_prog(n)%name)//' content'
        call write_chksum_3d('blob '//tname(1:19), grdtracer(COMP,1:nk,n))
        call write_chksum_3d(fname(1:19), grdfield(COMP,1:nk,n))
     endif
  enddo
  write(stdoutunit, '(a)') 'end blob chksums'

end subroutine blob_chksum
! </SUBROUTINE>  NAME="blob_chksum"

!######################################################################
! <SUBROUTINE NAME="lagrangian_system_chksum">
!
! <DESCRIPTION>
!
! Performs checksums for the Lagrangian_system derived type.  This is
! the derived type that stores all of the "gridded" blob variables, 
! and is essential for the accounting required to interact with the 
! Eulerian model in a conservative manner.  The checksums are for
! diagnostic purposes.
!
! </DESCRIPTION>
!
subroutine lagrangian_system_chksum(L_system)

  type(ocean_lagrangian_type), intent(in) :: L_system

  integer :: stdoutunit
  character(len=*), parameter :: fmt="(a,x,i20)"

  stdoutunit=stdout()

  call write_chksum_3d('T-grid upper cell rho_dzt (taup1)', L_system%rho_dztup(COMP,1:nk))
  call write_chksum_3d('T-grid lower cell rho_dzt (taup1)', L_system%rho_dztlo(COMP,1:nk))
  call write_chksum_3d('T-grid blob convergence (taup1)', L_system%conv_blob(COMP,1:nk))
  write(stdoutunit, fmt) 'end Lagrangian system chksums'

end subroutine lagrangian_system_chksum
! </SUBROUTINE>  NAME="lagrangian_system_chksum"

!######################################################################
! <SUBROUTINE NAME="E_and_L_totals">
!
! <DESCRIPTION>
! Gives a brief summary of the total mass, volume and tracer content
! of the E, L and total systems.  Usually used for debuggin purposes.
! </DESCRIPTION>
!
subroutine E_and_L_totals(L_system, Thickness, T_prog, idx)
  type(ocean_lagrangian_type),  intent(in) :: L_system
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  integer,                      intent(in) :: idx

  real, dimension(isd:ied,jsd:jed) :: tmpE, tmpL1, tmpL2, tmpT
  real :: tmpE_total, tmpL1_total, tmpL2_total, tmpT_total
  character(len=128) :: tname
  integer :: n, k
  integer :: stdoutunit

  stdoutunit=stdout()

  tmpE  = Grd%dat(:,:)*sum(Grd%tmask(:,:,:)*Thickness%rho_dzt( :,:,:,idx),3)
  tmpL1 = Grd%dat(:,:)*sum(Grd%tmask(:,:,:)*Thickness%rho_dztL(:,:,:,idx),3)
  do k=1,nk
     tmpL2 = Grd%tmask(:,:,k)*Grd%dat(:,:)*(L_system%rho_dztup(:,:,k)+L_system%rho_dztlo(:,:,k))
  enddo
  tmpT  = Grd%dat(:,:)*sum(Grd%tmask(:,:,:)*Thickness%rho_dztT(:,:,:,idx),3)
  call maketotal(.true.)
  write(stdoutunit,'(a,x,es25.18,x,a)') 'E mass                  =',tmpE_total, 'kg'
  write(stdoutunit,'(a,x,es25.18,x,a)') 'L mass (from thickness) =',tmpL1_total,'kg'
  write(stdoutunit,'(a,x,es25.18,x,a)') 'L mass (from L_system)  =',tmpL2_total,'kg'
  write(stdoutunit,'(a,x,es25.18,x,a)') 'E + L mass              =',tmpE_total+tmpL1_total,'kg'
  write(stdoutunit,'(a,x,es25.18,x,a)') 'T mass (from rho_dztT)  =',tmpT_total,'kg'

  tmpE  = Grd%dat(:,:)*sum(Grd%tmask(:,:,:)*Thickness%dzt( :,:,:),3)
  tmpL1 = Grd%dat(:,:)*sum(Grd%tmask(:,:,:)*Thickness%dztL(:,:,:),3)
  tmpT  = Grd%dat(:,:)*sum(Grd%tmask(:,:,:)*Thickness%dztT(:,:,:,idx),3)
  call maketotal(.true.)
  write(stdoutunit,'(a,x,es25.18,x,a)') 'E volume                  =',tmpE_total, 'm^3'
  write(stdoutunit,'(a,x,es25.18,x,a)') 'L volume (from thickness) =',tmpL1_total,'m^3'
  write(stdoutunit,'(a,x,es25.18,x,a)') 'E + L volume              =',tmpE_total+tmpL1_total,'m^3'
  write(stdoutunit,'(a,x,es25.18,x,a)') 'T volume (from dztT)      =',tmpT_total,'m^3'

  do n=1,num_prog_tracers
     tmpE  = T_prog(n)%conversion*Grd%dat(:,:)                   &
             *sum( Grd%tmask(:,:,:)*Thickness%rho_dzt(:,:,:,idx)*T_prog(n)%field(:,:,:,idx), 3)
     tmpL1 = T_prog(n)%conversion*sum(Grd%tmask(:,:,:)*T_prog(n)%sum_blob(:,:,:,idx), 3)
     tmpT  = tmpE + tmpL1
     call maketotal(.false.)
     if(n==index_temp) then
        write(stdoutunit,'(a,x,es25.18,x,a)') 'E heat       =',tmpE_total, 'J'
        write(stdoutunit,'(a,x,es25.18,x,a)') 'L heat       =',tmpL1_total,'J'
        write(stdoutunit,'(a,x,es25.18,x,a)') 'T heat       =',tmpT_total, 'J'
     elseif(T_prog(n)%name(1:3)=='age') then
        tname = trim(T_prog(n)%name)
        write(stdoutunit,'(a,x,es25.18,x,a)') 'E '//tname(1:10)//' =',tmpE_total, 'yr'
        write(stdoutunit,'(a,x,es25.18,x,a)') 'L '//tname(1:10)//' =',tmpL1_total,'yr'
        write(stdoutunit,'(a,x,es25.18,x,a)') 'T '//tname(1:10)//' =',tmpT_total, 'yr'
     else
        tname = trim(T_prog(n)%name)
        write(stdoutunit,'(a,x,es25.18,x,a)') 'E '//tname(1:10)//' =',tmpE_total, 'kg'
        write(stdoutunit,'(a,x,es25.18,x,a)') 'L '//tname(1:10)//' =',tmpL1_total,'kg'
        write(stdoutunit,'(a,x,es25.18,x,a)') 'T '//tname(1:10)//' =',tmpT_total, 'kg'
     endif
  enddo

contains

  !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  ! This is a nested subroutine that does the global sum of an array for !
  ! each of the E system, L system and the combined system.              !
  !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine maketotal(do_L2)
    logical, intent(in) :: do_L2
    tmpE_total  = mpp_global_sum(Dom%domain2d, tmpE,  global_sum_flag)
    tmpL1_total = mpp_global_sum(Dom%domain2d, tmpL1, global_sum_flag)
    tmpT_total  = mpp_global_sum(Dom%domain2d, tmpT,  global_sum_flag)
    if (do_L2) then 
       tmpL2_total = mpp_global_sum(Dom%domain2d, tmpL2, global_sum_flag)
    endif
  end subroutine maketotal

end subroutine E_and_L_totals
! </SUBROUTINE>  NAME="E_and_L_totals"

!######################################################################
! <SUBROUTINE NAME="write_blobs">
!
! <DESCRIPTION>
! Dumps most of the information carried around by blobs, for all blobs
! in a particular list.  Useful for debugging.
! </DESCRIPTION>
!
subroutine write_blobs(head, head_name, time)
  type(ocean_blob_type), pointer    :: head
  character(len=*),      intent(in) :: head_name
  character(len=*),      intent(in) :: time

  type(ocean_blob_type), pointer :: this=>NULL()
  integer :: i,j,n
  integer :: stdoutunit

  stdoutunit = stdout()

  write(stdoutunit, '(a)') ' '
  write(stdoutunit, '(a)') 'Summary of all blobs in '//trim(head_name)//' list ('//trim(time)//')'
  write(stdoutunit,'(4(a3,x),2(a6,x),4(a6,x),2(a10,x),1(a8,x),2(a10,x),2(a6,x),3(a9,x),(a10))') &
       'pe','i','j','k', &
       'hash','number', &
       'lat','lon','depth', 'gdepth',&
       'mass','volume','density', &
       'heat','S (kg)', &
       'temp','sal', &
       'u','v','w', &
       'dzt'
  n=0
  if(associated(head)) then
     this=>head
     blobcycle: do
        i=this%i; j=this%j
        print('(4(i3,x),2(i6,x),4(f6.1,x),2(es10.3,x),(f8.2,x),2(es10.3,x),2(f6.2,x),3(es9.2,x),(es10.3))'), &
             Info%pe_this, i, j, this%k,&
             this%hash, this%number, &
             this%lat, this%lon, this%depth, this%geodepth,&
             this%mass, this%volume, &
             this%density,&
             this%tracer(index_temp), this%tracer(index_salt), &
             this%field(index_temp), this%field(index_salt),&
             this%v(1), this%v(2), this%v(3), &
             this%volume*Grd%datr(i,j)
        n=n+1
        this=>this%next
        if(.not.associated(this)) exit blobcycle
     enddo blobcycle
  endif
  print('(a,i3,a,i10)'), 'total '//trim(head_name)//' blobs on pe ',Info%pe_this,' = ', n

end subroutine write_blobs
! </SUBROUTINE>  NAME="write_blobs"

!######################################################################
! <SUBROUTINE NAME="blob_delete">
!
! <DESCRIPTION>
! Deletes all (nearly) zero mass blob objects from the linked list.
! The size of the blobs that are deleted is controlled by the variable
! blob_small_mass in the ocean_blob_nml.
! </DESCRIPTION>
!
subroutine blob_delete(Time, Thickness, T_prog, head)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(inout) :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_blob_type),        pointer       :: head

  ! local variables
  type(ocean_blob_type), pointer :: prev => NULL()
  type(ocean_blob_type), pointer :: this => NULL()
  type(ocean_blob_type), pointer :: next => NULL()
  integer :: i,j,k,tau,taup1

  taup1 = Time%taup1
  tau   = Time%tau

  ! point this to the head blob
  this => head
  
  !====================================================================!
  ! if the head is not associated, the list is empty and there is      !
  ! nothing to delete if it is associated, then cycle through the list,!
  ! deleting all zero-mass blobs until the end (tail) of the list is   !
  ! reached                                                            !
  !====================================================================!

  ! check if the head is associated
  if(associated(this)) then
     next => this%next

     blobdel: do
        i = this%i
        j = this%j
        k = this%k

        if(this%mass < blob_small_mass) then
           
           ! return any blob properties to the E system
           call kill_blob(Thickness, T_prog(:), this, i, j, k)
           
           ! Deallocate the blob from memory
           call free_blob_memory(this)
           
           ! Unlink the blob from the list. Point the previous blob 
           ! to the next blob and vice versa.
           if(associated(prev)) then
              prev%next=>next
           else
              ! if the prev is not associated, we are at the head
              ! and we need to point the head towards the next
              head => next
              if(associated(next)) next%prev=>NULL()
           endif
           
           ! this is the vice versa bit
           if(associated(next)) next%prev=>prev
           
        endif ! blob mass small?

        ! check to see whether we are at the end of the list.  If so, exit
        ! the loop.  If not, then move our current, prev and next blobs
        ! further down the list and go back to the beginning of the do loop
        if(associated(next)) then
           this => next
           prev => this%prev
           next => this%next
        else
           exit blobdel
        endif

     enddo blobdel

     nullify(this)
     nullify(prev)
     nullify(next)

  endif !head associated?

end subroutine blob_delete
! </SUBROUTINE>  NAME="blob_delete"

!######################################################################
! <SUBROUTINE NAME="unlink_blob">
!
! <DESCRIPTION>
! Unlinks a blob from a doubly linked list.  It returns pointers to 
! the blob, the head of the list, the (formerly) previous blob in the 
! list and the (formerly) next blob in the list.
! </DESCRIPTION>
!
subroutine unlink_blob(blob, head, prev, next)
  type(ocean_blob_type), pointer :: blob
  type(ocean_blob_type), pointer :: head
  type(ocean_blob_type), pointer :: prev
  type(ocean_blob_type), pointer :: next
  prev=>blob%prev
  next=>blob%next
  ! Unlink the list from the blob
  if(associated(prev)) then
     prev%next=>next
  else
     head=>next
     if(associated(next)) next%prev=>NULL()
  endif
  if(associated(next)) next%prev=>prev
  ! Unlink the blob from the list
  blob%next=>NULL()
  blob%prev=>NULL()
end subroutine unlink_blob
! </SUBROUTINE>  NAME="unlink_blob"

!######################################################################
! <SUBROUTINE NAME="insert_blob">
!
! <DESCRIPTION>
! Inserts a blob to the linked list.  The relative order of blobs in 
! a linked list determines whether bitwise reproduction is possible.
!
! Regardless of bitwise reproducability or not, we must ensure that 
! blobs always appear in the same relative order when we are using 
! dynamic blobs because if we have a situation where dztL>dztT, we 
! start destroying blobs to enforce dztL<dztT.  In order that we do 
! not significantly change answers, we must always destroy the same 
! blob, regardless of domain decomposition, restarts, etc. So, we must 
! always sort blobs so they appear in the linked list in the same 
! relative order.
! </DESCRIPTION>
!
subroutine insert_blob(blob, head)

  type(ocean_blob_type), pointer :: blob
  type(ocean_blob_type), pointer :: head

  ! local variables
  type(ocean_blob_type), pointer :: prev
  type(ocean_blob_type), pointer :: next
  logical :: order, eol
  integer :: stdoutunit 

  stdoutunit = stdout()

  if (associated(head)) then
     prev => NULL()
     next => head

     ! cycle through hash, looking for a spot
     checkhash: do
        call inorder(blob%hash, next%hash, order, eol)
        if (eol .or. order) exit checkhash
     enddo checkhash
     if (eol) return
     
     ! cycle through the blob number, ensuring we remain
     ! in the correct hash
     checknumber: do
        if (blob%hash > next%hash) then
           order = .true.
        elseif(blob%hash == next%hash) then
           call inorder(blob%number, next%number, order, eol)
        else
           write(stdoutunit,'(a)') 'ocean_blob_util_mod, insert_blob: list out of order'
           call debugoutput('blob information (hash and number)', prev, blob, next)
           call mpp_error(FATAL, 'ocean_blob_util_mod, insert_blob: list out of order')
        endif
        if (eol .or. order) exit checknumber
     enddo checknumber
     if (eol) return
     
     ! if we have made it this far, then we have not reached the end of the 
     ! list and the blob should be in its correct place in the list, so 
     ! insert it into the list between prev and next, or if we are at the 
     ! top of the list, insert it at the head.
     if (associated(prev)) then
        ! insert the blob after the previous blob
        prev%next => blob
        blob%prev => prev
     else
        ! insert the blobs at the head of the list
        head      => blob
        blob%prev => NULL()
     endif
     next%prev => blob
     blob%next => next

  else  !head associated

     ! the list is empty, so make the blob the only item in the list
     head      => blob
     blob%next => NULL()
     blob%prev => NULL()

  endif !head associated

contains

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that checks if the blob is in the right spot
! in the linked list
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine inorder(var1, var2, foundslot, eolist)

    integer, intent(in)  :: var1, var2
    logical, intent(out) :: foundslot, eolist

    foundslot = .false.
    eolist    = .false.

    if (var1 >= var2) then
       foundslot = .true.
    else
       call checkeol(eolist)
       if (.not. eolist) then
          ! move down the list
          prev => next
          next => next%next
       endif
    endif

  end subroutine inorder

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that checks if we are at the end of the 
! linked list
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine checkeol(endoflist)

    logical :: endoflist
    
    endoflist = .false.

    if(.not. associated(next%next)) then
       ! we are at the end of the list
       next%next => blob
       blob%prev => next
       blob%next => NULL()
       endoflist = .true.
    endif

  end subroutine checkeol

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that outputs useful debugging information
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine debugoutput(message, pr, th, ne)

    type(ocean_blob_type), pointer :: pr, th, ne
    character(len=*), intent(in) :: message

    print ('(/,a)'), trim(message)
    if(associated(pr)) then
       print('(a5,2i6)'), 'prev:', pr%hash, pr%number
    else
       print('(a19)'), 'prev not associated'
    endif
    if(associated(th)) then
       print('(a5,2i6)'), 'this:', th%hash, th%number
    else
       print('(a19)'), 'this not associated'
    endif
    if(associated(ne)) then
       print('(a5,2i6)'), 'next:', ne%hash, ne%number
    else
       print('(a19)'), 'next not associated'
    endif

  end subroutine debugoutput

end subroutine insert_blob
! </SUBROUTINE>  NAME="insert_blob"

!######################################################################
! <SUBROUTINE NAME="count_blob">
!
! <DESCRIPTION>
! Allocates a blob its hash and a number.  These two numbers can
! uniquely identify any blob.  The hash and number is based on the grid
! cell of origin.  Each grid cell has a unique hash.  We have an array 
! which keeps track of the number of blobs formed in a grid cell.  These
! two numbers give the unique identifier.  So, we also need to increment
! the counter array.
! </DESCRIPTION>
!
subroutine count_blob(blob, blob_counter)

  type(ocean_blob_type) :: blob
  integer, dimension(isc:iec,jsc:jec,nk), intent(inout) :: blob_counter

  integer :: ii, jj, kk

  blob%hash = hashfun(blob%i, blob%j, blob%k)

  ii = blob%i
  jj = blob%j
  kk = blob%k

  blob%number            = blob_counter(ii, jj, kk) + 1
  blob_counter(ii,jj,kk) = blob%number
  
end subroutine count_blob
! </SUBROUTINE>  NAME="count_blob"


!######################################################################
! <SUBROUTINE NAME="put_att">
!
! <DESCRIPTION>
! Writes an attribute to a netcdf file.
! </DESCRIPTION>
!
subroutine put_att(ncid, id, att, attval)
  integer,           intent(in) :: ncid, id
  character (len=*), intent(in) :: att, attval
  integer :: vallen, mret
  integer :: stderrunit

  stderrunit=stderr()

  ! Define the attribute for the netcdf file
  vallen=len_trim(attval)
  mret = nf_put_att_text(ncid, id, att, vallen, attval)
  ! If something goes wrong give error and bring the model down
  if (mret .ne. NF_NOERR) then
     write(stderrunit,'(a)') 'ocean_blob_util_mod, putt_att: '&
          //'nf_put_att_text failed adding '//trim(att)//' = '//trim(attval)
     write(stderrunit,'(3x,a,i3)') 'error code = ',mret
     call give_error_code(mret)
     call error_mesg('ocean_blob_util_mod, put_att', &
          'netcdf function returned a failure!', FATAL)
 endif
end subroutine put_att
! </SUBROUTINE>  NAME="put_att"

!######################################################################
! <FUNCTION NAME="inq_var">
!
! <DESCRIPTION>
! Gets the variable identifier from a netcdf file.
! </DESCRIPTION>
!
integer function inq_var(ncid, var)
  integer,           intent(in) :: ncid
  character(len=*),  intent(in) :: var
  integer :: iret
  integer :: stderrunit 

  stderrunit = stderr()
  iret = nf_inq_varid(ncid, var, inq_var)
  if (iret .ne. NF_NOERR) then
     write(stderrunit,*) 'ocean_blob_util_mod, inq_var: nf_inq_varid ',&
          var,' failed'
     call error_mesg('ocean_blob_util_mod, inq_var', &
          'netcdf function returned a failure!', FATAL)
   endif
end function inq_var
! </FUNCTION>  NAME="inq_var"

!######################################################################
! <FUNCTION NAME="get_double">
!
! <DESCRIPTION>
! Gets the value of a "double" variable from a netcdf file
! </DESCRIPTION>
!
real function get_double(ncid, id, m)
  integer, intent(in) :: ncid, id, m
  integer :: iret
  integer :: stderrunit 

  stderrunit = stderr()
  iret=nf_get_var1_double(ncid, id, m, get_double)
  if (iret .ne. NF_NOERR) then
     write(stderrunit,'(a)') 'ocean_blob_util_mod, get_double: ' &
          //'nf_get_var1_double failed reading'
     call error_mesg('ocean_blob_util_mod, get_double', &
          'netcdf function returned a failure!', FATAL)
  endif
end function get_double
! </FUNCTION>  NAME="get_double"

!######################################################################
! <FUNCTION NAME="get_int">
!
! <DESCRIPTION>
! Gets the value of an integer variable from a netcdf file
! </DESCRIPTION>
!
integer function get_int(ncid, id, m)
  integer, intent(in) :: ncid, id, m
  integer :: iret
  integer :: stderrunit 

  stderrunit = stderr()
  iret=nf_get_var1_int(ncid, id, m, get_int)
  if (iret .ne. NF_NOERR) then
     write(stderrunit,'(a)') 'ocean_blob_util_mod, get_int: '&
          //'nf_get_var1_double failed reading'
     call error_mesg('ocean_blob_util_mod, get_int', &
          'netcdf function returned a failure!', FATAL)
  endif
end function get_int
! </FUNCTION>  NAME="get_int"

!######################################################################
! <SUBROUTINE NAME="put_double">
!
! <DESCRIPTION>
! Writes the value of a "double" variable to a netcdf file
! </DESCRIPTION>
!
subroutine put_double(ncid, varid, start, val)
  integer, intent(in) :: ncid, varid, start
  real,    intent(in) :: val
  integer :: mret, mret1
  character(len=31) :: varname
  integer :: stderrunit 

  stderrunit = stderr()
  mret = nf_put_vara_double(ncid, varid, start, 1, val)
  if (mret .ne. NF_NOERR) then
     mret1 = nf_inq_varname(ncid, varid, varname)
     write(stderrunit,*) 'ocean_blob_util_mod, put_double: '&
          //'nf_put_vara_double failed writing'//trim(varname)
     write(stderrunit, '(a,i10)') 'Failed with error code: ', mret
     print *, 'ocean_blob_util_mod, put_double: '&
          //'nf_put_vara_double failed writing '//trim(varname)
     print *, 'Failed with error code: ', mret
     call give_error_code(mret)
     call error_mesg('ocean_blob_util_mod, put_double', &
          'netcdf function returned a failure!', FATAL)
  endif
end subroutine put_double
! </SUBROUTINE>  NAME="put_double"


!######################################################################
! <SUBROUTINE NAME="put_int">
!
! <DESCRIPTION>
! Writes the value of an integer variable to a netcdf file
! </DESCRIPTION>
!
subroutine put_int(ncid, varid, start, val)
  integer, intent(in) :: ncid, varid, start, val
  integer :: mret, mret1
  character(len=31) :: varname
  integer :: stderrunit 

  stderrunit = stderr()
  mret = nf_put_vara_int(ncid, varid, start, 1, val)
  if (mret .ne. NF_NOERR) then
     mret1 = nf_inq_varname(ncid, varid, varname)
     write(stderrunit,*) 'ocean_blob_util_mod, put_int: '&
          //'nf_put_vara_int failed writing '//trim(varname)
     write(stderrunit, '(a,i10)') 'Failed with error code: ', mret
     print *, 'ocean_blob_util_mod, put_int: '&
          //'nf_put_vara_int failed writing '//trim(varname)
     print *, 'Failed with error code: ', mret
     call give_error_code(mret)
     call error_mesg('ocean_blob_util_mod, put_int', &
          'netcdf function returned a failure!', FATAL)
  endif
end subroutine put_int
! </SUBROUTINE>  NAME="put_int"

!######################################################################
! <FUNCTION NAME="def_var">
!
! <DESCRIPTION>
! Defines a netcdf variable
! </DESCRIPTION>
!
integer function def_var(ncid, var, ntype, idim)
  integer,           intent(in) :: ncid
  integer,           intent(in) :: ntype 
  integer,           intent(in) ::idim
  character(len=*),  intent(in) :: var
  integer :: mret
  character(len=30) :: problem
  integer :: stderrunit 

  stderrunit = stderr()
  mret = nf_def_var(ncid, var, ntype, 1, idim, def_var)

  if (mret .ne. NF_NOERR) then
     write(stderrunit,'(a,i4)') 'ocean_blob_util_mod, def_var: '//&
          'nf_def_var failed for '//trim(var)//'with error code ',mret
     write(stderrunit,'(3x,a,i3)') 'error code = ',mret
     call give_error_code(mret)
     call error_mesg('ocean_blob_util_mod, '//trim(problem), &
          'netcdf function returned a failure!', FATAL)
  endif
end function def_var
! </FUNCTION>  NAME="def_var"

!######################################################################
! <SUBROUTINE NAME="give_error_code">
!
! <DESCRIPTION>
! Gives error descriptions for netcdf calls.
! </DESCRIPTION>
!
subroutine give_error_code(retval)
  integer :: retval
  print *, ' '
  if(retval == NF_EBADDIM)    print *, 'Bad dimension'
  if(retval == NF_ENAMEINUSE) print *, 'Name already in use'
  if(retval == NF_ENOTVAR)    print *, 'Not a variable'
end subroutine give_error_code
! </SUBROUTINE>  NAME="give_error_code"

!######################################################################
! <FUNCTION NAME="hashfun">
!
! <DESCRIPTION>
! Calculates the hash
! </DESCRIPTION>
!
integer function hashfun(i,j,k)
  integer, intent(in) :: i
  integer, intent(in) :: j
  integer, intent(in) :: k
  hashfun = k + nk*j + Info%nk_nj*i
end function hashfun
! </FUNCTION>  NAME="hashfun"

!######################################################################
! <SUBROUTINE NAME="blob_util_end">
!
! <DESCRIPTION>
! Does what is necessary to shut down the module.
! </DESCRIPTION>
!
subroutine blob_util_end()
  
  nullify(Info)
  nullify(Grd)
  nullify(Dom)
end subroutine blob_util_end
! </SUBROUTINE>  NAME="blob_util_end"

!######################################################################
! <SUBROUTINE NAME="check_ijcell">
!
! <DESCRIPTION>
! Checks whether a blob (horizontally) resides in a grid cell or not.  
! If it does not it figures out which direction the blob is in and 
! checks the neighbouring grid cell, until it finds which grid cell 
! the blob resides in.
!
! It uses a cross product technique from computational geometry
! (Cormen et al., 2001).
! </DESCRIPTION>
!
subroutine check_ijcell(dx, dy, i, j, h, a, lon, lat, off)
  real,                  intent(in)    :: dx
  real,                  intent(in)    :: dy
  integer,               intent(inout) :: i
  integer,               intent(inout) :: j
  real,    dimension(2), intent(inout) :: h
  real,    dimension(2), intent(in)    :: a
  real,                  intent(out)   :: lon
  real,                  intent(out)   :: lat
  logical, dimension(2), intent(out)   :: off

  real, dimension(2) :: b, a_b, b_ij, b_im1jm1, t_b
  logical :: check_north, check_south, check_east, check_west, doublecheck
  integer :: new_i, new_j
  integer :: stdoutunit

  stdoutunit = stdout()

  ! set default values
  check_north = .true. 
  check_south = .true. 
  check_east  = .true. 
  check_west  = .true.
  doublecheck = .true.

  ! Update the blob longitude and latitude and calculate the required vectors
  a_b(1) = dx/h(1)
  a_b(2) = dy/h(2)
  a_b(:) = rad_to_deg*a_b(:)
  b(:)   = a(:) + a_b(:)

  new_i = i
  new_j = j

  ! The verticies are indexed from southwest, anticlockwise
  ! 4-----3    U(i-1,j  ) == im1j   == 4
  ! |     |    U(i  ,j  ) ==   ij   == 3
  ! |  T  |     tracer cell, T(i,j)
  ! |   a-+-b  U(i   j-1) ==   ijm1 == 2
  ! 1-----2    U(i-1,j-1) == im1jm1 == 1
  ! a is the start position of the blob and b is the end position

  checkcell: do while (doublecheck)
          
     doublecheck = .false.

     b_im1jm1(:) = vert_t(:,1,i,j) - b(:)
     b_ij(:)     = vert_t(:,3,i,j) - b(:)
     t_b(1)      = b(1) - xt(i,j)
     t_b(2)      = b(2) - yt(i,j)

     if (check_north) then
        if( cross( t_im1j(:,i,j), t_b(:)         ) < 0.0 .and. & !T=>i-1j x T =>b
            cross( t_ij(:,i,j),   t_b(:)         ) > 0.0 .and. & !T=>ij   x T =>b
            cross( b_ij(:),       ij_im1j(:,i,j) ) < 0.0 ) then  !b=>ij   x ij=>i-1j
           new_j=new_j+1
           check_south = .false.
           doublecheck = .true.
        endif
     endif

     if (check_south) then
        if( cross( t_ijm1(:,i,j),   t_b(:)             ) < 0.0 .and. & !T=>ij-1   x T     =>b
            cross( t_im1jm1(:,i,j), t_b(:)             ) > 0.0 .and. & !b=>i-1j-1 x T     =>b
            cross( b_im1jm1(:),     im1jm1_ijm1(:,i,j) ) < 0.0 ) then  !b=>i-1j-1 x i-1j-1=>ij-1
           new_j=new_j-1
           check_north = .false.
           doublecheck = .true.
        endif
     endif

     if (check_east) then
        if( cross( t_ij(:,i,j),   t_b(:)         ) < 0.0 .and. & !T=>ij   x T =>b
            cross( t_ijm1(:,i,j), t_b(:)         ) > 0.0 .and. & !T=>ij-1 x T =>b
            cross( b_ij(:),       ij_ijm1(:,i,j) ) > 0.0 ) then  !b=>ij   x ij=>ij-1
           new_i=new_i+1
           check_west  = .false.
           doublecheck = .true.
        endif
     endif

     if (check_west) then
        if( cross( t_im1jm1(:,i,j), t_b(:)             ) < 0.0 .and. & !T=>i-1j-1 x T     =>b
            cross( t_im1j(:,i,j),   t_b(:)             ) > 0.0 .and. & !T=>i-1j   x T     =>b
            cross( b_im1jm1(:),     im1jm1_im1j(:,i,j) ) > 0.0) then   !b=>i-1j-1 x i-1j-1=>i-1j
           new_i=new_i-1
           check_east  = .false.
           doublecheck = .true.
        endif
     endif

     if (new_i<isd .or. ied<new_i .or. new_j<jsd .or. jed<new_j) then
        if (bitwise_reproduction) then
           write (stdoutunit, '(a,i4,a,a,2(i4,a),a,4(i4,a))')                       &
                'Error on pe ',Info%pe_this, ' a blob has gone outside the halo. ',&
                'blobs (i,j) location = (',new_i,',',new_j,') ',                   &
                '(isd:ied,jsd:jed) = (',isd,':',ied,',',jsd,':',jed,')'
           call mpp_error(FATAL, &
                '==>Error in ocean_blob_util_mod (check_ijcell): ' &
                //'blob has gone outside of halo.')
        else
           b(:) = a(:)
           exit checkcell
        endif
        
     else
        i = new_i
        j = new_j
     endif

  enddo checkcell

  off(1:2) = .false.
  if (i<isc .or. iec<i) off(1) = .true.
  if (j<jsc .or. jec<j) off(2) = .true.
  lon = b(1) 
  lat = b(2)

contains 

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! A nested function that does the cross product of two vectors of length!
! two.                                                                  !
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  pure function cross(vec1,vec2)
    real             :: cross
    real, intent(in) :: vec1(2)
    real, intent(in) :: vec2(2)
    cross = vec1(1)*vec2(2) - vec1(2)*vec2(1)
  end function cross

end subroutine check_ijcell
! </SUBROUTINE>  NAME="check_ijcell"

!######################################################################
! <SUBROUTINE NAME="check_kcell">
!
! <DESCRIPTION>
! Searches for which (vertical) grid cell a blob resides in).
! </DESCRIPTION>
!
subroutine check_kcell(Time,Ext_mode,Thickness,geodepth,w,i,j,k,off)
  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_external_mode_type), intent(in)    :: Ext_mode
  type(ocean_thickness_type),     intent(in)    :: Thickness
  real,                           intent(in)    :: geodepth
  real,                           intent(in)    :: w
  integer,                        intent(in)    :: i
  integer,                        intent(in)    :: j
  integer,                        intent(inout) :: k
  logical,                        intent(out)   :: off

  integer :: tau, increment
  logical :: foundk

  tau    = Time%tau
  off    = .false.
  foundk = .false.

  ! Check if the blob has gone out of bounds.  This can happen even if
  ! a blob does not change from one k level to another.
  if (geodepth < -Ext_mode%eta_t(i,j,tau)) then
     k=1
     off=.true.
     return
  elseif (geodepth > Grd%ht(i,j)) then
     k=Grd%kmt(i,j)
     off=.true.
     return
  endif

  ! Next, check if the blob remains in the same vertical k-level.
  if (k>1) then
     if (Thickness%geodepth_zwt(i,j,k-1) < geodepth .and. geodepth <= Thickness%geodepth_zwt(i,j,k)) foundk=.true.
  else
     if (-Ext_mode%eta_t(i,j,tau) < geodepth .and. geodepth <= Thickness%geodepth_zwt(i,j,k)) foundk=.true.
  endif

  if (foundk) then
     ! Because of the way that Thickness%geodepth_zwt is calculated, there 
     !can be a very small discrepency with Grd%ht.  So, we double check 
     ! that the cell that we are in is actually a water cell.  If it is not, 
     ! and we have made it here, we know that 
     ! Thickness%geodepth_zwt(k)<geodepth<=Grd%ht for some k<kmt. However, 
     ! there can be circumstances where, due to the discrepency between 
     ! geodepth_zwt and ht, we can have geodepth<Grd%ht and 
     ! Thickness%geodepth_zwt(kmt)<geodepth<=Thickness%geodepth_zwt(kmt+1). 
     ! In these cases we need to ensure that the blob is in the kmt cell and 
     ! not kmt+1.
     if (k>Grd%kmt(i,j)) k=Grd%kmt(i,j)
     return
  endif

  ! Guess which direction to search based on the vertical velocity
  if(w>=0.0) then !up
     increment = -1
  else !down
     increment = +1
  endif

  kcycle: do
     k = k+increment
     if (k<2 .or. Grd%kmt(i,j)<k) exit kcycle !note: we need to treat the surface grid cell differently
     if (Thickness%geodepth_zwt(i,j,k-1) < geodepth .and. geodepth <= Thickness%geodepth_zwt(i,j,k)) return
  enddo kcycle

  ! Treating the surface cell
  k=1
  if ( -Ext_mode%eta_t(i,j,tau) < geodepth .and. geodepth <= Thickness%geodepth_zwt(i,j,1)) return

  ! If we have made it this far then the search has not been successful, so, we take a brute
  ! force approach and do a full sweep of the water column from top to bottom
  column: do
     k=k+1
     if (k>Grd%kmt(i,j)) exit column !something is wrong
     if (Thickness%geodepth_zwt(i,j,k-1) < geodepth .and. geodepth <= Thickness%geodepth_zwt(i,j,k)) return
  enddo column

  ! Somtimes, there can be really small differences between Thickness%geodepth_zwt(kmt) and Grd%ht. 
  ! So, we check against Grd%ht before raising an error
  if (Thickness%geodepth_zwt(i,j,Grd%kmt(i,j))<geodepth .and. geodepth<=Grd%ht(i,j)) then
     k = Grd%kmt(i,j)
     return
  endif
     
  ! By now, we have covered all bases, so if we have made it this far, there is a problem with the logic
  ! of the search algorithm, so, we raise a fatal error
  call mpp_error(FATAL, 'ocean_blob_util_mod, check_kcell: Cannot find vertical cell for blob!')

end subroutine check_kcell
! </SUBROUTINE>  NAME="check_kcell"

!######################################################################
! <SUBROUTINE NAME="kill_blob">
!
! <DESCRIPTION>
! Kills a blob by returning all of its remaining properties to the E
! system.
! </DESCRIPTION>
!
subroutine kill_blob(Thickness, T_prog, this, i, j, k)
  type(ocean_thickness_type),   intent(inout) :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_blob_type),        pointer       :: this
  integer, intent(in) :: i
  integer, intent(in) :: j
  integer, intent(in) :: k

  integer :: n

  Thickness%blob_source(i,j) = Thickness%blob_source(i,j) &
                               + datdtime_r(i,j)*this%mass
  this%mass = 0.0

  do n=1,num_prog_tracers
     T_prog(n)%tend_blob(i,j,k) = T_prog(n)%tend_blob(i,j,k) &
                                  + this%tracer(n)*datdtime_r(i,j)
     this%tracer(n) = 0.0
  enddo

end subroutine kill_blob
! </SUBROUTINE>  NAME="kill_blob"


!######################################################################
! <SUBROUTINE NAME="free_blob_memory">
!
! <DESCRIPTION>
! Frees the heap memory taken up by a blob.
! </DESCRIPTION>
!
subroutine free_blob_memory(blob)
  type(ocean_blob_type), pointer :: blob

  deallocate(blob)
  nullify(blob)

end subroutine free_blob_memory
! </SUBROUTINE>  NAME="free_blob_memory"


!######################################################################
! <SUBROUTINE NAME="allocate_interaction_memory">
!
! <DESCRIPTION>
! Allocates the history arrays for a blob (only used when
! bitwise_reproduction=.true. in the ocean_blob_nml).
! </DESCRIPTION>
!
subroutine allocate_interaction_memory(blob, total_ns)
  type(ocean_blob_type), pointer   :: blob
  integer,              intent(in) :: total_ns

  allocate(blob%dtracer(num_prog_tracers))
  if (bitwise_reproduction) then
     allocate(blob%di(0:total_ns))
     allocate(blob%dj(0:total_ns))
     allocate(blob%dk(0:total_ns))
     allocate(blob%entrainment(1:total_ns,0:num_prog_tracers)) 
     allocate(blob%detrainment(1:total_ns,0:num_prog_tracers)) 
     allocate(blob%mass_in(1:total_ns))
     allocate(blob%mass_out(0:total_ns))
  endif
end subroutine allocate_interaction_memory
! </SUBROUTINE>  NAME="allocate_interaction_memory"

!######################################################################
! <SUBROUTINE NAME="reallocate_interaction_memory">
!
! <DESCRIPTION>
! Different blobs can have different history memory requirements.  
! When they change from one type of blob to another, we need to change
! the memory allocated to a blob to reflect the new requirements.  This
! is only necessary if bitwise_reproduction=.true. in the ocean_blob_nml.
! </DESCRIPTION>
!
subroutine reallocate_interaction_memory(blob, head, total_ns)
  type(ocean_blob_type), pointer :: blob
  type(ocean_blob_type), pointer :: head
  integer, intent(in) :: total_ns

  type(ocean_blob_type), pointer :: new_blob

  ! Allocate memory to the new blob
  allocate(new_blob)
  allocate(new_blob%tracer(num_prog_tracers))
  allocate(new_blob%field( num_prog_tracers))
  call allocate_interaction_memory(new_blob, total_ns)

  ! Copy the data from the old blob to the new blob
  new_blob%i = blob%i
  new_blob%j = blob%j
  new_blob%k = blob%k

  new_blob%m   = blob%m
  new_blob%kdw = blob%kdw
  new_blob%kup = blob%kup

  new_blob%hash   = blob%hash
  new_blob%number = blob%number

  new_blob%model_steps = blob%model_steps
  new_blob%nsteps      = blob%nsteps

  new_blob%sink = blob%sink
  new_blob%new  = blob%new

  new_blob%h1 = blob%h1
  new_blob%h2 = blob%h2

  new_blob%lat = blob%lat
  new_blob%lon = blob%lon

  new_blob%depth    = blob%depth
  new_blob%geodepth = blob%geodepth

  new_blob%st        = blob%st
  new_blob%mass      = blob%mass
  new_blob%density   = blob%density
  new_blob%densityr  = blob%densityr
  new_blob%volume    = blob%volume
  new_blob%tracer(:) = blob%tracer(:)
  new_blob%field(:)  = blob%field(:)

  new_blob%step        = blob%step
  new_blob%nfrac_steps = blob%nfrac_steps

  new_blob%v(:) = blob%v(:)

  ! Unlink the blob from the list, and link in the new blob
  new_blob%next => blob%next
  if(associated(new_blob%next)) new_blob%next%prev=>new_blob
  new_blob%prev => blob%prev
  if(associated(new_blob%prev)) then
     new_blob%prev%next=>new_blob
  else
     head=>new_blob
  endif

  ! Deallocate memory from the old blob
  call free_blob_memory(blob)

  ! Now point to the new bit of memory
  blob => new_blob

end subroutine reallocate_interaction_memory
! </SUBROUTINE>  NAME="reallocate_interaction_memory"


!######################################################################
! <SUBROUTINE NAME="interp_tcoeff">
!
! <DESCRIPTION>
! Used for the horizontal interpolation of T grid variables.  The
! routine returns coefficients required for inverse distance
! weighting (Shephard, 1968).
! </DESCRIPTION>
!
subroutine interp_tcoeff(i, j, h, lon, lat, dsq_r)
  integer,               intent(in)  :: i
  integer,               intent(in)  :: j
  real,    dimension(2), intent(in)  :: h
  real,                  intent(in)  :: lon
  real,                  intent(in)  :: lat
  real,    dimension(9), intent(out) :: dsq_r

  real,    dimension(9) :: distance
  integer :: m, iit, jjt

  distance(:) = 0.0

     ! We have special treatment for solid boundaries
     tcoeff: do m=1,Info%tidx(0,i,j)
        iit = i+Info%it(Info%tidx(m,i,j))
        jjt = j+Info%jt(Info%tidx(m,i,j))
        ! Calculate the distance from each point to the blob
        ! We do not need to include deg_to_rad because it cancels anyway
        distance(m) = onehalf                                              &
             *sqrt( abs(lon-xt(iit,jjt))**2 * (h(1)+Info%ht(iit,jjt,1))**2 &
             +abs(lat-yt(iit,jjt))**2 * (h(2)+info%ht(iit,jjt,2))**2 )
        
        if (distance(m)<epsln) then
           dsq_r(:) = 0.0
           dsq_r(m) = 1.0
           exit tcoeff
        endif
        ! Accumulate that distance 
        dsq_r(m) = 1.0/distance(m)**2
     enddo tcoeff

end subroutine interp_tcoeff
! </SUBROUTINE>  NAME="interp_tcoeff"


!######################################################################
! <SUBROUTINE NAME="interp_ucoeff">
!
! <DESCRIPTION>
! Used for the horizontal interpolation of U grid variables.  The
! routine returns coefficients required for inverse distance
! weighting (Shephard, 1968).
! </DESCRIPTION>
!
subroutine interp_ucoeff(i, j, h, lon, lat, dsq_r)
  integer,               intent(in)  :: i
  integer,               intent(in)  :: j
  real,    dimension(2), intent(in)  :: h
  real,                  intent(in)  :: lon
  real,                  intent(in)  :: lat
  real,    dimension(4), intent(out) :: dsq_r
  
  real, dimension(4) :: distance
  integer :: m, iiu, jju
  
  !Initialise some variables
  distance(:) = 0.0

     ucoeff: do m=1,Info%uidx(0,i,j)
        iiu = i+Info%iu(Info%uidx(m,i,j))
        jju = j+Info%ju(Info%uidx(m,i,j))
        ! Calculate the distance from each point to the blob
        ! We do not need to include deg_to_rad because it cancels anyway
        distance(m) = onehalf                                  &
             *sqrt( abs(lon-xu(iiu,jju))**2 * (h(1)+Info%hu(iiu,jju,1))**2  &
             +abs(lat-yu(iiu,jju))**2 * (h(2)+Info%hu(iiu,jju,2))**2 )

        if (distance(m)<epsln) then
           dsq_r(:) = 0.0
           dsq_r(m) = 1.0
           exit ucoeff
        endif
        
        ! Accumulate that distance 
        dsq_r(m) = 1.0/distance(m)**2
     enddo ucoeff

end subroutine interp_ucoeff
! </SUBROUTINE>  NAME="interp_ucoeff"


!######################################################################
! <SUBROUTINE NAME="check_cyclic">
!
! <DESCRIPTION>
! Checks and adjusts blob position and grid cell index
! for cylclic/periodic domains, as well as
! the Murray (1996) tripolar grid.
! </DESCRIPTION>
!
subroutine check_cyclic(blob, i, j, adjust_latlon)
  type(ocean_blob_type), pointer    :: blob
  integer,               intent(inout) :: i
  integer,               intent(inout) :: j
  logical,               intent(in) :: adjust_latlon

  logical :: change_ij

  ! If we have a cyclic grid and a blob goes from one PE to another
  ! we need to reset its (i,j) coordinates and its (lon,lat).
  ! Same with the tripolar grid.  Things get a bit more 
  ! complicated if we cross the arctic bipolar fold.
  change_ij = .false.
  
  if (Grd%cyclic_x) then
     if (i<isg) then
        i = nig - i
        change_ij=.true.
     elseif (i>ieg) then
        i = i - nig
        change_ij=.true.
     endif
  endif
  
  if (Grd%cyclic_y) then
     if (j<jsg) then
        j = njg - j
        change_ij=.true.
     elseif (j>jeg) then
        j = j - njg
        change_ij=.true.
     endif
  elseif(Grd%tripolar) then
     if (j>jeg) then
        ! We have crossed the bipolar Arctic fold.
        ! We reset the i vlue to correspond to the
        ! opposing i value, and reset the j value 
        ! to be jeg.
        ! See figure 4.6 of Griffies et al (2004)
        i = nip1 - i
        j = jeg
        
        ! If we cross the geographic north pole.
        if (blob%lat>90.) then
           blob%lat  = 180-blob%lat
           blob%v(2) = -blob%v(2)
        endif
        
        if (adjust_latlon) then
           ! Handle the x-cyclic bit, if required
           if    (blob%lon<Info%minlon(j)) then
              blob%lon = Info%maxlon(j) - modulo(Info%minlon(j),blob%lon)
           elseif(blob%lon>Info%maxlon(j)) then
              blob%lon = Info%minlon(j) + modulo(blob%lon,Info%maxlon(j))
           endif
        endif
     endif
  endif

  if (adjust_latlon) then
     
     if (change_ij) then
        if    (blob%lon<Info%minlon(j)) then
           blob%lon = Info%maxlon(j) - modulo(Info%minlon(j),blob%lon)
        elseif(blob%lon>Info%maxlon(j)) then
           blob%lon = Info%minlon(j) + modulo(blob%lon,Info%maxlon(j))
        endif
        
        if    (blob%lat<Info%minlat(i)) then
           blob%lat = Info%maxlat(i) - modulo(Info%minlat(i),blob%lat)
        elseif(blob%lat>Info%maxlat(i)) then
           blob%lat = Info%minlat(i) + modulo(blob%lat,Info%maxlat(i))
        endif
     
     endif
  endif


end subroutine check_cyclic
! </SUBROUTINE>  NAME="check_cyclic"

end module ocean_blob_util_mod

module ocean_shortwave_mod
#include <fms_platform.h>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S. M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! This module sets up the shortwave routines. 
!</OVERVIEW>
!
!<DESCRIPTION>
! There are two shortwave routines available.  The more complete one is 
! from GFDL, and the streamlined and simpler one is from CSIRO.  
!</DESCRIPTION>
!
!<NAMELIST NAME="ocean_shortwave_nml">
!  <DATA NAME="use_this_module=" TYPE="logical">
!  Must be .true. to run with module. Default is false.
!  </DATA> 
!
!  <DATA NAME="use_shortwave_gfdl=" TYPE="logical">
!  Must be .true. to run with the GFDL shortwave module. 
!  Default is true.  
!  </DATA> 
!  <DATA NAME="use_shortwave_csiro=" TYPE="logical">
!  Must be .true. to run with the CSIRO shortwave module. 
!  Default is false.  
!  </DATA> 
!
!</NAMELIST>

use constants_mod,    only: epsln 
use diag_manager_mod, only: register_diag_field
use fms_mod,          only: write_version_number, open_namelist_file, close_file, check_nml_error
use fms_mod,          only: stdout, stdlog, FATAL, WARNING, NOTE
use mpp_mod,          only: input_nml_file, mpp_error, mpp_max, mpp_min

use ocean_domains_mod,          only: get_local_indices
use ocean_parameters_mod,       only: cp_ocean, missing_value, rho0r
use ocean_shortwave_csiro_mod,  only: ocean_shortwave_csiro_init, sw_source_csiro
use ocean_shortwave_jerlov_mod, only: ocean_shortwave_jerlov_init, sw_source_jerlov
use ocean_shortwave_gfdl_mod,   only: ocean_shortwave_gfdl_init, sw_source_gfdl
use ocean_types_mod,            only: ocean_time_type, ocean_domain_type, ocean_grid_type
use ocean_types_mod,            only: ocean_prog_tracer_type, ocean_diag_tracer_type
use ocean_types_mod,            only: ocean_thickness_type, ocean_options_type, ocean_density_type
use ocean_tpm_util_mod,         only: otpm_set_diag_tracer
use ocean_workspace_mod,        only: wrk1, wrk2, wrk3, wrk4, wrk5
use ocean_util_mod,             only: diagnose_2d, diagnose_3d, diagnose_sum
use ocean_tracer_util_mod,      only: diagnose_3d_rho

implicit none

private

#include <ocean_memory.h>

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

character(len=128)  :: version='$Id: ocean_shortwave.F90,v 20.0 2013/12/14 00:16:14 fms Exp $'
character (len=128) :: tagname = '$Name: tikal $'

public  ocean_shortwave_init
public  ocean_irradiance_init
public  sw_source
private sw_source_ext
private watermass_diag_init
private watermass_diag

! internally set for computing watermass diagnostics
logical :: compute_watermass_diag = .false. 

! for global area normalization
real    :: cellarea_r

! for diagnostics 
integer :: id_sw_frac       =-1
integer :: id_sw_heat       =-1
integer :: id_sw_heat_on_nrho=-1
integer :: id_irradiance    =-1

integer :: id_neut_rho_sw          =-1
integer :: id_pot_rho_sw           =-1
integer :: id_wdian_rho_sw         =-1
integer :: id_tform_rho_sw         =-1
integer :: id_neut_rho_sw_on_nrho  =-1
integer :: id_wdian_rho_sw_on_nrho =-1
integer :: id_tform_rho_sw_on_nrho =-1
integer :: id_eta_tend_sw_pen      =-1
integer :: id_eta_tend_sw_pen_glob =-1


logical :: used

! inverse of specific heat
real :: cp_r

! for irradiance index
integer :: index_irr

! for FAFMIP redistributed heat tracer
integer :: index_redist_heat = -1 

logical :: module_is_initialized  = .false.
logical :: use_this_module        = .false.
logical :: use_shortwave_gfdl     = .true.
logical :: use_shortwave_csiro    = .false.
logical :: use_shortwave_jerlov   = .false.
logical :: use_shortwave_ext      = .false.

namelist /ocean_shortwave_nml/ use_this_module, use_shortwave_gfdl,       &
                               use_shortwave_csiro, use_shortwave_jerlov, &
                               use_shortwave_ext

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_shortwave_init">
!
! <DESCRIPTION>
! Initialization for the shortwave module.
! </DESCRIPTION>
  subroutine ocean_shortwave_init(Grid, Domain, Time, Dens, T_prog, vert_coordinate, Ocean_options)

    type(ocean_grid_type),    intent(in), target :: Grid
    type(ocean_domain_type),  intent(in), target :: Domain
    type(ocean_time_type),    intent(in)         :: Time 
    type(ocean_density_type), intent(in)         :: Dens
    type(ocean_prog_tracer_type), intent(in)     :: T_prog(:)
    integer,                  intent(in)         :: vert_coordinate
    type(ocean_options_type), intent(inout)      :: Ocean_options

    integer :: unit, io_status, ierr
    integer :: num_schemes=0
    integer :: n, num_prog_tracers
    integer :: stdoutunit,stdlogunit 
    stdoutunit=stdout();stdlogunit=stdlog() 

    if ( module_is_initialized ) return
    
    module_is_initialized = .TRUE.

    call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_shortwave_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_shortwave_nml')
#else
    unit = open_namelist_file()
    read(unit, ocean_shortwave_nml,iostat=io_status)
    ierr = check_nml_error(io_status, 'ocean_shortwave_nml')
    call close_file(unit)
#endif
    write(stdoutunit,'(/)')
    write(stdoutunit,ocean_shortwave_nml)    
    write(stdlogunit,ocean_shortwave_nml)

    Dom => Domain
    Grd => Grid

    cp_r = 1.0/cp_ocean
    cellarea_r = 1.0/(epsln + Grd%tcellsurf)

#ifndef MOM_STATIC_ARRAYS    
    call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
    nk = Grid%nk
#endif 

    if(use_this_module) then 
      call mpp_error(NOTE, '==>Note: USING shortwave_mod.')
    else 
      call mpp_error(NOTE, '==>Note: NOT using shortwave_mod.')
      Ocean_options%shortwave = 'Did NOT use the shortwave penetration option.'
      return 
    endif 

    if(use_shortwave_gfdl) then 
       call ocean_shortwave_gfdl_init (Grid, Domain, Time, vert_coordinate, Ocean_options)
       num_schemes = num_schemes+1
    elseif(use_shortwave_csiro) then 
       call ocean_shortwave_csiro_init(Grid, Domain, Time, Ocean_options)       
       num_schemes = num_schemes+1
    elseif(use_shortwave_jerlov) then 
       call ocean_shortwave_jerlov_init(Grid, Domain, vert_coordinate, Ocean_options)       
       num_schemes = num_schemes+1
    elseif(use_shortwave_ext) then 
      call mpp_error(NOTE, &
      '==>Note: using shortwave_ext. Obtaining radiation from another model.')
       num_schemes = num_schemes+1
    endif 
    if(num_schemes==0) then 
      call mpp_error(WARNING,&
      '==>shortwave_mod: no shortwave scheme selected, yet using shortwave_mod. Is this correct?.')
    endif 
    if(num_schemes > 1) then 
      call mpp_error(FATAL,&
      '==>shortwave_mod: choose only ONE of the shortwave schemes: GFDL, CSIRO, JERLOV, or External.')
    endif

    ! to determine index for FAFMIP temperature tracer
    num_prog_tracers = size(T_prog(:))
    do n=1,num_prog_tracers
       if (T_prog(n)%name == 'redist_heat') index_redist_heat = n
    enddo

    ! for diagnostics      
    id_sw_frac = register_diag_field ('ocean_model', 'sw_frac',                       &
         Grid%tracer_axes(1:3), Time%model_time, 'fraction of shortwave penetrating', &
         'dimensionless', missing_value=-1e10, range=(/-1.e10,1.e10/))

    id_sw_heat = register_diag_field ('ocean_model', 'sw_heat',                   & 
         Grid%tracer_axes(1:3), Time%model_time, 'penetrative shortwave heating', &
         'W/m^2', missing_value=-1e10, range=(/-1.e10,1.e10/),                    &
         standard_name='downwelling_shortwave_flux_in_sea_water')

    id_irradiance = register_diag_field ('ocean_model', 'irradiance', &
         Grid%tracer_axes(1:3), Time%model_time, 'irradiance', &
         'W/m^2',missing_value=missing_value, range=(/-1e6,1e6/))

    call watermass_diag_init(Time, Dens)


end subroutine ocean_shortwave_init
! </SUBROUTINE> NAME="ocean_shortwave_init"



!#######################################################################
! <SUBROUTINE NAME="ocean_irradiance_init">
!
! <DESCRIPTION>
!
! Initialize the irradiance diagnostic tracer.
!
! </DESCRIPTION>

subroutine ocean_irradiance_init

  character(len=48), parameter :: sub_name = 'ocean_irradiance_init'
  character(len=48), parameter :: mod_name = 'ocean_shortwave_mod'

  ! set the irradiance diagnostic tracer
  index_irr = otpm_set_diag_tracer('irr',                             &
       longname = 'Irradiance', units = 'Watts/m^2',                  &
       const_init_tracer = .true., const_init_value = 0.0,            &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')

end subroutine ocean_irradiance_init
! </SUBROUTINE> NAME="ocean_irradiance_init">



!#######################################################################
! <SUBROUTINE NAME="sw_source">
!
! <DESCRIPTION>
!
! Choose either of the GFDL, CSIRO, JERLOV or External sw_source methods.
!
! </DESCRIPTION>
subroutine sw_source (Time, Thickness, Dens, T_prog, T_diag, swflx, swflx_vis, Temp, sw_frac_zt, opacity)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_density_type),       intent(in)    :: Dens
  type(ocean_prog_tracer_type),   intent(inout) :: T_prog(:)
  type(ocean_diag_tracer_type),   intent(inout) :: T_diag(:)
  real, dimension(isd:,jsd:),     intent(in)    :: swflx
  real, dimension(isd:,jsd:),     intent(in)    :: swflx_vis
  type(ocean_prog_tracer_type),   intent(inout) :: Temp
  real, dimension(isd:,jsd:,:),   intent(inout) :: sw_frac_zt
  real, dimension(isd:,jsd:,:),   intent(inout) :: opacity 

  integer :: i,j,k,tau

  if (.not. use_this_module) return 

  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL,&
    '==>Error in ocean_shortwave_mod (sw_source): module must be initialized ')
  endif 

  tau = Time%tau

  if (Temp%name /= 'temp') then 
    call mpp_error(FATAL,&
    '==>Error in ocean_shortwave_mod (sw_source): invalid tracer for sw_source')
  endif 

  ! initialize wrk1 array used to diagnose heating from shortwave 
  Temp%wrk1(:,:,:) = 0.0

  if(use_shortwave_gfdl) then 
     call sw_source_gfdl (Time, Thickness, T_diag(:), swflx, swflx_vis, index_irr, Temp, sw_frac_zt, opacity)
  elseif(use_shortwave_csiro) then 
     call sw_source_csiro (Time, Thickness, T_diag(:), swflx, index_irr, Temp, sw_frac_zt)
  elseif(use_shortwave_jerlov) then 
     call sw_source_jerlov (Thickness, T_diag(:), swflx, swflx_vis, index_irr, Temp, sw_frac_zt, opacity)
  elseif(use_shortwave_ext) then
     call sw_source_ext(Time, Thickness, T_diag(:),  swflx, Temp, sw_frac_zt)
  endif 

  ! add heating rate to thickness*density weighted temperature
  ! tendency. cp_r factor needed to convert from W/m^2 to (kg/m^3)*(m/s)*degC.
  do k=1,nk-1
    do j=jsc,jec
      do i=isc,iec
        Temp%th_tendency(i,j,k) = Temp%th_tendency(i,j,k) + Temp%wrk1(i,j,k)*cp_r
      enddo
    enddo
  enddo


  ! add heating rate to thickness*density weighted redistributed temperature
  ! for the case when including the FAFMIP redistributed heat tracer.
  if(index_redist_heat > 0) then 
    do k=1,nk-1
      do j=jsc,jec
        do i=isc,iec
          T_prog(index_redist_heat)%th_tendency(i,j,k) = T_prog(index_redist_heat)%th_tendency(i,j,k) + Temp%wrk1(i,j,k)*cp_r
        enddo
      enddo
    enddo
  endif 


#ifndef MOM_STATIC_ARRAYS
  if(_ALLOCATED(Temp%radiation)) then
#endif
    do k=1,nk-1
      do j=jsc,jec
        do i=isc,iec
          Temp%radiation(i,j,k) = Temp%wrk1(i,j,k)
        enddo
      enddo
    enddo
#ifndef MOM_STATIC_ARRAYS
  endif
#endif


  ! diagnostics 

  call diagnose_3d(Time, Grd, id_sw_frac, sw_frac_zt(:,:,:))
  call diagnose_3d(Time, Grd, id_sw_heat, Temp%wrk1(:,:,:))
  call diagnose_3d(Time, Grd, id_irradiance, T_diag(index_irr)%field(:,:,:))

  call watermass_diag(Time, Temp, Dens)


end subroutine sw_source
! </SUBROUTINE> NAME="sw_source"


!#######################################################################
! <SUBROUTINE NAME="sw_source_ext">
!
! <DESCRIPTION>
!
! Example of a routine that applies an externally supplied shortwave 
! heating rate (i.e. top minus bottom radiation flux in W/m^2). Users
! should modify this routine for their own purposes.
!
! </DESCRIPTION>

subroutine sw_source_ext (Time, Thickness, T_diag, swflx, Temp, sw_frac_zt)

  type(ocean_time_type),         intent(in)    :: Time
  type(ocean_thickness_type),    intent(in)    :: Thickness
  type(ocean_diag_tracer_type),   intent(inout) :: T_diag(:)
  real, dimension(isd:,jsd:) ,   intent(in)    :: swflx
  type(ocean_prog_tracer_type),  intent(inout) :: Temp
  real, dimension(isd:,jsd:,:),  intent(inout) :: sw_frac_zt

  integer :: k, j, i
  real :: sw_heat_rate(isd:ied,jsd:jed,1:nk) 

  ! load sw_heat_rate here
  ! sw_heat_rate = ...
  ! 
  ! for our testing purposes we'll just invoke one of our methods
  ! Note here that index_irr is "global"
  call sw_source_csiro (Time, Thickness, T_diag, swflx, index_irr, Temp, sw_frac_zt)
  ! the heating rate is stored in 
  sw_heat_rate = Temp%wrk1

  ! load sw_heat_rate
  do k=1,nk-1
    do j=jsc,jec
      do i=isc,iec
        Temp%wrk1(i,j,k) = sw_heat_rate(i,j,k)
      enddo
    enddo
  enddo

end subroutine sw_source_ext
! </SUBROUTINE> NAME="sw_source_ext">


!#######################################################################
! <SUBROUTINE NAME="watermass_diag_init">
!
! <DESCRIPTION>
! Initialization of watermass diagnostic output files. 
! </DESCRIPTION>
!
subroutine watermass_diag_init(Time, Dens)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens

  integer :: stdoutunit
  stdoutunit=stdout()
  compute_watermass_diag = .false. 

  id_sw_heat_on_nrho = register_diag_field ('ocean_model', 'sw_heat_on_nrho',   &
       Dens%neutralrho_axes(1:3), Time%model_time, 'penetrative shortwave heating binned to neutral density', &
       'W/m^2', missing_value=-1e10, range=(/-1.e20,1.e20/))
  if(id_sw_heat_on_nrho > 0) compute_watermass_diag = .true.

  id_neut_rho_sw = register_diag_field ('ocean_model', 'neut_rho_sw',&
    Grd%tracer_axes(1:3), Time%model_time,                           &
    'update of locally ref potrho from shortwave penetration',       &
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_sw > 0) compute_watermass_diag = .true. 

  id_pot_rho_sw = register_diag_field ('ocean_model', 'pot_rho_sw',&
    Grd%tracer_axes(1:3), Time%model_time,                         &
    'update of depth ref potrho from shortwave penetration',       &
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_pot_rho_sw > 0) compute_watermass_diag = .true. 

  id_neut_rho_sw_on_nrho = register_diag_field ('ocean_model',                            &
   'neut_rho_sw_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                     &
   'update of locally ref potrho from shortwave penetration binned to neutral rho layers',&
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_sw_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_rho_sw = register_diag_field ('ocean_model', 'wdian_rho_sw',&
    Grd%tracer_axes(1:3), Time%model_time,                             &
    'dianeutral mass transport due to penetrative shortwave heating',  &
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_sw > 0) compute_watermass_diag = .true. 

  id_wdian_rho_sw_on_nrho = register_diag_field ('ocean_model',                                   &
    'wdian_rho_sw_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,                            &
    'dianeutral mass transport due to penetrative shortwave heating binned to neutral rho layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_sw_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_rho_sw = register_diag_field ('ocean_model',        &
    'tform_rho_sw',Grd%tracer_axes(1:3), Time%model_time,      &
    'watermass transform due to penetrative shortwave heating',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_sw > 0) compute_watermass_diag = .true. 

  id_tform_rho_sw_on_nrho = register_diag_field ('ocean_model',                             &
    'tform_rho_sw_on_nrho',Dens%neutralrho_axes(1:3), Time%model_time,                      &
    'watermass transform due to penetrative shortwave heating binned to neutral rho layers',&
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_sw_on_nrho > 0) compute_watermass_diag = .true. 

  id_eta_tend_sw_pen= -1          
  id_eta_tend_sw_pen= register_diag_field ('ocean_model','eta_tend_sw_pen', &
       Grd%tracer_axes(1:2), Time%model_time,                               &
       'non-Bouss steric sea level tendency from swflx penetration', 'm/s', &
       missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_sw_pen > 0) compute_watermass_diag = .true. 

  id_eta_tend_sw_pen_glob= -1          
  id_eta_tend_sw_pen_glob= register_diag_field ('ocean_model', 'eta_tend_sw_pen_glob',&
       Time%model_time,                                                               &
       'global mean non-bouss steric sea level tendency from swflx penetration',      &
       'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_sw_pen_glob > 0) compute_watermass_diag = .true. 


  if(compute_watermass_diag) then 
      write(stdoutunit,'(/a/)') &
           '==>Note: running ocean_shortwave_mod w/ compute_watermass_diag=.true.'  
  endif

end subroutine watermass_diag_init
! </SUBROUTINE> NAME="watermass_diag_init"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag">
!
! <DESCRIPTION>
! Diagnose effects from shortwave heating on watermass transformation.  
! </DESCRIPTION>
!
subroutine watermass_diag(Time, Temp, Dens)

  type(ocean_time_type),          intent(in) :: Time
  type(ocean_prog_tracer_type),   intent(in) :: Temp
  type(ocean_density_type),       intent(in) :: Dens

  integer :: i,j,k,tau
  real, dimension(isd:ied,jsd:jed) :: eta_tend

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_shortwave (watermass_diag): module needs initialization ')
  endif 

  if (.not. compute_watermass_diag) return

  tau = Time%tau 

  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Grd%tmask(i,j,k)*Dens%drhodT(i,j,k)*cp_r*Temp%wrk1(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
           wrk5(i,j,k) =-wrk1(i,j,k)/(epsln+Dens%rho(i,j,k,tau)**2) ! for eta_tend
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_sw, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_sw, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_sw, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_sw_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_sw_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_sw_on_nrho, wrk4)
  call diagnose_3d_rho(Time, Dens, id_sw_heat_on_nrho, Temp%wrk1)

  if(id_eta_tend_sw_pen > 0 .or. id_eta_tend_sw_pen_glob > 0) then
      eta_tend(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               eta_tend(i,j) = eta_tend(i,j) + wrk5(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_eta_tend_sw_pen, eta_tend(:,:))
      call diagnose_sum(Time, Grd, Dom, id_eta_tend_sw_pen_glob, eta_tend, cellarea_r)
  endif

  if(id_pot_rho_sw > 0) then 
     wrk1(:,:,:) = 0.0
     wrk2(:,:,:) = 0.0
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              wrk1(i,j,k) = Grd%tmask(i,j,k)*Dens%dpotrhodT(i,j,k)*cp_r*Temp%wrk1(i,j,k)
              wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           enddo
        enddo
     enddo
     call diagnose_3d(Time, Grd, id_pot_rho_sw, wrk2(:,:,:))
  endif
   

end subroutine watermass_diag
! </SUBROUTINE>  NAME="watermass_diag"


end module ocean_shortwave_mod

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
!                                                                              !
! SEA ICE DYNAMICS using ELASTIC-VISCOUS-PLASTIC RHEOLOGY adapted from         !
! Hunke and Dukowicz (JPO 1990, H&D hereafter) -Mike Winton (Michael.Winton) !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
module ice_dyn_mod

  use mpp_domains_mod, only: mpp_update_domains, BGRID_NE
  use constants_mod,   only: grav, pi
  use ice_grid_mod,    only: Domain, isc, iec, im, jsc, jec, isd, ied, jsd, jed, jm
  use ice_grid_mod,    only: dtw, dte, dts, dtn, dxt, dxv, dyt, dyv, cor, wett, wetv
  use ice_grid_mod,    only: t_on_uv, t_to_uv, dTdx, dTdy, dt_evp, evp_sub_steps
  use ice_grid_mod,    only: dydx, dxdy
  use ice_grid_mod,    only: reproduce_siena_201303
  use ice_thm_mod,     only: DI, DS, DW

  implicit none
  private

  public :: ice_dyn_param, ice_dynamics, strain_angle, ice_strength, sigI, sigII
  public :: blturn

  logical         :: SLAB_ICE = .false.  ! should we do old style GFDL slab ice?
  !
  ! parameters for calculating water drag and internal ice stresses
  !
  real            :: p0 = 2.75e4         ! pressure constant (Pa)
  real            :: c0 = 20.0           ! another pressure constant
  real            :: cdw = 3.24e-3       ! ice/water drag coef.
  real            :: blturn = 25.0       ! air/water surf. turning angle (NH) 25
  real, parameter :: EC = 2.0            ! yield curve axis ratio
  real, parameter :: EC2I = 1.0/(EC*EC)
  real, parameter :: MIV_MIN =  1.0      ! min ice mass to do dynamics (kg/m^2)

contains

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! ice_dyn_param - set ice dynamic parameters                                   !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine ice_dyn_param(p0_in, c0_in, cdw_in, wd_turn_in, slab_ice_in)
    real,    intent(in)   :: p0_in, c0_in, cdw_in, wd_turn_in
    logical, intent(in)   :: slab_ice_in

    p0 = p0_in
    c0 = c0_in
    cdw = cdw_in
    blturn = wd_turn_in
    SLAB_ICE = slab_ice_in
  end subroutine ice_dyn_param

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! set_strn - calculate generalized orthogonal coordinate strain tensor         !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine set_strn(ui, vi, strn11, strn22, strn12) ! ??? may change to do loop
    real, intent(in ), dimension(isd:ied,jsd:jed) :: ui, vi
    real, intent(out), dimension(isc:iec,jsc:jec) :: strn11, strn22, strn12
    real, allocatable, dimension(:,:), save :: fac1, fac2, fac3, fac4
    logical, save :: initialized = .false.
    integer       :: i, j

    if (.not. initialized) then
       allocate( fac1(isc:iec,jsc:jec), fac2(isc:iec,jsc:jec), &
                 fac3(isc:iec,jsc:jec), fac4(isc:iec,jsc:jec)  )
       do j = jsc, jec
          do i = isc, iec
             fac1(i,j) = (dtn(i,j)-dts(i,j))/dyt(i,j)
             fac2(i,j) = (dte(i,j)-dtw(i,j))/dxt(i,j)
             fac3(i,j) = 0.5*dyt(i,j)/dxt(i,j)
             fac4(i,j) = 0.5*dxt(i,j)/dyt(i,j)
          enddo
       enddo
       initialized = .true.
    end if

    do j = jsc, jec
       do i = isc, iec
          strn11(i,j) = (0.5*(ui(i,j)-ui(i-1,j)+ui(i,j-1)-ui(i-1,j-1))        &
                      + 0.25*(vi(i,j)+vi(i,j-1)+vi(i-1,j)+vi(i-1,j-1))*fac1(i,j))/dxt(i,j)
          strn22(i,j) = (0.5*(vi(i,j)-vi(i,j-1)+vi(i-1,j)-vi(i-1,j-1))        &
                      + 0.25*(ui(i,j)+ui(i,j-1)+ui(i-1,j)+ui(i-1,j-1))*fac2(i,j))/dyt(i,j)
          strn12(i,j) = fac3(i,j)*(0.5*(vi(i,j)/dyv(i,j)-vi(i-1,j)/dyv(i-1,j) &
                      + vi(i,j-1)/dyv(i,j-1)-vi(i-1,j-1)/dyv(i-1,j-1)))       &
                      + fac4(i,j)*(0.5*(ui(i,j)/dxv(i,j)-ui(i,j-1)/dxv(i,j-1) &
                      + ui(i-1,j)/dxv(i-1,j)-ui(i-1,j-1)/dxv(i-1,j-1)))
       enddo
    enddo

    return
  end subroutine set_strn

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! ice_strength - magnitude of force on ice in plastic deformation              !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  function ice_strength(hi, ci) ! ??? may change to do loop
!!$    real, dimension(isc:iec,jsc:jec), intent(in) :: hi, ci
    real, dimension(isc:,jsc:), intent(in) :: hi, ci
    real, dimension(isc:iec,jsc:jec)             :: ice_strength

    integer :: i, j

    do j = jsc, jec
       do i = isc, iec
          ice_strength(i,j) = p0*hi(i,j)*ci(i,j)*exp(-c0*(1-ci(i,j)))
       enddo
    enddo

    return
  end function ice_strength

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! ice_dynamics - take a single dynamics timestep with EVP subcycles            !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine ice_dynamics(ci, hs, hi, ui, vi, sig11, sig22, sig12, uo, vo,       &
       fxat, fyat, sea_lev, fxoc, fyoc, fxic, fyic, fxco, fyco)
!!$    real, intent(in   ), dimension(isd:ied,jsd:jed) :: ci, hs, hi  ! ice properties
    real, intent(in   ), dimension(isd:,jsd:) :: ci, hs, hi  ! ice properties
    real, intent(inout), dimension(isd:ied,jsd:jed) :: ui, vi      ! ice velocity
    real, intent(inout), dimension(isd:ied,jsd:jed) :: sig11, sig22, sig12       ! stress tensor
    real, intent(in   ), dimension(isd:ied,jsd:jed) :: uo, vo      ! ocean velocity
!!$    real, intent(in   ), dimension(isc:iec,jsc:jec) :: fxat, fyat  ! air stress on ice
    real, intent(in   ), dimension(isc:,jsc:) :: fxat, fyat  ! air stress on ice
    real, intent(in   ), dimension(isd:ied,jsd:jed) :: sea_lev     ! sea level
    real, intent(  out), dimension(isc:iec,jsc:jec) :: fxoc, fyoc  ! ice stress on ocean
    real, intent(  out), dimension(isc:iec,jsc:jec) :: fxic, fyic  ! ice int. stress
    real, intent(  out), dimension(isc:iec,jsc:jec) :: fxco, fyco  ! coriolis force

    real, dimension(isc:iec,jsc:jec)    :: prs                    ! ice pressure
    real                                :: zeta, eta              ! bulk/shear viscosities
    real, dimension(isc:iec,jsc:jec)    :: strn11, strn12, strn22 ! strain tensor

    real,    dimension(isc:iec,jsc:jec) :: miv                 ! mass on v-points
    real,    dimension(isc:iec,jsc:jec) :: civ                 ! conc. on v-points
    complex                             :: rr                  ! linear drag coefficient
    real                                :: fxic_now, fyic_now  ! ice internal stress

    ! temporaries for ice stress calculation
    real                             :: del2, a, b, tmp
    real, dimension(isc:iec,jsc:jec) :: edt, mp4z, t0, t1, t2
    real, dimension(isc:iec,jsc:jec) :: f11, f22
    real, dimension(isc:iec,jsc:jec) :: sldx, sldy
    real, dimension(isc:iec,jsc:jec) :: tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7

    ! for velocity calculation
    real,    dimension(isc:iec,jsc:jec) :: dtmiv, rpart, fpart, uvfac
    complex                             :: newuv
    integer                             :: i,j,l

    fxoc = 0.0; fyoc = 0.0 ! zero these for summing later
    fxic = 0.0; fyic = 0.0
    fxco = 0.0; fyco = 0.0

    if (SLAB_ICE) then
       ui = uo; vi = vo;
       fxoc = fxat; fyoc = fyat;
       return
    end if

    if (evp_sub_steps==0) return;
    !
    ! sea level slope force
    !
    do j = jsc, jec
       do i = isc, iec
          sldx(i,j) = -dt_evp*grav*(0.5*(sea_lev(i+1,j+1)-sea_lev(i,j+1) &
                    + sea_lev(i+1,j)-sea_lev(i,j)))/dxv(i,j)
          sldy(i,j) = -dt_evp*grav*(0.5*(sea_lev(i+1,j+1)-sea_lev(i+1,j) &
                    + sea_lev(i,j+1)-sea_lev(i,j)))/dyv(i,j)
       enddo
    enddo

    ! put ice/snow mass and concentration on v-grid
    call t_to_uv(ci*(hi*DI+hs*DS), miv)
    call t_to_uv(ci, civ)
    !
    ! precompute prs, elastic timestep parameter, and linear drag coefficient
    !
    prs = ice_strength(hi(isc:iec,jsc:jec), ci(isc:iec,jsc:jec) )

    do j = jsc, jec
       do i = isc, iec
          if(dxt(i,j) < dyt(i,j) ) then
             edt(i,j) = (DI*dxt(i,j)*dxt(i,j)*ci(i,j)*hi(i,j))/(2*dt_evp)
          else
             edt(i,j) = (DI*dyt(i,j)*dyt(i,j)*ci(i,j)*hi(i,j))/(2*dt_evp)
          endif
       enddo
    enddo

    do j = jsc, jec
       do i = isc, iec
          if((wetv(i,j)>0.5) .and. miv(i,j) > MIV_MIN ) then ! values for velocity calculation (on v-grid)
             dtmiv(i,j) = dt_evp/miv(i,j)
          else
             ui(i,j) = 0.0
             vi(i,j) = 0.0
          endif
       enddo
    enddo

    do l=1,evp_sub_steps
       !
       ! calculate strain tensor for viscosities and forcing elastic eqn.
       if(reproduce_siena_201303) then
          call mpp_update_domains(ui, vi, Domain)
       else
          call mpp_update_domains(ui, vi, Domain, gridtype=BGRID_NE)
       endif
!rab       call mpp_update_domains(vi, Domain)
       !
       call set_strn(ui, vi, strn11, strn22, strn12)
       !
       ! calculate viscosities - how often should we do this ?
       !
       if (l>=1) then
          do j = jsc, jec
             do i = isc, iec
                del2 = (strn11(i,j)*strn11(i,j)+strn22(i,j)*strn22(i,j))*(1+EC2I)     &
                       +4*EC2I*strn12(i,j)*strn12(i,j) +2*strn11(i,j)*strn22(i,j)*(1-EC2I)  ! H&D eqn 9
                if(del2 > 4e-18 ) then
                   zeta = 0.5*prs(i,j)/sqrt(del2)
                else
                   zeta = 2.5e8*prs(i,j)
                endif

                if(zeta<4e8) zeta = 4e8 ! Hibler uses to prevent nonlinear instability

                eta = zeta*EC2I
                !
                ! some helpful temporaries
                !
                if(hi(i,j) > 0.0 ) then
                   mp4z(i,j) = -prs(i,j)/(4*zeta)
                   t0(i,j)   = 2*eta/(2*eta+edt(i,j))
                   tmp       = 1/(4*eta*zeta)
                   a         = 1/edt(i,j)+(zeta+eta)*tmp
                   b         = (zeta-eta)*tmp
                   t1(i,j)   = b/a
                   t2(i,j)   = a-b*b/a
                endif
             enddo
          enddo
       end if
       !
       ! timestep stress tensor (H&D eqn 21)
       !

       do j = jsc, jec
          do i = isc, iec
             if( (wett(i,j)>0.5) .and.(ci(i,j)*(DI*hi(i,j)+DS*hs(i,j))>MIV_MIN) ) then
                f11(i,j)   = mp4z(i,j)+sig11(i,j)/edt(i,j)+strn11(i,j)
                f22(i,j)   = mp4z(i,j)+sig22(i,j)/edt(i,j)+strn22(i,j)
                sig11(i,j) = (t1(i,j)*f22(i,j)+f11(i,j))/t2(i,j)
                sig22(i,j) = (t1(i,j)*f11(i,j)+f22(i,j))/t2(i,j)
                sig12(i,j) = t0(i,j)*(sig12(i,j)+edt(i,j)*strn12(i,j))
             else
                sig11(i,j) = 0.0
                sig22(i,j) = 0.0
                sig12(i,j) = 0.0 ! eliminate internal ice forces 
             endif
          enddo
       enddo

       call mpp_update_domains(sig11, Domain, complete=.false.)
       call mpp_update_domains(sig22, Domain, complete=.false.)
       call mpp_update_domains(sig12, Domain, complete=.true.)

       tmp1 = dTdy(sig12*dxt)
       tmp2 = dTdx(sig11*dyt)
       tmp3 = t_on_uv(sig12)
       tmp4 = t_on_uv(sig22)
       tmp5 = t_on_uv(sig11)
       tmp6 = dTdx(sig12*dyt)
       tmp7 = dTdy(sig22*dxt)

       do j = jsc, jec
          do i = isc, iec
             if( (wetv(i,j)>0.5).and.(miv(i,j)>MIV_MIN)) then ! timestep ice velocity (H&D eqn 22)
                rr       = cdw*dw*abs(cmplx(ui(i,j)-uo(i,j),vi(i,j)-vo(i,j)))*exp(sign(blturn*pi/180,cor(i,j))*(0.0,1.0))
                !
                ! first, timestep explicit parts (ice, wind & ocean part of water stress)
                !
                fxic_now = ( tmp1(i,j) + tmp2(i,j) + tmp3(i,j)*dxdy(i,j) - tmp4(i,j)*dydx(i,j) )/(dxv(i,j)*dyv(i,j)) 
                fyic_now = ( tmp6(i,j) + tmp7(i,j) + tmp3(i,j)*dydx (i,j) - tmp5(i,j)*dxdy(i,j))/(dxv(i,j)*dyv(i,j)) 

                ui(i,j) = ui(i,j)+(fxic_now+civ(i,j)*fxat(i,j)+ real(civ(i,j)*rr*cmplx(uo(i,j),vo(i,j))))*dtmiv(i,j)+sldx(i,j)
                vi(i,j) = vi(i,j)+(fyic_now+civ(i,j)*fyat(i,j)+aimag(civ(i,j)*rr*cmplx(uo(i,j),vo(i,j))))*dtmiv(i,j)+sldy(i,j)
                !
                ! second, timestep implicit parts (coriolis and ice part of water stress)
                !
                newuv = cmplx(ui(i,j),vi(i,j))/(1+dt_evp*(0.0,1.0)*cor(i,j)+civ(i,j)*rr*dtmiv(i,j))
                ui(i,j) = real(newuv); vi(i,j) = aimag(newuv)
                !
                ! sum for averages
                !
                fxic(i,j) = fxic(i,j) + fxic_now
                fyic(i,j) = fyic(i,j) + fyic_now
                fxoc(i,j) = fxoc(i,j) +  real(civ(i,j)*rr*cmplx(ui(i,j)-uo(i,j),vi(i,j)-vo(i,j)))
                fyoc(i,j) = fyoc(i,j) + aimag(civ(i,j)*rr*cmplx(ui(i,j)-uo(i,j),vi(i,j)-vo(i,j)))
                fxco(i,j) = fxco(i,j) - miv(i,j)*real ((0.0,1.0)*cor(i,j)*cmplx(ui(i,j),vi(i,j)))
                fyco(i,j) = fyco(i,j) - miv(i,j)*aimag((0.0,1.0)*cor(i,j)*cmplx(ui(i,j),vi(i,j)))              
             endif
          enddo
       enddo
    enddo
    !
    ! make averages
    !
    do j = jsc, jec
       do i = isc, iec
          if( (wetv(i,j)>0.5) .and. miv(i,j)>MIV_MIN ) then
             fxoc(i,j) = fxoc(i,j)/evp_sub_steps;  fyoc(i,j) = fyoc(i,j)/evp_sub_steps
             fxic(i,j) = fxic(i,j)/evp_sub_steps;  fyic(i,j) = fyic(i,j)/evp_sub_steps
             fxco(i,j) = fxco(i,j)/evp_sub_steps;  fyco(i,j) = fyco(i,j)/evp_sub_steps             
          endif
       enddo
    enddo

  end subroutine ice_dynamics

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! strain_angle                                                                 !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  function strain_angle(ui, vi)
    real, dimension(isd:ied,jsd:jed), intent(in) :: ui, vi
    real, dimension(isc:iec,jsc:jec)             :: strn11, strn22, strn12, strain_angle

    integer :: i, j

    call set_strn(ui, vi, strn11, strn22, strn12)

    do j = jsc, jec
       do i = isc, iec
          if(strn11(i,j) + strn22(i,j) == 0.0 ) then
             strain_angle(i,j) = pi
          else
             strain_angle(i,j) = atan(((strn11(i,j)-strn22(i,j))**2+4*strn12(i,j)**2)**0.5/(strn11(i,j)+strn22(i,j)))
          endif
          if(strain_angle(i,j) < 0) then
             strain_angle(i,j) = 180 + strain_angle(i,j)*180/pi
          else
             strain_angle(i,j) = strain_angle(i,j)*180/pi
          endif
       enddo
    enddo

    return
  end function strain_angle

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! sigI - first stress invariant                                                !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  function sigI(hi, ci, sig11, sig22, sig12)
    real, dimension(isc:iec,jsc:jec), intent(in) :: hi, ci, sig11, sig22, sig12
    real, dimension(isc:iec,jsc:jec)             :: sigI

    integer :: i, j

    sigI = ice_strength(hi,ci)

    do j = jsc, jec
       do i = isc, iec
          if(sigI(i,j) > 0.0) sigI(i,j) = (sig11(i,j) + sig22(i,j))/sigI(i,j)
       enddo
    enddo

    return
  end function sigI

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! sigII - second stress invariant                                              !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  function sigII(hi, ci, sig11, sig22, sig12)
    real, dimension(isc:iec,jsc:jec), intent(in) :: hi, ci, sig11, sig22, sig12
    real, dimension(isc:iec,jsc:jec)             :: sigII

    integer :: i, j

    sigII = ice_strength(hi,ci)

    do j = jsc, jec
       do i = isc, iec
          if(sigII(i,j) > 0.0) sigII(i,j) = (((sig11(i,j)-sig22(i,j))**2+4*sig12(i,j)*sig12(i,j))/(sigII(i,j)**2))**0.5
       enddo
    enddo

    return
  end function sigII

end module ice_dyn_mod

module mg_drag_mod

!=======================================================================
!         MOUNTAIN GRAVITY WAVE DRAG - PIerrehumbert (1986)            !
!=======================================================================

!-------------------------------------------------------------------
!  Calculates partial tendencies for the zonal and meridional winds
!  due to the effect of mountain gravity wave drag 
!-------------------------------------------------------------------

 use  topography_mod, only: get_topog_stdev

 use         mpp_mod, only: input_nml_file
 use         fms_mod, only: mpp_npes, field_size, file_exist, write_version_number, stdlog, &
                            mpp_pe, mpp_root_pe, error_mesg, FATAL, NOTE, read_data, write_data,  &
                            open_namelist_file, close_file, check_nml_error, mpp_error
 use      fms_io_mod, only: register_restart_field, restart_file_type
 use      fms_io_mod, only: save_restart, restore_state
 use   constants_mod, only: Grav, Kappa, RDgas, cp_air

!-----------------------------------------------------------------------
 implicit none
!-----------------------------------------------------------------------

 private

 character(len=128) :: version = '$Id: mg_drag.F90,v 19.0 2012/01/06 20:10:07 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'

 real, parameter :: p00 = 1.e5

!---------------------------------------------------------------------
!     Ghprime - array of sub-grid scale mountain height variance
!-----------------------------------------------------------------------

  real, allocatable, dimension(:,:) :: Ghprime
!-----------------------------------------------------------------------
!Contants
!     grav    value of gravity
!     rdgas    universal gas constant for dry air
!     kappa  2/7 (i.e., R/Cp)
!-----------------------------------------------------------------------

 logical :: module_is_initialized = .false.

!--- for netcdf restart
type(restart_file_type), save :: Mg_restart

!---------------------------------------------------------------------
! --- NAMELIST (mg_drag_nml)
!---------------------------------------------------------------------
!     xl_mtn      effective mountain length ( set currently to 100km)
!     acoef       order unity "tunable" parameter
!     gmax    order unity "tunable" parameter 
!             (may be enhanced to increase drag)
!     rho     stand value for density of the air at sea-level (1.13 KG/M**3)
!     low_lev_frac - fraction of atmosphere (from bottom up) considered
!              to be "low-level-layer for base flux calc. and where no
!              wave breaking is allowed.
!     flux_cut_level pressure level (Pa) above which flux divergence is set to zero 
!-----------------------------------------------------------------------

 real :: &
      xl_mtn=1.0e5 &
!     & ,gmax=1.0, acoef=1.0
!  v197 value of gmax = 2.0
      ,gmax=2.0, acoef=1.0, rho=1.13  &
!  v197 value for low-level-layer
      ,low_lev_frac = .23

real  ::  flux_cut_level= 0.0

logical :: do_conserve_energy = .false.
logical :: do_mcm_mg_drag = .false.
character(len=128) :: source_of_sgsmtn = 'input'

    namelist / mg_drag_nml / xl_mtn, gmax, acoef, rho, low_lev_frac, &
                             do_conserve_energy, do_mcm_mg_drag,     &
                             source_of_sgsmtn, flux_cut_level 

 public mg_drag, mg_drag_init, mg_drag_end, mg_drag_restart

 contains

!#############################################################################      

 subroutine mg_drag (is, js, delt, uwnd, vwnd, temp, pfull, phalf, &
                    zfull,zhalf,dtaux,dtauy,dtemp,taubx, tauby, tausf,&
                    kbot)
!===================================================================

! Arguments (intent in)

 integer, intent(in) :: is,js
 real, intent(in)    :: delt
 real, intent(in), dimension (:,:,:) :: &
     &             uwnd, vwnd, temp, pfull, phalf, zfull, zhalf
 integer, intent(in), optional, dimension(:,:)   :: kbot

!
!      INPUT
!      -----
!
!      is,js   - integers containing the starting
!                  i,j indices from the full horizontal grid
!      delt     time step in seconds
!      UWND     Zonal wind (dimensioned IDIM x JDIM x KDIM)
!      VWND     Meridional wind (dimensioned IDIM x JDIM x KDIM)
!      TEMP     Temperature at full model levels
!                   (dimensioned IDIM x JDIM x KDIM)
!      PFULL    Pressure at full model levels
!                   (dimensioned IDIM x JDIM x KDIM)
!      PHALF    Pressure at half model levels
!                   (dimensioned IDIM x JDIM x KDIM+1)
!      ZHALF    Height at half model levels
!                   (dimensioned IDIM x JDIM x KDIM+1)
!      ZFULL    Height at full model levels
!                   (dimensioned IDIM x JDIM x KDIM+1)
!      KBOT     optional;lowest model level index (integer)
!                   (dimensioned IDIM x JDIM)
!===================================================================
! Arguments (intent out)

 real, intent(out), dimension (:,:) :: taubx, tauby
 real, intent(out), dimension (:,:,:) :: dtaux, dtauy, dtemp, tausf

!      OUTPUT
!      ------

!       TAUBX, TAUBY  base momentum flux componenets - output for diagnostics
!                   (dimensioned IDIM x JDIM)-kg/m/s**2
!                   = -(RHO*U**3/(N*XL))*G(FR) FOR N**2 > 0
!                   =          0               FOR N**2 <=0
!      DTAUX    Tendency of the zonal wind component deceleration 
!                   (dimensioned IDIM x JDIM x KDIM)
!      DTAUY    Tendency of the meridional wind component deceleration 
!                   (dimensioned IDIM x JDIM x KDIM)
!      dtemp    Tendency of temperature due to dissipation of ke
!
!      TAUSF = "CLIPPED" SAT MOMENTUM FLUX ( AT HALF LEVELS below top)
!                  
!===================================================================

!-----------------------------------------------------------------------

!     LLA IS DEFINED AS THE NUMBER OF LEVELS UP FROM THE LOWEST USED
!     TO CALCULATE THE "LOW-LEVEL" AVERAGES.

!     THIS ROUTINE COMPUTES THE DECELERATION OF THE ZONAL WIND AND
!     MERIDIONAL WIND DUE TO MOUNTAIN GRAVITY WAVE DRAG.  THE
!     PARAMETERIZATION WAS DEVELOPED BY R. PIERREHUMBERT AND ADAPTED
!     TO THE SPECTRAL MODEL BY B. STERN.  THE SCHEME IS STRUCTURED TO
!     INCLUDE 4 MAIN (GENERALLY VALID) COMPONENTS
!              1)  CALCULATION OF A BASE MOMENTUM FLUX(TAUB) WHICH IS
!                  A FUNCTION OF LOW-LEVEL->  WINDS, BRUNT-VAISALA FREQ,
!                  AND DENSITY  AS WELL AS THE SUB-GRID SCALE MOUNTAIN
!                  HEIGHT AND EFFECTIVE MOUNTAIN LENGTH.
!              2)  CALCULATION OF A SATURATION MOMENTUM FLUX PROFILE
!                  (TAUS(P) ) - IN GENERAL THIS IS A FUNCTION OF THE
!                  VERTICAL PROFILES OF WINDS, BRUNT VAISALA FREQ AND
!                  DENSITY.
!              3)  DETERMINE THE ACTUAL MOMENTUM FLUX PROFILE.  IT IS
!                  EQUAL TO THE FLUX ENTERING THE LAYER FROM BELOW
!                  BUT CANNOT EXCEED THE SATURATION FLUX IN THAT LAYER.
!              4)  CALCULATE THE DE-CELERATION DUE TO THE DRAG.
!     SATURATION MOMENTUM FLUX PROFILES
!          SCHEME 1:  LINEAR DROP OFF (IN P OR SIGMA) FROM THE BASE
!                     FLUX AT THE BOTTOM OF THE MODEL TO ZERO AT SIGTOP
!                           (^4/86)
!          SCHEME 2:  FUNCTION OF DENSITY, WINDS AND BRUNT VAISALA FREQ.
!                     V SCALE OF WAVE(D)  -
!                       A. FROM WKB THEORY
!                           (^6/87)
!                       B. FROM EXTENSION TO WKB THEORY
!                           (^7/87)
!     THE DECELERATION  IS PROPORTIONAL TO DTAUP/DSIGMA -> MOMENTUM FLUX
!     ABSORPTION WILL TAKE PLACE ONLY IN THOSE REGIONS WHERE TAUP VARIES
!     IN THE VERTICAL - I.E. WAVE BREAKING LAYERS.

!=======================================================================
!  (Intent local)
 real , dimension(size(uwnd,1),size(uwnd,2)) ::  xn, yn, psurf,ptop,taub
 real , dimension(size(uwnd,1),size(uwnd,2),size(uwnd,3)) ::  theta 
 real , dimension(size(uwnd,1),size(uwnd,2),size(uwnd,3)+1) ::  taus
 real vsamp
integer, dimension (size(uwnd,1),size(uwnd,2)) :: ktop, kbtm
integer idim, jdim, kdim, kdimm1, kdimp1, ie, je

!              XN,YN  = PROJECTIONS OF "LOW LEVEL" WIND
!                       IN ZONAL & MERIDIONAL DIRECTIONS
!              TAUB = BASE MOMENTUM FLUX
!                   = -(RHO*U**3/(N*XL))*G(FR) FOR N**2 > 0
!                   =          0               FOR N**2 <=0
!              TAUS = SATURATION MOMENTUM FLUX ( AT HALF LEVELS)
!                   = (XN,XY)*(1-(AETA-1)/(SIGTOP-1))*TAUB  - SCHEME 1
!                   = -DENSITY(L)*UMAG(L)*D(L)*GMAX/XL       - SCHEME 2
!                   -> -AETA(L)*PS*UMAG(L)*D(L)*GMAX/XL
!      THETA    POTENTIAL temperature at full model levels
!                   (dimensioned IDIM x JDIM x KDIM)
!      PSURF    Surface pressure 
!                   (dimensioned IDIM x JDIM)
!      PTOP     Pressure at top of low-level layer
!                   (dimensioned IDIM x JDIM)
!      KTOP     Top model level index included in low-level layer
!                   (dimensioned IDIM x JDIM)
!      KBTM     Bottom model level index included in low-level layer
!                   usually the lowest level 
!                   (dimensioned IDIM x JDIM)
!-----------------------------------------------------------------------
!  type loop indicies
 integer i, j, k, kd
!-----------------------------------------------------------------------
!  Local variables needed only for code that
!  implements supersource-like gravity wave drag.

integer :: klast, kcrit
real    :: sigtop, small=1.e-10

real,    dimension(size(uwnd,1),size(uwnd,2))              :: ulow, vlow, tlow, thlow
real,    dimension(size(uwnd,1),size(uwnd,2))              :: rlow, zsvar, bvfreq, x
real,    dimension(size(uwnd,1),size(uwnd,2))              :: depth, ave_p
integer, dimension(size(uwnd,1),size(uwnd,2))              :: ntop 
real,    dimension(size(uwnd,1),size(uwnd,2),size(uwnd,3)) :: th, sh_ang, test
real,    dimension(size(uwnd,1),size(uwnd,2),size(uwnd,3)) :: sigma, del_sigma
!real,    dimension(size(uwnd,1),size(uwnd,2),size(uwnd,3)+1) :: sigma_half

!---------------------------------------------------------------------

  idim = size( uwnd, 1 )
  jdim = size( uwnd, 2 )
  kdim = size( uwnd, 3 )
  kdimm1 = kdim - 1
  kdimp1 = kdim + 1

!-----------------------------------------------------------------------

!        CODE VARIABLES     DESCRIPTION

!              XN,YN  = PROJECTIONS OF "LOW LEVEL" WIND
!                       IN ZONAL & MERIDIONAL DIRECTIONS
!              TAUB = BASE MOMENTUM FLUX
!                   = -(RHO*U**3/(N*XL))*G(FR) FOR N**2 > 0
!                   =          0               FOR N**2 <=0
!              TAUS = SATURATION MOMENTUM FLUX ( AT HALF LEVELS)
!                   = (XN,XY)*(1-(AETA-1)/(SIGTOP-1))*TAUB  - SCHEME 1
!                   = -DENSITY(L)*UMAG(L)*D(L)*GMAX/XL       - SCHEME 2
!                   -> -AETA(L)*PS*UMAG(L)*D(L)*GMAX/XL
!              TAUP = MOMENTUM FLUX ( AT HALF LEVELS)
!              TAUP(L) = MIN ( TAUP(L-1),TAUS(L))
!              ULOW = "LOW-LEVEL" WIND MAGNITUDE (M/S)   (= U )
!                    AVERAGE UP TO ^2KM ABOVE SURFACE(LOWEST 1/3 SIGMAS)
!              UMAG = V. PROFILE OF WIND MAGNITUDES-AT HALF LEVS (=U(L))
!              DUDZ = VERTICAL DERIVATIVE OF U(L) WITH RESPECT TO Z
!                     DEFINED AT FULL LEVELS
!              DU2DZ2 = 2ND DERIVATIVE OF U(L) WITH RESPECT TO Z
!                     DEFINED AT HALF LEVELS
!              D = CHARACTERISTI! V. LENGTH SCALE OF WAVES (=D(L))
!                  FOR WKB D(L) = U(L)/N(L)
!                  FOR EXTENDED WKB 1/D**2 = N(L)**2/U(L)**2
!                                            - D2UDZ2(L)/U(L)
!              BNV,BNVK = "LOW-LEVEL",V. PROFILE -  BRUNT VAISALA FREQ(1
!                                                                 (= N,N
!              BNV2,BNVK2 = N**2, N(L)**2
!              HPRIME = Sub-grid scale mountain height 
!                       over local domain (IDIM x JDIM)
!              XL = EFFECTIVE MOUNTAIN LENGTH = (100KM EVERYWHERE)
!              SIGTOP = HIGHEST LEVEL TO WHICH GRAVITY WAVE
!                         MOMENTUM FLUX WILL BE DISTRIBUTED.
!              G = GMAX*FR**2/(FR**2+A**2)
!                 GMAX = 1.0
!                 A = 1.0
!=======================================================================

if ( .not.do_mcm_mg_drag ) then

!--- export sub grid scale topography
  ie = is + idim - 1
  je = js + jdim - 1

!-----------------------------------------------------------------------
!     vsamp is a vertical sampling coefficient which serves to amplify
!     the windshear wkb extension term in the calculation of d.
!     it increases this term to adjust for the deficiency of coarse
!     vertical resolution properly resolving the vertical windshear.

!     vsamp = (kdim+63)/kdim
      vsamp = 1.0
!-----------------------------------------------------------------------
!  calculate bottom of low-level layer = lowest level unless kbot is present
    if (present(kbot)) then
       kbtm(:,:) = kbot(:,:)
    else
       kbtm(:,:) = kdim
    endif
!  calculate top of low-level layer, first get surface p from phalf
    if (present(kbot)) then
       do j=1,jdim
       do i=1,idim
         psurf(i,j) = phalf(i,j,kbtm(i,j)+1)
       end do
       end do
    else
       psurf(:,:) = phalf(:,:,kdimp1)
    endif
!     print *,'psurf=', psurf
!  Based on fraction of model atmosphere to be considered "low-level"
!  (input via namelist), find highest model level.

    ktop(:,:) = kdim
    ptop(:,:) = (1.-low_lev_frac)*psurf(:,:)
    do kd=kdim,1,-1 
         where (pfull(:,:,kd) .ge. ptop(:,:)) 
           ktop(:,:) = kd
         end where
    end do
!  Make sure that low-level layer is at least 2 layer thick
    ktop(:,:) = min(ktop(:,:),(kbtm(:,:)-1) )
!     print *,'ptop=', ptop
!     print *,'ktop=', ktop

!  calculate base flux
    call mgwd_base_flux (is,js,uwnd,vwnd,temp,pfull,phalf,ktop,kbtm,theta, &
         &               xn,yn,taub)

!  split taub in to x and y components
    taubx(:,:) = taub(:,:)*xn(:,:)
    tauby(:,:) = taub(:,:)*yn(:,:)

!  calculate saturation flux profile
    call mgwd_satur_flux (uwnd,vwnd,temp,theta,ktop,kbtm, &
         &                xn,yn,taub,pfull, phalf,zfull,zhalf,vsamp,taus)

!  calculate mountain gravity wave drag tendency contributions
    call mgwd_tend (is,js,xn,yn,taub,phalf,taus,dtaux,dtauy, tausf)

else if ( do_mcm_mg_drag ) then

    if(present(kbot)) then
      call error_mesg ('mg_drag','kbot cannot be present in the calling arguments when using the Manabe Climate Model option',FATAL)
    endif

    do k=1,kdim
      sigma(:,:,k) = pfull(:,:,k)/phalf(:,:,kdimp1)
      del_sigma(:,:,k) = (phalf(:,:,k+1) - phalf(:,:,k))/phalf(:,:,kdimp1)
!     sigma_half(:,:,k) = phalf(:,:,k)/phalf(:,:,kdimp1)
    enddo
!    sigma_half(:,:,kdimp1) = 1.0

    ie = is + idim - 1
    je = js + jdim - 1

    zsvar = (Ghprime(is:ie,js:je))**2

    do k = 1,kdim
      th(:,:,k) = temp(:,:,k) + grav*(zfull(:,:,k)-zhalf(:,:,kdimp1))*kappa/rdgas
    end do

    sigtop = 1.0 - low_lev_frac
    do j = 1,jdim
      do i = 1,idim
        do k = kdim,1,-1
          if (sigma(i,j,k) .lt. sigtop) then
              if ( (sigtop - sigma(i,j,k)) .le. (sigma(i,j,k+1)-sigtop) ) then
                ntop(i,j) = k
              else
                ntop(i,j) = k + 1
              endif
              go to 10
          endif
        end do
        10 continue
      enddo
    enddo

    ulow  = 0.0
    vlow  = 0.0
    tlow  = 0.0
    thlow = 0.0
    depth = 0.0

    do j = 1,jdim
      do i = 1,idim
        do k = ntop(i,j), kdim
           ulow(i,j)  = ulow(i,j)  + del_sigma(i,j,k)* uwnd(i,j,k) 
           vlow(i,j)  = vlow(i,j)  + del_sigma(i,j,k)* vwnd(i,j,k) 
           tlow(i,j)  = tlow(i,j)  + del_sigma(i,j,k)* temp(i,j,k)  
           thlow(i,j) = thlow(i,j) + del_sigma(i,j,k)*th(i,j,k)
           depth(i,j) = depth(i,j) + del_sigma(i,j,k)
        end do
      enddo
    enddo
    ulow  = ulow/depth
    vlow  = vlow/depth
    tlow  = tlow/depth
    thlow = thlow/depth

    do j = 1,jdim
      do i = 1,idim
        ave_p(i,j)  = (phalf(i,j,ntop(i,j)-1) + phalf(i,j,kdim))/2.
        bvfreq(i,j) = (th(i,j,kdim) - th(i,j,ntop(i,j)))/(pfull(i,j,kdim) - pfull(i,j,ntop(i,j)))
        bvfreq(i,j) = -grav*grav*ave_p(i,j)*bvfreq(i,j)/(rdgas*tlow(i,j)*thlow(i,j))  ! thlow should be tlow !IH
      enddo
    enddo

    where(bvfreq > 0.0)
      bvfreq = sqrt(bvfreq)
    elsewhere
      bvfreq = 0.0
    endwhere

!     TK mod: original had rk0*grav*bvfreq*zsvar*ulow .... etc..

    x = grav*bvfreq*zsvar/(rdgas*tlow*xl_mtn)

    rlow = 1.0/sqrt(ulow**2 + vlow**2 + small)
    do k = 1, kdim
      sh_ang(:,:,k) = rlow*(ulow*uwnd(:,:,k) + vlow*vwnd(:,:,k))/      &
                     sqrt(uwnd(:,:,k)**2 + vwnd(:,:,k)**2 + small)
    enddo
    sh_ang = min(sh_ang, 0.99999)
    sh_ang = max(sh_ang,-0.99999)
    sh_ang = acos(sh_ang)

    test = 1.0
    where (sh_ang > 2.*atan(1.0))
      test = 0.0
    endwhere
    do j = 1,jdim
      do i = 1,idim
        do k=ntop(i,j),kdim
          test(i,j,k) = 1.0
        enddo
      enddo
    enddo

    do j = 1,jdim
      do i = 1,idim
        do k = ntop(i,j) - 1, 1, -1
          klast = k
          if (test(i,j,k) /= 1.0 )  go to 20
        end do
        klast = 0
        20 continue
        if ( klast /= 0 )  test(i,j,1:klast) = 0.0
        kcrit = klast + 1
        x(i,j) = x(i,j)/(1.-sigma(i,j,kcrit))  
!       should be  x(i,j) = x(i,j)/(1 - sigma_half(klast)/sigma_half(kdim))
      end do
    end do

    do k = 1,kdim
      dtaux(:,:,k) = - x*ulow*test(:,:,k)
      dtauy(:,:,k) = - x*vlow*test(:,:,k)
    end do

    taub = 0.0
    taubx = 0.0
    tauby = 0.0
    tausf = 0.0

endif

!  calculate temperature tendency due to dissipation of kinetic energy
if (do_conserve_energy) then
  dtemp = -((uwnd+.5*delt*dtaux)*dtaux + (vwnd+.5*delt*dtauy)*dtauy)/cp_air
else
  dtemp = 0.0
endif

return
end subroutine mg_drag
!=======================================================================

!#############################################################################      
 
subroutine mgwd_base_flux (is,js,uwnd,vwnd,temp,pfull,phalf,ktop,kbtm,  &
                          theta,xn,yn,taub)
                                  


!-------------------------------------------------------------------
!  calculates base momentum flux  - taub
!-------------------------------------------------------------------

!===================================================================
! Arguments (intent in)
 real, intent(in), dimension (:,:,:) :: uwnd, vwnd, temp, pfull, phalf
 integer, intent(in), dimension (:,:) :: ktop, kbtm
 integer, intent(in)   :: is, js
!===================================================================
! Arguments (intent out)
 real, intent(out), dimension (:,:) :: xn, yn, taub
 real , intent(out), dimension (:,:,:) :: theta
!===================================================================
! Arguments (intent inout)
!=======================================================================
!  (Intent local)
real , dimension(size(uwnd,1),size(uwnd,2)) :: sumw, delp, ulow, bnv, &
     &  hprime, fr, g, ubar, vbar, bnv2 
real grav2, xli, a, small
 integer idim, jdim,kdim,ie, je
!-----------------------------------------------------------------------
!  type loop indicies
 integer i, j, k, kb, kt
!-----------------------------------------------------------------------
!===================================================================

!-------------------------------------------------------------------
! --- DEFINE CURRENT WINDOW & GET GLOBAL VARIABLES
!-------------------------------------------------------------------

  idim = size( uwnd, 1 )
  jdim = size( uwnd, 2 )
  kdim = size( uwnd, 3 )
  ie = is + idim - 1
  je = js + jdim - 1
  hprime(:,:) = Ghprime(is:ie,js:je)

! define local scalar variables
  xli=1.0/xl_mtn
  grav2=grav*grav
  a = acoef 


!-----------------------------------------------------------------------
!     <><><><><><><><>   base flux code   <><><><><><><><>
!-----------------------------------------------------------------------

!  initialize arrays
        sumw(:,:) = 0.0
        ubar(:,:) = 0.0
        vbar(:,:) = 0.0
        ulow(:,:) = 0.0
        taub(:,:) = 0.0
        xn  (:,:) = 0.0
        yn  (:,:) = 0.0


!     compute low-level averages
!     --------------------------

      do j=1,jdim
        do i=1,idim
          do k=ktop(i,j),kbtm(i,j)
            delp(i,j) = phalf(i,j,k+1)-phalf(i,j,k)
            sumw(i,j) = sumw(i,j) + delp(i,j)
            ubar(i,j) = ubar(i,j) + uwnd(i,j,k)*delp(i,j)
            vbar(i,j) = vbar(i,j) + vwnd(i,j,k)*delp(i,j)
          end do
        end do
      end do
!    print *, 'low-lev aves computed, ubar, vbar =', ubar, vbar

!     calculate projections of low level flow onto wind components (u&v)
!     ------------------------------------------------------------------
        sumw(:,:) = 1./sumw(:,:)
        ubar(:,:) = ubar(:,:) * sumw(:,:)
        vbar(:,:) = vbar(:,:) * sumw(:,:)
        ulow(:,:) =sqrt(ubar(:,:)*ubar(:,:) + vbar(:,:)*vbar(:,:))
        xn(:,:) = ubar(:,:)/(ulow(:,:) + 1.0e-20)
        yn(:,:) = vbar(:,:)/(ulow(:,:) + 1.0e-20)


!     calculate squared brunt vaisala freq
!     ------------------------------------

      theta(:,:,:)=temp(:,:,:)*(pfull(:,:,:)/p00)**(-kappa)
!  v197 uses p* as reference vlues for theta, in above 1000 hPa is used
!      theta(:,:,:)=temp(:,:,:)*(pfull(:,:,:)/ &
!     &             phalf(:,:,kdim+1))**(-kappa)
 
      do j=1,jdim
        do i=1,idim
          kt=ktop(i,j)
          kb=kbtm(i,j)
          bnv2(i,j) = grav2*(pfull(i,j,kt)+pfull(i,j,kb)) &
                 * (theta(i,j,kt)-theta(i,j,kb)) &
              / ( rdgas*(theta(i,j,kt)+theta(i,j,kb)) &
                 * (pfull(i,j,kb)-pfull(i,j,kt)) &
                 *.5*(temp(i,j,kt)+temp(i,j,kb)))
        end do
      end do

!      calculate bnv,fr,g,taub,xn,yn - if n**2>0
!      -----------------------------------------
           small = epsilon(ulow)

           where (bnv2(:,:) .gt. 0.0) 
             bnv(:,:) = sqrt(bnv2(:,:))
             fr (:,:) = bnv(:,:)*hprime(:,:)/(ulow(:,:) + small)
             g  (:,:) = gmax*fr(:,:)*fr(:,:)/(fr(:,:)*fr(:,:)+a*a)
             taub(:,:) = -rho*xli*ulow(:,:)*ulow(:,:)*ulow(:,:) &
     &                 / bnv(:,:)*g(:,:)
           elsewhere
             bnv(:,:) = 0.0
             fr (:,:) = 0.0
             g  (:,:) = 0.0
           endwhere

end subroutine mgwd_base_flux

!#############################################################################      

subroutine mgwd_satur_flux (uwnd,vwnd,temp,theta,ktop,kbtm, &
                           xn,yn,taub,pfull,phalf,zfull,zhalf,vsamp,taus)

!===================================================================
! Arguments (intent in)
 real, intent(in), dimension (:,:,:)  :: &
     &             uwnd, vwnd, temp, theta, pfull, phalf,zfull, zhalf
 real, intent(in), dimension (:,:)    :: xn, yn, taub
 real, intent(in)                     :: vsamp 
 integer, intent(in), dimension (:,:) :: ktop, kbtm
!===================================================================
! Arguments (intent out)
 real, intent(out), dimension (:,:,:) :: taus
!=======================================================================
!  (Intent local)
 real , dimension(size(uwnd,1),size(uwnd,2),size(uwnd,3)) ::  &
     &       dudz  
 real , dimension(size(uwnd,1),size(uwnd,2),size(uwnd,3)+1) ::  &
     &       umag, bnvk2, d,d2, d2i, d2udz2, extend
 real grav2, xli, small
 integer :: idim, jdim, kdim, kdimm1, kdimp1
!-----------------------------------------------------------------------
!  type loop indicies
 integer i, j, k, kb, kt, kbp1, ktm1 
!-----------------------------------------------------------------------
!  type flux cutoff 
 integer kcut
!=======================================================================


  idim = size( uwnd, 1 )
  jdim = size( uwnd, 2 )
  kdim = size( uwnd, 3 )
  kdimm1 = kdim - 1
  kdimp1 = kdim + 1

! define local scalar variables
  xli=1.0/xl_mtn
  grav2=grav*grav

!-----------------------------------------------------------------------
!     <><><><><><><><>   saturation flux code   <><><><><><><><>
!-----------------------------------------------------------------------

!     scheme 1 - linear profile
!     do 35 l=1,lp1
!     do 35 i=1,idim
!     taus(i,l) = taub(i) * (1-(eta(l)-1)/(sigtop-1) )
!35    continue

!-----------------------------------------------------------------------

!     ********** scheme 2 - wave breaking formulation  **********

!-----------------------------------------------------------------------


!     calculate wind magnitude at 1/2 levels
!     --------------------------------------------

      do k=2,kdim
        umag(:,:,k) =  (0.50*(uwnd(:,:,k-1)+uwnd(:,:,k))*xn(:,:) &
                     + 0.50*(vwnd(:,:,k-1)+vwnd(:,:,k))*yn(:,:))
        umag(:,:,k) = abs( umag(:,:,k) )
      end do


!     set wind magnitude at top of model = to magnitude at top full
!     level.

        umag(:,:,1) = uwnd(:,:,1)*xn(:,:) + vwnd(:,:,1)*yn(:,:)
        umag(:,:,1) = abs( umag(:,:,1) )

!     set wind magnitude at ground = 0.

      do j=1,jdim
        do i=1,idim
          kbp1=kbtm(i,j)+1
          do k=kbp1,kdimp1
            umag(i,j,k) = 0.0
          end do
        end do
      end do

!     set minimum wind magnitude

      small = epsilon (umag)
      where ( umag .lt. small ) umag = 0.0


!      print *, ' umag for sat flux =', umag

!-----------------------------------------------------------------------

!     calculate vertical derivatives of umag, to be used in
!     the extension to the wkb approach for determining d.
!     -- derivative of umag with respect to z is computed at
!        full levels and stored in dudz.
!     dudz(1) is defined using an uncentered difference

         dudz(:,:,1) = (umag(:,:,1)-umag(:,:,2)) &
     &                /(zfull(:,:,1)-zhalf(:,:,2))

      do k=2,kdim
         dudz(:,:,k) = (umag(:,:,k)-umag(:,:,k+1)) &
     &                /(zhalf(:,:,k)-zhalf(:,:,k+1))
      end do

!      print *, ' dudz for sat flux =', dudz



!     assume vertical derivative of umag at the boundaries=0 and
!     compute 2nd derivatives there using uncentered differencing

      do k=2,kdim
         d2udz2(:,:,k) = (dudz(:,:,k)-dudz(:,:,k-1)) &
     &                  /(zfull(:,:,k)-zfull(:,:,k-1))
      end do

!     set d2udz2 = 0 at the top of the atmosphere (original code)
!     set d2udz2 at the top of atm to level 2 value (new code)

!del    d2udz2(:,:,1) = 0.0
        d2udz2(:,:,1) = d2udz2(:,:,2)

      do  j=1,jdim
      do  i=1,idim
        kb=kbtm(i,j)
        kbp1=kb+1
        d2udz2(i,j,kbp1) = dudz(i,j,kb)/(zfull(i,j,kb)-zhalf(i,j,kbp1))
      end do
      end do

!      print *, ' d2udz2 for sat flux =', d2udz2


!-----------------------------------------------------------------------

!     compute wkb extension term for umag > 0
!     ---------------------------------------

         where (umag(:,:,:).gt.0.0) 
            extend(:,:,:) = vsamp*d2udz2(:,:,:)/umag(:,:,:)
         elsewhere
            extend(:,:,:) = 0.0
         endwhere

!      print *, ' wkb exten for sat flux =', extend


!     calculate brunt vaisala frequency at 1/2 levels
!     -----------------------------------------------------

      do k=2,kdim
        bnvk2(:,:,k) =  grav2*(pfull(:,:,k-1)+pfull(:,:,k)) &
     &          * (theta(:,:,k-1)-theta(:,:,k)) &
     &      /     ( rdgas*(theta(:,:,k-1)+theta(:,:,k)) &
     &  * (pfull(:,:,k)-pfull(:,:,k-1))*.5*(temp(:,:,k-1)+temp(:,:,k)) )
      end do


!     keep static stability constant in top & bottom layers of model
!     for taus calculations.

        bnvk2(:,:,1) = bnvk2(:,:,2)


      do j=1,jdim
      do i=1,idim
        kb=kbtm(i,j)
        kbp1=kb+1
        bnvk2(i,j,kbp1)   = bnvk2(i,j,kb)
        bnvk2(i,j,kdimp1) = bnvk2(i,j,kdim)
      end do
      end do

!      print *, ' brunt vaisala for sat flux =', bnvk2


!-----------------------------------------------------------------------

!     calculate d2i (=1/d**2) for umag .gt. 0
!     initialize d2i to a large number, which will result in a very
!     small vertical wavelength (d) where umag = 0.

         where (umag(:,:,:).gt.0.0) 
            d2i(:,:,:) = (bnvk2(:,:,:)/(umag(:,:,:)* &
     &                   umag(:,:,:)) - extend(:,:,:) )
         elsewhere
            d2i(:,:,:) = 1.0e+30
         endwhere

!      print *, ' 1/d**2 for sat flux =', d2i


!     for 1/d**2 approaching 0 calculate d by dividing by a
!     very small but finite number

         where (d2i(:,:,:) .lt. 1.e-30) 
            d(:,:,:) = 1.e+30
         elsewhere
            d2(:,:,:) = 1./d2i(:,:,:)
            d (:,:,:) = sqrt(d2(:,:,:))
         endwhere


!     set d=0 for umag=0.
         where (umag(:,:,:).eq.0.0) 
            d(:,:,:) = 0.0
         endwhere


!-----------------------------------------------------------------------

!      print *, 'd for sat flux =', d

!     calculation of the saturation flux profile for scheme 2
!     -------------------------------------------------------

      do j=1,jdim
        do i=1,idim
          kb=kbtm(i,j)
          kt=ktop(i,j)
          ktm1=kt-1

          do k=2,ktm1
            taus(i,j,k) = -phalf(i,j,k)*umag(i,j,k)*umag(i,j,k) &
     &                  *d(i,j,k)*xli*gmax &
     &                / (0.50*(temp(i,j,k-1)+temp(i,j,k))*rdgas)
          end do

          do k = kt,kdimp1
            taus(i,j,k) = taub(i,j)
          end do

        end do
      end do


!     keep taus profile constant across top model layer (original code)
!     calculate taus profile in top model layer (new code)
 
        taus(:,:,1) = taus(:,:,2)
!del        taus(:,:,1) = -phalf(:,:,1)*umag(:,:,1)*umag(:,:,1) &
!del     &                  *d(:,:,1)*xli*gmax / (temp(:,:,1)*rdgas)


!     do not allow wave breaking for unstable layers
 
       do k = 1,kdimp1
         where ( bnvk2(:,:,k) .lt. 0.0) 
           taus(:,:,k) =  taub(:,:)
         endwhere
       end do


! -------------------------------------------
!        tausat(:,:,1) = 0.             ! use all forcing
!         Instead,  let remaining flux escape above flux_cut_level
      if( flux_cut_level > 0.0 ) then 
         kcut= 1 
         do while( phalf(1,1,kcut) < flux_cut_level )
            kcut= kcut+1
         enddo

        do k= 1, kcut-1
            taus(:,:,k)= taus(:,:,kcut)
        enddo
      endif

end subroutine mgwd_satur_flux

!#############################################################################      

subroutine mgwd_tend (is,js,xn,yn,taub,phalf,taus,dtaux,dtauy,tausf)

!===================================================================
! Arguments (intent in)
 real, intent(in), dimension (:,:,:) :: phalf, taus
 real, intent(in), dimension (:,:) :: xn, yn, taub
 integer, intent(in)   :: is, js
!===================================================================
! Arguments (intent out)
 real, intent(out), dimension (:,:,:) :: dtaux, dtauy, tausf
!=======================================================================
!  (Intent local)
 real , dimension(size(phalf,1),size(phalf,2),size(phalf,3)) ::  dterm 
 real , dimension(size(phalf,1),size(phalf,2),size(phalf,3)+1) ::  taup
 integer kdim, kdimp1
!-----------------------------------------------------------------------
!  type loop indicies
 integer k, kd
!-----------------------------------------------------------------------
!=======================================================================


  kdim = size( dtaux, 3 )
  kdimp1 = kdim + 1


!-----------------------------------------------------------------------
!     <><><><><><><><>   MOMENTUM FLUX CODE   <><><><><><><><>
!-----------------------------------------------------------------------

!     CALCULATE FLUX FROM GROUND UP
!     -----------------------------

        taup (:,:,kdimp1) = taub(:,:)

      do kd=2,kdimp1
        k = kdimp1-kd+1
        tausf(:,:,k)=taup(:,:,k+1)
        taup(:,:,k) = max (taus(:,:,k),taup(:,:,k+1))
      end do

!     ALLOW FLUX TO ESCAPE THE TOP - DO NOT RE-DISTRIBUTE

!     <><><><><><><><><><><><><><><><><><><><><><><><><><><><>

!     <><><><><><><><>   DE-CELERATION CODE   <><><><><><><><>
 
!     CALCULATE DECELERATION TERMS - DTAUX,DTAUY
!     ------------------------------------------

       do k=1,kdim
          dterm(:,:,k) = grav*(taup (:,:,k+1)-taup (:,:,k)) &
     &                     /(phalf(:,:,k+1)-phalf(:,:,k))
 
        dtaux(:,:,k) = xn(:,:)*dterm(:,:,k)
        dtauy(:,:,k) = yn(:,:)*dterm(:,:,k)
       end do

!  print sample output
!            print*, ' mgdrag output for i,j=', is,js
!            print *,'taub = ', taub(is,js)     
!            print *,'taus = ', taus(is,js,:)     
!            print *,'taup = ', taup(is,js,:)     


!     ***********************************************************

end subroutine mgwd_tend

!#######################################################################

  subroutine mg_drag_init( lonb, latb, hprime )

!=======================================================================
! ***** INITIALIZE Mountain Gravity Wave Drag
!=======================================================================

!---------------------------------------------------------------------
! Arguments (Intent in)
!     lonb  = longitude in radians of the grid box corners
!     latb  = latitude  in radians of the grid box corners
!---------------------------------------------------------------------
 real, intent(in), dimension(:,:) :: lonb, latb
 
!---------------------------------------------------------------------
! Arguments (Intent out - optional)
!     hprime  = array of sub-grid scale mountain heights
!---------------------------------------------------------------------
 real, intent(out), dimension(:,:), optional :: hprime
 
!---------------------------------------------------------------------
!  (Intent local)
!---------------------------------------------------------------------
 integer  ::  ix, iy, unit, io, ierr, logunit
 logical  ::  answer
 integer  :: id_restart

!=====================================================================

if(module_is_initialized) return

!---------------------------------------------------------------------
! --- Read namelist
!---------------------------------------------------------------------
  if( file_exist( 'input.nml' ) ) then
#ifdef INTERNAL_FILE_NML
   read (input_nml_file, nml=mg_drag_nml, iostat=io)
   ierr = check_nml_error(io,'mg_drag_nml')
#else   
! -------------------------------------mg_drag_nml')
 
   unit = open_namelist_file()
   ierr = 1
   do while( ierr .ne. 0 )
   read ( unit,  nml = mg_drag_nml, iostat = io, end = 10 ) 
   ierr = check_nml_error(io,'mg_drag_nml')
   end do
10 continue
   call close_file ( unit )
#endif

! -------------------------------------
  end if

!---------------------------------------------------------------------
! --- Output version
!---------------------------------------------------------------------

  call write_version_number(version, tagname)
  logunit = stdlog()
  if(mpp_pe() == mpp_root_pe()) write (logunit, nml=mg_drag_nml)

!---------------------------------------------------------------------
! --- Allocate storage for Ghprime
!---------------------------------------------------------------------

  ix = size(lonb,1) - 1
  iy = size(latb,2) - 1

  allocate( Ghprime(ix,iy) ) ; Ghprime = 0.0
  
!-------------------------------------------------------------------
  module_is_initialized = .true.
!---------------------------------------------------------------------
! --- Input hprime
!---------------------------------------------------------------------

  id_restart = register_restart_field(Mg_restart, 'mg_drag.res.nc', 'ghprime', Ghprime)

  if ( trim(source_of_sgsmtn) == 'computed' ) then
    answer = get_topog_stdev ( lonb, latb, Ghprime )
    if ( .not.answer ) then
      call error_mesg('mg_drag_init','source_of_sgsmtn="'//trim(source_of_sgsmtn)//'"'// &
                      ', but topography data file does not exist', FATAL)
    endif
  else if ( trim(source_of_sgsmtn) == 'input' .or. trim(source_of_sgsmtn) == 'input/computed' ) then
    if ( file_exist('INPUT/mg_drag.res.nc') ) then
       if (mpp_pe() == mpp_root_pe()) call mpp_error ('mg_drag_mod', &
            'Reading NetCDF formatted restart file: INPUT/mg_drag.res.nc', NOTE)
       call restore_state(Mg_restart)
    else if ( file_exist( 'INPUT/mg_drag.res' ) ) then
       if (mpp_pe() == mpp_root_pe()) call mpp_error ('mg_drag_mod', &
            'Native formatted restart capability removed.', FATAL)
    else
       if (trim(source_of_sgsmtn) == 'input') then
          call error_mesg ('mg_drag_init','source_of_sgsmtn="'//trim(source_of_sgsmtn)//'"'// &
                           ', but neither ./INPUT/mg_drag.res.nc  or  ./INPUT/mg_drag.res  exists', FATAL)
       else
          answer = get_topog_stdev ( lonb, latb, Ghprime )
          if ( .not.answer ) then
            call error_mesg('mg_drag_init','source_of_sgsmtn="'//trim(source_of_sgsmtn)//'"'// &
                            ', but topography data file does not exist', FATAL)
          endif
       endif
    endif
  else
    call error_mesg ('mg_drag_init','"'//trim(source_of_sgsmtn)//'"'// &
          ' is not a valid value for source_of_sgsmtn', FATAL)
  endif

! return sub-grid scale topography?
  if (present(hprime)) hprime = Ghprime
 
!=====================================================================
  end subroutine mg_drag_init

!#######################################################################

  subroutine mg_drag_end
  integer :: unit

  if(.not.module_is_initialized) return

  if (mpp_pe() == mpp_root_pe()) call mpp_error ('mg_drag_mod', &
       'Writing NetCDF formatted restart file: RESTART/mg_drag.res.nc', NOTE)
  call mg_drag_restart
  deallocate(ghprime)
  module_is_initialized = .false.

  end subroutine mg_drag_end


!#######################################################################
! <SUBROUTINE NAME="mg_drag_restart">
!
! <DESCRIPTION>
! write out restart file.
! Arguments: 
!   timestamp (optional, intent(in)) : A character string that represents the model time, 
!                                      used for writing restart. timestamp will append to
!                                      the any restart file name as a prefix. 
! </DESCRIPTION>
!
subroutine mg_drag_restart(timestamp)
  character(len=*), intent(in), optional :: timestamp

  call save_restart(Mg_restart, timestamp)

end subroutine mg_drag_restart
! </SUBROUTINE> NAME="mg_drag_restart"

!#######################################################################

end module mg_drag_mod

!----------------------------------------------------------------
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Niki Zadeh 
! </CONTACT>
! 
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> William Cooke
! </REVIEWER>
!<OVERVIEW>
! Ocean Carbon Model Intercomparison Study II: CFC module
! This module contains the generic version of CFC Tracers and their chemistry.
! It is designed so that both GFDL Ocean models, GOLD and MOM, can use it.
! The chemistry calculations in this module are ported from MOM ocmip2_cfc.F90
! released in omsk_2008_03 
!</OVERVIEW>
!
!<DESCRIPTION>
!       Implementation of routines to solve the OCMIP-2 CFC
!       simulations as outlined in the CFC-HOWTO documentation,
!       revision 1.6, 1999/04/29.
!</DESCRIPTION>
!
! <INFO>
! <REFERENCE>
! http://www.ipsl.jussieu.fr/OCMIP/phase2/simulations/CFC/HOWTO-CFC.html
! </REFERENCE>
! <DEVELOPER_NOTES>
! nnz: 
! A. Reproducing GOLD results
! The tracers in this module reproduce the corresponding ones
! in non-generic module GOLD_OMIP2_CFC.F90 with branch tag perth_gas_fluxes_nnz.
! The reproducing of non-generic tracers in this case is sufficient evidence for the consistency of vertical diffusion
! (tracer_vertdiff) routine used in the two cases. 
! 
! B. Reproducing MOM results
!
! </DEVELOPER_NOTES>
! </INFO>
!
!----------------------------------------------------------------

module generic_CFC

  use coupler_types_mod, only: coupler_2d_bc_type
  use field_manager_mod, only: fm_string_len
  use mpp_mod, only : mpp_error, NOTE, WARNING, FATAL, stdout
  use time_manager_mod, only : time_type
  use fm_util_mod,       only: fm_util_start_namelist, fm_util_end_namelist  

  use g_tracer_utils, only : g_tracer_type,g_tracer_start_param_list,g_tracer_end_param_list
  use g_tracer_utils, only : g_tracer_add,g_tracer_add_param, g_tracer_set_files
  use g_tracer_utils, only : g_tracer_set_values,g_tracer_get_pointer,g_tracer_get_common
  use g_tracer_utils, only : g_tracer_coupler_set,g_tracer_coupler_get
  use g_tracer_utils, only : g_tracer_send_diag, g_tracer_get_values  


  implicit none ; private

  character(len=fm_string_len), parameter :: mod_name       = 'generic_CFC'
  character(len=fm_string_len), parameter :: package_name   = 'generic_cfc'

  public do_generic_CFC
  public generic_CFC_register
  public generic_CFC_init
  public generic_CFC_update_from_coupler
  public generic_CFC_update_from_source
  public generic_CFC_set_boundary_values
  public generic_CFC_end

  !The following logical for using this module is overwritten 
  ! by generic_tracer_nml namelist
  logical, save :: do_generic_CFC = .false.

  real, parameter :: epsln=1.0e-30

  !
  !This type contains all the parameters and arrays used in this module.
  !
  !Note that there is no programatic reason for treating
  !the following as a type. These are the parameters used only in this module. 
  !It suffices for varables to be a declared at the top of the module. 
  !nnz: Find out about the timing overhead for using type%x rather than x

  type generic_CFC_params
     real :: a1_11, a2_11, a3_11, a4_11   ! Coefficients in the calculation of the
     real :: a1_12, a2_12, a3_12, a4_12   ! CFC11 and CFC12 Schmidt numbers, in
     ! units of ND, degC-1, degC-2, degC-3.
     real :: d1_11, d2_11, d3_11, d4_11   ! Coefficients in the calculation of the
     real :: d1_12, d2_12, d3_12, d4_12   ! CFC11 and CFC12 solubilities, in units
     ! of ND, K-1, log(K)^-1, K-2.
     real :: e1_11, e2_11, e3_11          ! More coefficients in the calculation of
     real :: e1_12, e2_12, e3_12          ! the CFC11 and CFC12 solubilities, in
     ! units of PSU-1, PSU-1 K-1, PSU-1 K-2.
     real :: Rho_0
     character(len=fm_string_len) :: ice_restart_file
     character(len=fm_string_len) :: ocean_restart_file,IC_file
  end type generic_CFC_params


  type(generic_CFC_params) :: param

contains

  subroutine generic_CFC_register(tracer_list)
    type(g_tracer_type), pointer :: tracer_list

    character(len=fm_string_len), parameter :: sub_name = 'generic_CFC_register'

    !Specify all prognostic and diagnostic tracers of this modules.
    call user_add_tracers(tracer_list)

    
    
  end subroutine generic_CFC_register

  ! <SUBROUTINE NAME="generic_CFC_init">
  !  <OVERVIEW>
  !   Initialize the generic CFC module
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   This subroutine: 
  !       Adds all the CFC Tracers to the list of generic Tracers passed to it via utility subroutine g_tracer_add().
  !       Adds all the parameters used by this module via utility subroutine g_tracer_add_param().
  !       Allocates all work arrays used in the module. 
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_CFC_init(tracer_list)
  !  </TEMPLATE>
  !  <IN NAME="tracer_list" TYPE="type(g_tracer_type), pointer">
  !   Pointer to the head of generic tracer list.
  !  </IN>
  ! </SUBROUTINE>

  subroutine generic_CFC_init(tracer_list)
    type(g_tracer_type), pointer :: tracer_list

    character(len=fm_string_len), parameter :: sub_name = 'generic_CFC_init'

    !Specify and initialize all parameters used by this package
    call user_add_params

    !Allocate and initiate all the private work arrays used by this module.
    !    call user_allocate_arrays !None for CFC module currently

  end subroutine generic_CFC_init

  subroutine user_allocate_arrays
    !Allocate all the private arrays.
    !None for CFC module currently
  end subroutine user_allocate_arrays

  !
  !   This is an internal sub, not a public interface.
  !   Add all the parameters to be used in this module. 
  !
  subroutine user_add_params

    !Specify all parameters used in this modules.
    !==============================================================
    !User adds one call for each parameter below!
    !User also adds the definition of each parameter in generic_CFC_params type
    !==============================================================    

    !=============
    !Block Starts: g_tracer_add_param
    !=============
    !Add the known experimental parameters used for calculations
    !in this module.
    !All the g_tracer_add_param calls must happen between 
    !g_tracer_start_param_list and g_tracer_end_param_list  calls.
    !This implementation enables runtime overwrite via field_table.

    call g_tracer_start_param_list(package_name)

    !-----------------------------------------------------------------------
    !     Schmidt number coefficients
    !      Use coefficients given by Zheng et al (1998), JGR vol 103, C1
    !         for CFC11 and CFC12
    !-----------------------------------------------------------------------
    !    g_tracer_add_param(name   , variable   ,  default_value)
    call g_tracer_add_param('a1_11', param%a1_11,  3501.8)
    call g_tracer_add_param('a2_11', param%a2_11, -210.31)
    call g_tracer_add_param('a3_11', param%a3_11,  6.1851)
    call g_tracer_add_param('a4_11', param%a4_11, -0.07513)
    call g_tracer_add_param('a1_12', param%a1_12,  3845.4)
    call g_tracer_add_param('a2_12', param%a2_12, -228.95)
    call g_tracer_add_param('a3_12', param%a3_12,  6.1908)
    call g_tracer_add_param('a4_12', param%a4_12, -0.067430)
    !-----------------------------------------------------------------------
    !     Solubility coefficients for alpha in mol/l/atm
    !      (1) for CFC11, (2) for CFC12
    !     after Warner and Weiss (1985) DSR, vol 32 for CFC11 and CFC12
    !-----------------------------------------------------------------------
    call g_tracer_add_param('d1_11', param%d1_11, -229.9261)
    call g_tracer_add_param('d2_11', param%d2_11,  319.6552)
    call g_tracer_add_param('d3_11', param%d3_11,  119.4471)
    call g_tracer_add_param('d4_11', param%d4_11, -1.39165)
    call g_tracer_add_param('e1_11', param%e1_11, -0.142382)
    call g_tracer_add_param('e2_11', param%e2_11,  0.091459)
    call g_tracer_add_param('e3_11', param%e3_11, -0.0157274)
    call g_tracer_add_param('d1_12', param%d1_12, -218.0971)
    call g_tracer_add_param('d2_12', param%d2_12,  298.9702)
    call g_tracer_add_param('d3_12', param%d3_12,  113.8049)
    call g_tracer_add_param('d4_12', param%d4_12, -1.39165)
    call g_tracer_add_param('e1_12', param%e1_12, -0.143566)
    call g_tracer_add_param('e2_12', param%e2_12,  0.091015)
    call g_tracer_add_param('e3_12', param%e3_12, -0.0153924)

    !  Rho_0 is used in the Boussinesq
    !  approximation to calculations of pressure and
    !  pressure gradients, in units of kg m-3.
    call g_tracer_add_param('RHO_0', param%Rho_0, 1035.0)

    call g_tracer_end_param_list(package_name)
    !===========
    !Block Ends: g_tracer_add_param
    !===========



  end subroutine user_add_params

  !
  !   This is an internal sub, not a public interface.
  !   Add all the tracers to be used in this module. 
  !
  subroutine user_add_tracers(tracer_list)
    type(g_tracer_type), pointer :: tracer_list


    character(len=fm_string_len), parameter :: sub_name = 'user_add_tracers'


    call g_tracer_start_param_list(package_name)!nnz: Does this append?
    call g_tracer_add_param('ice_restart_file'   , param%ice_restart_file   , 'ice_ocmip2_cfc.res.nc')
    call g_tracer_add_param('ocean_restart_file' , param%ocean_restart_file , 'ocmip2_cfc.res.nc' )
    call g_tracer_add_param('IC_file'       , param%IC_file       , '')
    call g_tracer_end_param_list(package_name)

    ! Set Restart files
    call g_tracer_set_files(ice_restart_file=param%ice_restart_file, ocean_restart_file=param%ocean_restart_file )

    !=====================================================
    !Specify all prognostic tracers of this modules.
    !=====================================================
    !User adds one call for each prognostic tracer below!
    !User should specify if fluxes must be extracted from boundary 
    !by passing one or more of the following methods as .true.  
    !and provide the corresponding parameters array
    !methods: flux_gas,flux_runoff,flux_wetdep,flux_drydep  
    !
    !prog_tracers: cfc_11,cfc_12 
    !diag_tracers: none
    !
    !cfc_12
    call g_tracer_add(tracer_list,package_name,&
         name       = 'cfc_12',               &
         longname   = 'cfc_12 Concentration', &
         units      = 'mol/kg',            &
         prog       = .true.,              &
         flux_gas       = .true.,                      &
         flux_gas_type  = 'air_sea_gas_flux_generic',                  &
         flux_gas_param = (/ 9.36e-07, 9.7561e-06 /), &
         flux_gas_restart_file  = 'ocmip2_cfc_airsea_flux.res.nc' )

    !g_cfc_11
    call g_tracer_add(tracer_list,package_name,&
         name       = 'cfc_11',               &
         longname   = 'cfc_11 Concentration', &
         units      = 'mol/kg',            &
         prog       = .true.,              &
         flux_gas       = .true.,                      &
         flux_gas_type  = 'air_sea_gas_flux_generic',                  &
         flux_gas_param = (/ 9.36e-07, 9.7561e-06 /), &
         flux_gas_restart_file  = 'ocmip2_cfc_airsea_flux.res.nc' )


  end subroutine user_add_tracers

  ! <SUBROUTINE NAME="generic_CFC_update_from_coupler">
  !  <OVERVIEW>
  !   Modify the values obtained from the coupler if necessary.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Currently an empty stub for CFCs.
  !   Some tracer fields need to be modified after values are obtained from the coupler.
  !   This subroutine is the place for specific tracer manipulations.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_CFC_update_from_coupler(tracer_list) 
  !  </TEMPLATE>
  !  <IN NAME="tracer_list" TYPE="type(g_tracer_type), pointer">
  !   Pointer to the head of generic tracer list.
  !  </IN>
  ! </SUBROUTINE>
  subroutine generic_CFC_update_from_coupler(tracer_list)
    type(g_tracer_type), pointer :: tracer_list
    character(len=fm_string_len), parameter :: sub_name = 'generic_CFC_update_from_copler'
    !
    !Nothing specific to be done for CFC's
    !
    return
  end subroutine generic_CFC_update_from_coupler

  ! <SUBROUTINE NAME="generic_CFC_update_from_source">
  !  <OVERVIEW>
  !   Update tracer concentration fields due to the source/sink contributions.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Currently an empty stub for CFCs.
  !  </DESCRIPTION>
  ! </SUBROUTINE>
  subroutine generic_CFC_update_from_source(tracer_list)
    type(g_tracer_type), pointer :: tracer_list
    !
    !No source update for CFC's currently exit in code.
    !
    return
  end subroutine generic_CFC_update_from_source

  ! <SUBROUTINE NAME="generic_CFC_set_boundary_values">
  !  <OVERVIEW>
  !   Calculate and set coupler values at the surface / bottom
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_CFC_set_boundary_values(tracer_list,SST,SSS,rho,ilb,jlb,tau)
  !  </TEMPLATE>
  !  <IN NAME="tracer_list" TYPE="type(g_tracer_type), pointer">
  !   Pointer to the head of generic tracer list.
  !  </IN>
  !  <IN NAME="ilb,jlb" TYPE="integer">
  !   Lower bounds of x and y extents of input arrays on data domain
  !  </IN>
  !  <IN NAME="SST" TYPE="real, dimension(ilb:,jlb:)">
  !   Sea Surface Temperature   
  !  </IN>
  !  <IN NAME="SSS" TYPE="real, dimension(ilb:,jlb:)">
  !   Sea Surface Salinity
  !  </IN>
  !  <IN NAME="rho" TYPE="real, dimension(ilb:,jlb:,:,:)">
  !   Ocean density
  !  </IN>
  !  <IN NAME="tau" TYPE="integer">
  !   Time step index of %field
  !  </IN>
  ! </SUBROUTINE>

  !User must provide the calculations for these boundary values.
  subroutine generic_CFC_set_boundary_values(tracer_list,ST,SSS,rho,ilb,jlb,taum1)
    type(g_tracer_type),          pointer    :: tracer_list
    real, dimension(ilb:,jlb:),     intent(in) :: ST, SSS 
    real, dimension(ilb:,jlb:,:,:), intent(in) :: rho
    integer,                        intent(in) :: ilb,jlb,taum1

    integer :: isc,iec, jsc,jec,isd,ied,jsd,jed,nk,ntau , i, j
    real    :: conv_fac,sal,ta,SST,alpha_11,alpha_12,sc_11,sc_12
    real, dimension(:,:,:)  ,pointer  :: grid_tmask
    real, dimension(:,:,:,:), pointer :: g_cfc_11_field,g_cfc_12_field
    real, dimension(:,:), ALLOCATABLE :: g_cfc_11_alpha,g_cfc_11_csurf,g_cfc_12_alpha,g_cfc_12_csurf
    real, dimension(:,:), ALLOCATABLE :: sc_no_11,sc_no_12

    character(len=fm_string_len), parameter :: sub_name = 'generic_CFC_set_boundary_values'


    !nnz: Can we treat these as source and move block to user_update_from_source?
    !
    !=============
    !Block Starts: Calculate the boundary values
    !=============
    !
    !Get the necessary properties
    !
    call g_tracer_get_common(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,grid_tmask=grid_tmask) 

    call g_tracer_get_pointer(tracer_list,'cfc_11','field',g_cfc_11_field)
    call g_tracer_get_pointer(tracer_list,'cfc_12','field',g_cfc_12_field)

    allocate(g_cfc_11_alpha(isd:ied, jsd:jed)); g_cfc_11_alpha=0.0
    allocate(g_cfc_11_csurf(isd:ied, jsd:jed)); g_cfc_11_csurf=0.0
    allocate(g_cfc_12_alpha(isd:ied, jsd:jed)); g_cfc_12_alpha=0.0
    allocate(g_cfc_12_csurf(isd:ied, jsd:jed)); g_cfc_12_csurf=0.0
    allocate(sc_no_11(isd:ied, jsd:jed))
    allocate(sc_no_12(isd:ied, jsd:jed))

    !The atmospheric code needs soluabilities in units of mol/m3/atm
    !
    !MOM
    !       The factor 1.0e+03 is for the conversion  
    !       from mol/(l * atm) to mol/(m3 * atm) 
    conv_fac = 1.0e+03
    !
    !GOLD
    !       The factor 1.e-09 converts 
    !       from mol/(l * atm) to mol/(m3 * pptv).
    !conv_fac = 1.0e-09

    do j=jsc,jec ; do i=isc,iec
       !This calculation needs an input of SST and SSS
       ta = (ST(i,j) + 273.15) * 0.01 ! Why is this in dekaKelvin?
       sal = SSS(i,j) ; SST = ST(i,j)

       !---------------------------------------------------------------------
       !     Calculate solubilities
       !       Use Warner and Weiss (1985) DSR, vol 32, final result
       !       in mol/l/atm (note, atmospheric data may be in 1 part per trillion 1e-12, pptv)
       !
       !       Use Bullister and Wisegavger for CCl4
       !---------------------------------------------------------------------

       !nnz: MOM hmask=grid_tmask(i,j,1), GOLD hmask=G%hmask 
       alpha_11 = conv_fac * grid_tmask(i,j,1) * &
            exp(param%d1_11 + param%d2_11/ta + param%d3_11*log(ta) + param%d4_11*ta*ta +&
            sal * ((param%e3_11 * ta + param%e2_11) * ta + param%e1_11)&
            )

       alpha_12 = conv_fac * grid_tmask(i,j,1) * &
            exp(param%d1_12 + param%d2_12/ta + param%d3_12*log(ta) + param%d4_12*ta*ta +&
            sal * ((param%e3_12 * ta + param%e2_12) * ta + param%e1_12)&
            )

       !---------------------------------------------------------------------
       !     Calculate Schmidt numbers
       !      use coefficients given by Zheng et al (1998), JGR vol 103, C1
       !---------------------------------------------------------------------
       sc_no_11(i,j) = param%a1_11 + SST * (param%a2_11 + SST * (param%a3_11 + SST * param%a4_11)) * &
            grid_tmask(i,j,1)
       sc_no_12(i,j) = param%a1_12 + SST * (param%a2_12 + SST * (param%a3_12 + SST * param%a4_12)) * &
            grid_tmask(i,j,1)

       !sc_no_term = sqrt(660.0 / (sc_11 + epsln))
       !
       ! In 'ocmip2_generic' atmos_ocean_fluxes.F90 coupler formulation,
       ! the schmidt number is carried in explicitly
       !
       g_cfc_11_alpha(i,j) = alpha_11              

       g_cfc_11_csurf(i,j) = g_cfc_11_field(i,j,1,taum1) *  param%Rho_0

       g_cfc_12_alpha(i,j) = alpha_12              

       g_cfc_12_csurf(i,j) = g_cfc_12_field(i,j,1,taum1) *  param%Rho_0
 
    enddo; enddo
    !=============
    !Block Ends: Calculate the boundary values
    !=============

    !
    !Set %csurf and %alpha for these tracers. This will mark them for sending fluxes to coupler
    !
    call g_tracer_set_values(tracer_list,'cfc_11','alpha',g_cfc_11_alpha,isd,jsd)
    call g_tracer_set_values(tracer_list,'cfc_11','csurf',g_cfc_11_csurf,isd,jsd)
    call g_tracer_set_values(tracer_list,'cfc_11','sc_no',sc_no_11,isd,jsd)

    call g_tracer_set_values(tracer_list,'cfc_12','alpha',g_cfc_12_alpha,isd,jsd)
    call g_tracer_set_values(tracer_list,'cfc_12','csurf',g_cfc_12_csurf,isd,jsd)
    call g_tracer_set_values(tracer_list,'cfc_12','sc_no',sc_no_12,isd,jsd)

    deallocate(g_cfc_11_alpha,g_cfc_11_csurf,g_cfc_12_alpha,g_cfc_12_csurf,sc_no_11,sc_no_12)

  end subroutine generic_CFC_set_boundary_values

  ! <SUBROUTINE NAME="generic_CFC_end">
  !  <OVERVIEW>
  !   End the module.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Deallocate all work arrays
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call generic_CFC_end
  !  </TEMPLATE>
  ! </SUBROUTINE>

  subroutine generic_CFC_end
    character(len=fm_string_len), parameter :: sub_name = 'generic_CFC_end'

  end subroutine generic_CFC_end


end module generic_CFC

module grey_radiation_mod

! ==================================================================================
! ==================================================================================

!   use utilities_mod,         only: error_mesg, open_file, file_exist, &
!                                   check_nml_error, FATAL, get_my_pe, & 
!                                   close_file, set_domain, get_num_pes, &
!                                   read_data, write_data, &
!                                   check_system_clock, NOTE, &
!                                   get_domain_decomp, check_system_clock

   use             mpp_mod,   only: input_nml_file
   use             fms_mod,   only: open_namelist_file, check_nml_error,  &
                                    mpp_pe, mpp_root_pe, close_file, &
                                    write_version_number, stdlog, file_exist

   use       constants_mod,   only: stefan, cp_air, grav

   use       astronomy_mod,   only: astronomy_init, daily_mean_solar, diurnal_solar

   use    diag_manager_mod,   only: register_diag_field, send_data

   use    time_manager_mod,   only: time_type, set_date, set_time,  &
                                    get_time,    operator(+),       &
                                    operator(-), operator(/=), get_date
 
!==================================================================================
implicit none
private
!==================================================================================

! version information 

character(len=128), parameter :: version = &
'$Id: grey_radiation.F90,v 19.0 2012/01/06 20:09:59 fms Exp $'

character(len=128), parameter :: tagname = '$Name: tikal $'

logical                       :: module_is_initialized = .false.

!==================================================================================

! public interfaces

public :: grey_radiation_init, grey_radiation, grey_radiation_end              
!==================================================================================


! module variables
character (len=*),  parameter :: module='grey_radiation_mod'

logical :: initialized =.false.
real, parameter :: p00 = 1000.e2

real    :: solar_constant  = 1360.0
real    :: del_sol         = 0.0
! modif omp: winter/summer hemisphere
real    :: del_sw          = 0.0
real    :: ir_tau_eq       = 4.0
real    :: ir_tau_pole     = 4.0
real    :: atm_abs         = 0.2
real    :: sw_diff         = 0.0
real    :: long_pert       = 180.
real    :: del_long        =  30.
real    :: size_pert       =  0.
real    :: linear_tau      = 0.1

real    :: lat_pert        = 0.0
real    :: lon_pert        = 180.0
real    :: del_lat         = 30.0
real    :: del_lon         = 90.0
real    :: fcng_pert       = 0.0

real    :: wave_amp        = 0.0
real    :: wave_lon        = 180.0
real    :: wave_lat        = 0.0
real    :: wave_del_lon    = 30.0
real    :: wave_del_lat    = 20.0
real    :: wave_period     = 20.0
real    :: wave_env        = 80.0
logical :: wave_source     = .FALSE.
integer :: n_tau           = 4
! call to astronomy to include the Seasonal Cycle
logical :: do_season       = .false.


real, save :: pi, deg_to_rad , rad_to_deg

namelist/grey_radiation_nml/ solar_constant, del_sol, &
           ir_tau_eq, ir_tau_pole, atm_abs, sw_diff, long_pert, del_long, &
           size_pert, linear_tau, del_sw,                    &
           lat_pert, lon_pert, del_lat, del_lon, fcng_pert, &
           wave_amp, wave_lon, wave_lat, wave_del_lon,      &
           wave_del_lat, wave_period, wave_env, wave_source, do_season

!==================================================================================
!-------------------- diagnostics fields -------------------------------

integer :: id_olr, id_swdn_sfc, id_swdn_toa, id_lwdn_sfc, id_lwup_sfc, &
           id_tdt_rad, id_flux_rad, id_flux_lw, id_flux_sw, id_entrop_rad, & 
           id_tsurfgrey, id_tempgrey


character(len=14), parameter :: mod_name = 'grey_radiation'

real :: missing_value = -999.


contains



! ==================================================================================
! ==================================================================================


subroutine grey_radiation_init(axes, Time)

!-------------------------------------------------------------------------------------
integer, intent(in), dimension(4) :: axes
type(time_type), intent(in)       :: Time
!-------------------------------------------------------------------------------------
integer, dimension(3) :: half = (/1,2,4/)
integer :: ierr, io, unit, logunit
!-----------------------------------------------------------------------------------------
! read namelist and copy to logfile

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=grey_radiation_nml, iostat=io)
    ierr = check_nml_error(io,'grey_radiation_nml')
#else   
    if ( file_exist('input.nml')) then
      unit = open_namelist_file ( )
      ierr=1
      do while (ierr /= 0)
        read  (unit, nml=grey_radiation_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'grey_radiation_nml')
      enddo
10    call close_file (unit)
    endif
#endif

call write_version_number(version, tagname)
if ( mpp_pe() == mpp_root_pe() ) then
  logunit = stdlog()
  write (logunit, nml=grey_radiation_nml)
endif

pi    = 4.0*atan(1.)
deg_to_rad = 2.*pi/360.
rad_to_deg = 360.0/2./pi

call astronomy_init 

initialized = .true.

!-----------------------------------------------------------------------
!------- initialize quantities for integral package -------

!       call diag_integral_field_init ('olr',    'f8.3')
!       call diag_integral_field_init ('abs_sw', 'f8.3')

!-----------------------------------------------------------------------
!------------ initialize diagnostic fields ---------------

    id_olr = &
    register_diag_field ( mod_name, 'olr', axes(1:2), Time, &
               'outgoing longwave radiation', &
               'watts/m2', missing_value=missing_value               )
    id_swdn_sfc = &
    register_diag_field ( mod_name, 'swdn_sfc', axes(1:2), Time, &
               'SW flux down at surface', &
               'watts/m2', missing_value=missing_value               )
    id_swdn_toa = &
    register_diag_field ( mod_name, 'swdn_toa', axes(1:2), Time, &
               'SW flux down at TOA', &
               'watts/m2', missing_value=missing_value               )
    id_lwup_sfc = &
    register_diag_field ( mod_name, 'lwup_sfc', axes(1:2), Time, &
               'LW flux up at surface', &
               'watts/m2', missing_value=missing_value               )

    id_lwdn_sfc = &
    register_diag_field ( mod_name, 'lwdn_sfc', axes(1:2), Time, &
               'LW flux down at surface', &
               'watts/m2', missing_value=missing_value               )

    id_tdt_rad = &
        register_diag_field ( mod_name, 'tdt_rad', axes(1:3), Time, &
               'Temperature tendency due to radiation', &
               'K/s', missing_value=missing_value               )

    id_flux_rad = &
        register_diag_field ( mod_name, 'flux_rad', axes(half), Time, &
               'Total radiative flux (positive up)', &
               'W/m^2', missing_value=missing_value               )
    id_flux_lw = &
        register_diag_field ( mod_name, 'flux_lw', axes(half), Time, &
               'Net longwave radiative flux (positive up)', &
               'W/m^2', missing_value=missing_value               )
    id_flux_sw = &
        register_diag_field ( mod_name, 'flux_sw', axes(half), Time, &
               'Net shortwave radiative flux (positive up)', &
               'W/m^2', missing_value=missing_value               )
    id_entrop_rad = &
            register_diag_field ( mod_name, 'entrop_rad', axes(1:3), Time, &
               'Entropy production by radiation', &
               '1/s', missing_value=missing_value               )

    ! rif:(09/09/09) New Diagnostics 
    id_tsurfgrey = &
    register_diag_field ( mod_name, 't_surf_rad', axes(1:2), Time, &
               'Temp surf from grey radiation', &
               'K', missing_value=missing_value               )

    id_tempgrey = &
        register_diag_field ( mod_name, 'temp_rad', axes(1:3), Time, &
               'Temperature from grey radiation', &
               'K', missing_value=missing_value               )



      module_is_initialized = .true.

return
end subroutine grey_radiation_init


! ==================================================================================

subroutine grey_radiation (is, js, Time, Time_diag, lat, lon, phalfgrey, albedo, t_surf, t, tdt, net_surf_sw_down, surf_lw_down)

integer, intent(in)                 :: is, js
type(time_type), intent(in)         :: Time, Time_diag
real, intent(in) , dimension(:,:)   :: lat, lon, albedo
real, intent(in) , dimension(:,:)   :: t_surf
real, intent(in) , dimension(:,:,:) :: t
real, intent(in) , dimension(:,:,:) :: phalfgrey
real, intent(inout), dimension(:,:,:) :: tdt
real, intent(out), dimension(:,:)   :: net_surf_sw_down, surf_lw_down

real, dimension(size(t,2)) :: ss, ss2, solar, tau_0, solar_tau_0, p2
real, dimension(size(t,1), size(t,2))              :: b_surf
real, dimension(size(t,1), size(t,2), size(t,3))   :: b, tdt_rad, entrop_rad
real, dimension(size(t,1), size(t,2), size(t,3)+1) :: up, down, net, solar_down, flux_rad, flux_sw
real, dimension(size(t,2), size(t,3)  )   :: dtrans
real, dimension(size(t,2), size(t,3)+1)   :: tau, solar_tau
real, dimension(size(t,1), size(t,2))     :: long_forcing, olr, swin

real, dimension(size(t,1), size(t,2))     :: walker_forcing

integer :: i, j, k, n

real :: cosz1, fracday1, rrsun1
real :: dist
logical :: used

n = size(t,3)

do i=1,size(t,1)
   do j=1,size(t,2)
      long_forcing(i,j) = size_pert*exp(-(rad_to_deg*lon(i,j)-long_pert)**2./ &
                         del_long**2.)
   end do
end do

do i =  1,size(t,1)
  do j = 1,size(t,2)
    dist = SQRT(((rad_to_deg*lat(i,j) - lat_pert)/del_lat)**2                   &
         + ((rad_to_deg*lon(i,j) - lon_pert)/del_lon)**2)
    if (dist .lt. 1) then
        walker_forcing(i,j) = fcng_pert*cos(pi * dist*0.5)**2;
       else
        walker_forcing(i,j) = 0.0
     end if
  end do
end do

ss  = sin(lat(1,:))
ss2 = ss*ss
p2 = (1. - 3.*ss*ss)/4.  

solar = 0.25*solar_constant*(1.0 + del_sol*p2 + del_sw * ss)

tau_0 = ir_tau_eq +(ir_tau_pole - ir_tau_eq)*ss*ss

solar_tau_0 = (1.0 - sw_diff*ss*ss)*atm_abs

b = stefan*t*t*t*t
b_surf = stefan*t_surf*t_surf*t_surf*t_surf

do k = 1, n+1

! modif df  1-23-04: changing profile of IR absorber
! modif rif 9-05-08: changed p_half to phalf for Bgrid model 
   tau(:,k)       = tau_0(:) * (linear_tau * phalfgrey(1,1,k)/p00 + (1.0 - linear_tau) &
       * (phalfgrey(1,1,k)/p00)**4)

  solar_tau(:,k) = solar_tau_0(:)*(phalfgrey(1,1,k)/p00)**4
end do

do k = 1, n
  dtrans(:,k) = exp(-(tau(:,k+1)-tau(:,k)))
end do

up(:,:,n+1) = b_surf
do k = n,1,-1
  do j = 1, size(t,2)
    up(:,j,k) = up(:,j,k+1)*dtrans(j,k) + b(:,j,k)*(1.0 - dtrans(j,k))
  end do
end do

down(:,:,1) = 0.0
do k = 1,n
  do j =1, size(t,2)
    down(:,j,k+1) = down(:,j,k)*dtrans(j,k) + b(:,j,k)*(1.0 - dtrans(j,k))
  end do
end do

if (do_season) then !Seasonal Cycle

  do j=1,size(t,2)
    call daily_mean_solar(lat(1,j),time,cosz1,fracday1,rrsun1)
    do i=1,size(t,1)
    do k=1,n+1
      solar_down(i,j,k) = cosz1*fracday1*solar_constant*rrsun1
    end do
    end do
  end do
else 

do i = 1, size(t,1)
do j = 1, size(t,2)
  do k = 1,n+1
         solar_down(i,j,k) = (walker_forcing(i,j)+long_forcing(i,j)  &
               + solar(j))*exp(-solar_tau(j,k))
  end do
end do
end do

end if !if (do_season)

do k = 1,n+1
  net(:,:,k) = up(:,:,k)-down(:,:,k)
  flux_sw(:,:,k) = albedo(:,:)*solar_down(:,:,n+1) - solar_down(:,:,k)
  flux_rad(:,:,k) = net(:,:,k) + flux_sw(:,:,k)
end do

do k = 1,n
  tdt_rad(:,:,k) = (net(:,:,k+1) - net(:,:,k) - solar_down(:,:,k+1) + solar_down(:,:,k))  &
             *grav/(cp_air*(phalfgrey(1,1,k+1)-phalfgrey(1,1,k)))
  tdt(:,:,k) = tdt(:,:,k) + tdt_rad(:,:,k)
end do



surf_lw_down     = down(:,:,n+1)
net_surf_sw_down = solar_down(:,:,n+1)*(1. - albedo(:,:))
olr = up(:,:,1)
swin = solar_down(:,:,1)


!------- t_surf grey (t_surf_greyrad) -------
      if ( id_tsurfgrey > 0 ) then
          used = send_data ( id_tsurfgrey, t_surf, Time_diag, is, js )
      endif
!------- temp grey (temp_greyrad) -------
      if ( id_tempgrey > 0 ) then
          used = send_data ( id_tempgrey, t, Time_diag, is, js, 1 )
      endif

!------- outgoing lw flux toa (olr) -------
      if ( id_olr > 0 ) then
          used = send_data ( id_olr, olr, Time_diag, is, js )
      endif
!------- downward sw flux surface -------
      if ( id_swdn_sfc > 0 ) then
          used = send_data ( id_swdn_sfc, net_surf_sw_down, Time_diag, is, js )
      endif
!------- incoming sw flux toa -------
      if ( id_swdn_toa > 0 ) then
          used = send_data ( id_swdn_toa, swin, Time_diag, is, js )
      endif
!------- upward lw flux surface -------
      if ( id_lwup_sfc > 0 ) then
          used = send_data ( id_lwup_sfc, b_surf, Time_diag, is, js )
      endif

!------- downward lw flux surface -------
      if ( id_lwdn_sfc > 0 ) then
          used = send_data ( id_lwdn_sfc, surf_lw_down, Time_diag, is, js )
      endif
!------- temperature tendency due to radiation ------------
      if ( id_tdt_rad > 0 ) then
         used = send_data ( id_tdt_rad, tdt_rad, Time_diag, is, js, 1 )
      endif
!------- total radiative flux (at half levels) -----------
      if ( id_flux_rad > 0 ) then
         used = send_data ( id_flux_rad, flux_rad, Time_diag, is, js, 1 )
      endif
!------- longwave radiative flux (at half levels) --------
      if ( id_flux_lw > 0 ) then 
         used = send_data ( id_flux_lw, net, Time_diag, is, js, 1 )
      endif
      if ( id_flux_sw > 0 ) then
         used = send_data ( id_flux_sw, flux_sw, Time_diag, is, js, 1 )
      endif
      if ( id_entrop_rad > 0 ) then
         do k=1,n 
            entrop_rad(:,:,k) =tdt_rad(:,:,k)/t(:,:,k)*phalfgrey(1,1,n+1)/1.e5
         end do
         used = send_data ( id_entrop_rad, entrop_rad, Time_diag, is, js, 1 )
      endif

return
end subroutine grey_radiation

! ==================================================================================

subroutine grey_radiation_end()

      module_is_initialized = .false.

end subroutine grey_radiation_end

! ==================================================================================

end module grey_radiation_mod

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! ice_type_mod - maintains the sea ice data, reads/writes restarts, reads the  !
!                namelist and initializes diagnostics. - Mike Winton           !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
module ice_type_mod

  use mpp_mod,          only: mpp_pe, mpp_root_pe, mpp_sum, mpp_clock_id, CLOCK_COMPONENT, &
                              CLOCK_LOOP, CLOCK_ROUTINE, stdout,input_nml_file
  use mpp_domains_mod,  only: domain2D, mpp_update_domains, CORNER, BGRID_NE
  use fms_mod,          only: file_exist, open_namelist_file, check_nml_error, write_version_number,&
                              read_data, close_file, field_exist, &
                              stderr, stdlog, error_mesg, FATAL, WARNING, NOTE, clock_flag_default
  use fms_io_mod,       only: save_restart, restore_state, query_initialized, &
                              register_restart_field, restart_file_type, set_domain, nullify_domain, &
                              parse_mask_table
  use diag_manager_mod, only: diag_axis_init, register_diag_field, &
                              register_static_field, send_data
  use time_manager_mod, only: time_type, get_time
  use coupler_types_mod,only: coupler_2d_bc_type, coupler_3d_bc_type
  use constants_mod,    only: Tfreeze, radius, pi
  use ice_grid_mod,     only: set_ice_grid, t_to_uv, ice_grid_end
  use ice_grid_mod,     only: Domain, isc, iec, jsc, jec, isd, ied, jsd, jed, im, jm, km
  use ice_grid_mod,     only: geo_lon, geo_lat, cell_area, sin_rot, cos_rot, wett, xb1d, yb1d
  use ice_grid_mod,     only: geo_lonv_ib, geo_latv_ib
  use ice_grid_mod,     only: x_cyclic, tripolar_grid, dtn, dte, wetv
  use ice_grid_mod,     only: reproduce_siena_201303
  use ice_thm_mod,      only: ice_thm_param, DI, DS, e_to_melt
  use ice_dyn_mod,      only: ice_dyn_param
  use constants_mod,    only: LI => hlf ! latent heat of fusion - 334e3 J/(kg-ice)
  use ice_bergs,        only: icebergs_init, icebergs_end, icebergs, icebergs_stock_pe
  use ice_bergs,        only: icebergs_save_restart
  use astronomy_mod,    only: astronomy_init, astronomy_end

  implicit none
  private

public :: ice_data_type, ice_model_init, ice_model_end, ice_stock_pe, kmelt,  &
          mom_rough_ice, heat_rough_ice, atmos_winds, hlim, slab_ice,         &
          spec_ice, verbose, ice_bulk_salin, do_ice_restore, do_ice_limit,    &
          max_ice_limit, ice_restore_timescale, do_init, h2o, heat, slp2ocean,&
          cm2_bugs, conservation_check, do_icebergs, ice_model_restart,       &
          add_diurnal_sw, channel_viscosity, smag_ocn, ssh_gravity,           &
          chan_cfl_limit, ice_data_type_chksum
public :: do_sun_angle_for_alb

public  :: id_cn, id_hi, id_hs, id_t1, id_t2, id_ts
public  :: id_mi, id_sh, id_lh, id_sw, id_lw, id_snofl, id_rain, id_runoff,    &
           id_calving, id_runoff_hflx, id_calving_hflx,                        &
           id_evap, id_saltf, id_tmelt, id_bmelt, id_bheat, id_e2m,            &
           id_frazil, id_alb, id_xprt, id_lsrc, id_lsnk, id_bsnk, id_strna,    &
           id_sigi, id_sigii, id_stren, id_ui, id_vi, id_fax, id_fay, id_fix,  &
           id_fiy, id_fcx, id_fcy, id_fwx, id_fwy, id_swdn, id_lwdn, id_sn2ic, &
           id_slp, id_ext, id_sst, id_sss, id_ssh, id_uo, id_vo, id_ta, id_obi,&
           id_qfres, id_qflim, id_ix_trans, id_iy_trans,                       &
           id_sw_vis, id_sw_dir, id_sw_dif, id_sw_vis_dir, id_sw_vis_dif,      &
           id_sw_nir_dir, id_sw_nir_dif, id_mib, id_ustar, id_vstar, id_vocean,&
           id_uocean, id_vchan, id_uchan, id_wnd

public  :: id_alb_vis_dir, id_alb_vis_dif,id_alb_nir_dir, id_alb_nir_dif

public  :: iceClock,iceClock1,iceClock2,iceClock3,iceClock4,iceClock5,iceClock6,iceClock7,iceClock8,iceClock9
public  :: iceClocka,iceClockb,iceClockc

  character(len=128) :: version = '$Id: ice_type.F90,v 20.0 2013/12/13 23:28:32 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

  !---- id for diagnositics -------------------
  integer :: id_xb, id_xt, id_yb, id_yt, id_ct, id_xv, id_yv
  integer :: id_cn, id_hi, id_hs, id_t1, id_t2, id_ts
  integer :: id_mi, id_sh, id_lh, id_sw, id_lw, id_snofl, id_rain
  integer :: id_runoff, id_calving, id_runoff_hflx, id_calving_hflx
  integer :: id_evap, id_saltf, id_tmelt, id_bmelt, id_bheat, id_e2m
  integer :: id_frazil, id_alb, id_xprt, id_lsrc, id_lsnk, id_bsnk, id_strna
  integer :: id_sigi, id_sigii, id_stren, id_ui, id_vi, id_fax, id_fay, id_fix
  integer :: id_fiy, id_fcx, id_fcy, id_fwx, id_fwy, id_swdn, id_lwdn, id_sn2ic
  integer :: id_slp, id_ext, id_sst, id_sss, id_ssh, id_uo, id_vo, id_ta, id_obi
  integer :: id_qfres, id_qflim, id_ix_trans, id_iy_trans
  integer :: id_sw_vis, id_sw_dir, id_sw_dif, id_sw_vis_dir, id_sw_vis_dif
  integer :: id_sw_nir_dir, id_sw_nir_dif, id_mib, id_ustar, id_vstar
  integer :: id_vocean, id_uocean, id_vchan, id_uchan
  integer :: id_alb_vis_dir, id_alb_vis_dif, id_alb_nir_dir, id_alb_nir_dif 
  integer :: id_wnd 

  !--- namelist interface --------------
  real    :: mom_rough_ice  = 1.0e-4     ! momentum same, cd10=(von_k/ln(10/z0))^2
  real    :: heat_rough_ice = 1.0e-4     ! heat roughness length
  real    :: kmelt          = 6e-5*4e6   ! ocean/ice heat flux constant
  real    :: ks             = 0.31       ! snow conductivity (W/mK)
  real    :: alb_sno        = 0.85       ! snow albedo (less if melting)
  real    :: alb_ice        = 0.5826     ! ice albedo (less if melting)
  real    :: pen_ice        = 0.3        ! part unreflected solar penetrates ice
  real    :: opt_dep_ice    = 0.67       ! ice optical depth
  real    :: t_range_melt   = 1.0        ! melt albedos scaled in over T range
  real    :: ice_bulk_salin = 0.0        ! ice bulk salinity (for ocean salt flux)
  real    :: p0             = 2.75e4     ! ice strength parameter
  real    :: c0             = 20.0       ! another ice strength parameter
  real    :: cdw            = 3.24e-3    ! water/ice drag coefficient
  real    :: wd_turn        = 25.0       ! water/ice drag turning angle
  real    :: h_lo_lim       = 0.0        ! min ice thickness for temp. calc.
  integer :: nsteps_dyn     = 432        ! dynamics steps per slow timestep
  integer :: nsteps_adv     = 8          ! advection steps per slow timestep
  integer :: num_part       = 6          ! number of ice grid partitions
                                         ! partition 1 is open water
                                         ! partitions 2 to num_part-1 are
                                         !   thickness limited ice categories
                                         ! partition num_part is unlimited ice
  logical :: atmos_winds = .true.        ! wind stress from atmosphere model over t points and has wrong sign
  logical :: slab_ice    = .false.       ! do old-style GFDL slab ice?
  logical :: spec_ice    = .false.       ! old-style GFDL slab ice with SST, ice thickness and conc. from data
  logical :: do_ice_restore  = .false.   ! restore sea-ice toward climatology
  logical :: do_ice_limit    = .false.   ! limit sea ice to max_ice_limit
  real    :: max_ice_limit   = 4.0       ! maximum sea ice height(m),
                                         ! if do_ice_limit is true
                                         ! TK: default chosen based on observed
                                         !     ice thickness data used by climate
                                         !     group, which range up to 7.31 m
  real    :: ice_restore_timescale = 5.0 ! time scale for restoring ice (days)
  logical :: conservation_check = .true. ! check for heat and h2o conservation
  logical :: slp2ocean          = .false.! apply sea level pressure to ocean surface
  logical :: cm2_bugs           = .false.! keep cm2 bugs for reproducibility        
  logical :: verbose            = .false.! control printing message, will slow model down when turn true
  logical :: do_icebergs        = .false.! call iceberg code to modify calving field
  logical :: add_diurnal_sw     = .false.! apply an additional diurnal cycle to shortwave radiation
  real    :: channel_viscosity  = 0.     ! viscosity used in one-cell wide channels to parameterize transport (m^2/s)
  real    :: smag_ocn           = 0.15   ! Smagorinksy coefficient for viscosity (dimensionless)
  real    :: ssh_gravity        = 9.81   ! Gravity parameter used in channel viscosity parameterization (m/s^2)
  real    :: chan_cfl_limit     = 0.25   ! CFL limit for channel viscosity parameterization (dimensionless)
  logical :: do_sun_angle_for_alb = .false.! find the sun angle for ocean albed in the frame of the ice model
  integer :: layout(2)          = (/0, 0/)
  integer :: io_layout(2)       = (/0, 0/)
  ! mask_table contains information for masking domain ( n_mask, layout and mask_list).
  !   A text file to specify n_mask, layout and mask_list to reduce number of processor
  !   usage by masking out some domain regions which contain all land points. 
  !   The default file name of mask_table is "INPUT/ice_mask_table". Please note that 
  !   the file name must begin with "INPUT/". The first 
  !   line of mask_table will be number of region to be masked out. The second line 
  !   of the mask_table will be the layout of the model. User need to set ice_model_nml
  !   variable layout to be the same as the second line of the mask table.
  !   The following n_mask line will be the position of the processor to be masked out.
  !   The mask_table could be created by tools check_mask. 
  !   For example the mask_table will be as following if n_mask=2, layout=4,6 and 
  !   the processor (1,2) and (3,6) will be masked out. 
  !     2
  !     4,6
  !     1,2
  !     3,6

  character(len=128) :: mask_table = "INPUT/ice_mask_table"


  namelist /ice_model_nml/ mom_rough_ice, heat_rough_ice, p0, c0, cdw, wd_turn,  &
                           kmelt, alb_sno, alb_ice, pen_ice, opt_dep_ice,        &
                           nsteps_dyn, nsteps_adv, num_part, atmos_winds,        &
                           slab_ice, spec_ice, ice_bulk_salin, layout,           &
                           do_ice_restore, do_ice_limit, max_ice_limit,          &
                           ice_restore_timescale, slp2ocean, conservation_check, &
                           t_range_melt, cm2_bugs, ks, h_lo_lim, verbose,        &
                           do_icebergs, add_diurnal_sw, io_layout, channel_viscosity,&
                           smag_ocn, ssh_gravity, chan_cfl_limit, do_sun_angle_for_alb, &
                           mask_table, reproduce_siena_201303

  logical :: do_init = .false.
  real    :: hlim(8) = (/ 0.0, 0.1, 0.3, 0.7, 1.1, 1.5, 2.0, 2.5 /) ! thickness limits 1...num_part-1
  real    :: h2o(4), heat(4) ! for conservation analysis
                             ! 1 - initial ice h2o/heat content
                             ! 2 - h2o/heat flux down at top of ice
                             ! 3 - h2o/heat flux down at bottom of ice
                             ! 4 - final ice h2o/heat content

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! This structure contains the ice model data (some used by calling routines);  !
  ! the third index is partition (1 is open water; 2 is ice cover)               !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  type ice_data_type
     type(domain2D)                     :: Domain
     type (time_type)                   :: Time_Init, Time
     type (time_type)                   :: Time_step_fast, Time_step_slow
     integer                            :: avg_kount
     logical                            :: pe
     integer, pointer, dimension(:)     :: pelist              =>NULL() ! Used for flux-exchange.
     logical, pointer, dimension(:,:)   :: mask                =>NULL() ! where ice can be
     logical, pointer, dimension(:,:,:) :: ice_mask            =>NULL() ! where ice actually is
     real,    pointer, dimension(:,:,:) :: part_size           =>NULL()
     real,    pointer, dimension(:,:,:) :: part_size_uv        =>NULL()
     real,    pointer, dimension(:,:,:) :: albedo              =>NULL()
     real,    pointer, dimension(:,:,:) :: albedo_vis_dir      =>NULL()
     real,    pointer, dimension(:,:,:) :: albedo_nir_dir      =>NULL()
     real,    pointer, dimension(:,:,:) :: albedo_vis_dif      =>NULL()
     real,    pointer, dimension(:,:,:) :: albedo_nir_dif      =>NULL()
     real,    pointer, dimension(:,:,:) :: rough_mom           =>NULL()
     real,    pointer, dimension(:,:,:) :: rough_heat          =>NULL()
     real,    pointer, dimension(:,:,:) :: rough_moist         =>NULL()
     real,    pointer, dimension(:,:,:) :: t_surf              =>NULL()
     real,    pointer, dimension(:,:,:) :: u_surf              =>NULL()
     real,    pointer, dimension(:,:,:) :: v_surf              =>NULL()
     real,    pointer, dimension(:,:)   :: sea_lev             =>NULL()
     real,    pointer, dimension(:,:)   :: s_surf              =>NULL()
     real,    pointer, dimension(:,:)   :: u_ocn               =>NULL()
     real,    pointer, dimension(:,:)   :: v_ocn               =>NULL()
     real,    pointer, dimension(:,:,:) :: flux_u_top          =>NULL()
     real,    pointer, dimension(:,:,:) :: flux_v_top          =>NULL()
     real,    pointer, dimension(:,:,:) :: flux_u_top_bgrid    =>NULL()
     real,    pointer, dimension(:,:,:) :: flux_v_top_bgrid    =>NULL()
     real,    pointer, dimension(:,:,:) :: flux_t_top          =>NULL()
     real,    pointer, dimension(:,:,:) :: flux_q_top          =>NULL()
     real,    pointer, dimension(:,:,:) :: flux_lw_top         =>NULL()
     real,    pointer, dimension(:,:,:) :: flux_sw_vis_dir_top =>NULL()
     real,    pointer, dimension(:,:,:) :: flux_sw_vis_dif_top =>NULL()
     real,    pointer, dimension(:,:,:) :: flux_sw_nir_dir_top =>NULL()
     real,    pointer, dimension(:,:,:) :: flux_sw_nir_dif_top =>NULL()
     real,    pointer, dimension(:,:,:) :: flux_lh_top         =>NULL()
     real,    pointer, dimension(:,:,:) :: lprec_top           =>NULL()
     real,    pointer, dimension(:,:,:) :: fprec_top           =>NULL()
     real,    pointer, dimension(:,:  ) :: flux_u              =>NULL()
     real,    pointer, dimension(:,:  ) :: flux_v              =>NULL()
     real,    pointer, dimension(:,:  ) :: flux_t              =>NULL()
     real,    pointer, dimension(:,:  ) :: flux_q              =>NULL()
     real,    pointer, dimension(:,:  ) :: flux_lw             =>NULL()
     real,    pointer, dimension(:,:  ) :: flux_sw_vis_dir     =>NULL()
     real,    pointer, dimension(:,:  ) :: flux_sw_vis_dif     =>NULL()
     real,    pointer, dimension(:,:  ) :: flux_sw_nir_dir     =>NULL()
     real,    pointer, dimension(:,:  ) :: flux_sw_nir_dif     =>NULL()
     real,    pointer, dimension(:,:  ) :: flux_lh             =>NULL()
     real,    pointer, dimension(:,:  ) :: lprec               =>NULL()
     real,    pointer, dimension(:,:  ) :: fprec               =>NULL()
     real,    pointer, dimension(:,:  ) :: p_surf              =>NULL()
     real,    pointer, dimension(:,:  ) :: runoff              =>NULL()
     real,    pointer, dimension(:,:  ) :: calving             =>NULL()
     real,    pointer, dimension(:,:  ) :: runoff_hflx         =>NULL()
     real,    pointer, dimension(:,:  ) :: calving_hflx        =>NULL()
     real,    pointer, dimension(:,:  ) :: flux_salt           =>NULL()
     real,    pointer, dimension(:,:)   :: lwdn                =>NULL()
     real,    pointer, dimension(:,:  ) :: swdn                =>NULL() ! downward long/shortwave
     real,    pointer, dimension(:,:,:) :: pen                 =>NULL()
     real,    pointer, dimension(:,:,:) :: trn                 =>NULL() ! ice optical parameters
     real,    pointer, dimension(:,:,:) :: tmelt               =>NULL()
     real,    pointer, dimension(:,:,:) :: bmelt               =>NULL()
     real,    pointer, dimension(:,:,:) :: h_snow              =>NULL()
     real,    pointer, dimension(:,:,:) :: h_ice               =>NULL()
     real,    pointer, dimension(:,:,:) :: t_ice1              =>NULL()
     real,    pointer, dimension(:,:,:) :: t_ice2              =>NULL()
     real,    pointer, dimension(:,:)   :: u_ice               =>NULL()
     real,    pointer, dimension(:,:)   :: v_ice               =>NULL()
     real,    pointer, dimension(:,:)   :: sig11               =>NULL()
     real,    pointer, dimension(:,:)   :: sig22               =>NULL()
     real,    pointer, dimension(:,:)   :: sig12               =>NULL()
     real,    pointer, dimension(:,:)   :: frazil              =>NULL()
     real,    pointer, dimension(:,:)   :: bheat               =>NULL()
     real,    pointer, dimension(:,:)   :: qflx_lim_ice        =>NULL()
     real,    pointer, dimension(:,:)   :: qflx_res_ice        =>NULL()
     real,    pointer, dimension(:,:)   :: area                =>NULL()
     real,    pointer, dimension(:,:)   :: vmask               =>NULL() ! where ice vels can be non-zero
     real,    pointer, dimension(:,:)   :: mi                  =>NULL() ! This is needed for the wave model. It is introduced here,
                                                                        ! because flux_ice_to_ocean cannot handle 3D fields. This may be
									! removed, if the information on ice thickness can be derived from 
									! eventually from h_ice outside the ice module.
     real,    pointer, dimension(:,:,:) :: wnd                 =>NULL() ! need 10m wind speed to deduce Stokes drift etc in QL_KF_17
     logical, pointer, dimension(:,:)   :: maskmap             =>NULL() ! A pointer to an array indicating which
                                                                        ! logical processors are actually used for
                                                                        ! the ocean code. The other logical
                                                                        ! processors would be all land points and
                                                                        ! are not assigned to actual processors.
                                                                        ! This need not be assigned if all logical
                                                                        ! processors are used
     integer, dimension(3)              :: axes
     type(coupler_3d_bc_type)           :: ocean_fields       ! array of fields used for additional tracers
     type(coupler_2d_bc_type)           :: ocean_fluxes       ! array of fluxes used for additional tracers
     type(coupler_3d_bc_type)           :: ocean_fluxes_top   ! array of fluxes for averaging
     type(icebergs), pointer            :: icebergs

  end type ice_data_type

  integer :: iceClock, iceClock1, iceCLock2, iceCLock3, iceClock4, iceClock5, &
             iceClock6, iceClock7, iceClock8, iceClock9, iceClocka, iceClockb, iceClockc
  type(restart_file_type), save :: Ice_restart

  contains

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! ice_stock_pe - returns stocks of heat, water, etc. for conservation checks   !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine ice_stock_pe(Ice, index, value)

    use stock_constants_mod, only : ISTOCK_WATER, ISTOCK_HEAT, ISTOCK_SALT

    use ice_grid_mod, only : all_avg

    type(ice_data_type)    :: Ice
    integer, intent(in) :: index
    real, intent(out)   :: value

    integer :: i, j, k
    real :: icebergs_value

    value = 0.0
    if(.not.Ice%pe) return

    select case (index)

    case (ISTOCK_WATER)

       value = sum(cell_area*all_avg(DI*Ice%h_ice(isc:iec,jsc:jec,:)+   &
            DS*Ice%h_snow(isc:iec,jsc:jec,:),  &
            Ice%part_size(isc:iec,jsc:jec,:))) &
            *4*pi*radius*radius 
  
    case (ISTOCK_HEAT)

       value = 0.0
       do k=2,km
          do j=jsc, jec
             do i=isc, iec
                if ((Ice%part_size(i,j,k)>0.0.and.Ice%h_ice(i,j,k)>0.0)) then
                   if (slab_ice) then
                      value = value - cell_area(i,j) * Ice%part_size(i,j,k)*Ice%h_ice(i,j,2)*DI*LI
                   else
                      value = value - cell_area(i,j) * Ice%part_size(i,j,k)*e_to_melt(Ice%h_snow(i,j,k), &
                                Ice%h_ice(i,j,k)/2, Ice%t_ice1(i,j,k), Ice%h_ice(i,j,k)/2, Ice%t_ice2(i,j,k))
                   end if
                end if
             end do
          end do
       end do
       value = value*4*pi*radius*radius

    case (ISTOCK_SALT)
       !No salt in the h_snow component.
       value =  sum(cell_area*all_avg(DI*Ice%h_ice(isc:iec,jsc:jec,:),Ice%part_size(isc:iec,jsc:jec,:))) &
              *ice_bulk_salin*4*pi*radius*radius
    case default

       value = 0.0

    end select

    if (do_icebergs) then
      call icebergs_stock_pe(Ice%icebergs, index, icebergs_value)
      value = value + icebergs_value
    endif

  end subroutine ice_stock_pe

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! ice_model_init - initializes ice model data, parameters and diagnostics      !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine ice_model_init (Ice, Time_Init, Time, Time_step_fast, Time_step_slow )

    type (ice_data_type), intent(inout) :: Ice
    type (time_type)    , intent(in)    :: Time_Init      ! starting time of model integration
    type (time_type)    , intent(in)    :: Time           ! current time
    type (time_type)    , intent(in)    :: Time_step_fast ! time step for the ice_model_fast
    type (time_type)    , intent(in)    :: Time_step_slow ! time step for the ice_model_slow

    integer           :: io, ierr, nlon, nlat, npart, unit, log_unit, k
    integer           :: sc, dy, i, j
    integer           :: id_restart, id_restart_albedo, id_restart_flux_sw
    real              :: dt_slow
    character(len=64) :: restart_file
    integer           :: stdlogunit, stdoutunit

    stdlogunit=stdlog()
    stdoutunit = stdout()
    !
    ! read namelist and write to logfile
    !
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ice_model_nml, iostat=io)
#else
    unit = open_namelist_file()
    read  (unit, ice_model_nml,iostat=io)
    call close_file (unit)
#endif
    ierr = check_nml_error(io,'ice_model_nml')
    write (stdoutunit,'(/)')
    write (stdoutunit, ice_model_nml)
    write (stdlogunit, ice_model_nml)

    call write_version_number(version, tagname)

    if (spec_ice) then
       slab_ice = .true.
       nsteps_dyn = 0
       nsteps_adv = 0
    end if
    if (slab_ice) num_part = 2 ! open water and ice ... but never in same place
    if (num_part>size(hlim(:))+1) &
         call error_mesg ('ice_model_init', 'not enough thickness limits', FATAL)

    call get_time(Time_step_slow, sc, dy); dt_slow=864e2*dy+sc

    if(file_exist(mask_table)) then
       write(stdoutunit, *) '==> NOTE from ice_model_init:  reading maskmap information from '//trim(mask_table)
       if(layout(1) == 0 .OR. layout(2) == 0 ) call error_mesg('ice_model_init', &
          'ice_model_nml layout should be set when file '//trim(mask_table)//' exists', FATAL)

       allocate(Ice%maskmap(layout(1), layout(2)))
       call parse_mask_table(mask_table, Ice%maskmap, "Ice model")
    endif

    if( ASSOCIATED(Ice%maskmap) ) then
       call set_ice_grid(Ice%domain, dt_slow, nsteps_dyn, nsteps_adv, num_part, layout, io_layout, Ice%maskmap  )
    else
       call set_ice_grid(Ice%domain, dt_slow, nsteps_dyn, nsteps_adv, num_part, layout, io_layout )
    end if
    call set_domain(domain)

    call ice_dyn_param(p0, c0, cdw, wd_turn, slab_ice)
    call ice_thm_param(alb_sno, alb_ice, pen_ice, opt_dep_ice, slab_ice, &
                       t_range_melt, cm2_bugs, ks, h_lo_lim)

    allocate ( Ice % mask     (isc:iec, jsc:jec)       , &
         Ice % ice_mask       (isc:iec, jsc:jec, km)   , &
         Ice % t_surf         (isc:iec, jsc:jec, km)   , &
         Ice % s_surf         (isc:iec, jsc:jec)       , &
         Ice % vmask          (isd:ied, jsd:jed)       , &
         Ice % sea_lev        (isd:ied, jsd:jed)       , &
         Ice % part_size      (isd:ied, jsd:jed, km)   , &
         Ice % part_size_uv   (isc:iec, jsc:jec, km)   , &
         Ice % wnd            (isc:iec, jsc:jec, km)   , &
         Ice % u_surf         (isc:iec, jsc:jec, km)   , &
         Ice % v_surf         (isc:iec, jsc:jec, km)   , &
         Ice % u_ocn          (isd:ied, jsd:jed)       , &
         Ice % v_ocn          (isd:ied, jsd:jed)       , &
         Ice % rough_mom      (isc:iec, jsc:jec, km)   , &
         Ice % rough_heat     (isc:iec, jsc:jec, km)   , &
         Ice % rough_moist    (isc:iec, jsc:jec, km)   , &
         Ice % albedo         (isc:iec, jsc:jec, km)   , &                
         Ice % albedo_vis_dir (isc:iec, jsc:jec, km)   , &
         Ice % albedo_nir_dir (isc:iec, jsc:jec, km)   , &
         Ice % albedo_vis_dif (isc:iec, jsc:jec, km)   , &
         Ice % albedo_nir_dif (isc:iec, jsc:jec, km)   )

    allocate ( Ice % flux_u_top   (isd:ied, jsd:jed, km) ,       &
         Ice % flux_v_top         (isd:ied, jsd:jed, km) ,       &
         Ice % flux_t_top         (isc:iec, jsc:jec, km) ,       &
         Ice % flux_q_top         (isc:iec, jsc:jec, km) ,       &
         Ice % flux_sw_vis_dir_top(isc:iec, jsc:jec, km) ,       &
         Ice % flux_sw_vis_dif_top(isc:iec, jsc:jec, km) ,       &
         Ice % flux_sw_nir_dir_top(isc:iec, jsc:jec, km) ,       &
         Ice % flux_sw_nir_dif_top(isc:iec, jsc:jec, km) ,       &
         Ice % flux_lw_top        (isc:iec, jsc:jec, km) ,       &
         Ice % flux_lh_top        (isc:iec, jsc:jec, km) ,       &
         Ice % lprec_top          (isc:iec, jsc:jec, km) ,       &
         Ice % fprec_top          (isc:iec, jsc:jec, km)   )

    allocate ( Ice % flux_u_top_bgrid   (isc:iec, jsc:jec, km) , &
         Ice % flux_v_top_bgrid         (isc:iec, jsc:jec, km)   )

    allocate ( Ice % flux_u    (isc:iec, jsc:jec ) ,       &
         Ice % flux_v          (isc:iec, jsc:jec ) ,       &
         Ice % flux_t          (isc:iec, jsc:jec ) ,       &
         Ice % flux_q          (isc:iec, jsc:jec ) ,       &
         Ice % flux_sw_vis_dir (isc:iec, jsc:jec) ,        &
         Ice % flux_sw_vis_dif (isc:iec, jsc:jec) ,        &
         Ice % flux_sw_nir_dir (isc:iec, jsc:jec) ,        &
         Ice % flux_sw_nir_dif (isc:iec, jsc:jec) ,        &
         Ice % flux_lw         (isc:iec, jsc:jec ) ,       &
         Ice % flux_lh         (isc:iec, jsc:jec ) ,       &
         Ice % lprec           (isc:iec, jsc:jec ) ,       &
         Ice % fprec           (isc:iec, jsc:jec ) ,       &
         Ice % p_surf          (isc:iec, jsc:jec ) ,       &
         Ice % runoff          (isc:iec, jsc:jec ) ,       &
         Ice % calving         (isc:iec, jsc:jec ) ,       &
         Ice % runoff_hflx     (isc:iec, jsc:jec ) ,       &
         Ice % calving_hflx    (isc:iec, jsc:jec ) ,       &
         Ice % flux_salt       (isc:iec, jsc:jec ) ,       &
         Ice % lwdn            (isc:iec, jsc:jec ) ,       &
         Ice % swdn            (isc:iec, jsc:jec )         )
    allocate ( Ice % frazil (isc:iec, jsc:jec), Ice % bheat  (isc:iec, jsc:jec), &
               Ice % u_ice  (isd:ied, jsd:jed), Ice % v_ice  (isd:ied, jsd:jed), &
               Ice % sig11  (isd:ied, jsd:jed), Ice % sig22  (isd:ied, jsd:jed), &
               Ice % sig12  (isd:ied, jsd:jed)                               )
    allocate ( Ice % tmelt  (isc:iec, jsc:jec, 2:km), Ice % bmelt  (isc:iec, jsc:jec, 2:km) , &
               Ice % pen    (isc:iec, jsc:jec, 2:km), Ice % trn    (isc:iec, jsc:jec, 2:km) , &
               Ice % h_snow (isd:ied, jsd:jed, 2:km), Ice % h_ice  (isd:ied, jsd:jed, 2:km) , &
               Ice % t_ice1 (isd:ied, jsd:jed, 2:km), Ice % t_ice2 (isd:ied, jsd:jed, 2:km)   )
    allocate ( Ice % qflx_lim_ice  (isc:iec, jsc:jec) , Ice % qflx_res_ice  (isc:iec, jsc:jec)   )
    allocate ( Ice % area          (isc:iec, jsc:jec) )
    allocate ( Ice % mi            (isc:iec, jsc:jec) )

    Ice % flux_sw_vis_dir =0.
    Ice % flux_sw_vis_dif =0.
    Ice % flux_sw_nir_dir =0.
    Ice % flux_sw_nir_dif =0.
    Ice % flux_lh         =0. 
    Ice % lwdn            =0.
    Ice % swdn            =0.
    Ice % flux_u_top      =0. 
    Ice % flux_v_top      =0.
    Ice % flux_u_top_bgrid=0. 
    Ice % flux_v_top_bgrid=0.
    Ice % sea_lev         =0.
    Ice % part_size       =0.
    Ice % wnd             =0.
    Ice % u_ocn           =0.
    Ice % v_ocn           =0.
    Ice % u_ice           =0.
    Ice % v_ice           =0.
    Ice % sig11           =0.
    Ice % sig12           =0.
    Ice % sig22           =0.
    Ice % h_snow          =0.
    Ice % h_ice           =0.
    Ice % t_ice1          =0.
    Ice % t_ice2          =0.
    Ice % area            = cell_area * 4*PI*RADIUS*RADIUS
    Ice % mi              =0.
    Ice % u_surf          =0.
    Ice % v_surf          =0.
    Ice % s_surf          =0.
    Ice % flux_t_top      =0.
    Ice % flux_q_top      =0.
    Ice % flux_lw_top     =0.
    Ice % flux_sw_vis_dir_top =0.
    Ice % flux_sw_vis_dif_top =0.
    Ice % flux_sw_nir_dir_top =0.
    Ice % flux_sw_nir_dif_top =0.
    Ice % flux_lh_top     =0.
    Ice % lprec_top       =0.
    Ice % fprec_top       =0.
    Ice % flux_salt       =0.
    Ice % pen             =0.
    Ice % trn             =0.
    Ice % bheat           =0.


    do j = jsc, jec
       do i = isc, iec
          if( wett(i,j) > 0.5 ) then
             Ice % mask(i,j) = .true.
          else
             Ice % mask(i,j) = .false.
          end if
          if( wetv(i,j) > 0.5 ) then
             Ice % vmask(i,j) = 1.
          else
             Ice % vmask(i,j) = 0.
          end if
       enddo
    enddo
    if(reproduce_siena_201303) then
       call mpp_update_domains(Ice%vmask, domain=domain )
    else
       call mpp_update_domains(Ice%vmask, domain=domain, position=CORNER )
    endif

    Ice % Time           = Time
    Ice % Time_Init      = Time_Init
    Ice % Time_step_fast = Time_step_fast
    Ice % Time_step_slow = Time_step_slow

    Ice % avg_kount      = 0
    !
    ! read restart
    !
    !! Need to create new restart version including the needed albedos
    !  that have been added ??

    !--- 
    restart_file = 'ice_model.res.nc'
    id_restart = register_restart_field(Ice_restart, restart_file, 'part_size', Ice%part_size, domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'albedo',    Ice%albedo,    domain=domain)
    id_restart_albedo = register_restart_field(Ice_restart, restart_file, 'albedo_vis_dir', Ice%albedo_vis_dir, &
                                               domain=domain, mandatory=.false.)
    id_restart        = register_restart_field(Ice_restart, restart_file, 'albedo_nir_dir', Ice%albedo_nir_dir, &
                                               domain=domain, mandatory=.false.)
    id_restart        = register_restart_field(Ice_restart, restart_file, 'albedo_vis_dif', Ice%albedo_vis_dif, &
                                               domain=domain, mandatory=.false.)
    id_restart        = register_restart_field(Ice_restart, restart_file, 'albedo_nir_dif', Ice%albedo_nir_dif, &
                                               domain=domain, mandatory=.false.)
    id_restart = register_restart_field(Ice_restart, restart_file, 'rough_mom',   Ice%rough_mom,        domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'rough_heat',  Ice%rough_heat,       domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'rough_moist', Ice%rough_moist,      domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 't_surf',      Ice%t_surf,           domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'h_snow',      Ice%h_snow(:,:,2:km), domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'h_ice',       Ice%h_ice(:,:,2:km),  domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 't_ice1',      Ice%t_ice1(:,:,2:km), domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 't_ice2',      Ice%t_ice2(:,:,2:km), domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'u_ice',       Ice%u_ice,            domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'v_ice',       Ice%v_ice,            domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'sig11',       Ice%sig11,            domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'sig22',       Ice%sig22,            domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'sig12',       Ice%sig12,            domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'flux_u',      Ice%flux_u,           domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'flux_v',      Ice%flux_v,           domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'flux_t',      Ice%flux_t,           domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'flux_q',      Ice%flux_q,           domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'flux_salt',   Ice%flux_salt,        domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'flux_lw',     Ice%flux_lw,          domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'lprec',       Ice%lprec,            domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'fprec',       Ice%fprec,            domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'runoff',      Ice%runoff,           domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'calving',     Ice%calving,          domain=domain)
    id_restart = register_restart_field(Ice_restart, restart_file, 'runoff_hflx', Ice%runoff_hflx,      domain=domain, mandatory=.false.)
    id_restart = register_restart_field(Ice_restart, restart_file, 'calving_hflx',Ice%calving_hflx,     domain=domain, mandatory=.false.)
    id_restart = register_restart_field(Ice_restart, restart_file, 'p_surf',      Ice%p_surf,           domain=domain)
    id_restart         = register_restart_field(Ice_restart, restart_file, 'flux_sw_vis_dir', Ice%flux_sw_vis_dir, &
                                                domain=domain, mandatory=.false.)    
    id_restart         = register_restart_field(Ice_restart, restart_file, 'flux_sw_vis_dif', Ice%flux_sw_vis_dif, &
                                                domain=domain, mandatory=.false.)
    id_restart_flux_sw = register_restart_field(Ice_restart, restart_file, 'flux_sw_nir_dir', Ice%flux_sw_nir_dir, &
                                                domain=domain, mandatory=.false.)
    id_restart         = register_restart_field(Ice_restart, restart_file, 'flux_sw_nir_dif', Ice%flux_sw_nir_dif, &
                                                domain=domain, mandatory=.false.)
!
!        Total SW flux is broken into 4 components in Nalanda,
!        it was a single component preNalanda.
!
    restart_file = 'INPUT/ice_model.res.nc'
    if (file_exist(restart_file)) then
       call restore_state(Ice_restart)
       if( .NOT. query_initialized(Ice_restart, id_restart_albedo)) then
          Ice % albedo_vis_dir    = 0.0         
          Ice % albedo_nir_dir    = 0.0       
          Ice % albedo_vis_dif    = 0.0       
          Ice % albedo_nir_dif    = 0.0       
       endif

       if(.NOT. query_initialized(Ice_restart, id_restart_flux_sw) ) then 
          call error_mesg ('ice_model_init', &
            'Restart file does not contain flux_sw_* subcomponents!', WARNING)
          ! for compatibility with preN restarts, we should check for total SW flux 
          if(field_exist(restart_file,'flux_sw')) then
             call read_data( restart_file, 'flux_sw',Ice%flux_sw_vis_dir , domain ) 
             ! simplest way to brake the total flux to 4 components
             Ice % flux_sw_vis_dir = Ice%flux_sw_vis_dir / 4
             Ice % flux_sw_vis_dif = Ice%flux_sw_vis_dir
             Ice % flux_sw_nir_dir = Ice%flux_sw_vis_dir
             Ice % flux_sw_nir_dif = Ice%flux_sw_vis_dir
          else
             call error_mesg ('ice_model_init', &
                  'Restart file does not contain flux_sw total or its components!', FATAL)
          endif
       endif

       !--- update to data domain
       call mpp_update_domains(Ice%part_size, Domain)
       call mpp_update_domains(Ice%h_snow(:,:,2:km), Domain )
       call mpp_update_domains(Ice%h_ice (:,:,2:km), Domain )
       call mpp_update_domains(Ice%t_ice1(:,:,2:km), Domain )
       call mpp_update_domains(Ice%t_ice2(:,:,2:km), Domain )
       if(reproduce_siena_201303) then
          call mpp_update_domains(Ice%u_ice, Domain )
          call mpp_update_domains(Ice%v_ice, Domain )
       else
          call mpp_update_domains(Ice%u_ice, Ice%v_ice, Domain, gridtype=BGRID_NE )
       endif
       call mpp_update_domains(Ice%sig11, Domain )
       call mpp_update_domains(Ice%sig22, Domain )
       call mpp_update_domains(Ice%sig12, Domain )
    else ! no restart => no ice
       Ice % part_size    = 0.0
       !   where (Ice%mask) Ice % part_size (:,:,1) = 1.0  - flux_exchange won't allow
       Ice % part_size (:,:,1) = 1.0
       Ice % albedo            = 0.0
       Ice % albedo_vis_dir    = 0.0         
       Ice % albedo_nir_dir    = 0.0       
       Ice % albedo_vis_dif    = 0.0       
       Ice % albedo_nir_dif    = 0.0       
       Ice % rough_mom         = mom_rough_ice
       Ice % rough_heat        = heat_rough_ice
       Ice % rough_moist       = heat_rough_ice
       Ice % t_surf            = Tfreeze-5.0
       Ice % h_snow            = 0.0
       Ice % h_ice             = 0.0
       Ice % t_ice1            = -5.0
       Ice % t_ice2            = -5.0
       Ice % u_ice             = 0.0
       Ice % v_ice             = 0.0
       Ice % sig11             = 0.0
       Ice % sig22             = 0.0
       Ice % sig12             = 0.0
       Ice % flux_u            = 0.0 
       Ice % flux_v            = 0.0
       Ice % flux_t            = 0.0 
       Ice % flux_q            = 0.0
       Ice % flux_lw           = 0.0
       Ice % flux_salt         = 0.0 
       Ice % lprec             = 0.0
       Ice % fprec             = 0.0
       Ice % p_surf            = 0.0
       Ice % runoff            = 0.0
       Ice % calving           = 0.0
       Ice % runoff_hflx       = 0.0
       Ice % calving_hflx      = 0.0
       Ice % frazil            = 0.0
       Ice % flux_sw_vis_dir   = 0.0 
       Ice % flux_sw_vis_dif   = 0.0 
       Ice % flux_sw_nir_dir   = 0.0 
       Ice % flux_sw_nir_dif   = 0.0 
       do_init = .true. ! done in ice_model
    end if

    Ice % tmelt       = 0.0
    Ice % bmelt       = 0.0

    Ice % qflx_lim_ice = 0.0
    Ice % qflx_res_ice = 0.0

    Ice%part_size_uv(:,:,1) = 1.0
    do k=2,km
       call t_to_uv(Ice%part_size(:,:,k),Ice%part_size_uv(:,:,k))
       Ice%part_size_uv (:,:,1) = Ice%part_size_uv(:,:,1)-Ice%part_size_uv (:,:,k)
    end do

    call ice_diagnostics_init(Ice)
    !Balaji
    iceClock = mpp_clock_id( 'Ice', flags=clock_flag_default, grain=CLOCK_COMPONENT )
    iceClock1 = mpp_clock_id( 'Ice: bot to top', flags=clock_flag_default, grain=CLOCK_ROUTINE )
    iceClock2 = mpp_clock_id( 'Ice: update slow (dn)', flags=clock_flag_default, grain=CLOCK_ROUTINE )
    iceClock7 = mpp_clock_id( '  Ice: slow: conservation check', flags=clock_flag_default, grain=CLOCK_LOOP )
    iceClock4 = mpp_clock_id( '  Ice: slow: dynamics', flags=clock_flag_default, grain=CLOCK_LOOP )
    iceClocka = mpp_clock_id( '       slow: ice_dynamics', flags=clock_flag_default, grain=CLOCK_LOOP )
    iceClockb = mpp_clock_id( '       slow: comm/cut check ', flags=clock_flag_default, grain=CLOCK_LOOP )
    iceClockc = mpp_clock_id( '       slow: diags', flags=clock_flag_default, grain=CLOCK_LOOP )
    iceClock5 = mpp_clock_id( '  Ice: slow: thermodynamics', flags=clock_flag_default, grain=CLOCK_LOOP )
    iceClock6 = mpp_clock_id( '  Ice: slow: restore/limit', flags=clock_flag_default, grain=CLOCK_LOOP )
    iceClock8 = mpp_clock_id( '  Ice: slow: salt to ocean', flags=clock_flag_default, grain=CLOCK_LOOP )
    iceClock9 = mpp_clock_id( '  Ice: slow: thermodyn diags', flags=clock_flag_default, grain=CLOCK_LOOP )
    iceClock3 = mpp_clock_id( 'Ice: update fast', flags=clock_flag_default, grain=CLOCK_ROUTINE )
 
    ! Initialize icebergs
    if (do_icebergs) call icebergs_init(Ice%icebergs, &
             im, jm, layout, io_layout, Ice%axes(1:2), Ice%maskmap, x_cyclic, tripolar_grid, &
             dt_slow, Time, geo_lonv_ib, geo_latv_ib, wett, dtn, dte, cell_area, cos_rot, sin_rot )

   if (add_diurnal_sw .or. do_sun_angle_for_alb) call astronomy_init
   call nullify_domain()

  end subroutine ice_model_init

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! ice_model_end - writes the restart file                                      !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine ice_model_end (Ice)
    type (ice_data_type), intent(inout) :: Ice
    integer           :: k

    integer           :: unit
    character(len=22) :: restart='RESTART/ice_model.res'

    if (conservation_check) then
       do k=1,4
          call mpp_sum(h2o(k))
          call mpp_sum(heat(k))
       end do
       if (mpp_pe()==mpp_root_pe()) then
          print *
          print '(a10,5a13)',   'ICE MODEL ','   AT START  ', &
               ' TOP FLUX DN.', &
               ' BOT FLUX DN.', &
               '   AT END    ', &
               '   ERROR     '
          print '(a10,5es13.5)','WATER     ', h2o , h2o (4)-(h2o (1)+h2o (2)-h2o (3))
          print '(a10,5es13.5)','HEAT      ', heat, heat(4)-(heat(1)+heat(2)-heat(3))
          print *
       end if
    end if

    call ice_model_restart()

    !--- release memory ------------------------------------------------
    call ice_grid_end()

    deallocate(Ice % mask, Ice % ice_mask, Ice % t_surf, Ice % s_surf, Ice % sea_lev )
    deallocate(Ice % vmask)
    deallocate(Ice % part_size, Ice % part_size_uv, Ice % u_surf, Ice % v_surf )
    deallocate(Ice % u_ocn, Ice % v_ocn ,  Ice % rough_mom, Ice % rough_heat )
    deallocate(Ice % rough_moist, Ice % albedo, Ice % flux_u_top, Ice % flux_v_top )
    deallocate(Ice % flux_u_top_bgrid, Ice % flux_v_top_bgrid )
    deallocate(Ice % flux_t_top, Ice % flux_q_top, Ice % flux_lw_top )
    deallocate(Ice % flux_lh_top, Ice % lprec_top, Ice % fprec_top, Ice % flux_u )
    deallocate(Ice % flux_v, Ice % flux_t, Ice % flux_q, Ice % flux_lw )
    deallocate(Ice % flux_lh, Ice % lprec, Ice % fprec, Ice % p_surf, Ice % runoff ) 
    deallocate(Ice % calving, Ice % runoff_hflx, Ice % calving_hflx )
    deallocate(Ice % flux_salt)
    deallocate( Ice % lwdn)
    deallocate( Ice % swdn)
    deallocate( Ice % frazil )
    deallocate(Ice % bheat, Ice % u_ice, Ice % v_ice, Ice % sig11, Ice % sig22 )
    deallocate(Ice % sig12, Ice % tmelt, Ice % bmelt, Ice % pen, Ice % trn )
    deallocate(Ice % h_snow, Ice % h_ice, Ice % t_ice1, Ice % t_ice2  )
    deallocate(Ice % qflx_lim_ice, Ice % qflx_res_ice )
    deallocate(Ice % flux_sw_vis_dir, Ice % flux_sw_vis_dif )
    deallocate(Ice % flux_sw_nir_dir, Ice % flux_sw_nir_dif )
    deallocate(Ice % wnd )

    ! End icebergs
    if (do_icebergs) call icebergs_end(Ice%icebergs)

    if (add_diurnal_sw .or. do_sun_angle_for_alb) call astronomy_end

  end subroutine ice_model_end

  !#######################################################################
  ! <SUBROUTINE NAME="ice_model_restart">
  ! <DESCRIPTION>
  !  Write out restart files registered through register_restart_file
  ! </DESCRIPTION>
  subroutine ice_model_restart(Ice, time_stamp)
    type (ice_data_type),     intent(inout), optional :: Ice
    character(len=*),         intent(in), optional :: time_stamp

    call save_restart(Ice_restart, time_stamp)
   !call icebergs_save_restart(Ice%icebergs)
   ! This should go here but since "Ice" is not available we have to
   ! rely on the restart written via ice_model_end() -AJA

  end subroutine ice_model_restart
  ! </SUBROUTINE>
  !#######################################################################

  subroutine ice_diagnostics_init(Ice)
    type (ice_data_type), intent(inout) :: Ice

    real, parameter       :: missing = -1e34
    integer, dimension(2) :: axt, axv, axtv, axvt
    integer, dimension(3) :: axt2
    integer               :: id_geo_lon, id_geo_lat, id_sin_rot, id_cos_rot, id_cell_area
    logical               :: sent

    !
    ! diagnostics MUST use a domain without halos otherwise same as the
    ! regular domain:  Domain (see ice_grid.f90)
    !
    id_xv = diag_axis_init('xv', xb1d(2:im+1), 'degrees_E', 'X','longitude', set_name='ice', Domain2=Domain )
    id_yv = diag_axis_init('yv', yb1d(2:jm+1), 'degrees_N', 'Y','latitude',  set_name='ice', Domain2=Domain )
    id_xb = diag_axis_init('xb', xb1d, 'degrees_E', 'X', 'longitude', set_name='ice', Domain2=Domain )
    id_yb = diag_axis_init('yb', yb1d, 'degrees_N', 'Y', 'latitude', set_name='ice', Domain2=Domain )
    id_xt = diag_axis_init('xt', (xb1d(1:im)+xb1d(2:im+1))/2, 'degrees_E', 'X', &
            'longitude',set_name='ice',edges=id_xb,Domain2=Domain)
    id_yt = diag_axis_init('yt', (yb1d(1:jm)+yb1d(2:jm+1))/2, 'degrees_N', 'Y', &
            'latitude',set_name='ice', edges=id_yb,Domain2=Domain)
    id_ct = diag_axis_init('ct', hlim(1:num_part-1), 'meters','Z', 'thickness')
    axv  = (/ id_xv, id_yv       /)
    axt  = (/ id_xt, id_yt       /)
    axt2 = (/ id_xt, id_yt, id_ct/)
    Ice%axes(:) = axt2(:)
    axtv = (/ id_xt, id_yv /); ! for north faces of t-cells
    axvt = (/ id_xv, id_yt /); ! for east  faces of t-cells

    id_sin_rot   = register_static_field('ice_model', 'SINROT', axt,              &
                   '-SINROT,COSROT points north', 'none')
    id_cos_rot   = register_static_field('ice_model', 'COSROT', axt,              &
                   'COSROT,SINROT points east','none')
    id_geo_lon   = register_static_field('ice_model', 'GEOLON', axt, 'longitude', &
                   'degrees')
    id_geo_lat   = register_static_field('ice_model', 'GEOLAT', axt, 'latitude',  &
                   'degrees')
    id_cell_area = register_static_field('ice_model', 'CELL_AREA', axt,           &
                   'cell area', 'sphere')
    id_ext       = register_diag_field('ice_model', 'MOI', axt, Ice%Time,   &
                   'ice modeled', '0 or 1', missing_value=missing)
    if (id_ext > 0 ) then
       call error_mesg ('ice_model_init', &
            'Diagnostic MOI has been renamed EXT.  Change your diag_table.', WARNING)
    else
       id_ext = register_diag_field('ice_model', 'EXT', axt, Ice%Time, &
                'ice modeled', '0 or 1', missing_value=missing)
    end if
    id_wnd      = register_diag_field('ice_model', 'wnd ', axt, Ice%Time,   &
                   'wind speed', 'm/s', missing_value=missing)
    id_mi       = register_diag_field('ice_model', 'MI', axt, Ice%Time,                  &
                 'ice mass', 'kg/m^2', missing_value=missing)
    id_mib      = register_diag_field('ice_model', 'MIB', axt, Ice%Time,                  &
                 'ice + bergs mass', 'kg/m^2', missing_value=missing)
    id_cn       = register_diag_field('ice_model', 'CN', axt2, Ice%Time,                 &
                 'ice concentration', '0-1', missing_value=missing)
    id_hs       = register_diag_field('ice_model', 'HS', axt, Ice%Time,                  &
                 'snow thickness', 'm-snow', missing_value=missing)
    id_hi       = register_diag_field('ice_model', 'HI', axt, Ice%Time,                  &
                 'ice thickness', 'm-ice', missing_value=missing)
    id_t1       = register_diag_field('ice_model', 'T1', axt, Ice%Time,                  &
                 'upper ice layer temperature', 'C',  missing_value=missing)
    id_t2       = register_diag_field('ice_model', 'T2', axt, Ice%Time,                  &
                 'lower ice layer temperature', 'C',  missing_value=missing)
    id_ts       = register_diag_field('ice_model', 'TS', axt, Ice%Time,                  &
                 'surface temperature', 'C', missing_value=missing)
    id_sh       = register_diag_field('ice_model','SH' ,axt, Ice%Time,                   &
                 'sensible heat flux', 'W/m^2',  missing_value=missing)
    id_lh       = register_diag_field('ice_model','LH' ,axt, Ice%Time,                   &
                 'latent heat flux', 'W/m^2', missing_value=missing)
    id_sw       = register_diag_field('ice_model','SW' ,axt, Ice%Time,                   &
                 'short wave heat flux', 'W/m^2', missing_value=missing)
    id_lw       = register_diag_field('ice_model','LW' ,axt, Ice%Time,                   &
                 'long wave heat flux over ice', 'W/m^2', missing_value=missing)
    id_snofl    = register_diag_field('ice_model','SNOWFL' ,axt, Ice%Time,               &
                 'rate of snow fall', 'kg/(m^2*s)', missing_value=missing)
    id_rain     = register_diag_field('ice_model','RAIN' ,axt, Ice%Time,                 &
                 'rate of rain fall', 'kg/(m^2*s)', missing_value=missing)
    id_runoff   = register_diag_field('ice_model','RUNOFF' ,axt, Ice%Time,               &
                 'liquid runoff', 'kg/(m^2*s)', missing_value=missing)
    id_calving  = register_diag_field('ice_model','CALVING',axt, Ice%Time,               &
                 'frozen runoff', 'kg/(m^2*s)', missing_value=missing)
    id_runoff_hflx   = register_diag_field('ice_model','RUNOFF_HFLX' ,axt, Ice%Time,               &
                 'liquid runoff sensible heat flux', 'W/m^2', missing_value=missing)
    id_calving_hflx  = register_diag_field('ice_model','CALVING_HFLX',axt, Ice%Time,               &
                 'frozen runoff sensible heat flux', 'W/m^2', missing_value=missing)
    id_evap     = register_diag_field('ice_model','EVAP',axt, Ice%Time,                  &
                 'evaporation', 'kg/(m^2*s)', missing_value=missing)
    id_saltf    = register_diag_field('ice_model','SALTF' ,axt, Ice%Time,                &
                 'ice to ocean salt flux', 'kg/(m^2*s)', missing_value=missing)
    id_sn2ic    = register_diag_field('ice_model','SN2IC'  ,axt,Ice%Time,                &
                 'rate of snow to ice conversion', 'kg/(m^2*s)', missing_value=missing)
    id_tmelt    = register_diag_field('ice_model','TMELT'  ,axt, Ice%Time,               &
                 'upper surface melting energy flux', 'W/m^2', missing_value=missing)
    id_bmelt    = register_diag_field('ice_model','BMELT'  ,axt, Ice%Time,               &
                 'bottom surface melting energy flux', 'W/m^2', missing_value=missing)
    id_bheat    = register_diag_field('ice_model','BHEAT'  ,axt, Ice%Time,               &
                 'ocean to ice heat flux', 'W/m^2', missing_value=missing)
    id_e2m      = register_diag_field('ice_model','E2MELT' ,axt, Ice%Time,               &
                 'heat needed to melt ice', 'J/m^2', missing_value=missing)
    id_frazil   = register_diag_field('ice_model','FRAZIL' ,axt, Ice%Time,               &
                 'energy flux of frazil formation', 'W/m^2', missing_value=missing)
    id_alb      = register_diag_field('ice_model','ALB',axt, Ice%Time,                   &
                 'surface albedo','0-1', missing_value=missing )
    id_alb_vis_dir = register_diag_field('ice_model','alb_vis_dir',axt, Ice%Time,                &
                 'ice surface albedo vis_dir','0-1', missing_value=missing )
    id_alb_vis_dif = register_diag_field('ice_model','alb_vis_dif',axt, Ice%Time,                &
                 'ice surface albedo vis_dif','0-1', missing_value=missing )
    id_alb_nir_dir = register_diag_field('ice_model','alb_nir_dir',axt, Ice%Time,                &
                 'ice surface albedo nir_dir','0-1', missing_value=missing )
    id_alb_nir_dif = register_diag_field('ice_model','alb_nir_dif',axt, Ice%Time,                &
                 'ice surface albedo nir_dif','0-1', missing_value=missing )
    id_xprt     = register_diag_field('ice_model','XPRT',axt, Ice%Time,                  &
                 'frozen water transport convergence', 'kg/(m^2*yr)', missing_value=missing)
    id_lsrc     = register_diag_field('ice_model','LSRC', axt, Ice%Time,                 &
                 'frozen water local source', 'kg/(m^2*yr)', missing_value=missing)
    id_lsnk     = register_diag_field('ice_model','LSNK',axt, Ice%Time,                  &
                 'frozen water local sink', 'kg/(m^2*yr)', missing_value=missing)
    id_bsnk     = register_diag_field('ice_model','BSNK',axt, Ice%Time,                  &
                 'frozen water local bottom sink', 'kg/(m^2*yr)', missing_value=missing)
    id_qfres    = register_diag_field('ice_model', 'QFLX_RESTORE_ICE', axt, Ice%Time,    &
                 'Ice Restoring heat flux', 'W/m^2', missing_value=missing)
    id_qflim    = register_diag_field('ice_model', 'QFLX_LIMIT_ICE', axt, Ice%Time,      &
                 'Ice Limit heat flux', 'W/m^2', missing_value=missing)
    id_strna    = register_diag_field('ice_model','STRAIN_ANGLE', axt,Ice%Time,          &
                 'strain angle', 'none', missing_value=missing)
    id_sigi     = register_diag_field('ice_model','SIGI' ,axt, Ice%Time,                 &
                 'first stress invariant', 'none', missing_value=missing)
    id_sigii    = register_diag_field('ice_model','SIGII' ,axt, Ice%Time,                &
                 'second stress invariant', 'none', missing_value=missing)
    id_stren    = register_diag_field('ice_model','STRENGTH' ,axt, Ice%Time,             &
                 'ice strength', 'Pa*m', missing_value=missing)
    id_ui       = register_diag_field('ice_model', 'UI', axv, Ice%Time,                  &
                 'ice velocity - x component', 'm/s', missing_value=missing)
    id_vi       = register_diag_field('ice_model', 'VI', axv, Ice%Time,                  &
                 'ice velocity - y component', 'm/s', missing_value=missing)
    id_ix_trans = register_diag_field('ice_model', 'IX_TRANS', axvt, Ice%Time,           &
                 'x-direction ice transport', 'kg/s', missing_value=missing)
    id_iy_trans = register_diag_field('ice_model', 'IY_TRANS', axtv, Ice%Time,           &
                 'y-direction ice transport', 'kg/s', missing_value=missing)
    id_fax      = register_diag_field('ice_model', 'FA_X', axv, Ice%Time,                &
                 'air stress on ice - x component', 'Pa', missing_value=missing)
    id_fay      = register_diag_field('ice_model', 'FA_Y', axv, Ice%Time,                &
                 'air stress on ice - y component', 'Pa', missing_value=missing)
    id_fix      = register_diag_field('ice_model', 'FI_X', axv, Ice%Time,                &
                 'ice internal stress - x component', 'Pa', missing_value=missing)
    id_fiy      = register_diag_field('ice_model', 'FI_Y', axv, Ice%Time,                &
                 'ice internal stress - y component', 'Pa', missing_value=missing)
    id_fcx      = register_diag_field('ice_model', 'FC_X', axv, Ice%Time,                &
                 'coriolis force - x component', 'Pa', missing_value=missing)
    id_fcy      = register_diag_field('ice_model', 'FC_Y', axv, Ice%Time,                &
                 'coriolis force - y component', 'Pa', missing_value=missing)
    id_fwx      = register_diag_field('ice_model', 'FW_X', axv, Ice%Time,                &
                 'water stress on ice - x component', 'Pa', missing_value=missing)
    id_fwy      = register_diag_field('ice_model', 'FW_Y', axv, Ice%Time,                &
                 'water stress on ice - y component', 'Pa', missing_value=missing)
    id_uo       = register_diag_field('ice_model', 'UO', axv, Ice%Time,                  &
                 'surface current - x component', 'm/s', missing_value=missing)
    id_vo       = register_diag_field('ice_model', 'VO', axv, Ice%Time,                  &
                 'surface current - y component', 'm/s', missing_value=missing)
    id_sw_vis   = register_diag_field('ice_model','SW_VIS' ,axt, Ice%Time,               &
                 'visible short wave heat flux', 'W/m^2', missing_value=missing)
    id_sw_dir   = register_diag_field('ice_model','SW_DIR' ,axt, Ice%Time,               &
                 'direct short wave heat flux', 'W/m^2', missing_value=missing)
    id_sw_dif   = register_diag_field('ice_model','SW_DIF' ,axt, Ice%Time,               &
                 'diffuse short wave heat flux', 'W/m^2', missing_value=missing)
    id_sw_vis_dir = register_diag_field('ice_model','SW_VIS_DIR' ,axt, Ice%Time,         &
                 'visible direct short wave heat flux', 'W/m^2', missing_value=missing)
    id_sw_vis_dif = register_diag_field('ice_model','SW_VIS_DIF' ,axt, Ice%Time,         &
                 'visible diffuse short wave heat flux', 'W/m^2', missing_value=missing)
    id_sw_nir_dir = register_diag_field('ice_model','SW_NIR_DIR' ,axt, Ice%Time,         &
                 'near IR direct short wave heat flux', 'W/m^2', missing_value=missing)
    id_sw_nir_dif = register_diag_field('ice_model','SW_NIR_DIF' ,axt, Ice%Time,         &
                 'near IR diffuse short wave heat flux', 'W/m^2', missing_value=missing)
    id_ustar    = register_diag_field('ice_model', 'U_STAR', axvt, Ice%Time,              &
                 'channel transport velocity - x component', 'm/s', missing_value=missing)
    id_vstar    = register_diag_field('ice_model', 'V_STAR', axtv, Ice%Time,              &
                 'channel transport velocity - y component', 'm/s', missing_value=missing)
    id_uocean   = register_diag_field('ice_model', 'U_CHAN_OCN', axvt, Ice%Time,          &
                 'ocean component of channel transport - x', 'm/s', missing_value=missing)
    id_vocean   = register_diag_field('ice_model', 'V_CHAN_OCN', axtv, Ice%Time,          &
                 'ocean component of channel transport - y', 'm/s', missing_value=missing)
    id_uchan    = register_diag_field('ice_model', 'U_CHAN_VISC', axvt, Ice%Time,         &
                 'viscous component of channel transport - x', 'm/s', missing_value=missing)
    id_vchan    = register_diag_field('ice_model', 'V_CHAN_VISC', axtv, Ice%Time,         &
                 'viscous component of channel transport - y', 'm/s', missing_value=missing)

    !
    ! diagnostics for quantities produced outside the ice model
    !
    id_swdn  = register_diag_field('ice_model','SWDN' ,axt, Ice%Time,       &
               'downward shortwave flux', 'W/m^2', missing_value=missing)
    id_lwdn  = register_diag_field('ice_model','LWDN' ,axt, Ice%Time,       &
               'downward longwave flux', 'W/m^2', missing_value=missing)
    id_ta    = register_diag_field('ice_model', 'TA', axt, Ice%Time,        &
               'surface air temperature', 'C', missing_value=missing)
    id_slp   = register_diag_field('ice_model', 'SLP', axt, Ice%Time,       &
               'sea level pressure', 'Pa', missing_value=missing)
    id_sst   = register_diag_field('ice_model', 'SST', axt, Ice%Time,       &
               'sea surface temperature', 'deg-C', missing_value=missing)
    id_sss   = register_diag_field('ice_model', 'SSS', axt, Ice%Time,       &
               'sea surface salinity', 'psu', missing_value=missing)
    id_ssh   = register_diag_field('ice_model', 'SSH', axt, Ice%Time,       &
               'sea surface height', 'm', missing_value=missing)
    id_obi   = register_diag_field('ice_model', 'OBI', axt, Ice%Time,       &
         'ice observed', '0 or 1', missing_value=missing)

    if (id_sin_rot>0)   sent=send_data(id_sin_rot, sin_rot(isc:iec,jsc:jec), Ice%Time);
    if (id_cos_rot>0)   sent=send_data(id_cos_rot, cos_rot(isc:iec,jsc:jec), Ice%Time);
    if (id_geo_lon>0)   sent=send_data(id_geo_lon, geo_lon, Ice%Time);
    if (id_geo_lat>0)   sent=send_data(id_geo_lat, geo_lat, Ice%Time);
    if (id_cell_area>0) sent=send_data(id_cell_area, cell_area, Ice%Time);

  end subroutine ice_diagnostics_init

subroutine ice_data_type_chksum(id, timestep, data_type)
  use fms_mod,                 only: stdout
  use mpp_mod,                 only: mpp_chksum

    character(len=*), intent(in) :: id
    integer         , intent(in) :: timestep
    type(ice_data_type), intent(in) :: data_type
 integer ::   n, m, outunit

    outunit = stdout()
100 FORMAT("   CHECKSUM::",A32," = ",Z20)
    write(outunit,*) "BEGIN CHECKSUM(ice_data_type):: ", id, timestep
    write(outunit,100) 'ice_data_type%part_size          ',mpp_chksum(data_type%part_size(isc:iec,jsc:jec,:)          )
    write(outunit,100) 'ice_data_type%part_size_uv       ',mpp_chksum(data_type%part_size_uv(isc:iec,jsc:jec,:)       )
    write(outunit,100) 'ice_data_type%albedo             ',mpp_chksum(data_type%albedo(isc:iec,jsc:jec,:)             )
    write(outunit,100) 'ice_data_type%albedo_vis_dir     ',mpp_chksum(data_type%albedo_vis_dir(isc:iec,jsc:jec,:)     )
    write(outunit,100) 'ice_data_type%albedo_nir_dir     ',mpp_chksum(data_type%albedo_nir_dir(isc:iec,jsc:jec,:)     )
    write(outunit,100) 'ice_data_type%albedo_vis_dif     ',mpp_chksum(data_type%albedo_vis_dif(isc:iec,jsc:jec,:)     )
    write(outunit,100) 'ice_data_type%albedo_nir_dif     ',mpp_chksum(data_type%albedo_nir_dif(isc:iec,jsc:jec,:)     )
    write(outunit,100) 'ice_data_type%rough_mom          ',mpp_chksum(data_type%rough_mom(isc:iec,jsc:jec,:)          )
    write(outunit,100) 'ice_data_type%rough_heat         ',mpp_chksum(data_type%rough_heat(isc:iec,jsc:jec,:)         )
    write(outunit,100) 'ice_data_type%rough_moist        ',mpp_chksum(data_type%rough_moist(isc:iec,jsc:jec,:)        )
    write(outunit,100) 'ice_data_type%flux_u             ',mpp_chksum(data_type%flux_u(isc:iec,jsc:jec)               )
    write(outunit,100) 'ice_data_type%flux_v             ',mpp_chksum(data_type%flux_v(isc:iec,jsc:jec)               )
    write(outunit,100) 'ice_data_type%flux_t             ',mpp_chksum(data_type%flux_t(isc:iec,jsc:jec)               )
    write(outunit,100) 'ice_data_type%flux_q             ',mpp_chksum(data_type%flux_q(isc:iec,jsc:jec)               )
    write(outunit,100) 'ice_data_type%flux_lw            ',mpp_chksum(data_type%flux_lw(isc:iec,jsc:jec)              )
    write(outunit,100) 'ice_data_type%flux_sw_vis_dir    ',mpp_chksum(data_type%flux_sw_vis_dir(isc:iec,jsc:jec)      )
    write(outunit,100) 'ice_data_type%flux_sw_vis_dif    ',mpp_chksum(data_type%flux_sw_vis_dif(isc:iec,jsc:jec)      )
    write(outunit,100) 'ice_data_type%flux_sw_nir_dir    ',mpp_chksum(data_type%flux_sw_nir_dir(isc:iec,jsc:jec)      )
    write(outunit,100) 'ice_data_type%flux_sw_nir_dif    ',mpp_chksum(data_type%flux_sw_nir_dif(isc:iec,jsc:jec)      )
    write(outunit,100) 'ice_data_type%lprec              ',mpp_chksum(data_type%lprec(isc:iec,jsc:jec)                )
    write(outunit,100) 'ice_data_type%fprec              ',mpp_chksum(data_type%fprec(isc:iec,jsc:jec)                )
    write(outunit,100) 'ice_data_type%p_surf             ',mpp_chksum(data_type%p_surf(isc:iec,jsc:jec)               )
    write(outunit,100) 'ice_data_type%runoff             ',mpp_chksum(data_type%runoff(isc:iec,jsc:jec)               )
    write(outunit,100) 'ice_data_type%calving            ',mpp_chksum(data_type%calving(isc:iec,jsc:jec)              )
    write(outunit,100) 'ice_data_type%flux_salt          ',mpp_chksum(data_type%flux_salt(isc:iec,jsc:jec)            )
    write(outunit,100) 'ice_data_type%h_snow             ',mpp_chksum(data_type%h_snow(isc:iec,jsc:jec,:))
    write(outunit,100) 'ice_data_type%h_ice              ',mpp_chksum(data_type%h_ice(isc:iec,jsc:jec,:) )
    write(outunit,100) 'ice_data_type%t_ice1             ',mpp_chksum(data_type%t_ice1(isc:iec,jsc:jec,:))
    write(outunit,100) 'ice_data_type%t_ice2             ',mpp_chksum(data_type%t_ice2(isc:iec,jsc:jec,:))
    write(outunit,100) 'ice_data_type%u_ice              ',mpp_chksum(data_type%u_ice(isc:iec,jsc:jec))
    write(outunit,100) 'ice_data_type%v_ice              ',mpp_chksum(data_type%v_ice(isc:iec,jsc:jec))
    write(outunit,100) 'ice_data_type%sig11              ',mpp_chksum(data_type%sig11(isc:iec,jsc:jec))
    write(outunit,100) 'ice_data_type%sig22              ',mpp_chksum(data_type%sig22(isc:iec,jsc:jec))
    write(outunit,100) 'ice_data_type%sig12              ',mpp_chksum(data_type%sig12(isc:iec,jsc:jec))
    write(outunit,100) 'ice_data_type%frazil             ',mpp_chksum(data_type%frazil(isc:iec,jsc:jec))
    write(outunit,100) 'ice_data_type%qflx_lim_ice       ',mpp_chksum(data_type%qflx_lim_ice(isc:iec,jsc:jec))
    write(outunit,100) 'ice_data_type%qflx_res_ice       ',mpp_chksum(data_type%qflx_res_ice(isc:iec,jsc:jec))
    write(outunit,*) '   ======The following are not restart variables======'
    write(outunit,100) 'ice_data_type%u_surf             ',mpp_chksum(data_type%u_surf(isc:iec,jsc:jec,:)             )
    write(outunit,100) 'ice_data_type%v_surf             ',mpp_chksum(data_type%v_surf(isc:iec,jsc:jec,:)             )
    write(outunit,100) 'ice_data_type%sea_lev            ',mpp_chksum(data_type%sea_lev(isc:iec,jsc:jec)              )
    write(outunit,100) 'ice_data_type%s_surf             ',mpp_chksum(data_type%s_surf(isc:iec,jsc:jec)               )
    write(outunit,100) 'ice_data_type%u_ocn              ',mpp_chksum(data_type%u_ocn(isc:iec,jsc:jec)                )
    write(outunit,100) 'ice_data_type%v_ocn              ',mpp_chksum(data_type%v_ocn(isc:iec,jsc:jec)                )
    write(outunit,100) 'ice_data_type%flux_u_top         ',mpp_chksum(data_type%flux_u_top(isc:iec,jsc:jec,:)         )
    write(outunit,100) 'ice_data_type%flux_v_top         ',mpp_chksum(data_type%flux_v_top(isc:iec,jsc:jec,:)         )
    write(outunit,100) 'ice_data_type%flux_t_top         ',mpp_chksum(data_type%flux_t_top(isc:iec,jsc:jec,:)         )
    write(outunit,100) 'ice_data_type%flux_q_top         ',mpp_chksum(data_type%flux_q_top(isc:iec,jsc:jec,:)         )
    write(outunit,100) 'ice_data_type%flux_lw_top        ',mpp_chksum(data_type%flux_lw_top(isc:iec,jsc:jec,:)        )
    write(outunit,100) 'ice_data_type%flux_sw_vis_dir_top',mpp_chksum(data_type%flux_sw_vis_dir_top(isc:iec,jsc:jec,:))
    write(outunit,100) 'ice_data_type%flux_sw_vis_dif_top',mpp_chksum(data_type%flux_sw_vis_dif_top(isc:iec,jsc:jec,:))
    write(outunit,100) 'ice_data_type%flux_sw_nir_dir_top',mpp_chksum(data_type%flux_sw_nir_dir_top(isc:iec,jsc:jec,:))
    write(outunit,100) 'ice_data_type%flux_sw_nir_dif_top',mpp_chksum(data_type%flux_sw_nir_dif_top(isc:iec,jsc:jec,:))
    write(outunit,100) 'ice_data_type%flux_lh_top        ',mpp_chksum(data_type%flux_lh_top(isc:iec,jsc:jec,:)        )
    write(outunit,100) 'ice_data_type%lprec_top          ',mpp_chksum(data_type%lprec_top(isc:iec,jsc:jec,:)          )
    write(outunit,100) 'ice_data_type%fprec_top          ',mpp_chksum(data_type%fprec_top(isc:iec,jsc:jec,:)          )
    write(outunit,100) 'ice_data_type%flux_lh            ',mpp_chksum(data_type%flux_lh(isc:iec,jsc:jec)              )
    write(outunit,100) 'ice_data_type%lwdn               ',mpp_chksum(data_type%lwdn(isc:iec,jsc:jec)                 )
    write(outunit,100) 'ice_data_type%swdn               ',mpp_chksum(data_type%swdn(isc:iec,jsc:jec)                 )
    write(outunit,100) 'ice_data_type%pen                ',mpp_chksum(data_type%pen(isc:iec,jsc:jec,:)                )
    write(outunit,100) 'ice_data_type%trn                ',mpp_chksum(data_type%trn(isc:iec,jsc:jec,:)                )
    write(outunit,100) 'ice_data_type%tmelt              ',mpp_chksum(data_type%tmelt(isc:iec,jsc:jec,:)              )
    write(outunit,100) 'ice_data_type%bmelt              ',mpp_chksum(data_type%bmelt(isc:iec,jsc:jec,:)              )
    write(outunit,100) 'ice_data_type%bheat              ',mpp_chksum(data_type%bheat(isc:iec,jsc:jec))

    do n = 1, data_type%ocean_fields%num_bcs  !{
       do m = 1, data_type%ocean_fields%bc(n)%num_fields  !{
          !write(outunit,101) 'ice%', m, n, mpp_chksum(Ice%ocean_fields%bc(n)%field(m)%values)
          write(outunit,101) 'ice%',trim(data_type%ocean_fields%bc(n)%name), &
               trim(data_type%ocean_fields%bc(n)%field(m)%name), &
               mpp_chksum(data_type%ocean_fields%bc(n)%field(m)%values)
       enddo  !} m
    enddo  !} n
101 FORMAT("   CHECKSUM::",A16,a,'%',a," = ",Z20)

end subroutine ice_data_type_chksum

end module ice_type_mod

#include <fms_platform.h>

MODULE diag_output_mod
  ! <CONTACT EMAIL="seth.underwood@noaa.gov">
  !   Seth Underwood
  ! </CONTACT>

  ! <OVERVIEW> <TT>diag_output_mod</TT> is an integral part of
  !   <TT>diag_manager_mod</TT>. Its function is to write axis-meta-data,
  !   field-meta-data and field data
  ! </OVERVIEW>

  USE mpp_io_mod, ONLY: axistype, fieldtype, mpp_io_init, mpp_open,  mpp_write_meta,&
       & mpp_write, mpp_flush, mpp_close, mpp_get_id, MPP_WRONLY, MPP_OVERWR,&
       & MPP_NETCDF, MPP_MULTI, MPP_SINGLE
  USE mpp_domains_mod, ONLY: domain1d, domain2d, mpp_define_domains, mpp_get_pelist,&
       &  mpp_get_global_domain, mpp_get_compute_domains, null_domain1d, null_domain2d,&
       & OPERATOR(.NE.), mpp_get_layout, OPERATOR(.EQ.)
  USE mpp_mod, ONLY: mpp_npes, mpp_pe
  USE diag_axis_mod, ONLY: diag_axis_init, get_diag_axis, get_axis_length,&
       & get_axis_global_length, get_domain1d, get_domain2d, get_axis_aux, get_tile_count
  USE diag_data_mod, ONLY: diag_fieldtype, diag_global_att_type, CMOR_MISSING_VALUE, diag_atttype
  USE time_manager_mod, ONLY: get_calendar_type, valid_calendar_types
  USE fms_mod, ONLY: error_mesg, mpp_pe, write_version_number, FATAL

#ifdef use_netCDF
  USE netcdf, ONLY: NF90_INT, NF90_FLOAT, NF90_CHAR
#endif

  IMPLICIT NONE

  PRIVATE
  PUBLIC :: diag_output_init, write_axis_meta_data, write_field_meta_data, done_meta_data,&
       & diag_field_out, diag_flush, diag_fieldtype, get_diag_global_att, set_diag_global_att

  TYPE(diag_global_att_type), SAVE :: diag_global_att

  INTEGER, PARAMETER      :: NETCDF1 = 1
  INTEGER, PARAMETER      :: mxch  = 128
  INTEGER, PARAMETER      :: mxchl = 256
  INTEGER                 :: current_file_unit = -1
  INTEGER, DIMENSION(2,2) :: max_range = RESHAPE((/ -32767, 32767, -127,   127 /),(/2,2/))
!  DATA max_range / -32767, 32767, -127,   127 /
  INTEGER, DIMENSION(2)   :: missval = (/ -32768, -128 /)

  INTEGER, PARAMETER      :: max_axis_num = 20
  INTEGER                 :: num_axis_in_file = 0
  INTEGER, DIMENSION(max_axis_num) :: axis_in_file
  LOGICAL, DIMENSION(max_axis_num) :: time_axis_flag, edge_axis_flag
  TYPE(axistype), DIMENSION(max_axis_num), SAVE :: Axis_types

  LOGICAL :: module_is_initialized = .FALSE.

  CHARACTER(len=128), PRIVATE :: version= &
       '$Id$'
  CHARACTER(len=128), PRIVATE :: tagname= &
       '$Name$'

CONTAINS

  ! <SUBROUTINE NAME="diag_output_init">
  !   <OVERVIEW>
  !     Registers the time axis and opens the output file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE diag_output_init (file_name, format, file_title, file_unit,
  !      all_scalar_or_1d, domain)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Registers the time axis, and opens the file for output.
  !   </DESCRIPTION>
  !   <IN NAME="file_name" TYPE="CHARACTER(len=*)">Output file name</IN>
  !   <IN NAME="format" TYPE="INTEGER">File format (Currently only 'NETCDF' is valid)</IN>
  !   <IN NAME="file_title" TYPE="CHARACTER(len=*)">Descriptive title for the file</IN>
  !   <OUT NAME="file_unit" TYPE="INTEGER">
  !     File unit number assigned to the output file.  Needed for subsuquent calls to
  !     <TT>diag_output_mod</TT>
  !   </OUT>
  !   <IN NAME="all_scalar_or_1d" TYPE="LOGICAL" />
  !   <IN NAME="domain" TYPE="TYPE(domain2d)" />
  SUBROUTINE diag_output_init(file_name, FORMAT, file_title, file_unit,&
       & all_scalar_or_1d, domain, attributes)
    CHARACTER(len=*), INTENT(in)  :: file_name, file_title
    INTEGER         , INTENT(in)  :: FORMAT
    INTEGER         , INTENT(out) :: file_unit
    LOGICAL         , INTENT(in)  :: all_scalar_or_1d
    TYPE(domain2d)  , INTENT(in)  :: domain
    TYPE(diag_atttype), INTENT(in), DIMENSION(:), OPTIONAL :: attributes

    INTEGER :: form, threading, fileset, i
    TYPE(diag_global_att_type) :: gAtt

    !---- initialize mpp_io ----
    IF ( .NOT.module_is_initialized ) THEN
       CALL mpp_io_init ()
       module_is_initialized = .TRUE.
    END IF
    CALL write_version_number( version, tagname )

    !---- set up output file ----
    SELECT CASE (FORMAT)
    CASE (NETCDF1)
       form      = MPP_NETCDF
       threading = MPP_MULTI
       fileset   = MPP_MULTI
    CASE default
       ! <ERROR STATUS="FATAL">invalid format</ERROR>
       CALL error_mesg('diag_output_init', 'invalid format', FATAL)
    END SELECT

    IF(all_scalar_or_1d) THEN
       threading = MPP_SINGLE
       fileset   = MPP_SINGLE
    END IF

    !---- open output file (return file_unit id) -----
    IF ( domain .EQ. NULL_DOMAIN2D ) THEN
       CALL mpp_open(file_unit, file_name, action=MPP_OVERWR, form=form,&
            & threading=threading, fileset=fileset)
    ELSE
       CALL mpp_open(file_unit, file_name, action=MPP_OVERWR, form=form,&
            & threading=threading, fileset=fileset, domain=domain)
    END IF

    !---- write global attributes ----
    IF ( file_title(1:1) /= ' ' ) THEN
       CALL mpp_write_meta(file_unit, 'title', cval=TRIM(file_title))
    END IF

    IF ( PRESENT(attributes) ) THEN
       DO i=1, SIZE(attributes)
          SELECT CASE (attributes(i)%type)
          CASE (NF90_INT)
             CALL mpp_write_meta(file_unit, TRIM(attributes(i)%name), ival=attributes(i)%iatt)
          CASE (NF90_FLOAT)
             CALL mpp_write_meta(file_unit, TRIM(attributes(i)%name), rval=attributes(i)%fatt)
          CASE (NF90_CHAR)
             CALL mpp_write_meta(file_unit, TRIM(attributes(i)%name), cval=TRIM(attributes(i)%catt))
          CASE default
             ! <ERROR STATUS="FATAL">
             !   Unknown attribute type for attribute <name> to module/input_field <module_name>/<field_name>.
             !   Contact the developers.
             ! </ERROR>
             CALL error_mesg('diag_output_mod::diag_output_init', 'Unknown attribute type for global attribute "'&
                  &//TRIM(attributes(i)%name)//'" in file "'//TRIM(file_name)//'". Contact the developers.', FATAL)
          END SELECT
       END DO
    END IF
    !---- write grid type (mosaic or regular)
    CALL get_diag_global_att(gAtt)
    CALL mpp_write_meta(file_unit, 'grid_type', cval=TRIM(gAtt%grid_type))
    CALL mpp_write_meta(file_unit, 'grid_tile', cval=TRIM(gAtt%tile_name))

  END SUBROUTINE diag_output_init
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="write_axis_meta_data">
  !   <OVERVIEW>
  !     Write the axes meta data to file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE write_axis_meta_data(file_unit, axes, time_ops)
  !   </TEMPLATE>
  !   <IN NAME="file_unit" TYPE="INTEGER">File unit number</IN>
  !   <IN NAME="axes" TYPE="INTEGER, DIMENSION(:)">Array of axis ID's, including the time axis</IN>
  !   <IN NAME="time_ops" TYPE="LOGICAL, OPTIONAL">
  !     .TRUE. if this file contains any min, max, time_rms, or time_average
  !   </IN>
  SUBROUTINE write_axis_meta_data(file_unit, axes, time_ops)
    INTEGER, INTENT(in) :: file_unit, axes(:)
    LOGICAL, INTENT(in), OPTIONAL :: time_ops

    TYPE(domain1d)       :: Domain

    CHARACTER(len=mxch)  :: axis_name, axis_units
    CHARACTER(len=mxchl) :: axis_long_name
    CHARACTER(len=1)     :: axis_cart_name
    INTEGER              :: axis_direction, axis_edges
    REAL, ALLOCATABLE    :: axis_data(:)
    INTEGER, ALLOCATABLE :: axis_extent(:), pelist(:)

    INTEGER              :: calendar, id_axis, id_time_axis
    INTEGER              :: i, index, num, length, edges_index
    INTEGER              :: gbegin, gend, gsize, ndivs
    LOGICAL              :: time_ops1

    IF ( PRESENT(time_ops) ) THEN
       time_ops1 = time_ops
    ELSE
       time_ops1 = .FALSE.
    END IF

    !---- save the current file_unit ----
    IF ( num_axis_in_file == 0 ) current_file_unit = file_unit

    !---- dummy checks ----
    num = SIZE(axes(:))
    ! <ERROR STATUS="FATAL">number of axes < 1 </ERROR>
    IF ( num < 1 ) CALL error_mesg('write_axis_meta_data', 'number of axes < 1.', FATAL)

    ! <ERROR STATUS="FATAL">writing meta data out-of-order to different files.</ERROR>
    IF ( file_unit /= current_file_unit ) CALL error_mesg('write_axis_meta_data',&
         & 'writing meta data out-of-order to different files.', FATAL)

    !---- check all axes ----
    !---- write axis meta data for new axes ----
    DO i = 1, num
       id_axis = axes(i)
       index = get_axis_index ( id_axis )

       !---- skip axes already written -----
       IF ( index > 0 ) CYCLE

       !---- create new axistype (then point to) -----
       num_axis_in_file = num_axis_in_file + 1
       axis_in_file(num_axis_in_file) = id_axis
       edge_axis_flag(num_axis_in_file) = .FALSE.
       length = get_axis_global_length(id_axis)
       ALLOCATE(axis_data(length))

       CALL get_diag_axis(id_axis, axis_name, axis_units, axis_long_name,&
            & axis_cart_name, axis_direction, axis_edges, Domain, axis_data)

       IF ( Domain .NE. null_domain1d ) THEN
          IF ( length > 0 ) THEN
             CALL mpp_write_meta(file_unit, Axis_types(num_axis_in_file),&
                  & axis_name, axis_units, axis_long_name, axis_cart_name,&
                  & axis_direction, Domain, axis_data )
          ELSE
             CALL mpp_write_meta(file_unit, Axis_types(num_axis_in_file), axis_name,&
                  & axis_units, axis_long_name, axis_cart_name, axis_direction, Domain)
          END IF
       ELSE
          IF ( length > 0 ) THEN
             CALL mpp_write_meta(file_unit, Axis_types(num_axis_in_file), axis_name,&
                  & axis_units, axis_long_name, axis_cart_name, axis_direction, DATA=axis_data)
          ELSE
             CALL mpp_write_meta(file_unit, Axis_types(num_axis_in_file), axis_name,&
                  & axis_units, axis_long_name, axis_cart_name, axis_direction)
          END IF
       END IF

       !---- write additional attribute (calendar_type) for time axis ----
       !---- NOTE: calendar attribute is compliant with CF convention
       !---- http://www.cgd.ucar.edu/cms/eaton/netcdf/CF-current.htm#cal
       IF ( axis_cart_name == 'T' ) THEN
          time_axis_flag(num_axis_in_file) = .TRUE.
          id_time_axis = mpp_get_id(Axis_types(num_axis_in_file))
          calendar = get_calendar_type()
          CALL mpp_write_meta(file_unit, id_time_axis, 'calendar_type', cval=TRIM(valid_calendar_types(calendar)))
          CALL mpp_write_meta(file_unit, id_time_axis, 'calendar', cval=TRIM(valid_calendar_types(calendar)))
          IF ( time_ops1 ) THEN
             CALL mpp_write_meta( file_unit, id_time_axis, 'bounds', cval = TRIM(axis_name)//'_bounds')
          END IF
       ELSE
          time_axis_flag(num_axis_in_file) = .FALSE.
       END IF

       DEALLOCATE(axis_data)

       !------------- write axis containing edge information ---------------

       !  --- this axis has no edges -----
       IF ( axis_edges <= 0 ) CYCLE

       !  --- was this axis edge previously defined? ---
       id_axis = axis_edges
       edges_index = get_axis_index(id_axis)
       IF ( edges_index > 0 ) CYCLE

       !  ---- get data for axis edges ----
       length = get_axis_global_length ( id_axis )
       ALLOCATE(axis_data(length))
       CALL get_diag_axis(id_axis, axis_name, axis_units, axis_long_name, axis_cart_name,&
            & axis_direction, axis_edges, Domain, axis_data )

       !  ---- write edges attribute to original axis ----
       CALL mpp_write_meta(file_unit, mpp_get_id(Axis_types(num_axis_in_file)),&
            & 'edges', cval=axis_name )

       !  ---- add edges index to axis list ----
       !  ---- assume this is not a time axis ----
       num_axis_in_file = num_axis_in_file + 1
       axis_in_file(num_axis_in_file) = id_axis
       edge_axis_flag(num_axis_in_file) = .TRUE.
       time_axis_flag (num_axis_in_file) = .FALSE.

       !  ---- write edges axis to file ----
       IF ( Domain .NE. null_domain1d ) THEN
          ! assume domain decomposition is irregular and loop through all prev and next
          ! domain pointers extracting domain extents.  Assume all pes are used in
          ! decomposition
          CALL mpp_get_global_domain(Domain, begin=gbegin, END=gend, size=gsize)
          CALL mpp_get_layout(Domain, ndivs)
          IF ( ndivs .EQ. 1 ) THEN
             CALL mpp_write_meta(file_unit, Axis_types(num_axis_in_file), axis_name,&
                  & axis_units, axis_long_name, axis_cart_name, axis_direction, DATA=axis_data )
          ELSE
             IF ( ALLOCATED(axis_extent) ) DEALLOCATE(axis_extent)
             ALLOCATE(axis_extent(0:ndivs-1))
             CALL mpp_get_compute_domains(Domain,size=axis_extent(0:ndivs-1))
             gend=gend+1
             axis_extent(ndivs-1)= axis_extent(ndivs-1)+1
             IF ( ALLOCATED(pelist) ) DEALLOCATE(pelist)
             ALLOCATE(pelist(0:ndivs-1))
             CALL mpp_get_pelist(Domain,pelist)
             CALL mpp_write_meta(file_unit, Axis_types(num_axis_in_file),&
                  & axis_name, axis_units, axis_long_name, axis_cart_name,&
                  & axis_direction, Domain,  DATA=axis_data)
          END IF
       ELSE
          CALL mpp_write_meta(file_unit, Axis_types(num_axis_in_file), axis_name, axis_units,&
               & axis_long_name, axis_cart_name, axis_direction, DATA=axis_data)
       END IF
       DEALLOCATE (axis_data)
    END DO
  END SUBROUTINE write_axis_meta_data
  ! </SUBROUTINE>

  ! <FUNCTION NAME="write_field_meta_data">
  !   <OVERVIEW>
  !     Write the field meta data to file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     TYPE(diag_fieldtype) FUNCTION write_field_meta_data(file_unit, name, axes, units,
  !     long_name, rnage, pack, mval, avg_name, time_method, standard_name, interp_method)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     The meta data for the field is written to the file indicated by file_unit
  !   </DESCRIPTION>
  !   <IN NAME="file_unit" TYPE="INTEGER">Output file unit number</IN>
  !   <IN NAME="name" TYPE="CHARACTER(len=*)">Field name</IN>
  !   <IN NAME="axes" TYPE="INTEGER, DIMENSION(:)">Array of axis IDs</IN>
  !   <IN NAME="units" TYPE="CHARACTER(len=*)">Field units</IN>
  !   <IN NAME="long_name" TYPE="CHARACTER(len=*)">Field's long name</IN>
  !   <IN NAME="range" TYPE="REAL, DIMENSION(2), OPTIONAL">
  !     Valid range (min, max).  If min > max, the range will be ignored
  !   </IN>
  !   <IN NAME="pack" TYPE="INTEGER, OPTIONAL" DEFAULT="2">
  !     Packing flag.  Only valid when range specified.  Valid values:
  !     <UL>
  !       <LI> 1 = 64bit </LI>
  !       <LI> 2 = 32bit </LI>
  !       <LI> 4 = 16bit </LI>
  !       <LI> 8 =  8bit </LI>
  !     </UL>
  !   </IN>
  !   <IN NAME="mval" TYPE="REAL, OPTIONAL">Missing value, must be within valid range</IN>
  !   <IN NAME="avg_name" TYPE="CHARACTER(len=*), OPTIONAL">
  !     Name of variable containing time averaging info
  !   </IN>
  !   <IN NAME="time_method" TYPE="CHARACTER(len=*), OPTIONAL">
  !     Name of transformation applied to the time-varying data, i.e. "avg", "min", "max"
  !   </IN>
  !   <IN NAME="standard_name" TYPE="CHARACTER(len=*), OPTIONAL">Standard name of field</IN>
  !   <IN NAME="interp_method" TYPE="CHARACTER(len=*), OPTIONAL" />
  FUNCTION write_field_meta_data ( file_unit, name, axes, units, long_name, range, pack, mval,&
       & avg_name, time_method, standard_name, interp_method, attributes, num_attributes) result ( Field )
    INTEGER, INTENT(in) :: file_unit, axes(:)
    CHARACTER(len=*), INTENT(in) :: name, units, long_name
    REAL, OPTIONAL, INTENT(in) :: RANGE(2), mval
    INTEGER, OPTIONAL, INTENT(in) :: pack
    CHARACTER(len=*), OPTIONAL, INTENT(in) :: avg_name, time_method, standard_name
    CHARACTER(len=*), OPTIONAL, INTENT(in) :: interp_method
    TYPE(diag_atttype), DIMENSION(:), _ALLOCATABLE, OPTIONAL, INTENT(in) :: attributes
    INTEGER, OPTIONAL, INTENT(in) :: num_attributes

    CHARACTER(len=128) :: standard_name2
    CHARACTER(len=1280) :: att_str
    TYPE(diag_fieldtype) :: Field
    LOGICAL :: coord_present
    CHARACTER(len=40) :: aux_axes(SIZE(axes))
    CHARACTER(len=160) :: coord_att

    REAL :: scale, add
    INTEGER :: i, indexx, num, ipack, np, att_len
    LOGICAL :: use_range
    INTEGER :: axis_indices(SIZE(axes))

    !---- dummy checks ----
    coord_present = .FALSE.
    IF( PRESENT(standard_name) ) THEN
       standard_name2 = standard_name
    ELSE
       standard_name2 = 'none'
    END IF

    num = SIZE(axes(:))
    ! <ERROR STATUS="FATAL">number of axes < 1</ERROR>
    IF ( num < 1 ) CALL error_mesg ( 'write_meta_data', 'number of axes < 1', FATAL)
    ! <ERROR STATUS="FATAL">writing meta data out-of-order to different files</ERROR>
    IF ( file_unit /= current_file_unit ) CALL error_mesg ( 'write_meta_data',  &
         & 'writing meta data out-of-order to different files', FATAL)


    !---- check all axes for this field ----
    !---- set up indexing to axistypes ----
    DO i = 1, num
       indexx = get_axis_index(axes(i))
       !---- point to existing axistype -----
       IF ( indexx > 0 ) THEN
          axis_indices(i) = indexx
       ELSE
          ! <ERROR STATUS="FATAL">axis data not written for field</ERROR>
          CALL error_mesg ('write_field_meta_data',&
               & 'axis data not written for field '//TRIM(name), FATAL)
       END IF
    END DO

    !  Create coordinate attribute
    IF ( num >= 2 ) THEN
       coord_att = ' '
       DO i = 1, num
          aux_axes(i) = get_axis_aux(axes(i))
          IF( TRIM(aux_axes(i)) /= 'none' ) THEN
             IF(LEN_TRIM(coord_att) == 0) THEN
                coord_att = TRIM(aux_axes(i))
             ELSE
                coord_att = TRIM(coord_att)// ' '//TRIM(aux_axes(i))
             ENDIF
             coord_present = .TRUE.
          END IF
       END DO
    END IF

    !--------------------- write field meta data ---------------------------

    !---- select packing? ----
    !(packing option only valid with range option)
    IF ( PRESENT(pack) ) THEN
       ipack = pack
    ELSE
       ipack = 2
    END IF

    !---- check range ----
    use_range = .FALSE.
    add = 0.0
    scale = 1.0
    IF ( PRESENT(range) ) THEN
       IF ( RANGE(2) > RANGE(1) ) THEN
          use_range = .TRUE.
          !---- set packing parameters ----
          IF ( ipack > 2 ) THEN
             np = ipack/4
             add = 0.5*(RANGE(1)+RANGE(2))
             scale = (RANGE(2)-RANGE(1)) / real(max_range(2,np)-max_range(1,np))
          END IF
       END IF
    END IF

    !---- select packing? ----
    IF ( PRESENT(mval) ) THEN
       Field%miss = mval
       Field%miss_present = .TRUE.
       IF ( ipack > 2 ) THEN
          np = ipack/4
          Field%miss_pack = REAL(missval(np))*scale+add
          Field%miss_pack_present = .TRUE.
       ELSE
          Field%miss_pack = mval
          Field%miss_pack_present = .FALSE.
       END IF
    ELSE
       Field%miss_present = .FALSE.
       Field%miss_pack_present = .FALSE.
    END IF

    !------ write meta data and return fieldtype -------
    IF ( use_range ) THEN
       IF ( Field%miss_present ) THEN
          CALL mpp_write_meta(file_unit, Field%Field,&
               & Axis_types(axis_indices(1:num)),&
               & name, units, long_name,&
               & RANGE(1), RANGE(2),&
               & missing=Field%miss_pack,&
               & fill=Field%miss_pack,&
               & scale=scale, add=add, pack=ipack,&
               & time_method=time_method)
       ELSE
          CALL mpp_write_meta(file_unit, Field%Field,&
               & Axis_types(axis_indices(1:num)),&
               & name, units,  long_name,&
               & RANGE(1), RANGE(2),&
               & missing=CMOR_MISSING_VALUE,&
               & fill=CMOR_MISSING_VALUE,&
               & scale=scale, add=add, pack=ipack,&
               & time_method=time_method)
       END IF
    ELSE
       IF ( Field%miss_present ) THEN
          CALL mpp_write_meta(file_unit, Field%Field,&
               & Axis_types(axis_indices(1:num)),&
               & name, units, long_name,&
               & missing=Field%miss_pack,&
               & fill=Field%miss_pack,&
               & pack=ipack, time_method=time_method)
       ELSE
          CALL mpp_write_meta(file_unit, Field%Field,&
               & Axis_types(axis_indices(1:num)),&
               & name, units, long_name,&
               & missing=CMOR_MISSING_VALUE,&
               & fill=CMOR_MISSING_VALUE,&
               & pack=ipack, time_method=time_method)
       END IF
    END IF

    !---- write user defined attributes -----
    IF ( PRESENT(num_attributes) ) THEN
       IF ( PRESENT(attributes) ) THEN
          IF ( num_attributes .GT. 0 .AND. _ALLOCATED(attributes) ) THEN
             DO i = 1, num_attributes
                SELECT CASE (attributes(i)%type)
                CASE (NF90_INT)
                   IF ( .NOT._ALLOCATED(attributes(i)%iatt) ) THEN
                      CALL error_mesg('diag_output_mod::write_field_meta_data',&
                           & 'Integer attribute type indicated, but array not allocated for attribute '&
                           &//TRIM(attributes(i)%name)//' for field '//TRIM(name)//'. Contact the developers.', FATAL)
                   END IF
                   CALL mpp_write_meta(file_unit, mpp_get_id(Field%Field), TRIM(attributes(i)%name),&
                        & ival=attributes(i)%iatt)
                CASE (NF90_FLOAT)
                   IF ( .NOT._ALLOCATED(attributes(i)%fatt) ) THEN
                      CALL error_mesg('diag_output_mod::write_field_meta_data',&
                           & 'Real attribute type indicated, but array not allocated for attribute '&
                           &//TRIM(attributes(i)%name)//' for field '//TRIM(name)//'. Contact the developers.', FATAL)
                   END IF
                   CALL mpp_write_meta(file_unit, mpp_get_id(Field%Field), TRIM(attributes(i)%name),&
                        & rval=attributes(i)%fatt)
                CASE (NF90_CHAR)
                   att_str = attributes(i)%catt
                   att_len = attributes(i)%len
                   IF ( TRIM(attributes(i)%name).EQ.'cell_methods' .AND. PRESENT(time_method) ) THEN
                      ! Append ",time: time_method" if time_method present
                      att_str = attributes(i)%catt(1:attributes(i)%len)//' time: '//time_method
                      att_len = LEN_TRIM(att_str)
                   END IF
                   CALL mpp_write_meta(file_unit, mpp_get_id(Field%Field), TRIM(attributes(i)%name),&
                        & cval=att_str(1:att_len))
                CASE default
                   CALL error_mesg('diag_output_mod::write_field_meta_data', 'Invalid type for field attribute '&
                        &//TRIM(attributes(i)%name)//' for field '//TRIM(name)//'. Contact the developers.', FATAL)
                END SELECT
             END DO
          ELSE
             ! Catch some bad cases
             IF ( num_attributes .GT. 0 .AND. .NOT._ALLOCATED(attributes) ) THEN
                CALL error_mesg('diag_output_mod::write_field_meta_data',&
                     & 'num_attributes > 0 but attributes is not allocated for attribute '&
                     &//TRIM(attributes(i)%name)//' for field '//TRIM(name)//'. Contact the developers.', FATAL)
             ELSE IF ( num_attributes .EQ. 0 .AND. _ALLOCATED(attributes) ) THEN
                CALL error_mesg('diag_output_mod::write_field_meta_data',&
                     & 'num_attributes == 0 but attributes is allocated for attribute '&
                     &//TRIM(attributes(i)%name)//' for field '//TRIM(name)//'. Contact the developers.', FATAL)
             END IF
          END IF
       ELSE
          ! More edge error cases
          CALL error_mesg('diag_output_mod::write_field_meta_data',&
               & 'num_attributes present but attributes missing for attribute '&
               &//TRIM(attributes(i)%name)//' for field '//TRIM(name)//'. Contact the developers.', FATAL)
       END IF
    ELSE IF ( PRESENT(attributes) ) THEN
       CALL error_mesg('diag_output_mod::write_field_meta_data',&
            & 'attributes present but num_attributes missing for attribute '&
            &//TRIM(attributes(i)%name)//' for field '//TRIM(name)//'. Contact the developers.', FATAL)
    END IF


    !---- write additional attribute for time averaging -----
    IF ( PRESENT(avg_name) ) THEN
       IF ( avg_name(1:1) /= ' ' ) THEN
          CALL mpp_write_meta(file_unit, mpp_get_id(Field%Field),&
             & 'time_avg_info',&
             & cval=trim(avg_name)//'_T1,'//trim(avg_name)//'_T2,'//trim(avg_name)//'_DT')
       END IF
    END IF

    ! write coordinates attribute for CF compliance
    IF ( coord_present ) &
         CALL mpp_write_meta(file_unit, mpp_get_id(Field%Field),&
         & 'coordinates', cval=TRIM(coord_att))
    IF ( TRIM(standard_name2) /= 'none' ) CALL mpp_write_meta(file_unit, mpp_get_id(Field%Field),&
         & 'standard_name', cval=TRIM(standard_name2))

    !---- write attribute for interp_method ----
    IF( PRESENT(interp_method) ) THEN
       CALL mpp_write_meta ( file_unit, mpp_get_id(Field%Field),&
            & 'interp_method', cval=TRIM(interp_method))
    END IF

    !---- get axis domain ----
    Field%Domain = get_domain2d ( axes )
    Field%tile_count = get_tile_count ( axes )

  END FUNCTION write_field_meta_data
  ! </FUNCTION>

  ! <SUBROUTINE NAME="done_meta_data">
  !   <OVERVIEW>
  !     Writes axis data to file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE done_meta_data(file_unit)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Writes axis data to file.  This subroutine is to be called once per file
  !     after all <TT>write_meta_data</TT> calls, and before the first
  !     <TT>diag_field_out</TT> call.
  !   </DESCRIPTION>
  !   <IN NAME="file_unit" TYPE="INTEGER">Output file unit number</IN>
  SUBROUTINE done_meta_data(file_unit)
    INTEGER,  INTENT(in)  :: file_unit

    INTEGER               :: i

    !---- write data for all non-time axes ----
    DO i = 1, num_axis_in_file
       IF ( time_axis_flag(i) ) CYCLE
       CALL mpp_write(file_unit, Axis_types(i))
    END DO

    num_axis_in_file = 0
  END SUBROUTINE done_meta_data
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="diag_field_out">
  !   <OVERVIEW>
  !     Writes field data to an output file.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     SUBROUTINE diag_field_out(file_unit, field, data, time)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Writes field data to an output file.
  !   </DESCRIPTION>
  !   <IN NAME="file_unit" TYPE="INTEGER">Output file unit number</IN>
  !   <INOUT NAME="field" TYPE="TYPE(diag_fieldtype)"></INOUT>
  !   <INOUT NAME="data" TYPE="REAL, DIMENSIONS(:,:,:,:)"></INOUT>
  !   <IN NAME="time" TYPE="REAL, OPTIONAL"></IN>
  SUBROUTINE diag_field_out(file_unit, Field, DATA, time)
    INTEGER, INTENT(in) :: file_unit
    TYPE(diag_fieldtype), INTENT(inout) :: Field
    REAL , INTENT(inout) :: data(:,:,:,:)
    REAL, OPTIONAL, INTENT(in) :: time

    !---- replace original missing value with (un)packed missing value ----
    !print *, 'PE,name,miss_pack_present=',mpp_pe(), &
    !  trim(Field%Field%name),Field%miss_pack_present
    IF ( Field%miss_pack_present ) THEN
       WHERE ( DATA == Field%miss ) DATA = Field%miss_pack
    END IF

    !---- output data ----
    IF ( Field%Domain .NE. null_domain2d ) THEN
       IF( Field%miss_present ) THEN
          CALL mpp_write(file_unit, Field%Field, Field%Domain, DATA, time, &
                      tile_count=Field%tile_count, default_data=Field%miss_pack)
       ELSE
          CALL mpp_write(file_unit, Field%Field, Field%Domain, DATA, time, &
                      tile_count=Field%tile_count, default_data=CMOR_MISSING_VALUE)
       END IF
    ELSE
       CALL mpp_write(file_unit, Field%Field, DATA, time)
    END IF
  END SUBROUTINE diag_field_out
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="diag_flush">
  !   <OVERVIEW>
  !     Flush buffer and insure data is not lost.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     CALL diag_flush(file_unit)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     This subroutine can be called periodically to flush the buffer, and
  !     insure that data is not lost if the execution fails.
  !   </DESCRIPTION>
  !   <IN NAME="file_unit" TYPE="INTEGER">Output file unit number to flush</IN>
  SUBROUTINE diag_flush(file_unit)
    INTEGER, INTENT(in) :: file_unit

    CALL mpp_flush (file_unit)
  END SUBROUTINE diag_flush
  ! </SUBROUTINE>


  ! <FUNCTION NAME="get_axis_index">
  !   <OVERVIEW>
  !     Return the axis index number.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     INTEGER FUNCTION get_axis_index(num)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Return the axis index number.
  !   </DESCRIPTION>
  !   <IN NAME="num" TYPE="INTEGER"></IN>
  FUNCTION get_axis_index(num) RESULT ( index )
    INTEGER, INTENT(in) :: num

    INTEGER :: index
    INTEGER :: i

    !---- get the array index for this axis type ----
    !---- set up pointers to axistypes ----
    !---- write axis meta data for new axes ----
    index = 0
    DO i = 1, num_axis_in_file
       IF ( num == axis_in_file(i) ) THEN
          index = i
          EXIT
       END IF
    END DO
  END FUNCTION get_axis_index
  ! </FUNCTION>

  ! <SUBROUTINE NAME="get_diag_global_att">
  !   <OVERVIEW>
  !     Return the global attribute type.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     CALL get_diag_global_att(gAtt)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Return the global attribute type.
  !   </DESCRIPTION>
  !   <OUT NAME="gAtt" TYPE="TYPE(diag_global_att_type"></OUT>
  SUBROUTINE get_diag_global_att(gAtt)
    TYPE(diag_global_att_type), INTENT(out) :: gAtt

    gAtt=diag_global_att
  END SUBROUTINE get_diag_global_att
  ! </SUBROUTINE>

  ! <SUBROUTINE NAME="set_diag_global_att">
  !   <OVERVIEW>
  !     Set the global attribute type.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     CALL set_diag_global_att(component, gridType, timeName)
  !   </TEMPLATE>
  !   <DESCRIPTION>
  !     Set the global attribute type.
  !   </DESCRIPTION>
  !   <IN NAME="component" TYPE="CHARACTER(len=*)"></IN>
  !   <IN NAME="gridType" TYPE="CHARACTER(len=*)"></IN>
  !   <IN NAME="tileName" TYPE="CHARACTER(len=*)"></IN>
  SUBROUTINE set_diag_global_att(component, gridType, tileName)
    CHARACTER(len=*),INTENT(in) :: component, gridType, tileName

    ! The following two lines are set to remove compile time warnings
    ! about 'only used once'.
    CHARACTER(len=64) :: component_tmp
    component_tmp = component
    ! Don't know how to set these for specific component
    ! Want to be able to say
    ! if(output_file has component) then
    diag_global_att%grid_type = gridType
    diag_global_att%tile_name = tileName
    ! endif
  END SUBROUTINE set_diag_global_att
  ! </SUBROUTINE>

END MODULE diag_output_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !MODULE: mtridiagonal --- solving the system\label{sec:tridiagonal}
!
! !INTERFACE:
   MODULE mtridiagonal

   use mpp_mod, only: mpp_pe, mpp_root_pe
!
! !DESCRIPTION:
!
!  Solves a linear system of equations with a tridiagonal matrix
!  using Gaussian elimination.
!
! !PUBLIC MEMBER FUNCTIONS:
   public init_tridiagonal, tridiagonal, clean_tridiagonal
!
! !PUBLIC DATA MEMBERS:
   REALTYPE, dimension(:), allocatable     :: au,bu,cu,du
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard & Karsten Bolding
!  $Log: tridiagonal_gotm.F90,v $
!  Revision 20.0  2013/12/14 00:14:06  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:01:18  smg
!  initial cvs ci to mom5
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:33:41  smg
!  updated to gotm-2012.03.09 CVS tagged code.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.8  2010-09-17 12:53:53  jorn
!  extensive code clean-up to ensure proper initialization and clean-up of all variables
!
!  Revision 1.7  2006-11-24 15:13:41  kbk
!  de-allocate memory and close open files
!
!  Revision 1.6  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.5  2004/08/17 15:33:47  lars
!  removed tabs
!
!  Revision 1.4  2003/03/28 09:20:36  kbk
!  added new copyright to files
!
!  Revision 1.3  2003/03/28 08:06:33  kbk
!  removed tabs
!
!  Revision 1.2  2003/03/10 08:54:16  gotm
!  Improved documentation and cleaned up code
!
!  Revision 1.1.1.1  2001/02/12 15:55:58  gotm
!  initial import into CVS
!
!EOP
!
!  private data members
   REALTYPE, private, dimension(:),allocatable  ::  ru,qu
!
!-----------------------------------------------------------------------

   contains

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Allocate memory
!
! !INTERFACE:
   subroutine init_tridiagonal(N)
!
! !DESCRIPTION:
!  This routines allocates memory necessary to perform the Gaussian
!  elimination.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: N
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard & Karsten Bolding
!
!EOP
!
! !LOCAL VARIABLES:
   integer                   :: rc
!
!-----------------------------------------------------------------------
!BOC
    if (mpp_pe() == mpp_root_pe()) then
   LEVEL1 'init_tridiagonal'
   endif
   allocate(au(0:N),stat=rc)
   if (rc /= 0) stop 'init_tridiagonal: Error allocating au)'
   au = _ZERO_

   allocate(bu(0:N),stat=rc)
   if (rc /= 0) stop 'init_tridiagonal: Error allocating bu)'
   bu = _ZERO_

   allocate(cu(0:N),stat=rc)
   if (rc /= 0) stop 'init_tridiagonal: Error allocating cu)'
   cu = _ZERO_

   allocate(du(0:N),stat=rc)
   if (rc /= 0) stop 'init_tridiagonal: Error allocating du)'
   du = _ZERO_

   allocate(ru(0:N),stat=rc)
   if (rc /= 0) stop 'init_tridiagonal: Error allocating ru)'
   ru = _ZERO_

   allocate(qu(0:N),stat=rc)
   if (rc /= 0) stop 'init_tridiagonal: Error allocating qu)'
   qu = _ZERO_

   return
   end subroutine init_tridiagonal
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: Simplified Gaussian elimination
!
! !INTERFACE:
   subroutine tridiagonal(N,fi,lt,value)
!
! !DESCRIPTION:
! A linear equation with tridiagonal matrix structure is solved here. The main
! diagonal is stored on {\tt bu}, the upper diagonal on {\tt au}, and the
! lower diagonal on {\tt cu}, the right hand side is stored on {\tt du}.
! The method used here is the simplified Gauss elimination, also called
! \emph{Thomas algorithm}.
!
! !USES:
   IMPLICIT NONE
!
! !INPUT PARAMETERS:
   integer, intent(in)                 :: N,fi,lt
!
! !OUTPUT PARAMETERS:
   REALTYPE                            :: value(0:N)
!
! !REVISION HISTORY:
!  Original author(s): Hans Burchard & Karsten Bolding
!  $Log: tridiagonal_gotm.F90,v $
!  Revision 20.0  2013/12/14 00:14:06  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:01:18  smg
!  initial cvs ci to mom5
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:33:41  smg
!  updated to gotm-2012.03.09 CVS tagged code.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.8  2010-09-17 12:53:53  jorn
!  extensive code clean-up to ensure proper initialization and clean-up of all variables
!
!  Revision 1.7  2006-11-24 15:13:41  kbk
!  de-allocate memory and close open files
!
!  Revision 1.6  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.5  2004/08/17 15:33:47  lars
!  removed tabs
!
!  Revision 1.4  2003/03/28 09:20:36  kbk
!  added new copyright to files
!
!  Revision 1.3  2003/03/28 08:06:33  kbk
!  removed tabs
!
!  Revision 1.2  2003/03/10 08:54:16  gotm
!  Improved documentation and cleaned up code
!
!  Revision 1.1.1.1  2001/02/12 15:55:58  gotm
!  initial import into CVS
!
!EOP
!
! !LOCAL VARIABLES:
   integer                   :: i
!
!-----------------------------------------------------------------------
!BOC
   ru(lt)=au(lt)/bu(lt)
   qu(lt)=du(lt)/bu(lt)

   do i=lt-1,fi+1,-1
      ru(i)=au(i)/(bu(i)-cu(i)*ru(i+1))
      qu(i)=(du(i)-cu(i)*qu(i+1))/(bu(i)-cu(i)*ru(i+1))
   end do

   qu(fi)=(du(fi)-cu(fi)*qu(fi+1))/(bu(fi)-cu(fi)*ru(fi+1))

   value(fi)=qu(fi)
   do i=fi+1,lt
      value(i)=qu(i)-ru(i)*value(i-1)
   end do


   return
   end subroutine tridiagonal
!EOC

!-----------------------------------------------------------------------
!BOP
!
! !IROUTINE: De-allocate memory
!
! !INTERFACE:
   subroutine clean_tridiagonal()
!
! !DESCRIPTION:
!  De-allocates memory allocated in init\_tridiagonal.
!
! !USES:
   IMPLICIT NONE
!
! !REVISION HISTORY:
!  Original author(s): Karsten Bolding
!
!EOP
!-----------------------------------------------------------------------
!BOC
   LEVEL1 'clean_tridiagonal'

   if (allocated(au)) deallocate(au)

   if (allocated(bu)) deallocate(bu)

   if (allocated(cu)) deallocate(cu)

   if (allocated(du)) deallocate(du)

   if (allocated(ru)) deallocate(ru)

   if (allocated(qu)) deallocate(qu)

   return
   end subroutine clean_tridiagonal
!EOC
!-----------------------------------------------------------------------

   end module mtridiagonal

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module mapz_module

  use fv_pack,      only: ak, bk, ks, ptop, cosp, acap,     &
                         u_ghosted, coslon, sinlon,          &
                         cose,  acosu, ptop_min, d2a3d, master &
                        ,  beglon, endlon, beglat, endlat

  use fill_module,  only: fillz

#ifdef VERT_FLUX
  use fv_diagnostics,   only: id_dnflux, id_upflux
  use diag_manager_mod, only: send_data
#endif

#ifdef SPMD
      use mod_comm, only: gid, mp_send3d, mp_recv3d
#endif
      use time_manager_mod, only: time_type      ! This is not needed if not under FMS
      use fv_arrays_mod, only: fv_array_check, fv_array_limits, &
           fv_print_chksums, fv_stack_push, fv_array_sync, fv_print_chksum, &
           isp, iep, jsp, jep, ksp, kep

      implicit none

      private
! !PUBLIC MEMBER FUNCTIONS:
      public benergy, geo_map, te_map, p_energy

#ifndef SPMD
      integer :: gid=0
#endif

CONTAINS

  subroutine te_map(consv, ps, omga, pe, pem, delp, pkz, pk, mdt,        &
       im, jm, km, p_map, nx, jfirst, jlast, nq, u, v,   &
       pt,  q, hs, r_vir, cp_vir, cp, akap, kord_mt,     &
       kord_tr, kord_tm,  peln,                          &
       tte0, ng_d,  ng_s, ua, va, fill, Time_next)
#ifdef use_shared_pointers
    use fv_arrays_mod, only: is,ie,js,je, isd,ied,jsd,jed, isg,ieg,jsg,jeg
    use fv_arrays_mod, only: nlev
    use fv_arrays_mod, only: ptr_ps_bp, ptr_pesouth
    real :: ps_bp (isg:ieg, js:je)
    pointer( p_ps_bp, ps_bp )
    real :: pesouth(isg:ieg, nlev+1)
    pointer( p_pesouth, pesouth )
#else
    use fv_arrays_mod, only: ps_bp, pesouth
#endif


! !ROUTINE: te_map --- Perform (optionally partial) remapping from surface to
!                      a chosen level


! !INPUT PARAMETERS:
    integer, intent(in):: mdt                   ! mapping time step (same as phys)
    integer, intent(in):: im, jm, km            ! x, y, z dimensions
    integer, intent(in):: nq                    ! number of tracers (including h2o)
    integer, intent(in):: nx                    ! number of SMP "decomposition" in x
    integer, intent(in):: ng_d
    integer, intent(in):: ng_s
    integer, intent(in):: jfirst, jlast         ! starting & ending latitude index
    integer, intent(in):: kord_mt                  ! Mapping oder for the vector winds
    integer, intent(in):: kord_tr                  ! Mapping oder for tracers
    integer, intent(in):: kord_tm                  ! Mapping oder for thermodynamics

    real, intent(in):: consv                 ! factor for TE conservation
    real, intent(in)::  r_vir
    real, intent(in):: cp_vir
    real, intent(in):: cp
    real, intent(in):: tte0(jfirst:jlast)
    real, intent(in):: hs(im,jfirst:jlast)  ! surface geopotential

    logical, intent(in):: p_map                 ! Do partial remapping
! layers between [1,ks] would stay Lagrangian
    logical, intent(in):: fill                  ! fill negative tracers
    type(time_type), optional, intent(in) :: Time_next

! !INPUT/OUTPUT
    real, intent(inout):: pk(im,jfirst:jlast,km+1) ! pe to the kappa
!Balaji: no assumed size?  real, intent(inout):: q(im,jfirst-ng_d:jlast+ng_d,km,*)
    real, intent(inout):: q(im,jfirst-ng_d:jlast+ng_d,km,nq)
    real, intent(inout):: delp(im,jfirst:jlast,km) ! pressure thickness
    real, intent(inout)::  pe(im,km+1,jfirst:jlast) ! pressure at layer edges
    real, intent(inout):: pem(im,km+1,jfirst:jlast) ! (old) pressure at layer edges
    real, intent(inout):: ps(im,jfirst:jlast)      ! surface pressure

! u-wind will be ghosted one latitude to the north upon exit
    real, intent(inout):: u(im,jfirst-ng_d:jlast+ng_s,km)   ! u-wind (m/s)
    real, intent(inout):: v(im,jfirst-ng_d:jlast+ng_d,km)   ! v-wind (m/s)
    real, intent(inout):: pt(im,jfirst-ng_d:jlast+ng_d,km)  ! virtual potential temperature 
! as input; output: temperature

    real, intent(inout):: ua(im,jfirst:jlast,km)   ! u-wind (m/s) on physics grid
    real, intent(inout):: va(im,jfirst:jlast,km)   ! v-wind (m/s) on physics grid
    real, intent(out):: omga(im,jfirst:jlast,km)    ! vertical press. velocity (pascal/sec)
    real, intent(out):: peln(im,km+1,jfirst:jlast)  ! log(pe)
    real, intent(out):: pkz(im,jfirst:jlast,km)     ! layer-mean pk for converting t to pt

! !DESCRIPTION:
!
! !REVISION HISTORY:
! SJL 03.11.04: Initial version for partial remapping
!
!EOP
!-----------------------------------------------------------------------

#ifdef VERT_FLUX
    real :: mflux(im,jfirst:jlast,km)
    logical used
#endif
    real rmin(nx*jm), rmax(nx*jm)
    real tte(jfirst:jlast)
! x-y
    real  u2(im,jfirst:jlast+1)
    real  v2(im,jfirst:jlast)
! y-z
    real   q2(im/nx,km)
    real  dp2(im/nx,km)
    real  pe0(im,km+1)
    real  pe1(im,km+1)
    real  pe2(im,km+1)
    real  pe3(im,km+1)
    real phis(im,km+1)
! x
    real    gz(im)
    real ratio(im)
    real   bte(im)

    integer i, j, k, js2g0, jn2g0
    integer kmap

    real akap, dak, bkh, qmax, qmin
    real te_sp,  te_np
    real xsum, ysum, tsum
    real zsum(im)
    real dtmp
    real rdt5
    real rg
    real tm
    real te1
    real dlnp

    integer ixj, jp, it, i1, i2
    integer iq
    logical:: diag = .false.

    integer :: ixjs, ixje
#ifdef use_shared_pointers
    pointer( p_tte, tte )
#ifdef VERT_FLUX
    pointer( p_mflux, mflux )
    call fv_stack_push( p_mflux, im*km*(jlast-jfirst+1) )
#endif
    call fv_stack_push( p_tte, jlast-jfirst+1 )
    p_ps_bp = ptr_ps_bp
    p_pesouth = ptr_pesouth
#endif

    call fv_print_chksums( 'Entering  te_map' )
!     diag = .true.
    call fv_array_check( LOC(hs) )
    call fv_array_check( LOC(pk) )
    call fv_array_check( LOC(q) )
    call fv_array_check( LOC(delp) )
    call fv_array_check( LOC(pe) )
    call fv_array_check( LOC(pem) )
    call fv_array_check( LOC(ps) )
    call fv_array_check( LOC(u) )
    call fv_array_check( LOC(v) )
    call fv_array_check( LOC(pt) )
    call fv_array_check( LOC(ua) )
    call fv_array_check( LOC(va) )
    call fv_array_check( LOC(omga) )
    call fv_array_check( LOC(peln) )
    call fv_array_check( LOC(pkz) )

    if ( p_map ) then
        kmap = ks+1
    else
        kmap = 1
    endif

#ifdef SPMD
    call mp_send3d(gid-1, gid+1, im, jm, km, 1, im, jfirst-ng_d, jlast+ng_s, &
         1, km, 1, im, jfirst, jfirst, 1, km, u)
    call mp_send3d(gid+1, gid-1, im, km+1, jm, 1, im, 1, km+1,               &
         jfirst, jlast, 1, im, 1, km+1, jlast, jlast, pe)
#endif

    js2g0 = max(2,   jfirst)
    jn2g0 = min(jm-1,jlast)

    call pkez(nx, im, km, jfirst, jlast,             &
         pe, pk, akap, ks, peln, pkz, .false.)

#ifdef SPMD
    call mp_recv3d(gid+1, im, jm, km, 1, im, jfirst-ng_d, jlast+ng_s, &
         1, km, 1, im, jlast+1, jlast+1, 1, km, u)
    call fv_array_sync()
#endif

!$omp parallel do private(i, j, k, u2, v2, te_sp, te_np)
    do 1000 k=ksp,kep !1,km
! Compute cp*T + KE

       do j=js2g0,min(jlast+1,jm)    ! u ghosted one lat to the North
          do i=1,im
             u2(i,j) = cose(j) * u(i,j,k)**2
          enddo
       enddo

       do j=js2g0,jn2g0
          do i=1,im
             v2(i,j) = v(i,j,k)**2
          enddo

          do i=1,im-1
             ua(i,j,k) = 0.25 * ( (u2(i,j)+u2(i,j+1))*acosu(j) +   &
                  v2(i,j) + v2(i+1,j)  ) +         &
                  pt(i,j,k)*pkz(i,j,k)
!                        pt(i,j,k)*pkz(i,j,k)/(1.+r_vir*q(i,j,k,1))  &
!                       * (1.+cp_vir*q(i,j,k,1))
          enddo
! i=im
          ua(im,j,k) = 0.25 * ( (u2(im,j)+u2(im,j+1))*acosu(j) +   &
               v2(im,j) + v2(1,j)  ) +            &
               pt(im,j,k)*pkz(im,j,k)
!                       * (1.+cp_vir*q(im,j,k,1))
!                       * (1.+cp_vir*q(im,j,k,1))
       enddo

       if( jfirst == 1 ) then
           te_sp = 0.
           do i=1,im
!            te_sp = te_sp + u2(i,2) + v2(i,2)
! SJL: 01/26/04
              te_sp = te_sp + 0.5*u2(i,2)/cose(2)
           enddo
           te_sp = 0.5*te_sp/float(im) +  pt(1,1,k)*pkz(1,1,k)
!                    * (1.+cp_vir*q(1,1,k,1)) / (1.+r_vir*q(1,1,k,1))
           do i=1,im
              ua(i,1,k) = te_sp
           enddo
       endif

       if ( jlast == jm ) then
           te_np = 0.
           do i=1,im
!            te_np = te_np + u2(i,jm) + v2(i,jm-1)
! SJL: 01/26/04
              te_np = te_np + 0.5*u2(i,jm)/cose(jm)
           enddo
           te_np = 0.5*te_np/float(im) + pt(1,jm,k)*pkz(1,jm,k)
!              * (1.+cp_vir*q(1,jm,k,1)) / (1.+r_vir*q(1,jm,k,1))

           do i=1,im
              ua(i,jm,k) = te_np
           enddo
       endif

! Compute va; geopotential increments
       do j=jfirst,jlast
          do i=1,im
             va(i,j,k) = pt(i,j,k)*(pk(i,j,k+1)-pk(i,j,k))
          enddo
       enddo
1000 end do !continue
    call fv_array_sync()

#ifdef SPMD
    call mp_recv3d(gid-1, im, km+1, jm, 1, im, 1, km+1, jfirst-1, jfirst-1, &
         1, im,    1, km+1, jfirst-1, jfirst-1, pesouth)
    call fv_array_sync()
#endif

    it = im / nx
    jp = nx * ( jlast - jfirst + 1 )

    call fv_array_limits( 1, jp, ixjs, ixje )
!$omp parallel do default(shared)                 &
!$omp private(i, j, k, pe0, pe1, pe2, pe3, ratio) &
!$omp private(dak,bkh,rdt5,phis,ixj,i1,i2, iq, q2, dp2)
    do 2000 ixj=ixjs, ixje !1, jp

       j  = jfirst + (ixj-1) / nx
       i1 = 1 + it * mod(ixj-1, nx)
       i2 = i1 + it - 1

! Copy data to local 2D arrays.
       do k=1,km+1
          do i=i1,i2
             pe1(i,k) = pe(i,k,j)
          enddo
       enddo

       rdt5 = 0.5 / float(mdt)
#ifdef VERT_FLUX
! use pe0 for net flux; pkz for downward (positive) flux; mflux for upward flux
       do k=1,km+1
          do i=i1,i2
             pe0(i,k) = pe1(i,k) - (ak(k)+bk(k)*pe1(i,km+1))
          enddo
       enddo
       do k=1,km
          do i=i1,i2
             dak = rdt5*(pe0(i,k)+pe0(i,k+1))
             if ( dak < 0. ) then
                 mflux(i,j,k) = dak
                 pkz(i,j,k) = 0.
             else
                 mflux(i,j,k) = 0.
                 pkz(i,j,k) = dak
             endif
          enddo
       enddo
#endif

       if ( p_map ) then
           do k=1,kmap
              do i=i1,i2
                 pe2(i,k) = pe1(i,k)     ! Stay Lagrangian
              enddo
           enddo
           do k=kmap+1,km
              do i=i1,i2
                 pe2(i,k) = (1.-bk(k))*pe1(i,k) + bk(k)*(ak(k)+bk(k)*pe1(i,km+1))
              enddo
           enddo
       else
           do k=1,ks+1
              do i=i1,i2
                 pe2(i,k) = ak(k)
              enddo
           enddo
           do k=ks+2,km
              do i=i1,i2
                 pe2(i,k) = ak(k) + bk(k)*pe1(i,km+1)
              enddo
           enddo
       endif

       do i=i1,i2
          pe2(i,km+1) = pe1(i,km+1)
       enddo

! Compute omga (dp/dt)
       do k=2,km+1
          do i=i1,i2
             pe0(i,k) = pe1(i,k) - pem(i,k,j)
          enddo
       enddo

       do i=i1,i2
! update ps
          ps(i,j)    = pe1(i,km+1)
          ps_bp(i,j) = ps(i,j)
          omga(i,j,1)  = rdt5 * pe0(i,2)
       enddo

       do k=2,km
          do i=i1,i2
             omga(i,j,k) = rdt5 * ( pe0(i,k) + pe0(i,k+1) )
          enddo
       enddo

       if( ks /= 0 ) then
           if ( .not.  p_map ) then
               do k=1,ks
                  dak = ak(k+1) - ak(k)
                  do i=i1,i2
                     delp(i,j,k) = dak
                  enddo
               enddo
           endif
       endif

       do k=ks+1,km
          do i=i1,i2
             delp(i,j,k) = pe2(i,k+1) - pe2(i,k)
          enddo
       enddo

!---------------------
! Compute Total Energy
!---------------------
       do i=i1,i2
          phis(i,km+1) = hs(i,j)      
       enddo

       do k=km,1,-1
          do i=i1,i2
             phis(i,k) = phis(i,k+1) + va(i,j,k)   
          enddo
       enddo

       do k=1,km+1
          do i=i1,i2
             phis(i,k) = phis(i,k) * pe1(i,k)
          enddo
       enddo

       do k=1,km
          do i=i1,i2
! ua is used as the total energy
             ua(i,j,k) = ua(i,j,k)+(phis(i,k+1)-phis(i,k))/(pe1(i,k+1)-pe1(i,k))
          enddo
       enddo

!----------------
! Map Total Energy
!----------------

! kord=7 combined with high vertical resolutiona in the stratosphere
! may produce insufficient vertical dampping; inertial instability like oscillations in
! v-wind  may occur
! Therefore, use kord=7 only for low vertical resolution cases.

       call map1_ppm (km,   pe1,   ua,  kmap,                &
            km,   pe2,   ua,  0,     0,            &
            im,   i1, i2, j, jfirst, jlast, 1, kord_tm)

!----------------
! Map constituents
!----------------
       if(nq /= 0) then

           do k=1,km
              do i=i1,i2
                 dp2(i-i1+1,k) = pe2(i,k+1) - pe2(i,k)
              enddo
           enddo

!------------------------------------------------------------------
! Do remapping one tracer at a time; seems to be faster on the SGI
! It requires less memory than mapn_ppm

           do iq=1,nq

              call map1_q2(km, pe1, q(1,jfirst-ng_d,1,iq), kmap,  &
                   km, pe2, q2, im,    &
                   i1, i2, 0, kord_tr, j, jfirst, jlast, ng_d)

              if (fill) call fillz(i2-i1+1, km, 1, q2, dp2)
              do k=1,km
                 do i=i1,i2
                    q(i,j,k,iq) = q2(i-i1+1,k)
                 enddo
              enddo
           enddo
       endif

!------
! map u
!------
       if(j /= 1) then

           do i=i1,i2
              pe0(i,1) = pe1(i,1)
           enddo

           if (j > jfirst) then

               do k=2,km+1
                  do i=i1,i2
                     pe0(i,k) = 0.5*(pe1(i,k)+pe(i,k,j-1))
                  enddo
               enddo

               do k=ks+2,km+1
                  bkh = 0.5*bk(k)
                  do i=i1,i2
                     pe3(i,k) = ak(k) + bkh*(pe1(i,km+1)+pe(i,km+1,j-1))
                  enddo
               enddo

#ifdef SPMD
           else
               do k=2,km+1
                  do i=i1,i2
                     pe0(i,k) = 0.5*(pe1(i,k)+pesouth(i,k))
                  enddo
               enddo

               do k=ks+2,km+1
                  bkh = 0.5*bk(k)
                  do i=i1,i2
                     pe3(i,k) = ak(k) + bkh*(pe1(i,km+1)+pesouth(i,km+1))
                  enddo
               enddo
#endif
           endif

           if ( p_map ) then
               do k=1,kmap
                  do i=i1,i2
                     pe3(i,k) = pe0(i,k) 
                  enddo
               enddo
               do k=kmap+1,km
                  do i=i1,i2
                     pe3(i,k) =  (1.-bk(k))*pe0(i,k) + bk(k)*pe3(i,k)
                  enddo
               enddo
           else
               do k=1,ks+1
                  do i=i1,i2
                     pe3(i,k) = ak(k)
                  enddo
               enddo
           endif

           call map1_ppm( km,   pe0,   u, kmap,                  &
                km,   pe3,   u, ng_d, ng_s,            &
                im, i1, i2, j, jfirst, jlast, -1, kord_mt)
       endif

!------
! map v
!------
       if(j /= 1 .and. j /= jm) then
           do k=2,km+1

!-----------------------------------------------------------------------------
              if( i1 > 1 ) then
                  pe0(i1,k) = 0.5*(pe1(i1,k)+pe(i1-1,k,j))
              else
                  pe0(1,k) = 0.5*(pe1(1,k)+pe(im,k,j))
              endif
!-----------------------------------------------------------------------------

              do i=i1+1,i2
                 pe0(i ,k) = 0.5*(pe1(i,k)+pe1(i-1,k))
              enddo
           enddo

           do k=ks+2,km+1
!-----------------------------------------------------------------------------
              if ( i1 > 1 ) then
                  pe3(i1,k) = 0.5 * ( pe2(i1,k) +            &
                       (ak(k) + bk(k)*pe(i1-1,km+1,j)))
              else
                  pe3(1,k) = 0.5 * ( pe2(1,k) +            &
                       (ak(k) + bk(k)*pe(im,km+1,j)))
              endif
!-----------------------------------------------------------------------------

              do i=i1+1,i2
                 pe3(i,k) = 0.5*(pe2(i,k)+pe2(i-1,k))
              enddo
           enddo

           if ( p_map ) then
               do k=1,kmap
                  do i=i1,i2
                     pe3(i,k) = pe0(i,k) 
                  enddo
               enddo
               do k=kmap+1,km
                  do i=i1,i2
                     pe3(i,k) = (1.-bk(k))*pe0(i,k)+ bk(k)*pe3(i,k)
                  enddo
               enddo
           endif

           call map1_ppm ( km,   pe0,   v, kmap,                &
                km,   pe3,   v, ng_d, ng_d,          &
                im, i1, i2, j, jfirst, jlast, -1, kord_mt)
       endif

! Save new PE to pem
       do k=2,km+1
          do i=i1,i2
             pem(i,k,j) = pe2(i,k)
          enddo
       enddo

! Check deformation.
       if( diag .and. .not. p_map ) then
           rmax(ixj) = 0.
           rmin(ixj) = 1.
           do k=1,km
              do i=i1,i2
                 ratio(i) = (pe1(i,k+1)-pe1(i,k)) / (pe2(i,k+1)-pe2(i,k))
              enddo

              do i=i1,i2
                 if(ratio(i) > rmax(ixj)) then
                     rmax(ixj) = ratio(i)
                 elseif(ratio(i) < rmin(ixj)) then
                     rmin(ixj) = ratio(i)
                 endif
              enddo
           enddo
       endif
2000 end do !continue
    call fv_array_sync()
#ifdef SPMD
    call mp_send3d(gid-1, gid+1, im, jm, km, 1, im, jfirst-ng_d, jlast+ng_s, &
         1, km, 1, im, jfirst, jfirst, 1, km, u)
#endif

#ifdef VERT_FLUX
! use pkz for downward flux
    if(id_dnflux > 0) used = send_data ( id_dnflux,   pkz(beglon:endlon,beglat:endlat), Time_next )
    if(id_upflux > 0) used = send_data ( id_upflux, mflux(beglon:endlon,beglat:endlat), Time_next )
!      deallocate (mflux)
#endif

    if( diag .and. .not. p_map ) then
        qmin = rmin(1)
        do ixj=2, jp
           if(rmin(ixj) < qmin) then
               qmin = rmin(ixj)
           endif
        enddo

        qmax = rmax(1)
        do ixj=2, jp
           if(rmax(ixj) > qmax) then
               qmax = rmax(ixj)
           endif
        enddo
        if(qmin < 0.5 .or. qmax > 1.5) then
            write(6,*) 'PE=',gid, '[Rmin, Rmax] = [', qmin, ', ', qmax,']'
        endif
    endif

!$omp parallel do private(i,j,k)
    do j=jsp,jep !jfirst,jlast
       if ( p_map ) then
           do k=kmap+1,km
              do i=1,im
                 pe(i,k,j) = pem(i,k,j)
                 pk(i,j,k) = pe(i,k,j) ** akap
              enddo
           enddo
       else
           do k=2,km
              do i=1,im
                 pe(i,k,j) = pem(i,k,j)
              enddo
           enddo
       endif
    enddo
    call fv_array_sync()

    call pkez( nx, im, km, jfirst, jlast,               &
         pe, pk, akap, ks, peln, pkz, .not. p_map )

#ifdef SPMD
    call mp_recv3d(gid+1, im, jm, km, 1, im, jfirst-ng_d, jlast+ng_s, &
         1, km, 1, im, jlast+1, jlast+1, 1, km, u)
    u_ghosted = .true.
    call fv_array_sync()
#endif

!----- compute globally integrated TE ---------------
    if( consv > 1.E-5 ) then
!$omp parallel do private(i,j,k)
        do k=ksp,kep !1,km
           do j=jfirst,jlast
              do i=1,im
                 va(i,j,k) = ua(i,j,k) * delp(i,j,k)
              enddo
           enddo
        enddo
        call fv_array_sync()

!$omp parallel do private(i, j, k, bte, xsum)
        do j=jsp,jep !jfirst,jlast
! Perform vertical integration
           if ( j == 1 ) then
! SP
               tte(1) = 0.

               do k=1,km
                  tte(1) = tte(1) + va(1,1,k)
               enddo
               tte(1)  = acap * tte(1)

           elseif ( j == jm) then
! NP
               tte(jm) = 0.

               do k=1,km
                  tte(jm) = tte(jm) + va(1,jm,k)
               enddo
               tte(jm) = acap * tte(jm)

           else
! Interior
               do i=1, im
                  bte(i) = 0.
               enddo

               do k=1,km
                  do i=1,im
                     bte(i) = bte(i) + va(i,j,k)
                  enddo
               enddo

               xsum = 0.
               do i=1,im
                  xsum = xsum + bte(i)
               enddo
               tte(j) = xsum*cosp(j)

           endif

           tte(j) = tte0(j) - tte(j)
        enddo           ! end openMP j-loop
        call fv_array_sync()

        call par_vecsum(jm, jfirst, jlast, tte, te1)

!$omp parallel do private(i, j, xsum, ysum, zsum)
        do j=jsp,jep !jfirst,jlast

#ifdef FIX_TEMP
           if( j == 1 ) then
               tte(1) = acap*cp * (ps(1,1) - ptop -                  &
                    akap*ptop*(peln(1,km+1,1) - peln(1,1,1) ) )
           elseif( j == jm ) then
               tte(jm)= acap*cp * (ps(1,jm) - ptop -                 &
                    akap*ptop*(peln(1,km+1,jm) - peln(1,1,jm) ) )
           else
               xsum = 0.
               ysum = 0.
               do i=1,im
                  xsum = xsum + ps(i,j)
                  ysum = ysum + peln(i,km+1,j)
               enddo
               tte(j) = cp*cosp(j)*(xsum - ptop*im -                   &
                    akap*ptop*(ysum - peln(1,1,j)*im) )
           endif
#else
           if( j==1 .or. j==jm ) then
               ysum = ptop*(pk(1,j,1)-pk(1,j,km+1))
               do k=1,km
                  ysum = ysum + pkz(1,j,k)*delp(1,j,k)
               enddo

               tte(j) = cp*acap*ysum
           else

               do i=1,im
                  zsum(i) = ptop*(pk(i,j,1)-pk(i,j,km+1))
               enddo

               do k=1,km
                  do i=1,im
                     zsum(i) = zsum(i) + pkz(i,j,k)*delp(i,j,k)
                  enddo
               enddo

               xsum = 0.
               do i=1,im
                  xsum = xsum + zsum(i)
               enddo

               tte(j) = cp*cosp(j)*xsum
           endif
#endif
        enddo
        call fv_array_sync()

        call par_vecsum(jm, jfirst, jlast, tte, tsum)

        dtmp = min(1., consv) * te1 / tsum        ! do not allow over-correction
!       if(master) write(6,*) 'Energy correction in T/PT (deg/yr) =',dtmp*86400*365/mdt
    else
        dtmp = 0.
    endif        ! end consv check


!$omp parallel do private(i, j, k, u2, v2, te_sp, te_np)
    do 8000 k=max(kmap,ksp),kep !kmap,km
! Compute KE
       do j=js2g0, min(jlast+1,jm)
          do i=1,im
             u2(i,j) = cose(j) * u(i,j,k)**2
          enddo
       enddo

       do j=js2g0, jn2g0
          do i=1,im
             v2(i,j) = v(i,j,k)**2
          enddo
       enddo

       do j=js2g0, jn2g0
          do i=1,im-1
             ua(i,j,k) = ua(i,j,k) - 0.25 * ( (u2(i,j)+u2(i,j+1))*acosu(j)  &
                  +v2(i,j) + v2(i+1,j) )
          enddo
          ua(im,j,k) = ua(im,j,k) - 0.25*( (u2(im,j)+u2(im,j+1))*acosu(j) &
               +v2(im,j) + v2(1,j) )
       enddo

! poles
       if ( jfirst == 1 ) then
           te_sp = 0.
           do i=1,im
!           te_sp = te_sp + u2(i,2) + v2(i,2)
! SJL: 01/26/04
              te_sp = te_sp + 0.5*u2(i,2)/cose(2)
           enddo
           te_sp = ua(1,1,k) - 0.5*te_sp/float(im)

           do i=1,im
              ua(i,1,k) = te_sp
           enddo
       endif

       if ( jlast == jm ) then
           te_np = 0.
           do i=1,im
!           te_np = te_np + u2(i,jm) + v2(i,jm-1)
! SJL: 01/26/04
              te_np = te_np + 0.5*u2(i,jm)/cose(jm)
           enddo

           te_np = ua(1,jm,k) - 0.5*te_np/float(im)
           do i=1,im
              ua(i,jm,k) = te_np
           enddo
       endif
8000 end do !continue
    call fv_array_sync()

! Recover temperature
!$omp parallel do private(ixj, i1, i2, i, j, k, rg, gz, tm, dlnp)

    do ixj=ixjs,ixje !1,jp

       j  = jfirst + (ixj-1) / nx
       i1 = 1 + it * mod(ixj-1, nx)
       i2 = i1 + it - 1

       rg = akap * cp
       do i=i1,i2
          gz(i) = hs(i,j)      
       enddo

       if ( p_map ) then
           do k=1,kmap-1
              do i=i1,i2
! Recover temperature from Cp * virt_potential temp
                 pt(i,j,k) = pt(i,j,k)*pkz(i,j,k) / (cp*(1.+r_vir*q(i,j,k,1)))
              enddo
           enddo
       endif

       do k=km,kmap,-1
          do i=i1,i2
             dlnp = rg*(peln(i,k+1,j) - peln(i,k,j))
!             tm = (ua(i,j,k)-gz(i)) / ( cp*(1.+cp_vir*q(i,j,k,1)) -      &
!                        (1.+r_vir*q(i,j,k,1))*pe(i,k,j)*dlnp/delp(i,j,k) )
             tm = (ua(i,j,k)-gz(i)) / ( (cp -        &
                  pe(i,k,j)*dlnp/delp(i,j,k))*(1.+r_vir*q(i,j,k,1)) )
#ifdef FIX_TEMP
             pt(i,j,k) = tm + dtmp        ! pt is now temperature
#else
             pt(i,j,k) = tm + dtmp*pkz(i,j,k)/(1.+r_vir*q(i,j,k,1))
#endif
             gz(i) = gz(i) + dlnp*tm*(1.+r_vir*q(i,j,k,1))
          enddo
       enddo           ! end k-loop

    enddo
    call fv_array_sync()

!----------------------
! Output A grid winds:
!----------------------
    call d2a3d(u, v, ua, va, im, jm, km, jfirst, jlast,    &
         ng_d, ng_s, coslon, sinlon)


    call fv_print_chksums( 'Exiting  te_map' )
  end subroutine te_map

  subroutine geo_map(ps, omga, pe, delp, pkz, pk, mdt,            &
       im, jm, km, nx, jfirst, jlast, nq,  u,  v,   &
       pt, q, r_vir, cp_vir,  cp, akap,             &
       kord_mt, kord_tr, kord_tm,  peln,            &
       phis, ng_d, ng_s, rg, acap, cosp, ua, va,    &
       consv, tte0, fill)
! Alternative remapping algorithm based on preservation of
! geopotential; total energy is not conserved. This algorithm has the
! potential of being more accurate by NOT perturbing the pressure gradient
! with remapping
!
#ifdef use_shared_pointers
    use fv_arrays_mod, only: is,ie,js,je, isd,ied,jsd,jed, isg,ieg,jsg,jeg
    use fv_arrays_mod, only: nlev
    use fv_arrays_mod, only: ptr_ps_bp, ptr_pesouth
    real :: ps_bp (isg:ieg, js:je)
    pointer( p_ps_bp, ps_bp )
    real :: pesouth(isg:ieg, nlev+1)
    pointer( p_pesouth, pesouth )
#else
    use fv_arrays_mod, only: ps_bp, pesouth
#endif

! !INPUT PARAMETERS:
    integer, intent(in):: mdt        ! mapping time step (same as phys)
    integer, intent(in):: im         ! E-W dimension
    integer, intent(in):: jm         ! N-S dimension
    integer, intent(in):: km         ! Vertical dimension
    integer, intent(in):: nq         ! number of tracers (including h2o)
    integer, intent(in):: ng_d
    integer, intent(in):: ng_s
    integer, intent(in):: nx            ! number of SMP "decomposition" in x
    integer, intent(in):: jfirst, jlast ! starting & ending latitude index
    integer, intent(in):: kord_mt, kord_tr, kord_tm

    real, intent(in)::  r_vir
    real, intent(in):: cp_vir
    real, intent(in):: cp, rg, acap
    real, intent(in):: akap
    real, intent(in):: phis(im,jfirst:jlast)
    real, intent(in):: cosp(jm)
    real, intent(in):: consv
    logical,  intent(in):: fill

! !INPUT/OUTPUT PARAMETERS:
    real, intent(inout):: tte0(jfirst:jlast)
    real, intent(inout):: u(im,jfirst-ng_d:jlast+ng_s,km)   ! u-wind (m/s)
    real, intent(inout):: v(im,jfirst-ng_d:jlast+ng_d,km)   ! v-wind (m/s)
    real, intent(inout):: pt(im,jfirst-ng_d:jlast+ng_d,km)  ! virtual potential temperature
    real, intent(inout):: delp(im,jfirst:jlast,km) ! pressure thickness
    real, intent(inout):: q(im,jfirst-ng_d:jlast+ng_d,km,*)
    real, intent(inout):: pe(im,km+1,jfirst:jlast) ! pressure at layer edges
    real, intent(inout):: pk(im,jfirst:jlast,km+1) ! pe to the kappa
    real, intent(inout):: ps(im,jfirst:jlast)      ! surface pressure

! !OUTPUT PARAMETERS:
    real, intent(out):: omga(im,jfirst:jlast,km)    ! vertical press. velocity (pascal/sec)
    real, intent(out):: peln(im,km+1,jfirst:jlast)  ! log(pe)
    real, intent(out):: pkz(im,jfirst:jlast,km)     ! layer-mean pk for converting t to pt

! Work
    real, intent(out):: ua(im,jfirst:jlast,km)
    real, intent(out):: va(im,jfirst:jlast,km)
! !DESCRIPTION:
! This routine is based on te_map. However, total energy is no longer conserved.
! Instead, the geopotential is conserved.
!
! !REVISION HISTORY:
!
! SJL 02.04.07: Geopotential conserving mapping initial version based on te_map
!
!EOP
!-----------------------------------------------------------------------
!BOC
! Local arrays:
    real tte(jfirst:jlast)
    real rmin(nx*jm), rmax(nx*jm)
! y-z
    real  q2(im/nx,km,nq)
    real dp2(im/nx,km)
    real pe0(im,km+1)
    real pe1(im,km+1)
    real pe2(im,km+1)
    real pe3(im,km+1)
    real ratio(im)
    real pe1w(km+1)
    real pe2w(km+1)

    real dak, bkh, qmax, qmin
    real rdt5
    real pktmp, tmp, ak1
    real xsum, ysum, tsum, dtmp, te1

    integer i, j, k, iq
    integer ixj, jp, it, i1, i2

    integer :: ixjs, ixje
    logical diag
    data diag    /.false./
#ifdef use_shared_pointers
    pointer( p_tte, tte )
    call fv_stack_push( p_tte, jlast-jfirst+1 )
#endif

!     diag = .true.
#ifdef use_shared_pointers
    p_ps_bp = ptr_ps_bp
    p_pesouth = ptr_pesouth
#endif

    call fv_print_chksums( 'Entering  geo_map' )
    call fv_array_check( LOC(phis) )
    call fv_array_check( LOC(u) )
    call fv_array_check( LOC(v) )
    call fv_array_check( LOC(pt) )
    call fv_array_check( LOC(delp) )
    call fv_array_check( LOC(q) )
    call fv_array_check( LOC(pe) )
    call fv_array_check( LOC(pk) )
    call fv_array_check( LOC(ps) )
    call fv_array_check( LOC(omga) )
    call fv_array_check( LOC(peln) )
    call fv_array_check( LOC(pkz) )
    call fv_array_check( LOC(ua) )
    call fv_array_check( LOC(va) )

#ifdef SPMD
    call mp_send3d(gid+1, gid-1, im, km+1, jm, 1, im, 1, km+1, jfirst, jlast,&
         1, im, 1, km+1, jlast, jlast, pe)
    call mp_recv3d(gid-1, im, km+1, jm, 1, im, 1, km+1, jfirst-1, jfirst-1, &
         1, im, 1, km+1, jfirst-1, jfirst-1, pesouth)
    u_ghosted = .false.
    call fv_array_sync()
#endif

    it = im / nx
    jp = nx * ( jlast - jfirst + 1 )

    call fv_array_limits( 1, jp, ixjs, ixje )
!$omp parallel do default(shared)                 &
!$omp private(i,j,k,pe0,pe1,pe2,pe3,ratio)        &
!$omp private(dak, bkh, rdt5, ixj, i1, i2, iq)   &
!$omp private(pe1w, pe2w, pktmp, q2, dp2)

    do 2000 ixj=ixjs, ixje !1, jp

       j  = jfirst + (ixj-1) / nx
       i1 = 1 + it * mod(ixj-1, nx)
       i2 = i1 + it - 1

! Copy data to local 2D arrays.
       do k=1,km+1
          do i=i1,i2
             pe1(i,k) = pe(i,k,j)
          enddo
       enddo

       do k=1,ks+1
          do i=i1,i2
             pe0(i,k) = ak(k)
             pe2(i,k) = ak(k)
             pe3(i,k) = ak(k)
          enddo
       enddo

       do k=ks+2,km
          do i=i1,i2
             pe0(i,k) = ak(k) + bk(k)* ps_bp(i,j)
             pe2(i,k) = ak(k) + bk(k)*pe1(i,km+1)
          enddo
       enddo

       do i=i1,i2
          pe0(i,km+1) =  ps_bp(i,j)
          pe2(i,km+1) = pe1(i,km+1)
       enddo

! Compute omga (dp/dt)
       do k=2,km+1
          do i=i1,i2
             pe0(i,k) = pe1(i,k) - pe0(i,k)
          enddo
       enddo

       rdt5 = 0.5 / float(mdt)
       do i=i1,i2
! update ps
          ps(i,j) = pe1(i,km+1)
          ps_bp(i,j) = ps(i,j)
          omga(i,j,1) = rdt5 * pe0(i,2)
       enddo

       do k=2,km
          do i=i1,i2
             omga(i,j,k) = rdt5 * ( pe0(i,k) + pe0(i,k+1) )
          enddo
       enddo

       if(ks /= 0) then
           do k=1,ks
              dak = ak(k+1) - ak(k)
              do i=i1,i2
                 delp(i,j,k) = dak
              enddo
           enddo
       endif

       do k=ks+1,km
          do i=i1,i2
             delp(i,j,k) = pe2(i,k+1) - pe2(i,k)
          enddo
       enddo

! Check deformation.
       if( diag ) then
           rmax(ixj) = 0.
           rmin(ixj) = 1.
           do k=1,km
              do i=i1,i2
                 ratio(i) = (pe1(i,k+1)-pe1(i,k)) / (pe2(i,k+1)-pe2(i,k))
              enddo

              do i=i1,i2
                 if(ratio(i) > rmax(ixj)) then
                     rmax(ixj) = ratio(i)
                 elseif(ratio(i) .lt. rmin(ixj)) then
                     rmin(ixj) = ratio(i)
                 endif
              enddo
           enddo
       endif

!-----------------
! Map constituents
!-----------------

       if(nq /= 0) then

           do k=1,km
              do i=i1,i2
                 dp2(i-i1+1,k) = pe2(i,k+1) - pe2(i,k)
              enddo
           enddo


           call mapn_ppm ( km,   pe1,   q, nq,   1,                &
                km,   pe2,  q2, ng_d, ng_d,             &
                im,   i1, i2, j, jfirst, jlast, 0, kord_tr)

           if (fill) call fillz(i2-i1+1, km, nq, q2, dp2)
           do iq=1,nq
              do k=1,km
                 do i=i1,i2
                    q(i,j,k,iq) = q2(i-i1+1,k,iq)
                 enddo
              enddo
           enddo
       endif

!-------
! map u
!-------
       if(j /= 1) then

! WS 99.07.29 : protect j==jfirst case
           if (j > jfirst) then
               do k=2,km+1
                  do i=i1,i2
                     pe0(i,k) = 0.5*(pe1(i,k)+pe(i,k,j-1))
                  enddo
               enddo

               do k=ks+2,km+1
                  bkh = 0.5*bk(k)
                  do i=i1,i2
                     pe3(i,k) = ak(k) + bkh*(pe1(i,km+1)+pe(i,km+1,j-1))
                  enddo
               enddo

#ifdef SPMD
           else
               do k=2,km+1
                  do i=i1,i2
                     pe0(i,k) = 0.5*(pe1(i,k)+pesouth(i,k))
                  enddo
               enddo

               do k=ks+2,km+1
                  bkh = 0.5*bk(k)
                  do i=i1,i2
                     pe3(i,k) = ak(k) + bkh*(pe1(i,km+1)+pesouth(i,km+1))
                  enddo
               enddo
#endif
           endif

           call map1_ppm( km,   pe0,   u, 1,                      &
                km,   pe3,   u, ng_d, ng_s,             &
                im, i1, i2, j, jfirst, jlast, -1, kord_mt)
       endif

! map v
       if(j .ne. 1 .and. j .ne. jm) then

           do k=1,km+1
              if( i1 == 1 ) then
                  pe1w(k) = pe(im,k,j)
              else
                  pe1w(k) = pe(i1-1,k,j)
              endif
           enddo

           do k=ks+2,km
              pe2w(k) = ak(k) + bk(k)*pe1w(km+1)
           enddo
           pe2w(km+1) = pe1w(km+1)

           do k=2,km+1
              pe0(i1,k) = 0.5*(pe1(i1,k)+pe1w(k))
              do i=i1+1,i2
                 pe0(i ,k) = 0.5*(pe1(i,k)+pe1(i-1,k))
              enddo
           enddo

           do k=ks+2,km+1
              pe3(i1,k) = 0.5*(pe2(i1,k)+pe2w(k))
              do i=i1+1,i2
                 pe3(i,k) = 0.5*(pe2(i,k)+pe2(i-1,k))
              enddo
           enddo

           call map1_ppm ( km,   pe0,   v, 1,                    &
                km,   pe3,   v, ng_d, ng_d,           &
                im, i1, i2, j, jfirst, jlast, -1, kord_mt)
       endif

! Save new PE to peln
       do k=2,km
          do i=i1,i2
             peln(i,k,j) = pe2(i,k)
          enddo
       enddo

!-------
! Map pt
!-------
       do k=1,km+1
          do i=i1,i2
             pe1(i,k) = pk(i,j,k)
          enddo
       enddo

       do k=1,ks+1
          pktmp = ak(k) ** akap
          do i=i1,i2
             pe2(i,k)  = pktmp
             pk(i,j,k) = pktmp
          enddo
       enddo

       do k=ks+2,km+1
          do i=i1,i2
             pe2(i,k)  = pe2(i,k) ** akap
             pk(i,j,k) = pe2(i,k)
          enddo
       enddo

       call map1_ppm ( km,   pe1,   pt,  1,                   &
            km,   pe2,   pt, ng_d, ng_d,           &
            im, i1, i2, j, jfirst, jlast, 1, kord_tr)
2000 end do !continue
    call fv_array_sync()
    if( diag ) then
        qmin = rmin(1)
        do ixj=2, jp
           if(rmin(ixj) < qmin) then
               qmin = rmin(ixj)
           endif
        enddo

        qmax = rmax(1)
        do ixj=2, jp
           if(rmax(ixj) > qmax) then
               qmax = rmax(ixj)
           endif
        enddo
        if(master) write(6,*) 'Rmin=', qmin, 'Rmax=', qmax
    endif

    ak1 = (akap + 1.) / akap

!$omp parallel do private(ixj, i1, i2, i, j, k, tmp)
    do 4000 ixj=ixjs,ixje !1,jp

       j  = jfirst + (ixj-1) / nx
       i1 = 1 + it * mod(ixj-1, nx)
       i2 = i1 + it - 1

       do k=2,km
          do i=i1,i2
             pe(i,k,j) = peln(i,k,j)
          enddo
       enddo

! Compute updated peln

       do k=2,ks+1
          tmp = log(ak(k))
          do i=i1,i2
             peln(i,k,j) = tmp
          enddo
       enddo

       do k=ks+2,km+1
          do i=i1,i2
             peln(i,k,j) = log(pe(i,k,j))
          enddo
       enddo

       if( ptop < ptop_min ) then
           do i=i1,i2
              peln(i,1,j) = peln(i,2,j) - ak1
           enddo
       else
           tmp = log( ptop )
           do i=i1,i2
              peln(i,1,j) = tmp
           enddo
       endif

! Compute pkz
       do k=1,km
          do i=i1,i2
             pkz(i,j,k) = ( pk(i,j,k+1) - pk(i,j,k) )  /         &
                  (akap*(peln(i,k+1,j) - peln(i,k,j)) )
          enddo
       enddo

! Recover temperature
       do k=1,km
          do i=i1,i2
             pt(i,j,k) = pt(i,j,k) * pkz(i,j,k) / ( cp*(1.+r_vir*q(i,j,k,1)) )
          enddo
       enddo
4000 end do !continue
    call fv_array_sync()

    if ( consv > 1.E-5 ) then
        call p_energy(im, jm, km, u, v, pt, delp, q(1,jfirst-ng_d,1,1),  &
             pe, peln, phis, ng_d, ng_s,                         &
             r_vir, cp_vir,  cp, rg,  tte,                    &
             jfirst, jlast, acap, cosp, ua, va)

!$omp parallel do private(i, j, xsum, ysum)
        do j=jsp,jep !jfirst,jlast

           tte0(j) = tte0(j) - tte(j)

           if( j == 1 ) then
               tte(1) = acap*cp * (ps(1,1) - ptop -                  &
                    akap*ptop*(peln(1,km+1,1) - peln(1,1,1) ) )
           elseif( j == jm ) then
               tte(jm)= acap*cp * (ps(1,jm) - ptop -                 &
                    akap*ptop*(peln(1,km+1,jm) - peln(1,1,jm) ) )
           else
               xsum = 0.
               ysum = 0.
               do i=1,im
                  xsum = xsum + ps(i,j)
                  ysum = ysum + peln(i,km+1,j)
               enddo
               tte(j) = cp*cosp(j)*(xsum - ptop*im -                   &
                    akap*ptop*(ysum - peln(1,1,j)*im) )
           endif
        enddo
        call fv_array_sync()

        call par_vecsum(jm, jfirst, jlast, tte0, te1)
        call par_vecsum(jm, jfirst, jlast, tte,  tsum)

        dtmp = min(1., consv) * te1 / tsum

!     if(master) write(6,*) 'dtmp=', dtmp*86400*365/mdt

!$omp parallel do private(i, j, k)
        do k=ksp,kep !1,km
           do j=jfirst,jlast
              do i=1,im
                 pt(i,j,k) = pt(i,j,k) + dtmp
              enddo
           enddo
        enddo
        call fv_array_sync()

    else
!----------------------
! Output A grid winds:
!----------------------
        call d2a3d(u, v, ua,  va, im, jm, km, jfirst, jlast,      &
             ng_d, ng_s, coslon, sinlon)

    endif

    call fv_print_chksums( 'Exiting  geo_map' )
  end subroutine geo_map


  subroutine p_energy(im, jm, km, u, v, pt, delp, q, pe, peln, phis,   &
       ng_d, ng_s, r_vir, cp_vir,  cp, rg, tte,       &
       jfirst, jlast, acap, cosp, ua, va )
! !INPUT PARAMETERS:
    integer,  intent(in):: im, jm, km, jfirst, jlast          ! Dimensions
    integer,  intent(in):: ng_d, ng_s
    real, intent(in):: r_vir
    real, intent(in):: cp_vir
    real, intent(in):: cp
    real, intent(in):: rg
    real, intent(in):: acap

    real, intent(in):: cosp(jm)
    real, intent(inout):: u(im,jfirst-ng_d:jlast+ng_s,km)  ! u-wind
    real, intent(in):: v(im,jfirst-ng_d:jlast+ng_d,km)  ! Winds y
    real, intent(in):: pt(im,jfirst-ng_d:jlast+ng_d,km)  ! temperature
    real, intent(in):: delp(im,jfirst:jlast,km)          ! Delta pressure
    real, intent(in):: q(im,jfirst-ng_d:jlast+ng_d,km)   ! specific humidity

    real, intent(in):: pe(im, km+1, jfirst:jlast)        ! Edge pressure
    real, intent(in):: peln(im, km+1, jfirst:jlast)      ! log(pe)
    real, intent(in):: phis(im,jfirst:jlast)

    real, intent(out):: ua(im, jfirst:jlast, km)
    real, intent(out):: va(im, jfirst:jlast, km)
    real, intent(out):: tte(jfirst:jlast)      ! column integrated Total Energy

! Local
    real bte(im)
    real gztop(im)

    real te_sp
    real te_np
    real xsum

    integer i, j, k, js2g0, jn2g0


    call fv_print_chksums( 'Entering  p_energy' )
    call fv_array_check( LOC(u) )
    call fv_array_check( LOC(v) )
    call fv_array_check( LOC(pt) )
    call fv_array_check( LOC(delp) )
    call fv_array_check( LOC(q) )
    call fv_array_check( LOC(pe) )
    call fv_array_check( LOC(peln) )
    call fv_array_check( LOC(phis) )
    call fv_array_check( LOC(ua) )
    call fv_array_check( LOC(va) )
    call fv_array_check( LOC(tte) )
    js2g0  = max(2,jfirst)
    jn2g0  = min(jm-1,jlast)

!----------------------
! Output A grid winds:
!----------------------
    call d2a3d(u, v, ua,  va, im, jm, km, jfirst, jlast,      &
         ng_d, ng_s, coslon, sinlon)

!$omp parallel do private(i,j,k,bte, xsum, gztop)
    do j=jsp,jep !jfirst,jlast
! Perform vertical integration
       do i=1,im
          gztop(i) = phis(i,j)
          do k=1,km
             gztop(i) = gztop(i) + (peln(i,k+1,j)-peln(i,k,j)) *   &
                  rg*pt(i,j,k)*(1.+r_vir*q(i,j,k))
          enddo
       enddo

       if (j == 1) then
! SP
           tte(1) = pe(1,km+1,1)*phis(1,1) - pe(1,1,1)*gztop(1)
           do k=1,km
              tte(1) = tte(1) + delp(1,1,k) * (0.5*(ua(1,1,k)**2+va(1,1,k)**2) + &
                   cp*pt(1,1,k)*(1.+r_vir*q(1,1,k)))
           enddo
           tte(1)  = acap * tte(1)
       elseif (j == jm) then
! NP
           tte(jm) = pe(1,km+1,jm)*phis(1,jm) - pe(1,1,jm)*gztop(1)
           do k=1,km
              tte(jm) = tte(jm) + delp(1,jm,k) * (0.5*(ua(1,jm,k)**2+va(1,jm,k)**2) + &
                   cp*pt(1,jm,k)*(1.+r_vir*q(1,jm,k)))
           enddo
           tte(jm) = acap * tte(jm)
       else
           do i=1,im
              bte(i) = pe(i,km+1,j)*phis(i,j) - pe(i,1,j)*gztop(i)
           enddo

           do k=1,km
              do i=1,im
                 bte(i) = bte(i) + delp(i,j,k) * (0.5*(ua(i,j,k)**2+va(i,j,k)**2)  + &
                      cp*pt(i,j,k)*(1.+r_vir*q(i,j,k)))
              enddo
           enddo

           xsum = 0.
           do i=1,im
              xsum = xsum + bte(i)
           enddo

           tte(j) = xsum*cosp(j)

       endif
    enddo
    call fv_array_sync()

    call fv_print_chksums( 'Exiting  p_energy' )
  end subroutine p_energy

  subroutine map1_q2( km,   pe1,   q1,   kmap,         &
                      kn,   pe2,   q2,   itot,         &
                      i1,   i2,    iv,   kord, j, jfirst, jlast, ng)


! !INPUT PARAMETERS:
      integer, intent(in) :: j                 ! Current latitude
      integer, intent(in) :: jfirst            ! Starting latitude
      integer, intent(in) :: jlast             ! Finishing latitude
      integer, intent(in) :: ng                ! Ghosted latitudes south
      integer, intent(in) :: i1                ! Starting longitude
      integer, intent(in) :: i2                ! Finishing longitude
      integer, intent(in) :: itot              ! Total latitudes
      integer, intent(in) :: iv                ! Mode: 0 ==  constituents  1 == ???
      integer, intent(in) :: kord              ! Method order
      integer, intent(in) :: km                ! Original vertical dimension
      integer, intent(in) :: kmap              ! starting remapping k-index
      integer, intent(in) :: kn                ! Target vertical dimension

      real, intent(in) ::  pe1(itot,km+1)  ! pressure at layer edges 
                                               ! (from model top to bottom surface)
                                               ! in the original vertical coordinate
      real, intent(in) ::  pe2(itot,kn+1)  ! pressure at layer edges 
                                               ! (from model top to bottom surface)
                                               ! in the new vertical coordinate
      real, intent(in) ::  q1(itot,jfirst-ng:jlast+ng,km) ! Field input

! !INPUT/OUTPUT PARAMETERS:
      real, intent(inout):: q2(i2-i1+1,kn) ! Field output

! !DESCRIPTION:
!
!     Perform piecewise parabolic method on a given latitude    
! IV = 0: constituents
! pe1: pressure at layer edges (from model top to bottom surface)
!      in the original vertical coordinate
! pe2: pressure at layer edges (from model top to bottom surface)
!      in the new vertical coordinate
!
! !REVISION HISTORY: 
!    00.04.24   Lin       Last modification
!    01.03.26   Sawyer    Added ProTeX documentation
!    02.04.04   Sawyer    incorporated latest FVGCM version
!    02.06.20   Sawyer    made Q2 inout since the args for Q1/Q2 same
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      real, parameter:: r3 = 1./3., r23 = 2./3.
      real   dp1(i1:i2,km)
      real   q4(4,i1:i2,km)
      real   pl, pr, qsum, delp, esl

      integer i, k, l, ll, k0

      do k=max(1,kmap-3),km
         do i=i1,i2
             dp1(i,k) = pe1(i,k+1) - pe1(i,k)
            q4(1,i,k) = q1(i,j,k)
         enddo
      enddo

! Compute vertical subgrid distribution
      call ppm2m( q4, dp1, km, kmap, i1, i2, iv, kord )

! Mapping
      do 1000 i=i1,i2
         k0 = kmap
      do 555 k=kmap,kn
      do 100 l=k0,km
! locate the top edge: pe2(i,k)
      if(pe2(i,k) >= pe1(i,l) .and. pe2(i,k) <= pe1(i,l+1)) then
         pl = (pe2(i,k)-pe1(i,l)) / dp1(i,l)
         if(pe2(i,k+1) <= pe1(i,l+1)) then
! entire new grid is within the original grid
            pr = (pe2(i,k+1)-pe1(i,l)) / dp1(i,l)
            q2(i-i1+1,k) = q4(2,i,l) + 0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))  &
                       *(pr+pl)-q4(4,i,l)*r3*(pr*(pr+pl)+pl**2)
               k0 = l
               goto 555
          else
! Fractional area...
            qsum = (pe1(i,l+1)-pe2(i,k))*(q4(2,i,l)+0.5*(q4(4,i,l)+   &
                    q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*           &
                     (r3*(1.+pl*(1.+pl))))
              do ll=l+1,km
! locate the bottom edge: pe2(i,k+1)
                 if(pe2(i,k+1) > pe1(i,ll+1) ) then
! Whole layer..
                 qsum = qsum + dp1(i,ll)*q4(1,i,ll)
                 else
                 delp = pe2(i,k+1)-pe1(i,ll)
                  esl = delp / dp1(i,ll)
                 qsum = qsum + delp*(q4(2,i,ll)+0.5*esl*               &
                       (q4(3,i,ll)-q4(2,i,ll)+q4(4,i,ll)*(1.-r23*esl)))
                 k0 = ll
                 goto 123
                 endif
              enddo
              goto 123
           endif
      endif
100   continue
123   q2(i-i1+1,k) = qsum / ( pe2(i,k+1) - pe2(i,k) )
555   continue
1000  continue

!EOC
 end subroutine map1_q2

 subroutine map1_ppm( km,   pe1,    q1,   kmap,         &
                      kn,   pe2,    q2,                 &
                      ng_s, ng_n,   itot,  i1,  i2,     &
                      j,    jfirst, jlast, iv,  kord)

! !INPUT PARAMETERS:
      integer, intent(in) :: i1                ! Starting longitude
      integer, intent(in) :: i2                ! Finishing longitude
      integer, intent(in) :: itot              ! Total latitudes
      integer, intent(in) :: iv                ! Mode: 0 ==  constituents  1 == ???
      integer, intent(in) :: kord              ! Method order
      integer, intent(in) :: j                 ! Current latitude
      integer, intent(in) :: jfirst            ! Starting latitude
      integer, intent(in) :: jlast             ! Finishing latitude
      integer, intent(in) :: ng_s              ! Ghosted latitudes south
      integer, intent(in) :: ng_n              ! Ghosted latitudes north
      integer, intent(in) :: km                ! Original vertical dimension
      integer, intent(in) :: kmap              ! starting remapping k-index
      integer, intent(in) :: kn                ! Target vertical dimension

      real, intent(in) ::  pe1(itot,km+1)  ! pressure at layer edges 
                                               ! (from model top to bottom surface)
                                               ! in the original vertical coordinate
      real, intent(in) ::  pe2(itot,kn+1)  ! pressure at layer edges 
                                               ! (from model top to bottom surface)
                                               ! in the new vertical coordinate
      real, intent(in) ::  q1(itot,jfirst-ng_s:jlast+ng_n,km) ! Field input

! !INPUT/OUTPUT PARAMETERS:
      real, intent(inout)::  q2(itot,jfirst-ng_s:jlast+ng_n,kn) ! Field output

! !DESCRIPTION:
!
!     Perform piecewise parabolic method on a given latitude    
! IV = 0: constituents
! pe1: pressure at layer edges (from model top to bottom surface)
!      in the original vertical coordinate
! pe2: pressure at layer edges (from model top to bottom surface)
!      in the new vertical coordinate
!
! !REVISION HISTORY: 
!    00.04.24   Lin       Last modification
!    01.03.26   Sawyer    Added ProTeX documentation
!    02.04.04   Sawyer    incorporated latest FVGCM version
!    02.06.20   Sawyer    made Q2 inout since the args for Q1/Q2 same
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      real, parameter:: r3 = 1./3., r23 = 2./3.
      real    dp1(i1:i2,km)
      real   q4(4,i1:i2,km)
      real    pl, pr, qsum, delp, esl

      integer i, k, l, ll, k0

      do k=max(1,kmap-3),km
         do i=i1,i2
             dp1(i,k) = pe1(i,k+1) - pe1(i,k)
            q4(1,i,k) = q1(i,j,k)
         enddo
      enddo

! Compute vertical subgrid distribution
      call ppm2m( q4, dp1, km, kmap, i1, i2, iv, kord )

! Mapping
      do 1000 i=i1,i2
         k0 = kmap
      do 555 k=kmap,kn
      do 100 l=k0,km
! locate the top edge: pe2(i,k)
      if(pe2(i,k) >= pe1(i,l) .and. pe2(i,k) <= pe1(i,l+1)) then
         pl = (pe2(i,k)-pe1(i,l)) / dp1(i,l)
         if(pe2(i,k+1) <= pe1(i,l+1)) then
! entire new grid is within the original grid
            pr = (pe2(i,k+1)-pe1(i,l)) / dp1(i,l)
            q2(i,j,k) = q4(2,i,l) + 0.5*(q4(4,i,l)+q4(3,i,l)-q4(2,i,l))  &
                       *(pr+pl)-q4(4,i,l)*r3*(pr*(pr+pl)+pl**2)
               k0 = l
               goto 555
          else
! Fractional area...
            qsum = (pe1(i,l+1)-pe2(i,k))*(q4(2,i,l)+0.5*(q4(4,i,l)+   &
                    q4(3,i,l)-q4(2,i,l))*(1.+pl)-q4(4,i,l)*           &
                     (r3*(1.+pl*(1.+pl))))
              do ll=l+1,km
! locate the bottom edge: pe2(i,k+1)
                 if(pe2(i,k+1) > pe1(i,ll+1) ) then
! Whole layer..
                 qsum = qsum + dp1(i,ll)*q4(1,i,ll)
                 else
                 delp = pe2(i,k+1)-pe1(i,ll)
                  esl = delp / dp1(i,ll)
                 qsum = qsum + delp*(q4(2,i,ll)+0.5*esl*               &
                       (q4(3,i,ll)-q4(2,i,ll)+q4(4,i,ll)*(1.-r23*esl)))
                 k0 = ll
                 goto 123
                 endif
              enddo
              goto 123
           endif
      endif
100   continue
123   q2(i,j,k) = qsum / ( pe2(i,k+1) - pe2(i,k) )
555   continue
1000  continue

!EOC
 end subroutine map1_ppm
!--------------------------------------------------------- 

 subroutine mapn_ppm(km,     pe1,   q1,  nq,   kmap,     &
                     kn,     pe2,   q2,  ng_s, ng_n,     &
                     itot,   i1,    i2,  j,              &
                     jfirst, jlast, iv, kord)

! !INPUT PARAMETERS:
      integer, intent(in) :: i1                ! Starting longitude
      integer, intent(in) :: i2                ! Finishing longitude
      integer, intent(in) :: itot              ! Total latitudes
      integer, intent(in) :: iv                ! Mode: 0 ==  constituents  1 == other scalars
      integer, intent(in) :: kord              ! Method order
      integer, intent(in) :: j                 ! Current latitude
      integer, intent(in) :: jfirst            ! Starting latitude
      integer, intent(in) :: jlast             ! Finishing latitude
      integer, intent(in) :: ng_s              ! Ghosted latitudes south
      integer, intent(in) :: ng_n              ! Ghosted latitudes north
      integer, intent(in) :: km                ! Original vertical dimension
      integer, intent(in) :: kmap              ! partial remapping
      integer, intent(in) :: kn                ! Target vertical dimension
      integer, intent(in) :: nq                ! Number of tracers

      real , intent(in) :: pe1(itot,km+1)   ! pressure at layer edges 
                                               ! (from model top to bottom surface)
                                               ! in the original vertical coordinate
      real , intent(in) :: pe2(itot,kn+1)   ! pressure at layer edges 
                                               ! (from model top to bottom surface)
                                               ! in the new vertical coordinate
      real , intent(in) ::  q1(itot,jfirst-ng_s:jlast+ng_n,km,nq) ! Field input
! !INPUT/OUTPUT PARAMETERS:
      real , intent(inout)::  q2(i2-i1+1,kn,nq) ! Field output

! !DESCRIPTION:
!
!     Perform piecewise parabolic method on a given latitude    
! IV = 0: constituents
! pe1: pressure at layer edges (from model top to bottom surface)
!      in the original vertical coordinate
! pe2: pressure at layer edges (from model top to bottom surface)
!      in the new vertical coordinate
!
! !REVISION HISTORY: 
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:

   real , parameter:: r3= 1./3., r23 = 2./3.
   real  dp1(i1:i2,km)
   real   q4(4,i1:i2,km,nq)
   real   qsum(nq)
   real   pl, pr, delp, esl
   real   tmp1, tmp2
   integer i, k, l, m, mm, k0, iq

   do k=max(1,kmap-3),km
      do i=i1,i2
         dp1(i,k) = pe1(i,k+1) - pe1(i,k)
      enddo
   enddo

   do iq=1,nq
      do k=max(1,kmap-3),km
         do i=i1,i2
            q4(1,i,k,iq) = q1(i,j,k,iq)
         enddo
      enddo
! Compute vertical subgrid distribution
      call ppm2m( q4(1,i1,1,iq), dp1, km, kmap, i1, i2, iv, kord )
   enddo

! Mapping
      do 1000 i=i1,i2
         k0 = kmap
      do 555 k=kmap,kn
      do 100 m=k0,km
! locate the top edge: pe2(i,k)
      if(pe2(i,k) >= pe1(i,m) .and. pe2(i,k) <= pe1(i,m+1)) then
         pl = (pe2(i,k)-pe1(i,m)) / dp1(i,m)
         if(pe2(i,k+1) <= pe1(i,m+1)) then
! entire new grid is within the original grid
            pr = (pe2(i,k+1)-pe1(i,m)) / dp1(i,m)
            tmp2 = pr + pl
            tmp1 = r3 * ( pr*tmp2 + pl**2 ) 
            do iq=1,nq
               q2(i-i1+1,k,iq) = q4(2,i,m,iq) + 0.5*(q4(4,i,m,iq)+q4(3,i,m,iq) -    &
                              q4(2,i,m,iq))*tmp2 - q4(4,i,m,iq)*tmp1
            enddo
            k0 = m
            goto 555
         else
! Fractional area...
            tmp1 = r3 * ( 1. + pl*(1.+pl) )
            do iq=1,nq
               qsum(iq) = (pe1(i,m+1)-pe2(i,k))*(q4(2,i,m,iq)+0.5*(q4(4,i,m,iq)+     &
                           q4(3,i,m,iq)-q4(2,i,m,iq))*(1.+pl)-q4(4,i,m,iq)*tmp1 )
            enddo
            do mm=m+1,km
! locate the bottom edge: pe2(i,k+1)
               if(pe2(i,k+1) > pe1(i,mm+1) ) then
! Whole layer..
                 do iq=1,nq
                    qsum(iq) = qsum(iq) + dp1(i,mm)*q4(1,i,mm,iq)
                 enddo
               else
                 delp = pe2(i,k+1) - pe1(i,mm)
                  esl = delp / dp1(i,mm)
                 tmp1 = 1. - r23*esl
                 do iq=1,nq
                    qsum(iq) = qsum(iq) + delp*(q4(2,i,mm,iq)+0.5*esl*            &
                       (q4(3,i,mm,iq)-q4(2,i,mm,iq)+q4(4,i,mm,iq)*tmp1 ))
                 enddo
                 k0 = mm
                 goto 123
               endif
            enddo
            goto 123
         endif
      endif
100   continue
123   do iq=1,nq 
         q2(i-i1+1,k,iq) = qsum(iq) / ( pe2(i,k+1) - pe2(i,k))
      enddo
555   continue
1000  continue

 end subroutine mapn_ppm

!----------------------------------------------------------------------- 
!BOP
! !ROUTINE:  ppm2m --- Piecewise parabolic method for fields
!
! !INTERFACE:
 subroutine ppm2m(a4, delp, km, kmap, i1, i2, iv, kord)

! !INPUT PARAMETERS:
 integer, intent(in):: iv      ! iv =-1: winds
                               ! iv = 0: positive definite scalars
                               ! iv = 1: others
 integer, intent(in):: i1      ! Starting longitude
 integer, intent(in):: i2      ! Finishing longitude
 integer, intent(in):: km      ! vertical dimension
 integer, intent(in):: kmap    ! partial remap to start
 integer, intent(in):: kord    ! Order (or more accurately method no.):
                               ! 
 real , intent(in):: delp(i1:i2,km)     ! layer pressure thickness

! !INPUT/OUTPUT PARAMETERS:
 real , intent(inout):: a4(4,i1:i2,km)  ! Interpolated values

! !DESCRIPTION:
!
!   Perform the piecewise parabolic method 
! 
! !REVISION HISTORY: 
!   ??.??.??    Lin        Creation
!   02.04.04    Sawyer     Newest release from FVGCM
! 
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
! local arrays:
      real    dc(i1:i2,km)
      real    h2(i1:i2,km)
      real  delq(i1:i2,km)
      real   df2(i1:i2,km)
      real    d4(i1:i2,km)

! local scalars:
      integer i, k, km1, lmt
      integer it
      real  fac
      real  a1, a2, c1, c2, c3, d1, d2
      real  qmax, qmin, cmax, cmin
      real  qm, dq, tmp
      real  qmp, pmp
      real  lac

      km1 = km - 1
       it = i2 - i1 + 1

      do k=max(2,kmap-2),km
         do i=i1,i2
            delq(i,k-1) =   a4(1,i,k) - a4(1,i,k-1)
              d4(i,k  ) = delp(i,k-1) + delp(i,k)
         enddo
      enddo
 
      do k=max(2,kmap-2),km1
         do i=i1,i2
            c1  = (delp(i,k-1)+0.5*delp(i,k))/d4(i,k+1)
            c2  = (delp(i,k+1)+0.5*delp(i,k))/d4(i,k)
            tmp = delp(i,k)*(c1*delq(i,k) + c2*delq(i,k-1)) /      &
                                    (d4(i,k)+delp(i,k+1))
            qmax = max(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1)) - a4(1,i,k)
            qmin = a4(1,i,k) - min(a4(1,i,k-1),a4(1,i,k),a4(1,i,k+1))
             dc(i,k) = sign(min(abs(tmp),qmax,qmin), tmp)
            df2(i,k) = tmp
         enddo
      enddo

!-----------------------------------------------------------
! 4th order interpolation of the provisional cell edge value
!-----------------------------------------------------------

      do k=max(3,kmap), km1
      do i=i1,i2
        c1 = delq(i,k-1)*delp(i,k-1) / d4(i,k)
        a1 = d4(i,k-1) / (d4(i,k) + delp(i,k-1))
        a2 = d4(i,k+1) / (d4(i,k) + delp(i,k))
        a4(2,i,k) = a4(1,i,k-1) + c1 + 2./(d4(i,k-1)+d4(i,k+1)) *    &
                  ( delp(i,k)*(c1*(a1 - a2)+a2*dc(i,k-1)) -          &
                                delp(i,k-1)*a1*dc(i,k  ) )
      enddo
      enddo

      if(km>8 .and. kord>3) call steepz(i1, i2, km, kmap, a4, df2, dc, delq, delp, d4)

! Area preserving cubic with 2nd deriv. = 0 at the boundaries
! Top
      if ( kmap <= 2 ) then
      do i=i1,i2
         d1 = delp(i,1)
         d2 = delp(i,2)
         qm = (d2*a4(1,i,1)+d1*a4(1,i,2)) / (d1+d2)
         dq = 2.*(a4(1,i,2)-a4(1,i,1)) / (d1+d2)
         c1 = 4.*(a4(2,i,3)-qm-d2*dq) / ( d2*(2.*d2*d2+d1*(d2+3.*d1)) )
         c3 = dq - 0.5*c1*(d2*(5.*d1+d2)-3.*d1**2)
         a4(2,i,2) = qm - 0.25*c1*d1*d2*(d2+3.*d1)
         a4(2,i,1) = d1*(2.*c1*d1**2-c3) + a4(2,i,2)
         dc(i,1) =  a4(1,i,1) - a4(2,i,1)
! No over- and undershoot condition
         cmax = max(a4(1,i,1), a4(1,i,2))
         cmin = min(a4(1,i,1), a4(1,i,2))
         a4(2,i,2) = max(cmin,a4(2,i,2))
         a4(2,i,2) = min(cmax,a4(2,i,2))
      enddo
      endif

! Bottom
! Area preserving cubic with 2nd deriv. = 0 at the surface
      do i=i1,i2
         d1 = delp(i,km)
         d2 = delp(i,km1)
         qm = (d2*a4(1,i,km)+d1*a4(1,i,km1)) / (d1+d2)
         dq = 2.*(a4(1,i,km1)-a4(1,i,km)) / (d1+d2)
         c1 = (a4(2,i,km1)-qm-d2*dq) / (d2*(2.*d2*d2+d1*(d2+3.*d1)))
         c3 = dq - 2.0*c1*(d2*(5.*d1+d2)-3.*d1**2)
         a4(2,i,km) = qm - c1*d1*d2*(d2+3.*d1)
         a4(3,i,km) = d1*(8.*c1*d1**2-c3) + a4(2,i,km)
         dc(i,km) = a4(3,i,km) -  a4(1,i,km)
! No over- and under-shoot condition
         cmax = max(a4(1,i,km), a4(1,i,km1))
         cmin = min(a4(1,i,km), a4(1,i,km1))
         a4(2,i,km) = max(cmin,a4(2,i,km))
         a4(2,i,km) = min(cmax,a4(2,i,km))
      enddo

      do k=max(1,kmap),km1
         do i=i1,i2
            a4(3,i,k) = a4(2,i,k+1)
         enddo
      enddo

! Enforce monotonicity of the "slope" within the top layer
      if ( kmap <= 2 ) then
      do i=i1,i2
         if ( a4(2,i,1) * a4(1,i,1) <= 0. ) then 
              a4(2,i,1) = 0.
                dc(i,1) = a4(1,i,1)
         endif
         if ( dc(i,1) * (a4(2,i,2) - a4(1,i,1)) <= 0. ) then
! Setting DC==0 will force piecewise constant distribution after
! calling kmppm
              dc(i,1) = 0.
         endif
      enddo
      endif

! Enforce constraint on the "slope" at the surface

      do i=i1,i2
         if( a4(3,i,km) * a4(1,i,km) <= 0. ) then
               dc(i,km) = 0.
         endif
         if( dc(i,km) * (a4(1,i,km) - a4(2,i,km)) <= 0. ) then
             dc(i,km) = 0.
         endif
      enddo
 
!-----------------------------------------------------------
! f(s) = AL + s*[(AR-AL) + A6*(1-s)]         ( 0 <= s  <= 1 )
!-----------------------------------------------------------
! Top 2 and bottom 2 layers always use monotonic mapping
      if ( kmap <= 2 ) then
      do k=1,2
         do i=i1,i2
            a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
         enddo
            call kmppm(dc(i1,k), a4(1,i1,k), it, 0)
      enddo
      endif

      if(kord >= 7) then
!-----------------------
! Huynh's 2nd constraint
!-----------------------
      do k=max(2,kmap-1), km1
         do i=i1,i2
! Method#1
!           h2(i,k) = delq(i,k) - delq(i,k-1)
! Method#2
!           h2(i,k) = 2.*(dc(i,k+1)/delp(i,k+1) - dc(i,k-1)/delp(i,k-1))
!    &               / ( delp(i,k)+0.5*(delp(i,k-1)+delp(i,k+1)) )
!    &               * delp(i,k)**2
! Method#3
            h2(i,k) = dc(i,k+1) - dc(i,k-1)
         enddo
      enddo

      if( kord == 7 ) then
         fac = 1.5           ! original quasi-monotone
      else
         fac = 0.125         ! full monotone
      endif

      do k=max(3,kmap), km-2
        do i=i1,i2
! Right edges
!        qmp   = a4(1,i,k) + 2.0*delq(i,k-1)
!        lac   = a4(1,i,k) + fac*h2(i,k-1) + 0.5*delq(i,k-1)
!
         pmp   = 2.*dc(i,k)
         qmp   = a4(1,i,k) + pmp
         lac   = a4(1,i,k) + fac*h2(i,k-1) + dc(i,k)
         qmin  = min(a4(1,i,k), qmp, lac)
         qmax  = max(a4(1,i,k), qmp, lac)
         a4(3,i,k) = min(max(a4(3,i,k), qmin), qmax)
! Left  edges
!        qmp   = a4(1,i,k) - 2.0*delq(i,k)
!        lac   = a4(1,i,k) + fac*h2(i,k+1) - 0.5*delq(i,k)
!
         qmp   = a4(1,i,k) - pmp
         lac   = a4(1,i,k) + fac*h2(i,k+1) - dc(i,k)
         qmin  = min(a4(1,i,k), qmp, lac)
         qmax  = max(a4(1,i,k), qmp, lac)
         a4(2,i,k) = min(max(a4(2,i,k), qmin), qmax)
! Recompute A6
         a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
        enddo
! Additional constraint to ensure positivity when kord=7
         if (iv == 0 .and. kord == 7) then
             call kmppm(dc(i1,k), a4(1,i1,k), it, 2)
         endif
      enddo

      else
 
         lmt = kord - 3
         lmt = max(0, lmt)
         if (iv == 0) lmt = min(2, lmt)

      do k=max(3,kmap), km-2
      if( kord /= 4) then
         do i=i1,i2
            a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
         enddo
      endif
         call kmppm(dc(i1,k), a4(1,i1,k), it, lmt)
      enddo
      endif

      do k=km1,km
         do i=i1,i2
            a4(4,i,k) = 3.*(2.*a4(1,i,k) - (a4(2,i,k)+a4(3,i,k)))
         enddo
         call kmppm(dc(i1,k), a4(1,i1,k), it, 0)
      enddo
!EOC
 end subroutine ppm2m
!-----------------------------------------------------------------------

!----------------------------------------------------------------------- 
!BOP
! !ROUTINE:  kmppm --- Perform piecewise parabolic method in vertical
!
! !INTERFACE:
 subroutine kmppm(dm, a4, itot, lmt)

! !INPUT PARAMETERS:
      real , intent(in):: dm(*)     ! the linear slope
      integer, intent(in) :: itot      ! Total Longitudes
      integer, intent(in) :: lmt       ! 0: Standard PPM constraint
                                       ! 1: Improved full monotonicity constraint (Lin)
                                       ! 2: Positive definite constraint
                                       ! 3: do nothing (return immediately)
! !INPUT/OUTPUT PARAMETERS:
      real , intent(inout) :: a4(4,*)   ! PPM array
                                           ! AA <-- a4(1,i)
                                           ! AL <-- a4(2,i)
                                           ! AR <-- a4(3,i)
                                           ! A6 <-- a4(4,i)

! !DESCRIPTION:
!
! !REVISION HISTORY: 
!    00.04.24   Lin       Last modification
!    01.03.26   Sawyer    Added ProTeX documentation
!    02.04.04   Sawyer    Incorporated newest FVGCM version
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:

      real , parameter:: r12 = 1./12.
      real  qmp
      real  da1, da2, a6da
      real  fmin
      integer i

! Developer: S.-J. Lin, NASA-GSFC
! Last modified: Apr 24, 2000

      if ( lmt == 3 ) return

      if(lmt == 0) then
! Standard PPM constraint
      do i=1,itot
      if(dm(i) == 0.) then
         a4(2,i) = a4(1,i)
         a4(3,i) = a4(1,i)
         a4(4,i) = 0.
      else
         da1  = a4(3,i) - a4(2,i)
         da2  = da1**2
         a6da = a4(4,i)*da1
         if(a6da < -da2) then
            a4(4,i) = 3.*(a4(2,i)-a4(1,i))
            a4(3,i) = a4(2,i) - a4(4,i)
         elseif(a6da > da2) then
            a4(4,i) = 3.*(a4(3,i)-a4(1,i))
            a4(2,i) = a4(3,i) - a4(4,i)
         endif
      endif
      enddo

      elseif (lmt == 1) then

! Improved full monotonicity constraint (Lin 2003)
! Note: no need to provide first guess of A6 <-- a4(4,i)
      do i=1, itot
           qmp = 2.*dm(i)
         a4(2,i) = a4(1,i)-sign(min(abs(qmp),abs(a4(2,i)-a4(1,i))), qmp)
         a4(3,i) = a4(1,i)+sign(min(abs(qmp),abs(a4(3,i)-a4(1,i))), qmp)
         a4(4,i) = 3.*( 2.*a4(1,i) - (a4(2,i)+a4(3,i)) )
      enddo

      elseif (lmt == 2) then

! Positive definite constraint
      do i=1,itot
      if( abs(a4(3,i)-a4(2,i)) < -a4(4,i) ) then
      fmin = a4(1,i)+0.25*(a4(3,i)-a4(2,i))**2/a4(4,i)+a4(4,i)*r12
         if( fmin < 0. ) then
         if(a4(1,i)<a4(3,i) .and. a4(1,i)<a4(2,i)) then
            a4(3,i) = a4(1,i)
            a4(2,i) = a4(1,i)
            a4(4,i) = 0.
         elseif(a4(3,i) > a4(2,i)) then
            a4(4,i) = 3.*(a4(2,i)-a4(1,i))
            a4(3,i) = a4(2,i) - a4(4,i)
         else
            a4(4,i) = 3.*(a4(3,i)-a4(1,i))
            a4(2,i) = a4(3,i) - a4(4,i)
         endif
         endif
      endif
      enddo

      endif

!EOC
 end subroutine kmppm
!-----------------------------------------------------------------------

!----------------------------------------------------------------------- 
!BOP
! !ROUTINE:  steepz --- Calculate attributes for PPM
!
! !INTERFACE:
 subroutine steepz(i1, i2, km, kmap, a4, df2, dm, dq, dp, d4)

! !INPUT PARAMETERS:
      integer, intent(in) :: km                   ! Total levels
      integer, intent(in) :: kmap                 ! 
      integer, intent(in) :: i1                   ! Starting longitude
      integer, intent(in) :: i2                   ! Finishing longitude
      real , intent(in) ::  dp(i1:i2,km)       ! grid size
      real , intent(in) ::  dq(i1:i2,km)       ! backward diff of q
      real , intent(in) ::  d4(i1:i2,km)       ! backward sum:  dp(k)+ dp(k-1) 
      real , intent(in) :: df2(i1:i2,km)       ! first guess mismatch
      real , intent(in) ::  dm(i1:i2,km)       ! monotonic mismatch

! !INPUT/OUTPUT PARAMETERS:
      real , intent(inout) ::  a4(4,i1:i2,km)  ! first guess/steepened

!
! !DESCRIPTION:
!   This is complicated stuff related to the Piecewise Parabolic Method
!   and I need to read the Collela/Woodward paper before documenting
!   thoroughly.
!
! !REVISION HISTORY: 
!   ??.??.??    Lin?       Creation
!   01.03.26    Sawyer     Added ProTeX documentation
!
!EOP
!-----------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
      integer i, k
      real  alfa(i1:i2,km)
      real     f(i1:i2,km)
      real   rat(i1:i2,km)
      real   dg2

! Compute ratio of dq/dp
      do k=max(2,kmap-1),km
         do i=i1,i2
            rat(i,k) = dq(i,k-1) / d4(i,k)
         enddo
      enddo

! Compute F
      do k=max(2,kmap-1),km-1
         do i=i1,i2
            f(i,k) =   (rat(i,k+1) - rat(i,k))                          &
                     / ( dp(i,k-1)+dp(i,k)+dp(i,k+1) )
         enddo
      enddo

      do k=max(3,kmap),km-2
         do i=i1,i2
         if(f(i,k+1)*f(i,k-1)<0. .and. df2(i,k)/=0.) then
            dg2 = (f(i,k+1)-f(i,k-1))*((dp(i,k+1)-dp(i,k-1))**2          &
                   + d4(i,k)*d4(i,k+1) )
            alfa(i,k) = max(0., min(0.5, -0.1875*dg2/df2(i,k))) 
         else
            alfa(i,k) = 0.
         endif
         enddo
      enddo

      do k=max(4,kmap+1),km-2
         do i=i1,i2
            a4(2,i,k) = (1.-alfa(i,k-1)-alfa(i,k)) * a4(2,i,k) +         &
                        alfa(i,k-1)*(a4(1,i,k)-dm(i,k))    +             &
                        alfa(i,k)*(a4(1,i,k-1)+dm(i,k-1))
         enddo
      enddo

!EOC
 end subroutine steepz


! !ROUTINE: benergy --- Calculate the total energy Before the Lagrangian dynamics
 
 subroutine benergy(im, jm, km, u, v, pt, delp, q, pe, peln, phis,    &
      u_ghosted,  ng_d, ng_s, r_vir, cp_vir, cp, rg,    &
      tte, jfirst, jlast, acap, cosp, te, dz )
! !USES:


! !INPUT PARAMETERS:
   integer,  intent(in):: im, jm, km, jfirst, jlast          ! Dimensions
   integer,  intent(in):: ng_d, ng_s
   real, intent(in):: r_vir
   real, intent(in):: cp_vir
   real, intent(in):: cp
   real, intent(in):: rg
   real, intent(in):: acap

   real, intent(in):: cosp(jm)
   real, intent(inout):: u(im,jfirst-ng_d:jlast+ng_s,km)  ! u-wind be ghosted one lat N
   real, intent(in)::  v(im,jfirst-ng_d:jlast+ng_d,km)  ! Winds y
   real, intent(in):: pt(im,jfirst-ng_d:jlast+ng_d,km)  ! temperature
   real, intent(in):: delp(im,jfirst:jlast,km)          ! Delta pressure
   real, intent(in):: q(im,jfirst-ng_d:jlast+ng_d,km)   ! specific humidity

   real, intent(in):: pe(im, km+1, jfirst:jlast)        ! Edge pressure
   real, intent(in):: peln(im, km+1, jfirst:jlast)      ! log(pe)
   real, intent(in):: phis(im,jfirst:jlast)
   real, intent(out):: tte(jfirst:jlast)                ! column integrated Total Energy

   logical, intent(inout):: u_ghosted


! !REVISION HISTORY:
!
!EOP
!---------------------------------------------------------------------
!BOC

! Local
   real u2(im,jfirst:jlast+1)
   real v2(im,jfirst:jlast)
   real tm(im,jfirst:jlast)

   real bte(im)
   real gztop(im)

   real te_sp
   real te_np
   real xsum

   integer i, j, k, js2g0, jn2g0
!Balaji: te/dz are listed as local work arrays but are actually
! reusing ua/va which are shared arrays!
! work arrays:
   real te(im, jfirst:jlast, km)
   real dz(im, jfirst:jlast, km)


   call fv_print_chksums( 'Entering  benergy' )
   call fv_array_check( LOC(u) )
   call fv_array_check( LOC(v) )
   call fv_array_check( LOC(pt) )
   call fv_array_check( LOC(delp) )
   call fv_array_check( LOC(q) )
   call fv_array_check( LOC(pe) )
   call fv_array_check( LOC(peln) )
   call fv_array_check( LOC(phis) )
   call fv_array_check( LOC(te) )
   call fv_array_check( LOC(dz) )
   call fv_array_check( LOC(tte) )

   js2g0  = max(2,jfirst)
   jn2g0  = min(jm-1,jlast)

!     if ( .not. u_ghosted ) then
!!        call error_mesg('Benergy:', 'U not ghosted',FATAL)
!     call mp_send3d(gid-1, gid+1, im, jm, km, 1, im, jfirst-ng_d, jlast+ng_s, &
!                        1, km, 1, im, jfirst, jfirst, 1, km, u)
!     call mp_recv3d(gid+1, im, jm, km, 1, im, jfirst-ng_d, jlast+ng_s, &
!                        1, km, 1, im, jlast+1, jlast+1, 1, km, u)
!           u_ghosted = .true.
!     endif

!$omp parallel do private(i, j, k, u2, v2, tm, te_sp, te_np)
   do k=ksp,kep !1,km
      do j=js2g0,min(jlast+1,jm)
         do i=1,im
            u2(i,j) = cose(j) * u(i,j,k)**2
         enddo
      enddo

      do j=js2g0,jn2g0
         do i=1,im
            v2(i,j) = v(i,j,k)**2
         enddo
      enddo

      do j=js2g0,jn2g0
         do i=1,im-1
            te(i,j,k) = 0.25*((u2(i,j)+u2(i,j+1))*acosu(j) + v2(i,j) + v2(i+1,j))
         enddo
         te(im,j,k) = 0.25*((u2(im,j)+u2(im,j+1))*acosu(j) + v2(im,j) + v2(1,j))
      enddo

      do j=jfirst,jlast
         do i=1,im
            tm(i,j) = pt(i,j,k)*(1.+r_vir*q(i,j,k))
         enddo
      enddo


      do j=js2g0,jn2g0
         do i=1,im
            te(i,j,k) = delp(i,j,k) * ( te(i,j,k)    +            &
                 cp*tm(i,j) )
         enddo
      enddo

      if ( jfirst == 1 ) then
          te_sp = 0.
          do i=1,im
!          te_sp = te_sp + u2(i,2) + v2(i,2)
! SJL 01/26/04
             te_sp = te_sp + 0.5*u2(i,2)/cose(2)
          enddo

          te_sp =  delp(1,1,k) * (0.5*te_sp/float(im) +           &
               cp*tm(1,1) )
          do i=1,im
             te(i,1,k) = te_sp
          enddo
      endif

      if ( jlast == jm ) then
          te_np = 0.
          do i=1,im
!          te_np = te_np + u2(i,jm) + v2(i,jm-1)
             te_np = te_np + 0.5*u2(i,jm)/cose(jm)
          enddo
          te_np = delp(1,jm,k) * (0.5*te_np/float(im) +          &
               cp*tm(1,jm) )
          do i=1,im
             te(i,jm,k) = te_np
          enddo
      endif

      do j=jfirst,jlast
         do i=1,im
            dz(i,j,k) = rg*tm(i,j)
         enddo
      enddo
   enddo
   call fv_array_sync()

!$omp parallel do private(i,j,k,bte, xsum, gztop)
   do j=jsp,jep !jfirst,jlast
! Perform vertical integration
      do i=1,im
         gztop(i) = phis(i,j)
         do k=1,km
            gztop(i) = gztop(i) + dz(i,j,k)*(peln(i,k+1,j)-peln(i,k,j))
         enddo
      enddo

      if (j == 1) then
! SP
          tte(1) = pe(1,km+1,1)*phis(1,1) - pe(1,1,1)*gztop(1)
          do k=1,km
             tte(1) = tte(1) + te(1,1,k)
          enddo
          tte(1)  = acap * tte(1)

      elseif (j == jm) then
! NP
          tte(jm) = pe(1,km+1,jm)*phis(1,jm) - pe(1,1,jm)*gztop(1)
          do k=1,km
             tte(jm) = tte(jm) + te(1,jm,k)
          enddo
          tte(jm) = acap * tte(jm)

      else
! Interior

          do i=1, im
             bte(i) = pe(i,km+1,j)*phis(i,j) - pe(i,1,j)*gztop(i)
          enddo

          do k=1,km
             do i=1,im
                bte(i) = bte(i) + te(i,j,k)
             enddo
          enddo

          xsum = 0.
          do i=1,im
             xsum = xsum + bte(i)
          enddo
          tte(j) = xsum*cosp(j)

      endif
   enddo
   call fv_array_sync()

! call par_vecsum(jm, jfirst, jlast, tte, te0)

   call fv_print_chksums( 'Exiting  benergy' )
 end subroutine benergy


 subroutine pkez(nx, im, km, jfirst, jlast,      &
      pe, pk, akap, ks, peln, pkz, eta)

! !INPUT PARAMETERS:
   integer, intent(in):: nx                   ! SMP decomposition in x
   integer, intent(in):: im, km               ! Dimensions
   integer, intent(in):: jfirst, jlast        ! Latitude strip
   integer, intent(in):: ks
   logical, intent(in):: eta     ! Is data on ETA coordinate?
! True:  input pe;     output pk, pkz, peln
! False: input pe, pk; output pkz and peln
   real, intent(in):: pe(im, km+1, jfirst:jlast)    ! Edge pressure
   real, intent(in):: akap

! !INPUT/OUTPUT PARAMETERS:
   real, intent(inout)::  pk(im,jfirst:jlast,km+1)
   real, intent(inout):: pkz(im,jfirst:jlast,km)

! !OUTPUT
   real, intent(out):: peln(im, km+1, jfirst:jlast)   ! log (pe)

! !DESCRIPTION:
!
!
! !CALLED FROM:
!     te_map and fvgcm
!
! !REVISION HISTORY:
!
!     WS  99.07.27 : Limited region to jfirst:jlast
!     WS  99.10.22 : Deleted cp as argument (was not used)
!     WS  99.11.05 : Documentation; pruning of arguments
!     SJL 00.01.02: SMP decomposition in i
!
!EOP
!---------------------------------------------------------------------
!BOC

! Local
   real pk2(im, km+1)
   real pek
   real lnp
   real ak1
   integer i, j, k
   integer ixj, jp, it, i1, i2

   integer :: ixjs, ixje


   call fv_print_chksums( 'Entering  pkez' )
   call fv_array_check( LOC(pe) )
   call fv_array_check( LOC(pk) )
   call fv_array_check( LOC(pkz) )
   call fv_array_check( LOC(peln) )

   it = im / nx
   jp = nx * ( jlast - jfirst + 1 )

   ak1 = (akap + 1.) / akap

   call fv_array_limits( 1, jp, ixjs, ixje )

!$omp  parallel do default(shared) private(ixj, i1, i2, i, j, k, pek, lnp, pk2)
!     do 1000 j=jfirst, jlast
!        i1 = 1
!        i2 = im
   do 1000 ixj=ixjs, ixje !1,jp

      j  = jfirst + (ixj-1) / nx
      i1 =  1 + it * mod(ixj-1, nx)
      i2 = i1 + it - 1

      if ( eta ) then
!---- Eta cordinate Coordinate -----------
          pek = pe(i1,1,j) ** akap

          do i=i1,i2
             pk2(i,1)   = pek
          enddo

          if(ks /= 0) then
              do k=2, ks+1
                 pek = pe(i1,k,j)**akap
                 lnp = log(pe(i1,k,j))
                 do i=i1,i2
                    pk2(i,k)   = pek
                    peln(i,k,j) =  lnp
                 enddo
              enddo

              if( ptop < ptop_min ) then
                  do i=i1,i2
                     peln(i,1,j) = peln(i,2,j) - ak1
                  enddo
              else
                  lnp = log( ptop )
                  do i=i1,i2
                     peln(i,1,j) = lnp
                  enddo
              endif

              do k=1,ks
                 pek = (pk2(i1,k+1) - pk2(i1,k)) / (akap*(peln(i1,k+1,j) - peln(i1,k,j)) )
                 do i=i1,i2
                    pkz(i,j,k) = pek
                 enddo
              enddo
          endif

          do k=ks+2,km
             do i=i1,i2
                pk2(i,k) = pe(i,k,j)**akap
             enddo
          enddo

          do i=i1,i2
             pk2(i,km+1) = pk(i,j,km+1)
          enddo

          do k=ks+2,km+1
             do i=i1,i2
                peln(i,k,j) =  log(pe(i,k,j))
             enddo
          enddo

          if ( ks == 0 ) then
              if( ptop < ptop_min ) then
                  do i=i1,i2
                     peln(i,1,j) = peln(i,2,j) - ak1
                  enddo
              else
                  lnp = log( ptop )
                  do i=i1,i2
                     peln(i,1,j) = lnp
                  enddo
              endif
          endif

          do k=ks+1,km
             do i=i1,i2
                pkz(i,j,k) = (pk2(i,k+1) - pk2(i,k)) /           &
                     (akap*(peln(i,k+1,j) - peln(i,k,j)) )
             enddo
          enddo

          do k=2,km
             do i=i1,i2
                pk(i,j,k) = pk2(i,k)
             enddo
          enddo
      else
! ---- General Coordinate -------

          pek = pk(i1,j,1)
          do i=i1,i2
             pk2(i,1) = pek
          enddo

          do k=2,km+1
             do i=i1,i2
                peln(i,k,j) =  log(pe(i,k,j))
                pk2(i,k) =  pk(i,j,k)
             enddo
          enddo

!---- GFDL modification
          if( ptop < ptop_min ) then
              do i=i1,i2
                 peln(i,1,j) = peln(i,2,j) - ak1
              enddo
          else
              lnp = log( ptop )
              do i=i1,i2
                 peln(i,1,j) = lnp
              enddo
          endif
!---- GFDL modification
          do k=1,km
             do i=i1,i2
                pkz(i,j,k) = (pk2(i,k+1) - pk2(i,k) )  /  &
                     (akap*(peln(i,k+1,j) - peln(i,k,j)) )
             enddo
          enddo

      endif
1000 end do !continue
   call fv_array_sync()
   call fv_print_chksums( 'Exiting  pkez' )
  end subroutine pkez

end module mapz_module

                    module optical_path_mod

! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  ds
! </REVIEWER>
! <OVERVIEW>
!  Module that set up optical depth calculaiton
! </OVERVIEW>
! <DESCRIPTION>
!  radiative fluxes
! </DESCRIPTION>

!   shared modules:

use mpp_mod,             only: input_nml_file
use fms_mod,             only: open_namelist_file, fms_init, &
                               mpp_pe, mpp_root_pe, stdlog, &
                               file_exist, write_version_number, &
                               check_nml_error, error_mesg, &
                               FATAL, close_file
use constants_mod,       only: RDGAS, RVGAS, GRAV, wtmair, &
                               avogno, pstd, diffac, tfreeze, &
                               constants_init

!   shared radiation package modules:

use rad_utilities_mod,   only: looktab, longwave_tables3_type, &
                               rad_utilities_init,  &
                               radiative_gases_type, &
                               aerosol_type,  &
                               aerosol_diagnostics_type,&
                               aerosol_properties_type, &
                               atmos_input_type, &
                               Lw_parameters,  Lw_control, &
                               Rad_control, &
                               optical_path_type, &
                               gas_tf_type, &
                               table_alloc
use longwave_params_mod, only: longwave_params_init, NBCO215,&
                               NBLY_RSB

!   radiation package modules:

use lw_gases_stdtf_mod,  only: lw_gases_stdtf_init, cfc_exact,&
                               cfc_overod, cfc_overod_part,   &
                               cfc_exact_part

!--------------------------------------------------------------------

implicit none
private

!---------------------------------------------------------------------
!    optical_path_mod computes the optical depths and associated
!    transmission functions for various atmospheric components 
!    including radiative gases and aerosols.
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- version number for this module -------------------

   character(len=128)  :: &
   version =  '$Id: optical_path.F90,v 19.0 2012/01/06 20:20:47 fms Exp $'
   character(len=128)  :: tagname =  '$Name: tikal $'


!---------------------------------------------------------------------
!----- interfaces  -----
           
public     &
         optical_path_init, optical_path_setup,     &
         optical_trans_funct_from_KS,    &
         optical_trans_funct_k_down, &
         optical_trans_funct_KE,  &
         optical_trans_funct_diag, &
         get_totch2o, get_totch2obd, &
         get_totvo2, optical_dealloc, &
         optical_path_end

private    &

!   called from optical_path_init:
         optical_ckd_init,     &

!   called from optical_path_setup:
         optical_path_ckd, optical_o3, optical_rbts,   &
         optical_h2o, cfc_optical_depth, optical_depth_aerosol


!---------------------------------------------------------------------
!---- namelist   -----

logical   :: tmp_dpndnt_h2o_lines = .true.  ! the 1200-1400 cm(-1)
                                            ! band h2o line intensities
                                            ! are temperature dependent?



namelist / optical_path_nml /    &
                                 tmp_dpndnt_h2o_lines

!-------------------------------------------------------------------
!-----  public data ----


!---------------------------------------------------------------------
!----- private  data  ----

!--------------------------------------------------------------------
!    data from former block data bs296 for self-broadened continuum
!    at 296K, band-integrated, in 5 - 19995 cm-1 range.
!               06/28/82
!               units of (cm**3/mol) * 1.E-20
!-------------------------------------------------------------------
real       :: v1sh2o_296, v2sh2o_296, dvsh2o_296,   &
              ssh2o_296(2000)
integer    :: nptsh2o_296

!--------------------------------------------------------------------
!  data from former block data bfh2o for foreign-broadened continuum
!    band-integrated, in 5 - 19995 cm-1 range.
!               06/28/82
!               units of (cm**3/mol) * 1.E-20
!--------------------------------------------------------------------
real        ::  v1fh2o, v2fh2o, dvfh2o, sfh2o(2000)
integer     ::  nptfh2o

!--------------------------------------------------------------------
!    array sfac is the frequency-dependent multiplicative factor used
!    to change the original self-broadened continuum coefficients
!    to those used in ckd2.1 or ckd2.4 (including intermediate changes).
!
!    array fscal is the frequency-dependent multiplicative factor used
!    to change the original foreign-broadened continuum coefficients
!    to those used in ckd2.1 or ckd2.4 (including intermediate changes).
!
!    array tmpfctrs is the logarithmic temperature dependence (per K)
!    of the self-broadened continuum coefficient, as a function of
!    frequency, used in all ckd AFGL continuum models.
!    the frequency ranges and intervals are as in sh2o_296.
!----------------------------------------------------------------------
real         :: sfac(2000), fscal(2000), tmpfctrs(2000)

!----------------------------------------------------------------------
!         the radfunc function (1 - exp(-h*nu/kt))/(1 + exp(-h*nu/kt))
!    is tabulated from 5 to 2995 cm-1 at intervals of 10 cm-1,
!    and from 100K to 490K at 10K intervals. note that the
!    radfn function used in ckd models equals the radfunc function
!    defined above, multiplied by nu (in cm-1).
!        the temperature derivative (at 105K to 485K, with the final
!    array value set to zero) is obtained from radfunc, and stored in
!    radfuncderiv.
!        tktab and vjtab are the respective temperature and frequency
!    points at which tabulations occurred.
!----------------------------------------------------------------------
type (longwave_tables3_type),save  :: radfunc
integer                            :: ioffh2o, nptch2o 
real                               :: vvj(2000)

!---------------------------------------------------------------------
!        fvj = foreign-broadened ckd 2.1 (ckd2.4) coefficient (including
!              all corrections), averaged over 7 specified wide
!              frequency bands in the 560-1200 cm-1 range. The average
!              is weighted by the frequency of the individual 10 cm-1
!              bands used in the averaging process.
!     fvjinw = band-averaged foreign coefficient (as in fvj) over
!              the 900-990,1070-1200 cm-1 range.
!      fvjwd = band-averaged foreign coefficient (as in fvj) over
!              the 560-800 cm-1 range.
!        svj = self-broadened ckd 2.1 (ckd2.4) coefficient (including
!              all corrections), averaged over 7 specified wide
!              frequency bands in the 560-1200 cm-1 range. The average
!              is weighted by the frequency of the individual 10 cm-1
!              bands used in the averaging process.
!     fvjinw = band-averaged self coefficient (as in svj) over
!              the 900-990,1070-1200 cm-1 range.
!      svjwd = band-averaged self coefficient (as in svj) over
!              the 560-800 cm-1 range.
!    radfnbd = the radiation function (radfn) averaged over each of
!              the 7 frequency bands: assumed to be altitude-independent
! radfnbdinw = same as radfnbd, but for the 560-800 cm-1 range.
!  radfnbdwd = same as radfnbd, but for the 900-990,1070-1200 cm-1 range
!----------------------------------------------------------------------
real      ::    fvj(7), fvjinw, fvjwd, svj(7), svjinw, svjwd,    &
                radfnbd(7), radfnbdinw, radfnbdwd

real      ::    ao3rnd(3), bo3rnd(3)

real      ::    ab15wd 

!---------------------------------------------------------------------
!  define continuum coefficients over special bands, the choices
!  depend on model architecture. the program gasbnd is used.
!
!    1) 560-800 as 1 band
!----------------------------------------------------------------------
real      ::    betawd 

!----------------------------------------------------------------------
!    3) 160-560 (as 8 bands using combined bands). program gasbnd is
!    used as 40 bands (160-560,10 cm-1 bandwidth) with ifdef icomb on.
!    4) 560-1200 and 4.3 um band (8 bands, frequency range given
!    by bdlocm-bdhicm). program gasbnd is used with 8 specified
!    bandwidths.
!--------------------------------------------------------------------
real, dimension (NBLY_RSB)           :: betacm

!---------------------------------------------------------------------

real, allocatable, dimension (:,:)     ::             csfah2o

!---------------------------------------------------------------------
!   the values of the molecular weights of f11 and f12 are derived
!   from elemental atomic weights adopted by the International Union of 
!   Pure and Applied Chemistry in 1961. These values are also used in 
!   the US Standard Atmosphere, 1976.
!   some previous radiative calculations at gfdl have used the
!   values  137.5, 121.0 for the molecular weights of f11 and f12.
!---------------------------------------------------------------------
real       ::  wtmf11  = 137.36855
real       ::  wtmf12  = 120.91395
real       ::  wtmf113 = 187.3765
real       ::  wtmf22  =  86.46892

!---------------------------------------------------------------------
real, dimension(2,10)  :: cpf10h2o, csf10h2o
real, dimension(2, 4)  :: cpf4h2o, csf4h2o
real, dimension(2, 2)  :: cpf2h2o, csf2h2o
real, dimension(2   )  :: cpf1h2o, csf1h2o


real      :: d622 = RDGAS/RVGAS
integer   :: NBTRG, NBTRGE
!!$integer   :: n

integer   :: ks, ke

logical   :: module_is_initialized      = .false. ! module has been
                                                  ! initialized ?


!----------------------------------------------------------------------




                              contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
!#####################################################################
! <SUBROUTINE NAME="optical_path_init">
!  <OVERVIEW>
!   Subroutine to initialize optical depth calculation and read
!   optical path namelist from input file.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to initialize optical depth calculation and read
!   optical path namelist from input file.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call optical_path_init
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine optical_path_init(pref)

!--------------------------------------------------------------------
!    optical_path_init is the constructor for optical_path_mod.
!--------------------------------------------------------------------

      real, dimension(:,:), intent(in) :: pref
!--------------------------------------------------------------------
!  local variables:

      real                    :: dum
      real, dimension (NBLY_RSB)  :: dummy_n
      real, dimension (Lw_parameters%NBTRGE) :: dummy_ch4n2o
      real                    :: awide_c, bwide_c, awide_n, bwide_n, &
                                 awide, bwide
      integer, dimension(5)   :: no_h2o12001400bands = &
                                  (/ 1, 2, 4, 10, 20 /)
      real, dimension(20)     :: arndm_12001400, brndm_12001400,    &
                                 ap_12001400, bp_12001400,          &
                                 atp_12001400, btp_12001400,        &
                                 fbdlo_12001400, fbdhi_12001400
      integer                 ::  unit, ierr, io, logunit
      integer                 :: inrad, k, m
      integer                 :: subb

!---------------------------------------------------------------------
!  local variables:
!
!       dum
!       dummy
!       dummy_n
!       dummy_ch4n2o
!       ap
!       bp
!       atp
!       btp
!    define random band parameters for special bands. the choices 
!    depend on model architecture. the program gasbnd is used.
!    1)  560-800 as 1 band
!       awide_c
!       bwide_c
!       awide_n
!       bwide_n
!    end comment for above
!       awide
!       bwide
!       no_h2o12001400bands
!       arndm_12001400
!       brndm_12001400
!       ap_12001400
!       bp_12001400
!       atp_12001400
!       btp_12001400
!       fbdlo_12001400
!       fbdhi_12001400
!       unit
!       ierr
!       io
!       inrad
!       k,m
!       subb
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return
 
!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call constants_init
      call rad_utilities_init
      call longwave_params_init
      call lw_gases_stdtf_init(pref)

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=optical_path_nml, iostat=io)
      ierr = check_nml_error(io,"optical_path_nml")
#else
!-----------------------------------------------------------------------
!    read namelist.
!-----------------------------------------------------------------------
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=optical_path_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'optical_path_nml')
        end do
10      call close_file (unit)
      endif
#endif
 
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                        write (logunit, nml=optical_path_nml)

!--------------------------------------------------------------------
!    verify that Lw_parameters%NBTRG and NBTRGE have been initialized.
!--------------------------------------------------------------------
      if (Lw_parameters%NBTRG_iz) then
        NBTRG  = Lw_parameters%NBTRG
      else
        call error_mesg ('optical_path_mod',  &
           ' Lw_parameters%NBTRG not yet initialized', FATAL)
      endif
      if (Lw_parameters%NBTRGE_iz) then
        NBTRGE = Lw_parameters%NBTRGE
      else
        call error_mesg ('optical_path_mod',  &
           ' Lw_parameters%NBTRGE not yet initialized', FATAL)
      endif

      if (nbtrge == 0 .and. tmp_dpndnt_h2o_lines) then
        call error_mesg ('optical_path_mod', &
        'cannot have temperature-dependent h2o line intensities &
             &without having separate 1200-1400 cm(-1) band(s)', FATAL) 
      endif
        
!---------------------------------------------------------------------
!    read needed data from raduiation input files.
!---------------------------------------------------------------------
      if (trim(Lw_control%linecatalog_form) == 'hitran_1992' ) then
        if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
            trim(Lw_control%continuum_form) == 'ckd2.4' ) then
          inrad = open_namelist_file('INPUT/h2ocoeff_ckd_speccombwidebds_hi92')
          read (inrad,9000) awide_c   ! ckd rndm coeff for 560-800 band
          read (inrad,9000) bwide_c   ! ckd rndm coeff for 560-800 band
        else if (trim(Lw_control%continuum_form) == 'rsb' ) then
          inrad = open_namelist_file('INPUT/h2ocoeff_rsb_speccombwidebds_hi92')
          read (inrad,9000) awide_n   ! rsb rndm coeff for 560-800 band
          read (inrad,9000) bwide_n   ! rsb rndm coeff for 560-800 band
          read (inrad,9000) dum
          read (inrad,9000) dum
          read (inrad,9000) dum
          read (inrad,9000) dum
          read (inrad,9000) dum
          read (inrad,9000) dum
          read (inrad,9000) betawd    ! rsb cont coeff for 560-800 band
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
!  rsb cont coeff for 8 comb bands (160-560) and 8 wide bands (560-1400)
          read (inrad,9000) (betacm(k),k=1,NBLY_RSB)
        endif
      else if (trim(Lw_control%linecatalog_form) == 'hitran_2000' ) then
        if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
            trim(Lw_control%continuum_form) == 'ckd2.4' ) then
          inrad = open_namelist_file('INPUT/h2ocoeff_ckd_speccombwidebds_hi00')
          read (inrad,9000) awide_c   ! ckd rndm coeff for 560-800 band
          read (inrad,9000) bwide_c   ! ckd rndm coeff for 560-800 band
        else if (trim(Lw_control%continuum_form) == 'rsb' ) then
          inrad = open_namelist_file('INPUT/h2ocoeff_rsb_speccombwidebds_hi00')
          read (inrad,9000) awide_n   ! rsb rndm coeff for 560-800 band
          read (inrad,9000) bwide_n   ! rsb rndm coeff for 560-800 band
          read (inrad,9000) dum
          read (inrad,9000) dum
          read (inrad,9000) dum
          read (inrad,9000) dum
          read (inrad,9000) dum
          read (inrad,9000) dum
          read (inrad,9000) betawd    ! rsb cont coeff for 560-800 band
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
          read (inrad,9000) (dummy_n(k),k=1,NBLY_RSB)
!  rsb cont coeff for 8 comb bands (160-560) and 8 wide bands (560-1400)
          read (inrad,9000) (betacm(k),k=1,NBLY_RSB)
        endif
      endif
9000  format(5e14.6)
      call close_file (inrad)

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        awide = awide_c
        bwide = bwide_c
      else if (trim(Lw_control%continuum_form) == 'rsb' ) then
        awide = awide_n
        bwide = bwide_n
      endif

!---------------------------------------------------------------------
!    compute a*b for computational frequency bands for the 15 um
!    region, as 1 band (ab15wd)
!---------------------------------------------------------------------
      ab15wd = awide*bwide

      if (trim(Lw_control%linecatalog_form) == 'hitran_1992') then
        inrad = open_namelist_file('INPUT/o39001200_hi92_data')
      else if (trim(Lw_control%linecatalog_form) == 'hitran_2000') then
        inrad = open_namelist_file('INPUT/o39001200_hi00_data')
      endif
      read (inrad,2001) (ao3rnd(k),k=1,3)
      read (inrad,2001) (bo3rnd(k),k=1,3)

!---------------------------------------------------------------------
!    verify that Lw_control%do_ch4 has been initialized.
!--------------------------------------------------------------------
      if (Lw_control%do_ch4_iz) then
      else
        call error_mesg ( 'optical_path_mod',  &
                      ' do_ch4 not yet initialized', FATAL)
      endif

!---------------------------------------------------------------------
!    verify that Lw_control%do_n2o has been initialized.
!--------------------------------------------------------------------
      if (Lw_control%do_n2o_iz) then
      else
        call error_mesg ( 'optical_path_mod',  &
                      ' do_n2o not yet initialized', FATAL)
      endif

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      if (NBTRGE > 0) then
        allocate ( csfah2o(2, NBTRGE) )
        if (trim(Lw_control%linecatalog_form) == 'hitran_1992') then
          inrad = open_namelist_file('INPUT/h2o12001400_hi92_data')
        else if (trim(Lw_control%linecatalog_form) ==    &
                                                    'hitran_2000') then
          inrad = open_namelist_file('INPUT/h2o12001400_hi00_data')
        endif

!----------------------------------------------------------------------
!     read in random coefficients for 1200-1400 freq region, spacing
!     through the data until  those appropriate for NBTRGE h2o bands
!     are reached. note: unless a continuum is inserted beyond 1200
!     cm-1, the band coefficients are independent of continuum type.
!---------------------------------------------------------------------
        do subb = 1,5    ! 5 = no. band divisions in h2o 1200-1400 data
          if (NBTRGE == no_h2o12001400bands(subb)) then
!  read and process data for sub-band number from data matching NBTRGE
!  then exit subb loop
            read (inrad,2001) (arndm_12001400(k),k=1,NBTRGE)
            read (inrad,2001) (brndm_12001400(k),k=1,NBTRGE)
            read (inrad,2001) (ap_12001400(k),k=1,NBTRGE)
            read (inrad,2001) (bp_12001400(k),k=1,NBTRGE)
            read (inrad,2001) (atp_12001400(k),k=1,NBTRGE)
            read (inrad,2001) (btp_12001400(k),k=1,NBTRGE)
            read (inrad,2001) (fbdlo_12001400(k),k=1,NBTRGE)
            read (inrad,2001) (fbdhi_12001400(k),k=1,NBTRGE)
            do m=1,NBTRGE
              csfah2o(1,m) =          atp_12001400(m)
              csfah2o(2,m) =          btp_12001400(m)
            end do
            exit
          else if (subb < 5) then 
!  read data for sub-band number from  data not matching NBTRGE
            read (inrad,2001)    &
                       (dummy_ch4n2o(k),k=1,no_h2o12001400bands(subb))
            read (inrad,2001)    &
                       (dummy_ch4n2o(k),k=1,no_h2o12001400bands(subb))
            read (inrad,2001)    &
                       (dummy_ch4n2o(k),k=1,no_h2o12001400bands(subb))
            read (inrad,2001)    &
                       (dummy_ch4n2o(k),k=1,no_h2o12001400bands(subb))
            read (inrad,2001)    &
                       (dummy_ch4n2o(k),k=1,no_h2o12001400bands(subb))
            read (inrad,2001)    &
                       (dummy_ch4n2o(k),k=1,no_h2o12001400bands(subb))
            read (inrad,2001)    &
                       (dummy_ch4n2o(k),k=1,no_h2o12001400bands(subb))
            read (inrad,2001)    &
                       (dummy_ch4n2o(k),k=1,no_h2o12001400bands(subb))
          else
!    failure of any sub-band number to match NBTRGE
            call error_mesg ('optical_path_mod',  &
              'NBTRGE is inconsistent with available data', FATAL)
          endif
        end do
2001  format(5e14.6)
        call close_file(inrad)
      endif

!------------------------------------------------------------------
!
!------------------------------------------------------------------
      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        call optical_ckd_init
      endif

!------------------------------------------------------------------
!    mark the module as initialized.
!------------------------------------------------------------------
      module_is_initialized = .true.

!--------------------------------------------------------------------



end subroutine optical_path_init




!###################################################################
! <SUBROUTINE NAME="optical_path_setup">
!  <OVERVIEW>
!   Subroutine to prepare optical path calculation, such as memory
!   allocation.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to prepare optical path calculation, such as memory
!   allocation.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call optical_path_setup (is, ie, js, je,  Atmos_input, &
!                            Rad_gases, Aerosol, Aerosol_props, Optical)
!  </TEMPLATE>
!  <IN NAME="is, ie, js, je" TYPE="integer">
!   Latitude and longitude bound of model physics window.
!  </IN>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
!   Atmospheric input data
!  </IN>
!  <IN NAME="Rad_gases" TYPE="radiative_gases_type">
!   Radiative gases input data
!  </IN>
!  <IN NAME="Aerosol" TYPE="aerosol_type">
!   Aerosol radiative properties input data
!  </IN>
!  <INOUT NAME="Aerosol_props" TYPE="aerosol_properties_type">
!   Aerosol radiative properties output (extinction coefficient,
!   single scattering albedo and asymmetry parameter in different
!   bands)
!  </INOUT>
!  <INOUT NAME="Optical" TYPE="optical_path_type">
!   optical path output
!  </INOUT>
! </SUBROUTINE>
!
subroutine optical_path_setup (is, ie, js, je, Atmos_input, &
                               Rad_gases, Aerosol, Aerosol_props,  &
                               Aerosol_diags, Optical, &
                               including_aerosols)  

!------------------------------------------------------------------
!
!------------------------------------------------------------------

integer, intent(in)                          :: is, ie, js, je
type(atmos_input_type),        intent(in)    :: Atmos_input
type(radiative_gases_type),    intent(in)    :: Rad_gases
type(aerosol_type),            intent(in)    :: Aerosol      
type(aerosol_properties_type), intent(inout) :: Aerosol_props      
type(aerosol_diagnostics_type), intent(inout) :: Aerosol_diags      
type(optical_path_type),       intent(inout) :: Optical     
logical,                   intent(in)            :: including_aerosols  

!---------------------------------------------------------------------
!  intent(in) variables:
!
!      is,ie,js,je
!      Atmos_input
!      Rad_gases
!      Aerosol
!
!  intent(inout) variables:
!
!      Aerosol_props
!      Optical
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:
 
      real, dimension (size(Atmos_input%press,1),    &
                       size(Atmos_input%press,2), &
                       size(Atmos_input%press,3) )  :: press, pflux, &
                                                       temp, tflux, &
                                                       atmden, vv

      real, dimension (size(Atmos_input%press,1),   &
                       size(Atmos_input%press,2), &
                       size(Atmos_input%press,3) - 1 )  ::   &
                                                       rh2o, deltaz
      real, dimension (size(Atmos_input%press,3) ) :: bsum

      integer      :: n_aerosol_bands
      integer      :: k, i, j, n
      integer      :: ix, jx, kx
      integer      :: israd, ierad, jsrad, jerad

!--------------------------------------------------------------------
!  local variables:
!
!       press
!       pflux
!       temp
!       tflux
!       atmden
!       vv             layer-mean pressure in atmospheres. due to quad-
!                      rature considerations, this does not equal the 
!                      pressure at the data level (press).
!       rh2o
!       deltaz
!       n_aerosol_bands
!       i,k
!       ix,jx,kx
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module is initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg( 'optical_path_mod',  &
              'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
      ix = ie -is + 1
      jx = je -js +1
      israd = 1
      ierad = ix
      jsrad = 1
      jerad = jx
      ks    = 1
      kx = size(Atmos_input%press,3) - 1
      ke    = kx

!  convert press and pflux to cgs.
      press(:,:,:) = 10.0*Atmos_input%press(:,:,:)
      pflux(:,:,:) = 10.0*Atmos_input%pflux(:,:,:)
      deltaz = Atmos_input%deltaz
      temp = Atmos_input%temp
      rh2o = Atmos_input%rh2o
      tflux = Atmos_input%tflux

!--------------------------------------------------------------------
!    atmden   =  atmospheric density, in gm/cm**2, for each of the
!                KMAX layers.
!-------------------------------------------------------------------
      allocate (Optical%wk       (ISRAD:IERAD, JSRAD:JERAD, KS:KE  ) )
      allocate (Optical%rh2os    (ISRAD:IERAD, JSRAD:JERAD, KS:KE  ) )
      allocate (Optical%rfrgn    (ISRAD:IERAD, JSRAD:JERAD, KS:KE  ) )
      allocate (Optical%tfac     (ISRAD:IERAD, JSRAD:JERAD, KS:KE  ) )
      allocate (Optical%avephi   (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )

      if (NBTRGE > 0) then
        allocate (Optical%avephif(ISRAD:IERAD, JSRAD:JERAD,    &
                                  KS:KE+1, NBTRGE) )
      endif

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      Optical%wk      = 0.                                      
      Optical%rh2os   = 0.                                      
      Optical%rfrgn   = 0.                                       
      Optical%tfac    = 0.                                       
      Optical%avephi   = 0.

      if (NBTRGE > 0) then
        Optical%avephif   = 0.
      endif
 
!----------------------------------------------------------------------
!    define the layer-mean pressure in atmospheres (vv) and the layer 
!    density (atmden). 
!----------------------------------------------------------------------
      do k=KS,KE
        atmden(:,:,k) = (pflux(:,:,k+1) - pflux(:,:,k))/(1.0E+02*GRAV)
        vv(:,:,k)     = 0.5E+00*(pflux(:,:,k+1) + pflux(:,:,k)  )/pstd
      end do

!----------------------------------------------------------------------
!     compute optical paths.
!----------------------------------------------------------------------
      call optical_h2o (pflux, atmden, vv, press, temp, rh2o,   &
                        tflux, Optical)

!---------------------------------------------------------------------
!    call optical_ckd2p1 to determine self- and foreign-broadened h2o
!    continuum paths, for the given temperature, pressure and mixing
!    ratio, over the predetermined frequency range for the ckd2.1 
!    continuum. call optical_roberts for self-broadened continuum
!    paths for the rsb (Roberts) continuum.
!---------------------------------------------------------------------
      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        call optical_path_ckd  (atmden, press, temp, rh2o, Optical)
      else if (trim(Lw_control%continuum_form) == 'rsb' ) then
        call optical_rbts  (temp, rh2o, Optical)
      endif

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      call optical_o3 (atmden, Rad_gases%qo3, vv, Optical)

!--------------------------------------------------------------------
      if (Lw_control%do_cfc) then
        call cfc_optical_depth (atmden, Rad_gases, Optical) 
      endif

!---------------------------------------------------------------------
!    compute aerosol layer transmission functions for all layers.
!    option predlwaer is planned, but not yet available. when  it 
!    becomes available,  aeralb, aerext and aerconc will be additional 
!    arguments going to aertau.
!---------------------------------------------------------------------
      if (including_aerosols .or. Rad_control%volcanic_lw_aerosols) then
        n_aerosol_bands = Lw_parameters%n_lwaerosol_bands

!---------------------------------------------------------------------
!    allocate space for and then retrieve the aerosol mixing ratios and
!    aerosol optical properties from the aerosol module.
!--------------------------------------------------------------------
        allocate (Optical%totaerooptdep (ix,jx,kx+1, N_AEROSOL_BANDS))
        allocate (Optical%aerooptdep_KE_15 (ix, jx ) )
        Optical%totaerooptdep = 0.                              
        Optical%aerooptdep_KE_15 = 0.           
      else
        n_aerosol_bands = 0
      endif
!-------------------------------------------------------------------
!    for each aerosol frequency band, retrieve aerosol optical proper-
!    ties for each aerosol category. then call optical_depth_aerosol 
!    to compute for aerosol optical depth. 
!-------------------------------------------------------------------
      do n=1,n_aerosol_bands  !  loop on aerosol frequency bands
        if (including_aerosols) then
          call optical_depth_aerosol (js, Atmos_input, n, Aerosol,   &
                                      Aerosol_props, Aerosol_diags, &
                                      Optical)
        endif   ! (including_aerosols)

        if (Rad_control%volcanic_lw_aerosols) then
          if (size(Aerosol_props%lw_ext,4) /= 0) then
            do j=1,jx
              do i=1,ix
                bsum(1) = 0.0
                do k=2,kx+1
                  if (n == 5) then
                    Aerosol_diags%lw_extopdep_vlcno(i,j,k,1) =  &
                                   Aerosol_props%lw_ext(i,j,k-1,n)*&
                                   Atmos_input%deltaz(i,j,k-1)
                    Aerosol_diags%lw_absopdep_vlcno(i,j,k,1) =  &
                          Aerosol_diags%lw_extopdep_vlcno(i,j,k,1) 
!! NOT CURRENTLY AVAILABLE IN SEA LW CODE -- lw_ssa not processed
!                     Aerosol_diags%lw_absopdep_vlcno(i,j,k,2) =  &
!                              (1.0-Aerosol_props%lw_ssa(i,j,k-1,n))*  &
!                                  Aerosol_props%lw_ext(i,j,k-1,n)*&
!                                  Atmos_input%deltaz(i,j,k-1)
                  endif
                  if (n == 6) then
                    Aerosol_diags%lw_extopdep_vlcno(i,j,k,2) =  &
                                   Aerosol_props%lw_ext(i,j,k-1,n)*&
                                   Atmos_input%deltaz(i,j,k-1)
                    Aerosol_diags%lw_absopdep_vlcno(i,j,k,2) =  &
                           Aerosol_diags%lw_extopdep_vlcno(i,j,k,2) 
!! NOT CURRENTLY AVAILABLE IN SEA LW CODE -- lw_ssa not processed
!                     Aerosol_diags%lw_absopdep_vlcno(i,j,k,1) =  &
!                           (1.0-Aerosol_props%lw_ssa(i,j,k-1,n))*  &
!                                  Aerosol_props%lw_ext(i,j,k-1,n)*&
!                                  Atmos_input%deltaz(i,j,k-1)
                  endif
                  bsum(k) = bsum(k-1) +    &
                            Aerosol_props%lw_ext(i,j,k-1,n)*&
                            Atmos_input%deltaz(i,j,k-1)
                end do
                Optical%totaerooptdep(i,j,2:kx+1,n) =    &
                        Optical%totaerooptdep(i,j,2:kx+1,n) +   &
                        bsum(2:kx+1)
                if (n == n_aerosol_bands) then
                  Optical%aerooptdep_KE_15(i,j) = &
                                Optical%aerooptdep_KE_15(i,j) +  &
                                Aerosol_props%lw_ext(i,j,kx,n)* &
                                Atmos_input%deltaz(i,j,kx)
                endif
              end do   
            end do
          endif ! (size)
        endif  ! (volcanic_lw_aerosols)
      end do  ! (n_aerosol_bnads)

!---------------------------------------------------------------------
       


end subroutine  optical_path_setup



!####################################################################
! <SUBROUTINE NAME="optical_trans_funct_from_KS">
!  <OVERVIEW>
!   Subroutine to compute transmission function from level KS to another
!   level
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to compute transmission function from level KS to another
!   level
!  </DESCRIPTION>
!  <TEMPLATE>
!   call optical_trans_funct_from_KS (Gas_tf, to3cnt, overod, Optical, &
!                                        cnttaub1, cnttaub2, cnttaub3)
!  </TEMPLATE>
!  <INOUT NAME="Gas_tf" TYPE="gas_tf_type">
!   Gas transmission functions
!  </INOUT>
!  <OUT NAME="to3cnt" TYPE="real">
!   Ozone continuum transmission function
!  </OUT>
!  <OUT NAME="overod" TYPE="real">
!   Transmission function due to h2o continuum and aerosol
!  </OUT> 
!  <INOUT NAME="Optical" TYPE="real">
!   Optical depth function
!  </INOUT>
!  <OUT NAME="cnttaub1, cnttaub2, cnttaub3" TYPE="real">
!   Transmission functions of gas continuum
!  </OUT>
! </SUBROUTINE>
!
subroutine optical_trans_funct_from_KS (Gas_tf, to3cnt, overod,   &
                                        Optical, cnttaub1, cnttaub2, &
                                        cnttaub3, including_aerosols)  

!--------------------------------------------------------------------
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
real, dimension (:,:,:), intent(out)   ::  to3cnt, overod, &
                                           cnttaub1, cnttaub2, cnttaub3
type(optical_path_type), intent(inout) ::  Optical
type(gas_tf_type),       intent(inout) ::  Gas_tf 
logical,                   intent(in)            :: including_aerosols  
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   intent(inout) variables:
!
!     Optical
!     Gas_tf
!
!   intent(out) variables:
!
!     to3cnt
!     overod
!     cnttaub1
!     cnttaub2
!     cnttaub3
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables:

      real, dimension (size(to3cnt,1), size(to3cnt,2), &
                       size(to3cnt,3)) ::   &
                                               tmp1, tmp2, tmp3,   &
                                               totch2o_tmp,  &
                                               totaer_tmp, tn2o17

      real, dimension (size(to3cnt,1), size(to3cnt,2), &
                       size(to3cnt,3)-1) ::    cfc_tf

      integer    :: m

!---------------------------------------------------------------------
!  local variables:
!
!     tmp1
!     tmp2
!     tmp3
!     totch2o_tmp
!     totaer_tmp
!     tn2o17
!     cfc_tf
!     m
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module is initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg( 'optical_path_mod',  &
              'module has not been initialized', FATAL )
      endif
!-----------------------------------------------------------------------
!    compute transmission functions in 990-1070 cm-1 range, including
!    ozone and h2o continuum, from level KS to all other levels. 
!------------------------------------------------------------------
      if (Lw_control%do_o3) then
        tmp1  (:,:,KS:KE) = bo3rnd(2)*Optical%tphio3(:,:,KS+1:KE+1)/  &
                            Optical%toto3(:,:,KS+1:KE+1)
        tmp2(:,:,KS:KE) = 0.5*(tmp1(:,:,KS:KE)*(SQRT(1.0E+00 +   &
                              (4.0E+00*ao3rnd(2)*  &
                               Optical%toto3(:,:,KS+1:KE+1))/  &
                               tmp1(:,:,KS:KE))  - 1.0E+00))
      else
        tmp2(:,:,KS:KE)  = 0.0E+00
      endif

      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        call get_totch2obd(6, Optical, totch2o_tmp)
        tmp2(:,:,KS:KE) = tmp2(:,:,KS:KE) + diffac*   &
                          totch2o_tmp(:,:,KS+1:KE+1)
      else if (trim(Lw_control%continuum_form) == 'rsb' ) then
        tmp2(:,:,KS:KE) = tmp2(:,:,KS:KE) + betacm(14)*   &
                          Optical%totvo2(:,:,KS+1:KE+1)
      endif

      if (including_aerosols) then
        totaer_tmp(:,:,:) = Optical%totaerooptdep(:,:,:,6)
        tmp2(:,:,KS:KE) = tmp2(:,:,KS:KE) +    &
                          totaer_tmp   (:,:,KS+1:KE+1)
      endif
      to3cnt(:,:,KS) = 1.0
      to3cnt(:,:,KS+1:KE+1) = EXP(-1.0E+00*tmp2(:,:,KS:KE))
 
!--------------------------------------------------------------------
!    if cfcs are included, also include the transmission functions for
!    f11, f12, f113, and f22 in to3cnt.
!---------------------------------------------------------------------
      if (Lw_control%do_cfc) then
        call cfc_exact (6, Optical, cfc_tf)
        to3cnt(:,:,KS+1:KE+1) = to3cnt(:,:,KS+1:KE+1)* cfc_tf(:,:,KS:KE)
      endif

!---------------------------------------------------------------------
!    compute transmission function in the 560-800 cm-1 range
!    evaluate  optical depth contributions 
!    add contributions from h2o(lines) and h2o(continuum).
!    h2o(continuum) contributions are either Roberts or CKD2.1
!---------------------------------------------------------------------
      if (Lw_control%do_h2o) then
        tmp1(:,:,KS:KE) = SQRT(ab15wd*Optical%totphi(:,:,KS+1:KE+1)) 
      else
        tmp1(:,:,:) = 0.0
      endif
      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        tmp1(:,:,KS:KE) = tmp1(:,:,KS:KE) + diffac*   &
                          Optical%totch2obdwd(:,:,KS+1:KE+1)
      else if (trim(Lw_control%continuum_form) == 'rsb' ) then
        tmp1(:,:,KS:KE) = tmp1(:,:,KS:KE) + betawd*   &
                          Optical%totvo2     (:,:,KS+1:KE+1)
      endif

!--------------------------------------------------------------------
!    add contribution from longwave aerosols (if desired).
!--------------------------------------------------------------------
      if (including_aerosols) then
        totaer_tmp(:,:,:) = Optical%totaerooptdep(:,:,:, 9)
        tmp1(:,:,KS:KE) = tmp1(:,:,KS:KE) +    &
                          totaer_tmp(:,:,KS+1:KE+1)
      endif
 
!----------------------------------------------------------------------
!    compute transmission function due to these contributions. the
!    effects of co2, n2o  and  cfc's (not exponentials) are added
!    later.
!---------------------------------------------------------------------
      overod(:,:,KS) = 1.0
      overod(:,:,KS+1:KE+1) = EXP(-1.0E+00*tmp1     (:,:,KS:KE))

!---------------------------------------------------------------------
!    add contribution from the 17 um n2o band (if desired).
!    the expression with tn2o17 retains the 560-630 cm-1 equi-
!    valent widths in evaluating 560-800 cm-1 transmissivities.
!---------------------------------------------------------------------
      if (Lw_control%do_n2o) then
        tn2o17(:,:,ks+1:ke+1) = Gas_tf%tn2o17(:,:,ks+1:ke+1)
        if (NBCO215 .EQ. 2) then
          overod(:,:,KS+1:KE+1) = overod(:,:,KS+1:KE+1) *    &
                                  (130./240. + 110./240.*   &
                                  tn2o17(:,:,KS+1:KE+1))
        elseif (NBCO215 .EQ. 3) then
          overod(:,:,KS+1:KE+1) = overod(:,:,KS+1:KE+1)*(170./240. +  &
                                  70./240.*tn2o17(:,:,KS+1:KE+1))
        endif
      endif

!--------------------------------------------------------------------- 
!    if cfcs are included, also include the transmission functions for
!    f11, f12, f113, and f22 in overod .
!--------------------------------------------------------------------
      if (Lw_control%do_cfc) then
        call cfc_overod (Optical, cfc_tf)
        overod(:,:,KS+1:KE+1) = overod(:,:,KS+1:KE+1)*cfc_tf(:,:,KS:KE)
      endif 

!----------------------------------------------------------------------
!    compute continuum band transmission functions from level KS to
!    other levels (cnttau). the continuum transmission function from
!    level k to kp (contod) equals cnttau for k=KS, so is not
!    evaluated here. for all other levels k, contod is obtained by
!    division of relevant values of cnttau.
!---------------------------------------------------------------------
      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        call get_totch2obd(4, Optical, totch2o_tmp)
        tmp1(:,:,KS:KE) = diffac*totch2o_tmp(:,:,KS+1:KE+1)
        call get_totch2obd(5, Optical, totch2o_tmp)
        tmp2(:,:,KS:KE) = diffac*totch2o_tmp(:,:,KS+1:KE+1)
        call get_totch2obd(7, Optical, totch2o_tmp)
        tmp3(:,:,KS:KE) = diffac*totch2o_tmp(:,:,KS+1:KE+1)
      else if (trim(Lw_control%continuum_form) == 'rsb' ) then
        tmp1(:,:,KS:KE) = betacm(12)*Optical%totvo2(:,:,KS+1:KE+1)
        tmp2(:,:,KS:KE) = betacm(13)*Optical%totvo2(:,:,KS+1:KE+1)
        tmp3(:,:,KS:KE) = betacm(15)*Optical%totvo2(:,:,KS+1:KE+1)
      endif

      if (including_aerosols) then
        totaer_tmp(:,:,:) = Optical%totaerooptdep(:,:,:,4)
        tmp1(:,:,KS:KE) =  tmp1(:,:,KS:KE) +    &
                           totaer_tmp   (:,:,KS+1:KE+1  )
        totaer_tmp(:,:,:) = Optical%totaerooptdep(:,:,:,5)
        tmp2(:,:,KS:KE) =  tmp2(:,:,KS:KE) +    &
                           totaer_tmp   (:,:,KS+1:KE+1)
        totaer_tmp(:,:,:) = Optical%totaerooptdep(:,:,:,7)
        tmp3(:,:,KS:KE) =  tmp3(:,:,KS:KE) +    &
                           totaer_tmp   (:,:,KS+1:KE+1)
      endif

      cnttaub1(:,:,KS) = 1.0                       
      cnttaub2(:,:,KS) = 1.0                       
      cnttaub3(:,:,KS) = 1.0                       
      cnttaub1(:,:,KS+1:KE+1) = EXP(-1.0*tmp1(:,:,KS:KE))
      cnttaub2(:,:,KS+1:KE+1) = EXP(-1.0*tmp2(:,:,KS:KE))
      cnttaub3(:,:,KS+1:KE+1) = EXP(-1.0*tmp3(:,:,KS:KE))

!---------------------------------------------------------------------
!    if cfcs are included, add transmission functions for f11, f12,
!    f113, and f22.
!---------------------------------------------------------------------
      if (Lw_control%do_cfc) then
        call cfc_exact (4, Optical, cfc_tf)
        cnttaub1(:,:,KS+1:KE+1) = cnttaub1(:,:,KS+1:KE+1)*  &
                                  cfc_tf(:,:,KS:KE)
        call cfc_exact (5, Optical, cfc_tf)
        cnttaub2(:,:,KS+1:KE+1) = cnttaub2(:,:,KS+1:KE+1)*  &
                                  cfc_tf(:,:,KS:KE)
        call cfc_exact (7, Optical, cfc_tf)
        cnttaub3(:,:,KS+1:KE+1) = cnttaub3(:,:,KS+1:KE+1)*   &
                                  cfc_tf(:,:,KS:KE)
      endif 
 
!----------------------------------------------------------------------
!    evaluate h2o (mbar*phibar) between level KS and other levels.
!----------------------------------------------------------------------
      Optical%avephi(:,:,KS:KE) = Optical%totphi(:,:,KS+1:KE+1)
 
!----------------------------------------------------------------------
!    the evaluation of emiss over the layer between data level (KS)
!    and flux level (KE+1) is done by averaging E2 functions referring
!    to the top and bottom of the layer. a special value of (mbar*
!    phibar) is required; it is stored in the (otherwise vacant)
!    KE+1'th position of avephi.
!----------------------------------------------------------------------
      Optical%avephi(:,:,KE+1) = Optical%avephi(:,:,KE-1) +   &
                                 Optical%emx1(:,:)

!----------------------------------------------------------------------
!    if h2o lines in the 1200-1400 range are assumed to have a temp-
!    erature dependent intensity, similar evaluation for (mbar*phibar)
!    is performed, with a special value for the lowest layer
!----------------------------------------------------------------------
      if (NBTRGE > 0) then
        if (tmp_dpndnt_h2o_lines) then
          do m=1,NBTRGE
            Optical%avephif(:,:,KS:KE,m) =     &
                                       Optical%tphfh2o(:,:,KS+1:KE+1,m)
          end do
          do m=1,NBTRGE
            Optical%avephif(:,:,KE+1,m) =   &
                                        Optical%avephif(:,:,KE-1,m) +  &
                                        Optical%emx1f(:,:,m)
          end do
        else 
          do m=1,NBTRGE
            Optical%avephif(:,:,KS:KE,m) =     &
                                       Optical%avephi(:,:,KS:KE)
          end do
          do m=1,NBTRGE
            Optical%avephif(:,:,KE+1,m) = Optical%avephi(:,:,KE+1)
          end do
        endif
      endif

!----------------------------------------------------------------------


end subroutine optical_trans_funct_from_KS




!####################################################################
! <SUBROUTINE NAME="optical_trans_funct_k_down">
!  <OVERVIEW>
!   Subroutine to compute transmission function downward from level k
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to compute transmission function downward from level k
!  </DESCRIPTION>
!  <TEMPLATE>
!   call optical_trans_funct_k_down (Gas_tf, k,                     &
!                                    to3cnt, overod, Optical)
!  </TEMPLATE>
!  <INOUT NAME="Gas_tf" TYPE="gas_tf_type">
!   Gas transmission functions
!  </INOUT>
!  <IN NAME="k" TYPE="integer">
!   The data level from which downward transmission functions are computed
!  </IN>
!  <OUT NAME="to3cnt" TYPE="real">
!   Ozone continuum transmission function
!  </OUT>
!  <OUT NAME="overod" TYPE="real">
!   Transmission function due to h2o continuum and aerosol
!  </OUT> 
!  <INOUT NAME="Optical" TYPE="real">
!   Optical depth function
!  </INOUT>
! </SUBROUTINE>
!
subroutine optical_trans_funct_k_down (Gas_tf, k, to3cnt, overod,   &
                                       Optical,including_aerosols)  

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------

integer,                 intent (in)    :: k
real, dimension (:,:,:), intent(out)    :: to3cnt, overod
type(optical_path_type), intent(inout)  :: Optical
type(gas_tf_type),       intent(inout)  :: Gas_tf 
logical,                   intent(in)            :: including_aerosols  

!---------------------------------------------------------------------
!   intent(in) variable:
!        
!       k
!
!   intent(inout) variables:
!
!       Optical
!       Gas_tf
!
!   intent(out) variables:
!
!       to3cnt
!       overod
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      real, dimension (size(to3cnt,1), size(to3cnt,2), &
                       size(to3cnt,3)) ::    &
                                                avmo3, avpho3, tmp1, &
                                                tmp2, avvo2,  &
                                                avckdwd, avckdo3, &
                                                avaero3, totch2o_tmp,  &
                                                totaer_tmp, tn2o17

      real, dimension (size(to3cnt,1), size(to3cnt,2), &
                       size(to3cnt,3)-1) ::     cfc_tf

      integer       :: kp, m

!---------------------------------------------------------------------
!   local variables:
!
!       avmo3
!       avpho3
!       tmp1
!       tmp2
!       avvo2
!       avchdwd
!       avckdo3
!       avaero3  
!       totch2o_tmp
!       totaer_tmp
!       tn2o17
!       cfc_tf
!       kp
!       m
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module is initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg( 'optical_path_mod',  &
              'module has not been initialized', FATAL )
      endif
!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        call get_totch2obd(6, Optical, totch2o_tmp)
      endif

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      if (including_aerosols) then
        totaer_tmp(:,:,:) = Optical%totaerooptdep(:,:,:,6)
      endif

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      do kp=1,KE+1-k
        avmo3 (:,:,kp+k-1) = Optical%toto3 (:,:,kp+k) -    &
                             Optical%toto3 (:,:,k)
        avmo3 (:,:,kp+k-1) = max(avmo3 (:,:,kp+k-1),1.0e-10)
        avpho3(:,:,kp+k-1) = Optical%tphio3(:,:,kp+k) -    &
                             Optical%tphio3(:,:,k) 
        avpho3 (:,:,kp+k-1) = max(avpho3 (:,:,kp+k-1),1.0e-12)
        if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
            trim(Lw_control%continuum_form) == 'ckd2.4' ) then
          avckdwd(:,:,kp+k-1) = Optical%totch2obdwd(:,:,kp+k) -   &
                                Optical%totch2obdwd(:,:,k)
          avckdo3(:,:,kp+k-1) = totch2o_tmp(:,:,kp+k) -  &
                                totch2o_tmp(:,:,k)
        else if (trim(Lw_control%continuum_form) == 'rsb' ) then
          avvo2 (:,:,kp+k-1) = Optical%totvo2(:,:,kp+k) -   &
                               Optical%totvo2(:,:,k)
        endif 
        if (including_aerosols) then
          avaero3(:,:,kp+k-1) =  &
                       totaer_tmp   (:,:,kp+k) - totaer_tmp   (:,:,k)
         endif
       end do

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
       do kp=1,KE+1-k
         Optical%avephi  (:,:,kp+k-1) = Optical%totphi(:,:,kp+k) -  &
                                        Optical%totphi(:,:,k)
       end do
       Optical%avephi (:,:,KE+1) = Optical%avephi(:,:,KE-1) +   &
                                   Optical%emx1(:, :)

!---------------------------------------------------------------------
!    if h2o lines in the 1200-1400 range are assumed to have a temp-
!    erature dependent intensity, similar evaluation for (mbar*phibar)
!    is performed, with a special value for the lowest layer
!---------------------------------------------------------------------
      if (NBTRGE > 0) then
        if (tmp_dpndnt_h2o_lines) then
          do m=1,NBTRGE
            do kp=1,KE+1-k
              Optical%avephif(:,:,kp+k-1,m) =   &
                                     Optical%tphfh2o(:,:,kp+k,m) -  &
                                     Optical%tphfh2o(:,:,k,   m)
            end do
            Optical%avephif(:,:,KE+1,m) =   &
                                         Optical%avephif(:,:,KE-1,m) + &
                                         Optical%emx1f(:,:,m)
          end do
        else
          do m=1,NBTRGE
            do kp=1,KE+1-k
              Optical%avephif(:,:,kp+k-1,m) = Optical%avephi(:,:,kp+k-1)
            end do
            Optical%avephif(:,:,KE+1,m) = Optical%avephi(:,:,KE+1) 
          end do
        endif
      endif

!----------------------------------------------------------------------
!    compute transmission function in the 560-800 cm-1 range
!    evaluate  optical depth contributions 
!
!    add contributions from h2o(lines) and h2o(continuum).
!    h2o(continuum) contributions are either Roberts or CKD2.1
!----------------------------------------------------------------------
      if (Lw_control%do_h2o) then 
        tmp1(:,:,k:KE) = SQRT(ab15wd*Optical%avephi(:,:,k:KE)) 
      else
        tmp1(:,:,k:KE) = 0.0
      endif

      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        tmp1(:,:,k:KE) = tmp1(:,:,k:KE) + diffac*   &
                         avckdwd    (:,:,k:KE)
      else if (trim(Lw_control%continuum_form) == 'rsb' ) then
        tmp1(:,:,k:KE) = tmp1(:,:,k:KE) + betawd*   &
                         avvo2      (:,:,k:KE)
      endif

!-------------------------------------------------------------------
!    add contribution from longwave aerosols (if desired).
!-------------------------------------------------------------------
      if (including_aerosols) then
        totaer_tmp      (:,:,:) = Optical%totaerooptdep   (:,:,:,9)
        do kp=k,KE
          tmp1(:,:,kp) = tmp1(:,:,kp) +    &
                         (totaer_tmp(:,:,kp+1) - totaer_tmp(:,:,k) )
        end do
      endif

!---------------------------------------------------------------------
!    compute transmission function due to these contributions. the
!    effects of co2, n2o  and  cfc's (not exponentials) are added
!    later.
!--------------------------------------------------------------------
      overod(:,:,k+1:KE+1) = EXP(-1.0E+00*tmp1(:,:,k:KE))

!----------------------------------------------------------------------
!    add contribution from the 17 um n2o band (if desired).
!    the expression with tn2o17 retains the 560-630 cm-1 equi-
!    valent widths in evaluating 560-800 cm-1 transmissivities.
!---------------------------------------------------------------------
      if (Lw_control%do_n2o) then
        tn2o17(:,:,k+1:ke+1) = Gas_tf%tn2o17(:,:,k+1:ke+1)
        if (NBCO215 .EQ. 2) then
          overod(:,:,k+1:KE+1) = overod(:,:,k+1:KE+1) *(130./240. +  &
                                 110./240.*tn2o17(:,:,k+1:KE+1))
        elseif (NBCO215 .EQ. 3) then
          overod(:,:,k+1:KE+1) = overod(:,:,k+1:KE+1)*(170./240. + &
                                 70./240.*tn2o17(:,:,k+1:KE+1))
        endif
      endif

!----------------------------------------------------------------------
!    if cfcs are included, also include the transmission functions for
!    f11, f12, f113, and f22 in overod .
!----------------------------------------------------------------------
      if (Lw_control%do_cfc) then
        call cfc_overod_part ( Optical, cfc_tf, k)
        overod(:,:,k+1:KE+1) = overod(:,:,k+1:KE+1)*cfc_tf(:,:,k:KE)
      endif

!--------------------------------------------------------------------
!    compute transmission functions in 990-1070 cm-1 range, including
!    ozone and h2o continuum, from level k to all other levels. 
!---------------------------------------------------------------------
      if (Lw_control%do_o3) then
        tmp1  (:,:,k:KE) = bo3rnd(2)*avpho3(:,:,k:KE)/avmo3(:,:,k:KE)
        tmp2(:,:,k:KE) = 0.5*(tmp1(:,:,k:KE)*(SQRT(1.0E+00 + (4.0E+00* &
                           ao3rnd(2)*avmo3(:,:,k:KE))/tmp1(:,:,k:KE))  &
                           - 1.0E+00))
      else
        tmp2(:,:,k:KE) = 0.0
      endif

      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        tmp2(:,:,k:KE) = tmp2(:,:,k:KE) + diffac*   &
                         avckdo3  (:,:,k:KE) 
      else if (trim(Lw_control%continuum_form) == 'rsb' ) then
        tmp2(:,:,k:KE) = tmp2(:,:,k:KE) + betacm(14)*   &
                         avvo2 (:,:,k:KE)
      endif
      if (including_aerosols) then
        tmp2(:,:,k:KE) = tmp2(:,:,k:KE) +   &
                         avaero3      (:,:,k:KE)
      endif
      to3cnt(:,:,k+1:KE+1) = EXP(-1.0E+00*tmp2(:,:,k:KE))

!---------------------------------------------------------------------
!    if cfcs are included, also include the transmission functions for
!    f11, f12, f113, and f22 in to3cnt.
!---------------------------------------------------------------------
      if (Lw_control%do_cfc) then
        call cfc_exact_part (6, Optical, cfc_tf, k)
        to3cnt(:,:,k+1:KE+1) = to3cnt(:,:,k+1:KE+1)*cfc_tf(:,:,k:KE)
      endif 
!---------------------------------------------------------------------


end subroutine optical_trans_funct_k_down



!#################################################################
! <SUBROUTINE NAME="optical_trans_funct_KE">
!  <OVERVIEW>
!   Subroutine to compute transmission function from level KE
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to compute transmission function from level KE
!  </DESCRIPTION>
!  <TEMPLATE>
!   call optical_trans_funct_KE (Gas_tf, to3cnt, Optical, overod)
!  </TEMPLATE>
!  <INOUT NAME="Gas_tf" TYPE="gas_tf_type">
!   Gas transmission functions
!  </INOUT>
!  <OUT NAME="to3cnt" TYPE="real">
!   Ozone continuum transmission function
!  </OUT>
!  <OUT NAME="overod" TYPE="real">
!   Transmission function due to h2o continuum and aerosol
!  </OUT> 
!  <INOUT NAME="Optical" TYPE="real">
!   Optical depth function
!  </INOUT>
! </SUBROUTINE>
!
subroutine optical_trans_funct_KE (Gas_tf, to3cnt, Optical, overod, &
                                   including_aerosols)  

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------

real, dimension (:,:,:), intent(out)   :: to3cnt, overod
type(optical_path_type), intent(inout) :: Optical
type(gas_tf_type),       intent(inout) :: Gas_tf 
logical,                   intent(in)            :: including_aerosols  

!---------------------------------------------------------------------
!   intent(inout) variables:
!
!     Optical
!     Gas_tf
!
!   intent(out) variables:
!
!     to3cnt
!     overod
!
!---------------------------------------------------------------------


!---------------------------------------------------------------------
!   local variables:

      real, dimension (size(to3cnt,1), size(to3cnt,2), &
                       size(to3cnt,3)) ::    &
                                             tmp1, tmp2, tn2o17

      real, dimension (size(to3cnt,1), size(to3cnt,2), &
                       size(to3cnt,3)-1) ::    &
                                             cfc_tf

      real, dimension (size(to3cnt,1), size(to3cnt,2)) :: &
                                             aerooptdep_KE_15

!---------------------------------------------------------------------
!   local variables:
!
!      tmp1
!      tmp2
!      tn2o17
!      cfc_tf
!      aer_tmp
!      aerooptdep_KE_15
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module is initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg( 'optical_path_mod',  &
             'module has not been initialized', FATAL )
      endif

!-----------------------------------------------------------------------
!    compute transmission function in the 560-800 cm-1 range. evaluate 
!    optical depth contributions. add contributions from h2o(lines) and
!    h2o(continuum). h2o(continuum) contributions are either Roberts 
!    or CKD2.1 or CKD2.4.
!----------------------------------------------------------------------
      if (Lw_control%do_h2o) then
        tmp1     (:,:,KE) = SQRT(ab15wd*Optical%var2  (:,:,KE)) 
      else
        tmp1     (:,:,KE) = 0.0
      endif
      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        tmp1(:,:,KE) = tmp1(:,:,KE) + diffac*   &
                       Optical%xch2obdwd   (:,:,KE)
      else if (trim(Lw_control%continuum_form) == 'rsb' ) then
        tmp1(:,:,KE) = tmp1(:,:,KE) + betawd*  &
                       Optical%cntval     (:,:,KE)
      endif

!---------------------------------------------------------------------
!    add contribution from longwave aerosols (if desired).
!---------------------------------------------------------------------
      if (including_aerosols) then
        aerooptdep_KE_15(:,:) = Optical%aerooptdep_KE_15(:,:)
        tmp1(:,:,KE) = tmp1(:,:,KE) + aerooptdep_KE_15(:,:)  
      endif
 
!---------------------------------------------------------------------
!    compute transmission function due to these contributions. the
!    effects of co2, n2o  and  cfc's (not exponentials) are added
!    later.
!---------------------------------------------------------------------
      overod(:,:,KE+1) = EXP(-1.0E+00*tmp1     (:,:,KE))
 
!---------------------------------------------------------------------
!    add contribution from the 17 um n2o band (if desired).
!    the expression with tn2o17 retains the 560-630 cm-1 equi-
!    valent widths in evaluating 560-800 cm-1 transmissivities.
!---------------------------------------------------------------------
      if (Lw_control%do_n2o) then
        tn2o17(:,:,ke+1    ) = Gas_tf%tn2o17(:,:,ke+1)
        if (NBCO215 .EQ. 2) then
          overod(:,:,KE+1) = overod(:,:,KE+1) *  &
                             (130./240. + 110./240.*tn2o17(:,:,KE+1))
        else if (NBCO215 .EQ. 3) then
          overod(:,:,KE+1) = overod(:,:,KE+1) *   &
                             (170./240. + 70./240.*tn2o17(:,:,KE+1))
        endif
      endif

!---------------------------------------------------------------------
!    if cfcs are included, also include the transmission functions for
!    f11, f12, f113, and f22 in overod .
!---------------------------------------------------------------------
      if (Lw_control%do_cfc) then
        call cfc_overod_part (Optical, cfc_tf, KE)
        overod(:,:,KE+1) = overod(:,:,KE+1)*cfc_tf(:,:,KE)
      endif 

!-----------------------------------------------------------------------
!    compute transmission functions in 990-1070 cm-1 range, including
!    ozone and h2o continuum, from level KS to all other levels. 
!---------------------------------------------------------------------
      if (Lw_control%do_o3) then
        tmp1  (:,:,KE) = bo3rnd(2)*Optical%var4(:,:,KE)/  &
                         Optical%var3(:,:,KE)
        tmp2(:,:,KE) = 0.5*(tmp1(:,:,KE)*(SQRT(1.0E+00 + (4.0E+00*  &
                       ao3rnd(2)*Optical%var3 (:,:,KE))/  &
                       tmp1(:,:,KE)) - 1.0E+00))
      else
        tmp2(:,:,KE) = 0.0
      endif

      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        tmp2(:,:,KE) = tmp2(:,:,KE) + diffac*Optical%xch2obd  (:,:,KE,6)
      else if (trim(Lw_control%continuum_form) == 'rsb' ) then
        tmp2(:,:,KE) = tmp2(:,:,KE) + betacm(14)*Optical%cntval (:,:,KE)
      endif

      to3cnt(:,:,KE+1) = EXP(-1.0E+00*tmp2(:,:,KE))

!---------------------------------------------------------------------
!    if cfcs are included, also include the transmission functions for
!    f11, f12, f113, and f22 in overod and to3cnt.
!---------------------------------------------------------------------
      if (Lw_control%do_cfc) then
        call cfc_exact_part (6, Optical, cfc_tf, KE)
        to3cnt(:,:,KE+1) = to3cnt(:,:,KE+1)*cfc_tf(:,:,KE)
      endif

!-------------------------------------------------------------------


end subroutine optical_trans_funct_KE




!####################################################################
! <SUBROUTINE NAME="optical_trans_funct_diag">
!  <OVERVIEW>
!   Subroutine to compute diagnostic transmission function
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to compute diagnostic transmission function
!  </DESCRIPTION>
!  <TEMPLATE>
!   call optical_trans_funct_diag (Atmos_input, contdg, to3dg, &
!                                  Optical)
!  </TEMPLATE>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
!   Atmospheric input data
!  </IN>
!  <OUT NAME="to3dg" TYPE="real">
!   Ozone continuum diagnostic transmission function
!  </OUT>
!  <OUT NAME="contdg" TYPE="real">
!   Diagnostic continuum transmission functions
!  </OUT> 
!  <INOUT NAME="Optical" TYPE="real">
!   Optical depth function
!  </INOUT>
! </SUBROUTINE>
!
subroutine optical_trans_funct_diag (Atmos_input, contdg, to3dg, &
                                     Optical)

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------

real, dimension (:,:,:),   intent(out)   :: to3dg                
real, dimension (:,:,:,:), intent(out)   :: contdg               
type(optical_path_type),   intent(inout) :: Optical
type(atmos_input_type),    intent(in)    :: Atmos_input

!---------------------------------------------------------------------
!   intent(in) variables:
!
!     Atmos_input
!
!   intent(inout) variables:
!
!     Optical
!
!   intent(out) variables:
!
!     to3dg
!     contdg
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      real, dimension (size(Atmos_input%pflux,1),             &
                       size(Atmos_input%pflux,2),             &
                       size(Atmos_input%pflux,3)-1) ::        &
                                                       pdfinv

      real, dimension (size(Atmos_input%pflux,1),          &
                       size(Atmos_input%pflux,2), &
                       size(Atmos_input%pflux,3)) ::  &
                                    press, pflux, ca, cb, csuba,  &
                                    csubb, ctmp2, ctmp3, delpr1, delpr2

!---------------------------------------------------------------------
!   local variables:
!
!      pdfinv
!      press 
!      pflux 
!      ca        
!      cb      
!      csuba 
!      csubb 
!      ctmp2 
!      ctmp3 
!      delpr1
!      delpr2
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module is initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg( 'optical_path_mod',  &
               'module has not been initialized', FATAL )
      endif
!---------------------------------------------------------------------
!    convert press and pflux to cgs.
!---------------------------------------------------------------------
      press(:,:,:) = 10.0*Atmos_input%press(:,:,:)
      pflux(:,:,:) = 10.0*Atmos_input%pflux(:,:,:)

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      pdfinv(:,:,ks:ke) = 1.0/(pflux(:,:,ks+1:ke+1) - pflux(:,:,ks:ke))
      delpr1(:,:,KS+1:KE)   = pdfinv (:,:,KS+1:KE)*  &
                              (press(:,:,KS+1:KE) - pflux(:,:,KS+1:KE)) 
      delpr2(:,:,KS+1:KE+1) = pdfinv(:,:,KS:KE)*   &
                              (pflux(:,:,KS+1:KE+1) - press(:,:,KS:KE)) 

!-----------------------------------------------------------------------
!    compute nearby-layer transmissivities for the o3 band and for the
!    one-band continuum band.  the sf function is used.
!    the method is the same as described for co2 in reference(4).
!-----------------------------------------------------------------------
      if (trim(Lw_control%continuum_form) == 'rsb' ) then
        ctmp2(:,:,KS+1:KE)  = Optical%cntval(:,:,KS+1:KE)*  &
                              delpr1(:,:,KS+1:KE) 
        ctmp3(:,:,KS+1:KE)  = Optical%cntval(:,:,KS:KE-1)*   &
                              delpr2(:,:,KS+1:KE) 
      endif
    
!-----------------------------------------------------------------------
!    compute sf2.
!    continuum band 1
!-----------------------------------------------------------------------
      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        csuba(:,:,KS+1:KE)  = diffac*Optical%xch2obd(:,:,KS+1:KE,4)*  &
                              delpr1(:,:,KS+1:KE)
        csubb(:,:,KS+1:KE)  = diffac*Optical%xch2obd(:,:,KS:KE-1,4)*  &
                              delpr2(:,:,KS+1:KE)
      else if (trim(Lw_control%continuum_form) == 'rsb' ) then
        csuba(:,:,KS+1:KE)  = betacm(12)*ctmp2(:,:,KS+1:KE)
        csubb(:,:,KS+1:KE)  = betacm(12)*ctmp3(:,:,KS+1:KE)
      endif
      ca    (:,:,KS+1:KE) = csuba(:,:,KS+1:KE)*(-0.5E+00 +    &
                            csuba(:,:,KS+1:KE)*(0.166666E+00 -  &
                            csuba(:,:,KS+1:KE)*0.416666E-01))   
      cb    (:,:,KS+1:KE) = csubb(:,:,KS+1:KE)*(-0.5E+00 +  &
                            csubb(:,:,KS+1:KE)*(0.166666E+00 - &
                            csubb(:,:,KS+1:KE)*0.416666E-01)) 
      contdg(:,:,KE+1,1)    = 1.0E+00 + cb (:,:,KE)
      contdg(:,:,KS+1:KE,1) = 1.0E+00 + 0.5E+00*(ca (:,:,KS+1:KE) +  &
                              cb (:,:,KS+1:KE))

!--------------------------------------------------------------------
!    continuum band 2
!---------------------------------------------------------------------
      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        csuba(:,:,KS+1:KE)  = diffac*Optical%xch2obd(:,:,KS+1:KE,5)*   &
                              delpr1(:,:,KS+1:KE)
        csubb(:,:,KS+1:KE)  = diffac*Optical%xch2obd(:,:,KS:KE-1,5)*  &
                              delpr2(:,:,KS+1:KE)
      else if (trim(Lw_control%continuum_form) == 'rsb' ) then
        csuba(:,:,KS+1:KE)  = betacm(13)*ctmp2(:,:,KS+1:KE)
        csubb(:,:,KS+1:KE)  = betacm(13)*ctmp3(:,:,KS+1:KE)
      endif
      ca    (:,:,KS+1:KE) = csuba(:,:,KS+1:KE)*(-0.5E+00 +  &
                            csuba(:,:,KS+1:KE)*(0.166666E+00 -   &
                            csuba(:,:,KS+1:KE)*0.416666E-01)) 
      cb    (:,:,KS+1:KE) = csubb(:,:,KS+1:KE)*(-0.5E+00 +   &
                            csubb(:,:,KS+1:KE)*(0.166666E+00 -   &
                            csubb(:,:,KS+1:KE)*0.416666E-01)) 
      contdg(:,:,KE+1,2)    = 1.0E+00 + cb (:,:,KE)
      contdg(:,:,KS+1:KE,2) = 1.0E+00 + 0.5E+00*(ca (:,:,KS+1:KE) +  &
                              cb (:,:,KS+1:KE))

!--------------------------------------------------------------------
!    continuum band 3
!--------------------------------------------------------------------
      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        csuba(:,:,KS+1:KE)  = diffac*Optical%xch2obd(:,:,KS+1:KE,7)*   &
                              delpr1(:,:,KS+1:KE)
        csubb(:,:,KS+1:KE)  = diffac*Optical%xch2obd(:,:,KS:KE-1,7)*  &
                              delpr2(:,:,KS+1:KE)
      else if (trim(Lw_control%continuum_form) == 'rsb' ) then
        csuba(:,:,KS+1:KE)  = betacm(15)*ctmp2(:,:,KS+1:KE)
        csubb(:,:,KS+1:KE)  = betacm(15)*ctmp3(:,:,KS+1:KE)
      endif
      ca    (:,:,KS+1:KE) = csuba(:,:,KS+1:KE)*(-0.5E+00 +    &
                            csuba(:,:,KS+1:KE)*(0.166666E+00 -  &
                            csuba(:,:,KS+1:KE)*0.416666E-01)) 
      cb    (:,:,KS+1:KE) = csubb(:,:,KS+1:KE)*(-0.5E+00 +   &
                            csubb(:,:,KS+1:KE)*(0.166666E+00 -  &
                            csubb(:,:,KS+1:KE)*0.416666E-01)) 
      contdg(:,:,KE+1,3)    = 1.0E+00 + cb (:,:,KE)
      contdg(:,:,KS+1:KE,3) = 1.0E+00 + 0.5E+00*(ca (:,:,KS+1:KE) +   &
                              cb (:,:,KS+1:KE))

!--------------------------------------------------------------------
!    ozone band
!--------------------------------------------------------------------
      if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
          trim(Lw_control%continuum_form) == 'ckd2.4' ) then
        csuba(:,:,KS+1:KE)  = diffac*Optical%xch2obd(:,:,KS+1:KE,6)*   &
                              delpr1(:,:,KS+1:KE)
        csubb(:,:,KS+1:KE)  = diffac*Optical%xch2obd(:,:,KS:KE-1,6)*  &
                              delpr2(:,:,KS+1:KE)
      else if (trim(Lw_control%continuum_form) == 'rsb' ) then
        csuba(:,:,KS+1:KE)  = betacm(14)*ctmp2(:,:,KS+1:KE)
        csubb(:,:,KS+1:KE)  = betacm(14)*ctmp3(:,:,KS+1:KE)
      endif
      ca   (:,:,KS+1:KE)  = csuba(:,:,KS+1:KE)*(-0.5E+00 +   &
                            csuba(:,:,KS+1:KE)*   &
                            (0.166666E+00 - csuba(:,:,KS+1:KE)*  &
                            0.416666E-01)) 
      cb   (:,:,KS+1:KE)  = csubb(:,:,KS+1:KE)*(-0.5E+00 +  &
                            csubb(:,:,KS+1:KE)*   &
                            (0.166666E+00 - csubb(:,:,KS+1:KE)*   &
                            0.416666E-01)) 
      to3dg (:,:,KE+1)    = 1.0E+00 + cb(:,:,KE)
      to3dg (:,:,KS+1:KE) = 1.0E+00 + 0.5E+00*(ca(:,:,KS+1:KE) +   &
                            cb(:,:,KS+1:KE))

!-------------------------------------------------------------------



end subroutine optical_trans_funct_diag


!###################################################################
! <SUBROUTINE NAME="get_totch2o">
!  <OVERVIEW>
!   Subroutine to compute self broadened temperature dependent
!   water vapor continuum
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to compute self broadened temperature dependent
!   water vapor continuum
!  </DESCRIPTION>
!  <TEMPLATE>
!   call get_totch2o (n, Optical, totch2o, dte1, ixoe1)
!  </TEMPLATE>
!  <IN NAME="n" TYPE="integer">
!   frequency band index
!  </IN>
!  <INOUT NAME="Optical" TYPE="optical_path_type">
!   Optical depth output
!  </INOUT>
!  <OUT NAME="totch2o" TYPE="real">
!   self broadened and temperature dependent continuum
!  </OUT>
!  <IN NAME="dte1" TYPE="real">
!   temperature step delta
!  </IN>
!  <IN NAME="ixoe1" TYPE="integer">
!   temperature index array
!  </IN>
! </SUBROUTINE>
!
subroutine get_totch2o (n, Optical, totch2o, dte1, ixoe1)

!------------------------------------------------------------------
!
!------------------------------------------------------------------

real, dimension(:,:,:),    intent(in)      :: dte1    
type(optical_path_type),   intent(inout)   :: Optical
integer, dimension(:,:,:), intent(in)      :: ixoe1   
real, dimension(:,:,:),    intent(out)     :: totch2o
integer,                   intent(in)      :: n

!-----------------------------------------------------------------
!   intent(in) variables:
!
!        dte1
!        ixoe1
!        n
!      
!   intent(inout) variables:
!        Optical
!
!   intent(out) variables:
!
!        totch2o
!
!---------------------------------------------------------------------

!------------------------------------------------------------------
!   local variables:

      real, dimension (size(Optical%tfac,1), size(Optical%tfac,2), &
                       size(Optical%tfac,3)) ::     &
                                                 radf, sh2o , tmpexp

      real               ::  fh2o0, sh2o0
      integer            ::  k, nu

!------------------------------------------------------------------
!   local variables:
!
!       radf
!       sh2o
!       tmpexp
!       fh2o0
!       sh2o0
!       k
!       nu
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module is initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg( 'optical_path_mod',  &
              'module has not been initialized', FATAL )
      endif
!--------------------------------------------------------------------
!    compute self-broadened temperature-dependent continuum coefficient
!    using the single coefficient -.013 for all frequencies in
!    the 160-560 cm-1 range. experiments with the mid-latitude
!    summer profile show errors of < .01 W/m**2 (in the net broadband
!    flux, 0-2200 cm-1) using this value. this value is used instead
!    of tmpfctrs at each frequency band.
!--------------------------------------------------------------------
      tmpexp(:,:,KS:KE) = EXP(-.013*Optical%tfac(:,:,KS:KE))

!--------------------------------------------------------------------
!    compute source function for frequency bands (ioffh2o+1 to ioffh2o
!    +nptch2o) at layer temperatures using table lookup.
!    note that ixoe1 can be used for temp index, and dte1 for deltat,
!    as the table extent for radf is the same as for the e1 tables
!    of the model.
!--------------------------------------------------------------------
      nu = n
      call looktab (radfunc, ixoe1, dte1, radf, KS, KE, nu+ioffh2o)
      sh2o0 = ssh2o_296(nu+ioffh2o)*sfac(nu+ioffh2o)

      do k=KS,KE 
        sh2o(:,:,k) = sh2o0*        tmpexp(:,:,k)
      end do
 
!--------------------------------------------------------------------
!    compute h2o self- and foreign- broadened continuum optical path,
!    summed from the top of the atmosphere through layer k.
!--------------------------------------------------------------------
      fh2o0 = sfh2o(nu+ioffh2o)*fscal(nu+ioffh2o)
      totch2o(:,:,1) = 0.0E+00
      do k = KS+1,KE+1
        totch2o(:,:,k) = Optical%wk(:,:,k-1)*1.0e-20*   &
                         (sh2o(:,:,k-1)*Optical%rh2os(:,:,k-1) +    &
                          fh2o0*Optical%rfrgn(:,:,k-1))* &
                          vvj(nu)*radf(:,:,k-1   )    +   &
                          totch2o(:,:,k-1)
      end do

!------------------------------------------------------------------

end subroutine get_totch2o



!#####################################################################
! <SUBROUTINE NAME="get_totch2obd">
!  <OVERVIEW>
!   Subroutine to compute self broadened temperature dependent
!   water vapor continuum
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to compute self broadened temperature dependent
!   water vapor continuum
!  </DESCRIPTION>
!  <TEMPLATE>
!   call get_totch2obd (n, Optical, totch2obd)
!  </TEMPLATE>
!  <IN NAME="n" TYPE="integer">
!   frequency band index
!  </IN>
!  <INOUT NAME="Optical" TYPE="optical_path_type">
!   Optical depth output
!  </INOUT>
!  <OUT NAME="totch2obd" TYPE="real">
!   self broadened and temperature dependent h2o continuum
!  </OUT>
! </SUBROUTINE>
!
subroutine get_totch2obd (n, Optical, totch2obd)

!------------------------------------------------------------------
!
!------------------------------------------------------------------

real, dimension(:,:,:), intent(out)     :: totch2obd
integer,                intent(in)      :: n
type(optical_path_type), intent(inout) :: Optical

!-----------------------------------------------------------------
!   intent(in) variables:
!
!      n
!
!   intent(inout) variable:
!
!      Optical
!
!   intent(out) variable:
!
!      totch2obd
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

      integer            ::  k, nu

!--------------------------------------------------------------------
!  local variables:
!
!      k
!      nu
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module is initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg( 'optical_path_mod',  &
              'module has not been initialized', FATAL )
      endif
!---------------------------------------------------------------------
!    compute h2o self- and foreign- broadened continuum optical path 
!    for each layer k (xch2obd, xch2obdinw, xch2obdwd) and summed from
!    the top of the atmosphere through layer k (totch2obd,
!    totch2obdinw, totch2obdwd).
!---------------------------------------------------------------------
      nu = n     
      totch2obd(:,:,1) = 0.0E+00
      do k = KS+1,KE+1
        totch2obd(:,:,k) = totch2obd(:,:,k-1) +   &
                           Optical%xch2obd(:,:,k-1,nu)
      end do

!--------------------------------------------------------------------
 
end subroutine get_totch2obd




!#####################################################################
! <SUBROUTINE NAME="get_totvo2">
!  <OVERVIEW>
!   Subroutine to compute continuum coefficients in band n
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to compute continuum coefficients in band n
!  </DESCRIPTION>
!  <TEMPLATE>
!   call get_totvo2 (n, Optical, totvo2_out) 
!  </TEMPLATE>
!  <IN NAME="n" TYPE="integer">
!   frequency band index
!  </IN>
!  <INOUT NAME="Optical" TYPE="optical_path_type">
!   Optical depth output
!  </INOUT>
!  <OUT NAME="totvo2_out" TYPE="real">
!   Continuum coefficients in band n
!  </OUT>
! </SUBROUTINE>
!
subroutine get_totvo2 (n, Optical, totvo2_out) 

!------------------------------------------------------------------
!
!------------------------------------------------------------------

integer,                 intent(in)       :: n
type(optical_path_type), intent(inout)    :: Optical
real, dimension(:,:,:),  intent(out)      :: totvo2_out

!-----------------------------------------------------------------
!   intent(in) variables:
!
!      n
!
!   intent(inout) variable:
!
!      Optical
!
!   intent(out) variable:
!
!      totvo2_out
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module is initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg( 'optical_path_mod',  &
             'module has not been initialized', FATAL )
      endif

!-----------------------------------------------------------------

      totvo2_out(:,:,:) = betacm(n)*Optical%totvo2(:,:,KS+1:KE+1)

end subroutine get_totvo2 



!####################################################################
! <SUBROUTINE NAME="optical_dealloc">
!  <OVERVIEW>
!   Subroutine to deallocate the array components of the 
!   optical_path_type input variable.
!  </OVERVIEW>
!  <DESCRIPTION>
!   This subroutine deallocates the array components of the 
!   optical_path_type input variable. Dependent on the namelist
!   options chosen, some of the arrays may or may nothave been
!   allocated.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call optical_dealloc (Optical)            
!  </TEMPLATE>
!  <INOUT NAME="Optical" TYPE="optical_path_type">
!   Derived type variable containing information related to
!   the computation of optical depth associated with 
!   different atmospheric constituents. 
!  </INOUT>
! </SUBROUTINE>
!

subroutine optical_dealloc (Optical, including_aerosols)  

!-------------------------------------------------------------------
!    optical_dealloc deallocates the array components of the 
!    optical_path_type input variable.
!--------------------------------------------------------------------

type(optical_path_type), intent(inout) :: Optical
logical,                   intent(in)            :: including_aerosols  

!--------------------------------------------------------------------
! intent(inout) variables:
!
!    Optical       optical_path_type variable containing fields used
!                  in the calculation of optical paths for various
!                  atmospheric constituents
! 
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!    deallocate the array elements of Optical.
!--------------------------------------------------------------------
       deallocate (Optical%empl1          )
       deallocate (Optical%empl2          )
       deallocate (Optical%var1           )
       deallocate (Optical%var2           )
       deallocate (Optical%avephi         )
       deallocate (Optical%totphi         )
       deallocate (Optical%emx1           )
       deallocate (Optical%emx2           )

 
       if (NBTRGE > 0) then
         deallocate (Optical%avephif        )
         deallocate (Optical%emx1f          )
         deallocate (Optical%emx2f          )
         deallocate (Optical%empl1f         )
         deallocate (Optical%empl2f         )
         deallocate (Optical%vrpfh2o        )
         deallocate (Optical%tphfh2o         )
       endif
 
       if (trim(Lw_control%continuum_form) == 'ckd2.1' .or.     &
           trim(Lw_control%continuum_form) == 'ckd2.4' ) then
         deallocate (Optical%xch2obd        )
         deallocate (Optical%totch2obdwd    )
         deallocate (Optical%xch2obdwd      )
       else if (trim(Lw_control%continuum_form) == 'rsb' ) then
         deallocate (Optical%cntval         )
         deallocate (Optical%totvo2         )
       endif
 
       deallocate (Optical%toto3          )
       deallocate (Optical%tphio3         )
       deallocate (Optical%var3           )
       deallocate (Optical%var4           )
       deallocate (Optical%wk             )
       deallocate (Optical%rh2os          )
       deallocate (Optical%rfrgn          )
       deallocate (Optical%tfac           )

       if (Lw_control%do_cfc) then
         deallocate (Optical%totf11         )
         deallocate (Optical%totf12         )
         deallocate (Optical%totf113         )
         deallocate (Optical%totf22         )
       endif

       if (including_aerosols) then
         deallocate (Optical%totaerooptdep  )
         deallocate (Optical%aerooptdep_KE_15  )
       endif

!-------------------------------------------------------------------


end subroutine optical_dealloc



!####################################################################
! <SUBROUTINE NAME="optical_path_end">
!  <OVERVIEW>
!   optical_path_end is the destructor for optical_path_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!   optical_path_end is the destructor for optical_path_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call optical_depth_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine optical_path_end

!--------------------------------------------------------------------
!    optical_path_end is the destructor for optical_path_mod.
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module is initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg( 'optical_path_mod',  &
             'module has not been initialized', FATAL )
      endif

!-----------------------------------------------------------------
!    mark the module as uninitialized.
!-----------------------------------------------------------------
      module_is_initialized = .false.

!------------------------------------------------------------------



end subroutine optical_path_end



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                                
!                    PRIVATE SUBROUTINES
!                                
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
                                   
                                  
!###################################################################
! <SUBROUTINE NAME="optical_ckd_init">
!  <OVERVIEW>
!   Subroutine to initialize water vapor self and foreign broadened
!   continuum coefficients. 
!  </OVERVIEW>
!  <DESCRIPTION>
!   Idckdh2o reads ckd2.1 self and foreign-broadened h2o continuum
!   coefficients, corrections, and coefficients for temperature
!   dependence of the self-continuum. these are tabulated at 10
!   cm-1 intervals from 0 to 20000 cm-1
!  </DESCRIPTION>
!  <TEMPLATE>
!   call optical_ckd_init
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine optical_ckd_init

!------------------------------------------------------------------
!    optical_ckd_init reads ckd2.1 or ckd2.4 self and foreign-broadened
!    h2o continuum coefficients, corrections, and coefficients for
!    temperature dependence of the self-continuum. these are tabulated
!    at 10 cm-1 intervals from 0 to 20000 cm-1.
!    (the above information is as of 2/12/96).
!
!    references:
!
!    (1) clough, s. a.  et al. "line shape and the water vapor
!        continuum," atmospheric research, 23 (1989) 229-241.
!
!
!    author: m. d. schwarzkopf
!----------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:


!-------------------------------------------------------------------
!   data from former block data bs260 for self-broadened continuum
!    at 260K, band-integrated, in 5 - 19995 cm-1 range.
!               06/28/82
!               units of (cm**3/mol) * 1.E-20
!---------------------------------------------------------------------
      real    ::  v1sh2o_260, v2sh2o_260, dvsh2o_260,    &
                  ssh2o_260(2000)
      integer ::  nptsh2o_260

!--------------------------------------------------------------------
!        tktab and vjtab are the respective temperature and frequency
!    points at which tabulations occurred.
!---------------------------------------------------------------------
      real   ::   tktab(40),  vjtab(300)

!---------------------------------------------------------------------
      integer  :: inrad, k, j, ihih2o

!--------------------------------------------------------------------
!   local variables:
!
!      v1sh2o_260
!      v2sh2o_260
!      dvsh2o_260
!      ssh2o_260
!      nptsh2o_260
!      tktab
!      vjtab
!      inrad
!      k,j
!      ihih2o
!
!--------------------------------------------------------------------

!---------------------------------------------------------------------
!    call routine to allocate radfunc table
!---------------------------------------------------------------------
      call table_alloc (radfunc, 40, 300)

!--------------------------------------------------------------------
!    read h2o (original) data
!    data are at frequencies 5 - 19995 cm-1, at 10 cm-1 intervals
!-------------------------------------------------------------------
      inrad = open_namelist_file ('INPUT/h2ockd2.1_data')
      read (inrad,9001) v1sh2o_296, v2sh2o_296, dvsh2o_296,  &
                        nptsh2o_296
      read (inrad,9002) (ssh2o_296(k),k=1,2000)
      read (inrad,9001) v1sh2o_260, v2sh2o_260, dvsh2o_260,   &
                        nptsh2o_260
      read (inrad,9002) (ssh2o_260(k),k=1,2000)
      read (inrad,9001) v1fh2o, v2fh2o, dvfh2o, nptfh2o
      read (inrad,9002) (sfh2o(k),k=1,2000)
9001  format (3f12.1,i8)
9002  format (5e14.5)
 
      call close_file (inrad)

!--------------------------------------------------------------------
!    read h2o corrected data
!--------------------------------------------------------------------
      if (trim(Lw_control%continuum_form) == 'ckd2.1') then
        inrad = open_namelist_file ('INPUT/h2ockd2.1_corrdata')
      else if (trim(Lw_control%continuum_form) == 'ckd2.4') then
        inrad = open_namelist_file ('INPUT/h2ockd2.4_corrdata')
      endif
      read (inrad,9007) (sfac(k),k=1,2000)
      read (inrad,9007) (fscal(k),k=1,2000)
      read (inrad,9007) (tmpfctrs(k),k=1,2000)
9007  format (5e13.6)
 
      call close_file (inrad)

!--------------------------------------------------------------------
!    read radfn data
!--------------------------------------------------------------------
      inrad = open_namelist_file ('INPUT/radfn_5-2995_100-490k')
      read (inrad,9000) ((radfunc%vae(k,j),radfunc%td(k,j),k=1,40), &
                                                           j=1,300)
9000  format (8f14.6)
      call close_file (inrad)

!---------------------------------------------------------------------
      do k=1,40
        tktab(k) = 100. + 10.*(k-1)
      end do
      do j=1,300
        vjtab(j) = 5. + 10.*(j-1)
      end do
 
!--------------------------------------------------------------------
!    compute range to use in datasets for actual frequency intervals
!    used in model.
!
!    freqlo = 160.
!    freqhi = 560.
!
!    define initial offset and number of data points to use
!    for the 3 h2o continua over the frequency range of the
!    calculations (freqlo,freqhi). note: we assume no interpolation
!    is needed. if interp. was required, these limits would be
!    expanded. values are put into commons in include file tab.h
!    for transmission into Optical_ckd2.1.F.
!
!    ioff is the offset from the absorption tables (starting at 5)
!    needed for proper freq computations. first index used then
!    is (ioff+1). for calculations with the first band beginning
!    at 160 cm-1, this number is 16, and the index number of the
!    band ending at 560 cm-1 is 56.
!-----------------------------------------------------------------------
      ioffh2o = 16

!---------------------------------------------------------------------
!    the final index number used in the calculation is (ihi)
!--------------------------------------------------------------------
      ihih2o  = 56

!--------------------------------------------------------------------
!    nptc is the number of frequency points used in the calculation.
!    ( = ihi - (ioff+1) + 1)
!---------------------------------------------------------------------
      nptch2o = ihih2o - ioffh2o

!---------------------------------------------------------------------
!    vvj are the frequencies for calculation of h2o coefficients. by
!    assumption, no other frequencies are used.
!----------------------------------------------------------------------
      do j=1,nptch2o
        vvj(j) = v1sh2o_296 + dvsh2o_296*float(j+ioffh2o-1)
      end do

!---------------------------------------------------------------------
!    compute h2o coefficients averaged over the broad bands used
!    in the 560 -1200 cm-1 range. until the frequency bands are read
!    in, I will re-list them here, rather than use rnddta.H variables
!    (where they are stored).
!
!    the required wide bands are:
!        560-630 cm-1
!        630-700   (assuming 3 bands in 15um complex)
!        700-800
!        560-800   (1 band for entire complex)
!        800-900
!        900-990
!        990-1070
!        1070-1200
!        800-900,1070-1200   (until this band is broken into 2)
!    we assume that, for best accuracy:
!    the quantity required is <svj> and <fvj) where angle brackets are
!    averages over frequency, s and f are self- and foreign coeff-
!    icients, including corrections, and vj is frequency (from vjtab).
!    notations for special bands attempt similarity with that
!    previously used in the radiation code.
!    we also assume that one value may be used (at all altitudes)
!    for the radiation correction term radfn, in each frequency band.
!    the values used below result from experimentation.
!---------------------------------------------------------------------
      svj = 0.0
      fvj = 0.0
      svjwd = 0.0
      fvjwd = 0.0
      svjinw = 0.0
      fvjinw = 0.0

!--------------------------------------------------------------------
!    560-630 band:
!--------------------------------------------------------------------
      do j=57,63
        svj(1) = svj(1) + vjtab(j)*ssh2o_296(j)*sfac(j)/7.
        fvj(1) = fvj(1) + vjtab(j)*sfh2o(j)*fscal(j)/7.
      end do
      radfnbd(1) = 0.90

!--------------------------------------------------------------------
!    630-700 band:
!--------------------------------------------------------------------
      do j=64,70
        svj(2) = svj(2) + vjtab(j)*ssh2o_296(j)*sfac(j)/7.
        fvj(2) = fvj(2) + vjtab(j)*sfh2o(j)*fscal(j)/7.
      end do
      radfnbd(2) = 0.92

!--------------------------------------------------------------------
!    700-800 band:
!--------------------------------------------------------------------
      do j=71,80
        svj(3) = svj(3) + vjtab(j)*ssh2o_296(j)*sfac(j)/10.
        fvj(3) = fvj(3) + vjtab(j)*sfh2o(j)*fscal(j)/10.
      end do
      radfnbd(3) = 0.95
!--------------------------------------------------------------------
!    800-900 band:
!--------------------------------------------------------------------
      do j=81,90
        svj(4) = svj(4) + vjtab(j)*ssh2o_296(j)*sfac(j)/10.
        fvj(4) = fvj(4) + vjtab(j)*sfh2o(j)*fscal(j)/10.
      end do
      radfnbd(4) = 0.97

!--------------------------------------------------------------------
!    900-990 band:
!--------------------------------------------------------------------
      do j=91,99
        svj(5) = svj(5) + vjtab(j)*ssh2o_296(j)*sfac(j)/9.
        fvj(5) = fvj(5) + vjtab(j)*sfh2o(j)*fscal(j)/9.
      end do
      radfnbd(5) = 0.98

!--------------------------------------------------------------------
!    990-1070 band:
!--------------------------------------------------------------------
      do j=100,107
        svj(6) = svj(6) + vjtab(j)*ssh2o_296(j)*sfac(j)/8.
        fvj(6) = fvj(6) + vjtab(j)*sfh2o(j)*fscal(j)/8.
      end do
      radfnbd(6) = 0.99

!--------------------------------------------------------------------
!    1070-1200 band:
!--------------------------------------------------------------------
      do j=108,120
        svj(7) = svj(7) + vjtab(j)*ssh2o_296(j)*sfac(j)/13.
        fvj(7) = fvj(7) + vjtab(j)*sfh2o(j)*fscal(j)/13.
      end do
      radfnbd(7) = 0.992

!--------------------------------------------------------------------
!    560-800 combined band:
!-------------------------------------------------------------------
      do j=57,80
        svjwd = svjwd + vjtab(j)*ssh2o_296(j)*sfac(j)/24.
        fvjwd = fvjwd + vjtab(j)*sfh2o(j)*fscal(j)/24.
      end do
      radfnbdwd = 0.92

!--------------------------------------------------------------------
!    800-990,1070-1200 combined band:
!--------------------------------------------------------------------
      do j=81,99
        svjinw = svjinw + vjtab(j)*ssh2o_296(j)*sfac(j)/22.
        fvjinw = fvjinw + vjtab(j)*sfh2o(j)*fscal(j)/32.
      end do
      do j=108,120
        svjinw = svjinw + vjtab(j)*ssh2o_296(j)*sfac(j)/32.
        fvjinw = fvjinw + vjtab(j)*sfh2o(j)*fscal(j)/32.
      end do
      radfnbdinw = 0.98

!--------------------------------------------------------------------


end subroutine optical_ckd_init




!###################################################################
! <SUBROUTINE NAME="optical_path_ckd">
!  <OVERVIEW>
!   Subroutine to compute water vapor self and foreign broadened 
!   continuum optical paths
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to compute water vapor self and foreign broadened 
!   continuum optical paths over the frequency range specified by
!    ioffh2o and nptch2o using the ckd algorithm, modified for 
!    the gcm parameterization.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call optical_path_ckd (atmden, press, temp, rh2o, Optical)
!  </TEMPLATE>
!  <IN NAME="atmden" TYPE="real">
!   Atmospheric density profile
!  </IN>
!  <IN NAME="press" TYPE="real">
!   The pressure coordinate array
!  </IN>
!  <IN NAME="temp" TYPE="real">
!   Temperature
!  </IN> 
!  <IN NAME="rh2o" TYPE="real">
!   mass mixing ratio of h2o at model data levels
!  </IN>
!  <INOUT NAME="Optical" TYPE="optical_path_type">
!   water vapor continuum optical path otuput
!  </INOUT>
! </SUBROUTINE>
!
subroutine optical_path_ckd (atmden, press, temp, rh2o, Optical) 

!------------------------------------------------------------------
!    subroutine optical_ckd computes h2o continuum optical paths
!    (self + foreign) over the frequency range specified by
!    ioffh2o and nptch2o using the ckd algorithm, modified for 
!    the gcm parameterization.
!    (this routine is previously called contnm.F)
!------------------------------------------------------------------

real, dimension (:,:,:), intent(in)       :: atmden, press, temp, rh2o
type(optical_path_type), intent(inout)    :: Optical

!-----------------------------------------------------------------
!   intent(in) variables:
!
!      atmden
!      press
!      temp
!      rh2o
!
!   intent(inout) variable:
!
!      Optical
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

      real, dimension (size(press,1), size(press,2), &
                       size(press,3)) ::                totch2obdinw

      real, dimension (size(press,1), size(press,2), &
                       size(press,3)-1) ::       &
                                    xch2obdinw, tmpexp, rvh2o, rhoave

      real                    ::  t0 = 296.0
      integer                 ::  k, nu
      integer      :: israd, ierad, jsrad, jerad

!---------------------------------------------------------------------
!  local variables:
!
!      totch2obdinw
!      xch2obdinw
!      tmpexp
!      rvh2o
!      rhoave
!      t0
!      n,k
!      nu
!
!--------------------------------------------------------------------
      israd = 1
      ierad = size(press,1)
      jsrad = 1
      jerad = size(press,2)

!--------------------------------------------------------------------
!
!--------------------------------------------------------------------
      allocate (Optical%xch2obd    (ISRAD:IERAD, JSRAD:JERAD,    &
                                                          KS:KE  , 7) )
      allocate (Optical%totch2obdwd(ISRAD:IERAD, JSRAD:JERAD,    &
                                                          KS:KE+1   ) )
      allocate (Optical%xch2obdwd  (ISRAD:IERAD, JSRAD:JERAD,    &
                                                          KS:KE     ) )
      Optical%xch2obd  = 0.                                           
      Optical%totch2obdwd = 0.                                        
      Optical%xch2obdwd  = 0.      

!--------------------------------------------------------------------
!    define the volume mixing ratio of h2o
!---------------------------------------------------------------------
      rvh2o(:,:,KS:KE) = rh2o(:,:,KS:KE)/d622

!---------------------------------------------------------------------
!    define input arguments to optical_ckd
!    wk is column density (molec/cm2) of water vapor
!    rfrgn is partial pressure (Amagat) at 296K from N2+O2+Ar
!    rh2os is partial pressure (Amagat) at 296K from water vapor
!-------------------------------------------------------------------
      Optical%wk(:,:,KS:KE) =  rvh2o(:,:,KS:KE)*avogno/wtmair*   &
                               atmden(:,:,KS:KE)/   &
                               (1.0 + rvh2o(:,:,KS:KE))
      rhoave(:,:,KS:KE) = (press(:,:,KS:KE)/pstd)*   &
                          (tfreeze/temp(:,:,KS:KE))
      Optical%rfrgn(:,:,KS:KE) =  rhoave(:,:,KS:KE)*(t0/tfreeze)/  &
                                  (1.0 + rvh2o(:,:,KS:KE))
      Optical%rh2os(:,:,KS:KE) = Optical%rfrgn(:,:,KS:KE)*   &
                                 rvh2o(:,:,KS:KE)
      Optical%tfac(:,:,KS:KE) = temp(:,:,KS:KE) - t0

!--------------------------------------------------------------------
!    compute self-broadened temperature-dependent continuum coefficient
!    using the single coefficient -.020 for all frequencies in
!    the 560-1200 cm-1 range. experiments with the mid-latitude
!    summer profile show errors of < .01 W/m**2 (in the net broadband
!    flux, 0-2200 cm-1) using this value. this value is used instead
!    of tmpfctrs at each frequency band.
!-------------------------------------------------------------------
      tmpexp(:,:,KS:KE) = EXP(-.020*Optical%tfac(:,:,KS:KE))
 
!-------------------------------------------------------------------
!    compute h2o self- and foreign- broadened continuum optical path 
!    for each layer k (xch2obd, xch2obdinw, xch2obdwd) and summed from
!    the top of the atmosphere through layer k (totch2obd,
!    totch2obdinw, totch2obdwd).
!--------------------------------------------------------------------
      do nu = 1,7
        do k = KS,KE 
          Optical%xch2obd(:,:,k,nu) = Optical%wk(:,:,k)*1.0e-20*   &
                                      (svj(nu)*Optical%rh2os(:,:,k)*&
                                      tmpexp(:,:,k) + fvj(nu)*   &
                                      Optical%rfrgn(:,:,k))*radfnbd(nu)
        end do
      end do
 
      do k = KS,KE 
        xch2obdinw(:,:,k) = Optical%wk(:,:,k)*1.0e-20*(svjinw*  &
                            Optical%rh2os(:,:,k)* tmpexp(:,:,k) +   &
                            fvjinw*Optical%rfrgn(:,:,k))*radfnbdinw
        Optical%xch2obdwd(:,:,k) = Optical%wk(:,:,k)*1.0e-20*   &
                                   (svjwd*Optical%rh2os(:,:,k)* &
                                   tmpexp(:,:,k) + fvjwd*  &
                                   Optical%rfrgn(:,:,k))*radfnbdwd
      end do
 
      totch2obdinw(:,:,1) = 0.0E+00
      Optical%totch2obdwd(:,:,1) = 0.0E+00
      do k = KS+1,KE+1
        totch2obdinw(:,:,k) = totch2obdinw(:,:,k-1) +    &
                              xch2obdinw(:,:,k-1)
        Optical%totch2obdwd(:,:,k) = Optical%totch2obdwd(:,:,k-1) + &
                                     Optical%xch2obdwd(:,:,k-1)
      end do

!----------------------------------------------------------------------

 
end subroutine optical_path_ckd
 


!################################################################## 
! <SUBROUTINE NAME="optical_o3">
!  <OVERVIEW>
!   Subroutine to compute optical paths for o3.
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to compute optical paths for o3.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call optical_o3 (atmden, qo3, vv, Optical)
!  </TEMPLATE>
!  <IN NAME="atmden" TYPE="real">
!   Atmospheric density profile
!  </IN>
!  <IN NAME="qo3" TYPE="real">
!   mass mixing ratio of o3 at model data levels
!  </IN>
!  <IN NAME="vv" TYPE="real">
!   Ozone volume mixing atio
!  </IN> 
!  <INOUT NAME="Optical" TYPE="optical_path_type">
!   ozone optical path otuput
!  </INOUT>
! </SUBROUTINE>
!
subroutine optical_o3 (atmden, qo3, vv, Optical)

!------------------------------------------------------------------
!    optical_o3 computes optical paths for o3.
!------------------------------------------------------------------

real, dimension(:,:,:),  intent(in)    ::  atmden, qo3, vv
type(optical_path_type), intent(inout) ::  Optical

!-----------------------------------------------------------------
!   intent(in) variables:
!
!     atmden
!     qo3     mass mixing ratio of o3 at model data levels.
!     vv
!
!   intent(inout) variable:
!
!      Optical
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

      integer  ::    k    ! do-loop index
      integer      :: israd, ierad, jsrad, jerad

!---------------------------------------------------------------------
      israd = 1
      ierad = size(qo3,1)
      jsrad = 1
      jerad = size(qo3,2)

!--------------------------------------------------------------------
!
!--------------------------------------------------------------------
      allocate (Optical%toto3 (ISRAD:IERAD, JSRAD:JERAD, KS:KE      +1))
      allocate (Optical%tphio3(ISRAD:IERAD, JSRAD:JERAD, KS:KE      +1))
      allocate (Optical%var3  (ISRAD:IERAD, JSRAD:JERAD, KS:KE        ))
      allocate (Optical%var4  (ISRAD:IERAD, JSRAD:JERAD, KS:KE        ))
      Optical%toto3  = 0.
      Optical%tphio3 = 0.
      Optical%var3  = 0.
      Optical%var4  = 0.                                        

!-----------------------------------------------------------------------
!    compute optical paths for o3, using the diffusivity 
!    approximation 1.66 for the angular integration.  obtain 
!    unweighted values var3 and weighted values  var4.
!    the quantities  0.003 (.003) appearing in the
!    var4 expression are the approximate voigt corrections
!    for o3.
!---------------------------------------------------------------------  
      Optical%var3(:,:,KS:KE) = atmden(:,:,KS:KE)*qo3(:,:,KS:KE)*diffac
      Optical%var4(:,:,KS:KE) = Optical%var3(:,:,KS:KE)*    &
                                (vv(:,:,KS:KE) + 3.0E-03)

!----------------------------------------------------------------------
!    compute summed optical paths for o3.
!----------------------------------------------------------------------
      Optical%toto3 (:,:,KS) = 0.0E+00
      Optical%tphio3(:,:,KS) = 0.0E+00
      do k=KS+1,KE+1
        Optical%toto3 (:,:,k) = Optical%toto3 (:,:,k-1) +    &
                                Optical%var3  (:,:,k-1) 
        Optical%tphio3(:,:,k) = Optical%tphio3(:,:,k-1) +    &
                                Optical%var4  (:,:,k-1) 
      end do

!----------------------------------------------------------------------


end subroutine optical_o3




!#####################################################################
! <SUBROUTINE NAME="optical_rbts">
!  <OVERVIEW>
!   Subroutine to compute optical paths for h2o rbts continuum
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to compute optical paths for h2o rbts continuum
!  </DESCRIPTION>
!  <TEMPLATE>
!   call optical_rbts (temp, rh2o, Optical) 
!  </TEMPLATE>
!  <IN NAME="temp" TYPE="real">
!   temperature profile used in continuum calculation
!  </IN>
!  <IN NAME="rh2o" TYPE="real">
!   mass mixing ratio of h2o at model data levels
!  </IN>
!  <INOUT NAME="Optical" TYPE="optical_path_type">
!   water vapor robert continuum optical path
!  </INOUT>
! </SUBROUTINE>
!
subroutine optical_rbts (temp, rh2o, Optical) 

!------------------------------------------------------------------
!    optical_rbts computes optical paths for h2o rbts comtinuum.
!------------------------------------------------------------------

real, dimension(:,:,:),  intent(in)    :: temp, rh2o
type(optical_path_type), intent(inout) :: Optical

!-----------------------------------------------------------------
!   intent(in) variables:
!
!      temp
!      rh2o
!
!   intent(inout) variable:
!
!      Optical
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

      real, dimension(size(temp,1), size(temp,2), &
                                     size(temp,3)) :: texpsl
      integer     :: k
      integer      :: israd, ierad, jsrad, jerad

!--------------------------------------------------------------------
!  local variables:
!
!      texpsl
!      i,k
!
!----------------------------------------------------------------------
      israd = 1
      ierad = size(temp,1)
      jsrad = 1
      jerad = size(temp,2)

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      allocate (Optical%cntval(ISRAD:IERAD, JSRAD:JERAD,   KS:KE+1   ))
      allocate (Optical%totvo2(ISRAD:IERAD, JSRAD:JERAD,   KS:KE+1   ))
      Optical%cntval = 0.                                         
      Optical%totvo2 = 0.                                        

!----------------------------------------------------------------------
!    compute argument for constant temperature coefficient (this is 
!    1.800E+03/(1.0E+00/temp - 1.0E+00/2.960E+02)).
!---------------------------------------------------------------------- 
      texpsl(:,:,KS:KE+1) = EXP(1.800E+03/temp(:,:,KS:KE+1) -   &
                                6.081081081E+00) 

!----------------------------------------------------------------------
!    compute optical path for the h2o continuum, using roberts 
!    coefficients betinw, and temperature correction texpsl. 
!    the diffusivity approximation (which cancels out in this
!    expression) is assumed to be 1.66.  the use of the diffusivity
!    factor has been shown to be a significant source of error in the
!    continuum calculations, however, the time penalty of an angular
!    integration is severe.
!---------------------------------------------------------------------  
      Optical%cntval(:,:,KS:KE) = texpsl(:,:,KS:KE)*rh2o(:,:,KS:KE)*   &
                                  Optical%var2(:,:,KS:KE)/   &
                                  (rh2o(:,:,KS:KE) + d622   )

!----------------------------------------------------------------------
!    compute summed optical paths for h2o roberts continuum.
!----------------------------------------------------------------------
      Optical%totvo2(:,:,KS) = 0.0E+00
      do k=KS+1,KE+1
        Optical%totvo2(:,:,k) = Optical%totvo2(:,:,k-1) +   &
                                Optical%cntval(:,:,k-1) 
      end do

!----------------------------------------------------------------------



end subroutine optical_rbts



!####################################################################
! <SUBROUTINE NAME="optical_h2o">
!  <OVERVIEW>
!   Subroutine to compute water vapor optical paths
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to compute water vapor optical paths
!  </DESCRIPTION>
!  <TEMPLATE>
!   call optical_h2o (pflux, atmden, vv, press, temp, rh2o, tflux, &
!                     Optical) 
!  </TEMPLATE>
!  <IN NAME="pflux" TYPE="real">
!   pressure at flux levels of model
!  </IN>
!  <IN NAME="atmden" TYPE="real">
!   Atmospheric density profile
!  </IN>
!  <IN NAME="vv" TYPE="real">
!   volume mixing ratio of h2o at model data levels
!  </IN>
!  <IN NAME="press" TYPE="real">
!   The pressure coordinate array
!  </IN>
!  <IN NAME="temp" TYPE="real">
!   Temperature at data levels of model
!  </IN> 
!  <IN NAME="rh2o" TYPE="real">
!   mass mixing ratio of h2o at model data levels
!  </IN>
!  <IN NAME="tflux" TYPE="real">
!   Temperature at flux levels of model
!  </IN>
!  <INOUT NAME="Optical" TYPE="optical_path_type">
!   water vapor optical path otuput
!  </INOUT>
! </SUBROUTINE>
!
subroutine optical_h2o (pflux, atmden, vv, press, temp, rh2o, tflux, &
                        Optical) 

!----------------------------------------------------------------------
!    optical_h2o computes optical paths for h2o.
!----------------------------------------------------------------------

real, dimension (:,:,:), intent(in)    ::  pflux, atmden, vv, press, &
                                           temp, rh2o, tflux
type(optical_path_type), intent(inout) ::  Optical

!-----------------------------------------------------------------
!   intent(in) variables:
!
!     pflux     pressure at flux levels of model.
!     atmden
!     vv
!     press     pressure at data levels of model.
!     temp      temperature at data levels of model. 
!     rh2o      mass mixing ratio of h2o at model data levels 
!     tflux
!
!   intent(inout) variable:
!
!      Optical
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

      real, dimension (size(pflux,1), size(pflux,2), &
                       size(pflux,3)) ::        &
                                             tpl1, tpl2, &
                                             qh2o, tdif, tdif2
      integer    ::  m, k
      integer      :: israd, ierad, jsrad, jerad

!--------------------------------------------------------------------
!  local variables:
!
!      tpl1
!      tpl2
!      qh2o       h2o mass mixing ratio, multiplied by the diffusivity
!                 factor diffac.
!      tdif
!      tdif2
!      m,k
!
!-----------------------------------------------------------------------

      israd = 1
      ierad = size(pflux,1)
      jsrad = 1
      jerad = size(pflux,2)
!-------------------------------------------------------------------- 
!    compute mean temperature in the "nearby layer" between a flux
!    level and the first data level below the flux level (tpl1) or the
!    first data level above the flux level (tpl2)
!---------------------------------------------------------------------
      tpl1(:,:,KS   )         = temp(:,:,KE   )
      tpl1(:,:,KS   +1:KE   ) = tflux(:,:,KS   +1:KE   )
      tpl1(:,:,KE   +1)       = 0.5E+00*(tflux(:,:,KE   +1) +   &
                                temp(:,:,KE   ))
      tpl2(:,:,KS   +1:KE   ) = tflux(:,:,KS   +1:KE   )
      tpl2(:,:,KE   +1)       = 0.5E+00*(tflux(:,:,KE   ) +    &
                                temp(:,:,KE   ))

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      allocate (Optical%empl1  (ISRAD:IERAD, JSRAD:JERAD  , KS:KE+1   ))
      allocate (Optical%empl2  (ISRAD:IERAD, JSRAD:JERAD  , KS:KE+1   ))
      allocate (Optical%totphi (ISRAD:IERAD, JSRAD:JERAD  , KS:KE+1   ))
      allocate (Optical%var1   (ISRAD:IERAD, JSRAD:JERAD  , KS:KE     ))
      allocate (Optical%var2   (ISRAD:IERAD, JSRAD:JERAD  , KS:KE     ))
      allocate (Optical%emx1   (ISRAD:IERAD, JSRAD:JERAD              ))
      allocate (Optical%emx2   (ISRAD:IERAD, JSRAD:JERAD              ))
      Optical%empl1   = 0.
      Optical%empl2  =0.
      Optical%totphi  = 0.
      Optical%var1   = 0.
      Optical%var2   = 0.
      Optical%emx1   = 0.
      Optical%emx2   = 0.

!----------------------------------------------------------------------
!    compute optical paths for h2o, using the diffusivity 
!    approximation 1.66 for the angular integration.  obtain 
!    unweighted values var1, and weighted values var2.
!    the quantities 0.0003 (.0003) appearing in the
!    var2 expressions are the approximate voigt corrections
!    for h2o.  vv is the layer-mean pressure (in 
!    atmosphere), which is not the same as the level pressure press.
!---------------------------------------------------------------------  
      qh2o(:,:,KS:KE) = rh2o(:,:,KS:KE)*diffac
      Optical%var1(:,:,KS:KE) = atmden(:,:,KS:KE)*qh2o(:,:,KS:KE)
      Optical%var2(:,:,KS:KE) = Optical%var1(:,:,KS:KE)*   &
                                (vv(:,:,KS:KE) + 3.0E-04)

!----------------------------------------------------------------------
!    compute summed optical paths for h2o.
!----------------------------------------------------------------------
      Optical%totphi(:,:,KS) = 0.0E+00
      do k=KS+1,KE+1
        Optical%totphi(:,:,k) = Optical%totphi(:,:,k-1) +   &
                                Optical%var2  (:,:,k-1) 
      end do

!----------------------------------------------------------------------
!    emx1 is the additional pressure-scaled mass from press(KE) to 
!    pflux(KE).  it is used in nearby layer and emiss calculations.
!    emx2 is the additional pressure-scaled mass from press(KE) to 
!    pflux(KE+1).  it is used in calculations between flux levels k
!    and KE+1.
!----------------------------------------------------------------------
      Optical%emx1(:,:) = qh2o(:,:,KE)*press(:,:,KE)*(press(:,:,KE) - &
                          pflux(:,:,KE))/(1.0E+02*GRAV*pstd)
      Optical%emx2(:,:) = qh2o(:,:,KE)*press(:,:,KE)*(pflux(:,:,KE+1) -&
                          press(:,:,KE))/(1.0E+02*GRAV*pstd)

!----------------------------------------------------------------------
!    empl is the pressure scaled mass from pflux(k) to press(k) or to 
!    press(k+1).
!----------------------------------------------------------------------
      Optical%empl1(:,:,KS) = Optical%var2(:,:,KE)
      Optical%empl1(:,:,KS+1:KE+1) = qh2o(:,:,KS:KE)*    &
                                     pflux(:,:,KS+1:KE+1)*   &
                                     (pflux(:,:,KS+1:KE+1) -   &
                                      press(:,:,KS:KE))/   &
                                      (1.0E+02*GRAV*pstd)
      Optical%empl2(:,:,KS+1:KE) =    &
                 qh2o(:,:,KS+1:KE)*pflux(:,:,KS+1:KE)*   &
                 (press(:,:,KS+1:KE) - pflux(:,:,KS+1:KE))/  &
                 (1.0E+02*GRAV*pstd)
      Optical%empl2(:,:,KE+1) = Optical%empl2(:,:,KE) 

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      if (NBTRGE > 0) then
        allocate ( Optical%empl1f (ISRAD:IERAD , JSRAD:JERAD ,    & 
                                                  KS:KE+1,  NBTRGE ) ) 
        allocate ( Optical%empl2f (ISRAD:IERAD , JSRAD:JERAD ,     &  
                                                  KS:KE+1,  NBTRGE ) ) 
        allocate ( Optical%tphfh2o(ISRAD:IERAD , JSRAD:JERAD ,     & 
                                                  KS:KE+1,  NBTRGE ) ) 
        allocate ( Optical%vrpfh2o(ISRAD:IERAD , JSRAD:JERAD ,    &
                                                  KS:KE+1,  NBTRGE ) )
        allocate ( Optical%emx1f  (ISRAD:IERAD , JSRAD:JERAD ,   &
                                                            NBTRGE ) )
        allocate ( Optical%emx2f  (ISRAD:IERAD , JSRAD:JERAD ,   &
                                                            NBTRGE ) )
        Optical%empl1f  = 0.
        Optical%empl2f  = 0.
        Optical%tphfh2o  = 0.
        Optical%vrpfh2o = 0.
        Optical%emx1f   = 0.
        Optical%emx2f  = 0.                               

        if (tmp_dpndnt_h2o_lines) then
!----------------------------------------------------------------------
!    compute h2o optical paths for use in the 1200-1400 cm-1 range if
!    temperature dependence of line intensities is accounted for.
!----------------------------------------------------------------------
          tdif(:,:,KS:KE) = temp(:,:,KS:KE)-2.5E+02

          do m=1,NBTRGE
            Optical%vrpfh2o(:,:,KS:KE,m) = Optical%var2(:,:,KS:KE)*   &
                                           EXP(csfah2o(1,m)*   &
                                               (tdif(:,:,KS:KE)) +   &
                                               csfah2o(2,m)*   &
                                               (tdif(:,:,KS:KE))**2 )
          end do
          do m=1,NBTRGE
            Optical%tphfh2o(:,:,KS,m) = 0.0E+00
            do k=KS+1,KE+1
              Optical%tphfh2o(:,:,k,m) = Optical%tphfh2o(:,:,k-1,m) +  &
                                         Optical%vrpfh2o(:,:,k-1,m)
            end do
          end do

          tdif2(:,:,KS+1:KE+1) = tpl2(:,:,KS+1:KE+1)-2.5E+02
          tdif (:,:,KS+1:KE+1) = tpl1(:,:,KS+1:KE+1)-2.5E+02

!---------------------------------------------------------------------
!    compute this additional mass, for use in the 1200-1400 cm-1 range,
!    if temperature dependence of line intensities is accounted for.
!--------------------------------------------------------------------
          do m=1,NBTRGE
            Optical%emx1f(:,:,m) = Optical%emx1(:,:) *    &
                                   EXP(csfah2o(1,m)*(tdif2(:,:,KE+1)) +&
                                     csfah2o(2,m)*(tdif2(:,:,KE+1))**2 )
            Optical%emx2f(:,:,m) = Optical%emx2(:,:) *    &
                                 EXP(csfah2o(1,m)*(tdif (:,:,KE+1)) + &
                                     csfah2o(2,m)*(tdif (:,:,KE+1))**2 )
          end do

!----------------------------------------------------------------------
!    compute this additional mass, for use in the 1200-1400 cm-1 range,
!    if temperature dependence of line intensities is accounted for.
!----------------------------------------------------------------------
          do m=1,NBTRGE
            Optical%empl1f(:,:,KS+1:KE+1,m) =     &
                                        Optical%empl1(:,:,KS+1:KE+1)*&
                                        EXP(csfah2o(1,m)*   &
                                            (tdif(:,:,KS+1:KE+1)) + &
                                            csfah2o(2,m)*   &
                                            (tdif(:,:,KS+1:KE+1))**2 )
            Optical%empl2f(:,:,KS+1:KE,m) = Optical%empl2(:,:,KS+1:KE)*&
                                          EXP(csfah2o(1,m)*  &
                                              (tdif2(:,:,KS+1:KE)) +   &
                                              csfah2o(2,m)*  &
                                              (tdif2(:,:,KS+1:KE))**2 )
            Optical%empl1f(:,:,KS ,m) = Optical%vrpfh2o(:,:,KE,m)
            Optical%empl2f(:,:,KE+1,m) = Optical%empl2f(:,:,KE,m)
          end do
        else
          do m=1,NBTRGE
            Optical%empl1f(:,:,ks+1:ke+1,m) =   &
                                           Optical%empl1(:,:,ks+1:ke+1)
            Optical%empl2f(:,:,ks+1:ke,m) = Optical%empl2(:,:,ks+1:ke)
            Optical%emx1f(:,:,m)   = Optical%emx1(:,:)
            Optical%emx2f(:,:,m)  = Optical%emx2(:,:)              
            Optical%tphfh2o(:,:,:,m) = Optical%totphi (:,:,:)
            Optical%vrpfh2o(:,:,KE,m) = Optical%var2(:,:,KE)
            Optical%vrpfh2o(:,:,KS:ke,m) = Optical%var2(:,:,KS:Ke)
            Optical%empl1f(:,:,KS,m) = Optical%vrpfh2o(:,:,KE,1)
            Optical%empl2f(:,:,KE+1,m) = Optical%empl2f (:,:,KE,1)
          end do
        endif
      endif
!---------------------------------------------------------------------



end subroutine optical_h2o



!####################################################################
! <SUBROUTINE NAME="cfc_optical_depth">
!  <OVERVIEW>
!   Subroutine to compute CFC optical depths
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to compute CFC optical depths. The code assumes
!   a constant mixing ratio throughout the atmosphere.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call cfc_optical_depth (density, Rad_gases, Optical)
!  </TEMPLATE>
!  <IN NAME="density" TYPE="real">
!   density profile of CFC in the atmosphere
!  </IN>
!  <IN NAME="Rad_gases" TYPE="radiative_gases_type">
!   Radiative gases optical properties input data
!  </IN>
!  <INOUT NAME="Optical" TYPE="optical_path_type">
!   CFC Optical depth output
!  </INOUT>
! </SUBROUTINE>
!
subroutine cfc_optical_depth (density, Rad_gases, Optical)

!------------------------------------------------------------------
!    cfc_optical_depth computes optical paths for cfc. The code assumes
!    a constant mixing ratio throughout the atmosphere.
!------------------------------------------------------------------

real, dimension (:,:,:),    intent(in)     :: density 
type(radiative_gases_type), intent(in)     :: Rad_gases
type(optical_path_type),    intent(inout)  :: Optical 

!-----------------------------------------------------------------
!   intent(in) variables:
!
!      density
!      Rad_gases
!
!   intent(inout) variable:
!
!      Optical
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

      real          ::  rrf11, rrf12, rrf113, rrf22
      real          ::  rf11air, rf12air, rf113air, rf22air
      integer       ::  k
      integer       ::  kx

!--------------------------------------------------------------------
!  local variables:
!
!      rrf11
!      rrf12
!      rrf113
!      rrf22
!      rf11air
!      rf12air
!      rf113air
!      rf22air
!      k
!      kx
!
!---------------------------------------------------------------------

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      allocate ( Optical%totf11 (size(density,1), size(density,2),    &
                                 size(density,3) ) )
      allocate ( Optical%totf12 (size(density,1), size(density,2),    &
                                 size(density,3) ) )
      allocate ( Optical%totf113(size(density,1), size(density,2),    &
                                 size(density,3) ) )
      allocate ( Optical%totf22 (size(density,1), size(density,2),    &
                                 size(density,3) ) )
      Optical%totf11  = 0.
      Optical%totf12  = 0.
      Optical%totf113 = 0.
      Optical%totf22 = 0.
 
!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      kx = size (density,3)

!--------------------------------------------------------------------
!    define cfc mixing ratio conversion factors.
!--------------------------------------------------------------------
      rf11air  = wtmf11/wtmair
      rf12air  = wtmf12/wtmair
      rf113air = wtmf113/wtmair
      rf22air  = wtmf22/wtmair

      rrf11 = Rad_gases%rrvf11*rf11air
      rrf12 = Rad_gases%rrvf12*rf12air
      rrf113 = Rad_gases%rrvf113*rf113air
      rrf22 = Rad_gases%rrvf22*rf22air

!----------------------------------------------------------------------
!    compute summed optical paths for f11,f12, f113 and f22  with the 
!    diffusivity factor of 2 (appropriate for weak-line absorption 
!    limit).
!----------------------------------------------------------------------
      Optical%totf11(:,:,1) = 0.0E+00
      Optical%totf12(:,:,1) = 0.0E+00
      Optical%totf113(:,:,1) = 0.0E+00
      Optical%totf22 (:,:,1) = 0.0E+00
      do k=2,kx           
        Optical%totf11(:,:,k) = Optical%totf11(:,:,k-1) +    &
                                density(:,:,k-1)*rrf11*2.0E+00
        Optical%totf12(:,:,k) = Optical%totf12(:,:,k-1) +    &
                                density(:,:,k-1)*rrf12*2.0E+00
        Optical%totf113(:,:,k) = Optical%totf113(:,:,k-1) +  &
                                 density(:,:,k-1)*rrf113*2.0E+00
        Optical%totf22(:,:,k) = Optical%totf22(:,:,k-1) +    &
                                density(:,:,k-1)*rrf22*2.0E+00
      end do
       
!--------------------------------------------------------------------


end subroutine cfc_optical_depth



!#####################################################################
! <SUBROUTINE NAME="optical_depth_aerosol">
!  <OVERVIEW>
!   Subroutine to compute aerosol optical depths
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to compute aerosol optical depths. 
!  </DESCRIPTION>
!  <TEMPLATE>
!   call optical_depth_aerosol (Atmos_input, n, Aerosol,    &
!                                  Aerosol_props, Optical)
!  </TEMPLATE>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
!   Atmospheric input data to model grid point for radiative 
!   properties calculation
!  </IN>
!  <IN NAME="n" TYPE="integer">
!   aerosol optical index
!  </IN>
!  <IN NAME="Aerosol" TYPE="aerosol_type">
!   Aerosol climatological input data
!  </IN>
!  <INOUT NAME="Aerosol_props" TYPE="aerosol_properties_type">
!   Aerosol radiative properties
!  </INOUT>
!  <INOUT NAME="Optical" TYPE="optical_path_type">
!   Aerosol Optical depth output
!  </INOUT>
! </SUBROUTINE>
!
subroutine optical_depth_aerosol ( js, Atmos_input, n, Aerosol,    &
                                  Aerosol_props, Aerosol_diags, &
                                  Optical)

!------------------------------------------------------------------
!
!------------------------------------------------------------------

integer,                       intent(in)    :: js
type(atmos_input_type),        intent(in)    :: Atmos_input
integer,                       intent(in)    :: n
type(aerosol_type),            intent(in)    :: Aerosol
type(aerosol_properties_type), intent(inout) :: Aerosol_props
type(aerosol_diagnostics_type),intent(inout) :: Aerosol_diags
type(optical_path_type),       intent(inout) :: Optical

!-----------------------------------------------------------------
!   intent(in) variables:
!
!      Atmos_input
!      n
!      Aerosol
!
!   intent(inout) variable:
!
!      Aerosol_props
!      Optical
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variables:

      real, dimension (size(Aerosol%aerosol,1),  &
                       size(Aerosol%aerosol,2),  &
                       size(Aerosol%aerosol,3), &
                       size(Aerosol%aerosol,4))   :: aerooptdepspec, &
                                                     aerooptdepspec_cn

      real, dimension (size(Aerosol%aerosol,1),  &
                       size(Aerosol%aerosol,2),  &
                       size(Aerosol%aerosol,3))  :: aerooptdep
!yim
      integer, dimension (size(Aerosol%aerosol,1),  &
                          size(Aerosol%aerosol,2),  &
                          size(Aerosol%aerosol,3))  :: opt_index_v1, &
                          opt_index_v2, opt_index_v3, opt_index_v4, &
                          opt_index_v5, opt_index_v6, opt_index_v7,opt_index_v8

      real, dimension (size(Aerosol%aerosol,3)+1) :: bsum

      real      :: asum
      integer   :: nfields, irh
      integer   ::  N_AEROSOL_BANDS 
      integer   :: i,j,k
      integer   :: ix, jx, kx
      integer   :: nsc, opt_index
!--------------------------------------------------------------------
!  local variables:
!
!      aerooptdepspec
!      aerooptdep
!      irh
!      opt_index_v
!      bsum
!      asum
!      nfields
!      n_aerosol_bands
!      i,j,k
!      ix,jx,kx
!      na, nw, ni  
!      nsc 
!      opt_index
!      
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      ix = size (Aerosol%aerosol,1)
      jx = size (Aerosol%aerosol,2)
      kx = size (Aerosol%aerosol,3)
      nfields = size (Aerosol%aerosol,4)

!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
      aerooptdep(:,:,:) = 0.0
      Optical%totaerooptdep(:,:,:,n) = 0.0
      do k = 1,kx         
        do j = 1,jx         
          do i = 1,ix           
            irh = MIN(100, MAX(0,     &
                      NINT(100.*Atmos_input%aerosolrelhum(i,j,k))))
            opt_index_v1(i,j,k) =     &
                        Aerosol_props%sulfate_index (irh, &
                                             Aerosol_props%ivol(i,j,k) )
            opt_index_v2(i,j,k) =     &
                               Aerosol_props%omphilic_index( irh )
            opt_index_v3(i,j,k) =     &
                               Aerosol_props%bcphilic_index( irh )
            opt_index_v4(i,j,k) =     &
                               Aerosol_props%seasalt1_index( irh )
            opt_index_v5(i,j,k) =     &
                               Aerosol_props%seasalt2_index( irh )
            opt_index_v6(i,j,k) =     &
                               Aerosol_props%seasalt3_index( irh )
            opt_index_v7(i,j,k) =     &
                               Aerosol_props%seasalt4_index( irh )
            opt_index_v8(i,j,k) =     &
                               Aerosol_props%seasalt5_index( irh )
          end do
        end do
      end do

!---------------------------------------------------------------------
!    using relative humidity criterion (where necessary) determine the
!    aerosol category (as an index) appropriate for the aerosol species
!---------------------------------------------------------------------
  do nsc=1,nfields  ! loop on aerosol species
      if (Aerosol_props%optical_index(nsc) > 0 ) then   

      do k = 1,kx         
        do j = 1,jx         
          do i = 1,ix           
                opt_index = Aerosol_props%optical_index(nsc)
                if (opt_index == 0 ) then
                   call error_mesg ('optical_path_init', &
                  'Cannot find aerosol optical properties for species = ' // &
                   TRIM( Aerosol%aerosol_names(nsc) ),  FATAL )
                endif
                aerooptdepspec(i,j,k,nsc) =    &
                     diffac*Aerosol%aerosol(i,j,k,nsc)*   &
                     (1.0 - Aerosol_props%aerssalbbandlw(n,opt_index))*&
                            Aerosol_props%aerextbandlw(n,opt_index)
                if (n == 1) then
                   aerooptdepspec_cn(i,j,k,nsc) =    &
                   diffac*Aerosol%aerosol(i,j,k,nsc)*   &
                   (1.0 - Aerosol_props%aerssalbbandlw_cn(n,opt_index))*&
                   Aerosol_props%aerextbandlw_cn(n,opt_index)
                 end if
            end do
          end do
        end do
     else if (Aerosol_props%optical_index(nsc) == &   
                          Aerosol_props%sulfate_flag  ) then
      do k = 1,kx         
        do j = 1,jx         
          do i = 1,ix           
            opt_index = opt_index_v1(i,j,k)
                aerooptdepspec(i,j,k,nsc) =     &
                   diffac*Aerosol%aerosol(i,j,k,nsc)*&
                   (1.0 - Aerosol_props%aerssalbbandlw(n,opt_index))* &
                          Aerosol_props%aerextbandlw(n,opt_index)
                if (n == 1) then
                  aerooptdepspec_cn(i,j,k,nsc) =    &
                     diffac*Aerosol%aerosol(i,j,k,nsc)*   &
                 (1.0 - Aerosol_props%aerssalbbandlw_cn(n,opt_index))*&
                        Aerosol_props%aerextbandlw_cn(n,opt_index)
              endif
            end do
          end do
        end do
!yim
     else if (Aerosol_props%optical_index(nsc) == &   
                          Aerosol_props%bc_flag  ) then
      do k = 1,kx         
        do j = 1,jx         
          do i = 1,ix           
            opt_index = opt_index_v1(i,j,k)
                aerooptdepspec(i,j,k,nsc) =     &
                   diffac*Aerosol%aerosol(i,j,k,nsc)*&
                   (1.0 - Aerosol_props%aerssalbbandlw(n,opt_index))* &
                          Aerosol_props%aerextbandlw(n,opt_index)
                if (n == 1) then
                  aerooptdepspec_cn(i,j,k,nsc) =    &
                     diffac*Aerosol%aerosol(i,j,k,nsc)*   &
                 (1.0 - Aerosol_props%aerssalbbandlw_cn(n,opt_index))*&
                        Aerosol_props%aerextbandlw_cn(n,opt_index)
              endif
            end do
          end do
        end do
     else if (Aerosol_props%optical_index(nsc) ==  &
                        Aerosol_props%omphilic_flag ) then
      do k = 1,kx         
        do j = 1,jx         
          do i = 1,ix           
            opt_index = opt_index_v2(i,j,k)
                aerooptdepspec(i,j,k,nsc) =     &
                   diffac*Aerosol%aerosol(i,j,k,nsc)*&
                   (1.0 - Aerosol_props%aerssalbbandlw(n,opt_index))* &
                          Aerosol_props%aerextbandlw(n,opt_index)
                if (n == 1) then
                  aerooptdepspec_cn(i,j,k,nsc) =    &
                     diffac*Aerosol%aerosol(i,j,k,nsc)*   &
                 (1.0 - Aerosol_props%aerssalbbandlw_cn(n,opt_index))*&
                        Aerosol_props%aerextbandlw_cn(n,opt_index)
              endif
            end do
          end do
        end do
!yim
     else if (Aerosol_props%optical_index(nsc) ==  &
                        Aerosol_props%bcphilic_flag ) then
      if (Rad_control%using_im_bcsul) then
      do k = 1,kx         
        do j = 1,jx         
          do i = 1,ix           
            opt_index = opt_index_v1(i,j,k)
                aerooptdepspec(i,j,k,nsc) =     &
                   diffac*Aerosol%aerosol(i,j,k,nsc)*&
                   (1.0 - Aerosol_props%aerssalbbandlw(n,opt_index))* &
                          Aerosol_props%aerextbandlw(n,opt_index)
                if (n == 1) then
                  aerooptdepspec_cn(i,j,k,nsc) =    &
                     diffac*Aerosol%aerosol(i,j,k,nsc)*   &
                 (1.0 - Aerosol_props%aerssalbbandlw_cn(n,opt_index))*&
                        Aerosol_props%aerextbandlw_cn(n,opt_index)
              endif
            end do
          end do
        end do
      else ! (using_im_bcsul)
      do k = 1,kx         
        do j = 1,jx         
          do i = 1,ix           
            opt_index = opt_index_v3(i,j,k)
                aerooptdepspec(i,j,k,nsc) =     &
                   diffac*Aerosol%aerosol(i,j,k,nsc)*&
                   (1.0 - Aerosol_props%aerssalbbandlw(n,opt_index))* &
                          Aerosol_props%aerextbandlw(n,opt_index)
                if (n == 1) then
                  aerooptdepspec_cn(i,j,k,nsc) =    &
                     diffac*Aerosol%aerosol(i,j,k,nsc)*   &
                 (1.0 - Aerosol_props%aerssalbbandlw_cn(n,opt_index))*&
                        Aerosol_props%aerextbandlw_cn(n,opt_index)
              endif
            end do
          end do
        end do
      endif  ! (using_im_bcsul)
     else if (Aerosol_props%optical_index(nsc) ==  &
                        Aerosol_props%seasalt1_flag ) then
      do k = 1,kx         
        do j = 1,jx         
          do i = 1,ix           
            opt_index = opt_index_v4(i,j,k)
                aerooptdepspec(i,j,k,nsc) =     &
                   diffac*Aerosol%aerosol(i,j,k,nsc)*&
                   (1.0 - Aerosol_props%aerssalbbandlw(n,opt_index))* &
                          Aerosol_props%aerextbandlw(n,opt_index)
                if (n == 1) then
                  aerooptdepspec_cn(i,j,k,nsc) =    &
                     diffac*Aerosol%aerosol(i,j,k,nsc)*   &
                 (1.0 - Aerosol_props%aerssalbbandlw_cn(n,opt_index))*&
                        Aerosol_props%aerextbandlw_cn(n,opt_index)
              endif
            end do
          end do
        end do
     else if (Aerosol_props%optical_index(nsc) ==  &
                        Aerosol_props%seasalt2_flag ) then
      do k = 1,kx         
        do j = 1,jx         
          do i = 1,ix           
            opt_index = opt_index_v5(i,j,k)
                aerooptdepspec(i,j,k,nsc) =     &
                   diffac*Aerosol%aerosol(i,j,k,nsc)*&
                   (1.0 - Aerosol_props%aerssalbbandlw(n,opt_index))* &
                          Aerosol_props%aerextbandlw(n,opt_index)
                if (n == 1) then
                  aerooptdepspec_cn(i,j,k,nsc) =    &
                     diffac*Aerosol%aerosol(i,j,k,nsc)*   &
                 (1.0 - Aerosol_props%aerssalbbandlw_cn(n,opt_index))*&
                        Aerosol_props%aerextbandlw_cn(n,opt_index)
              endif
            end do
          end do
        end do
     else if (Aerosol_props%optical_index(nsc) ==  &
                        Aerosol_props%seasalt3_flag ) then
      do k = 1,kx         
        do j = 1,jx         
          do i = 1,ix           
            opt_index = opt_index_v6(i,j,k)
                aerooptdepspec(i,j,k,nsc) =     &
                   diffac*Aerosol%aerosol(i,j,k,nsc)*&
                   (1.0 - Aerosol_props%aerssalbbandlw(n,opt_index))* &
                          Aerosol_props%aerextbandlw(n,opt_index)
                if (n == 1) then
                  aerooptdepspec_cn(i,j,k,nsc) =    &
                     diffac*Aerosol%aerosol(i,j,k,nsc)*   &
                 (1.0 - Aerosol_props%aerssalbbandlw_cn(n,opt_index))*&
                        Aerosol_props%aerextbandlw_cn(n,opt_index)
              endif
            end do
          end do
        end do
     else if (Aerosol_props%optical_index(nsc) ==  &
                        Aerosol_props%seasalt4_flag ) then
      do k = 1,kx         
        do j = 1,jx         
          do i = 1,ix           
            opt_index = opt_index_v7(i,j,k)
                aerooptdepspec(i,j,k,nsc) =     &
                   diffac*Aerosol%aerosol(i,j,k,nsc)*&
                   (1.0 - Aerosol_props%aerssalbbandlw(n,opt_index))* &
                          Aerosol_props%aerextbandlw(n,opt_index)
                if (n == 1) then
                  aerooptdepspec_cn(i,j,k,nsc) =    &
                     diffac*Aerosol%aerosol(i,j,k,nsc)*   &
                 (1.0 - Aerosol_props%aerssalbbandlw_cn(n,opt_index))*&
                        Aerosol_props%aerextbandlw_cn(n,opt_index)
              endif
            end do
          end do
        end do
     else if (Aerosol_props%optical_index(nsc) ==  &
                        Aerosol_props%seasalt5_flag ) then
      do k = 1,kx         
        do j = 1,jx         
          do i = 1,ix           
            opt_index = opt_index_v8(i,j,k)
                aerooptdepspec(i,j,k,nsc) =     &
                   diffac*Aerosol%aerosol(i,j,k,nsc)*&
                   (1.0 - Aerosol_props%aerssalbbandlw(n,opt_index))* &
                          Aerosol_props%aerextbandlw(n,opt_index)
                if (n == 1) then
                  aerooptdepspec_cn(i,j,k,nsc) =    &
                     diffac*Aerosol%aerosol(i,j,k,nsc)*   &
                 (1.0 - Aerosol_props%aerssalbbandlw_cn(n,opt_index))*&
                        Aerosol_props%aerextbandlw_cn(n,opt_index)
              endif
            end do
          end do
        end do
      endif
   end do

!---------------------------------------------------------------------
!    save optical path contributions from each layer for band4 and the
!    continuum band. note that if the lw scheme is changed to allow
!    longwave scattering then the %absopdep must be defined approp-
!    riately.
!---------------------------------------------------------------------
      if (n == 1) then
        Aerosol_diags%extopdep(:,:,:,:,3) = aerooptdepspec_cn(:,:,:,:)
        Aerosol_diags%absopdep(:,:,:,:,3) = aerooptdepspec_cn(:,:,:,:)
      endif

!---------------------------------------------------------------------
!    sum optical depths over all species and obtain column optical depth
!---------------------------------------------------------------------
      do k=1,kx
        do j=1,jx
          do i=1,ix
            asum = 0.0
            do nsc=1,nfields
              asum = asum + aerooptdepspec(i,j,k,nsc)
            end do
            aerooptdep(i,j,k) = asum                         
          end do
        end do
      end do

      do j=1,jx
        do i=1,ix
          bsum(1) = 0.0
          do k=2,kx+1         
            bsum(k) = bsum(k-1) + aerooptdep(i,j,k-1)
          end do
          do k=2,kx+1         
            Optical%totaerooptdep(i,j,k,n) = bsum(k)
          end do
        end do
      end do

!---------------------------------------------------------------------
!    continuum band is the last indx:
!---------------------------------------------------------------------
      n_aerosol_bands = Lw_parameters%n_lwaerosol_bands
      if ( n == n_aerosol_bands) then
        Optical%aerooptdep_KE_15(:,:) = aerooptdep(:,:,kx)
      endif
    
!---------------------------------------------------------------------

end subroutine optical_depth_aerosol


!#####################################################################

                   end module optical_path_mod

                       module rad_output_file_mod

! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  fil
! </CONTACT>
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!  ds
! </REVIEWER>
! <OVERVIEW>
!  Module that provides subroutines to write radiation output to
!  history file
! </OVERVIEW>
! <DESCRIPTION>
! </DESCRIPTION>

!   shared modules:

use mpp_mod,           only: input_nml_file
use fms_mod,           only: open_namelist_file, fms_init, &
                             mpp_pe, mpp_root_pe, stdlog, &
                             file_exist, write_version_number, &
                             check_nml_error, error_mesg, &
                             FATAL, close_file
use time_manager_mod,  only: time_manager_init, time_type, operator(>)
use diag_manager_mod,  only: register_diag_field, diag_manager_init, &
                             send_data
use constants_mod,     only: constants_init, GRAV, WTMAIR, WTMOZONE

!  radiation package shared modules:

use rad_utilities_mod, only:  rad_utilities_init, radiative_gases_type,&
                              rad_output_type, cldrad_properties_type, &
                              cld_specification_type, atmos_input_type,&
                              Sw_control, aerosol_diagnostics_type, &
                              aerosol_type, aerosol_properties_type, &
                              surface_type, sw_output_type,  &
                              lw_output_type, Rad_control
use esfsw_parameters_mod, only : esfsw_parameters_init, Solar_spect

!--------------------------------------------------------------------

implicit none
private

!------------------------------------------------------------------
!    rad_output_file_mod writes an output file containing an assort-
!    ment of variables related to the sea_esf_rad radiation package.
!    this is an optionally-generated file, which may be used to sup-
!    plement the standard diagnostic model output files. NOTE THAT
!    THIS FILE IS GENERATED ONLY ON RADIATION TIMESTEPS, SO THAT WHEN 
!    SW FLUXES ARE BEING RENORMALIZED ON EACH PHYSICS STEP, VARIABLES 
!    IN THIS FILE RELATED TO SW RADIATION WILL NOT REFLECT THE EFFECTS 
!    OF THE RENORMALIZATION.
!------------------------------------------------------------------


!-------------------------------------------------------------------
!----------- version number for this module ------------------------

character(len=128)  :: version = &
'$Id: rad_output_file.F90,v 19.0 2012/01/06 20:21:53 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!---------------------------------------------------------------------
!-------  interfaces --------

public   &
         rad_output_file_init, write_rad_output_file,   &
         rad_output_file_end

private   &

!   called from rad_output_file_init
        register_fields


!-------------------------------------------------------------------
!-------- namelist  ---------

logical :: write_data_file=.false.  ! data file to be written  ?


namelist  / rad_output_file_nml /  &
                                  write_data_file
     
!------------------------------------------------------------------
!----public data------


!------------------------------------------------------------------
!----private data------

!--------------------------------------------------------------------
!    DU_factor is Dobson units per (kg/m2). the first term is 
!    (avogadro's number/loeschmidt's number at STP = vol./kmol of an 
!    ideal gas at STP). second term = mol wt o3 . third term is units 
!    conversion. values are chosen from US Standard Atmospheres, 1976.
!--------------------------------------------------------------------
real, parameter  :: DU_factor =    &
                            (6.022169e26/2.68684e25)/(47.9982)*1.0e5
real, parameter  :: DU_factor2 = DU_factor/GRAV
                                   ! Dobson units per (kg/kg * dyn/cm2) 
                                   ! Dobson units per (kg/kg * N  /m2) 

!--------------------------------------------------------------------
! netcdf diagnostics field variables
!---------------------------------------------------------------------
character(len=16), parameter       :: mod_name='radiation'
real                               :: missing_value = -999.
integer, dimension(:), allocatable :: id_aerosol, id_aerosol_column
!integer, dimension(:), allocatable :: id_aerosol, id_aerosol_column, &
!                                     id_absopdep, id_absopdep_column, &
integer, dimension(:,:), allocatable :: id_absopdep,  &
                                        id_absopdep_column, &
                                      id_extopdep, id_extopdep_column
integer, dimension(:,:), allocatable :: id_asymdep, id_asymdep_column
integer, dimension(2)              :: id_lw_absopdep_vlcno_column, &
                                      id_lw_extopdep_vlcno_column, &
                                      id_lwext_vlcno, id_lwssa_vlcno, &
                                      id_lwasy_vlcno, id_lw_xcoeff_vlcno
integer, dimension(2)              :: id_absopdep_vlcno_column, &
                                      id_extopdep_vlcno_column, &
                                      id_swext_vlcno, id_swssa_vlcno, &
                                      id_swasy_vlcno, id_sw_xcoeff_vlcno
integer, dimension(4)              :: id_lw_bdyflx_clr, id_lw_bdyflx, &
                                      id_sw_bdyflx_clr, id_sw_bdyflx
integer                            :: id_swheat_vlcno
integer                            :: id_sulfate_col_cmip,  &
                                      id_sulfate_cmip
integer, dimension(:), allocatable :: id_aerosol_fam, &
                                      id_aerosol_fam_column    
integer, dimension(:,:), allocatable :: id_absopdep_fam,  &
                                        id_absopdep_fam_column, &
                                        id_extopdep_fam,  &
                                        id_extopdep_fam_column
integer, dimension(:,:), allocatable :: id_asymdep_fam,  &
                                        id_asymdep_fam_column
integer                            :: id_radswp, id_radp, id_temp, &
                                      id_rh2o, id_qo3, id_qo3_col,  &
                                      id_qo3v, &
                                      id_cmxolw, id_crndlw, id_flxnet, &
                                      id_fsw, id_ufsw, id_psj, &
                                      id_dfsw, &
                                      id_tmpsfc, id_cvisrfgd_dir,  &
                                      id_cirrfgd_dir, &
                                      id_cvisrfgd_dif, id_cirrfgd_dif, &
                                      id_radswpcf,  &
                                      id_cldwater, id_cldice,  &
                                      id_cldarea, &
                                      id_radpcf, id_flxnetcf, &
                                      id_fswcf, id_ufswcf, id_pressm,  &
                                      id_dfswcf, &
                                      id_phalfm, id_pfluxm, &
                                      id_dphalf, id_dpflux, &
                                      id_ptop



!---------------------------------------------------------------------
!    miscellaneous variables
!---------------------------------------------------------------------
integer :: nso4 
integer :: naerosol=0                      ! number of active aerosols
logical :: module_is_initialized= .false.  ! module initialized ?
integer, parameter              :: N_DIAG_BANDS = 10
character(len=16), dimension(N_DIAG_BANDS) ::   &
                     band_suffix = (/ '_vis', '_nir', '_con',  &
                                      '_bd5', '_bd6', '_870', &
! +++ pag 11/13/2009
                                      '_340','_380','_440','_670' /)
! Properties at specific wavelength are in fact averaged over a band which
! are defined in the input file:
! /home/pag/fms/radiation/esf_sw_input_data_n38b18_1992_version_ckd2.1.lean.nov89.ref
!
! 309 < 340 < 364
! 364 < 380 < 406
! 406 < 440 < 448
! 500 < vis < 600
! 600 < 670 < 685
! 685 < 870 < 870
! 870 < nir < 1219
! In the file, each band is defined by its end wavelength in wavenumber.
! For 340nm, the endband is 1.e4/0.309=32400 (11th wavenumber among the 18
! specified in the input file)
! +++ pag 11/13/2009


!---------------------------------------------------------------------
!---------------------------------------------------------------------



                          contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!     
!                     PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
!#####################################################################
! <SUBROUTINE NAME="rad_output_file_init">
!  <OVERVIEW>
!   Constructor of rad_output_file module
!  </OVERVIEW>
!  <DESCRIPTION>
!   Subroutine to initialize and set up rad_output_file module
!  </DESCRIPTION>
!  <TEMPLATE>
!   call  rad_output_file_init (axes, Time, names)
!  </TEMPLATE>
!  <IN NAME="axes" TYPE="integer">
!   diagnostic variable axes for netcdf files
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!   current time [ time_type(days, seconds) ]
!  </IN>
!  <IN NAME="names" TYPE="character">
!   aerosol names
!  </IN>
! </SUBROUTINE>
!
subroutine rad_output_file_init (axes, Time, names, family_names)

!--------------------------------------------------------------------
!    rad_output_file_init is the constructor for rad_output_file_mod.
!--------------------------------------------------------------------

integer, dimension(4),           intent(in)    :: axes
type(time_type),                 intent(in)    :: Time
!character(len=64), dimension(:), intent(in)    :: names
character(len=*), dimension(:), intent(in)    :: names
character(len=*), dimension(:), intent(in)    :: family_names

!--------------------------------------------------------------------
!  intent(in) variables:
!
!    these variables are present when running the gcm, not present
!    when running the standalone code.
!  
!       axes      diagnostic variable axes for netcdf files
!       Time      current time [ time_type(days, seconds) ]
!       names     names of active aerosols
!       family_names 
!                 names of active aerosol families
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      integer   :: unit, io, ierr, logunit
      integer   :: nfields

!---------------------------------------------------------------------
!   local variables:
!
!        unit            io unit number used for namelist file
!        ierr            error code
!        io              error status returned from io operation
!        nfields         number of active aerosol fields
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    if routine has already been executed, exit.
!---------------------------------------------------------------------
      if (module_is_initialized) return

!---------------------------------------------------------------------
!    verify that modules used by this module that are not called later
!    have already been initialized.
!---------------------------------------------------------------------
      call fms_init
      call constants_init
      call rad_utilities_init
      call esfsw_parameters_init
      call diag_manager_init  
      call time_manager_init 

!-----------------------------------------------------------------------
!    read namelist.
!-----------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=rad_output_file_nml, iostat=io)
      ierr = check_nml_error(io,'rad_output_file_nml')
#else   
      if ( file_exist('input.nml')) then
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=rad_output_file_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'rad_output_file_nml')
        end do
10      call close_file (unit)
      endif
#endif
 
!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                         write (logunit, nml=rad_output_file_nml)

!--------------------------------------------------------------------
!    if running gcm, continue on if data file is to be written. 
!--------------------------------------------------------------------
        if (write_data_file) then

!---------------------------------------------------------------------
!    register the diagnostic fields for output.
!---------------------------------------------------------------------
          nfields = size(names(:))
          call register_fields (Time, axes, nfields, names,  &
                                family_names)
        endif

!--------------------------------------------------------------------
!    mark the module as initialized.
!--------------------------------------------------------------------
      module_is_initialized = .true.

!--------------------------------------------------------------------


end subroutine rad_output_file_init



!################################################################
! <SUBROUTINE NAME="write_rad_output_file">
!  <OVERVIEW>
!   write_rad_output_file produces a netcdf output file containing
!   the user-specified radiation-related variables.
!  </OVERVIEW>
!  <DESCRIPTION>
!   write_rad_output_file produces a netcdf output file containing
!   the user-specified radiation-related variables.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call write_rad_output_file (is, ie, js, je, Atmos_input, Surface, &
!                                  Rad_output, &
!                                  Sw_output, Lw_output, Rad_gases, &
!                                  Cldrad_props, Cld_spec,  &
!                                  Time_diag, Time, aerosol_in)
!  </TEMPLATE>
!  <IN NAME="is, ie, js, je" TYPE="integer">
!   starting/ending subdomain i,j indices of data 
!   in the physics_window being integrated
!  </IN>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
!   atmos_input_type variable containing atmos-
!                        pheric input data for the radiation package 
!                        on the model grid
!  </IN>
!  <IN NAME="Surface" TYPE="surface_type">
!   Surface input data to radiation package
!  </IN>
!  <IN NAME="Rad_output" TYPE="rad_output_type">
!   rad_output_type variable containing radiation
!                        output data needed by other modules
!  </IN>
!  <IN NAME="Sw_output" TYPE="sw_output_type">
!   sw_output_type variable containing shortwave 
!                        radiation output data from the sea_esf_rad
!                        radiation package on the model grid
!  </IN>
!  <IN NAME="Lw_output" TYPE="lw_output_type">
!   lw_output_type variable containing longwave 
!                        radiation output data from the sea_esf_rad
!                        radiation package on the model grid 
!  </IN>
!  <IN NAME="Rad_gases" TYPE="radiative_gases_type">
!   radiative_gases_type variable containing rad-
!                        iative gas input data for the radiation package
!                        on the model grid
!  </IN>
!  <IN NAME="Cldrad_pros" TYPE="cldrad_properties_type">
!   cldrad_properties_type variable containing 
!                        cloud radiative property input data for the 
!                        radiation package on the model grid
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_diagnostics_type">
!   cld_specification_type variable containing cloud
!                        microphysical data
!  </IN>
!  <IN NAME="Time_diag" TYPE="time_type">
!   time on next timestep, used as stamp for diag-
!                        nostic output  [ time_type  (days, seconds) ]
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!   current time [ time_type(days, seconds) ]
!  </IN>
!  <IN NAME="aerosol_in" TYPE="real">
!   optional aerosol data
!  </IN>
! </SUBROUTINE>
!
subroutine write_rad_output_file (is, ie, js, je, Atmos_input, Surface,&
                                  Rad_output, Sw_output, Lw_output,    &
                                  Rad_gases, Cldrad_props, Cld_spec,   &
                                  Time_diag, Time, Aerosol, Aerosol_props,&
                                  Aerosol_diags)

!----------------------------------------------------------------
!    write_rad_output_file produces a netcdf output file containing
!    the user-specified radiation-related variables.
!----------------------------------------------------------------

integer,                      intent(in)            ::  is, ie, js, je
type(atmos_input_type),       intent(in)            ::  Atmos_input
type(surface_type),           intent(in)            ::  Surface
type(rad_output_type),        intent(in)            ::  Rad_output
type(sw_output_type),         intent(in)            ::  Sw_output
type(lw_output_type),         intent(in)            ::  Lw_output
type(radiative_gases_type),   intent(in)            ::  Rad_gases
type(cldrad_properties_type), intent(in)            ::  Cldrad_props
type(cld_specification_type), intent(in)            ::  Cld_spec      
type(time_type),              intent(in)            ::  Time_diag, Time
type(aerosol_type),           intent(in), optional  ::  Aerosol
type(aerosol_properties_type), intent(in), optional ::  Aerosol_props
type(aerosol_diagnostics_type), intent(in), optional :: Aerosol_diags

!------------------------------------------------------------------
!  intent(in) variables:
!
!      is,ie,js,je       starting/ending subdomain i,j indices of data 
!                        in the physics_window being integrated
!      Atmos_input       atmos_input_type variable containing atmos-
!                        pheric input data for the radiation package 
!                        on the model grid
!      Surface           surface input fields to radiation package
!                        [ surface_type ]
!      Rad_output        rad_output_type variable containing radiation
!                        output data needed by other modules
!      Sw_output         sw_output_type variable containing shortwave 
!                        radiation output data from the sea_esf_rad
!                        radiation package on the model grid
!      Lw_output         lw_output_type variable containing longwave 
!                        radiation output data from the sea_esf_rad
!                        radiation package on the model grid 
!      Rad_gases         radiative_gases_type variable containing rad-
!                        iative gas input data for the radiation package
!                        on the model grid
!      Cldrad_props      cldrad_properties_type variable containing 
!                        cloud radiative property input data for the 
!                        radiation package on the model grid
!      Cld_spec          cld_specification_type variable containing 
!                        cloud specification input data for the 
!                        radiation package on the model grid
!      Time_diag         time on next timestep, used as stamp for diag-
!                        nostic output  [ time_type  (days, seconds) ]  
!      Time              current time [ time_type(days, seconds) ]

!
!  intent(in), optional variables:
!
!      aerosol_in        active aerosol distributions
!                        [ kg / m**2 ]
!
!----------------------------------------------------------------------

!----------------------------------------------------------------------
!  local variables:

      real, dimension (size(Atmos_input%press,1),   &
                       size(Atmos_input%press,2) )  ::  &
                           tmpsfc, psj, cvisrfgd_dir, cirrfgd_dir,  &
                           cvisrfgd_dif, cirrfgd_dif, qo3_col, &
                           ptop

      real, dimension (size(Atmos_input%press,1),    &
                       size(Atmos_input%press,2), &
                       size(Atmos_input%press,3)  ) ::   &
                          fsw, ufsw, fswcf, ufswcf, flxnet, flxnetcf, &
                          phalfm, pfluxm

      real, dimension (size(Atmos_input%press,1),    &
                       size(Atmos_input%press,2), &
                       size(Atmos_input%press,3)-1 ) ::  &
                       temp, rh2o, qo3, cmxolw, crndlw, radp, radswp, &
                       v_heat, &
                       radpcf, radswpcf, pressm, dphalf, dpflux, deltaz

      real, dimension (size(Atmos_input%press,1),    &
                       size(Atmos_input%press,2), 4)  :: &
                                bdy_flx_mean, bdy_flx_clr_mean

      real, dimension(:,:,:),   allocatable :: aerosol_col
      real, dimension(:,:,:,:),   allocatable :: extopdep_col
      real, dimension(:,:,:,:),   allocatable :: absopdep_col
      real, dimension(:,:,:),   allocatable :: lw_extopdep_vlcno_col
      real, dimension(:,:,:),   allocatable :: lw_absopdep_vlcno_col
      real, dimension(:,:,:),   allocatable :: extopdep_vlcno_col
      real, dimension(:,:,:),   allocatable :: absopdep_vlcno_col
      real, dimension(:,:,:,:),   allocatable :: absopdep_fam_col
      real, dimension(:,:,:,:),   allocatable :: extopdep_fam_col
      real, dimension(:,:,:),   allocatable :: aerosol_fam_col
      real, dimension(:,:,:,:,:), allocatable :: absopdep_fam
      real, dimension(:,:,:,:,:), allocatable :: extopdep_fam
      real, dimension(:,:,:,:), allocatable :: aerosol_fam
      real, dimension(:,:,:,:),   allocatable :: asymdep_col
      real, dimension(:,:,:,:,:), allocatable :: asymdep_fam
      real, dimension(:,:,:,:),   allocatable :: asymdep_fam_col
      real, dimension(:,:,:,:), allocatable :: sum1
      real, dimension(:,:,:), allocatable :: sum2

      logical   :: used, Lasymdep
      integer   :: kerad ! number of model layers
      integer   :: n, k, na, nfamilies, nl
      integer   :: nv, vis_indx, nir_indx
      integer   :: co_indx, bnd_indx
      integer   :: nzens, nz

!----------------------------------------------------------------------
!  local variables:
!
!      tmpsfc         surface temperature [ deg K ]
!      psj            surface pressure [ hPa ]
!      cvisrfgd       surface visible light albedo [ dimensionless ]
!      cirrfgd        surface ir albedo [ dimensionless ]
!      tot_clds       total column isccp clouds [ percent ]
!      cld_isccp_hi   number of isccp high clouds [ percent ]
!      cld_isccp_mid  number of isccp middle clouds [ percent ]
!      cld_isccp_low  number of isccp low clouds [ percent ]
!      qo3_col        ozone column [ DU ]
!      fsw            net shortwave flux [ W / m**2 ]
!      ufsw           upward shortwave flux [ W / m**2 ]
!      fswcf          net sw flux in the absence of clouds [ W / m**2 ]
!      ufswcf         upward sw flux in absence of clouds [ W / m**2]
!      flxnet         net longwave flux [ W / m**2 ]
!      flxnetcf       net lw flux in the absence of clouds [ W / m**2 ]
!      phalfm         model interface level pressure [ Pa ]
!      pfluxm         avg of adjacent model level pressures [ Pa ]
!      temp           temperature [ deg K ]
!      rh2o           water vapor specific humidity [ g / g ]
!      qo3            ozone mixing ratio [ g / g ]
!      heatra         lw heating rate [ deg K / day ]
!      heatracf       lw heating rate without cloud [ deg K / day ]
!      cmxolw         amount of maximal overlap clouds [ percent]
!      crndlw         amount of ramndom overlap clouds [ percent]
!      radp           lw + sw heating rate [ deg K / sec ]
!      radswp         sw heating rate [ deg K / sec ]
!      radpcf         lw + sw heating rate w/o clouds [ deg K / sec ]
!      radswpcf       sw heating rate w/o clouds [ deg K / sec ]
!      pressm         pressure at model levels [ Pa ]
!      aerosol_col
!      used
!      kerad
!      n,k
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('rad_output_file_mod', &
              'module has not been initialized', FATAL )
      endif

!--------------------------------------------------------------------
!    if the file is not to be written, do nothing.
!--------------------------------------------------------------------
      if (write_data_file) then
      if (Time_diag > Time) then

        Lasymdep = .false.
        if (any(id_asymdep_fam(:,:)  > 0) .or. &
            any(id_asymdep_fam_column(:,:)  > 0 )) Lasymdep = .true.
            
!--------------------------------------------------------------------
!    define the number of zenith angles that the sw was calculated 
!    for on this step.
!--------------------------------------------------------------------
        nzens = Rad_control%nzens

!--------------------------------------------------------------------
!    if the file is to be written, define the number of model layers.
!--------------------------------------------------------------------
        kerad = ubound(Atmos_input%temp,3) - 1

!--------------------------------------------------------------------
!    retrieve the desired fields from the input derived data types.
!--------------------------------------------------------------------
        tmpsfc(:,:)     = Atmos_input%temp(:,:,kerad+1)
        psj   (:,:)     = Atmos_input%press(:,:,kerad+1)
        pressm(:,:,:)   = Atmos_input%press(:,:,1:kerad)
        phalfm(:,:,:)   = Atmos_input%phalf(:,:,:)
        pfluxm(:,:,:)   = Atmos_input%pflux(:,:,:)
        temp(:,:,:)     = Atmos_input%temp(:,:,1:kerad)
        rh2o(:,:,:)     = Atmos_input%rh2o(:,:,:)
        radp = 0.
        radswp = 0.
        fsw = 0.
        ufsw = 0.
        bdy_flx_mean = 0.
        do nz = 1, nzens
          radp(:,:,:)     = radp(:,:,:) +    &
                                 Rad_output%tdt_rad(is:ie,js:je,:,nz)
          radswp(:,:,:)   = radswp(:,:,:) +    &
                                 Rad_output%tdtsw  (is:ie,js:je,:,nz)
          fsw(:,:,:)    = fsw(:,:,:) + Sw_output% fsw(:,:,:,nz)
          ufsw(:,:,:)   = ufsw(:,:,:) + Sw_output%ufsw(:,:,:,nz)
          bdy_flx_mean(:,:,:) = bdy_flx_mean(:,:,:) +  &
                                  Sw_output%bdy_flx(:,:,:,nz) 
        end do
        radp = radp/float(nzens)
        radswp = radswp/float(nzens)
        fsw = fsw/float(nzens)
        ufsw = ufsw/float(nzens)
        bdy_flx_mean = bdy_flx_mean/float(nzens)
!       cirrfgd(:,:)    = Surface%asfc(:,:)
!       cvisrfgd(:,:)   = Surface%asfc(:,:)
        cirrfgd_dir(:,:)    = Surface%asfc_nir_dir(:,:)
        cvisrfgd_dir(:,:)   = Surface%asfc_vis_dir(:,:)
        cirrfgd_dif(:,:)    = Surface%asfc_nir_dif(:,:)
        cvisrfgd_dif(:,:)   = Surface%asfc_vis_dif(:,:)
        flxnet(:,:,:)   = Lw_output%flxnet(:,:,:)
        qo3(:,:,:)      = Rad_gases%qo3(:,:,:)
        cmxolw(:,:,:)   = 100.0*Cld_spec%cmxolw(:,:,:)
        crndlw(:,:,:)   = 100.0*Cld_spec%crndlw(:,:,:)
        deltaz(:,:,:)   = Atmos_input%deltaz(:,:,:)

          do k = 1,kerad
            dphalf(:,:,k)   = phalfm(:,:,k+1) - phalfm(:,:,k)
            dpflux(:,:,k)   = pfluxm(:,:,k+1) - pfluxm(:,:,k)
          enddo
          ptop(:,:) = 0.01*Atmos_input%phalf(:,:,1)

        if (Rad_control%do_totcld_forcing) then 
          fswcf = 0.
          ufswcf = 0.
          radpcf = 0.
          radswpcf = 0.
          bdy_flx_clr_mean = 0.
          do nz=1,nzens
            fswcf(:,:,:)    = fswcf(:,:,:) + Sw_output%fswcf(:,:,:,nz)
            ufswcf(:,:,:)   = ufswcf(:,:,:) + Sw_output%ufswcf(:,:,:,nz)
            radpcf(:,:,:)   = radpcf(:,:,:) +    &
                                Rad_output%tdt_rad_clr(is:ie,js:je,:,nz)
            radswpcf(:,:,:) = radswpcf(:,:,:) +    &
                                Rad_output%tdtsw_clr  (is:ie,js:je,:,nz)
            bdy_flx_clr_mean(:,:,:) = bdy_flx_clr_mean(:,:,:) +  &
                                  Sw_output%bdy_flx_clr(:,:,:,nz) 
          end do
          fswcf = fswcf/float(nzens)
          ufswcf = ufswcf/float(nzens)
          radpcf = radpcf/float(nzens)
          radswpcf = radswpcf/float(nzens)
          bdy_flx_clr_mean = bdy_flx_clr_mean/float(nzens)
          flxnetcf(:,:,:) = Lw_output%flxnetcf(:,:,:)
        endif

!---------------------------------------------------------------------
!    calculate the column ozone in DU (Dobson units). convert from 
!    (kg/kg) * (N/m2) to DU (1DU = 2.687E16 molec cm^-2).
!---------------------------------------------------------------------
        qo3_col(:,:) = 0.
        do k = 1,size(qo3,3)
          qo3_col(:,:) = qo3_col(:,:) + &
                         qo3(:,:,k)*(Atmos_input%pflux(:,:,k+1) -  &
                                     Atmos_input%pflux(:,:,k))
        end do
        qo3_col(:,:) = qo3_col(:,:)*DU_factor2

!---------------------------------------------------------------------
!    define the aerosol fields and calculate the column aerosol. 
!---------------------------------------------------------------------
        if (Rad_control%do_aerosol) then
          allocate ( aerosol_col(size(Aerosol%aerosol, 1), &
                                 size(Aerosol%aerosol, 2), &
                                 size(Aerosol%aerosol, 4)) )       
          aerosol_col(:,:,:) = SUM (Aerosol%aerosol(:,:,:,:), 3)
!         if (Sw_control%do_swaerosol) then
            allocate ( extopdep_col(size(Aerosol_diags%extopdep  , 1), &
                                    size(Aerosol_diags%extopdep  , 2), &
                               size(Aerosol_diags%extopdep  , 4), &
                                    N_DIAG_BANDS) )
            extopdep_col(:,:,:,:) =    &
                          SUM (Aerosol_diags%extopdep  (:,:,:,:,:), 3)
            allocate ( absopdep_col(size(Aerosol_diags%absopdep  , 1), &
                                    size(Aerosol_diags%absopdep  , 2), &
                              size(Aerosol_diags%absopdep  , 4), &
                                   N_DIAG_BANDS) )
            absopdep_col(:,:,:,:) =    &
                           SUM (Aerosol_diags%absopdep  (:,:,:,:,:), 3)
            if ( Lasymdep ) then 
              allocate ( asymdep_col(size(Aerosol_diags%asymdep  , 1), &
                                 size(Aerosol_diags%asymdep  ,     2), &
                                 size(Aerosol_diags%asymdep  ,     4), &
                                      N_DIAG_BANDS) )
              asymdep_col(:,:,:,:) =  SUM ( &
                            Aerosol_diags%asymdep(:,:,:,:,:) &
                                *(Aerosol_diags%extopdep(:,:,:,:,:)-  &
                                    Aerosol_diags%absopdep(:,:,:,:,:)), 3) &
                             /(1.e-30+SUM(Aerosol_diags%extopdep(:,:,:,:,:)&
                                     -Aerosol_diags%absopdep(:,:,:,:,:), 3))
            endif
            if (Rad_control%volcanic_sw_aerosols) then
              allocate ( extopdep_vlcno_col(   &
                           size(Aerosol_diags%extopdep_vlcno  , 1), &
                           size(Aerosol_diags%extopdep_vlcno  , 2),3))
              extopdep_vlcno_col(:,:,:) =    &
                        SUM (Aerosol_diags%extopdep_vlcno  (:,:,:,:), 3)
              allocate ( absopdep_vlcno_col(    &
                            size(Aerosol_diags%absopdep_vlcno  , 1), &
                            size(Aerosol_diags%absopdep_vlcno  , 2),3))
              absopdep_vlcno_col(:,:,:) =    &
                        SUM (Aerosol_diags%absopdep_vlcno  (:,:,:,:), 3)
            endif
              
            if (Rad_control%volcanic_lw_aerosols) then
              allocate ( lw_extopdep_vlcno_col(   &
                         size(Aerosol_diags%lw_extopdep_vlcno  , 1), &
                         size(Aerosol_diags%lw_extopdep_vlcno  , 2),2))
              lw_extopdep_vlcno_col(:,:,:) =    &
                    SUM (Aerosol_diags%lw_extopdep_vlcno  (:,:,:,:), 3)
              allocate ( lw_absopdep_vlcno_col(    &
                          size(Aerosol_diags%lw_absopdep_vlcno  , 1), &
                          size(Aerosol_diags%lw_absopdep_vlcno  , 2),2))
              lw_absopdep_vlcno_col(:,:,:) =    &
                    SUM (Aerosol_diags%lw_absopdep_vlcno  (:,:,:,:), 3)
            endif
        endif
        
!---------------------------------------------------------------------
!    define the aerosol family output fields.
!---------------------------------------------------------------------
        if (Rad_control%do_aerosol) then
          nfamilies = size(Aerosol%family_members,2)
          if (nfamilies > 0) then
            allocate (aerosol_fam (     &
                                    size(Aerosol%aerosol,1), &
                                    size(Aerosol%aerosol,2), &
                                    size(Aerosol%aerosol,3), &
                                    nfamilies))
            allocate (aerosol_fam_col (     &
                                    size(Aerosol%aerosol,1), &
                                    size(Aerosol%aerosol,2), &
                                    nfamilies))
            allocate (extopdep_fam (     &
                                    size(Aerosol%aerosol,1), &
                                    size(Aerosol%aerosol,2), &
                                    size(Aerosol%aerosol,3), &
                                    nfamilies, N_DIAG_BANDS))
            allocate (absopdep_fam (     &
                                    size(Aerosol%aerosol,1), &
                                    size(Aerosol%aerosol,2), &
                                    size(Aerosol%aerosol,3), &
                                    nfamilies, N_DIAG_BANDS))
            allocate (extopdep_fam_col (     &
                                    size(Aerosol%aerosol,1), &
                                    size(Aerosol%aerosol,2), &
                                    nfamilies, N_DIAG_BANDS))
            allocate (absopdep_fam_col (     &
                                    size(Aerosol%aerosol,1), &
                                    size(Aerosol%aerosol,2), &
                                    nfamilies, N_DIAG_BANDS))
            aerosol_fam = 0.
            aerosol_fam_col = 0.
            extopdep_fam = 0.
            absopdep_fam = 0.
            extopdep_fam_col = 0.
            absopdep_fam_col = 0.

            if ( Lasymdep ) then
              allocate (asymdep_fam ( size(Aerosol%aerosol,1), &
                                      size(Aerosol%aerosol,2), &
                                      size(Aerosol%aerosol,3), &
                                      nfamilies, N_DIAG_BANDS))
              allocate (asymdep_fam_col ( size(Aerosol%aerosol,1), &
                                          size(Aerosol%aerosol,2), &
                                          nfamilies, N_DIAG_BANDS))
              allocate (sum1 (       size(Aerosol%aerosol,1), &
                                     size(Aerosol%aerosol,2), &
                                     size(Aerosol%aerosol,3), &
                                     N_DIAG_BANDS))
              allocate (sum2 (       size(Aerosol%aerosol,1), &
                                     size(Aerosol%aerosol,2), &
                                     N_DIAG_BANDS))
              asymdep_fam = 0.
              asymdep_fam_col = 0.
            endif

            do n = 1, nfamilies                      
              do na = 1, naerosol                
                if (Aerosol%family_members(na,n)) then
                  aerosol_fam(:,:,:,n) = aerosol_fam(:,:,:,n) +  &
                                         Aerosol%aerosol(:,:,:,na)
                  aerosol_fam_col(:,:,n) = aerosol_fam_col(:,:,n) +  &
                                         aerosol_col(:,:,na)
                  do nl = 1,N_DIAG_BANDS
                    extopdep_fam(:,:,:,n,nl) = extopdep_fam(:,:,:,n,nl) +  &
                                      Aerosol_diags%extopdep(:,:,:,na,nl)
                    extopdep_fam_col(:,:,n,nl) = extopdep_fam_col(:,:,n,nl) +  &
                                      extopdep_col(:,:,na,nl)
                    absopdep_fam(:,:,:,n,nl) = absopdep_fam(:,:,:,n,nl) +  &
                                      Aerosol_diags%absopdep(:,:,:,na,nl)
                    absopdep_fam_col(:,:,n,nl) = absopdep_fam_col(:,:,n,nl) +  &
                                      absopdep_col(:,:,na,nl)
                  end do ! (nl)
                endif
              end do ! (na)
              if ( Lasymdep ) then
                sum1(:,:,:,:)=1.e-30
                sum2(:,:,:)=1.e-30
                do na = 1, naerosol                
                  if (Aerosol%family_members(na,n)) then
                    do nl = 1,N_DIAG_BANDS
                      asymdep_fam(:,:,:,n,nl) = asymdep_fam(:,:,:,n,nl) &
                          + Aerosol_diags%asymdep(:,:,:,na,nl) &
                          *( Aerosol_diags%extopdep(:,:,:,na,nl) &
                          -Aerosol_diags%absopdep(:,:,:,na,nl))
                      sum1(:,:,:,nl) = sum1(:,:,:,nl) &
                          + Aerosol_diags%extopdep(:,:,:,na,nl) &
                          - Aerosol_diags%absopdep(:,:,:,na,nl)
                      asymdep_fam_col(:,:,n,nl) = asymdep_fam_col(:,:,n,nl) &
                          + asymdep_col(:,:,na,nl)&
                          *(extopdep_col(:,:,na,nl)-absopdep_col(:,:,na,nl))
                      sum2(:,:,nl) = sum2(:,:,nl)&
                          + extopdep_col(:,:,na,nl) - absopdep_col(:,:,na,nl)
                    end do ! (nl)
                  endif
                end do ! (na)

                asymdep_fam = max (0., min(1., asymdep_fam))
                sum1 = max(1.e-30,min(1.,sum1))
                asymdep_fam_col = max (0., min(1., asymdep_fam_col))
                sum2 = max (1.e-30, min(1.,sum2))
                do nl = 1,N_DIAG_BANDS
                  asymdep_fam(:,:,:,n,nl) = asymdep_fam(:,:,:,n,nl)/sum1(:,:,:,nl)
                  asymdep_fam_col(:,:,n,nl)=asymdep_fam_col(:,:,n,nl)/sum2(:,:,nl)
                enddo
              endif

              if (Aerosol%family_members(naerosol+1,n)) then
                if (Rad_control%volcanic_sw_aerosols) then
                  extopdep_fam_col(:,:,n,1) = extopdep_fam_col(:,:,n,1) +  &
                                              extopdep_vlcno_col(:,:,1)
                  absopdep_fam_col(:,:,n,1) = absopdep_fam_col(:,:,n,1) +  &
                                              absopdep_vlcno_col(:,:,1)
                  extopdep_fam_col(:,:,n,2) = extopdep_fam_col(:,:,n,2) +  &
                                              extopdep_vlcno_col(:,:,2)
                  absopdep_fam_col(:,:,n,2) = absopdep_fam_col(:,:,n,2) +  &
                                              absopdep_vlcno_col(:,:,2)
                  extopdep_fam_col(:,:,n,6) = extopdep_fam_col(:,:,n,6) +  &
                                              extopdep_vlcno_col(:,:,3)
                  absopdep_fam_col(:,:,n,6) = absopdep_fam_col(:,:,n,6) +  &
                                              absopdep_vlcno_col(:,:,3)
                endif
                if (Rad_control%volcanic_lw_aerosols) then
                  extopdep_fam_col(:,:,n,4) = extopdep_fam_col(:,:,n,4) +  &
                                              lw_extopdep_vlcno_col(:,:,1)
                  absopdep_fam_col(:,:,n,4) = absopdep_fam_col(:,:,n,4) +  &
                                              lw_absopdep_vlcno_col(:,:,1)
                  extopdep_fam_col(:,:,n,5) = extopdep_fam_col(:,:,n,5) +  &
                                              lw_extopdep_vlcno_col(:,:,2)
                  absopdep_fam_col(:,:,n,5) = absopdep_fam_col(:,:,n,5) +  &
                                              lw_absopdep_vlcno_col(:,:,2)
                endif
              endif
            enddo ! (n)

          do n = 1,nfamilies
            if (id_aerosol_fam(n)  > 0 ) then
              used = send_data (id_aerosol_fam(n),  &
                                aerosol_fam(:,:,:,n)/deltaz(:,:,:),   &
                                Time_diag, is, js, 1)
            endif
            if (id_aerosol_fam_column(n)  > 0 ) then
              used = send_data (id_aerosol_fam_column(n),     &
                                aerosol_fam_col(:,:,n), Time_diag, is, js)
            endif
            do nl=1,N_DIAG_BANDS
              if (id_extopdep_fam(n,nl)  > 0 ) then
                used = send_data (id_extopdep_fam(n,nl),    &
                                  extopdep_fam  (:,:,:,n,nl), &
                                  Time_diag, is, js, 1)
              endif
              if (id_extopdep_fam_column(n,nl)  > 0 ) then
                used = send_data (id_extopdep_fam_column(n,nl),     &
                                 extopdep_fam_col(:,:,n,nl), Time_diag, is, js)
              endif
              if (id_absopdep_fam(n,nl)  > 0 ) then
                used = send_data (id_absopdep_fam(n,nl),    &
                                  absopdep_fam  (:,:,:,n,nl), &
                                  Time_diag, is, js, 1)
              endif
              if (id_absopdep_fam_column(n,nl)  > 0 ) then
                used = send_data (id_absopdep_fam_column(n,nl),     &
                             absopdep_fam_col(:,:,n,nl), Time_diag, is, js)
              endif
              if (id_asymdep_fam(n,nl)  > 0 ) then
                used = send_data (id_asymdep_fam(n,nl),    &
                                  asymdep_fam  (:,:,:,n,nl), &
                                  Time_diag, is, js, 1)
              endif
              if (id_asymdep_fam_column(n,nl)  > 0 ) then
                used = send_data (id_asymdep_fam_column(n,nl),     &
                             asymdep_fam_col(:,:,n,nl), Time_diag, is, js)
              endif
            end do  
        end do
          deallocate (aerosol_fam)
          deallocate (aerosol_fam_col)
          deallocate (extopdep_fam)
          deallocate (absopdep_fam)
          deallocate (extopdep_fam_col)
          deallocate (absopdep_fam_col)
          if ( Lasymdep ) then
            deallocate (asymdep_fam)
            deallocate (asymdep_fam_col)
            deallocate (sum1)
            deallocate (sum2)
          endif
      endif
    endif
        
!---------------------------------------------------------------------
!    send the user-designated data to diag_manager_mod for processing.
!---------------------------------------------------------------------
        if (id_radswp > 0 ) then
          used = send_data (id_radswp, radswp, Time_diag, is, js, 1)
        endif

        if (id_radp > 0 ) then
          used = send_data (id_radp, radp, Time_diag, is, js, 1)
        endif

        if (id_temp > 0 ) then
          used = send_data (id_temp, temp, Time_diag, is, js, 1)
        endif

        if (id_pressm > 0 ) then
          used = send_data (id_pressm, pressm, Time_diag, is, js, 1)
        endif

        if (id_phalfm > 0 ) then
          used = send_data (id_phalfm, phalfm, Time_diag, is, js, 1)
        endif
 
        if (id_pfluxm > 0 ) then
          used = send_data (id_pfluxm, pfluxm, Time_diag, is, js, 1)
        endif

        if (id_rh2o > 0 ) then
          used = send_data (id_rh2o, rh2o, Time_diag, is, js, 1)
        endif

        if (id_cldwater > 0 ) then
          used = send_data (id_cldwater, Cld_spec%cloud_water,  &
                            Time_diag, is, js, 1)
        endif

        if (id_cldice > 0 ) then
          used = send_data (id_cldice, Cld_spec%cloud_ice,  &
                            Time_diag, is, js, 1)
        endif

        if (id_cldarea > 0 ) then
          used = send_data (id_cldarea, Cld_spec%cloud_area,  &
                            Time_diag, is, js, 1)
        endif

        if (id_qo3  > 0 ) then
          used = send_data (id_qo3, qo3, Time_diag, is, js, 1)
        endif

        if (id_qo3v  > 0 ) then
          used = send_data (id_qo3v, 1.0e09*qo3*WTMAIR/WTMOZONE, Time_diag, is, js, 1)
        endif

        if (id_qo3_col  > 0 ) then
          used = send_data (id_qo3_col, qo3_col, Time_diag, is, js)
        endif

          if (id_dphalf > 0 ) then
            used = send_data (id_dphalf, dphalf, Time_diag, is, js, 1)
          endif

          if (id_dpflux > 0 ) then
            used = send_data (id_dpflux, dpflux, Time_diag, is, js, 1)
          endif

          if (id_ptop  > 0 ) then
            used = send_data (id_ptop, ptop, Time_diag, is, js)
          endif
        if (Rad_control%do_aerosol) then
            if (id_sulfate_col_cmip  > 0 ) then
              used = send_data (id_sulfate_col_cmip,      &
                            (96./132.)*aerosol_col(:,:,nso4), Time_diag, is, js)
            endif
            if (id_sulfate_cmip  > 0 ) then
              used = send_data (id_sulfate_cmip,      &
                       (96./132.)*Aerosol%aerosol(:,:,:,nso4)/  &
                                   deltaz(:,:,:), Time_diag, is, js,1)
            endif
!           if (Sw_control%do_swaerosol) then
          do n = 1,naerosol
            if (id_aerosol(n)  > 0 ) then
              used = send_data (id_aerosol(n),  &
                                Aerosol%aerosol(:,:,:,n)/deltaz(:,:,:),&
                                Time_diag, is, js, 1)
            endif
            if (id_aerosol_column(n)  > 0 ) then
              used = send_data (id_aerosol_column(n),     &
                                aerosol_col(:,:,n), Time_diag, is, js)
            endif
!           if (Sw_control%do_swaerosol) then
            do nl=1,N_DIAG_BANDS
              if (id_extopdep(n,nl)  > 0 ) then
                used = send_data (id_extopdep(n,nl),    &
                                  Aerosol_diags%extopdep  (:,:,:,n,nl), &
                                  Time_diag, is, js, 1)
              endif
              if (id_extopdep_column(n,nl)  > 0 ) then
                used = send_data (id_extopdep_column(n,nl),     &
                                 extopdep_col(:,:,n,nl), Time_diag, is, js)
              endif
              if (id_absopdep(n,nl)  > 0 ) then
                used = send_data (id_absopdep(n,nl),    &
                                  Aerosol_diags%absopdep  (:,:,:,n,nl), &
                                  Time_diag, is, js, 1)
              endif
              if (id_absopdep_column(n,nl)  > 0 ) then
                used = send_data (id_absopdep_column(n,nl),     &
                                 absopdep_col(:,:,n,nl), Time_diag, is, js)
              endif
              if (id_asymdep(n,nl)  > 0 ) then
                used = send_data (id_asymdep(n,nl),    &
                                  Aerosol_diags%asymdep  (:,:,:,n,nl), &
                                  Time_diag, is, js, 1)
              endif
              if (id_asymdep_column(n,nl)  > 0 ) then
                used = send_data (id_asymdep_column(n,nl),     &
                                 asymdep_col(:,:,n,nl), Time_diag, is, js)
              endif
!           endif
            end do
          end do
          if (Rad_control%volcanic_lw_aerosols) then
!           co_indx = size(Aerosol_props%lw_ext,4)
            co_indx = 5
            if (id_lwext_vlcno(1)  > 0 ) then
              used = send_data (id_lwext_vlcno(1),     &
                         Aerosol_props%lw_ext(:,:,:,co_indx)*  &
                         Atmos_input%deltaz(:,:,:),  &
                         Time_diag, is, js,1)
            endif
            if (id_lw_xcoeff_vlcno(1)  > 0 ) then
              used = send_data (id_lw_xcoeff_vlcno(1),     &
                            Aerosol_props%lw_ext(:,:,:,co_indx),  &
                            Time_diag, is, js,1)
            endif
            if (id_lwssa_vlcno(1)  > 0 ) then
              used = send_data (id_lwssa_vlcno(1),     &
                            Aerosol_props%lw_ssa(:,:,:,co_indx),  &
                            Time_diag, is, js,1)
            endif
            if (id_lwasy_vlcno(1)  > 0 ) then
              used = send_data (id_lwasy_vlcno(1),     &
                           Aerosol_props%lw_asy(:,:,:,co_indx),  &
                           Time_diag, is, js,1)
            endif
!           bnd_indx = 4
            bnd_indx = 6
            if (id_lwext_vlcno(2)  > 0 ) then
              used = send_data (id_lwext_vlcno(2),     &
                               Aerosol_props%lw_ext(:,:,:,bnd_indx)* &
                               Atmos_input%deltaz(:,:,:),  &
                               Time_diag, is, js,1)
            endif
            if (id_lw_xcoeff_vlcno(2)  > 0 ) then
              used = send_data (id_lw_xcoeff_vlcno(2),     &
                               Aerosol_props%lw_ext(:,:,:,bnd_indx),  &
                               Time_diag, is, js,1)
            endif
            if (id_lwssa_vlcno(2)  > 0 ) then
              used = send_data (id_lwssa_vlcno(2),     &
                               Aerosol_props%lw_ssa(:,:,:,bnd_indx), &
                               Time_diag, is, js,1)
            endif
            if (id_lwasy_vlcno(2)  > 0 ) then
              used = send_data (id_lwasy_vlcno(2),     &
                              Aerosol_props%lw_asy(:,:,:,bnd_indx), &
                              Time_diag, is, js,1)
            endif
            do nv=1,2
              if (id_lw_extopdep_vlcno_column(nv)  > 0 ) then
                used = send_data (id_lw_extopdep_vlcno_column(nv),     &
                                  lw_extopdep_vlcno_col(:,:,nv),  &
                                  Time_diag, is, js)
              endif
              if (id_lw_absopdep_vlcno_column(nv)  > 0 ) then
                used = send_data (id_lw_absopdep_vlcno_column(nv),     &
                                  lw_absopdep_vlcno_col(:,:,nv),  &
                                  Time_diag, is, js)
              endif
            end do
            deallocate (lw_absopdep_vlcno_col, lw_extopdep_vlcno_col)
          endif
          if (Rad_control%volcanic_sw_aerosols) then
            vis_indx = Solar_spect%visible_band_indx
            if (id_swext_vlcno(1)  > 0 ) then
              used = send_data (id_swext_vlcno(1),     &
                                Aerosol_props%sw_ext(:,:,:,vis_indx)* &
                                Atmos_input%deltaz(:,:,:),  &
                                Time_diag, is, js,1)
            endif
            if (id_sw_xcoeff_vlcno(1)  > 0 ) then
              used = send_data (id_sw_xcoeff_vlcno(1),     &
                               Aerosol_props%sw_ext(:,:,:,vis_indx),  &
                               Time_diag, is, js,1)
            endif
            if (id_swssa_vlcno(1)  > 0 ) then
              used = send_data (id_swssa_vlcno(1),     &
                                 Aerosol_props%sw_ssa(:,:,:,vis_indx), &
                                 Time_diag, is, js,1)
            endif
            if (id_swasy_vlcno(1)  > 0 ) then
              used = send_data (id_swasy_vlcno(1),     &
                                Aerosol_props%sw_asy(:,:,:,vis_indx), &
                                Time_diag, is, js,1)
            endif
            if (id_swheat_vlcno  > 0 ) then

              v_heat = 0.0
              do nz = 1,nzens
                v_heat(:,:,:) = v_heat(:,:,:)  +  &
                              Aerosol_diags%sw_heating_vlcno(:,:,:,nz)
              end do
              v_heat = v_heat/float(nzens)

              used = send_data (id_swheat_vlcno ,    &
!                               Aerosol_diags%sw_heating_vlcno(:,:,:), &
                                v_heat(:,:,:), &
                                Time_diag, is, js, 1)
            endif
            nir_indx = Solar_spect%one_micron_indx
            if (id_swext_vlcno(2)  > 0 ) then
              used = send_data (id_swext_vlcno(2),     &
                               Aerosol_props%sw_ext(:,:,:,nir_indx)*  &
                               Atmos_input%deltaz(:,:,:),  &
                               Time_diag, is, js,1)
            endif
            if (id_sw_xcoeff_vlcno(2)  > 0 ) then
              used = send_data (id_sw_xcoeff_vlcno(2),     &
                               Aerosol_props%sw_ext(:,:,:,nir_indx),  &
                               Time_diag, is, js,1)
            endif
            if (id_swssa_vlcno(2)  > 0 ) then
              used = send_data (id_swssa_vlcno(2),     &
                                Aerosol_props%sw_ssa(:,:,:,nir_indx),  &
                                Time_diag, is, js,1)
            endif
            if (id_swasy_vlcno(2)  > 0 ) then
              used = send_data (id_swasy_vlcno(2),     &
                                Aerosol_props%sw_asy(:,:,:,vis_indx), &
                                Time_diag, is, js,1)
            endif
            do nv=1,2
              if (id_extopdep_vlcno_column(nv)  > 0 ) then
                used = send_data (id_extopdep_vlcno_column(nv),     &
                                  extopdep_vlcno_col(:,:,nv),  &
                                  Time_diag, is, js)
              endif
              if (id_absopdep_vlcno_column(nv)  > 0 ) then
                used = send_data (id_absopdep_vlcno_column(nv),     &
                                  absopdep_vlcno_col(:,:,nv),  &
                                  Time_diag, is, js)
              endif
            end do
            deallocate (absopdep_vlcno_col, extopdep_vlcno_col)
          endif
          deallocate (aerosol_col)
!         if (Sw_control%do_swaerosol) then
            deallocate (extopdep_col)
            deallocate (absopdep_col)
            if (allocated (asymdep_col)) deallocate (asymdep_col)
!         endif
        endif

        if (id_cmxolw > 0 ) then
          used = send_data (id_cmxolw, cmxolw, Time_diag, is, js, 1)
        endif

        if (id_crndlw > 0 ) then
          used = send_data (id_crndlw, crndlw, Time_diag, is, js, 1)
        endif

        if (id_flxnet > 0 ) then
          used = send_data (id_flxnet, flxnet, Time_diag, is, js, 1)
        endif

        if (id_fsw    > 0 ) then
          used = send_data (id_fsw   , fsw   , Time_diag, is, js, 1)
        endif

        if (id_ufsw   > 0 ) then
          used = send_data (id_ufsw  , ufsw  , Time_diag, is, js, 1)
        endif

        if (id_dfsw   > 0 ) then
          used = send_data (id_dfsw  , ufsw-fsw  , Time_diag, is, js, 1)
        endif

        if (id_psj    > 0 ) then
          used = send_data (id_psj   , psj   , Time_diag, is, js)
        endif

        if (id_tmpsfc > 0 ) then
          used = send_data (id_tmpsfc, tmpsfc, Time_diag, is, js)
        endif

        if (id_cvisrfgd_dir > 0 ) then
          used = send_data (id_cvisrfgd_dir, cvisrfgd_dir, Time_diag, is, js)
        endif
 
        if (id_cvisrfgd_dif > 0 ) then
          used = send_data (id_cvisrfgd_dif, cvisrfgd_dif, Time_diag, is, js)
        endif

        if (id_cirrfgd_dir > 0 ) then
          used = send_data (id_cirrfgd_dir , cirrfgd_dir , Time_diag, is,js)
        endif
 
        if (id_cirrfgd_dif > 0 ) then
          used = send_data (id_cirrfgd_dif , cirrfgd_dif , Time_diag, is,js)
        endif

     do n=1, 4
        if (id_lw_bdyflx(n) > 0 ) then
          used = send_data (id_lw_bdyflx(n) , Lw_output%bdy_flx(:,:,n),&
                            Time_diag, is,js)
        endif
        if (id_sw_bdyflx(n) > 0 ) then
          used = send_data (id_sw_bdyflx(n) , bdy_flx_mean(:,:,n),&
                            Time_diag, is,js)
        endif
     end do

        if (Rad_control%do_totcld_forcing) then
     do n=1, 4
        if (id_lw_bdyflx_clr(n) > 0 ) then
          used = send_data (id_lw_bdyflx_clr(n) ,   &
                            Lw_output%bdy_flx_clr(:,:,n),&
                            Time_diag, is,js)
        endif
        if (id_sw_bdyflx_clr(n) > 0 ) then
          used = send_data (id_sw_bdyflx_clr(n) ,   &
                            bdy_flx_clr_mean(:,:,n),&
                            Time_diag, is,js)
        endif
     end do

          if (id_radswpcf > 0 ) then
            used = send_data (id_radswpcf, radswpcf, Time_diag,   &
                              is, js, 1)
          endif

          if (id_radpcf > 0 ) then
            used = send_data (id_radpcf, radpcf, Time_diag, is, js, 1)
          endif

          if (id_flxnetcf > 0 ) then
            used = send_data (id_flxnetcf, flxnetcf, Time_diag,   &
                              is, js, 1)
          endif

          if (id_fswcf  > 0 ) then
            used = send_data (id_fswcf , fswcf , Time_diag, is, js, 1)
          endif

          if (id_ufswcf  > 0 ) then
            used = send_data (id_ufswcf , ufswcf , Time_diag, is, js, 1)
          endif

          if (id_dfswcf  > 0 ) then
            used = send_data (id_dfswcf , ufswcf-fswcf , Time_diag, is, js, 1)
          endif
        endif

      endif    ! (Time_diag > Time)
      endif    ! (write_data_file)

!------------------------------------------------------------------


end subroutine write_rad_output_file



!#####################################################################
! <SUBROUTINE NAME="rad_output_file_end">
!  <OVERVIEW>
!   rad_output_file_end is the destructor for rad_output_file_mod
!  </OVERVIEW>
!  <DESCRIPTION>
!   rad_output_file_end is the destructor for rad_output_file_mod
!  </DESCRIPTION>
!  <TEMPLATE>
!   call rad_output_file_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine rad_output_file_end

!-------------------------------------------------------------------
!    rad_output_file_end is the destructor for rad_output_file_mod.
!-------------------------------------------------------------------

!---------------------------------------------------------------------
!    be sure module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized ) then
        call error_mesg ('rad_output_file_mod', &
              'module has not been initialized', FATAL )
      endif

!---------------------------------------------------------------------
!    mark the module as uninitialized.
!---------------------------------------------------------------------
      module_is_initialized= .false. 

!----------------------------------------------------------------------

end subroutine rad_output_file_end



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!     
!                     PRIVATE SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!#################################################################
! <SUBROUTINE NAME="register_fields">
!  <OVERVIEW>
!   register_fields send the relevant information concerning the 
!    user-desired output fields to diag_manager_mod.
!  </OVERVIEW>
!  <DESCRIPTION>
!   register_fields send the relevant information concerning the 
!    user-desired output fields to diag_manager_mod.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call register_fields (Time, axes, nfilds, names)
!  </TEMPLATE>
!  <IN NAME="Time" TYPE="time_type">
!   current time [ time_type(days, seconds) ]
!  </IN>
!  <IN NAME="axes" TYPE="integer">
!   diagnostic variable axes for netcdf files
!  </IN>
!  <IN NAME="nfields" TYPE="integer">
!   number of aerosol fields
!  </IN>
!  <IN NAME="names" TYPE="character">
!   names of aerosol fields
!  </IN>
! </SUBROUTINE>
!
subroutine register_fields (Time, axes, nfields, names, family_names)

!--------------------------------------------------------------------
!    register_fields send the relevant information concerning the 
!    user-desired output fields to diag_manager_mod.
!--------------------------------------------------------------------

type(time_type),                 intent(in) :: Time
integer, dimension(4),           intent(in) :: axes
integer,                         intent(in) :: nfields
!character(len=64), dimension(:), intent(in) :: names
character(len=*), dimension(:), intent(in) :: names, family_names

!--------------------------------------------------------------------
!  intent(in) variables:
!
!       Time      current time [ time_type(days, seconds) ]
!       axes      diagnostic variable axes for netcdf files
!       nfields   number of active aerosol species
!       names     names of active aerosol species
!       family_names  
!                 names of active aerosol families
!
!----------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      character(len=64), dimension(:), allocatable ::   & 
                                               aerosol_column_names, &
                                              extopdep_column_names, &
                                              absopdep_column_names, &
                                                 extopdep_names, &
                                                 absopdep_names, &
                                             asymdep_column_names, &
                                             asymdep_names, &
                                             asymdep_fam_column_names, &
                                             asymdep_fam_names, &
                                          aerosol_fam_column_names, &
                                         extopdep_fam_column_names, &
                                        absopdep_fam_column_names, &
                                        extopdep_fam_names, &
                                        absopdep_fam_names
      integer, dimension(4)    :: bxes
      integer                  :: n, nl
      integer                  :: nfamilies
      real                     :: trange(2)

!---------------------------------------------------------------------
!   local variables:
!
!       aerosol_column_names
!       bxes                   diagnostic variable axes with elements 
!                              (1:3) valid for variables defined at
!                              flux levels
!       n
!
!--------------------------------------------------------------------
 
!-------------------------------------------------------------------
!    define variable axis array with elements (1:3) valid for variables
!    defined at flux levels.
!-------------------------------------------------------------------
      bxes(1:2) = axes(1:2)
      bxes(3) = axes(4)
      bxes(4) = axes(4)
      trange =(/ 100., 400. /)

!---------------------------------------------------------------------
!    register the potential diagnostic variables from this module.
!    the variables will actually be saved and then output only if
!    they are activated through the input diag_file.
!---------------------------------------------------------------------
      id_radswp = &
         register_diag_field (mod_name, 'radswp', axes(1:3), Time, &
                          'temperature tendency for SW radiation', &
                          'deg_K/sec', missing_value=missing_value)

      id_radp = &
         register_diag_field (mod_name, 'radp', axes(1:3), Time, &
                          'temperature tendency for radiation', &
                          'deg_K/sec', missing_value=missing_value)

      id_temp   = &
         register_diag_field (mod_name, 'temp', axes(1:3), Time, &
                          'temperature field', &
                          'deg_K', missing_value=trange(1), &
                          range=trange)

      id_pressm  = &
         register_diag_field (mod_name, 'pressm', axes(1:3), Time, &
                           'model level pressure', &
                           'Pa', missing_value=missing_value)
 
      id_phalfm  = &
         register_diag_field (mod_name, 'phalfm', bxes(1:3), Time, &
                           'model interface level pressure', &
                           'Pa', missing_value=missing_value)

      id_pfluxm  = &
          register_diag_field (mod_name, 'pfluxm', bxes(1:3), Time, &
                           'radiation flux level pressures', &
                           'Pa', missing_value=missing_value)

        id_dpflux  = &
          register_diag_field (mod_name, 'dpflux', axes(1:3), Time,  &
                           'radiation flux layer thickness', &
                           'hPa', missing_value=missing_value)
   
        id_dphalf  = &
          register_diag_field (mod_name, 'dphalf', axes(1:3), Time,  &
                           'radiation model layer thickness', &
                           'hPa', missing_value=missing_value)
   
        id_ptop  = &
          register_diag_field (mod_name, 'ptop', axes(1:2), Time, &
                           'pressure at model top', &
                           'hPa', missing_value=missing_value)
 

      id_rh2o   = &
         register_diag_field (mod_name, 'rh2o', axes(1:3), Time, &
                          'water vapor mixing ratio', &
                          'kg/kg', missing_value=missing_value)

      id_cldwater = &
         register_diag_field (mod_name, 'cloud_water', axes(1:3), Time,&
                          'cloud water specific humidity', &
                          'kg/kg', missing_value=missing_value)

      id_cldice = &
         register_diag_field (mod_name, 'cloud_ice', axes(1:3), Time,&
                          'cloud ice specific humidity', &
                          'kg/kg', missing_value=missing_value)

      id_cldarea = &
         register_diag_field (mod_name, 'cloud_area', axes(1:3), Time,&
                          'cloud fractional area', &
                          'fraction', missing_value=missing_value)

      id_qo3    = &
         register_diag_field (mod_name, 'qo3', axes(1:3), Time, &
                          'ozone mixing ratio', &
                          'kg/kg', missing_value=missing_value)

      id_qo3v    = &
         register_diag_field (mod_name, 'qo3v', axes(1:3), Time, &
                          'ozone mole fraction', &
                          '1.e-9', missing_value=missing_value)

      id_qo3_col = &
         register_diag_field (mod_name, 'qo3_col', axes(1:2), Time, &
                          'ozone column', &
                          'DU', missing_value=missing_value)

!--------------------------------------------------------------------
!    allocate space for and save aerosol name information.
!--------------------------------------------------------------------
      if (nfields /= 0) then
        naerosol = nfields
        allocate (id_aerosol(naerosol))
        allocate (id_aerosol_column(naerosol)) 
        allocate (aerosol_column_names(naerosol))
        id_sulfate_col_cmip = &
             register_diag_field (mod_name, 'sulfate_col_cmip',  &
                            axes(1:2), Time, 'sulfate_col_cmip',&
                                  'kg/m2', missing_value=missing_value)
        id_sulfate_cmip = &
             register_diag_field (mod_name, 'sulfate_cmip',  &
                            axes(1:3), Time, 'sulfate_cmip',&
                                  'kg/m3', missing_value=missing_value)
        do n = 1,naerosol                           
          aerosol_column_names(n) = TRIM(names(n) ) // "_col"
          if (TRIM(names(n)) == 'so4') then
            nso4 = n
          endif
        end do
        do n = 1,naerosol
          id_aerosol(n)    = &
             register_diag_field (mod_name, TRIM(names(n)), axes(1:3), &
                                  Time, TRIM(names(n)),&
                                  'kg/m3', missing_value=missing_value)
          id_aerosol_column(n)    = &
             register_diag_field (mod_name,   &
                      TRIM(aerosol_column_names(n)), axes(1:2), Time, &
                      TRIM(aerosol_column_names(n)), &
                      'kg/m2', missing_value=missing_value)
        end do
        deallocate (aerosol_column_names)

        allocate (extopdep_names(naerosol))
        allocate (extopdep_column_names(naerosol))
        allocate (absopdep_names(naerosol))
        allocate (absopdep_column_names(naerosol))
        allocate (id_extopdep(naerosol, N_DIAG_BANDS))
        allocate (id_extopdep_column(naerosol, N_DIAG_BANDS))
        allocate (id_absopdep(naerosol, N_DIAG_BANDS))
        allocate (id_absopdep_column(naerosol, N_DIAG_BANDS))
        allocate (id_asymdep(naerosol, N_DIAG_BANDS))
        allocate (id_asymdep_column(naerosol, N_DIAG_BANDS))
        allocate (asymdep_names(naerosol))
        allocate (asymdep_column_names(naerosol))
     do nl=1,N_DIAG_BANDS
        do n = 1,naerosol                           
          extopdep_names(n) =   &
                TRIM(names(n) ) // "_exopdep" // TRIM(band_suffix(nl))
          extopdep_column_names(n) =   &
             TRIM(names(n) ) // "_exopdep_col" // TRIM(band_suffix(nl))
          absopdep_names(n) =   &
             TRIM(names(n) ) // "_abopdep" // TRIM(band_suffix(nl))
          absopdep_column_names(n) =   &
             TRIM(names(n) ) // "_abopdep_col" // TRIM(band_suffix(nl))
          asymdep_names(n) =   &
             TRIM(names(n) ) // "_asymdep" // TRIM(band_suffix(nl))
          asymdep_column_names(n) =   &
             TRIM(names(n) ) // "_asymdep_col" // TRIM(band_suffix(nl))
        end do
        do n = 1,naerosol
          id_extopdep(n,nl)    = &
             register_diag_field (mod_name, TRIM(extopdep_names(n)), axes(1:3), &
                                  Time, TRIM(extopdep_names(n)),&
                                  'dimensionless', missing_value=missing_value)
          id_extopdep_column(n,nl)    = &
             register_diag_field (mod_name,   &
                      TRIM(extopdep_column_names(n)), axes(1:2), Time, &
                      TRIM(extopdep_column_names(n)), &
                      'dimensionless', missing_value=missing_value)
          id_absopdep(n,nl)    = &
             register_diag_field (mod_name, TRIM(absopdep_names(n)), axes(1:3), &
                                  Time, TRIM(absopdep_names(n)),&
                                  'dimensionless', missing_value=missing_value)
          id_absopdep_column(n,nl)    = &
             register_diag_field (mod_name,   &
                      TRIM(absopdep_column_names(n)), axes(1:2), Time, &
                      TRIM(absopdep_column_names(n)), &
                      'dimensionless', missing_value=missing_value)
          id_asymdep(n,nl)    = &
             register_diag_field (mod_name, TRIM(asymdep_names(n)), axes(1:3),&
                                  Time, TRIM(asymdep_names(n)),&
                                  'dimensionless', missing_value=missing_value)
          id_asymdep_column(n,nl)    = &
             register_diag_field (mod_name,   &
                      TRIM(asymdep_column_names(n)), axes(1:2), Time, &
                      TRIM(asymdep_column_names(n)), &
                      'dimensionless', missing_value=missing_value)
        end do
      end do
        deallocate (extopdep_names)
        deallocate (extopdep_column_names)
        deallocate (absopdep_names)
        deallocate (absopdep_column_names)
        deallocate (asymdep_names)
        deallocate (asymdep_column_names)
      endif

      if (size(family_names(:)) /= 0) then
        nfamilies = size(family_names(:))
        allocate (id_aerosol_fam(nfamilies))
        allocate (id_aerosol_fam_column(nfamilies)) 
        allocate (aerosol_fam_column_names(naerosol))
        do n=1,nfamilies      
          aerosol_fam_column_names(n) = TRIM(family_names(n) ) // "_col"
        end do
        do n = 1,nfamilies
          id_aerosol_fam(n)    = &
             register_diag_field (mod_name, TRIM(family_names(n)), axes(1:3), &
                                  Time, TRIM(family_names(n)),&
                                  'kg/m3', missing_value=missing_value)
          id_aerosol_fam_column(n)    = &
             register_diag_field (mod_name,   &
                      TRIM(aerosol_fam_column_names(n)), axes(1:2), Time, &
                      TRIM(aerosol_fam_column_names(n)), &
                      'kg/m2', missing_value=missing_value)
        end do
        deallocate (aerosol_fam_column_names)


        allocate (id_extopdep_fam(nfamilies, N_DIAG_BANDS))
        allocate (id_extopdep_fam_column(nfamilies, N_DIAG_BANDS))
        allocate (id_absopdep_fam(nfamilies, N_DIAG_BANDS))
        allocate (id_absopdep_fam_column(nfamilies, N_DIAG_BANDS))
        allocate (extopdep_fam_names(naerosol))
        allocate (extopdep_fam_column_names(naerosol))
        allocate (absopdep_fam_names(naerosol))
        allocate (absopdep_fam_column_names(naerosol))
        allocate (id_asymdep_fam(nfamilies, N_DIAG_BANDS))
        allocate (id_asymdep_fam_column(nfamilies, N_DIAG_BANDS))
        allocate (asymdep_fam_names(naerosol))
        allocate (asymdep_fam_column_names(naerosol))
   do nl=1,N_DIAG_BANDS
        do n=1,nfamilies      
          extopdep_fam_names(n) =   &
           TRIM(family_names(n) ) // "_exopdep" // TRIM(band_suffix(nl))
          extopdep_fam_column_names(n) =   &
       TRIM(family_names(n) ) // "_exopdep_col" // TRIM(band_suffix(nl))
          absopdep_fam_names(n) =   &
          TRIM(family_names(n) ) // "_abopdep" // TRIM(band_suffix(nl))
          absopdep_fam_column_names(n) =  &
       TRIM(family_names(n) ) // "_abopdep_col" // TRIM(band_suffix(nl))
          asymdep_fam_names(n) =   &
          TRIM(family_names(n) ) // "_asymdep" // TRIM(band_suffix(nl))
          asymdep_fam_column_names(n) =  &
       TRIM(family_names(n) ) // "_asymdep_col" // TRIM(band_suffix(nl))
        end do
        do n = 1,nfamilies
          id_extopdep_fam(n,nl)    = &
             register_diag_field (mod_name, TRIM(extopdep_fam_names(n)), axes(1:3), &
                                  Time, TRIM(extopdep_fam_names(n)),&
                                  'dimensionless', missing_value=missing_value)
          id_extopdep_fam_column(n,nl)    = &
             register_diag_field (mod_name,   &
                      TRIM(extopdep_fam_column_names(n)), axes(1:2), Time, &
                      TRIM(extopdep_fam_column_names(n)), &
                      'dimensionless', missing_value=missing_value)
          id_absopdep_fam(n,nl)    = &
             register_diag_field (mod_name, TRIM(absopdep_fam_names(n)), axes(1:3), &
                                  Time, TRIM(absopdep_fam_names(n)),&
                                  'dimensionless', missing_value=missing_value)
          id_absopdep_fam_column(n,nl)    = &
             register_diag_field (mod_name,   &
                      TRIM(absopdep_fam_column_names(n)), axes(1:2), Time, &
                      TRIM(absopdep_fam_column_names(n)), &
                      'dimensionless', missing_value=missing_value)
          id_asymdep_fam(n,nl)    = &
             register_diag_field(mod_name,TRIM(asymdep_fam_names(n)),axes(1:3),&
                      Time, TRIM(asymdep_fam_names(n)),&
                     'dimensionless', missing_value=missing_value)
          id_asymdep_fam_column(n,nl)    = &
             register_diag_field (mod_name,   &
                      TRIM(asymdep_fam_column_names(n)), axes(1:2), Time, &
                      TRIM(asymdep_fam_column_names(n)), &
                      'dimensionless', missing_value=missing_value)
        end do
   end do
        deallocate (extopdep_fam_names)
        deallocate (extopdep_fam_column_names)
        deallocate (absopdep_fam_names)
        deallocate (absopdep_fam_column_names)
        deallocate (asymdep_fam_names)
        deallocate (asymdep_fam_column_names)
      endif
      
      if (Rad_control%volcanic_lw_aerosols_iz) then
        if (Rad_control%volcanic_lw_aerosols) then
          id_lw_extopdep_vlcno_column(1) = &
             register_diag_field (mod_name,   &
                    'lw_b5_extopdep_vlcno_c', axes(1:2), Time, &
                    'lw 900-990 band column volcanic extopdep',  &
                      'dimensionless', missing_value=missing_value)
          id_lw_absopdep_vlcno_column(1)    = &
             register_diag_field (mod_name,   &
                    'lw_b5_absopdep_vlcno_c', axes(1:2), Time, &
                    'lw 900-990 band column volcanic absopdep',  &
                      'dimensionless', missing_value=missing_value)
          id_lwext_vlcno(1)    = &
             register_diag_field (mod_name,   &
                    'bnd5_extopdep_vlcno', axes(1:3), Time, &
                    '900-990 band volcanic lw extopdep  ',  &
                      'dimensionless', missing_value=missing_value)
          id_lw_xcoeff_vlcno(1)    = &
             register_diag_field (mod_name,   &
                    'bnd5_lwext_vlcno', axes(1:3), Time, &
                    '900-990 band volcanic lw extinction',  &
                      'meter**(-1)  ', missing_value=missing_value)
          id_lwssa_vlcno(1)    = &
             register_diag_field (mod_name,   &
                    'bnd5_lwssa_vlcno', axes(1:3), Time, &
                    '900-990   band volcanic lw scattering albedo', &
                      'dimensionless', missing_value=missing_value)
          id_lwasy_vlcno(1)    = &
             register_diag_field (mod_name,   &
                    'bnd5_lwasy_vlcno', axes(1:3), Time, &
                    '900-990 band volcanic lw asymmetry',  &
                      'dimensionless', missing_value=missing_value)
          id_lw_extopdep_vlcno_column(2) = &
             register_diag_field (mod_name,   &
                    'bnd6_extopdep_vlcno_c', axes(1:2), Time, &
                    '990-1070 column volcanic extopdep',  &
                      'dimensionless', missing_value=missing_value)
          id_lw_absopdep_vlcno_column(2)    = &
             register_diag_field (mod_name,   &
                    'bnd6_absopdep_vlcno_c', axes(1:2), Time, &
                    '990-1070 column volcanic absopdep',  &
                      'dimensionless', missing_value=missing_value)
          id_lwext_vlcno(2)    = &
             register_diag_field (mod_name,   &
                    'bnd6_extopdep_vlcno', axes(1:3), Time, &
                    '990-1070 volcanic lw extopdep  ',  &
                      'dimensionless', missing_value=missing_value)
          id_lw_xcoeff_vlcno(2)    = &
             register_diag_field (mod_name,   &
                    'bnd6_lwext_vlcno', axes(1:3), Time, &
                    '990-1070 volcanic lw extinction',  &
                      'meter**(-1)  ', missing_value=missing_value)
          id_lwssa_vlcno(2)    = &
             register_diag_field (mod_name,   &
                    'bnd6_lwssa_vlcno', axes(1:3), Time, &
                    '990-1070 volcanic lw scattering albedo',  &
                      'dimensionless', missing_value=missing_value)
          id_lwasy_vlcno(2)    = &
             register_diag_field (mod_name,   &
                    'bnd6_lwasy_vlcno', axes(1:3), Time, &
                    '990-1070 volcanic lw asymmetry',  &
                      'dimensionless', missing_value=missing_value)
        endif
      else 
        call error_mesg ('rad_output_file_mod', &
            'Rad_control%volcanic_lw_aerosols not yet defined', FATAL)
      endif
      if (Rad_control%volcanic_sw_aerosols_iz) then
        if (Rad_control%volcanic_sw_aerosols) then
          id_extopdep_vlcno_column(1) = &
             register_diag_field (mod_name,   &
                    'vis_extopdep_vlcno_c', axes(1:2), Time, &
                    'visband column volcanic extopdep',  &
                      'dimensionless', missing_value=missing_value)
          id_absopdep_vlcno_column(1)    = &
             register_diag_field (mod_name,   &
                    'vis_absopdep_vlcno_c', axes(1:2), Time, &
                    'visband column volcanic absopdep',  &
                      'dimensionless', missing_value=missing_value)
          id_swext_vlcno(1)    = &
             register_diag_field (mod_name,   &
                    'visband_swextopdep_vlcno', axes(1:3), Time, &
                    'visband volcanic sw extopdep  ',  &
                      'dimensionless', missing_value=missing_value)
          id_sw_xcoeff_vlcno(1)    = &
             register_diag_field (mod_name,   &
                    'visband_swext_vlcno', axes(1:3), Time, &
                    'visband volcanic sw extinction',  &
                      'meter**(-1)', missing_value=missing_value)
          id_swssa_vlcno(1)    = &
             register_diag_field (mod_name,   &
                    'visband_swssa_vlcno', axes(1:3), Time, &
                    'visband volcanic sw scattering albedo',  &
                      'dimensionless', missing_value=missing_value)
          id_swasy_vlcno(1)    = &
             register_diag_field (mod_name,   &
                    'visband_swasy_vlcno', axes(1:3), Time, &
                    'visband volcanic sw asymmetry',  &
                      'dimensionless', missing_value=missing_value)
          id_extopdep_vlcno_column(2) = &
             register_diag_field (mod_name,   &
                    'nir_extopdep_vlcno_c', axes(1:2), Time, &
                    'nirband column volcanic extopdep',  &
                      'dimensionless', missing_value=missing_value)
          id_absopdep_vlcno_column(2)    = &
             register_diag_field (mod_name,   &
                    'nir_absopdep_vlcno_c', axes(1:2), Time, &
                    'nirband column volcanic absopdep',  &
                      'dimensionless', missing_value=missing_value)
          id_swext_vlcno(2)    = &
             register_diag_field (mod_name,   &
                    'nirband_swextopdep_vlcno', axes(1:3), Time, &
                    'nirband volcanic sw extopdep  ',  &
                      'dimensionless', missing_value=missing_value)
          id_sw_xcoeff_vlcno(2)    = &
             register_diag_field (mod_name,   &
                    'nirband_swext_vlcno', axes(1:3), Time, &
                    'nirband volcanic sw extinction',  &
                      'meter**(-1)', missing_value=missing_value)
          id_swssa_vlcno(2)    = &
             register_diag_field (mod_name,   &
                    'nirband_swssa_vlcno', axes(1:3), Time, &
                    'nirband volcanic sw scattering albedo',  &
                      'dimensionless', missing_value=missing_value)
          id_swasy_vlcno(2)    = &
             register_diag_field (mod_name,   &
                    'nirband_swasy_vlcno', axes(1:3), Time, &
                    'nirband volcanic sw asymmetry',  &
                      'dimensionless', missing_value=missing_value)
          id_swheat_vlcno    = &
             register_diag_field (mod_name,   &
                    'sw_heating_vlcno', axes(1:3), Time, &
                    'sw heating due to vlcnic aero',  &
                      'deg K per day', missing_value=missing_value)
        endif
      else 
        call error_mesg ('rad_output_file_mod', &
           'Rad_control%volcanic_sw_aerosols not yet defined', FATAL)
      endif


      id_cmxolw = &
         register_diag_field (mod_name, 'cmxolw', axes(1:3), Time, &
                          'maximum overlap cloud amount', &
                          'percent', missing_value=missing_value)

      id_crndlw = &
         register_diag_field (mod_name, 'crndlw', axes(1:3), Time, &
                          'random overlap cloud amount', &
                          'percent', missing_value=missing_value)

      id_flxnet = &
         register_diag_field (mod_name, 'flxnet', bxes(1:3), Time, &
                          'net longwave radiative flux', &
                          'W/m**2', missing_value=missing_value)

      id_fsw    = &
         register_diag_field (mod_name, 'fsw', bxes(1:3), Time, &
                          'net shortwave radiative flux', &
                          'W/m**2', missing_value=missing_value)

      id_ufsw   = &
         register_diag_field (mod_name, 'ufsw', bxes(1:3), Time, &
                          'upward shortwave radiative flux ', &
                          'W/m**2', missing_value=missing_value)

      id_dfsw   = &
         register_diag_field (mod_name, 'dfsw', bxes(1:3), Time, &
                          'downward shortwave radiative flux ', &
                          'W/m**2', missing_value=missing_value)

      id_psj    = &
         register_diag_field (mod_name, 'psj', axes(1:2), Time, &
                          'surface pressure', &
                          'Pa', missing_value=missing_value)

      id_tmpsfc = &
         register_diag_field (mod_name, 'tmpsfc', axes(1:2), Time, &
                          'surface temperature', &
                          'deg_K', missing_value=missing_value)

      id_cvisrfgd_dir = &
         register_diag_field (mod_name, 'cvisrfgd_dir', axes(1:2), Time , &
                         'direct visible surface albedo', &
                        'dimensionless', missing_value=missing_value)

       id_cvisrfgd_dif = &
       register_diag_field (mod_name, 'cvisrfgd_dif', axes(1:2), Time, &
                          'diffuse visible surface albedo', &
                          'dimensionless', missing_value=missing_value)
 
       id_cirrfgd_dir = &
        register_diag_field (mod_name, 'cirrfgd_dir', axes(1:2), Time, &
                       'direct infra-red surface albedo', &
                       'dimensionless', missing_value=missing_value)

       id_cirrfgd_dif = &
         register_diag_field (mod_name, 'cirrfgd_dif', axes(1:2), Time, &
                       'diffuse infra-red surface albedo', &
                      'dimensionless', missing_value=missing_value)

       id_lw_bdyflx(1) = &
         register_diag_field (mod_name, 'olr_800_1200', axes(1:2), Time, &
                       'olr in 800_1200  band', &
                      'W/m**2', missing_value=missing_value)

       id_lw_bdyflx(2) = &
         register_diag_field (mod_name, 'olr_900_990', axes(1:2), Time, &
                       'olr in 800_900  band', &
                      'W/m**2', missing_value=missing_value)

       id_lw_bdyflx(3) = &
         register_diag_field (mod_name, 'sfc_800_1200', axes(1:2),&
                             Time, 'lw sfc flx in 800_1200  band', &
                      'W/m**2', missing_value=missing_value)

       id_lw_bdyflx(4) = &
         register_diag_field (mod_name, 'sfc_900_990', axes(1:2), &
                              Time, 'lw sfc flx in 900_990 band', &
                      'W/m**2', missing_value=missing_value)

       id_sw_bdyflx(1) = &
         register_diag_field (mod_name, 'swup_toa_vis', axes(1:2),  &
                       Time, &
                       'sw up flx in vis band at toa', &
                      'W/m**2', missing_value=missing_value)

       id_sw_bdyflx(2) = &
         register_diag_field (mod_name, 'swup_toa_1p6', axes(1:2),  &
                       Time, &
                       'sw up flx in 1.6 micron band at toa', &
                      'W/m**2', missing_value=missing_value)

       id_sw_bdyflx(3) = &
         register_diag_field (mod_name, 'swnt_sfc_vis', axes(1:2),  &
                       Time, &
                       'net sw flx in vis band at sfc', &
                      'W/m**2', missing_value=missing_value)

       id_sw_bdyflx(4) = &
         register_diag_field (mod_name, 'swnt_sfc_1p6', axes(1:2),  &
                       Time, &
                       'net sw flx in 1.6 micron band at sfc', &
                      'W/m**2', missing_value=missing_value)

!-------------------------------------------------------------------
!    verify that Rad_control%do_totcld_forcing has been initialized.
!-------------------------------------------------------------------
      if (Rad_control%do_totcld_forcing_iz) then
      else
        call error_mesg ('rad_output_file_mod', &
         ' attempting to use Rad_control%do_totcld_forcing before'//&
                                                ' it is set', FATAL)
      endif

      if (Rad_control%do_totcld_forcing) then
        id_radswpcf = &
           register_diag_field (mod_name, 'radswpcf', axes(1:3), Time, &
                            'temperature forcing from sw w/o clouds', &
                            'deg_K/sec', missing_value=missing_value)

        id_radpcf = &
           register_diag_field (mod_name, 'radpcf', axes(1:3), Time, &
                            'temperature forcing w/o clouds', &
                            'deg_K/sec', missing_value=missing_value)

        id_flxnetcf = &
           register_diag_field (mod_name, 'flxnetcf', bxes(1:3), Time, &
                            'net longwave flux w/o clouds', &
                            'W/m**2', missing_value=missing_value)

        id_fswcf = &
           register_diag_field (mod_name, 'fswcf', bxes(1:3), Time, &
                            'net shortwave flux w/o clouds', &
                            'W/m**2', missing_value=missing_value)

        id_ufswcf   = &
           register_diag_field (mod_name, 'ufswcf', bxes(1:3), Time, &
                            'upward shortwave flux w/o clouds', &
                            'W/m**2', missing_value=missing_value)

        id_dfswcf   = &
           register_diag_field (mod_name, 'dfswcf', bxes(1:3), Time, &
                            'downward shortwave flux w/o clouds', &
                            'W/m**2', missing_value=missing_value)

       id_lw_bdyflx_clr(1) = &
         register_diag_field (mod_name, 'olr_800_1200_cf', axes(1:2), Time, &
                       'clr sky olr in 800_1200  band', &
                      'W/m**2', missing_value=missing_value)

       id_lw_bdyflx_clr(2) = &
         register_diag_field (mod_name, 'olr_900_990_cf', axes(1:2), Time, &
                       'clr sky olr in 800_900  band', &
                      'W/m**2', missing_value=missing_value)

       id_lw_bdyflx_clr(3) = &
         register_diag_field (mod_name, 'sfc_800_1200_cf', axes(1:2),&
                             Time, 'clr sky lw sfc flx in 800_1200 band', &
                      'W/m**2', missing_value=missing_value)

       id_lw_bdyflx_clr(4) = &
         register_diag_field (mod_name, 'sfc_900_990_cf', axes(1:2), &
                              Time, 'clr sky lw sfc flx in 900_990 band', &
                      'W/m**2', missing_value=missing_value)

       id_sw_bdyflx_clr(1) = &
         register_diag_field (mod_name, 'swup_toa_vis_cf', axes(1:2),  &
                       Time, &
                       'clr sky sw up flx in vis band at toa', &
                      'W/m**2', missing_value=missing_value)

       id_sw_bdyflx_clr(2) = &
         register_diag_field (mod_name, 'swup_toa_1p6_cf', axes(1:2),  &
                       Time, &
                       'clr sky sw up flx in 1.6 micron band at toa', &
                      'W/m**2', missing_value=missing_value)

       id_sw_bdyflx_clr(3) = &
         register_diag_field (mod_name, 'swnt_sfc_vis_cf', axes(1:2),  &
                       Time, &
                       'clr sky net sw flx in vis band at sfc', &
                      'W/m**2', missing_value=missing_value)

       id_sw_bdyflx_clr(4) = &
         register_diag_field (mod_name, 'swnt_sfc_1p6_cf', axes(1:2),  &
                       Time, &
                       'clr sky net sw flx in 1.6 micron band at sfc', &
                      'W/m**2', missing_value=missing_value)

      endif

!---------------------------------------------------------------------


end subroutine register_fields


!####################################################################





                  end module rad_output_file_mod

!FDOC_TAG_GFDL
module microphys_cloud_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   
! </CONTACT>
! <REVIEWER EMAIL="">
!   
! </REVIEWER>
! <OVERVIEW>
!   
! </OVERVIEW>
! <DESCRIPTION>
!   
! </DESCRIPTION>
!

!-----------------------------------------------------------------------
! module information
!-----------------------------------------------------------------------

use mpp_mod, only: input_nml_file
use fms_mod, only: open_namelist_file, mpp_pe,          &
                   mpp_root_pe, stdlog, fms_init,       &
                   write_version_number, file_exist,    &
                   check_nml_error, close_file

!-----------------------------------------------------------------------
! public interfaces
!-----------------------------------------------------------------------

implicit none
private

public microphys_cloud, microphys_cloud_init, microphys_cloud_end

integer :: idim, jdim, kdim

!namelist:
!real :: diam_liq = 40.0  ! vtp
real :: diam_liq = 33.2

namelist /microphys_cloud_nml/  diam_liq

!-----------------------------------------------------------------------
! version control information
!-----------------------------------------------------------------------

character(len=128)  :: version =  '$Id: microphys_cloud.F90,v 19.0 2012/01/06 20:19:43 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'

logical ::   module_is_initialized = .false.
contains 

!#######################################################################

! <SUBROUTINE NAME="microphys_cloud">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call microphys_cloud ( zhalf, zfull, diam_liq_out, diam_ice)
!
!  </TEMPLATE>
!  <IN NAME="zhalf" TYPE="real">
! 
!  </IN>
!  <IN NAME="zfull" TYPE="real">
! 
!  </IN>
!  <OUT NAME="diam_liq_out" TYPE="real">
! 
!  </OUT>
!  <OUT NAME="diam_ice" TYPE="real">
! 
!  </OUT>
! </SUBROUTINE>
!
subroutine microphys_cloud ( zhalf, zfull, diam_liq_out, diam_ice)

real,    dimension(:,:,:),    intent(in)        :: zhalf, zfull
real,    dimension(:,:,:),    intent(out)       :: diam_liq_out,  &
                                                   diam_ice

!-----------------------------------------------------------------------
!   intent(in) variables:
!
!      zhalf        height asl at half levels [m]
!      zfull        height asl at full levels [m]
!
!   intent(out):
!
!      diam_liq
!      diam_ice
!
!----------------------------------------------------------------------

!-----------------------------------------------------------------------
! local allocations
!-----------------------------------------------------------------------

  idim = size (zfull,1)
  jdim = size (zfull,2)
  kdim = size (zfull,3)

  call get_diam ( zhalf, zfull, diam_ice )
  diam_liq_out = diam_liq

end subroutine microphys_cloud

!#######################################################################

! <SUBROUTINE NAME="get_diam">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call get_diam ( zhalf, zfull, diam )
!
!  </TEMPLATE>
!  <IN NAME="zhalf" TYPE="real">
! 
!  </IN>
!  <IN NAME="zfull" TYPE="real">
! 
!  </IN>
!  <OUT NAME="diam" TYPE="real">
! 
!  </OUT>
! </SUBROUTINE>
!
subroutine get_diam ( zhalf, zfull, diam )

real, dimension(:,:,:), intent(in)  :: zhalf
real, dimension(:,:,:), intent(in)  :: zfull
real, dimension(:,:,:), intent(out) :: diam

!-----------------------------------------------------------------------
! local allocations
!-----------------------------------------------------------------------

real, dimension(size(zfull,3)+1) :: relht

real :: slope, zref
integer :: i, j, k

  relht(kdim+1) = 0.0

  do i=1,idim
     do j=1,jdim

       zref = zhalf(i,j,kdim+1) + 9.9e3
       relht(1:kdim) = max(0.0, min(1.0, (zfull(i,j,:) - zref)/3.3e3 ))

        k = kdim+1
        do while ( relht(k) < 0.30 .and. k > 1 )
           k=k-1
           slope = (30.72 - 38.50)/(0.30 - 0.00)
           diam(i,j,k) = 38.50 + (relht(k) - 0.00) * slope
        enddo

        do while ( relht(k) < 0.45 .and. k > 1 )
           k=k-1
           slope = (28.28 - 30.72)/(0.45 - 0.30)
           diam(i,j,k) = 30.72 + (relht(k) - 0.30) * slope
        enddo

        do while ( relht(k) < 0.64 .and. k > 1 )
           k=k-1
           slope = (25.62 - 28.28)/(0.64 - 0.45)
           diam(i,j,k) = 28.28 + (relht(k) - 0.45) * slope
        enddo

        do while ( relht(k) < 0.76 .and. k > 1 )
           k=k-1
           slope = (24.80 - 25.62)/(0.76 - 0.64)
           diam(i,j,k) = 25.62 + (relht(k) - 0.64) * slope
        enddo

        do while ( k > 1 ) 
           k=k-1
!           slope = (13.30 - 24.80)/(1.00 - 0.76)                              !vtp
           slope = (18.60 - 24.80)/(1.00 - 0.76)
           diam(i,j,k) = 24.80 + (relht(k) - 0.76) * slope
        enddo

     enddo
  enddo

  return
end subroutine get_diam

!#######################################################################

! <SUBROUTINE NAME="microphys_cloud_init">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call microphys_cloud_init
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine microphys_cloud_init

integer :: unit, ierr, io, logunit

   if (module_is_initialized ) return
   call fms_init

!-----------------------------------------------------------------------
! read namelist       
!-----------------------------------------------------------------------

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=microphys_cloud_nml, iostat=io)
  ierr = check_nml_error(io,"microphys_cloud_nml")
#else
  if (file_exist('input.nml')) then
     unit =  open_namelist_file ( )
     ierr=1; do while (ierr /= 0)
     read (unit, nml=microphys_cloud_nml, iostat=io, end=10) 
     ierr = check_nml_error (io, 'microphys_cloud_nml')
     enddo                       
10   call close_file (unit)      
  endif                         
#endif
                                    
!------------------------------------------------------------------------
!  write version number and namelist to logfile.
!------------------------------------------------------------------------

  call write_version_number(version, tagname)
  logunit = stdlog()
  if (mpp_pe() == mpp_root_pe() )                                       &
                                write (logunit, nml=microphys_cloud_nml)

   module_is_initialized = .true.

  return
end subroutine microphys_cloud_init

!#######################################################################
subroutine microphys_cloud_end

   module_is_initialized = .true.

  return
end subroutine microphys_cloud_end

!#######################################################################

end module microphys_cloud_mod

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
!                                                                              !
!                       THREE-LAYER VERTICAL THERMODYNAMICS                    !
!                                                                              !
! Reference:  M. Winton, 2000: "A reformulated three-layer sea ice model",     !
!            Journal of Atmospheric and Oceanic Technology, 17, 525-531.       !
!                                                                              !
!                                                                              !
!        -> +---------+ <- ts - diagnostic surface temperature ( <= 0C )       !
!       /   |         |                                                        !
!     hs    |  snow   | <- 0-heat capacity snow layer                          !
!       \   |         |                                                        !
!        => +---------+                                                        !
!       /   |         |                                                        !
!      /    |         | <- t1 - upper 1/2 ice temperature; this layer has      !
!     /     |         |         a variable (T/S dependent) heat capacity       !
!   hi      |...ice...|                                                        !
!     \     |         |                                                        !
!      \    |         | <- t2 - lower 1/2 ice temp. (fixed heat capacity)      !
!       \   |         |                                                        !
!        -> +---------+ <- base of ice fixed at seawater freezing temp.        !
!                                                                              !
!                                         Mike Winton (Michael.Winton)!
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!

! TK mod:  SLAB_ICE treatment modified to follow supersource
!          (after Bryan 1969).  The conductive heat
!           flux from ice to atmosphere is computed based on 
!           an effective ice thickness which ensures a minimum 
!           thickness of 1.7cm for the calculation.

module ice_thm_mod

use constants_mod, only : LI => hlf ! latent heat of fusion - 334e3 J/(kg-ice)

implicit none
private
public :: DS, DI, DW, MU_TS, TFI, ice_optics, ice3lay_temp, ice3lay_resize, &
          thm_pack, thm_unpack, ice_thm_param, e_to_melt
!
! properties of ice, snow, and seawater (NCAR CSM values)
!

real            :: KS    = 0.31      ! conductivity of snow - 0.31 W/(mK)
real, parameter :: DS    = 330.0     ! density of snow - 330 kg/(m^3)
real, parameter :: KI    = 2.03      ! conductivity of ice  - 2.03 W/(mK)
real, parameter :: DI    = 905.0     ! density of ice  - 905 kg/(m^3)
real, parameter :: CI    = 21e2      ! heat cap. of fresh ice - 2100 J/(kg K)
real, parameter :: SI    = 1.0       ! salinity of sea ice
real, parameter :: MU_TS = 0.054     ! relates freezing temp. to salinity
real, parameter :: TFI   = -MU_TS*SI ! sea ice freezing temp. = -mu*salinity
real, parameter :: CW    = 4.2e3     ! heat capacity of seawater
real, parameter :: DW    = 1030.0    ! density of water for waterline - kg/(m^3)

! albedos are from CSIM4 assumming 0.53 visible and 0.47 near-ir insolation
real            :: ALB_SNO = 0.85       ! albedo of snow (not melting)
real            :: ALB_ICE = 0.5826     ! albedo of ice (not melting)
real            :: PEN_ICE = 0.3        ! ice surface penetrating solar fraction
real            :: OPT_DEP_ICE = 0.67   ! ice optical depth (m)
real            :: T_RANGE_MELT = 1.0   ! melt albedos scaled in below melting T

real            :: H_LO_LIM = 0.0       ! hi/hs lower limit for temp. calc.
logical         :: SLAB_ICE = .false.   ! should we do old style GFDL slab ice?
!
! slab ice specific parameters
!
real, parameter :: CRIT_THICKNESS       = 1.00   
real, parameter :: T_RANGE              = 10.0
real, parameter :: MIN_ICE_ALB          = 0.55   ! coupled model uses 0.55
real, parameter :: MAX_ICE_ALB          = 0.80
real, parameter :: ALB_OCEAN            = 0.10

!
logical         :: CM2_BUGS = .false.   ! keep cm2 bugs for reproducibility

contains

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! ice_thm_param - set ice thermodynamic parameters                             !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
subroutine ice_thm_param(alb_sno_in, alb_ice_in, pen_ice_in, opt_dep_ice_in, &
                         slab_ice_in, t_range_melt_in, cm2_bugs_in, ks_in, &
                         h_lo_lim_in                                          )
    real, intent(in)      :: alb_sno_in, alb_ice_in, pen_ice_in 
    real, intent(in)      :: opt_dep_ice_in, t_range_melt_in
logical, intent(in)   :: slab_ice_in
logical, intent(in)   :: cm2_bugs_in
    real, intent(in)   :: ks_in
    real, intent(in)   :: h_lo_lim_in

  ALB_SNO     = alb_sno_in
  ALB_ICE     = alb_ice_in
  PEN_ICE     = pen_ice_in
  OPT_DEP_ICE = opt_dep_ice_in
  SLAB_ICE    = slab_ice_in
  T_RANGE_MELT = t_range_melt_in

  CM2_BUGS    = cm2_bugs_in
  KS          = ks_in
  H_LO_LIM    = h_lo_lim_in

end subroutine ice_thm_param

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! ice_optics - set albedo, penetrating solar, and ice/snow transmissivity      !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
subroutine ice_optics(alb, pen, trn, hs, hi, ts, tfw)
real, intent(  out) :: alb ! ice surface albedo (0-1)
real, intent(  out) :: pen ! fraction of down solar penetrating the ice
real, intent(  out) :: trn ! ratio of down solar at bottom to top of ice
real, intent(in   ) :: hs  ! snow thickness (m-snow)
real, intent(in   ) :: hi  ! ice thickness (m-ice)
real, intent(in   ) :: ts  ! surface temperature
real, intent(in   ) :: tfw ! seawater freezing temperature
real :: as, ai, cs
real :: thick_ice_alb, tcrit, fh


  if (SLAB_ICE) then
    tcrit = tfw - T_RANGE
       if (ts <= tcrit) then
          thick_ice_alb = MAX_ICE_ALB
       else if (ts >= tfw) then
          thick_ice_alb = MIN_ICE_ALB
       else
      thick_ice_alb = MAX_ICE_ALB + (MIN_ICE_ALB-MAX_ICE_ALB)*(ts-tcrit)/T_RANGE
       endif
  
       if (hi >= crit_thickness) then
          alb = THICK_ICE_ALB
       else
          alb = ALB_OCEAN + (thick_ice_alb-ALB_OCEAN)*sqrt(hi/CRIT_THICKNESS)
       endif

    pen = 0.0
    trn = 0.0

!! check for ice albdeos out of range (0 to 1)
!      if (alb.lt.0.0 .or.alb.gt.1.0) then
!         print *,'ice_optics: albedo out of range, alb_in=',alb_in, 'alb=',alb
!         print *,'ts=',ts,  'tfw=',tfw, 'tcrit=',tcrit
!         print *,'hi=',hi,  'thick_ice_alb=',thick_ice_alb
!         print *,'ALB_OCEAN=',ALB_OCEAN
!         print *,'MIN_ICE_ALB=',MIN_ICE_ALB, 'MAX_ICE_ALB=',MAX_ICE_ALB
!         print *,'T_RANGE,=',T_RANGE, 'CRIT_THICKNESS=',CRIT_THICKNESS
!         stop
!      end if
  
    return
  endif


!! 2007/04/11 Fix for thin ice negative ice albedos from Mike Winton
!!            Move ai calculation after if test

  as = ALB_SNO; ai = ALB_ICE
  cs = hs/(hs+0.02)                        ! thin snow partially covers ice

  fh = min(atan(5.0*hi)/atan(5.0*0.5),1.0) ! use this form from CSIM4 to
                                           ! reduce albedo for thin ice
  if (CM2_BUGS) then
    ai = fh*ai+(1-fh)*0.06                 ! reduce albedo for thin ice
    if (ts+T_RANGE_MELT > TFI) then        ! reduce albedo for melting as in
                                           ! CSIM4 assuming 0.53/0.47 vis/ir
       as = as-0.1235*min((ts+T_RANGE_MELT-TFI)/T_RANGE_MELT,1.0)
       ai = ai-0.075 *min((ts+T_RANGE_MELT-TFI)/T_RANGE_MELT,1.0)
    endif
  else
    if (ts+T_RANGE_MELT > TFI) then        ! reduce albedo for melting as in
                                           ! CSIM4 assuming 0.53/0.47 vis/ir
       as = as-0.1235*min((ts+T_RANGE_MELT-TFI)/T_RANGE_MELT,1.0)
       ai = ai-0.075 *min((ts+T_RANGE_MELT-TFI)/T_RANGE_MELT,1.0)
    endif
    ai = fh*ai+(1-fh)*0.06                 ! reduce albedo for thin ice
  end if

  alb = cs*as+(1-cs)*ai
  pen = (1-cs)*PEN_ICE
  trn = exp(-hi/OPT_DEP_ICE);

!! check for ice albdeos out of range (0 to 1)
! if (alb.lt.0.0 .or. alb.gt.1.0) then
!    print *,'ice_optics: albedo out of range, alb=',alb
!    print *,'cs=',cs,  'as=',as, 'ai=',ai
!    print *,'ts=',ts,  'fh=',fh, 'hs=',hs, 'hi=',hi, 'tfw=',tfw
!    print *,'ALB_SNO=',ALB_SNO,  'ALB_ICE=',ALB_ICE, 'T_RANGE_MELT,=',T_RANGE_MELT, 'TFI=',TFI
!    stop
! end if

  return

end subroutine ice_optics

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! ice3lay_temp - ice & snow temp. change [Winton (2000) section 2.a]           !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
subroutine ice3lay_temp(hs, hi, t1, t2, ts, A, B, I, tfw, fb, dt, tmelt, bmelt)
implicit none

real, intent(in   ) :: hs    ! snow thickness (m)
real, intent(in   ) :: hi    ! ice thickness (m)
real, intent(  out) :: ts    ! surface temperature (deg-C)
real, intent(inout) :: t1    ! upper ice temperature (deg-C)
real, intent(inout) :: t2    ! lower ice temperature (deg-C)
real, intent(in   ) :: A     ! net surface heat flux (+ up) at ts=0 (W/m^2)
real, intent(in   ) :: B     ! d(sfc heat flux)/d(ts) [W/(m^2 deg-C)]
real, intent(in   ) :: I     ! solar absorbed by upper ice (W/m^2)
real, intent(in   ) :: tfw   ! seawater freezing temperature (deg-C)
real, intent(in   ) :: fb    ! heat flux from ocean to ice bottom (W/m^2)
real, intent(in   ) :: dt    ! timestep (sec)
real, intent(inout) :: tmelt ! accumulated top melting energy  (J/m^2)
real, intent(inout) :: bmelt ! accumulated bottom melting energy (J/m^2)
!
! variables for temperature calculation [see Winton (1999) section II.A.]
! note:  here equations are multiplied by hi to improve thin ice accuracy
!
    real :: tsf, k12, hi2, a10, b10, a1, b1, c1
! TK Mods:
real :: hi_effective, hie
real :: KI_over_eps = 1.7065e-2     ! 5/2.93 from Bryan (1969); 
!                                 Value used in SS tsc.F (1.7065 cm) 
!                                  converted to meters...         

  if (SLAB_ICE) then
    hi_effective = hi + KI_over_eps     ! TK added
    ts = (KI*tfw-A*hi_effective)/(KI+B*hi_effective)     ! TK mod
    if (ts > 0.0) then       ! surface melting conditions
       ts = 0.0
       if (hi>0.0) tmelt = tmelt + (KI*tfw/hi_effective-A)*dt     ! TK mod
    endif
    if (hi>0.0) then
       bmelt = bmelt + (fb-KI*(tfw-ts)/hi_effective)*dt     ! TK mod
    else
       bmelt = bmelt + (fb-A-B*tfw)*dt
    endif
    return
  endif

  if (hs > 0.0) then
    TSF = 0.0
  else
    TSF = TFI
  endif

  hie = max(hi, H_LO_LIM); ! prevent thin ice inaccuracy (mw)

  !
  ! Compute upper ice and surface temperatures
  !
  K12 = 4*KI*KS/(KS+4*KI*hs/hie)
  hi2 = hie*hie

  A10 = DI*hi2*CI/(2*dt) + 2*KI*(4*dt*2*KI+DI*hi2*CI)/(6*dt*2*KI+DI*hi2*CI)
  B10 = -DI*hi2*(CI*t1+LI*TFI/t1)/(2*dt) - I*hie                       &
        -2*KI*(4*dt*2*KI*tfw+DI*hi2*CI*t2)/(6*dt*2*KI+DI*hi2*CI)

  A1 = A10+K12*B*hie/(K12+B*hie)
  B1 = B10+A*K12*hie/(K12+B*hie)
  C1  = DI*hi2*LI*TFI/(2*dt)
  t1 = -(sqrt(B1*B1-4*A1*C1)+B1)/(2*A1)
  ts = (K12*t1-A*hie)/(K12+B*hie)
   
  if (ts > tsf) then       ! slightly different equation for melting conditions
    A1 = A10+K12
    B1 = B10-K12*tsf
    t1 = -(sqrt(B1*B1-4*A1*C1)+B1)/(2*A1)
    ts = tsf
    tmelt = tmelt + (K12*(t1-ts)/hie-(A+B*ts))*dt
  endif
  !
  ! set lower ice temp. -- use tfw as reference for thin ice precision
  !
  t1 = t1-tfw; t2 = t2-tfw;
  t2 = (2*dt*2*KI*t1+DI*hi2*CI*t2)/(6*dt*2*KI+DI*hi2*CI)
  t1 = t1+tfw; t2 = t2+tfw;

  bmelt = bmelt + (fb+4*KI*(t2-tfw)/hie)*dt

  if (t2 > TFI) then ! put excess lower ice energy into bmelt
    bmelt = bmelt + e_to_melt(h2=hie/2,t2=TFI) - e_to_melt(h2=hie/2,t2=t2)
    t2 = TFI
  endif

  if (t1 > TFI) then ! put excess upper ice energy into tmelt
    tmelt = tmelt + e_to_melt(h1=hie/2,t1=TFI) - e_to_melt(h1=hie/2,t1=t1)
    t1 = TFI
  endif

! if (tmelt<0) then
!    print *,'neg. tmelt=',tmelt,ts,t1,hs,hi,K12*(t1-ts)/hi,-(A+B*ts)
!    print *,'K12=',K12
!    print *,'A/B/I=',A,B,I
!    print *,'A/B/C=',A1,B1,C1,A1*t1*t1+B1*t1+C1,A1*t1*t1,B1*t1,C1
!    stop
! end if
! call thm_checkout(ts, hs, hi, t1, t2, bmelt, tmelt)

  return
end subroutine ice3lay_temp

subroutine thm_checkout(ts, hs, hi, t1, t2, bmelt, tmelt)
    real, intent(in) :: ts, hs, hi, t1, t2, bmelt, tmelt

  if (ts>0 .or. t1>TFI .or. t2>0 .or. hs<0 .or. hs>100 .or. hi<0 .or. hi>100 &
           .or. abs(bmelt)>100*DI*LI .or. tmelt<0 .or. tmelt>100*DI*LI) then
      print *,'UNREASONABLE ICE: hs=',hs,'hi=',hi,'t1=',t1,'t2=',t2,'ts=', &
              ts,'tmelt=',tmelt,'bmelt=',bmelt
  end if
end subroutine thm_checkout

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! e_to_melt - energy needed to melt a given snow/ice configuration             !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
function e_to_melt(hs, h1, t1, h2, t2)
    real, intent(in), optional :: hs, h1, t1, h2, t2
    real                       :: e_to_melt

  e_to_melt = 0.0
  if (present(hs))              e_to_melt = e_to_melt+DS*LI*hs
  if (present(h1).and.present(t1)) then
                                e_to_melt = e_to_melt+DI*h1*(CI-LI/t1)*(TFI-t1)
  endif
  if (present(h2).and.present(t2)) then
                                e_to_melt = e_to_melt+DI*h2*(LI+CI*(TFI-t2))
  endif
end function e_to_melt

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! add_to_top - add some ice to the top ice layer                               !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
subroutine add_to_top(h, t, h1, t1)
    real,    intent(in) :: h, t
    real, intent(inout) :: h1, t1
    real                :: f1

  f1 = h1/(h1+h)
  t1 = f1*(t1+LI*TFI/(CI*t1))+(1-f1)*t
  t1 = (t1-sqrt(t1*t1-4*TFI*LI/CI))/2
  h1 = h1+h
  return
end subroutine add_to_top

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! add_to_bot - add some ice to the bottom ice layer                            !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
subroutine add_to_bot(h, t, h2, t2)
    real,    intent(in) :: h, t
    real, intent(inout) ::  h2, t2

  t2 = (h2*t2+h*t)/(h2+h)
  h2 = h2+h
  return
end subroutine add_to_bot

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! even_up - transfer mass/energy between ice layers to maintain equal thickness!
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
subroutine even_up(h1, t1, h2, t2)
    real,intent(inout) :: h1, t1, h2, t2
    real               :: dh

  if (h1 > (h1+h2)/2) then
    call add_to_bot(h1-(h1+h2)/2, t1+LI*TFI/(CI*t1), h2, t2)
    h1 = h2
  else if (h2 > (h1+h2)/2) then
    call add_to_top(h2-(h1+h2)/2, t2, h1, t1)
    h2 = h1
  endif
  if (t2>TFI) then                 ! use extra energy to melt both layers evenly
    dh = h2*CI*(t2-TFI)*t1/(LI*t1+(CI*t1-LI)*(TFI-t1))
    t2 = TFI
    h1 = h1-dh
    h2 = h2-dh
  endif
  return
end subroutine even_up

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! ice3lay_resize - ice & snow thickness change [Winton (1998) section II.B.]   !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
subroutine ice3lay_resize(hs, hi, t1, t2, snow, frazil, evap, tmelt, bmelt, &
                          tfw, heat_to_ocn, h2o_to_ocn, h2o_from_ocn,       &
                          snow_to_ice, bablt                                )
real, intent(inout) :: hs          ! snow thickness (m-snow)
real, intent(inout) :: hi          ! ice thickness (m-ice)
real, intent(inout) :: t1          ! temperature of upper ice (deg-C)
real, intent(inout) :: t2          ! temperature of lower ice (deg-C)
real, intent(in   ) :: snow        ! new snow (kg/m^2-snow)
real, intent(in   ) :: frazil      ! frazil in energy units
real, intent(in   ) :: evap        ! ice evaporation (kg/m^2)
real, intent(in   ) :: tmelt       ! top melting energy (J/m^2)
real, intent(in   ) :: bmelt       ! bottom melting energy (J/m^2)
real, intent(in   ) :: tfw         ! seawater freezing temperature (deg-C)
real, intent(  out) :: heat_to_ocn ! energy left after ice all melted (J/m^2)
real, intent(  out) :: h2o_to_ocn  ! liquid water flux to ocean (kg/m^2)
real, intent(  out) :: h2o_from_ocn! evaporation flux from ocean (kg/m^2)
real, intent(  out) :: snow_to_ice ! snow below waterline becomes ice
real, intent(  out), optional :: bablt ! bottom ablation (kg/m^2)

real h1, h2, dh, hw

  heat_to_ocn  = 0.0
  h2o_to_ocn   = DS*hs+DI*hi+snow-evap ! - from ice at end gives ocean h2o flux
  h2o_from_ocn = 0.0
  snow_to_ice  = 0.0

  if (SLAB_ICE) then
    !
    ! add snow and frazil
    !
    hi = hi + snow/DI + frazil/(DI*LI)
    t1 = tfw; t2 = tfw;
    !
    ! atmospheric evaporation
    !
    if (evap <= hi*DI) then
      hi = hi - evap/DI
    else
      h2o_from_ocn = evap-hi*DI
      hi = 0.0
    end if
    !
    ! ... melting
    !
    hi = hi - (tmelt+bmelt)/(DI*LI)
    if (hi<0.0) then
       heat_to_ocn = -hi*DI*LI
       hi = 0.0
    else
       heat_to_ocn = 0.0
    endif
  
    h2o_to_ocn = h2o_to_ocn+h2o_from_ocn ! reset mark for leftover evap thru ice
    h2o_to_ocn = h2o_to_ocn-DI*hi-DS*hs  ! hs should be zero
    if (present(bablt)) bablt = bmelt/LI
    return
  endif

  h1 = hi/2
  h2 = hi/2
  !
  ! add snow ...
  !
  hs = hs + snow/DS
  !
  ! ... and frazil
  !
  call add_to_bot(frazil/e_to_melt(h2=1.0,t2=tfw), tfw, h2, t2)
  !
  ! atmospheric evaporation
  !
  if (evap <= hs*DS) then
    hs = hs - evap/DS
  else if (evap-hs*DS<=h1*DI) then
    hs = 0.0
    h1 = h1-(evap-DS*hs)/DI
  else if (evap-hs*DS-h1*DI<=h2*DI) then
    hs = 0.0
    h1 = 0.0
    h2 = h2 - (evap-hs*DS-h1*DI)/DI
  else
    h2o_from_ocn = evap-hs*DS-(h1+h2)*DI
    hs = 0.0
    h1 = 0.0
    h2 = 0.0
  end if

  if (bmelt < 0.0) call add_to_bot(-bmelt/e_to_melt(h2=1.0,t2=tfw), tfw, h2, t2)

  if (h1 == 0.0) t1 = tfw  ! need this, below we divide by t1 even when h1 == 0

  !
  ! apply energy fluxes ... top ...
  !
  if (tmelt <= e_to_melt(hs)) then
    hs = hs - tmelt/e_to_melt(hs=1.0)
  else if (tmelt <= e_to_melt(hs,h1,t1)) then
    h1 = h1 - (tmelt-e_to_melt(hs))/e_to_melt(h1=1.0,t1=t1)
    hs = 0.0
  else if (tmelt <= e_to_melt(hs,h1,t1,h2,t2)) then
    h2 = h2 - (tmelt-e_to_melt(hs,h1,t1))/e_to_melt(h2=1.0,t2=t2)
    hs = 0.0
    h1 = 0.0
  else
   heat_to_ocn = heat_to_ocn+tmelt-e_to_melt(hs,h1,t1,h2,t2)
   hs = 0.0
   h1 = 0.0
   h2 = 0.0
  endif
  !
  ! ... and bottom
  !
  if (present(bablt)) bablt = DS*hs+DI*(h1+h2)
  if (bmelt > 0.0) then
    if (bmelt < e_to_melt(h2=h2,t2=t2)) then
      h2 = h2 - bmelt/e_to_melt(h2=1.0,t2=t2)
    else if (bmelt < e_to_melt(h1=h1,t1=t1,h2=h2,t2=t2)) then
      h1 = h1-(bmelt-e_to_melt(h2=h2,t2=t2))/e_to_melt(h1=1.0,t1=t1)
      h2 = 0.0
    else if (bmelt < e_to_melt(hs,h1,t1,h2,t2)) then
      hs = hs - (bmelt-e_to_melt(h1=h1,t1=t1,h2=h2,t2=t2))/e_to_melt(hs=1.0)
      h1 = 0.0
      h2 = 0.0
    else
      heat_to_ocn = heat_to_ocn+bmelt-e_to_melt(hs,h1,t1,h2,t2)
      hs = 0.0
      h1 = 0.0
      h2 = 0.0
    endif
  endif
  if (present(bablt)) bablt = bablt-DS*hs-DI*(h1+h2)

  hi = h1 + h2
  hw = (DI*hi+DS*hs)/DW
  if (hw>hi) then           ! convert snow to ice to maintain ice at waterline
    snow_to_ice = (hw-hi)*DI
    hs = hs - snow_to_ice/DS
    call add_to_top(hw-hi, TFI, h1, t1)
  endif

  call even_up(h1, t1, h2, t2)
  hi = h1+h2
  if (hi==0.0) then
    t1 = 0.0
    t2 = 0.0
  endif

  h2o_to_ocn = h2o_to_ocn+h2o_from_ocn ! correct mark for leftover evap thru ice
  h2o_to_ocn = h2o_to_ocn-DS*hs-DI*hi

  return
end subroutine ice3lay_resize

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! thm_pack - form conserved quantities for two-dimensional advection           !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
subroutine thm_pack(cn, hs, hi, t1, t2)
real, dimension(:,:,:), intent(inout) :: cn, hs, hi, t1, t2

    integer :: i, j, k
    real    :: tmp

    tmp = MU_TS*SI*LI/CI

    do k = 1, size(hi,3)
       do j = 1, size(hi,2)
          do i = 1, size(hi,1)
             if (hi(i,j,k)>0.0) then
                hi(i,j,k) = cn(i,j,k)*hi(i,j,k)
                hs(i,j,k) = cn(i,j,k)*hs(i,j,k)
                t1(i,j,k) = (t1(i,j,k)-tmp/t1(i,j,k))*hi(i,j,k)
                t2(i,j,k) = t2(i,j,k)*hi(i,j,k)
             else 
                cn(i,j,k) = 0.0
                hi(i,j,k) = 0.0
                hs(i,j,k) = 0.0
                t1(i,j,k) = 0.0
                t2(i,j,k) = 0.0
             endif
          enddo
       enddo
    enddo

  return

end subroutine thm_pack

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! thm_unpack - reform ice properties from advectively conserved quantities     !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
subroutine thm_unpack(cn, hs, hi, t1, t2)
real, dimension(:,:,:), intent(inout) :: cn, hs, hi, t1, t2
    integer :: i, j, k
    real    :: tmp

    tmp = 4*MU_TS*SI*LI/CI

    do k = 1, size(hi,3)
       do j = 1, size(hi,2)
          do i = 1, size(hi,1)
             if (hi(i,j,k)>0.0) then
                t1(i,j,k) = t1(i,j,k)/hi(i,j,k)
                t1(i,j,k) = 0.5*(t1(i,j,k)-sqrt(t1(i,j,k)*t1(i,j,k)+tmp))
                t2(i,j,k) = t2(i,j,k)/hi(i,j,k)
                hi(i,j,k) = hi(i,j,k)/cn(i,j,k)
                hs(i,j,k) = hs(i,j,k)/cn(i,j,k)
             else
                cn(i,j,k) = 0.0
                hi(i,j,k) = 0.0
                hs(i,j,k) = 0.0
                t1(i,j,k) = 0.0
                t2(i,j,k) = 0.0
             endif
          enddo
       enddo
    enddo

  return
end subroutine thm_unpack

end module ice_thm_mod

!-----------------------------------------------------------------------
! Copyright 2011 NOAA Geophysical Fluid Dynamics Lab, Princeton, NJ
! This program is distributed under the terms of the GNU General Public
! License. See the file COPYING contained in this directory
!
! This program reads several input netcdf files, presumably containing 
! "compressed by gathering" data, and combines them into a single output file
!
!-----------------------------------------------------------------------

#define __NF_ASRT__(ierr) call nfu_check_err(ierr,__FILE__,__LINE__)
program combine_res

  use nfu_mod
  use nfu_compress_mod
  implicit none
  include 'netcdf.inc'

  integer, parameter :: PATH_MAX = 1024 ! max len of the file name; 
  integer, parameter :: HEADERPAD = 16384 ! Use mpp_io large headers; 
  integer            ::  blksz = 65536  ! blksz must be writable for nf__create

  character(PATH_MAX), allocatable :: files(:) ! names of all files on the command line
  character(PATH_MAX)              :: outfile  ! name of the output file
  integer :: nfiles    ! number of files on command line
  integer :: debug = 0 ! debug output verbosity level
  integer, allocatable :: input(:)             ! netcdf IDs of input files
  integer :: i,ncid,dimid,varid,dimlen,vsize,ndims,nvars,ngatts
  integer :: dimlens(NF_MAX_DIMS)
  logical :: has_records
  integer :: in_format ! format of input files
  integer :: cmode     ! mode for output file creation
  character(NF_MAX_NAME) :: dimname,varname,attname
  real   , allocatable :: buffer(:)
  logical, allocatable :: mask(:)

  ! get command line options and list of files
  call parse_command_line() ! modigies global data!

  call assert(nfiles>0,'at least one input file must be specified')
  if(debug>0) then
     do i = 1,nfiles
        write(*,'("input file",i3,":",a)')i, '"'//trim(files(i))//'"'
     enddo
     write(*,'("output file:",a)')'"'//trim(outfile)//'"'
  endif

  ! open all input files and determine the creation mode of output file:
  ! if any of the input files is 64-bit then the output is 64-bit as well,
  ! otherwise it's 32-bit
  allocate(input(nfiles))
  do i = 1,nfiles
     __NF_ASRT__(nf_open(files(i),NF_NOWRITE,input(i)))
     __NF_ASRT__(nf_inq_format(input(i),in_format))
  enddo

  if (in_format==NF_FORMAT_NETCDF4) then
     cmode = NF_NETCDF4
  elseif (in_format==NF_FORMAT_NETCDF4_CLASSIC) then
     cmode=IOR(NF_NETCDF4,NF_CLASSIC_MODEL)
  elseif (in_format==NF_FORMAT_64BIT) then
     cmode=IOR(NF_CLOBBER,NF_64BIT_OFFSET)
     if(debug>0)write(*,'("output file is 64-bit netcdf")')
  elseif (in_format==NF_FORMAT_CLASSIC) then
     cmode=IOR(NF_CLOBBER,NF_CLASSIC_MODEL)
     if(debug>0)write(*,'("output file is 32-bit netcdf")')
  else
     call assert(.false.,'Unknown netCDF format')
  endif

  ! create output file

  ! mpp_io supports environment variables to set these. For Riga, we'll simply use the defaults`

  __NF_ASRT__(nf__create(outfile,cmode,0,blksz,ncid))

  ! Create netcdf structure in the output NetCDF file, using last input file
  ! as a template.

  ! clone all dimensions; for compressed dimensions calculate the length
  __NF_ASRT__(nf_inq_ndims(input(nfiles),ndims))
  do dimid = 1,ndims
     __NF_ASRT__(nfu_inq_dim(input(nfiles),dimid,dimname=dimname,dimlen=dimlen,is_unlim=has_records))
     if(nfu_inq_att(input(nfiles),dimname,'compress')==NF_NOERR) then
        __NF_ASRT__(nfu_inq_compressed_var(input(nfiles),dimname,varsize=vsize))
        allocate(buffer(vsize),mask(vsize))
        mask(:) = .false.
        do i=1,nfiles
           __NF_ASRT__(nfu_get_compressed_var_r8n(input(i),dimname,buffer,mask))
        enddo
        dimlen = max(count(mask),1)
        ! can't have 0-length dimension, since it is (mis-)understood by netcdf as 
        ! a record one.
        deallocate(buffer,mask)
     endif
     if(debug>0)&
          write(*,*)'defining dimension "'//trim(dimname)//'" with length',dimlen
     if(has_records)then
        dimlen = NF_UNLIMITED
     endif
     __NF_ASRT__(nf_def_dim(ncid,dimname,dimlen,i)) ! i is just a space for id

  enddo

  ! clone all variable definitions
  __NF_ASRT__(nf_inq_nvars(input(nfiles),nvars))
  do i = 1,nvars
     __NF_ASRT__(nfu_clone_var(input(nfiles),i,ncid))
     ! NOTE: since cloning of variable definition relies on dimension names,
     ! each variable tile and compressed dimensions automaticaly get the right
     ! size, as defined while creating dimensions in the output file
  enddo

  ! clone all global attributes
  __NF_ASRT__(nf_inq_natts(input(nfiles),ngatts))
  do i = 1,ngatts
     __NF_ASRT__(nf_inq_attname(input(nfiles),NF_GLOBAL,i,attname))
     __NF_ASRT__(nf_copy_att(input(nfiles),NF_GLOBAL,attname,ncid,NF_GLOBAL))
  enddo

  ! ---- end of definition stage
  __NF_ASRT__(nf__enddef(ncid,HEADERPAD,4,0,4))

  ! grow unlimited dimension, if necessary
  do varid = 1,nvars
     __NF_ASRT__(nfu_inq_var(input(nfiles),varid,dimlens=dimlens,has_records=has_records))
     if(has_records)then
        __NF_ASRT__(nf_put_var1_int(ncid,varid,dimlens,0))
        exit ! loop
     endif
  enddo


  ! gather and copy data
  do varid = 1,nvars
     __NF_ASRT__(nfu_inq_compressed_var(ncid,varid,name=varname,varsize=vsize))
     if(debug>0) &
          write(*,*)'processing var "'//trim(varname)//'"'
     allocate(buffer(vsize),mask(vsize))
     mask(:) = .false.
     do i=1,nfiles
        __NF_ASRT__(nfu_get_compressed_var_r8n(input(i),varname,buffer,mask))
     enddo
     if (count(mask)>0) then
        __NF_ASRT__(nfu_put_var_r8(ncid,varname,pack(buffer,mask)))
     endif
     deallocate(buffer,mask)
  enddo
     
  __NF_ASRT__(nf_close(ncid))

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

! ---- parses command line arguments, getting options and gathering list of
! file names
! NOTE: updates global variables.
subroutine parse_command_line()
  character(PATH_MAX) :: arg, param

  integer :: nargs     ! number of command-line arguments
  logical :: do_interpret_arguments
  integer :: i, iostat

  integer, external :: iargc

  nargs = iargc()
  if(nargs==0) then
     call usage()
     call exit(1)
  endif
  
  allocate(files(nargs))  ! allocate storage for all file names
  do_interpret_arguments = .true.
  i=1        ! counter of all command-line arguments
  nfiles = 0 ! counter of input files
  do while (i<=nargs)
     call getarg(i,arg)
     if(debug>1) write(*,*)'argument ',i, trim(arg)
     if(arg(1:1)=='-'.and.do_interpret_arguments) then
        select case(trim(arg))
        case('--')
           do_interpret_arguments = .false.

        case('-D','--debug-level')
           call assert(i<nargs,trim(arg)//' flag must be followed by integer verbosity level')
           call getarg(i+1,param)
           read(param,*,iostat=iostat) debug
           call assert(iostat==0,trim(arg)//' flag must be followed by integer verbosity level')
           i=i+1

        case ('-h','-?','--help')
           call usage()
           call exit(1)

        case default
           call usage()
           call assert(.false.,'argument "'//trim(arg)//'" is illegal')
        end select
     else
        ! argument is either input or output file name, add it to the list
        nfiles = nfiles+1
        files(nfiles) = arg
     endif
     i = i+1
  enddo
  if (nfiles>0) then
     outfile = files(nfiles)
     nfiles  = nfiles-1
  endif
  if(debug>0) &
       write(*,*) nfiles, ' input files'
end subroutine


! ---- prints usage information
subroutine usage()
  character(len=PATH_MAX) :: name
  call getarg(0,name)
  write(*,'(a)')'Combines several compressed-by-gathering netcdf files into one.'
  write(*,'(a)')'Normally used to combine lm3 restarts generated by each processor.'
  write(*,'(a)')
  write(*,'(a)')'Usage:'
  write(*,'(a)')'  '//trim(name)//' [-D debug-level] in.nc [...] out.nc'
  write(*,'(a)')
  write(*,'(a)')'-D debug-level   Specifies level of debug output verbosity'
  write(*,'(a)')'in.nc            Input file name(s)'
  write(*,'(a)')'out.nc           Output file name'
  write(*,'(a)')
  write(*,'(a)')'WARNING: output file is overwritten.'
  
end subroutine


! ===========================================================================
! ---- prints error message an exits if condition is not satisfied
subroutine assert(cond,message)
  logical     , intent(in) :: cond    ! condition to check
  character(*), intent(in) :: message ! error message to print if condition is not satisfied
  
  if(.not.cond) then
     write(*,*) 'ERROR :: ',trim(message)
     call exit(1)
  endif
end subroutine

end program combine_res

                   MODULE HCONST_MOD

!-----------------------------------------------------------------------
!     ----- The following are physical constants -----

           REAL,PARAMETER :: AMOLWT   = 28.9644
           REAL,PARAMETER :: CSUBP    = 1.00484E7 
           REAL,PARAMETER :: DIFFCTR  = 1.66
           REAL,PARAMETER :: GRAV     = 980.665 
           REAL,PARAMETER :: GINV     = 1./GRAV 
           REAL,PARAMETER :: GRAVDR   = 980.0
           REAL,PARAMETER :: O3DIFCTR = 1.90 
           REAL,PARAMETER :: P0       = 1013250. 
           REAL,PARAMETER :: P0INV    = 1./P0 
           REAL,PARAMETER :: GP0INV   = GINV*P0INV 
           REAL,PARAMETER :: P0XZP2   = 202649.902 
           REAL,PARAMETER :: P0XZP8   = 810600.098 
           REAL,PARAMETER :: P0X2     = 2.*1013250.
           REAL,PARAMETER :: RADCON   = 8.427
           REAL,PARAMETER :: RADCON1  = 1./8.427
           REAL,PARAMETER :: RATCO2MW = 1.519449738
           REAL,PARAMETER :: RATH2OMW = 0.622 
           REAL,PARAMETER :: RGAS     = 8.3142E7 
           REAL,PARAMETER :: RGASSP   = 8.31432E7
           REAL,PARAMETER :: SECPDA   = 8.64E4 

!-----------------------------------------------------------------------

                  END MODULE HCONST_MOD

module ocean_blob_static_bottom_mod
!
!<CONTACT EMAIL="m.bates@student.unsw.edu.au"> Michael L. Bates
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Contains static bottom blob parameterisations, namely the Campin and 
! Goossee (1999) scheme and some variations.
!</OVERVIEW>
!
!<DESCRIPTION>
! Presently, there is only one static bottom blob scheme implemented 
! (although, there are three potential variants), and there are no plans
! to implement any additional schemes.
!
! The scheme that is implemented emulates the Campin and Goossee (1999) 
! scheme, as well as having two additional variations for this scheme, 
! in which the "plumbing" is change.
!
! Details of the variations can be found in Bates et al. (2010) and are 
! controlled by the namelist options overflow_no_return and
! overflow_one_return.
!</DESCRIPTION>
!<INFO>
!
! <REFERENCE>
! Bates, M.L., Griffies, S.M., England, M.H., Adcroft, A.J. (2009)
! Lagrangian blobs of buoyancy embedded in Eulerian models: a framework
! to parameterise vertical and downslope motion of gravitationally unstable
! water parcels.  Unpublished Notes.
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, Elements of mom4p1 (2009)
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
! <REFERENCE>
! Campin, J.-M., Goossee, H., 1999, Parameterization of density-driven
! downsloping flow for a coarse-resolution ocean model in z-coordinate.
! Tellus 51A (3), 412-430
! </REFERENCE>
!
!</INFO>
!
!<NAMELIST NAME="ocean_blob_static_bottom_nml">
!
!  <DATA NAME="blob_overflow" TYPE="logical">
!  if true, will use a Campin and Goosse (1999) style overflow 
!  formulation.
!  Default is blob_overflow=.false.
!  </DATA>
!
!  <DATA NAME="blob_overflow_mu" UNITS="1/s" TYPE="real">
!  Frictional dissipation used in blob_overflow scheme
!  Default is blob_overflow_mu=1.0e-4
!  </DATA>
!
!  <DATA NAME="blob_overflow_delta" TYPE="real">
!  Fraction of grid cell participating in overflow
!  Valid values are 0<=delta<=1
!  Default is blob_overflow_delta=1/3
!  </DATA>
!
!  <DATA NAME="blob_overflow_umax" UNITS="m/s" TYPE="real">
!  Maximum downslope speed allowed for overflow
!  Default is blob_overflow_umax=0.01
!  </DATA>
!  
!  <DATA NAME="overflow_no_return" TYPE="logical">
!  When .false. creates return blobs to replicate the
!  original Campin and Goosse scheme.  When .true. only
!  creates blobs that sink.  See further overflow_one_return
!  </DATA>
!
!  <DATA NAME="overflow_one_return" TYPE="logical">
!  Creates a single return blob when .true.  Cannot be .true.
!  when overflow_no_return is also .true.
!  </DATA>
!
!</NAMELIST>
!
use fms_mod,         only: open_namelist_file, check_nml_error, stdout, stdlog
use fms_mod,         only: stderr, FATAL, error_mesg, mpp_error, close_file
use mpp_domains_mod, only: mpp_update_domains
use mpp_mod,         only: NULL_PE, mpp_sync_self, mpp_send, mpp_recv

use ocean_blob_util_mod,  only: insert_blob, count_blob, free_blob_memory, blob_delete
use ocean_density_mod,    only: density
use ocean_parameters_mod, only: onehalf, rho0r, grav
use ocean_types_mod,      only: ocean_time_type, ocean_grid_type, ocean_domain_type
use ocean_types_mod,      only: ocean_thickness_type, ocean_prog_tracer_type
use ocean_types_mod,      only: ocean_density_type, ocean_blob_type, blob_grid_type

implicit none

private

type(ocean_grid_type),   pointer :: Grd  => NULL()
type(ocean_domain_type), pointer :: Dom  => NULL()
type(blob_grid_type),    pointer :: Info => NULL()

logical :: module_is_initialized=.false.
integer :: num_prog_tracers
integer :: index_temp
integer :: index_salt

integer :: isd,ied,jsd,jed,isc,iec,jsc,jec,nk
integer :: rea_buff_size

integer, dimension(4) :: ip, jq, ish, jsh, ieh, jeh

real, dimension(:,:),   allocatable :: datdtime_r   ! 1./(Grd%dat*dtime)
real, dimension(:,:,:), allocatable :: topog_step, topog_slope
real, dimension(:,:),   allocatable :: slope_x, slope_y
real, dimension(:,:),   allocatable :: max_overflow_flux
real :: dtime
real :: overflow_factor

type, private :: blob_buffer_type
   integer :: numblobs
   integer :: size
   integer, allocatable, dimension(:,:) :: integer_buff
   real,    allocatable, dimension(:,:) :: real_buff
   logical, allocatable, dimension(:,:) :: logical_buff
end type blob_buffer_type

type(blob_buffer_type), pointer :: Ebuffer_out,  Ebuffer_in
type(blob_buffer_type), pointer :: Wbuffer_out,  Wbuffer_in
type(blob_buffer_type), pointer :: Nbuffer_out,  Nbuffer_in
type(blob_buffer_type), pointer :: Sbuffer_out,  Sbuffer_in

! buffers and buffer variables to send blobs to adjacent PE's
integer, parameter :: delta_buffer = 25   ! Size by which to increment the buffer
integer, parameter :: int_buff_params = 8 ! number of integer blob attributes
integer, parameter :: log_buff_params = 1 ! number of logical blob attributes

public blob_static_bottom_init
public blob_overflow_like
public blob_static_bottom_end

! namelist defaults
logical :: use_this_module     =.false.  ! whether to use this module or not
logical :: overflow_no_return  =.false.  ! for the overflow-like scheme
logical :: overflow_one_return =.false.  ! for the overflow-like scheme
real    :: blob_overflow_mu    = 1.0e-4  ! frictional dissipation rate (sec^-1) at bottom  
real    :: blob_overflow_delta = 0.3333  ! fraction of a grid cell participating in overflow 
real    :: blob_overflow_umax  = 0.01    ! maximum downslope speed (m/s)

namelist /ocean_blob_static_bottom_nml/ use_this_module, overflow_no_return, &
                                        overflow_one_return, blob_overflow_mu, &
                                        blob_overflow_delta, blob_overflow_umax


contains

!######################################################################
! <SUBROUTINE NAME="blob_static_bottom_init">
!
! <DESCRIPTION>
! Initialises the static bottom blob module.
! </DESCRIPTION>
!
subroutine blob_static_bottom_init(Grid, Domain, PE_info, num_tracers, itemp, isalt, dtimein)

  type(ocean_grid_type),   intent(in), target :: Grid
  type(ocean_domain_type), intent(in), target :: Domain
  type(blob_grid_type),    intent(in), target :: PE_info
  integer, intent(in) :: num_tracers
  integer, intent(in) :: itemp
  integer, intent(in) :: isalt
  real,    intent(in) :: dtimein

  integer :: i, j, m
  integer :: ioun, ierr, io_status
  integer :: stdoutunit,stdlogunit 

  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL,&
         '==>Error in ocean_blob_static_bottom_mod (ocean_blob_static_bottom_init):' &
         //' module already initialized')
  endif 

  ! provide for namelist over-ride of default values
  ioun =  open_namelist_file()
  read (ioun,ocean_blob_static_bottom_nml,IOSTAT=io_status)
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_blob_static_bottom_nml)  
  write (stdlogunit,ocean_blob_static_bottom_nml)
  ierr = check_nml_error(io_status,'ocean_blob_static_bottom_nml')
  call close_file (ioun)

  module_is_initialized = .true.

  if (.not. use_this_module) return

  write(stdoutunit,'(a)') & 
       ' ==>Note: Using the Lagrangian overflow scheme.'
  if (overflow_no_return .and. overflow_one_return) then
     call mpp_error(FATAL, '  ==>Error in ocean_blobs_mod '   &
          //'(ocean_blob_init): overflow_no_return and '      &
          //'overflow_one_return are selected.  Only one may '&
          //'be selected')
  elseif(overflow_one_return) then
     write(stdoutunit,'(a)') '  ==>Note: using a single return blob'
  elseif(overflow_no_return) then
     write(stdoutunit,'(a)') '  ==>Note: not using any return blobs'
  else
     write(stdoutunit,'(a)') '  ==>Note: using the full C&G scheme'
  endif

  Grd  => Grid
  Dom  => Domain
  Info => PE_info

  isd=Dom%isd; ied=Dom%ied; jsd=Dom%jsd; jed=Dom%jed
  isc=Dom%isc; iec=Dom%iec; jsc=Dom%jsc; jec=Dom%jec
  nk = Grd%nk

  dtime             = dtimein
  index_temp        = itemp
  index_salt        = isalt
  num_prog_tracers  = num_tracers

  allocate(datdtime_r(isd:ied,jsd:jed))
  datdtime_r(:,:) = Grd%datr(:,:)/dtime

  allocate(max_overflow_flux(isd:ied,jsd:jed))
  max_overflow_flux(:,:) = onehalf*Grd%dat(:,:)/dtime

  overflow_factor = grav*blob_overflow_delta*rho0r/blob_overflow_mu

  ! compute topographic slope arrays for the i-slope and j-slope
  ! slopes are centered on the i-face and j-face of tracer cells 
  allocate(slope_x(isd:ied,jsd:jed))
  allocate(slope_y(isd:ied,jsd:jed))
  slope_x(:,:) = 0.0 
  slope_y(:,:) = 0.0
  do j=jsc,jec
     do i=isc,iec
        slope_x(i,j) = (Grd%ht(i+1,j)-Grd%ht(i,j))*Grd%dxter(i,j)
        slope_y(i,j) = (Grd%ht(i,j+1)-Grd%ht(i,j))*Grd%dytnr(i,j)
        slope_x(i,j) = abs(slope_x(i,j))
        slope_y(i,j) = abs(slope_y(i,j))
     enddo
  enddo

  call mpp_update_domains(slope_x(:,:),Dom%domain2d)
  call mpp_update_domains(slope_y(:,:),Dom%domain2d)
  
  ! labels for the four tracer cells surrounding a 
  ! central tracer cell (moving counter-clockwise)
  m=1 ; ip(m)=1  ; jq(m)=0
  m=2 ; ip(m)=0  ; jq(m)=1
  m=3 ; ip(m)=-1 ; jq(m)=0
  m=4 ; ip(m)=0  ; jq(m)=-1

  
  ! a useful index for accessing only certain parts of the halo
  ish(:) = isc; ieh(:) = iec; jsh(:) = jsc; jeh(:) = jec
  if (Info%pe_W .ne. NULL_PE) ish(1) = isc - 1
  if (Info%pe_S .ne. NULL_PE) jsh(2) = jsc - 1
  if (Info%pe_E .ne. NULL_PE) ieh(3) = iec + 1
  if (Info%pe_N .ne. NULL_PE) jeh(4) = jec + 1


  ! a useful index for accessing only certain parts of the halo
!  ish(:) = isc; ieh(:) = iec; jsh(:) = jsc; jeh(:) = jec
!  if (Info%pe_W .ne. NULL_PE) ish(1) = isc - 1
!  if (Info%pe_S .ne. NULL_PE) jsh(2) = jsc - 1
!  if (Info%pe_E .ne. NULL_PE) ieh(3) = iec + 1
!  if (Info%pe_N .ne. NULL_PE) jeh(4) = jec + 1
  
  ! compute directions from an (i,j) point where topography deepens.
  ! these directions may potentially have downslope flow. 
  ! insist that downslope flow occurs only when there are more kmt 
  ! cells in the adjacent column. 
  ! also insist that downslope flow does not involve k=1 cells. 
  allocate (topog_step(isd:ied,jsd:jed,4))
  allocate (topog_slope(isd:ied,jsd:jed,4))
  topog_step(:,:,:)  = 0.0
  topog_slope(:,:,:) = 0.0
  do j=jsc,jec
     do i=isc,iec
        if(Grd%kmt(i,j) > 1) then 
           if(Grd%kmt(i+1,j) > Grd%kmt(i,j)) topog_step(i,j,1)=1.0
           if(Grd%kmt(i,j+1) > Grd%kmt(i,j)) topog_step(i,j,2)=1.0
           if(Grd%kmt(i-1,j) > Grd%kmt(i,j)) topog_step(i,j,3)=1.0
           if(Grd%kmt(i,j-1) > Grd%kmt(i,j)) topog_step(i,j,4)=1.0
        endif
     enddo
  enddo

  ! Block out the bipolar fold in order to ensure tracer 
  ! conservation.
  if(jec+Dom%joff==Dom%jeg) topog_step(:,jec,:) = 0.0

  do j=jsc,jec
     do i=isc,iec
        m=1 ; topog_slope(i,j,m) = slope_x(i,j)  
        m=2 ; topog_slope(i,j,m) = slope_y(i,j)  
        m=3 ; topog_slope(i,j,m) = slope_x(i-1,j)
        m=4 ; topog_slope(i,j,m) = slope_y(i,j-1)
     enddo
  enddo

  call mpp_update_domains(topog_step(:,:,:), Dom%domain2d)
  call mpp_update_domains(topog_slope(:,:,:),Dom%domain2d)

  ! Allocate the buffers
  rea_buff_size = num_prog_tracers+1
  call allocate_buffer(Ebuffer_out, rea_buff_size)
  call allocate_buffer(Ebuffer_in, rea_buff_size)
  
  call allocate_buffer(Wbuffer_out, rea_buff_size)
  call allocate_buffer(Wbuffer_in, rea_buff_size)

  call allocate_buffer(Nbuffer_out, rea_buff_size)
  call allocate_buffer(Nbuffer_in, rea_buff_size)

  call allocate_buffer(Sbuffer_out, rea_buff_size)
  call allocate_buffer(Sbuffer_in, rea_buff_size)

end subroutine blob_static_bottom_init
! </SUBROUTINE>  NAME="ocean_blob_static_bottom_init"


!######################################################################
! <SUBROUTINE NAME="blob_overflow_like">
!
! <DESCRIPTION>
! Run the Lagrangian blob model for the Overflow schemes.  These 
! schemes are static schemes and uses Lagrangian blobs to transport 
! tracer and mass down slopes where an onshelf/offshelf instability
! exists.
!
! This scheme is activated by setting the namelist variable 
! blob_overflow=.true.
!
! There are three flavours to this scheme, which are detailed in
! sections 2.4 and 2.5 of Bates et al. for further details.  The three
! flavours are:
! 1/ A Campin and Goosse (1999) scheme in which the full "plumbing" of
!    water going off shelf to the deep ocean and deep ocean waters
!    returning on shelf is specified (described in full in section 2.4
!    of Bates et al.)
! 2/ Only the lateral part of the plumbing is specified and all vertical
!    movement of water within the deep ocean column is taken care of 
!    (described in full in section 2.5 of Bates et al.).  This option is
!    activated by setting the namelist variable overflow_one_return=.true.
! 3/ Only the movement of shelf water to the deep ocean column is
!    explicitly dealt with (described in full in section 2.5 of Bates
!    et al.).  This option is activated by setting the namelist variable
!    overflow_no_return=.true.
! 
! Other namelist variables associated with this scheme are:
!  blob_overflow_mu (real), which is the coefficient of friction used
!    used to calculate the overflow velocity,
!  blob_overflow_delta (real), which is the fraction of a grid cell that
!    participates in any one overflow event,
!  blob_overflow_umax (real), which is the maximum overflow velocity.
!    Depending on the flavour of scheme chosen and the impact that you want
!    it to have, typical values should be O(0.01) to O(1).
! </DESCRIPTION>
!
subroutine blob_overflow_like(Time, Thickness, T_prog, Dens, head, blob_counter)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(inout) :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_density_type),     intent(in)    :: Dens
  type(ocean_blob_type),        pointer       :: head 
  integer, dimension(isc:iec,jsc:jec,nk), intent(inout) :: blob_counter

  !local variables
  real    :: temp_so, salt_so, press, so_dens, blob_mass
  real    :: overflow_speed, overflow_thickness, overflow_flux
  integer :: i,j,k,kdw,kup,m,n,tau,iip,jjq
  integer :: nE, nW, nN, nS
  integer :: stderrunit
  logical :: sink
  type(ocean_blob_type), pointer :: prev => NULL()
  type(ocean_blob_type), pointer :: this => NULL()
  type(ocean_blob_type), pointer :: next => NULL()

  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
         '==>Error in ocean_blob_static_bottom_mod (Lagrangian blob model): '&
         //'module needs to be initialized')
  endif 

  if (.not. use_this_module) return

  stderrunit = stderr()
  tau   = Time%tau
  kup   = 0
  kdw   = 0

  ! search for horizontal instability, including in certain parts of the halo
  do m=1,4
     do j=jsh(m),jeh(m)
        do i=ish(m),ieh(m)

           ! check whether downslope flow is possible
           if (topog_step(i,j,m) == 1.0) then

              ! some convenient variables
              iip = i+ip(m)
              jjq = j+jq(m)
              kup = Grd%kmt(i,j)

              ! overflow _flux and _speed are used to calculate the mass that 
              ! is overflowing.
              overflow_flux  = 0.0 !overflow flux kg/s
              overflow_speed = 0.0 !overflow speed m/s

              ! check whether density of shelf water is more than deep water
              if(Dens%rho(i,j,kup,tau) > Dens%rho(iip,jjq,kup,tau)) then
                 
                 ! calculate the overflow velocity
                 overflow_speed = overflow_factor*topog_slope(i,j,m) &
                                  *( Dens%rho(i,j,kup,tau)-Dens%rho(iip,jjq,kup,tau) )
                 overflow_speed = min(overflow_speed, blob_overflow_umax)

                 ! find the neutral level, or the lowest ocean grid box
                 salt_so = T_prog(index_salt)%field(i,j,kup,tau)
                 temp_so = T_prog(index_temp)%field(i,j,kup,tau)
                 kdw = kup
                 do k=kup+1,Grd%kmt(iip,jjq)
                    press = Dens%pressure_at_depth(iip,jjq,k)
                    so_dens = density(salt_so,temp_so,press)
                    ! compare the density of the shelf water to the 
                    ! deep water density referenced to the pressure of
                    ! depth of the deep water
                    if (so_dens > Dens%rho(iip,jjq,k,tau)) then
                       kdw = k
                    else
                       exit
                    endif
                 enddo

                 ! compute m^2/sec flux leaving vertical face of cell  
                 if(m==1 .or. m==3) then 
                    overflow_flux = overflow_speed*Grd%dyt(i,j)
                 elseif(m==2 .or. m==4) then 
                    overflow_flux = overflow_speed*Grd%dxt(i,j)
                 endif

                 ! based on 1D diffusive stability criteria, no more than 
                 ! one-half the mass of a grid cell can be mixed per time
                 ! step, which means:
                 ! overflow_flux(m^2/sec)*rho_dzt*dtime < 0.5*rho_dzt*dat,
                 ! or equivalently overflow_flux(m^2/sec) < 0.5*dat/dtime
                 overflow_flux = min(overflow_flux, max_overflow_flux(i,j))
       
                 ! now convert overflow_flux from m^2/sec to kg/sec
                 ! using rho_dzt 
                 overflow_thickness = Thickness%rho_dzt(i,j,kup,tau)
    
                 do k=kup,kdw
                    overflow_thickness = min(overflow_thickness,&
                                         Thickness%rho_dzt(iip,jjq,k,tau))
                 enddo

                 ! overflow flux is (m^2/s).  In order to get mass (kg), we
                 ! need to multiply by overflow_thickness(kg/m^2)*dtime(s)
                 blob_mass = overflow_flux*overflow_thickness*dtime

                 ! Form the onshelf blobs.  Make sure they are in the 
                 ! compute domain.
                 if (i>=isc .and. i<=iec .and. j>=jsc .and. j<=jec) then
                    call formoverflowblob(i,j,kup,.true.)
                 endif

                 ! Form the deep ocean blobs.  Make sure they are in the compute
                 ! domain
                 if (iip>=isc .and. iip<=iec .and. jjq>=jsc .and. jjq<=jec) then
                    if(overflow_one_return) then
                       call formoverflowblob(iip,jjq,kup,.false.)
                    elseif(.not. overflow_no_return) then
                       do k=kup,kdw
                          call formoverflowblob(iip,jjq,k,.false.)
                       enddo
                    endif
                 endif
              endif !rho_so>rho_do?
           endif !topog_step==1.0?
        enddo !i
     enddo !j
  enddo !m

  ! The next portion of code performs the following operations:
  ! 1/ move the blobs
  ! 2/ any blobs that have gone outside the compute domain need to:
  ! 2a/ put into a buffer and deleted from this PE's blob list
  ! 2b/ send the buffer to the adjacent compute domain, N,S,E or W
  ! 2c/ receive buffers from adjacent compute domains
  ! 2d/ add the blobs contained in the received bufferto this PE's blob
  !     list
  ! 3/ do some more diagnostics 
  ! 4/ transfer the properties from the Lagrangian model to the Eulerian
  !    model
  ! MPI does not handle passing of objects from one PE to another.  So,
  ! we need to "pack" the blob into a "buffer", which is an array of
  ! properties.  We then pass the array to another PE, where the array is
  ! read, and objects are created on that PE.

  ! clear the outward buffers & accummulators
  call clear_buffer(Ebuffer_out);  nE  = 0
  call clear_buffer(Wbuffer_out);  nW  = 0
  call clear_buffer(Nbuffer_out);  nN  = 0
  call clear_buffer(Ebuffer_out);  nS  = 0

  if(associated(head)) then
     prev=>NULL()
     this=>head
     next=>head%next

     blobmove: do
        ! for convenience
        i    = this%i - Dom%ioff
        j    = this%j - Dom%joff
        k    = this%k
        m    = this%m
        kdw  = this%kdw
        kup  = this%kup
        sink = this%sink

        if (sink) then
           ! Move the blobs:
           ! if sink is .true. then the on shelf blob moves to kdw in the
           ! deep ocean column
           i = i + ip(m)
           j = j + jq(m)
           k = kdw
        else
           ! if sink is not .true. the the blob must be in the deep
           ! ocean column
           if (k==kup) then
              ! if the blob is in the deep ocean at kup, then move it on
              ! to the shelf, staying at kup
              i = i - ip(m)
              j = j - jq(m)
           else
              ! if the blob is not at kup, then keep it in the deep ocean
              ! column and move it up one grid box
              k = k - 1
           endif
        endif ! sink?

        this%i = i + Dom%ioff
        this%j = j + Dom%joff
        this%k = k

        ! test if this has gone out to the E,W,N or S of the 
        ! compute domain.  If it has, then pack it into an outward
        ! buffer and remove it from this PE's list of blobs
        if (i>iec) then
           nE = nE + 1
           call addtobuffer(Ebuffer_out, nE, Info%pe_E)
        elseif (i<isc) then
           nW = nW + 1
           call addtobuffer(Wbuffer_out, nW, Info%pe_W)
        elseif (j>jec) then
           nN = nN + 1
           call addtobuffer(Nbuffer_out, nN, Info%pe_N)
        elseif (j<jsc) then
           nS = nS + 1
           call addtobuffer(Sbuffer_out, nS, Info%pe_S)
        endif

        ! move down the list.  If we're at the end of the list, exit.
        if(associated(this)) prev=>this
        this=>next
        if(associated(next)) next=>next%next

        if(.not.associated(this)) then
           nullify(prev)
           nullify(this)
           nullify(next)
           exit blobmove
        endif

     enddo blobmove
  endif !head associated

  ! Tell the buffer how many blobs it contains from the accummulators
  Ebuffer_out%numblobs  = nE
  Wbuffer_out%numblobs  = nW
  Nbuffer_out%numblobs  = nN
  Sbuffer_out%numblobs  = nS
  
  ! Now, send blobs to neighbouring PE's.  Note: since blobs can only move
  ! N,S,E or W, we do not need to worry about diagonal PE's 
  ! (i.e. NE,SE,SW,NW)
  if (Info%pe_E .ne. NULL_PE) call send_buffer(Ebuffer_out, Info%pe_E, rea_buff_size)
  if (Info%pe_W .ne. NULL_PE) call send_buffer(Wbuffer_out, Info%pe_W, rea_buff_size)
  if (Info%pe_N .ne. NULL_PE) call send_buffer(Nbuffer_out, Info%pe_N, rea_buff_size)
  if (Info%pe_S .ne. NULL_PE) call send_buffer(Sbuffer_out, Info%pe_S, rea_buff_size)
  
  ! Clear the incoming buffers
  call clear_buffer(Wbuffer_in)
  call clear_buffer(Ebuffer_in)
  call clear_buffer(Sbuffer_in)
  call clear_buffer(Nbuffer_in)
  
  ! Now receive blobs from neighbouring PE's
  if (Info%pe_W .ne. NULL_PE) call receive_buffer(Wbuffer_in, Info%pe_W, rea_buff_size)
  if (Info%pe_E .ne. NULL_PE) call receive_buffer(Ebuffer_in, Info%pe_E, rea_buff_size)
  if (Info%pe_S .ne. NULL_PE) call receive_buffer(Sbuffer_in, Info%pe_S, rea_buff_size)
  if (Info%pe_N .ne. NULL_PE) call receive_buffer(Nbuffer_in, Info%pe_N, rea_buff_size)

  ! Now unpack the buffer and add the received blobs to this PE's blob list
  if (Info%pe_W .ne. NULL_PE) call unpackbuffer(Wbuffer_in)
  if (Info%pe_E .ne. NULL_PE) call unpackbuffer(Ebuffer_in)
  if (Info%pe_S .ne. NULL_PE) call unpackbuffer(Sbuffer_in)
  if (Info%pe_N .ne. NULL_PE) call unpackbuffer(Nbuffer_in)

  call mpp_sync_self()
  
  if (associated(head)) then
     prev=>NULL()
     this=>head
     next=>this%next

     blob_diag: do
        ! for convenience
        i         = this%i - Dom%ioff
        j         = this%j - Dom%joff
        k         = this%k
        m         = this%m
        kup       = this%kup
        kdw       = this%kdw
        sink      = this%sink
        blob_mass = this%mass

        if (i>=isc .and. i<=iec .and. j>=jsc .and. j<= jec) then
           ! now transfer mass from the Lagrangian model to the Eulerian model
           Thickness%mass_source(i,j,k) = Thickness%mass_source(i,j,k) &
                                          + this%mass*datdtime_r(i,j)
           this%mass = this%mass - blob_mass

           ! now transfer tracer from the Lagrangian system to the Eulerian System
           do n=1,num_prog_tracers
              T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) &
                                             + this%tracer(n)*datdtime_r(i,j)
              this%tracer(n) = this%tracer(n) - this%tracer(n)
           enddo

           ! move down the list
           prev=>this
           this=>next
           if(associated(next)) next=>next%next

           ! if we are at the end of the list, then exit the loop
           if(.not.associated(this)) exit blob_diag
        else
           write(stderrunit,*) 'blob not on PE when it should be! blob coordinates i=',i,'j=',j,'pe=',Info%pe_this
           call error_mesg( 'ocean_blob_static_bottom_mod, '&
                //'subroutine blob_overflow_like', 'blob outside domain',FATAL)
        endif
     enddo blob_diag
  endif !head associated?

  ! now delete all approximately zero mass blobs
  ! (which should be all of them in the overflow_like_scheme)
  call blob_delete(Time, Thickness, T_prog(:), head)

  ! While there should be identically zero nett change in the mass source
  ! we need to update the mass_source in order to get bitwise agreement
  ! across different numbers of processors.
  call mpp_update_domains(Thickness%mass_source(:,:,:),Dom%domain2d)

contains

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that forms the overflow blobs
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  subroutine formoverflowblob(this_i, this_j, this_k, this_sink)

    integer :: this_i, this_j, this_k
    logical :: this_sink

    !local variables
    type(ocean_blob_type), pointer :: new_blob => NULL()

    allocate(new_blob)
    allocate(new_blob%tracer(num_prog_tracers))

    ! allocate important position integers to the blob
    new_blob%i   = this_i + Dom%ioff
    new_blob%j   = this_j + Dom%joff
    new_blob%k   = this_k
    new_blob%m   = m
    new_blob%kup = kup
    new_blob%kdw = kdw

    call count_blob(new_blob, blob_counter)

    ! .true. indicates the onshelf blob 
    ! .false. indicates a deep ocean blob
    new_blob%sink = this_sink

    ! now transfer the properties from the Eulerian model to
    ! the Lagrangian model.  mass_source is in units 
    ! (kg/m^3)*(m/s)=kg/(m^2*s)
    Thickness%mass_source(this_i,this_j,this_k) =    &
         Thickness%mass_source(this_i,this_j,this_k) &
         - blob_mass*datdtime_r(this_i,this_j)
    new_blob%mass      = blob_mass

    do n=1,num_prog_tracers
       ! transfer the tracer from the Eulerian system to the Lagrangian 
       ! system. field is tracer concentration. th_tendency is 
       ! kg*[concentration]/(m^2 sec).  
       new_blob%tracer(n) = new_blob%mass&
                            *T_prog(n)%field(this_i,this_j,this_k,tau)
       T_prog(n)%th_tendency(this_i,this_j,this_k) =    &
            T_prog(n)%th_tendency(this_i,this_j,this_k) &
            - new_blob%tracer(n)*datdtime_r(this_i,this_j)
    enddo

    ! insert the new blob into the list
    call insert_blob(new_blob,head)

    !now disassociate the new_blob pointer from the new_blob object
    nullify(new_blob)
 
  end subroutine formoverflowblob

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that packs a blob into a buffer          !
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  subroutine addtobuffer(buffer, nblob, pe)

    type(blob_buffer_type), pointer :: buffer
    integer, intent(in) :: nblob, pe

    ! local variables
    integer :: pt !counter for prognostic tracers

    if (pe .eq. NULL_PE) then
       write(stderrunit,*) 'this pe =',Info%pe_this, 'other pe =',pe
       call error_mesg('ocean_blobs_mod, subroutine addtobuffer', &
            'trying to pack a buffer to be sent to a NULL_PE',FATAL)
    endif

    if (nblob>buffer%size) call increase_buffer(buffer, rea_buff_size)

    buffer%numblobs = nblob

    ! Pack all the integer data
    buffer%integer_buff(1, nblob) = this%i
    buffer%integer_buff(2, nblob) = this%j
    buffer%integer_buff(3, nblob) = this%k
    buffer%integer_buff(4, nblob) = this%m
    buffer%integer_buff(5, nblob) = this%kdw
    buffer%integer_buff(6, nblob) = this%kup
    buffer%integer_buff(7, nblob) = this%hash
    buffer%integer_buff(8, nblob) = this%number
    
    ! Pack all the real data
    do pt=1,num_prog_tracers
       buffer%real_buff(pt,nblob) = this%tracer(pt)
    enddo
    buffer%real_buff(num_prog_tracers+1,nblob) = this%mass
       
    ! Pack all the logical data
    buffer%logical_buff(1,nblob) = this%sink

    ! Now take the blob out of the list and erase from memory
    if(associated(prev)) then
       prev%next=>next
    else
       head=>next
    endif
    if(associated(next)) next%prev=>prev

!!$    deallocate(this)
!!$    nullify(this)
    call free_blob_memory(this)

  end subroutine addtobuffer

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! This is a nested subroutine that unpacks an entire buffer            !
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  subroutine unpackbuffer(buffer)

    type(blob_buffer_type), pointer :: buffer

    ! local variables
    type(ocean_blob_type),pointer :: new_blob=>NULL()
    integer :: pt !counter for prognostic tracers
    integer :: nb !counter for blobs

    if (buffer%numblobs>0) then
       do nb=1,buffer%numblobs

          allocate(new_blob)
          allocate(new_blob%tracer(num_prog_tracers))

          ! Unpack all the integer data
          new_blob%i      = buffer%integer_buff(1 ,nb)
          new_blob%j      = buffer%integer_buff(2 ,nb)
          new_blob%k      = buffer%integer_buff(3 ,nb)
          new_blob%m      = buffer%integer_buff(4 ,nb)
          new_blob%kdw    = buffer%integer_buff(5 ,nb)
          new_blob%kup    = buffer%integer_buff(6 ,nb)
          new_blob%hash   = buffer%integer_buff(7 ,nb)
          new_blob%number = buffer%integer_buff(8 ,nb)

          ! Unpack all the real data
          do pt=1,num_prog_tracers
             new_blob%tracer(pt)      = buffer%real_buff(pt,nb)
          enddo
          new_blob%mass      = buffer%real_buff(num_prog_tracers+1,nb)

          ! Unpack all the logical data
          new_blob%sink = buffer%logical_buff(1,nb)

          ! Add the blob to the list
          call insert_blob(new_blob, head)

          nullify(new_blob)
          
       enddo
    endif

  end subroutine unpackbuffer

end subroutine blob_overflow_like
! </SUBROUTINE>  NAME="blob_overflow_like"

!######################################################################
! <SUBROUTINE NAME="blob_static_bottom_end">
!
! <DESCRIPTION>
! Does what is necessary to finish the run.
! </DESCRIPTION>
!
subroutine blob_static_bottom_end()

  if (.not. use_this_module) return

  call deallocate_buffer(Ebuffer_out);  call deallocate_buffer(Ebuffer_in)
  call deallocate_buffer(Wbuffer_out);  call deallocate_buffer(Wbuffer_in)
  call deallocate_buffer(Nbuffer_out);  call deallocate_buffer(Nbuffer_in)
  call deallocate_buffer(Sbuffer_out);  call deallocate_buffer(Sbuffer_in)

  nullify(Dom)
  nullify(Grd)

end subroutine blob_static_bottom_end
! </SUBROUTINE>  NAME="blob_static_bottom_end"

!######################################################################
! <SUBROUTINE NAME="allocate_buffer">
!
! <DESCRIPTION>
! Increases the buffer size for sending blobs from one PE to another.
! </DESCRIPTION>
!
subroutine allocate_buffer(buffer, rea_buff_params)
  
  type(blob_buffer_type), pointer :: buffer
  integer, intent(in) :: rea_buff_params
  
  allocate(buffer)
  allocate(buffer%integer_buff(int_buff_params, delta_buffer))
  allocate(buffer%real_buff(rea_buff_params,    delta_buffer))
  allocate(buffer%logical_buff(log_buff_params, delta_buffer))
  
  buffer%size = delta_buffer
  
end subroutine allocate_buffer

! </SUBROUTINE>  NAME="allocate_buffer"

!######################################################################
! <SUBROUTINE NAME="increase_buffer">
!
! <DESCRIPTION>
! Increases the buffer size for sending blobs from one PE to another.
! </DESCRIPTION>
!
subroutine increase_buffer(buffer, rea_buff_params)

  type(blob_buffer_type), pointer :: buffer
  integer, intent(in) :: rea_buff_params

  ! local variables
  type(blob_buffer_type), pointer :: new_buffer
  integer :: newbuffsize

  allocate(new_buffer)
  newbuffsize = buffer%size + delta_buffer

  allocate(new_buffer%integer_buff(1:int_buff_params, 1:newbuffsize))
  allocate(new_buffer%real_buff(   1:rea_buff_params, 1:newbuffsize))
  allocate(new_buffer%logical_buff(1:log_buff_params, 1:newbuffsize))
  
  new_buffer%integer_buff(:,1:buffer%size) = buffer%integer_buff(:,1:buffer%size)
  new_buffer%real_buff(   :,1:buffer%size) = buffer%real_buff(   :,1:buffer%size)
  new_buffer%logical_buff(:,1:buffer%size) = buffer%logical_buff(:,1:buffer%size)

  new_buffer%size = newbuffsize

  deallocate(buffer%integer_buff)
  deallocate(buffer%real_buff)
  deallocate(buffer%logical_buff)
  deallocate(buffer)

  nullify(buffer)
  buffer=>new_buffer

end subroutine increase_buffer
! </SUBROUTINE>  NAME="increase_buffer"

!######################################################################
! <SUBROUTINE NAME="send_buffer">
!
! <DESCRIPTION>
! Sends a buffer to an adjoining PE
! </DESCRIPTION>
!
subroutine send_buffer(buffer, pe, rea_buff_params)

  type(blob_buffer_type), pointer :: buffer
  integer, intent(in) :: pe
  integer, intent(in) :: rea_buff_params

  call mpp_send(buffer%numblobs, plen=1, to_pe=pe)
  if (buffer%numblobs>0) then
     call mpp_send(buffer%integer_buff, buffer%numblobs*int_buff_params, pe)
     call mpp_send(buffer%real_buff,    buffer%numblobs*rea_buff_params, pe)
     call mpp_send(buffer%logical_buff, buffer%numblobs*log_buff_params, pe)
  endif

end subroutine send_buffer
! </SUBROUTINE>  NAME="send_buffer"



!######################################################################
! <SUBROUTINE NAME="receive_buffer">
!
! <DESCRIPTION>
! Receives a buffer from an adjoining PE
! </DESCRIPTION>
!
subroutine receive_buffer(buffer, pe, rea_buff_params)

  type(blob_buffer_type), pointer :: buffer
  integer, intent(in) :: pe
  integer, intent(in) :: rea_buff_params

  !local variables
  integer :: incoming

  call mpp_recv(incoming, glen=1, from_pe=pe)
  if (incoming>0) then
     if (incoming>buffer%size) call increase_buffer(buffer, rea_buff_params)
     call mpp_recv(buffer%integer_buff, incoming*int_buff_params, pe)
     call mpp_recv(buffer%real_buff,    incoming*rea_buff_params, pe)
     call mpp_recv(buffer%logical_buff, incoming*log_buff_params, pe)
  endif
  buffer%numblobs = incoming

end subroutine receive_buffer
! </SUBROUTINE>  NAME="receive_buffer"


!######################################################################
! <SUBROUTINE NAME="clear_buffer">
!
! <DESCRIPTION>
! Clears the contents of a buffer
! </DESCRIPTION>
!
subroutine clear_buffer(buffer)
    
  type(blob_buffer_type), pointer :: buffer

  buffer%numblobs          = 0
  buffer%integer_buff(:,:) = 0
  buffer%real_buff(:,:)    = 0.0
  buffer%logical_buff(:,:) = .true.
  
  !note, we do not clear buffer%size
  
end subroutine clear_buffer
! </SUBROUTINE>  NAME="clear_buffer"

!######################################################################
! <SUBROUTINE NAME="deallocate_buffer">
!
! <DESCRIPTION>
! Deallocates memory from a buffer (usually at the end of a run).
! </DESCRIPTION>
!
subroutine deallocate_buffer(buffer)
  
  type(blob_buffer_type), pointer :: buffer
  
  deallocate(buffer%logical_buff)
  deallocate(buffer%real_buff)
  deallocate(buffer%integer_buff)
  deallocate(buffer)
  
end subroutine deallocate_buffer
! </SUBROUTINE>  NAME="deallocate_buffer"

end module ocean_blob_static_bottom_mod

module atmosphere_mod

!-----------------------------------------------------------------------
!
!    interface for B-grid dynamical core with Held-Suarez forcing
!
!-----------------------------------------------------------------------

use bgrid_core_driver_mod, only: bgrid_dynam_type,       &
                                 bgrid_core_driver_init, &
                                 bgrid_core_driver,      &
                                 bgrid_core_time_diff,   &
                                 bgrid_core_driver_end,  &
                                 get_bottom_data,        &
                                 put_bottom_data,        &
                                 atmosphere_domain

use   bgrid_prog_var_mod, only: prog_var_type, var_init

use      bgrid_horiz_mod, only: get_horiz_grid_size,        &
                                get_horiz_grid_bound, TGRID

use     time_manager_mod, only: time_type, get_time, operator(+)

use              fms_mod, only: file_exist, open_namelist_file, &
                                error_mesg, FATAL,              &
                                check_nml_error, stdlog,        &
                                write_version_number,           &
                                mpp_pe, mpp_root_pe,            &
                                close_file, set_domain

! routines used by subroutine bgrid_physics
use bgrid_change_grid_mod, only: change_grid, TEMP_GRID, WIND_GRID
use bgrid_horiz_mod      , only: horiz_grid_type
use bgrid_vert_mod       , only: vert_grid_type, &
                                 compute_pres_full, compute_pres_half
use bgrid_halo_mod       , only: update_halo, UWND, VWND, TEMP, &
                                 NORTH, EAST, WEST, SOUTH
use shallow_physics_mod  , only: shallow_physics_init, shallow_physics, &
                                 shallow_physics_end

!-----------------------------------------------------------------------

implicit none
private

public  atmosphere,      &
        atmosphere_init, &
        atmosphere_end,  &
        atmosphere_resolution,  &
        atmosphere_boundary,    &
        get_atmosphere_axes,    &
        atmosphere_domain

!-----------------------------------------------------------------------

character(len=128) :: version = '$Id: atmosphere.F90,v 14.0 2007/03/15 21:56:36 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!-----------------------------------------------------------------------
!---- namelist (saved in file input.nml) ----
!
! physics_window  The number of "i" by "j" rows processed each time
!                 the modular physics is called. To process the entire
!                 domain use physics_window = (/0,0/).
!                   [integer, default: physics_window = 0,0]

   integer, dimension(2) :: physics_window = (/0,0/)

   namelist /atmosphere_nml/ physics_window

!-----------------------------------------------------------------------
!---- private data ----

type (bgrid_dynam_type), save :: Dynam
type    (prog_var_type), save :: Var, Var_dt
type        (time_type) :: Time_step_atmos

real                               :: dt_atmos
real,    dimension(:,:,:), pointer :: omega =>NULL()
integer, dimension(4)              :: atmos_axes

!-----------------------------------------------------------------------

contains

!#######################################################################

 subroutine atmosphere (Time)
 type (time_type), intent(in) :: Time

  type(time_type) :: Time_prev, Time_next
!-----------------------------------------------------------------------

   Time_prev = Time                       ! two time-level scheme
   Time_next = Time + Time_step_atmos

!---- dynamics -----

   call bgrid_core_driver ( Time_next, Var, Var_dt, Dynam, omega )

!---- call physics -----

   call bgrid_physics ( physics_window, dt_atmos, Time_next,  &
                        Dynam%Hgrid,   Dynam%Vgrid,    Dynam,             &
                        Var,     Var_dt                       )

!---- time differencing and diagnostics -----

   call bgrid_core_time_diff ( omega, Time_next, Dynam, Var, Var_dt )

!-----------------------------------------------------------------------

 end subroutine atmosphere

!#######################################################################

 subroutine atmosphere_init ( Time_init, Time, Time_step )

 type (time_type),     intent(in)    :: Time_init, Time, Time_step

  integer :: unit, sec, ierr, io

!-----------------------------------------------------------------------
!----- read namelist -----

    if (file_exist('input.nml')) then
        unit = open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
           read (unit, nml=atmosphere_nml, iostat=io, end=10)
           ierr = check_nml_error (io, 'atmosphere_nml')
        enddo
 10     call close_file (unit)
    endif

!----- write version and namelist to log file -----

    call write_version_number(version, tagname)
    if ( mpp_pe() == mpp_root_pe() ) write (stdlog(), nml=atmosphere_nml)

!---- compute physics/atmos time step in seconds ----

   Time_step_atmos = Time_step
   call get_time (Time_step_atmos, sec)
   dt_atmos = real(sec)

!----- initialize dynamical core -----

   call bgrid_core_driver_init ( Time_init, Time, Time_step,    &
                                 Var, Var_dt, Dynam, atmos_axes )

!----- make sure code is initialized for shallow water version -----

   if (Dynam%Vgrid%nlev /= 1) call error_mesg ('atmosphere_init', &
                          'number of model levels not correct '// &
                          'for shallow water version', FATAL)

!----- initialize storage needed for vert motion ----

    omega => var_init (Dynam%Hgrid, Dynam%Vgrid%nlev)

!----- initialize physics interface -----
! (might want to use alm,aph instead of tlm,tph)

    call shallow_physics_init ( atmos_axes, Time,  &
         Dynam%Hgrid%Tmp%tlm(Dynam%Hgrid%Tmp%is:Dynam%Hgrid%Tmp%ie), &
         Dynam%Hgrid%Tmp%tph(Dynam%Hgrid%Tmp%js:Dynam%Hgrid%Tmp%je)  )

!   ----- use entire grid as window ? -----

    if (physics_window(1) <= 0) physics_window(1) = Dynam%Hgrid%Tmp%ie-Dynam%Hgrid%Tmp%is+1
    if (physics_window(2) <= 0) physics_window(2) = Dynam%Hgrid%Tmp%je-Dynam%Hgrid%Tmp%js+1

!-----------------------------------------------------------------------

 end subroutine atmosphere_init

!#######################################################################

 subroutine atmosphere_end

 integer :: unit

    call bgrid_core_driver_end ( Var, Dynam )

 end subroutine atmosphere_end

!#######################################################################
!    returns the number of longitude and latitude grid points
!    for either the local PEs grid (default) or the global grid

 subroutine atmosphere_resolution (nlon, nlat, global)

  integer, intent(out)          :: nlon, nlat
  logical, intent(in), optional :: global

!---- return the size of the grid used for physics computations ----

    call get_horiz_grid_size (Dynam % Hgrid, TGRID, nlon, nlat, global)

 end subroutine atmosphere_resolution

!#######################################################################
!    returns the longitude and latitude grid box edges
!    for either the local PEs grid (default) or the global grid

 subroutine atmosphere_boundary (blon, blat, global)

    real,    intent(out)          :: blon(:), blat(:)
    logical, intent(in), optional :: global

!----- return the longitudinal and latitudinal grid box edges ----------

    call get_horiz_grid_bound (Dynam % Hgrid, TGRID, blon, blat, global)

 end subroutine atmosphere_boundary

!#######################################################################
!    returns the axis indices associated with the coupling grid

 subroutine get_atmosphere_axes ( axes )

   integer, intent(out) :: axes (:)

!----- returns the axis indices for the atmospheric (mass) grid -----

     if ( size(axes) < 0 .or. size(axes) > 4 ) call error_mesg (    &
                    'get_atmosphere_axes in atmosphere_mod', &
                           'size of argument is incorrect', FATAL   )

     axes (1:size(axes)) = atmos_axes (1:size(axes))

 end subroutine get_atmosphere_axes

!#######################################################################

subroutine bgrid_physics ( window, dt_phys, Time, Hgrid, Vgrid, &
                           Dynam, Var, Var_dt )

!-----------------------------------------------------------------------
!
!   Time      =  current time (time_type, see time manager)
!
!-----------------------------------------------------------------------
  integer, intent(in)                :: window(2)
  real,    intent(in)                :: dt_phys
       type(time_type),intent(in)    :: Time
type (horiz_grid_type),intent(inout) :: Hgrid
type  (vert_grid_type),intent(in)    :: Vgrid
type(bgrid_dynam_type),intent(in)    :: Dynam
type   (prog_var_type),intent(in)    :: Var
type   (prog_var_type),intent(inout) :: Var_dt

!-----------------------------------------------------------------------
  integer :: j, k, n, is, ie, js, je, i1, i2, j1, j2, idim, jdim
  integer :: timelev = +1
!-----------------------------------------------------------------------

   real, dimension(Hgrid%ilb:Hgrid%iub, &
                   Hgrid%jlb:Hgrid%jub,1) :: uh, vh, uh_dt, vh_dt, &
                                             u_dt, v_dt

!-----------------------------------------------------------------------
!---------------------------- do physics -------------------------------

    idim = window(1)
    jdim = window(2)

!   --- momentum and momentum tendency on mass grid ---

    call update_halo (Hgrid, UWND, Var_dt%u, halos=SOUTH+WEST)
    call update_halo (Hgrid, VWND, Var_dt%v, halos=SOUTH+WEST)

    call change_grid (Hgrid, WIND_GRID, TEMP_GRID,    Var%u,    Var%v, uh   , vh   )
    call change_grid (Hgrid, WIND_GRID, TEMP_GRID, Var_dt%u, Var_dt%v, uh_dt, vh_dt)

    u_dt = uh_dt  ! save copy of tendency before physics
    v_dt = vh_dt

!   --- loop through physics windows ---

    js = Hgrid%Tmp%js

    do while ( js <= Hgrid%Tmp%je )

       je = min ( js+jdim-1, Hgrid%Tmp%je )
       is = Hgrid%Tmp%is

    do while ( is <= Hgrid%Tmp%ie )

       ie = min ( is+idim-1, Hgrid%Tmp%ie )

!      ---- j-axis indices in the global physics grid ----

       j1 = js-Hgrid%Tmp%js+1; j2 = j1+(je-js)
       i1 = is-Hgrid%Tmp%is+1; i2 = i1+(ie-is)

!-----------------------------------------------------------------------
!-------------------------- call physics -------------------------------
!------------ (need to add leap-frog option for uh,vh) -----------------
!-----------------------------------------------------------------------
       call shallow_physics ( i1, i2, j1, j2, timelev, dt_phys, Time ,&
                              uh        (is:ie,js:je,1)        ,&
                              vh        (is:ie,js:je,1)        ,&
                              Var%ps    (is:ie,js:je)          ,&
                              uh        (is:ie,js:je,1)        ,&
                              vh        (is:ie,js:je,1)        ,&
                              Var%ps    (is:ie,js:je)          ,&
                              uh_dt     (is:ie,js:je,1)        ,&
                              vh_dt     (is:ie,js:je,1)        ,&
                              Var_dt%ps (is:ie,js:je)          )
                              
        is = is + idim

     enddo

        js = js + jdim

     enddo

!-----------------------------------------------------------------------
! compute momentum tendencies on mass grid for physics only
!      udt(phys) = udt(current) - udt(before physics)

     uh_dt = uh_dt - u_dt
     vh_dt = vh_dt - v_dt

!  update halos of momentum tendencies on mass grid
!  then move momentum tendencies to momentum grid

     call update_halo (Hgrid, TEMP, uh_dt, halos=NORTH+EAST)
     call update_halo (Hgrid, TEMP, vh_dt, halos=NORTH+EAST)

     call change_grid (Hgrid, TEMP_GRID, WIND_GRID, uh_dt, vh_dt, u_dt, v_dt)

     u_dt(:,Hgrid%jub,:) = 0.0   ! zero out unused polar halo row
     v_dt(:,Hgrid%jub,:) = 0.0   ! no harm done when not polar row

!---- update momentum tendencies ----

     Var_dt%u = Var_dt%u + u_dt
     Var_dt%v = Var_dt%v + v_dt

!---- update all halo rows ----

     call update_halo (Hgrid, TEMP, Var_dt%ps)
     call update_halo (Hgrid, UWND, Var_dt%u)
     call update_halo (Hgrid, VWND, Var_dt%v)

     call update_halo (Hgrid, TEMP, Var_dt%t)
     call update_halo (Hgrid, TEMP, Var_dt%r)

     Var_dt % pssl = Var_dt % ps

!-----------------------------------------------------------------------

end subroutine bgrid_physics

!#######################################################################

end module atmosphere_mod

module topog_mod
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">Z. Liang </CONTACT>
  ! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">S. M. Griffies</REVIEWER>
  !
  !<OVERVIEW>
  ! <TT>topog_mod</TT> Generate topography for ocean model. 
  !</OVERVIEW>
  !
  !<DESCRIPTION>
  !    The topography can be idealized or remapped from some source topography data.
  !    The type of topography is specified by the namelist variable "topography" and
  !    "topog_depend_on_vgrid". See the documentation of namelist variable "topography"
  !    and "topog_depend_on_vgrid" for details.
  !</DESCRIPTION>
  !
  !<NAMELIST NAME="topog_nml">
  !<DATA NAME="topography" TYPE="character(len=24)">
  !<PRE>
  ! rectangular_basin : Constructing a rectangular basin with a flat bottom
  ! bowl              : From "Simulation of density-driven frictional downslope 
  !                     flow in  z-coordinate mocean models"  Winton et al. 
  !                     JPO, Vol 28, No 11, 2163-2174,  November 1998
  ! gaussian          : sets "kmt" to a gaussian bump on a sloping bottom.
  ! dome              : similar (not identical) to DOME configuration of Legg etal Ocean Modelling (2005) 
  ! idealized         : generates an "idealized" not very realistic topography.
  ! all_land          : constructing a all land topography.
  ! from_file         : Remap the topography onto the current grid from some source data file.
  !</PRE>
  !</DATA>
  !<DATA NAME="topog_depend_on_vgrid" TYPE = "logical" >
  ! when topography /= "from_file", topog_depend_on_vgrid must be true (default value). 
  ! When it is false, topography is obtained by a simple remapping onto current grid.
  !</DATA>
  !<DATA NAME="topog_file" TYPE="character(len=128)">
  ! name of topograhy file (e.g. scripps, navy_topo, ...)
  !</DATA>
  !<DATA NAME="topog_field" TYPE="character(len=24)">
  ! name of topography field in file
  !</DATA>
  !<DATA NAME="flat_bottom" TYPE="logical">
  ! generate flat bottom over ocean points. Default value is false.
  !</DATA>
  !<DATA NAME="full_cell" TYPE="logical">
  ! do not generate partial bottom cells. Default value is false.
  !</DATA>
  !<DATA NAME="fill_isolated_cells" TYPE="logical">
  ! Do not allow non-advective tracer cells (strongly recommended). Default value is true.
  !</DATA>
  !<DATA NAME="dont_change_landmask" TYPE="logical">
  ! Do not change land/sea mask when filling isolated cells. Default value is false.
  !</DATA>
  !<DATA NAME="fill_shallow" TYPE="logical">
  ! Make cells less than minimum depth land. Default value is false. 
  !</DATA>
  !<DATA NAME="fill_first_row" TYPE="logical">
  ! if true make first row of ocean model all land points for ice model when
  ! topography is "from_file". It will do nothing when topography is not "from_file".
  ! Default value is true.
  !</DATA>
  !<DATA NAME="deepen_shallow" TYPE="logical">
  ! Make cells less than minimum depth equal to minimum depth. Default value is false.
  !</DATA>
  !<DATA NAME="round_shallow" TYPE="logical">
  ! Make cells land if depth is less than 1/2 mimumim depth, otherwise make ocean. Default value is false.
  !</DATA>
  !<DATA NAME="gauss_amp" TYPE="real" >
  ! height of gaussian bump as percentage of ocean depth
  !</DATA>
  !<DATA NAME="gauss_scale" TYPE="real">
  ! width of gaussian bump as percentag e of basin width
  !</DATA>
  !<DATA NAME="slope_x" TYPE="real" UNITS="(m/deg)">
  ! rise of the ocean floor to the east for the gaussian bump
  !</DATA>
  !<DATA NAME="slope_y" TYPE="real" UNITS="(m/deg)">
  ! rise of the ocean floor to the north for the gaussian bump
  !</DATA>
  !<DATA NAME="bowl_south" TYPE="real" UNITS="degrees">
  ! southern boundary of Winton bowl
  !</DATA>
  !<DATA NAME="bowl_north" TYPE="real" UNITS="degrees">
  ! northern boundary of Winton bowl
  !</DATA>
  !<DATA NAME="bowl_west" TYPE="real" UNITS="degrees">
  ! western boundary of Winton bowl
  !</DATA>
  !<DATA NAME="bowl_east" TYPE="real" UNITS="degrees">
  ! eastern boundary of Winton bowl
  !</DATA>
  !<DATA NAME="bowl_min_depth" TYPE="real" UNITS="meters">
  ! minimum depth of Winton bowl 
  !</DATA>
  !<DATA NAME="bowl_max_depth" TYPE="real" UNITS="meters">
  ! maximum depth of Winton bowl 
  !</DATA>
  !
  !<DATA NAME="dome_slope" TYPE="real" UNITS="radians">
  ! Slope for the dome configuration.  Default = 0.01
  !</DATA>
  !<DATA NAME="dome_bottom" TYPE="real" UNITS="m">
  ! Bottom of the dome configuration.  Default=3600.0
  !</DATA>
  !<DATA NAME="dome_embayment_west" TYPE="real" UNITS="dimensionless">
  ! western edge of dome embayment. Default=19.0
  !</DATA>
  !<DATA NAME="dome_embayment_east" TYPE="real" UNITS="dimensionless">
  ! eastern edge of dome embayment. Default=21.0
  !</DATA>
  !<DATA NAME="dome_embayment_south" TYPE="real" UNITS="dimensionless">
  ! southern edge of dome embayment. Default=69.0
  !</DATA>
  !<DATA NAME="dome_embayment_depth" TYPE="real" UNITS="m">
  ! Depth of the embayment. Default=600.0
  !</DATA>
  !<DATA NAME="kmt_min" TYPE="integer">
  ! minimum number of vertical levels
  !</DATA>
  !<DATA NAME="filter_topog" TYPE="logical">
  ! apply filter to topography. Default value is false.
  !</DATA>
  !<DATA NAME="num_filter_pass" TYPE="integer">
  ! number of passes of spatial filter
  !</DATA>
  !<DATA NAME="adjust_topo" TYPE="logical">
  ! adjust topography (enforce_min_depth;remove_isolated_cells;restrict_partial_cells)
  ! Strongly recommended. Default value is true.
  !</DATA>
  !<DATA NAME="fraction_full_cell" TYPE="real" >
  ! Fraction of the associated full cell that a corresponding partial cell thickness 
  ! is no smaller than.  That is, we maintain 
  ! partial_cell_min_dht(i,j,k) = fraction_full_cell*full_cell_dzt(k)
  ! If fraction_full_cell=0.0, then partial_cell_min_dht = min(zw(1), 50.0)
  !</DATA>
  !<DATA NAME="scale_factor" TYPE="real" >
  ! scaling factor for topography data (e.g. -1 to flip sign or 0.01 to convert from centimeters)
  !</DATA>
  !<DATA NAME="smooth_topo_allow_deepening" TYPE="logical">
  ! allow filter to deepen cells. Default value is false.
  !</DATA>
  !<DATA NAME="interp_method"  TYPE= "character(len=64)" >
  ! specifying the remapping method when remampping topography from source data to current grid.
  ! Its value can be "spherical", " bilinear" or "conservative". Default value is "bilinear". when the source
  ! topography is on the regular grid (nml src_is_spherical is true), "bilinear" interpolation 
  ! is recommanded, since bilinear interpolation will provide more smooth results than 
  ! "spherical" interpolation (especially when interpolating from coarse grid to fine grid). 
  ! Plus bilinear interpolation is much more efficiency than "spherical interpolation". 
  ! When the source data is on non-regular grid (nml src_is_spherical is false), "bilinear" 
  ! interpolation may not work well because the destination is not inside the source grid, 
  ! in this case, you need to set interp_method to "spherical".
  !</DATA>
  !<DATA NAME="num_nbrs" TYPE="integer">
  ! Number of nearest neighbors for regridding.
  !</DATA>
  !<DATA NAME="max_dist" TYPE="real" UNITS="radians">
  ! Maximum region of influence around destination grid points.
  !</DATA>
  !<DATA NAME="src_is_spherical" TYPE="logical" >
  ! Determine if the source grid is spherical grid or not. If true, source grid is spherical grid,
  ! otherwise not. Default value is .true. When src_is_spherical is .true., lon_field and lat_field
  ! need to be set.
  !</DATA>
  !<DATA NAME="lon_field" TYPE="character(len=24)">
  ! name of geographic longitude field in source file
  !</DATA>
  !<DATA NAME="lat_field" TYPE="character(len=24)">
  ! name of geographic latitude field in source file
  !</DATA>
  !<DATA NAME="output_corner_topog" TYPE="logical" >
  ! When true, will write topography information on the C-cell cneter to the grid file.
  ! Default value is false.
  !</DATA>
  !<DATA NAME="check_mask" TYPE="logical" >
  ! When true, check the possible masking ( all-land region) for certain layout. The print out message 
  ! will provide coupler_nml ( or ocean_solo_nml) entry : nmask, layout_mask and mask_list.
  ! Default value is false.
  !</DATA>
  !<DATA NAME="open_very_this_cell" TYPE="logical">
  !  When set to false, check which change is larger, opening or closing the cell, and 
  !  to do that with smaller  effect in depth_t. Default is true, will always 
  !  opening the cell.
  !</DATA>
  !<DATA NAME="min_thickness" TYPE="real" UNITS="METERS">
  !  minimum vertical thickness allowed. with default value 0.1. Increase or decrease this number as needed.
  !<DATA NAME="debug" TYPE="logical" >
  ! Control standard output. Default value is true so to show lots of information.
  !</DATA>
  !</NAMELIST>
  use mpp_mod,          only : mpp_error,FATAL, NOTE, mpp_npes, mpp_pe, mpp_root_pe, mpp_chksum
  use mpp_domains_mod,  only : domain2d, mpp_define_domains, mpp_define_layout, mpp_global_field
  use mpp_domains_mod,  only : mpp_get_compute_domain
  use mpp_io_mod,       only : axistype, fieldtype, mpp_write_meta, mpp_write, mpp_open
  use mpp_io_mod,       only : MPP_RDONLY, MPP_NETCDF, MPP_MULTI, MPP_SINGLE
  use mpp_io_mod,       only : mpp_get_info, mpp_get_fields, mpp_get_atts, mpp_get_axis_data
  use mpp_io_mod,       only : mpp_read, mpp_close
  use fms_mod,          only : lowercase, open_namelist_file, close_file, check_nml_error
  use fms_mod,          only : stdout, write_version_number, file_exist, string
  use axis_utils_mod,   only : nearest_index, get_axis_cart, get_axis_bounds
  use grids_type_mod,   only : hgrid_data_type, vgrid_data_type, topog_data_type
  use grids_util_mod,   only : write_field_meta, write_field_data, get_file_unit
  use horiz_interp_mod, only : horiz_interp
  use constants_mod,    only : pi
  use check_mask_mod,   only : checking_mask

  implicit none
  private

  !--- namelist variables ----------------------------------------------
  character(len=128) :: topog_file = 'scripps'
  character(len=24)  :: topog_field = 'topog'
  character(len=24)  :: topography = 'from_file'
  logical            :: topog_depend_on_vgrid = .TRUE.
  logical :: flat_bottom=.false.          ! sets ocean bottom to the deepest level when true
  logical :: full_cell=.false.            ! sets bottom cell thickness equal to thickness of vertical level when true 
  logical :: fill_isolated_cells=.true. 
  logical :: fill_first_row = .true.
  logical :: dont_change_landmask=.false. ! when filling isolated cells
  real    :: gauss_amp=0.50               ! height of gaussian bump as a percent of max ocean depth 
  real    :: gauss_scale=0.25             ! half width of gaussian bump as a percent of basin width
  real    :: slope_x=0.0                  ! (m/deg) rise of the ocean floor to the east for the gaussian bump
  real    :: slope_y=0.0                  ! (m/deg) rise of the ocean floor to the north for the gaussian bump 
  real    :: bowl_south=60.0              ! southern boundary of Winton bowl (deg)
  real    :: bowl_north=70.0              ! northern boundary of Winton bowl (deg)
  real    :: bowl_west=0.0                ! western boundary of Winton bowl (deg)
  real    :: bowl_east=20.0               ! eastern boundary of Winton bowl (deg)
  real    :: bowl_min_depth=500.0         ! unit is m
  real    :: bowl_max_depth=3000.0        ! unit is m
  real    :: read_epsln=.1                

  real    :: dome_slope=0.01              ! slope for the dome configuration (radians)
  real    :: dome_bottom=3600.0           ! bottom depth (m) of the dome configuration 
  real    :: dome_embayment_west=19.0     ! western edge of dome embayment (degrees)
  real    :: dome_embayment_east=21.0     ! eastern edge of dome embayment (degrees)
  real    :: dome_embayment_south=69.0    ! southern edge of the dome embayment (degrees)
  real    :: dome_embayment_depth=600.0   ! depth of the dome embayment (m)

  real    :: deg2metre=111.324e3          ! convert degrees latitude to metres  

  logical :: fill_shallow = .false.
  logical :: deepen_shallow = .false.
  logical :: round_shallow=.false.
  integer :: kmt_min = 2, num_filter_pass = 1, num_nbrs = 10
  logical :: filter_topog=.false.
  logical :: adjust_topo = .true.
  real    :: fraction_full_cell=0.20      ! partial cell thickness >= fraction_full_cell*dzt 
  real    :: scale_factor=1               ! scaling factor for topography (e.g. -1 to flip sign)
  logical :: smooth_topo_allow_deepening = .false.
  real    :: max_dist=0.1
  character(len=64) :: interp_method = 'bilinear'
  logical           :: src_is_spherical = .true.
  character(len=24) :: lon_field        = 'x_T'
  character(len=24) :: lat_field        = 'y_T'
  logical :: output_corner_topog        = .false.
  logical :: check_mask                 = .false.
  logical :: open_very_this_cell        = .true.
  real    :: min_thickness              = 0.1
  logical :: debug = .true.

  namelist /topog_nml/ topography, topog_depend_on_vgrid, topog_file, topog_field, &
       flat_bottom, full_cell, fill_isolated_cells, dont_change_landmask,          &
       fill_shallow, deepen_shallow, round_shallow, gauss_amp, gauss_scale,        &
       slope_x, slope_y, bowl_south, bowl_north, bowl_east, bowl_west,             &
       bowl_max_depth, bowl_min_depth, kmt_min, filter_topog, num_filter_pass,     &
       scale_factor, adjust_topo, smooth_topo_allow_deepening,num_nbrs,max_dist,   &
       debug, fill_first_row, fraction_full_cell, interp_method, src_is_spherical, &
       lon_field, lat_field, output_corner_topog, check_mask, open_very_this_cell, &
       min_thickness, dome_slope, dome_bottom, dome_embayment_west,                &
       dome_embayment_east, dome_embayment_south, dome_embayment_depth

!--- namelist variables for OBC ----------------------------------------------

  integer, parameter :: max_obc = 4      ! maximum number of open boundaries (increase if want more)
  integer                               :: nobc= 0
  character(len=10), dimension(max_obc) :: direction='none' ! open directions; to be consistent with is, ie, js, je
  integer, dimension(max_obc)           :: is=-999, ie=-999, js=-999, je=-999     ! boundary position
  integer, dimension(max_obc)           :: nsmooth=2        ! number of points to be smoothed
  character(len=32), dimension(max_obc) :: name='none' 
  
  namelist /obc_nml/ nobc, direction, is, ie, js, je, nsmooth, name

  !--- version information ---------------------------------------------
  character(len=128) :: version = '$Id: topog.f90,v 20.0 2013/12/14 00:30:50 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'  
  !--- other variables
  logical              :: module_is_initialized = .false.
  real                 :: grid_tol = 1.e-2
  type(fieldtype),save :: fld_depth, fld_num_levels, fld_wet
  real                 :: small = 0.
  logical              :: have_obc = .false.

  !---public interface -------------------------------------------------

  public :: generate_topog, topog_init, topog_end, process_topo, write_topog_global_meta 
  public :: write_topog_field_meta, write_topog_data, show_deepest,  set_topog_nml

contains

  !#######################################################################
  !<SUBROUTINE NAME="topog_init">
  !   <OVERVIEW>
  !    Initialization routine.
  !   </OVERVIEW>
  !
  !<DESCRIPTION>
  !   Read topography namelist.
  !</DESCRIPTION>
  !   <TEMPLATE>
  !     call topog_init(Topog, Hgrid)
  !   </TEMPLATE>
  !<IN NAME="Hgrid" TYPE="type(hgrid_data_type)">
  !   A derived-type variable that contains horizontal grid information.
  !</IN>
  !<INOUT NAME="Topog" TYPE="type(topog_data_type)">
  !   A derived-type variable that contains topography.
  !</INOUT>
  !</SUBROUTINE>

  subroutine topog_init(Topog, Hgrid)
    type(hgrid_data_type),   intent(in)  :: Hgrid
    type(topog_data_type), intent(inout) :: Topog

    integer :: unit, ierr, io, ni, nj

    !---- read namelist --------------------------------------------------
    unit = open_namelist_file ( )
    ierr=1
    do while (ierr /= 0)
       read  (unit, nml=topog_nml, iostat=io, end=10)
       ierr = check_nml_error(io,'topog_nml')  ! also initializes nml error codes
    enddo
10  call close_file (unit)
    unit = open_namelist_file ( )
    ierr=1
    do while (ierr /= 0)
       read  (unit, nml=obc_nml, iostat=io, end=20)
       ierr = check_nml_error(io,'obc_nml')  ! also initializes nml error codes
    enddo
20  call close_file (unit)

    !--- write version info and namelist to logfile ----------------------

    call write_version_number(version, tagname)
    write (stdout(), nml=topog_nml)
    write (stdout(), nml=obc_nml)

    if(trim(topography) == 'from_file') then
       if(trim(interp_method) .ne. 'spherical' .and. trim(interp_method) .ne. 'bilinear' &
                                          .and. trim(interp_method) .ne. 'conservative') &
          call mpp_error(FATAL, 'topog_mod: interp_method = '// trim(interp_method)//' is not a valid option')
       if(src_is_spherical) then
          if( trim(interp_method) == 'spherical' ) write(stdout(),*)" NOTE from topog_mod: ", &
              "when src_is_spherical is true, interp_methos set to 'bilinear' is recommanded"
       endif
    endif

    if(.NOT. topog_depend_on_vgrid .AND. (trim(topography) .NE. 'from_file' .and. trim(topography) .NE. 'all_land') ) &
         call mpp_error(FATAL, &
        'topog_mod: when topography /= "from_file" or "all_land", topog_depend_on_vgrid should be true' )

    ni = Hgrid%ni
    nj = Hgrid%nj

    allocate(Topog%depth_t(ni,nj), Topog%num_levels(ni,nj))
    if(output_corner_topog) allocate(Topog%depth_c(ni, nj), Topog%num_levels_c(ni, nj))

    if (nobc > 0) have_obc = .true.

    module_is_initialized = .true.

    return

  end subroutine topog_init

  !#######################################################################
  !<SUBROUTINE NAME="generate_topog">
  !<OVERVIEW>
  !  generate topography data.
  !</OVERVIEW>
  !<DESCRIPTION>
  !Call horiz_interp to calculate regridded topography.
  !Perform topography checks
  !</DESCRIPTION>
  !   <TEMPLATE>
  !     call generate_topog(Hgrid, Topog, Vgrid)
  !   </TEMPLATE>
  !<IN NAME="Hgrid" TYPE="type(hgrid_data_type)">
  !  A derived-type variable that contains horizontal grid information.
  !</IN>
  !<IN NAME="Vgrid" TYPE="type(vgrid_data_type), optional">
  !  A derived-type variable that contains vertical grid information.
  !</IN>
  !<INOUT NAME="Topog" TYPE="type(topog_data_type)">
  !  A derived-type variable that contains topography data.
  !</INOUT>   
  !</SUBROUTINE>

  subroutine generate_topog( Topog, Hgrid, Vgrid)
    type(topog_data_type), intent(inout) :: Topog
    type(hgrid_data_type), intent(in)    :: Hgrid
    type(vgrid_data_type), intent(in), optional  :: Vgrid

    real, dimension(:,:), allocatable    :: ht
    real, dimension(:,:), allocatable    :: hu
    real, dimension(:,:), allocatable    :: dxte, dytn
    real, dimension(:,:), allocatable    :: lonv, latv
    real, dimension(:,:,:), allocatable  :: xv, yv
    integer, dimension(:,:), allocatable :: kmt
    integer, dimension(:,:), allocatable :: kmu
    logical                              :: tripolar_grid, cyclic_x, cyclic_y
    integer                              :: pe, ni ,nj, i, j

    if(topog_depend_on_vgrid) then
       if(.not. present(Vgrid)) call mpp_error(FATAL, 'topog_mod: when topog_depend_on_vgrid is true, Vgrid is needed')
    else
       if(present(Vgrid)) call mpp_error(FATAL, 'topog_mod: when topog_depend_on_vgrid is false, Vgrid is not needed')
    endif

    tripolar_grid = Hgrid%tripolar_grid
    cyclic_x      = Hgrid%cyclic_x
    cyclic_y      = Hgrid%cyclic_y

    ni = Hgrid%ni; nj = Hgrid%nj
    allocate(ht(0:ni+1, 0:nj+1), kmt(0:ni+1,0:nj+1), Topog%wet(ni,nj))
    kmt=0
    ht = 0.0
    if(output_corner_topog) then
    allocate(hu(0:ni+1, 0:nj+1), kmu(0:ni+1,0:nj+1), Topog%wet_c(ni,nj))
       kmu=0
       hu = 0.0
    end if

    select case (trim(topography))
    case('rectangular_basin')
       call rectangular_basin(Vgrid%zb, ht(1:ni,1:nj) )
       kmt(:,:) = size(Vgrid%zb)
    case('bowl')             
       call bowl(Hgrid%T%x(1:ni,1:nj), Hgrid%T%y(1:ni,1:nj), Vgrid%zb, ht(1:ni,1:nj) )  
    case('gaussian')         
       call gaussian(Hgrid%T%x(1:ni,1:nj), Hgrid%T%y(1:ni,1:nj), Vgrid%zb, ht(1:ni,1:nj) ) 
    case('dome')         
       call dome(Hgrid%T%x(1:ni,1:nj), Hgrid%T%y(1:ni,1:nj), Vgrid%zb, ht(1:ni,1:nj) ) 
    case('idealized')
       call idealized (Hgrid%T%x(1:ni,1), Hgrid%T%y(1,1:nj), Vgrid%zb, ht(1:ni,1:nj), kmt(1:ni,1:nj)  )
    case('all_land') 
       ht(:,:) = 0.0
       kmt(:,:) = 0
    case ( 'from_file' )
       if(interp_method == "conservative") then
          allocate(lonv(ni+1, nj+1), latv(ni+1, nj+1) )
          allocate(xv(ni,nj,4), yv(ni,nj,4) )
          call mpp_global_field(Hgrid%Domain, Hgrid%T%x_vert, xv)
          call mpp_global_field(Hgrid%Domain, Hgrid%T%y_vert, yv)
          lonv(1:ni,1:nj) = xv(1:ni,1:nj,1)
          lonv(ni+1,1:nj) = xv(ni,  1:nj,2)
          lonv(1:ni,nj+1) = xv(1:ni,  nj,3)
          lonv(ni+1,nj+1) = xv(ni,    nj,4)
          latv(1:ni,1:nj) = yv(1:ni,1:nj,1)
          latv(ni+1,1:nj) = yv(ni,  1:nj,2)
          latv(1:ni,nj+1) = yv(1:ni,  nj,3)
          latv(ni+1,nj+1) = yv(ni,    nj,4)
          call get_topog_from_file(lonv, latv, ht(1:ni,1:nj) )
          deallocate(xv, yv, lonv, latv)
       else
          call get_topog_from_file(Hgrid%T%x(1:ni,1:nj), Hgrid%T%y(1:ni,1:nj), ht(1:ni,1:nj) )
       end if
         ht = scale_factor*ht         ! flip sign or change units (user specified) 
         where (ht < 0) ht = 0        ! set elevation of land points to zero
    case default 
       call mpp_error(FATAL,'topog_mod: '//trim(topography)//' is not a valid option of nml "topography" ')
    end select

    if (filter_topog) call filter_topo(ht(1:ni,1:nj), num_filter_pass)

    !--- process topography if needed
    if(topog_depend_on_vgrid) then

       ! Compare "ht" to bottom of deepest model level. 
       if(debug) call show_deepest(Vgrid%zb, ht(1:ni,1:nj) )

       ! make first row of ocean model all land points for ice model
       if(fill_first_row .and. trim(topography) == "from_file" )  ht(:,1) = 0.0 
    
       !--- for idealized topog, do not need to process topography
       if(trim(topography) .ne. "all_land" .and. trim(topography) .ne. "idealized" ) then
          ! Discretize "kmt" based on "ht" and zw(1..nk). 
          allocate(dxte(ni,nj), dytn(ni,nj))
          call mpp_global_field(Hgrid%Domain, Hgrid%E%ds_01_21, dxte)
          call mpp_global_field(Hgrid%Domain, Hgrid%N%ds_10_12, dytn)
          call process_topo(ht, kmt, Vgrid%zb, dxte, dytn,    &
               Hgrid%T%x(1:ni,1:nj), Hgrid%T%y(1:ni,1:nj) , tripolar_grid, cyclic_x, cyclic_y)
          deallocate(dxte, dytn)
       endif
    endif
    if (have_obc) call prep_obc_topog(kmt, ht, Hgrid%ni, Hgrid%nj)

    if(output_corner_topog) then
       do j=1,nj
          do i=1,ni
             kmu(i,j) = min(kmt(i,j), kmt(i+1,j), kmt(i,j+1), kmt(i+1,j+1))
             hu (i,j) = min(ht (i,j), ht (i+1,j), ht (i,j+1), ht (i+1,j+1))
          enddo
       enddo
    end if

    !--- define topography data -----------------------------------------
    Topog%depth_t(1:ni,1:nj)      = ht(1:ni,1:nj)
    if(topog_depend_on_vgrid) Topog%num_levels(1:ni,1:nj) = kmt(1:ni,1:nj)
    if(output_corner_topog) then
    Topog%depth_c(1:ni,1:nj)      = hu(1:ni,1:nj)
       if(topog_depend_on_vgrid) Topog%num_levels_c(1:ni,1:nj) = kmu(1:ni,1:nj)
    end if

    !--- define land/sea mask --------------------------------------
    Topog%wet = 0.0
    where(Topog%depth_t .gt. 0.0) Topog%wet = 1.0
    if(output_corner_topog) then
    Topog%wet_c = 0.0
    where(Topog%depth_c .gt. 0.0) Topog%wet_c = 1.0
    end if

    if(check_mask) call checking_mask(Topog%wet, cyclic_x, cyclic_y, tripolar_grid, have_obc)

    !--- chcksum ---------------------------------------------------
    if(debug) then
       pe = mpp_pe()
       write (stdout(),'(/(a,I20/))')'topog chksum: depth_t = ',   mpp_chksum(Topog%depth_t, (/pe/))
       if(topog_depend_on_vgrid) write (stdout(),'(/(a,I20/))')'topog chksum: num_levels = ', &
              mpp_chksum(Topog%num_levels, (/pe/))
       write (stdout(),'(/(a,I20/))')'topog chksum: wet = ',       mpp_chksum(Topog%wet, (/pe/))
       if(output_corner_topog) then
       write (stdout(),'(/(a,I20/))')'topog chksum: depth_c = ',   mpp_chksum(Topog%depth_c, (/pe/))
          if(topog_depend_on_vgrid) write (stdout(),'(/(a,I20/))')'topog chksum: num_levels_c = ', &
               mpp_chksum(Topog%num_levels_c, (/pe/))
       write (stdout(),'(/(a,I20/))')'topog chksum: wet_c = ',       mpp_chksum(Topog%wet_c, (/pe/))
    endif
        endif

    deallocate(ht, kmt)
    if(output_corner_topog) deallocate(hu, kmu)

    return

  end subroutine generate_topog

  !#######################################################################
  ! <SUBROUTINE NAME="write_topog_meta">

  !   <OVERVIEW>
  !     Write out topography meta data.
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     call write_topog_meta(unit, axis_x, axis_y)
  !   </TEMPLATE>
  !   <IN NAME="unit" TYPE="integer" >
  !     The unit corresponding the output netcdf file. Always is returned by mpp_open.
  !   </IN>
  !   <IN NAME="axis_x, axis_y" TYPE="type(axistype)">
  !     axis of T-cell center
  !   </IN>
  ! </SUBROUTINE>


  subroutine write_topog_global_meta(file)
    character(len=*), intent(in) :: file    
    real                         :: ttmp
    integer                      :: unit
        
    if(mpp_pe() .ne. mpp_root_pe() ) return

    !--- get the io unit associated with file
    unit = get_file_unit(file)

    call mpp_write_meta(unit,'topography', cval=trim(topography) )
    if(trim(topography) == 'from_file') then
       call mpp_write_meta(unit,'input_file',cval=trim(topog_file))
       call mpp_write_meta(unit,'input_field',cval=trim(topog_field))
    end if

    if (full_cell) call mpp_write_meta(unit,'full_cell',cval='y')
    if (fill_isolated_cells) call mpp_write_meta(unit,'fill_isolated_cells',cval='y')
    if (fill_first_row .and. trim(topography) == "from_file" )  &
             call mpp_write_meta(unit,'fill_first_row',cval='y')
    if (dont_change_landmask) call mpp_write_meta(unit,'dont_change_landmask',cval='y')
    if (fill_shallow) call mpp_write_meta(unit,'fill_shallow',cval='y')
    if (deepen_shallow) call mpp_write_meta(unit,'deepen_shallow',cval='y')
    if (round_shallow) call mpp_write_meta(unit,'round_shallow',cval='y')
    if (adjust_topo) call mpp_write_meta(unit,'adjust_topo',cval='y')
    if (filter_topog) then
       call mpp_write_meta(unit,'filter_topog',cval='y')
       ttmp=num_filter_pass
       call mpp_write_meta(unit,'num_filter_pass',rval=ttmp)
    endif

  end subroutine write_topog_global_meta

  !#####################################################################

  subroutine write_topog_field_meta(file)
    character(len=*),      intent(in) :: file

    if(mpp_pe() .ne. mpp_root_pe() ) return

    call write_field_meta(file,'depth_t','meters', 'topographic depth of T-cell', 2)
    if(output_corner_topog) call write_field_meta(file,'depth_c','meters', 'topographic depth of C-cell', 2, 'C', 'C')
    if(topog_depend_on_vgrid) &
    call write_field_meta(file,'num_levels', 'none', 'number of vertical T-cells', 2)
    if(output_corner_topog .and. topog_depend_on_vgrid) &
    call write_field_meta(file,'num_levels_c', 'none', 'number of vertical C-cells', 2, 'C', 'C')
    call write_field_meta(file, 'wet', 'none','land/sea flag (0=land) for T-cell', 2)
    if(output_corner_topog) call write_field_meta(file, 'wet_c', 'none','land/sea flag (0=land) for C-cell', 2, 'C', 'C')

    return
  end subroutine write_topog_field_meta

  !#######################################################################
  ! <SUBROUTINE NAME="write_topog_data">
  !   <OVERVIEW>
  !     write the topography data to netcdf file
  !   </OVERVIEW>
  !   <TEMPLATE>
  !     call write_topog_data (unit,Topog)
  !   </TEMPLATE>
  !   <IN NAME="unit" TYPE="integer" >
  !     The unit corresponding the output netcdf file. Always is returned by mpp_open.
  !   </IN>
  !   <IN NAME="Topog" TYPE="type(topog_data_type)">
  !     A derived-type variable that contains topography data.
  !   </IN>
  ! </SUBROUTINE>

  subroutine write_topog_data(file, Topog)
    character(len=*),      intent(in) :: file
    type(topog_data_type), intent(in) :: Topog

    call write_field_data(file, 'depth_t', Topog%depth_t)
    if(output_corner_topog) call write_field_data(file, 'depth_c', Topog%depth_c)
    if(topog_depend_on_vgrid) call write_field_data(file, 'num_levels', Topog%num_levels)
    if(output_corner_topog .and. topog_depend_on_vgrid) call write_field_data(file, 'num_levels_c', Topog%num_levels_c)
    call write_field_data(file, 'wet', Topog%wet)
    if(output_corner_topog) call write_field_data(file, 'wet_c', Topog%wet_c)

    return
  end subroutine write_topog_data

  !#######################################################################
  ! <SUBROUTINE NAME="topog_end">

  !   <OVERVIEW>
  !     Destruction routine.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Deallocates memory used by "topog_data_type" variables.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call topog_end ( Topog )
  !   </TEMPLATE>
  !   <INOUT NAME="Topog" TYPE="type(topog_data_type)">
  !     A derived-type variable that contains topography data.
  !   </INOUT>
  ! </SUBROUTINE>

  subroutine topog_end(Topog)
    type(topog_data_type), intent(inout) :: Topog

    deallocate( Topog%depth_t, Topog%num_levels, Topog%wet)
    if(output_corner_topog) deallocate( Topog%depth_c, Topog%num_levels_c, Topog%wet_c )
    module_is_initialized = .false.

    return

  end subroutine topog_end

  !#######################################################################
  !--- get the minimum depth of surrounding cells
  function hmin(ht, i,j)
    real, dimension(0:,0:), intent(in) :: ht
    integer,                intent(in) :: i, j
    real :: hmin

    hmin = min(ht(i,j), ht(i+1,j), ht(i,j+1), ht(i+1,j+1))
    return

  end function hmin

  !#######################################################################
  !--- get the minimum number of vertical levels of surrounding cells
  function kmin(kmt, i,j)
    integer, dimension(0:,0:), intent(in) :: kmt
    integer,                   intent(in) :: i, j
    integer :: kmin

    kmin = min(kmt(i,j), kmt(i+1,j), kmt(i,j+1), kmt(i+1,j+1))
    return

  end function kmin

  !#######################################################################
  !--- analyze topographic slopes and write to standard output.
  subroutine analyze_topographic_slopes(dxte, dytn, geolon_t, geolat_t, ht, kmt, nk)
    real, dimension(:,:), intent(in)    :: dxte, dytn
    real, dimension(:,:), intent(in)    :: geolon_t, geolat_t
    real, dimension(:,:), intent(in)    :: ht
    integer, dimension(:,:), intent(in) :: kmt
    integer,              intent(in)    :: nk

    integer,dimension(:), allocatable :: slope
    integer :: i, j, k, nbin, it, iu, jt, ju, ni, nj
    real    :: sum_t, sum_u, slope_t, slope_u

    ni = size(ht,1); nj = size(ht,2)
    allocate (slope(nk))
    slope(:) = 0
    do j=1,nj-1
       do i=1,ni-1
          if (kmt(i+1,j) > 0 .and. kmt(i,j) > 0) then
             nbin = abs(kmt(i+1,j) - kmt(i,j)) + 1
             slope(nbin) = slope(nbin) + 1
          endif
          if (kmt(i,j+1) > 0 .and. kmt(i,j) > 0) then
             nbin = abs(kmt(i,j+1) - kmt(i,j)) + 1
             slope(nbin) = slope(nbin) + 1
          endif
       enddo
    enddo

    ! not checking the slopes at the boundaries here since it is unclear how
    ! to handle tripolar grid.  need to resolve !!

    write (stdout(),'(//,10x,a/)') 'How well does the specified resolution resolve Topography?'
    sum_t = 0.0; sum_u = 0.0
    do k=1,nk
       sum_t = sum_t + slope(k)
       sum_u = sum_u + slope(k)
    enddo

    if (full_cell) then
       write (stdout(),'(/a)') ' Note: Since full_cell = true, topography cannot be well &
            & resolved and this analysis is inappropriate.'
       write (stdout(),'(a/)') '       Set full_cell = false to see the analysis.'
       write (stdout(),'(/a)') ' Warning: full_cell = true is only meant for testing the partial cell algorithm.'
       write (stdout(),'(a/)') '          Its use is not recommended for physically realistic experiments.'
    else
       if (slope(1) /= 0) write (stdout(),'(1x,i8,a,f7.3,a)') slope(1), ' T-cell slopes (',100.0*slope(1)/sum_t,&
            '%) are resolved without any change in vertical levels.'
       if(nk .gt. 2) then
          if (slope(2) /= 0) write (stdout(),'(1x,i8,a,f7.3,a)') slope(2), ' T-cell slopes (',100.0*slope(2)/sum_t,&
               '%) are resolved by a change of 1 vertical level.'
       endif
       do k=3,nk
          if (slope(k) /= 0) write (stdout(),'(1x,i8,a,f7.3,a,i3,a)') slope(k), ' T-cell slopes (',100.0*slope(k)/sum_t,&
               '%) require a change of ',k-1,' vertical levels and are thus unresolved.'
       enddo
    endif
    deallocate (slope)

    ! compute maximum slopes

    slope_t = 0.0
    slope_u = 0.0
    iu=1; ju=1; it=1; jt=1
    ! these are approximate slopes where grids are unevenly spaced.
    ! fix this
    do j=1,nj-1
       do i=1,ni-1
          if (ht(i,j) /= 0.0 .and. ht(i+1,j) /= 0.0) then
             if (slope_t < abs((ht(i+1,j)-ht(i,j))/dxte(i,j))) then
                slope_t = abs((ht(i+1,j)-ht(i,j))/dxte(i,j))
                it = i; jt = j
             endif
          endif
          if (ht(i,j) /= 0.0 .and. ht(i,j+1) /= 0.0) then
             if (slope_t < abs((ht(i,j+1)-ht(i,j))/dytn(i,j))) then
                slope_t = abs((ht(i,j+1)-ht(i,j))/dytn(i,j))
                it = i; jt = j
             endif
          endif
       enddo
    enddo

    write (stdout(),'(/,a,f8.6,a,i4,a1,i4,a,f7.2,a,f7.2,a)') ' The maximum T-cell slope =',slope_t,&    
         ' at (i,j) = (',it,',',jt,'),  (lon,lat) = (',geolon_t(it,jt),',',geolat_t(it,jt),')'
  end subroutine analyze_topographic_slopes

  !#######################################################################
  !--- Constructing a rectangular basin with a flat bottom
  subroutine rectangular_basin(zw, ht)
    real, dimension(:),      intent(in) :: zw
    real, dimension(:,:), intent(inout) :: ht

    integer :: i, j, ni, nj, nk

    ni = size(ht,1); nj = size(ht,2); nk = size(zw)

    write (stdout(),'(/a/)')' Constructing a rectangular basin with a flat bottom.'

    do j=1,nj
       do i=1,ni
          ht(i,j) = zw(nk)
       enddo
    enddo
  end subroutine rectangular_basin

  !#######################################################################
  !--- Constructing a gaussian bump
  subroutine gaussian(geolon_t, geolat_t, zw, ht)
    real, dimension(:,:),   intent(in)  :: geolon_t, geolat_t
    real, dimension(:),     intent(in)  :: zw
    real, dimension(:,:), intent(inout) :: ht

    real    :: bump_height, bump_scale, xcent, ycent, arg, bottom
    real    :: xe, xw, ys, yn
    integer :: i, j, ni, nj, nk

    ni = size(ht,1); nj = size(ht,2); nk = size(zw)

    xw = geolon_t(1,1); ys = geolat_t(1,1); xe = xw; yn = ys
    do j=1,nj
       do i=1,ni
          xw = min(geolon_t(i,j),xw); xe = max(geolon_t(i,j),xe)
          ys = min(geolat_t(i,j),ys); yn = max(geolat_t(i,j),yn)
       enddo
    enddo

    bump_height = gauss_amp*zw(nk)
    bump_scale = gauss_scale*min(xe-xw, yn-ys)
    xcent = 0.5*(xe+xw)
    ycent = 0.5*(yn+ys)
    write (stdout(),'(/a,f8.2,a,f8.2,a)')&
         ' Constructing a gaussian bump of height =', bump_height,' meters with a scale width of ', bump_scale,' degrees.'
    write (stdout(),'(a,f6.2,a,f6.2,a)') ' The bump is centered at (lon,lat) = (',xcent,',',ycent,') deg.'
    write (stdout(),'(a,f8.2,a,f8.2,a/)') ' The ocean floor rises with a slope of ',slope_x, &
         ' meters/deg towards the east and ', slope_y,' meters/deg to the north.'
    do j=1,nj
       do i=1,ni
          arg = ((geolon_t(i,j)-xcent)**2 + (geolat_t(i,j) - ycent)**2)
          bottom = zw(nk) - bump_height*exp(-arg/bump_scale**2)
          bottom = bottom - slope_x*(geolon_t(i,j)-xw)- slope_y*(geolat_t(i,j)-ys)
          ht(i,j) = max(bottom,zw(2))  
       enddo
    enddo

    return

  end subroutine gaussian



  !#######################################################################
  !--- Construct a domain similar to the DOME configuration used in 
  !    Legg, Hallberg, and Girton (2005) Ocean Modelling.  
  !
  !
  !                       |     |
  !                       |     |
  !                      /|     |
  !                     / |     |
  !     up             /  |     |
  !     ^             /   |     |
  !     |            /    |     |
  !     |           /     |     |
  !                /      |     |
  !---------------/-------|-----|
  !     --->north 
  !
  !
  subroutine dome (geolon_t, geolat_t, zw, ht)
    real, dimension(:,:),   intent(in)  :: geolon_t, geolat_t
    real, dimension(:),     intent(in)  :: zw
    real, dimension(:,:), intent(inout) :: ht

    real    :: xe, xw, ys, yn
    real    :: xe_embay, xw_embay, yn_embay, ys_embay
    real    :: yn_slope, ys_slope
    real    :: height 
    integer :: inear, jnear
    integer :: i, j, ni, nj, nk

    ni = size(ht,1); nj = size(ht,2); nk = size(zw)

    ! determine full domain extents 
    xw = geolon_t(1,1); ys = geolat_t(1,1); xe = xw; yn = ys
    do j=1,nj
       do i=1,ni
          xw = min(geolon_t(i,j),xw); xe = max(geolon_t(i,j),xe)
          ys = min(geolat_t(i,j),ys); yn = max(geolat_t(i,j),yn)
       enddo
    enddo

    ! define embayment location
    xw_embay = dome_embayment_west 
    xe_embay = dome_embayment_east 
    yn_embay = yn
    ys_embay = dome_embayment_south

    ! find grid (lat,lon) corresponding to embayment specifications 
    do j=1,1 
      do i=1,ni-1
         if(geolon_t(i,j) <= xw_embay .and. geolon_t(i+1,j) >= xw_embay) then 
           xw_embay = geolon_t(i,j)
         endif 
         if(geolon_t(i,j) <= xe_embay .and. geolon_t(i+1,j) >= xe_embay) then 
           xe_embay = geolon_t(i,j)
         endif 
      enddo
    enddo
    do j=1,nj-1
      do i=1,1
         if(geolat_t(i,j) <= ys_embay .and. geolat_t(i,j+1) >= ys_embay) then 
           ys_embay = geolat_t(i,j)
         endif 
      enddo
    enddo

    ! define latitudes sloping surface starts and finishes 
    yn_slope = ys_embay
    ys_slope = yn_slope - (dome_bottom-dome_embayment_depth)/(dome_slope*deg2metre) 
    do j=1,nj-1
      do i=1,1
         if(geolat_t(i,j) <= ys_slope .and. geolat_t(i,j+1) >= ys_slope) then 
           ys_slope = geolat_t(i,j)
         endif 
      enddo
    enddo

    write (stdout(),'(/a)')     ' Constructing DOME configuration topography'
    write(stdout(),'(/a,f10.4)')' western boundary (longitude) of full domain = ',xw
    write(stdout(),'(a,f10.4)') ' eastern boundary (longitude) of full domain = ',xe
    write(stdout(),'(a,f10.4)') ' southern boundary (latitude) of full domain = ',ys
    write(stdout(),'(a,f10.4)') ' northern boundary (latitude) of full domain = ',yn

    write(stdout(),'(a,f10.4)') ' depth (m) of the embayment                  = ',dome_embayment_depth
    write(stdout(),'(a,f10.4)') ' depth (m) of the domain bottom              = ',dome_bottom
    write(stdout(),'(a,f10.4)') ' western boundary (longitude) of embayment   = ',xw_embay 
    write(stdout(),'(a,f10.4)') ' eastern boundary (longitude) of embayment   = ',xe_embay 
    write(stdout(),'(a,f10.4)') ' southern boundary (latitude) of embayment   = ',ys_embay
    write(stdout(),'(a,f10.4)') ' northern boundary (latitude) of embayment   = ',yn_embay
 
    write(stdout(),'(/a,f10.4)')' slope of the dome configuration             = ',dome_slope
    write(stdout(),'(a,f10.4)') ' northern boundary (latitude) of slope       = ',yn_slope 
    write(stdout(),'(a,f10.4)') ' southern boundary (latitude) of slope       = ',ys_slope 


    ! define flat bottom
    do j=1,nj
       do i=1,ni
          ht(i,j) = dome_bottom 
       enddo
    enddo

    ! define sloping bottom 
    do j=1,nj
       do i=1,ni
          if(geolat_t(i,j) >= ys_slope .and. geolat_t(i,j) < yn_slope) then 
              height  = dome_slope*deg2metre*(geolat_t(i,j)-ys_slope)
              ht(i,j) = dome_bottom - height
          endif
       enddo
    enddo
    
    ! define shelf
    do j=1,nj
       do i=1,ni
          if(geolat_t(i,j) >= yn_slope) then 
              ht(i,j) = 0.0
          endif
       enddo
    enddo

    ! define embayment 
    do j=1,nj
       do i=1,ni
          if(geolon_t(i,j) >= xw_embay .and. geolon_t(i,j) <= xe_embay .and. &
             geolat_t(i,j) >= ys_embay .and. geolat_t(i,j) <= yn_embay) then
             ht(i,j) = dome_embayment_depth
          endif
       enddo
    enddo
  

    return

  end subroutine dome



  !#######################################################################
  ! From "Simulation of density-driven frictional downslope flow in z-coordinate mocean models"
  ! Winton et al. JPO, Vol 28, No 11, 2163-2174, November 1998
  subroutine bowl(geolon_t, geolat_t, zw, ht)
    real, dimension(:,:),   intent(in)  :: geolon_t, geolat_t
    real, dimension(:),     intent(in)  :: zw
    real, dimension(:,:), intent(inout) :: ht

    real    :: bottom
    integer :: i, j, ni, nj

    ni = size(ht,1); nj = size(ht,2)

    write (stdout(),'(/a)') ' Constructing a Winton bowl.'
    do j=1,nj
       do i=1,ni
          if (geolon_t(i,j) <= bowl_west .or. geolon_t(i,j) >= bowl_east &
               .or. geolat_t(i,j) <= bowl_south .or. geolat_t(i,j) >= bowl_north) then           
             bottom = bowl_min_depth
          else
             bottom = bowl_min_depth + bowl_max_depth*(1.0-exp(-((geolat_t(i,j)-bowl_south)/2.0)**2))&
                  *(1.0-exp(-((geolat_t(i,j)-bowl_north)/2.0)**2))&
                  *(1.0-exp(-((geolon_t(i,j)-bowl_west)/4.0)**2))&
                  *(1.0-exp(-((geolon_t(i,j)-bowl_east)/4.0)**2))
          endif
          ht(i,j) = max(bottom,zw(2))  
       enddo
    enddo
  end subroutine bowl

  !#######################################################################
  ! limit the minimum number of levels. kmt_min should be >= 2
  subroutine enforce_min_depth(zw, ht, kmt)
    real, dimension(:),         intent(in) :: zw 
    real, dimension(:,:),    intent(inout) :: ht
    integer, dimension(:,:), intent(inout) :: kmt

    integer :: n, i, j, kmt_shallow, ni, nj

    ni = size(ht,1); nj = size(ht,2)

    if(debug) write (stdout(),'(/a,i2)') ' Enforcing the minimum number of ocean cells in the vertical to be ', kmt_min
    if(size(zw) .lt. kmt_min) call mpp_error(FATAL,'topog_mod: number of vertical cells= '// &
         trim(string(size(zw)))//' is less than nml "kmt_min"= '//trim(string(kmt_min)) ) 
    n = 0
    do i=1,ni
       do j=1,nj
          if (kmt(i,j) /= 0 .and. kmt(i,j) < kmt_min) then
             n = n + 1
             kmt_shallow = kmt(i,j)
             if (round_shallow .or. (.not. deepen_shallow .and. .not. fill_shallow)) then
                if (zw(kmt(i,j)) < 0.5*zw(kmt_min)) then
                   if (debug) write(stdout(),'(a,3i6,a)') 'Making location i,j,kmt= ',i,j,kmt(i,j),' land'
                   kmt(i,j) = 0
                   ht(i,j)  = 0.0
                else
                   if (debug) write(stdout(),'(a,3i6,a)') 'Setting location i,j,kmt= ', &
                        i,j,kmt(i,j),'  to minimum ocean depth'
                   kmt(i,j) = kmt_min
                   ht(i,j)  = zw(kmt_min)
                end if
             endif
             if (fill_shallow) then
                if (debug) write(stdout(),'(a,3i6,a)') 'Making location i,j,kmt= ',i,j,kmt(i,j),' land'
                kmt(i,j) = 0
                ht(i,j)  = 0.0
             endif
             if (deepen_shallow) then
                if (debug) write(stdout(),'(a,3i6,a)') 'Setting location i,j,kmt= ',i,j,kmt(i,j),'  to minimum ocean depth'
                kmt(i,j) = kmt_min
                ht(i,j)  = zw(kmt_min)
             endif

          endif
       enddo
    enddo

    if(debug) then
    if (n > 0) then
          write (stdout(),'(a,i5,a/)')  '  -> Modified', n,' shallow cells'
    else
          write (stdout(),'(a/)') '  -> No modifications needed'
       endif
    endif

  end subroutine enforce_min_depth

  !#######################################################################
  !--- remove isolated cells
  subroutine remove_isolated_cells(ht, kmt, tripolar_grid)
    real, dimension(0:,0:),    intent(inout) :: ht
    integer, dimension(0:,0:), intent(inout) :: kmt
    logical,                   intent(in   ) :: tripolar_grid

    integer :: i, j, k, n, ni, nj, nj_max
    real    :: tmp

    ni = size(ht,1) - 2; nj = size(ht,2) - 2
    ! when tripolar_grid is true, do not check at j = nj (folded region).
    ! Will upgrade it if needed.
    if (tripolar_grid) then
      nj_max = nj-1
    else
      nj_max = nj
    endif

    if (fill_isolated_cells) then
       ! fill isolated cells (potholes and trenches) at all levels in kmt.
       ! filled kmt array is the maximum of the surrounding kmt levels.
    n=0
       if(debug) write (stdout(),'(a)') ' Searching for isolated T cells...'
        do j=1,nj_max
          do i=1,ni
            k = max(kmin(kmt,i,j), kmin(kmt,i-1,j), kmin(kmt,i,j-1), kmin(kmt,i-1,j-1))
             if ((k > 0) .or. .not. dont_change_landmask) then
                if (kmt(i,j) /= k) then
                   n = n + 1
              tmp = max(hmin(ht,i,j), hmin(ht,i-1,j), hmin(ht,i,j-1),hmin(ht,i-1,j-1))
                   if (debug) write(stdout(),'(a,3i6,f10.3,a,i4,f10.3)') 'Resetting location i,j,kmt,ht= ', &
                        i,j,kmt(i,j),ht(i,j),'  to ',  k,tmp
                   ht(i,j) = tmp
                kmt(i,j) = k
              endif
            endif
          enddo
        enddo
       if(debug) then
          if (n > 0) then
             write (stdout(),*) ' -> Found ',n,' and filled them in.'
        else
          write (stdout(),*) ' -> None Found.'
        endif
       endif
      else
       if(debug) write (stdout(),'(/a)') 'Note: Not filling isolated T cells...'
    endif

  end subroutine remove_isolated_cells

  !#######################################################################  
  !--- Restricting partial cells
  subroutine restrict_partial_cells(zw, ht, kmt)
    real, dimension(:), intent(in)      :: zw  
    real, dimension(:,:), intent(inout) :: ht
    integer, dimension(:,:), intent(inout) :: kmt

    real, dimension(size(zw)) :: p_cell_min
    real    :: tmp, tmp1, tmp2
    integer :: i, j, n, k, ni, nj, nk, itmp

    ni = size(ht,1); nj = size(ht,2); nk = size(zw)
    n = 0

    if (fraction_full_cell==0.0) then 
        do k=1,nk
           p_cell_min(k) = min(50.0,zw(1))
      enddo
    else
      p_cell_min(1) = fraction_full_cell*zw(1)
      if (nk >= 2) then
        do k=2,nk
           p_cell_min(k) = max(fraction_full_cell*(zw(k)-zw(k-1)),min_thickness) 
        enddo
      endif
    endif

    if(debug) then 
      write (stdout(),'(/a)') 'Partial cell restriction' 
    do k=1,nk
        write (stdout(),'(a,i6,a,e12.6,a)') ' Restricting partial cell # ',k,' to a min thickness of ', p_cell_min(k),' m.'
    enddo
    endif 

    if( open_very_this_cell  ) then
       do j=1,nj       
          do i=1,ni
             k = kmt(i,j)
             if (k > 1) then
                ! Use a "fuzzy" small epsilon value in comparison, to prevent
                ! single-precision comparison from re-editing cells
                ! that are "exactly" at the minimum partial cell thickness.
                if ((ht(i,j)-zw(k-1))*(1.+small) < p_cell_min(k)) then
                   tmp = zw(k-1) + p_cell_min(k)
                   if (debug) write(stdout(),'(a,2i4,f12.5,a,f10.5)') 'Resetting depth i,j,ht= ',i,j,ht(i,j),'  to ',&
                        tmp
                   ht(i,j) = tmp
                   n = n + 1
                endif
             endif
          enddo
       enddo
    else
    do j=1,nj       
      do i=1,ni
        k = kmt(i,j)
        if (k > 1) then
          ! Use a "fuzzy" small epsilon value in comparison, to prevent
          ! single-precision comparison from re-editing cells
          ! that are "exactly" at the minimum partial cell thickness.
          if ((ht(i,j)-zw(k-1))*(1.+small) < p_cell_min(k)) then
                   tmp1 = ht(i,j)-zw(k-1)
                   tmp2 = zw(k-1) + p_cell_min(k) - ht(i,j)
                   if (tmp2 .gt. tmp1) then
                      itmp = kmt(i,j) -1 
                      tmp = zw(k-1)
                      if (debug) write(stdout(),'(a,2i4,i4,a,i4)') 'Resetting kmt i,j,kmt= ',i,j,kmt(i,j),'  to ',&
                           itmp
                      kmt(i,j) = itmp
                   else  
             tmp = zw(k-1) + p_cell_min(k)
                   endif
                   if (debug) write(stdout(),'(a,2i4,f12.5,a,f10.5)') 'Resetting depth i,j,ht= ',i,j,ht(i,j),'  to ',&
                        tmp
             ht(i,j) = tmp
             n = n + 1
          endif
        endif
      enddo
    enddo
    end if
    if(debug) then
    if (n > 0) then
          write (stdout(),*) ' -> Found ',n, ' cells with too thin partical cell thickness, and so reset depth ht for these cells.'
    else
          write (stdout(),*) ' -> No cells were found whose partial cells were too thin.'
       endif
    endif
  end subroutine restrict_partial_cells

  !#######################################################################
    !     smooth topographic depth "d" with "num_pass" applications of a 2D
    !     version of a shapiro filter (weights = 1/4, 1/2, 1/4) . 
    !     allow filtering to decrease the bottom depth but not increase it.
    !     do not allow original geometry to change.
    !     note: depth "d" should be on a grid of uniformly constant spacing
  subroutine filter_topo (d, num_pass)
    real, dimension(:,:),  intent(inout) :: d
    integer,                  intent(in) :: num_pass
    real, dimension(size(d,1),size(d,2)) :: rmask, s
    real,           dimension(-1:1,-1:1) :: f
    integer                              :: n, i, j, ip, jp, ni, nj
    real                                 :: d_old

    ni = size(d,1); nj = size(d,2)
    ! 2D symmetric filter weights

    f(-1,-1) = 1.0/16.0
    f( 0,-1) = 1.0/8.0
    f( 1,-1) = 1.0/16.0
    f(-1, 0) = 1.0/8.0
    f( 0, 0) = 1.0/4.0
    f( 1, 0) = 1.0/8.0
    f(-1, 1) = 1.0/16.0
    f( 0, 1) = 1.0/8.0
    f( 1, 1) = 1.0/16.0

    ! geometry mask

    where (d(:,:) == 0.0)
       rmask(:,:) = 0.0
    elsewhere
       rmask(:,:) = 1.0
    endwhere

    s=d

    do n=1,num_pass
       do j=2,nj-1
          !      if (j >= js .and. j <= je) then
          do i=2,ni-1
             s(i,j) = 0.0
             d_old  = d(i,j)
               do ip=-1,1
                  do jp=-1,1
                   if (rmask(i+ip,j+jp) .eq. 0.0) then
                        s(i,j) = s(i,j) + d(i,j)*f(ip,jp)
                     else
                        s(i,j) = s(i,j) + d(i+ip,j+jp)*f(ip,jp)
                     endif
                  enddo
               enddo
             if (.not. smooth_topo_allow_deepening) then
                if (s(i,j) .gt. d_old) then
                   s(i,j) = d_old
                endif
             endif
          enddo
          do i=2,ni-1
             s(i,j) = s(i,j)*rmask(i,j)
          enddo
          !      endif
       enddo

            d(:,:) = s(:,:)
    enddo
  end subroutine filter_topo

  !#######################################################################
  !--- print out deepest topography
  subroutine show_deepest(zw, ht )
    real, dimension(:),   intent(in) :: zw
    real, dimension(:,:), intent(in) :: ht

    integer :: i, j, ni, nj, nk
    real    :: deepest

    ni = size(ht,1); nj = size(ht,2); nk = size(zw)
    deepest = 0.0
    do j=1,nj
       do i=1,ni
          if (ht(i,j) /= 0.0) then
             deepest  = max(ht(i,j),deepest)
          endif
       enddo
    enddo

    if ((deepest - zw(nk)) > 1.0) then
       write (stdout(),'(/a,f8.1,a,f8.1,a/a/)')'  Warning: Topography reaches to a depth of ',deepest,    &
            ' m. The deepest model level only reaches ', zw(nk), ' m.     Re-think the vertical grid  '// &
            'specification if the idea is to accurately capture the specified topography.'
    elseif (nk .gt. 1 .and. deepest <= zw(nk-1)) then
       write (stdout(),'(/a,f8.1,a,f8.1,a,i3,a/a)')&
            '   Warning: Topography reaches to a depth of ',deepest,' m. The deepest model level reaches ', &
            zw(nk),' m.            Fewer than ',nk,' vertical levels are required. '//                      &
            'The specified number of vertical levels is wasteful.'
    else
       write (stdout(),'(/a/)')&
            ' Note: The vertical grid specification contains the correct number of &
            &levels to efficiently contain the specified topography.'
    endif

  end subroutine show_deepest

  !#######################################################################
  !--- processing topography
  subroutine process_topo(ht, kmt, zw, dxte, dytn, geolon_t, geolat_t, tripolar_grid, cyclic_x, cyclic_y)

    real, dimension(0:,0:),    intent(inout) :: ht
    integer, dimension(0:,0:), intent(inout) :: kmt
    logical,                      intent(in) :: tripolar_grid, cyclic_x, cyclic_y
    real, dimension(:),           intent(in) :: zw
    real, dimension(:,:),         intent(in) :: dxte, dytn
    real, dimension(:,:),         intent(in) :: geolon_t, geolat_t

    integer :: i,j, ni, nj, nk
    real    :: ht_prev

    ni = size(ht,1)-2; nj = size(ht,2)-2; nk = size(zw)
    do j=1,nj
      do i=1,ni
        if (ht(i,j) >  0.0) then
          kmt(i,j) = nearest_index (ht(i,j), zw(1:nk))
          if (zw(kmt(i,j)) < ht(i,j)) then
                if ((ht(i,j)-zw(kmt(i,j))) < min_thickness) then
                   ht_prev = ht(i,j)
                   ht(i,j) = zw(kmt(i,j))
                   write (stdout(),*) ' Warning: very thin partial cell at ',i,j, &
                       ' (possibly because of netcdf-accuracy) is changed from ',ht_prev,' to ',ht(i,j)
                   write (stdout(),*) ' If this is not wanted, set "min_thickness" to zero in topog_nml'
                else
            if (kmt(i,j) == nk) then
              ht(i,j) = zw(kmt(i,j))
            else
              kmt(i,j) = kmt(i,j) + 1
            endif
          endif
             endif
        endif
      enddo
    enddo

    if (full_cell) then
       write (stdout(),'(/a/a/)')' Warning: Replacing partial bottom cells with full cell thicknesses.'
       do j=1,nj
          do i=1,ni
             if (kmt(i,j) /= 0) then
                ht(i,j) = zw(kmt(i,j))
             endif
          enddo
       enddo
    endif

    if (flat_bottom) then 
       write (stdout(),'(/a/a/)')' Warning: Replacing the ocean topography with a flat bottom where kmt(i,j)=nk.'
       do j=1,nj
          do i=1,ni
             if (kmt(i,j) /= 0) then
                kmt(i,j) = nk
                ht(i,j)  = zw(nk)
             endif
          enddo
       enddo
    endif

   if (tripolar_grid) then
       do i=1,ni
          kmt(i,nj+1) = kmt(ni-i+1,nj)
          ht(i,nj+1)  = ht(ni-i+1,nj)
       enddo
    else if(cyclic_y) then
       kmt(:,0)    = kmt(:,nj)
       kmt(:,nj+1) = kmt(:,1)
       ht(:,0)     = ht(:,nj)
       ht(:,nj+1)  = ht(:,1)       
    endif

   if (cyclic_x) then
       kmt(0,:)    = kmt(ni,:)
       kmt(ni+1,:) = kmt(1,:)
       ht(0,:)     = ht(ni,:)
       ht(ni+1,:)  = ht(1,:)
    endif

    if(debug)then
       write (stdout(),*) ' Checksum: Original ht =', sum( ht(1:ni, 1:nj) )
       write (stdout(),*) ' Checksum: Original kmt=', sum (kmt(1:ni, 1:nj) )
    endif

    if (adjust_topo) then
       call remove_isolated_cells(ht, kmt, tripolar_grid)
       call restrict_partial_cells(zw, ht(1:ni,1:nj), kmt(1:ni,1:nj) )
       call enforce_min_depth(zw, ht(1:ni,1:nj), kmt(1:ni,1:nj))
       if(debug) then
          write (stdout(),*) ' Checksum: Final kmt=', sum(kmt(1:ni, 1:nj))
          write (stdout(),*) ' Checksum: Final  ht=', sum( ht(1:ni, 1:nj))
       endif
    endif

    ! do some analysis.
    if(debug) call analyze_topographic_slopes(dxte, dytn, geolon_t, geolat_t, ht(1:ni,1:nj), kmt(1:ni,1:nj), nk) 

  end subroutine process_topo

  !#######################################################################
   ! construct a highly "idealized" world ... piece by piece
    !
    ! note: the purpose of this geometry/topography is to automatically
    !       map into arbitrary resolution as grid dimensions are
    !       changed, thereby facilitating the implementation
    !       and verification of the model on various computer platforms
    !       without referencing the topographic database.  Although it
    !       somewhat resembles the real world, it is NOT realistic.
    ! Note: this routine needs to be re-thought for generalized curvilinear coordinates
  subroutine idealized (xt,yt, zw, ht, kmt)
    real, dimension(:),    intent(in)      :: xt
    real, dimension(:),    intent(in)      :: yt
    real, dimension(:), intent(in)         :: zw
    real, dimension(:,:), intent(inout)    :: ht
    integer, dimension(:,:), intent(inout) :: kmt

    integer :: nj2, ni2, i, j, level, ni, nj, nk
    real    :: bot, arg

    ni = size(ht,1); nj = size(ht,2); nk = size(zw)
    kmt(:,:) = nk

    ! antarctica

    call setkmt (kmt(1:ni,1:nj), xt, yt, -90.0, 0.0, 360.0, -80.0, 0.0, 360.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, -80.0, 360.0-25.0, 360.0, -70.0, 360.0, 360.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, -80.0, 0.0, 360.0, -70.0, 0.0, 170.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, -80.0, 360.0-135.0, 360.0-60.0, -68.0, 360.0-75.0, 360.0-60.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, -70.0, 0.0, 155.0, -67.0, 50.0, 145.0, 0)

    ! australia

    call setkmt (kmt(1:ni,1:nj), xt, yt, -35.0, 116.0, 120.0, -31.0, 114.0, 130.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, -38.0, 140.0, 151.0, -31.0, 130.0, 151.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, -31.0, 115.0, 153.0, -20.0, 113.0, 149.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, -20.0, 113.0, 149.0, -11.0, 131.0, 143.0, 0)

    ! south america

    call setkmt (kmt(1:ni,1:nj), xt, yt, -50.0, 360.0-74.0, 360.0-68.0, -40.0, 360.0-73.0, 360.0-62.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, -40.0, 360.0-73.0, 360.0-62.0, -20.0, 360.0-70.0, 360.0-40.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, -20.0, 360.0-70.0, 360.0-40.0, -16.0, 360.0-81.0, 360.0-35.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, -16.0, 360.0-81.0, 360.0-35.0, 0.0, 360.0-80.0, 360.0-50.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 0.0, 360.0-80.0, 360.0-50.0, 11.0, 360.0-75.0, 360.0-60.0, 0)

    ! central america

    call setkmt (kmt(1:ni,1:nj), xt, yt, 6.0, 360.0-78.0, 360.0-75.0, 20.0, 360.0-105.0, 360.0-97.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 20.0, 360.0-105.0, 360.0-97.0, 30.0, 360.0-115.0, 360.0-94.0, 0)

    ! north america

    call setkmt (kmt(1:ni,1:nj), xt, yt, 25.0, 360.0-82.0, 360.0-80.0, 30.0, 360.0-85.0, 360.0-81.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 30.0, 360.0-115.0, 360.0-80.0, 40.0, 360.0-124.0, 360.0-74.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 40.0, 360.0-124.0, 360.0-74.0, 50.0, 360.0-124.0, 360.0-57.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 50.0, 360.0-124.0, 360.0-57.0, 60.0, 360.0-140.0, 360.0-64.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 60.0, 360.0-165.0, 360.0-64.0, 65.0, 360.0-140.0, 360.0-64.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 65.0, 360.0-140.0, 360.0-64.0, 70.0, 360.0-162.0, 360.0-72.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 70.0, 360.0-162.0, 360.0-140.0, 72.0, 360.0-157.0, 360.0-157.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 70.0, 360.0-130.0, 360.0-70.0, 75.0, 360.0-120.0, 360.0-80.0, 0)

    ! greenland
          
    call setkmt (kmt(1:ni,1:nj), xt, yt, 60.0, 360.0-45.0, 360.0-45.0, 75.0, 360.0-58.0, 360.0-19.0, 0)

    ! africa

    call setkmt (kmt(1:ni,1:nj), xt, yt, -35.0, 19.0, 28.0, 6.0, 8.0, 50.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 6.0, 0.0, 50.0, 18.0, 0.0, 56.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 18.0, 0.0, 56.0, 26.0, 0.0, 59.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 6.0, 360.0-10.0, 360.0, 18.0, 360.0-18.0, 360.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 18.0, 360.0-18.0, 360.0, 26.0,  360.0-15.0, 360.0, 0)

    ! northern africa and europe and asia
    
    call setkmt (kmt(1:ni,1:nj), xt, yt, 26.0, 360.0-15.0, 360.0, 40.0, 360.0-7.0, 360.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 40.0, 360.0-7.0, 360.0, 50.0, 360.0, 360.0, 0)
    
    call setkmt (kmt(1:ni,1:nj), xt, yt, 8.0, 77.0, 78.0, 26.0, 65.0, 90.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 4.0, 99.0, 100.0, 26.0, 90.0, 115.0, 0)

    call setkmt (kmt(1:ni,1:nj), xt, yt, 26.0, 0.0, 126.0, 40.0, 0.0, 122.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 40.0, 0.0, 130.0, 50.0, 0.0, 140.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 50.0, 0.0, 140.0, 60.0, 8.0, 140.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 60.0, 8.0, 163.0, 65.0, 13.0, 180.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 65.0, 13.0, 188.0, 70.0, 20.0, 180.0, 0)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 70.0, 70.0, 180.0, 75.0, 90.0, 100.0, 0)

    ! add an "idealized" undulating topography

    bot = zw(nk)
    nj2 = nj+2
    ni2 = ni+2
      do j=1,nj
        do i=1,ni
          if (kmt(i,j) .ne. 0) then
             arg = bot*(1-0.4*abs(cos(((j+1)*pi)/nj2)*sin(((i+1)*2*pi)/ni2)))
             kmt(i,j) = nearest_index (arg, zw)
          endif
        enddo
      enddo
      
    ! add "idealized" ridges

    level = nearest_index (0.666*zw(nk), zw)

    call setkmt (kmt(1:ni,1:nj), xt, yt, -20.0, 360.0-20.0, 360.0-10.0, 30.0, 360.0-45.0, 360.0-35.0, level)
    call setkmt (kmt(1:ni,1:nj), xt, yt, 30.0, 360.0-45.0, 360.0-35.0, 60.0, 360.0-20.0,  360.0-30.0, level)
    call setkmt (kmt(1:ni,1:nj), xt, yt, -60.0,360.0-100.0, 360.0-130.0, 40.0, 360.0-160.0, 180.0, level)

    level = nearest_index (0.5*zw(nk), zw)

    call setkmt (kmt(1:ni,1:nj), xt, yt, -50.0, 360.0-120.0, 360.0-120.0, 30.0, 190.0, 190.0, level)

    ! set ht to full cell depth.
    
    do j=1,nj
        do i=1,ni
          if (kmt(i,j) .ne. 0) then
             ht(i,j) = zw(kmt(i,j))
          else
            ht(i,j)  = 0.0
          endif
        enddo
      enddo

  end subroutine idealized

  !#####################################################################
    !     set the topography mask "kmt(i,j)" = "num" within the area of
    !     the trapezoid bounded by vertices:
    !     (alat1,slon1), (alat1,elon1), (alat2,slon2), and (alat2,elon2)
    !
    !     inputs:
    !
    !     xt = longitudes of T points in degrees
    !     yt = latitudes of T points in degrees
    !     alat1 = southern latitude of trapezoid (degrees)
    !     slon1 = starting longitude of southern edge of trapezoid (deg)
    !     elon1 = ending longitude of southern edge of trapezoid (deg)
    !     alat2 = northern latitude of trapezoid (degrees)
    !     slon2 = starting longitude of northern edge of trapezoid (deg)
    !     elon2 = ending longitude of northern edge of trapezoid (deg)
    !     num   = number of vertical levels
    !
    !     outputs:
    !
    !     kmt   = mask of vertical levels on model T points
  subroutine setkmt (kmt, xt, yt, alat1, slon1, elon1, alat2, slon2, elon2, num)
    real, intent(in),        dimension(:)  :: xt
    real, intent(in),        dimension(:)  :: yt
    integer, intent(inout), dimension(:,:) :: kmt 
    real,                       intent(in) :: alat1, slon1, elon1, alat2, slon2, elon2
    integer,                    intent(in) :: num
    integer                                :: j1, j2, js, je, i1, i2, is1, ie1
    integer                                :: is2, ie2, is, ie, i, j
    real                                   :: rdj

    j1 = nearest_index (alat1, yt )
    j2 = nearest_index (alat2, yt )
    js = min (j1,j2)
    je = max (j1,j2)

    i1  = nearest_index (slon1, xt)
    i2  = nearest_index (elon1, xt)
    is1 = min (i1,i2)
    ie1 = max (i1,i2)

    i1  = nearest_index (slon2, xt )
    i2  = nearest_index (elon2, xt )
    is2 = min (i1,i2)
    ie2 = max (i1,i2)

    is = is1
    ie = ie1

    ! fill in the area bounded by (js,is1), (js,ie1), (je,is2), (je,ie2)
    ! the nudging of 1.e-5 is to insure that the test case resolution
    ! generates the same topography and geometry on various computers.

    if (js .eq. je) then
       rdj = 1.0
      else
       rdj = 1.0/(je-js)
      endif 
    do j=js,je
       do i=is,ie
          kmt(i,j) = num
    enddo
       is = nint(rdj*((j-js)*is2 + (je-j)*is1) + 1.0e-5)
       ie = nint(rdj*((j-js)*ie2 + (je-j)*ie1) + 1.0e-5)
    enddo
  end subroutine setkmt

  !#######################################################################
  !--- reading data from source data file topog_file and remap it onto current grid
  subroutine get_topog_from_file(lon_dst, lat_dst, data_dst)
    real,dimension(:,:), intent(in)  :: lon_dst, lat_dst
    real,dimension(:,:), intent(out) :: data_dst

    !--- local variables -------------------------------------------------
    integer           :: isc, iec, jsc, jec, layout(2), ndivs, unit, ndim, nvar, natt, ntime, n, len
    integer           :: i, j, nlon_src, nlat_src, nlon_dst, nlat_dst
    real              :: missing, D2R
    logical           :: do_remap = .true.
    logical           :: found_lon, found_lat
    character(len=1)  :: cart
    character(len=64) :: name
    type(domain2D)    :: domain  
    type(fieldtype)   :: data_field
    real, dimension(:,:), allocatable          :: tmp, global_tmp
    real, dimension(:),   allocatable          :: lon, lat, lonb, latb
    real, dimension(:,:), allocatable          :: data_src, mask_src, lon_src, lat_src
    type(fieldtype), allocatable, dimension(:) :: fields
    type(axistype), allocatable, dimension(:)  :: axes
    real  :: min_lat, max_lat
    integer :: jstart, jend

    !-------------------------------------------------------------------
    D2R = PI/180.
    layout = (/ 0, 0 /)

    !--- First read data from topog_file -------------------------------
    if(.not. file_exist(trim(topog_file))) &
         call mpp_error(FATAL,'topog_mod: file '//trim(topog_file)//' does not exist')
    call mpp_open(unit, trim(topog_file), action=MPP_RDONLY, form=MPP_NETCDF, &
         threading=MPP_MULTI, fileset=MPP_SINGLE)
    call mpp_get_info(unit, ndim, nvar, natt, ntime)
    allocate(fields(nvar))
    call mpp_get_fields(unit,fields)

    write (stdout(),'(//,10x,a/)') 'Reading topography from file'

    nlon_src=0; nlat_src=0
    do n=1,nvar
       call mpp_get_atts(fields(n), name=name)
       if( trim(lowercase(name)) .eq. trim(lowercase(topog_field))) then
          call mpp_get_atts(fields(n), ndim=ndim)
          allocate(axes(ndim))
          call mpp_get_atts(fields(n), axes=axes)
          do i=1,ndim
             call get_axis_cart(axes(i),cart)
             call mpp_get_atts(axes(i),len=len)
             select case(cart)
             case('X')
                nlon_src = len
                allocate(lon(nlon_src) )
                call mpp_get_axis_data(axes(i),lon)
             case('Y')
                nlat_src = len
                allocate(lat(nlat_src))
                call mpp_get_axis_data(axes(i),lat)
             case('N')
                call mpp_error(FATAL,'topog_mod: axis cart of field '//trim(topog_field) &
                         //' is not correct, check file '//trim(topog_file)//' to make sure field ' &
                         //trim(topog_field)// ' has suitable attribute units or cartesian_axis')
             end select
          enddo
          data_field = fields(n)
       endif
    enddo

    if (nlon_src == 0 .or. nlat_src == 0 ) call mpp_error(FATAL,'topog_mod: field '//trim(topog_field)// &
         ' not found in file '//trim(topog_file) )

    !--- we assume the source grid is uniform in the zonal direction
    nlon_dst = size(data_dst,1)
    nlat_dst = size(data_dst,2)
    if( trim(interp_method) == 'conservative' ) then
       allocate(lonb(nlon_src+1), latb(nlat_src+1) )
       do i = 2, nlon_src
          lonb(i) = (lon(i-1) + lon(i))*0.5;
       end do
       lonb(1) = 2*lon(1) - lonb(2)
       lonb(nlon_src+1) = 2*lon(nlon_src) - lonb(nlon_src)
       do j = 2, nlat_src
          latb(j) = (lat(j-1) + lat(j))*0.5;
       end do
       latb(1) = 2*lat(1) - latb(2)
       latb(nlat_src+1) = 2*lat(nlat_src) - latb(nlat_src)
       ! lon_dst and lat_dst is at C-cell
       nlon_dst = nlon_dst - 1
       nlat_dst = nlat_dst - 1
    end if

    !--- if the src grid is not spherical grid, we need to get the geographical grid
    allocate(lon_src(nlon_src,nlat_src), lat_src(nlon_src,nlat_src) )
    if(src_is_spherical) then
       do i = 1, nlon_src
          lon_src(i,:) = lon(i)
       enddo
       do j = 1, nlat_src
          lat_src(:,j) = lat(j)
       enddo
    else !--- if the src grid is not spherical grid, we need to get the geographical grid
       found_lon = .false.; found_lat = .false.
       do n=1,nvar
          call mpp_get_atts(fields(n), name=name)
          if( trim(lowercase(name)) .eq. trim(lowercase(lon_field))) then
             call mpp_read(unit, fields(n), lon_src)
             found_lon = .true.
          else  if( trim(lowercase(name)) .eq. trim(lowercase(lat_field))) then            
             call mpp_read(unit, fields(n), lat_src)
             found_lat = .true.
          endif
       enddo
       if(.not.found_lon)call mpp_error(FATAL,"topog_mod: src_is_spherical is false, but field " //&
                           trim(lon_field)//" does not exist in the file "//trim(topog_file) )
       if(.not.found_lat)call mpp_error(FATAL,"topog_mod: src_is_spherical is false, but field " //&
                           trim(lat_field)//" does not exist in the file "//trim(topog_file) )
    endif

    !--- read the source data --------------------------------------------
    allocate(data_src(nlon_src,nlat_src), mask_src(nlon_src,nlat_src) )
    call mpp_read(unit, data_field, data_src)
    mask_src=1.0
    call mpp_get_atts(data_field,missing=missing)
    where(data_src == missing)          mask_src = 0.0
    where(data_src*scale_factor <= 0.0) mask_src = 0.0 

    call mpp_close(unit)
    deallocate(fields, axes)

    ! decompose model grid points
    ndivs = mpp_npes()
    call mpp_define_layout((/1,nlon_dst,1,nlat_dst/),ndivs,layout)
    call mpp_define_domains((/1,nlon_dst,1,nlat_dst/),layout,domain,xhalo=0,yhalo=0)  
    call mpp_get_compute_domain(domain,isc, iec, jsc, jec)

    ! --- check if a remap is needed or not
    if ( nlon_src == nlon_dst .and. nlat_src == nlat_dst .and. interp_method .NE. "conservative" ) then
       do_remap = .false.
       do j=1,nlat_dst
          do i=1,nlon_dst
             if (abs(lon_dst(i,j) -lon_src(i,j)) > grid_tol) then
                do_remap = .true.
                exit
             endif
          enddo
       enddo

       if (.not. do_remap) then
          do j=1,nlat_dst
             do i=1,nlon_dst
                if (abs(lat_dst(i,j)-lat_src(i,j)) > grid_tol) then
                   do_remap = .true.
                   exit
                endif
             enddo
          enddo
       endif
    endif

    if (do_remap) then
       ! use a temporary array for the regridding. use a global communication call to
       ! send the result on the global array back to all PEs

       allocate(tmp(isc:iec,jsc:jec),global_tmp(nlon_dst, nlat_dst))
       tmp = 0.0; data_dst=0.0
       select case(trim(interp_method))
       case('spherical')
             write (stdout(),'(//,10x,a/)') 'Interpolating topography spherical'
             call horiz_interp(data_src(:,:), lon_src*D2R, lat_src*D2R, lon_dst(isc:iec,jsc:jec)*D2R, &
                  lat_dst(isc:iec,jsc:jec)*D2R, tmp, mask_in=mask_src, interp_method = "spherical",   &
                  num_nbrs=num_nbrs, max_dist=max_dist)
       case('bilinear')       
          if(src_is_spherical) then
             write (stdout(),'(//,10x,a/)') 'Interpolating topography from spherical grid with method bilinear'
             call horiz_interp(data_src, lon*D2R, lat*D2R, lon_dst(isc:iec,jsc:jec)*D2R,   &
               lat_dst(isc:iec,jsc:jec)*D2R, tmp, mask_in=mask_src,                        &
               interp_method = "bilinear", grid_at_center = .true. )
          else
             write (stdout(),'(//,10x,a/)') 'Interpolating topography from non-spherical grid with method bilinear'
             call horiz_interp(data_src, lon_src*D2R, lat_src*D2R, lon_dst(isc:iec,jsc:jec)*D2R,   &
               lat_dst(isc:iec,jsc:jec)*D2R, tmp, mask_in=mask_src, interp_method = "bilinear")
          endif
       case('conservative')
          !--- find the starting and ending index of source grid to improve efficiency.
          min_lat = minval(lat_dst(isc:iec+1,jsc:jec+1))
          max_lat = maxval(lat_dst(isc:iec+1,jsc:jec+1))
          do j = 2, nlat_src+1
             jstart = j-1
             if(latb(j) > min_lat) exit
          enddo
          do j = nlat_src, 1, -1
             jend = j+1
             if(latb(j) < max_lat) exit
          enddo
          !--- To avoid truncation error, extend one more point.
          jstart = max(1, jstart-1)
          jend   = min(nlat_src+1, jend+1)

          if(src_is_spherical) then
             write (stdout(),'(//,10x,a/)') 'Interpolating topography from spherical grid with method conservative'
             call horiz_interp(data_src(:, jstart:jend-1), lonb*D2R, latb(jstart:jend)*D2R, lon_dst(isc:iec+1,jsc:jec+1)*D2R,   &
               lat_dst(isc:iec+1,jsc:jec+1)*D2R, tmp, mask_in=mask_src(:, jstart:jend-1), interp_method = "conservative" )
             deallocate(lonb, latb)
          else
             call mpp_error(FATAL,'topog_mod: for conservative interpolation, the source should be regular lon-lat grid.');
          end if
       case default
          call mpp_error(FATAL,'topog_mod: nml interp_method should be either "spherical", "bilinear" or "conservative" ')
       end select
       call mpp_global_field(domain, tmp,global_tmp)
       data_dst = global_tmp
       deallocate(tmp, global_tmp)
    else
       write (stdout(),'(//,10x,a/)') 'Topography is on-grid, no remapping'
       data_dst(:,:)=data_src(:,:)*mask_src(:,:)
    endif

    return

  end subroutine get_topog_from_file

  !#####################################################################
  subroutine set_topog_nml(is_full_cell, is_fill_isolated_cells, is_dont_change_landmask, &
       is_fill_shallow, is_deepen_shallow,is_round_shallow, is_adjust_topo,               &
       is_fill_first_row, min_kmt, verbose )    
    logical, intent(in)  :: is_full_cell, is_fill_isolated_cells, is_dont_change_landmask
    logical, intent(in)  :: is_fill_shallow, is_deepen_shallow, is_round_shallow
    logical, intent(in)  :: is_adjust_topo, is_fill_first_row, verbose
    integer, intent(in)  :: min_kmt

    full_cell            = is_full_cell
    fill_isolated_cells  = is_fill_isolated_cells
    dont_change_landmask = is_dont_change_landmask
    fill_shallow         = is_fill_shallow
    deepen_shallow       = is_deepen_shallow
    round_shallow        = is_round_shallow
    adjust_topo          = is_adjust_topo
    fill_first_row       = is_fill_first_row
    kmt_min              = min_kmt
    debug                = verbose
    small                = 1.e-6

    return

  end subroutine set_topog_nml

  !#####################################################################
  subroutine prep_obc_topog(kmt, ht, ni, nj)  
  ! Topography should be smooth neer open boundaries. Kmt and ht are set
  ! to the same value at the boundary point and two additional ocean points 
  ! near the boundary. To avoid steps, kmt and ht from the second inner point 
  ! near the boundary is used. The first oint outside the boundary is set to the
  ! depth at the boundary. In this case also velocity points at the B-grid are 
  ! well defined. If the boundary is at index i=1 or j=1, the buffer rows and 
  ! columnes at i=0 or j=0 are used. These points will not be stored in the 
  ! gridfile and the corresponding settings are evetually overwritten in other
  ! subroutines. So it is recommended, to use i>1 and j>1 as boundaries. 
    integer, dimension(0:,0:), intent(inout) :: kmt
    real,    dimension(0:,0:), intent(inout) :: ht
    integer,                   intent(in)    :: ni, nj
    integer :: i, j, n, ib, jb, ichange, kmt_temp
    real    :: ht_temp

    if (nobc == 0) return
      
    write(stdout(),'(/a/)') 'Checking bathymetry at open boundaries'
    do n=1, nobc
       write(stdout(),*) 'boundary', n, ' direction ',trim(direction(n))
       select case( trim(direction(n)) )
       case('west')
         ichange=0 
         if (is(n) .ne. ie(n)) call mpp_error(FATAL,'is must be equal to ie at a western boundary')
         ib = is(n)
!        If there is land near the boundary close the row.
!        If there is no land near the boundary set kmt and ht in
!        this row to ht(ib+nsmooth,jrow).
!        If this is land, the row is closed automatically.
         do j=js(n), je(n)
           kmt_temp = min(kmt(ib,j),kmt(ib+1,j),kmt(ib+2,j))
           if(kmt_temp.eq.0) then
             ht_temp = 0.
           else  
             ht_temp = ht (ib+nsmooth(n),j)
             kmt_temp= kmt(ib+nsmooth(n),j)
           endif 
           do i=is(n)-1,is(n)+2
! show all changes made to kmt and/or ht, use appropriate output format
             if (kmt(i,j).ne.kmt_temp .or. ht(i,j).ne.ht_temp) then
               ichange=ichange+1 
               write(stdout(),'(6x,2(a,i4),2(a,f10.2),a,i4)') &
                   'ht(',i,',',j,') =',ht_temp,' ! changed from',ht(i,j), ', kmt_new =',kmt_temp
               kmt(i,j) = kmt_temp
               ht(i,j)  = ht_temp
             endif
           enddo
         enddo
         if (ichange == 0) then
           write(stdout(),'(a)') 'No bathymetry changes at western obc'
         endif
       case('east')
         ichange=0 
         if (is(n) .ne. ie(n)) call mpp_error(FATAL,'is must be equal to ie at a eastern boundary')
         ib = is(n)
!        If there is land near the boundary close the row.
!        If there is no land near the boundary set kmt and ht in
!        this row to ht(ib-nsmooth,jrow).
!        If this is land, the row is closed automatically.
         do j=js(n), je(n)
           kmt_temp = min(kmt(ib,j),kmt(ib-1,j),kmt(ib-2,j))
           if(kmt_temp.eq.0) then
             ht_temp = 0.
           else  
             ht_temp = ht (ib-nsmooth(n),j)
             kmt_temp= kmt(ib-nsmooth(n),j)
           endif  
           do i=is(n)-2, min(is(n)+2,ni+1)
! show all changes made to kmt and/or ht, use appropriate output format
             if (kmt(i,j).ne.kmt_temp .or. ht(i,j).ne.ht_temp) then
               ichange=ichange+1 
               write(stdout(),'(6x,2(a,i4),2(a,f10.2),a,i4)')  &
                   'ht(',i,',',j,') =',ht_temp,' ! changed from',ht(i,j), ', kmt_new =',kmt_temp
               kmt(i,j) = kmt_temp
               ht(i,j)  = ht_temp
             endif
           enddo
         enddo
         if (ichange == 0) then
           write(stdout(),'(a)') 'No bathymetry changes at eastern obc'
         endif
       case('south')
         ichange=0 
         if (js(n) .ne. je(n)) call mpp_error(FATAL,'js must be equal to je at a southern boundary')
         jb = js(n)
!        If there is land near the boundary close the column.
!        If there is no land near the boundary set kmt and ht in
!        this row to ht(i,jb+2).
!        If this is land, the row is closed automatically.
         do i=is(n), ie(n)
           kmt_temp = min(kmt(i,jb),kmt(i,jb+1),kmt(i,jb+2))
           if(kmt_temp.eq.0) then
             ht_temp = 0.
           else  
             ht_temp = ht (i,jb+nsmooth(n))
             kmt_temp= kmt(i,jb+nsmooth(n))
           endif  
           do j=js(n)-1,js(n)+2
! show all changes made to kmt and/or ht, use appropriate output format
           if (kmt(i,j).ne.kmt_temp .or. ht(i,j).ne.ht_temp) then
               ichange=ichange+1 
               write(stdout(),'(6x,2(a,i4),2(a,f10.2),a,i4)')  &
                   'ht(',i,',',j,') =',ht_temp,' ! changed from',ht(i,j), ', kmt_new =',kmt_temp
               kmt(i,j) = kmt_temp
               ht(i,j)  = ht_temp
             endif
           enddo
         enddo
         if (ichange == 0) then
           write(stdout(),'(a)') 'No bathymetry changes at southern obc'
         endif
       case('north')
         ichange=0 
         if (js(n) .ne. je(n)) call mpp_error(FATAL,'js must be equal to je at a northern boundary')
         jb = js(n)
!        If there is land near the boundary close the column.
!        If there is no land near the boundary set kmt and ht in
!        this row to ht(i,jb-nsmooth).
!        If this is land, the row is closed automatically.
         do i=is(n), ie(n)
           kmt_temp = min(kmt(i,jb),kmt(i,jb-1),kmt(i,jb-2))
           if(kmt_temp.eq.0) then
             ht_temp = 0.
           else  
             ht_temp = ht (i,jb-nsmooth(n))
             kmt_temp= kmt(i,jb-nsmooth(n))
           endif  
           do j=js(n)-2,min(js(n)+2, nj+1)
! show all changes made to kmt and/or ht, use appropriate output format
             if (kmt(i,j).ne.kmt_temp .or. ht(i,j).ne.ht_temp) then
               ichange=ichange+1 
               write(stdout(),'(6x,2(a,i4),2(a,f10.2),a,i4)')  &
                   'ht(',i,',',j,') =',ht_temp,' ! changed from',ht(i,j), ', kmt_new =',kmt_temp
               kmt(i,j) = kmt_temp
               ht(i,j)  = ht_temp
             endif
           enddo
         enddo
         if (ichange == 0) then
           write(stdout(),'(a)') 'No bathymetry changes at northern obc'
         endif
       case default
          call mpp_error(FATAL,'each element of nml direction should be west, east, south or north')
       end select    
    enddo ! loop over all boundaries
    
    return
  end subroutine prep_obc_topog
  !#####################################################################

  end module topog_mod

module bgrid_horiz_mod

!-----------------------------------------------------------------------
!
!        allocates memory and initializes grid constants
!              for the FMS B-grid dynamical core
!
!-----------------------------------------------------------------------

use mpp_domains_mod, only: mpp_domains_init,           &
                           mpp_define_domains,         &
                           domain1D, domain2D,         &
                           mpp_get_global_domain,      &
                           mpp_get_data_domain,        &
                           mpp_get_compute_domain,     &
                           mpp_get_compute_domains,    &
                           mpp_get_domain_components,  &
                           mpp_get_pelist,             &
                           mpp_define_layout,          &
                           mpp_get_layout,             &
                           CYCLIC_GLOBAL_DOMAIN,       &
                           mpp_global_sum,             &
                           BITWISE_EXACT_SUM

use  constants_mod, only: RADIUS
use        fms_mod, only: error_mesg, FATAL, NOTE,  &
                          mpp_pe, mpp_root_pe, mpp_npes, &
                          write_version_number, stdlog

implicit none
private

!-----------------------------------------------------------------------
!------- public interfaces -------

public  horiz_grid_init,       &
        get_horiz_grid_bound,  &
        get_horiz_grid_size,   &
        update_np, update_sp,  &
        TGRID, VGRID

!-----------------------------------------------------------------------
!             public derived data types
!-----------------------------------------------------------------------

public bgrid_type
public bgrid_interp_type
public horiz_grid_type

!-----------------------------------------------------------------------
!
!    NOTE: all horizontal indexing references global indices
!                    ( 1:nlon, 1:nlat )

type bgrid_type
   integer :: is,  ie,  js,  je         ! compute domain indices
   integer :: isd, ied, jsd, jed        ! data    domain indices
   integer :: isg, ieg, jsg, jeg        ! global  domain indices
   real, pointer, dimension(:)   :: blong=>NULL(), blatg=>NULL()  ! global grid edges
   real, pointer, dimension(:)   ::    dx=>NULL(),   rdx=>NULL(), &
                                     area=>NULL(), rarea=>NULL(), &
                                      tph=>NULL(),   tlm=>NULL()
   real, pointer, dimension(:,:) ::   aph=>NULL(),   alm=>NULL()
   real                          :: dy, rdy
   real                          :: areasum
   type(domain2D) :: Domain, Domain_nohalo
end type

!    is   = starting x-axis index for the compute domain
!    ie   = ending   x-axis index for the compute domain
!    js   = starting y-axis index for the compute domain
!    je   = ending   y-axis index for the compute domain
!    isd  = starting x-axis index for the data    domain
!    ied  = ending   x-axis index for the data    domain
!    jsd  = starting y-axis index for the data    domain
!    jed  = ending   y-axis index for the data    domain
!    isg  = starting x-axis index for the global  domain
!    ieg  = ending   x-axis index for the global  domain
!    jsg  = starting y-axis index for the global  domain
!    jeg  = ending   y-axis index for the global  domain
!
!    dx    = grid spacing for x-axis (in meters)
!    rdx   = reciprocal of dx (1/m)
!    dy    = grid spacing for y-axis (in meters)
!    rdy   = reciprocal of dy (1/m)
!    area  = area of a grid box (in m2)
!    rarea = reciprocal of area (1/m2)
!    areasum = bit-reproducible global sum of area
!
!    tph  = latitude at the center of grid box (in radians)
!    tlm  = longitude at the center of grid box (in radians)
!    aph  = actual latitude at the center of grid box (in radians)
!    alm  = actual longitude at the center of grid box (in radians)
!
!    blong = longitude grid box boundaries along the global x/longitude axis (in radians)
!    blatg = latitude  grid box boundaries along the global y/latitude  axis (in radians)
!
!    Domain        = domain2D variable with halo size = 1
!    Domain_nohalo = domain2D variable with halo size = 0
!                    used for outputing diagnostic fields
!
!-----------------------------------------------------------------------
! interpolation weights: used to move data between model grids

type bgrid_interp_type
   real, pointer, dimension(:,:) :: tmpwts=>NULL(), velwts=>NULL(), nowts=>NULL()
end type bgrid_interp_type

! tmpwts, velwts = interpolation weights for area-weighted 4-point averages
! nowts          = interpolation weights for simple 4-point averages

!-----------------------------------------------------------------------

type horiz_grid_type
   type(bgrid_type)        :: Tmp, Vel
   type(bgrid_interp_type) :: Interp
   integer :: nlon, nlat, isize, jsize
   integer :: ilb, iub, jlb, jub
   logical :: channel, double_periodic, decompx, decompy
   real    :: dlmd, dphd, dlm, dph
   real    :: sb, nb, wb, eb
   real, pointer, dimension(:,:) :: sinphv=>NULL(), tanphv=>NULL()
end type horiz_grid_type

!    Tmp = constants for the temperature/tracer/mass grid
!    Vel = constants for the u/v wind component grid
!
!    sinphv = sine of Vel%aph
!    tanphv = tangent of Vel%aph
!
!    nlon = number of grid points along the global x-axis (no halo points)
!    nlat = number of grid points along the global y-axis (no halo points)
!
!    isize = number of grid points along the x-axis for the current processor
!             (includes halo points)
!    jsize = number of grid points along the y-axis for the current processor
!             (includes halo points)
!
!    ilb  = lower bound x-axis
!    iub  = upper bound x-axis
!    jlb  = lower bound y-axis
!    jub  = upper bound y-axis
!
!    dlm  = grid spacing for x-axis (in radians)
!    dph  = grid spacing for y-axis (in radians)
!    dlmd = grid spacing for x-axis (in degrees of longitude)
!    dphd = grid spacing for y-axis (in degrees of latitude)
!
!    sb = southern boundary of temperature grid (in radians)
!    nb = northern boundary of temperature grid (in radians)
!    wb =  western boundary of temperature grid (in radians)
!    eb =  eastern boundary of temperature grid (in radians)
!
!    channel = channel model, uses grid boundaries: ed,wb,sb,nb.
!              also boundary condition at N/S walls is modified
!              may select f-plane option or double periodic options
!    double_periodic = f-plane channel with periodic boundaries in x and y.
!
!    decompx = x-axis is decomposed across more than one processor
!    decompy = y-axis is decomposed across more than one processor
!-----------------------------------------------------------------------
!-------- public parameters -------------

   integer, parameter :: TGRID = 51, VGRID = 52

!-----------------------------------------------------------------------
!-------- private data ------------

   real,    parameter :: eps=0.0001

!-------- internal parameters --------

!----- untested/unsupported options -----
!         use at you own risk 

   real :: wbd = 0.0  ! western edge in degrees of the first
                      ! longitude (i=1) of temperature grid boxes

   real :: ebd = 360.0 ! eastern edge in degrees of the last
                       ! longitude (i=nlon) of temperature grid boxes

   real :: sbd = -90.0  ! southern edge in degrees of the first
                        ! latitude row (j=1) of temperature grid boxes

   real :: nbd =  90.0  ! northern edge in degrees of the last latitude
                        ! row (j=nlat) of temperature grid boxes

   logical :: do_channel = .false. ! if TRUE, then use sbd,nbd as southern and northern 
                                   ! boundaries of a channel.

   logical :: do_fplane_approx = .false. ! f-plane channel without spherical geometry
                                         ! used in conjunction with do_channel option
   real    :: fphd = 45.                 ! coriolis latitude used for f-plane channel

   logical :: do_double_periodic = .false.  ! domain is cyclic in X and Y
                                            ! this option must be used with do_fplane_approx = true
                                            ! Tmp and Vel grids will have the same size global compute domain
!-----------------------------------------------------------------------

   real :: tph0d = 0.  ! grid/globe transformation (unsupported)
   real :: tlm0d = 0.  ! (set tph0d=tlm0d=0 for no transformation)

!-----------------------------------------------------------------------
 character(len=128) :: version = '$Id: bgrid_horiz.F90,v 19.0 2012/01/06 19:55:11 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'
 logical :: do_vers = .true.
!-----------------------------------------------------------------------

contains

!#######################################################################

subroutine horiz_grid_init ( Hgrid, nlon, nlat, layout )

!-----------------------------------------------------------------------
!   Hgrid     = horizontal grid constants
!   nlon,nlat = the global horizontal grid resolution
!               number of longitude and latitude grid boxes, respectively
!   layout    = domain decomposition (num X pes by num Y pes),
!                default decomposition along y-axis then x-axis
!-----------------------------------------------------------------------

     type(horiz_grid_type), intent(inout) :: Hgrid
     integer,               intent(in)    :: nlon, nlat
     integer, optional,     intent(in)    :: layout(2)

!-----------------------------------------------------------------------
!------------------- local/private declarations ------------------------

real,    allocatable :: tlmi(:), tphj(:), slat(:), dxj(:), wt(:,:)
integer, allocatable :: xrows(:), yrows(:)

real    :: hpi, dtr
integer :: i, j, ilb, iub, jlb, jub, npes, pe, yflags, nlatv
integer :: is, ie, hs, he, vs, ve
integer :: isd, ied, hsd, hed, vsd, ved
integer :: isg, ieg, hsg, heg, vsg, veg
integer :: domain_layout(2)
integer :: logunit
logical :: global_x, global_y
type(domain1D) :: Domx, Domy

!------------- parallel interface --------------------------------------
!        ---- domain decomposition -----

      call mpp_domains_init

      npes = mpp_npes()
      logunit = stdlog()

! write version info to logfile
     if (do_vers) then
       call write_version_number(version, tagname)
       do_vers = .false.
     endif

! error checks and messages

   Hgrid % channel = do_channel
   Hgrid % double_periodic = do_double_periodic

   if (Hgrid%channel) then
       write (logunit,'(a)') 'Channel model option has been selected.'
   endif

   if (do_fplane_approx) then
       if (.not.Hgrid%channel) call error_mesg ('horiz_grid_init', &
             'f-plane approximation cannot be used without do_channel=TRUE', FATAL)
       write (logunit,'(a)') '... the f-plane approximation will be used'
   endif

   if (do_double_periodic) then
       ! error check
       if (.not.do_fplane_approx) call error_mesg ('horiz_grid_init', &
              'double periodic option cannot be used without do_fplane_approx=TRUE', FATAL)
       yflags = CYCLIC_GLOBAL_DOMAIN
       nlatv  = nlat
       write (logunit,'(a)') '... and double periodic boundary conditions will be used'
   else
       yflags = 0
       nlatv  = nlat-1
   endif

! print channel options used
   if (Hgrid%channel) then
       write (logunit,'(4x,a4,f10.3,4x,a4,f10.3)') 'WBD=',wbd,'EBD=',ebd
       write (logunit,'(4x,a4,f10.3,4x,a4,f10.3)') 'SBD=',sbd,'NBD=',nbd
       if (do_fplane_approx) then
           write (logunit,'(4x,a4,f10.3)') 'FPHD=',fphd
       endif
   endif
 
!---- set-up x- & y-axis decomposition -----

 domain_layout = (/ 0, 0 /)
 if (present(layout)) domain_layout = layout
 if (domain_layout(1)+domain_layout(2) == 0) then
     call mpp_define_layout ( (/1,nlon,1,nlat/), npes, domain_layout )
 else
     if (domain_layout(1) == 0) domain_layout(1) = npes/domain_layout(2)
     if (domain_layout(2) == 0) domain_layout(2) = npes/domain_layout(1)
 endif

  if ( domain_layout(1)*domain_layout(2) /= npes ) call error_mesg &
              ('horiz_grid_init', 'number of processors requested not &
                                  &compatible with grid', FATAL )

! flag to indicate axis decomposition
  Hgrid % decompx = domain_layout(1) .gt. 1
  Hgrid % decompy = domain_layout(2) .gt. 1


!    ---- mass/temperature grid domain with halo = 0,1 ----

     call mpp_define_domains ( (/1,nlon,1,nlat/), domain_layout,   &
                               Hgrid % Tmp % Domain,               &
                               xflags = CYCLIC_GLOBAL_DOMAIN,      &
                               yflags = yflags,                    &
                               xhalo = 1, yhalo = 1,               &
          name = 'ATMOSPHERIC (B-GRID) MODEL, temperature grid, halo=1,')
     call mpp_define_domains ( (/1,nlon,1,nlat/), domain_layout,   &
                               Hgrid % Tmp % Domain_nohalo,        &
                               xflags = CYCLIC_GLOBAL_DOMAIN,      &
                               yflags = yflags,                    &
                               xhalo = 0, yhalo = 0                )

!   ---- compute exact decomposition ----
!   ---- compute 2d layout of PEs ----

     allocate ( xrows(domain_layout(1)), yrows(domain_layout(2)) )
     call mpp_get_domain_components ( Hgrid%Tmp%Domain, Domx, Domy )
     call mpp_get_compute_domains   ( Domx, size=xrows )
     call mpp_get_compute_domains   ( Domy, size=yrows )

!    ---- velocity grid may have one less latitude row ----

     if (nlatv == nlat-1) then
         yrows(domain_layout(2)) = yrows(domain_layout(2)) - 1
     endif

!    ---- velocity grid domain with halo = 0,1 ----

     call mpp_define_domains ( (/1,nlon,1,nlatv/), domain_layout,  &
                               Hgrid % Vel % Domain,               &
                               xflags = CYCLIC_GLOBAL_DOMAIN,      &
                               yflags = yflags,                    &
                               xhalo = 1, yhalo = 1,               &
                               xextent = xrows, yextent = yrows    )
     call mpp_define_domains ( (/1,nlon,1,nlatv/), domain_layout,  &
                               Hgrid % Vel % Domain_nohalo,        &
                               xflags = CYCLIC_GLOBAL_DOMAIN,      &
                               yflags = yflags,                    &
                               xhalo = 0, yhalo = 0,               &
                               xextent = xrows, yextent = yrows    )

     deallocate ( xrows, yrows )


!------------- indices for global compute domain -----------------------

     call mpp_get_global_domain ( Hgrid%Tmp%Domain, isg, ieg, hsg, heg )
     call mpp_get_global_domain ( Hgrid%Vel%Domain, isg, ieg, vsg, veg )

     Hgrid % Tmp % isg = isg;   Hgrid % Tmp % ieg = ieg
     Hgrid % Tmp % jsg = hsg;   Hgrid % Tmp % jeg = heg
     Hgrid % Vel % isg = isg;   Hgrid % Vel % ieg = ieg
     Hgrid % Vel % jsg = vsg;   Hgrid % Vel % jeg = veg

!------------- indices for data domain -----------------------

     call mpp_get_data_domain ( Hgrid%Tmp%Domain, isd, ied, hsd, hed )
     call mpp_get_data_domain ( Hgrid%Vel%Domain, isd, ied, vsd, ved )

     Hgrid % Tmp % isd = isd;   Hgrid % Tmp % ied = ied
     Hgrid % Tmp % jsd = hsd;   Hgrid % Tmp % jed = hed
     Hgrid % Vel % isd = isd;   Hgrid % Vel % ied = ied
     Hgrid % Vel % jsd = vsd;   Hgrid % Vel % jed = ved

!------------- indices for computational domain ------------------------

     call mpp_get_compute_domain ( Hgrid%Tmp%Domain, is, ie, hs, he )
     call mpp_get_compute_domain ( Hgrid%Vel%Domain, is, ie, vs, ve )

     Hgrid % Tmp % is = is;   Hgrid % Tmp % ie = ie
     Hgrid % Tmp % js = hs;   Hgrid % Tmp % je = he
     Hgrid % Vel % is = is;   Hgrid % Vel % ie = ie
     Hgrid % Vel % js = vs;   Hgrid % Vel % je = ve

!------------- indices including halo regions --------------------------

     call mpp_get_data_domain ( Hgrid%Tmp%Domain, ilb, iub, jlb, jub )

     Hgrid % ilb = ilb;  Hgrid % iub = iub
     Hgrid % jlb = jlb;  Hgrid % jub = jub

!------------ other values ---------------------------------------------

     Hgrid % nlon = nlon  ! global resolution
     Hgrid % nlat = nlat

     Hgrid % isize = Hgrid % iub - Hgrid % ilb + 1  ! array size for current PE
     Hgrid % jsize = Hgrid % jub - Hgrid % jlb + 1

!-----------------------------------------------------------------------
!    -------- allocate space for arrays ---------

    call alloc_array_space ( ilb, iub, jlb, jub, Hgrid%Tmp )
    call alloc_array_space ( ilb, iub, jlb, jub, Hgrid%Vel )
                 
    allocate ( Hgrid % sinphv(ilb:iub,jlb:jub), &
               Hgrid % tanphv(ilb:iub,jlb:jub)  )

    allocate ( slat (hs-1:he+2), wt (ilb:iub,jlb:jub) ) 

!-----------------------------------------------------------------------
!--------------derived geometrical constants----------------------------

      hpi = acos(0.0)
      dtr = hpi/90.

      if (Hgrid%channel) then
          Hgrid % dphd = (nbd-sbd)/real(nlat)
          Hgrid % dlmd = (ebd-wbd)/real(nlon)
          Hgrid % sb = sbd*dtr
          Hgrid % nb = nbd*dtr
          Hgrid % wb = wbd*dtr
          Hgrid % eb = ebd*dtr
          global_x = abs(ebd-wbd-360.).lt.eps
          global_y = abs(nbd-sbd-180.).lt.eps
      else
          ! global code used for bit-reprocibility
          Hgrid % dphd = 180./real(nlat)
          Hgrid % dlmd = 360./real(nlon)
          Hgrid % sb =  -hpi
          Hgrid % nb =  +hpi
          Hgrid % wb =   0.0
          Hgrid % eb = 360.0*dtr
          global_x = .true.
          global_y = .true.
      endif

      Hgrid % dlm = Hgrid % dlmd*dtr
      Hgrid % dph = Hgrid % dphd*dtr

!     --- dy is the same on both grids ---

      Hgrid % Tmp %  dy = RADIUS * Hgrid % dph
      Hgrid % Vel %  dy = RADIUS * Hgrid % dph
      Hgrid % Tmp % rdy = 1.0 / Hgrid % Tmp % dy
      Hgrid % Vel % rdy = 1.0 / Hgrid % Vel % dy

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!---- get grid box boundaries for computational global domain ----

     Hgrid % Tmp % blong(isg-1:ieg+2) = get_grid (nlon+3, Hgrid%wb-Hgrid%dlm, &
                                                                   Hgrid%dlm  )
   ! global cyclic continuity (may not be necessary)
     if (global_x) then
        Hgrid % Tmp % blong(isg-1) = Hgrid % Tmp % blong(ieg)-4.*hpi
        Hgrid % Tmp % blong(ieg+1) = Hgrid % Tmp % blong(isg)+4.*hpi
        Hgrid % Tmp % blong(ieg+2) = Hgrid % Tmp % blong(isg+1)+4.*hpi
     endif

     Hgrid % Tmp % blatg(hsg+1:heg) = get_grid (nlat-1, Hgrid%sb+Hgrid%dph, &
                                                                 Hgrid%dph  )
   ! polar halos
     Hgrid % Tmp % blatg(heg+2) = Hgrid % Tmp % blatg(heg)
     Hgrid % Tmp % blatg(heg+1) = Hgrid % nb
     Hgrid % Tmp % blatg(hsg)   = Hgrid % sb
     Hgrid % Tmp % blatg(hsg-1) = Hgrid % Tmp % blatg(hsg+1)

     do i = is-1, ie+1
        Hgrid % Tmp % tlm(i) = 0.5*(Hgrid%Tmp%blong(i)+Hgrid%Tmp%blong(i+1))
     enddo

     do j = hs-1, he+1
        Hgrid % Tmp % tph(j) = 0.5*(Hgrid%Tmp%blatg(j)+Hgrid%Tmp%blatg(j+1))
     enddo

     if (do_fplane_approx) then
!    --- no spherical geometry ---
         Hgrid % Tmp % dx(hs-1:he+1) = RADIUS * Hgrid % dlm
     else
!    --- sphere ---
         slat(hs-1:he+2) = sin(Hgrid%Tmp%blatg(hs-1:he+2))
         Hgrid % Tmp % dx (hs-1:he+1) = RADIUS * Hgrid % dlm / Hgrid % dph *  &
                                        abs(slat(hs:he+2)-slat(hs-1:he+1))
     endif

!-------------initialize lat/lon at velocity points---------------------

     Hgrid % Vel % blong(isg-1:ieg+2) = get_grid (nlon+3, Hgrid%wb-0.5*Hgrid%dlm, &
                                                                       Hgrid%dlm  )
   ! global cyclic continuity
     if (global_x) then
        Hgrid % Vel % blong(isg-1) = Hgrid % Vel % blong(ieg)-4.*hpi
        Hgrid % Vel % blong(ieg+1) = Hgrid % Vel % blong(isg)+4.*hpi
        Hgrid % Vel % blong(ieg+2) = Hgrid % Vel % blong(isg+1)+4.*hpi
     endif

     Hgrid % Vel % blatg(vsg:veg+1) = get_grid (nlat, Hgrid%sb+0.5*Hgrid%dph, &
                                                                   Hgrid%dph  )
   ! polar halos
     Hgrid % Vel % blatg(vsg-1) = Hgrid % sb
     Hgrid % Vel % blatg(veg+2) = Hgrid % nb

     do i = is-1, ie+1
        Hgrid % Vel % tlm(i) = 0.5*(Hgrid%Vel%blong(i)+Hgrid%Vel%blong(i+1))
     enddo
     do j = vs-1, ve+1
        Hgrid % Vel % tph(j) = 0.5*(Hgrid%Vel%blatg(j)+Hgrid%Vel%blatg(j+1))
     enddo

     if (do_fplane_approx) then
!    --- no spherical geometry ---
         Hgrid % Vel % dx = RADIUS * Hgrid % dlm
     else
!    --- sphere ---
         slat(vs-1:ve+2) = sin(Hgrid%Vel%blatg(vs-1:ve+2))
         Hgrid % Vel % dx (vs-1:ve+1) = RADIUS * Hgrid % dlm / Hgrid % dph *  &
                                        (slat(vs:ve+2)-slat(vs-1:ve+1))
     endif
     Hgrid % Vel % rdx(vs-1:ve+1) = 1.0 / Hgrid % Vel % dx(vs-1:ve+1)

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!------------- grid box areas ------------------------------------------

      Hgrid % Tmp % area = Hgrid % Tmp % dx * Hgrid % Tmp % dy
      Hgrid % Vel % area = Hgrid % Vel % dx * Hgrid % Vel % dy

! Note: area of the pole on velocity grid is not important because:
!         1) pole is not in compute domain
!         2) current polar boundary condition is u=v=0
!         3) fluxes between pole and sub-pole row are set to zero

!--- reciprocal of area ----

      do j = jlb, jub
         if (Hgrid % Tmp % area(j) > 0.0) Hgrid % Tmp % rarea(j) = 1.0 / Hgrid % Tmp % area(j)
         if (Hgrid % Vel % area(j) > 0.0) Hgrid % Vel % rarea(j) = 1.0 / Hgrid % Vel % area(j)
      enddo

!--- compute bit-reproducible global sum of area ---

      do j = hsd, hed
         wt(:,j) = Hgrid%Tmp%area(j)
      enddo
      Hgrid % Tmp % areasum = mpp_global_sum (Hgrid%Tmp%Domain, wt, flags=BITWISE_EXACT_SUM)

      do j = vsd, ved  ! may not be full array extent
         wt(:,j) = Hgrid%Vel%area(j)
      enddo
      Hgrid % Vel % areasum = mpp_global_sum (Hgrid%Vel%Domain, wt(:,vsd:ved), flags=BITWISE_EXACT_SUM)

      deallocate ( slat, wt )


!--- initialization of weights for grid interpolation ---

     call bgrid_interp_init ( Hgrid )

!-----------------------------------------------------------------------
! unsupported option for transforming the position of poles
! tph0d,tlm0d are the lat,lon position in the transformed grid
! of the point [lat=0,lon=0] ..... I think ????

      if (tph0d > eps .or. tlm0d > eps) then
         ! compute "actual" lat/lon ( aph, aph )
         ! actual lat/lon would be used for the coriolis, radiation, and ...
         ! at temperature points
           call trans_latlon (tph0d,  tlm0d,                        &
                              Hgrid % Tmp % tlm, Hgrid % Tmp % tph, &
                              Hgrid % Tmp % alm, Hgrid % Tmp % aph)
         ! at velocity points
           call trans_latlon (tph0d,  tlm0d,                        &
                              Hgrid % Vel % tlm, Hgrid % Vel % tph, &
                              Hgrid % Vel % alm, Hgrid % Vel % aph)
      else
         ! no transformation
           do j = jlb, jub
           do i = ilb, iub
              Hgrid % Tmp % aph(i,j) = Hgrid % Tmp % tph(j)
              Hgrid % Vel % aph(i,j) = Hgrid % Vel % tph(j)
              Hgrid % Tmp % alm(i,j) = Hgrid % Tmp % tlm(i)
              Hgrid % Vel % alm(i,j) = Hgrid % Vel % tlm(i)
           enddo
           enddo
      endif

!------------- trigometric constants -----------------------------------

      if (do_fplane_approx) then
!     --- channel model ---
          Hgrid % sinphv = sin(fphd*dtr)
          Hgrid % tanphv = tan(fphd*dtr)
      else
!     --- sphere ---
          Hgrid % sinphv = sin(Hgrid % Vel % aph)
          Hgrid % tanphv = tan(Hgrid % Vel % aph)
      endif

!-----------------------------------------------------------------------

end subroutine horiz_grid_init

!##############################################################################
! initializes weights for interpolation between model grids

subroutine bgrid_interp_init ( Hgrid )
type(horiz_grid_type), intent(inout) :: Hgrid

real :: hpi
real :: sph  (1:2*Hgrid%nlat+1), area(-1:2*Hgrid%nlat+2)
real :: areah(Hgrid%Tmp%jsd:Hgrid%Tmp%jed), areav(Hgrid%Vel%jsd:Hgrid%Vel%jed)
integer :: i, j, k
! indexing for interpolation weights array
  integer, parameter :: SOUTH = 1, NORTH = 2

! allocate memory
 allocate ( Hgrid%Interp%tmpwts(Hgrid%jlb:Hgrid%jub,2), &
            Hgrid%Interp%velwts(Hgrid%jlb:Hgrid%jub,2), &
            Hgrid%Interp%nowts (Hgrid%jlb:Hgrid%jub,2)  )

! weights for simple 4-pt averages with equal weighting
  Hgrid%Interp%nowts = 0.25

! equal weighting for non-spherical grid
  if (do_fplane_approx) then
      Hgrid%Interp%tmpwts = 0.25
      Hgrid%Interp%velwts = 0.25
      return
  endif

! create weights that will conserve the quantity being interpolated

! create areas for grid boxes and interpolation
! need sin(lat) every 1/2 delta-lat
  hpi = acos(0.0)
  if (.not.Hgrid%channel) then
      ! original global code (used for bit-reproducibility)
      sph(1) = -1.; sph(2*Hgrid%nlat+1) = 1.
      do j = 2, 2*Hgrid%nlat
        sph(j) = sin(-hpi+real(j-1)*Hgrid%dph*0.5)
      enddo
  else
      sph(1) = sin(Hgrid%sb); sph(2*Hgrid%nlat+1) = sin(Hgrid%nb)
      do j = 2, 2*Hgrid%nlat
        sph(j) = sin(Hgrid%sb+real(j-1)*Hgrid%dph*0.5)
      enddo
  endif
! 1/4 area/radius^2 of grid boxes
  area(1:2*Hgrid%nlat) = 0.5*Hgrid%dlm*(sph(2:2*Hgrid%nlat+1)-sph(1:2*Hgrid%nlat))
! assume halo size of one (fill two 1/2 size grid boxes)
  area(-1:0) = area(2:1:-1)
  area(2*Hgrid%nlat+1:2*Hgrid%nlat+2) = area(2*Hgrid%nlat:2*Hgrid%nlat-1:-1)

! area of temperature grid boxes
  do j = Hgrid%Tmp%jsd, Hgrid%Tmp%jed
    Hgrid%Interp%tmpwts(j,SOUTH) = area(2*j-1)
    Hgrid%Interp%tmpwts(j,NORTH) = area(2*j)
    areah(j) = (Hgrid%Interp%tmpwts(j,SOUTH)+Hgrid%Interp%tmpwts(j,NORTH))*2.0
    ! compute final weights for 4-pt averages
    Hgrid%Interp%tmpwts(j,SOUTH) = Hgrid%Interp%tmpwts(j,SOUTH) / areah(j)
    Hgrid%Interp%tmpwts(j,NORTH) = Hgrid%Interp%tmpwts(j,NORTH) / areah(j)
  enddo

! area of velocity grid boxes
  do j = Hgrid%Vel%jsd, Hgrid%Vel%jed
    Hgrid%Interp%velwts(j,SOUTH) = area(2*j)
    Hgrid%Interp%velwts(j,NORTH) = area(2*j+1)
    areav(j) = (Hgrid%Interp%velwts(j,SOUTH)+Hgrid%Interp%velwts(j,NORTH))*2.0
    ! compute final weights for 4-pt averages
    Hgrid%Interp%velwts(j,SOUTH) = Hgrid%Interp%velwts(j,SOUTH) / areav(j)
    Hgrid%Interp%velwts(j,NORTH) = Hgrid%Interp%velwts(j,NORTH) / areav(j)
  enddo

end subroutine bgrid_interp_init

!#######################################################################

function get_grid (npts, start, space) result (grid)

integer, intent(in) :: npts
real,    intent(in) :: start, space
real                :: grid(npts)
integer :: j

!---- compute equally spaced grid ----

      do j = 1, npts
         grid(j) = start + real(j-1)*space
      enddo

end function get_grid

!#######################################################################

   subroutine trans_latlon (tph0d, tlm0d, tlm, tph, alm, aph)

   real, intent(in)  :: tph0d, tlm0d, tlm(:), tph(:)
   real, intent(out) :: alm(:,:), aph(:,:)

   real :: dtr, pi, tph0, tlm0, stph0, ctph0, ttph0, cc, ee
   real, dimension(size(tph)) :: stph, ctph
   integer :: i, j

!-----------------------------------------------------------------------

    ! scalars
      pi  = 2.*acos(0.0)
      dtr  = pi/180.
      tph0 = tph0d*dtr;  tlm0 = tlm0d*dtr
      stph0 = sin(tph0); ctph0 = cos(tph0)
      ttph0 = stph0/ctph0

!     ------- compute actual lat and lon -------
      stph = sin(tph)
      ctph = cos(tph)
      do j = 1, size(aph,2)
      do i = 1, size(aph,1)
         cc = ctph(j)*cos(tlm(i))
         aph(i,j) = asin(ctph0*stph(j)+stph0*cc)
         ee = cc/(ctph0*cos(aph(i,j))) - tan(aph(i,j))*ttph0
         ee = min(ee,1.)
         if (tlm(i) > pi) then
             alm(i,j) = tlm0-acos(ee)
         else
             alm(i,j) = tlm0+acos(ee)
         endif
      enddo
      enddo

!-----------------------------------------------------------------------

end subroutine trans_latlon

!#######################################################################

subroutine get_horiz_grid_bound ( Hgrid, grid, blon, blat, global )

!       returns the grid box boundaries for either
!           the compute or global grid
!
!   Hgrid = horizontal grid constants
!   grid  = grid identifier, possible values: TGRID, VGRID
!   blon  = longitude edges in radians
!   blat  = latitude edges in radians
!   global = values for compute(F) or global(T) grid?

   type (horiz_grid_type), intent(in)  :: Hgrid
   integer,                intent(in)  ::  grid
   real,                   intent(out) :: blon(:), blat(:)
   logical, optional,      intent(in)  :: global

    select case (grid)
       case (TGRID)
          call horiz_grid_bound ( Hgrid%Tmp, blon, blat, global )
       case (VGRID)
          call horiz_grid_bound ( Hgrid%Vel, blon, blat, global )
       case default
          call error_mesg ('get_horiz_grid_bound', 'invalid grid', FATAL)
    end select

!-----------------------------------------------------------------------

end subroutine get_horiz_grid_bound

!#######################################################################

subroutine get_horiz_grid_size ( Hgrid, grid, nlon, nlat, global )

!     returns the number of longitude and latitude grid boxes
!            for either the compute or global grid
!
!   Hgrid = horizontal grid constants
!   grid  = grid identifier, possible values: TGRID, VGRID
!   nlon  = number longitude grid boxes
!   nlat  = number latitude grid boxes
!   global = values for compute(F) or global(T) grid?

   type (horiz_grid_type), intent(in)  :: Hgrid
   integer,                intent(in)  ::  grid
   integer,                intent(out) :: nlon, nlat
   logical, optional,      intent(in)  :: global

    select case (grid)
       case (TGRID)
          call horiz_grid_size ( Hgrid%Tmp, nlon, nlat, global )
       case (VGRID)
          call horiz_grid_size ( Hgrid%Vel, nlon, nlat, global )
       case default
          call error_mesg ('get_horiz_grid_size', 'invalid grid', FATAL)
    end select

end subroutine get_horiz_grid_size

!#######################################################################

subroutine horiz_grid_bound ( Grid, blon, blat, global )

   type (bgrid_type), intent(in)  :: Grid
   real,              intent(out) :: blon(:), blat(:) 
   logical, optional, intent(in)  :: global

!      private routine that returns the grid box boundaries
!          for either the compute or global grid

    integer :: is, ie, js, je
    logical :: lglobal 

    lglobal = .false.;  if (present(global)) lglobal = global


    if (lglobal) then
      is = Grid % isg; ie = Grid % ieg  ! global grid
      js = Grid % jsg; je = Grid % jeg
    else    
      is = Grid % is ; ie = Grid % ie   ! compute grid
      js = Grid % js ; je = Grid % je
    endif   

     !----- define longitudinal grid box edges -----

      if (size(blon) /= ie-is+2) call error_mesg  &
                         ('get_horiz_grid_bound', &
                          'invalid argument dimension for blon', FATAL)

      blon = Grid % blong (is:ie+1)

     !----- define latitudinal grid box edges -----

      if (size(blat) /= je-js+2) call error_mesg  &
                         ('get_horiz_grid_bound', &
                          'invalid argument dimension for blat', FATAL)

      blat = Grid %  blatg (js:je+1)

!-----------------------------------------------------------------------

end subroutine horiz_grid_bound

!#######################################################################

subroutine horiz_grid_size ( Grid, nlon, nlat, global )

   type (bgrid_type), intent(in)  :: Grid
   integer,                intent(out) :: nlon, nlat
   logical, optional,      intent(in)  :: global

   logical :: lglobal

   lglobal = .false.;  if (present(global)) lglobal = global

  !---- return the size of the requested grid ----

   if (lglobal) then
      nlon = Grid % ieg - Grid % isg + 1   ! global grid
      nlat = Grid % jeg - Grid % jsg + 1
   else
      nlon = Grid % ie - Grid % is + 1     ! compute grid
      nlat = Grid % je - Grid % js + 1
   endif

end subroutine horiz_grid_size

!#######################################################################

function update_np (Hgrid, grid) result (answer)

!   Hgrid = horizontal grid constants
!   grid  = grid identifier, possible values: TGRID, VGRID
!
!   Returns TRUE if the northernmost latitude row
!   is adjacent to the north pole.

  type (horiz_grid_type), intent(in)  :: Hgrid
  integer,                intent(in)  ::  grid
  logical :: answer
  integer :: je, jeg

     answer = .false.
    !if (Hgrid%Tmp%jeg == Hgrid%Vel%jeg) return ! periodic in y
     if (Hgrid%double_periodic) return ! periodic in y

     select case (grid)
       case (TGRID)
          if ( Hgrid%Tmp%je == Hgrid%Tmp%jeg ) answer = .true.
       case(VGRID)
          if ( Hgrid%Vel%je == Hgrid%Vel%jeg ) answer = .true.
       case default
          call error_mesg ('update_np', 'invalid grid', FATAL)
     end select

end function update_np

!#######################################################################

function update_sp (Hgrid, grid) result (answer)

!   Hgrid = horizontal grid constants
!   grid  = grid identifier, possible values: TGRID, VGRID
!
!   Returns TRUE if the southernmost latitude row
!   is adjacent to the south pole.

  type (horiz_grid_type), intent(in)  :: Hgrid
  integer,                intent(in)  ::  grid
  logical :: answer
  integer :: js, jsg

     answer = .false.
    !if (Hgrid%Tmp%jeg == Hgrid%Vel%jeg) return ! periodic in y
     if (Hgrid%double_periodic) return ! periodic in y

     select case (grid)
       case (TGRID)
          if ( Hgrid%Tmp%js == Hgrid%Tmp%jsg ) answer = .true.
       case(VGRID)
          if ( Hgrid%Vel%js == Hgrid%Vel%jsg ) answer = .true.
       case default
          call error_mesg ('update_sp', 'invalid grid', FATAL)
     end select

end function update_sp

!#######################################################################

 subroutine alloc_array_space ( ilb, iub, jlb, jub, Grid )
 integer, intent(in) :: ilb, iub, jlb, jub
 type(bgrid_type), intent(inout) :: Grid
         
      allocate ( Grid % dx   (jlb:jub), &
                 Grid % rdx  (jlb:jub), &
                 Grid % tph  (jlb:jub), &
                 Grid % tlm  (ilb:iub), &
                 Grid % area (jlb:jub), &
                 Grid % rarea(jlb:jub), &
                 Grid % aph  (ilb:iub,jlb:jub), &
                 Grid % alm  (ilb:iub,jlb:jub)  )

      allocate ( Grid % blong (Grid%isg-1:Grid%ieg+2), &
                 Grid % blatg (Grid%jsg-1:Grid%jeg+2)  )

      Grid % dx   = 0.; Grid % rdx   = 0.
      Grid % tph  = 0.; Grid % tlm   = 0.
      Grid % area = 0.; Grid % rarea = 0.

 end subroutine alloc_array_space

!#######################################################################

end module bgrid_horiz_mod

module atmos_ch3i_mod


use mpp_mod, only: input_nml_file 
use            fms_mod, only : file_exist,   &
                               write_version_number, &
                               error_mesg, &
                               FATAL, &
                               NOTE, &
                               mpp_pe,  &
                               mpp_root_pe, &
                               lowercase,   &
                               open_namelist_file, &
                               check_nml_error, &
                               close_file,   &
                               stdlog
use  field_manager_mod, only : MODEL_ATMOS,          &
                               parse
use tracer_manager_mod, only : get_tracer_index,     &
                               get_tracer_names,     &
                               query_method
use   time_manager_mod, only : time_type
use   diag_manager_mod, only : send_data,            &
                               register_diag_field
use   interpolator_mod, only : interpolate_type,     &
                               interpolator_init,    &
                               obtain_interpolator_time_slices, &
                               unset_interpolator_time_flag, &
                               interpolator_end,     &
                               interpolator,         &
                               query_interpolator,   &
                               CONSTANT,             &
                               INTERP_WEIGHTED_P  
use      constants_mod, only : WTMAIR, &
                               AVOGNO, &
                               SECONDS_PER_DAY
implicit none

private
public :: atmos_ch3i_init, atmos_ch3i_time_vary, atmos_ch3i,  &
          atmos_ch3i_endts, atmos_ch3i_end

!-----------------------------------------------------------------------
!     ... namelist
!-----------------------------------------------------------------------
character(len=128) :: conc_filename = ''

namelist /atmos_ch3i_nml/    &
   conc_filename

logical :: has_emissions                      
character(len=128) :: emis_filename
type(interpolate_type), save :: ch3i_emissions, input_conc

character(len=128), allocatable :: field_names(:)

integer :: id_emissions, id_loss, id_j_ch3i, ind_ch3i
real, parameter :: g_to_kg    = 1.e-3,    & !conversion factor (kg/g)
                   m2_to_cm2  = 1.e4        !conversion factor (cm2/m2)
real, parameter :: emis_cons = WTMAIR * g_to_kg * m2_to_cm2 / AVOGNO        
real, parameter :: boltz = 1.38044e-16      ! Boltzmann's Constant (erg/K)


character(len=7), parameter :: module_name = 'tracers'
!---- version number -----
character(len=128) :: version = '$Id: atmos_ch3i.F90,v 20.0 2013/12/13 23:23:47 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
logical :: module_is_initialized = .FALSE.

contains

subroutine atmos_ch3i_init( lonb_mod, latb_mod, axes, Time, mask )

!-----------------------------------------------------------------------
!
!   mask = optional mask (0. or 1.) that designates which grid points
!          are above (=1.) or below (=0.) the ground dimensioned as
!          (nlon,nlat,nlev).
!
!-----------------------------------------------------------------------
   real, intent(in), dimension(:,:) :: lonb_mod
   real, intent(in), dimension(:,:) :: latb_mod
   type(time_type), intent(in) :: Time
   integer        , intent(in) :: axes(4)
   real, intent(in),    dimension(:,:,:), optional :: mask

!-----------------------------------------------------------------------

   integer ::  unit, nfields, flag_file
   integer :: ierr, io, logunit

   character(len=128) :: tracer_name, tracer_units, name, control

   if (module_is_initialized) then
      return
   end if

   ind_ch3i = get_tracer_index(MODEL_ATMOS, 'ch3i')

!-----------------------------------------------------------------------
!     ... write version number
!-----------------------------------------------------------------------
   call write_version_number(version, tagname)

!-----------------------------------------------------------------------
!     ... read namelist
!-----------------------------------------------------------------------
   if ( file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
     read (input_nml_file, nml=atmos_ch3i_nml, iostat=io)
     ierr = check_nml_error(io, 'atmos_ch3i_nml')
#else
     unit = open_namelist_file ()
     ierr=1; do while (ierr /= 0)
     read  (unit, nml=atmos_ch3i_nml, iostat=io, end=10)
     ierr = check_nml_error(io, 'atmos_ch3i_nml')
     enddo
10   call close_file (unit)
#endif
   endif

  
   logunit=stdlog()
   if(mpp_pe() == mpp_root_pe()) then       
      write(logunit, nml=atmos_ch3i_nml)
   endif
     
!-----------------------------------------------------------------------
!     ... set up emissions
!-----------------------------------------------------------------------
   has_emissions = .false.
   if( query_method('emissions',MODEL_ATMOS,ind_ch3i,name,control) ) then
      if( trim(name) == 'file' ) then
         flag_file = parse(control, 'file',emis_filename)
         if (flag_file > 0) then
            has_emissions = .true.
            call interpolator_init( ch3i_emissions, trim(emis_filename), &
                                    lonb_mod, latb_mod,  &
                                    data_out_of_bounds=(/CONSTANT/) )
            call query_interpolator(ch3i_emissions,nfields=nfields)
            allocate( field_names(nfields) )
            call query_interpolator(ch3i_emissions,field_names=field_names)
            id_emissions = register_diag_field( module_name, 'ch3i_emis', axes(1:2), &
                                                Time, 'ch3i_emis', 'molec/cm2/s' )
         else
            call error_mesg('atmos_ch3i_init','CH3I emission file not specified in field table',FATAL)
         end if
      else 
         call error_mesg('atmos_ch3i_init','CH3I emission file not specified in field table',FATAL)
      end if
   else
      call error_mesg('atmos_ch3i_init','No emissions specified for CH3I in field table',NOTE)
   end if

!-----------------------------------------------------------------------
!     ... set up tracer concentrations
!-----------------------------------------------------------------------
   if (conc_filename /= '') then
      call interpolator_init( input_conc,trim(conc_filename), lonb_mod, latb_mod,&
                              data_out_of_bounds=(/CONSTANT/), &
                              vert_interp=(/INTERP_WEIGHTED_P/) )
   end if


   call get_tracer_names( MODEL_ATMOS,ind_ch3i,tracer_name,units=tracer_units)
   id_loss =register_diag_field( module_name, 'ch3i_loss', axes(1:3), Time, 'ch3i_loss', TRIM(tracer_units)//'/s' )
   id_j_ch3i =register_diag_field( module_name, 'j_ch3i', axes(1:3), Time, 'j_ch3i', '/s' )

   module_is_initialized = .true.

end subroutine atmos_ch3i_init


!#####################################################################

subroutine atmos_ch3i_time_vary (Time)


type(time_type), intent(in) :: Time

      if (has_emissions) then
        call obtain_interpolator_time_slices (ch3i_emissions, Time)  
      endif
      if (conc_filename /= '') then
        call obtain_interpolator_time_slices (input_conc, Time)  
      endif

end subroutine atmos_ch3i_time_vary


!######################################################################

subroutine atmos_ch3i_endts              


      if (has_emissions) then
        call unset_interpolator_time_flag (ch3i_emissions)  
      endif
      if (conc_filename /= '') then
        call unset_interpolator_time_flag (input_conc)  
      endif

end subroutine atmos_ch3i_endts


!-----------------------------------------------------------------------

subroutine atmos_ch3i( lon, lat, land, pwt, ch3i, ch3i_dt,       &
                       Time, phalf, pfull, t, is, js, dt,    &
                       z_half, z_full, q, tsurf, albedo, coszen, &
                       Time_next, kbot)

real, intent(in),    dimension(:,:)            :: lon, lat
real, intent(in),    dimension(:,:)            :: land
real, intent(in),    dimension(:,:,:)          :: pwt
real, intent(in),    dimension(:,:,:)          :: ch3i
real, intent(out),   dimension(:,:,:)          :: ch3i_dt
type(time_type), intent(in)                    :: Time, Time_next     
integer, intent(in)                            :: is,js
real, intent(in),    dimension(:,:,:)          :: phalf,pfull,t
real, intent(in)                               :: dt !to be passed into chemdr
real, intent(in),    dimension(:,:,:)          :: z_half !height in meters at half levels
real, intent(in),    dimension(:,:,:)          :: z_full !height in meters at full levels
real, intent(in),    dimension(:,:,:)          :: q !specific humidity at current time step in kg/kg
real, intent(in),    dimension(:,:)            :: tsurf !surface temperature
real, intent(in),    dimension(:,:)            :: albedo
real, intent(in),    dimension(:,:)            :: coszen
integer, intent(in),  dimension(:,:), optional :: kbot

!-----------------------------------------------------------------------

logical :: used
integer :: i, j, k, id, jd, kd, kb
real, dimension(size(ch3i,1),size(ch3i,2),size(ch3i,3)) :: &
   conc_o3, conc_oh, j_ch3i, k_ch3i_oh, &
   emis_source, ch3i_loss, &
   air_dens
real, dimension(size(ch3i,1),size(ch3i,2)) :: emis,temp_data

!   <ERROR MSG="tracer_driver_init must be called first." STATUS="FATAL">
!     Tracer_driver_init needs to be called before tracer_driver.
!   </ERROR>
if (.not. module_is_initialized)  &
   call error_mesg ('atmos_ch3i','atmos_ch3i_init must be called first1', FATAL)

id=size(ch3i,1); jd=size(ch3i,2); kd=size(ch3i,3)

!-----------------------------------------------------------------------
!     ... Get emissions
!-----------------------------------------------------------------------
emis_source(:,:,:) = 0.
emis(:,:) = 0.
if (has_emissions) then
   do k = 1,size(field_names)
      call interpolator( ch3i_emissions, Time, temp_data, field_names(k), is, js )
      emis(:,:) = emis(:,:) + temp_data(:,:)
   end do
   if (present(kbot)) then
      do j=1,jd
         do i=1,id
            kb=kbot(i,j)
            emis_source(i,j,kb) = emis(i+is,j+js)/pwt(i,j,kb) * emis_cons
         enddo
      enddo
   else
      emis_source(:,:,kd) = emis(:,:)/pwt(:,:,kd) * emis_cons
   end if
   used = send_data(id_emissions,emis,Time_next,is_in=is,js_in=js)
end if

!-----------------------------------------------------------------------
!     ... Get tracer concentrations
!-----------------------------------------------------------------------
call interpolator(input_conc, Time, phalf, conc_o3, 'ox')
call interpolator(input_conc, Time, phalf, conc_oh, 'oh')

air_dens(:,:,:) = 10. * pfull(:,:,:) / (boltz*t(:,:,:)) ! molec/cm3
conc_oh(:,:,:) = conc_oh(:,:,:) * air_dens(:,:,:) ! convert VMR to molec/cm3

!-----------------------------------------------------------------------
!     ... reaction rates
!-----------------------------------------------------------------------
k_ch3i_oh(:,:,:) = 2.9e-12 * exp( -1100./t(:,:,:) ) ! s^-1
do k = 1,kd
   where( coszen(:,:) > 0. )
      j_ch3i(:,:,k) = 2./(4.*SECONDS_PER_DAY) ! s^-1
   elsewhere
      j_ch3i(:,:,k) = 0.
   endwhere
end do
ch3i_loss(:,:,:) = ( j_ch3i(:,:,:) + k_ch3i_oh(:,:,:)*conc_oh(:,:,:) ) &
                 * ch3i(:,:,:) ! VMR/s
used = send_data( id_loss, ch3i_loss, Time_next, is_in=is, js_in=js )
used = send_data( id_j_ch3i, j_ch3i, Time_next, is_in=is, js_in=js )

ch3i_dt(:,:,:) = emis_source(:,:,:) - ch3i_loss(:,:,:)


end subroutine atmos_ch3i

!-----------------------------------------------------------------------

subroutine atmos_ch3i_end

   deallocate( field_names )
   module_is_initialized = .FALSE.

end subroutine atmos_ch3i_end

end module atmos_ch3i_mod

#include <fms_platform.h>

module snow_tile_mod

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only : &
     write_version_number, file_exist, check_nml_error, &
     close_file, stdlog
use constants_mod,only: tfreeze, hlf
use land_constants_mod, only : &
     NBANDS
use land_tile_selectors_mod, only : &
     tile_selector_type

implicit none
private

! ==== public interfaces =====================================================
public :: snow_tile_type

public :: new_snow_tile, delete_snow_tile
public :: snow_tiles_can_be_merged, merge_snow_tiles
public :: snow_is_selected
public :: get_snow_tile_tag
public :: snow_tile_stock_pe
public :: snow_tile_heat

public :: read_snow_data_namelist

public :: snow_data_thermodynamics
public :: snow_data_hydraulics
public :: snow_data_area
public :: snow_data_radiation
public :: snow_data_diffusion

public :: max_lev
public :: cpw, clw, csw
! ==== end of public interfaces ==============================================
interface new_snow_tile
   module procedure snow_tile_ctor
   module procedure snow_tile_copy_ctor
end interface


! ==== module constants ======================================================
character(len=*), parameter :: &
     module_name = 'snow_tile_mod' ,&
     version     = '$Id: snow_tile.F90,v 20.0 2013/12/13 23:30:46 fms Exp $' ,&
     tagname     = '$Name: tikal $'
integer, parameter :: max_lev = 10
real   , parameter :: t_range = 10.0 ! degK

! from the modis brdf/albedo product user's guide:
real            :: g_iso  = 1.
real            :: g_vol  = 0.189184
real            :: g_geo  = -1.377622
real            :: g0_iso = 1.0
real            :: g1_iso = 0.0
real            :: g2_iso = 0.0
real            :: g0_vol = -0.007574
real            :: g1_vol = -0.070987
real            :: g2_vol =  0.307588
real            :: g0_geo = -1.284909
real            :: g1_geo = -0.166314
real            :: g2_geo =  0.041840

! ==== types =================================================================

type :: snow_tile_type
   integer :: tag ! kind of the tile
   real, pointer :: wl(:)
   real, pointer :: ws(:)
   real, pointer :: T(:)
   real,                 pointer :: e(:), f(:)
end type snow_tile_type

! ==== module data ===========================================================

!---- namelist ---------------------------------------------------------------
logical :: use_mcm_masking       = .false.   ! MCM snow mask fn
real    :: w_sat                 = 670.
real    :: psi_sat               = -0.06
real    :: k_sat                 = 0.02
real    :: chb                   = 3.5
real    :: thermal_cond_ref      = 0.3
real    :: depth_crit            = 0.0167
real    :: z0_momentum           = 0.001
real    :: refl_snow_max_dir(NBANDS) = (/ 0.8,  0.8  /) ! reset to 0.6 for MCM
real    :: refl_snow_max_dif(NBANDS) = (/ 0.8,  0.8  /) ! reset to 0.6 for MCM
real    :: refl_snow_min_dir(NBANDS) = (/ 0.65, 0.65 /) ! reset to 0.45 for MCM
real    :: refl_snow_min_dif(NBANDS) = (/ 0.65, 0.65 /) ! reset to 0.45 for MCM
real    :: emis_snow_max         = 0.95      ! reset to 1 for MCM
real    :: emis_snow_min         = 0.90      ! reset to 1 for MCM
real    :: k_over_B              = 2         ! reset to 0 for MCM
integer :: num_l                 = 3         ! number of snow levels
real    :: dz(max_lev)           = (/0.1,0.8,0.1,0.,0.,0.,0.,0.,0.,0./)
                                              ! rel. thickness of model layers,
                                              ! from top down
real    :: cpw = 1952.  ! specific heat of water vapor at constant pressure
real    :: clw = 4218.  ! specific heat of water (liquid)
real    :: csw = 2106.  ! specific heat of water (ice)
real    :: mc_fict = 10. * 4218 ! additional (fictitious) soil heat capacity (for numerical stability?).
! from analysis of modis data (ignoring temperature dependence):
  real :: f_iso_cold(NBANDS) = (/ 0.354, 0.530 /)
  real :: f_vol_cold(NBANDS) = (/ 0.200, 0.252 /)
  real :: f_geo_cold(NBANDS) = (/ 0.054, 0.064 /)
  real :: f_iso_warm(NBANDS) = (/ 0.354, 0.530 /)
  real :: f_vol_warm(NBANDS) = (/ 0.200, 0.252 /)
  real :: f_geo_warm(NBANDS) = (/ 0.054, 0.064 /)
  real :: refl_cold_dif(NBANDS), refl_warm_dif(NBANDS)

namelist /snow_data_nml/use_mcm_masking,    w_sat,                 &
                    psi_sat,                k_sat,                 &
                    chb,                                           &
                    thermal_cond_ref,       depth_crit,            &
                    z0_momentum,                                   &
                    refl_snow_max_dir,    refl_snow_min_dir,   &
                    refl_snow_max_dif,    refl_snow_min_dif,   &
                    emis_snow_max,          emis_snow_min,         &
                    k_over_B,             &
                    num_l,                   dz, cpw, clw, csw, mc_fict, &
     f_iso_cold, f_vol_cold, f_geo_cold, f_iso_warm, f_vol_warm, f_geo_warm 
     
!---- end of namelist --------------------------------------------------------

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

! ============================================================================
subroutine read_snow_data_namelist(snow_num_l, snow_dz, snow_mc_fict)
  integer, intent(out) :: snow_num_l
  real,    intent(out) :: snow_dz(:)
  real,    intent(out) :: snow_mc_fict

  ! ---- local vars
  integer :: unit         ! unit for namelist i/o
  integer :: io           ! i/o status for the namelist
  integer :: ierr         ! error code, returned by i/o routines

  call write_version_number(version, tagname)
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=snow_data_nml, iostat=io)
  ierr = check_nml_error(io, 'snow_data_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file()
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=snow_data_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'snow_data_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif
  unit=stdlog()
  write(unit, nml=snow_data_nml)

  ! initialize global module data here

  ! set up output arguments
  snow_num_l = num_l
  snow_dz    = dz
  snow_mc_fict = mc_fict

  refl_cold_dif = g_iso*f_iso_cold + g_vol*f_vol_cold + g_geo*f_geo_cold
  refl_warm_dif = g_iso*f_iso_warm + g_vol*f_vol_warm + g_geo*f_geo_warm

end subroutine 

! ============================================================================
function snow_tile_ctor(tag) result(ptr)
  type(snow_tile_type), pointer :: ptr ! return value
  integer, optional, intent(in) :: tag ! kind of tile

  allocate(ptr)
  ptr%tag = 0 ; if(present(tag)) ptr%tag = tag
  ! allocate storage for tile data
  allocate(ptr%ws(num_l))
  allocate(ptr%wl(num_l))
  allocate(ptr%T(num_l))
  allocate(ptr%e(num_l))
  allocate(ptr%f(num_l))

end function snow_tile_ctor

! ============================================================================
function snow_tile_copy_ctor(snow) result(ptr)
  type(snow_tile_type), pointer :: ptr ! return value
  type(snow_tile_type), intent(in) :: snow ! tile to copy

  allocate(ptr)
  ! copy all non-pointer members
  ptr = snow
  ! allocate storage for tile data
  allocate(ptr%ws(num_l))
  allocate(ptr%wl(num_l))
  allocate(ptr%T(num_l))
  allocate(ptr%e(num_l))
  allocate(ptr%f(num_l))
  ! copy all pointer members
  ptr%ws(:) = snow%ws(:)
  ptr%wl(:) = snow%wl(:)
  ptr%T(:) = snow%T(:)
  ptr%e(:) = snow%e(:)
  ptr%f(:) = snow%f(:)
end function snow_tile_copy_ctor

! ============================================================================
subroutine delete_snow_tile(snow)
  type(snow_tile_type), pointer :: snow

  deallocate(snow%ws)
  deallocate(snow%wl)
  deallocate(snow%T)
  deallocate(snow%e)
  deallocate(snow%f)
  deallocate(snow)
end subroutine delete_snow_tile

! =============================================================================
function snow_tiles_can_be_merged(snow1,snow2) result(response)
  logical :: response
  type(snow_tile_type), intent(in) :: snow1,snow2

  response = .TRUE.
end function

! =============================================================================
subroutine merge_snow_tiles(snow1, w1, snow2, w2)
  type(snow_tile_type), intent(in)    :: snow1
  type(snow_tile_type), intent(inout) :: snow2
  real                , intent(in)    :: w1, w2 ! relative weights
  
  ! ---- local vars
  real    :: x1, x2 ! normalized weights
  real    :: HEAT1, HEAT2
  integer :: i
  
  ! calculate normalized weights
  x1 = w1/(w1+w2)
  x2 = 1-x1
  
  do i = 1, num_l
    HEAT1 = (mc_fict*dz(i)+clw*snow1%wl(i)+csw*snow1%ws(i))*(snow1%T(i)-tfreeze)
    HEAT2 = (mc_fict*dz(i)+clw*snow2%wl(i)+csw*snow2%ws(i))*(snow2%T(i)-tfreeze)
    snow2%wl(i) = snow1%wl(i)*x1 + snow2%wl(i)*x2
    snow2%ws(i) = snow1%ws(i)*x1 + snow2%ws(i)*x2
    if (snow2%wl(i)/=0.or.snow2%ws(i)/=0) then
       snow2%T(i)  = (HEAT1*x1+HEAT2*x2)/&
            (mc_fict*dz(i)+clw*snow2%wl(i)+csw*snow2%ws(i))+tfreeze
    else
       snow2%T(i)  = snow1%T(i)*x1 + snow2%T(i)*x2
    endif
  enddo
end subroutine

! =============================================================================
! returns true if tile fits the specified selector
function snow_is_selected(snow, sel)
  logical snow_is_selected
  type(tile_selector_type),  intent(in) :: sel
  type(snow_tile_type),      intent(in) :: snow

  snow_is_selected = .TRUE.
end function

! ============================================================================
! retruns tag of the tile
function get_snow_tile_tag(snow) result(tag)
  integer :: tag
  type(snow_tile_type), intent(in) :: snow
  
  tag = snow%tag
end function

! ============================================================================
! compute snow thermodynmamic properties.
subroutine snow_data_thermodynamics ( snow_rh, thermal_cond)
  real, intent(out) :: snow_rh
  real, intent(out) :: thermal_cond(:)

  ! snow surface assumed to have air at saturation
  snow_rh = 1

  ! these will eventually be functions of water contents and T.
  thermal_cond  = thermal_cond_ref

end subroutine 


! ============================================================================
! compute snow hydraulic properties (assumed dependent only on wl)
subroutine snow_data_hydraulics (wl, ws, psi, hyd_cond )
  real, intent(in),  dimension(:) :: wl, ws
  real, intent(out), dimension(:) :: psi, hyd_cond

  ! ---- local vars 
  integer :: l
  
  do l = 1, num_l
    psi     (l) = psi_sat *(w_sat/(wl(l)+ws(l)))**chb
    hyd_cond(l) = k_sat*(wl(l)/w_sat)**(3+2*chb)
  enddo

end subroutine snow_data_hydraulics


! ============================================================================
! compute snow area
subroutine snow_data_area ( snow_depth, snow_area )
    real, intent(in)  :: snow_depth
    real, intent(out) :: snow_area

  snow_area = 0.
  if (use_mcm_masking) then
     snow_area = min(1., 0.5*sqrt(max(0.,snow_depth)/depth_crit))
  else
     snow_area = max(0.,snow_depth) / (max(0.,snow_depth) + depth_crit)
  endif

end subroutine


! ============================================================================
subroutine snow_data_radiation(snow_T, snow_refl_dir, snow_refl_dif, snow_emis,&
                                  cosz, use_brdf)
  real, intent(in) :: snow_T
  real, intent(out):: snow_refl_dir(NBANDS), snow_refl_dif(NBANDS), snow_emis
  real, optional :: cosz
  logical :: use_brdf

  ! ---- local vars
  real :: blend
  real :: warm_value_dir(NBANDS), cold_value_dir(NBANDS)
  real :: warm_value_dif(NBANDS), cold_value_dif(NBANDS)
  real :: zenith_angle, zsq, zcu

  blend = max(0.,min(1.,1.-(tfreeze-snow_T)/t_range))
  if (use_brdf) then
     zenith_angle = acos(cosz)
     zsq = zenith_angle*zenith_angle
     zcu = zenith_angle*zsq
     warm_value_dir = f_iso_warm*(g0_iso+g1_iso*zsq+g2_iso*zcu) &
                    + f_vol_warm*(g0_vol+g1_vol*zsq+g2_vol*zcu) &
                    + f_geo_warm*(g0_geo+g1_geo*zsq+g2_geo*zcu)
     cold_value_dir = f_iso_cold*(g0_iso+g1_iso*zsq+g2_iso*zcu) &
                    + f_vol_cold*(g0_vol+g1_vol*zsq+g2_vol*zcu) &
                    + f_geo_cold*(g0_geo+g1_geo*zsq+g2_geo*zcu)
     warm_value_dif = refl_warm_dif
     cold_value_dif = refl_cold_dif
  else
     warm_value_dir = refl_snow_min_dir
     cold_value_dir = refl_snow_max_dir
     warm_value_dif = refl_snow_min_dif
     cold_value_dif = refl_snow_max_dif
  endif
  snow_refl_dir = cold_value_dir + blend*(warm_value_dir-cold_value_dir)
  snow_refl_dif = cold_value_dif + blend*(warm_value_dif-cold_value_dif)
  snow_emis     = emis_snow_max + blend*(emis_snow_min-emis_snow_max  )
end subroutine


! ============================================================================
subroutine snow_data_diffusion(snow_z0s, snow_z0m)
  real, intent(out):: snow_z0s, snow_z0m

  snow_z0m =  z0_momentum
  snow_z0s =  z0_momentum * exp(-k_over_B)
end subroutine

! ============================================================================
subroutine snow_tile_stock_pe (snow, twd_liq, twd_sol  )
  type(snow_tile_type),  intent(in)    :: snow
  real,                  intent(out)   :: twd_liq, twd_sol
  integer n
  
  twd_liq = 0.
  twd_sol = 0.
  do n=1, size(snow%wl)
    twd_liq = twd_liq + snow%wl(n)
    twd_sol = twd_sol + snow%ws(n)
    enddo

end subroutine snow_tile_stock_pe

! ============================================================================
! returns snow heat content, J/m2
function snow_tile_heat (snow) result(heat) ; real heat
  type(snow_tile_type), intent(in)  :: snow

  integer :: i

  heat = 0
  do i = 1,num_l
     heat = heat - snow%ws(i)*hlf &
        + (mc_fict*dz(i) + clw*snow%wl(i) + csw*snow%ws(i))  &
                                      * (snow%T(i)-tfreeze) 
  enddo
end function

end module snow_tile_mod

! ============================================================================
! root uptake module
! ============================================================================
module uptake_mod

#include "../shared/debug.inc"

use constants_mod, only: PI
use fms_mod, only : write_version_number
use soil_tile_mod, only : &
     soil_tile_type, soil_pars_type, max_lev, psi_wilt
use land_debug_mod, only : is_watch_point

implicit none
private

! ==== public interfaces =====================================================
public :: UPTAKE_LINEAR, UPTAKE_DARCY2D, UPTAKE_DARCY2D_LIN

public :: uptake_init

public :: darcy2d_uptake, darcy2d_uptake_solver
public :: darcy2d_uptake_lin, darcy2d_uptake_solver_lin
! =====end of public interfaces ==============================================


! ==== module constants ======================================================
character(len=*), parameter, private   :: &
    module_name = 'uptake',&
    version     = '$Id: uptake.F90,v 20.0 2013/12/13 23:30:52 fms Exp $',&
    tagname     = '$Name: tikal $'

! values for internal soil uptake option selector
integer, parameter ::   &
     UPTAKE_LINEAR         = 1, &
     UPTAKE_DARCY2D        = 2, &
     UPTAKE_DARCY2D_LIN    = 3

! ==== module variables ======================================================
logical :: module_is_initialized =.FALSE.
integer :: num_l ! # of water layers
real    :: dz    (max_lev)    ! thicknesses of layers
real    :: zfull (max_lev)

contains

! ============================================================================
subroutine uptake_init(num_l_in, dz_in, zfull_in)
  integer, intent(in) :: num_l_in ! # of layers
  real   , intent(in) :: &
       dz_in(:), &  ! layer thickness
       zfull_in(:)  ! layer centers

  call write_version_number(version, tagname)
  module_is_initialized =.TRUE.

  num_l = num_l_in
  dz    = dz_in
  zfull = zfull_in
end subroutine uptake_init


! ============================================================================
! given soil and root parameters, calculate the flux of water toward root
! per unit root length, and its derivative w.r.t. xylem water potential
subroutine darcy2d_flow (psi_x, psi_soil, K_sat, psi_sat, b, K_r, r_r, R, eps, u, du, psi_root)
  real, intent(in) :: &
       psi_x,    & ! xylem water potential, m
       psi_soil, & ! soil water potential, m
       K_sat,    & ! saturated soil hydraulic conductivity, kg/(m2 s)
       psi_sat,  & ! saturates soil water potential, m
       b,        & ! power of soil moisture characteristic function
       K_r,      & ! root membrane permeability per unit area, kg/(m3 s)
       r_r,      & ! radius of root, m
       R,        & ! characteristic radial half-distance between roots, m
       eps         ! requested precision in terms of psi, m

  real, intent(out) :: &
       u,        & ! uptake, kg/(m s)
       du,       & ! derivative of uptake w.r.t psi_x, kg/(m2 s)
       psi_root    ! water potential at the root/soil interface, m

  ! ---- local constants
  integer :: max_iter = 50 ! max number of iterations
  ! ---- local vars
  real :: u_soil, u_root ! water flows through soil and root skin, respectively, kg/(m s)
  real :: f ! u_soil - u_root difference; we look for f(psi_root) = 0
  real :: df ! derivative of w.r.t psi_root
  real :: n
  real :: C_r ! 
  real :: K_s
  real :: K_root ! root membrane prmeability per unit length, kg/(m2 s)
  real :: pl, ph ! brackets of the solution
  real :: psi_root0 ! previous guess for root water potential
  real :: dpsi
  integer :: iter 

  C_r=2*PI/(log(R/r_r))
  n = -(1+3/b)
  K_root = 2*PI*r_r*K_r

  ! set up values bracketing the solution for psi_root, so that
  ! f(pl)<0 and f(ph)>0, where f = u_soil - u_root
  if(psi_soil>psi_x) then
     pl = psi_soil; ph = psi_x
  else
     ph = psi_soil; pl = psi_x
  endif
  ! choose initial values of f and df so that we always do bisection on the
  ! first iteration. 
  ! That means that our first approximation is (psi_soil+psi_x)/2 -- in future,
  ! modify to get something better
  f=1; df=0; psi_root=pl 

  do iter = 1, max_iter
     psi_root0=psi_root
     if (((psi_root-ph)*df-f)*((psi_root-pl)*df-f)>0) then
        ! Newton step would throws us out of range, do bisection
        psi_root = (pl+ph)/2
     else
        ! do Newton step
        psi_root = psi_root - f/df
     endif
     dpsi=psi_root-psi_root0

     ! calculate flux difference and its derivative
     u_soil = C_r*K_sat*&
          (psi_sat/n* &
          (  (min(psi_soil,psi_sat)/psi_sat)**n   &
            -(min(psi_root,psi_sat)/psi_sat)**n ) &
          + max(0.0, psi_soil - psi_sat)          &
          - max(0.0, psi_root - psi_sat)          )
     u_root = K_root*(psi_root-psi_x)
     
     f=u_soil-u_root
     df=-C_r*K_sat*(min(psi_root,psi_sat)/psi_sat)**(n-1)-K_root

     ! update brackets so that they still enclose the root
     if(f>0) then
        ph = psi_root
     else
        pl = psi_root
     endif

     if(abs(dpsi)<eps) exit
  enddo

  u = u_root; 
  ! calcilate derivalive of u w.r.t psi_x
  K_s = C_r*K_sat*(min(psi_root,psi_sat)/psi_sat)**(n-1)
  du = -K_root*K_s/(K_root+K_s)

end subroutine 


! ============================================================================
! given water potential of roots and soil, and array of vegetation factors in
! the uptake formula, calculate the total soil water uptake, its derivative
! w.r.t. root water potential, and optionally the vertical distribution of the
! uptake.
! NOTE that is we use one-way uptake option then U(psi_root) is continuous, but
! DUDpsi_root is not
subroutine darcy2d_uptake ( soil, psi_x0, VRL, K_r, r_r, uptake_oneway, &
     uptake_from_sat, uptake, duptake)
  type(soil_tile_type), intent(in) :: soil
  real, intent(in) :: &
       psi_x0, &   ! water potential inside roots (in xylem) at zero depth, m
       VRL(:), &   ! Volumetric Root Length (root length per unit volume), m/m3
       K_r,    &   ! permeability of the root skin per unit area, kg/(m3 s)
       r_r         ! radius of the roots, m
  logical, intent(in) :: &
       uptake_oneway, & ! if true, then the roots can only take up water, but 
                   ! never loose it to the soil
       uptake_from_sat   ! if false, uptake from saturated soil is prohibited
  real, intent(out) :: &
       uptake(:), & ! water uptake by roots
       duptake(:)   ! derivative of water uptake w.r.t. psi_root
  ! ---- local constants
  real, parameter :: eps = 1e-4 ! tolerance for psi
  ! ---- local vars
  integer :: l
  real :: psi_x     ! water potential inside roots (psi_x0+z), m
  real :: psi_soil  ! water potential of soil, m
  real :: psi_sat   ! saturation soil water potential, m
  real :: k_sat     ! hyraulic conductivity of saturated soil, kg/(m2 s)
  real :: R         ! characteristic half-distance between roots, m
  
  real :: u         ! water uptake by roots at the current layer, kg/(m2 s)
  real :: du        ! derivative of u w.r.t. root water potential
  real :: psi_r


  if(is_watch_point())then
     write(*,*)'##### darcy2d_uptake input #####'
     __DEBUG3__(psi_x0,psi_sat,K_sat)
     __DEBUG2__(K_r,r_r)
  endif
  ! calculate soil water supply and its derivative
  uptake = 0; duptake = 0
  do l = 1, num_l
     psi_sat = soil%pars%psi_sat_ref/soil%alpha(l)
     k_sat   = soil%pars%k_sat_ref*soil%alpha(l)**2
     psi_x    = psi_x0+zfull(l)
     psi_soil = soil%psi(l)
     if (VRL(l) > 0) then
        R     = 1.0/sqrt(PI*VRL(l)) ! characteristic half-distance between roots, m
     else
        R     = 1.0 ! the value doesn't matter since uptake is 0 anyway 
     endif

     if ( soil%prog(l)%ws > 0 ) &
          cycle ! skip layers with ice
     if ( uptake_oneway.and.psi_x > soil%psi(l) ) &
          cycle ! skip layers where roots would loose water
     if ( .not.(uptake_from_sat).and.psi_soil >= psi_sat ) &
          cycle ! skip layers where the soil is saturated

     ! calculates soil term of uptake expression
     call darcy2d_flow (psi_x, psi_soil, K_sat, psi_sat, soil%pars%chb, K_r, r_r, R, eps, u, du, psi_r)

     ! scale by volumetric root length and thickness of layer to get total uptake 
     ! from the current soil layer
     uptake(l)  = VRL(l)*dz(l)*u ; duptake(l) = VRL(l)*dz(l)*du
     if(is_watch_point()) then
        write(*,'(a,i2.2,100(2x,a,g23.16))')'level=',l, &
             'VRL=', VRL(l), 'R=', R,&
             'psi_x=', psi_x, 'psi_r=', psi_r, 'psi_soil=', psi_soil, &
             'U=',u,&
             'z=', zfull(l)
     endif
  enddo
end subroutine darcy2d_uptake


! =============================================================================
! for Darcy-flow uptake, find the root water potential such to satisfy actual 
! uptake by the vegetation. 
subroutine darcy2d_uptake_solver (soil, vegn_uptk, VRL, K_r, r_r, uptake_oneway, &
     uptake_from_sat, uptake, psi_x0, n_iter)
  type(soil_tile_type), intent(in) :: soil
  real, intent(in)  :: &
       vegn_uptk, & ! uptake requested by vegetation, kg/(m2 s)
       VRL(:),    & ! volumetric root length, m/m3
       K_r,       & ! root membrane permeability per unit area, kg/(m3 s)
       r_r          ! root radius, m
  logical, intent(in) :: &
       uptake_oneway, & ! if true, then the roots can only take up water, but 
                    ! never loose it to the soil
       uptake_from_sat ! if false, uptake from saturated soil is prohibited
  real,    intent(out) :: &
       uptake(:), & ! soil water uptake, by layer
       psi_x0       ! water potential inside roots (in xylem) at zero depth, m
  integer, intent(out) :: n_iter ! # of iterations made, for diagnostics only

  real :: uptake_tot

  call uptake_solver_K(soil, vegn_uptk, VRL, K_r, r_r, uptake_oneway, &
     uptake_from_sat, uptake, psi_x0, n_iter, darcy2d_uptake)

  ! since the numerical solution is not exact, adjust the vertical profile 
  ! of uptake to ensure that the sum is equal to transpiration exactly
  uptake_tot = sum(uptake(:))
  uptake(:) = uptake(:)+(vegn_uptk-uptake_tot)/sum(dz(:))*dz(:) 
  
end subroutine darcy2d_uptake_solver

! =============================================================================
! kernel of the uptake solver: given the input and a subroutine that calculates 
! the uptake vertical profile for given water potential at the surface, returns
! a soulution
subroutine uptake_solver_K (soil, vegn_uptk, VRL, K_r, r_r, uptake_oneway, &
     uptake_from_sat, uptake, psi_x0, n_iter, uptake_subr)
  type(soil_tile_type), intent(in) :: soil
  real, intent(in)  :: &
       vegn_uptk, & ! uptake requested by vegetation, kg/(m2 s)
       VRL(:),    & ! volumetric root length, m/m3
       K_r,       & ! root membrane permeability per unit area, kg/(m3 s)
       r_r          ! root radius, m
  logical, intent(in) :: &
       uptake_oneway, & ! if true, then the roots can only take up water, but 
                    ! never loose it to the soil
       uptake_from_sat ! if false, uptake from saturated soil is prohibited
  real,    intent(out) :: &
       uptake(:), & ! vertical distribution of soil uptake
       psi_x0       ! water potential inside roots (in xylem) at zero depth, m
  integer, intent(out) :: n_iter ! # of iterations made, for diagnostics only

  interface 
     subroutine uptake_subr ( soil, psi_x0, VRL, K_r, r_r, uptake_oneway, &
          uptake_from_sat, uptake, duptake)
     use soil_tile_mod, only : soil_tile_type
       type(soil_tile_type), intent(in) :: soil
       real, intent(in) :: &
            psi_x0, &   ! water potential inside roots (in xylem) at zero depth, m
            VRL(:), &   ! Volumetric Root Length (root length per unit volume), m/m3
            K_r,    &   ! permeability of the root skin per unit area, kg/(m3 s)
            r_r         ! radius of the roots, m
       logical, intent(in) :: &
            uptake_oneway, & ! if true, then the roots can only take up water, but 
            ! never loose it to the soil
            uptake_from_sat   ! if false, uptake from saturated soil is prohibited
       real, intent(out) :: &
            uptake(:), & ! water uptake by roots
            duptake(:)   ! derivative of water uptake w.r.t. psi_root
     end subroutine uptake_subr
  end interface

  ! ---- local constants
  ! parameters of uptake equation solver:
  integer, parameter :: max_iter = 50    ! max number of iterations
  real   , parameter :: eps      = 1e-10 ! end condition

  ! ---- local vars
  real :: xl,xh,x2,f,DfDx, incr
  real :: duptake(size(uptake))
  integer :: i

  n_iter = 0

  xl = psi_wilt
  xh = maxval(soil%psi(1:num_l)-zfull(1:num_l))

  ! find the lower upper boundary of the interval that contains solution
  incr = 100.0 ! inital psi increment for the lower bracket search
  do i = 1,20
     call uptake_subr ( soil, xl, VRL, K_r, r_r, uptake_oneway, uptake_from_sat, &
          uptake, duptake )
     if (sum(uptake)>=vegn_uptk) exit
     xl = xl-incr; incr=incr*2
  enddo
  if (sum(uptake) <= vegn_uptk) then
     ! Uptake is still smaller than vegn_uptake (that is,
     ! transpiration). We got as close to actual solution as possible.
     if (is_watch_point()) then
        write(*,*)'###### failed to reach lower bracket of uptake #####'
        __DEBUG2__(xl,uptake)
     endif
     return
  endif
  
  ! find upper boundary of the interval that contains solution
  incr = 1.0 ! inital psi increment for the upper bracket search
  do i = 1,20
     call uptake_subr ( soil, xh, VRL, K_r, r_r, uptake_oneway, &
          uptake_from_sat, uptake, duptake)
     if (sum(uptake)<=vegn_uptk) exit
     xh = xh+incr; incr = incr*2
  enddo
  if (sum(uptake)>= vegn_uptk) then
     ! Could not reach the psi_root high enough for uptake from soil to be 
     ! smaller than the transpiration: this can happen when transpiration is 
     ! negative (due to numerics) and uptake is one-way
     return
  endif

  ! the root is bracketed, find it
  x2 = (xl+xh)/2
  call uptake_subr ( soil, x2, VRL, K_r, r_r, uptake_oneway, &
       uptake_from_sat, uptake, duptake )
  f = sum(uptake) - vegn_uptk
  DfDx = sum(duptake)
  do n_iter = 1, max_iter
     ! check if we already reached the desired precision
     if(abs(f)<eps) then
         psi_x0 = x2
         exit
       endif
           
     if (is_watch_point()) then
        write(*,*)'##### solution iteration iter=',n_iter
        __DEBUG5__(f,DfDx,xl,xh,x2)
        __DEBUG2__((x2-xl)*DfDx,(x2-xh)*DfDx)
     endif
           
     if (((x2-xl)*DfDx-f)*((x2-xh)*DfDx-f)>0) then
        ! the Newton-Raphson step would throw us out of the bonds of the interval,
        ! so we do the bisection
        x2 = (xl+xh)/2
        if(is_watch_point()) write(*,*) 'did bisection'
     else
        x2 = x2-f/DfDx
        if(is_watch_point()) write(*,*) 'did Newton-Raphson step'
     endif
           
     call uptake_subr ( soil, x2, VRL, K_r, r_r, uptake_oneway, &
          uptake_from_sat, uptake, duptake)
     f = sum(uptake) - vegn_uptk
     DfDx = sum(duptake)
     
     if (f>0) then
        xl = x2
     else
        xh = x2
     endif
     
     if(is_watch_point()) then
        write(*,*)'#### After iteration',n_iter
        __DEBUG2__(vegn_uptk,sum(uptake))
     endif
  enddo

end subroutine uptake_solver_K

! ============================================================================
! given soil and root parameters, calculate the flux of water toward root
! per unit root length, and its derivative w.r.t. xylem water potential
! this version calculates fluxes linearized around psi_root0
subroutine darcy2d_flow_lin (psi_x, psi_soil, psi_root0, K_sat, psi_sat, b, K_r, &
     r_r, R, u, du, psi_root)
  real, intent(in) :: &
       psi_x,    & ! xylem water potential, m
       psi_soil, & ! soil water potential, m
       psi_root0,& ! value of psi_root we linearize around, m
       K_sat,    & ! saturated soil hydraulic conductivity, kg/(m2 s)
       psi_sat,  & ! saturates soil water potential, m
       b,        & ! power of soil moisture characteristic function
       K_r,      & ! root membrane permeability per unit area, kg/(m3 s)
       r_r,      & ! radius of root, m
       R           ! characteristic radial half-distance between roots, m
  real, intent(out) :: &
       u,        & ! uptake, kg/(m s)
       du,       & ! derivative of uptake w.r.t psi_x, kg/(m2 s)
       psi_root    ! water potential at the root/soil interface, m

  ! ---- local vars
  real :: u_soil0 ! flux through soil for psi_root = psi_root0
  real :: du_soil ! its derivative w.r.t. psi_root
  real :: C_r !
  real :: n
  real :: K_root  ! root membrane prmeability per unit length, kg/(m2 s)

  C_r=2*PI/(log(R/r_r))
  n = -(1+3/b)
  K_root = 2*PI*r_r*K_r

  ! calculate flux through soil for psi_root = psi_root0
  u_soil0 = C_r*K_sat*&
       (psi_sat/n* &
          (  (min(psi_soil ,psi_sat)/psi_sat)**n   &
            -(min(psi_root0,psi_sat)/psi_sat)**n ) &
          + max(0.0, psi_soil  - psi_sat)          &
          - max(0.0, psi_root0 - psi_sat)          )
  ! and its derivative w.r.t. psi_root at psi_root0
  du_soil=-C_r*K_sat*(min(psi_root0,psi_sat)/psi_sat)**(n-1)

  ! flux through soil+membrane
  u  = K_root/(-du_soil+K_root)*(u_soil0+du_soil*(psi_x-psi_root0))
  ! and its derivative w.r.t. psi_x
  du = K_root/(-du_soil+K_root)*du_soil
  ! water potential at the root-soil interface
  psi_root = psi_x + u/K_root
end subroutine 


! ============================================================================
subroutine darcy2d_uptake_lin ( soil, psi_x0, VRL, K_r, r_r,uptake_oneway, &
    uptake_from_sat, u, du )
  type(soil_tile_type), intent(in) :: soil
  real, intent(in) :: &
       psi_x0,    & ! water potential inside roots (in xylem) at zero depth, m
       VRL(:),    & ! Volumetric Root Length (root length per unit volume), m/m3
       K_r,       & ! permeability of the root membrane per unit area, kg/(m3 s)
       r_r          ! radius of fine roots, m
  logical, intent(in) :: &
       uptake_oneway, & ! if true, then the roots can only take up water, but 
                   ! never loose it to the soil
       uptake_from_sat   ! if false, uptake from saturated soil is prohibited
  real, intent(out) :: &
       u(:), &      ! layer-by-layer distribution of uptake, kg/(m2 s)
       du(:)        ! derivative of u w.r.t. root water potential, kg/(m3 s)
  ! ---- local vars
  integer :: k
  real :: psi_x     ! water potential inside roots (psi_x0+z), m
  real :: psi_soil  ! water potential of soil, m
  real :: psi_sat   ! saturation soil water potential, m
  real :: K_sat     ! hyraulic conductivity of saturated soil, kg/(m2 s)
  real :: R         ! characteristic half-distance between roots, m
  
  real :: psi_root  ! water potential at the root/soil interface, m
  real :: psi_root0 ! initial guess of psi_root, m


  u = 0; du = 0
  do k = 1, num_l
     psi_sat = soil%pars%psi_sat_ref/soil%alpha(k)
     K_sat   = soil%pars%k_sat_ref*soil%alpha(k)**2
     psi_x    = psi_x0 + zfull(k)
     psi_soil = soil%psi(k)
     psi_root0= soil%psi(k) ! change it later to prev. time step value
     if (VRL(k)>0) then
        R     = 1.0/sqrt(PI*VRL(k)) ! characteristic half-distance between roots, m
     else
        R     = 1.0 ! the value doesn't matter since uptake is 0 anyway (no roots) 
     endif
     if ( soil%prog(k)%ws > 0 ) &
          cycle ! skip layers with ice
     if ( uptake_oneway.and.psi_x > soil%psi(k) ) &
          cycle ! skip layers where roots would loose water
     if ( .not.(uptake_from_sat).and.psi_soil >= psi_sat ) &
          cycle ! skip layers where the soil is saturated

     ! calculates soil term of uptake expression
     call darcy2d_flow_lin (psi_x, psi_soil, psi_root0, K_sat, psi_sat, soil%pars%chb, &
          K_r, r_r, R, u(k), du(k), psi_root)

     ! scale by volumetric root length and thickness of layer to get total 
     ! uptake from the current soil layer
     u(k)  = VRL(k)*dz(k)*u(k)
     du(k) = VRL(k)*dz(k)*du(k)
  enddo

end subroutine

! ============================================================================
subroutine darcy2d_uptake_solver_lin ( soil, vegn_uptk, VRL, K_r, r_r, &
     uptake_oneway, uptake_from_sat, uptake, psi_x0, n_iter )
  type(soil_tile_type), intent(in) :: soil
  real, intent(in) :: &
       vegn_uptk, & ! uptake requested by vegetation, kg/(m2 s)
       VRL(:),    & ! Volumetric Root Length (root length per unit volume), m/m3
       K_r,       & ! permeability of the root membrane per unit area, kg/(m3 s)
       r_r          ! radius of fine roots, m
  logical, intent(in) :: &
       uptake_oneway, & ! if true, then the roots can only take up water, but 
                   ! never loose it to the soil
       uptake_from_sat   ! if false, uptake from saturated soil is prohibited
  real, intent(out) :: &
       uptake(:), & ! layer-by-layer distribution of uptake, kg/(m2 s)
       psi_x0       ! water potential inside roots (in xylem) at zero depth, m
  integer, intent(out) :: n_iter ! # of iterations made, for diagnostics only

  ! ---- local vars
  integer :: k
  real :: uptake_tot  ! total water uptake by roots, kg/(m2 s)
  real :: Duptake_tot ! derivative of water uptake w.r.t. psi_root, kg/(m3 s)
  real :: du(size(uptake)) ! derivative of u w.r.t. root water potential, kg/(m3 s)
  real :: d_psi_x     ! change of the xylem potential, m

  if (uptake_oneway) then
     call uptake_solver_K(soil, vegn_uptk, VRL, K_r, r_r, uptake_oneway, &
          uptake_from_sat, uptake, psi_x0, n_iter, darcy2d_uptake_lin )
     
     ! since the numerical solution is not exact, adjust the vertical profile 
     ! of uptake to ensure that the sum is equal to transpiration exactly
     uptake_tot = sum(uptake(:))
     uptake(1:num_l) = uptake(1:num_l)+(vegn_uptk-uptake_tot)/sum(dz(1:num_l))*dz(1:num_l) 
  else
     psi_x0 = 0.0
     call darcy2d_uptake_lin ( soil, psi_x0, VRL, K_r, r_r, uptake_oneway, &
          uptake_from_sat, uptake, du )
     uptake_tot = sum(uptake)
     Duptake_tot = sum(du) 
     
     if (duptake_tot/=0) then
        d_psi_x = (vegn_uptk - uptake_tot)/duptake_tot
        do k = 1,num_l
           uptake(k) = uptake(k) + d_psi_x*du(k)
        enddo
     else
        uptake(:) = 0
     endif
     psi_x0 = psi_x0 + d_psi_x
     n_iter = 0 ! because we didn't do any iterations
  endif

end subroutine


end module uptake_mod

module ocean_increment_tracer_mod
!
!<CONTACT EMAIL="russell.fiedler@csiro.au">  Russell Fiedler
!</CONTACT>
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov.au"> Paul Sandery
!</CONTACT>
!
!<OVERVIEW>
! Thickness weighted tracer tendency [tracer*meter/sec] from increments.
!</OVERVIEW>
!
!<DESCRIPTION>
!
! This increment module performs incremental update analysis (IUA), 
! an approach used in data assimilation and forecasting to reduce
! spurious perturbations when correcting the model state. 
! IUA involves restoring to analysis increments i.e. differences between model
! and analysis fields rather than actual fields (See Bloom et al., 1996). 
! The user can define the period that IUA is carried out
! and also the fraction of the increment to be restored over that period.
!
! This module applies a general 3D source to tracer. The sources
! can occur at any location and with any distribution in the domain
! An array of tracer tendencies due to the increments is augmented through a
! call to increment_tracer_source.  The array of tracer tendencies must be
! reset to zero between calls.
!
! The user is responsible for providing (and registering) the data on
! the model grid of values towards which the etas are being driven.
!</DESCRIPTION>
!
! <REFERENCE>
! S.C. Bloom, L.L. Takacs, A.M. da Silva, and D. Ledvina
! Data Assimilation Using Incremental Analysis Updates
! Monthly Weather Review  Volume 124, Issue 6 (June 1996)
! pages 1256--1271 
! </REFERENCE>
!
!<NAMELIST NAME="ocean_increment_tracer_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  For using this module.  Default use_this_module=.false.
!  </DATA>
!  <DATA NAME="fraction_increment" TYPE="real">
!  For prescribing the fraction of the increment.
!  applied to the restoring period.  Default fraction_increment=1.0
!  </DATA>
!  <DATA NAME="days_to_increment" TYPE="integer">
!  For specifying the amount of days to restore.
!  Default days_to_increment=1
!  </DATA>
!  <DATA NAME="secs_to_increment" TYPE="integer">
!  For specifying the amount of seconds to restore.
!  Default secs_to_increment=0
!  </DATA>
!</NAMELIST>
!
use diag_manager_mod,         only: register_diag_field
use fms_mod,                  only: write_version_number, open_namelist_file, close_file
use fms_mod,                  only: file_exist
use fms_mod,                  only: open_namelist_file, check_nml_error, close_file
use fms_mod,                  only: read_data, lowercase, FATAL, WARNING, stdout, stdlog
use mpp_mod,                  only: input_nml_file, mpp_sum, mpp_error
use time_interp_external_mod, only: init_external_field, time_interp_external
use time_manager_mod,         only: time_type, set_date, get_time
use time_manager_mod,         only: operator( + ), operator( - ), operator( // )
use time_manager_mod,         only: operator( > ), operator( == ), operator( <= )

use ocean_domains_mod,        only: get_local_indices
use ocean_parameters_mod,     only: missing_value 
use ocean_types_mod,          only: ocean_domain_type, ocean_grid_type, ocean_thickness_type
use ocean_types_mod,          only: ocean_prog_tracer_type, ocean_time_type 
use ocean_workspace_mod,      only: wrk1, wrk2
use ocean_util_mod,           only: diagnose_3d

implicit none

private

#include <ocean_memory.h>

type ocean_increment_type
   integer :: id                                             ! time_interp_external index
   character(len=32) :: name                                 ! tracer name corresponding to increment
   real, dimension(:,:,:), pointer :: damp_coeff   => NULL() ! 3d inverse forcing rate (tracer units/ sec)
end type ocean_increment_type


type(ocean_increment_type), allocatable, dimension(:) :: Increment
type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

public ocean_increment_tracer_init
public ocean_increment_tracer_source

character(len=126)  :: version = '$Id: ocean_increment_tracer.F90,v 20.0 2013/12/14 00:15:58 fms Exp $'
character (len=128) :: tagname = '$Name: tikal $'

! for diagnostics 
logical :: used
integer, dimension(:), allocatable :: id_increment_tend
integer :: num_prog_tracers      = 0
logical :: module_is_initialized = .false.
logical :: use_this_module       = .false. 
real    :: time_scale
real    :: fraction_increment    = 1.0
integer :: days_to_increment     = 1
integer :: secs_to_increment     = 0

namelist /ocean_increment_tracer_nml/ use_this_module, fraction_increment, &
                                      days_to_increment, secs_to_increment

! Time info
integer :: days_end_increment, secs_end_increment
integer :: days, secs

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_increment_tracer_init">
!
! <DESCRIPTION>
! This subroutine is intended to be used to initialize the increments.
! Everything in this subroutine is a user prototype, and should be replacable.
! </DESCRIPTION>
!
subroutine ocean_increment_tracer_init(Grid, Domain, Time, T_prog)

  type(ocean_grid_type),        intent(in), target :: Grid
  type(ocean_domain_type),      intent(in), target :: Domain
  type(ocean_time_type),        intent(in)         :: Time
  type(ocean_prog_tracer_type), intent(in)         :: T_prog(:)

  integer :: i, j, k, n
  integer :: index_temp
  integer :: ioun, io_status, ierr

  character(len=128) :: name

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_increment_mod (ocean_increment_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.

  num_prog_tracers = size(T_prog(:))
  do n=1,num_prog_tracers
     if (trim(T_prog(n)%name) == 'temp') index_temp = n
  enddo

  allocate( Increment(num_prog_tracers) )

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_increment_tracer_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_increment_tracer_nml')
#else
  ioun =  open_namelist_file()
  read (ioun,ocean_Increment_tracer_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_increment_tracer_nml')
  call close_file (ioun)
#endif
  write (stdlogunit,ocean_increment_tracer_nml)
  write (stdoutunit,'(/)') 
  write (stdoutunit,ocean_increment_tracer_nml)

  Dom => Domain
  Grd => Grid

#ifndef MOM_STATIC_ARRAYS    
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
#endif

  do n=1,num_prog_tracers
     Increment(n)%id = -1
  enddo


  if(.not. use_this_module) return 

   if ( days_to_increment  < 0  .or. secs_to_increment < 0 .or. &
    days_to_increment==0 .and. secs_to_increment == 0 ) then
   call mpp_error(FATAL,&
         '==>Error: invalid restoring period, ensure days_to_increment + secs_to_increment is greater than zero')
   endif

  time_scale=fraction_increment/(days_to_increment*86400.0 + secs_to_increment)

  call get_time(Time%model_time,secs,days)
  days_end_increment=days + days_to_increment
  secs_end_increment=secs + secs_to_increment

  do n=1,num_prog_tracers

     allocate(Increment(n)%damp_coeff(isd:ied,jsd:jed,nk))
     Increment(n)%damp_coeff(:,:,:) = 0.0  


     do k=1,nk
        do j=jsd,jed
           do i=isd,ied
              if(Grd%tmask(i,j,k) == 0.0) then
                  Increment(n)%damp_coeff(i,j,k) = 0.0
              else
                  Increment(n)%damp_coeff(i,j,k) = time_scale
              endif
           enddo
        enddo
     enddo

    ! read forcing rates (1/sec) 
     name = 'INPUT/'//trim(T_prog(n)%name)//'_increment.nc'
     if(file_exist(trim(name))) then
         Increment(n)%id = init_external_field(name,trim(T_prog(n)%name //''),domain=Domain%domain2d)
         if (Increment(n)%id < 1) then 
             call mpp_error(FATAL,&
             '==>Error: in ocean_increment_tracer_mod: forcing rates are specified but increment values are not')
         endif
         write(stdoutunit,*) '==> Using increment data specified from file '//trim(name) 
     else
         write(stdoutunit,*) '==> '//trim(name)//' not found.  Increment not being applied '
     endif

  enddo


  ! register diagnostic output
  allocate (id_increment_tend(num_prog_tracers))
  id_increment_tend = -1

  do n=1,num_prog_tracers
     if(n==index_temp) then
        id_increment_tend(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_increment_tend', &
                   Grd%tracer_axes(1:3), Time%model_time, 'rho*dzt*cp*heating due to increment', &
                   trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))
     else
        id_increment_tend(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_increment_tend', &
                   Grd%tracer_axes(1:3), Time%model_time, 'rho*dzt*tendency due to increment', &
                   trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))
     endif
  enddo


end subroutine ocean_increment_tracer_init
! </SUBROUTINE> NAME="ocean_increment_tracer_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_increment_tracer_source">
!
! <DESCRIPTION>
! This subroutine calculates thickness weighted and density weighted
! time tendencies of tracers due to damping by increments.
! </DESCRIPTION>
!
subroutine ocean_increment_tracer_source(Time, Thickness, T_prog)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)

  integer :: taum1, tau
  integer :: i, j, k, n

  if(.not. use_this_module) return 

  taum1 = Time%taum1
  tau   = Time%tau
  wrk1  = 0.0 
  wrk2  = 0.0


  ! halt forcing
  call get_time(Time%model_time,secs,days)
  if(days + secs/86400.0 .ge. days_end_increment + secs_end_increment/86400.0 ) then
    Increment(:)%id=0
  endif

 
  do n=1,size(T_prog(:))

     if (Increment(n)%id > 0) then

         ! get increment value for current time
         call time_interp_external(Increment(n)%id, Time%model_time, wrk1) 

         do k=1,nk
            do j=jsd,jed
               do i=isd,ied 
                  wrk2(i,j,k) = Thickness%rho_dzt(i,j,k,tau)*Increment(n)%damp_coeff(i,j,k) &
                 *wrk1(i,j,k)
                  T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) + wrk2(i,j,k)
               enddo
            enddo
         enddo

     endif

     
     if (id_increment_tend(n) > 0) call diagnose_3d(Time, Grd, id_increment_tend(n), &
         T_prog(n)%conversion*wrk2(:,:,:))

  enddo

  return

end subroutine ocean_increment_tracer_source
! </SUBROUTINE> NAME="ocean_increment_tracer_source"


end module ocean_increment_tracer_mod

                       module donner_deep_mod

use donner_types_mod,       only: donner_initialized_type, &
                                  donner_save_type, donner_rad_type, &
                                  donner_nml_type, donner_param_type, &
                                  donner_budgets_type, &
                                  donner_column_diag_type, &
                                  MAXMAG, MAXVAL, MINMAG, MINVAL, &
                                  DET_MASS_FLUX, MASS_FLUX,  &
                                  CELL_UPWARD_MASS_FLUX, TEMP_FORCING, &
                                  MOIST_FORCING, PRECIP,  FREEZING, &
                                  RADON_TEND, &
                                  donner_conv_type, donner_cape_type, &
                                  donner_cem_type
use  conv_utilities_k_mod,  only: sd_init_k, sd_end_k, ac_init_k,  &
                                  ac_end_k, uw_params_init_k, &
                                  exn_init_k, exn_end_k, findt_init_k, &
                                  findt_end_k, &
                                  adicloud, sounding, uw_params
use  conv_plumes_k_mod,     only: cp_init_k, cp_end_k, ct_init_k,  &
                                  ct_end_k, cplume, ctend
use fms_donner_mod,         only: fms_donner_process_nml,   &
                                  fms_donner_process_tracers, &
                                  fms_donner_activate_diagnostics, &
                                  fms_donner_col_diag, &
                                  fms_donner_column_control, &
                                  fms_donner_read_restart, &
                                  fms_donner_write_restart, &
                                  fms_donner_deep_netcdf, &
                                  fms_get_pe_number, &
                                  fms_sat_vapor_pres, &
                                  fms_error_mesg, fms_constants, &
                                  fms_close_col_diag_units, &
                                  fms_deallocate_variables, &
                                  fms_donner_process_monitors
use nonfms_donner_mod,      only: nonfms_donner_process_nml,   &
                                  nonfms_donner_process_tracers, &
                                  nonfms_donner_activate_diag, &
                                  nonfms_donner_col_diag, &
                                  nonfms_donner_column_control, &
                                  nonfms_donner_read_restart, &
                                  nonfms_donner_write_restart, &
                                  nonfms_donner_deep_netcdf, &
                                  nonfms_get_pe_number, &
                                  nonfms_sat_vapor_pres, &
                                  nonfms_error_mesg, nonfms_constants,&
                                  nonfms_deallocate_variables, &
                                  nonfms_donner_process_monitors, &
                                  nonfms_close_col_diag_units

implicit none
private

!--------------------------------------------------------------------
!        donner_deep_mod diagnoses the location and computes the 
!        effects of deep convection on the model atmosphere
!--------------------------------------------------------------------


!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------


character(len=128)  :: version =  '$Id: donner_deep.F90,v 20.0 2013/12/13 23:17:16 fms Exp $'
character(len=128)  :: tagname =  '$Name: tikal $'


!--------------------------------------------------------------------
!---interfaces------

public   &
        donner_deep_init, donner_deep, donner_deep_end,  &
        donner_deep_restart, donner_deep_time_vary, donner_deep_endts

private   & 
        deallocate_variables


!---------------------------------------------------------------------
!---namelist----



!--------------------------------------------------------------------
!--- public data ----------




!--------------------------------------------------------------------
!----private data-----------



!---------------------------------------------------------------------
!  parameters stored in the donner_param derived type variable to facili-
!  tate passage to kernel subroutines:
!

integer,                   &
  parameter                  &
             ::  KPAR=7         
                        ! number of members in cumulus ensemble
integer,                   &
  parameter                  &
             ::  NLEV_HIRES=100       
                        ! number of levels in cloud model
real,                       &
  parameter                 &
             ::  PDEEP_CV = 500.e02 
                        ! minimum pressure difference between level of 
                        ! free convection and level of zero buoyancy 
                        ! needed for deep convection to occur [ Pa ].
real,                       &
  parameter                 &
             ::  MAX_ENTRAINMENT_CONSTANT_GATE = 0.0915
                        ! entrainment constant based on gate data for 
                        ! most entraining ensemble member
real,                       &
  parameter                 &
             ::  MAX_ENTRAINMENT_CONSTANT_KEP  = 0.0915
                        ! entrainment constant based on kep data for most
                        ! entraining ensemble member
real,                       &
  parameter,                 &
  dimension(KPAR)              &
             ::  ENSEMBLE_ENTRAIN_FACTORS_KEP  = (/ 1.0, 1.22, 1.56,  &
                                                    2.05, 2.6, 3.21,   &
                                                    7.84 /)
                        ! ratio of entrainment constant between ensemble
                        ! member 1 and ensemble member i for kep-based
                        ! ensemble
real,                       &
  parameter                 &
             ::  CLD_BASE_VERT_VEL = 0.5                          
                        ! vertical velocity assumed present at cloud base
                        ! [ m / sec ]
real,                       &
  parameter                 &
             ::  PSTOP = 40.0e02   
                        ! lowest possible pressure to which a cloud may 
                        ! extend in the cloud model [ Pa ]
real,                       &
  parameter                 &
             ::  PARCEL_DP = -1.0e02
                        ! pressure increment used for parcel calculations
                        ! [ Pa ]
real,                       &
  parameter                 &
             ::  UPPER_LIMIT_FOR_LFC = 500.e02 
                        ! lowest pressure allowed for level of free conv-
                        ! ection [ Pa ]
real,                       &
  parameter                 &
             ::  DP_OF_CLOUD_MODEL = -10.e02
                        ! pressure thickness (Pa) of the layers in the
                        ! donner parameterization's cloud model.
real,                       &
  parameter                 &
             ::  CLOUD_BASE_RADIUS = 1000.
                        ! radius assumed for cloud ensemble member #1 at
                        ! cloud base [ m ]
real,                       &
  parameter                 &
             ::  WDET = .1   
                        ! vertical velocity at which detrainment from the
                        ! clouds begins [ m/s ]
real,                       &
  parameter                 &
             ::  RBOUND = 0.01    
                        ! value of cumulus radius at which cloud effect-
                        ! ively disappears and cloud model calculation 
                        ! stops [ m ]
real,                       &
  parameter                 &
             ::  WBOUND = 0.01  
                        ! value of cumulus vertical velocity at which 
                        ! cloud model calculation stops [ m / sec ]
real,                       &
  parameter                 &
             ::  FREEZE_FRACTION = 0.52
                        ! fraction of liquid in cloud updraft which may 
                        ! be frozen. (Leary and Houze (JAS,1980)) 
                        ! [ dimensionless ]
real,                       &
  parameter                 &
             ::  VIRT_MASS_CO = 0.5
                        ! virtual mass coefficient [ dimensionless ]
real,                       &
  parameter                 &
             ::  PDEEP_MC = 200.e02 
                        ! pressure thickness [ Pa ] required for meso-
                        ! scale circulation. It refers to the least
                        ! penetrative ensemble member. For this check 
                        ! to function properly, the entrainment coeffic-
                        ! ient in cloud_model for kou=1 must be the 
                        ! largest entrainment coefficient.
real,                       &
  parameter                 &
             ::  TR_INSERT_TIME = 0.0
                        ! fractional point (based on mass increase) 
                        ! during a timestep at which an entraining parcel
                        ! takes on internally-generated tracer 
                        ! [ dimensionless, value between 0.0 and 1.0 ]
real,                       &
  parameter                 &
             ::  AUTOCONV_RATE = 1.0e-03
                        ! rate of autoconversion of cloud to rainwater 
                        ! [ sec**(-1) ]
real,                       &
  parameter                 &
             ::  AUTOCONV_THRESHOLD =  0.5    
                        ! threshold of cloud water at which autoconver-
                        ! sion of cloud to rainwater begins  [ g / m**3 ]
real,                       &
  parameter                 &
             ::  TFRE = 258.  
                        ! temperature at which cloud liquid begins to 
                        ! freeze [ deg K ]
real,                       &
  parameter                 &
             ::  DFRE = 10.   
                        ! range of temperature between the onset and 
                        ! completion of freezing  [ deg K ]
real,                       &
  parameter                 &
             ::  UPPER_LIMIT_FOR_LCL = 500.0E02
                        ! lowest pressure allowable for lifting condens-
                        ! ation level; deep convection will not be pres-
                        ! ent if lcl not reached before this pressure 
                        ! [ Pa ]
integer,                   &
  parameter         &
             ::  ISTART = 1    
                        ! index of level in cape grid from which the 
                        ! parcel originates for the cape calculations
real,                       &
  parameter                 &
             ::  TMIN = 154.       
                        ! cape calculations are terminated when parcel 
                        ! temperature goes below TMIN [ deg K ]
real,                       &
  parameter                 &
             ::  MESO_LIFETIME = 64800.
                        ! assumed lifetime of mesoscale circulation 
                        ! (from Leary and Louze, 1980) [ sec ]
real,                       &
  parameter                 &
             ::  MESO_REF_OMEGA = -0.463
                        ! assumed reference omega for mesoscale updraft 
                        ! (from Leary and Louze, 1980) [ Pa / sec ]
real,                       &
  parameter                 &
             ::  TPRIME_MESO_UPDRFT = 1.0    
                        ! assumed temperature excess of mesoscale updraft
                        ! over its environment [ deg K ]
real,                       &
  parameter                 &
             ::  MESO_SEP = 200.0E+02
                        ! pressure separation between base of mesoscale
                        ! updraft and top of mesoscale downdraft [ Pa ]
real,                       &
  parameter                 &
             ::  REF_PRESS = 1.0E05
                        ! reference pressure used in calculation of exner
                        ! fumction [ Pa ]
real,                       &
  parameter                 &
             ::  R_CONV_LAND  = 10.0    
                        ! assumed convective cloud droplet radius over 
                        ! land [ microns ]   
real,                       &
  parameter                 &
             ::  R_CONV_OCEAN = 16.0  
                        ! assumed convective cloud droplet radius over 
                        ! ocean [ microns ]   
real,                       &
  parameter                 &
             ::  N_LAND = 600*1.0e6 
                        ! assumed droplet number conc over land (m**-3)
real,                       &
  parameter                 &
             ::  N_OCEAN = 150*1.0e6 
                        ! assumed droplet number conc over ocean (m**-3)
real,                       &
  parameter                 &
             ::  DELZ_LAND = 500.0   
                        ! assumed cloud depth over land (m) 
real,                       &
  parameter                 &
             ::  DELZ_OCEAN = 1500.0   
                        ! assumed cloud depth over ocean (m)
real,                       &
  parameter                 &
             ::  CELL_LIQUID_EFF_DIAM_DEF = 15.0    
                        ! default cell liquid eff diameter [ microns ]
real,                       &
  parameter                 &
             ::  CELL_ICE_GENEFF_DIAM_DEF = 18.6   
                        ! default cell ice generalized effective diameter
                        ! [ microns ]
integer,                   &
  parameter         &
             ::  ANVIL_LEVELS = 6  
                        ! number of levels assumed to be in anvil clouds
real,                       &
  parameter,                &
  dimension(ANVIL_LEVELS)   &
             ::  DGEICE  = (/ 38.5, 30.72, 28.28, 25.62, 24.8, 13.3 /)
                        ! generalized effective size of hexagonal ice 
                        ! crystals, defined as in Fu (1996, J. Clim.) 
                        ! values from Table 2 of McFarquhar et al. 
                        ! (1999, JGR) are averaged over all grid boxes 
                        ! for which D_ge is defined for all altitudes 
                        ! between 9.9 and 13.2 km. index 1 at bottom of 
                        ! anvil
real,                       &
  parameter,                &
  dimension(ANVIL_LEVELS)   &
             ::  RELHT  =  (/0.0, 0.3, 0.45, 0.64, 0.76, 1.0/)
                        ! distance from anvil base, normalized by total 
                        ! anvil thickness. from Table 2 of McFarquhar et
                        ! al. (1999, JGR) for grid boxes with data 
                        ! between 9.9 and 13.2 km. index 1 at anvil 
                        ! bottom

integer,                      &
  parameter                   &
             ::  N_WATER_BUDGET = 9
                        ! number of terms in vapor budget

integer,                      &
  parameter                   &
             ::  N_ENTHALPY_BUDGET =  19 
                        ! number of terms in enthalpy budget

integer,               &
  parameter            &
             ::  N_PRECIP_PATHS = 5
                        ! number of paths precip may take from 
                        ! condensing until it reaches the ground
                        ! (liquid; liquid which freezes; liquid which
                        ! freezes and then remelts; ice; ice which 
                        ! melts)

integer,               &
  parameter            &
             ::  N_PRECIP_TYPES = 3
                        ! number of precip types (cell, cell condensate
                        ! tranmsferred to mesoscale circulation,
                        ! mesoscale condensation and deposition)





!---------------------------------------------------------------------
!    derived type variables present for duration of job:
!    (see donner_types.h for documentation of their contents)
!

type(donner_param_type),       save :: Param
type(donner_column_diag_type), save :: Col_diag
type(donner_nml_type),         save :: Nml
type(donner_save_type),        save :: Don_save
type(donner_initialized_type), save :: Initialized
 
type(uw_params),               save :: Uw_p

logical                             :: calc_conv_on_this_step

!-----------------------------------------------------------------------
!   miscellaneous variables
!
!     module_is_initialized       module has been initialized ?
!

logical :: module_is_initialized = .false. 


logical :: running_in_fms = .true.

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------


                          contains



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                   PUBLIC SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!#####################################################################

subroutine donner_deep_init (lonb, latb, pref, axes, secs, days, &
                             tracers_in_donner, do_conservation_checks,&
                             using_unified_closure, using_fms_code)

!---------------------------------------------------------------------
!    donner_deep_init is the constructor for donner_deep_mod.
!---------------------------------------------------------------------

!--------------------------------------------------------------------
real,            dimension(:,:), intent(in)   :: lonb, latb
real,            dimension(:),   intent(in)   :: pref
integer,         dimension(4),   intent(in)   :: axes
integer,                         intent(in)   :: secs, days
logical,         dimension(:),   intent(in)   :: tracers_in_donner
logical,                         intent(in)   :: do_conservation_checks
logical,                         intent(in)   :: using_unified_closure
logical,                         intent(in), optional :: &
                                                 using_fms_code

!---------------------------------------------------------------------
!  intent(in) variables:
!
!      lonb         array of model longitudes on cell corners     
!                   [ radians ]
!      latb         array of model latitudes on cell corners   
!                   [ radians ]
!      pref         array of reference pressures at full levels (plus 
!                   surface value at nlev+1), based on 1013.25 hPa pstar
!                   [ Pa ]
!      axes         data axes for diagnostics
!      Time         current time [ time_type ]
!      tracers_in_donner 
!                   logical array indicating which of the activated 
!                   tracers are to be transported by donner_deep_mod
!
!-------------------------------------------------------------------

!-------------------------------------------------------------------
!  local variables:

      integer                             :: idf, jdf, nlev, ntracers
      character(len=200)                  :: ermesg
      integer                             :: erflag
      integer                             :: me, root_pe
  
!-------------------------------------------------------------------
!  local variables:
!
!     idf                    number of columns in the x dimension on the
!                            processors domain
!     jdf                    number of columns in the y dimension on the
!                            processors domain
!     nlev                   number of model layers 
!     ntracers               number of tracers to be transported by
!                            the donner deep convection parameterization
!                         
!-------------------------------------------------------------------

!-------------------------------------------------------------------
!    initialize error message and error flag.
!-------------------------------------------------------------------
      ermesg = '  '
      erflag = 0

!---------------------------------------------------------------------
!    define variable to indicated whether this module is being executed
!    within the FMS infrastructure. by default it is.
!---------------------------------------------------------------------
      if (present (using_fms_code)) then
        if ( .not. using_fms_code) then
          running_in_fms = .false.
        endif
      endif

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    1. READ NAMELIST AND WRITE IT TO LOG FILE.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

      if (running_in_fms) then
        call fms_donner_process_nml (Nml, kpar)
      else 

!---------------------------------------------------------------------
!    for the nonfms case, appropriate code to read the namelist should 
!    be included in nonfms_process_nml.  the current routine (without 
!    such code) modifies nml values with source assignment statements,
!    as needed.
!---------------------------------------------------------------------
        call nonfms_donner_process_nml (Nml, kpar)
      endif 

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    2. DO CONSISTENCY / VALIDITY TESTS ON NML AND PARAMETER VARIABLES.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

      if (Nml%do_donner_plume) then
        Nml%do_hires_cape_for_closure = .true.
      endif
 
      if (.not. Nml%do_donner_cape .and. &
           Nml%rmuz_for_cape /= 0.0) then
        erflag = 1
        ermesg =  'donner_deep_init: &
            &  a non-zero rmuz_for_cape is allowed only when &
            & do_donner_cape is true'
      endif

      if (Nml%do_donner_cape .and.     &
           .not. Nml%do_hires_cape_for_closure) then
        erflag = 1
        ermesg =  'donner_deep_init: &
            & do_hires_cape_for_closure must be .true. when &
            & do_donner_cape is true'
      endif

      if (.not. (Nml%do_donner_cape) .and.  &
           .not. (Nml%do_hires_cape_for_closure)) then

        if (Nml%rmuz_for_closure /= 0.0) then
          erflag = 1
          ermesg =  'donner_deep_init: &
          &  a non-zero rmuz_for_closure is currently implemented &
          & only for the hi-res cape closure calculation'
        endif
 
        if (trim(Nml%entrainment_scheme_for_closure) /= 'none') then
          erflag = 1
          ermesg =  'donner_deep_init: &
          &  entrainment in the closure calculation is currently &
           & implemented only for the hi-res cape closure calculation'
        endif
              
        if (Nml%modify_closure_plume_condensate ) then
          erflag = 1
          ermesg =  'donner_deep_init: &
          &  condensate modification in the closure calculation is &
          & currently implemented only for the hi-res cape closure &
          & calculation'
        endif
              
        if (Nml%closure_plume_condensate /= -999. ) then
          erflag = 1
          ermesg =  'donner_deep_init: &
          &  condensate modification in the closure calculation is &
          & currently implemented only for the hi-res cape closure &
          & calculation'
        endif
      endif
              
      if (Nml%do_donner_cape .and. Nml%gama /= 0.0) then
        erflag = 1
        ermesg =  'donner_deep_init: &
            & gama must be 0.0 if do_donner_cape is .true.; code for &
            & gama /=  0.0 not yet implemented'
      endif
      if (Nml%deep_closure /= 0 .and. Nml%deep_closure /= 1 ) then
        erflag = 1
        ermesg =  'donner_deep_init: &
              & deep_closure must be 0 or 1; code for &
              & cu_clo_miz not yet implemented'
      endif
      if (Nml%do_rh_trig .and. Nml%do_donner_closure) then
        erflag = 1
        ermesg =  'donner_deep_init: &
             & do_rh_trig must be .false. for donner full  &
               &parameterization; its use not yet implemented'
      endif

!---------------------------------------------------------------------
!    check for a valid value of donner_deep_freq. 
!---------------------------------------------------------------------
      if (Nml%donner_deep_freq > 86400) then
        erflag = 1
        ermesg = 'donner_deep_init: &
         & donner convection must be called at least once per day'
      else if (Nml%donner_deep_freq <= 0) then
        erflag = 1
        ermesg = 'donner_deep_init: &
          & a positive value must be assigned to donner_deep_freq'
      endif

!---------------------------------------------------------------------
!    check for valid value of entrainment_constant_source.
!---------------------------------------------------------------------
      if (trim(Nml%entrainment_constant_source) == 'gate' .or. &
          trim(Nml%entrainment_constant_source) == 'kep' ) then
      else
        erflag = 1
        ermesg = 'donner_deep_init: &
         & invalid string for nml variable entrainment_constant_source'
      endif

!---------------------------------------------------------------------
!    test that PSTOP is smaller than UPPER_LIMIT_FOR_LFC.
!---------------------------------------------------------------------
      if (pstop > upper_limit_for_lfc) then
        erflag = 1
        ermesg = 'donner_deep_init: &
           & pstop must be above the upper limit of &
                                &the level of free convection'
      endif

!---------------------------------------------------------------------
!    test that cell_liquid_size_type has been validly specified, and if
!    it is specified as 'input', an appropriate input value has been
!    supplied.
!---------------------------------------------------------------------
      if (trim(Nml%cell_liquid_size_type) == 'input') then
        Initialized%do_input_cell_liquid_size = .true.
        Initialized%do_bower_cell_liquid_size = .false.
        if (Nml%cell_liquid_eff_diam_input < 0.0) then
          erflag = 1
          ermesg = 'donner_deep_init: &
            & cell liquid size must be input, but no value supplied'
        endif
      else if (trim(Nml%cell_liquid_size_type) == 'bower') then
        Initialized%do_input_cell_liquid_size = .false.
        Initialized%do_bower_cell_liquid_size = .true.
      else
        erflag = 1
        ermesg = 'donner_deep_init: &
           & cell_liquid_size_type must be either input or bower'
      endif

!---------------------------------------------------------------------
!    test that cell_ice_size_type has been validly specified, and if
!    specified as 'input', that cell_ice_geneff_diam_input has also 
!    been appropriately defined.
!---------------------------------------------------------------------
      if (trim(Nml%cell_ice_size_type) == 'input') then
        Initialized%do_input_cell_ice_size = .true.
        Initialized%do_default_cell_ice_size = .false.
        if (Nml%cell_ice_geneff_diam_input <= 0.0) then
          erflag = 1
          ermesg  =  'donner_deep_init: must define a '// &
                     'nonnegative generalized effective'// &
                     'diameter for ice when cell_ice_size_type is input'
        endif
      else if (trim(Nml%cell_ice_size_type) == 'default') then
        Initialized%do_input_cell_ice_size = .false.
        Initialized%do_default_cell_ice_size = .true.
      else
        erflag = 1
        ermesg =  'donner_deep_init: cell_ice_size_type must ' //  &
                  'be input or default'
      endif

!---------------------------------------------------------------------
!    check for consistency between entrainment used in closure 
!    calculation. define logical indicating whether entrainment
!    coefficient is to be constant or ht-dependent.
!---------------------------------------------------------------------
      if (trim(Nml%entrainment_scheme_for_closure) == 'none' .and. &
                               Nml%rmuz_for_closure /= 0.0) then 
        erflag = 1
        ermesg = 'donner_deep_init: do not specify a non-zero ' // &
                  'rmuz_for_closure when no entrainment is desired'
      endif
      if (trim(Nml%entrainment_scheme_for_closure) ==    &
                                                 'ht-dependent' .and. &
                               Nml%rmuz_for_closure == 0.0) then 
        erflag = 1
        ermesg = 'donner_deep_init: must specify rmuz_for_closure ' // &
                  'when ht-dependent entrainment is desired'
      endif
      if (trim(Nml%entrainment_scheme_for_closure) ==    &
                                                 'ht-dependent' ) then
        Initialized%use_constant_rmuz_for_closure = .false.
      else
        Initialized%use_constant_rmuz_for_closure = .true.
      endif

!---------------------------------------------------------------------
!    check that if the closure plume condensate is to be modified that
!    a value is given.
!---------------------------------------------------------------------
      if (Nml%modify_closure_plume_condensate .and. &
          Nml%closure_plume_condensate == -999.) then
        erflag = 1
        ermesg = 'donner_deep_init: must specify ' // &
              'closure_plume_condensate when modification is requested'
      endif
        
!---------------------------------------------------------------------
!    if any errors were encountered, process them.
!---------------------------------------------------------------------
      if (erflag /= 0) then
        if (running_in_fms) then
          call fms_error_mesg (ermesg) 
        else

!---------------------------------------------------------------------
!    appropriate error processing code should be added in subroutine
!    nonfms_error_mesg. currently an error message is printed and a 
!    stop command issued (dangerous on parallel machines!).
!---------------------------------------------------------------------
          call nonfms_error_mesg (ermesg) 
        endif
      endif

!---------------------------------------------------------------------
!    place the logical input argument indicating whether the cloud 
!    base mass flux calculated by uw_conv_mod is also to be used 
!    in defining the closure for donner deep convection in the 
!    donner_initialized_type variable Initialized.
!    place the conservation check flag in the Initialized variable.
!---------------------------------------------------------------------
      Initialized%using_unified_closure = using_unified_closure
      Initialized%do_conservation_checks = do_conservation_checks

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    3. PROCESS TRACERS THAT ARE TO BE TRANSPORTED BY THE DONNER DEEP
!       CONVECTION PARAMETERIZATION.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!---------------------------------------------------------------------
!    determine how many tracers are to be transported by donner_deep 
!    convection. allocate arrays to contain their names and units for use
!    with diagnostics and restarts. define a logical variable indicating
!    if any tracers are to be so transported. obtain the tracer names and
!    units.
!---------------------------------------------------------------------
      ntracers = count(tracers_in_donner)
      allocate ( Don_save%tracername   (ntracers) )
      allocate ( Don_save%tracer_units (ntracers) )
      allocate ( Initialized%wetdep(ntracers) )
      if (ntracers > 0) then
        if (running_in_fms) then
          call fms_donner_process_tracers (Initialized,  &
                                           tracers_in_donner, Don_save)
        else 

!----------------------------------------------------------------------
!    currently tracers are not supported in the nonfms case. if it is
!    desired to transport tracers with donner convection, then the
!    subroutine nonfms_donner_process_tracers should be set up to mimic
!    the functionality of fms_donner_process_tracers for each tracer
!    thus transported (see subroutine fms_donner_process_tracers in 
!    fms_donner.F90).
!----------------------------------------------------------------------
          call nonfms_donner_process_tracers 
        endif 
      else
        Initialized%do_donner_tracer = .false.
      endif
      

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    4. DEFINE PROCESSOR DIMENSIONS AND ALLOCATE SPACE FOR MODULE 
!       VARIABLES.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!-------------------------------------------------------------------
!    define the grid dimensions. idf and jdf are the (i,j) dimensions of
!    the domain on this processor, nlev is the number of model layers.
!-------------------------------------------------------------------
      nlev = size(pref(:)) - 1
      idf  = size(lonb,1) - 1
      jdf  = size(latb,2) - 1

!--------------------------------------------------------------------
!    allocate module variables that will be saved across timesteps.
!    these are stored in the derived-type variable Don_save. see 
!    donner_types.h for description of these variables.
!--------------------------------------------------------------------
      allocate ( Don_save%cemetf             (idf, jdf, nlev ) )
      allocate ( Don_save%lag_temp           (idf, jdf, nlev ) )
      allocate ( Don_save%lag_vapor          (idf, jdf, nlev ) )
      allocate ( Don_save%lag_press          (idf, jdf, nlev ) )
      allocate ( Don_save%cememf             (idf, jdf, nlev ) )
      allocate ( Don_save%mass_flux          (idf, jdf, nlev ) )
      allocate ( Don_save%mflux_up           (idf, jdf, nlev ) )
      allocate ( Don_save%cell_up_mass_flux  (idf, jdf, nlev+1 ) )
      allocate ( Don_save%det_mass_flux      (idf, jdf, nlev ) )
      allocate ( Don_save%dql_strat          (idf, jdf, nlev ) )
      allocate ( Don_save%dqi_strat          (idf, jdf, nlev ) )
      allocate ( Don_save%dqa_strat          (idf, jdf, nlev ) )
      allocate ( Don_save%humidity_area      (idf, jdf, nlev ) )
      allocate ( Don_save%humidity_factor    (idf, jdf, nlev ) )
      allocate ( Don_save%tracer_tends       (idf, jdf, nlev, ntracers))
      allocate ( Don_save%parcel_disp        (idf, jdf ) )
      allocate ( Don_save%tprea1             (idf, jdf ) )

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    4. INITIALIZE THE NETCDF OUTPUT VARIABLES.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!--------------------------------------------------------------------
!    activate the netcdf diagnostic fields.
!-------------------------------------------------------------------
      if (running_in_fms) then
        call fms_donner_activate_diagnostics (secs, days, axes, &
                  Don_save, Nml, n_water_budget, n_enthalpy_budget, &
                  n_precip_paths, n_precip_types, nlev_hires, kpar)
      else

!---------------------------------------------------------------------
!    subroutine  nonfms_donner_activate_diagnostics should be set up
!    to initialize the procedure needed to output netcdf variable
!    fields in the nonFMS model. by default, it currently does nothing.
!---------------------------------------------------------------------
        call nonfms_donner_activate_diag (secs, days, axes, &
                  Don_save, Nml, n_water_budget, n_enthalpy_budget, &
                  n_precip_paths, n_precip_types, nlev_hires, kpar)
      endif

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    5. PROCESS THE RESTART FILE.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

      if (running_in_fms) then
        call fms_donner_read_restart (Initialized, ntracers,   &
                                      secs, days, Don_save, Nml)
      else

!---------------------------------------------------------------------
!    subroutine nonfms_donner_read_restart should be set up to handle 
!    the reading of the donner_deep.res.nc file in the nonFMS framework.
!    by default, it begins the model run from a coldstart.
!---------------------------------------------------------------------
        call nonfms_donner_read_restart (Initialized, ntracers,   &
                                      secs, days, Don_save, Nml)
      endif

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    6. INITIALIZE VARIABLES NEEDED FOR COLUMN_DIAGNOSTICS_MOD OUTPUT.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

      if (running_in_fms) then
        call fms_donner_col_diag     (lonb, latb, Col_diag, pref)    
      else

!---------------------------------------------------------------------
!    subroutine nonfms_donner_col_diag should be set up to process
!    the column diagnostic output available from donner_deep_mod in 
!    the nonFMS framework. by default, it currently sets variables to
!    disallow that option; if that option is desired, the functionality
!    of fms_donner_col_diag needs to be added to that subroutine.
!---------------------------------------------------------------------
        call nonfms_donner_col_diag     (lonb, latb, Col_diag, pref)   
      endif

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    7. FILL THE DONNER_PARAM_TYPE VARIABLE WITH VALUES THAT HAVE BEEN 
!       DEFINED HERE.                  
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!----------------------------------------------------------------------
!    define the components of Param that come from constants_mod. see 
!    donner_types.h for their definitions.
!----------------------------------------------------------------------
      if (running_in_fms) then
        call fms_constants (Param)
      else

!---------------------------------------------------------------------
!    subroutine nonfms_constants is designed to obtain model constants
!    and place them in the donner_param_type variable Param. currently
!    values are assigned to them in this subroutine; this process should
!    be modified so that these constants are obtained from their natural
!    location in the nonFMS model.
!---------------------------------------------------------------------
        call nonfms_constants (Param)
      endif


!----------------------------------------------------------------------
!    store the parameters defined in this module into the 
!    donner_parameter_type variables Param. these variables are defined
!    above.
!----------------------------------------------------------------------
      Param%cp_vapor                = 4.0*Param%rvgas
      Param%parcel_dp               = PARCEL_DP
      Param%upper_limit_for_lfc     = UPPER_LIMIT_FOR_LFC
      Param%pstop                   = PSTOP
      Param%cld_base_vert_vel       = CLD_BASE_VERT_VEL
      Param%dp_of_cloud_model       = DP_OF_CLOUD_MODEL
      Param%cloud_base_radius       = CLOUD_BASE_RADIUS
      Param%wdet                    = WDET
      Param%rbound                  = RBOUND
      Param%wbound                  = WBOUND
      Param%freeze_fraction         = FREEZE_FRACTION
      Param%virt_mass_co            = VIRT_MASS_CO
      Param%pdeep_mc                = PDEEP_MC
      Param%tr_insert_time          = TR_INSERT_TIME
      Param%autoconv_rate           = AUTOCONV_RATE
      Param%autoconv_threshold      = AUTOCONV_THRESHOLD
      Param%tfre                    = TFRE
      Param%dfre                    = DFRE
      Param%evap_in_downdrafts      = Nml%EVAP_IN_DOWNDRAFTS
      Param%evap_in_environ         = Nml%EVAP_IN_ENVIRON      
      Param%entrained_into_meso     = Nml%ENTRAINED_INTO_MESO
      Param%d622                    = Param%rdgas/Param%rvgas
      Param%d608                    = Param%rvgas/Param%rdgas - 1.0
      Param%upper_limit_for_lcl     = UPPER_LIMIT_FOR_LCL
      Param%tmin                    = TMIN
      Param%anvil_precip_efficiency = Nml%ANVIL_PRECIP_EFFICIENCY
      Param%meso_lifetime           = MESO_LIFETIME
      Param%meso_ref_omega          = MESO_REF_OMEGA
      Param%tprime_meso_updrft      = TPRIME_MESO_UPDRFT
      Param%meso_sep                = MESO_SEP
      Param%ref_press               = REF_PRESS
      Param%meso_down_evap_fraction = Nml%MESO_DOWN_EVAP_FRACTION
      Param%meso_up_evap_fraction   = Nml%MESO_UP_EVAP_FRACTION
      Param%istart                  = ISTART

      Param%max_entrainment_constant_gate =   &
                                           MAX_ENTRAINMENT_CONSTANT_GATE
      Param%max_entrainment_constant_kep  = MAX_ENTRAINMENT_CONSTANT_KEP
      Param%pdeep_cv                      = PDEEP_CV
      Param%cdeep_cv                      = Nml%CDEEP_CV
      Param%kpar                          = KPAR
      Param%r_conv_land                   = R_CONV_LAND
      Param%r_conv_ocean                  = R_CONV_OCEAN 
      Param%n_land                        = N_LAND
      Param%n_ocean                       = N_OCEAN
      Param%delz_land                     = DELZ_LAND
      Param%delz_ocean                    = DELZ_OCEAN
      Param%cell_liquid_eff_diam_def      = CELL_LIQUID_EFF_DIAM_DEF 
      Param%cell_ice_geneff_diam_def      = CELL_ICE_GENEFF_DIAM_DEF
      Param%anvil_levels                  = ANVIL_LEVELS 

      allocate (Param%arat(kpar))
      allocate (Param%ensemble_entrain_factors_gate(kpar))
      allocate (Param%ensemble_entrain_factors_kep(kpar))
      Param%arat                          = Nml%ARAT
      Param%ensemble_entrain_factors_gate =   &
                                       Nml%ensemble_entrain_factors_gate
      Param%ensemble_entrain_factors_kep  = ENSEMBLE_ENTRAIN_FACTORS_KEP

      allocate (Param%dgeice (ANVIL_LEVELS))
      allocate (Param%relht  (ANVIL_LEVELS))
      Param%dgeice  = DGEICE               
      Param%relht   = RELHT                

!---------------------------------------------------------------------
!    initialize the kernelized modules needed outside of the donner 
!    directory.
!---------------------------------------------------------------------
      if (running_in_fms) then
        call fms_sat_vapor_pres
      else

!--------------------------------------------------------------------
!    this routine is reserved for any initialization involved with the
!    saturation vapor pressure calculation in the nonFMS model. For
!    test purposes, this routine currently uses the FMS routines, but
!    this should be changed to use the nonFMS model's procedures.
!--------------------------------------------------------------------
        call nonfms_sat_vapor_pres
      endif

      if (running_in_fms) then
        call fms_get_pe_number(me, root_pe)
      else

!---------------------------------------------------------------------
!    subroutine nonfms_get_pe_number should be set up to return the
!    current pe's number, if column daignostics are activated in the
!    nonFMS model. By default, the subroutine returns 0 for all pes.
!---------------------------------------------------------------------
        call nonfms_get_pe_number(me, root_pe)
      endif

      call uw_params_init_k (Param%hlv, Param%hls, Param%hlf, &
          Param%cp_air, Param%grav, Param%kappa, Param%rdgas,  &
          Param%ref_press, Param%d622,Param%d608, Param%kelvin -160., & 
          Param%kelvin + 100. , me, root_pe, Uw_p)


      call exn_init_k (Uw_p)
      call findt_init_k (Uw_p)

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!
!    9. SET UP CODE TO MONITOR SELECTED OUTPUT VARIABLES.
!
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

      if (running_in_fms) then
        call fms_donner_process_monitors (idf, jdf, nlev, ntracers, &
                               axes, secs, days, Initialized, Don_save)
      else

!---------------------------------------------------------------------
!    subroutine nonfms_donner_process_monitors should be set up to 
!    handle the processing of variable monitopr output, if that capa-
!    bility is desired. Currently the subroutine does nothing; see 
!    subroutine fms_donner_process_monitors in fms_donner.F90 for the
!    functionality required to activate this option.
!---------------------------------------------------------------------
        call nonfms_donner_process_monitors 
      endif

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!   10. END OF SUBROUTINE.

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!--------------------------------------------------------------------
!    set flag to indicate that donner_deep_mod has been initialized.
!--------------------------------------------------------------------
      module_is_initialized = .true.

!------------------------------------------------------------------



end subroutine donner_deep_init

!###################################################################
         
subroutine donner_deep_time_vary (dt)  
                                  
real, intent(in) :: dt

!--------------------------------------------------------------------
!    decrement the time remaining before the convection calculations. 
!    save the current model physics timestep.
!--------------------------------------------------------------------
      Initialized%conv_alarm  = Initialized%conv_alarm - int(dt)
      Initialized%physics_dt = int(dt)
 
!--------------------------------------------------------------------
!    set a flag to indicate whether the convection calculation is to be 
!    done on this timestep. if this is the first call to donner_deep 
!    (i.e., coldstart), convection cannot be calculated because the
!    lag profiles needed to calculate cape are unavailable, and so
!    a time tendency of cape can not be obtained. otherwise, it is a
!    calculation step or not dependent on whether the convection "alarm"
!    has gone off. 
!---------------------------------------------------------------------
      if (Initialized%coldstart) then
        calc_conv_on_this_step = .false.
      else
        if (Initialized%conv_alarm <= 0) then
          calc_conv_on_this_step = .true.
        else
          calc_conv_on_this_step = .false.
        endif
      endif

!--------------------------------------------------------------------


end subroutine donner_deep_time_vary



!###################################################################
 
subroutine donner_deep_endts

!---------------------------------------------------------------------
!    if this was the first time through the parameterization, set
!    the flag so indicating (coldstart) to be .false.. if this was a 
!    calculation step, set the alarm to define the next time at which 
!    donner convection is to be executed.
!----------------------------------------------------------------------
      if (Initialized%coldstart) Initialized%coldstart = .false.
      if (calc_conv_on_this_step) then
        Initialized%conv_alarm = Initialized%conv_alarm +    &
                                                 Nml%donner_deep_freq
      endif

!--------------------------------------------------------------------


end subroutine donner_deep_endts




!###################################################################

subroutine donner_deep (is, ie, js, je, dt, temp, mixing_ratio, pfull, &
                        phalf, zfull, zhalf, omega, pblht, tkemiz, &
                        qstar, cush, coldT, land, sfc_sh_flux,  &
                        sfc_vapor_flux, tr_flux, tracers, secs, days, &
                        cbmf, cell_cld_frac,  &
                        cell_liq_amt, cell_liq_size, cell_ice_amt,   &
                        cell_ice_size, cell_droplet_number, &
                        meso_cld_frac, meso_liq_amt, &
                        meso_liq_size, meso_ice_amt, meso_ice_size,  &
                        meso_droplet_number, &
                        nsum, precip, delta_temp, delta_vapor, detf, &
                        uceml_inter, mtot, mfluxup, mhalf_3d, &
                        donner_humidity_area,    &
                        donner_humidity_factor, qtrtnd, donner_wetdep,&
                        lheat_precip, vert_motion,        &
                        total_precip, liquid_precip, frozen_precip, &
                        frz_meso, liq_meso, frz_cell, liq_cell, &
                        qlin, qiin, qain,              &      ! optional
                        delta_ql, delta_qi, delta_qa)         ! optional
                        
!-------------------------------------------------------------------
!    donner_deep is the prognostic driver subroutine of donner_deep_mod.
!    it takes as input the temperature (temp), vapor mixing ratio 
!    (mixing_ratio), pressure at full and half-levels (pfull, phalf),
!    vertical velocity at full levels (omega), the large scale cloud 
!    variables (qlin, qiin, qain), the land fraction (land),  the heat 
!    (sfc_sh_flux) , moisture (sfc_vapor_flux) and tracer (tr_flux) 
!    fluxes across the surface that are to be seen by this parameter-
!    ization, the tracers to be transported by the donner convection
!    parameterization (tracers), and the current time (as time_type 
!    variable Time). the routine returns the precipitation (precip),
!    increments to the temperature (delta_temp) and mixing ratio 
!    (delta_vapor), the detrained mass flux (detf), upward cell mass 
!    flux at interface levels  (uceml_inter) and total mass flux at full
!    levels (mtot), two arrays needed to connect the donner convection 
!    and strat cloud parameterizations (donner_humidity_area, 
!    donner_humidity_ratio), increments to the cloudwater (delta_ql), 
!    cloudice (delta_qi) and cloud area (delta_qa) fields and tendencies
!    for those tracers that are to be transported by the donner convect-
!    ion parameterization (qtrtnd). there are an additional eleven arrays
!    defining the donner scheme cloud characteristics needed by the rad-
!    iation package, which are passed in and updated on donner calcul-
!    ation steps.
!-------------------------------------------------------------------

!--------------------------------------------------------------------
integer,                      intent(in)    :: is, ie, js, je
real,                         intent(in)    :: dt
real, dimension(:,:,:),       intent(in)    :: temp, mixing_ratio, &
                                               pfull, phalf, zfull, zhalf, omega
real, dimension(:,:),         intent(in)    :: pblht, tkemiz, qstar,cush
real, dimension(:,:),         intent(in)    :: land
logical, dimension(:,:),      intent(in)    :: coldT
real, dimension(:,:),         intent(in)    :: sfc_sh_flux, &
                                               sfc_vapor_flux
real, dimension(:,:,:),       intent(in)    :: tr_flux 
real, dimension(:,:,:,:),     intent(in)    :: tracers 
integer,                      intent(in)    :: secs, days
real, dimension(:,:),         intent(inout) :: cbmf              
real, dimension(:,:,:),       intent(inout) :: cell_cld_frac,  &
                                               cell_liq_amt,  &
                                               cell_liq_size, &
                                               cell_ice_amt,  &
                                               cell_ice_size, &
                                           cell_droplet_number, &
                                               meso_cld_frac,  &
                                               meso_liq_amt, &
                                               meso_liq_size, &
                                               meso_ice_amt,   &
                                               meso_ice_size, &
                                           meso_droplet_number
integer, dimension(:,:),      intent(inout) :: nsum
real, dimension(:,:),         intent(out)   :: precip, &
                                               lheat_precip, &
                                               vert_motion, &
                                               total_precip
real, dimension(:,:,:),       intent(out)   :: delta_temp, delta_vapor,&
                                               detf, uceml_inter, &
                                               mtot, mfluxup, &
                                               mhalf_3d, &
                                               donner_humidity_area,&
                                               donner_humidity_factor, &
                                               liquid_precip, &
                                               frozen_precip, frz_meso,&
                                            liq_meso, frz_cell, liq_cell
real, dimension(:,:,:,:),     intent(out)   :: qtrtnd 
real, dimension(:,:,:),       intent(out)   :: donner_wetdep
real, dimension(:,:,:),       intent(in),                &
                                   optional :: qlin, qiin, qain
real, dimension(:,:,:),       intent(out),               &
                                   optional :: delta_ql, delta_qi, &
                                               delta_qa

!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   intent(in) variables:
!
!     is, ie         first and last values of i index values of points 
!                    in this physics window (processor coordinates)
!     js, je         first and last values of j index values of points 
!                    in this physics window (processor coordinates)
!     dt             physics time step [ sec ]
!     temp           temperature field at model levels [ deg K ]
!     mixing_ratio   vapor mixing ratio field at model levels 
!                    [ kg(h20) / kg(dry air) ]
!     pfull          pressure field on model full levels [ Pa ]
!     phalf          pressure field at half-levels 1:nlev+1  [ Pa ]
!     omega          model omega field at model full levels [ Pa / sec ]
!     qlin           large-scale cloud liquid specific humidity 
!                    [ kg(h2o) / kg (moist air) ]
!     qiin           large-scale cloud ice specific humidity 
!                    [ kg(h2o) / kg (moist air) ]
!     qain           large-scale cloud fraction  
!                    [ fraction ]
!     land           fraction of grid box covered by land
!                    [ fraction ]
!     sfc_sh_flux    sensible heat flux across the surface
!                    [ watts / m**2 ]
!     sfc_vapor_flux water vapor flux across the surface
!                    [ kg(h2o) / (m**2 sec) ]
!     tr_flux        surface flux of tracers transported by
!                    donner_deep_mod [ kg(tracer) / (m**2 sec) ]
!     tracers        tracer mixing ratios
!                    [ kg(tracer) / kg (dry air) ]
!     Time           current time (time_type)
!
!   intent(out) variables:
!
!     precip         precipitation generated by deep convection
!                    [ kg(h2o) / m**2 ]
!     delta_temp     temperature increment due to deep convection 
!                    [ deg K ]
!     delta_vapor    water vapor mixing ratio increment due to deep 
!                    convection [ kg(h2o) / kg (dry air) ]
!     detf           detrained cell mass flux at model levels 
!                    [ (kg / (m**2 sec) ) ]
!     uceml_inter    upward cell mass flux at interface levels 
!                    [ (kg / (m**2 sec) ) ]
!     mtot           mass flux at model full levels, convective plus 
!                    mesoscale, due to donner_deep_mod 
!                    [ (kg / (m**2 sec) ) ]
!     mfluxup        upward mass flux at model full levels, convective 
!                    plus mesoscale, due to donner_deep_mod 
!                    [ (kg / (m**2 sec) ) ]
!     donner_humidity_area
!                    fraction of grid box in which humidity is affected
!                    by the deep convection, defined as 0.0 below cloud
!                    base and above the mesoscale updraft, and as the
!                    sum of the cell and mesoscale cloud areas in 
!                    between. it is used in strat_cloud_mod to determine
!                    the large-scale specific humidity field for the
!                    grid box. DO NOT use for radiation calculation,
!                    since not all of this area includes condensate.
!                    [ fraction ]
!     donner_humidity_ratio
!                    ratio of large-scale specific humidity to specific 
!                    humidity in environment outside convective system
!                    [ dimensionless ]
!     delta_ql       cloud water specific humidity increment due to 
!                    deep convection over the timestep
!                    [ kg (h2o) / kg (moist air) ]
!     delta_qi       cloud ice specific humidity increment due to deep 
!                    convection over the timestep 
!                    [ kg (h2o) / kg (moist air) ]
!     delta_qa       cloud area increment due to deep convection
!                    over the time step [ fraction ]
!     qtrtnd         tracer time tendencies due to deep convection
!                    during the time step
!                    [ kg(tracer) / (kg (dry air) sec) ]
!
!   intent(inout) variables:
!
!     cell_cld_frac  fractional coverage of convective cells in
!                    grid box [ dimensionless ]
!     cell_liq_amt   liquid water content of convective cells
!                    [ kg(h2o) / kg(air) ]
!     cell_liq_size  assumed effective size of cell liquid drops
!                    [ microns ]
!     cell_ice_amt   ice water content of cells
!                    [ kg(h2o) / kg(air) ]
!     cell_ice_size  generalized effective diameter for ice in
!                    convective cells [ microns ]
!     meso_cld_frac  fractional area of mesoscale clouds in grid
!                    box [ dimensionless ]
!     meso_liq_amt   liquid water content in mesoscale clouds
!                    [ kg(h2o) / kg(air) ]
!     meso_liq_size  assumed effective size of mesoscale drops
!                    [ microns ]
!     meso_ice_amt   ice water content of mesoscale elements
!                    [ kg(h2o) / kg(air) ]
!     meso_ice_size  generalized ice effective size for anvil ice
!                    [ microns ]
!     nsum           number of time levels over which the above variables
!                    have so far been summed
!
!--------------------------------------------------------------------


!--------------------------------------------------------------------
!    local variables:

      real,    dimension (size(temp,1), size(temp,2), size(temp,3)) :: &
                       temperature_forcing, moisture_forcing, pmass, &
                       qlin_arg, qiin_arg, qain_arg, delta_ql_arg, & 
                       delta_qi_arg, delta_qa_arg

      real,    dimension (size(temp,1), size(temp,2)) :: parcel_rise, &
                                                         summa

      type(donner_conv_type)            :: Don_conv
      type(donner_budgets_type)         :: Don_budgets
      type(donner_cape_type)            :: Don_cape
      type(donner_rad_type)             :: Don_rad
      type(donner_cem_type)             :: Don_cem
      type(sounding)                    :: sd
      type(adicloud)                    :: ac
      type(cplume)                      :: cp
      type(ctend )                      :: ct
      character(len=128)                :: ermesg
      integer                           :: error
      integer                           :: isize, jsize, nlev_lsm
      integer                           :: ntr, me, root_pe
      logical                           :: cloud_tracers_present
      integer                           :: num_cld_tracers
      integer                           :: k, n   

!--------------------------------------------------------------------
!   local variables:
!
!     temperature_forcing  temperature tendency due to donner convection
!                          [ deg K / sec ]
!     moisture_forcing     vapor mixing ratio tendency due to donner 
!                          convection [ kg(h2o) / (kg(dry air) sec ) ]
!     pmass                mass per unit area within the grid box
!                          [ kg (air) / (m**2) ]
!     parcel_rise          accumulated vertical displacement of a 
!                          near-surface parcel as a result of the lowest
!                          model level omega field [ Pa ]
!     total_precip         total precipitation rate produced by the
!                          donner parameterization [ mm / day ]
!     exit_flag            logical array indicating whether deep conv-
!                          ection exists in a column
!     Don_conv             donner_convection_type derived type variable 
!                          containing diagnostics and intermediate
!                          results describing the nature of the convec-
!                          tion produced by the donner parameterization
!     Don_cape             donner_cape type derived type variable con-
!                          taining diagnostics and intermediate results
!                          related to the cape calculation associated 
!                          with the donner convection parameterization
!     Don_rad              donner_rad_type derived type variable used
!                          to hold those fields needed to connect the
!                          donner deep convection parameterization and
!                          the model radiation package
!     Don_cem              donner_cem_type derived type variable 
!                          containing Donner cumulus ensemble member 
!                          diagnostics
!     ermesg               character string containing any error message
!                          that is returned from a kernel subroutine
!     isize                x-direction size of the current physics window
!     isize, jsize         y-direction size of the current physics window
!     nlev_lsm             number of model layers in large-scale model
!     ntr                  number of tracers to be transported by donner
!                          convection 
!     me                   local pe number
!     calc_conv_on_this_step 
!                          is this a step on which to calculate 
!                          convection ?
!     k                    do-loop index
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!    check that the module has been initialized.
!---------------------------------------------------------------------
      if (.not. module_is_initialized) then
         ermesg = 'donner_deep: &
             &donner_deep_init was not called before subroutine   &
                                                  &donner_deep'
        if (running_in_fms) then
          call fms_error_mesg (ermesg) 
        else

!---------------------------------------------------------------------
!    appropriate error processing code should be added in subroutine
!    nonfms_error_mesg. currently an error message is printed and a 
!    stop command issued (dangerous on parallel machines!).
!---------------------------------------------------------------------
          call nonfms_error_mesg (ermesg) 
        endif
      endif

!----------------------------------------------------------------------
!    determine if the arguments needed when run with the strat_cloud_mod 
!    are present; set cloud_tracers_present appropriately.
!----------------------------------------------------------------------
      num_cld_tracers = count( (/present(qlin), present(qiin),   &
                                 present(qain), present(delta_ql), &
                                 present(delta_qi),present(delta_qa)/) )
      if (num_cld_tracers == 0) then
        cloud_tracers_present = .false.
        qlin_arg = 0.
        qiin_arg = 0.
        qain_arg = 0.
      else if (num_cld_tracers == 6) then
        cloud_tracers_present = .true.
        qlin_arg = qlin 
        qiin_arg = qiin
        qain_arg = qain
      else
        ermesg = 'donner_deep: &
                        &Either none or all of the cloud tracers '// &
                         'and their tendencies must be present'
        if (running_in_fms) then
          call fms_error_mesg (ermesg) 
        else

!---------------------------------------------------------------------
!    appropriate error processing code should be added in subroutine
!    nonfms_error_mesg. currently an error message is printed and a 
!    stop command issued (dangerous on parallel machines!).
!---------------------------------------------------------------------
          call nonfms_error_mesg (ermesg) 
        endif
      endif

!--------------------------------------------------------------------
!    if column diagnostics have been requested for any column, call 
!    donner_column_control to define the components of the 
!    donner_column_diag_type variable for the diagnostic columns in this 
!    window. if column diagnostics have not been requested, the needed
!    variables so indicating have already been set.
!--------------------------------------------------------------------
      if (running_in_fms) then
        if (Col_diag%num_diag_pts > 0) then
          call fms_donner_column_control (is, ie, js, je, secs, days, &
                                          Col_diag)
        endif
      else

!---------------------------------------------------------------------
!    if column diagnostics are desired in the nonFMS model, subroutine
!    nonfms_donner_column_control must be modified to provide the
!    functionality of fms_donner_column_control. by default, column
!    diagnostics are not available with the nonFMS model.
!---------------------------------------------------------------------
        if (Col_diag%num_diag_pts > 0) then
          call nonfms_donner_column_control (is, ie, js, je, secs,  &
                                             days, Col_diag)
        endif
      endif

!-------------------------------------------------------------------
!    define the dimensions for the variables in this physics window.
!    define the pe number of the current pe.
!-------------------------------------------------------------------
      isize     = ie - is + 1
      jsize     = je - js + 1
      nlev_lsm  = size(temp,3)
      ntr       = size(tracers,4) 

      if (running_in_fms) then
        call fms_get_pe_number(me, root_pe)
      else

!---------------------------------------------------------------------
!    subroutine nonfms_get_pe_number should be set up to return the
!    current pe's number, if column daignostics are activated in the
!    nonFMS model. By default, the subroutine returns 0 for all pes.
!---------------------------------------------------------------------
        call nonfms_get_pe_number(me, root_pe)
      endif

      Don_budgets%n_water_budget      = N_WATER_BUDGET
      Don_budgets%n_enthalpy_budget   = N_ENTHALPY_BUDGET
      Don_budgets%n_precip_paths      = N_PRECIP_PATHS     
      Don_budgets%n_precip_types      = N_PRECIP_TYPES     

!-----------------------------------------------------------------------
!    call the kernel subroutine don_d_donner_deep_k to obtain the
!    output fields resulting from the donner deep convection parameter-
!    ization.
!-----------------------------------------------------------------------
      call don_d_donner_deep_k   &
           (is, ie, js, je, isize, jsize, nlev_lsm, NLEV_HIRES, ntr, me,&
            cloud_tracers_present,  cbmf,    &
            dt, Param, Nml, temp, mixing_ratio, pfull,    &
            phalf, zfull, zhalf, omega, pblht, tkemiz, qstar, cush, coldT,&
            qlin_arg, qiin_arg, qain_arg, land, sfc_sh_flux,  &
            sfc_vapor_flux,    &
            tr_flux, tracers, cell_cld_frac, cell_liq_amt,      &
            cell_liq_size, cell_ice_amt, cell_ice_size,   &
            cell_droplet_number, meso_cld_frac,  &
            meso_liq_amt, meso_liq_size, meso_ice_amt, meso_ice_size,  &
            meso_droplet_number, &
            nsum, precip, delta_temp, delta_vapor, detf, uceml_inter,  &
            mtot, mfluxup, donner_humidity_area,  &
            donner_humidity_factor, &
            total_precip, temperature_forcing, moisture_forcing,    &
            parcel_rise, delta_ql_arg, delta_qi_arg, delta_qa_arg,   &
            qtrtnd,         &
            calc_conv_on_this_step, mhalf_3d, ermesg, error, Initialized, Col_diag,   &
            Don_rad, Don_conv, Don_cape, Don_cem, Don_save, &!miz
            sd, Uw_p, ac, cp, ct,  Don_budgets)

!----------------------------------------------------------------------
!    if strat_cloud is active, move the output arguments into the proper
!    locations.
!----------------------------------------------------------------------
      if (cloud_tracers_present) then
        delta_ql = delta_ql_arg
        delta_qi = delta_qi_arg
        delta_qa = delta_qa_arg
      endif

      if (Initialized%do_conservation_checks .or.   &
                                          Nml%do_budget_analysis) then
        lheat_precip = Don_budgets%lheat_precip
        vert_motion = Don_budgets%vert_motion
      else
        lheat_precip = 0.
        vert_motion = 0.
      endif
      liquid_precip = Don_budgets%liq_prcp
      frozen_precip = Don_budgets%frz_prcp

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, process the error message.
!!!  HOW TO DISTINGUISH FATAL, WARNING, NOTE ??
!    FOR NOW, ALL messages considered FATAL.
!----------------------------------------------------------------------
      if (error /= 0) then
        if (running_in_fms) then
          call fms_error_mesg (ermesg) 
        else

!---------------------------------------------------------------------
!    appropriate error processing code should be added in subroutine
!    nonfms_error_mesg. currently an error message is printed and a 
!    stop command issued (dangerous on parallel machines!).
!---------------------------------------------------------------------
          call nonfms_error_mesg (ermesg) 
        endif
      endif

!---------------------------------------------------------------------
!    if this is a calculation step for donner_deep, define a mass
!    weighting factor (mass per unit area) needed for some of the netcdf
!    diagnostics (pmass). call donner_deep_netcdf to send the requested 
!    diagnostic data to the diag_manager for output.
!---------------------------------------------------------------------
      if (calc_conv_on_this_step) then
        do k=1,nlev_lsm
          pmass(:,:,k) = (phalf(:,:,k+1) - phalf(:,:,k))/Param%GRAV   
        end do

!---------------------------------------------------------------------
!   define the column integrated tracer wet deposition associated with 
!   donner convection so that it may be returned to moist_processes.
!---------------------------------------------------------------------

        donner_wetdep = 0.
        do n=1, ntr
          summa = 0.
          do k=1,nlev_lsm
            summa(:,:) = summa(:,:) + &
                                 Don_conv%wetdept(:,:,k,n)*pmass(:,:,k)
          end do
          donner_wetdep(:,:,n) = summa(:,:)
        end do
        if (running_in_fms) then
          call fms_donner_deep_netcdf (is, ie, js, je, Nml, secs, days,&
                                 Param, Initialized, Don_conv,  &
                                 Don_cape, Don_cem,parcel_rise, pmass, &
                                 total_precip,  Don_budgets, &
                                 temperature_forcing, &
                                 moisture_forcing)
        else

!---------------------------------------------------------------------
!    subroutine nonfms_donner_deep_netcdf should be set up to output 
!    the netcdf diagnostic fields. By default, it does nothing.
!---------------------------------------------------------------------
          call nonfms_donner_deep_netcdf 
        endif

!----------------------------------------------------------------------
!    on calculation steps, update the values of the cell and
!    mesoscale cloud variables to be returned to moist_processes_mod. 
!    (on non-calculation steps, the values that were passed in are 
!    simply passed back.)
!----------------------------------------------------------------------
        cell_cld_frac = Don_rad%cell_cloud_frac
        cell_liq_amt  = Don_rad%cell_liquid_amt
        cell_liq_size = Don_rad%cell_liquid_size
        cell_ice_amt  = Don_rad%cell_ice_amt
        cell_ice_size = Don_rad%cell_ice_size
        cell_droplet_number = Don_rad%cell_droplet_number
        meso_cld_frac = Don_rad%meso_cloud_frac
        meso_liq_amt  = Don_rad%meso_liquid_amt
        meso_liq_size = Don_rad%meso_liquid_size
        meso_ice_amt  = Don_rad%meso_ice_amt
        meso_ice_size = Don_rad%meso_ice_size
        meso_droplet_number = Don_rad%meso_droplet_number
        nsum          = Don_rad%nsum

!--------------------------------------------------------------------
!    define the precip fields at each model level for liq and frozen 
!    precip associated with the cell and meso circulations.
!    UNITS KG / KG/ DAY 
!--------------------------------------------------------------------
        if (Initialized%do_conservation_checks .or.   &
                                          Nml%do_budget_analysis) then
          do k=1,nlev_lsm
            frz_meso(:,:,k) = (Don_budgets%precip_budget(:,:,k,2,2) + &
                   Don_budgets%precip_budget(:,:,k,2,3) + &
                   Don_budgets%precip_budget(:,:,k,4,2) + &
                   Don_budgets%precip_budget(:,:,k,4,3))*  &
                                                     Don_conv%a1(:,:)
            liq_meso(:,:,k) = (Don_budgets%precip_budget(:,:,k,1,2) + &
                   Don_budgets%precip_budget(:,:,k,1,3) + &
                   Don_budgets%precip_budget(:,:,k,3,2) + &
                   Don_budgets%precip_budget(:,:,k,3,3) + &
                   Don_budgets%precip_budget(:,:,k,5,2) + &
                   Don_budgets%precip_budget(:,:,k,5,3))*  &
                                                     Don_conv%a1(:,:)
            frz_cell(:,:,k) = (Don_budgets%precip_budget(:,:,k,2,1) + &
                   Don_budgets%precip_budget(:,:,k,4,1))*   &
                                                     Don_conv%a1(:,:)
            liq_cell(:,:,k) = (Don_budgets%precip_budget(:,:,k,1,1) + &
                   Don_budgets%precip_budget(:,:,k,3,1) + &
                   Don_budgets%precip_budget(:,:,k,5,1))*  &
                                                     Don_conv%a1(:,:)
          end do
        endif

!--------------------------------------------------------------------
!    call deallocate_local_variables to deallocate space used by the
!    local derived-type variables.
!--------------------------------------------------------------------
        call don_d_dealloc_loc_vars_k   &
               (Don_conv, Don_cape, Don_rad, Don_cem,Don_budgets, Nml, &
                          Initialized, sd, ac, cp, ct, ermesg, error)

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, process the error message.
!----------------------------------------------------------------------
        if (error /= 0) then
          if (running_in_fms) then
            call fms_error_mesg (ermesg) 
          else

!---------------------------------------------------------------------
!    appropriate error processing code should be added in subroutine
!    nonfms_error_mesg. currently an error message is printed and a 
!    stop command issued (dangerous on parallel machines!).
!---------------------------------------------------------------------
            call nonfms_error_mesg (ermesg) 
          endif
        endif
      endif  ! (calc_conv_on_this_step)

!--------------------------------------------------------------------


end subroutine donner_deep


!#######################################################################
! <SUBROUTINE NAME="donner_deep_restart">
!
! <DESCRIPTION>
! write out restart file.
! Arguments: 
!   timestamp (optional, intent(in)) : A character string that represents the model time, 
!                                      used for writing restart. timestamp will append to
!                                      the any restart file name as a prefix. 
! </DESCRIPTION>
!
subroutine donner_deep_restart(timestamp)
  character(len=*), intent(in), optional :: timestamp
  integer                                :: ntracers

  if (running_in_fms) then
     call fms_donner_write_restart (Initialized, timestamp)
  else 

     !---------------------------------------------------------------------
     !    subroutine nonfms_donner_write_restart should be configured to
     !    write a netcdf restart file in the nonFMS framework (see subroutine
     !    fms_donner_write_restart for the variables which must be included).
     !    by default, the subroutine does nothing.
     !---------------------------------------------------------------------
     if(present(timestamp)) then
        call nonfms_error_mesg('donner_deep_mod: when running_in_fms is false, '// &
             'timestamp should not passed in donner_deep_restart')
     endif
     ntracers = size(Don_save%tracername(:))
     call nonfms_donner_write_restart (ntracers, Don_save, &
          Initialized, Nml)
  endif

end subroutine donner_deep_restart
! </SUBROUTINE> NAME="donner_deep_restart"


!####################################################################

subroutine donner_deep_end

!---------------------------------------------------------------------
!   donner_deep_end is the destructor for donner_deep_mod.
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!  local variable

      integer  :: ntracers     ! number of tracers transported by the
                               ! donner deep convection parameterization

!-------------------------------------------------------------------
!    if module has not been initialized, return.
!-------------------------------------------------------------------
      if (.not. module_is_initialized) return

!-------------------------------------------------------------------
!    define the number of tracers that have been transported by the 
!    donner deep convection parameterization.
!-------------------------------------------------------------------
      ntracers = size(Don_save%tracername(:))

!-------------------------------------------------------------------
!    call subroutine to write restart file. NOTE: only the netcdf 
!    restart file is currently supported.
!-------------------------------------------------------------------
      if (running_in_fms) then
        call donner_deep_restart
      else 

!---------------------------------------------------------------------
!    subroutine nonfms_donner_write_restart should be configured to
!    write a netcdf restart file in the nonFMS framework (see subroutine
!    fms_donner_write_restart for the variables which must be included).
!    by default, the subroutine does nothing.
!---------------------------------------------------------------------
        call nonfms_donner_write_restart (ntracers, Don_save, &
                                       Initialized, Nml)
      endif 


!-------------------------------------------------------------------
!    close any column diagnostics units which are open.
!------------------------------------------------------------------
      if (Col_diag%num_diag_pts > 0) then
        if (running_in_fms) then
          call fms_close_col_diag_units 
        else

!--------------------------------------------------------------------
!    subroutine nonfms_close_column_diagnostics_units should be used
!    to close the outpuit units activated for column duiagnostics.
!    by default, column diagnostics are not available in the nonFMS
!    model, and this subroutine does nothing.
!--------------------------------------------------------------------
          call nonfms_close_col_diag_units 
        endif
      endif

!----------------------------------------------------------------------
!    call deallocate_variables to deallocate the module variables.
!----------------------------------------------------------------------
      call deallocate_variables 

      if (running_in_fms) then
        call fms_deallocate_variables (Col_diag)
      else

!---------------------------------------------------------------------
!    subroutine nonfms_deallocate_variables should be used to deallocate
!    local arrays associated with the column diagnostics option,
!    the variable monitoring option, and netcdf output. Currently the 
!    subroutine does nothing, since these features are not available 
!    in the nonFMS model.
!---------------------------------------------------------------------
        call nonfms_deallocate_variables
      endif

!---------------------------------------------------------------------
!    mark the module as uninitialized.
!---------------------------------------------------------------------
      module_is_initialized = .false.


!---------------------------------------------------------------------

end subroutine donner_deep_end



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!                   PRIVATE SUBROUTINES
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!      1. ROUTINES CALLED BY DONNER_DEEP_INIT
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!#####################################################################
 



!####################################################################


!#####################################################################








!#####################################################################


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!      2. ROUTINES CALLED BY DONNER_DEEP
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




!######################################################################



!######################################################################


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!      3. ROUTINES CALLED BY DONNER_DEEP_END
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





!######################################################################

subroutine deallocate_variables 

!---------------------------------------------------------------------
!    subroutine deallocate_variables deallocates the space used by the
!    module variables.
!---------------------------------------------------------------------
 
      deallocate ( Don_save%cemetf              )
      deallocate ( Don_save%lag_temp            )
      deallocate ( Don_save%lag_vapor           )
      deallocate ( Don_save%lag_press           )
      deallocate ( Don_save%cememf              )
      deallocate ( Don_save%mass_flux           )
      deallocate ( Don_save%mflux_up            )
      deallocate ( Don_save%cell_up_mass_flux   )
      deallocate ( Don_save%det_mass_flux       )
      deallocate ( Don_save%dql_strat           )
      deallocate ( Don_save%dqi_strat           )
      deallocate ( Don_save%dqa_strat           )
      deallocate ( Don_save%humidity_area       )
      deallocate ( Don_save%humidity_factor     )
      deallocate ( Don_save%tracer_tends        )
      deallocate ( Don_save%parcel_disp         )
      deallocate ( Don_save%tprea1              )
      deallocate ( Don_save%tracername          )
      deallocate ( Don_save%tracer_units        )

      deallocate (Param%arat)
      deallocate (Param%ensemble_entrain_factors_gate)
      deallocate (Param%ensemble_entrain_factors_kep )
      deallocate (Param%dgeice)
      deallocate (Param%relht )

      call exn_end_k
      call findt_end_k


!----------------------------------------------------------------------


end subroutine deallocate_variables 




!######################################################################



                     end module donner_deep_mod

module update_fv_phys_mod
  public :: update_fv_phys
contains
  subroutine update_fv_phys ( dt, nq, full_phys, nudge, Time )

    use fv_pack, only: nlon, mlat, beglon, endlon, beglat, endlat, &
         age_tracer,  age_time, do_ch4_chem,   &
         u_ghosted, ng_d, ng_s, ak, bk,        &
         use_tendency, get_eta_level, pft_phys, polavg
#ifdef USE_LIMA
    use fv_pack, only : sc
#endif

    use pft_module, only: pft2d_phys
    use constants_mod,      only: kappa
    use field_manager_mod,  only: MODEL_ATMOS
    use tracer_manager_mod, only: get_tracer_index
    use atmos_nudge_mod,    only: get_atmos_nudge, do_ps
    use time_manager_mod,   only: time_type

#ifdef SPMD
    use mod_comm,     only: gid, mp_send3d, mp_recv3d
#endif
    use mpp_mod, only: mpp_sync
    use fv_arrays_mod, only: fv_stack_push, fv_array_sync, fv_print_chksums

! implicit none
#include "fv_arrays.h"

    integer, intent(in):: nq         ! tracers modified by physics 
    logical, intent(in):: full_phys   ! full physics
    logical, intent(in):: nudge
    type (time_type), intent(in) :: Time


    real, intent(in)   :: dt

! Local arrays:
    real du_s(nlon,nlev)
! real  pk2(nlon,nlev+1)
    real  pk2(nlon,nlev+1) !private, only used in j-parallel loop
    real  dt5
    integer i, j, k, m
    integer cld_amt

!***********
! Haloe Data for CH4
!***********

    real, parameter::    q1_h2o = 2.2E-6
    real, parameter::    q7_h2o = 3.8E-6
    real, parameter::  q100_h2o = 3.8E-6
    real, parameter:: q1000_h2o = 3.1E-6
    real, parameter:: q2000_h2o = 2.8E-6
    real, parameter::   tau_h2o = 120.*86400.

    integer js2g0, jn2g0

    real  phalf(nlev+1), pfull(nlev)
    real  qstar
    real  rdt
    real  dbk
! real, allocatable, dimension(:,:) :: ps_dt
    real :: ps_dt(nlon, beglat:endlat)
#ifdef use_shared_pointers
    pointer( ptr_du_s, du_s )
    pointer( ptr_ps_dt, ps_dt )

#include "fv_point.inc"
    call fv_stack_push( ptr_du_s, nlon*nlev )
    call fv_stack_push( ptr_ps_dt, nlon*(endlat-beglat+1) )
#endif

    call fv_print_chksums( 'Entering  update_fv_phys' )
    dt5 = 0.5 * dt
    rdt = 1./ dt

    if ( use_tendency ) then
!----------------------------------------
! Compute wind tendencies due to physics:
!----------------------------------------
!$omp parallel do private (i,j,k)
        do k=ksp,kep !1,nlev
           do j=beglat,endlat
              do i=1,nlon !beglon,endlon
                 u_dt(i,j,k) = u_dt(i,j,k) - (ua(i,j,k)-u_phys(i,j,k))*rdt
                 v_dt(i,j,k) = v_dt(i,j,k) - (va(i,j,k)-v_phys(i,j,k))*rdt
              enddo
           enddo
        enddo
    endif

    if ( pft_phys .and. full_phys ) then

        js2g0 = max(2,beglat)
        jn2g0 = min(mlat-1,endlat)

! 3-point physics tendency filter: u_dt, v_dt, t_dt
!!!!!!!!!!!!!!!!!!!!!!!!!!
! Need some mods for 2D to work
!!!!!!!!!!!!!!!!!!!!!!!!!!
!$omp parallel do private (k)
        do k=ksp,kep !1,nlev
#if ( !defined USE_LIMA)
           call pft2d_phys(u_dt(1,js2g0,k),  nlon, jn2g0-js2g0+1)
           call pft2d_phys(v_dt(1,js2g0,k),  nlon, jn2g0-js2g0+1)
           call pft2d_phys(t_dt(1,js2g0,k),  nlon, jn2g0-js2g0+1)
#else               
           call pft2d_phys(u_dt(1,js2g0,k),  sc(js2g0), nlon, jn2g0-js2g0+1)
           call pft2d_phys(v_dt(1,js2g0,k),  sc(js2g0), nlon, jn2g0-js2g0+1)
           call pft2d_phys(t_dt(1,js2g0,k),  sc(js2g0), nlon, jn2g0-js2g0+1)
#endif
        enddo

    endif

#if ( !defined MARS_GCM )
    cld_amt = get_tracer_index (MODEL_ATMOS, 'cld_amt')

    call get_eta_level(nlev, 1.0E5, pfull, phalf)
#endif


!$omp parallel do private (i,j,k,m, qstar)
    do k=ksp, kep !1,nlev

#if ( !defined MARS_GCM)
! Do idealized Ch4 chemistry
       if ( do_ch4_chem .and. pfull(k) < 20.E2 ) then

           if ( pfull(k) < 1. ) then
               qstar = q1_h2o
           elseif ( pfull(k) <   7. .and. pfull(k) >=    1. ) then
               qstar = q1_h2o + (q7_h2o-q1_h2o)*log(pfull(k)/1.)/log(7.)
           elseif ( pfull(k) <  100. .and. pfull(k) >=    7. ) then
               qstar = q7_h2o + (q100_h2o-q7_h2o)*log(pfull(k)/7.)/log(100./7.)
           elseif ( pfull(k) < 1000. .and. pfull(k) >=  100. ) then
               qstar = q100_h2o + (q1000_h2o-q100_h2o)*log(pfull(k)/1.E2)/log(10.)
           elseif ( pfull(k) < 2000. .and. pfull(k) >= 1000. ) then
               qstar = q1000_h2o + (q2000_h2o-q1000_h2o)*log(pfull(k)/1.E3)/log(2.)
           endif

           do j=beglat,endlat
              do i=1,nlon !beglon,endlon
                 q_dt(i,j,k,1) = q_dt(i,j,k,1) + (qstar-q(i,j,k,1))/(tau_h2o+dt)
              enddo
           enddo

       endif
#endif 

! Average tendencies for scalars at poles (make it single-valued)
! This is necessary because the the physics/land/ocean use different grid
! than the dynamics at the poles (which has polar caps)
!----------------------------------------
! Needs some mods for phys 2D decomp
!----------------------------------------
       call polavg(t_dt(1,beglat,k), nlon, mlat, beglat, endlat)

#ifdef MARS_GCM
!!!!       call polavg( delp_dt(1,beglat,k), nlon, mlat, beglat, endlat)
!!!!       This is carried out in fv_phys.F90
#endif MARS_GCM

       if ( use_tendency ) then
           do j=beglat,endlat
              do i=1,nlon !beglon,endlon
                 ua(i,j,k) = ua(i,j,k) + dt*u_dt(i,j,k)
                 va(i,j,k) = va(i,j,k) + dt*v_dt(i,j,k)
                 pt(i,j,k) = t_phys(i,j,k) + dt*t_dt(i,j,k)
              enddo
           enddo
           do m=1,nq
              do j=beglat,endlat
                 do i=1,nlon !beglon,endlon
                    q_dt(i,j,k,m) = q_dt(i,j,k,m) - (q(i,j,k,m)-q_phys(i,j,k,m))*rdt
                 enddo
              enddo
           enddo
       else
           do j=beglat,endlat
              do i=1,nlon !beglon,endlon
                 ua(i,j,k) = ua(i,j,k) + dt*u_dt(i,j,k)
                 va(i,j,k) = va(i,j,k) + dt*v_dt(i,j,k)
                 pt(i,j,k) = pt(i,j,k) + dt*t_dt(i,j,k)
              enddo
           enddo
       endif


!----------------
! Update tracers:
!----------------
       do m=1,nq
!----------------------------------------
! Needs some mods for phys 2D decomp
!----------------------------------------
          call polavg(q_dt(1,beglat,k,m), nlon, mlat, beglat, endlat)
          do j=beglat,endlat
             do i=1,nlon !beglon,endlon
                q(i,j,k,m) = q(i,j,k,m) + dt*q_dt(i,j,k,m)
             enddo
          enddo
       enddo


       if ( full_phys ) then

#ifdef MARS_GCM
!   The adjustment of tracer mixing rations to reflect the 
!    change in atmospheric mass is carried out in fv_phys.F90 

#else
           do j=beglat,endlat
              do i=1,nlon !beglon,endlon
!----------------------------------------------------
! Adjust total air mass due to changes in water vaper
! (cloud liquid/ice effects ignored)
!----------------------------------------------------
                 t_dt(i,j,k) = 1. + dt*q_dt(i,j,k,1)
                 delp(i,j,k) = delp(i,j,k) * t_dt(i,j,k)
              enddo
           enddo

           do m=1,ncnst
!      if( m /= cld_amt ) then  ! cloud fraction in GFDL physics
!-----------------------------------------
! Adjust mass mixing ratio of all tracers 
!-----------------------------------------
              do j=beglat,endlat
                 do i=1,nlon !beglon,endlon
                    q(i,j,k,m) = q(i,j,k,m) / t_dt(i,j,k)
                 enddo
              enddo
!      endif
           enddo
#endif 
       endif

    enddo         ! -----------------------k-loop------------------
    call fv_array_sync()

! [delp, (ua, va), pt, q] updated. Perform nudging if requested

!------- nudging of atmospheric variables toward specified data --------
    if (nudge) then
!      allocate ( ps_dt(beglon:endlon, beglat:endlat) )
        ps_dt(:,:) = 0.
!Balaji: get_atmos_nudge is parallelized over i (beglon:endlon of shared arrays)
!--------------------------------------------
! All fields will be updated; tendencies added
!--------------------------------------------
        call get_atmos_nudge ( Time, dt, beglon, endlon, beglat, endlat,    &
             nlev, ng_d, ps(beglon:endlon,:), ua(beglon:endlon,:,:), &
             va(beglon:endlon,:,:), pt(beglon:endlon,:,:), &
             q(beglon:endlon,:,:,:), ps_dt(beglon:endlon,:), u_dt(beglon:endlon,:,:),  & 
             v_dt(beglon:endlon,:,:), t_dt(beglon:endlon,:,:), &
             q_dt(beglon:endlon,:,:,:) )
        call fv_array_sync()
        if (do_ps) then
!$omp parallel do private (i,j,k, dbk)
            do k=ksp,kep !1,nlev
!--------------
! Update delp
!--------------
               dbk = dt * (bk(k+1) - bk(k))
               do j=beglat,endlat
                  do i=1,nlon !beglon,endlon
                     delp(i,j,k) = delp(i,j,k) + dbk*ps_dt(i,j)
                  enddo
               enddo
            enddo
        endif
!    deallocate ( ps_dt )
    endif
!-----------------------------------------------------------------------
    call fv_array_sync()
#ifdef SPMD
    call mp_send3d(gid+1, gid-1, nlon, mlat, nlev, 1, nlon,  beglat, endlat, &
         1, nlev, 1, nlon, endlat, endlat, 1, nlev, u_dt)
#endif

!$omp parallel do private (i,j,k)
    do k=ksp,kep !1,nlev
!--------------
! Update u-wind
!--------------
       do j=beglat+1,endlat
          do i=1,nlon !beglon,endlon
             u(i,j,k) = u(i,j,k) + dt5*(u_dt(i,j-1,k)+u_dt(i,j,k))
          enddo
       enddo

!---------
! Update v
!---------
       do j=max(2,beglat), min(mlat-1,endlat)
!----------------------------------------
! Needs some mods for phys 2D decomp
!----------------------------------------
          v(1,j,k) = v(1,j,k) + dt5*(v_dt(nlon,j,k)+v_dt(1,j,k))
          do i=2,nlon
             v(i,j,k) = v(i,j,k) + dt5*(v_dt(i-1,j,k)+v_dt(i,j,k))
          enddo
       enddo
    enddo         ! k-loop
    call fv_array_sync()
    if ( full_phys ) then
!----------------------------------------
! Update pe, peln, pkz, and surface winds
!----------------------------------------
!$omp parallel do private(i, j, k, pk2)
        do j=jsp,jep !beglat,endlat

           do i=1,nlon !beglon,endlon
              u_srf(i,j) = ua(i,j,nlev)
              v_srf(i,j) = va(i,j,nlev)
              pk2(i,1) = pk(i,j,1)
           enddo

           do k=2,nlev+1                                                                             
              do i=1,nlon !beglon,endlon
                 pe(i,k,j) = pe(i,k-1,j) + delp(i,j,k-1)
                 pk2(i,k)  = pe(i,k,j) ** kappa
                 peln(i,k,j) = log(pe(i,k,j))
              enddo
           enddo

           do i=1,nlon
              ps(i,j) = pe(i,nlev+1,j)
           enddo

           do k=1,nlev                                                                             
              do i=1,nlon !beglon,endlon
                 pkz(i,j,k) = (pk2(i,k+1) - pk2(i,k) )  /  &
                      (kappa*(peln(i,k+1,j) - peln(i,k,j)) )
              enddo
           enddo
        enddo      ! j-loop
        call fv_array_sync()
    endif

#ifdef SPMD 
    call mp_recv3d(gid-1, nlon, mlat, nlev, 1, nlon, beglat-1, beglat-1, 1, &
         nlev, 1, nlon, beglat-1, beglat-1, 1, nlev, du_s)
    call fv_array_sync()
!----------------
! Finish u update
!----------------
!Balaji: needs work!
    if ( beglat > 1 ) then 
!$omp parallel do private(i,k)
        do k=ksp,kep !1,nlev
           do i=1,nlon !beglon,endlon
              u(i,beglat,k) = u(i,beglat,k) + dt5*(u_dt(i,beglat,k)+du_s(i,k))
           enddo
        enddo
    endif
    call fv_array_sync()
    u_ghosted = .false.
#endif  SPMD 
    call fv_print_chksums( 'Exiting update_fv_phys' )
  end subroutine update_fv_phys

end module update_fv_phys_mod

module ocean_lapcst_friction_mod
#define COMP isc:iec,jsc:jec
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</REVIEWER>
!
!<OVERVIEW>
! This module computes the thickness weighted and density weighted
! acceleration for horizontal velocity arising from horizontal 
! Laplacian friction. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes the thickness weighted and density weighted
! time tendency for horizontal velocity arising from horizontal
! Laplacian friction. 
!
! The viscosity used to determine the strength of the tendency 
! can be a general function of space yet it is constant in time.  
! A namelist option exists that determines this viscosity 
! as a local function of the grid spacing. 
!
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
!  R. J. Murray and C. J. C. Reason,
!  A curvilinear version of the Bryan-Cox ocean model
!  Journal of Computational Physics (2002), vol 171, pages 1--46
! </REFERENCE>
!
! <REFERENCE>
!  S.M. Griffies, Elements of MOM (2012)
! </REFERENCE>
!
! <NOTE>
! The numerical implementation requires no calls to mpp_update_domains.  
! </NOTE>
!
! <NOTE>
! This scheme has been found to be faster than the Smagorinsky viscosity 
! scheme.  However, the algorithm here is less robust since it 
! contains null modes in the terms associated with the sphericity 
! of the earth.  Hence, there may be flow configurations that are 
! not dissipated.
! </NOTE>
!
! <NOTE>
! The sink from drag next to partial cells has been dropped 
! from MOM4p1.  
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_lapcst_friction_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is false. 
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging by printing checksums.  
!  </DATA> 
!
!  <DATA NAME="alap" UNITS="m^2/sec" TYPE="real">
!  This is the value for the space-time constant Laplacian viscosity. 
!  </DATA> 
!  <DATA NAME="velocity_mix_micom" TYPE="logical">
!  If .true., then the viscosity is set according to a velocity scale times
!  the cube of the grid spacing. It is based on an approach recommended by 
!  Eric Chassignet that is used in the Miami Isopycnal Model.  
!  </DATA> 
!  <DATA NAME="vel_micom" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM viscosity. 
!  </DATA> 
!
!</NAMELIST>

use constants_mod,       only: pi, radius, epsln
use diag_manager_mod,    only: register_diag_field, register_static_field
use fms_mod,             only: open_namelist_file, check_nml_error, write_version_number, close_file
use fms_mod,             only: FATAL, NOTE, stdout, stdlog, read_data
use mpp_domains_mod,     only: mpp_update_domains
use mpp_mod,             only: input_nml_file, mpp_sum, mpp_pe, mpp_max, mpp_error

use ocean_domains_mod,    only: get_local_indices
use ocean_obc_mod,        only: ocean_obc_enhance_visc_back
use ocean_operators_mod,  only: FAX, FAY, BAX, BAY, FMX, FMY
use ocean_operators_mod,  only: BDX_EU, BDY_NU, FDX_U, FDY_U, FDX_NT, FDY_ET
use ocean_parameters_mod, only: missing_value
use ocean_types_mod,      only: ocean_time_type, ocean_grid_type, ocean_domain_type
use ocean_types_mod,      only: ocean_thickness_type, ocean_velocity_type, ocean_options_type
use ocean_util_mod,       only: write_timestamp, diagnose_3d_u, diagnose_2d_u, write_chksum_3d
use ocean_workspace_mod,  only: wrk1_v, wrk1  

implicit none

public ocean_lapcst_friction_init
public lapcst_friction
public lapcst_viscosity_check
public lapcst_reynolds_check

private

! length of forward time step  
real :: dtime

! for diagnostics 
integer :: id_visc      =-1
integer :: id_lap_fric_u=-1
integer :: id_lap_fric_v=-1
logical :: used

real :: alap                  = 0e5     ! constant horz viscosity for momentum (m^2/sec)
real :: vel_micom             = 0.0     ! background scaling velocity for micom viscosity (m/sec) 
real :: alap_taper_start_lat  = 60.     ! for tapering viscosity at high latitudes
real :: alap_taper_end_lat    = 90.     ! for tapering viscosity at high latitudes
real :: alap_taper_min_fac    = 30.     ! for tapering viscosity at high latitudes
logical :: alap_taper_hi_lats = .false. ! for tapering viscosity at high latitudes
logical :: velocity_mix_micom =.false.  ! if true, viscosity made a function of the grid spacing

real, dimension(:,:,:), allocatable :: visc_ceu  ! viscosity on east face of U cells (m^2/s)
real, dimension(:,:,:), allocatable :: visc_cnu  ! viscosity on north face of U cells (m^2/s)
real, dimension(:,:,:), allocatable :: visc_cu   ! variable viscosity averaged to U cell (m^2/s)

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()

integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk

character(len=256) :: version=&
     '=>Using: ocean_lapcst_friction.f90 ($Id: ocean_lapcst_friction.F90,v 20.0 2013/12/14 00:14:24 fms Exp $)'
character (len=128) :: tagname = &
     '$Name: tikal $'

logical :: use_this_module       = .false.
logical :: debug_this_module     = .false.
logical :: module_is_initialized = .FALSE.
logical :: have_obc              = .FALSE.
logical :: read_alap              = .FALSE.

namelist /ocean_lapcst_friction_nml/ use_this_module, debug_this_module, alap,                     &
                                     velocity_mix_micom, vel_micom,                                &
                                     alap_taper_hi_lats, alap_taper_start_lat, alap_taper_end_lat, &
                                     alap_taper_min_fac, read_alap

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_lapcst_friction_init">
!
! <DESCRIPTION>
! Initialize the horizontal Laplacian friction module by 
! registering fields for diagnostic output and performing some 
! numerical checks to see that viscosity is set appropriately.
! </DESCRIPTION>
!
subroutine ocean_lapcst_friction_init(Grid, Domain, Time, Ocean_options, d_time, &
                                      obc, use_lapcst_friction, debug)

  type(ocean_grid_type),    target, intent(in)    :: Grid
  type(ocean_domain_type),  target, intent(in)    :: Domain
  type(ocean_time_type),            intent(in)    :: Time
  type(ocean_options_type),         intent(inout) :: Ocean_options
  real,                             intent(in)    :: d_time
  logical,                          intent(in)    :: obc
  logical,                          intent(inout) :: use_lapcst_friction
  logical,                optional, intent(in)    :: debug

  integer :: ioun, io_status, ierr
  integer :: i, j, k, num

  integer, save :: unit=6     

  real    :: cbeta, alap_munk, dau_max
  real    :: alap_taper_min            
  real, dimension(Domain%isd:Domain%ied,Domain%jsd:Domain%jed) :: alap_const

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lapcst_friction_mod (ocean_lapcst_friction_init): already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_lapcst_friction_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_lapcst_friction_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_lapcst_friction_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_lapcst_friction_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_lapcst_friction_nml)  
  write (stdlogunit,ocean_lapcst_friction_nml)

  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk

  if(use_this_module) then 
      call mpp_error(NOTE, '==>Note: USING ocean_lapcst_friction_mod')
      Ocean_options%horz_lap_friction = 'Used constant horizontal Laplacian friction.'
      use_lapcst_friction = .true. 
  else
      call mpp_error(NOTE, '==>Note: NOT using ocean_lapcst_friction_mod')
      Ocean_options%horz_lap_friction = 'Did NOT use horizontal Laplacian friction.'
      use_lapcst_friction = .false.
      return 
  endif

  if (PRESENT(debug) .and. .not. debug_this_module) then 
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') &
    '==>Note: running with debug_this_module=.true. so will print lots of checksums.'  
  endif 

  Grd => Grid
  Dom => Domain
  dtime = d_time

  write(stdoutunit,'(/a,f10.2)') &
  '==> Note from ocean_lapcst_friction_mod: using forward time step of (secs)', dtime 

  have_obc       = obc
  if (have_obc) write(stdoutunit,'(/a,f10.2)') &
  '==> Note from ocean_lapcst_friction_mod: considering obc' 

  alap_const=alap

  if (read_alap) then
      call read_data('INPUT/alap.nc','alap',alap_const,Domain%domain2d)
      call mpp_update_domains (alap_const, Dom%domain2d)      
  endif
  
  if (velocity_mix_micom) then
      alap_const(:,:) = vel_micom*(2.0*Grd%dxu(:,:)*Grd%dyu(:,:))/&
           (epsln + Grd%dxu(:,:) + Grd%dyu(:,:))
  else if (.not. read_alap) then
      ! use alternate velocity scaling based on cell area
      dau_max = 0.0
      do j=jsc,jec
         do i=isc,iec
            if (Grd%dau(i,j) > dau_max) dau_max = Grd%dau(i,j)
         enddo
      enddo
      call mpp_max(dau_max)
      alap_const(:,:) = alap*(Grd%dau(:,:)/dau_max)
  endif

  ! enhance background viscosity near open boundaries if needed
  if (have_obc) call ocean_obc_enhance_visc_back(alap_const)
  
  if (alap_taper_hi_lats) then
    alap_const = alap
    alap_taper_min = alap/alap_taper_min_fac
    do j=jsc,jec
      do i=isc,iec
        if (abs(Grid%yu(i,j)) > alap_taper_start_lat) then
           alap_const(i,j) = alap - &
            (alap-alap_taper_min)*(alap_taper_start_lat-abs(Grid%yu(i,j)))**2 &
            /(alap_taper_start_lat-alap_taper_end_lat)**2
        endif
        if (alap_const(i,j) < alap_taper_min) alap_const(i,j) = alap_taper_min
      enddo
    enddo
    call mpp_update_domains (alap_const, Dom%domain2d)
    do j=jsc,jec
      write (unit,'(a,i5,f10.3,f14.4)') ' lateral_friction_init: j, lat, alap_const =', &
                      j+Dom%joff, Grid%yu(isc,j), alap_const(isc,j)
    enddo
  endif

  allocate (visc_ceu(isd:ied,jsd:jed,nk)) ! east face of U cell
  allocate (visc_cnu(isd:ied,jsd:jed,nk)) ! north face of U cell
  allocate (visc_cu(isd:ied,jsd:jed,nk))  ! for metric term
 
  do k=1,nk
    visc_ceu(:,:,k) = FAX(alap_const(:,:))
    visc_cnu(:,:,k) = FAY(alap_const(:,:))
    visc_cu(:,:,k)  = alap_const(:,:)
  enddo
  call mpp_update_domains (visc_ceu, Dom%domain2d)
  call mpp_update_domains (visc_cnu, Dom%domain2d)
  call mpp_update_domains (visc_cu,  Dom%domain2d)


  ! Munk boundary check
  if (dtime /= 0.0) then
    num = 0
    write (stdoutunit,'(/,(1x,a))') &
    '==> Warning: locations (if any) where the Munk boundary layer is unresolved.'
    do j=jsc,jec
      do i=isc,iec
        cbeta = 2.28e-11
        alap_munk = cbeta*(Grd%h1u(i,j)/radius)*(Grd%dxu(i,j)*sqrt(3.0)/pi)**3
        if (visc_cu(i,j,1) <= alap_munk .and. num <= 10 .and. i == isc) then
          num = num + 1
          write (stdoutunit,'(a,i4,a,i4,a,f6.2,a,f6.2,a,2(e14.7,a))') ' at (i,j)= (',i,',',j,'),(lon,lat)= (', &
                           Grd%xt(i,j),',',Grd%yt(i,j),&
                           '),  "alap" = ', visc_cu(i,j,1),&
                           ' m^2/s. the critical value =',alap_munk,' m^2/s'
        endif
      enddo
    enddo
    call mpp_sum (num)
    if (num > 10) write (stdoutunit,*) ' (a max of 10 violations per PE are listed)'
  endif

  ! register diagnostics and send static viscosity 
  id_visc = register_static_field ('ocean_model', 'lap_visc', Grd%vel_axes_uv(1:2),&
            'laplacian viscosity', 'm^2/sec',missing_value=missing_value,          &
            range=(/-10.0,1.e10/),                                                 &
            standard_name='ocean_momentum_xy_laplacian_diffusivity')
  call diagnose_2d_u(Time, Grd, id_visc, visc_cu(:,:,1))

  id_lap_fric_u = register_diag_field('ocean_model','lap_fric_u',Grd%vel_axes_uv(1:3), &
                  Time%model_time,'Thickness and rho wghtd horz lap frict on u',       &
                  '(kg/m^2)*(m^2/s^2)', missing_value=missing_value, range=(/-1e10,1e10/))
  id_lap_fric_v = register_diag_field('ocean_model','lap_fric_v',Grd%vel_axes_uv(1:3), &
                  Time%model_time,'Thickness and rho wghtd horz lap frict on v',       &
                  '(kg/m^2)*(m^2/s^2)', missing_value=missing_value, range=(/-1e10,1e10/))


end subroutine ocean_lapcst_friction_init
! </SUBROUTINE>  NAME="ocean_lapcst_friction_init"


!#######################################################################
! <SUBROUTINE NAME="lapcst_friction">
!
! <DESCRIPTION>
! This routine computes the rho*thickness weighted time tendency for
! horizontal velocity from horizontal Laplacian friction.
! </DESCRIPTION>
!
subroutine lapcst_friction(Time, Thickness, Velocity, lap_viscosity, energy_analysis_step)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(in)    :: Thickness
  type(ocean_velocity_type),  intent(inout) :: Velocity
  logical,                    intent(in)    :: energy_analysis_step
  real, dimension(isd:,jsd:), intent(inout) :: lap_viscosity

  real, dimension(isd:ied,jsd:jed)   :: metric
  real, dimension(isd:ied,jsd:jed,2) :: uk
  real, dimension(isd:ied,jsd:jed)   :: tmp, tmp1, tmp2, m1, m2, n1, n2
  integer :: i, j, k, n, taum1, tau

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) then 

      if(energy_analysis_step) then 
          do n=1,2
             do k=1,nk
                do j=jsc,jec
                   do i=isc,iec
                      Velocity%wrkv(i,j,k,n) = 0.0
                   enddo
                enddo
             enddo
          enddo
      endif

      return 
  endif

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lapcst_friction_mod (lapcst_friction): module needs to be initialized')
  endif 

  taum1 = Time%taum1
  tau   = Time%tau

  metric(:,:)     = 0.0
  wrk1_v(:,:,:,:) = 0.0

  ! laplacian friction operator 
  do k=1,nk

     m1(:,:)   = 2.0*visc_cu(:,:,k)*Grd%dh1dy(:,:) + BAY(FDY_U(visc_cu(:,:,k)))
     m2(:,:)   = 2.0*visc_cu(:,:,k)*Grd%dh2dx(:,:) + BAX(FDX_U(visc_cu(:,:,k)))
     tmp1(:,:) = visc_ceu(:,:,k)*Grd%dyue(:,:)
     tmp2(:,:) = visc_cnu(:,:,k)*Grd%dxun(:,:)
     n1(:,:)   = -Grd%dyur(:,:)*BDX_EU(tmp1(:,:)*FAX(Grd%dh2dx(:,:))) &
                 -Grd%dxur(:,:)*BDY_NU(tmp2(:,:)*FAY(Grd%dh1dy(:,:)))
     n2(:,:)   = +Grd%dyur(:,:)*BDX_EU(tmp1(:,:)*FAX(Grd%dh1dy(:,:))) &
                 -Grd%dxur(:,:)*BDY_NU(tmp2(:,:)*FAY(Grd%dh2dx(:,:)))

     do n=1,2
        uk(:,:,:)   = Velocity%u(:,:,k,:,taum1)
        metric(:,:) = (3-2*n)*(m1(:,:)*FDX_NT(BAX(uk(:,:,3-n)))-m2(:,:)*FDY_ET(BAY(uk(:,:,3-n)))  )&
                             + n1(:,:)*uk(:,:,n) + (3-2*n)*n2(:,:)*uk(:,:,3-n)
        tmp(:,:) = ( BDX_EU(visc_ceu(:,:,k)*FMX(Thickness%rho_dzu(:,:,k,tau))*FDX_U(uk(:,:,n)))&
                    +BDY_NU(visc_cnu(:,:,k)*FMY(Thickness%rho_dzu(:,:,k,tau))*FDY_U(uk(:,:,n))) ) &
                    + metric(:,:)*Thickness%rho_dzu(:,:,k,tau)
        do j=jsc,jec
           do i=isc,iec
              wrk1_v(i,j,k,n) = tmp(i,j)*Grd%umask(i,j,k)
           enddo
        enddo

     enddo

  enddo

  if(energy_analysis_step) then 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%wrkv(i,j,k,n) = wrk1_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo

  else 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%accel(i,j,k,n) = Velocity%accel(i,j,k,n) + wrk1_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo
      
      ! vertically averaged viscosity at U-cell centre
      lap_viscosity(:,:) = 0.0
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               lap_viscosity(i,j) = lap_viscosity(i,j) &
                + Grd%umask(i,j,k)*Thickness%rho_dzu(i,j,k,tau)*visc_cu(i,j,k)
            enddo
         enddo
      enddo
      do j=jsd,jed
         do i=isd,ied
            lap_viscosity(i,j) = Grd%umask(i,j,1)*lap_viscosity(i,j)/(epsln+Thickness%mass_u(i,j,tau))
         enddo
      enddo


      ! diagnostics
      call diagnose_3d_u(Time, Grd, id_lap_fric_u, wrk1_v(:,:,:,1))
      call diagnose_3d_u(Time, Grd, id_lap_fric_v, wrk1_v(:,:,:,2))
  endif

  if(debug_this_module) then
      write(stdoutunit,*) ' ' 
      write(stdoutunit,*) 'From ocean_lapcst_friction_mod: friction chksums'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('rho_dzu(tau)', Thickness%rho_dzu(COMP,:,tau)*Grd%umask(COMP,:))
      call write_chksum_3d('lapcst friction(1)', wrk1_v(COMP,:,1)*Grd%umask(COMP,:))
      call write_chksum_3d('lapcst friction(2)', wrk1_v(COMP,:,2)*Grd%umask(COMP,:))
  endif 


end subroutine lapcst_friction
! </SUBROUTINE> NAME="lapcst_friction"


!#######################################################################
! <SUBROUTINE NAME="lapcst_viscosity_check">
!
! <DESCRIPTION>
! Perform linear stability check for the Laplacian operator 
! given a value for the horizontal laplacian viscosity.
! </DESCRIPTION>

subroutine lapcst_viscosity_check

  integer :: num, i, j, k
  integer, save :: unit=6, max_num=3
  real :: crit, dsmin

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lapcst_friction_mod (lapcst_viscosity_check): needs initialization')
  endif 

  write (stdoutunit,'(/60x,a/)') &
  ' Excessive horizontal Laplacian friction summary:'
  write (stdoutunit,'(1x,a/)')   &
  'Locations (if any) where viscosity exceeds conservative linear stability constraint'
  num = 0
  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        if (Grd%umask(i,j,k) > 0.0) then 
          dsmin = min(Grd%dxu(i,j),Grd%dxu(i+1,j),Grd%dyu(i,j),Grd%dyu(i,j+1))
          crit = 0.5*dsmin**2/max(dtime,epsln)
          if (visc_cu(i,j,k) > crit .and. num < max_num) then
            num = num + 1
            write (unit,9600) &
            'visc_cu(',visc_cu(i,j,k), crit, i, j, k, Grd%xu(i,j), Grd%yu(i,j), Grd%zt(k), mpp_pe()
          endif
        endif 
      enddo
    enddo
  enddo

  call mpp_sum(num)
  if (num > max_num) then 
    write (stdoutunit,*) ' (a max of ',max_num,' violations per pe are listed)'
  endif 

9600  format(/' Warning: ',a,es10.3,' m^2/s) exceeds max value (',es10.3,') at (i,j,k) = ','(',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.0,'m, pe=',i3,')')

end subroutine lapcst_viscosity_check
! </SUBROUTINE> NAME="lapcst_viscosity_check"


!#######################################################################
! <SUBROUTINE NAME="lapcst_reynolds_check">
!
! <DESCRIPTION>
! Subroutine to compute the Laplacian grid Reynolds number.  Large 
! Reynolds numbers indicate regions where solution may experience 
! some grid noise due to lack of enough horizontal friction. 
! </DESCRIPTION>
!
subroutine lapcst_reynolds_check(Time, Velocity)

  type(ocean_time_type),     intent(in) :: Time
  type(ocean_velocity_type), intent(in) :: Velocity

  real :: rame, ramn, reyx, reyy
  real :: reynx0, reyny0, reynx,reyny, reynu,reynv, reynmu,reynmv
  integer :: ireynx,jreynx,kreynx, ireyny,jreyny,kreyny
  integer :: i, j, k, tau
  integer, save :: unit=6

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lapcst_friction_mod (lapcst_reynolds_check): needs initialization')
  endif 

  tau = Time%tau

  ! look for max grid reynolds numbers using velocities at "tau".

  ireynx=isc; jreynx=jsc; kreynx=1; reynx=0.0
  ireyny=isc; jreyny=jsc; kreyny=1; reyny=0.0
  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        rame = 1.0/(visc_cu(i,j,k) + epsln)
        ramn = 1.0/(visc_cu(i,j,k) + epsln)
        reyx = abs(Velocity%u(i,j,k,1,tau)*Grd%dxu(i,j))*rame
        if (reyx > reynx) then
          ireynx = i
          jreynx = j
          kreynx = k
          reynx  = reyx
          reynu  = Velocity%u(i,j,k,1,tau)
          reynmu = 1.0/rame
        endif
        reyy = abs(Velocity%u(i,j,k,2,tau)*Grd%dyu(i,j))*ramn
        if (reyy > reyny) then
          ireyny = i
          jreyny = j
          kreyny = k
          reyny  = reyy
          reynv  = Velocity%u(i,j,k,2,tau)
          reynmv = 1.0/ramn
        endif
      enddo
    enddo
  enddo
  write (stdoutunit,'(/60x,a/)') ' Horizontal Laplacian Reynolds number summary'

  reynx0 = reynx
  reyny0 = reyny
  call mpp_max(reynx)
  call mpp_max(reyny)
  
  if (reynx == reynx0) then
    write (unit,10300) reynx, ireynx, jreynx, kreynx, Grd%xu(ireynx,jreynx), &
                       Grd%yu(ireynx,jreynx), Grd%zt(kreynx), reynu, reynmu
  endif
  
  if (reyny == reyny0) then
    write (unit,10400) reyny, ireyny, jreyny, kreyny, Grd%xu(ireyny,jreyny), &
                       Grd%yu(ireyny,jreyny), Grd%zt(kreyny), reynv, reynmv
  endif

  10300 format (1x,'Maximum zonal Re =',es9.2,' at (i,j,k) = (',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.2,'), U =',es9.2, ', mix =',e9.2)
  10400 format (1x,'Maximum merid Re =',es9.2,' at (i,j,k) = (',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.2,'), V =',es9.2, ', mix =',e9.2)


end subroutine lapcst_reynolds_check
! </SUBROUTINE> NAME="lapcst_reynolds_check"


end module ocean_lapcst_friction_mod
      
      

module vegn_data_mod

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only : &
     write_version_number, file_exist, check_nml_error, &
     close_file, stdlog, stdout

use land_constants_mod, only : NBANDS, BAND_VIS, BAND_NIR
use land_tile_selectors_mod, only : &
     tile_selector_type, SEL_VEGN, register_tile_selector
use table_printer_mod

implicit none
private

! ==== public interfaces =====================================================
! ---- public constants
integer, public, parameter :: LU_SEL_TAG = 1 ! tag for the land use selectors
integer, public, parameter :: SP_SEL_TAG = 2 ! tag for the species selectors
integer, public, parameter :: NG_SEL_TAG = 3 ! tag for natural grass selector
  ! by "natural" it means non-human-maintained, so secondary vegetation
  ! grassland will be included. 

integer, public, parameter :: NSPECIES = 5, & ! number of species
 SP_C4GRASS   = 0, & ! c4 grass
 SP_C3GRASS   = 1, & ! c3 grass
 SP_TEMPDEC   = 2, & ! temperate deciduous
 SP_TROPICAL  = 3, & ! non-grass tropical
 SP_EVERGR    = 4    ! non-grass evergreen
character(len=12), parameter :: species_name(0:NSPECIES-1) = &
    (/'c4grass  ',  'c3grass  ' ,  'tempdec  ', 'tropical ','evergreen'/)
character(len=32), parameter :: species_longname(0:NSPECIES-1) = &
    (/'c4 grass                 ', 'c3 grass                 ',  'temperate deciduous trees',&
      'tropical trees           ', 'evergreen trees          '/)

integer, public, parameter :: n_dim_vegn_types = 9
integer, public, parameter :: MSPECIES = NSPECIES+n_dim_vegn_types-1
 
integer, public, parameter :: NCMPT = 6, & ! number of carbon compartments
 CMPT_REPRO   = 1, & ! 
 CMPT_SAPWOOD = 2, & ! sapwood compartment
 CMPT_LEAF    = 3, & ! leaf compartment
 CMPT_ROOT    = 4, & ! fine root compartment
 CMPT_VLEAF   = 5, & ! virtual leaves compartment (labile store)
 CMPT_WOOD    = 6    ! structural wood compartment

integer, public, parameter :: & ! physiology types
 PT_C3        = 0, &
 PT_C4        = 1

integer, public, parameter :: & ! phenology type
 PHEN_DECIDIOUS = 0, &
 PHEN_EVERGREEN = 1

integer, public, parameter :: & ! status of leaves
 LEAF_ON      = 0, &  ! leaves are displayed
 LEAF_OFF     = 5     ! leaves are dropped

integer, public, parameter :: & ! land use types
 N_LU_TYPES = 4, & ! number of different land use types
 LU_PAST    = 1, & ! pasture
 LU_CROP    = 2, & ! crops
 LU_NTRL    = 3, & ! natural vegetation
 LU_SCND    = 4    ! secondary vegetation
character(len=4), public, parameter  :: &
     landuse_name (N_LU_TYPES) = (/ 'past','crop','ntrl','scnd'/)
character(len=32), public, parameter :: &
     landuse_longname (N_LU_TYPES) = (/ 'pasture  ', 'crop     ', 'natural  ', 'secondary' /)

integer, public, parameter :: & ! harvesing pools paraneters
 N_HARV_POOLS        = 6, & ! number of harvesting pools
 HARV_POOL_PAST      = 1, & 
 HARV_POOL_CROP      = 2, &
 HARV_POOL_CLEARED   = 3, &
 HARV_POOL_WOOD_FAST = 4, &
 HARV_POOL_WOOD_MED  = 5, &
 HARV_POOL_WOOD_SLOW = 6
character(len=9), public :: HARV_POOL_NAMES(N_HARV_POOLS)
data HARV_POOL_NAMES &
 / 'past', 'crop', 'cleared', 'wood_fast', 'wood_med', 'wood_slow' /

real, public, parameter :: C2B = 2.0  ! carbon to biomass conversion factor

real, public, parameter :: BSEED = 5e-5 ! seed density for supply/demand calculations, kg C/m2 
! ---- public types
public :: spec_data_type

! ---- public data
public :: &
    vegn_to_use,  input_cover_types, &
    mcv_min, mcv_lai, &
    use_bucket, use_mcm_masking, vegn_index_constant, &
    critical_root_density, &
    ! vegetation data, imported from LM3V
    spdata, &
    min_cosz, &
    agf_bs, K1,K2, fsc_liv, fsc_wood, &
    tau_drip_l, tau_drip_s, & ! canopy water and snow residence times, for drip calculations
    GR_factor, tg_c3_thresh, tg_c4_thresh, &
    fsc_pool_spending_time, ssc_pool_spending_time, harvest_spending_time, &
    l_fract, T_transp_min, soil_carbon_depth_scale, &
    cold_month_threshold, scnd_biomass_bins, &
    phen_ev1, phen_ev2, cmc_eps

! ---- public subroutine
public :: read_vegn_data_namelist
! ==== end of public interfaces ==============================================

! ==== constants =============================================================
character(len=*), parameter   :: &
     version     = '$Id: vegn_data.F90,v 20.0 2013/12/13 23:31:06 fms Exp $', &
     tagname     = '$Name: tikal $', &
     module_name = 'vegn_data_mod'
real, parameter :: TWOTHIRDS  = 2.0/3.0


! ==== types ================================================================
type spec_data_type
  real    :: treefall_disturbance_rate;
  logical :: mortality_kills_balive ! if true, then bl, blv, and br are affected by natural mortality
  integer :: pt           ! photosynthetic physiology of species

  real    :: c1 ! unitless, coefficient for living biomass allocation
  real    :: c2 ! 1/m, coefficient for living biomass allocation
  real    :: c3 ! unitless, coefficient for calculation of sapwood biomass 
                ! fraction times sapwood retirement rate

  real    :: alpha(NCMPT) ! decay rates of plant carbon pools, 1/yr
  real    :: beta (NCMPT) ! respiration rates of plant carbon pools
  
  real    :: dfr          ! fine root diameter ? or parameter relating diameter of fine roots to resistance
  ! the following two parameters are used in the Darcy-law calculations of water supply
  real    :: srl  ! specific root length, m/(kg C)
  real    :: root_r       ! radius of the fine roots, m
  real    :: root_perm    ! fine root membrane permeability per unit area, kg/(m3 s)
!!$  real    :: ltrans       ! leaf translocation fraction
!!$  real    :: rtrans       ! fine root translocation fraction

  real    :: specific_leaf_area ! cm2/(g biomass)
  real    :: leaf_size    ! characteristic leaf size
  real    :: leaf_life_span ! months
  
  real    :: alpha_phot   ! photosynthesis efficiency
  real    :: m_cond       ! factor of stomatal conductance
  real    :: Vmax         ! max rubisco rate
  real    :: gamma_resp
  real    :: wet_leaf_dreg ! wet leaf photosynthesis down-regulation
  real    :: leaf_age_onset, leaf_age_tau

  ! radiation parameters for 2 bands, VIS and NIR
  real    :: leaf_refl (NBANDS) ! reflectance of leaf
  real    :: leaf_tran (NBANDS) ! transmittance of leaf
  real    :: leaf_emis          ! emissivity of leaf 
  real    :: scatter   (NBANDS) ! scattering coefficient of leaf (calculated as leaf_tran+leaf_refl)
  real    :: upscatter_dif (NBANDS)

  ! parameters of leaf angle distribution; see also Bonan, NCAR/TN-417+STR (LSM
  ! 1.0 technical description), p.18
  real    :: ksi    ! departure of leaf angles from a random distribution
  real    :: phi1   ! leaf distribution parameter
  real    :: phi2   ! leaf distribution parameter
  real    :: mu_bar ! average inverse diffuse optical depth per unit leaf are

  ! canopy intercepted water parameters
  real    :: cmc_lai ! max amount of liquid water on vegetation, kg/(m2 of leaf)
  real    :: cmc_pow ! power of wet fraction dependance on amount of canopy water
  real    :: csc_lai ! max amount of snow on vegetation, kg/(m2 of leaf)
  real    :: csc_pow ! power of snow-covered fraction dependance on amount of canopy snow
  real    :: fuel_intensity

  ! critical temperature for leaf drop, was internal to phenology
  real    :: tc_crit
  ! critical soil-water-stress index, used in place of fact_crit_phen and 
  ! cnst_crit_phen. It is used if and only if it's value is greater than 0
  real    :: psi_stress_crit_phen
  real    :: fact_crit_phen, cnst_crit_phen ! wilting factor and offset to 
    ! get critical value for leaf drop -- only one is non-zero at any time
  real    :: fact_crit_fire, cnst_crit_fire ! wilting factor and offset to 
    ! get critical value for fire -- only one is non-zero at the time

  real    :: smoke_fraction ! fraction of carbon lost as smoke during fires

  ! data from LM3W, temporarily here
  real    :: dat_height
  real    :: dat_lai
  real    :: dat_root_density
  real    :: dat_root_zeta
  real    :: dat_rs_min
  real    :: dat_snow_crit
end type

! ==== module data ===========================================================
integer :: idata,jdata ! iterators used in data initialization statements

! ---- namelist --------------------------------------------------------------
type(spec_data_type), save :: spdata(0:MSPECIES)

logical :: use_bucket = .false.
logical :: use_mcm_masking = .false.
real    :: mcv_min = 5.   * 4218.
real    :: mcv_lai = 0.15 * 4218.

! ---- remainder are used only for cold start
character(len=16):: vegn_to_use     = 'single-tile'
       ! 'multi-tile' for tiled vegetation
       ! 'single-tile' for geographically varying vegetation with single type per
       !     model grid cell
       ! 'uniform' for global constant vegetation, e.g., to reproduce MCM
integer :: vegn_index_constant   = 1         ! index of global constant vegn,
                                             ! used when vegn_to_use is 'uniform'
real    :: critical_root_density = 0.125

integer, dimension(1:MSPECIES) :: &
 input_cover_types=(/          -1,   -1,   -1,   -1, &
                          1,    2,    3,    4,    5,    6,    7,    8,    9/)
!character(len=4), dimension(n_dim_vegn_types) :: &
!  tile_names=      (/'be  ','bd  ','bn  ','ne  ','nd  ','g   ','d   ','t   ','a   ' /)

!  BE -- broadleaf evergreen trees
!  BD -- broadleaf deciduous trees
!  BN -- broadleaf/needleleaf trees
!  NE -- needleleaf evergreen trees
!  ND -- needleleaf deciduous trees
!  G  -- grassland
!  D  -- desert
!  T  -- tundra
!  A  -- agriculture


!       c4grass       c3grass    temp-decid      tropical     evergreen      BE     BD     BN     NE     ND      G      D      T      A
real :: dat_height(0:MSPECIES)= &
       (/  0.51,         0.51,          6.6,         19.5,          6.6,   19.5,   6.6,   8.8,   6.6,   5.9,  0.51,   1.0,  0.51,   2.9 /)
real :: dat_lai(0:MSPECIES); data dat_lai(NSPECIES:MSPECIES) &
                                                                        /   5.0,   5.0,   5.0,   5.0,   5.0,  5.0,   .001,   5.0,   5.0 /
! dat_root_density and dat_root_zeta were extended to lm3v species by copying 
! appropriate values from LaD table (e.g., grassland for both C3 and C4 grass)
real :: dat_root_density(0:MSPECIES)= &
!       c4grass       c3grass    temp-decid      tropical     evergreen      BE     BD     BN     NE     ND      G      D      T      A
       (/   1.4,          1.4,          4.2,          4.9,          2.9,    4.9,   4.2,   4.3,   2.9,   2.9,   1.4,   1.0,   1.2,  0.15 /)
real :: dat_root_zeta(0:MSPECIES)= &
       (/  0.26,         0.26,         0.29,         0.26,         0.17,   0.26,  0.29,  0.35,  0.17,  0.17,  0.26,   0.1,  0.11,  0.25 /)
real :: dat_rs_min(0:MSPECIES)= &
       (/ 56.6,          56.6,        131.0,         43.6,         69.7,   43.6, 131.0,  87.1,  69.7, 218.0,  56.6, 100.0, 170.0,  56.6 /)
real :: dat_snow_crit(0:MSPECIES)= &
!       c4grass       c3grass    temp-decid      tropical     evergreen      BE     BD     BN     NE     ND      G      D      T      A
    (/  0.0167,       0.0167,        0.0333,          0.2,       0.1333,    0.2, .0333, .0833, .1333, .1333, .0167, .0167, .0167, .0167 /)

! ==== species data imported from LM3V ======================================

!         c4 grass      c3 grass      c3 temperate  c3 tropical   c3 evergreed
real :: treefall_disturbance_rate(0:MSPECIES); data treefall_disturbance_rate(0:NSPECIES-1) &
        / 0.175,        0.185,        0.015,        0.025,        0.015 /
logical :: mortality_kills_balive(0:MSPECIES); data mortality_kills_balive(0:NSPECIES-1) &
        /.false.,      .false.,      .false.,      .false.,      .false./
integer :: pt(0:MSPECIES)= &
!       c4grass       c3grass    temp-decid      tropical     evergreen      BE     BD     BN     NE     ND      G      D      T      A
       (/ PT_C4,        PT_C3,        PT_C3,        PT_C3,        PT_C3,  PT_C3, PT_C3, PT_C3, PT_C3, PT_C3, PT_C4, PT_C4, PT_C3, PT_C3 /)
real :: alpha(0:MSPECIES,NCMPT) ; data ((alpha(idata,jdata), idata=0,MSPECIES),jdata=1,NCMPT) &
        /   0.0,          0.0,          0.0,          0.0,          0.0,     0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0., & ! reproduction
            0.0,          0.0,          0.0,          0.0,          0.0,     0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0., & ! sapwood
            1.0,          1.0,          1.0,          0.8,         0.12,    0.8,   1.0,   1.0,  0.12,   1.0,   1.0,   1.0,   1.0,   1.0, & ! leaf
            0.9,         0.55,          1.0,          0.8,          0.6,    0.8,   1.0,   1.0,   0.6,   1.0,  0.55,   0.9,  0.55,  0.55, & ! root
            0.0,          0.0,          0.0,          0.0,          0.0,     0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0., & ! virtual leaf
            0.0,          0.0,        0.006,        0.012,        0.006,  0.012, 0.006, 0.006, 0.006, 0.006,    0.,    0.,    0.,    0. /  ! structural

! From Foley (Ibis model) 1996 gbc v10 pp. 603-628
real :: beta(0:MSPECIES,NCMPT) ; data ((beta(idata,jdata), idata=0,NSPECIES-1),jdata=1,NCMPT) &
        /   0.0,          0.0,          0.0,          0.0,          0.0,& ! reproduction
            0.0,          0.0,          0.0,          0.0,          0.0,& ! sapwood
            0.0,          0.0,          0.0,          0.0,          0.0,& ! leaf
           1.25,         1.25,         1.25,         1.25,         1.25,& ! root
            0.0,          0.0,          0.0,          0.0,          0.0,& ! virtual leaf
            0.0,          0.0,          0.0,          0.0,          0.0 / ! structural

! root parameters
real :: dfr(0:MSPECIES) ; data dfr &
!       c4grass       c3grass    temp-decid      tropical     evergreen      BE      BD      BN      NE      ND       G       D       T      A
        /   2.2,          2.2,          5.8,          5.8,          5.8,    5.8,    5.8,    5.8,    5.8,    5.8,    2.2,    2.2,    2.2,    2.2 /
real :: srl(0:MSPECIES); data srl & ! specific root length, m/(kg C)
        / 236e3,        236e3,       24.4e3,       24.4e3,       24.4e3, 24.4e3, 24.4e3, 24.4e3, 24.4e3, 24.4e3,  236e3,  236e3,   60e3,   60e3 /
real :: root_r(0:MSPECIES); data root_r & ! radius of fine roots, m
        /1.1e-4,       1.1e-4,       2.9e-4,       2.9e-4,       2.9e-4, 2.9e-4, 2.9e-4, 2.9e-4, 2.9e-4, 2.9e-4, 1.1e-4, 1.1e-4, 2.2e-4, 2.2e-4 /
real :: root_perm(0:MSPECIES); data root_perm & ! fine root membrane permeability per unit membrane area, kg/(m3 s)
        / 1e-5,          1e-5,         1e-5,         1e-5,         1e-5,   1e-5,   1e-5,   1e-5,   1e-5,   1e-5,   1e-5,   1e-5,   1e-5,   1e-5 /
! Specific root length is from Jackson et al., 1997, PNAS  Vol.94, pp.7362--7366, 
! converted to m/(kg C) from m/(g biomass). Biomass/C mass ratio was assumed 
! to be 2. The fine root radius is from the same source.
!
! Root membrane permeability is "high" value from Siqueira et al., 2008, Water 
! Resource Research Vol. 44, W01432, converted to mass units

real :: c1(0:MSPECIES); data c1(0:NSPECIES-1) &
        /   1.358025,     2.222222,     0.4807692,    0.3333333,    0.1948718 /
real :: c2(0:MSPECIES); data c2(0:NSPECIES-1) &
        /   0.4004486,    0.4004486,    0.4004486,    0.3613833,    0.1509976 /
real :: c3(0:MSPECIES); data c3(0:NSPECIES-1) &
        /   0.5555555,    0.5555555,    0.4423077,    1.230769,     0.5897437 /

! leaf radiation parameters
real :: leaf_refl(0:MSPECIES,NBANDS) ; data leaf_refl & ! leaf reflectance
        /   0.11,        0.11,         0.10,         0.10,         0.07,  0.149, 0.130, 0.132, 0.126, 0.143, 0.182, 0.300, 0.139, 0.160, & ! VIS
            0.45,        0.45,         0.45,         0.45,         0.35,  0.149, 0.130, 0.132, 0.126, 0.143, 0.182, 0.300, 0.139, 0.160  / ! NIR
real :: leaf_tran(0:MSPECIES,NBANDS) ; data leaf_tran & ! leaf transmittance
        /   0.07,        0.07,         0.05,         0.05,         0.05,     0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0., & ! VIS
            0.25,        0.25,         0.25,         0.25,         0.10,     0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.  / ! NIR
real :: leaf_emis(0:MSPECIES)= & ! leaf emissivity
       (/   1.00,        1.00,         1.00,         1.00,         1.00,   0.98,   0.96,  0.97,  0.98,  0.96, 0.96,   1.0,  0.96,  0.96  /)
real :: ksi(0:MSPECIES)= & ! leaf inclination index
       (/      0.,          0.,           0.,           0.,          0.,     0.,     0.,    0.,    0.,    0.,    0.,    0.,    0.,   0.  /)
real :: min_cosz = 0.01 ! minimum allowed value of cosz for vegetation radiation
   ! properties calculations.
   ! It probably doesn't make sense to set it any less than the default value, because the angular 
   ! diameter of the sun is about 0.01 radian (0.5 degree), so the spread of the direct radiation 
   ! zenith angles is about this. Besides, the sub-grid variations of land surface slope are 
   ! probably even larger that that. 

! canopy interception parameters
real :: cmc_lai(0:MSPECIES)= & ! maximum canopy water conntent per unit LAI
       (/    0.1,         0.1,          0.1,          0.1,          0.1,    0.1,    0.1,   0.1,   0.1,   0.1,   0.1,   0.1,   0.1,  0.1  /)
real :: cmc_pow(0:MSPECIES)= & ! power of the wet canopy fraction relation 
  (/   TWOTHIRDS,   TWOTHIRDS,    TWOTHIRDS,    TWOTHIRDS,    TWOTHIRDS,     1.,     1.,    1.,    1.,    1.,    1.,    1.,    1.,   1.  /)
real :: csc_lai(0:MSPECIES)= & ! maximum canopy snow conntent per unit LAI
       (/    0.1,         0.1,          0.1,          0.1,          0.1,    0.1,    0.1,   0.1,   0.1,   0.1,   0.1,   0.1,   0.1,  0.1  /)
real :: csc_pow(0:MSPECIES)= & ! power of the snow-covered fraction relation 
  (/   TWOTHIRDS,   TWOTHIRDS,    TWOTHIRDS,    TWOTHIRDS,    TWOTHIRDS,     1.,     1.,    1.,    1.,    1.,    1.,    1.,    1.,   1.  /)
real :: cmc_eps = 0.01 ! value of w/w_max for transition to linear function; 
                       ! the same value is used for liquid and snow

real :: fuel_intensity(0:MSPECIES) ; data fuel_intensity(0:NSPECIES-1) &
        /    1.0,         1.0,        0.002,        0.002,        0.004 /
real :: leaf_size(0:MSPECIES)= & ! characteristic leaf size
       (/   0.04,        0.04,         0.04,          0.04,        0.04,    0.1,   0.1,   0.1,   0.1,   0.1,   0.1,   0.1,   0.1,   0.1  /)
! photosynthesis parameters
real :: Vmax(0:MSPECIES)= & ! max rubisco rate
       (/  35e-6,       70e-6,        70e-6,         70e-6,       70e-6,  70e-6, 70e-6, 70e-6, 70e-6, 70e-6, 35e-6, 35e-6, 70e-6, 70e-6  /)
real :: m_cond(0:MSPECIES)= & ! factor of stomatal conductance
       (/    4.0,         9.0,          9.0,           9.0,         9.0,    9.0,   9.0,   9.0,   9.0,   9.0,   4.0,   4.0,   9.0,   9.0  /)
real :: alpha_phot(0:MSPECIES)= & ! photosynthesis efficiency
       (/   0.05,        0.06,         0.06,          0.06,        0.06,   0.06,  0.06,  0.06,  0.06,  0.06,  0.05,  0.05,  0.06,  0.06  /)
real :: gamma_resp(0:MSPECIES)= &
       (/   0.03,        0.02,         0.02,          0.02,        0.03,   0.02,  0.02,  0.02,  0.03,  0.03,  0.03,  0.03,  0.03,  0.02  /)
!       c4grass       c3grass    temp-decid      tropical     evergreen      BE     BD     BN     NE     ND      G      D      T      A
real :: tc_crit(0:MSPECIES)= &
       (/ 283.16,      278.16,       283.16,        283.16,      263.16,      0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0. /)
real :: psi_stress_crit_phen(0:MSPECIES)= & ! iff > 0, critical soil-water-stress index for leaf drop, overrides water content
       (/    0.0,         0.0,          0.0,           0.0,         0.0,    0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0 /)       
real :: cnst_crit_phen(0:MSPECIES)= & ! constant critical value for leaf drop
       (/    0.1,         0.1,          0.1,           0.1,         0.1,    0.1,   0.1,   0.1,   0.1,   0.1,   0.1,   0.1,   0.1,   0.1  /)
real :: fact_crit_phen(0:MSPECIES)= & ! factor for wilting to get critical value for leaf drop
       (/    0.0,         0.0,          0.0,           0.0,         0.0,    0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0  /)
real :: cnst_crit_fire(0:MSPECIES)= & ! constant critical value for leaf drop
       (/    0.1,         0.1,          0.1,           0.1,         0.1,    0.1,   0.1,   0.1,   0.1,   0.1,   0.1,   0.1,   0.1,   0.1  /)  
real :: fact_crit_fire(0:MSPECIES)= & ! factor for wilting to get critical value for fire
       (/    0.0,         0.0,          0.0,           0.0,         0.0,    0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0  /)
real :: wet_leaf_dreg(0:MSPECIES) = & ! wet leaf photosynthesis down-regulation: 0.3 means 
        ! photosynthesis of completely wet leaf will be 30% less than that of dry one,
        ! provided everything else is the same 
       (/    0.3,         0.3,          0.3,           0.3,         0.3,    0.3,   0.3,   0.3,   0.3,   0.3,   0.3,   0.3,   0.3,   0.3  /)
real :: leaf_age_onset(0:MSPECIES) = & ! onset of Vmax decrease due to leaf aging, days
       (/  100.0,       100.0,        100.0,         100.0,       100.0,  100.0, 100.0, 100.0, 100.0, 100.0, 100.0, 100.0, 100.0, 100.0  /)
real :: leaf_age_tau(0:MSPECIES) = &  ! e-folding time of Vmax decrease due to leaf aging, days (0 or less means no aging)
       (/    0.0,         0.0,          0.0,           0.0,         0.0,    0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0  /)

real :: soil_carbon_depth_scale = 0.2   ! depth of active soil for carbon decomposition
real :: cold_month_threshold    = 283.0 ! monthly temperature threshold for calculations of number of cold months
real :: smoke_fraction(0:MSPECIES) = & ! fration of carbon lost as smoke
       (/    0.9,         0.9,          0.9,           0.9,         0.9,    0.9,   0.9,   0.9,   0.9,   0.9,   0.9,   0.9,   0.9,   0.9  /)
real :: agf_bs         = 0.8 ! ratio of above ground stem to total stem
real :: K1 = 10.0, K2 = 0.05 ! soil decomposition parameters
real :: fsc_liv        = 0.8
real :: fsc_wood       = 0.2
real :: tau_drip_l     = 21600.0 ! canopy water residence time, for drip calculations
real :: tau_drip_s     = 86400.0 ! canopy snow residence time, for drip calculations
real :: GR_factor = 0.33 ! growth respiration factor     

real :: tg_c3_thresh = 1.5 ! threshold biomass between tree and grass for C3 plants
real :: tg_c4_thresh = 2.0 ! threshold biomass between tree and grass for C4 plants
real :: fsc_pool_spending_time = 1.0 ! time (yrs) during which intermediate pool of 
                  ! fast soil carbon is entirely converted to the fast soil carbon
real :: ssc_pool_spending_time = 1.0 ! time (yrs) during which intermediate pool of
                  ! slow soil carbon is entirely converted to the slow soil carbon
real :: harvest_spending_time(N_HARV_POOLS) = &
     (/1.0, 1.0, 1.0, 1.0, 10.0, 100.0/)
     ! time (yrs) during which intermediate pool of harvested carbon is completely
     ! released to the atmosphere. 
     ! NOTE: a year in the above *_spending_time definitions is exactly 365*86400 seconds
real :: l_fract      = 0.5 ! fraction of the leaves retained after leaf drop
real :: T_transp_min = 0.0 ! lowest temperature at which transporation is enabled
                           ! 0 means no limit, lm3v value is 268.0
! boundaries of wood biomass bins for secondary veg. (kg C/m2); used to decide 
! whether secondary vegetation tiles can be merged or not. MUST BE IN ASCENDING 
! ORDER.
real  :: scnd_biomass_bins(10) &  
     = (/ 0.5, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 8.0, 10.0, 1000.0 /)
real :: phen_ev1 = 0.5, phen_ev2 = 0.9 ! thresholds for evergreen/decidious 
      ! differentiation (see phenology_type in cohort.F90)

namelist /vegn_data_nml/ &
  vegn_to_use,  input_cover_types, &
  mcv_min, mcv_lai, &
  use_bucket, use_mcm_masking, vegn_index_constant, &
  critical_root_density, &

  dat_height, dat_lai, dat_root_density, dat_root_zeta, dat_rs_min, dat_snow_crit, &
  ! vegetation data, imported from LM3V
  pt, Vmax, m_cond, alpha_phot, gamma_resp, wet_leaf_dreg, &
  leaf_age_onset, leaf_age_tau, &
  treefall_disturbance_rate, mortality_kills_balive, fuel_intensity, &
  alpha, beta, c1,c2,c3, &
  dfr, &
  srl, root_r, root_perm, &
  cmc_lai, cmc_pow, csc_lai, csc_pow, cmc_eps, &
  min_cosz, &
  leaf_refl, leaf_tran, leaf_emis, ksi, &
  leaf_size, &
  soil_carbon_depth_scale, cold_month_threshold, &

  smoke_fraction, agf_bs, K1,K2, fsc_liv, fsc_wood, &
  tau_drip_l, tau_drip_s, GR_factor, tg_c3_thresh, tg_c4_thresh, &
  fsc_pool_spending_time, ssc_pool_spending_time, harvest_spending_time, &
  l_fract, T_transp_min,  tc_crit, psi_stress_crit_phen, &
  cnst_crit_phen, fact_crit_phen, cnst_crit_fire, fact_crit_fire, &
  scnd_biomass_bins, phen_ev1, phen_ev2


contains ! ###################################################################



! ============================================================================
subroutine read_vegn_data_namelist()
  ! ---- local vars
  integer :: unit         ! unit for namelist i/o
  integer :: io           ! i/o status for the namelist
  integer :: ierr         ! error code, returned by i/o routines
  integer :: i
  
  type(table_printer_type) :: table

  call write_version_number(version, tagname)
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=vegn_data_nml, iostat=io)
  ierr = check_nml_error(io, 'vegn_data_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file()
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=vegn_data_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'vegn_data_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif

  unit=stdlog()

  ! reconcile values of fact_crit_phen and cnst_crit_phen
  cnst_crit_phen = max(0.0,min(1.0,cnst_crit_phen))
  fact_crit_phen = max(0.0,fact_crit_phen)
  where (cnst_crit_phen/=0) fact_crit_phen=0.0
  write(unit,*)'reconciled fact_crit_phen and cnst_crit_phen'

  ! do the same for fire
  cnst_crit_fire = max(0.0,min(1.0,cnst_crit_fire))
  fact_crit_fire = max(0.0,fact_crit_fire)
  where (cnst_crit_fire/=0) fact_crit_fire=0.0 
  write(unit,*)'reconciled fact_crit_fire and cnst_crit_fire'

  ! initialize vegetation data structure

  spdata%dat_height = dat_height
  spdata%dat_lai = dat_lai
  spdata%dat_root_density = dat_root_density
  spdata%dat_root_zeta = dat_root_zeta
  spdata%dat_rs_min = dat_rs_min
  spdata%dat_snow_crit = dat_snow_crit

  spdata%treefall_disturbance_rate = treefall_disturbance_rate
  spdata%mortality_kills_balive    = mortality_kills_balive
  spdata%fuel_intensity            = fuel_intensity
 
  spdata%pt         = pt
  spdata%Vmax       = Vmax
  spdata%m_cond     = m_cond
  spdata%alpha_phot = alpha_phot
  spdata%gamma_resp = gamma_resp
  spdata%wet_leaf_dreg = wet_leaf_dreg
  spdata%leaf_age_onset = leaf_age_onset
  spdata%leaf_age_tau = leaf_age_tau
  spdata%dfr        = dfr

  spdata%srl        = srl
  spdata%root_r     = root_r
  spdata%root_perm  = root_perm
  
  spdata%c1 = c1
  spdata%c2 = c2
  spdata%c3 = c3

  spdata%cmc_lai = cmc_lai
  spdata%cmc_pow = cmc_pow
  spdata%csc_lai = csc_lai
  spdata%csc_pow = csc_pow
  
  spdata%leaf_size = leaf_size

  spdata%tc_crit   = tc_crit
  spdata%psi_stress_crit_phen = psi_stress_crit_phen
  spdata%cnst_crit_phen = cnst_crit_phen
  spdata%fact_crit_phen = fact_crit_phen
  spdata%cnst_crit_fire = cnst_crit_fire
  spdata%fact_crit_fire = fact_crit_fire

  spdata%smoke_fraction = smoke_fraction

  do i = 0, MSPECIES
     spdata(i)%alpha     = alpha(i,:)
     spdata(i)%beta      = beta(i,:)
     spdata(i)%leaf_refl = leaf_refl(i,:)
     spdata(i)%leaf_tran = leaf_tran(i,:)
     spdata(i)%leaf_emis = leaf_emis(i)
     spdata(i)%ksi       = ksi(i)
     call init_derived_species_data(spdata(i))
  enddo

  ! register selectors for land use type-specific diagnostics
  do i=1, N_LU_TYPES
     call register_tile_selector(landuse_name(i), long_name=landuse_longname(i),&
          tag = SEL_VEGN, idata1 = LU_SEL_TAG, idata2 = i )
  enddo
  
  ! register selectors for species-specific diagnostics
  do i=0,NSPECIES-1
     call register_tile_selector(species_name(i), long_name=species_longname(i),&
          tag = SEL_VEGN, idata1 = SP_SEL_TAG, idata2 = i )
  enddo

  ! register selector for natural grass
  call register_tile_selector('ntrlgrass', long_name='natural (non-human-maintained) grass',&
          tag = SEL_VEGN, idata1 = NG_SEL_TAG)

  write (unit, nml=vegn_data_nml)

  call init_with_headers(table,species_name)
  call add_row(table,'Treefall dist. rate', spdata(:)%treefall_disturbance_rate)
  call add_row(table,'Mortality kills balive', spdata(:)%mortality_kills_balive)
  call add_row(table,'Phisiology Type', spdata(:)%pt)
  call add_row(table,'C1',            spdata(:)%c1)
  call add_row(table,'C2',            spdata(:)%c2)
  call add_row(table,'C3',            spdata(:)%c3)

  call add_row(table,'alpha_leaf',    spdata(:)%alpha(CMPT_LEAF))
  call add_row(table,'alpha_root',    spdata(:)%alpha(CMPT_ROOT))
  call add_row(table,'alpha_vleaf',   spdata(:)%alpha(CMPT_VLEAF))
  call add_row(table,'alpha_sapwood', spdata(:)%alpha(CMPT_SAPWOOD))
  call add_row(table,'alpha_wood',    spdata(:)%alpha(CMPT_WOOD))
  call add_row(table,'alpha_repro',   spdata(:)%alpha(CMPT_REPRO))

  call add_row(table,'beta_leaf',     spdata(:)%beta(CMPT_LEAF))
  call add_row(table,'beta_root',     spdata(:)%beta(CMPT_ROOT))
  call add_row(table,'beta_vleaf',    spdata(:)%beta(CMPT_VLEAF))
  call add_row(table,'beta_sapwood',  spdata(:)%beta(CMPT_SAPWOOD))
  call add_row(table,'beta_wood',     spdata(:)%beta(CMPT_WOOD))
  call add_row(table,'beta_repro',    spdata(:)%beta(CMPT_REPRO))

  call add_row(table,'dfr',           spdata(:)%dfr)

  call add_row(table,'srl',           spdata(:)%srl)
  call add_row(table,'root_r',        spdata(:)%root_r)
  call add_row(table,'root_perm',     spdata(:)%root_perm)

  call add_row(table,'specific_leaf_area', spdata(:)%specific_leaf_area)
  call add_row(table,'leaf_size',     spdata(:)%leaf_size)
  call add_row(table,'leaf_life_span',spdata(:)%leaf_life_span)

  call add_row(table,'alpha_phot',    spdata(:)%alpha_phot)
  call add_row(table,'m_cond',        spdata(:)%m_cond)
  call add_row(table,'Vmax',          spdata(:)%Vmax)
  call add_row(table,'gamma_resp',    spdata(:)%gamma_resp)
  call add_row(table,'wet_leaf_dreg', spdata(:)%wet_leaf_dreg)
  call add_row(table,'leaf_age_onset',spdata(:)%leaf_age_onset)
  call add_row(table,'leaf_age_tau',  spdata(:)%leaf_age_tau)

  call add_row(table,'leaf_refl_vis', spdata(:)%leaf_refl(BAND_VIS))
  call add_row(table,'leaf_refl_nir', spdata(:)%leaf_refl(BAND_NIR))
  call add_row(table,'leaf_tran_vis', spdata(:)%leaf_tran(BAND_VIS))
  call add_row(table,'leaf_tran_nir', spdata(:)%leaf_tran(BAND_NIR))
  call add_row(table,'leaf_emis',     spdata(:)%leaf_emis)
  call add_row(table,'ksi',           spdata(:)%ksi)
  call add_row(table,'phi1',          spdata(:)%phi1)
  call add_row(table,'phi2',          spdata(:)%phi2)
  call add_row(table,'mu_bar',        spdata(:)%mu_bar)

  call add_row(table,'cmc_lai',       spdata(:)%cmc_lai)
  call add_row(table,'cmc_pow',       spdata(:)%cmc_pow)
  call add_row(table,'csc_lai',       spdata(:)%csc_lai)
  call add_row(table,'csc_pow',       spdata(:)%csc_pow)
  call add_row(table,'fuel_intensity',spdata(:)%fuel_intensity)

  call add_row(table,'tc_crit',       spdata(:)%tc_crit)
  call add_row(table,'psi_stress_crit_phen', spdata(:)%psi_stress_crit_phen)
  call add_row(table,'fact_crit_phen',spdata(:)%fact_crit_phen)
  call add_row(table,'cnst_crit_phen',spdata(:)%cnst_crit_phen)
  call add_row(table,'fact_crit_fire',spdata(:)%fact_crit_fire)
  call add_row(table,'cnst_crit_fire',spdata(:)%cnst_crit_fire)

  call add_row(table,'smoke_fraction',spdata(:)%smoke_fraction)

  call print(table,stdout())
  call print(table,unit)
  
end subroutine 


! ============================================================================
subroutine init_derived_species_data(sp)
   type(spec_data_type), intent(inout) :: sp

   integer :: j
   
   sp%leaf_life_span     = 12.0/sp%alpha(CMPT_LEAF) ! in months
   ! calculate specific leaf area (cm2/g(biomass))
   ! Global Raich et al 94 PNAS pp 13730-13734
   sp%specific_leaf_area = 10.0**(2.4 - 0.46*log10(sp%leaf_life_span));       
   ! convert to (m2/kg(carbon)
   sp%specific_leaf_area = C2B*sp%specific_leaf_area*1000.0/10000.0

! rho_wood is not used anywhere?
!     ! the relationship from Moorcroft, based on Reich
!     ! units kg C/m^3, hence the factor of 0.001 to convert from g/cm^3
!      sp%rho_wood = (0.5 + 0.2*(sp%leaf_life_span-1))*0.001;
!     if (sp%rho_wood > 500.) sp%rho_wood = 0.5*0.001;

   sp%phi1=0.5-0.633*sp%ksi-0.33*sp%ksi**2;
   sp%phi2=0.877*(1.0-2.0*sp%phi1);
   if(sp%ksi /= 0) then
      sp%mu_bar = &
           (1-sp%phi1/sp%phi2*log(1+sp%phi2/sp%phi1))&
           / sp%phi2
   else
      ! in degenerate case of spherical leaf angular distribution the above 
      ! formula for mu_bar gives an undefined value, so we handle it separately 
      sp%mu_bar = 1.0
   endif
   do j = 1,NBANDS
      sp%scatter(j)       = sp%leaf_refl(j)+sp%leaf_tran(j);
      sp%upscatter_dif(j) = 0.5*(sp%scatter(j) + & 
           (sp%leaf_refl(j)-sp%leaf_tran(j))*(1+sp%ksi)**2/4);
   enddo
end subroutine


end module

!-----------------------------------------------------------------------
!   Domain decomposition and domain update for message-passing codes
!
! AUTHOR: V. Balaji (vb@gfdl.gov)
!         SGI/GFDL Princeton University
!
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! For the full text of the GNU General Public License,
! write to: Free Software Foundation, Inc.,
!           675 Mass Ave, Cambridge, MA 02139, USA.  
!-----------------------------------------------------------------------

! <CONTACT EMAIL="V.Balaji@noaa.gov">
!   V. Balaji
! </CONTACT>
! <CONTACT EMAIL="Zhi.Liang@noaa.gov">
!   Zhi Liang
! </CONTACT>
! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>
! <RCSLOG SRC="http://www.gfdl.noaa.gov/~vb/changes_mpp_domains.html"/>

! <OVERVIEW>
!   <TT>mpp_domains_mod</TT> is a set of simple calls for domain
!   decomposition and domain updates on rectilinear grids. It requires the
!   module <LINK SRC="mpp.html">mpp_mod</LINK>, upon which it is built.
! </OVERVIEW>

! <DESCRIPTION>
!   Scalable implementations of finite-difference codes are generally
!   based on decomposing the model domain into subdomains that are
!   distributed among processors. These domains will then be obliged to
!   exchange data at their boundaries if data dependencies are merely
!   nearest-neighbour, or may need to acquire information from the global
!   domain if there are extended data dependencies, as in the spectral
!   transform. The domain decomposition is a key operation in the
!   development of parallel codes.
!   
!   <TT>mpp_domains_mod</TT> provides a domain decomposition and domain
!   update API for <I>rectilinear</I> grids, built on top of the <LINK
!   SRC="mpp.html">mpp_mod</LINK> API for message passing. Features
!   of <TT>mpp_domains_mod</TT> include:
! 
!   Simple, minimal API, with free access to underlying API for more complicated stuff.
!
!   Design toward typical use in climate/weather CFD codes.
!  
!   <H4>Domains</H4>
! 
!   I have assumed that domain decomposition will mainly be in 2
!   horizontal dimensions, which will in general be the two
!   fastest-varying indices. There is a separate implementation of 1D
!   decomposition on the fastest-varying index, and 1D decomposition on
!   the second index, treated as a special case of 2D decomposition, is
!   also possible. We define <I>domain</I> as the grid associated with a <I>task</I>.
!   We define the <I>compute domain</I> as the set of gridpoints that are
!   computed by a task, and the <I>data domain</I> as the set of points
!   that are required by the task for the calculation. There can in
!   general be more than 1 task per PE, though often
!   the number of domains is the same as the processor count. We define
!   the <I>global domain</I> as the global computational domain of the
!   entire model (i.e, the same as the computational domain if run on a
!   single processor). 2D domains are defined using a derived type <TT>domain2D</TT>,
!   constructed as follows (see comments in code for more details):
!   
!   <PRE>
!     type, public :: domain_axis_spec
!        private
!        integer :: begin, end, size, max_size
!        logical :: is_global
!     end type domain_axis_spec
!     type, public :: domain1D
!        private
!        type(domain_axis_spec) :: compute, data, global, active
!        logical :: mustputb, mustgetb, mustputf, mustgetf, folded
!        type(domain1D), pointer, dimension(:) :: list
!        integer :: pe              !PE to which this domain is assigned
!        integer :: pos
!     end type domain1D
!domaintypes of higher rank can be constructed from type domain1D
!typically we only need 1 and 2D, but could need higher (e.g 3D LES)
!some elements are repeated below if they are needed once per domain
!     type, public :: domain2D
!        private
!        type(domain1D) :: x
!        type(domain1D) :: y
!        type(domain2D), pointer, dimension(:) :: list
!        integer :: pe              !PE to which this domain is assigned
!        integer :: pos
!     end type domain2D
!     type(domain1D), public :: NULL_DOMAIN1D
!     type(domain2D), public :: NULL_DOMAIN2D
!   </PRE>

!   The <TT>domain2D</TT> type contains all the necessary information to
!   define the global, compute and data domains of each task, as well as the PE
!   associated with the task. The PEs from which remote data may be
!   acquired to update the data domain are also contained in a linked list
!   of neighbours.
! </DESCRIPTION>

module mpp_domains_mod
!a generalized domain decomposition package for use with mpp_mod
!Balaji (vb@gfdl.gov) 15 March 1999
#include <fms_platform.h>

#if defined(use_libMPI) && defined(sgi_mipspro)
  use mpi
#endif

  use mpp_parameter_mod,      only : MPP_DEBUG, MPP_VERBOSE, MPP_DOMAIN_TIME
  use mpp_parameter_mod,      only : GLOBAL_DATA_DOMAIN, CYCLIC_GLOBAL_DOMAIN, GLOBAL,CYCLIC 
  use mpp_parameter_mod,      only : AGRID, BGRID_SW, BGRID_NE, CGRID_NE, CGRID_SW, DGRID_NE, DGRID_SW
  use mpp_parameter_mod,      only : FOLD_WEST_EDGE, FOLD_EAST_EDGE, FOLD_SOUTH_EDGE, FOLD_NORTH_EDGE
  use mpp_parameter_mod,      only : WUPDATE, EUPDATE, SUPDATE, NUPDATE, XUPDATE, YUPDATE
  use mpp_parameter_mod,      only : NON_BITWISE_EXACT_SUM, BITWISE_EXACT_SUM, MPP_DOMAIN_TIME
  use mpp_parameter_mod,      only : CENTER, CORNER, SCALAR_PAIR, SCALAR_BIT, BITWISE_EFP_SUM
  use mpp_parameter_mod,      only : NORTH, NORTH_EAST, EAST, SOUTH_EAST
  use mpp_parameter_mod,      only : SOUTH, SOUTH_WEST, WEST, NORTH_WEST
  use mpp_parameter_mod,      only : MAX_DOMAIN_FIELDS, NULL_PE, DOMAIN_ID_BASE
  use mpp_parameter_mod,      only : ZERO, NINETY, MINUS_NINETY, ONE_HUNDRED_EIGHTY, MAX_TILES
  use mpp_parameter_mod,      only : EVENT_SEND, EVENT_RECV, ROOT_GLOBAL
  use mpp_parameter_mod,      only : NONBLOCK_UPDATE_TAG, EDGEONLY, EDGEUPDATE
  use mpp_data_mod,           only : mpp_domains_stack, ptr_domains_stack
  use mpp_data_mod,           only : mpp_domains_stack_nonblock, ptr_domains_stack_nonblock
  use mpp_mod,                only : mpp_pe, mpp_root_pe, mpp_npes, mpp_error, FATAL, WARNING, NOTE
  use mpp_mod,                only : stdout, stderr, stdlog, mpp_send, mpp_recv, mpp_transmit, mpp_sync_self
  use mpp_mod,                only : mpp_clock_id, mpp_clock_begin, mpp_clock_end
  use mpp_mod,                only : mpp_max, mpp_min, mpp_sum, mpp_get_current_pelist, mpp_broadcast
  use mpp_mod,                only : mpp_sync, mpp_init, mpp_malloc, lowercase
  use mpp_mod,                only : input_nml_file
  use mpp_mod,                only : COMM_TAG_1, COMM_TAG_2, COMM_TAG_3, COMM_TAG_4
  use mpp_memutils_mod,       only : mpp_memuse_begin, mpp_memuse_end
  use mpp_pset_mod,           only : mpp_pset_init
  use mpp_efp_mod,            only : mpp_reproducing_sum
  implicit none
  private

#if defined(use_libMPI) && !defined(sgi_mipspro)
#include <mpif.h>
!sgi_mipspro gets this from 'use mpi'
#endif

  !--- public paramters imported from mpp_domains_parameter_mod
  public :: GLOBAL_DATA_DOMAIN, CYCLIC_GLOBAL_DOMAIN, BGRID_NE, BGRID_SW, CGRID_NE, CGRID_SW
  public :: DGRID_NE, DGRID_SW, FOLD_WEST_EDGE, FOLD_EAST_EDGE, FOLD_SOUTH_EDGE, FOLD_NORTH_EDGE
  public :: WUPDATE, EUPDATE, SUPDATE, NUPDATE, XUPDATE, YUPDATE
  public :: NON_BITWISE_EXACT_SUM, BITWISE_EXACT_SUM, MPP_DOMAIN_TIME, BITWISE_EFP_SUM
  public :: CENTER, CORNER, SCALAR_PAIR
  public :: NORTH, NORTH_EAST, EAST, SOUTH_EAST
  public :: SOUTH, SOUTH_WEST, WEST, NORTH_WEST
  public :: ZERO, NINETY, MINUS_NINETY, ONE_HUNDRED_EIGHTY 
  public :: EDGEUPDATE

  !--- public data imported from mpp_data_mod
  public :: NULL_DOMAIN1D, NULL_DOMAIN2D

  public :: domain_axis_spec, domain1D, domain2D, DomainCommunicator2D
  public :: nest_domain_type, mpp_group_update_type

  !--- public interface from mpp_domains_util.h
  public :: mpp_domains_set_stack_size, mpp_get_compute_domain, mpp_get_compute_domains
  public :: mpp_get_data_domain, mpp_get_global_domain, mpp_get_domain_components
  public :: mpp_get_layout, mpp_get_pelist, operator(.EQ.), operator(.NE.) 
  public :: mpp_domain_is_symmetry, mpp_domain_is_initialized
  public :: mpp_get_neighbor_pe, mpp_nullify_domain_list
  public :: mpp_set_compute_domain, mpp_set_data_domain, mpp_set_global_domain
  public :: mpp_get_memory_domain, mpp_get_domain_shift, mpp_domain_is_tile_root_pe
  public :: mpp_get_tile_id, mpp_get_domain_extents, mpp_get_current_ntile, mpp_get_ntile_count
  public :: mpp_get_tile_list
  public :: mpp_get_tile_npes, mpp_get_domain_root_pe, mpp_get_tile_pelist, mpp_get_tile_compute_domains
  public :: mpp_get_num_overlap, mpp_get_overlap
  public :: mpp_get_io_domain, mpp_get_domain_pe, mpp_get_domain_tile_root_pe
  public :: mpp_get_domain_name, mpp_get_io_domain_layout
  public :: mpp_copy_domain, mpp_set_domain_symmetry
  public :: mpp_get_update_pelist, mpp_get_update_size
  public :: mpp_get_domain_npes, mpp_get_domain_pelist
  public :: mpp_clear_group_update
  public :: mpp_group_update_initialized, mpp_group_update_is_set

  !--- public interface from mpp_domains_reduce.h
  public :: mpp_global_field, mpp_global_max, mpp_global_min, mpp_global_sum
!  public :: mpp_global_sum_tl, mpp_global_sum_ad
  !--- public interface from mpp_domains_misc.h
  public :: mpp_broadcast_domain, mpp_domains_init, mpp_domains_exit, mpp_redistribute
  public :: mpp_update_domains, mpp_check_field
  public :: mpp_start_update_domains, mpp_complete_update_domains
  public :: mpp_create_group_update, mpp_do_group_update
  public :: mpp_start_group_update, mpp_complete_group_update
  public :: mpp_reset_group_update_field
  public :: mpp_update_nest_fine, mpp_update_nest_coarse
  public :: mpp_get_boundary
  !--- public interface from mpp_domains_define.h
  public :: mpp_define_layout, mpp_define_domains, mpp_modify_domain, mpp_define_mosaic
  public :: mpp_define_mosaic_pelist, mpp_define_null_domain, mpp_mosaic_defined
  public :: mpp_define_io_domain, mpp_deallocate_domain
  public :: mpp_compute_extent, mpp_compute_block_extent

  !--- public interface from mpp_define_domains.inc
  public :: mpp_define_nest_domains, mpp_get_C2F_index, mpp_get_F2C_index

  integer, parameter :: NAME_LENGTH = 64
  integer, parameter :: MAXLIST = 24
  integer, parameter :: MAXOVERLAP = 100
  integer, parameter :: FIELD_S = 0
  integer, parameter :: FIELD_X = 1
  integer, parameter :: FIELD_Y = 2


  !--- data types used mpp_domains_mod.
  type domain_axis_spec        !type used to specify index limits along an axis of a domain
     private
     integer :: begin, end, size, max_size      !start, end of domain axis, size, max size in set
     logical :: is_global       !TRUE if domain axis extent covers global domain
  end type domain_axis_spec

  type domain1D
     private
     type(domain_axis_spec) :: compute, data, global, memory
     logical :: cyclic
     type(domain1D), pointer :: list(:) =>NULL()
     integer :: pe               !PE to which this domain is assigned
     integer :: pos              !position of this PE within link list, i.e domain%list(pos)%pe = pe
     integer :: goffset, loffset !needed for global sum
  end type domain1D

  type domain1D_spec
     private
     type(domain_axis_spec) :: compute
     integer                :: pos
  end type domain1D_spec
       
  type domain2D_spec
     private
     type(domain1D_spec), pointer :: x(:)       => NULL() ! x-direction domain decomposition
     type(domain1D_spec), pointer :: y(:)       => NULL() ! x-direction domain decomposition
     integer,        pointer :: tile_id(:) => NULL() ! tile id of each tile
     integer                 :: pe                   ! PE to which this domain is assigned
     integer                 :: pos                  ! position of this PE within link list
     integer                 :: tile_root_pe         ! root pe of tile.
  end type domain2D_spec

  type overlap_type
     private
     integer                  :: count = 0                 ! number of ovrelapping
     integer                  :: pe
     integer                  :: start_pos                 ! start position in the buffer
     integer                  :: totsize                   ! all message size
     integer ,        pointer :: msgsize(:)      => NULL() ! overlapping msgsize to be sent or received
     integer,         pointer :: tileMe(:)       => NULL() ! my tile id for this overlap
     integer,         pointer :: tileNbr(:)      => NULL() ! neighbor tile id for this overlap
     integer,         pointer :: is(:)           => NULL() ! starting i-index 
     integer,         pointer :: ie(:)           => NULL() ! ending   i-index 
     integer,         pointer :: js(:)           => NULL() ! starting j-index 
     integer,         pointer :: je(:)           => NULL() ! ending   j-index 
     integer,         pointer :: dir(:)          => NULL() ! direction ( value 1,2,3,4 = E,S,W,N)
     integer,         pointer :: rotation(:)     => NULL() ! rotation angle.
     integer,         pointer :: index(:)        => NULL() ! for refinement
     logical,         pointer :: from_contact(:) => NULL() ! indicate if the overlap is computed from define_contact_overlap
  end type overlap_type

  type overlapSpec
     private
     integer                     :: whalo, ehalo, shalo, nhalo ! halo size
     integer                     :: xbegin, xend, ybegin, yend
     integer                     :: nsend, nrecv
     integer                     :: sendsize, recvsize
     type(overlap_type), pointer :: send(:) => NULL()
     type(overlap_type), pointer :: recv(:) => NULL()
     type(overlapSpec),  pointer :: next
  end type overlapSpec

  type tile_type
     integer :: xbegin, xend, ybegin, yend
  end type tile_type

!domaintypes of higher rank can be constructed from type domain1D
!typically we only need 1 and 2D, but could need higher (e.g 3D LES)
!some elements are repeated below if they are needed once per domain, not once per axis

  type domain2D
     private
     character(len=NAME_LENGTH)  :: name='unnamed'          ! name of the domain, default is "unspecified"
     integer(LONG_KIND)          :: id 
     integer                     :: pe                      ! PE to which this domain is assigned
     integer                     :: fold          
     integer                     :: pos                     ! position of this PE within link list
     logical                     :: symmetry                ! indicate the domain is symmetric or non-symmetric.
     integer                     :: whalo, ehalo            ! halo size in x-direction
     integer                     :: shalo, nhalo            ! halo size in y-direction
     integer                     :: ntiles                  ! number of tiles within mosaic
     integer                     :: max_ntile_pe            ! maximum value in the pelist of number of tiles on each pe.
     integer                     :: ncontacts               ! number of contact region within mosaic.
     logical                     :: rotated_ninety          ! indicate if any contact rotate NINETY or MINUS_NINETY
     logical                     :: initialized=.FALSE.     ! indicate if the overlapping is computed or not.
     integer                     :: tile_root_pe            ! root pe of current tile.
     integer                     :: io_layout(2)            ! io_layout, will be set through mpp_define_io_domain
                                                            ! default = domain layout
     integer,            pointer :: pearray(:,:)  => NULL() ! pe of each layout position 
     integer,            pointer :: tile_id(:)    => NULL() ! tile id of each tile
     type(domain1D),     pointer :: x(:)          => NULL() ! x-direction domain decomposition
     type(domain1D),     pointer :: y(:)          => NULL() ! y-direction domain decomposition
     type(domain2D_spec),pointer :: list(:)       => NULL() ! domain decomposition on pe list
     type(tile_type),    pointer :: tileList(:)   => NULL() ! store tile information
     type(overlapSpec),  pointer :: check_C       => NULL() ! send and recv information for boundary consistency check of C-cell
     type(overlapSpec),  pointer :: check_E       => NULL() ! send and recv information for boundary consistency check of E-cell
     type(overlapSpec),  pointer :: check_N       => NULL() ! send and recv information for boundary consistency check of N-cell
     type(overlapSpec),  pointer :: bound_C       => NULL() ! send information for getting boundary value for symmetry domain.
     type(overlapSpec),  pointer :: bound_E       => NULL() ! send information for getting boundary value for symmetry domain.
     type(overlapSpec),  pointer :: bound_N       => NULL() ! send information for getting boundary value for symmetry domain.
     type(overlapSpec),  pointer :: update_T      => NULL() ! send and recv information for halo update of T-cell.
     type(overlapSpec),  pointer :: update_E      => NULL() ! send and recv information for halo update of E-cell.
     type(overlapSpec),  pointer :: update_C      => NULL() ! send and recv information for halo update of C-cell.
     type(overlapSpec),  pointer :: update_N      => NULL() ! send and recv information for halo update of N-cell.
     type(domain2d),     pointer :: io_domain     => NULL() ! domain for IO, will be set through calling mpp_set_io_domain ( this will be changed).
  end type domain2D     

  !--- the following type is used to reprsent the contact between tiles.
  !--- this type will only be used in mpp_domains_define.inc
  type contact_type
     private
     integer          :: ncontact                               ! number of neighbor tile.
     integer, pointer :: tile(:) =>NULL()                      ! neighbor tile 
     integer, pointer :: align1(:)=>NULL(), align2(:)=>NULL()   ! alignment of me and neighbor
     real,    pointer :: refine1(:)=>NULL(), refine2(:)=>NULL() !
     integer, pointer :: is1(:)=>NULL(), ie1(:)=>NULL()         ! i-index of current tile repsenting contact
     integer, pointer :: js1(:)=>NULL(), je1(:)=>NULL()         ! j-index of current tile repsenting contact
     integer, pointer :: is2(:)=>NULL(), ie2(:)=>NULL()         ! i-index of neighbor tile repsenting contact
     integer, pointer :: js2(:)=>NULL(), je2(:)=>NULL()         ! j-index of neighbor tile repsenting contact
  end type contact_type


  type index_type
     integer :: is_me, ie_me, js_me, je_me
     integer :: is_you, ie_you, js_you, je_you
  end type index_type

  type nestSpec
     private
     integer                     :: xbegin, xend, ybegin, yend
     type(index_type)            :: west, east, south, north, center
     integer                     :: nsend, nrecv
     integer                     :: extra_halo
     type(overlap_type), pointer :: send(:) => NULL()
     type(overlap_type), pointer :: recv(:) => NULL()
     type(nestSpec),     pointer :: next

  end type nestSpec



  type nest_domain_type
     private
     integer                    :: tile_fine, tile_coarse
     integer                    :: istart_fine, iend_fine, jstart_fine, jend_fine
     integer                    :: istart_coarse, iend_coarse, jstart_coarse, jend_coarse
     integer                    :: x_refine, y_refine
     logical                    :: is_fine_pe, is_coarse_pe
     integer,           pointer :: pelist_fine(:) => NULL()
     integer,           pointer :: pelist_coarse(:) => NULL()
     character(len=NAME_LENGTH) :: name
     type(nestSpec), pointer :: C2F_T => NULL()
     type(nestSpec), pointer :: C2F_C => NULL()
     type(nestSpec), pointer :: C2F_E => NULL()
     type(nestSpec), pointer :: C2F_N => NULL()
     type(nestSpec), pointer :: F2C_T => NULL()
     type(nestSpec), pointer :: F2C_C => NULL()
     type(nestSpec), pointer :: F2C_E => NULL()
     type(nestSpec), pointer :: F2C_N => NULL()
     type(domain2d), pointer :: domain_fine   => NULL()
     type(domain2d), pointer :: domain_coarse => NULL()
  end type nest_domain_type



  type DomainCommunicator2D
     private
     logical            :: initialized=.false.
     integer(LONG_KIND) :: id=-9999
     integer(LONG_KIND) :: l_addr  =-9999
     integer(LONG_KIND) :: l_addrx =-9999
     integer(LONG_KIND) :: l_addry =-9999
     type(domain2D), pointer :: domain     =>NULL()
     type(domain2D), pointer :: domain_in  =>NULL()
     type(domain2D), pointer :: domain_out =>NULL()
     type(overlapSpec), pointer :: send(:,:,:,:) => NULL()
     type(overlapSpec), pointer :: recv(:,:,:,:) => NULL()
     integer, dimension(:,:),       _ALLOCATABLE :: sendis _NULL
     integer, dimension(:,:),       _ALLOCATABLE :: sendie _NULL
     integer, dimension(:,:),       _ALLOCATABLE :: sendjs _NULL
     integer, dimension(:,:),       _ALLOCATABLE :: sendje _NULL
     integer, dimension(:,:),       _ALLOCATABLE :: recvis _NULL
     integer, dimension(:,:),       _ALLOCATABLE :: recvie _NULL
     integer, dimension(:,:),       _ALLOCATABLE :: recvjs _NULL
     integer, dimension(:,:),       _ALLOCATABLE :: recvje _NULL
     logical, dimension(:),         _ALLOCATABLE :: S_do_buf _NULL
     logical, dimension(:),         _ALLOCATABLE :: R_do_buf _NULL
     integer, dimension(:),         _ALLOCATABLE :: cto_pe  _NULL
     integer, dimension(:),         _ALLOCATABLE :: cfrom_pe  _NULL
     integer, dimension(:),         _ALLOCATABLE :: S_msize _NULL
     integer, dimension(:),         _ALLOCATABLE :: R_msize _NULL
     integer :: Slist_size=0, Rlist_size=0
     integer :: isize=0, jsize=0, ke=0
     integer :: isize_in=0, jsize_in=0
     integer :: isize_out=0, jsize_out=0
     integer :: isize_max=0, jsize_max=0
     integer :: gf_ioff=0, gf_joff=0
  ! Remote data
     integer, dimension(:)  , _ALLOCATABLE :: isizeR _NULL
     integer, dimension(:)  , _ALLOCATABLE :: jsizeR _NULL
     integer, dimension(:,:), _ALLOCATABLE :: sendisR _NULL
     integer, dimension(:,:), _ALLOCATABLE :: sendjsR _NULL
     integer(LONG_KIND), dimension(:), _ALLOCATABLE :: rem_addr  _NULL
     integer(LONG_KIND), dimension(:), _ALLOCATABLE :: rem_addrx _NULL
     integer(LONG_KIND), dimension(:), _ALLOCATABLE :: rem_addry _NULL
     integer(LONG_KIND), dimension(:,:), _ALLOCATABLE :: rem_addrl  _NULL
     integer(LONG_KIND), dimension(:,:), _ALLOCATABLE :: rem_addrlx  _NULL
     integer(LONG_KIND), dimension(:,:), _ALLOCATABLE :: rem_addrly  _NULL
     integer                             :: position        ! data location. T, E, C, or N.
  end type DomainCommunicator2D

  integer, parameter :: MAX_REQUEST = 100

  type nonblock_type
     integer                         :: recv_pos
     integer                         :: send_pos
     integer                         :: recv_msgsize
     integer                         :: send_msgsize
     integer                         :: update_flags
     integer                         :: update_position
     integer                         :: update_gridtype
     integer                         :: update_whalo
     integer                         :: update_ehalo
     integer                         :: update_shalo
     integer                         :: update_nhalo
     integer                         :: request_send_count
     integer                         :: request_recv_count
     integer, dimension(MAX_REQUEST) :: request_send
     integer, dimension(MAX_REQUEST) :: request_recv
     integer, dimension(MAX_REQUEST) :: size_recv
     integer, dimension(MAX_REQUEST) :: type_recv
     integer, dimension(MAX_REQUEST) :: buffer_pos_send
     integer, dimension(MAX_REQUEST) :: buffer_pos_recv
     integer(LONG_KIND)              :: field_addrs(MAX_DOMAIN_FIELDS)
     integer(LONG_KIND)              :: field_addrs2(MAX_DOMAIN_FIELDS)
     integer                         :: nfields 
  end type nonblock_type

  type mpp_group_update_type
     private
     logical            :: initialized = .FALSE.
     logical            :: k_loop_inside = .TRUE.
     integer            :: nscalar = 0
     integer            :: nvector = 0
     integer            :: flags_s=0, flags_v=0
     integer            :: whalo_s=0, ehalo_s=0, shalo_s=0, nhalo_s=0
     integer            :: isize_s=0, jsize_s=0, ksize_s=1
     integer            :: whalo_v=0, ehalo_v=0, shalo_v=0, nhalo_v=0
     integer            :: isize_x=0, jsize_x=0, ksize_v=1
     integer            :: isize_y=0, jsize_y=0
     integer            :: position=0, gridtype=0
     logical            :: recv_s(8), recv_v(8)
     integer            :: is_s=0, ie_s=0, js_s=0, je_s=0
     integer            :: is_x=0, ie_x=0, js_x=0, je_x=0
     integer            :: is_y=0, ie_y=0, js_y=0, je_y=0
     integer            :: nrecv=0, nsend=0
     integer            :: npack=0, nunpack=0
     integer            :: reset_index_s = 0
     integer            :: reset_index_v = 0
     integer            :: tot_msgsize = 0
     integer            :: from_pe(MAXOVERLAP)
     integer            :: to_pe(MAXOVERLAP)
     integer            :: recv_size(MAXOVERLAP)
     integer            :: send_size(MAXOVERLAP)
     integer            :: buffer_pos_recv(MAXOVERLAP)
     integer            :: buffer_pos_send(MAXOVERLAP)
     integer            :: pack_type(MAXOVERLAP)
     integer            :: pack_buffer_pos(MAXOVERLAP)
     integer            :: pack_rotation(MAXOVERLAP)
     integer            :: pack_size(MAXOVERLAP)
     integer            :: pack_is(MAXOVERLAP)
     integer            :: pack_ie(MAXOVERLAP)
     integer            :: pack_js(MAXOVERLAP)
     integer            :: pack_je(MAXOVERLAP)
     integer            :: unpack_type(MAXOVERLAP)
     integer            :: unpack_buffer_pos(MAXOVERLAP)
     integer            :: unpack_rotation(MAXOVERLAP)
     integer            :: unpack_size(MAXOVERLAP)
     integer            :: unpack_is(MAXOVERLAP)
     integer            :: unpack_ie(MAXOVERLAP)
     integer            :: unpack_js(MAXOVERLAP)
     integer            :: unpack_je(MAXOVERLAP)
     integer(LONG_KIND) :: addrs_s(MAX_DOMAIN_FIELDS)
     integer(LONG_KIND) :: addrs_x(MAX_DOMAIN_FIELDS)
     integer(LONG_KIND) :: addrs_y(MAX_DOMAIN_FIELDS)
     integer            :: buffer_start_pos = -1
     integer            :: request_send(MAX_REQUEST)
     integer            :: request_recv(MAX_REQUEST)
     integer            :: type_recv(MAX_REQUEST)
  end type mpp_group_update_type

!#######################################################################

!***********************************************************************
!
!     module variables 
!
!***********************************************************************
  integer              :: pe
  logical              :: module_is_initialized = .false.
  logical              :: debug                 = .FALSE.
  logical              :: verbose=.FALSE.
  logical              :: mosaic_defined = .false.
  integer              :: mpp_domains_stack_size=0
  integer              :: mpp_domains_stack_hwm=0
  type(domain1D),save  :: NULL_DOMAIN1D
  type(domain2D),save  :: NULL_DOMAIN2D
  integer              :: current_id_update = 0
  integer                         :: num_update = 0
  integer                         :: num_nonblock_group_update = 0
  integer                         :: nonblock_buffer_pos = 0
  integer                         :: nonblock_group_buffer_pos = 0
  logical                         :: start_update = .true.
  logical                         :: complete_update = .false.
  type(nonblock_type), allocatable :: nonblock_data(:)
  integer, parameter              :: MAX_NONBLOCK_UPDATE = 100

  integer                         :: group_update_buffer_pos = 0
  logical                         :: complete_group_update_on = .false.
  !-------- The following variables are used in mpp_domains_comm.h
  
  integer, parameter :: MAX_ADDRS=512
  integer(LONG_KIND),dimension(MAX_ADDRS),save :: addrs_sorted=-9999  ! list of sorted local addrs
  integer,           dimension(-1:MAX_ADDRS),save :: addrs_idx=-9999  ! idx of addr assoicated w/ d_comm
  integer,           dimension(MAX_ADDRS),save :: a_salvage=-9999     ! freed idx list of addr
  integer,                                save :: a_sort_len=0        ! len sorted memory list
  integer,                                save :: n_addrs=0           ! num memory addresses used

  integer(LONG_KIND), parameter :: ADDR2_BASE=Z'0000000000010000'
  integer, parameter :: MAX_ADDRS2=128
  integer(LONG_KIND),dimension(MAX_ADDRS2),save :: addrs2_sorted=-9999  ! list of sorted local addrs
  integer,           dimension(-1:MAX_ADDRS2),save :: addrs2_idx=-9999  ! idx of addr2 assoicated w/ d_comm
  integer,           dimension(MAX_ADDRS2),save :: a2_salvage=-9999     ! freed indices of addr2
  integer,                                 save :: a2_sort_len=0        ! len sorted memory list
  integer,                                 save :: n_addrs2=0           ! num memory addresses used

  integer, parameter :: MAX_DOM_IDS=128
  integer(LONG_KIND),dimension(MAX_DOM_IDS),save :: ids_sorted=-9999 ! list of sorted domain identifiers
  integer,           dimension(-1:MAX_DOM_IDS),save :: ids_idx=-9999 ! idx of d_comm associated w/ sorted addr
  integer,                                  save :: i_sort_len=0     ! len sorted domain ids list
  integer,                                  save :: n_ids=0          ! num domain ids used (=i_sort_len; dom ids never removed)

  integer, parameter :: MAX_FIELDS=1024
  integer(LONG_KIND),        dimension(MAX_FIELDS),save           :: dcKey_sorted=-9999  ! list of sorted local addrs
  !     Not sure why static d_comm fails during deallocation of derived type members; allocatable works
  !     type(DomainCommunicator2D),dimension(MAX_FIELDS),save,target    :: d_comm              ! domain communicators
  type(DomainCommunicator2D),dimension(:),allocatable,save,target :: d_comm              ! domain communicators
  integer,                   dimension(-1:MAX_FIELDS),save           :: d_comm_idx=-9999 ! idx of d_comm associated w/ sorted addr
  integer,                   dimension(MAX_FIELDS),save           :: dc_salvage=-9999    ! freed indices of d_comm
  integer,                                         save           :: dc_sort_len=0       ! len sorted comm keys (=num active communicators)
  integer,                                         save           :: n_comm=0            ! num communicators used

  !     integer(LONG_KIND), parameter :: GT_BASE=2**8
  integer(LONG_KIND), parameter :: GT_BASE=Z'0000000000000100'  ! Workaround for 64bit int init problem

  !     integer(LONG_KIND), parameter :: KE_BASE=2**48
  integer(LONG_KIND), parameter :: KE_BASE=Z'0001000000000000'  ! Workaround for 64bit int init problem

  integer(LONG_KIND) :: domain_cnt=0

  !--- the following variables are used in mpp_domains_misc.h
  logical :: domain_clocks_on=.FALSE.
  integer :: send_clock=0, recv_clock=0, unpk_clock=0
  integer :: wait_clock=0, pack_clock=0
  integer :: send_pack_clock_nonblock=0, recv_clock_nonblock=0, unpk_clock_nonblock=0
  integer :: wait_clock_nonblock=0  
  integer :: nest_send_clock=0, nest_recv_clock=0, nest_unpk_clock=0
  integer :: nest_wait_clock=0, nest_pack_clock=0
  integer :: group_recv_clock=0, group_send_clock=0, group_pack_clock=0, group_unpk_clock=0, group_wait_clock=0
  integer :: nonblock_group_recv_clock=0, nonblock_group_send_clock=0, nonblock_group_pack_clock=0
  integer :: nonblock_group_unpk_clock=0, nonblock_group_wait_clock=0

  !--- namelist interface
! <NAMELIST NAME="mpp_domains_nml">
!   <DATA NAME="debug_update_domain" TYPE="character(len=32)"  DEFAULT="none">
!     when debug_update_domain = none, no debug will be done. When debug_update_domain is set to fatal, 
!     the run will be exited with fatal error message. When debug_update_domain is set to 
!     warning, the run will output warning message. when debug update_domain is set to 
!     note, the run will output some note message. Will check the consistency on the boundary between
!     processor/tile when updating doamin for symmetric domain and check the consistency on the north
!     folded edge. 
!   </DATA>
!   <DATA NAME="efp_sum_overflow_check" TYPE="logical" DEFAULT=".FALSE.">
!     Set true to always do overflow_check when doing EFP bitwise mpp_global_sum. 
!   </DATA>
!   <DATA NAME="nthread_control_loop" TYPE="integer"  DEFAULT="4">
!     Determine the loop order for packing and unpacking. When number of threads is greater than nthread_control_loop,
!     k-loop will be moved outside and combined with number of pack and unpack. When number of threads is less 
!     than or equal to nthread_control_loop, k-loop is moved inside but still outside of j,i loop.
!   </DATA>
! </NAMELIST>
  character(len=32) :: debug_update_domain = "none"
  logical           :: debug_message_passing = .false.
  integer           :: nthread_control_loop = 4
  logical           :: efp_sum_overflow_check = .false.
  namelist /mpp_domains_nml/ debug_update_domain, domain_clocks_on, debug_message_passing, nthread_control_loop, &
                             efp_sum_overflow_check

  !***********************************************************************

  integer, parameter :: NO_CHECK = -1
  integer            :: debug_update_level = NO_CHECK
!***********************************************************************
!
!         public interface from mpp_domains_define.h
!
!***********************************************************************

  ! <INTERFACE NAME="mpp_define_layout">
  !  <OVERVIEW>
  !    Retrieve layout associated with a domain decomposition.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    Given a global 2D domain and the number of divisions in the
  !    decomposition (<TT>ndivs</TT>: usually the PE count unless some
  !    domains are masked) this calls returns a 2D domain layout.
  !    
  !    By default, <TT>mpp_define_layout</TT> will attempt to divide the
  !    2D index space into domains that maintain the aspect ratio of the
  !    global domain. If this cannot be done, the algorithm favours domains
  !    that are longer in <TT>x</TT> than <TT>y</TT>, a preference that could
  !    improve vector performance.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_define_layout( global_indices, ndivs, layout )
  !  </TEMPLATE>
  !  <IN NAME="global_indices"></IN>
  !  <IN NAME="ndivs"></IN>
  !  <OUT NAME="layout"></OUT>
  ! </INTERFACE>

  interface mpp_define_layout
     module procedure mpp_define_layout2D
  end interface


  ! <INTERFACE NAME="mpp_define_domains">

  !   <OVERVIEW>
  !     Set up a domain decomposition.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     There are two forms for the <TT>mpp_define_domains</TT> call. The 2D
  !     version is generally to be used but is built by repeated calls to the
  !     1D version, also provided.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call mpp_define_domains( global_indices, ndivs, domain, &
  !                                   pelist, flags, halo, extent, maskmap )
  !   </TEMPLATE>
  !  <TEMPLATE>
  !    call mpp_define_domains( global_indices, layout, domain, pelist, &
  !                                   xflags, yflags, xhalo, yhalo,           &
  !                                   xextent, yextent, maskmap, name )
  !  </TEMPLATE>
  !   <IN NAME="global_indices" >
  !     Defines the global domain.
  !   </IN>
  !   <IN NAME="ndivs">
  !     Is the number of domain divisions required.
  !   </IN>
  !   <INOUT NAME="domain">
  !     Holds the resulting domain decomposition.
  !   </INOUT>
  !   <IN NAME="pelist">
  !     List of PEs to which the domains are to be assigned.
  !   </IN>
  !   <IN NAME="flags">
  !      An optional flag to pass additional information
  !      about the desired domain topology. Useful flags in a 1D decomposition
  !      include <TT>GLOBAL_DATA_DOMAIN</TT> and
  !      <TT>CYCLIC_GLOBAL_DOMAIN</TT>. Flags are integers: multiple flags may
  !      be added together. The flag values are public parameters available by
  !      use association.
  !   </IN>
  !   <IN NAME="halo">
  !     Width of the halo.
  !   </IN>
  !   <IN NAME="extent">
  !      Normally <TT>mpp_define_domains</TT> attempts
  !      an even division of the global domain across <TT>ndivs</TT>
  !      domains. The <TT>extent</TT> array can be used by the user to pass a
  !      custom domain division. The <TT>extent</TT> array has <TT>ndivs</TT>
  !      elements and holds the compute domain widths, which should add up to
  !      cover the global domain exactly.
  !   </IN>
  !   <IN NAME="maskmap">
  !     Some divisions may be masked
  !     (<TT>maskmap=.FALSE.</TT>) to exclude them from the computation (e.g
  !     for ocean model domains that are all land). The <TT>maskmap</TT> array
  !     is dimensioned <TT>ndivs</TT> and contains <TT>.TRUE.</TT> values for
  !     any domain that must be <I>included</I> in the computation (default
  !     all). The <TT>pelist</TT> array length should match the number of
  !     domains included in the computation.
  !    </IN>   

  !  <IN NAME="layout"></IN>
  !  <IN NAME="xflags, yflags"></IN>
  !  <IN NAME="xhalo, yhalo"></IN>
  !  <IN NAME="xextent, yextent"></IN>
  !  <IN NAME="name" ></IN>

  !  <NOTE>    
  !    For example:
  !    
  !    <PRE>
  !    call mpp_define_domains( (/1,100/), 10, domain, &
  !         flags=GLOBAL_DATA_DOMAIN+CYCLIC_GLOBAL_DOMAIN, halo=2 )
  !    </PRE>
  !    
  !    defines 10 compute domains spanning the range [1,100] of the global
  !    domain. The compute domains are non-overlapping blocks of 10. All the data
  !    domains are global, and with a halo of 2 span the range [-1:102]. And
  !    since the global domain has been declared to be cyclic,
  !    <TT>domain(9)%next => domain(0)</TT> and <TT>domain(0)%prev =>
  !    domain(9)</TT>. A field is allocated on the data domain, and computations proceed on
  !    the compute domain. A call to <LINK
  !    SRC="#mpp_update_domains"><TT>mpp_update_domains</TT></LINK> would fill in
  !    the values in the halo region:

  !    <PRE>
  !    call mpp_get_data_domain( domain, isd, ied ) !returns -1 and 102
  !    call mpp_get_compute_domain( domain, is, ie ) !returns (1,10) on PE 0 ...
  !    allocate( a(isd:ied) )
  !    do i = is,ie
  !       a(i) = &lt;perform computations&gt;
  !    end do
  !    call mpp_update_domains( a, domain )
  !    </PRE>

  !    The call to <TT>mpp_update_domains</TT> fills in the regions outside
  !    the compute domain. Since the global domain is cyclic, the values at
  !    <TT>i=(-1,0)</TT> are the same as at <TT>i=(99,100)</TT>; and
  !    <TT>i=(101,102)</TT> are the same as <TT>i=(1,2)</TT>.
  !    
  !    The 2D version is just an extension of this syntax to two
  !    dimensions.
  !
  !    The 2D version of the above should generally be used in
  !    codes, including 1D-decomposed ones, if there is a possibility of
  !    future evolution toward 2D decomposition. The arguments are similar to
  !    the 1D case, except that now we have optional arguments
  !    <TT>flags</TT>, <TT>halo</TT>, <TT>extent</TT> and <TT>maskmap</TT>
  !    along two axes.
  !    
  !    <TT>flags</TT> can now take an additional possible value to fold
  !    one or more edges. This is done by using flags
  !    <TT>FOLD_WEST_EDGE</TT>, <TT>FOLD_EAST_EDGE</TT>,
  !    <TT>FOLD_SOUTH_EDGE</TT> or <TT>FOLD_NORTH_EDGE</TT>. When a fold
  !    exists (e.g cylindrical domain), vector fields reverse sign upon
  !    crossing the fold. This parity reversal is performed only in the
  !    vector version of <LINK
  !    SRC="#mpp_update_domains"><TT>mpp_update_domains</TT></LINK>. In
  !    addition, shift operations may need to be applied to vector fields on
  !    staggered grids, also described in the vector interface to
  !    <TT>mpp_update_domains</TT>.
  !    
  !    <TT>name</TT> is the name associated with the decomposition,
  !    e.g <TT>'Ocean model'</TT>. If this argument is present,
  !    <TT>mpp_define_domains</TT> will print the domain decomposition
  !    generated to <TT>stdlog</TT>.
  !    
  !    Examples:
  !    
  !    <PRE>
  !    call mpp_define_domains( (/1,100,1,100/), (/2,2/), domain, xhalo=1 )
  !    </PRE>
  !    
  !    will create the following domain layout:
  !    <PRE>
  !                   |---------|-----------|-----------|-------------|
  !                   |domain(1)|domain(2)  |domain(3)  |domain(4)    |
  !    |--------------|---------|-----------|-----------|-------------|
  !    |Compute domain|1,50,1,50|51,100,1,50|1,50,51,100|51,100,51,100|
  !    |--------------|---------|-----------|-----------|-------------|
  !    |Data domain   |0,51,1,50|50,101,1,50|0,51,51,100|50,101,51,100|
  !    |--------------|---------|-----------|-----------|-------------|
  !    </PRE>
  !    
  !    Again, we allocate arrays on the data domain, perform computations
  !    on the compute domain, and call <TT>mpp_update_domains</TT> to update
  !    the halo region.
  !    
  !    If we wished to perfom a 1D decomposition along <TT>Y</TT>
  !    on the same global domain, we could use:

  !    <PRE>
  !    call mpp_define_domains( (/1,100,1,100/), layout=(/4,1/), domain, xhalo=1 )
  !    </PRE>

  !    This will create the following domain layout:
  !    <PRE>
  !                   |----------|-----------|-----------|------------|
  !                   |domain(1) |domain(2)  |domain(3)  |domain(4)   |
  !    |--------------|----------|-----------|-----------|------------|
  !    |Compute domain|1,100,1,25|1,100,26,50|1,100,51,75|1,100,76,100|
  !    |--------------|----------|-----------|-----------|------------|
  !    |Data domain   |0,101,1,25|0,101,26,50|0,101,51,75|1,101,76,100|
  !    |--------------|----------|-----------|-----------|------------|
  !    </PRE>
  !   </NOTE>
  ! </INTERFACE>
  interface mpp_define_domains
     module procedure mpp_define_domains1D
     module procedure mpp_define_domains2D
  end interface

  interface mpp_define_null_domain
     module procedure mpp_define_null_domain1D
     module procedure mpp_define_null_domain2D
  end interface

  interface mpp_copy_domain
     module procedure mpp_copy_domain1D
     module procedure mpp_copy_domain2D
  end interface mpp_copy_domain

  interface mpp_deallocate_domain 
     module procedure mpp_deallocate_domain1D
     module procedure mpp_deallocate_domain2D
  end interface

! <INTERFACE NAME="mpp_modify_domain">
!   <OVERVIEW>
!     modifies the extents (compute, data and global) of domain
!   </OVERVIEW>
!   <IN NAME="domain_in">
!     The source domain.
!   </IN>
!   <IN NAME="halo">
!     Halo size of the returned 1D doamin. Default value is 0.
!   </IN>
!   <IN NAME="cbegin,cend">
!    Axis specifications associated with the compute domain of the returned 1D domain.
!   </IN>
!   <IN NAME="gbegin,gend">
!    Axis specifications associated with the global domain of the returned 1D domain.
!   </IN>
!   <IN NAME="isc,iec">
!    Zonal axis specifications associated with the compute domain of the returned 2D domain.
!   </IN>
!   <IN NAME="jsc,jec">
!    Meridinal axis specifications associated with the compute domain of the returned 2D domain.
!   </IN>
!   <IN NAME="isg,ieg">
!    Zonal axis specifications associated with the global domain of the returned 2D domain.
!   </IN>
!   <IN NAME="jsg,jeg">
!    Meridinal axis specifications associated with the global domain of the returned 2D domain.
!   </IN>
!   <IN NAME="xhalo,yhalo">
!     Halo size of the returned 2D doamin. Default value is 0.
!   </IN>
!   <INOUT NAME="domain_out">
!     The returned domain.
!   </INOUT>

! </INTERFACE>

  interface mpp_modify_domain
     module procedure mpp_modify_domain1D
     module procedure mpp_modify_domain2D
  end interface


!***********************************************************************
!
!        public interface from mpp_domains_misc.h
!
!***********************************************************************

! <INTERFACE NAME="mpp_update_domains">
!  <OVERVIEW>
!     Halo updates.
!  </OVERVIEW>
!  <DESCRIPTION>
!    <TT>mpp_update_domains</TT> is used to perform a halo update of a
!    domain-decomposed array on each PE. <TT>MPP_TYPE_</TT> can be of type
!    <TT>complex</TT>, <TT>integer</TT>, <TT>logical</TT> or <TT>real</TT>;
!    of 4-byte or 8-byte kind; of rank up to 5. The vector version (with
!    two input data fields) is only present for <TT>real</TT> types.
!    
!    For 2D domain updates, if there are halos present along both
!    <TT>x</TT> and <TT>y</TT>, we can choose to update one only, by
!    specifying <TT>flags=XUPDATE</TT> or <TT>flags=YUPDATE</TT>. In
!    addition, one-sided updates can be performed by setting <TT>flags</TT>
!    to any combination of <TT>WUPDATE</TT>, <TT>EUPDATE</TT>,
!    <TT>SUPDATE</TT> and <TT>NUPDATE</TT>, to update the west, east, north
!    and south halos respectively. Any combination of halos may be used by
!    adding the requisite flags, e.g: <TT>flags=XUPDATE+SUPDATE</TT> or
!    <TT>flags=EUPDATE+WUPDATE+SUPDATE</TT> will update the east, west and
!    south halos.
!    
!    If a call to <TT>mpp_update_domains</TT> involves at least one E-W
!    halo and one N-S halo, the corners involved will also be updated, i.e,
!    in the example above, the SE and SW corners will be updated.
!    
!    If <TT>flags</TT> is not supplied, that is
!    equivalent to <TT>flags=XUPDATE+YUPDATE</TT>.
!    
!    The vector version is passed the <TT>x</TT> and <TT>y</TT>
!    components of a vector field in tandem, and both are updated upon
!    return. They are passed together to treat parity issues on various
!    grids. For example, on a cubic sphere projection, the <TT>x</TT> and
!    <TT>y</TT> components may be interchanged when passing from an
!    equatorial cube face to a polar face. For grids with folds, vector
!    components change sign on crossing the fold.  Paired scalar quantities
!    can also be passed with the vector version if flags=SCALAR_PAIR, in which
!    case components are appropriately interchanged, but signs are not.
!    
!    Special treatment at boundaries such as folds is also required for
!    staggered grids. The following types of staggered grids are
!    recognized:
!    
!    1) <TT>AGRID</TT>: values are at grid centers.<BR/>
!    2) <TT>BGRID_NE</TT>: vector fields are at the NE vertex of a grid
!    cell, i.e: the array elements <TT>u(i,j)</TT> and <TT>v(i,j)</TT> are
!    actually at (i+&#189;,j+&#189;) with respect to the grid centers.<BR/>
!    3) <TT>BGRID_SW</TT>: vector fields are at the SW vertex of a grid
!    cell, i.e: the array elements <TT>u(i,j)</TT> and <TT>v(i,j)</TT> are
!    actually at (i-&#189;,j-&#189;) with respect to the grid centers.<BR/>
!    4) <TT>CGRID_NE</TT>: vector fields are at the N and E faces of a
!    grid cell, i.e: the array elements <TT>u(i,j)</TT> and <TT>v(i,j)</TT>
!    are actually at (i+&#189;,j) and (i,j+&#189;) with respect to the
!    grid centers.<BR/>
!    5) <TT>CGRID_SW</TT>: vector fields are at the S and W faces of a
!    grid cell, i.e: the array elements <TT>u(i,j)</TT> and <TT>v(i,j)</TT>
!    are actually at (i-&#189;,j) and (i,j-&#189;) with respect to the
!    grid centers.
!
!    The gridtypes listed above are all available by use association as
!    integer parameters. The scalar version of <TT>mpp_update_domains</TT>
!    assumes that the values of a scalar field are always at <TT>AGRID</TT>
!    locations, and no special boundary treatment is required. If vector
!    fields are at staggered locations, the optional argument
!    <TT>gridtype</TT> must be appropriately set for correct treatment at
!    boundaries.
!    
!    It is safe to apply vector field updates to the appropriate arrays
!    irrespective of the domain topology: if the topology requires no
!    special treatment of vector fields, specifying <TT>gridtype</TT> will
!    do no harm.
!
!    <TT>mpp_update_domains</TT> internally buffers the date being sent
!    and received into single messages for efficiency. A turnable internal
!    buffer area in memory is provided for this purpose by
!    <TT>mpp_domains_mod</TT>. The size of this buffer area can be set by
!    the user by calling <LINK SRC="mpp_domains.html#mpp_domains_set_stack_size">
!    <TT>mpp_domains_set_stack_size</TT></LINK>.
!  </DESCRIPTION>
!  <TEMPLATE>
!    call mpp_update_domains( field, domain, flags )
!  </TEMPLATE>
!  <TEMPLATE>
!    call mpp_update_domains( fieldx, fieldy, domain, flags, gridtype )
!  </TEMPLATE>
! </INTERFACE>
  interface mpp_update_domains
     module procedure mpp_update_domain2D_r8_2d
     module procedure mpp_update_domain2D_r8_3d
     module procedure mpp_update_domain2D_r8_4d
     module procedure mpp_update_domain2D_r8_5d
     module procedure mpp_update_domain2D_r8_2dv
     module procedure mpp_update_domain2D_r8_3dv
     module procedure mpp_update_domain2D_r8_4dv
     module procedure mpp_update_domain2D_r8_5dv
#ifdef OVERLOAD_C8
     module procedure mpp_update_domain2D_c8_2d
     module procedure mpp_update_domain2D_c8_3d
     module procedure mpp_update_domain2D_c8_4d
     module procedure mpp_update_domain2D_c8_5d
#endif
#ifndef no_8byte_integers
     module procedure mpp_update_domain2D_i8_2d
     module procedure mpp_update_domain2D_i8_3d
     module procedure mpp_update_domain2D_i8_4d
     module procedure mpp_update_domain2D_i8_5d
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_update_domain2D_r4_2d
     module procedure mpp_update_domain2D_r4_3d
     module procedure mpp_update_domain2D_r4_4d
     module procedure mpp_update_domain2D_r4_5d
     module procedure mpp_update_domain2D_r4_2dv
     module procedure mpp_update_domain2D_r4_3dv
     module procedure mpp_update_domain2D_r4_4dv
     module procedure mpp_update_domain2D_r4_5dv
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_update_domain2D_c4_2d
     module procedure mpp_update_domain2D_c4_3d
     module procedure mpp_update_domain2D_c4_4d
     module procedure mpp_update_domain2D_c4_5d
#endif
     module procedure mpp_update_domain2D_i4_2d
     module procedure mpp_update_domain2D_i4_3d
     module procedure mpp_update_domain2D_i4_4d
     module procedure mpp_update_domain2D_i4_5d
  end interface

! <INTERFACE NAME="mpp_start_update_domains/mpp_complete_update_domains">
!  <OVERVIEW>
!     Interface to start halo updates.
!  </OVERVIEW>
!  <DESCRIPTION>
!    <TT>mpp_start_update_domains</TT> is used to start a halo update of a
!    domain-decomposed array on each PE. <TT>MPP_TYPE_</TT> can be of type
!    <TT>complex</TT>, <TT>integer</TT>, <TT>logical</TT> or <TT>real</TT>;
!    of 4-byte or 8-byte kind; of rank up to 5. The vector version (with
!    two input data fields) is only present for <TT>real</TT> types.
!    
!    <TT>mpp_start_update_domains</TT> must be paired together with 
!    <TT>mpp_complete_update_domains</TT>. In <TT>mpp_start_update_domains</TT>,
!    a buffer will be pre-post to receive (non-blocking) the 
!    data and data on computational domain will be packed and sent (non-blocking send)
!    to other processor. In <TT>mpp_complete_update_domains</TT>, buffer will
!    be unpacked to fill the halo and mpp_sync_self will be called to 
!    to ensure communication safe at the last call of mpp_complete_update_domains.
!
!    Each mpp_update_domains can be replaced by the combination of mpp_start_update_domains
!    and mpp_complete_update_domains. The arguments in mpp_start_update_domains
!    and mpp_complete_update_domains should be the exact the same as in 
!    mpp_update_domains to be replaced except no optional argument "complete". 
!    The following are examples on how to replace mpp_update_domains with
!    mpp_start_update_domains/mpp_complete_update_domains
!    
!    Example 1: Replace one scalar mpp_update_domains.
!
!    Replace 
!    
!        call mpp_update_domains(data, domain, flags=update_flags)
!
!    with
!
!        id_update = mpp_start_update_domains(data, domain, flags=update_flags)<BR/>
!        ...( doing some computation )<BR/>
!        call mpp_complete_update_domains(id_update, data, domain, flags=update_flags)<BR/>
!<BR/>
!    Example 2: Replace group scalar mpp_update_domains,
!
!    Replace
!    
!        call mpp_update_domains(data_1, domain, flags=update_flags, complete=.false.)<BR/>
!        .... ( other n-2 call mpp_update_domains with complete = .false. )<BR/>
!        call mpp_update_domains(data_n, domain, flags=update_flags, complete=.true. )<BR/>
!<BR/>
!    With
!
!        id_up_1 = mpp_start_update_domains(data_1, domain, flags=update_flags)<BR/>
!        .... ( other n-2 call mpp_start_update_domains )<BR/>
!        id_up_n = mpp_start_update_domains(data_n, domain, flags=update_flags)<BR/>
!
!        ..... ( doing some computation )
!
!        call mpp_complete_update_domains(id_up_1, data_1, domain, flags=update_flags)<BR/>
!        .... ( other n-2 call mpp_complete_update_domains  )<BR/>
!        call mpp_complete_update_domains(id_up_n, data_n, domain, flags=update_flags)<BR/>
!<BR/>
!    Example 3: Replace group CGRID_NE vector, mpp_update_domains
!
!    Replace
!    
!        call mpp_update_domains(u_1, v_1, domain, flags=update_flgs, gridtype=CGRID_NE, complete=.false.)<BR/>
!        .... ( other n-2 call mpp_update_domains with complete = .false. )<BR/>
!        call mpp_update_domains(u_1, v_1, domain, flags=update_flags, gridtype=CGRID_NE, complete=.true. )<BR/>
!<BR/>
!    with
!
!        id_up_1 = mpp_start_update_domains(u_1, v_1, domain, flags=update_flags, gridtype=CGRID_NE)<BR/>
!        .... ( other n-2 call mpp_start_update_domains )<BR/>
!        id_up_n = mpp_start_update_domains(u_n, v_n, domain, flags=update_flags, gridtype=CGRID_NE)<BR/>
!<BR/>
!        ..... ( doing some computation )
!
!        call mpp_complete_update_domains(id_up_1, u_1, v_1, domain, flags=update_flags, gridtype=CGRID_NE)<BR/>
!        .... ( other n-2 call mpp_complete_update_domains  )<BR/>
!        call mpp_complete_update_domains(id_up_n, u_n, v_n, domain, flags=update_flags, gridtype=CGRID_NE)<BR/>
! <BR/>
!    For 2D domain updates, if there are halos present along both
!    <TT>x</TT> and <TT>y</TT>, we can choose to update one only, by
!    specifying <TT>flags=XUPDATE</TT> or <TT>flags=YUPDATE</TT>. In
!    addition, one-sided updates can be performed by setting <TT>flags</TT>
!    to any combination of <TT>WUPDATE</TT>, <TT>EUPDATE</TT>,
!    <TT>SUPDATE</TT> and <TT>NUPDATE</TT>, to update the west, east, north
!    and south halos respectively. Any combination of halos may be used by
!    adding the requisite flags, e.g: <TT>flags=XUPDATE+SUPDATE</TT> or
!    <TT>flags=EUPDATE+WUPDATE+SUPDATE</TT> will update the east, west and
!    south halos.
!    
!    If a call to <TT>mpp_start_update_domains/mpp_complete_update_domains</TT> involves at least one E-W
!    halo and one N-S halo, the corners involved will also be updated, i.e,
!    in the example above, the SE and SW corners will be updated.
!    
!    If <TT>flags</TT> is not supplied, that is
!    equivalent to <TT>flags=XUPDATE+YUPDATE</TT>.
!    
!    The vector version is passed the <TT>x</TT> and <TT>y</TT>
!    components of a vector field in tandem, and both are updated upon
!    return. They are passed together to treat parity issues on various
!    grids. For example, on a cubic sphere projection, the <TT>x</TT> and
!    <TT>y</TT> components may be interchanged when passing from an
!    equatorial cube face to a polar face. For grids with folds, vector
!    components change sign on crossing the fold.  Paired scalar quantities
!    can also be passed with the vector version if flags=SCALAR_PAIR, in which
!    case components are appropriately interchanged, but signs are not.
!    
!    Special treatment at boundaries such as folds is also required for
!    staggered grids. The following types of staggered grids are
!    recognized:
!    
!    1) <TT>AGRID</TT>: values are at grid centers.<BR/>
!    2) <TT>BGRID_NE</TT>: vector fields are at the NE vertex of a grid
!    cell, i.e: the array elements <TT>u(i,j)</TT> and <TT>v(i,j)</TT> are
!    actually at (i+&#189;,j+&#189;) with respect to the grid centers.<BR/>
!    3) <TT>BGRID_SW</TT>: vector fields are at the SW vertex of a grid
!    cell, i.e: the array elements <TT>u(i,j)</TT> and <TT>v(i,j)</TT> are
!    actually at (i-&#189;,j-&#189;) with respect to the grid centers.<BR/>
!    4) <TT>CGRID_NE</TT>: vector fields are at the N and E faces of a
!    grid cell, i.e: the array elements <TT>u(i,j)</TT> and <TT>v(i,j)</TT>
!    are actually at (i+&#189;,j) and (i,j+&#189;) with respect to the
!    grid centers.<BR/>
!    5) <TT>CGRID_SW</TT>: vector fields are at the S and W faces of a
!    grid cell, i.e: the array elements <TT>u(i,j)</TT> and <TT>v(i,j)</TT>
!    are actually at (i-&#189;,j) and (i,j-&#189;) with respect to the
!    grid centers.
!
!    The gridtypes listed above are all available by use association as
!    integer parameters. If vector fields are at staggered locations, the 
!    optional argument <TT>gridtype</TT> must be appropriately set for 
!    correct treatment at boundaries.
!    
!    It is safe to apply vector field updates to the appropriate arrays
!    irrespective of the domain topology: if the topology requires no
!    special treatment of vector fields, specifying <TT>gridtype</TT> will
!    do no harm.
!
!    <TT>mpp_start_update_domains/mpp_complete_update_domains</TT> internally 
!    buffers the data being sent and received into single messages for efficiency. 
!    A turnable internal buffer area in memory is provided for this purpose by
!    <TT>mpp_domains_mod</TT>. The size of this buffer area can be set by
!    the user by calling <LINK SRC="mpp_domains.html#mpp_domains_set_stack_size">
!    <TT>mpp_domains_set_stack_size</TT></LINK>.
!  </DESCRIPTION>
!  <TEMPLATE>
!    call mpp_start_update_domains( field, domain, flags )
!    call mpp_complete_update_domains( field, domain, flags )
!  </TEMPLATE>

! </INTERFACE>

  interface mpp_start_update_domains
     module procedure mpp_start_update_domain2D_r8_2d
     module procedure mpp_start_update_domain2D_r8_3d
     module procedure mpp_start_update_domain2D_r8_4d
     module procedure mpp_start_update_domain2D_r8_5d
     module procedure mpp_start_update_domain2D_r8_2dv
     module procedure mpp_start_update_domain2D_r8_3dv
     module procedure mpp_start_update_domain2D_r8_4dv
     module procedure mpp_start_update_domain2D_r8_5dv
#ifdef OVERLOAD_C8
     module procedure mpp_start_update_domain2D_c8_2d
     module procedure mpp_start_update_domain2D_c8_3d
     module procedure mpp_start_update_domain2D_c8_4d
     module procedure mpp_start_update_domain2D_c8_5d
#endif
#ifndef no_8byte_integers
     module procedure mpp_start_update_domain2D_i8_2d
     module procedure mpp_start_update_domain2D_i8_3d
     module procedure mpp_start_update_domain2D_i8_4d
     module procedure mpp_start_update_domain2D_i8_5d
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_start_update_domain2D_r4_2d
     module procedure mpp_start_update_domain2D_r4_3d
     module procedure mpp_start_update_domain2D_r4_4d
     module procedure mpp_start_update_domain2D_r4_5d
     module procedure mpp_start_update_domain2D_r4_2dv
     module procedure mpp_start_update_domain2D_r4_3dv
     module procedure mpp_start_update_domain2D_r4_4dv
     module procedure mpp_start_update_domain2D_r4_5dv
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_start_update_domain2D_c4_2d
     module procedure mpp_start_update_domain2D_c4_3d
     module procedure mpp_start_update_domain2D_c4_4d
     module procedure mpp_start_update_domain2D_c4_5d
#endif
     module procedure mpp_start_update_domain2D_i4_2d
     module procedure mpp_start_update_domain2D_i4_3d
     module procedure mpp_start_update_domain2D_i4_4d
     module procedure mpp_start_update_domain2D_i4_5d
  end interface

  interface mpp_complete_update_domains
     module procedure mpp_complete_update_domain2D_r8_2d
     module procedure mpp_complete_update_domain2D_r8_3d
     module procedure mpp_complete_update_domain2D_r8_4d
     module procedure mpp_complete_update_domain2D_r8_5d
     module procedure mpp_complete_update_domain2D_r8_2dv
     module procedure mpp_complete_update_domain2D_r8_3dv
     module procedure mpp_complete_update_domain2D_r8_4dv
     module procedure mpp_complete_update_domain2D_r8_5dv
#ifdef OVERLOAD_C8
     module procedure mpp_complete_update_domain2D_c8_2d
     module procedure mpp_complete_update_domain2D_c8_3d
     module procedure mpp_complete_update_domain2D_c8_4d
     module procedure mpp_complete_update_domain2D_c8_5d
#endif
#ifndef no_8byte_integers
     module procedure mpp_complete_update_domain2D_i8_2d
     module procedure mpp_complete_update_domain2D_i8_3d
     module procedure mpp_complete_update_domain2D_i8_4d
     module procedure mpp_complete_update_domain2D_i8_5d
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_complete_update_domain2D_r4_2d
     module procedure mpp_complete_update_domain2D_r4_3d
     module procedure mpp_complete_update_domain2D_r4_4d
     module procedure mpp_complete_update_domain2D_r4_5d
     module procedure mpp_complete_update_domain2D_r4_2dv
     module procedure mpp_complete_update_domain2D_r4_3dv
     module procedure mpp_complete_update_domain2D_r4_4dv
     module procedure mpp_complete_update_domain2D_r4_5dv
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_complete_update_domain2D_c4_2d
     module procedure mpp_complete_update_domain2D_c4_3d
     module procedure mpp_complete_update_domain2D_c4_4d
     module procedure mpp_complete_update_domain2D_c4_5d
#endif
     module procedure mpp_complete_update_domain2D_i4_2d
     module procedure mpp_complete_update_domain2D_i4_3d
     module procedure mpp_complete_update_domain2D_i4_4d
     module procedure mpp_complete_update_domain2D_i4_5d
  end interface

  interface mpp_start_do_update
     module procedure mpp_start_do_update_r8_3d
     module procedure mpp_start_do_update_r8_3dv
#ifdef OVERLOAD_C8
     module procedure mpp_start_do_update_c8_3d
#endif
#ifndef no_8byte_integers
     module procedure mpp_start_do_update_i8_3d
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_start_do_update_r4_3d
     module procedure mpp_start_do_update_r4_3dv
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_start_do_update_c4_3d
#endif
     module procedure mpp_start_do_update_i4_3d
  end interface

  interface mpp_complete_do_update
     module procedure mpp_complete_do_update_r8_3d
     module procedure mpp_complete_do_update_r8_3dv
#ifdef OVERLOAD_C8
     module procedure mpp_complete_do_update_c8_3d
#endif
#ifndef no_8byte_integers
     module procedure mpp_complete_do_update_i8_3d
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_complete_do_update_r4_3d
     module procedure mpp_complete_do_update_r4_3dv
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_complete_do_update_c4_3d
#endif
     module procedure mpp_complete_do_update_i4_3d
  end interface


  interface mpp_create_group_update
     module procedure mpp_create_group_update_r4_2d
     module procedure mpp_create_group_update_r4_3d
     module procedure mpp_create_group_update_r4_4d
     module procedure mpp_create_group_update_r4_2dv
     module procedure mpp_create_group_update_r4_3dv
     module procedure mpp_create_group_update_r4_4dv
     module procedure mpp_create_group_update_r8_2d
     module procedure mpp_create_group_update_r8_3d
     module procedure mpp_create_group_update_r8_4d
     module procedure mpp_create_group_update_r8_2dv
     module procedure mpp_create_group_update_r8_3dv
     module procedure mpp_create_group_update_r8_4dv
  end interface mpp_create_group_update

  interface mpp_do_group_update
     module procedure mpp_do_group_update_r4
     module procedure mpp_do_group_update_r8
  end interface mpp_do_group_update

  interface mpp_start_group_update
     module procedure mpp_start_group_update_r4
     module procedure mpp_start_group_update_r8
  end interface mpp_start_group_update

  interface mpp_complete_group_update
     module procedure mpp_complete_group_update_r4
     module procedure mpp_complete_group_update_r8
  end interface mpp_complete_group_update

  interface mpp_reset_group_update_field
     module procedure mpp_reset_group_update_field_r4_2d
     module procedure mpp_reset_group_update_field_r4_3d
     module procedure mpp_reset_group_update_field_r4_4d
     module procedure mpp_reset_group_update_field_r4_2dv
     module procedure mpp_reset_group_update_field_r4_3dv
     module procedure mpp_reset_group_update_field_r4_4dv
     module procedure mpp_reset_group_update_field_r8_2d
     module procedure mpp_reset_group_update_field_r8_3d
     module procedure mpp_reset_group_update_field_r8_4d
     module procedure mpp_reset_group_update_field_r8_2dv
     module procedure mpp_reset_group_update_field_r8_3dv
     module procedure mpp_reset_group_update_field_r8_4dv
  end interface mpp_reset_group_update_field

  ! <INTERFACE NAME="mpp_define_nest_domains">
  !   <OVERVIEW>
  !     Set up a domain to pass data between coarse and fine grid of nested model.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Set up a domain to pass data between coarse and fine grid of nested model. 
  !     Currently it only support one fine nest region over the corase grid region.
  !     It supports both serial and concurrent nesting. The serial nesting is that 
  !     both coarse and fine grid are on the exact same processor list. Concurrent
  !     nesting is that coarse and fine grid are on individual processor list and 
  !     no overlapping. Coarse and fine grid domain need to be defined before 
  !     calling mpp_define_nest_domains. For concurrent nesting, mpp_broadcast
  !     need to be called to broadcast both fine and coarse grid domain onto
  !     all the processors. 
  !     <BR> 
  !     </BR>
  !     <BR> 
  !     </BR> 
  !     mpp_update_nest_coarse is used to pass data from fine grid to coarse grid computing domain.
  !     mpp_update_nest_fine   is used to pass data from coarse grid to fine grid halo.
  !     You may call mpp_get_C2F_index before calling mpp_update_nest_fine to get the index for 
  !     passing data from coarse to fine. You may call mpp_get_F2C_index before calling 
  !     mpp_update_nest_coarse to get the index for passing data from coarse to fine.
  !     <BR> 
  !     </BR>
  !     <BR> 
  !     </BR> 

  !     NOTE: The following tests are done in test_mpp_domains: the coarse grid is cubic sphere
  !           grid and the fine grid is a regular-latlon grid (symmetric domain) nested inside
  !           face 3 of the cubic sphere grid. Tests are done for data at T, E, C, N-cell center.
  !           
  !     Below is an example to pass data between fine and coarse grid (More details on how to
  !     use the nesting domain update are available in routing test_update_nest_domain of 
  !     shared/mpp/test_mpp_domains.F90.
  !
  !    <PRE>
  !    if( concurrent ) then
  !       call mpp_broadcast_domain(domain_fine)
  !       call mpp_broadcast_domain(domain_coarse)
  !    endif
  !    
  !     call mpp_define_nest_domains(nest_domain, domain_fine, domain_coarse, tile_fine, tile_coarse, &
  !                                  istart_fine, iend_fine, jstart_fine, jend_fine,                  &
  !                                  istart_coarse, iend_coarse, jstart_coarse, jend_coarse,         &
  !                                  pelist, extra_halo, name="nest_domain")
  !     call mpp_get_C2F_index(nest_domain, isw_f, iew_f, jsw_f, jew_f, isw_c, iew_c, jsw_c, jew_c, WEST)
  !     call mpp_get_C2F_index(nest_domain, ise_f, iee_f, jse_f, jee_f, ise_c, iee_c, jse_c, jee_c, EAST)
  !     call mpp_get_C2F_index(nest_domain, iss_f, ies_f, jss_f, jes_f, iss_c, ies_c, jss_c, jes_c, SOUTH)
  !     call mpp_get_C2F_index(nest_domain, isn_f, ien_f, jsn_f, jen_f, isn_c, ien_c, jsn_c, jen_c, NORTH)
  !
  !     allocate(wbuffer(isw_c:iew_c, jsw_c:jew_c,nz))
  !     allocate(ebuffer(ise_c:iee_c, jse_c:jee_c,nz))
  !     allocate(sbuffer(iss_c:ies_c, jss_c:jes_c,nz))
  !     allocate(nbuffer(isn_c:ien_c, jsn_c:jen_c,nz))
  !     call mpp_update_nest_fine(x, nest_domain, wbuffer, sbuffer, ebuffer, nbuffer)
  !
  !     call mpp_get_F2C_index(nest_domain, is_c, ie_c, js_c, je_c, is_f, ie_f, js_f, je_f)
  !     allocate(buffer (is_f:ie_f, js_f:je_f,nz))
  !     call mpp_update_nest_coarse(x, nest_domain, buffer)
  !     </PRE>

  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call mpp_define_nest_domains(nest_domain, domain_fine, domain_coarse, tile_fine, tile_coarse, 
  !                                 istart_fine, iend_fine, jstart_fine, jend_fine,                  
  !                                 istart_coarse, iend_coarse, jstart_coarse, jend_coarse,         
  !                                 pelist, extra_halo, name)
  !   </TEMPLATE>
  !
  !   <INOUT NAME="nest_domain">
  !     Holds the information to pass data between fine and coarse grid.
  !   </INOUT>
  !   <IN NAME="domain_fine">
  !     domain for fine grid.
  !   </IN>
  !   <IN NAME="domain_coarse">
  !     domain for coarse grid.
  !   </IN>
  !   <IN NAME="tile_fine">
  !     tile number of the fine grid. Currently this value should be 1.
  !   </IN>
  !   <IN NAME="tile_coarse">
  !     tile numuber of the coarse grid.
  !   </IN>
  !   <IN NAME="istart_fine, iend_fine, jstart_fine, jend_fine">
  !     index in the fine grid of the nested region
  !   </IN>
  !   <IN NAME="istart_coarse, iend_coarse, jstart_coarse, jend_coarse">
  !     index in the coarse grid of the nested region
  !   </IN>
  !   <IN NAME="pelist">
  !     List of PEs to which the domains are to be assigned.
  !   </IN>
  !   <IN NAME="extra_halo">
  !     optional argument. extra halo for passing data from coarse grid to fine grid. 
  !     Default is 0 and currently only support extra_halo = 0.
  !   </IN>
  !   <IN NAME="name">
  !     opitonal argument. Name of the nest domain. 
  !   </IN>
  ! </INTERFACE>

  ! <INTERFACE NAME="mpp_get_C2F_index">
  !   <OVERVIEW>
  !     Get the index of the data passed from coarse grid to fine grid.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Get the index of the data passed from coarse grid to fine grid.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call mpp_get_C2F_index(nest_domain, is_fine, ie_fine, js_fine, je_fine, 
  !                            is_coarse, ie_coarse, js_coarse, je_coarse, dir, position)
  !   </TEMPLATE>
  !
  !   <IN NAME="nest_domain">
  !     Holds the information to pass data between fine and coarse grid.
  !   </IN>
  !   <OUT NAME="istart_fine, iend_fine, jstart_fine, jend_fine">
  !     index in the fine grid of the nested region
  !   </OUT>
  !   <OUT NAME="istart_coarse, iend_coarse, jstart_coarse, jend_coarse">
  !     index in the coarse grid of the nested region
  !   </OUT>
  !   <IN NAME="dir">
  !     direction of the halo update. Its value should be WEST, EAST, SOUTH or NORTH. 
  !   </IN>
  !   <IN NAME="position">
  !     Cell position. It value should be CENTER, EAST, NORTH or SOUTH. 
  !   </IN>
  ! </INTERFACE>

  ! <INTERFACE NAME="mpp_get_F2C_index">
  !   <OVERVIEW>
  !     Get the index of the data passed from fine grid to coarse grid.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Get the index of the data passed from fine grid to coarse grid.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call mpp_get_F2C_index(nest_domain, is_coarse, ie_coarse, js_coarse, je_coarse, 
  !                            is_fine, ie_fine, js_fine, je_fine, position)
  !   </TEMPLATE>
  !
  !   <IN NAME="nest_domain">
  !     Holds the information to pass data between fine and coarse grid.
  !   </IN>
  !   <OUT NAME="istart_fine, iend_fine, jstart_fine, jend_fine">
  !     index in the fine grid of the nested region
  !   </OUT>
  !   <OUT NAME="istart_coarse, iend_coarse, jstart_coarse, jend_coarse">
  !     index in the coarse grid of the nested region
  !   </OUT>
  !   <IN NAME="position">
  !     Cell position. It value should be CENTER, EAST, NORTH or SOUTH. 
  !   </IN>
  ! </INTERFACE>

  ! <INTERFACE NAME="mpp_update_nest_fine">
  !   <OVERVIEW>
  !     Pass the data from coarse grid to fill the buffer to be ready to be interpolated 
  !     onto fine grid.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Pass the data from coarse grid to fill the buffer to be ready to be interpolated 
  !     onto fine grid.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call mpp_update_nest_fine(field, nest_domain, wbuffer, ebuffer, sbuffer, nbuffer, 
  !                               flags, complete, position, extra_halo, name, tile_count)
  !   </TEMPLATE>
  !
  !   <IN    NAME="field">
  !     field on the model grid.
  !   </IN>
  !   <INOUT NAME="nest_domain">
  !     Holds the information to pass data between fine and coarse grid.
  !   </INOUT>
  !   <OUT   NAME="wbuffer">
  !     west side buffer to be filled with data on coarse grid.
  !   </OUT>
  !   <OUT   NAME="ebuffer">
  !     east side buffer to be filled with data on coarse grid.
  !   </OUT>
  !   <OUT   NAME="sbuffer">
  !     south side buffer to be filled with data on coarse grid.
  !   </OUT>
  !   <OUT   NAME="nbuffer">
  !     north side buffer to be filled with data on coarse grid.
  !   </OUT>
  !   <IN    NAME="flags">
  !     optional arguments. Specify the direction of fine grid halo buffer to be filled.
  !     Default value is XUPDATE+YUPDATE.
  !   </IN>
  !   <IN    NAME="complete">
  !     optional argument. When true, do the buffer filling. Default value is true.
  !   </IN>
  !   <IN NAME="position">
  !     Cell position. It value should be CENTER, EAST, NORTH or SOUTH. Default is CENTER.
  !   </IN>
  !   <IN NAME="extra_halo">
  !     optional argument. extra halo for passing data from coarse grid to fine grid. 
  !     Default is 0 and currently only support extra_halo = 0.
  !   </IN>
  !   <IN NAME="name">
  !     opitonal argument. Name of the nest domain. 
  !   </IN>
  !   <IN NAME="tile_count">
  !     optional argument. Used to support multiple-tile-per-pe. default is 1 and currently
  !     only support tile_count = 1.
  !   </IN>
  ! </INTERFACE>

  ! <INTERFACE NAME="mpp_update_nest_coarse">
  !   <OVERVIEW>
  !     Pass the data from fine grid to fill the buffer to be ready to be interpolated 
  !     onto coarse grid.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Pass the data from fine grid to fill the buffer to be ready to be interpolated 
  !     onto coarse grid.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call mpp_update_nest_coarse(field, nest_domain, buffer, complete, position, name, tile_count)
  !   </TEMPLATE>
  !
  !   <IN    NAME="field">
  !     field on the model grid.
  !   </IN>
  !   <INOUT NAME="nest_domain">
  !     Holds the information to pass data between fine and coarse grid.
  !   </INOUT>
  !   <OUT   NAME="buffer">
  !     buffer to be filled with data on coarse grid.
  !   </OUT>
  !   <IN    NAME="complete">
  !     optional argument. When true, do the buffer filling. Default value is true.
  !   </IN>
  !   <IN NAME="position">
  !     Cell position. It value should be CENTER, EAST, NORTH or SOUTH. Default is CENTER.
  !   </IN>
  !   <IN NAME="name">
  !     opitonal argument. Name of the nest domain. 
  !   </IN>
  !   <IN NAME="tile_count">
  !     optional argument. Used to support multiple-tile-per-pe. default is 1 and currently
  !     only support tile_count = 1.
  !   </IN>
  ! </INTERFACE>

  interface mpp_update_nest_fine
     module procedure mpp_update_nest_fine_r8_2d
     module procedure mpp_update_nest_fine_r8_3d
     module procedure mpp_update_nest_fine_r8_4d
#ifdef OVERLOAD_C8
     module procedure mpp_update_nest_fine_c8_2d
     module procedure mpp_update_nest_fine_c8_3d
     module procedure mpp_update_nest_fine_c8_4d
#endif
#ifndef no_8byte_integers
     module procedure mpp_update_nest_fine_i8_2d
     module procedure mpp_update_nest_fine_i8_3d
     module procedure mpp_update_nest_fine_i8_4d
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_update_nest_fine_r4_2d
     module procedure mpp_update_nest_fine_r4_3d
     module procedure mpp_update_nest_fine_r4_4d
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_update_nest_fine_c4_2d
     module procedure mpp_update_nest_fine_c4_3d
     module procedure mpp_update_nest_fine_c4_4d
#endif
     module procedure mpp_update_nest_fine_i4_2d
     module procedure mpp_update_nest_fine_i4_3d
     module procedure mpp_update_nest_fine_i4_4d
  end interface

  interface mpp_do_update_nest_fine
     module procedure mpp_do_update_nest_fine_r8_3d
#ifdef OVERLOAD_C8
     module procedure mpp_do_update_nest_fine_c8_3d
#endif
#ifndef no_8byte_integers
     module procedure mpp_do_update_nest_fine_i8_3d
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_do_update_nest_fine_r4_3d
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_do_update_nest_fine_c4_3d
#endif
     module procedure mpp_do_update_nest_fine_i4_3d
  end interface

  interface mpp_update_nest_coarse
     module procedure mpp_update_nest_coarse_r8_2d
     module procedure mpp_update_nest_coarse_r8_3d
     module procedure mpp_update_nest_coarse_r8_4d
#ifdef OVERLOAD_C8
     module procedure mpp_update_nest_coarse_c8_2d
     module procedure mpp_update_nest_coarse_c8_3d
     module procedure mpp_update_nest_coarse_c8_4d
#endif
#ifndef no_8byte_integers
     module procedure mpp_update_nest_coarse_i8_2d
     module procedure mpp_update_nest_coarse_i8_3d
     module procedure mpp_update_nest_coarse_i8_4d
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_update_nest_coarse_r4_2d
     module procedure mpp_update_nest_coarse_r4_3d
     module procedure mpp_update_nest_coarse_r4_4d
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_update_nest_coarse_c4_2d
     module procedure mpp_update_nest_coarse_c4_3d
     module procedure mpp_update_nest_coarse_c4_4d
#endif
     module procedure mpp_update_nest_coarse_i4_2d
     module procedure mpp_update_nest_coarse_i4_3d
     module procedure mpp_update_nest_coarse_i4_4d
  end interface

  interface mpp_do_update_nest_coarse
     module procedure mpp_do_update_nest_coarse_r8_3d
#ifdef OVERLOAD_C8
     module procedure mpp_do_update_nest_coarse_c8_3d
#endif
#ifndef no_8byte_integers
     module procedure mpp_do_update_nest_coarse_i8_3d
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_do_update_nest_coarse_r4_3d
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_do_update_nest_coarse_c4_3d
#endif
     module procedure mpp_do_update_nest_coarse_i4_3d
  end interface


interface mpp_broadcast_domain
  module procedure mpp_broadcast_domain_1
  module procedure mpp_broadcast_domain_2
end interface


  interface mpp_do_update
     module procedure mpp_do_update_r8_3d
     module procedure mpp_do_update_r8_3dv
#ifdef OVERLOAD_C8
     module procedure mpp_do_update_c8_3d
#endif
#ifndef no_8byte_integers
     module procedure mpp_do_update_i8_3d
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_do_update_r4_3d
     module procedure mpp_do_update_r4_3dv
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_do_update_c4_3d
#endif
     module procedure mpp_do_update_i4_3d
  end interface

  interface mpp_do_check
     module procedure mpp_do_check_r8_3d
     module procedure mpp_do_check_r8_3dv
#ifdef OVERLOAD_C8
     module procedure mpp_do_check_c8_3d
#endif
#ifndef no_8byte_integers
     module procedure mpp_do_check_i8_3d
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_do_check_r4_3d
     module procedure mpp_do_check_r4_3dv
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_do_check_c4_3d
#endif
     module procedure mpp_do_check_i4_3d
  end interface


!!$     module procedure mpp_do_update_ad_i4_3d
!!$  end interface
!bnc

! <INTERFACE NAME="mpp_get_boundary">
! <OVERVIEW>
!    Get the boundary data for symmetric domain when the data is at C, E, or N-cell center
! </OVERVIEW>
!  <DESCRIPTION>
!    <TT>mpp_get_boundary</TT> is used to get the boundary data for symmetric domain 
!        when the data is at C, E, or N-cell center. For cubic grid, the data should 
!        always at C-cell center. 
!  </DESCRIPTION>
!  <TEMPLATE>
!    call mpp_get_boundary
!  </TEMPLATE>
!  <TEMPLATE>
!    call mpp_get_boundary
!  </TEMPLATE>
! </INTERFACE>
  interface mpp_get_boundary
     module procedure mpp_get_boundary_r8_2d
     module procedure mpp_get_boundary_r8_3d
!     module procedure mpp_get_boundary_r8_4d
!     module procedure mpp_get_boundary_r8_5d
     module procedure mpp_get_boundary_r8_2dv
     module procedure mpp_get_boundary_r8_3dv
!     module procedure mpp_get_boundary_r8_4dv
!     module procedure mpp_get_boundary_r8_5dv
#ifdef OVERLOAD_R4
     module procedure mpp_get_boundary_r4_2d
     module procedure mpp_get_boundary_r4_3d
!     module procedure mpp_get_boundary_r4_4d
!     module procedure mpp_get_boundary_r4_5d
     module procedure mpp_get_boundary_r4_2dv
     module procedure mpp_get_boundary_r4_3dv
!     module procedure mpp_get_boundary_r4_4dv
!     module procedure mpp_get_boundary_r4_5dv
#endif
  end interface

  interface mpp_do_get_boundary
     module procedure mpp_do_get_boundary_r8_3d
     module procedure mpp_do_get_boundary_r8_3dv
#ifdef OVERLOAD_R4
     module procedure mpp_do_get_boundary_r4_3d
     module procedure mpp_do_get_boundary_r4_3dv
#endif
  end interface

! <INTERFACE NAME="mpp_redistribute">
!  <OVERVIEW>
!    Reorganization of distributed global arrays.
!  </OVERVIEW>
!  <DESCRIPTION>
!    <TT>mpp_redistribute</TT> is used to reorganize a distributed
!    array.  <TT>MPP_TYPE_</TT> can be of type <TT>integer</TT>,
!    <TT>complex</TT>, or <TT>real</TT>; of 4-byte or 8-byte kind; of rank
!    up to 5.
!  </DESCRIPTION>
!  <TEMPLATE>
!    call mpp_redistribute( domain_in, field_in, domain_out, field_out )
!  </TEMPLATE>
!  <IN NAME="field_in" TYPE="MPP_TYPE_">
!    <TT>field_in</TT> is dimensioned on the data domain of <TT>domain_in</TT>.
!  </IN>
!  <OUT NAME="field_out" TYPE="MPP_TYPE_">
!    <TT>field_out</TT> on the data domain of <TT>domain_out</TT>.
!  </OUT>
! </INTERFACE>
  interface mpp_redistribute
     module procedure mpp_redistribute_r8_2D
     module procedure mpp_redistribute_r8_3D
     module procedure mpp_redistribute_r8_4D
     module procedure mpp_redistribute_r8_5D
#ifdef OVERLOAD_C8
     module procedure mpp_redistribute_c8_2D
     module procedure mpp_redistribute_c8_3D
     module procedure mpp_redistribute_c8_4D
     module procedure mpp_redistribute_c8_5D
#endif
#ifndef no_8byte_integers
     module procedure mpp_redistribute_i8_2D
     module procedure mpp_redistribute_i8_3D
     module procedure mpp_redistribute_i8_4D
     module procedure mpp_redistribute_i8_5D
!!$     module procedure mpp_redistribute_l8_2D
!!$     module procedure mpp_redistribute_l8_3D
!!$     module procedure mpp_redistribute_l8_4D
!!$     module procedure mpp_redistribute_l8_5D
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_redistribute_r4_2D
     module procedure mpp_redistribute_r4_3D
     module procedure mpp_redistribute_r4_4D
     module procedure mpp_redistribute_r4_5D
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_redistribute_c4_2D
     module procedure mpp_redistribute_c4_3D
     module procedure mpp_redistribute_c4_4D
     module procedure mpp_redistribute_c4_5D
#endif
     module procedure mpp_redistribute_i4_2D
     module procedure mpp_redistribute_i4_3D
     module procedure mpp_redistribute_i4_4D
     module procedure mpp_redistribute_i4_5D
!!$     module procedure mpp_redistribute_l4_2D
!!$     module procedure mpp_redistribute_l4_3D
!!$     module procedure mpp_redistribute_l4_4D
!!$     module procedure mpp_redistribute_l4_5D
  end interface

  interface mpp_do_redistribute
     module procedure mpp_do_redistribute_r8_3D
#ifdef OVERLOAD_C8
     module procedure mpp_do_redistribute_c8_3D
#endif
#ifndef no_8byte_integers
     module procedure mpp_do_redistribute_i8_3D
     module procedure mpp_do_redistribute_l8_3D
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_do_redistribute_r4_3D
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_do_redistribute_c4_3D
#endif
     module procedure mpp_do_redistribute_i4_3D
     module procedure mpp_do_redistribute_l4_3D
  end interface


! <INTERFACE NAME="mpp_check_field">
!   <OVERVIEW>
!     Parallel checking between two ensembles which run
!     on different set pes at the same time.
!   </OVERVIEW>
!   <DESCRIPTION>
!     There are two forms for the <TT>mpp_check_field</TT> call. The 2D
!     version is generally to be used and 3D version is  built by repeated calls to the
!     2D version.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call mpp_check_field(field_in, pelist1, pelist2, domain, mesg, &
!                                w_halo, s_halo, e_halo, n_halo, force_abort  )
!   </TEMPLATE>
!   <IN NAME="field_in" >
!     Field to be checked
!   </IN>
!   <IN NAME="pelist1, pelist2">
!     Pelist of the two ensembles to be compared
!   </IN>
!   <IN NAME="domain">
!     Domain of current pe
!   </IN>
!   <IN NAME="mesg" >
!     Message to be printed out
!   </IN>
!   <IN NAME="w_halo, s_halo, e_halo, n_halo">
!     Halo size to be checked. Default value is 0.
!   </IN>
!   <IN NAME="force_abort">
!     When true, abort program when any difference found. Default value is false.
!   </IN>
! </INTERFACE>

  interface mpp_check_field
     module procedure mpp_check_field_2D
     module procedure mpp_check_field_3D
  end interface

!***********************************************************************
!
!         public interface from mpp_domains_reduce.h
!
!***********************************************************************

! <INTERFACE NAME="mpp_global_field">
!  <OVERVIEW>
!    Fill in a global array from domain-decomposed arrays.
!  </OVERVIEW>
!  <DESCRIPTION>
!    <TT>mpp_global_field</TT> is used to get an entire
!    domain-decomposed array on each PE. <TT>MPP_TYPE_</TT> can be of type
!    <TT>complex</TT>, <TT>integer</TT>, <TT>logical</TT> or <TT>real</TT>;
!    of 4-byte or 8-byte kind; of rank up to 5.
!    
!    All PEs in a domain decomposition must call
!    <TT>mpp_global_field</TT>, and each will have a complete global field
!    at the end. Please note that a global array of rank 3 or higher could
!    occupy a lot of memory.
!  </DESCRIPTION>
!  <TEMPLATE>
!    call mpp_global_field( domain, local, global, flags )
!  </TEMPLATE>
!  <IN NAME="domain" TYPE="type(domain2D)"></IN>
!  <IN NAME="local" TYPE="MPP_TYPE_">
!    <TT>local</TT> is dimensioned on either the compute domain or the
!    data domain of <TT>domain</TT>.
!  </IN>
!  <OUT NAME="global" TYPE="MPP_TYPE_">
!    <TT>global</TT> is dimensioned on the corresponding global domain.
!  </OUT>
!  <IN NAME="flags" TYPE="integer">
!    <TT>flags</TT> can be given the value <TT>XONLY</TT> or
!    <TT>YONLY</TT>, to specify a globalization on one axis only.
!  </IN>
! </INTERFACE>
  interface mpp_global_field
     module procedure mpp_global_field2D_r8_2d
     module procedure mpp_global_field2D_r8_3d
     module procedure mpp_global_field2D_r8_4d
     module procedure mpp_global_field2D_r8_5d
#ifdef OVERLOAD_C8
     module procedure mpp_global_field2D_c8_2d
     module procedure mpp_global_field2D_c8_3d
     module procedure mpp_global_field2D_c8_4d
     module procedure mpp_global_field2D_c8_5d
#endif
#ifndef no_8byte_integers
     module procedure mpp_global_field2D_i8_2d
     module procedure mpp_global_field2D_i8_3d
     module procedure mpp_global_field2D_i8_4d
     module procedure mpp_global_field2D_i8_5d
     module procedure mpp_global_field2D_l8_2d
     module procedure mpp_global_field2D_l8_3d
     module procedure mpp_global_field2D_l8_4d
     module procedure mpp_global_field2D_l8_5d
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_global_field2D_r4_2d
     module procedure mpp_global_field2D_r4_3d
     module procedure mpp_global_field2D_r4_4d
     module procedure mpp_global_field2D_r4_5d
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_global_field2D_c4_2d
     module procedure mpp_global_field2D_c4_3d
     module procedure mpp_global_field2D_c4_4d
     module procedure mpp_global_field2D_c4_5d
#endif
     module procedure mpp_global_field2D_i4_2d
     module procedure mpp_global_field2D_i4_3d
     module procedure mpp_global_field2D_i4_4d
     module procedure mpp_global_field2D_i4_5d
     module procedure mpp_global_field2D_l4_2d
     module procedure mpp_global_field2D_l4_3d
     module procedure mpp_global_field2D_l4_4d
     module procedure mpp_global_field2D_l4_5d
  end interface

  interface mpp_do_global_field
     module procedure mpp_do_global_field2D_r8_3d
#ifdef OVERLOAD_C8
     module procedure mpp_do_global_field2D_c8_3d
#endif
#ifndef no_8byte_integers
     module procedure mpp_do_global_field2D_i8_3d
     module procedure mpp_do_global_field2D_l8_3d
#endif
#ifdef OVERLOAD_R4
     module procedure mpp_do_global_field2D_r4_3d
#endif
#ifdef OVERLOAD_C4
     module procedure mpp_do_global_field2D_c4_3d
#endif
     module procedure mpp_do_global_field2D_i4_3d
     module procedure mpp_do_global_field2D_l4_3d
  end interface

! <INTERFACE NAME="mpp_global_max">
!  <OVERVIEW>
!    Global max/min of domain-decomposed arrays.
!  </OVERVIEW>
!  <DESCRIPTION>
!    <TT>mpp_global_max</TT> is used to get the maximum value of a
!    domain-decomposed array on each PE. <TT>MPP_TYPE_</TT> can be of type
!    <TT>integer</TT> or <TT>real</TT>; of 4-byte or 8-byte kind; of rank
!    up to 5. The dimension of <TT>locus</TT> must equal the rank of
!    <TT>field</TT>.
!    
!    All PEs in a domain decomposition must call
!    <TT>mpp_global_max</TT>, and each will have the result upon exit.
!    
!    The function <TT>mpp_global_min</TT>, with an identical syntax. is
!    also available.
!  </DESCRIPTION>
!  <TEMPLATE>
!    mpp_global_max( domain, field, locus )
!  </TEMPLATE>
!  <IN NAME="domain" TYPE="type(domain2D)"></IN>
!  <IN NAME="field" TYPE="MPP_TYPE_">  
!    <TT>field</TT> is dimensioned on either the compute domain or the
!    data domain of <TT>domain</TT>.
!  </IN>
!  <OUT NAME="locus" TYPE="integer" DIM="(:)">
!    <TT>locus</TT>, if present, can be used to retrieve the location of
!    the maximum (as in the <TT>MAXLOC</TT> intrinsic of f90).
!  </OUT>
! </INTERFACE>

  interface mpp_global_max
     module procedure mpp_global_max_r8_2d
     module procedure mpp_global_max_r8_3d
     module procedure mpp_global_max_r8_4d
     module procedure mpp_global_max_r8_5d
#ifdef OVERLOAD_R4
     module procedure mpp_global_max_r4_2d
     module procedure mpp_global_max_r4_3d
     module procedure mpp_global_max_r4_4d
     module procedure mpp_global_max_r4_5d
#endif
#ifndef no_8byte_integers
     module procedure mpp_global_max_i8_2d
     module procedure mpp_global_max_i8_3d
     module procedure mpp_global_max_i8_4d
     module procedure mpp_global_max_i8_5d
#endif
     module procedure mpp_global_max_i4_2d
     module procedure mpp_global_max_i4_3d
     module procedure mpp_global_max_i4_4d
     module procedure mpp_global_max_i4_5d
  end interface

  interface mpp_global_min
     module procedure mpp_global_min_r8_2d
     module procedure mpp_global_min_r8_3d
     module procedure mpp_global_min_r8_4d
     module procedure mpp_global_min_r8_5d
#ifdef OVERLOAD_R4
     module procedure mpp_global_min_r4_2d
     module procedure mpp_global_min_r4_3d
     module procedure mpp_global_min_r4_4d
     module procedure mpp_global_min_r4_5d
#endif
#ifndef no_8byte_integers
     module procedure mpp_global_min_i8_2d
     module procedure mpp_global_min_i8_3d
     module procedure mpp_global_min_i8_4d
     module procedure mpp_global_min_i8_5d
#endif
     module procedure mpp_global_min_i4_2d
     module procedure mpp_global_min_i4_3d
     module procedure mpp_global_min_i4_4d
     module procedure mpp_global_min_i4_5d
  end interface

! <INTERFACE NAME="mpp_global_sum">
!  <OVERVIEW>
!    Global sum of domain-decomposed arrays.
!  </OVERVIEW>
!  <DESCRIPTION>
!    <TT>mpp_global_sum</TT> is used to get the sum of a
!    domain-decomposed array on each PE. <TT>MPP_TYPE_</TT> can be of type
!    <TT>integer</TT>, <TT>complex</TT>, or <TT>real</TT>; of 4-byte or
!    8-byte kind; of rank up to 5.
!  </DESCRIPTION>
!  <TEMPLATE>
!    call mpp_global_sum( domain, field, flags )
!  </TEMPLATE>
!  <IN NAME="domain" TYPE="type(domain2D)"></IN>
!  <IN NAME="field" TYPE="MPP_TYPE_">
!    <TT>field</TT> is dimensioned on either the compute domain or the
!    data domain of <TT>domain</TT>.
!  </IN>
!  <IN NAME="flags" TYPE="integer">
!    <TT>flags</TT>, if present, must have the value
!    <TT>BITWISE_EXACT_SUM</TT>. This produces a sum that is guaranteed to
!    produce the identical result irrespective of how the domain is
!    decomposed. This method does the sum first along the ranks beyond 2,
!    and then calls <LINK
!    SRC="#mpp_global_field"><TT>mpp_global_field</TT></LINK> to produce a
!    global 2D array which is then summed. The default method, which is
!    considerably faster, does a local sum followed by <LINK
!    SRC="mpp.html#mpp_sum"><TT>mpp_sum</TT></LINK> across the domain
!    decomposition.
!  </IN>
!  <NOTE>
!    All PEs in a domain decomposition must call
!    <TT>mpp_global_sum</TT>, and each will have the result upon exit.
!  </NOTE>
! </INTERFACE>

  interface mpp_global_sum
     module procedure mpp_global_sum_r8_2d
     module procedure mpp_global_sum_r8_3d
     module procedure mpp_global_sum_r8_4d
     module procedure mpp_global_sum_r8_5d
#ifdef OVERLOAD_R4
     module procedure mpp_global_sum_r4_2d
     module procedure mpp_global_sum_r4_3d
     module procedure mpp_global_sum_r4_4d
     module procedure mpp_global_sum_r4_5d
#endif
#ifndef no_8byte_integers
     module procedure mpp_global_sum_i8_2d
     module procedure mpp_global_sum_i8_3d
     module procedure mpp_global_sum_i8_4d
     module procedure mpp_global_sum_i8_5d
#endif
     module procedure mpp_global_sum_i4_2d
     module procedure mpp_global_sum_i4_3d
     module procedure mpp_global_sum_i4_4d
     module procedure mpp_global_sum_i4_5d
  end interface

!gag
  interface mpp_global_sum_tl
     module procedure mpp_global_sum_tl_r8_2d
     module procedure mpp_global_sum_tl_r8_3d
     module procedure mpp_global_sum_tl_r8_4d
     module procedure mpp_global_sum_tl_r8_5d
#ifdef OVERLOAD_R4
     module procedure mpp_global_sum_tl_r4_2d
     module procedure mpp_global_sum_tl_r4_3d
     module procedure mpp_global_sum_tl_r4_4d
     module procedure mpp_global_sum_tl_r4_5d
#endif
  end interface
!gag

!***********************************************************************
!
!            public interface from mpp_domain_util.h
!
!***********************************************************************

  ! <INTERFACE NAME="mpp_get_neighbor_pe">
  !  <OVERVIEW>
  !    Retrieve PE number of a neighboring domain.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    Given a 1-D or 2-D domain decomposition, this call allows users to retrieve 
  !    the PE number of an adjacent PE-domain while taking into account that the 
  !    domain may have holes (masked) and/or have cyclic boundary conditions and/or a 
  !    folded edge. Which PE-domain will be retrived will depend on "direction": 
  !    +1 (right) or -1 (left) for a 1-D domain decomposition and either NORTH, SOUTH, 
  !    EAST, WEST, NORTH_EAST, SOUTH_EAST, SOUTH_WEST, or NORTH_WEST for a 2-D 
  !    decomposition. If no neighboring domain exists (masked domain), then the 
  !    returned "pe" value will be set to NULL_PE.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_get_neighbor_pe( domain1d, direction=+1   , pe)
  !    call mpp_get_neighbor_pe( domain2d, direction=NORTH, pe)
  !  </TEMPLATE>
  ! </INTERFACE>
  interface mpp_get_neighbor_pe
     module procedure mpp_get_neighbor_pe_1d
     module procedure mpp_get_neighbor_pe_2d
  end interface 
  ! <INTERFACE NAME="operator">
  !  <OVERVIEW>
  !    Equality/inequality operators for domaintypes.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    The module provides public operators to check for
  !    equality/inequality of domaintypes, e.g:
  !    
  !    <PRE>
  !    type(domain1D) :: a, b
  !    type(domain2D) :: c, d
  !    ...
  !    if( a.NE.b )then
  !        ...
  !    end if
  !    if( c==d )then
  !        ...
  !    end if
  !    </PRE>
  !    
  !    Domains are considered equal if and only if the start and end
  !    indices of each of their component global, data and compute domains
  !    are equal.
  !  </DESCRIPTION>
  ! </INTERFACE>
  interface operator(.EQ.)
     module procedure mpp_domain1D_eq
     module procedure mpp_domain2D_eq
  end interface

  interface operator(.NE.)
     module procedure mpp_domain1D_ne
     module procedure mpp_domain2D_ne
  end interface

  ! <INTERFACE NAME="mpp_get_compute_domain">
  !  <OVERVIEW>
  !    These routines retrieve the axis specifications associated with the compute domains.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    The domain is a derived type with private elements. These routines 
  !    retrieve the axis specifications associated with the compute domains
  !    The 2D version of these is a simple extension of 1D.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_get_compute_domain
  !  </TEMPLATE>
  ! </INTERFACE>
  interface mpp_get_compute_domain
     module procedure mpp_get_compute_domain1D
     module procedure mpp_get_compute_domain2D
  end interface

  ! <INTERFACE NAME="mpp_get_compute_domains">
  !  <OVERVIEW>
  !    Retrieve the entire array of compute domain extents associated with a decomposition.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    Retrieve the entire array of compute domain extents associated with a decomposition.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_get_compute_domains( domain, xbegin, xend, xsize, &
  !                                                ybegin, yend, ysize )
  !  </TEMPLATE>
  !  <IN NAME="domain" TYPE="type(domain2D)"></IN>
  !  <OUT NAME="xbegin,ybegin" TYPE="integer" DIM="(:)"></OUT>
  !  <OUT NAME="xend,yend" TYPE="integer" DIM="(:)"></OUT>
  !  <OUT NAME="xsize,ysize" TYPE="integer" DIM="(:)"></OUT>
  ! </INTERFACE>
  interface mpp_get_compute_domains
     module procedure mpp_get_compute_domains1D
     module procedure mpp_get_compute_domains2D
  end interface

  ! <INTERFACE NAME="mpp_get_data_domain">
  !  <OVERVIEW>
  !    These routines retrieve the axis specifications associated with the data domains.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    The domain is a derived type with private elements. These routines 
  !    retrieve the axis specifications associated with the data domains.
  !    The 2D version of these is a simple extension of 1D.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_get_data_domain
  !  </TEMPLATE>
  ! </INTERFACE>
  interface mpp_get_data_domain
     module procedure mpp_get_data_domain1D
     module procedure mpp_get_data_domain2D
  end interface

  ! <INTERFACE NAME="mpp_get_global_domain">
  !  <OVERVIEW>
  !    These routines retrieve the axis specifications associated with the global domains.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    The domain is a derived type with private elements. These routines 
  !    retrieve the axis specifications associated with the global domains.
  !    The 2D version of these is a simple extension of 1D.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_get_global_domain
  !  </TEMPLATE>
  ! </INTERFACE>
  interface mpp_get_global_domain
     module procedure mpp_get_global_domain1D
     module procedure mpp_get_global_domain2D
  end interface

  ! <INTERFACE NAME="mpp_get_memory_domain">
  !  <OVERVIEW>
  !    These routines retrieve the axis specifications associated with the memory domains.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    The domain is a derived type with private elements. These routines 
  !    retrieve the axis specifications associated with the memory domains.
  !    The 2D version of these is a simple extension of 1D.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_get_memory_domain
  !  </TEMPLATE>
  ! </INTERFACE>
  interface mpp_get_memory_domain
     module procedure mpp_get_memory_domain1D
     module procedure mpp_get_memory_domain2D
  end interface

  interface mpp_get_domain_extents
     module procedure mpp_get_domain_extents1D
     module procedure mpp_get_domain_extents2D
  end interface

  ! <INTERFACE NAME="mpp_set_compute_domain">
  !  <OVERVIEW>
  !    These routines set the axis specifications associated with the compute domains.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    The domain is a derived type with private elements. These routines 
  !    set the axis specifications associated with the compute domains
  !    The 2D version of these is a simple extension of 1D.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_set_compute_domain
  !  </TEMPLATE>
  ! </INTERFACE>
  interface mpp_set_compute_domain
     module procedure mpp_set_compute_domain1D
     module procedure mpp_set_compute_domain2D
  end interface

  ! <INTERFACE NAME="mpp_set_data_domain">
  !  <OVERVIEW>
  !    These routines set the axis specifications associated with the data domains.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    The domain is a derived type with private elements. These routines 
  !    set the axis specifications associated with the data domains.
  !    The 2D version of these is a simple extension of 1D.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_set_data_domain
  !  </TEMPLATE>
  ! </INTERFACE>
  interface mpp_set_data_domain
     module procedure mpp_set_data_domain1D
     module procedure mpp_set_data_domain2D
  end interface

  ! <INTERFACE NAME="mpp_set_global_domain">
  !  <OVERVIEW>
  !    These routines set the axis specifications associated with the global domains.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    The domain is a derived type with private elements. These routines 
  !    set the axis specifications associated with the global domains.
  !    The 2D version of these is a simple extension of 1D.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_set_global_domain
  !  </TEMPLATE>
  ! </INTERFACE>
  interface mpp_set_global_domain
     module procedure mpp_set_global_domain1D
     module procedure mpp_set_global_domain2D
  end interface


  ! <INTERFACE NAME="mpp_get_pelist">
  !  <OVERVIEW>
  !    Retrieve list of PEs associated with a domain decomposition.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    The 1D version of this call returns an array of the PEs assigned to this 1D domain
  !    decomposition. In addition the optional argument <TT>pos</TT> may be
  !    used to retrieve the 0-based position of the domain local to the
  !    calling PE, i.e <TT>domain%list(pos)%pe</TT> is the local PE,
  !    as returned by <LINK SRC="mpp.html#mpp_pe"><TT>mpp_pe()</TT></LINK>.
  !    The 2D version of this call is identical to 1D version.
  !  </DESCRIPTION>
  !  <IN NAME="domain"></IN>
  !  <OUT NAME="pelist"></OUT>
  !  <OUT NAME="pos"></OUT>
  ! </INTERFACE>
  interface mpp_get_pelist
     module procedure mpp_get_pelist1D
     module procedure mpp_get_pelist2D
  end interface

  ! <INTERFACE NAME="mpp_get_layout">
  !  <OVERVIEW>
  !    Retrieve layout associated with a domain decomposition.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    The 1D version of this call returns the number of divisions that was assigned to this
  !    decomposition axis. The 2D version of this call returns an array of
  !    dimension 2 holding the results on two axes.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_get_layout( domain, layout )
  !  </TEMPLATE>
  !  <IN NAME="domain"></IN>
  !  <OUT NAME="layout"></OUT>
  ! </INTERFACE>
  interface mpp_get_layout
     module procedure mpp_get_layout1D
     module procedure mpp_get_layout2D
  end interface

  ! <INTERFACE NAME="mpp_nullify_domain_list">
  !  <OVERVIEW>
  !    nullify domain list.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    Nullify domain list. This interface is needed in mpp_domains_test.
  !    1-D case can be added in if needed.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !    call mpp_nullify_domain_list( domain)
  !  </TEMPLATE>
  !  <INOUT NAME="domain"></INOUT>
  ! </INTERFACE>
  interface mpp_nullify_domain_list
     module procedure nullify_domain2d_list
  end interface  

  !--- version information variables
  character(len=128), public :: version= &
       '$Id$'
  character(len=128), public :: tagname= &
       '$Name$'


contains

#include <mpp_define_nest_domains.inc>
#include <mpp_domains_util.inc>
#include <mpp_domains_comm.inc>
#include <mpp_domains_define.inc>
#include <mpp_domains_misc.inc>
#include <mpp_domains_reduce.inc>


end module mpp_domains_mod

! <INFO>

!   <COMPILER NAME="">     
!     Any module or program unit using <TT>mpp_domains_mod</TT>
!     must contain the line

!     <PRE>
!     use mpp_domains_mod
!     </PRE>

!     <TT>mpp_domains_mod</TT> <TT>use</TT>s <LINK
!     SRC="mpp.html">mpp_mod</LINK>, and therefore is subject to the <LINK
!     SRC="mpp.html#COMPILING AND LINKING SOURCE">compiling and linking requirements of that module.</LINK>
!   </COMPILER>
!   <PRECOMP FLAG="">      
!     <TT>mpp_domains_mod</TT> uses standard f90, and has no special
!     requirements. There are some OS-dependent
!     pre-processor directives that you might need to modify on
!     non-SGI/Cray systems and compilers. The <LINK
!     SRC="mpp.html#PORTABILITY">portability of mpp_mod</LINK>
!     obviously is a constraint, since this module is built on top of
!     it. Contact me, Balaji, SGI/GFDL, with questions.
!   </PRECOMP> 
!   <LOADER FLAG="">       
!     The <TT>mpp_domains</TT> source consists of the main source file
!     <TT>mpp_domains.F90</TT> and also requires the following include files:
!    <PRE>
!     <TT>fms_platform.h</TT>
!     <TT>mpp_update_domains2D.h</TT>
!     <TT>mpp_global_reduce.h</TT>
!     <TT>mpp_global_sum.h</TT>
!     <TT>mpp_global_field.h</TT>
!    </PRE>
!    GFDL users can check it out of the main CVS repository as part of
!    the <TT>mpp</TT> CVS module. The current public tag is <TT>galway</TT>.
!    External users can download the latest <TT>mpp</TT> package <LINK SRC=
!    "ftp://ftp.gfdl.gov/pub/vb/mpp/mpp.tar.Z">here</LINK>. Public access
!    to the GFDL CVS repository will soon be made available.

!   </LOADER>

! </INFO>

module ocean_sponges_tracer_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Bonnie Samuels 
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> R.W. Hallberg 
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> M.J. Harrison 
!</CONTACT>
!
!<CONTACT EMAIL="swathi@cmmacs.ernet.in"> P. S. Swathi  
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S. M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! Thickness weighted tracer tendency [tracer*meter/sec] from sponges.
!</OVERVIEW>
!
!<DESCRIPTION>
! This module applies sponges to tracers. The sponges
! can occur at any location and with any distribution in the domain, and
! with any time step and damping rate.  Sponges occur where positive
! inverse restore times occur in the field passed to sponge_init.  An
! array of tracer tendencies due to the sponges is augmented through a
! call to sponge_tracer_source.  The array of tracer tendencies must be
! reset to zero between calls.
!
! Different damping rates can be specified for each field by making
! calls to register_sponge_rate - no sponges are applied to fields for
! which uniformly zero inverse damping rates are set with a call to
! register_sponge_rate.  The value towards which a field is damped is
! set with calls to register_sponge_field; successive calls are used to
! set up linear interpolation of this restore rate.
!
! Sponge data and damping coefficients are generally 3 dimensional. 
!
! The user is responsible for providing (and registering) the data on
! the model grid of values towards which the tracers are being driven.
!</DESCRIPTION>
!
!<NAMELIST NAME="ocean_sponges_tracer_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  For using this module.  Default use_this_module=.false.
!  </DATA> 
!  <DATA NAME="damp_coeff_3d" TYPE="logical">
!  For case when damping coefficients are full 3d field of values.
!  Default damp_coeff_3d=.false., which means damping coeffs are 
!  2d horizontal array.   
!  </DATA> 
!</NAMELIST>
!
use diag_manager_mod,         only: register_diag_field
use fms_mod,                  only: write_version_number, open_namelist_file, close_file
use fms_mod,                  only: file_exist
use fms_mod,                  only: open_namelist_file, check_nml_error, close_file
use fms_mod,                  only: read_data, lowercase, FATAL, WARNING, stdout, stdlog
use mpp_mod,                  only: input_nml_file, mpp_sum, mpp_error, mpp_max
use time_interp_external_mod, only: init_external_field, time_interp_external
use time_manager_mod,         only: time_type, set_date, get_time
use time_manager_mod,         only: operator( + ), operator( - ), operator( // )
use time_manager_mod,         only: operator( > ), operator( == ), operator( <= )

use ocean_domains_mod,        only: get_local_indices
use ocean_parameters_mod,     only: missing_value 
use ocean_types_mod,          only: ocean_domain_type, ocean_grid_type, ocean_thickness_type
use ocean_types_mod,          only: ocean_prog_tracer_type, ocean_options_type, ocean_time_type 
use ocean_workspace_mod,      only: wrk1, wrk2
use ocean_util_mod,           only: diagnose_3d

implicit none

private

#include <ocean_memory.h>

type ocean_sponge_type
   integer :: id                                             ! time_interp_external index
   character(len=32) :: name                                 ! tracer name corresponding to sponge
   real, dimension(:,:,:), pointer :: damp_coeff   => NULL() ! 3d inverse damping rate (tracer units/ sec)
   real, dimension(:,:)  , pointer :: damp_coeff2d => NULL() ! 2d inverse damping rate (tracer units/ sec)
end type ocean_sponge_type


type(ocean_sponge_type), allocatable, dimension(:) :: Sponge
type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

public ocean_sponges_tracer_init
public sponge_tracer_source

character(len=126)  :: version = '$Id: ocean_sponges_tracer.F90,v 20.0 2013/12/14 00:16:24 fms Exp $'
character (len=128) :: tagname = '$Name: tikal $'

! for diagnostics 
logical :: used
integer, dimension(:), allocatable :: id_sponge_tend

integer :: num_prog_tracers      = 0
logical :: module_is_initialized = .FALSE.
logical :: damp_coeff_3d         = .false. 
logical :: use_this_module       = .false. 

! Adaptive restoring
real    :: athresh               = 0.5
real    :: npower                = 1.0
real    :: lambda                = 0.0083
real    :: taumin                = 720
logical :: use_adaptive_restore  = .false.
logical :: use_sponge_after_init = .false.
logical :: use_normalising       = .false.
logical :: use_hard_thump        = .false.
logical :: deflate               = .false.
real    :: deflate_fraction      = 0.6
integer :: secs_to_restore       = 0
integer :: days_to_restore       = 1

logical :: limit_temp            = .false.
real    :: limit_temp_min        = -1.8
real    :: limit_temp_restore    = 10800.

logical :: limit_salt            = .false.
real    :: limit_salt_min        = 0.01
real    :: limit_salt_restore    = 3600.

integer :: secs_restore
integer :: initial_day
integer :: initial_secs
real, allocatable :: sdiffo(:)

namelist /ocean_sponges_tracer_nml/ use_this_module, damp_coeff_3d
namelist /ocean_sponges_tracer_ofam_nml/ &
    use_adaptive_restore, use_sponge_after_init, use_normalising, &
    use_hard_thump, athresh, taumin, lambda, npower, days_to_restore, &
    secs_to_restore, deflate, deflate_fraction, &
    limit_temp, limit_temp_min, limit_temp_restore, &
    limit_salt, limit_salt_min, limit_salt_restore

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_sponges_tracer_init">
!
! <DESCRIPTION>
! This subroutine is intended to be used to initialize the tracer sponges.
! Everything in this subroutine is a user prototype, and should be replacable.
! </DESCRIPTION>
!
subroutine ocean_sponges_tracer_init(Grid, Domain, Time, T_prog, dtime, Ocean_options)

  type(ocean_grid_type),        intent(in), target :: Grid
  type(ocean_domain_type),      intent(in), target :: Domain
  type(ocean_time_type),        intent(in)         :: Time
  type(ocean_prog_tracer_type), intent(in)         :: T_prog(:)
  real,                         intent(in)         :: dtime
  type(ocean_options_type),     intent(inout)      :: Ocean_options

  integer :: i, j, k, n
  integer :: ioun, io_status, ierr
  integer :: index_temp
  integer :: secs, days
  real    :: dtimer

  character(len=128) :: name

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_sponges_tracer_mod (ocean_sponges_tracer_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.

  num_prog_tracers = size(T_prog(:))
  do n=1,num_prog_tracers
     if (trim(T_prog(n)%name) == 'temp') index_temp = n
  enddo

  allocate( Sponge(num_prog_tracers) )

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
  read(input_nml_file, nml=ocean_sponges_tracer_nml, iostat=io_status)
  ierr = check_nml_error(io_status, 'ocean_sponges_tracer_nml')
  read(input_nml_file, nml=ocean_sponges_tracer_ofam_nml, iostat=io_status)
  ierr = check_nml_error(io_status, 'ocean_sponges_tracer_ofam_nml')
#else
  ioun =  open_namelist_file()
  read(ioun, ocean_sponges_tracer_nml, IOSTAT=io_status)
  ierr = check_nml_error(io_status, 'ocean_sponges_tracer_nml')
  rewind(ioun)
  read(ioun, ocean_sponges_tracer_ofam_nml, IOSTAT=io_status)
  ierr = check_nml_error(io_status, 'ocean_sponges_tracer_ofam_nml')
  call close_file(ioun)
#endif
  write(stdlogunit, ocean_sponges_tracer_nml)
  write(stdoutunit, '(/)')
  write(stdoutunit, ocean_sponges_tracer_nml)

  write(stdlogunit, ocean_sponges_tracer_ofam_nml)
  write(stdoutunit, '(/)')
  write(stdoutunit, ocean_sponges_tracer_ofam_nml)

  Dom => Domain
  Grd => Grid

#ifndef MOM_STATIC_ARRAYS    
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
#endif

  do n=1,num_prog_tracers
     Sponge(n)%id = -1
  enddo

  dtimer = 1.0/dtime

  if(use_this_module) then
      write(stdoutunit,*)'==>Note from ocean_sponges_tracer_mod: Using this module.'
      Ocean_options%ocean_sponges_tracer= 'Used ocean tracer sponges.'
  else
      write(stdoutunit,*)'==>Note from ocean_sponges_tracer_mod: NOT using ocean tracer sponges.'
      Ocean_options%ocean_sponges_tracer= 'Did NOT use ocean tracer sponges.'
      return
  endif

  if (use_adaptive_restore) then
    allocate(sdiffo(num_prog_tracers))

    ! Set up some initial times
    call get_time(Time%model_time, secs, days)
    initial_day = days
    initial_secs = secs
  end if

  do n = 1, num_prog_tracers
    if (use_adaptive_restore) then
        allocate(Sponge(n)%damp_coeff(isd:ied,jsd:jed,nk))
        Sponge(n)%damp_coeff=0.0
    else
     ! read damping rates (1/sec)

     name = 'INPUT/'//trim(T_prog(n)%name)//'_sponge_coeff.nc'
     if (file_exist(trim(name))) then
        write(stdoutunit,*) '==> Using sponge damping times specified from file '//trim(name)
        allocate(Sponge(n)%damp_coeff(isd:ied,jsd:jed,nk))
        allocate(Sponge(n)%damp_coeff2d(isd:ied,jsd:jed))
        Sponge(n)%damp_coeff(:,:,:) = 0.0
        Sponge(n)%damp_coeff2d(:,:) = 0.0

        if(damp_coeff_3d) then
            call read_data(name,'coeff',Sponge(n)%damp_coeff,domain=Domain%domain2d,timelevel=1)
        else
            call read_data(name,'coeff',Sponge(n)%damp_coeff2d,domain=Domain%domain2d,timelevel=1)
            do k=1,nk
               do j=jsc,jec
                  do i=isc,iec
                     Sponge(n)%damp_coeff(i,j,k) = Sponge(n)%damp_coeff2d(i,j)
                  enddo
               enddo
            enddo
        endif

        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 if(Grd%tmask(i,j,k) == 0.0) then
                     Sponge(n)%damp_coeff(i,j,k) = 0.0
                 endif
              enddo
           enddo
        enddo

        ! modify damping rates to allow restoring to be solved implicitly
        ! note: test values between zero and 4.0e-8 revert to damping rates defined above

        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 if (dtime*Sponge(n)%damp_coeff(i,j,k) > 4.0e-8) then
                     if (dtime*Sponge(n)%damp_coeff(i,j,k) > 37.0) then
                         Sponge(n)%damp_coeff(i,j,k) = dtimer
                     else
                         Sponge(n)%damp_coeff(i,j,k) = (1.0 - exp(-dtime*Sponge(n)%damp_coeff(i,j,k))) * dtimer
                     endif
                 else if (dtime*Sponge(n)%damp_coeff(i,j,k) <= 0.0) then
                     Sponge(n)%damp_coeff(i,j,k) = 0.0
                 endif
              enddo
           enddo
        enddo
     else
        write(stdoutunit,*) '==> '//trim(name)//' not found.  Sponge not being applied '
        cycle
     endif
    endif

    ! Read restoring data

    name = 'INPUT/'//trim(T_prog(n)%name)//'_sponge.nc'
    Sponge(n)%id = init_external_field(name,T_prog(n)%name,domain=Domain%domain2d)
    if (Sponge(n)%id < 1) then
      call mpp_error(FATAL,&
      '==>Error: in ocean_sponges_tracer_mod: damping rates are specified but sponge values are not')
    endif
    write(stdoutunit,*) '==> Using sponge data specified from file '//trim(name)
  enddo

  ! register diagnostic output
  allocate (id_sponge_tend(num_prog_tracers))
  id_sponge_tend = -1

  do n=1,num_prog_tracers
     if(n==index_temp) then
        id_sponge_tend(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_sponge_tend',&
                   Grd%tracer_axes(1:3), Time%model_time, 'rho*dzt*cp*heating due to sponge',        &
                   trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))
     else
        id_sponge_tend(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_sponge_tend',&
                   Grd%tracer_axes(1:3), Time%model_time, 'rho*dzt*tendency due to sponge',          &
                   trim(T_prog(n)%flux_units), missing_value=missing_value, range=(/-1.e10,1.e10/))
     endif
  enddo


end subroutine ocean_sponges_tracer_init
! </SUBROUTINE> NAME="ocean_sponges_tracer_init"


!#######################################################################
! <SUBROUTINE NAME="sponge_tracer_source">
!
! <DESCRIPTION>
! This subroutine calculates thickness weighted and density weighted
! time tendencies of tracers due to damping by sponges.
! </DESCRIPTION>
!
subroutine sponge_tracer_source(Time, Thickness, T_prog)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)

  integer :: taum1, tau
  integer :: i, j, k, n

  real    :: sdiff, sum_val, adaptive_coeff
  integer :: secs, days, numsecs
  logical :: do_adaptive_restore = .false.  ! Only restore in specified time period.
  logical :: do_normal_restore = .false.  ! Only restore in specified time period.
  logical, save :: first_pass = .true.

  if(.not. use_this_module) return

  taum1 = Time%taum1
  tau   = Time%tau
  wrk1  = 0.0

  if (use_adaptive_restore) then
    secs_restore = days_to_restore * 86400 + secs_to_restore
    sdiff = 0.0
    call get_time(Time%model_time, secs, days)
    numsecs = (days - initial_day) * 86400 + secs - initial_secs

    do_adaptive_restore = (numsecs < secs_restore)
    do_normal_restore = (.not. do_adaptive_restore) .and. use_sponge_after_init
  else
    do_normal_restore = .true.
  endif

  do n=1,size(T_prog(:))

    ! Need to reinitialise wrk2 here due to limiting of temperature.
    wrk2  = 0.0

    if (Sponge(n)%id > 0) then

        ! get sponge value for current time
        call time_interp_external(Sponge(n)%id, Time%model_time, wrk1)
        if (do_adaptive_restore) then
           if (first_pass) then
              if (use_hard_thump) then
                 do k = 1, nk
                    do j = jsd, jed
                       do i = isd, ied
                          T_prog(n)%field(i,j,k,taum1) = wrk1(i,j,k)
                          T_prog(n)%field(i,j,k,tau) = wrk1(i,j,k)
                       end do
                    end do
                 end do
              end if
              wrk2 = abs(T_prog(n)%field(:,:,:,taum1) - wrk1(:,:,:)) &
                     * Grd%tmask(:,:,:)
              sum_val = sum(wrk2(isc:iec,jsc:jec,:))
              call mpp_sum(sum_val)
              sdiffo(n) = sum_val / Grd%wet_t_points
              if (.not. use_normalising) then
                sdiffo(n) = 1.0
              else
                sdiffo(n) = maxval(wrk2)
                call mpp_max(sdiffo(n))
                sdiffo(n) = 1.01 * sdiffo(n)
              endif
           endif

           do k = 1, nk
             do j = jsd, jed
               do i = isd, ied
                 sdiff = abs(T_prog(n)%field(i,j,k,taum1) - wrk1(i,j,k))
                 sdiff = max(sdiff, 1e-9) ! Minimum tolerance
                 adaptive_coeff = 1.0 / (taumin - &
                                         (lambda * real(secs_restore)) &
                                         / (((sdiff / sdiffo(n))**npower) & 
                                            * log(1 - athresh)))
                 wrk2(i,j,k) = Thickness%rho_dzt(i,j,k,tau) * adaptive_coeff &
                                  * (wrk1(i,j,k) - T_prog(n)%field(i,j,k,taum1))
               enddo
             enddo
           enddo
        else if (do_normal_restore) then
            do k = 1, nk
                do j = jsc, jec
                    do i = isc, iec
                        wrk2(i,j,k) = Thickness%rho_dzt(i,j,k,tau) &
                                     * Sponge(n)%damp_coeff(i,j,k) &
                                     * (wrk1(i,j,k) - T_prog(n)%field(i,j,k,taum1))
                    end do
                end do
             end do
        end if

    end if

    ! These tracer relaxation schemes were in the original OFAM and AusCOM
    ! source code, and may be needed by other OFAM-based experiments.
    !
    ! For now, let's keep them in the same place, but they are now turned off
    ! by default.  They may need to be moved or deleted in the future.

    ! Limit to -1.8 deg with 3hour restoring (got other limits here for initialising. Not sure if needed (namelist use?).
    if (limit_temp .and. trim(T_prog(n)%name) == 'temp') then
       do k=1,nk
          do j=jsc,jec
             do i=isc,iec
                wrk2(i,j,k) = wrk2(i,j,k) + Thickness%rho_dzt(i,j,k,tau) &
                    * max(limit_temp_min - T_prog(n)%field(i,j,k,taum1), 0.0) &
                    / limit_temp_restore
!                wrk2(i,j,k) = wrk2(i,j,k)+Thickness%rho_dzt(i,j,k,tau)*min(43.0-T_prog(n)%field(i,j,k,taum1),0.0)/3600.0
             enddo
          enddo
       enddo
    end if

    if (limit_salt .and. trim(T_prog(n)%name) == 'salt') then
       do k=1,nk
          do j=jsc,jec
             do i=isc,iec
                wrk2(i,j,k) = wrk2(i,j,k) + Thickness%rho_dzt(i,j,k,tau) &
                    * max(limit_salt_min - T_prog(n)%field(i,j,k,taum1), 0.0) &
                    / limit_salt_restore
             enddo
          enddo
       enddo
    end if

    ! Update tendency
    do k = 1, nk
        do j = jsc, jec
            do i = isc, iec
                T_prog(n)%th_tendency(i,j,k) = T_prog(n)%th_tendency(i,j,k) &
                                              + wrk2(i,j,k)
            end do
        end do
    end do

    if (id_sponge_tend(n) > 0) call diagnose_3d(Time, Grd, id_sponge_tend(n), &
         T_prog(n)%conversion*wrk2(:,:,:))

  enddo

  first_pass = .false.

  return

end subroutine sponge_tracer_source
! </SUBROUTINE> NAME="sponge_tracer_source"


end module ocean_sponges_tracer_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The local, weak-equilibrium stability functions \label{sec:cmueC}
!
! !INTERFACE:
   subroutine cmue_c(nlev)
!
! !DESCRIPTION:
!
!  This subroutine updates the explicit solution of
!  \eq{bijVertical} and \eq{giVertical} with shape indicated
!  by \eq{b13}. In addition to the simplifications discussed
!  in \sect{sec:cmueB}, $P_b = \epsilon_b$ is assumed
!  in \eq{giVertical} to eliminate the dependency on $\overline{T}$
!  according to \eq{Tequilibrium}.
!  As discussed in \sect{sec:EASM}, this implies that the last of \eq{giVertical}
!  is replaced by \eq{giVerticalEq}. Thus, the $\Gamma$-term in \eq{b13} drops
!  out, and the solution is characterized by $c_\mu$ and $c'_\mu$ only.
!
!  As a consequence, the numerators and the denominator appearing in \eq{cm}
!  are of somewhat different form compared to the result in \sect{sec:cmueA}.
!  They can be written as
!  \begin{equation}
!   \label{vdngEq}
!    \begin{array}{rcl}
!    D         &=& d_0
!               +  d_1 \overline{N}^2  + d_2 \overline{S}^2
!               +  d_3 \overline{N}^2 \overline{S}^2
!               + d_4 \overline{N}^4   + d_5 \overline{S}^4                  \comma \\[3mm]
!    N_n        &=& n_0
!               +  n_1 \overline{N}^2  + n_2 \overline{S}^2                  \comma \\[3mm]
!    N_b       &=& n_{b0}
!               +  n_{b1} \overline{N}^2 + n_{b2} \overline{S}^2
!   \point
!   \end{array}
!  \end{equation}
!
!  The coefficients of $D$ are given by
!  \begin{equation}
!   \label{vdiEq}
!   \begin{array}{rcl}
!     d_0 &=& 36 {\cal N}^3 {\cal N}_b^2                                     \comma \\[3mm]
!     d_1 &=& 84 a_5 a_{b3} {\cal N}^2 {\cal N}_b
!          +  36 a_{b5} {\cal N}^3 {\cal N}_b                                \comma \\[3mm]
!     d_2 &=&  9 (a_{b2}^2 - a_{b1}^2) {\cal N}^3
!           + 12 ( 3 a_3^2 - a_2^2) {\cal N}   {\cal N}_b^2                  \comma \\[3mm]
!     d_3 &=& 12 (a_2 a_{b1} - 3 a_3 a_{b2} ) a_5 a_{b3}  {\cal N}
!           + 12 ( a_3^2 - a_2^2)  a_5 a_{b3} {\cal N}_b                            \\[3mm]
!         &+& 12 ( 3 a_3^2 - a_2^2) a_{b5} {\cal N} {\cal N}_b               \comma \\[3mm]
!     d_4 &=& 48 a_5^2 a_{b3}^2 {\cal N} + 36 a_5 a_{b3}  a_{b5} {\cal N}^2  \comma \\[3mm]
!     d_5 &=&  3 ( 3 a_3^2 - a_2^2)(a_{b2}^2 - a_{b1}^2) {\cal N}
!     \comma
!   \end{array}
!  \end{equation}
!  and the coefficients of the numerators are
!  \begin{equation}
!   \label{vniEq}
!   \begin{array}{rcl}
!     n_0 &=& 36 a_1 {\cal N}^2 {\cal N}_b^2                                 \comma \\[3mm]
!     n_1 &=&-12 a_5 a_{b3} (a_{b1}+a_{b2}) {\cal N}^2
!           -  8 a_5 a_{b3} (-6 a_1+a_2+3 a_3) {\cal N} {\cal N}_b                  \\[3mm]
!         &+& 36 a_1 a_{b5} {\cal N}^2 {\cal N}_b                            \comma \\[3mm]
!     n_2 &=& 9 a_1 (a_{b2}^2 - a_{b1}^2){\cal N}^2
!   \end{array}
!  \end{equation}
!  and
!  \begin{equation}
!   \label{vnbiEq}
!   \begin{array}{rcl}
!     n_{b0} &=& 12 a_{b3} {\cal N}^3 {\cal N}_b                             \comma \\[3mm]
!     n_{b1} &=& 12 a_5 a_{b3}^2 {\cal N}^2                                  \comma \\[3mm]
!     n_{b2} &=&  9 a_1 a_{b3} (a_{b1}-a_{b2}) {\cal N}^2
!              +    a_{b3} (6 a_1 (a_2-3 a_3)
!              -    4 (a_2^2-3 a_3^2) ) {\cal N} {\cal N}_b                  \comma
!   \end{array}
!  \end{equation}
!
!  These polynomials correspond to a slightly generalized form of the solution
!  suggested by \cite{Canutoetal2001a} and \cite{Chengetal2002}. For cases with
!  unstable stratification, the same clipping conditions on $\alpha_N$ is applied
!  as described in \sect{sec:cmueD}. For the cases of extreme shear, the
!  limiter described in the context of \eq{simpleShearCondition} is active.
!
! !USES:
   use turbulence, only: an,as,at
   use turbulence, only: cmue1,cmue2
   use turbulence, only: cm0
   use turbulence, only: cc1
   use turbulence, only: ct1,ctt
   use turbulence, only: a1,a2,a3,a4,a5
   use turbulence, only: at1,at2,at3,at4,at5

   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer, intent(in)       :: nlev

! !DEFINED PARAMETERS:
   REALTYPE, parameter       :: asLimitFact=1.0d0
   REALTYPE, parameter       :: anLimitFact=0.5d0

!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: cmue_c.F90,v $
!  Revision 20.0  2013/12/14 00:13:30  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1  2005-06-27 10:54:33  kbk
!  new files needed
!
!
!EOP
!-----------------------------------------------------------------------
! !LOCAL VARIABLES:
!
     integer                 ::   i
     REALTYPE                ::   N,Nt
     REALTYPE                ::   d0,d1,d2,d3,d4,d5
     REALTYPE                ::   n0,n1,n2,nt0,nt1,nt2
     REALTYPE                ::   dCm,nCm,nCmp,cm3_inv
     REALTYPE                ::   tmp0,tmp1,tmp2
     REALTYPE                ::   asMax,asMaxNum,asMaxDen
     REALTYPE                ::   anMin,anMinNum,anMinDen
!-----------------------------------------------------------------------
!BOC

     N    =   0.5*cc1
     Nt   =   ct1

     d0   =   36.* N**3. * Nt**2.
     d1   =   84.*a5*at3 * N**2. * Nt  + 36.*at5 * N**3. * Nt
     d2   =   9.*(at2**2.-at1**2.) * N**3. - 12.*(a2**2.-3.*a3**2.) * N * Nt**2.
     d3   =   12.*a5*at3*(a2*at1-3.*a3*at2) * N + 12.*a5*at3*(a3**2.-a2**2.) * Nt       &
            + 12.*at5*(3.*a3**2.-a2**2.) * N * Nt
     d4   =   48.*a5**2.*at3**2. * N + 36.*a5*at3*at5 * N**2.
     d5   =   3.*(a2**2.-3.*a3**2.)*(at1**2.-at2**2.) * N


     n0   =   36.*a1 * N**2. * Nt**2.
     n1   = - 12.*a5*at3*(at1+at2) * N**2. + 8.*a5*at3*(6.*a1-a2-3.*a3) * N * Nt        &
            + 36.*a1*at5 * N**2. * Nt
     n2   =   9.*a1*(at2**2.-at1**2.) * N**2.

     nt0  =   12.*at3 * N**3. * Nt
     nt1  =   12.*a5*at3**2.  * N**2.
     nt2  =   9.*a1*at3*(at1-at2) * N**2. + (  6.*a1*(a2-3.*a3)                         &
            - 4.*(a2**2.-3.*a3**2.) )*at3 * N * Nt


     cm3_inv = 1./cm0**3.


 !   mininum value of "an" to insure that "as" > 0 in equilibrium
     anMinNum  = -(d1 + nt0) + sqrt((d1+nt0)**2. - 4.*d0*(d4+nt1))
     anMinDen  = 2.*(d4+nt1)
     anMin     = anMinNum / anMinDen


     do i=0,nlev

!       clip an at minimum value
        an(i) = max(an(i),anLimitFact*anMin)

!       compute maximum as for shear instability
        asMaxNum  = d0*n0 + (d0*n1+d1*n0)*an(i) + (d1*n1+d4*n0)*an(i)*an(i) + d4*n1*an(i)*an(i)*an(i)
        asMaxDen  = d2*n0 + (d2*n1+d3*n0)*an(i) + d3*n1*an(i)*an(i)
        asMax     = asMaxNum / asMaxDen

!       clip as at miximum value
        as(i) = min(as(i),asLimitFact*asMax)

        dCm  = d0  +  d1*an(i) +  d2*as(i) + d3*an(i)*as(i) + d4*an(i)*an(i) + d5*as(i)*as(i)
        nCm  = n0  +  n1*an(i) +  n2*as(i)
        nCmp = nt0 + nt1*an(i) + nt2*as(i)

        cmue1(i) =  cm3_inv*nCm /dCm
        cmue2(i) =  cm3_inv*nCmp/dCm

     end do


     return
   end subroutine cmue_c


!-----------------------------------------------------------------------
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

! ============================================================================
! snow model module
! ============================================================================
module snow_mod

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only : error_mesg, file_exist, check_nml_error, &
     stdlog, write_version_number, close_file, mpp_pe, mpp_root_pe, FATAL, NOTE
use time_manager_mod,   only: time_type, increment_time, time_type_to_real
use constants_mod,      only: tfreeze, hlv, hlf, PI

use land_constants_mod, only : NBANDS
use snow_tile_mod, only : &
     snow_tile_type, read_snow_data_namelist, &
     snow_data_thermodynamics, snow_data_area, snow_data_radiation, snow_data_diffusion, &
     snow_data_hydraulics, max_lev, cpw, clw, csw

use land_tile_mod, only : land_tile_type, land_tile_enum_type, &
     first_elmt, tail_elmt, next_elmt, current_tile, operator(/=)
use land_tile_diag_mod, only : &
     register_tiled_diag_field, send_tile_data, diag_buff_type
use land_data_mod,      only : land_state_type, lnd
use land_tile_io_mod, only : create_tile_out_file, read_tile_data_r1d_fptr, &
     write_tile_data_r1d_fptr, print_netcdf_error, get_input_restart_name, &
     sync_nc_files
use nf_utils_mod, only : nfu_def_dim, nfu_put_att
use land_debug_mod, only : is_watch_point

implicit none
private

! ==== public interfaces =====================================================
public :: read_snow_namelist
public :: snow_init
public :: snow_end
public :: save_snow_restart
public :: snow_get_sfc_temp
public :: snow_get_depth_area
public :: snow_radiation
public :: snow_diffusion
public :: snow_step_1
public :: snow_step_2
! =====end of public interfaces ==============================================


! ==== module variables ======================================================
character(len=*), parameter, private   :: &
       module_name = 'snow_mod' ,&
       version     = '$Id: snow.F90,v 20.0 2013/12/13 23:30:44 fms Exp $' ,&
       tagname     = '$Name: tikal $'

! ==== module variables ======================================================

!---- namelist ---------------------------------------------------------------
logical :: retro_heat_capacity  = .false.
logical :: lm2  = .false.
logical :: steal = .false.
character(len=16):: albedo_to_use = ''  ! or 'brdf-params'
real    :: max_snow             = 1000.
real    :: wet_max              = 0.0  ! TEMP, move to snow_data
real    :: snow_density         = 300. ! TEMP, move to snow_data and generalize
   real :: init_temp = 260.   ! cold-start snow T
   real :: init_pack_ws   =   0.  
   real :: init_pack_wl   =   0.
   real :: min_snow_mass = 0.

namelist /snow_nml/ retro_heat_capacity, lm2, steal, albedo_to_use, &
                    max_snow, wet_max, snow_density, &
                    init_temp, init_pack_ws, init_pack_wl, &
                    min_snow_mass
!---- end of namelist --------------------------------------------------------

logical         :: module_is_initialized =.FALSE.
logical         :: use_brdf
type(time_type) :: time
real            :: delta_time
integer         :: num_l    ! # of snow layers
! next three 'z' variables are all normalized by total snow pack depth
real            :: dz (max_lev) ! relative thicknesses of layers
real            :: z  (max_lev) ! relative depths of layer bounds
real            :: zz (max_lev) ! relative depths of layer centers
real            :: heat_capacity_retro = 1.6e6
real            :: mc_fict

! ==== end of module variables ===============================================

! ==== NetCDF declarations ===================================================
include 'netcdf.inc'
#define __NF_ASRT__(x) call print_netcdf_error((x),module_name,__LINE__)

contains

! ============================================================================
subroutine read_snow_namelist()
  ! ---- local vars
  integer :: unit         ! unit for namelist i/o
  integer :: io           ! i/o status for the namelist
  integer :: ierr         ! error code, returned by i/o routines
  integer :: l            ! layer iterator

  call read_snow_data_namelist(num_l,dz,mc_fict)

  call write_version_number(version, tagname)
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=snow_nml, iostat=io)
  ierr = check_nml_error(io, 'snow_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file()
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=snow_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'snow_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif
  if (mpp_pe() == mpp_root_pe()) then
     unit=stdlog()
     write(unit, nml=snow_nml)
  endif

  ! -------- set up vertical discretization --------
  zz(1) = 0
  do l = 1, num_l
     zz(l+1) = zz(l) + dz(l)
     z(l)    = 0.5*(zz(l+1) + zz(l))
  enddo

end subroutine read_snow_namelist


! ============================================================================
! initialize snow model
subroutine snow_init ( id_lon, id_lat )
  integer, intent(in)               :: id_lon  ! ID of land longitude (X) axis  
  integer, intent(in)               :: id_lat  ! ID of land latitude (Y) axis

  ! ---- local vars ----------------------------------------------------------
  integer :: unit,k         ! unit for various i/o
  type(land_tile_enum_type)     :: te,ce ! tail and current tile list elements
  type(land_tile_type), pointer :: tile  ! pointer to current tile
  character(len=256) :: restart_file_name
  logical :: restart_exists

  module_is_initialized = .TRUE.
  time       = lnd%time
  delta_time = time_type_to_real(lnd%dt_fast)

  ! -------- initialize snow state --------
  call get_input_restart_name('INPUT/snow.res.nc',restart_exists,restart_file_name)
  if (restart_exists) then
     call error_mesg('snow_init',&
          'reading NetCDF restart "'//trim(restart_file_name)//'"',&
          NOTE)
     __NF_ASRT__(nf_open(restart_file_name,NF_NOWRITE,unit))
     call read_tile_data_r1d_fptr(unit, 'temp', snow_temp_ptr  )
     call read_tile_data_r1d_fptr(unit, 'wl'  , snow_wl_ptr )
     call read_tile_data_r1d_fptr(unit, 'ws'  , snow_ws_ptr )
     __NF_ASRT__(nf_close(unit))     
  else
     call error_mesg('snow_init',&
          'cold-starting snow',&
          NOTE)
     te = tail_elmt (lnd%tile_map)
     ce = first_elmt(lnd%tile_map)
     do while(ce /= te)
        tile=>current_tile(ce)  ! get pointer to current tile
        ce=next_elmt(ce)       ! advance position to the next tile
        
        if (.not.associated(tile%snow)) cycle
        do k = 1,num_l
           tile%snow%wl(k) = init_pack_wl * dz(k)
           tile%snow%ws(k) = init_pack_ws * dz(k)
           tile%snow%T(k)  = init_temp
        enddo 
     enddo
  endif

  if (trim(albedo_to_use)=='') then
     use_brdf = .false.
  elseif (trim(albedo_to_use)=='brdf-params') then
     use_brdf = .true.
  else
     call error_mesg('snow_init',&
          'option albedo_to_use="'//&
          trim(albedo_to_use)//'" is invalid, use "" or "brdf-params"',&
          FATAL)
  endif

end subroutine snow_init


! ============================================================================
subroutine snow_end ()

  module_is_initialized =.FALSE.

end subroutine snow_end


! ============================================================================
subroutine save_snow_restart (tile_dim_length, timestamp)
  integer, intent(in) :: tile_dim_length ! length of tile dim. in the output file
  character(*), intent(in) :: timestamp ! timestamp to add to the file name

  ! ---- local vars ----------------------------------------------------------
  integer :: unit            ! restart file i/o unit

  call error_mesg('snow_end','writing NetCDF restart',NOTE)
  ! create output file, including internal structure necessary for tile output
  call create_tile_out_file(unit,'RESTART/'//trim(timestamp)//'snow.res.nc', &
          lnd%coord_glon, lnd%coord_glat, snow_tile_exists, tile_dim_length )

  ! additionally, define vertical coordinate
  if (mpp_pe()==lnd%io_pelist(1)) then
     __NF_ASRT__(nfu_def_dim(unit,'zfull',zz(1:num_l),'depth of level centers'))
     __NF_ASRT__(nfu_put_att(unit,'zfull','positive','down'))
  endif
  call sync_nc_files(unit)

  ! write fields
  call write_tile_data_r1d_fptr(unit,'temp',snow_temp_ptr,'zfull','snow temperature','degrees_K')
  call write_tile_data_r1d_fptr(unit,'wl'  ,snow_wl_ptr,  'zfull','snow liquid water content','kg/m2')
  call write_tile_data_r1d_fptr(unit,'ws'  ,snow_ws_ptr,  'zfull','snow solid water content','kg/m2')
  ! close output file
  if (mpp_pe()==lnd%io_pelist(1)) &
       __NF_ASRT__(nf_close(unit))

end subroutine save_snow_restart

! ============================================================================
subroutine snow_get_sfc_temp(snow, snow_T)
  type(snow_tile_type), intent(in) :: snow
  real, intent(out) :: snow_T
  
  snow_T = snow%T(1)
end subroutine


! ============================================================================
subroutine snow_get_depth_area(snow, snow_depth, snow_area)
  type(snow_tile_type), intent(in) :: snow
  real, intent(out) :: snow_depth, snow_area

  integer :: l

  snow_depth= 0.0
  do l = 1, num_l
     snow_depth = snow_depth + snow%ws(l)
  enddo
  snow_depth = snow_depth / snow_density
  call snow_data_area (snow_depth, snow_area )
end subroutine


! ============================================================================
! compute snow properties needed to do soil-canopy-atmos energy balance
subroutine snow_radiation ( snow_T, cosz, &
     snow_refl_dir, snow_refl_dif, snow_refl_lw, snow_emis )
  real, intent(in) :: snow_T  ! snow temperature, deg K
  real, intent(in) :: cosz ! cosine of zenith angle
  real, intent(out) :: snow_refl_dir(NBANDS), snow_refl_dif(NBANDS), snow_refl_lw, snow_emis

  call snow_data_radiation (snow_T, snow_refl_dir, snow_refl_dif, &
                                snow_emis, cosz, use_brdf )
  snow_refl_lw = 1 - snow_emis
end subroutine 


! ============================================================================
! compute snow properties needed to do soil-canopy-atmos energy balance
subroutine snow_diffusion ( snow, snow_z0s, snow_z0m )
  type(snow_tile_type), intent(in) :: snow
  real, intent(out) :: snow_z0s, snow_z0m

  call snow_data_diffusion ( snow_z0s, snow_z0m )
end subroutine


! ============================================================================
! update snow properties explicitly for time step.
! integrate snow-heat conduction equation upward from bottom of snow
! to surface, delivering linearization of surface ground heat flux.
subroutine snow_step_1 ( snow, snow_G_Z, snow_G_TZ, &
                         snow_active, snow_T, snow_rh, snow_liq, snow_ice, &
                         snow_subl, snow_area, snow_G0, snow_DGDT )
  type(snow_tile_type), intent(inout) :: snow
  real,                 intent(in) :: snow_G_Z
  real,                 intent(in) :: snow_G_TZ
  logical,              intent(out):: snow_active
  real,                 intent(out):: &
       snow_T, snow_rh, snow_liq, snow_ice, &
       snow_subl, snow_area, snow_G0, snow_DGDT

  ! ---- local vars
  real :: snow_depth, bbb, denom, dt_e
  real, dimension(num_l):: aaa, ccc, thermal_cond, dz_phys, heat_capacity
  integer :: l

! ----------------------------------------------------------------------------
! in preparation for implicit energy balance, determine various measures
! of water availability, so that vapor fluxes will not exceed mass limits
! ----------------------------------------------------------------------------

  snow_T = tfreeze
  snow_T = snow%T(1)

  call snow_data_thermodynamics ( snow_rh, thermal_cond )
  snow_depth= 0.0
  do l = 1, num_l
     snow_depth = snow_depth + snow%ws(l)
  enddo
  snow_depth = snow_depth / snow_density
  call snow_data_area (snow_depth, snow_area )
  ! ---- only liquid in the top snow layer is available to freeze implicitly
  snow_liq =     snow%wl(1)
  ! ---- snow in any layer can be melted implicitly
  snow_ice = sum(snow%ws(:))

! ---- fractionate evaporation/sublimation according to sfc phase ratios
!  where (max(snow%ws(1),0.)+max(snow%wl(1),0.)>0)
!      snow_subl = max(snow%ws(1),0.) &
!       /(max(snow%ws(1),0.)+max(snow%wl(1),0.))
!    elsewhere
!      snow_subl = 0
!    endwhere
!  snow_active = snow_subl>0.
  if (snow_depth>0) then
     snow_subl = 1.
  else
     snow_subl = 0
  endif
  snow_active = snow_subl>0.

  do l = 1, num_l
     dz_phys(l) = dz(l)*snow_depth
  enddo

  if (retro_heat_capacity) then
     do l = 1, num_l
        heat_capacity(l) = heat_capacity_retro*dz_phys(l)
     enddo
  else
     do l = 1, num_l
        heat_capacity(l) = mc_fict*dz(l) + &
             clw*snow%wl(l) + csw*snow%ws(l)
     enddo
  endif

!  if(num_l > 1) then
  if (snow_depth > 0) then
     do l = 1, num_l-1
        dt_e = 2 / ( dz_phys(l+1)/thermal_cond(l+1) &
                     + dz_phys(l)/thermal_cond(l)   )
        aaa(l+1) = - dt_e * delta_time / heat_capacity(l+1)
        ccc(l)   = - dt_e * delta_time / heat_capacity(l)
     enddo

     bbb = 1.0 - aaa(num_l) + delta_time*snow_G_TZ/heat_capacity(num_l)
     denom = bbb
     dt_e = aaa(num_l)*(snow%T(num_l) - snow%T(num_l-1)) &
          - delta_time*snow_G_Z/heat_capacity(num_l)
     snow%e(num_l-1) = -aaa(num_l)/denom
     snow%f(num_l-1) = dt_e/denom

     do l = num_l-1, 2, -1
        bbb = 1.0 - aaa(l) - ccc(l)
        denom = bbb + ccc(l)*snow%e(l)
        dt_e = - ( ccc(l)*(snow%T(l+1) - snow%T(l)  ) &
                  -aaa(l)*(snow%T(l)   - snow%T(l-1)) )
        snow%e(l-1) = -aaa(l)/denom
        snow%f(l-1) = (dt_e - ccc(l)*snow%f(l))/denom
     enddo

     denom = delta_time/heat_capacity(1)
     snow_G0    = ccc(1)*(snow%T(2)- snow%T(1) &
          + snow%f(1)) / denom
     snow_DGDT  = (1 - ccc(1)*(1-snow%e(1))) / denom    
  endif

!    else  ! one-level case
!      denom = delta_time/heat_capacity(1)
!      snow_G0    = 0.
!      snow_DGDT  = 1. / denom
!    end if

  if (snow_depth <= 0) then
     snow_G0   = snow_G_Z
     snow_DGDT = snow_G_TZ
  endif

  if(is_watch_point()) then
     write(*,*) 'snow_depth', snow_depth 
     write(*,*) '############ snow_step_1 output'
     write(*,*) 'mask      ', .true.
     write(*,*) 'snow_T    ', snow_T     
     write(*,*) 'snow_rh   ', snow_rh    
     write(*,*) 'snow_liq  ', snow_liq   
     write(*,*) 'snow_ice  ', snow_ice   
     write(*,*) 'snow_subl ', snow_subl  
     write(*,*) 'snow_area ', snow_area  
     write(*,*) 'snow_G_Z  ', snow_G_Z   
     write(*,*) 'snow_G_TZ ', snow_G_TZ  
     write(*,*) 'snow_G0   ', snow_G0    
     write(*,*) 'snow_DGDT ', snow_DGDT  
     write(*,*) '############ end of snow_step_1 output'
  endif

end subroutine snow_step_1



! ============================================================================
! apply boundary flows to snow water and move snow water vertically.
  subroutine snow_step_2 ( snow, snow_subl,                     &
                           vegn_lprec, vegn_fprec, vegn_hlprec, vegn_hfprec, &
                           DTg,  Mg_imp,  evapg,  fswg,  flwg,  sensg,  &
                           use_tfreeze_in_grnd_latent, subs_DT, &
                           subs_M_imp, subs_evap, subs_fsw, subs_flw, subs_sens,  &
                           snow_fsw, snow_flw, snow_sens, &
                           snow_levap, snow_fevap, snow_melt, &
                           snow_lprec, snow_hlprec, snow_lrunf, snow_frunf, &
                           snow_hlrunf, snow_hfrunf, snow_Tbot, snow_Cbot, snow_C, &
                           snow_avrg_T )
  type(snow_tile_type), intent(inout) :: snow
  real, intent(in) :: &
     snow_subl, vegn_lprec, vegn_fprec, vegn_hlprec, vegn_hfprec
  real, intent(in) :: &
     DTg, Mg_imp, evapg, fswg, flwg, sensg
  logical, intent(in) :: use_tfreeze_in_grnd_latent
  real, intent(out) :: &
         subs_DT, subs_M_imp, subs_evap, subs_fsw, subs_flw, subs_sens, &
         snow_fsw, snow_flw, snow_sens, &
         snow_levap, snow_fevap, snow_melt, &
         snow_lprec, snow_hlprec, snow_lrunf, snow_frunf, &
         snow_hlrunf, snow_hfrunf, snow_Tbot, snow_Cbot, snow_C, snow_avrg_T

  ! ---- local vars
  real, dimension(num_l) :: del_t, M_layer
  real :: depth, &
         cap0, dW_l, dW_s, dcap, dheat,&
         melt, melt_per_deg, drain,       &
         snow_mass, sum_liq, &
         sum_heat, sum_sno, &
         snow_transfer, frac,&
         liq_rate, hliq_rate,&
         sno_rate, hsno_rate, fict_heat, &
         evapg_lm2, vegn_fprec_lm2, &
         snow_LMASS, snow_FMASS, snow_HEAT
  integer :: l, l_old
  real :: new_ws(num_l)
  real :: new_wl(num_l)
  real :: new_T(num_l)
  ! --------------------------------------------------------------------------

  depth= 0.
  do l = 1, num_l
    depth = depth + snow%ws(l)
  enddo
  depth = depth / snow_density

  if(is_watch_point()) then
     write(*,*) '############ snow_step_2 input'
     write(*,*) 'mask       ', .TRUE.       
     write(*,*) 'snow_subl  ', snow_subl  
     write(*,*) 'vegn_lprec ', vegn_lprec 
     write(*,*) 'vegn_fprec ', vegn_fprec 
     write(*,*) 'vegn_hlprec', vegn_hlprec
     write(*,*) 'vegn_hfprec', vegn_hfprec
     write(*,*) 'DTg        ', DTg        
     write(*,*) 'Mg_imp     ', Mg_imp     
     write(*,*) 'evapg      ', evapg      
     write(*,*) 'fswg       ', fswg       
     write(*,*) 'flwg       ', flwg       
     write(*,*) 'sensg      ', sensg      
     write(*,*) '############ end of snow_step_2 input'

     write(*,*) 'depth   ', depth
     do l = 1, num_l
        write(*,'(i2,3(x,a,g23.16))') l,&
             ' wl=', snow%wl(l),&
             ' ws=', snow%ws(l),&
             ' T =', snow%T(l)
     enddo
  endif

  snow_LMASS = 0; snow_FMASS = 0; snow_HEAT = 0
  do l = 1, num_l;
        snow_LMASS = snow_LMASS + snow%wl(l)
        snow_FMASS = snow_FMASS + snow%ws(l)
        snow_HEAT = snow_HEAT + &
          (mc_fict*dz(l) + clw*snow%wl(l) + csw*snow%ws(l))  &
                                                * (snow%T(l)-tfreeze)
  enddo

  if(is_watch_point()) then
     write(*,*) ' ***** snow_step_2 checkpoint 1.01 ***** '
     write(*,*) 'LMASS         ', snow_LMASS
     write(*,*) 'FMASS         ', snow_FMASS
     write(*,*) 'HEAT          ', snow_HEAT
  endif

  ! ---- record fluxes -------------------------------------------------------
  if (lm2.and.steal) then
    if (snow_FMASS-Mg_imp > 0.) then
      if (evapg <= (snow_FMASS-Mg_imp)/delta_time) then
          evapg_lm2 = evapg
          vegn_fprec_lm2 = vegn_fprec
      else if (evapg <= (snow_FMASS-Mg_imp)/delta_time+vegn_fprec) then
          evapg_lm2 = evapg
          vegn_fprec_lm2 = vegn_fprec - evapg + (snow_FMASS-Mg_imp)/delta_time
      else
          evapg_lm2 = (snow_FMASS-Mg_imp)/delta_time+vegn_fprec
          vegn_fprec_lm2 = 0.
      endif
    else
      evapg_lm2 = 0.
      vegn_fprec_lm2 = vegn_fprec
    endif
  else
     evapg_lm2 = evapg
     vegn_fprec_lm2 = vegn_fprec
  endif
  vegn_fprec_lm2 = vegn_fprec
  if (depth>0) then
        snow_fsw   = fswg
        snow_flw   = flwg
        snow_sens  = sensg
        snow_levap = evapg_lm2*(1-snow_subl)
        snow_fevap = evapg_lm2*   snow_subl
  else
        snow_fsw    = 0
        snow_flw    = 0
        snow_sens   = 0
        snow_levap  = 0
        snow_fevap  = 0
  endif
  subs_fsw = fswg - snow_fsw
  subs_flw = flwg - snow_flw
  subs_evap = evapg - snow_levap - snow_fevap
  subs_sens = sensg - snow_sens 

  ! ---- load surface temp change and perform back substitution --------------
  if (depth>0) then
      del_t(1) = DTg
      snow%T(1)  = snow%T(1) + del_t(1)
  endif
  if ( num_l > 1) then
     do l = 1, num_l-1
        if (depth>0) then
            del_t(l+1) = snow%e(l) * del_t(l) + snow%f(l)
            snow%T(l+1) = snow%T(l+1) + del_t(l+1)
        endif
     enddo
  endif
  if (depth>0) then
    subs_DT = del_t(num_l)
  else
    subs_DT = DTg
  endif

  if(is_watch_point()) then
     write(*,*) ' ***** snow_step_2 checkpoint 2 ***** '
     do l = 1, num_l
        write(*,'(i2,a,g23.16)') l,' T =', snow%T(l)
     enddo
  endif

  snow_LMASS = 0; snow_FMASS = 0; snow_HEAT = 0
  do l = 1, num_l
        snow_LMASS = snow_LMASS + snow%wl(l)
        snow_FMASS = snow_FMASS + snow%ws(l)
        snow_HEAT = snow_HEAT + &
          (mc_fict*dz(l) + clw*snow%wl(l) + csw*snow%ws(l))  &
                                                * (snow%T(l)-tfreeze)
  enddo

  if(is_watch_point()) then
     write(*,*) ' ***** snow_step_2 checkpoint 2.01 ***** '
     write(*,*) 'LMASS         ', snow_LMASS
     write(*,*) 'FMASS         ', snow_FMASS
     write(*,*) 'HEAT          ', snow_HEAT
  endif

  ! ---- evaporation and sublimation -----------------------------------------
  if (depth>0) then
      snow%wl(1) = snow%wl(1) - snow_levap*delta_time
      snow%ws(1) = snow%ws(1) - snow_fevap*delta_time
      cap0 = mc_fict*dz(1) + clw*snow%wl(1) + csw*snow%ws(1)
      ! T adjustment for nonlinear terms (del_T)*(del_W)
      dheat = delta_time*(clw*snow_levap+csw*snow_fevap)*del_T(1)
      ! take out extra heat not claimed in advance for evaporation
      if (use_tfreeze_in_grnd_latent) dheat = dheat &
            - delta_time*((cpw-clw)*snow_levap+(cpw-csw)*snow_fevap) &
                               *(snow%T(1)-del_T(1)-tfreeze)
      snow%T(1)  = snow%T(1)  + dheat/cap0
    endif

  if(is_watch_point()) then
     write(*,*) ' ***** snow_step_2 checkpoint 2.5 ***** '
     do l = 1, num_l
        write(*,'(i2,3(a,g23.16))')l,&
             ' wl=', snow%wl(l),&
             ' ws=', snow%ws(l),&
             ' T =', snow%T(l)
     enddo
  endif

  snow_LMASS = 0; snow_FMASS = 0; snow_HEAT = 0
  do l = 1, num_l
        snow_LMASS = snow_LMASS + snow%wl(l)
        snow_FMASS = snow_FMASS + snow%ws(l)
        snow_HEAT = snow_HEAT + &
          (mc_fict*dz(l) + clw*snow%wl(l) + csw*snow%ws(l))  &
                                                * (snow%T(l)-tfreeze)
  enddo

  if(is_watch_point()) then
     write(*,*) ' ***** snow_step_2 checkpoint 2.51 ***** '
     write(*,*) 'LMASS         ', snow_LMASS
     write(*,*) 'FMASS         ', snow_FMASS
     write(*,*) 'HEAT          ', snow_HEAT
  endif

  ! ---- distribute implicit phase change downward through snow layers -------
  if (depth>0) then 
      snow_melt = Mg_imp/delta_time
  else
      snow_melt = 0
  endif
  M_layer = 0.
  subs_M_imp = Mg_imp
  do l = 1, num_l
    if (depth>0 .and. subs_M_imp.gt.0) then
        M_layer(l) =  min( subs_M_imp, max(0.,snow%ws(l)) )
        subs_M_imp = subs_M_imp - M_layer(l)
    endif
  enddo
  if (depth>0) then
      M_layer(1) = M_layer(1) + subs_M_imp
      subs_M_imp = 0.
  endif
  do l = 1, num_l
    if (depth>0) then
          cap0 = mc_fict*dz(l) + clw*snow%wl(l) + csw*snow%ws(l)
          snow%wl(l) = snow%wl(l) + M_layer(l)
          snow%ws(l) = snow%ws(l) - M_layer(l)
          snow%T(l)  = tfreeze + (cap0*(snow%T(l)-tfreeze) ) &
                                                          / ( cap0 + (clw-csw)*M_layer(l) )
    endif
  enddo

  if(is_watch_point()) then
     write(*,*) ' ***** snow_step_2 checkpoint 3 ***** '
     do l = 1, num_l
        write(*,'(i2,3(a,g23.16))') l,&
             ' wl=', snow%wl(l),&
             ' ws=', snow%ws(l),&
             '  T=', snow%T(l)
     enddo
  endif

  snow_LMASS = 0; snow_FMASS = 0; snow_HEAT = 0
  do l = 1, num_l
    snow_LMASS = snow_LMASS + snow%wl(l)
    snow_FMASS = snow_FMASS + snow%ws(l)
        snow_HEAT = snow_HEAT + &
          (mc_fict*dz(l) + clw*snow%wl(l) + csw*snow%ws(l))  &
                                                * (snow%T(l)-tfreeze)
  enddo

  if(is_watch_point()) then
     write(*,*) ' ***** snow_step_2 checkpoint 3.01 ***** '
     write(*,*) 'LMASS         ', snow_LMASS
     write(*,*) 'FMASS         ', snow_FMASS
     write(*,*) 'HEAT          ', snow_HEAT
  endif

! ----------------------------------------------------------------------------
!  call snow_data_hydraulics (pars, snow%wl, psi, hyd_cond )

! ---- remainder of mass fluxes and associated sensible heat fluxes ----------
  liq_rate = vegn_lprec
  sno_rate = vegn_fprec_lm2
  hliq_rate = vegn_hlprec
  if (vegn_fprec.ne.0.) then
          hsno_rate = vegn_hfprec*(vegn_fprec_lm2/vegn_fprec)
  else
          hsno_rate = 0.
  endif

  do l = 1, num_l
    if(depth>0 .or. vegn_fprec_lm2>0) then
    ! ---- mix inflow with existing snow and water ---------------------------
          cap0 = mc_fict*dz(l) + clw*snow%wl(l) + csw*snow%ws(l)
          dW_l = liq_rate*delta_time
          dW_s = sno_rate*delta_time
          dcap = clw*dW_l + csw*dW_s
          snow%ws(l) = snow%ws(l) + dW_s
          snow%wl(l) = snow%wl(l) + dW_l
          snow%T(l)  = tfreeze + (cap0*(snow%T(l)-tfreeze) &
                               + (hsno_rate+hliq_rate)*delta_time) /(cap0 + dcap)
    endif

    if(is_watch_point()) then
       write(*,*) ' ***** snow_step_2 checkpoint 4a ***** '
       write(*,'(i2,3(a,g23.16))') l,&
            ' wl=', snow%wl(l),&
            ' ws=', snow%ws(l),&
            '  T=', snow%T(l)
    endif

    if (depth>0 .or. vegn_fprec_lm2>0) then
    ! ---- compute explicit melt/freeze --------------------------------------
          melt_per_deg = (cap0+dcap)/hlf
          if (snow%ws(l)>0 .and. snow%T(l)>tfreeze) then
                  melt =  min(snow%ws(l), (snow%T(l)-tfreeze)*melt_per_deg)
      elseif (snow%wl(l)>0 .and. snow%T(l)<tfreeze) then
                  melt = -min(snow%wl(l), (tfreeze-snow%T(l))*melt_per_deg)
      else
                  melt = 0
          endif
          snow_melt = snow_melt + melt/delta_time
          snow%wl(l) = snow%wl(l) + melt
          snow%ws(l) = snow%ws(l) - melt
!        where (cap0+dcap.ne.0.) &
!        snow%T(l)  = snow%T(l)  - melt/melt_per_deg
          snow%T(l) = tfreeze &
                 + ((cap0+dcap)*(snow%T(l)-tfreeze) - hlf*melt) &
                                                          / ( cap0+dcap + (clw-csw)*melt )
    endif

   if(is_watch_point()) then
      write(*,*) ' ***** snow_step_2 checkpoint 4b ***** '
      write(*,'(i2,3(a,g23.16))')l,&
            ' wl=', snow%wl(l),&
            ' ws=', snow%ws(l),&
            '  T=', snow%T(l)
   endif

   if (depth>0 .or. vegn_fprec_lm2>0) then
    ! ---- compute drainage from this layer to next --------------------------
        drain = max (0., snow%wl(l) - wet_max*snow%ws(l))
        snow%wl(l) = snow%wl(l) - drain
        liq_rate = drain / delta_time
        hliq_rate = clw*liq_rate*(snow%T(l)-tfreeze)
        sno_rate = 0
        hsno_rate = 0
    endif
  enddo

  snow_lprec  = liq_rate
  snow_hlprec = hliq_rate

  snow_LMASS = 0; snow_FMASS = 0; snow_HEAT = 0
  do l = 1, num_l
        snow_LMASS = snow_LMASS + snow%wl(l)
        snow_FMASS = snow_FMASS + snow%ws(l)
        snow_HEAT = snow_HEAT + &
          (mc_fict*dz(l) + clw*snow%wl(l) + csw*snow%ws(l))  &
                                                * (snow%T(l)-tfreeze)
  enddo


  if(is_watch_point()) then
     write(*,*) ' ***** snow_step_2 checkpoint 4c ***** '
     write(*,*) 'LMASS         ', snow_LMASS
     write(*,*) 'FMASS         ', snow_FMASS
     write(*,*) 'HEAT          ', snow_HEAT
  endif

! ---- conceptually remove fictitious mass/heat for the moment ---------------
  fict_heat = 0.
  do l = 1, num_l
    fict_heat = fict_heat + dz(l)*snow%T(l)     ! (*mc_fict)
  enddo

  snow_mass  = sum(snow%ws)
  if(is_watch_point()) then
     write(*,*) ' ***** snow_step_2 checkpoint 4d ***** '
     write(*,*) 'max_snow    ', max_snow
     write(*,*) 'snow_mass   ', snow_mass
  endif

! ---- remove any isolated snow molecules (!) or sweep any excess snow from top of pack ----

  snow_lrunf  = 0.
  snow_frunf  = 0.
  snow_hlrunf = 0.
  snow_hfrunf = 0.
  if (0. < snow_mass .and. snow_mass < min_snow_mass ) then
        do l = 1, num_l
          snow_hlrunf = snow_hlrunf  &
            + clw*snow%wl(l)*(snow%T(l)-tfreeze)
          snow_hfrunf = snow_hfrunf  &
            + csw*snow%ws(l)*(snow%T(l)-tfreeze)
          enddo
        snow_lrunf  = sum(snow%wl)
        snow_frunf  = snow_mass
        snow_mass   = 0.
        snow%ws = 0.
        snow%wl = 0.
    else if (max_snow < snow_mass) then
        snow_frunf  = snow_mass - max_snow
        snow_mass  = max_snow
        sum_sno  = 0
        snow_transfer = 0
        do l = 1, num_l
          if (sum_sno + snow%ws(l) > snow_frunf) then
              snow_transfer = snow_frunf - sum_sno
            else
              snow_transfer = snow%ws(l)
            endif
          if (snow%ws(l) > 0) then
              frac = snow_transfer / snow%ws(l)
            else
              frac = 1.
            endif
          sum_sno  = sum_sno  + snow_transfer
          snow_lrunf  = snow_lrunf  +     frac*snow%wl(l)
          snow_hlrunf = snow_hlrunf + clw*frac*snow%wl(l)*(snow%T(l)-tfreeze)
          snow_hfrunf = snow_hfrunf + csw*frac*snow%ws(l)*(snow%T(l)-tfreeze)
          snow%ws(l) = (1-frac)*snow%ws(l)
          snow%wl(l) = (1-frac)*snow%wl(l)
          enddo
    endif
  snow_lrunf  = snow_lrunf  / delta_time
  snow_frunf  = snow_frunf  / delta_time
  snow_hlrunf = snow_hlrunf / delta_time
  snow_hfrunf = snow_hfrunf / delta_time

  if(is_watch_point()) then
     write(*,*) ' ***** snow_step_2 checkpoint 5 ***** '
     write(*,*) 'fict_heat         ', fict_heat
     do l = 1, num_l
        write(*,'(i2,3(a,g23.16))')l,&
             ' wl=', snow%wl(l),&
             ' ws=', snow%ws(l),&
             ' T =', snow%T(l)
     enddo
  endif

  snow_LMASS = 0; snow_FMASS = 0; snow_HEAT = 0
  do l = 1, num_l
        snow_LMASS = snow_LMASS + snow%wl(l)
        snow_FMASS = snow_FMASS + snow%ws(l)
        snow_HEAT = snow_HEAT + &
          (mc_fict*dz(l) + clw*snow%wl(l) + csw*snow%ws(l))  &
                                                * (snow%T(l)-tfreeze)
  enddo

  if(is_watch_point()) then
     write(*,*) ' ***** snow_step_2 checkpoint 5.01 ***** '
     write(*,*) 'LMASS         ', snow_LMASS
     write(*,*) 'FMASS         ', snow_FMASS
     write(*,*) 'HEAT          ', snow_HEAT
  endif

  depth= 0.
  new_ws=0
  new_wl=0
  new_T=0
  do l = 1, num_l
    depth = depth + snow%ws(l)
  enddo
  depth = depth / snow_density

!************************** fudge to avoid T=NaN from too-small mass **
!   if(depth*snow_density < min_snow_mass .and. depth>0.) then
!       depth = 0
!       snow%ws = 0
!       snow%wl = 0
!     endif

! ---- re-layer the snowpack ------------------------------------------------
  do l = 1, num_l
     if (depth > 0) then
        new_ws(l) = snow_mass*dz(l)
        sum_sno = 0
        sum_liq = 0
        sum_heat = 0
     endif
     do l_old = 1, num_l
        if (depth > 0) then
           if (sum_sno + snow%ws(l_old) > new_ws(l)) then
              snow_transfer = new_ws(l) - sum_sno
           else
              snow_transfer = snow%ws(l_old)
           endif
           if (snow%ws(l_old) .ne. 0.) then
              frac = snow_transfer / snow%ws(l_old)
           else
              frac = 1
           endif
           sum_sno  = sum_sno  + snow_transfer
           sum_liq  = sum_liq  + frac*     snow%wl(l_old)
           sum_heat = sum_heat + frac*&
                (clw*snow%wl(l_old) + csw*snow%ws(l_old))&
                *snow%T(l_old)
           snow%ws(l_old) = (1.-frac)*snow%ws(l_old)
           snow%wl(l_old) = (1.-frac)*snow%wl(l_old)
           if(is_watch_point()) then
              write(*,*) 'l=',l, ' l_old=',l_old,snow_transfer,frac,&
                   sum_sno,sum_liq, sum_heat
           endif
        endif
        
     enddo
     if (depth > 0) then
        new_wl(l) = sum_liq
        new_T(l)  = sum_heat / (clw*new_wl(l) + csw*new_ws(l))
     endif
  enddo

  if(is_watch_point()) then
     write(*,*) ' ***** snow_step_2 checkpoint 5.1 ***** '
     write(*,*) 'depth             ', depth
     write(*,*) 'fict_heat         ', fict_heat
     do l = 1, num_l
        write(*,'(i2,3(a,g23.16))')l,&
             ' new_wl=', new_wl(l),&
             ' new_ws=', new_ws(l),&
             ' new_T =', new_T(l) 
     enddo
  endif

! add back fictional mass/heat
  do l = 1, num_l
    if (depth > 0) &
    new_T(l) = ( &
    (clw*new_wl(l) + csw*new_ws(l))*new_T(l)  &
      + mc_fict*dz(l)*fict_heat ) &
      / (clw*new_wl(l) + csw*new_ws(l) + dz(l)*mc_fict)
  enddo
    
  do l = 1, num_l
    if (depth > 0) then
      snow%ws(l) = new_ws(l)
      snow%wl(l) = new_wl(l)
      snow%T(l)  = new_T(l)
    endif
  enddo

  if(is_watch_point()) then
     write(*,*) ' ***** snow_step_2 checkpoint 6 ***** '
     write(*,*) 'evap         ', subs_evap
     write(*,*) 'snow_lprec', snow_lprec
     write(*,*) 'depth        ', depth
     do l = 1, num_l
        write(*,'(i2,3(a,g23.16))')l,&
             ' wl=', snow%wl(l),&
             ' ws=', snow%ws(l),&
             ' T =', snow%T(l)
     enddo
  endif

  snow_LMASS = 0
  snow_FMASS = 0
  snow_HEAT = 0
  do l = 1, num_l
        snow_LMASS = snow_LMASS + snow%wl(l)
        snow_FMASS = snow_FMASS + snow%ws(l)
        snow_HEAT = snow_HEAT + &
          (mc_fict*dz(l) + clw*snow%wl(l) + csw*snow%ws(l))  &
                            * (snow%T(l)-tfreeze)
  enddo
  snow_Tbot = snow%T(num_l)
  snow_Cbot = mc_fict*dz(num_l) &
        + clw*snow%wl(num_l) + csw*snow%ws(num_l)
  snow_C = sum(mc_fict*dz(1:num_l) &
        + clw*snow%wl(1:num_l) + csw*snow%ws(1:num_l))
  snow_avrg_T = snow_HEAT/snow_C+tfreeze

  if(is_watch_point()) then
     write(*,*) ' ***** snow_step_2 checkpoint 7 ***** '
     write(*,*) 'LMASS         ', snow_LMASS
     write(*,*) 'FMASS         ', snow_FMASS
     write(*,*) 'HEAT          ', snow_HEAT
  endif

  ! ---- increment time and do diagnostics -----------------------------------
  time = increment_time(time, int(delta_time), 0)

end subroutine snow_step_2

! ============================================================================
! tile existence detector: returns a logical value indicating wether component
! model tile exists or not
logical function snow_tile_exists(tile)
   type(land_tile_type), pointer :: tile
   snow_tile_exists = associated(tile%snow)
end function snow_tile_exists

! ============================================================================
! accessor functions: given a pointer to a land tile, they return pointer
! to the desired member of the land tile, of NULL if this member does not
! exist.
subroutine snow_temp_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr(:)
   integer :: n
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%snow)) then
        n = size(tile%snow%T)
        ptr(1:n) => tile%snow%T(1:n)
      endif
   endif
end subroutine snow_temp_ptr

subroutine snow_wl_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr(:)
   integer :: n
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%snow)) then
        n = size(tile%snow%wl)
        ptr(1:n) => tile%snow%wl(1:n)
      endif
   endif
end subroutine snow_wl_ptr

subroutine snow_ws_ptr(tile, ptr)
   type(land_tile_type), pointer :: tile
   real                , pointer :: ptr(:)
   integer :: n
   ptr=>NULL()
   if(associated(tile)) then
      if(associated(tile%snow)) then
        n = size(tile%snow%ws)
        ptr(1:n) => tile%snow%ws(1:n)
      endif
   endif
end subroutine snow_ws_ptr

end module snow_mod

module ocean_convect_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<CONTACT EMAIL="russell.fiedler@csiro.au"> R. Fiedler 
!</CONTACT>
!
!<OVERVIEW>
! Vertically adjusts gravitationally unstable columns of ocean fluid.
!</OVERVIEW>
!
!<DESCRIPTION>
! This module vertically adjusts gravitationally unstable columns of 
! ocean fluid.  
!
! Three algorithms are available:
!
! 1. Full convection from Rahmstorf.  The algorithm produces a fully 
! stable fluid column.  Since most convection propagates downward, the
! scheme looks downward first and follows any instability (upward or
! downward) before checking the other direction. The routine mixes 
! passive tracers only after the entire instability is found. 
!
! 2. Full convection from Rahmstorf as optimized for vector machines
! by Russ Fiedler. 
!
! 3. The Cox (1984) NCON-scheme.  This scheme is recommended only 
! for those wishing to maintain legacy code. 
!
! 4. Legacy (pre TEOS-10) versions now supplied. In TEOS-10 we 
! need to mix S_prog, fdelta first, and then compute S_A. This 
! approach is not the same as mixing S_A directly.
!
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! Stefan Rahmstorf (Ocean Modelling, 1993 vol 101 pages 9-11)
! </REFERENCE>
!
! <NOTE>
! Implementation of the full convection scheme is 
! based on mom2/3 code by Stefan Rahmstorf 
! (rahmstorf@pik-potsdam.de). But  modified slightly 
! for efficiency purposes in mom3.1
! by M. Eby (eby@uvic.ca) in June 2000. Notably, Eby 
! eliminated goto statements.     
! </NOTE>
!
! <NOTE>
! The Eby code was ported to mom4 by Griffies (Stephen.Griffies). 
! </NOTE>
!
! <NOTE>
! To recover the exact same numerical values as the original
! Rahmstorf code, look for the two "Rahmstorf" comments in the code.  
! </NOTE>
!
! </INFO>
!<NAMELIST NAME="ocean_convect_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is false. 
!  </DATA> 
!
!  <DATA NAME="convect_ncon" TYPE="logical">
!  If true, will use the old NCON convection scheme from Cox. 
!  Retained only for legacy purposes to reproduce very old results. 
!  </DATA> 
!  <DATA NAME="ncon" TYPE="integer">
!  Number of passes through the NCON-scheme. 
!  </DATA> 
!  <DATA NAME="convect_full_scalar" TYPE="logical">
!  If true, will use the full convection scheme as implemented at GFDL for scalar
!  machines. 
!  </DATA> 
!  <DATA NAME="convect_full_vector" TYPE="logical">
!  If true, will use the full convection scheme as optimized for vector machines
!  by russell.fiedler@csiro.au. 
!  </DATA> 
!
!</NAMELIST>
!
use constants_mod,       only: epsln 
use diag_manager_mod,    only: register_diag_field
use fms_mod,             only: open_namelist_file, check_nml_error
use fms_mod,             only: write_version_number, close_file
use fms_mod,             only: mpp_error, FATAL, stdout, stdlog
use mpp_mod,             only: input_nml_file 

use ocean_density_mod,    only: density, update_ocean_density_salinity 
use ocean_domains_mod,    only: get_local_indices
use ocean_parameters_mod, only: missing_value
use ocean_types_mod,      only: ocean_time_type, ocean_grid_type, ocean_domain_type, ocean_options_type
use ocean_types_mod,      only: ocean_density_type, ocean_prog_tracer_type, ocean_thickness_type
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3, wrk4, wrk5, wrk6
use ocean_util_mod,       only: diagnose_3d, diagnose_2d
use ocean_tracer_util_mod,only: diagnose_3d_rho


implicit none

private

public ocean_convect_init
public convection

private convection_ncon
private convection_full_scalar 
private convection_full_vector 
private convection_full_scalar_preteos10
private convection_full_vector_preteos10

private convection_diag 
private watermass_diag_init
private watermass_diag

! internally set for computing watermass diagnstics
logical :: compute_watermass_diag = .false. 

! for diagnostics 
integer :: id_neut_rho_convect
integer :: id_wdian_rho_convect
integer :: id_tform_rho_convect
integer :: id_neut_rho_convect_on_nrho
integer :: id_wdian_rho_convect_on_nrho
integer :: id_tform_rho_convect_on_nrho

integer :: id_neut_temp_convect
integer :: id_neut_temp_convect_on_nrho
integer :: id_wdian_temp_convect
integer :: id_wdian_temp_convect_on_nrho
integer :: id_tform_temp_convect
integer :: id_tform_temp_convect_on_nrho

integer :: id_neut_salt_convect
integer :: id_neut_salt_convect_on_nrho
integer :: id_wdian_salt_convect
integer :: id_wdian_salt_convect_on_nrho
integer :: id_tform_salt_convect
integer :: id_tform_salt_convect_on_nrho

integer :: id_ktot=-1
integer :: id_kven=-1
integer, allocatable, dimension(:) :: id_convect
logical :: used

integer :: nkm1         
integer :: index_temp  =-1
integer :: index_salt  =-1
integer :: index_fdelta=-1

logical :: use_preteos10_version=.false.
real    :: dtimer

type(ocean_grid_type), pointer   :: Grd =>NULL()
type(ocean_domain_type), pointer :: Dom =>NULL()

integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk

character(len=128) :: version=&
  '$Id: ocean_convect.F90,v 20.0 2013/12/14 00:16:32 fms Exp $'
character (len=128) :: tagname = &
  '$Name: tikal $'

logical :: module_is_initialized=.FALSE.
logical :: use_this_module      =.false.
logical :: convect_ncon         =.false.  ! for Cox ncon scheme. if false, use Rahmstorf full convection 
logical :: convect_full_scalar  =.false.  ! for full convection scheme implemented at GFDL on scalar machines
logical :: convect_full_vector  =.false.  ! for full convection scheme implemented at CSIRO on vector machines
integer :: ncon=7                         ! number of passes through a column for convect_ncon=.true.   

namelist /ocean_convect_nml/ use_this_module, convect_ncon, ncon,      &
                             convect_full_scalar, convect_full_vector

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_convect_init">
!
! <DESCRIPTION>
!
! Initialize the convection module.
! 
! For the full convection module, we register two fields
! for diagnostic output.  
! <BR/>
! ktot  = number of levels convected  in a vertical column
! <BR/> 
! kven  = number of levels ventilated in a vertical column
!
! Note that ktot can in rare cases count some levels twice, if they
! get involved in two originally separate, but then
! overlapping convection areas in the water column. The field 
! kven is 0 on land, 1 on ocean points with no
! convection, and any value up to nk on convecting points. 
! </DESCRIPTION>
!
subroutine ocean_convect_init (Grid, Domain, Time, Dens, T_prog, Ocean_options, dtime)

  type(ocean_grid_type),        intent(in), target :: Grid
  type(ocean_domain_type),      intent(in), target :: Domain
  type(ocean_time_type),        intent(in)         :: Time
  type(ocean_density_type),     intent(in)         :: Dens
  type(ocean_prog_tracer_type), intent(inout)      :: T_prog(:)
  type(ocean_options_type),     intent(inout)      :: Ocean_options
  real,                         intent(in)         :: dtime

  integer :: n, num_prog_tracers, ioun, ierr, io_status

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL,&
    '==>Error in ocean_convect_mod (ocean_convect_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  num_prog_tracers = size(T_prog(:))

  allocate( id_convect(num_prog_tracers) )
  id_convect(:) = -1

  do n=1,num_prog_tracers
     if (T_prog(n)%name == 'temp')   index_temp   = n
     if (T_prog(n)%name == 'salt')   index_salt   = n
     if (T_prog(n)%name == 'fdelta') index_fdelta = n
  enddo

  Grd => Grid
  Dom => Domain

  call get_local_indices(Dom, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grd%nk
  nkm1 = nk-1

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_convect_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_convect_nml')
#else
  ioun =  open_namelist_file()
  read (ioun,ocean_convect_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_convect_nml')
  call close_file (ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_convect_nml)  
  write (stdlogunit,ocean_convect_nml)

  if(use_this_module) then 
     write(stdoutunit,'(a)') &
     '==>Note: Using convective adjustment to stabilize gravitationally unstable water columns.'
     Ocean_options%convective_adjustment = 'Used convective adjustment.'
  else 
     write(stdoutunit,'(a)') &
     '==>Note: NOT using convective adjustment in gravitationally unstable water columns.'
     Ocean_options%convective_adjustment = 'Did NOT use convective adjustment.'
     return 
  endif 

  if(convect_ncon) then 
      write(stdoutunit,'(a,i3)')' ==>Note: Using the Cox NCON convection scheme with ncon= ', ncon
  elseif(convect_full_vector .or. convect_full_scalar) then  
      write(stdoutunit,'(a)')' ==>Note: Using the Rahmstorf full convection scheme'
      if(convect_full_scalar .and. convect_full_vector) then 
          call mpp_error(FATAL,&
          '==>Error in ocean_convect_mod: "convect_full_vector" and "convect_full_scalar" cannot both be true.')
      endif
      if(convect_full_vector) then 
          write(stdoutunit,'(a)')'   as implemented on vector machines at CSIRO/Hobart.'
      endif
      if(convect_full_scalar) then 
          write(stdoutunit,'(a)')'   as implemented on scalar machines at GFDL.'
      endif
      if (index_fdelta < 0) then
          write(stdoutunit,'(a)')'   Using preTEOS-10 implementation of convective adjustment.'
          use_preteos10_version = .TRUE.
      endif
  else
      write(stdoutunit,'(a)')&
      '==>Error in ocean_convect_mod: no convective adjustment selected, yet use_this_module=.true.. '
      write(stdoutunit,'(a)')&
      '   Choose one of the following: "convect_ncon",  "convect_full_vector", or "convect_full_scalar"'
      call mpp_error(FATAL,&
      '==>ocean_convect_mod: convective adjustment not chosen.  Must choose a scheme since use_this_module=.true.')
  endif 

  ! register fields for diagnostic output
  dtimer = 1.0/dtime

  do n=1,num_prog_tracers 
     id_convect(n) = -1
     if (n == index_temp) then
         id_convect(n) = register_diag_field ('ocean_model', 'convect_heating',               &
                         Grid%tracer_axes(1:3), Time%model_time, 'heating due to convection', &
                         'Watts/m^2', missing_value=missing_value, range=(/-1.e10,1.e10/))
     else
         id_convect(n) = register_diag_field ('ocean_model', 'convect_'//trim(T_prog(n)%name),            &
                         Grid%tracer_axes(1:3), Time%model_time, 'rho*dzt*th_tendency due to convection', &
                        'm*kg/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
     endif
  enddo 

  id_ktot   = register_diag_field ('ocean_model', 'ktot', Grid%tracer_axes(1:2), Time%model_time, &
              'number convecting levels', 'number', missing_value=missing_value, range=(/-10.0,1.e20/))
  id_kven   = register_diag_field ('ocean_model', 'kven', Grid%tracer_axes(1:2), Time%model_time, &
              'number ventilated levels', 'number', missing_value=missing_value, range=(/-10.0,1.e20/))

  call watermass_diag_init(Time, Dens)


end subroutine ocean_convect_init
! </SUBROUTINE>  NAME="ocean_convect_init"


!#######################################################################
! <SUBROUTINE NAME="convection">
!
! <DESCRIPTION>
! Subroutine calls one of the two possible convection schemes. 
! </DESCRIPTION>
!
subroutine convection (Time, Thickness, T_prog, Dens)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_density_type),     intent(inout) :: Dens

  if (.not. use_this_module) return 

  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL,'==>Error in ocean_convect_mod (convection): module needs to be initialized')
  endif 

  if(convect_ncon) then 
    call convection_ncon(Time, Thickness, T_prog, Dens)
  else 
    if (use_preteos10_version) then
      if(convect_full_scalar) call convection_full_scalar_preteos10(Time, Thickness, T_prog, Dens)
      if(convect_full_vector) call convection_full_vector_preteos10(Time, Thickness, T_prog, Dens)
    else
      if(convect_full_scalar) call convection_full_scalar(Time, Thickness, T_prog, Dens)
      if(convect_full_vector) call convection_full_vector(Time, Thickness, T_prog, Dens)
    endif
  endif 

end subroutine convection 
! </SUBROUTINE> NAME="convection"


!#######################################################################
! <SUBROUTINE NAME="convection_full_scalar">
!
! <DESCRIPTION>
! Subroutine to vertically adjust gravitationally unstable columns of ocean fluid.
! Produces updated values for all the tracers.  Code implemented on scalar 
! machines at GFDL. Has been found to be slow on vector machines.  Use 
! convection_full_vector for vector machines.  
!
! internal variables:
!
!     chk_la = logical flag to check level above kt
!
!     chk_lb = logical flag to check level below kb
!
!     kb     = bottom level of (potential) instability
!
!     kbo    = bottom level of ocean
!
!     kt     = top level of (potential) instability
!
!     la     = test level above kt
!
!     lb     = test level below kb
!
!     rl     = lower level density referenced to lower level
!
!     ru     = upper level density referenced to lower level
!
!     tmx    = mixed tracer (1=temp, 2=salt, 3=fdelta, 4=other)
!
!     tsm    = sum of tracers (weighted by thickness) in the instability
!
!     zsm    = total thickness of the instability
!
!     rho_salinity_mx = computed density salinity resulting from mixing of tracers.
!
! </DESCRIPTION>
!
subroutine convection_full_scalar (Time, Thickness, T_prog, Dens)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_density_type),     intent(inout) :: Dens

  real, dimension(4) :: tmx, tsm
  real, dimension(isc:iec,jsc:jec) :: ktot, kven

  logical :: chk_la, chk_lb
  integer :: i, j, k, n, kb, kbo, kt, la, lb, taup1, tau
  real    :: rl, ru, zsm
  real    :: rho_salinity_mx

  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL,'==>Error in ocean_convect_mod (convection_full_scalar): module needs to be initialized')
  endif 

  ! for diagnostics, save initial value of the tracers 

  taup1 = Time%taup1
  tau   = Time%tau
  
  ! save pre-convection tracer concentration for diagnostics 
  do n=1, size(T_prog(:))
     T_prog(n)%wrk1(:,:,:) = T_prog(n)%field(:,:,:,taup1)    
  enddo
  call update_ocean_density_salinity(T_prog,taup1,Dens)
!
! First we treat instabilities arising at the surface.
!

  do j=jsc,jec
    do i=isc,iec
      kbo       = Grd%kmt(i,j)
      ktot(i,j) = 0.0
      kven(i,j) = 0.0

      ! search for unstable regions starting from the top
      kt = 1
      kb = 2
      do while (kt < kbo)

        ru = density (Dens%rho_salinity(i,j,kt,taup1),       &
                      T_prog(index_temp)%field(i,j,kt,taup1),&
                      Dens%pressure_at_depth(i,j,kb))
        rl = density (Dens%rho_salinity(i,j,kb,taup1),       &
                      T_prog(index_temp)%field(i,j,kb,taup1),&
                      Dens%pressure_at_depth(i,j,kb))

        ! sum the first pair found in an unstable region
        if (ru > rl) then
          chk_la = .true.
          chk_lb = .true.
          zsm    = Thickness%rho_dzt(i,j,kt,taup1) + Thickness%rho_dzt(i,j,kb,taup1)
          tsm(1) = T_prog(index_temp)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1) &
                 + T_prog(index_temp)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
          tmx(1) = tsm(1)/zsm
          tsm(2) = T_prog(index_salt)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1) &
                 + T_prog(index_salt)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
          tmx(2) = tsm(2)/zsm
          tsm(3) = T_prog(index_fdelta)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1) &
                 + T_prog(index_fdelta)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
          tmx(3) = tsm(3)/zsm

          ! calculate temporary density_salinity due to mixing 
          rho_salinity_mx = tmx(2) * ( 1.0 + tmx(3) )

          do while (chk_lb .or. chk_la)

            ! check for an unstable level (lb) below kb
            if (kb >= kbo) chk_lb = .false.
            do while (chk_lb)
              chk_lb = .false.
              lb = kb + 1 
              ru = density (rho_salinity_mx, tmx(1), Dens%pressure_at_depth(i,j,lb))
              rl = density (Dens%rho_salinity(i,j,lb,taup1),       &
                            T_prog(index_temp)%field(i,j,lb,taup1),&
                            Dens%pressure_at_depth(i,j,lb))
              if (ru > rl) then
                ! add new level to sums
                kb     = lb
                zsm    = zsm + Thickness%rho_dzt(i,j,kb,taup1)
                tsm(1) = tsm(1) + T_prog(index_temp)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
                tmx(1) = tsm(1)/zsm
                tsm(2) = tsm(2) + T_prog(index_salt)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
                tmx(2) = tsm(2)/zsm
                tsm(3) = tsm(3) + T_prog(index_fdelta)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
                tmx(3) = tsm(3)/zsm
                rho_salinity_mx = tmx(2) * ( 1.0 + tmx(3) )
                chk_la = .true.
                if (kb < kbo) chk_lb = .true.
              endif
            enddo

            ! check for an unstable level (la) above kt
            ! To get equivalent of original Rahmstorf code, uncomment next line
            ! chk_la = .true.
            if (kt <= 1) chk_la = .false.
            do while (chk_la)
              chk_la = .false.
              la = kt - 1
              ru = density (Dens%rho_salinity(i,j,la,taup1),       &
                            T_prog(index_temp)%field(i,j,la,taup1),&
                            Dens%pressure_at_depth(i,j,kt))
              rl = density (rho_salinity_mx, tmx(1), Dens%pressure_at_depth(i,j,kt))
              if (ru > rl) then
                ! add new level to sums
                kt     = la
                zsm    = zsm + Thickness%rho_dzt(i,j,kt,taup1) 
                tsm(1) = tsm(1) + T_prog(index_temp)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1)
                tmx(1) = tsm(1)/zsm
                tsm(2) = tsm(2) + T_prog(index_salt)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1)
                tmx(2) = tsm(2)/zsm
                tsm(3) = tsm(3) + T_prog(index_fdelta)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1)
                tmx(3) = tsm(3)/zsm
                rho_salinity_mx = tmx(2) * ( 1.0 + tmx(3) )
                chk_lb = .true.
                ! to get equivalent of original Rahmstorf code, comment out next line
                if (kt > 1) chk_la = .true.
              endif
            enddo

          enddo

          ! mix all tracers from kt to kb
          do k=kt,kb
            T_prog(index_temp)%field(i,j,k,taup1) = tmx(1)
            T_prog(index_salt)%field(i,j,k,taup1) = tmx(2)
            T_prog(index_fdelta)%field(i,j,k,taup1) = tmx(3)
            Dens%rho_salinity(i,j,k,taup1) = tmx(2) * ( 1.0 + tmx(3) )
          enddo
          do n=1,size(T_prog(:))
            if (n /= index_temp .and. n /= index_salt .and. n /= index_fdelta) then
              tsm(4) = 0.0
              do k=kt,kb
                tsm(4) = tsm(4) + T_prog(n)%field(i,j,k,taup1)*Thickness%rho_dzt(i,j,k,taup1)
              enddo
              tmx(4) = tsm(4)/zsm 
              do k=kt,kb
                T_prog(n)%field(i,j,k,taup1) = tmx(4)
              enddo
            endif
          enddo

          ! compute diagnostic fields
          ktot(i,j) = ktot(i,j) + kb - kt + 1
          if (kt == 1) kven(i,j) = kb

          kt = kb + 1

        else
          kt = kb
        endif

        ! continue the search for other unstable regions
        kb = kt + 1

      enddo   ! while (kt < kbo)

    enddo     ! i=isc,iec
  enddo       ! j=jsc,jec

  call diagnose_2d(Time, Grd, id_ktot, ktot(:,:))
  call diagnose_2d(Time, Grd, id_kven, kven(:,:))

  call convection_diag(Time, Thickness, T_prog, Dens)


end subroutine convection_full_scalar
! </SUBROUTINE> NAME="convection_full_scalar"



!#######################################################################
! <SUBROUTINE NAME="convection_full_vector">
!
! <DESCRIPTION>
! Subroutine to vertically adjust gravitationally unstable columns of ocean fluid.
! Produces updated values for all the tracers.  Code implemented on vector 
! machines at CSIRO. Has been found to be faster on these machines than 
! convection_full_scalar. Answers differ, but not significantly. 
!
! Code written by russell.fiedler@csiro.au 
! most recently modified Aug2011
!
! internal variables:
!
!     chk_la = logical flag to check level above kt
!
!     chk_lb = logical flag to check level below kb
!
!     kb     = bottom level of (potential) instability
!
!     kbo    = bottom level of ocean
!
!     kt     = top level of (potential) instability
!
!     la     = test level above kt
!
!     lb     = test level below kb
!
!     rl     = lower level density referenced to lower level
!
!     ru     = upper level density referenced to lower level
!
!     tmx    = mixed tracer (1=temp, 2=salt, 3=other)
!
!     tsm    = sum of tracers (weighted by thickness) in the instability
!
!     zsm    = total thickness of the instability
!
!     rho_salinity_mx = computed density salinity resulting from mixing of tracers.
!
! </DESCRIPTION>
!
subroutine convection_full_vector (Time, Thickness, T_prog, Dens)
  
  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_density_type),     intent(inout) :: Dens

  real, dimension(4)               :: tmx, tsm
  real, dimension(isc:iec,jsc:jec) :: ktot, kven

  logical :: chk_la, chk_lb
  integer :: i, j, k, n, kb, kbo, kt, la, lb, taup1, tau
  real    :: rl, ru, zsm
  real    ::  rho_salinity_mx

  ! additions for vectorised code
  logical :: unstable(isc:iec)
  integer :: ikven(isc:iec,jsc:jec), kt_temp(isc:iec)
  real    :: zsum(isc:iec),zsum1(isc:iec)
  real    :: rl_line(isd:ied), ru_line(isd:ied)
  real    :: ratio1(isc:iec),ratio2(isc:iec)
  integer :: ikunstable, nunstable
  integer,dimension((iec-isc+1)*nk)  :: iindex,kindex 


  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_convect_mod (convection_full_vector): module needs to be initialized')
  endif 

  ! for diagnostics, save initial value of the tracers 

  taup1 = Time%taup1
  tau   = Time%tau
  
  ! save pre-convection tracer concentration for diagnostics 
  do n=1, size(T_prog(:))
    T_prog(n)%wrk1(:,:,:) = T_prog(n)%field(:,:,:,taup1)    
  enddo
  call update_ocean_density_salinity(T_prog,taup1,Dens)
!
! First we treat instabilities arising at the surface.
!

  do j=jsc,jec
!
! Initialise instability flag. Mask land points.
!
    do i=isc,iec
      if(Grd%kmt(i,j) .ne. 0) then
        unstable(i)=.true.
      else
        unstable(i)=.false.
      endif
    
      ikven(i,j)=0
      zsum1(i)=Thickness%rho_dzt(i,j,1,taup1)
    enddo
    do k=1,nk-1
!
! Calculate depth of this cell and the one below it; If we hit land column has
! been stabilised.
!
      do i=isc,iec
        zsum(i)=zsum1(i)
        zsum1(i)=zsum1(i)+Thickness%rho_dzt(i,j,k+1,taup1)
        ratio1(i)=zsum(i)/zsum1(i)
        ratio2(i)=1.0-ratio1(i)
        if(k >= Grd%kmt(i,j)) then
          unstable(i) = .false.
        endif
      enddo
!
! Check if entire row has been stabilised.
!
      if(.not.any(unstable(:))) exit
!
! Main part.
! calculate densities for this row and the one below it
! If unstable, mix the layers and mark the depth to which convection has
! occured.
!
      ru_line = density(Dens%rho_salinity(:,j,k,taup1),       &
                        T_prog(index_temp)%field(:,j,k,taup1),&
                        Dens%pressure_at_depth(:,j,k+1))
      rl_line = density(Dens%rho_salinity(:,j,k+1,taup1),       &
                        T_prog(index_temp)%field(:,j,k+1,taup1),&
                        Dens%pressure_at_depth(:,j,k+1))

      do n=1,size(T_prog(:))
        do i=isc,iec
          if(unstable(i)) then
            if(ru_line(i) > rl_line(i)) then
              T_prog(n)%field(i,j,k+1,taup1) = T_prog(n)%field(i,j,k+1,taup1)*ratio2(i) + &
                                               T_prog(n)%field(i,j,k,taup1)*ratio1(i)
              ikven(i,j)=k+1
            else
              unstable(i)=.false.
            endif
          endif
        enddo
      enddo
      ! update density_salinity after downward mixing
      do i=isc,iec
         if(unstable(i)) then
           if(ru_line(i) > rl_line(i)) then
              Dens%rho_salinity(i,j,k+1,taup1) = T_prog(index_salt)%field(i,j,k+1,taup1)* &
                                                 (1.0 + T_prog(index_fdelta)%field(i,j,k+1,taup1))
           endif
        endif
      enddo
      if(.not. any(unstable(:))) exit
    enddo

!
! Now adjust all the layerabove the bottom of the instablity
!
    do n=1,size(T_prog(:))
      do k=1,maxval(ikven(:,j))-1
        do i=isc,iec
          if(k <= ikven(i,j)-1) then
            T_prog(n)%field(i,j,k,taup1)=T_prog(n)%field(i,j,ikven(i,j),taup1)
          endif
        enddo
      enddo
    enddo
  enddo

  ! update density_salinity before proceeding
  call update_ocean_density_salinity(T_prog,taup1,Dens)

!
! now treat instabilies arising within the water column.
!
  ktot=0.0
  kven=0.0

  jloop: do j=jsc,jec
!
! Preliminary sweep through density field to eliminate stable columns 
! Note that top level is necessarily stable from initial sweep.
! 
   kt_temp=nk
   nunstable=0
   iindex=0
   kindex=0     
   kloop: do k=2,maxval(Grd%kmt(isc:iec,j))-1
      ru_line = density(Dens%rho_salinity(:,j,k,taup1),       &
                        T_prog(index_temp)%field(:,j,k,taup1),&
                        Dens%pressure_at_depth(:,j,k+1))
      rl_line = density(Dens%rho_salinity(:,j,k+1,taup1),       &
                        T_prog(index_temp)%field(:,j,k+1,taup1),&
                        Dens%pressure_at_depth(:,j,k+1))
!
! If an instability occurs anywhere at this level exit to the main loop
! and process as normal.
!
      do i=isc,iec
        if(k < Grd%kmt(i,j) .and. ru_line(i) > rl_line(i)) then
          nunstable=nunstable+1                                    
          iindex(nunstable)=i                                      
          kindex(nunstable)=k                                      
        endif
      enddo
    enddo kloop
    if(nunstable .eq. 0) cycle jloop 

    do ikunstable=1,nunstable                                      
      i   = iindex(ikunstable)                                         
      kt  = kindex(ikunstable)                                        
      kbo = Grd%kmt(i,j)                                     
      kb  = kt+1                                                    

        ru = density (Dens%rho_salinity(i,j,kt,taup1),       &
                      T_prog(index_temp)%field(i,j,kt,taup1),&
                      Dens%pressure_at_depth(i,j,kb))
        rl = density (Dens%rho_salinity(i,j,kb,taup1),       &
                      T_prog(index_temp)%field(i,j,kb,taup1),&
                      Dens%pressure_at_depth(i,j,kb))

        ! sum the first pair found in an unstable region
        if (ru > rl) then
          chk_la = .true.
          chk_lb = .true.
          zsm    = Thickness%rho_dzt(i,j,kt,taup1) + Thickness%rho_dzt(i,j,kb,taup1)
          tsm(1) =   T_prog(index_temp)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1) &
                   + T_prog(index_temp)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
          tmx(1) = tsm(1)/zsm
          tsm(2) = T_prog(index_salt)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1) &
                 + T_prog(index_salt)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
          tmx(2) = tsm(2)/zsm
          tsm(3) = T_prog(index_fdelta)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1) &
                 + T_prog(index_fdelta)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
          tmx(3) = tsm(3)/zsm
          ! calculate temporary density_salinity due to mixing 
          rho_salinity_mx = tmx(2) * ( 1.0 + tmx(3) )

          do while (chk_lb .or. chk_la)

            ! check for an unstable level (lb) below kb
            if (kb >= kbo) chk_lb = .false.
            do while (chk_lb)
              chk_lb = .false.
              lb = kb + 1 
              ru = density (rho_salinity_mx,tmx(1),Dens%pressure_at_depth(i,j,lb))
              rl = density (Dens%rho_salinity(i,j,lb,taup1),       &
                            T_prog(index_temp)%field(i,j,lb,taup1),&
                            Dens%pressure_at_depth(i,j,lb))
              if (ru > rl) then
                ! add new level to sums
                kb = lb
                zsm = zsm + Thickness%rho_dzt(i,j,kb,taup1)
                tsm(1) = tsm(1) + T_prog(index_temp)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
                tmx(1) = tsm(1)/zsm
                tsm(2) = tsm(2) + T_prog(index_salt)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
                tmx(2) = tsm(2)/zsm
                tsm(3) = tsm(3) + T_prog(index_fdelta)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
                tmx(3) = tsm(3)/zsm
                rho_salinity_mx = tmx(2) * ( 1.0 + tmx(3) )
                chk_la = .true.
                if (kb < kbo) chk_lb = .true.
              endif
            enddo

            ! check for an unstable level (la) above kt
            ! To get equivalent of original Rahmstorf code, uncomment next line
            ! chk_la = .true.
            if (kt <= 1) chk_la = .false.
            do while (chk_la)
              chk_la = .false.
              la = kt - 1
              ru = density (Dens%rho_salinity(i,j,la,taup1),       & 
                            T_prog(index_temp)%field(i,j,la,taup1),&
                            Dens%pressure_at_depth(i,j,kt))
              rl = density (rho_salinity_mx, tmx(1), Dens%pressure_at_depth(i,j,kt))
              if (ru > rl) then
                ! add new level to sums
                kt = la
                zsm = zsm + Thickness%rho_dzt(i,j,kt,taup1) 
                tsm(1) = tsm(1) + T_prog(index_temp)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1)
                tmx(1) = tsm(1)/zsm
                tsm(2) = tsm(2) + T_prog(index_salt)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1)
                tmx(2) = tsm(2)/zsm
                tsm(3) = tsm(3) + T_prog(index_fdelta)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1)
                tmx(3) = tsm(3)/zsm
                rho_salinity_mx = tmx(2) * ( 1.0 + tmx(3) )
                chk_lb = .true.
                ! to get equivalent of original Rahmstorf code, comment out next line
                if (kt > 1) chk_la = .true.
              endif
            enddo

          enddo

          ! mix all tracers from kt to kb
          do k=kt,kb
            T_prog(index_temp)%field(i,j,k,taup1)   = tmx(1)
            T_prog(index_salt)%field(i,j,k,taup1)   = tmx(2)
            T_prog(index_fdelta)%field(i,j,k,taup1) = tmx(3)
            Dens%rho_salinity(i,j,k,taup1) = tmx(2) * ( 1.0 + tmx(3) )
          enddo
          do n=1,size(T_prog(:))
            if (n /= index_temp .and. n /= index_salt .and. n /= index_fdelta) then
              tsm(4) = 0.0
              do k=kt,kb
                tsm(4) = tsm(4) + T_prog(n)%field(i,j,k,taup1)*Thickness%rho_dzt(i,j,k,taup1)
              enddo
              tmx(4) = tsm(4)/zsm 
              do k=kt,kb
                T_prog(n)%field(i,j,k,taup1) = tmx(4)
              enddo
            endif
          enddo

          ! compute diagnostic fields
          ktot(i,j) = ktot(i,j) + kb - kt + 1
          if (kt == 1) kven(i,j) = kb


        endif

    enddo         !ikunstable 
  enddo jloop     ! j=jsc,jec


  ! merge diagnostic information 
  do j=jsc,jec
    do i=isc,iec
      if(real(ikven(i,j)) > kven(i,j)) then
        kven(i,j)=ikven(i,j)
        ktot(i,j)=ikven(i,j)
      endif
    enddo
  enddo

  ! write diagnostics 
  call convection_diag(Time, Thickness, T_prog, Dens)
  call diagnose_2d(Time, Grd, id_ktot, ktot(:,:))
  call diagnose_2d(Time, Grd, id_kven, kven(:,:))


end subroutine convection_full_vector
! </SUBROUTINE> NAME="convection_full_vector"


!#######################################################################
! <SUBROUTINE NAME="convection_ncon">
!
! <DESCRIPTION>
! "ncon" convection scheme
!
! Convectively adjust water column if gravitationally unstable.
! Based on algorithm from Mike Cox used in his code from 1984.  
! Algorithm has well known problems with incomplete homogenization
! and sensitivity to the ncon parameter. 
!
! Coded in mom4 for legacy purposes by Stephen.Griffies
! April 2001  
!
! </DESCRIPTION>
!
subroutine convection_ncon (Time, Thickness, T_prog, Dens)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_density_type),     intent(inout) :: Dens

  integer :: i, j, k, l, ks, n, nn
  integer :: tau, taup1
  real    :: dense 

  taup1 = Time%taup1
  tau   = Time%tau

  ! save pre-convection tracer concentration for diagnostics 
  do n=1, size(T_prog(:))
     T_Prog(n)%wrk1(:,:,:) = T_prog(n)%field(:,:,:,taup1)    
  enddo
  wrk1 = 0.0

  ! ks=1: compare levels 1 to 2; 3 to 4; etc.
  ! ks=2: compare levels 2 to 3; 4 to 5; etc.
  do nn=1,ncon
    do ks=1,2

     ! can do update here safely. We will still be updating outside this routine
      call update_ocean_density_salinity(T_prog,taup1,Dens)

      ! find density with reference pressure determined by vertical pairs 
      do j=jsc,jec
        do l=1,nk,2
          if (ks .eq. 1) then
            k = min(l+1,nk)
          else
            k = l
          endif
          do i=isc,iec
            wrk1(i,j,l)=density(Dens%rho_salinity(i,j,l,taup1),       &
                                T_prog(index_temp)%field(i,j,l,taup1),&
                                Dens%pressure_at_depth(i,j,k))
          enddo
        enddo
      enddo
      do j=jsc,jec
        do l=2,nk,2
          if (ks .eq. 1) then
            k = l
          else
            k = min(l+1,nk)
          endif
          do i=isc,iec
            wrk1(i,j,l)=density(Dens%rho_salinity(i,j,l,taup1),       &
                                T_prog(index_temp)%field(i,j,l,taup1),&
                                Dens%pressure_at_depth(i,j,k))
          enddo
        enddo
      enddo

      ! set "heavy water" in land to stop convection
      dense = 1.e30
      do j=jsc,jec
        do i=isc,iec
          k = Grd%kmt(i,j) + 1
          if (k .le. nk) wrk1(i,j,k) = dense
        enddo
      enddo

      !if unstable, then mix tracers on adjoining levels
      do n=1,size(T_prog(:))
        do j=jsc,jec
          do k=ks,nkm1,2
            do i=isc,iec
              if (wrk1(i,j,k) .gt. wrk1(i,j,k+1)) then
                T_prog(n)%field(i,j,k,taup1) = (  Thickness%rho_dzt(i,j,k,taup1)*T_prog(n)%field(i,j,k,taup1)      &
                                                 +Thickness%rho_dzt(i,j,k+1,taup1)*T_prog(n)%field(i,j,k+1,taup1)) &
                                                /(Thickness%rho_dzt(i,j,k,taup1) + Thickness%rho_dzt(i,j,k+1,taup1))
                T_prog(n)%field(i,j,k+1,taup1) = T_prog(n)%field(i,j,k,taup1)
              endif
            enddo
          enddo
        enddo
      enddo

    enddo  !ks=1,2
  enddo    !nn=1,ncon

  ! make rho_salinity consistent
  call update_ocean_density_salinity(T_prog, taup1, Dens)

  ! call diagnostics 
  call convection_diag(Time, Thickness, T_prog, Dens)


end subroutine convection_ncon
! </SUBROUTINE> NAME="convection_ncon"


!#######################################################################
! <SUBROUTINE NAME="convection_full_scalar_preteos10">
!
! <DESCRIPTION>
!
! This routine is a legacy version which is consistent with using the old equation of state.
!
! Subroutine to vertically adjust gravitationally unstable columns of ocean fluid.
! Produces updated values for all the tracers.  Code implemented on scalar 
! machines at GFDL. Has been found to be slow on vector machines.  Use 
! convection_full_vector_preteos10 for vector machines.  
!
! internal variables:
!
!     chk_la = logical flag to check level above kt
!
!     chk_lb = logical flag to check level below kb
!
!     kb     = bottom level of (potential) instability
!
!     kbo    = bottom level of ocean
!
!     kt     = top level of (potential) instability
!
!     la     = test level above kt
!
!     lb     = test level below kb
!
!     rl     = lower level density referenced to lower level
!
!     ru     = upper level density referenced to lower level
!
!     tmx    = mixed tracer (1=temp, 2=salt, 3=other)
!
!     tsm    = sum of tracers (weighted by thickness) in the instability
!
!     zsm    = total thickness of the instability
!
! </DESCRIPTION>
!
subroutine convection_full_scalar_preteos10 (Time, Thickness, T_prog, Dens)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_density_type),     intent(inout) :: Dens

  real, dimension(3) :: tmx, tsm
  real, dimension(isc:iec,jsc:jec) :: ktot, kven

  integer :: i, j, k, n, kb, kbo, kt, la, lb, taup1, tau
  real :: rl, ru, zsm
  logical :: chk_la, chk_lb

  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL,&
    '==>Error in ocean_convect_mod (convection_full_scalar_preteos10): module needs to be initialized')
  endif 

  ! for diagnostics, save initial value of the tracers 

  taup1 = Time%taup1
  tau   = Time%tau
  
  do n=1, size(T_prog(:))
     T_prog(n)%wrk1(:,:,:) = T_prog(n)%field(:,:,:,taup1)    
  enddo

  do j=jsc,jec
    do i=isc,iec
      kbo       = Grd%kmt(i,j)
      ktot(i,j) = 0.0
      kven(i,j) = 0.0

      ! search for unstable regions starting from the top
      kt = 1
      kb = 2
      do while (kt < kbo)

        ru = density (T_prog(index_salt)%field(i,j,kt,taup1),&
                      T_prog(index_temp)%field(i,j,kt,taup1),&
                      Dens%pressure_at_depth(i,j,kb))
        rl = density (T_prog(index_salt)%field(i,j,kb,taup1),&
                      T_prog(index_temp)%field(i,j,kb,taup1),&
                      Dens%pressure_at_depth(i,j,kb))

        ! sum the first pair found in an unstable region
        if (ru > rl) then
          chk_la = .true.
          chk_lb = .true.
          zsm    = Thickness%rho_dzt(i,j,kt,taup1) + Thickness%rho_dzt(i,j,kb,taup1)
          tsm(1) = T_prog(index_temp)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1) &
                 + T_prog(index_temp)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
          tmx(1) = tsm(1)/zsm
          tsm(2) = T_prog(index_salt)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1) &
                 + T_prog(index_salt)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
          tmx(2) = tsm(2)/zsm

          do while (chk_lb .or. chk_la)

            ! check for an unstable level (lb) below kb
            if (kb >= kbo) chk_lb = .false.
            do while (chk_lb)
              chk_lb = .false.
              lb = kb + 1 
              ru = density (tmx(2)     ,tmx(1)     ,Dens%pressure_at_depth(i,j,lb))
              rl = density (T_prog(index_salt)%field(i,j,lb,taup1),&
                            T_prog(index_temp)%field(i,j,lb,taup1),&
                            Dens%pressure_at_depth(i,j,lb))
              if (ru > rl) then
                ! add new level to sums
                kb     = lb
                zsm    = zsm + Thickness%rho_dzt(i,j,kb,taup1)
                tsm(1) = tsm(1) + T_prog(index_temp)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
                tmx(1) = tsm(1)/zsm
                tsm(2) = tsm(2) + T_prog(index_salt)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
                tmx(2) = tsm(2)/zsm
                chk_la = .true.
                if (kb < kbo) chk_lb = .true.
              endif
            enddo

            ! check for an unstable level (la) above kt
            ! To get equivalent of original Rahmstorf code, uncomment next line
            ! chk_la = .true.
            if (kt <= 1) chk_la = .false.
            do while (chk_la)
              chk_la = .false.
              la = kt - 1
              ru = density (T_prog(index_salt)%field(i,j,la,taup1),&
                            T_prog(index_temp)%field(i,j,la,taup1),&
                            Dens%pressure_at_depth(i,j,kt))
              rl = density (tmx(2), tmx(1), Dens%pressure_at_depth(i,j,kt))
              if (ru > rl) then
                ! add new level to sums
                kt     = la
                zsm    = zsm + Thickness%rho_dzt(i,j,kt,taup1) 
                tsm(1) = tsm(1) + T_prog(index_temp)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1)
                tmx(1) = tsm(1)/zsm
                tsm(2) = tsm(2) + T_prog(index_salt)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1)
                tmx(2) = tsm(2)/zsm
                chk_lb = .true.
                ! to get equivalent of original Rahmstorf code, comment out next line
                if (kt > 1) chk_la = .true.
              endif
            enddo

          enddo

          ! mix all tracers from kt to kb
          do k=kt,kb
            T_prog(index_temp)%field(i,j,k,taup1) = tmx(1)
            T_prog(index_salt)%field(i,j,k,taup1) = tmx(2)
          enddo
          do n=1,size(T_prog(:))
            if (n /= index_temp .and. n /= index_salt) then
              tsm(3) = 0.0
              do k=kt,kb
                tsm(3) = tsm(3) + T_prog(n)%field(i,j,k,taup1)*Thickness%rho_dzt(i,j,k,taup1)
              enddo
              tmx(3) = tsm(3)/zsm 
              do k=kt,kb
                T_prog(n)%field(i,j,k,taup1) = tmx(3)
              enddo
            endif
          enddo

          ! compute diagnostic fields
          ktot(i,j) = ktot(i,j) + kb - kt + 1
          if (kt == 1) kven(i,j) = kb

          kt = kb + 1

        else
          kt = kb
        endif

        ! continue the search for other unstable regions
        kb = kt + 1

      enddo   ! while (kt < kbo)

    enddo     ! i=isc,iec
  enddo       ! j=jsc,jec


  ! update density salinity fields 
  call update_ocean_density_salinity(T_prog, taup1, Dens)

  ! diagnostics   
  call convection_diag(Time, Thickness, T_prog, Dens)
  call diagnose_2d(Time, Grd, id_ktot, ktot(:,:))
  call diagnose_2d(Time, Grd, id_kven, kven(:,:))


end subroutine convection_full_scalar_preteos10
! </SUBROUTINE> NAME="convection_full_scalar_preteos10"


!#######################################################################
! <SUBROUTINE NAME="convection_full_vector_preteos10">
!
! <DESCRIPTION>
!
! This routine is a legacy version which is consistent with using the old equation of state.
!
! Subroutine to vertically adjust gravitationally unstable columns of ocean fluid.
! Produces updated values for all the tracers.  Code implemented on vector 
! machines at CSIRO. Has been found to be faster on these machines than 
! convection_full_scalar_preteos10. Answers differ, but not significantly. 
!
! Code written by russell.fiedler@csiro.au 
! most recently modified Aug2011 
!
! internal variables:
!
!     chk_la = logical flag to check level above kt
!
!     chk_lb = logical flag to check level below kb
!
!     kb     = bottom level of (potential) instability
!
!     kbo    = bottom level of ocean
!
!     kt     = top level of (potential) instability
!
!     la     = test level above kt
!
!     lb     = test level below kb
!
!     rl     = lower level density referenced to lower level
!
!     ru     = upper level density referenced to lower level
!
!     tmx    = mixed tracer (1=temp, 2=salt, 3=other)
!
!     tsm    = sum of tracers (weighted by thickness) in the instability
!
!     zsm    = total thickness of the instability
!
! </DESCRIPTION>
!
subroutine convection_full_vector_preteos10 (Time, Thickness, T_prog, Dens)
  
  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  type(ocean_prog_tracer_type), intent(inout) :: T_prog(:)
  type(ocean_density_type),     intent(inout) :: Dens

  real, dimension(3)               :: tmx, tsm
  real, dimension(isc:iec,jsc:jec) :: ktot, kven

  integer :: i, j, k, n, kb, kbo, kt, la, lb, taup1, tau
  real    :: rl, ru, zsm
  logical :: chk_la, chk_lb

  ! additions for vectorised code
  logical :: unstable(isc:iec)
  integer :: ikven(isc:iec,jsc:jec), kt_temp(isc:iec)
  real    :: zsum(isc:iec),zsum1(isc:iec)
  real    :: rl_line(isd:ied), ru_line(isd:ied)
  real    :: ratio1(isc:iec),ratio2(isc:iec)
  integer :: ikunstable, nunstable
  integer,dimension((iec-isc+1)*nk)  :: iindex,kindex 


  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_convect_mod (convection_full_vector_preteos10): module needs to be initialized')
  endif 

  ! for diagnostics, save initial value of the tracers 

  taup1 = Time%taup1
  tau   = Time%tau
  
  do n=1, size(T_prog(:))
    T_prog(n)%wrk1(:,:,:) = T_prog(n)%field(:,:,:,taup1)    
  enddo

!
! First we treat instabilities arising at the surface.
!

  do j=jsc,jec
!
! Initialise instability flag. Mask land points.
!
    do i=isc,iec
      if(Grd%kmt(i,j) .ne. 0) then
        unstable(i)=.true.
      else
        unstable(i)=.false.
      endif
    
      ikven(i,j)=0
      zsum1(i)=Thickness%rho_dzt(i,j,1,taup1)
    enddo
    do k=1,nk-1
!
! Calculate depth of this cell and the one below it; If we hit land column has
! been stabilised.
!
      do i=isc,iec
        zsum(i)=zsum1(i)
        zsum1(i)=zsum1(i)+Thickness%rho_dzt(i,j,k+1,taup1)
        ratio1(i)=zsum(i)/zsum1(i)
        ratio2(i)=1.0-ratio1(i)
        if(k >= Grd%kmt(i,j)) then
          unstable(i) = .false.
        endif
      enddo
!
! Check if entire row has been stabilised.
!
      if(.not.any(unstable(:))) exit
!
! Main part.
! calculate densities for this row and the one below it
! If unstable, mix the layers and mark the depth to which convection has
! occured.
!
      ru_line = density(T_prog(index_salt)%field(:,j,k,taup1),&
                        T_prog(index_temp)%field(:,j,k,taup1),&
                        Dens%pressure_at_depth(:,j,k+1))
      rl_line = density(T_prog(index_salt)%field(:,j,k+1,taup1),&
                        T_prog(index_temp)%field(:,j,k+1,taup1),&
                        Dens%pressure_at_depth(:,j,k+1))

      do n=1,size(T_prog(:))
        do i=isc,iec
          if(unstable(i)) then
            if(ru_line(i) > rl_line(i)) then
              T_prog(n)%field(i,j,k+1,taup1) = T_prog(n)%field(i,j,k+1,taup1)*ratio2(i) + &
                                               T_prog(n)%field(i,j,k,taup1)*ratio1(i)
              ikven(i,j)=k+1
            else
              unstable(i)=.false.
            endif
          endif
        enddo
      enddo
      if(.not. any(unstable(:))) exit
    enddo

!
! Now adjust all the layerabove the bottom of the instablity
!
    do n=1,size(T_prog(:))
      do k=1,maxval(ikven(:,j))-1
        do i=isc,iec
          if(k <= ikven(i,j)-1) then
            T_prog(n)%field(i,j,k,taup1)=T_prog(n)%field(i,j,ikven(i,j),taup1)
          endif
        enddo
      enddo
    enddo
  enddo

!
! Now procede to treating instabilies arising within the water column.
!
  ktot=0.0
  kven=0.0

  jloop: do j=jsc,jec
!
! Preliminary sweep through density field to eliminate stable columns 
! Note that top level is necessarily stable from initial sweep.
! 
   kt_temp=nk
   nunstable=0
   iindex=0
   kindex=0     
   kloop: do k=2,maxval(Grd%kmt(isc:iec,j))-1
      ru_line = density(T_prog(index_salt)%field(:,j,k,taup1),&
                        T_prog(index_temp)%field(:,j,k,taup1),&
                        Dens%pressure_at_depth(:,j,k+1))
      rl_line = density(T_prog(index_salt)%field(:,j,k+1,taup1),&
                        T_prog(index_temp)%field(:,j,k+1,taup1),&
                        Dens%pressure_at_depth(:,j,k+1))
!
! If an instability occurs anywhere at this level exit to the main loop
! and process as normal.
!
      do i=isc,iec
        if(k < Grd%kmt(i,j) .and. ru_line(i) > rl_line(i)) then
          nunstable=nunstable+1                                    
          iindex(nunstable)=i                                      
          kindex(nunstable)=k                                      
        endif
      enddo
    enddo kloop
    if(nunstable .eq. 0) cycle jloop 

    do ikunstable=1,nunstable                                      
      i   = iindex(ikunstable)                                         
      kt  = kindex(ikunstable)                                        
      kbo = Grd%kmt(i,j)                                     
      kb  = kt+1                                                    

        ru = density (T_prog(index_salt)%field(i,j,kt,taup1),&
                      T_prog(index_temp)%field(i,j,kt,taup1),&
                      Dens%pressure_at_depth(i,j,kb))
        rl = density (T_prog(index_salt)%field(i,j,kb,taup1),&
                      T_prog(index_temp)%field(i,j,kb,taup1),&
                      Dens%pressure_at_depth(i,j,kb))

        ! sum the first pair found in an unstable region
        if (ru > rl) then
          chk_la = .true.
          chk_lb = .true.
          zsm    = Thickness%rho_dzt(i,j,kt,taup1) + Thickness%rho_dzt(i,j,kb,taup1)
          tsm(1) =   T_prog(index_temp)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1) &
                   + T_prog(index_temp)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
          tmx(1) = tsm(1)/zsm
          tsm(2) =   T_prog(index_salt)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1)  &
                   + T_prog(index_salt)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
          tmx(2) = tsm(2)/zsm

          do while (chk_lb .or. chk_la)

            ! check for an unstable level (lb) below kb
            if (kb >= kbo) chk_lb = .false.
            do while (chk_lb)
              chk_lb = .false.
              lb = kb + 1 
              ru = density (tmx(2), tmx(1), Dens%pressure_at_depth(i,j,lb))
              rl = density (T_prog(index_salt)%field(i,j,lb,taup1),&
                            T_prog(index_temp)%field(i,j,lb,taup1),&
                            Dens%pressure_at_depth(i,j,lb))
              if (ru > rl) then
                ! add new level to sums
                kb = lb
                zsm = zsm + Thickness%rho_dzt(i,j,kb,taup1)
                tsm(1) = tsm(1) + T_prog(index_temp)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
                tmx(1) = tsm(1)/zsm
                tsm(2) = tsm(2) + T_prog(index_salt)%field(i,j,kb,taup1)*Thickness%rho_dzt(i,j,kb,taup1)
                tmx(2) = tsm(2)/zsm
                chk_la = .true.
                if (kb < kbo) chk_lb = .true.
              endif
            enddo

            ! check for an unstable level (la) above kt
            ! To get equivalent of original Rahmstorf code, uncomment next line
            ! chk_la = .true.
            if (kt <= 1) chk_la = .false.
            do while (chk_la)
              chk_la = .false.
              la = kt - 1
              ru = density (T_prog(index_salt)%field(i,j,la,taup1),&
                            T_prog(index_temp)%field(i,j,la,taup1),&
                            Dens%pressure_at_depth(i,j,kt))
              rl = density (tmx(2), tmx(1), Dens%pressure_at_depth(i,j,kt))
              if (ru > rl) then
                ! add new level to sums
                kt = la
                zsm = zsm + Thickness%rho_dzt(i,j,kt,taup1) 
                tsm(1) = tsm(1) + T_prog(index_temp)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1)
                tmx(1) = tsm(1)/zsm
                tsm(2) = tsm(2) + T_prog(index_salt)%field(i,j,kt,taup1)*Thickness%rho_dzt(i,j,kt,taup1)
                tmx(2) = tsm(2)/zsm
                chk_lb = .true.
                ! to get equivalent of original Rahmstorf code, comment out next line
                if (kt > 1) chk_la = .true.
              endif
            enddo

          enddo

          ! mix all tracers from kt to kb
          do k=kt,kb
            T_prog(index_temp)%field(i,j,k,taup1) = tmx(1)
            T_prog(index_salt)%field(i,j,k,taup1) = tmx(2)
          enddo
          do n=1,size(T_prog(:))
            if (n /= index_temp .and. n /= index_salt) then
              tsm(3) = 0.0
              do k=kt,kb
                tsm(3) = tsm(3) + T_prog(n)%field(i,j,k,taup1)*Thickness%rho_dzt(i,j,k,taup1)
              enddo
              tmx(3) = tsm(3)/zsm 
              do k=kt,kb
                T_prog(n)%field(i,j,k,taup1) = tmx(3)
              enddo
            endif
          enddo

          ! compute diagnostic fields
          ktot(i,j) = ktot(i,j) + kb - kt + 1
          if (kt == 1) kven(i,j) = kb


        endif

    enddo         !ikunstable 
  enddo jloop     ! j=jsc,jec


! Merge diagnostic info.

  do j=jsc,jec
    do i=isc,iec
      if(real(ikven(i,j)) > kven(i,j)) then
        kven(i,j)=ikven(i,j)
        ktot(i,j)=ikven(i,j)
      endif
    enddo
  enddo
  

  ! update density salinity fields 
  call update_ocean_density_salinity(T_prog,taup1,Dens)

  ! diagnostics 
  call convection_diag(Time, Thickness, T_prog, Dens)
  call diagnose_2d(Time, Grd, id_ktot, ktot(:,:))
  call diagnose_2d(Time, Grd, id_kven, kven(:,:))


end subroutine convection_full_vector_preteos10
! </SUBROUTINE> NAME="convection_full_vector_preteos10"


!#######################################################################
! <SUBROUTINE NAME="convection_diag">
!
! <DESCRIPTION>
! Some diagnostics for convection.
! </DESCRIPTION>
!
subroutine convection_diag (Time, Thickness, T_prog, Dens)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_prog_tracer_type), intent(in) :: T_prog(:)
  type(ocean_density_type),     intent(in) :: Dens

  integer :: i, j, k, n, tau, taup1

  tau   = Time%tau
  taup1 = Time%taup1

  do n=1,size(T_prog(:))

     if (id_convect(n) > 0) then 
        wrk1(:,:,:) = 0.0 
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 wrk1(i,j,k) =  dtimer*(T_prog(n)%field(i,j,k,taup1) - T_prog(n)%wrk1(i,j,k)) &
                                *T_prog(n)%conversion*Thickness%rho_dzt(i,j,k,taup1)
              enddo
           enddo
        enddo
        call diagnose_3d(Time, Grd, id_convect(n),wrk1(:,:,:))
     endif

  enddo

  call watermass_diag(Time, T_prog, Dens, Thickness)


end subroutine convection_diag
! </SUBROUTINE> NAME="convection_diag"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag_init">
!
! <DESCRIPTION>
! Initialization of watermass diagnostic output files. 
! </DESCRIPTION>
!
subroutine watermass_diag_init(Time, Dens)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens

  integer :: stdoutunit
  stdoutunit=stdout()
  compute_watermass_diag = .false. 

  id_neut_rho_convect = register_diag_field ('ocean_model', 'neut_rho_convect', &
    Grd%tracer_axes(1:3), Time%model_time,                                      &
    'update of locally referenced potential density from convective adjustment',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_rho_convect > 0) compute_watermass_diag=.true.

  id_wdian_rho_convect = register_diag_field ('ocean_model', 'wdian_rho_convect',& 
    Grd%tracer_axes(1:3), Time%model_time,                                       &
    'dianeutral mass transport due to convective adjustment',                    &
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_convect > 0) compute_watermass_diag=.true.

  id_tform_rho_convect = register_diag_field ('ocean_model', 'tform_rho_convect',     & 
     Grd%tracer_axes(1:3), Time%model_time,                                           &
     'watermass transform due to convective adjustment on levels (pre-layer binning)',&
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_convect > 0) compute_watermass_diag=.true.

  id_neut_rho_convect_on_nrho = register_diag_field ('ocean_model',                                &
     'neut_rho_convect_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                       &
     'update of locally ref potrho from convective adjustment as binned to neutral density layers',&
     '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_rho_convect_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_rho_convect_on_nrho = register_diag_field ('ocean_model',                              &
     'wdian_rho_convect_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                     &
     'dianeutral mass transport due to convective adjustment as binned to neutral density layers',&
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_convect_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_rho_convect_on_nrho = register_diag_field ('ocean_model',                        &
     'tform_rho_convect_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,               &
     'watermass transform due to convective adjustment as binned to neutral density layers',&
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_convect_on_nrho > 0) compute_watermass_diag=.true.


  id_neut_temp_convect = register_diag_field ('ocean_model', 'neut_temp_convect',             &
     Grd%tracer_axes(1:3), Time%model_time,                                                   &
     'temp related update of locally referenced potential density from convective adjustment',&
     '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_temp_convect > 0) compute_watermass_diag=.true.

  id_neut_temp_convect_on_nrho = register_diag_field ('ocean_model',                                     &
     'neut_temp_convect_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                            &
     'temp related update of locally ref potrho from convect adjust as binned to neutral density layers',&
     '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_temp_convect_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_temp_convect = register_diag_field ('ocean_model', 'wdian_temp_convect',  &     
     Grd%tracer_axes(1:3), Time%model_time,                                          &
     'temp related dianeutral mass transport due to convective adjustment on levels',&
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_convect > 0) compute_watermass_diag=.true.

  id_wdian_temp_convect_on_nrho = register_diag_field ('ocean_model',                                        &
   'wdian_temp_convect_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                                 &
   'temp related dianeutral mass transport due to convective adjustment as binned to neutral density layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_convect_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_temp_convect = register_diag_field ('ocean_model', 'tform_temp_convect',                &     
     Grd%tracer_axes(1:3), Time%model_time,                                                        &
     'temp related watermass transform due to convective adjustment on levels (pre-layer binning)',&
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_convect > 0) compute_watermass_diag=.true.

  id_tform_temp_convect_on_nrho = register_diag_field ('ocean_model',                                    &
     'tform_temp_convect_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                           &
     'temp related watermass transform due to convective adjustment as binned to neutral density layers',&
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_convect_on_nrho > 0) compute_watermass_diag=.true.


  id_neut_salt_convect = register_diag_field ('ocean_model', 'neut_salt_convect',            &
    Grd%tracer_axes(1:3), Time%model_time,                                                   &
    'salt related update of locally referenced potential density from convective adjustment',&
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_salt_convect > 0) compute_watermass_diag=.true.

  id_neut_salt_convect_on_nrho = register_diag_field ('ocean_model',                                     &
     'neut_salt_convect_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                            &
     'salt related update of locally ref potrho from convect adjust as binned to neutral density layers',&
     '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  if(id_neut_salt_convect_on_nrho > 0) compute_watermass_diag=.true.

  id_wdian_salt_convect = register_diag_field ('ocean_model', 'wdian_salt_convect',  &     
     Grd%tracer_axes(1:3), Time%model_time,                                          &
     'salt related dianeutral mass transport due to convective adjustment on levels',&
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_convect > 0) compute_watermass_diag=.true.

  id_wdian_salt_convect_on_nrho = register_diag_field ('ocean_model',                                          &
     'wdian_salt_convect_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                                 &
     'salt related dianeutral mass transport due to convective adjustment as binned to neutral density layers',&
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_convect_on_nrho > 0) compute_watermass_diag=.true.

  id_tform_salt_convect = register_diag_field ('ocean_model', 'tform_salt_convect',                &     
     Grd%tracer_axes(1:3), Time%model_time,                                                        &
     'salt related watermass transform due to convective adjustment on levels (pre-layer binning)',&
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_convect > 0) compute_watermass_diag=.true.

  id_tform_salt_convect_on_nrho = register_diag_field ('ocean_model',                                  &
   'tform_salt_convect_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                           &
   'salt related watermass transform due to convective adjustment as binned to neutral density layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_convect_on_nrho > 0) compute_watermass_diag=.true.


  if(compute_watermass_diag) then 
    write(stdoutunit,'(/a/)') &
    '==>Note: running ocean_convect_mod w/ compute_watermass_diag=.true. to compute watermass diagnostics.'  
  endif 


end subroutine watermass_diag_init
! </SUBROUTINE> NAME="watermass_diag_init"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag">
!
! <DESCRIPTION>
! Diagnose effects from convection of 
! temp and salt on the watermass transformation diagnostics.  
!
! </DESCRIPTION>
!
subroutine watermass_diag(Time, T_prog, Dens, Thickness)

  type(ocean_time_type),          intent(in) :: Time
  type(ocean_prog_tracer_type),   intent(in) :: T_prog(:)
  type(ocean_density_type),       intent(in) :: Dens
  type(ocean_thickness_type),     intent(in) :: Thickness

  integer :: i,j,k,taup1
  real    :: temporary 

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_convect (watermass_diag): module needs initialization ')
  endif 

  if(.not. compute_watermass_diag) return 

  taup1 = Time%taup1


  ! diagnostics for rho = temp + salt contributions  
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0
  wrk6(:,:,:) = 0.0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           temporary   =  Grd%tmask(i,j,k)*Thickness%rho_dzt(i,j,k,taup1)*dtimer
           wrk1(i,j,k) =  (T_prog(index_temp)%field(i,j,k,taup1) - T_prog(index_temp)%wrk1(i,j,k)) &
                          *Dens%drhodT(i,j,k)*temporary
           wrk2(i,j,k) =  (T_prog(index_salt)%field(i,j,k,taup1) - T_prog(index_salt)%wrk1(i,j,k)) &
                          *Dens%drhodS(i,j,k)*temporary
           wrk3(i,j,k) =  wrk1(i,j,k) + wrk2(i,j,k)
           wrk4(i,j,k) =  wrk3(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk5(i,j,k) =  wrk4(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk6(i,j,k) =  wrk3(i,j,k)*Dens%watermass_factor(i,j,k)*Grd%dat(i,j)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_convect, wrk4(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_convect, wrk5(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_convect, wrk6(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_convect_on_nrho, wrk4)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_convect_on_nrho, wrk5)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_convect_on_nrho, wrk6)

  ! diagnostics for contributions from temp alone 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0
  wrk6(:,:,:) = 0.0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           temporary   =  Grd%tmask(i,j,k)*Thickness%rho_dzt(i,j,k,taup1)*dtimer
           wrk1(i,j,k) =  (T_prog(index_temp)%field(i,j,k,taup1) - T_prog(index_temp)%wrk1(i,j,k)) &
                          *Dens%drhodT(i,j,k)*temporary
           wrk2(i,j,k) =  0.0
           wrk3(i,j,k) =  wrk1(i,j,k) + wrk2(i,j,k)
           wrk4(i,j,k) =  wrk3(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk5(i,j,k) =  wrk4(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk6(i,j,k) =  wrk3(i,j,k)*Dens%watermass_factor(i,j,k)*Grd%dat(i,j)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_convect, wrk4(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_convect, wrk5(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_temp_convect, wrk6(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_convect_on_nrho, wrk4)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_convect_on_nrho, wrk5)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_convect_on_nrho, wrk6)

  ! diagnostics for contributions from salinity alone 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0
  wrk6(:,:,:) = 0.0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           temporary   =  Grd%tmask(i,j,k)*Thickness%rho_dzt(i,j,k,taup1)*dtimer
           wrk1(i,j,k) =  0.0
           wrk2(i,j,k) =  (T_prog(index_salt)%field(i,j,k,taup1) - T_prog(index_salt)%wrk1(i,j,k)) &
                          *Dens%drhodS(i,j,k)*temporary
           wrk3(i,j,k) =  wrk1(i,j,k) + wrk2(i,j,k)
           wrk4(i,j,k) =  wrk3(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk5(i,j,k) =  wrk4(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk6(i,j,k) =  wrk3(i,j,k)*Dens%watermass_factor(i,j,k)*Grd%dat(i,j)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_convect, wrk4(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_convect, wrk5(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_salt_convect, wrk6(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_convect_on_nrho, wrk4)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_convect_on_nrho, wrk5)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_convect_on_nrho, wrk6)

end subroutine watermass_diag
! </SUBROUTINE>  NAME="watermass_diag"


end module ocean_convect_mod 

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! ice_spec_mod - sea ice and SST specified from data as per GFDL climate group !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
module ice_spec_mod

use fms_mod, only: open_namelist_file, check_nml_error, close_file, &
                   stdlog, stdout, mpp_pe, mpp_root_pe, write_version_number
use mpp_mod, only: input_nml_file

use time_manager_mod, only: time_type, get_date, set_date
use data_override_mod,only: data_override
use constants_mod,    only: Tfreeze

implicit none
include 'netcdf.inc'
private
public :: get_sea_surface

character(len=128), parameter :: version = '$Id: ice_spec.F90,v 20.0 2013/12/13 23:28:29 fms Exp $'
character(len=128), parameter :: tagname = '$Name: tikal $'

logical :: module_is_initialized = .false.

logical :: mcm_ice = .false. ! When mcm_ice=.true., ice is handled as in supersource
real    :: sst_pert = 0.     ! global temperature perturbation used for sensitivity experiments

real    :: minimum_ice_concentration = 0.2
real    :: minimum_ice_thickness     = 1.0
logical :: do_leads = .true.   ! when do_leads=false there is no fractional ice concentration
                               ! also you should set the minimum_ice_concentration = 0.5
logical :: sst_degk = .false.  ! when sst_degk=true the input sst data is in degrees Kelvin
                               ! otherwise it is assumed to be in degrees Celsius

!amip date for repeating single day (rsd) option
 integer :: repeat_date(3)=(/-1,-1,-1/)

namelist /ice_spec_nml/ mcm_ice, do_leads, minimum_ice_concentration, &
                          minimum_ice_thickness, sst_degk, sst_pert, repeat_date

contains

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! get_sea_surface - get SST, ice concentration and thickness from data         !
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
subroutine get_sea_surface(Time, ts, cn, iceh)
type (time_type),                         intent(in)  :: Time
real, dimension(:, :),                    intent(out) :: ts
real, dimension(size(ts,1),size(ts,2),2), intent(out) :: cn
real, dimension(size(ts,1),size(ts,2)),   intent(out) :: iceh

real, dimension(size(ts,1),size(ts,2))                :: sst, icec

real ::  t_sw_freeze0 = -1.8
real ::  t_sw_freeze
integer :: ierr, io, unit
type(time_type) :: Spec_Time
integer :: tod(3),dum
integer :: stdoutunit,stdlogunit

stdoutunit=stdout()
stdlogunit=stdlog()

if(.not.module_is_initialized) then
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ice_spec_nml, iostat=io)
#else
    unit = open_namelist_file()
    read  (unit, ice_spec_nml,iostat=io)
    call close_file (unit)
#endif
    ierr = check_nml_error(io,'ice_spec_nml')
    write (stdoutunit,'(/)')
    write (stdoutunit, ice_spec_nml)
    write (stdlogunit, ice_spec_nml)

   call write_version_number(version, tagname)
   module_is_initialized = .true.
endif

! modify time repeating single day option
  if (all(repeat_date>0)) then
     call get_date(Time,dum,dum,dum,tod(1),tod(2),tod(3))
     Spec_Time = set_date(repeat_date(1),repeat_date(2),repeat_date(3),tod(1),tod(2),tod(3))
  else
     Spec_Time = Time
  endif

  t_sw_freeze = t_sw_freeze0
  if (sst_degk) then
     t_sw_freeze = t_sw_freeze0 + Tfreeze ! convert sea water freeze point to degK
  endif
  icec = 0.0; iceh = 0.0; sst = t_sw_freeze;
  call data_override('ICE', 'sic_obs', icec, Spec_Time)
  call data_override('ICE', 'sit_obs', iceh, Spec_Time)
  call data_override('ICE', 'sst_obs', sst,  Spec_Time)

  if(mcm_ice) then
    icec = 0.0
!   TK Mod: Limit minimum non-zero sea ice thickness to 0.01m.
!           This is to eliminate some very thin but non-zero
!           sea ice thickness values, where they really should be zero
!           but have become nonzero due to spatial interpolation
!           where the input grid and model grid are not
!           EXACTLY the same.  0.01 was obtained by trial and
!           error to roughly match supersource behavior.
!           5/22/01; 8/23/01

    where (iceh < 0.01) iceh=0.0
    where (iceh>0.0)
      icec = 1.0
      sst  = t_sw_freeze
    end where
  else
    where (icec >= minimum_ice_concentration)
      iceh = max(iceh, minimum_ice_thickness)
      sst = t_sw_freeze
    elsewhere
      icec = 0.0
      iceh = 0.0
    end where
    if (.not.do_leads) then
       where (icec >= minimum_ice_concentration) icec = 1.0
    endif
  endif

  where (icec==0.0 .and. sst<=t_sw_freeze) sst = t_sw_freeze+1e-10

! add on non-zero sea surface temperature perturbation (namelist option)
! this perturbation may be useful in accessing model sensitivities

   if ( abs(sst_pert) > 0.0001 ) then
      sst = sst + sst_pert
   endif

  cn(:,:,2) = icec
  cn(:,:,1) = 1-cn(:,:,2)

  if (sst_degk) then
     ts = sst
  else
     ts = sst+Tfreeze
  endif

  return
end subroutine get_sea_surface

end module ice_spec_mod

! The include file fms_platform.h will handle the conversion of POINTER to _ALLOCATABLE arrays
! for derived type members. The conversion affects performance only and should not change 
! any numeric result. It is limited to member arrays that are used within MOM only
! and to arrays that are never associated (=>) with another array.

! Fortran 90 requires array members of derived type to have the POINTER attribute. 
! However, most Fortran 95 compilers now also support _ALLOCATABLE array components 
! (a Fortran 2003 feature). This avoids the aliasing problem afflicting pointers. 
! Some compilers may require an additional switch (e.g. -fno-alias) to fully exploit
! the performance benefit of the conversion.
!
! Macros used from fms_platform.h:
! __ALLOCATABLE maps to either POINTER  or _ALLOCATABLE
! _NULL        maps to either =>NULL() or "nothing"
#include <fms_platform.h>

module wave_types_mod

#include <ocean_memory.h>

  type, public :: ocean_wave_type

#ifndef MOM_STATIC_ARRAYS
    real, dimension(:,:,:),_ALLOCATABLE:: xmom, ymom  _NULL !x & y-component of local wave momentum (scaled by 1/rho/g -> m s)
    real, dimension(:,:),  _ALLOCATABLE:: wave_k      _NULL !wave number (1/m)
    real, dimension(:,:),  _ALLOCATABLE:: height      _NULL !significant wave height (m)
    real, dimension(:,:),  _ALLOCATABLE:: wave_p      _NULL !peak frequency at time level taup1
#else
    real, dimension(isd:ied,jsd:jed,2) :: xmom, ymom	    !x & y-component of local wave momentum
    real, dimension(isd:ied,jsd:jed)   :: wave_k	    !wave number (1/m)
    real, dimension(isd:ied,jsd:jed)   :: height	    !significant wave height (m)
    real, dimension(isd:ied,jsd:jed)   :: wave_p	    !peak frequency at time level taup1
#endif

  end type ocean_wave_type

end module wave_types_mod

module mpp_utilities_mod

!-----------------------------------------------------------------------
  character(len=128) :: version = '$Id$'
  character(len=128) :: tag = '$Name$'
!-----------------------------------------------------------------------

  public :: mpp_array_global_min_max

contains

!#######################################################################
! <SUBROUTINE NAME="mpp_array_global_min_max">
!
! <DESCRIPTION>
! Compute and return the global min and max of an array
! and the corresponding lat-lon-depth locations .   
!
! NOTES:
! This algorithm works only for an input array that has a unique global 
! max and min location. This is assured by introducing a factor that distinguishes
! the values of extrema at each processor.
!
! Vectorized using maxloc() and minloc() intrinsic functions by 
! Russell.Fiedler@csiro.au (May 2005).
!
! Modified by Zhi.Liang@noaa.gov (July 2005)
!          
! Modified by Niki.Zadeh@noaa.gov (Feb. 2009)
!
! </DESCRIPTION>
!
subroutine mpp_array_global_min_max(in_array, tmask,isd,jsd,isc,iec,jsc,jec,nk, g_min, g_max, &
                                    geo_x,geo_y,geo_z, xgmin, ygmin, zgmin, xgmax, ygmax, zgmax)

  use mpp_mod,           only: mpp_min, mpp_max, mpp_pe, mpp_sum

  real, dimension(isd:,jsd:,:), intent(in) :: in_array
  real, dimension(isd:,jsd:,:), intent(in) :: tmask
  integer,                      intent(in) :: isd,jsd,isc,iec,jsc,jec,nk
  real,                         intent(out):: g_min, g_max
  real, dimension(isd:,jsd:),   intent(in) :: geo_x,geo_y
  real, dimension(:),           intent(in) :: geo_z
  real,                         intent(out):: xgmin, ygmin, zgmin, xgmax, ygmax, zgmax 



  real    :: tmax, tmin, tmax0, tmin0
  integer :: itmax, jtmax, ktmax, itmin, jtmin, ktmin
  integer :: igmax, jgmax, kgmax, igmin, jgmin, kgmin
  real    :: fudge

  ! arrays to enable vectorization
  integer :: iminarr(3),imaxarr(3)

  g_min=-88888888888.0 ; g_max=-999999999.0

  tmax=-1.e10;tmin=1.e10
  itmax=0;jtmax=0;ktmax=0
  itmin=0;jtmin=0;ktmin=0
  
  if(ANY(tmask(isc:iec,jsc:jec,:) > 0.)) then
     iminarr=minloc(in_array(isc:iec,jsc:jec,:),tmask(isc:iec,jsc:jec,:) > 0.)
     imaxarr=maxloc(in_array(isc:iec,jsc:jec,:),tmask(isc:iec,jsc:jec,:) > 0.)
     itmin=iminarr(1)+isc-1
     jtmin=iminarr(2)+jsc-1
     ktmin=iminarr(3)
     itmax=imaxarr(1)+isc-1
     jtmax=imaxarr(2)+jsc-1 
     ktmax=imaxarr(3)
     tmin=in_array(itmin,jtmin,ktmin)
     tmax=in_array(itmax,jtmax,ktmax)
  end if

  ! use "fudge" to distinguish processors when tracer extreme is independent of processor
  fudge = 1.0 + 1.e-12*real(mpp_pe() )
  tmax = tmax*fudge
  tmin = tmin*fudge
  if(tmax == 0.0) then 
    tmax = tmax + 1.e-12*real(mpp_pe() )
  endif 
  if(tmin == 0.0) then 
    tmin = tmin + 1.e-12*real(mpp_pe() )
  endif 
  

  tmax0=tmax;tmin0=tmin

  call mpp_max(tmax)
  call mpp_min(tmin)

  g_max = tmax
  g_min = tmin

  !Now find the location of the global extrema.
  !
  !Note that the fudge factor above guarantees that the location of max (min) is uinque,
  ! since tmax0 (tmin0) has slightly different values on each processor.
  !Otherwise, the function in_array(i,j,k) could be equal to global max (min) at more 
  ! than one point in space and this would be a much more difficult problem to solve.
  !
  !mpp_max trick
  !-999 on all current PE's
  xgmax=-999.; ygmax=-999.; zgmax=-999.
  xgmin=-999.; ygmin=-999.; zgmin=-999.


  !except when
  if (tmax0 == tmax) then !This happens ONLY on ONE processor because of fudge factor above.
     xgmax=geo_x(itmax,jtmax) 
     ygmax=geo_y(itmax,jtmax) 
     zgmax=geo_z(ktmax)    
  endif

  call mpp_max(xgmax) 
  call mpp_max(ygmax) 
  call mpp_max(zgmax)     
  
  if (tmin0 == tmin) then !This happens ONLY on ONE processor because of fudge factor above.
     xgmin=geo_x(itmin,jtmin) 
     ygmin=geo_y(itmin,jtmin) 
     zgmin=geo_z(ktmin)    
  endif

  call mpp_max(xgmin) 
  call mpp_max(ygmin) 
  call mpp_max(zgmin)     
  
  return


end subroutine mpp_array_global_min_max
! </SUBROUTINE>  NAME="mpp_array_global_min_max"



end module mpp_utilities_mod

#include <fms_platform.h>

MODULE CONV_UTILITIES_k_MOD
  
  use Sat_Vapor_Pres_k_Mod, ONLY: compute_qs_k

!---------------------------------------------------------------------
  implicit none
  private

!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------

  character(len=128) :: version = '$Id: conv_utilities_k.F90,v 20.0 2013/12/13 23:21:37 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'

!---------------------------------------------------------------------
!-------  interfaces --------

  public  :: sd_init_k, sd_copy_k, sd_end_k, ac_init_k, ac_clear_k,  &
             ac_end_k, qsat_k, qses_k, exn_k, exn_init_k, exn_end_k, &
             findt_k, findt_init_k, findt_end_k, uw_params_init_k, &
             conden_k, pack_sd_k, pack_sd_lsm_k, extend_sd_k,  &
             adi_cloud_k, check_tracer_realizability, qt_parcel_k





 public sounding
 type sounding
    logical  :: coldT
    integer  :: kmax, kinv, ktoppbl, ktopconv
    real     :: psfc, pinv, zinv, thvinv, land, pblht, qint, delt, crh, tke
    real, _ALLOCATABLE :: t     (:)_NULL, qv   (:)_NULL, u     (:)_NULL
    real, _ALLOCATABLE :: v     (:)_NULL, ql   (:)_NULL, qi    (:)_NULL
    real, _ALLOCATABLE :: qa    (:)_NULL, thc  (:)_NULL, qct   (:)_NULL
    real, _ALLOCATABLE :: thv   (:)_NULL, rh   (:)_NULL, p     (:)_NULL
    real, _ALLOCATABLE :: z     (:)_NULL, dp   (:)_NULL, dz    (:)_NULL
    real, _ALLOCATABLE :: rho   (:)_NULL, nu   (:)_NULL, leff  (:)_NULL
    real, _ALLOCATABLE :: exner (:)_NULL, ps   (:)_NULL, exners(:)_NULL
    real, _ALLOCATABLE :: zs    (:)_NULL, ssthc(:)_NULL, ssqct (:)_NULL
    real, _ALLOCATABLE :: dudp  (:)_NULL, dvdp (:)_NULL, thvbot(:)_NULL
    real, _ALLOCATABLE :: thvtop(:)_NULL, qn   (:)_NULL, qs    (:)_NULL
    real, _ALLOCATABLE :: am1   (:)_NULL, am2  (:)_NULL, am3   (:)_NULL
    real, _ALLOCATABLE :: am4   (:)_NULL
    real, _ALLOCATABLE :: hl    (:)_NULL, sshl (:)_NULL, hm    (:)_NULL
    real, _ALLOCATABLE :: hms   (:)_NULL
!++++yim     
    real, _ALLOCATABLE :: tr    (:,:)_NULL, sstr(:,:)_NULL
 end type sounding

 public adicloud
 type adicloud
   real     :: usrc, vsrc, hlsrc, thcsrc, qctsrc
    integer  :: klcl, klfc, klnb
    real     :: plcl, zlcl, thvlcl, thv0lcl, rho0lcl
    real     :: plfc, plnb, cape, cin
    real, _ALLOCATABLE :: t  (:)_NULL, qv  (:)_NULL, ql  (:)_NULL
    real, _ALLOCATABLE :: qi (:)_NULL, thc (:)_NULL, qct (:)_NULL
    real, _ALLOCATABLE :: thv(:)_NULL, nu  (:)_NULL, leff(:)_NULL
    real, _ALLOCATABLE :: hl (:)_NULL, buo (:)_NULL
 end type adicloud

 public uw_params
 type uw_params
   real  :: hlv, hls, hlf, cp_air, grav, kappa, rdgas, p00, epsilo,  &
            zvir, tkmin, tkmax
   integer :: me
   logical :: master
 end type uw_params

! Lookup table dimension and ranges for findt_k
! These values should not be changed without a careful evaluation
! of the accuracy implications (cjg).

    integer, parameter :: nta = 1700
    real, parameter :: tamin =  120.0
    real, parameter :: tamax =  700.0

    integer, parameter :: np1 = 300
    real, parameter :: p1min = 10.0e2
    real, parameter :: p1max = 100.0e2
    integer, parameter :: np2 = 1000
    real, parameter :: p2min = 100.0e2
    real, parameter :: p2max = 1100.0e2
 
    real dta, dp1, dp2
    real rdta, rdp1, rdp2
    real(kind=4), allocatable :: ta_lookup(:,:,:)
    logical :: ta_lookup_allocated = .false.
 
! Lookup table for exn_k function (cjg)

    integer, parameter :: npex = 100000
    real, parameter :: pexmin = 10.0e2
    real, parameter :: pexmax = 1100.0e2

    real dpex, rdpex
    real(kind=4), allocatable :: ex_lookup(:)
    logical :: ex_lookup_allocated = .false.

contains

!#####################################################################
!#####################################################################

  subroutine uw_params_init_k (hlv, hls, hlf, cp_air, grav, kappa,  &
                               rdgas, p00, epsilo, zvir, tkmin,  &
                               tkmax, me, root_pe, Uw_p)
    real, intent(in) :: hlv, hls, hlf, cp_air, grav, kappa, rdgas,  &
                        p00, epsilo, zvir, tkmin, tkmax
    integer, intent(in) :: me, root_pe
    type(uw_params), intent(inout) :: Uw_p

    Uw_p%hlv = hlv
    Uw_p%hls = hls
    Uw_p%hlf = hlf
    Uw_p%cp_air = cp_air
    Uw_p%grav   = grav  
    Uw_p%kappa  = kappa 
    Uw_p%rdgas  = rdgas 
    Uw_p%p00    = p00   
    Uw_p%epsilo = epsilo
    Uw_p%zvir   = zvir  
    Uw_p%tkmin  = tkmin
    Uw_p%tkmax  = tkmax 
    Uw_p%me     = me
    Uw_p%master = (me == root_pe)

  end subroutine uw_params_init_k

!#####################################################################
!#####################################################################

  subroutine sd_init_k(kd, num_tracers, sd)
    integer, intent(in) :: kd, num_tracers
    type(sounding), intent(inout) :: sd
    
    sd%coldT    = .false.
    sd%kmax     = kd
    sd%kinv     = 0
    sd%ktoppbl  = 0
    sd%ktopconv = 0
    sd%psfc     = 0.0
    sd%pinv     = 0.0
    sd%zinv     = 0.0
    sd%thvinv   = 0.0
    sd%land     = 0.0
    sd%pblht    = 0.0
    sd%qint     = 0.0
    sd%delt     = 0.0
    sd%crh      = 0.0
    sd%tke      = 0.0
    allocate ( sd%t     (1:kd)); sd%t     =0.;
    allocate ( sd%qv    (1:kd)); sd%qv    =0.;
    allocate ( sd%u     (1:kd)); sd%u     =0.;
    allocate ( sd%v     (1:kd)); sd%v     =0.;
    allocate ( sd%qs    (1:kd)); sd%qs    =0.;
    allocate ( sd%ql    (1:kd)); sd%ql    =0.;
    allocate ( sd%qi    (1:kd)); sd%qi    =0.;
    allocate ( sd%qa    (1:kd)); sd%qa    =0.;
    allocate ( sd%qn    (1:kd)); sd%qn    =0.;
    allocate ( sd%thc   (1:kd)); sd%thc   =0.;
    allocate ( sd%qct   (1:kd)); sd%qct   =0.;
    allocate ( sd%thv   (1:kd)); sd%thv   =0.;
    allocate ( sd%rh    (1:kd)); sd%rh    =0.;
    allocate ( sd%p     (1:kd)); sd%p     =0.;
    allocate ( sd%z     (1:kd)); sd%z     =0.;
    allocate ( sd%dp    (1:kd)); sd%dp    =0.;
    allocate ( sd%dz    (1:kd)); sd%dz    =0.;
    allocate ( sd%rho   (1:kd)); sd%rho   =0.;
    allocate ( sd%nu    (1:kd)); sd%nu    =0.;
    allocate ( sd%leff  (1:kd)); sd%leff  =0.;
    allocate ( sd%exner (1:kd)); sd%exner =0.;
    allocate ( sd%ps    (0:kd)); sd%ps    =0.;
    allocate ( sd%zs    (0:kd)); sd%zs    =0.;
    allocate ( sd%exners(0:kd)); sd%exners=0.;
    allocate ( sd%ssthc (1:kd)); sd%ssthc =0.;
    allocate ( sd%ssqct (1:kd)); sd%ssqct =0.;
    allocate ( sd%dudp  (1:kd)); sd%dudp  =0.;
    allocate ( sd%dvdp  (1:kd)); sd%dvdp  =0.;
    allocate ( sd%thvbot(1:kd)); sd%thvbot=0.;
    allocate ( sd%thvtop(1:kd)); sd%thvtop=0.;
    allocate ( sd%am1   (1:kd)); sd%am1   =0.;
    allocate ( sd%am2   (1:kd)); sd%am2   =0.;
    allocate ( sd%am3   (1:kd)); sd%am3   =0.;
    allocate ( sd%am4   (1:kd)); sd%am4   =0.;
    allocate ( sd%hl    (1:kd)); sd%hl    =0.;
    allocate ( sd%hm    (1:kd)); sd%hm    =0.;
    allocate ( sd%hms   (1:kd)); sd%hms   =0.;
    allocate ( sd%sshl  (1:kd)); sd%sshl  =0.;
!++++yim
    allocate ( sd%tr  (1:kd,1:num_tracers)); sd%tr  =0.;
    allocate ( sd%sstr  (1:kd,1:num_tracers)); sd%sstr  =0.;
    
  end subroutine sd_init_k

!#####################################################################
!#####################################################################

  subroutine sd_copy_k(sd, sd1)
    type(sounding), intent(in)    :: sd
    type(sounding), intent(inout) :: sd1
    
    sd1% ktopconv = sd % ktopconv
    sd1% kmax = sd % kmax
    sd1% land = sd % land
    sd1% coldT= sd % coldT
    sd1%p     = sd%p;    sd1%z     =sd%z;
    sd1%ps    = sd%ps;   sd1%zs    =sd%zs;
    sd1%t     = sd%t;    sd1%qv    =sd%qv;
    sd1%u     = sd%u;    sd1%v     =sd%v;
    sd1%ql    = sd%ql;   sd1%qi    =sd%qi;
    sd1%qa    = sd%qa;   sd1%qn    =sd%qn;    
    sd1%am1   = sd%am1;  sd1%am2   =sd%am2; 
    sd1%am3   = sd%am3;  sd1%am4   =sd%am4;
    sd1%hl    = sd%hl;   sd1%sshl  =sd%sshl;
    sd1%hm    = sd%hm;   sd1%hms   =sd%hms;
!++++yim
    sd1%tr  =sd%tr
  end subroutine sd_copy_k

!#####################################################################
!#####################################################################

  subroutine sd_end_k(sd)
    type(sounding), intent(inout) :: sd
    deallocate ( sd%t, sd%qv, sd%u, sd%v, sd%ql, sd%qi, sd%qa, sd%thc, sd%qct,&
         sd%thv, sd%rh, sd%p, sd%z, sd%dp, sd%dz, sd%rho, sd%nu, sd%leff,     &
         sd%exner, sd%ps, sd%exners, sd%zs, sd%ssthc, sd%ssqct, sd%dudp,      &
         sd%dvdp, sd%thvbot, sd%thvtop, sd%qn, sd%am1, sd%am2, sd%am3, sd%am4,&
         sd%qs, sd%hl, sd%hm, sd%hms, sd%sshl, sd%tr, sd%sstr)
  end subroutine sd_end_k

!#####################################################################
!#####################################################################

  subroutine ac_init_k(kd, ac)
    integer, intent(in) :: kd
    type(adicloud), intent(inout) :: ac
    
    ac%usrc    = 0.0
    ac%vsrc    = 0.0
    ac%hlsrc   = 0.0
    ac%thcsrc  = 0.0
    ac%qctsrc  = 0.0
    ac%klcl    = 0
    ac%klfc    = 0
    ac%klnb    = 0
    ac%plcl    = 0.0
    ac%zlcl    = 0.0
    ac%thvlcl  = 0.0
    ac%thv0lcl = 0.0
    ac%rho0lcl = 0.0
    ac%plfc    = 0.0
    ac%plnb    = 0.0
    ac%cape    = 0.0
    ac%cin     = 0.0
    allocate ( ac%t     (1:kd)); ac%t    =0.;
    allocate ( ac%qv    (1:kd)); ac%qv   =0.;
    allocate ( ac%ql    (1:kd)); ac%ql   =0.;
    allocate ( ac%qi    (1:kd)); ac%qi   =0.;
    allocate ( ac%thc   (1:kd)); ac%thc  =0.;
    allocate ( ac%qct   (1:kd)); ac%qct  =0.;
    allocate ( ac%thv   (1:kd)); ac%thv  =0.;
    allocate ( ac%nu    (1:kd)); ac%nu   =0.;
    allocate ( ac%leff  (1:kd)); ac%leff =0.;
    allocate ( ac%hl    (1:kd)); ac%hl   =0.;
    allocate ( ac%buo   (1:kd)); ac%buo  =0.;
  end subroutine ac_init_k

!#####################################################################
!#####################################################################

  subroutine ac_clear_k(ac)
    type(adicloud), intent(inout) :: ac
    ac%t    =0.;    ac%qv   =0.;    ac%ql   =0.;
    ac%qi   =0.;    ac%thc  =0.;    ac%qct  =0.;
    ac%thv  =0.;    ac%nu   =0.;    ac%leff =0.; ac%hl   =0.;
    ac%buo  =0.;
  end subroutine ac_clear_k

!#####################################################################
!#####################################################################

  subroutine ac_end_k(ac)
    type(adicloud), intent(inout) :: ac
    deallocate (ac%t, ac%qv, ac%ql, ac%qi, ac%thc, ac%qct,  &
                ac%thv, ac%nu, ac%leff, ac%hl, ac%buo )
  end subroutine ac_end_k

!#####################################################################
!#####################################################################

  subroutine pack_sd_k (land, coldT, delt, pmid, pint, zmid, zint, &
                      u, v, t, qv, ql, qi, qa, qn, am1, am2, am3, am4,&
                        tracers, sd, Uw_p)

    real,    intent(in)              :: land
    logical, intent(in)              :: coldT
    real,    intent(in)              :: delt
    real, intent(in), dimension(:)   :: pmid, zmid !pressure&height@mid level
    real, intent(in), dimension(:)   :: pint, zint !pressure&height@ interface level
    real, intent(in), dimension(:)   :: u, v       !wind profile (m/s)
    real, intent(in), dimension(:)   :: t, qv      !temperature and specific humidity
    real, intent(in), dimension(:)   :: ql, qi, qa, qn !cloud tracers
    real, intent(in), dimension(:)   :: am1, am2, am3, am4  ! aerosal species
    real, intent(in), dimension(:,:) :: tracers        !env. tracers    
    type(sounding), intent(inout)    :: sd
    type(uw_params), intent(inout)    :: Uw_p

!++++yim
    integer :: k, nk, m
    real, parameter :: ptopconv = 3000.

    !Pack environmental sounding; layers are numbered from bottom up!=
    sd % kmax   = size(t)
    sd % land   = land
    sd % coldT  = coldT
    sd % delt   = delt
    sd % ps(0)  = pint(sd%kmax+1);
    sd % zs(0)  = zint(sd%kmax+1);
    sd % ktopconv = 1

    do k=1, sd%kmax
       nk=sd%kmax-k+1
       sd % p     (k) = pmid(nk)
       sd % z     (k) = zmid(nk);
       sd % ps    (k) = pint(nk); 
       sd % zs    (k) = zint(nk); 
       sd % t     (k) = t   (nk)
       !prevent negative values for qv,ql,qi,qa,qn
       sd % qv    (k) = max(qv(nk), 4.e-10) 
       sd % ql    (k) = max(ql(nk), 0.)
       sd % qi    (k) = max(qi(nk), 0.)
       sd % qa    (k) = max(qa(nk), 0.)
       sd % qn    (k) = max(qn(nk), 0.)
       sd % u     (k) = u(nk)
       sd % v     (k) = v(nk)
       !yim's aerosol
       sd % am1  (k) = am1(nk)
       sd % am2  (k) = am2(nk)
       sd % am3  (k) = am3(nk)
       sd % am4  (k) = am4(nk)
!++++yim
       do m=1, size(tracers,2)
          sd % tr (k,m) = tracers (nk,m)
       end do
       if (sd % p (k) > ptopconv) sd % ktopconv = k
    end do
  end subroutine pack_sd_k

!#####################################################################
!#####################################################################

  subroutine extend_sd_k(sd, pblht, doice, Uw_p)
    type(sounding), intent(inout) :: sd
    real, intent(in)              :: pblht
    logical, intent(in)           :: doice
    type(uw_params), intent(inout)    :: Uw_p

    integer :: k, kl, ktoppbl
    real    :: sshl0a, sshl0b, ssthc0a, ssthc0b, ssqct0a, ssqct0b
    real    :: hl0bot, thc0bot, qct0bot, hl0top, thc0top, qct0top
    real    :: thj, qvj, qlj, qij, qse, qs_sum, qt_sum, dpsum
    real, dimension(size(sd%tr,2)) :: sstr0a, sstr0b

    sd % exners(0) = exn_k(sd%ps(0),Uw_p);
    if (doice) then
       sd%nu(:)= max(min((268. - sd % t(:))/20.,1.0),0.0);
    else
       sd%nu(:)=0.
    end if
    sd % leff(:) = (1-sd%nu(:))*Uw_p%HLv + sd%nu(:)*Uw_p%HLs
    sd % qct (:) = sd%qv(:)+sd%ql(:)+sd%qi(:)
    sd % hl  (:) = Uw_p%cp_air*sd%t(:)+Uw_p%grav*sd%z(:)-  &
                   sd%leff(:)*(sd%ql(:)+sd%qi(:))
    sd % qint = 0.
    sd % crh = 0.; qs_sum=0.; qt_sum=0.; !dpsum=0.;
    do k=1, sd%ktopconv !sd%kmax
       sd % dp    (k) = sd%ps(k-1)-sd%ps(k)
       sd % dz    (k) = sd%zs(k)  -sd%zs(k-1)
       sd % exner (k) = exn_k(sd%p (k), Uw_p)
       sd % exners(k) = exn_k(sd%ps(k),Uw_p)
       sd % thc   (k) = sd%t(k) / sd%exner(k) 
       sd % qs    (k) = qsat_k(sd%t(k), sd%p(k),Uw_p, qv=sd%qv(k))
       sd % rh    (k) = min(sd%qv(k)/sd%qs(k),1.)
       sd % thv   (k) = sd%t(k)/sd%exner(k) *   &
                        (1.+Uw_p%zvir*sd%qv(k)-sd%ql(k)-sd%qi(k))
       sd % rho   (k) = sd % p(k)/     &
                        (Uw_p%rdgas * sd % thv(k) * sd % exner(k))
       sd % qint      =sd % qint + sd%qct(k)*sd%dp(k)
       qs_sum = qs_sum + sd % qs(k)  * sd%dp(k)
       qt_sum = qt_sum + sd % qct(k) * sd%dp(k)
       !dpsum = dpsum + sd%dp(k)
    end do
    sd % qint = sd % qint / Uw_p%grav
    sd % crh  = qt_sum / qs_sum
    sd % hm  (:) = Uw_p%cp_air*sd%t(:)+Uw_p%grav*sd%z(:)+sd%leff(:)*sd%qv(:)
    sd % hms (:) = Uw_p%cp_air*sd%t(:)+Uw_p%grav*sd%z(:)+sd%leff(:)*sd%qs(:)

   !Finite-Volume intepolation
    kl=sd%ktopconv !sd%kmax-1
    sshl0b  = (sd%hl (2)-sd%hl (1))/(sd%p(2)-sd%p(1))
    ssthc0b = (sd%thc(2)-sd%thc(1))/(sd%p(2)-sd%p(1))
    ssqct0b = (sd%qct(2)-sd%qct(1))/(sd%p(2)-sd%p(1))
    sstr0b(:) = (sd%tr(2,:)-sd%tr(1,:))/(sd%p(2)-sd%p(1))

    do k=2,kl
       sshl0a  = (sd%hl (k)-sd%hl (k-1))/(sd%p(k)-sd%p(k-1))
       if(sshl0a.gt.0)then
          sd%sshl (k-1) = max(0.,min(sshl0a,sshl0b))
       else
          sd%sshl (k-1) = min(0.,max(sshl0a,sshl0b))
       endif
       sshl0b = sshl0a
       ssthc0a = (sd%thc(k)-sd%thc(k-1))/(sd%p(k)-sd%p(k-1))
       if(ssthc0a.gt.0)then
          sd%ssthc(k-1) = max(0.,min(ssthc0a,ssthc0b))
       else
          sd%ssthc(k-1) = min(0.,max(ssthc0a,ssthc0b))
       endif
       ssthc0b = ssthc0a
       ssqct0a = (sd%qct(k)-sd%qct(k-1))/(sd%p(k)-sd%p(k-1))
       if(ssqct0a.gt.0)then
          sd%ssqct(k-1) = max(0.,min(ssqct0a,ssqct0b))
       else
          sd%ssqct(k-1) = min(0.,max(ssqct0a,ssqct0b))
       endif
       ssqct0b = ssqct0a
       sstr0a(:) = (sd%tr(k,:)-sd%tr(k-1,:))/(sd%p(k)-sd%p(k-1))
       where (sstr0a(:) > 0)
          sd%sstr(k-1,:) = max(0.,min(sstr0a(:),sstr0b(:)))
       elsewhere
          sd%sstr(k-1,:) = min(0.,max(sstr0a(:),sstr0b(:)))
       end where
       sstr0b(:) = sstr0a(:)
    enddo
    do k = 2,kl-1 !wind shear
       sd%dudp(k) = (sd%u(k+1)-sd%u(k-1))/(sd%p(k+1)-sd%p(k-1))
       sd%dvdp(k) = (sd%v(k+1)-sd%v(k-1))/(sd%p(k+1)-sd%p(k-1))
    end do
    sd%sshl (kl)=sd%sshl (kl-1)
    sd%ssthc(kl)=sd%ssthc(kl-1)
    sd%ssqct(kl)=sd%ssqct(kl-1)
    sd%sstr(kl,:)=sd%sstr(kl-1,:)

    do k = 1,sd%ktopconv !kl cannot be pver since ps0(pver)=0
       hl0bot  = sd%hl (k)+sd%sshl (k)*(sd%ps(k-1)-sd%p(k))
       thc0bot = sd%thc(k)+sd%ssthc(k)*(sd%ps(k-1)-sd%p(k))
       qct0bot = sd%qct(k)+sd%ssqct(k)*(sd%ps(k-1)-sd%p(k))
       call findt_k(sd%zs(k-1),sd%ps(k-1),hl0bot,qct0bot,thj,  &
                    qvj,qlj,qij,qse,sd%thvbot(k),doice, Uw_p)
       hl0top  = sd%hl (k)+sd%sshl (k)*(sd%ps(k)-sd%p(k))
       thc0top = sd%thc(k)+sd%ssthc(k)*(sd%ps(k)-sd%p(k))
       qct0top = sd%qct(k)+sd%ssqct(k)*(sd%ps(k)-sd%p(k))
       call findt_k(sd%zs(k),sd%ps(k),hl0top,qct0top,thj,  &
                    qvj,qlj,qij,qse,sd%thvtop(k),doice, Uw_p)
    enddo

    ktoppbl=1;
    do k = 2, kl-1
       if ((pblht+sd%zs(0)+1.-sd%zs(k))*(pblht+sd%zs(0)+1.-sd%zs(k+1)).lt.0.) then
          ktoppbl=k; exit;
       endif
    end do
    !given a layer index k (here k=kinv); !its bottom interface 
    !level pressure is ps0(k-1) [here ps0(kinv-1)] and its bottom
    !interface level virt. pot. temperature is thv(k) [thv0bot(kinv)]
    sd % ktoppbl = ktoppbl
    sd % kinv    = ktoppbl+1 
    sd % pinv    = sd % ps    (sd % kinv-1) 
    sd % zinv    = sd % zs    (sd % kinv-1) 
    sd % thvinv  = sd % thvbot(sd % kinv)
    sd % pblht   = pblht
  end subroutine extend_sd_k

!#####################################################################
!#####################################################################

  subroutine adi_cloud_k (zsrc, psrc, hlsrc, thcsrc, qctsrc, sd,   &
                          Uw_p, dofast, doice, ac, rmuz)
  
    real, intent(inout) :: zsrc, psrc, hlsrc, thcsrc, qctsrc
    type(sounding), intent(in)    :: sd 
    type(uw_params), intent(inout)    :: Uw_p
    logical,        intent(in)    :: dofast, doice
    type(adicloud), intent(inout) :: ac
    real, intent(in), optional :: rmuz
    
    integer :: k, kl, klcl
    real    :: qs
    real    :: hl0lcl, thc0lcl, qct0lcl, thv0lcl, rho0lcl
    real    :: cin, cinlcl, plfc, thvubot, thvutop
    real    :: thj, qvj, qlj, qij, qse, thvj
    real    :: cape, plnb, chi, tmp, rhtmp
    real    :: alpha

    call ac_clear_k(ac);
    ac%klcl=0; ac%klfc=0; ac%klnb=0; 
    ac%plcl=0.; ac%zlcl=0.; ac%thvlcl=0.; ac%thv0lcl=0; ac%rho0lcl=0.;
    ac%plfc=0.; ac%plnb=0.; ac%cape=0.; ac%cin=0.;

!!$!below is pzhu's version now commented out
!!$    esrc=qctsrc*psrc/100./(qctsrc+epsilo)             ! water vapor pressure
!!$    tdsrc=tfreeze/(1-tfreeze*rvgas*log(esrc/6.11)/HLv)! dew-point of source air
!!$    temsrc=thcsrc*exn(psrc)                           ! temperature of source air
!!$    zlcl=123.5*(temsrc-tdsrc)+zsrc                    ! from sea-level
!!$    tlcl=temsrc-0.0098*(zlcl-zsrc)
!!$    ac % zlcl =zlcl
!!$    ac % plcl =psrc*(tlcl/temsrc)**(1./Kappa)


    !calculate lifted condensation level of air at parcel origin level
    !(within 0.2% of formula of Bolton, mon. wea. rev.,1980)
    call findt_k(zsrc, psrc, hlsrc, qctsrc, thj, qvj,    &
                 qlj, qij, qse, thvj, doice, Uw_p)
    tmp=thj*exn_k(psrc,Uw_p)
    rhtmp=min(qctsrc/qse,1.)
    chi=tmp/(1669.0-122.0*rhtmp-tmp)
    ac%plcl=psrc*(rhtmp**chi); !Emanuel's calculation, results nearly identical to RAS

    klcl=0;  !klcl is the layer containing the LCL, i.e., ps0(klcl)<=plcl(i,j)
    do k=1,sd % ktopconv-1
       if(sd%ps(k).le.ac%plcl) then
          klcl=k; 
          ac%zlcl=sd%zs(k)-(ac%plcl-sd%ps(k))/sd%dp(k)*sd%dz(k);
          exit
       else
          klcl   =sd % ktopconv
          ac%zlcl=sd % zs(klcl)
       end if
    end do
    if (sd%ps(1).le.ac%plcl) then
       klcl=2; ac%plcl=sd%ps(1); ac%zlcl=sd%zs(1); 
    end if
    ac % klcl=klcl; 

    if (dofast.and.(ac%klcl.eq.0 .or. ac%plcl.gt.sd%ps(1) .or. ac%plcl.lt.20000.)) return;

    call findt_k(ac%zlcl, ac%plcl, hlsrc, qctsrc, thj,   &
                 qvj, qlj, qij, qse, ac%thvlcl, doice, Uw_p)
    ac % hlsrc  = hlsrc
    ac % thcsrc = thcsrc
    ac % qctsrc = qctsrc

    hl0lcl  = sd%hl (klcl)+sd%sshl (klcl)*(ac%plcl-sd%p(klcl))
    thc0lcl = sd%thc(klcl)+sd%ssthc(klcl)*(ac%plcl-sd%p(klcl))
    qct0lcl = sd%qct(klcl)+sd%ssqct(klcl)*(ac%plcl-sd%p(klcl))
    call findt_k(ac%zlcl,ac%plcl,hl0lcl,qct0lcl,thj,qvj,  &
                 qlj,qij,qse,thv0lcl, doice, Uw_p)
    rho0lcl = ac%plcl/(Uw_p%rdgas*thv0lcl*exn_k(ac%plcl,Uw_p))
    ac % thv0lcl= thv0lcl
    ac % rho0lcl= rho0lcl


    kl=sd % ktopconv-1

    if (present(rmuz)) then
      if (rmuz /= 0.0) then
        do k=1,kl
         call findt_k(sd%zs(k),sd%ps(k), hlsrc, qctsrc, thj, ac%qv(k), &
                      ac%ql(k), ac%qi(k), qs, ac%thv(k), doice, Uw_p)
         ac%t(k) = thj*exn_k(sd%ps(k),Uw_p)
         alpha = MIN(1.0, rmuz*(sd%zs(k+1) - sd%zs(k)))
         hlsrc = (1.0-alpha)*hlsrc + alpha*sd%hl(k+1)
         qctsrc =(1.0-alpha)*qctsrc + alpha*sd%qct(k+1)
       end do
    else
      do k=1,kl
        call findt_k(sd%zs(k),sd%ps(k), hlsrc, qctsrc, thj, ac%qv(k), &
                     ac%ql(k), ac%qi(k), qs, ac%thv(k), doice, Uw_p)
        ac%t(k) = thj*exn_k(sd%ps(k),Uw_p)
      end do
    endif
  else
    do k=1,kl
       call findt_k(sd%zs(k),sd%ps(k), hlsrc, qctsrc, thj, ac%qv(k), &
                    ac%ql(k), ac%qi(k), qs, ac%thv(k), doice, Uw_p)
       ac%t(k) = thj*exn_k(sd%ps(k),Uw_p)
       ac%buo(k) = ac%thv(k) - sd%thvtop(k)
    end do
  endif


    !Determine the convective inhibition (CIN)
    CIN = 0.
    cinlcl = 0.
    plfc   = 0.

    !define CIN based on LFC  
    do k = sd % kinv, kl-1
       if(k.eq.klcl-1) then !klcl-1 < layer < klcl
          thvubot=ac % thv (k); thvutop=ac % thvlcl
          call getcin_k(sd%ps(k),sd%thvtop(k),ac%plcl,  &
                        thv0lcl,thvubot,thvutop,plfc,cin,Uw_p)
          cinlcl = cin
          thvubot=thvutop; thvutop=ac % thv (k+1)
          call getcin_k(ac%plcl,thv0lcl,sd%ps(k+1),sd%thvtop(k+1),  &
                        thvubot,thvutop,plfc,cin,Uw_p)
          if(plfc.gt.0. .and. plfc.lt.ac%plcl) exit
       else
          thvubot=ac % thv (k); thvutop=ac % thv (k+1)
          call getcin_k(sd%ps(k),sd%thvtop(k),sd%ps(k+1),  &
                        sd%thvtop(k+1),thvubot,thvutop,plfc, cin, Uw_p)
          if(plfc.gt.0. .and. plfc.lt.ac%plcl) exit
       endif
    enddo
 
    ac % cin =cin; !CIN has been estimated
    ac % plfc=plfc;

    if (dofast .and. (ac%plfc .lt. 500.) ) return; !miz

    !calculate cape=================
    if (ac%plfc.eq.0.0) then
       ac%cape=0.0;
       ac%plnb=0.0;
    else
       ac % klfc=0; !klfc is the layer containing the plfc, i.e., ps0(klfc)<=plfc(i,j)
       do k=1,kl 
          if(sd%ps(k).le.ac%plfc) then
             ac % klfc=max(k,2); exit
          end if
       end do
       plnb = 0.; cape=0.0;
       do k = ac % klfc-1, kl !for m45l48: sd%kmax
          thvubot=ac % thv (k); thvutop=ac % thv (k+1)
          call getcape_k(sd%ps(k),sd%thvtop(k),sd%ps(k+1),  &
                         sd%thvtop(k+1),thvubot,thvutop,plnb,cape,Uw_p)
          if(plnb.gt.0.) exit
       enddo
       ac%cape=cape
       ac%plnb=plnb
    end if

  end subroutine adi_cloud_k

!#####################################################################
!#####################################################################

 function qsat_k(temp, p,Uw_p, qv)
   real, intent(in)    :: temp, p
   type(uw_params), intent(inout) :: Uw_p
   real, intent(in), optional :: qv
   real :: qsat_k, t
   integer :: ier
 
   t = min(max(temp,Uw_p%tkmin),Uw_p%tkmax)
   if (present(qv)) then
     call compute_qs_k (t, p, Uw_p%epsilo, Uw_p%zvir, qsat_k, ier, &
                                                               q = qv)
   else
     call compute_qs_k (t, p, Uw_p%epsilo, Uw_p%zvir, qsat_k, ier)
   endif
 
   return
   end function qsat_k


!#####################################################################
!#####################################################################

  subroutine qses_k(temp, p, qs, es,Uw_p                     )
   real, intent(in)    :: temp, p
   type(uw_params), intent(inout) :: Uw_p
   real, intent(inout) :: qs, es
   real :: t
   integer :: ier

   t = min(max(temp,Uw_p%tkmin),Uw_p%tkmax)
   call compute_qs_k (t, p, Uw_p%epsilo, Uw_p%zvir, qs, ier)
  
   return
   end subroutine qses_k


!#####################################################################
!#####################################################################

! Subroutine to initialize the lookup table used to speed up
! the computation of the exner function (cjg)
 
  subroutine exn_init_k(Uw_p)       
 
    type(uw_params), intent(in) :: Uw_p
    

    integer k
    real p

!   Initialize 1d lookup table for exner function

  if ( .not. ex_lookup_allocated) then
!   if ( allocated(ex_lookup) ) deallocate(ex_lookup)
    allocate( ex_lookup(npex) )

    dpex = (pexmax-pexmin)/(npex-1)
    rdpex = 1.0 / dpex
    do k=1,npex
      p = (k-1)*dpex + pexmin
      ex_lookup(k) = (p/Uw_p%p00) ** Uw_p%kappa
    end do
    ex_lookup_allocated = .true.
 endif

  end subroutine exn_init_k

!#####################################################################
!#####################################################################

  subroutine exn_end_k()
 
    if ( allocated(ex_lookup) ) deallocate(ex_lookup)
    ex_lookup_allocated = .false.
 
  end subroutine exn_end_k
 
!#####################################################################
!#####################################################################

! Subroutine to compute the exner function using a lookup
! table for better performance (cjg)

  function exn_k(p,Uw_p)      
 
    real :: exn_k
    real, intent(in)  :: p
    type(uw_params), intent(inout) :: Uw_p

    integer k, kp1
    real w

    k = 0
    if ( p-pexmin.gt.0.0 ) k = int( (p-pexmin)*rdpex ) + 1
 
    if ( k.ge.1 .and.  k.lt.npex ) then
      kp1 = k+1
      w = ( p  - (k-1)*dpex  - pexmin  )*rdpex
      exn_k = (1-w)*ex_lookup(k) + w*ex_lookup(kp1)
    else
      exn_k = (p/Uw_p%p00) ** Uw_p%kappa
    end if
 
  end function exn_k

! Old subroutine that doesn't use a lookup table

! function exn_k(p,Uw_p)
!   real :: exn_k
!   real, intent(in)  :: p
!  type(uw_params), intent(inout) :: Uw_p
!   exn_k = (p/Uw_p%p00) ** Uw_p%Kappa
! end function exn_k

!#####################################################################
!#####################################################################

  subroutine conden_k(p,thc,qt,th,qv,ql,qi,qs,thv, Uw_p)
    real,     intent(in)  :: p, thc, qt
   type(uw_params), intent(inout) :: Uw_p
    real,     intent(out) :: th, qv, ql, qi, qs, thv
    real      tc, exn, leff, nu, qc, temps, tc1
    integer   iteration, id_check
    integer :: niteration = 5

    exn = (p/Uw_p%p00)**Uw_p%Kappa
    tc = thc * exn
    nu = max(min((268.-tc)/20.,1.0),0.0);
    leff = (1-nu)*Uw_p%HLv + nu*Uw_p%HLs
  
    temps = tc
    qs=qsat_k(temps,p,Uw_p)
    
    if(qs.gt.qt) then
       id_check=0
    else
       do iteration = 1,niteration
          temps = temps + ((tc-temps)*Uw_p%cp_air/leff + (qt -qs))/        &
               (Uw_p%cp_air/leff + Uw_p%epsilo*leff*qs/Uw_p%rdgas/temps/temps)
          qs = qsat_k(temps,p,Uw_p)
       enddo
       tc1=temps-leff/Uw_p%cp_air*(qt-qs)
       if(abs(tc1-tc).lt.1.0) then
          id_check=0
       else
          id_check=1; print*,'ID_CHECK=11111111111111111111111111111111'
       endif
    endif
    qc = max(qt-qs, 0.)
    qv = qt - qc
    ql = (1-nu)*qc
    qi = nu*qc !temps=tc+leff/Uw_p%cp_air*qc
    th = temps/exn
    thv=th*(1.+Uw_p%zvir*qv-ql-qi)
  end subroutine conden_k

!#####################################################################
!#####################################################################
! Subroutine to initialize lookup tables used to speed up findt (cjg)

  subroutine findt_init_k (Uw_p)                               
 
    implicit none

!   real, intent(in) :: epsilo, hlv, hls, cp_air, tkmin, tkmax
    type(uw_params), intent(inout) :: Uw_p

    integer i, k
    real ta, p, t

!   Allocate memory to hold lookup table

  if (.not. ta_lookup_allocated) then
!   if ( allocated(ta_lookup) ) deallocate(ta_lookup)
    allocate( ta_lookup(nta,np1+np2,0:1) )

!   Initialize 2d look up tables for temperature conversion

    dta = (tamax-tamin)/(nta-1)
    rdta = 1.0 / dta
    dp1 = (p1max-p1min)/(np1-1)
    rdp1 = 1.0 / dp1
    dp2 = (p2max-p2min)/(np2-1)
    rdp2 = 1.0 / dp2

    do i=1,nta
      ta = (i-1)*dta + tamin
      do k=1,np1
        p = (k-1)*dp1 + p1min
         call solve_ta_k(ta,p,t,0,Uw_p)
         ta_lookup(i,k,0) = t
         call solve_ta_k(ta,p,t,1,Uw_p)
         ta_lookup(i,k,1) = t
       end do
       do k=np1+1,np1+np2
         p = (k-np1-1)*dp2 + p2min
         call solve_ta_k(ta,p,t,0,Uw_p)
         ta_lookup(i,k,0) = t
         call solve_ta_k(ta,p,t,1,Uw_p)
         ta_lookup(i,k,1) = t
       end do
     end do
     ta_lookup_allocated = .true.
  endif

  end subroutine findt_init_k
 
!#####################################################################
!#####################################################################

  subroutine findt_end_k()
 
    if ( allocated(ta_lookup) ) deallocate(ta_lookup)
    ta_lookup_allocated = .false.

  end subroutine findt_end_k

!#####################################################################
!#####################################################################

  subroutine getcin_k(pbot,thv0bot,ptop,thv0top,thvubot,  &
                      thvutop,plfc,cin,Uw_p)
    
    real,    intent(in)    :: pbot,thv0bot,ptop,thv0top,thvubot,thvutop
    real,    intent(inout) :: plfc,cin
    real                   :: frc, rhom, delp
   type(uw_params), intent(inout) :: Uw_p

    delp=(pbot-ptop)
    rhom = pbot/(Uw_p%rdgas*thv0bot*exn_k(pbot,Uw_p))+ptop/  &
           (Uw_p%rdgas*thv0top*exn_k(ptop,Uw_p))

    if(thvubot.gt.thv0bot.and.thvutop.gt.thv0top)then
       !Both top and bottom positively buoyant
       plfc = pbot
    elseif(thvubot.le.thv0bot.and.thvutop.le.thv0top)then 
       !Both top and bottom negatively buoyant
       cin  = cin  - ((thvubot/thv0bot-1.)+(thvutop/thv0top-1.)) * delp / rhom
    elseif(thvutop.le.thv0top.and.thvubot.gt.thv0bot)then
       !Top negatively buoyant; Bottom positively buoyant
       frc  = (thvutop/thv0top-1.)/((thvutop/thv0top-1.)-(thvubot/thv0bot-1.))
       delp = (ptop+frc*delp) - ptop
       cin  = cin - (thvutop/thv0top-1.) * delp / rhom
    else                                                  
       !Top positively buoyant; Bottom negatively buoyant
       frc = (thvubot/thv0bot-1.)/((thvubot/thv0bot-1.)-(thvutop/thv0top-1.))
       plfc = pbot - frc * (pbot-ptop)
       delp = pbot - plfc
       cin  = cin - (thvubot/thv0bot-1.) * delp / rhom
    endif
  end subroutine getcin_k

!#####################################################################
!#####################################################################

  subroutine getcape_k (pbot,thv0bot,ptop,thv0top,thvubot,  &
                        thvutop,plnb,cape,Uw_p)
   
    real,    intent(in)    :: pbot,thv0bot,ptop,thv0top,thvubot,thvutop
    real,    intent(inout) :: plnb,cape
   type(uw_params), intent(inout) :: Uw_p
    real                   :: frc, rhom, delp

    delp=(pbot-ptop)
    rhom = pbot/(Uw_p%rdgas*thv0bot*exn_k(pbot,Uw_p))+ptop/  &
           (Uw_p%rdgas*thv0top*exn_k(ptop,Uw_p))

    if(thvubot.gt.thv0bot.and.thvutop.gt.thv0top)then
       !Both top and bottom positively buoyant
       cape = cape + ((thvubot/thv0bot - 1.) + (thvutop/thv0top - 1.))*&
              delp/rhom
    elseif(thvubot.le.thv0bot.and.thvutop.le.thv0top)then 
       !Both top and bottom negatively buoyant
       plnb = pbot
    elseif(thvutop.le.thv0top.and.thvubot.gt.thv0bot)then
       !Top negatively buoyant; Bottom positively buoyant
       frc  = (thvubot/thv0bot-1.)/((thvubot/thv0bot-1.)-  &
              (thvutop/thv0top-1.))
       plnb = pbot - frc * (pbot-ptop)
       delp = pbot - plnb
       cape = cape + (thvubot/thv0bot-1.) * delp / rhom
    else                                                  
       !Top positively buoyant; Bottom negatively buoyant
       frc  = (thvutop/thv0top-1.)/((thvutop/thv0top-1.)- &
               (thvubot/thv0bot-1.))
       delp = (ptop+frc*delp) - ptop
       cape = cape + (thvutop/thv0top-1.) * delp / rhom
    endif

  end subroutine getcape_k


!###################################################################
!###################################################################

subroutine pack_sd_lsm_k (do_lands, land, coldT, dt, pf, ph, zf, zh, &
                          t, qv, tracers, sd)

  logical,            intent(in)    :: do_lands
  real,               intent(in)    :: land
  logical,            intent(in)    :: coldT
  real,               intent(in)    :: dt
  real, dimension(:), intent(in)    :: pf, ph, zf, zh, t, qv
!++++yim
  real, dimension(:,:), intent(in)    :: tracers
  type(sounding),     intent(inout) :: sd

!++++yim
  real, parameter :: ptopconv = 3000.
  integer :: k, nk, kmax, m

  kmax=size(t)
  sd % kmax   = kmax
  if (do_lands) then
    sd % land   = land  
    sd % coldT  = coldT    
  else
    sd % land   = 0.
    sd % coldT  = .false.
  endif 
  sd % delt   = dt   
  sd % ps(0)  = ph(kmax+1)
  sd % zs(0)  = zh(kmax+1)
  sd % ktopconv = 1

  do k=1, kmax
     nk=kmax-k+1
     sd % p (k) = pf(nk)
     sd % z (k) = zf(nk)
     sd % ps(k) = ph(nk)
     sd % zs(k) = zh(nk)
     sd % t (k) = t (nk)
     sd % qv(k) = max(qv(nk)/(1.+qv(nk)), 4.e-10) !for donner_deep where mixing-ratio passed in
     sd % ql(k) = 0.
     sd % qi(k) = 0.
     sd % qa(k) = 0.
     sd % qn(k) = 0.
     sd % u (k) = 0.
     sd % v (k) = 0.
     if (sd % p (k) > ptopconv) sd % ktopconv = k
!++++yim
       do m=1, size(tracers,2)
          sd % tr (k,m) = tracers (nk,m)
       end do
  end do

end subroutine pack_sd_lsm_k

!###################################################################
!###################################################################

! subroutine findt_k(z,p,hl,qt,th,qv,ql,qi,qs,thv,doice, Uw_p)
  subroutine findt_new_k(z,p,hl,qt,th,qv,ql,qi,qs,thv,doice, Uw_p)

      implicit none

      real, intent(in)  :: z, p, hl, qt
      real, intent(out) :: th, qv, ql, qi, qs, thv
      logical, intent(in) :: doice
      type(uw_params), intent(inout) :: Uw_p

      real hh, temp, temp_unsat, temp_sat, temp1, temp2, dtemp
      real tempmin, tempmax
      real f, f1, fmin, fmax
      real es, nu, leff, qc

      integer n, nmax
      integer hflag
      logical lbracket

      hflag = 1
      if (doice) hflag = 2

!     Definitely unsaturated case
!     The unsaturated temperature (temp_unsat) is always lower or equal 
!     to the actual temperature (temp). 
!     Therefore qs(temp_unsat) <= qs(temp), since qs(T) is monotically
!     increasing with T.

      temp = (hl-Uw_p%grav*z)/Uw_p%cp_air
      call qses_k(temp,p,qs,es,Uw_p)
      if ( qs.gt.qt ) then
        ql  = 0.
        qi  = 0.
        qv  = qt
        th  = temp/exn_k(p,Uw_p)
        thv = th*(1.+Uw_p%zvir*qv-ql-qi)
        return
      end if
      temp_unsat = temp

!     Possibly saturated case
!     Absolute bounds on the temperature

      hh = hl - Uw_p%grav*z
      tempmin = max( temp_unsat - 1.0, Uw_p%tkmin )
      tempmax = min( temp_unsat + Uw_p%hls*(qt-qs)/Uw_p%cp_air + 1.0,  &
                     Uw_p%tkmax )
      fmin = saturated_k(tempmin,hh,qt,p,hflag,Uw_p)
      fmax = saturated_k(tempmax,hh,qt,p,hflag,Uw_p)

!     The bounds on temperature are likely to be too large,
!     so we need to bracket the solution first. 
!     We search for the root closest to tempmin.

      lbracket = .false.
      dtemp = 10.0

!     Is the initial bracket good enough ?

      if ( tempmax-tempmin.le.dtemp ) then
        if ( fmin*fmax.le.0.0 ) then
          lbracket = .true.
          temp1 = tempmin
          temp2 = tempmax
        else
          dtemp = tempmax - tempmin
        endif
      endif

!     If not refine it

      do while (.not.lbracket .and. dtemp.ge.0.2)
      temp1 = tempmin
      temp2 = tempmax
      f1 = saturated_k(temp1,hh,qt,p,hflag,Uw_p)
      nmax = int( (temp2-temp1)/dtemp ) + 1
      temp = temp1
      do n=1,nmax
        temp = MIN(temp + dtemp, tempmax)
        f = saturated_k(temp,hh,qt,p,hflag,Uw_p)
        if (f1*f.le.0) then
          temp2 = temp
          lbracket = .true.
          exit
        endif
        temp1 = temp
        f1 = f
      enddo
      dtemp = 0.5 * dtemp
      enddo

!     Did we make it ?

      if (lbracket) then

!       Now find the root within the bracket

        temp_sat = zriddr_k(saturated_k,temp1,temp2,hh,qt,p,hflag,1.e-3,Uw_p)

!       Choose between one of the two choices, the highest value is temp

        if (temp_sat .gt. temp_unsat ) then
          temp = temp_sat
        else
          temp = temp_unsat
        endif

        call qses_k(temp,p,qs,es,Uw_p)
        if (doice) then
          nu = max(min((268.-temp)/20.,1.0),0.0)
        else
          nu = 0.0
        endif
        leff = (1.-nu)*Uw_p%hlv + nu*Uw_p%hls

        qc = max(qt-qs, 0.)
        qv = qt - qc
        ql = (1.-nu)*qc
        qi = nu*qc
        th = temp/exn_k(p,Uw_p)
        thv=th*(1.+Uw_p%zvir*qv-ql-qi)
        return

      else

!RSH2    write(*,*) 'WARNING findt_new_k: not bracketed'
!        write(*,*) 'Not bracketed i = ',i
!RSH :: need to properly process this error condition (if in fact it is
!       possible to occur)
!       write(*,*) 'Not bracketed temp1, temp2, dtemp, f1, f, tempmin&
!                    & tempmax, fmin, fmax = ', &
!               temp1, temp2, dtemp, f1, f, tempmin, tempmax, fmin, fmax
        temp = temp_unsat
        qv = qt
        ql = 0.0
        qi = 0.0
        th = temp/exn_k(p,Uw_p)
        thv=th*(1.+Uw_p%zvir*qv)
        return
        
      endif

      end subroutine findt_new_k
!     end subroutine findt_k

!     -----------------------------------------------------------------
!     To diagnose temp from hl and qt, we need to find the zero
!     of this function

      real function saturated_k(temp,hh,qt,p,hflag,Uw_p)
      implicit none

      real, intent(in) :: temp, hh, qt, p
      type(uw_params), intent(inout) :: Uw_p
  
      integer, intent(in) :: hflag

      real es, qs, leff, nu

      call qses_k(temp,p,qs,es,Uw_p)

      select case (hflag)
        case (0)
          leff = Uw_p%hls
        case (1)
          leff = Uw_p%hlv
        case (2)
          nu = max(min((268.0-temp)/20.,1.0),0.0)
          leff = (1.0-nu)*Uw_p%hlv + nu*Uw_p%hls
      end select
      saturated_k = hh - Uw_p%cp_air*temp + Leff*(qt-qs)

      return
      end function saturated_k

!###################################################################
!###################################################################
! Newest findt subroutine (cjg). Comparable in accuracy with
! the revised version (findt_new_k), but substantially
! faster thanks to the use of lookup tables.

! subroutine findt_fast_k(z,p,hl,qt,th,qv,ql,qi,qs,thv,doice, Uw_p)
  subroutine findt_k(z,p,hl,qt,th,qv,ql,qi,qs,thv,doice, Uw_p)

    implicit none

    real, intent(in)  :: z, p, hl, qt
    real, intent(out) :: th, qv, ql, qi, qs, thv
    logical, intent(in) :: doice
    type(uw_params), intent(inout) :: Uw_p

    integer i, il, ii, k
    integer ip1, kp1
    integer hflag

    real hh, tl, tal, tai, t0, t1, temp, temp_unsat, temp_sat
    real es
    real qc, nu, leff

    real u, w

    hflag = 1
    if (doice) hflag = 2

!   Definitely unsaturated case
!   The unsaturated temperature (temp_unsat) is always lower or equal 
!   to the actual temperature (temp). 
!   Therefore qs(temp_unsat) <= qs(temp), since qs(T) is monotically
!   increasing with T.

    tl = (hl-Uw_p%grav*z)/Uw_p%cp_air
    call qses_k(tl,p,qs,es,Uw_p)
    if ( qs.gt.qt .or. tl >= 372.9 ) then
      ql  = 0.
      qi  = 0.
      qv  = qt
      th  = tl/exn_k(p,Uw_p)          
      thv = th*(1.+Uw_p%zvir*qv-ql-qi)
      return
    end if
    temp_unsat = tl

!   Compute temperature assuming saturated air

    tai = ( hl - Uw_p%grav*z + Uw_p%hls*qt ) / Uw_p%cp_air
    tal = ( hl - Uw_p%grav*z + Uw_p%hlv*qt ) / Uw_p%cp_air

!   Are we within the lookup table range?

    il = 0
    if ( tal.gt.tamin ) il = int( (tal-tamin)*rdta ) + 1
    ii = 0
    if ( tai.gt.tamin ) ii = int( (tai-tamin)*rdta ) + 1
    k = 0
    if ( p.gt.p1min .and. p.le.p1max ) then
      k = int( (p-p1min)*rdp1 ) + 1
    else if ( p.gt.p2min ) then
      k = int( (p-p2min)*rdp2 ) + np1 + 1
    end if

    if (       il.ge.1 .and. il.lt.nta  &
         .and. ii.ge.1 .and. ii.lt.nta  &
         .and.  k.ge.1 .and.  k.lt.np1+np2 ) then

!     Inside lookup table range

!     Use bi-linear interpolation from lookup table values

      if (hflag.eq.2) then

!       Mixed phase case

!       Use bi-linear interpolation to find temperature values
!       from look up tabled

        kp1 = k+1
        if ( k.le.np1 ) then
          w = ( p  - (k-1)*dp1  - p1min  )*rdp1
        else
          w = ( p  - (k-np1-1)*dp2  - p2min  )*rdp2
        endif

!       t0 is the temperature assuming pure ice condensate

        i = ii
        ip1 = i+1
        u = ( tai - (i-1)*dta - tamin )*rdta
        t0 =   (1-u)*(1-w) * ta_lookup(i  ,k  ,0) &
             + (1-u)*w     * ta_lookup(i  ,kp1,0) &
             + u    *(1-w) * ta_lookup(ip1,k  ,0) &
             + u    *w     * ta_lookup(ip1,kp1,0)

!       t1 is the temperature assuming pure liquid condensate

        i = il
        ip1 = i+1
        u = ( tal - (i-1)*dta - tamin )*rdta
        t1 =   (1-u)*(1-w) * ta_lookup(i  ,k  ,1) &
             + (1-u)*w     * ta_lookup(i  ,kp1,1) &
             + u    *(1-w) * ta_lookup(ip1,k  ,1) &
             + u    *w     * ta_lookup(ip1,kp1,1)

!       Do either t0 or t1 fall inside the mixed phase temperature range?

        if (      (t0.ge.248.0 .and. t0.le.268.0)  &
             .or. (t1.ge.248.0 .and. t1.le.268.0) ) then

!         Yes, use t0 and t1 as initial brackets for the root. Because
!         t0 and t1 are derived from lookup tables, the actual bracket
!         must be increased slightly

          hh = hl - Uw_p%grav*z
          temp_sat = zriddr_k(sat1_k,t1-0.01,t0+0.01,hh,qt,p,hflag,1.e-3, &
                              Uw_p)

        elseif ( t0.lt.248.0 .and. t1.lt.248.0 ) then

!         No, the condensate is definitely pure ice

          temp_sat = t0

        elseif ( t0.gt.268.0 .and. t1.gt.268.0 ) then

!         No, the condensate is definitely pure liquid

          temp_sat = t1

        else

         write(*,*) 'WARNING findt_fast_k: never get there'

        endif

      else  ! hflag.ne.2

!     Not mixed phase case: hflag = 0 : ice only
!                           hflag = 1 : liquid only (doice = .false.)

      i = il
      ip1 = i+1
      kp1 = k+1
      u = ( tal - (i-1)*dta - tamin )*rdta
      if ( k.le.np1 ) then
        w = ( p  - (k-1)*dp1  - p1min  )*rdp1
      else
        w = ( p  - (k-np1-1)*dp2  - p2min  )*rdp2
      endif

      temp_sat =   (1-u)*(1-w) * ta_lookup(i  ,k  ,hflag) &
                 + (1-u)*w     * ta_lookup(i  ,kp1,hflag) &
                 + u    *(1-w) * ta_lookup(ip1,k  ,hflag) &
                 + u    *w     * ta_lookup(ip1,kp1,hflag)

      endif

    else

!     Outside lookup table range: use root finding algorithm

      call solve_hl_k(z,p,hl,qt,temp_sat,hflag,Uw_p)

    endif

!   Choose between one of the two choices (temp_unsat, temp_sat):
!   the highest value is temp

    temp = max( temp_unsat, temp_sat )

!   Compute output variables

    call qses_k(temp,p,qs,es,Uw_p)
    if (doice) then
      nu = max(min((268.-temp)/20.,1.0),0.0)
    else
      nu = 0.0
    endif
    leff = (1.-nu)*Uw_p%hlv + nu*Uw_p%hls

    qc = max(qt-qs, 0.)
    qv = qt - qc
    ql = (1.-nu)*qc
    qi = nu*qc
    th = temp/exn_k(p,Uw_p)
    thv=th*(1.+Uw_p%zvir*qv-ql-qi)

    return

!  end subroutine findt_fast_k
  end subroutine findt_k

!     -----------------------------------------------------------------
!     Subroutine to solve for temp as a function of z, p, hl, qt

      subroutine solve_hl_k(z,p,hl,qt,temp,hflag,Uw_p)
      implicit none

      real, intent(in)  :: z, p, hl, qt
      real, intent(out) :: temp
      integer, intent(in) :: hflag
      type(uw_params), intent(inout) :: Uw_p

      real hh, temp_unsat, temp_sat, temp1, temp2, dtemp
      real tempmin, tempmax
      real f, f1, fmin, fmax
      real qs, es

      integer n, nmax
      logical lbracket

!     Definitely unsaturated case
!     The unsaturated temperature (temp_unsat) is always lower or equal 
!     to the actual temperature (temp). 
!     Therefore qs(temp_unsat) <= qs(temp), since qs(T) is monotically
!     increasing with T.

      temp = (hl-Uw_p%grav*z)/Uw_p%cp_air
      call qses_k(temp,p,qs,es,Uw_p)        
      if ( qs.gt.qt ) return

!     Absolute bounds on the temperature. Return immediately
!     if the bounds are outside the range of the saturation vapor 
!     pressure lookup tables.

      tempmin = temp - 1.0
      tempmax = temp + Uw_p%hls*(qt-qs)/Uw_p%cp_air + 1.0

      if ( tempmin.lt.Uw_p%tkmin .and. tempmax.lt.Uw_p%tkmin ) then
        temp = (hl-Uw_p%grav*z+Uw_p%hls*max(qt-qs,0.))/Uw_p%cp_air
        return
      endif

      if ( tempmin.gt.Uw_p%tkmax .and. tempmax.gt.Uw_p%tkmax ) then
        temp = (hl-Uw_p%grav*z+Uw_p%hlv*max(qt-qs,0.))/Uw_p%cp_air
        return
      endif

      temp_unsat = temp
      hh = hl - Uw_p%grav*z
      fmin = sat1_k(tempmin,hh,qt,p,hflag,Uw_p)
      fmax = sat1_k(tempmax,hh,qt,p,hflag,Uw_p)  

!     The bounds on temperature are likely to be too large,
!     so we need to bracket the solution first. 
!     We search for the root closest to tempmin.

      lbracket = .false.
      dtemp = 10.0

!     Is the initial bracket good enough ?

      if ( tempmax-tempmin.le.dtemp ) then
        if ( fmin*fmax.le.0.0 ) then
          lbracket = .true.
          temp1 = tempmin
          temp2 = tempmax
        else
          dtemp=tempmax-tempmin
        endif
      endif

!     If not refine it

      do while (.not.lbracket .and. dtemp.ge.0.2)
      temp1 = tempmin
      temp2 = tempmax
      f1 = sat1_k(temp1,hh,qt,p,hflag,Uw_p)  
      nmax = int( (temp2-temp1)/dtemp ) + 1
      temp = temp1
      do n=1,nmax
        temp = min(temp + dtemp, tempmax)
        f = sat1_k(temp,hh,qt,p,hflag,Uw_p)
        if (f1*f.le.0) then
          temp2 = temp
          lbracket = .true.
          exit
        endif
        temp1 = temp
        f1 = f
      enddo
      dtemp = 0.5 * dtemp
      enddo

!     Did we manage to bracket the root ?

      if (lbracket) then

!       Yes, now find the root within the bracket

        temp_sat = zriddr_k(sat1_k,temp1,temp2,hh,qt,p,hflag,1.e-3, &
                            Uw_p)   

!       Choose between one of the two choices (temp_unsat, temp_sat):
!       the highest value is temp

        temp = max( temp_unsat, temp_sat )

      else

        if (Uw_p%me == 0) then
        write(*,'(a,4e20.12)') 'WARNING solve_hl_k: not bracketed',z,p,hl,qt
        endif
        temp = temp_unsat
        
      endif

      return
      end subroutine solve_hl_k

!     -----------------------------------------------------------------
!     Subroutine to solve for temp as a function of ta, p

      subroutine solve_ta_k(ta,p,t,hflag,Uw_p)
      implicit none

      real, intent(in)  :: ta, p
      real, intent(out) :: t
      integer, intent(in) :: hflag
      type(uw_params), intent(inout) :: Uw_p

      real temp, temp1, temp2, dtemp
      real tempmin, tempmax
      real f, f1, fmin, fmax

      integer n, nmax
      logical lbracket

!     Absolute bounds on the temperature

      tempmin = Uw_p%tkmin
      tempmax = ta + 1.0
      fmin = sat2_k(tempmin,ta,p,0.0,hflag,Uw_p)  
      fmax = sat2_k(tempmax,ta,p,0.0,hflag,Uw_p)

!     The bounds on temperature are likely to be too large,
!     so we need to bracket the solution first. 
!     We search for the root closest to tempmin.

      lbracket = .false.
      dtemp = 50.0

!     Is the initial bracket good enough ?

      if ( tempmax-tempmin.le.dtemp ) then
        if ( fmin*fmax.le.0.0 ) then
          lbracket = .true.
          temp1 = tempmin
          temp2 = tempmax
        else
          dtemp=tempmax-tempmin
        endif
      endif

!     If not refine it

      do while (.not.lbracket .and. dtemp.ge.0.1)
      temp1 = tempmin
      temp2 = tempmax
      f1 = sat2_k(temp1,ta,p,0.0,hflag,Uw_p)
      nmax = int( (temp2-temp1)/dtemp ) + 1
      temp = temp1
      do n=1,nmax
        temp = min(temp + dtemp, tempmax)
        f = sat2_k(temp,ta,p,0.0,hflag,Uw_p)
        if (f1*f.le.0) then
          temp2 = temp
          lbracket = .true.
          exit
        endif
        temp1 = temp
        f1 = f
      enddo
      dtemp = 0.5 * dtemp
      enddo

!     Did we manage to bracket the root ?

      if (lbracket) then

!       Yes, now find the root within the bracket
        t = zriddr_k(sat2_k,temp1,temp2,ta,p,0.0,hflag,1.e-10,Uw_p)
!                    epsilo,hlv,hls,cp_air,tkmin,tkmax)
        return

      else

!       No, bracketing failed
        write(*,*) 'WARNING solve_ta_k: not bracketed'
        t = -999.0
        return
        
      endif

      end subroutine solve_ta_k

!     -----------------------------------------------------------------
!     To diagnose temp from hl and qt, we need to find the zero
!     of this function

      real function sat1_k(temp,hh,qt,p,hflag,Uw_p)  
      implicit none

      real, intent(in) :: temp, hh, qt, p
      integer, intent(in) :: hflag
      type(uw_params), intent(inout) :: Uw_p

      integer ier
      real qs, leff, nu
      real t

!     In-line qses computation here for better performance
      t = min(max(temp,Uw_p%tkmin),Uw_p%tkmax)
!   INLINING ????
      call compute_qs_k (t, p, Uw_p%epsilo, Uw_p%zvir, qs, ier)

      select case (hflag)
        case (0)
          leff = Uw_p%hls
        case (1)
          leff = Uw_p%hlv
        case (2)
          nu = max(min((268.0-temp)/20.,1.0),0.0)
          leff = (1.0-nu)*Uw_p%hlv + nu*Uw_p%hls
      end select
      sat1_k = hh - Uw_p%cp_air*temp + leff*(qt-qs)

      return
      end function sat1_k

!     -----------------------------------------------------------------
!     To diagnose temp from ta and p, we need to find the zero
!     of this function

      real function sat2_k(temp,ta,p,tmp,hflag, Uw_p)
      implicit none

      real, intent(in) :: temp, ta, p, tmp
      integer, intent(in) :: hflag
      type(uw_params), intent(inout) :: Uw_p

      integer ier
      real qs, leff, nu
      real t

!     In-line qses computation here for better performance
      t = min(max(temp,Uw_p%tkmin),Uw_p%tkmax)
!   INLINING ????
      call compute_qs_k (t, p, Uw_p%epsilo, Uw_p%zvir, qs, ier)

      select case (hflag)
        case (0)
          leff = Uw_p%hls
        case (1)
          leff = Uw_p%hlv
        case (2)
          nu = max(min((268.0-temp)/20.,1.0),0.0)
          leff = (1.0-nu)*Uw_p%hlv + nu*Uw_p%hls
      end select
      sat2_k = ta - temp - leff/Uw_p%cp_air*qs

      return
      end function sat2_k

!     -----------------------------------------------------------------
!     Function to find zero of function 'saturated' using Ridders'
!     method

      real function zriddr_k(func, x1,x2,ya,yb,yc,ld,xacc,Uw_p)
      implicit none

      integer maxit
      real unused
      type(uw_params) Uw_p
      parameter (maxit=60,unused=-1.11e30)

      real func
      external func

      real x1,x2,xacc
      real ya,yb,yc
      integer ld
      
      integer j
      real fh,fl,fm,fnew,s,xh,xl,xm,xnew

      fl=func       (x1,ya,yb,yc,ld,Uw_p)
      fh=func       (x2,ya,yb,yc,ld,Uw_p)
      if((fl.gt.0..and.fh.lt.0.).or.(fl.lt.0..and.fh.gt.0.))then
        xl=x1
        xh=x2
        zriddr_k=unused
        do j=1,maxit
          xm=0.5*(xl+xh)
          fm=func       (xm,ya,yb,yc,ld,Uw_p)
          s=sqrt(fm**2-fl*fh)
          if(s.eq.0.)return
          xnew=xm+(xm-xl)*(sign(1.,fl-fh)*fm/s)
          if (abs(xnew-zriddr_k).le.xacc) return
          zriddr_k=xnew
          fnew=func       (zriddr_k,ya,yb,yc,ld,Uw_p)
          if (fnew.eq.0.) return
          if(sign(fm,fnew).ne.fm) then
            xl=xm
            fl=fm
            xh=zriddr_k
            fh=fnew
          else if(sign(fl,fnew).ne.fl) then
            xh=zriddr_k
            fh=fnew
          else if(sign(fh,fnew).ne.fh) then
            xl=zriddr_k
            fl=fnew
          else
!            write(*,*) 'WARNING: never get here in zriddr'
!            write(*,*) 'WARNING zriddr_k: never get there'
          endif
          if(abs(xh-xl).le.xacc) return
        enddo
!       write(*,*) 'WARNING zriddr_k: exceeded maximum iterations'
!        write(*,*) 'WARNING: zriddr exceed maximum iterations'
!  need to properly handle error condition
!        write(*,*) 'WARNING: zriddr exceed maximum iterations', &
!         x1, x2, xl, xh
      else if (fl.eq.0.) then
        zriddr_k=x1
      else if (fh.eq.0.) then
        zriddr_k=x2
      else
!        write(*,*) 'WARNING zriddr_k: root must be bracketed'
!        write(*,*) 'WARNING: root must be bracketed in zriddr'
      endif

      return
      end function zriddr_k

!######################################################################

!++lwh
subroutine check_tracer_realizability(kmax, ntr, dt, &
                                             tracers, trten, trwet)
!---------------------------------------------------------------------
!  Check for tracer realizability. If convective tendencies would
!  produce negative tracer mixing ratios, scale down tracer tendency
!  terms uniformly for this tracer throughout convective column. This is
!  equivalent to limiting the cell areas.
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  Dummy arguments
!---------------------------------------------------------------------
integer,                 intent(in)     :: kmax, ntr
real,                    intent(in)     :: dt 
real, dimension(kmax,ntr), &
                         intent(in)     :: tracers        
real,dimension(kmax,ntr),intent(inout)  :: trten, trwet

!---------------------------------------------------------------------
!   intent(in) variables:
!     tracers        tracer mixing ratios
!                    [ kg(tracer) / kg (dry air) ]
!     kmax           number of model layers in large-scale model
!     dt             physics time step [ sec ]
!
!   intent(inout) variables:
!     trten          tracer tendency
!     trwet          tracer wet deposition tendency
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  Local variables
!---------------------------------------------------------------------

   integer :: n,k
   real, dimension(kmax) :: tracer0, trtend, trtendw, tracer1, tracer1w
   real :: ratio, tracer_max, tracer_min

!---------------------------------------------------------------------
!   local variables:
!
!     tracers        tracer mixing ratios of tracers transported by the
!                    donner deep convection parameterization
!                    [ tracer units, e.g., kg(tracer) / kg (dry air) ]
!     tracer0        column tracer mixing ratios before convection
!     trtend         column tracer mixing ratio tendencies due to convection [ (tracer units) / s ]
!     tracer1        column tracer mixing ratios after convection
!     k, n     do-loop indices
!     ratio          ratio by which tracer convective tendencies need to 
!                    be reduced to permit realizability (i.e., to prevent
!                    negative tracer mixing ratios)
!
!---------------------------------------------------------------------

   do n = 1,ntr
      
      tracer0(:)  = tracers(:,n)
      trtend(:)   = trten(:,n)
      trtendw(:)  = trtend(:) + trwet(:,n)
      tracer1(:)  = tracer0 + dt * trtend(:)
      tracer1w(:) = tracer0 + dt * trtendw(:)

      tracer_min = 1.e20
      tracer_max = -1.e20

      do k = 1,kmax
         if (trtend(k) /= 0.) then
            tracer_max = max(tracer0(k),tracer_max)
            tracer_min = min(tracer0(k),tracer_min)
         end if
      end do
 
      ratio = 1.
      do k = 1,kmax
         if (tracer0(k)>0. .and. tracer1w(k)<0. ) then
            ratio = MIN( ratio,tracer0(k)/(-trtendw(k)*dt) )
         end if
         if (tracer1(k)<tracer_min .and. trtend(k) /= 0.0 ) then
            ratio = MIN( ratio,(tracer0(k)-tracer_min)/(-trtend(k)*dt) )
         end if
         if (tracer1(k)>tracer_max  .and. trtend(k) /= 0.0 ) then
            ratio = MIN( ratio,(tracer_max-tracer0(k))/(trtend(k)*dt) )
         end if
      end do
      ratio = MAX(0.,MIN(1.,ratio))
      if (ratio /= 1.) then
         trten(:,n) =  trten(:,n)*ratio
         trwet(:,n) =  trwet(:,n)*ratio
      end if
   end do


end subroutine check_tracer_realizability
!--lwh

!#####################################################################
subroutine qt_parcel_k (qs, qstar, pblht, tke, land, gama, pblht0, tke0, lofactor0, &
     lochoice, qt, lofactor)
    real,    intent(in)    :: qs, qstar, pblht, tke, land, gama, pblht0, tke0, lofactor0
    integer, intent(in)    :: lochoice
    real,    intent(inout) :: qt, lofactor

    real :: qttmp

    if (lochoice .eq. 0) then
       lofactor = 1. - land * (1. - lofactor0)
    elseif (lochoice .eq. 1) then
       lofactor = pblht0 / max(pblht,  pblht0)
    elseif (lochoice .eq. 2) then
       lofactor = tke0   / max(tke, tke0  )
    elseif (lochoice .eq. 3) then
       lofactor = tke0   / max(tke, tke0  )
       lofactor = sqrt(lofactor)
    else
       lofactor = 1.
    end if

    qttmp = qt*(1. + gama * land)
    qt    = max(qt, min(qttmp, qs))
 
  end subroutine qt_parcel_k


end MODULE CONV_UTILITIES_k_MOD

module monin_obukhov_mod


!=======================================================================
!
!                         MONIN-OBUKHOV MODULE
!
!          Routines for computing surface drag coefficients 
!                 from data at the lowest model level 
!              and for computing the profile of fields 
!           between the lowest model level and the ground
!                  using Monin-Obukhov scaling 
!
!=======================================================================


use constants_mod, only: grav, vonkarm
use mpp_mod,       only: input_nml_file
use fms_mod,       only: error_mesg, FATAL, file_exist,   &
                         check_nml_error, open_namelist_file,      &
                         mpp_pe, mpp_root_pe, close_file, stdlog, &
                         write_version_number

implicit none
private

!=======================================================================
 public monin_obukhov_init
 public monin_obukhov_end
 public mo_drag
 public mo_profile
 public mo_diff
 public stable_mix
!=======================================================================

interface mo_drag
    module procedure  mo_drag_0d, mo_drag_1d, mo_drag_2d
end interface


interface mo_profile
    module procedure  mo_profile_0d,   mo_profile_1d,   mo_profile_2d, &
                      mo_profile_0d_n, mo_profile_1d_n, mo_profile_2d_n
end interface

interface mo_diff
    module procedure  mo_diff_0d_n, mo_diff_0d_1, &
                      mo_diff_1d_n, mo_diff_1d_1, &
                      mo_diff_2d_n, mo_diff_2d_1
end interface

interface stable_mix
    module procedure  stable_mix_0d, stable_mix_1d, &
                      stable_mix_2d, stable_mix_3d
end interface


!--------------------- version number ---------------------------------

character(len=128) :: version = '$Id: monin_obukhov.F90,v 19.0 2012/01/06 20:10:48 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!=======================================================================

!  DEFAULT VALUES OF NAMELIST PARAMETERS:

real    :: rich_crit      = 2.0
real    :: drag_min       = 1.e-05          
logical :: neutral        = .false.
integer :: stable_option  = 1
real    :: zeta_trans     = 0.5


namelist /monin_obukhov_nml/ rich_crit, neutral, drag_min, &
                             stable_option, zeta_trans

!=======================================================================

!  MODULE VARIABLES

real, parameter    :: small  = 1.e-04
real               :: b_stab, r_crit, sqrt_drag_min, lambda, rich_trans
logical            :: module_is_initialized = .false.


contains

!=======================================================================

subroutine monin_obukhov_init

integer :: unit, ierr, io, logunit

!------------------- read namelist input -------------------------------

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=monin_obukhov_nml, iostat=io)
      ierr = check_nml_error(io,"monin_obukhov_nml")
#else
      if (file_exist('input.nml')) then
         unit = open_namelist_file ()
         ierr=1; do while (ierr /= 0)
            read  (unit, nml=monin_obukhov_nml, iostat=io, end=10)
            ierr = check_nml_error(io,'monin_obukhov_nml')
         enddo
  10     call close_file (unit)
      endif
#endif

!---------- output namelist to log-------------------------------------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
           logunit = stdlog()
           write (logunit, nml=monin_obukhov_nml)
      endif
      
!----------------------------------------------------------------------

if(rich_crit.le.0.25)  call error_mesg( &
        'MONIN_OBUKHOV_INIT in MONIN_OBUKHOV_MOD', &
        'rich_crit in monin_obukhov_mod must be > 0.25', FATAL)

if(drag_min.le.0.0)  call error_mesg( &
        'MONIN_OBUKHOV_INIT in MONIN_OBUKHOV_MOD', &
        'drag_min in monin_obukhov_mod must be >= 0.0', FATAL)

if(stable_option < 1 .or. stable_option > 2) call error_mesg( &
        'MONIN_OBUKHOV_INIT in MONIN_OBUKHOV_MOD', &
        'the only allowable values of stable_option are 1 and 2', FATAL)

if(stable_option == 2 .and. zeta_trans < 0) call error_mesg( &
        'MONIN_OBUKHOV_INIT in MONIN_OBUKHOV_MOD', &
        'zeta_trans must be positive', FATAL)

b_stab = 1.0/rich_crit
r_crit = 0.95*rich_crit  ! convergence can get slow if one is 
                         ! close to rich_crit

sqrt_drag_min = 0.0
if(drag_min.ne.0.0) sqrt_drag_min = sqrt(drag_min)

lambda     = 1.0 + (5.0 - b_stab)*zeta_trans   ! used only if stable_option = 2
rich_trans = zeta_trans/(1.0 + 5.0*zeta_trans) ! used only if stable_option = 2

module_is_initialized = .true.

return
end subroutine monin_obukhov_init

!=======================================================================

subroutine monin_obukhov_end

module_is_initialized = .false.

end subroutine monin_obukhov_end

!=======================================================================

subroutine mo_drag_1d &
         (pt, pt0, z, z0, zt, zq, speed, drag_m, drag_t, drag_q, &
          u_star, b_star, avail)

real, intent(in)   , dimension(:) :: pt, pt0, z, z0, zt, zq, speed
real, intent(inout), dimension(:) :: drag_m, drag_t, drag_q, u_star, b_star
logical, intent(in), optional, dimension(:) :: avail

logical            :: lavail, avail_dummy(1)
integer            :: n, ier

integer, parameter :: max_iter = 20
real   , parameter :: error=1.e-04, zeta_min=1.e-06, small=1.e-04

! #include "monin_obukhov_interfaces.h"

if(.not.module_is_initialized) call monin_obukhov_init

n      = size(pt)
lavail = .false.
if(present(avail)) lavail = .true.


if(lavail) then 
   if (count(avail) .eq. 0) return
   call monin_obukhov_drag_1d(grav, vonkarm,               &
        & error, zeta_min, max_iter, small,                         &
        & neutral, stable_option, rich_crit, zeta_trans, drag_min,  &
        & n, pt, pt0, z, z0, zt, zq, speed, drag_m, drag_t,         &
        & drag_q, u_star, b_star, lavail, avail, ier)
else
   call monin_obukhov_drag_1d(grav, vonkarm,               &
        & error, zeta_min, max_iter, small,                         &
        & neutral, stable_option, rich_crit, zeta_trans, drag_min,  &
        & n, pt, pt0, z, z0, zt, zq, speed, drag_m, drag_t,         &
        & drag_q, u_star, b_star, lavail, avail_dummy, ier)
endif

end subroutine mo_drag_1d


!=======================================================================

subroutine mo_profile_1d(zref, zref_t, z, z0, zt, zq, u_star, b_star, q_star, &
                         del_m, del_t, del_q, avail)

real,    intent(in)                :: zref, zref_t
real,    intent(in) , dimension(:) :: z, z0, zt, zq, u_star, b_star, q_star
real,    intent(out), dimension(:) :: del_m, del_t, del_q
logical, intent(in) , optional, dimension(:) :: avail

logical                            :: dummy_avail(1)
integer                            :: n, ier

! #include "monin_obukhov_interfaces.h"

if(.not. module_is_initialized) call monin_obukhov_init

n = size(z)
if(present(avail)) then

   if (count(avail) .eq. 0) return

   call monin_obukhov_profile_1d(vonkarm, &
        & neutral, stable_option, rich_crit, zeta_trans, &
        & n, zref, zref_t, z, z0, zt, zq, u_star, b_star, q_star, &
        & del_m, del_t, del_q, .true., avail, ier)

else

   call monin_obukhov_profile_1d(vonkarm, &
        & neutral, stable_option, rich_crit, zeta_trans, &
        & n, zref, zref_t, z, z0, zt, zq, u_star, b_star, q_star, &
        & del_m, del_t, del_q, .false., dummy_avail, ier)

endif

end subroutine mo_profile_1d

!=======================================================================

subroutine stable_mix_3d(rich, mix)

real, intent(in) , dimension(:,:,:)  :: rich
real, intent(out), dimension(:,:,:)  :: mix

integer :: n, ier

if(.not. module_is_initialized) call monin_obukhov_init

n = size(rich,1)*size(rich,2)*size(rich,3)
call monin_obukhov_stable_mix(stable_option, rich_crit, zeta_trans, &
     & n, rich, mix, ier)


end subroutine stable_mix_3d

!=======================================================================

subroutine mo_diff_2d_n(z, u_star, b_star, k_m, k_h)

real, intent(in),  dimension(:,:,:) :: z
real, intent(in),  dimension(:,:)   :: u_star, b_star
real, intent(out), dimension(:,:,:) :: k_m, k_h

integer            :: ni, nj, nk, ier
real, parameter    :: ustar_min = 1.e-10

if(.not.module_is_initialized) call monin_obukhov_init

ni = size(z, 1); nj = size(z, 2); nk = size(z, 3)
call monin_obukhov_diff(vonkarm,                           &
          & ustar_min,                                     &
          & neutral, stable_option, rich_crit, zeta_trans, &
          & ni, nj, nk, z, u_star, b_star, k_m, k_h, ier)

end subroutine mo_diff_2d_n

!=======================================================================
! The following routines are used by the public interfaces above
!=======================================================================

subroutine solve_zeta(rich, z, z0, zt, zq, f_m, f_t, f_q, mask)

real   , intent(in) , dimension(:) :: rich, z, z0, zt, zq
logical, intent(in) , dimension(:) :: mask
real   , intent(out), dimension(:) :: f_m, f_t, f_q


real, parameter    :: error    = 1.e-04
real, parameter    :: zeta_min = 1.e-06
integer, parameter :: max_iter = 20

real    :: max_cor
integer :: iter

real, dimension(size(rich(:))) ::   &
          d_rich, rich_1, correction, corr, z_z0, z_zt, z_zq, &
          ln_z_z0, ln_z_zt, ln_z_zq, zeta,                    &
          phi_m, phi_m_0, phi_t, phi_t_0, rzeta,              &
          zeta_0, zeta_t, zeta_q, df_m, df_t
          
logical, dimension(size(rich(:))) :: mask_1


z_z0 = z/z0
z_zt = z/zt
z_zq = z/zq
ln_z_z0 = log(z_z0)
ln_z_zt = log(z_zt)
ln_z_zq = log(z_zq)

corr = 0.0
mask_1 = mask

! initial guess

where(mask_1) 
  zeta = rich*ln_z_z0*ln_z_z0/ln_z_zt
elsewhere
  zeta = 0.0
end where

where (mask_1 .and. rich >= 0.0)
  zeta = zeta/(1.0 - rich/rich_crit)
end where 

iter_loop: do iter = 1, max_iter

  where (mask_1 .and. abs(zeta).lt.zeta_min) 
    zeta = 0.0
    f_m = ln_z_z0
    f_t = ln_z_zt
    f_q = ln_z_zq
    mask_1 = .false.  ! don't do any more calculations at these pts
  end where
  
  where (mask_1)
    rzeta  = 1.0/zeta
    zeta_0 = zeta/z_z0
    zeta_t = zeta/z_zt
    zeta_q = zeta/z_zq
  elsewhere
    zeta_0 = 0.0
    zeta_t = 0.0
    zeta_q = 0.0
  end where

  call mo_derivative_m(phi_m  , zeta  , mask_1)
  call mo_derivative_m(phi_m_0, zeta_0, mask_1)
  call mo_derivative_t(phi_t  , zeta  , mask_1)
  call mo_derivative_t(phi_t_0, zeta_t, mask_1)
                   
  call mo_integral_m(f_m, zeta, zeta_0, ln_z_z0, mask_1)
  call mo_integral_tq(f_t, f_q, zeta, zeta_t, zeta_q, ln_z_zt, ln_z_zq, mask_1)

  where (mask_1)
    df_m  = (phi_m - phi_m_0)*rzeta
    df_t  = (phi_t - phi_t_0)*rzeta
    rich_1 = zeta*f_t/(f_m*f_m)
    d_rich = rich_1*( rzeta +  df_t/f_t - 2.0 *df_m/f_m) 
    correction = (rich - rich_1)/d_rich  
    corr = min(abs(correction),abs(correction/zeta)) 
      ! the criterion corr < error seems to work ok, but is a bit arbitrary
      !  when zeta is small the tolerance is reduced
  end where
  
  max_cor= maxval(corr)

  if(max_cor > error) then
    mask_1 = mask_1 .and. (corr > error)  
       ! change the mask so computation proceeds only on non-converged points
    where(mask_1) 
      zeta = zeta + correction
    end where
    cycle iter_loop
  else
    return
  end if

end do iter_loop

call error_mesg ('solve_zeta in monin_obukhov_mod',  &
                 'surface drag iteration did not converge', FATAL)

end subroutine solve_zeta

!=======================================================================

subroutine mo_derivative_m(phi_m, zeta, mask)

! the differential similarity function for momentum

real    , intent(out),  dimension(:) :: phi_m
real    , intent(in),   dimension(:) :: zeta
logical , intent(in),   dimension(:) :: mask

logical, dimension(size(zeta(:))) :: stable, unstable
real   , dimension(size(zeta(:))) :: x

stable   = mask .and. zeta >= 0.0
unstable = mask .and. zeta <  0.0

where (unstable) 
  x     = (1 - 16.0*zeta  )**(-0.5)
  phi_m = sqrt(x)  ! phi_m = (1 - 16.0*zeta)**(-0.25)
end where

if(stable_option == 1) then 

  where (stable) 
    phi_m = 1.0 + zeta  *(5.0 + b_stab*zeta)/(1.0 + zeta)
  end where
  
else if(stable_option == 2) then

  where (stable .and. zeta < zeta_trans)
    phi_m = 1 + 5.0*zeta
  end where
  where (stable .and. zeta >= zeta_trans)
    phi_m = lambda + b_stab*zeta
  end where

endif

return
end subroutine mo_derivative_m

!=======================================================================

subroutine mo_derivative_t(phi_t, zeta, mask)

! the differential similarity function for buoyancy and tracers

real    , intent(out),  dimension(:) :: phi_t
real    , intent(in),   dimension(:) :: zeta
logical , intent(in),   dimension(:) :: mask

logical, dimension(size(zeta(:))) :: stable, unstable

stable   = mask .and. zeta >= 0.0
unstable = mask .and. zeta <  0.0

where (unstable) 
  phi_t = (1 - 16.0*zeta)**(-0.5)
end where

if(stable_option == 1) then 

  where (stable) 
    phi_t = 1.0 + zeta*(5.0 + b_stab*zeta)/(1.0 + zeta)
  end where
  
else if(stable_option == 2) then

  where (stable .and. zeta < zeta_trans)
    phi_t = 1 + 5.0*zeta
  end where
  where (stable .and. zeta >= zeta_trans)
    phi_t = lambda + b_stab*zeta
  end where

endif

return
end subroutine mo_derivative_t

!=======================================================================

subroutine mo_integral_tq (psi_t, psi_q, zeta, zeta_t, zeta_q, &
                           ln_z_zt, ln_z_zq, mask)

! the integral similarity function for moisture and tracers

real    , intent(out), dimension(:) :: psi_t, psi_q
real    , intent(in),  dimension(:) :: zeta, zeta_t, zeta_q, ln_z_zt, ln_z_zq
logical , intent(in),  dimension(:) :: mask

real, dimension(size(zeta(:))) :: x, x_t, x_q
                               
logical, dimension(size(zeta(:))) :: stable, unstable, &
                                  weakly_stable, strongly_stable

stable   = mask .and. zeta >= 0.0
unstable = mask .and. zeta <  0.0

where(unstable) 

  x     = sqrt(1 - 16.0*zeta)
  x_t   = sqrt(1 - 16.0*zeta_t)
  x_q   = sqrt(1 - 16.0*zeta_q)
  
  psi_t = ln_z_zt - 2.0*log( (1.0 + x)/(1.0 + x_t) )
  psi_q = ln_z_zq - 2.0*log( (1.0 + x)/(1.0 + x_q) )

end where

if( stable_option == 1) then

  where (stable) 
  
    psi_t = ln_z_zt + (5.0 - b_stab)*log((1.0 + zeta)/(1.0 + zeta_t)) &
       + b_stab*(zeta - zeta_t) 
    psi_q = ln_z_zq + (5.0 - b_stab)*log((1.0 + zeta)/(1.0 + zeta_q)) &
       + b_stab*(zeta - zeta_q) 
       
  end where
  
else if (stable_option == 2) then

  weakly_stable   = stable .and. zeta <= zeta_trans
  strongly_stable = stable .and. zeta >  zeta_trans

  where (weakly_stable)
    psi_t = ln_z_zt + 5.0*(zeta - zeta_t) 
    psi_q = ln_z_zq + 5.0*(zeta - zeta_q) 
  end where
  
  where(strongly_stable)
    x = (lambda - 1.0)*log(zeta/zeta_trans) + b_stab*(zeta - zeta_trans)
  endwhere
  
  where (strongly_stable .and. zeta_t <= zeta_trans)
    psi_t = ln_z_zt + x + 5.0*(zeta_trans - zeta_t)
  end where
  where (strongly_stable .and. zeta_t > zeta_trans)
    psi_t = lambda*ln_z_zt + b_stab*(zeta  - zeta_t)
  endwhere
  
  where (strongly_stable .and. zeta_q <= zeta_trans)
    psi_q = ln_z_zq + x + 5.0*(zeta_trans - zeta_q)
  end where
  where (strongly_stable .and. zeta_q > zeta_trans)
    psi_q = lambda*ln_z_zq + b_stab*(zeta  - zeta_q)
  endwhere
  
end if

return
end subroutine mo_integral_tq

!=======================================================================

subroutine mo_integral_m (psi_m, zeta, zeta_0, ln_z_z0, mask)

!  the integral similarity function for momentum

real    , intent(out), dimension(:) :: psi_m
real    , intent(in),  dimension(:) :: zeta, zeta_0, ln_z_z0
logical , intent(in),  dimension(:) :: mask

real, dimension(size(zeta(:))) :: x, x_0, x1, x1_0, num, denom, y
                               
logical, dimension(size(zeta(:))) :: stable, unstable, &
                                  weakly_stable, strongly_stable

stable   = mask .and. zeta >= 0.0
unstable = mask .and. zeta <  0.0

where(unstable) 

  x     = sqrt(1 - 16.0*zeta)
  x_0   = sqrt(1 - 16.0*zeta_0)

  x      = sqrt(x)
  x_0    = sqrt(x_0)
  
  x1     = 1.0 + x
  x1_0   = 1.0 + x_0
  
  num    = x1*x1*(1.0 + x*x)
  denom  = x1_0*x1_0*(1.0 + x_0*x_0)
  y      = atan(x) - atan(x_0)
  psi_m  = ln_z_z0 - log(num/denom) + 2*y
  
end where

if( stable_option == 1) then

  where (stable) 
    psi_m = ln_z_z0 + (5.0 - b_stab)*log((1.0 + zeta)/(1.0 + zeta_0)) &
       + b_stab*(zeta - zeta_0) 
  end where
  
else if (stable_option == 2) then

  weakly_stable   = stable .and. zeta <= zeta_trans
  strongly_stable = stable .and. zeta >  zeta_trans

  where (weakly_stable)
    psi_m = ln_z_z0 + 5.0*(zeta - zeta_0) 
  end where
  
  where(strongly_stable)
    x = (lambda - 1.0)*log(zeta/zeta_trans) + b_stab*(zeta - zeta_trans)
  endwhere
  
  where (strongly_stable .and. zeta_0 <= zeta_trans)
    psi_m = ln_z_z0 + x + 5.0*(zeta_trans - zeta_0)
  end where
  where (strongly_stable .and. zeta_0 > zeta_trans)
    psi_m = lambda*ln_z_z0 + b_stab*(zeta  - zeta_0)
  endwhere
  
end if

return
end subroutine mo_integral_m


!=======================================================================
! The following routines allow the public interfaces to be used
! with different dimensions of the input and output
!
!=======================================================================


subroutine mo_drag_2d &
    (pt, pt0, z, z0, zt, zq, speed, drag_m, drag_t, drag_q, u_star, b_star)

real, intent(in)   , dimension(:,:) :: z, speed, pt, pt0, z0, zt, zq
real, intent(out)  , dimension(:,:) :: drag_m, drag_t, drag_q
real, intent(inout), dimension(:,:) :: u_star, b_star

integer :: j

do j = 1, size(pt,2)
  call mo_drag_1d (pt(:,j), pt0(:,j), z(:,j), z0(:,j), zt(:,j), zq(:,j), &
                   speed(:,j), drag_m(:,j), drag_t(:,j), drag_q(:,j), &
                   u_star(:,j), b_star(:,j))
end do


return
end subroutine mo_drag_2d

!=======================================================================
subroutine mo_drag_0d &
    (pt, pt0, z, z0, zt, zq, speed, drag_m, drag_t, drag_q, u_star, b_star)

real, intent(in)    :: z, speed, pt, pt0, z0, zt, zq
real, intent(out)   :: drag_m, drag_t, drag_q, u_star, b_star

real, dimension(1) :: pt_1, pt0_1, z_1, z0_1, zt_1, zq_1, speed_1, &
                      drag_m_1, drag_t_1, drag_q_1, u_star_1, b_star_1

pt_1   (1) = pt
pt0_1  (1) = pt0
z_1    (1) = z
z0_1   (1) = z0
zt_1   (1) = zt
zq_1   (1) = zq
speed_1(1) = speed

call mo_drag_1d (pt_1, pt0_1, z_1, z0_1, zt_1, zq_1, speed_1, &
                 drag_m_1, drag_t_1, drag_q_1, u_star_1, b_star_1)

drag_m = drag_m_1(1)
drag_t = drag_t_1(1)
drag_q = drag_q_1(1)
u_star = u_star_1(1)
b_star = b_star_1(1)

return
end subroutine mo_drag_0d
!=======================================================================

subroutine mo_profile_2d(zref, zref_t, z, z0, zt, zq, u_star, b_star, q_star, &
                         del_m, del_h, del_q)

real, intent(in)                  :: zref, zref_t
real, intent(in) , dimension(:,:) :: z, z0, zt, zq, u_star, b_star, q_star
real, intent(out), dimension(:,:) :: del_m, del_h, del_q

integer :: j

do j = 1, size(z,2)
  call mo_profile_1d (zref, zref_t, z(:,j), z0(:,j), zt(:,j),         &
                      zq(:,j), u_star(:,j), b_star(:,j), q_star(:,j), &
                      del_m(:,j), del_h (:,j), del_q (:,j))
enddo

return
end subroutine mo_profile_2d

!=======================================================================

subroutine mo_profile_0d(zref, zref_t, z, z0, zt, zq, u_star, b_star, q_star, &
                         del_m, del_h, del_q)

real, intent(in)  :: zref, zref_t
real, intent(in)  :: z, z0, zt, zq, u_star, b_star, q_star
real, intent(out) :: del_m, del_h, del_q

real, dimension(1) :: z_1, z0_1, zt_1, zq_1, u_star_1, b_star_1, q_star_1, &
                      del_m_1, del_h_1, del_q_1

z_1     (1) = z
z0_1    (1) = z0
zt_1    (1) = zt
zq_1    (1) = zq
u_star_1(1) = u_star
b_star_1(1) = b_star
q_star_1(1) = q_star

call mo_profile_1d (zref, zref_t, z_1, z0_1, zt_1, zq_1, &
                    u_star_1, b_star_1, q_star_1,        &
                    del_m_1, del_h_1, del_q_1)
                    
del_m = del_m_1(1)
del_h = del_h_1(1)
del_q = del_q_1(1)
                    

return
end subroutine mo_profile_0d

!=======================================================================

subroutine mo_profile_1d_n(zref, z, z0, zt, zq, u_star, b_star, q_star, &
                         del_m, del_t, del_q, avail)

real,    intent(in),  dimension(:)   :: zref
real,    intent(in) , dimension(:)   :: z, z0, zt, zq, u_star, b_star, q_star
real,    intent(out), dimension(:,:) :: del_m, del_t, del_q
logical, intent(in) , optional, dimension(:) :: avail

integer :: k

do k = 1, size(zref(:))
  if(present(avail)) then
    call mo_profile_1d (zref(k), zref(k), z, z0, zt, zq, &
       u_star, b_star, q_star, del_m(:,k), del_t(:,k), del_q(:,k), avail)
  else 
      call mo_profile_1d (zref(k), zref(k), z, z0, zt, zq, &
       u_star, b_star, q_star, del_m(:,k), del_t(:,k), del_q(:,k))
  endif
enddo

return
end subroutine mo_profile_1d_n

!=======================================================================

subroutine mo_profile_0d_n(zref, z, z0, zt, zq, u_star, b_star, q_star, &
                         del_m, del_t, del_q)

real,    intent(in),  dimension(:) :: zref
real,    intent(in)                :: z, z0, zt, zq, u_star, b_star, q_star
real,    intent(out), dimension(:) :: del_m, del_t, del_q

integer :: k

do k = 1, size(zref(:))
  call mo_profile_0d (zref(k), zref(k), z, z0, zt, zq, &
       u_star, b_star, q_star, del_m(k), del_t(k), del_q(k))
enddo

return
end subroutine mo_profile_0d_n

!=======================================================================

subroutine mo_profile_2d_n(zref, z, z0, zt, zq, u_star, b_star, q_star, &
                         del_m, del_t, del_q)

real,    intent(in),  dimension(:)     :: zref
real,    intent(in),  dimension(:,:)   :: z, z0, zt, zq, u_star, b_star, q_star
real,    intent(out), dimension(:,:,:) :: del_m, del_t, del_q

integer :: k

do k = 1, size(zref(:))
  call mo_profile_2d (zref(k), zref(k), z, z0, zt, zq, &
       u_star, b_star, q_star, del_m(:,:,k), del_t(:,:,k), del_q(:,:,k))
enddo

return
end subroutine mo_profile_2d_n

!=======================================================================

subroutine mo_diff_2d_1(z, u_star, b_star, k_m, k_h)

real, intent(in),  dimension(:,:) :: z, u_star, b_star
real, intent(out), dimension(:,:) :: k_m, k_h

real   , dimension(size(z,1),size(z,2),1) :: z_n, k_m_n, k_h_n

z_n(:,:,1) = z

call mo_diff_2d_n(z_n, u_star, b_star, k_m_n, k_h_n)

k_m = k_m_n(:,:,1)
k_h = k_h_n(:,:,1)

return
end subroutine mo_diff_2d_1


!=======================================================================

subroutine mo_diff_1d_1(z, u_star, b_star, k_m, k_h)

real, intent(in),  dimension(:) :: z, u_star, b_star
real, intent(out), dimension(:) :: k_m, k_h

real, dimension(size(z),1,1) :: z_n, k_m_n, k_h_n
real, dimension(size(z),1)   :: u_star_n, b_star_n

z_n   (:,1,1) = z
u_star_n(:,1) = u_star
b_star_n(:,1) = b_star

call mo_diff_2d_n(z_n, u_star_n, b_star_n, k_m_n, k_h_n)

k_m = k_m_n(:,1,1)
k_h = k_h_n(:,1,1)

return
end subroutine mo_diff_1d_1

!=======================================================================

subroutine mo_diff_1d_n(z, u_star, b_star, k_m, k_h)

real, intent(in),  dimension(:,:) :: z
real, intent(in),  dimension(:)   :: u_star, b_star
real, intent(out), dimension(:,:) :: k_m, k_h

real, dimension(size(z,1),1)            :: u_star2, b_star2
real, dimension(size(z,1),1, size(z,2)) :: z2, k_m2, k_h2

integer :: n

do n = 1, size(z,2)
  z2   (:,1,n) = z(:,n)
enddo
u_star2(:,1) = u_star
b_star2(:,1) = b_star

call mo_diff_2d_n(z2, u_star2, b_star2, k_m2, k_h2)

do n = 1, size(z,2)
  k_m(:,n) = k_m2(:,1,n)
  k_h(:,n) = k_h2(:,1,n)
enddo

return
end subroutine mo_diff_1d_n

!=======================================================================

subroutine mo_diff_0d_1(z, u_star, b_star, k_m, k_h)

real, intent(in)  :: z, u_star, b_star
real, intent(out) :: k_m, k_h

integer            :: ni, nj, nk, ier
real, parameter    :: ustar_min = 1.e-10
real, dimension(1,1)   :: u_star1, b_star1
real, dimension(1,1,1) :: z1, k_m1, k_h1

if(.not.module_is_initialized) call monin_obukhov_init

ni = 1; nj = 1; nk = 1
z1 = z; u_star1 = u_star; b_star1 = b_star
call monin_obukhov_diff(vonkarm,                           &
          & ustar_min,                                     &
          & neutral, stable_option, rich_crit, zeta_trans, &
          & ni, nj, nk, z1, u_star1, b_star1, k_m1, k_h1, ier)

k_m = k_m1(1,1,1); k_h = k_h1(1,1,1)

end subroutine mo_diff_0d_1

!=======================================================================

subroutine mo_diff_0d_n(z, u_star, b_star, k_m, k_h)

real, intent(in),  dimension(:) :: z
real, intent(in)                :: u_star, b_star
real, intent(out), dimension(:) :: k_m, k_h

integer            :: ni, nj, nk, ier
real, parameter    :: ustar_min = 1.e-10
real, dimension(1,1)   :: u_star1, b_star1

if(.not.module_is_initialized) call monin_obukhov_init

ni = 1; nj = 1; nk = size(z(:))
u_star1 = u_star; b_star1 = b_star
call monin_obukhov_diff(vonkarm,                           &
          & ustar_min,                                     &
          & neutral, stable_option, rich_crit, zeta_trans, &
          & ni, nj, nk, z, u_star1, b_star1, k_m, k_h, ier)

end subroutine mo_diff_0d_n

!=======================================================================

subroutine stable_mix_2d(rich, mix)

real, intent(in) , dimension(:,:)  :: rich
real, intent(out), dimension(:,:)  :: mix

real, dimension(size(rich,1),size(rich,2),1) :: rich_3d, mix_3d

rich_3d(:,:,1) = rich

call stable_mix_3d(rich_3d, mix_3d)

mix = mix_3d(:,:,1)

return
end subroutine stable_mix_2d


!=======================================================================

subroutine stable_mix_1d(rich, mix)

real, intent(in) , dimension(:)  :: rich
real, intent(out), dimension(:)  :: mix

real, dimension(size(rich),1,1) :: rich_3d, mix_3d

rich_3d(:,1,1) = rich

call stable_mix_3d(rich_3d, mix_3d)

mix = mix_3d(:,1,1)

return
end subroutine stable_mix_1d

!=======================================================================

subroutine stable_mix_0d(rich, mix)

real, intent(in) :: rich
real, intent(out) :: mix

real, dimension(1,1,1) :: rich_3d, mix_3d

rich_3d(1,1,1) = rich

call stable_mix_3d(rich_3d, mix_3d)

mix = mix_3d(1,1,1)

return
end subroutine stable_mix_0d
!=======================================================================

end module monin_obukhov_mod

module gaussian_topog_mod

! <CONTACT EMAIL="Bruce.Wyman@noaa.gov">
!   Bruce Wyman
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!   Routines for creating Gaussian-shaped land surface topography
!   for latitude-longitude grids.
! </OVERVIEW>

! <DESCRIPTION>
!   Interfaces generate simple Gaussian-shaped mountains from
!   parameters specified by either argument list or namelist input.
!   The mountain shapes are controlled by the height, half-width,
!   and ridge-width parameters.
! </DESCRIPTION>

use  fms_mod, only: file_exist, open_namelist_file,  &
                    check_nml_error, close_file,     &
                    stdlog, write_version_number,    &
                    mpp_pe, mpp_root_pe,             &
                    error_mesg, FATAL

use constants_mod, only: pi

use mpp_mod,       only: input_nml_file

implicit none
private

public :: gaussian_topog_init, get_gaussian_topog

!-----------------------------------------------------------------------
! <NAMELIST NAME="gaussian_topog_nml">
!   <DATA NAME="height" UNITS="meter" TYPE="real" DIM="(mxmtns)" DEFAULT="0.">
!     Height in meters of the Gaussian mountains.
!    </DATA>
!   <DATA NAME="olon, olat" UNITS="degree" TYPE="real" DIM="(mxmtns)" DEFAULT="0.">
!     The longitude and latitude of mountain origins (in degrees).
!    </DATA>
!   <DATA NAME="wlon, wlat" UNITS="degree" TYPE="real" DIM="(mxmtns)" DEFAULT="0.">
!     The longitude and latitude half-width of mountain tails (in degrees).
!    </DATA>
!   <DATA NAME="rlon, rlat" UNITS="degree" TYPE="real" DIM="(mxmtns)" DEFAULT="0.">
!     The longitude and latitude half-width of mountain ridges (in degrees).  For a
!     "standard" Gaussian mountain set rlon=rlat=0.
!    </DATA>
!
!    <DATA NAME="NOTE">
!     The variables in this namelist are only used when routine
!     <TT>gaussian_topog_init</TT> is called.  The namelist variables
!     are dimensioned (by 10), so that multiple mountains can be generated.
!
!     Internal parameter mxmtns = 10. By default no mountains are generated. 
!    </DATA>

   integer, parameter :: maxmts = 10

   real, dimension(maxmts) :: height = 0.
   real, dimension(maxmts) ::  olon  = 0.
   real, dimension(maxmts) ::  olat  = 0.
   real, dimension(maxmts) ::  wlon  = 0.
   real, dimension(maxmts) ::  wlat  = 0.
   real, dimension(maxmts) ::  rlon  = 0.
   real, dimension(maxmts) ::  rlat  = 0.

   namelist /gaussian_topog_nml/ height, olon, olat, wlon, wlat, rlon, rlat
! </NAMELIST>

!-----------------------------------------------------------------------

character(len=128) :: version = '$Id$'
character(len=128) :: tagname = '$Name$'

logical :: do_nml = .true.
logical :: module_is_initialized = .FALSE.

!-----------------------------------------------------------------------

contains

!#######################################################################

! <SUBROUTINE NAME="gaussian_topog_init">

!   <OVERVIEW>
!     Returns a surface height field that consists
!     of the sum of one or more Gaussian-shaped mountains.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Returns a land surface topography that consists of a "set" of
!     simple Gaussian-shaped mountains.  The height, position,
!     width, and elongation of the mountains can be controlled
!     by variables in namelist <LINK SRC="#NAMELIST">&#38;gaussian_topog_nml</LINK>.
!   </DESCRIPTION>
!   <TEMPLATE>
!     <B>call gaussian_topog_init</B> ( lon, lat, zsurf )
!   </TEMPLATE>

!   <IN NAME="lon" UNITS="radians" TYPE="real" DIM="(:)">
!     The mean grid box longitude in radians.
!   </IN>
!   <IN NAME="lat" UNITS="radians" TYPE="real" DIM="(:)">
!     The mean grid box latitude in radians.
!   </IN>
!   <OUT NAME="zsurf" UNITS="meter" TYPE="real" DIM="(:,:)">
!     The surface height (in meters).
!     The size of this field must be size(lon) by size(lat).
!   </OUT>

subroutine gaussian_topog_init ( lon, lat, zsurf )

real, intent(in)  :: lon(:), lat(:)
real, intent(out) :: zsurf(:,:)

integer :: n

  if (.not.module_is_initialized) then
     call write_version_number( version, tagname )
  endif

  if(any(shape(zsurf) /= (/size(lon(:)),size(lat(:))/))) then
    call error_mesg ('get_gaussian_topog in topography_mod', &
     'shape(zsurf) is not equal to (/size(lon),size(lat)/)', FATAL)
  endif

  if (do_nml) call read_namelist

! compute sum of all non-zero mountains
  zsurf(:,:) = 0.
  do n = 1, maxmts
    if ( height(n) == 0. ) cycle
    zsurf = zsurf + get_gaussian_topog ( lon, lat, height(n), &
                olon(n), olat(n), wlon(n), wlat(n), rlon(n), rlat(n))
  enddo
 module_is_initialized = .TRUE.                    

end subroutine gaussian_topog_init
! </SUBROUTINE>

!#######################################################################

! <FUNCTION NAME="get_gaussian_topog">

!   <OVERVIEW>
!     Returns a simple surface height field that consists of a single
!     Gaussian-shaped mountain.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Returns a single Gaussian-shaped mountain.
!     The height, position, width, and elongation of the mountain
!     is controlled by optional arguments.
!   </DESCRIPTION>
!   <TEMPLATE>
!     zsurf = <B>get_gaussian_topog</B> ( lon, lat, height
!                    [, olond, olatd, wlond, wlatd, rlond, rlatd ] )
!   </TEMPLATE>

!   <IN NAME="lon" UNITS="radians" TYPE="real" DIM="(:)">
!     The mean grid box longitude in radians.
!   </IN>
!   <IN NAME="lat" UNITS="radians" TYPE="real" DIM="(:)">
!     The mean grid box latitude in radians.
!   </IN>
!   <IN NAME="height" UNITS="meter" TYPE="real" DIM="(scalar)">
!     Maximum surface height in meters.
!   </IN>
!   <IN NAME="olond, olatd" UNITS="degrees" TYPE="real" DIM="(scalar)">
!     Position/origin of mountain in degrees longitude and latitude.
!     This is the location of the maximum height.
!   </IN>
!   <IN NAME="wlond, wlatd" UNITS="degrees" TYPE="real" DIM="(scalar)" DEFAULT="15.">
!     Gaussian half-width of mountain in degrees longitude and latitude.
!   </IN>
!   <IN NAME="rlond, rlatd" UNITS="degrees" TYPE="real" DIM="(scalar)" DEFAULT="0.">
!     Ridge half-width of mountain in degrees longitude and latitude.
!                    This is the elongation of the maximum height.
!   </IN>
!   <OUT NAME="zsurf" UNITS="meter" TYPE="real" DIM="(:,:)">
!     The surface height (in meters).
!              The size of the returned field is size(lon) by size(lat).
!   </OUT>
!   <ERROR MSG="shape(zsurf) is not equal to (/size(lon),size(lat)/)" STATUS="FATAL">
!     Check the input grid size and output field size.
!     The input grid is defined at the midpoint of grid boxes.
!   </ERROR>
!   <NOTE>
!     Mountains do not wrap around the poles.
!   </NOTE>

function get_gaussian_topog ( lon, lat, height,                          &
                              olond, olatd, wlond, wlatd, rlond, rlatd ) &
                     result ( zsurf )

real, intent(in)  :: lon(:), lat(:)
real, intent(in)  :: height
real, intent(in), optional :: olond, olatd, wlond, wlatd, rlond, rlatd
real :: zsurf(size(lon,1),size(lat,1))

integer :: i, j
real    :: olon, olat, wlon, wlat, rlon, rlat
real    :: tpi, dtr, dx, dy, xx, yy

  if (do_nml) call read_namelist

! no need to compute mountain if height=0
  if ( height == 0. ) then
       zsurf(:,:) = 0.
       return
  endif

  tpi = 2.0*pi
  dtr = tpi/360.

! defaults and convert degrees to radians (dtr)
  olon = 90.*dtr;  if (present(olond)) olon=olond*dtr
  olat = 45.*dtr;  if (present(olatd)) olat=olatd*dtr
  wlon = 15.*dtr;  if (present(wlond)) wlon=wlond*dtr
  wlat = 15.*dtr;  if (present(wlatd)) wlat=wlatd*dtr
  rlon =  0.    ;  if (present(rlond)) rlon=rlond*dtr
  rlat =  0.    ;  if (present(rlatd)) rlat=rlatd*dtr

! compute gaussian-shaped mountain
    do j=1,size(lat(:))
      dy = abs(lat(j) - olat)   ! dist from y origin
      yy = max(0., dy-rlat)/wlat
      do i=1,size(lon(:))
        dx = abs(lon(i) - olon) ! dist from x origin
        dx = min(dx, abs(dx-tpi))  ! To ensure that: -pi <= dx <= pi
        xx = max(0., dx-rlon)/wlon
        zsurf(i,j) = height*exp(-xx**2 - yy**2)
      enddo
    enddo

end function get_gaussian_topog
! </FUNCTION>

!#######################################################################

subroutine read_namelist

   integer :: unit, ierr, io
   real    :: dtr

!  read namelist

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, gaussian_topog_nml, iostat=io)
      ierr = check_nml_error(io,'gaussian_topog_nml')
#else
   if ( file_exist('input.nml')) then
      unit = open_namelist_file ( )
      ierr=1; do while (ierr /= 0)
         read  (unit, nml=gaussian_topog_nml, iostat=io, end=10)
         ierr = check_nml_error(io,'gaussian_topog_nml')
      enddo
 10   call close_file (unit)
   endif
#endif

!  write version and namelist to log file

   if (mpp_pe() == mpp_root_pe()) then
      unit = stdlog()
      write (unit, nml=gaussian_topog_nml)
   endif

   do_nml = .false.

end subroutine read_namelist

!#######################################################################

end module gaussian_topog_mod

! <INFO>
!   <NOTE>
!     NAMELIST FOR GENERATING GAUSSIAN MOUNTAINS
!
!  * multiple mountains can be generated
!  * the final mountains are the sum of all
!
!       height = height in meters
!       olon, olat = longitude,latitude origin              (degrees)
!       rlon, rlat = longitude,latitude half-width of ridge (degrees)
!       wlon, wlat = longitude,latitude half-width of tail  (degrees)
!
!       Note: For the standard gaussian mountain
!             set rlon = rlat = 0 .
!
! <PRE>
!
!       height -->   ___________________________
!                   /                           \
!                  /              |              \
!    gaussian     /               |               \
!      sides --> /                |                \
!               /               olon                \
!         _____/                olat                 \______
!
!              |    |             |
!              |<-->|<----------->|
!              |wlon|    rlon     |
!               wlat     rlat
!
! </PRE>
!
!See the <LINK SRC="topography.html#TEST PROGRAM">topography </LINK>module documentation for a test program.
!   </NOTE>
! </INFO>

#include "cosp_defs.H"
#ifdef COSP_GFDL
 
!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: cosp_stats.F90,v 20.0 2013/12/13 23:15:52 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without modification, are permitted
! provided that the following conditions are met:
!
!     * Redistributions of source code must retain the above copyright notice, this list
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used
!       to endorse or promote products derived from this software without specific prior written
!       permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

!
! History:
! Jul 2007 - A. Bodas-Salcedo - Initial version
! Jul 2008 - A. Bodas-Salcedo - Added capability of producing outputs in standard grid
! Oct 2008 - J.-L. Dufresne   - Bug fixed. Assignment of Npoints,Nlevels,Nhydro,Ncolumns in COSP_STATS
! Oct 2008 - H. Chepfer       - Added PARASOL reflectance arguments
! Jun 2010 - T. Yokohata, T. Nishimura and K. Ogochi - Added NEC SXs optimisations
!
!
!#include "cosp_defs.h" 
#ifndef COSP_GFDL
#include "cosp_defs.h" 
#endif
MODULE MOD_COSP_STATS
  USE MOD_COSP_CONSTANTS
  USE MOD_COSP_TYPES
  USE MOD_LLNL_STATS
  USE MOD_LMD_IPSL_STATS
  IMPLICIT NONE

CONTAINS

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------------- SUBROUTINE COSP_STATS ------------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_STATS(gbx,sgx,cfg,sgradar,sglidar,vgrid,stradar,stlidar)

   ! Input arguments
   type(cosp_gridbox),intent(in) :: gbx
   type(cosp_subgrid),intent(in) :: sgx
   type(cosp_config),intent(in)  :: cfg
   type(cosp_sgradar),intent(in) :: sgradar
   type(cosp_sglidar),intent(in) :: sglidar
   type(cosp_vgrid),intent(in)   :: vgrid
   ! Output arguments
   type(cosp_radarstats),intent(inout) :: stradar ! Summary statistics for radar
   type(cosp_lidarstats),intent(inout) :: stlidar ! Summary statistics for lidar

   ! Local variables
   integer :: Npoints  !# of grid points
   integer :: Nlevels  !# of levels
   integer :: Nhydro   !# of hydrometeors
   integer :: Ncolumns !# of columns
   integer :: Nlr
   logical :: ok_lidar_cfad = .false.
   real,dimension(:,:,:),allocatable :: Ze_out,betatot_out,betamol_in,betamol_out,ph_in,ph_out
   real,dimension(:,:),allocatable :: ph_c,betamol_c

   Npoints  = gbx%Npoints
   Nlevels  = gbx%Nlevels
   Nhydro   = gbx%Nhydro
   Ncolumns = gbx%Ncolumns
   Nlr      = vgrid%Nlvgrid

   if (cfg%LcfadLidarsr532) ok_lidar_cfad=.true.

   if (vgrid%use_vgrid) then ! Statistics in a different vertical grid
        allocate(Ze_out(Npoints,Ncolumns,Nlr),betatot_out(Npoints,Ncolumns,Nlr), &
                 betamol_in(Npoints,1,Nlevels),betamol_out(Npoints,1,Nlr),betamol_c(Npoints,Nlr), &
                 ph_in(Npoints,1,Nlevels),ph_out(Npoints,1,Nlr),ph_c(Npoints,Nlr))
        Ze_out = 0.0
        betatot_out  = 0.0
        betamol_out= 0.0
        betamol_c  = 0.0
        ph_in(:,1,:)  = gbx%ph(:,:)
        ph_out  = 0.0
        ph_c    = 0.0
        !++++++++++++ Radar CFAD ++++++++++++++++
        if (cfg%Lradar_sim) then
            call cosp_change_vertical_grid(Npoints,Ncolumns,Nlevels,gbx%zlev,gbx%zlev_half,sgradar%Ze_tot, &
                                           Nlr,vgrid%zl,vgrid%zu,Ze_out,log_units=.true.)
            stradar%cfad_ze = cosp_cfad(Npoints,Ncolumns,Nlr,DBZE_BINS,Ze_out, &
                                        DBZE_MIN,DBZE_MAX,CFAD_ZE_MIN,CFAD_ZE_WIDTH)
        endif
        !++++++++++++ Lidar CFAD ++++++++++++++++
        if (cfg%Llidar_sim) then
            betamol_in(:,1,:) = sglidar%beta_mol(:,:)
            call cosp_change_vertical_grid(Npoints,1,Nlevels,gbx%zlev,gbx%zlev_half,betamol_in, &
                                           Nlr,vgrid%zl,vgrid%zu,betamol_out)
            call cosp_change_vertical_grid(Npoints,Ncolumns,Nlevels,gbx%zlev,gbx%zlev_half,sglidar%beta_tot, &
                                           Nlr,vgrid%zl,vgrid%zu,betatot_out)
            call cosp_change_vertical_grid(Npoints,1,Nlevels,gbx%zlev,gbx%zlev_half,ph_in, &
                                           Nlr,vgrid%zl,vgrid%zu,ph_out)
            ph_c(:,:) = ph_out(:,1,:)
            betamol_c(:,:) = betamol_out(:,1,:)
            ! Stats from lidar_stat_summary
            call diag_lidar(Npoints,Ncolumns,Nlr,SR_BINS,PARASOL_NREFL &
                            ,betatot_out,betamol_c,sglidar%refl,gbx%land,ph_c &
                            ,LIDAR_UNDEF,ok_lidar_cfad &
                            ,stlidar%cfad_sr,stlidar%srbval &
                            ,LIDAR_NCAT,stlidar%lidarcld,stlidar%cldlayer,stlidar%parasolrefl)
        endif
        !++++++++++++ Lidar-only cloud amount and lidar&radar total cloud mount ++++++++++++++++
        if (cfg%Lradar_sim.and.cfg%Llidar_sim) call cosp_lidar_only_cloud(Npoints,Ncolumns,Nlr, &
                                    betatot_out,betamol_c,Ze_out, &
                                    stradar%lidar_only_freq_cloud,stradar%radar_lidar_tcc)
        ! Deallocate arrays at coarse resolution
        deallocate(Ze_out,betatot_out,betamol_in,betamol_out,betamol_c,ph_in,ph_out,ph_c)
   else ! Statistics in model levels
        !++++++++++++ Radar CFAD ++++++++++++++++
        if (cfg%Lradar_sim) stradar%cfad_ze = cosp_cfad(Npoints,Ncolumns,Nlr,DBZE_BINS,sgradar%Ze_tot, &
                                        DBZE_MIN,DBZE_MAX,CFAD_ZE_MIN,CFAD_ZE_WIDTH)
        !++++++++++++ Lidar CFAD ++++++++++++++++
        ! Stats from lidar_stat_summary
        if (cfg%Llidar_sim) call diag_lidar(Npoints,Ncolumns,Nlr,SR_BINS,PARASOL_NREFL &
                        ,sglidar%beta_tot,sglidar%beta_mol,sglidar%refl,gbx%land,gbx%ph &
                        ,LIDAR_UNDEF,ok_lidar_cfad &
                        ,stlidar%cfad_sr,stlidar%srbval &
                        ,LIDAR_NCAT,stlidar%lidarcld,stlidar%cldlayer,stlidar%parasolrefl)
        !++++++++++++ Lidar-only cloud amount and lidar&radar total cloud mount ++++++++++++++++
        if (cfg%Lradar_sim.and.cfg%Llidar_sim) call cosp_lidar_only_cloud(Npoints,Ncolumns,Nlr, &
                                    sglidar%beta_tot,sglidar%beta_mol,sgradar%Ze_tot, &
                                    stradar%lidar_only_freq_cloud,stradar%radar_lidar_tcc)
   endif
   ! Replace undef
   where (stlidar%cfad_sr   == LIDAR_UNDEF) stlidar%cfad_sr   = R_UNDEF
   where (stlidar%lidarcld  == LIDAR_UNDEF) stlidar%lidarcld  = R_UNDEF
   where (stlidar%cldlayer  == LIDAR_UNDEF) stlidar%cldlayer  = R_UNDEF
   where (stlidar%parasolrefl == LIDAR_UNDEF) stlidar%parasolrefl = R_UNDEF

END SUBROUTINE COSP_STATS


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!---------- SUBROUTINE COSP_CHANGE_VERTICAL_GRID ----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_CHANGE_VERTICAL_GRID(Npoints,Ncolumns,Nlevels,zfull,zhalf,y,M,zl,zu,r,log_units)
   implicit none
   ! Input arguments
   integer,intent(in) :: Npoints  !# of grid points
   integer,intent(in) :: Nlevels  !# of levels
   integer,intent(in) :: Ncolumns !# of columns
   real,dimension(Npoints,Nlevels),intent(in) :: zfull ! Height at model levels [m] (Bottom of model layer)
   real,dimension(Npoints,Nlevels),intent(in) :: zhalf ! Height at half model levels [m] (Bottom of model layer)
   real,dimension(Npoints,Ncolumns,Nlevels),intent(in) :: y     ! Variable to be changed to a different grid
   integer,intent(in) :: M  !# levels in the new grid
   real,dimension(M),intent(in) :: zl ! Lower boundary of new levels  [m]
   real,dimension(M),intent(in) :: zu ! Upper boundary of new levels  [m]
   logical,optional,intent(in) :: log_units ! log units, need to convert to linear units
   ! Output
   real,dimension(Npoints,Ncolumns,M),intent(out) :: r ! Variable on new grid

   ! Local variables
   integer :: i,j,k
   logical :: lunits
#ifdef SYS_SX
   integer :: l
   real,dimension(Npoints) :: ws,sumwyp
   real,dimension(Npoints,Nlevels) :: xl,xu
   real,dimension(Npoints,Nlevels) :: w
   real,dimension(Npoints,Ncolumns,Nlevels) :: yp
#else
   real :: ws
   real,dimension(Nlevels) :: xl,xu ! Lower and upper boundaries of model grid
   real,dimension(M) :: dz          ! Layer depth
   real,dimension(Nlevels,M) :: w   ! Weights to do the mean at each point
   real,dimension(Ncolumns,Nlevels) :: yp  ! Variable to be changed to a different grid.
                                           ! Local copy at a particular point.
                                           ! This allows for change of units.
#endif

   lunits=.false.
   if (present(log_units)) lunits=log_units

#ifdef SYS_SX
   r(:,:,:) = R_GROUND
   ! Vertical grid at that point
   xl(:,:) = zhalf(:,:)
   xu(:,1:Nlevels-1) = xl(:,2:Nlevels)
   xu(:,Nlevels) = zfull(:,Nlevels) +  zfull(:,Nlevels) - zhalf(:,Nlevels) ! Top level symmetric
   yp(:,:,:) = y(:,:,:) ! Temporary variable to regrid
   ! Check for dBZ and change if necessary
   if (lunits) then
     where (y /= R_UNDEF)
       yp = 10.0**(y/10.0)
     elsewhere
       yp = 0.0
     end where
   endif
   do k=1,M
     ! Find weights
     w(:,:) = 0.0
     do j=1,Nlevels
       do i=1,Npoints
         if ((xl(i,j) < zl(k)).and.(xu(i,j) > zl(k)).and.(xu(i,j) <= zu(k))) then
           !xl(j)-----------------xu(j)
           !      zl(k)------------------------------zu(k)
           w(i,j) = xu(i,j) - zl(k)
         else if ((xl(i,j) >= zl(k)).and.(xu(i,j) <= zu(k))) then
           !           xl(j)-----------------xu(j)
           !      zl(k)------------------------------zu(k)
           w(i,j) = xu(i,j) - xl(i,j)
         else if ((xl(i,j) >= zl(k)).and.(xl(i,j) < zu(k)).and.(xu(i,j) >= zu(k))) then
           !                           xl(j)-----------------xu(j)
           !      zl(k)------------------------------zu(k)
           w(i,j) = zu(k) - xl(i,j)
         else if ((xl(i,j) <= zl(k)).and.(xu(i,j) >= zu(k))) then
           !  xl(j)---------------------------xu(j)
           !        zl(k)--------------zu(k)
           w(i,j) = zu(k) - zl(k)
         endif
       enddo
     enddo
     ! Do the weighted mean
     do j=1,Ncolumns
       ws    (:) = 0.0
       sumwyp(:) = 0.0
       do l=1,Nlevels
         do i=1,Npoints
           if (zu(k) > zhalf(i,1)) then ! Level above model bottom level
             ws    (i) = ws    (i) + w(i,l)
             sumwyp(i) = sumwyp(i) + w(i,l)*yp(i,j,l)
           endif
         enddo
       enddo
       do i=1,Npoints
         if (zu(k) > zhalf(i,1)) then ! Level above model bottom level
           if (ws(i) > 0.0) r(i,j,k) = sumwyp(i)/ws(i)
         endif
       enddo
     enddo
   enddo
   ! Check for dBZ and change if necessary
   if (lunits) then
     do k=1,M
       do j=1,Ncolumns
         do i=1,Npoints
           if (zu(k) > zhalf(i,1)) then ! Level above model bottom level
             if (r(i,j,k) <= 0.0) then
                 r(i,j,k) = R_UNDEF
             else
                 r(i,j,k) = 10.0*log10(r(i,j,k))
             endif
           endif
         enddo
       enddo
     enddo
   endif
#else
   r = R_UNDEF
   do i=1,Npoints
     ! Vertical grid at that point
     xl = zhalf(i,:)
     xu(1:Nlevels-1) = xl(2:Nlevels)
     xu(Nlevels) = zfull(i,Nlevels) +  zfull(i,Nlevels) - zhalf(i,Nlevels) ! Top level symmetric
     dz = zu - zl
     yp = y(i,:,:) ! Temporary variable to regrid
     ! Find weights
     w = 0.0
     do k=1,M
       do j=1,Nlevels
         if ((xl(j) < zl(k)).and.(xu(j) > zl(k)).and.(xu(j) <= zu(k))) then
           !xl(j)-----------------xu(j)
           !      zl(k)------------------------------zu(k)
           w(j,k) = xu(j) - zl(k)
         else if ((xl(j) >= zl(k)).and.(xu(j) <= zu(k))) then
           !           xl(j)-----------------xu(j)
           !      zl(k)------------------------------zu(k)
           w(j,k) = xu(j) - xl(j)
         else if ((xl(j) >= zl(k)).and.(xl(j) < zu(k)).and.(xu(j) >= zu(k))) then
           !                           xl(j)-----------------xu(j)
           !      zl(k)------------------------------zu(k)
           w(j,k) = zu(k) - xl(j)
         else if ((xl(j) <= zl(k)).and.(xu(j) >= zu(k))) then
           !  xl(j)---------------------------xu(j)
           !        zl(k)--------------zu(k)
           w(j,k) = dz(j)
         endif
       enddo
     enddo
     ! Check for dBZ and change if necessary
     if (lunits) then
        where (yp /= R_UNDEF)
          yp = 10.0**(yp/10.0)
        elsewhere
          yp = 0.0
        end where
     endif
     ! Do the weighted mean
     do j=1,Ncolumns
       do k=1,M
          if (zu(k) <= zhalf(i,1)) then ! Level below model bottom level
             r(i,j,k) = R_GROUND
          else
            ws = sum(w(:,k))
            if ((ws > 0.0).and.(r(i,j,k) /= R_GROUND)) r(i,j,k) = sum(w(:,k)*yp(j,:))/ws
            ! Check for dBZ and change if necessary
            if ((lunits).and.(r(i,j,k) /= R_GROUND)) then
                if (r(i,j,k) <= 0.0) then
                    r(i,j,k) = R_UNDEF
                else
                    r(i,j,k) = 10.0*log10(r(i,j,k))
                endif
            endif
          endif
       enddo
     enddo
   enddo
#endif



END SUBROUTINE COSP_CHANGE_VERTICAL_GRID

END MODULE MOD_COSP_STATS

module atmos_tracer_driver_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   William Cooke
! </CONTACT>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Matt Harrison
! </REVIEWER>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Bruce Wyman
! </REVIEWER>


! <OVERVIEW>
!     This code allows the user to easily add tracers to the FMS framework.
! </OVERVIEW>

! <DESCRIPTION>
!
!     This code allows a user to easily implement tracer code in the FMS
!     framework.  The tracer and tracer tendency arrays are supplied along
!     with longtitude,  latitude, wind, temperature, and pressure
!     information which allows a  user to implement sources and sinks of the
!     tracer which depend on these parameters.
!
!     In the following example, radon being implemented in the atmosphere
!     will be used as an example of how to implement a tracer in the FMS
!     framework.
!
!     Within the global scope of tracer_driver_mod a use
!     statement should be inserted for each tracer to be added.
!<PRE>      use radon_mod, only : radon_sourcesink, radon_init, radon_end </PRE>
!     
!     An integer parameter, which  will be used as an identifier for the
!     tracer, should be assigned.
!<PRE>
!      integer :: nradon 
!</PRE>
!     Within tracer_driver_init a call to the tracer manager is needed in
!     order  to identify which tracer it has set the tracer as.
!<PRE>
!      nradon = get_tracer_index(MODEL_ATMOS,'radon')
!</PRE>
!     Here MODEL_ATMOS is a parameter defined in field_manager. 
!          'radon' is the name of the tracer within the field_table.
!     
!     If the tracer exists then the integer returned will be positive and it
!     can be used to call the initialization routines for the individual
!     tracers.
!<PRE>
!      if (nradon > 0) then
!           call radon_init(Argument list)
!      endif
!</PRE>     
!
!     Within tracer_driver the user can also use the identifier to surround
!     calls to the source-sink routines for the tracer of interest.
!
!<PRE>
!      if (nradon > 0 .and. nradon <= nt) then
!          call radon_sourcesink (Argument list)
!          rdt(:,:,:,nradon)=rdt(:,:,:,nradon)+rtnd(:,:,:)
!      endif
!</PRE>
!
!     It is the users responsibility to add the tendency generated by the
!     sourcesink routine.
!      
!     Within tracer_driver_end the user can add calls to the
!     terminators for the appropriate source sink routines.
!
!<PRE>      call radon_end</PRE>
!
!     This may simply be a deallocation statement or a routine to send
!     output to the logfile stating that the termination routine has been
!     called.
!
! <NOTE>
! This code has been modified by Paul.Ginoux in 2005
! to include the following aerosols:
!  - SO4 with a simplified SOx chemistry
!  - sea salt with a size distributon splitted into 5 bins
!  - mineral dust with a size distributon splitted into 5 bins
!  - carbonaceous aerosols with new emissions by Shekar.Reddy
! </NOTE>
!
! </DESCRIPTION>


!-----------------------------------------------------------------------

use mpp_mod,               only : input_nml_file 
use fms_mod,               only : file_exist, close_file,&
                                  open_namelist_file, check_nml_error, &
                                  write_version_number, &
                                  error_mesg, &
                                  FATAL, &
                                  mpp_pe, &
                                  mpp_root_pe, &
                                  stdlog, &
                                  mpp_clock_id, &
                                  mpp_clock_begin, &
                                  mpp_clock_end, &
                                  CLOCK_MODULE
use time_manager_mod,      only : time_type, &
                                  get_date, get_date_julian, &
                                  real_to_time_type
use diag_manager_mod,      only : register_diag_field, send_data
use astronomy_mod,         only : astronomy_init, diurnal_solar
use tracer_manager_mod,    only : get_tracer_index,   &
                                  get_number_tracers, &
                                  get_tracer_names,   &
                                  get_tracer_indices, &
                                  adjust_positive_def
use field_manager_mod,     only : MODEL_ATMOS
use atmos_tracer_utilities_mod, only :                     &
                                  dry_deposition,     &
                                  dry_deposition_time_vary, &
                                  dry_deposition_endts,     &
                                  atmos_tracer_utilities_init, &
                                  get_rh, get_w10m, get_cldf, &
                                  sjl_fillz
use constants_mod,         only : grav, WTMAIR
use atmos_radon_mod,       only : atmos_radon_sourcesink,   &
                                  atmos_radon_init,         &
                                  atmos_radon_end
use atmos_carbon_aerosol_mod, only : &
                                  atmos_carbon_aerosol_time_vary,  &
                                  atmos_carbon_aerosol_endts,      &
                                  atmos_carbon_aerosol_driver,  &
                                  atmos_carbon_aerosol_init,&
                                  atmos_carbon_aerosol_end
use atmos_convection_tracer_mod,only: &
                                  atmos_convection_tracer_init, &
                                  atmos_cnvct_tracer_sourcesink, &
                                  atmos_convection_tracer_end
use atmos_sulfur_hex_mod,  only : atmos_sf6_sourcesink,     &
                                  atmos_sulfur_hex_init,    &
                                  atmos_sulfur_hex_end
use atmos_ch3i_mod,        only : atmos_ch3i, &
                                  atmos_ch3i_init, &
                                  atmos_ch3i_time_vary, &
                                  atmos_ch3i_endts, &
                                  atmos_ch3i_end
use atmos_sea_salt_mod,    only : atmos_sea_salt_sourcesink,     &
                                  atmos_sea_salt_init,    &
                                  atmos_sea_salt_end
use atmos_dust_mod,        only : atmos_dust_sourcesink,     &
                                  atmos_dust_init,    &
                                  atmos_dust_time_vary,    &
                                  atmos_dust_endts,        &
                                  atmos_dust_end
use atmos_sulfate_mod,     only : atmos_sulfate_init, &
                                  atmos_sulfate_time_vary, &
                                  atmos_sulfate_endts,     &
                                  atmos_sulfate_end, &
                                  atmos_DMS_emission, &
                                  atmos_SOx_emission, &
                                  atmos_SOx_chem
use atmos_soa_mod,         only : atmos_SOA_init, &
                                  atmos_SOA_time_vary, &
                                  atmos_SOA_endts, &
                                  atmos_SOA_end, &
                                  atmos_SOA_chem
use tropchem_driver_mod,   only : tropchem_driver, &
                                  tropchem_driver_time_vary, &
                                  tropchem_driver_endts, &
                                  tropchem_driver_init
use strat_chem_driver_mod, only : strat_chem, strat_chem_driver_init
use atmos_age_tracer_mod,  only : atmos_age_tracer_init, atmos_age_tracer, &
                                  atmos_age_tracer_end
use atmos_co2_mod,         only : atmos_co2_sourcesink,   &
                                  atmos_co2_emissions,          &
                                  atmos_co2_gather_data,        &
                                  atmos_co2_flux_init,          &
                                  atmos_co2_init,               &
                                  atmos_co2_end

use interpolator_mod,      only : interpolate_type

implicit none
private
!-----------------------------------------------------------------------
!----- interfaces -------

public  atmos_tracer_driver,            &
        atmos_tracer_driver_init,       &
        atmos_tracer_driver_time_vary,       &
        atmos_tracer_driver_endts,       &
        atmos_tracer_driver_end,        &
        atmos_tracer_flux_init,         &
        atmos_tracer_driver_gather_data

!-----------------------------------------------------------------------
!----------- namelist -------------------
logical :: prevent_flux_through_ice = .false.  
                               ! when true, tracers will only be fluxed 
                               ! through the non-ice-covered portions of
                               ! ocean grid boxes
                                             

namelist /atmos_tracer_driver_nml / prevent_flux_through_ice
!-----------------------------------------------------------------------
!
!  When initializing additional tracers, the user needs to make the
!  following changes.
!
!  Add an integer variable below for each additional tracer. 
!  This should be initialized to zero. 
!
!-----------------------------------------------------------------------

! Indices for timing the various chemistry routines
integer :: radon_clock = 0
integer :: convect_clock = 0
integer :: age_tracer_clock = 0
integer :: stratozone_clock = 0
integer :: tropchem_clock = 0
integer :: carbon_clock = 0
integer :: dust_clock = 0
integer :: seasalt_clock = 0
integer :: sulfur_clock = 0
integer :: SOA_clock = 0
integer :: sf6_clock = 0
integer :: ch3i_clock = 0
integer :: co2_clock = 0

logical :: do_tropchem = .false.  ! Do tropospheric chemistry?
logical :: do_coupled_stratozone = .FALSE. !Do stratospheric chemistry?

integer, dimension(6) :: itime   ! JA's time (simpler than model time) 
integer :: nsphum  ! Specific humidity parameter

integer :: no3 = 0
integer :: no3ch = 0
integer :: nextinct = 0
integer :: naerosol = 0
integer :: nbcphobic =0
integer :: nbcphilic =0
integer :: nomphobic =0
integer :: nomphilic =0
integer :: nclay     =0
integer :: nsilt     =0
integer :: nseasalt1 =0
integer :: nseasalt2 =0
integer :: nseasalt3 =0
integer :: nseasalt4 =0
integer :: nseasalt5 =0
integer :: ndust1    =0
integer :: ndust2    =0
integer :: ndust3    =0
integer :: ndust4    =0
integer :: ndust5    =0
integer :: nsf6      =0
integer :: nDMS      =0
integer :: nSO2      =0
integer :: nSO4      =0
integer :: nMSA      =0
integer :: nSOA      =0
integer :: nH2O2     =0
integer :: nch3i     =0
integer :: nage      =0
integer :: nco2      =0
integer :: nNH4NO3   =0
integer :: nNH4      =0
integer :: nDMS_cmip =0
integer :: nSO2_cmip =0
integer :: noh       =0

real    :: ozon(11,48),cosp(14),cosphc(48),photo(132,14,11,48),   &
           solardata(1801),chlb(90,15),ozb(144,90,12),tropc(151,9),  &
           dfdage(90,48,8),anoy(90,48)


integer, dimension(:), pointer :: nradon
integer, dimension(:), pointer :: nconvect

integer :: nt     ! number of activated tracers
integer :: ntp    ! number of activated prognostic tracers

logical :: use_tau=.false.

character(len=6), parameter :: module_name = 'tracer'
character(len=7), parameter :: mod_name = 'tracers'

logical :: module_is_initialized = .FALSE.

type(interpolate_type), allocatable :: drydep_data(:)

integer, allocatable :: local_indices(:) 
! This is the array of indices for the local model. 
! local_indices(1) = 5 implies that the first local tracer is the fifth
! tracer in the tracer_manager.
  
integer :: id_landfr, id_seaicefr, id_snowfr, id_vegnfr, id_vegnlai
integer :: id_om_ddep, id_bc_ddep, id_ssalt_ddep, id_dust_ddep, &
           id_nh4_ddep_cmip
integer :: id_ssalt_emis, id_dust_emis
integer :: id_nh4no3_col, id_nh4_col
integer :: id_nh4no3_cmip, id_nh4_cmip
integer :: id_nh4no3_cmipv2, id_nh4_cmipv2
integer :: id_so2_cmip, id_dms_cmip
integer :: id_so2_cmipv2, id_dms_cmipv2

!-----------------------------------------------------------------------
type(time_type) :: Time

!---- version number -----
character(len=128) :: version = '$Id: atmos_tracer_driver.F90,v 20.0 2013/12/13 23:24:10 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
!-----------------------------------------------------------------------

contains

!#######################################################################

! <SUBROUTINE NAME="atmos_tracer_driver">
!   <OVERVIEW>
!     A routine which allows tracer code to be called.
!   </OVERVIEW>
!   <DESCRIPTION>
!     This subroutine calls the source sink routines for atmospheric
!     tracers. This is the interface between the dynamical core of the 
!     model and the tracer code. It should supply all the necessary 
!     information to a user that they need in order to calculate the 
!     tendency of that tracer with respect to emissions or chemical losses.
!
!   </DESCRIPTION>
!   <TEMPLATE>
!     call atmos_tracer_driver (is, ie, js, je, Time, lon, lat, land, phalf, pfull, r,  &
!                           u, v, t, q, u_star, rdt, rm, rdiag, kbot)
!   </TEMPLATE>
!   <IN NAME="is, ie, js, je" TYPE="integer">
!     Local domain boundaries.
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="lon" TYPE="real" DIM="(:,:)">
!     Longitude of the centre of the model gridcells
!   </IN>
!   <IN NAME="lat" TYPE="real" DIM="(:,:)">
!     Latitude of the centre of the model gridcells
!   </IN>
!   <IN NAME="land" TYPE="logical" DIM="(:,:)">
!     Land/sea mask.
!   </IN>
!   <IN NAME="phalf" TYPE="real" DIM="(:,:,:)">
!     Pressures on the model half levels.
!   </IN>
!   <IN NAME="pfull" TYPE="real" DIM="(:,:,:)">
!     Pressures on the model full levels.
!   </IN>
!   <IN NAME="r" TYPE="real" DIM="(:,:,:,:)">
!     The tracer array in the component model.
!   </IN>
!   <IN NAME="u" TYPE="real" DIM="(:,:,:)">
!     Zonal wind speed.
!   </IN>
!   <IN NAME="v" TYPE="real" DIM="(:,:,:)">
!     Meridonal wind speed.
!   </IN>
!   <IN NAME="t" TYPE="real" DIM="(:,:,:)">
!     Temperature.
!   </IN>
!   <IN NAME="q" TYPE="real" DIM="(:,:,:)">
!     Specific humidity. This may also be accessible as a
!                        portion of the tracer array.
!   </IN>
!   <IN NAME="u_star" TYPE="real" DIM="(:,:)">
!     Friction velocity :: 
!     The magnitude of the wind stress is density*(ustar**2)
!     The drag coefficient for momentum is u_star**2/(u**2+v**2)
!   </IN>
!   <INOUT NAME="rdt" TYPE="real" DIM="(:,:,:,:)">
!     The tendency of the tracer array in the compenent
!     model. The tendency due to sources and sinks computed
!     in the individual tracer routines should be added to
!     this array before exiting tracer_driver.
!   </INOUT>
!   <IN NAME="rm" TYPE="real" DIM="(:,:,:,:)">
!     The tracer array in the component model for the previous timestep.
!   </IN>
!++amf
!   <IN NAME="flux_sw_down_vis_dir" TYPE="real" DIM="(:,:)">
!     Visible direct radiation at the surface in W / m2
!   </IN>
!   <IN NAME="flux_sw_down_vis_dif" TYPE="real" DIM="(:,:)">
!     Visible diffuse radiation at the surface in W / m2
!   </IN>
!--amf
!   <INOUT NAME="rdiag" TYPE="real" DIM="(:,:,:,:)">
!     The array of diagnostic tracers. As these may be changed within the
!     tracer routines for diagnostic purposes, they need to be writable.
!   </INOUT>
!   <IN NAME="kbot" TYPE="integer, optional" DIM="(:,:)">
!     Integer array describing which model layer intercepts the surface.
!   </IN>
 subroutine atmos_tracer_driver (is, ie, js, je, Time, lon, lat,  &
                           area, z_pbl, rough_mom, &
                           frac_open_sea, &
                           land, phalf, pfull,     &
                           u, v, t, q, r,          &
                           rm, rdt, dt,            &
                           u_star, b_star, q_star, &
                           z_half, z_full,         &
                           t_surf_rad, albedo,     &
                           Time_next,              &
                           flux_sw_down_vis_dir,   &
                           flux_sw_down_vis_dif,   &
                           mask,                   &
                           kbot)

!-----------------------------------------------------------------------
integer, intent(in)                           :: is, ie, js, je
type(time_type), intent(in)                   :: Time
real, intent(in),    dimension(:,:)           :: lon, lat
real, intent(in),    dimension(:,:)           :: u_star, b_star, q_star
real, intent(in),    dimension(:,:)           :: land
real, intent(in),    dimension(:,:)           :: area, z_pbl, rough_mom
real, intent(in),    dimension(:,:)           :: frac_open_sea
real, intent(in),    dimension(:,:,:)         :: phalf, pfull
real, intent(in),    dimension(:,:,:)         :: u, v, t, q
real, intent(inout), dimension(:,:,:,:)       :: r
real, intent(inout), dimension(:,:,:,:)       :: rm
real, intent(inout), dimension(:,:,:,:)       :: rdt
real, intent(in)                              :: dt !timestep(used in chem_interface)
real, intent(in),    dimension(:,:,:)         :: z_half !height in meters at half levels
real, intent(in),    dimension(:,:,:)         :: z_full !height in meters at full levels
real, intent(in),    dimension(:,:)           :: t_surf_rad !surface temperature
real, intent(in),    dimension(:,:)           :: albedo
real, intent(in), dimension(:,:)              :: flux_sw_down_vis_dir
real, intent(in), dimension(:,:)              :: flux_sw_down_vis_dif
type(time_type), intent(in)                   :: Time_next
integer, intent(in), dimension(:,:), optional :: kbot
real, intent(in), dimension(:,:,:),  optional :: mask

!-----------------------------------------------------------------------
! Local variables
!-----------------------------------------------------------------------
real, dimension(size(r,1),size(r,2),size(r,3)) :: rtnd, pwt, ozone, o3_prod, &
                                                  aerosol, rho
real, dimension(size(r,1),size(r,2),size(r,3)) :: rtndso2, rtndso4
real, dimension(size(r,1),size(r,2),size(r,3)) :: rtnddms, rtndmsa, rtndh2o2
real, dimension(size(r,1),size(r,2),size(r,3)) :: rtndbcphob, rtndbcphil
real, dimension(size(r,1),size(r,2),size(r,3)) :: rtndomphob, rtndomphil
real, dimension(size(r,1),size(r,2),size(r,3)) :: rtndco2, rtndco2_emis
real, dimension(size(r,1),size(r,2),size(rdt,4)) :: dsinku
real, dimension(size(r,1),size(r,2)) ::  w10m_ocean, w10m_land
integer :: year,month,day,hour,minute,second
integer :: jday
real, dimension(size(rdt,1),size(rdt,2),size(rdt,3),size(rdt,4)) :: chem_tend
real, dimension(size(r,1),size(r,2))           :: coszen, fracday, half_day
real :: rrsun
real, dimension(size(r,1),size(r,2),size(r,3)) :: cldf ! cloud fraction
real, dimension(size(r,1),size(r,2),size(r,3)) :: rh  ! relative humidity
real, dimension(size(r,1),size(r,2),size(r,3)) :: lwc ! liq water content
real, dimension(size(r,1),size(r,2),size(r,3),size(r,4)) :: tracer
real, dimension(size(r,1),size(r,3)) :: dp, temp
real, dimension(size(r,1),size(r,2),5) ::  ssalt_settl, dust_settl              
real, dimension(size(r,1),size(r,2),5) ::  ssalt_emis, dust_emis                
real, dimension(size(r,1),size(r,2)) ::  all_salt_settl, all_dust_settl         
real, dimension(size(r,1),size(r,2)) ::  suma, ocn_flx_fraction
real, dimension(size(r,1),size(r,2)) ::  frland, frsnow, frsea, frice

integer :: j, k, id, jd, kd, nt
integer :: nqq  ! index of specific humidity
integer :: nql  ! index of cloud liquid specific humidity
integer :: nqi  ! index of cloud ice water specific humidity
integer :: nqa  ! index of cloud amount
integer :: n, nnn
logical :: used


!-----------------------------------------------------------------------

!   <ERROR MSG="tracer_driver_init must be called first." STATUS="FATAL">
!     Tracer_driver_init needs to be called before tracer_driver.
!   </ERROR>
      if (.not. module_is_initialized)  &
      call error_mesg ('Tracer_driver','tracer_driver_init must be called first.', FATAL)

!-----------------------------------------------------------------------
     id=size(r,1);jd=size(r,2);kd=size(r,3); nt=size(r,4)

      nqa = get_tracer_index(MODEL_ATMOS,'cld_amt')
      nqi = get_tracer_index(MODEL_ATMOS,'ice_wat')
      nql = get_tracer_index(MODEL_ATMOS,'liq_wat')
      nqq = get_tracer_index(MODEL_ATMOS,'sphum')

      ssalt_settl = 0.
      ssalt_emis = 0.
      dust_settl = 0.
      dust_emis = 0.
!------------------------------------------------------------------------
! Make local copies of all the tracers
!------------------------------------------------------------------------
!++lwh
      if (use_tau) then
        do n = 1,nt
          tracer(:,:,:,n) = r(:,:,:,n)
!------------------------------------------------------------------------
! For tracers other than specific humdity, cloud amount, ice water and &
! liquid water fill eventual negative values
!------------------------------------------------------------------------
!        does tracer need to be adjusted to remain positive definite?
!         if (n /= nqq .and. n/=nqa .and. n/=nqi .and. n/=nql) then
          if ( adjust_positive_def(MODEL_ATMOS,n) ) then
!
            do j=1,jd
              do k=1,kd
                temp(:,k) = tracer(:,j,k,n)
                dp(:,k) = phalf(:,j,k+1)-phalf(:,j,k)
              enddo
              call sjl_fillz(id,kd,1,temp,dp)
              do k=1,kd
                tracer(:,j,k,n) = temp(:,k)
              enddo
            enddo
            if (n <= ntp) then
               rdt(:,:,:,n) = rdt(:,:,:,n) + (tracer(:,:,:,n)-r(:,:,:,n))/dt
            end if
          endif
        end do
      else
        do n = 1,nt
          if (n <= ntp) then
             tracer(:,:,:,n)=rm(:,:,:,n)+rdt(:,:,:,n)*dt
          else
             tracer(:,:,:,n)=r(:,:,:,n)
          end if
!        does tracer need to be adjusted to remain positive definite?
!         if (n /= nqq .and. n/=nqa .and. n/=nqi .and. n/=nql) then
          if ( adjust_positive_def(MODEL_ATMOS,n) ) then
            do j=1,jd
              do k=1,kd
                temp(:,k) = tracer(:,j,k,n)
                dp(:,k) = phalf(:,j,k+1)-phalf(:,j,k)
              enddo
              call sjl_fillz(id,kd,1,temp,dp)
              do k=1,kd
                tracer(:,j,k,n) = temp(:,k)
              enddo
            enddo
            if (n <= ntp) then
               rdt(:,:,:,n) = (tracer(:,:,:,n) - rm(:,:,:,n)) /dt
            end if
          end if
        end do
      end if
!--lwh

!------------------------------------------------------------------------
! Rediagnose meteoroligical variables. Note these parameterizations
! are not consistent with those used elsewhere in the GCM
!------------------------------------------------------------------------

!-----------------------------------------------------------------------
!-----------Calculate relative humidity
!-----------------------------------------------------------------------
      call get_rh(t,q,pfull,rh,mask)
!-----------------------------------------------------------------------
!--------- Calculate wind speed at 10 meters
!-----------------------------------------------------------------------
      call get_w10m(z_full(:,:,kd) - z_half(:,:,kd+1), &
                    u(:,:,kd), v(:,:,kd), &
                    rough_mom, u_star, b_star, q_star, &
                    w10m_ocean, w10m_land, Time_next, is, js)
!-----------------------------------------------------------------------
!------Cloud liquid water content
!-----------------------------------------------------------------------
      if (nqi > 0) then
        lwc(:,:,:)=max(tracer(:,:,:,nqi),0.) 
      else
        lwc(:,:,:) = 0.0
      endif
      if (nql > 0) lwc(:,:,:) = lwc(:,:,:) + max(tracer(:,:,:,nql),0.) 
!-----------------------------------------------------------------------
!--------- Cloud fraction -----------------------------
!-----------------------------------------------------------------------
      if (nqa > 0 ) then
!-----  cloud fraction is a prognostic variable ------------
        cldf(:,:,:)= max(0.,min(1.,tracer(:,:,:,nqa) ))
      else
!-----   cloud fraction estimated from RH-------------
        call get_cldf(phalf(:,:,kd+1),pfull,rh,cldf)
      endif
!-----------------------------------------------------------------------
!--------- Get Julian data
!-----------------------------------------------------------------------
      call get_date_julian(Time, year, month, jday, hour, minute, second)
!-----------------------------------------------------------------------
!--------- Get current date
!-----------------------------------------------------------------------
      call get_date(Time, year, month, day, hour, minute, second)

! Calculate cosine of solar zenith angle
!
       call diurnal_solar( lat, lon, Time, coszen, fracday, &
                           rrsun, dt_time=real_to_time_type(dt), &
                           half_day_out=half_day )

!------------------------------------------------------------------------
! Get air mass in layer (in kg/m2), equal to dP/g
!------------------------------------------------------------------------
      do k=1,kd
         pwt(:,:,k)=(phalf(:,:,k+1)-phalf(:,:,k))/grav
         rho(:,:,k) = pwt(:,:,k)/(z_half(:,:,k) - z_half(:,:,k+1))
      enddo

!------------------------------------------------------------------------
!    define various land fractions needed for dry deposition calculation.
!------------------------------------------------------------------------
      frland(:,:) = min(1., max(0.,     land(:,:) ) )
      frsea(:,:)  = min(1., max(0., 1. - frland(:,:) ) )
!      frsnow(:,:) = min(frland(:,:), max(0., snow_area(:,:) ) )
      frice(:,:)  = min(frsea(:,:),   &
                               max(0., frsea(:,:) - frac_open_sea(:,:) ) ) 

!------------------------------------------------------------------------
!    output land fraction information, if desired.
!------------------------------------------------------------------------
   used = send_data ( id_landfr, frland, Time_next, is_in =is,js_in=js)
   used = send_data ( id_seaicefr, frice, Time_next, is_in =is,js_in=js)
!   used = send_data ( id_snowfr, frsnow, Time_next, is_in =is,js_in=js)
!   used = send_data ( id_vegnfr, vegn_cover, Time_next, is_in =is,js_in=js)
!   used = send_data ( id_vegnlai, vegn_lai, Time_next, is_in =is,js_in=js)

!------------------------------------------------------------------------
! For tracers other than specific humdity, cloud amount, ice water and &
! liquid water calculate flux at surface due to dry deposition
!------------------------------------------------------------------------
!++lwh
      do n=1,ntp
         if (n /= nqq .and. n/=nqa .and. n/=nqi .and. n/=nql) then
            call dry_deposition( n, is, js, u(:,:,kd), v(:,:,kd), t(:,:,kd), &
                                 pwt(:,:,kd), pfull(:,:,kd), &
                                 z_half(:,:,kd)-z_half(:,:,kd+1), u_star, &
                                 (land > 0.5), dsinku(:,:,n), &
                                 tracer(:,:,kd,n), Time, Time_next, &
                                 lon, half_day, &
                                 drydep_data(n))!, frland, frice, frsnow, &
!                                 vegn_cover, vegn_lai, &
!                                 b_star, z_pbl, rough_mom)
            rdt(:,:,kd,n) = rdt(:,:,kd,n) - dsinku(:,:,n)
         end if
      enddo

      if (id_om_ddep > 0) then
        used  = send_data (id_om_ddep,  &
         pwt(:,:,kd)*(dsinku(:,:,nomphilic) + dsinku(:,:,nomphobic)),  &
                                              Time_next, is_in=is, js_in=js)
      endif
      if (id_bc_ddep > 0) then
        used  = send_data (id_bc_ddep,  &
         pwt(:,:,kd)*(dsinku(:,:,nbcphilic) + dsinku(:,:,nbcphobic)),  &
                                               Time_next, is_in=is, js_in=js)
      endif
      if (id_nh4_ddep_cmip > 0) then
        used  = send_data (id_nh4_ddep_cmip,  &
        0.018*1.0e03*pwt(:,:,kd)*(dsinku(:,:,nNH4NO3) + dsinku(:,:,nNH4))/WTMAIR,  &
                                              Time_next, is_in=is, js_in=js)
      endif

!----------------------------------------------------------------------
!   output the nh4no3 and nh4 loads.
!----------------------------------------------------------------------
      if(id_nh4_col > 0) then
        suma = 0.
        do k=1,kd
          suma(:,:) = suma(:,:) + pwt(:,:,k)*(tracer(:,:,k,nNH4) + &
                           tracer(:,:,k,nNH4NO3))
        end do
        used  = send_data (id_nh4_col,  &
               0.018*1.0e03*suma(:,:)/WTMAIR,  &
                                              Time_next, is_in=is, js_in=js)
      endif
      if(id_nh4no3_col > 0) then
        suma = 0.
        do k=1,kd
          suma(:,:) = suma(:,:) + pwt(:,:,k)*tracer(:,:,k,nNH4NO3)
        end do
        used  = send_data (id_nh4no3_col,  &
                  0.062*1.0e03*suma(:,:)/WTMAIR,  &
                                              Time_next, is_in=is, js_in=js)
      endif

!----------------------------------------------------------------------
!   output the tracer fields needed for CMIP.
!----------------------------------------------------------------------
      if (id_nh4_cmip > 0) then
        used  = send_data (id_nh4_cmip,  &
               0.018*1.0e03* (tracer(:,:,:,nNH4NO3) + &
                              tracer(:,:,:,nNH4)) /WTMAIR,  &
                                          Time_next, is_in=is, js_in=js, ks_in=1)
      endif
      if (id_nh4_cmipv2 > 0) then
        used  = send_data (id_nh4_cmipv2,  &
               0.018*1.0e03*rho(:,:,:)* (tracer(:,:,:,nNH4NO3) + &
                              tracer(:,:,:,nNH4)) /WTMAIR,  &
                                          Time_next, is_in=is, js_in=js, ks_in=1)
      endif
      if(id_nh4no3_cmip > 0) then
        used  = send_data (id_nh4no3_cmip,  &
                0.062*1.0e03*tracer(:,:,:,nNH4NO3)/WTMAIR,  &
                                         Time_next, is_in=is, js_in=js, ks_in=1)
     endif
      if(id_nh4no3_cmipv2 > 0) then
        used  = send_data (id_nh4no3_cmipv2,  &
                0.062*1.0e03*rho(:,:,:)*tracer(:,:,:,nNH4NO3)/WTMAIR,  &
                                         Time_next, is_in=is, js_in=js, ks_in=1)
     endif
     if(id_so2_cmip > 0) then
       used  = send_data (id_so2_cmip,  &
                 0.064*1.0e03*tracer(:,:,:,nSO2_cmip)/WTMAIR,  &
                                         Time_next, is_in=is, js_in=js, ks_in=1)
     endif
     if(id_so2_cmipv2 > 0) then
       used  = send_data (id_so2_cmipv2,  &
               0.064*1.0e03*rho(:,:,:)*tracer(:,:,:,nSO2_cmip)/WTMAIR,  &
                                         Time_next, is_in=is, js_in=js, ks_in=1)
     endif
     if(id_dms_cmip > 0) then
       used  = send_data (id_dms_cmip,  &
                0.062*1.0e03*tracer(:,:,:,nDMS_cmip)/WTMAIR,  &
                                         Time_next, is_in=is, js_in=js, ks_in=1)
     endif
     if(id_dms_cmipv2 > 0) then
       used  = send_data (id_dms_cmipv2,  &
                0.062*1.0e03*rho(:,:,:)*tracer(:,:,:,nDMS_cmip)/WTMAIR,  &
                                         Time_next, is_in=is, js_in=js, ks_in=1)
     endif

!------------------------------------------------------------------------
! Compute radon source-sink tendency
!------------------------------------------------------------------------
    call mpp_clock_begin (radon_clock)
    do nnn = 1, size(nradon(:))
     if (nradon(nnn) > 0) then
       if (nradon(nnn) > nt) call error_mesg ('Tracer_driver', &
                            'Number of tracers .lt. number for radon', FATAL)
         call atmos_radon_sourcesink (lon,lat,land,pwt,tracer(:,:,:,nradon(nnn)),  &
                                 rtnd, Time, kbot)
       rdt(:,:,:,nradon(nnn))=rdt(:,:,:,nradon(nnn))+rtnd(:,:,:)
    endif
 
   end do
   call mpp_clock_end (radon_clock)

!------------------------------------------------------------------------
! Compute convection tracer source-sink tendency
!------------------------------------------------------------------------
   call mpp_clock_begin (convect_clock)
   do nnn = 1, size(nconvect(:))
     if (nconvect(nnn) > 0) then
       if (nconvect(nnn) > nt) call error_mesg ('Tracer_driver', &
           'Number of tracers .lt. number for convection tracer', FATAL)
       call atmos_cnvct_tracer_sourcesink (lon,lat,land,pwt,  &
                                       tracer(:,:,:,nconvect(nnn)),  &
                                       rtnd, Time, is, ie, js, je,kbot)
       rdt(:,:,:,nconvect(nnn))=rdt(:,:,:,nconvect(nnn))+rtnd(:,:,:)
     endif
   end do
   call mpp_clock_end (convect_clock)

!------------------------------------------------------------------------
! Stratospheric chemistry
!------------------------------------------------------------------------
  if(do_coupled_stratozone) then
    call mpp_clock_begin (stratozone_clock)
    itime(:) = 0
    call get_date(time,itime(1),itime(2),itime(3),itime(4),itime(5),itime(6))

    call strat_chem(lon,lat,r,rdt,pfull,t,itime,is,ie,js,je,dt,coszen,  &
!    ozon,cosp,cosphc,photo,solardata,chlb,ozb,dfdage,tropc,anoy,        &
    nsphum,chem_tend,ozone,o3_prod,aerosol,mpp_pe())
!
! The water vapour tendency is included here, partially coupling the 
! chemistry to the radiation
! 
      rdt(:,:,:,:) = rdt(:,:,:,:) + chem_tend(:,:,:,1:ntp) 
      if(nt.gt.(ntp+1))  then
! Modify the diagnostic tracers.
        tracer(:,:,:,no3)      = ozone(:,:,:) 
        tracer(:,:,:,no3ch)    = o3_prod(:,:,:) 
        if (naerosol > 0 ) tracer(:,:,:,naerosol) = aerosol(:,:,:) 
      endif
    call mpp_clock_end (stratozone_clock)
  endif

!-----------------------------------------------------------------------
!   define sfc area through which tracer flux from ocean is allowed; it
!   is area fraction of sea unless prevent_flux_through_ice is .true.,
!   in which case it is the fractional area of open sea.
!-----------------------------------------------------------------------
   if (prevent_flux_through_ice) then
     ocn_flx_fraction = frac_open_sea
   else
     ocn_flx_fraction = 1. - land       
   endif

!------------------------------------------------------------------------
! Tropospheric chemistry
!------------------------------------------------------------------------
   if ( do_tropchem ) then
!------------------------------------------------------------------------
! Compute age tracer source-sink tendency
!------------------------------------------------------------------------
      if (nage > 0) then
        call mpp_clock_begin (age_tracer_clock)
        if (nage > nt) call error_mesg ('Tracer_driver', &
           'Number of tracers .lt. number for age tracer', FATAL)
        call atmos_age_tracer( lon, lat, pwt,  &
                               tracer(:,:,:,nage),  &
                               rtnd, Time, kbot)
          rdt(:,:,:,nage)=rdt(:,:,:,nage)+rtnd(:,:,:)
        call mpp_clock_end (age_tracer_clock)
      endif

      call mpp_clock_begin (tropchem_clock)
      call tropchem_driver( lon, lat, land, ocn_flx_fraction, pwt, &
                            tracer(:,:,:,1:ntp),chem_tend, &
                            Time, phalf, pfull, t, is, ie, js, je, dt, &
                            z_half, z_full, q, t_surf_rad, albedo, coszen, rrsun, &
                            area, w10m_ocean, &
                            flux_sw_down_vis_dir, flux_sw_down_vis_dif, & 
                            half_day, &
                            Time_next, tracer(:,:,:,MIN(ntp+1,nt):nt), kbot)
      rdt(:,:,:,:) = rdt(:,:,:,:) + chem_tend(:,:,:,:)
      call mpp_clock_end (tropchem_clock)
   endif

!! RSH 4/8/04
!! note that if there are no diagnostic tracers, that argument in the
!! call to sourcesink should be made optional and omitted in the calls
!! below. note the switch in argument order to make this argument
!! optional.
    if (nt == ntp) then  ! implies no diagnostic tracers
!   if(do_tropchem) then
!      if(present(kbot)) then
!        call sourcesink(lon,lat,land,pwt,r+rdt*dt,chem_tend,Time,phalf,pfull,t,is,js,je,dt,&
!                          z_half, z_full,q,t_surf_rad,albedo,coszen, Time_next,&
!                          u,v,u_star,&
!                          kbot)
!      else
!       call sourcesink(lon,lat,land,pwt,r+rdt*dt,chem_tend,Time,phalf,pfull,t,is,js,je,dt, &
!                          z_half, z_full,q, t_surf_rad, albedo, coszen, Time_next, &
!                          u,v,u_star,&
!                          )
!      endif
!      rdt(:,:,:,:) = rdt(:,:,:,:) + chem_tend(:,:,:,:)
!   endif        
      else   ! case of diagnostic tracers being present
!   if(do_tropchem) then
!      if(present(kbot)) then
!        call sourcesink(lon,lat,land,pwt,r+rdt*dt,chem_tend,Time,phalf,pfull,t,is,js,je,dt,&
!                          z_half, z_full,q,t_surf_rad,albedo,coszen, Time_next,&
!                          u,v,u_star,&
!       rdiag=rm(:,:,:,nt+1:ntp),  &  ! (the diagnostic tracers)
!                   kbot=kbot)
!      else
!       call sourcesink(lon,lat,land,pwt,r+rdt*dt,chem_tend,Time,phalf,pfull,t,is,js,je,dt, &
!                          z_half, z_full,q, t_surf_rad, albedo, coszen, Time_next, &
!                          u,v,u_star,&
!        rdiag=rm(:,:,:,nt+1:ntp),  & ! (the diagnostic tracers)
!                          )
!      endif
!      rdt(:,:,:,:) = rdt(:,:,:,:) + chem_tend(:,:,:,:)
!   endif        
   endif  ! (no diagnostic tracers)

!------------------------------------------------------------------------
!   carbonaceous aerosols
!------------------------------------------------------------------------
   if (nbcphobic > 0 .and. nbcphilic > 0 .and. &
       nomphobic > 0 .and. nomphilic > 0) then
         if (nbcphobic > ntp .or. nbcphilic > ntp) &
            call error_mesg ('Tracer_driver', &
            'Number of tracers .lt. number for black carbon', FATAL)
     call mpp_clock_begin (carbon_clock)
     call atmos_carbon_aerosol_driver(lon,lat,ocn_flx_fraction, pfull,phalf,z_half,z_pbl, &
                                      t_surf_rad, w10m_ocean, &
                                      T, pwt, &
                                      tracer(:,:,:,nbcphobic), rtndbcphob, &
                                      tracer(:,:,:,nbcphilic), rtndbcphil, &
                                      tracer(:,:,:,nomphobic), rtndomphob, &
                                      tracer(:,:,:,nomphilic), rtndomphil, &
                                      tracer(:,:,:,noh),    &
                                      Time_next,is,ie,js,je)
      rdt(:,:,:,nbcphobic)=rdt(:,:,:,nbcphobic)+rtndbcphob(:,:,:)
      rdt(:,:,:,nbcphilic)=rdt(:,:,:,nbcphilic)+rtndbcphil(:,:,:)
      rdt(:,:,:,nomphobic)=rdt(:,:,:,nomphobic)+rtndomphob(:,:,:)
      rdt(:,:,:,nomphilic)=rdt(:,:,:,nomphilic)+rtndomphil(:,:,:)
      call mpp_clock_end (carbon_clock)
   endif
!------------------------------------------------------------------------
! Mineral Dust 
!------------------------------------------------------------------------
   call mpp_clock_begin (dust_clock)
   if (ndust1 > 0) then
         if (ndust1 > ntp ) call error_mesg ('Tracer_driver', &
                   'Number of tracers .lt. number for dust', FATAL)
         call atmos_dust_sourcesink (&
              1, 0.1e-6, 1.0e-6, 0.75e-6, 2500., &
              lon,lat,land,pwt, &
              z_half, pfull, w10m_land, t, rh, &
              tracer(:,:,:,ndust1), rtnd, dust_emis(:,:,1), &
              dust_settl(:,:,1), Time, Time_next, &
              is,ie,js,je, kbot)
      rdt(:,:,:,ndust1)=rdt(:,:,:,ndust1)+rtnd(:,:,:)
   endif

   if (ndust2 > 0) then
         if (ndust2 > ntp ) call error_mesg ('Tracer_driver', &
                            'Number of tracers .lt. number for dust', FATAL)
         call atmos_dust_sourcesink (&
              2, 1.e-6, 2.e-6, 1.5e-6, 2650., &
              lon,lat,land,pwt, &
              z_half, pfull, w10m_land, t, rh, &
              tracer(:,:,:,ndust2), rtnd, dust_emis(:,:,2), &
              dust_settl(:,:,2), Time, Time_next, &
              is,ie,js,je, kbot)
      rdt(:,:,:,ndust2)=rdt(:,:,:,ndust2)+rtnd(:,:,:)
   endif

   if (ndust3 > 0) then
         if (ndust3 > ntp ) call error_mesg ('Tracer_driver', &
                            'Number of tracers .lt. number for dust', FATAL)
         call atmos_dust_sourcesink (&
              3, 2.e-6, 3.e-6, 2.5e-6, 2650., &
              lon,lat,land,pwt, &
              z_half, pfull, w10m_land, t, rh, &
              tracer(:,:,:,ndust3), rtnd, dust_emis(:,:,3), &
              dust_settl(:,:,3), Time, Time_next, &
              is,ie,js,je, kbot)
      rdt(:,:,:,ndust3)=rdt(:,:,:,ndust3)+rtnd(:,:,:)
   endif

   if (ndust4 > 0) then
         if (ndust4 > ntp ) call error_mesg ('Tracer_driver', &
                            'Number of tracers .lt. number for dust', FATAL)
         call atmos_dust_sourcesink (&
              4, 3.e-6, 6.e-6, 4.5e-6, 2650., &
              lon,lat,land,pwt, &
              z_half, pfull, w10m_land, t, rh, &
              tracer(:,:,:,ndust4), rtnd, dust_emis(:,:,4), &
              dust_settl(:,:,4), Time, Time_next, &
              is,ie,js,je, kbot)
      rdt(:,:,:,ndust4)=rdt(:,:,:,ndust4)+rtnd(:,:,:)
   endif

   if (ndust5 > 0) then
         if (ndust5 > ntp ) call error_mesg ('Tracer_driver', &
                            'Number of tracers .lt. number for dust', FATAL)
         call atmos_dust_sourcesink (&
              5, 6.e-6, 10.e-6, 8.e-6, 2650., &
              lon,lat,land,pwt, &
              z_half, pfull, w10m_land, t, rh, &
              tracer(:,:,:,ndust5), rtnd, dust_emis(:,:,5), &
              dust_settl(:,:,5), Time, Time_next, &
              is,ie,js,je, kbot)
      rdt(:,:,:,ndust5)=rdt(:,:,:,ndust5)+rtnd(:,:,:)
   endif
   if (id_dust_ddep > 0) then
     all_dust_settl(:,:) = dust_settl(:,:,1) +  &
                dust_settl(:,:,2) +  dust_settl(:,:,3) +  &
                dust_settl(:,:,4) +  dust_settl(:,:,5)
     used  = send_data (id_dust_ddep,  all_dust_settl(:,:) + &
        pwt(:,:,kd)*(dsinku(:,:,ndust1) + dsinku(:,:,ndust2) + &
                     dsinku(:,:,ndust3) + dsinku(:,:,ndust4) + &
                      dsinku(:,:,ndust5)), Time_next, is_in=is, js_in=js)
   endif
   if (id_dust_emis > 0) then
     used  = send_data (id_dust_emis,  &
                 dust_emis(:,:,1) + dust_emis(:,:,2) + &
                 dust_emis(:,:,3) + dust_emis(:,:,4) + &
                 dust_emis(:,:,5), Time_next, is_in=is, js_in=js)
   endif
   call mpp_clock_end (dust_clock)

!------------------------------------------------------------------------
!sea salt
!------------------------------------------------------------------------
   call mpp_clock_begin (seasalt_clock)
   if (nseasalt1 > 0) then
         if (nseasalt1 > ntp ) call error_mesg ('Tracer_driver', &
                            'Number of tracers .lt. number for sea salt', FATAL)
         rtnd(:,:,:) = 0.
         call atmos_sea_salt_sourcesink ( &
              1, 0.1e-6,0.5e-6,0.3e-6, 2200., &
              lon,lat,ocn_flx_fraction,pwt, &
              z_half, pfull, w10m_ocean, t, rh, &
              tracer(:,:,:,nseasalt1), rtnd, dt, &
               ssalt_settl(:,:,1), ssalt_emis(:,:,1), &
              Time,Time_next,is,ie,js,je, kbot)
      rdt(:,:,:,nseasalt1)=rdt(:,:,:,nseasalt1)+rtnd(:,:,:)
   endif
   if (nseasalt2 > 0) then
         if (nseasalt2 > ntp ) call error_mesg ('Tracer_driver', &
                            'Number of tracers .lt. number for sea salt', FATAL)
         rtnd(:,:,:) = 0.
         call atmos_sea_salt_sourcesink ( &
              2, 0.5e-6,1.0e-6,0.75e-6, 2200., &
              lon,lat,ocn_flx_fraction,pwt, &
              z_half, pfull, w10m_ocean, t, rh, &
              tracer(:,:,:,nseasalt2), rtnd, dt, &
               ssalt_settl(:,:,2), ssalt_emis(:,:,2), &
              Time,Time_next,is,ie,js,je, kbot)
      rdt(:,:,:,nseasalt2)=rdt(:,:,:,nseasalt2)+rtnd(:,:,:)
   endif
   if (nseasalt3 > 0) then
         if (nseasalt3 > ntp ) call error_mesg ('Tracer_driver', &
                            'Number of tracers .lt. number for sea salt', FATAL)
         rtnd(:,:,:) = 0.
         call atmos_sea_salt_sourcesink ( &
              3, 1.e-6,2.5e-6,1.75e-6, 2200., &
              lon,lat,ocn_flx_fraction,pwt, &
              z_half, pfull, w10m_ocean, t, rh, &
              tracer(:,:,:,nseasalt3), rtnd, dt, &
               ssalt_settl(:,:,3), ssalt_emis(:,:,3), &
              Time,Time_next,is,ie,js,je, kbot)
      rdt(:,:,:,nseasalt3)=rdt(:,:,:,nseasalt3)+rtnd(:,:,:)
   endif
   if (nseasalt4 > 0) then
         if (nseasalt4 > ntp ) call error_mesg ('Tracer_driver', &
                            'Number of tracers .lt. number for sea salt', FATAL)
         rtnd(:,:,:) = 0.
         call atmos_sea_salt_sourcesink ( &
              4, 2.5e-6,5.0e-6,3.75e-6, 2200., &
              lon,lat,ocn_flx_fraction,pwt, &
              z_half, pfull, w10m_ocean, t, rh, &
              tracer(:,:,:,nseasalt4), rtnd, dt, &
               ssalt_settl(:,:,4), ssalt_emis(:,:,4), &
              Time,Time_next,is,ie,js,je, kbot)
      rdt(:,:,:,nseasalt4)=rdt(:,:,:,nseasalt4)+rtnd(:,:,:)
   endif
   if (nseasalt5 > 0) then
         if (nseasalt5 > ntp ) call error_mesg ('Tracer_driver', &
                            'Number of tracers .lt. number for sea salt', FATAL)
         rtnd(:,:,:) = 0.
         call atmos_sea_salt_sourcesink ( &
              5, 5.e-6,10.0e-6,7.5e-6, 2200., &
              lon,lat,ocn_flx_fraction,pwt, &
              z_half, pfull, w10m_ocean, t, rh, &
              tracer(:,:,:,nseasalt5), rtnd, dt, &
               ssalt_settl(:,:,5), ssalt_emis(:,:,5), &
              Time,Time_next,is,ie,js,je, kbot)
      rdt(:,:,:,nseasalt5)=rdt(:,:,:,nseasalt5)+rtnd(:,:,:)
   endif
   if (id_ssalt_ddep > 0) then
     all_salt_settl(:,:) = ssalt_settl(:,:,1) + ssalt_settl(:,:,2) +  &
                         ssalt_settl(:,:,3) + ssalt_settl(:,:,4) + &
                         ssalt_settl(:,:,5)
     used  = send_data (id_ssalt_ddep, all_salt_settl(:,:) + &
         pwt(:,:,kd)*(dsinku(:,:,nseasalt1) + dsinku(:,:,nseasalt2) + &
                      dsinku(:,:,nseasalt3) + dsinku(:,:,nseasalt4) + &
                      dsinku(:,:,nseasalt5)), Time_next, is_in=is, js_in=js)
   endif
   if (id_ssalt_emis > 0) then
     used  = send_data (id_ssalt_emis,  &
                    ssalt_emis(:,:,1) + ssalt_emis(:,:,2) + &
                    ssalt_emis(:,:,3) + ssalt_emis(:,:,4) + &
                    ssalt_emis(:,:,5), Time_next, is_in=is, js_in=js)
   endif
   call mpp_clock_end (seasalt_clock)

!------------------------------------------------------------------------
! Sulfur chemistry
!------------------------------------------------------------------------
   if (nDMS > 0 .and. nSO2 > 0 .and. nSO4 > 0 .and. nMSA > 0 ) then
      if (nDMS > ntp ) call error_mesg ('Tracer_driver', &
                     'Number of tracers .lt. number for DMS', FATAL)
      if (nSO2 > ntp ) call error_mesg ('Tracer_driver', &
                     'Number of tracers .lt. number for SO2', FATAL)
      if (nSO4 > ntp ) call error_mesg ('Tracer_driver', &
                     'Number of tracers .lt. number for SO4', FATAL)

      call mpp_clock_begin (sulfur_clock)
      call atmos_DMS_emission(lon, lat, area, ocn_flx_fraction, t_surf_rad, &
             w10m_ocean, pwt, rtnddms, Time, Time_next, is,ie,js,je,kbot)
      rdt(:,:,kd,nDMS) = rdt(:,:,kd,nDMS) + rtnddms(:,:,kd)
      call atmos_SOx_emission(lon, lat, area, land, &
             z_pbl, z_half, phalf, pwt, rtndso2, rtndso4, &
             Time, Time_next, is,ie,js,je,kbot)
      rdt(:,:,:,nSO2) = rdt(:,:,:,nSO2) + rtndso2(:,:,:)
      rdt(:,:,:,nSO4) = rdt(:,:,:,nSO4) + rtndso4(:,:,:)
      call atmos_SOx_chem( pwt, t, pfull, phalf, dt, lwc, &
                jday,hour,minute,second,lat,lon,    &
                tracer(:,:,:,nSO2), tracer(:,:,:,nSO4), tracer(:,:,:,nDMS), &
                tracer(:,:,:,nMSA), tracer(:,:,:,nH2O2), &
                tracer(:,:,:,noh), &
                rtndso2, rtndso4, rtnddms, rtndmsa, rtndh2o2, &
                Time,Time_next, is,ie,js,je,kbot)
      rdt(:,:,:,nSO2) = rdt(:,:,:,nSO2) + rtndso2(:,:,:)
      rdt(:,:,:,nSO4) = rdt(:,:,:,nSO4) + rtndso4(:,:,:)
      rdt(:,:,:,nDMS) = rdt(:,:,:,nDMS) + rtnddms(:,:,:)
      rdt(:,:,:,nMSA) = rdt(:,:,:,nMSA) + rtndmsa(:,:,:)
      rdt(:,:,:,nH2O2) = rdt(:,:,:,nH2O2) + rtndh2o2(:,:,:)
      call mpp_clock_end (sulfur_clock)
   endif

!------------------------------------------------------------------------
! Secondary organic aerosols
!------------------------------------------------------------------------
   if (nSOA > 0 ) then
      if (nSOA > ntp ) call error_mesg ('Tracer_driver', &
                     'Number of tracers .lt. number for SOA', FATAL)

      call mpp_clock_begin (SOA_clock)
      call atmos_SOA_chem(pwt,t,pfull,phalf,dt, &
                jday,hour,minute,second,lat,lon,    &
                tracer(:,:,:,nSOA),rtnd, Time,Time_next,is,ie,js,je,kbot )

      rdt(:,:,:,nSOA)=rdt(:,:,:,nSOA)+rtnd(:,:,:)
      call mpp_clock_end (SOA_clock)

   endif

!------------------------------------------------------------------------
! Sulfur hexafluoride (SF6)
!------------------------------------------------------------------------
   if (nsf6 > 0) then
         if (nsf6 > ntp ) call error_mesg ('Tracer_driver', &
                            'Number of tracers .lt. number for sulfur hexafluoride', FATAL)
         call mpp_clock_begin (sf6_clock)
         call atmos_sf6_sourcesink (lon,lat,land,pwt,r(:,:,:,nsf6),  &
                                 rtnd, Time,is,ie,js,je, kbot)
      rdt(:,:,:,nsf6)=rdt(:,:,:,nsf6)+rtnd(:,:,:)
         call mpp_clock_end (sf6_clock)
   endif

   if (nch3i > 0) then
         if (nch3i > ntp ) call error_mesg ('Tracer_driver', &
                            'Number of tracers < number for ch3i', FATAL)
         call mpp_clock_begin (ch3i_clock)
         call atmos_ch3i( lon, lat, land, pwt, &
                          r(:,:,:,nch3i)+dt*rdt(:,:,:,nch3i), rtnd,  &
                          Time, phalf, pfull, t, is, js, dt, &
                          z_half, z_full,q, t_surf_rad, albedo, coszen, &
                          Time_next, kbot)
         rdt(:,:,:,nch3i) = rdt(:,:,:,nch3i) + rtnd(:,:,:)
         call mpp_clock_end (ch3i_clock)
   endif

!------------------------------------------------------------------------
! Compute CO2 source-sink tendency:  tracer(:,:,:,nco2) is in moist mmr
!  atmos_co2_sourcesink will convert to dry vmr and return rtnd as moist mmr
!------------------------------------------------------------------------
   if (nco2 > 0 ) then
         if (nco2 > ntp ) call error_mesg ('Tracer_driver', &
                            'Number of tracers < number for co2', FATAL)
         call mpp_clock_begin (co2_clock)
         call atmos_co2_emissions (is, ie, js, je, Time, Time_next, dt, pwt, tracer(:,:,:,nco2),     &
                                   tracer(:,:,:,nsphum), rtndco2_emis, kbot)
         rdt(:,:,:,nco2)=rdt(:,:,:,nco2)+rtndco2_emis(:,:,:)

         call atmos_co2_sourcesink (is, ie, js, je, Time, Time_next, dt, pwt, tracer(:,:,:,nco2),     &
                                    tracer(:,:,:,nsphum), rtndco2)
         rdt(:,:,:,nco2)=rdt(:,:,:,nco2)+rtndco2(:,:,:)
         call mpp_clock_end (co2_clock)
   endif

!------------------------------------------------------------------------
! Save diagnostic tracer concentrations back to tracer array
!------------------------------------------------------------------------
   if (nt > ntp) then
      r(:,:,:,ntp+1:nt) = tracer(:,:,:,ntp+1:nt)
   end if

 end subroutine atmos_tracer_driver
! </SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="atmos_tracer_driver_init">
!   <OVERVIEW>
!     Subroutine to initialize the tracer driver module.
!   </OVERVIEW>
!   <DESCRIPTION>
!   The purpose of the arguments here are for passing on to the individual
!   tracer code. The user may wish to provide initial values which can be
!   implemented in the initialization part of the tracer code. Remember that
!   the tracer manager will provide a simple fixed or exponential profile if
!   the user provides data for this within the field table. However if a more
!   complicated profile is required then it should be set up in the
!   initialization section of the user tracer code.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call atmos_tracer_driver_init (lonb,latb, r, mask, axes, Time)
!   </TEMPLATE>
!   <IN NAME="lonb" TYPE="real" DIM="(:,:)">
!     The longitude corners for the local domain.
!   </IN>
!   <IN NAME="latb" TYPE="real" DIM="(:,:)">
!     The latitude corners for the local domain.
!   </IN>
!   <IN NAME="mask" TYPE="real, optional" DIM="(:,:,:)">
!      optional mask (0. or 1.) that designates which grid points
!           are above (=1.) or below (=0.) the ground dimensioned as
!           (nlon,nlat,nlev).
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="axes" TYPE="integer" DIM="(4)">
!     The axes relating to the tracer array dimensioned as
!      (nlon, nlat, nlev, ntime)
!   </IN>
!   <INOUT NAME="r" TYPE="real" DIM="(:,:,:,:)">
!     Tracer fields dimensioned as (nlon,nlat,nlev,ntrace). 
!   </INOUT>
 subroutine atmos_tracer_driver_init (lonb, latb, r, axes, Time, phalf, mask)

!-----------------------------------------------------------------------
           real, intent(in),    dimension(:,:)             :: lonb, latb
           real, intent(inout), dimension(:,:,:,:)         :: r
type(time_type), intent(in)                                :: Time
        integer, intent(in)                                :: axes(4)
           real, intent(in),    dimension(:,:,:)           :: phalf
           real, intent(in),    dimension(:,:,:), optional :: mask

!-----------------------------------------------------------------------
! Local variables
!-----------------------------------------------------------------------
      integer :: nbr_layers
      integer :: unit, ierr, io, logunit
  
!-----------------------------------------------------------------------
!
!  When initializing additional tracers, the user needs to make changes 
!
!-----------------------------------------------------------------------

      if (module_is_initialized) return

!------------------------------------------------------------------------
!   read namelist.
!------------------------------------------------------------------------
      if ( file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
        read (input_nml_file, nml=atmos_tracer_driver_nml, iostat=io)
        ierr = check_nml_error(io,'atmos_tracer_driver_nml')
#else
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=atmos_tracer_driver_nml, iostat=io, end=10)
        ierr = check_nml_error(io, 'atmos_tracer_driver_nml')
        end do
10      call close_file (unit)
#endif
      endif
!--------- write version and namelist to standard log ------------
      call write_version_number(version, tagname)
      logunit=stdlog()
      if ( mpp_pe() == mpp_root_pe() ) &
                         write ( logunit, nml=atmos_tracer_driver_nml )

!---------------------------------------------------------------------
!  make sure that astronomy_mod has been initialized (if radiation
!  not being called in this run, it will not have previously been 
!  initialized).
!---------------------------------------------------------------------
      call astronomy_init

!If we wish to automatically register diagnostics for wet and dry 
! deposition, do it now.
      call atmos_tracer_utilities_init(lonb, latb, axes, Time)

!----- set initial value of radon ------------

      call atmos_radon_init(r, axes, Time, nradon, mask)
      radon_clock = mpp_clock_id( 'Tracer: Radon', &
           grain=CLOCK_MODULE )

!----- initialize the convection tracer ------------

      call atmos_convection_tracer_init(r, phalf, axes, Time, &
                                        nconvect,  mask)
      convect_clock = mpp_clock_id( 'Tracer: Convection tracer', &
           grain=CLOCK_MODULE )

!----- initialize the age tracer ------------

      call atmos_age_tracer_init( r, axes, Time, nage, lonb, latb, phalf, mask)
      age_tracer_clock = mpp_clock_id( 'Tracer: Age tracer', grain=CLOCK_MODULE )

      call get_number_tracers (MODEL_ATMOS, num_tracers=nt, &
                               num_prog=ntp)


!------------------------------------------------------------------------
! Initialize stratospheric chemistry
!------------------------------------------------------------------------
      nsphum   = get_tracer_index(MODEL_ATMOS,'sphum')
      no3      = get_tracer_index(MODEL_ATMOS,'O3')
      no3ch    = get_tracer_index(MODEL_ATMOS,'O3_chem')
      nextinct = get_tracer_index(MODEL_ATMOS,'Extinction')
      naerosol = get_tracer_index(MODEL_ATMOS,'Aerosol')
!
!  Set up photolysis rates etc.
!
      do_coupled_stratozone = strat_chem_driver_init()
      stratozone_clock = mpp_clock_id( 'Tracer: Stratospheric Ozone', &
           grain=CLOCK_MODULE )
         

!------------------------------------------------------------------------
! Initialize tropospheric chemistry
!------------------------------------------------------------------------
      allocate( drydep_data(nt) )
      do_tropchem = tropchem_driver_init(r,mask,axes,Time,lonb,latb,phalf,drydep_data)
      tropchem_clock = mpp_clock_id( 'Tracer: Tropospheric chemistry', &
           grain=CLOCK_MODULE )

! ----------Interactive traceres--------------------
! If any of the interactive tracers are activated, get the 
! tracer number and initialize it.
!      ntraceer= get_tracer_index(MODEL_ATMOS,'tracer_name')
!      if (ntracer > 0) then
!        call {tracer}_init(lonb, latb, r, axes, Time, mask)
!      endif


!    get tracer indices
      nbcphobic = get_tracer_index(MODEL_ATMOS,'bcphob')
      nbcphilic = get_tracer_index(MODEL_ATMOS,'bcphil')
      nomphobic = get_tracer_index(MODEL_ATMOS,'omphob')
      nomphilic = get_tracer_index(MODEL_ATMOS,'omphil')
      ndust1    = get_tracer_index(MODEL_ATMOS,'dust1')
      ndust2    = get_tracer_index(MODEL_ATMOS,'dust2')
      ndust3    = get_tracer_index(MODEL_ATMOS,'dust3')
      ndust4    = get_tracer_index(MODEL_ATMOS,'dust4')
      ndust5    = get_tracer_index(MODEL_ATMOS,'dust5')
      nseasalt1 = get_tracer_index(MODEL_ATMOS,'ssalt1')
      nseasalt2 = get_tracer_index(MODEL_ATMOS,'ssalt2')
      nseasalt3 = get_tracer_index(MODEL_ATMOS,'ssalt3')
      nseasalt4 = get_tracer_index(MODEL_ATMOS,'ssalt4')
      nseasalt5 = get_tracer_index(MODEL_ATMOS,'ssalt5')
      nDMS      = get_tracer_index(MODEL_ATMOS,'simpleDMS')
      nSO2      = get_tracer_index(MODEL_ATMOS,'simpleSO2')
      nSO4      = get_tracer_index(MODEL_ATMOS,'simpleSO4')
      nMSA      = get_tracer_index(MODEL_ATMOS,'simpleMSA')
      nH2O2     = get_tracer_index(MODEL_ATMOS,'simpleH2O2')
      nnH4NO3   = get_tracer_index(MODEL_ATMOS,'nh4no3')
      nnH4      = get_tracer_index(MODEL_ATMOS,'nh4')
      nSOA      = get_tracer_index(MODEL_ATMOS,'SOA')
      nsf6      = get_tracer_index(MODEL_ATMOS,'sf6')
      nch3i     = get_tracer_index(MODEL_ATMOS,'ch3i')
      nco2      = get_tracer_index(MODEL_ATMOS,'co2')
      nDMS_cmip = get_tracer_index(MODEL_ATMOS,'DMS')
      nSO2_cmip = get_tracer_index(MODEL_ATMOS,'so2')
      noh       = get_tracer_index(MODEL_ATMOS,'oh')

! Number of vertical layers
      nbr_layers=size(r,3)

! initialize the tracers
!carbonaceous aerosols
      if (nbcphobic > 0 .or. nbcphilic >0 .or.  &
          nomphobic > 0 .or. nomphilic >0 ) then
        call atmos_carbon_aerosol_init(lonb, latb, axes, Time, mask)
        carbon_clock = mpp_clock_id( 'Tracer: Carbonaceous aerosol', &
                       grain=CLOCK_MODULE )

      endif
!dust aerosols
      if (ndust1 > 0.or.ndust2 > 0.or.ndust3 > 0 &
        .or.ndust4 > 0.or.ndust5 > 0 ) then
        call atmos_dust_init (lonb, latb, axes, Time, mask)
        dust_clock = mpp_clock_id( 'Tracer: Dust aerosol', &
                     grain=CLOCK_MODULE )
      endif
!sea salt
      if (nseasalt1 > 0.or.nseasalt2 > 0.or.nseasalt3 > 0 &
        .or.nseasalt4 > 0.or.nseasalt5 > 0 ) then
        call atmos_sea_salt_init (lonb, latb, axes, Time, mask)
        seasalt_clock = mpp_clock_id( 'Tracer: Seasalt aerosol', &
                        grain=CLOCK_MODULE )
      endif
!sulfur cycle
      if (nDMS > 0 .or. nSO2 > 0 .or. nSO4 > 0 &
                   .or. nMSA > 0 .or. nH2O2 > 0 ) then
        call atmos_sulfate_init ( lonb, latb, nbr_layers, axes, Time, mask)
        sulfur_clock = mpp_clock_id( 'Tracer: Sulfur', &
                       grain=CLOCK_MODULE )
      endif
!SOA
      if ( nSOA > 0 ) then
        call atmos_SOA_init ( lonb, latb, nbr_layers, axes, Time, mask)
        SOA_clock = mpp_clock_id( 'Tracer: SOA', &
                    grain=CLOCK_MODULE )
      endif
!sf6
      if (nsf6 > 0) then
        call atmos_sulfur_hex_init (lonb, latb, r, axes, Time, mask)
        sf6_clock = mpp_clock_id( 'Tracer: SF6', &
                    grain=CLOCK_MODULE )
      endif
!ch3i
      if (nch3i > 0) then
        call atmos_ch3i_init (lonb, latb, axes, Time, mask)
        ch3i_clock = mpp_clock_id( 'Tracer: CH3I', &
                     grain=CLOCK_MODULE )
      endif

!co2
      if (nco2 > 0) then
      call atmos_co2_init ( Time, axes(1:3))
        co2_clock = mpp_clock_id( 'Tracer: CO2', &
                    grain=CLOCK_MODULE )
      endif

      call get_number_tracers (MODEL_ATMOS, num_tracers=nt, &
                               num_prog=ntp)

     id_landfr = register_diag_field ( mod_name,                    &
            'landfr_atm', axes(1:2), Time,               &
            'land fraction',                                 &
            'fraction', missing_value=-999.     )
     id_seaicefr = register_diag_field ( mod_name,                    &
            'seaicefr_atm', axes(1:2), Time,               &
            'seaice fraction',                                 &
            'fraction', missing_value=-999.     )
     id_snowfr = register_diag_field ( mod_name,                    &
            'snowfr_atm', axes(1:2), Time,               &
            'snow cover fraction',                                 &
            'fraction', missing_value=-999.     )
     id_vegnfr = register_diag_field ( mod_name,                    &
            'vegnfr_atm', axes(1:2), Time,               &
            'vegetation cover fraction',                                 &
            'fraction', missing_value=-999.     )
     id_vegnlai = register_diag_field ( mod_name,                    &
            'vegnlai_atm', axes(1:2), Time,               &
            'vegetation leaf area index',                                &
            'fraction', missing_value=-999.     )

      id_om_ddep = register_diag_field (mod_name, &
          'om_ddep', axes(1:2), Time, &
          'total dry deposition of om', 'kg/m2/s')

      id_bc_ddep = register_diag_field (mod_name, &
          'bc_ddep', axes(1:2), Time, &
          'total dry deposition of bc', 'kg/m2/s')

      id_ssalt_ddep = register_diag_field (mod_name, &
          'ssalt_ddep', axes(1:2), Time, &
          'dry deposition and settling of seasalt', 'kg/m2/s')

      id_ssalt_emis = register_diag_field (mod_name, &
          'ssalt_emis', axes(1:2), Time, &
          'total emission of seasalt', 'kg/m2/s')

      id_dust_ddep = register_diag_field (mod_name, &
          'dust_ddep', axes(1:2), Time, &
          'dry deposition and settling of dust', 'kg/m2/s')

      id_dust_emis = register_diag_field (mod_name, &
          'dust_emis', axes(1:2), Time, &
          'total emission of dust', 'kg/m2/s')

      id_nh4_ddep_cmip = register_diag_field (mod_name, &
          'tot_nh4_ddep_cmip', axes(1:2), Time, &
          'total dry deposition of ammonium', 'kg/m2/s')

      id_nh4no3_col = register_diag_field (mod_name, &
          'tot_no3_col', axes(1:2), Time, &
          'total aerosol load of nitrate', 'kg/m2')

      id_nh4_col  = register_diag_field (mod_name, &
          'tot_nh4_col', axes(1:2), Time, &
          'total aerosol load of ammonium', 'kg/m2')

      id_nh4no3_cmip = register_diag_field (mod_name, &
          'tot_no3', axes(1:3), Time, &
          'total nitrate', 'kg/m3')

      id_nh4_cmip  = register_diag_field (mod_name, &
          'tot_nh4', axes(1:3), Time, &
          'total ammonium', 'kg/m3')

      id_nh4no3_cmipv2 = register_diag_field (mod_name, &
          'tot_no3v2', axes(1:3), Time, &
          'total nitrate', 'kg/m3')

      id_nh4_cmipv2  = register_diag_field (mod_name, &
          'tot_nh4v2', axes(1:3), Time, &
          'total ammonium', 'kg/m3')

      id_so2_cmip  = register_diag_field (mod_name, &
          'so2_cmip', axes(1:3), Time, &
          'SO2', 'kg/m3')

      id_dms_cmip  = register_diag_field (mod_name, &
          'dms_cmip', axes(1:3), Time, &
          'DMS', 'kg/m3')

      id_so2_cmipv2  = register_diag_field (mod_name, &
          'so2_cmipv2', axes(1:3), Time, &
          'SO2', 'kg/m3')

      id_dms_cmipv2  = register_diag_field (mod_name, &
          'dms_cmipv2', axes(1:3), Time, &
          'DMS', 'kg/m3')

      module_is_initialized = .TRUE.

 end subroutine atmos_tracer_driver_init



!#####################################################################

subroutine atmos_tracer_driver_time_vary (Time)

type(time_type), intent(in) :: Time

      if (nbcphobic > 0 .and. nbcphilic > 0 .and. &
          nomphobic > 0 .and. nomphilic > 0) then
        call atmos_carbon_aerosol_time_vary (Time)
      endif

      if (nch3i > 0) then
        call atmos_ch3i_time_vary (Time)
      endif

      if (ndust1 > 0.or.ndust2 > 0.or.ndust3 > 0 &
          .or.ndust4 > 0.or.ndust5 > 0 ) then
        call atmos_dust_time_vary (Time)
      endif

      if (nSOA > 0 ) then
        call atmos_SOA_time_vary (Time)
      endif

      if (nDMS > 0 .or. nSO2 > 0 .or. nSO4 > 0 &
                   .or. nMSA > 0 .or. nH2O2 > 0 ) then
        call atmos_sulfate_time_vary (Time)
      endif

      call dry_deposition_time_vary (drydep_data, Time)

      if (do_tropchem) then
        call tropchem_driver_time_vary (Time)
      endif



end subroutine atmos_tracer_driver_time_vary




!#####################################################################

subroutine atmos_tracer_driver_endts

      if (do_tropchem) then
        call tropchem_driver_endts
      endif
      if (nbcphobic > 0 .and. nbcphilic > 0 .and. &
          nomphobic > 0 .and. nomphilic > 0) then
        call atmos_carbon_aerosol_endts
      endif
      if (nch3i > 0) then
        call atmos_ch3i_endts
      endif
      if (ndust1 > 0.or.ndust2 > 0.or.ndust3 > 0 &
          .or.ndust4 > 0.or.ndust5 > 0 ) then
        call atmos_dust_endts
      endif
      if (nSOA > 0 ) then
        call atmos_soa_endts
      endif
      if (nDMS > 0 .or. nSO2 > 0 .or. nSO4 > 0 &
                   .or. nMSA > 0 .or. nH2O2 > 0 ) then
        call atmos_sulfate_endts
      endif
      call dry_deposition_endts (drydep_data)

end subroutine atmos_tracer_driver_endts




!#####################################################################


! </SUBROUTINE>

!#######################################################################

! <SUBROUTINE NAME="atmos_tracer_driver_end">
!   <OVERVIEW>
!     Subroutine to terminate the tracer driver module.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Termination routine for tracer_driver. It should also call
!     the destructors for the individual tracer routines.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call atmos_tracer_driver_end
!   </TEMPLATE>
 subroutine atmos_tracer_driver_end

!-----------------------------------------------------------------------
integer :: logunit
      if (mpp_pe() /= mpp_root_pe()) return

      logunit=stdlog()
      write (logunit,'(/,(a))') 'Exiting tracer_driver, have a nice day ...'

      call atmos_radon_end
      call atmos_sulfur_hex_end
      call atmos_convection_tracer_end
      call atmos_dust_end     
      call atmos_sea_salt_end 
      call atmos_sulfate_end
      call atmos_SOA_end      
      call atmos_carbon_aerosol_end
      if (nch3i > 0) then
        call atmos_ch3i_end
      endif
      call atmos_age_tracer_end      
      call atmos_co2_end

      module_is_initialized = .FALSE.

!-----------------------------------------------------------------------

 end subroutine atmos_tracer_driver_end
! </SUBROUTINE>

!#######################################################################
! <SUBROUTINE NAME="atmos_tracer_flux_init">
!   <OVERVIEW>
!     Subroutine to initialize the ocean-atmosphere gas flux modules
!   </OVERVIEW>
!   <DESCRIPTION>
!     Subroutine to initialize the ocean-atmosphere gas flux modules
!   </DESCRIPTION>

subroutine atmos_tracer_flux_init

call atmos_co2_flux_init

return

end subroutine atmos_tracer_flux_init
! </SUBROUTINE>

!######################################################################
! <SUBROUTINE NAME="atmos_tracer_driver_gather_data">
!   <OVERVIEW>
!     Subroutine to terminate the tracer driver module.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Termination routine for tracer_driver. It should also call
!     the destructors for the individual tracer routines.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call atmos_tracer_driver_gather_data
!   </TEMPLATE>
 subroutine atmos_tracer_driver_gather_data(gas_fields, tr_bot)

use coupler_types_mod, only: coupler_2d_bc_type

type(coupler_2d_bc_type), intent(inout) :: gas_fields
real, dimension(:,:,:), intent(in)      :: tr_bot

!-----------------------------------------------------------------------

  call atmos_co2_gather_data(gas_fields, tr_bot)

!-----------------------------------------------------------------------

 end subroutine atmos_tracer_driver_gather_data
! </SUBROUTINE>

!######################################################################


end module atmos_tracer_driver_mod

module bgrid_conserve_energy_mod

!------------------------------------------------------------------
!  Enforces energy conservation by computing a correction term
!------------------------------------------------------------------
! This module computes a correction to the temperature tendency to
! conserve the globally-averaged total energy, TE = cp*T + KE.
! The assumption is made that the input tendencies are only
! due to the dynamical core.
!
! The global average of TE is weighted by pressure and area,
! and therefore the time rate of change of pressure must also be
! considered. The correction is applied as a global constant value.
!
! Diagnostics fields that are available (through the diag_manager)
! have few spatial patterns because of the uniform global correction.
!------------------------------------------------------------------

use       bgrid_horiz_mod, only: horiz_grid_type, update_np, VELGRID => VGRID
use        bgrid_vert_mod, only: vert_grid_type, compute_pres_depth
use       bgrid_masks_mod, only: grid_mask_type
use    bgrid_prog_var_mod, only: prog_var_type
use bgrid_change_grid_mod, only: change_grid, TEMP_GRID, WIND_GRID

use      time_manager_mod, only: time_type
use      diag_manager_mod, only: register_diag_field, send_data
use               fms_mod, only: error_mesg, FATAL, stdlog, &
                                 write_version_number,      &
                                 mpp_pe, mpp_root_pe,       &
                                 mpp_clock_id,              &
                                 mpp_clock_begin,           &
                                 mpp_clock_end,             &
                                 MPP_CLOCK_SYNC, CLOCK_MODULE
use         constants_mod, only: CP_AIR, GRAV
use       mpp_domains_mod, only: mpp_global_sum, BITWISE_EXACT_SUM

 implicit none
 private

 public :: bgrid_conserve_energy_init, bgrid_conserve_energy, &
           bgrid_conserve_energy_end

!------------------------------------------------------------------
! private module data
 character(len=128) :: version = '$Id: bgrid_conserve_energy.F90,v 19.0 2012/01/06 19:53:25 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'

! saves the total correction for the entire run
 real :: total_correction

! for diagnostics
 character(len=8) :: mod_name = 'dynamics'
 integer :: id_tdt_diss, id_diss_heat

 integer :: id_clock
 logical :: do_init = .true.

contains
!################################################################

 subroutine bgrid_conserve_energy ( dt, Time, Hgrid, Vgrid, Masks, &
                                    Var, Var_dt )
 real,                  intent(in)    :: dt
 type      (time_type), intent(in)    :: Time
 type(horiz_grid_type), intent(in)    :: Hgrid
 type (vert_grid_type), intent(in)    :: Vgrid
 type (grid_mask_type), intent(in)    :: Masks
 type  (prog_var_type), intent(in)    :: Var
 type  (prog_var_type), intent(inout) :: Var_dt

 real, dimension(Hgrid%ilb:Hgrid%iub, &
                 Hgrid%jlb:Hgrid%jub, Vgrid%nlev) :: tcor, vcor, pwt, dpde, dpde_vel, &
                                                     dpde_old, dpde_old_vel
 real, dimension(Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub) :: diss_heat, pssl_new
 real    :: sum_tcor, sum_vcor, sum_pwt, correction
 integer :: j, k
 logical :: used

    if (do_init) call error_mesg ('bgrid_conserve_energy', &
                                  'initializtion not called', FATAL)
    call mpp_clock_begin (id_clock)

  ! compute mass weights (at tau and tau+1)
    pssl_new = Var%pssl + dt*Var_dt%pssl
    call compute_pres_depth ( Vgrid, Var%pssl, dpde_old )
    call compute_pres_depth ( Vgrid, pssl_new, dpde     )
    call change_grid ( Hgrid, TEMP_GRID, WIND_GRID, dpde_old,     dpde,    &
                                                    dpde_old_vel, dpde_vel )

  ! compute local correction terms
  ! also need to take into account time rate of change of pressure
    vcor =  ((Var%u+.5*dt*Var_dt%u)*Var_dt%u + &
             (Var%v+.5*dt*Var_dt%v)*Var_dt%v) * dpde_vel + &
            0.5*(Var%u**2+Var%v**2)*(dpde_vel-dpde_old_vel)/dt
    tcor = Var_dt%t*dpde + Var%t*(dpde-dpde_old)/dt
    do k = 1, Vgrid%nlev
    do j = Hgrid%jlb, Hgrid%jub
      vcor(:,j,k) = Hgrid%Vel%area(j) * vcor (:,j,k)
      tcor(:,j,k) = Hgrid%Tmp%area(j) * tcor (:,j,k)
      pwt (:,j,k) = Hgrid%Tmp%area(j) * dpde (:,j,k)
    enddo
    enddo

  ! compute bit-reproducible global sums
  ! pass only data domain for velocity grid
    sum_vcor = mpp_global_sum ( Hgrid%Vel%Domain, vcor(:,Hgrid%Vel%jsd:Hgrid%Vel%jed,:), &
                                                        flags=BITWISE_EXACT_SUM )
    sum_tcor = mpp_global_sum ( Hgrid%Tmp%Domain, tcor, flags=BITWISE_EXACT_SUM )
    sum_pwt  = mpp_global_sum ( Hgrid%Tmp%Domain, pwt,  flags=BITWISE_EXACT_SUM )

  ! global correction
    correction = -( sum_tcor + sum_vcor/CP_AIR ) / sum_pwt

  ! add on tendency
    Var_dt%t = Var_dt%t + correction
  ! save total correction (as a potential diagnostic)
    total_correction = total_correction + correction

  !------ diagnostics section ------

    if ( id_tdt_diss > 0 .or. id_diss_heat > 0 ) then
         tcor = correction
         if (.not.Masks%sigma) tcor = tcor*Masks%Tmp%mask ! zero-out below surface
    endif

    if ( id_tdt_diss > 0 ) then
     ! this will be a very boring 3d diagnostic
       used = send_data ( id_tdt_diss, tcor(Hgrid%Tmp%is:Hgrid%Tmp%ie,Hgrid%Tmp%js:Hgrid%Tmp%je,:), &
        Time, mask=Masks%Tmp%mask(Hgrid%Tmp%is:Hgrid%Tmp%ie,Hgrid%Tmp%js:Hgrid%Tmp%je,:) > 0.5 )
    endif

    if ( id_diss_heat > 0 ) then
      ! vertical integral of ke dissipation
        diss_heat = CP_AIR/GRAV * sum( tcor*dpde, 3 ) 
        used = send_data ( id_diss_heat, &
                           diss_heat(Hgrid%Tmp%is:Hgrid%Tmp%ie,Hgrid%Tmp%js:Hgrid%Tmp%je), Time )
    endif

    call mpp_clock_end (id_clock)

 end subroutine bgrid_conserve_energy

!################################################################

 subroutine bgrid_conserve_energy_init ( Time, axes )
 type(time_type), intent(in) :: Time
 integer,         intent(in) :: axes(3)

   call write_version_number(version, tagname)

   id_clock = mpp_clock_id ('BGRID: conserve_energy', &
                  flags=MPP_CLOCK_SYNC, grain=CLOCK_MODULE)

! initialize diagnostics related to the energy conservation

   id_tdt_diss = register_diag_field ( mod_name, 'tdt_diss_dynam', axes(1:3), Time, &       
                           'Dissipative heating from dynamical core', & 
                                 'deg_k/s', missing_value=-1.e10   )
       
   id_diss_heat = register_diag_field &
        ( mod_name, 'diss_heat_dynam', axes(1:2), Time,      &
         'Integrated dissipative heating for dynamical core', & 
         'W/m2' )

   total_correction = 0.

   do_init = .false.

 end subroutine bgrid_conserve_energy_init

!################################################################

 subroutine bgrid_conserve_energy_end

 integer :: logunit 
 ! rewrite module name and version info to log file
   call write_version_number(version, tagname)
 ! write diagnostic to log file
   logunit = stdlog()
   if (mpp_pe() == mpp_root_pe()) write (logunit,*)  &
    'Total dissipative heating from dynamical core (deg/s) = ', total_correction

 end subroutine bgrid_conserve_energy_end

!################################################################

end module bgrid_conserve_energy_mod

module fm_util_mod  !{
! 
!<CONTACT EMAIL="Richard.Slater@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="John.Dunne@noaa.gov"> John P. Dunne
!</REVIEWER>
!
!<OVERVIEW>
! Utility routines for the field manager
!</OVERVIEW>
!
!<DESCRIPTION>
! This module provides utility routines for the field manager.
! Basically, it provides for error catching, reporting and
! termination while interfacing with the field manager.
!</DESCRIPTION>
!
! <INFO>
! </INFO>
!

use field_manager_mod, only: fm_string_len, fm_path_name_len, fm_field_name_len, fm_type_name_len
use field_manager_mod, only: fm_get_type, fm_get_index, fm_get_length
use field_manager_mod, only: fm_get_current_list, fm_new_list, fm_change_list, fm_loop_over_list
use field_manager_mod, only: fm_new_value, fm_get_value
use field_manager_mod, only: fm_exists, fm_dump_list
use fms_mod,           only: FATAL, stdout
use mpp_mod,           only: mpp_error

implicit none

private

public  fm_util_start_namelist
public  fm_util_end_namelist
public  fm_util_check_for_bad_fields
public  fm_util_set_caller
public  fm_util_reset_caller
public  fm_util_set_no_overwrite
public  fm_util_reset_no_overwrite
public  fm_util_set_good_name_list
public  fm_util_reset_good_name_list
public  fm_util_get_length
public  fm_util_get_integer
public  fm_util_get_logical
public  fm_util_get_real
public  fm_util_get_string
public  fm_util_get_integer_array
public  fm_util_get_logical_array
public  fm_util_get_real_array
public  fm_util_get_string_array
public  fm_util_set_value
public  fm_util_set_value_integer_array
public  fm_util_set_value_logical_array
public  fm_util_set_value_real_array
public  fm_util_set_value_string_array
public  fm_util_set_value_integer
public  fm_util_set_value_logical
public  fm_util_set_value_real
public  fm_util_set_value_string
!public  fm_util_get_index
public  fm_util_get_index_list
public  fm_util_get_index_string

!
!       Public variables
!

character(len=128), public      :: fm_util_default_caller = ' '

!
!       private parameters
!

character(len=48), parameter    :: mod_name = 'fm_util_mod'

!
!       Private variables
!

character(len=128)              :: save_default_caller = ' '
character(len=128)              :: default_good_name_list = ' '
character(len=128)              :: save_default_good_name_list = ' '
logical                         :: default_no_overwrite = .false.
logical                         :: save_default_no_overwrite = .false.
character(len=fm_path_name_len) :: save_current_list
character(len=fm_path_name_len) :: save_path
character(len=fm_path_name_len) :: save_name
character(len=128) :: version = '$Id$'
character(len=128) :: tagname = '$Name$'

!
!        Interface definitions for overloaded routines
!

!interface  fm_util_get_value  !{
  !module procedure  fm_util_get_value_integer
  !module procedure  fm_util_get_value_logical
  !module procedure  fm_util_get_value_real
  !module procedure  fm_util_get_value_string
  !module procedure  fm_util_get_value_integer_array
  !module procedure  fm_util_get_value_logical_array
  !module procedure  fm_util_get_value_real_array
  !module procedure  fm_util_get_value_string_array
!end interface  !}

interface  fm_util_set_value  !{
  module procedure  fm_util_set_value_integer_array
  module procedure  fm_util_set_value_logical_array
  module procedure  fm_util_set_value_real_array
  module procedure  fm_util_set_value_string_array
  module procedure  fm_util_set_value_integer
  module procedure  fm_util_set_value_logical
  module procedure  fm_util_set_value_real
  module procedure  fm_util_set_value_string
end interface  !}

!interface  fm_util_get_index  !{
  !module procedure  fm_util_get_index_list
  !module procedure  fm_util_get_index_string
!end interface  !}


contains


!#######################################################################
! <SUBROUTINE NAME="fm_util_set_caller">
!
! <DESCRIPTION>
! Set the default value for the optional "caller" variable used in many of these
! subroutines. If the argument is blank, then set the default to blank, otherwise
! the deault will have brackets placed around the argument.
!
! </DESCRIPTION>
!

subroutine fm_util_set_caller(caller)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)          :: caller

!
!       Local variables
!

!
!       save the default caller string
!

save_default_caller = fm_util_default_caller

!
!       set the default caller string
!

if (caller .eq. ' ') then  !{
  fm_util_default_caller = ' '
else  !}{
  fm_util_default_caller = '[' // trim(caller) // ']'
endif  !}

return

end subroutine fm_util_set_caller  !}
! </SUBROUTINE> NAME="fm_util_set_caller"


!#######################################################################
! <SUBROUTINE NAME="fm_util_reset_caller">
!
! <DESCRIPTION>
! Reset the default value for the optional "caller" variable used in many of these
! subroutines to blank.
!
! </DESCRIPTION>
!

subroutine fm_util_reset_caller  !{

implicit none

!
!       arguments
!

!
!       Local variables
!

!
!       reset the default caller string
!

fm_util_default_caller = save_default_caller
save_default_caller = ' '

return

end subroutine fm_util_reset_caller  !}
! </SUBROUTINE> NAME="fm_util_reset_caller"


!#######################################################################
! <SUBROUTINE NAME="fm_util_set_good_name_list">
!
! <DESCRIPTION>
! Set the default value for the optional "good_name_list" variable used in many of these
! subroutines.
!
! </DESCRIPTION>
!

subroutine fm_util_set_good_name_list(good_name_list)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)          :: good_name_list

!
!       Local variables
!

!
!       save the default good_name_list string
!

save_default_good_name_list = default_good_name_list

!
!       set the default good_name_list string
!

default_good_name_list = good_name_list

return

end subroutine fm_util_set_good_name_list  !}
! </SUBROUTINE> NAME="fm_util_set_good_name_list"


!#######################################################################
! <SUBROUTINE NAME="fm_util_reset_good_name_list">
!
! <DESCRIPTION>
! Reset the default value for the optional "good_name_list" variable used in many of these
! subroutines to the saved value.
!
! </DESCRIPTION>
!

subroutine fm_util_reset_good_name_list  !{

implicit none

!
!       arguments
!

!
!       Local variables
!

!
!       reset the default good_name_list string
!

default_good_name_list = save_default_good_name_list
save_default_good_name_list = ' '

return

end subroutine fm_util_reset_good_name_list  !}
! </SUBROUTINE> NAME="fm_util_reset_good_name_list"


!#######################################################################
! <SUBROUTINE NAME="fm_util_set_no_overwrite">
!
! <DESCRIPTION>
! Set the default value for the optional "no_overwrite" variable used in some of these
! subroutines.
!
! </DESCRIPTION>
!

subroutine fm_util_set_no_overwrite(no_overwrite)  !{

implicit none

!
!       arguments
!

logical, intent(in)          :: no_overwrite

!
!       Local variables
!

!
!       save the default no_overwrite string
!

save_default_no_overwrite = default_no_overwrite

!
!       set the default no_overwrite value
!

default_no_overwrite = no_overwrite

return

end subroutine fm_util_set_no_overwrite  !}
! </SUBROUTINE> NAME="fm_util_set_no_overwrite"


!#######################################################################
! <SUBROUTINE NAME="fm_util_reset_no_overwrite">
!
! <DESCRIPTION>
! Reset the default value for the optional "no_overwrite" variable used in some of these
! subroutines to false.
!
! </DESCRIPTION>
!

subroutine fm_util_reset_no_overwrite  !{

implicit none

!
!       arguments
!

!
!       Local variables
!

!
!       reset the default no_overwrite value
!

default_no_overwrite = save_default_no_overwrite
save_default_no_overwrite = .false.

return

end subroutine fm_util_reset_no_overwrite  !}
! </SUBROUTINE> NAME="fm_util_reset_no_overwrite"


!#######################################################################
! <SUBROUTINE NAME="fm_util_check_for_bad_fields">
!
! <DESCRIPTION>
! Check for unrecognized fields in a list
!
! </DESCRIPTION>
!

subroutine fm_util_check_for_bad_fields(list, good_fields, caller)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)                    :: list
character(len=*), intent(in), dimension(:)      :: good_fields
character(len=*), intent(in), optional          :: caller

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'fm_util_check_for_bad_fields'

!
!       Local variables
!

logical                                 :: fm_success
integer                                 :: i
integer                                 :: ind
integer                                 :: list_length
integer                                 :: good_length
character(len=fm_type_name_len)         :: typ
character(len=fm_field_name_len)        :: name
logical                                 :: found
character(len=256)                      :: error_header
character(len=256)                      :: warn_header
character(len=256)                      :: note_header
character(len=128)                      :: caller_str
integer                         :: out_unit

out_unit = stdout()

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a list is given (fatal if not)
!

if (list .eq. ' ') then  !{
  write (out_unit,*) trim(error_header) // ' Empty list given'
  call mpp_error(FATAL, trim(error_header) // ' Empty list given')
endif  !}

!
!       Check that we have been given a list
!

if (fm_get_type(list) .ne. 'list') then  !{
  write (out_unit,*) trim(error_header) // ' Not given a list: ' // trim(list)
  call mpp_error(FATAL, trim(error_header) // ' Not given a list: ' // trim(list))
endif  !}

!
!       Get the list length
!

list_length = fm_get_length(list)
if (list_length .lt. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(list))
endif  !}

!
!       Get the number of good fields
!

good_length = size(good_fields)

if (list_length .lt. good_length) then  !{

!
!       If the list length is less than the number of good fields this is an error 
!       as the list should be fully populated and we'll check which extra fields
!       are given in good_fields
!

  write (out_unit,*) trim(error_header), ' List length < number of good fields (',       &
       list_length, ' < ', good_length, ') in list ', trim(list)

  write (out_unit,*)
  write (out_unit,*) 'The list contains the following fields:'
  fm_success= fm_dump_list(list, .false.)
  write (out_unit,*)
  write (out_unit,*) 'The supposed list of good fields is:'
  do i = 1, good_length  !{
    if (fm_exists(trim(list) // '/' // good_fields(i))) then  !{
      write (out_unit,*) 'List field: "', trim(good_fields(i)), '"'
    else  !}{
      write (out_unit,*) 'EXTRA good field: "', trim(good_fields(i)), '"'
    endif  !}
  enddo  !} i
  write (out_unit,*)

  call mpp_error(FATAL, trim(error_header) //                                           &
       ' List length < number of good fields for list: ' // trim(list))

elseif (list_length .gt. good_length) then  !}{

!
!       If the list length is greater than the number of good fields this is an error
!       as the there should not be any more fields than those given in the good fields list
!       and we'll check which extra fields are given in the list
!

  write (out_unit,*) trim(warn_header), 'List length > number of good fields (',        &
       list_length, ' > ', good_length, ') in list ', trim(list)

  write (out_unit,*) trim(error_header), ' Start of list of fields'
  do while (fm_loop_over_list(list, name, typ, ind))  !{
    found = .false.
    do i = 1, good_length  !{
      found = found .or. (name .eq. good_fields(i))
    enddo  !} i
    if (found) then  !{
      write (out_unit,*) 'Good list field: "', trim(name), '"'
    else  !}{
      write (out_unit,*) 'EXTRA list field: "', trim(name), '"'
    endif  !}
  enddo  !}
  write (out_unit,*) trim(error_header), ' End of list of fields'

  call mpp_error(FATAL, trim(error_header) //                                           &
       ' List length > number of good fields for list: ' // trim(list))

endif  !}

!
!       If the list length equals the number of good fields then all is good
!

return

end subroutine fm_util_check_for_bad_fields  !}
! </SUBROUTINE> NAME="fm_util_check_for_bad_fields"


!#######################################################################
! <FUNCTION NAME="fm_util_get_length">
!
! <DESCRIPTION>
! Get the length of an element of the Field Manager tree
! </DESCRIPTION>
!
function fm_util_get_length(name, caller)       &
         result (field_length)  !{

implicit none

!
!       Return type
!

integer :: field_length

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in), optional  :: caller

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'fm_util_get_length'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       Get the field's length
!

field_length = fm_get_length(name)
if (field_length .lt. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
endif  !}

return

end function fm_util_get_length  !}
! </FUNCTION> NAME="fm_util_get_length"


!#######################################################################
! <FUNCTION NAME="fm_util_get_index_string">
!
! <DESCRIPTION>
! Get the index of an element of a string in the Field Manager tree
! </DESCRIPTION>
!
function fm_util_get_index_string(name, string, caller)       &
         result (fm_index)  !{

implicit none

!
!       Return type
!

integer :: fm_index

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in)            :: string
character(len=*), intent(in), optional  :: caller

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'fm_util_get_index_string'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
character(len=32)               :: index_str
character(len=fm_type_name_len) :: fm_type
character(len=fm_string_len)    :: fm_string
integer                         :: i
integer                         :: length

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       Check the field's type and get the index
!

fm_index = 0
fm_type = fm_get_type(name)
if (fm_type .eq. 'string') then  !{
  length = fm_get_length(name)
  if (length .lt. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
  endif  !}
  if (length .gt. 0) then  !{
    do i = 1, length  !{
      if (.not. fm_get_value(name, fm_string, index = i)) then  !{
        write (index_str,*) '(', i, ')'
        call mpp_error(FATAL, trim(error_header) // ' Problem getting ' // trim(name) // trim(index_str))
      endif  !}
      if (fm_string .eq. string) then  !{
        fm_index = i
        exit
      endif  !}
    enddo  !} i
  endif  !}
elseif (fm_type .eq. ' ') then  !}{
  call mpp_error(FATAL, trim(error_header) // ' Array does not exist: ' // trim(name))
else  !}{
 call mpp_error(FATAL, trim(error_header) // ' Wrong type for ' // trim(name) // ', found (' // trim(fm_type) // ')')
endif  !}

!if (fm_index .eq. 0) then  !{
  !call mpp_error(FATAL, trim(error_header) // ' "' // trim(string) // '" does not exist in ' // trim(name))
!endif  !}

return

end function fm_util_get_index_string  !}
! </FUNCTION> NAME="fm_util_get_index_string"


!#######################################################################
! <FUNCTION NAME="fm_util_get_index_list">
!
! <DESCRIPTION>
! Get the length of an element of the Field Manager tree
! </DESCRIPTION>
!
function fm_util_get_index_list(name, caller)       &
         result (fm_index)  !{

implicit none

!
!       Return type
!

integer :: fm_index

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in), optional  :: caller

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'fm_util_get_index_list'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
character(len=fm_type_name_len) :: fm_type

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       Check the field's type and get the index
!

fm_index = 0
fm_type = fm_get_type(name)
if (fm_type .eq. 'list') then  !{
  fm_index = fm_get_index(name)
  if (fm_index .le. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' List does not exist: ' // trim(name))
  endif  !}
elseif (fm_type .eq. ' ') then  !}{
  call mpp_error(FATAL, trim(error_header) // ' List does not exist: ' // trim(name))
else  !}{
 call mpp_error(FATAL, trim(error_header) // ' Wrong type for ' // trim(name) // ', found (' // trim(fm_type) // ')')
endif  !}


return

end function fm_util_get_index_list  !}
! </FUNCTION> NAME="fm_util_get_index_list"


!#######################################################################
! <FUNCTION NAME="fm_util_get_integer_array">
!
! <DESCRIPTION>
! Get an integer value from the Field Manager tree.
! </DESCRIPTION>
!
function fm_util_get_integer_array(name, caller)            &
         result (array)  !{

implicit none

!
!       Return type
!

integer, pointer, dimension(:) :: array

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in), optional  :: caller

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'fm_util_get_integer_array'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
character(len=32)               :: index_str
character(len=fm_type_name_len) :: fm_type
integer                         :: i
integer                         :: length

nullify(array)

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

fm_type = fm_get_type(name)
if (fm_type .eq. 'integer') then  !{
  length = fm_get_length(name)
  if (length .lt. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
  endif  !}
  if (length .gt. 0) then  !{
    allocate(array(length))
    do i = 1, length  !{
      if (.not. fm_get_value(name, array(i), index = i)) then  !{
        write (index_str,*) '(', i, ')'
        call mpp_error(FATAL, trim(error_header) // ' Problem getting ' // trim(name) // trim(index_str))
      endif  !}
    enddo  !} i
  endif  !}
elseif (fm_type .eq. ' ') then  !}{
  call mpp_error(FATAL, trim(error_header) // ' Array does not exist: ' // trim(name))
else  !}{
 call mpp_error(FATAL, trim(error_header) // ' Wrong type for ' // trim(name) // ', found (' // trim(fm_type) // ')')
endif  !}

return

end function fm_util_get_integer_array  !}
! </FUNCTION> NAME="fm_util_get_integer_array"


!#######################################################################
! <FUNCTION NAME="fm_util_get_logical_array">
!
! <DESCRIPTION>
! Get a logical value from the Field Manager tree.
! </DESCRIPTION>
!
function fm_util_get_logical_array(name, caller)            &
         result (array)  !{

implicit none

!
!       Return type
!

logical, pointer, dimension(:) :: array

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in), optional  :: caller

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'fm_util_get_logical_array'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
character(len=32)               :: index_str
character(len=fm_type_name_len) :: fm_type
integer                         :: i
integer                         :: length

nullify(array)

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

fm_type = fm_get_type(name)
if (fm_type .eq. 'logical') then  !{
  length = fm_get_length(name)
  if (length .lt. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
  endif  !}
  if (length .gt. 0) then  !{
    allocate(array(length))
    do i = 1, length  !{
      if (.not. fm_get_value(name, array(i), index = i)) then  !{
        write (index_str,*) '(', i, ')'
        call mpp_error(FATAL, trim(error_header) // ' Problem getting ' // trim(name) // trim(index_str))
      endif  !}
    enddo  !} i
  endif  !}
elseif (fm_type .eq. ' ') then  !}{
  call mpp_error(FATAL, trim(error_header) // ' Array does not exist: ' // trim(name))
else  !}{
 call mpp_error(FATAL, trim(error_header) // ' Wrong type for ' // trim(name) // ', found (' // trim(fm_type) // ')')
endif  !}

return

end function fm_util_get_logical_array  !}
! </FUNCTION> NAME="fm_util_get_logical_array"


!#######################################################################
! <FUNCTION NAME="fm_util_get_real_array">
!
! <DESCRIPTION>
! Get a real value from the Field Manager tree.
! </DESCRIPTION>
!
function fm_util_get_real_array(name, caller)            &
         result (array)  !{

implicit none

!
!       Return type
!

real, pointer, dimension(:) :: array

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in), optional  :: caller

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'fm_util_get_real_array'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
character(len=32)               :: index_str
character(len=fm_type_name_len) :: fm_type
integer                         :: i
integer                         :: length

nullify(array)

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

fm_type = fm_get_type(name)
if (fm_type .eq. 'real') then  !{
  length = fm_get_length(name)
  if (length .lt. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
  endif  !}
  if (length .gt. 0) then  !{
    allocate(array(length))
    do i = 1, length  !{
      if (.not. fm_get_value(name, array(i), index = i)) then  !{
        write (index_str,*) '(', i, ')'
        call mpp_error(FATAL, trim(error_header) // ' Problem getting ' // trim(name) // trim(index_str))
      endif  !}
    enddo  !} i
  endif  !}
elseif (fm_type .eq. ' ') then  !}{
  call mpp_error(FATAL, trim(error_header) // ' Array does not exist: ' // trim(name))
else  !}{
 call mpp_error(FATAL, trim(error_header) // ' Wrong type for ' // trim(name) // ', found (' // trim(fm_type) // ')')
endif  !}

return

end function fm_util_get_real_array  !}
! </FUNCTION> NAME="fm_util_get_real_array"


!#######################################################################
! <FUNCTION NAME="fm_util_get_string_array">
!
! <DESCRIPTION>
! Get a string value from the Field Manager tree.
! </DESCRIPTION>
!
function fm_util_get_string_array(name, caller)            &
         result (array)  !{

implicit none

!
!       Return type
!

character(len=fm_string_len), pointer, dimension(:) :: array

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in), optional  :: caller

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'fm_util_get_string_array'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
character(len=32)               :: index_str
character(len=fm_type_name_len) :: fm_type
integer                         :: i
integer                         :: length

nullify(array)

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

fm_type = fm_get_type(name)
if (fm_type .eq. 'string') then  !{
  length = fm_get_length(name)
  if (length .lt. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
  endif  !}
  if (length .gt. 0) then  !{
    allocate(array(length))
    do i = 1, length  !{
      if (.not. fm_get_value(name, array(i), index = i)) then  !{
        write (index_str,*) '(', i, ')'
        call mpp_error(FATAL, trim(error_header) // ' Problem getting ' // trim(name) // trim(index_str))
      endif  !}
    enddo  !} i
  endif  !}
elseif (fm_type .eq. ' ') then  !}{
  call mpp_error(FATAL, trim(error_header) // ' Array does not exist: ' // trim(name))
else  !}{
 call mpp_error(FATAL, trim(error_header) // ' Wrong type for ' // trim(name) // ', found (' // trim(fm_type) // ')')
endif  !}

return

end function fm_util_get_string_array  !}
! </FUNCTION> NAME="fm_util_get_string_array"


!#######################################################################
! <FUNCTION NAME="fm_util_get_integer">
!
! <DESCRIPTION>
! Get an integer value from the Field Manager tree.
! </DESCRIPTION>
!
function fm_util_get_integer(name, caller, index, default_value, scalar)            &
         result (value)  !{

implicit none

!
!       Return type
!

integer :: value

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in), optional  :: caller
integer, intent(in), optional           :: index
integer, intent(in), optional           :: default_value
logical, intent(in), optional           :: scalar

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'fm_util_get_integer'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
integer                         :: index_t
character(len=fm_type_name_len) :: fm_type
integer                         :: field_length

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       Check whether we require a scalar (length=1) and return
!       an error if we do, and it isn't
!

if (present(scalar)) then  !{
  if (scalar) then  !{
    field_length = fm_get_length(name)
    if (field_length .lt. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
    elseif (field_length .gt. 1) then  !}{
      call mpp_error(FATAL, trim(error_header) // trim(name) // ' not scalar')
    endif  !}
  endif  !}
endif  !}

!
!       set the index
!

if (present(index)) then  !{
  index_t = index
  if (index .le. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Index not positive')
  endif  !}
else  !}{
  index_t = 1
endif  !}

fm_type = fm_get_type(name)
if (fm_type .eq. 'integer') then  !{
  if (.not. fm_get_value(name, value, index = index_t)) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Problem getting ' // trim(name))
  endif  !}
elseif (fm_type .eq. ' ' .and. present(default_value)) then  !}{
  value = default_value
elseif (fm_type .eq. ' ') then  !}{
  call mpp_error(FATAL, trim(error_header) // ' Field does not exist: ' // trim(name))
else  !}{
 call mpp_error(FATAL, trim(error_header) // ' Wrong type for ' // trim(name) // ', found (' // trim(fm_type) // ')')
endif  !}

return

end function fm_util_get_integer  !}
! </FUNCTION> NAME="fm_util_get_integer"


!#######################################################################
! <FUNCTION NAME="fm_util_get_logical">
!
! <DESCRIPTION>
! Get a logical value from the Field Manager tree.
! </DESCRIPTION>
!
function fm_util_get_logical(name, caller, index, default_value, scalar)            &
         result (value)  !{

implicit none

!
!       Return type
!

logical :: value

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in), optional  :: caller
integer, intent(in), optional           :: index
logical, intent(in), optional           :: default_value
logical, intent(in), optional           :: scalar

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'fm_util_get_logical'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
integer                         :: index_t
character(len=fm_type_name_len) :: fm_type
integer                         :: field_length

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       Check whether we require a scalar (length=1) and return
!       an error if we do, and it isn't
!

if (present(scalar)) then  !{
  if (scalar) then  !{
    field_length = fm_get_length(name)
    if (field_length .lt. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
    elseif (field_length .gt. 1) then  !}{
      call mpp_error(FATAL, trim(error_header) // trim(name) // ' not scalar')
    endif  !}
  endif  !}
endif  !}

!
!       set the index
!

if (present(index)) then  !{
  index_t = index
  if (index .le. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Index not positive')
  endif  !}
else  !}{
  index_t = 1
endif  !}

fm_type = fm_get_type(name)
if (fm_type .eq. 'logical') then  !{
  if (.not. fm_get_value(name, value, index = index_t)) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Problem getting ' // trim(name))
  endif  !}
elseif (fm_type .eq. ' ' .and. present(default_value)) then  !}{
  value = default_value
elseif (fm_type .eq. ' ') then  !}{
  call mpp_error(FATAL, trim(error_header) // ' Field does not exist: ' // trim(name))
else  !}{
 call mpp_error(FATAL, trim(error_header) // ' Wrong type for ' // trim(name) // ', found (' // trim(fm_type) // ')')
endif  !}

return

end function fm_util_get_logical  !}
! </FUNCTION> NAME="fm_util_get_logical"


!#######################################################################
! <FUNCTION NAME="fm_util_get_real">
!
! <DESCRIPTION>
! Get a real value from the Field Manager tree.
! </DESCRIPTION>
!
function fm_util_get_real(name, caller, index, default_value, scalar)            &
         result (value)  !{

implicit none

!
!       Return type
!

real :: value

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in), optional  :: caller
integer, intent(in), optional           :: index
real, intent(in), optional              :: default_value
logical, intent(in), optional           :: scalar

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'fm_util_get_real'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
integer                         :: index_t
character(len=fm_type_name_len) :: fm_type
integer                         :: field_length

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       Check whether we require a scalar (length=1) and return
!       an error if we do, and it isn't
!

if (present(scalar)) then  !{
  if (scalar) then  !{
    field_length = fm_get_length(name)
    if (field_length .lt. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
    elseif (field_length .gt. 1) then  !}{
      call mpp_error(FATAL, trim(error_header) // trim(name) // ' not scalar')
    endif  !}
  endif  !}
endif  !}

!
!       set the index
!

if (present(index)) then  !{
  index_t = index
  if (index .le. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Index not positive')
  endif  !}
else  !}{
  index_t = 1
endif  !}

fm_type = fm_get_type(name)
if (fm_type .eq. 'real') then  !{
  if (.not. fm_get_value(name, value, index = index_t)) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Problem getting ' // trim(name))
  endif  !}
elseif (fm_type .eq. ' ' .and. present(default_value)) then  !}{
  value = default_value
elseif (fm_type .eq. ' ') then  !}{
  call mpp_error(FATAL, trim(error_header) // ' Field does not exist: ' // trim(name))
else  !}{
 call mpp_error(FATAL, trim(error_header) // ' Wrong type for ' // trim(name) // ', found (' // trim(fm_type) // ')')
endif  !}

return

end function fm_util_get_real  !}
! </FUNCTION> NAME="fm_util_get_real"


!#######################################################################
! <FUNCTION NAME="fm_util_get_string">
!
! <DESCRIPTION>
! Get a string value from the Field Manager tree.
! </DESCRIPTION>
!
function fm_util_get_string(name, caller, index, default_value, scalar)            &
         result (value)  !{

implicit none

!
!       Return type
!

character(len=fm_string_len) :: value

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in), optional  :: caller
integer, intent(in), optional           :: index
character(len=*), intent(in), optional  :: default_value
logical, intent(in), optional           :: scalar

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'fm_util_get_string'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
integer                         :: index_t
character(len=fm_type_name_len) :: fm_type
integer                         :: field_length

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       Check whether we require a scalar (length=1) and return
!       an error if we do, and it isn't
!

if (present(scalar)) then  !{
  if (scalar) then  !{
    field_length = fm_get_length(name)
    if (field_length .lt. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
    elseif (field_length .gt. 1) then  !}{
      call mpp_error(FATAL, trim(error_header) // trim(name) // ' not scalar')
    endif  !}
  endif  !}
endif  !}

!
!       set the index
!

if (present(index)) then  !{
  index_t = index
  if (index .le. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Index not positive')
  endif  !}
else  !}{
  index_t = 1
endif  !}

fm_type = fm_get_type(name)
if (fm_type .eq. 'string') then  !{
  if (.not. fm_get_value(name, value, index = index_t)) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Problem getting ' // trim(name))
  endif  !}
elseif (fm_type .eq. ' ' .and. present(default_value)) then  !}{
  value = default_value
elseif (fm_type .eq. ' ') then  !}{
  call mpp_error(FATAL, trim(error_header) // ' Field does not exist: ' // trim(name))
else  !}{
 call mpp_error(FATAL, trim(error_header) // ' Wrong type for ' // trim(name) // ', found (' // trim(fm_type) // ')')
endif  !}

return

end function fm_util_get_string  !}
! </FUNCTION> NAME="fm_util_get_string"


!#######################################################################
! <SUBROUTINE NAME="fm_util_set_value_integer_array">
!
! <DESCRIPTION>
! Set an integer array in the Field Manager tree.
! </DESCRIPTION>
!

subroutine fm_util_set_value_integer_array(name, value, length, caller, no_overwrite, good_name_list)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)                            :: name
integer, intent(in)                                     :: length
integer, intent(in)                                     :: value(length)
character(len=*), intent(in), optional                  :: caller
logical, intent(in), optional                           :: no_overwrite
character(len=fm_path_name_len), intent(in), optional   :: good_name_list

!
!       Local parameters
!

character(len=48), parameter    :: sub_name = 'fm_util_set_value_integer_array'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
character(len=32)               :: str_error
integer                         :: field_index
integer                         :: field_length
integer                         :: n
logical                         :: no_overwrite_use
character(len=fm_path_name_len) :: good_name_list_use
logical                         :: add_name

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       check that the length is non-negative
!

if (length .lt. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Negative array length')
endif  !}

!
!       check for whether to overwrite existing values
!

if (present(no_overwrite)) then  !{
  no_overwrite_use = no_overwrite
else  !}{
  no_overwrite_use = default_no_overwrite
endif  !}

!
!       check for whether to save the name in a list
!

if (present(good_name_list)) then  !{
  good_name_list_use = good_name_list
else  !}{
  good_name_list_use = default_good_name_list
endif  !}

!
!       write the data array
!

if (length .eq. 0) then  !{
  if (.not. (no_overwrite_use .and. fm_exists(name))) then  !{
    field_index = fm_new_value(name, 0, index = 0)
    if (field_index .le. 0) then  !{
      write (str_error,*) ' with length = ', length
      call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
    endif  !}
  endif  !}
else  !}{
  if (no_overwrite_use .and. fm_exists(name)) then  !{
    field_length = fm_get_length(name)
    if (field_length .lt. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
    endif  !}
    do n = field_length + 1, length  !{
      field_index = fm_new_value(name, value(n), index = n)
      if (field_index .le. 0) then  !{
        write (str_error,*) ' with index = ', n
        call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
      endif  !}
    enddo  !} n
  else  !}{
    field_index = fm_new_value(name, value(1))
    if (field_index .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name))
    endif  !}
    do n = 2, length  !{
      field_index = fm_new_value(name, value(n), index = n)
      if (field_index .le. 0) then  !{
        write (str_error,*) ' with index = ', n
        call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
      endif  !}
    enddo  !} n
  endif  !}
endif  !}

!
!       Add the variable name to the list of good names, to be used
!       later for a consistency check
!

if (good_name_list_use .ne. ' ') then  !{
  if (fm_exists(good_name_list_use)) then  !{
    add_name = fm_util_get_index_string(good_name_list_use, name,               &
       caller = caller_str) .le. 0              ! true if name does not exist in string array
  else  !}{
    add_name = .true.                           ! always add to new list
  endif  !}
  if (add_name .and. fm_exists(name)) then  !{
    if (fm_new_value(good_name_list_use, name, append = .true., create = .true.) .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) //                               &
           ' Could not add ' // trim(name) // ' to "' // trim(good_name_list_use) // '" list')
    endif  !}
  endif  !}
endif  !}

return

end subroutine fm_util_set_value_integer_array  !}
! </SUBROUTINE> NAME="fm_util_set_value_integer_array"


!#######################################################################
! <SUBROUTINE NAME="fm_util_set_value_logical_array">
!
! <DESCRIPTION>
! Set a logical array in the Field Manager tree.
! </DESCRIPTION>
!

subroutine fm_util_set_value_logical_array(name, value, length, caller, no_overwrite, good_name_list)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)                            :: name
integer, intent(in)                                     :: length
logical, intent(in)                                     :: value(length)
character(len=*), intent(in), optional                  :: caller
logical, intent(in), optional                           :: no_overwrite
character(len=fm_path_name_len), intent(in), optional   :: good_name_list

!
!       Local parameters
!

character(len=48), parameter    :: sub_name = 'fm_util_set_value_logical_array'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
character(len=32)               :: str_error
integer                         :: field_index
integer                         :: field_length
integer                         :: n
logical                         :: no_overwrite_use
character(len=fm_path_name_len) :: good_name_list_use
logical                         :: add_name

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       check that the length is non-negative
!

if (length .lt. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Negative array length')
endif  !}

!
!       check for whether to overwrite existing values
!

if (present(no_overwrite)) then  !{
  no_overwrite_use = no_overwrite
else  !}{
  no_overwrite_use = default_no_overwrite
endif  !}

!
!       check for whether to save the name in a list
!

if (present(good_name_list)) then  !{
  good_name_list_use = good_name_list
else  !}{
  good_name_list_use = default_good_name_list
endif  !}

!
!       write the data array
!

if (length .eq. 0) then  !{
  if (.not. (no_overwrite_use .and. fm_exists(name))) then  !{
    field_index = fm_new_value(name, .false., index = 0)
    if (field_index .le. 0) then  !{
      write (str_error,*) ' with length = ', length
      call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
    endif  !}
  endif  !}
else  !}{
  if (no_overwrite_use .and. fm_exists(name)) then  !{
    field_length = fm_get_length(name)
    if (field_length .lt. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
    endif  !}
    do n = field_length + 1, length  !{
      field_index = fm_new_value(name, value(n), index = n)
      if (field_index .le. 0) then  !{
        write (str_error,*) ' with index = ', n
        call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
      endif  !}
    enddo  !} n
  else  !}{
    field_index = fm_new_value(name, value(1))
    if (field_index .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name))
    endif  !}
    do n = 2, length  !{
      field_index = fm_new_value(name, value(n), index = n)
      if (field_index .le. 0) then  !{
        write (str_error,*) ' with index = ', n
        call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
      endif  !}
    enddo  !} n
  endif  !}
endif  !}

!
!       Add the variable name to the list of good names, to be used
!       later for a consistency check
!

if (good_name_list_use .ne. ' ') then  !{
  if (fm_exists(good_name_list_use)) then  !{
    add_name = fm_util_get_index_string(good_name_list_use, name,               &
       caller = caller_str) .le. 0              ! true if name does not exist in string array
  else  !}{
    add_name = .true.                           ! always add to new list
  endif  !}
  if (add_name .and. fm_exists(name)) then  !{
    if (fm_new_value(good_name_list_use, name, append = .true., create = .true.) .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) //                               &
           ' Could not add ' // trim(name) // ' to "' // trim(good_name_list_use) // '" list')
    endif  !}
  endif  !}
endif  !}

return

end subroutine fm_util_set_value_logical_array  !}
! </SUBROUTINE> NAME="fm_util_set_value_logical_array"


!#######################################################################
! <SUBROUTINE NAME="fm_util_set_value_real_array">
!
! <DESCRIPTION>
! Set a real array in the Field Manager tree.
! </DESCRIPTION>
!

subroutine fm_util_set_value_real_array(name, value, length, caller, no_overwrite, good_name_list)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)                            :: name
integer, intent(in)                                     :: length
real, intent(in)                                        :: value(length)
character(len=*), intent(in), optional                  :: caller
logical, intent(in), optional                           :: no_overwrite
character(len=fm_path_name_len), intent(in), optional   :: good_name_list

!
!       Local parameters
!

character(len=48), parameter    :: sub_name = 'fm_util_set_value_real_array'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
character(len=32)               :: str_error
integer                         :: field_index
integer                         :: field_length
integer                         :: n
logical                         :: no_overwrite_use
character(len=fm_path_name_len) :: good_name_list_use
logical                         :: add_name

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       check that the length is non-negative
!

if (length .lt. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Negative array length')
endif  !}

!
!       check for whether to overwrite existing values
!

if (present(no_overwrite)) then  !{
  no_overwrite_use = no_overwrite
else  !}{
  no_overwrite_use = default_no_overwrite
endif  !}

!
!       check for whether to save the name in a list
!

if (present(good_name_list)) then  !{
  good_name_list_use = good_name_list
else  !}{
  good_name_list_use = default_good_name_list
endif  !}

!
!       write the data array
!

if (length .eq. 0) then  !{
  if (.not. (no_overwrite_use .and. fm_exists(name))) then  !{
    field_index = fm_new_value(name, 0.0, index = 0)
    if (field_index .le. 0) then  !{
      write (str_error,*) ' with length = ', length
      call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
    endif  !}
  endif  !}
else  !}{
  if (no_overwrite_use .and. fm_exists(name)) then  !{
    field_length = fm_get_length(name)
    if (field_length .lt. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
    endif  !}
    do n = field_length + 1, length  !{
      field_index = fm_new_value(name, value(n), index = n)
      if (field_index .le. 0) then  !{
        write (str_error,*) ' with index = ', n
        call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
      endif  !}
    enddo  !} n
  else  !}{
    field_index = fm_new_value(name, value(1))
    if (field_index .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name))
    endif  !}
    do n = 2, length  !{
      field_index = fm_new_value(name, value(n), index = n)
      if (field_index .le. 0) then  !{
        write (str_error,*) ' with index = ', n
        call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
      endif  !}
    enddo  !} n
  endif  !}
endif  !}

!
!       Add the variable name to the list of good names, to be used
!       later for a consistency check
!

if (good_name_list_use .ne. ' ') then  !{
  if (fm_exists(good_name_list_use)) then  !{
    add_name = fm_util_get_index_string(good_name_list_use, name,               &
       caller = caller_str) .le. 0              ! true if name does not exist in string array
  else  !}{
    add_name = .true.                           ! always add to new list
  endif  !}
  if (add_name .and. fm_exists(name)) then  !{
    if (fm_new_value(good_name_list_use, name, append = .true., create = .true.) .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) //                               &
           ' Could not add ' // trim(name) // ' to "' // trim(good_name_list_use) // '" list')
    endif  !}
  endif  !}
endif  !}

return

end subroutine fm_util_set_value_real_array  !}
! </SUBROUTINE> NAME="fm_util_set_value_real_array"


!#######################################################################
! <SUBROUTINE NAME="fm_util_set_value_string_array">
!
! <DESCRIPTION>
! Set a string array in the Field Manager tree.
! </DESCRIPTION>
!

subroutine fm_util_set_value_string_array(name, value, length, caller, no_overwrite, good_name_list)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)                            :: name
integer, intent(in)                                     :: length
character(len=*), intent(in)                            :: value(length)
character(len=*), intent(in), optional                  :: caller
logical, intent(in), optional                           :: no_overwrite
character(len=fm_path_name_len), intent(in), optional   :: good_name_list

!
!       Local parameters
!

character(len=48), parameter    :: sub_name = 'fm_util_set_value_string_array'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
character(len=32)               :: str_error
integer                         :: field_index
integer                         :: field_length
integer                         :: n
logical                         :: no_overwrite_use
character(len=fm_path_name_len) :: good_name_list_use
logical                         :: add_name

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       check that the length is non-negative
!

if (length .lt. 0) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Negative array length')
endif  !}

!
!       check for whether to overwrite existing values
!

if (present(no_overwrite)) then  !{
  no_overwrite_use = no_overwrite
else  !}{
  no_overwrite_use = default_no_overwrite
endif  !}

!
!       check for whether to save the name in a list
!

if (present(good_name_list)) then  !{
  good_name_list_use = good_name_list
else  !}{
  good_name_list_use = default_good_name_list
endif  !}

!
!       write the data array
!

if (length .eq. 0) then  !{
  if (.not. (no_overwrite_use .and. fm_exists(name))) then  !{
    field_index = fm_new_value(name, ' ', index = 0)
    if (field_index .le. 0) then  !{
      write (str_error,*) ' with length = ', length
      call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
    endif  !}
  endif  !}
else  !}{
  if (no_overwrite_use .and. fm_exists(name)) then  !{
    field_length = fm_get_length(name)
    if (field_length .lt. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
    endif  !}
    do n = field_length + 1, length  !{
      field_index = fm_new_value(name, value(n), index = n)
      if (field_index .le. 0) then  !{
        write (str_error,*) ' with index = ', n
        call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
      endif  !}
    enddo  !} n
  else  !}{
    field_index = fm_new_value(name, value(1))
    if (field_index .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name))
    endif  !}
    do n = 2, length  !{
      field_index = fm_new_value(name, value(n), index = n)
      if (field_index .le. 0) then  !{
        write (str_error,*) ' with index = ', n
        call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
      endif  !}
    enddo  !} n
  endif  !}
endif  !}

!
!       Add the variable name to the list of good names, to be used
!       later for a consistency check
!

if (good_name_list_use .ne. ' ') then  !{
  if (fm_exists(good_name_list_use)) then  !{
    add_name = fm_util_get_index_string(good_name_list_use, name,               &
       caller = caller_str) .le. 0              ! true if name does not exist in string array
  else  !}{
    add_name = .true.                           ! always add to new list
  endif  !}
  if (add_name .and. fm_exists(name)) then  !{
    if (fm_new_value(good_name_list_use, name, append = .true., create = .true.) .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) //                               &
           ' Could not add ' // trim(name) // ' to "' // trim(good_name_list_use) // '" list')
    endif  !}
  endif  !}
endif  !}

return

end subroutine fm_util_set_value_string_array  !}
! </SUBROUTINE> NAME="fm_util_set_value_string_array"


!#######################################################################
! <SUBROUTINE NAME="fm_util_set_value_integer">
!
! <DESCRIPTION>
! Set an integer value in the Field Manager tree.
! </DESCRIPTION>
!

subroutine fm_util_set_value_integer(name, value, caller, index, append, no_create,        &
     no_overwrite, good_name_list)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)            :: name
integer, intent(in)                     :: value
character(len=*), intent(in), optional  :: caller
integer, intent(in), optional           :: index
logical, intent(in), optional           :: append
logical, intent(in), optional           :: no_create
logical, intent(in), optional           :: no_overwrite
character(len=*), intent(in), optional  :: good_name_list

!
!       Local parameters
!

character(len=48), parameter    :: sub_name = 'fm_util_set_value_integer'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
character(len=32)               :: str_error
integer                         :: field_index
logical                         :: no_overwrite_use
integer                         :: field_length
character(len=fm_path_name_len) :: good_name_list_use
logical                         :: create
logical                         :: add_name

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       check that append and index are not both given
!

if (present(index) .and. present(append)) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Append and index both given as arguments')
endif  !}

!
!       check for whether to overwrite existing values
!

if (present(no_overwrite)) then  !{
  no_overwrite_use = no_overwrite
else  !}{
  no_overwrite_use = default_no_overwrite
endif  !}

!
!       check for whether to save the name in a list
!

if (present(good_name_list)) then  !{
  good_name_list_use = good_name_list
else  !}{
  good_name_list_use = default_good_name_list
endif  !}

if (present(no_create)) then  !{
  create = .not. no_create
  if (no_create .and. (present(append) .or. present(index))) then  !{
    call mpp_error(FATAL, trim(error_header) // ' append or index are present when no_create is true for ' // trim(name))
  endif  !}
else  !}{
  create = .true.
endif  !}

if (present(index)) then  !{
  if (fm_exists(name)) then  !{
    field_length = fm_get_length(name)
    if (field_length .lt. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
    endif  !}
    if (.not. (no_overwrite_use .and. field_length .ge. index)) then  !{
      field_index = fm_new_value(name, value, index = index)
      if (field_index .le. 0) then  !{
        write (str_error,*) ' with index = ', index
        call mpp_error(FATAL, trim(error_header) // ' Problem overwriting ' // trim(name) // trim(str_error))
      endif  !}
    endif  !}
  else  !}{
    field_index = fm_new_value(name, value, index = index)
    if (field_index .le. 0) then  !{
      write (str_error,*) ' with index = ', index
      call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
    endif  !}
  endif  !}
elseif (present(append)) then  !}{
  field_index = fm_new_value(name, value, append = append)
  if (field_index .le. 0) then  !{
    write (str_error,*) ' with append = ', append
    call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
  endif  !}
else  !}{
  if (fm_exists(name)) then  !{
    if (.not. no_overwrite_use) then  !{
      field_index = fm_new_value(name, value)
      if (field_index .le. 0) then  !{
        call mpp_error(FATAL, trim(error_header) // ' Problem overwriting ' // trim(name))
      endif  !}
    endif  !}
  elseif (create) then  !}{
    field_index = fm_new_value(name, value)
    if (field_index .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem creating ' // trim(name))
    endif  !}
  endif  !}
endif  !}

!
!       Add the variable name to the list of good names, to be used
!       later for a consistency check, unless the field did not exist and we did not create it
!

if (good_name_list_use .ne. ' ') then  !{
  if (fm_exists(good_name_list_use)) then  !{
    add_name = fm_util_get_index_string(good_name_list_use, name,               &
       caller = caller_str) .le. 0              ! true if name does not exist in string array
  else  !}{
    add_name = .true.                           ! always add to new list
  endif  !}
  if (add_name .and. fm_exists(name)) then  !{
    if (fm_new_value(good_name_list_use, name, append = .true., create = .true.) .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) //                               &
           ' Could not add ' // trim(name) // ' to "' // trim(good_name_list_use) // '" list')
    endif  !}
  endif  !}
endif  !}

return

end subroutine fm_util_set_value_integer  !}
! </SUBROUTINE> NAME="fm_util_set_value_integer"


!#######################################################################
! <SUBROUTINE NAME="fm_util_set_value_logical">
!
! <DESCRIPTION>
! Set a logical value in the Field Manager tree.
! </DESCRIPTION>
!

subroutine fm_util_set_value_logical(name, value, caller, index, append, no_create,        &
     no_overwrite, good_name_list)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)            :: name
logical, intent(in)                     :: value
character(len=*), intent(in), optional  :: caller
integer, intent(in), optional           :: index
logical, intent(in), optional           :: append
logical, intent(in), optional           :: no_create
logical, intent(in), optional           :: no_overwrite
character(len=*), intent(in), optional  :: good_name_list

!
!       Local parameters
!

character(len=48), parameter    :: sub_name = 'fm_util_set_value_logical'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
character(len=32)               :: str_error
integer                         :: field_index
logical                         :: no_overwrite_use
integer                         :: field_length
character(len=fm_path_name_len) :: good_name_list_use
logical                         :: create
logical                         :: add_name

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       check that append and index are not both given
!

if (present(index) .and. present(append)) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Append and index both given as arguments')
endif  !}

!
!       check for whether to overwrite existing values
!

if (present(no_overwrite)) then  !{
  no_overwrite_use = no_overwrite
else  !}{
  no_overwrite_use = default_no_overwrite
endif  !}

!
!       check for whether to save the name in a list
!

if (present(good_name_list)) then  !{
  good_name_list_use = good_name_list
else  !}{
  good_name_list_use = default_good_name_list
endif  !}

if (present(no_create)) then  !{
  create = .not. no_create
  if (no_create .and. (present(append) .or. present(index))) then  !{
    call mpp_error(FATAL, trim(error_header) // ' append or index are present when no_create is true for ' // trim(name))
  endif  !}
else  !}{
  create = .true.
endif  !}

if (present(index)) then  !{
  if (fm_exists(name)) then  !{
    field_length = fm_get_length(name)
    if (field_length .lt. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
    endif  !}
    if (.not. (no_overwrite_use .and. field_length .ge. index)) then  !{
      field_index = fm_new_value(name, value, index = index)
      if (field_index .le. 0) then  !{
        write (str_error,*) ' with index = ', index
        call mpp_error(FATAL, trim(error_header) // ' Problem overwriting ' // trim(name) // trim(str_error))
      endif  !}
    endif  !}
  else  !}{
    field_index = fm_new_value(name, value, index = index)
    if (field_index .le. 0) then  !{
      write (str_error,*) ' with index = ', index
      call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
    endif  !}
  endif  !}
elseif (present(append)) then  !}{
  field_index = fm_new_value(name, value, append = append)
  if (field_index .le. 0) then  !{
    write (str_error,*) ' with append = ', append
    call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
  endif  !}
else  !}{
  if (fm_exists(name)) then  !{
    if (.not. no_overwrite_use) then  !{
      field_index = fm_new_value(name, value)
      if (field_index .le. 0) then  !{
        call mpp_error(FATAL, trim(error_header) // ' Problem overwriting ' // trim(name))
      endif  !}
    endif  !}
  elseif (create) then  !}{
    field_index = fm_new_value(name, value)
    if (field_index .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem creating ' // trim(name))
    endif  !}
  endif  !}
endif  !}

!
!       Add the variable name to the list of good names, to be used
!       later for a consistency check, unless the field did not exist and we did not create it
!

if (good_name_list_use .ne. ' ') then  !{
  if (fm_exists(good_name_list_use)) then  !{
    add_name = fm_util_get_index_string(good_name_list_use, name,               &
       caller = caller_str) .le. 0              ! true if name does not exist in string array
  else  !}{
    add_name = .true.                           ! always add to new list
  endif  !}
  if (add_name .and. fm_exists(name)) then  !{
    if (fm_new_value(good_name_list_use, name, append = .true., create = .true.) .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) //                               &
           ' Could not add ' // trim(name) // ' to "' // trim(good_name_list_use) // '" list')
    endif  !}
  endif  !}
endif  !}

return

end subroutine fm_util_set_value_logical  !}
! </SUBROUTINE> NAME="fm_util_set_value_logical"


!#######################################################################
! <SUBROUTINE NAME="fm_util_set_value_real">
!
! <DESCRIPTION>
! Set a real value in the Field Manager tree.
! </DESCRIPTION>
!

subroutine fm_util_set_value_real(name, value, caller, index, append, no_create,        &
     no_overwrite, good_name_list)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)            :: name
real, intent(in)                        :: value
character(len=*), intent(in), optional  :: caller
integer, intent(in), optional           :: index
logical, intent(in), optional           :: append
logical, intent(in), optional           :: no_create
logical, intent(in), optional           :: no_overwrite
character(len=*), intent(in), optional  :: good_name_list

!
!       Local parameters
!

character(len=48), parameter    :: sub_name = 'fm_util_set_value_real'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
character(len=32)               :: str_error
integer                         :: field_index
logical                         :: no_overwrite_use
integer                         :: field_length
character(len=fm_path_name_len) :: good_name_list_use
logical                         :: create
logical                         :: add_name

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       check that append and index are not both given
!

if (present(index) .and. present(append)) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Append and index both given as arguments')
endif  !}

!
!       check for whether to overwrite existing values
!

if (present(no_overwrite)) then  !{
  no_overwrite_use = no_overwrite
else  !}{
  no_overwrite_use = default_no_overwrite
endif  !}

!
!       check for whether to save the name in a list
!

if (present(good_name_list)) then  !{
  good_name_list_use = good_name_list
else  !}{
  good_name_list_use = default_good_name_list
endif  !}

if (present(no_create)) then  !{
  create = .not. no_create
  if (no_create .and. (present(append) .or. present(index))) then  !{
    call mpp_error(FATAL, trim(error_header) // ' append or index are present when no_create is true for ' // trim(name))
  endif  !}
else  !}{
  create = .true.
endif  !}

if (present(index)) then  !{
  if (fm_exists(name)) then  !{
    field_length = fm_get_length(name)
    if (field_length .lt. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
    endif  !}
    if (.not. (no_overwrite_use .and. field_length .ge. index)) then  !{
      field_index = fm_new_value(name, value, index = index)
      if (field_index .le. 0) then  !{
        write (str_error,*) ' with index = ', index
        call mpp_error(FATAL, trim(error_header) // ' Problem overwriting ' // trim(name) // trim(str_error))
      endif  !}
    endif  !}
  else  !}{
    field_index = fm_new_value(name, value, index = index)
    if (field_index .le. 0) then  !{
      write (str_error,*) ' with index = ', index
      call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
    endif  !}
  endif  !}
elseif (present(append)) then  !}{
  field_index = fm_new_value(name, value, append = append)
  if (field_index .le. 0) then  !{
    write (str_error,*) ' with append = ', append
    call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
  endif  !}
else  !}{
  if (fm_exists(name)) then  !{
    if (.not. no_overwrite_use) then  !{
      field_index = fm_new_value(name, value)
      if (field_index .le. 0) then  !{
        call mpp_error(FATAL, trim(error_header) // ' Problem overwriting ' // trim(name))
      endif  !}
    endif  !}
  elseif (create) then  !}{
    field_index = fm_new_value(name, value)
    if (field_index .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem creating ' // trim(name))
    endif  !}
  endif  !}
endif  !}

!
!       Add the variable name to the list of good names, to be used
!       later for a consistency check, unless the field did not exist and we did not create it
!

if (good_name_list_use .ne. ' ') then  !{
  if (fm_exists(good_name_list_use)) then  !{
    add_name = fm_util_get_index_string(good_name_list_use, name,               &
       caller = caller_str) .le. 0              ! true if name does not exist in string array
  else  !}{
    add_name = .true.                           ! always add to new list
  endif  !}
  if (add_name .and. fm_exists(name)) then  !{
    if (fm_new_value(good_name_list_use, name, append = .true., create = .true.) .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) //                               &
           ' Could not add ' // trim(name) // ' to "' // trim(good_name_list_use) // '" list')
    endif  !}
  endif  !}
endif  !}

return

end subroutine fm_util_set_value_real  !}
! </SUBROUTINE> NAME="fm_util_set_value_real"


!#######################################################################
! <SUBROUTINE NAME="fm_util_set_value_string">
!
! <DESCRIPTION>
! Set a string value in the Field Manager tree.
! </DESCRIPTION>
!

subroutine fm_util_set_value_string(name, value, caller, index, append, no_create,        &
     no_overwrite, good_name_list)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in)            :: value
character(len=*), intent(in), optional  :: caller
integer, intent(in), optional           :: index
logical, intent(in), optional           :: append
logical, intent(in), optional           :: no_create
logical, intent(in), optional           :: no_overwrite
character(len=*), intent(in), optional  :: good_name_list

!
!       Local parameters
!

character(len=48), parameter    :: sub_name = 'fm_util_set_value_string'

!
!       Local variables
!

character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
character(len=32)               :: str_error
integer                         :: field_index
logical                         :: no_overwrite_use
integer                         :: field_length
character(len=fm_path_name_len) :: good_name_list_use
logical                         :: create
logical                         :: add_name

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       check that append and index are not both given
!

if (present(index) .and. present(append)) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Append and index both given as arguments')
endif  !}

!
!       check for whether to overwrite existing values
!

if (present(no_overwrite)) then  !{
  no_overwrite_use = no_overwrite
else  !}{
  no_overwrite_use = default_no_overwrite
endif  !}

!
!       check for whether to save the name in a list
!

if (present(good_name_list)) then  !{
  good_name_list_use = good_name_list
else  !}{
  good_name_list_use = default_good_name_list
endif  !}

if (present(no_create)) then  !{
  create = .not. no_create
  if (no_create .and. (present(append) .or. present(index))) then  !{
    call mpp_error(FATAL, trim(error_header) // ' append or index are present when no_create is true for ' // trim(name))
  endif  !}
else  !}{
  create = .true.
endif  !}

if (present(index)) then  !{
  if (fm_exists(name)) then  !{
    field_length = fm_get_length(name)
    if (field_length .lt. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem getting length of ' // trim(name))
    endif  !}
    if (.not. (no_overwrite_use .and. field_length .ge. index)) then  !{
      field_index = fm_new_value(name, value, index = index)
      if (field_index .le. 0) then  !{
        write (str_error,*) ' with index = ', index
        call mpp_error(FATAL, trim(error_header) // ' Problem overwriting ' // trim(name) // trim(str_error))
      endif  !}
    endif  !}
  else  !}{
    field_index = fm_new_value(name, value, index = index)
    if (field_index .le. 0) then  !{
      write (str_error,*) ' with index = ', index
      call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
    endif  !}
  endif  !}
elseif (present(append)) then  !}{
  field_index = fm_new_value(name, value, append = append)
  if (field_index .le. 0) then  !{
    write (str_error,*) ' with append = ', append
    call mpp_error(FATAL, trim(error_header) // ' Problem setting ' // trim(name) // trim(str_error))
  endif  !}
else  !}{
  if (fm_exists(name)) then  !{
    if (.not. no_overwrite_use) then  !{
      field_index = fm_new_value(name, value)
      if (field_index .le. 0) then  !{
        call mpp_error(FATAL, trim(error_header) // ' Problem overwriting ' // trim(name))
      endif  !}
    endif  !}
  elseif (create) then  !}{
    field_index = fm_new_value(name, value)
    if (field_index .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) // ' Problem creating ' // trim(name))
    endif  !}
  endif  !}
endif  !}

!
!       Add the variable name to the list of good names, to be used
!       later for a consistency check, unless the field did not exist and we did not create it
!

if (good_name_list_use .ne. ' ') then  !{
  if (fm_exists(good_name_list_use)) then  !{
    add_name = fm_util_get_index_string(good_name_list_use, name,               &
       caller = caller_str) .le. 0              ! true if name does not exist in string array
  else  !}{
    add_name = .true.                           ! always add to new list
  endif  !}
  if (add_name .and. fm_exists(name)) then  !{
    if (fm_new_value(good_name_list_use, name, append = .true., create = .true.) .le. 0) then  !{
      call mpp_error(FATAL, trim(error_header) //                               &
           ' Could not add ' // trim(name) // ' to "' // trim(good_name_list_use) // '" list')
    endif  !}
  endif  !}
endif  !}

return

end subroutine fm_util_set_value_string  !}
! </SUBROUTINE> NAME="fm_util_set_value_string"


!#######################################################################
! <SUBROUTINE NAME="fm_util_start_namelist">
!
! <DESCRIPTION>
! Start processing a namelist
! </DESCRIPTION>
!
subroutine fm_util_start_namelist(path, name, caller, no_overwrite, check)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)            :: path
character(len=*), intent(in)            :: name
character(len=*), intent(in), optional  :: caller
logical,          intent(in), optional  :: no_overwrite
logical,          intent(in), optional  :: check

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'fm_util_start_namelist'

!
!       Local variables
!

integer                         :: namelist_index
character(len=fm_path_name_len) :: path_name
character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
integer                         :: out_unit

out_unit = stdout()

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       Concatenate the path and name
!

if (path .eq. ' ') then  !{
  path_name = name
else  !}{
  path_name = trim(path) // '/' // name
endif  !}
save_path = path
save_name = name

!
!       set the default caller string, if desired
!

if (present(caller)) then  !{
  call fm_util_set_caller(caller)
else  !}{
  call fm_util_reset_caller
endif  !}

!
!       set the default no_overwrite flag, if desired
!

if (present(no_overwrite)) then  !{
  call fm_util_set_no_overwrite(no_overwrite)
else  !}{
  call fm_util_reset_no_overwrite
endif  !}

!
!       set the default good_name_list string, if desired
!

if (present(check)) then  !{
  if (check) then  !{
    call fm_util_set_good_name_list('/ocean_mod/GOOD/namelists/' // trim(path_name) // '/good_list')
  else  !}{
    call fm_util_reset_good_name_list
  endif  !}
else  !}{
  call fm_util_reset_good_name_list
endif  !}

!
!       Process the namelist
!

write (out_unit,*)
write (out_unit,*) trim(note_header), ' Processing namelist ', trim(path_name)

!
!       Check whether the namelist already exists. If so, then use that one
!

namelist_index = fm_get_index('/ocean_mod/namelists/' // trim(path_name))
if (namelist_index .gt. 0) then  !{

  !write (out_unit,*) trim(note_header), ' Namelist already set with index ', namelist_index

else  !}{

!
!       Set a new namelist and get its index
!

  namelist_index = fm_new_list('/ocean_mod/namelists/' // trim(path_name), create = .true.)
  if (namelist_index .le. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Could not set namelist ' // trim(path_name))
  endif  !}

endif  !}

!
!       Add the namelist name to the list of good namelists, to be used
!       later for a consistency check
!

if (fm_new_value('/ocean_mod/GOOD/namelists/' // trim(path) // '/good_values',    &
                 name, append = .true., create = .true.) .le. 0) then  !{
  call mpp_error(FATAL, trim(error_header) //                           &
       ' Could not add ' // trim(name) // ' to "' // trim(path) // '/good_values" list')
endif  !}

!
!       Change to the new namelist, first saving the current list
!

save_current_list = fm_get_current_list()
if (save_current_list .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not get the current list')
endif  !}

if (.not. fm_change_list('/ocean_mod/namelists/' // trim(path_name))) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not change to the namelist ' // trim(path_name))
endif  !}

return

end subroutine fm_util_start_namelist  !}
! </SUBROUTINE> NAME="fm_util_start_namelist"


!#######################################################################
! <SUBROUTINE NAME="fm_util_end_namelist">
!
! <DESCRIPTION>
! Finish up processing a namelist
! </DESCRIPTION>
!
subroutine fm_util_end_namelist(path, name, caller, check)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)            :: path
character(len=*), intent(in)            :: name
character(len=*), intent(in), optional  :: caller
logical,          intent(in), optional  :: check

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'fm_util_end_namelist'

!
!       Local variables
!

character(len=fm_string_len), pointer, dimension(:)     :: good_list => NULL()
character(len=fm_path_name_len)                         :: path_name
character(len=256)                                      :: error_header
character(len=256)                                      :: warn_header
character(len=256)                                      :: note_header
character(len=128)                                      :: caller_str

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a path is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       Check that the path ane name match the preceding call to
!       fm_util_start_namelist
!

if (path .ne. save_path) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Path "' // trim(path) // '" does not match saved path "' // trim(save_path) // '"')
elseif (name .ne. save_name) then  !}{
  call mpp_error(FATAL, trim(error_header) // ' Name "' // trim(name) // '" does not match saved name "' // trim(save_name) // '"')
endif  !}

!
!       Concatenate the path and name
!

if (path .eq. ' ') then  !{
  path_name = name
else  !}{
  path_name = trim(path) // '/' // name
endif  !}
save_path = ' '
save_name = ' '

!
!       Check for any errors in the number of fields in this list
!

if (present(check)) then  !{
  if (check) then  !{
    if (caller_str .eq. ' ') then  !{
      caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'
    endif  !}
    good_list => fm_util_get_string_array('/ocean_mod/GOOD/namelists/' // trim(path_name) // '/good_list',            &
         caller = trim(mod_name) // '(' // trim(sub_name) // ')')
    if (associated(good_list)) then  !{
      call fm_util_check_for_bad_fields('/ocean_mod/namelists/' // trim(path_name), good_list, caller = caller_str)
      deallocate(good_list)
    else  !}{
      call mpp_error(FATAL, trim(error_header) // ' Empty "' // trim(path_name) // '" list')
    endif  !}
  endif  !}
endif  !}

!
!       Change back to the saved list
!

if (save_current_list .ne. ' ') then  !{
  if (.not. fm_change_list(save_current_list)) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Could not change to the saved list: ' // trim(save_current_list))
  endif  !}
endif  !}
save_current_list = ' '

!
!       reset the default caller string
!

call fm_util_reset_caller

!
!       reset the default no_overwrite string
!

call fm_util_reset_no_overwrite

!
!       reset the default good_name_list string
!

call fm_util_reset_good_name_list

return

end subroutine fm_util_end_namelist  !}
! </SUBROUTINE> NAME="fm_util_end_namelist"


end module fm_util_mod  !}

!-----------------------------------------------------------------------
! Copyright 2011 NOAA Geophysical Fluid Dynamics Lab, Princeton, NJ
! This program is distributed under the terms of the GNU General Public
! License. See the file COPYING contained in this directory
!
!-----------------------------------------------------------------------
#define __NF_TRY__(err_code,iret,LABEL) iret=err_code;\
call cdfe(iret,"",__LINE__,verb);\
if(iret/=NF_NOERR)goto LABEL


module nfu_compress_mod

  use nfu_mod

implicit none
private

! ==== public interface ======================================================
public :: nfu_inq_compressed_dim, nfu_inq_compressed_var
public :: nfu_get_compressed_var_r8, nfu_get_compressed_var_int
public :: nfu_put_compressed_var_r8, nfu_put_compressed_var_int
public :: nfu_get_compressed_var_r8n
public :: nfu_put_compressed_var_r8n
! ==== end of public interface ===============================================

! ==== interfaces for overloaded functions ===================================
interface nfu_inq_compressed_dim
   module procedure inq_compressed_dim_n
   module procedure inq_compressed_dim_i
end interface

interface nfu_inq_compressed_var
   module procedure inq_compressed_var_n
   module procedure inq_compressed_var_i
end interface

#include <netcdf.inc>

integer :: verb = 0


! ---- private type - used to hold dimension/packing information during unpacking
! (see get_compressed_var_i_r8)
type diminfo_type
   integer, pointer :: idx(:)=>NULL() ! packing information
   integer :: length  ! size of the dimension in the input array
   integer :: stride  ! stide along the dimension in the output array
end type 


contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

! ===========================================================================
function nfu_get_compressed_var_r8n(ncid,name,data,mask) result (iret)
  integer          , intent(in)    :: ncid
  character(*)     , intent(in)  :: name
  real(kind=8)     , intent(inout) :: data(*)
  logical, optional, intent(inout) :: mask(*)
  integer :: iret

  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid, name, varid), iret, 7)
  iret = nfu_get_compressed_var_r8(ncid,varid,data,mask)
7 return

end function 

! ===========================================================================
function nfu_get_compressed_var_r8(ncid,varid,data,mask) result (iret)
  integer          , intent(in)    :: ncid,varid
  real(kind=8)     , intent(inout) :: data(*)
  logical, optional, intent(inout) :: mask(*)
  integer :: iret

  integer :: ndims,dimids(NF_MAX_VAR_DIMS),dimlen
  integer :: varsize ! total size of the compressed variable
  integer :: cndims, cdimids(NF_MAX_VAR_DIMS),cdimlens(NF_MAX_VAR_DIMS)
  character(NF_MAX_NAME) :: dimname

  real(kind=8),allocatable :: buffer(:)
  integer :: i, ii, n, length, idx(NF_MAX_VAR_DIMS)
  integer :: stride

  type(diminfo_type) :: diminfo(NF_MAX_VAR_DIMS)

  ! get the information for the compressed variable
  iret = nfu_inq_var(ncid,varid,ndims=ndims,dimids=dimids,varsize=varsize)
  __NF_TRY__(iret,iret,7)

  ! get the compressed dimensions
  stride = 1
  do i = 1,ndims
     __NF_TRY__(nfu_inq_dim(ncid,dimids(i),dimlen=diminfo(i)%length,dimname=dimname),iret,7)
     if(nfu_inq_compressed_dim(ncid,dimids(i),&
          ndims=cndims,dimids=cdimids,dimlens=cdimlens)==NF_NOERR) then
        ! it is a compressed dimension; get dimension itself and calculate
        ! get the dimension (that is, compression information)
        __NF_TRY__(nfu_inq_dim(ncid,dimids(i),dimlen=dimlen,dimname=dimname),iret,7)
        allocate(diminfo(i)%idx(0:dimlen-1))
        __NF_TRY__(nfu_get_var_int(ncid,dimname,diminfo(i)%idx),iret,7)
        ! calculate corresponding stride in output (unpacked) array
        length = 1
        do n = 1,cndims
           length = length*cdimlens(n)
        enddo
     else
        length = diminfo(i)%length
     endif
     diminfo(i)%stride = stride
     stride = stride*length
  enddo
        
  ! get the entire variable
  allocate(buffer(varsize))
  __NF_TRY__(nf_get_var_double(ncid,varid,buffer),iret,7)

  ! move the data to the output buffer
  idx(:) = 0
  do i = 1,size(buffer)
     ! calculate destination index
     ii = 1
     do n = 1,ndims
        if(associated(diminfo(n)%idx)) then
           if(diminfo(n)%idx(idx(n)) >= 0)then
              ii = ii+diminfo(n)%idx(idx(n))*diminfo(n)%stride
           else
              ii = -1 ! set a value flagging an invalid point
              exit    ! from index loop
           endif
        else
           ii = ii+idx(n)*diminfo(n)%stride
        endif
     enddo

     ! if index is negative, skip an invalid point
     if (ii > 0) then
        data(ii) = buffer(i)
        if(present(mask))mask(ii) = .true.
     endif

     ! increment indices
     do n = 1,ndims
        idx(n) = idx(n)+1
        if(idx(n)<diminfo(n)%length)exit
        idx(n) = 0
     enddo
  enddo

7 continue
  ! clean up memory
  do i = 1,size(diminfo)
     if(associated(diminfo(i)%idx)) &
          deallocate(diminfo(i)%idx)
  enddo
  if (allocated(buffer)) &
       deallocate(buffer)
end function


! ===========================================================================
function nfu_get_compressed_var_int(ncid,varid,data,mask) result (iret)
  integer :: iret
  integer, intent(in)    :: ncid,varid
  integer, intent(inout) :: data(*)
  logical, optional, intent(inout) :: mask(*)

  integer :: ndims,dimids(NF_MAX_VAR_DIMS),dimlen
  integer :: varsize ! total size of the compressed variable
  integer :: cndims, cdimids(NF_MAX_VAR_DIMS),cdimlens(NF_MAX_VAR_DIMS)
  character(NF_MAX_NAME) :: dimname

  integer, allocatable :: buffer(:)
  integer :: i, ii, n, length, idx(NF_MAX_VAR_DIMS)
  integer :: stride

  type(diminfo_type) :: diminfo(NF_MAX_VAR_DIMS)

  ! get the information for the compressed variable
  iret = nfu_inq_var(ncid,varid,ndims=ndims,dimids=dimids,varsize=varsize)
  __NF_TRY__(iret,iret,7)

  ! get the compressed dimensions
  stride = 1
  do i = 1,ndims
     __NF_TRY__(nfu_inq_dim(ncid,dimids(i),dimlen=diminfo(i)%length,dimname=dimname),iret,7)
     if(nfu_inq_compressed_dim(ncid,dimids(i),&
          ndims=cndims,dimids=cdimids,dimlens=cdimlens)==NF_NOERR) then
        ! it is a compressed dimension; get dimension itself and calculate
        ! get the dimension (that is, compression information)
        __NF_TRY__(nfu_inq_dim(ncid,dimids(i),dimlen=dimlen,dimname=dimname),iret,7)
        allocate(diminfo(i)%idx(0:dimlen-1))
        __NF_TRY__(nfu_get_var_int(ncid,dimname,diminfo(i)%idx),iret,7)
        ! calculate corresponding stride in output (unpacked) array
        length = 1
        do n = 1,cndims
           length = length*cdimlens(n)
        enddo
     else
        length = diminfo(i)%length
     endif
     diminfo(i)%stride = stride
     stride = stride*length
  enddo
        
  ! get the entire variable
  allocate(buffer(varsize))
  __NF_TRY__(nf_get_var_int(ncid,varid,buffer),iret,7)

  ! move the data to the output buffer
  idx(:) = 0
  do i = 1,size(buffer)
     ! calculate destination index
     ii = 1
     do n = 1,ndims
        if(associated(diminfo(n)%idx)) then
           if(diminfo(n)%idx(idx(n)) >= 0)then
              ii = ii+diminfo(n)%idx(idx(n))*diminfo(n)%stride
           else
              ii = -1 ! set a value flagging an invalid point
              exit    ! from index loop
           endif
        else
           ii = ii+idx(n)*diminfo(n)%stride
        endif
     enddo

     ! if index is negative, skip an invalid point
     if (ii > 0) then
        data(ii) = buffer(i)
        if(present(mask)) mask(ii) = .true.
     endif

     ! increment indices
     do n = 1,ndims
        idx(n) = idx(n)+1
        if(idx(n)<diminfo(n)%length)exit
        idx(n) = 0
     enddo
  enddo

7 continue
  ! clean up memory
  do i = 1,size(diminfo)
     if(associated(diminfo(i)%idx)) &
          deallocate(diminfo(i)%idx)
  enddo
  if (allocated(buffer)) &
       deallocate(buffer)
end function

! ===========================================================================
function nfu_put_compressed_var_r8n(ncid,name,src) result (iret)
  integer     , intent(in)    :: ncid
  character(*), intent(in)    :: name
  real(kind=8), intent(inout) :: src(*)      ! data to write
  integer :: iret

  integer :: varid
  __NF_TRY__(nf_inq_varid(ncid, name, varid), iret, 7)
  iret = nfu_put_compressed_var_r8(ncid,varid,src)
7 return
end function

! ===========================================================================
function nfu_put_compressed_var_r8(ncid,varid,src) result (iret)
  integer     , intent(in)    :: ncid,varid
  real(kind=8), intent(inout) :: src(*)      ! data to write
  integer :: iret

  integer :: ndims,dimids(NF_MAX_VAR_DIMS),dimlen
  integer :: varsize ! total size of the compressed variable
  integer :: cndims, cdimids(NF_MAX_VAR_DIMS),cdimlens(NF_MAX_VAR_DIMS)
  character(NF_MAX_NAME) :: dimname

  real(kind=8),allocatable :: buffer(:)
  integer :: i, ii, n, length, idx(NF_MAX_VAR_DIMS)
  integer :: stride

  type(diminfo_type) :: diminfo(NF_MAX_VAR_DIMS)

  ! get the information for the compressed variable
  iret = nfu_inq_var(ncid,varid,ndims=ndims,dimids=dimids,varsize=varsize)
  __NF_TRY__(iret,iret,7)

  ! get the compressed dimensions
  stride = 1
  do i = 1,ndims
     __NF_TRY__(nfu_inq_dim(ncid,dimids(i),dimlen=diminfo(i)%length,dimname=dimname),iret,7)
     if(nfu_inq_compressed_dim(ncid,dimids(i),&
          ndims=cndims,dimids=cdimids,dimlens=cdimlens)==NF_NOERR) then
        ! it is a compressed dimension; get dimension itself and calculate
        ! get the dimension (that is, compression information)
        __NF_TRY__(nfu_inq_dim(ncid,dimids(i),dimlen=dimlen,dimname=dimname),iret,7)
        allocate(diminfo(i)%idx(0:dimlen-1))
        __NF_TRY__(nfu_get_var_int(ncid,dimname,diminfo(i)%idx),iret,7)
        ! calculate corresponding stride in output (unpacked) array
        length = 1
        do n = 1,cndims
           length = length*cdimlens(n)
        enddo
     else
        length = diminfo(i)%length
     endif
     diminfo(i)%stride = stride
     stride = stride*length
  enddo
        
  ! get the entire variable
  allocate(buffer(varsize))

  ! move the data to the output buffer
  idx(:) = 0
  do i = 1,size(buffer)
     ! calculate destination index
     ii = 1
     do n = 1,ndims
        if(associated(diminfo(n)%idx)) then
           ii = ii+diminfo(n)%idx(idx(n))*diminfo(n)%stride
        else
           ii = ii+idx(n)*diminfo(n)%stride
        endif
     enddo

     buffer(i) = src(ii)

     ! increment indices
     do n = 1,ndims
        idx(n) = idx(n)+1
        if(idx(n)<diminfo(n)%length)exit
        idx(n) = 0
     enddo
  enddo

  __NF_TRY__(nf_put_var_double(ncid,varid,buffer),iret,7)

7 continue
  ! clean up memory
  do i = 1,size(diminfo)
     if(associated(diminfo(i)%idx)) &
          deallocate(diminfo(i)%idx)
  enddo
  if (allocated(buffer)) &
       deallocate(buffer)
end function


! ===========================================================================
function nfu_put_compressed_var_int(ncid,varid,src) result (iret)
  integer :: iret
  integer, intent(in)    :: ncid,varid
  integer, intent(inout) :: src(*)

  integer :: ndims,dimids(NF_MAX_VAR_DIMS),dimlen
  integer :: varsize ! total size of the compressed variable
  integer :: cndims, cdimids(NF_MAX_VAR_DIMS),cdimlens(NF_MAX_VAR_DIMS)
  character(NF_MAX_NAME) :: dimname

  integer, allocatable :: buffer(:)
  integer :: i, ii, n, length, idx(NF_MAX_VAR_DIMS)
  integer :: stride

  type(diminfo_type) :: diminfo(NF_MAX_VAR_DIMS)

  ! get the information for the compressed variable
  iret = nfu_inq_var(ncid,varid,ndims=ndims,dimids=dimids,varsize=varsize)
  __NF_TRY__(iret,iret,7)

  ! get the compressed dimensions
  stride = 1
  do i = 1,ndims
     __NF_TRY__(nfu_inq_dim(ncid,dimids(i),dimlen=diminfo(i)%length,dimname=dimname),iret,7)
     if(nfu_inq_compressed_dim(ncid,dimids(i),&
          ndims=cndims,dimids=cdimids,dimlens=cdimlens)==NF_NOERR) then
        ! it is a compressed dimension; get dimension itself and calculate
        ! get the dimension (that is, compression information)
        __NF_TRY__(nfu_inq_dim(ncid,dimids(i),dimlen=dimlen,dimname=dimname),iret,7)
        allocate(diminfo(i)%idx(0:dimlen-1))
        __NF_TRY__(nfu_get_var_int(ncid,dimname,diminfo(i)%idx),iret,7)
        ! calculate corresponding stride in output (unpacked) array
        length = 1
        do n = 1,cndims
           length = length*cdimlens(n)
        enddo
     else
        length = diminfo(i)%length
     endif
     diminfo(i)%stride = stride
     stride = stride*length
  enddo
        
  ! get the entire variable
  allocate(buffer(varsize))

  ! move the data to the output buffer
  idx(:) = 0
  do i = 1,size(buffer)
     ! increment indices
     do n = 1,ndims
        idx(n) = idx(n)+1
        if(idx(n)<diminfo(n)%length)exit
        idx(n) = 0
     enddo
     ! calculate destination index
     ii = 1
     do n = 1,ndims
        if(associated(diminfo(n)%idx)) then
           ii = ii+diminfo(n)%idx(idx(n))*diminfo(n)%stride
        else
           ii = ii+idx(n)*diminfo(n)%stride
        endif
     enddo
     buffer(i) = src(ii)
  enddo

  __NF_TRY__(nf_get_var_int(ncid,varid,buffer),iret,7)

7 continue
  ! clean up memory
  do i = 1,size(diminfo)
     if(associated(diminfo(i)%idx)) &
          deallocate(diminfo(i)%idx)
  enddo
  if (allocated(buffer)) &
       deallocate(buffer)
end function

! ===========================================================================
function inq_compressed_dim_n(ncid,name,ndims,dimids,dimlens,dimid) result (iret)
  integer :: iret
  integer, intent(in)  :: ncid
  character(*), intent(in) :: name
  integer, intent(out), optional :: ndims
  integer, intent(out), optional :: dimids(:)
  integer, intent(out), optional :: dimlens(:)
  integer, intent(out), optional :: dimid

  integer :: dimid_

  __NF_TRY__(nf_inq_dimid(ncid,name,dimid_),iret,7)
  if(present(dimid)) dimid = dimid_
  __NF_TRY__(inq_compressed_dim_i(ncid,dimid_,ndims,dimids,dimlens),iret,7)
7 return
end function

! ===========================================================================
function inq_compressed_dim_i(ncid,dimid,ndims,dimids,dimlens,dimname) result (iret)
  integer :: iret
  integer, intent(in)  :: ncid,dimid
  integer, intent(out), optional :: ndims
  integer, intent(out), optional :: dimids(:)
  integer, intent(out), optional :: dimlens(:)
  character(*), intent(out), optional :: dimname
  
  character(NF_MAX_NAME) :: dimname_
  character(1024) :: compress ! should be more than enough to hold the compression info
  integer :: dimlen,dimid0,n,is,ie

  __NF_TRY__(nfu_inq_dim(ncid,dimid,dimname=dimname_),iret,7)
  if(present(dimname)) dimname = dimname_
  compress = ''
  __NF_TRY__(nfu_get_att(ncid,dimname_,'compress',compress),iret,7)

  ! parse the description of the compression
  ie = len_trim(compress)
  n = 0
  do while(ie>0)
     is = scan(compress(1:ie),' ',back=.true.)
     if(is==ie) then
        ! skip space runs
     else
        n = n+1
        iret = nfu_inq_dim(ncid,compress(is+1:ie),dimlen=dimlen,dimid=dimid0)
        __NF_TRY__(iret,iret,7)
        if(present(dimids)) dimids(n) = dimid0
        if(present(dimlens)) dimlens(n) = dimlen
     endif
     ie = is-1
  enddo
  if(present(ndims))ndims=n
7 return
end function

! ============================================================================
function inq_compressed_var_n(ncid, name, id, xtype, ndims, dimids, dimlens, natts, &
     is_dim, has_records, varsize, recsize, nrec, is_compressed) result(iret)
  integer :: iret
  integer, intent(in) :: ncid
  character(*),intent(in) :: name
  integer, intent(out), optional :: id
  integer, intent(out), optional :: xtype
  integer, intent(out), optional :: ndims
  integer, intent(out), optional :: dimids(:)
  integer, intent(out), optional :: dimlens(:)
  integer, intent(out), optional :: natts
  logical, intent(out), optional :: is_dim ! true if variable is a dimension variable
  logical, intent(out), optional :: has_records ! true if variable depends on record dimension
  integer, intent(out), optional :: varsize ! total size of the variable
  integer, intent(out), optional :: recsize ! size of a single record
  integer, intent(out), optional :: nrec    ! number of records
  logical, intent(out), optional :: is_compressed ! true if variable is actually compressed

  integer :: vid
  character(len=NF_MAX_NAME) :: vname

  __NF_TRY__(nf_inq_varid(ncid,name,vid),iret,7)
  if(present(id)) id = vid
  iret = inq_compressed_var_i(ncid,vid,vname,xtype,ndims,dimids,dimlens,natts,&
       is_dim,has_records,varsize,recsize,nrec,is_compressed)

7 return  
end function

! ============================================================================
function inq_compressed_var_i(ncid, vid, name, xtype, ndims, dimids, dimlens, &
     natts, is_dim, has_records, varsize, recsize, nrec, is_compressed) result(iret)
  integer :: iret
  integer, intent(in) :: ncid
  integer, intent(in) :: vid
  character(*),intent(out), optional :: name
  integer, intent(out), optional :: xtype
  integer, intent(out), optional :: ndims
  integer, intent(out), optional :: dimids(:)
  integer, intent(out), optional :: dimlens(:)
  integer, intent(out), optional :: natts
  logical, intent(out), optional :: is_dim ! true if variable is a dimension variable
  logical, intent(out), optional :: has_records ! true if variable depends on record dimension
  integer, intent(out), optional :: varsize ! total size of the variable
  integer, intent(out), optional :: recsize ! size of a single record
  integer, intent(out), optional :: nrec    ! number of records
  logical, intent(out), optional :: is_compressed ! true if variable is actually compressed

  
  integer :: nd0, dids0(NF_MAX_VAR_DIMS),dlens0(NF_MAX_VAR_DIMS)
  integer :: nd1, dids1(NF_MAX_VAR_DIMS),dlens1(NF_MAX_VAR_DIMS)
  integer :: i,n,unlimdim,vsize,rsize

  iret =  nfu_inq_var(ncid, vid, name, xtype, nd0, dids0, dlens0, natts, &
     is_dim, has_records, varsize, recsize, nrec)

  nd1=1
  if(present(is_compressed)) is_compressed=.false.
  do i = 1, nd0
     if(nfu_inq_compressed_dim(ncid,dids0(i),&
          ndims=n,dimids=dids1(nd1:),dimlens=dlens1(nd1:))==NF_NOERR) then
        nd1 = nd1+n
        if(present(is_compressed)) is_compressed=.true.
     else
        dlens1(nd1) = dlens0(i)
        dids1(nd1) = dids0(i)
        nd1 = nd1+1
     endif
  enddo
  nd1 = nd1-1

  if(present(ndims))   ndims   = nd1
  if(present(dimids))  dimids  = dids1
  if(present(dimlens)) dimlens = dlens1
  if(present(varsize).or.present(recsize)) then
     __NF_TRY__(nf_inq_unlimdim(ncid,unlimdim),iret,7)
     vsize = 1; rsize=1
     do i = 1,nd1
        vsize = vsize*dlens1(i)
        if(dids1(i)/=unlimdim)&
             rsize = rsize*dlens1(i)
     enddo
     if (present(varsize)) varsize=vsize
     if (present(recsize)) recsize=rsize
  end if
7 return

end function

end module nfu_compress_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: load_mie_table.F90,v 20.0 2013/12/13 23:16:47 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

  subroutine load_mie_table(mie_table_name,mt)
  use radar_simulator_types
#ifdef COSP_GFDL
  use mpp_mod,only: get_unit
#endif
  implicit none
  
! Purpose:
!   Loads the Mie table data
!   Part of Quickbeam v1.03
!   http://reef.atmos.colostate.edu/haynes/radarsim
!
! Inputs:  
!   [mie_table_name]   Mie table input file
!
! Outputs:
!   [mt]            structure of Mie table data
!
! Created from Quickbeam v1.02 08/24/2006 by Roger Marchand  

! ----- INPUT -----
  character*200, intent(in) :: mie_table_name

! ----- OUTPUT -----
  type(mie), intent(out) :: mt

! ----- INTERNAL -----  
#ifdef COSP_GFDL
  integer :: i, funit
#else
  integer :: i
#endif

  integer*4 :: dummy_in(4)
     
#ifdef COSP_GFDL
    funit = get_unit()
    open(funit,file=mie_table_name,action='read')
    read(funit,*) dummy_in
#else
    open(51,file=mie_table_name,action='read')
    read(51,*) dummy_in
#endif
 
     if(dummy_in(1).ne. mt_nfreq .or. &
        dummy_in(2).ne. mt_ntt .or. &
        dummy_in(3).ne. mt_nf .or. &
        dummy_in(4).ne. mt_nd) then

          print *,'Mie file is of size :',dummy_in(:)
          print *,'  expected a size of:',mt_nfreq, mt_ntt,mt_nf,mt_nf
          print *,'  change paramters in radar_simulator_types.f90 ?? '
          stop
     endif

#ifdef COSP_GFDL
    read(funit,*) mt%freq
    read(funit,*) mt%tt
    read(funit,*) mt%f
    read(funit,*) mt%phase
    read(funit,*) mt%D
    read(funit,*) mt%qext
    read(funit,*) mt%qbsca
#else
    read(51,*) mt%freq
    read(51,*) mt%tt
    read(51,*) mt%f
    read(51,*) mt%phase
    read(51,*) mt%D
    read(51,*) mt%qext
    read(51,*) mt%qbsca
#endif
    
#ifdef COSP_GFDL
    close(funit)
#else
    close(51)
#endif

! // create arrays of liquid/ice temperature
  cnt_liq = 0
  cnt_ice = 0
  do i=1,mt_ntt
    if (mt%phase(i) == 0) cnt_liq = cnt_liq + 1
    if (mt%phase(i) == 1) cnt_ice = cnt_ice + 1
  enddo
#ifndef COSP_GFDL
  allocate(mt_ttl(cnt_liq),mt_tti(cnt_ice))
#endif
  do i=1,cnt_liq
    mt_ttl(i) = mt%tt(i)
  enddo
  do i=1,cnt_ice
    mt_tti(i) = mt%tt(cnt_liq+i)
  enddo

  end subroutine load_mie_table

#undef _TYP
#define _TYP integer

module quicksort_mod

private
public qksrt_quicksort

! Written by Magnus Lie Hetland 

contains

function qksrt_partition(n, list, start, end) result(top)
  implicit none
  integer, intent(in) :: n
  _TYP, intent(inout) :: list(n)
     integer, intent(in) :: start, end

     integer pivot, bottom, top
     logical done

     pivot = list(end)                          ! Partition around the last value
     bottom = start-1                           ! Start outside the area to be partitioned
     top = end                                  ! Ditto

     done = .false.
     do while (.not. done)                      ! Until all elements are partitioned...

        do while (.not. done)                  ! Until we find an out of place element...
           bottom = bottom+1                  ! ... move the bottom up.

           if(bottom == top) then             ! If we hit the top...
              done = .true.                  ! ... we are done.
              exit
           endif

           if(list(bottom) > pivot) then           ! Is the bottom out of place?
              list(top) = list(bottom)       ! Then put it at the top...
              exit                          ! ... and start searching from the top.
           endif
        enddo

        do while (.not. done)                        ! Until we find an out of place element...
           top = top-1                        ! ... move the top down.

           if(top == bottom) then                  ! If we hit the bottom...
              done = .true.                      ! ... we are done.
              exit
           endif

           if(list(top) < pivot) then              ! Is the top out of place?
              list(bottom) = list(top)       ! Then put it at the bottom...
              exit                          ! ...and start searching from the bottom.
           endif
        enddo
     enddo

     list(top) = pivot                          ! Put the pivot in its place.
     ! Return the split point

end function qksrt_partition

recursive subroutine qksrt_quicksort(n, list, start, end)
     implicit none
     integer, intent(in) :: n
     _TYP, intent(inout) :: list(n)
     integer, intent(in) :: start, end
     integer :: split
     if(start < end) then                            ! If there are two or more elements...
        split = qksrt_partition(n, list, start, end)    ! ... partition the sublist...
        call qksrt_quicksort(n, list,  start, split-1)        ! ... and sort both halves.
        call qksrt_quicksort(n, list, split+1, end)
     endif
end subroutine qksrt_quicksort

end module quicksort_mod

#ifdef _TEST_SORT
      program test
        implicit none
        integer :: list(16) = (/6, 2, 3, 4, 1, 45, 3432, 3245, 32545, 66555, 32, 1,3, -43254, 324, 54/)
        print *,'before list=', list
        call qksrt_quicksort(size(list), list, 1, size(list))
        print *,'after  list=', list
      end program test
#endif

module spectral_init_cond_mod

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use               fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, field_size, stdlog, file_exist, &
                                 write_version_number, close_file, check_nml_error, read_data

use               mpp_mod, only: mpp_chksum

use       mpp_domains_mod, only: mpp_get_global_domain

use         constants_mod, only: grav, pi

use   vert_coordinate_mod, only: compute_vert_coord

use        transforms_mod, only: get_grid_boundaries, get_deg_lon, get_deg_lat, trans_grid_to_spherical, &
                                 trans_spherical_to_grid, grid_domain, spectral_domain, get_grid_domain, &
                                 get_spec_domain

use  press_and_geopot_mod, only: press_and_geopot_init, pressure_variables

use spectral_initialize_fields_mod, only: spectral_initialize_fields

use      ic_from_external_file_mod, only: ic_from_external_file

use       topog_regularization_mod, only: compute_lambda, regularize

use                 topography_mod, only: gaussian_topog_init, get_topog_mean, get_ocean_mask

use                tracer_type_mod, only: tracer_type

implicit none
private

character(len=128), parameter :: version = &
'$Id: spectral_init_cond.F90,v 19.0 2012/01/06 20:35:39 fms Exp $'

character(len=128), parameter :: tagname = &
'$Name: tikal $'

public :: spectral_init_cond

real :: initial_temperature=264.
character(len=64) :: topography_option = 'flat'  ! realistic topography computed from high resolution raw data
character(len=64) :: topog_file_name  = 'INPUT/topography.data.nc'
character(len=64) :: topog_field_name = 'zsurf'

namelist / spectral_init_cond_nml / initial_temperature, topography_option, topog_file_name, topog_field_name

contains

!=========================================================================================================================

subroutine spectral_init_cond(initial_state_option, tracer_attributes, reference_sea_level_press, triang_trunc, use_virtual_temperature, &
                              vert_coord_option, vert_difference_option, scale_heights, surf_res,    &
                              p_press, p_sigma, exponent, ocean_topog_smoothing, pk, bk, vors, divs, &
                              ts, ln_ps, ug, vg, tg, psg, vorg, divg, grid_tracers, surf_geopotential, ocean_mask)

character(len=*), intent(in) :: initial_state_option
type(tracer_type), intent(inout), dimension(:) :: tracer_attributes
real,    intent(in) :: reference_sea_level_press
logical, intent(in) :: triang_trunc, use_virtual_temperature
character(len=*), intent(in) :: vert_coord_option, vert_difference_option
real,    intent(in) :: scale_heights, surf_res, p_press, p_sigma, exponent, ocean_topog_smoothing
real,    intent(out), dimension(:)       :: pk, bk
complex, intent(out), dimension(:,:,:)   :: vors, divs, ts
complex, intent(out), dimension(:,:  )   :: ln_ps
real,    intent(out), dimension(:,:,:)   :: ug, vg, tg
real,    intent(out), dimension(:,:  )   :: psg
real,    intent(out), dimension(:,:,:)   :: vorg, divg
real,    intent(out), dimension(:,:,:,:) :: grid_tracers
real,    intent(out), dimension(:,:  )   :: surf_geopotential
logical, optional, intent(in), dimension(:,:) :: ocean_mask

integer :: unit, ierr, io

!------------------------------------------------------------------------------------------------

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=spectral_init_cond_nml, iostat=io)
    ierr = check_nml_error(io, 'spectral_init_cond_nml')
#else
    unit = open_namelist_file()
    ierr=1
    do while (ierr /= 0)
      read(unit, nml=spectral_init_cond_nml, iostat=io, end=20)
      ierr = check_nml_error (io, 'spectral_init_cond_nml')
    enddo
20  call close_file (unit)
#endif
call write_version_number(version, tagname)
if(mpp_pe() == mpp_root_pe()) write (stdlog(), nml=spectral_init_cond_nml)

call compute_vert_coord(vert_coord_option, scale_heights, surf_res, exponent, p_press, p_sigma, reference_sea_level_press, pk,bk)

call get_topography(topography_option, ocean_topog_smoothing, surf_geopotential, ocean_mask)
call press_and_geopot_init(pk, bk, use_virtual_temperature, vert_difference_option)

if(initial_state_option == 'quiescent') then
  call spectral_initialize_fields(reference_sea_level_press, triang_trunc, initial_temperature, &
                  surf_geopotential, ln_ps, vors, divs, ts, psg, ug, vg, tg, vorg, divg)
else if(initial_state_option == 'input') then
  call ic_from_external_file(triang_trunc, tracer_attributes, vors, divs, ts, ln_ps, ug, &
                             vg, tg, psg, vorg, divg, grid_tracers)
endif

call check_vert_coord(size(ug,3), psg)

return
end subroutine spectral_init_cond

!================================================================================

subroutine check_vert_coord(num_levels, psg)
integer, intent(in) :: num_levels
real, intent(in), dimension(:,:) :: psg
real, dimension(size(psg,1), size(psg,2), num_levels  ) :: p_full, ln_p_full
real, dimension(size(psg,1), size(psg,2), num_levels+1) :: p_half, ln_p_half
integer :: i,j,k

call pressure_variables(p_half, ln_p_half, p_full, ln_p_full, psg)
do k=1,size(p_full,3)
  do j=1,size(p_full,2)
    do i=1,size(p_full,1)
      if(p_half(i,j,k+1) < p_half(i,j,k)) then
        call error_mesg('check_vert_coord','Pressure levels intersect.',FATAL)
      endif
    enddo
  enddo
enddo

return
end subroutine check_vert_coord
!================================================================================

subroutine get_topography(topography_option, ocean_topog_smoothing, surf_geopotential, ocean_mask_in)

character(len=*), intent(in) :: topography_option
real,    intent(in) :: ocean_topog_smoothing
real,    intent(out), dimension(:,:) :: surf_geopotential
logical, intent(in), optional, dimension(:,:) :: ocean_mask_in
real,    dimension(size(surf_geopotential,1)  ) :: deg_lon
real,    dimension(size(surf_geopotential,2)  ) :: deg_lat
real,    dimension(size(surf_geopotential,1),size(surf_geopotential,2)) :: surf_height
logical, dimension(size(surf_geopotential,1),size(surf_geopotential,2)) :: ocean_mask
complex, allocatable, dimension(:,:) :: spec_tmp
real :: fraction_smoothed, lambda
integer :: is, ie, js, je, ms, me, ns, ne, global_num_lon, global_num_lat
real, allocatable, dimension(:) :: blon, blat
logical :: topo_file_exists, water_file_exists
integer, dimension(4) :: siz
character(len=12) :: ctmp1='     by     ', ctmp2='     by     '

if(trim(topography_option) == 'flat') then
   surf_geopotential = 0.

else if(trim(topography_option) == 'input') then
   if(file_exist(trim(topog_file_name))) then
     call mpp_get_global_domain(grid_domain, xsize=global_num_lon, ysize=global_num_lat) 
     call field_size(trim(topog_file_name), trim(topog_field_name), siz)
     if ( siz(1) == global_num_lon .or. siz(2) == global_num_lat ) then
       call read_data(trim(topog_file_name), trim(topog_field_name), surf_height, grid_domain)
     else
       write(ctmp1(1: 4),'(i4)') siz(1)
       write(ctmp1(9:12),'(i4)') siz(2)
       write(ctmp2(1: 4),'(i4)') global_num_lon
       write(ctmp2(9:12),'(i4)') global_num_lat
       call error_mesg ('get_topography','Topography file contains data on a '// &
              ctmp1//' grid, but atmos model grid is '//ctmp2, FATAL)
     endif

!    Spectrally truncate the topography
     call get_spec_domain(ms, me, ns, ne)
     allocate(spec_tmp(ms:me, ns:ne))
     call trans_grid_to_spherical(surf_height,spec_tmp)
     call trans_spherical_to_grid(spec_tmp,surf_height)
     deallocate(spec_tmp)
     surf_geopotential = grav*surf_height
   else
     call error_mesg('get_topography','topography_option="'//trim(topography_option)//'"'// &
                     ' but trim(topog_file_name) does not exist', FATAL)
   endif

else if(trim(topography_option) == 'interpolated') then

!  Get realistic topography
   call get_grid_domain(is, ie, js, je)
   allocate(blon(is:ie+1), blat(js:je+1))
   call get_grid_boundaries(blon, blat)
   topo_file_exists = get_topog_mean(blon, blat, surf_height)
   if(.not.topo_file_exists) then
     call error_mesg('get_topography','topography_option="'//trim(topography_option)//'"'// &
                     ' but topography data file does not exist', FATAL)
   endif
   surf_geopotential = grav*surf_height

   if(ocean_topog_smoothing == 0.) then
!    Spectrally truncate the realistic topography 
     call get_spec_domain(ms, me, ns, ne)
     allocate(spec_tmp(ms:me, ns:ne))
     call trans_grid_to_spherical(surf_geopotential,spec_tmp)
     call trans_spherical_to_grid(spec_tmp,surf_geopotential)
     deallocate(spec_tmp)
   else
!    Do topography regularization
     if(present(ocean_mask_in)) then
       ocean_mask = ocean_mask_in
     else
       water_file_exists = get_ocean_mask(blon, blat, ocean_mask)
       if(.not.water_file_exists) then
         call error_mesg('get_topography','topography_option="'//trim(topography_option)//'"'// &
                         ' and ocean_mask is not present but water data file does not exist', FATAL)
       endif
     endif
     call compute_lambda(ocean_topog_smoothing, ocean_mask, surf_geopotential, lambda, fraction_smoothed)

!  Note that the array surf_height is used here for the smoothed surf_geopotential,
!  then immediately loaded back into surf_geopotential
     call regularize(lambda, ocean_mask, surf_geopotential, surf_height, fraction_smoothed)
     surf_geopotential = surf_height

     if(mpp_pe() == mpp_root_pe()) then
       print '(/,"Message from subroutine get_topography:")'
       print '("lambda=",1pe16.8,"  fraction_smoothed=",1pe16.8,/)',lambda,fraction_smoothed
     endif
   endif
   deallocate(blon, blat)

else if(trim(topography_option) == 'gaussian') then
   call get_deg_lon(deg_lon)
   call get_deg_lat(deg_lat)
   call gaussian_topog_init(deg_lon*pi/180, deg_lat*pi/180, surf_height)
   surf_geopotential = grav*surf_height
else 
   call error_mesg('get_topography','"'//trim(topography_option)//'" is an invalid value for topography_option.', FATAL)
endif

return
end subroutine get_topography
!=======================================================================================================
subroutine print_chksum(text, vors, divs, ts, ln_ps, ug, vg, tg, psg, vorg, divg, surf_geopotential)
character(len=*), intent(in) :: text
complex, intent(in), dimension(:,:,:) :: vors, divs, ts
complex, intent(in), dimension(:,:  ) :: ln_ps
real,    intent(in), dimension(:,:,:) :: ug, vg, tg, vorg, divg
real,    intent(in), dimension(:,:  ) :: psg, surf_geopotential

integer(kind=kind(ug)) :: chksum_vors, chksum_divs, chksum_ts, chksum_ln_ps, chksum_ug, chksum_vg
integer(kind=kind(ug)) :: chksum_tg, chksum_psg, chksum_vorg, chksum_divg, chksum_surf_geo

if (mpp_pe() == mpp_root_pe()) print '(/,a)',text

chksum_vors    = mpp_chksum(vors)
chksum_divs    = mpp_chksum(divs)
chksum_ts      = mpp_chksum(ts)
chksum_ln_ps   = mpp_chksum(ln_ps)
chksum_ug      = mpp_chksum(ug)
chksum_vg      = mpp_chksum(vg)
chksum_tg      = mpp_chksum(tg)
chksum_psg     = mpp_chksum(psg)
chksum_vorg    = mpp_chksum(vorg)
chksum_divg    = mpp_chksum(divg)
chksum_surf_geo = mpp_chksum(surf_geopotential)

if (mpp_pe() == mpp_root_pe()) then
  print '("mpp_chksum(vors   )=",z17)',chksum_vors
  print '("mpp_chksum(divs   )=",z17)',chksum_divs
  print '("mpp_chksum(ts     )=",z17)',chksum_ts
  print '("mpp_chksum(ln_ps  )=",z17)',chksum_ln_ps
  print '("mpp_chksum(ug     )=",z17)',chksum_ug
  print '("mpp_chksum(vg     )=",z17)',chksum_vg
  print '("mpp_chksum(tg     )=",z17)',chksum_tg
  print '("mpp_chksum(psg    )=",z17)',chksum_psg
  print '("mpp_chksum(vorg   )=",z17)',chksum_vorg
  print '("mpp_chksum(divg   )=",z17)',chksum_divg
  print '("mpp_chksum(surf_geopotential)=",z17)',chksum_surf_geo
endif

return
end subroutine print_chksum
!================================================================================
end module spectral_init_cond_mod

module horiz_interp_bilinear_mod

  ! <CONTACT EMAIL="Zhi.Liang@noaa.gov"> Zhi Liang </CONTACT>

  ! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

  ! <OVERVIEW>
  !   Performs spatial interpolation between grids using bilinear interpolation
  ! </OVERVIEW>

  ! <DESCRIPTION>
  !     This module can interpolate data from regular rectangular grid
  !     to rectangular/tripolar grid. The interpolation scheme is bilinear interpolation.
  !     There is an optional mask field for missing input data.
  !     An optional output mask field may be used in conjunction with
  !     the input mask to show where output data exists.
  ! </DESCRIPTION>

  use mpp_mod,               only: mpp_error, FATAL, stdout, mpp_pe, mpp_root_pe
  use fms_mod,               only: write_version_number
  use constants_mod,         only: PI
  use horiz_interp_type_mod, only: horiz_interp_type, stats

  implicit none
  private


  public :: horiz_interp_bilinear_new, horiz_interp_bilinear, horiz_interp_bilinear_del
  public :: horiz_interp_bilinear_init

  !--- public interface
  interface horiz_interp_bilinear_new
    module procedure horiz_interp_bilinear_new_1d
    module procedure horiz_interp_bilinear_new_2d
  end interface


  real, parameter :: epsln=1.e-10
  integer, parameter :: DUMMY = -999

  !-----------------------------------------------------------------------
  character(len=128) :: version = '$Id$'
  character(len=128) :: tagname = '$Name$'
  logical            :: module_is_initialized = .FALSE.

contains

  !#######################################################################
  !  <SUBROUTINE NAME="horiz_interp_bilinear_init">
  !  <OVERVIEW>
  !     writes version number and tag name to logfile.out
  !  </OVERVIEW>
  !  <DESCRIPTION>       
  !     writes version number and tag name to logfile.out
  !  </DESCRIPTION>

  subroutine horiz_interp_bilinear_init

    if(module_is_initialized) return
    call write_version_number (version, tagname)
    module_is_initialized = .true.

  end subroutine horiz_interp_bilinear_init

  !  </SUBROUTINE>

  !########################################################################

  subroutine horiz_interp_bilinear_new_1d ( Interp, lon_in, lat_in, lon_out, lat_out, &
       verbose, src_modulo )

    !-----------------------------------------------------------------------
    type(horiz_interp_type), intent(inout) :: Interp
    real, intent(in),  dimension(:)        :: lon_in , lat_in
    real, intent(in),  dimension(:,:)      :: lon_out, lat_out
    integer, intent(in),          optional :: verbose
    logical, intent(in),          optional :: src_modulo

    logical :: src_is_modulo
    integer :: nlon_in, nlat_in, nlon_out, nlat_out, n, m
    integer :: ie, is, je, js, ln_err, lt_err, warns, unit
    real    :: wtw, wte, wts, wtn, lon, lat, tpi, hpi
    real    :: glt_min, glt_max, gln_min, gln_max, min_lon, max_lon

    warns = 0
    if(present(verbose)) warns = verbose
    src_is_modulo = .true. 
    if (present(src_modulo)) src_is_modulo = src_modulo

    hpi = 0.5*pi
    tpi = 4.0*hpi
    glt_min = hpi
    glt_max = -hpi
    gln_min = tpi
    gln_max = -tpi
    min_lon = 0.0
    max_lon = tpi
    ln_err = 0
    lt_err = 0
    !-----------------------------------------------------------------------

    allocate ( Interp % wti (size(lon_out,1),size(lon_out,2),2),   &
               Interp % wtj (size(lon_out,1),size(lon_out,2),2),   &
               Interp % i_lon (size(lon_out,1),size(lon_out,2),2), &
               Interp % j_lat (size(lon_out,1),size(lon_out,2),2))
    !-----------------------------------------------------------------------

    nlon_in = size(lon_in(:))  ; nlat_in = size(lat_in(:))
    nlon_out = size(lon_out, 1); nlat_out = size(lon_out, 2)
    Interp%nlon_src = nlon_in;  Interp%nlat_src = nlat_in
    Interp%nlon_dst = nlon_out; Interp%nlat_dst = nlat_out

    if(src_is_modulo) then
       if(lon_in(nlon_in) - lon_in(1) .gt. tpi + epsln) &
            call mpp_error(FATAL,'horiz_interp_bilinear_mod: '// & 
            'The range of source grid longitude should be no larger than tpi')

       if(lon_in(1) .lt. 0.0 .OR. lon_in(nlon_in) > tpi ) then
          min_lon = lon_in(1)
          max_lon = lon_in(nlon_in)
       endif
    endif

    do n = 1, nlat_out
       do m = 1, nlon_out
          lon = lon_out(m,n)
          lat = lat_out(m,n)

          if(src_is_modulo) then
             if(lon .lt. min_lon) then
                lon = lon + tpi
             else if(lon .gt. max_lon) then
                lon = lon - tpi
             endif
          else  ! when the input grid is in not cyclic, the output grid should located inside
             ! the input grid
             if((lon .lt. lon_in(1)) .or. (lon .gt. lon_in(nlon_in))) &
                  call mpp_error(FATAL,'horiz_interp_bilinear_mod: ' //&
                  'when input grid is not modulo, output grid should locate inside input grid')
          endif

          glt_min = min(lat,glt_min);  glt_max = max(lat,glt_max)
          gln_min = min(lon,gln_min);  gln_max = max(lon,gln_max)

          is = indp(lon, lon_in ) 
          if( lon_in(is) .gt. lon ) is = max(is-1,1)
          if( lon_in(is) .eq. lon .and. is .eq. nlon_in) is = max(is - 1,1)
          ie = min(is+1,nlon_in)
          if(lon_in(is) .ne. lon_in(ie) .and. lon_in(is) .le. lon) then
             wtw = ( lon_in(ie) - lon) / (lon_in(ie) - lon_in(is) )
          else
             !     east or west of the last data value. this could be because a
             !     cyclic condition is needed or the dataset is too small. 
             ln_err = 1
             ie = 1
             is = nlon_in
             if (lon_in(ie) .ge. lon ) then
                wtw = (lon_in(ie) -lon)/(lon_in(ie)-lon_in(is)+tpi+epsln)
             else
                wtw = (lon_in(ie) -lon+tpi+epsln)/(lon_in(ie)-lon_in(is)+tpi+epsln)
             endif
          endif
          wte = 1. - wtw

          js = indp(lat, lat_in ) 

          if( lat_in(js) .gt. lat ) js = max(js - 1, 1)
          if( lat_in(js) .eq. lat .and. js .eq. nlat_in) js = max(js - 1, 1)
          je = min(js + 1, nlat_in)

          if ( lat_in(js) .ne. lat_in(je) .and. lat_in(js) .le. lat) then
             wts = ( lat_in(je) - lat )/(lat_in(je)-lat_in(js))
          else
             !     north or south of the last data value. this could be because a
             !     pole is not included in the data set or the dataset is too small.
             !     in either case extrapolate north or south
             lt_err = 1
             wts = 1.
          endif

          wtn = 1. - wts

          Interp % i_lon (m,n,1) = is; Interp % i_lon (m,n,2) = ie
          Interp % j_lat (m,n,1) = js; Interp % j_lat (m,n,2) = je
          Interp % wti   (m,n,1) = wtw
          Interp % wti   (m,n,2) = wte
          Interp % wtj   (m,n,1) = wts
          Interp % wtj   (m,n,2) = wtn

       enddo
    enddo

    unit = stdout()

    if (ln_err .eq. 1 .and. warns > 0) then
       write (unit,'(/,(1x,a))')                                      &
            '==> Warning: the geographic data set does not extend far   ', &
            '             enough east or west - a cyclic boundary       ', &
            '             condition was applied. check if appropriate   '
       write (unit,'(/,(1x,a,2f8.4))')                                &
            '    data required between longitudes:', gln_min, gln_max,     &
            '      data set is between longitudes:', lon_in(1), lon_in(nlon_in)
       warns = warns - 1
    endif

    if (lt_err .eq. 1 .and. warns > 0) then
       write (unit,'(/,(1x,a))')                                     &
            '==> Warning: the geographic data set does not extend far   ',&
            '             enough north or south - extrapolation from    ',&
            '             the nearest data was applied. this may create ',&
            '             artificial gradients near a geographic pole   ' 
       write (unit,'(/,(1x,a,2f8.4))')                             &
            '    data required between latitudes:', glt_min, glt_max,   &
            '      data set is between latitudes:', lat_in(1), lat_in(nlat_in)
    endif

    return

  end subroutine horiz_interp_bilinear_new_1d

  !#######################################################################
  ! <SUBROUTINE NAME="horiz_interp_bilinear_new">

  !   <OVERVIEW>
  !      Initialization routine.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !      Allocates space and initializes a derived-type variable
  !      that contains pre-computed interpolation indices and weights.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call horiz_interp_bilinear_new ( Interp, lon_in, lat_in, lon_out, lat_out, verbose, src_modulo )

  !   </TEMPLATE>
  !   
  !   <IN NAME="lon_in" TYPE="real, dimension(:,:)" UNITS="radians">
  !      Longitude (in radians) for source data grid. 
  !   </IN>

  !   <IN NAME="lat_in" TYPE="real, dimension(:,:)" UNITS="radians">
  !      Latitude (in radians) for source data grid.
  !   </IN>

  !   <IN NAME="lon_out" TYPE="real, dimension(:,:)" UNITS="radians" >
  !      Longitude (in radians) for source data grid. 
  !   </IN>

  !   <IN NAME="lat_out" TYPE="real, dimension(:,:)" UNITS="radians" >
  !      Latitude (in radians) for source data grid. 
  !   </IN>

  !   <IN NAME="src_modulo" TYPE="logical, optional">
  !      logical variable to indicate if the boundary condition along zonal boundary
  !      is cyclic or not. When true, the zonal boundary condition is cyclic.
  !   </IN>

  !   <IN NAME="verbose" TYPE="integer, optional" >
  !      flag for the amount of print output.
  !   </IN>

  !   <INOUT NAME="Interp" TYPE="type(horiz_interp_type)" >
  !      A derived-type variable containing indices and weights used for subsequent 
  !      interpolations. To reinitialize this variable for a different grid-to-grid 
  !      interpolation you must first use the "horiz_interp_del" interface.
  !   </INOUT>

  subroutine horiz_interp_bilinear_new_2d ( Interp, lon_in, lat_in, lon_out, lat_out, &
       verbose, src_modulo, new_search, no_crash_when_not_found )

    !-----------------------------------------------------------------------
    type(horiz_interp_type), intent(inout) :: Interp
    real, intent(in),  dimension(:,:)      :: lon_in , lat_in
    real, intent(in),  dimension(:,:)      :: lon_out, lat_out
    integer, intent(in),          optional :: verbose
    logical, intent(in),          optional :: src_modulo
    logical, intent(in),          optional :: new_search
    logical, intent(in),          optional :: no_crash_when_not_found
    integer                                :: warns 
    logical                                :: src_is_modulo
    integer                                :: nlon_in, nlat_in, nlon_out, nlat_out
    integer                                :: m, n, is, ie, js, je, num_solution
    real                                   :: lon, lat, quadra, x, y, y1, y2
    real                                   :: a1, b1, c1, d1, a2, b2, c2, d2, a, b, c
    real                                   :: lon1, lat1, lon2, lat2, lon3, lat3, lon4, lat4
    real                                   :: tpi, lon_min, lon_max
    real                                   :: epsln2
    logical                                :: use_new_search, no_crash

    tpi = 2.0*pi

    warns = 0
    if(present(verbose)) warns = verbose
    src_is_modulo = .true. 
    if (present(src_modulo)) src_is_modulo = src_modulo
    use_new_search = .false.
    if (present(new_search)) use_new_search = new_search
    no_crash = .false.
    if(present(no_crash_when_not_found)) no_crash = no_crash_when_not_found

    ! make sure lon and lat has the same dimension
    if(size(lon_out,1) /= size(lat_out,1) .or. size(lon_out,2) /= size(lat_out,2) ) &
         call mpp_error(FATAL,'horiz_interp_bilinear_mod: when using bilinear ' // &
         'interplation, the output grids should be geographical grids')    

    if(size(lon_in,1) /= size(lat_in,1) .or. size(lon_in,2) /= size(lat_in,2) ) &
         call mpp_error(FATAL,'horiz_interp_bilinear_mod: when using bilinear '// &
         'interplation, the input grids should be geographical grids')  

    !--- get the grid size 
    nlon_in  = size(lon_in,1) ; nlat_in  = size(lat_in,2)
    nlon_out = size(lon_out,1); nlat_out = size(lon_out,2)
    Interp%nlon_src = nlon_in;  Interp%nlat_src = nlat_in
    Interp%nlon_dst = nlon_out; Interp%nlat_dst = nlat_out

    allocate ( Interp % wti (size(lon_out,1),size(lon_out,2),2),   &
               Interp % wtj (size(lon_out,1),size(lon_out,2),2),   &
               Interp % i_lon (size(lon_out,1),size(lon_out,2),2), &
               Interp % j_lat (size(lon_out,1),size(lon_out,2),2))

    !--- first fine the neighbor points for the destination points.
    if(use_new_search) then
       epsln2 = epsln*1e5
       call find_neighbor_new(Interp, lon_in, lat_in, lon_out, lat_out, src_is_modulo, no_crash)
    else
       epsln2 = epsln
       call find_neighbor(Interp, lon_in, lat_in, lon_out, lat_out, src_is_modulo)
    endif

    !***************************************************************************
    !         Algorithm explanation (from disscussion with Steve Garner )      *
    !                                                                          *
    !    lon(x,y) = a1*x + b1*y + c1*x*y + d1         (1)                      *
    !    lat(x,y) = a2*x + b2*y + c2*x*y + d2         (2)                      *
    !    f (x,y) = a3*x + b3*y + c3*x*y + d3          (3)                      *
    !    with x and y is between 0 and 1.                                      *
    !    lon1 = lon(0,0) = d1,          lat1 = lat(0,0) = d2                   *
    !    lon2 = lon(1,0) = a1+d1,       lat2 = lat(1,0) = a2+d2                *
    !    lon3 = lon(1,1) = a1+b1+c1+d1, lat3 = lat(1,1) = a2+b2+c2+d2          *
    !    lon4 = lon(0,1) = b1+d1,       lat4 = lat(0,1) = b2+d2                *
    !    where (lon1,lat1),(lon2,lat2),(lon3,lat3),(lon4,lat4) represents      *
    !    the four corners starting from the left lower corner of grid box      *
    !    that encloses a destination grid ( the rotation direction is          *
    !    counterclockwise ). With these conditions, we get                     *
    !    a1 = lon2-lon1,           a2 = lat2-lat1                              *
    !    b1 = lon4-lon1,           b2 = lat4-lat1                              *
    !    c1 = lon3-lon2-lon4+lon1, c2 = lat3-lat2-lat4+lat1                    *
    !    d1 = lon1                 d2 = lat1                                   *
    !    So given any point (lon,lat), from equation (1) and (2) we can        *
    !    solve (x,y).                                                          *
    !    From equation (3)                                                     *
    !    f1 = f(0,0) = d3,          f2 = f(1,0) = a3+d3                        *
    !    f3 = f(1,1) = a3+b3+c3+d3, f4 = f(0,1) = b3+d3                        *
    !    we obtain                                                             *
    !    a3 = f2-f1,       b3 = f4-f1                                          *
    !    c3 = f3-f2-f4+f1, d3 = f1                                             *
    !    at point (lon,lat) ---> (x,y)                                         *
    !    f(x,y) = (f2-f1)x + (f4-f1)y + (f3-f2-f4+f1)xy + f1                   *
    !           = f1*(1-x)*(1-y) + f2*x*(1-y) + f3*x*y + f4*y*(1-x)            *
    !    wtw=1-x; wte=x; wts=1-y; xtn=y                                        *
    !                                                                          *
    !***************************************************************************

    lon_min = minval(lon_in);
    lon_max = maxval(lon_in);
    !--- calculate the weight
    do n = 1, nlat_out
       do m = 1, nlon_out
          lon = lon_out(m,n)
          lat = lat_out(m,n)
          if(lon .lt. lon_min) then
             lon = lon + tpi
          else if(lon .gt. lon_max) then
             lon = lon - tpi
          endif
          is = Interp%i_lon(m,n,1); ie = Interp%i_lon(m,n,2)
          js = Interp%j_lat(m,n,1); je = Interp%j_lat(m,n,2)
          if( is == DUMMY) cycle
          lon1 = lon_in(is,js); lat1 = lat_in(is,js);
          lon2 = lon_in(ie,js); lat2 = lat_in(ie,js);
          lon3 = lon_in(ie,je); lat3 = lat_in(ie,je);
          lon4 = lon_in(is,je); lat4 = lat_in(is,je); 
          if(lon .lt. lon_min) then
             lon1 = lon1 -tpi; lon4 = lon4 - tpi
          else if(lon .gt. lon_max) then
             lon2 = lon2 +tpi; lon3 = lon3 + tpi
          endif                      
          a1 = lon2-lon1
          b1 = lon4-lon1
          c1 = lon1+lon3-lon4-lon2
          d1 = lon1
          a2 = lat2-lat1
          b2 = lat4-lat1
          c2 = lat1+lat3-lat4-lat2
          d2 = lat1
          !--- the coefficient of the quadratic equation
          a  = b2*c1-b1*c2
          b  = a1*b2-a2*b1+c1*d2-c2*d1+c2*lon-c1*lat
          c  = a2*lon-a1*lat+a1*d2-a2*d1
          quadra = b*b-4.*a*c
          if(abs(quadra) < epsln) quadra = 0.0
          if(quadra < 0.0) call mpp_error(FATAL, &
               "horiz_interp_bilinear_mod: No solution existed for this quadratic equation")
          if ( abs(a) .lt. epsln2) then  ! a = 0 is a linear equation
             if( abs(b) .lt. epsln) call mpp_error(FATAL, &
                  "horiz_interp_bilinear_mod: no unique solution existed for this linear equation")
             y = -c/b
          else
             y1 = 0.5*(-b+sqrt(quadra))/a
             y2 = 0.5*(-b-sqrt(quadra))/a
             if(abs(y1) < epsln2) y1 = 0.0
             if(abs(y2) < epsln2) y2 = 0.0
             if(abs(1.0-y1) < epsln2) y1 = 1.0
             if(abs(1.0-y2) < epsln2) y2 = 1.0
             num_solution = 0
             if(y1 >= 0.0 .and. y1 <= 1.0) then
                y = y1
                num_solution = num_solution +1
             endif
             if(y2 >= 0.0 .and. y2 <= 1.0) then
                y = y2
                num_solution = num_solution + 1
             endif
             if(num_solution == 0) then
                call mpp_error(FATAL, "horiz_interp_bilinear_mod: No solution found")
             else if(num_solution == 2) then
                call mpp_error(FATAL, "horiz_interp_bilinear_mod: Two solutions found")
             endif
           endif
           if(abs(a1+c1*y) < epsln) call mpp_error(FATAL, &
               "horiz_interp_bilinear_mod: the denomenator is 0")
           if(abs(y) < epsln2) y = 0.0
           if(abs(1.0-y) < epsln2) y = 1.0
           x = (lon-b1*y-d1)/(a1+c1*y)
           if(abs(x) < epsln2) x = 0.0
           if(abs(1.0-x) < epsln2) x = 1.0
           ! x and y should be between 0 and 1.
           !! Added for ECDA 
           if(use_new_search) then
             if (x < 0.0) x = 0.0 ! snz
             if (y < 0.0) y = 0.0 ! snz
             if (x > 1.0) x = 1.0
             if (y > 1.0) y = 1.0
           endif 
           if( x>1. .or. x<0. .or. y>1. .or. y < 0.) call mpp_error(FATAL, &
                "horiz_interp_bilinear_mod: weight should be between 0 and 1")
           Interp % wti(m,n,1)=1.0-x; Interp % wti(m,n,2)=x   
           Interp % wtj(m,n,1)=1.0-y; Interp % wtj(m,n,2)=y          
       enddo
    enddo

  end subroutine horiz_interp_bilinear_new_2d
  ! </SUBROUTINE>

  !#######################################################################
  ! this routine will search the source grid to fine the grid box that encloses 
  ! each destination grid.
  subroutine find_neighbor( Interp, lon_in, lat_in, lon_out, lat_out, src_modulo )
    type(horiz_interp_type), intent(inout) :: Interp
    real, intent(in),       dimension(:,:) :: lon_in , lat_in
    real, intent(in),       dimension(:,:) :: lon_out, lat_out
    logical,                 intent(in)    :: src_modulo
    integer                                :: nlon_in, nlat_in, nlon_out, nlat_out
    integer                                :: max_step, n, m, l, i, j, ip1, jp1, step
    integer                                :: is, js, jstart, jend, istart, iend, npts
    integer, allocatable, dimension(:)     :: ilon, jlat
    real                                   :: lon_min, lon_max, lon, lat, tpi
    logical                                :: found
    real                                   :: lon1, lat1, lon2, lat2, lon3, lat3, lon4, lat4

    tpi = 2.0*pi
    nlon_in  = size(lon_in,1) ; nlat_in  = size(lat_in,2)
    nlon_out = size(lon_out,1); nlat_out = size(lon_out,2)

    lon_min = minval(lon_in);
    lon_max = maxval(lon_in);

    max_step = min(nlon_in,nlat_in)/2 ! can be adjusted if needed
    allocate(ilon(8*max_step), jlat(8*max_step) )

    do n = 1, nlat_out
       do m = 1, nlon_out
          found = .false.
          lon = lon_out(m,n)
          lat = lat_out(m,n)

          if(src_modulo) then
             if(lon .lt. lon_min) then
                lon = lon + tpi
             else if(lon .gt. lon_max) then
                lon = lon - tpi
             endif
          else
             if(lon .lt. lon_min .or. lon .gt. lon_max ) &
             call mpp_error(FATAL,'horiz_interp_bilinear_mod: ' //&
                  'when input grid is not modulo, output grid should locate inside input grid')
          endif
          !--- search for the surrounding four points locatioon.
          if(m==1 .and. n==1) then
             J_LOOP: do j = 1, nlat_in-1
                do i = 1, nlon_in
                   ip1 = i+1
                   jp1 = j+1
                   if(i==nlon_in) then
                      if(src_modulo)then
                         ip1 = 1
                      else
                         cycle
                      endif
                   endif
                   lon1 = lon_in(i,  j);   lat1 = lat_in(i,j)
                   lon2 = lon_in(ip1,j);   lat2 = lat_in(ip1,j)
                   lon3 = lon_in(ip1,jp1); lat3 = lat_in(ip1,jp1)
                   lon4 = lon_in(i,  jp1); lat4 = lat_in(i,  jp1)  

                   if(lon .lt. lon_min .or. lon .gt. lon_max) then
                      if(i .ne. nlon_in) then
                         cycle
                      else
                         if(lon .lt. lon_min) then
                             lon1 = lon1 -tpi; lon4 = lon4 - tpi
                         else if(lon .gt. lon_max) then
                             lon2 = lon2 +tpi; lon3 = lon3 + tpi
                         endif
                      endif
                   endif

                   if(lat .ge. intersect(lon1,lat1,lon2,lat2,lon))then ! south
                      if(lon .le. intersect(lat2,lon2,lat3,lon3,lat))then ! east
                         if(lat .le. intersect(lon3,lat3,lon4,lat4,lon))then ! north
                            if(lon .ge. intersect(lat4,lon4,lat1,lon1,lat))then  ! west
                               found = .true.
                               Interp % i_lon (m,n,1) = i; Interp % i_lon (m,n,2) = ip1
                               Interp % j_lat (m,n,1) = j; Interp % j_lat (m,n,2) = jp1
                               exit J_LOOP
                            endif
                         endif
                      endif
                   endif
                enddo
             enddo J_LOOP
          else
             step = 0
             do while ( .not. found .and. step .lt. max_step )
                !--- take the adajcent point as the starting point
                if(m == 1) then
                   is = Interp % i_lon (m,n-1,1)
                   js = Interp % j_lat (m,n-1,1)
                else
                   is = Interp % i_lon (m-1,n,1)
                   js = Interp % j_lat (m-1,n,1)
                endif
                if(step==0) then
                   npts = 1
                   ilon(1) = is
                   jlat(1) = js
                else
                   npts = 0
                   !--- bottom and top boundary
                   jstart = max(js-step,1)
                   jend   = min(js+step,nlat_in)

                   do l = -step, step
                      i = is+l
                      if(src_modulo)then
                         if( i < 1) then
                            i = i + nlon_in
                         else if (i > nlon_in) then
                            i = i - nlon_in
                         endif
                         if( i < 1 .or. i > nlon_in) call mpp_error(FATAL, &
                              'horiz_interp_bilinear_mod: max_step is too big, decrease max_step' )
                      else
                         if( i < 1 .or. i > nlon_in) cycle
                      endif

                      npts       = npts + 1
                      ilon(npts) = i
                      jlat(npts) = jstart
                      npts       = npts + 1
                      ilon(npts) = i
                      jlat(npts) = jend                         
                   enddo

                   !--- right and left boundary -----------------------------------------------
                   istart = is - step
                   iend   = is + step
                   if(src_modulo) then
                      if( istart < 1)       istart = istart + nlon_in
                      if( iend   > nlon_in) iend   = iend   - nlon_in
                   else 
                      istart = max(istart,1)
                      iend   = min(iend, nlon_in)
                   endif
                   do l = -step, step
                      j = js+l
                         if( j < 1 .or. j > nlat_in) cycle
                         npts = npts+1
                         ilon(npts) = istart
                         jlat(npts) = j
                         npts = npts+1
                         ilon(npts) = iend
                         jlat(npts) = j
                  end do
                end if

                !--- find the surrouding points             
                do l = 1, npts
                   i = ilon(l)
                   j = jlat(l)
                   ip1 = i+1
                   if(ip1>nlon_in) then
                      if(src_modulo) then
                         ip1 = 1
                      else
                         cycle
                      endif
                   endif
                   jp1 = j+1
                   if(jp1>nlat_in) cycle
                   lon1 = lon_in(i,  j);   lat1 = lat_in(i,j)
                   lon2 = lon_in(ip1,j);   lat2 = lat_in(ip1,j)
                   lon3 = lon_in(ip1,jp1); lat3 = lat_in(ip1,jp1)
                   lon4 = lon_in(i,  jp1); lat4 = lat_in(i,  jp1)  

                   if(lon .lt. lon_min .or. lon .gt. lon_max) then
                      if(i .ne. nlon_in) then
                         cycle
                      else
                         if(lon .lt. lon_min) then
                             lon1 = lon1 -tpi; lon4 = lon4 - tpi
                         else if(lon .gt. lon_max) then
                             lon2 = lon2 +tpi; lon3 = lon3 + tpi
                         endif
                      endif
                   endif

                   if(lat .ge. intersect(lon1,lat1,lon2,lat2,lon))then ! south
                      if(lon .le. intersect(lat2,lon2,lat3,lon3,lat))then ! east
                         if(lat .le. intersect(lon3,lat3,lon4,lat4,lon))then !north
                            if(lon .ge. intersect(lat4,lon4,lat1,lon1,lat))then ! west
                               found = .true.
                               is=i; js=j  
                               Interp % i_lon (m,n,1) = i; Interp % i_lon (m,n,2) = ip1
                               Interp % j_lat (m,n,1) = j; Interp % j_lat (m,n,2) = jp1
                               exit
                            endif
                         endif
                      endif
                   endif
                enddo
                step = step + 1
             enddo
          endif
          if(.not.found) then
             call mpp_error(FATAL, &
                  'horiz_interp_bilinear_mod: the destination point is not inside the source grid' )
          endif
       enddo
    enddo

  end subroutine find_neighbor

  !#######################################################################
  ! 
  ! The function will return true if the point x,y is inside a polygon, or
  ! NO if it is not.  If the point is exactly on the edge of a polygon,
  ! the function will return .true.
  !
  ! real polyx(:) : longitude coordinates of corners 
  ! real polyx(:) : latitude  coordinates of corners
  ! real x,y      : point to be tested 
  ! ??? How to deal with truncation error.
  !
  function inside_polygon(polyx, polyy, x, y)
     real, dimension(:), intent(in) :: polyx, polyy
     real,               intent(in) :: x, y
     logical                        :: inside_polygon
     integer                        :: i, j, nedges
     real                           :: xx

     inside_polygon = .false.
     nedges = size(polyx(:))
     j = nedges
     do i = 1, nedges
        if( (polyy(i) < y .AND. polyy(j) >= y) .OR. (polyy(j) < y .AND. polyy(i) >= y) ) then
           xx = polyx(i)+(y-polyy(i))/(polyy(j)-polyy(i))*(polyx(j)-polyx(i))
           if( xx == x ) then
             inside_polygon = .true.
             return
           else if( xx < x ) then
             inside_polygon = .not. inside_polygon
           endif
        endif
        j = i
     enddo

     return

  end function inside_polygon

  !#######################################################################
  ! this routine will search the source grid to fine the grid box that encloses 
  ! each destination grid.
  subroutine find_neighbor_new( Interp, lon_in, lat_in, lon_out, lat_out, src_modulo, no_crash )
    type(horiz_interp_type), intent(inout) :: Interp
    real, intent(in),       dimension(:,:) :: lon_in , lat_in
    real, intent(in),       dimension(:,:) :: lon_out, lat_out
    logical,                 intent(in)    :: src_modulo, no_crash
    integer                                :: nlon_in, nlat_in, nlon_out, nlat_out
    integer                                :: max_step, n, m, l, i, j, ip1, jp1, step
    integer                                :: is, js, jstart, jend, istart, iend, npts
    integer, allocatable, dimension(:)     :: ilon, jlat
    real                                   :: lon_min, lon_max, lon, lat, tpi
    logical                                :: found
    real                                   :: polyx(4), polyy(4)
    real                                   :: min_lon, min_lat, max_lon, max_lat    

    tpi = 2.0*pi
    nlon_in  = size(lon_in,1) ; nlat_in  = size(lat_in,2)
    nlon_out = size(lon_out,1); nlat_out = size(lon_out,2)

    lon_min = minval(lon_in);
    lon_max = maxval(lon_in);

    max_step = min(nlon_in,nlat_in)/2 ! can be adjusted if needed
    allocate(ilon(8*max_step), jlat(8*max_step) )

    do n = 1, nlat_out
       do m = 1, nlon_out
          found = .false.
          lon = lon_out(m,n)
          lat = lat_out(m,n)

          if(src_modulo) then
             if(lon .lt. lon_min) then
                lon = lon + tpi
             else if(lon .gt. lon_max) then
                lon = lon - tpi
             endif
          else
             if(lon .lt. lon_min .or. lon .gt. lon_max ) &
             call mpp_error(FATAL,'horiz_interp_bilinear_mod: ' //&
                  'when input grid is not modulo, output grid should locate inside input grid')
          endif
          !--- search for the surrounding four points locatioon.
          if(m==1 .and. n==1) then
             J_LOOP: do j = 1, nlat_in-1
                do i = 1, nlon_in
                   ip1 = i+1
                   jp1 = j+1
                   if(i==nlon_in) then
                      if(src_modulo)then
                         ip1 = 1
                      else
                         cycle
                      endif
                   endif
                   
                   polyx(1) = lon_in(i,  j);   polyy(1) = lat_in(i,j)
                   polyx(2) = lon_in(ip1,j);   polyy(2) = lat_in(ip1,j)
                   polyx(3) = lon_in(ip1,jp1); polyy(3) = lat_in(ip1,jp1)
                   polyx(4) = lon_in(i,  jp1); polyy(4) = lat_in(i,  jp1) 
                   if(lon .lt. lon_min .or. lon .gt. lon_max) then
                      if(i .ne. nlon_in) then
                         cycle
                      else
                         if(lon .lt. lon_min) then
                             polyx(1) = polyx(1) -tpi; polyx(4) = polyx(4) - tpi
                         else if(lon .gt. lon_max) then
                             polyx(2) = polyx(2) +tpi; polyx(3) = polyx(3) + tpi
                         endif
                      endif
                   endif
 
                   min_lon = minval(polyx)
                   max_lon = maxval(polyx)
                   min_lat = minval(polyy)
                   max_lat = maxval(polyy)
!                   if( lon .GE. min_lon .AND. lon .LE. max_lon .AND. &
!                       lat .GE. min_lat .AND. lat .LE. max_lat ) then
!                      print*, 'i =', i, 'j = ', j
!                      print '(5f15.11)', lon, polyx
!                      print '(5f15.11)', lat, polyy    
!                   endif 

                   if(inside_polygon(polyx, polyy, lon, lat)) then
                      found = .true.
!                      print*, " found ", i, j
                      Interp % i_lon (m,n,1) = i; Interp % i_lon (m,n,2) = ip1
                      Interp % j_lat (m,n,1) = j; Interp % j_lat (m,n,2) = jp1
                      exit J_LOOP
                   endif
                enddo
             enddo J_LOOP
          else
             step = 0
             do while ( .not. found .and. step .lt. max_step )
                !--- take the adajcent point as the starting point
                if(m == 1) then
                   is = Interp % i_lon (m,n-1,1)
                   js = Interp % j_lat (m,n-1,1)
                else
                   is = Interp % i_lon (m-1,n,1)
                   js = Interp % j_lat (m-1,n,1)
                endif
                if(step==0) then
                   npts = 1
                   ilon(1) = is
                   jlat(1) = js
                else
                   npts = 0
                   !--- bottom and top boundary
                   jstart = max(js-step,1)
                   jend   = min(js+step,nlat_in)

                   do l = -step, step
                      i = is+l
                      if(src_modulo)then
                         if( i < 1) then
                            i = i + nlon_in
                         else if (i > nlon_in) then
                            i = i - nlon_in
                         endif
                         if( i < 1 .or. i > nlon_in) call mpp_error(FATAL, &
                              'horiz_interp_bilinear_mod: max_step is too big, decrease max_step' )
                      else
                         if( i < 1 .or. i > nlon_in) cycle
                      endif

                      npts       = npts + 1
                      ilon(npts) = i
                      jlat(npts) = jstart
                      npts       = npts + 1
                      ilon(npts) = i
                      jlat(npts) = jend                         
                   enddo

                   !--- right and left boundary -----------------------------------------------
                   istart = is - step
                   iend   = is + step
                   if(src_modulo) then
                      if( istart < 1)       istart = istart + nlon_in
                      if( iend   > nlon_in) iend   = iend   - nlon_in
                   else 
                      istart = max(istart,1)
                      iend   = min(iend, nlon_in)
                   endif
                   do l = -step, step
                      j = js+l
                         if( j < 1 .or. j > nlat_in) cycle
                         npts = npts+1
                         ilon(npts) = istart
                         jlat(npts) = j
                         npts = npts+1
                         ilon(npts) = iend
                         jlat(npts) = j
                  end do
                end if

                !--- find the surrouding points             
                do l = 1, npts
                   i = ilon(l)
                   j = jlat(l)
                   ip1 = i+1
                   if(ip1>nlon_in) then
                      if(src_modulo) then
                         ip1 = 1
                      else
                         cycle
                      endif
                   endif
                   jp1 = j+1
                   if(jp1>nlat_in) cycle
                   polyx(1) = lon_in(i,  j);   polyy(1) = lat_in(i,j)
                   polyx(2) = lon_in(ip1,j);   polyy(2) = lat_in(ip1,j)
                   polyx(3) = lon_in(ip1,jp1); polyy(3) = lat_in(ip1,jp1)
                   polyx(4) = lon_in(i,  jp1); polyy(4) = lat_in(i,  jp1)  
                   if(inside_polygon(polyx, polyy, lon, lat)) then
                      found = .true.
                      Interp % i_lon (m,n,1) = i; Interp % i_lon (m,n,2) = ip1
                      Interp % j_lat (m,n,1) = j; Interp % j_lat (m,n,2) = jp1
                      exit
                   endif
                enddo
                step = step + 1
             enddo
          endif
          if(.not.found) then
             if(no_crash) then
                Interp % i_lon (m,n,1:2) = DUMMY
                Interp % j_lat (m,n,1:2) = DUMMY
                print*,'lon,lat=',lon,lat ! snz
             else
                call mpp_error(FATAL, &
                    'horiz_interp_bilinear_mod: the destination point is not inside the source grid' )
             endif
          endif
       enddo
    enddo

  end subroutine find_neighbor_new

  !#######################################################################
  function intersect(x1, y1, x2, y2, x)
     real, intent(in) :: x1, y1, x2, y2, x
     real             :: intersect

     intersect = (y2-y1)*(x-x1)/(x2-x1) + y1

  return

  end function intersect

  !#######################################################################
  ! <SUBROUTINE NAME="horiz_interp_bilinear">

  !   <OVERVIEW>
  !      Subroutine for performing the horizontal interpolation between two grids.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Subroutine for performing the horizontal interpolation between two grids. 
  !     horiz_interp_bilinear_new must be called before calling this routine.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call horiz_interp_bilinear ( Interp, data_in, data_out, verbose, mask_in,mask_out, missing_value, missing_permit)
  !   </TEMPLATE>
  !   
  !   <IN NAME="Interp" TYPE="type(horiz_interp_type)">
  !     Derived-type variable containing interpolation indices and weights.
  !     Returned by a previous call to horiz_interp_bilinear_new.
  !   </IN>
  !   <IN NAME="data_in" TYPE="real, dimension(:,:)">
  !      Input data on source grid.
  !   </IN>
  !   <IN NAME="verbose" TYPE="integer, optional">
  !      flag for the amount of print output.
  !               verbose = 0, no output; = 1, min,max,means; = 2, still more
  !   </IN>
  !   <IN NAME="mask_in" TYPE="real, dimension(:,:),optional">
  !      Input mask, must be the same size as the input data. The real value of
  !      mask_in must be in the range (0.,1.). Set mask_in=0.0 for data points 
  !      that should not be used or have missing data. 
  !   </IN>
  !   <IN NAME="missing_value" TYPE="real, optional">
  !      Use the missing_value to indicate missing data.
  !   </IN>

  !   <IN NAME="missing_permit" TUPE="integer, optional">
  !      numbers of points allowed to miss for the bilinear interpolation. The value
  !      should be between 0 and 3.
  !   </IN>

  !   <OUT NAME="data_out" TYPE="real, dimension(:,:)">
  !      Output data on destination grid.
  !   </OUT>
  !   <OUT NAME="mask_out" TYPE="real, dimension(:,:),optional">
  !      Output mask that specifies whether data was computed.
  !   </OUT>

  subroutine horiz_interp_bilinear ( Interp, data_in, data_out, verbose, mask_in,mask_out, &
       missing_value, missing_permit, new_handle_missing )
    !-----------------------------------------------------------------------
    type (horiz_interp_type), intent(in)        :: Interp
    real, intent(in),  dimension(:,:)           :: data_in
    real, intent(out), dimension(:,:)           :: data_out
    integer, intent(in),               optional :: verbose
    real, intent(in), dimension(:,:),  optional :: mask_in
    real, intent(out), dimension(:,:), optional :: mask_out
    real, intent(in),                  optional :: missing_value
    integer, intent(in),               optional :: missing_permit
    logical, intent(in),               optional :: new_handle_missing
    !-----------------------------------------------------------------------
    integer :: nlon_in, nlat_in, nlon_out, nlat_out, n, m,         &
         is, ie, js, je, iverbose, max_missing, num_missing, &
         miss_in, miss_out, unit
    real    :: dwtsum, wtsum, min_in, max_in, avg_in, &
         min_out, max_out, avg_out, wtw, wte, wts, wtn
    real    :: mask(size(data_in,1), size(data_in,2) )
    logical :: set_to_missing, is_missing(4), new_handler
    real    :: f1, f2, f3, f4, middle, w, s

    num_missing = 0

    nlon_in  = Interp%nlon_src;  nlat_in  = Interp%nlat_src
    nlon_out = Interp%nlon_dst; nlat_out = Interp%nlat_dst

    if(present(mask_in)) then
       mask = mask_in
    else
       mask = 1.0
    endif

    if (present(verbose)) then
       iverbose = verbose
    else
       iverbose = 0
    endif

    if(present(missing_permit)) then
       max_missing = missing_permit
    else
       max_missing = 0
    endif

    if(present(new_handle_missing)) then
       new_handler = new_handle_missing
    else
       new_handler = .false.
    endif

    if(max_missing .gt. 3 .or. max_missing .lt. 0) call mpp_error(FATAL, &
         'horiz_interp_bilinear_mod: missing_permit should be between 0 and 3')

    if (size(data_in,1) /= nlon_in .or. size(data_in,2) /= nlat_in) &
         call mpp_error(FATAL,'horiz_interp_bilinear_mod: size of input array incorrect')

    if (size(data_out,1) /= nlon_out .or. size(data_out,2) /= nlat_out) &
         call mpp_error(FATAL,'horiz_interp_bilinear_mod: size of output array incorrect')

    if(new_handler) then
       if( .not. present(missing_value) )  call mpp_error(FATAL, &
            "horiz_interp_bilinear_mod: misisng_value must be present when new_handle_missing is .true.")
       if( present(mask_in) ) call mpp_error(FATAL, &
            "horiz_interp_bilinear_mod: mask_in should not be present when new_handle_missing is .true.")
       do n = 1, nlat_out
          do m = 1, nlon_out
             is = Interp % i_lon (m,n,1); ie = Interp % i_lon (m,n,2)
             js = Interp % j_lat (m,n,1); je = Interp % j_lat (m,n,2)
             wtw = Interp % wti   (m,n,1)
             wte = Interp % wti   (m,n,2)
             wts = Interp % wtj   (m,n,1)
             wtn = Interp % wtj   (m,n,2)

             is_missing = .false.
             num_missing = 0
             set_to_missing = .false.
             if(data_in(is,js) == missing_value) then
                num_missing = num_missing+1
                is_missing(1) = .true.
                if(wtw .GE. 0.5 .AND. wts .GE. 0.5) set_to_missing = .true.
             endif

             if(data_in(ie,js) == missing_value) then
                num_missing = num_missing+1
                is_missing(2) = .true.
                if(wte .GE. 0.5 .AND. wts .GE. 0.5) set_to_missing = .true.
             endif
             if(data_in(ie,je) == missing_value) then
                num_missing = num_missing+1
                is_missing(3) = .true.
                if(wte .GE. 0.5 .AND. wtn .GE. 0.5) set_to_missing = .true.
             endif
             if(data_in(is,je) == missing_value) then
                num_missing = num_missing+1
                is_missing(4) = .true.
                if(wtw .GE. 0.5 .AND. wtn .GE. 0.5) set_to_missing = .true.
             endif

             if( num_missing == 4 .OR. set_to_missing ) then
                data_out(m,n) = missing_value
                if(present(mask_out)) mask_out(m,n) = 0.0
                 cycle
             else if(num_missing == 0) then
                f1 = data_in(is,js)
                f2 = data_in(ie,js)
                f3 = data_in(ie,je)
                f4 = data_in(is,je)
                w = wtw
                s = wts
             else if(num_missing == 3) then  !--- three missing value 
                if(.not. is_missing(1) ) then
                   data_out(m,n) = data_in(is,js)
                else if(.not. is_missing(2) ) then
                   data_out(m,n) = data_in(ie,js)
                else if(.not. is_missing(3) ) then
                   data_out(m,n) = data_in(ie,je)
                else if(.not. is_missing(4) ) then
                   data_out(m,n) = data_in(is,je)
                endif
                if(present(mask_out) ) mask_out(m,n) = 1.0
                cycle
             else   !--- one or two missing value
                if( num_missing == 1) then
                   if( is_missing(1) .OR. is_missing(3) ) then
                      middle = 0.5*(data_in(ie,js)+data_in(is,je))
                   else
                      middle = 0.5*(data_in(is,js)+data_in(ie,je))
                   endif
                else ! num_missing = 2
                   if( is_missing(1) .AND. is_missing(2) ) then
                      middle = 0.5*(data_in(ie,je)+data_in(is,je))
                   else if( is_missing(1) .AND. is_missing(3) ) then
                      middle = 0.5*(data_in(ie,js)+data_in(is,je))
                   else if( is_missing(1) .AND. is_missing(4) ) then
                      middle = 0.5*(data_in(ie,js)+data_in(ie,je))
                   else if( is_missing(2) .AND. is_missing(3) ) then
                      middle = 0.5*(data_in(is,js)+data_in(is,je))
                   else if( is_missing(2) .AND. is_missing(4) ) then
                      middle = 0.5*(data_in(is,js)+data_in(ie,je))
                   else if( is_missing(3) .AND. is_missing(4) ) then
                      middle = 0.5*(data_in(is,js)+data_in(ie,js))
                   endif
                endif

                if( wtw .GE. 0.5 .AND. wts .GE. 0.5 ) then  ! zone 1
                   w = 2.0*(wtw-0.5)
                   s = 2.0*(wts-0.5)
                   f1 = data_in(is,js)
                   if(is_missing(2)) then
                      f2 = f1
                   else
                      f2 = 0.5*(data_in(is,js)+data_in(ie,js))
                   endif
                   f3 = middle
                   if(is_missing(4)) then
                      f4 = f1
                   else
                      f4 = 0.5*(data_in(is,js)+data_in(is,je))
                   endif
                else if( wte .GE. 0.5 .AND. wts .GE. 0.5 ) then  ! zone 2
                   w = 2.0*(1.0-wte)
                   s = 2.0*(wts-0.5)
                   f2 = data_in(ie,js)
                   if(is_missing(1)) then
                      f1 = f2
                   else
                      f1 = 0.5*(data_in(is,js)+data_in(ie,js))
                   endif
                   f4 = middle
                   if(is_missing(3)) then
                      f3 = f2
                   else
                      f3 = 0.5*(data_in(ie,js)+data_in(ie,je))
                   endif
                else if( wte .GE. 0.5 .AND. wtn .GE. 0.5 ) then  ! zone 3
                   w = 2.0*(1.0-wte)
                   s = 2.0*(1.0-wtn)
                   f3 = data_in(ie,je)
                   if(is_missing(2)) then
                      f2 = f3
                   else
                      f2 = 0.5*(data_in(ie,js)+data_in(ie,je))
                   endif
                   f1 = middle
                   if(is_missing(4)) then
                      f4 = f3
                   else
                      f4 = 0.5*(data_in(ie,je)+data_in(is,je))
                   endif
                else if( wtw .GE. 0.5 .AND. wtn .GE. 0.5 ) then  ! zone 4
                   w = 2.0*(wtw-0.5)
                   s = 2.0*(1.0-wtn)
                   f4 = data_in(is,je)
                   if(is_missing(1)) then
                      f1 = f4
                   else
                      f1 = 0.5*(data_in(is,js)+data_in(is,je))
                   endif
                   f2 = middle
                   if(is_missing(3)) then
                      f3 = f4
                   else
                      f3 = 0.5*(data_in(ie,je)+data_in(is,je))
                   endif
                else 
                   call mpp_error(FATAL, &
                      "horiz_interp_bilinear_mod: the point should be in one of the four zone")
                endif
             endif

             data_out(m,n) = f3 + (f4-f3)*w + (f2-f3)*s + ((f1-f2)+(f3-f4))*w*s 
            if(present(mask_out)) mask_out(m,n) = 1.0
          enddo
       enddo       
    else
       do n = 1, nlat_out
          do m = 1, nlon_out
             is = Interp % i_lon (m,n,1); ie = Interp % i_lon (m,n,2)
             js = Interp % j_lat (m,n,1); je = Interp % j_lat (m,n,2)
             wtw = Interp % wti   (m,n,1)
             wte = Interp % wti   (m,n,2)
             wts = Interp % wtj   (m,n,1)
             wtn = Interp % wtj   (m,n,2)

             if(present(missing_value) ) then
                num_missing = 0
                if(data_in(is,js) == missing_value) then
                   num_missing = num_missing+1
                   mask(is,js) = 0.0
                endif
                if(data_in(ie,js) == missing_value) then
                   num_missing = num_missing+1
                   mask(ie,js) = 0.0
                endif
                if(data_in(ie,je) == missing_value) then
                   num_missing = num_missing+1
                   mask(ie,je) = 0.0
                endif
                if(data_in(is,je) == missing_value) then
                   num_missing = num_missing+1
                   mask(is,je) = 0.0
                endif
             endif

             dwtsum = data_in(is,js)*mask(is,js)*wtw*wts &
                  + data_in(ie,js)*mask(ie,js)*wte*wts &
                  + data_in(ie,je)*mask(ie,je)*wte*wtn &
                  + data_in(is,je)*mask(is,je)*wtw*wtn 
             wtsum  = mask(is,js)*wtw*wts + mask(ie,js)*wte*wts  &
                  + mask(ie,je)*wte*wtn + mask(is,je)*wtw*wtn

             if(.not. present(mask_in) .and. .not. present(missing_value)) wtsum = 1.0

             if(num_missing .gt. max_missing ) then
                data_out(m,n) = missing_value
                if(present(mask_out)) mask_out(m,n) = 0.0
             else if(wtsum .lt. epsln) then 
                if(present(missing_value)) then
                   data_out(m,n) = missing_value
                else
                   data_out(m,n) = 0.0
                endif
                if(present(mask_out)) mask_out(m,n) = 0.0      
             else
                data_out(m,n) = dwtsum/wtsum
                if(present(mask_out)) mask_out(m,n) = wtsum
             endif
          enddo
       enddo
    endif
    !***********************************************************************
    ! compute statistics: minimum, maximum, and mean
    !-----------------------------------------------------------------------
    if (iverbose > 0) then

       ! compute statistics of input data

       call stats (data_in, min_in, max_in, avg_in, miss_in, missing_value, mask_in)

       ! compute statistics of output data
       call stats (data_out, min_out, max_out, avg_out, miss_out, missing_value, mask_out)

       !---- output statistics ----
       unit = stdout()
       write (unit,900)
       write (unit,901)  min_in ,max_in, avg_in
       if (present(mask_in))  write (unit,903)  miss_in
       write (unit,902)  min_out,max_out,avg_out
       if (present(mask_out)) write (unit,903)  miss_out

900    format (/,1x,10('-'),' output from horiz_interp ',10('-'))
901    format ('  input:  min=',f16.9,'  max=',f16.9,'  avg=',f22.15)
902    format (' output:  min=',f16.9,'  max=',f16.9,'  avg=',f22.15)
903    format ('          number of missing points = ',i6)

    endif

    return

  end subroutine horiz_interp_bilinear
  ! </SUBROUTINE>

  !#######################################################################
  ! <SUBROUTINE NAME="horiz_interp_bilinear_del">

  !   <OVERVIEW>
  !     Deallocates memory used by "horiz_interp_type" variables.
  !     Must be called before reinitializing with horiz_interp_bilinear_new.
  !   </OVERVIEW>
  !   <DESCRIPTION>
  !     Deallocates memory used by "horiz_interp_type" variables.
  !     Must be called before reinitializing with horiz_interp_bilinear_new.
  !   </DESCRIPTION>
  !   <TEMPLATE>
  !     call horiz_interp_bilinear_del ( Interp )
  !   </TEMPLATE>

  !   <INOUT NAME="Interp" TYPE="horiz_interp_type">
  !     A derived-type variable returned by previous call
  !     to horiz_interp_bilinear_new. The input variable must have
  !     allocated arrays. The returned variable will contain
  !     deallocated arrays.
  !   </INOUT>

  subroutine horiz_interp_bilinear_del( Interp )

    type (horiz_interp_type), intent(inout) :: Interp

    if(associated(Interp%wti))   deallocate(Interp%wti)
    if(associated(Interp%wtj))   deallocate(Interp%wtj)
    if(associated(Interp%i_lon)) deallocate(Interp%i_lon)
    if(associated(Interp%j_lat)) deallocate(Interp%j_lat)

  end subroutine horiz_interp_bilinear_del
  ! </SUBROUTINE>

  !#######################################################################

  function indp (value, array)
    integer                        :: indp
    real, dimension(:), intent(in) :: array
    real, intent(in)               :: value
    !
    !=======================================================================
    !
    !     indp = index of nearest data point within "array" corresponding to
    !            "value".

    !     inputs:
    !     value  = arbitrary data...same units as elements in "array"
    !     array  = array of data points  (must be monotonically increasing)

    !     output:
    !     indp =  index of nearest data point to "value"
    !             if "value" is outside the domain of "array" then indp = 1
    !             or "ia" depending on whether array(1) or array(ia) is
    !             closest to "value"
    !=======================================================================
    !
    integer i, ia, unit
    logical keep_going
    !
    ia = size(array(:))
    do i=2,ia
       if (array(i) .lt. array(i-1)) then
          unit = stdout()
          write (unit,*) &
               ' => Error: array must be monotonically increasing in "indp"' , &
               '           when searching for nearest element to value=',value
          write (unit,*) '           array(i) < array(i-1) for i=',i 
          write (unit,*) '           array(i) for i=1..ia follows:'
          call abort()
       endif
    enddo
    if (value .lt. array(1) .or. value .gt. array(ia)) then
       if (value .lt. array(1))  indp = 1
       if (value .gt. array(ia)) indp = ia
    else
       i=1
       keep_going = .true.
       do while (i .le. ia .and. keep_going)
          i = i+1
          if (value .le. array(i)) then
             indp = i
             if (array(i)-value .gt. value-array(i-1)) indp = i-1
             keep_going = .false.
          endif
       enddo
    endif
    return
  end function indp

  !######################################################################

end module horiz_interp_bilinear_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: cosp_constants.F90,v 20.0 2013/12/13 23:15:36 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

!
! History:
! Jul 2007 - A. Bodas-Salcedo - Initial version
! Jul 2008 - A. Bodas-Salcedo - Added definitions of ISCCP axes
! Oct 2008 - H. Chepfer       - Added PARASOL_NREFL
!
! 

MODULE MOD_COSP_CONSTANTS
    IMPLICIT NONE
    
    character(len=32) :: COSP_VERSION='COSP v1.3.1'
    
    ! Indices to address arrays of LS and CONV hydrometeors
    integer,parameter :: I_LSCLIQ = 1
    integer,parameter :: I_LSCICE = 2
    integer,parameter :: I_LSRAIN = 3
    integer,parameter :: I_LSSNOW = 4
    integer,parameter :: I_CVCLIQ = 5
    integer,parameter :: I_CVCICE = 6
    integer,parameter :: I_CVRAIN = 7
    integer,parameter :: I_CVSNOW = 8
    integer,parameter :: I_LSGRPL = 9
    
    ! Missing value
    real,parameter :: R_UNDEF = -1.0E30
    ! Number of possible output variables
    integer,parameter :: N_OUT_LIST = 44
    ! Value for forward model result from a level that is under the ground
    real,parameter :: R_GROUND = -1.0E20
    
    ! Stratiform and convective clouds in frac_out
    integer, parameter :: I_LSC = 1, & ! Large-scale clouds
                          I_CVC = 2    ! Convective clouds
    !--- Radar constants
    ! CFAD constants
    integer,parameter :: DBZE_BINS     =   15   ! Number of dBZe bins in histogram (cfad)
    real,parameter    :: DBZE_MIN      = -100.0 ! Minimum value for radar reflectivity
    real,parameter    :: DBZE_MAX      =   80.0 ! Maximum value for radar reflectivity
    real,parameter    :: CFAD_ZE_MIN   =  -50.0 ! Lower value of the first CFAD Ze bin
    real,parameter    :: CFAD_ZE_WIDTH =    5.0 ! Bin width (dBZe)

   
    !--- Lidar constants
    ! CFAD constants
    integer,parameter :: SR_BINS       =   15
    integer,parameter :: DPOL_BINS     =   6
    real,parameter    :: LIDAR_UNDEF   =   999.999
    ! Other constants
    integer,parameter :: LIDAR_NCAT    =   4
    integer,parameter :: PARASOL_NREFL =   5 ! parasol
    real,parameter,dimension(PARASOL_NREFL) :: PARASOL_SZA = (/0.0, 20.0, 40.0, 60.0, 80.0/)
    real,parameter    :: DEFAULT_LIDAR_REFF = 30.0e-6 ! Default lidar effective radius
    
    !--- MISR constants
    integer,parameter :: MISR_N_CTH = 16

    !--- RTTOV constants
    integer,parameter :: RTTOV_MAX_CHANNELS = 20
    
    ! ISCCP tau-Pc axes
    real,parameter,dimension(7) :: ISCCP_TAU = (/0.15, 0.80, 2.45, 6.5, 16.2, 41.5, 100.0/)
    real,parameter,dimension(2,7) :: ISCCP_TAU_BNDS = reshape(source=(/0.0,0.3,0.3,1.30,1.30,3.6,3.6,9.4, &
                                                      9.4,23.0,23.0,60.0,60.0,100000.0/), shape=(/2,7/))
!     real,parameter,dimension(7) :: ISCCP_PC = (/9000., 24500., 37500., 50000., 62000., 74000., 90000./)
!     real,parameter,dimension(2,7) :: ISCCP_PC_BNDS = reshape(source=(/0.0,18000.0,18000.0,31000.0,31000.0, &
!                                44000.0,44000.0,56000.0,56000.0,68000.0,68000.0,80000.0,80000.0,100000.0/), shape=(/2,7/))
   
    real,parameter,dimension(7) :: ISCCP_PC = (/90000., 74000., 62000., 50000., 37500., 24500., 9000./)
    real,parameter,dimension(2,7) :: ISCCP_PC_BNDS = reshape(source=(/100000.0,80000.0,80000.0,68000.0,68000.0,56000.0 &
                               ,56000.0,44000.0,44000.0,31000.0,31000.0,18000.0,18000.0,0.0/), shape=(/2,7/))
    
    real,parameter,dimension(MISR_N_CTH) :: MISR_CTH = 1000.0*(/ 0., 0.25, 0.75, 1.25, 1.75, 2.25, 2.75, 3.5, &
                                            4.5, 6., 8., 10., 12., 14.5, 16., 18./)
    real,parameter,dimension(2,MISR_N_CTH) :: MISR_CTH_BNDS = 1000.0*reshape(source=(/ &
                                            -99.0,  0.0,       0.0,  0.5,       0.5,  1.0,      1.0,  1.5, &
                                              1.5,  2.0,       2.0,  2.5,       2.5,  3.0,      3.0,  4.0, &
                                              4.0,  5.0,       5.0,  7.0,       7.0,  9.0,      9.0, 11.0, &
                                             11.0, 13.0,      13.0, 15.0,      15.0, 17.0,     17.0, 99.0/), &
                                             shape=(/2,MISR_N_CTH/))
            
    !  Table hclass for quickbeam
    integer,parameter :: N_HYDRO = 9
    real :: HCLASS_TYPE(N_HYDRO),HCLASS_COL(N_HYDRO),HCLASS_PHASE(N_HYDRO), &
            HCLASS_CP(N_HYDRO),HCLASS_DMIN(N_HYDRO),HCLASS_DMAX(N_HYDRO)
    real :: HCLASS_APM(N_HYDRO),HCLASS_BPM(N_HYDRO),HCLASS_RHO(N_HYDRO), &
            HCLASS_P1(N_HYDRO),HCLASS_P2(N_HYDRO),HCLASS_P3(N_HYDRO)
    real,dimension(N_HYDRO) :: N_ax,N_bx,alpha_x,c_x,d_x,g_x,a_x,b_x,gamma_1,gamma_2,gamma_3,gamma_4
    
     ! HCLASS_CP is not used in the version of Quickbeam included in COSP
!                      LSL    LSI      LSR     LSS   CVL    CVI   CVR     CVS   LSG
    data HCLASS_TYPE/    5,      1,      2,      2,     5,     1,   2,      2,    2/
    data HCLASS_COL/     1,      2,      3,      4,     5,     6,   7,      8,    9/
    data HCLASS_PHASE/   0,      1,      0,      1,     0,     1,   0,      1,    1/
    data HCLASS_CP/      0,      0,      0,      0,     0,     0,   0,      0,    0/
    data HCLASS_DMIN/   -1,     -1,     -1,     -1,    -1,    -1,   -1,    -1,   -1/
    data HCLASS_DMAX/   -1,     -1,     -1,     -1,    -1,    -1,   -1,    -1,   -1/
    data HCLASS_APM/   524,  110.8,    524,     -1,   524, 110.8,  524,    -1,   -1/
    data HCLASS_BPM/     3,   2.91,      3,     -1,     3,  2.91,    3,    -1,   -1/
    data HCLASS_RHO/    -1,     -1,     -1,    100,    -1,    -1,   -1,   100,  400/
    data HCLASS_P1/     -1,     -1,   8.e6,   3.e6,    -1,    -1, 8.e6,  3.e6, 4.e6/
    data HCLASS_P2/      6,     40,     -1,     -1,     6,    40,   -1,    -1,   -1/
    data HCLASS_P3/    0.3,      2,     -1,     -1,   0.3,     2,   -1,    -1,   -1/
    
    ! Microphysical settings for the precipitation flux to mixing ratio conversion
!                    LSL    LSI       LSR       LSS   CVL    CVI       CVR       CVS      LSG
    data N_ax/       -1.,   -1.,     8.e6,     3.e6,  -1.,   -1.,     8.e6,     3.e6,     4.e6/
    data N_bx/       -1.,   -1.,      0.0,      0.0,  -1.,   -1.,      0.0,      0.0,      0.0/
    data alpha_x/    -1.,   -1.,      0.0,      0.0,  -1.,   -1.,      0.0,      0.0,      0.0/
    data c_x/        -1.,   -1.,    842.0,     4.84,  -1.,   -1.,    842.0,     4.84,     94.5/
    data d_x/        -1.,   -1.,      0.8,     0.25,  -1.,   -1.,      0.8,     0.25,      0.5/
    data g_x/        -1.,   -1.,      0.5,      0.5,  -1.,   -1.,      0.5,      0.5,      0.5/
    data a_x/        -1.,   -1.,    524.0,    52.36,  -1.,   -1.,    524.0,    52.36,   209.44/
    data b_x/        -1.,   -1.,      3.0,      3.0,  -1.,   -1.,      3.0,      3.0,      3.0/
    data gamma_1/    -1.,   -1., 17.83725, 8.284701,  -1.,   -1., 17.83725, 8.284701, 11.63230/
    data gamma_2/    -1.,   -1.,      6.0,      6.0,  -1.,   -1.,      6.0,      6.0,      6.0/
    data gamma_3/    -1.,   -1.,      2.0,      2.0,  -1.,   -1.,      2.0,      2.0,      2.0/
    data gamma_4/    -1.,   -1.,      6.0,      6.0,  -1.,   -1.,      6.0,      6.0,      6.0/

! !                     LSL     LSI   LSR     LSS   CVL     CVI   CVR     CVS     LSG
!     data HCLASS_TYPE/   1,      1,    1,     -1,    1,      1,    1,      1,     -1/
!     data HCLASS_COL/    1,      2,    3,      4,    5,      6,    7,      8,      9/
!     data HCLASS_PHASE/  0,      1,    0,      1,    0,      1,    0,      1,      1/
!     data HCLASS_CP/     0,      0,    0,      0,    0,      0,    0,      0,      0/
!     data HCLASS_DMIN/  -1,     -1,   -1,     -1,   -1,     -1,   -1,     -1,     -1/
!     data HCLASS_DMAX/  -1,     -1,   -1,     -1,   -1,     -1,   -1,     -1,     -1/
!     data HCLASS_APM/   -1, 0.0444,   -1, 0.0444,   -1, 0.0444,   -1, 0.0444,  261.8/
!     data HCLASS_BPM/   -1,    2.1,   -1,    2.1,   -1,    2.1,   -1,    2.1,      3/
!     data HCLASS_RHO/ 1000,     -1, 1000,     -1, 1000,     -1, 1000,     -1,     -1/
!     data HCLASS_P1/    -1,     -1,   -1,     -1,   -1,     -1,   -1,     -1,     -1/
!     data HCLASS_P2/    10,     40, 1000,    120,   10,     40, 1000,    120,   1000/
!     data HCLASS_P3/     3,      1,    1,      1,    3,      1,    1,      1,    3.5/
! 
!     ! Microphysical settings for the precipitation flux to mixing ratio conversion
! !                     LSL    LSI      LSR    LSS   CVL    CVI       CVR       CVS      LSG
!     data N_ax/       -1.,   -1.,     26.2,   -1.,  -1.,   -1.,     26.2,     4.e6,     -1./
!     data N_bx/       -1.,   -1.,     1.57,   -1.,  -1.,   -1.,     1.57,      0.0,     -1./
!     data alpha_x/    -1.,   -1.,      0.0,   -1.,  -1.,   -1.,      0.0,      0.0,     -1./
!     data c_x/        -1.,   -1.,    386.8,   -1.,  -1.,   -1.,    386.8,     14.3,     -1./
!     data d_x/        -1.,   -1.,     0.67,   -1.,  -1.,   -1.,     0.67,    0.416,     -1./
!     data g_x/        -1.,   -1.,      0.4,   -1.,  -1.,   -1.,      0.4,      0.4,     -1./
!     data a_x/        -1.,   -1.,    523.6,   -1.,  -1.,   -1.,    523.6,   0.0444,     -1./
!     data b_x/        -1.,   -1.,      3.0,   -1.,  -1.,   -1.,      3.0,      2.1,     -1./
!     data gamma_1/    -1.,   -1., 14.78119,   -1.,  -1.,   -1., 14.78119, 3.382827,     -1./
!     data gamma_2/    -1.,   -1.,      6.0,   -1.,  -1.,   -1.,      6.0, 2.197659,     -1./
!     data gamma_3/    -1.,   -1.,      2.0,   -1.,  -1.,   -1.,      2.0,      2.0,     -1./
!     data gamma_4/    -1.,   -1.,      6.0,   -1.,  -1.,   -1.,      6.0,      6.0,     -1./

END MODULE MOD_COSP_CONSTANTS

! ============================================================================
! canopy air
! ============================================================================
module canopy_air_mod

#include "../shared/debug.inc"
#include "../shared/concat.inc"

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only : write_version_number, error_mesg, FATAL, NOTE, file_exist, &
     close_file, check_nml_error, &
     mpp_pe, mpp_root_pe, stdlog
use time_manager_mod, only : time_type, time_type_to_real
use constants_mod, only : rdgas, rvgas, cp_air, PI, VONKARM
use sphum_mod, only : qscomp

use nf_utils_mod, only : nfu_inq_var
use land_constants_mod, only : NBANDS,d608,mol_CO2,mol_air
use cana_tile_mod, only : cana_tile_type, cana_prog_type, &
     canopy_air_mass, canopy_air_mass_for_tracers, cpw
use land_tile_mod, only : land_tile_type, land_tile_enum_type, &
     first_elmt, tail_elmt, next_elmt, current_tile, operator(/=)
use land_tile_diag_mod, only : &
     register_tiled_diag_field, send_tile_data, diag_buff_type
use land_data_mod,      only : land_state_type, lnd
use land_tile_io_mod, only : create_tile_out_file, read_tile_data_r0d_fptr, write_tile_data_r0d_fptr, &
     get_input_restart_name, print_netcdf_error
use land_debug_mod, only : is_watch_point, check_temp_range

implicit none
private

! ==== public interfaces =====================================================
public :: read_cana_namelist
public :: cana_init
public :: cana_end
public :: save_cana_restart
public :: cana_radiation
public :: cana_turbulence
public :: cana_roughness
public :: cana_state
public :: cana_step_1
public :: cana_step_2
! ==== end of public interfaces ==============================================

! ==== module constants ======================================================
character(len=*), private, parameter :: &
  version = '$Id: canopy_air.F90,v 20.0 2013/12/13 23:29:31 fms Exp $', &
  tagname = '$Name: tikal $', &
  module_name = 'canopy_air_mod'

! options for turbulence parameter calculations
integer, parameter :: TURB_LM3W = 1, TURB_LM3V = 2
! ==== module variables ======================================================

!---- namelist ---------------------------------------------------------------
real :: init_T           = 288.
real :: init_T_cold      = 260.
real :: init_q           = 0.
real :: init_co2         = 350.0e-6 ! ppmv = mol co2/mol of dry air
character(len=32) :: turbulence_to_use = 'lm3w' ! or lm3v
logical :: save_qco2     = .TRUE.
logical :: sfc_dir_albedo_bug = .FALSE. ! if true, reverts to buggy behavior
! where direct albedo was mistakenly used for part of sub-canopy diffuse light
logical :: allow_small_z0 = .FALSE. ! to use z0 provided by lake and glac modules
real :: lai_min_turb = 0.0 ! fudge to desensitize Tv to SW/cosz inconsistency
namelist /cana_nml/ &
  init_T, init_T_cold, init_q, init_co2, turbulence_to_use, &
  canopy_air_mass, canopy_air_mass_for_tracers, cpw, save_qco2, &
  sfc_dir_albedo_bug, allow_small_z0, lai_min_turb
!---- end of namelist --------------------------------------------------------

logical            :: module_is_initialized =.FALSE.
type(time_type)    :: time ! *** NOT YET USED
real               :: delta_time      ! fast time step
integer :: turbulence_option ! selected option of turbulence parameters 
     ! calculations

! ==== NetCDF declarations ===================================================
include 'netcdf.inc'
#define __NF_ASRT__(x) call print_netcdf_error((x),module_name,__LINE__)


contains


! ============================================================================
subroutine read_cana_namelist()
  ! ---- local vars
  integer :: unit         ! unit for namelist i/o
  integer :: io           ! i/o status for the namelist
  integer :: ierr         ! error code, returned by i/o routines

  call write_version_number(version, tagname)
#ifdef INTERNAL_FILE_NML
     read (input_nml_file, nml=cana_nml, iostat=io)
     ierr = check_nml_error(io, 'cana_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file()
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=cana_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'cana_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif
  if (mpp_pe() == mpp_root_pe()) then
     unit = stdlog()
     write (unit, nml=cana_nml)
  endif
end subroutine read_cana_namelist

! ============================================================================
! initialize canopy air
subroutine cana_init ( id_lon, id_lat )
  integer, intent(in)          :: id_lon  ! ID of land longitude (X) axis  
  integer, intent(in)          :: id_lat  ! ID of land latitude (Y) axis

  ! ---- local vars ----------------------------------------------------------
  integer :: unit         ! unit for various i/o
  type(land_tile_enum_type)     :: te,ce ! last and current tile
  type(land_tile_type), pointer :: tile   ! pointer to current tile
  character(len=256) :: restart_file_name
  logical :: restart_exists

  module_is_initialized = .TRUE.

  ! ---- make module copy of time --------------------------------------------
  time       = lnd%time
  delta_time = time_type_to_real(lnd%dt_fast)

  ! ---- initialize cana state -----------------------------------------------
  ! first, set the initial values
  te = tail_elmt (lnd%tile_map)
  ce = first_elmt(lnd%tile_map)
  do while(ce /= te)
     tile=>current_tile(ce)  ! get pointer to current tile
     ce=next_elmt(ce)       ! advance position to the next tile
     
     if (.not.associated(tile%cana)) cycle
     
     if (associated(tile%glac)) then
        tile%cana%prog%T = init_T_cold
     else
        tile%cana%prog%T = init_T
     endif
     tile%cana%prog%q = init_q
     ! convert to kg CO2/kg wet air
     tile%cana%prog%co2 = init_co2*mol_CO2/mol_air*(1-tile%cana%prog%q) 
  enddo

  ! then read the restart if it exists
  call get_input_restart_name('INPUT/cana.res.nc',restart_exists,restart_file_name)
  if (restart_exists) then
     call error_mesg('cana_init',&
          'reading NetCDF restart "'//trim(restart_file_name)//'"',&
          NOTE)
     __NF_ASRT__(nf_open(restart_file_name,NF_NOWRITE,unit))
     call read_tile_data_r0d_fptr(unit, 'temp'  , cana_T_ptr  )
     call read_tile_data_r0d_fptr(unit, 'sphum' , cana_q_ptr )
     if(nfu_inq_var(unit,'co2')==NF_NOERR) then
        call read_tile_data_r0d_fptr(unit, 'co2', cana_co2_ptr )
     endif
     __NF_ASRT__(nf_close(unit))     
  else
     call error_mesg('cana_init',&
          'cold-starting canopy air',&
          NOTE)
  endif

  ! initialize options, to avoid expensive character comparisons during 
  ! run-time
  if (trim(turbulence_to_use)=='lm3v') then
     turbulence_option = TURB_LM3V
  else if (trim(turbulence_to_use)=='lm3w') then
     turbulence_option = TURB_LM3W
  else
     call error_mesg('cana_init', 'canopy air turbulence option turbulence_to_use="'// &
          trim(turbulence_to_use)//'" is invalid, use "lm3w" or "lm3v"', FATAL)
  endif
  
end subroutine cana_init


! ============================================================================
! release memory
subroutine cana_end ()

  module_is_initialized =.FALSE.

end subroutine cana_end


! ============================================================================
subroutine save_cana_restart (tile_dim_length, timestamp)
  integer, intent(in) :: tile_dim_length ! length of tile dim. in the output file
  character(*), intent(in) :: timestamp ! timestamp to add to the file name

  ! ---- local vars ----------------------------------------------------------
  integer :: unit            ! restart file i/o unit

  call error_mesg('cana_end','writing NetCDF restart',NOTE)
  call create_tile_out_file(unit,'RESTART/'//trim(timestamp)//'cana.res.nc',&
          lnd%coord_glon, lnd%coord_glat, cana_tile_exists, tile_dim_length)

     ! write fields
     call write_tile_data_r0d_fptr(unit,'temp' ,cana_T_ptr,'canopy air temperature','degrees_K')
     call write_tile_data_r0d_fptr(unit,'sphum',cana_q_ptr,'canopy air specific humidity','kg/kg')
     if (save_qco2) then
        call write_tile_data_r0d_fptr(unit,'co2'  ,cana_co2_ptr,'canopy air co2 concentration','(kg CO2)/(kg wet air)')
     endif
     ! close output file
     __NF_ASRT__(nf_close(unit))
end subroutine save_cana_restart


! ============================================================================
! set up constants for linearization of radiative transfer, using information
! provided by soil, snow and vegetation modules.
subroutine cana_radiation (lm2, &
     subs_refl_dir, subs_refl_dif, subs_refl_lw, & 
     snow_refl_dir, snow_refl_dif, snow_refl_lw, & 
     snow_area, &
     vegn_refl_dir, vegn_refl_dif, vegn_tran_dir, vegn_tran_dif, &
     vegn_tran_dir_dir, vegn_refl_lw, vegn_tran_lw,  &
     vegn_cover, &
     Sg_dir, Sg_dif, Sv_dir, Sv_dif, &
     land_albedo_dir, land_albedo_dif )

  logical, intent(in) :: lm2
  real, intent(in) :: &
       subs_refl_dir(NBANDS), subs_refl_dif(NBANDS), subs_refl_lw,  & ! sub-snow reflectances for direct, diffuse, and LW radiation respectively
       snow_refl_dir(NBANDS), snow_refl_dif(NBANDS), snow_refl_lw,  & ! snow reflectances for direct, diffuse, and LW radiation respectively
       snow_area, &
       vegn_refl_dir(NBANDS), vegn_tran_dir(NBANDS), & ! vegn reflectance & transmittance for direct light
       vegn_tran_dir_dir(NBANDS), & !
       vegn_refl_dif(NBANDS), vegn_tran_dif(NBANDS), & ! vegn reflectance & transmittance for diffuse light 
       vegn_refl_lw,  vegn_tran_lw,  & ! vegn reflectance & transmittance for thermal radiation 
       vegn_cover

  real, intent(out) :: &
     Sg_dir(NBANDS), Sg_dif(NBANDS), & ! fraction of downward short-wave absorbed by ground and snow
     Sv_dir(NBANDS), Sv_dif(NBANDS), & ! fraction of downward short-wave absorbed by vegetation
     land_albedo_dir(NBANDS), land_albedo_dif(NBANDS)

  ! ---- local vars
  real :: &
       grnd_refl_dir(NBANDS), & ! SW reflectances of ground surface (by spectral band)
       grnd_refl_dif(NBANDS), & ! SW reflectances of ground surface (by spectral band)
       grnd_refl_lw             ! LW reflectance of ground surface
  real :: &
       subs_up_from_dir(NBANDS), subs_up_from_dif(NBANDS), &
       subs_dn_dir_from_dir(NBANDS),  subs_dn_dif_from_dif(NBANDS), subs_dn_dif_from_dir(NBANDS)

  grnd_refl_dir = subs_refl_dir + (snow_refl_dir - subs_refl_dir) * snow_area
  grnd_refl_dif = subs_refl_dif + (snow_refl_dif - subs_refl_dif) * snow_area
  grnd_refl_lw  = subs_refl_lw  + (snow_refl_lw  - subs_refl_lw ) * snow_area

  ! ---- shortwave -----------------------------------------------------------
  ! allocation to canopy and ground, based on solution for single
  ! vegetation layer of limited cover. both ground and vegetation are gray.
  Sv_dir = 0; Sv_dif = 0
  IF (LM2) THEN

     subs_dn_dir_from_dir = vegn_tran_dir_dir
     subs_dn_dif_from_dir = vegn_tran_dir
     subs_dn_dif_from_dif = vegn_tran_dif
     if (sfc_dir_albedo_bug) then
        subs_up_from_dir = grnd_refl_dir &
             * (subs_dn_dir_from_dir + subs_dn_dif_from_dir)
     else
        subs_up_from_dir = grnd_refl_dir*subs_dn_dir_from_dir + &
                           grnd_refl_dif*subs_dn_dif_from_dir
     endif
     subs_up_from_dif = grnd_refl_dif*subs_dn_dif_from_dif
     land_albedo_dir = subs_up_from_dir+vegn_refl_dir
     land_albedo_dif = subs_up_from_dif+vegn_refl_dif

  ELSE

     subs_dn_dir_from_dir = vegn_tran_dir_dir
     subs_dn_dif_from_dir = (vegn_tran_dir + vegn_refl_dif*grnd_refl_dir*vegn_tran_dir_dir)&
                          / (1 - grnd_refl_dif*vegn_refl_dif)
     subs_dn_dif_from_dif = vegn_tran_dif &
                          / (1 - grnd_refl_dif*vegn_refl_dif)
     if (sfc_dir_albedo_bug) then
        subs_up_from_dir = grnd_refl_dir * (subs_dn_dir_from_dir + subs_dn_dif_from_dir)
     else
        subs_up_from_dir = grnd_refl_dir*subs_dn_dir_from_dir + &
                           grnd_refl_dif*subs_dn_dif_from_dir
     endif
     subs_up_from_dif = grnd_refl_dif*subs_dn_dif_from_dif
     land_albedo_dir  = subs_up_from_dir*vegn_tran_dif + vegn_refl_dir
     land_albedo_dif  = subs_up_from_dif*vegn_tran_dif + vegn_refl_dif

  ENDIF

  Sg_dir = subs_dn_dir_from_dir + subs_dn_dif_from_dir - subs_up_from_dir
  Sg_dif = subs_dn_dif_from_dif - subs_up_from_dif
  Sv_dir = 1 - Sg_dir - land_albedo_dir
  Sv_dif = 1 - Sg_dif - land_albedo_dif

end subroutine cana_radiation


! ============================================================================
subroutine cana_turbulence (u_star,&
     vegn_cover, vegn_height, vegn_lai, vegn_sai, vegn_d_leaf, &
     land_d, land_z0m, land_z0s, grnd_z0s, &
     con_v_h, con_v_v, con_g_h, con_g_v )
  real, intent(in) :: &
       u_star, & ! friction velocity, m/s
       land_d, land_z0m, land_z0s, grnd_z0s, & 
       vegn_cover, vegn_height, &
       vegn_lai, vegn_sai, vegn_d_leaf
  real, intent(out) :: &
       con_v_h, con_v_v, & ! one-sided foliage-cas conductance per unit of ground area
       con_g_h, con_g_v    ! ground-CAS conductance per unit ground area

  !---- local constants
  real, parameter :: a_max = 3
  real, parameter :: leaf_co = 0.01 ! meters per second^(1/2)
                                    ! leaf_co = g_b(z)/sqrt(wind(z)/d_leaf)
  ! ---- local vars 
  real :: a        ! parameter of exponential wind profile within canopy:
                   ! u = u(ztop)*exp(-a*(1-z/ztop))
  real :: height   ! effective height of vegetation
  real :: wind     ! normalized wind on top of canopy, m/s
  real :: Kh_top   ! turbulent exchange coefficient on top of the canopy
  real :: vegn_idx ! total vegetation index = LAI+SAI
  real :: rah_sca  ! ground-SCA resistance

  vegn_idx = vegn_lai+vegn_sai  ! total vegetation index
  select case(turbulence_option)
  case(TURB_LM3W)
     if(vegn_cover > 0) then
        wind  = u_star/VONKARM*log((vegn_height-land_d)/land_z0m) ! normalized wind on top of the canopy
        a     = vegn_cover*a_max
        con_v_h = (2*max(vegn_lai,lai_min_turb)*leaf_co*(1-exp(-a/2))/a)*sqrt(wind/vegn_d_leaf)
        con_g_h = u_star*a*VONKARM*(1-land_d/vegn_height) &
             / (exp(a*(1-grnd_z0s/vegn_height)) - exp(a*(1-(land_z0s+land_d)/vegn_height)))
     else
        con_v_h = 0
        con_g_h = 0
     endif
  case(TURB_LM3V)
     height = max(vegn_height,0.1) ! effective height of the vegetation
     a = a_max
     wind=u_star/VONKARM*log((height-land_d)/land_z0m) ! normalized wind on top of the canopy
  
     con_v_h = (2*max(vegn_lai,lai_min_turb)*leaf_co*(1-exp(-a/2))/a)*sqrt(wind/vegn_d_leaf)

     if (land_d > 0.06 .and. vegn_idx > 0.25) then
        Kh_top = VONKARM*u_star*(height-land_d)
        rah_sca = height/a/Kh_top * &
             (exp(a*(1-grnd_z0s/height)) - exp(a*(1-(land_z0m+land_d)/height)))
        rah_sca = min(rah_sca,1250.0)
     else
        rah_sca=0.01
     endif
     con_g_h = 1.0/rah_sca
  end select
  con_g_v = con_g_h
  con_v_v = con_v_h
end subroutine

! ============================================================================
! update effective surface roughness lengths for CAS-to-atmosphere fluxes
! and conductances for canopy-to-CAS and ground-to-CAS fluxes
!
! Strategy: Always define a canopy present. Non-vegetated situation is simply
! a limit as vegetation density approaches (but isn't allowed to reach) zero.
! Create expressions for the outputs that reduce to the special
! cases of full canopy cover and no canopy. Full canopy solution is that
! from Bonan (NCAR/TN-417+STR, 1996, p. 63). Thus, setting cover=1 in
! recovers Bonan. Letting cover approach 0 makes con_v_coef go to zero,
! preventing exchange with canopy, and makes con_g_coef go infinite,
! removing sub-canopy resistance and putting all resistance above the
! canopy, where it can be affected by stability adjustments.
!
! ** However, there is still a problem with this formulation when a
! canopy is present, because surface flux (I think) is not told to
! subtract out the resistances associated with con_v_coef and con_g_coef,
! which thus seem to be double-counted. For testing LM2, we should set them
! to zero anyway.
subroutine cana_roughness(lm2, &
     subs_z0m, subs_z0s, &
     snow_z0m, snow_z0s, snow_area, &
     vegn_cover, vegn_height, vegn_lai, vegn_sai, &
     land_d, land_z0m, land_z0s, is_lake_or_glac )
  logical, intent(in) :: lm2, is_lake_or_glac
  real, intent(in) :: &
       subs_z0m, subs_z0s, snow_z0m, snow_z0s, snow_area, vegn_cover, vegn_height, &
       vegn_lai, vegn_sai
  real, intent(out) :: &
       land_d    ,&
       land_z0m  ,&
       land_z0s

  !---- local constants
  real, parameter :: d_h_max = 2./3.
  real, parameter :: z0m_h_max = 1/7.35

  ! ---- local vars 
  real :: d_h      ! ratio of displacement height to vegetation height
  real :: z0m_h    ! ratio of roughness length to vegetation height
  real :: grnd_z0m, grnd_z0s
  real :: z0s_h, z0s_h_max
  real :: vegn_idx ! total vegetation index = LAI+SAI
  real :: height   ! effective vegetation height

  grnd_z0m = exp( (1-snow_area)*log(subs_z0m) + snow_area*log(snow_z0m))
  grnd_z0s = exp( (1-snow_area)*log(subs_z0s) + snow_area*log(snow_z0s))

  select case(turbulence_option)
  case(TURB_LM3W)
     if(vegn_cover > 0) then
        z0s_h_max = z0m_h_max*grnd_z0s/grnd_z0m ! to ensure cover->0 limit works
        d_h = vegn_cover*d_h_max
        if (lm2) then
           if (vegn_lai.gt.1) then  ! TEMP ***
              z0m_h = z0m_h_max
              z0s_h = z0s_h_max
           else
              z0m_h = grnd_z0m/vegn_height
              z0s_h = grnd_z0s/vegn_height
           endif
        else
           z0m_h = exp( vegn_cover*log(z0m_h_max) + (1-vegn_cover)*log(grnd_z0m/vegn_height))
           z0s_h = exp( vegn_cover*log(z0s_h_max) + (1-vegn_cover)*log(grnd_z0s/vegn_height))
        endif
        land_d   = d_h*vegn_height
        land_z0m = z0m_h*vegn_height
        land_z0s = z0s_h*vegn_height
     else
        land_d   = 0
        land_z0m = grnd_z0m
        land_z0s = grnd_z0s
     endif
     
  case(TURB_LM3V)
     height = max(vegn_height,0.1) ! effective height of the vegetation
     vegn_idx = vegn_lai+vegn_sai  ! total vegetation index
     if(vegn_idx>1e-4) then
        land_d = 1.1*height*log(1+(0.07*vegn_idx)**0.25)
        if(vegn_idx>2.85) then
           land_z0m = 0.3*(height-land_d)
        else
           land_z0m = grnd_z0m + 0.3*height*sqrt(0.07*vegn_idx)
        endif
     else 
        ! bare soil or leaf off
        land_z0m = 0.1 *height
        land_d   = 0.66*height
     endif
     land_z0s = land_z0m*exp(-2.0) 

     if (allow_small_z0.and.is_lake_or_glac) then
         land_d = 0
	 land_z0m = grnd_z0m
	 land_z0s = grnd_z0s
       endif
     
  end select

end subroutine cana_roughness

! ============================================================================
subroutine cana_state ( cana, cana_T, cana_q, cana_co2 )
  type(cana_tile_type), intent(in)  :: cana
  real, optional      , intent(out) :: cana_T, cana_q, cana_co2

  if (present(cana_T))   cana_T   = cana%prog%T
  if (present(cana_q))   cana_q   = cana%prog%q
  if (present(cana_co2)) cana_co2 = cana%prog%co2
  
end subroutine

! ============================================================================
subroutine cana_step_1 ( cana,&
     p_surf, con_g_h, con_g_v, grnd_T, grnd_rh, grnd_rh_psi, &
     Hge,  DHgDTg, DHgDTc,    &
     Ege,  DEgDTg, DEgDqc, DEgDpsig     )
  type(cana_tile_type), intent(in) :: cana
  real, intent(in) :: &
     p_surf,  & ! surface pressure, Pa
     con_g_h, & ! conductivity between ground and CAS for heat
     con_g_v, & ! conductivity between ground and CAS for vapor
     grnd_T,  & ! ground temperature, degK
     grnd_rh, & ! ground relative humidity
     grnd_rh_psi ! psi derivative of ground relative humidity
  real, intent(out) ::   &
     Hge,  DHgDTg, DHgDTc, & ! linearization of the sensible heat flux from ground
     Ege,  DEgDTg, DEgDqc, DEgDpsig    ! linearization of evaporation from ground

  ! ---- local vars
  real :: rho, grnd_q, qsat, DqsatDTg

  call check_temp_range(grnd_T,'cana_step_1','grnd_T', lnd%time)

  call qscomp(grnd_T,p_surf,qsat,DqsatDTg)
  grnd_q = grnd_rh * qsat

  rho      =  p_surf/(rdgas*cana%prog%T*(1+d608*cana%prog%q))
  Hge      =  rho*cp_air*con_g_h*(grnd_T - cana%prog%T)
  DHgDTg   =  rho*cp_air*con_g_h
  DHgDTc   = -rho*cp_air*con_g_h
  Ege      =  rho*con_g_v*(grnd_q  - cana%prog%q)
  DEgDTg   =  rho*con_g_v*DqsatDTg*grnd_rh
  DEgDqc   = -rho*con_g_v
  DEgDpsig =  rho*con_g_v*qsat*grnd_rh_psi
  if(is_watch_point())then
     write(*,*)'#### cana_step_1 input ####'
     __DEBUG1__(p_surf)
     __DEBUG2__(con_g_h,con_g_v)
     __DEBUG2__(grnd_T,grnd_rh)
     write(*,*)'#### cana_step_1 internals ####'
     __DEBUG4__(rho, grnd_q, qsat, DqsatDTg)
     __DEBUG2__(cana%prog%T,cana%prog%q)
     write(*,*)'#### cana_step_1 output ####'
     __DEBUG3__(Hge,  DHgDTg, DHgDTc)
     __DEBUG4__(Ege,  DEgDTg, DEgDqc, DEgDpsig)
  endif
end subroutine 


! ============================================================================
subroutine cana_step_2 ( cana, delta_Tc, delta_qc )
  type(cana_tile_type), intent(inout) :: cana
  real, intent(in) ::  &
     delta_Tc, & ! change in canopy air temperature
     delta_qc    ! change in canopy air humidity

  cana%prog%T = cana%prog%T + delta_Tc
  cana%prog%q = cana%prog%q + delta_qc
end subroutine cana_step_2

! ============================================================================
! tile existence detector: returns a logical value indicating wether component
! model tile exists or not
logical function cana_tile_exists(tile)
   type(land_tile_type), pointer :: tile
   cana_tile_exists = associated(tile%cana)
end function cana_tile_exists

! ============================================================================
! accessor functions: given a pointer to a land tile, they return pointer
! to the desired member of the land tile, of NULL if this member does not
! exist.

#define DEFINE_CANA_ACCESSOR_0D(xtype,x) subroutine CONCAT3(cana_,x,_ptr(t,p));\
type(land_tile_type),pointer::t;xtype,pointer::p;p=>NULL();if(associated(t))then;if(associated(t%cana))p=>t%cana%prog%x;endif;end subroutine

DEFINE_CANA_ACCESSOR_0D(real,T)
DEFINE_CANA_ACCESSOR_0D(real,q)
DEFINE_CANA_ACCESSOR_0D(real,co2)

end module canopy_air_mod

program river_regrid
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  !<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Zhi Liang  </CONTACT>
  !<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Kirsten Findell </CONTACT>

  !<OVERVIEW>
  !  This program can remap river network data from spherical grid onto another
  !  spherical grid.
  !</OVERVIEW>
  !<DESCRIPTION>
  !  The program expects to read river network data from a netcdf file, which 
  !  is specified by the namelist variable "river_input_file". This file should 
  !  contains field 'cellarea', 'tocell', 'fromcell', 'basin', 'basincells', 
  !  'order', 'travel', 'subL', 'subA','disttomouth', 'disttoocean' and 'dx'. 
  !  The program will remap the data in "river_input_file" onto the grid, which
  !  is specified by namelist grid_file. The grid file should contains the same
  !  grid as the land modle to be run. The output is stored in a netcdf file, which
  !  is specified by river_output_file.
  !</DESCRIPTION>

  use mpp_mod,          only : mpp_error, FATAL, NOTE, mpp_init, mpp_pe, mpp_root_pe, mpp_npes
  use mpp_domains_mod,  only : domain2D, mpp_define_layout, mpp_define_domains, mpp_get_compute_domain
  use mpp_domains_mod,  only : mpp_global_field
  use mpp_io_mod,       only : mpp_open, mpp_close, axistype, fieldtype, mpp_write, mpp_write_meta
  use mpp_io_mod,       only : MPP_OVERWR, MPP_NETCDF, MPP_MULTI, MPP_RDONLY, MPP_ASCII, MPP_SINGLE 
  use mpp_io_mod,       only : mpp_get_atts, mpp_get_axes, mpp_get_axis_data, mpp_get_fields
  use mpp_io_mod,       only : mpp_read, mpp_get_info, mpp_io_init
  use fms_mod,          only : open_namelist_file, check_nml_error, stdout, stdlog, close_file
  use fms_mod,          only : file_exist,  write_version_number, error_mesg, read_data
  use fms_mod,          only : fms_init, fms_end, field_exist, field_size
  use axis_utils_mod,   only : get_axis_cart, get_axis_bounds
  use constants_mod,    only : PI, radius, constants_init, DEG_TO_RAD
  use fms_io_mod,       only : fms_io_exit
  use horiz_interp_mod, only : horiz_interp_init, horiz_interp_new, horiz_interp, horiz_interp_del, horiz_interp_type

  implicit none

  !--- namelist interface ----------------------------------------------
  !<NAMELIST NAME="river_regrid_nml">
  !  <DATA NAME="river_input_file" TYPE="character(len=128)" >
  !    river data source file.
  !  </DATA>
  !  <DATA NAME="grid_file" TYPE="character(len=128)" >
  !    the grid file that contains land and ocean grid information.
  !  </DATA>
  !  <DATA NAME="river_output_file" TYPE="character(len=128)" >
  !    The output river data file after coupled with land grid.
  !  </DATA>
  !  <DATA NAME="lon_start, lon_end" TYPE="real">
  !    starting and ending longitude of the river network to be extended to. Default value is 0 and 360. 
  !  </DATA>
  !  <DATA NAME="lat_start, lat_end" TYPE="real">
  !    starting and ending latitude of the river network to be extended to. Default value is -90 and 90. 
  !  </DATA>
  !  <DATA NAME="lat_end" TYPE="real">
  !    The ending latitude. Default value is 90. Used to extend river network.  
  !  </DATA>
  !</NAMELIST>
  character(len=128) :: river_input_file  = 'river_input.nc'
  character(len=128) :: grid_file    = 'grid_spec.nc'
  character(len=128) :: river_output_file = 'river_output.nc'
!  character(len=128) :: edit_table       = 'river_table'
  real               :: lon_start         = 0
  real               :: lon_end           = 360
  real               :: lat_start         = -90
  real               :: lat_end           = 90
  namelist /river_regrid_nml/ river_input_file, river_output_file, grid_file, &
                              lon_start, lon_end, lat_start, lat_end

  real :: missing_value = -9999.

  !--- derived data type ------------------------------------------------
  type river_regrid_type
     real, dimension(:),      pointer :: lon         => NULL()   ! longitude (in degree)
     real, dimension(:),      pointer :: lat         => NULL()   ! lattitude (in degree)
     real, dimension(:),      pointer :: lonb        => NULL()   ! longitude edges (in degree)
     real, dimension(:),      pointer :: latb        => NULL()   ! latitude edges (in degree)
     real, dimension(:,:),    pointer :: slope       => NULL()   ! slope
     real, dimension(:,:),    pointer :: cellarea    => NULL()   ! cell area
     real, dimension(:,:),    pointer :: subL        => NULL()   ! subbasin length
     real, dimension(:,:),    pointer :: subA        => NULL()   ! subbasin area
     real, dimension(:,:),    pointer :: disttoocean => NULL()   ! distant to ocean
     real, dimension(:,:),    pointer :: celllength  => NULL()   ! cell size
     integer, dimension(:,:), pointer :: order       => NULL()   ! river order
     integer, dimension(:,:), pointer :: basinid     => NULL()   ! basin id
     integer, dimension(:,:), pointer :: tocell      => NULL()   ! tocell information
     integer, dimension(:,:), pointer :: fromcell    => NULL()   ! fromcell information
     integer, dimension(:,:), pointer :: basincells  => NULL()   ! basincells
     integer, dimension(:,:), pointer :: travel      => NULL()   ! number of travel to ocean
     real, dimension(:,:),    pointer :: mask        => NULL()   ! land/sea mask(land=1)
     real, dimension(:,:,:),  pointer :: dist        => NULL()   ! distance to neighbor cell
     integer, dimension(:,:), pointer :: neighbor    => NULL()   ! neighbor information
     integer, dimension(:,:), pointer :: land_order  => NULL()   ! land_order
     integer                          :: nlon, nlat              ! grid size
  end type river_regrid_type

  !--- version information ---------------------------------------------
  character(len=128) :: version = '$ID$'
  character(len=128) :: tagname = '$Name: tikal $'

  !--- other variables
  type(river_regrid_type),save      :: Source
  type(river_regrid_type),save      :: River
  real, parameter                   :: lnd_thresh = 1.0e-6   ! some small number
  logical                           :: module_is_initialized = .FALSE.
  integer                           :: next_basinid = 0
  real                              :: D2R
  integer                           :: nlon, nlat  ! grid size of extended river grid
  real, dimension(:,:), allocatable :: mask_ocn, lon_ocn, lat_ocn

  !--- begin the program
  call fms_init
  call constants_init

  call river_regrid_init()
  write(stdout(),*)"complete river_regrid_init"

  call river_regrid_data(River)
  write(stdout(),*)"complete river_regrid_data"

  if(mpp_pe() == mpp_root_pe())call write_river_regrid_data(River)
  write(stdout(),*)"complete write_river_regrid_data"

  call river_regrid_end(River)
  write(stdout(),*)" ****** congradulation! You have successfully run river_regrid"

  call fms_end

contains

  !--- initialization routine, reading namelist, read river source 
  !--- data and land grid information.
  subroutine river_regrid_init

    integer :: unit, ierr, io_status

    !--- read namelist and write out namelist --------------------------
    unit = open_namelist_file()
    read  (unit, river_regrid_nml,iostat=io_status)
    write (stdout(),'(/)')
    write (stdout(), river_regrid_nml)
    write (stdlog(), river_regrid_nml)
    ierr = check_nml_error(io_status,'river_regrid_nml')
    call close_file (unit)

    D2R = PI/180.0

    !--- write out version information ---------------------------------
    call write_version_number(version, tagname)

    !--- read the river data from river_input_file
    call read_river_src_data( )

    return

  end subroutine river_regrid_init

  !#####################################################################

  !--- remap and define river routing network.
  subroutine river_regrid_data(River)
    type(river_regrid_type), intent(inout) :: River

    !--- define River to make land and river has the same range and initialize
    !--- the river data.
    call define_new_grid(River)

    !--- the following will be done only on root pe.
    if(mpp_pe() .NE. mpp_root_pe()) return

    !--- remove previously land point
    call trim_river(River)

    !--- define land order for new river grid
    call define_new_land_order(River)

    !--- define new land point data
    call define_new_land_data(River)

    !--- extend river with travel = 0 , tocell not zero, full land cell an extra points.
    call update_coast_land(River)

    !--- check river data to see if there is any bad value.
    call check_river_data(River)
  end subroutine river_regrid_data

  !####################################################################
  subroutine update_coast_land(River)
    type(river_regrid_type), intent(inout) :: River 
    integer                                :: nbasin, basin, cur_basin, num_nbrs
    integer                                :: i_array(8), j_array(8)
    integer                                :: i, j, ii, jj, i_nbr, j_nbr
    integer                                :: num_river_merged   = 0
    integer                                :: num_river_extended = 0
    integer                                :: num_partial_land   = 0
    !--- first add one ocean point to the river network with the coast point is a full land cell.
    !--- ( point with travel=0, tocell > 0)

    nbasin = maxval(River%basinid)
    do basin = 1, nbasin
       LOOP: do j = 1, nlat
          do i = 1, nlon
             if(River%basinid(i,j) == basin .AND. River%travel(i,j) == 0) then
                if(River%tocell(i,j)>0 .AND. River%mask(i,j) ==1 ) then ! full land coast point, not inland point, add one more point.
                   call get_nbr_index(River%tocell(i,j), i, j, i_array, j_array, num_nbrs)
                   if(num_nbrs .ne. 1) call mpp_error(FATAL,'River will flow to one and only one direction')
                   i_nbr = i_array(1)
                   j_nbr = j_array(1) 
                   if(River%basinid(i_nbr,j_nbr) >0) then  ! the ocean point is already extended.
                      num_river_merged = num_river_merged + 1
                      cur_basin = River%basinid(i_nbr,j_nbr)
                      if(River%fromcell(i_nbr,j_nbr) <0) then
!                      write(stdout(), *)"The river with basinid = ", basin, &
!                           " will be merged into river with basin =", cur_basin
                      call mpp_error(FATAL,'crash')
                      end if
                      do jj = 1, nlat
                         do ii = 1, nlon
                            if(River%basinid(ii,jj) == basin) then
                               River%basinid(ii,jj) = cur_basin
                               River%travel(ii,jj) = River%travel(ii,jj) + 1
                            end if
                         end do
                      end do
                      if(River%tocell(i,j) .lt. 16) then
                         River%fromcell(i_nbr,j_nbr) = River%fromcell(i_nbr,j_nbr) + River%tocell(i,j)*16
                      else if(River%tocell(i,j) .ge. 16) then
                         River%fromcell(i_nbr,j_nbr) = River%fromcell(i_nbr,j_nbr) + River%tocell(i,j)/16
                      endif
                   else
                      num_river_extended = num_river_extended + 1
!                      write(stdout(), *) "The river with basinid = ", basin, " will be extended "
                      do jj = 1, nlat
                         do ii = 1, nlon
                            if(River%basinid(ii,jj) == basin) then
                               River%travel(ii,jj) = River%travel(ii,jj) + 1
                            end if
                         end do
                      end do
                      River%basinid(i_nbr,j_nbr) = basin
                      River%travel(i_nbr,j_nbr)  = 0
                      River%tocell(i_nbr,j_nbr)  = 0
                      if(River%tocell(i,j) .lt. 16) then
                         River%fromcell(i_nbr,j_nbr) = River%tocell(i,j)*16
                      else if(River%tocell(i,j) .ge. 16) then
                         River%fromcell(i_nbr,j_nbr) = River%tocell(i,j)/16
                      endif
                   end if
                end if
                exit LOOP
             end if
          end do
       end do LOOP
    end do

    !--- set tocell of coast partial land to 0
    num_partial_land = 0
    do j = 1, nlat
       do i = 1, nlon
          if(River%travel(i,j) == 0 .AND. River%tocell(i,j) > 0) then ! coast point
             if(River%mask(i,j) < 1) then
                 River%tocell(i,j) = 0 ! partial land coast point will flow into itself.
                num_partial_land = num_partial_land + 1
             end if
          end if
       end do
    end do

    write(stdout(),*) "******* number of river extended is :", num_river_extended
    write(stdout(),*) "******* number of river merged is :", num_river_merged
    write(stdout(),*) "******* number of coast partial river point with tocell set to 0 is :", num_partial_land

  end subroutine update_coast_land

  !####################################################################
  subroutine check_river_data(River)
    type(river_regrid_type), intent(in) :: River 
    integer                             :: nbasin, basin, ncoast, i, j
    integer                             :: i_array(8), j_array(8), i_nbr, j_nbr, num_nbrs

    ! check that all the data should be missing value or greater than or equal to 0
    do j = 1, nlat
       do i = 1, nlon
          if(River%basinid(i,j) < 0 .AND. River%basinid(i,j) .NE. missing_value) call mpp_error(FATAL, &
              "the basinid of some points is less than 0 and not equal to missing_value")
          if(River%cellarea(i,j) < 0 .AND. River%cellarea(i,j) .NE. missing_value) call mpp_error(FATAL, &
              "the cellarea of some points is less than 0 and not equal to missing_value")
          if(River%subL(i,j) < 0 .AND. River%subL(i,j) .NE. missing_value) call mpp_error(FATAL, &
              "the subL of some points is less than 0 and not equal to missing_value")
          if(River%subA(i,j) < 0 .AND. River%subA(i,j) .NE. missing_value) call mpp_error(FATAL, &
              "the subA of some points is less than 0 and not equal to missing_value")
          if(River%disttoocean(i,j) < 0 .AND. River%disttoocean(i,j) .NE. missing_value) call mpp_error(FATAL, &
              "the disttoocean of some points is less than 0 and not equal to missing_value")
          if(River%celllength(i,j) < 0 .AND. River%celllength(i,j) .NE. missing_value) call mpp_error(FATAL, &
              "the celllength of some points is less than 0 and not equal to missing_value")
          if(River%order(i,j) < 0 .AND. River%order(i,j) .NE. missing_value) call mpp_error(FATAL, &
              "the order of some points is less than 0 and not equal to missing_value")
          if(River%tocell(i,j) < 0 .AND. River%tocell(i,j) .NE. missing_value) call mpp_error(FATAL, &
              "the tocell of some points is less than 0 and not equal to missing_value")
          if(River%fromcell(i,j) < 0 .AND. River%fromcell(i,j) .NE. missing_value) call mpp_error(FATAL, &
              "the fromcell of some points is less than 0 and not equal to missing_value")
          if(River%basincells(i,j) < 0 .AND. River%basincells(i,j) .NE. missing_value) call mpp_error(FATAL, &
              "the basincells of some points is less than 0 and not equal to missing_value")
          if(River%travel(i,j) < 0 .AND. River%travel(i,j) .NE. missing_value) call mpp_error(FATAL, &
              "the basinid of some points is less than 0 and not equal to missing_value")
       end do
    end do


    ! check river travel to make sure there is one and only one point with travel = 0.
    nbasin = maxval(River%basinid)
    do basin = 1, nbasin
       ncoast = 0
       do j = 1, nlat
          do i = 1, nlon
             if(River%basinid(i,j) == basin ) then
                if(River%travel(i,j) == 0 ) ncoast = ncoast + 1
             end if
          end do
       end do
       if( ncoast < 0 ) then
           write(stdout(),*) ' river with basin = ', basin, ' has no point with traver = 0'
           call mpp_error(FATAL,"some river has no point with travel = 0")
       end if
       if( ncoast > 1 ) then
           write(stdout(),*) ' river with basin = ', basin, ' has more that 1 point with traver = 0'
           call mpp_error(FATAL,"some river has more than one point with travel = 0")
       end if
    end do

    !--- make sure when the mask is 1 ( land/river), basin is not missing value
    !--- and = missing_value when mask is 0 ( ocean )
    
    do j = 1, nlat
       do i = 1, nlon
          if(River%mask(i,j) > lnd_thresh ) then ! river point
             if(River%basinid(i,j) == missing_value  ) then
                write(stdout(),*) 'at (i,j) = (', i, ',',j, &
                     '), mask = 1(river), but basinid equal to missing value'
                call mpp_error(FATAL,"some river point has basinid = missing value")
             end if
          else if(River%basinid(i,j) > 0) then
             if(River%travel(i,j) .NE. 0 .OR. River%tocell(i,j) .NE. 0  ) then
                write(stdout(),*) 'at (i,j) = (', i, ',',j, &
                     '), mask = 0( ocean), basinid = ', River%basinid(i,j), &
                     ', travel = ', River%travel(i,j), ', tocell = ',  River%tocell(i,j)
                call mpp_error(FATAL,"some ocean point in the river network has nonzero travel or nonzero tocell")
             end if
          end if
       end do
    end do

    !--- check travel, tocell, fromcell and basinid
    do j = 1, nlat
       do i = 1, nlon
          if(River%tocell(i,j) >0 ) then  ! river point
             call get_nbr_index(River%tocell(i,j), i, j, i_array, j_array, num_nbrs)
             if(num_nbrs .ne. 1) then
                write(stdout(),*) 'at (i,j) = (', i, ',',j, &
                  ', there are ', num_nbrs, ' tocell and the neighbors are: i_nbr =  ', &
                  i_array(1:num_nbrs), ', j_nbr = ', j_array(1:num_nbrs)
                call mpp_error(FATAL,'River can only flow to one direction')
             end if
             i_nbr = i_array(1)
             j_nbr = j_array(1)
             if(River%basinid(i,j) .NE. River%basinid(i_nbr,j_nbr)) then
                write(stdout(),*) 'at (i,j) = (', i, ',',j, &
                     '), basinid = ', River%basinid(i,j), ',tocell = (', i_nbr, ',', j_nbr, &
                      ') with basinid = ', River%basinid(i_nbr, j_nbr), &
                      River%travel(i,j), River%mask(i,j), River%travel(i_nbr,j_nbr), River%mask(i_nbr,j_nbr)

                call mpp_error(FATAL,"Every cell should have the same basinid as its tocell")
             end if
             call get_nbr_index(River%fromcell(i_nbr,j_nbr), i_nbr, j_nbr, i_array, j_array, num_nbrs)
             if(count(i_array(1:num_nbrs) == i .AND. j_array(1:num_nbrs) == j) .NE. 1) then
                write(stdout(),*) 'at (i,j) = (', i, ',',j, '), all the fromcell of its tocell does not contain itself'
                 call mpp_error(FATAL,"all the fromcell of its tocell does not contain itself")
             end if
             if( River%travel(i,j) .NE. River%travel(i_nbr,j_nbr) + 1 ) then
                write(stdout(),*) 'at (i,j) = (', i, ',',j, '), The travel does not equal to the travel of tocell + 1'
                call mpp_error(FATAL,"The travel does not equal to the travel of tocell + 1")
             end if
          end if
       end do
    end do


    !--- make sure no river point with travel = 0 and tocell > 0
    if(ANY(River%travel(1:nlon,1:nlat) == 0 .AND. River%tocell(1:nlon,1:nlat) > 0) )  call mpp_error(FATAL, &
           "some river point have zero travel and nonzero tocell")

  end subroutine check_river_data


  !#####################################################################
  !--- write out river routing data
  subroutine write_river_regrid_data(River)
    type(river_regrid_type), intent(in) :: River

    integer                    :: unit
    type(axistype)             :: axis_x, axis_y, axis_x_ocn, axis_y_ocn
    type(fieldtype)            :: fld_basin, fld_basincells, fld_cellarea
    type(fieldtype)            :: fld_disttoocean, fld_fromcell, fld_order, fld_subA
    type(fieldtype)            :: fld_subL, fld_tocell, fld_travel, fld_celllength, fld_mask
    type(fieldtype)            :: fld_neighbor, fld_land_order, fld_ocn_mask, fld_slope
    type(fieldtype)            :: fld_ocn_lon, fld_ocn_lat
    real, allocatable          :: tmp(:,:)

    call mpp_open(unit,trim(river_output_file), MPP_OVERWR, MPP_NETCDF, threading = MPP_SINGLE)

    !--- write out axis meta data ---------------------------------------------
    call mpp_write_meta(unit, axis_x,'lon','degree_east','Nominal Longitude of T-cell center', &
         cartesian ='X', data = River%lon )

    call mpp_write_meta(unit, axis_y,'lat','degree_north','Nominal Latitude of T-cell center', &
         cartesian ='Y', data = River%lat )

    call mpp_write_meta(unit, axis_x_ocn,'grid_x_ocn','degree_east','Nominal Longitude of T-cell center of ocean grid', &
         cartesian ='X', data = lon_ocn(:,1) )

    call mpp_write_meta(unit, axis_y_ocn,'grid_y_ocn','degree_north','Nominal Latitude of T-cell center of ocean grid', &
         cartesian ='Y', data = lat_ocn(1,:) )

    !--- write out field meta data ---------------------------------------------
    call mpp_write_meta(unit, fld_basin, (/axis_x, axis_y/), 'basin', &
         'none','river basin id', pack=1, missing=missing_value )

    call mpp_write_meta(unit, fld_basincells, (/axis_x, axis_y/), 'basincells', &
         'none','number of cells in subbasin', pack=1, missing=missing_value)

    call mpp_write_meta(unit, fld_slope, (/axis_x, axis_y/), 'So', &
         'none','slope', pack=1, missing=missing_value)

    call mpp_write_meta(unit, fld_cellarea, (/axis_x, axis_y/), 'cellarea', &
         'm2','cell area', pack=1, missing=missing_value)

    call mpp_write_meta(unit, fld_disttoocean, (/axis_x, axis_y/), 'disttoocean', &
         'm','distance to ocean', pack=1, missing=missing_value)

    call mpp_write_meta(unit, fld_fromcell, (/axis_x, axis_y/), 'fromcell', &
         'none','sum of directions from upstream cells', pack=1, missing=missing_value)

    call mpp_write_meta(unit, fld_order, (/axis_x, axis_y/), 'order', &
         'none','Strahler stream order', pack=1, missing=missing_value)

    call mpp_write_meta(unit, fld_subA, (/axis_x, axis_y/), 'subA', &
         'm2','subbasin area', pack=1, missing=missing_value)

    call mpp_write_meta(unit, fld_subL, (/axis_x, axis_y/), 'subL', &
         'm','subbasin length', pack=1, missing=missing_value)

    call mpp_write_meta(unit, fld_tocell, (/axis_x, axis_y/), 'tocell', &
         'none','direction to downstream cell', pack=1, missing=missing_value)

    call mpp_write_meta(unit, fld_travel, (/axis_x, axis_y/), 'travel', &
         'none','cells left to travel before reaching ocean', pack=1, missing=missing_value)

    call mpp_write_meta(unit, fld_celllength, (/axis_x, axis_y/), 'celllength', &
         'm','cell length', pack=1, missing=missing_value)
    call mpp_write_meta(unit, fld_mask, (/axis_x, axis_y/), 'mask', &
         'none','land/sea mask(land = 1)', pack=1, missing=missing_value)
    call mpp_write_meta(unit, fld_neighbor, (/axis_x, axis_y/), 'neighbor', &
         'none','neighbor point', pack=1, missing=missing_value)
    call mpp_write_meta(unit, fld_land_order, (/axis_x, axis_y/), 'land_order', &
         'none','neighbor point', pack=1, missing=missing_value)

    call mpp_write_meta(unit, fld_ocn_lon, (/axis_x_ocn, axis_y_ocn/), 'lon_ocean', &
         'none','geographical longitude of ocean grid', pack=1)
    call mpp_write_meta(unit, fld_ocn_lat, (/axis_x_ocn, axis_y_ocn/), 'lat_ocean', &
         'none','geographical latitude of ocean grid', pack=1)
    call mpp_write_meta(unit, fld_ocn_mask, (/axis_x_ocn, axis_y_ocn/), 'mask_ocean', &
         'none','land/sea mask of ocean grid', pack=1)
    call mpp_write(unit, axis_x)
    call mpp_write(unit, axis_y)
    call mpp_write(unit, axis_x_ocn)
    call mpp_write(unit, axis_y_ocn)

    allocate(tmp(nlon, nlat) )
    tmp = River%basinid(1:nlon,1:nlat)
    call mpp_write(unit, fld_basin, tmp)
    tmp = River%basincells(1:nlon,1:nlat)
    call mpp_write(unit, fld_basincells, tmp)
    call mpp_write(unit, fld_slope, River%slope(1:nlon,1:nlat))
    call mpp_write(unit, fld_cellarea, River%cellarea(1:nlon,1:nlat))
    call mpp_write(unit, fld_disttoocean, River%disttoocean(1:nlon,1:nlat))
    tmp = River%fromcell(1:nlon,1:nlat)
    call mpp_write(unit, fld_fromcell, tmp)
    tmp = River%order(1:nlon,1:nlat)
    call mpp_write(unit, fld_order, tmp)
    call mpp_write(unit, fld_subA, River%subA(1:nlon,1:nlat))
    call mpp_write(unit, fld_subL, River%subL(1:nlon,1:nlat))
    tmp = River%tocell(1:nlon,1:nlat)
    call mpp_write(unit, fld_tocell, tmp)
    tmp = River%travel(1:nlon,1:nlat)
    call mpp_write(unit, fld_travel, tmp)
    call mpp_write(unit, fld_celllength, River%celllength(1:nlon,1:nlat))
    call mpp_write(unit, fld_mask, River%mask(1:nlon,1:nlat))
    tmp = River%neighbor(1:nlon,1:nlat)
    call mpp_write(unit, fld_neighbor, tmp)
    tmp = River%land_order(1:nlon,1:nlat)
    call mpp_write(unit, fld_land_order, tmp)
    call mpp_write(unit, fld_ocn_lon,  lon_ocn )
    call mpp_write(unit, fld_ocn_lat,  lat_ocn )
    call mpp_write(unit, fld_ocn_mask, mask_ocn )
    call mpp_close(unit)
    deallocate(tmp)

  end subroutine write_river_regrid_data

  !#####################################################################
  ! release memory
  subroutine river_regrid_end(River)
    type(river_regrid_type), intent(inout) :: River

    module_is_initialized = .FALSE.
    deallocate(River%lonb, River%latb, River%cellarea, River%subL, River%subA )
    deallocate(River%disttoocean, River%celllength, River%order )
    deallocate(River%basinid, River%tocell, River%fromcell, River%basincells )
    deallocate(River%travel, River%mask, River%neighbor,  River%land_order )
    deallocate(River%dist, River%lon, River%lat )

  end subroutine river_regrid_end

  !#####################################################################
  !--- read river source data
  subroutine read_river_src_data

    type(axistype), dimension(:),  allocatable :: axes, axes_bounds
    type(fieldtype), dimension(:), allocatable :: fields
    real, dimension(:,:),          allocatable :: tmp
    real               :: old_missing_value
    integer            :: unit, n, m, ndim, nvar, natt, ntime, len_axes, nlon_src, nlat_src
    character(len=128) :: name
    character(len=1)   :: cart
    logical            :: found_cellarea, found_tocell, found_fromcell, found_basin, found_so
    logical            :: found_basincells, found_order, found_travel, found_subL
    logical            :: found_subA, found_disttoocean, found_dx

    write(stdout(),*) ' read river src data from file '//trim(river_input_file)

    if(.not. file_exist(trim(river_input_file))) &
         call mpp_error(FATAL, 'river_regrid: file '//trim(river_input_file)//' does not exist')

    !--- get the grid size and grids
    call mpp_open(unit,trim(river_input_file),action=MPP_RDONLY,form=MPP_NETCDF)
    call mpp_get_info(unit, ndim, nvar, natt, ntime)
    allocate(fields(nvar))
    call mpp_get_fields(unit,fields)
    found_cellarea = .false.
    do n = 1, nvar
       call mpp_get_atts(fields(n),name=name)
       if(trim(name) == "cellarea") then
          found_cellarea = .true.
          ndim = 2
          allocate(axes(ndim), axes_bounds(ndim))
          call mpp_get_atts(fields(n),axes=axes)
          do m = 1, ndim
       cart = 'N'
             call get_axis_cart(axes(m), cart)
             call mpp_get_atts(axes(m),len=len_axes)
       if (cart == 'N') call mpp_error(FATAL,'river_routing_mod: couldnt recognize axis atts.')
       select case (cart)
       case ('X')
          nlon_src = len_axes
          allocate(Source%lonb(nlon_src+1), Source%lon(nlon_src))
                call mpp_get_axis_data(axes(m), Source%lon)
                call get_axis_bounds(axes(m), axes_bounds(m), axes)
                call mpp_get_axis_data(axes_bounds(m), Source%lonb)
       case ('Y')
          nlat_src = len_axes
          allocate(Source%latb(nlat_src+1), Source%lat(nlat_src))
                call mpp_get_axis_data(axes(m), Source%lat)
                call get_axis_bounds(axes(m), axes_bounds(m), axes)
                call mpp_get_axis_data(axes_bounds(m), Source%latb)
       end select
    enddo
          exit
       end if
    end do
    if(.not. found_cellarea) call mpp_error(FATAL,'river_routing_mod: cellarea is not in file '//trim(river_input_file) )

    Source%nlon = nlon_src
    Source%nlat = nlat_src
    !--- read the field
    allocate(Source%cellarea   (nlon_src,nlat_src), Source%tocell     (nlon_src,nlat_src) )
    allocate(Source%fromcell   (nlon_src,nlat_src), Source%basinid    (nlon_src,nlat_src) )
    allocate(Source%basincells (nlon_src,nlat_src), Source%travel     (nlon_src,nlat_src) )
    allocate(Source%subL       (nlon_src,nlat_src), Source%subA  (nlon_src,nlat_src) )
    allocate(Source%disttoocean(nlon_src,nlat_src) )
    allocate(Source%celllength (nlon_src,nlat_src), Source%order      (nlon_src,nlat_src) )
    allocate(Source%slope      (nlon_src,nlat_src), tmp               (nlon_src,nlat_src) )

    found_cellarea = .FALSE.    ; found_tocell = .FALSE.
    found_fromcell = .FALSE.    ; found_basin = .FALSE.
    found_basincells = .FALSE.  ; found_order = .FALSE.
    found_travel = .FALSE.      ; found_subL = .FALSE.
    found_subA = .FALSE.
    found_disttoocean = .FALSE. ; found_dx = .FALSE.
    do n = 1, nvar
       call mpp_get_atts(fields(n),name=name, missing = old_missing_value)
       select case (trim(name))
       case ('So')
          found_so = .TRUE.
          call mpp_read(unit,fields(n), Source%slope )
          where(Source%Slope == old_missing_value) Source%slope = missing_value
       case ('cellarea')
          found_cellarea = .TRUE.
          call mpp_read(unit,fields(n), Source%cellarea )
          where(Source%cellarea == old_missing_value) Source%cellarea = missing_value
       case ('tocell')
          found_tocell = .TRUE.
          call mpp_read(unit,fields(n), tmp )
          Source%tocell = tmp               
          where(Source%tocell == old_missing_value) Source%tocell = missing_value
       case ('fromcell')
          found_fromcell = .TRUE.
          call mpp_read(unit,fields(n), tmp ) 
          Source%fromcell = tmp
          where(Source%fromcell == old_missing_value) Source%fromcell = missing_value
       case ('basin')
          found_basin = .TRUE.
          call mpp_read(unit,fields(n), tmp ) 
          Source%basinid = tmp
          where(Source%basinid == old_missing_value) Source%basinid = missing_value
       case ('basincells')
          found_basincells = .TRUE.
          call mpp_read(unit,fields(n), tmp) 
          Source%basincells = tmp 
          where(Source%basincells == old_missing_value) Source%basincells = missing_value           
       case ('order')
          found_order = .TRUE.
          call mpp_read(unit,fields(n), tmp ) 
          Source%order = tmp
          where(Source%order == old_missing_value) Source%order = missing_value
       case ('travel')
          found_travel = .TRUE.
          call mpp_read(unit,fields(n), tmp )
          Source%travel = tmp
          where(Source%travel == old_missing_value) Source%travel = missing_value
       case ('subL')
          found_subL = .TRUE.
          call mpp_read(unit,fields(n), Source%subL ) 
          where(Source%subL == old_missing_value) Source%subL = missing_value
       case ('subA')
          found_subA = .TRUE.
          call mpp_read(unit,fields(n), Source%subA ) 
          where(Source%subA == old_missing_value) Source%subA = missing_value
       case ('disttoocean')
          found_disttoocean = .TRUE.
          call mpp_read(unit,fields(n), Source%disttoocean ) 
          where(Source%disttoocean == old_missing_value) Source%disttoocean = missing_value
       case ('dx')
          found_dx = .TRUE.
          call mpp_read(unit,fields(n), Source%celllength ) 
          where(Source%celllength == old_missing_value) Source%celllength = missing_value
       end select
    enddo
    deallocate(tmp, axes, axes_bounds, fields )

    if(.not. found_so) call mpp_error(FATAL,'river_routing_mod: So is not in file '//trim(river_input_file) )
    if(.not. found_cellarea) call mpp_error(FATAL,'river_routing_mod: cellarea is not in file '//trim(river_input_file) )
    if(.not. found_tocell) call mpp_error(FATAL,'river_routing_mod: tocell is not in file '//trim(river_input_file) )
    if(.not. found_fromcell) call mpp_error(FATAL,'river_routing_mod: fromcell is not in file '//trim(river_input_file) )
    if(.not. found_basin) call mpp_error(FATAL,'river_routing_mod: basin is not in file '//trim(river_input_file) )
    if(.not. found_basincells) call mpp_error(FATAL,'river_routing_mod: basincells is not in file '//trim(river_input_file) )
    if(.not. found_order) call mpp_error(FATAL,'river_routing_mod: order is not in file '//trim(river_input_file) )
    if(.not. found_travel) call mpp_error(FATAL,'river_routing_mod: travel is not in file '//trim(river_input_file) )
    if(.not. found_subL) call mpp_error(FATAL,'river_routing_mod: subL is not in file '//trim(river_input_file) )
    if(.not. found_subA) call mpp_error(FATAL,'river_routing_mod: subA is not in file '//trim(river_input_file) )
    if(.not. found_disttoocean) call mpp_error(FATAL,'river_routing_mod: disttoocean is not in file '//trim(river_input_file) )
    if(.not. found_dx) call mpp_error(FATAL,'river_routing_mod: dx is not in file '//trim(river_input_file) )

    call mpp_close(unit)

  end subroutine read_river_src_data

  !#####################################################################
  !--- extend river grid to match land grid
  !--- define land/sea mask for each grid.
  subroutine define_new_grid(River)
    type(river_regrid_type), intent(out) :: River

    integer :: num_lon_begin, num_lon_end, num_lat_begin, num_lat_end, nlon_src, nlat_src
    integer :: i, j, i_trans, j_trans, im1, ip1, jm1, jp1
    real    :: dx, dy

    write(stdout(),*) 'define new grid After coupled with ocean grid'
    !--- We assume river source grid always is uniform
    dx = Source%lonb(2) - Source%lonb(1)
    dy = Source%latb(2) - Source%latb(1)  
    nlon_src = Source%nlon; nlat_src = Source%nlat

    !--- The river grid should be inside the land grid
    if(Source%lonb(1) .lt. lon_start .or. Source%lonb(nlon_src+1) .gt. lon_end  .or. &
         Source%latb(1) .lt. lat_start .or. Source%latb(nlat_src+1) .gt. lat_end)    &
         call mpp_error(FATAL,'river_regrid: static river grid is not inside the region bounded by '// &
                   'lon_start, lon_end, lat_start and lat_end' )

    !--- find how many points need to be added at the begining and end
    call find_grid_addition(lon_start, lon_end, Source%lonb(1), &
         Source%lonb(size(Source%lonb)), dx, num_lon_begin, num_lon_end)

    call find_grid_addition(lat_start, lat_end, Source%latb(1), &
         Source%latb(size(Source%latb)), dy, num_lat_begin, num_lat_end)  

    River%nlon = nlon_src + num_lon_begin + num_lon_end
    River%nlat = nlat_src + num_lat_begin + num_lat_end
    nlon = River%nlon
    nlat = River%nlat

    !--- memory allocation 
    allocate(River%lonb(nlon+1), River%latb(nlat+1), River%cellarea(nlon,nlat) )
    allocate(River%subL(0:nlon+1,0:nlat+1), River%subA(0:nlon+1,0:nlat+1) )
    allocate(River%disttoocean(nlon,nlat) )
    allocate(River%celllength(nlon,nlat), River%order(0:nlon+1,0:nlat+1) )
    allocate(River%basinid(nlon,nlat), River%tocell(0:nlon+1,0:nlat+1) )
    allocate(River%fromcell(nlon,nlat), River%basincells(nlon,nlat) )
    allocate(River%travel(nlon,nlat), River%mask(-1:nlon+2,-1:nlat+2) )
    allocate(River%neighbor(nlon,nlat),  River%land_order(nlon,nlat) )
    allocate(River%dist(nlon, nlat, 8), River%lon(nlon), River%lat(nlat) )
    allocate(River%slope(nlon,nlat) )

    !--- get the expanded river grid
    call grid_expansion(River%lonb, Source%lonb, lon_start, lon_end, dx, num_lon_begin, num_lon_end)
    call grid_expansion(River%latb, Source%latb, lat_start, lat_end, dy, num_lat_begin, num_lat_end)

    write(stdout(),*) num_lon_begin, 'points is added at the west bound.  ',  num_lon_end, 'points is added at the east bound'
    write(stdout(),*) num_lat_begin, 'points is added at the south bound. ',  num_lat_end, 'points is added at the north bound'

    do i = 1, nlon
       River%lon(i) = ( River%lonb(i) + River%lonb(i+1) ) * 0.5
    enddo
    do j = 1, nlat
       River%lat(j) = ( River%latb(j) + River%latb(j+1) ) * 0.5
    enddo

    !--- fill it with nan value
    River%slope       = missing_value
    River%cellarea    = missing_value
    River%subL        = missing_value  
    River%subA        = missing_value
    River%disttoocean = missing_value
    River%celllength  = missing_value
    River%order       = missing_value
    River%basinid     = missing_value
    River%tocell      = missing_value
    River%fromcell    = missing_value
    River%basincells  = missing_value
    River%travel      = missing_value
    
    !--- file it with orginal grid data
    do j = 1, nlat_src
       do i = 1, nlon_src
          i_trans = num_lon_begin + i
          j_trans = num_lat_begin + j
          River%slope      (i_trans,j_trans)  = Source%slope      (i,j)
          River%cellarea   (i_trans,j_trans)  = Source%cellarea   (i,j)
          River%subL       (i_trans,j_trans)  = Source%subL       (i,j)  
          River%subA       (i_trans,j_trans)  = Source%subA       (i,j)
          River%disttoocean(i_trans,j_trans)  = Source%disttoocean(i,j)
          River%celllength (i_trans,j_trans)  = Source%celllength (i,j)
          River%order      (i_trans,j_trans)  = Source%order      (i,j)
          River%basinid    (i_trans,j_trans)  = Source%basinid    (i,j)
          River%tocell     (i_trans,j_trans)  = Source%tocell     (i,j)
          River%fromcell   (i_trans,j_trans)  = Source%fromcell   (i,j)
          River%basincells (i_trans,j_trans)  = Source%basincells (i,j)
          River%travel     (i_trans,j_trans)  = Source%travel     (i,j)
       enddo
    enddo

    !--- we assume the cyclic condition
    River%order(0,     1:nlat) = River%order(nlon,1:nlat)
    River%order(nlon+1,1:nlat) = River%order(1,   1:nlat)
    River%subL (0,     1:nlat) = River%subL (nlon,1:nlat)
    River%subL (nlon+1,1:nlat) = River%subL (1,   1:nlat)
    River%subA (0,     1:nlat) = River%subA (nlon,1:nlat)
    River%subA (nlon+1,1:nlat) = River%subA (1,   1:nlat)

    !--- define the mask of river grid according to land grid mask.

    call define_river_mask(River)

    !--- here we suppose the cyclic condition exists
    River%tocell(0,1:nlat)      = River%tocell(nlon,1:nlat)
    River%tocell(nlon+1,1:nlat) = River%tocell(1,1:nlat)

    !--- define the distance to the neighbor at each point
    River%dist = 1.0e20      
    do j = 1, nlat
       do i = 1, nlon
          ip1 = i + 1; im1 = i - 1
          jp1 = j + 1; jm1 = j - 1
          if(im1 == 0) im1 = nlon
          if(ip1 == nlon+1) ip1 = 1
          River%dist(i,j,1) = dist(River%lon(i), River%lat(j), River%lon(ip1), River%lat(j) )
          if(jm1 .ne. 0 ) then
             River%dist(i,j,2) = dist(River%lon(i), River%lat(j), River%lon(ip1), River%lat(jm1) )
             River%dist(i,j,3) = dist(River%lon(i), River%lat(j), River%lon(i  ), River%lat(jm1) )
             River%dist(i,j,4) = dist(River%lon(i), River%lat(j), River%lon(im1), River%lat(jm1) )
          endif
          River%dist(i,j,5) = dist(River%lon(i), River%lat(j), River%lon(im1), River%lat(j) )
          if(jp1 .ne. nlat+1) then
             River%dist(i,j,6) = dist(River%lon(i), River%lat(j), River%lon(im1), River%lat(jp1) )
             River%dist(i,j,7) = dist(River%lon(i), River%lat(j), River%lon(i  ), River%lat(jp1) )
             River%dist(i,j,8) = dist(River%lon(i), River%lat(j), River%lon(ip1), River%lat(jp1) )
          endif
       enddo
    enddo

    next_basinid = maxval(Source%basinid) + 1

  end subroutine define_new_grid

  !#####################################################################
  !--- find number of points needed to be extended.
  subroutine find_grid_addition(lnd_start, lnd_end, river_start, river_end, dx, num_begin, num_end)
    real, intent(in)     :: lnd_start, lnd_end, river_start, river_end, dx
    integer, intent(out) :: num_begin, num_end
    real                 :: diff, min_size 

    min_size =  0.05
    if(dx .lt. min_size) call mpp_error(FATAL,'river_routing_mod: river grid size is too small')
    !---first check how many points we need to add at the begining.
    num_begin = 0
    diff = river_start - lnd_start
    if( diff .gt. min_size) then
       num_begin = int(diff / dx)
       if(diff-num_begin*dx .gt. min_size) num_begin = num_begin + 1
    endif

    num_end = 0
    diff = lnd_end - river_end
    if( diff .gt. min_size) then
       num_end = int(diff / dx)
       if(diff-num_end*dx .gt. min_size) num_end = num_end + 1
    endif

  end subroutine find_grid_addition

  !#####################################################################
  !--- define new river grid
  subroutine grid_expansion(river_grid, orig_grid, lnd_start,lnd_end, dx, num_begin, num_end)
    real, dimension(:),    intent(out) :: river_grid
    real, dimension(:),     intent(in) :: orig_grid
    real,                   intent(in) :: lnd_start, lnd_end, dx
    integer,                intent(in) :: num_begin, num_end
    integer                            :: num_orig, i

    num_orig = size(orig_grid)

    river_grid(num_begin+1:num_begin+num_orig) = orig_grid(:)

    do i=num_begin,2,-1
       river_grid(i) = orig_grid(1) - (num_begin-i+1)*dx
    enddo
    if(num_begin .gt. 0) river_grid(1) = lnd_start

    do i=1,num_end-1
       river_grid(num_begin+num_orig+i) = orig_grid(num_orig)+dx*i
    enddo

    if(num_end .gt. 0) river_grid(size(river_grid)) = lnd_end

    return
  end subroutine grid_expansion

  !#####################################################################
  !--- define land order for new river grid.
  subroutine define_new_land_order(River)
    type(river_regrid_type), intent(inout) :: River

    integer, dimension(:,:), allocatable :: land_order
    integer                              :: i, j, num_order
    logical                              :: found_new_land_pt

    write(stdout(),*) 'define land order for new river grid.'

    allocate(land_order(0:nlon+1,0:nlat+1) )

    !---set the initial value to some dummy number
    land_order = -1
    where( River%mask(1:nlon,1:nlat) .gt. lnd_thresh .and. River%travel(1:nlon,1:nlat) .eq. missing_value ) 
       land_order(1:nlon,1:nlat) = 0  ! new land point
    end where

    !--- continue if there is any new land point to check

    !--- first find the coastal points
    River%neighbor = 0
    do j = 1, nlat
       do i = 1, nlon
          if(land_order(i,j) == 0) then
             River%neighbor(i,j) = get_neighbor( River%mask(i-1:i+1,j-1:j+1) .le. lnd_thresh )
             if(River%neighbor(i,j) .gt. 0) land_order(i,j) = 1
          endif
       enddo
    enddo

    land_order(0,1:nlat) = land_order(nlon,1:nlat)
    land_order(nlon+1,1:nlat) = land_order(1,1:nlat)

    num_order = 2
    do while(any(land_order(1:nlon,1:nlat) == 0) )
       found_new_land_pt = .FALSE.
       do j = 1, nlat
          do i = 1, nlon
             if(land_order(i,j) == 0) then
                River%neighbor(i,j) = get_neighbor(land_order(i-1:i+1,j-1:j+1) .eq. num_order-1)
                if( River%neighbor(i,j) .gt. 0 ) then
                   found_new_land_pt = .true.
                   land_order(i,j) = num_order
                   if(i == 1) land_order(nlon+1,j) = num_order
                   if(i == nlon) land_order(0,j) = num_order
                endif
             endif
          enddo
       enddo
       if(.not. found_new_land_pt ) exit
       num_order = num_order + 1
    enddo

    River%land_order(1:nlon,1:nlat) = land_order(1:nlon,1:nlat)
    deallocate(land_order)

    return
  end subroutine define_new_land_order

  !#####################################################################
  !--- define river routing data for new river grid
  subroutine define_new_land_data(River)

    type(river_regrid_type), intent(inout) :: River

    integer :: max_land_order, num_nbrs, num_max_order, num_max_subL
    integer :: i, j, k, n, i_lo, the_basinid, ii, jj, num_max_subA, fromcell
    logical :: is_neighbor(8)
    integer :: i_nbr, j_nbr, i_array(8), j_array(8), i_in(8), j_in(8), i_out(8), j_out(8)
    integer :: basinid_cur

    !--- first initialialize some field
    do j = 1, nlat
       do i = 1, nlon
          if(River%land_order(i,j) .ge. 0) then    
             River%tocell(i,j) = 0
             River%fromcell(i,j) = 0
             River%travel(i,j) = 0
             River%disttoocean(i,j) = 0
             River%celllength(i,j) = 0
          end if
       end do
    end do

    !--- first define the outflow direction for new land grid
    do j = 1, nlat
       do i = 1, nlon
          if(River%land_order(i,j) .ge. 1) then
             do k = 1,8
                is_neighbor(k) = btest(River%neighbor(i,j),k-1)
             enddo
             River%tocell(i,j) = outflow_direction(is_neighbor, River%dist(i,j,:))
          endif
       enddo
    enddo

    !--- update halo points of tocell
    River%tocell(0,1:nlat) = River%tocell(nlon,1:nlat)
    River%tocell(nlon+1,1:nlat) = River%tocell(1,1:nlat)

    !--- then define the inflow direction for new land grid
    do j = 1, nlat
       do i = 1, nlon
          if(River%land_order(i,j) .ge. 1) then
             River%fromcell(i,j) = inflow_direction(River%tocell(i-1:i+1,j-1:j+1))
          else if(River%land_order(i,j) ==0) then
             fromcell = inflow_direction(River%tocell(i-1:i+1,j-1:j+1))
             if(fromcell >0) then
                River%fromcell(i,j) = fromcell
                River%land_order(i,j) = 1
             end if
          endif
       enddo
    enddo

    !--- extend river with travel = 0 , tocell not zero, full land cell an extra points.
    ! ****************************************************************
    ! *  Update properties of new land cells                         *
    ! *  (and attributes of other cells impacted by the new land)    *
    ! ****************************************************************

    ! First: properties that are only about each individual cell
    !        only have to define these for the new points added to the system
    do j = 1, nlat
       do i = 1, nlon
          River%cellarea(i,j) = area(River%lonb(i:i+1), River%latb(j:j+1) )
          if(River%land_order(i,j) .ge. 1) then
!             River%cellarea(i,j) = area(River%lonb(i:i+1), River%latb(j:j+1) )
             if(River%tocell(i,j) ==0) cycle
             call get_nbr_index(River%tocell(i,j), i, j, i_array, j_array, num_nbrs)
             if(num_nbrs .ne. 1) call mpp_error(FATAL,'River can only flow to one direction')
             i_nbr = i_array(1)
             j_nbr = j_array(1)
             River%celllength(i,j) = dist(River%lon(i),River%lat(j), River%lon(i_nbr), River%lat(j_nbr) )
          endif
       enddo
    enddo

    !--- extend river with travel = 0 , tocell not zero, full land cell an extra points.
    !--multiple river%mask to get partial cellarea and remove previously land point
    do j = 1, nlat
       do i = 1, nlon
          if(River%cellarea(i,j) .NE. missing_value) then
             River%cellarea(i,j) = River%cellarea(i,j) *River%mask(i,j)
          end if
       end do
    end do

    !--- extend river with travel = 0 , tocell not zero, full land cell an extra points.
    ! Now update properties that are dependent on upstream cells (fromcell)
    !     Need to do this from the inner-most new land points downstream toward the ocean
    ! Loop: for new points, from max(River%land_order(i,j)) to 1, counting down
    max_land_order = maxval(River%land_order)
    do i_lo = max_land_order, 1, -1
       do j = 1, nlat
          do i = 1, nlon
             if (River%land_order(i,j) .eq. i_lo) then
                !--- find neighbors --------------
                call get_nbr_index(River%fromcell(i,j), i,j,i_array, j_array, num_nbrs)
                ! No neighbors feed this cell (fromcell = 0)
                if (num_nbrs .eq. 0) then
                   River%basinid(i,j) = next_basinid
                   next_basinid = next_basinid + 1
                   River%order(i,j) = 1
                   River%subL(i,j) = River%celllength(i,j)
                   River%subA(i,j) = River%cellarea(i,j)
                   River%basincells(i,j) = 1
                   ! only one neighbor feeds this cell
                else if(num_nbrs == 1  ) then
                   i_nbr = i_array(1)
                   j_nbr = j_array(1)
                   River%order(i,j) = River%order(i_nbr,j_nbr)
                   River%basinid(i,j) = River%basinid(i_nbr,j_nbr)
                   River%subL(i,j) = River%celllength(i,j) + River%subL(i_nbr,j_nbr)
                   River%subA(i,j) = River%cellarea(i,j) + River%subA(i_nbr,j_nbr)
                   River%basincells(i,j) = 1 + River%basincells(i_nbr,j_nbr)
                else       ! multiple neighbors feed this cell
                   ! one neighbor is the clear mainstem (by stream order)
                   i_in(1:num_nbrs) = i_array(1:num_nbrs)
                   j_in(1:num_nbrs) = j_array(1:num_nbrs)
                   call find_max_int ( River%order, i_in, j_in, num_nbrs, i_out, j_out, num_max_order ) 

                   if( num_max_order == 1) then
                      i_nbr = i_out(1)
                      j_nbr = j_out(1)
                      River%order(i,j) = River%order(i_nbr,j_nbr)
                      ! no neighbor is the clear mainstem (by stream order)
                   else   ! multiple neighbors feeding in have the same, max(order)) 
                      ! determine mainstem by largest subL, then largest subA, then arbitrary
                      i_in(1:num_max_order) = i_out(1:num_max_order)
                      j_in(1:num_max_order) = j_out(1:num_max_order)
                      call find_max_real( River%subL, i_in, j_in, num_max_order, i_out, j_out, num_max_subL )
                      if(num_max_subL == 1) then
                         i_nbr  = i_out(1)
                         j_nbr  = j_out(1)
                         River%order(i,j) = 1 + River%order(i_nbr,j_nbr)
                      else 
                         i_in(1:num_max_subL) = i_out(1:num_max_subL)
                         j_in(1:num_max_subL) = j_out(1:num_max_subL)
                         call find_max_real( River%subA, i_in, j_in, num_max_subL, i_out, j_out, num_max_subA )
                         if(num_max_subA == 1) then
                            i_nbr  = i_out(1)
                            j_nbr  = j_out(1)
                            River%order(i,j) = 1 + River%order(i_nbr,j_nbr)
                         else
                            i_nbr  = i_out(1)
                            j_nbr  = j_out(1)
                            River%order(i,j) = 1 + River%order(i_nbr,j_nbr)
                            write(stdout(),*) 'i,j, num_max_subA, i_out, j_out', i,j, &
                                 num_max_subA, i_out(1:num_max_subA), j_out(1:num_max_subA)
                            call mpp_error(NOTE,'river_routing_mod: that is impossible')
                         endif
                      endif
                   endif
                   ! These properties depend on only one input cell
                   River%basinid(i,j) = River%basinid(i_nbr,j_nbr)
                   River%subL(i,j) = River%celllength(i,j) + River%subL(i_nbr,j_nbr)
                   River%subA(i,j) = River%cellarea(i,j)
                   River%basincells(i,j) = 1
                   do n = 1, num_nbrs
                      River%subA(i,j)  = River%subA(i,j)  + River%subA(i_array(n),j_array(n))
                      River%basincells(i,j) = River%basincells(i,j) + River%basincells(i_array(n),j_array(n))
                   enddo
                   ! These properties depend on all the input neighbor cells 
                   !                   River%subA(i,j) = River%cellarea(i,j) + SUMOVER_NEIGHBORS(River%subA(?,?))
                   !                   River%basincells(i,j) = 1 + SUMOVER_NEIGHBORS(River%basincells(?,?))
                   ! update basinid of other neighbors of point (i,j)
                   do n = 1, num_nbrs
                      where(River%basinid == River%basinid(i_array(n),j_array(n)) )  &
                           River%basinid = River%basinid(i,j)
                   enddo
                endif
                if(i == 1) then
                   River%order(nlon+1,j) = River%order(i,j)
                   River%subL(nlon+1,j) = River%subL(i,j)
                else if(i == nlon) then
                   River%order(0,j) = River%order(i,j)
                   River%subL(0,j) = River%subL(i,j)
                endif
             endif
          enddo
       enddo
    enddo

    !--- extend river with travel = 0 , tocell not zero, full land cell an extra points.
    ! Now update properties that are dependent on downstream cells (tocell)
    ! Loop: start at the coast and move upstream
    do i_lo = 1, max_land_order
       do j = 1, nlat
          do i = 1, nlon
             if (River%land_order(i,j) .eq. i_lo) then
                River%travel(i,j) = River%land_order(i,j) - 1
                if (River%travel(i,j) .eq. 0) then
                   River%disttoocean(i,j) = River%celllength(i,j)
                else
                   call get_nbr_index(River%tocell(i,j), i, j, i_array, j_array, num_nbrs)
                   i_nbr = i_array(1)
                   j_nbr = j_array(1)
                   River%disttoocean(i,j) = River%celllength(i,j) + River%disttoocean(i_nbr,j_nbr)
                endif
             endif
          enddo
       enddo
    enddo

    !--- extend river with travel = 0 , tocell not zero, full land cell an extra points.
    ! Now must update pre-existing network (anywhere that it used to go to the ocean and now it goes to land)
    ! Only the three cell attributes which depend on downstream cells need to be updated.
    do j = 1, nlat
       do i = 1, nlon
          if ((River%travel(i,j) .eq. 0) .and. (River%land_order(i,j) .lt. 0) ) then
             call get_nbr_index(River%tocell(i,j), i, j, i_array, j_array, num_nbrs)
             if(num_nbrs == 0) cycle
             i_nbr = i_array(1)
             j_nbr = j_array(1)
             if(River%land_order(i_nbr, j_nbr) .gt. 0) then
                River%travel(i,j) = River%travel(i_nbr, j_nbr) + 1
                !River%travel(i,j) = River%travel(i,j) + River%travel(i_nbr, j_nbr) !??? 
                River%disttoocean(i,j) = River%disttoocean(i,j) + River%disttoocean(i_nbr, j_nbr)
                the_basinid = River%basinid(i,j)
                do jj = 1, nlat
                   do ii = 1, nlon
                      if(River%land_order(ii,jj) .lt. 0 .and. River%basinid(ii,jj) .EQ. the_basinid) then
                         if( is_connected(River%tocell(1:nlon,1:nlat), ii, jj, i, j) )then
                            River%travel(ii,jj) = River%travel(ii,jj) + River%travel(i, j)
                            River%disttoocean(ii,jj) = River%disttoocean(ii,jj) + River%disttoocean(i, j)
                         endif
                      endif
                   enddo
                enddo
             endif
          endif
       enddo
    enddo

    !--- extend river with travel = 0 , tocell not zero, full land cell an extra points.
    !--- deal with in-land ocean, all the in-land ocean will be fefined as isolated river.
    do j = 1, nlat
       do i = 1, nlon
          if (River%land_order(i,j) == 0 ) then
             River%travel(i,j) = 0
             River%basinid(i,j) = next_basinid
             next_basinid = next_basinid + 1
          end if
       end do
    end do

   !--- the cell area will be cell area, not counted percentage of land
    do j = 1, nlat
       do i = 1, nlon
          River%cellarea(i,j) = area(River%lonb(i:i+1), River%latb(j:j+1) )
       end do
    end do

    return

  end subroutine define_new_land_data

  !#####################################################################
  !--- this function will return an integer of power of 2.
  function outflow_direction(neighbor, dist)
    logical, dimension(:), intent(in) :: neighbor
    real, dimension(:),    intent(in) :: dist
    integer                           :: outflow_direction

    integer :: max_count, max_adj, num_set, start(4)
    integer :: i, j, ii, n, outflow, num_min_points, index_min(8)
    logical :: keep_going
    real    :: min_dist

    !--- first find the maximum adjacent ocean points
    start = 0
    max_adj = 0
    num_set = 1
    i = 1

    if(count(neighbor) == 8) then  ! surrouding points are all ocean
       max_adj = 8
       start = 1
    else
       do while (i .le. 8)
          max_count = 0
          if(neighbor(i)) then
             keep_going = .true.
             max_count = 1
             j = i + 1
             do while(keep_going) 
                if(j .gt. 8) j = j-8
                if(neighbor(j)) then
                   max_count = max_count + 1
                else
                   keep_going = .false.
                   exit
                endif
                j = j + 1
             enddo
             if(max_count .gt. max_adj) then
                num_set = 1
                max_adj = max_count
                start(num_set) = i
             else if(max_count .eq. max_adj) then
                num_set = num_set  + 1
                start(num_set) = i
             endif
          endif
          i = i + max_count + 1
       enddo
    endif

    !--- find the outflow direction --------------------------------------
    if(num_set .eq. 1 .and. mod(max_adj,2) == 1) then
       !--- There will be a center point if max_adj is odd  --------------
       outflow = start(1) + max_count/2
       if(outflow .gt. 8) outflow = outflow - 8
    else !--- find the shortest distance point
       min_dist = dist(start(1))
       num_min_points = 1
       index_min(num_min_points) = start(num_set)
       do n = 1, num_set 
          do i = 1, max_adj - 1
             ii = start(n)+i
             if(ii .gt. 8 ) ii = ii - 8
             if(dist(ii) .lt. min_dist) then
                min_dist = dist(ii)
                num_min_points = 1
                index_min(1)   = ii
             else if(dist(ii) .eq. min_dist) then
                num_min_points = num_min_points + 1
                index_min(num_min_points) = ii
             endif
          enddo
       enddo
       if(num_min_points .eq. 1) then   
          outflow = index_min(num_min_points)
       else
          outflow = random_select(index_min(1:num_min_points))
       endif
    endif

    outflow_direction = 2 ** (outflow - 1)

    return

  end function outflow_direction

  !#####################################################################
  !--- calculate inflow direction from outflow data.
  function inflow_direction(outflow)
    integer, dimension(:,:), intent(in) :: outflow
    integer :: inflow_direction

    integer :: i, j
    i = 2;    j = 2    

    inflow_direction = 0
    if( outflow(i+1,j) == 16 )   inflow_direction = inflow_direction + 1
    if( outflow(i+1,j-1) == 32)  inflow_direction = inflow_direction + 2
    if( outflow(i,j-1) == 64)    inflow_direction = inflow_direction + 4
    if( outflow(i-1,j-1) == 128) inflow_direction = inflow_direction + 8
    if( outflow(i-1,j) == 1)     inflow_direction = inflow_direction + 16
    if( outflow(i-1,j+1) == 2)   inflow_direction = inflow_direction + 32
    if( outflow(i,j+1) == 4)     inflow_direction = inflow_direction + 64
    if( outflow(i+1,j+1) == 8)   inflow_direction = inflow_direction + 128

    return
  end function inflow_direction

  !#####################################################################
  !--- find neighbor points.
  function get_neighbor(is_neighbor )
    logical, dimension(:,:), intent(in) :: is_neighbor
    integer                             :: get_neighbor
    integer                             :: i,j

    i=2; j=2

    get_neighbor = 0
    if(is_neighbor(i+1,j))   get_neighbor = get_neighbor + 1
    if(is_neighbor(i+1,j-1)) get_neighbor = get_neighbor + 2
    if(is_neighbor(i,j-1))   get_neighbor = get_neighbor + 4
    if(is_neighbor(i-1,j-1)) get_neighbor = get_neighbor + 8
    if(is_neighbor(i-1,j))   get_neighbor = get_neighbor + 16
    if(is_neighbor(i-1,j+1)) get_neighbor = get_neighbor + 32
    if(is_neighbor(i,j+1))   get_neighbor = get_neighbor + 64
    if(is_neighbor(i+1,j+1)) get_neighbor = get_neighbor + 128

    return
  end function get_neighbor


  !#####################################################################
  ! --- this is only for rectangular grid --------------------------------------
  function area(x, y)
    real, dimension(2), intent(in) :: x,y
    real :: area

    real :: dx
    dx = (x(2)-x(1)) * D2R

    if(dx > PI)  dx = dx - 2.0*PI
    if(dx < -PI) dx = dx + 2.0*PI

    !??? Do we need to multiple radius*radius  
    area = radius*radius*dx*(sin(y(2)*D2R) - sin(y(1)*D2R))

    return

  end function area

  !#####################################################################
  !--- find the distance of any two grid.
  function dist(lon1, lat1, lon2, lat2)
    real, intent(in)           :: lon1,lat1,lon2,lat2
    real                       :: dist

    real :: s1, s2, dx

    dx = lon2 - lon1
    if(dx .gt. 180.) dx = dx - 360.
    if(dx .lt. -180.) dx = dx + 360.

    if(lon1 == lon2) then
       dist = abs(lat2 - lat1) * D2R
    else if(lat1 == lat2) then
       dist = abs(dx) * D2R * cos(lat1*D2R)
    else    ! diagonal distance
       s1 =  abs(dx)  * D2R * cos(lat1*D2R)
       s2 =  abs(lat2 - lat1) * D2R
       dist = sqrt(s1*s1+s2*s2)
    endif
    dist = radius * dist

    return
  end function dist

  !#####################################################################
  !--- find the max value of real data array
  subroutine find_max_real(data, i_in, j_in, num_in, i_out, j_out, num_out)
    real, dimension(0:,0:),  intent(in)  :: data
    integer, dimension(:), intent(in)  :: i_in, j_in
    integer,               intent(in)  :: num_in
    integer, dimension(:), intent(out) :: i_out, j_out
    integer,               intent(out) :: num_out

    integer, dimension(num_in) :: index
    integer                    :: n

    i_out(1) = i_in(1)
    j_out(1) = j_in(1)
    index(1) = 1   
    num_out  = 1  

    do n = 2, num_in
       if(data(i_in(n),j_in(n)) .gt. data(i_out(num_out), j_out(num_out))) then
          num_out = 1
          i_out(num_out) = i_in(n)
          j_out(num_out) = j_in(n)        
          index(num_out) = n
       else if(data(i_in(n),j_in(n)) .eq. data(i_out(num_out), j_out(num_out))) then
          num_out = num_out + 1
          i_out(num_out) = i_in(n)
          j_out(num_out) = j_in(n) 
          index(num_out) = n         
       endif
    enddo

    return
  end subroutine find_max_real

  !#####################################################################
  !--- find the max value of integer data array
  subroutine find_max_int(data, i_in, j_in, num_in, i_out, j_out, num_out)
    integer, dimension(0:,0:), intent(in)  :: data
    integer, dimension(:),   intent(in)  :: i_in, j_in
    integer,                 intent(in)  :: num_in
    integer, dimension(:),   intent(out) :: i_out, j_out
    integer,                 intent(out) :: num_out

    real, dimension(size(data,1), size(data,2) ) :: real_data
    real_data = data

    call find_max_real(real_data, i_in, j_in, num_in, i_out, j_out, num_out)

    return
  end subroutine find_max_int

  !#####################################################################
  !--- remove land point in source data but is ocean recognized by land model.
  subroutine trim_river(River)
    type(river_regrid_type), intent(inout) :: River

    integer, dimension(:,:), allocatable :: land_order
    integer :: i, j
    logical :: need_to_modify

    write(stdout(),*) 'remove previously land point ( is ocean after coupled with land grid). '

    !---set the initial value to some dummy number
    allocate(land_order(nlon, nlat) )
    land_order = -1
    !---find points that have river network info but the land model thinks are ocean points
    do j = 1, nlat
       do i = 1, nlon
          if(River%mask(i,j) .lt. lnd_thresh .and. River%travel(i,j) .ne. missing_value ) land_order(i,j) = 1  
       enddo
    enddo

    !--- continue if there is any land point in the river network to change to ocean
    do while(any(land_order == 1) )
       write(stdout(), *)' number of points land_order == 1', count(land_order == 1)
       write(stdout(), *)' number of points land_order == 1 and travel == 0', &
            count(land_order == 1.and. River%travel==0)
       if(.not.( any((land_order == 1) .and. (River%travel .eq. 0) ) .or. &
            any (land_order == 1 .and. River%travel .gt. 0 .and. River%fromcell .le. 0) )  )then
          do j = 1, nlat
             do i = 1, nlon
                if(land_order(i,j) == 1) then
                   write(stdout(),*)i,j, River%lon(i), &
                        River%lat(j), land_order(i,j), River%travel(i,j)
                endif
             enddo
          enddo
          exit
       endif
       do j =1, nlat
          do i =1, nlon
             !--- first situation: The previously land point is at coast.
             if(land_order(i,j) == 1) then
                need_to_modify = .false.
                if(River%travel(i,j) .eq. 0) then
                   call update_upstream(River,land_order, i,j)   ! coast point
                   need_to_modify = .true.
                   !--- second situation: The previously land point is not at coast and is start point of a river
                else if(River%travel(i,j) .gt. 0 .and. River%fromcell(i,j) .le. 0) then
                   call update_downstream(River,i,j)
                   need_to_modify = .true.
                endif
                if(need_to_modify) then
                   land_order(i,j) = -1        !--- return it to dummy value
                   !--- fill it with nan value
                   River%cellarea(i,j)    = missing_value
                   River%subL(i,j)   = missing_value  
                   River%subA(i,j)   = missing_value
                   River%disttoocean(i,j) = missing_value
                   River%celllength(i,j)  = missing_value
                   River%order(i,j)       = missing_value
                   River%basinid(i,j)     = missing_value
                   River%tocell(i,j)      = missing_value
                   River%fromcell(i,j)    = missing_value
                   River%basincells(i,j)  = missing_value
                   River%travel(i,j)      = missing_value
                endif
             endif
          enddo
       enddo
    enddo

    do while(any(land_order == 1) )
       write(stdout(), *)' number of points land_order == 1', count(land_order == 1)
       if(.not. any(land_order == 1 .and. River%travel .gt. 0 .and. River%fromcell .gt. 0) ) &
            call mpp_error(FATAL,'infinity loop')

       do j =1, nlat
          do i =1, nlon
             !--- first situation: The previously land point is at coast.
             if(land_order(i,j) == 1) then
                if(River%travel(i,j) .gt. 0) then
                   if(River%fromcell(i,j) .gt. 0) call update_upstream(River,land_order,i,j)
                   call update_downstream(River,i,j)
                endif
                land_order(i,j) = -1        !--- return it to dummy value
                !--- fill it with nan value
                River%cellarea(i,j)    = missing_value
                River%subL(i,j)   = missing_value  
                River%subA(i,j)   = missing_value
                River%disttoocean(i,j) = missing_value
                River%celllength(i,j)  = missing_value
                River%order(i,j)       = missing_value
                River%basinid(i,j)     = missing_value
                River%tocell(i,j)      = missing_value
                River%fromcell(i,j)    = missing_value
                River%basincells(i,j)  = missing_value
                River%travel(i,j)      = missing_value
             endif
          enddo
       enddo
    enddo

  end subroutine trim_river

  !#####################################################################
  !--- update downstream points.
  subroutine update_downstream(River,i,j)
    type(river_regrid_type), intent(inout) :: River
    integer,                 intent(in)    :: i,j
    integer :: i_array(8), j_array(8), i_in(8), j_in(8), i_out(8), j_out(8)
    integer :: i_nbr,j_nbr, ii,jj, iii, jjj, num_nbrs
    integer :: num_max_subL, num_max_subA, num_max_order, n, nn
    logical :: keep_going

    call get_nbr_index(River%tocell(i,j), i, j, i_array, j_array, num_nbrs)

    if(num_nbrs .NE. 1) return

       i_nbr = i_array(1); j_nbr = j_array(1)

    if(River%fromcell(i_nbr,j_nbr) == missing_value) return

       call get_nbr_index(River%fromcell(i_nbr,j_nbr), i_nbr, j_nbr, i_array, j_array, num_nbrs)

       ii = i_nbr; jj = j_nbr
       iii = i;    jjj = j
       do while (River%tocell(ii,jj) .gt. 0) 
          call get_nbr_index(River%fromcell(ii,jj), ii, jj, i_array, j_array, num_nbrs)
          if(num_nbrs == 1) then
             if(i_array(1) == i .and. j_array(1) == j) then
                River%order(ii,jj) = 1
             else
                River%order(ii,jj) =  River%order(i_array(1), j_array(1))
             endif
             River%subL(ii,jj) = River%subL(ii,jj) - River%subL(i,j)
          else 
             !--- first find the largest order
             i_in(1:num_nbrs) = i_array(1:num_nbrs)
             j_in(1:num_nbrs) = j_array(1:num_nbrs)
             call find_max_int ( River%order, i_in, j_in, num_nbrs, i_out, j_out, num_max_order ) 
             ! if (iii,jjj) is not among the points with max order, we can stop
             keep_going = .false.
             do n = 1, num_max_order
                if(i_out(n) .eq. iii .and. j_out(n) .eq. jjj) keep_going = .true.
             enddo
             if(.not. keep_going) exit

             if( num_max_order == 1) then
                River%subL(ii,jj) = River%subL(ii,jj) - River%subL(i,j)
                nn = 0
                do n = 1, num_nbrs
                   if( .not. (i_in(n) == i .and. j_in(n) == j ) ) then
                      nn = nn + 1
                      i_in(nn) = i_in(n)
                      j_in(nn) = j_in(n)
                   endif
                enddo
                call find_max_int(River%order, i_in, j_in, nn, i_out, j_out, num_max_order) 
                if(num_max_order == 1 )then
                   River%order(ii,jj) = River%order(i_out(1), j_out(1) )
                else
                   River%order(ii,jj) = River%order(i_out(1), j_out(1) ) + 1
                endif
                ! no neighbor is the clear mainstem (by stream order)
             else   ! multiple neighbors feeding in have the same, max(order)) 
                ! determine mainstem by largest subL, then largest subA, then arbitrary

                !--- if num_max_order is greater than 2, do not need to modify order.
                if(num_max_order .gt. 2) exit

                if(iii == i .and. jjj == j) then   !--- (iii, jjj ) is the point we are going to remove
                   keep_going = .false.
                   do n = 1, num_max_order
                      if( i_out(n) .eq. i .and. j_out(n) .eq. j) then
                         River%order(ii,jj) = River%order(i_out(1), j_out(1) )
                         keep_going = .true.
                      endif
                   enddo
                else                               !--- (iii, jjj ) is not the point we are going to remove
                   if(River%order(ii,jj) == River%order(i_out(1), j_out(1)) +1 ) then
                      keep_going = .false.
                   else
                      River%order(ii,jj) = River%order(i_out(1), j_out(1) ) + 1
                   endif
                endif
                if(.not. keep_going) exit

                !--- change subL.
                i_in(1:num_max_order) = i_out(1:num_max_order)
                j_in(1:num_max_order) = j_out(1:num_max_order)
                call find_max_real( River%subL, i_in, j_in, num_max_order, i_out, j_out, num_max_subL )
                if(num_max_subL == 1) then
                   if(i_out(1) .eq. iii .and. j_out(1) .eq. jjj) then
                      River%subL(ii,jj) = River%subL(ii,jj) - River%subL(i,j)
                   else
                      exit
                   endif
                else 
                   i_in(1:num_max_subL) = i_out(1:num_max_subL)
                   j_in(1:num_max_subL) = j_out(1:num_max_subL)
                   call find_max_real( River%subA, i_in, j_in, num_max_subL, i_out, j_out, num_max_subA )
                   if(num_max_subA == 1) then
                      if(i_out(1) .eq. iii .and. j_out(1) .eq. jjj) then
                         River%subL(ii,jj) = River%subL(ii,jj) - River%subL(i,j)
                      else
                         exit
                      endif
                   else
                      exit
                      call mpp_error(FATAL,'river_routing_mod: that is impossible')
                   endif
                endif
             endif
          endif
          call get_nbr_index(River%tocell(ii,jj), ii, jj, i_array, j_array, num_nbrs)                   
          iii = ii;         jjj = jj
          ii  = i_array(1); jj = j_array(1)
       enddo
 
       ii = i_nbr; jj = j_nbr
       do while(River%tocell(ii,jj) > 0)
          River%subA(ii,jj) = River%subA(ii,jj) - River%subA(i,j)
          River%basincells(ii,jj) = River%basincells(ii,jj) - River%basincells(i,j)                    
          call get_nbr_index(River%tocell(ii,jj), ii, jj, i_array, j_array, num_nbrs)
          if(num_nbrs .ne. 1) then
             call mpp_error(FATAL,'num_nbrs should be 1 here' )
          endif
          ii = i_array(1); jj = j_array(1)
       enddo

       if(River%tocell(i,j) .lt. 16) then
          River%fromcell(i_nbr,j_nbr) = River%fromcell(i_nbr,j_nbr) - River%tocell(i,j)*16
       else if(River%tocell(i,j) .ge. 16) then
          River%fromcell(i_nbr,j_nbr) = River%fromcell(i_nbr,j_nbr) - River%tocell(i,j)/16
       endif

  end subroutine update_downstream

  !#######################################################################
  !--- update upstream points
  subroutine update_upstream(River, land_order, i, j)
    type(river_regrid_type), intent(inout) :: River
    integer, dimension(:,:), intent(in)    :: land_order
    integer,                 intent(in)    :: i,j

    integer :: i_array(8), j_array(8)
    integer :: ii,jj, num_nbrs, n
    logical :: connect

    call get_nbr_index(River%fromcell(i,j), i, j, i_array, j_array, num_nbrs)

    do n = 1, num_nbrs
       !--- if the from cell also need to be removed, will update upstream through the from cell.
       if(land_order(i_array(n),j_array(n)) == 1) cycle

       River%basinid(i_array(n),j_array(n)) = next_basinid
       River%travel(i_array(n),j_array(n)) = River%travel(i_array(n),j_array(n)) - River%travel(i,j) - 1
       River%disttoocean(i_array(n),j_array(n)) = &
            River%disttoocean(i_array(n),j_array(n)) - River%disttoocean(i,j)

       !--- Search all the points to see which point is connected with i_array(n), j_array(n)
       do jj = 1, nlat
          do ii = 1, nlon
             if(River%basinid(ii,jj) .eq. River%basinid(i,j) ) then
                connect = is_connected(River%tocell(1:nlon,1:nlat), ii, jj, i_array(n), j_array(n))
                if( connect) then
                   River%basinid(ii,jj) = next_basinid
                   River%travel(ii,jj) = River%travel(ii,jj) - River%travel(i,j) - 1
                   River%disttoocean(ii,jj) = River%disttoocean(ii,jj) - River%disttoocean(i,j)
                endif
             endif
          enddo
       enddo
       next_basinid = next_basinid + 1
    enddo

  end subroutine update_upstream

  !#####################################################################
  !--- check if two point are connected by a river
  function is_connected(tocell, i, j, i_dst, j_dst)
    integer, dimension(:,:), intent(in) :: tocell
    integer,                 intent(in) :: i, j, i_dst, j_dst            
    logical                             :: is_connected

    integer :: cell, ii, jj, m, n, num_nbr, i_array(8), j_array(8)

    is_connected = .false.
    cell = tocell(i,j)
    ii = i; jj = j
    do while(cell .gt. 0)
       call get_nbr_index(cell, ii, jj, i_array, j_array, num_nbr)
       if(num_nbr .ne. 1) call mpp_error(FATAL,'river_regrid: num_nbr should be 1')
       m = i_array(1); n = j_array(1)
       if(m == i_dst .and. n == j_dst) then
          is_connected = .true.
          return
       else
          cell = tocell(m,n)
          ii = m; jj = n
       endif

    enddo

  end function is_connected

  !#####################################################################
  !--- random select a direction.
  function random_select(array)
    integer, dimension(:), intent(in) :: array
    integer :: random_select

    integer, save :: prev = 0
    integer :: i, num_ele
    num_ele = size(array)

    do 
       prev = prev + 1
       if(prev .gt. 8) prev = prev - 8
       do i = 1, num_ele
          if(array(i) .eq. prev) then
             random_select = prev
             return
          endif
       enddo

    enddo

  end function random_select

  !#####################################################################
  !--- get the index of neighbor point
  subroutine get_nbr_index(number, i_in, j_in, i_out, j_out, num_nbr)
    integer,               intent(in)  :: number        !number should be between 0 to 255
    integer,               intent(in)  :: i_in, j_in    
    integer, dimension(:), intent(out) :: i_out, j_out
    integer,               intent(out) :: num_nbr
    integer                            :: n

    num_nbr = 0
    n = number

    if(n .ge. 128) then
       num_nbr = num_nbr + 1
       n = n - 128
       i_out(num_nbr) = i_in+1; j_out(num_nbr) = j_in + 1
    endif
    if(n .ge. 64) then
       num_nbr = num_nbr + 1
       n = n - 64
       i_out(num_nbr) = i_in; j_out(num_nbr) = j_in + 1
    endif
    if(n .ge. 32) then
       num_nbr = num_nbr + 1
       n = n - 32
       i_out(num_nbr) = i_in-1; j_out(num_nbr) = j_in + 1
    endif
    if(n .ge. 16) then
       num_nbr = num_nbr + 1
       n = n - 16
       i_out(num_nbr) = i_in-1; j_out(num_nbr) = j_in 
    endif
    if(n .ge. 8) then
       num_nbr = num_nbr + 1
       n = n - 8
       i_out(num_nbr) = i_in-1; j_out(num_nbr) = j_in - 1
    endif
    if(n .ge. 4) then
       num_nbr = num_nbr + 1
       n = n - 4
       i_out(num_nbr) = i_in; j_out(num_nbr) = j_in - 1
    endif
    if(n .ge. 2) then
       num_nbr = num_nbr + 1
       n = n - 2
       i_out(num_nbr) = i_in+1; j_out(num_nbr) = j_in - 1
    endif
    if(n .ge. 1) then
       num_nbr = num_nbr + 1
       n = n - 1
       i_out(num_nbr) = i_in+1; j_out(num_nbr) = j_in
    endif

    do n = 1, num_nbr
       if(i_out(n) .eq. nlon+1) i_out(n) = 1
       if(i_out(n) .eq. 0)    i_out(n) = nlon
       if(j_out(n) .eq. 0 .or. j_out(n) .eq. nlat+1) &
            call mpp_error(FATAL,'river_regrid: neighbor latitude index should be between 1 and nj')
    enddo

    return
  end subroutine get_nbr_index

  !#####################################################################
  ! define river grid mask. river mask will be defined through ocean land/sea mask.
  ! conservative remapping will be done from ocean grid onto river grid.
  subroutine define_river_mask(River)
    type(river_regrid_type), intent(inout) :: River
    integer                                :: i, j, layout(2), isc, iec, jsc, jec
    integer                                :: siz(4), nlon_ocn, nlat_ocn
    real, dimension(:,:,:),    allocatable :: x_vert_t, y_vert_t
    real, dimension(:,:),      allocatable :: x_vert_ocn, y_vert_ocn
    real, dimension(:,:),      allocatable :: local_mask, global_mask
    type(horiz_interp_type)                :: Interp
    type(domain2D)                         :: Domain
    real                                   :: diff
    real, parameter                        :: small = 1.e-6

    River%mask = 0  ! 0 means ocean points

    !--- read ocean grid location and land/sea mask.
    call field_size(grid_file, 'wet', siz)
    nlon_ocn = siz(1)
    nlat_ocn = siz(2)
    allocate(x_vert_ocn(nlon_ocn+1, nlat_ocn+1))
    allocate(y_vert_ocn(nlon_ocn+1, nlat_ocn+1))
    allocate(mask_ocn  (nlon_ocn,   nlat_ocn  ))
    allocate(lon_ocn   (nlon_ocn,   nlat_ocn  ))
    allocate(lat_ocn   (nlon_ocn,   nlat_ocn  ))
    call read_data(grid_file, 'wet', mask_ocn, no_domain=.true.)
    if(field_exist(grid_file, 'geolon_vert_t') )then
       call read_data(grid_file, 'geolon_vert_t', x_vert_ocn, no_domain=.true.)
       call read_data(grid_file, 'geolat_vert_t', y_vert_ocn, no_domain=.true.)
       call read_data(grid_file, 'geolon_t', lon_ocn, no_domain=.true.)
       call read_data(grid_file, 'geolat_t', lat_ocn, no_domain=.true.)       
    else if(field_exist(grid_file, 'x_vert_T') )then
       allocate(x_vert_t(nlon_ocn, nlat_ocn, 4))
       allocate(y_vert_t(nlon_ocn, nlat_ocn, 4))
       call read_data(grid_file, 'x_vert_T', x_vert_t, no_domain=.true.)
       call read_data(grid_file, 'y_vert_T', y_vert_t, no_domain=.true.)
       call read_data(grid_file, 'x_T', lon_ocn, no_domain=.true.)
       call read_data(grid_file, 'y_T', lat_ocn, no_domain=.true.)
       x_vert_ocn(1:nlon_ocn,1:nlat_ocn) = x_vert_t(1:nlon_ocn,1:nlat_ocn,1)
       x_vert_ocn(nlon_ocn+1,1:nlat_ocn) = x_vert_t(nlon_ocn,1:nlat_ocn,2)
       x_vert_ocn(1:nlon_ocn,nlat_ocn+1) = x_vert_t(1:nlon_ocn,nlat_ocn,4)
       x_vert_ocn(nlon_ocn+1,nlat_ocn+1) = x_vert_t(nlon_ocn,nlat_ocn,3)
       y_vert_ocn(1:nlon_ocn,1:nlat_ocn) = y_vert_t(1:nlon_ocn,1:nlat_ocn,1)
       y_vert_ocn(nlon_ocn+1,1:nlat_ocn) = y_vert_t(nlon_ocn,1:nlat_ocn,2)
       y_vert_ocn(1:nlon_ocn,nlat_ocn+1) = y_vert_t(1:nlon_ocn,nlat_ocn,4)
       y_vert_ocn(nlon_ocn+1,nlat_ocn+1) = y_vert_t(nlon_ocn,nlat_ocn,3)
       deallocate(x_vert_t)
       deallocate(y_vert_t)
    else
       call mpp_error(FATAL,'river_regrid: both geolon_vert_t and x_vert_T do not exist in file '//trim(grid_file))
    end if

    ! There is some truncation error in some latitude, adjust the small difference for non-folded region
    do j = 1, nlat_ocn+1
       if(ANY( y_vert_ocn(:,j) .NE. y_vert_ocn(1,j)) ) exit
       diff = abs(y_vert_ocn(1,j) - int(y_vert_ocn(1,j)))
       if( diff < small .AND. diff > 0) then
          write(stdout(),*)'y_vert_ocn is adjusted from ', y_vert_ocn(1,j), ' to ', int(y_vert_ocn(1,j)), ' at j = ', j
          y_vert_ocn(:,j) = int(y_vert_ocn(1,j))

       end if
    end do    

    do j = 1, nlat_ocn
       if(ANY( lat_ocn(:,j) .NE. lat_ocn(1,j)) ) exit
       if( abs(lat_ocn(1,j) - int(lat_ocn(1,j))) < small ) then
          lat_ocn(:,j) = int(lat_ocn(1,j))
       end if
    end do    

    call horiz_interp_init
    ! The following procedure is very expensive, so parallization is needed
    call mpp_define_layout( (/1,nlon,1,nlat/), mpp_npes(), layout)
    call mpp_define_domains((/1,nlon,1,nlat/),layout, Domain,xhalo=0,yhalo=0)
    call mpp_get_compute_domain( Domain, isc, iec, jsc, jec )
    call horiz_interp_new(Interp, x_vert_ocn*DEG_TO_RAD, y_vert_ocn*DEG_TO_RAD, River%lonb(isc:iec+1)*DEG_TO_RAD, &
                          River%latb(jsc:jec+1)*DEG_TO_RAD, interp_method='conservative' )
    allocate(local_mask(isc:iec,jsc:jec), global_mask(nlon,nlat))
    call horiz_interp(Interp, mask_ocn, local_mask)
    call mpp_global_field(Domain, local_mask, global_mask)
    River%mask(1:nlon,1:nlat) = global_mask
    call horiz_interp_del(Interp)
    deallocate(x_vert_ocn, y_vert_ocn, local_mask, global_mask)

    !--- currently the mask is the ocean mask.
    do j = 1, nlat
       do i = 1, nlon
          River%mask(i,j) = 1 - River%mask(i,j)
          if( abs(River%mask(i,j)) < lnd_thresh ) River%mask(i,j) = 0.0
          if( abs(River%mask(i,j)-1) < lnd_thresh) River%mask(i,j) = 1.0
          if( River%mask(i,j) < 0 .or. River%mask(i,j) > 1) &
             call mpp_error(FATAL,'river_regrid: river mask should be between 0 or 1')
       end do
    end do

    !--- here we suppose the cyclic condition exists
    call update_halo(River%mask(-1:nlon+2,1:nlat), 2)

    !--- set mask to large positive value for the purpose of defining neighbor points.
    River%mask(:,-1:0) = 999.0
    River%mask(:,nlat+1:nlat+2) = 999.0

   end subroutine define_river_mask

  !#####################################################################
  !--- update point on the global halo.
  subroutine update_halo(data, halo)
    integer,                       intent(in) :: halo
    real, dimension(1-halo:,:), intent(inout) :: data

    integer                             :: n, ni

    ni = size(data,1) - 2*halo
    do n = 1, halo

       data(1-n,:)      = data(ni+1-n,:)
       data(ni+n,:) = data(halo,:)

    enddo

  end subroutine update_halo

  !#####################################################################
  !--- read each line of the file grid_edits
  subroutine parse_edits(txt,is,ie,js,je,flag)

    character(len=*), intent(in) :: txt
    integer, intent(inout)       :: is,ie,js,je
    logical, intent(inout)       :: flag

    integer :: i1,i2, i3
    character(len=128) :: txt2

    flag = .true.
    i1 = scan(txt,',')
    if (i1 <= 0) goto 90

    txt2 = txt(1:i1-1)

    i2 = scan(txt2,':')
    if (i2 <= 0) then
       read(txt2,*,err=90) is
       ie = is
    else
       read(txt2(1:i2-1),*,err=90) is
       read(txt2(i2+1:),*,err=90) ie
    endif

    txt2 = txt(i1+1:)
 
    i3 = scan(txt2,':')
     if (i3 <= 0) then
       read(txt2,*,err=90) js
       je = js
    else
       read(txt2(1:i3-1),*,err=90) js
       read(txt2(i3+1:),*,err=90) je
    endif

    return

90  continue

    flag = .false.

    return
  end subroutine parse_edits

  !#####################################################################


end program river_regrid

module vegetation_mod

#include "../shared/debug.inc"
#include "../shared/concat.inc"

#ifdef INTERNAL_FILE_NML
use mpp_mod, only: input_nml_file
#else
use fms_mod, only: open_namelist_file
#endif

use fms_mod, only: write_version_number, error_mesg, NOTE,FATAL, file_exist, close_file, &
                   check_nml_error, stdlog 
use mpp_mod, only: mpp_sum, mpp_max, mpp_pe, mpp_root_pe
use time_manager_mod, only: time_type, time_type_to_real, get_date, operator(-)
use constants_mod,    only: tfreeze, rdgas, rvgas, hlv, hlf, cp_air, PI
use sphum_mod, only: qscomp
use nf_utils_mod, only: nfu_def_var, nfu_get_var, nfu_put_var, nfu_inq_var

use vegn_tile_mod, only: vegn_tile_type, &
     vegn_seed_demand, vegn_seed_supply, vegn_add_bliving, &
     cpw, clw, csw
use soil_tile_mod, only: soil_tile_type, soil_ave_temp, &
                         soil_ave_theta0, soil_ave_theta1, soil_psi_stress
use land_constants_mod, only : NBANDS, BAND_VIS, d608, mol_C, mol_CO2, mol_air, &
     seconds_per_year
use land_tile_mod, only : land_tile_type, land_tile_enum_type, &
     first_elmt, tail_elmt, next_elmt, current_tile, operator(/=), &
     get_elmt_indices
use land_tile_diag_mod, only : &
     register_tiled_static_field, register_tiled_diag_field, &
     send_tile_data, diag_buff_type
use land_data_mod,      only : land_state_type, lnd
use land_io_mod, only : read_field
use land_tile_io_mod, only : &
     create_tile_out_file, &
     write_tile_data_r0d_fptr, write_tile_data_i0d_fptr, write_tile_data_r1d_fptr, &
     read_tile_data_r0d_fptr,  read_tile_data_i0d_fptr,  read_tile_data_r1d_fptr, &
     print_netcdf_error, get_input_restart_name
use vegn_data_mod, only : SP_C4GRASS, LEAF_ON, LU_NTRL, read_vegn_data_namelist, &
     tau_drip_l, tau_drip_s, T_transp_min, cold_month_threshold, soil_carbon_depth_scale, &
     fsc_pool_spending_time, ssc_pool_spending_time, harvest_spending_time, &
     N_HARV_POOLS, HARV_POOL_NAMES
use vegn_cohort_mod, only : vegn_cohort_type, vegn_phys_prog_type, &
     update_species,&
     vegn_data_heat_capacity, vegn_data_intrcptn_cap, &
     get_vegn_wet_frac, vegn_data_cover
use canopy_air_mod, only : cana_turbulence
     
use cohort_io_mod, only :  read_create_cohorts, create_cohort_dimension, &
     read_cohort_data_r0d_fptr,  read_cohort_data_i0d_fptr,&
     write_cohort_data_r0d_fptr, write_cohort_data_i0d_fptr
use land_debug_mod, only : is_watch_point, set_current_point, check_temp_range
use vegn_radiation_mod, only : vegn_radiation_init, vegn_radiation
use vegn_photosynthesis_mod, only : vegn_photosynthesis_init, vegn_photosynthesis
use static_vegn_mod, only : read_static_vegn_namelist, static_vegn_init, static_vegn_end, &
     read_static_vegn
use vegn_dynamics_mod, only : vegn_dynamics_init, vegn_carbon_int, vegn_growth, &
     vegn_daily_npp, vegn_phenology, vegn_biogeography
use vegn_disturbance_mod, only : vegn_nat_mortality, vegn_disturbance, update_fuel
use vegn_harvesting_mod, only : &
     vegn_harvesting_init, vegn_harvesting_end, vegn_harvesting

implicit none
private

! ==== public interfaces =====================================================
public :: read_vegn_namelist
public :: vegn_init
public :: vegn_end
public :: save_vegn_restart

public :: vegn_get_cover
public :: vegn_radiation
public :: vegn_diffusion

public :: vegn_step_1
public :: vegn_step_2
public :: vegn_step_3

public :: update_vegn_slow
! ==== end of public interfaces ==============================================

! ==== module constants ======================================================
character(len=*), private, parameter :: &
   version = '$Id: vegetation.F90,v 20.0 2013/12/13 23:30:58 fms Exp $', &
   tagname = '$Name: tikal $', &
   module_name = 'vegn'
! values for internal selector of CO2 option used for photosynthesis
integer, parameter :: VEGN_PHOT_CO2_PRESCRIBED  = 1
integer, parameter :: VEGN_PHOT_CO2_INTERACTIVE = 2


! ==== module variables ======================================================

!---- namelist ---------------------------------------------------------------
logical :: lm2               = .false.
real    :: init_Wl           = 0
real    :: init_Ws           = 0
real    :: init_Tv           = 288.
real    :: init_cohort_bl    = 0.05 ! initial biomass of leaves, kg C/m2
real    :: init_cohort_blv   = 0.0  ! initial biomass of labile store, kg C/m2
real    :: init_cohort_br    = 0.05 ! initial biomass of fine roots, kg C/m2
real    :: init_cohort_bsw   = 0.05 ! initial biomass of sapwood, kg C/m2
real    :: init_cohort_bwood = 0.05 ! initial biomass of heartwood, kg C/m2
real    :: init_cohort_cmc   = 0.0  ! initial intercepted water
character(32) :: rad_to_use = 'big-leaf' ! or 'two-stream'
character(32) :: snow_rad_to_use = 'ignore' ! or 'paint-leaves'
character(32) :: photosynthesis_to_use = 'simple' ! or 'leuning'
character(32) :: co2_to_use_for_photosynthesis = 'prescribed' ! or 'interactive'
   ! specifies what co2 concentration to use for photosynthesis calculations: 
   ! 'prescribed'  : a prescribed value is used, equal to co2_for_photosynthesis
   !      specified below.
   ! 'interactive' : concentration of co2 in canopy air is used
real    :: co2_for_photosynthesis = 350.0e-6 ! concentration of co2 for photosynthesis 
   ! calculations, mol/mol. Ignored if co2_to_use_for_photosynthesis is not 'prescribed'
character(32) :: soil_decomp_option = 'use_ave_t_and_theta' ! or 'use_layer_t_and_theta'
logical :: do_cohort_dynamics   = .TRUE. ! if true, do vegetation growth
logical :: do_patch_disturbance = .TRUE. ! 
logical :: do_phenology         = .TRUE. 
logical :: xwilt_available      = .TRUE.
logical :: do_biogeography      = .TRUE.
logical :: do_seed_transport    = .TRUE.
real    :: min_Wl=-1.0, min_Ws=-1.0 ! threshold values for condensation numerics, kg/m2:
   ! if water or snow on canopy fall below these values, the derivatives of
   ! condensation are set to zero, thereby prohibiting switching from condensation to
   ! evaporation in one time step.
real    :: tau_smooth_ncm = 0.0 ! Time scale for ncm smoothing
   ! (low-pass filtering), years. 0.0 retrieves previous behavior (no smoothing)
real :: rav_lit_0         = 0.0 ! constant litter resistance to vapor
real :: rav_lit_vi        = 0.0 ! litter resistance to vapor per LAI+SAI
real :: rav_lit_fsc       = 0.0 ! litter resistance to vapor per fsc
real :: rav_lit_ssc       = 0.0 ! litter resistance to vapor per ssc
real :: rav_lit_bwood     = 0.0 ! litter resistance to vapor per bwood
namelist /vegn_nml/ &
    lm2, init_Wl, init_Ws, init_Tv, cpw, clw, csw, &
    init_cohort_bl, init_cohort_blv, init_cohort_br, init_cohort_bsw, &
    init_cohort_bwood, init_cohort_cmc, &
    rad_to_use, snow_rad_to_use, photosynthesis_to_use, &
    co2_to_use_for_photosynthesis, co2_for_photosynthesis, &
    soil_decomp_option, &
    do_cohort_dynamics, do_patch_disturbance, do_phenology, &
    xwilt_available, &
    do_biogeography, do_seed_transport, &
    min_Wl, min_Ws, tau_smooth_ncm, &
    rav_lit_0, rav_lit_vi, rav_lit_fsc, rav_lit_ssc, rav_lit_bwood
    
!---- end of namelist --------------------------------------------------------

logical         :: module_is_initialized =.FALSE.
type(time_type) :: time ! *** NOT YET USED
real            :: delta_time      ! fast time step
real            :: dt_fast_yr      ! fast time step in years
integer         :: vegn_phot_co2_option = -1 ! internal selector of co2 option 
                                   ! used for photosynthesis
! diagnostic field ids
integer :: id_vegn_type, id_temp, id_wl, id_ws, id_height, id_lai, id_sai, id_leaf_size, &
   id_root_density, id_root_zeta, id_rs_min, id_leaf_refl, id_leaf_tran,&
   id_leaf_emis, id_snow_crit, id_stomatal, id_an_op, id_an_cl, &
   id_bl, id_blv, id_br, id_bsw, id_bwood, id_btot, id_species, id_status, &
   id_con_v_h, id_con_v_v, id_fuel, id_harv_pool(N_HARV_POOLS), &
   id_harv_rate(N_HARV_POOLS), id_t_harv_pool, id_t_harv_rate, &
   id_csmoke_pool, id_csmoke_rate, id_fsc_in, id_fsc_out, id_ssc_in, &
   id_ssc_out, id_veg_in, id_veg_out, id_fsc_pool, id_fsc_rate, &
   id_ssc_pool, id_ssc_rate, id_t_ann, id_t_cold, id_p_ann, id_ncm, &
   id_lambda, id_afire, id_atfall, id_closs, id_cgain, id_wdgain, id_leaf_age, &
   id_phot_co2, id_theph, id_psiph, id_evap_demand
! ==== end of module variables ===============================================

! ==== NetCDF declarations ===================================================
include 'netcdf.inc'
#define __NF_ASRT__(x) call print_netcdf_error((x),module_name,__LINE__)

contains

! ============================================================================
subroutine read_vegn_namelist()
  ! ---- local vars
  integer :: unit         ! unit for namelist i/o
  integer :: io           ! i/o status for the namelist
  integer :: ierr         ! error code, returned by i/o routines
  logical :: use_static_veg ! if true, switch off vegetation dynamics

  call read_vegn_data_namelist()
  call read_static_vegn_namelist(use_static_veg)

  call write_version_number(version, tagname)
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=vegn_nml, iostat=io)
    ierr = check_nml_error(io, 'vegn_nml')
#else
  if (file_exist('input.nml')) then
     unit = open_namelist_file()
     ierr = 1;  
     do while (ierr /= 0)
        read (unit, nml=vegn_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'vegn_nml')
     enddo
10   continue
     call close_file (unit)
  endif
#endif

  unit=stdlog()

  ! switch off vegetation dynamics if static vegetation is set
  if (use_static_veg) then
     call error_mesg('vegn_init', &
          'use_static_veg=.TRUE., switching off vegetation dynamics', NOTE)
     write(unit,*)'use_static_veg=.TRUE., switching off vegetation dynamics'
     do_cohort_dynamics   = .FALSE.
     do_patch_disturbance = .FALSE.
     do_phenology         = .FALSE. 
     do_biogeography      = .FALSE.
     do_seed_transport    = .FALSE.
  endif

  if (mpp_pe() == mpp_root_pe()) then
     write(unit, nml=vegn_nml)
  endif

  ! convert symbolic names of photosynthesis CO2 options into numeric IDs to
  ! speed up selection during run-time
  if (trim(co2_to_use_for_photosynthesis)=='prescribed') then
     vegn_phot_co2_option = VEGN_PHOT_CO2_PRESCRIBED
  else if (trim(co2_to_use_for_photosynthesis)=='interactive') then
     vegn_phot_co2_option = VEGN_PHOT_CO2_INTERACTIVE
  else
     call error_mesg('vegn_init',&
          'vegetation photosynthesis option co2_to_use_for_photosynthesis="'//&
          trim(co2_to_use_for_photosynthesis)//'" is invalid, use "prescribed" or "interactive"',&
          FATAL)
  endif

  ! ---- initialize vegetation radiation options
  call vegn_radiation_init(rad_to_use, snow_rad_to_use)

  ! ---- initialize vegetation photosynthesis options
  call vegn_photosynthesis_init(photosynthesis_to_use)

end subroutine read_vegn_namelist


! ============================================================================
! initialize vegetation
subroutine vegn_init ( id_lon, id_lat, id_band )
  integer, intent(in) :: id_lon  ! ID of land longitude (X) axis  
  integer, intent(in) :: id_lat  ! ID of land latitude (Y) axis
  integer, intent(in) :: id_band ! ID of spectral band axis

  ! ---- local vars
  integer :: unit         ! unit for various i/o
  type(land_tile_enum_type)     :: te,ce ! current and tail tile list elements
  type(land_tile_type), pointer :: tile  ! pointer to current tile
  type(vegn_cohort_type), pointer :: cohort! pointer to initial cohort for cold-start
  integer :: n_accum
  integer :: nmn_acm
  character(len=256) :: restart_file_name_1, restart_file_name_2
  logical :: restart_1_exists, restart_2_exists
  real, allocatable :: t_ann(:,:),t_cold(:,:),p_ann(:,:),ncm(:,:) ! buffers for biodata reading 
  logical :: did_read_biodata = .FALSE.
  integer :: i,j ! indices of current tile

  module_is_initialized = .TRUE.

  ! ---- make module copy of time and calculate time step ------------------
  time       = lnd%time
  delta_time = time_type_to_real(lnd%dt_fast)
  dt_fast_yr = delta_time/seconds_per_year


  ! ---- initialize vegn state ---------------------------------------------
  n_accum = 0
  nmn_acm = 0
  call get_input_restart_name('INPUT/vegn1.res.nc',restart_1_exists, restart_file_name_1)
  call get_input_restart_name('INPUT/vegn2.res.nc',restart_2_exists, restart_file_name_2)
  if (restart_1_exists) then
     call error_mesg('vegn_init',&
          'reading NetCDF restarts "'//trim(restart_file_name_1)//&
                            '" and "'//trim(restart_file_name_2)//'"',&
          NOTE)
     __NF_ASRT__(nf_open(restart_file_name_1,NF_NOWRITE,unit))
     ! read the cohort index and generate appropriate number of cohorts
     ! for each vegetation tile
     call read_create_cohorts(unit)
     
     ! read cohort data
     call read_cohort_data_r0d_fptr(unit, 'tv', cohort_tv_ptr )
     call read_cohort_data_r0d_fptr(unit, 'wl', cohort_wl_ptr )
     call read_cohort_data_r0d_fptr(unit, 'ws', cohort_ws_ptr )
     __NF_ASRT__(nf_close(unit))     

     __NF_ASRT__(nf_open(restart_file_name_2,NF_NOWRITE,unit))
     ! read global variables
     __NF_ASRT__(nfu_get_var(unit,'n_accum',n_accum))
     __NF_ASRT__(nfu_get_var(unit,'nmn_acm',nmn_acm))

     call read_cohort_data_i0d_fptr(unit, 'species', cohort_species_ptr )
     call read_cohort_data_r0d_fptr(unit, 'hite', cohort_height_ptr )
     call read_cohort_data_r0d_fptr(unit, 'bl', cohort_bl_ptr )
     call read_cohort_data_r0d_fptr(unit, 'blv', cohort_blv_ptr )
     call read_cohort_data_r0d_fptr(unit, 'br', cohort_br_ptr )
     call read_cohort_data_r0d_fptr(unit, 'bsw', cohort_bsw_ptr )
     call read_cohort_data_r0d_fptr(unit, 'bwood', cohort_bwood_ptr )
     call read_cohort_data_r0d_fptr(unit, 'bliving', cohort_bliving_ptr )
     call read_cohort_data_i0d_fptr(unit, 'status', cohort_status_ptr )
     if(nfu_inq_var(unit,'leaf_age')==NF_NOERR) &
          call read_cohort_data_r0d_fptr(unit,'leaf_age',cohort_leaf_age_ptr)
     call read_cohort_data_r0d_fptr(unit, 'npp_prev_day', cohort_npp_previous_day_ptr )

     if(nfu_inq_var(unit,'landuse')==NF_NOERR) &
          call read_tile_data_i0d_fptr(unit,'landuse',vegn_landuse_ptr)
     call read_tile_data_r0d_fptr(unit,'age',vegn_age_ptr)
     call read_tile_data_r0d_fptr(unit,'fsc_pool',vegn_fsc_pool_ptr)
     call read_tile_data_r0d_fptr(unit,'fsc_rate',vegn_fsc_rate_ptr)
     call read_tile_data_r0d_fptr(unit,'ssc_pool',vegn_ssc_pool_ptr)
     call read_tile_data_r0d_fptr(unit,'ssc_rate',vegn_ssc_rate_ptr)
     ! monthly-mean values
     call read_tile_data_r0d_fptr(unit,'tc_av', vegn_tc_av_ptr)
     if(nfu_inq_var(unit,'theta_av_phen')==NF_NOERR) then
        call read_tile_data_r0d_fptr(unit,'theta_av_phen', vegn_theta_av_phen_ptr)
        call read_tile_data_r0d_fptr(unit,'theta_av_fire', vegn_theta_av_fire_ptr)
        call read_tile_data_r0d_fptr(unit,'psist_av', vegn_psist_av_ptr)
     else
        call read_tile_data_r0d_fptr(unit,'theta_av', vegn_theta_av_phen_ptr)
        call read_tile_data_r0d_fptr(unit,'theta_av', vegn_theta_av_fire_ptr)
	! psist_av remains at initial value (equal to 0)
     endif
     call read_tile_data_r0d_fptr(unit,'tsoil_av', vegn_tsoil_av_ptr)
     call read_tile_data_r0d_fptr(unit,'precip_av', vegn_precip_av_ptr)
     call read_tile_data_r0d_fptr(unit,'lambda', vegn_lambda_ptr)
     call read_tile_data_r0d_fptr(unit,'fuel', vegn_fuel_ptr)
     ! annual-mean values
     call read_tile_data_r0d_fptr(unit,'t_ann', vegn_t_ann_ptr)
     call read_tile_data_r0d_fptr(unit,'t_cold', vegn_t_cold_ptr)
     call read_tile_data_r0d_fptr(unit,'p_ann', vegn_p_ann_ptr)
     call read_tile_data_r0d_fptr(unit,'ncm', vegn_ncm_ptr)
     ! accumulated values for annual averaging
     call read_tile_data_r0d_fptr(unit,'t_ann_acm', vegn_t_ann_acm_ptr)
     call read_tile_data_r0d_fptr(unit,'t_cold_acm', vegn_t_cold_acm_ptr)
     call read_tile_data_r0d_fptr(unit,'p_ann_acm', vegn_p_ann_acm_ptr)
     call read_tile_data_r0d_fptr(unit,'ncm_acm', vegn_ncm_acm_ptr)
     ! burned carbon pool and rate
     if(nfu_inq_var(unit,'csmoke_pool')==NF_NOERR) &
          call read_tile_data_r0d_fptr(unit,'csmoke_pool',vegn_csmoke_pool_ptr)
     if(nfu_inq_var(unit,'csmoke_rate')==NF_NOERR) &
          call read_tile_data_r0d_fptr(unit,'csmoke_rate',vegn_csmoke_rate_ptr)
     ! harvesting pools and rates
     do i = 1, N_HARV_POOLS
        if (nfu_inq_var(unit,trim(HARV_POOL_NAMES(i))//'_harv_pool')==NF_NOERR) &
             call read_tile_data_r1d_fptr(unit,trim(HARV_POOL_NAMES(i))//'_harv_pool',vegn_harv_pool_ptr,i)
        if (nfu_inq_var(unit,trim(HARV_POOL_NAMES(i))//'_harv_rate')==NF_NOERR) &
             call read_tile_data_r1d_fptr(unit,trim(HARV_POOL_NAMES(i))//'_harv_rate',vegn_harv_rate_ptr,i)
     enddo

     __NF_ASRT__(nf_close(unit))
  else
     call error_mesg('vegn_init',&
          'cold-starting vegetation',&
          NOTE)
  endif
  ! read climatological fields for initialization of species distribution
  if (file_exist('INPUT/biodata.nc'))then
     allocate(&
          t_ann (lnd%is:lnd%ie,lnd%js:lnd%je),&
          t_cold(lnd%is:lnd%ie,lnd%js:lnd%je),&
          p_ann (lnd%is:lnd%ie,lnd%js:lnd%je),&
          ncm   (lnd%is:lnd%ie,lnd%js:lnd%je) )
     call read_field( 'INPUT/biodata.nc','T_ANN', &
          lnd%lon, lnd%lat, t_ann, interp='nearest')
     call read_field( 'INPUT/biodata.nc','T_COLD', &
          lnd%lon, lnd%lat, t_cold, interp='nearest')
     call read_field( 'INPUT/biodata.nc','P_ANN', &
          lnd%lon, lnd%lat, p_ann, interp='nearest')
     call read_field( 'INPUT/biodata.nc','NCM', &
          lnd%lon, lnd%lat, ncm, interp='nearest')
     did_read_biodata = .TRUE.
  endif
  ! Go through all tiles and initialize the cohorts that have not been initialized yet --
  ! this allows to read partial restarts. Also initialize accumulation counters to zero
  ! or the values from the restarts.
  te = tail_elmt(lnd%tile_map)
  ce = first_elmt(lnd%tile_map, is=lnd%is, js=lnd%js)
  do while(ce /= te)
     tile=>current_tile(ce)  ! get pointer to current tile
     call get_elmt_indices(ce,i,j)
     ce=next_elmt(ce)       ! advance position to the next tile
     if (.not.associated(tile%vegn)) cycle

     tile%vegn%n_accum = n_accum
     tile%vegn%nmn_acm = nmn_acm

     if (tile%vegn%n_cohorts>0) cycle ! skip initialized tiles
     
     ! create and initialize cohorts for this vegetation tile
     ! for now, just create a new cohort with default values of biomasses
     tile%vegn%n_cohorts = 1
     allocate(tile%vegn%cohorts(tile%vegn%n_cohorts))
     cohort => tile%vegn%cohorts(1)
     cohort%prog%Wl = init_Wl
     cohort%prog%Ws = init_Ws
     cohort%prog%Tv = init_Tv
     
     cohort%bl      = init_cohort_bl
     cohort%blv     = init_cohort_blv
     cohort%br      = init_cohort_br
     cohort%bsw     = init_cohort_bsw
     cohort%bwood   = init_cohort_bwood
     cohort%bliving = cohort%bl+cohort%br+cohort%blv+cohort%bsw
     cohort%npp_previous_day = 0.0
     cohort%status  = LEAF_ON
     cohort%leaf_age = 0.0
     if(did_read_biodata.and.do_biogeography) then
        call update_species(cohort,t_ann(i,j),t_cold(i,j),p_ann(i,j),ncm(i,j),LU_NTRL)
     else
        cohort%species = tile%vegn%tag
     endif
  enddo
    
  ! initialize carbon integrator
  call vegn_dynamics_init ( id_lon, id_lat, lnd%time, delta_time, soil_decomp_option )

  ! initialize static vegetation
  call static_vegn_init ()
  call read_static_vegn ( lnd%time )

  ! initialize harvesting options
  call vegn_harvesting_init()

  ! initialize vegetation diagnostic fields
  call vegn_diag_init ( id_lon, id_lat, id_band, lnd%time )

  ! ---- diagnostic section
  ce = first_elmt(lnd%tile_map, is=lnd%is, js=lnd%js)
  te  = tail_elmt(lnd%tile_map)
  do while(ce /= te)
     tile => current_tile(ce)
     ce=next_elmt(ce)     
     if (.not.associated(tile%vegn)) cycle ! skip non-vegetation tiles
     ! send the data
     call send_tile_data(id_vegn_type,  real(tile%vegn%tag), tile%diag)
  enddo

  if (allocated(t_ann))  deallocate(t_ann)
  if (allocated(t_cold)) deallocate(t_cold)
  if (allocated(p_ann))  deallocate(p_ann)
  if (allocated(ncm))    deallocate(ncm)

end subroutine vegn_init

! ============================================================================
subroutine vegn_diag_init ( id_lon, id_lat, id_band, time )
  integer        , intent(in) :: id_lon  ! ID of land longitude (X) axis  
  integer        , intent(in) :: id_lat  ! ID of land latitude (Y) axis
  integer        , intent(in) :: id_band ! ID of spectral band axis
  type(time_type), intent(in) :: time    ! initial time for diagnostic fields
  
  ! ---- local vars
  integer :: i

  id_vegn_type = register_tiled_static_field ( module_name, 'vegn_type',  &
       (/id_lon,id_lat/), 'vegetation type', missing_value=-1.0 )

  id_temp = register_tiled_diag_field ( module_name, 'temp',  &
       (/id_lon,id_lat/), time, 'canopy temperature', 'degK', missing_value=-1.0 )
  id_wl = register_tiled_diag_field ( module_name, 'wl',  &
       (/id_lon,id_lat/), time, 'canopy liquid water content', 'kg/m2', missing_value=-1.0 )
  id_ws = register_tiled_diag_field ( module_name, 'ws',  &
       (/id_lon,id_lat/), time, 'canopy solid water content', 'kg/m2', missing_value=-1.0 )

  id_height = register_tiled_diag_field ( module_name, 'height',  &
       (/id_lon,id_lat/), time, 'vegetation height', 'm', missing_value=-1.0 )
  id_lai    = register_tiled_diag_field ( module_name, 'lai',  &
       (/id_lon,id_lat/), time, 'leaf area index', 'm2/m2', missing_value=-1.0 )
  id_sai    = register_tiled_diag_field ( module_name, 'sai',  &
       (/id_lon,id_lat/), time, 'stem area index', 'm2/m2', missing_value=-1.0 )
  id_leaf_size = register_tiled_diag_field ( module_name, 'leaf_size',  &
       (/id_lon,id_lat/), time, missing_value=-1.0 )
  id_root_density = register_tiled_diag_field ( module_name, 'root_density',  &
       (/id_lon,id_lat/), time, 'total biomass below ground', 'kg/m2', missing_value=-1.0 )
  id_root_zeta = register_tiled_diag_field ( module_name, 'root_zeta',  &
       (/id_lon,id_lat/), time, 'e-folding depth of root biomass', 'm',missing_value=-1.0 )
  id_rs_min = register_tiled_diag_field ( module_name, 'rs_min',  &
       (/id_lon,id_lat/), time, missing_value=-1.0 )
  id_leaf_refl = register_tiled_diag_field ( module_name, 'leaf_refl',  &
       (/id_lon,id_lat,id_band/), time, 'reflectivity of leaf', missing_value=-1.0 )
  id_leaf_tran = register_tiled_diag_field ( module_name, 'leaf_tran',  &
       (/id_lon,id_lat,id_band/), time, 'transmittance of leaf', missing_value=-1.0 )
  id_leaf_emis = register_tiled_diag_field ( module_name, 'leaf_emis',  &
       (/id_lon,id_lat/), time, 'leaf emissivity', missing_value=-1.0 )
  id_snow_crit = register_tiled_diag_field ( module_name, 'snow_crit',  &
       (/id_lon,id_lat/), time, missing_value=-1.0 )
  id_stomatal = register_tiled_diag_field ( module_name, 'stomatal_cond',  &
       (/id_lon,id_lat/), time, 'vegetation stomatal conductance', missing_value=-1.0 )
  id_evap_demand = register_tiled_diag_field ( module_name, 'evap_demand',  &
       (/id_lon,id_lat/), time, 'plant evaporative water demand',&
       'kg/(m2 s)', missing_value=-1e20 )
  id_an_op = register_tiled_diag_field ( module_name, 'an_op',  &
       (/id_lon,id_lat/), time, 'net photosynthesis with open stomata', &
       '(mol CO2)(m2 of leaf)^-1 year^-1', missing_value=-1e20 )
  id_an_cl = register_tiled_diag_field ( module_name, 'an_cl',  &
       (/id_lon,id_lat/), time, 'net photosynthesis with closed stomata', &
       '(mol CO2)(m2 of leaf)^-1 year^-1', missing_value=-1e20 )

  id_bl = register_tiled_diag_field ( module_name, 'bl',  &
       (/id_lon,id_lat/), time, 'biomass of leaves', 'kg C/m2', missing_value=-1.0 )
  id_blv = register_tiled_diag_field ( module_name, 'blv',  &
       (/id_lon,id_lat/), time, 'biomass in labile store', 'kg C/m2', missing_value=-1.0 )
  id_br = register_tiled_diag_field ( module_name, 'br',  &
       (/id_lon,id_lat/), time, 'biomass of fine roots', 'kg C/m2', missing_value=-1.0 )
  id_bsw = register_tiled_diag_field ( module_name, 'bsw',  &
       (/id_lon,id_lat/), time, 'biomass of sapwood', 'kg C/m2', missing_value=-1.0 )
  id_bwood = register_tiled_diag_field ( module_name, 'bwood',  &
       (/id_lon,id_lat/), time, 'biomass of heartwood', 'kg C/m2', missing_value=-1.0 )
  id_btot = register_tiled_diag_field ( module_name, 'btot',  &
       (/id_lon,id_lat/), time, 'total biomass', 'kg C/m2', missing_value=-1.0 )
  id_fuel = register_tiled_diag_field ( module_name, 'fuel',  &
       (/id_lon,id_lat/), time, 'mass of fuel', 'kg C/m2', missing_value=-1.0 )
  id_lambda = register_tiled_diag_field (module_name, 'lambda',(/id_lon,id_lat/), &
       time, 'drought', 'months', missing_value=-100.0)

  id_species = register_tiled_diag_field ( module_name, 'species',  &
       (/id_lon,id_lat/), time, 'vegetation species number', missing_value=-1.0 )
  id_status = register_tiled_diag_field ( module_name, 'status',  &
       (/id_lon,id_lat/), time, 'status of leaves', missing_value=-1.0 )
  id_theph = register_tiled_diag_field ( module_name, 'theph',  &
       (/id_lon,id_lat/), time, 'theta for phenology', missing_value=-1.0 )
  id_psiph = register_tiled_diag_field ( module_name, 'psiph',  &
       (/id_lon,id_lat/), time, 'psi stress for phenology', missing_value=-1.0 )
  id_leaf_age = register_tiled_diag_field ( module_name, 'leaf_age',  &
       (/id_lon,id_lat/), time, 'age of leaves since bud burst', 'days', missing_value=-1.0 )!ens

  id_con_v_h = register_tiled_diag_field ( module_name, 'con_v_h', (/id_lon,id_lat/), &
       time, 'conductance for sensible heat between canopy and canopy air', &
       'm/s', missing_value=-1.0 )
  id_con_v_v = register_tiled_diag_field ( module_name, 'con_v_v', (/id_lon,id_lat/), &
       time, 'conductance for water vapor between canopy and canopy air', &
       'm/s', missing_value=-1.0 )

  id_cgain = register_tiled_diag_field ( module_name, 'cgain', (/id_lon,id_lat/), &
       time, 'carbon gain', 'kg C', missing_value=-100.0 )
  id_closs = register_tiled_diag_field ( module_name, 'closs', (/id_lon,id_lat/), &
       time, 'carbon loss', 'kg C', missing_value=-100.0 )
  id_wdgain = register_tiled_diag_field ( module_name, 'wdgain', (/id_lon,id_lat/), &
       time, 'wood biomass gain', 'kg C', missing_value=-100.0 )

  id_t_ann  = register_tiled_diag_field ( module_name, 't_ann', (/id_lon,id_lat/), &
       time, 'annual mean temperature', 'degK', missing_value=-999.0 )
  id_t_cold  = register_tiled_diag_field ( module_name, 't_cold', (/id_lon,id_lat/), &
       time, 'average temperature of the coldest month', 'degK', missing_value=-999.0 )
  id_p_ann  = register_tiled_diag_field ( module_name, 'p_ann', (/id_lon,id_lat/), &
       time, 'annual mean precipitation', 'kg/(m2 s)', missing_value=-999.0 )
  id_ncm = register_tiled_diag_field ( module_name, 'ncm', (/id_lon,id_lat/), &
       time, 'number of cold months', 'dimensionless', missing_value=-999.0 )

  id_t_harv_pool = register_tiled_diag_field( module_name, 'harv_pool', (/id_lon,id_lat/), &
       time, 'total harvested carbon', 'kg C/m2', missing_value=-999.0)
  id_t_harv_rate = register_tiled_diag_field( module_name, 'harv_rate', (/id_lon,id_lat/), &
       time, 'total rate of release of harvested carbon to the atmosphere', &
       'kg C/(m2 year)', missing_value=-999.0)
  do i = 1,N_HARV_POOLS
     id_harv_pool(i) = register_tiled_diag_field( module_name, &
          trim(HARV_POOL_NAMES(i))//'_harv_pool', (/id_lon,id_lat/), time, &
          'harvested carbon', 'kg C/m2', missing_value=-999.0)
     id_harv_rate(i) = register_tiled_diag_field( module_name, &
          trim(HARV_POOL_NAMES(i))//'_harv_rate', (/id_lon,id_lat/), time, &
          'rate of release of harvested carbon to the atmosphere', 'kg C/(m2 year)', &
          missing_value=-999.0)
  enddo

  id_fsc_pool = register_tiled_diag_field (module_name, 'fsc_pool', (/id_lon, id_lat/), &
       time, 'intermediate pool of fast soil carbon', 'kg C/m2', missing_value=-999.0)
  id_fsc_rate = register_tiled_diag_field (module_name, 'fsc_rate', (/id_lon, id_lat/), &
       time, 'rate of conversion of fsc_pool to the fast soil_carbon', 'kg C/(m2 yr)', &
       missing_value=-999.0)
  id_ssc_pool = register_tiled_diag_field (module_name, 'ssc_pool', (/id_lon, id_lat/), &
       time, 'intermediate pool of slow soil carbon', 'kg C/m2', missing_value=-999.0)
  id_ssc_rate = register_tiled_diag_field (module_name, 'ssc_rate', (/id_lon, id_lat/), &
       time, 'rate of conversion of ssc_pool to the fast soil_carbon', 'kg C/(m2 yr)', &
       missing_value=-999.0)

  id_csmoke_pool = register_tiled_diag_field ( module_name, 'csmoke', (/id_lon, id_lat/), &
       time, 'carbon lost through fire', 'kg C/m2', missing_value=-999.0)
  id_csmoke_rate = register_tiled_diag_field ( module_name, 'csmoke_rate', (/id_lon, id_lat/), &
       time, 'rate of release of carbon lost through fire to the atmosphere', &
       'kg C/(m2 yr)', missing_value=-999.0)

  id_ssc_in = register_tiled_diag_field ( module_name, 'ssc_in',  (/id_lon, id_lat/), &
     time,  'soil slow carbon in', 'kg C/m2', missing_value=-999.0 )
  id_ssc_out = register_tiled_diag_field ( module_name, 'ssc_out',  (/id_lon, id_lat/), &
     time,  'soil slow carbon out', 'kg C/m2', missing_value=-999.0 )
  id_fsc_in = register_tiled_diag_field ( module_name, 'fsc_in',  (/id_lon, id_lat/), &
     time,  'soil fast carbon in', 'kg C/m2', missing_value=-999.0 )
  id_fsc_out = register_tiled_diag_field ( module_name, 'fsc_out',  (/id_lon, id_lat/), &
     time,  'soil fast carbon out', 'kg C/m2', missing_value=-999.0 )
  id_veg_in = register_tiled_diag_field ( module_name, 'veg_in',  (/id_lon, id_lat/), &
     time,  'vegetation carbon in', 'kg C/m2', missing_value=-999.0 )
  id_veg_out = register_tiled_diag_field ( module_name, 'veg_out',  (/id_lon, id_lat/), &
     time,  'vegetation carbon out', 'kg C/m2', missing_value=-999.0 )

  id_afire = register_tiled_diag_field (module_name, 'afire', (/id_lon,id_lat/), &
       time, 'area been fired', missing_value=-100.0)
  id_atfall = register_tiled_diag_field (module_name, 'atfall',(/id_lon,id_lat/), &
       time, 'area been disturbed', missing_value=-100.0)

  id_phot_co2 = register_tiled_diag_field (module_name, 'qco2_phot',(/id_lon,id_lat/), &
       time, 'CO2 mixing ratio for photosynthesis calculations', 'mol CO2/mol dry air', &
       missing_value=-1.0)
end subroutine


! ============================================================================
! write restart file and release memory
subroutine vegn_end ()

  module_is_initialized =.FALSE.

  ! finalize harvesting
  call vegn_harvesting_end ()

  ! finalize static vegetation, if necessary
  call static_vegn_end ()
end subroutine vegn_end


! ============================================================================
subroutine save_vegn_restart(tile_dim_length,timestamp)
  integer, intent(in) :: tile_dim_length ! length of tile dim. in the output file
  character(*), intent(in) :: timestamp ! timestamp to add to the file name

  ! ---- local vars ----------------------------------------------------------
  integer :: unit ! restart file unit 
  integer :: ierr, i
  type(land_tile_enum_type) :: ce, te
  type(land_tile_type), pointer :: tile
  integer :: n_accum, nmn_acm

  call error_mesg('vegn_end','writing NetCDF restart',NOTE)
  ! create output file, including internal structure necessary for tile output
  call create_tile_out_file(unit,'RESTART/'//trim(timestamp)//'vegn1.res.nc', &
          lnd%coord_glon, lnd%coord_glat, vegn_tile_exists, tile_dim_length)
  ! create compressed dimension for vegetation cohorts -- must be called even
  ! if restart has not been created, because it calls mpp_max and that should 
  ! be called on all PEs to work
  call create_cohort_dimension(unit)

  call write_cohort_data_r0d_fptr(unit,'tv',cohort_tv_ptr,'vegetation temperature','degrees_K')
  call write_cohort_data_r0d_fptr(unit,'wl',cohort_wl_ptr,'vegetation liquid water content','kg/m2')
  call write_cohort_data_r0d_fptr(unit,'ws',cohort_ws_ptr,'vegetation solid water content','kg/m2')
  ! close output file
  __NF_ASRT__(nf_close(unit))


  call create_tile_out_file(unit,'RESTART/'//trim(timestamp)//'vegn2.res.nc', &
          lnd%coord_glon, lnd%coord_glat, vegn_tile_exists, tile_dim_length )
  ! create compressed dimension for vegetation cohorts -- see note above
  call create_cohort_dimension(unit)

  ! store global variables
  ! find first tile and get n_accum and nmn_acm from it
  n_accum = 0; nmn_acm = 0
  ce = first_elmt(lnd%tile_map) ; te = tail_elmt(lnd%tile_map)
  do while ( ce /= te )
     tile => current_tile(ce) ; ce=next_elmt(ce)
     if(associated(tile%vegn)) then
        n_accum = tile%vegn%n_accum
        nmn_acm = tile%vegn%nmn_acm
     endif
  enddo
  ! n_accum and nmn_acm are currently the same for all tiles; we only call mpp_max
  ! to handle the situation when there are no tiles in the current domain
  call mpp_max(n_accum); call mpp_max(nmn_acm)
  
  if(mpp_pe()==lnd%io_pelist(1)) then
     ierr = nf_redef(unit)
     __NF_ASRT__(nfu_def_var(unit,'n_accum',NF_INT,long_name='number of accumulated steps'))
     __NF_ASRT__(nfu_def_var(unit,'nmn_acm',NF_INT,long_name='number of accumulated months'))
     ierr = nf_enddef(unit)
     __NF_ASRT__(nfu_put_var(unit,'n_accum',n_accum))
     __NF_ASRT__(nfu_put_var(unit,'nmn_acm',nmn_acm))
  end if
  
  call write_cohort_data_i0d_fptr(unit,'species', cohort_species_ptr, 'vegetation species')
  call write_cohort_data_r0d_fptr(unit,'hite', cohort_height_ptr, 'vegetation height','m')
  call write_cohort_data_r0d_fptr(unit,'bl', cohort_bl_ptr, 'biomass of leaves per individual','kg C/m2')
  call write_cohort_data_r0d_fptr(unit,'blv', cohort_blv_ptr, 'biomass of virtual leaves (labile store) per individual','kg C/m2')
  call write_cohort_data_r0d_fptr(unit,'br', cohort_br_ptr, 'biomass of fine roots per individual','kg C/m2')
  call write_cohort_data_r0d_fptr(unit,'bsw', cohort_bsw_ptr, 'biomass of sapwood per individual','kg C/m2')
  call write_cohort_data_r0d_fptr(unit,'bwood', cohort_bwood_ptr, 'biomass of heartwood per individual','kg C/m2')
  call write_cohort_data_r0d_fptr(unit,'bliving', cohort_bliving_ptr, 'total living biomass per individual','kg C/m2')
!     call write_cohort_data_r0d_fptr(unit,'tleaf', cohort_tleaf_ptr, 'leaf temperature','degK')
  call write_cohort_data_i0d_fptr(unit,'status', cohort_status_ptr, 'leaf status')
  call write_cohort_data_r0d_fptr(unit,'leaf_age',cohort_leaf_age_ptr, 'age of leaves since bud burst', 'days')

!     call write_cohort_data_r0d_fptr(unit,'intercept_l', cohort_cmc_ptr, 'intercepted water per cohort','kg/m2')
  call write_cohort_data_r0d_fptr(unit,'npp_prev_day', cohort_npp_previous_day_ptr, 'previous day NPP','kg C/(m2 year)')

  call write_tile_data_i0d_fptr(unit,'landuse',vegn_landuse_ptr,'vegetation land use type')
  call write_tile_data_r0d_fptr(unit,'age',vegn_age_ptr,'vegetation age', 'yr')
  call write_tile_data_r0d_fptr(unit,'fsc_pool',vegn_fsc_pool_ptr,'intermediate pool for fast soil carbon input', 'kg C/m2')
  call write_tile_data_r0d_fptr(unit,'fsc_rate',vegn_fsc_rate_ptr,'conversion rate of fsc_pool to fast soil carbon', 'kg C/(m2 yr)')
  call write_tile_data_r0d_fptr(unit,'ssc_pool',vegn_ssc_pool_ptr,'intermediate pool for slow soil carbon input', 'kg C/m2')
  call write_tile_data_r0d_fptr(unit,'ssc_rate',vegn_ssc_rate_ptr,'conversion rate of ssc_pool to slow soil carbon', 'kg C/(m2 yr)')

  ! monthly-mean values
  call write_tile_data_r0d_fptr(unit,'tc_av', vegn_tc_av_ptr,'average canopy air temperature','degK')
  call write_tile_data_r0d_fptr(unit,'theta_av_phen', vegn_theta_av_phen_ptr,'average soil moisture for phenology')
  call write_tile_data_r0d_fptr(unit,'theta_av_fire', vegn_theta_av_fire_ptr,'average soil moisture for fire')
  call write_tile_data_r0d_fptr(unit,'psist_av', vegn_psist_av_ptr,'average soil-water-stress index')
  call write_tile_data_r0d_fptr(unit,'tsoil_av', vegn_tsoil_av_ptr,'average bulk soil temperature for soil carbon','degK')
  call write_tile_data_r0d_fptr(unit,'precip_av', vegn_precip_av_ptr,'average total precipitation','kg/(m2 s)')
  call write_tile_data_r0d_fptr(unit,'lambda', vegn_lambda_ptr,'dryness parameter')
  call write_tile_data_r0d_fptr(unit,'fuel', vegn_fuel_ptr,'fuel density','kg C/m2')
  ! annual-mean values
  call write_tile_data_r0d_fptr(unit,'t_ann', vegn_t_ann_ptr,'average annual canopy air temperature','degK')
  call write_tile_data_r0d_fptr(unit,'t_cold', vegn_t_cold_ptr,'average canopy air temperature of coldest month','degK')
  call write_tile_data_r0d_fptr(unit,'p_ann', vegn_p_ann_ptr,'average annual precipitation','kg/(m2 s)')
  call write_tile_data_r0d_fptr(unit,'ncm', vegn_ncm_ptr,'number of cold months')
  ! accumulated values for annual averaging
  call write_tile_data_r0d_fptr(unit,'t_ann_acm', vegn_t_ann_acm_ptr,'accumulated annual canopy air temperature','degK')
  call write_tile_data_r0d_fptr(unit,'t_cold_acm', vegn_t_cold_acm_ptr,'accumulated temperature of coldest month','degK')
  call write_tile_data_r0d_fptr(unit,'p_ann_acm', vegn_p_ann_acm_ptr,'accumulated precipitation','kg/(m2 s)')
  call write_tile_data_r0d_fptr(unit,'ncm_acm', vegn_ncm_acm_ptr,'accumulated number of cold months')

  ! burned carbon pool and rate
  call write_tile_data_r0d_fptr(unit,'csmoke_pool',vegn_csmoke_pool_ptr,'carbon lost through fires', 'kg C/m2')
  call write_tile_data_r0d_fptr(unit,'csmoke_rate',vegn_csmoke_rate_ptr,'rate of release of carbon lost through fires to the atmosphere', 'kg C/(m2 yr)')

  ! harvesting pools and rates
  do i = 1, N_HARV_POOLS
     call write_tile_data_r1d_fptr(unit, trim(HARV_POOL_NAMES(i))//'_harv_pool', &
          vegn_harv_pool_ptr, i, 'harvested carbon','kg C/m2')
     call write_tile_data_r1d_fptr(unit, trim(HARV_POOL_NAMES(i))//'_harv_rate', &
          vegn_harv_rate_ptr, i, 'rate of release of harvested carbon to the atmosphere','kg C/(m2 yr)')
  enddo
     

  __NF_ASRT__(nf_close(unit))

end subroutine save_vegn_restart


! ============================================================================
subroutine vegn_get_cover(vegn, snow_depth, vegn_cover)
  type(vegn_tile_type), intent(inout)  :: vegn ! it is only inout because vegn%data%cover
                                    ! changes cohort; can it be avoided?
  real,                 intent(in)  :: snow_depth
  real,                 intent(out) :: vegn_cover

  real :: vegn_cover_snow_factor

  call vegn_data_cover(vegn%cohorts(1), snow_depth, vegn_cover, vegn_cover_snow_factor)
  
end subroutine vegn_get_cover


! ============================================================================
subroutine vegn_diffusion ( vegn, vegn_cover, vegn_height, vegn_lai, vegn_sai, vegn_d_leaf)
  type(vegn_tile_type), intent(in) :: vegn
  real,                intent(out) :: &
       vegn_cover, vegn_height, vegn_lai, vegn_sai, vegn_d_leaf
  
  vegn_cover  = vegn%cohorts(1)%cover
  vegn_lai    = vegn%cohorts(1)%lai
  vegn_sai    = vegn%cohorts(1)%sai
  vegn_height = vegn%cohorts(1)%height
  vegn_d_leaf = vegn%cohorts(1)%leaf_size

end subroutine vegn_diffusion


! ============================================================================
subroutine vegn_step_1 ( vegn, soil, diag, &
        p_surf, ustar, drag_q, &
        SWdn, RSv, precip_l, precip_s, &
        land_d, land_z0s, land_z0m, grnd_z0s, &
        soil_beta, soil_water_supply, &
        cana_T, cana_q, cana_co2_mol, &
        ! output
        con_g_h, con_g_v, & ! aerodynamic conductance between canopy air and canopy, for heat and vapor flux
        vegn_T,vegn_Wl,  vegn_Ws,           & ! temperature, water and snow mass of the canopy
        vegn_ifrac,                         & ! intercepted fraction of liquid and frozen precipitation
        vegn_lai,                           & ! leaf area index
        drip_l, drip_s,                     & ! water and snow drip rate from precipitation, kg/(m2 s)
        vegn_hcap,                          & ! vegetation heat capacity
        Hv0,   DHvDTv,   DHvDTc,            & ! sens heat flux
        Et0,   DEtDTv,   DEtDqc,   DEtDwl,   DEtDwf,  & ! transpiration
        Eli0,  DEliDTv,  DEliDqc,  DEliDwl,  DEliDwf, & ! evaporation of intercepted water
        Efi0,  DEfiDTv,  DEfiDqc,  DEfiDwl,  DEfiDwf  ) ! sublimation of intercepted snow
  type(vegn_tile_type), intent(inout) :: vegn ! vegetation data
  type(soil_tile_type), intent(inout) :: soil ! soil data
  ! TODO: possibly move calculation of soil-related stuff from calling subroutine to here
  !       now since we have soil tiled passed to us
  type(diag_buff_type), intent(inout) :: diag ! diagnostic buffer
  real, intent(in) :: &
       p_surf,    & ! surface pressure, N/m2
       ustar,     & ! friction velocity, m/s
       drag_q,    & ! bulk drag coefficient for specific humidity
       SWdn(NBANDS), & ! downward SW radiation at the top of the canopy, W/m2
       RSv (NBANDS), & ! net SW radiation balance of the canopy, W/m2
       precip_l, precip_s, & ! liquid and solid precipitation rates, kg/(m2 s)
       land_d, land_z0s, land_z0m, & ! land displacement height and roughness, m
       grnd_z0s, & ! roughness of ground surface (including snow effect)
       soil_beta, & ! relative water availability
       soil_water_supply, & ! max rate of water supply to the roots, kg/(m2 s)
       cana_T,    & ! temperature of canopy air, deg K
       cana_q,    & ! specific humidity of canopy air, kg/kg
       cana_co2_mol ! co2 mixing ratio in the canopy air, mol CO2/mol dry air
  ! output -- coefficients of linearized expressions for fluxes
  real, intent(out) ::   &
       vegn_T,vegn_Wl,  vegn_Ws,& ! temperature, water and snow mass of the canopy
       vegn_ifrac, & ! intercepted fraction of liquid and frozen precipitation
       vegn_lai, & ! vegetation leaf area index
       drip_l, drip_s, & ! water and snow drip rate from precipitation, kg/(m2 s)
       vegn_hcap, & ! total vegetation heat capacity, including intercepted water and snow
       con_g_h, con_g_v, & ! aerodynamic conductance between ground and canopy air
       Hv0,   DHvDTv,   DHvDTc, & ! sens heat flux
       Et0,   DEtDTv,   DEtDqc,   DEtDwl,   DEtDwf,  & ! transpiration
       Eli0,  DEliDTv,  DEliDqc,  DEliDwl,  DEliDwf, & ! evaporation of intercepted water
       Efi0,  DEfiDTv,  DEfiDqc,  DEfiDwl,  DEfiDwf    ! sublimation of intercepted snow
  
  ! ---- local vars 
  real :: &
       ft,DftDwl,DftDwf, & ! fraction of canopy not covered by intercepted water/snow, and its' 
                    ! derivatives w.r.t. intercepted water masses 
       fw,DfwDwl,DfwDwf, & ! fraction of canopy covered by intercepted water, and its' 
                    ! derivatives w.r.t. intercepted water masses 
       fs,DfsDwl,DfsDwf, & ! fraction of canopy covered by intercepted snow, and its' 
                    ! derivatives w.r.t. intercepted water masses
       stomatal_cond, & ! integral stomatal conductance of canopy
       con_v_h, con_v_v, & ! aerodyn. conductance between canopy and CAS, for heat and vapor
       rav_lit,   & ! additional resistance of litter to vapor transport
       total_cond, &! overall conductance from inside stomata to canopy air 
       qvsat,     & ! sat. specific humidity at the leaf T
       DqvsatDTv, & ! derivative of qvsat w.r.t. leaf T
       rho,       & ! density of canopy air
       phot_co2,  & ! co2 mixing ratio for photosynthesis, mol CO2/mol dry air
       evap_demand, & ! evaporative water demand, kg/(m2 s)
       photosynt, & ! photosynthesis
       photoresp    ! photo-respiration
  type(vegn_cohort_type), pointer :: cohort
  
  ! get the pointer to the first (and, currently, the only) cohort
  cohort => vegn%cohorts(1)

  if(is_watch_point()) then
     write(*,*)'#### vegn_step_1 input ####'
     __DEBUG3__(p_surf, ustar, drag_q)
     __DEBUG1__(SWdn)
     __DEBUG1__(RSv) 
     __DEBUG2__(precip_l, precip_s)
     __DEBUG4__(land_d, land_z0s, land_z0m, grnd_z0s)
     __DEBUG2__(soil_beta, soil_water_supply)
     __DEBUG3__(cana_T, cana_q, cana_co2_mol)
     write(*,*)'#### end of vegn_step_1 input ####'
     __DEBUG3__(cohort%height, cohort%lai, cohort%sai)
     __DEBUG2__(cohort%cover,cohort%leaf_size)
     __DEBUG1__(cohort%prog%Tv)
  endif

  ! check the range of input temperature
  call check_temp_range(cohort%prog%Tv,'vegn_step_1','cohort%prog%Tv', lnd%time) 

  ! calculate the fractions of intercepted precipitation
  vegn_ifrac = cohort%cover

  ! get the lai
  vegn_lai = cohort%lai

  ! calculate the aerodynamic conductance coefficients
  call cana_turbulence(ustar, &
     cohort%cover, cohort%height, cohort%lai, cohort%sai, cohort%leaf_size, &
     land_d, land_z0m, land_z0s, grnd_z0s, &
     con_v_h, con_v_v, con_g_h, con_g_v)

  ! take into account additional resistance of litter to the water vapor flux.
  ! not a good parameterization, but just using for sensitivity analyses now.
  ! ignores differing biomass and litter turnover rates.
  rav_lit = rav_lit_0 + rav_lit_vi * (cohort%lai+cohort%sai) &
                      + rav_lit_fsc * soil%fast_soil_C(1) &
                      + rav_lit_ssc * soil%slow_soil_C(1) &
                      + rav_lit_bwood * cohort%bwood
  con_g_v = con_g_v/(1.0+rav_lit*con_g_v)

  ! calculate the vegetation photosynthesis and associated stomatal conductance
  if (vegn_phot_co2_option == VEGN_PHOT_CO2_INTERACTIVE) then
     phot_co2 = cana_co2_mol
  else 
     phot_co2 = co2_for_photosynthesis
  endif
  call vegn_photosynthesis ( vegn, &
     SWdn(BAND_VIS), RSv(BAND_VIS), cana_q, phot_co2, p_surf, drag_q, &
     soil_beta, soil_water_supply, &
     evap_demand, stomatal_cond, photosynt, photoresp )

  call get_vegn_wet_frac ( cohort, fw, DfwDwl, DfwDwf, fs, DfsDwl, DfsDwf )
  ! transpiring fraction and its derivatives
  ft     = 1 - fw - fs
  DftDwl = - DfwDwl - DfsDwl
  DftDwf = - DfwDwf - DfsDwf
  call qscomp(cohort%prog%Tv, p_surf, qvsat, DqvsatDTv)

  rho = p_surf/(rdgas*cana_T *(1+d608*cana_q))
  
  ! get the vegetation temperature
  vegn_T  =  cohort%prog%Tv
  ! get the amount of intercepted water and snow
  vegn_Wl =  cohort%prog%Wl
  vegn_Ws =  cohort%prog%Ws
  ! calculate the drip rates
  drip_l  = max(vegn_Wl,0.0)/tau_drip_l
  drip_s  = max(vegn_Ws,0.0)/tau_drip_s
  ! correct the drip rates so that the amount of water and snow accumulated over time step 
  ! is no larger then the canopy water-holding capacity
  drip_l = max((vegn_Wl+precip_l*delta_time*vegn_ifrac-cohort%Wl_max)/delta_time,drip_l)
  drip_s = max((vegn_Ws+precip_s*delta_time*vegn_ifrac-cohort%Ws_max)/delta_time,drip_s)

  ! calculate the total heat capacity
  call vegn_data_heat_capacity (cohort, vegn_hcap)
  vegn_hcap = vegn_hcap + clw*cohort%prog%Wl + csw*cohort%prog%Ws
  ! calculate the coefficient of sensible heat flux linearization
  Hv0     =  2*rho*cp_air*con_v_h*(cohort%prog%Tv - cana_T)
  DHvDTv  =  2*rho*cp_air*con_v_h
  DHvDTc  = -2*rho*cp_air*con_v_h
  ! calculate the coefficients of the transpiration linearization
  if(con_v_v==0.and.stomatal_cond==0) then
     total_cond = 0.0
  else
     total_cond = stomatal_cond*con_v_v/(stomatal_cond+con_v_v)
  endif

  if(qvsat>cana_q)then
     ! flux is directed from the surface: transpiration is possible, and the
     ! evaporation of intercepted water depends on the fraction of wet/snow
     ! covered canopy.

     ! prohibit transpiration if leaf temperature below some predefined minimum
     ! typically (268K, but check namelist)
     if(cohort%prog%Tv < T_transp_min) total_cond = 0 
     ! calculate the transpiration linearization coefficients
     Et0     =  rho*total_cond*ft*(qvsat - cana_q)
     DEtDTv  =  rho*total_cond*ft*DqvsatDTv
     DEtDqc  = -rho*total_cond*ft
     DEtDwl  =  rho*total_cond*DftDwl*(qvsat - cana_q)
     DEtDwf  =  rho*total_cond*DftDwf*(qvsat - cana_q)
     ! calculate the coefficients of the intercepted liquid evaporation linearization
     Eli0    =  rho*con_v_v*fw*(qvsat - cana_q)
     DEliDTv =  rho*con_v_v*fw*DqvsatDTv
     DEliDqc = -rho*con_v_v*fw
     DEliDwl =  rho*con_v_v*DfwDwl*(qvsat-cana_q)
     DEliDwf =  rho*con_v_v*DfwDwf*(qvsat-cana_q)
     ! calculate the coefficients of the intercepted snow evaporation linearization
     Efi0    =  rho*con_v_v*fs*(qvsat - cana_q)
     DEfiDTv =  rho*con_v_v*fs*DqvsatDTv
     DEfiDqc = -rho*con_v_v*fs
     DEfiDwl =  rho*con_v_v*DfsDwl*(qvsat-cana_q)
     DEfiDwf =  rho*con_v_v*DfsDwf*(qvsat-cana_q)
  else
     ! Flux is directed TOWARD the surface: no transpiration (assuming plants do not
     ! take water through stomata), and condensation does not depend on the fraction
     ! of wet canopy -- dew formation occurs on the entire surface

     ! prohibit transpiration:
     Et0     = 0
     DEtDTv  = 0; DEtDwl = 0; DEtDwf = 0;
     DEtDqc  = 0
     ! calculate dew or frost formation rates, depending on the temperature
     Eli0    = 0; Efi0    = 0
     DEliDTv = 0; DEfiDTv = 0
     DEliDqc = 0; DEfiDqc = 0
     DEliDwl = 0; DEfiDwl = 0
     DEliDwf = 0; DEfiDwf = 0
     ! calculate the coefficients of the intercepted liquid condensation linearization
     if(vegn_T >= tfreeze) then
        Eli0    =  rho*con_v_v*(qvsat - cana_q)
        DEliDTv =  rho*con_v_v*DqvsatDTv
        DEliDqc = -rho*con_v_v
     else
        ! calculate the coefficients of the intercepted snow condensation linearization
        Efi0    =  rho*con_v_v*(qvsat - cana_q)
        DEfiDTv =  rho*con_v_v*DqvsatDTv
        DEfiDqc = -rho*con_v_v
     endif
     ! prohibit switching from condensation to evaporation if the water content
     ! is below certain threshold
     if (vegn_Wl < min_Wl) then
        Eli0 = 0 ; DEliDTv = 0 ; DEliDqc = 0 ; DEliDwl = 0 ; DEliDwf = 0
     endif
     if (vegn_Ws < min_Ws) then
        Efi0 = 0 ; DEfiDTv = 0 ; DEfiDqc = 0 ; DEfiDwl = 0 ; DEfiDwf = 0
     endif
        
  endif
  ! ---- diagnostic section
  call send_tile_data(id_evap_demand, evap_demand, diag)
  call send_tile_data(id_stomatal, stomatal_cond, diag)
  call send_tile_data(id_an_op, cohort%An_op, diag)
  call send_tile_data(id_an_cl, cohort%An_cl, diag)
  call send_tile_data(id_con_v_h, con_v_h, diag)
  call send_tile_data(id_con_v_v, con_v_v, diag)
  call send_tile_data(id_phot_co2, phot_co2, diag)

end subroutine vegn_step_1


! ============================================================================
! Given the surface solution, substitute it back into the vegetation equations 
! to determine new vegetation state.
subroutine vegn_step_2 ( vegn, diag, &
     delta_Tv, delta_wl, delta_wf, &
     vegn_melt, &
     vegn_ovfl_l,  vegn_ovfl_s,  & ! overflow of liquid and solid water from the canopy, kg/(m2 s)
     vegn_ovfl_Hl, vegn_ovfl_Hs  ) ! heat flux carried from canopy by overflow, W/(m2 s)

  ! ---- arguments 
  type(vegn_tile_type) , intent(inout) :: vegn
  type(diag_buff_type) , intent(inout) :: diag
  real, intent(in) :: &
       delta_Tv, & ! change in vegetation temperature, degK
       delta_wl, & ! change in intercepted liquid water mass, kg/m2
       delta_wf    ! change in intercepted frozen water mass, kg/m2 
  real, intent(out) :: &
       vegn_melt, &
       vegn_ovfl_l,   vegn_ovfl_s,   & ! overflow of liquid and solid water from the canopy
       vegn_ovfl_Hl, vegn_ovfl_Hs      ! heat flux from canopy due to overflow

  ! ---- local variables
  real :: &
     vegn_Wl_max, &  ! max. possible amount of liquid water in the canopy
     vegn_Ws_max, &  ! max. possible amount of solid water in the canopy
     mcv, &
     cap0, melt_per_deg, &
     Wl, Ws  ! positively defined amounts of water and snow on canopy
  type(vegn_cohort_type), pointer :: cohort
  
  ! get the pointer to the first (and, currently, the only) cohort
  cohort => vegn%cohorts(1)

  if (is_watch_point()) then
     write(*,*)'#### vegn_step_2 input ####'
     __DEBUG3__(delta_Tv, delta_wl, delta_wf)
     __DEBUG1__(cohort%prog%Tv)
  endif

  ! update vegetation state
  cohort%prog%Tv = cohort%prog%Tv + delta_Tv
  cohort%prog%Wl = cohort%prog%Wl + delta_wl
  cohort%prog%Ws = cohort%prog%Ws + delta_wf 

  call vegn_data_intrcptn_cap(cohort, vegn_Wl_max, vegn_Ws_max)
  call vegn_data_heat_capacity(cohort, mcv)


  ! ---- update for evaporation and interception -----------------------------
  cap0 = mcv + clw*cohort%prog%Wl + csw*cohort%prog%Ws

  if(is_watch_point()) then
     write (*,*)'#### vegn_step_2 #### 1'
     __DEBUG1__(cap0)
     __DEBUG1__(cohort%prog%Tv)
     __DEBUG2__(cohort%prog%Wl, cohort%prog%Ws)
  endif
  ! melt on the vegetation should probably be prohibited altogether, since
  ! the amount of melt or freeze calculated this way is severely underestimated 
  ! (depending on the overall vegetation heat capacity) which leads to extended 
  ! periods when the canopy temperature is fixed at freezing point.
  if (lm2) then 
     vegn_melt = 0
  else
     ! ---- freeze/melt of intercepted water
     ! heat capacity of leaf + intercepted water/snow _can_ go below zero if the 
     ! total water content goes below zero as a result of implicit time step.
     ! If it does, we just prohibit melt, setting it to zero.
     if(cap0 > 0)then
        melt_per_deg = cap0 / hlf
        if (cohort%prog%Ws>0 .and. cohort%prog%Tv>tfreeze) then
           vegn_melt =  min(cohort%prog%Ws, (cohort%prog%Tv-tfreeze)*melt_per_deg)
        else if (cohort%prog%Wl>0 .and. cohort%prog%Tv<tfreeze) then
           vegn_melt = -min(cohort%prog%Wl, (tfreeze-cohort%prog%Tv)*melt_per_deg)
        else
           vegn_melt = 0
        endif
        cohort%prog%Ws = cohort%prog%Ws - vegn_melt
        cohort%prog%Wl = cohort%prog%Wl + vegn_melt
        if (vegn_melt/=0) &
             cohort%prog%Tv = tfreeze + (cap0*(cohort%prog%Tv-tfreeze) - hlf*vegn_melt) &
             / ( cap0 + (clw-csw)*vegn_melt )
        vegn_melt = vegn_melt / delta_time
     else
        vegn_melt = 0
     endif
  endif

  if(is_watch_point()) then
     write (*,*)'#### vegn_step_2 #### 1'
     __DEBUG1__(cap0)
     __DEBUG1__(cohort%prog%Tv)
     __DEBUG3__(vegn_melt, cohort%prog%Wl, cohort%prog%Ws)
  endif

  ! ---- update for overflow -------------------------------------------------
  Wl = max(cohort%prog%Wl,0.0); Ws = max(cohort%prog%Ws,0.0)
  vegn_ovfl_l = max (0.,Wl-vegn_Wl_max)/delta_time
  vegn_ovfl_s = max (0.,Ws-vegn_Ws_max)/delta_time
  vegn_ovfl_Hl = clw*vegn_ovfl_l*(cohort%prog%Tv-tfreeze)
  vegn_ovfl_Hs = csw*vegn_ovfl_s*(cohort%prog%Tv-tfreeze)

  cohort%prog%Wl = cohort%prog%Wl - vegn_ovfl_l*delta_time
  cohort%prog%Ws = cohort%prog%Ws - vegn_ovfl_s*delta_time

  if(is_watch_point()) then
     write(*,*)'#### vegn_step_2 output #####'
     __DEBUG3__(vegn_melt, vegn_ovfl_l, vegn_ovfl_s)
     __DEBUG2__(vegn_ovfl_Hl,vegn_ovfl_Hs)
  endif

  ! ---- diagnostic section
  call send_tile_data(id_temp,   cohort%prog%Tv, diag)
  call send_tile_data(id_wl,     cohort%prog%Wl, diag)
  call send_tile_data(id_ws,     cohort%prog%Ws, diag)

  call send_tile_data(id_height, cohort%height, diag)
  call send_tile_data(id_lai, cohort%lai, diag)
  call send_tile_data(id_sai, cohort%sai, diag)
  call send_tile_data(id_leaf_size, cohort%leaf_size, diag)
  call send_tile_data(id_root_density, cohort%root_density, diag)
  call send_tile_data(id_root_zeta, cohort%root_zeta, diag)
  call send_tile_data(id_rs_min, cohort%rs_min, diag)
  call send_tile_data(id_leaf_refl, cohort%leaf_refl, diag)
  call send_tile_data(id_leaf_tran, cohort%leaf_tran, diag)
  call send_tile_data(id_leaf_emis, cohort%leaf_emis, diag)
  call send_tile_data(id_snow_crit, cohort%snow_crit, diag)
  
end subroutine vegn_step_2


! ============================================================================
! do the vegetation calculations that require updated (end-of-timestep) values 
! of prognostic land variables
subroutine vegn_step_3(vegn, soil, cana_T, precip, vegn_fco2, diag)
  type(vegn_tile_type), intent(inout) :: vegn
  type(soil_tile_type), intent(inout) :: soil
  real, intent(in) :: cana_T ! canopy temperature, deg K
  real, intent(in) :: precip ! total (rain+snow) precipitation, kg/(m2 s)
  real, intent(out) :: vegn_fco2 ! co2 flux from vegetation, kg CO2/(m2 s)
  type(diag_buff_type), intent(inout) :: diag
  
  ! ---- local vars
  real :: tsoil ! average temperature of soil for soil carbon decomposition, deg K
  real :: theta ! average soil wetness, unitless
  real :: psist ! psi stress index
  real :: depth_ave! depth for averaging soil moisture based on Jackson function for root distribution  
  real :: percentile = 0.95

  tsoil = soil_ave_temp (soil,soil_carbon_depth_scale)
  ! depth for 95% of root according to Jackson distribution 
  depth_ave = -log(1.-percentile)*vegn%cohorts(1)%root_zeta

  theta = soil_ave_theta1(soil, depth_ave)

  if(is_watch_point()) then
     write(*,*)'#### vegn_step_3 drought input ####'
     __DEBUG3__(depth_ave, tsoil, theta)
  endif

  call vegn_carbon_int(vegn, soil, tsoil, theta, diag)
  ! decrease, if necessary, csmoke spending rate so that csmoke pool
  ! is never depleted below zero
  vegn%csmoke_rate = max( 0.0, &
       min( vegn%csmoke_rate, &
            vegn%csmoke_pool/dt_fast_yr)&
       )
  ! update smoke pool -- stored amount of carbon lost to fire
  vegn%csmoke_pool = vegn%csmoke_pool - &
       vegn%csmoke_rate*dt_fast_yr
  ! decrease harvested rates so that pools are not depleted below zero  
  vegn%harv_rate(:) = max( 0.0, &
                           min(vegn%harv_rate(:), vegn%harv_pool(:)/dt_fast_yr) &
                         )
  ! update harvested pools -- amounts of stored harvested carbon by category
  vegn%harv_pool(:) = vegn%harv_pool(:) - &
       vegn%harv_rate(:)*dt_fast_yr
  ! --- calculate total co2 flux from vegetation
  vegn_fco2 = -vegn%nep + vegn%csmoke_rate + sum(vegn%harv_rate(:))
  ! --- convert it to kg CO2/(m2 s)
  vegn_fco2 = vegn_fco2*mol_CO2/(mol_C*seconds_per_year)

  ! --- accumulate values for climatological averages
  vegn%tc_av     = vegn%tc_av + cana_T
  vegn%tsoil_av  = vegn%tsoil_av + tsoil
  vegn%precip_av = vegn%precip_av + precip
  if (xwilt_available) then
     theta = soil_ave_theta1(soil,depth_ave)
  else
     theta = soil_ave_theta0(soil,vegn%cohorts(1)%root_zeta)
  endif
  vegn%theta_av_phen = vegn%theta_av_phen + theta
  vegn%theta_av_fire = vegn%theta_av_fire + soil_ave_theta1(soil,depth_ave)
  psist = soil_psi_stress(soil,vegn%cohorts(1)%root_zeta)
  vegn%psist_av  = vegn%psist_av + psist

  vegn%n_accum   = vegn%n_accum+1
  
  call send_tile_data(id_theph, theta, diag)
  call send_tile_data(id_psiph, psist, diag)

end subroutine vegn_step_3


! ============================================================================
! update slow components of the vegetation model
subroutine update_vegn_slow( )

  ! ---- local vars ----------------------------------------------------------
  integer :: second, minute, hour, day0, day1, month0, month1, year0, year1
  type(land_tile_enum_type) :: ce, te
  type(land_tile_type), pointer :: tile
  integer :: i,j,k ! current point indices
  integer :: ii ! pool iterator
  integer :: n ! number of cohorts
  real    :: weight_ncm ! low-pass filter value for the number of cold months

  ! get components of calendar dates for this and previous time step
  call get_date(lnd%time,             year0,month0,day0,hour,minute,second)
  call get_date(lnd%time-lnd%dt_slow, year1,month1,day1,hour,minute,second)

  ce = first_elmt(lnd%tile_map, lnd%is, lnd%js) ; te = tail_elmt(lnd%tile_map)
  do while ( ce /= te )
     call get_elmt_indices(ce,i,j,k) ; call set_current_point(i,j,k) ! this is for debug output only
     tile => current_tile(ce) ; ce=next_elmt(ce)
     if(.not.associated(tile%vegn)) cycle ! skip the rest of the loop body

     if (day1 /= day0) then
        call vegn_daily_npp(tile%vegn)
     endif

     ! monthly averaging
     if (month1 /= month0) then
        ! compute averages from accumulated monthly values 
        tile%vegn%tc_av     = tile%vegn%tc_av     / tile%vegn%n_accum
        tile%vegn%tsoil_av  = tile%vegn%tsoil_av  / tile%vegn%n_accum
        tile%vegn%theta_av_phen  = tile%vegn%theta_av_phen  / tile%vegn%n_accum
        tile%vegn%theta_av_fire  = tile%vegn%theta_av_fire  / tile%vegn%n_accum
	tile%vegn%psist_av  = tile%vegn%psist_av  / tile%vegn%n_accum
        tile%vegn%precip_av = tile%vegn%precip_av / tile%vegn%n_accum
        ! accumulate annual values
        tile%vegn%p_ann_acm = tile%vegn%p_ann_acm+tile%vegn%precip_av
        tile%vegn%t_ann_acm = tile%vegn%t_ann_acm+tile%vegn%tc_av
        if ( tile%vegn%tc_av < cold_month_threshold ) & 
             tile%vegn%ncm_acm = tile%vegn%ncm_acm+1
        tile%vegn%t_cold_acm = min(tile%vegn%t_cold_acm, tile%vegn%tc_av)

        tile%vegn%nmn_acm = tile%vegn%nmn_acm+1 ! increase the number of accumulated months
     endif

     ! annual averaging
     if (year1 /= year0) then
        ! The ncm smoothing is coded as a low-pass exponential filter. See, for example
        ! http://en.wikipedia.org/wiki/Low-pass_filter
        weight_ncm = 1/(1+tau_smooth_ncm)
        if(tile%vegn%nmn_acm /= 0) then
           ! calculate annual averages from accumulated values
           tile%vegn%p_ann  = tile%vegn%p_ann_acm/tile%vegn%nmn_acm
           tile%vegn%t_ann  = tile%vegn%t_ann_acm/tile%vegn%nmn_acm
           tile%vegn%t_cold = tile%vegn%t_cold_acm
           tile%vegn%ncm    = weight_ncm*tile%vegn%ncm_acm + (1-weight_ncm)*tile%vegn%ncm
           ! reset accumulated values
           tile%vegn%ncm_acm    = 0
           tile%vegn%p_ann_acm  = 0
           tile%vegn%t_ann_acm  = 0
           tile%vegn%t_cold_acm = HUGE(tile%vegn%t_cold_acm)
        endif
!!$        call calc_miami_npp(tile%vegn)
        tile%vegn%nmn_acm = 0
     endif

     if (year1 /= year0 .and. do_biogeography) then
        call vegn_biogeography(tile%vegn)
     endif

     if (month1 /= month0.and.do_patch_disturbance) then
        call update_fuel(tile%vegn,tile%soil%w_wilt(1)/tile%soil%pars%vwc_sat)
        ! assume that all layers are the same soil type and wilting is vertically homogeneous
     endif

     if (day1 /= day0 .and. do_cohort_dynamics) then
        n = tile%vegn%n_cohorts
        call send_tile_data(id_cgain,sum(tile%vegn%cohorts(1:n)%carbon_gain),tile%diag)
        call send_tile_data(id_closs,sum(tile%vegn%cohorts(1:n)%carbon_loss),tile%diag)
        call send_tile_data(id_wdgain,sum(tile%vegn%cohorts(1:n)%bwood_gain),tile%diag)
        call vegn_growth(tile%vegn)
        call vegn_nat_mortality(tile%vegn,tile%soil,86400.0)
     endif

     if  (month1 /= month0 .and. do_phenology) then
        call vegn_phenology (tile%vegn, tile%soil)
        ! assume that all layers are the same soil type and wilting is vertically homogeneous
     endif

     if (year1 /= year0 .and. do_patch_disturbance) then
        call vegn_disturbance(tile%vegn, tile%soil, seconds_per_year)
     endif

     if (year1 /= year0) then
        call vegn_harvesting(tile%vegn)
        tile%vegn%fsc_rate = tile%vegn%fsc_pool/fsc_pool_spending_time
        tile%vegn%ssc_rate = tile%vegn%ssc_pool/ssc_pool_spending_time
        where(harvest_spending_time(:)>0)
           tile%vegn%harv_rate(:) = &
                tile%vegn%harv_pool(:)/harvest_spending_time(:)
        elsewhere
           tile%vegn%harv_rate(:) = 0.0
        end where
     endif

     ! ---- diagnostic section
     call send_tile_data(id_t_ann,   tile%vegn%t_ann,   tile%diag)
     call send_tile_data(id_t_cold,  tile%vegn%t_cold,  tile%diag)
     call send_tile_data(id_lambda,  tile%vegn%lambda,  tile%diag)
     call send_tile_data(id_p_ann,   tile%vegn%p_ann,   tile%diag)
     call send_tile_data(id_ncm,     real(tile%vegn%ncm), tile%diag)
     call send_tile_data(id_afire,   tile%vegn%disturbance_rate(1), tile%diag)
     call send_tile_data(id_atfall,  tile%vegn%disturbance_rate(0), tile%diag)

     do ii = 1,N_HARV_POOLS
        call send_tile_data(id_harv_pool(ii),tile%vegn%harv_pool(ii),tile%diag)
        call send_tile_data(id_harv_rate(ii),tile%vegn%harv_rate(ii),tile%diag)
     enddo
     call send_tile_data(id_t_harv_pool,sum(tile%vegn%harv_pool(:)),tile%diag)
     call send_tile_data(id_t_harv_rate,sum(tile%vegn%harv_rate(:)),tile%diag)
     call send_tile_data(id_csmoke_pool,tile%vegn%csmoke_pool,tile%diag)
     call send_tile_data(id_csmoke_rate,tile%vegn%csmoke_rate,tile%diag)
     call send_tile_data(id_fsc_pool,tile%vegn%fsc_pool,tile%diag)
     call send_tile_data(id_fsc_rate,tile%vegn%fsc_rate,tile%diag)
     call send_tile_data(id_ssc_pool,tile%vegn%ssc_pool,tile%diag)
     call send_tile_data(id_ssc_rate,tile%vegn%ssc_rate,tile%diag)

     n=tile%vegn%n_cohorts
     call send_tile_data(id_bl,      sum(tile%vegn%cohorts(1:n)%bl),     tile%diag)
     call send_tile_data(id_blv,     sum(tile%vegn%cohorts(1:n)%blv),    tile%diag)
     call send_tile_data(id_br,      sum(tile%vegn%cohorts(1:n)%br),     tile%diag)
     call send_tile_data(id_bsw,     sum(tile%vegn%cohorts(1:n)%bsw),    tile%diag)
     call send_tile_data(id_bwood,   sum(tile%vegn%cohorts(1:n)%bwood),  tile%diag)
     call send_tile_data(id_btot,    sum(tile%vegn%cohorts(1:n)%bl    &
                                        +tile%vegn%cohorts(1:n)%blv   &
                                        +tile%vegn%cohorts(1:n)%br    &
                                        +tile%vegn%cohorts(1:n)%bsw   &
                                        +tile%vegn%cohorts(1:n)%bwood ), tile%diag)
     call send_tile_data(id_fuel,    tile%vegn%fuel, tile%diag)
     call send_tile_data(id_species, real(tile%vegn%cohorts(1)%species), tile%diag)
     call send_tile_data(id_status,  real(tile%vegn%cohorts(1)%status),  tile%diag)
     call send_tile_data(id_leaf_age,real(tile%vegn%cohorts(1)%leaf_age),  tile%diag)!ens

     ! carbon budget tracking
     call send_tile_data(id_fsc_in,  sum(tile%soil%fsc_in(:)),  tile%diag)
     call send_tile_data(id_fsc_out, tile%vegn%fsc_out, tile%diag)
     call send_tile_data(id_ssc_in,  sum(tile%soil%ssc_in(:)),  tile%diag)
     call send_tile_data(id_ssc_out, tile%vegn%ssc_out, tile%diag)
     call send_tile_data(id_veg_in,  tile%vegn%veg_in,  tile%diag)
     call send_tile_data(id_veg_out, tile%vegn%veg_out, tile%diag)
     ! ---- end of diagnostic section

     ! reset averages and number of steps to 0 before the start of new month
     if (month1 /= month0) then
        tile%vegn%n_accum  = 0
        tile%vegn%tc_av    = 0.
        tile%vegn%tsoil_av = 0.
        tile%vegn%theta_av_phen = 0.
        tile%vegn%theta_av_fire = 0.
        tile%vegn%psist_av = 0.
        tile%vegn%precip_av= 0.
     endif

     !reset fuel and drought months before the start of new year
     if (year1 /= year0) then
        tile%vegn%lambda     = 0
        tile%vegn%fuel       = 0
     endif

  enddo

  ! seed transport
  if (year1 /= year0 .and. do_seed_transport) then
     call vegn_seed_transport()
  endif

  ! override with static vegetation
  if(day1/=day0) &
       call  read_static_vegn(lnd%time)
end subroutine update_vegn_slow


! ============================================================================
subroutine vegn_seed_transport()

  ! local vars
  type(land_tile_enum_type) :: ce, te
  type(land_tile_type), pointer :: tile
  integer :: i,j ! current point indices
  real :: total_seed_supply
  real :: total_seed_demand
  real :: f_supply ! fraction of the supply that gets spent
  real :: f_demand ! fraction of the demand that gets satisfied

  ce = first_elmt(lnd%tile_map, lnd%is, lnd%js) ; te = tail_elmt(lnd%tile_map)
  total_seed_supply = 0.0; total_seed_demand = 0.0
  do while ( ce /= te )
     call get_elmt_indices(ce,i,j)
     tile => current_tile(ce) ; ce=next_elmt(ce)
     if(.not.associated(tile%vegn)) cycle ! skip the rest of the loop body

     total_seed_supply = total_seed_supply + vegn_seed_supply(tile%vegn)*tile%frac*lnd%area(i,j)
     total_seed_demand = total_seed_demand + vegn_seed_demand(tile%vegn)*tile%frac*lnd%area(i,j)
  enddo
  ! sum totals globally
  call mpp_sum(total_seed_demand, pelist=lnd%pelist)
  call mpp_sum(total_seed_supply, pelist=lnd%pelist)
  ! if either demand or supply are zeros we don't need (or can't) transport anything
  if (total_seed_demand==0.or.total_seed_supply==0)then
     return
  end if

  ! calculate the fraction of the supply that's going to be used
  f_supply = MIN(total_seed_demand/total_seed_supply, 1.0)
  ! calculate the fraction of the demand that's going to be satisfied
  f_demand = MIN(total_seed_supply/total_seed_demand, 1.0)
  ! note that either f_supply or f_demand is 1; the mass conservation law in the
  ! following calculations is satisfied since 
  ! f_demand*total_seed_demand - f_supply*total_seed_supply == 0

  ! redistribute part (or possibly all) of the supply to satisfy part (or possibly all) 
  ! of the demand
  ce = first_elmt(lnd%tile_map) ; te = tail_elmt(lnd%tile_map)
  do while ( ce /= te )
     call get_elmt_indices(ce,i,j)
     tile => current_tile(ce) ; ce=next_elmt(ce)
     if(.not.associated(tile%vegn)) cycle ! skip the rest of the loop body
     
     call vegn_add_bliving(tile%vegn, &
          f_demand*vegn_seed_demand(tile%vegn)-f_supply*vegn_seed_supply(tile%vegn))
  enddo
end subroutine vegn_seed_transport


! ============================================================================
! tile existence detector: returns a logical value indicating wether component
! model tile exists or not
logical function vegn_tile_exists(tile)
   type(land_tile_type), pointer :: tile
   vegn_tile_exists = associated(tile%vegn)
end function vegn_tile_exists


! ============================================================================
! cohort accessor functions: given a pointer to cohort, return a pointer to a
! specific member of the cohort structure
#define DEFINE_VEGN_ACCESSOR_0D(xtype,x) subroutine CONCAT3(vegn_,x,_ptr(t,p));\
type(land_tile_type),pointer::t;xtype,pointer::p;p=>NULL();if(associated(t))then;if(associated(t%vegn))p=>t%vegn%x;endif;end subroutine

#define DEFINE_VEGN_ACCESSOR_1D(xtype,x) subroutine CONCAT3(vegn_,x,_ptr(t,p));\
type(land_tile_type),pointer::t;xtype,pointer::p(:);p=>NULL();if(associated(t))then;if(associated(t%vegn))p=>t%vegn%x;endif;end subroutine

#define DEFINE_COHORT_ACCESSOR(xtype,x) subroutine CONCAT3(cohort_,x,_ptr(c,p));\
type(vegn_cohort_type),pointer::c;xtype,pointer::p;p=>NULL();if(associated(c))p=>c%x;end subroutine

#define DEFINE_COHORT_COMPONENT_ACCESSOR(xtype,component,x) subroutine CONCAT3(cohort_,x,_ptr(c,p));\
type(vegn_cohort_type),pointer::c;xtype,pointer::p;p=>NULL();if(associated(c))p=>c%component%x;end subroutine

DEFINE_VEGN_ACCESSOR_0D(integer,landuse)
DEFINE_VEGN_ACCESSOR_0D(real,age)
DEFINE_VEGN_ACCESSOR_0D(real,fsc_pool)
DEFINE_VEGN_ACCESSOR_0D(real,fsc_rate)
DEFINE_VEGN_ACCESSOR_0D(real,ssc_pool)
DEFINE_VEGN_ACCESSOR_0D(real,ssc_rate)
DEFINE_VEGN_ACCESSOR_0D(real,tc_av)
DEFINE_VEGN_ACCESSOR_0D(real,theta_av_phen)
DEFINE_VEGN_ACCESSOR_0D(real,theta_av_fire)
DEFINE_VEGN_ACCESSOR_0D(real,psist_av)
DEFINE_VEGN_ACCESSOR_0D(real,tsoil_av)
DEFINE_VEGN_ACCESSOR_0D(real,precip_av)
DEFINE_VEGN_ACCESSOR_0D(real,fuel)
DEFINE_VEGN_ACCESSOR_0D(real,lambda)
DEFINE_VEGN_ACCESSOR_0D(real,t_ann)
DEFINE_VEGN_ACCESSOR_0D(real,p_ann)
DEFINE_VEGN_ACCESSOR_0D(real,t_cold)
DEFINE_VEGN_ACCESSOR_0D(real,ncm)
DEFINE_VEGN_ACCESSOR_0D(real,t_ann_acm)
DEFINE_VEGN_ACCESSOR_0D(real,p_ann_acm)
DEFINE_VEGN_ACCESSOR_0D(real,t_cold_acm)
DEFINE_VEGN_ACCESSOR_0D(real,ncm_acm)
DEFINE_VEGN_ACCESSOR_0D(real,csmoke_pool)
DEFINE_VEGN_ACCESSOR_0D(real,csmoke_rate)

DEFINE_VEGN_ACCESSOR_1D(real,harv_pool)
DEFINE_VEGN_ACCESSOR_1D(real,harv_rate)

DEFINE_COHORT_ACCESSOR(integer,species)
DEFINE_COHORT_ACCESSOR(real,bl)
DEFINE_COHORT_ACCESSOR(real,br)
DEFINE_COHORT_ACCESSOR(real,blv)
DEFINE_COHORT_ACCESSOR(real,bsw)
DEFINE_COHORT_ACCESSOR(real,bwood)
DEFINE_COHORT_ACCESSOR(real,bliving)
DEFINE_COHORT_ACCESSOR(integer,status)
DEFINE_COHORT_ACCESSOR(real,leaf_age)
DEFINE_COHORT_ACCESSOR(real,npp_previous_day)

DEFINE_COHORT_COMPONENT_ACCESSOR(real,prog,tv)
DEFINE_COHORT_COMPONENT_ACCESSOR(real,prog,wl)
DEFINE_COHORT_COMPONENT_ACCESSOR(real,prog,ws)

DEFINE_COHORT_ACCESSOR(real,height)

end module vegetation_mod

module ocean_nphysics_flux_mod

!<CONTACT EMAIL="tim.leslie@gmail.com"> Tim Leslie
!</CONTACT>
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Stephen M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Compute the neutral physics fluxes. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes the neutral physics fluxes. 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies 
! Fundamentals of Ocean Climate Models (FOCM) (2004)
! Princeton University Press 
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies: Elements of MOM (2012)
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_nphysics_flux_nml">
!
!  <DATA NAME="diffusion_all_explicit" TYPE="logical">
! To compute K33 explicitly in time.  This setting is meant
! only for debugging tests, since in general the simulation 
! will go unstable. 
! Default diffusion_all_explicit=.false.
!  </DATA> 
!
!  <DATA NAME="neutral_physics_limit" TYPE="logical">
! Revert to horizontal diffusion when tracer falls outside specified range.
! Default neutral_physics_limit=.true., so to keep tracers from going
! too far outside of physical range. 
!  </DATA> 
!
!</NAMELIST>

#define COMP isc:iec,jsc:jec
#define COMPXL isc-1:iec,jsc:jec
#define COMPXR isc:iec+1,jsc:jec
#define COMPXLL isc-1:iec-1,jsc:jec
#define COMPYL isc:iec,jsc-1:jec
#define COMPYR isc:iec,jsc:jec+1
#define COMPYLL isc:iec,jsc-1:jec-1
#define COMPXLYL isc-1:iec,jsc-1:jec

  use constants_mod,   only: epsln
  use fms_mod,         only: open_namelist_file, check_nml_error, close_file
  use mpp_domains_mod, only: mpp_update_domains, CGRID_NE
  use mpp_mod,         only: stdout, stdlog, mpp_clock_id, CLOCK_ROUTINE
  use mpp_mod,         only: mpp_clock_begin, mpp_clock_end
  use mpp_mod,         only: input_nml_file

  use ocean_domains_mod,           only: get_local_indices, set_ocean_domain
  use ocean_nphysics_util_new_mod, only: stencil_centre_to_vert, stencil_centre_to_horiz
  use ocean_nphysics_util_new_mod, only: vert_smooth
  use ocean_operators_mod,         only: FMX, FMY
  use ocean_types_mod,             only: ocean_grid_type, ocean_domain_type, ocean_time_type
  use ocean_types_mod,             only: ocean_thickness_type, ocean_prog_tracer_type
  use ocean_util_mod,              only: write_note, diagnose_3d 
  use ocean_util_mod,              only: register_3d_t_field, register_3d_xte_field
  use ocean_util_mod,              only: register_3d_ytn_field, register_3d_ztb_field

  implicit none

  public flux_calculations
  public ocean_nphysics_flux_init

  private compute_mass_diff
  private geometric_terms
  private compute_33_term
  private compute_fluxes
  private apply_tracer_limits
  private update_tendencies

  private

#include <ocean_memory.h>

character(len=128) :: version=&
     '$Id: ocean_nphysics_flux.F90,v 20.0 2013/12/14 00:14:44 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

character(len=*), parameter :: FILENAME=&
     __FILE__


  type(ocean_domain_type), save :: Dom_flux

  ! Diagnostics

  integer :: id_clock_flux_mass_diff
  integer :: id_clock_flux_33_term
  integer :: id_clock_flux_fluxes
  integer :: id_clock_flux_tracer_limits
  integer :: id_clock_flux_misc
  integer :: id_clock_flux_update

  ! Mass weighted tensor components
  integer :: id_symm_mass_diff_11_xte
  integer :: id_symm_mass_diff_22_ytn

  integer :: id_symm_mass_diff_13_h_xz
  integer :: id_symm_mass_diff_23_h_yz
  integer :: id_symm_mass_diff_31_v_xz
  integer :: id_symm_mass_diff_32_v_yz
  
  integer :: id_skew_mass_diff_13_h_xz
  integer :: id_skew_mass_diff_23_h_yz
  integer :: id_skew_mass_diff_31_v_xz
  integer :: id_skew_mass_diff_32_v_yz
  
  integer :: id_m33_explicit_ztb
  integer :: id_m33_implicit

  ! Fluxes
  integer, dimension(:), allocatable :: id_diff_flux_x_xte
  integer, dimension(:), allocatable :: id_diff_flux_y_ytn
  integer, dimension(:), allocatable :: id_diff_flux_z_ztb
  integer, dimension(:), allocatable :: id_skew_flux_x_xte
  integer, dimension(:), allocatable :: id_skew_flux_y_ytn
  integer, dimension(:), allocatable :: id_skew_flux_z_ztb

  ! Tendencies
  integer, dimension(:), allocatable :: id_diff_th_tendency
  integer, dimension(:), allocatable :: id_skew_th_tendency

  ! Namelist

  ! to compute K33 explicitly in time.
  ! diffusion_all_explicit=.false. for realistic simulations.
  logical :: diffusion_all_explicit = .false.

  ! revert to horizontal diffusion when tracer falls outside specified range
  logical :: neutral_physics_limit = .true.

  namelist /ocean_nphysics_flux_nml/ diffusion_all_explicit, neutral_physics_limit

contains

  !#######################################################################
  ! <SUBROUTINE NAME="ocean_nphysics_flux_init">
  !
  ! <DESCRIPTION>
  ! Initialise namelist variables and prepare diagnostics.
  ! </DESCRIPTION>
  !
  subroutine ocean_nphysics_flux_init(Domain, Grid, Time, T_prog)

    type(ocean_domain_type), intent(in) :: Domain
    type(ocean_grid_type),   intent(in) :: Grid
    type(ocean_time_type),   intent(in) :: Time
    type(ocean_prog_tracer_type), dimension(:), intent(in) :: T_prog

    integer :: ierr, ioun, io_status
    integer :: stdoutunit, stdlogunit
    stdoutunit = stdout()
    stdlogunit = stdlog()

    ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_nphysics_flux_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_nphysics_flux_nml')
#else
    ioun =  open_namelist_file()
    read (ioun,ocean_nphysics_flux_nml,IOSTAT=io_status)
    ierr = check_nml_error(io_status,'ocean_nphysics_flux_nml')
    call close_file (ioun)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit,ocean_nphysics_flux_nml)  
    write (stdlogunit,ocean_nphysics_flux_nml)

#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
    nk = Grid%nk
#endif

    call set_ocean_domain(Dom_flux,Grid,xhalo=Domain%xhalo,yhalo=Domain%yhalo,name='flux dom neutral',maskmap=Domain%maskmap)
    
    id_clock_flux_mass_diff     = mpp_clock_id('(Ocean neutral: flux: mass diff)'     ,grain=CLOCK_ROUTINE)
    id_clock_flux_33_term       = mpp_clock_id('(Ocean neutral: flux: 33 term)'       ,grain=CLOCK_ROUTINE)
    id_clock_flux_fluxes        = mpp_clock_id('(Ocean neutral: flux: fluxes)'        ,grain=CLOCK_ROUTINE)
    id_clock_flux_tracer_limits = mpp_clock_id('(Ocean neutral: flux: tracer limits)' ,grain=CLOCK_ROUTINE)
    id_clock_flux_misc          = mpp_clock_id('(Ocean neutral: flux: misc)'          ,grain=CLOCK_ROUTINE)
    id_clock_flux_update        = mpp_clock_id('(Ocean neutral: flux: update)'        ,grain=CLOCK_ROUTINE)

    call register_fields(Grid, Time, T_prog)

  end subroutine ocean_nphysics_flux_init
  ! </SUBROUTINE> NAME="ocean_nphysics_flux_init"


  !#######################################################################
  ! <SUBROUTINE NAME="register fields">
  !
  ! <DESCRIPTION>
  ! Register diagnostic fields.
  ! </DESCRIPTION>
  !
  subroutine register_fields(Grid, Time, T_prog)
    type(ocean_grid_type), intent(in) :: Grid
    type(ocean_time_type), intent(in) :: Time
    type(ocean_prog_tracer_type), dimension(:), intent(in) :: T_prog

    integer n, num_prog_tracers

    num_prog_tracers = size(T_prog(:))

    id_symm_mass_diff_11_xte = register_3d_xte_field(Grid, Time, 'symm_mass_diff_11_xte', &
         '11 component of mass weighted neutral diffusivity at Eastern tracer-cell face', &
         'kg m^2/s', range=(/-1e8,1.e8/))
    id_symm_mass_diff_22_ytn = register_3d_ytn_field(Grid, Time, 'symm_mass_diff_22_ytn',  &
         '22 component of mass weighted neutral diffusivity at Northern tracer-cell face', &
         'kg m^2/s', range=(/-1e8,1.e8/))
    id_symm_mass_diff_13_h_xz = register_3d_xte_field(Grid, Time,  'symm_mass_diff_13_h_xz',             &
         'Triad-averaged 13 component of mass weighted neutral diffusivity at Eastern tracer-cell face', &
         'kg m^2/s', range=(/-1e8,1.e8/))
    id_symm_mass_diff_23_h_yz = register_3d_ytn_field(Grid, Time, 'symm_mass_diff_23_h_yz',               &
         'Triad-averaged 13 component of mass weighted neutral diffusivity at Northern tracer-cell face', &
         'kg m^2/s', range=(/-1e8,1.e8/))
    id_symm_mass_diff_31_v_xz = register_3d_ztb_field(Grid, Time, 'symm_mass_diff_31_v_xz',             &
         'Triad-averaged 31 component of mass weighted neutral diffusivity at bottom tracer-cell face', &
         'kg m^2/s', range=(/-1e8,1.e8/))
    id_symm_mass_diff_32_v_yz = register_3d_ztb_field(Grid, Time, 'symm_mass_diff_32_v_yz',             &
         'Triad-averaged 32 component of mass weighted neutral diffusivity at bottom tracer-cell face', &
         'kg m^2/s', range=(/-1e8,1.e8/))

    id_skew_mass_diff_13_h_xz = register_3d_xte_field(Grid, Time, 'skew_mass_diff_13_h_xz',          &
         'Triad-averaged 13 component of mass weighted skew diffusivity at Eastern tracer-cell face',&
         'kg m^2/s', range=(/-1e8,1.e8/))
    id_skew_mass_diff_23_h_yz = register_3d_ytn_field(Grid, Time, 'skew_mass_diff_23_h_yz',            &
         'Triad-averaged 13 component of mass weighted skew diffusivity at Northern tracer-cell face', &
         'kg m^2/s', range=(/-1e8,1.e8/))
    id_skew_mass_diff_31_v_xz = register_3d_ztb_field(Grid, Time, 'skew_mass_diff_31_v_xz',          &
         'Triad-averaged 31 component of mass weighted skew diffusivity at bottom tracer-cell face', &
         'kg m^2/s', range=(/-1e8,1.e8/))
    id_skew_mass_diff_32_v_yz = register_3d_ztb_field(Grid, Time, 'skew_mass_diff_32_v_yz',          &
         'Triad-averaged 32 component of mass weighted skew diffusivity at bottom tracer-cell face', &
         'kg m^2/s', range=(/-1e8,1.e8/))

    id_m33_explicit_ztb = register_3d_ztb_field(Grid, Time, 'm33_explicit_ztb',                   &
         'Explicit 33 component of mass weighted neutral diffusivity at bottom tracer-cell face', &
         'kg m^2/s', range=(/-1e8,1.e8/))
    id_m33_implicit = register_3d_t_field(Grid, Time, 'm33_implicit',                        &
         'Implicit 33 component of mass weighted neutral diffusivity at tracer-cell center', &
         'kg m^2/s', range=(/-1e8,1.e8/))

    allocate(id_diff_flux_x_xte(num_prog_tracers))
    allocate(id_diff_flux_y_ytn(num_prog_tracers))
    allocate(id_diff_flux_z_ztb(num_prog_tracers))
    allocate(id_skew_flux_x_xte(num_prog_tracers))
    allocate(id_skew_flux_y_ytn(num_prog_tracers))
    allocate(id_skew_flux_z_ztb(num_prog_tracers))

    do n = 1, num_prog_tracers
       id_diff_flux_x_xte(n) = register_3d_xte_field(Grid, Time, 'diff_flux_x_xte_'//trim(T_prog(n)%name),          &
            'Density-area weighted flux of '//trim(T_prog(n)%name)//' through Eastern face from neutral diffusion', &
            'rho_dzt*dyt*flux of '//trim(T_prog(n)%name), (/-1.e18,1.e18/))
       id_diff_flux_y_ytn(n) = register_3d_ytn_field(Grid, Time, 'diff_flux_y_ytn_'//trim(T_prog(n)%name),           &
            'Density-area weighted flux of '//trim(T_prog(n)%name)//' through Northern face from neutral diffusion', &
            'rho_dzt*dxt*flux of '//trim(T_prog(n)%name), (/-1.e18,1.e18/))
       id_diff_flux_z_ztb(n) = register_3d_ztb_field(Grid, Time, 'diff_flux_z_ztb_'//trim(T_prog(n)%name),           &
            'Density-area weighted flux of '//trim(T_prog(n)%name)//' through bottom face from neutral diffusivion', &
            'rho*dxt*dyt*flux of '//trim(T_prog(n)%name), (/-1.e18,1.e18/))

       id_skew_flux_x_xte(n) = register_3d_xte_field(Grid, Time, 'skew_flux_x_xte_'//trim(T_prog(n)%name),       &
            'Density-area weighted flux of '//trim(T_prog(n)%name)//' through Eastern face from skew diffusion', &
            'rho_dzt*dyt*flux of '//trim(T_prog(n)%name), (/-1.e18,1.e18/))
       id_skew_flux_y_ytn(n) = register_3d_ytn_field(Grid, Time, 'skew_flux_y_ytn_'//trim(T_prog(n)%name),        &
            'Density-area weighted flux of '//trim(T_prog(n)%name)//' through Northern face from skew diffusion', &
            'rho_dzt*dxt*flux of '//trim(T_prog(n)%name), (/-1.e18,1.e18/))
       id_skew_flux_z_ztb(n) = register_3d_ztb_field(Grid, Time, 'skew_flux_z_ztb_'//trim(T_prog(n)%name),        &
            'Density-area weighted flux of '//trim(T_prog(n)%name)//' through bottom face from skew diffusivion', &
            'rho*dxt*dyt*flux of '//trim(T_prog(n)%name), (/-1.e18,1.e18/))
    enddo

    allocate(id_diff_th_tendency(num_prog_tracers))
    allocate(id_skew_th_tendency(num_prog_tracers))

    do n = 1, num_prog_tracers
       id_diff_th_tendency(n) = register_3d_t_field(Grid, Time, 'diff_th_tendency_'//trim(T_prog(n)%name), &
            'Thickness density weighted tendency of '//trim(T_prog(n)%name)//' due to neutral diffusion',  &
            'rho_dzt*'//trim(T_prog(n)%units)//'/s', (/-1.e18,1.e18/))
       id_skew_th_tendency(n) = register_3d_t_field(Grid, Time, 'skew_th_tendency_'//trim(T_prog(n)%name), &
            'Thickness density weighted tendency of '//trim(T_prog(n)%name)//' due to skew diffusion',     &
            'rho_dzt*'//trim(T_prog(n)%units)//'/s', (/-1.e18,1.e18/))
    enddo

  end subroutine register_fields
  ! </SUBROUTINE> NAME="register_fields"

  !#######################################################################
  ! <SUBROUTINE NAME="flux_calculations">
  !
  ! <DESCRIPTION>
  ! This function computes the thickness weighted tendency of tracers
  ! due to neutral physics as well as the implicit vertical diffusivity
  ! term.
  ! </DESCRIPTION>
  !
  subroutine flux_calculations(Domain, Grid, Time, Thickness, dtime,               &
       symm_tensor13_xz, symm_tensor23_yz, symm_tensor33_xz, symm_tensor33_yz,     &
       symm_tensor1122_z, upsilonx_xz, upsilony_yz, dTdx, dTdy, dTdz, aredi_array, &
       total_th_tendency, T_prog)

    type(ocean_domain_type),     intent(inout) :: Domain
    type(ocean_grid_type),       intent(in)    :: Grid
    type(ocean_time_type),       intent(in)    :: Time
    type(ocean_thickness_type),  intent(in)    :: Thickness
    real,                        intent(in)    :: dtime

    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: symm_tensor13_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: symm_tensor23_yz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: symm_tensor33_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: symm_tensor33_yz
    real, dimension(isd:,jsd:,:,0:),    intent(in) :: symm_tensor1122_z
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: upsilonx_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: upsilony_yz

    real, dimension(isd:,jsd:,:,:),  intent(in) :: dTdx
    real, dimension(isd:,jsd:,:,:),  intent(in) :: dTdy
    real, dimension(isd:,jsd:,0:,:), intent(in) :: dTdz

    real, dimension(isd:,jsd:,:), intent(in) :: aredi_array

    real, dimension(isd:,jsd:,:,:),             intent(out)   :: total_th_tendency
    type(ocean_prog_tracer_type), dimension(:), intent(inout) :: T_prog

    ! Mass weighted neutral diffusion tensor components [kgm^2/s]
    real, dimension(isd:ied,jsd:jed,nk)         :: symm_mass_diff_11_xte
    real, dimension(isd:ied,jsd:jed,nk)         :: symm_mass_diff_22_ytn
    real, dimension(isd:ied,jsd:jed,nk,0:1)     :: symm_mass_diff_33_z
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: symm_mass_diff_13_h_xz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: symm_mass_diff_23_h_yz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: symm_mass_diff_31_v_xz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: symm_mass_diff_32_v_yz

    ! Mass weighted skew diffusion tensor components [kgm^2/s]
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: skew_mass_diff_13_h_xz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: skew_mass_diff_23_h_yz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: skew_mass_diff_31_v_xz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: skeW_mass_diff_32_v_yz

    ! non-tensor based value of (kS) for used horizontal on diffusion [m^2/s]
    real, dimension(isd:ied,jsd:jed,nk) :: simple_mass_diff_11_xte 
    real, dimension(isd:ied,jsd:jed,nk) :: simple_mass_diff_22_ytn

    ! [kg*T/s]
    real, dimension(isd:ied,jsd:jed,nk,size(T_prog))   :: diff_flux_x_xte, diff_flux_y_ytn
    real, dimension(isd:ied,jsd:jed,0:nk,size(T_prog)) :: diff_flux_z_ztb
    real, dimension(isd:ied,jsd:jed,nk,size(T_prog))   :: skew_flux_x_xte, skew_flux_y_ytn
    real, dimension(isd:ied,jsd:jed,0:nk,size(T_prog)) :: skew_flux_z_ztb

    real, dimension(isd:ied,jsd:jed,nk) :: m33_explicit_ztb
    integer :: n, num_prog_tracers

    num_prog_tracers = size(T_prog)

    call mpp_clock_begin(id_clock_flux_mass_diff)
    call compute_mass_diff(Time, symm_tensor13_xz, symm_tensor23_yz, symm_tensor33_xz, &
         symm_tensor33_yz, symm_tensor1122_z, upsilonx_xz, upsilony_yz,                &
         aredi_array, Time%tau, Thickness, Grid, Domain,                               &
         simple_mass_diff_11_xte, simple_mass_diff_22_ytn,                             &
         symm_mass_diff_11_xte, symm_mass_diff_22_ytn,                                 &
         symm_mass_diff_13_h_xz, symm_mass_diff_23_h_yz,                               &
         symm_mass_diff_31_v_xz, symm_mass_diff_32_v_yz,                               &
         symm_mass_diff_33_z, skew_mass_diff_13_h_xz,                                  &
         skew_mass_diff_23_h_yz, skew_mass_diff_31_v_xz, skew_mass_diff_32_v_yz)
    call mpp_clock_end(id_clock_flux_mass_diff)

    call mpp_clock_begin(id_clock_flux_33_term)
    call compute_33_term(Time, Grid, symm_mass_diff_33_z, dtime, Time%tau, Thickness, &
         m33_explicit_ztb, T_prog)
    call mpp_clock_end(id_clock_flux_33_term)

    call mpp_clock_begin(id_clock_flux_fluxes)
    call compute_fluxes(symm_mass_diff_11_xte, symm_mass_diff_13_h_xz,     &
         symm_mass_diff_22_ytn, symm_mass_diff_23_h_yz,                    &
         symm_mass_diff_31_v_xz, symm_mass_diff_32_v_yz, m33_explicit_ztb, &
         skew_mass_diff_13_h_xz, skew_mass_diff_23_h_yz,                   & 
         skew_mass_diff_31_v_xz, skew_mass_diff_32_v_yz,                   &
         dTdx, dTdy, dTdz, Grid, Thickness,                                &
         diff_flux_x_xte, diff_flux_y_ytn, diff_flux_z_ztb,                &
         skew_flux_x_xte, skew_flux_y_ytn, skew_flux_z_ztb, T_prog)
    call mpp_clock_end(id_clock_flux_fluxes)

    call mpp_clock_begin(id_clock_flux_tracer_limits)
    call apply_tracer_limits(simple_mass_diff_11_xte,       &
         simple_mass_diff_22_ytn, Grid, dTdx, dTdy,         &
         diff_flux_x_xte, diff_flux_y_ytn, diff_flux_z_ztb, &
         skew_flux_x_xte, skew_flux_y_ytn, skew_flux_z_ztb, T_prog)
    call mpp_clock_end(id_clock_flux_tracer_limits)

    call mpp_clock_begin(id_clock_flux_misc)
    if (Grid%tripolar) then
       do n = 1, num_prog_tracers
          call mpp_update_domains(diff_flux_x_xte(:,:,:,n), diff_flux_y_ytn(:,:,:,n), &
               Dom_flux%domain2d, gridtype=CGRID_NE, complete=T_prog(n)%complete)
          call mpp_update_domains(skew_flux_x_xte(:,:,:,n), skew_flux_y_ytn(:,:,:,n), &
               Dom_flux%domain2d, gridtype=CGRID_NE, complete=T_prog(n)%complete)
       enddo
    endif

    ! minus sign is a MOM convention.
    do n = 1, num_prog_tracers
       call diagnose_3d(Time, Grid, id_diff_flux_x_xte(n), -diff_flux_x_xte(:,:,:,n))
       call diagnose_3d(Time, Grid, id_diff_flux_y_ytn(n), -diff_flux_y_ytn(:,:,:,n))
       call diagnose_3d(Time, Grid, id_diff_flux_z_ztb(n), -diff_flux_z_ztb(:,:,1:,n))
       call diagnose_3d(Time, Grid, id_skew_flux_x_xte(n), -skew_flux_x_xte(:,:,:,n))
       call diagnose_3d(Time, Grid, id_skew_flux_y_ytn(n), -skew_flux_y_ytn(:,:,:,n))
       call diagnose_3d(Time, Grid, id_skew_flux_z_ztb(n), -skew_flux_z_ztb(:,:,1:,n))
    enddo
    call mpp_clock_end(id_clock_flux_misc)

    call mpp_clock_begin(id_clock_flux_update)
    call update_tendencies(Time, Grid, diff_flux_x_xte, &
         diff_flux_y_ytn, diff_flux_z_ztb,              &
         skew_flux_x_xte, skew_flux_y_ytn,              &
         skew_flux_z_ztb, total_th_tendency)
    call mpp_clock_end(id_clock_flux_update)

  end subroutine flux_calculations
  ! </SUBROUTINE> NAME="flux_calculations"

  !#######################################################################
  ! <SUBROUTINE NAME="compute_mass_diff">
  !
  ! <DESCRIPTION>
  ! Subroutine computes the vertical neutral diffusion tracer flux component.
  ! Compute this component for all tracers at level k.
  ! Surface and bottom boundary condition fz(k=0)=fz(k=kmt(i,j))=0
  !
  ! fz has physical dimensions (density*diffusivity*tracer gradient)
  !
  ! This is nearly the same as the subroutine in ocean_nphysicsA.
  !
  ! </DESCRIPTION>
  !
  subroutine compute_mass_diff(Time, symm_tensor13_xz, symm_tensor23_yz, &
         symm_tensor33_xz, symm_tensor33_yz, symm_tensor1122_z,          &
         upsilonx_xz, upsilony_yz,                                       &
         aredi_array, tau, Thickness, Grid, Domain,                      &
         simple_mass_diff_11_xte, simple_mass_diff_22_ytn,               &
         symm_mass_diff_11_xte,  symm_mass_diff_22_ytn,                  &
         symm_mass_diff_13_h_xz, symm_mass_diff_23_h_yz,                 &
         symm_mass_diff_31_v_xz, symm_mass_diff_32_v_yz,                 &
         symm_mass_diff_33_z, skew_mass_diff_13_h_xz,                    &
         skew_mass_diff_23_h_yz, skew_mass_diff_31_v_xz, skew_mass_diff_32_v_yz)
   
    type(ocean_time_type),              intent(in) :: Time
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: symm_tensor13_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: symm_tensor23_yz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: symm_tensor33_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: symm_tensor33_yz
    real, dimension(isd:,jsd:,:,0:),    intent(in) :: symm_tensor1122_z
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: upsilonx_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: upsilony_yz

    real, dimension(isd:,jsd:,:), intent(in)    :: aredi_array
    integer,                      intent(in)    :: tau
    type(ocean_thickness_type),   intent(in)    :: Thickness
    type(ocean_grid_type),        intent(in)    :: Grid
    type(ocean_domain_type),      intent(inout) :: Domain

    real, dimension(isd:,jsd:,:),       intent(out) :: simple_mass_diff_11_xte
    real, dimension(isd:,jsd:,:),       intent(out) :: simple_mass_diff_22_ytn
    real, dimension(isd:,jsd:,:),       intent(out) :: symm_mass_diff_11_xte
    real, dimension(isd:,jsd:,:),       intent(out) :: symm_mass_diff_22_ytn
    real, dimension(isd:,jsd:,:,0:),    intent(out) :: symm_mass_diff_33_z

    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: symm_mass_diff_13_h_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: symm_mass_diff_23_h_yz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: symm_mass_diff_31_v_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: symm_mass_diff_32_v_yz

    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: skew_mass_diff_13_h_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: skew_mass_diff_23_h_yz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: skew_mass_diff_31_v_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: skew_mass_diff_32_v_yz

    ! Density weighted quarter cell volumes [kg]
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: rho_qcv_xz, rho_qcv_yz

    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: simple_mass_diff_11_h_xz, simple_mass_diff_22_h_yz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: symm_mass_diff_11_h_xz, symm_mass_diff_22_h_yz

    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: simple_mass_diff_11_xz, simple_mass_diff_22_yz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: symm_mass_diff_11_xz, symm_mass_diff_22_yz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: symm_mass_diff_13_xz, symm_mass_diff_23_yz
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: skew_mass_diff_13_xz, skew_mass_diff_23_yz

    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: full_tensor1122 ! [m^2/s]

    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: full_aredi ! [m^2/s]

    call geometric_terms(Grid, Thickness%rho_dzt(:,:,:,tau), Thickness%dzt(:,:,:), rho_qcv_xz, rho_qcv_yz)

    full_aredi(COMP,:,:,:)      = spread(spread(aredi_array(COMP,:), 4, 2), 5, 2)
    full_tensor1122(COMP,:,:,:) = spread(symm_tensor1122_z(COMP,:,:), 5, 2)

    simple_mass_diff_11_xz(COMP,:,:,:) = full_aredi(COMP,:,:,:)*rho_qcv_xz(COMP,:,:,:)
    simple_mass_diff_22_yz(COMP,:,:,:) = full_aredi(COMP,:,:,:)*rho_qcv_yz(COMP,:,:,:)
    symm_mass_diff_11_xz(COMP,:,:,:)   = full_tensor1122(COMP,:,:,:)*rho_qcv_xz(COMP,:,:,:)
    symm_mass_diff_22_yz(COMP,:,:,:)   = full_tensor1122(COMP,:,:,:)*rho_qcv_yz(COMP,:,:,:)
    symm_mass_diff_13_xz(COMP,:,:,:)   = symm_tensor13_xz(COMP,:,:,:)*rho_qcv_xz(COMP,:,:,:)
    symm_mass_diff_23_yz(COMP,:,:,:)   = symm_tensor23_yz(COMP,:,:,:)*rho_qcv_yz(COMP,:,:,:)
    skew_mass_diff_13_xz(COMP,:,:,:)   = upsilonx_xz(COMP,:,:,:)*rho_qcv_xz(COMP,:,:,:)
    skew_mass_diff_23_yz(COMP,:,:,:)   = upsilony_yz(COMP,:,:,:)*rho_qcv_yz(COMP,:,:,:)
    call mpp_update_domains(simple_mass_diff_11_xz, Domain%domain2d)
    call mpp_update_domains(simple_mass_diff_22_yz, Domain%domain2d)
    call mpp_update_domains(symm_mass_diff_11_xz, Domain%domain2d)
    call mpp_update_domains(symm_mass_diff_22_yz, Domain%domain2d)
    call mpp_update_domains(symm_mass_diff_13_xz, Domain%domain2d)
    call mpp_update_domains(symm_mass_diff_23_yz, Domain%domain2d)
    call mpp_update_domains(skew_mass_diff_13_xz, Domain%domain2d)
    call mpp_update_domains(skew_mass_diff_23_yz, Domain%domain2d)

    ! off diagonal terms
    call stencil_centre_to_horiz(symm_mass_diff_13_xz,   symm_mass_diff_23_yz, &
                                 symm_mass_diff_13_h_xz, symm_mass_diff_23_h_yz)
    call stencil_centre_to_vert( symm_mass_diff_13_xz,   symm_mass_diff_23_yz, &
                                 symm_mass_diff_31_v_xz, symm_mass_diff_32_v_yz)
    call stencil_centre_to_horiz(skew_mass_diff_13_xz,   skew_mass_diff_23_yz,  &
                                 skew_mass_diff_13_h_xz, skew_mass_diff_23_h_yz)
    call stencil_centre_to_vert(-skew_mass_diff_13_xz,  -skew_mass_diff_23_yz,  &
                                 skew_mass_diff_31_v_xz, skew_mass_diff_32_v_yz)

    ! horizontal diagonal terms    
    call stencil_centre_to_horiz(symm_mass_diff_11_xz, symm_mass_diff_22_yz, &
                                 symm_mass_diff_11_h_xz, symm_mass_diff_22_h_yz)
    symm_mass_diff_11_xte(COMPXL,:) = sum(sum(symm_mass_diff_11_h_xz(COMPXL,:,:,:), dim=5), dim=4)
    symm_mass_diff_22_ytn(COMPYL,:) = sum(sum(symm_mass_diff_22_h_yz(COMPYL,:,:,:), dim=5), dim=4)

    ! Simple horizontal
    call stencil_centre_to_horiz(simple_mass_diff_11_xz, simple_mass_diff_22_yz, &
                                 simple_mass_diff_11_h_xz, simple_mass_diff_22_h_yz)
    simple_mass_diff_11_xte(COMPXLYL,:) = sum(sum(simple_mass_diff_11_h_xz(COMPXLYL,:,:,:), dim=5), dim=4)
    simple_mass_diff_22_ytn(COMPXLYL,:) = sum(sum(simple_mass_diff_22_h_yz(COMPXLYL,:,:,:), dim=5), dim=4)

    ! Sum over each half cell
    symm_mass_diff_33_z(COMP,:,:) = sum(symm_tensor33_xz(COMP,:,:,:)*rho_qcv_xz(COMP,:,:,:) &
         +                              symm_tensor33_yz(COMP,:,:,:)*rho_qcv_yz(COMP,:,:,:), dim=4)

    call diagnose_3d(Time, Grid, id_symm_mass_diff_11_xte, symm_mass_diff_11_xte)
    call diagnose_3d(Time, Grid, id_symm_mass_diff_22_ytn, symm_mass_diff_22_ytn)

    call diagnose_3d(Time, Grid, id_symm_mass_diff_13_h_xz, sum(sum(symm_mass_diff_13_h_xz, dim=5), dim=4))
    call diagnose_3d(Time, Grid, id_symm_mass_diff_23_h_yz, sum(sum(symm_mass_diff_23_h_yz, dim=5), dim=4))
    call diagnose_3d(Time, Grid, id_symm_mass_diff_31_v_xz, sum(sum(symm_mass_diff_31_v_xz, dim=5), dim=4))
    call diagnose_3d(Time, Grid, id_symm_mass_diff_32_v_yz, sum(sum(symm_mass_diff_32_v_yz, dim=5), dim=4))
    
    call diagnose_3d(Time, Grid, id_skew_mass_diff_13_h_xz, sum(sum(skew_mass_diff_13_h_xz, dim=5), dim=4))
    call diagnose_3d(Time, Grid, id_skew_mass_diff_23_h_yz, sum(sum(skew_mass_diff_23_h_yz, dim=5), dim=4))
    call diagnose_3d(Time, Grid, id_skew_mass_diff_31_v_xz, sum(sum(skew_mass_diff_31_v_xz, dim=5), dim=4))
    call diagnose_3d(Time, Grid, id_skew_mass_diff_32_v_yz, sum(sum(skew_mass_diff_32_v_yz, dim=5), dim=4))

  end subroutine compute_mass_diff
  ! </SUBROUTINE> NAME="compute_mass_diff"


  !#######################################################################
  ! <SUBROUTINE NAME="geometric_terms">
  !
  ! <DESCRIPTION>
  ! Calculate the density weighted quarter cell volumes of the triads.
  ! </DESCRIPTION>
  !
  subroutine geometric_terms(Grid, rho_dzt, dzt, &
       rho_qcv_xz, rho_qcv_yz)

    type(ocean_grid_type),        intent(in) :: Grid
    real, dimension(isd:,jsd:,:), intent(in) :: rho_dzt
    real, dimension(isd:,jsd:,:), intent(in) :: dzt

    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: rho_qcv_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(out) :: rho_qcv_yz

    integer :: k, ip, kr

    ! density calculated by removing dzt from rho_dzt [kg/m^3]
    real, dimension(isd:ied,jsd:jed,nk) :: rho

    ! minimum half cell thickness between adjacent tracer cells [m]
    real, dimension(isd:ied,jsd:jed,nk,0:1) :: min_dzt_xte_z
    real, dimension(isd:ied,jsd:jed,nk,0:1) :: min_dzt_ytn_z

    ! quarter cell area [m^2]
    real, dimension(isd:ied,jsd:jed,nk,0:1,0:1) :: qca_xz, qca_yz

    do k = 1, nk
       do kr = 0, 1
          min_dzt_xte_z(:,:,k,kr) = FMX(Grid%fracdz(k,kr)*dzt(:,:,k)) ! G(2004): 16.53
          min_dzt_ytn_z(:,:,k,kr) = FMY(Grid%fracdz(k,kr)*dzt(:,:,k)) ! G(2004): 16.54
       enddo
    enddo

    do k = 1, nk
       qca_xz(COMP,k,0,0) = Grid%dtw(COMP)*min_dzt_xte_z(COMPXLL,k,0) ! ~ V(1)
       qca_xz(COMP,k,0,1) = Grid%dtw(COMP)*min_dzt_xte_z(COMPXLL,k,1) ! ~ V(3)
       qca_xz(COMP,k,1,0) = Grid%dte(COMP)*min_dzt_xte_z(COMP,k,0)    ! ~ V(2)
       qca_xz(COMP,k,1,1) = Grid%dte(COMP)*min_dzt_xte_z(COMP,k,1)    ! ~ V(4)

       qca_yz(COMP,k,0,0) = Grid%dts(COMP)*min_dzt_ytn_z(COMPYLL,k,0)
       qca_yz(COMP,k,0,1) = Grid%dts(COMP)*min_dzt_ytn_z(COMPYLL,k,1)
       qca_yz(COMP,k,1,0) = Grid%dtn(COMP)*min_dzt_ytn_z(COMP,k,0)
       qca_yz(COMP,k,1,1) = Grid%dtn(COMP)*min_dzt_ytn_z(COMP,k,1)
    enddo

    rho(COMP,:) = (rho_dzt(COMP,:)/(dzt(COMP,:) + epsln))
    do k = 1, nk
       do ip = 0, 1
          do kr = 0, 1
             rho_qcv_xz(COMP,k,ip,kr) = rho(COMP,k)*qca_xz(COMP,k,ip,kr)*Grid%dyt(COMP)
             rho_qcv_yz(COMP,k,ip,kr) = rho(COMP,k)*qca_yz(COMP,k,ip,kr)*Grid%dxt(COMP)
          enddo
       enddo
    enddo

  end subroutine geometric_terms
  ! </SUBROUTINE> NAME="geometric_terms"

  !#######################################################################
  ! <SUBROUTINE NAME="compute_33_term">
  !
  ! <DESCRIPTION>
  ! K33 is the (3,3) term in small angle Redi diffusion tensor.
  ! It is broken into an explicit in time piece and implicit
  ! in time piece.  It is weighted by density for non-Boussinesq
  ! and rho0 for Boussinesq.
  !
  ! K33 has units (kg/m^3)*m^2/sec.
  ! </DESCRIPTION>
  subroutine compute_33_term(Time, Grid, symm_mass_diff_33_z, dtime, tau, Thickness, &
       m33_explicit_ztb, T_prog)

    type(ocean_time_type),              intent(in) :: Time
    type(ocean_grid_type),              intent(in) :: Grid
    real, dimension(isd:,jsd:,:,0:),    intent(in) :: symm_mass_diff_33_z
    real,                               intent(in) :: dtime
    integer,                            intent(in) :: tau
    type(ocean_thickness_type),         intent(in) :: Thickness

    real, dimension(isd:,jsd:,:), intent(out) :: m33_explicit_ztb
    type(ocean_prog_tracer_type), dimension(:), intent(inout) :: T_prog

    integer :: k, kr
    integer :: n, num_prog_tracers

    real, dimension(isd:ied,jsd:jed,nk,0:1) :: m33_explicit_z, m33_crit_z
    real, dimension(isd:ied,jsd:jed,nk) :: m33_implicit

    ! [(kg/m^3)*(m^2/s)]
    real, dimension(isd:ied,jsd:jed,nk) :: rho_k33_implicit

    num_prog_tracers = size(T_prog)

    ! Compute the explicit component of m33
    if (.not. diffusion_all_explicit) then
       ! Critical value at the tracer point
       do k = 1, nk
          do kr = 0, 1
             m33_crit_z(COMP,k,kr) = &
             (0.5/dtime)*(Grid%fracdz(k,kr)*Thickness%dzt(COMP,k))**2 &
             *(Grid%fracdz(k,kr)*Thickness%rho_dzt(COMP,k,tau)*Grid%dat(COMP))
          enddo
       enddo
       m33_explicit_z(COMP,:,:) = min(symm_mass_diff_33_z(COMP,:,:), m33_crit_z(COMP,:,:))
    else
       m33_explicit_z(COMP,:,:) = symm_mass_diff_33_z(COMP,:,:)
    endif

    ! Tracer-centred implicit component for use in other modules
    m33_implicit(COMP,:) = sum((symm_mass_diff_33_z(COMP,:,:) - m33_explicit_z(COMP,:,:)), dim=4)
    do k = 1, nk
       rho_k33_implicit(COMP,k) = &
       m33_implicit(COMP,k)*Grid%datr(COMP)/(Thickness%dzt(COMP,k) + epsln)
    enddo
    do n = 1, num_prog_tracers
       T_prog(n)%K33_implicit(:,:,:) = rho_k33_implicit(:,:,:)
    enddo

    ! Cell-bottom centred explicit component for use in this module.    
    do k = 1, nk-1
       m33_explicit_ztb(COMP,k) = m33_explicit_z(COMP,k,1) + m33_explicit_z(COMP,k+1,0)
    enddo

    call diagnose_3d(Time, Grid, id_m33_explicit_ztb, m33_explicit_ztb)
    call diagnose_3d(Time, Grid, id_m33_implicit, m33_implicit)
  
  end subroutine compute_33_term
  ! </SUBROUTINE> NAME="compute_33_term"

  
  !#######################################################################
  ! <SUBROUTINE NAME="compute_fluxes">
  !
  ! <DESCRIPTION>
  ! Computes the tracer fluxes due to neutral diffusion and skew diffusion.
  ! Fluxes are computed at the tracer cell faces and have units of [kg*T/s].
  ! </DESCRIPTION>
  !
  subroutine compute_fluxes(symm_mass_diff_11_xte, symm_mass_diff_13_h_xz,     &
       symm_mass_diff_22_ytn,  symm_mass_diff_23_h_yz,                         &
       symm_mass_diff_31_v_xz, symm_mass_diff_32_v_yz, m33_explicit_ztb,       &
       skew_mass_diff_13_h_xz, skew_mass_diff_23_h_yz, skew_mass_diff_31_v_xz, &
       skew_mass_diff_32_v_yz, dTdx, dTdy, dTdz, Grid, Thickness,              &
       diff_flux_x_xte, diff_flux_y_ytn, diff_flux_z_ztb, skew_flux_x_xte,     &
       skew_flux_y_ytn, skew_flux_z_ztb, T_prog)

    real, dimension(isd:,jsd:,:),       intent(in) :: symm_mass_diff_11_xte
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: symm_mass_diff_13_h_xz
    real, dimension(isd:,jsd:,:),       intent(in) :: symm_mass_diff_22_ytn
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: symm_mass_diff_23_h_yz

    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: symm_mass_diff_31_v_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: symm_mass_diff_32_v_yz
    real, dimension(isd:,jsd:,:),       intent(in) :: m33_explicit_ztb

    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: skew_mass_diff_13_h_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: skew_mass_diff_23_h_yz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: skew_mass_diff_31_v_xz
    real, dimension(isd:,jsd:,:,0:,0:), intent(in) :: skew_mass_diff_32_v_yz

    real, dimension(isd:,jsd:,:,:),  intent(in) :: dTdx
    real, dimension(isd:,jsd:,:,:),  intent(in) :: dTdy
    real, dimension(isd:,jsd:,0:,:), intent(in) :: dTdz
    type(ocean_grid_type),           intent(in) :: Grid
    type(ocean_thickness_type),      intent(in) :: Thickness

    real, dimension(isd:,jsd:,:,:),  intent(out) :: diff_flux_x_xte
    real, dimension(isd:,jsd:,:,:),  intent(out) :: diff_flux_y_ytn
    real, dimension(isd:,jsd:,0:,:), intent(out) :: diff_flux_z_ztb
    real, dimension(isd:,jsd:,:,:),  intent(out) :: skew_flux_x_xte
    real, dimension(isd:,jsd:,:,:),  intent(out) :: skew_flux_y_ytn
    real, dimension(isd:,jsd:,0:,:), intent(out) :: skew_flux_z_ztb

    type(ocean_prog_tracer_type), dimension(:), intent(inout) :: T_prog

    integer :: k, n, num_prog_tracers
    ! Components of z-flux from dTdz and dTdz respectivly [(rho*dz*T/s)/m^2]
    real, dimension(isd:ied,jsd:jed,nk) :: flux_x_ztb, flux_y_ztb

    num_prog_tracers = size(T_prog)

    ! Compute the flux due to neutral diffusion
    diff_flux_x_xte(:,:,:,:) = 0.0
    diff_flux_y_ytn(:,:,:,:) = 0.0
    diff_flux_z_ztb(:,:,:,:) = 0.0
    do n = 1, num_prog_tracers
       do k = 1, nk
          diff_flux_x_xte(COMPXL,k,n) = -(symm_mass_diff_11_xte(COMPXL,k)*dTdx(COMPXL,k,n) &
               + symm_mass_diff_13_h_xz(COMPXL,k,0,0)*dTdz(COMPXL,k-1,n)                   &
               + symm_mass_diff_13_h_xz(COMPXL,k,0,1)*dTdz(COMPXL,k  ,n)                   &
               + symm_mass_diff_13_h_xz(COMPXL,k,1,0)*dTdz(COMPXR,k-1,n)                   &
               + symm_mass_diff_13_h_xz(COMPXL,k,1,1)*dTdz(COMPXR,k  ,n))*Grid%dxter(COMPXL)
          diff_flux_y_ytn(COMPYL,k,n) = -(symm_mass_diff_22_ytn(COMPYL,k)*dTdy(COMPYL,k,n) &
               + symm_mass_diff_23_h_yz(COMPYL,k,0,0)*dTdz(COMPYL,k-1,n)                   &
               + symm_mass_diff_23_h_yz(COMPYL,k,0,1)*dTdz(COMPYL,k,n)                     &
               + symm_mass_diff_23_h_yz(COMPYL,k,1,0)*dTdz(COMPYR,k-1,n)                   &
               + symm_mass_diff_23_h_yz(COMPYL,k,1,1)*dTdz(COMPYR,k,n))*Grid%dytnr(COMPYL)
       enddo

       flux_x_ztb(:,:,:) = 0.0
       flux_y_ztb(:,:,:) = 0.0
       do k = 1, nk-1
          flux_x_ztb(COMP,k) = symm_mass_diff_31_v_xz(COMP,k,0,0)*dTdx(COMPXLL,k,n)   &
               +               symm_mass_diff_31_v_xz(COMP,k,0,1)*dTdx(COMPXLL,k+1,n) &
               +               symm_mass_diff_31_v_xz(COMP,k,1,0)*dTdx(COMP,k,n)      &
               +               symm_mass_diff_31_v_xz(COMP,k,1,1)*dTdx(COMP,k+1,n)
          flux_y_ztb(COMP,k) = symm_mass_diff_32_v_yz(COMP,k,0,0)*dTdy(COMPYLL,k,n)   &
               +               symm_mass_diff_32_v_yz(COMP,k,0,1)*dTdy(COMPYLL,k+1,n) &
               +               symm_mass_diff_32_v_yz(COMP,k,1,0)*dTdy(COMP,k,n)      &
               +               symm_mass_diff_32_v_yz(COMP,k,1,1)*dTdy(COMP,k+1,n)
       enddo
       diff_flux_z_ztb(COMP,1:nk,n) = -((flux_x_ztb(COMP,:) + flux_y_ztb(COMP,:)  &
           + m33_explicit_ztb(COMP,:)*dTdz(COMP,1:nk,n))/(Thickness%dzwt(COMP,1:nk)+epsln))
    enddo

    ! Compute the flux due to skew diffusion (same algorithm as above, but without diagonal terms)
    skew_flux_x_xte(:,:,:,:) = 0.0
    skew_flux_y_ytn(:,:,:,:) = 0.0
    skew_flux_z_ztb(:,:,:,:) = 0.0
    do n = 1, num_prog_tracers
       do k = 1, nk
          skew_flux_x_xte(COMPXL,k,n) = -(                               &
               + skew_mass_diff_13_h_xz(COMPXL,k,0,0)*dTdz(COMPXL,k-1,n) &
               + skew_mass_diff_13_h_xz(COMPXL,k,0,1)*dTdz(COMPXL,k  ,n) &
               + skew_mass_diff_13_h_xz(COMPXL,k,1,0)*dTdz(COMPXR,k-1,n) &
               + skew_mass_diff_13_h_xz(COMPXL,k,1,1)*dTdz(COMPXR,k  ,n))*Grid%dxter(COMPXL)
          skew_flux_y_ytn(COMPYL,k,n) = -(                               &
               + skew_mass_diff_23_h_yz(COMPYL,k,0,0)*dTdz(COMPYL,k-1,n) &
               + skew_mass_diff_23_h_yz(COMPYL,k,0,1)*dTdz(COMPYL,k,n)   &
               + skew_mass_diff_23_h_yz(COMPYL,k,1,0)*dTdz(COMPYR,k-1,n) &
               + skew_mass_diff_23_h_yz(COMPYL,k,1,1)*dTdz(COMPYR,k,n))*Grid%dytnr(COMPYL)
       enddo

       flux_x_ztb(:,:,:) = 0.0
       flux_y_ztb(:,:,:) = 0.0
       do k = 1, nk-1
          flux_x_ztb(COMP,k) = skew_mass_diff_31_v_xz(COMP,k,0,0)*dTdx(COMPXLL,k,n)   &
               +               skew_mass_diff_31_v_xz(COMP,k,0,1)*dTdx(COMPXLL,k+1,n) &
               +               skew_mass_diff_31_v_xz(COMP,k,1,0)*dTdx(COMP,k,n)      &
               +               skew_mass_diff_31_v_xz(COMP,k,1,1)*dTdx(COMP,k+1,n)
          flux_y_ztb(COMP,k) = skew_mass_diff_32_v_yz(COMP,k,0,0)*dTdy(COMPYLL,k,n)   &
               +               skew_mass_diff_32_v_yz(COMP,k,0,1)*dTdy(COMPYLL,k+1,n) &
               +               skew_mass_diff_32_v_yz(COMP,k,1,0)*dTdy(COMP,k,n)      &
               +               skew_mass_diff_32_v_yz(COMP,k,1,1)*dTdy(COMP,k+1,n)
       enddo
       skew_flux_z_ztb(COMP,1:nk,n) = -((flux_x_ztb(COMP,:) + flux_y_ztb(COMP,:))/(Thickness%dzwt(COMP,1:nk)+epsln))
    enddo

  end subroutine compute_fluxes
  ! </SUBROUTINE> NAME="compute_fluxes"

  !#######################################################################
  ! <SUBROUTINE NAME="apply_tracer_limits">
  !
  ! <DESCRIPTION>
  ! If the neutral_physics_limit flag is set, then the flux used in regions of large
  ! tracer gradients (as defined by T_prog(n)tmask_limit) are set to have purely
  ! horizontal diffusion, with no vertical or skew terms.
  ! </DESCRIPTION>
  !
  subroutine apply_tracer_limits(simple_mass_diff_11_xte, simple_mass_diff_22_ytn, &
       Grid, dTdx, dTdy, diff_flux_x_xte, diff_flux_y_ytn, diff_flux_z_ztb,        &
       skew_flux_x_xte, skew_flux_y_ytn, skew_flux_z_ztb, T_prog)
    
    real, dimension(isd:,jsd:,:),    intent(in) :: simple_mass_diff_11_xte
    real, dimension(isd:,jsd:,:),    intent(in) :: simple_mass_diff_22_ytn
    type(ocean_grid_type),           intent(in) :: Grid
    real, dimension(isd:,jsd:,:,:),  intent(in) :: dTdx
    real, dimension(isd:,jsd:,:,:),  intent(in) :: dTdy

    real, dimension(isd:,jsd:,:,:),  intent(inout) :: diff_flux_x_xte
    real, dimension(isd:,jsd:,:,:),  intent(inout) :: diff_flux_y_ytn
    real, dimension(isd:,jsd:,0:,:), intent(inout) :: diff_flux_z_ztb
    real, dimension(isd:,jsd:,:,:),  intent(inout) :: skew_flux_x_xte
    real, dimension(isd:,jsd:,:,:),  intent(inout) :: skew_flux_y_ytn
    real, dimension(isd:,jsd:,0:,:), intent(inout) :: skew_flux_z_ztb
    type(ocean_prog_tracer_type), dimension(:), intent(inout) :: T_prog

    integer :: k, n, num_prog_tracers

    num_prog_tracers = size(T_prog)

    if (neutral_physics_limit) then
       do n = 1, num_prog_tracers
          do k = 1, nk
             where (T_prog(n)%tmask_limit(COMPXLYL,k) == 1.0)
                diff_flux_x_xte(COMPXLYL,k,n) =  &
                  -simple_mass_diff_11_xte(COMPXLYL,k)*dTdx(COMPXLYL,k,n)*Grid%dxter(COMPXLYL)
                diff_flux_y_ytn(COMPXLYL,k,n) =  &
                  -simple_mass_diff_22_ytn(COMPXLYL,k)*dTdy(COMPXLYL,k,n)*Grid%dytnr(COMPXLYL)
                skew_flux_x_xte(COMPXLYL,k,n) = 0.0
                skew_flux_y_ytn(COMPXLYL,k,n) = 0.0
             endwhere
          enddo

          where (T_prog(n)%tmask_limit(COMP,:) == 1.0) 
             diff_flux_z_ztb(COMP,1:nk,n)   = 0.0
             skew_flux_z_ztb(COMP,1:nk,n)   = 0.0
             T_prog(n)%K33_implicit(COMP,:) = 0.0
          endwhere
       enddo
    endif

  end subroutine apply_tracer_limits
  ! </SUBROUTINE> NAME="apply_tracer_limits"

  !#######################################################################
  ! <SUBROUTINE NAME="update_tendencies">
  !
  ! <DESCRIPTION>
  ! Update the tendency for each tracer in each cell based on the total flux
  ! flowing through each of the six cell faces. The tendency is calculated 
  ! separately for the flux due to neutral diffusion and due skew diffusion.
  ! </DESCRIPTION>
  !
  subroutine update_tendencies(Time, Grid, diff_flux_x_xte, diff_flux_y_ytn, diff_flux_z_ztb, &
       skew_flux_x_xte, skew_flux_y_ytn, skew_flux_z_ztb, total_th_tendency)

    type(ocean_time_type),             intent(in) :: Time
    type(ocean_grid_type),            intent(in)  :: Grid
    real, dimension(isd:,jsd:,:,:),   intent(in)  :: difF_flux_x_xte
    real, dimension(isd:,jsd:,:,:),   intent(in)  :: diff_flux_y_ytn
    real, dimension(isd:,jsd:,0:,:),  intent(in)  :: diff_flux_z_ztb
    real, dimension(isd:,jsd:,:,:),   intent(in)  :: skew_flux_x_xte
    real, dimension(isd:,jsd:,:,:),   intent(in)  :: skew_flux_y_ytn
    real, dimension(isd:,jsd:,0:,:),  intent(in)  :: skew_flux_z_ztb
    real, dimension(isd:,jsd:,:,:),   intent(out) :: total_th_tendency

    integer :: k, n, num_prog_tracers
    
    ! density thickness weighted tracer tendency due to neutral and skew diffusion [rho*dz*T/s]
    real, dimension(isd:ied,jsd:jed,nk) :: diff_th_tendency
    real, dimension(isd:ied,jsd:jed,nk) :: skew_th_tendency

    num_prog_tracers = size(total_th_tendency, dim=4)

    do n = 1, num_prog_tracers
       diff_th_tendency(:,:,:) = 0.0
       skew_th_tendency(:,:,:) = 0.0
       do k = 1, nk
          diff_th_tendency(COMP,k) =                                        &
               -(diff_flux_x_xte(COMP,k,n)   - diff_flux_x_xte(COMPXLL,k,n) &
               + diff_flux_y_ytn(COMP,k,n)   - diff_flux_y_ytn(COMPYLL,k,n) &
               + diff_flux_z_ztb(COMP,k-1,n) - diff_flux_z_ztb(COMP,k,n) )*Grid%datr(COMP)*Grid%tmask(COMP,k)
          skew_th_tendency(COMP,k) =                                        &
               -(skew_flux_x_xte(COMP,k,n)   - skew_flux_x_xte(COMPXLL,k,n) &
               + skew_flux_y_ytn(COMP,k,n)   - skew_flux_y_ytn(COMPYLL,k,n) &
               + skew_flux_z_ztb(COMP,k-1,n) - skew_flux_z_ztb(COMP,k,n) )*Grid%datr(COMP)*Grid%tmask(COMP,k)
       enddo
       total_th_tendency(COMP,:,n) = diff_th_tendency(COMP,:) + skew_th_tendency(COMP,:)
       call diagnose_3d(Time, Grid, id_diff_th_tendency(n), diff_th_tendency)
       call diagnose_3d(Time, Grid, id_skew_th_tendency(n), skew_th_tendency)
    enddo

  end subroutine update_tendencies
  ! </SUBROUTINE> NAME="update_tendencies"

end module ocean_nphysics_flux_mod

module bgrid_sponge_mod

!-----------------------------------------------------------------------
!
!   Eddy damping of prognostic fields at the top level of the model
!
!   Damping is done using a 5-point Shapiro filter.
!   For temperature, tracers, and zonal wind the zonal mean is
!   removed before applying the filter.  For meridional wind,
!   the entire field is damped.
!
!-----------------------------------------------------------------------

use mpp_mod, only: input_nml_file 
 use bgrid_horiz_mod,       only: horiz_grid_type
 use bgrid_masks_mod,       only: grid_mask_type
 use bgrid_prog_var_mod,    only: prog_var_type
 use bgrid_change_grid_mod, only: change_grid, TEMP_GRID, WIND_GRID
 use bgrid_halo_mod,        only: update_halo, vel_flux_boundary, &
                                  TEMP, UWND, VWND, &
                                  NORTH, EAST, NOPOLE

 use         fms_mod, only: error_mesg, FATAL, write_version_number, &
                            file_exist, open_namelist_file, stdlog,  &
                            check_nml_error, close_file, mpp_pe,     &
                            mpp_npes, mpp_root_pe, mpp_clock_id,     &
                            mpp_clock_begin, mpp_clock_end,          &       
                            MPP_CLOCK_SYNC, CLOCK_MODULE

 use         mpp_mod, only: mpp_transmit, mpp_sync_self

 use mpp_domains_mod, only: domain2d, domain1d,         &
                            mpp_update_domains,         &
                            mpp_get_layout,             &
                            mpp_get_pelist,             &
                            mpp_get_global_domain,      &
                            mpp_get_compute_domain,     &
                            mpp_get_compute_domains,    &
                            mpp_get_domain_components,  &
                            WUPDATE, EUPDATE,           &
                            CYCLIC_GLOBAL_DOMAIN

 implicit none
 private

 public   sponge_driver, sponge_init

!-----------------------------------------------------------------------
! namelist

!  num_sponge_levels   The number of uppermost model levels where 
!                      the sponge damping is applied.  Currently,
!                      this cannot exceed one level.   
!                         [integer, default = 0]
!
!  sponge_coeff_wind   Normalized [0,1] sponge damping coefficients
!  sponge_coeff_temp   for the top model level.
!  sponge_coeff_tracer    [real, default = 0.]
!

   integer   ::     num_sponge_levels = 0
   real      ::     sponge_coeff_wind   = 0.0
   real      ::     sponge_coeff_temp   = 0.0
   real      ::     sponge_coeff_tracer = 0.0

   namelist /bgrid_sponge_nml/ num_sponge_levels, sponge_coeff_wind, &
                               sponge_coeff_temp, sponge_coeff_tracer

!-----------------------------------------------------------------------

 character(len=128) :: version='$Id: bgrid_sponge.F90,v 19.0 2012/01/06 19:54:03 fms Exp $'
 character(len=128) :: tagname='$Name: tikal $'
 logical :: do_log  = .true.
 logical :: do_init = .true.
 integer :: id_clock

 real :: small = .000001  !  damping coefficients larger than this
                          !  activate the sponge

!--- module storage for computing exact/reproducible zonal means ---
  type zsum_type
     integer :: is , ie , js , je, isize, jsize, &
                isg, ieg, nlon, imaxsize
     integer, pointer ::  pelist(:) => NULL(), &
                        sizelist(:) => NULL()
  end type


!--- module storage for sponge control parameters ---
  type sponge_control_type
     real :: coeff_vel, coeff_tmp, coeff_trs
     integer :: numlev
     type(zsum_type) :: Zdomain_tmp, Zdomain_vel
  end type sponge_control_type

  type(sponge_control_type),save :: Control

!-----------------------------------------------------------------------

contains

!#######################################################################

 subroutine sponge_driver ( Hgrid, nplev, dt, dpde, Var, Var_dt )
 
!-----------------------------------------------------------------------
! Hgrid  = horizontal grid constants
! nplev  = number of "pure" pressure levels at the top of the model
! dt     = adjustment time step
! dpde   = pressure weight for model layers
! Var    = prognostic variables at the last updated time level
! Var_dt = tendency of prog variables since the last updated time level
!-----------------------------------------------------------------------
 type (horiz_grid_type), intent(inout) :: Hgrid
 integer,                intent(in)    :: nplev
 real,                   intent(in)    :: dt
 real,                   intent(in)    :: dpde(Hgrid%ilb:,Hgrid%jlb:,:)
 type  (prog_var_type),  intent(in)    :: Var
 type  (prog_var_type),  intent(inout) :: Var_dt
!-----------------------------------------------------------------------

 real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub,Control%numlev) :: dpxy
 integer :: n, np, nt

!-----------------------------------------------------------------------

   if (do_init) call error_mesg ('bgrid_sponge_mod',  &
                                 'initialization not called', FATAL)

   if ( Control%numlev == 0 ) return

   call mpp_clock_begin (id_clock)
!-----------------------------------------------------------------------

   n  = Control%numlev   ! number of sponge levels
   np = nplev    ! number of pressure levels at top of model

!---- temperature and tracers -----

   if ( Control%coeff_tmp > small .or. Control%coeff_trs > small ) then
       nt = Var_dt%ntrace
       call local_filter_mass ( Hgrid, np, dt, dpde(:,:,1:n),              &
                                Var   %t(:,:,1:n), Var   %r(:,:,1:n,1:nt), &
                                Var_dt%t(:,:,1:n), Var_dt%r(:,:,1:n,1:nt)  )
   endif

!---- momentum components -----

   if ( Control%coeff_vel > small ) then
      ! compute pressure weights at velocity points
        dpxy(:,:,:) = dpde(:,:,1:n)
        if (np < n) then
          call change_grid (Hgrid, TEMP_GRID, WIND_GRID, &
                            dpxy(:,:,np+1:n), dpxy(:,:,np+1:n))
          call update_halo (Hgrid, UWND, dpxy(:,:,np+1:n), &
                            halos=EAST+NORTH, flags=NOPOLE)
        endif

        call local_filter_vel ( Hgrid, np, dt, dpxy,                  &
                                Var   %u(:,:,1:n), Var   %v(:,:,1:n), &
                                Var_dt%u(:,:,1:n), Var_dt%v(:,:,1:n)  )
   endif

   call mpp_clock_end (id_clock)
!-----------------------------------------------------------------------

 end subroutine sponge_driver

!#######################################################################

 subroutine sponge_init (Hgrid )
 type (horiz_grid_type), intent(in) :: Hgrid ! horizontal grid constants

 integer :: unit, ierr, io, logunit
!-----------------------------------------------------------------------
! read namelist
   if (file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
       read (input_nml_file, nml=bgrid_sponge_nml, iostat=io)
       ierr = check_nml_error(io,'bgrid_sponge_nml')
#else
       unit = open_namelist_file ( )
       ierr=1; do while (ierr /= 0)
          read (unit, nml=bgrid_sponge_nml, iostat=io, end=5)
          ierr = check_nml_error (io, 'bgrid_sponge_nml')
       enddo
 5     call close_file (unit)
#endif
   endif
! write version and namelist to log 
   if (do_log) then
      call write_version_number(version, tagname)
      logunit=stdlog()
      if (mpp_pe() == mpp_root_pe()) write (logunit, nml=bgrid_sponge_nml)
      do_log = .false.
   endif

! timing routine initialization
   id_clock = mpp_clock_id ('BGRID: sponge', flags=MPP_CLOCK_SYNC, &
                                             grain=CLOCK_MODULE)

! set values for optional arguments
   Control%coeff_vel = min(max(sponge_coeff_wind  ,0.),1.)
   Control%coeff_tmp = min(max(sponge_coeff_temp  ,0.),1.)
   Control%coeff_trs = min(max(sponge_coeff_tracer,0.),1.)
   Control%numlev    = max(num_sponge_levels,0)

!  do not allow more than one sponge layer in this version
   if (Control%numlev > 1) call error_mesg ('bgrid_sponge_mod',  &
                                            'numlev > 1 ', FATAL)

!  set up domain2d types for computing bit-reproducible zonal means

   if ( Control%coeff_tmp > small .or. Control%coeff_trs > small ) then
           call zsum_init ( Hgrid%Tmp%Domain, Control%Zdomain_tmp )
   endif
   if ( Control%coeff_vel > small ) then
           call zsum_init ( Hgrid%Vel%Domain, Control%Zdomain_vel )
   endif

   do_init=.false.

!-----------------------------------------------------------------------

 end subroutine sponge_init

!#######################################################################
! sponge/filter for temperature and tracers fields

 subroutine local_filter_mass ( Hgrid, nplev, dt, dp, t, tr, tdt, trdt )

   type (horiz_grid_type), intent(inout) :: Hgrid
   integer, intent(in)                   :: nplev
   real,    intent(in)                   :: dt
   real,    intent(in),    dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: dp, t
   real,    intent(inout), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: tdt
   real,    intent(in),    dimension(Hgrid%ilb:,Hgrid%jlb:,:,:) :: tr
   real,    intent(inout), dimension(Hgrid%ilb:,Hgrid%jlb:,:,:) :: trdt

   real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub,size(t,3)) :: &
                                             tmp, akew, akns, akdp
   real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub) :: tew, tns
   real, dimension(Hgrid%jlb:Hgrid%jub) :: akew2, akns2
   integer :: i, j, k, is, ie, js, je, n

   is  = Hgrid%Tmp%is;   ie  = Hgrid%Tmp%ie
   js  = Hgrid%Tmp%js;   je  = Hgrid%Tmp%je

 ! 2D geometric constants
   do j = js-1, je
      akew2(j) = 0.0625 * (Hgrid%Tmp%area(j)+Hgrid%Tmp%area(j))
      akns2(j) = 0.0625 * (Hgrid%Tmp%area(j)+Hgrid%Tmp%area(j+1))
   enddo

 ! 3D mass weighted constants
   do k = 1, size(t,3)
   do j = js-1, je
      akew(is-1:ie,j,k) = akew2(j)
      akns(is-1:ie,j,k) = akns2(j)
      akdp(:,j,k) = Hgrid%Tmp%rarea(j)/dt
   enddo
   enddo
   do k = nplev+1, size(t,3)
      do j = js-1, je
      do i = is-1, ie
         akew(i,j,k) = akew(i,j,k) * (dp(i,j,k)+dp(i+1,j,k))
         akns(i,j,k) = akns(i,j,k) * (dp(i,j,k)+dp(i,j+1,k))
         akdp(i,j,k) = akdp(i,j,k) / (2.*dp(i,j,k))
      enddo
      enddo
   enddo


 ! temperature

   if ( Control%coeff_tmp > small ) then
      tmp = t + dt*tdt
     !---- remove zonal mean ----
      call remove_mean ( Control%Zdomain_tmp, tmp(is:ie,js:je,:) )
      call update_halo ( Hgrid, TEMP, tmp )
      do k = 1, size(t,3)
         do j = js-1, je
         do i = is-1, ie
            tew(i,j) = akew(i,j,k) * (tmp(i+1,j,k)-tmp(i,j,k))
            tns(i,j) = akns(i,j,k) * (tmp(i,j+1,k)-tmp(i,j,k))
         enddo
         enddo
         do j = js, je
         do i = is, ie
            tdt(i,j,k) = tdt(i,j,k) + &
                  Control%coeff_tmp*(tew(i,j)-tew(i-1,j)+tns(i,j)-tns(i,j-1))*akdp(i,j,k)
         enddo
         enddo
      enddo
   endif

 ! tracers

   if ( Control%coeff_trs > small ) then
      do n = 1, size(tr,4)
         tmp = tr(:,:,:,n) + dt*trdt(:,:,:,n)
        !---- remove zonal mean ----
         call remove_mean ( Control%Zdomain_tmp, tmp(is:ie,js:je,:) )
         call update_halo ( Hgrid, TEMP, tmp )
         do k = 1, size(tr,3)
            do j = js-1, je
            do i = is-1, ie
               tew(i,j) = akew(i,j,k) * (tmp(i+1,j,k)-tmp(i,j,k))
               tns(i,j) = akns(i,j,k) * (tmp(i,j+1,k)-tmp(i,j,k))
            enddo
            enddo
            do j = js, je
            do i = is, ie
               trdt(i,j,k,n) = trdt(i,j,k,n) +  &
                    Control%coeff_trs*(tew(i,j)-tew(i-1,j)+tns(i,j)-tns(i,j-1))*akdp(i,j,k)
            enddo
            enddo
         enddo
      enddo
   endif

 end subroutine local_filter_mass

!#######################################################################
! sponge/filter for momentum components

 subroutine local_filter_vel ( Hgrid, nplev, dt, dp, u, v, udt, vdt )

   type (horiz_grid_type), intent(inout) :: Hgrid
   integer, intent(in)                   :: nplev
   real,    intent(in)                   :: dt
   real,    intent(in),    dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: dp, u, v
   real,    intent(inout), dimension(Hgrid%ilb:,Hgrid%jlb:,:) :: udt, vdt

   real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub,size(u,3)) :: &
                                                akew, akns, akdp, uu, vv
   real, dimension(Hgrid%ilb:Hgrid%iub,Hgrid%jlb:Hgrid%jub) ::  uew, vew, uns, vns
   real, dimension(Hgrid%jlb:Hgrid%jub) ::  akew2, akns2
   integer :: i, j, k, is, ie, js, je

   is  = Hgrid%Tmp%is;   ie  = Hgrid%Tmp%ie
   js  = Hgrid%Vel%js;   je  = Hgrid%Vel%je

 ! 2D geometric constants
   do j = js, je+1
      akew2(j) = 0.0625 * Control%coeff_vel * (Hgrid%Vel%area(j)+Hgrid%Vel%area(j))
      akns2(j) = 0.0625 * Control%coeff_vel * (Hgrid%Vel%area(j-1)+Hgrid%Vel%area(j))
   enddo

 ! 3D mass weighted constants
   do k = 1, size(u,3)
   do j = js, je+1
      akew(is:ie+1,j,k) = akew2(j)
      akns(is:ie+1,j,k) = akns2(j)
      akdp(:,j,k) = Hgrid%Vel%rarea(j)/dt
   enddo
   enddo
   do k = nplev+1, size(u,3)
      do j = js, je+1
      do i = is, ie+1
         akew(i,j,k) = akew(i,j,k) * (dp(i,j,k)+dp(i-1,j,k))
         akns(i,j,k) = akns(i,j,k) * (dp(i,j,k)+dp(i,j-1,k))
         akdp(i,j,k) = akdp(i,j,k) / (2.*dp(i,j,k))
      enddo
      enddo
   enddo

   uu = u + dt*udt
   vv = v + dt*vdt
  !---- remove zonal mean from u comp ----
   call remove_mean ( Control%Zdomain_vel, uu(is:ie,js:je,:) )
   call update_halo ( Hgrid, UWND, uu )
   call update_halo ( Hgrid, VWND, vv )

   do k = 1, size(u,3)
      do j = js, je+1
      do i = is, ie+1
         uew(i,j) = akew(i,j,k) * (uu(i,j,k)-uu(i-1,j,k))
         vew(i,j) = akew(i,j,k) * (vv(i,j,k)-vv(i-1,j,k))
         uns(i,j) = akns(i,j,k) * (uu(i,j,k)-uu(i,j-1,k))
         vns(i,j) = akns(i,j,k) * (vv(i,j,k)-vv(i,j-1,k))
      enddo
      enddo
     !---- remove meridional gradients adjacent to poles ----
      call vel_flux_boundary (Hgrid, uns)
      call vel_flux_boundary (Hgrid, vns)

      do j = js, je
      do i = is, ie
         udt(i,j,k) = udt(i,j,k) + (uew(i+1,j)-uew(i,j)+uns(i,j+1)-uns(i,j))*akdp(i,j,k)
         vdt(i,j,k) = vdt(i,j,k) + (vew(i+1,j)-vew(i,j)+vns(i,j+1)-vns(i,j))*akdp(i,j,k)
      enddo
      enddo
   enddo

 end subroutine local_filter_vel

!#######################################################################
! initializes domain2d type for summation in zonal direction

 subroutine zsum_init ( Domain, Zonal )
 type(domain2d),  intent(in)   :: Domain
 type(zsum_type), intent(out)  :: Zonal
 integer :: layout(2)
 type(domain1D) :: Domx, Domy

! create new domain2d type with large global halo along x-axis 
  call mpp_get_layout ( Domain, layout )
  allocate ( Zonal%pelist(layout(1)), Zonal%sizelist(layout(1)) )

  call mpp_get_domain_components ( Domain, Domx, Domy )
  call mpp_get_pelist            ( Domx, Zonal%pelist )
  call mpp_get_compute_domains   ( Domx, size=Zonal%sizelist )

! get compute domain 
  call mpp_get_global_domain  ( Domain, Zonal%isg, Zonal%ieg  )
  call mpp_get_compute_domain ( Domain, Zonal%is , Zonal%ie , &
                                        Zonal%js , Zonal%je   )
  Zonal%imaxsize = maxval(Zonal%sizelist)
  Zonal%isize = Zonal%ie-Zonal%is+1
  Zonal%jsize = Zonal%je-Zonal%js+1
  Zonal%nlon  = Zonal%ieg-Zonal%isg+1

 end subroutine zsum_init

!#######################################################################

 subroutine remove_mean ( Zonal, local )
 type(zsum_type), intent(in)   :: Zonal
 real,            intent(inout):: local(Zonal%is:,Zonal%js:,:) ! compute domain only
 real, dimension(Zonal%js:Zonal%je,size(local,3)) :: zsum
 real, dimension(Zonal%imaxsize*Zonal%jsize*size(local,3)) :: data_get
 real, dimension(Zonal%isize*Zonal%jsize*size(local,3)) :: data_put
 integer :: i, j, k, m, n, is, ie, npts_put, npts_get

   zsum = 0.
   ie = Zonal%isg - 1
 ! loop thru PEs in zonal direction
   do n = 1, size(Zonal%pelist(:))
      is = ie + 1
      ie = is + Zonal%sizelist(n) - 1
      if (Zonal%pelist(n) == mpp_pe()) then
        ! data is local to current PE
          do k = 1, size(local,3)
          do j = Zonal%js, Zonal%je
          do i = is, ie
             zsum(j,k) = zsum(j,k) + local(i,j,k)
          enddo
          enddo
          enddo
      else
        ! reshape input array into 1d array (data must be contiguous)
          m = 0
          do k = 1, size(local,3)
          do j = Zonal%js, Zonal%je
          do i = Zonal%is, Zonal%ie
             m = m+1
             data_put(m) = local(i,j,k)
          enddo
          enddo
          enddo
          npts_put = size(data_put(:))
          npts_get = Zonal%sizelist(n)*size(local,2)*size(local,3)
        ! data is not local (communication required)
          call mpp_transmit ( put_data=data_put, put_len=npts_put,   to_pe=Zonal%pelist(n), &
                              get_data=data_get, get_len=npts_get, from_pe=Zonal%pelist(n)  )
        ! reshape (with summation)
          m = 0
          do k = 1, size(local,3)
          do j = Zonal%js, Zonal%je
          do i = is, ie
             m = m+1
             zsum(j,k) = zsum(j,k) + data_get(m)
          enddo
          enddo
          enddo
      endif
   enddo

 ! remove zonal mean
   do k = 1, size(local,3)
   do j = Zonal%js, Zonal%je
   do i = Zonal%is, Zonal%ie
      local(i,j,k) = local(i,j,k) - zsum(j,k)/real(Zonal%nlon)
   enddo
   enddo
   enddo

   ! required after a call to mpp_transmit
   call mpp_sync_self()
      
 end subroutine remove_mean

!#######################################################################

end module bgrid_sponge_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL
 
!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: radar_simulator.F90,v 20.0 2013/12/13 23:16:51 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

  subroutine radar_simulator(freq,k2,do_ray,use_gas_abs,use_mie_table,mt, &
    nhclass,hp,nprof,ngate,nsizes,D,hgt_matrix,hm_matrix,re_matrix,p_matrix,t_matrix, &
    rh_matrix,Ze_non,Ze_ray,h_atten_to_vol,g_atten_to_vol,dBZe, &
    g_to_vol_in,g_to_vol_out)

!     rh_matrix,Ze_non,Ze_ray,kr_matrix,g_atten_to_vol,dBZe)
 
  use m_mrgrnk 
  use array_lib
  use math_lib
  use optics_lib
  use radar_simulator_types
  implicit none
  
! Purpose:
!   Simulates a vertical profile of radar reflectivity
!   Part of QuickBeam v1.04 by John Haynes & Roger Marchand
!
! Inputs:
!   [freq]            radar frequency (GHz), can be anything unless
!                     use_mie_table=1, in which case one of 94,35,13.8,9.6,3
!   [k2]              |K|^2, the dielectric constant, set to -1 to use the
!                     frequency dependent default
!   [do_ray]          1=do Rayleigh calcs, 0=not
!   [use_gas_abs]     1=do gaseous abs calcs, 0=not,
!                     2=use same as first profile (undocumented)
!   [use_mie_table]   1=use Mie tables, 0=not
!   [mt]              Mie look up table
!   [nhclass]         number of hydrometeor types
!   [hp]              structure that defines hydrometeor types
!   [nprof]           number of hydrometeor profiles
!   [ngate]           number of vertical layers
!   [nsizes]          number of discrete particles in [D]
!   [D]               array of discrete particles (um)
!
!   (The following 5 arrays must be in order from closest to the radar
!    to farthest...)
!   [hgt_matrix]      height of hydrometeors (km)
!   [hm_matrix]       table of hydrometeor mixing rations (g/kg)
!   [re_matrix]       OPTIONAL table of hydrometeor effective radii (microns)
!   [p_matrix]        pressure profile (hPa)
!   [t_matrix]        temperature profile (C)
!   [rh_matrix]       relative humidity profile (%)
!
! Outputs:
!   [Ze_non]          radar reflectivity without attenuation (dBZ)
!   [Ze_ray]          Rayleigh reflectivity (dBZ)
!   [h_atten_to_vol]  attenuation by hydromets, radar to vol (dB)
!   [g_atten_to_vol]  gaseous atteunation, radar to vol (dB)
!   [dBZe]            effective radar reflectivity factor (dBZ)
!
! Optional:
!   [g_to_vol_in]     integrated atten due to gases, r>v (dB).
!                     If present then is used as gaseous absorption, independently of the
!                     value in use_gas_abs
!   [g_to_vol_out]    integrated atten due to gases, r>v (dB).
!                     If present then gaseous absorption for each profile is returned here.
!
! Created:
!   11/28/2005  John Haynes (haynes@atmos.colostate.edu)
! Modified:
!   09/2006  placed into subroutine form, scaling factors (Roger Marchand,JMH)
!   08/2007  added equivalent volume spheres, Z and N scalling most distrubtion types (Roger Marchand)
!   01/2008  'Do while' to determine if hydrometeor(s) present in volume
!             changed for vectorization purposes (A. Bodas-Salcedo)

! ----- INPUTS -----  
  type(mie), intent(in) :: mt
  type(class_param), intent(inout) :: hp
#ifdef COSP_GFDL
  real*8, intent(in)    :: freq
  real*8, intent(inout) :: k2
#else
  real*8, intent(in) :: freq,k2
#endif
  integer, intent(in) ::  do_ray,use_gas_abs,use_mie_table, &
    nhclass,nprof,ngate,nsizes
  real*8, dimension(nsizes), intent(in) :: D
  real*8, dimension(nprof,ngate), intent(in) :: hgt_matrix, p_matrix, &
    t_matrix,rh_matrix
  real*8, dimension(nhclass,nprof,ngate), intent(in) :: hm_matrix
  real*8, dimension(nhclass,nprof,ngate), intent(inout) :: re_matrix
    
! ----- OUTPUTS -----
  real*8, dimension(nprof,ngate), intent(out) :: Ze_non,Ze_ray, &
     g_atten_to_vol,dBZe,h_atten_to_vol

! ----- OPTIONAL -----
  real*8, optional, dimension(ngate,nprof) :: &
  g_to_vol_in,g_to_vol_out ! integrated atten due to gases, r>v (dB). This allows to output and then input
                           ! the same gaseous absorption in different calls. Optional to allow compatibility
                           ! with original version. A. Bodas April 2008.
        
!  real*8, dimension(nprof,ngate) :: kr_matrix 

! ----- INTERNAL -----
  integer :: &
  phase, &               ! 0=liquid, 1=ice
  ns                     ! number of discrete drop sizes

  integer*4, dimension(ngate) :: &
  hydro                  ! 1=hydrometeor in vol, 0=none
  real*8 :: &
  rho_a, &               ! air density (kg m^-3)
  gases                  ! function: 2-way gas atten (dB/km)

  real*8, dimension(:), allocatable :: &
  Di, Deq, &             ! discrete drop sizes (um)
  Ni, Ntemp, &           ! discrete concentrations (cm^-3 um^-1)
  rhoi, &                ! discrete densities (kg m^-3)
  xx_rhoi                ! to expand parameter xx to array parameter
  
  real*8, dimension(ngate) :: &
  z_vol, &               ! effective reflectivity factor (mm^6/m^3)
  z_ray, &                      ! reflectivity factor, Rayleigh only (mm^6/m^3)
  kr_vol, &              ! attenuation coefficient hydro (dB/km)
  g_vol, &               ! attenuation coefficient gases (dB/km)
  a_to_vol, &            ! integrated atten due to hydometeors, r>v (dB)
  g_to_vol               ! integrated atten due to gases, r>v (dB)
   
 
  integer,parameter :: KR8 = selected_real_kind(15,300)
  real*8, parameter :: xx = -1.0_KR8
  real*8,  dimension(:), allocatable :: xxa
  real*8 :: kr, ze, zr, pi, scale_factor, Re, ld, tmp1, apm,bpm
  integer*4 :: tp, i, j, k, pr, itt, iff

  real*8 bin_length,step,base,step_list(25),base_list(25)
  integer*4 iRe_type,n,max_bin
  
  logical :: g_to_vol_in_present, g_to_vol_out_present
     
  ! Logicals to avoid calling present within the loops
  g_to_vol_in_present  = present(g_to_vol_in)
  g_to_vol_out_present = present(g_to_vol_out)
  
    ! set up Re bins for z_scalling
     bin_length=50;
     max_bin=25

     step_list(1)=1
     base_list(1)=75 
     do j=2,max_bin
          step_list(j)=3*(j-1);
          if(step_list(j)>bin_length) then
               step_list(j)=bin_length;
          endif
          base_list(j)=base_list(j-1)+floor(bin_length/step_list(j-1));
     enddo


  pi = acos(-1.0)
  if (use_mie_table == 1) iff = infind(mt%freq,freq,sort=1)

     
  ! // loop over each profile (nprof)
  do pr=1,nprof
!   ----- calculations for each volume ----- 
    z_vol(:) = 0
    z_ray(:) = 0
    kr_vol(:) = 0
    hydro(:) = 0    

!   // loop over eacho range gate (ngate)
    do k=1,ngate
  
!     :: determine if hydrometeor(s) present in volume
      hydro(k) = 0
      do j=1,nhclass ! Do while changed for vectorization purposes (A. B-S)
        if ((hm_matrix(j,pr,k) > 1E-12) .and. (hp%dtype(j) > 0)) then
          hydro(k) = 1
          exit
        endif
      enddo

      if (hydro(k) == 1) then
!     :: if there is hydrometeor in the volume            

        rho_a = (p_matrix(pr,k)*100.)/(287*(t_matrix(pr,k)+273.15))

!       :: loop over hydrometeor type
        do tp=1,nhclass

          if (hm_matrix(tp,pr,k) <= 1E-12) cycle

       phase = hp%phase(tp)
       if(phase==0) then
          itt = infind(mt_ttl,t_matrix(pr,k))
       else
          itt = infind(mt_tti,t_matrix(pr,k))
      endif

       ! calculate Re if we have an exponential distribution with fixed No ... precipitation type particle
       if( hp%dtype(tp)==2 .and. abs(hp%p2(tp)+1) < 1E-8)  then

          apm=hp%apm(tp)
          bpm=hp%bpm(tp)

          if ((hp%rho(tp) > 0) .and. (apm < 0)) then
               apm = (pi/6)*hp%rho(tp)
               bpm = 3.
          endif

          tmp1 = 1./(1.+bpm)
          ld = ((apm*gamma(1.+bpm)*hp%p1(tp))/(rho_a*hm_matrix(tp,pr,k)*1E-3))**tmp1
          
          Re = 1.5E6/ld 
          
          re_matrix(tp,pr,k) = Re;

       endif
  
       if(re_matrix(tp,pr,k).eq.0) then

          iRe_type=1
          Re=0
       else
          iRe_type=1
          Re=re_matrix(tp,pr,k)
          
          n=floor(Re/bin_length)
          if(n==0) then
               if(Re<25) then
                    step=0.5
                    base=0
               else           
                    step=1
                    base=25
               endif
          else
               if(n>max_bin) then
                    n=max_bin 
               endif

               step=step_list(n)
               base=base_list(n)
          endif

          iRe_type=floor(Re/step)

          if(iRe_type.lt.1) then  
               iRe_type=1               
          endif

          Re=step*(iRe_type+0.5)
          iRe_type=iRe_type+base-floor(n*bin_length/step)

          ! make sure iRe_type is within bounds
          if(iRe_type.ge.nRe_types) then  

               ! print *, tp, re_matrix(tp,pr,k), Re, iRe_type

               ! no scaling allowed
               Re=re_matrix(tp,pr,k)

               iRe_type=nRe_types
               hp%z_flag(tp,itt,iRe_type)=.false.
               hp%scaled(tp,iRe_type)=.false.               
          endif
       endif
     
       ! use Ze_scaled, Zr_scaled, and kr_scaled ... if know them
       ! if not we will calculate Ze, Zr, and Kr from the distribution parameters
#ifdef COSP_GFDL
!RSH:
!  In order to get reproducibility across physics windows, the "else" branch
!   of the following if block must be removed. However doing so increases 
!   total model time by over a factor of 2. Therefore I have left the loop
!   in place for now, pending a response to this issue from the COSP 
!   developers. Instead, to avoid generating incorrect diagnostics, the 
!   following diagnostics must be removed from the diag_table:
!    "cloudsatcfad_x", where x=1,15
!    "cloudsatcfad_mdl_x", where x=1,15
!    "cloudsatcfad_sat_x", where x=1,15
!    "clcalipso2_sat"
!    "clcalipso2_mdl"
!    "clcalipso2"
! 
!   If these diagnostics are required, they may be correctly obtained 
!   (at great cost) by removing the else block (see !RSH section below) and
!   always executing the first part of this if loop.
#endif
       if( .not. hp%z_flag(tp,itt,iRe_type) )  then
      
!         :: create a distribution of hydrometeors within volume   
       select case(hp%dtype(tp))
          case(4)
         ns = 1
         allocate(Di(ns),Ni(ns),rhoi(ns),xx_rhoi(ns),xxa(ns),Deq(ns))
         if (use_mie_table == 1) allocate(mt_qext(ns),mt_qbsca(ns),Ntemp(ns))
         Di = hp%p1(tp)
         Ni = 0.
       case default
         ns = nsizes            
         allocate(Di(ns),Ni(ns),rhoi(ns),xx_rhoi(ns),xxa(ns),Deq(ns))
         if (use_mie_table == 1) allocate(mt_qext(ns),mt_qbsca(ns),Ntemp(ns))       
         Di = D
         Ni = 0.
       end select
       xx_rhoi = xx

!         :: create a DSD (using scaling factor if applicable)
!        hp%scaled(tp,iRe_type)=.false.   ! turn off N scaling

       call dsd(hm_matrix(tp,pr,k),Re,Di,Ni,ns,hp%dtype(tp),rho_a, &
         t_matrix(pr,k),hp%dmin(tp),hp%dmax(tp),hp%apm(tp),hp%bpm(tp), &
         hp%rho(tp),hp%p1(tp),hp%p2(tp),hp%p3(tp),hp%fc(tp,1:ns,iRe_type), &
         hp%scaled(tp,iRe_type))

!         :: calculate particle density 
          ! if ((hp%rho_eff(tp,1,iRe_type) < 0) .and. (phase == 1)) then
       if (phase == 1) then
         if (hp%rho(tp) < 0) then
                
          ! MG Mie approach - adjust density of sphere with D = D_characteristic to match particle density         
          ! hp%rho_eff(tp,1:ns,iRe_type) = (6/pi)*hp%apm(tp)*(Di*1E-6)**(hp%bpm(tp)-3)   !MG Mie approach
          
          ! as the particle size gets small it is possible that the mass to size relationship of 
          ! (given by power law in hclass.data) can produce impossible results 
          ! where the mass is larger than a solid sphere of ice.  
          ! This loop ensures that no ice particle can have more mass/density larger than an ice sphere.
          ! do i=1,ns
          ! if(hp%rho_eff(tp,i,iRe_type) > 917 ) then
          !    hp%rho_eff(tp,i,iRe_type) = 917
          !endif
          !enddo

          ! alternative is to use equivalent volume spheres.
          hp%rho_eff(tp,1:ns,iRe_type) = 917                     ! solid ice == equivalent volume approach
               Deq = ( ( 6/pi*hp%apm(tp)/917 ) ** (1.0/3.0) ) * &
                  ( (Di*1E-6) ** (hp%bpm(tp)/3.0) )  * 1E6       ! Di now really Deq in microns.
          
            else

               ! hp%rho_eff(tp,1:ns,iRe_type) = hp%rho(tp)   !MG Mie approach
               
          ! Equivalent volume sphere (solid ice rho_ice=917 kg/m^3).
               hp%rho_eff(tp,1:ns,iRe_type) = 917
               Deq=Di * ((hp%rho(tp)/917)**(1.0/3.0))  

         endif

          ! if using equivalent volume spheres
          if (use_mie_table == 1) then

               Ntemp=Ni

               ! Find N(Di) from N(Deq) which we know
               do i=1,ns
                              j=infind(Deq,Di(i))
                    Ni(i)=Ntemp(j)
               enddo
          else
               ! just use Deq and D variable input to mie code
               Di=Deq;
          endif

       endif
       rhoi = hp%rho_eff(tp,1:ns,iRe_type)
       
!         :: calculate effective reflectivity factor of volume
       if (use_mie_table == 1) then
       
#ifndef COSP_GFDL
         if ((hp%dtype(tp) == 4) .and. (hp%idd(tp) < 0)) then
              hp%idd(tp) = infind(mt%D,Di(1))
         endif
         
         if (phase == 0) then
         
           ! itt = infind(mt_ttl,t_matrix(pr,k))
              select case(hp%dtype(tp))
           case(4)
          mt_qext(1) = mt%qext(hp%idd(tp),itt,1,iff)
             mt_qbsca(1) = mt%qbsca(hp%idd(tp),itt,1,iff)
              case default
             mt_qext = mt%qext(:,itt,1,iff)
             mt_qbsca = mt%qbsca(:,itt,1,iff)
           end select

          call zeff(freq,Di,Ni,ns,k2,mt_ttl(itt),0,do_ray, &
             ze,zr,kr,mt_qext,mt_qbsca,xx_rhoi)
         
         else

           ! itt = infind(mt_tti,t_matrix(pr,k))
           select case(hp%dtype(tp))
           case(4)
                if (hp%ifc(tp,1,iRe_type) < 0) then
                  hp%ifc(tp,1,iRe_type) = infind(mt%f,rhoi(1)/917.)
             endif             
                mt_qext(1) = &
            mt%qext(hp%idd(tp),itt+cnt_liq,hp%ifc(tp,1,iRe_type),iff)
             mt_qbsca(1) = &
            mt%qbsca(hp%idd(tp),itt+cnt_liq,hp%ifc(tp,1,iRe_type),iff)           
           case default
             do i=1,ns
               if (hp%ifc(tp,i,iRe_type) < 0) then
                    hp%ifc(tp,i,iRe_type) = infind(mt%f,rhoi(i)/917.)
               endif           
                    mt_qext(i) = mt%qext(i,itt+cnt_liq,hp%ifc(tp,i,iRe_type),iff)
            mt_qbsca(i) = mt%qbsca(i,itt+cnt_liq,hp%ifc(tp,i,iRe_type),iff)
             enddo
           end select

             call zeff(freq,Di,Ni,ns,k2,mt_tti(itt),1,do_ray, &
             ze,zr,kr,mt_qext,mt_qbsca,xx_rhoi)

         endif
#endif

       else
       
         xxa = -9.9
         call zeff(freq,Di,Ni,ns,k2,t_matrix(pr,k),phase,do_ray, &
           ze,zr,kr,xxa,xxa,rhoi)

           
       endif  ! end of use mie table 

          ! xxa = -9.9
          !call zeff(freq,Di,Ni,ns,k2,t_matrix(pr,k),phase,do_ray, &
               !    ze2,zr,kr2,xxa,xxa,rhoi)

          ! if(abs(ze2-ze)/ze2 > 0.1) then
          ! if(abs(kr2-kr)/kr2 > 0.1) then
          
          ! write(*,*) pr,k,tp,ze2,ze2-ze,abs(ze2-ze)/ze2,itt+cnt_liq,iff
          ! write(*,*) pr,k,tp,ze2,kr2,kr2-kr,abs(kr2-kr)/kr2
          ! stop

          !endif

       deallocate(Di,Ni,rhoi, xx_rhoi,xxa,Deq)
       if (use_mie_table == 1) deallocate(mt_qext,mt_qbsca,Ntemp)

#ifdef COSP_GFDL
!RSH
!  the following lines need be removed for reproducible execution.
!with these lines retained the diagnostics listed above will not reproduce
!across physics_windows.
#endif
       else ! can use z scaling
       
          if( hp%dtype(tp)==2 .and. abs(hp%p2(tp)+1) < 1E-8 )  then
           
               ze = hp%Ze_scaled(tp,itt,iRe_type)
               zr = hp%Zr_scaled(tp,itt,iRe_type)
               kr = hp%kr_scaled(tp,itt,iRe_type)

          else
               scale_factor=rho_a*hm_matrix(tp,pr,k) 

               zr = hp%Zr_scaled(tp,itt,iRe_type) * scale_factor 
               ze = hp%Ze_scaled(tp,itt,iRe_type) * scale_factor
               kr = hp%kr_scaled(tp,itt,iRe_type) * scale_factor 
          endif

       endif  ! end z_scaling
#ifdef COSP_GFDL
!RSH  end of lines to remove
#endif
 
       ! kr=0 

       kr_vol(k) = kr_vol(k) + kr
       z_vol(k) = z_vol(k) + ze
       z_ray(k) = z_ray(k) + zr
     
       ! construct Ze_scaled, Zr_scaled, and kr_scaled ... if we can
       if( .not. hp%z_flag(tp,itt,iRe_type) .and. 1.eq.1 ) then

          if( ( (hp%dtype(tp)==1 .or. hp%dtype(tp)==5 .or.  hp%dtype(tp)==2)  .and. abs(hp%p1(tp)+1) < 1E-8  ) .or. &
              (  hp%dtype(tp)==3 .or. hp%dtype(tp)==4 )  &
          ) then

               scale_factor=rho_a*hm_matrix(tp,pr,k) 

               hp%Ze_scaled(tp,itt,iRe_type) = ze/ scale_factor
               hp%Zr_scaled(tp,itt,iRe_type) = zr/ scale_factor
               hp%kr_scaled(tp,itt,iRe_type) = kr/ scale_factor

               hp%z_flag(tp,itt,iRe_type)=.True.

          elseif( hp%dtype(tp)==2 .and. abs(hp%p2(tp)+1) < 1E-8 ) then 
           
               hp%Ze_scaled(tp,itt,iRe_type) = ze
               hp%Zr_scaled(tp,itt,iRe_type) = zr
               hp%kr_scaled(tp,itt,iRe_type) = kr

               hp%z_flag(tp,itt,iRe_type)=.True.
          endif

       endif

        enddo  ! end loop of tp (hydrometeor type)

      else
!     :: volume is hydrometeor-free
     
        kr_vol(k) = 0
     z_vol(k) = -999
        z_ray(k) = -999
     
      endif

!     :: attenuation due to hydrometeors between radar and volume
      a_to_vol(k) = 2*path_integral(kr_vol,hgt_matrix(pr,:),1,k-1)
      
!     :: attenuation due to gaseous absorption between radar and volume
      if (g_to_vol_in_present) then
        g_to_vol(k) = g_to_vol_in(k,pr)
      else
        if ( (use_gas_abs == 1) .or. ((use_gas_abs == 2) .and. (pr == 1)) )  then
            g_vol(k) = gases(p_matrix(pr,k),t_matrix(pr,k)+273.15, &
            rh_matrix(pr,k),freq)
            g_to_vol(k) = path_integral(g_vol,hgt_matrix(pr,:),1,k-1)
        elseif (use_gas_abs == 0) then
            g_to_vol(k) = 0
        endif  
      endif
    
!      kr_matrix(pr,:)=kr_vol

!     :: store results in matrix for return to calling program
      h_atten_to_vol(pr,k)=a_to_vol(k)
      g_atten_to_vol(pr,k)=g_to_vol(k)
      if ((do_ray == 1) .and. (z_ray(k) > 0)) then
        Ze_ray(pr,k) = 10*log10(z_ray(k))
      else
        Ze_ray(pr,k) = -999
      endif
      if (z_vol(k) > 0) then
        dBZe(pr,k) = 10*log10(z_vol(k))-a_to_vol(k)-g_to_vol(k)
        Ze_non(pr,k) = 10*log10(z_vol(k))
      else
        dBZe(pr,k) = -999
        Ze_non(pr,k) = -999
      endif
      
    enddo ! end loop of k (range gate)
    ! Output array with gaseous absorption
    if (g_to_vol_out_present) g_to_vol_out(:,pr) = g_to_vol
  enddo        ! end loop over pr (profile)  

  end subroutine radar_simulator
  

! ============================================================================
! vegetation disturbances
! ============================================================================
module vegn_disturbance_mod

use land_constants_mod, only : seconds_per_year
use vegn_data_mod,   only : spdata, fsc_wood, fsc_liv, agf_bs, LEAF_OFF
use vegn_tile_mod,   only : vegn_tile_type
use soil_tile_mod,   only : soil_tile_type
use vegn_cohort_mod, only : vegn_cohort_type, height_from_biomass, lai_from_biomass, &
     update_biomass_pools

implicit none
private

! ==== public interfaces =====================================================
public :: vegn_nat_mortality
public :: vegn_disturbance
public :: update_fuel
! =====end of public interfaces ==============================================

! ==== module constants ======================================================
character(len=*), parameter :: &
     version = '$Id: vegn_disturbance.F90,v 20.0 2013/12/13 23:31:08 fms Exp $', &
     tagname = '$Name: tikal $', &
     module_name = 'vegn_disturbance_mod'

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

subroutine vegn_disturbance(vegn, soil, dt)
  type(vegn_tile_type), intent(inout) :: vegn ! vegetation data
  type(soil_tile_type), intent(inout) :: soil ! soil data
  real, intent(in) :: dt ! time since last disturbance calculations, s
  

  real, parameter :: BMIN = 1e-10; ! should be the same as in growth function
  ! ---- local vars
  type(vegn_cohort_type), pointer :: cc    ! current cohort
  real :: precip;
  real :: delta;
  real :: fraction_lost;
  real :: drought_month;
  real :: deltat
  integer :: i
  integer :: sp ! shorhand for cohort species

  deltat = dt/seconds_per_year ! convert time interval to years

  !  Disturbance Rates
  precip=vegn%p_ann*86400*365; 
  drought_month = vegn%lambda;
  vegn%disturbance_rate(0) = 0.0;
  vegn%disturbance_rate(1) = 0.0;
  
  call calculate_patch_disturbance_rates(vegn)
   
  ! Fire disturbance implicitly, i.e.  not patch creating
  vegn%area_disturbed_by_fire = (1.0-exp(-vegn%disturbance_rate(1)*deltat));
  
  do i = 1,vegn%n_cohorts   
     cc => vegn%cohorts(i)
     sp = cc%species

     fraction_lost = 1.0-exp(-vegn%disturbance_rate(1)*deltat);	
      
     ! "dead" biomass : wood + sapwood
     delta = (cc%bwood+cc%bsw)*fraction_lost;
      
     soil%slow_soil_C(1) = soil%slow_soil_C(1) + (1.0-spdata(sp)%smoke_fraction)*delta*(1-fsc_wood);
     soil%fast_soil_C(1) = soil%fast_soil_C(1) + (1.0-spdata(sp)%smoke_fraction)*delta*   fsc_wood;
     cc%bwood = cc%bwood * (1-fraction_lost);
     cc%bsw   = cc%bsw   * (1-fraction_lost);
      
     vegn%csmoke_pool = vegn%csmoke_pool + spdata(sp)%smoke_fraction*delta;
      
     ! for budget tracking - temporarily not keeping wood and the rest separately,ens
     !      soil%ssc_in(1)+=delta*(1.0-spdata(sp)%smoke_fraction)*(1-fsc_wood); */
     !      soil%fsc_in(1)+=delta*(1.0-spdata(sp)%smoke_fraction)*fsc_wood; */
      
     soil%ssc_in(1) = soil%ssc_in(1)+(cc%bwood+cc%bsw)*fraction_lost *(1.0-spdata(sp)%smoke_fraction);
     !     soil%fsc_in(1)+=cc%bsw*fraction_lost *(1.0-spdata(sp)%smoke_fraction);
     vegn%veg_out = vegn%veg_out+delta;
      
     !"alive" biomass: leaves, roots, and virtual pool
     delta = (cc%bl+cc%blv+cc%br)*fraction_lost;
     soil%fast_soil_C(1) = soil%fast_soil_C(1) + (1.0-spdata(sp)%smoke_fraction)*delta*    fsc_liv ;
     soil%slow_soil_C(1) = soil%slow_soil_C(1) + (1.0-spdata(sp)%smoke_fraction)*delta*(1- fsc_liv);
      
     cc%bl  = cc%bl  * (1-fraction_lost);
     cc%blv = cc%blv * (1-fraction_lost);
     cc%br  = cc%br  * (1-fraction_lost);
      
     vegn%csmoke_pool = vegn%csmoke_pool + spdata(sp)%smoke_fraction*delta;
      
     ! for budget tracking- temporarily keeping alive separate ens
     ! /*      soil%fsc_in(1)+=delta* fsc_liv; */
     ! /*      soil%ssc_in(1)+=delta* (1-fsc_liv); */
     soil%fsc_in(1) = soil%fsc_in(1)+delta*(1.0-spdata(sp)%smoke_fraction);
     vegn%veg_out = vegn%veg_out+delta;
      
     !"living" biomass:leaves, roots and sapwood
     delta = cc%bliving*fraction_lost;
     cc%bliving = cc%bliving - delta;

     if(cc%bliving < BMIN) then
        ! remove vegetaion competely 	      
        soil%fast_soil_C(1) = soil%fast_soil_C(1) + fsc_liv*cc%bliving+ fsc_wood*cc%bwood;
        soil%slow_soil_C(1) = soil%slow_soil_C(1) + (1.- fsc_liv)*cc%bliving+ (1-fsc_wood)*cc%bwood;
        
        soil%fsc_in(1) = soil%fsc_in(1) + cc%bwood+cc%bliving;
        vegn%veg_out = vegn%veg_out + cc%bwood+cc%bliving;
        
        cc%bliving = 0.;
        cc%bwood   = 0.;
     endif
     call update_biomass_pools(cc)
  enddo

  vegn%csmoke_rate = vegn%csmoke_pool; ! kg C/(m2 yr)
end subroutine vegn_disturbance

! ============================================================================
subroutine calculate_patch_disturbance_rates(vegn)
  type(vegn_tile_type), intent(inout) :: vegn

  ! ---- local vars
  real :: fire_prob;
  real :: fuel;

  fuel = vegn%fuel

#if SIMPLE_FIRE
  ! CALCULATE FIRE DISTURBANCE RATES
  vegn%disturbance_rate(1)=fire(vegn);
#else

  ! lambda is the number of drought months;
  fire_prob = vegn%lambda/(1.+vegn%lambda); 
  ! compute average fuel during fire months
  if (vegn%lambda > 0.00001 ) fuel = fuel/vegn%lambda;
  vegn%disturbance_rate(1) = fuel * fire_prob;

  ! put a threshold for very dry years for warm places
  if (vegn%t_ann > 273.16 .and. vegn%lambda > 3.)  vegn%disturbance_rate(1)=0.33;
#endif  
  
  if(vegn%disturbance_rate(1) > 0.33) vegn%disturbance_rate(1)=0.33;
  
  ! this is only true for the one cohort per patch case
  vegn%disturbance_rate(0) = spdata(vegn%cohorts(1)%species)%treefall_disturbance_rate;
  vegn%total_disturbance_rate = vegn%disturbance_rate(1)+vegn%disturbance_rate(0);
  
  vegn%fuel = fuel;
end subroutine calculate_patch_disturbance_rates


! ============================================================================
function fire(vegn) result(fireterm)
  real :: fireterm; ! return value
  type(vegn_tile_type), intent(inout) :: vegn

  ! ---- local vars
  real :: precip_av ! average precipitation, mm/year

  fireterm = 0
  precip_av = vegn%p_ann * seconds_per_year;
!!$  vegn%ignition_rate = 0.00;             
  vegn%fuel = vegn%total_biomass;

  if(vegn%fuel>0.0) then
     if(precip_av < 400.+40.*(vegn%t_ann-273.16)) then
        fireterm = vegn%fuel*(400. + 40.*(vegn%t_ann-273.16) - precip_av);
     endif
  endif
end function


! ============================================================================
subroutine update_fuel(vegn, wilt)
  type(vegn_tile_type), intent(inout) :: vegn
  real, intent(in) :: wilt ! ratio of wilting to saturated water content

  ! ---- local constants
  !  these three used to be in data 
  real, parameter :: fire_height_threashold = 100;
  real, parameter :: fp1 = 1.; ! disturbance rate per kgC/m2 of fuel
  ! ---- local vars
  type(vegn_cohort_type), pointer :: cc    ! current cohort
  real :: theta_crit; ! critical ratio of average soil water to sat. water
  real :: ignition_rate;
  real ::  babove;
  integer :: i

  do i = 1,vegn%n_cohorts   
     cc => vegn%cohorts(i)
     ! calculate theta_crit: actually either fact_crit_fire or cnst_crit_fire 
     ! is zero, enforced by logic in the vegn_data.F90
     theta_crit = spdata(cc%species)%cnst_crit_fire &
           + wilt*spdata(cc%species)%fact_crit_fire
     theta_crit = max(0.0,min(1.0, theta_crit))
     if((cc%height < fire_height_threashold) &
          .and.(vegn%theta_av_fire < theta_crit)  &
          .and.(vegn%tsoil_av > 278.16)) then
        babove = cc%bl + agf_bs * (cc%bsw + cc%bwood + cc%blv);
        ! this is fuel available durng the drought months only
        vegn%fuel = vegn%fuel + spdata(cc%species)%fuel_intensity*babove;	
     endif
  enddo

  ! note that the ignition rate calculation based on the value of theta_crit for 
  ! the last cohort -- currently it doesn't matter since we have just one cohort, 
  ! but something needs to be done about that in the future
  ignition_rate = 0.;
  if ( (vegn%theta_av_fire < theta_crit) &
       .and. (vegn%tsoil_av>278.16)) ignition_rate = 1.;
  vegn%lambda = vegn%lambda + ignition_rate;

end subroutine update_fuel




! ============================================================================
subroutine vegn_nat_mortality(vegn, soil, deltat)
  type(vegn_tile_type), intent(inout) :: vegn  ! vegetation data
  type(soil_tile_type), intent(inout) :: soil  ! soil data
  real, intent(in) :: deltat ! time since last mortality calculations, s
  
  ! ---- local vars
  type(vegn_cohort_type), pointer :: cc    ! current cohort
  real :: delta;
  real :: fraction_lost;
  real :: bdead, balive; ! combined biomass pools
  integer :: i
  
  vegn%disturbance_rate(0)        = 0.0; 
  vegn%area_disturbed_by_treefall = 0.0;
  
  do i = 1,vegn%n_cohorts
     cc => vegn%cohorts(i)
     ! Treat treefall disturbance implicitly, i.e. not creating a new tile.
     ! note that this disturbance rate calculation only works for the one cohort per 
     ! tile case -- in case of multiple cohort disturbance rate perhaps needs to be 
     ! accumulated (or averaged? or something else?) over the cohorts.
     vegn%disturbance_rate(0) = spdata(cc%species)%treefall_disturbance_rate;
     vegn%area_disturbed_by_treefall = &
          1.0-exp(-vegn%disturbance_rate(0)*deltat/seconds_per_year);

     ! calculate combined biomass pools
     balive = cc%bl + cc%blv + cc%br;
     bdead  = cc%bsw + cc%bwood;
     ! ens need a daily PATCH_FREQ here, for now it is set to 48
     fraction_lost = 1.0-exp(-vegn%disturbance_rate(0)*deltat/seconds_per_year);     
      
     ! "dead" biomass : wood + sapwood
     delta = bdead*fraction_lost;

     soil%slow_soil_C(1) = soil%slow_soil_C(1) + (1-fsc_wood)*delta;
     soil%fast_soil_C(1) = soil%fast_soil_C(1) +    fsc_wood *delta;

     cc%bwood = cc%bwood * (1-fraction_lost);
     cc%bsw   = cc%bsw   * (1-fraction_lost);

     ! for budget tracking -temporarily
     ! It doesn't look correct to me: ssc_in should probably include factor 
     ! (1-fsc_wood) and the whole calculations should be moved up in front
     ! of bwood and bsw modification
     ! soil%fsc_in(1)+= cc%bsw*fraction_lost;
     soil%ssc_in(1)  = soil%ssc_in(1)  + (cc%bwood+cc%bsw)*fraction_lost;
     vegn%veg_out = vegn%veg_out + delta;
     
     ! kill the live biomass if mortality is set to affect it
     if (spdata(cc%species)%mortality_kills_balive) then
        delta = (cc%bl + cc%blv + cc%br)*fraction_lost
        
        soil%slow_soil_C(1) = soil%slow_soil_C(1) + (1-fsc_liv)*delta;
        soil%fast_soil_C(1) = soil%fast_soil_C(1) +    fsc_liv *delta;
        
        cc%br  = cc%br  * (1-fraction_lost);
        cc%bl  = cc%bl  * (1-fraction_lost);
        cc%blv = cc%blv * (1-fraction_lost);

        ! for budget tracking
        soil%ssc_in(1)  = soil%ssc_in(1)  + (cc%bwood+cc%bsw)*fraction_lost;
        vegn%veg_out = vegn%veg_out + delta;
     endif

     cc%bliving = cc%bsw + cc%bl + cc%br + cc%blv;
     call update_biomass_pools(cc);
  enddo
     
end subroutine vegn_nat_mortality


end module vegn_disturbance_mod

module soil_mod

! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Christopher Milly
! </CONTACT> 
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Elena Shevliakova
! </REVIEWER>

! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Sergey Malyshev
! </REVIEWER>

! <OVERVIEW>
!   Module containing processes relating to the soil.
! </OVERVIEW>

! <DESCRIPTION>
!   Soil data type is defined and describes the characteristics of the soil.
!   The soil module and the state of soil is initialized. The soil data is
!   updated on the fast and slow time-scale. Contains updates to the "fast"
!   boundary data that the atmosphere sees and the "slow" part of boundary
!   data for the atmosphere. Sends tile-averaged data to the diagnostics
!   manager.
! </DESCRIPTION>

use time_manager_mod,    only: time_type, get_time, get_date, increment_time
use mpp_domains_mod,     only: domain2d, mpp_get_compute_domain
use fms_mod,             only: file_exist,  close_file, read_data,   &
                               error_mesg, FATAL, NOTE, set_domain, mpp_pe,    &
                               check_nml_error, write_version_number,          &
                               open_namelist_file, open_restart_file,          &
                               write_data, stdlog, mpp_root_pe

use fms_io_mod,          only: get_restart_io_mode

use rivers_mod,          only: rivers_type, rivers_init, update_rivers_fast,   &
                               rivers_end, update_rivers_slow,                 &
                               update_rivers_bnd_slow
use land_types_mod,      only: land_data_type

use land_properties_mod, only: land_properties_init,                          &
                               update_land_properties_fast,                   &
                               update_land_properties_slow
use constants_mod,       only: hlf, hlv, tfreeze

use diag_manager_mod,    only: diag_axis_init, register_diag_field, send_data, &
                               register_static_field

use data_override_mod,   only: data_override

#ifdef SCM
use scm_forc_mod,        only: do_specified_tskin, do_specified_land, TSKIN
#endif

use stock_constants_mod, only: ISTOCK_WATER, ISTOCK_HEAT


implicit none
private


! ==== public interfaces =====================================================
public soil_type            ! soil data type
public soil_init            ! initialize the soil module, and the state of soil
public soil_end             ! finish soil calculations

public update_soil_fast     ! fast time-scale soil update
public update_soil_slow     ! slow time-scale soil update
public update_soil_bnd_fast ! updates "fast" boundary data that atmosphere sees
public update_soil_bnd_slow ! updates "slow" part of boundary data for atmosphere

public send_averaged_data   ! sends tile-averaged data to diagnostics manager
public soil_stock_pe        ! calculate and return total amount of requested quantitiy per PE

! ==== end of public interface ===============================================

! <TYPE NAME="soil_type">

!   <DESCRIPTION>
!     Public data type describing soil characteristics.
!   </DESCRIPTION>

type soil_type
!   private                ! opaque type slm, Mar 19 2002: made it public

!   <DATA NAME="domain" TYPE="domain2d" DIM="2">
!     Domain of computation
!   </DATA>
   type(domain2d)::domain ! our domain of computation

   ! geometry of the grid

!   <DATA NAME="is" TYPE="integer">
!     Computational domain bounds
!   </DATA>
!   <DATA NAME="ie" TYPE="integer">
!     Computational domain bounds
!   </DATA>
!   <DATA NAME="js" TYPE="integer">
!     Computational domain bounds
!   </DATA>
!   <DATA NAME="je" TYPE="integer">
!     Computational domain bounds
!   </DATA>
!   <DATA NAME="n_levels" TYPE="integer">
!     Number of levels in the soil
!   </DATA>
!   <DATA NAME="n_tiles" TYPE="integer">
!     Maximum number of tiles in the soil
!   </DATA>
   integer is,ie,js,je;   ! computational domain bounds
   integer n_levels       ! number of levels in the soil
   integer n_tiles        ! max number of tiles in the soil

!   <DATA NAME="area" UNITS="m2" TYPE="real, pointer" DIM="2">
!     Land area for each cell
!   </DATA>
!   <DATA NAME="frac" TYPE="real, pointer" DIM="3">
!     Tile area fraction for each tile
!   </DATA>
!   <DATA NAME="mask" TYPE="logical, pointer" DIM="3">
!     Land mask: true where data are present 
!   </DATA>
!   <DATA NAME="dz" UNITS="m" TYPE="real, pointer" DIM="1">
!     Thickness of layers
!   </DATA>
!   <DATA NAME="z" UNITS="m" TYPE="real, pointer" DIM="1">
!     Full level
!   </DATA>
!   <DATA NAME="zz" UNITS="m" TYPE="real, pointer" DIM="1">
!     Half level
!   </DATA>
!   <DATA NAME="max_fusion" UNITS="J/m3" TYPE="real, pointer" DIM="1">
!     Max amount of energy stored in frozen water, J/m3
!   </DATA>
   real,    pointer :: area(:,:) =>NULL()    ! land area for each cell
   real,    pointer :: frac(:,:,:) =>NULL()  ! tile area fraction for each tile
   logical, pointer :: mask(:,:,:) =>NULL()  ! land mask: true where data are present
   real,    pointer :: dz(:) =>NULL()        ! thickness of layers, m
   real,    pointer :: z(:) =>NULL(),  zz(:) =>NULL() ! full (z) and half (zz) levels, m

   real,    pointer :: max_fusion(:) =>NULL() ! max amount of fusion energy, J/m3
!   <NOTE>
!     NOTE: original intent was to use frac as a mask, meaning that the land 
!     does not exist where fractional area is zero. However, original version
!     of exchange grid requires sum of fractional areas to be == 1 for every
!     grid point. In addition, it is probably useful to have separate mask,
!     just in case somebody ever needs a tile with zero fractional area.
!   </NOTE>

!   <DATA NAME="time" TYPE="time_type">
!     Current time
!   </DATA>
!   <DATA NAME="dt" UNITS="s" TYPE="real">
!     Fast time step
!   </DATA>
!   <DATA NAME="dt_slow" UNITS="s" TYPE="real">
!     Slow time step
!   </DATA>
   type(time_type) :: time         ! current time
   real            :: dt           ! fast time step, s
   real            :: dt_slow      ! slow time step, s

!   <DATA NAME="temp" UNITS="K" TYPE="real, pointer" DIM="4">
!     Temperature (i,j,tile,level)
!   </DATA>
!   <DATA NAME="fusion" UNITS="J/m3" TYPE="real, pointer" DIM="4">
!      Energy needed to melt frozen freezable water (i,j,tile,level)
!   </DATA>
   ! soil state variables
   real, pointer :: temp(:,:,:,:) =>NULL() !  temperature (i,j,tile,level), degK
   real, pointer :: fusion(:,:,:,:) =>NULL()  ! energy needed to melt frozen freezable water, J/m3
 
!   <DATA NAME="snow" UNITS="kg/m2" TYPE="real, pointer" DIM="3">
!     Snow water mass (i,j,tile)
!   </DATA>
!   <DATA NAME="water" UNITS="kg/m2" TYPE="real, pointer" DIM="3">
!     Root-zone water (i,j,tile)
!   </DATA>
!   <DATA NAME="groundwater" UNITS="kg/m2" TYPE="real, pointer" DIM="3">
!     Groundwater (i,j,tile)
!   </DATA>
!   <DATA NAME="drainage" UNITS="kg/(m2 s)" TYPE="real, pointer" DIM="3">
!     Flux from water to groundwater (i,j,tile)
!   </DATA>
!   <DATA NAME="drainage_accum" UNITS="kg/m2" TYPE="real, pointer" DIM="3">
!     Drainage, accumulated for slow time steps (i,j,tile)
!   </DATA>
!   <DATA NAME="calving" UNITS="kg/(m2 s)" TYPE="real, pointer" DIM="3">
!     Horizontal snow flux divergence (i,j,tile)
!   </DATA>
!   <DATA NAME="calving_accum" UNITS="kg/m2" TYPE="real, pointer" DIM="3">
!     Calving, accumulated for slow time steps (i,j,tile)
!   </DATA>
!   <DATA NAME="albedo" TYPE="real, pointer" DIM="3">
!     Snow-adjusted land (soil?) albedo (i,j,tile)
!   </DATA>
!   <DATA NAME="albedo_vis_dir" TYPE="real, pointer" DIM="3">
!     Direct visible surface albedo (i,j,tile)
!   </DATA>
!   <DATA NAME="albedo_nir_dir" TYPE="real, pointer" DIM="3">
!     Direct near-infrared surface albedo (i,j,tile)
!   </DATA>
!   <DATA NAME="albedo_vis_dif" TYPE="real, pointer" DIM="3">
!     Diffuse visible surface albedo (i,j,tile)
!   </DATA>
!   <DATA NAME="albedo_nir_dif" TYPE="real, pointer" DIM="3">
!     Diffuse near-infrared albedo (i,j,tile)
!   </DATA>
!   <DATA NAME="rough_mom" UNITS="m" TYPE="real, pointer" DIM="3">
!     Momentum roughness length (i,j,tile)
!   </DATA>
!   <DATA NAME="rough_heat" UNITS="m" TYPE="real, pointer" DIM="3">
!     Heat roughness length (i,j,tile)
!   </DATA>
!   <DATA NAME="rough_scale" UNITS="m" TYPE="real, pointer" DIM="3">
!     Scale momentum drag coefficient (i,j,tile)
!   </DATA>
!   <DATA NAME="stomatal" UNITS="s/m" TYPE="real, pointer" DIM="3">
!     Non-water-stressed bulk stomatal resistance (i,j,tile)
!   </DATA>
!   <DATA NAME="max_water" UNITS="kg/m2" TYPE="real, pointer" DIM="3">
!     Water capacity of root zone (i,j,tile)
!   </DATA>
!   <DATA NAME="tcon" UNITS="W/(m K s)" TYPE="real, pointer" DIM="4">
!     Thermal conductivity of the ground (i,j,tile,level)
!   </DATA>
!   <DATA NAME="rho_cap" UNITS="J/(m3 K)" TYPE="real, pointer" DIM="4">
!     Volumetric heat capacity of the ground (i,j,tile,level)
!   </DATA>
!   <DATA NAME="tau_groundwater" UNITS="s" TYPE="real, pointer" DIM="3">
!     Groundwater residence time (i,j,tile)
!   </DATA>
   real, pointer, dimension(:,:,:) :: &  ! (lon, lat, tile)
        snow =>NULL(),           & ! snow water mass, kg/m2
        water =>NULL(),          & ! root-zone water, kg/m2
        groundwater =>NULL(),    & ! groundawter, kg/m2
        drainage =>NULL(),       & ! flux from water to groundwater
        drainage_accum =>NULL(), & ! drainage, accumulated for slow time steps
        calving =>NULL(),        & ! horizontal snow flux divergence
        calving_accum =>NULL(),  & ! calving, accumulated for slow time steps
        albedo =>NULL(),         & ! snow-adjusted land (soil?) albedo -- should be revised
        albedo_vis_dir =>NULL(),     &
        albedo_nir_dir =>NULL(),     &
        albedo_vis_dif =>NULL(),     &
        albedo_nir_dif =>NULL(),     &
        rough_mom =>NULL(),      & ! momentum roughness length
        rough_heat =>NULL(),     & ! heat roughness length
        rough_scale =>NULL(),    & ! scale for momentum drag coefficient
        stomatal =>NULL(),       & ! non-water-stressed bulk stomatal resistance
        max_water =>NULL(),      & ! water capacity of root zone, kg/m2
        tau_groundwater =>NULL()   ! groundwater
   real, pointer, dimension (:,:,:,:) :: &  ! (lon, lat, tile, level)
        tcon =>NULL(),           & ! thermal conductivity of the ground
        rho_cap =>NULL()           ! volumetric heat capacity of the ground, J/(m3 K)

!   <DATA NAME="glacier" TYPE="logical, pointer" DIM="3">
!     Glacier mask, true if land is a glacier (lon, lat, tile)
!   </DATA>
!   <DATA NAME="lake" TYPE="logical, pointer" DIM="3">
!     Lake mask, true where lake on land (lon, lat, tile)
!   </DATA>
   logical, pointer, dimension (:,:,:) :: & ! (lon, lat, tile)
        glacier =>NULL(),        & ! true if land is a glacier
        lake =>NULL()              ! lake mask (true where lake on land)

!   <DATA NAME="cover_type" TYPE="integer, pointer" DIM="3">
!     Land surface cover type (lon, lat, tile)
!   </DATA>
!   <DATA NAME="ground" TYPE="integer, pointer" DIM="3">
!     Ground type (lon, lat, tile)
!   </DATA>
   integer, pointer, dimension (:,:,:) :: & ! (lon, lat, tile)
        cover_type =>NULL(),          & ! land cover type
        ground =>NULL()            ! ground type

!   <DATA NAME="max_snow" TYPE="real">
!     Maximum snow capacity
!   </DATA>
!   <DATA NAME="conserve_glacier_mass" TYPE="logical">
!     When true, prevent glacier sublimation and do not allow glacier melt
!     to run off
!   </DATA>
!   <DATA NAME="aa" TYPE="real, pointer" DIM="1">
!     Coefficients for diffusion
!   </DATA>
!   <DATA NAME="cc" TYPE="real, pointer" DIM="1">
!     Coefficients for diffusion
!   </DATA>
   real :: max_snow       ! max snow capacity
   logical :: conserve_glacier_mass ! when true, prevent glacier sublimation and don't
                                    ! allow glacier melt to run off
   logical :: conserve_glacier_snow_mass ! when true, don't reset negative snow
                                    ! masses to zero on top of glacier
   real, pointer :: aa(:) =>NULL(), cc(:) =>NULL() ! coefficients for diffusion

!   <DATA NAME="Rivers" TYPE="rivers_type">
!     State of rivers and runoff
!   </DATA>
   type(rivers_type) :: Rivers ! state of rivers and runoff

end type soil_type
! </TYPE>


! some names, for information only
character(len=*),    parameter :: module_name = 'soil'
character(len=128),  parameter :: version     = '$Id: soil.F90,v 16.0 2008/07/30 22:30:32 fms Exp $'
character(len=128),  parameter :: tagname         = '$Name: tikal $'

! ---- module constants ------------------------------------------------------
integer, parameter :: max_lev = 50

! <NAMELIST NAME="soil_nml">
!   <DATA NAME="n_levels" TYPE="integer" DEFAULT="5">
!     Default number of soil levels
!   </DATA>
!   <DATA NAME="dz(max_lev)" UNITS="m" TYPE="real" DIM="1" DEFAULT="(/ 0.005, 0.045, 0.10, 0.35, 1.0, 45*0. /)">
!     Default thickness of layers, from top down
!   </DATA>
!   <DATA NAME="init_temp_no_ice" UNITS="K" TYPE="real" DEFAULT="288">
!     Initial no-ice T if no restart
!   </DATA>
!   <DATA NAME="init_temp_ice" UNITS="K" TYPE="real" DEFAULT="260">
!     Initial ice T if no restart, used where snow or glacier
!   </DATA>
!   <DATA NAME="init_water" TYPE="real" DEFAULT="0">
!     Initial soil water is set to min(init_water, max_water) if no restart
!   </DATA>
!   <DATA NAME="init_snow" TYPE="real" DEFAULT="0">
!     Initial snow pack is set to min(init_snow, max_snow) if no restart
!   </DATA>
!   <DATA NAME="init_groundwater" TYPE="real" DEFAULT="0">
!     Initial groundwater storage if no restart
!   </DATA>
!   <DATA NAME="conserve_glacier_mass" TYPE="logical" DEFAULT=".false.">
!     When true, prevent glacier sublimation and don't allow glacier melt to
!     run off
!   </DATA>
!   <DATA NAME="freezable_water(max_lev)" UNITS="kg/m3" TYPE="real" DIM="1" DEFAULT="(/0,index=1,max_lev/)">
!     Amount of freezable water in soil, from top down
!   </DATA>
!   <DATA NAME="init_frozen_water" UNITS="kg/m3" TYPE="real" DEFAULT="0">
!     Initial amount of frozen water in soil if no restart
!   </DATA>
integer :: index
! ---- namelist variables and their default values ---------------------------
logical :: do_netcdf_restart = .true.
integer :: n_levels    = 5 ! default number of soil levels
real    :: dz(max_lev) = & ! default thickness of layers, from top down, m
     (/ 0.005, 0.045, 0.10, 0.35, 1.0, 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0., &
         0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0. /)
real    :: init_temp_no_ice     = 288.        ! initial no-ice T if no restart
real    :: init_temp_ice        = 260.        ! initial ice T if no restart,
                                              ! used where snow or glacier
real    :: init_water           =   0.        ! initial soil water is set to
                                              ! min(init_water, max_water)
                                              ! if no restart
real    :: init_snow            =   0.        ! initial snow pack is set to
                                              ! min(init_snow, max_snow)
                                              ! if no restart
real    :: init_groundwater     =   0.        ! initial groundwater storage
                                              ! if no restart
logical :: conserve_glacier_mass= .false.     ! when true, prevent glacier sublimation
                                              ! and don't allow glacier melt to run off
logical :: conserve_glacier_snow_mass= .false.   ! when true, don't reset negative snow
                                              ! masses to zero on top of glacier
real    :: freezable_water(max_lev) = (/(0.0,index=1,max_lev)/)      
         ! amount of water that can be frozen (but cannot participate in other hydrologycal processes)
real    :: init_frozen_water   =  0 

namelist /soil_nml/ n_levels, dz, &
     init_temp_no_ice, init_temp_ice, init_water, init_snow, &
     init_groundwater, conserve_glacier_mass, conserve_glacier_snow_mass, &
     freezable_water, init_frozen_water
! </NAMELIST>


logical :: module_is_initialized = .FALSE. ! indicates whether the module was initialized


! ---- diagnostic field ids --------------------------------------------------
! diag fields
integer :: id_zhalf, id_zfull
integer :: id_snow, id_water, id_temp
integer :: id_albedo, id_albedo_vis_dir, id_albedo_nir_dir
integer ::            id_albedo_vis_dif, id_albedo_nir_dif
integer :: id_drainage, id_calving, id_precip, id_snowfall, id_evapor, id_sublim
integer :: id_smelt, id_gmelt, id_watsno
integer :: id_sens, id_lhf
integer :: id_lw, id_sw
integer :: id_surface_runoff, id_surface_runoff_snow
integer :: id_groundwater
! static fields
integer :: id_area
integer :: id_lfrac
integer :: id_glacier
integer :: id_cover_type
integer :: id_tcon, id_rho_cap
integer :: id_stomatal
integer :: id_max_water
integer :: id_rough_heat, id_rough_mom
integer :: id_tau_gw
integer :: id_frozen
integer :: id_hlf
integer :: id_hlv
! <DIAGFIELDS>
!   <NETCDF NAME="zhalf" UNITS="m">
!     Half level
!   </NETCDF>
!   <NETCDF NAME="zfull" UNITS="m">
!     Full level
!   </NETCDF>
!   <NETCDF NAME="water" UNITS="kg/m2">
!     Mass of water in the bucket
!   </NETCDF>
!   <NETCDF NAME="snow" UNITS="kg/m2">
!     Mass of snow on the ground
!   </NETCDF>
!   <NETCDF NAME="temp" UNITS="degK">
!     Temperature
!   </NETCDF>
!   <NETCDF NAME="albedo" UNITS="dimensionless">
!     Albedo
!   </NETCDF>
!   <NETCDF NAME="albedo_vis_dir" UNITS="dimensionless">
!     Direct visible surface albedo
!   </NETCDF>
!   <NETCDF NAME="albedo_nir_dir" UNITS="dimensionless">
!     Direct near-infrared surface albedo
!   </NETCDF>
!   <NETCDF NAME="albedo_vis_dif" UNITS="dimensionless">
!     Diffuse visible surface albedo
!   </NETCDF>
!   <NETCDF NAME="albedo_nir_dif" UNITS="dimensionless">
!     Diffuse near-infrared surface albedo
!   </NETCDF>
!   <NETCDF NAME="drainage" UNITS="kg/(m2 s)">
!     Drainage rate
!   </NETCDF>
!   <NETCDF NAME="calving" UNITS="kg/(m2 s)">
!     Snow sweep rate
!   </NETCDF>
!   <NETCDF NAME="precip" UNITS="kg/(m2 s)">
!     Total precipitation rate
!   </NETCDF>
!   <NETCDF NAME="snowfall" UNITS="kg/(m2 s)">
!     Snowfall rate
!   </NETCDF>
!   <NETCDF NAME="evap" UNITS="kg/(m2 s)">
!     Evaporation rate
!   </NETCDF>
!   <NETCDF NAME="sublim" UNITS="kg/(m2 s)">
!     Sublimation rate
!   </NETCDF>
!   <NETCDF NAME="smelt" UNITS="kg/(m2 s)">
!     Snow melt rate
!   </NETCDF>
!   <NETCDF NAME="gmelt" UNITS="kg/(m2 s)">
!     Glacier melt rate
!   </NETCDF>
!   <NETCDF NAME="sens" UNITS="W/m2">
!     Sensible heat flux
!   </NETCDF>
!   <NETCDF NAME="latent" UNITS="W/m2">
!     Latent heat flux
!   </NETCDF>
!   <NETCDF NAME="flw" UNITS="W/m2">
!     Net longwave radiative flux
!   </NETCDF>
!   <NETCDF NAME="fsw" UNITS="W/m2">
!     Net shortwave radiative flux
!   </NETCDF>
!   <NETCDF NAME="wroff" UNITS="kg/(m2 s)">
!     Surface runoff of water
!   </NETCDF>
!   <NETCDF NAME="sroff" UNITS="kg/(m2 s)">
!     Surface runoff of snow
!   </NETCDF>
!   <NETCDF NAME="groundwater" UNITS="kg/m2">
!     Mass of water below bucket
!   </NETCDF>
!   <NETCDF NAME="area" UNITS="m2">
!     Land area
!   </NETCDF>
!   <NETCDF NAME="lfrac" UNITS="dimensionless">
!     Fraction of land in cell
!   </NETCDF>
!   <NETCDF NAME="glacier" UNITS="dimensionless">
!     Glacier logical mask
!   </NETCDF>
!   <NETCDF NAME="cover_type" UNITS="dimensionless">
!     Land surface cover type
!   </NETCDF>
!   <NETCDF NAME="tcon" UNITS="W/(m K s)">
!     Ground thermal conductivity
!   </NETCDF>
!   <NETCDF NAME="rho_cap" UNITS="J/(m3 K)">
!     Ground volumetric heat capacity
!   </NETCDF>
!   <NETCDF NAME="stomatal" UNITS="s/m">
!     Non-water-stressed stomatal resistance
!   </NETCDF>
!   <NETCDF NAME="max_water" UNITS="kg/m2">
!     Root-zone water capacity
!   </NETCDF>
!   <NETCDF NAME="rough_mom" UNITS="m">
!     Momentum roughness length
!   </NETCDF>
!   <NETCDF NAME="rough_heat" UNITS="m">
!     Scalar roughness length
!   </NETCDF>
!   <NETCDF NAME="tau_gw" UNITS="s">
!     Groundwater residence time
!   </NETCDF>
!   <NETCDF NAME="frozen" UNITS="kg/m3">
!     Amount of frozen water in soil
!   </NETCDF>
!   <NETCDF NAME="hlf" UNITS="J/kg">
!     Latent heat of fusion
!   </NETCDF>
!   <NETCDF NAME="hlv" UNITS="J/kg">
!     Latent heat of evaporation
!   </NETCDF>
! </DIAGFIELDS>
! ---- end of diagnostic field ids -------------------------------------------

! <INTERFACE NAME="send_averaged_data">

!   <OVERVIEW>
!     Interface to tile-averaged diagnostic routines
!   </OVERVIEW>

!   <DESCRIPTION>
!     Interface to tile-averaged diagnostic routines
!   </DESCRIPTION>
! ---- interface to tile-averaged diagnostic routines ------------------------
interface send_averaged_data
   module procedure send_averaged_data2d
   module procedure send_averaged_data3d
end interface
! </INTERFACE>

! for diagnostics only
integer :: i 
integer, parameter :: iwatch = 133, jwatch=84

contains


! <SUBROUTINE NAME="soil_init">

!   <OVERVIEW>
!     Initializes the state of the soil.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Reads the namelist, which is assumed to be named soil_nml and located
!     in the file input.nml. Sets the number of tiles in the soil and the
!     level number for the soil data. Allocate soil data.  Sets up
!     time-related values and vertical layering parameters. Sets up initial
!     land area, fractional area, and mask. Reconciles the fractional area with
!     mask: the sum of fractional areas has to be 1 everywhere, even where
!     there is no land. Initializes accumulated values, soil diagnostics and
!     rivers submodule. Assigns initial values to dynamic land properties
!     (albedo). Send static fields to diagnostic manager for output and copies
!     glacier mass conservation flag to the soil data stricture.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call soil_init ( soil, gblon, gblat, garea, gfrac,  &
!     time, dt_fast, dt_slow, domain, frac, mask, &
!     id_lon, id_lat, dz1 )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine soil_init ( soil, gblon, gblat, garea, gfrac,  &
     time, dt_fast, dt_slow, domain, frac, mask, &
     id_lon, id_lat, dz1 )

  type(soil_type), intent(inout) :: soil        ! soil data to initialize
  real,            intent(in)  :: gblon(:,:)  ! lon corners of the grid cells
  real,            intent(in)  :: gblat(:,:)  ! lat corners of the grid cells
  real,            intent(in)  :: garea(:,:)  ! full area of the land grid cells
  real,            intent(in)  :: gfrac(:,:)  ! fraction of grid cells covered by land
  type(time_type), intent(in)  :: time        ! time origin
  type(time_type), intent(in)  :: dt_fast     ! fast time step
  type(time_type), intent(in)  :: dt_slow     ! slow time step
  type(domain2d),  intent(in)  :: domain      ! domain assigned for us
  ! may be the values below should be replaced with something more
  ! general, like "grid_type" ?
  real,            intent(in)  :: frac(:,:,:) ! fractional area of tiles
  logical,         intent(in)  :: mask(:,:,:) ! true if land
  integer,         intent(in)  :: id_lon      ! ID of longitude land diag axis
  integer,         intent(in)  :: id_lat      ! ID of latitude land diag axis

  real, optional,  intent(in)  :: dz1(:)      ! thickness of soil layers
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer :: unit         ! unit for various i/o
  integer :: ierr         ! error code, returned by i/o routines
  integer :: io           ! i/o status for the namelist
  integer :: day, sec     ! for computation of real time step
  integer :: k            ! level iterator
  real    :: init_fusion  ! initial value stored in frozen water, J/m3
  integer :: model_yr, model_month, model_day        ! used for get_date
  integer :: model_hour, model_minute, model_second  ! used for get_date
  integer :: this_year    ! the current model year
  character(len=64) :: fname = 'INPUT/soil.res.nc'
  character(len=64) :: lvltag
  logical :: is_data_read = .false.

  module_is_initialized =.TRUE.   
   
  ! read namelist, which is assumed to be named soil_nml and located in the 
  ! file input.nml
  if ( file_exist( 'input.nml' ) ) then
     unit = open_namelist_file ( )
     ierr = 1
     do while ( ierr /= 0 )
        read ( unit,  nml = soil_nml, iostat = io, end = 10 ) 
        ierr = check_nml_error ( io, 'soil_nml' )
     enddo
10   continue
     call close_file( unit )
  endif
  call get_restart_io_mode(do_netcdf_restart)

  ! write version information to a log file
  call write_version_number(version, tagname)

  !  write the namelist to a log file
  if( mpp_pe()==0 ) then
     unit = stdlog( )
     write (unit, nml=soil_nml)
     call close_file (unit)
  endif
  
  ! copy specified domain to our data
  soil % domain = domain

  ! get the size of our domain
  call mpp_get_compute_domain ( soil%domain, &
       soil%is, soil%ie, soil%js, soil%je )

  ! set the number of tiles in the soil
  soil%n_tiles = size(frac,3)

  ! set up level number for the soil data
  if (present(dz1)) then
     soil%n_levels = size(dz1(:)) ! values from the argument list
  else
     soil%n_levels = n_levels ! default value
  endif

  ! allocate soil data 
  allocate ( &
       soil% dz             (soil%n_levels),   &
       soil% z              (soil%n_levels),   &
       soil% zz             (soil%n_levels+1), &
       soil% aa             (soil%n_levels+1), &
       soil% cc             (soil%n_levels+1), &
       soil% max_fusion     (soil%n_levels),   &
       soil% area           (soil%is:soil%ie, soil%js:soil%je), & 
       soil% frac           (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), & 
       soil% mask           (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), & 
       soil% temp           (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles,  &
                             soil%n_levels), &
       soil% fusion         (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles,  &
                             soil%n_levels), &
       soil% snow           (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% water          (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% groundwater    (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% drainage       (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% drainage_accum (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% calving        (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% calving_accum  (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% albedo         (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% albedo_vis_dir (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% albedo_nir_dir (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% albedo_vis_dif (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% albedo_nir_dif (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% rough_mom      (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% rough_heat     (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% rough_scale    (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% stomatal       (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% max_water      (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), & 
       stat = ierr )
  if (ierr /= 0) &
       call error_mesg (module_name, 'Cannot allocate memory for soil', FATAL)
  allocate ( &
       soil% tcon           (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles,  &
                             soil%n_levels), & 
       soil% rho_cap        (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles,  &
                             soil%n_levels), & 
       soil% tau_groundwater(soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% glacier        (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% lake           (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% cover_type     (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), &
       soil% ground         (soil%is:soil%ie, soil%js:soil%je, soil%n_tiles), stat = ierr )

  if (ierr /= 0) &
       call error_mesg (module_name, 'Cannot allocate memory for soil', FATAL)
!   <ERROR MSG="Cannot allocate memory for soil" STATUS="FATAL">
!   </ERROR>

  ! set up time-related values
  soil % time = time
  call get_time(dt_fast, sec, day); soil%dt      = day*86400.0+sec
  call get_time(dt_slow, sec, day); soil%dt_slow = day*86400.0+sec

  ! get current model year from the soil%time
  call get_date(soil%Time, model_yr, model_month, model_day, model_hour, model_minute, model_second)
  this_year = model_yr

  ! set up level number for the soil data
  if (present(dz1)) then
     soil%dz       = dz1(1:size(soil%dz(:)))
  else
     soil%dz       = dz (1:size(soil%dz(:)))
  endif

  ! set up vertical layering parameters
  soil%zz(1) = 0
  do k = 1, soil%n_levels
     soil%zz(k+1) = soil%zz(k) + soil%dz(k)
  end do
  do k = 1, soil%n_levels
     soil%z(k) = 0.5*(soil%zz(k+1) + soil%zz(k))
  end do

  do k = 1, soil%n_levels-1
     soil%aa(k) = - 2.0*soil%dt/(soil%dz(k)*(soil%dz(k+1)+soil%dz(k)))
  end do

  do k = 2, soil%n_levels
     soil%cc(k) = - 2.0*soil%dt/(soil%dz(k)*(soil%dz(k)+soil%dz(k-1)))
  end do

  soil%aa(soil%n_levels) = 0.0
  soil%cc(1)             = 0.0

  ! set up initial land area, fractional area, and mask
  soil%area = garea(soil%is:soil%ie, soil%js:soil%je)       &
       * gfrac(soil%is:soil%ie, soil%js:soil%je)
  soil%frac = frac
  soil%mask = mask

  ! initialize max amount of possible fusion 
  soil%max_fusion = freezable_water(1:size(soil%dz(:)))*hlf

  ! read restart file, if it exists
  if( file_exist('INPUT/soil.res.nc') .or. file_exist('INPUT/soil.res.tile1.nc') ) then
     if (mpp_pe() == mpp_root_pe()) call error_mesg ('soil_mod', &
            'Reading NetCDF formatted restart file: INPUT/soil.res.nc', NOTE)
     call set_domain( soil%domain )
     call read_data ( fname, 'frac', soil%frac)
     do k = 1, size(soil%temp, 4)
        if(k < 10)   write(lvltag, '(i1)') k
        if(k >= 10)  write(lvltag, '(i2)') k
        if(k >= 100) write(lvltag, '(i3)') k
        call read_data ( fname, 'soil_temp_'//trim(lvltag), soil%temp(:,:,:,k) )
     enddo
     call read_data ( fname, 'water', soil%water )
     call read_data ( fname, 'snow', soil%snow )
     call read_data ( fname, 'groundwater', soil%groundwater )
     do k = 1, size(soil%fusion, 4)
        if(k < 10)   write(lvltag, '(i1)') k
        if(k >= 10)  write(lvltag, '(i2)') k
        if(k >= 100) write(lvltag, '(i3)') k
        call read_data ( fname, 'fusion_'//trim(lvltag), soil%fusion(:,:,:,k) )
     enddo
     soil%mask = (soil%frac >= 0)   
     is_data_read = .true.
  else if (file_exist('INPUT/soil.res')) then
     if (mpp_pe() == mpp_root_pe()) call error_mesg ('soil_mod', &
            'Reading native formatted restart file.', NOTE)
     unit = open_restart_file('INPUT/soil.res', 'read')
     call set_domain( soil%domain )
     call read_data ( unit, soil%frac )
     call read_data ( unit, soil%temp )
     call read_data ( unit, soil%water )
     call read_data ( unit, soil%snow )
     call read_data ( unit, soil%groundwater )
     call read_data ( unit, soil%fusion )
     call close_file( unit )
     is_data_read = .true. 
     ! set up mask and fractional area
     soil%mask = (soil%frac >= 0)
  else
     ! set up initial land area, fractional area, and mask
     soil%area  = garea(soil%is:soil%ie, soil%js:soil%je)   &
          * gfrac(soil%is:soil%ie, soil%js:soil%je)
     soil%frac  = frac
     soil%mask  = mask
  endif

  ! reconcile fractional area with mask: the sum of fractional areas
  ! has to be 1 everywhere, even where there is no land. 
  where ( .not.soil%mask )             soil%frac        = 0.0
  where ( .not.any(soil%mask, DIM=3) ) soil%frac(:,:,1) = 1.0

  ! initialize accumulated values
  soil%drainage_accum = 0
  soil%calving_accum  = 0

  ! initialize soil diagnostics -- must be before calls to initialization of 
  ! sub-modules because they use id_lon and id_lat, defined by this call
  call init_soil_diag ( id_lon, id_lat, soil%z, soil%zz, Time )

  call land_properties_init ( &
       gblon(soil%is:(soil%ie+1),soil%js:(soil%je+1)), &
       gblat(soil%is:(soil%ie+1),soil%js:(soil%je+1)), &
       soil%mask, time, soil%domain, &
       soil%glacier,         &
       soil%lake,            &
       soil%rough_mom,       &
       soil%rough_heat,      &
       soil%rough_scale,     &
       soil%tcon,            &
       soil%rho_cap,         &
       soil%stomatal,        &
       soil%max_water,       &
       soil%tau_groundwater, &
       soil%max_snow,        &
       soil%cover_type,      &
       id_lon, id_lat )

  if (.not.is_data_read) then
     ! if we did not read the restart file, initialize data with reasonable values
     ! ("cold start"). Note that we could not do that before initialization of land
     ! properties; on the other hand the initialization of land properties cannot be
     ! done before reading restart file since mask is being read from restart.
     Soil%water = init_water

     Soil%snow = init_snow

     Soil%groundwater = init_groundwater
     init_fusion = init_frozen_water*hlf
     do k = 1, n_levels
        Soil%temp(:,:,:,k) = init_temp_no_ice
        Soil%fusion(:,:,:,k) = init_fusion
        where (Soil%glacier .or. Soil%snow>0)
           Soil%temp(:,:,:,k) = init_temp_ice
        endwhere
     enddo
  endif

#ifdef SCM
  !--- for single column model -------------------------------------!
  !--- initialize surface temperature to observed value ------------!  
  if (do_specified_tskin .and. do_specified_land) then     
       Soil%temp(:,:,:,1) = TSKIN
  end if   
  !-----------------------------------------------------------------!
#endif

  ! initialize rivers submodule
  call rivers_init &
     ( Soil%rivers, gblon, gblat, garea, gfrac, time, dt_fast, dt_slow, domain, &
       id_lon, id_lat )

  !  assign initial values to dynamic land properties (albedo)
!! either include all the albedo components in this call, or define 
!!  the albedo components upon return. 
  call update_land_properties_fast &
       (soil%snow(:,:,:), soil%temp(:,:,:,1), soil%mask, soil%albedo(:,:,:), &
        soil%cover_type(:,:,:))

!      (soil%snow(:,:,:), soil%temp(:,:,:,1), soil%mask,   &
!        soil%albedo(:,:,:),  &
!        soil%albedo_vis_dir(:,:,:),  &
!        soil%albedo_nir_dir(:,:,:),  &
!        soil%albedo_vis_dif(:,:,:),  &
!        soil%albedo_nir_dif(:,:,:) )
!! FOR NOW, set all values to be the same:
   soil%albedo_vis_dir = soil%albedo
   soil%albedo_nir_dir = soil%albedo
   soil%albedo_vis_dif = soil%albedo
   soil%albedo_nir_dif = soil%albedo

  ! send static fields to diagnostic manager for output
  call diag_static(soil, gfrac(soil%is:soil%ie, soil%js:soil%je))

  ! copy glacier mass conservation flag to the soil data stricture
  soil%conserve_glacier_mass = conserve_glacier_mass
  soil%conserve_glacier_snow_mass = conserve_glacier_snow_mass

end subroutine soil_init
! </SUBROUTINE>


! <SUBROUTINE NAME="init_soil_diag">

!   <OVERVIEW>
!     Initializes diagnostic for soil.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Initializes diagnostics for soil. Defines vertical axis, array of
!     axis indices and diagnostic and static fields.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call init_soil_diag ( id_lon, id_lat, zfull, zhalf, Time )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine init_soil_diag ( id_lon, id_lat, zfull, zhalf, Time )

  integer,         intent(in) :: id_lon  ! ID of land longitude (X) axis  
  integer,         intent(in) :: id_lat  ! ID of land longitude (X) axis
  real,            intent(in) :: zfull(:)! Full levels, m
  real,            intent(in) :: zhalf(:)! Half levels, m
  type(time_type), intent(in) :: Time    ! Current time
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer :: axes(3)

  ! define vertical axis
  id_zhalf = diag_axis_init ( &
       'zhalf', zhalf, 'meters', 'z', 'half level',  -1, set_name='land' )
  id_zfull = diag_axis_init ( &
       'zfull', zfull, 'meters', 'z', 'full level',  -1, set_name='land', &
       edges=id_zhalf )

  ! define array of axis indices
  axes = (/ id_lon, id_lat, id_zfull /)

  ! define diagnostic fields
  id_water = register_diag_field ( module_name, 'water', axes(1:2),  &
       Time, 'mass of water in bucket', 'kg/m2', missing_value=-100.0 )
  id_snow  = register_diag_field ( module_name, 'snow',  axes(1:2),  &
       Time, 'mass of snow on ground', 'kg/m2',  missing_value=-100.0 )
  id_temp  = register_diag_field ( module_name, 'temp',  axes,       &
       Time, 'temperature',            'degK',  missing_value=-100.0 )
  id_frozen = register_diag_field ( module_name, 'frozen',  axes,       &
       Time, 'amount of frozen water', 'kg/m3',  missing_value=-100.0 )
  id_albedo = register_diag_field ( module_name, 'albedo',  axes(1:2), &
       Time, 'albedo', 'dimensionless',  missing_value=-100.0 )
  id_albedo_vis_dir = register_diag_field ( module_name, 'albedo_vis_dir',  axes(1:2), &
       Time, 'albedo_vis_dir', 'dimensionless',  missing_value=-100.0 )
  id_albedo_vis_dif = register_diag_field ( module_name, 'albedo_vis_dif',  axes(1:2), &
       Time, 'albedo_vis_dif', 'dimensionless',  missing_value=-100.0 )
  id_albedo_nir_dir = register_diag_field ( module_name, 'albedo_nir_dir',  axes(1:2), &
       Time, 'albedo_nir_dir', 'dimensionless',  missing_value=-100.0 )
  id_albedo_nir_dif = register_diag_field ( module_name, 'albedo_nir_dif',  axes(1:2), &
       Time, 'albedo_nir_dif', 'dimensionless',  missing_value=-100.0 )
  id_drainage = register_diag_field ( module_name, 'drainage',  axes(1:2), &
       Time, 'drainage rate',          'kg/(m2 s)',missing_value=-100.0 )
  id_calving = register_diag_field ( module_name, 'calving',  axes(1:2), &
       Time, 'snow sweep rate',     'kg/(m2 s)',missing_value=-100.0 )
  id_precip = register_diag_field ( module_name, 'precip',  axes(1:2), &
       Time, 'total precipitation rate',  'kg/(m2 s)', missing_value=-100.0 )
  id_snowfall = register_diag_field ( module_name, 'snowfall',  axes(1:2), &
       Time, 'snowfall rate',          'kg/(m2 s)', missing_value=-100.0 )
  id_evapor = register_diag_field ( module_name, 'evap',  axes(1:2), &
       Time, 'evaporation rate',       'kg/(m2 s)', missing_value=-100.0 )
  id_sublim = register_diag_field ( module_name, 'sublim',axes(1:2), &
       Time, 'sublimation rate',       'kg/(m2 s)', missing_value=-100.0 )
  id_smelt = register_diag_field ( module_name, 'smelt',  axes(1:2),  &
       Time, 'snow melt rate',         'kg/(m2 s)',     missing_value=-100.0 )
  id_gmelt = register_diag_field ( module_name, 'gmelt',  axes(1:2),  &
       Time, 'glacier melt rate',      'kg/(m2 s)', missing_value=-100.0 )
  id_watsno = register_diag_field ( module_name, 'watsno',  axes(1:2),  &
       Time, 'rate of water theft by snow',    'kg/(m2 s)', missing_value=-100.0 )
  id_sens = register_diag_field ( module_name, 'sens',  axes(1:2),  &
       Time, 'sensible heat flux',      'W/m2',  missing_value=-999.0 )
  id_lhf = register_diag_field ( module_name, 'latent',  axes(1:2),  &
       Time, 'latent heat flux',        'W/m2',  missing_value=-999.0 )
  id_lw   = register_diag_field ( module_name, 'flw',  axes(1:2),      &
       Time, 'net longwave radiative flux', 'W/m2', missing_value=-999.0 )
  id_sw   = register_diag_field ( module_name, 'fsw',  axes(1:2),      &
       Time, 'net shortwave radiative flux', 'W/m2', missing_value=-999.0 )
  id_surface_runoff= register_diag_field ( module_name, 'wroff',  axes(1:2), &
       Time, 'surface runoff of water',    'kg/(m2 s)', missing_value=-999.0 )
  id_surface_runoff_snow= register_diag_field ( module_name, 'sroff', axes(1:2), &
       Time, 'surface runoff of snow',     'kg/(m2 s)', missing_value=-999.0 )
  id_groundwater   = register_diag_field ( module_name, 'groundwater',  axes(1:2),&
       Time, 'mass of water below bucket', 'kg/m2', missing_value=-999.0 )
  id_cover_type = register_diag_field( module_name, 'cover_type', axes(1:2),    &
       Time, 'Land surface cover type', 'dimensionless', missing_value=-1.0)
  id_hlf  = register_diag_field ( module_name, 'hlf', long_name='Latent heat of fusion', units='J/kg' )
  id_hlv  = register_diag_field ( module_name, 'hlv', long_name='Latent heat of evaporation', units='J/kg' )


  ! define static diagnostic fields
  id_area  = register_static_field ( module_name, 'area',  axes(1:2), &
       'land area', 'm2', missing_value=-999.0 )
  id_lfrac = register_static_field ( module_name, 'lfrac', axes(1:2), &
       'fraction of land in cell','none', missing_value=-999.0 ) 
  id_glacier  = register_static_field ( module_name, 'glacier',  axes(1:2), &
       'glacier logical mask', 'dimensionless', missing_value=-999.0 )
  id_tcon     = register_static_field ( module_name, 'tcon',  axes, &
       'ground thermal conductivity', 'W/(m K s)', missing_value=-999.0 )
  id_rho_cap  = register_static_field ( module_name, 'rho_cap',  axes, &
       'ground volumetric heat capacity', 'J/(m3 K)', missing_value=-999.0 )
  id_stomatal = register_static_field ( module_name,'stomatal', axes(1:2), &
       'non-water-stressed stomatal resistance', 's/m', missing_value=-999.0 )
  id_max_water = register_static_field ( module_name, 'max_water', axes(1:2),&
       'root-zone water capacity', 'kg/m2', missing_value=-999.0 )
  id_rough_mom = register_static_field ( module_name, 'rough_mom',axes(1:2),&
       'momentum roughness length', 'm', missing_value=-999.0 )
  id_rough_heat = register_static_field ( module_name, 'rough_heat',axes(1:2),&
       'scalar roughness length', 'm', missing_value=-999.0 )
  id_tau_gw = register_static_field ( module_name, 'tau_gw',axes(1:2),&
       'groundwater residence time', 's', missing_value=-999.0 )
  
end subroutine init_soil_diag
! </SUBROUTINE>


! <SUBROUTINE NAME="soil_end">

!   <OVERVIEW>
!     Deallocates soil data.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Deallocates soil data.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call soil_end ( soil )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine soil_end ( soil )

  type(soil_type), intent(inout)      :: soil    ! data to finish using
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  integer unit ! file unit number to write
  real    frac(soil%is:soil%ie, soil%js:soil%je, soil%n_tiles)
  character(len=64) :: fname = 'RESTART/soil.res.nc'
  character(len=64) :: lvltag
  integer           :: k

  module_is_initialized =.FALSE.
  ! finish using rivers data
  call rivers_end ( soil%rivers )

  ! save restart file
  frac=soil%frac
  where ( .not.soil%mask ) frac = -1

  call set_domain(soil%domain)

  if( do_netcdf_restart ) then
     if (mpp_pe() == mpp_root_pe()) call error_mesg ('soil_mod', &
          'Writing NetCDF formatted restart file: RESTART/soil.res.nc', NOTE)
     call write_data ( fname, 'frac', frac )
     do k = 1, size(soil%temp, 4)
        if(k < 10)   write(lvltag, '(i1)') k
        if(k >= 10)  write(lvltag, '(i2)') k
        if(k >= 100) write(lvltag, '(i3)') k
        call write_data ( fname, 'soil_temp_'//trim(lvltag), soil%temp(:,:,:,k) )
     enddo
     call write_data ( fname, 'water', soil%water )
     call write_data ( fname, 'snow', soil%snow )
     call write_data ( fname, 'groundwater', soil%groundwater )
     do k = 1, size(soil%fusion, 4)
        if(k < 10)   write(lvltag, '(i1)') k
        if(k >= 10)  write(lvltag, '(i2)') k
        if(k >= 100) write(lvltag, '(i3)') k
        call write_data ( fname, 'fusion_'//trim(lvltag), soil%fusion(:,:,:,k) )
     enddo
  else
     if (mpp_pe() == mpp_root_pe()) call error_mesg ('soil_mod', &
          'Writing native formatted restart file.', NOTE)
  unit = open_restart_file ('RESTART/soil.res', 'write')

  call write_data ( unit,frac )
  call write_data ( unit,soil%temp )
  call write_data ( unit,soil%water )
  call write_data ( unit,soil%snow )
  call write_data ( unit,soil%groundwater )
  call write_data ( unit,soil%fusion )

  call close_file ( unit )
  endif

  ! deallocate data
  deallocate ( &
       soil % dz,   &
       soil % z,    &
       soil % zz,   &
       soil % aa,   &
       soil % cc,   &
       soil % max_fusion,   &

       soil % area, & 
       soil % frac, & 
       soil % mask, & 

       soil % temp, &

       soil % snow, &
       soil % water, &
       soil % groundwater, &
       soil % drainage, &
       soil % drainage_accum, &
       soil % calving, &
       soil % calving_accum, &
       soil % albedo, &
       soil % albedo_vis_dir, &
       soil % albedo_nir_dir, &
       soil % albedo_vis_dif, &
       soil % albedo_nir_dif, &
       soil % rough_mom, &
       soil % rough_heat, &
       soil % rough_scale, &
       soil % stomatal, &
       soil % max_water, & 
       soil % tcon, & 
       soil % rho_cap, & 
       soil % tau_groundwater, &

       soil % glacier, &
       soil % lake, &

       soil % cover_type, &
       soil % ground, &
       soil % fusion  )
  
end subroutine soil_end
! </SUBROUTINE>


! <SUBROUTINE NAME="update_soil_fast">

!   <OVERVIEW>
!     Fast time-scale soil updater.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Calculate surface temperature with implicit correction via upward part
!     of tridiagonal elimination for implicit correction. The surface
!     temperature is corrected for snow melt before proceeding to complete
!     downward part of tridiagonal elimination. If the temperature is above
!     freezing and snow or glacial ice is present, compute potential melt.
!
!     In non-glaciated regions, if there is not enough snow, melt only what's
!     there and increase surface temperature above freezing. In glaciated
!     regions, if there is not enough snow, melt only what's there and then
!     melt the glacier. Otherwise go ahead and use all of the potential snow
!     melt, and leave the surface temperature at freezing.
!
!     Accumulate snow melt water into bucket in non-glacier regions. Using
!     this snow melt-modified surface temperature, correct all fluxes and
!     compute temperature increment and new temperature for output. Complete
!     the tridiagonal solver.
!     
!     Bucket hydrology involves treating unglaciated cells first. Tentative
!     changes are based on time-step evaporation and precipitation. If snow
!     cover went negative during this step, take the necessary mass from the
!     soil (water) and re-zero snow. Then put excess soil water into soil
!     drainage. Then do the glaciated cells. soil water is not present, and
!     glacier mass is not tracked. For all land cells, put excess snow into
!     calving. Accumulate drainage for transfer to groundwater on the slow
!     time step. Similarly, accumulate calving. Compute the new albedos and 
!     update rivers.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call update_soil_fast ( soil, &
!     fsw, flw, sens, evap, dhdt, dedt, drdt, lprec, fprec )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine update_soil_fast ( soil, &
     fsw, flw, sens, evap, dhdt, dedt, drdt, lprec, fprec )

  type(soil_type), intent(inout) :: soil ! soil state to update
  real, intent(in) :: &
       fsw  (soil%is:soil%ie,soil%js:soil%je,soil%n_tiles), & ! shortwave flux
       flw  (soil%is:soil%ie,soil%js:soil%je,soil%n_tiles), & ! longwave flux
       sens (soil%is:soil%ie,soil%js:soil%je,soil%n_tiles), & ! sensible heat
                                                              ! flux
       evap (soil%is:soil%ie,soil%js:soil%je,soil%n_tiles), & ! evaporation
       dhdt (:,:,:), & ! derivative of sens over T
       dedt (:,:,:), & ! derivative of evap over T
       drdt (:,:,:), & ! derivative of LW radiation over T
       lprec(:,:,:), & ! liquid prec
       fprec(:,:,:)    ! solid prec (snow)
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  real, dimension(size(soil%frac,1), size(soil%frac,2), size(soil%frac,3)) :: &
       t_surf,        &
       snow_melt,     &
       glacier_melt,  &
       watsno,        &
       rho_cap_dz,    &
       latent,        & ! spec heat of sublimation/evaporation
       sublim,        &
       t_to_snow,     & 
       phase_change,  &
       sens_new,      &
       evap_new,      &
       flw_new,       &
       aaa, ccc, bbb, &
       num, denom,    &
       flux, deriv
  logical, dimension(size(fsw,1), size(fsw,2), size(soil%frac,3)) :: &
       not_glacier,   &
       ice_or_snow,   &
       snow_on_ground
  real, dimension(&
       size(fsw,1), size(fsw,2), size(soil%temp,3), size(soil%temp,4))::&
       e,             &
       f,             &
       del_t

  integer :: k, k2
  integer :: num_lev        ! number of levels in the soil
  

  ! check input argument consistency -- should be disabled after debugging
  if ( size(fsw,1) /= size(soil%area,1) .or. size(fsw,2) /= size(soil%area,2) )  &
       call error_mesg ( module_name, &
       'update_land_fast:: input arguments have incorrect horizontal dimensions', &
       FATAL)

!   <ERROR MSG="update_land_fast:: input arguments have incorrect horizontal dimensions" STATUS="FATAL">
!   </ERROR>

  not_glacier  = soil%mask .and. .not.soil%glacier
  ice_or_snow  = soil%mask .and. (soil%snow > 0 .or. soil%glacier)

  ! when snow or ice is present, include latent heat of fusion when computing 
  ! energy equivalent of evaporation (sublimation) rate 

  latent = hlv
  where (ice_or_snow) latent = hlf + hlv

  ! some initial values
  t_surf       = soil%temp(:,:,:,1)
  snow_melt    = 0.0
  glacier_melt = 0.0
  evap_new     = 0.0
  sens_new     = 0.0
  flw_new      = 0.0
  sublim       = 0.0
  watsno       = 0.0

  num_lev = size(soil%temp,4)

  ! some useful combinations
  where(soil%mask) 
     ! factor for converting flux into temperature change in top layer
     rho_cap_dz = soil%dt/(soil%rho_cap(:,:,:,1)*soil%dz(1))
     ! factor for converting temperature change into energy equivalent 
     ! of snow melt
     t_to_snow  = soil%rho_cap(:,:,:,1)*soil%dz(1)/hlf
     ! temperature change in top layer due to flux into soil
     flux  = (flw + fsw - (sens + latent*evap))*rho_cap_dz  
     ! derivative  of 'flux' with respect to surface T -- a non-dimensional quantity
     deriv = -(dhdt + latent*dedt + drdt)*rho_cap_dz 
  endwhere

  if(num_lev > 1) then
     ! explicit tendency due to diffusion
     

! pcm NOTE: I REALIZE THERE ARE MORE EFFICIENT WAYS TO PROGRAM THIS !!!
     
     do k = 2, num_lev - 1
        where(soil%mask) &
             del_t(:,:,:,k) =  (    &
!            - soil%diff*(  soil%aa(k)*(soil%temp(:,:,:,k+1) - soil%temp(:,:,:,k))  &
!                         - soil%cc(k)*(soil%temp(:,:,:,k)   - soil%temp(:,:,:,k-1)))
             - (  (dz(k)+dz(k+1))/(dz(k)/soil%tcon(:,:,:,k)+dz(k+1)/soil%tcon(:,:,:,k+1))) &
             *(  soil%aa(k)*(soil%temp(:,:,:,k+1) - soil%temp(:,:,:,k)))  &
             + (  (dz(k)+dz(k-1))/(dz(k)/soil%tcon(:,:,:,k)+dz(k-1)/soil%tcon(:,:,:,k-1))) &
             *(  soil%cc(k)*(soil%temp(:,:,:,k)   - soil%temp(:,:,:,k-1))) &
                               ) / soil%rho_cap(:,:,:,k)

     enddo

     k = 1
     k2 = num_lev
     where ( soil%mask ) 
!       aaa = soil%diff*soil%aa(1)
!       ccc = soil%diff*soil%cc(num_lev)
        
        aaa = (  (dz(k)+dz(k+1))/(dz(k)/soil%tcon(:,:,:,k)+dz(k+1)/soil%tcon(:,:,:,k+1))) &
                       *soil%aa(k) / soil%rho_cap(:,:,:,k)
        ccc = (  (dz(k2)+dz(k2-1))/(dz(k2)/soil%tcon(:,:,:,k2)+dz(k2-1)/soil%tcon(:,:,:,k2-1))) &
                       *soil%cc(k2) / soil%rho_cap(:,:,:,k2)
        
        del_t(:,:,:,1)= &
             -aaa*(soil%temp(:,:,:,2) - soil%temp(:,:,:,1))
        del_t(:,:,:,num_lev) =  &
             ccc*(soil%temp(:,:,:,num_lev) - soil%temp(:,:,:,num_lev-1))

        e(:,:,:,num_lev) = 0.0   ! boundary condition for tridiagonal elimination
        f(:,:,:,num_lev) = 0.0   ! boundary condition for tridiagonal elimination
     endwhere

     ! upward part of tridiagonal elimination for implicit correction
     !   (one could save a few multiplications by defining some additional arrays)

     k = num_lev
        where(soil%mask) 
!          aaa = soil%diff*soil%aa(k)
!          ccc = soil%diff*soil%cc(k)
           aaa =  0
           ccc =  ( (dz(k)+dz(k-1))/(dz(k)/soil%tcon(:,:,:,k)+dz(k-1)/soil%tcon(:,:,:,k-1)))&
                   * soil%cc(k)/soil%rho_cap(:,:,:,k)
           bbb = 1.0 - aaa - ccc
           denom = aaa*e(:,:,:,k) + bbb
           e(:,:,:,k-1) = -ccc/denom
           f(:,:,:,k-1) = (del_t(:,:,:,k) - aaa*f(:,:,:,k))/denom
        endwhere

     do k = num_lev-1, 2, -1
        where(soil%mask) 
!          aaa = soil%diff*soil%aa(k)
!          ccc = soil%diff*soil%cc(k)
           aaa =  ( (dz(k)+dz(k+1))/(dz(k)/soil%tcon(:,:,:,k)+dz(k+1)/soil%tcon(:,:,:,k+1)))&
                   * soil%aa(k)/soil%rho_cap(:,:,:,k)
           ccc =  ( (dz(k)+dz(k-1))/(dz(k)/soil%tcon(:,:,:,k)+dz(k-1)/soil%tcon(:,:,:,k-1)))&
                   * soil%cc(k)/soil%rho_cap(:,:,:,k)
           bbb = 1.0 - aaa - ccc
           denom = aaa*e(:,:,:,k) + bbb
           e(:,:,:,k-1) = -ccc/denom
           f(:,:,:,k-1) = (del_t(:,:,:,k) - aaa*f(:,:,:,k))/denom
        endwhere
     end do

     ! surface temperature with implicit correction

     k = 1
     where(soil%mask)
        aaa   =  ( (dz(k)+dz(k+1))/(dz(k)/soil%tcon(:,:,:,k)+dz(k+1)/soil%tcon(:,:,:,k+1)))&
                  *soil%aa(1)/soil%rho_cap(:,:,:,1)
        num   = del_t(:,:,:,1) - aaa*f(:,:,:,1)  + flux
        denom = 1.0 + aaa*(e(:,:,:,1) -1.0) - deriv
        
        t_surf = soil%temp(:,:,:,1) + num/denom
     endwhere

  else  ! one level case
     where(soil%mask)
        num   = flux
        denom = 1.0 - deriv
        t_surf = soil%temp(:,:,:,1) + num/denom
     endwhere
  end if

  ! correct this surface temperature for snow melt before proceeding to 
  !    complete "downward" part of tridiagonal elimination

  ! if temperature is above freezing and snow or glacial ice is present, 
  !     compute potential melt

  where (ice_or_snow .and. t_surf > tfreeze) &
       snow_melt = (t_surf - tfreeze)*denom*t_to_snow


  ! in non-glaciated region, 
  !    if there is not enough snow, melt only what's there and increase 
  !    surface temperature above freezing

  where (not_glacier .and. snow_melt > soil%snow ) 
     snow_melt  = soil%snow
     t_surf     = soil%temp(:,:,:,1) + (num - snow_melt/t_to_snow)/denom
     soil%snow  = 0.0
     soil%water = soil%water + snow_melt
  endwhere 

  ! in glaciated region, 
  !    if there is not enough snow, melt only what's there and then
  !     melt the glacier

  where (soil%glacier .and. snow_melt > soil%snow) 
     t_surf       = tfreeze
     glacier_melt = snow_melt - soil%snow
     snow_melt    = soil%snow
     soil%snow    = 0.0
  endwhere

  ! otherwise go ahead and use all of the potential snow melt, and leave the 
  !   surface temperature at freezing

  ! accumulate snow melt water into bucket in non-glacier regions

  where (not_glacier .and. snow_melt > 0.0 .and. snow_melt <= soil%snow)
     soil%water = soil%water + snow_melt
  endwhere

  where (soil%mask .and. snow_melt > 0 .and. snow_melt <= soil%snow)
     t_surf    = tfreeze
     soil%snow = soil%snow - snow_melt
  endwhere

  !  using this snow melt-modified surface temperature, correct all fluxes
  !   and compute temperature increment and new temperature for output 
  where (soil%mask)
     del_t(:,:,:,1)     = t_surf - soil%temp(:,:,:,1)
     soil%temp(:,:,:,1) = t_surf
     sens_new = sens + dhdt*del_t(:,:,:,1)
     evap_new = evap + dedt*del_t(:,:,:,1)
     flw_new  = flw  - drdt*del_t(:,:,:,1)
  endwhere

  where (ice_or_snow) sublim = evap_new

  ! completing the tridiagonal solver
  if( num_lev > 1) then
     do k = 1, num_lev-1
        where (soil%mask)
           del_t(:,:,:,k+1)     = e(:,:,:,k)*del_t(:,:,:,k) + f(:,:,:,k)
           soil%temp(:,:,:,k+1) = soil%temp(:,:,:,k+1) + del_t(:,:,:,k+1)
        endwhere
     end do
  end if

  do k=1, num_lev
     where (soil%mask .and. soil%fusion(:,:,:,k)>0.and.soil%temp(:,:,:,k)>tfreeze)
        phase_change = min (soil%fusion(:,:,:,k),(soil%temp(:,:,:,k)-tfreeze)*soil%rho_cap(:,:,:,k))
        soil%fusion(:,:,:,k) = soil%fusion(:,:,:,k) - phase_change
        soil%temp(:,:,:,k) = soil%temp(:,:,:,k) - phase_change/soil%rho_cap(:,:,:,k)
     elsewhere (soil%mask .and.soil%fusion(:,:,:,k)<soil%max_fusion(k) .and. soil%temp(:,:,:,k)<tfreeze) 
        phase_change = min (soil%max_fusion(k)-soil%fusion(:,:,:,k),(tfreeze-soil%temp(:,:,:,k))*soil%rho_cap(:,:,:,k))
        soil%fusion(:,:,:,k) = soil%fusion(:,:,:,k) + phase_change
        soil%temp(:,:,:,k) = soil%temp(:,:,:,k) + phase_change/soil%rho_cap(:,:,:,k)
     endwhere
  enddo

  !--- bucket hydrology  (snow_melt has already been taken care of) ----
  snow_on_ground = soil%snow > 0.0

  !--- first treat unglaciated cells...
  !
  ! tentative changes based on time-step evaporation and precipitation.
  ! if snow cover went negative during step, take necessary mass from
  ! soil (water) and re-zero snow. (this does not conserve latent heat?)
  ! then put excess soil water into soil drainage.
  !
  where(not_glacier .and. .not. snow_on_ground) 
     soil%water = soil%water + (lprec - evap_new)*soil%dt
     soil%snow  = fprec*soil%dt
     where(ice_or_snow) watsno = evap_new
  end where
  where (not_glacier .and. snow_on_ground)  
     soil%water = soil%water  + lprec*soil%dt 
     soil%snow  = soil%snow   + (fprec - evap_new)*soil%dt
     soil%water = soil%water  + min(soil%snow, 0.0) 
     watsno     = -min(soil%snow, 0.0)/soil%dt
     soil%snow  = max(soil%snow, 0.0)
  end where

  where (not_glacier) 
     soil%drainage = max((soil%water-soil%max_water)/soil%dt, 0.0)
     soil%water    = min( soil%water,soil%max_water)
  end where
  where (soil%lake)
     soil%drainage = soil%drainage + (soil%water - soil%max_water)/soil%dt
     soil%water= soil%max_water
  end where

  !--- then do the glaciated cells. soil water is not present, and
  !    glacier mass is not tracked.
  if (soil%conserve_glacier_snow_mass) then
      where(soil%glacier) soil%snow = soil%snow  + (fprec - evap_new)*soil%dt
    else
      where(soil%glacier .and. .not. snow_on_ground) &
           soil%snow  = fprec*soil%dt  ! seems to asssume evap_new is not<0 !!
      where (soil%glacier .and. snow_on_ground)  
         soil%snow = soil%snow  + (fprec - evap_new)*soil%dt
         soil%snow = max(soil%snow, 0.0)
      end where
    endif
  if (soil%conserve_glacier_mass) then
      where (soil%glacier) 
        soil%drainage = snow_melt/soil%dt + lprec
        soil%water    = soil%max_water ! to avoid spurious "bone dry" on glaciers
      endwhere
    else
      where (soil%glacier) 
        soil%drainage = (snow_melt + glacier_melt)/soil%dt + lprec
        soil%water    = soil%max_water ! to avoid spurious "bone dry" on glaciers
      endwhere
    endif

  !--- for all land cells, put excess snow into calving.
  where (soil%mask)
     soil%calving = max((soil%snow - soil%max_snow)/soil%dt, 0.0)
     soil%snow    = min(soil%snow, soil%max_snow)
  endwhere

  !--- accumulate drainage for transfer to groundwater on slow time step.
  !    similarly, accumulate calving
  where (soil%mask)
     soil%drainage_accum = soil%drainage_accum &
          + soil%drainage*soil%dt
     soil%calving_accum  = soil%calving_accum &
          + soil%calving*soil%dt
  endwhere

  !--- end of bucket hydrology -----------------------------------------

  ! increment time
  soil%Time = increment_time(soil%Time, int(soil%dt), 0)

  !--- override snow and water, if necessary ---------------------------
  call data_override('LND', 'water', soil%water, soil%Time)
  call data_override('LND', 'snow',  soil%snow,  soil%Time)

#ifdef SCM
  !--- for single column model keep top level --------------------------
  !--- temperature at observed value -----------------------------------
  if (do_specified_tskin .and. do_specified_land) then     
     soil%temp(:,:,:,1) = TSKIN
  end if
#endif

  !  compute new albedos
!! either include all the albedo components in this call, or define
!! the albedo components upon return.
  call update_land_properties_fast &
       (soil%snow, soil%temp(:,:,:,1), soil%mask, soil%albedo, soil%cover_type)
!      (soil%snow(:,:,:), soil%temp(:,:,:,1), soil%mask,   &
!        soil%albedo(:,:,:),  &
!        soil%albedo_vis_dir(:,:,:),  &
!        soil%albedo_nir_dir(:,:,:),  &
!        soil%albedo_vis_dif(:,:,:),  &
!        soil%albedo_nir_dif(:,:,:) ) 

!! FOR NOW, set all values to be the same:
     soil%albedo_vis_dir = soil%albedo
     soil%albedo_nir_dir = soil%albedo
     soil%albedo_vis_dif = soil%albedo
     soil%albedo_nir_dif = soil%albedo        

  ! update rivers
  call update_rivers_fast ( soil%rivers )

  call diag_fast(soil, lprec+fprec, fprec, evap_new, sublim, &
       snow_melt/soil%dt, &
       glacier_melt/soil%dt, watsno, sens_new, evap_new*latent, flw_new, fsw )

end subroutine update_soil_fast
! </SUBROUTINE>


! <SUBROUTINE NAME="update_soil_slow">

!   <OVERVIEW>
!     Slow time-scale soil state updater: groundwater dynamics and routing of 
!     river flows (and calving). 
!   </OVERVIEW>

!   <DESCRIPTION>
!     Slow time-scale soil state updater: groundwater dynamics and routing of 
!     river flows (and calving). Calculations include snow runoff, liquid water
!     runoff and surface runoff. Ground water is modified and the accumulated
!     values for the next interval are cleaned up. Calls to average_tiles and
!     update_rivers_slow.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call update_soil_slow(soil)
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine update_soil_slow(soil, blon, blat)

  type(soil_type), intent(inout) :: soil  ! state to update
  real, intent(inout) :: blon(:,:)
  real, intent(inout) :: blat(:,:)
!   </PUBLICROUTINE>

  ! ATTENTION: check and recheck to make sure area measures are consistent!

  ! ---- local vars ----------------------------------------------------------
  real, dimension(soil%is:soil%ie,soil%js:soil%je,size(soil%frac,3)):: &
       c0, c1, c2, & ! runoff calculation coefficients
       x             ! temporary value for calculations
  real :: runoff_w (soil%is:soil%ie,soil%js:soil%je) ! liquid runoff
  real :: runoff_s (soil%is:soil%ie,soil%js:soil%je) ! snow runoff
  integer :: model_yr, model_month, model_day
  integer :: model_hour, model_minute, model_second
  integer, save :: this_year = -1

  ! calculate "snow runoff"
  call average_tiles ( soil%calving_accum/soil%dt_slow, soil%frac, soil%mask, runoff_s )

  ! calculate liquid water runoff
  where (soil%mask)
     ! calculate surface runoff
     c0 = soil%dt_slow/soil%tau_groundwater
     c1 = exp(-c0)
     c2 = (1-c1)/c0
     x  = ((1-c1)*soil%groundwater + (1-c2)*soil%drainage_accum) / soil%dt_slow
     
     ! modify ground water
     soil%groundwater    = c1 * soil%groundwater + c2 * soil%drainage_accum

     ! clean up accumulated values for the next interval
     soil%drainage_accum = 0.
     soil%calving_accum  = 0.
  endwhere
  
  call average_tiles ( x, soil%frac, soil%mask, runoff_w)

! get the current year of the model
  call get_date(soil%Time, model_yr, model_month, model_day, model_hour, model_minute, model_second)

! initialize this_year
  if (this_year == -1) this_year = model_yr

! read the cover type forcing data every year
  if (model_yr /= this_year) then
     this_year = model_yr 
     call update_land_properties_slow ( &
         blon, blat, &
         soil%mask, soil%Time, soil%domain, &
         soil%glacier,         &
         soil%lake,            &
         soil%rough_mom,       &
         soil%rough_heat,      &
         soil%rough_scale,     &
         soil%tcon,            & 
         soil%rho_cap,         &
         soil%stomatal,        &
         soil%max_water,       &
         soil%tau_groundwater, &
         soil%max_snow,        &
         soil%cover_type )
  endif 

  call update_rivers_slow ( soil % Rivers, runoff_w, runoff_s )

  ! diagnostic section
  call diag_slow ( soil, runoff_w, runoff_s )
  
end subroutine update_soil_slow
! </SUBROUTINE>


! <SUBROUTINE NAME="update_soil_bnd_fast">

!   <OVERVIEW>
!     Updates boundary data for the atmosphere on the fast time-scale.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Updates boundary data for the atmosphere on the fast time-scale.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call update_soil_bnd_fast ( soil, bnd )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine update_soil_bnd_fast ( soil, bnd )

  type(soil_type),      intent(in)  :: soil ! current soil state
  type(land_data_type), intent(inout) :: bnd  ! output boundary data
!   </PUBLICROUTINE>

  bnd % t_surf     = soil % temp(:,:,:,1)
  bnd % t_ca       = soil % temp(:,:,:,1) ! vegetation can override this,
                                          ! if necessary
  bnd % albedo     = soil % albedo
  bnd % albedo_vis_dir = soil%albedo_vis_dir
  bnd % albedo_nir_dir = soil%albedo_nir_dir
  bnd % albedo_vis_dif = soil%albedo_vis_dif
  bnd % albedo_nir_dif = soil%albedo_nir_dif
  

end subroutine update_soil_bnd_fast
! </SUBROUTINE>


! <SUBROUTINE NAME="update_soil_bnd_slow">

!   <OVERVIEW>
!     Updates boundary data for the atmosphere on the slow time-scale.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Updates boundary data for the atmosphere on the slow time-scale.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call update_soil_bnd_slow ( soil, bnd )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine update_soil_bnd_slow ( soil, bnd )

  type(soil_type),      intent(in)  :: soil ! current soil state
  type(land_data_type), intent(inout) :: bnd  ! output boundary data
!   </PUBLICROUTINE>

  bnd % tile_size  = soil % frac
  bnd % mask       = soil % mask

  bnd % rough_mom  = soil % rough_mom
  bnd % rough_heat = soil % rough_heat
  bnd % rough_scale= soil % rough_scale

  call update_rivers_bnd_slow (soil%Rivers, bnd)

end subroutine update_soil_bnd_slow
! </SUBROUTINE>

! <SUBROUTINE NAME="diag_fast">

!   <OVERVIEW>
!     Calculate and return total amount of requested quantitiy per PE.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Compute and return stock values of mass, heat, etc.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call soil_stock_pe &
!     ( soil, index, value )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine soil_stock_pe(soil,index,value)
  type(soil_type), intent(in) :: soil      ! soil state
  integer        , intent(in)  :: index ! ID of the stock to calculate
  real           , intent(out) :: value ! calculated value of the stock

  ! ---- local vars
  integer :: i,j,k,l,num_lev

  select case(index)
  case(ISTOCK_WATER)
     value = 0
     do k = 1, soil%n_tiles
     do j = soil%js,soil%je
     do i = soil%is,soil%ie
        if(.not.soil%mask(i,j,k)) cycle
        value = value + soil%area(i,j)*soil%frac(i,j,k)*&
             (soil%water(i,j,k)+soil%groundwater(i,j,k)+soil%snow(i,j,k))
     enddo
     enddo
     enddo
  case(ISTOCK_HEAT)
    value = 0
    num_lev = size(soil%temp,4)
    do k = 1, soil%n_tiles
    do j = soil%js,soil%je
    do i = soil%is,soil%ie
       if(.not.soil%mask(i,j,k)) cycle
       do l = 1, num_lev
          value = value + soil%area(i,j)*soil%frac(i,j,k)*soil%dz(l)* &
            (-soil%fusion(i,j,k,l)&
             +soil%rho_cap(i,j,k,l)*(soil%temp(i,j,k,l)-tfreeze) )
       enddo
       value = value - hlf*soil%area(i,j)*soil%frac(i,j,k)*soil%snow(i,j,k)
    enddo
    enddo
    enddo
  case default 
    value = 0
  end select

end subroutine soil_stock_pe
! </SUBROUTINE>


! <SUBROUTINE NAME="diag_fast">

!   <OVERVIEW>
!     Sends data for diagnostics on fast time-scale.
!   </OVERVIEW>

!   <DESCRIPTION>
!     Sends data for diagnostics on fast time-scale.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call diag_fast &
!     ( soil, prec, fprec, evap, sublim, smelt, gmelt, sens, lhf, flw, fsw )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine diag_fast &
     ( soil, prec, fprec, evap, sublim, smelt, gmelt, watsno, sens, lhf, flw, fsw )

  type(soil_type), intent(in) :: soil      ! soil state
  real,            intent(in), dimension(:,:,:) :: &
       prec,  &   ! total precipitation, 
       fprec, &   ! frozen precipitation (snow)
       evap,  &   ! evaporation
       sublim,&   ! sublimation
       smelt, &   ! snow melt
       gmelt, &   ! glacier melt
       watsno,&   ! water stolen by snow to satisfy sublimation
       sens,  &   ! sensible heat flux, W/m2
       lhf,   &   ! latent heat flux, W/m2
       flw,   &   ! net longwave flux, W/m2
       fsw        ! shortwave flux, W/m2
!   </PUBLICROUTINE>

  ! ---- local vars ----------------------------------------------------------
  logical, pointer, save :: mask2 (:,:) =>NULL()
  logical :: used


  ! set up masks
  mask2 => soil%mask(:,:,1)


  ! send data to diagnostics manager ---

  ! tile-averaged data
  if ( id_water > 0 )    used = send_averaged_data &
       ( id_water,    soil%water,      soil%frac, soil%Time, mask=soil%mask )
  if ( id_snow  > 0 )    used = send_averaged_data &
       ( id_snow ,    soil%snow,       soil%frac, soil%Time, mask=soil%mask )
  if ( id_temp  > 0 )    used = send_averaged_data &
       ( id_temp ,    soil%temp,       soil%frac, soil%Time, mask=soil%mask )
  if ( id_frozen > 0 )    used = send_averaged_data &
       ( id_frozen ,  soil%fusion/hlf, soil%frac, soil%Time, mask=soil%mask )
  if ( id_albedo > 0 )   used = send_averaged_data &
       ( id_albedo,   soil%albedo,     soil%frac, soil%Time, mask=soil%mask )
  if ( id_albedo_vis_dir > 0 )   used = send_averaged_data &
       ( id_albedo_vis_dir,   soil%albedo_vis_dir,     soil%frac, soil%Time, mask=soil%mask )
  if ( id_albedo_nir_dir > 0 )   used = send_averaged_data &
       ( id_albedo_nir_dir,   soil%albedo_nir_dir,     soil%frac, soil%Time, mask=soil%mask )
  if ( id_albedo_vis_dif > 0 )   used = send_averaged_data &
       ( id_albedo_vis_dif,   soil%albedo_vis_dif,     soil%frac, soil%Time, mask=soil%mask )
  if ( id_albedo_nir_dif > 0 )   used = send_averaged_data &
       ( id_albedo_nir_dif,   soil%albedo_nir_dif,     soil%frac, soil%Time, mask=soil%mask )
  if ( id_drainage > 0 ) used = send_averaged_data &
       ( id_drainage, soil%drainage,   soil%frac, soil%Time, mask=soil%mask )
  if ( id_calving > 0 )  used = send_averaged_data &
       ( id_calving,  soil%calving,    soil%frac, soil%Time, mask=soil%mask )
  if ( id_precip > 0 )   used = send_averaged_data &
       ( id_precip,  prec,             soil%frac, soil%Time, mask=soil%mask )
  if ( id_snowfall > 0 ) used = send_averaged_data &
       ( id_snowfall, fprec,           soil%frac, soil%Time, mask=soil%mask )
  if ( id_evapor > 0 )   used = send_averaged_data &
       ( id_evapor,   evap,            soil%frac, soil%Time, mask=soil%mask )
  if ( id_sublim > 0 )   used = send_averaged_data &
       ( id_sublim,   sublim,          soil%frac, soil%Time, mask=soil%mask )
  if ( id_smelt > 0 )    used = send_averaged_data &
       ( id_smelt, smelt,              soil%frac, soil%Time, mask=soil%mask )
  if ( id_gmelt > 0 )    used = send_averaged_data &
       ( id_gmelt,    gmelt,           soil%frac, soil%Time, mask=soil%mask )
  if ( id_watsno > 0 )    used = send_averaged_data &
       ( id_watsno,    watsno,         soil%frac, soil%Time, mask=soil%mask )
  if ( id_sens  > 0 )    used = send_averaged_data &
       ( id_sens ,    sens,            soil%frac, soil%Time, mask=soil%mask )
  if ( id_lhf  > 0 )     used = send_averaged_data &
       ( id_lhf ,     lhf,             soil%frac, soil%Time, mask=soil%mask )
  if ( id_lw    > 0 )    used = send_averaged_data &
       ( id_lw   ,    flw,             soil%frac, soil%Time, mask=soil%mask )
  if ( id_sw    > 0 )    used = send_averaged_data &
       ( id_sw   ,    fsw,             soil%frac, soil%Time, mask=soil%mask )


end subroutine diag_fast
! </SUBROUTINE>


! <SUBROUTINE NAME="diag_slow">

!   <OVERVIEW>
!      Diagnostics on slow time-scale.
!   </OVERVIEW>

!   <DESCRIPTION>
!      Diagnostics on slow time-scale.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call diag_slow (soil, runoff_w, runoff_s )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine diag_slow (soil, runoff_w, runoff_s )

  type(soil_type), intent(in)  :: soil           ! current soil state
  real,            intent(in)  :: runoff_w(:,:)  ! liquid runoff
  real,            intent(in)  :: runoff_s(:,:)  ! snow runoff
!   </PUBLICROUTINE>

  ! --- local data ----------------------------------------------------------
  logical :: mask2(size(soil%frac,1),size(soil%frac,2))
  logical :: used
  real    :: dummy(size(soil%mask,1), size(soil%mask,2))

  mask2 = ANY(soil%mask(:,:,:),3)

  if (id_surface_runoff>0) &
     used = send_data (id_surface_runoff, runoff_w, soil%Time, mask=mask2)
  if (id_surface_runoff_snow>0) &
     used = send_data (id_surface_runoff_snow, runoff_s, soil%Time, mask=mask2)
  if (id_groundwater>0) &
     used = send_averaged_data &
     (id_groundwater, soil%groundwater, soil%frac, soil%Time, mask=soil%mask)
  if (id_cover_type>0) then
     dummy = soil%cover_type(:,:,1)
     used = send_data (id_cover_type, dummy, soil%Time, mask=mask2)
  endif

end subroutine
! </SUBROUTINE>


! <SUBROUTINE NAME="diag_static">

!   <OVERVIEW>
!      Diagnostics of the static variables.
!   </OVERVIEW>

!   <DESCRIPTION>
!      Diagnostics of the static variables.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call diag_static(soil, frac)
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine diag_static(soil, frac)

  type(soil_type), intent(in) :: soil            ! soil state to diagnose
  real,            intent(in) :: frac(:,:)       ! fraction of land in each cell
!   </PUBLICROUTINE>

  ! --- local data ----------------------------------------------------------
  real     :: dummy(size(soil%frac,1),size(soil%frac,2))
  logical  :: mask2(size(soil%frac,1),size(soil%frac,2))
  logical  :: mask3(size(soil%frac,1),size(soil%frac,2),size(soil%tcon,4))
  logical  :: used

  ! --- update to averaged data later

  mask2 = ANY(soil%mask(:,:,:),3)
  mask3 = SPREAD(mask2,3,size(mask3,3))

  dummy = 0.
  if ( id_area > 0 ) &
       used = send_data ( id_area, soil%area(:,:), soil%Time, mask=mask2 )
  if ( id_lfrac > 0 ) &
       used = send_data ( id_lfrac, frac(:,:), soil%Time, mask=mask2 )
  where (soil%glacier(:,:,1)) dummy = 1.
  if ( id_glacier > 0 ) &
       used = send_data ( id_glacier, dummy(:,:), soil%Time, mask=mask2 )
  if ( id_tcon > 0 )&
       used = send_data ( id_tcon, soil%tcon(:,:,1,:), soil%Time, mask=mask3 )
  if ( id_rho_cap > 0 )&
       used = send_data ( id_rho_cap, soil%rho_cap(:,:,1,:), soil%Time, &
       mask=mask3 )
  if ( id_stomatal > 0 )&
       used = send_data ( id_stomatal, soil%stomatal(:,:,1), soil%Time, &
       mask=mask2 )
  if ( id_max_water > 0 )&
       used = send_data ( id_max_water, soil%max_water(:,:,1), soil%Time, &
       mask=mask2 )
  if ( id_rough_mom > 0 )&
       used = send_data ( id_rough_mom, soil%rough_mom(:,:,1), soil%Time, &
       mask=mask2 )
  if ( id_rough_heat > 0 )&
       used = send_data ( id_rough_heat, soil%rough_heat(:,:,1), soil%Time, &
       mask=mask2 )
  if ( id_tau_gw > 0 )&
       used = send_data ( id_tau_gw, soil%tau_groundwater(:,:,1), soil%Time, &
       mask=mask2 )
  if ( id_hlf > 0 )&
       used = send_data ( id_hlf, hlf, soil%Time )
  if ( id_hlv > 0 )&
       used = send_data ( id_hlv, hlv, soil%Time )

end subroutine diag_static
!   </SUBROUTINE>



! <FUNCTION NAME="send_averaged_data2d" INTERFACE="send_averaged_data">

!   <OVERVIEW>
!     Averages the data over tiles and sends them to diagnostics. 
!   </OVERVIEW>

!   <DESCRIPTION>
!     Averages the data over tiles and sends them to diagnostics. 
!   </DESCRIPTION>

!   <TEMPLATE>
!     value=send_averaged_data2d ( id, field, area, time, mask )
!   </TEMPLATE>

!   <PUBLICROUTINE INTERFACE="send_averaged_data">
function send_averaged_data2d ( id, field, area, time, mask )

  integer, intent(in)          :: id             ! id of the diagnostic field 
  real,    intent(in)          :: field(:,:,:)   ! field to average and send
  real,    intent(in)          :: area (:,:,:)   ! area of tiles (== averaging 
                                                 ! weights), arbitrary units
  type(time_type), intent(in)  :: time           ! current time
  logical, intent(in),optional :: mask (:,:,:)   ! land mask
!   </PUBLICROUTINE>

  ! --- return value ---------------------------------------------------------
  logical                      :: send_averaged_data2d

  ! --- local vars -----------------------------------------------------------
  real  :: out(size(field,1), size(field,2))

  call average_tiles( field, area, mask, out )
  send_averaged_data2d = send_data( id, out, time, mask=ANY(mask,DIM=3) )
end function send_averaged_data2d
!   </FUNCTION>


! <FUNCTION NAME="send_averaged_data3d" INTERFACE="send_averaged_data">

!   <OVERVIEW>
!     Averages the data over tiles and sends them to diagnostics. 
!   </OVERVIEW>

!   <DESCRIPTION>
!     Averages the data over tiles and sends them to diagnostics. 
!   </DESCRIPTION>

!   <TEMPLATE>
!     value=send_averaged_data3d ( id, field, area, time, mask )
!   </TEMPLATE>

!   <PUBLICROUTINE INTERFACE="send_averaged_data">
function send_averaged_data3d( id, field, area, time, mask )

  integer, intent(in)          :: id              ! id of the diagnostic field
  real,    intent(in)          :: field(:,:,:,:)  ! (lon, lat, tile, lev) field 
                                                  ! to average and send
  real,    intent(in)          :: area (:,:,:)    ! (lon, lat, tile) tile areas 
                                                  ! ( == averaging weights), 
                                                  ! arbitrary units
  type(time_type), intent(in)  :: time            ! current time
  logical, intent(in),optional :: mask (:,:,:)    ! (lon, lat, tile) land mask
!   </PUBLICROUTINE>

  ! --- return value ---------------------------------------------------------
  logical  :: send_averaged_data3d     

  ! --- local vars -----------------------------------------------------------
  real    :: out(size(field,1), size(field,2), size(field,4))
  logical :: mask3(size(field,1), size(field,2), size(field,4))
  integer :: it

  do it=1,size(field,4)
     call average_tiles( field(:,:,:,it), area, mask, out(:,:,it) )
  enddo

  mask3(:,:,1) = ANY(mask,DIM=3)
  do it = 2, size(field,4)
     mask3(:,:,it) = mask3(:,:,1)
  enddo

  send_averaged_data3d = send_data( id, out, time, mask=mask3 )
end function send_averaged_data3d
!   </FUNCTION>


! <SUBROUTINE NAME="average_tiles">

!   <OVERVIEW>
!     Average 2-dimensional field over tiles.
!   </OVERVIEW>

!   <DESCRIPTION>
!    Average 2-dimensional field over tiles.
!   </DESCRIPTION>

!   <TEMPLATE>
!     call average_tiles ( x, area, mask, out )
!   </TEMPLATE>

!   <PUBLICROUTINE>
subroutine average_tiles ( x, area, mask, out )

  real,    intent(in)  :: x   (:,:,:) ! (lon, lat, tile) field to average
  real,    intent(in)  :: area(:,:,:) ! (lon, lat, tile) fractional area
  logical, intent(in)  :: mask(:,:,:) ! (lon, lat, tile) land mask
  real,    intent(out) :: out (:,:)   ! (lon, lat)       result of averaging
!   </PUBLICROUTINE>

! --- local vars --------------------------------------------------------------
  integer  :: it                      ! iterator over tile number
  real     :: s(size(x,1),size(x,2))  ! area accumulator

  s(:,:)   = 0.0
  out(:,:) = 0.0

  do it = 1,size(area,3)
     where (mask(:,:,it)) 
        out(:,:) = out(:,:) + x(:,:,it)*area(:,:,it)
        s(:,:)   = s(:,:) + area(:,:,it)
     endwhere
  enddo

  where( s(:,:) > 0 ) &
       out(:,:) = out(:,:)/s(:,:)

end subroutine average_tiles
! </SUBROUTINE>

end module soil_mod

!FDOC_TAG_GFDL
module strat_cloud_mod

! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Stephen Klein
! </CONTACT>
!/"/>q
! <OVERVIEW>
!   Code to compute time tendencies of stratiform clouds and diagnose
!   rain and snow flux with prognostic scheme.
!   
! </OVERVIEW>
! <DESCRIPTION>
!
!
!       The prognostic scheme returns the time tendencies of liquid,
!       ice, and saturated volume fraction that are suspended in 
!       stratiform clouds.  The scheme diagnoses the fluxes of rain
!       and snow in saturated and unsaturated areas.
!
!       The prognostic cloud scheme is responsible for determing
!       cloud volume fractions, condensed water tendencies, and
!       the stratiform precipitation rate.  It includes processes
!       for evaporation, condensation, deposition, and sublimation
!       of cloud water, conversion of cloud water to precipitation,
!       evaporation of falling precipitation, the bergeron-findeisan 
!       process, freezing of cloud liquid, accretion of cloud water 
!       by precipitation, and melting of falling precipitation.
!
!       This scheme is based on the experience the author had 
!       at the ECMWF in 1997. The saturated volume fraction formalism 
!       and type of solution follow directly from the scheme of Tiedtke
!       (1993): Monthly Weather Review, Volume 121, pages 3040-3061.
!       The form of most of the microphysics follows Rotstayn , 1997:
!       Quart. J. Roy. Met. Soc. vol 123, pages 1227-1282. The partial
!       precipitation area formulism follows Jakob and Klein, 2000:
!       Quart. J. Roy. Met. Soc. vol 126, pages 2525-2544. 
!
!       The statistical cloud scheme treatment, which is used as
!       a replacement for the Tiedtke cloud fraction scheme, is based
!       on a number of publications: Tompkins, A., 2002: J. Atmos. 
!       Sci., 59, 1917-1942, Klein et al., 2005: J. Geophys. Res., 
!       110, D15S06, doi:10.1029/2004JD005017. 
! </DESCRIPTION>
!

! <DATASET NAME="strat_cloud.res">
!   native format of the restart file
! </DATASET>
! <DATASET NAME="strat_cloud.res.nc">
!   netcdf format of the restart file
! </DATASET>


! <INFO>
!   <REFERENCE>           
!The saturation volume fraction formalism comes from:
!
!Tiedtke, M., 1993: Representation of clouds in large-scale models.
! Mon. Wea. Rev., 121, 3040-3061.
!
! </REFERENCE>
!   <REFERENCE>           
!The form of most of the microphysics follows:
!
!Rotstayn, L., 1997: A physically based scheme for the treatment of
! stratiform clouds and precipitation in large-scale models. I:
! Description and evaluation of microphysical processes. Quart. J.
! Roy. Met. Soc. 123, 1227-1282. 
! </REFERENCE>
!   <COMPILER NAME="">     </COMPILER>
!   <PRECOMP FLAG="">      </PRECOMP>
!   <LOADER FLAG="">       </LOADER>
!   <TESTPROGRAM NAME="">  </TESTPROGRAM>
!   <BUG>                  </BUG>
!   <NOTE> 
!  1. qmin should be chosen such that the range of {qmin, max(qa,ql
!     ,qi)} is resolved by the precision of the numbers used. (default =
!     1.E-10)
!   </NOTE>

!   <NOTE> 
!  2. Dmin will be MACHINE DEPENDENT and occur when
!   </NOTE>

!   <NOTE> 
!    a. 1. -exp(-Dmin) = 0. instead of Dmin in the limit of very small
!       Dmin
!   </NOTE>

!   AND

!   <NOTE> 
!    b. 1. - exp(-D) < D for all D > Dmin
!   </NOTE>
!   <FUTURE>               </FUTURE>

! </INFO>

use mpp_mod,                   only : mpp_clock_id, mpp_clock_begin, &
                                      mpp_clock_end, CLOCK_LOOP,  &
                                      input_nml_file
use fms_mod,                   only : file_exist, open_namelist_file,&
                                      open_file, error_mesg, FATAL, NOTE, &
                                      mpp_pe, mpp_root_pe, close_file, &
                                      read_data, write_data, stdlog,  &
                                      open_restart_file, open_ieee32_file,&
                                      mpp_error, check_nml_error,  &
                                      write_version_number, stdout
use fms_io_mod,                only : get_restart_io_mode, restore_state, &
                                      register_restart_field,  &
                                      restart_file_type, save_restart, &
                                      get_mosaic_tile_file
use constants_mod,             only : rdgas, rvgas, hlv, hls, hlf, cp_air, grav
use cloud_rad_mod,             only : cloud_rad_init
use diag_manager_mod,          only : register_diag_field, send_data
use time_manager_mod,          only : time_type, get_date, get_time
use rad_utilities_mod,         only : aerosol_type
use microphysics_mod,          only : microphysics_init, microphysics, &
                                      microphysics_end
use nc_cond_mod,               only:  nc_cond, nc_cond_init,  nc_cond_end
use polysvp_mod,               only : polysvp_init, polysvp_end, &
                                      compute_qs_a
use aerosol_cloud_mod,         only:  aerosol_cloud, aerosol_cloud_init, &
                                      aerosol_cloud_end
use strat_cloud_utilities_mod, only:  strat_cloud_utilities_init, &
                                      diag_id_type, diag_pt_type, &
                                      strat_nml_type, atmos_state_type, &
                                      particles_type, cloud_state_type, &
                                      strat_constants_type, &
                                      cloud_processes_type,  &
                                      precip_state_type
use strat_netcdf_mod,          only:  strat_netcdf, strat_netcdf_init, &
                                      strat_netcdf_end
use strat_cloud_legacy_mod,    only : strat_cloud_legacy_init,  &
                                      strat_cloud_legacy,   &
                                      strat_cloud_legacy_end
use check_nan_mod,             only : check_nan_init, check_nan


implicit none
private

!------------------------------------------------------------------------
!---interfaces-----------------------------------------------------------

!       The module contains the following  public interfaces:
!
!       strat_cloud_init       read namelist file, open logfile, initialize
!                              constants and fields, read restart file
!
!       strat_cloud            calls the legacy strat_cloud routine to 
!                              perform the calculations of the cloud scheme
!                              (strat_cloud_legacy_mod)
!
!       strat_cloud_new        rewritten version of strat_cloud  supporting
!                              double moment microphysics (rewritten by
!                              M. Salzmann and R. Hemler)
!
!       strat_cloud_end        writes out restart data to a restart file.
!
!       strat_cloud_sum        sum cloud scheme variables over time
!
!       strat_cloud_avg        return time average of summed cloud scheme 
!                              variables
!
!       do_strat_cloud         logical function, is the scheme on?
!
!       strat_cloud_restart    writes  module restart files
!
!-----------------------------------------------------------------------
!
!       The module contains the following  private subroutines:
!
!        fill_nml_variable     put all nml variables into a strat_nml_type
!                              variable for use by other modules
!
!        strat_debug           debug routine for additional output
!
!        inpose_realizability  make sure input cloud tracer fields are 
!                              physically realizable  
!
!        strat_alloc           allocate components of derived types used 
!                              in module
!
!        strat_dealloc         deallocate components of derived types used 
!                              in module
!
!------------------------------------------------------------------------

public  strat_cloud_init, strat_cloud, strat_cloud_new, strat_cloud_end,  &
        strat_cloud_sum, strat_cloud_avg, do_strat_cloud,  &
        strat_cloud_restart, strat_cloud_time_vary
private fill_nml_variable, strat_debug, impose_realizability, strat_alloc,&
        strat_dealloc


!------------------------------------------------------------------------
!---version number-------------------------------------------------------

Character(len=128) :: Version = '$Id: strat_cloud.F90,v 20.0 2013/12/13 23:22:09 fms Exp $'
Character(len=128) :: Tagname = '$Name: tikal $'

!------------------------------------------------------------------------
!---namelist-------------------------------------------------------------

# include "strat_nml.h"

!------------------------------------------------------------------------
!----module variables----------------------------------------------------

!-----------------------------------------------------------------------
!    accumulation arrays for fields that may be time averaged
!-----------------------------------------------------------------------
real,    allocatable, dimension (:,:,:) :: qlsum, qisum, cfsum
integer, allocatable, dimension (:,:)   :: nsum

!-----------------------------------------------------------------------
!    derived types present for duratioon of run.         
!-----------------------------------------------------------------------
type(strat_nml_type), save       :: Nml
type(strat_constants_type), save :: Constants

!------------------------------------------------------------------------
!     ------ constants used by the scheme -------
!-----------------------------------------------------------------------
real, parameter :: d608 = (rvgas - rdgas)/rdgas
  

!-----------------------------------------------------------------------
!    variables related to netcdf diagnostics.
!-----------------------------------------------------------------------
INTEGER            :: n_diag_4d, n_diag_4d_kp1
TYPE(diag_id_type) :: diag_id
TYPE(diag_pt_type) :: diag_pt
character(len=5)   :: mod_name = 'strat'
real               :: missing_value = -999.

!-----------------------------------------------------------------------
!    variables related to restart files.
!-----------------------------------------------------------------------
type(restart_file_type), pointer, save :: Str_restart => NULL()
type(restart_file_type), pointer, save :: Til_restart => NULL()
logical                                :: in_different_file = .false.
integer, dimension(1)                  :: restart_versions = (/ 1 /)
integer                                :: vers

!-----------------------------------------------------------------------
!    variables related to debugging options.
!-----------------------------------------------------------------------
integer :: otun               ! file where debug output is written
logical :: debugo0 = .false.  ! small output
logical :: debugo1 = .false.  ! .true. !morr 
logical :: debugo3 = .false. 
logical :: debugo4 = .false.  ! when true, nrefuse will be output
integer :: ncall   = 1        ! timestep counter of calls to strat_cloud

!-----------------------------------------------------------------------
!    variables related to code timing.         
!-----------------------------------------------------------------------
integer   :: sc_loop, sc_pre_loop, sc_post_loop
integer   :: sc_micro, sc_init, sc_qs, sc_realiz, sc_aero, &
             sc_nccond, sc_after, sc_end

!-----------------------------------------------------------------------
!    miscellaneous variables 
!-----------------------------------------------------------------------
logical        :: do_average = .false. ! time average stratiform cloud 
                                       ! fields before computing radiation?
logical,PUBLIC :: strat_cloud_on = .false.
                                       ! is the stratiform cloud scheme
                                       ! operating? this variable used by 
                                       ! vert_turb_driver_mod; should
                                       ! change code to use function
                                       ! do_strat_cloud()
integer        :: overlap =  2         ! value of the overlap parameter
                                       ! obtained from cloud_rad_mod.
                                       ! overlap = 1 is maximum-random
                                       ! overlap = 2 is random
                                       ! RSH:specification method should be
                                       ! changed
logical :: module_is_initialized = .false.
                                       ! current module is initialized ?
logical :: running_old_code            ! we are running the legacy
                                       ! strat_cloud code (as opposed to
                                       ! the newer version compatible with
                                       ! double-moment microphysics)


CONTAINS



!#######################################################################

! <SUBROUTINE NAME="strat_cloud_init">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!       Initializes strat_cloud.  Reads namelist, calls cloud_rad_init,
!       reads restart (if present), initializes netcdf output.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call strat_cloud_init(axes,Time,idim,jdim,kdim)
!                
!  </TEMPLATE>
!  <IN NAME="axes" TYPE="integer">
!       Axes integer vector used for netcdf initialization.
!  </IN>
!  <IN NAME="Time" TYPE="time_type">
!       Time type variable used for netcdf.
!  </IN>
!  <IN NAME="idim" TYPE="integer">
!       Size of first array (usually longitude) dimension.
!  </IN>
!  <IN NAME="jdim" TYPE="integer">
!       Size of second array (usually latitude) dimension.
!  </IN>
!  <IN NAME="kdim" TYPE="integer">
!       Size of vertical array (usually height) dimension.
!  </IN>
! </SUBROUTINE>
!
!------------------------------------------------------------------------
subroutine strat_cloud_init (axes, Time, idim, jdim, kdim,  &
                                                     do_legacy_strat_cloud)

!------------------------------------------------------------------------
!    this subroutine reads the namelist file, opens a logfile, 
!    and initializes the physical constants of the routine.
!------------------------------------------------------------------------

integer,          intent(in)            :: idim, jdim, kdim, axes(4)
type(time_type),  intent(in)            :: Time
logical,          intent(in), optional  :: do_legacy_strat_cloud

!-----------------------------------------------------------------------
!
!    axes           integers corresponding to the
!                   x,y,z,z_half axes types
!
!    Time           time type variable
!
!    idim,jdim      number of points in first 
!                   and second dimensions
!
!    kdim           number of points in vertical
!                   dimension
!
!    do_legacy_strat_cloud
!                   activate the older version of the strat_cloud module
!                   rather than the latest ?
!------------------------------------------------------------------------

!------------------------------------------------------------------------
!---local variables------------------------------------------------------

      integer                          :: id_restart
      integer                          :: unit,io,ierr, logunit
      integer                          :: vers2
      character(len=4)                 :: chvers
      character(len=64)                :: restart_file, fname
      character(len=64)                :: otname =  'debug_strt_cld.txt'

!-----------------------------------------------------------------------
!
!       unit           unit number for namelist and restart file
!
!       io             internal variable for reading of namelist file
!
!------------------------------------------------------------------------

!------------------------------------------------------------------------ 
!    if module is already initialized, return.
!------------------------------------------------------------------------ 
      if (module_is_initialized) return

!----------------------------------------------------------------------- 
!    process namelist.
!-----------------------------------------------------------------------  
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=strat_cloud_nml, iostat=io)
      ierr = check_nml_error(io,'strat_cloud_nml')
#else
      if ( file_exist('input.nml')) then
        unit = open_namelist_file ()
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=strat_cloud_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'strat_cloud_nml')
        enddo
10      call close_file (unit)
      endif
#endif

!----------------------------------------------------------------------- 
!    write version and namelist to stdlog.
!-----------------------------------------------------------------------  
      call write_version_number(version, tagname)
      logunit = stdlog()
      if ( mpp_pe() == mpp_root_pe() )  &
                    write (logunit, nml=strat_cloud_nml)

!----------------------------------------------------------------------- 
!    obtain info on form of restart file to be written.
!-----------------------------------------------------------------------  
      call get_restart_io_mode (do_netcdf_restart)

!-----------------------------------------------------------------------
!    check for acceptable namelist values:
!    qthalfwidth must be greater than 0.001
!    nsublevels must be greater than 0
!-----------------------------------------------------------------------
      if (qthalfwidth .lt. 1.e-03) then
        call error_mesg ( 'strat_cloud_mod', &
                       'qthalfwidth must be greater than 0.001', FATAL)
      endif
      if (nsublevels .lt. 1) then
        call error_mesg ( 'strat_cloud_mod', &
                            'nsublevels must be greater than 0', FATAL)
      endif

!------------------------------------------------------------------------
!    call subroutine to place nml variables in strat_nml_type variable.
!------------------------------------------------------------------------
      call fill_nml_variable

!------------------------------------------------------------------------
!    define logicals defining microphysics scheme which is active.
!------------------------------------------------------------------------
      if (trim(microphys_scheme) =='rotstayn_klein') then
        Constants%do_rk_microphys = .true.
        Constants%do_mg_microphys = .false.
        Constants%do_mg_ncar_microphys = .false.
        Constants%do_predicted_ice_number = .false.
      else if (trim(microphys_scheme) == 'morrison_gettelman') then
        Constants%do_rk_microphys = .false.
        Constants%do_mg_microphys = .true.
        Constants%do_mg_ncar_microphys = .false.
        Constants%do_predicted_ice_number = .true.
      else if (trim(microphys_scheme) == 'mg_ncar') then
        Constants%do_rk_microphys = .false.
        Constants%do_mg_microphys = .false.
        Constants%do_mg_ncar_microphys = .true.
        Constants%do_predicted_ice_number = .true.
      else
        call error_mesg ('strat_cloud_init', &
         'invalid expression supplied for nml variable microphys_scheme', &
                                                                    FATAL)
      endif
   
!------------------------------------------------------------------------
!    define logicals defining macrophysics scheme which is active.
!------------------------------------------------------------------------
     if (trim(macrophys_scheme) == 'tiedtke') then
       Constants%tiedtke_macrophysics = .true.
     else
       Constants%tiedtke_macrophysics = .false.
     endif

!------------------------------------------------------------------------
!    define logicals defining aerosol activation scheme which is active.
!------------------------------------------------------------------------
     if (trim(aerosol_activation_scheme) == 'dqa') then
       Constants%dqa_activation = .true.
       Constants%total_activation = .false.
     else if (trim(aerosol_activation_scheme) == 'total') then
       Constants%dqa_activation = .false.
       Constants%total_activation = .true.
     else
       call error_mesg ('strat_cloud_init',   &
           'invalid value for aerosol_activation_scheme specified', FATAL)
     endif

!-----------------------------------------------------------------------
!    pass values of qmin, N_land, N_ocean and as needed, do_liq_num and 
!    do_mg_microphys to cloud_rad_mod for use there. retrieve the value of
!    overlap from cloud_rad_mod for use here. this is done to assure 
!    consistency between these values in these two modules. (this process
!    should be changed to avoid potential problems --RSH)
!-----------------------------------------------------------------------
      if (do_liq_num) then
        if (Constants%do_rk_microphys) then 
          call cloud_rad_init (axes, Time, qmin_in=qmin, N_land_in=N_land,&
                               N_ocean_in=N_ocean,  &
                               prog_droplet_in=do_liq_num,  &
                               overlap_out=overlap)
        else if (Constants%do_mg_microphys .or.  &
                                     Constants%do_mg_ncar_microphys) then
          call cloud_rad_init (axes, Time, qmin_in=qmin, N_land_in=N_land,&
                               N_ocean_in=N_ocean,  &
                               prog_droplet_in=do_liq_num,  &
                               overlap_out=overlap,  &
                               qcvar_in = Nml%qcvar, &
                          prog_ice_num_in=Constants%do_mg_microphys .or.&
                                            Constants%do_mg_ncar_microphys)
        endif
      else
        call cloud_rad_init (axes, Time, qmin_in=qmin, N_land_in=N_land,&
                             N_ocean_in=N_ocean, overlap_out=overlap)
      endif

!-------------------------------------------------------------------------
!    save the returned value of overlap in a derived type variable
!-------------------------------------------------------------------------
      Constants%overlap = overlap

!-----------------------------------------------------------------------
!    set logicals indicating that strat_cloud is active and whether the
!    legacy or new version is being executed.
!-----------------------------------------------------------------------
      strat_cloud_on = .TRUE.
      if (present(do_legacy_strat_cloud)) then
        if (do_legacy_strat_cloud) then
          running_old_code = .true.
        else
          running_old_code = .false.
        endif
      else
        running_old_code = .true.
      endif

!-----------------------------------------------------------------------
!    allocate the arrays needed to accumulate cloud fields which may need
!    to be time-averaged. these fields are also saved to the restart file.
!-----------------------------------------------------------------------
      allocate (nsum(idim, jdim),      &
                qlsum(idim,jdim,kdim), &
                qisum(idim,jdim,kdim), &
                cfsum(idim,jdim,kdim)  )

!------------------------------------------------------------------------
!    register the restart fields to be written and/or read.
!------------------------------------------------------------------------- 
      if (do_netcdf_restart) then
        restart_file = 'strat_cloud.res.nc'
        call get_mosaic_tile_file (restart_file, fname, .false. ) 
        allocate(Str_restart)
        if (trim(restart_file) == trim(fname)) then
          Til_restart => Str_restart
          in_different_file = .false.
        else
          in_different_file = .true.
          allocate(Til_restart)
        endif
        id_restart = register_restart_field  &
             (Str_restart, restart_file, 'vers', vers, no_domain = .true.)
        id_restart = register_restart_field  &
                             (Til_restart, restart_file, 'nsum', nsum)
        id_restart = register_restart_field  &
                             (Til_restart, restart_file, 'qlsum', qlsum)
        id_restart = register_restart_field  &
                             (Til_restart, restart_file, 'qisum', qisum)
        id_restart = register_restart_field  &
                             (Til_restart, restart_file, 'cfsum', cfsum)
      endif

!-----------------------------------------------------------------------
!    see if restart file exists
!-----------------------------------------------------------------------
      if (file_exist('INPUT/strat_cloud.res.nc') ) then
        if (mpp_pe() == mpp_root_pe() )    &
                   call mpp_error ('strat_cloud_mod', &
             'Reading netCDF formatted restart file:  &
                                          &INPUT/strat_cloud.res.nc', NOTE)
!------------------------------------------------------------------------
!    make sure do_netcdf_restart is true.
!------------------------------------------------------------------------
        if (.not. do_netcdf_restart)   &
                     call error_mesg ('strat_cloud_mod', &
                         'netcdf format restart file &
                            &INPUT/strat_cloud.res.nc exist, but  &
                                    &do_netcdf_restart is false.', FATAL)
        call restore_state (Str_restart)
        if (in_different_file) call restore_state (Til_restart)
      else
        if (file_exist('INPUT/strat_cloud.res')) Then
          unit = open_restart_file (FILE='INPUT/strat_cloud.res', &
                                                            ACTION='read')
          if (mpp_pe() == mpp_root_pe() ) call mpp_error   &
                                 ('strat_cloud_mod', &
                           'Reading native formatted restart file.', NOTE)
          read (unit, iostat=io, err=142) vers, vers2
142       continue
          if (io == 0) then

!--------------------------------------------------------------------
!    if eor is not encountered, then the file includes radturbten.
!    that data is not needed, simply continue by reading next record.
!--------------------------------------------------------------------
            call error_mesg ('strat_cloud_mod',  &
                    'reading pre-version number strat_cloud.res file, &
                                              &ignoring radturbten', NOTE)

!--------------------------------------------------------------------
!    the file is a newer one with a version number included. read the 
!    version number. if it is not a valid version, stop execution with
!    a message.
!--------------------------------------------------------------------
          else
            if (.not. any(vers == restart_versions) ) then
              write (chvers, '(i4)') vers
              call error_mesg ('strat_cloud_mod',  &
                    'restart version ' // chvers//' cannot be read &
                             &by this version of strat_cloud_mod.', FATAL)
            endif
          endif
          call read_data (unit, nsum)
          call read_data (unit, qlsum)
          call read_data (unit, qisum)
          call read_data (unit, cfsum)
          call close_file (unit)
        else
          qlsum=0.0; qisum=0.0; cfsum=0.0; nsum=0
        endif
      endif
      vers = restart_versions(size(restart_versions(:)))

!-----------------------------------------------------------------------
!    call strat_netcdf_init to set up the netcdf diagnostic output
!    requested via the diag_table. 
!-----------------------------------------------------------------------
      call strat_netcdf_init (axes, Time, diag_id, diag_pt, n_diag_4d, &
                              n_diag_4d_kp1)

!-----------------------------------------------------------------------
!    initialize the other modules which are used by strat_cloud_mod.
!-----------------------------------------------------------------------
      call strat_cloud_utilities_init
      if (running_old_code) then
        call strat_cloud_legacy_init (do_pdf_clouds)
      else
        call microphysics_init (Nml)
        call aerosol_cloud_init (Constants)
        call nc_cond_init (do_pdf_clouds)
        call polysvp_init
        call check_nan_init
      endif

!-----------------------------------------------------------------------
!    set up clocks to time various code portions.
!-----------------------------------------------------------------------
      sc_pre_loop = mpp_clock_id ('strat_cloud: vertical loop setup', &
                                                        grain=CLOCK_LOOP)
      sc_loop = mpp_clock_id ('strat_cloud: main vertical level loop',&
                                                         grain=CLOCK_LOOP)
      sc_post_loop = mpp_clock_id ('strat_cloud: diagnostic send-data', &
                                                         grain=CLOCK_LOOP)
      sc_init = mpp_clock_id ('strat_cloud: start of routine', &
                                                          grain=CLOCK_LOOP)
      sc_qs = mpp_clock_id ('strat_cloud: qs call',  grain=CLOCK_LOOP)
      sc_realiz = mpp_clock_id ('strat_cloud: realizability',  &
                                                         grain=CLOCK_LOOP)
      sc_aero = mpp_clock_id ('strat_cloud: aerosol', grain=CLOCK_LOOP)
      sc_nccond = mpp_clock_id ('strat_cloud: nccond', grain=CLOCK_LOOP)
      sc_after = mpp_clock_id ('strat_cloud: after nccond',  &
                                                         grain=CLOCK_LOOP)
      sc_micro = mpp_clock_id ('strat_cloud: microphysics', &
                                                         grain=CLOCK_LOOP)
      sc_end = mpp_clock_id ('strat_cloud: end of routine',  &
                                                          grain=CLOCK_LOOP)

!-------------------------------------------------------------------------
!    if any debugging is desired, open a file to hold the output. set
!    debugging at level o0 to occur only on pe 0.
!-------------------------------------------------------------------------
      if ((debugo .or. debugo0 .or.  debugo1 .or. debugo3)) then
        otun = open_file (otname, threading = 'multi', action = 'append')
      else 
        otun = 0
      endif
      if ( mpp_pe() .NE. 0 ) then
        debugo0 = .FALSE.
      endif

!------------------------------------------------------------------------
!    mark the module as initialized.
!------------------------------------------------------------------------
      module_is_initialized = .true.

!-----------------------------------------------------------------------


end subroutine strat_cloud_init



!#######################################################################

!-----------------------------------------------------------------------
! <SUBROUTINE NAME="strat_cloud">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!       
!  </DESCRIPTION>
!  <TEMPLATE>
! subroutine strat_cloud (Time,is,ie,js,je,dtcloud,pfull,phalf,radturbten2,
!                         T,qv,ql,qi,qa,omega,Mc,diff_t,LAND,              
!                         ST,SQ,SL,SI,SA,rain3d,snow3d,snowclr3d,surfrain, 
!                         surfsnow,qrat,ahuco,limit_conv_cloud_frac,MASK, 
!                         qn, Aerosol, SN)
!
!  </TEMPLATE>
!  <IN NAME="Time" TYPE="time_type">
!         Time
!  </IN>
!  <IN NAME="is" TYPE="integer">
!         Index of starting point in the longitude direction of the current
!         physics window               
!  </IN>
!  <IN NAME="ie" TYPE="integer">
!         Index of ending point in the longitude direction of the current  
!         physics window
!  </IN>
!  <IN NAME="js" TYPE="integer">
!         Index of starting point in the latitude direction of the current
!         physics window
!  </IN>
!  <IN NAME="je" TYPE="integer">
!         Index of ending point in the latitude direction of the current
!         physics window
!  </IN>
!  <IN NAME="dtcloud" TYPE="real">
!         Physics time step (sec)
!  </IN>
!  <IN NAME="pfull" TYPE="real">
!         Pressure on model full levels (Pa)
!  </IN>
!  <IN NAME="phalf" TYPE="real">
!         Pressure on model half levels (Pa)
!  </IN>
!  <IN NAME="radturbten2" TYPE="real">
!         Sum of the tendencies of temperature from turbulence and 
!         radiation schemes (K/s)
!  </IN>
!  <IN NAME="T" TYPE="real">
!         Temperature (K)         
!  </IN>
!  <IN NAME="qv" TYPE="real">
!         Water vapor specific humidity (kg vapor/kg air)
!  </IN>
!  <IN NAME="ql" TYPE="real">
!         Grid-box mean liquid water specific humidity (kg liquid/kg air)
!  </IN>
!  <IN NAME="qi" TYPE="real">
!         Grid-box mean ice water specific humidity (kg ice/kg air)
!  </IN>
!  <IN NAME="qa" TYPE="real">
!         Cloud fraction (3d array and a prognostic variable) (fraction)
!  </IN>
!  <IN NAME="qn" TYPE="real">
!         Cloud droplet number (3d array and a prognostic variable) 
!         (#/kg air)
!  </IN>
!  <IN NAME="omega" TYPE="real">
!         Vertical pressure velocity (Pa/sec)
!  </IN>
!  <IN NAME="Mc" TYPE="real">
!         Cumulus mass flux (defined positive as upward) (kg air/m2/sec)
!  </IN>
!  <IN NAME="diff_t" TYPE="real">
!         Vertical diffusion coefficient for temperature and tracer from 
!         vertical diffusion scheme (m2/sec) 
!  </IN>
!  <IN NAME="LAND" TYPE="real">
!         Fraction of surface that contains land (fraction)
!  </IN>
!  <OUT NAME="ST" TYPE="real">
!         Change in temperature due to strat_cloud (K) 
!  </OUT>
!  <OUT NAME="SQ" TYPE="real">
!         Change in water vapor due to strat_cloud (kg vapor/kg air) 
!  </OUT>
!  <OUT NAME="SL" TYPE="real">
!         Change in cloud liquid due to strat_cloud (kg liquid/kg air)
!  </OUT>
!  <OUT NAME="SI" TYPE="real">
!         Change in cloud ice due to strat_cloud (kg ice/kg air)
!  </OUT>
!  <OUT NAME="SA" TYPE="real">
!         Change in cloud fraction due to strat_cloud (fraction)
!  </OUT>
!  <OUT NAME="SN" TYPE="real">
!         Change in cloud droplet number due to strat_cloud (fraction)
!  </OUT>
!  <OUT NAME="surfrain" TYPE="real">
!         Surface rain fall over time step dtcloud (kg liquid/m2)
!  </OUT>
!  <OUT NAME="surfsnow" TYPE="real">
!         Surface snow fall over time step dtcloud (kg ice/m2)
!  </OUT>
!  <OUT NAME="rain3d" TYPE="real">
!         3D rain fall over time step dtcloud (kg liquid/m2)
!  </OUT>
!  <OUT NAME="snow3d" TYPE="real">
!         3D snow fall over time step dtcloud (kg ice/m2)
!  </OUT>
!  <IN NAME="qrat" TYPE="real">
!         Ratio of large-scale specific humidity to specific humidity in 
!         environment outside of activated convective systems 
!         (donner_deep, uw) 
!  </IN>
!  <IN NAME="ahuco" TYPE="real">
!         The fraction of the grid box containing either cumulus cells or 
!         the  mesoscale circulation from donner_deep, and any uw shallow 
!         clouds.
!  </IN>
!  <IN NAME="MASK" TYPE="real">
!         Optional input real array indicating the point is above the 
!         surface if equal to 1.0 and indicating the point is below the 
!         surface if equal to 0.
!         Used only in eta vertical coordinate model.
!  </IN>
! </SUBROUTINE>
!
!-----------------------------------------------------------------------

subroutine strat_cloud    &
         (Time, is, ie, js, je, dtcloud, pfull, phalf, radturbten2,&
          T, qv, ql, qi ,qa, omega, Mc, diff_t, LAND,              &
          ST, SQ, SL, SI, SA, f_snow_berg, rain3d, snow3d, snowclr3d,   &
          surfrain, surfsnow, qrat, ahuco, limit_conv_cloud_frac, MASK,  &
          qn, Aerosol, SN)

!-------------------------------------------------------------------------
type(time_type),        intent (in)            :: Time
integer,                intent (in)            :: is, ie, js, je
real,                   intent (in)            :: dtcloud
real, dimension(:,:,:), intent (in)            :: pfull, phalf, T, qv,  &
                                                  ql, qi, qa, omega, Mc, &
                                                  diff_t,  qrat, ahuco, &
                                                  radturbten2
logical, intent(in)                            :: limit_conv_cloud_frac
real, dimension(:,:),   intent (in)            :: LAND
real, dimension(:,:,:), intent (out)           :: ST, SQ, SL, SI, SA,  &
                                                  rain3d, snow3d,  &
                                                  snowclr3d, f_snow_berg
real, dimension(:,:),   intent (out)           :: surfrain, surfsnow
real, dimension(:,:,:), intent (in),  optional :: MASK, qn
type(aerosol_type),     intent (in),  optional :: Aerosol  
real, dimension(:,:,:), intent (out), optional :: SN
!------------------------------------------------------------------------

!------------------------------------------------------------------------
!---local variables------------------------------------------------------

      real, allocatable, dimension(:,:,:,:) :: diag_4d, diag_4d_kp1    
      real, allocatable, dimension(:,:,:)   :: diag_3d
      integer                               :: kdim

!-----------------------------------------------------------------------
      kdim = size (T,3)

!------------------------------------------------------------------------
!    allocate arrays to hold netcdf diagnostics.
!------------------------------------------------------------------------
      if (allocated(diag_3d)) deallocate (diag_3d)
      allocate(diag_3d(size(T,1),size(T,2),0:n_diag_4d))
 
      diag_3d(:,:,0:) = 0.

      if (allocated(diag_4d)) deallocate (diag_4d)
      allocate(diag_4d(size(T,1),size(T,2),size(T,3),0:n_diag_4d))

      diag_4d(:,:,:,0:) = 0.

      if (allocated(diag_4d_kp1)) deallocate (diag_4d_kp1)
      allocate(  &
            diag_4d_kp1(size(T,1),size(T,2),size(T,3)+1,0:n_diag_4d_kp1))

      diag_4d_kp1(:,:,:,0:) = 0.

!-----------------------------------------------------------------------
!    call strat_cloud_legacy to execute the pre-double-moment-capable
!    strat_cloud code.
!------------------------------------------------------------------------
      call strat_cloud_legacy       &
            (Nml, diag_id, diag_pt, n_diag_4d, n_diag_4d_kp1, diag_4d, &
             diag_4d_kp1, diag_3d, Time, is, &
             ie, js, je, dtcloud, pfull, phalf, radturbten2, T, qv, ql, &
             qi, qa, omega, Mc, diff_t, LAND, ST, SQ, SL, SI, SA,  &
             f_snow_berg, rain3d, &
             snow3d, snowclr3d, surfrain, surfsnow, qrat, ahuco,   &
             limit_conv_cloud_frac, MASK, qn, Aerosol, SN)
        
!-----------------------------------------------------------------------
!    call strat_netcdf to process diagnostics.
!-----------------------------------------------------------------------
      call strat_netcdf (diag_id, diag_pt, diag_4d, diag_4d_kp1,  &
                         diag_3d, Time, is, js, kdim, MASK)
 
!-------------------------------------------------------------------------
!    deallocate the local allocatable variables. call strat_dealloc to 
!    deallocate the derived type variable components.
!-------------------------------------------------------------------------
      deallocate ( diag_4d )
      deallocate ( diag_4d_kp1 )
      deallocate ( diag_3d )

!---------------------------------------------------------------------


end subroutine strat_cloud


subroutine strat_cloud_time_vary (dtcloud, limit_conv_cloud_frac)

real, intent(in) :: dtcloud
logical, intent(in) :: limit_conv_cloud_frac

      Constants%dtcloud = dtcloud
      Constants%inv_dtcloud = 1.0/dtcloud
      Constants%limit_conv_cloud_frac = limit_conv_cloud_frac

end subroutine strat_cloud_time_vary

!#########################################################################

!------------------------------------------------------------------------
! <SUBROUTINE NAME="strat_cloud_new">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!       
!  </DESCRIPTION>
!  <TEMPLATE>
!subroutine strat_cloud_new (Time, is, ie, js, je, dtcloud, pfull,  
!                            phalf, zhalf, zfull, radturbten2, 
!                            T_in, qv_in, ql_in, qi_in, qa_in, omega, Mc, 
!                            diff_t, LAND, ST_out, SQ_out, SL_out, SI_out, 
!                            SA_out, rain3d, snow3d, snowclr3d, surfrain, 
!                            surfsnow, qrat, ahuco, limit_conv_cloud_frac,
!                            Aerosol, MASK3d, qn_in, SN_out, qni_in,  
!                            SNi_out, lsc_snow, lsc_rain, lsc_snow_size, 
!                            lsc_rain_size )
!
!  </TEMPLATE>
!  <IN NAME="Time" TYPE="time_type">
!         Time
!  </IN>
!  <IN NAME="is" TYPE="integer">
!         Index of starting point in the longitude direction of the current
!         physics window               
!  </IN>
!  <IN NAME="ie" TYPE="integer">
!         Index of ending point in the longitude direction of the current  
!         physics window
!  </IN>
!  <IN NAME="js" TYPE="integer">
!         Index of starting point in the latitude direction of the current
!         physics window
!  </IN>
!  <IN NAME="je" TYPE="integer">
!         Index of ending point in the latitude direction of the current
!         physics window
!  </IN>
!  <IN NAME="dtcloud" TYPE="real">
!         Physics time step (sec)
!  </IN>
!  <IN NAME="pfull" TYPE="real">
!         Pressure on model full levels (Pa)
!  </IN>
!  <IN NAME="phalf" TYPE="real">
!         Pressure on model half levels (Pa)
!  </IN>
!  <IN NAME="zfull" TYPE="real">
!         Height on model full levels (m)
!  </IN>
!  <IN NAME="zhalf" TYPE="real">
!         Height on model half levels (m)
!  </IN>
!  <IN NAME="radturbten2" TYPE="real">
!         Sum of the tendencies of temperature from turbulence and 
!         radiation schemes (K/s)
!  </IN>
!  <IN NAME="T_in" TYPE="real">
!         Temperature (K)         
!  </IN>
!  <IN NAME="qv_in" TYPE="real">
!         Water vapor specific humidity (kg vapor/kg air)
!  </IN>
!  <IN NAME="ql_in" TYPE="real">
!         Grid-box mean liquid water specific humidity (kg liquid/kg air)
!  </IN>
!  <IN NAME="qi_in" TYPE="real">
!         Grid-box mean ice water specific humidity (kg ice/kg air)
!  </IN>
!  <IN NAME="qa_in" TYPE="real">
!         Cloud fraction (3d array and a prognostic variable) (fraction)
!  </IN>
!  <IN NAME="omega" TYPE="real">
!         Vertical pressure velocity (Pa/sec)
!  </IN>
!  <IN NAME="Mc" TYPE="real">
!         Cumulus mass flux (defined positive as upward) (kg air/m2/sec)
!  </IN>
!  <IN NAME="diff_t" TYPE="real">
!         Vertical diffusion coefficient for temperature and tracer from 
!         vertical diffusion scheme (m2/sec) 
!  </IN>
!  <IN NAME="LAND" TYPE="real">
!         Fraction of surface that contains land (fraction)
!  </IN>
!  <OUT NAME="ST_out" TYPE="real">
!         Change in temperature due to strat_cloud_new (K) 
!  </OUT>
!  <OUT NAME="SQ_out" TYPE="real">
!         Change in water vapor due to strat_cloud_new (kg vapor/kg air) 
!  </OUT>
!  <OUT NAME="SL_out" TYPE="real">
!         Change in cloud liquid due to strat_cloud_new (kg liquid/kg air)
!  </OUT>
!  <OUT NAME="SI_out" TYPE="real">
!         Change in cloud ice due to strat_cloud_new (kg ice/kg air)
!  </OUT>
!  <OUT NAME="SA_out" TYPE="real">
!         Change in cloud fraction due to strat_cloud_new (fraction)
!  </OUT>
!  <OUT NAME="rain3d" TYPE="real">
!         3D rain fall over time step dtcloud (kg liquid/m2)
!  </OUT>
!  <OUT NAME="snow3d" TYPE="real">
!         3D snow fall over time step dtcloud (kg ice/m2)
!  </OUT>
!  <OUT NAME="snowclr3d" TYPE="real">
!         3D snow fall outside of clouds over time step dtcloud (kg ice/m2)
!  </OUT>
!  <OUT NAME="surfrain" TYPE="real">
!         Surface rain fall over time step dtcloud (kg liquid/m2)
!  </OUT>
!  <OUT NAME="surfsnow" TYPE="real">
!         Surface snow fall over time step dtcloud (kg ice/m2)
!  </OUT>
!  <IN NAME="qrat" TYPE="real">
!         Ratio of large-scale specific humidity to specific humidity in 
!         environment outside convective systems (donner_deep, uw) 
!  </IN>
!  <IN NAME="ahuco" TYPE="real">
!         The fraction of the grid box containing either cumulus cells or 
!         the  mesoscale circulation from donner_deep, and any uw shallow 
!         clouds.
!  </IN>
!  <IN NAME="limit_conv_cloud_frac" TYPE="logical">
!         Total cloud fraction in a grid box should be limited to 100% ?
!  </IN>
!  <IN NAME="Aerosol" TYPE="aerosol_type">
!         Model aerosol amounts needed for nuclei activation calculations.
!  </IN>
!  <IN NAME="MASK3d" TYPE="real">
!         Optional input real array indicating the point is above the 
!         surface if equal to 1.0 and indicating the point is below the 
!         surface if equal to 0. Used only in eta vertical coordinate 
!         model.
!  </IN>
!  <IN NAME="qn_in" TYPE="real">
!         Cloud droplet number (3d array and a prognostic variable) 
!         (#/kg air)
!  </IN>
!  <OUT NAME="SN_out" TYPE="real">
!         Change in cloud droplet number due to strat_cloud_new (fraction)
!  </OUT>
!  <IN NAME="qni_in" TYPE="real">
!         Ice particle number (3d array and a prognostic variable) 
!         (#/kg air)
!  </IN>
!  <OUT NAME="SNi_out" TYPE="real">
!         Change in ice particle number due to strat_cloud_new (fraction)
!  </OUT>
!  <OUT NAME="lsc_snow" TYPE="real">
!         3D snow field (mass mixing ratio)from morrison-gettelman 
!         calculation.   (kg/kg)
!  </OUT>
!  <OUT NAME="lsc_rain" TYPE="real">
!         3D rain field (mass mixing ratio) from morrison-gettelman 
!         calculation.   (kg/kg)
!  </OUT>
!  <OUT NAME="lsc_snow_size" TYPE="real">
!         Snow flake size from morrison-gettelman calculation.   (microns)
!  </OUT>
!  <OUT NAME="lsc_rain_size" TYPE="real">
!         Rain drop size from morrison-gettelman calculation.   (microns)
!  </OUT>
! </SUBROUTINE>
!
!-----------------------------------------------------------------------


subroutine strat_cloud_new (Time, is, ie, js, je, dtcloud, pfull,  &
                            phalf, zhalf, zfull, radturbten2, &
                            T_in, qv_in, ql_in, qi_in, qa_in, omega, Mc, &
                            diff_t, LAND, ST_out, SQ_out, SL_out, SI_out, &
                            SA_out, f_snow_berg, rain3d, snow3d,    &
                            snowclr3d, surfrain, &
                            surfsnow, qrat, ahuco, limit_conv_cloud_frac, &
                            Aerosol, MASK3d, qn_in, SN_out, qni_in,  &
                            SNi_out, lsc_snow, lsc_rain, lsc_snow_size, &
                            lsc_rain_size )

!------------------------------------------------------------------------
type(time_type),        intent (in)            :: Time
integer,                intent (in)            :: is,ie,js,je
real,                   intent (in)            :: dtcloud
real, dimension(:,:,:), intent (in)            :: pfull, phalf, zhalf, &
                                                  zfull, T_in, qv_in,  &
                                                  ql_in, qi_in, qa_in, &
                                                  omega,Mc, diff_t, &
                                                  qrat, ahuco, radturbten2
logical,                intent(in)             :: limit_conv_cloud_frac
type(aerosol_type),     intent (in)            :: Aerosol  
real, dimension(:,:),   intent (in)            :: LAND
real, dimension(:,:,:), intent (out)           :: ST_out, SQ_out, SL_out, &
                                                  SI_out, SA_out, rain3d, &
                                                  snow3d, snowclr3d
real, dimension(:,:,:), intent (out)           :: f_snow_berg         
real, dimension(:,:),   intent (out)           :: surfrain,surfsnow
real, dimension(:,:,:), intent (in),  optional :: MASK3d, qn_in, qni_in
real, dimension(:,:,:), intent (out), optional :: SN_out, SNi_out,  &
                                                  lsc_snow, lsc_rain, &
                                                  lsc_snow_size, &
                                                  lsc_rain_size


!------------------------------------------------------------------------
!---local variables------------------------------------------------------

!------------------------------------------------------------------------
!  variables used in calculation of particle number diagnostics:
      real, dimension(size(T_in,1),size(T_in,2))  ::    &
              N3D_col, N3Di_col, N3D_col250, gb_N3D_col, gb_N3Di_col
      real :: dum, qa_new, qn_new, ql_new, qi_new, qni_new

!------------------------------------------------------------------------
!  variables used to hold particle number fields:
!       N3D   number of cloud drops per unit volume in liquid clouds
!             [ 1/(m*m*m) ]
!       N3Di  number of ice particles per unit volume in ice clouds
!             [ 1/(m*m*m) ]
      real, dimension(size(T_in,1),size(T_in,2),size(T_in,3)) ::     &
              N3Di, N3D

!------------------------------------------------------------------------
!  variables allocated to hold all netcdf diagnostic fields:
      real, allocatable, dimension(:,:,:,:) :: diag_4d, diag_4d_kp1
      real, allocatable, dimension(:,:,:)   :: diag_3d

!------------------------------------------------------------------------
!  derived type variables used to pass fields between modules:
      type(atmos_state_type)     :: Atmos_state
      type(cloud_state_type)     :: Cloud_state
      type(particles_type)       :: Particles 
      type(precip_state_type)    :: Precip_state
      type(cloud_processes_type) :: Cloud_processes

!------------------------------------------------------------------------
!  variables needed with column diagnostics:
      integer  :: unit, ipt, jpt, outunit

!------------------------------------------------------------------------
!  dimensions of physics window:
      integer  :: idim, jdim, kdim

!------------------------------------------------------------------------
!  do-loop indices:
      integer :: i, j ,k, nn
 
!------------------------------------------------------------------------
!  counter of columns in which mg_micro is not computed due to negative
!  water in column (activated by setting debugo4 to .true.)
      integer :: nrefuse 

      outunit = stdout()

!-----------------------------------------------------------------------
!    check for consistent arguments and options.
!-----------------------------------------------------------------------
      call mpp_clock_begin (sc_init)
      if (.not. module_is_initialized) call error_mesg  &
            ('strat_cloud_new', 'strat_cloud_new is not initialized',FATAL)

      IF (Constants%do_rk_microphys ) THEN
        IF ( present(MASK3d) ) THEN
          Constants%mask_present = .true.
          Constants%mask = MASK3d
        ELSE
          Constants%mask_present = .false.
          Constants%mask = 1.0       
        END IF
      ELSE if (Constants%do_mg_microphys .or.    &
                                     Constants%do_mg_ncar_microphys) then
        IF ( .NOT. present(SNi_out)) THEN
          call error_mesg ('strat_cloud_new_mod', &
             'morrison gettelman microp requires progn. ice num ',  FATAL) 
        END IF
        IF ( .NOT. PRESENT ( lsc_snow ) ) THEN
          call error_mesg ( 'strat_cloud_new_mod', &
            'need lsc_snow for morrrison-gettelman microphysics', FATAL)
        END IF   
        IF ( .NOT. PRESENT ( lsc_rain ) ) THEN
          call error_mesg ( 'strat_cloud_new_mod', &
            'need lsc_rain for morrrison-gettelman microphysics', FATAL)
        END IF   
        IF ( .NOT. PRESENT ( lsc_snow_size ) ) THEN
          call error_mesg ( 'strat_cloud_new_mod', &
          'need lsc_snow_size for morrrison-gettelman microphysics', FATAL)
        END IF   
        IF ( .NOT. PRESENT ( lsc_rain_size ) ) THEN
          call error_mesg ( 'strat_cloud_new_mod', &
          'need lsc_rain_size for morrrison-gettelman microphysics', FATAL)
        END IF   
        IF (PRESENT(MASK3d)) then
          call error_mesg ( 'strat_cloud_new_mod',  &
              "ERROR: mask not implementd with m-g rescaling", FATAL)
        END IF
      ENDIF  ! (do_rk_microphys)
      if (debugo) then
        IF( MAXVAL( ahuco ) .GT. 1. ) WRITE(outunit,*) "AHUCO WARNING"
      endif

!-------------------------------------------------------------------------
!    define spatial dimensions.                
!-------------------------------------------------------------------------
      idim = SIZE(T_in, 1)
      jdim = SIZE(T_in, 2)
      kdim = SIZE(T_in, 3) 

!-------------------------------------------------------------------------
!    initialize debug / diagnostic variables. be sure isamp, jsamp, ksamp
!    are valid. output initial data to debug file (otun). if debugo4 is
!    activated, output call counter to stdout to track model progress 
!    during debug, and then increment the counter.
!-------------------------------------------------------------------------
      nrefuse = 0 
      isamp = min (idim, isamp)
      jsamp = min (jdim, jsamp)
      Nml%isamp = isamp
      Nml%jsamp = jsamp
      Nml%ksamp = ksamp
      if ( ncall .eq. 1 .and.   &
                ( debugo .or. debugo0 .or.  debugo1 .or. debugo3 ) ) then
        write(otun,*) "MODIF TEST"
        write(otun,*) "is,ie,js,je ", is, ie, js, je
        if (.not. debugo1 .and. .not. debugo3 )    &
          write(otun,*) "  isamp, jsamp, ksamp ", isamp, jsamp, ksamp
      end if

      if ( debugo4 .and. mpp_pe() .EQ. 0 ) then   
        write (outunit,*) "in stratcloud mod", ncall
      endif

      if (debugo .or. debugo0 .or. debugo3 )then
        write(otun,*) "-----------------------------------------------" 
        write(otun,*) "ncall ", ncall
      endif

      ncall = ncall +1

!------------------------------------------------------------------------
!    allocate and initialize the diagnostic variables.
!------------------------------------------------------------------------
      allocate (diag_3d(idim,jdim,0:n_diag_4d))
      allocate (diag_4d(idim,jdim,kdim,0:n_diag_4d))
      allocate (diag_4d_kp1(idim,jdim,kdim+1,0:n_diag_4d_kp1))
      diag_3d(:,:,0:) = 0.
      diag_4d(:,:,:,0:) = 0.
      diag_4d_kp1(:,:,:,0:) = 0.
       
!------------------------------------------------------------------------
!    call strat_alloc to allocate and initialize the derived type variables
!    of the module.
!------------------------------------------------------------------------
      call strat_alloc (idim, jdim, kdim, pfull, phalf, zhalf, zfull,&
                        radturbten2, T_in, qv_in, ql_in, qi_in, qa_in, &
                        omega, Mc, diff_t, qrat, ahuco,  &
                        Atmos_state, Particles, Cloud_state, &
                        Precip_state, Cloud_processes, &
                        qn_in=qn_in, qni_in=qni_in)

!-----------------------------------------------------------------------
!    initialize remaining output variables. define constants to be passed
!    to other modules.
!-----------------------------------------------------------------------
      ST_out = 0.
      SQ_out = 0.
      call mpp_clock_end (sc_init)

!-----------------------------------------------------------------------
!    calculate saturation specific humidity and its temperature 
!    derivative, thermal conductivity plus vapor diffusivity factor, 
!    and relative humidity.
!-----------------------------------------------------------------------
      call mpp_clock_begin (sc_qs)
      call compute_qs_a (idim, jdim, kdim, Nml, Atmos_state, Cloud_state) 
      if (debugo ) then
        write(otun, *) " T, pfull ", T_in(isamp,jsamp,ksamp),   &
                                              pfull(isamp,jsamp,ksamp)
        write(otun, *) " aaa dqsdT, qs ",   &
                                Atmos_state%dqsdT(isamp,jsamp,ksamp),  &
                                      Atmos_state%qs(isamp,jsamp,ksamp)
      endif
      call mpp_clock_end (sc_qs)

!-----------------------------------------------------------------------
!    define cloud droplet number for non-predicted-droplet-number case.
!    for the predicted case, N3D is defined in subroutine 
!    impose_realizability, called below.
!-----------------------------------------------------------------------
      call mpp_clock_begin (sc_realiz)
      if ( .not. do_liq_num) then
        do k=1,kdim
          N3D (:,:,k) = N_land*LAND(:,:) + N_ocean*(1. - LAND(:,:))
        end do
      endif 

!-----------------------------------------------------------------------
!    call impose_realizability to account for the fact that other processes
!    may have created negative tracer or extremely small values of tracer 
!    fields. the general reason for the extremely small values of the 
!    tracer fields is due to vertical diffusion, advection of condensate or!    cumulus induced subsidence (also a form of advection) of condensate.
!
!    in this step any values of the prognostic variables which are less 
!    than qmin are reset to zero, while conserving total moisture.
!
!    note that this is done slightly different for the Tiedtke cloud 
!    fraction than it is for pdf clouds. In the former, the filling 
!    requires that cloud liquid, cloud ice, and cloud fraction are greater
!    than qmin. For PDF clouds, cloud fraction need not be considered since
!    it is diagnosed from the PDF clouds.
!-----------------------------------------------------------------------
      call impose_realizability (idim, jdim, kdim, Atmos_state, &
                                 Cloud_state, SQ_out, ST_out, N3d,   &
                                 N3Di, otun, n_diag_4d, diag_4d)
      call mpp_clock_end (sc_realiz)

!------------------------------------------------------------------------
!    call aerosol_cloud to determine available condensation nuclei.
!------------------------------------------------------------------------
      call mpp_clock_begin (sc_aero)
      CALL aerosol_cloud (idim, jdim, kdim, n_diag_4d, Nml, Constants, &
                          Atmos_state, Particles, Cloud_state%qa_upd,  &
                          Aerosol, diag_4d, diag_id, diag_pt, otun)        
      call mpp_clock_end (sc_aero)

!------------------------------------------------------------------------
!    call nc_cond to calculate non-convective condensation using either
!    Tiedtke, Tompkins et al., or Klein simple PDF. this contains the 
!    dcond_ls calc., etc. from the Tiedtke scheme and the Klein pdf scheme.
!------------------------------------------------------------------------
      call mpp_clock_begin (sc_nccond)
      CALL nc_cond (idim, jdim, kdim, Nml, Constants, Atmos_state,   &
                    Cloud_state, ST_out, SQ_out, Cloud_processes,   &
                    Particles, n_diag_4d, diag_4d, diag_id, diag_pt, otun) 
      call mpp_clock_end (sc_nccond)
      
!------------------------------------------------------------------------
!    define the mean droplet number after this timestep's activation. note
!    that if the cloud area has not increased during the timestep in r-k 
!    microphysics, then droplet number does not increase.
!    delta_cf:  A_dt * (1.-qabar)   where A_dt = A*dt , A source rate
!    Eq. 7 of Yi's 2007 paper
!------------------------------------------------------------------------
      call mpp_clock_begin (sc_after)
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            if (diag_id%potential_droplets > 0 .and.   &
                      Cloud_processes%da_ls(i,j,k) <= 0.0)   &
                           diag_4d(i,j,k,diag_pt%potential_droplets) = 0.0
            if (diag_id%subgrid_w_variance > 0 .and.   &
                      Cloud_processes%da_ls(i,j,k) <= 0.0)   &
                           diag_4d(i,j,k,diag_pt%subgrid_w_variance) = 0.0
            if (Cloud_processes%da_ls(i,j,k) > 0.0 .or.  &
                                  Constants%do_mg_ncar_microphys .or.  &
                                          Constants%do_mg_microphys) then
              Cloud_state%qn_mean(i,j,k) =   &
                    Cloud_state%qn_upd(i,j,k) +   &
                        max(Cloud_processes%delta_cf(i,j,k),0.)*  &
                           Particles%drop1(i,j,k)*1.e6/  &
                                               Atmos_state%airdens(i,j,k)
            else
              Particles%drop1(i,j,k) = 0.                
              Cloud_state%qn_mean(i,j,k) = Cloud_state%qn_upd(i,j,k)
            end if
          end do
        end do
      end do
      call mpp_clock_end (sc_after)

!-------------------------------------------------------------------------
!    call microphysics to compute those terms.
!-------------------------------------------------------------------------
      call mpp_clock_begin (sc_micro)
      call microphysics (idim, jdim, kdim, Nml, Constants, N3D,  &
                         Atmos_state, Cloud_state, Cloud_processes,  &
                         Particles, n_diag_4d, diag_4d, diag_id, diag_pt, &
                         n_diag_4d_kp1, diag_4d_kp1, ST_out, SQ_out,  &
                         Precip_state, otun, ncall, &
                         Cloud_state%qa_upd_0, Cloud_state%SA_0, &
                         nrefuse, isamp, jsamp, ksamp, debugo, debugo0, &
                         debugo1)    
      if (Constants%do_mg_ncar_microphys .or.  &
                                          Constants%do_mg_microphys) then
        if (diag_id%qadt_limits + diag_id%qa_limits_col > 0)    &
            diag_4d(:,:,:,diag_pt%qadt_limits) =    &
                   (Cloud_state%SA_out(:,:,:) - &
                            diag_4d(:,:,:,diag_pt%qadt_limits)) *  &
                                               Constants%inv_dtcloud
      endif
      call mpp_clock_end (sc_micro)

!-----------------------------------------------------------------------
!    place some output fields in the appropriate locations.
!-----------------------------------------------------------------------
      call mpp_clock_begin(sc_end)
      SL_out = Cloud_state%SL_out
      SI_out = Cloud_state%SI_out
      SA_out = Cloud_state%SA_out
      rain3d = Precip_state%rain3d
      snow3d = Precip_state%snow3d
!RSH
!  for r-k, snow in cloud is included in cloud ice. For mg and ncar,
!  snow is not included in cloud ice, so all snow must be put into
!  snowclr3d which for those schemes is used to hold the total 
!  precipitating ice field.
      if (Constants%do_mg_ncar_microphys .or.  &
                                          Constants%do_mg_microphys) then
        snowclr3d = Precip_state%snow3d
      else
        snowclr3d = Precip_state%snowclr3d
      endif
      surfrain = Precip_state%surfrain
      surfsnow = Precip_state%surfsnow
      f_snow_berg = Cloud_processes%f_snow_berg

      if (present(lsc_snow)) lsc_snow = Precip_state%lsc_snow
      if (present(lsc_rain)) lsc_rain = Precip_state%lsc_rain
      if (present(lsc_snow_size)) lsc_snow_size =   &
                                                Precip_state%lsc_snow_size
      if (present(lsc_rain_size)) lsc_rain_size =  &
                                                Precip_state%lsc_rain_size
    
      if (present(SN_out)) SN_out(:,:,:) = Cloud_state%SN_out(:,:,:)
      if (present(SNi_out)) SNi_out(:,:,:) = Cloud_state%SNI_out(:,:,:)

!-----------------------------------------------------------------------
!    define some diagnostics.
!-----------------------------------------------------------------------
      if (diag_id%SA3d + diag_id%SA2d > 0) then
        diag_4d(:,:,:,diag_pt%SA3d) = SA_out(:,:,:)*Constants%inv_dtcloud
      endif
      if (diag_id%ST3d + diag_id%ST2d > 0) then
        diag_4d(:,:,:,diag_pt%ST3d) = ST_out(:,:,:)*Constants%inv_dtcloud
      endif
      if (diag_id%SQ3d + diag_id%SQ2d > 0) then
        diag_4d(:,:,:,diag_pt%SQ3d) = SQ_out(:,:,:)*Constants%inv_dtcloud
      endif
      if (diag_id%SL3d + diag_id%SL2d > 0) then
        diag_4d(:,:,:,diag_pt%SL3d) = SL_out(:,:,:)*Constants%inv_dtcloud
      endif
      if (diag_id%SI3d + diag_id%SI2d > 0) then
        diag_4d(:,:,:,diag_pt%SI3d) = SI_out(:,:,:)*Constants%inv_dtcloud
      endif
      if (diag_id%SN3d + diag_id%SN2d > 0) then
        diag_4d(:,:,:,diag_pt%SN3d) = Cloud_state%SN_out(:,:,:)*   &
                                                    Constants%inv_dtcloud
      endif
      if (diag_id%SNI3d + diag_id%SNI2d > 0) then
        diag_4d(:,:,:,diag_pt%SNI3d) = Cloud_state%SNI_out(:,:,:)*   &
                                                    Constants%inv_dtcloud
      endif
        
!-----------------------------------------------------------------------
!    define some diagnostics.
!-----------------------------------------------------------------------
      if (diag_id%SA_imb + diag_id%SA_imb_col > 0) then
        diag_4d(:,:,:,diag_pt%SA_imb) =    &
             diag_4d(:,:,:,diag_pt%SA3d) -   (       &
                diag_4d(:,:,:,diag_pt%qadt_lsform)   &
             +  diag_4d(:,:,:,diag_pt%qadt_lsdiss)   &
             +  diag_4d(:,:,:,diag_pt%qadt_rhred)    &
             +  diag_4d(:,:,:,diag_pt%qadt_eros)     &
             +  diag_4d(:,:,:,diag_pt%qadt_fill)     &
             +  diag_4d(:,:,:,diag_pt%qadt_super)    &
             +  diag_4d(:,:,:,diag_pt%qadt_destr)    &
             +  diag_4d(:,:,:,diag_pt%qadt_limits)   &
             +  diag_4d(:,:,:,diag_pt%qadt_ahuco)    &
                                                          )
      endif
      if (diag_id%SL_imb + diag_id%SL_imb_col > 0) then
        diag_4d(:,:,:,diag_pt%SL_imb) =  &
             diag_4d(:,:,:,diag_pt%SL3d) -   (            &
                diag_4d(:,:,:,diag_pt%qldt_cond )         &
              + diag_4d(:,:,:,diag_pt%qldt_evap  )        &
              + diag_4d(:,:,:,diag_pt%qldt_eros  )        &
              + diag_4d(:,:,:,diag_pt%qldt_berg)          &
              + diag_4d(:,:,:,diag_pt%qldt_freez )        &
              + diag_4d(:,:,:,diag_pt%liq_adj    )        &
              + diag_4d(:,:,:,diag_pt%qldt_rime  )        &
              + diag_4d(:,:,:,diag_pt%qldt_accr)          &
              + diag_4d(:,:,:,diag_pt%qldt_auto)          &
              + diag_4d(:,:,:,diag_pt%qldt_fill  )        &
              + diag_4d(:,:,:,diag_pt%qldt_destr )        &
              + diag_4d(:,:,:,diag_pt%qldt_freez2)        &
              + diag_4d(:,:,:,diag_pt%qldt_sedi  )        &
              + diag_4d(:,:,:,diag_pt%qldt_accrs)         &
              + diag_4d(:,:,:,diag_pt%qldt_bergs)         &
              + diag_4d(:,:,:,diag_pt%qldt_HM_splinter)   &
              - diag_4d(:,:,:,diag_pt%qidt_melt2 )        &
              - diag_4d(:,:,:,diag_pt%qidt_accrs)         &
              - diag_4d(:,:,:,diag_pt%qdt_cleanup_liquid) &    
                                                             )
      endif
      if (diag_id%SI_imb + diag_id%SI_imb_col > 0) then
        diag_4d(:,:,:,diag_pt%SI_imb) =     &
             diag_4d(:,:,:,diag_pt%SI3d) -   (          &
              - diag_4d(:,:,:,diag_pt%qldt_berg)        &
              - diag_4d(:,:,:,diag_pt%qldt_freez )      &
              - diag_4d(:,:,:,diag_pt%qldt_rime  )      &
              - diag_4d(:,:,:,diag_pt%qldt_freez2)      &
              - diag_4d(:,:,:,diag_pt%qldt_HM_splinter) &
              + diag_4d(:,:,:,diag_pt%qidt_dep  )       &
              + diag_4d(:,:,:,diag_pt%qidt_subl  )      &
              + diag_4d(:,:,:,diag_pt%qidt_fall  )      &
              + diag_4d(:,:,:,diag_pt%qidt_eros  )      &
              + diag_4d(:,:,:,diag_pt%qidt_melt  )      &
              + diag_4d(:,:,:,diag_pt%qidt_melt2 )      &
              + diag_4d(:,:,:,diag_pt%qidt_fill  )      &
              + diag_4d(:,:,:,diag_pt%qidt_destr )      &
              + diag_4d(:,:,:,diag_pt%qidt_qvdep )      &
              + diag_4d(:,:,:,diag_pt%qidt_auto)        &
              + diag_4d(:,:,:,diag_pt%qidt_accr)        &
              + diag_4d(:,:,:,diag_pt%qidt_accrs)       &
              + diag_4d(:,:,:,diag_pt%ice_adj    )      &
              - diag_4d(:,:,:,diag_pt%qdt_cleanup_ice)  &
                                                          )
      endif


      if (diag_id%SN_imb + diag_id%SN_imb_col > 0) then
        diag_4d(:,:,:,diag_pt%SN_imb) =  &
             diag_4d(:,:,:,diag_pt%SN3d) -   ( &
                diag_4d(:,:,:,diag_pt%qndt_cond  )      &
              + diag_4d(:,:,:,diag_pt%qndt_evap  )      &
              + diag_4d(:,:,:,diag_pt%qndt_fill  )      &
              + diag_4d(:,:,:,diag_pt%qndt_berg  )      &
              + diag_4d(:,:,:,diag_pt%qndt_destr )      &
              + diag_4d(:,:,:,diag_pt%qndt_super )      &
              + diag_4d(:,:,:,diag_pt%qndt_freez )      &
              + diag_4d(:,:,:,diag_pt%qndt_sacws )      &
              + diag_4d(:,:,:,diag_pt%qndt_sacws_o)     &
              + diag_4d(:,:,:,diag_pt%qndt_eros  )      &
              + diag_4d(:,:,:,diag_pt%qndt_pra   )      &
              + diag_4d(:,:,:,diag_pt%qndt_auto  )      &
              + diag_4d(:,:,:,diag_pt%qndt_nucclim)     &
              + diag_4d(:,:,:,diag_pt%qndt_sedi )       &
              + diag_4d(:,:,:,diag_pt%qndt_melt)        &
              + diag_4d(:,:,:,diag_pt%qndt_ihom)        &
              + diag_4d(:,:,:,diag_pt%qndt_size_adj)    &
              + diag_4d(:,:,:,diag_pt%qndt_fill2)       &
              + diag_4d(:,:,:,diag_pt%qndt_contact_frz) &
              + diag_4d(:,:,:,diag_pt%qndt_cleanup)     &
              + diag_4d(:,:,:,diag_pt%qndt_cleanup2)    &
                                                            )
      endif

      if (diag_id%SNi_imb + diag_id%SNi_imb_col > 0) then
        diag_4d(:,:,:,diag_pt%SNi_imb) =     &
             diag_4d(:,:,:,diag_pt%SNi3d) -   ( &
                diag_4d(:,:,:,diag_pt%qnidt_fill )     &
              + diag_4d(:,:,:,diag_pt%qnidt_nnuccd)    &
              + diag_4d(:,:,:,diag_pt%qnidt_nsubi)     &
              + diag_4d(:,:,:,diag_pt%qnidt_nerosi)    &
              + diag_4d(:,:,:,diag_pt%qnidt_nprci)     &
              + diag_4d(:,:,:,diag_pt%qnidt_nprai)     &
              + diag_4d(:,:,:,diag_pt%qnidt_nucclim1)  &
              + diag_4d(:,:,:,diag_pt%qnidt_nucclim2)  &
              + diag_4d(:,:,:,diag_pt%qnidt_sedi  )    &
              + diag_4d(:,:,:,diag_pt%qnidt_melt  )    &
              + diag_4d(:,:,:,diag_pt%qnidt_size_adj ) &
              + diag_4d(:,:,:,diag_pt%qnidt_fill2  )   &
              + diag_4d(:,:,:,diag_pt%qnidt_super )    &
              + diag_4d(:,:,:,diag_pt%qnidt_ihom )     &
              + diag_4d(:,:,:,diag_pt%qnidt_destr )    &
              + diag_4d(:,:,:,diag_pt%qnidt_cleanup)   &
              + diag_4d(:,:,:,diag_pt%qnidt_cleanup2)  &
              + diag_4d(:,:,:,diag_pt%qnidt_nsacwi)    &
                                                           )
      endif

      if (diag_id%SQ_imb + diag_id%SQ_imb_col > 0) then
        diag_4d(:,:,:,diag_pt%SQ_imb) =     &
             diag_4d(:,:,:,diag_pt%SQ3d) -   (                &
              - diag_4d(:,:,:,diag_pt%qldt_cond  )            &
              - diag_4d(:,:,:,diag_pt%qldt_evap  )            &
              - diag_4d(:,:,:,diag_pt%qldt_eros  )            &
              - diag_4d(:,:,:,diag_pt%liq_adj    )            &
              - diag_4d(:,:,:,diag_pt%qldt_fill  )            &
              - diag_4d(:,:,:,diag_pt%qldt_destr )            &
              - diag_4d(:,:,:,diag_pt%qidt_dep  )             &
              - diag_4d(:,:,:,diag_pt%qidt_subl  )            &
              - diag_4d(:,:,:,diag_pt%qidt_eros  )            &
              - diag_4d(:,:,:,diag_pt%qidt_fill  )            &
              - diag_4d(:,:,:,diag_pt%qidt_destr )            &
              - diag_4d(:,:,:,diag_pt%qidt_qvdep )            &
              - diag_4d(:,:,:,diag_pt%ice_adj    )            &
              + diag_4d(:,:,:,diag_pt%rain_evap  )            &
              + diag_4d(:,:,:,diag_pt%qdt_sedi_ice2vapor)     & 
              + diag_4d(:,:,:,diag_pt%qdt_sedi_liquid2vapor)  &  
              + diag_4d(:,:,:,diag_pt%qdt_cleanup_ice)        &
              + diag_4d(:,:,:,diag_pt%qdt_cleanup_liquid)     &    
              + diag_4d(:,:,:,diag_pt%qdt_snow_sublim  )      &
              + diag_4d(:,:,:,diag_pt%qdt_snow2vapor    )     &
                                                                )
      endif

      if (diag_id%ST_imb + diag_id%ST_imb_col > 0) then
        diag_4d(:,:,:,diag_pt%ST_imb) =     &
             diag_4d(:,:,:,diag_pt%ST3d) -    (              &
              - hlf*diag_4d(:,:,:,diag_pt%qldt_berg)         &
              - hlf*diag_4d(:,:,:,diag_pt%qldt_freez )       &
              - hlf*diag_4d(:,:,:,diag_pt%qldt_rime  )       &
              - hlf*diag_4d(:,:,:,diag_pt%qldt_freez2)       &
              - hlf*diag_4d(:,:,:,diag_pt%qldt_accrs)        &
              - hlf*diag_4d(:,:,:,diag_pt%qldt_bergs)        &
              - hlf*diag_4d(:,:,:,diag_pt%qldt_HM_splinter)  &
              + hlf*diag_4d(:,:,:,diag_pt%qidt_melt  )       &
              + hlf*diag_4d(:,:,:,diag_pt%qidt_melt2 )       &
              + hlf*diag_4d(:,:,:,diag_pt%qidt_accrs)        &
              + hlf*diag_4d(:,:,:,diag_pt%rain_freeze)       &
              - hlf*diag_4d(:,:,:,diag_pt%srfrain_accrs )    &
              - hlf*diag_4d(:,:,:,diag_pt%srfrain_freez )    &
              - hlf*diag_4d(:,:,:,diag_pt%snow_melt)         &
              
              + hlv*diag_4d(:,:,:,diag_pt%qldt_cond  )           &
              + hlv*diag_4d(:,:,:,diag_pt%qldt_evap  )           &
              + hlv*diag_4d(:,:,:,diag_pt%qldt_eros  )           &
              + hlv*diag_4d(:,:,:,diag_pt%liq_adj    )           &
              + hlv*diag_4d(:,:,:,diag_pt%qldt_fill  )           &
              + hlv*diag_4d(:,:,:,diag_pt%qldt_destr )           &
              - hlv*diag_4d(:,:,:,diag_pt%rain_evap  )           &
              - hlv*diag_4d(:,:,:,diag_pt%qdt_sedi_liquid2vapor) &  
              - hlv*diag_4d(:,:,:,diag_pt%qdt_cleanup_liquid)    &      

              + hls*diag_4d(:,:,:,diag_pt%qidt_dep  )          &
              + hls*diag_4d(:,:,:,diag_pt%qidt_subl  )         &
              + hls*diag_4d(:,:,:,diag_pt%qidt_eros  )         &
              + hls*diag_4d(:,:,:,diag_pt%qidt_fill  )         &
              + hls*diag_4d(:,:,:,diag_pt%qidt_destr )         &
              + hls*diag_4d(:,:,:,diag_pt%qidt_qvdep )         &
              + hls*diag_4d(:,:,:,diag_pt%ice_adj    )         &
              - hls*diag_4d(:,:,:,diag_pt%qdt_sedi_ice2vapor)  & 
              - hls*diag_4d(:,:,:,diag_pt%qdt_cleanup_ice)     &
              - hls*diag_4d(:,:,:,diag_pt%qdt_snow_sublim  )   &
              - hls*diag_4d(:,:,:,diag_pt%qdt_snow2vapor    )  &
                                                              )/cp_air 
              endif 

              if (diag_id%rain3d > 0) then 
                 diag_4d_kp1(:,:,:,diag_pt%rain3d) = Precip_state%rain3d(:,:,:) 
              endif 
              if (diag_id%snow3d > 0) then 
                 diag_4d_kp1(:,:,:,diag_pt%snow3d) = Precip_state%snow3d(:,:,:) 
              endif 

      if ( diag_id%cf_ice_init > 0 ) then  
        diag_4d(:,:,:,diag_pt%cf_ice_init) =   &
                                MIN(diag_4d(:,:,:,diag_pt%cf_ice_init), 1.)
      end if
      if (diag_id%droplets > 0) then
        diag_4d(:,:,:,diag_pt%droplets) = N3D(:,:,:)
      end if
      if (diag_id%droplets_wtd > 0) then
        diag_4d(:,:,:,diag_pt%droplets_wtd) = N3D(:,:,:)*ql_in(:,:,:)
      end if
      if (diag_id%ql_wt > 0) then
        diag_4d(:,:,:,diag_pt%ql_wt) = ql_in(:,:,:)
      end if
      if (diag_id%nice > 0) then
        diag_4d(:,:,:,diag_pt%nice) = N3Di(:,:,:)
      end if
      if (diag_id%qrout > 0) then
        diag_4d(:,:,:,diag_pt%qrout) = Precip_state%lsc_rain  (:,:,:)
      end if
      if (diag_id%qsout > 0) then
        diag_4d(:,:,:,diag_pt%qsout) = Precip_state%lsc_snow  (:,:,:) 
      end if

!-------------------------------------------------------------------------
!    call strat_debug to output data to file otun, if requested.
!-------------------------------------------------------------------------
      if (debugo) then
        call strat_debug (otun, ST_out, SQ_out, Cloud_state,  &
                                                 Precip_state, Atmos_State)
      endif

      
      if ( debugo4 .and. nrefuse .gt. 0)then
        write(outunit,*) "WARNING: Refusing to do two moment microphysics &
           &in columns containing points with negative total water: " ,  &
                                                                   nrefuse
      end if

!-----------------------------------------------------------------------
!   INSTANTANEOUS OUTPUT DIAGNOSTICS
!-----------------------------------------------------------------------
      if (num_strat_pts > 0) then
        do nn=1,num_strat_pts
          if (strat_pts(1,nn) >= is .and. strat_pts(1,nn) <= ie .and.  &
                  strat_pts(2,nn) >= js .and. strat_pts(2,nn) <= je) then
            ipt = strat_pts(1,nn); jpt = strat_pts(2,nn)
            i = ipt - is + 1; j = jpt - js + 1
            unit = open_ieee32_file ('strat.data', action='append')
            write (unit) ipt, jpt, ql_in(i,j,:) + SL_out(i,j,:)
            write (unit) ipt, jpt, qi_in(i,j,:) + SI_out(i,j,:)
            write (unit) ipt, jpt, qa_in(i,j,:) + SA_out(i,j,:)
            write (unit) ipt, jpt, T_in(i,j,:) + ST_out(i,j,:) 
            write (unit) ipt, jpt, qv_in(i,j,:) + SQ_out(i,j,:)
            write (unit) ipt, jpt, pfull(i,j,:)
            call close_file (unit)
          endif
        enddo
      endif

!------------------------------------------------------------------------
!    define column pressure-weighting factor.
!------------------------------------------------------------------------
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            Atmos_state%deltpg(i,j,k) =   &
                                  (phalf(i,j,k+1) - phalf(i,j,k))/grav
            if (present(MASK3d)) then
              Atmos_state%deltpg(i,j,k) =   &
                                Atmos_state%deltpg(i,j,k)*MASK3d(i,j,k)
            endif
          end do
        end do
      end do
           
!------------------------------------------------------------------------
!    generate column integrated diagnostics.
!------------------------------------------------------------------------
      do nn=1, n_diag_4d
        do k =kdim,1, -1
          diag_3d(:,:,nn) = diag_3d(:,:,nn) &
                          + diag_4d(:,:,k,nn)*Atmos_state%deltpg(:,:,k)
        enddo
      enddo
!------------------------------------------------------------------------
!SPECIAL CASES not following general pattern of above:
!rain, snow cloud ice and cloud liquid fallout -- only column integrals 
!are valid
!------------------------------------------------------------------------
      if (Constants%do_mg_microphys .or.   &
                                     Constants%do_mg_ncar_microphys) then
        if (diag_id%cld_liq_imb + diag_id%cld_liq_imb_col > 0) then
          diag_3d(:,:,diag_pt%cld_liq_imb) =   - ( &
                diag_3d(:,:,diag_pt%qldt_sedi )  +   &
                diag_3d(:,:,diag_pt%qdt_sedi_liquid2vapor)  ) 
        endif
        if (diag_id%cld_ice_imb + diag_id%cld_ice_imb_col > 0) then
          diag_3d(:,:,diag_pt%cld_ice_imb) =   - ( &
                diag_3d(:,:,diag_pt%qidt_fall )  +   &
                diag_3d(:,:,diag_pt%qdt_sedi_ice2vapor)  ) 
        endif
      endif
      IF ( diag_id%neg_rain > 0   ) &
          diag_3d(:,:,diag_pt%neg_rain) =   &
                          diag_4d(:,:,1,diag_pt%neg_rain) 
      IF ( diag_id%neg_snow > 0   ) &
          diag_3d(:,:,diag_pt%neg_snow) =   &
                          diag_4d(:,:,1,diag_pt%neg_snow) 
      if (diag_id%rain_imb + diag_id%rain_imb_col > 0) then
        diag_3d(:,:,diag_pt%rain_imb) =    &
             Precip_state%surfrain(:,:)*Constants%inv_dtcloud -   &
                diag_3d(:,:,diag_pt%cld_liq_imb)   +  (  &
                diag_3d(:,:,diag_pt%qldt_accr)      &
              + diag_3d(:,:,diag_pt%qldt_auto )     &
              + diag_3d(:,:,diag_pt%qidt_melt  )    &
              + diag_3d(:,:,diag_pt%rain_evap)      &
              + diag_3d(:,:,diag_pt%rain_freeze)    &
              - diag_3d(:,:,diag_pt%srfrain_accrs)  &
              - diag_3d(:,:,diag_pt%srfrain_freez)  &
              + diag_3d(:,:,diag_pt%neg_rain)       &
              - diag_3d(:,:,diag_pt%snow_melt )     &
              + diag_3d(:,:,diag_pt%qdt_snow2vapor) &
                                                         )
      endif
      if (diag_id%snow_imb + diag_id%snow_imb_col > 0) then

        if (Constants%do_rk_microphys) then
          diag_3d(:,:,diag_pt%snow_imb) =    &
             Precip_state%surfsnow(:,:)*Constants%inv_dtcloud -    &
               diag_3d(:,:,diag_pt%cld_ice_imb)  + (  &
                diag_3d(:,:,diag_pt%qldt_accrs)      &
              + diag_3d(:,:,diag_pt%qldt_bergs)      &
              + diag_3d(:,:,diag_pt%qidt_fall)       &
              + diag_3d(:,:,diag_pt%qidt_auto  )     &
              + diag_3d(:,:,diag_pt%qidt_accr  )     &
              - diag_3d(:,:,diag_pt%rain_freeze)     &
              + diag_3d(:,:,diag_pt%srfrain_accrs)   &
              + diag_3d(:,:,diag_pt%srfrain_freez)   &
              + diag_3d(:,:,diag_pt%snow_melt )      &
              + diag_3d(:,:,diag_pt%neg_snow)        &
              + diag_3d(:,:,diag_pt%qdt_snow_sublim) &
                                                         )
        else
          diag_3d(:,:,diag_pt%snow_imb) =    &
             Precip_state%surfsnow(:,:)*Constants%inv_dtcloud -    &
               diag_3d(:,:,diag_pt%cld_ice_imb)  + (  &
                diag_3d(:,:,diag_pt%qldt_accrs)       &
              + diag_3d(:,:,diag_pt%qldt_bergs)       &
              + diag_3d(:,:,diag_pt%qidt_auto  )      &
              + diag_3d(:,:,diag_pt%qidt_accr  )      &
              - diag_3d(:,:,diag_pt%rain_freeze)      &
              + diag_3d(:,:,diag_pt%srfrain_accrs)    &
              + diag_3d(:,:,diag_pt%srfrain_freez)    &
              + diag_3d(:,:,diag_pt%snow_melt )       &
              + diag_3d(:,:,diag_pt%neg_snow)         &
              + diag_3d(:,:,diag_pt%qdt_snow_sublim)  &
                                                        )
        endif
      endif
!------------------------------------------------------------------------
!SPECIAL CASES not following general pattern of above:
!yim: in-cloud droplet column burden
!------------------------------------------------------------------------
      IF ( diag_id%rain_mass_conv > 0   ) &
          diag_3d(:,:,diag_pt%rain_mass_conv) =   &
                          diag_4d(:,:,1,diag_pt%rain_mass_conv) 
      IF ( diag_id%snow_mass_conv > 0   ) &
          diag_3d(:,:,diag_pt%snow_mass_conv) =   &
                          diag_4d(:,:,1,diag_pt%snow_mass_conv) 

      if (diag_id%droplets_col > 0 .or. diag_id%gb_droplets_col > 0  .or. &
                                       diag_id%droplets_col250 > 0 ) then
        if (present (qn_in)) then
          N3D_col(:,:) = 0.
          N3D_col250(:,:) = 0.
          gb_N3D_col(:,:) = 0.
          do k =1,kdim
            do j=1,jdim
              do i=1,idim
! the current code:
                qa_new = qa_in(i,j,k) + SA_out(i,j,k)
                ql_new = ql_in(i,j,k) + SL_out(i,j,k)
                qn_new = qn_in(i,j,k) + SN_out(i,j,k)
                if (ql_new > qmin .and. &
                    qa_new > qmin .and. &
                    qn_new > qmin ) then      
!RSH 12/22/11 fix as per email from yim 11/3/11:
!                 dum = qn_new*Atmos_state%airdens(i,j,k)*  &
                  dum = qn_new*                             &
!RSH 12/22/11 fix as per email from yim 11/3/11:
!                                    Atmos_state%deltpg(i,j,k)*1.e-6
                                Atmos_state%deltpg(i,j,k)*1.e-4
                  if (qa_new > 0.05) then !count only columns with qa > 5% 
                    N3D_col(i,j) = N3D_col(i,j) + dum /min(qa_new,1.)
                    if (T_in(i,j,k) + st_out(i,j,k)  .ge. 250.) then
                      N3D_col250(i,j)  = N3D_col250(i,j) +   &
                                                     dum /min (qa_new, 1.)
                    endif
                  endif
                  gb_N3D_col(i,j) = gb_N3D_col(i,j) + dum
                endif
              end do
            end do
          end do
! end of current code
! the legacy equivalent
!NOTE: in addition to the error correction, the legacy code differs from 
!  the new code in that it is appplied to input fields rather than output i
!  fields.
!               if (ql_in(i,j,k) > qmin .and. &
!                   qa_in(i,j,k) > qmin .and. &
!                   qn_in(i,j,k) > qmin ) then      
!                 dum = qn_in(i,j,k)*Atmos_state%airdens(i,j,k)*  &
!                                    Atmos_state%deltpg(i,j,k)*1.e-6
!                 if (qa_new > 0.05) then !count only columns with qa > 5% 
!                   N3D_col(i,j) = N3D_col(i,j) + dum /min(qa_in(i,j,k),1.)
!                   if (T_in(i,j,k) + st_out(i,j,k)  .ge. 250.) then
!                     N3D_col250(i,j)  = N3D_col250(i,j) +   &
!                                               dum /min (qa_in(i,j,k), 1.)
!                   endif
!                 endif
!                 gb_N3D_col(i,j) = gb_N3D_col(i,j) + dum
!               endif
!             end do
!           end do
!         end do
! end of the legacy equivalent
          diag_3d(:,:,diag_pt%droplets_col) = N3D_col
          diag_3d(:,:,diag_pt%droplets_col250) = N3D_col250
          diag_3d(:,:,diag_pt%gb_droplets_col) = gb_N3D_col
        endif
      endif

!------------------------------------------------------------------------
!SPECIAL CASES not following general pattern of above:
!yim: in-cloud ice crystal column burden
!------------------------------------------------------------------------
      if (diag_id%nice_col > 0 .or. diag_id%gb_nice_col > 0) then
        if (present (qni_in)) then
          N3Di_col(:,:) = 0.
          gb_N3Di_col(:,:) = 0.
          do k=1,kdim
            do j=1,jdim
              do i=1,idim
                qa_new = qa_in(i,j,k) + SA_out(i,j,k)
                qi_new = qi_in(i,j,k) + SI_out(i,j,k)
                qni_new = qni_in(i,j,k) + SNi_out(i,j,k)
                if (qi_new > qmin .and. &
                    qa_new > qmin .and. &
                    qni_new  > qmin ) then
                  dum =  qni_new*Atmos_state%airdens(i,j,k)*  &
                                        Atmos_state%deltpg(i,j,k)*1.e-6
                  if (qa_new > 0.05) then !count only columns with qa > 5% 
                    N3Di_col(i,j) = N3Di_col(i,j) + dum /min(qa_new,1.)
                  endif
                  gb_N3Di_col(i,j) = gb_N3Di_col(i,j) + dum
                endif
              end do
            end do
          end do
          diag_3d(:,:,diag_pt%nice_col) = N3Di_col
          diag_3d(:,:,diag_pt%gb_nice_col) = gb_N3Di_col
        endif
      endif



!-------------------------------------------------------------------------
!    call strat_netcdf to output the requested netcdf diagnostics.
!-------------------------------------------------------------------------
      call strat_netcdf (diag_id, diag_pt, diag_4d, diag_4d_kp1, diag_3d, &
                         Time, is, js, kdim, MASK3d)

!-------------------------------------------------------------------------
!    deallocate the local allocatable variables. call strat_dealloc to 
!    deallocate the derived type variable components.
!-------------------------------------------------------------------------
      deallocate ( diag_4d )
      deallocate ( diag_4d_kp1 )
      deallocate ( diag_3d )
      call strat_dealloc (Atmos_state, Particles, Cloud_state,  &
                          Precip_state, Cloud_processes)

!------------------------------------------------------------------------
!    indicate exit from module for pe 0.
!------------------------------------------------------------------------
      if ( debugo4 .and. mpp_pe() .EQ.  0) then  
        write(outunit,*) "out stratcloud mod"
      endif
      call mpp_clock_end (sc_end)

!-----------------------------------------------------------------------


end subroutine strat_cloud_new




!#######################################################################

! <SUBROUTINE NAME="strat_cloud_end">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   This writes out a restart (if needed).
!  </DESCRIPTION>
!  <TEMPLATE>
!   call strat_cloud_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine strat_cloud_end()

!-------------------------------------------------------------------------
!---local variables-------------------------------------------------------

      integer  :: unit

!------------------------------------------------------------------------
      if (.not. module_is_initialized) return
       
!------------------------------------------------------------------------
!    write out restart file.
!------------------------------------------------------------------------
      if (do_netcdf_restart) then
        call strat_cloud_restart
      else
        if (mpp_pe() == mpp_root_pe()) then
          call mpp_error ('strat_cloud_mod',    &
                           'Writing native formatted restart file.', NOTE)
        endif
        unit = open_restart_file('RESTART/strat_cloud.res', ACTION='write')
        if (mpp_pe() == mpp_root_pe()) then
          write (unit) restart_versions(size(restart_versions(:)))
        endif
        call write_data (unit, nsum)
        call write_data (unit, qlsum)
        call write_data (unit, qisum)
        call write_data (unit, cfsum)
        call close_file (unit)
      endif
 
!--------------------------------------------------------------------------
!    call destructors for modules used by strat_cloud_mod.
!--------------------------------------------------------------------------
      if (running_old_code) then
        call strat_cloud_legacy_end (do_pdf_clouds)
      else
        call microphysics_end (Nml)
        call aerosol_cloud_end
        call nc_cond_end ( do_pdf_clouds )
        call polysvp_end
      endif
      call strat_netcdf_end

!------------------------------------------------------------------------
!    mark the module as uninitialized.
!------------------------------------------------------------------------
      module_is_initialized = .false.


end subroutine strat_cloud_end


!#######################################################################

!-----------------------------------------------------------------------
! <SUBROUTINE NAME="strat_cloud_sum">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!     This increments cloud variables for passing to radiation.
!     It is expected that this will become obsolete soon.
!  </DESCRIPTION>
!  <TEMPLATE>
!   call  strat_cloud_sum (is, js, ql, qi, cf)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!        Starting integer for longitude window.
!  </IN>
!  <IN NAME="js" TYPE="integer">
!        Starting integer for latitude window.
!  </IN>
!  <IN NAME="ql" TYPE="real">
!        Cloud liquid water specific humidity (kg/kg)
!  </IN>
!  <IN NAME="qi" TYPE="real">
!        Cloud ice water specific humidity (kg/kg)
!  </IN>
!  <IN NAME="cf" TYPE="real">
!        Cloud fraction (fraction, 0-1)
!  </IN>
! </SUBROUTINE>
!------------------------------------------------------------------------

subroutine strat_cloud_sum (is, js, ql, qi, cf)


!-----------------------------------------------------------------------
integer,                intent(in) :: is, js
real, dimension(:,:,:), intent(in) :: ql, qi, cf
!-----------------------------------------------------------------------

!------------------------------------------------------------------------
!----locla variables-----------------------------------------------------

      integer :: ie, je

!------------------------------------------------------------------------
      if (.not.module_is_initialized) then
        call error_mesg('strat_cloud_sum',     &
                              'strat_cloud_mod is not initialized',FATAL)
      endif

!-------------------------------------------------------------------------
!    define end indices of window.
!-------------------------------------------------------------------------
      ie = is + SIZE(ql,1) - 1
      je = js + SIZE(ql,2) - 1
     
!-------------------------------------------------------------------------
!    if radiation is being supplied time-averaged cloud fields, add the
!    current values to the accumulating sum.
!-------------------------------------------------------------------------
      if (do_average) then
       nsum(is:ie,js:je)   =  nsum(is:ie,js:je)   +  1
       qlsum(is:ie,js:je,:) = qlsum(is:ie,js:je,:) + ql
       qisum(is:ie,js:je,:) = qisum(is:ie,js:je,:) + qi
       cfsum(is:ie,js:je,:) = cfsum(is:ie,js:je,:) + cf

!-------------------------------------------------------------------------
!    if radiation is being supplied instantaneous cloud fields, save the 
!    current values in the accumulating sum arrays.
!-------------------------------------------------------------------------
      else
        nsum(is:ie,js:je)   =  1
        qlsum(is:ie,js:je,:) = ql
        qisum(is:ie,js:je,:) = qi
        cfsum(is:ie,js:je,:) = cf
      endif

!-----------------------------------------------------------------------


 end subroutine strat_cloud_sum


!#######################################################################

!-----------------------------------------------------------------------
! <SUBROUTINE NAME="strat_cloud_avg">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!      Averaging routine for cloud variables to be passed to radiation.
!      Expected to be removed shortly.
!  </DESCRIPTION>
!  <TEMPLATE>
!RSH!   call  strat_cloud_new_avg (is, js, ql, qi, cf, ierr)
!   call  strat_cloud_avg (is, js, ql, qi, cf, ierr)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
!      Starting integer for longitude window.
!  </IN>
!  <IN NAME="js" TYPE="integer">
!      Starting integer for latitude window.
!  </IN>
!  <OUT NAME="ql" TYPE="real">
!      Cloud liquid water specific humidity (kg/kg)
!  </OUT>
!  <OUT NAME="qi" TYPE="real">
!      Cloud ice water specific humidity (kg/kg)
!  </OUT>
!  <OUT NAME="cf" TYPE="real">
!      Cloud fraction (0-1)
!  </OUT>
!  <OUT NAME="ierr" TYPE="integer">
!      Error integer.
!  </OUT>
! </SUBROUTINE>
!-----------------------------------------------------------------------

subroutine strat_cloud_avg (is, js, ql, qi, cf, ierr)


!-----------------------------------------------------------------------
integer,                intent(in)  :: is, js
real, dimension(:,:,:), intent(out) :: ql, qi, cf
integer,                intent(out) :: ierr
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!----local variables---------------------------------------------------

      integer :: ie, je, num, k

!-----------------------------------------------------------------------
!    be sure module is initialized. check for agreement in size of  k-index
!    of argument and of module variable holding output.
!-----------------------------------------------------------------------
      if (.not.module_is_initialized) then
        call error_mesg ('strat_cloud_avg',    &
                                  'strat_cloud is not initialized',FATAL)
      endif
      if (SIZE(ql,3) /= SIZE(qlsum,3)) then
        call error_mesg ('strat_cloud_avg in strat_cloud_mod',  &
                              'input argument has the wrong SIZE',FATAL)
      endif

!-------------------------------------------------------------------------
!    define ending indices of current window.
!-------------------------------------------------------------------------
      ie = is + SIZE(ql,1) - 1
      je = js + SIZE(ql,2) - 1

!------------------------------------------------------------------------
!    determine if all values are available. if any are missing, return an
!    error code; otherwise compute average, and return the desired fields.
!------------------------------------------------------------------------
      num = count(nsum(is:ie,js:je) == 0)
      if (num > 0) then
        ierr = 1
      else
        do k=1, SIZE(ql,3)
          ql(:,:,k) = qlsum(is:ie,js:je,k)/float(nsum(is:ie,js:je))
          qi(:,:,k) = qisum(is:ie,js:je,k)/float(nsum(is:ie,js:je))
          cf(:,:,k) = cfsum(is:ie,js:je,k)/float(nsum(is:ie,js:je))
        enddo
        ierr = 0
      endif

!-------------------------------------------------------------------------
!    initialize the accumulation arrays so they are ready for the next 
!    access.
!-------------------------------------------------------------------------
      nsum (is:ie,js:je)   = 0
      qlsum(is:ie,js:je,:) = 0.0
      qisum(is:ie,js:je,:) = 0.0
      cfsum(is:ie,js:je,:) = 0.0

!-----------------------------------------------------------------------


 end subroutine strat_cloud_avg


!#######################################################################


!-------------------------------------------------------------------------
! <FUNCTION NAME="do_strat_cloud">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!     Logical function to indicate whether or not strat_cloud is running.
!  </DESCRIPTION>
!  <TEMPLATE>
!   result =  do_strat_cloud ( ) result (answer)
!
!  </TEMPLATE>
! </FUNCTION>
!-------------------------------------------------------------------------

function do_strat_cloud ( ) result (answer)


logical :: answer

!------------------------------------------------------------------------
!    define output value; it will be the value of module variable
!    strat_cloud_on.
!------------------------------------------------------------------------
      answer = strat_cloud_on


end function do_strat_cloud


!##########################################################################

!-------------------------------------------------------------------------
! <SUBROUTINE NAME="strat_cloud_restart">
!
! <DESCRIPTION>
! write out restart file.
! Arguments: 
!   timestamp (optional, intent(in)) : A character string that represents 
!                                      the model time, used for writing 
!                                      restart. timestamp will append to
!                                      any restart file name as a prefix. 
! </DESCRIPTION>
!
! </SUBROUTINE> 
!-------------------------------------------------------------------------

subroutine strat_cloud_restart(timestamp)

character(len=*), intent(in), optional :: timestamp

!-----------------------------------------------------------------------
!    write message indicating status of restart files. call routine to
!    output restart fields.
!-----------------------------------------------------------------------
      if (do_netcdf_restart) then
        if (mpp_pe() == mpp_root_pe()) then
          call mpp_error ('strat_cloud_mod',   &
            'Writing netCDF formatted restart file:  &
                                      &RESTART/strat_cloud.res.nc', NOTE)
        endif
        call save_restart(Str_restart, timestamp)
        if (in_different_file) call  save_restart(Til_restart, timestamp)
      else
        call error_mesg ('strat_cloud_mod', &
            'Native intermediate restart files are not supported.', FATAL)
      endif

!------------------------------------------------------------------------

end subroutine strat_cloud_restart




!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
!
!
!                         PRIVATE INTERFACES
!
!
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||





!########################################################################

subroutine fill_nml_variable

!------------------------------------------------------------------------
!    place the strat_cloud_nml variables in strat_nml_type variable Nml.
!------------------------------------------------------------------------
      Nml%do_netcdf_restart = do_netcdf_restart
      Nml%U00 = U00
      Nml%U00_profile = U00_profile
      Nml%rthresh = rthresh
      Nml%use_kk_auto = use_kk_auto 
      Nml%var_limit = var_limit
      Nml%use_online_aerosol = use_online_aerosol
      Nml%sea_salt_scale = sea_salt_scale
      Nml%om_to_oc = om_to_oc
      Nml%N_land = N_land
      Nml%use_sub_seasalt = use_sub_seasalt
      Nml%N_ocean = N_ocean
      Nml%U_evap = U_evap
      Nml%eros_scale = eros_scale
      Nml%eros_choice = eros_choice
      Nml%eros_scale_t = eros_scale_t
      Nml%eros_scale_c = eros_scale_c
      Nml%mc_thresh = mc_thresh
      Nml%diff_thresh = diff_thresh
      Nml%super_choice = super_choice
      Nml%tracer_advec = tracer_advec
      Nml%qmin = qmin
      Nml%Dmin = Dmin
      Nml%num_strat_pts = num_strat_pts

      if (num_strat_pts > 0) then
        allocate (Nml%strat_pts(2, num_strat_pts))
        Nml%strat_pts = strat_pts
      endif

      Nml%efact = efact
      Nml%vfact = vfact
      Nml%cfact = cfact
      Nml%do_old_snowmelt = do_old_snowmelt
      Nml%retain_cm3_bug  = retain_cm3_bug 
      Nml%do_pdf_clouds = do_pdf_clouds
      Nml%betaP = betaP
      Nml%iwc_crit = iwc_crit
      Nml%vfall_const2 = vfall_const2
      Nml%vfall_exp2 = vfall_exp2
      Nml%qthalfwidth = qthalfwidth
      Nml%nsublevels = nsublevels
      Nml%kmap = kmap
      Nml%kord = kord
      Nml%do_liq_num = do_liq_num
      Nml%do_dust_berg = do_dust_berg
      Nml%N_min = N_min
      Nml%num_mass_ratio1 = num_mass_ratio1
      Nml%num_mass_ratio2 = num_mass_ratio2
      Nml%microphys_scheme = microphys_scheme              
      Nml%macrophys_scheme = macrophys_scheme              
      Nml%aerosol_activation_scheme = aerosol_activation_scheme        
      Nml%mass_cons = mass_cons
      Nml%super_ice_opt = super_ice_opt
      Nml%pdf_org = pdf_org
      Nml%do_ice_nucl_wpdf = do_ice_nucl_wpdf
      Nml%do_hallet_mossop = do_hallet_mossop
      Nml%activate_all_ice_always = activate_all_ice_always
      Nml%debugo = debugo
      Nml%isamp = isamp
      Nml%jsamp = jsamp
      Nml%ksamp = ksamp

      Nml%qcvar = qcvar

!----------------------------------------------------------------------

end subroutine fill_nml_variable



!#######################################################################

subroutine strat_debug (otun, ST_out, SQ_out, Cloud_state, Precip_state,  &
                        Atmos_State)

integer,                 intent(in) :: otun
real, dimension(:,:,:),  intent(in) :: ST_out, SQ_out
type(cloud_state_type),  intent(in) :: Cloud_state
type(atmos_state_type),  intent(in) :: Atmos_state
type(precip_state_type), intent(in) :: Precip_state

      integer, dimension(3) :: maxl, minl

!------------------------------------------------------------------------
!    write numerous diagnostics to file otun to aid in debugging.
!------------------------------------------------------------------------
      write(otun, *)  "eee max, min ST ", MAXVAL(ST_out), MINVAL(ST_out)
      write(otun, *)  "eee maxloc, minloc  ", MAXLOC(ST_out),   &
                                                            MINLOC(ST_out)

      call check_nan (ST_out,'ST_out')


      write(otun, *)  "eee max, min SQ ", MAXVAL(SQ_out), MINVAL(SQ_out)
      write(otun, *)  "eee maxloc, minloc  ", MAXLOC(SQ_out),   &
                                                            MINLOC(SQ_out)
      call check_nan (SQ_out,'SQ_out')

      write(otun, *)  "eee max, min SL ", MAXVAL(Cloud_state%SL_out), &
                                                 MINVAL(Cloud_state%SL_out)
      write(otun, *)  "eee maxloc, minloc  ", MAXLOC(Cloud_state%SL_out),&
                                                 MINLOC(Cloud_state%SL_out)

      write(otun, *)  "eee max, min SI ", MAXVAL(Cloud_state%SI_out), &
                                                 MINVAL(Cloud_state%SI_out)
      write(otun, *)  "eee maxloc, minloc  ", MAXLOC(Cloud_state%SI_out),&
                                                 MINLOC(Cloud_state%SI_out)
      call check_nan   (Cloud_state%SI_out,'SI_out')

      write(otun, *)  "eee max, min SA ", MAXVAL(Cloud_state%SA_out), &
                                                MINVAL(Cloud_state%SA_out)
      write(otun, *)  "eee maxloc, minloc  ", MAXLOC(Cloud_state%SA_out),&
                                                 MINLOC(Cloud_state%SA_out)
      call check_nan   (Cloud_state%SA_out,'SA_out')

      write(otun, *)  "eee max, min SN ", MAXVAL(Cloud_state%SN_out), &
                                                MINVAL(Cloud_state%SN_out)
      write(otun, *)  "eee maxloc, minloc  ", &
                     MAXLOC(Cloud_state%SN_out), MINLOC(Cloud_state%SN_out)
      call check_nan   (Cloud_state%SN_out,'SN_out')

      write(otun, *)  "eee max, min SNi ", MAXVAL(Cloud_state%SNi_out),&
                                                MINVAL(Cloud_state%SNi_out)
      write(otun, *)  "eee maxloc, minloc  ", &
                   MAXLOC(Cloud_state%SNi_out), MINLOC(Cloud_state%SNi_out)
      call check_nan   (Cloud_state%SNi_out,'SNi_out')

      write(otun, *)  "--"
      write(otun, *)  "eee max, min T+ST ",  &
                                 MAXVAL(Atmos_state%T_in + ST_out),  &  
                                         MINVAL(Atmos_state%T_in + ST_out)

      write(otun, *)  "eee max, min qv+SQ ", &
                                 MAXVAL(Atmos_state%qv_in + SQ_out), &
                                        MINVAL(Atmos_state%qv_in + SQ_out)

      write(otun, *)  "eee max, min ql+ SL ",   &
                           MAXVAL(Cloud_state%ql_in+Cloud_state%SL_out),  &
                               MINVAL(Cloud_state%ql_in+Cloud_state%SL_out)

      write(otun, *)  "eee max, min qi +SI ",  &
                           MAXVAL(Cloud_state%qi_in+ Cloud_state%SI_out), &
                             MINVAL(Cloud_state%qi_in + Cloud_state%SI_out)

      write(otun, *)  "eee max, min qa + SA ",  &
                           MAXVAL(Cloud_state%qa_in+Cloud_state%SA_out),  &
                              MINVAL(Cloud_state%qa_in+Cloud_state%SA_out)

      write(otun, *)  "eee max, min qn + SN ",  &
                         MAXVAL(Cloud_state%qn_in + Cloud_state%SN_out), &
                            MINVAL(Cloud_state%qn_in + Cloud_state%SN_out)

      write(otun, *)  "eee max, min qni SNi ",   &
                        MAXVAL(Cloud_state%qni_in+ Cloud_state%SNi_out), &
                            MINVAL(Cloud_state%qni_in+Cloud_state%SNi_out)

      write(otun, *)  "--"
      write(otun, *)  "--"

      write(otun, *)  "eee max, min rain3d ",  &
                  MAXVAL(Precip_state%rain3d), MINVAL(Precip_state%rain3d)
      write(otun, *)  "eee maxloc, minloc  ",  &
                  MAXLOC(Precip_state%rain3d), MINLOC(Precip_state%rain3d)
      call check_nan   (Precip_state%rain3d,'rain3d')

      write(otun, *)  "eee max, min snow3d ",   &
                  MAXVAL(Precip_state%snow3d), MINVAL(Precip_state%snow3d)
      write(otun, *)  "eee maxloc, minloc  ",  &
                   MAXLOC(Precip_state%snow3d), MINLOC(Precip_state%snow3d)
      call check_nan   (Precip_state%snow3d,'snow3d')

      write(otun, *)  "--"
      write(otun, *)  "eee max, min surfrain ",   &
               MAXVAL(Precip_state%surfrain), MINVAL(Precip_state%surfrain)
      write(otun, *)  "eee maxloc, minloc  ",    &
               MAXLOC(Precip_state%surfrain), MINLOC(Precip_state%surfrain)

      write(otun, *)  "eee max, min surfsnow ",   &
               MAXVAL(Precip_state%surfsnow), MINVAL(Precip_state%surfsnow)
      write(otun, *)  "eee maxloc, minloc  ",   &
               MAXLOC(Precip_state%surfsnow), MINLOC(Precip_state%surfsnow)
      write(otun, *)  "--"

      IF ( MAXVAL(SQ_out + Cloud_state%ql_in) .GT. 1.e-1 )  &
                                            write(otun, *) " MMMMM Q1 "
      IF ( MAXVAL(SQ_out + Cloud_state%ql_in) .LT. 0. )   &
                                            write(otun, *) " MMMMM Q2 "

      IF ( MAXVAL(Cloud_state%SI_out + Cloud_state%qi_in) .LT. 0. )  &
                                            write(otun, *) " MMMMM I11 "
      IF ( MAXVAL(Cloud_state%SL_out + Cloud_state%ql_in) .LT. 0. )   &
                                            write(otun, *) " MMMMM L11 "

      IF ( MAXVAL(  &
              Cloud_state%qa_in+Cloud_state%SA_out+Atmos_state%ahuco)   &
                                               .GT. 1.00000000001  ) THEN
        write(otun, *) " MMMMMA1 ahuco "
        maxl =  maxloc (Cloud_state%qa_in + Cloud_state%SA_out +  &
                                                        Atmos_state%ahuco) 
        write(otun, *) "  maxloc(qa+SA) ",  &
             maxloc (Cloud_state%qa_in + Cloud_state%SA_out +  &
                                                         Atmos_state%ahuco)
        write(otun, *) " qa+SA+ahuco ",    &
                      Cloud_state%qa_in(maxl(1),maxl(2),maxl(3)) +     &
                          Cloud_state%SA_out(maxl(1),maxl(2),maxl(3)) +&
                              Atmos_state%ahuco(maxl(1),maxl(2),maxl(3))
        write(otun, *) " qa, ahuco, SA ",   &
                     Cloud_state%qa_in(maxl(1),maxl(2),maxl(3)),   &
                     Atmos_state%ahuco(maxl(1),maxl(2),maxl(3)),  &
                     Cloud_state%SA_out(maxl(1),maxl(2),maxl(3)) 

      END IF

      IF ( MINVAL(Cloud_state%qa_in+Cloud_state%SA_out) .LT. 0.  ) THEN
        minl =  minloc(Cloud_state%qa_in+Cloud_state%SA_out)
        write(otun, *) " MMMMMA2"
        write(otun, *) "  minloc(qa+SA) ",   &
                              minloc(Cloud_state%qa_in+Cloud_state%SA_out)
        write(otun, *) " qa+SA ", &
                         Cloud_state%qa_in(minl(1),minl(2),minl(3)) +  &
                                Cloud_state%SA_out(minl(1),minl(2),minl(3))
        write(otun, *) "    qa, SA ",  &
                           Cloud_state%qa_in(minl(1),minl(2),minl(3)),  &
                                Cloud_state%SA_out(minl(1),minl(2),minl(3))
      END IF

      IF ( MINVAL(Cloud_state%qn_in+Cloud_state%SN_out) .LT. 0.  ) THEN
        write(otun, *) " MMMMMN1"
        minl =  minloc(Cloud_state%qn_in+Cloud_state%SN_out)
        write(otun, *) "  minloc(qn+SN) ",  &
                           minloc(Cloud_state%qn_in+Cloud_state%SN_out)
        write(otun, *) "    qn, SN ",   &
                          Cloud_state%qn_in(minl(1),minl(2),minl(3)),  &
                          Cloud_state%SN_out(minl(1),minl(2),minl(3)) 
      END IF

      IF ( MAXVAL(Cloud_state%qi_in +    &
                                   Cloud_state%SI_out) .GT. 1.e-2 )   then
        maxl = MAXLOC(Cloud_state%qi_in + Cloud_state%SI_out)
        write(otun, *) " MMMMMII"
        write(otun, *) "  maxloc(qi+SI) ",    &
                              maxloc(Cloud_state%qi_in+Cloud_state%SI_out)
        write(otun, *) "  qi+SI " ,    &
                           Cloud_state%qi_in(maxl(1),maxl(2),maxl(3))+  &
                                Cloud_state%SI_out(maxl(1),maxl(2),maxl(3))
        write(otun, *) "  qi, SI " ,    &
                      Cloud_state%qi_in(maxl(1),maxl(2),maxl(3)),  &
                               Cloud_state%SI_out(maxl(1),maxl(2),maxl(3))
        write(otun, *) "  T ",    &
                     Atmos_state%T_in(maxl(1),maxl(2),maxl(3)),   &
                               Cloud_state%SI_out(maxl(1),maxl(2),maxl(3))
      END IF

      IF ( MAXVAL(Cloud_state%ql_in + Cloud_state%SL_out) .GT. 1.e-2 )   &
                                               write(otun, *) " MMMMMLL"
      IF ( MINVAL(Cloud_state%qni_in+Cloud_state%SNi_out) .LT. -1.e-5) &
                                                write(otun, *) " MMMMMN2"
      IF ( MAXVAL(ST_out) .GT. 7. ) write(otun, *) " MMMMMT1 "
      IF ( MINVAL(ST_out) .LT. - 7. ) write(otun, *) " MMMMMT2 "
      IF ( MAXVAL(Atmos_state%T_in+ST_out) .GT. 330. )   &
                                            write(otun, *) " MMMMMT3 "
      IF ( MINVAL(Atmos_state%T_in+ST_out) .LT. 170. )    &
                                               write(otun, *) " MMMMMT4 "

      IF  ( MINVAL(Precip_state%rain3d) .LT. 0. )   &
                                                write(otun, *) " MMMMMR1 "
      IF  ( MINVAL(Precip_state%snow3d) .LT. 0. )   &
                                                write(otun, *) " MMMMMS1 "

      IF ( MINVAL(Precip_state%surfrain) .LT. 0. )   &
                                                write(otun, *) " MMMMMX1 "
      IF ( MINVAL(Precip_state%surfsnow) .LT. 0. )   &
                                                write(otun, *) " MMMMMX2 "

!-------------------------------------------------------------------------


end subroutine strat_debug 



!#######################################################################

subroutine impose_realizability (idim, jdim, kdim, Atmos_state,  &
                                 Cloud_state, SQ_out, ST_out, N3d, N3Di,  &
                                 otun, n_diag_4d, diag_4d)

!-----------------------------------------------------------------------
!    account for the fact that other processes may have created negative 
!    tracer or extremely small values of tracer fields. the general reason
!    for the extremely small values of the tracer fields is due to vertical
!    diffusion, advection of condensate or cumulus induced subsidence (also
!    a form of advection) of condensate.
!    in this step any values of the prognostic variables which are less 
!    than qmin are reset to zero, while conserving total moisture.
!    note that this is done slightly different for the Tiedtke cloud 
!    fraction than it is for pdf clouds. In the former, the filling 
!    requires that cloud liquid, cloud ice, and cloud fraction are greater
!    than qmin. For PDF clouds, cloud fraction need not be considered 
!    since it is diagnosed later from the PDF cloud field.
!-----------------------------------------------------------------------

!-------------------------------------------------------------------------
integer,                                     intent(in)    :: idim, jdim, &
                                                              kdim
type( atmos_state_type),                     intent(inout) :: Atmos_state
type( cloud_state_type),                     intent(inout) :: Cloud_state
real, dimension(idim,jdim,kdim),             intent(inout) :: ST_out,  &
                                                              SQ_out, &
                                                              N3D, N3Di
integer,                                     intent(in)    :: otun,  &
                                                              n_diag_4d
real, dimension(idim,jdim,kdim,0:n_diag_4d), intent(inout) :: diag_4d
!-------------------------------------------------------------------------

!------------------------------------------------------------------------
!---local variables------------------------------------------------------

      logical, dimension(idim, jdim, kdim) :: ql_too_small, qi_too_small 
      integer :: i,j,k

!-----------------------------------------------------------------------
!    for the non-pdf scheme,  assure that cloud fraction is greater than 
!    qmin.  if it is not, set it to 0.0 and save the tendency and updated
!    value. save a diagnostic if requested.
!-----------------------------------------------------------------------
      if (.not. Nml%do_pdf_clouds) then
        where (Cloud_state%qa_in .le. Nml%qmin)
          Cloud_state%SA_out= Cloud_state%SA_out - Cloud_state%qa_in
          Cloud_state%qa_upd = 0.
        elsewhere
          Cloud_state%qa_upd = Cloud_state%qa_in     
        end where
        if (diag_id%qadt_fill + diag_id%qa_fill_col > 0 ) then
          where (Cloud_state%qa_in .le. Nml%qmin)
            diag_4d(:,:,:,diag_pt%qadt_fill) =  -Cloud_state%qa_in*   &
                                                    Constants% inv_dtcloud
          endwhere
        end if

!------------------------------------------------------------------------ 
!    define the max cloud area permitted (U01), which is equal to the 
!    grid box RH, under the assumption that the cloudy air is saturated 
!    and the temperature inside and outside of the cloud are ~ the same.
!    save a diagnostic indicating the amount cloud area was reduced due
!    to this requirenment,
!------------------------------------------------------------------------ 
        Atmos_state%U01 = min(Atmos_state%U01, 1.)
        if (diag_id%qadt_rhred + diag_id%qa_rhred_col >0) then
          where (Cloud_state%qa_upd .gt. Atmos_state%U01)
            diag_4d(:,:,:,diag_pt%qadt_rhred) = -(Cloud_state%qa_upd -  &
                                Atmos_state%U01)*Constants%inv_dtcloud
          endwhere
        end if
        
        where (Cloud_state%qa_upd .gt. Atmos_state%U01)
          Cloud_state%SA_out = Cloud_state%SA_out + Atmos_state%U01 -   &
                                                      Cloud_state%qa_upd
          Cloud_state%qa_upd = Atmos_state%U01      
        end where
      endif

!-------------------------------------------------------------------------
!    define the conditions under which liquid and ice filling must be done,
!    for both the pdf and non-pdf cases.
!    for the non-pdf scheme, the filling requires that cloud liquid, cloud
!    ice, and cloud fraction are greater than qmin.
!    for pdf clouds, cloud fraction need not be considered since it is 
!    diagnosed later from the PDF cloud field.
!-------------------------------------------------------------------------
      if (.not. Nml%do_pdf_clouds) then
        if (Nml%do_liq_num) then
          ql_too_small = (Cloud_state%ql_in .le. Nml%qmin .or.   &
                          Cloud_state%qa_in .le. Nml%qmin .or.   &
                          Cloud_state%qn_in .le. Nml%qmin)
        else
          ql_too_small = (Cloud_state%ql_in .le. Nml%qmin .or.   &
                          Cloud_state%qa_in .le. Nml%qmin)
        endif
        if (Constants%do_predicted_ice_number) then
             qi_too_small = (Cloud_state%qi_in .le.  Nml%qmin .or.   &
                          Cloud_state%qa_in .le. Nml%qmin .or.   &
                          Cloud_state%qni_in .le. Nml%qmin)
        else
          qi_too_small = (Cloud_state%qi_in .le.  Nml%qmin .or.   &
                          Cloud_state%qa_in .le. Nml%qmin)
        endif
      else
        if ( Nml%do_liq_num) then
          ql_too_small = (Cloud_state%ql_in .le.  Nml%qmin  .or.   &
                          Cloud_state%qn_in .le.  Nml%qmin)
        else
          ql_too_small = (Cloud_state%ql_in .le.  Nml%qmin)
        endif
        if (Constants%do_predicted_ice_number) then
             qi_too_small = (Cloud_state%qi_in .le.  Nml%qmin .or.   &
                          Cloud_state%qni_in .le. Nml%qmin)
        else
          qi_too_small = (Cloud_state%qi_in .le.  Nml%qmin )
        endif
      endif
  
!------------------------------------------------------------------------
!    determine if ql needs filling. if so, fill. save a diagnostic if 
!    requested. define tendency terms and update cloud liquid fields. 
!    include temperature and specific humidity adjustments to assure 
!    conservation. 
!------------------------------------------------------------------------
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            if (ql_too_small(i,j,k)) then
              Cloud_state%SL_out(i,j,k) = Cloud_state%SL_out(i,j,k) -   &
                                                   Cloud_state%ql_in(i,j,k)
              SQ_out(i,j,k) = SQ_out(i,j,k) + Cloud_state%ql_in(i,j,k)
              ST_out(i,j,k) = ST_out(i,j,k) -    &
                                        hlv*Cloud_state%ql_in(i,j,k)/cp_air
              Cloud_state%ql_upd(i,j,k) = 0.
            else
              Cloud_state%ql_upd(i,j,k) = Cloud_state%ql_in(i,j,k)
            endif
          end do
        end do
      end do
      if ( diag_id%qldt_fill  + diag_id%ql_fill_col > 0 ) then
        where (ql_too_small )
          diag_4d(:,:,:,diag_pt%qldt_fill) =   &
                            -1.*Cloud_state%ql_in*Constants%inv_dtcloud
        endwhere
      end if
      if ( diag_id%qdt_liquid_init > 0 ) then
        where (ql_too_small )
          diag_4d(:,:,:,diag_pt%qdt_liquid_init) =   &
                            Cloud_state%ql_in*Constants%inv_dtcloud
        endwhere
      end if

!------------------------------------------------------------------------
!    adjust cloud droplet numbers as needed when those fields
!    are being predicted. include diagnostics if requested. if droplet
!    number not being predicted, values are as set above, dependent on
!    whether column is over land or ocean.
!------------------------------------------------------------------------
      if (Nml%do_liq_num) then
        do k=1,kdim
          do j=1,jdim
            do i=1,idim
              if (ql_too_small(i,j,k)) then
                Cloud_state%SN_out(i,j,k) = Cloud_state%SN_out(i,j,k) -  &
                                                 Cloud_state%qn_in(i,j,k)
                Cloud_state%qn_upd(i,j,k) = 0.
                N3D(i,j,k)    = 0.
              else
                Cloud_state%qn_upd(i,j,k) = Cloud_state%qn_in(i,j,k)
                N3D(i,j,k) = Cloud_state%qn_in(i,j,k)*   &
                                       Atmos_state%airdens(i,j,k)*1.e-6
              endif
            end do
          end do
        end do
        if (diag_id%cf_liq_init   > 0)  then
          do k = 1,kdim
            do j=1,jdim
              do i = 1,idim
                if (ql_too_small(i,j,k)) then
                  diag_4d(i,j,k,diag_pt%cf_liq_init  ) = 0.
                else
                   diag_4d(i,j,k,diag_pt%cf_liq_init  ) =    &
                                         min(Cloud_state%qa_in(i,j,k),1.)
                endif
              end do
            end do
          end do
        endif 
        if ( diag_id%qndt_fill  + diag_id%qn_fill_col + &
                    diag_id%qldt_fill + diag_id%ql_fill_col > 0 ) then
          where (ql_too_small )
            diag_4d(:,:,:,diag_pt%qndt_fill) =    &
                           -1.*Cloud_state%qn_in*Constants%inv_dtcloud
          endwhere
        end if
      endif

!------------------------------------------------------------------------
!    determine if qi needs filling. if so, fill. save a diagnostic if 
!    requested. define tendency terms and update cloud ice fields. 
!    include temperature and specific humidity adjustments to assure 
!    conservation. adjust ice particle numbers as needed when those fields
!    are being predicted.
!------------------------------------------------------------------------
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            if (qi_too_small(i,j,k)) then
              Cloud_state%SI_out(i,j,k) = Cloud_state%SI_out(i,j,k) -   &
                                                   Cloud_state%qi_in(i,j,k)
              SQ_out(i,j,k) = SQ_out(i,j,k) + Cloud_state%qi_in(i,j,k)
              ST_out(i,j,k) = ST_out(i,j,k) -    &
                                        hls*Cloud_state%qi_in(i,j,k)/cp_air
              Cloud_state%qi_upd(i,j,k) = 0.
            else
              Cloud_state%qi_upd(i,j,k) = Cloud_state%qi_in(i,j,k)
            endif
          end do
        end do
      end do
      if (diag_id%qidt_fill  + diag_id%qi_fill_col > 0 ) then
        where (qi_too_small )
          diag_4d(:,:,:,diag_pt%qidt_fill) =     &
                              -1.*Cloud_state%qi_in *Constants%inv_dtcloud
        endwhere
      end if
      if (diag_id%qdt_ice_init > 0 ) then
        where (qi_too_small )
          diag_4d(:,:,:,diag_pt%qdt_ice_init) =     &
                             Cloud_state%qi_in *Constants%inv_dtcloud
        endwhere
      end if
      if (diag_id%cf_ice_init > 0) then
        where (qi_too_small)
          diag_4d(:,:,:,diag_pt%cf_ice_init) = 0.
        elsewhere
          diag_4d(:,:,:,diag_pt%cf_ice_init) = Cloud_state%qa_in
        end where
      endif
      if (Constants%do_mg_microphys .or. &
              Constants%do_mg_ncar_microphys) then
        if (Nml%debugo) then
          write(otun, *) " SNi 00 ",   &
                Cloud_state%SNi_out(Nml%isamp,Nml%jsamp,NMl%ksamp)*  &
                                                    Constants%inv_dtcloud
        end if
        where (qi_too_small) 
          Cloud_state%SNi_out  = Cloud_state%SNi_out - Cloud_state%qni_in
          Cloud_state%qni_upd=0.
          N3Di = 0.
        elsewhere
          Cloud_state%qni_upd = Cloud_state%qni_in
          N3Di  = Cloud_state%qni_in*Atmos_state%airdens*1.e-6
        end where

        if (diag_id%qnidt_fill  + diag_id%qni_fill_col > 0 ) then
          where (qi_too_small) 
            diag_4d(:,:,:,diag_pt%qnidt_fill) =  &
                           -1.*Cloud_state%qni_in *Constants%inv_dtcloud
          endwhere
        end if

        if (Nml%debugo) then
          write(otun, *) " SNi 01 ",   &
            Cloud_state%SNi_out(Nml%isamp,Nml%jsamp,Nml%ksamp)*   &
                                                  Constants%inv_dtcloud
          write(otun, *) "     qnidt_fill ",   &
               diag_4d(Nml%isamp,Nml%jsamp,Nml%ksamp,diag_pt%qnidt_fill) 
        end if
      else
        N3Di = 0.
      endif

!------------------------------------------------------------------------
!    save the cloud area tendency and updated area values at this point
!    for later use in the m-g microphysics.
!------------------------------------------------------------------------
      if (Constants%do_mg_microphys .or. &
              Constants%do_mg_ncar_microphys) then
        Cloud_state%qa_upd_0 = Cloud_state%qa_upd
        Cloud_state%SA_0 = Cloud_State%SA_out
      endif

!-------------------------------------------------------------------------

end subroutine impose_realizability 




!#########################################################################

subroutine strat_alloc (idim, jdim, kdim, pfull, phalf, zhalf, &
                        zfull, radturbten2, T_in, qv_in, ql_in, qi_in, &
                        qa_in, omega, Mc, diff_t, qrat, ahuco, &
                        Atmos_state, Particles, Cloud_state, Precip_state,&
                        Cloud_processes, qn_in, qni_in)

integer,                    intent(in)           :: idim, jdim, kdim
real,dimension(:,:,:),      intent(in)           ::    &
                      pfull, phalf, zfull, zhalf, radturbten2, &
                      T_in, qv_in, ql_in, qi_in, qa_in, omega, Mc,    &
                      diff_t, qrat, ahuco
type(atmos_state_type),     intent(inout)        :: Atmos_state
type(cloud_state_type),     intent(inout)        :: Cloud_state
type(precip_state_type),    intent(inout)        :: Precip_state
type(cloud_processes_type), intent(inout)        :: Cloud_processes
type(particles_type),       intent(inout)        :: Particles
real,dimension(:,:,:),      intent(in), optional :: qn_in, qni_in    


!-------------------------------------------------------------------------
!----local variables------------------------------------------------------

      integer :: k

!-----------------------------------------------------------------------
!    allocate and initialize the components of the atmos_state_type 
!    variable Atmos_state.
!-----------------------------------------------------------------------
      allocate (Atmos_state%pfull          (idim, jdim, kdim) )
      allocate (Atmos_state%phalf          (idim, jdim, kdim+1) )
      allocate (Atmos_state%zfull          (idim, jdim, kdim) )
      allocate (Atmos_state%zhalf          (idim, jdim, kdim+1) )
      allocate (Atmos_state%radturbten2    (idim, jdim, kdim) )
      allocate (Atmos_state%T_in           (idim, jdim, kdim) )
      allocate (Atmos_state%qv_in          (idim, jdim, kdim) )
      allocate (Atmos_state%omega          (idim, jdim, kdim) )
      allocate (Atmos_state%Mc             (idim, jdim, kdim) )
      allocate (Atmos_state%diff_t         (idim, jdim, kdim) )
      allocate (Atmos_state%qrat           (idim, jdim, kdim) )
      allocate (Atmos_state%ahuco          (idim, jdim, kdim) )
      allocate (Atmos_state%airdens        (idim, jdim, kdim) )
      allocate (Atmos_state%tn             (idim, jdim, kdim) )
      allocate (Atmos_state%qvn            (idim, jdim, kdim) )
      allocate (Atmos_state%qs             (idim, jdim, kdim) )
      allocate (Atmos_state%dqsdT          (idim, jdim, kdim) )
      allocate (Atmos_state%qsi            (idim, jdim, kdim) )
      allocate (Atmos_state%qsl            (idim, jdim, kdim) )
      allocate (Atmos_state%rh_crit        (idim, jdim, kdim) )
      allocate (Atmos_state%rh_crit_min    (idim, jdim, kdim) )
      allocate (Atmos_state%gamma          (idim, jdim, kdim) )
      allocate (Atmos_state%esat0          (idim, jdim, kdim) )
      allocate (Atmos_state%U_ca           (idim, jdim, kdim) )
      allocate (Atmos_state%delp           (idim, jdim, kdim) )
      allocate (Atmos_state%U01            (idim, jdim, kdim) )
      allocate (Atmos_state%deltpg         (idim, jdim, kdim) )

      Atmos_state%pfull       = pfull
      Atmos_state%phalf       = phalf
      Atmos_state%zhalf       = zhalf
      Atmos_state%zfull       = zfull
      Atmos_state%radturbten2 = radturbten2
      Atmos_state%T_in        = T_in
      Atmos_state%qv_in       = qv_in
      Atmos_state%omega       = omega
      Atmos_state%Mc          = Mc  
      Atmos_state%diff_t      = diff_t
      Atmos_state%qrat        = qrat
      Atmos_state%ahuco       = ahuco

!-----------------------------------------------------------------------
!    calculate pressure thickness of layer.
!-----------------------------------------------------------------------
      do k=1, kdim
        Atmos_state%deltpg(:,:,k) = (phalf(:,:,k+1) - phalf(:,:,k))/grav
      end do         

!-----------------------------------------------------------------------
!    calculate air density.   
!-----------------------------------------------------------------------
      where (qrat .gt. 0.) 
        Atmos_state%airdens = pfull/(rdgas*T_in*  &
                                (1. + (d608*qv_in/qrat) - ql_in - qi_in) )
      elsewhere
        Atmos_state%airdens = pfull/(rdgas*T_in*(1. - ql_in - qi_in) )
      end where

      Atmos_state%tn            = T_in
      Atmos_state%qvn           = 0.
      Atmos_state%qs            = 0.
      Atmos_state%dqsdT         = 0.
      Atmos_state%qsi           = 0.
      Atmos_state%qsl           = 0.
      Atmos_state%rh_crit       = 1.
      Atmos_state%rh_crit_min   = 1.
      Atmos_state%gamma         = 0.
      Atmos_state%esat0         = 0.
      Atmos_state%U_ca          = 0.
      do k = 1, kdim
        Atmos_state%delp(:,:,k) = phalf(:,:,k+1) - phalf(:,:,k)
      enddo     
      Atmos_state%U01           = 0.

!-----------------------------------------------------------------------
!    allocate and initialize the components of the particles_type 
!    variable Particles.
!-----------------------------------------------------------------------
      allocate (Particles%concen_dust_sub   (idim, jdim, kdim) )
      allocate (Particles%drop1             (idim, jdim, kdim) )
      allocate (Particles%drop2             (idim, jdim, kdim) )
      allocate (Particles%crystal1          (idim, jdim, kdim) )
      allocate (Particles%rbar_dust         (idim, jdim, kdim) )
      allocate (Particles%ndust             (idim, jdim, kdim) )
      allocate (Particles%hom               (idim, jdim, kdim) )

      Particles%concen_dust_sub   = 0.
      Particles%drop1    = 0.
      Particles%drop2    = 0.
      Particles%crystal1    = 0.
      Particles%rbar_dust   = 0.
      Particles%ndust   = 0.
      Particles%hom   = 0.

!-----------------------------------------------------------------------
!    allocate and initialize the components of the cloud_state_type 
!    variable Cloud_state.
!-----------------------------------------------------------------------
      allocate (Cloud_state%ql_upd    (idim, jdim, kdim) )
      allocate (Cloud_state%qi_upd    (idim, jdim, kdim) )
      allocate (Cloud_state%qa_upd    (idim, jdim, kdim) )
      allocate (Cloud_state%qn_upd    (idim, jdim, kdim) )
      allocate (Cloud_state%qni_upd   (idim, jdim, kdim) )
  
      allocate (Cloud_state%ql_mean   (idim, jdim, kdim) )
      allocate (Cloud_state%qi_mean   (idim, jdim, kdim) )
      allocate (Cloud_state%qa_mean   (idim, jdim, kdim) )
      allocate (Cloud_state%qn_mean   (idim, jdim, kdim) )
      allocate (Cloud_state%qni_mean  (idim, jdim, kdim) )
 
      allocate (Cloud_state%ql_in     (idim, jdim, kdim) )
      allocate (Cloud_state%qi_in     (idim, jdim, kdim) )
      allocate (Cloud_state%qa_in     (idim, jdim, kdim) )
      allocate (Cloud_state%qn_in     (idim, jdim, kdim) )
      allocate (Cloud_state%qni_in    (idim, jdim, kdim) )

      allocate (Cloud_state%SL_out    (idim, jdim, kdim) )
      allocate (Cloud_state%SI_out    (idim, jdim, kdim) )
      allocate (Cloud_state%SA_out    (idim, jdim, kdim) )
      allocate (Cloud_state%SN_out    (idim, jdim, kdim) )
      allocate (Cloud_state%SNi_out   (idim, jdim, kdim) )

      allocate (Cloud_state%qa_upd_0     (idim, jdim, kdim) )
      allocate (Cloud_state%SA_0         (idim, jdim, kdim) )

      Cloud_state%ql_upd    = 0.
      Cloud_state%qi_upd    = 0.
      Cloud_state%qa_upd    = 0.
      Cloud_state%qn_upd    = 0.
      Cloud_state%qni_upd   = 0.

      Cloud_state%ql_mean    = 0.      
      Cloud_state%qi_mean    = 0.      
      Cloud_state%qa_mean    = 0.      
      Cloud_state%qn_mean    = 0.      
      Cloud_state%qni_mean   = 0.      

      Cloud_state%ql_in = ql_in
      Cloud_state%qi_in = qi_in
      Cloud_state%qa_in = qa_in
      if (present(qn_in)) then
        Cloud_state%qn_in = qn_in
      else
        Cloud_state%qn_in = 0.
      end if

      if (present(qni_in)) then
        Cloud_state%qni_in  = qni_in
      else
        Cloud_state%qni_in  = 0.
      endif

      Cloud_state%SL_out  = 0.
      Cloud_state%SI_out  = 0.
      Cloud_state%SA_out  = 0.
      Cloud_state%SN_out  = 0.
      Cloud_state%SNi_out = 0.
    
      Cloud_state%qa_upd_0 = 0.
      Cloud_state%SA_0        = 0.

!-----------------------------------------------------------------------
!    allocate and initialize the components of the precip_state_type 
!    variable Precip_state.
!-----------------------------------------------------------------------
      allocate (Precip_state%lsc_snow      (idim, jdim, kdim) )
      allocate (Precip_state%lsc_rain      (idim, jdim, kdim) )
      allocate (Precip_state%lsc_snow_size (idim, jdim, kdim) )
      allocate (Precip_state%lsc_rain_size (idim, jdim, kdim) )
      allocate (Precip_state%qsout3d_mg    (idim, jdim, kdim) )
      allocate (Precip_state%qrout3d_mg    (idim, jdim, kdim) )
      allocate (Precip_state%rain3d        (idim, jdim, kdim+1) )
      allocate (Precip_state%snow3d        (idim, jdim, kdim+1) )
      allocate (Precip_state%snowclr3d     (idim, jdim, kdim+1) )
      allocate (Precip_state%surfrain      (idim, jdim) )
      allocate (Precip_state%surfsnow      (idim, jdim) )

      Precip_state%lsc_snow      = 0.
      Precip_state%lsc_rain      = 0.
      Precip_state%lsc_snow_size = 0.
      Precip_state%lsc_rain_size = 0.
      Precip_state%qsout3d_mg    = 0.
      Precip_state%qrout3d_mg    = 0.
      Precip_state%rain3d        = 0.
      Precip_state%snow3d        = 0.
      Precip_state%snowclr3d     = 0.
      Precip_state%surfrain      = 0.
      Precip_state%surfsnow      = 0.

!-----------------------------------------------------------------------
!    allocate and initialize the components of the cloud_processes_type
!    variable Cloud_processes.
!-----------------------------------------------------------------------
      allocate  (Cloud_processes%da_ls         (idim, jdim, kdim) )
      allocate  (Cloud_processes%D_eros        (idim, jdim, kdim) )
      allocate  (Cloud_processes%qvg           (idim, jdim, kdim) )
      allocate  (Cloud_processes%dcond_ls      (idim, jdim, kdim) )
      allocate  (Cloud_processes%dcond_ls_ice  (idim, jdim, kdim) )
      allocate  (Cloud_processes%dcond_ls_tot  (idim, jdim, kdim) )
      allocate  (Cloud_processes%delta_cf      (idim, jdim, kdim) )
      allocate  (Cloud_processes%f_snow_berg   (idim, jdim, kdim) )

      Cloud_processes%da_ls          = 0.
      Cloud_processes%D_eros         = 0.
      Cloud_processes%qvg            = 0.
      Cloud_processes%dcond_ls       = 0.
      Cloud_processes%dcond_ls_ice   = 0.
      Cloud_processes%dcond_ls_tot   = 0.
      Cloud_processes%delta_cf       = 0.
      Cloud_processes%f_snow_berg    = 0.

!--------------------------------------------------------------------------


end subroutine strat_alloc




!##########################################################################

subroutine strat_dealloc (Atmos_state, Particles, Cloud_State, &
                          Precip_state, Cloud_Processes)
      
!-----------------------------------------------------------------------
type(atmos_state_type),     intent(inout) :: Atmos_state
type(particles_type),       intent(inout) :: Particles   
type(cloud_state_type),     intent(inout) :: Cloud_state
type(precip_state_type),    intent(inout) :: Precip_state
type(cloud_processes_type), intent(inout) :: Cloud_processes


!-----------------------------------------------------------------------
!    deallocate the components of the atmos_state_type variable 
!    Atmos_State.
!-----------------------------------------------------------------------
      deallocate (Atmos_state%pfull       )
      deallocate (Atmos_state%phalf       )
      deallocate (Atmos_state%zfull       )
      deallocate (Atmos_state%zhalf       )
      deallocate (Atmos_state%radturbten2 )
      deallocate (Atmos_state%T_in        )
      deallocate (Atmos_state%qv_in       )
      deallocate (Atmos_state%omega       )
      deallocate (Atmos_state%Mc          )
      deallocate (Atmos_state%diff_t      )
      deallocate (Atmos_state%qrat        )
      deallocate (Atmos_state%ahuco       )
      deallocate (Atmos_state%airdens     )
      deallocate (Atmos_state%tn          )
      deallocate (Atmos_state%qvn         )
      deallocate (Atmos_state%qs          )
      deallocate (Atmos_state%dqsdT       )
      deallocate (Atmos_state%qsi         )
      deallocate (Atmos_state%qsl         )
      deallocate (Atmos_state%rh_crit     )
      deallocate (Atmos_state%rh_crit_min )
      deallocate (Atmos_state%gamma       )
      deallocate (Atmos_state%esat0       )
      deallocate (Atmos_state%U_ca        )
      deallocate (Atmos_state%delp        )
      deallocate (Atmos_state%U01         )
      deallocate (Atmos_state%deltpg      )
 
!-----------------------------------------------------------------------
!    deallocate the components of the particles_type variable Particles.
!-----------------------------------------------------------------------
      deallocate (Particles%concen_dust_sub )
      deallocate (Particles%drop1           )
      deallocate (Particles%drop2           )
      deallocate (Particles%crystal1        )
      deallocate (Particles%rbar_dust       )
      deallocate (Particles%ndust           )
      deallocate (Particles%hom             )

!-----------------------------------------------------------------------
!    deallocate the components of the cloud_state_type variable 
!    Cloud_state.
!-----------------------------------------------------------------------
      deallocate (Cloud_state%ql_upd  )
      deallocate (Cloud_state%qi_upd  )
      deallocate (Cloud_state%qa_upd  )
      deallocate (Cloud_state%qn_upd  )
      deallocate (Cloud_state%qni_upd )
      deallocate (Cloud_state%ql_mean )
      deallocate (Cloud_state%qi_mean )
      deallocate (Cloud_state%qa_mean )
      deallocate (Cloud_state%qn_mean )
      deallocate (Cloud_state%qni_mean)
      deallocate (Cloud_state%ql_in   )
      deallocate (Cloud_state%qi_in   )
      deallocate (Cloud_state%qa_in   )
      deallocate (Cloud_state%qn_in   )
      deallocate (Cloud_state%qni_in  )
      deallocate (Cloud_state%SL_out  )
      deallocate (Cloud_state%SI_out  )
      deallocate (Cloud_state%SA_out  )
      deallocate (Cloud_state%SN_out  )
      deallocate (Cloud_state%SNi_out )
      deallocate (Cloud_state%qa_upd_0)
      deallocate (Cloud_state%SA_0    )

!-----------------------------------------------------------------------
!    deallocate the components of the precip_state_type variable 
!    Precip_state.
!-----------------------------------------------------------------------
      deallocate (Precip_state%lsc_snow      )
      deallocate (Precip_state%lsc_rain      )
      deallocate (Precip_state%lsc_snow_size )
      deallocate (Precip_state%lsc_rain_size )
      deallocate (Precip_state%qsout3d_mg    )
      deallocate (Precip_state%qrout3d_mg    )
      deallocate (Precip_state%rain3d        )
      deallocate (Precip_state%snow3d        )
      deallocate (Precip_state%snowclr3d     )
      deallocate (Precip_state%surfrain      )
      deallocate (Precip_state%surfsnow      )

!-----------------------------------------------------------------------
!    deallocate the components of the cloud_processes_type variable 
!    Cloud_processes.
!-----------------------------------------------------------------------
      deallocate (Cloud_processes%da_ls       )
      deallocate (Cloud_processes%D_eros      )
      deallocate (Cloud_processes%qvg         )
      deallocate (Cloud_processes%dcond_ls    )
      deallocate (Cloud_processes%dcond_ls_ice)
      deallocate (Cloud_processes%dcond_ls_tot)
      deallocate (Cloud_processes%delta_cf    )
      deallocate (Cloud_processes%f_snow_berg )

!-------------------------------------------------------------------------

end subroutine strat_dealloc




!#######################################################################



end module strat_cloud_mod

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
! ice_grid_mod - sets up grid, processor domain, and does advection-Michael.Winton!
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
module ice_grid_mod

  use constants_mod,   only: radius, omega, pi
  use mpp_mod,         only: mpp_pe, mpp_npes, mpp_root_pe, mpp_error, NOTE, mpp_chksum
  use mpp_mod,         only: mpp_sync_self, mpp_send, mpp_recv, stdout, EVENT_RECV, COMM_TAG_1, NULL_PE
  use mpp_domains_mod, only: mpp_define_domains, CYCLIC_GLOBAL_DOMAIN, FOLD_NORTH_EDGE
  use mpp_domains_mod, only: mpp_update_domains, domain2D, mpp_global_field, YUPDATE, XUPDATE, CORNER
  use mpp_domains_mod, only: mpp_get_compute_domain, mpp_get_data_domain, mpp_set_domain_symmetry
  use mpp_domains_mod, only: mpp_define_io_domain, mpp_copy_domain, mpp_get_global_domain
  use mpp_domains_mod, only: mpp_set_global_domain, mpp_set_data_domain, mpp_set_compute_domain
  use mpp_domains_mod, only: mpp_deallocate_domain, mpp_get_pelist, mpp_get_compute_domains
  use mpp_domains_mod, only: SCALAR_PAIR, CGRID_NE, BGRID_NE
  use fms_mod,         only: error_mesg, FATAL, field_exist, field_size, read_data
  use fms_mod,         only: get_global_att_value, stderr
  use mosaic_mod,      only: get_mosaic_ntiles, get_mosaic_ncontacts
  use mosaic_mod,      only: calc_mosaic_grid_area, get_mosaic_contact
  use grid_mod,        only: get_grid_cell_vertices

  implicit none
  include 'netcdf.inc'
  private

  public :: set_ice_grid, dt_evp, evp_sub_steps, g_sum, ice_avg, all_avg
  public :: Domain, isc, iec, jsc, jec, isd, ied, jsd, jed, im, jm, km
  public :: dtw, dte, dts, dtn, dxt, dxv, dyt, dyv, cor, xb1d, yb1d
  public :: geo_lon, geo_lat, sin_rot, cos_rot, cell_area, wett, wetv
  public :: geo_lonv_ib, geo_latv_ib
  public :: dTdx, dTdy, t_on_uv, t_to_uv, uv_to_t, ice_advect
  public :: ice_line, vel_t_to_uv, cut_check, latitude, slab_ice_advect
  public :: dxdy, dydx, ice_grid_end
  public :: tripolar_grid, x_cyclic, dt_adv
  public :: reproduce_siena_201303

  type(domain2D), save :: Domain

  integer                           :: isc, iec, jsc, jec ! compute domain
  integer                           :: isd, ied, jsd, jed ! data domain
  integer                           :: im, jm, km         ! global domain and vertical size
  real, allocatable, dimension(:,:) :: wett, wetv         ! t and v cell masks
  !
  ! grid geometry
  !
  logical                           ::  x_cyclic           ! x boundary condition
  logical                           ::  tripolar_grid      ! y boundary condition
  real, allocatable, dimension(:,:) ::  dtw, dte, dts, dtn ! size of t cell sides
  real, allocatable, dimension(:,:) ::  dxt, dxv           ! x-extent of t and v cells
  real, allocatable, dimension(:,:) ::  dyt, dyv           ! y-extent of t and v cells
  real, allocatable, dimension(:,:) ::  dxdy, dydx         
  real, allocatable, dimension(:,:) ::  latitude           ! latitude of t cells
  real, allocatable, dimension(:,:) ::  cor                ! coriolis on v cells
  real, allocatable, dimension(:,:) ::  geo_lat            ! true latitude (rotated grid)
  real, allocatable, dimension(:,:) ::  geo_lon            ! true longitude              
  real, allocatable, dimension(:,:) ::  geo_latv_ib        ! true latitude at the grid corners
  real, allocatable, dimension(:,:) ::  geo_lonv_ib        ! true longitude at the grid corners
  real, allocatable, dimension(:  ) ::  xb1d, yb1d         ! 1d global grid for diag_mgr
  real, allocatable, dimension(:,:) ::  sin_rot, cos_rot   ! sin/cos of vector rotation angle
  real, allocatable, dimension(:,:) ::  cell_area          ! grid cell area; sphere frac.
  !
  ! timestep parameters
  !
  integer            :: evp_sub_steps                ! evp subcycles / timestep
  real               :: dt_evp = 0.0                 ! evp timestep (sec)
  integer            :: adv_sub_steps                ! advection steps / timestep
  real               :: dt_adv = 0.0                 ! advection timestep (sec)
  integer            :: comm_pe                      ! pe to be communicated with

  logical            :: reproduce_siena_201303 = .TRUE.

contains
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! ice_avg - take area weighted average over ice partiions                      !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  function ice_avg(x,part)
    real, dimension(:,:,:),    intent(in) :: x
    real, dimension(:,:,:),    intent(in) :: part
    real, dimension(size(x,1),size(x,2) ) :: ice_avg, ice_part

    integer :: i, j, k

    ice_part = 0.0
    ice_avg  = 0.0
    if (size(x,3)==km) then
       do k=2,km
          do j = 1, size(x,2)
             do i = 1, size(x,1)
                ice_avg(i,j) = ice_avg(i,j) + part(i,j,k)*x(i,j,k)
             enddo
          enddo
       enddo
    else if (size(x,3)==km-1) then
       do k=2,km
          do j = 1, size(x,2)
             do i = 1, size(x,1)
                ice_avg(i,j) = ice_avg(i,j) + part(i,j,k)*x(i,j,k-1)
             enddo
          enddo
       enddo
    end if

    do k=2,km
       ice_part = ice_part + part(:,:,k)
    enddo

    do j = 1, size(x,2)
       do i = 1, size(x,1)
          if(ice_part(i,j) > 0 ) then
             ice_avg(i,j) = ice_avg(i,j)/ice_part(i,j)
          else
             ice_avg(i,j) = 0
          endif
       enddo
    enddo
    return
  end function ice_avg

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! all_avg - take area weighted average over all partiions                      !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  function all_avg(x,part)
    real, dimension(:,:, :),             intent(in) :: x
    real, dimension(isc:,jsc:,:), intent(in) :: part
    real, dimension(isc:iec,jsc:jec)         :: all_avg

    integer :: k

    all_avg = 0.0
    if (size(x,3)==km) then
       do k=1,km
          all_avg = all_avg + part(:,:,k)*x(:,:,k)
       end do
    else
       do k=2,km
          all_avg = all_avg + part(:,:,k)*x(:,:,k-1)
       end do
    end if
    return
  end function all_avg

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! g_sum - returns the global sum of a real array                               !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  real function g_sum(x)
    real, dimension(:,:) :: x

    real, dimension(1 :im, 1 :jm) :: g_x

    call mpp_global_field(Domain, x, g_x)
    g_sum = sum(g_x)

    return
  end function g_sum

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! uv_to_t - average v-values to t-points and apply mask                        !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine uv_to_t(uv, t)
    real,    intent(in   ), dimension(isd:,jsd:) :: uv
    real,    intent(  out), dimension(isc:,jsc:) :: t

    integer :: i, j

    do j = jsc, jec
       do i = isc, iec
          if(wett(i,j) > 0.5 ) then
             t(i,j) = 0.25*(uv(i,j) + uv(i,j-1) + uv(i-1,j) + uv(i-1,j-1) )   
          else
             t(i,j) = 0.0
          endif
       enddo
    enddo

  end subroutine uv_to_t

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! dTdx - eastward difference of tracer, result on uv cells                     !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  function dTdx(T)
    real, intent(in   ), dimension(isd:,jsd:) :: T 
    real, dimension(isc:iec,jsc:jec)          :: dTdx

    integer :: i, j

    do j = jsc, jec
       do i = isc, iec
          DTdx(i,j) = 0.5*(T(i+1,j+1) - T(i,j+1) + T(i+1,j) - T(i,j) )
       enddo
    enddo

    return
  end function dTdx

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! dTdy - northward difference of tracer, result on uv cells                    !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  function dTdy(T)
    real, intent(in   ), dimension(isd:,jsd:) :: T 
    real, dimension(isc:iec,jsc:jec)          :: dTdy

    integer :: i, j

    do j = jsc, jec
       do i = isc, iec
          DTdy(i,j) = 0.5*(T(i+1,j+1) - T(i+1,j) + T(i,j+1) - T(i,j) )
       enddo
    enddo

    return
  end function dTdy

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! t_on_uv - average tracer to uv cells                                      !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  function t_on_uv(T)
    real, intent(in   ), dimension(isd:,jsd:) :: T 
    real, dimension(isc:iec,jsc:jec)          :: t_on_uv

    integer :: i, j

    do j = jsc, jec
       do i = isc, iec
          t_on_uv(i,j) = 0.25*(T(i+1,j+1)+T(i+1,j)+T(i,j+1)+T(i,j) )
       enddo
    enddo

    return
  end function t_on_uv

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! t_to_uv - average t-values to v-points and apply mask                        !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine t_to_uv(t, uv)
    real,    intent(in ), dimension(isd:,jsd:) :: t
    real,    intent(out), dimension(isc:,jsc:) :: uv

    integer :: i, j

    do j = jsc, jec
       do i = isc, iec
          if(wetv(i,j) > 0.5 ) then
             uv(i,j) = 0.25*( t(i+1, j+1)+t(i+1, j) + t(i,j+1)+t(i,j) )
          else
             uv(i,j) = 0.0
          endif
       enddo
    enddo

  end subroutine t_to_uv

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! vel_t_to_uv - average vel component on t-points to v-points and apply mask   !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine vel_t_to_uv(tx, ty, uvx, uvy)
    real,    intent(in   ), dimension(isd:,jsd:) :: tx, ty
    real,    intent(  out), dimension(isc:,jsc:) :: uvx, uvy

    integer :: i, j

    do j = jsc, jec
       do i = isc, iec
          if( wetv(i,j) > 0.5 ) then
             uvx(i,j) = 0.25*( tx(i+1, j+1)+tx(i+1, j) + tx(i,j+1)+tx(i,j) )
             uvy(i,j) = 0.25*( ty(i+1, j+1)+ty(i+1, j) + ty(i,j+1)+ty(i,j) )
          else
             uvx(i,j) = 0.0
             uvy(i,j) = 0.0
          endif
       enddo
    enddo

  end subroutine vel_t_to_uv

  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! set_ice_grid - initialize sea ice grid for dynamics and transport            !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine set_ice_grid(ice_domain, dt_slow, dyn_sub_steps_in, &
                          adv_sub_steps_in, km_in, layout, io_layout, maskmap )
    type(domain2D),        intent(inout) :: ice_domain
    real,                  intent(in)    :: dt_slow
    integer,               intent(in)    :: dyn_sub_steps_in
    integer,               intent(in)    :: adv_sub_steps_in
    integer,               intent(in)    :: km_in
    integer, dimension(2), intent(inout) :: layout
    integer, dimension(2), intent(inout) :: io_layout
    logical, optional,     intent(in)    :: maskmap(:,:)

    real                                :: angle, lon_scale
    integer                             :: i, j, m, ntiles, ncontacts, outunit
    integer                             :: dims(4)
    real, allocatable, dimension(:,:,:) :: x_vert_t, y_vert_t
    real, allocatable,   dimension(:,:) :: geo_latv   
    real, allocatable,   dimension(:,:) :: geo_lonv  
    real, allocatable,   dimension(:,:) :: depth, tmpx, tmpy, tmp_2d
    integer, dimension(2)               :: tile1, tile2
    integer, dimension(2)               :: istart1, iend1, jstart1, jend1
    integer, dimension(2)               :: istart2, iend2, jstart2, jend2
    integer, dimension(4)               :: start, nread
    character(len=80)                   :: domainname
    character(len=128)                  :: grid_file, ocean_topog
    character(len=256)                  :: ocean_hgrid, ocean_mosaic, attvalue
    type(domain2d)                      :: domain2
    integer                             :: isg, ieg, jsg, jeg
    integer                             :: is,  ie,  js,  je
    integer                             :: grid_version
    integer, parameter                  :: VERSION_0 = 0
    integer, parameter                  :: VERSION_1 = 1
    integer, parameter                  :: VERSION_2 = 2
    integer, allocatable, dimension(:)  :: pelist, islist, ielist, jslist, jelist
    integer                             :: npes, p
    logical                             :: symmetrize, ndivx_is_even, im_is_even


    grid_file = 'INPUT/grid_spec.nc'
    ocean_topog = 'INPUT/topog.nc'
    outunit = stdout()
    !--- first determine the grid version
    if(field_exist(grid_file, 'ocn_mosaic_file') .or. field_exist(grid_file, 'gridfiles') ) then ! read from mosaic file
       write(outunit,*) '==>Note from ice_grid_mod(set_ice_grid): read grid from mosaic version grid'
       grid_version = VERSION_2
       if( field_exist(grid_file, 'ocn_mosaic_file') ) then ! coupler mosaic
          call read_data(grid_file, "ocn_mosaic_file", ocean_mosaic)
          ocean_mosaic = "INPUT/"//trim(ocean_mosaic)
       else
          ocean_mosaic = trim(grid_file)
       end if
       ntiles = get_mosaic_ntiles(ocean_mosaic)
       if(ntiles .NE. 1) call mpp_error(FATAL, '==>Error from ice_grid_mod(set_ice_grid): '//&
            'ntiles should be 1 for ocean mosaic, contact developer')
       call read_data(ocean_mosaic, "gridfiles", ocean_hgrid)
       ocean_hgrid = 'INPUT/'//trim(ocean_hgrid)
    else  if(field_exist(grid_file, 'x_T')) then
       ocean_hgrid = grid_file
       write(outunit,*) '==>Note from ice_grid_mod(set_ice_grid): read grid from new version grid'
       grid_version = VERSION_1
    else if(field_exist(grid_file, 'geolon_t')) then
       ocean_hgrid = grid_file
       write(outunit,*) '==>Note from ice_grid_mod(set_ice_grid): read grid from old version grid'
       grid_version = VERSION_0 
    else
       call mpp_error(FATAL, '==>Error from ice_grid_mod(set_ice_grid): '//&
            'x_T, geolon_t, ocn_mosaic_file, gridfiles does not exist in file ' //trim(grid_file))
    end if

    x_cyclic = .false.; tripolar_grid = .false.
    if(grid_version == VERSION_2) then
       if(field_exist(ocean_mosaic, "contacts") ) then
          ncontacts = get_mosaic_ncontacts(ocean_mosaic)
          if(ncontacts < 1) call mpp_error(FATAL,'==>Error from ice_grid_mod(set_ice_grid): '//&
               'number of contacts should be larger than 0 when field contacts exist in file '//trim(ocean_mosaic) )
          if(ncontacts > 2) call mpp_error(FATAL,'==>Error from ice_grid_mod(set_ice_grid): '//&
               'number of contacts should be no larger than 2')
          call get_mosaic_contact( ocean_mosaic, tile1(1:ncontacts), tile2(1:ncontacts),           &
               istart1(1:ncontacts), iend1(1:ncontacts), jstart1(1:ncontacts), jend1(1:ncontacts), &
               istart2(1:ncontacts), iend2(1:ncontacts), jstart2(1:ncontacts), jend2(1:ncontacts)  )
          do m = 1, ncontacts
             if(istart1(m) == iend1(m) ) then  ! x-direction contact, only cyclic condition
                if(istart2(m) .NE. iend2(m) ) call mpp_error(FATAL,  &
                     "==>Error from ice_grid_mod(set_ice_grid): only cyclic condition is allowed for x-boundary")
                x_cyclic = .true.
             else if( jstart1(m) == jend1(m) ) then  ! y-direction contact, cyclic or folded-north
                if( jstart1(m) == jstart2(m) ) then ! folded north
                   tripolar_grid=.true.
                else 
                   call mpp_error(FATAL, "==>Error from ice_grid_mod(set_ice_grid): "//&
                     "only folded-north condition is allowed for y-boundary")
                end if
             else 
                call mpp_error(FATAL,  &
                     "==>Error from ice_grid_mod(set_ice_grid): invalid boundary contact")
             end if
          end do
       end if
       !--- get grid size
       call field_size(ocean_hgrid, 'x', dims)
       if(mod(dims(1),2) .NE. 1) call mpp_error(FATAL, '==>Error from ice_grid_mod(set_ice_grid): '//&
            'x-size of x in file '//trim(ocean_hgrid)//' should be 2*ni+1')
       if(mod(dims(2),2) .NE. 1) call mpp_error(FATAL, '==>Error from ice_grid_mod(set_ice_grid): '//&
            'y-size of x in file '//trim(ocean_hgrid)//' should be 2*nj+1')
       im = dims(1)/2 
       jm = dims(2)/2 
    else
       if( get_global_att_value(ocean_hgrid, "x_boundary_type", attvalue) ) then
          if(attvalue == 'cyclic') x_cyclic = .true.
       end if
       if( get_global_att_value(ocean_hgrid, "y_boundary_type", attvalue) ) then
          if(attvalue == 'cyclic') then
             call mpp_error(FATAL, "==>Error from ice_grid_mod(set_ice_grid): "//&
                  "y-cyclic boundary condition is not implemented yet.")
          else if(attvalue == 'fold_north_edge') then
             tripolar_grid = .true.
          end if
       end if
       !--- get the grid size
       call field_size(ocean_hgrid, 'wet', dims)
       im = dims(1)
       jm = dims(2)
    end if

    if(x_cyclic) then
       call mpp_error(NOTE, "==>Note from ice_grid_mod: x_boundary_type is cyclic")
    else
       call mpp_error(NOTE, "==>Note from ice_grid_mod: x_boundary_type is solid_walls")
    end if
   if(tripolar_grid) then
       call mpp_error(NOTE, "==>Note from ice_grid_mod: y_boundary_type is fold_north_edge")
    else
       call mpp_error(NOTE, "==>Note from ice_grid_mod: y_boundary_type is solid_walls")
    end if

    ! default is merdional domain decomp. to load balance xgrid
    if( layout(1)==0 .and. layout(2)==0 ) layout=(/ mpp_npes(), 1 /)
    if( layout(1)/=0 .and. layout(2)==0 ) layout(2) = mpp_npes()/layout(1)
    if( layout(1)==0 .and. layout(2)/=0 ) layout(1) = mpp_npes()/layout(2)
    domainname = 'ice model'
    if(tripolar_grid) then    
       !z1l: Tripolar grid requires symmetry in i-direction domain decomposition
       ndivx_is_even = (mod(layout(1),2) == 0)
       im_is_even    = (mod(im,2) == 0)
       symmetrize = ( ndivx_is_even .AND. im_is_even ) .OR. &
               (  (.NOT.ndivx_is_even) .AND.  (.NOT.im_is_even) ) .OR. &
               (  (.NOT.ndivx_is_even) .AND. im_is_even .AND. layout(1) .LT. im/2 )

       if( .not. symmetrize) then
          call mpp_error(FATAL, "ice_model(set_ice_grid): tripolar regrid requires symmetry in i-direction domain decomposition")
       endif
       call mpp_define_domains( (/1,im,1,jm/), layout, Domain, maskmap=maskmap,   &
                                xflags=CYCLIC_GLOBAL_DOMAIN, xhalo=1,             &
                                yflags=FOLD_NORTH_EDGE, yhalo=1, name=domainname )
    else if(x_cyclic) then
       call mpp_define_domains( (/1,im,1,jm/), layout, Domain, maskmap=maskmap,   &
                                xflags=CYCLIC_GLOBAL_DOMAIN, xhalo=1, yhalo=1, name=domainname )
    else
       call mpp_define_domains( (/1,im,1,jm/), layout, Domain, maskmap=maskmap,   &
                                xhalo=1, yhalo=1, name=domainname )
    endif
    call mpp_define_io_domain(Domain, io_layout)

    call mpp_get_compute_domain( Domain, isc, iec, jsc, jec )
    call mpp_get_data_domain( Domain, isd, ied, jsd, jed )
    call mpp_get_global_domain( Domain, isg, ieg, jsg, jeg )

    call mpp_define_domains( (/1,im,1,jm/), layout, ice_domain, maskmap=maskmap, name='ice_nohalo') ! domain without halo
    call mpp_define_io_domain(ice_domain, io_layout)


    allocate ( geo_lonv(isc:iec+1,jsc:jec+1), geo_latv(isc:iec+1,jsc:jec+1) )
    
    allocate ( wett   (isd:ied,jsd:jed), wetv   ( isc:iec,jsc:jec),  &
               dxt    (isd:ied,jsd:jed), dxv     (isd:ied,jsd:jed),  &
               dyt    (isd:ied,jsd:jed), dyv     (isd:ied,jsd:jed),  &
               dtw    (isc:iec,jsc:jec), dte     (isd:ied,jsd:jed),  &
               dts    (isc:iec,jsc:jec), dtn     (isd:ied,jsd:jed),  &
               dxdy   (isc:iec,jsc:jec), dydx    (isc:iec,jsc:jec),  &
               geo_lat(isc:iec,jsc:jec), geo_lon (isc:iec,jsc:jec),  &
               cor    (isc:iec,jsc:jec), sin_rot (isd:ied,jsd:jed),  &
               cos_rot(isd:ied,jsd:jed), latitude(isc:iec,jsc:jec) )
    allocate ( geo_latv_ib(isc:iec,jsc:jec), geo_lonv_ib(isc:iec,jsc:jec) )
    !--- read data from grid_spec.nc
    wett = 0.0
    if(grid_version == VERSION_2) then
       allocate(depth(isc:iec,jsc:jec))
       call read_data(ocean_topog, 'depth', depth(isc:iec,jsc:jec), Domain)
       do j = jsc, jec
          do i = isc, iec
             if(depth(i,j) > 0) wett(i,j) = 1.0
          end do
       end do
       deallocate(depth)
    else
       call read_data(grid_file, 'wet', wett(isc:iec,jsc:jec), Domain)
    end if
    call mpp_update_domains(wett, Domain)

    do j = jsc, jec
       do i = isc, iec
          if( wett(i,j)>0.5 .and. wett(i,j+1)>0.5 .and. wett(i+1,j)>0.5 .and. wett(i+1,j+1)>0.5 ) then
             wetv(i,j) = 1.0
          else
             wetv(i,j) = 0.0
          endif
       enddo
    enddo

    if(tripolar_grid) then
       if (jsc==1.and.any(wett(:,jsc)>0.5)) call error_mesg ('ice_model_mod', &
            'ice model requires southernmost row of land', FATAL);
    endif

    evp_sub_steps = dyn_sub_steps_in
    if (evp_sub_steps>0) then
       dt_evp = dt_slow/evp_sub_steps
    else                            ! evp_sub_steps==0 means no dynamics
       dt_evp = dt_slow              ! but set dt>0 to avoid divide by zero
    end if

    adv_sub_steps = adv_sub_steps_in
    if (adv_sub_steps>0) then
       dt_adv = dt_slow/adv_sub_steps
    else                            ! adv_sub_steps==0 means no advection
       dt_adv = dt_slow              ! but set dt>0 to avoid divide by zero
    end if

    km = km_in

    allocate ( cell_area(isc:iec,jsc:jec) )
    select case(grid_version)
    case(VERSION_0)
       call mpp_copy_domain(domain, domain2)
       call mpp_set_compute_domain(domain2, isc, iec+1, jsc, jec+1, iec-isc+2, jec-jsc+2 )
       call mpp_set_data_domain   (domain2, isd, ied+1, jsd, jed+1, ied-isd+2, jed-jsd+2 )   
       call mpp_set_global_domain (domain2, isg, ieg+1, jsg, jeg+1, ieg-isg+2, jeg-jsg+2 )
       call read_data(grid_file, 'geolon_vert_t', geo_lonv, domain2)
       call read_data(grid_file, 'geolat_vert_t', geo_latv, domain2)  
       call read_data(grid_file, 'AREA_OCN', cell_area, Domain)    
    case(VERSION_1)
       allocate ( x_vert_t(isc:iec,jsc:jec,4), y_vert_t(isc:iec,jsc:jec,4) )
       call read_data(grid_file, 'x_vert_T', x_vert_t,  Domain)
       call read_data(grid_file, 'y_vert_T', y_vert_t,  Domain)
       call read_data(grid_file, 'AREA_OCN', cell_area, Domain)
       geo_lonv(isc:iec,jsc:jec) = x_vert_t(isc:iec,jsc:jec,1)
       geo_lonv(iec+1,  jsc:jec) = x_vert_t(iec,jsc:jec,    2)
       geo_lonv(isc:iec,jec+1  ) = x_vert_t(isc:iec,jec,    4)
       geo_lonv(iec+1,  jec+1  ) = x_vert_t(iec,jec,        3)
       geo_latv(isc:iec,jsc:jec) = y_vert_t(isc:iec,jsc:jec,1)
       geo_latv(iec+1,  jsc:jec) = y_vert_t(iec,jsc:jec,    2)
       geo_latv(isc:iec,jec+1  ) = y_vert_t(isc:iec,jec,    4)
       geo_latv(iec+1,  jec+1  ) = y_vert_t(iec,    jec,    3)
       deallocate(x_vert_t, y_vert_t)
    case(VERSION_2)
       call mpp_copy_domain(domain, domain2)
       call mpp_set_compute_domain(domain2, 2*isc-1, 2*iec+1, 2*jsc-1, 2*jec+1, 2*(iec-isc)+3, 2*(jec-jsc)+3 )
       call mpp_set_data_domain   (domain2, 2*isd-1, 2*ied+1, 2*jsd-1, 2*jed+1, 2*(ied-isd)+3, 2*(jed-jsd)+3 )   
       call mpp_set_global_domain (domain2, 2*isg-1, 2*ieg+1, 2*jsg-1, 2*jeg+1, 2*(ieg-isg)+3, 2*(jeg-jsg)+3 )   
       call mpp_get_compute_domain(domain2, is, ie, js, je)
       if(is .NE. 2*isc-1 .OR. ie .NE. 2*iec+1 .OR. js .NE. 2*jsc-1 .OR. je .NE. 2*jec+1) then
          call mpp_error(FATAL, 'ice_grid_mod: supergrid domain is not set properly')
       endif
       allocate(tmpx(is:ie, js:je), tmpy(is:ie, js:je) )
       call read_data(ocean_hgrid, 'x', tmpx, domain2)
       call read_data(ocean_hgrid, 'y', tmpy, domain2)     
       do j = jsc, jec+1
          do i = isc, iec+1
             geo_lonv(i,j) = tmpx(2*i-1,2*j-1)
             geo_latv(i,j) = tmpy(2*i-1,2*j-1)
          end do
       end do
       call calc_mosaic_grid_area(geo_lonv(isc:iec+1, jsc:jec+1)*pi/180, geo_latv(isc:iec+1, jsc:jec+1)*pi/180, cell_area)
       cell_area = cell_area/(4*PI*RADIUS*RADIUS)
       deallocate(tmpx, tmpy)
       do j = jsc, jec
          do i = isc, iec
             if(wett(i,j) ==0) cell_area(i,j) = 0.0
          end do
       end do       
       call mpp_deallocate_domain(domain2)
    end select

    allocate ( xb1d (im+1), yb1d (jm+1) )

    if(PRESENT(maskmap)) then    
       allocate(tmpx(im+1,jm+1), tmpy(im+1,jm+1))
       call get_grid_cell_vertices('OCN', 1, tmpx, tmpy)
       xb1d = sum(tmpx,2)/(jm+1)
       yb1d = sum(tmpy,1)/(im+1)
       deallocate(tmpx, tmpy)

    else if (grid_version == VERSION_2) then
       allocate(tmpx(2*im + 1, 2), tmpy(2, 2*jm + 1))

       ! Default index span initialization
       start(:) = 1; nread(:) = 1

       ! Read x-axis along y[0]
       start(1) = 1; nread(1) = 2*im + 1
       start(2) = 2; nread(2) = 2
       call read_data(ocean_hgrid, 'x', tmpx, start, nread, no_domain=.true.)
       xb1d(:) = tmpx(::2, 1)

       ! Read y-axis along x[im/4]
       ! NOTE: At x[im/4], dy is constant for a standard global tripole grid
       start(1) = 2*(im/4) + 1; nread(1) = 2
       start(2) = 1; nread(2) = 2*jm + 1
       call read_data(ocean_hgrid, 'y', tmpy, start, nread, no_domain=.true.)
       yb1d(:) = tmpy(1, ::2)

       deallocate(tmpx, tmpy)

    else
       ! For non-mosaic grids, calculate the mean axis values across the grid

       allocate ( tmpx(isc:iec+1, jm+1) )
       call mpp_set_domain_symmetry(Domain, .TRUE.)
       call mpp_global_field(Domain, geo_lonv, tmpx, flags=YUPDATE, position=CORNER)
       allocate ( tmp_2d(isc:iec+1, jsc:jec+1) )
       tmp_2d = 0
       tmp_2d(isc:iec+1,jsc) = sum(tmpx,2)/(jm+1);
       deallocate(tmpx)
       allocate ( tmpx(im+1, jsc:jec+1) )

       call mpp_global_field(Domain, tmp_2d, tmpx, flags=XUPDATE, position=CORNER)
       xb1d = tmpx(:,jsc)
       deallocate(tmpx, tmp_2d)

       allocate ( tmpy(im+1, jsc:jec+1) )
       call mpp_global_field(Domain, geo_latv, tmpy, flags=XUPDATE, position=CORNER)
       allocate ( tmp_2d(isc:iec+1, jsc:jec+1) )
       tmp_2d = 0
       tmp_2d(isc,jsc:jec+1) = sum(tmpy,1)/(im+1);
       deallocate(tmpy)
       allocate ( tmpy(isc:iec+1, jm+1) )
       call mpp_global_field(Domain, tmp_2d, tmpy, flags=YUPDATE, position=CORNER)
       yb1d = tmpy(isc,:)
       deallocate(tmpy, tmp_2d)
       call mpp_set_domain_symmetry(Domain, .FALSE.)
    endif

    dte = 0.0
    dtn = 0.0
    cos_rot = 0.0
    sin_rot = 0.0

    do j=jsc,jec
       do i=isc,iec
          dts(i,j)     = edge_length(geo_lonv(i,j),  geo_latv(i,j), geo_lonv(i+1,j),geo_latv(i+1,j))
          dtn(i,j)     = edge_length(geo_lonv(i,j+1),geo_latv(i,j+1), geo_lonv(i+1,j+1),geo_latv(i+1,j+1))
          dtw(i,j)     = edge_length(geo_lonv(i,j),  geo_latv(i,j), geo_lonv(i,j+1),geo_latv(i,j+1))
          dte(i,j)     = edge_length(geo_lonv(i+1,j),geo_latv(i+1,j),geo_lonv(i+1,j+1),geo_latv(i+1,j+1))
          lon_scale    = cos((geo_latv(i,j  )+geo_latv(i+1,j  )+geo_latv(i,j+1)+geo_latv(i+1,j+1))*atan(1.0)/180)
          angle        = atan2((geo_lonv(i,j+1)+geo_lonv(i+1,j+1)-geo_lonv(i,j)-geo_lonv(i+1,j))&
                         *lon_scale, geo_latv(i,j+1)+geo_latv(i+1,j+1)-geo_latv(i,j)-geo_latv(i+1,j) )
          sin_rot(i,j) = sin(angle) ! angle is the clockwise angle from lat/lon to ocean
          cos_rot(i,j) = cos(angle) ! grid (e.g. angle of ocean "north" from true north)
       end do
    end do

    if(reproduce_siena_201303) then
       call mpp_update_domains(dte, Domain)
       call mpp_update_domains(dtn, Domain)
    else
       call mpp_update_domains(dte, dtn, Domain, gridtype=CGRID_NE, flags = SCALAR_PAIR)
    endif
    call mpp_update_domains(cos_rot, Domain)
    call mpp_update_domains(sin_rot, Domain)

    dxt = 0.0
    dyt = 0.0

    do j = jsc, jec
       do i = isc, iec
          dxt(i,j) = (dts(i,j) + dtn(i,j) )/2
          if(cell_area(i,j) > 0.0) then
             dyt(i,j) = cell_area(i,j)*4*pi*radius*radius/dxt(i,j)
          else
             dyt(i,j) = (dtw(i,j) + dte(i,j) )/2
          endif
       enddo
    enddo

    call mpp_update_domains(dxt, Domain )
    call mpp_update_domains(dyt, Domain )

    dxv = 1.0
    dyv = 1.0

    dxv(isc:iec,jsc:jec) = t_on_uv(dxt)
    dyv(isc:iec,jsc:jec) = t_on_uv(dyt)

    if(reproduce_siena_201303) then
       call mpp_update_domains(dxv, Domain )
       call mpp_update_domains(dyv, Domain )
    else
       call mpp_update_domains(dxv, dyv, Domain, gridtype=BGRID_NE, flags=SCALAR_PAIR )
    endif

    !--- dxdy and dydx to be used by ice_dyn_mod.
    dydx = dTdx(dyt)
    dxdy = dTdy(dxt)

    do j=jsc,jec
       do i = isc,iec
          geo_lon(i,j) = lon_avg( (/ geo_lonv(i,j  ), geo_lonv(i+1,j  ), &
                         geo_lonv(i,j+1), geo_lonv(i+1,j+1) /) )
          geo_lonv_ib(i,j) = geo_lonv(i+1,j+1)
          geo_latv_ib(i,j) = geo_latv(i+1,j+1)
       end do
    end do

    geo_lat  = (geo_latv(isc:iec,jsc:jec) + geo_latv(isc+1:iec+1,jsc:jec) &
               +geo_latv(isc:iec,jsc+1:jec+1)+geo_latv(isc+1:iec+1,jsc+1:jec+1))/4
    cor      = 2*omega*sin(geo_latv(isc+1:iec+1,jsc+1:jec+1)*pi/180)
    latitude = geo_lat(isc:iec,jsc:jec)*pi/180

    deallocate (geo_lonv, geo_latv)

    !--- z1l: loop through the pelist to find the symmetry processor.
    !--- This is needed to address the possibility that some of the all-land processor 
    !--- regions are masked out. This is only needed for tripolar grid.
    if(tripolar_grid) then
       npes = mpp_npes()
       allocate(pelist(npes), islist(npes), ielist(npes), jslist(npes), jelist(npes))
       call mpp_get_pelist(Domain, pelist)
       call mpp_get_compute_domains(Domain, xbegin=islist, xend=ielist, ybegin=jslist, yend=jelist)

       comm_pe = NULL_PE
 
       do p = 1, npes
          if( jslist(p) == jsc .AND. islist(p) + iec == im+1 ) then
             if( jelist(p) .NE. jec ) then
                call mpp_error(FATAL, "ice_model: jelist(p) .NE. jec but jslist(p) == jsc")
             endif
             if( ielist(p) + isc .NE. im+1) then
                call mpp_error(FATAL, "ice_model: ielist(p) + isc .NE. im+1 but islist(p) + iec == im+1")
             endif
             comm_pe = pelist(p)
             exit 
          endif
       enddo
       deallocate(pelist, islist, ielist, jslist, jelist)
    endif
!    comm_pe = mpp_pe() + layout(1) - 2*mod(mpp_pe()-mpp_root_pe(),layout(1)) - 1

    return
  end subroutine set_ice_grid

  !#####################################################################
  !--- release memory
  subroutine ice_grid_end

     deallocate(wett, wetv, dtw, dte, dts, dtn, dxt, dxv, dyt, dyv, latitude )
     deallocate(cor, geo_lat, geo_lon, xb1d, yb1d, sin_rot, cos_rot, cell_area )


  end subroutine ice_grid_end

  !#####################################################################

  real function lon_avg(lons)
    real, dimension(:), intent(in) :: lons

    real, dimension(size(lons(:))) :: lons2 ! lons relative to lon(1)
    integer                        :: i

    lons2(1) = 0.0
    do i=2,size(lons(:))
       lons2(i) = lons(i)-lons(1)
       if (lons2(i) >  180) lons2(i) = lons2(i) - 360;
       if (lons2(i) < -180) lons2(i) = lons2(i) + 360;
    end do
    lon_avg = lons(1)+sum(lons2)/size(lons(:))
  end function lon_avg

  !#####################################################################
  function edge_length(x1, y1, x2, y2)
    real, intent(in) :: x1, x2, y1, y2 ! end-point coordinates in degrees
    real             :: edge_length
    real             :: dx, dy

    dx = (x2-x1)*cos((atan(1.0)/45)*(y2+y1)/2)
    dy = y2-y1
    edge_length = radius*(atan(1.0)/45)*(dx*dx+dy*dy)**0.5
  end function edge_length

  !#####################################################################
  subroutine ice_line(year, day, second, cn, sst)
    integer,                               intent(in) :: year, day, second
    real, dimension(isc:,jsc:,1:),   intent(in) :: cn
    real, dimension(isc:,jsc:),      intent(in) :: sst

    real, dimension(isc:iec,jsc:jec) :: x
    real                             :: gx(3)
    integer                          :: i

    do i=-1,1,2
       x = 0.0
       where (cn(:,:,1)<0.85 .and. i*geo_lat>0.0) x=cell_area
       gx((i+3)/2) = g_sum(x)*4*pi*radius*radius/1e12
    end do
    gx(3) = g_sum(sst*cell_area)/(g_sum(cell_area)+1e-10)
    !
    ! print info every 5 days
    !
    if ( mpp_pe()==0 .and. second==0 .and. mod(day,5)==0 ) &
       print '(a,2I4,3F10.5)','ICE y/d (SH_ext NH_ext SST):', year, day, gx
  end subroutine ice_line

  !#####################################################################
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! ice_advect - take adv_sub_steps upstream advection timesteps                 !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine ice_advect(uc, vc, trc, uf, vf)
    real, intent(in   ),           dimension(isd:,jsd:) :: uc, vc  ! advecting velocity on C-grid
    real, intent(inout),           dimension(isd:,jsd:) :: trc     ! tracer to advect
    real, optional, intent(inout), dimension(isc:,jsc:) :: uf, vf

    integer                          :: l, i, j
    real, dimension(isd:ied,jsd:jed) ::  uflx, vflx

    if (adv_sub_steps==0) return;

    if (present(uf)) uf = 0.0
    if (present(vf)) vf = 0.0

    uflx = 0.0
    vflx = 0.0

    do l=1,adv_sub_steps
       do j = jsd, jec
          do i = isd, iec
             if( uc(i,j) > 0.0 ) then
                uflx(i,j) = uc(i,j) * trc(i,j) * dte(i,j)
             else
                uflx(i,j) = uc(i,j) * trc(i+1,j) * dte(i,j)
             endif

             if( vc(i,j) > 0.0 ) then
                vflx(i,j) = vc(i,j) * trc(i,j) * dtn(i,j)
             else
                vflx(i,j) = vc(i,j) * trc(i,j+1) * dtn(i,j)
             endif
          enddo
       enddo

       do j = jsc, jec
          do i = isc, iec
             trc(i,j) = trc(i,j) + dt_adv * ( uflx(i-1,j) - uflx(i,j) + &
                        vflx(i,j-1) - vflx(i,j) )/ ( dxt(i,j) * dyt(i,j) ) 
          enddo
       enddo

       call mpp_update_domains(trc, Domain)

       if (present(uf)) then
          do j = jsc, jec
             do i = isc, iec       
                uf(i,j) = uf(i,j) + uflx(i,j)
             enddo
          enddo
       endif

       if (present(vf)) then
          do j = jsc, jec
             do i = isc, iec       
                vf(i,j) = vf(i,j) + vflx(i,j)
             enddo
          enddo
       endif

    end do

    if (present(uf)) uf = uf/adv_sub_steps;
    if (present(vf)) vf = vf/adv_sub_steps;

  end subroutine ice_advect

  !#####################################################################
  subroutine slab_ice_advect(ui, vi, trc, stop_lim)
    real, intent(in   ), dimension(isd:,jsd:) :: ui, vi       ! advecting velocity
    real, intent(inout), dimension(isd:,jsd:) :: trc          ! tracer to advect
    real, intent(in   )                             :: stop_lim

    integer                          :: l, i, j
    real, dimension(isd:ied,jsd:jed) :: ue, vn, uflx, vflx
    real                             :: avg, dif

    if (adv_sub_steps==0) return;

    ue(:,jsd) = 0.0; ue(:,jed) = 0.0
    vn(:,jsd) = 0.0; vn(:,jed) = 0.0

    do j = jsc, jec
       do i = isc, iec
          ue(i,j) = 0.5 * ( ui(i,j-1) + ui(i,j) )
          vn(i,j) = 0.5 * ( vi(i-1,j) + vi(i,j) )
       enddo
    enddo

    if(reproduce_siena_201303) then
       call mpp_update_domains(ue, Domain)
       call mpp_update_domains(vn, Domain)
    else
       call mpp_update_domains(ue, vn, Domain, gridtype=CGRID_NE)
    endif

    do l=1,adv_sub_steps
       do j = jsd, jec
          do i = isd, iec
             avg = ( trc(i,j) + trc(i+1,j) )/2
             dif = trc(i+1,j) - trc(i,j)
             if( avg > stop_lim .and. ue(i,j) * dif > 0.0) then
                uflx(i,j) = 0.0
             else if( ue(i,j) > 0.0 ) then
                uflx(i,j) = ue(i,j) * trc(i,j) * dte(i,j)
             else
                uflx(i,j) = ue(i,j) * trc(i+1,j) * dte(i,j)
             endif

             avg = ( trc(i,j) + trc(i,j+1) )/2
             dif = trc(i,j+1) - trc(i,j)
             if( avg > stop_lim .and. vn(i,j) * dif > 0.0) then
                vflx(i,j) = 0.0
             else if( vn(i,j) > 0.0 ) then
                vflx(i,j) = vn(i,j) * trc(i,j) * dtn(i,j)
             else
                vflx(i,j) = vn(i,j) * trc(i,j+1) * dtn(i,j)
             endif
          enddo
       enddo

       do j = jsc, jec
          do i = isc, iec
             trc(i,j) = trc(i,j) + dt_adv * ( uflx(i-1,j)-uflx(i,j) + vflx(i,j-1)-vflx(i,j) ) / (dxt(i,j)*dyt(i,j))
          enddo
       enddo

       call mpp_update_domains(trc, Domain)

    end do
  end subroutine slab_ice_advect

  !#####################################################################
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  ! cut_check - check for mirror symmetry of uv field along bipolar grid cut     !
  !~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
  subroutine cut_check(mesg, uv)
    character(len=*), intent(in) :: mesg
    real, intent(inout), dimension(isd:,jsd:) :: uv

!    real, dimension(1:im, 1:jm)  :: global_uv

    integer :: i, l
    real, dimension(iec-isc+1) :: send_buffer, recv_buffer

    if(comm_pe == NULL_PE) return

    call mpp_recv(recv_buffer(1), glen=(iec-isc+1), from_pe=comm_pe, block=.false., tag=COMM_TAG_1)

    l = 0
    do i = iec-1, isd, -1
       l = l+1
       send_buffer(l) = uv(i,jec)
    enddo

    call mpp_send(send_buffer(1), plen=(iec-isc+1), to_pe=comm_pe, tag=COMM_TAG_1)
    call mpp_sync_self(check=EVENT_RECV)

    ! cut_check only at the north pole.
    if( jec == jm) then
       l = 0
       do i = isc, iec
          l=l+1
          ! excludes the point at im/2, and im.
          if(i == im/2 .or. i == im) cycle
          uv(i,jec) = (uv(i,jec) - recv_buffer(l))/2
       enddo
    endif

    call mpp_sync_self()


    !    call mpp_global_field ( Domain, uv, global_uv )

    !    do i=1,im/2-1
    !       if (global_uv(i,jm)/=-global_uv(im-i,jm)) then
    !      cut_error =.true.
    !     if (mpp_pe()==0) &
         !       print *, mesg, i, im-i, global_uv(i,jm), global_uv(im-i,jm)
    !          fix = (global_uv(i,jm)-global_uv(im-i,jm))/2
    !          global_uv(i   ,jm) =  fix
    !          global_uv(im-i,jm) = -fix
    !       end if
    !    end do

    !    uv(isc:iec,jsc:jec) = global_uv(isc:iec,jsc:jec)

    ! if (cut_error) call error_mesg ('ice_model_mod', &
         !                     'cut check of mirror anti-symmetry failed', FATAL)
  end subroutine cut_check
  !#####################################################################

end module ice_grid_mod

#ifdef test_mpp_pset
#include <fms_platform.h>
program test
  use mpp_mod, only: mpp_init, mpp_exit, mpp_pe, mpp_npes, stderr, stdout, &
       mpp_clock_id, mpp_clock_begin, mpp_clock_end
  use mpp_pset_mod, only: mpp_pset_type, mpp_pset_create, mpp_pset_root, &
       mpp_pset_broadcast_ptr, mpp_pset_segment_array, mpp_pset_sync, &
       mpp_pset_stack_push, mpp_pset_print_chksum, mpp_pset_delete
  implicit none
!test program demonstrates how to create PSETs
!  how to distribute allocatable arrays
!  how to distribute automatic arrays
  integer, parameter :: n=96 !divisible by lots of numbers
  real, allocatable, dimension(:,:,:) :: a, b, cc
  real :: c(n,n,n)
#ifdef use_CRI_pointers
  pointer( ptr_c, c )
#endif
  integer(POINTER_KIND) :: ptr !useless declaration, but it will compile
  integer :: i, j, k, ks, ke
!MPP
  integer :: pe, npes
!MPP_PSET
  type(mpp_pset_type) :: pset
  logical :: root
!clocks
  integer :: id_full, id_alloc, id_auto
  integer :: out_unit, errunit

  call mpp_init()
  pe = mpp_pe()
  npes = mpp_npes()
  out_unit = stdout()
  errunit = stderr()
  write( out_unit,'(a,i6)' )'Starting MPP_PSET unit test, npes=', npes
  call mpp_pset_create( npes, pset )
  root = mpp_pset_root(pset)
  id_full = mpp_clock_id( 'Full array' )
  id_alloc = mpp_clock_id( 'Allocatable array, PSETs' )
  id_auto = mpp_clock_id( 'Automatic array, PSETs' )
!allocate a and b
  allocate( a(n,n,n) )
  allocate( b(n,n,n) )
!allocate shared array c
  if( root )then
      allocate( cc(n,n,n) )
#ifdef use_CRI_pointers
      ptr = LOC(cc)
#endif
  end if
  call mpp_pset_broadcast_ptr( pset, ptr )
#ifdef use_CRI_pointers
  ptr_c = ptr
#endif
!initialize a and b
  call RANDOM_NUMBER(a)
  call mpp_clock_begin(id_full)
  do k = 1,n
     do j = 1,n
        do i = 1,n
           b(i,j,k) = 2*a(i,j,k)
        end do
     end do
  end do
  call mpp_clock_end(id_full)
!divide up among PSETs
  call mpp_pset_segment_array( pset, 1, n, ks, ke )
  write( errunit,'(a,4i6)' )'pe, n, ks, ke=', pe, n, ks, ke
  call mpp_clock_begin(id_alloc)
  do k = ks,ke
     do j = 1,n
        do i = 1,n
           c(i,j,k) = 2*a(i,j,k)
        end do
     end do
  end do
  call mpp_pset_sync(pset)
  call mpp_clock_end(id_alloc)
  write( errunit,'(a,i6,2es23.15)' )'b, c should be equal: pe b c=', &
       pe, sum(b), sum(c)
  call mpp_pset_print_chksum( pset, 'test_alloc', c(:,:,ks:ke) )
  call test_auto(n)
  call mpp_pset_delete(pset)
  call mpp_exit()

contains

  subroutine test_auto(m)
!same test as above, on auto array d
!this is how you create shared auto arrays
    integer, intent(in) :: m
    real :: d(m,m,m)
    integer :: js, je
#ifdef use_CRI_pointers
    pointer( pd, d )
    call mpp_pset_stack_push( pset, pd, size(d) )
#endif
    call mpp_pset_segment_array( pset, 1, m, js, je )
    call mpp_clock_begin(id_auto)
    do k = 1,m
       do j = js,je
          do i = 1,m
             d(i,j,k) = 2*a(i,j,k)
          end do
       end do
    end do
    call mpp_pset_sync(pset)
    call mpp_clock_end(id_auto)
    write( errunit,'(a,i6,2es23.15)' )'b, d should be equal: pe b d=', &
         pe, sum(b), sum(d)
    call mpp_pset_print_chksum( pset, 'test_auto ', d(:,js:je,:) )
  end subroutine test_auto
    
end program test
#else
module null_mpp_pset_test
end module
#endif

module spherical_fourier_mod

!Balaji: parallel spectral model using transpose method

use fms_mod,         only: mpp_pe, mpp_root_pe, error_mesg, FATAL, write_version_number

use mpp_mod,         only: mpp_error

use mpp_domains_mod, only: domain1D, mpp_get_compute_domains, mpp_get_domain_components, mpp_get_layout

use   constants_mod, only: pi

use spec_mpp_mod,    only: get_grid_domain, grid_domain, get_spec_domain

use spherical_mod,   only: spherical_init, spherical_end,                &
                           compute_lon_deriv_cos, compute_lat_deriv_cos, &
                           compute_laplacian, compute_vor, compute_div,  &
                           get_spherical_wave, get_fourier_wave,         &
                           get_eigen_laplacian, compute_gradient_cos,    &
                           compute_ucos_vcos, compute_vor_div,           &
                           triangular_truncation, rhomboidal_truncation

use gauss_and_legendre_mod, only: compute_legendre, compute_gaussian

!-------------------------------------------------------------------------
!  provides latitudinal transforms from spherical harmonics to 
!       (zonal fourier, latitude (gaussian) grid) space , and 
!       related operations
!       works within the window provided by windows module
!
!       spherical fields are complex, dimension(0:num_fourier, 0:num_spherical)
!         where the zonal wavenumber of (m,n) is M = m*fourier_inc
!             the "meridional" wavenumber is n
!             the "total", 2D, spherical wavenumber L = M+n
!       "fourier fields" are complex, dimension(0:num_fourier, lat_max)
!
!------------------------------------------------------------------------

implicit none
private

character(len=128), parameter :: version = '$Id: spherical_fourier.F90,v 13.0 2006/03/28 21:18:33 fms Exp $'
character(len=128), parameter :: tagname = '$Name: tikal $'

interface trans_spherical_to_fourier
   module procedure trans_spherical_to_fourier_3d,  &
                    trans_spherical_to_fourier_2d
end interface
interface trans_fourier_to_spherical
   module procedure trans_fourier_to_spherical_3d,  &
                    trans_fourier_to_spherical_2d
end interface

! ---------------------------------------------------

!  public interfaces defined in this module

public :: spherical_fourier_init, spherical_fourier_end
public :: trans_spherical_to_fourier, trans_fourier_to_spherical
public :: get_south_to_north
public :: get_sin_lat, get_cos_lat, get_cosm_lat, get_cosm2_lat
public :: get_deg_lat, get_wts_lat

! ---------------------------------------------------

!  public interfaces carried forward from used modules

public :: spherical_init, spherical_end
public :: compute_lon_deriv_cos, compute_lat_deriv_cos
public :: compute_laplacian, compute_vor, compute_div
public :: get_spherical_wave, get_fourier_wave
public :: get_eigen_laplacian, compute_gradient_cos
public :: compute_ucos_vcos, compute_vor_div
public :: triangular_truncation, rhomboidal_truncation


public :: compute_legendre, compute_gaussian

! ---------------------------------------------------
integer :: fourier_max
integer :: fourier_inc
logical :: south_to_north_local

integer :: lat_max
integer :: num_fourier
integer :: num_spherical

real, allocatable, dimension(:) :: sin_lat
real, allocatable, dimension(:) :: cos_lat
real, allocatable, dimension(:) :: cosm_lat
real, allocatable, dimension(:) :: cosm2_lat
real, allocatable, dimension(:) :: deg_lat
real, allocatable, dimension(:) :: wts_lat
real, allocatable, dimension(:) :: sin_hem
real, allocatable, dimension(:,:,:) :: legendre
real, allocatable, dimension(:,:,:) :: legendre_wts

type(domain1D),save :: grid_domain_y !used by the trans_s_f anfd f_s routines
integer :: grid_layout(2)
logical, private :: debug=.FALSE.

logical :: module_is_initialized = .false.
integer :: is, ie, js, je, ms, me, ns, ne

contains

!-----------------------------------------------------------------------
subroutine spherical_fourier_init(radius, lat_max_in, num_fourier_in, &
                   fourier_inc_in, num_spherical_in, south_to_north)
!-----------------------------------------------------------------------

real,    intent(in) :: radius
integer, intent(in) :: lat_max_in
integer, intent(in) :: num_fourier_in
integer, intent(in) :: fourier_inc_in
integer, intent(in) :: num_spherical_in
logical, intent(in), optional :: south_to_north

call write_version_number(version, tagname)

if(present(south_to_north)) then
  south_to_north_local = south_to_north
else
  south_to_north_local = .true.
end if

call get_grid_domain(is, ie, js, je)
call get_spec_domain(ms, me, ns, ne)

lat_max       = lat_max_in

fourier_inc   = fourier_inc_in
num_spherical = num_spherical_in
num_fourier   = num_fourier_in
fourier_max   = num_fourier*fourier_inc

call spherical_init(radius, num_fourier, fourier_inc, num_spherical)
call define_gaussian
call define_legendre

call mpp_get_domain_components( grid_domain, y=grid_domain_y )
call mpp_get_layout( grid_domain, grid_layout )
module_is_initialized = .true.

return
end subroutine spherical_fourier_init

!-------------------------------------------------------------------------
subroutine trans_spherical_to_fourier_3d(spherical,fourier)
!-------------------------------------------------------------------------

!in parallel, assumes that computational domains are being passed in.

  complex, intent(in),  dimension(ms:,ns:,:) :: spherical
  complex, intent(out), dimension(ms:,:,:,:) :: fourier

  complex :: x_odd, x_even

  integer :: m,n,j,k, num_levels

  integer :: neven, nodd
  integer :: jd, joff, nd, nj
  integer, dimension(grid_layout(2)) :: jstart

  if( size(spherical,1).ne.me-ms+1 )&
       call mpp_error( FATAL, 'TRANS_SPHERICAL_TO_FOURIER: size(spherical,1).NE.me-ms+1.' )
  if( size(spherical,2).NE.ne-ns+1 )&
       call mpp_error( FATAL, 'TRANS_SPHERICAL_TO_FOURIER: size(spherical,2).NE.ne-ns+1.' )
  if( size(fourier,2)*size(fourier,4).NE.lat_max ) &
       call mpp_error( FATAL, 'TRANS_SPHERICAL_TO_FOURIER: size(fourier,2)*size(fourier,4).NE.lat_max.' )

  num_levels = size(spherical,3)
  nd = grid_layout(2)   !also equal to size(fourier,4), could put in an error check
  nj = je-js+1 !this version requires grid domains equal in Y
  if( debug )write( 0,'(a,i2,2i4)' )'pe, nd, nj=', mpp_pe(), nd, nj

  if( mod(ns,2).EQ.0 )then
      neven = ns
      nodd = ns+1
  else
      nodd = ns
      neven = ns+1
  endif

  call mpp_get_compute_domains( grid_domain_y, begin=jstart(:) )
  DOMAIN_LOOP: do jd=1,nd/2+1
!each domain jd has a mirror domain nd+1-jd
!if nd is even we stop at jd=nd/2; if nd is odd we stop at j=nj/2
     if( jd.EQ.nd/2+1 .AND. mod(nd,2).EQ.0 )exit DOMAIN_LOOP
     joff = jstart(jd) - 1
     if( debug )write( 0,'(a,i2,2i4)' )'pe, jd, joff=', mpp_pe(), jd, joff
     do j = 1,nj
        if( jd.EQ.nd/2+1 .AND. j.GT.nj/2 )exit DOMAIN_LOOP
        if(south_to_north_local) then !how long are we going to keep carrying around S2N and N2S?
            do k=1,num_levels
               do m=ms,me
                  x_even = cmplx(0.,0.)
                  x_odd  = cmplx(0.,0.)

                  do n=neven,ne,2
                     x_even = x_even + spherical(m,n,k) * legendre(m,n,j+joff)
                  end do
                  do n=nodd,ne,2
                     x_odd  = x_odd  + spherical(m,n,k) * legendre(m,n,j+joff)
                  end do

                  fourier(m,     j,k,     jd) = x_even - x_odd
                  fourier(m,nj+1-j,k,nd+1-jd) = x_even + x_odd
               end do
            end do
        else
            do k=1,num_levels
               do m=ms,me
                  x_even = cmplx(0.,0.)
                  x_odd  = cmplx(0.,0.)

                  do n=neven,ne,2
                     x_even = x_even + spherical(m,n,k) * legendre(m,n,j+joff)
                  end do
                  do n=nodd,ne,2
                     x_odd  = x_odd  + spherical(m,n,k) * legendre(m,n,j+joff)
                  end do

                  fourier(m,     j,k,     jd) = x_even + x_odd
                  fourier(m,nj+1-j,k,nd+1-jd) = x_even - x_odd
               end do
            end do
        end if
     end do
  end do DOMAIN_LOOP

  return
end subroutine trans_spherical_to_fourier_3d

!-----------------------------------------------------------------------
subroutine trans_fourier_to_spherical_3d(fourier,spherical)
!-----------------------------------------------------------------------

  complex, intent (out), dimension(ms:,ns:,:) :: spherical
  complex, intent (in),  dimension(ms:,:,:,:) :: fourier

  integer :: k,j,m,n
!  complex, dimension(ms:me, size(spherical,3)) :: x_odd, x_even
  complex :: x_odd, x_even

  integer :: num_levels, nd, nj

  integer :: neven, nodd
  integer :: jd, joff
  integer, dimension(grid_layout(2)) :: jstart

  if( size(spherical,1).ne.me-ms+1 )&
       call mpp_error( FATAL, 'TRANS_SPHERICAL_TO_FOURIER: size(spherical,1).NE.me-ms+1.' )
  if( size(spherical,2).NE.ne-ns+1 )&
       call mpp_error( FATAL, 'TRANS_SPHERICAL_TO_FOURIER: size(spherical,2).NE.ne-ns+1.' )
  if( size(fourier,2)*size(fourier,4).NE.lat_max ) &
       call mpp_error( FATAL, 'TRANS_SPHERICAL_TO_FOURIER: size(fourier,2)*size(fourier,4).NE.lat_max.' )

  num_levels = size(spherical,3)
  nd = grid_layout(2)   !also equal to size(fourier,4), could put in an error check
  nj = je-js+1 !this version requires grid domains equal in Y

  if( mod(ns,2).EQ.0 )then
      neven = ns
      nodd = ns+1
  else
      nodd = ns
      neven = ns+1
  endif

  call mpp_get_compute_domains( grid_domain_y, begin=jstart(:) )
  spherical = cmplx(0.,0.)
  DOMAIN_LOOP: do jd=1,nd/2+1
!each domain jd has a mirror domain nd+1-jd
!if nd is even we stop at jd=nd/2; if nd is odd we stop at j=nj/2
     if( jd.EQ.nd/2+1 .AND. mod(nd,2).EQ.0 )exit DOMAIN_LOOP
     joff = jstart(jd) - 1
     do j = 1,nj
        if( jd.EQ.nd/2+1 .AND. j.GT.nj/2 )exit DOMAIN_LOOP
        if(south_to_north_local) then
            do k = 1,num_levels
               do m = ms,me
                  x_even = fourier(m,nj+1-j,k,nd+1-jd) + fourier(m,j,k,jd)
                  x_odd  = fourier(m,nj+1-j,k,nd+1-jd) - fourier(m,j,k,jd)
                  do n=neven,ne,2
                     spherical(m,n,k) = spherical(m,n,k) + x_even*legendre_wts(m,n,j+joff)
                  end do
                  do n=nodd, ne,2                           
                     spherical(m,n,k) = spherical(m,n,k) + x_odd *legendre_wts(m,n,j+joff)
                  end do
               end do
            enddo
        else
            do k = 1,num_levels
               do m = ms,me
                  x_even = fourier(m,j,k,jd) + fourier(m,nj+1-j,k,nd+1-jd)
                  x_odd  = fourier(m,j,k,jd) - fourier(m,nj+1-j,k,nd+1-jd)
                  do n=neven,ne,2
                     spherical(m,n,k) = spherical(m,n,k) + x_even*legendre_wts(m,n,j+joff)
                  end do
                  do n=nodd, ne,2                           
                     spherical(m,n,k) = spherical(m,n,k) + x_odd *legendre_wts(m,n,j+joff)
                  end do
               end do
            enddo
        end if
     end do
  end do DOMAIN_LOOP

  return
end subroutine trans_fourier_to_spherical_3d

!-------------------------------------------------------------------------
subroutine trans_spherical_to_fourier_2d(spherical,fourier) 
!-------------------------------------------------------------------------

complex, intent(in),  dimension(:,:) :: spherical
complex, intent(out), dimension(:,:,:) :: fourier

complex, dimension(size(spherical,1), size(spherical,2), 1) :: spherical_3d
complex, dimension(size(fourier,1),   size(fourier,2),   1, size(fourier,3)) :: fourier_3d

spherical_3d(:,:,1) = spherical(:,:)
call trans_spherical_to_fourier_3d(spherical_3d,fourier_3d)
fourier(:,:,:) = fourier_3d(:,:,1,:)

return
end subroutine trans_spherical_to_fourier_2d

!-----------------------------------------------------------------------
subroutine trans_fourier_to_spherical_2d(fourier,spherical)
!-----------------------------------------------------------------------

complex, intent (in), dimension(:,:,:) :: fourier
complex, intent (out),  dimension(:,:) :: spherical

complex, dimension(size(spherical,1), size(spherical,2), 1) :: spherical_3d
complex, dimension(size(fourier,1),   size(fourier,2),   1, size(fourier,3)) :: fourier_3d

fourier_3d(:,:,1,:) = fourier(:,:,:)
call trans_fourier_to_spherical_3d(fourier_3d,spherical_3d)
spherical(:,:) = spherical_3d(:,:,1)
 
return
end subroutine trans_fourier_to_spherical_2d

!-----------------------------------------------------------------------
subroutine define_legendre
!-----------------------------------------------------------------------

integer j
real, dimension(0:num_fourier,0:num_spherical,lat_max/2) :: legendre_global

allocate(legendre(ms:me,ns:ne,lat_max/2))

allocate(legendre_wts(ms:me,ns:ne,lat_max/2))

call compute_legendre(legendre_global, num_fourier, fourier_inc, num_spherical, sin_hem, lat_max/2)
legendre = legendre_global(ms:me,ns:ne,:)

do j=1,lat_max/2
  legendre_wts(:,:,j) = legendre(:,:,j)*wts_lat(j)
end do

return
end subroutine define_legendre

!----------------------------------------------------------------------
subroutine define_gaussian
!----------------------------------------------------------------------

integer j
real, dimension(lat_max/2) :: wts_hem

allocate (sin_lat(lat_max))
allocate (cos_lat(lat_max))
allocate (cosm_lat(lat_max))
allocate (cosm2_lat(lat_max))
allocate (wts_lat(lat_max))
allocate (deg_lat(lat_max))
allocate (sin_hem(lat_max/2))

call compute_gaussian(sin_hem, wts_hem, lat_max/2)

if(south_to_north_local) then
   sin_lat(1:lat_max/2)   = - sin_hem
else
   sin_lat(1:lat_max/2)   =   sin_hem
end if

do j=1,lat_max/2
  sin_lat(lat_max+1-j) = - sin_lat(j)
  wts_lat(j)           =   wts_hem(j)
  wts_lat(lat_max+1-j) =   wts_hem(j)
end do

cos_lat   = sqrt(1-sin_lat*sin_lat)
cosm_lat  = 1./cos_lat
cosm2_lat = 1./(cos_lat*cos_lat)
deg_lat   = asin(sin_lat)*180.0/pi
  
return
end subroutine define_gaussian

!-----------------------------------------------------------------------
subroutine get_south_to_north(south_to_north_out)
!-----------------------------------------------------------------------

logical, intent (out) :: south_to_north_out

if(.not. module_is_initialized) then
  call error_mesg('get_south_to_north','failed to define package', FATAL)
end if

south_to_north_out = south_to_north_local

return
end subroutine get_south_to_north

!-----------------------------------------------------------------------
subroutine get_sin_lat(sin_lat_out)
!-----------------------------------------------------------------------

real, intent (out), dimension(:) :: sin_lat_out

if(.not. module_is_initialized) then
  call error_mesg('get_sin_lat','failed to define package', FATAL)
end if

if(size(sin_lat_out,1).eq.lat_max) then
    sin_lat_out = sin_lat
else                            !assume grid compute domain
    sin_lat_out = sin_lat(js:je)
end if

return
end subroutine get_sin_lat

!-----------------------------------------------------------------------
subroutine get_cos_lat(cos_lat_out)
!-----------------------------------------------------------------------

real, intent (out), dimension(:) :: cos_lat_out

if(.not. module_is_initialized) then
  call error_mesg('get_cos_lat','failed to define package', FATAL)
end if
  
if(size(cos_lat_out,1).eq.lat_max) then
    cos_lat_out = cos_lat
else                            !assume grid compute domain
    cos_lat_out = cos_lat(js:je)
end if

return
end subroutine get_cos_lat

!-----------------------------------------------------------------------
subroutine get_cosm_lat(cosm_lat_out)
!-----------------------------------------------------------------------

real, intent (out), dimension(:) :: cosm_lat_out

if(.not. module_is_initialized) then
  call error_mesg('get_cosm_lat','failed to define package', FATAL)
end if
  
if(size(cosm_lat_out,1).eq.lat_max) then
    cosm_lat_out = cosm_lat
else                            !assume grid compute domain
    cosm_lat_out = cosm_lat(js:je)
end if

return
end subroutine get_cosm_lat

!-----------------------------------------------------------------------
subroutine get_cosm2_lat(cosm2_lat_out)
!-----------------------------------------------------------------------

real, intent (out), dimension(:) :: cosm2_lat_out

if(.not. module_is_initialized) then 
  call error_mesg('get_cosm2_lat','failed to define package', FATAL)
end if
  
if(size(cosm2_lat_out,1).eq.lat_max) then
    cosm2_lat_out = cosm2_lat
else                            !assume grid compute domain
    cosm2_lat_out = cosm2_lat(js:je)
end if

return
end subroutine get_cosm2_lat

!-----------------------------------------------------------------------
subroutine get_deg_lat(deg_lat_out)
!-----------------------------------------------------------------------

real, intent (out), dimension(:) :: deg_lat_out

if(.not. module_is_initialized) then
  call error_mesg('get_deg_lat','failed to define package', FATAL)
end if
  
if(size(deg_lat_out,1).eq.lat_max) then
    deg_lat_out = deg_lat
else                            !assume grid compute domain
    deg_lat_out = deg_lat(js:je)
end if

return
end subroutine get_deg_lat

!-----------------------------------------------------------------------
subroutine get_wts_lat(wts_lat_out)
!-----------------------------------------------------------------------

real, intent (out), dimension(:) :: wts_lat_out

if(.not. module_is_initialized) then
  call error_mesg('get_wts_lat','failed to define package', FATAL)
end if
  
if(size(wts_lat_out,1).eq.lat_max) then
    wts_lat_out = wts_lat
else                            !assume grid compute domain
    wts_lat_out = wts_lat(js:je)
end if

return
end subroutine get_wts_lat

!----------------------------------------------------------------------
subroutine spherical_fourier_end

if(.not. module_is_initialized) return

deallocate(sin_lat, cos_lat, cosm_lat, cosm2_lat, wts_lat, deg_lat)
deallocate(sin_hem, legendre, legendre_wts)
call spherical_end
module_is_initialized = .false.

return
end subroutine spherical_fourier_end
!----------------------------------------------------------------------
end module spherical_fourier_mod

program grid_transfer
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">Z. Liang </CONTACT>
  ! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov">S. M. Griffies</REVIEWER>


  !<OVERVIEW>
  !  Converts the grid specification netcdf file using old name convention to a netcdf 
  !  file with new grid name convention. This program can be applied on any ocean grid 
  !  or exchange grid. 
  !</OVERVIEW>
  use fms_mod,       only : fms_init, fms_end, file_exist, close_file, open_namelist_file
  use fms_mod,       only : check_nml_error, write_version_number, stdout
  use mpp_mod,       only : mpp_error, FATAL, mpp_npes
  use constants_mod, only : constants_init, PI

  implicit none
#include <netcdf.inc>

  !--- namelist interface
  !
  !<NAMELIST NAME="grid_transfer_nml">
  !<DATA NAME="old_grid" TYPE="character(len=128)">
  !  name of input grid file to be converted.
  !</DATA>
  !<DATA NAME="new_grid" TYPE="character(len=128)">
  !  name of output grid file converted from old_grid.
  !</DATA>
  !</NAMELIST>
  character(len=128) :: old_grid = 'old_grid.nc'
  character(len=128) :: new_grid = 'new_grid.nc'
  namelist /grid_transfer_nml/ old_grid, new_grid

  !---------version information-------------------------------------------
  character(len=128) :: version = '$Id: grid_transfer.F90,v 13.0 2006/03/28 21:44:17 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $' 

  !---------------------------------------------------------------------
  integer                             :: nlon, nlat, nk
  real, dimension(:), allocatable     :: grid_x_T, grid_y_T, grid_x_c, grid_y_c, zb
  real, dimension(:,:), allocatable   :: x_T, y_T, x_c, y_c, angle_c, depth_t, num_levels
  real, dimension(:,:), allocatable   :: ds_11_21_t, ds_01_11_t, ds_11_12_t, ds_10_11_t 
  real, dimension(:,:), allocatable   :: ds_01_21_t, ds_10_12_t, ds_20_22_t, ds_02_22_t
  real, dimension(:,:), allocatable   :: ds_00_20_c, ds_00_02_c, ds_11_21_c, ds_01_11_c
  real, dimension(:,:), allocatable   :: ds_11_12_c, ds_10_11_c, ds_01_21_c, ds_10_12_c
  real, dimension(:,:), allocatable   :: ds_02_22_c, ds_20_22_c, area_t
  real, dimension(:,:), allocatable   :: ds_01_21_e, ds_10_12_n
  real, dimension(:,:,:), allocatable :: x_vert_T, y_vert_T


  !--- begin of the program 
  call fms_init
  call constants_init

  !--- read the namelist
  call grid_transfer_init

  !--- read the old_grid file.
  call read_old_grid

  !--- write the new_grid file
  call write_new_grid

  call grid_transfer_end

  call fms_end

contains

  !#####################################################################
  !--- initializtion routine
  !--- Read namelist and write out namelist and version information
  subroutine grid_transfer_init

    integer :: unit, ierr, io_status

    if(mpp_npes() .ne. 1)&
         call mpp_error(FATAL,' grid_transfer: do not support parallel, number of pes should be 1')

    if(file_exist('input.nml')) then
       unit = open_namelist_file()
       read (unit,grid_transfer_nml,IOSTAT=io_status)
       write (stdout(),'(/)')
       write (stdout(),grid_transfer_nml)  
       ierr = check_nml_error(io_status, 'grid_transfer_nml')
       call close_file(unit)
    else
       call mpp_error(FATAL, 'grid_transfer: file input.nml does not exist' )
    endif

    !--- write version information
    call write_version_number(version, tagname)

  end subroutine grid_transfer_init

  !#####################################################################
  !--- read_old_grid
  subroutine read_old_grid
    integer :: ncid, rcode, start(4), nread(4), dims(4)
    integer :: id_geolon_t, id_geolat_t, id_geolon_c, id_geolat_c
    integer :: id_geolon_vert_t, id_geolat_vert_t, id_sin_rot, id_ht, id_kmt
    integer :: id_zw, id_gridlon_t, id_gridlat_t, id_gridlon_c, id_gridlat_c
    integer :: id_dte, id_dtw, id_dtn, id_dts, id_dxt, id_dyt, id_dyte, id_dxtn
    integer :: id_dxte, id_dytn, id_due, id_duw, id_dun, id_dus, id_dxu, id_dyu
    integer :: id_dxun, id_dyue
    real, dimension(:,:), allocatable :: geolon_vert_t, geolat_vert_t, sin_rot  

    rcode = nf_open(trim(old_grid), NF_NOWRITE, ncid)
    if(rcode /= 0) call mpp_error(FATAL, 'Cannot open file '//trim(old_grid))
    !--- first get the dimension of the grid
    rcode = nf_inq_varid(ncid, 'geolon_t', id_geolon_t )
    if(rcode /= 0) call mpp_error(FATAL, ' field geolon_t is not in the file' //trim(old_grid) )
    rcode = nf_inq_vardimid(ncid, id_geolon_t, dims)
    rcode = nf_inq_dimlen(ncid, dims(1), nlon)
    rcode = nf_inq_dimlen(ncid, dims(2), nlat)
    rcode = nf_inq_varid(ncid, 'zw', id_zw )
    if(rcode /= 0) call mpp_error(FATAL, 'zw is not in the file' //trim(old_grid) )
    rcode = nf_inq_vardimid(ncid, id_zw, dims)
    rcode = nf_inq_dimlen(ncid, dims(1), nk)    
    !--- get the axis data
    allocate(grid_x_t(nlon), grid_y_t(nlat), grid_x_c(nlon), grid_y_c(nlat), zb(nk) )
    rcode = nf_inq_varid(ncid, 'gridlon_t', id_gridlon_t )  
    if(rcode /= 0) call mpp_error(FATAL, 'gridlon_t is not in the file' //trim(old_grid) )  
    rcode = nf_inq_varid(ncid, 'gridlat_t', id_gridlat_t )
    if(rcode /= 0) call mpp_error(FATAL, 'gridlat_t is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'gridlon_c', id_gridlon_c )
    if(rcode /= 0) call mpp_error(FATAL, 'gridlon_c is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'gridlat_c', id_gridlat_c )
    if(rcode /= 0) call mpp_error(FATAL, 'gridlat_c is not in the file' //trim(old_grid) )
    start = 1; nread = 1
    nread(1) = nlon
    rcode = nf_get_vara_double(ncid, id_gridlon_t, start, nread,grid_x_t )
    rcode = nf_get_vara_double(ncid, id_gridlon_c, start, nread,grid_x_c )
    nread(1) = nlat
    rcode = nf_get_vara_double(ncid, id_gridlat_t, start, nread,grid_y_t )
    rcode = nf_get_vara_double(ncid, id_gridlat_c, start, nread,grid_y_c )
    nread(1) = nk
    rcode = nf_get_vara_double(ncid, id_zw, start, nread,zb )

    !--- get the field data

    allocate(x_t(nlon,nlat), y_t(nlon,nlat), x_c(nlon,nlat), y_c(nlon,nlat))
    allocate(x_vert_t(nlon,nlat,4), y_vert_t(nlon,nlat,4))
    allocate(geolon_vert_t(nlon+1,nlat+1), geolat_vert_t(nlon+1,nlat+1) )
    allocate(ds_11_21_t(nlon,nlat), ds_01_11_t(nlon,nlat), ds_11_12_t(nlon,nlat), ds_10_11_t(nlon,nlat) )
    allocate(ds_01_21_t(nlon,nlat), ds_10_12_t(nlon,nlat), ds_20_22_t(nlon,nlat), ds_02_22_t(nlon,nlat) )
    allocate(ds_00_20_c(nlon,nlat), ds_00_02_c(nlon,nlat), ds_11_21_c(nlon,nlat), ds_01_11_c(nlon,nlat) )
    allocate(ds_11_12_c(nlon,nlat), ds_10_11_c(nlon,nlat), ds_01_21_c(nlon,nlat), ds_10_12_c(nlon,nlat) )
    allocate(ds_02_22_c(nlon,nlat), ds_20_22_c(nlon,nlat), area_t(nlon,nlat) )
    allocate(ds_10_12_n(nlon,nlat), ds_01_21_e(nlon,nlat) )
    allocate(angle_c(nlon,nlat), sin_rot(nlon,nlat), depth_t(nlon,nlat), num_levels(nlon,nlat)  )

    rcode = nf_inq_varid(ncid, 'geolat_t', id_geolat_t )
    if(rcode /= 0) call mpp_error(FATAL, 'geolat_t is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'geolon_c', id_geolon_c )
    if(rcode /= 0) call mpp_error(FATAL, 'geolon_c is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'geolat_c', id_geolat_c )
    if(rcode /= 0) call mpp_error(FATAL, 'geolat_c is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'geolon_vert_t', id_geolon_vert_t )
    if(rcode /= 0) call mpp_error(FATAL, 'geolon_vert_t is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'geolat_vert_t', id_geolat_vert_t )
    if(rcode /= 0) call mpp_error(FATAL, 'geolat_vert_t is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'sin_rot', id_sin_rot )
    if(rcode /= 0) call mpp_error(FATAL, 'sin_rot is not in the file' //trim(old_grid) )

    nread(1) = nlon; nread(2) = nlat
    rcode = nf_get_vara_double(ncid, id_geolon_t, start, nread, x_t)
    rcode = nf_get_vara_double(ncid, id_geolat_t, start, nread, y_t)
    rcode = nf_get_vara_double(ncid, id_geolon_c, start, nread, x_c)
    rcode = nf_get_vara_double(ncid, id_geolat_c, start, nread, y_c)
    rcode = nf_get_vara_double(ncid, id_sin_rot, start, nread, sin_rot)
    nread(1) = nlon+1; nread(2) = nlat+1
    rcode = nf_get_vara_double(ncid, id_geolon_vert_t, start, nread, geolon_vert_t )
    rcode = nf_get_vara_double(ncid, id_geolat_vert_t, start, nread, geolat_vert_t )

    !--- define x_vert_t and y_vert_t
    x_vert_t(:,:,1) = geolon_vert_t(1:nlon,   1:nlat  )
    x_vert_t(:,:,2) = geolon_vert_t(2:nlon+1, 1:nlat   )
    x_vert_t(:,:,3) = geolon_vert_t(2:nlon+1, 2:nlat+1)
    x_vert_t(:,:,4) = geolon_vert_t(1:nlon,   2:nlat+1)
    y_vert_t(:,:,1) = geolat_vert_t(1:nlon,   1:nlat  )
    y_vert_t(:,:,2) = geolat_vert_t(2:nlon+1, 1:nlat  )
    y_vert_t(:,:,3) = geolat_vert_t(2:nlon+1, 2:nlat+1)
    y_vert_t(:,:,4) = geolat_vert_t(1:nlon,   2:nlat+1)

    !--- define rotation angle
    angle_c = asin(sin_rot)*180./PI

    !--- get the grid resolution variables
    rcode = nf_inq_varid(ncid, 'dte', id_dte )
    if(rcode /= 0) call mpp_error(FATAL, 'dte is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dtw', id_dtw )
    if(rcode /= 0) call mpp_error(FATAL, 'dtw is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dtn', id_dtn )
    if(rcode /= 0) call mpp_error(FATAL, 'dtn is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dts', id_dts )
    if(rcode /= 0) call mpp_error(FATAL, 'dts is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dxt', id_dxt )
    if(rcode /= 0) call mpp_error(FATAL, 'dxt is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dyt', id_dyt )
    if(rcode /= 0) call mpp_error(FATAL, 'dyt is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dyte', id_dyte )
    if(rcode /= 0) call mpp_error(FATAL, 'dyte is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dxtn', id_dxtn )
    if(rcode /= 0) call mpp_error(FATAL, 'dxtn is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dxte', id_dxte )
    if(rcode /= 0) call mpp_error(FATAL, 'dxte is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dytn', id_dytn )
    if(rcode /= 0) call mpp_error(FATAL, 'dytn is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'due', id_due )
    if(rcode /= 0) call mpp_error(FATAL, 'due is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'duw', id_duw )
    if(rcode /= 0) call mpp_error(FATAL, 'duw is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dun', id_dun )
    if(rcode /= 0) call mpp_error(FATAL, 'dun is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dus', id_dus )
    if(rcode /= 0) call mpp_error(FATAL, 'dus is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dxu', id_dxu )
    if(rcode /= 0) call mpp_error(FATAL, 'dxu is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dyu', id_dyu )
    if(rcode /= 0) call mpp_error(FATAL, 'dyu is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dxun', id_dxun )
    if(rcode /= 0) call mpp_error(FATAL, 'dxun is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dyue', id_dyue )
    if(rcode /= 0) call mpp_error(FATAL, 'dyue is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dxte', id_dxte )
    if(rcode /= 0) call mpp_error(FATAL, 'dxte is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'dytn', id_dytn )
    if(rcode /= 0) call mpp_error(FATAL, 'dytn is not in the file' //trim(old_grid) )

    !--- get the grid resolution data
    start=1; nread=1
    nread(1)=nlon; nread(2) = nlat
    rcode = nf_get_vara_double(ncid, id_dte, start, nread, ds_11_21_t)
    rcode = nf_get_vara_double(ncid, id_dtw, start, nread, ds_01_11_t)
    rcode = nf_get_vara_double(ncid, id_dtn, start, nread, ds_11_12_t)
    rcode = nf_get_vara_double(ncid, id_dts, start, nread, ds_10_11_t)
    rcode = nf_get_vara_double(ncid, id_dxt, start, nread, ds_01_21_t)
    rcode = nf_get_vara_double(ncid, id_dyt, start, nread, ds_10_12_t)
    rcode = nf_get_vara_double(ncid, id_dyte, start, nread, ds_20_22_t)
    rcode = nf_get_vara_double(ncid, id_dxtn, start, nread, ds_02_22_t)
    rcode = nf_get_vara_double(ncid, id_dxte, start, nread, ds_00_20_c)
    rcode = nf_get_vara_double(ncid, id_dytn, start, nread, ds_00_02_c)
    rcode = nf_get_vara_double(ncid, id_due, start, nread, ds_11_21_c)
    rcode = nf_get_vara_double(ncid, id_duw, start, nread, ds_01_11_c)
    rcode = nf_get_vara_double(ncid, id_dun, start, nread, ds_11_12_c)
    rcode = nf_get_vara_double(ncid, id_dus, start, nread, ds_10_11_c)
    rcode = nf_get_vara_double(ncid, id_dxu, start, nread, ds_01_21_c)
    rcode = nf_get_vara_double(ncid, id_dyu, start, nread, ds_10_12_c)
    rcode = nf_get_vara_double(ncid, id_dxun, start, nread, ds_02_22_c)
    rcode = nf_get_vara_double(ncid, id_dyue, start, nread, ds_20_22_c)
    rcode = nf_get_vara_double(ncid, id_dxte, start, nread, ds_01_21_e)
    rcode = nf_get_vara_double(ncid, id_dytn, start, nread, ds_10_12_n)

    !--- calculate area of T-cell, which is dxt*dyt
    area_t =  ds_01_21_t * ds_10_12_t

    !--- get the topography data
    rcode = nf_inq_varid(ncid, 'ht', id_ht )
    if(rcode /= 0) call mpp_error(FATAL, 'ht is not in the file' //trim(old_grid) )
    rcode = nf_inq_varid(ncid, 'kmt', id_kmt )
    if(rcode /= 0) call mpp_error(FATAL, 'kmt is not in the file' //trim(old_grid) )

    rcode = nf_get_vara_double(ncid, id_ht, start, nread, depth_t)
    rcode = nf_get_vara_double(ncid, id_kmt, start, nread, num_levels)


  end subroutine read_old_grid

  !#####################################################################
  !--- write out the new_grid
  subroutine write_new_grid

    integer :: ncid, rcode, dims(10), start(4), nwrite(4), dim(4)
    integer :: id_grid_x_t, id_grid_y_t, id_grid_x_c, id_grid_y_c, id_zb, id_vertex
    integer :: id_x_t, id_y_t, id_x_c, id_y_c, id_x_vert_t, id_y_vert_t
    integer :: id_ds_11_21_t, id_ds_01_11_t, id_ds_11_12_t, id_ds_10_11_t
    integer :: id_ds_01_21_t, id_ds_10_12_t, id_ds_20_22_t, id_ds_02_22_t
    integer :: id_ds_00_20_c, id_ds_00_02_c, id_ds_11_21_c, id_ds_01_11_c
    integer :: id_ds_11_12_c, id_ds_10_11_c, id_ds_01_21_c, id_ds_10_12_c
    integer :: id_ds_02_22_c, id_ds_20_22_c, id_area_t, id_ds_01_21_e, id_ds_10_12_n
    integer :: id_angle_c, id_depth_t, id_num_levels


    call system("cp "//trim(old_grid)//" "//trim(new_grid) )
    rcode = nf_open(trim(new_grid), NF_WRITE, ncid)
    rcode = nf_redef(ncid)
    rcode = nf_def_dim(ncid, 'grid_x_T', nlon, dims(1))
    rcode = nf_def_dim(ncid, 'grid_y_T', nlat, dims(2))
    rcode = nf_def_dim(ncid, 'vertex',      4, dims(3))
    rcode = nf_def_dim(ncid, 'zb',      nk, dims(4))
    rcode = nf_def_dim(ncid, 'grid_x_C', nlon, dims(5))
    rcode = nf_def_dim(ncid, 'grid_y_C', nlat, dims(6))
    rcode = nf_def_var(ncid, "grid_x_T", NF_FLOAT, 1, dims(1), id_grid_x_t)
    rcode = nf_put_att_text(ncid,id_grid_x_t, 'cartesian_axis', 1,'X')
    rcode = nf_put_att_text(ncid,id_grid_x_t, 'units', 11,'degree_east')
    rcode = nf_def_var(ncid, "grid_y_T", NF_FLOAT, 1, dims(2), id_grid_y_t)
    rcode = nf_put_att_text(ncid,id_grid_y_t, 'cartesian_axis', 1,'Y')
    rcode = nf_put_att_text(ncid,id_grid_y_t, 'units', 12,'degree_north')
    rcode = nf_def_var(ncid, "grid_x_C", NF_FLOAT, 1, dims(5), id_grid_x_c)
    rcode = nf_put_att_text(ncid,id_grid_x_c, 'cartesian_axis', 1,'X')
    rcode = nf_put_att_text(ncid,id_grid_x_c, 'units', 11,'degree_east')
    rcode = nf_def_var(ncid, "grid_y_C", NF_FLOAT, 1, dims(6), id_grid_y_c)
    rcode = nf_put_att_text(ncid,id_grid_y_c, 'cartesian_axis', 1,'Y')
    rcode = nf_put_att_text(ncid,id_grid_y_c, 'units', 12,'degree_north')
    rcode = nf_def_var(ncid, "vertex", NF_FLOAT, 1, dims(3), id_vertex)
    rcode = nf_def_var(ncid, "zb", NF_FLOAT, 1, dims(4), id_zb)
    rcode = nf_put_att_text(ncid,id_zb, 'cartesian_axis', 1,'Z')
    rcode = nf_put_att_text(ncid,id_zb, 'units', 6,'meters')

    rcode = nf_def_var(ncid, 'x_T', NF_DOUBLE, 2, dims(1:2), id_x_t)
    rcode = nf_def_var(ncid, 'y_T', NF_DOUBLE, 2, dims(1:2), id_y_t)
    rcode = nf_def_var(ncid, 'x_C', NF_DOUBLE, 2, dims(5:6), id_x_c)
    rcode = nf_def_var(ncid, 'y_C', NF_DOUBLE, 2, dims(5:6), id_y_c)
    rcode = nf_def_var(ncid, 'x_vert_T', NF_DOUBLE, 3, dims(1:3), id_x_vert_t)
    rcode = nf_def_var(ncid, 'y_vert_T', NF_DOUBLE, 3, dims(1:3), id_y_vert_t)
    rcode = nf_def_var(ncid, 'area_T', NF_DOUBLE, 2, dims(1:2), id_area_t)
    rcode = nf_def_var(ncid, 'ds_11_21_T', NF_DOUBLE, 2, dims(1:2), id_ds_11_21_t)
    rcode = nf_def_var(ncid, 'ds_01_11_T', NF_DOUBLE, 2, dims(1:2), id_ds_01_11_t)
    rcode = nf_def_var(ncid, 'ds_11_12_T', NF_DOUBLE, 2, dims(1:2), id_ds_11_12_t)
    rcode = nf_def_var(ncid, 'ds_10_11_T', NF_DOUBLE, 2, dims(1:2), id_ds_10_11_t)
    rcode = nf_def_var(ncid, 'ds_01_21_T', NF_DOUBLE, 2, dims(1:2), id_ds_01_21_t)
    rcode = nf_def_var(ncid, 'ds_10_12_T', NF_DOUBLE, 2, dims(1:2), id_ds_10_12_t)
    rcode = nf_def_var(ncid, 'ds_20_22_T', NF_DOUBLE, 2, dims(1:2), id_ds_20_22_t)
    rcode = nf_def_var(ncid, 'ds_02_22_T', NF_DOUBLE, 2, dims(1:2), id_ds_02_22_t)
    rcode = nf_def_var(ncid, 'ds_00_20_C', NF_DOUBLE, 2, dims(5:6), id_ds_00_20_c)
    rcode = nf_def_var(ncid, 'ds_00_02_C', NF_DOUBLE, 2, dims(5:6), id_ds_00_02_c)
    rcode = nf_def_var(ncid, 'ds_11_21_C', NF_DOUBLE, 2, dims(5:6), id_ds_11_21_c)
    rcode = nf_def_var(ncid, 'ds_01_11_C', NF_DOUBLE, 2, dims(5:6), id_ds_01_11_c)
    rcode = nf_def_var(ncid, 'ds_11_12_C', NF_DOUBLE, 2, dims(5:6), id_ds_11_12_c)
    rcode = nf_def_var(ncid, 'ds_10_11_C', NF_DOUBLE, 2, dims(5:6), id_ds_10_11_c)
    rcode = nf_def_var(ncid, 'ds_01_21_C', NF_DOUBLE, 2, dims(5:6), id_ds_01_21_c)
    rcode = nf_def_var(ncid, 'ds_10_12_C', NF_DOUBLE, 2, dims(5:6), id_ds_10_12_c)
    rcode = nf_def_var(ncid, 'ds_02_22_C', NF_DOUBLE, 2, dims(5:6), id_ds_02_22_c)
    rcode = nf_def_var(ncid, 'ds_20_22_C', NF_DOUBLE, 2, dims(5:6), id_ds_20_22_c)
    dim(1) = dims(5); dim(2) = dims(2)
    rcode = nf_def_var(ncid, 'ds_01_21_E', NF_DOUBLE, 2, dim,       id_ds_01_21_e)
    dim(1) = dims(1); dim(2) = dims(6)
    rcode = nf_def_var(ncid, 'ds_10_12_N', NF_DOUBLE, 2, dim,       id_ds_10_12_n)
    rcode = nf_def_var(ncid, 'angle_C', NF_DOUBLE, 2, dims(5:6), id_angle_c)
    rcode = nf_def_var(ncid, 'depth_t', NF_DOUBLE, 2, dims(1:2), id_depth_t)
    rcode = nf_def_var(ncid, 'num_levels', NF_DOUBLE, 2, dims(1:2), id_num_levels)

    rcode = nf_enddef(ncid)

    start = 1; nwrite = 1;
    nwrite(1) = nlon
    rcode = nf_put_vara_double(ncid, id_grid_x_t, start, nwrite, grid_x_t)
    rcode = nf_put_vara_double(ncid, id_grid_x_c, start, nwrite, grid_x_c)
    nwrite(1) = nlat
    rcode = nf_put_vara_double(ncid, id_grid_y_t, start, nwrite, grid_y_t)
    rcode = nf_put_vara_double(ncid, id_grid_y_c, start, nwrite, grid_y_c)
    nwrite(1) = nk
    rcode = nf_put_vara_double(ncid, id_zb, start, nwrite, zb)

    nwrite(1) = nlon; nwrite(2) = nlat
    rcode = nf_put_vara_double(ncid, id_x_t, start, nwrite, x_t)
    rcode = nf_put_vara_double(ncid, id_y_t, start, nwrite, y_t) 
    rcode = nf_put_vara_double(ncid, id_x_c, start, nwrite, x_c)
    rcode = nf_put_vara_double(ncid, id_y_c, start, nwrite, y_c) 
    nwrite(3) = 4   
    rcode = nf_put_vara_double(ncid, id_x_vert_t, start, nwrite, x_vert_t)
    rcode = nf_put_vara_double(ncid, id_y_vert_t, start, nwrite, y_vert_t)

    nwrite = 1; nwrite(1) = nlon; nwrite(2) = nlat
    rcode = nf_put_vara_double(ncid, id_area_t, start, nwrite, area_t)
    rcode = nf_put_vara_double(ncid, id_ds_11_21_t, start, nwrite, ds_11_21_t)
    rcode = nf_put_vara_double(ncid, id_ds_01_11_t, start, nwrite, ds_01_11_t)
    rcode = nf_put_vara_double(ncid, id_ds_11_12_t, start, nwrite, ds_11_12_t)
    rcode = nf_put_vara_double(ncid, id_ds_10_11_t, start, nwrite, ds_10_11_t)
    rcode = nf_put_vara_double(ncid, id_ds_01_21_t, start, nwrite, ds_01_21_t)
    rcode = nf_put_vara_double(ncid, id_ds_10_12_t, start, nwrite, ds_10_12_t)
    rcode = nf_put_vara_double(ncid, id_ds_20_22_t, start, nwrite, ds_20_22_t)
    rcode = nf_put_vara_double(ncid, id_ds_02_22_t, start, nwrite, ds_02_22_t)
    rcode = nf_put_vara_double(ncid, id_ds_00_20_c, start, nwrite, ds_00_20_c)
    rcode = nf_put_vara_double(ncid, id_ds_00_02_c, start, nwrite, ds_00_02_c)
    rcode = nf_put_vara_double(ncid, id_ds_11_21_c, start, nwrite, ds_11_21_c)
    rcode = nf_put_vara_double(ncid, id_ds_01_11_c, start, nwrite, ds_01_11_c)
    rcode = nf_put_vara_double(ncid, id_ds_11_12_c, start, nwrite, ds_11_12_c)
    rcode = nf_put_vara_double(ncid, id_ds_10_11_c, start, nwrite, ds_10_11_c)
    rcode = nf_put_vara_double(ncid, id_ds_01_21_c, start, nwrite, ds_01_21_c)
    rcode = nf_put_vara_double(ncid, id_ds_10_12_c, start, nwrite, ds_10_12_c)
    rcode = nf_put_vara_double(ncid, id_ds_02_22_c, start, nwrite, ds_02_22_c)
    rcode = nf_put_vara_double(ncid, id_ds_20_22_c, start, nwrite, ds_20_22_c)
    rcode = nf_put_vara_double(ncid, id_ds_01_21_e, start, nwrite, ds_01_21_e)
    rcode = nf_put_vara_double(ncid, id_ds_10_12_n, start, nwrite, ds_10_12_n)
    rcode = nf_put_vara_double(ncid, id_angle_c, start, nwrite, angle_c )
    rcode = nf_put_vara_double(ncid, id_depth_t, start, nwrite, depth_t)
    rcode = nf_put_vara_double(ncid, id_num_levels, start, nwrite, num_levels)

    rcode = nf_close(ncid)

  end   subroutine write_new_grid

  !#####################################################################
  !--- release the memory
  subroutine grid_transfer_end

    deallocate( grid_x_T, grid_y_T, grid_x_c, grid_y_c, zb, x_T, y_T, x_c, y_c )
    deallocate( x_vert_T, y_vert_T, angle_c, depth_t, num_levels )
    deallocate( ds_11_21_t, ds_01_11_t, ds_11_12_t, ds_10_11_t )
    deallocate( ds_01_21_t, ds_10_12_t, ds_20_22_t, ds_02_22_t )
    deallocate( ds_00_20_c, ds_00_02_c, ds_11_21_c, ds_01_11_c )
    deallocate( ds_11_12_c, ds_10_11_c, ds_01_21_c, ds_10_12_c )
    deallocate( ds_01_21_e, ds_10_12_n )

  end subroutine grid_transfer_end

  !#####################################################################

end program grid_transfer

!****6***0*********0*********0*********0*********0*********0**********72
      subroutine hswf(im, jm, km, jfirst, jlast,                    &
                      u,v,pt,pe, delp, peln, pkz,pdt,akap0,grav,rg,  &
                      strat, rayf, master, sinp,cosp,sine,cose,    &
                      ng_s, ng_d)
!****6***0*********0*********0*********0*********0*********0**********72
! !USES:

#if defined( SPMD )
      use mod_comm, only :  gid, mp_send3d, mp_recv3d
#endif
      implicit none

! !INPUT PARAMETERS:
      integer im, jm, km
      integer jfirst, jlast
      integer ng_s, ng_d
      integer pdt
      real akap0, grav, rg
      logical strat
      logical rayf
      logical master
      real cosp(jm),sinp(jm),cose(jm),sine(jm)

! !INPUT/OUTPUT PARAMETERS:

      real :: u(im,jfirst-ng_d:jlast+ng_s,km)
      real :: v(im,jfirst-ng_d:jlast+ng_d,km)
      real :: pt(im,jfirst-ng_d:jlast+ng_d,km)
      real :: delp(im,jfirst:jlast,km)
      real ::   pe(im,km+1,jfirst:jlast)
      real :: peln(im,km+1,jfirst:jlast)
      real :: pkz(im,jfirst:jlast,km)


! !DESCRIPTION:
!    Author: Shian-Jiann Lin, JCET, UMBC and NASA/GSFC
!
! !REVISION HISTORY:
!   SJL 99.09.30:  Delivery
!   WS  99.10.28:  jfirst:jlast; documentation
!   WS  99.11.07:  pruned arrays
!   WS  00.07.10:  Incorporated simplfications to PILGRIM
!
!EOP
!-----------------------------------------------------------------------
!BOC
!

      real  p0, t0, sday, rkv, rka, rks, rkt, sigb, rsgb
      real  tmp
      real  ap0k, algpk, rfc
      real  tey, tez, fac, pw, sigl
      real  pl(im,km),frac(im,jm)
      real  teq(im,km)
      real  h0, dz
      real  dt_tropic
      real  rmr, rms
      real  relx, tau
      real  t_st, t_ms
      real  f1
      real  ptop
      real  ak(km+1), bk(km+1)
      real  pc, c1
      real  t2(im, km)
      real  dp(im, km)

      real  ua(im,jfirst:jlast,km)
      real  va(im,jfirst:jlast,km)
      real  u2(im,km)
      real  v2(im,km)
      real  fu(im,km)
      real  fv(im,km)

#if defined( SPMD )
      real  , allocatable :: pesouth(:,:), uasouth(:,:)    !will be removed later
!      real  :: pesouth(im, km+1), uasouth(im, km)    !will be removed later
#endif
      real rdt
      real tz
      real akap
      integer ks
      save ks

      integer i, j, k, js2g0, js2gm1, jn2g0, count, ierror

      logical initialized
      data initialized /.false./

      real, allocatable, save :: sinp2(:),cosp2(:),cosp4(:), rf(:)

      js2g0  = max(2,jfirst)
      js2gm1 = max(2,jfirst+1)
      jn2g0  = min(jm-1,jlast)

      tz = 10.             ! Original value from H-S was 10.
      akap = 2./7.

      p0 = 100000.
      t0 = 200.
      h0 = 7.
      sday = 24*3600
      rkv = 0.5*pdt/sday
      rka = pdt/ (40.*sday)      ! was 40 days
      rfc = 1./(1.+rka)
      rks = pdt/ (4.*sday)       ! was 4 days

! For strat-mesosphere
      t_ms = 10.
      t_st = 40.
      tau = (t_st - t_ms) / log(100.)
      rms = pdt/(t_ms*sday)
      rmr =  1./(1.+rms)

      sigb = 0.7
      rsgb = 1./(1.-sigb)
      ap0k = 1./p0**akap
      algpk = log(ap0k)

      if ( .not. initialized ) then
        allocate( sinp2(jm), cosp2(jm), cosp4(jm), rf(km) )
        do j=2,jm-1
          sinp2(j) = sinp(j)**2
          cosp2(j) = cosp(j)**2
        enddo

        sinp2(1) = ( 0.5*(-1.+sine(2)) )**2
        sinp2(jm) = sinp2(1)
        cosp2(1) = ( 0.5*cose(2) ) **2
        cosp2(jm) = cosp2(1)

        do j=1,jm
          cosp4(j) = cosp2(j)**2
        enddo

        call set_eta(km, ks, ptop, ak, bk)

        if ( rayf ) then
          c1 = 1. / (36.*3600)
          pc = 1.
          do k=1,ks
            tmp = (ak(k+1)-ak(k))/log(ak(k+1)/ak(k))
            rf(k) = c1*(1.+tanh(log10(pc/tmp)))
            if(master) write(6,*) k, 0.01*tmp, 1./(rf(k)*sday)
	    rf(k) = 1./(1.+pdt*rf(k))
          enddo
        endif

	initialized = .true.
      endif

!$omp  parallel do                                      &
!$omp  default(shared)                                  &
!$omp  private(i,j,k,pl,tey,tez,dz,relx,dt_tropic, rdt) &
!$omp  private(teq,sigl,f1,rkt, tmp, u2, v2, fu, fv, t2, dp)

      do 1000 j=jfirst,jlast

        tey = ap0k*(315.-60.*sinp2(j))
!       tez = ap0k*10./akap*cosp2(j)
        tez = tz*(ap0k/akap)*cosp2(j)

        do k=1,km
          do i=1,im
            pl(i,k) = delp(i,j,k) / ( peln(i,k+1,j)-peln(i,k,j))
          enddo
        enddo

        do k=km,1,-1
          do i=1,im
            if (strat .and. pl(i,k) < 10000.    &
                      .and. pl(i,k) > 100.  )  then
              dz = h0 * log(pl(i,k+1)/pl(i,k))
!
! Lapse rate above tropic stratopause is 2.25 deg/km
! Relaxation time is t_st days at 100 mb (as H-S) and gradually
! decreases to t_ms Days at and above the stratopause
!
              relx =  t_ms + tau*log(0.01*pl(i,k))
              relx = pdt/(relx*sday)
              dt_tropic = 2.25*cosp(j) * dz
              teq(i,k)  =  teq(i,k+1) + dt_tropic
              pt(i,j,k) = (pt(i,j,k)+relx*teq(i,k))/(1.+relx)
            elseif (strat .and. pl(i,k) <= 100.)  then
!
! Mesosphere: defined as the region above 1 mb
!
              dz = h0 * log(pl(i,k+1)/pl(i,k))
              dt_tropic = -2.25*cosp(j) * dz
              teq(i,k) = teq(i,k+1) + dt_tropic
              pt(i,j,k) = (pt(i,j,k)+rms*teq(i,k))*rmr
            else
!
! Trop:  strictly Held-Suarez
!
              sigl = pl(i,k)/pe(i,km+1,j)
              f1 = max(0., (sigl-sigb) * rsgb )
              teq(i,k) = tey - tez*(log(pkz(i,j,k))+algpk)
              teq(i,k) = max(t0, teq(i,k)*pkz(i,j,k))
              rkt = rka + (rks-rka)*f1*cosp4(j)
              pt(i,j,k) = (pt(i,j,k)+rkt*teq(i,k))/(1.+rkt)
            endif
          enddo     !i-loop
        enddo     !k-loop

1000  continue

#if defined( SPMD )
!
! Communication might include ua and/or pe on the south only

      allocate (uasouth(im, km)) 
      allocate (pesouth(im, km+1)) 

1001  continue
      call mp_send3d(gid+1, gid-1, im, km+1, jm, 1, im, 1, km+1, jfirst, jlast,&
                            1, im, 1, km+1, jlast, jlast, pe)
      call mp_recv3d(gid-1, im, km+1, jm, 1, im, 1, km+1, jfirst-1, jfirst-1, &
                            1, im, 1, km+1, jfirst-1, jfirst-1, pesouth)
#endif

!$omp  parallel do                  &
!$omp  default(shared)              &
!$omp  private(i,j,k,sigl,fac,frac)


      do 2000 k=1,km

        if (rayf .and. k <= ks) then
! Apply Rayleigh friction
          do j=js2g0,jlast
            do i=1,im
              u(i,j,k) = u(i,j,k)*rf(k)
            enddo
          enddo

          do j=js2g0,jn2g0
            do i=1,im
              v(i,j,k) = v(i,j,k)*rf(k)
            enddo
          enddo
        else
! Surface Rayleigh friction according to Held-Suarez
          do j=jfirst,jlast
            do i=1,im
              sigl = 0.5*(pe(i,k,j)+pe(i,k+1,j)) / pe(i,km+1,j)
              frac(i,j) = max(0., (sigl-sigb)*rsgb )
            enddo
          enddo
#if defined( SPMD )
          if ( jfirst > 1 ) then
            do i=1,im
              sigl = 0.5*(pesouth(i,k)+pesouth(i,k+1)) / pesouth(i,km+1)
              frac(i,jfirst-1) = max(0., (sigl-sigb)*rsgb )
            enddo
          endif
#endif

! Backward adjustment
          do j=js2g0,jlast
            do i=1,im
              fac = frac(i,j)+frac(i,j-1)
              if (fac .gt. 0.) then
                u(i,j,k) = u(i,j,k)/(1.+rkv*fac)
              endif
            enddo
          enddo

          do j=js2g0,jn2g0
            do i=2,im
              fac = frac(i,j)+frac(i-1,j)
              if (fac .gt. 0.) then
                 v(i,j,k) = v(i,j,k)/(1.+rkv*fac)
              endif
            enddo
          enddo

          do j=js2g0,jn2g0
             fac = frac(1,j)+frac(im,j)
             if (fac .gt. 0.) then
                 v(1,j,k) = v(1,j,k)/(1.+rkv*fac)
             endif
          enddo
        endif
2000  continue


#if defined (SPMD)
      deallocate (pesouth)
      deallocate (uasouth)
#endif

      return
      end

module ocean_rough_mod

!-----------------------------------------------------------------------

#ifdef INTERNAL_FILE_NML
use          mpp_mod, only: input_nml_file
#else
use          fms_mod, only: open_namelist_file
#endif

use       fms_mod, only: error_mesg, FATAL, file_exist,  &
                         check_nml_error, mpp_pe, mpp_root_pe, close_file, &
                         write_version_number, stdlog
use constants_mod, only: grav

implicit none
private

public :: compute_ocean_roughness, fixed_ocean_roughness

!-----------------------------------------------------------------------
character(len=256) :: version = '$Id: ocean_rough.F90,v 19.0 2012/01/06 20:37:13 fms Exp $'
character(len=256) :: tagname = '$Name: tikal $'
!-----------------------------------------------------------------------
!----- namelist -----

  real    :: roughness_init = 0.00044   ! not used in this version
  real    :: roughness_min  = 1.e-6
  real    :: charnock       = 0.032
  
  real    :: roughness_mom   = 5.8e-5
  real    :: roughness_heat  = 5.8e-5   ! was 4.00e-4
  real    :: roughness_moist = 5.8e-5
!  real, parameter :: zcoh1 = 0.0       ! Beljaars 1994 values
!  real, parameter :: zcoq1 = 0.0
! real, parameter :: zcoh1 = 1.4e-5
! real, parameter :: zcoq1 = 1.3e-4
  real            :: zcoh1 = 0.0 !miz
  real            :: zcoq1 = 0.0 !miz
  logical :: do_highwind     = .false.
  logical :: do_cap40        = .false.

  character(len=32) :: rough_scheme = 'fixed'   ! possible values:
                                                !   'fixed'
                                                !   'charnock'
                                                !   'beljaars'

namelist /ocean_rough_nml/ roughness_init, roughness_heat,  &
                           roughness_mom,  roughness_moist, &
                           roughness_min,                   &
                           charnock,                        &
                           rough_scheme, do_highwind,       &!miz
                           do_cap40, zcoh1, zcoq1            !sjl


!-----------------------------------------------------------------------

  logical :: do_init = .true.

!-----------------------------------------------------------------------
! ---- constants ----

! ..... high wind speed - rough sea
  real, parameter :: zcom1 = 1.8e-2    ! Charnock's constant
! ..... low wind speed - smooth sea
  real, parameter :: gnu   = 1.5e-5
  real, parameter :: zcom2 = 0.11
  real, parameter :: zcoh2 = 0.40
  real, parameter :: zcoq2 = 0.62


contains

!#######################################################################

 subroutine compute_ocean_roughness ( ocean, u_star,  &
                                      rough_mom, rough_heat, rough_moist )

 logical, intent(in)  :: ocean(:,:)
 real,    intent(in)  :: u_star(:,:)
 real,    intent(out) :: rough_mom(:,:), rough_heat(:,:), rough_moist(:,:)

!-----------------------------------------------------------------------
!  computes ocean roughness for momentum using wind stress
!  and sets roughness for heat/moisture using namelist value
!-----------------------------------------------------------------------

   real, dimension(size(ocean,1),size(ocean,2)) :: ustar2, xx1, xx2, w10 !miz
   real ::  a=0.001, b=0.028 !miz

   if (do_init) call ocean_rough_init


   if (trim(rough_scheme) == 'fixed') then

!  --- set roughness for momentum and heat/moisture ---

      call fixed_ocean_roughness ( ocean, rough_mom, rough_heat, &
                                          rough_moist )


!  --- compute roughness for momentum, heat, moisture ---

   else if (trim(rough_scheme) == 'beljaars' .or. &
            trim(rough_scheme) == 'charnock') then

      where (ocean)
          ustar2(:,:) = max(gnu*gnu,u_star(:,:)*u_star(:,:))          
          xx1(:,:) = gnu / sqrt(ustar2(:,:))
          xx2(:,:) = ustar2(:,:) / grav
      elsewhere
          rough_mom   = 0.0
          rough_heat  = 0.0
          rough_moist = 0.0
      endwhere

      if (trim(rough_scheme) == 'charnock') then
          where (ocean)
              rough_mom  (:,:) = charnock * xx2(:,:)
              rough_mom  (:,:) = max( rough_mom(:,:), roughness_min )
              rough_heat (:,:) = rough_mom  (:,:)
              rough_moist(:,:) = rough_mom  (:,:)
          endwhere
      else if (trim(rough_scheme) == 'beljaars') then
!     --- Beljaars scheme ---

! SJL*** High Wind correction following Moon et al 2007 ***
          if (do_highwind) then

              if ( do_cap40 ) then
     
              where (ocean)
                  w10(:,:) = 2.458 + u_star(:,:)*(20.255-0.56*u_star(:,:))  ! Eq(7) Moon et al.
                  where ( w10(:,:) > 12.5 )
! SJL mods: cap the growth of z0 with w10 up to 40 m/s
!                     rough_mom(:,:) = 0.001*(0.085*min(w10(:,:), 40.) - 0.58)    ! capped Eq(8b) Moon et al.
! z0 (w10=40) = 2.82E-3
                      rough_mom(:,:) = 0.001*(0.085*w10(:,:) - 0.58)    ! Eq(8b) Moon et al.
                      rough_mom(:,:) = min( rough_mom(:,:), 2.82E-3)
                  elsewhere     
                      rough_mom(:,:) = 0.0185/grav*u_star(:,:)**2  ! (8a) Moon et al.
                  endwhere
                  rough_heat (:,:) = zcoh1 * xx2(:,:) + zcoh2 * xx1(:,:)
                  rough_moist(:,:) = zcoq1 * xx2(:,:) + zcoq2 * xx1(:,:)
!             --- lower limit on roughness? ---
                  rough_mom  (:,:) = max( rough_mom  (:,:), roughness_min )
                  rough_heat (:,:) = max( rough_heat (:,:), roughness_min )
                  rough_moist(:,:) = max( rough_moist(:,:), roughness_min )
              endwhere

              else

              where (ocean)
                  w10(:,:) = 2.458 + u_star(:,:)*(20.255-0.56*u_star(:,:))  ! Eq(7) Moon et al.
                  where ( w10(:,:) > 12.5 )
                      rough_mom(:,:) = 0.001*(0.085*w10(:,:) - 0.58)    ! Eq(8b) Moon et al.
                  elsewhere     
                      rough_mom(:,:) = 0.0185/grav*u_star(:,:)**2  ! (8a) Moon et al.
                  endwhere
                  rough_heat (:,:) = zcoh1 * xx2(:,:) + zcoh2 * xx1(:,:)
                  rough_moist(:,:) = zcoq1 * xx2(:,:) + zcoq2 * xx1(:,:)
!             --- lower limit on roughness? ---
                  rough_mom  (:,:) = max( rough_mom  (:,:), roughness_min )
                  rough_heat (:,:) = max( rough_heat (:,:), roughness_min )
                  rough_moist(:,:) = max( rough_moist(:,:), roughness_min )
              endwhere

              endif
! SJL ----------------------------------------------------------------------------------------

          else
          where (ocean)
              rough_mom  (:,:) = zcom1 * xx2(:,:) + zcom2 * xx1(:,:)
              rough_heat (:,:) = zcoh1 * xx2(:,:) + zcoh2 * xx1(:,:)
              rough_moist(:,:) = zcoq1 * xx2(:,:) + zcoq2 * xx1(:,:)
!             --- lower limit on roughness? ---
              rough_mom  (:,:) = max( rough_mom  (:,:), roughness_min )
              rough_heat (:,:) = max( rough_heat (:,:), roughness_min )
              rough_moist(:,:) = max( rough_moist(:,:), roughness_min )
          endwhere
          endif
      endif
   endif

!-----------------------------------------------------------------------

 end subroutine compute_ocean_roughness

!#######################################################################

 subroutine fixed_ocean_roughness ( ocean, rough_mom, rough_heat, rough_moist )

 logical, intent(in)  :: ocean(:,:)
 real,    intent(out) :: rough_mom(:,:), rough_heat(:,:), rough_moist(:,:)

   if (do_init) call ocean_rough_init

    where (ocean)
       rough_mom   = roughness_mom
       rough_heat  = roughness_heat
       rough_moist = roughness_moist
    endwhere

 end subroutine fixed_ocean_roughness

!#######################################################################

 subroutine ocean_rough_init

   integer :: unit, ierr, io

!   ----- read and write namelist -----

#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_rough_nml, iostat=io)
  ierr = check_nml_error(io, 'ocean_rough_nml')
#else
    if ( file_exist('input.nml')) then
          unit = open_namelist_file ('input.nml')
        ierr=1; do while (ierr /= 0)
           read  (unit, nml=ocean_rough_nml, iostat=io, end=10)
           ierr = check_nml_error(io,'ocean_rough_nml')
        enddo
 10     call close_file (unit)
    endif
#endif

!------- write version number and namelist ---------

    if ( mpp_pe() == mpp_root_pe() ) then
         call write_version_number(version, tagname)
         unit = stdlog()
         write (unit,nml=ocean_rough_nml)
         write (unit,11)
    endif

!------ constants -----

    roughness_moist = max (roughness_moist, roughness_min)
    roughness_heat  = max (roughness_heat , roughness_min)
    roughness_mom   = max (roughness_mom  , roughness_min)

    do_init = .false.

11 format (/,'namelist option USE_FIXED_ROUGH is no longer supported', &
           /,'use variable ROUGH_SCHEME instead')

 end subroutine ocean_rough_init

!#######################################################################

end module ocean_rough_mod

#ifdef TEST_XGRID
! Now only test some simple test, will test cubic grid mosaic in the future.

program xgrid_test

  use mpp_mod,         only : mpp_pe, mpp_npes, mpp_error, FATAL, mpp_chksum, mpp_min, mpp_max
  use mpp_mod,         only : mpp_set_current_pelist, mpp_declare_pelist
  use mpp_domains_mod, only : mpp_define_domains, mpp_define_layout, mpp_domains_exit
  use mpp_domains_mod, only : mpp_get_compute_domain, domain2d, mpp_domains_init
  use mpp_domains_mod, only : mpp_define_mosaic_pelist, mpp_define_mosaic, mpp_global_sum
  use mpp_domains_mod, only : mpp_get_data_domain, mpp_get_global_domain, mpp_update_domains
  use mpp_io_mod,      only : mpp_open, MPP_RDONLY,MPP_NETCDF, MPP_MULTI, MPP_SINGLE, mpp_close
  use mpp_io_mod,      only : mpp_get_att_value
  use fms_mod,         only : fms_init, file_exist, field_exist, field_size, open_namelist_file
  use fms_mod,         only : check_nml_error, close_file, read_data, stdout, fms_end
  use fms_mod,         only : get_mosaic_tile_grid, write_data, set_domain
  use fms_io_mod,      only : fms_io_exit
  use constants_mod,   only : DEG_TO_RAD
  use xgrid_mod,       only : xgrid_init, setup_xmap, put_to_xgrid, get_from_xgrid
  use xgrid_mod,       only : xmap_type, xgrid_count, grid_box_type, SECOND_ORDER
  use xgrid_mod,       only : get_xmap_grid_area, set_frac_area
  use mosaic_mod,      only : get_mosaic_ntiles, get_mosaic_grid_sizes
  use mosaic_mod,      only : get_mosaic_ncontacts, get_mosaic_contact
  use gradient_mod,    only : calc_cubic_grid_info
  use ensemble_manager_mod, only : ensemble_manager_init, ensemble_pelist_setup
  use ensemble_manager_mod, only : get_ensemble_size

implicit none

  real, parameter :: EPSLN = 1.0e-10
  character(len=256) :: atm_input_file  = "INPUT/atmos_input.nc"
  character(len=256) :: atm_output_file = "atmos_output.nc"
  character(len=256) :: lnd_output_file = "land_output.nc"
  character(len=256) :: ice_output_file = "ocean_output.nc"
  character(len=256) :: atm_field_name  = "none"

  character(len=256) :: runoff_input_file  = "INPUT/land_runoff.nc"
  character(len=256) :: runoff_output_file  = "land_runoff.nc"
  character(len=256) :: runoff_field_name  = "none"
  integer            :: num_iter           = 0 
  integer            :: nk_lnd = 1, nk_ice = 1
  integer            :: atm_layout(2) = (/0,0/)
  integer            :: lnd_layout(2) = (/0,0/)
  integer            :: ice_layout(2) = (/0,0/)
  integer            :: atm_nest_layout(2) = (/0,0/)
  integer            :: atm_npes = 0
  integer            :: lnd_npes = 0
  integer            :: ice_npes = 0
  integer            :: ocn_npes = 0
  integer            :: atm_nest_npes = 0
  logical            :: concurrent = .false.

  namelist /xgrid_test_nml/ atm_input_file, atm_field_name, runoff_input_file, runoff_field_name, num_iter, &
                            nk_lnd, nk_ice, atm_layout, ice_layout, lnd_layout, atm_nest_layout, &
                            atm_nest_npes, atm_npes, lnd_npes, ice_npes

  integer              :: remap_method
  integer              :: pe, npes, ierr, nml_unit, io, n
  integer              :: siz(4), ntile_lnd, ntile_atm, ntile_ice, ncontact
  integer, allocatable :: layout(:,:), global_indices(:,:)
  integer, allocatable :: atm_nx(:), atm_ny(:), ice_nx(:), ice_ny(:), lnd_nx(:), lnd_ny(:)
  integer, allocatable :: pe_start(:), pe_end(:), dummy(:)
  integer, allocatable :: istart1(:), iend1(:), jstart1(:), jend1(:), tile1(:)
  integer, allocatable :: istart2(:), iend2(:), jstart2(:), jend2(:), tile2(:)
  character(len=256)   :: grid_file = "INPUT/grid_spec.nc"
  character(len=256)   :: atm_mosaic, ocn_mosaic, lnd_mosaic
  character(len=256)   :: atm_mosaic_file, ocn_mosaic_file, lnd_mosaic_file
  character(len=256)   :: grid_descriptor, tile_file
  integer              :: isc_atm, iec_atm, jsc_atm, jec_atm, nxc_atm, nyc_atm
  integer              :: isc_lnd, iec_lnd, jsc_lnd, jec_lnd
  integer              :: isc_ice, iec_ice, jsc_ice, jec_ice
  integer              :: isd_atm, ied_atm, jsd_atm, jed_atm
  integer              :: unit, i, j, nxa, nya, nxgrid, nxl, nyl, out_unit, k
  type(domain2d)       :: Atm_domain, Ice_domain, Lnd_domain
  type(xmap_type)      :: Xmap, Xmap_runoff
  type(grid_box_type)  :: atm_grid
  real, allocatable    :: xt(:,:), yt(:,:)  ! on T-cell data domain
  real, allocatable    :: xc(:,:), yc(:,:)  ! on C-cell compute domain
  real, allocatable    :: tmpx(:,:), tmpy(:,:)
  real, allocatable    :: atm_data_in(:,:), atm_data_out(:,:)
  real, allocatable    :: atm_data_out_1(:,:), atm_data_out_2(:,:), atm_data_out_3(:,:)
  real, allocatable    :: lnd_data_out(:,:,:), ice_data_out(:,:,:)
  real, allocatable    :: runoff_data_in(:,:), runoff_data_out(:,:,:)
  real, allocatable    :: atm_area(:,:), lnd_area(:,:), ice_area(:,:)
  real, allocatable    :: lnd_frac(:,:,:), ice_frac(:,:,:)
  real, allocatable    :: x_1(:), x_2(:), x_3(:), x_4(:)
  real                 :: sum_atm_in, sum_ice_out, sum_lnd_out, sum_atm_out
  real                 :: sum_runoff_in, sum_runoff_out, tot
  real                 :: min_atm_in, max_atm_in, min_atm_out, max_atm_out
  real                 :: min_x, max_x
  logical              :: atm_input_file_exist, runoff_input_file_exist
  integer              :: npes_per_tile
  integer              :: id_put_side1_to_xgrid, id_get_side1_from_xgrid
  integer              :: id_put_side2_to_xgrid, id_get_side2_from_xgrid
  integer              :: ens_siz(6), ensemble_size
  integer              :: atm_root_pe, lnd_root_pe, ocn_root_pe, ice_root_pe, atm_nest_root_pe
  integer              :: atm_global_npes, ntile_atm_global, ncontact_global
  integer              :: atm_nest_nx, atm_nest_ny, ntile_atm_nest
  logical              :: atm_pe, lnd_pe, ice_pe, ocn_pe, atm_global_pe, atm_nest_pe
  integer, allocatable :: atm_pelist(:), ocn_pelist(:), ice_pelist(:), lnd_pelist(:)
  integer, allocatable :: atm_global_pelist(:), atm_nest_pelist(:)
  integer, allocatable :: tile_id(:)

  call fms_init

  call mpp_domains_init

  call xgrid_init(remap_method)
  call ensemble_manager_init() 

  npes     = mpp_npes()
  pe       = mpp_pe()
  out_unit = stdout()

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, xgrid_test_nml, iostat=io)
      ierr = check_nml_error(io, 'xgrid_test_nml')
#else
  if (file_exist('input.nml')) then
     ierr=1
     nml_unit = open_namelist_file()
     do while (ierr /= 0)
        read(nml_unit, nml=xgrid_test_nml, iostat=io, end=10)
        ierr = check_nml_error(io, 'xgrid_test_nml')
     enddo
10   call close_file(nml_unit)
  endif
#endif

  !--- get ensemble size
  ens_siz = get_ensemble_size()   
  ensemble_size = ens_siz(1)      
  npes = ens_siz(2)              

  if( atm_npes == 0 ) atm_npes = mpp_npes()
  if( lnd_npes == 0 ) lnd_npes = atm_npes
  if( ocn_npes == 0 ) ocn_npes = atm_npes
  if( ice_npes == 0 ) ice_npes = atm_npes
  if(lnd_npes > atm_npes) call mpp_error(FATAL, 'xgrid_test: lnd_npes > atm_npes')
  if(ocn_npes > atm_npes) call mpp_error(FATAL, 'xgrid_test: ocn_npes > atm_npes')
  
  write(out_unit, *) "NOTE from test_xgrid: atm_npes = ", atm_npes
  write(out_unit, *) "NOTE from test_xgrid: atm_nest_npes = ", atm_nest_npes
  write(out_unit, *) "NOTE from test_xgrid: lnd_npes = ", lnd_npes
  write(out_unit, *) "NOTE from test_xgrid: ice_npes = ", ice_npes
  write(out_unit, *) "NOTE from test_xgrid: ocn_npes = ", ocn_npes
  
  allocate(atm_pelist(atm_npes))
  allocate(ice_pelist(ice_npes))
  allocate(lnd_pelist(lnd_npes))
  allocate(ocn_pelist(ocn_npes))
  concurrent = .false.

  call ensemble_pelist_setup(concurrent, atm_npes, ocn_npes, lnd_npes, ice_npes, &
                             atm_pelist, ocn_pelist, lnd_pelist, ice_pelist)
 
  if(atm_nest_npes > 0) then
    atm_global_npes = atm_npes - atm_nest_npes
    allocate(atm_global_pelist(atm_global_npes))
    allocate(atm_nest_pelist(atm_nest_npes))
    atm_global_pelist(1:atm_global_npes) = atm_pelist(1:atm_global_npes)
    atm_nest_pelist(1:atm_nest_npes)     = atm_pelist(atm_global_npes+1:atm_npes)
    atm_global_pe = ANY(atm_global_pelist == mpp_pe())
    atm_nest_pe = ANY(atm_nest_pelist == mpp_pe())
    atm_nest_root_pe = atm_nest_pelist(1)
    call mpp_declare_pelist(atm_global_pelist, "atm global pelist")
    call mpp_declare_pelist(atm_nest_pelist, "atm nest pelist")
  else
    atm_global_npes = atm_npes
    allocate(atm_global_pelist(atm_global_npes))
    atm_global_pelist(1:atm_global_npes) = atm_pelist(1:atm_global_npes)
    atm_global_pe = ANY(atm_global_pelist == mpp_pe())
    atm_nest_pe = .FALSE.
  endif

  atm_pe = ANY(atm_pelist   .EQ. mpp_pe()) 
  lnd_pe = ANY(lnd_pelist   .EQ. mpp_pe()) 
  ocn_pe = ANY(ocn_pelist   .EQ. mpp_pe()) 
  ice_pe = ANY(ice_pelist   .EQ. mpp_pe())
  atm_root_pe = atm_pelist(1)
  lnd_root_pe = lnd_pelist(1)
  ice_root_pe = ice_pelist(1)
  ocn_root_pe = ocn_pelist(1)

  ntile_atm = 1
  ntile_ice = 1
  ntile_lnd = 1

  if(field_exist(grid_file, "AREA_ATM" ) ) then
     if( atm_nest_npes > 0 ) call mpp_error(FATAL,  &
           'xgrid_test: nested atmosphere model is only supported for mosaic grid')
     allocate(atm_nx(1), atm_ny(1))
     allocate(lnd_nx(1), lnd_ny(1))
     allocate(ice_nx(1), ice_ny(1))
     call field_size(grid_file, "AREA_ATM", siz )
     atm_nx = siz(1); atm_ny = siz(2)
     call field_size(grid_file, "AREA_OCN", siz )
     ice_nx = siz(1); ice_ny = siz(2)
     call field_size(grid_file, "AREA_LND", siz )
     lnd_nx = siz(1); lnd_ny = siz(2)
     if( atm_layout(1)*atm_layout(2) .NE. npes ) then
        call mpp_define_layout( (/1,atm_nx,1,atm_ny/), npes, atm_layout) 
     endif
     call mpp_define_domains( (/1,atm_nx,1,atm_ny/), atm_layout, Atm_domain, name="atmosphere")
     if( lnd_layout(1)*lnd_layout(2) .NE. npes ) then
        call mpp_define_layout( (/1,lnd_nx,1,lnd_ny/), npes, lnd_layout) 
     endif
     call mpp_define_domains( (/1,lnd_nx,1,lnd_ny/), lnd_layout, Lnd_domain, name="land") 
     if( ice_layout(1)*ice_layout(2) .NE. npes ) then
        call mpp_define_layout( (/1,ice_nx,1,ice_ny/), npes, ice_layout)
     endif
     call mpp_define_domains( (/1,ice_nx,1,ice_ny/), ice_layout, Ice_domain, name="Ice")
  else if (field_exist(grid_file, "atm_mosaic" ) ) then
     !--- Get the mosaic data of each component model 
     call read_data(grid_file, 'atm_mosaic', atm_mosaic)
     call read_data(grid_file, 'lnd_mosaic', lnd_mosaic)
     call read_data(grid_file, 'ocn_mosaic', ocn_mosaic)
     atm_mosaic_file = 'INPUT/'//trim(atm_mosaic)//'.nc'
     lnd_mosaic_file = 'INPUT/'//trim(lnd_mosaic)//'.nc'
     ocn_mosaic_file = 'INPUT/'//trim(ocn_mosaic)//'.nc'

     ntile_lnd = get_mosaic_ntiles(lnd_mosaic_file);
     ntile_ice = get_mosaic_ntiles(ocn_mosaic_file);
     ntile_atm = get_mosaic_ntiles(atm_mosaic_file);

     if(ntile_ice > 1) call mpp_error(FATAL,  &
           'xgrid_test: there is more than one tile in ocn_mosaic, which is not implemented yet')

     write(out_unit,*)" There is ", ntile_atm, " tiles in atmos mosaic"
     write(out_unit,*)" There is ", ntile_lnd, " tiles in land  mosaic"
     write(out_unit,*)" There is ", ntile_ice, " tiles in ocean mosaic"
     allocate(atm_nx(ntile_atm), atm_ny(ntile_atm))
     allocate(lnd_nx(ntile_lnd), lnd_ny(ntile_lnd))
     allocate(ice_nx(ntile_ice), ice_ny(ntile_ice))

     call get_mosaic_grid_sizes(atm_mosaic_file, atm_nx, atm_ny)
     call get_mosaic_grid_sizes(lnd_mosaic_file, lnd_nx, lnd_ny)
     call get_mosaic_grid_sizes(ocn_mosaic_file, ice_nx, ice_ny)

     ncontact = get_mosaic_ncontacts(atm_mosaic_file)

     if(ncontact > 0) then
        allocate(tile1(ncontact),   tile2(ncontact) )
        allocate(istart1(ncontact), iend1(ncontact) )
        allocate(jstart1(ncontact), jend1(ncontact) )
        allocate(istart2(ncontact), iend2(ncontact) )
        allocate(jstart2(ncontact), jend2(ncontact) )
        call get_mosaic_contact( atm_mosaic_file, tile1, tile2, istart1, iend1, jstart1, jend1, &
                                 istart2, iend2, jstart2, jend2)
     endif

     ntile_atm_global = ntile_atm
     ncontact_global = ncontact
     if( atm_nest_npes > 0 ) then
        if(ntile_atm .NE. 7) call mpp_error(FATAL,  &
           'xgrid_test: ntile_atm should be 7 when atmos_nest_npes > 0')
        if(ncontact .NE. 13 ) call mpp_error(FATAL,  &
           'xgrid_test: ncontact_atm should be 13 when atmos_nest_npes > 0')
        ntile_atm_global = ntile_atm_global - 1
        ncontact_global  = ncontact_global  - 1
     endif

     if(atm_global_pe) then         
        call mpp_set_current_pelist(atm_global_pelist)
        if(mod(atm_global_npes, ntile_atm_global) .NE. 0 ) call mpp_error(FATAL, &
             "atm_npes_global should be divided by ntile_atm_global")

        allocate(pe_start(ntile_atm_global), pe_end(ntile_atm_global) )
        allocate(global_indices(4, ntile_atm_global), layout(2,ntile_atm_global))
        npes_per_tile = atm_global_npes/ntile_atm_global
        do n = 1, ntile_atm_global
           pe_start(n) = atm_root_pe + (n-1)*npes_per_tile
           pe_end(n)   = atm_root_pe + n*npes_per_tile - 1
           global_indices(:,n) = (/1, atm_nx(n), 1, atm_ny(n)/)
           if(atm_layout(1)*atm_layout(2) == npes_per_tile ) then
              layout(:,n) = atm_layout(:)
           else
              call mpp_define_layout( global_indices(:,n), pe_end(n)-pe_start(n)+1, layout(:,n))
           endif
        end do
 
        allocate(tile_id(ntile_atm_global))
        do n = 1, ntile_atm_global
           tile_id(n) = n
        enddo

        call mpp_define_mosaic(global_indices, layout, Atm_domain, ntile_atm_global, ncontact_global, &
                               tile1(1:ncontact_global), tile2(1:ncontact_global),                    &
                               istart1(1:ncontact_global), iend1(1:ncontact_global),                  &
                               jstart1(1:ncontact_global), jend1(1:ncontact_global),                  &
                               istart2(1:ncontact_global), iend2(1:ncontact_global),                  &
                               jstart2(1:ncontact_global), jend2(1:ncontact_global),                  &
                               pe_start, pe_end, whalo=1, ehalo=1, shalo=1, nhalo=1,                  &
                               tile_id=tile_id, name="atmosphere")
        deallocate( pe_start, pe_end, global_indices, layout, tile_id )
     endif
     if( atm_nest_pe ) then
        atm_nest_nx = atm_nx(ntile_atm)
        atm_nest_ny = atm_ny(ntile_atm)
        call mpp_set_current_pelist(atm_nest_pelist)
        ntile_atm_nest = 1
        ncontact = 0
        allocate(pe_start(1), pe_end(1) )
        allocate(global_indices(4, 1), layout(2,1))
        pe_start(1) = atm_nest_root_pe 
        pe_end(1)   = atm_nest_root_pe + atm_nest_npes - 1
        global_indices(:,1) = (/1, atm_nest_nx, 1, atm_nest_ny/)  !-- the last tile is the nested tile
        if(atm_nest_layout(1)*atm_nest_layout(2) == atm_nest_npes ) then
           layout(:,1) = atm_nest_layout(:)
        else
           call mpp_define_layout( global_indices(:,1), atm_nest_npes, layout(:,1))
        endif
        allocate(tile_id(1))
        tile_id(1) = ntile_atm
        call mpp_define_mosaic(global_indices, layout, Atm_domain, ntile_atm_nest, ncontact, dummy, dummy, &
                               dummy, dummy, dummy, dummy, dummy, dummy, dummy, dummy, pe_start, pe_end, &
                               whalo=1, ehalo=1, shalo=1, nhalo=1, tile_id=tile_id, name="atmos nest")
        deallocate( pe_start, pe_end, global_indices, layout, tile_id )
     endif

     if( lnd_pe ) then
        call mpp_set_current_pelist(lnd_pelist)
        ncontact = 0 ! no update is needed for land model.
        allocate(pe_start(ntile_lnd), pe_end(ntile_lnd) )
        allocate(global_indices(4,ntile_lnd), layout(2,ntile_lnd))
        if(mod(lnd_npes, ntile_lnd) .NE. 0 ) call mpp_error(FATAL,"lnd_npes should be divided by ntile_lnd")
        npes_per_tile = lnd_npes/ntile_lnd  
        do n = 1, ntile_lnd
           pe_start(n) = lnd_root_pe + (n-1)*npes_per_tile
           pe_end(n)   = lnd_root_pe + n*npes_per_tile - 1
           global_indices(:,n) = (/1, lnd_nx(n), 1, lnd_ny(n)/)
           if(lnd_layout(1)*lnd_layout(2) == npes_per_tile ) then
              layout(:,n) = lnd_layout(:)
           else
              call mpp_define_layout( global_indices(:,n), npes_per_tile, layout(:,n))
           endif
        end do

        ncontact = 0 ! no update is needed for land and ocean model.

        allocate(tile_id(ntile_lnd))
        do n = 1, ntile_lnd
           tile_id(n) = n      
        enddo

        call mpp_define_mosaic(global_indices, layout, Lnd_domain, ntile_lnd, ncontact, dummy, dummy, &
             dummy, dummy, dummy, dummy, dummy, dummy, dummy, dummy, pe_start, pe_end, tile_id=tile_id, name="land")
        deallocate( pe_start, pe_end, global_indices, layout, tile_id )
     endif

     if( ice_pe ) then
        call mpp_set_current_pelist(ice_pelist)
        ncontact = 0 ! no update is needed for ocn model.
        allocate(pe_start(ntile_ice), pe_end(ntile_ice) )
        allocate(global_indices(4, ntile_ice), layout(2, ntile_ice))
        npes_per_tile = ice_npes/ntile_ice
        do n = 1, ntile_ice
           pe_start(n) = ice_root_pe + (n-1)*npes_per_tile
           pe_end(n)   = ice_root_pe + n*npes_per_tile - 1
           global_indices(:,n) = (/1, ice_nx(n), 1, ice_ny(n)/)
           if(ice_layout(1)*ice_layout(2) == npes_per_tile ) then
              layout(:,n) = ice_layout(:)
           else
              call mpp_define_layout( global_indices(:,n), ice_npes, layout(:,n))
           endif
        end do
        allocate(tile_id(ntile_ice))
        do n = 1, ntile_ice
           tile_id(n) = n
        enddo

        call mpp_define_mosaic(global_indices, layout, Ice_domain, ntile_ice, ncontact, dummy, dummy, &
             dummy, dummy, dummy, dummy, dummy, dummy, dummy, dummy, pe_start, pe_end, tile_id=tile_id, name="Ice")
        deallocate( pe_start, pe_end, global_indices, layout, tile_id )
     endif
  else
     call mpp_error(FATAL, 'test_xgrid:both AREA_ATM and atm_mosaic does not exist in '//trim(grid_file))
  end if

  deallocate(atm_nx, atm_ny, lnd_nx, lnd_ny, ice_nx, ice_ny)

  if( atm_pe ) then
     call mpp_get_compute_domain(atm_domain, isc_atm, iec_atm, jsc_atm, jec_atm)
     call mpp_get_data_domain(atm_domain, isd_atm, ied_atm, jsd_atm, jed_atm)
     call mpp_get_global_domain(atm_domain, xsize = nxa, ysize = nya)
     nxc_atm = iec_atm - isc_atm + 1
     nyc_atm = jec_atm - jsc_atm + 1
  endif
  if( lnd_pe ) then
     call mpp_get_compute_domain(lnd_domain, isc_lnd, iec_lnd, jsc_lnd, jec_lnd)
     call mpp_get_global_domain(lnd_domain, xsize = nxl, ysize = nyl)
  endif
  if( ice_pe ) then
     call mpp_get_compute_domain(Ice_domain, isc_ice, iec_ice, jsc_ice, jec_ice)
  endif

  ! set up atm_grid for second order conservative interpolation and atm grid is cubic grid.
  if(remap_method == SECOND_ORDER ) then  
      if( atm_nest_npes > 0 ) call mpp_error(FATAL, &
            'test_xgrid: remap_method could not be SECOND_ORDER when atmos_nest_npes > 0')
      if(ntile_atm == 6) then ! 6 tile for cubic grid
        allocate(xt         (isd_atm:ied_atm,jsd_atm:jed_atm),     yt         (isd_atm:ied_atm,jsd_atm:jed_atm)   )
        allocate(xc         (isc_atm:ied_atm,jsc_atm:jed_atm),     yc         (isc_atm:ied_atm,jsc_atm:jed_atm)   )
        allocate(atm_grid%dx(isc_atm:iec_atm,jsc_atm:jed_atm),     atm_grid%dy(isc_atm:iec_atm+1,jsc_atm:jec_atm) )
        allocate(atm_grid%edge_w(jsc_atm:jed_atm),               atm_grid%edge_e(jsc_atm:jed_atm))
        allocate(atm_grid%edge_s(isc_atm:ied_atm),               atm_grid%edge_n(isc_atm:ied_atm))
        allocate(atm_grid%en1 (3,isc_atm:iec_atm,jsc_atm:jed_atm), atm_grid%en2 (3,isc_atm:ied_atm,jsc_atm:jec_atm) )
        allocate(atm_grid%vlon(3,isc_atm:iec_atm,jsc_atm:jec_atm), atm_grid%vlat(3,isc_atm:iec_atm,jsc_atm:jec_atm) )
        allocate(atm_grid%area(isc_atm:iec_atm,jsc_atm:jec_atm) )

        ! first get grid from grid file 
        call get_mosaic_tile_grid(tile_file, atm_mosaic_file, atm_domain)
        allocate(tmpx(nxa*2+1, nya*2+1), tmpy(nxa*2+1, nya*2+1))
        call read_data( tile_file, 'x', tmpx, no_domain=.true.)
        call read_data( tile_file, 'y', tmpy, no_domain=.true.) 
        xt = 0; yt = 0;
        do j = jsc_atm, jec_atm
           do i = isc_atm, iec_atm
              xt(i,j) = tmpx(2*i, 2*j)*DEG_TO_RAD
              yt(i,j) = tmpy(2*i, 2*j)*DEG_TO_RAD
           end do
        end do
        do j = jsc_atm, jed_atm
           do i = isc_atm, ied_atm
              xc(i,j) = tmpx(2*i-1, 2*j-1)*DEG_TO_RAD
              yc(i,j) = tmpy(2*i-1, 2*j-1)*DEG_TO_RAD
           end do
        end do        
        call mpp_update_domains(xt, atm_domain)
        call mpp_update_domains(yt, atm_domain)

        call calc_cubic_grid_info(xt, yt, xc, yc, atm_grid%dx, atm_grid%dy, atm_grid%area, atm_grid%edge_w, &
                                  atm_grid%edge_e, atm_grid%edge_s, atm_grid%edge_n, atm_grid%en1,          &
                                  atm_grid%en2, atm_grid%vlon, atm_grid%vlat, isc_atm==1, iec_atm==nxa,     &
                                  jsc_atm==1, jec_atm==nya                               )
     end if
  end if

  call mpp_set_current_pelist()

  !--- conservation check is done in setup_xmap. 
  call setup_xmap(Xmap, (/ 'ATM', 'OCN', 'LND' /), (/ Atm_domain, Ice_domain, Lnd_domain /), grid_file, atm_grid)
  call setup_xmap(Xmap_runoff, (/ 'LND', 'OCN'/), (/ Lnd_domain, Ice_domain/), grid_file )
  !--- set frac area if nk_lnd or nk_ocn is greater than 1.
  if(nk_lnd > 0 .AND. lnd_pe) then
    allocate(lnd_frac(isc_lnd:iec_lnd, jsc_lnd:jec_lnd, nk_lnd))
    call random_number(lnd_frac)
    lnd_frac = lnd_frac + 0.5
    do j = jsc_lnd, jec_lnd
       do i = isc_lnd, iec_lnd
          tot = sum(lnd_frac(i,j,:))
          do k = 1, nk_lnd
             lnd_frac(i,j,k)=lnd_frac(i,j,k)/tot
          enddo
       enddo
    enddo
    call set_frac_area(lnd_frac, 'LND', xmap)
  endif
  if(nk_ice > 0 ) then
    if( ice_pe ) then
       allocate(ice_frac(isc_ice:iec_ice, jsc_ice:jec_ice, nk_ice))
       call random_number(ice_frac)
       ice_frac = ice_frac + 0.5
       do j = jsc_ice, jec_ice
          do i = isc_ice, iec_ice
             tot = sum(ice_frac(i,j,:))
             do k = 1, nk_ice
                ice_frac(i,j,k)=ice_frac(i,j,k)/tot
             enddo
          enddo
       enddo
    endif
    call set_frac_area(ice_frac, 'OCN', xmap)
  endif

  !--- remap realistic data and write the output file when atmos_input_file does exist
  atm_input_file_exist = file_exist(atm_input_file, domain=atm_domain)
  if( atm_input_file_exist ) then
     if(trim(atm_input_file) == trim(atm_output_file) ) call mpp_error(FATAL, &
          "test_xgrid: atm_input_file should have a different name from atm_output_file")
     call field_size(atm_input_file, atm_field_name, siz, domain=Atm_domain )
     if(siz(1) .NE. nxa .OR. siz(2) .NE. nya ) call mpp_error(FATAL,"test_xgrid: x- and y-size of field "//trim(atm_field_name) &
            //" in file "//trim(atm_input_file) //" does not compabile with the grid size" )
     if(siz(3) > 1) call mpp_error(FATAL,"test_xgrid: number of vertical level of field "//trim(atm_field_name) &
            //" in file "//trim(atm_input_file) //" should be no larger than 1")

     allocate(atm_data_in (isc_atm:iec_atm, jsc_atm:jec_atm   ) )
     allocate(atm_data_out(isc_atm:iec_atm, jsc_atm:jec_atm   ) )
     allocate(lnd_data_out(isc_lnd:iec_lnd, jsc_lnd:jec_lnd, nk_lnd) )
     allocate(ice_data_out(isc_ice:iec_ice, jsc_ice:jec_ice, nk_ice) )
     allocate(atm_data_out_1(isc_atm:iec_atm, jsc_atm:jec_atm   ) )
     allocate(atm_data_out_2(isc_atm:iec_atm, jsc_atm:jec_atm   ) )
     allocate(atm_data_out_3(isc_atm:iec_atm, jsc_atm:jec_atm   ) )
     nxgrid = max(xgrid_count(Xmap), 1)
     allocate(x_1(nxgrid), x_2(nxgrid))
     allocate(x_3(nxgrid), x_4(nxgrid))
     x_1 = 0
     x_2 = 0
     x_3 = 0
     x_4 = 0

     atm_data_in  = 0
     atm_data_out = 0
     lnd_data_out = 0
     ice_data_out = 0
     atm_data_out_1 = 0
     atm_data_out_2 = 0
     atm_data_out_3 = 0
     ! test one time level should be sufficient
     call read_data(atm_input_file, atm_field_name, atm_data_in, atm_domain)
     call put_to_xgrid(atm_data_in, 'ATM', x_1, Xmap, remap_method=remap_method)
     call put_to_xgrid(atm_data_in, 'ATM', x_2, Xmap, remap_method=remap_method, complete=.false.)
     call put_to_xgrid(atm_data_in, 'ATM', x_3, Xmap, remap_method=remap_method, complete=.false.)
     call put_to_xgrid(atm_data_in, 'ATM', x_4, Xmap, remap_method=remap_method, complete=.true.)
     min_x = minval(x_1)
     max_x = maxval(x_1)
     !--- check make sure x_2, x_3 and x_4 are the same as x_1
     if(ANY(x_1 .NE. x_2)) call mpp_error(FATAL,"test_xgrid: x_1 and x_2 are not equal")
     if(ANY(x_1 .NE. x_3)) call mpp_error(FATAL,"test_xgrid: x_1 and x_3 are not equal")
     if(ANY(x_1 .NE. x_4)) call mpp_error(FATAL,"test_xgrid: x_1 and x_4 are not equal")
 
     deallocate(x_3,x_4)
     x_2 = 0
     call get_from_xgrid(lnd_data_out, 'LND', x_1, xmap)
     call get_from_xgrid(ice_data_out, 'OCN', x_1, xmap)
     call put_to_xgrid(lnd_data_out, 'LND', x_2, xmap)
     call put_to_xgrid(ice_data_out, 'OCN', x_2, xmap)
     call get_from_xgrid(atm_data_out, 'ATM', x_2, xmap)
     call get_from_xgrid(atm_data_out_1, 'ATM', x_2, xmap, complete=.false.)
     call get_from_xgrid(atm_data_out_2, 'ATM', x_2, xmap, complete=.false.)
     call get_from_xgrid(atm_data_out_3, 'ATM', x_2, xmap, complete=.true.)
     if(ANY(atm_data_out .NE. atm_data_out_1)) &
        call mpp_error(FATAL,"test_xgrid: atm_data_out and atm_data_out_1 are not equal")
     if(ANY(atm_data_out .NE. atm_data_out_2)) &
        call mpp_error(FATAL,"test_xgrid: atm_data_out and atm_data_out_2 are not equal")
     if(ANY(atm_data_out .NE. atm_data_out_3)) &
        call mpp_error(FATAL,"test_xgrid: atm_data_out and atm_data_out_3 are not equal")

     call write_data( atm_output_file, atm_field_name, atm_data_out, atm_domain)
     call write_data( lnd_output_file, atm_field_name, lnd_data_out, lnd_domain)
     call write_data( ice_output_file, atm_field_name, ice_data_out, Ice_domain)
     !--- print out checksum
     write(out_unit,*) "chksum for atm_data_in",  mpp_chksum(atm_data_in)
     write(out_unit,*) "chksum for lnd_data_out", mpp_chksum(lnd_data_out)
     write(out_unit,*) "chksum for ice_data_out", mpp_chksum(ice_data_out)
     write(out_unit,*) "chksum for atm_data_out", mpp_chksum(atm_data_out)

     ! conservation check 
     allocate(atm_area(isc_atm:iec_atm, jsc_atm:jec_atm ) )
     allocate(lnd_area(isc_lnd:iec_lnd, jsc_lnd:jec_lnd ) )
     allocate(ice_area(isc_ice:iec_ice, jsc_ice:jec_ice ) )
     call get_xmap_grid_area("ATM", Xmap, atm_area)
     call get_xmap_grid_area("LND", Xmap, lnd_area)
     call get_xmap_grid_area("OCN", Xmap, ice_area)

     min_atm_in   = minval(atm_data_in)
     max_atm_in   = maxval(atm_data_in)
     min_atm_out  = minval(atm_data_out)
     max_atm_out  = maxval(atm_data_out)
     call mpp_min(min_atm_in)
     call mpp_max(max_atm_in)
     call mpp_min(min_atm_out)
     call mpp_max(max_atm_out)
     call mpp_min(min_x)
     call mpp_max(max_x)

     sum_atm_in  = mpp_global_sum(atm_domain, atm_area * atm_data_in)
     sum_lnd_out = 0
     do k = 1, nk_lnd
        sum_lnd_out = sum_lnd_out + mpp_global_sum(lnd_domain, lnd_area * lnd_data_out(:,:,k))
     enddo
     sum_ice_out = 0
     do k = 1, nk_ice
        sum_ice_out = sum_ice_out + mpp_global_sum(ice_domain, ice_area * ice_data_out(:,:,k))
     enddo
     sum_atm_out = mpp_global_sum(atm_domain, atm_area * atm_data_out)
     write(out_unit,*) "********************** check conservation *********************** "
     write(out_unit,*) "the global area sum of atmos input data is                    : ", sum_atm_in 
     write(out_unit,*) "the global area sum of atmos output data is                   : ", sum_atm_out
     write(out_unit,*) "the global area sum of land output data + ocean output data is: ", sum_lnd_out+sum_ice_out
     write(out_unit,*) "The min of atmos input   data is ", min_atm_in
     write(out_unit,*) "The min of xgrid         data is ", min_x
     write(out_unit,*) "The min of atmos output  data is ", min_atm_out
     write(out_unit,*) "The max of atmos input   data is ", max_atm_in
     write(out_unit,*) "The max of xgrid         data is ", max_x
     write(out_unit,*) "The max of atmos output  data is ", max_atm_out


     deallocate(atm_area, lnd_area, ice_area, atm_data_in, atm_data_out, lnd_data_out, ice_data_out)
     deallocate(atm_data_out_1, atm_data_out_2, atm_data_out_3)
     deallocate(x_1, x_2)
  else
     write(out_unit,*) "NOTE from test_xgrid ==> file "//trim(atm_input_file)//" does not exist, no check is done for real data sets."
  end if           

  runoff_input_file_exist = file_exist(runoff_input_file, domain=atm_domain)     
  if( runoff_input_file_exist ) then
     if( atm_nest_npes > 0 ) call mpp_error(FATAL, &
          "test_xgrid: runoff_input_file_exist should be false when atmos_nest_npes > 0")
     if(trim(runoff_input_file) == trim(runoff_output_file) ) call mpp_error(FATAL, &
          "test_xgrid: runoff_input_file should have a different name from runoff_output_file")
     call field_size(runoff_input_file, runoff_field_name, siz )
     if(siz(1) .NE. nxl .OR. siz(2) .NE. nyl ) call mpp_error(FATAL,"test_xgrid: x- and y-size of field "//trim(runoff_field_name) &
            //" in file "//trim(runoff_input_file) //" does not compabile with the grid size" )
     if(siz(3) > 1) call mpp_error(FATAL,"test_xgrid: number of vertical level of field "//trim(runoff_field_name) &
            //" in file "//trim(runoff_input_file) //" should be no larger than 1")

     allocate(runoff_data_in (isc_lnd:iec_lnd, jsc_lnd:jec_lnd   ) ) 
     allocate(runoff_data_out(isc_ice:iec_ice, jsc_ice:jec_ice, 1) )
     nxgrid = max(xgrid_count(Xmap_runoff), 1)
     allocate(x_1(nxgrid), x_2(nxgrid))

     runoff_data_in  = 0
     runoff_data_out = 0
     ! test one time level should be sufficient
     call read_data(runoff_input_file, runoff_field_name, runoff_data_in, lnd_domain)
     call put_to_xgrid(runoff_data_in, 'LND', x_1, Xmap_runoff)
     call get_from_xgrid(runoff_data_out, 'OCN', x_1, xmap_runoff)
     call write_data( runoff_output_file, runoff_field_name, runoff_data_out, ice_domain)
     ! conservation check 
     allocate(lnd_area(isc_lnd:iec_lnd, jsc_lnd:jec_lnd ) )
     allocate(ice_area(isc_ice:iec_ice, jsc_ice:jec_ice ) )
     call get_xmap_grid_area("LND", Xmap_runoff, lnd_area)
     call get_xmap_grid_area("OCN", Xmap_runoff, ice_area)

     sum_runoff_in  = mpp_global_sum(lnd_domain, lnd_area * runoff_data_in)
     sum_runoff_out = mpp_global_sum(Ice_domain, ice_area * runoff_data_out(:,:,1))
     write(out_unit,*) "********************** check conservation *********************** "
     write(out_unit,*) "the global area sum of runoff input data is                    : ", sum_runoff_in 
     write(out_unit,*) "the global area sum of runoff output data is                   : ", sum_runoff_out
  else
     write(out_unit,*) "NOTE from test_xgrid ==> file "//trim(runoff_input_file)//" does not exist, no check is done for real data sets."
  end if           

  ! when num_iter is greater than 0, create random number as input to test the performance of xgrid_mod.
  if(num_iter > 0) then
    if( atm_nest_npes > 0 ) call mpp_error(FATAL, &
          "test_xgrid: num_iter > 0 when atm_nest_npes > 0")

     allocate(atm_data_in (isc_atm:iec_atm, jsc_atm:jec_atm   ) )
     allocate(atm_data_out(isc_atm:iec_atm, jsc_atm:jec_atm   ) )
     allocate(lnd_data_out(isc_lnd:iec_lnd, jsc_lnd:jec_lnd, nk_lnd) )
     allocate(ice_data_out(isc_ice:iec_ice, jsc_ice:jec_ice, nk_ice) )
     nxgrid = max(xgrid_count(Xmap), 1)
     allocate(x_1(nxgrid), x_2(nxgrid))  
     atm_data_in  = 0
     atm_data_out = 0
     lnd_data_out = 0
     ice_data_out = 0   
     allocate(atm_area(isc_atm:iec_atm, jsc_atm:jec_atm ) )
     allocate(lnd_area(isc_lnd:iec_lnd, jsc_lnd:jec_lnd ) )
     allocate(ice_area(isc_ice:iec_ice, jsc_ice:jec_ice ) )
     call get_xmap_grid_area("ATM", Xmap, atm_area)
     call get_xmap_grid_area("LND", Xmap, lnd_area)
     call get_xmap_grid_area("OCN", Xmap, ice_area)
     do n = 1, num_iter
        call random_number(atm_data_in)
        call put_to_xgrid(atm_data_in, 'ATM', x_1, Xmap, remap_method=remap_method)

        call get_from_xgrid(lnd_data_out, 'LND', x_1, xmap)
        call get_from_xgrid(ice_data_out, 'OCN', x_1, xmap)

        call put_to_xgrid(lnd_data_out, 'LND', x_2, xmap)
        call put_to_xgrid(ice_data_out, 'OCN', x_2, xmap)

        call get_from_xgrid(atm_data_out, 'ATM', x_2, xmap)
        sum_atm_in  = mpp_global_sum(atm_domain, atm_area * atm_data_in)
        sum_lnd_out = 0
        do k = 1, nk_lnd
           sum_lnd_out = sum_lnd_out + mpp_global_sum(lnd_domain, lnd_area * lnd_data_out(:,:,k))
        enddo
        sum_ice_out = 0
        do k = 1, nk_ice
           sum_ice_out = sum_ice_out + mpp_global_sum(Ice_domain, ice_area * ice_data_out(:,:,k))
        enddo
        sum_atm_out = mpp_global_sum(atm_domain, atm_area * atm_data_out)
        write(out_unit,*) "********************** check conservation *********************** "
        write(out_unit,*) "the global area sum of atmos input data is                    : ", sum_atm_in 
        write(out_unit,*) "the global area sum of atmos output data is                   : ", sum_atm_out
        write(out_unit,*) "the global area sum of land output data + ocean output data is: ", sum_lnd_out+sum_ice_out
     enddo
     deallocate(atm_area, lnd_area, ice_area, atm_data_in, atm_data_out, lnd_data_out, ice_data_out)
     deallocate(x_1, x_2)
  endif  

  write(out_unit,*) "************************************************************************"
  write(out_unit,*) "***********      Finish running program test_xgrid         *************"
  write(out_unit,*) "************************************************************************"

  call fms_io_exit
  call fms_end

end program xgrid_test

#else
module null_test_xgrid
end module  

#endif /* test_mpp */

#include "cosp_defs.H"
#ifdef COSP_GFDL
 
!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: cosp_simulator.F90,v 20.0 2013/12/13 23:15:51 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

!
! History:
! Jul 2007 - A. Bodas-Salcedo - Initial version
!
!

!#include "cosp_defs.h" 
#ifndef COSP_GFDL
#include "cosp_defs.h" 
#endif
MODULE MOD_COSP_SIMULATOR
  USE MOD_COSP_TYPES
  USE MOD_COSP_RADAR
  USE MOD_COSP_LIDAR
  USE MOD_COSP_ISCCP_SIMULATOR
  USE MOD_COSP_MODIS_SIMULATOR
  USE MOD_COSP_MISR_SIMULATOR
#ifdef RTTOV
  USE MOD_COSP_RTTOV_SIMULATOR 
#endif
  USE MOD_COSP_STATS
  IMPLICIT NONE

CONTAINS


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!--------------------- SUBROUTINE COSP_SIMULATOR ------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#ifdef RTTOV
SUBROUTINE COSP_SIMULATOR(gbx,sgx,sghydro,cfg,vgrid,sgradar,sglidar,isccp,misr,modis,rttov,stradar,stlidar)
#else
SUBROUTINE COSP_SIMULATOR(gbx,sgx,sghydro,cfg,vgrid,sgradar,sglidar,isccp,misr,modis,stradar,stlidar)
#endif

  ! Arguments
#ifdef COSP_GFDL
  type(cosp_gridbox),intent(inout) :: gbx      ! Grid-box inputs
#else
  type(cosp_gridbox),intent(in) :: gbx      ! Grid-box inputs
#endif
  type(cosp_subgrid),intent(in) :: sgx      ! Subgrid inputs
  type(cosp_sghydro),intent(in) :: sghydro  ! Subgrid info for hydrometeors
  type(cosp_config),intent(in)  :: cfg      ! Configuration options
  type(cosp_vgrid),intent(in)   :: vgrid    ! Information on vertical grid of stats
  type(cosp_sgradar),intent(inout) :: sgradar ! Output from radar simulator
  type(cosp_sglidar),intent(inout) :: sglidar ! Output from lidar simulator
  type(cosp_isccp),intent(inout)   :: isccp   ! Output from ISCCP simulator
  type(cosp_misr),intent(inout)    :: misr    ! Output from MISR simulator
  type(cosp_modis),intent(inout)   :: modis   ! Output from MODIS simulator
#ifdef RTTOV
  type(cosp_rttov),intent(inout)    :: rttov    ! Output from RTTOV
#endif
  type(cosp_radarstats),intent(inout) :: stradar ! Summary statistics from radar simulator
  type(cosp_lidarstats),intent(inout) :: stlidar ! Summary statistics from lidar simulator
  ! Local variables
#ifdef COSP_GFDL
  integer :: i,j,k, nSunlit
#else
  integer :: i,j,k
#endif
  logical :: inconsistent
  ! Timing variables
  integer :: t0,t1,count_rate,count_max

  inconsistent=.false.
!   do k=1,gbx%Nhydro
!   do j=1,gbx%Nlevels
!   do i=1,gbx%Npoints
!     if ((gbx%mr_hydro(i,j,k)>0.0).and.(gbx%Reff(i,j,k)<=0.0)) inconsistent=.true.
!   enddo
!   enddo
!   enddo
  if (inconsistent)  print *, '%%%% COSP_SIMULATOR: inconsistency in mr_hydro and Reff'
  
  !+++++++++ Radar model ++++++++++  
  if (cfg%Lradar_sim) then
    !call system_clock(t0,count_rate,count_max)
    call cosp_radar(gbx,sgx,sghydro,sgradar)
    !call system_clock(t1,count_rate,count_max)
    !print *, '%%%%%%  Radar:', (t1-t0)*1.0/count_rate, ' s'
  endif
  
  !+++++++++ Lidar model ++++++++++
  if (cfg%Llidar_sim) then
    !call system_clock(t0,count_rate,count_max)
    call cosp_lidar(gbx,sgx,sghydro,sglidar)
    !call system_clock(t1,count_rate,count_max)
    !print *, '%%%%%%  Lidar:', (t1-t0)*1.0/count_rate, ' s'
  endif

  !+++++++++ ISCCP simulator ++++++++++
  if (cfg%Lisccp_sim) then
    !call system_clock(t0,count_rate,count_max)
    call cosp_isccp_simulator(gbx,sgx,isccp)
    !call system_clock(t1,count_rate,count_max)
    !print *, '%%%%%%  ISCCP:', (t1-t0)*1.0/count_rate, ' s'
  endif

  !+++++++++ MISR simulator ++++++++++
  if (cfg%Lmisr_sim) then
    !call system_clock(t0,count_rate,count_max)
    call cosp_misr_simulator(gbx,sgx,misr)
    !call system_clock(t1,count_rate,count_max)
    !print *, '%%%%%%  MISR:', (t1-t0)*1.0/count_rate, ' s'
  endif
  
  !+++++++++ MODIS simulator ++++++++++
  if (cfg%Lmodis_sim) then
    !call system_clock(t0,count_rate,count_max)
#ifdef COSP_GFDL
    nSunlit = count(gbx%sunlit(:) > 0)
    call cosp_modis_simulator(gbx,sgx,sghydro,isccp, nSunlit, modis)
#else
    call cosp_modis_simulator(gbx,sgx,sghydro,isccp, modis)
#endif
    !call system_clock(t1,count_rate,count_max)
    !print *, '%%%%%%  MODIS:', (t1-t0)*1.0/count_rate, ' s'
  endif
  
  !+++++++++ RTTOV ++++++++++ 
#ifdef RTTOV 
  if (cfg%Lrttov_sim) then 
    !call system_clock(t0,count_rate,count_max) 
    call cosp_rttov_simulator(gbx,rttov) 
    !call system_clock(t1,count_rate,count_max) 
    !print *, '%%%%%%  RTTOV:', (t1-t0)*1.0/count_rate, ' s' 
  endif 
#endif 


  !+++++++++++ Summary statistics +++++++++++
  if (cfg%Lstats) then
    !call system_clock(t0,count_rate,count_max)
    call cosp_stats(gbx,sgx,cfg,sgradar,sglidar,vgrid,stradar,stlidar)
    !call system_clock(t1,count_rate,count_max)
    !print *, '%%%%%%  Stats:', (t1-t0)*1.0/count_rate, ' s'
  endif
  
  !+++++++++++ Change of units after computation of statistics +++++++++++
  ! This avoids using UDUNITS in CMOR
  
!   if (cfg%Latb532) then
!     where((sglidar%beta_tot > 0.0) .and. (sglidar%beta_tot /= R_UNDEF)) 
!         sglidar%beta_tot = log10(sglidar%beta_tot)
!     elsewhere
!         sglidar%beta_tot = R_UNDEF
!     end where
!   endif
   
  ! Cloud fractions from 1 to %
  if (cfg%Lclcalipso) then
    where(stlidar%lidarcld /= R_UNDEF) stlidar%lidarcld = stlidar%lidarcld*100.0
  endif
  if (cfg%Lcltcalipso.OR.cfg%Lcllcalipso.OR.cfg%Lclmcalipso.OR.cfg%Lclhcalipso) then
    where(stlidar%cldlayer /= R_UNDEF) stlidar%cldlayer = stlidar%cldlayer*100.0
  endif
  if (cfg%Lclcalipso2) then
    where(stradar%lidar_only_freq_cloud /= R_UNDEF) stradar%lidar_only_freq_cloud = stradar%lidar_only_freq_cloud*100.0
  endif
  
  if (cfg%Lcltisccp) then
     where(isccp%totalcldarea /= R_UNDEF) isccp%totalcldarea = isccp%totalcldarea*100.0
  endif  
  if (cfg%Lclisccp) then
    where(isccp%fq_isccp /= R_UNDEF) isccp%fq_isccp = isccp%fq_isccp*100.0
  endif
  
  if (cfg%LclMISR) then
    where(misr%fq_MISR /= R_UNDEF) misr%fq_MISR = misr%fq_MISR*100.0
  endif
  
  if (cfg%Lcltlidarradar) then
    where(stradar%radar_lidar_tcc /= R_UNDEF) stradar%radar_lidar_tcc = stradar%radar_lidar_tcc*100.0
  endif
  
  if (cfg%Lclmodis) then
    where(modis%Optical_Thickness_vs_Cloud_Top_Pressure /= R_UNDEF) modis%Optical_Thickness_vs_Cloud_Top_Pressure = &
                                                      modis%Optical_Thickness_vs_Cloud_Top_Pressure*100.0
  endif
  if (cfg%Lcltmodis) then
     where(modis%Cloud_Fraction_Total_Mean /= R_UNDEF) modis%Cloud_Fraction_Total_Mean = modis%Cloud_Fraction_Total_Mean*100.0
  endif
  if (cfg%Lclwmodis) then
     where(modis%Cloud_Fraction_Water_Mean /= R_UNDEF) modis%Cloud_Fraction_Water_Mean = modis%Cloud_Fraction_Water_Mean*100.0
  endif
  if (cfg%Lclimodis) then
     where(modis%Cloud_Fraction_Ice_Mean /= R_UNDEF) modis%Cloud_Fraction_Ice_Mean = modis%Cloud_Fraction_Ice_Mean*100.0
  endif
 
  if (cfg%Lclhmodis) then
     where(modis%Cloud_Fraction_High_Mean /= R_UNDEF) modis%Cloud_Fraction_High_Mean = modis%Cloud_Fraction_High_Mean*100.0
  endif
  if (cfg%Lclmmodis) then
     where(modis%Cloud_Fraction_Mid_Mean /= R_UNDEF) modis%Cloud_Fraction_Mid_Mean = modis%Cloud_Fraction_Mid_Mean*100.0
  endif
  if (cfg%Lcllmodis) then
     where(modis%Cloud_Fraction_Low_Mean /= R_UNDEF) modis%Cloud_Fraction_Low_Mean = modis%Cloud_Fraction_Low_Mean*100.0
  endif
 
  ! Change pressure from hPa to Pa.
  if (cfg%Lboxptopisccp) then
    where(isccp%boxptop /= R_UNDEF) isccp%boxptop = isccp%boxptop*100.0
  endif
  if (cfg%Lpctisccp) then
    where(isccp%meanptop /= R_UNDEF) isccp%meanptop = isccp%meanptop*100.0
  endif
  

END SUBROUTINE COSP_SIMULATOR

END MODULE MOD_COSP_SIMULATOR

module fv_phys_mod

  public :: fv_phys

contains

  subroutine fv_phys( Time , ndt )

    use time_manager_mod, only: time_type
    use hs_forcing_mod,   only: hs_forcing
    use constants_mod,    only: grav, kappa, rdgas
    use fv_pack, only: nt_phys, beglat, endlat, nlon, nlev, rlon, rlat
    use shr_kind_mod,     only : r8 => shr_kind_r8
    use update_fv_phys_mod, only: update_fv_phys
#include <fv_arrays.h>
!  implicit none

    type (time_type), intent(in):: Time
    integer,          intent(in):: ndt         ! physics time step (sec)

! Local arrays:
!    real(r8)  dt_u(nlon, beglat:endlat, nlev)
!    real(r8)  dt_v(nlon, beglat:endlat, nlev)
!    real(r8)  dt_t(nlon, beglat:endlat, nlev)
    real(r8)  dt_q(nlon, beglat:endlat, nlev, ncnst)

    real(r8) p_full(nlon, beglat:beglat, nlev)
    real(r8) p_half(nlon, beglat:beglat, nlev+1)

    real(r8) dt, dt5
    integer i, j, k, m
    integer ij, nx, tsiz, isiz
#ifndef use_shared_pointers
    integer is, ie
#endif
    logical rayf
    logical strat
#include <fv_point.inc>

    dt = ndt

    dt5 = 0.5 * dt

#ifdef HS_TSM

    rayf  = .false.
    strat = .false.

    call hswf(nlon,  mlat,  nlev,  beglat,  endlat,       &
         u, v, pt, pe, delp, peln, pkz, ndt,         &
         kappa, grav, rdgas,  strat, rayf, master,   &
         sinp, cosp, sine, cose,  ng_s, ng_d)
#else
!    nt_phys = 1

!   isiz = window(1)
    isiz = nlon/4
    nx = nlon/isiz
    tsiz = nx * ( endlat - beglat + 1 )         ! Total loop length


! Calling phys one latitude at a time using a big/fat OpenMP loop
! For cache performance, this could be changed to finer decomposition if needed

!$omp parallel do private(ij,i,j,k,m,is,ie,p_full,p_half)
    do ij=1,tsiz              

       j  = beglat + (ij-1) / nx

       is = 1 + isiz * mod(ij-1, nx)
       ie = is + isiz - 1

       do k=1,nlev
          do i=is,ie
             u_dt(i,j,k) = 0.
             v_dt(i,j,k) = 0.
             t_dt(i,j,k) = 0.
          enddo
       enddo

       do m=1,ncnst
          do k=1,nlev
             do i=is,ie
                q_dt(i,j,k,m) = 0.
             enddo
          enddo
       enddo


       do k=1,nlev+1
          do i=is,ie
             p_half(i,beglat,k) = pe(i,k,j)
          enddo
       enddo

       do k=1,nlev
          do i=is,ie
             p_full(i,beglat,k) = delp(i,j,k) / ( peln(i,k+1,j)-peln(i,k,j))
          enddo
       enddo

       call hs_forcing(is, ie, j-beglat+1, j-beglat+1, dt, Time,   &
            rlon(is:ie,j:j), rlat(is:ie,j:j),                      &
            p_half(is:ie,beglat:beglat,:),                         &
            p_full(is:ie,beglat:beglat,:),                         &
            ua(is:ie,j:j,1:nlev), va(is:ie,j:j,1:nlev),            &
            pt(is:ie,j:j,1:nlev),  q(is:ie,j:j,1:nlev,1:ncnst),    &
            ua(is:ie,j:j,1:nlev), va(is:ie,j:j,1:nlev),            &
            pt(is:ie,j:j,1:nlev),  q(is:ie,j:j,1:nlev,1:nt_phys),  &
            u_dt(is:ie,j:j,:), v_dt(is:ie,j:j,:),                  &
            t_dt(is:ie,j:j,:), q_dt(is:ie,j:j,:,1:nt_phys) )
    enddo

    call update_fv_phys ( dt, nt_phys, .false., .false., Time )
#endif

  end subroutine fv_phys

end module fv_phys_mod

module pmaxmin_mod

  implicit none
  private
  public :: pmaxming, pmaxmin, prt_maxmin_local

contains
! Parallelized utility routines for computing/printing
! max/min of an input array
!

  subroutine pmaxmin( qname, a, pmin, pmax, im, jt, fac )

#if defined( SPMD )
#define CPP_PRT_PREFIX  if(gid.eq.0)
    use mod_comm, only : gid, mp_reduce_max
#else
#define CPP_PRT_PREFIX
#endif
    use fv_arrays_mod, only: fv_array_check, fv_array_limits, fv_stack_push, fv_array_sync
    use mpp_mod, only: mpp_sync

    implicit none

    character*(*)  qname
    integer im, jt
    integer i, j
    real a(im,jt)

    real qmin(jt), qmax(jt)
    real pmax, pmin
    real fac                     ! multiplication factor
    real pm1(2)

    integer :: js, je
#ifdef use_shared_pointers
    pointer( p_qmin, qmin )
    pointer( p_qmax, qmax )
    call fv_stack_push( p_qmin, jt )
    call fv_stack_push( p_qmax, jt )
#endif

    call fv_array_check( LOC(a) )
    call fv_array_limits( 1, jt, js, je )
!$omp parallel do private(i, j, pmax, pmin)

    do j=js,je
       pmax = a(1,j)
       pmin = a(1,j)
       do i=2,im
          pmax = max(pmax, a(i,j))
          pmin = min(pmin, a(i,j))
       enddo
       qmax(j) = pmax
       qmin(j) = pmin
    enddo
    call fv_array_sync()
!
! Now find max/min of amax/amin
!
    pmax = qmax(1)
    pmin = qmin(1)
    do j=2,jt
       pmax = max(pmax, qmax(j))
       pmin = min(pmin, qmin(j))
    enddo


#if defined( SPMD )
    pm1(1) = pmax
    call mp_reduce_max(1, pm1)
    pmax=pm1(1)
    pm1(1) = -pmin
    call mp_reduce_max(1, pm1)
    pmin=-pm1(1)
#endif

    CPP_PRT_PREFIX write(6,*) qname, ' max = ', pmax*fac, ' min = ', pmin*fac

  end subroutine pmaxmin

  subroutine pmaxming(qname, a, im, jm, km,     &
       jfirst, jlast, ng_d, ng_s, fac)

    use fv_arrays_mod, only: fv_array_check, fv_array_sync, jsp, jep
    use mpp_mod, only: mpp_sync
#ifdef use_shared_pointers
   use fv_arrays_mod, only: fv_stack_push
#endif
    implicit none

    character*(*)  qname
    integer im, jm, km, jfirst, jlast, ng_d, ng_s
    real a(im,jfirst-ng_d:jlast+ng_s,km)
    real tmp(im, jfirst:jlast,km)
    real pmax, pmin, fac
    integer i, j, k
#ifdef use_shared_pointers
    pointer( p_tmp, tmp )
    call fv_stack_push( p_tmp, im*km*(jlast-jfirst+1) )
#endif
    call fv_array_check( LOC(a) )

!$omp parallel do private(i, j, k)
!balaji: note, parallelizing j not k... km may be 1.
    do k=1, km
       do j=jsp,jep
          do i=1, im
             tmp(i,j,k)=a(i,j,k)
          enddo
       enddo
    enddo
    call fv_array_sync()

    call pmaxmin(qname, tmp, pmin, pmax, im*(jlast-jfirst+1),km, fac)

  end subroutine pmaxming


! Routine for debug domain decomposed data

  subroutine prt_maxmin_local(gid, qname, q, im, jm, km, j1, j2)

    implicit none
    character*(*)  qname
    integer im, jm, km, j1, j2, gid
    real q(im,j1:j2,km)
    integer i,j,k,jp
    real qmax, qmin

    jp = max(1,j1)

    qmax = q(1,jp,1)
    qmin = qmax

    do k=1,km
       do j=max(2,j1), min(jm-1,j2)
          do i=1,im
             qmax = max(qmax, q(i,j,k))
             qmin = min(qmin, q(i,j,k))
          enddo
       enddo
    enddo
    write(*,*) 'GID=', gid, qname, ': Max=', qmax, ' Min=', qmin

  end subroutine prt_maxmin_local

end module pmaxmin_mod

module ocean_tpm_mod  !{
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> John P. Dunne
!</REVIEWER>
!
!<OVERVIEW>
! Ocean tracer package module
!</OVERVIEW>
!
!<DESCRIPTION>
!       Currently this module only works for the ocean model,
!       but it could be extended (or generalized) to work with other
!       models.
!
!       This module consists of eight subroutines, three are called as
!       the model is intialized, four are called every time-step, and
!       one is called at model ending. The subroutines are called in
!       the following order.
!
!       These routines are called once at model startup in the
!       ocean_tracer_init routine:
!
!       ocean_tpm_init: This routine saves pointers to "global" model
!               structures, such as Grid and Domain. Also this
!               routine will call specified routines to set default
!               values for each tracer for such things as advection
!               scheme, tracer name, etc.
!               
!       ocean_tpm_flux_init: this routine initalizes field elements
!               relating to the ocean-atmosphere gas fluxes
!
!       ocean_tpm_start: This routine calls specified routines to
!               allocate appropriate storage for the tracer packages,
!               perform pre-processing and initialization (possibly
!               from extra restart information) and set parameters,
!               either via namelist or via the field manager.
!
!       These routines are called each time-step from
!       update_ocean_tracer (one before integration and one after):
!
!       ocean_tpm_sbc: Calls specified routines to handle surface
!               coundary condition calculations. Some or all of
!               this functionality may be moved into a new, generalized
!               boundary condition manager.
!
!       ocean_tpm_bbc: Calls specified routines to handle bottom
!               coundary condition calculations.
!
!       ocean_tpm_source: Calls specified routines to calculate the
!               source array for each tracer in the tracer packages.
!
!       ocean_tpm_tracer: For those packages which need to do
!               post-processing after the continuity equation has
!               been integrated, calls may be placed here. This
!               could be for global, annual means, for instance.
!
!       This routine is called once at the end of the run from
!       ocean_tracer_end:
!
!       ocean_tpm_end: Call routines to finish up any loose ends, such
!               as saving extra restart fields.
!
!       The following routines are called in relation to tying in to
!               the FMS coupler to calculate fluxes for the additional
!               tracers:
!
!       ocean_tpm_init_sfc: Allocate arrays for the accumulation of
!               data to be used by the coupler
!
!       ocean_tpm_sum_sfc: Accumulate data for the coupler
!
!       ocean_tpm_avg_sfc: Take the time-mean of the fields for the coupler
!
!       ocean_tpm_zero_sfc: Zero out the fields for the coupler to allow
!               for accumulation for the next time period
!
!       ocean_tpm_sfc_end: Save out fields for the restart.
!
!</DESCRIPTION>
!
! <INFO>
! </INFO>
!

use mpp_mod,            only: stdout, mpp_error, FATAL
use mpp_domains_mod,    only: mpp_get_compute_domain
use ocean_types_mod,    only: ocean_thickness_type, ocean_public_type
use ocean_types_mod,    only: ocean_options_type
use ocean_types_mod,    only: ocean_time_type, ocean_time_steps_type
use ocean_types_mod,    only: ocean_grid_type, ocean_domain_type
use ocean_types_mod,    only: ocean_prog_tracer_type, ocean_diag_tracer_type
use ocean_types_mod,    only: ocean_density_type
use ocean_types_mod,    only: ocean_velocity_type

!
!       Place tracer modules here
!

use ocean_age_tracer_mod, only: do_ocean_age_tracer
use ocean_age_tracer_mod, only: ocean_age_tracer_init
use ocean_age_tracer_mod, only: ocean_age_tracer_source
use ocean_age_tracer_mod, only: ocean_age_tracer_start
use ocean_age_tracer_mod, only: ocean_age_tracer_tracer

use ocean_residency_mod, only: do_ocean_residency
use ocean_residency_mod, only: ocean_residency_init
use ocean_residency_mod, only: ocean_residency_source
use ocean_residency_mod, only: ocean_residency_start
use ocean_residency_mod, only: ocean_residency_tracer

#ifdef USE_OCEAN_BGC 
use ocean_pert_co2_mod, only: do_ocean_pert_co2
use ocean_pert_co2_mod, only: ocean_pert_co2_avg_sfc
use ocean_pert_co2_mod, only: ocean_pert_co2_end
use ocean_pert_co2_mod, only: ocean_pert_co2_flux_init
use ocean_pert_co2_mod, only: ocean_pert_co2_init
use ocean_pert_co2_mod, only: ocean_pert_co2_init_sfc
use ocean_pert_co2_mod, only: ocean_pert_co2_sbc
use ocean_pert_co2_mod, only: ocean_pert_co2_source
use ocean_pert_co2_mod, only: ocean_pert_co2_sum_sfc
use ocean_pert_co2_mod, only: ocean_pert_co2_start
use ocean_pert_co2_mod, only: ocean_pert_co2_zero_sfc

use ocmip2_abiotic_mod, only: do_ocmip2_abiotic
use ocmip2_abiotic_mod, only: ocmip2_abiotic_avg_sfc
use ocmip2_abiotic_mod, only: ocmip2_abiotic_end
use ocmip2_abiotic_mod, only: ocmip2_abiotic_flux_init
use ocmip2_abiotic_mod, only: ocmip2_abiotic_init
use ocmip2_abiotic_mod, only: ocmip2_abiotic_init_sfc
use ocmip2_abiotic_mod, only: ocmip2_abiotic_sbc
use ocmip2_abiotic_mod, only: ocmip2_abiotic_sfc_end
use ocmip2_abiotic_mod, only: ocmip2_abiotic_source
use ocmip2_abiotic_mod, only: ocmip2_abiotic_sum_sfc
use ocmip2_abiotic_mod, only: ocmip2_abiotic_start
use ocmip2_abiotic_mod, only: ocmip2_abiotic_zero_sfc
use ocmip2_abiotic_mod, only: ocmip2_abiotic_restart
use ocmip2_abiotic_mod, only: ocmip2_abiotic_tracer

use ocmip2_cfc_mod, only: do_ocmip2_cfc
use ocmip2_cfc_mod, only: ocmip2_cfc_avg_sfc
use ocmip2_cfc_mod, only: ocmip2_cfc_end
use ocmip2_cfc_mod, only: ocmip2_cfc_flux_init
use ocmip2_cfc_mod, only: ocmip2_cfc_init
use ocmip2_cfc_mod, only: ocmip2_cfc_init_sfc
use ocmip2_cfc_mod, only: ocmip2_cfc_sbc
use ocmip2_cfc_mod, only: ocmip2_cfc_sfc_end
use ocmip2_cfc_mod, only: ocmip2_cfc_start
use ocmip2_cfc_mod, only: ocmip2_cfc_sum_sfc
use ocmip2_cfc_mod, only: ocmip2_cfc_zero_sfc

use ocmip2_biotic_mod, only: do_ocmip2_biotic
use ocmip2_biotic_mod, only: ocmip2_biotic_avg_sfc
use ocmip2_biotic_mod, only: ocmip2_biotic_bbc
use ocmip2_biotic_mod, only: ocmip2_biotic_end
use ocmip2_biotic_mod, only: ocmip2_biotic_flux_init
use ocmip2_biotic_mod, only: ocmip2_biotic_init
use ocmip2_biotic_mod, only: ocmip2_biotic_init_sfc
use ocmip2_biotic_mod, only: ocmip2_biotic_sbc
use ocmip2_biotic_mod, only: ocmip2_biotic_sfc_end
use ocmip2_biotic_mod, only: ocmip2_biotic_source
use ocmip2_biotic_mod, only: ocmip2_biotic_sum_sfc
use ocmip2_biotic_mod, only: ocmip2_biotic_start
use ocmip2_biotic_mod, only: ocmip2_biotic_zero_sfc
use ocmip2_biotic_mod, only: ocmip2_biotic_restart

use ocean_bgc_restore_mod, only: do_ocean_bgc_restore
use ocean_bgc_restore_mod, only: ocean_bgc_restore_avg_sfc
use ocean_bgc_restore_mod, only: ocean_bgc_restore_bbc
use ocean_bgc_restore_mod, only: ocean_bgc_restore_end
use ocean_bgc_restore_mod, only: ocean_bgc_restore_flux_init
use ocean_bgc_restore_mod, only: ocean_bgc_restore_init
use ocean_bgc_restore_mod, only: ocean_bgc_restore_init_sfc
use ocean_bgc_restore_mod, only: ocean_bgc_restore_sbc
use ocean_bgc_restore_mod, only: ocean_bgc_restore_sfc_end
use ocean_bgc_restore_mod, only: ocean_bgc_restore_source
use ocean_bgc_restore_mod, only: ocean_bgc_restore_sum_sfc
use ocean_bgc_restore_mod, only: ocean_bgc_restore_start
use ocean_bgc_restore_mod, only: ocean_bgc_restore_zero_sfc
use ocean_bgc_restore_mod, only: ocean_bgc_restore_restart

use ocmip2_he_mod, only: do_ocmip2_he
use ocmip2_he_mod, only: ocmip2_he_avg_sfc
use ocmip2_he_mod, only: ocmip2_he_end
use ocmip2_he_mod, only: ocmip2_he_flux_init
use ocmip2_he_mod, only: ocmip2_he_init
use ocmip2_he_mod, only: ocmip2_he_init_sfc
use ocmip2_he_mod, only: ocmip2_he_sbc
use ocmip2_he_mod, only: ocmip2_he_source
use ocmip2_he_mod, only: ocmip2_he_start
use ocmip2_he_mod, only: ocmip2_he_sum_sfc
use ocmip2_he_mod, only: ocmip2_he_zero_sfc
use ocmip2_he_mod, only: ocmip2_he_restart

use ocean_po4_pre_mod, only: do_ocean_po4_pre
use ocean_po4_pre_mod, only: ocean_po4_pre_end
use ocean_po4_pre_mod, only: ocean_po4_pre_init
use ocean_po4_pre_mod, only: ocean_po4_pre_start
use ocean_po4_pre_mod, only: ocean_po4_pre_tracer
use ocean_po4_pre_mod, only: ocean_po4_pre_zero_sfc

use ocean_ibgc_mod, only: do_ocean_ibgc
use ocean_ibgc_mod, only: ocean_ibgc_avg_sfc
use ocean_ibgc_mod, only: ocean_ibgc_bbc
use ocean_ibgc_mod, only: ocean_ibgc_end
use ocean_ibgc_mod, only: ocean_ibgc_flux_init
use ocean_ibgc_mod, only: ocean_ibgc_init
use ocean_ibgc_mod, only: ocean_ibgc_init_sfc
use ocean_ibgc_mod, only: ocean_ibgc_sbc
use ocean_ibgc_mod, only: ocean_ibgc_sfc_end
use ocean_ibgc_mod, only: ocean_ibgc_source
use ocean_ibgc_mod, only: ocean_ibgc_sum_sfc
use ocean_ibgc_mod, only: ocean_ibgc_start
use ocean_ibgc_mod, only: ocean_ibgc_tracer
use ocean_ibgc_mod, only: ocean_ibgc_zero_sfc
use ocean_ibgc_mod, only: ocean_ibgc_restart

use ocean_generic_mod, only: do_generic_tracer
use ocean_generic_mod, only: ocean_generic_sum_sfc
use ocean_generic_mod, only: ocean_generic_zero_sfc
use ocean_generic_mod, only: ocean_generic_sbc
use ocean_generic_mod, only: ocean_generic_init
use ocean_generic_mod, only: ocean_generic_column_physics
use ocean_generic_mod, only: ocean_generic_end
use ocean_generic_mod, only: ocean_generic_flux_init
#endif

use ocean_frazil_mod,     only: ocean_frazil_init
use ocean_tempsalt_mod,   only: ocean_tempsalt_init
!use ocean_tempsalt_mod,   only: ocean_fafmip_heat_init
use ocean_passive_mod,    only: ocean_passive_init

use transport_matrix_mod, only: do_transport_matrix
use transport_matrix_mod, only: transport_matrix_init
use transport_matrix_mod, only: transport_matrix_start
use transport_matrix_mod, only: transport_matrix_store_implicit

#if defined(CSIRO_BGC)
use csiro_bgc_mod 
#endif

!
!       force all variables to be "typed"
!

implicit none

!
!       Set all variables to be private by default

private

!
!       Private routines
!

private do_time_calc

!
!       Public routines
!

public ocean_tpm_bbc
public ocean_tpm_end
public ocean_tpm_init
public ocean_tpm_flux_init
public ocean_tpm_sbc
public ocean_tpm_source
public ocean_tpm_start
public ocean_tpm_tracer
public ocean_tpm_init_sfc
public ocean_tpm_sum_sfc
public ocean_tpm_avg_sfc
public ocean_tpm_zero_sfc
public ocean_tpm_sfc_end

!
!       private parameters
!

character(len=48), parameter                    :: mod_name = 'ocean_tpm_mod'

!
!       Public variables
!
!
!       Private variables
!

character(len=128) :: version = '$Id: ocean_tpm.F90,v 20.0 2013/12/14 00:17:16 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

integer :: imonth
integer :: iyear
logical :: end_of_day
logical :: end_of_month
logical :: end_of_year
logical :: mid_month

contains

!#######################################################################
! <SUBROUTINE NAME="do_time_calc">
!
! <DESCRIPTION>
!       call subroutines to perform time calculations
! </DESCRIPTION>
!

subroutine do_time_calc(time, dtts)  !{

!
!-----------------------------------------------------------------------
!
!       Modules
!
!-----------------------------------------------------------------------
!

use time_manager_mod, only: time_type, set_time, get_time
use time_manager_mod, only: set_date, get_date, days_in_month, operator(+)
use time_manager_mod, only: operator(<=), operator(==)
use time_manager_mod, only: operator(*), operator(/), operator(-)

implicit none

!
!-----------------------------------------------------------------------
!     Arguments
!-----------------------------------------------------------------------
!

type(ocean_time_type), intent(in)       :: time
real, intent(in)                        :: dtts

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

!
!-----------------------------------------------------------------------
!       Local variables
!-----------------------------------------------------------------------
!

integer         :: length
type(time_type) :: target_time
type(time_type) :: temp_time
type(time_type) :: dt_time
integer         :: isec
integer         :: iday
real            :: dayint
integer         :: days
integer         :: months
integer         :: years
integer         :: hours
integer         :: minutes
integer         :: seconds
integer, save   :: time_tau = -1000
integer         :: isec2
integer         :: iday2
real            :: daymodel

!
!-----------------------------------------------------------------------
!       Return if this routine has already been called this time-step
!-----------------------------------------------------------------------
!

if (time_tau .eq. time%tau) then  !{
  return
endif  !}

!
!-----------------------------------------------------------------------
!       Set up some things
!-----------------------------------------------------------------------
!
! Check that old ifdef is not accidently defined
#ifdef USE_OCEAN_OCMIP2 
  call mpp_error(FATAL, &
  '==>Error in ocean_tmp_mod: cpp option USE_OCEAN_OCMIP2 is now called USE_OCEAN_BGC. Please recompile...sorry.')
#endif


time_tau = time%tau

dt_time = set_time (seconds=int(dtts), days=0)

call get_date (time%model_time, years, months, days,            &
               hours, minutes, seconds)

!
!-----------------------------------------------------------------------
!     is it within 1/2 time step of the end of a day ?
!-----------------------------------------------------------------------
!

end_of_day = set_switch (1.0, time%model_time, dt_time)

!
!-----------------------------------------------------------------------
!     is it within 1/2 time step of the middle of a month ?
!-----------------------------------------------------------------------
!

length = days_in_month(time%model_time)
temp_time = set_time(0, length)/2
target_time = set_date(years, months, 1) + temp_time
call get_time (target_time, isec, iday)
dayint = iday + isec/86400.0
mid_month = set_switch (dayint, time%model_time, dt_time)

!
!-----------------------------------------------------------------------
!     is it within 1/2 time step of the end of the month ?
!-----------------------------------------------------------------------
!

length = days_in_month(time%model_time)
target_time = set_date(years, months, 1) + set_time(0, length)
call get_time (target_time, isec, iday)
dayint = iday + isec/86400.
if (days .eq. 1 .and. hours .eq. 0 .and. minutes .eq. 0 .and.   &
    seconds .eq. 0) dayint = dayint - length
call get_time (time%model_time, isec2, iday2)
daymodel = iday2 + isec2/86400.
end_of_month = set_switch (dayint, time%model_time, dt_time)

!
!       if this is the end of month, make sure that the month and
!       year pointers point to the month/year just completed, and not
!       possibly to the next month/year. This is important for indexing
!       purposes
!

if (end_of_month) then  !{

!
!       check whether we think we're in the next month and if so,
!       decrement the month and possibly year
!

  if (days .lt. 15) then  !{

!
!       if we're in the next month then we need to handle "January"
!       differently (namely go back to December of the previous year)
!

    if (months .eq. 1) then  !{

      imonth = 12
      iyear = years - 1

    else  !}{

!
!       otherwise just decrement the month
!

      imonth = months - 1
      iyear = years

    endif  !}

  else  !}{

!
!       we're think that we are at the end of the just-processed month
!       so no modifications need be done
!

    imonth = months
    iyear = years

  endif  !}

else  !}{

!
!       not end of month case, so just save the month
!

  imonth = months
  iyear = years

endif  !}

!
!       set a correct end of year indicator
!

end_of_year = end_of_month .and. imonth .eq. 12

return

contains

function set_switch (switch_interval, time_since, dt_time)  !{

implicit none

!
!       Function definition
!

logical                 :: set_switch

!
!----------------------------------------------------------------------
!       Arguments
!----------------------------------------------------------------------
!

real, intent(in)                :: switch_interval      ! in units of days
type(time_type), intent(in)     :: time_since
type(time_type), intent(in)     :: dt_time

!
!       local variables
!

type(time_type)         :: interval_time
type(time_type)         :: current_time
type(time_type)         :: next_time
type(time_type)         :: half_dt_time
integer                 :: n
integer                 :: seconds
integer                 :: days

if (switch_interval < 0) then
  set_switch = .false.
  return
endif

days           = int(switch_interval)
seconds        = int((switch_interval - days)*86400)
interval_time  = set_time (seconds, days)

if (interval_time <= dt_time) then
  set_switch = .true.
else
  half_dt_time = dt_time / 2
  n            = (time_since + half_dt_time) / interval_time
  current_time = time_since - n * interval_time
  if (current_time  <= half_dt_time) then
    next_time = (time_since + dt_time) - n * interval_time
    if (current_time == next_time) then
      set_switch = .false.
    else
      set_switch = .true.
    endif
  else
    set_switch = .false.
  endif
endif

end function  set_switch  !}

end subroutine do_time_calc  !}
! </SUBROUTINE> NAME="do_time_calc"


!#######################################################################
! <SUBROUTINE NAME="ocean_tpm_bbc">
!
! <DESCRIPTION>
!       call subroutines to perform bottom boundary condition
!       calculations
! </DESCRIPTION>

subroutine ocean_tpm_bbc(Domain, Grid, T_prog, Time)  !{

!
!-----------------------------------------------------------------------
!     Arguments
!-----------------------------------------------------------------------
!

type(ocean_domain_type), intent(in)                             :: Domain
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
type(ocean_time_type), intent(in), optional                     :: Time

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

!
!       set some indices and flags dependent on time
!


#ifdef USE_OCEAN_BGC 

if (do_ocmip2_biotic) then  !{
  call ocmip2_biotic_bbc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,        &
                         Domain%isd, Domain%ied, Domain%jsd, Domain%jed, T_prog, Grid%kmt)
endif  !}

if (do_ocean_bgc_restore) then  !{
  call ocean_bgc_restore_bbc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,    &
                             Domain%isd, Domain%ied, Domain%jsd, Domain%jed, T_prog, Grid%kmt)
endif  !}

#endif

#if defined(CSIRO_BGC)
if (do_csiro_bgc) then  !{
  call csiro_bgc_bbc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, T_prog, Grid, Time)
endif  !}
#endif

return

end subroutine ocean_tpm_bbc  !}
! </SUBROUTINE> NAME="ocean_tpm_bbc"


!#######################################################################
! <SUBROUTINE NAME="ocean_tpm_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocean_tpm_restart(time_stamp)
  character(len=*),           intent(in), optional :: time_stamp

#ifdef USE_OCEAN_BGC 

if (do_ocmip2_abiotic) call ocmip2_abiotic_restart(time_stamp)
if (do_ocmip2_biotic) call ocmip2_biotic_restart(time_stamp)
if (do_ocmip2_he) call ocmip2_he_restart(time_stamp)
if (do_ocean_bgc_restore) call ocean_bgc_restore_restart(time_stamp)
if (do_ocean_ibgc) call ocean_ibgc_restart(time_stamp)

#endif

end subroutine ocean_tpm_restart
! </SUBROUTINE> NAME="ocean_tpm_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_tpm_end">
!
! <DESCRIPTION>
!       Finish up calculations for the tracer packages,
!       possibly writing out non-field restart information
! </DESCRIPTION>
!

subroutine ocean_tpm_end(Domain, Grid, T_prog, T_diag, Time, Thickness)  !{

implicit none

!
!-----------------------------------------------------------------------
!     Arguments
!-----------------------------------------------------------------------
!

type(ocean_domain_type), intent(in)                     :: Domain
type(ocean_grid_type), intent(in)                       :: Grid
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
type(ocean_diag_tracer_type), dimension(:), intent(in)  :: T_diag
type(ocean_time_type), intent(in)                       :: Time
type(ocean_thickness_type), intent(in)                  :: Thickness

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

!
!       call subroutines to finish up the run
!

#ifdef USE_OCEAN_BGC 

if (do_ocmip2_cfc) then  !{
  call ocmip2_cfc_end(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,  &
                      Domain%isd, Domain%jsd,            &
                      T_prog, Grid%dat, Grid%tmask,                             &
                      Thickness%rho_dzt, Time%taup1)
endif  !}

if (do_ocean_pert_co2) then  !{
  call ocean_pert_co2_end(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,      &
                          Domain%isd, Domain%ied, Domain%jsd, Domain%jed,               &
                          T_prog, grid%dat, grid%tmask, Domain%domain2d,                &
                          Thickness%rho_dzt, Time%taup1)
endif  !}

if (do_ocmip2_abiotic) then  !{
  call ocmip2_abiotic_end(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,      &
                          Domain%isd, Domain%ied, Domain%jsd, Domain%jed,               &
                          T_prog, Grid%dat, Grid%tmask, Domain%domain2d,                &
                          Thickness%rho_dzt, Time%taup1)
endif  !}

if (do_ocmip2_biotic) then  !{
  call ocmip2_biotic_end(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,       &
                         Domain%isd, Domain%ied, Domain%jsd, Domain%jed,                &
                         T_prog, Grid%dat, Grid%tmask, Domain%domain2d,                 &
                         Thickness%rho_dzt, Time%taup1)
endif  !}

if (do_ocean_bgc_restore) then  !{
  call ocean_bgc_restore_end(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,   &
                           Domain%isd, Domain%ied, Domain%jsd, Domain%jed,              &
                           T_prog, T_diag, Grid%dat, Grid%tmask, Domain%domain2d,       &
                           Thickness%rho_dzt, Time%taup1)
endif  !}

if (do_ocmip2_he) then  !{
  call ocmip2_he_end(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,  &
                     Domain%isd, Domain%ied, Domain%jsd, Domain%jed,           &
                     T_prog, grid%dat, grid%tmask,                             &
                     Thickness%rho_dzt, Time%taup1)
endif  !}

if (do_ocean_po4_pre) then  !{
  call ocean_po4_pre_end(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk, &
                     Domain%isd, Domain%jsd,               &
                     T_prog, Grid%dat, Grid%tmask, Thickness%rho_dzt, Time%taup1)
endif  !}

if (do_ocean_ibgc) then  !{
  call ocean_ibgc_end()
endif  !}

if (do_generic_tracer) call ocean_generic_end

#endif 

#if defined(CSIRO_BGC)
if (do_csiro_bgc) then  !{
  call csiro_bgc_end(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Time%taup1,          &
                           Thickness, T_prog, Grid)
endif  !}
#endif

return

end subroutine ocean_tpm_end  !}
! </SUBROUTINE> NAME="ocean_tpm_end"


!#######################################################################
! <SUBROUTINE NAME="ocean_tpm_init_sfc">
!
! <DESCRIPTION>
!       call subroutines to perform surface coupler initializations
!
!       Note: this subroutine should be merged into ocean_tpm_start
! </DESCRIPTION>
!

subroutine ocean_tpm_init_sfc(Domain, T_prog, Dens, Ocean, Time, Grid)  !{

implicit none

!
!-----------------------------------------------------------------------
!     Arguments
!-----------------------------------------------------------------------
!

type(ocean_domain_type), intent(in)                     :: Domain
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
type(ocean_density_type), intent(in)                    :: Dens
type(ocean_public_type), intent(inout)                  :: Ocean
type(ocean_time_type), intent(in)                       :: Time
type(ocean_grid_type), intent(in)                       :: Grid

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

!
!-----------------------------------------------------------------------
!       Local variables
!-----------------------------------------------------------------------
!

logical, save   :: initialized = .false.
integer         :: isc_bnd
integer         :: iec_bnd
integer         :: jsc_bnd
integer         :: jec_bnd

if (.not. initialized) then  !{

  call mpp_get_compute_domain(Ocean%Domain, isc_bnd, iec_bnd, jsc_bnd, jec_bnd)

#ifdef USE_OCEAN_BGC 

  if (do_ocmip2_cfc) then  !{
    call ocmip2_cfc_init_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,            &
                             Domain%isd, Domain%jsd,                     &
                             isc_bnd, jsc_bnd,                                 &
                             Ocean%fields, T_prog, Dens%rho, Time%taum1,                        &
                             Grid%tmask)
  endif  !}

  if (do_ocean_pert_co2) then  !{
    call ocean_pert_co2_init_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,        &
                                 Domain%isd, Domain%ied, Domain%jsd, Domain%jed,                &
                                 isc_bnd, jsc_bnd,                             &
                                 Ocean%fields, T_prog, Dens%rho, Time%taum1, &
                                 Grid%tmask)
  endif  !}

  if (do_ocmip2_abiotic) then  !{
    call ocmip2_abiotic_init_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,       &
                                 Domain%isd, Domain%ied, Domain%jsd, Domain%jed,                &
                                 isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                            &
                                 Ocean%fields, T_prog, Dens%rho, Time%taum1, Time%model_time,   &
                                 Grid%tmask)
  endif  !}

  if (do_ocmip2_biotic) then  !{
    call ocmip2_biotic_init_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,        &
                                Domain%isd, Domain%ied, Domain%jsd, Domain%jed,                 &
                                isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                             &
                                Ocean%fields, T_prog, Dens%rho, Time%taum1, Time%model_time,    &
                                Grid%tmask)
  endif  !}

  if (do_ocean_bgc_restore) then  !{
    call ocean_bgc_restore_init_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,    &
                                    Domain%isd, Domain%ied, Domain%jsd, Domain%jed,             &
                                    isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                         &
                                    Ocean%fields, T_prog, Dens%rho, Time%taum1, Time%model_time,&
                                    Grid%tmask)
  endif  !}

  if (do_generic_tracer) call ocean_generic_sum_sfc(Domain%isd,Domain%jsd, Ocean, T_prog, Dens, Time )

  if (do_ocmip2_he) then  !{
    call ocmip2_he_init_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,   &
                            Domain%isd, Domain%ied, Domain%jsd, Domain%jed,            &
                            isc_bnd, jsc_bnd,                        &
                            Ocean%fields, T_prog, Dens%rho, Time%taum1, Grid%tmask)
  endif  !}
  
  if (do_ocean_ibgc) then  !{
    call ocean_ibgc_init_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,      &
                              Domain%isd, Domain%ied, Domain%jsd, Domain%jed,                   &
                              isc_bnd, jsc_bnd,                                &
                              Ocean%fields, T_prog, Dens%rho, Time%taum1, Time%model_time,      &
                              Grid%tmask)
  endif  !}

#endif 


  initialized = .true.

endif  !}

return

end subroutine ocean_tpm_init_sfc  !}
! </SUBROUTINE> NAME="ocean_tpm_init_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_tpm_sum_sfc">
!
! <DESCRIPTION>
!       call subroutines to perform surface coupler initializations
! </DESCRIPTION>
!

subroutine ocean_tpm_sum_sfc(Domain, T_prog, Dens, Ocean, Time, Grid, isc_bnd, iec_bnd, jsc_bnd, jec_bnd)  !{

implicit none

!
!-----------------------------------------------------------------------
!     Arguments
!-----------------------------------------------------------------------
!

type(ocean_domain_type), intent(in)                     :: Domain
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
type(ocean_density_type), intent(in)                    :: Dens
type(ocean_public_type), intent(inout)                  :: Ocean
type(ocean_time_type), intent(in)                       :: Time
type(ocean_grid_type), intent(in)                       :: Grid
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: iec_bnd
integer, intent(in)                                     :: jsc_bnd
integer, intent(in)                                     :: jec_bnd

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

!
!-----------------------------------------------------------------------
!       Local variables
!-----------------------------------------------------------------------
!

#ifdef USE_OCEAN_BGC 

if (do_ocmip2_cfc) then  !{
  call ocmip2_cfc_sum_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,             &
                          Domain%isd, Domain%jsd,                      &
                          isc_bnd, jsc_bnd,                                  &
                          Ocean%fields, T_prog, Dens%rho, Time%taum1,        &
                          Grid%tmask, Grid, Time)
endif  !}

if (do_ocean_pert_co2) then  !{
  call ocean_pert_co2_sum_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,           &
                              Domain%isd, Domain%ied, Domain%jsd, Domain%jed,                   &
                              isc_bnd, jsc_bnd,                                &
                              Ocean%fields, T_prog, Dens%rho, Time%taum1,      &
                              Grid%tmask)
endif  !}

if (do_ocmip2_abiotic) then  !{
  call ocmip2_abiotic_sum_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,        &
                              Domain%isd, Domain%ied, Domain%jsd, Domain%jed,                 &
                              isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                             &
                              Ocean%fields, T_prog, Dens%rho, Time%taum1, Time%model_time,    &
                              Grid%tmask)
endif  !}

if (do_ocmip2_biotic) then  !{
  call ocmip2_biotic_sum_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,         &
                             Domain%isd, Domain%ied, Domain%jsd, Domain%jed,                  &
                             isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                              &
                             Ocean%fields, T_prog, Dens%rho, Time%taum1, Time%model_time,     &
                             Grid%tmask)
endif  !}

if (do_ocean_bgc_restore) then  !{
  call ocean_bgc_restore_sum_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,     &
                                 Domain%isd, Domain%ied, Domain%jsd, Domain%jed,              &
                                 isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                          &
                                 Ocean%fields, T_prog, Dens%rho, Time%taum1, Time%model_time, &
                                 Grid%tmask)
endif  !}

if (do_generic_tracer) then
   call ocean_generic_sum_sfc(Domain%isd,Domain%jsd, Ocean, T_prog, Dens, Time )
endif

if (do_ocmip2_he) then  !{
  call ocmip2_he_sum_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,             &
                          Domain%isd, Domain%ied, Domain%jsd, Domain%jed,                     &
                          isc_bnd, jsc_bnd,                                  &
                          Ocean%fields, T_prog, Dens%rho, Time%taum1,         &
                          Grid%tmask, Grid, Time)
endif  !}

if (do_ocean_ibgc) then  !{
  call ocean_ibgc_sum_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,       &
                             Domain%isd, Domain%ied, Domain%jsd, Domain%jed,                  &
                             isc_bnd, jsc_bnd,                               &
                             Ocean%fields, T_prog, Dens%rho, Time%taum1, Time%model_time,     &
                             Grid%tmask)
endif  !}


#endif 

return

end subroutine ocean_tpm_sum_sfc  !}
! </SUBROUTINE> NAME="ocean_tpm_sum_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_tpm_avg_sfc">
!
! <DESCRIPTION>
!       call subroutines to perform surface coupler initializations
! </DESCRIPTION>
!

subroutine ocean_tpm_avg_sfc(Domain, Ocean, Grid, isc_bnd, iec_bnd, jsc_bnd, jec_bnd)  !{

implicit none

!
!-----------------------------------------------------------------------
!     Arguments
!-----------------------------------------------------------------------
!

type(ocean_domain_type), intent(in)     :: Domain
type(ocean_public_type), intent(inout)  :: Ocean
type(ocean_grid_type), intent(in)       :: Grid
integer, intent(in)                     :: isc_bnd
integer, intent(in)                     :: iec_bnd
integer, intent(in)                     :: jsc_bnd
integer, intent(in)                     :: jec_bnd

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

!
!-----------------------------------------------------------------------
!       Local variables
!-----------------------------------------------------------------------
!

#ifdef USE_OCEAN_BGC 

if (do_ocmip2_cfc) then  !{
  call ocmip2_cfc_avg_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,         &
                          Domain%isd, Domain%jsd,                 &
                          isc_bnd, jsc_bnd,                              &
                          Ocean%fields, Ocean%avg_kount, Grid%tmask)
endif  !}

if (do_ocean_pert_co2) then  !{
  call ocean_pert_co2_avg_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, &
                              Domain%isd, Domain%jsd,           &
                              isc_bnd, jsc_bnd,                       &
                              Ocean%fields, Ocean%avg_kount, Grid%tmask)
endif  !}

if (do_ocmip2_abiotic) then  !{
  call ocmip2_abiotic_avg_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,    &
                              Domain%isd, Domain%ied, Domain%jsd, Domain%jed,             &
                              isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                         &
                              Ocean%fields, Ocean%avg_kount, Grid%tmask)
endif  !}

if (do_ocmip2_biotic) then  !{
  call ocmip2_biotic_avg_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,     &
                             Domain%isd, Domain%ied, Domain%jsd, Domain%jed,              &
                             isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                          &
                             Ocean%fields, Ocean%avg_kount, Grid%tmask)
endif  !}

if (do_ocean_bgc_restore) then  !{
  call ocean_bgc_restore_avg_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk, &
                                 Domain%isd, Domain%ied, Domain%jsd, Domain%jed,          &
                                 isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                      &
                                 Ocean%fields, Ocean%avg_kount, Grid%tmask)
endif  !}

if (do_ocmip2_he) then  !{
  call ocmip2_he_avg_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,         &
                          Domain%isd, Domain%ied, Domain%jsd, Domain%jed,                 &
                          isc_bnd, jsc_bnd,                              &
                          Ocean%fields, Ocean%avg_kount, Grid%tmask)
endif  !}

if (do_ocean_ibgc) then  !{
  call ocean_ibgc_avg_sfc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, &
                             Domain%isd, Domain%jsd,               &
                             isc_bnd, jsc_bnd,                           &
                             Ocean%fields, Ocean%avg_kount, Grid%tmask)
endif  !}


#endif 


return

end subroutine ocean_tpm_avg_sfc  !}
! </SUBROUTINE> NAME="ocean_tpm_avg_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_tpm_zero_sfc">
!
! <DESCRIPTION>
!       call subroutines to perform surface coupler initializations
! </DESCRIPTION>
!

subroutine ocean_tpm_zero_sfc(Ocean)  !{

implicit none

!
!-----------------------------------------------------------------------
!     Arguments
!-----------------------------------------------------------------------
!

type(ocean_public_type), intent(inout)  :: Ocean

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!


#ifdef USE_OCEAN_BGC 

if (do_ocmip2_cfc) then  !{
  call ocmip2_cfc_zero_sfc(Ocean%fields)
endif  !}

if (do_ocmip2_he) then  !{
  call ocmip2_he_zero_sfc(Ocean%fields)
endif  !}

if (do_ocean_pert_co2) then  !{
  call ocean_pert_co2_zero_sfc(Ocean%fields)
endif  !}

if (do_ocmip2_abiotic) then  !{
  call ocmip2_abiotic_zero_sfc(Ocean%fields)
endif  !}

if (do_ocmip2_biotic) then  !{
  call ocmip2_biotic_zero_sfc(Ocean%fields)
endif  !}

if (do_ocean_bgc_restore) then  !{
  call ocean_bgc_restore_zero_sfc(Ocean%fields)
endif  !}

if (do_ocean_ibgc) then  !{
  call ocean_ibgc_zero_sfc(Ocean%fields)
endif  !}

if (do_generic_tracer) call ocean_generic_zero_sfc(Ocean%fields)

#endif 

return

end subroutine ocean_tpm_zero_sfc  !}
! </SUBROUTINE> NAME="ocean_tpm_zero_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_tpm_sfc_end">
!
! <DESCRIPTION>
!       call subroutines to perform surface coupler initializations
! </DESCRIPTION>
!

subroutine ocean_tpm_sfc_end !{

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!


#ifdef USE_OCEAN_BGC 

if (do_ocmip2_cfc) then  !{
  call ocmip2_cfc_sfc_end
endif  !}

if (do_ocmip2_abiotic) then  !{
  call ocmip2_abiotic_sfc_end
endif  !}

if (do_ocmip2_biotic) then  !{
  call ocmip2_biotic_sfc_end
endif  !}

if (do_ocean_bgc_restore) then  !{
  call ocean_bgc_restore_sfc_end
endif  !}

if (do_ocean_ibgc) then  !{
  call ocean_ibgc_sfc_end
endif  !}

#endif 


return

end subroutine ocean_tpm_sfc_end  !}
! </SUBROUTINE> NAME="ocean_tpm_sfc_end"


!#######################################################################
! <SUBROUTINE NAME="ocean_tpm_sbc">
!
! <DESCRIPTION>
!       call subroutines to perform surface boundary condition
!       calculations
! </DESCRIPTION>
!

subroutine ocean_tpm_sbc(Domain, Grid, T_prog, Time, Ice_ocean_boundary_fluxes, &
     runoff, isc_bnd, iec_bnd, jsc_bnd, jec_bnd, aice, wnd,            &
     use_waterflux, salt_restore_as_salt_flux, atm_co2, co2flux, ocn_co2)


use coupler_types_mod, only: coupler_2d_bc_type

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

type(ocean_domain_type), intent(in)                             :: Domain
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
type(ocean_time_type), intent(in)                               :: Time
type(coupler_2d_bc_type), intent(in)                            :: Ice_ocean_boundary_fluxes
integer, intent(in)                                             :: isc_bnd
integer, intent(in)                                             :: iec_bnd
integer, intent(in)                                             :: jsc_bnd
integer, intent(in)                                             :: jec_bnd
real, dimension(Domain%isd:,Domain%jsd:), intent(in)            :: runoff

! Optional arguments. Passed through for csiro BGC.

real, intent(in), dimension(Domain%isd:,Domain%jsd:), optional :: aice
real, intent(in), dimension(Domain%isd:,Domain%jsd:), optional :: atm_co2
real, intent(in), dimension(Domain%isd:,Domain%jsd:), optional :: wnd
logical, intent(in), optional                                  :: use_waterflux, salt_restore_as_salt_flux

real, intent(out), dimension(Domain%isd:,Domain%jsd:), optional :: co2flux, ocn_co2
!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

!
!-----------------------------------------------------------------------
!     local variables
!-----------------------------------------------------------------------
!


#ifdef USE_OCEAN_BGC 

if (do_ocmip2_cfc) then  !{
  call ocmip2_cfc_sbc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,           &
                      isc_bnd, jsc_bnd,                                &
                      T_prog, Grid, Time, Ice_ocean_boundary_fluxes)
endif  !}

if (do_ocean_pert_co2) then  !{
  call ocean_pert_co2_sbc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,       &
                          isc_bnd, jsc_bnd,                            &
                          T_prog, Grid, Time,                               &
                          Ice_ocean_boundary_fluxes)
endif  !}

if (do_ocmip2_abiotic) then  !{
  call ocmip2_abiotic_sbc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,      &
                          Domain%isd, Domain%ied, Domain%jsd, Domain%jed,               &
                          isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                           &
                          T_prog, Time%taum1,                                           &
                          Grid, Time, Ice_ocean_boundary_fluxes)
endif  !}

if (do_ocmip2_biotic) then  !{
  call ocmip2_biotic_sbc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,       &
                         Domain%isd, Domain%ied, Domain%jsd, Domain%jed,                &
                         isc_bnd, iec_bnd, jsc_bnd, jec_bnd,                            &
                         T_prog, Time%taum1,                                            &
                         Grid, Time, Ice_ocean_boundary_fluxes)
endif  !}

if (do_ocean_bgc_restore) then  !{
  call ocean_bgc_restore_sbc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,            &
                             Grid%nk, Domain%isd, Domain%ied, Domain%jsd,               &
                             Domain%jed, isc_bnd, iec_bnd, jsc_bnd, jec_bnd,            &
                             T_prog, Time%tau, Time,                                    &
                             Grid, Ice_ocean_boundary_fluxes)
endif  !}

if (do_generic_tracer) call ocean_generic_sbc(Ice_ocean_boundary_fluxes,Domain%isd,Domain%jsd, T_prog, runoff)
if (do_ocmip2_he) then  !{
  call ocmip2_he_sbc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,            &
                      isc_bnd, jsc_bnd,                                &
                      T_prog, Grid, Time, Ice_ocean_boundary_fluxes)
endif  !}

if (do_ocean_ibgc) then  !{
  call ocean_ibgc_sbc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, &
                           isc_bnd, jsc_bnd,                           &
                           T_prog,                                             &
                           Grid, Time, Ice_ocean_boundary_fluxes)
endif  !}

#endif 

#if defined(CSIRO_BGC)
if (do_csiro_bgc) then  !{
  call csiro_bgc_sbc(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Domain%isd, Domain%ied, Domain%jsd, Domain%jed,  &
  T_prog, aice, wnd, Grid, Time, use_waterflux, salt_restore_as_salt_flux, atm_co2, co2flux, ocn_co2)
endif  !}
#endif

return

end subroutine ocean_tpm_sbc  !}
! </SUBROUTINE> NAME="ocean_tpm_sbc"


!#######################################################################
! <SUBROUTINE NAME="ocean_tpm_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the tracer packages
!
!       Save pointers to various "types", such as Ocean, Grid and Domains.
! </DESCRIPTION>
!

subroutine ocean_tpm_init(Domain, Grid, Time, Time_steps, &
                          Ocean_options, debug)

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

  type(ocean_domain_type),     intent(in)     :: Domain
  type(ocean_grid_type),       intent(in)     :: Grid
  type(ocean_time_type),       intent(in)     :: Time
  type(ocean_time_steps_type), intent(in)     :: Time_steps
  type(ocean_options_type),    intent(inout)  :: Ocean_options
  logical, intent(in), optional               :: debug

integer :: index_temp=-1
integer :: index_salt=-1
integer :: index_redist_heat=-1

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!
!
!-----------------------------------------------------------------------
!       local variables
!-----------------------------------------------------------------------
!

!
!-----------------------------------------------------------------------
!       Check which tracer packages have been turned on
!-----------------------------------------------------------------------
!

!
!       Call subroutines to perform initialization operations
!

call ocean_tempsalt_init (Domain, Grid, Ocean_options, index_temp, index_salt, index_redist_heat, debug)  

call ocean_frazil_init (Domain, Grid, Time, Time_steps, Ocean_options, &
                        index_temp, index_salt, index_redist_heat, debug)  

call ocean_passive_init (Domain, Grid, Ocean_options, debug)  

call ocean_residency_init       ! must come first

call ocean_age_tracer_init

#ifdef USE_OCEAN_BGC 

call ocmip2_cfc_init

call ocmip2_he_init

call ocean_pert_co2_init

call ocmip2_abiotic_init

call ocmip2_biotic_init

call ocean_bgc_restore_init

call ocean_po4_pre_init

call ocean_ibgc_init

call ocean_generic_init(Domain,Grid,Time)

#endif 

#if defined(CSIRO_BGC)
call csiro_bgc_init
#endif 

call transport_matrix_init


return

end subroutine ocean_tpm_init  !}
! </SUBROUTINE> NAME="ocean_tpm_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_tpm_flux_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the ocean-atmosphere gas fluxes
! </DESCRIPTION>
!

subroutine ocean_tpm_flux_init  !{

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

!
!-----------------------------------------------------------------------
!       local variables
!-----------------------------------------------------------------------
!


!
!-----------------------------------------------------------------------
!       Initialize fields for the ocean-atmosphere gas fluxes
!-----------------------------------------------------------------------
!

!
!       These routines must always be called as this routine
!       is called from both atmosphere and oceanic processors to set
!       up fluxes. The variable being "fluxed" may only exist in the
!       ocean model (eg., O2), hence the need to have the calls not
!       have tests for whether the specific package is turned on--those
!       tests will always be false on atmospheric processors, even if
!       we're using that package on the oceanic processors.
!

#ifdef USE_OCEAN_BGC 

call ocmip2_cfc_flux_init

call ocmip2_he_flux_init

call ocean_pert_co2_flux_init

call ocmip2_abiotic_flux_init

call ocmip2_biotic_flux_init

call ocean_bgc_restore_flux_init

call ocean_ibgc_flux_init

call ocean_generic_flux_init

#endif 

return

end subroutine ocean_tpm_flux_init  !}
! </SUBROUTINE> NAME="ocean_tpm_flux_init"


!#######################################################################

! <SUBROUTINE NAME="ocean_tpm_source">
!
! <DESCRIPTION>
!       Calculate the source arrays for the tracer packages
! </DESCRIPTION>
!

subroutine ocean_tpm_source(isd, ied, jsd, jed, Domain, Grid, T_prog, T_diag,   &
     Time, Thickness, Dens, hblt_depth, dtts, swflx, sw_frac_zt)

implicit none

!
!-----------------------------------------------------------------------
!     Arguments
!-----------------------------------------------------------------------
!

integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
type(ocean_domain_type), intent(in)                             :: Domain
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
type(ocean_diag_tracer_type), dimension(:), intent(inout)       :: T_diag
type(ocean_time_type), intent(in)                               :: Time
type(ocean_thickness_type), intent(in)                          :: Thickness
type(ocean_density_type), intent(in)                            :: Dens
real, intent(in), dimension(isd:,jsd:)                          :: hblt_depth
real, intent(in)                                                :: dtts

! Optional input for csiro bgc
real, intent(in), dimension(isd:,jsd:), optional                :: swflx ! short wave radiation flux (W/m^2)
real, intent(in), dimension(isd:,jsd:,:), optional              :: sw_frac_zt ! short wave radiation fraction

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!


!
!       Call subroutines to determine the source array
!

if (do_ocean_age_tracer) then 
  call ocean_age_tracer_source(isd, ied, jsd, jed, Grid%nk,     &
                               Time%model_time, Grid%tmask, T_prog)
endif 

#ifdef USE_OCEAN_BGC 
if (do_ocean_pert_co2) then
  call ocean_pert_co2_source(Grid, Time)
endif 

if (do_ocmip2_abiotic) then
  call ocmip2_abiotic_source(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,   &
                             isd, ied, jsd, jed, T_prog,                                &
                             Time%taum1, Grid, Time,       &
                             Thickness%rho_dzt)
endif 

if (do_ocmip2_biotic) then
  call ocmip2_biotic_source(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,    &
                            isd, ied, jsd, jed, T_prog,                                 &
                            Time%taum1, Grid%zw, Grid%ht, Grid%tmask,  &
                            Grid, Time, Thickness%rho_dzt)
endif 

if (do_ocean_bgc_restore) then  !{
  call ocean_bgc_restore_source(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,&
                                isd, ied, jsd, jed, T_prog, T_diag,                     &
                                Time%taum1, Time%model_time, Grid, Time, Grid%kmt,      &
                                Thickness%rho_dzt, dtts)
endif  !}

if (do_ocean_ibgc) then  !{
  call ocean_ibgc_source(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,  &
                              isd, jsd, T_prog, T_diag,                       &
                              Time%taum1, Grid%tmask, Grid, Time, &
                              Grid%kmt, Thickness%depth_zt,Dens%rho, Thickness%rho_dzt, &
                              Thickness%dzt, hblt_depth, dtts)
endif  !}

if (do_ocmip2_he) then
  call ocmip2_he_source(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,               &
                        isd, ied, jsd, jed, T_prog, Thickness%depth_zt, Thickness%dzt,         &
                        Time%model_time, Grid%tmask, Grid, Time, Grid%kmt)
endif

#endif 

#if defined(CSIRO_BGC)
if (do_csiro_bgc) then
  call csiro_bgc_source(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, &
    Domain%isd, Domain%ied, Domain%jsd, Domain%jed,                   &
    T_prog, grid, Time, dtts, Thickness, Dens, swflx, sw_frac_zt)
endif
#endif

if (do_ocean_residency) then  !{        ! must come last
  call ocean_residency_source(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,           &
       isd, ied, jsd, jed, Grid%nk, T_prog, T_diag, Time, Thickness, Dens,              &
       grid%xt, grid%yt, grid%zw, grid%tmask, grid%kmt, hblt_depth)
endif  !}

return

end subroutine ocean_tpm_source 
! </SUBROUTINE> NAME="ocean_tpm_source"


!#######################################################################
! <SUBROUTINE NAME="ocean_tpm_start">
!
! <DESCRIPTION>
!       Start the tracer packages.
!       This could include reading in extra restart information,
!       processing namelists or doing initial calculations
! </DESCRIPTION>
!

subroutine ocean_tpm_start(Domain, Grid, T_prog, T_diag, Time, Thickness)  !{

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

type(ocean_domain_type), intent(in)                     :: Domain
type(ocean_grid_type), intent(in)                       :: Grid
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
type(ocean_diag_tracer_type), dimension(:), intent(in)  :: T_diag
type(ocean_time_type), intent(in)                       :: Time
type(ocean_thickness_type), intent(in)                  :: Thickness

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

!
!       call subroutines to start the tracer packages
!

if (do_ocean_residency) then  !{        ! must come first
  call ocean_residency_start(Domain%isd, Domain%ied, Domain%jsd, Domain%jed, Grid%nk,   &
                             Time%model_time, grid%tracer_axes)
endif  !}

if (do_ocean_age_tracer) then  !{
  call ocean_age_tracer_start(Domain%isd, Domain%ied, Domain%jsd, Domain%jed, T_prog,   &
                              Grid%xt, Grid%yt, Grid%kmt)
endif  !}

#ifdef USE_OCEAN_BGC 

if (do_ocmip2_cfc) then  !{
  call ocmip2_cfc_start(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,        &
                        Domain%isd, Domain%jsd,                  &
                        T_prog, Time%taup1, Time%model_time,                              &
                        Grid%dat, Grid%tmask, Grid%tracer_axes, Thickness%rho_dzt)
endif  !}

if (do_ocmip2_he) then  !{
  call ocmip2_he_start(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,        &
                       Domain%isd, Domain%ied, Domain%jsd, Domain%jed,                 &
                       T_prog, Time%taup1, Time%model_time,                            &
                       Grid%dat, Grid%tmask, Grid%tracer_axes, Domain%domain2d,        &
                       Thickness%rho_dzt)
endif  !}

if (do_ocean_pert_co2) then  !{
  call ocean_pert_co2_start(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,    &
                            Domain%isd, Domain%ied, Domain%jsd, Domain%jed,             &
                            T_prog, Time%taup1, Time%model_time,                          &
                            grid%dat, grid%tmask,                                       &
                            grid%tracer_axes,                          &
                            Thickness%rho_dzt)
endif  !}

if (do_ocmip2_abiotic) then  !{
  call ocmip2_abiotic_start(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,    &
                            Domain%isd, Domain%ied, Domain%jsd, Domain%jed,             &
                            T_prog, Time%taup1, Time%model_time,                          &
                            Grid%dat, Grid%tmask, Grid%kmt, Grid%xt, Grid%yt, Grid%zt,  &
                            Grid%zw, Grid%dzt,                                          &
                            Grid%tracer_axes, Domain%domain2d,                          &
                            Thickness%rho_dzt)
endif  !}

if (do_ocmip2_biotic) then  !{
  call ocmip2_biotic_start(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,     &
                           Domain%isd, Domain%ied, Domain%jsd, Domain%jed,              &
                           T_prog, Time%taup1, Time%model_time,                           &
                           Grid%dat, Grid%tmask, Grid%kmt, Grid%xt, Grid%yt, Grid%zt,   &
                           Grid%zw, Grid%dzt,                                           &
                           Grid%name, Grid%tracer_axes, Domain%domain2d,                &
                           Thickness%rho_dzt)
endif  !}

if (do_ocean_bgc_restore) then  !{
  call ocean_bgc_restore_start(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,          &
                               Grid%nk, Domain%isd, Domain%ied, Domain%jsd,             &
                               Domain%jed, T_prog, T_diag, Time%taup1, Time%model_time,   &
                               Grid%dat, Grid%tmask, Grid%kmt, Grid%xt, Grid%yt,        &
                               Grid%zt, Grid%zw, Grid%dzt,                              &
                               Grid%name, Grid%tracer_axes, Domain%domain2d,            &
                               Thickness%rho_dzt)
endif  !}

if (do_ocean_po4_pre) then  !{
  call ocean_po4_pre_start(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,     &
                             Domain%isd, Domain%ied, Domain%jsd, Domain%jed,            &
                             T_prog, Time%taup1,                                        &
                             Grid%dat, Grid%tmask, Grid%kmt, Grid%xt, Grid%yt,          &
                             Thickness%rho_dzt)
endif  !}

if (do_ocean_ibgc) then  !{
  call ocean_ibgc_start(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk,        &
                             Domain%isd, Domain%jsd,             &
                             Time%model_time,               &
                             Grid%tmask,           &
                             Grid%tracer_axes, Domain%domain2d)
                             
endif  !}

#endif 

#if defined(CSIRO_BGC)
if (do_csiro_bgc) then  !{
  call csiro_bgc_start(Time, Domain, Grid)
endif  !}
#endif

if (do_transport_matrix) then  !{
  call transport_matrix_start(Time, T_prog, Domain%isd, Domain%ied, Domain%jsd,         &
                              Domain%jed, Grid%nk, Grid%tracer_axes)
endif  !}


return

end subroutine ocean_tpm_start  !}
! </SUBROUTINE> NAME="ocean_tpm_start"


!#######################################################################
! <SUBROUTINE NAME="ocean_tpm_tracer">
!
! <DESCRIPTION>
!       Subroutine to do calculations needed every time-step after
!       the continuity equation has been integrated
! </DESCRIPTION>
!

subroutine ocean_tpm_tracer(Domain, T_prog, T_diag, Grid, Time, Thickness, Dens, dtts, hblt_depth,&
                            sw_pen, opacity, diff_cbt, Velocity)  !{

implicit none

!
!-----------------------------------------------------------------------
!       Arguments
!-----------------------------------------------------------------------
!

type(ocean_domain_type), intent(in)                             :: Domain
type(ocean_prog_tracer_type), dimension(:), intent(inout)       :: T_prog
type(ocean_diag_tracer_type), dimension(:), intent(inout)       :: T_diag
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time
type(ocean_thickness_type), intent(in)                          :: Thickness
type(ocean_density_type), intent(in)                            :: Dens
type(ocean_Velocity_type), intent(in)                           :: Velocity
real, intent(in)                                                :: dtts
real, intent(in), dimension(Domain%isd:,Domain%jsd:)            :: hblt_depth
real, intent(in), dimension(Domain%isd:,Domain%jsd:)            :: sw_pen
real, intent(in), dimension(Domain%isd:,Domain%jsd:,:)          :: opacity
real, intent(in), dimension(Domain%isd:,Domain%jsd:,:,:)        :: diff_cbt

!
!-----------------------------------------------------------------------
!     local parameters
!-----------------------------------------------------------------------
!

!
!       call subroutines to perform functions required each time-step
!       after the continuity equation has been integrated
!

!
!       set some indices and flags dependent on time
!

call do_time_calc(Time, dtts)

if (do_ocean_age_tracer) then  !{
  call ocean_age_tracer_tracer(T_prog, Time%taup1)
endif  !}

if (do_ocean_residency) then  !{
  call ocean_residency_tracer(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,           &
                              Domain%isd, Domain%ied, Domain%jsd, Domain%jed, Grid%nk,  &
                              T_prog, Grid%tmask, Time%taup1, Time%model_time, dtts)
endif  !}

#ifdef USE_OCEAN_BGC

if (do_ocmip2_abiotic) then  !{
  call ocmip2_abiotic_tracer(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%nk, &
                             Domain%isd, Domain%ied, Domain%jsd, Domain%jed,          &
                             T_prog, Grid%dat, Grid%tmask, Grid%tcella,               &
                             Time%taum1, dtts, end_of_year)
endif  !}

if (do_ocean_po4_pre) then  !{
  call ocean_po4_pre_tracer(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,          &
                            Domain%isd, Domain%ied, Domain%jsd, Domain%jed, Grid%nk, &
                            T_prog, Time, Thickness, Dens, Grid%zt, hblt_depth)
endif  !}

if (do_ocean_ibgc) then  !{
  call ocean_ibgc_tracer(Domain%isc, Domain%iec, Domain%jsc, Domain%jec,               &
                              Domain%isd, Domain%jsd, Grid%nk, &
                              Time, T_prog,                            &
                              Thickness%depth_zt, hblt_depth)
                              
endif  !}

if (do_generic_tracer) then 
   call ocean_generic_column_physics(Thickness, hblt_depth, Time, &
        Grid, dtts, Domain%isd,Domain%jsd, T_prog, T_diag,sw_pen,opacity, diff_cbt, Velocity)
endif

#endif 

#if defined(CSIRO_BGC)
if (do_csiro_bgc) then  !{
  call csiro_bgc_tracer(Domain%isc, Domain%iec, Domain%jsc, Domain%jec, T_prog, grid, Time, dtts)
endif  !}
#endif

if (do_transport_matrix) then !{
  call transport_matrix_store_implicit(Time, T_prog, Domain%isd, Domain%ied, Domain%jsd, Domain%jed,    &
       Grid%nk, Domain%isc, Domain%iec, Domain%jsc, Domain%jec, Grid%tmask)
endif  !}


return

end subroutine ocean_tpm_tracer  !}
! </SUBROUTINE> NAME="ocean_tpm_tracer"

end module ocean_tpm_mod  !}

!VERSION NUMBER:
!  $Id: donner_meso_k.F90,v 19.0 2012/01/06 20:08:00 fms Exp $

!module donner_meso_inter_mod

!#include "donner_meso_interfaces.h"

!end module donner_meso_inter_mod

!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

subroutine don_m_meso_effects_k    &
         (me, nlev_lsm, nlev_hires, ntr, diag_unit, debug_ijt, Param, Nml,&
          pfull_c, temp_c, mixing_ratio_c, phalf_c, rlsm, emsm, etsm, &
          tracers_c, ensembl_cond, ensmbl_precip, pb, plzb_c, pt_ens, &
          ampta1, ensembl_anvil_cond_liq, ensembl_anvil_cond_liq_frz, &
          ensembl_anvil_cond_ice,  wtp, qtmes, meso_frz_intg_sum,  &
          anvil_precip_melt, meso_cloud_area, cmus_tot, dmeml,  &
          emds_liq, emds_ice, emes_liq, emes_ice,  wmms, wmps, &
          umeml, temptr, tmes, tmes_up, tmes_dn, mrmes, mrmes_up, &
          mrmes_dn, emdi, pmd, pztm, pzm, meso_precip, ermesg, error)

!-------------------------------------------------------------------
!    subroutine don_m_meso_effects_k obtains the mesoscale effects
!    of the composited cloud ensemble on the heat, moisture and tracer 
!    budgets, producing tendency terms which are to be applied to the 
!    large-scale model equations. the scheme employed here is a variation
!    on the procedure of Leary and Houze (JAS, 1980). for more details 
!    on notation, see "Cu Closure A notes," 2/97.
!-------------------------------------------------------------------

use donner_types_mod, only : donner_param_type, donner_nml_type

implicit none

!-------------------------------------------------------------------
integer,                           intent(in)  :: me, nlev_lsm, nlev_hires, &
                                                  ntr, diag_unit
logical,                           intent(in)  :: debug_ijt        
type(donner_param_type),           intent(in)  :: Param
type(donner_nml_type),             intent(in)  :: Nml  
real,   dimension(nlev_lsm),       intent(in)  :: pfull_c, temp_c, &
                                                  mixing_ratio_c
real,   dimension(nlev_lsm+1),     intent(in)  :: phalf_c
real,   dimension(nlev_hires),     intent(in)  :: rlsm, emsm
real,   dimension(nlev_hires,ntr), intent(in)  :: etsm
real,   dimension(nlev_lsm,ntr),   intent(in)  :: tracers_c
logical,                           intent(in)  :: meso_frz_intg_sum
real,                              intent(in)  :: ensembl_cond,   &
                                                  ensmbl_precip, pb, &
                                                  plzb_c, pt_ens,   &
                                                  ampta1, &
                                              ensembl_anvil_cond_liq, &
                                       ensembl_anvil_cond_liq_frz, &
                                                  ensembl_anvil_cond_ice
real,   dimension(nlev_lsm,ntr),   intent(out) :: wtp, qtmes, temptr
real,   dimension(nlev_lsm),       intent(out) :: anvil_precip_melt, &
                                                  meso_cloud_area,    &
                                                  cmus_tot, dmeml, &
                                                  emds_liq, emds_ice, &
                                                        wmms, wmps,   &
                                                  emes_liq, emes_ice, &
                                                  umeml, tmes, mrmes, &
                                                  mrmes_up, mrmes_dn, &
                                                  tmes_up, tmes_dn
real,                              intent(out) :: emdi,           &
                                                  pmd, pztm, pzm, &
                                                  meso_precip
character(len=*),                  intent(out) :: ermesg
integer,                           intent(out) :: error

!----------------------------------------------------------------------
!   intent(in) variables:
!
!       pfull_c      large-scale model pressure full levels [ Pa ]
!       phalf_c      large-scale model pressure half levels [ Pa ]
!       temp_c       large-scale model temperature profile [ deg K ]
!       mixing_ratio_c  
!                    large-scale model mixing ratio profile
!                    [ kg(h2o) / kg(air) ]
!       rlsm         cloud model condensation profile summed over
!                    cloud ensemble
!                    [ kg(h2o) / kg(air) / sec ]
!       emsm         cloud model moisture flux convergence summed over 
!                    the cloud ensemble
!                    [ kg(h2o) / kg(air) / sec ]
!       etsm         cloud model tracer flux convergence summed over
!                    the cloud ensemble 
!                    [ kg(tracer) / kg(air) / sec ]
!       tracers_c    large-scale model tracer mixing ratio profiles
!                    [ kg(tracer) /kg(air) ]
!       ensmbl_cond  total ensemble condensation integral
!                    [ mm / day ]
!       ensmbl_precip   total ensemble precipitation integral
!                    [ mm / day ]
!       ps           surface pressure [ Pa ]
!       pb           cloud-base pressure [ Pa ]
!       plzb_c       level of zero buoyancy [ Pa ]
!       pt_ens       cloud-top pressure [ Pa ]
!       ampta1       fractional area of mesoscale anvil
!                    [ dimensionless ]
!       ensembl_anvil_cond 
!                    condensed water transferred from cells to anvil 
!                    [ mm / day ]
!       debug_ijt    is this a diagnostics column ?
!       diag_unit    output unit number for this diagnostics column
!
!  output variables:
! 
!       meso_cloud_area 
!               fractional mesoscale area, normalized by
!               a(1,p_b) at resolution of GCM
!       meso_precip
!       cmu     water mass condensed in mesoscale updraft
!               (g/kg/day) (normalized by a(1,p_b))
!       cmui    vertical integral of mesoscale-updraft deposition
!               (kg(H2O)/((m**2)*sec) 
!       dmeml   mass flux in mesoscale downdraft (kg/((m**2) s))
!               (normalized by a(1,p_b)) (index 1 at atmosphere bottom)
!               (resolution of GCM)
!       emds    water mass evaporated in mesoscale
!               downdraft (g/kg/day) (normalized by a(1,p_b))
!       emdi    vertical integral of mesoscale-downdraft sublimation
!               (mm/d)
!       emes    water mass evaporated from mesoscale
!               updraft (g/kg/day) (normalized by a(1,p_b))
!       emei    vertical integral of mesoscale-updraft sublimation
!               (kg(h2O)/((m**2)*sec)
!       pmd     pressure at top of mesoscale downdraft (Pa)
!       pztm    pressure at top of mesoscale updraft (Pa)
!       wmms    water vapor removal by condensation of
!               cell vapor source (g/kg/day) (normalized by a(1,p_b))
!       wmps    water vapor redistributed from cell vapor source
!               (g/kg/day) (normalized by a(1,p_b))
!       wtp     tracer redistributed by mesoscale processes
!               (kg/kg/s) (normalized by a(1,p_b))
!       anvil_precip_melt     melting of ice in mesoscale updraft-
!               equivalent (g/kg/day)-which falls as meso sfc precip
!               (normalized by a(1,p_b))
!       tmes    temperature tendency due to mesoscale entropy-flux-
!               convergence (K/day) (normalized by a(1,p_b))
!       mrmes    moisture tendency due to mesoscale moisture-flux
!               convergence (g/kg/day) (normalized by a(1,p_b))
!       qtmes   tracer tendency due to mesoscale tracer-flux
!               convergence (kg/kg/s) (normalized by a(1,p_b))
!       umeml   mass flux in mesoscale updraft (kg/((m**2) s))
!               (normalized by a(1,p_b)) (index 1 at atmosphere bottom)
!               (resolution of GCM)
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:

      real, dimension (nlev_lsm)     ::  cmu
      real, dimension (nlev_lsm)     ::  out
      real, dimension (nlev_hires)   ::  p_hires
      real                           ::  alp, hfmin, cmui, qtmesum, dp,&
                                         available_condensate, &
                                         available_condensate_liq, &
                                         available_condensate_ice
      real                           ::  emdi_liq, emdi_ice
      integer                        ::  k, kcont, itrop
      real  :: intgl_lo, intgl_hi
      real          :: p2, ptrop

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      ermesg = ' ' ; error = 0

      dp = Param%dp_of_cloud_model

!--------------------------------------------------------------------
!    define the pressure at the melting level (p2).
!--------------------------------------------------------------------
      p2 = -10.
      do k=1,nlev_lsm-1
        if ((temp_c(k) >= Param%kelvin) .and.   &
             (temp_c(k+1) <= Param%kelvin))  then
          p2 = phalf_c(k+1)
          exit
        end if
      end do

!---------------------------------------------------------------------
!    if in diagnostics column, output message indicating that sub-
!    routine meso_effects has been entered.
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a)') 'in meens: entering meens'
      endif

!--------------------------------------------------------------------
!    define the pressure at the top of the mesoscale updraft (pztm) to 
!    be the pressure at the zero buyancy level, unless the cloud top is
!    above 100 hPa, in which case pztm is set to be one level above the 
!    level of zero buoyancy.  previously pztm was restricted to be  >=
!    100 hPa, cf Ackerman et al (JAS,1988), unless pt_ens <= 10kPa. 
!    result was that stratospheric water vapor was transported too high 
!    in AM2p9 with this pztm, so the constraint was changed to pztm >= 
!    plzb_c + dp
!--------------------------------------------------------------------
      if ((pt_ens + dp) >= 10.e03)  then
        pztm = plzb_c
      else
        pztm = plzb_c + dp
      endif

      if (Nml%limit_pztm_to_tropo) then
        call find_tropopause (nlev_lsm, temp_c, pfull_c, ptrop, itrop)
        pztm = MAX (pztm, ptrop)
      endif

!---------------------------------------------------------------------
!    if in diagnostics column, output the pressure at top of meso-
!    scale circulation (pztm) and the precipitation efficiency 
!    (ensmbl_precip/ensembl_cond).
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a,  e20.12)') 'in meens: pztm = ',pztm 
        write (diag_unit, '(a, e20.12)') 'in meens: gnu= ',   &
                                             ensmbl_precip/ensembl_cond
      endif

!---------------------------------------------------------------------
!    define the pressure at the vertical grid levels of the cloud model
!    grid.
!---------------------------------------------------------------------
      do k=1,nlev_hires        
        p_hires(k) = pb + (k-1)*dp
      end do

!---------------------------------------------------------------------
!    call subroutine meso_updraft to define the needed output fields 
!    associated with the mesoscale updraft.
!---------------------------------------------------------------------
      call don_m_meso_updraft_k   &
           (nlev_lsm, nlev_hires, ntr, diag_unit, debug_ijt, Param, &
            p_hires, rlsm, emsm, etsm, pfull_c,  &
             temp_c, mixing_ratio_c, phalf_c, tracers_c,  &
              pb, pt_ens, ampta1, dp, pztm,  wtp, &
                  qtmes, cmu, wmms, wmps, temptr, tmes_up, mrmes_up,   &
                  meso_cloud_area, umeml,&
                  alp, pzm, hfmin, cmui, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

      if (Nml%frc_internal_enthalpy_conserv) then
!-----------------------------------------------------------------------
!    call don_u_set_column_integral_k to adjust the tmes_up
!    profile below cloud base so that the desired integral value is
!    obtained.
!-----------------------------------------------------------------------
         call don_u_set_column_integral_k    &
              (nlev_lsm, tmes_up   , pb, &
               phalf_c(1), 0.0, phalf_c , intgl_hi,     &
               intgl_lo, out, ermesg, error)

!---------------------------------------------------------------------
!    if column diagnostics are desired, output the integrals and 
!    profiles, both before and after the adjustment to the desired value        .
!---------------------------------------------------------------------
        if (debug_ijt) then
           write (diag_unit, '(a, e20.12)')  &
                   'in set_col_integral: tmes_up column(in)= ',intgl_hi
           write (diag_unit, '(a, e20.12)')  &
                   'in set_col_integral: tmes_up column(out)= ',intgl_lo
           do k=1,nlev_lsm
            if (tmes_up(k)       /= out(k)) then
               write (diag_unit, '(a, i4, 2e20.12)') &
               'in set_col_integral: k,tmesup(in), tmesup(out)= ', k,  &
                     tmes_up(k)      , out(k)
            endif
          end do
        endif
 
!---------------------------------------------------------------------
!    define the adjusted output profile by removing conservation_factor.
!---------------------------------------------------------------------
       tmes_up(:) = out(:)       
    endif

!---------------------------------------------------------------------
!    call subroutine meso_downdraft to define the needed output fields 
!    associated with the mesoscale downdraft.
!---------------------------------------------------------------------
      call don_m_meso_downdraft_k  &
           (nlev_lsm, nlev_hires, diag_unit, debug_ijt, Param, Nml,  &
            p_hires, pfull_c, temp_c, mixing_ratio_c, phalf_c, pb, &
            ampta1, dp, pztm, pzm, alp, hfmin, pmd, tmes_dn,  &
            mrmes_dn, dmeml, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

      if (Nml%frc_internal_enthalpy_conserv) then
!-----------------------------------------------------------------------
!    call don_u_set_column_integral_k to adjust the tmes_dn
!    profile below cloud base so that the desired integral value is
!    obtained.
!-----------------------------------------------------------------------
         call don_u_set_column_integral_k    &
              (nlev_lsm, tmes_dn   , pb, &
               phalf_c(1), 0.0, phalf_c , intgl_hi,     &
               intgl_lo, out, ermesg, error)

!---------------------------------------------------------------------
!    if column diagnostics are desired, output the integrals and 
!    profiles, both before and after the adjustment to the desired value        .
!---------------------------------------------------------------------
        if (debug_ijt) then
           write (diag_unit, '(a, e20.12)')  &
                    'in set_col_integral: tmes_dn column(in)= ',intgl_hi
           write (diag_unit, '(a, e20.12)')  &
                  'in set_col_integral: tmes_dn column(out)= ',intgl_lo
           do k=1,nlev_lsm
            if (tmes_dn(k) /= out(k)) then
               write (diag_unit, '(a, i4, 2e20.12)') &
               'in set_col_integral: k,tmesdn(in), tmesdn(out)= ', k,  &
                     tmes_dn(k)      , out(k)
            endif
          end do
        endif
 
!---------------------------------------------------------------------
!    define the adjusted output profile by removing conservation_factor.
!---------------------------------------------------------------------
       tmes_dn(:) = out(:)       
     endif

!---------------------------------------------------------------------
!    combine the heating and moistening effects from the updraft and
!    downdraft to obtain the total mesoscale effect on the large-scale
!    model temperature and water vapor mixing ratio(?) equations.
!---------------------------------------------------------------------
      tmes = (tmes_up + tmes_dn)*86400.
      tmes_up = tmes_up*86400.
      tmes_dn = tmes_dn*86400.
      mrmes = (mrmes_up + mrmes_dn)*8.64e07
      mrmes_up = mrmes_up*8.64e07
      mrmes_dn = mrmes_dn*8.64e07

!---------------------------------------------------------------------
!    if in a diagnostics column, output the entropy (tmes) and
!    mixing ratio (mrmes) tendencies due to the mesoscale
!    updraft and downdraft.
!---------------------------------------------------------------------
      do k=1,nlev_lsm              
        if (debug_ijt) then
          if (tmes(k) /= 0.0) then
            write (diag_unit, '(a, i4, f19.10, f20.14, 2e20.12)')   &
                    'in meens: jk,pr,tmes,tmes_u, tmes_d,= ', &
                     k, pfull_c(k), tmes(k)/86400., tmes_up(k)/86400., &
                     tmes_dn(k)/86400.
            write (diag_unit, '(a, i4, f19.10, f20.14, 3e20.12)')   &
                    'in meens: jk,pr,mrmes,mrmes_u, mrmes_d= ', &
                     k, pfull_c(k), mrmes(k)/8.64e07,  &
                      mrmes_up(k)/8.64e07, mrmes_dn(k)/8.64e07
          endif
        endif
      end do

!---------------------------------------------------------------------
!    define the column anvil precip (meso_precip) as the precipitation
!    efficiency times the available condensate in the anvil, which is 
!    made up of the deposition in the updraft (cmui) and the condensate
!    transferred from the cells to the anvil (ensembl_anvil_cond). 
!---------------------------------------------------------------------
      available_condensate = cmui + ensembl_anvil_cond_liq + &
                                ensembl_anvil_cond_liq_frz + &
                             ensembl_anvil_cond_ice
! precip from _liq takes hlv with it; precip from _ice takes hls
! with it
      if ( p2 == -10. .or. p2 > pb .or. p2 < pt_ens) then
        if ( .not. meso_frz_intg_sum ) then
!   this implies no melting of precip; cmui and _liq don't freeze.
         available_condensate_liq =  cmui + ensembl_anvil_cond_liq 
         available_condensate_ice =         &
                                ensembl_anvil_cond_liq_frz + &
                             ensembl_anvil_cond_ice
        else
         available_condensate_liq =  0.0                           
         available_condensate_ice =    cmui + ensembl_anvil_cond_liq + & 
                                ensembl_anvil_cond_liq_frz + &
                             ensembl_anvil_cond_ice
        endif
      else
!    all condensate will melt before leaving
      available_condensate_ice = 0.0                               
      available_condensate_liq = cmui + ensembl_anvil_cond_liq + &
                                ensembl_anvil_cond_liq_frz + &
                             ensembl_anvil_cond_ice
      endif

      meso_precip = Param%anvil_precip_efficiency*available_condensate

!---------------------------------------------------------------------
!    if in a diagnostics column, output the total mesoscale-supplied
!    condensate (condensation plus deposition), the cell provided 
!    condensate (ensembl_anvil_cond),  the mesoscale precipitation 
!    (meso_precip) and the cell-scale precipitation (ensmbl_precip).
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 4e20.12)')  &
                     'in meens: cmui,ca (liq,frxliq,ice)=', cmui, &
                 ensembl_anvil_cond_liq, ensembl_anvil_cond_liq_frz,  &
                             ensembl_anvil_cond_ice
        write (diag_unit, '(a, e20.12, a, e20.12)')  &
                     'in meens: rm= ',meso_precip,  'rc= ',ensmbl_precip
      endif

!----------------------------------------------------------------------
!    call subroutine meso_evap to define the amount of condensate that
!    is evaporated in the mesoscale updraft (emes) and mesoscale 
!    downdraft (emds).
!----------------------------------------------------------------------
      call don_m_meso_evap_k  &
           (nlev_lsm, diag_unit, debug_ijt, Param,  &
            available_condensate, available_condensate_liq,  &
            available_condensate_ice, pzm, pztm, phalf_c, emdi_liq, &
            emdi_ice, emds_liq, emds_ice, emes_liq, emes_ice, ermesg, error)
 
      emdi = emdi_liq + emdi_ice

!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!---------------------------------------------------------------------
!    call subroutine meso_melt to distribute the melting of precipitat-
!    ing anvil ice within the column (anvil_precip_melt).
!---------------------------------------------------------------------
      call don_m_meso_melt_k   &
           (nlev_lsm, diag_unit, debug_ijt, Param, temp_c, phalf_c, &
            pztm, meso_precip, pb, anvil_precip_melt, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!--------------------------------------------------------------------
!    define cmus_tot   as the profile of total condensate source to the
!    large-scale flow from the mesoscale circulation; the sum of the
!    water mass condensed in the mesoscale updraft plus the vapor
!    transferred from cell to mesoscale and then condensed.
!--------------------------------------------------------------------
      do k=1,nlev_lsm            
        cmus_tot(k) = cmu(k) - wmms(k)
      end do

!---------------------------------------------------------------------
!    if in a diagnostics column, output the profiles of tracer tranfer-
!    red from cells to mesoscale circulation (wtp), mesoscale tracer-
!    flux convergence (qtmes), and cell-scale tracer flux convergence 
!    (qtren). also output the  column integral of the mesoscale 
!    tracer-flux convergence (qtmesum).
!---------------------------------------------------------------------
      if (debug_ijt) then
        qtmesum = 0.
        do k=1,nlev_lsm             
          do kcont=1,ntr           
            write (diag_unit, '(a, 2i4, f19.10, e20.12)')  &
                      'in mulsub: jk, pr,wtp= ',k, kcont,  &
                          pfull_c(k), wtp(k,kcont)
            write (diag_unit, '(a, 2i4, f19.10, e20.12)')  &
                     'in mulsub: jk, pr,qtmes= ', k, kcont,         &
                            pfull_c(k),  qtmes(k,kcont)
            qtmesum = qtmesum + qtmes(k,kcont)*  &
                      (phalf_c(k) - phalf_c(k+1))
            write (diag_unit, '(a, i4, e20.12)')  &
                        'in mulsub: jk,qtmesum= ', k, qtmesum
          end do
        end do
      endif

!--------------------------------------------------------------------


end subroutine don_m_meso_effects_k 


!#######################################################################

subroutine don_m_meso_updraft_k    &
         (nlev_lsm, nlev_hires, ntr, diag_unit, debug_ijt, Param,  &
          p_hires, rlsm, emsm, etsm, pfull_c, temp_c, mixing_ratio_c, &
          phalf_c, tracers_c, pb, pt_ens, ampta1, dp, pztm, wtp, &
          qtmes, cmu, wmms, wmps, temptr, tmes_up, mrmes_up,  &
          meso_cloud_area, umeml, alp, pzm, hfmin, cmui, ermesg, error)

!-------------------------------------------------------------------
!    subroutine meens computes the mesoscale effects of the composited
!    cloud ensemble on the heat, moisture and tracer budgets, producing
!    tendency terms which are to be applied to the large-scale model.
!    scheme employed here is a variation on procedure of Leary and 
!    Houze (JAS, 1980). for more details on notation, see 
!    "Cu Closure A notes," 2/97.
!-------------------------------------------------------------------

use donner_types_mod, only : donner_param_type
use sat_vapor_pres_k_mod, only: compute_mrs_k

implicit none

!-------------------------------------------------------------------
integer,                         intent(in)  :: nlev_lsm, nlev_hires, ntr
integer,                         intent(in)  :: diag_unit
logical,                         intent(in)  :: debug_ijt
type(donner_param_type),         intent(in)  :: Param
real,   dimension(nlev_hires),   intent(in)  :: p_hires, rlsm, emsm
real,   dimension(nlev_hires,ntr),                          &
                                 intent(in)  :: etsm
real,   dimension(nlev_lsm),     intent(in)  :: pfull_c, temp_c,    &
                                                mixing_ratio_c
real,   dimension(nlev_lsm+1),   intent(in)  :: phalf_c
real,   dimension(nlev_lsm,ntr), intent(in)  :: tracers_c
real,                            intent(in)  :: pb, pt_ens, ampta1,   &
                                                dp, pztm
real,   dimension(nlev_lsm,ntr), intent(out) :: wtp, qtmes, temptr
real,   dimension(nlev_lsm),     intent(out) :: cmu, wmms, wmps, &
                                                tmes_up, mrmes_up, &
                                                meso_cloud_area, umeml
real,                            intent(out) :: alp, pzm, hfmin, cmui
character(len=128),              intent(out) :: ermesg
integer,                         intent(out) :: error

!---------------------------------------------------------------------
!   local variables:



      real, dimension (nlev_hires)       :: wmhr, cumh
      real, dimension (nlev_lsm)         :: omv, tempq, owm, tempqa
      real, dimension(nlev_lsm,ntr)      :: otm
      real, dimension(nlev_hires, ntr)   :: wthr
      real, dimension(ntr)               :: q1t


      real      ::  cmfhr, pc1, pc2, omer, pctm, q1, q4, mrsat, &
                    q3, anv, qref, pp, pm, qprip, qprim, eqfp, eqfm, &
                    qmu, hflux, pfmin, owms, wpc, wmc, ta, te, tep, tmu,&
                    qtprip, qtprim, eqtfp, eqtfm, rintsum, rintsum2
      logical   :: do_donner_tracer
      integer   :: ncc, ncztm
      integer   :: kcont, kk
      integer   :: jk, i, jsave, jkm, jkp, k, nbad

!-----------------------------------------------------------------------
      ermesg = ' ' ; error = 0

      if (ntr > 0) then
        do_donner_tracer = .true.
      else
        do_donner_tracer = .false.
      endif

      do i=1,nlev_hires
        if (p_hires(i) < pt_ens) then
          ncc = i
          exit
        endif
      end do
      do i=1,nlev_hires
        if (p_hires(i) < pztm) then
          ncztm = i + 1
          exit
        endif
      end do

      do kcont=1,ntr
        wtp(:,kcont) = 0.
        qtmes(:,kcont) = 0.
        temptr(:,kcont) = tracers_c(:,kcont)
      end do
      tmes_up(:) = 0.
      mrmes_up(:) = 0.
      cmu = 0.
      wmms = 0.
      wmps = 0.
      tempq(:) = mixing_ratio_c(:)
      tempqa(:) = mixing_ratio_c(:)

!----------------------------------------------------------------------
!    initialize the pressure at the base of the mesoscale circulation
!    (pzm).
!----------------------------------------------------------------------
      pzm = 0.

!----------------------------------------------------------------------
!    define the vertical profile of the rate at which water vapor is
!    made available to the mesoscale circulation by the convective 
!    updrafts on the cloud model grid (wmhr). if vapor is being made 
!    available, determine if there is also a vertical flux convergence 
!    of tracer; if so, define the rate at which tracer is being made
!    available to the mesoscale circulation (wthr). define the pressure
!    at the base of the mesoscale circulation (pzm) as the pressure at 
!    the lowest cloud model level where the convective updrafts are 
!    supplying condensate to the mesoscale circulation.
!----------------------------------------------------------------------
      do k=1,nlev_hires
        cmfhr = -rlsm(k) + emsm(k)
        if (cmfhr > 0.) then
          wmhr(k) = -cmfhr
          if (do_donner_tracer) then
            do kcont=1,ntr
              if (etsm(k,kcont) > 0.) then
                wthr(k,kcont) = -etsm(k,kcont)
              else
                wthr(k,kcont) = 0.0               
              endif
            end do
          else
            wthr(k,:) = 0.0               
          endif
          if (pzm == 0.) then
            pzm = p_hires(k)
          endif
        else
          wmhr(k) = 0.0   
          wthr(k,:) = 0.0               
        endif
      end do

!---------------------------------------------------------------------
!    if in diagnostics column, output the profiles of condensation rate
!    (rlsm), water vapor flux convergence (emsm) and water vapor 
!    supplied to the mesoscale (wmhr) on the cloud model grid.
!---------------------------------------------------------------------
      do k=1,nlev_hires
        if (debug_ijt) then
          write (diag_unit, '(a, i4, 2e20.12)')  &
                     'in meens: i,rlhr,emfhr= ',k,rlsm(k),emsm(k)
          write (diag_unit, '(a, i4, e20.12)')  &
                      'in meens: i,wmhr= ',k,wmhr(k)
        endif
      end do

      if (debug_ijt) then
        write (diag_unit, '(a, i4, e20.12)')  &
                        'in meens: ncc+1, pt', ncc+1, pt_ens
        do k=1,ncc+1
          write (diag_unit, '(a, i4, e20.12)')  &
                         'in meens: k,p_hi= ', k, p_hires(k)
        end do
        do k=1,nlev_lsm+1         
          write (diag_unit, '(a, i4, e20.12)')  &
                      'in meens: k,p_lo= ', k, phalf_c(k)
        end do
      endif

!---------------------------------------------------------------------
!    convert the vertical profile of vapor made available to the meso-
!    scale from the updraft to the large-scale model grid (output var-
!    iable is owm). if tracers are being transported by donner conv-
!    ection, convert the vertical profile of tracer made available to 
!    the mesoscale from the updraft to the large-scale model grid 
!    (output variable is otm). 
!---------------------------------------------------------------------
      call don_u_map_hires_c_to_lores_c_k &
           (nlev_lsm, nlev_hires, wmhr, p_hires, pt_ens + dp, phalf_c,&
            owm, rintsum, rintsum2, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12)')  &
            'in meens: rintsum(owm) =', rintsum, rintsum2
        call don_u_compare_integrals_k  &
             (rintsum, rintsum2, diag_unit, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (error /= 0 ) return
      endif

      if (do_donner_tracer) then
        do kcont=1,ntr
          call don_u_map_hires_c_to_lores_c_k  &
               (nlev_lsm, nlev_hires, wthr (:,kcont), p_hires,  &
                pt_ens + dp, phalf_c, otm(:,kcont), rintsum,   &
                rintsum2, ermesg, error) 
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (error /= 0 ) return

          if (debug_ijt) then
            write (diag_unit, '(a, 2e20.12)')  &
                 'in meens: rintsum(otm) =', rintsum, rintsum2
            call don_u_compare_integrals_k  &
                 (rintsum, rintsum2, diag_unit, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
            if (error /= 0 ) return
          endif
        end do
      endif

!----------------------------------------------------------------------
!    adjust the value for pressure at base of mesocscale circulation,
!    if necessary.
!----------------------------------------------------------------------
      if (pzm == 0.) pzm = pt_ens
      if (pzm <= pztm - dp) pzm = pztm - dp

!---------------------------------------------------------------------
!    if in diagnostics column, output the pressure at the base of the
!    mesoscale circulation (pzm), and the vertical profile of vapor 
!    supplied to the mesoscale by the updraft on the large-scale model
!    grid (owm).
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, f19.10)') 'in meens: pzm= ',pzm
        do k=1,nlev_lsm
          write (diag_unit, '(a, i4, e20.12)')  &
                                 'in meens: jk,owm= ',k,owm(k)
        end do
      endif

!---------------------------------------------------------------------
!    march up the column, determining the redistribution of the cumulus-
!    updraft-supplied vapor by the mesoscale updraft.
!---------------------------------------------------------------------
      do k=1,nlev_lsm

!---------------------------------------------------------------------
!    if there is  vapor being supplied to the mesoscale by the cumulus
!    updraft at this level, determine the pressure depth over which the
!    mesoscale updraft will distribute that vapor over the lifetime of
!    the mesoscale circulation.
!---------------------------------------------------------------------
        if (owm(k) < 0.) then     

!---------------------------------------------------------------------
!    define the bottom (pc1) and top (pc2) of the current layer. deter-
!    mine the pressure level to which air in this layer will reach when
!    moving at the appropriate mesoscale updraft velocity for the dur-
!    ation of the mesoscale circulation (pctm). this level is limited to
!    be no higher than the top of the mesoscale circulation; if it is 
!    calculated to be higher, redefine the mesoscale updraft velocity 
!    for this layer so that the air in this layer will reach only to
!    the mesoscale circulation top, and no higher.
!---------------------------------------------------------------------
          pc1 = phalf_c(k)
          pc2 = phalf_c(k+1)
          pctm = pc2 + Param%meso_ref_omega*Param%meso_lifetime
          if (pctm <= pztm) then
            omer = (pztm - pc2)/Param%meso_lifetime
            pctm = pc2 + omer*Param%meso_lifetime
          else
            omer = Param%meso_ref_omega
          endif
 
!---------------------------------------------------------------------
!    define the amount of water vapor from this layer (owm(k)* 
!    (pc2 - pc1)*MESO_LIFETIME) which is to be distributed
!    uniformly between pc1 and pctm (q1).
!--------------------------------------------------------------------  
          q1 = owm(k)*(pc2 - pc1)*Param%meso_lifetime/(pc1 - pctm)
          q4 = 0.5*q1

!---------------------------------------------------------------------
!    define the amount of tracer from this layer (otm(k,kcont)* 
!    (pc2 - pc1)*meso_Lifetime) which is to be distributed
!    uniformly between pc1 and pctm (q1t).
!--------------------------------------------------------------------  
          if (do_donner_tracer) then
            do kcont=1,ntr
              q1t(kcont) = otm(k,kcont)*(pc2 - pc1)*Param%meso_lifetime/&
                           (pc1 - pctm)                     
            end do
          endif

!---------------------------------------------------------------------
!    if in diagnostics column, output the topmost pressure reached by
!    the mesoscale updraft from this layer (pctm), the top of the meso-
!    scale circulation (pztm) and the amount of water vapor supplied to
!    each layer between the current vertical level and the top of the 
!    mesoscale updraft originating here (q4).
!---------------------------------------------------------------------
          if (debug_ijt) then
            write (diag_unit, '(a, 3e20.12)')  &
                         'in meens: pctm,pztm,q4= ', pctm, pztm, q4
          endif

!---------------------------------------------------------------------
!    distribute the vapor supplied in the current layer to all layers
!    between the current location and the top of the mesoscale updraft.
!---------------------------------------------------------------------
          do kk=k,nlev_lsm

!--------------------------------------------------------------------
!    exit the loop when above the top of the mesoscale updraft. if still
!    within the mesoscale updraft originating from level k, add the 
!    contribution of water vapor being supplied to the mesoscale circ-
!    ulation at this level (kk) from the current source level (k), 
!    normalized by the anvil fractional area, to the arrays accumulating
!    these moisture sources (tempq, tempqa). these arrays will be used 
!    in the calculation of deposition in the mesoscale updraft.
!--------------------------------------------------------------------
            if (phalf_c(kk) < pctm) exit
            tempq(kk) = tempq(kk) + (q1/ampta1)
            tempqa(kk) = tempqa(kk) + (q4/ampta1)

!--------------------------------------------------------------------
!    add the rate of moisture input to the current layer kk from 
!    the current source layer k to the accumulation array (wmps). if the
!    current model layer extends beyond the top of the mesoscale 
!    updraft, pro-rate the contribution by the ratio of pressure depths.
!--------------------------------------------------------------------
            if (phalf_c(kk+1) <= pctm)  then
              wmps(kk) = wmps(kk) + (q1/Param%meso_lifetime)*  &
                        (phalf_c(kk) - pctm)/  &
                                            (phalf_c(kk) - phalf_c(kk+1))
            else
              wmps(kk) = wmps(kk) + q1/Param%meso_lifetime
            endif

!--------------------------------------------------------------------
!    add the contribution of tracer being supplied to the mesoscale 
!    circulation at this level (kk) from the current source level (k), 
!    normalized by the anvil fractional area, to the array accumulating
!    this tracer source (temptr). this array will be used in the 
!    calculation of tracer deposition in the mesoscale updraft.
!    add the rate of tracer input to the current layer kk from 
!    the current source layer k to the accumulation array (wtp). if the
!    current model layer extends beyond the top of the mesoscale 
!    updraft, pro-rate the contribution by the ratio of pressure depths.
!--------------------------------------------------------------------
            if (do_donner_tracer) then
              do kcont=1,ntr
                temptr(kk,kcont) = temptr(kk,kcont) + (q1t(kcont)/  &
                                   (2.* ampta1))
                if (phalf_c(kk+1) <= pctm) then
                  wtp(kk,kcont) = wtp(kk,kcont) +   &
                                  (q1t(kcont)/Param%meso_lifetime)*  &
                                  (phalf_c(kk)-pctm)/   &
                                              (phalf_c(kk)-phalf_c(kk+1))
                else
                  wtp(kk,kcont) = wtp(kk,kcont) +   &
                                  (q1t(kcont)/Param%meso_lifetime)
                endif
              end do
            endif
          end do

!--------------------------------------------------------------------
!    if in diagnostics column, output the moisture and tracer sources
!    to the mesoscale from the convective scale.
!--------------------------------------------------------------------
          if (debug_ijt) then
            do kk=k,nlev_lsm
              if (phalf_c(kk) < pctm) exit        
              write (diag_unit, '(a, i4, f19.10)') &
                            'in meens: jj,pr= ',kk,pfull_c(kk)
              write (diag_unit, '(a, i4, 3e20.12)')  &
                  'in meens: jj,q1,tempq,wmm= ',kk,q1,tempq(kk),wmms(kk)
              write (diag_unit, '(a, e20.12)')  &
                   'in meens: wmp= ',wmps(kk)
              write (diag_unit, '(a, i4, e20.12)')  &
                   'in meens: jj,tempqa= ',kk,tempqa(kk)
            end do
            write (diag_unit, '(a, i4, 3e20.12)')  &
                  'in meens: jk,q1,tempq,wmm= ',k,q1,tempq(k),wmms(k)
            write (diag_unit, '(a, i4, 2e20.12)')  &
                   'in meens: jk,wmp,owm= ',k,wmps(k),owm(k)
          endif
        endif ! (owm(k) < 0.)

!----------------------------------------------------------------------
!    if in diagnostics column, output the profile of moisture made
!    available to the mesoscale circulation by the cumulus updraft (owm)
!    and the amount deposited in each level (wmps).
!----------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, i4, 2e20.12)')  &
                        'in meens: jk,wmp,owm= ',k,wmps(k),owm(k)
        endif

!----------------------------------------------------------------------
!    add the  source level value to the array accumulating the  profile
!    of total updraft source at each level (wmps). the if loop prevents
!    the inclusion of moisture which is available but above the top of 
!    the mesoscale updraft (the level of zero bupoyancy usually).  wmps
!    will only be non-zero at layers within the mesoscale updraft, 
!    but owm may be non-zero in layers above the updraft.
!--------------------------------------------------------------------
        if (wmps(k) /= 0.0) then
          wmps(k) = wmps(k) + owm(k)
          if (do_donner_tracer) then
            wtp(k,:) = wtp(k,:) + otm(k,:)
          endif
        endif
      end do   ! (end of k loop)

!--------------------------------------------------------------------
!    convert various moisture rates from kg(h2o) / kg(air) / sec to
!    g(h2o) / kg(air) / day.
!--------------------------------------------------------------------
      owm(:)  = owm(:)*8.64e07

!---------------------------------------------------------------------
!     calculate the portion of redistributed water vapor that condenses.
!     cycle until lowest level within the region of mesoscale circ-
!     ulation is reached. exit the loop when have marched past top of 
!     the mesoscale circulation.
!---------------------------------------------------------------------
      do k=1,nlev_lsm
        if (phalf_c(k+1) > pzm) cycle
        if (phalf_c(k) < pztm) exit

!---------------------------------------------------------------------
!    determine if the current level is within the region of the meso-
!    scale circulation (between pzm and pztm).
!---------------------------------------------------------------------
        if ((phalf_c(k+1) <= pzm) .and. (phalf_c(k) >= pztm)) then

!---------------------------------------------------------------------
!    if so, define the top (pc2) of the current layer. deter-
!    mine the pressure level to which air in this layer will reach when
!    moving at the appropriate mesoscale updraft velocity for the dur-
!    ation of the mesoscale circulation (pctm). this level is limited to
!    be no higher than the top of the mesoscale circulation; if it is 
!    calculated to be higher, redefine the mesoscale updraft velocity 
!    for this layer so that the air in this layer will reach only to
!    the mesoscale circulation top, and no higher.
!---------------------------------------------------------------------
          pc2 = phalf_c(k+1)
          pctm = pc2 +Param%meso_ref_omega*Param%meso_lifetime
          if (pctm <= pztm)  then
            omer = (pztm - pc2)/Param%meso_lifetime
          else
            omer = Param%meso_ref_omega
          endif
          pctm = pc2 + omer*Param%meso_lifetime

!---------------------------------------------------------------------
!    define the temperature of the mesoscale updraft at this level.
!    determine its saturation vapor pressure and saturation mixing  
!    ratio. define saturation deficit
!    or excess relative to tempq(k), which is the mixing ratio in the 
!    mesoscale region (environmental mixing ratio plus source from 
!    cumulus updrafts). if there is a moisture excess (and thus conden-
!    sation must occur), define the condensation rate in the mesoscale
!    region, normalized over the mesoscale lifetime and its areal cover-
!    age. if only a portion of the layer is within the mesoscale updraft
!    region, adjust the mesoscale condensation rate appropriately.
!    if tempqa is greater than the saturation specific humidity (ERROR-
!    should be mixing ratio), reset it to the saturation value.
!---------------------------------------------------------------------
          ta = temp_c(k) + Param%tprime_meso_updrft
          call compute_mrs_k (ta, pfull_c(k), Param%d622 , Param%d608 ,&
                              mrsat, nbad)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (nbad /= 0) then
            ermesg = 'subroutine don_m_meso_updraft_k: '// &
                     'temperatures out of range of esat table'
            error = 1
            return
          endif

          q3 = mrsat - tempq(k)
          if (q3 <= 0.) then
            if (phalf_c(k+1) <= pctm)  then
              wmms(k) = (q3*ampta1/Param%meso_lifetime)*    &
                       (phalf_c(k) - pctm)/(phalf_c(k) - phalf_c(k+1))
            else
              wmms(k) = q3*ampta1/Param%meso_lifetime
            endif
          endif
          tempqa(k) = MIN (tempqa(k), mrsat)
        endif
      end do

!---------------------------------------------------------------------
!    determine the large-scale model full level at which parcel contain-
!    ing the water vapor at the base of the mesoscale updraft will reach
!    saturation and begin to condense (jsave).
!---------------------------------------------------------------------
      anv = 0.
      do k=1,nlev_lsm

!---------------------------------------------------------------------
!    determine the water vapor mixing ratio at the base of the mesoscale
!    updraft (qref).
!---------------------------------------------------------------------
        if (pfull_c(k) > pzm) cycle       
        if (anv == 0.) qref = tempqa(k)
        anv = 1.
        if (pfull_c(k) < pztm) exit        

!---------------------------------------------------------------------
!    define the temperature of the mesoscale updraft at this level.
!    determine its saturation vapor pressure and saturation specific
!    humidity. NOTE: should be mixing RATIO. define the level at which
!    mesoscale updraft condensation begins as the current level, in 
!    case the loop will be exited.
!---------------------------------------------------------------------
        te = temp_c(k) + Param%tprime_meso_updrft
        call compute_mrs_k (te, pfull_c(k), Param%d622 , Param%d608 , &
                            mrsat, nbad, mr = qref)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (nbad /= 0) then
          ermesg = 'subroutine don_m_meso_updraft_k: '// &
                   'temperatures out of range of esat table'
          error = 1
          return
        endif

        jsave = k

!---------------------------------------------------------------------
!    if in diagnostics column, output the values of saturation mixing  
!    ratio (mrsat) and mixing ratio in the mesoscale region (tempqa).
!---------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, 2e20.12)')  &
                          'in meens: qs,tempqa= ',mrsat,tempqa(k)
        endif

!---------------------------------------------------------------------
!    if there is a saturation excess at this level then exit, saving the
!    level index as jsave. this is the level at which condensation  in
!    the mesoscale updraft will begin.
!---------------------------------------------------------------------
        if (qref >= mrsat) exit      
      end do

!---------------------------------------------------------------------
!    define the  ???????
!!    What is the 6 ?? how is it related to the 8 below in the omd
!!    definition ???
!---------------------------------------------------------------------
      alp = 6.*Param%meso_ref_omega/((pzm - pztm)**2)

      omv = 0.

!---------------------------------------------------------------------
!    define the forcing terms associated with mesoscale updrafts.
!---------------------------------------------------------------------
      do k=1,nlev_lsm

!-------------------------------------------------------------------
!    if the current level is below the base of the mesoscale updraft,
!    cycle. if the current level is above the top of the mesoscale 
!    updraft, exit the loop.
!-------------------------------------------------------------------
        if (pfull_c(k) .gt. pzm) cycle       
        if (pfull_c(k) .lt. pztm) exit

!--------------------------------------------------------------------
!    define the limits of the current layer, modified from the large-
!    scale model levels when the mesoscale updraft region starts or ends
!    within the layer.
!--------------------------------------------------------------------
        pp = phalf_c(k+1)
        pm = phalf_c(k)
        if (phalf_c(k+1) < pztm) pp = pztm
        if (phalf_c(k) > pzm) pm = pzm

!---------------------------------------------------------------------
!    calculate mesoscale vertical velocity profile.
!---------------------------------------------------------------------
        omv(k) = (pzm + pztm)*((pp**2) - (pm**2))/2.
        omv(k) =  omv(k) - (((pp**3) - (pm**3))/3.)
        omv(k) = omv(k) - pztm*pzm*(pp - pm)
        omv(k) = omv(k)/(phalf_c(k+1) - phalf_c(k))
        omv(k) = omv(k)*alp

!---------------------------------------------------------------------
!    calculate mesoscale entropy-flux convergence. analytic integration
!    used, possible only because mesoscale temperature perturbation is 
!    not function of pressure. see "Vertical Velocity in Mesoscale 
!    Cloud" notes, 11/12/91.
!---------------------------------------------------------------------
        tmes_up(k) = (pzm + pztm)*(Param%rdgas - Param%cp_air)*  &
                     (pp - pm)/Param%cp_air
        tmes_up(k) = tmes_up(k) + ((2.*Param%cp_air - Param%rdgas)*  &
                     ((pp**2) - (pm**2))/(2.*Param%cp_air))
        tmes_up(k) = tmes_up(k) - (Param%rdgas*pztm*pzm/Param%cp_air)* &
                     alog(pp/pm)
        tmes_up(k) = tmes_up(k)/(phalf_c(k+1) - phalf_c(k))
        tmes_up(k) = tmes_up(k)*ampta1*Param%tprime_meso_updrft*alp

!--------------------------------------------------------------------
!    if currently below the level at which condensation in the meso-
!    scale updraft begins, cycle until that level is reached.
!--------------------------------------------------------------------
        if (k < jsave) cycle      

!--------------------------------------------------------------------
!    if into the region where deposition occurs, define the appropriate
!    above and below indices for boundary levels.
!--------------------------------------------------------------------
        if (k == 1) then
          jkm = k
        else
          jkm = k - 1
        endif
        if (k == nlev_lsm) then
          jkp = k
        else
          jkp = k + 1
        endif

!--------------------------------------------------------------------
!    define the temperature of the mesoscale updraft (te). define the
!    associated saturation vapor pressure and specific humidity (ERROR 
!    !!!).
!--------------------------------------------------------------------
        te = temp_c(k) + Param%tprime_meso_updrft
        call compute_mrs_k (te, pfull_c(k), Param%d622 , Param%d608 ,&
                              tempqa(k), nbad)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (nbad /= 0) then
          ermesg = 'subroutine don_m_meso_updraft_k: '// &
                   'temperatures out of range of esat table'
          error = 1
          return
        endif

!--------------------------------------------------------------------
!    if an excess of vapor is present and deposition should occur, 
!    define the mesoscale updraft temperature at the next higher level 
!    (tep). 
!--------------------------------------------------------------------
        if (qref >= tempqa(k)) then
          tep = temp_c(jkp) + Param%tprime_meso_updrft

!--------------------------------------------------------------------
!    if the next higher level is no longer in the mesoscale updraft 
!    layer, define the deposition rate in the mesoscale updraft at 
!    level k as the vapor flux divergence between layer k-1 and layer k.
!--------------------------------------------------------------------
          if (pfull_c(jkp) <= pztm) then
            cmu(k) = -omv(k)*(tempqa(k) - tempqa(jkm))/ &
                     (pfull_c(k) - pfull_c(jkm))

!--------------------------------------------------------------------
!     if level k is the lowest level within the condensation region,
!     determine the saturation specific humidity (ERROR !!!) at the
!     next higher level. define the deposition rate in the mesoscale  
!     updraft at level k as the vapor flux divergence between level k 
!     and level k+1. redefine qref as the amount of vapor remaining
!     in the parcel at the jkp level.
!--------------------------------------------------------------------
          else if (k == jsave) then
            call compute_mrs_k (tep, pfull_c(jkp), Param%d622 , &
                                Param%d608 , tempqa(jkp), nbad)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
            if (nbad /= 0) then
              ermesg = 'subroutine don_m_meso_updraft_k: '// &
                       'temperatures out of range of esat table'
              error = 1
              return
            endif

            cmu(k) = -omv(k)*(tempqa(jkp) - tempqa(k))/  &
                     (pfull_c(jkp) - pfull_c(k))
            qref = tempqa(jkp)

!--------------------------------------------------------------------
!     if level k is within the condensation region, determine the  
!     saturation specific humidity (ERROR !!!) at the next higher level.
!     define the deposition rate in the mesoscale updraft at level k as
!     the vapor flux divergence between level k-1 and level k+1. 
!     redefine qref as the amount of vapor remaining in the parcel at 
!     the jkp level.
!--------------------------------------------------------------------
          else
            call compute_mrs_k (tep, pfull_c(jkp), Param%d622 , &
                                Param%d608 , tempqa(jkp), nbad)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
            if (nbad /= 0) then
              ermesg = 'subroutine don_m_meso_updraft_k: '// &
                       'temperatures out of range of esat table'
              error = 1
              return
            endif

            cmu(k) = -omv(k)*(tempqa(jkp) - tempqa(jkm))/ &
                     (pfull_c(jkp) - pfull_c(jkm))
            qref = tempqa(jkp)
          endif

!---------------------------------------------------------------------
!    make certain that the deposition rate is non-negative.
!---------------------------------------------------------------------
          if (cmu(k) < 0.) cmu(k) = 0.

!---------------------------------------------------------------------
!    if there is insufficient moisture for deposition, set the depo-
!    sition rate to 0.0.
!---------------------------------------------------------------------
        else
          cmu(k) = 0.
        endif

!---------------------------------------------------------------------
!    convert the deposition rate to g(h2o) / kg(air) / day. multiply
!    by the anvil area (ampta1) to obtain a grid-box-mean value of the
!    deposition rate.
!---------------------------------------------------------------------
        cmu(k) = cmu(k)*ampta1*8.64e07

!--------------------------------------------------------------------
!    if in diagnostics column, output the environmental temperature
!    (temp_c) and the mesoscale vertical velocity (omv).
!--------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, i4, f20.14, e20.12)') &
                      'in meens: jk,t,omv= ', k, temp_c(k), omv(k)
        endif
      end do

!---------------------------------------------------------------------
!    calculate the mesoscale moisture-flux and tracer-flux convergence.
!---------------------------------------------------------------------
      do k=1,nlev_lsm 

!---------------------------------------------------------------------
!    if the current level is above the mesoscale updraft, exit the loop.
!    if the next level is still below the base of the mesoscale updraft,
!    cycle to the end of the loop.
!---------------------------------------------------------------------
        if (phalf_c(k) .lt. pztm) exit       
        if (phalf_c(k+1) .gt. pzm) cycle      

!--------------------------------------------------------------------
!    define the appropriate above and below indices for boundary levels.
!--------------------------------------------------------------------
        if (k == 1) then
          jkm = k
        else
          jkm = k - 1
        endif
        if (k == nlev_lsm) then
          jkp = k
        else
          jkp = k + 1
        endif

!---------------------------------------------------------------------
!    define the difference between the environmental vapor mixing ratio 
!    and that in the mesoscale updraft at the two half-levels bracketing
!    the current level.
!---------------------------------------------------------------------
        qprip = (tempqa(jkp) + tempqa(k) -    &
                             mixing_ratio_c(jkp) - mixing_ratio_c(k))/2.
        qprim = (tempqa(k) + tempqa(jkm) -    &
                             mixing_ratio_c(k) - mixing_ratio_c(jkm))/2.

!---------------------------------------------------------------------
!    define the difference between the environmental tracer mixing 
!    ratios and those in the mesoscale updraft at the two half-levels 
!    bracketing the current level.
!---------------------------------------------------------------------
        if (do_donner_tracer) then
          do kcont=1,ntr
            qtprip = (temptr(jkp,kcont) + temptr(k,kcont) - &
                      tracers_c(jkp,kcont) - tracers_c(k,kcont))/2.
            qtprim = (temptr(k,kcont) + temptr(jkm,kcont) -  &
                      tracers_c(k,kcont) - tracers_c(jkm,kcont))/2.
            eqtfp = ampta1*qtprip*alp*(phalf_c(k+1) - pztm)*  &
                    (pzm - phalf_c(k+1))
            eqtfm = ampta1*qtprim*alp*(phalf_c(k) - pztm)*  &
                    (pzm - phalf_c(k))
            if ((phalf_c(k) <= pzm) .and. (phalf_c(k+1) >= pztm)) then
              qtmes(k,kcont) = (eqtfm - eqtfp)/   &
                                              (phalf_c(k+1) - phalf_c(k))
            endif
            if ((pzm <= phalf_c(k)) .and. (pzm >= phalf_c(k+1))) then
              qtmes(k,kcont) = eqtfp/(phalf_c(k) - phalf_c(k+1))
            endif
            if ((pztm >= phalf_c(k+1)) .and. (pztm <= phalf_c(k))) then
              qtmes(k,kcont) = eqtfm/(phalf_c(k+1) - phalf_c(k))
              if ((pzm <= phalf_c(k)) .and. (pzm >= phalf_c(k+1))) then
                qtmes(k,kcont) = 0.
              endif
            endif ! ((pztm >= phalf_c(k+1)) .and. (pztm <= phalf_c(k)))
          end do
        endif

!-------------------------------------------------------------------
!    define the
!-------------------------------------------------------------------
        eqfp = ampta1*qprip*alp*(phalf_c(k+1) - pztm)*   &
                                                    (pzm - phalf_c(k+1))
        eqfm = ampta1*qprim*alp*(phalf_c(k) - pztm)*(pzm - phalf_c(k))
        if ((phalf_c(k) <= pzm) .and. (phalf_c(k+1) >= pztm)) then
          mrmes_up(k) = (eqfm - eqfp)/(phalf_c(k+1) - phalf_c(k))
        endif
        if ((pzm <= phalf_c(k)) .and. (pzm >= phalf_c(k+1))) then
          mrmes_up(k) = eqfp/(phalf_c(k) - phalf_c(k+1))
        endif
        if ((pztm >= phalf_c(k+1)) .and. (pztm <= phalf_c(k))) then
          mrmes_up(k) = eqfm/(phalf_c(k+1) - phalf_c(k))
          if ((pzm <= phalf_c(k)) .and. (pzm >= phalf_c(k+1))) then
            mrmes_up(k) = 0.
          endif
        endif ! ((pztm .ge. phalf_c(k+1)) .and. (pztm .le. phalf_c(k)))

!---------------------------------------------------------------------
!    if in diagnostics column,  output the entropy     (tmes) and
!    specific humidity (?)(mrmes) tendencies due to the mesoscale
!    updraft.
!---------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, i4, f19.10, f20.14, e20.12)')   &
                  'in meens: jk,pr,tmes,qmes= ', k, pfull_c(k),  &
                   tmes_up(k), mrmes_up(k)
        endif
      end do

!---------------------------------------------------------------------
!    calculate the eddy flux of moist static energy in mesoscale
!    updraft (hflux) and identify its minimum (hfmin).
!---------------------------------------------------------------------
      hfmin = 0.
      do jk=1,nlev_lsm
!---------------------------------------------------------------------
!    if the current level is above the mesoscale updraft, exit the loop.
!    if the next level is still below the base of the mesoscale updraft,
!    cycle to the end of the loop.
!---------------------------------------------------------------------
        if (pfull_c(jk) .lt. pztm) exit      
        if (pfull_c(jk) .gt. pzm) cycle      

!--------------------------------------------------------------------
!    define the temperature of the mesoscale updraft (tmu). define the
!    associated saturation vapor pressure and specific humidity (ERROR 
!    !!!).
!--------------------------------------------------------------------
        tmu = temp_c(jk) + Param%TPRIME_MESO_UPDRFT
        call compute_mrs_k (tmu, pfull_c(jk), Param%d622 , &
                                Param%d608 , qmu, nbad)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (nbad /= 0) then
          ermesg = 'subroutine don_m_meso_updraft_k: '// &
                   'temperatures out of range of esat table'
          error = 1
          return
        endif

!---------------------------------------------------------------------
!    define the eddy flux of moist static energy in the mesoscale 
!    updraft (hflux). retain the minimum value in the profile (hfmin)
!    and its pressure level (pfmin).
!---------------------------------------------------------------------
        hflux = omv(jk)*(((Param%cp_air*Param%tprime_meso_updrft ) + &
                                 Param%hlv*(qmu - mixing_ratio_c(jk))))
        if (hflux < hfmin) then
          hfmin = hflux      
          pfmin = pfull_c(jk)
        endif
      end do

!---------------------------------------------------------------------
!    if in a diagnostics column, output the minimum of the eddy moist 
!    static energy flux and its level.
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12)')  &
                        'in meens: hfmin,pfmin= ', hfmin, pfmin
      endif

!---------------------------------------------------------------------
!    define the mesoscale fractional area (cumh) in the region of the 
!    mesoscale updraft. 
!---------------------------------------------------------------------
      do k=1,nlev_hires
        if ((p_hires(k) <= pzm) .and. (p_hires(k) >= pztm))  then
          cumh(k) = ampta1
        else
          cumh(k) = 0.0 
        endif
      end do

!---------------------------------------------------------------------
!    call map_hi_res_col_to_lo_res_col to map the mesoscale anvil area 
!    from the cloud model to the large-scale 
!    model.
!---------------------------------------------------------------------
      call don_u_map_hires_c_to_lores_c_k  &
           (nlev_lsm, nlev_hires, cumh, p_hires, pztm + dp, phalf_c, &
            meso_cloud_area, rintsum, rintsum2, ermesg, error) 
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12)')  &
            'in meens: rintsum(cuml) =', rintsum, rintsum2
        call don_u_compare_integrals_k   &
             (rintsum, rintsum2, diag_unit, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return
      endif

!---------------------------------------------------------------------
!    define the upward mass flux associated with the mesoscale 
!    circulation. 
!---------------------------------------------------------------------
      do k=1,nlev_lsm
        umeml(k) = -omv(k)*ampta1/Param%grav  
        wmms(k)  = wmms(k)*8.64e07
        wmps(k)  = wmps(k)*8.64e07
      end do

!---------------------------------------------------------------------
!    obtain column integrals of deposition rate in the mesoscale (cmui),
!    convective updraft condensation (wmc), cell to mesoscale moisture
!    transfer (wpc), and the moisture made available to the mesoscale
!    by the cumulus updraft (owms). convert to units of mm / day.
!---------------------------------------------------------------------
      cmui = 0.
      wmc  = 0.
      wpc  = 0.
      owms = 0.
      do k=1,nlev_lsm
        wmc  = wmc  + wmms(k)*(phalf_c(k) - phalf_c(k+1))
        owms = owms + owm(k)*(phalf_c(k) - phalf_c(k+1))
        wpc  = wpc  + wmps(k)*(phalf_c(k) - phalf_c(k+1))
        cmui = cmui + cmu(k)*(phalf_c(k) - phalf_c(k+1))
      end do
      wmc  = wmc/(Param%grav*1000.)
      wpc  = wpc/(Param%grav*1000.)
      owms = owms/(Param%grav*1000.)
      cmui = cmui/(Param%grav*1000.)

!---------------------------------------------------------------------
!    if in diagnostics column, output the column-integral moisture 
!    conversion rates (wmc, wpc, owms, cmui). 
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, e20.12,a,a,e20.12,a)')  &
               'in meens: wmc=', wmc, ' mm/day', ' wpc=', wpc, 'mm/day'
        write (diag_unit, '(a, e20.12, a, a, e20.12, a)')  &
               'in meens: owms= ', owms, ' mm/day', ' cmui= ',   &
                        cmui, 'mm/day'
      endif

!---------------------------------------------------------------------
!    calculate precipitation resulting from the mesoscale circulation.
!    define the total additional condensate supplied to the column
!    by the mesoscale circulation, the sum of the deposition (wmc) and
!    additional condensation (cmui). 
!---------------------------------------------------------------------
      cmui = cmui - wmc

!--------------------------------------------------------------------


end subroutine don_m_meso_updraft_k



!#####################################################################

subroutine don_m_meso_downdraft_k    &
         (nlev_lsm, nlev_hires, diag_unit, debug_ijt, Param, Nml, &
          p_hires, pfull_c, temp_c, mixing_ratio_c, phalf_c, pb, &
          ampta1, dp, pztm, pzm, alp, hfmin, pmd, tmes_dn, mrmes_dn, &
          dmeml, ermesg, error)

!-------------------------------------------------------------------
!    subroutine meens computes the mesoscale effects of the composited
!    cloud ensemble on the heat, moisture and tracer budgets, producing
!    tendency terms which are to be applied to the large-scale model.
!    scheme employed here is a variation on procedure of Leary and 
!    Houze (JAS, 1980). for more details on notation, see 
!    "Cu Closure A notes," 2/97.
!-------------------------------------------------------------------

use donner_types_mod, only : donner_param_type, donner_nml_type
use sat_vapor_pres_k_mod, only: compute_mrs_k

implicit none

!-------------------------------------------------------------------
integer,                       intent(in)   :: nlev_lsm, nlev_hires, &
                                               diag_unit
logical,                       intent(in)   :: debug_ijt        
type(donner_param_type),       intent(in)   :: Param
type(donner_nml_type),         intent(in)   :: Nml  
real,   dimension(nlev_hires), intent(in)   :: p_hires
real,   dimension(nlev_lsm),   intent(in)   :: pfull_c, temp_c,  &
                                               mixing_ratio_c
real,   dimension(nlev_lsm+1), intent(in)   :: phalf_c
real,                          intent(in)   :: pb, ampta1, dp, pztm, &
                                               pzm, alp, hfmin 
real,                          intent(out)  :: pmd
real,   dimension(nlev_lsm),   intent(out)  :: tmes_dn, mrmes_dn, dmeml
character(len=*),              intent(out)  :: ermesg
integer,                       intent(out)  :: error

!---------------------------------------------------------------------
!   local variables:

      real, dimension(nlev_hires)     :: dmemh
      real, dimension(nlev_lsm)       :: tempt, tempqa
      real, dimension(nlev_lsm+1)     :: emt, emq

!     real :: qlo
      real    ::  es, mrsat, c2, c3, c1, fjk, fjkm, qb, fjkb, qbm, qmd, &
                  qsmd, fjkmd, qmmd, pi, psa, targ, tprimd, tb, qten, tten, &
                  omd, mrsb, wa, wb, tmd, rin, rintsum, rintsum2
      integer :: ncmd
      integer :: jksave, k, nbad

!----------------------------------------------------------------------

      ermesg = ' ' ; error = 0

      tmes_dn = 0.
      mrmes_dn = 0.
      tempt(:) = temp_c(:)
      emt(:) = 0.
      emq(:) = 0.
      tempqa(:) = mixing_ratio_c(:)

!---------------------------------------------------------------------
!    define the top of the mesoscale downdraft (pmd). it is assumed to 
!    be meso_sep Pa below the base of the mesoscale updraft. (no meso-
!    scale motion is assumed between the base of the mesoscale updraft 
!    and the top of the mesoscale downdraft.) make certain it is not 
!    below the surface.
!---------------------------------------------------------------------
      pmd = MIN(pzm + Param%meso_sep, phalf_c(1))
      ncmd = 1
      do k=1,nlev_hires         
        if (p_hires(k) < pmd ) then
          ncmd = k + 1
          exit
        endif
      end do

!---------------------------------------------------------------------
!    calculate mesoscale downdraft speed (omd) at top of mesoscale 
!    downdraft (pmd). follow Leary and Houze (1980,JAS) and set 
!    magnitude to half that in mesoscale updraft; this vertical pressure
!    velocity assumed constant with ht between pzm and cloud base (pb). 
!---------------------------------------------------------------------
      omd = -alp*((pzm-pztm)**2)/8.
      omd = omd/2.

!--------------------------------------------------------------------
!    calculate temperature and specific humidity in mesoscale
!    downdraft. 
!---------------------------------------------------------------------
      do k=1,nlev_lsm

!---------------------------------------------------------------------
!    if the current level is above the top of the mesoscale downdraft, 
!    exit the loop. if the level is below cloud base, cycle to the end
!    of the loop.
!---------------------------------------------------------------------
        if (pfull_c(k) < pmd) exit      
        if (pfull_c(k) > pb) cycle      

!---------------------------------------------------------------------
!    calculate c2, the relative humidity in the mesoscale downdraft,
!    after Table 3 of Leary and Houze (1980, JAS).
!---------------------------------------------------------------------
        c2 = 1. - (.3*(pfull_c(k) - pmd)/(pb - pmd))

!---------------------------------------------------------------------
!    calculate c3, the factor which yields the eddy flux of moist
!    static energy when multiplied by the minimum of moist static
!    energy in the mesoscale updraft. Multiply by 1.3 to take account
!    of convective downdrafts. See Fig. 7 of Leary and Houze
!    (1980,JAS).
!---------------------------------------------------------------------
        c3 = (pfull_c(k) - pmd)/(pb - pmd)
        c3 = 1.3*c3

!---------------------------------------------------------------------
!    see "Moist Static Energy A, 1/26/91" notes.
!---------------------------------------------------------------------
        targ = temp_c(k)
        call compute_mrs_k (targ, pfull_c(k), Param%d622 , &
                                Param%d608 , mrsat, nbad, esat=es)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (nbad /= 0) then
          ermesg = 'subroutine don_m_meso_downdraft_k: '// &
                   'temperatures out of range of esat table'
          error = 1
          return
        endif

        c1 = Param%d622*Param%hlv*es/   &
                                 (pfull_c(k)*Param%rvgas*(temp_c(k)**2))
        tprimd = c3*hfmin/omd
        tprimd = tprimd - Param%hlv*(c2*mrsat - mixing_ratio_c(k))
        tprimd = tprimd/(Param%cp_air + Param%hlv*c1*c2)
        tempt(k) = temp_c(k) + tprimd
        targ = tempt(k)
        call compute_mrs_k (targ, pfull_c(k), Param%d622 , &
                                Param%d608 , tempqa(k), nbad)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (nbad /= 0) then
          ermesg = 'subroutine don_m_meso_downdraft_k: '// &
                   'temperatures out of range of esat table'
          error = 1
          return
        endif

        tempqa(k) = c2*tempqa(k)

!---------------------------------------------------------------------
!    if in diagnostics column, output 
!---------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, 4e20.12)')  &
                    'in meens: tprimd,tempqa,q,qs= ',tprimd,   &
                    tempqa(k), mixing_ratio_c(k), mrsat
          write (diag_unit, '(a, f19.10, 2e20.12)')  &
                    'in meens: pr,rh,factr= ', pfull_c(k), c2, c3
        endif
      end do

!---------------------------------------------------------------------
!    calculate eddy fluxes of potential temperature and specific
!    humidity in mesoscale downdraft.
!---------------------------------------------------------------------
      do k=2,nlev_lsm-1

!---------------------------------------------------------------------
!    if the current level is above the top of the mesoscale downdraft, 
!    exit the loop. if the level is below cloud base, cycle to the end
!    of the loop.
!---------------------------------------------------------------------
        if (phalf_c(k) .lt. pmd) exit
        if (phalf_c(k) .gt. pb) cycle        

!---------------------------------------------------------------------
!    calculate potential temperature and specific humidity (?) fluxes
!    for pressure levels between cloud base and top of mesoscale down-
!    draft.
!---------------------------------------------------------------------
        if ((pfull_c(k-1) <= pb) .and. (pfull_c(k) >= pmd)) then
          fjk = ampta1*omd*((Param%ref_press/pfull_c(k))**     &
                   (Param%rdgas/Param%cp_air))*(tempt(k) - temp_c(k))    
          fjkm = ampta1*omd*((Param%ref_press/pfull_c(k-1))**  &
                   (Param%rdgas/Param%cp_air))*(tempt(k-1) - temp_c(k-1))
          emt(k) = (fjk + fjkm)/2.
          fjk = ampta1*omd*(tempqa(k) - mixing_ratio_c(k))
          fjkm = ampta1*omd*(tempqa(k-1) - mixing_ratio_c(k-1))
          emq(k) = (fjk + fjkm)/2.
        endif

!---------------------------------------------------------------------
!    calculate potential temperature and specific humidity (?) fluxes
!    for pressure levels below cloud base.
!---------------------------------------------------------------------
        if (pfull_c(k-1) >= pb) then
          fjk = ampta1*omd*((Param%ref_press/pfull_c(k))**   &
                 (Param%rdgas/Param%cp_air))*(tempt(k) - temp_c(k))
          call don_u_lo1d_to_hi0d_linear_k  &
               (nlev_lsm, mixing_ratio_c, pfull_c, pb, qb, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (error /= 0 ) return

          if (debug_ijt   ) then
            write (diag_unit, '(a, i4, f19.10, f20.14)')  &
                           'in polat: k,p,x=', k, pb, qb
          endif
          call don_u_lo1d_to_hi0d_linear_k  &
               (nlev_lsm, temp_c, pfull_c, pb, tb, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (error /= 0 ) return

          if (debug_ijt   ) then
            write (diag_unit, '(a, i4, f19.10, f20.14)')  &
                      'in polat: k,p,x=', k, pb, tb
          endif
        call compute_mrs_k (tb, pb, Param%d622 , &
                                Param%d608 , mrsb, nbad, esat=es)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (nbad /= 0) then
            ermesg = 'subroutine don_m_meso_downdraft_k: '// &
                     'temperatures out of range of esat table'
            error = 1
            return
          endif

          tprimd = hfmin/omd
          tprimd = tprimd - Param%hlv*(.7*mrsb - qb)
          c1 = Param%D622  *Param%hlv*es/(pb*Param%rvgas*(tb**2))
          tprimd = tprimd/(Param%cp_air + .7*Param%hlv*c1)
          fjkb = ampta1*omd*((Param%ref_press/pb)**      &
                                    (Param%rdgas/Param%cp_air))*tprimd
          wa = (phalf_c(k) - pfull_c(k))/(pb - pfull_c(k))
          wb = (pb - phalf_c(k))/(pb - pfull_c(k))
          emt(k) = wa*fjkb + wb*fjk
          fjk = ampta1*omd*(tempqa(k) - mixing_ratio_C(k))
          targ = tb + tprimd
          call compute_mrs_k (targ, pb, Param%d622 , &
                                Param%d608 , qbm, nbad)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (nbad /= 0) then
            ermesg = 'subroutine don_m_meso_downdraft_k: '// &
                     'temperatures out of range of esat table'
            error = 1
            return
          endif

          qbm = .7*qbm   
          fjkb = ampta1*omd*(qbm - qb)
          emq(k) = wa*fjkb + wb*fjk
        endif

!---------------------------------------------------------------------
!    calculate potential temperature and specific humidity (?) fluxes
!    for pressure levels at or above the top of the mesoscale downdraft.
!---------------------------------------------------------------------
        if (pfull_c(k) <= pmd) then
          fjkm = ampta1*omd*((Param%ref_press/pfull_c(k-1))**    &
                 (Param%rdgas/Param%cp_air))*(tempt(k-1) - temp_c(k-1))
          call don_u_lo1d_to_hi0d_linear_k  &
               (nlev_lsm, mixing_ratio_c, pfull_c, pmd, qmd, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (error /= 0 ) return

          if (debug_ijt) then
            write (diag_unit, '(a, i4, f19.10, f20.14)')  &
                      'in polat: k,p,x=', k, pmd, qmd
          endif
          call don_u_lo1d_to_hi0d_linear_k  &
               (nlev_lsm, temp_c, pfull_c, pmd, tmd, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (error /= 0 ) return

          if (debug_ijt   ) then
            write (diag_unit, '(a, i4, f19.10, f20.14)')  &
                      'in polat: k,p,x=', k, pmd, tmd
          endif
          call compute_mrs_k (tmd, pmd, Param%d622 , &
                                Param%d608 , qsmd, nbad, esat=es)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (nbad /= 0) then
            ermesg = 'subroutine don_m_meso_downdraft_k: '// &
                     'temperatures out of range of esat table'
            error = 1
            return
          endif

          c1 = Param%d622*Param%hlv*es/(pmd*Param%rvgas*(tmd**2))
          tprimd = -Param%hlv*(qsmd - qmd)/(Param%cp_air + Param%hlv*c1)
          fjkmd = ampta1*omd*((Param%ref_press/pmd)**   &
                                     (Param%rdgas/Param%cp_air))*tprimd
          wa = (pfull_c(k-1) - phalf_c(k))/(pfull_c(k-1) - pmd)
          wb = (phalf_c(k) - pmd)/(pfull_c(k-1) - pmd)
          emt(k) = fjkmd*wa + fjkm*wb
          targ = tmd + tprimd
          call compute_mrs_k (targ, pmd, Param%d622 , &
                                Param%d608 , qmmd, nbad)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
          if (nbad /= 0) then
            ermesg = 'subroutine don_m_meso_downdraft_k: '// &
                     'temperatures out of range of esat table'
            error = 1
            return
          endif

          fjkm = ampta1*omd*(tempqa(k-1) - mixing_ratio_c(k-1))
          fjkmd = ampta1*omd*(qmmd - qmd)
          emq(k) = fjkmd*wa + fjkm*wb
        endif

!---------------------------------------------------------------------
!    if in diagnostics column, output the potential temprature and
!    specific humidity fluxes associated with the mesoscale downdrafts.
!---------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, i4, 3e20.12)')  &
                        'in meens: jk,phr,emt,emq= ', k ,phalf_c(k),   &
                         emt(k), emq(k)
        endif

!---------------------------------------------------------------------
!    convert the potential temperature flux to a temperature flux.
!---------------------------------------------------------------------
! RSH : unneeded, causes error
!       emt(k) = ((Param%ref_press/pfull_c(k))**     &
!                                    (Param%rdgas/Param%cp_air))*emt(k)
      end do  ! (end of k loop)

!---------------------------------------------------------------------
!    calculate temperature and specific humidity tendencies due
!    to eddy-flux convergences in mesoscale downdraft.
!---------------------------------------------------------------------
      rin = 0.
      do k=nlev_lsm,1, -1

!---------------------------------------------------------------------
!    define the index of the base of the mesoscale updraft (jksave).
!---------------------------------------------------------------------
        if ((phalf_c(k+1) <= pzm) .and. (phalf_c(k) >= pzm))   &
                                                         jksave = k + 1
        pi = (Param%ref_press/pfull_c(k))**(Param%rdgas/Param%cp_air)
        if ((emt(k+1) /= 0.) .and. (emt(k) == 0.) .and.    &
            (rin == 0.)) then
          tten = -emt(k+1)/(phalf_c(k+1) - phalf_c(1))
          qten = -emq(k+1)/(phalf_c(k+1) - phalf_c(1))
          rin = 1.
        endif
        if (rin == 1.) then
          
          if (.not. Nml%frc_internal_enthalpy_conserv) then
            tmes_dn(k) = tmes_dn(k) + (tten/pi)
          endif
          mrmes_dn(k) = mrmes_dn(k) + qten
        endif
        if ((rin == 0.) .and. (emt(k+1) /= 0.) .and.   &
            (emt(k) /= 0.)) then
          tten = (emt(k+1) - emt(k))/(phalf_c(k+1) - phalf_c(k))
          tten = -tten/pi
          qten = (emq(k+1) - emq(k))/(phalf_c(k+1) - phalf_c(k))
          qten = -qten
          tmes_dn(k) = tmes_dn(k) + tten
          mrmes_dn(k) = mrmes_dn(k) + qten
        endif

!---------------------------------------------------------------------
!    if in diagnostics column,  output the entropy     (tmes) and
!    specific humidity (?)(mrmes) tendencies due to the mesoscale
!    downdraft.
!---------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, i4, f19.10, f20.14, e20.12)')   &
                    'in meens: jk,pr,tmes,qmes= ', k, pfull_c(k),  &
                     tmes_dn(k), mrmes_dn(k)
        endif
      end do

!---------------------------------------------------------------------
!    define the temperature (tten)and moisture (qten) tendencies result-
!    ing from the mesoscale downdraft that are to be applied to the 
!    layers between the top of mesoscale downdraft (where emt is 
!    non-zero, saved as psa), and the base of the mesoscale updraft 
!    given by phalf_c(jksave).
!---------------------------------------------------------------------
      psa = 0.
      do k=1,nlev_lsm
        if ((emt(k) /= 0.) .and. (emt(k+1) == 0.)) then
          tten = emt(k)/(phalf_c(jksave) - phalf_c(k))
          qten = emq(k)/(phalf_c(jksave) - phalf_c(k))
          psa = phalf_c(k)
        endif
      end do

!---------------------------------------------------------------------
!    if in diagnostcs column, output the pressures at the top of the
!    mesoscale downdraft (pmd) and at cloud base (pb).
!---------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 2f19.10)')  &
                                 'in meens: pmd,pb= ', pmd, pb
      endif

!--------------------------------------------------------------------
!    apply these tendencies to the levels between top of mesoscale
!    downdraft and base of mesoscale updraft.
!--------------------------------------------------------------------
      do k=1,nlev_lsm
        if ((pfull_c(k) <= psa) .and.    &
            (pfull_c(k) >= phalf_c(jksave))) then

!---------------------------------------------------------------------
!    if in diagnostcs column, output the pressure bounds of this region
!    (psa, phalf_c(jksave), the tendencies applied (qten, tten), and the 
!    large-scale model entropy     and moisture tendencies 
!    (mrmes, tmes) prior to the addition of these terms. 
!---------------------------------------------------------------------
          if (debug_ijt) then
            write (diag_unit, '(a, 3e20.12)')  &
                   'in meens: po,psa,phr(jksave)= ',  &
                           Param%REF_PRESS, psa, phalf_c(jksave)
            write (diag_unit, '(a, i4, 2e20.12)')  &
                       'in meens: jk,qmes,qten= ', k, mrmes_dn(k), qten
            write (diag_unit, '(a, i4, 2e20.12)')  &
                           'in meens: jk,tmes,tten= ', k, tmes_dn(k), tten
          endif

!---------------------------------------------------------------------
!    update the moisture and entropy tendencies.
!---------------------------------------------------------------------
          mrmes_dn(k) = mrmes_dn(k) + qten
!!! ISN't emt (and therefore tten) already temperature tendency rather 
!   than theta, and so the conversion here is unnecessary ??
          pi=(Param%ref_press/pfull_c(k))**(Param%rdgas/Param%cp_air)
          tmes_dn(k) = tmes_dn(k) + (tten/pi)
        endif
      end do

!---------------------------------------------------------------------
!    define the mass flux of the mesoscale down-
!    draft (dmemh) in the region of the mesoscale downdraft.
!---------------------------------------------------------------------
      do k=1,nlev_hires
        if ((p_hires(k) <= pb) .and. (p_hires(k) >= pmd))  then
          dmemh(k) = -omd*ampta1/Param%grav  
        else
          dmemh(k) = 0.
        endif
      end do

!---------------------------------------------------------------------
!    call map_hi_res_col_to_lo_res_col to map the 
!    mesoscale downdraft flux from the cloud model to the large-scale 
!    model.
!---------------------------------------------------------------------
      call don_u_map_hires_c_to_lores_c_k  &
           (nlev_lsm, nlev_hires, dmemh, p_hires, pmd + dp, phalf_c, &
            dmeml, rintsum, rintsum2, ermesg, error) 
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12)')  &
            'in meens: rintsum(dmeml) =', rintsum , rintsum2
        call don_u_compare_integrals_k  &
             (rintsum, rintsum2, diag_unit, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (error /= 0 ) return
      endif

!---------------------------------------------------------------------


end subroutine don_m_meso_downdraft_k



!####################################################################

subroutine don_m_meso_evap_k    &
         (nlev_lsm, diag_unit, debug_ijt, Param, available_condensate,&
          available_condensate_liq, available_condensate_ice, &
          pzm, pztm, phalf_c, emdi_liq, emdi_ice,      &
          emds_liq, emds_ice, emes_liq, emes_ice, ermesg, error)

!---------------------------------------------------------------------
!    subroutine meso_evap calculates the sublimation associated with
!    the mesoscale circulation and partitions both the updraft- and
!    downdraft-induced sublimation within the column.
!---------------------------------------------------------------------

use donner_types_mod, only : donner_param_type

implicit none

!---------------------------------------------------------------------
integer,                     intent(in)  :: nlev_lsm
integer ,                    intent(in)  :: diag_unit
logical ,                    intent(in)  :: debug_ijt 
type(donner_param_type),     intent(in)  :: Param
real,                        intent(in)  :: available_condensate,  &
                                            available_condensate_liq,  &
                                            available_condensate_ice,  &
                                            pzm, pztm
real, dimension(nlev_lsm+1), intent(in)  :: phalf_c
real,                        intent(out) ::       emdi_liq, emdi_ice
real, dimension(nlev_lsm),   intent(out) :: emds_liq, emds_ice
real, dimension(nlev_lsm),   intent(out) :: emes_liq, emes_ice
character(len=128),          intent(out) :: ermesg
integer,                     intent(out) :: error

!--------------------------------------------------------------------
!   intent(in) variables:
!
!       available_condensate      total condensate available in the
!                                 anvil [ mm(h2o) / day ]
!       pzm                       pressure at base of mesoscale updraft
!                                 [ Pa ]
!       pztm                      pressure at top of mesoscale updraft
!                                 [ Pa ]
!       phalf_c                   pressures at large-scale model inter-
!                                 face levels [ Pa ]
!       diag_unit                 output unit number for this 
!                                 diagnostics column
!       debug_ijt                 is this a diagnostics column ?
!
!   intent(out) variables:
!
!       emdi                      vertical integral of mesoscale down-
!                                 draft sublimation [ mm (h2o) / day ]
!       emds                      water mass sublimated in mesoscale
!                                 downdraft [ g(h2o) / (kg(air) day) ] 
!       emes                      water mass sublimated in mesoscale
!                                 updraft [ g(h2o) / (kg(air) day) ] 
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:
!
!       emei                      vertical integral of mesoscale updraft
!                                 sublimation [ mm (h2o) / day ]
!       emea                      vertical integral of mesoscale updraft
!                                 sublimation [ g(h2o) / (kg(air) day) ]




     real    ::                   pm, pp, pbot_meso_sub
     real  :: emei_liq, emei_ice, emea_liq, emea_ice
     real  :: emda_liq, emda_ice
     integer :: k


      ermesg = ' ' ; error = 0
      emes_liq = 0.
      emes_ice = 0.

!---------------------------------------------------------------------
!    define the rate of total water sublimation in the mesoscale updraft
!    (emei) using the Leary and Houze coefficient.
!---------------------------------------------------------------------
      emei_liq = Param%meso_up_evap_fraction*available_condensate_liq
      emei_ice = Param%meso_up_evap_fraction*available_condensate_ice

!----------------------------------------------------------------------
!    convert the integral of mesoscale updraft evaporation from mm (h20)
!    per day to g(h2o) / (kg(air) / day (emea). updraft evaporation is 
!    assumed to occur between base of mesoscale updraft (pzm) and the 
!    top of mesoscale updraft (pztm) at a uniform rate. 
!---------------------------------------------------------------------- 
      emea_liq = emei_liq*Param%grav*1000./(pzm - pztm)
      emea_ice = emei_ice*Param%grav*1000./(pzm - pztm)

!--------------------------------------------------------------------
!    if in diagnostics column, output the column integral mesoscale
!    updraft evaporation, in units of both mm / day (emei) and 
!    g(h2o) / kg(air) / day (emea), and the pressures defining the
!    mesoscale updraft region (pzm, pztm).
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, 2e20.12)')  &
                         'in meens: emea,emei= ',emea_liq + emea_ice, &
                                                  emei_liq + emei_ice
        write (diag_unit, '(a, 2e20.12)')  &
                         'in meens: LIQemea,emei= ',emea_liq, emei_liq
        write (diag_unit, '(a, 2e20.12)')  &
                         'in meens: ICEemea,emei= ',emea_ice, emei_ice
        write (diag_unit, '(a, 2f19.10)')  &
                         'in meens: pzm, pztm= ',pzm, pztm
      endif

!---------------------------------------------------------------------
!    call map_hi_res_intgl_to_lo_res_col to distribute the integrated 
!    mesoscale updraft sublimation (emea) within the mesoscale updraft
!    region (pzm -> pztm) of the large-scale model column whose layers
!    are defined by interface pressure array phalf_c.
!---------------------------------------------------------------------
      call don_u_map_hires_i_to_lores_c_k &
           (nlev_lsm, emea_liq, pzm, pztm, phalf_c, emes_liq, ermesg, error)
      call don_u_map_hires_i_to_lores_c_k &
           (nlev_lsm, emea_ice, pzm, pztm, phalf_c, emes_ice, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

!----------------------------------------------------------------------
!    if in a diagnostics column, output the mesoscale updraft sublim-
!    ation profile (emes) at those levels where it is non-zero.
!----------------------------------------------------------------------
      if (debug_ijt) then
        do k=1,nlev_lsm           
          if ((emes_liq(k) + emes_ice(k)) /= 0.0) then
            write (diag_unit, '(a, i4, e20.12)') &
                   'in cm_intgl_to_gcm_col: k,x= ',k,emes_liq(k) + &
                                                       emes_ice(k)
          endif
        end do
      endif

!---------------------------------------------------------------------
!    define the rate of total water sublimation in the mesoscale down-
!    draft (emdi) using the Leary and Houze coefficient.
!---------------------------------------------------------------------
      emdi_liq = Param%meso_down_evap_fraction*available_condensate_liq
      emdi_ice = Param%meso_down_evap_fraction*available_condensate_ice

!----------------------------------------------------------------------
!    convert the integral of mesoscale downdraft sublimation from mm 
!    (h20) per day to g(h2o) / (kg(air) / day (emda). downdraft sublim- 
!    ation is assumed to occur between base of mesoscale updraft (pzm)
!    and pressure pbot_meso_sub at a uniform rate.
!---------------------------------------------------------------------- 
      pbot_meso_sub = phalf_c(1)
      emda_liq = emdi_liq*Param%grav*1000./(pbot_meso_sub - pzm)
      emda_ice = emdi_ice*Param%grav*1000./(pbot_meso_sub - pzm)

!----------------------------------------------------------------------
!    distribute the integrated downdraft sublimation over the approp-
!    riate large-scale model layers.
!----------------------------------------------------------------------
      emds_liq = 0.
      emds_ice = 0.
      do k=1,nlev_lsm            

!---------------------------------------------------------------------
!    if the current level is above the base of the mesoscale updraft, 
!    exit the loop. if the level is below the surface, cycle to the end
!    of the loop.
!---------------------------------------------------------------------
        if (phalf_c(k) < pzm) exit
        if (phalf_c(k+1) > pbot_meso_sub ) cycle
        pm = phalf_c(k)
        pp = phalf_c(k+1)
        if ((phalf_c(k) >= pbot_meso_sub) .and.    &
            (phalf_c(k+1) <= pbot_meso_sub ) )  then
          pm = phalf_c(1) 
        endif
        if ((phalf_c(k) >= pzm) .and. (phalf_c(k+1) <= pzm))  pp = pzm
        emds_liq(k) = emda_liq*(pm - pp)*(pm + pp - 2.*pbot_meso_sub)
        emds_ice(k) = emda_ice*(pm - pp)*(pm + pp - 2.*pbot_meso_sub)

!--------------------------------------------------------------------
!    if in diagnostics column, output the column integral mesoscale
!    downdraft evaporation (emda) and the amount assigned to each layer
!    (emds), in units of g(h2o) / kg(air) / day.
!--------------------------------------------------------------------
        if (debug_ijt) then
          write (diag_unit, '(a, i4, 2e20.12)')  &
               'in meens: jk,emda,emd= ', k, emda_liq + emda_ice,  &
                                          emds_liq(k) + emds_ice(k)
          write (diag_unit, '(a, i4, 2e20.12)')  &
                  'in meens: jk,LIQemda,emd= ', k, emda_liq, emds_liq(k)
          write (diag_unit, '(a, i4, 2e20.12)')  &
                 'in meens: jk,ICEemda,emd= ', k, emda_ice, emds_ice(k)
        endif

!---------------------------------------------------------------------
!    
!---------------------------------------------------------------------
        emds_liq(k) = emds_liq(k)/((phalf_c(k) - phalf_c(k+1))*    &
                  (pzm - pbot_meso_sub))
        emds_ice(k) = emds_ice(k)/((phalf_c(k) - phalf_c(k+1))*    &
                  (pzm - pbot_meso_sub))
        if (debug_ijt) then
          write (diag_unit, '(a, i4, 2e20.12)')  &
            'in meens: FINALjk,emda,emd= ', k, emda_liq + emda_ice,   &
                                             emds_liq(k) + emds_ice(k)
        endif
      end do

!--------------------------------------------------------------------
!    if in diagnostics column, output the column integral mesoscale
!    downdraft evaporation in units of mm / day (emdi) and the surface
!    pressure (ps).
!--------------------------------------------------------------------
      if (debug_ijt) then
        write (diag_unit, '(a, e20.12, f19.10)')  &
              'in meens: emdi,ps= ', emdi_liq + emdi_ice, pbot_meso_sub
        write (diag_unit, '(a, e20.12, f19.10)')  &
                    'in meens: LIQemdi,ps= ', emdi_liq, pbot_meso_sub
        write (diag_unit, '(a, e20.12, f19.10)')  &
                    'in meens: ICEemdi,ps= ', emdi_ice, pbot_meso_sub
      endif

!---------------------------------------------------------------------


end subroutine don_m_meso_evap_k



!######################################################################

subroutine don_m_meso_melt_k   &
         (nlev_lsm, diag_unit, debug_ijt, Param, temp_c, phalf_c,  &
          pztm, meso_precip, pb, anvil_precip_melt, ermesg, error)

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------

use donner_types_mod, only : donner_param_type

implicit none

!----------------------------------------------------------------------
integer,                     intent(in)  :: nlev_lsm
integer,                     intent(in)  :: diag_unit
logical,                     intent(in)  :: debug_ijt 
type(donner_param_type),     intent(in)  :: Param
real, dimension(nlev_lsm),   intent(in)  :: temp_c
real, dimension(nlev_lsm+1), intent(in)  :: phalf_c
real,                        intent(in)  :: pztm, meso_precip, pb
real, dimension(nlev_lsm),   intent(out) :: anvil_precip_melt
character(len=*),            intent(out) :: ermesg
integer,                     intent(out) :: error

  
      real  ::  p2, rma
      integer :: k

      anvil_precip_melt = 0.
      ermesg = ' ' ; error = 0

!--------------------------------------------------------------------
!    define the pressure at the melting level (p2).
!--------------------------------------------------------------------
      p2 = -10.
      do k=1,nlev_lsm-1
        if (phalf_c(k+1) < pztm ) exit
        if ((temp_c(k) >= Param%kelvin) .and.   &
             (temp_c(k+1) <= Param%kelvin))  then
          p2 = phalf_c(k+1)
          exit
        end if
      end do

!---------------------------------------------------------------------
!    define the rate of melting (mm/day)of anvil precipitation as it 
!    falls between the melting level (p2) and cloud base (pb). if there
!    is a melting level, all anvil precip is assumed to melt.
!---------------------------------------------------------------------
      if (p2 .ne. -10.) then
        rma = meso_precip
      else
        rma = 0.
      endif

!---------------------------------------------------------------------
!    convert the melting rate in mm / day (rm) to g(h2o) / kg(air) /day
!    (rma).
!---------------------------------------------------------------------
      rma = -rma*Param%grav*1000./(pb - p2)

!--------------------------------------------------------------------
!    if there is a melting level, map the melting rate uniformly across
!    the region of melting (melting level to cloud base). if there is
!    no melting level in the cloud, anvil_precip_melt is set to 0.0.
!--------------------------------------------------------------------
      if (pb > p2) then
        if (debug_ijt) then
          write (diag_unit, '(a, e20.12, 2f19.10)')  &
                     'in cm_intgl_to_gcm_col: xav,p1,p2= ',-rma, pb, p2
        endif
        call don_u_map_hires_i_to_lores_c_k  &
             (nlev_lsm, rma, pb, p2, phalf_c, anvil_precip_melt, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (error /= 0 ) return

        if (debug_ijt) then
          do k=1,nlev_lsm               
            if (anvil_precip_melt(k) /= 0.0) then
              write (diag_unit, '(a, i4, e20.12)') &
                'in cm_intgl_to_gcm_col: k,x= ',k,-anvil_precip_melt(k)
            endif
          end do
        endif
      else                           
        anvil_precip_melt = 0.0
      endif

!---------------------------------------------------------------------

end subroutine don_m_meso_melt_k 



!#####################################################################

subroutine don_m_define_anvil_ice_k   &
         (isize, jsize, nlev_lsm, Param, Col_diag, pfull, temp,       &
          exit_flag, Don_conv, ermesg, error)

!----------------------------------------------------------------------
!    subroutine define_anvil_ice obtains the anvil ice profile
!    (Don_conv%xice) and the corresponding effective ice crystal size 
!    profile (Don_conv%dgeice).
!----------------------------------------------------------------------

use donner_types_mod, only : donner_param_type, donner_conv_type, &
                             donner_column_diag_type

implicit none

!-----------------------------------------------------------------------
integer,                               intent(in)    :: isize, jsize,   &
                                                        nlev_lsm
type(donner_param_type),               intent(in)    :: Param
type(donner_column_diag_type),         intent(in)    :: Col_diag
real, dimension(isize,jsize,nlev_lsm), intent(in)    :: pfull, temp
logical, dimension(isize,jsize),       intent(in)    :: exit_flag      
type(donner_conv_type),                intent(inout) :: Don_conv
character(len=*),                      intent(out)   :: ermesg
integer,                               intent(out)   :: error
            
!---------------------------------------------------------------------
!   intent(in) variables:
!
!     is, ie         first and last values of i index values of points 
!                    in this physics window (processor coordinates)
!     js, je         first and last values of j index values of points 
!                    in this physics window (processor coordinates)
!     pfull          pressure at model full levels [ Pa ]
!     temp           temperature at model full levels [ deg K ]
!     total_precip   total convective-system precipitation [ mm / day ]
!
!   intent(inout) variables:
!
!     Don_conv
!
!----------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:
  
     integer :: anvil_top_indx ! vertical index of highest model level
                               ! containing anvil ice 
     integer :: anvil_bot_indx ! vertical index of lowest model level
                               ! containing anvil ice 
     integer :: i, j, k, n     ! do-loop indices


!--------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!---------------------------------------------------------------------
!    if column diagnostics are desired and there is mesoscale cloud 
!    present, output the mesoscale cloud area (ampta1), the mesoscale
!    downdraft sublimation integral (emdi), 
!---------------------------------------------------------------------
      if (Col_diag%in_diagnostics_window) then
        do n=1,Col_diag%ncols_in_window
          if (Don_conv%ampta1(Col_diag%i_dc(n),   &
                              Col_diag%j_dc(n)) /= 0.0) then
            write (Col_diag%unit_dc(n), '(a, 2e20.12)')   &
                     'pre prean: ampta1, emdi, contot, tprei', &
                  Don_conv%ampta1 (Col_diag%i_dc(n),Col_diag%j_dc(n)), &
                  Don_conv%emdi_v    (Col_diag%i_dc(n),Col_diag%j_dc(n))
          endif
        end do
      endif

!--------------------------------------------------------------------
!    determine the vertical ice distribution and the effective ice 
!    size at each level.
!--------------------------------------------------------------------
      do j=1,jsize
        do i=1,isize
          if (.not. exit_flag(i,j)) then
!---------------------------------------------------------------------
!    call subroutine prean to assign the anvil ice content to the 
!    appropriate model layers. if there is no anvil in the column
!    (i.e., no mesoscale area, no mesoscale precip, no mesoscale down-
!    draft sublimation, no total precip), set the ice profile to be 0.0 
!    throughout the column.
!---------------------------------------------------------------------
            if (Don_conv%ampta1(i,j) > 0.0 .and.  &
                Don_conv%emdi_v(i,j) > 0.0 .and.  &
                Don_conv%meso_precip(i,j) > 0.0) then
              call don_m_prean_k   &
                   (i, j, nlev_lsm, Param, Col_diag, &
                    Don_conv%ampta1(i,j), Don_conv%meso_precip(i,j),&
                    Don_conv%emdi_v(i,j), pfull(i,j,:),  &
                    Don_conv%umeml(i,j,:), temp(i,j,:),   &
                    Don_conv%xice(i,j,:), ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
              if (error /= 0 ) return
            else
              Don_conv%xice(i,j,:) = 0.0      
            endif

!!! ANVIL ICE EXTENDS WELL BELOW FREEZING LEVEL  ?????
!!! BEGINS AT BASE OF MESOSCALE UPDRAFT WHICH IS NOT CONSTRAINED TO 
!!! BE AT OR BELOW FREEZING ??
           
!--------------------------------------------------------------------
!    determine the pressure at the top of the anvil (prztm). this will 
!    be the lowest model level pressure at which ice is present. at 
!    levels above this, set the effective ice size to 0.0.
!--------------------------------------------------------------------
            do k=1,nlev_lsm
              anvil_top_indx  = k 
              if ((Don_conv%xice(i,j,k) >= 1.0E-10)) then 
                Don_conv%prztm(i,j) = pfull(i,j,k)
                exit 
              endif
            end do

!--------------------------------------------------------------------
!    determine the pressure at the bottom of the anvil (przm). this 
!    will be the highest model level pressure at which ice is present.
!--------------------------------------------------------------------
            do k=anvil_top_indx+1,nlev_lsm
              if ((Don_conv%xice(i,j,k) < 1.0E-11) ) then
                Don_conv%przm(i,j) = pfull(i,j,k-1)
                anvil_bot_indx = k-1
                exit
              endif
            end do
          else
            Don_conv%xice(i,j,:) = 0.0      
            Don_conv%przm(i,j) = 0.0              
            Don_conv%prztm(i,j) = 0.0            
          endif
        end do
      end do

!---------------------------------------------------------------------
!    if column diagnostics are desired, output the level index, the 
!    pressure and the amount of ice at those levels at which ice is
!    present.
!---------------------------------------------------------------------
      if (Col_diag%in_diagnostics_window) then
        do n=1,Col_diag%ncols_in_window
          do k=1,nlev_lsm
            if (Don_conv%xice(Col_diag%i_dc(n),  &
                              Col_diag%j_dc(n),k) > 0.0) then
              write (Col_diag%unit_dc(n), '(a, i4, e10.3, e20.12)')  &
                    'post prean: pressure, xice', &
                    k, pfull(Col_diag%i_dc(n), Col_diag%j_dc(n),k),    &
                    Don_conv%xice(Col_diag%i_dc(n), Col_diag%j_dc(n),k) 
            endif
          end do
        end do
      endif

!---------------------------------------------------------------------



end subroutine don_m_define_anvil_ice_k

!#####################################################################

subroutine don_m_prean_k     &
         (i, j, nlev_lsm, Param, Col_diag, ampta1_s, meso_precip_s,  &
          emdi_s, pfull_c, umeml_c, temp_c, xice_c, ermesg, error)

!---------------------------------------------------------------------
!    subroutine prean calculates the ice content assigned to the model
!    layers with an upward mesoscale mass flux.
!     Leo Donner
!     GFDL
!     17 May 2001
!---------------------------------------------------------------------
 
use donner_types_mod, only : donner_param_type, donner_column_diag_type

implicit none

!---------------------------------------------------------------------
integer,                       intent(in)  :: i, j, nlev_lsm
type(donner_param_type),       intent(in)  :: Param
type(donner_column_diag_type), intent(in)  :: Col_diag
real,                          intent(in)  :: ampta1_s, meso_precip_s, &
                                              emdi_s
real, dimension(nlev_lsm),     intent(in)  :: pfull_c, umeml_c, temp_c
real, dimension(nlev_lsm),     intent(out) :: xice_c 
character(len=*),              intent(out) :: ermesg
integer,                       intent(out) :: error

!-------------------------------------------------------------------
!   intent(in) variables:
!
!      i, j        horizontal coordinates of current column
!      ampta1_s    fractional area of mesoscale circulation
!                  [ fraction ]
!      emdi_s      vertical integral of  mesoscale-downdraft 
!                  sublimation [ mm / day ]
!      tprei       total convective-system precipitation [ mm / day ]
!      pfull_c     pressure at full model levels [ Pa ]
!      umeml_c     mesoscale updraft mass flux  [ kg / (m**2 sec) ]
!      temp_c      temperature at model full levels [ deg K ]
!
!   intent(out) variables:
!
!      xice_c      anvil ice [ kg(ice) / kg(air) ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!  local variables:
 
      real      :: rho       !  height-averaged anvil air density 
                             !  [ kg/ (m**3) ]
      real      :: xicet     !  anvil ice work variable 
                             !  [ kg(ice) / kg (air) ]
      integer   :: kou       !  counter
      integer   :: k, kk, n  !  do-loop indices

!---------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!---------------------------------------------------------------------
!    sum up the air density in the anvil layers.
!---------------------------------------------------------------------
      rho = 0.
      kou = 0
      do k=1,nlev_lsm             
        if (umeml_c(k) /= 0.) then
          kou = kou + 1
!  SHOULD virtual temp be used in defining this density ??
          rho = rho + pfull_c(k)/(Param%rdgas*temp_c(k))
        endif
      end do

!--------------------------------------------------------------------
!    if an anvil exists, determine the ice content of its layers.
!--------------------------------------------------------------------
      if (kou /= 0) then  

!--------------------------------------------------------------------
!    define the mean air density in the anvil region.
!--------------------------------------------------------------------
        rho = rho/kou

!----------------------------------------------------------------------
!    calculate the mesoscale ice content by balancing the fallout at 
!    anvil base with the mesoscale precipitation and the sublimation 
!    in the mesoscale downdraft.
!---------------------------------------------------------------------
!----------------------------------------------------------------------
!    sum up the anvil precipitation and the mesoscale downdraft sub-
!    limation (xicet).
!----------------------------------------------------------------------
        xicet = (meso_precip_s/86400.) + (emdi_s/86400.)
!!!???????????   DON'T KNOW THIS EXPRESSION ????
        xicet=xicet/(3.29*ampta1_s)
        xicet=xicet**.862
        xicet=xicet/rho

!----------------------------------------------------------------------
!    assign anvil ice to all layers with postive mesoscale updraft mass
!    flux.
!---------------------------------------------------------------------
        do k=1,nlev_lsm            
          if (umeml_c(k) > 0.) then
            xice_c(k) = xicet
          else
            xice_c(k) = 0.
          endif
        end do

!---------------------------------------------------------------------
!   if in diagnostics column, output the variables related to the
!   mesoscale ice content.
!---------------------------------------------------------------------
        if (Col_diag%in_diagnostics_window) then
          do n=1,Col_diag%ncols_in_window
            if (j == Col_diag%j_dc(n) .and. i == Col_diag%i_dc(n)) then
              do k=1, nlev_lsm            
                if (xice_c(k) > 0.00) then
                  write (Col_diag%unit_dc(n), '(a, 2e22.12)') &
                        'prean ampu,contot,emdi=', ampta1_s,  emdi_s
                  write (Col_diag%unit_dc(n), '(a, 1e22.12, i5)') &
                              'rho,     kou= ',rho,     kou
                  do kk=1,nlev_lsm           
                    if (xice_c(kk) > 0.00) then
                      write (Col_diag%unit_dc(n), '(a, i5, 2e22.12)') &
                                'k,prf,xice= ',kk,pfull_c(kk),xice_c(kk)
                      write (Col_diag%unit_dc(n), '(a, i5, 2e22.12)') &
                                 'k,prf,trf= ',kk,pfull_c(kk),temp_c(kk)
                      write (Col_diag%unit_dc(n), '(a, i5, 2e22.12)') &
                                   'k,prf,rmuf= ',kk,pfull_c(kk),umeml_c(kk)
                       write (Col_diag%unit_dc(n), '(a, i5, 2e22.12)') &
                     'k, grid box mean meso_precip_s, emdi_s = ', &
                        kk, meso_precip_s, emdi_s
                       write (Col_diag%unit_dc(n), '(a, i5, 2e22.12)') &
  'k,meso_precip_s, cloud area normalized xice in cloud (g / m**3) = ',&
                   kk, meso_precip_s,     &
        xice_c(kk)*ampta1_s*1.0e03*pfull_c(kk)/(temp_c(kk)*Param%rdgas)
                    endif
                  end do
                  exit
                endif
              end do
            endif
          end do
        endif

!---------------------------------------------------------------------
!    if there are no layers with positive mesoscale mass flux, set the
!    ice content at all levels to be 0.0.
!---------------------------------------------------------------------
      else
        xice_c(:) = 0.0
      endif

!--------------------------------------------------------------------


end subroutine don_m_prean_k



!######################################################################

#include <fms_platform.h>

! ----------------------------------------------------------------
!                   GNU General Public License                        
! This file is a part of MOM.                                                                 
!                                                                      
! MOM is free software; you can redistribute it and/or modify it and  
! are expected to follow the terms of the GNU General Public License  
! as published by the Free Software Foundation; either version 2 of   
! the License, or (at your option) any later version.                 
!                                                                      
! MOM is distributed in the hope that it will be useful, but WITHOUT    
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
! License for more details.                                           
!                                                                      
! For the full text of the GNU General Public License,                
! write to: Free Software Foundation, Inc.,                           
!           675 Mass Ave, Cambridge, MA 02139, USA.                   
! or see:   http://www.gnu.org/licenses/gpl.html                      
!-----------------------------------------------------------------------
! 
! <CONTACT EMAIL="Eric.Galbraith@mcgill.ca"> Eric Galbraith
! </CONTACT>
!
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Anand Gnanandesikan
! </CONTACT>
!
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Rick Slater
! </REVIEWER>
!
!<OVERVIEW>
!                    IDEALIZED OCEAN BIOGEOCHEMISTRY                        *
!                                                                           *
! An idealized biogeochemical cycling module, in which the ecosystem and    * 
! particles are treated implicitly. This is intended as a first-order       *
! complexity complement to more intricate ecosystem/biogeochemical models   *
! such as BLING, or the GFDL TOPAZ model.                                   *
!
! iBGC is not intended to simulate marine biogeochemistry in the most       *
! accurate sense possible - that is left to the more complex models.        *
! Instead, it is intended as a tool for basic research, being easily        *
! modified, simply understood, and readily used in idealized configurations.*
!
! Note that the model parameters are not particularly well tuned for any    *
! ocean model, and the user should feel free to alter anything as they see  * 
! fit.                                                                      *
! 
!</OVERVIEW>
!
!<DESCRIPTION>
!
!* Inorganic nutrients are incorporated into organic matter in the presence *
!* of light. Once in the organic pool, the nutrient elements are recycled   *
!* between organisms and labile reservoirs as long as light is present in   *
!* sufficient abundance to fuel continued growth. In the absence of light,  *
!* inorganic nutrients gradually accumulate once again. The ideal nutrient  *
!* tracers are intended to capture the fundamental dynamics of these        *
!* light-dependent inorganic-organic transitions, but in a very simple,     *
!* transparent way that depends only on the physical circulation and the    *
!* availability of PAR. Thus, they ignore the complexities of ecosystems,   *
!* in terms of uptake dynamics and remineralization pathways. Although this *
!* will certainly decrease their ability to reproduce the observed          *
!* distributions of nutrients in the ocean, they are computationally        *
!* inexpensive and easy to interpret, features which will hopefully give    *
!* them some utility.                                                       *

!* The simplest ideal nutrient tracer, ideal_n, is non-conservative,        *
!* designed to quickly approach  equilibrium (order 10 years), avoiding the *
!* need for long integrations. The slightly less straightforward,           *
!* conservative tracers are remineralized through the water column and      *
!* therefore approach steady state on much longer, multi-centennial         *
!* timescales.                                                              *
!*
!* The core behaviour of the ideal nutrients are given by the exponential,  *
!* exp(-IRR/IRRk). IRR is the available light (average SW radiation, in     *
!* W/m2, within the grid cell) and IRRk (in W/m2) determines the light      *
!* level at which the phytoplankton growth rate approaches saturation.      *
!* Thus, this term is 1 when IRR is 0, and approaches 0 as IRR increases. A *
!* larger value for IRRk causes the exponential to approach 0 more slowly,  *
!* ie. to saturate at a higher light level.                                 *
!*                                                                          
!* Uptake is determined by the product of the 1 minus the exponential term, *
!* a maximum uptake velocity (Vmax, in s-1), and limitation caused by the   *
!* concentration of the ideal nutrient itself, N (in mol kg-1):             *
!*                                                                          *
!* -Vmax * (1 - exp( -IRR / IRRk )) * (N / N + k)                           *
!*                                                                          *
!* The last term causes nutrient uptake to slow as the nutrient             *
!* concentration approaches 0, according to Michaelis-Menten dynamics.      *
!*                                                                          *
!* In ideal_n, regeneration is simply a constant rate, R.                   *
!*
!* Starting from this simple foundation, biogeochemical functionality is    *
!* added by creating a macronutrient (iPO4) with identical uptake to        *
!* ideal_n, but for which mass is conserved within the ocean. This is       *
!* achieved by separating the uptake into dissolved and particulate         *
!* organic matter, the latter of which is instantaneously remineralized     *
!* throughout the water column below according to a variant of the OCMPIP2  *
!* protocol. This calculates the remineralization rate at each level as a   *
!* function of the temperature, base remineralization rate, and sinking     *
!* rate (itself a function of depth). Any flux reaching the bottom box is   *
!* instantly remineralized there to conserve mass within the ocean.         *
!* Meanwhile, Dissolved Organic Phosphorus (iDOP) is transported within the *
!* ocean, decaying to PO4 at a temperature-dependent rate.                  *
!*
!* Given the apparent importance of iron (Fe) as a limiting micronutrient   *
!* in the oceans, it seemed interesting to try making another PO4 tracer,   * 
!* limited by Fe, in addition to the basic limitations given above: this is *
!* called iPO4f. The iron input is highly idealized, and the scavenging     *
!* function very simple, but iron-limitation develops and modulates         *
!* growth rate through iron-light colimitation in a way that may not be     *
!* totally unlike the real ocean. The Fe-limited PO4 cycle is completely    *
!* independent of the non-Fe-limited PO4, and they can be run on their own  *
!* or in parallel for comparison.
!*
!* A full biogeochemical simulation can then be made by selecting one of    *
!* the iPO4s as the central bgc variable (default is iPO4). Biological      * 
!* consumption and production of other quantities, including a number of    *
!* gases and idealized gas tracers, are then determined from the generally  *
!* reliable Redfield stoichiometries.                                       *
!*
!* Isotopic fractionations are simulated by multiplying the uptake rate of  *
!* the chemical species by the isotopic rate ratio, alpha. The tracer       *
!* concentrations of the heavy isotope species are actually                 *
!* equal to the true concentration divided by the isotopic ratio of the     *
!* standard, e.g. 15NO3 = [15NO3] * [14Nair] / [15Nair]. The true value in  *
!* permil is given by (15NO3 / NO3 - 1.) * 1000.                            *
!*
!* Dissolved gases are handled according to the OCMIP2 protocol. The air-   *
!* sea exchange code was taken from the ocmip2_abiotic and ocmip2_biotic    *
!* modules, with negligible modification. Note that the 14C implementation  *
!* differs from that of abiotic, in that biological uptake and remineraliz- *
!* ation of carbon impact the distribution of 14C, analagous to 15N.        *
!*
!* Chlorophyll is estimated diagnostically from the net bgc iPO4 (or iPO4f) *
!* uptake rate, with an adjustment for photoadaptation.
!
!
!    A general note on nomenclature
! Variables starting with 'j' are source/sink terms; jprod_x is the 
! biological production term for the quantity 'x'; jremin_x is the 
! remineralization rate of the quantity 'x'. Variables starting with 'fp' 
! are sinking particulate flux terms. Most of the 'i's stand for idealized,
! as in iBGC, and help to avoid duplication of arrays and tracer names used
! by TOPAZ and BLING, so that ibgc can be run in parallel with these other 
! models. Most of the 'p's stand for particulate, though a lot of them 
! stand for phosphorus. So, for example, jprod_pip is the production rate 
! of particulate idealized phosphorus through the uptake of iPO4.
!
! Tracer units are generally in mol kg-1, with some exceptions (suntan, 
! ideal_n, Fe).
!
! A general note on parameter values:
! Pretty much all of the parameter values were selected ad hoc, from very
! loose principles. They were not particularly well 'tuned' to match any
! given circulation model, though they gave reasonable results with the 
! 3-degree ocean model, om1p7. As such, the user should feel free to make 
! changes to the default values given here.
! Exceptions to this are: gas exchange parameters, radiocarbon decay, 
! nutrient stoichiometry, fractionation factors.

!</DESCRIPTION>
!
! <INFO>
! <REFERENCE>
! The basic nutrient uptake equations will be described in an upcoming paper
! by Galbraith et al. (in prep.). The remainder of the biogeochemistry 
! module may be documented more officially elsewhere. All are welcome to use
! ibgc model output for the purposes of publication; however, please contact
! Eric Galbraith (Eric.Galbraith@mcgill.ca) for the appropriate reference.
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_ibgc_nml">
!
!  <DATA NAME="do_ideal" TYPE="logical">
!  If true, then do ideal_n and suntan. This does not require any other
! part of the model.
!  </DATA> 
!
!  <DATA NAME="do_po4" TYPE="logical">
!  If true, then do the non-Fe-limited P cycle, iPO4 and iDOP. If either 
! this or do_po4f is true, PO4_pre and chl will be calculated as well. If 
! both do_po4 and do_po4f are true, po4 will be the master variable,
! unless bgc_felim is true.
!  </DATA> 
!
!  <DATA NAME="do_po4f" TYPE="logical">
!  If true, then do the Fe-limited P cycle, with iFe, iPO4f and DOP. If  
! either this or do_po4 is true, PO4_pre and chl will be calculated as well.
! If both do_po4 and do_po4f are true, po4 will be the master variable,
! unless do_bgc_felim is true.
!  </DATA> 
!
!  <DATA NAME="do_bgc_felim" TYPE="logical">
!  If true, then use PO4f as the master variable for biogeochemical 
! calculations (gases, PO4_pre, chl, isotopes). Requires that do_PO4f be true.
!  </DATA> 
!
!  <DATA NAME="do_gasses" TYPE="logical">
!  If true, then do the gases Dissolved Inorganic Carbon (iDIC) and oxygen 
! (iO2). Requires that do_po4 and/or do_po4f be true.
!  </DATA> 
!
!  <DATA NAME="do_carbon_comp" TYPE="logical">
!  If true, then do the dissolved inorganic carbon component tracers,  
! Saturation DIC (iDIC_sat) and preformed DIC (iDIC_pre). Requires
! that do_po4 and/or do_po4f be true, and that do_gasses be true.
!  </DATA> 
!
!  <DATA NAME="do_radiocarbon" TYPE="logical">
!  If true, then do the radiocarbon tracers (iDI14C and iDO14C). Requires
! that do_po4 and/or do_po4f be true, and that do_gasses be true. 
!  </DATA> 
!
!  <DATA NAME="do_isio4" TYPE="logical">
!  If true, then do silica cycle and silicon isotopes, iSiO4 and i30SiO4.
!  </DATA> 
!
!  <DATA NAME="do_no3_iso" TYPE="logical">
!  If true, then do NO3 isotopes, i15NO3, iN18O3 and iDO15N. Requires that
! do_po4 and/or do_po4f be true.
!  </DATA> 
!
!</NAMELIST>
!
!------------------------------------------------------------------
!
!       Module ocean_ibgc_mod
!
!------------------------------------------------------------------

module  ocean_ibgc_mod

use diag_manager_mod,         only: register_diag_field, diag_axis_init
use field_manager_mod,        only: fm_field_name_len, fm_path_name_len, fm_string_len
use field_manager_mod,        only: fm_get_length, fm_get_value, fm_new_value, fm_get_index
use mpp_mod,                  only: input_nml_file, stdout, stdlog, mpp_error, mpp_sum, mpp_chksum, FATAL, NOTE
use fms_mod,                  only: field_exist, file_exist
use fms_mod,                  only: open_namelist_file, check_nml_error, close_file
use fms_io_mod,               only: register_restart_field, save_restart, restore_state
use fms_io_mod,               only: restart_file_type
use time_manager_mod,         only: get_date, time_type, days_in_year, days_in_month
use time_interp_external_mod, only: time_interp_external, init_external_field
use mpp_domains_mod,          only: domain2d
use constants_mod,            only: WTMCO2, WTMO2

use ocean_tpm_util_mod,       only: otpm_set_tracer_package, otpm_set_prog_tracer, otpm_set_diag_tracer
use fm_util_mod,              only: fm_util_check_for_bad_fields, fm_util_set_value
use fm_util_mod,              only: fm_util_get_string, fm_util_get_logical, fm_util_get_integer, fm_util_get_real
use fm_util_mod,              only: fm_util_get_logical_array, fm_util_get_real_array, fm_util_get_string_array
use fm_util_mod,              only: fm_util_start_namelist, fm_util_end_namelist
use ocean_types_mod,          only: ocean_prog_tracer_type, ocean_diag_tracer_type
use ocean_types_mod,          only: ocean_thickness_type, ocean_density_type, ocean_time_type, ocean_grid_type
use ocmip2_co2calc_mod,       only: ocmip2_co2calc
use coupler_types_mod,        only: ind_alpha, ind_csurf, coupler_2d_bc_type, ind_flux
use atmos_ocean_fluxes_mod,   only: aof_set_coupler_flux
use ocean_util_mod,           only: diagnose_2d, diagnose_2d_comp, diagnose_3d_comp

implicit none

private

public  :: ocean_ibgc_bbc
public  :: ocean_ibgc_end
public  :: ocean_ibgc_init
public  :: ocean_ibgc_flux_init
public  :: ocean_ibgc_sbc
public  :: ocean_ibgc_source
public  :: ocean_ibgc_start
public  :: ocean_ibgc_init_sfc
public  :: ocean_ibgc_avg_sfc
public  :: ocean_ibgc_sum_sfc
public  :: ocean_ibgc_zero_sfc
public  :: ocean_ibgc_sfc_end
public  :: ocean_ibgc_tracer
public  :: ocean_ibgc_restart

private :: allocate_arrays

character(len=32), parameter              :: package_name = 'ocean_ibgc'
character(len=48), parameter              :: mod_name = 'ocean_ibgc_mod'
character(len=48), parameter              :: diag_name = 'ocean_ibgc'
character(len=fm_string_len), parameter   :: default_restart_file =  'ocean_ibgc.res.nc'
character(len=fm_string_len), parameter   :: default_local_restart_file =  'ocean_ibgc_local.res.nc'
character(len=fm_string_len), parameter   :: default_ice_restart_file   =    'ice_ibgc.res.nc'
character(len=fm_string_len), parameter   :: default_ocean_restart_file =  'ocean_ibgc_airsea_flux.res.nc'

! coefficients for O2 saturation
real, parameter :: a_0 = 2.00907
real, parameter :: a_1 = 3.22014
real, parameter :: a_2 = 4.05010
real, parameter :: a_3 = 4.94457
real, parameter :: a_4 = -2.56847e-01
real, parameter :: a_5 = 3.88767
real, parameter :: b_0 = -6.24523e-03
real, parameter :: b_1 = -7.37614e-03
real, parameter :: b_2 = -1.03410e-02
real, parameter :: b_3 = -8.17083e-03
real, parameter :: c_0 = -4.88682e-07

! Options

  logical :: do_ideal       = .true.  ! ideal_n and suntan
  logical :: do_po4         = .true.  ! incl PO4, DOP, PO4_pre
  logical :: do_gasses      = .true.  ! DIC, DI14C, O2 etc, requires po4 and/or po4f
  logical :: do_carbon_comp = .true.  ! use po4f for gases, PO4_pre, isotopes
  logical :: do_radiocarbon = .true.  ! use po4f for gases, PO4_pre, isotopes
  logical :: do_bgc_felim   = .true.  ! use po4f for gases, PO4_pre, isotopes
  logical :: do_po4f        = .true.  ! iFe and iron-limited PO4, DOP 
  logical :: do_isio4       = .true.  ! silica and d30Si
  logical :: do_no3_iso     = .true.  ! 15N and 18O of NO3

namelist /ocean_ibgc_nml/ do_ideal, do_po4, do_gasses, do_carbon_comp, do_radiocarbon, &
  do_bgc_felim, do_po4f, do_isio4, do_no3_iso

type ibgc_type

  real                                  :: kappa_eppley
  real                                  :: kappa_eppley_remin
  real                                  :: irrk

  real                                  :: ideal_n_vmax
  real                                  :: ideal_n_k
  real                                  :: ideal_n_r

  real                                  :: suntan_fade

  real                                  :: ipo4_vmax
  real                                  :: ipo4_k
  real                                  :: idop_frac
  real                                  :: gamma_idop
  real                                  :: gamma_ip 
  real                                  :: gamma_isi 
  real                                  :: sinking_init
  real                                  :: sinking_acc

  real                                  :: uptake_2_chl
  real                                  :: ichl_lag
  real                                  :: ichl_highlight

  real                                  :: ife_supply
  real                                  :: ligand_tot 
  real                                  :: ligand_k 
  real                                  :: scav_k 
  real                                  :: ipo4f_vmax
  real                                  :: ife_irrsuf 

!  real                                  :: alpha_12c_13c
  real                                  :: alpha_14n_15n
  real                                  :: alpha_28si_30si

  real                                  :: o2_2_ip
  real                                  :: io2_min

  real                                  :: half_life_14c
  real                                  :: lambda_14c
  real                                  :: alkbar
  real                                  :: si_2_ip
  real                                  :: c_2_ip
  real                                  :: sal_global
  real                                  :: frac_14catm_const = 0.0
  character(len=128)                    :: frac_14catm_file = ' '
  character(len=128)                    :: frac_14catm_name = ' '
  integer                               :: frac_14catm_id = 0

  real, _ALLOCATABLE, dimension(:,:,:)  :: jideal_n  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jsuntan  _NULL

  real, _ALLOCATABLE, dimension(:,:,:)  :: remin_ip  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: remin_isi  _NULL

  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_pisi  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: fpisi  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jremin_pisi  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_pi30si  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: fpi30si  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jremin_pi30si  _NULL

  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_pip  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_idop  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jremin_idop  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: fpip  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jremin_pip  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jife_new  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: felim_irrk  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_pipf  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_idopf  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jremin_idopf  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: fpipf  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jremin_pipf  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_pife  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: fpife  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jremin_pife  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: ife_free  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jife_scav  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jipo4  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jipo4f  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jipo4_bgc  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: ipo4_bgc  _NULL

  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_pi15n  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_ido15n  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jremin_ido15n  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: fpi15n  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jremin_pi15n  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: ji15no3  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_i18o  _NULL

  real, _ALLOCATABLE, dimension(:,:,:)  :: ichl_new  _NULL

  real, _ALLOCATABLE, dimension(:,:)    :: alpha  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: csurf  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: csatsurf  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: htotal  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: htotal_sat  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: alk  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: c14surf  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: frac_14catm  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: pco2surf  _NULL
  real, _ALLOCATABLE, dimension(:,:)    :: pco2satsurf  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jdecay_idi14c  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jdecay_ido14c  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_pi14c  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jprod_ido14c  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jremin_ido14c  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jremin_pi14c  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: fpi14c  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jidi14c  _NULL
  real, _ALLOCATABLE, dimension(:,:,:)  :: jio2  _NULL

  integer                               :: id_sc_co2 = -1
  integer                               :: id_sc_o2 = -1
  real, _ALLOCATABLE, dimension(:,:)    :: sc_co2  _NULL
  real                                  :: sc_co2_0
  real                                  :: sc_co2_1
  real                                  :: sc_co2_2
  real                                  :: sc_co2_3
  real, _ALLOCATABLE, dimension(:,:)    :: sc_o2  _NULL
  real                                  :: sc_o2_0
  real                                  :: sc_o2_1
  real                                  :: sc_o2_2
  real                                  :: sc_o2_3

  integer                               :: ind_irr = -1
  integer                               :: id_jideal_n = -1
  integer                               :: id_jsuntan = -1
  
  integer                               :: id_remin_ip = -1

  integer                               :: id_remin_isi = -1
  integer                               :: id_jprod_pisi = -1
  integer                               :: id_fpisi = -1
  integer                               :: id_jremin_pisi = -1
  integer                               :: id_jprod_pi30si = -1
  integer                               :: id_fpi30si = -1
  integer                               :: id_jremin_pi30si = -1

  integer                               :: id_jprod_pip = -1
  integer                               :: id_jprod_idop = -1
  integer                               :: id_jremin_idop = -1
  integer                               :: id_fpip = -1
  integer                               :: id_jremin_pip = -1
  integer                               :: id_jife_new = -1
  integer                               :: id_felim_irrk = -1
  integer                               :: id_jprod_pipf = -1
  integer                               :: id_jprod_idopf = -1
  integer                               :: id_jremin_idopf = -1
  integer                               :: id_fpipf = -1
  integer                               :: id_jremin_pipf = -1
  integer                               :: id_jprod_pife = -1
  integer                               :: id_fpife = -1
  integer                               :: id_jremin_pife = -1
  integer                               :: id_ife_free = -1
  integer                               :: id_jife_scav = -1
  integer                               :: id_jipo4 = -1
  integer                               :: id_jipo4f = -1
  integer                               :: id_jipo4_bgc = -1
  integer                               :: id_ipo4_bgc = -1

  integer                               :: id_jprod_pi15n = -1
  integer                               :: id_jprod_ido15n = -1
  integer                               :: id_jremin_ido15n = -1
  integer                               :: id_fpi15n = -1
  integer                               :: id_jremin_pi15n = -1
  integer                               :: id_ji15no3 = -1
  integer                               :: id_jprod_i18o = -1

  integer                               :: ind_ichl = -1
  integer                               :: ind_irrmem = -1
  integer                               :: id_ichl_new = -1

  integer                               :: id_alpha = -1
  integer                               :: id_csurf = -1
  integer                               :: id_csatsurf = -1
  integer                               :: id_htotal = -1
  integer                               :: id_htotal_sat = -1
  integer                               :: id_alk = -1
  integer                               :: id_c14surf = -1
  integer                               :: id_frac_14catm = -1
  integer                               :: id_pco2surf = -1
  integer                               :: id_pco2satsurf = -1
  integer                               :: id_sfc_flux_co2 = -1
  integer                               :: id_sfc_flux_co2sat = -1
  integer                               :: id_sfc_flux_14co2 = -1
  integer                               :: id_jdecay_idi14c = -1
  integer                               :: id_jdecay_ido14c = -1
  integer                               :: id_jprod_pi14c = -1
  integer                               :: id_jprod_ido14c = -1
  integer                               :: id_jremin_pi14c = -1
  integer                               :: id_jremin_ido14c = -1
  integer                               :: id_fpi14c = -1
  integer                               :: id_jidi14c = -1
  integer                               :: id_jio2 = -1
  integer                               :: id_sfc_flux_o2 = -1

  integer                               :: ind_ideal_n = -1
  integer                               :: ind_suntan = -1
  integer                               :: ind_ipo4_pre = -1
  integer                               :: ind_isio4 = -1
  integer                               :: ind_i30sio4 = -1
  integer                               :: ind_ipo4 = -1
  integer                               :: ind_idop = -1
  integer                               :: ind_i15no3 = -1
  integer                               :: ind_in18o3 = -1
  integer                               :: ind_ido15n = -1
  integer                               :: ind_ipo4f = -1
  integer                               :: ind_idopf = -1
  integer                               :: ind_ife = -1

  integer                               :: ind_idi14c = -1
  integer                               :: ind_ido14c = -1
  integer                               :: ind_idic = -1
  integer                               :: ind_idic_pre = -1
  integer                               :: ind_idic_sat = -1
  integer                               :: ind_co2_flux = -1
  integer                               :: ind_co2sat_flux = -1
  integer                               :: ind_14co2_flux = -1
  integer                               :: ind_io2 = -1
  integer                               :: ind_o2_flux = -1

  character(len=fm_string_len)          :: local_restart_file
  character(len=fm_field_name_len)      :: name

end type ibgc_type

logical, public :: do_ocean_ibgc
integer, public :: indsal
integer, public :: indtemp

integer                                 :: package_index
logical                                 :: module_initialized = .false.

character(len=128) :: version = '$Id: ocean_ibgc.F90,v 20.0 2013/12/14 00:09:32 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!       Input parameters:
!
!  htotal_in            = default value for htotal for an initial run
!  htotal_scale_lo      = scaling parameter to chose htotallo
!  htotal_scale_hi      = scaling parameter to chose htotalhi
real                                    :: htotal_in
real, allocatable, dimension(:,:)       :: htotal_scale_hi
real                                    :: htotal_scale_hi_in
real, allocatable, dimension(:,:)       :: htotal_scale_lo
real                                    :: htotal_scale_lo_in

! Calculated parameters (with possible initial input values):
integer                                         :: id_o2_sat = -1
real, allocatable, dimension(:,:)               :: sc_no_term
type(ibgc_type), allocatable, dimension(:) :: ibgc
integer                                         :: instances
real, allocatable, dimension(:,:,:)             :: o2_sat
real, allocatable, dimension(:)                 :: tk
real, allocatable, dimension(:)                 :: ts
real, allocatable, dimension(:)                 :: ts2
real, allocatable, dimension(:)                 :: ts3
real, allocatable, dimension(:)                 :: ts4
real, allocatable, dimension(:)                 :: ts5
real, allocatable, dimension(:)                 :: tt

! for restart
integer                              :: num_restart = 0
type(restart_file_type), allocatable :: restart(:)


contains

!#######################################################################
! <SUBROUTINE NAME="allocate_arrays">
!
! <DESCRIPTION>
!     Dynamically allocate arrays for quantities with unknown dimensions.
! These are arrays that only exist temporarily.
! </DESCRIPTION>
!
subroutine allocate_arrays(isc, iec, jsc, jec, nk)

integer, intent(in)     :: isc
integer, intent(in)     :: iec
integer, intent(in)     :: jsc
integer, intent(in)     :: jec
integer, intent(in)     :: nk


integer :: i, j, k, n

allocate( sc_no_term(isc:iec,jsc:jec) )
allocate( htotal_scale_lo(isc:iec,jsc:jec) )
allocate( htotal_scale_hi(isc:iec,jsc:jec) )
allocate( o2_sat(isc:iec,jsc:jec,nk) )
allocate( tt(isc:iec) )
allocate( tk(isc:iec) )
allocate( ts(isc:iec) )
allocate( ts2(isc:iec) )
allocate( ts3(isc:iec) )
allocate( ts4(isc:iec) )
allocate( ts5(isc:iec) )

! initialize some arrays
sc_no_term(:,:)      = 0.0
htotal_scale_lo(:,:) = 0.0
htotal_scale_hi(:,:) = 0.0
o2_sat(:,:,:) = 0.0
tt(:) = 0.0
tk(:) = 0.0
ts(:) = 0.0
ts2(:) = 0.0
ts3(:) = 0.0
ts4(:) = 0.0
ts5(:) = 0.0

! allocate ibgc array elements
do n = 1, instances

  allocate( ibgc(n)%sc_co2(isc:iec,jsc:jec) )
  allocate( ibgc(n)%sc_o2(isc:iec,jsc:jec) )
  allocate( ibgc(n)%jideal_n(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jsuntan(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%remin_ip(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%remin_isi(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jprod_pisi(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%fpisi(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jremin_pisi(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jprod_pi30si(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%fpi30si(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jremin_pi30si(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jprod_pip(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jprod_idop(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jremin_idop(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%fpip(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jremin_pip(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jife_new(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%felim_irrk(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jprod_pipf(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jprod_idopf(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jremin_idopf(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%fpipf(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jremin_pipf(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jprod_pife(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%fpife(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jremin_pife(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%ife_free(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jife_scav(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jipo4(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jipo4f(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jipo4_bgc(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%ipo4_bgc(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jprod_pi15n(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jprod_ido15n(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jremin_ido15n(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%fpi15n(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jremin_pi15n(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%ji15no3(isc:iec,jsc:jec,nk) )  
  allocate( ibgc(n)%jprod_i18o(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%ichl_new(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%alpha(isc:iec,jsc:jec) )
  allocate( ibgc(n)%csurf(isc:iec,jsc:jec) )
  allocate( ibgc(n)%csatsurf(isc:iec,jsc:jec) )
  allocate( ibgc(n)%htotal(isc:iec,jsc:jec) )
  allocate( ibgc(n)%htotal_sat(isc:iec,jsc:jec) )
  allocate( ibgc(n)%alk(isc:iec,jsc:jec) )
  allocate( ibgc(n)%c14surf(isc:iec,jsc:jec) )
  allocate( ibgc(n)%frac_14catm(isc:iec,jsc:jec) )
  allocate( ibgc(n)%pco2surf(isc:iec,jsc:jec) )
  allocate( ibgc(n)%pco2satsurf(isc:iec,jsc:jec) )
  allocate( ibgc(n)%jdecay_idi14c(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jdecay_ido14c(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jremin_pi14c(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jremin_ido14c(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jprod_pi14c(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jprod_ido14c(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%fpi14c(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jidi14c(isc:iec,jsc:jec,nk) )
  allocate( ibgc(n)%jio2(isc:iec,jsc:jec,nk) )

enddo

do n = 1, instances

  do j = jsc, jec
    do i = isc, iec
     ibgc(n)%sc_co2(i,j) = 0.0
     ibgc(n)%sc_o2(i,j) = 0.0
     ibgc(n)%alpha(i,j) = 0.0
     ibgc(n)%csurf(i,j) = 0.0
     ibgc(n)%csatsurf(i,j) = 0.0
     ibgc(n)%htotal(i,j) = 0.0
     ibgc(n)%htotal_sat(i,j) = 0.0
     ibgc(n)%alk(i,j) = 0.0
     ibgc(n)%c14surf(i,j) = 0.0
     ibgc(n)%frac_14catm(i,j) = ibgc(n)%frac_14catm_const
     ibgc(n)%pco2surf(i,j) = 0.0
     ibgc(n)%pco2satsurf(i,j) = 0.0
      do k = 1, nk
       ibgc(n)%jideal_n(i,j,k) = 0.0
       ibgc(n)%jsuntan(i,j,k) = 0.0
       ibgc(n)%remin_ip(i,j,k) = 0.0
       ibgc(n)%remin_isi(i,j,k) = 0.0
       ibgc(n)%jprod_pisi(i,j,k) = 0.0
       ibgc(n)%fpisi(i,j,k) = 0.0
       ibgc(n)%jremin_pisi(i,j,k) = 0.0
       ibgc(n)%jprod_pi30si(i,j,k) = 0.0
       ibgc(n)%fpi30si(i,j,k) = 0.0
       ibgc(n)%jremin_pi30si(i,j,k) = 0.0
       ibgc(n)%jprod_pip(i,j,k) = 0.0
       ibgc(n)%jprod_idop(i,j,k) = 0.0
       ibgc(n)%jremin_idop(i,j,k) = 0.0
       ibgc(n)%fpip(i,j,k) = 0.0
       ibgc(n)%jremin_pip(i,j,k) = 0.0
       ibgc(n)%jife_new(i,j,k) = 0.0
       ibgc(n)%felim_irrk(i,j,k) = 0.0
       ibgc(n)%jprod_pipf(i,j,k) = 0.0
       ibgc(n)%jprod_idopf(i,j,k) = 0.0
       ibgc(n)%jremin_idopf(i,j,k) = 0.0
       ibgc(n)%fpipf(i,j,k) = 0.0
       ibgc(n)%jremin_pipf(i,j,k) = 0.0
       ibgc(n)%jprod_pife(i,j,k) = 0.0
       ibgc(n)%fpife(i,j,k) = 0.0
       ibgc(n)%jremin_pife(i,j,k) = 0.0
       ibgc(n)%ife_free(i,j,k) = 0.0
       ibgc(n)%jife_scav(i,j,k) = 0.0
       ibgc(n)%jipo4(i,j,k) = 0.0
       ibgc(n)%jipo4f(i,j,k) = 0.0
       ibgc(n)%jipo4_bgc(i,j,k) = 0.0
       ibgc(n)%ipo4_bgc(i,j,k) = 0.0
       ibgc(n)%jprod_pi15n(i,j,k) = 0.0
       ibgc(n)%jprod_ido15n(i,j,k) = 0.0
       ibgc(n)%jremin_ido15n(i,j,k) = 0.0
       ibgc(n)%fpi15n(i,j,k) = 0.0
       ibgc(n)%jremin_pi15n(i,j,k) = 0.0
       ibgc(n)%ji15no3(i,j,k) = 0.0
       ibgc(n)%jprod_i18o(i,j,k) = 0.0
       ibgc(n)%ichl_new(i,j,k) = 0.0
       ibgc(n)%jdecay_idi14c(i,j,k) = 0.0
       ibgc(n)%jdecay_ido14c(i,j,k) = 0.0
       ibgc(n)%jremin_pi14c(i,j,k) = 0.0
       ibgc(n)%jremin_ido14c(i,j,k) = 0.0
       ibgc(n)%jprod_pi14c(i,j,k) = 0.0
       ibgc(n)%jprod_ido14c(i,j,k) = 0.0
       ibgc(n)%fpi14c(i,j,k) = 0.0
       ibgc(n)%jidi14c(i,j,k) = 0.0
       ibgc(n)%jio2(i,j,k) = 0.0
      enddo
    enddo
  enddo

enddo

return
end subroutine  allocate_arrays
! </SUBROUTINE> NAME="allocate_arrays"


!#######################################################################
! <SUBROUTINE NAME="ocean_ibgc_bbc">
!
! <DESCRIPTION>
!     This sets up the boundary conditions at the bottom of the water 
! column. Here, this does nothing and is just a placeholder.
! </DESCRIPTION>
!

subroutine ocean_ibgc_bbc

end subroutine  ocean_ibgc_bbc
! </SUBROUTINE> NAME="ocean_ibgc_bbc"


!#######################################################################
! <SUBROUTINE NAME="ocean_ibgc_end">
!
! <DESCRIPTION>
!     Clean up various quantities for this run. This includes writing out 
! additional information to ensure reproduction across restarts.
! </DESCRIPTION>

subroutine ocean_ibgc_end()

character(len=64), parameter    :: sub_name = 'ocean_ibgc_end'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '): '

integer :: i, j, k, n

  integer :: stdoutunit 
  stdoutunit=stdout() 

  ! save out additional information for a restart

write(stdoutunit,*)
call ocean_ibgc_restart

do n = 1, instances

  write(stdoutunit,*) trim(note_header),                         &
       'Writing additional restart information for instance ', &
       trim(ibgc(n)%name)

  write (stdoutunit,*) trim(note_header),                        &
       'Done writing additional restart information for instance ',&
       trim(ibgc(n)%name)

enddo

return
end subroutine  ocean_ibgc_end
! </SUBROUTINE> NAME="ocean_ibgc_end"


!#######################################################################
! <SUBROUTINE NAME="ocean_ibgc_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocean_ibgc_restart(time_stamp)
  character(len=*),             intent(in), optional :: time_stamp
  integer :: n

character(len=64), parameter    :: sub_name = 'ocean_ibgc_restart'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
  integer :: stdoutunit 
  stdoutunit=stdout() 


  do n=1, instances
     call save_restart(restart(n), time_stamp)
  end do

  ! perform checksums on restart fields
write (stdoutunit,*)
write (stdoutunit,*) trim(note_header), ' Saved check sums for extra variables'
do n = 1, instances
  write(stdoutunit,*) 'htotal chksum = ', mpp_chksum(ibgc(n)%htotal)
  write(stdoutunit,*) 'htotal_sat chksum = ', mpp_chksum(ibgc(n)%htotal_sat)
enddo
write (stdoutunit,*)

end subroutine ocean_ibgc_restart
! </SUBROUTINE> NAME="ocean_ibgc_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_ibgc_sbc">
!
! <DESCRIPTION>
!     Calculate the surface boundary conditions. This includes things
! like gas exchange, atmospheric deposition, and riverine inputs.
! </DESCRIPTION>

subroutine ocean_ibgc_sbc(isc, iec, jsc, jec, &
     isc_bnd, jsc_bnd, T_prog,     &
     Grid, Time, ice_ocean_boundary_fluxes)

integer, intent(in)                                       :: isc
integer, intent(in)                                       :: iec
integer, intent(in)                                       :: jsc
integer, intent(in)                                       :: jec
integer, intent(in)                                       :: isc_bnd
integer, intent(in)                                       :: jsc_bnd
type(ocean_prog_tracer_type), intent(inout), dimension(:) :: T_prog
type(ocean_grid_type), intent(in)                         :: Grid
type(ocean_time_type), intent(in)                         :: Time
type(coupler_2d_bc_type), intent(in)                      :: ice_ocean_boundary_fluxes

integer :: i, j, k, n, m
integer :: i_bnd_off
integer :: j_bnd_off
integer :: kz
integer :: hour
integer :: day
real    :: days_in_this_year
integer :: minute
integer :: month
integer :: num_days
integer :: second
integer :: year
logical :: used

!     use the surface fluxes from the coupler
!       stf is in mol/m^2/s, flux from coupler is positive upwards
i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

if (do_gasses) then

do n = 1, instances
  do j = jsc, jec
    do i = isc, iec
  t_prog(ibgc(n)%ind_idic)%stf(i,j) =                                     &
   -ice_ocean_boundary_fluxes%bc(ibgc(n)%ind_co2_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
  t_prog(ibgc(n)%ind_io2)%stf(i,j) =                      &
   -ice_ocean_boundary_fluxes%bc(ibgc(n)%ind_o2_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
    enddo
  enddo
enddo

! Save variables for diagnostics
do n = 1, instances
   call diagnose_2d(Time, Grid, ibgc(n)%id_sfc_flux_co2, t_prog(ibgc(n)%ind_idic)%stf(:,:))
   call diagnose_2d(Time, Grid, ibgc(n)%id_sfc_flux_o2, t_prog(ibgc(n)%ind_io2)%stf(:,:))
enddo


if (do_carbon_comp) then
do n = 1, instances
  do j = jsc, jec
    do i = isc, iec
  t_prog(ibgc(n)%ind_idic_sat)%stf(i,j) =               &
   -ice_ocean_boundary_fluxes%bc(ibgc(n)%ind_co2sat_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
    enddo
  enddo
enddo
do n = 1, instances
   call diagnose_2d(Time, Grid, ibgc(n)%id_sfc_flux_co2sat, t_prog(ibgc(n)%ind_idic_sat)%stf(:,:))
enddo
endif

if (do_radiocarbon) then
do n = 1, instances
  do j = jsc, jec
    do i = isc, iec
  t_prog(ibgc(n)%ind_idi14c)%stf(i,j) =                  &
   -ice_ocean_boundary_fluxes%bc(ibgc(n)%ind_14co2_flux)%field(ind_flux)%values(i-i_bnd_off,j-j_bnd_off)
    enddo
  enddo
enddo
do n = 1, instances
   call diagnose_2d(Time, Grid, ibgc(n)%id_sfc_flux_14co2, t_prog(ibgc(n)%ind_idi14c)%stf(:,:))
enddo
endif

endif

return

end subroutine  ocean_ibgc_sbc
! </SUBROUTINE> NAME="ocean_ibgc_sbc"


!#######################################################################
! <SUBROUTINE NAME="ocean_ibgc_flux_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the ocean-atmosphere gas fluxes
! </DESCRIPTION>

subroutine ocean_ibgc_flux_init

character(len=64), parameter    :: sub_name = 'ocean_ibgc_flux_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=256)                                      :: caller_str

  integer :: stdoutunit 
  stdoutunit=stdout() 

!       First, perform some initialization if this module has not been
!       initialized because the normal initialization routine will
!       not have been called as part of the normal ocean model
!       initialization if this is an Atmosphere pe of a coupled
!       model running in concurrent mode
if (.not. module_initialized) then

   ! Initialize the package
  package_index = otpm_set_tracer_package(package_name,            &
       restart_file = default_restart_file,                        &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')

  ! Check whether to use this package
  path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
  instances = fm_get_length(path_to_names)
  if (instances .lt. 0) then
    call mpp_error(FATAL, trim(error_header) // ' Could not get number of instances')
  endif

  write (stdoutunit,*)
  if (instances .eq. 0) then
    write (stdoutunit,*) trim(note_header), ' No instances'
    do_ocean_ibgc = .false.
  else
    if (instances .eq. 1) then
      write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
    else
      write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
    endif
    do_ocean_ibgc = .true.
  endif

  module_initialized = .true.

endif

! return if we do not want to use this package
if (.not. do_ocean_ibgc) then
  return
endif

if (.not. allocated(ibgc)) then

   ! allocate storage for ibgc array
  allocate ( ibgc(instances) )

  ! loop over the names, saving them into the ibgc array
  do n = 1, instances

    if (fm_get_value(path_to_names, name, index = n)) then
      ibgc(n)%name = name
    else
      write (name,*) n
      call mpp_error(FATAL, trim(error_header) //        &
           'Bad field name for index ' // trim(name))
    endif

  enddo

endif

if (do_gasses) then
   ! Set up the ocean-atmosphere gas flux fields
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

  name = ibgc(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
  else
    suffix = '_' // name
  endif

  ! Coupler fluxes
  ibgc(n)%ind_co2_flux = aof_set_coupler_flux('ico2_flux' // suffix,            &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',               &
       mol_wt = WTMCO2, param = (/ 9.36e-07, 9.7561e-06 /),                     &
       ice_restart_file = default_ice_restart_file,                             &
       ocean_restart_file = default_ocean_restart_file,                         &
       caller = caller_str)

  ibgc(n)%ind_o2_flux = aof_set_coupler_flux('io2_flux' // suffix,              &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',               &
       mol_wt = WTMO2, param = (/ 9.36e-07, 9.7561e-06 /),                      &
       ice_restart_file = default_ice_restart_file,                             &
       ocean_restart_file = default_ocean_restart_file,                         &
       caller = caller_str)

if (do_carbon_comp) then
  ibgc(n)%ind_co2sat_flux = aof_set_coupler_flux('ico2sat_flux' // suffix,      &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',               &
       mol_wt = WTMCO2, param = (/ 9.36e-07, 9.7561e-06 /),                     &
       ice_restart_file = default_ice_restart_file,                             &
       ocean_restart_file = default_ocean_restart_file,                         &
       caller = caller_str)
endif

if (do_radiocarbon) then
  ibgc(n)%ind_14co2_flux = aof_set_coupler_flux('i14co2_flux' // suffix,        &
       flux_type = 'air_sea_gas_flux', implementation = 'ocmip2',               &
       mol_wt = WTMCO2, param = (/ 9.36e-07, 9.7561e-06 /),                     &
       ice_restart_file = default_ice_restart_file,                             &
       ocean_restart_file = default_ocean_restart_file,                         &
       caller = caller_str)
endif

enddo

endif

return

end subroutine  ocean_ibgc_flux_init
! </SUBROUTINE> NAME="ocean_ibgc_flux_init"

!#######################################################################
! <SUBROUTINE NAME="ocean_ibgc_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the tracer packages
!
!       Save pointers to various "types", such as Grid and Domains.
! </DESCRIPTION>

subroutine ocean_ibgc_init

character(len=64), parameter    :: sub_name = 'ocean_ibgc_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '): '
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '): '

real, parameter :: sperd = 24.0 * 3600.0

integer                                                 :: ioun
integer                                                 :: n
integer                                                 :: ierr
integer                                                 :: io_status
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=fm_string_len)                            :: string
character(len=fm_field_name_len+3)                      :: long_suffix
logical, dimension(12)                                  :: t_mask
character(len=256)                                      :: caller_str
character(len=fm_string_len), pointer, dimension(:)     :: good_list

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  ! Initialize the package
package_index = otpm_set_tracer_package(package_name,                 &
     restart_file = default_restart_file,                             &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')

! Check whether to use this package
path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
instances = fm_get_length(path_to_names)
if (instances .lt. 0) then
  call mpp_error(FATAL, trim(error_header) // 'Could not get number of instances')
endif

write (stdoutunit,*)
if (instances .eq. 0) then
  write (stdoutunit,*) trim(note_header), ' No instances'
  do_ocean_ibgc = .false.
else
  if (instances .eq. 1) then
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
  else
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
  endif
  do_ocean_ibgc = .true.
endif

module_initialized = .true.

! Return if we do not want to use this package,
! after changing the list back
if (.not. do_ocean_ibgc) then
  return
endif

! provide for namelist over-ride
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_ibgc_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_ibgc_nml')
#else
ioun = open_namelist_file()
read  (ioun, ocean_ibgc_nml,iostat=io_status)
ierr = check_nml_error(io_status,'ocean_ibgc_nml')
call close_file (ioun)
#endif
write (stdoutunit,'(/)')
write (stdoutunit, ocean_ibgc_nml)  
write (stdlogunit, ocean_ibgc_nml)

do n = 1, instances

  if ((do_gasses) .and. ((do_po4) .or. (do_po4f))) then
    write (stdoutunit,*) trim(note_header), 'Doing iBGC gasses'
  else if ((do_gasses) .and. .not. ((do_po4) .or. (do_po4f))) then
    call mpp_error(FATAL, trim(error_header) //        &
         'Do_gasses requires do_po4 and/or do_po4f' // trim(name))
  endif

  if ((do_carbon_comp) .and. ((do_po4) .or. (do_po4f)) .and. (do_gasses)) then
    write (stdoutunit,*) trim(note_header), 'Doing DIC components'
  else if ((do_gasses) .and. .not. ((do_po4) .or. (do_po4f)) .and. .not. (do_gasses)) then
    call mpp_error(FATAL, trim(error_header) //        &
         'Do_carbon_comp requires do_po4 and/or do_po4f as well as do_carbon' // trim(name))
  endif
  
  if ((do_radiocarbon) .and. ((do_po4) .or. (do_po4f)) .and. (do_gasses)) then
    write (stdoutunit,*) trim(note_header), 'Doing radiocarbon'
  else if ((do_gasses) .and. .not. ((do_po4) .or. (do_po4f)) .and. .not. (do_gasses)) then
    call mpp_error(FATAL, trim(error_header) //        &
         'Do_radiocarbon requires do_po4 and/or do_po4f as well as do_carbon' // trim(name))
  endif
  
  if ((do_no3_iso) .and. ((do_po4) .or. (do_po4f))) then
    write (stdoutunit,*) trim(note_header), 'Doing NO3 isotopes'
  else if ((do_gasses) .and. .not. ((do_po4) .or. (do_po4f))) then
    call mpp_error(FATAL, trim(error_header) //        &
         'Do_no3_iso requires do_po4 and/or do_po4f' // trim(name))
  endif
  
  if ((do_bgc_felim) .and. (do_po4f)) then
    write (stdoutunit,*) trim(note_header), 'Using Fe-limited P for ibgc'
  else if ((do_bgc_felim) .and. .not. (do_po4f)) then
    call mpp_error(FATAL, trim(error_header) //        &
         'Do_bgc_felim requires do_po4f' // trim(name))
  endif
  
enddo

!       Otherwise, go ahead to allocate storage for ibgc array.
allocate ( ibgc(instances) )

! Loop over the names, saving them into the ibgc array.
do n = 1, instances

  if (fm_get_value(path_to_names, name, index = n)) then
    ibgc(n)%name = name
  else
    write (name,*) n
    call mpp_error(FATAL, trim(error_header) //        &
         'Bad field name for index ' // trim(name))
  endif

enddo

! Set up the field input
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

  name = ibgc(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // name
    long_suffix = ' (' // trim(name) // ')'
  endif

if (do_ideal) then
   ! Ideal_N
  ibgc(n)%ind_ideal_n = otpm_set_prog_tracer('ideal_n' // suffix, package_name,   &
       longname = 'Ideal Nutrient' // trim(long_suffix),                          &
       units = 'mol kg-1', flux_units = 'mol m-2 s-1',                            &
       caller = caller_str)

  ! Suntan
  ibgc(n)%ind_suntan = otpm_set_prog_tracer('suntan' // suffix, package_name,     &
       longname = 'Suntan' // trim(long_suffix),                                  &
       units = 'J kg-1', flux_units = 'W/kg-1',                                   &
       caller = caller_str)
endif

if (do_po4) then
   ! PO4
  ibgc(n)%ind_ipo4 = otpm_set_prog_tracer('ipo4' // suffix, package_name,         &
       longname = 'Phosphate' // trim(long_suffix),                               &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)

  ! DOP
  ibgc(n)%ind_idop = otpm_set_prog_tracer('idop' // suffix, package_name,         &
       longname = 'DOP' // trim(long_suffix),                                     &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)

endif

if (do_po4f) then
   ! PO4 Fe/Irr lim 
  ibgc(n)%ind_ipo4f = otpm_set_prog_tracer('ipo4f' // suffix, package_name,       &
       longname = 'Phosphate Fe/Irr lim' // trim(long_suffix),                    &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)

  ! DOPf
  ibgc(n)%ind_idopf = otpm_set_prog_tracer('idopf' // suffix, package_name,       &
       longname = 'DOPf' // trim(long_suffix),                                    &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)

  ! Fe Fe/Irr lim 
  ibgc(n)%ind_ife = otpm_set_prog_tracer('ife' // suffix, package_name,           &
       longname = 'Iron Fe/Irr lim' // trim(long_suffix),                         &
       units = 'mmol/kg', flux_units = 'mmol m-2 s-1',                            &
       caller = caller_str)

endif

if ((do_po4f) .or. (do_po4)) then
   ! Preformed PO4
  ibgc(n)%ind_ipo4_pre = otpm_set_prog_tracer('ipo4_pre' // suffix, package_name, &
       longname = 'Preformed iPO4' // trim(long_suffix),                          &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)

  ! Irradiance memory
  ibgc(n)%ind_irrmem = otpm_set_diag_tracer('irrmem' // suffix, package_name,   &
       longname = 'Irradiance memory' // trim(long_suffix),               &
       restart_file = default_restart_file,                         &
       units = 'Watts/m^2',const_init_tracer=.true.,    &
       const_init_value=0.0)

  ! Chlorophyll
  ibgc(n)%ind_ichl = otpm_set_diag_tracer('ichl' // suffix, package_name,         &
       longname = 'Chlorophyll' // trim(long_suffix),                             &
       restart_file = default_restart_file,                                       &
       units = 'ug/kg', const_init_tracer=.true.,                                 &
       const_init_value=0.08)

endif

if (do_gasses) then
   ! DIC
  ibgc(n)%ind_idic = otpm_set_prog_tracer('idic' // suffix, package_name,         &
       longname = 'DIC' // trim(long_suffix),                                     &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)

  ! O2
  ibgc(n)%ind_io2 = otpm_set_prog_tracer('io2' // suffix, package_name,           &
       longname = 'O2' // trim(long_suffix),                                      &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)

if (do_carbon_comp) then
   ! Saturation DIC
  ibgc(n)%ind_idic_sat = otpm_set_prog_tracer('idic_sat' // suffix, package_name, &
       longname = 'Saturation DIC' // trim(long_suffix),                          &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)

  ! Preformed DIC
  ibgc(n)%ind_idic_pre = otpm_set_prog_tracer('idic_pre' // suffix, package_name, &
       longname = 'Preformed iDIC' // trim(long_suffix),                          &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)
endif

if (do_radiocarbon) then
  ! DI14C
  ibgc(n)%ind_idi14c = otpm_set_prog_tracer('idi14c' // suffix, package_name,     &
       longname = 'DI14C' // trim(long_suffix),                                   &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)

  ! DO14C
  ibgc(n)%ind_ido14c = otpm_set_prog_tracer('ido14c' // suffix, package_name,     &
       longname = 'DO14C' // trim(long_suffix),                                   &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)
endif

endif

if (do_no3_iso) then
   ! 15no3
  ibgc(n)%ind_i15no3 = otpm_set_prog_tracer('i15no3' // suffix, package_name,     &
       longname = '15NO3' // trim(long_suffix),                                   &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)

  ! DO15N
  ibgc(n)%ind_ido15n = otpm_set_prog_tracer('ido15n' // suffix, package_name,     &
       longname = 'DO15N' // trim(long_suffix),                                   &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)

  ! n18o3
  ibgc(n)%ind_in18o3 = otpm_set_prog_tracer('in18o3' // suffix, package_name,     &
       longname = 'N18O3' // trim(long_suffix),                                   &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)

endif

if (do_isio4) then
   ! SiO4
  ibgc(n)%ind_isio4 = otpm_set_prog_tracer('isio4' // suffix, package_name,       &
       longname = 'Silicate' // trim(long_suffix),                                &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)

  ! 30SiO4
  ibgc(n)%ind_i30sio4 = otpm_set_prog_tracer('i30sio4' // suffix, package_name,   &
       longname = '30SiO4' // trim(long_suffix),                                  &
       units = 'mol/kg', flux_units = 'mol m-2 s-1',                              &
       caller = caller_str)

endif

enddo

! Process the namelists

! Add the package name to the list of good namelists, to be used
! later for a consistency check
if (fm_new_value('/ocean_mod/GOOD/good_namelists', package_name, append = .true.) .le. 0) then
  call mpp_error(FATAL, trim(error_header) //                           &
       ' Could not add ' // trim(package_name) // ' to "good_namelists" list')
endif

! Set up the *global* namelist
call fm_util_start_namelist(package_name, '*global*', caller = caller_str, no_overwrite = .true., &
     check = .true.)

call fm_util_set_value('htotal_scale_lo_in', 0.001 )
call fm_util_set_value('htotal_scale_hi_in', 1000.0)
call fm_util_set_value('htotal_in', 1.0e-08)

call fm_util_end_namelist(package_name, '*global*', caller = caller_str, check = .true.)

! Set up the instance namelists
t_mask(:) = .true.

do n = 1, instances

   !       create the instance namelist
  call fm_util_start_namelist(package_name, ibgc(n)%name, caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('local_restart_file', default_local_restart_file)

  ! Global constants
  call fm_util_set_value('kappa_eppley', 0.0378)         ! deg C-1. 
  call fm_util_set_value('kappa_eppley_remin', 0.0249)   ! deg C-1. 
  call fm_util_set_value('irrk', 20.)                    !Light half-saturation constant W m-2

  ! Ideal Nutrient constants
  call fm_util_set_value('ideal_n_vmax', 0.007 / sperd)  ! Maximum uptake rate mol kg-1 s-1
  call fm_util_set_value('ideal_n_k', 0.2)               ! Nutrient half-saturation constant mol kg-1
  call fm_util_set_value('ideal_n_r', 0.00025 / sperd)   ! regeneration rate s-1

  ! Suntan constant
  call fm_util_set_value('suntan_fade', 0.01 )           ! Suntan fading rate W m-3 s-1

  ! Ideal Phosphate constants
  call fm_util_set_value('ipo4_vmax', 0.010 * 2.16e-6 / sperd) ! Maximum uptake rate mol kg-1 s-1 at 0C
  call fm_util_set_value('ipo4_k', 0.2 * 2.16e-6)        ! Nutrient half-saturation constant mol kg-1
  call fm_util_set_value('idop_frac', 0.65)              ! fraction of total production converted to dissolved pool
  call fm_util_set_value('gamma_idop', 0.007 / sperd)    ! remineralization rate for iDOP at 0C
  call fm_util_set_value('gamma_ip', 0.04 / sperd)       ! remineralization rate for soft tissue s-1
  call fm_util_set_value('sinking_init', 12. / sperd)    ! m s-1
  call fm_util_set_value('sinking_acc', .009 / sperd)    ! m s-2

  call fm_util_set_value('gamma_isi', 0.02 / sperd)      ! remineralization rate for silica

  ! Ideal Chlorophyll constants
  call fm_util_set_value('uptake_2_chl', 3.e13)          ! convert uptake rate to chl concentration mg-chl s molP-1
  call fm_util_set_value('ichl_lag', 0.5 / sperd)        ! Smoothing timescale for ichl adjustment s-1
  call fm_util_set_value('ichl_highlight', 0.1)          ! Fractional ichl:iP reduction under intense light

  ! Ideal Iron constants
  call fm_util_set_value('ipo4f_vmax', 0.012 * 2.16e-6 / sperd) ! Maximum uptake rate for PO4f mol kg-1 s-1 at 0C
  call fm_util_set_value('ligand_tot', 1. * 1.e-6)       !Ligand concentration mmol kg-1, Parekh 2005
  call fm_util_set_value('ligand_k', 1.e8)               ! Ligand stability constant, kg mmol-1 Dutkiewicz 2005
  call fm_util_set_value('scav_k', 0.001 / sperd)        ! Scavenging rate of free Fe, s-1, Dutkiewicz 2005 
  call fm_util_set_value('ife_irrsuf', 0.25 * 1.e-6)     !Iron-sufficient-ish Fe concentration for IRRk calc mmol kg-1
  call fm_util_set_value('ife_supply', 0.02  * 1.e-3 / sperd) ! Average global Fe input to surface mmol m-2 s-1

  ! Ideal isotope fractionations
!  call fm_util_set_value('alpha_12c_13c', 1.04)         ! 14C isotope fractionation factor (=2x13c)
  call fm_util_set_value('alpha_14n_15n', 1.005)         ! Nitrogen isotope fractionation factor
  call fm_util_set_value('alpha_28si_30si', 1.001)       ! Silicon isotope fractionation factor
  
  ! Gases 
  call fm_util_set_value('o2_2_ip', 170.)                ! Molar O2 to P ratio
  call fm_util_set_value('io2_min', 2.e-6)               ! Minimum O2 concentration

  call fm_util_set_value('sal_global', 35.0)             ! Average global salinity PSU
  call fm_util_set_value('half_life_14c', 5730.0)        ! a
  call fm_util_set_value('alkbar', 2.310e-03)            ! Average alkalinity eq/kg
  call fm_util_set_value('si_2_ip', 92. / 2.16)          ! Global average Si/PO4 concentration (to convert iSiO4 to SiO4)
  call fm_util_set_value('c_2_ip', 117.)                 ! Molar Redfield C to P ratio
  call fm_util_set_value('frac_14catm_file', ' ')      
  call fm_util_set_value('frac_14catm_name', ' ')
  call fm_util_set_value('frac_14catm_const', ibgc(n)%frac_14catm_const)

  !New Wanninkhof numbers
  call fm_util_set_value('sc_co2_0', 2068.9)
  call fm_util_set_value('sc_co2_1', -118.63)
  call fm_util_set_value('sc_co2_2', 2.9311)
  call fm_util_set_value('sc_co2_3', -0.027)
  call fm_util_set_value('sc_o2_0', 1929.7)
  call fm_util_set_value('sc_o2_1', -117.46)
  call fm_util_set_value('sc_o2_2', 3.116)
  call fm_util_set_value('sc_o2_3', -0.0306)

  call fm_util_end_namelist(package_name, ibgc(n)%name, check = .true., caller = caller_str)

enddo


! Check for any errors in the number of fields in the namelists for this package
good_list => fm_util_get_string_array('/ocean_mod/GOOD/namelists/' // trim(package_name) // '/good_values',   &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
if (associated(good_list)) then
  call fm_util_check_for_bad_fields('/ocean_mod/namelists/' // trim(package_name), good_list,       &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')
  deallocate(good_list)
else
  call mpp_error(FATAL,trim(error_header) // ' Empty "' // trim(package_name) // '" list')
endif

return

end subroutine ocean_ibgc_init
! </SUBROUTINE> NAME="ocean_ibgc_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_ibgc_init_sfc">
!
! <DESCRIPTION>
!
! SURFACE GAS FLUXES
! 
! This subroutine coordinates the calculation of gas solubilities in the surface layer, 
! and sends the appropriate values to the coupler.
!
! First, for CO2 and 14CO2, the carbon solubility and speciation are calculated by the
! subroutine co2calc, following the OCMIP2 protocol. These calculations are both made
! using total CO2, following which the surface CO2 concentration (CO2*, also known as
! H2CO3*) is scaled by the DI14C/DIC ratio to give the surface 14CO2 concentration.
! The speciation calculation uses in situ temperature, salinity, idealized PO4 and 
! idealized SiO4 (which must be scaled to real SiO4 units, since I'm using PO4 units
! for iSiO4). 
! Oxygen solubility is calculated here, using in situ temperature and salinity.
!
! The actual gas fluxes will be calculated in the coupler using a piston velocity (Kw),
!    Flux = Kw * (alpha - csurf)
! and returned as elements of ice_ocean_boundary_fluxes%bc in the ocean_ibgc_sbc 
! subroutine.

! </DESCRIPTION>

subroutine ocean_ibgc_init_sfc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,   &
     isc_bnd, jsc_bnd,                                         &
     Ocean_fields, T_prog, rho, taum1, model_time, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: jsc_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho
integer, intent(in)                                     :: taum1
type(time_type), intent(in)                             :: model_time
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer         :: i, j, k, n
integer         :: i_bnd_off
integer         :: j_bnd_off
integer         :: ind

real            :: epsln = 1.0e-30

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

if (do_gasses) then

do n = 1, instances

   ! CO2 flux
  ind = ibgc(n)%ind_co2_flux

  ! Have ocmip2_co2calc calculate alpha (which is the saturation co2star per atmosphere CO2, 
  ! in mol kg-1 atm-1), co2star (the actual co2star, in mol kg-1) and pco2surf (uatm)
  if (.not. field_exist('INPUT/'//trim(Ocean_fields%bc(ind)%ocean_restart_file),  &
                        Ocean_fields%bc(ind)%field(ind_alpha)%name)) then

    call ocmip2_co2calc(isd, jsd, isc, iec, jsc, jec,            &
         grid_tmask(isd:ied,jsd:jed,1),                                    &
         t_prog(indtemp)%field(isd:ied,jsd:jed,1,taum1),                   &
         t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1),                    &
         t_prog(ibgc(n)%ind_idic)%field(isd:ied,jsd:jed,1,taum1),          &
         t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1) *                   &
              ibgc(n)%alkbar / ibgc(n)%sal_global,                    &
         t_prog(ibgc(n)%ind_ipo4)%field(isd:ied,jsd:jed,1,taum1),     &
         t_prog(ibgc(n)%ind_ipo4)%field(isd:ied,jsd:jed,1,taum1) *    &
              ibgc(n)%si_2_ip,                                        &
         htotal_scale_lo, htotal_scale_hi, ibgc(n)%htotal,            &
         co2star = ibgc(n)%csurf, alpha = ibgc(n)%alpha,              &
         pco2surf = ibgc(n)%pco2surf)


    !  Compute the Schmidt number of CO2 in seawater using the 
    !  formulation presented by Wanninkhof (1992, J. Geophys. Res., 97,
    !  7373-7382). This parameterizes the temperature-dependence of the
    !  gas exchange rate.
    do j = jsc, jec
      do i = isc, iec
        ibgc(n)%sc_co2(i,j) =                                              &
             ibgc(n)%sc_co2_0 + t_prog(indtemp)%field(i,j,1,taum1) *       &
             (ibgc(n)%sc_co2_1 + t_prog(indtemp)%field(i,j,1,taum1) *      &
              (ibgc(n)%sc_co2_2 + t_prog(indtemp)%field(i,j,1,taum1) *     &
               ibgc(n)%sc_co2_3)) * grid_tmask(i,j,1)
        sc_no_term(i,j) = sqrt(660.0 / (ibgc(n)%sc_co2(i,j) + epsln)) * grid_tmask(i,j,1)

        ! Send surface CO2* solubility (alpha) to coupler in units of mol m-3 atm-1
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) = &
             ibgc(n)%alpha(i,j) * sc_no_term(i,j) * rho(i,j,1,taum1)
        ! Send surface CO2* concentration (csurf) to coupler in units of mol m-3 
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) = &
             ibgc(n)%csurf(i,j) * sc_no_term(i,j) * rho(i,j,1,taum1)
      enddo
    enddo

  endif

  ! O2 flux
  ind = ibgc(n)%ind_o2_flux
  if (.not. field_exist('INPUT/'//trim(Ocean_fields%bc(ind)%ocean_restart_file), &
                        Ocean_fields%bc(ind)%field(ind_alpha)%name)) then

!  Compute the oxygen saturation concentration at 1 atm total
!  pressure in mol/m^3 given the temperature (t, in deg C) and
!  the salinity (s, in permil)
!
!  From Garcia and Gordon (1992), Limnology and Oceonography.
!  The formula used is from page 1310, eq (8).
!
!  *** Note: the "a3*ts^2" term (in the paper) is incorrect. ***
!  *** It shouldn't be there.                                ***
!
!  o2_saturation is defined between T(freezing) <= T <= 40 deg C and
!                                   0 permil <= S <= 42 permil
!
! check value: T = 10 deg C, S = 35 permil,
!              o2_saturation = 0.282015 mol/m^3
  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        tt(i) = 298.15 - t_prog(indtemp)%field(i,j,k,taum1)
        tk(i) = 273.15 + t_prog(indtemp)%field(i,j,k,taum1)
        ts(i) = log(tt(i) / tk(i))
        ts2(i) = ts(i) * ts(i)
        ts3(i) = ts2(i) * ts(i)
        ts4(i) = ts3(i) * ts(i)
        ts5(i) = ts4(i) * ts(i)
        o2_sat(i,j,k) =                                                 &
             exp(a_0 + a_1*ts(i) + a_2*ts2(i) +                         &
                 a_3*ts3(i) + a_4*ts4(i) + a_5*ts5(i) +                 &
                 t_prog(indsal)%field(i,j,1,taum1) *                    &
                 (b_0 + b_1*ts(i) + b_2*ts2(i) + b_3*ts3(i) +           &
                  c_0*t_prog(indsal)%field(i,j,1,taum1)))
      enddo
    enddo
  enddo

  ! convert from ml/l to mol/m^3
  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        o2_sat(i,j,k) = o2_sat(i,j,k) * (1000.0/22391.6)
      enddo
    enddo
  enddo
  
  !  Compute the Schmidt number of O2 in seawater using the 
  !  formulation proposed by Keeling et al. (1998, Global Biogeochem.
  !  Cycles, 12, 141-163).
    do j = jsc, jec
      do i = isc, iec
        ibgc(n)%sc_o2(i,j) =                                               &
             ibgc(n)%sc_o2_0 + t_prog(indtemp)%field(i,j,1,taum1) *        &
             (ibgc(n)%sc_o2_1 + t_prog(indtemp)%field(i,j,1,taum1) *       &
              (ibgc(n)%sc_o2_2 + t_prog(indtemp)%field(i,j,1,taum1) *      &
               ibgc(n)%sc_o2_3)) * grid_tmask(i,j,1)
        sc_no_term(i,j) = sqrt(660.0 / (ibgc(n)%sc_o2(i,j) + epsln)) * grid_tmask(i,j,1)
        
        ! Send the O2 solubility term (alpha) to the coupler, in units of mol m-3.
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) = &
             o2_sat(i,j,1) * sc_no_term(i,j)

        ! Send the in situ O2 concentration to the coupler, in units of mol m-3.
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =         &
             t_prog(ibgc(n)%ind_io2)%field(i,j,1,taum1) * rho(i,j,1,taum1) *       &
             sc_no_term(i,j)
      enddo
    enddo

  endif
  
if (do_carbon_comp) then
   !     DIC Sat CO2 flux
   !  This is similar to the CO2 flux above, but the Schmidt number term is increased  
   !  by 30x to cause rapid approach to saturation DIC concentrations.
  ind = ibgc(n)%ind_co2sat_flux

  if (.not. field_exist('INPUT/'//trim(Ocean_fields%bc(ind)%ocean_restart_file), &
                        Ocean_fields%bc(ind)%field(ind_alpha)%name)) then

    call ocmip2_co2calc(isd, jsd, isc, iec, jsc, jec,                &
         grid_tmask(isd:ied,jsd:jed,1),                                        &
         t_prog(indtemp)%field(isd:ied,jsd:jed,1,taum1),                       &
         t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1),                        &
         t_prog(ibgc(n)%ind_idic_sat)%field(isd:ied,jsd:jed,1,taum1),          &
         t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1) *                       &
              ibgc(n)%alkbar / ibgc(n)%sal_global,                             &
         t_prog(ibgc(n)%ind_ipo4)%field(isd:ied,jsd:jed,1,taum1),              &
         t_prog(ibgc(n)%ind_ipo4)%field(isd:ied,jsd:jed,1,taum1) *            &
              ibgc(n)%si_2_ip,                                                 &
         htotal_scale_lo, htotal_scale_hi, ibgc(n)%htotal_sat,                 &
         co2star = ibgc(n)%csatsurf,                                           &
         pco2surf = ibgc(n)%pco2satsurf)


    do j = jsc, jec
      do i = isc, iec

         ! Send surface CO2* solubility (alpha) to coupler in units of mol m-3 atm-1
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) = &
             ibgc(n)%alpha(i,j) * sc_no_term(i,j) * 30. * rho(i,j,1,taum1)
        ! Send surface CO2* concentration (csatsurf) to coupler in units of mol m-3.
        ! Schmidt number term is removed, replaced by constant multiplier of 1e4.
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) = &
             ibgc(n)%csatsurf(i,j) * sc_no_term(i,j) * 30. * rho(i,j,1,taum1)

      enddo
    enddo

  endif

endif

if (do_radiocarbon) then
    ! 14CO2 flux
    ind = ibgc(n)%ind_14co2_flux

    ! Calculate interpolated frac_14catm (fractionation of atmospheric 14CO2)
    if (ibgc(n)%frac_14catm_file .ne. ' ') then
      call time_interp_external(ibgc(n)%frac_14catm_id, model_time, ibgc(n)%frac_14catm)
    endif

    do j = jsc, jec
      do i = isc, iec

         ! Calculate surface 14CO2* concentration in mol kg-1, by scaling the total CO2* concentration 
         ! by 14C/12C
        ibgc(n)%c14surf(i,j) = ibgc(n)%csurf(i,j) *                              &
             t_prog(ibgc(n)%ind_idi14c)%field(i,j,1,taum1) /                     &
             (t_prog(ibgc(n)%ind_idic)%field(i,j,1,taum1) + epsln)

        ! Send surface 14CO2* solubility (alpha) to coupler in units of mol m-3 
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =  &
             ibgc(n)%alpha(i,j) * sc_no_term(i,j) * rho(i,j,1,taum1) *           &
             (1.0 + ibgc(n)%frac_14catm(i,j) * 1.0e-03)

        ! Send surface 14CO2* concentration (csurf) to coupler in units of mol m-3 
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =  &
             ibgc(n)%c14surf(i,j) * sc_no_term(i,j) * rho(i,j,1,taum1)
      enddo
    enddo
endif

enddo

endif

return

end subroutine ocean_ibgc_init_sfc
! </SUBROUTINE> NAME="ocean_ibgc_init_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_ibgc_sum_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations. 
! </DESCRIPTION>
subroutine ocean_ibgc_sum_sfc(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,    &
     isc_bnd, jsc_bnd,                                        &
     Ocean_fields, T_prog, rho, taum1, model_time, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: jsc_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
type(ocean_prog_tracer_type), intent(in), dimension(:)  :: T_prog
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho
integer, intent(in)                                     :: taum1
type(time_type), intent(in)                             :: model_time
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer         :: i, j, k, n
integer         :: i_bnd_off
integer         :: j_bnd_off
integer         :: ind

real            :: epsln=1.0e-30

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

if (do_gasses) then

do n = 1, instances

  ind = ibgc(n)%ind_co2_flux

    call ocmip2_co2calc(isd, jsd, isc, iec, jsc, jec,           &
         grid_tmask(isd:ied,jsd:jed,1),                                    &
         t_prog(indtemp)%field(isd:ied,jsd:jed,1,taum1),                   &
         t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1),                    &
         t_prog(ibgc(n)%ind_idic)%field(isd:ied,jsd:jed,1,taum1),     &
         t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1) *                   &
              ibgc(n)%alkbar / ibgc(n)%sal_global,               &
         t_prog(ibgc(n)%ind_ipo4)%field(isd:ied,jsd:jed,1,taum1),     &
         t_prog(ibgc(n)%ind_ipo4)%field(isd:ied,jsd:jed,1,taum1) *   &
              ibgc(n)%si_2_ip,                                        &
         htotal_scale_lo, htotal_scale_hi, ibgc(n)%htotal,            &
         co2star = ibgc(n)%csurf, alpha = ibgc(n)%alpha,         &
         pco2surf = ibgc(n)%pco2surf)

    ! Compute the Schmidt number of CO2 in seawater using the 
    ! formulation presented by Wanninkhof (1992, J. Geophys. Res., 97,
    ! 7373-7382).
    do j = jsc, jec
      do i = isc, iec
        ibgc(n)%sc_co2(i,j) =                                              &
             ibgc(n)%sc_co2_0 + t_prog(indtemp)%field(i,j,1,taum1) *       &
             (ibgc(n)%sc_co2_1 + t_prog(indtemp)%field(i,j,1,taum1) *      &
              (ibgc(n)%sc_co2_2 + t_prog(indtemp)%field(i,j,1,taum1) *     &
               ibgc(n)%sc_co2_3)) * grid_tmask(i,j,1)
      sc_no_term(i,j) = sqrt(660.0 / (ibgc(n)%sc_co2(i,j) + epsln)) * grid_tmask(i,j,1)
      Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
           Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +      &
           ibgc(n)%alpha(i,j) * sc_no_term(i,j) * rho(i,j,1,taum1)
      Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
           Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +      &
           ibgc(n)%csurf(i,j) * sc_no_term(i,j) * rho(i,j,1,taum1)
      enddo
    enddo

    ! O2 flux
    ind = ibgc(n)%ind_o2_flux

!  Compute the oxygen saturation concentration at 1 atm total
!  pressure in mol/m^3 given the temperature (t, in deg C) and
!  the salinity (s, in permil)
!
!  From Garcia and Gordon (1992), Limnology and Oceonography.
!  The formula used is from page 1310, eq (8).
!
!  *** Note: the "a3*ts^2" term (in the paper) is incorrect. ***
!  *** It shouldn't be there.                                ***
!
!  o2_saturation is defined between T(freezing) <= T <= 40 deg C and
!                                   0 permil <= S <= 42 permil
!
! check value: T = 10 deg C, S = 35 permil,
!              o2_saturation = 0.282015 mol/m^3
  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        tt(i) = 298.15 - t_prog(indtemp)%field(i,j,k,taum1)
        tk(i) = 273.15 + t_prog(indtemp)%field(i,j,k,taum1)
        ts(i) = log(tt(i) / tk(i))
        ts2(i) = ts(i) * ts(i)
        ts3(i) = ts2(i) * ts(i)
        ts4(i) = ts3(i) * ts(i)
        ts5(i) = ts4(i) * ts(i)
        o2_sat(i,j,k) =                                         &
             exp(a_0 + a_1*ts(i) + a_2*ts2(i) +                 &
                 a_3*ts3(i) + a_4*ts4(i) + a_5*ts5(i) +         &
                 t_prog(indsal)%field(i,j,1,taum1) *            &
                 (b_0 + b_1*ts(i) + b_2*ts2(i) + b_3*ts3(i) +   &
                  c_0*t_prog(indsal)%field(i,j,1,taum1)))
      enddo
    enddo
  enddo

  ! convert from ml/l to mol/m^3
  do k = 1, nk
    do j = jsc, jec
      do i = isc, iec
        o2_sat(i,j,k) = o2_sat(i,j,k) * (1000.0/22391.6)
      enddo
    enddo
  enddo

  !  Compute the Schmidt number of O2 in seawater using the 
  !  formulation proposed by Keeling et al. (1998, Global Biogeochem.
  !  Cycles, 12, 141-163).
    do j = jsc, jec
      do i = isc, iec
        ibgc(n)%sc_o2(i,j) =                                               &
             ibgc(n)%sc_o2_0 + t_prog(indtemp)%field(i,j,1,taum1) *        &
             (ibgc(n)%sc_o2_1 + t_prog(indtemp)%field(i,j,1,taum1) *       &
              (ibgc(n)%sc_o2_2 + t_prog(indtemp)%field(i,j,1,taum1) *      &
               ibgc(n)%sc_o2_3)) * grid_tmask(i,j,1)
        sc_no_term(i,j) = sqrt(660.0 / (ibgc(n)%sc_o2(i,j) + epsln)) * grid_tmask(i,j,1)

        ! Send the O2 solubility term (alpha) to the coupler, in units of mol m-3.
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =         &
             Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +    &
             o2_sat(i,j,1) * sc_no_term(i,j)

        ! Send the in situ O2 concentration to the coupler, in units of mol m-3.
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =         &
             Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +    &
             t_prog(ibgc(n)%ind_io2)%field(i,j,1,taum1) * rho(i,j,1,taum1) *       &
             sc_no_term(i,j)
      enddo
    enddo

if (do_carbon_comp) then

   !     DIC Sat CO2 flux
   !  This is similar to the CO2 flux above, but the Schmidt number term is increased  
   !  by 30x to cause rapid approach to saturation DIC concentrations.
  ind = ibgc(n)%ind_co2sat_flux

      call ocmip2_co2calc(isd, jsd, isc, iec, jsc, jec,          &
         grid_tmask(isd:ied,jsd:jed,1),                                    &
         t_prog(indtemp)%field(isd:ied,jsd:jed,1,taum1),                   &
         t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1),                    &
         t_prog(ibgc(n)%ind_idic_sat)%field(isd:ied,jsd:jed,1,taum1),     &
         t_prog(indsal)%field(isd:ied,jsd:jed,1,taum1) *                   &
              ibgc(n)%alkbar / ibgc(n)%sal_global,               &
         t_prog(ibgc(n)%ind_ipo4)%field(isd:ied,jsd:jed,1,taum1),     &
         t_prog(ibgc(n)%ind_ipo4)%field(isd:ied,jsd:jed,1,taum1) *   &
              ibgc(n)%si_2_ip,                                        &
         htotal_scale_lo, htotal_scale_hi, ibgc(n)%htotal_sat,            &
         co2star = ibgc(n)%csatsurf,          &
         pco2surf = ibgc(n)%pco2satsurf)

    do j = jsc, jec
      do i = isc, iec
      Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
           Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +      &
           ibgc(n)%alpha(i,j) * sc_no_term(i,j) * 30. * rho(i,j,1,taum1)
      Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
           Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +      &
           ibgc(n)%csatsurf(i,j) * sc_no_term(i,j) * 30. * rho(i,j,1,taum1)
      enddo
    enddo

endif

if (do_radiocarbon) then
   ! 14CO2 flux
  ind = ibgc(n)%ind_14co2_flux

  ! Calculate interpolated frac_14catm (fractionation of atmospheric 14CO2)
  if (ibgc(n)%frac_14catm_file .ne. ' ') then
    call time_interp_external(ibgc(n)%frac_14catm_id, model_time, ibgc(n)%frac_14catm)
  endif

  do j = jsc, jec
    do i = isc, iec

       ! Calculate surface 14CO2* concentration in mol kg-1, by scaling the total CO2* concentration 
       ! by 14C/12C
      ibgc(n)%c14surf(i,j) = ibgc(n)%csurf(i,j) *                             &
           t_prog(ibgc(n)%ind_idi14c)%field(i,j,1,taum1) /                         &
           (t_prog(ibgc(n)%ind_idic)%field(i,j,1,taum1) + epsln)

      ! Send surface 14CO2* solubility (alpha) to coupler in units of mol m-3 
      Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =           &
           Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) +      &
           ibgc(n)%alpha(i,j) * sc_no_term(i,j) * rho(i,j,1,taum1) *               &
           (1.0 + ibgc(n)%frac_14catm(i,j) * 1.0e-03)

      ! Send surface 14CO2* concentration (csurf) to coupler in units of mol m-3 
      Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =           &
           Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) +      &
           ibgc(n)%c14surf(i,j) * sc_no_term(i,j)  * rho(i,j,1,taum1)
    enddo
  enddo

endif

enddo

endif

return

end subroutine ocean_ibgc_sum_sfc
! </SUBROUTINE> NAME="ocean_ibgc_sum_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_ibgc_zero_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations. 
! </DESCRIPTION>

subroutine ocean_ibgc_zero_sfc(Ocean_fields)

type(coupler_2d_bc_type), intent(inout) :: Ocean_fields

integer         :: n
integer         :: ind

if (do_gasses) then

do n = 1, instances

  ind = ibgc(n)%ind_co2_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0

  ind = ibgc(n)%ind_o2_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0

if (do_carbon_comp) then
  ind = ibgc(n)%ind_co2sat_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0
endif

if (do_radiocarbon) then
  ind = ibgc(n)%ind_14co2_flux

  Ocean_fields%bc(ind)%field(ind_alpha)%values = 0.0
  Ocean_fields%bc(ind)%field(ind_csurf)%values = 0.0
endif


enddo

endif

return

end subroutine ocean_ibgc_zero_sfc
! </SUBROUTINE> NAME="ocean_ibgc_zero_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_ibgc_avg_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations. 
! </DESCRIPTION>

subroutine ocean_ibgc_avg_sfc(isc, iec, jsc, jec, isd, jsd,    &
     isc_bnd, jsc_bnd, Ocean_fields, Ocean_avg_kount, grid_tmask)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: isc_bnd
integer, intent(in)                                     :: jsc_bnd
type(coupler_2d_bc_type), intent(inout)                 :: Ocean_fields
integer                                                 :: Ocean_avg_kount
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask

integer         :: i_bnd_off
integer         :: j_bnd_off
integer         :: i, j, n
integer         :: ind
real            :: divid

i_bnd_off = isc - isc_bnd
j_bnd_off = jsc - jsc_bnd

divid = 1./float(Ocean_avg_kount)

if (do_gasses) then

do n = 1, instances

  ind = ibgc(n)%ind_co2_flux

  do j = jsc, jec
    do i = isc, iec
      if (grid_tmask(i,j,1) == 1.0) then
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
      endif
    enddo
  enddo

  ind = ibgc(n)%ind_o2_flux

  do j = jsc, jec
    do i = isc, iec
      if (grid_tmask(i,j,1) == 1.0) then
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
      endif
    enddo
  enddo

if (do_carbon_comp) then
  ind = ibgc(n)%ind_co2sat_flux

  do j = jsc, jec
    do i = isc, iec
      if (grid_tmask(i,j,1) == 1.0) then
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
      endif
    enddo
  enddo
endif

if (do_radiocarbon) then
  ind = ibgc(n)%ind_14co2_flux

  do j = jsc, jec
    do i = isc, iec
      if (grid_tmask(i,j,1) == 1.0) then
        Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_alpha)%values(i-i_bnd_off,j-j_bnd_off) * divid
        Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) =                 &
             Ocean_fields%bc(ind)%field(ind_csurf)%values(i-i_bnd_off,j-j_bnd_off) * divid
      endif
    enddo
  enddo
endif

enddo

endif

return

end subroutine ocean_ibgc_avg_sfc
! </SUBROUTINE> NAME="ocean_ibgc_avg_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_ibgc_sfc_end">
!
! <DESCRIPTION>
!       Finish up stuff for surface fields for flux calculations. 
! </DESCRIPTION>

subroutine ocean_ibgc_sfc_end

end subroutine ocean_ibgc_sfc_end
! </SUBROUTINE> NAME="ocean_ibgc_sfc_end"


!#######################################################################
! <SUBROUTINE NAME="ocean_ibgc_source">
!
! <DESCRIPTION>
!     Compute the source terms for the ideal nutrients, including boundary
!     conditions (not done in setvbc, to minimize number
!     of hooks required in MOM base code)
! </DESCRIPTION>

subroutine ocean_ibgc_source(isc, iec, jsc, jec, nk, isd, jsd,       &
     T_prog, T_diag, taum1, grid_tmask, Grid, Time, grid_kmt, depth_zt,   &
     rho, rho_dzt, dzt, hblt_depth, dtts)

integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: nk
integer, intent(in)                                             :: isd
integer, intent(in)                                             :: jsd
type(ocean_prog_tracer_type), intent(inout), dimension(:)       :: T_prog
type(ocean_diag_tracer_type), intent(inout), dimension(:)       :: T_diag
integer, intent(in)                                             :: taum1
real, dimension(isd:,jsd:,:), intent(in)                        :: grid_tmask
type(ocean_grid_type), intent(in)                               :: Grid
type(ocean_time_type), intent(in)                               :: Time
integer, dimension(isd:,jsd:), intent(in)                       :: grid_kmt
real, dimension(isd:,jsd:,:), intent(in)                        :: depth_zt
real, dimension(isd:,jsd:,:,:), intent(in)                      :: rho
real, dimension(isd:,jsd:,:,:), intent(in)                      :: rho_dzt
real, dimension(isd:,jsd:,:), intent(in)                        :: dzt
real, dimension(isd:,jsd:), intent(in)                          :: hblt_depth
real, intent(in)                                                :: dtts
integer :: i, j, k, n

integer :: ind_ideal_n
integer :: ind_suntan
integer :: ind_ipo4_pre
integer :: ind_idic_pre
integer :: ind_isio4
integer :: ind_i30sio4
integer :: ind_ipo4
integer :: ind_idop
integer :: ind_i15no3
integer :: ind_in18o3
integer :: ind_ido15n
integer :: ind_ichl
integer :: ind_ipo4f
integer :: ind_idopf
integer :: ind_ife
integer :: ind_irr
integer :: ind_irrmem
integer :: ind_io2
integer :: ind_idic
integer :: ind_idi14c
integer :: ind_ido14c

integer :: kblt

real :: epsln = 1.0e-30
real :: tmp_irr
real :: tmp_hblt

logical :: used

real,dimension(isc:iec,jsc:jec,1:nk)             :: expkT
real,dimension(isc:iec,jsc:jec,1:nk)             :: expkT_remin
real,dimension(isc:iec,jsc:jec,1:nk)             :: irr_mix

real,dimension(isc:iec,jsc:jec,1:nk)             :: wsink

real,dimension(isc:iec,jsc:jec,1:nk)             :: jprod_ip
real,dimension(isc:iec,jsc:jec,1:nk)             :: jprod_ipf
real,dimension(isc:iec,jsc:jec,1:nk)             :: jprod_ip_bgc
real,dimension(isc:iec,jsc:jec,1:nk)             :: jprod_i15n
real,dimension(isc:iec,jsc:jec,1:nk)             :: jprod_i14c

real,dimension(isc:iec,jsc:jec,1:nk)             :: fe_ligand
real,dimension(isc:iec,jsc:jec,1:nk)             :: ligand
real,dimension(isc:iec,jsc:jec,1:nk)             :: scav_k

real,dimension(isc:iec,jsc:jec,1:nk)             :: cideal_n
real,dimension(isc:iec,jsc:jec,1:nk)             :: cisio4
real,dimension(isc:iec,jsc:jec,1:nk)             :: ci30sio4
real,dimension(isc:iec,jsc:jec,1:nk)             :: cipo4
real,dimension(isc:iec,jsc:jec,1:nk)             :: cidop
real,dimension(isc:iec,jsc:jec,1:nk)             :: cido15n
real,dimension(isc:iec,jsc:jec,1:nk)             :: cichl
real,dimension(isc:iec,jsc:jec,1:nk)             :: cipo4f
real,dimension(isc:iec,jsc:jec,1:nk)             :: cidopf
real,dimension(isc:iec,jsc:jec,1:nk)             :: cife
real,dimension(isc:iec,jsc:jec,1:nk)             :: cidic
real,dimension(isc:iec,jsc:jec,1:nk)             :: cido14c

! SOURCES

! Calculate the source component fluxes for each of the ideal 
! nutrient tracers.

!  Loop over multiple instances
do n = 1, instances

! Use shortened naming convention for indices
  ind_irr = fm_get_index('/ocean_mod/diag_tracers/irr')
if (do_ideal) then
  ind_ideal_n = ibgc(n)%ind_ideal_n
  ind_suntan = ibgc(n)%ind_suntan
endif
if (do_po4) then
  ind_ipo4 = ibgc(n)%ind_ipo4
  ind_idop = ibgc(n)%ind_idop
endif
if (do_po4f) then
  ind_ipo4f = ibgc(n)%ind_ipo4f
  ind_idopf = ibgc(n)%ind_idopf
  ind_ife = ibgc(n)%ind_ife
endif
if ((do_po4f) .or. (do_po4)) then
  ind_irrmem = ibgc(n)%ind_irrmem
  ind_ichl = ibgc(n)%ind_ichl
endif
if (do_gasses) then
  ind_io2 = ibgc(n)%ind_io2
  ind_idic = ibgc(n)%ind_idic
endif
if (do_radiocarbon) then
  ind_idi14c = ibgc(n)%ind_idi14c
  ind_ido14c = ibgc(n)%ind_ido14c
endif
if (do_no3_iso) then
  ind_i15no3 = ibgc(n)%ind_i15no3
  ind_in18o3 = ibgc(n)%ind_in18o3
  ind_ido15n = ibgc(n)%ind_ido15n
endif
if (do_isio4) then
  ind_isio4 = ibgc(n)%ind_isio4
  ind_i30sio4 = ibgc(n)%ind_i30sio4
endif

! Calculate positive tracer concentrations for relevant variables
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
        irr_mix(i,j,k) = t_diag(ind_irr)%field(i,j,k)
  enddo; enddo ; enddo
if (do_ideal) then
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
        cideal_n(i,j,k)  = max(0.0,t_prog(ind_ideal_n)%field(i,j,k,taum1))
  enddo; enddo ; enddo
endif
if (do_po4) then
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
        cipo4(i,j,k)  = max(0.0,t_prog(ind_ipo4)%field(i,j,k,taum1))
        cidop(i,j,k)  = max(0.0,t_prog(ind_idop)%field(i,j,k,taum1))
  enddo; enddo ; enddo
endif
if (do_po4f) then
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
        cipo4f(i,j,k)  = max(0.0,t_prog(ind_ipo4f)%field(i,j,k,taum1))
        cidopf(i,j,k)  = max(0.0,t_prog(ind_idopf)%field(i,j,k,taum1))
        cife(i,j,k)  = max(0.0,t_prog(ind_ife)%field(i,j,k,taum1))
  enddo; enddo ; enddo
endif
if ((do_po4f) .or. (do_po4)) then
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
        cichl(i,j,k)  = max(0.0,t_diag(ind_ichl)%field(i,j,k))
  enddo; enddo ; enddo
endif
if (do_gasses) then
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
        cidic(i,j,k)  = max(0.0,t_prog(ind_idic)%field(i,j,k,taum1))
  enddo; enddo ; enddo
endif
if (do_radiocarbon) then
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
        cido14c(i,j,k)  = max(0.0,t_prog(ind_ido14c)%field(i,j,k,taum1))
  enddo; enddo ; enddo
endif
if (do_no3_iso) then
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
        cido15n(i,j,k)  = max(0.0,t_prog(ind_ido15n)%field(i,j,k,taum1))
  enddo; enddo ; enddo
endif
if (do_isio4) then
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
        cisio4(i,j,k)  = max(0.0,t_prog(ind_isio4)%field(i,j,k,taum1))
        ci30sio4(i,j,k)  = max(0.0,t_prog(ind_i30sio4)%field(i,j,k,taum1))
  enddo; enddo ; enddo
endif


! The light used for uptake-limitation is the average irradiance within 
! the actively mixed layer, as defined in the KPP routine, plus an
! additional layer to account for mixing directly below the boundary.
  do j = jsc, jec
    do i = isc, iec
      kblt=1
      tmp_irr = irr_mix(i,j,1) * dzt(i,j,1)
      tmp_hblt = dzt(i,j,1)
      do k = 2, nk
        if (tmp_hblt .lt. hblt_depth(i,j)) then
          kblt=kblt+1
          tmp_irr = tmp_irr + irr_mix(i,j,k) * dzt(i,j,k)
          tmp_hblt = tmp_hblt + dzt(i,j,k)
        endif
      enddo
      irr_mix(i,j,1:kblt) = tmp_irr / max(1.0e-6,tmp_hblt)
    enddo
  enddo

  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
     ! Temperature functionality of export and remineralization

     ! After Eppley (1972). The eppley constant in use is 0.6 of the normal
     ! value (0.0378 rather than 0.063). In addition, the remineralization 
     ! temperature dependence is only 2/3 of that used for growth. This was 
     ! an arbitrary change, to reduce hypercycling in tropics.

       expkT(i,j,k) = exp(ibgc(n)%kappa_eppley *                           &
         t_prog(indtemp)%field(i,j,k,taum1))
       
       expkT_remin(i,j,k) = exp(ibgc(n)%kappa_eppley_remin *               &
          t_prog(indtemp)%field(i,j,k,taum1))

  enddo; enddo ; enddo

if (do_ideal) then
   ! NON-CONSERVATIVE TRACERS

   ! Ideal Nutrient

   ! Source function: 
   ! dN/dT = -Vmax * expkT * (1 - exp(-IRR/IRRk)) * (N / (N + k)) + expkT * R
   ! Do not allow the concentration of Ideal Nutrient to go above 1.
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec

      if (cideal_n(i,j,k) .lt. 1.) then
        ibgc(n)%jideal_n(i,j,k) = -ibgc(n)%ideal_n_vmax *                  &
        expkT(i,j,k) * (1.0 - exp(- irr_mix(i,j,k) /                       &
        ibgc(n)%irrk)) * cideal_n(i,j,k) / (cideal_n(i,j,k) +              &
        ibgc(n)%ideal_n_k) + expkT(i,j,k) * ibgc(n)%ideal_n_r *            &
        grid_tmask(i,j,k)                
      else
        ibgc(n)%jideal_n(i,j,k) = -ibgc(n)%ideal_n_vmax * (1.0 -           &
        exp(- irr_mix(i,j,k) / ibgc(n)%irrk)) *                            &
        cideal_n(i,j,k) / (cideal_n(i,j,k) + ibgc(n)%ideal_n_k) *          &
        grid_tmask(i,j,k)
      endif

      ! Suntan

      ! Source function: dS/dT = IRR / (layer thickness) - f
      ! This needs to be fixed - not to be used now.
       if (t_prog(ind_suntan)%field(i,j,k,taum1) .gt. 0.0) then
         ibgc(n)%jsuntan(i,j,k) = (t_diag(ind_irr)%field(i,j,k)            &
          - ibgc(n)%suntan_fade) / dzt(i,j,k)  * grid_tmask(i,j,k)
       else
         ibgc(n)%jsuntan(i,j,k) = t_diag(ind_irr)%field(i,j,k)             &
         / dzt(i,j,k) * grid_tmask(i,j,k)
       endif

  enddo; enddo ; enddo

endif

! CONSERVATIVE TRACERS

! UPTAKE

! Ideal Phosphate
! Option provides 2 types of P: normal, and iron-limited.

if (do_po4) then
   ! Ideal Phosphate with DOP

   ! Ideal phosphate is done as before, but with a dissolved organic 
   ! phosphorus pool, after Yamanaka and Tajika (1997). A fraction (idop_frac) 
   ! of the total production (jprod_ip) is instantly converted to the dissolved 
   ! pool, while the remainder goes into the sinking particulate pool. This
   ! 'dissolved' organic phosphorus should be thought of as the sum of all 
   ! non-sinking organic matter, from small molecules to plankton to whales, 
   ! and is therefore not directly comparable to real DOP. Thus, the DOP
   ! concentrations and distributions should not necessarily match those of 
   ! the ocean - iBGC should probably have higher-than-observed concentrations
   ! in general, especially in nutrient-rich regions.

 do k = 1, nk ; do j = jsc, jec ; do i = isc, iec

        jprod_ip(i,j,k) = ibgc(n)%ipo4_vmax * expkT(i,j,k) *               &
          (1.0 - exp(- irr_mix(i,j,k) / ibgc(n)%irrk)) *                   &         
          cipo4(i,j,k) / (cipo4(i,j,k) + ibgc(n)%ipo4_k) * grid_tmask(i,j,k)                              

        ibgc(n)%jprod_idop(i,j,k) = jprod_ip(i,j,k) * ibgc(n)%idop_frac                             

        ibgc(n)%jprod_pip(i,j,k) = jprod_ip(i,j,k) -                       &
          ibgc(n)%jprod_idop(i,j,k)

  enddo; enddo ; enddo

endif

if (do_po4f) then

   ! Iron cycling and growth limitation

   ! Iron is input in the upper 100m of the water column at a globally uniform 
   ! rate, intended to represent the sum of aeolian deposition and sediment-
   ! derived iron, without imposing geographical source distributions.

   ! Growth is limited by iron and phosphate concentrations, with iron 
   ! limitation expressed as an accentuator of light limitation, in 
   ! accordance with iron's role as an accessory in photosynthesis (e.g. 
   ! Strzepek et al., 2005). Iron uptake is a product of p uptake and  
   ! the iron concentration, to allow flexible stoichiometry and luxury 
   ! uptake. 

   ! The associated PO4 and DOP are called ipo4f and ipo4d, respectively.

   ! Iron taken up by organisms is assumed to be bound within organic matter
   ! until remineralized from a sinking particle. Sinking and remineralization 
   ! are identical to ipo4. Iron is also scavenged, further below.

   ! Iron source: spread over upper 100m and convert to mmol kg-1 s-1 
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec

        if (depth_zt(i,j,k) .lt. 100.) then
          ibgc(n)%jife_new(i,j,k) = ibgc(n)%ife_supply * 0.01 /            &
            (rho(i,j,k,taum1) + epsln) * grid_tmask(i,j,k)
        else
          ibgc(n)%jife_new(i,j,k) = 0.0
        endif
        
        ! Growth and uptake
        ! dP/dT = -Vmax * expkT * (1 - exp(-IRR/IRRFek) * (P / P + kP)
        ! where IRRFek = IRRk * Fesuf / (Fe + x) where x is a small number to 
        ! prevent 'infinite' iron limitation.
        ! The idea here is that Fe helps phytoplankton harvest light, so that iron 
        ! limitation hampers the phytoplankton's ability to grow at a given light 
        ! level. With brighter light less iron is required, while with abundant iron 
        ! less light is required.
        ibgc(n)%felim_irrk(i,j,k) = ibgc(n)%irrk *                         &
           ibgc(n)%ife_irrsuf / (cife(i,j,k) + 1.e-8) 

        jprod_ipf(i,j,k) = ibgc(n)%ipo4f_vmax * expkT(i,j,k) *             &
          (1.0 - exp(- irr_mix(i,j,k) / ibgc(n)%felim_irrk(i,j,k)))*       &         
          min(cipo4f(i,j,k) / (cipo4f(i,j,k) + ibgc(n)%ipo4_k),            &
          cife(i,j,k) / ibgc(n)%ife_irrsuf)*                               &
          grid_tmask(i,j,k)                              

        ibgc(n)%jprod_idopf(i,j,k) = jprod_ipf(i,j,k) * ibgc(n)%idop_frac                             

        ibgc(n)%jprod_pipf(i,j,k) = jprod_ipf(i,j,k) -                     &
          ibgc(n)%jprod_idopf(i,j,k)

        ! Biological uptake        
        ibgc(n)%jprod_pife(i,j,k) =   ibgc(n)%jprod_pipf(i,j,k) *          &
          cife(i,j,k) / ibgc(n)%ife_irrsuf

  enddo; enddo ; enddo

endif

if ((do_po4f) .or. (do_po4)) then
! Does BGC use Fe-limited P, or non-Fe-limited P?
! Default is non-Fe-limited P (iPO4).

! This part sets the jprod_ip and po4 to be used for the fluxes of 
! other elements (chl, isotopes, O2, DIC etc), called *_bgc.
if (do_bgc_felim) then
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
      jprod_ip_bgc(i,j,k) = jprod_ipf(i,j,k)
      ibgc(n)%ipo4_bgc(i,j,k) = t_prog(ind_ipo4f)%field(i,j,k,taum1)
  enddo; enddo ; enddo
else
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
      jprod_ip_bgc(i,j,k) = jprod_ip(i,j,k)
      ibgc(n)%ipo4_bgc(i,j,k) = t_prog(ind_ipo4)%field(i,j,k,taum1)
  enddo; enddo ; enddo
endif

! Ideal Chlorophyll

! Chlorophyll is an important determinant of the absorption of shortwave 
! radiation in seawater, thereby influencing the circulation. In order to 
! capture this effect in a prognostic, interactive sense with the minimum 
! possible complexity, we link the formation of chlorophyll to the uptake 
! of inorganic nutrients, modulated by the available light (with 
! phytoplankton producing relatively less chlorophyll under very intense 
! light) following Behrenfeld et al., 2005. Because chlorophyll cannot 
! react instantaneously to changes in light and uptake, but would be 
! expected to respond only on the timescale of phytoplankton lifetimes 
! (days), we introduce two lag terms. First, an 'irradiance memory' term 
! that smoothes the available light, representing photoadaptation; second, 
! a chlorophyll lag that smoothes the diagnostic ichl concentration, 
! representing the delay of community growth and mortality, reducing
! short-term excursions (and preventing zero values appearing overnight!).
!
! A better way to do this would be to diagnose a biomass from some 
! nonlinear function of the growth rate, calculate the theta from the
! irrmem and iron (if used), and multiply them together to get a
! chlorophyll.
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec

        t_diag(ind_irrmem)%field(i,j,k) = t_diag(ind_irrmem)%field(i,j,k)+ &
         (irr_mix(i,j,k) - t_diag(ind_irrmem)%field(i,j,k)) * min(1.0,     &
         ibgc(n)%ichl_lag * dtts) * grid_tmask(i,j,k)
         
        ibgc(n)%ichl_new(i,j,k) = jprod_ip_bgc(i,j,k) *                    &
          ibgc(n)%uptake_2_chl * (ibgc(n)%ichl_highlight + (1. -           &
          ibgc(n)%ichl_highlight) * exp (-0.05 *                           &
          t_diag(ind_irrmem)%field(i,j,k))) * grid_tmask(i,j,k)

        t_diag(ind_ichl)%field(i,j,k) = cichl(i,j,k) +                     & 
          (ibgc(n)%ichl_new(i,j,k) - cichl(i,j,k)) *                       &
          min(1.0, ibgc(n)%ichl_lag * dtts)         

  enddo; enddo ; enddo

endif

if (do_no3_iso) then
   ! Ideal Nitrate isotopes - with DOM

   ! Identical to implementation without DOM, except that a fraction of the 
   ! 15N taken up goes into the DOM pool. 
   ! The total uptake fractionation is the same, and there is no fractionation
   ! between particulate and dissolved organic forms.
   do k = 1, nk ; do j = jsc, jec ; do i = isc, iec

       jprod_i15n(i,j,k) = jprod_ip_bgc(i,j,k) *                           &
         t_prog(ind_i15no3)%field(i,j,k,taum1) /                           &
         (epsln + ibgc(n)%ipo4_bgc(i,j,k)) /                               &
         ibgc(n)%alpha_14n_15n * grid_tmask(i,j,k)

       ibgc(n)%jprod_ido15n(i,j,k) = jprod_i15n(i,j,k) * ibgc(n)%idop_frac                             

       ibgc(n)%jprod_pi15n(i,j,k) = jprod_i15n(i,j,k) -                   &
         ibgc(n)%jprod_ido15n(i,j,k)

       ibgc(n)%jprod_i18o(i,j,k) = jprod_ip_bgc(i,j,k) *                  &
         t_prog(ind_in18o3)%field(i,j,k,taum1) /                          &
         (epsln + ibgc(n)%ipo4_bgc(i,j,k)) /                              &
         ibgc(n)%alpha_14n_15n * grid_tmask(i,j,k)

  enddo; enddo ; enddo
  
endif

if (do_radiocarbon) then
   ! Ideal Carbon isotopes - with DOM

   ! The uptake is done in the same way as N and  Si isotopes, to account for 
   ! the biological impact on 14C due to uptake and remineralization of DIC. 
   ! Because the convention for D14C notation includes an implicit correction 
   ! for mass-dependent fractionation (calculated from the observed d13C of 
   ! the same sample), uptake fractionation is not included.
   do k = 1, nk ; do j = jsc, jec ; do i = isc, iec

       jprod_i14c(i,j,k) = jprod_ip_bgc(i,j,k) * ibgc(n)%c_2_ip *          &
         grid_tmask(i,j,k) * t_prog(ind_idi14c)%field(i,j,k,taum1) /       &
         (epsln + t_prog(ind_idic)%field(i,j,k,taum1))
         
       ibgc(n)%jprod_ido14c(i,j,k) = jprod_i14c(i,j,k) *                   &
         ibgc(n)%idop_frac                             

       ibgc(n)%jprod_pi14c(i,j,k) = jprod_i14c(i,j,k) -                    & 
         ibgc(n)%jprod_ido14c(i,j,k)

  enddo; enddo ; enddo

endif

if (do_isio4) then
   ! Ideal Silicate

   ! Uptake function: dN/dT = -Vmax * (1 - exp(-IRR/IRRk) * (N / N + k)
   ! Identical to Ideal Phosphate (without DOP), with different constants.
   do k = 1, nk ; do j = jsc, jec ; do i = isc, iec

       ibgc(n)%jprod_pisi(i,j,k) = ibgc(n)%ipo4_vmax * expkT(i,j,k) *      &
          (1.0 - exp(- irr_mix(i,j,k) / ibgc(n)%irrk)) *                   &
          cisio4(i,j,k)  / (cisio4(i,j,k)                                  &
          + ibgc(n)%ipo4_k) * grid_tmask(i,j,k)                              

       ! Ideal Silicon isotopes
       ! The uptake is given by the uptake of SiO4 (total silicate), 
       ! multiplied by the rate ratio alpha.
       ibgc(n)%jprod_pi30si(i,j,k) = ibgc(n)%jprod_pisi(i,j,k) *           &
         t_prog(ind_i30sio4)%field(i,j,k,taum1) /                          &
         (epsln + t_prog(ind_isio4)%field(i,j,k,taum1)) /                  &
         ibgc(n)%alpha_28si_30si * grid_tmask(i,j,k)                     

  enddo; enddo ; enddo

endif

  ! SINKING AND REMINERALIZATION

  ! First, convert all ideal particulate production in the first layer to 
  ! particulate flux, no remineralization.
  do j=jsc,jec
    do i=isc,iec

      ibgc(n)%fpisi(i,j,1) = ibgc(n)%jprod_pisi(i,j,1) *                   &
        rho_dzt(i,j,1,taum1) * grid_tmask(i,j,1)
      ibgc(n)%jremin_pisi(i,j,1) = 0.0

      ibgc(n)%fpi30si(i,j,1) = ibgc(n)%jprod_pi30si(i,j,1) *               &
        rho_dzt(i,j,1,taum1) * grid_tmask(i,j,1)
      ibgc(n)%jremin_pi30si(i,j,1) = 0.0

      ibgc(n)%fpi14c(i,j,1) = ibgc(n)%jprod_pi14c(i,j,1) *                 &
        rho_dzt(i,j,1,taum1) * grid_tmask(i,j,1)
      ibgc(n)%jremin_pi14c(i,j,1) = 0.0

      ibgc(n)%fpip(i,j,1) = ibgc(n)%jprod_pip(i,j,1) *                     &
        rho_dzt(i,j,1,taum1) * grid_tmask(i,j,1)
      ibgc(n)%jremin_pip(i,j,1) = 0.0

      ibgc(n)%fpi15n(i,j,1) = ibgc(n)%jprod_pi15n(i,j,1) *               &
        rho_dzt(i,j,1,taum1) * grid_tmask(i,j,1)
      ibgc(n)%jremin_pi15n(i,j,1) = 0.0

      ibgc(n)%fpipf(i,j,1) = ibgc(n)%jprod_pipf(i,j,1) *                   &
        rho_dzt(i,j,1,taum1) * grid_tmask(i,j,1)
      ibgc(n)%jremin_pipf(i,j,1) = 0.0

      ibgc(n)%fpife(i,j,1) = ibgc(n)%jprod_pife(i,j,1) *                   &
        rho_dzt(i,j,1,taum1) * grid_tmask(i,j,1)
      ibgc(n)%jremin_pife(i,j,1) = 0.0

    enddo
  enddo

 do k = 2, nk
    do j = jsc, jec
      do i = isc, iec
         ! Rest of water column

         ! Calculate the remineralization lengthscale matrix, remin, a function of 
         ! T and z. Sinking rate (wsink) increases linearly with depth from an 
         ! initial value. Everything uses the remin_ip (no DOM) or remin_ip (with 
         ! DOM) values except for silica.
        wsink(i,j,k) = (ibgc(n)%sinking_acc * depth_zt(i,j,k) +            &
          ibgc(n)%sinking_init) * grid_tmask(i,j,k)

        ibgc(n)%remin_ip(i,j,k) = ibgc(n)%gamma_ip * expkT_remin(i,j,k) /  &
          (wsink(i,j,k) + epsln)
          
        ibgc(n)%remin_isi(i,j,k) = ibgc(n)%gamma_isi * expkT_remin(i,j,k)/ &
          (wsink(i,j,k) + epsln)

        ! Calculate the flux at level k from the flux in the overlying layer and
        ! the local remineralization lengthscale.
        ibgc(n)%fpisi(i,j,k) = ibgc(n)%fpisi(i,j,k-1) /                    &
          (1.0 + dzt(i,j,k) * ibgc(n)%remin_isi(i,j,k)) * grid_tmask(i,j,k)

        ibgc(n)%fpi30si(i,j,k) = ibgc(n)%fpi30si(i,j,k-1) /                &
          (1.0 + dzt(i,j,k) * ibgc(n)%remin_isi(i,j,k)) * grid_tmask(i,j,k)

        ibgc(n)%fpi14c(i,j,k) = ibgc(n)%fpi14c(i,j,k-1) /                  &
          (1.0 + dzt(i,j,k) * ibgc(n)%remin_ip(i,j,k)) * grid_tmask(i,j,k)

         ibgc(n)%fpip(i,j,k) = ibgc(n)%fpip(i,j,k-1) /                     &
          (1.0 + dzt(i,j,k) * ibgc(n)%remin_ip(i,j,k)) * grid_tmask(i,j,k)

        ibgc(n)%fpi15n(i,j,k) = ibgc(n)%fpi15n(i,j,k-1) /                  &
          (1.0 + dzt(i,j,k) * ibgc(n)%remin_ip(i,j,k)) * grid_tmask(i,j,k)

        ibgc(n)%fpipf(i,j,k) = ibgc(n)%fpipf(i,j,k-1) /                    &
          (1.0 + dzt(i,j,k) * ibgc(n)%remin_ip(i,j,k)) * grid_tmask(i,j,k)

        ibgc(n)%fpife(i,j,k) = ibgc(n)%fpife(i,j,k-1) /                    &
          (1.0 + dzt(i,j,k) * ibgc(n)%remin_ip(i,j,k)) * grid_tmask(i,j,k)

        ! Calculate regeneration term assuming flux through bottom of grid cell
        ibgc(n)%jremin_pisi(i,j,k) = (ibgc(n)%fpisi(i,j,k-1) -             &
          ibgc(n)%fpisi(i,j,k)) * grid_tmask(i,j,k) / rho_dzt(i,j,k,taum1)

        ibgc(n)%jremin_pi30si(i,j,k) = (ibgc(n)%fpi30si(i,j,k-1) -         &
          ibgc(n)%fpi30si(i,j,k)) * grid_tmask(i,j,k) / rho_dzt(i,j,k,taum1)

        ibgc(n)%jremin_pi14c(i,j,k) = (ibgc(n)%fpi14c(i,j,k-1) -           &
          ibgc(n)%fpi14c(i,j,k)) * grid_tmask(i,j,k) / rho_dzt(i,j,k,taum1)

        ibgc(n)%jremin_pip(i,j,k) = (ibgc(n)%fpip(i,j,k-1) -               &
          ibgc(n)%fpip(i,j,k)) * grid_tmask(i,j,k) / rho_dzt(i,j,k,taum1)

        ibgc(n)%jremin_pi15n(i,j,k) = (ibgc(n)%fpi15n(i,j,k-1) -           &
          ibgc(n)%fpi15n(i,j,k)) * grid_tmask(i,j,k) / rho_dzt(i,j,k,taum1)

        ibgc(n)%jremin_pipf(i,j,k) = (ibgc(n)%fpipf(i,j,k-1) -             &
          ibgc(n)%fpipf(i,j,k)) * grid_tmask(i,j,k) / rho_dzt(i,j,k,taum1)

        ibgc(n)%jremin_pife(i,j,k) = (ibgc(n)%fpife(i,j,k-1) -             &
          ibgc(n)%fpife(i,j,k)) * grid_tmask(i,j,k) / rho_dzt(i,j,k,taum1)

        ! Add production within box to flux assuming flux through bottom of
        ! grid cell
        ibgc(n)%fpisi(i,j,k) = (ibgc(n)%fpisi(i,j,k) +                     & 
          ibgc(n)%jprod_pisi(i,j,k) * rho_dzt(i,j,k,taum1)) *              & 
          grid_tmask(i,j,k)

        ibgc(n)%fpi30si(i,j,k) = (ibgc(n)%fpi30si(i,j,k) +                 & 
          ibgc(n)%jprod_pi30si(i,j,k) * rho_dzt(i,j,k,taum1)) *            &
          grid_tmask(i,j,k)

        ibgc(n)%fpi14c(i,j,k) = (ibgc(n)%fpi14c(i,j,k) +                   & 
          ibgc(n)%jprod_pi14c(i,j,k) * rho_dzt(i,j,k,taum1)) *             &  
          grid_tmask(i,j,k)

        ibgc(n)%fpip(i,j,k) = (ibgc(n)%fpip(i,j,k) +                       & 
          ibgc(n)%jprod_pip(i,j,k) * rho_dzt(i,j,k,taum1)) *               & 
          grid_tmask(i,j,k)

        ibgc(n)%fpi15n(i,j,k) = (ibgc(n)%fpi15n(i,j,k) +                   &  
          ibgc(n)%jprod_pi15n(i,j,k) * rho_dzt(i,j,k,taum1)) *             & 
          grid_tmask(i,j,k)

        ibgc(n)%fpipf(i,j,k) = (ibgc(n)%fpipf(i,j,k) +                     & 
          ibgc(n)%jprod_pipf(i,j,k) * rho_dzt(i,j,k,taum1)) *              &  
          grid_tmask(i,j,k)

        ibgc(n)%fpife(i,j,k) = (ibgc(n)%fpife(i,j,k) +                     & 
          ibgc(n)%jprod_pife(i,j,k) * rho_dzt(i,j,k,taum1)) *              & 
          grid_tmask(i,j,k)
 
      enddo
    enddo
  enddo

  ! Remineralize everything remaining in the bottom cell
  do j = jsc, jec
    do i = isc, iec
      k = grid_kmt(i,j)

      if (k .gt. 0) then

        ibgc(n)%jremin_pisi(i,j,k) = (ibgc(n)%jremin_pisi(i,j,k) +         &
          ibgc(n)%fpisi(i,j,k) / rho_dzt(i,j,k,taum1)) * grid_tmask(i,j,k)

        ibgc(n)%jremin_pi30si(i,j,k) = (ibgc(n)%jremin_pi30si(i,j,k) +     &
          ibgc(n)%fpi30si(i,j,k) / rho_dzt(i,j,k,taum1)) * grid_tmask(i,j,k)

        ibgc(n)%jremin_pi14c(i,j,k) = (ibgc(n)%jremin_pi14c(i,j,k) +       &
          ibgc(n)%fpi14c(i,j,k) / rho_dzt(i,j,k,taum1)) * grid_tmask(i,j,k)

        ibgc(n)%jremin_pip(i,j,k) = (ibgc(n)%jremin_pip(i,j,k) +           &
          ibgc(n)%fpip(i,j,k) / rho_dzt(i,j,k,taum1)) * grid_tmask(i,j,k)

        ibgc(n)%jremin_pi15n(i,j,k) = (ibgc(n)%jremin_pi15n(i,j,k) +       &
          ibgc(n)%fpi15n(i,j,k) / rho_dzt(i,j,k,taum1)) * grid_tmask(i,j,k)

        ibgc(n)%jremin_pipf(i,j,k) = (ibgc(n)%jremin_pipf(i,j,k) +         &
          ibgc(n)%fpipf(i,j,k) / rho_dzt(i,j,k,taum1)) * grid_tmask(i,j,k)

        ibgc(n)%jremin_pife(i,j,k) = (ibgc(n)%jremin_pife(i,j,k) +         &
          ibgc(n)%fpife(i,j,k) / rho_dzt(i,j,k,taum1)) * grid_tmask(i,j,k)

      endif

    enddo
  enddo

   ! Remineralize the dissolved organic matter, as a function of the first 
   ! order decay constant, and sum the remineralization and uptake sources. 
   do k = 1, nk ; do j = jsc, jec ; do i = isc, iec

      ibgc(n)%jremin_idop(i,j,k) = (ibgc(n)%gamma_idop *                   &
        expkT_remin(i,j,k) * cidop(i,j,k)) * grid_tmask(i,j,k)
      
      ibgc(n)%jipo4(i,j,k) = (ibgc(n)%jremin_idop(i,j,k) -                 &
          ibgc(n)%jprod_pip(i,j,k) - ibgc(n)%jprod_idop(i,j,k)) *          &
          grid_tmask(i,j,k)

      ibgc(n)%jremin_idopf(i,j,k) = (ibgc(n)%gamma_idop *                  &
        expkT_remin(i,j,k) * cidopf(i,j,k)) * grid_tmask(i,j,k)
      
      ibgc(n)%jipo4f(i,j,k) = (ibgc(n)%jremin_idopf(i,j,k) -               &
          ibgc(n)%jprod_pipf(i,j,k) - ibgc(n)%jprod_idopf(i,j,k)) *        &
          grid_tmask(i,j,k)

      ibgc(n)%jremin_ido15n(i,j,k) = (ibgc(n)%gamma_idop *                 &
        expkT_remin(i,j,k) * cido15n(i,j,k)) * grid_tmask(i,j,k)
      
      ibgc(n)%ji15no3(i,j,k) = (ibgc(n)%jremin_ido15n(i,j,k) -             &
          ibgc(n)%jprod_pi15n(i,j,k) - ibgc(n)%jprod_ido15n(i,j,k)) *      &
          grid_tmask(i,j,k)
          
      ibgc(n)%jremin_ido14c(i,j,k) = (ibgc(n)%gamma_idop *                 &
        expkT_remin(i,j,k) * cido14c(i,j,k)) * grid_tmask(i,j,k)
      
      ibgc(n)%jidi14c(i,j,k) = (ibgc(n)%jremin_ido14c(i,j,k) -             &
          ibgc(n)%jprod_pi14c(i,j,k) - ibgc(n)%jprod_ido14c(i,j,k)) *      &
          grid_tmask(i,j,k)
          
  enddo; enddo ; enddo

if ((do_po4f) .or. (do_po4)) then
! Does BGC use Fe-limited P, or non-Fe-limited P?
! Default is non-Fe-limited P (iPO4).
! This is done now for jipo4_bgc.
if (do_bgc_felim) then
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
      ibgc(n)%jipo4_bgc(i,j,k) = ibgc(n)%jipo4f(i,j,k)
  enddo; enddo ; enddo
else
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
      ibgc(n)%jipo4_bgc(i,j,k) = ibgc(n)%jipo4(i,j,k)
  enddo; enddo ; enddo
endif

endif

if (do_po4f) then

   ! Iron scavenging
   do k = 1, nk ; do j = jsc, jec ; do i = isc, iec

! Calculate the Ligand complexation throughout the full domain.
! This is used for scavenging only; it's assumed that phytoplankton are 
! able to access all iron, regardless of complexation.
! The calculation used here came from Parekh.

        ligand(i,j,k) = (-ibgc(n)%ligand_k * cife(i,j,k) +                 &
          ibgc(n)%ligand_k * ibgc(n)%ligand_tot - 1. +                     &
          ((ibgc(n)%ligand_k * cife(i,j,k) - ibgc(n)%ligand_k *            &
          ibgc(n)%ligand_tot + 1.) **2 + 4. * ibgc(n)%ligand_k *           &
          ibgc(n)%ligand_tot) ** 0.5) / (2. * ibgc(n)%ligand_k) *          &
          grid_tmask(i,j,k)

        fe_ligand(i,j,k) = (ibgc(n)%ligand_tot - ligand(i,j,k)) *          &
          grid_tmask(i,j,k)

        ibgc(n)%ife_free(i,j,k) = cife(i,j,k) - fe_ligand(i,j,k)

        ! Calculate the loss of Fe due to scavenging. This is done in the
        ! absolute simplest way, as a first order rate constant.
        ibgc(n)%jife_scav(i,j,k) = ibgc(n)%scav_k * ibgc(n)%ife_free(i,j,k)

  enddo; enddo ; enddo

endif

if (do_gasses) then
    do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
! O2

! Oxygen is produced by photosynthesis and consumed by respiration, the two 
! biological processes which simultaneously cause, respectively, the 
! consumption and remineralization of inorganic nutrients. Assuming a 
! constant stoichiometric ratio between oxygen and iPO4 allows oxygen to be 
! calculated simply as a function of the iPO4 source terms. 
! Oxygen consumption is not allowed to occur below a very low threshold 
! concentration (o2_min), in order to avoid negative tracer values. Note 
! that reminerization continues at the same rate irrespective of oxygen 
! concentrations. This is not realistic, and will lead to very large O2
! minimum zones.

        if (t_prog(ind_io2)%field(i,j,k,taum1) .gt. ibgc(n)%io2_min) then
          ibgc(n)%jio2(i,j,k) = -ibgc(n)%o2_2_ip * grid_tmask(i,j,k) *      &
          ibgc(n)%jipo4_bgc(i,j,k)
        else
          ibgc(n)%jio2(i,j,k) = ibgc(n)%o2_2_ip * grid_tmask(i,j,k) *      &
          jprod_ip_bgc(i,j,k)
        endif
  enddo; enddo ; enddo

if (do_radiocarbon) then
    ! Compute DI14C decay. This depends on the decay rate constant, lambda_14c.
    do k = 1, nk ; do j = jsc, jec ; do i = isc, iec

        ibgc(n)%jdecay_idi14c(i,j,k) =                                     &
          t_prog(ind_idi14c)%field(i,j,k,taum1) * ibgc(n)%lambda_14c *     &
          grid_tmask(i,j,k)

        ibgc(n)%jdecay_ido14c(i,j,k) =                                     &
          t_prog(ind_ido14c)%field(i,j,k,taum1) * ibgc(n)%lambda_14c *     &
          grid_tmask(i,j,k)
             
  enddo; enddo ; enddo
endif

endif

! ACCUMULATE SOURCES IN TENDENCY TERMS
!
! Calculate source/sink tendency terms for each prognostic tracer as the
! sum of fluxes generated above. These tendency terms are passed to the
! ocean model in units of mol m-3.

! All prognostic terms go inside this loop
if (do_ideal) then
   do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
      t_prog(ind_ideal_n)%th_tendency(i,j,k) =                             &
        t_prog(ind_ideal_n)%th_tendency(i,j,k) + ibgc(n)%jideal_n(i,j,k)   &
        * rho_dzt(i,j,k,taum1)

      t_prog(ind_suntan)%th_tendency(i,j,k) =                              &
        t_prog(ind_suntan)%th_tendency(i,j,k) + ibgc(n)%jsuntan(i,j,k) *   &
        dzt(i,j,k)  
  enddo; enddo ; enddo
endif

if (do_po4) then
   do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
      t_prog(ind_ipo4)%th_tendency(i,j,k) =                                &
        t_prog(ind_ipo4)%th_tendency(i,j,k) + ibgc(n)%jipo4(i,j,k) *       &
        rho_dzt(i,j,k,taum1)

      t_prog(ind_idop)%th_tendency(i,j,k) =                                &
        t_prog(ind_idop)%th_tendency(i,j,k) + (ibgc(n)%jprod_idop(i,j,k) - &
        ibgc(n)%jremin_idop(i,j,k) + ibgc(n)%jremin_pip(i,j,k)) *          &
         rho_dzt(i,j,k,taum1)
  enddo; enddo ; enddo
endif
 
if (do_po4f) then
   do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
      t_prog(ind_ipo4f)%th_tendency(i,j,k) =                               & 
        t_prog(ind_ipo4f)%th_tendency(i,j,k) + ibgc(n)%jipo4f(i,j,k) *     &
        rho_dzt(i,j,k,taum1)

      t_prog(ind_ife)%th_tendency(i,j,k) =                                 &
        t_prog(ind_ife)%th_tendency(i,j,k) + (ibgc(n)%jremin_pife(i,j,k) + &
        ibgc(n)%jife_new(i,j,k) - ibgc(n)%jprod_pife(i,j,k) -              &
         ibgc(n)%jife_scav(i,j,k)) * rho_dzt(i,j,k,taum1)

      t_prog(ind_idopf)%th_tendency(i,j,k) =                               & 
        t_prog(ind_idopf)%th_tendency(i,j,k) +                             &
        (ibgc(n)%jprod_idopf(i,j,k) - ibgc(n)%jremin_idopf(i,j,k) +        &
        ibgc(n)%jremin_pipf(i,j,k)) * rho_dzt(i,j,k,taum1)
  enddo; enddo ; enddo
endif
 
if (do_gasses) then
   do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
      t_prog(ind_io2)%th_tendency(i,j,k) =                                 & 
        t_prog(ind_io2)%th_tendency(i,j,k) + ibgc(n)%jio2(i,j,k) *         &
        rho_dzt(i,j,k,taum1)

      t_prog(ind_idic)%th_tendency(i,j,k) =                                & 
        t_prog(ind_idic)%th_tendency(i,j,k) + rho_dzt(i,j,k,taum1) *       &
        ibgc(n)%c_2_ip *  ibgc(n)%jipo4_bgc(i,j,k)
  enddo; enddo ; enddo
endif

if (do_radiocarbon) then
   do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
      t_prog(ind_idi14c)%th_tendency(i,j,k) =                              & 
        t_prog(ind_idi14c)%th_tendency(i,j,k) + (ibgc(n)%jidi14c(i,j,k) -  &
        ibgc(n)%jdecay_idi14c(i,j,k)) * rho_dzt(i,j,k,taum1)

      t_prog(ind_ido14c)%th_tendency(i,j,k) =                              &
        t_prog(ind_ido14c)%th_tendency(i,j,k) +                            &
        (ibgc(n)%jprod_ido14c(i,j,k) - ibgc(n)%jremin_ido14c(i,j,k) -      &
        ibgc(n)%jdecay_ido14c(i,j,k)+ibgc(n)%jremin_pi14c(i,j,k)) *        &
        rho_dzt(i,j,k,taum1)
  enddo; enddo ; enddo
endif

if (do_no3_iso) then
   do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
      t_prog(ind_i15no3)%th_tendency(i,j,k) =                             &
        t_prog(ind_i15no3)%th_tendency(i,j,k) +                           &
        ibgc(n)%ji15no3(i,j,k) * rho_dzt(i,j,k,taum1)

      t_prog(ind_ido15n)%th_tendency(i,j,k) =                              &
        t_prog(ind_ido15n)%th_tendency(i,j,k) +                            &
        (ibgc(n)%jprod_ido15n(i,j,k) - ibgc(n)%jremin_ido15n(i,j,k) +      &
        ibgc(n)%jremin_pi15n(i,j,k)) * rho_dzt(i,j,k,taum1)
          
      t_prog(ind_in18o3)%th_tendency(i,j,k) =                             &
        t_prog(ind_in18o3)%th_tendency(i,j,k) +                           &
        (ibgc(n)%jremin_idop(i,j,k) -                                      &
        ibgc(n)%jprod_i18o(i,j,k)) * rho_dzt(i,j,k,taum1)
  enddo; enddo ; enddo
endif

if (do_isio4) then
   do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
      t_prog(ind_isio4)%th_tendency(i,j,k) =                               &
        t_prog(ind_isio4)%th_tendency(i,j,k) +                             &
        (ibgc(n)%jremin_pisi(i,j,k) - ibgc(n)%jprod_pisi(i,j,k)) *         &
        rho_dzt(i,j,k,taum1)

      t_prog(ind_i30sio4)%th_tendency(i,j,k) =                             &
        t_prog(ind_i30sio4)%th_tendency(i,j,k) +                           &
        (ibgc(n)%jremin_pi30si(i,j,k) - ibgc(n)%jprod_pi30si(i,j,k)) *     &
        rho_dzt(i,j,k,taum1)
  enddo; enddo ; enddo
endif

enddo

! Save variables for diagnostics
call diagnose_3d_comp(Time, Grid, id_o2_sat, o2_sat(:,:,:))

do n = 1, instances
   call diagnose_2d_comp(Time, Grid, ibgc(n)%id_sc_co2, ibgc(n)%sc_co2(:,:))
   call diagnose_2d_comp(Time, Grid, ibgc(n)%id_sc_o2, ibgc(n)%sc_o2(:,:))
   if (ibgc(n)%id_jideal_n .gt. 0) then
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jideal_n, ibgc(n)%jideal_n(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jsuntan .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jsuntan, ibgc(n)%jsuntan(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   call diagnose_3d_comp(Time, Grid, ibgc(n)%id_remin_ip, ibgc(n)%remin_ip(:,:,:))
   call diagnose_3d_comp(Time, Grid, ibgc(n)%id_remin_isi, ibgc(n)%remin_isi(:,:,:))
   if (ibgc(n)%id_jprod_pisi .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jprod_pisi, ibgc(n)%jprod_pisi(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   call diagnose_3d_comp(Time, Grid, ibgc(n)%id_fpisi, ibgc(n)%fpisi(:,:,:))
   if (ibgc(n)%id_jremin_pisi .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jremin_pisi, ibgc(n)%jremin_pisi(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jprod_pi30si .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jprod_pi30si, ibgc(n)%jprod_pi30si(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   call diagnose_3d_comp(Time, Grid, ibgc(n)%id_fpi30si, ibgc(n)%fpi30si(:,:,:))
   if (ibgc(n)%id_jremin_pi30si .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jremin_pi30si, ibgc(n)%jremin_pi30si(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jprod_pip .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jprod_pip, ibgc(n)%jprod_pip(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jprod_idop .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jprod_idop, ibgc(n)%jprod_idop(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jremin_idop .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jremin_idop, ibgc(n)%jremin_idop(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   call diagnose_3d_comp(Time, Grid, ibgc(n)%id_fpip, ibgc(n)%fpip(:,:,:))
   if (ibgc(n)%id_jremin_pip .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jremin_pip, ibgc(n)%jremin_pip(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jife_new .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jife_new, ibgc(n)%jife_new(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   call diagnose_3d_comp(Time, Grid, ibgc(n)%id_felim_irrk, ibgc(n)%felim_irrk(:,:,:))
   if (ibgc(n)%id_jprod_pipf .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jprod_pipf, ibgc(n)%jprod_pipf(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jprod_idopf .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jprod_idopf, ibgc(n)%jprod_idopf(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jremin_idopf .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jremin_idopf, ibgc(n)%jremin_idopf(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   call diagnose_3d_comp(Time, Grid, ibgc(n)%id_fpipf, ibgc(n)%fpipf(:,:,:))
   if (ibgc(n)%id_jremin_pipf .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jremin_pipf, ibgc(n)%jremin_pipf(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jprod_pife .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jprod_pife, ibgc(n)%jprod_pife(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   call diagnose_3d_comp(Time, Grid, ibgc(n)%id_fpife, ibgc(n)%fpife(:,:,:))
   if (ibgc(n)%id_jremin_pife .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jremin_pife, ibgc(n)%jremin_pife(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   call diagnose_3d_comp(Time, Grid, ibgc(n)%id_ife_free, ibgc(n)%ife_free(:,:,:))
   if (ibgc(n)%id_jife_scav .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jife_scav, ibgc(n)%jife_scav(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jipo4 .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jipo4, ibgc(n)%jipo4(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jipo4f .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jipo4f, ibgc(n)%jipo4f(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jipo4_bgc .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jipo4_bgc, ibgc(n)%jipo4_bgc(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   call diagnose_3d_comp(Time, Grid, ibgc(n)%id_ipo4_bgc, ibgc(n)%ipo4_bgc(:,:,:))
   if (ibgc(n)%id_jprod_pi15n .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jprod_pi15n, ibgc(n)%jprod_pi15n(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jprod_ido15n .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jprod_ido15n, ibgc(n)%jprod_ido15n(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jremin_ido15n .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jremin_ido15n, ibgc(n)%jremin_ido15n(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   call diagnose_3d_comp(Time, Grid, ibgc(n)%id_fpi15n, ibgc(n)%fpi15n(:,:,:))
   if (ibgc(n)%id_jremin_pi15n .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jremin_pi15n, ibgc(n)%jremin_pi15n(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_ji15no3 .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_ji15no3, ibgc(n)%ji15no3(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jprod_i18o .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jprod_i18o, ibgc(n)%jprod_i18o(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   call diagnose_3d_comp(Time, Grid, ibgc(n)%id_ichl_new, ibgc(n)%ichl_new(:,:,:))
   call diagnose_2d_comp(Time, Grid, ibgc(n)%id_alpha, ibgc(n)%alpha(:,:))
   call diagnose_2d_comp(Time, Grid, ibgc(n)%id_csurf, ibgc(n)%csurf(:,:))
   call diagnose_2d_comp(Time, Grid, ibgc(n)%id_csatsurf, ibgc(n)%csatsurf(:,:))
   call diagnose_2d_comp(Time, Grid, ibgc(n)%id_c14surf, ibgc(n)%c14surf(:,:))
   call diagnose_2d_comp(Time, Grid, ibgc(n)%id_pco2surf, ibgc(n)%pco2surf(:,:))
   call diagnose_2d_comp(Time, Grid, ibgc(n)%id_pco2satsurf, ibgc(n)%pco2satsurf(:,:))
   call diagnose_2d_comp(Time, Grid, ibgc(n)%id_htotal, ibgc(n)%htotal(:,:))
   call diagnose_2d_comp(Time, Grid, ibgc(n)%id_htotal_sat, ibgc(n)%htotal_sat(:,:))
   if (ibgc(n)%id_alk .gt. 0) then
      call diagnose_2d(Time, Grid, ibgc(n)%id_alk, t_prog(indsal)%field(:,:,1,taum1) * ibgc(n)%alkbar / ibgc(n)%sal_global)
   endif
   if (ibgc(n)%id_jdecay_idi14c .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jdecay_idi14c, ibgc(n)%jdecay_idi14c(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jdecay_ido14c .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jdecay_ido14c, ibgc(n)%jdecay_ido14c(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jremin_pi14c .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jremin_pi14c, ibgc(n)%jremin_pi14c(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jremin_ido14c .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jremin_ido14c, ibgc(n)%jremin_ido14c(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jprod_pi14c .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jprod_pi14c, ibgc(n)%jprod_pi14c(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   if (ibgc(n)%id_jprod_ido14c .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jprod_ido14c, ibgc(n)%jprod_ido14c(:,:,:) * rho_dzt(:,:,:,taum1))
   endif
   call diagnose_3d_comp(Time, Grid, ibgc(n)%id_fpi14c, ibgc(n)%fpi14c(:,:,:))
   call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jidi14c, ibgc(n)%jidi14c(:,:,:))
   if (ibgc(n)%id_jio2 .gt. 0) then                     
      call diagnose_3d_comp(Time, Grid, ibgc(n)%id_jio2, ibgc(n)%jio2(:,:,:) * rho_dzt(:,:,:,taum1))
   endif

enddo

return

end subroutine  ocean_ibgc_source
! </SUBROUTINE> NAME="ocean_ibgc_source"


!#######################################################################
! <SUBROUTINE NAME="ocean_ibgc_start">
!
! <DESCRIPTION>
! Initialize variables, read in namelists, calculate constants for a given run
! and allocate diagnostic arrays
! </DESCRIPTION>

subroutine ocean_ibgc_start(isc, iec, jsc, jec, nk, isd, jsd, &
     model_time, grid_tmask,            &
     grid_tracer_axes, &
     mpp_domain2d)

real, parameter :: spery = 365.25 * 24.0 * 3600.0

character(len=64), parameter    :: sub_name = 'ocean_ibgc_start'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '): '
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '): '

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: jsd
type(time_type), intent(in)                             :: model_time
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask
integer, dimension(3), intent(in)                       :: grid_tracer_axes
type(domain2d), intent(in)                              :: mpp_domain2d

  real                                  :: ideal_n_vmax
  real                                  :: ideal_n_k
  real                                  :: ideal_n_r

  real                                  :: suntan_fade

  real                                  :: ipo4_vmax
  real                                  :: ipo4_k
  real                                  :: idop_frac
  real                                  :: gamma_idop
  real                                  :: gamma_ip 
  real                                  :: gamma_isi 
  real                                  :: sinking_init
  real                                  :: sinking_acc
 
  real                                  :: uptake_2_chl
  real                                  :: ichl_lag
  real                                  :: ichl_highlight

  real                                  :: ligand_tot 
  real                                  :: ligand_k 
  real                                  :: scav_k 

  real                                  :: ipo4f_vmax
  real                                  :: ife_irrsuf 
  real                                  :: ife_supply

!  real                                  :: alpha_12c_13c
  real                                  :: alpha_14n_15n
  real                                  :: alpha_28si_30si

  real                                  :: o2_2_ip
  real                                  :: io2_min

  real                                  :: half_life_14c
  real                                  :: lambda_14c
  real                                  :: alkbar
  real                                  :: si_2_ip
  real                                  :: c_2_ip
  real                                  :: sal_global

integer                                         :: i, j, l, n
character(len=fm_field_name_len+1)              :: suffix
character(len=fm_field_name_len+3)              :: long_suffix
character(len=256)                              :: caller_str
character(len=fm_string_len), allocatable       :: local_restart_file(:)
integer                                         :: ind
logical                                         :: fld_exist
integer                                 :: id_restart

  integer :: stdoutunit 
  stdoutunit=stdout() 

! Determine indices for temperature and salinity
indtemp = fm_get_index('/ocean_mod/prog_tracers/temp')
if (indtemp .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the temperature index')
endif

indsal = fm_get_index('/ocean_mod/prog_tracers/salt')
if (indsal .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the salinity index')
endif

! dynamically allocate the global Ideal Nut arrays
call allocate_arrays(isc, iec, jsc, jec, nk)

! save the *global* namelist values
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

call fm_util_start_namelist(package_name, '*global*', caller = caller_str)

htotal_scale_lo_in =  fm_util_get_real   ('htotal_scale_lo_in', scalar = .true.)
htotal_scale_hi_in =  fm_util_get_real   ('htotal_scale_hi_in', scalar = .true.)
htotal_in          =  fm_util_get_real   ('htotal_in', scalar = .true.)

call fm_util_end_namelist(package_name, '*global*', caller = caller_str)
      
! set default values for htotal_scale bounds
htotal_scale_lo(:,:) = htotal_scale_lo_in
htotal_scale_hi(:,:) = htotal_scale_hi_in

! read in the namelists for each instance
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

  call fm_util_start_namelist(package_name, ibgc(n)%name, caller = caller_str)

  ibgc(n)%local_restart_file      = fm_util_get_string ('local_restart_file', scalar = .true.)

  ibgc(n)%kappa_eppley            = fm_util_get_real ('kappa_eppley', scalar = .true.)
  ibgc(n)%kappa_eppley_remin      = fm_util_get_real ('kappa_eppley_remin', scalar = .true.)
  ibgc(n)%irrk                    = fm_util_get_real ('irrk', scalar = .true.)

  ibgc(n)%ideal_n_vmax            = fm_util_get_real ('ideal_n_vmax', scalar = .true.)
  ibgc(n)%ideal_n_k               = fm_util_get_real ('ideal_n_k', scalar = .true.)
  ibgc(n)%ideal_n_r               = fm_util_get_real ('ideal_n_r', scalar = .true.)

  ibgc(n)%suntan_fade             = fm_util_get_real ('suntan_fade', scalar = .true.)
 
  ibgc(n)%ipo4_vmax               = fm_util_get_real ('ipo4_vmax', scalar = .true.)
  ibgc(n)%ipo4_k                  = fm_util_get_real ('ipo4_k', scalar = .true.)
  ibgc(n)%idop_frac               = fm_util_get_real ('idop_frac', scalar = .true.)
  ibgc(n)%gamma_idop              = fm_util_get_real ('gamma_idop', scalar = .true.)
  ibgc(n)%gamma_ip                = fm_util_get_real ('gamma_ip', scalar = .true.)
  ibgc(n)%gamma_isi               = fm_util_get_real ('gamma_isi', scalar = .true.)
  ibgc(n)%sinking_init            = fm_util_get_real ('sinking_init', scalar = .true.)
  ibgc(n)%sinking_acc             = fm_util_get_real ('sinking_acc', scalar = .true.)

  ibgc(n)%uptake_2_chl            = fm_util_get_real ('uptake_2_chl', scalar = .true.)
  ibgc(n)%ichl_lag                = fm_util_get_real ('ichl_lag', scalar = .true.)
  ibgc(n)%ichl_highlight          = fm_util_get_real ('ichl_highlight', scalar = .true.)

  ibgc(n)%ligand_tot              = fm_util_get_real ('ligand_tot', scalar = .true.)
  ibgc(n)%ligand_k                = fm_util_get_real ('ligand_k', scalar = .true.)
  ibgc(n)%scav_k                  = fm_util_get_real ('scav_k', scalar = .true.)

  ibgc(n)%ipo4f_vmax              = fm_util_get_real ('ipo4f_vmax', scalar = .true.)
  ibgc(n)%ife_irrsuf              = fm_util_get_real ('ife_irrsuf', scalar = .true.)
  ibgc(n)%ife_supply              = fm_util_get_real ('ife_supply', scalar = .true.)

!  ibgc(n)%alpha_12c_13c           = fm_util_get_real ('alpha_12c_13c', scalar = .true.)
  ibgc(n)%alpha_14n_15n           = fm_util_get_real ('alpha_14n_15n', scalar = .true.)
  ibgc(n)%alpha_28si_30si         = fm_util_get_real ('alpha_28si_30si', scalar = .true.)

  ibgc(n)%o2_2_ip                 = fm_util_get_real ('o2_2_ip', scalar = .true.)
  ibgc(n)%io2_min                 = fm_util_get_real ('io2_min', scalar = .true.)

  ibgc(n)%frac_14catm_file        = fm_util_get_string ('frac_14catm_file', scalar = .true.)
  ibgc(n)%frac_14catm_name        = fm_util_get_string ('frac_14catm_name', scalar = .true.)
  ibgc(n)%frac_14catm_const       = fm_util_get_real   ('frac_14catm_const', scalar = .true.)
  ibgc(n)%half_life_14c           = fm_util_get_real ('half_life_14c', scalar = .true.)
  ibgc(n)%alkbar                  = fm_util_get_real ('alkbar', scalar = .true.)
  ibgc(n)%si_2_ip                 = fm_util_get_real ('si_2_ip', scalar = .true.)
  ibgc(n)%c_2_ip                  = fm_util_get_real ('c_2_ip', scalar = .true.)
  ibgc(n)%sal_global              = fm_util_get_real ('sal_global', scalar = .true.)

  ibgc(n)%sc_co2_0                = fm_util_get_real ('sc_co2_0', scalar = .true.)
  ibgc(n)%sc_co2_1                = fm_util_get_real ('sc_co2_1', scalar = .true.)
  ibgc(n)%sc_co2_2                = fm_util_get_real ('sc_co2_2', scalar = .true.)
  ibgc(n)%sc_co2_3                = fm_util_get_real ('sc_co2_3', scalar = .true.)
  ibgc(n)%sc_o2_0                 = fm_util_get_real ('sc_o2_0', scalar = .true.)
  ibgc(n)%sc_o2_1                 = fm_util_get_real ('sc_o2_1', scalar = .true.)
  ibgc(n)%sc_o2_2                 = fm_util_get_real ('sc_o2_2', scalar = .true.)
  ibgc(n)%sc_o2_3                 = fm_util_get_real ('sc_o2_3', scalar = .true.)

  call fm_util_end_namelist(package_name, ibgc(n)%name, caller = caller_str)


enddo

if (do_gasses) then

do n = 1, instances

if (do_radiocarbon) then
   ! Open the frac_14catm (fractionation of atmospheric 14CO2) file
   ! If the file name is blank, then the 14C fractionation is assumed to
   ! be added to the atmospheric concentration
  if (ibgc(n)%frac_14catm_file .ne. ' ') then
    ibgc(n)%frac_14catm_id = init_external_field(ibgc(n)%frac_14catm_file, &
      ibgc(n)%frac_14catm_name, domain = mpp_domain2d,                     &
      use_comp_domain = .true.)
    if (ibgc(n)%frac_14catm_id .eq. 0) then
      call mpp_error(FATAL, trim(error_header) //                          &
        ' Could not open frac_14catm_file file: ' //                       &
        trim(ibgc(n)%frac_14catm_file) // ' for ' //                       &
        trim(ibgc(n)%frac_14catm_name))
    endif
  else
    call mpp_error(NOTE, trim(error_header) //                             &
      ' Using constant field for atmospheric 14C for instance '            &
      // trim(ibgc(n)%name))
    do j = jsc, jec
      do i = isc, iec
        ibgc(n)%frac_14catm(i,j) = ibgc(n)%frac_14catm_const *             &
        grid_tmask(i,j,1)
      enddo
    enddo
  endif
endif

enddo

!       Read in additional information for a restart.
!
!       We must process all of the instances before restoring any files
!       as all fields must be registered before the fields are
!       restored, and fields from different instances may be in the
!       same file.
!
!       Note that the restart file names here must be different from
!       those for the tracer values.

allocate(restart(instances))
allocate(local_restart_file(instances))

write(stdoutunit,*)

do n = 1, instances

   ! Set the suffix for this instance (if instance name is "_",
   ! then use a blank suffix).
  if (ibgc(n)%name(1:1) .eq. '_') then
    suffix = ' '
  else
    suffix = '_' // ibgc(n)%name
  endif

  ! Check whether we are already using this restart file, if so,
  ! we do not want to duplicate it in the list of restart files
  ! since we only read each restart file once.
  ind = 0
  do l = 1, num_restart
    if (ibgc(n)%local_restart_file == local_restart_file(l)) then
      ind = l
      exit
    endif
  end do

  if (ind .eq. 0) then
    num_restart = num_restart + 1
    ind = num_restart
    local_restart_file(ind) = trim(ibgc(n)%local_restart_file)
  end if

  ! Check whether the field already exists in the restart file.
  ! If not, then set a default value.
  fld_exist = field_exist('INPUT/' // trim(ibgc(n)%local_restart_file), 'htotal' // trim(suffix) )

  if ( fld_exist ) then
    write (stdoutunit,*) trim(note_header),                       &
         ' Reading additional information for instance ',       &
         trim(ibgc(n)%name)
  else
    write (stdoutunit,*) trim(note_header),                       &
         ' Initializing instance ', trim(ibgc(n)%name)
    ibgc(n)%htotal(:,:) = htotal_in
    ibgc(n)%htotal_sat(:,:) = htotal_in
  endif

  ! Register the field for restart
  id_restart = register_restart_field(restart(ind), ibgc(n)%local_restart_file,         &
                    'htotal' // trim(suffix), ibgc(n)%htotal,                           &
                    domain=mpp_domain2d, mandatory=fld_exist)

if (do_carbon_comp) then
  id_restart = register_restart_field(restart(ind), ibgc(n)%local_restart_file,         &
                    'htotal_sat' // trim(suffix), ibgc(n)%htotal_sat,                   &
                    domain=mpp_domain2d, mandatory=fld_exist)
endif

enddo

! Restore the restart fields if the file exists
do l = 1, num_restart
  if (file_exist('INPUT/' // trim(local_restart_file(l)))) then
    call restore_state(restart(l))
  end if
end do

deallocate(local_restart_file)

! perform checksums on restart fields
write (stdoutunit,*)
write (stdoutunit,*) trim(note_header), ' Starting check sums for extra variables'
do n = 1, instances
  write(stdoutunit,*) 'htotal chksum = ', mpp_chksum(ibgc(n)%htotal)
if (do_carbon_comp) then
  write(stdoutunit,*) 'htotal_sat chksum = ', mpp_chksum(ibgc(n)%htotal_sat)
endif
enddo
write (stdoutunit,*)

! initialize some arrays which are held constant for this
! simulation
if (do_radiocarbon) then
do n = 1, instances
  if (ibgc(n)%half_life_14c .gt. 0.0) then
    ibgc(n)%lambda_14c = log(2.0) / (ibgc(n)%half_life_14c * spery)
  else
    call mpp_error(FATAL,trim(error_header) // ' Half-life <= 0')
  endif
enddo
endif

endif

!       Set up diagnostic fields

! Register the global fields

suffix = '_' // package_name
long_suffix = ' (' // trim(package_name) // ')'

! Register the instance fields
do n = 1, instances

  if (instances .eq. 1) then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // ibgc(n)%name
    long_suffix = ' (' // trim(ibgc(n)%name) // ')'
  endif

if (do_ideal) then
  ibgc(n)%id_jideal_n = register_diag_field(trim(diag_name),                                  &
       'jideal_n' // trim(suffix), grid_tracer_axes(1:3),                                     &
       model_time, 'Ideal Nutrient source, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_jsuntan = register_diag_field(trim(diag_name),                                   &
       'jsuntan' // trim(suffix), grid_tracer_axes(1:3),                                      &
       model_time, 'Suntan source, layer integral' // trim(long_suffix), 'mol m-2 s-1',       &
       missing_value = -1.0e+10)
endif

if (do_po4) then
  ibgc(n)%id_remin_ip = register_diag_field(trim(diag_name),                                  &
       'remin_ip' // trim(suffix), grid_tracer_axes(1:3),                                     &
       model_time, 'Remineralization inverse lengthscale for fpip' // trim(long_suffix), 'm-1',       &
       missing_value = -1.0e+10)

  ibgc(n)%id_jprod_pip = register_diag_field(trim(diag_name),                                 &
       'jprod_pip' // trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'Particulate ideal P production, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_jprod_idop = register_diag_field(trim(diag_name),                                &
       'jprod_idop' // trim(suffix), grid_tracer_axes(1:3),                                   &
       model_time, 'DOP source, layer integral' // trim(long_suffix), 'mol m-2 s-1',          &
       missing_value = -1.0e+10)

  ibgc(n)%id_jremin_idop = register_diag_field(trim(diag_name),                               &
       'jremin_idop' // trim(suffix), grid_tracer_axes(1:3),                                  &
       model_time, 'DOP remineralization, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_fpip = register_diag_field(trim(diag_name),                                      &
       'fpip' // trim(suffix), grid_tracer_axes(1:3),                                         &
       model_time, 'Particulate ideal P sinking flux' // trim(long_suffix), 'mol m-2 s-1',    &
       missing_value = -1.0e+10)

  ibgc(n)%id_jremin_pip = register_diag_field(trim(diag_name),                                &
       'jremin_pip' // trim(suffix), grid_tracer_axes(1:3),                                   &
       model_time, 'Ideal PO4 remin fr particles, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_jipo4 = register_diag_field(trim(diag_name),                                     &
       'jipo4' // trim(suffix), grid_tracer_axes(1:3),                                        &
       model_time, 'Ideal PO4 total source, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

endif

if (do_po4f) then

 ibgc(n)%id_jife_new = register_diag_field(trim(diag_name),                                    &
       'jife_new' // trim(suffix), grid_tracer_axes(1:3),                                      &
       model_time, 'iFe surface source, layer integral' // trim(long_suffix), 'mol m-2 s-1',   &
       missing_value = -1.0e+10)

  ibgc(n)%id_felim_irrk = register_diag_field(trim(diag_name),                                 &
       'felim_irrk' // trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'Fe-limited light half-saturation' // trim(long_suffix), 'W m-2',           &
       missing_value = -1.0e+10)

  ibgc(n)%id_jprod_pipf = register_diag_field(trim(diag_name),                                 &
       'jprod_pipf' // trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'Particulate iPf production, layer integral' // trim(long_suffix), 'mmol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_jprod_idopf = register_diag_field(trim(diag_name),                                &
       'jprod_idopf' // trim(suffix), grid_tracer_axes(1:3),                                   &
       model_time, 'DOPf source, layer integral' // trim(long_suffix), 'mol m-2 s-1',          &
       missing_value = -1.0e+10)

  ibgc(n)%id_jremin_idopf = register_diag_field(trim(diag_name),                               &
       'jremin_idopf' // trim(suffix), grid_tracer_axes(1:3),                                  &
       model_time, 'DOPf remineralization, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_fpipf = register_diag_field(trim(diag_name),                                      &
       'fpipf' // trim(suffix), grid_tracer_axes(1:3),                                         &
       model_time, 'Particulate iPf sinking flux' // trim(long_suffix), 'mol m-2 s-1',         &
       missing_value = -1.0e+10)

  ibgc(n)%id_jremin_pipf = register_diag_field(trim(diag_name),                                &
       'jremin_pipf' // trim(suffix), grid_tracer_axes(1:3),                                   &
       model_time, 'iPO4f remineralization, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_jprod_pife = register_diag_field(trim(diag_name),                                 &
       'jprod_pife' // trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'Particulate iFe production, layer integral' // trim(long_suffix), 'mmol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_fpife = register_diag_field(trim(diag_name),                                      &
       'fpife' // trim(suffix), grid_tracer_axes(1:3),                                         &
       model_time, 'Particulate iFe sinking flux' // trim(long_suffix), 'mmol m-2 s-1',        &
       missing_value = -1.0e+10)

  ibgc(n)%id_jremin_pife = register_diag_field(trim(diag_name),                                &
       'jremin_pife' // trim(suffix), grid_tracer_axes(1:3),                                   &
       model_time, 'iFe remineralization, layer integral' // trim(long_suffix), 'mmol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_ife_free = register_diag_field(trim(diag_name),                                   &
       'ife_free' // trim(suffix), grid_tracer_axes(1:3),                                      &
       model_time, 'Free iFe concentration' // trim(long_suffix), 'mmol kg-1',                 &
       missing_value = -1.0e+10)

  ibgc(n)%id_jife_scav = register_diag_field(trim(diag_name),                                  &
       'jife_scav' // trim(suffix), grid_tracer_axes(1:3),                                     &
       model_time, 'iFe scavenging, layer integral' // trim(long_suffix), 'mmol m-2 s-1',      &
       missing_value = -1.0e+10)

  ibgc(n)%id_jipo4f = register_diag_field(trim(diag_name),                                     &
       'jipo4f' // trim(suffix), grid_tracer_axes(1:3),                                        &
       model_time, 'Ideal PO4f net source, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

endif

if ((do_po4f) .or. (do_po4)) then

  ibgc(n)%id_ichl_new = register_diag_field(trim(diag_name),                                   &
       'ichl_new' // trim(suffix), grid_tracer_axes(1:3),                                      &
       model_time, 'New ichl' // trim(long_suffix), 'mg kg-1',                                 &
       missing_value = -1.0e+10)

  ibgc(n)%id_ipo4_bgc = register_diag_field(trim(diag_name),                                   &
       'ipo4_bgc' // trim(suffix), grid_tracer_axes(1:3),                                      &
       model_time, 'PO4 used for bgc calculations' // trim(long_suffix), 'mol kg-1',           &
       missing_value = -1.0e+10)

  ibgc(n)%id_jipo4_bgc = register_diag_field(trim(diag_name),                                  &
       'jipo4_bgc' // trim(suffix), grid_tracer_axes(1:3),                                     &
       model_time, 'Net PO4 source for bgc calculations, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

endif

if (do_gasses) then

  id_o2_sat = register_diag_field(trim(diag_name),                                             &
       'o2_sat' // trim(suffix), grid_tracer_axes(1:3),                                        &
       model_time, 'O2 saturation' // trim(long_suffix), 'mol m-3',                            &
       missing_value = -1.0e+10)

  ibgc(n)%id_sc_co2 = register_diag_field(trim(diag_name),                                     &
       'sc_ico2' // trim(suffix), grid_tracer_axes(1:2),                                       &
       model_time, 'Schmidt number - CO2' // trim(long_suffix), ' ',                           &
       missing_value = -1.0e+10)

  ibgc(n)%id_sc_o2 = register_diag_field(trim(diag_name),                                      &
       'sc_io2' // trim(suffix), grid_tracer_axes(1:2),                                        &
       model_time, 'Schmidt number - O2' // trim(long_suffix), ' ',                            &
       missing_value = -1.0e+10)

  ibgc(n)%id_alpha = register_diag_field(trim(diag_name),                                      &
       'ialpha' // trim(suffix), grid_tracer_axes(1:2),                                        &
       model_time, 'CO2* saturation' // trim(long_suffix), 'mol kg-1',                         &
       missing_value = -1.0e+10)

  ibgc(n)%id_csurf = register_diag_field(trim(diag_name),                                      &
       'icsurf' // trim(suffix), grid_tracer_axes(1:2),                                        &
       model_time, 'CO2* water' // trim(long_suffix), 'mol kg-1',                              &
       missing_value = -1.0e+10)

  ibgc(n)%id_pco2surf = register_diag_field(trim(diag_name),                                   &
       'ipco2surf' // trim(suffix), grid_tracer_axes(1:2),                                     &
       model_time, 'Oceanic pCO2' // trim(long_suffix), 'ppm',                                 &
       missing_value = -1.0e+10)

  ibgc(n)%id_sfc_flux_co2 = register_diag_field(trim(diag_name),                               &
       'sfc_flux_ico2' // trim(suffix), grid_tracer_axes(1:2),                                 &
       model_time, 'CO2 surface flux' // trim(long_suffix), 'mol m-2 s-1',                     &
       missing_value = -1.0e+10)

  ibgc(n)%id_htotal = register_diag_field(trim(diag_name),                                     &
       'ihtotal' // trim(suffix), grid_tracer_axes(1:2),                                       &
       model_time, 'H+ ion concentration' // trim(long_suffix), 'mol kg-1',                    &
       missing_value = -1.0e+10)

  ibgc(n)%id_alk = register_diag_field(trim(diag_name),                                        &
       'ialk' // trim(suffix), grid_tracer_axes(1:2),                                          &
       model_time, 'ALK' // trim(long_suffix), 'mol eq kg-1',                                  &
       missing_value = -1.0e+10)

  ibgc(n)%id_sfc_flux_o2 = register_diag_field(trim(diag_name),                                &
       'sfc_flux_io2' // trim(suffix), grid_tracer_axes(1:2),                                  &
       model_time, 'iO2 surface flux' // trim(long_suffix), 'mol m-2 s-1',                     &
       missing_value = -1.0e+10)

  ibgc(n)%id_jio2 = register_diag_field(trim(diag_name),                                       &
       'jio2' // trim(suffix), grid_tracer_axes(1:3),                                          &
       model_time, 'Total iO2 biological source, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

if (do_carbon_comp) then

  ibgc(n)%id_csatsurf = register_diag_field(trim(diag_name),                                   &
       'icsatsurf' // trim(suffix), grid_tracer_axes(1:2),                                     &
       model_time, 'CO2* saturation DIC' // trim(long_suffix), 'mol kg-1',                     &
       missing_value = -1.0e+10)

  ibgc(n)%id_htotal_sat = register_diag_field(trim(diag_name),                                 &
       'ihtotal_sat' // trim(suffix), grid_tracer_axes(1:2),                                   &
       model_time, 'H+ ion concentration for DIC_sat' // trim(long_suffix), 'mol kg-1',        &
       missing_value = -1.0e+10)

  ibgc(n)%id_pco2satsurf = register_diag_field(trim(diag_name),                                &
       'ipco2satsurf' // trim(suffix), grid_tracer_axes(1:2),                                  &
       model_time, 'Oceanic pCO2 saturation DIC' // trim(long_suffix), 'ppm',                  &
       missing_value = -1.0e+10)

  ibgc(n)%id_sfc_flux_co2sat = register_diag_field(trim(diag_name),                            &
       'sfc_flux_ico2sat' // trim(suffix), grid_tracer_axes(1:2),                              &
       model_time, 'Saturation CO2 surface flux' // trim(long_suffix), 'mol m-2 s-1',          &
       missing_value = -1.0e+10)

endif

if (do_radiocarbon) then

  ibgc(n)%id_c14surf = register_diag_field(trim(diag_name),                                    &
       'ic14surf' // trim(suffix), grid_tracer_axes(1:2),                                      &
       model_time, '14CO2* water' // trim(long_suffix), 'mol kg-1',                            &
       missing_value = -1.0e+10)

  ibgc(n)%id_sfc_flux_14co2 = register_diag_field(trim(diag_name),                             &
       'sfc_flux_i14co2' // trim(suffix), grid_tracer_axes(1:2),                               &
       model_time, '14CO2 surface flux' // trim(long_suffix), 'mol m-2 s-1',                   &
       missing_value = -1.0e+10)

  ibgc(n)%frac_14catm = register_diag_field(trim(diag_name),                                   &
       'frac_14catm' // trim(suffix), grid_tracer_axes(1:2),                                   &
       model_time, '14C fraction' // trim(long_suffix), '',                                    &
       missing_value = -1.0e+10)

  ibgc(n)%id_jdecay_idi14c = register_diag_field(trim(diag_name),                              &
       'jdecay_idi14c' // trim(suffix), grid_tracer_axes(1:3),                                 &
       model_time, 'iDI14C decay, layer integral' // trim(long_suffix), 'mol m-2 s-1',         &
       missing_value = -1.0e+10)

  ibgc(n)%id_jdecay_ido14c = register_diag_field(trim(diag_name),                              &
       'jdecay_ido14c' // trim(suffix), grid_tracer_axes(1:3),                                 &
       model_time, 'iDO14C decay, layer integral' // trim(long_suffix), 'mol m-2 s-1',         &
       missing_value = -1.0e+10)

  ibgc(n)%id_jremin_pi14c = register_diag_field(trim(diag_name),                               &
       'jremin_pi14c' // trim(suffix), grid_tracer_axes(1:3),                                  &
       model_time, 'Remineralization of Pi14C, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_jremin_ido14c = register_diag_field(trim(diag_name),                              &
       'jremin_ido14c' // trim(suffix), grid_tracer_axes(1:3),                                 &
       model_time, 'Remineralization of iDO14C, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_jprod_pi14c = register_diag_field(trim(diag_name),                                &
       'jprod_pi14c' // trim(suffix), grid_tracer_axes(1:3),                                   &
       model_time, 'Pi14C production, layer integral' // trim(long_suffix), 'mol m-2 s-1',     &
       missing_value = -1.0e+10)

  ibgc(n)%id_jprod_ido14c = register_diag_field(trim(diag_name),                               &
       'jprod_ido14c' // trim(suffix), grid_tracer_axes(1:3),                                  &
       model_time, 'iDO14C production, layer integral' // trim(long_suffix), 'mol m-2 s-1',    &
       missing_value = -1.0e+10)

  ibgc(n)%id_fpi14c = register_diag_field(trim(diag_name),                                     &
       'fpi14c' // trim(suffix), grid_tracer_axes(1:3),                                        &
       model_time, 'Particulate i14C sinking flux' // trim(long_suffix), 'mol m-2 s-1',        &
       missing_value = -1.0e+10)

  ibgc(n)%id_jidi14c = register_diag_field(trim(diag_name),                                    &
       'jidi14c' // trim(suffix), grid_tracer_axes(1:3),                                       &
       model_time, 'Total iDI14C source, layer integral' // trim(long_suffix), 'mol m-2 s-1',  &
       missing_value = -1.0e+10)

endif

endif

if (do_no3_iso) then

   ibgc(n)%id_jprod_pi15n = register_diag_field(trim(diag_name),                              &
       'jprod_pi15n' // trim(suffix), grid_tracer_axes(1:3),                                  &
       model_time, 'Particulate ideal 15N production, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_jprod_ido15n = register_diag_field(trim(diag_name),                               &
       'jprod_ido15n' // trim(suffix), grid_tracer_axes(1:3),                                  &
       model_time, 'Dissolved ideal 15N source, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_jremin_ido15n = register_diag_field(trim(diag_name),                              &
       'jremin_ido15n' // trim(suffix), grid_tracer_axes(1:3),                                 &
       model_time, 'Dissolved ideal 15N remineralization' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_fpi15n = register_diag_field(trim(diag_name),                                     &
       'fpi15n' // trim(suffix), grid_tracer_axes(1:3),                                        &
       model_time, 'Particulate ideal 15N sinking flux' // trim(long_suffix), 'mol m-2 s-1',   &
       missing_value = -1.0e+10)

  ibgc(n)%id_jremin_pi15n = register_diag_field(trim(diag_name),                               &
       'jremin_pi15n' // trim(suffix), grid_tracer_axes(1:3),                                  &
       model_time, 'Ideal 15no3 remin fr particles, layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_ji15no3 = register_diag_field(trim(diag_name),                                    &
       'ji15no3' // trim(suffix), grid_tracer_axes(1:3),                                       &
       model_time, '15no3 net source, layer integral' // trim(long_suffix), 'mol m-2 s-1',     &
       missing_value = -1.0e+10)

  ibgc(n)%id_jprod_i18o = register_diag_field(trim(diag_name),                                 &
       'jprod_i18o' // trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'N18O3 uptake source, layer integral' // trim(long_suffix), 'mol m-2 s-1',  &
       missing_value = -1.0e+10)

endif

if (do_isio4) then

  ibgc(n)%id_remin_isi = register_diag_field(trim(diag_name),                                  &
       'remin_isi' // trim(suffix), grid_tracer_axes(1:3),                                     &
       model_time, 'Remineralization inverse lengthscale for fpisi' // trim(long_suffix), 'm-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_jprod_pisi = register_diag_field(trim(diag_name),                                 &
       'jprod_pisi' // trim(suffix), grid_tracer_axes(1:3),                                    &
       model_time, 'Particulate ideal Si production layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_fpisi = register_diag_field(trim(diag_name),                                      &
       'fpisi' // trim(suffix), grid_tracer_axes(1:3),                                         &
       model_time, 'Particulate ideal Si sinking flux' // trim(long_suffix), 'mol m-2 s-1',    &
       missing_value = -1.0e+10)

  ibgc(n)%id_jremin_pisi = register_diag_field(trim(diag_name),                                &
       'jremin_pisi' // trim(suffix), grid_tracer_axes(1:3),                                   &
       model_time, 'Ideal SiO4 remineralization layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_jprod_pi30si = register_diag_field(trim(diag_name),                               &
       'jprod_pi30si' // trim(suffix), grid_tracer_axes(1:3),                                  &
       model_time, 'Particulate ideal 30Si production layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

  ibgc(n)%id_fpi30si = register_diag_field(trim(diag_name),                                    &
       'fpi30si' // trim(suffix), grid_tracer_axes(1:3),                                       &
       model_time, 'Particulate ideal 30Si sinking flux' // trim(long_suffix), 'mol m-2 s-1',  &
       missing_value = -1.0e+10)
       
  ibgc(n)%id_jremin_pi30si = register_diag_field(trim(diag_name),                              &
       'jremin_pi30si' // trim(suffix), grid_tracer_axes(1:3),                                 &
       model_time, 'Ideal 30SiO4 remineralization layer integral' // trim(long_suffix), 'mol m-2 s-1', &
       missing_value = -1.0e+10)

endif

enddo

write(stdoutunit,*)
write(stdoutunit,*) trim(note_header), 'Tracer runs initialized'
write(stdoutunit,*)

return

end subroutine  ocean_ibgc_start
! </SUBROUTINE> NAME="ocean_ibgc_start"


!#######################################################################
! <SUBROUTINE NAME="ocean_ibgc_tracer">
!
! <DESCRIPTION>
!     Perform things that should be done in tracer, but are done here
! in order to minimize the number of hooks necessary in the MOM4 basecode.
!
! Here, it is used only to set the values of preformed iPO4 and iDIC in 
! the mixed layer.
!
! </DESCRIPTION>
!
subroutine ocean_ibgc_tracer(isc, iec, jsc, jec, isd, jsd, nk,   &
                                Time, t_prog,              &
                                depth_zt, hblt_depth)
integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: nk
type(ocean_time_type), intent(in)                          :: Time
type(ocean_prog_tracer_type), intent(inout), dimension(:)  :: t_prog
real, dimension(isd:,jsd:,:), intent(in)                   :: depth_zt
real, dimension(isd:,jsd:), intent(in)                     :: hblt_depth

integer :: i, j, k, n
integer :: taup1

!     set Preformed phosphate, DIC
!  Considered doing them differently, with DIC_pre set only in the very 
! surface layer, where gas exchange takes place...but for ease of 
! interpretation, made them equivalent.
taup1 = Time%taup1

if ((do_po4f) .or. (do_po4)) then

do n = 1, instances

if (do_bgc_felim) then
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
         if (depth_zt(i,j,k) <= hblt_depth(i,j)) then
           t_prog(ibgc(n)%ind_ipo4_pre)%field(i,j,k,taup1) =               &
             t_prog(ibgc(n)%ind_ipo4f)%field(i,j,k,taup1) 
         endif
  enddo; enddo ; enddo
else
  do k = 1, nk ; do j = jsc, jec ; do i = isc, iec
         if (depth_zt(i,j,k) <= hblt_depth(i,j)) then
           t_prog(ibgc(n)%ind_ipo4_pre)%field(i,j,k,taup1) =               &
             t_prog(ibgc(n)%ind_ipo4)%field(i,j,k,taup1) 
         endif
  enddo; enddo ; enddo
endif

enddo

endif

if (do_carbon_comp) then

do n = 1, instances

  do j = jsc, jec
    do i = isc, iec
      do k = 1,nk
         if (depth_zt(i,j,k) <= hblt_depth(i,j)) then
           t_prog(ibgc(n)%ind_idic_pre)%field(i,j,k,taup1) =               &
             t_prog(ibgc(n)%ind_idic)%field(i,j,k,taup1) 
         endif
      enddo
    enddo
  enddo

enddo

endif

return

end subroutine  ocean_ibgc_tracer
! </SUBROUTINE> NAME="ocean_ibgc_tracer"

!#######################################################################
end module  ocean_ibgc_mod

module ocean_density_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</CONTACT>
!
!<CONTACT EMAIL="Russell.Fiedler@csiro.au"> Russell Fiedler 
!</CONTACT>
!
!<OVERVIEW>
! Compute density and related quantities.
!</OVERVIEW>
!
!<DESCRIPTION>
!
! This module computes the in-situ density and its partial derivatives with 
! respect to conservative temperature or potential temperature, and with 
! respect to salinity.  
!
! There are three basic means for performing this calculation.
!
! A/ Linear equation for use in idealized studies
! 
! This equation renders density a linear function of potential 
! temperature and salinity.  All nonlinearities are ignored, as are  
! pressure effects. 
!
! The valid range for theta and salinity arbitrary for the 
! linear equation of state. 
!
! B/ pre-TEOS10 method: this method uses density as a rational 
! polynomial function of potential temperature, practical salinity,
! and gauge pressure.  There is also an implementation that computes
! density as a function of conservative temperature rather than 
! potential temperature.  The equation of state is based on that 
! documented in Jackett, McDougall, Feistel, Wright, and Griffies(2006).  
!
! This equation of state is valid over a "cone-shaped" range 
! corresponding to 
!
! 0psu <= salinity <= 40 psu
!
! -3C <= theta <= 40C    "theta" = either conservative or potential temp	 
!
! 0dbar <= pressure <= 8000dbar 
!
! with the cone getting smaller in the deeper ocean where 
! theta and salinity vary over a smaller range.  
!
!  Input variables are the following:
!
!  --salinity in psu or g/kg 
!  --conservative temperature or potential temperature (theta) in deg C
!  --pressure in dbars  (1bar = 10dbar = 10^5 Newton/m^2 = 10^5 Pascals). 
!
!  Note that in the ocean, pressure increases roughly by 1dbar for each meter depth.
!  Also note that pressure is the "sea pressure", which is the absolute pressure
!  minus the pressure of a standard atmosphere, which is 10.1325 dbars.
!
! check values                                                        <BR/>
!
!  for "theta" = conservative temperature 
!  rho(s=20psu,theta=20C,p=1000dbar)   = 1017.842890411975 (kg/m^3)   <BR/>
!  alpha(s=20psu,theta=20C,p=1000dbar) = 2.436057013634649e-4 (1/C)   <BR/>
!  beta(s=20psu,theta=20C,p=1000dbar)  = 7.314818108935248e-4 (1/psu) <BR/>
!
!  for "theta" = potential temperature 
!  rho(s=20psu,theta=20C,p=1000dbar)   = 1017.728868019642 (kg/m^3)   <BR/>
!  alpha(s=20psu,theta=20C,p=1000dbar) = 2.525481286927133e-4 (1/C)   <BR/>
!  beta(s=20psu,theta=20C,p=1000dbar)  = 7.379638527217575e-4 (1/psu) <BR/> 
!
! This equation of state should be suitable for purposes of realistic 
! global ocean climate modeling. 
!
! C/ TEOS10 method: this method makes use of the recommendations from 
! the SCOR working group on seawater thermodynamics, 2010.  Here, density
! is a function of conservative temperature and absolute salinity. 
! The equation is valid from 0 g/kg salinty to a very large value.
!
!
! </DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
!  McDougall T.J., P.M. Barker, R. Feistel and D.R. Jackett, 2011:  A
!   computationally efficient 48-term expression for the density of
!   seawater in terms of Conservative Temperature, and related properties
!   of seawater.  To be submitted to Ocean Science.
! </REFERENCE>
!
! <REFERENCE>
! IOC, SCOR and IAPSO, 2010: The international thermodynamic equation of 
! seawater 2010: Calculation and use of thermodynamic properties. 
! Intergovernmental Oceanographic Commission, Manuals and Guides No.
! 56, UNESCO (English), 196 pp.
! </REFERENCE>
!
! <REFERENCE>
! D. Iudicone, G. Madec, and T.J. McDougall (2008)
! Water-mass transformations in a neutral density framework and the
! key role of light penetration.  JPO vol 38, pages 1357-1376.
! </REFERENCE>
!
! <REFERENCE>
! Jackett, McDougall, Feistel, Wright, and Griffies (2006)
! Algorithms for density, potential temperature, conservative
! temperature, and freezing temperature of seawater.  
! Journal of Atmospheric and Oceanic Technology, 2006, 
! volume 23, pages 1709-1728.
! </REFERENCE>
!
! <REFERENCE>
! McDougall and Jackett (2005)
! The material derivative of neutral density
! Journal of Marine Research, vol 63, pages 159-185.
! </REFERENCE>
!
! <REFERENCE>
! Feistel (2003), A new extended Gibbs thermodynamic potential 
! of seawater. Progress in Oceanography. vol 58, pages 43-114.
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, M.J. Harrison,  R.C. Pacanowski, and A. Rosati
! A Technical Guide to MOM4 (2003)
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, R.C. Pacanowski, R.M. Schmidt, and V. Balaji
! Tracer Conservation with an Explicit Free Surface Method for 
! Z-coordinate Ocean Models
! Monthly Weather Review (2001) vol 129 pages 1081--1098
! </REFERENCE>
!
! <REFERENCE>
! T. McDougall (1987)
! Cabbeling, Thermobaricity, and water mass conversion
! JGR vol 92, pages 5448-5464
! </REFERENCE>
!
! <NOTE>
!
! Density is computed as a function of conservative temperature (degC) 
! or potential temperature (degC), salinity (psu or g/kg), and pressure (dbar).
! The pressure contribution includes that from the free surface height 
! and the applied atmospheric and/or sea ice pressure.  However, it is referenced
! to standard atmosphere, so that we use the "gauge" pressure rather than the 
! full in-situ pressure.  
!
! For vert_coordinate==GEOPOTENTIAL, ZSTAR, or ZSIGMA, baroclinic component of
! hydrostatic pressure is not known until density is known.  In this case,
! the baroclinic pressure contribution to density is lagged by a time step.  
! rho(tau) = rho[theta(tau),s(tau), p_atm(tau) + p_fs(tau) + p_baroclinic(tau-1)].  
! This issue does not arise when using vert_coordinate=PRESSURE, PSTAR, or PSIGMA.
!
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_density_nml">
!
!  <DATA NAME="write_a_restart" TYPE="logical">
!  Set true to write a restart.  False setting only for rare 
!  cases where wish to benchmark model without measuring the cost
!  of writing restarts and associated chksums.  
!  Default is write_a_restart=.true. 
!  </DATA> 
!
!  <DATA NAME="press_standard" UNITS="dbar" TYPE="real">
!  Standard atmospheric pressure (dbar).  The realistic 
!  EOS used in MOM requires "sea pressure" as an argument
!  rather than absolute pressure.  Sea pressure is 
!  absolute pressure minus a standard atmospheric pressure 
!  of 10.1325dbar.  
!
!  For models that do have a realistic atmospheric loading, then it
!  is appropriate to remove 10.1325dbar prior to computing the EOS.
!  For those cases with zero atmospheric pressure, then it is not
!  necessary to remove the standard atmosphere.  The default for the 
!  press_standard is 0.0dbar.   
!  </DATA> 
!
!  <DATA NAME="t_test" UNITS="C" TYPE="real"> 			
!  Conservative temperature or potential temperature for 
!  testing the EOS.
!  </DATA> 
!  <DATA NAME="s_test" UNITS="psu or g/kg" TYPE="real">
!  Salinity for testing the EOS.
!  </DATA> 
!  <DATA NAME="p_test" UNITS="dbar" TYPE="real">
!  Sea pressure for testing the EOS.
!  </DATA> 
!
!  <DATA NAME="tn_test" UNITS="C" TYPE="real"> 			
!  Conservative temperature or potential temperature for 
!  testing the equation for neutral density.
!  </DATA> 
!  <DATA NAME="sn_test" UNITS="psu or g/kg" TYPE="real">
!  Salinity the equation for neutral density.
!  </DATA> 
!
!  <DATA NAME="eos_teos10" TYPE="logical">
!  Set to true to use TEOS-10 equation of state, which 
!  is a function of conservative temperature and absolute
!  salinity.  
!  Default eos_teos10=.false.
!  </DATA>
!  <DATA NAME="eos_preteos10" TYPE="logical">
!  Set to true to use pre-TEOS-10 equation of state, which 
!  is a function of potential temperature and practical salinity, 
!  or conservative temperature and practical salinity.
!  Default eos_preteos10=.false.
!  </DATA>
!  <DATA NAME="eos_linear" TYPE="logical">
!  Set to true to use an idealized linear equation of state, which 
!  has no pressure dependence, and is a linear function of salinity
!  and temperature. 
!  Default eos_linear=.false.
!  </DATA>
!  <DATA NAME="alpha_linear_eos" TYPE="real">
!  Constant "thermal expansion coefficient" for linear EOS 
!  rho = rho0 - alpha_linear_eos*theta + beta_linear_eos*salinity
!  </DATA>
!  <DATA NAME="beta_linear_eos" TYPE="real">
!  Constant "saline contraction coefficient" for linear EOS 
!  rho = rho0 - alpha_linear_eos*theta + beta_linear_eos*salinity
!  </DATA>
!
!  <DATA NAME="potrho_press" UNITS="dbar" TYPE="real">
!  Reference sea pressure for computing diagnostic potential density
!  of use for computing diagnostics with potential density.  
!  Default potrho_press=2000.0
!  </DATA> 
!  <DATA NAME="potrho_min" UNITS="kg/m^3" TYPE="real">
!  Minimum potential density used to partition vertical according 
!  to potential density.  
!  </DATA> 
!  <DATA NAME="potrho_max" UNITS="kg/m^3" TYPE="real">
!  Maximum potential density used to partition vertical according 
!  to potential density.
!  </DATA> 
!
!  <DATA NAME="neutral_density_omega" TYPE="logical">
!  Set to true to compute the neutral density according to 
!  the omega method based on Klocker and McDougall. 
!  This approach has not yet been coded. Presently as a 
!  placeholder we use potential density referenced to 2000dbar.
!  Default neutral_density_omega=.false.
!  </DATA>
!  <DATA NAME="neutral_density_potrho" TYPE="logical">
!  Set to true to compute the neutral density as just 
!  a selected potential density, set according to potrho_press. 
!  Since the neutral_density_omega approach has yet to be coded,
!  we only have the neutral_density_potrho option to choose from
!  at this time.  
!  Default neutral_density_potrho=.true.
!  </DATA>
!  <DATA NAME="diff_nrho_press" TYPE="logical">
!  If neutral_density_potrho=true., use a different reference sea pressure
!  nrho_press, instead of potrho_press? Allows multiple diagnostic potential
!  densities to be output.
!  Default diff_nrho_press=.false.
!  <DATA NAME="nrho_press" UNITS="dbar" TYPE="real">
!  Reference sea pressure for computing diagnostic potential density
!  for the 'neutral' density variable used in computing diagnostics with nrho.
!  Default nrho_press=2000.0
!  </DATA>
!  <DATA NAME="neutral_density_theta" TYPE="logical">
!  Set to true to use temperature instead of neutral density as the
!  binning variable for water-mass diagnostics.
!  Default neutral_density_theta=.false.
!  </DATA>
!  <DATA NAME="neutralrho_min" UNITS="kg/m^3" TYPE="real">
!  Minimum neutral density used to partition vertical according 
!  to rational polynomial approximation to neutral density.  
!  </DATA> 
!  <DATA NAME="neutralrho_max" UNITS="kg/m^3" TYPE="real">
!  Maximum neutral density used to partition vertical according 
!  to rational polynomial approximation to neutral density.  
!  </DATA> 
!
!  <DATA NAME="theta_min" UNITS="C" TYPE="real">
!  Minimum conservative temperature or potential temperature used to 
!  partition vertical according to temperature.  
!  </DATA> 
!  <DATA NAME="theta_max" UNITS="C" TYPE="real">
!  Maximum conservative temperature or potential temperature used to
!  partition vertical according to temperature. 
!  </DATA> 
!
!  <DATA NAME="layer_nk" TYPE="integer">
!  Number of classes used to partition vertical according to potential density,
!  conservative temperature, or potential temperature. Used for diagnostics. 
!  </DATA> 
!
!  <DATA NAME="buoyfreq_smooth_vert" TYPE="logical">
!  To smooth the vertical temp and salt derivative for diagnosing 
!  the buoyancy frequency. Default buoyfreq_smooth_vert=.true.
!  </DATA>
!
!  <DATA NAME="epsln_drhodz" UNITS="kg/m4" TYPE="real">
!  To normalize the inverse vertical derivative of
!  locally referenced potential density for computing the
!  buoyancy frequency. Default epsln_drhodz=1e-10.
!  </DATA>
!
!  <DATA NAME="epsln_drhodz_diag" UNITS="kg/m4" TYPE="real">
!  To normalize the inverse vertical derivative of locally referenced
!  potential density for computing neutral_rho and wdian diagnostics. 
!  Default epsln_drhodz_diag=1e-10.
!  </DATA>
!
!  <DATA NAME="smax_diag" UNITS="dimensionless" TYPE="real">
!  A diagnostic maximum neutral slope for use in computing which direction 
!  is deemed the most stratified.  For use in computing the stratification_factor
!  which is then used to diagnose the dianeutral mass transport.  
!  smax_diag should corresond to the choice used in neutral diffusion scheme.  
!  Should have 0 <= smax_diag <= 1.0. 
!  Default smax_diag=-1.0, in which case we compute the smax according to 
!  the vertical to horizontal grid aspect ratio.  This method ensures that 
!  the slope is adequately "resolved" by the grid.
!  </DATA>
!  <DATA NAME="smax_min_in_column" TYPE="logical">
!  To compute the diagnostic maximum neutral slope within a column as the minimum 
!  vertical to horizontal grid aspect ratio.  This method ensures that 
!  the slope is adequately "resolved" by the grid, and that all depths use the 
!  same definition of "resolved", even if presumably thicker grid cells can 
!  "resolve" larger neutral slopes.  This approach is not very useful generally,
!  so it is retained only for testing purposes.  
!  Default smax_min_in_column=.false.  
!  </DATA>
!
!  <DATA NAME="mask_domain_restart" TYPE="logical">
!  For cases where use the domain masking, it is necessary to initialize the field 
!  denominator_r to nonzero in order to avoid NaNs in the case when change processor
!  layout in between restarts.  Note that when use solid wall boundary conditions, 
!  this logical should remain false in order to bitwise reproduce across restarts.
!  Default mask_domain_restart=.false. 
!  </DATA>
!
!  <DATA NAME="drhodz_diag_stable" TYPE="logical">
!  When computing drhodz_diag, we can enforce that it is negative,
!  thus reflecting a stable stratification.  The field drhodz_diag 
!  is used for many water mass transformation diagnostics, such as 
!  wdian_rho.  Allowing for unstable profiles can bias the wdian_rho 
!  calculation in an improper way, since the magnitude of drhodz_diag
!  is very small when it is positive, whereas it is larger magnitude when
!  negative.  Default drhodz_diag_stable=.true. 
!  </DATA>
!
!  <DATA NAME="grad_nrho_lrpotrho_compute" TYPE="logical">
!  To perform the diagnostic calculation of grad_nrho_lrpotrho
!  for analysis diagnostics.  This factor is not well constrained,
!  and can be problematic in certain regions.  So presently we do 
!  not recommend computing it, so that the default 
!  is grad_nrho_lrpotrho_compute=.false. 
!  </DATA>
!  <DATA NAME="grad_nrho_lrpotrho_max" UNITS="dimensionless" TYPE="real">
!  Maximum value used for grad_nrho_lrpotrho.  
!  Default grad_nrho_lrpotrho_max=10.
!  </DATA>
!  <DATA NAME="grad_nrho_lrpotrho_min" UNITS="dimensionless" TYPE="real">
!  Minimum value used for grad_nrho_lrpotrho.  
!  Default grad_nrho_lrpotrho_min=1.
!  </DATA>
!
!  <DATA NAME="smooth_stratification_factor" TYPE="logical">
!  For doing an S2D smoothing of the stratification factor used 
!  for diagnostic purposes.  Requires an extra call to mpp update.
!  Default smooth_stratification_factor=.false. since the smoothing 
!  incurs a cost that should be borne only when desired.  
!  </DATA>
!
!  <DATA NAME="update_diagnostic_factors" TYPE="logical">
!  To update the watermass_factor and stratification_factor
!  for use in the water mass transformation diagnostics.  
!  Default update_diagnostic_factors=.false. 
!  </DATA>
!
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging nonlinear equation of state 
!  </DATA>
!
!  <DATA NAME="rho0_density" TYPE="logical">
!  For debugging, it is often useful to have rho=rho0 uniform.
!  </DATA>
!
!  <DATA NAME="density_equal_potrho" TYPE="logical">
!  For idealized tests, set the in situ density equal to the 
!  potential density referenced to potrho_press.  All density 
!  derivatives will also be computed with respect to constant
!  potrho_press pressure.  
!  Default density_equal_potrho=.false.
!  </DATA>
!
!  <DATA NAME="do_bitwise_exact_sum" TYPE="logical">
!  Set true to do bitwise exact global sum. When it is false, the global
!  sum will be non-bitwise_exact, but will significantly increase 
!  efficiency.
!  default: do_bitwise_exact_sum=.false.
!  </DATA>
!
!</NAMELIST>

#include <fms_platform.h>

use constants_mod,       only: epsln, c2dbars
use diag_manager_mod,    only: register_diag_field, register_static_field, diag_axis_init
use diag_manager_mod,    only: need_data, send_data
use fms_mod,             only: write_version_number, mpp_error
use fms_mod,             only: field_exist, FATAL, WARNING
use fms_mod,             only: open_namelist_file, check_nml_error, close_file, file_exist
use fms_io_mod,          only: register_restart_field, save_restart, restore_state
use fms_io_mod,          only: reset_field_pointer, restart_file_type
use mpp_domains_mod,     only: mpp_update_domains, mpp_global_sum
use mpp_domains_mod,     only: BITWISE_EXACT_SUM, NON_BITWISE_EXACT_SUM
use mpp_mod,             only: input_nml_file, stdout, stdlog
use platform_mod,        only: i8_kind
use time_manager_mod,    only: time_type, increment_time
use field_manager_mod,   only: fm_get_index

use ocean_domains_mod,    only: get_local_indices
use ocean_operators_mod,  only: FDX_T, FDY_T, FMX, FMY, S2D 
use ocean_parameters_mod, only: GEOPOTENTIAL, ZSTAR, ZSIGMA, PRESSURE, PSTAR, PSIGMA 
use ocean_parameters_mod, only: CONSERVATIVE_TEMP, POTENTIAL_TEMP, PRACTICAL_SALT, PREFORMED_SALT
use ocean_parameters_mod, only: missing_value, onefourth, onehalf, rho0r, rho0, grav
use ocean_pressure_mod,   only: pressure_in_dbars, pressure_in_dbars_blob
use ocean_types_mod,      only: ocean_domain_type, ocean_grid_type, ocean_thickness_type
use ocean_types_mod,      only: ocean_time_type, ocean_time_steps_type, ocean_options_type
use ocean_types_mod,      only: ocean_prog_tracer_type, ocean_density_type, ocean_external_mode_type
use ocean_types_mod,      only: ocean_diag_tracer_type, ocean_lagrangian_type
use ocean_util_mod,       only: write_timestamp, diagnose_2d, diagnose_3d, write_chksum_3d
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3, wrk4, wrk5, wrk6
use ocean_workspace_mod,  only: wrk1_v, wrk2_v, wrk3_v, wrk4_v
use ocean_workspace_mod,  only: wrk1_2d, wrk2_2d, wrk3_2d, wrk4_2d

implicit none

private

real, dimension(:), allocatable     :: a, b                   ! polynomial coefficients in the realistic EOS
real, dimension(:,:), allocatable   :: rhodz_tau              ! vertical integral of rho*dzt at time tau
real, dimension(:,:), allocatable   :: rhodz_taup1            ! vertical integral of rho*dzt at time taup1
real, dimension(:,:,:), allocatable :: denominator_r          ! reciprocal of denominator for relastic EOS

integer  :: vert_coordinate        ! for setting which vertical coordinate to use
integer  :: global_sum_flag        ! for determing type of global sum BITWISE/NON

! polynomial coefficients in the preTEOS10 EOS
real :: a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11      
real :: b0, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12

! multiplied constants for density partial derivs in the preTEOS10 EOS
real :: two_a2, three_a3, two_a6, six_a3, two_a8, two_a10, two_a11, four_a11             
real :: two_b2, three_b3, six_b3, four_b4, twelve_b4, three_b7, six_b7             
real :: onep5_b8, onep5_b9, two_b9, three_b9, two_b11, three_b11, six_b11, three_b12   

! polynomial coefficients in the TEOS10 eos 
real :: v01,v02,v03,v04,v05,v06,v07,v08,v09,v10
real :: v11,v12,v13,v14,v15,v16,v17,v18,v19,v20
real :: v21,v22,v23,v24,v25,v26,v27,v28,v29,v30
real :: v31,v32,v33,v34,v35,v36,v37,v38,v39,v40
real :: v41,v42,v43,v44,v45,v46,v47,v48

! multiplied constants for density partial derivs in the TEOS10 EOS
real :: two_v03, two_v07, two_v10, two_v14, two_v17, two_v19, two_v18, two_v20, two_v23, two_v28, two_v33
real :: two_v36, two_v39, two_v43, two_v44, two_v45, two_v46
real :: three_v04, three_v11, three_v24, three_v29, three_v34, three_v40, three_v47, three_v48
real :: four_v25, four_v30, four_v35
real :: onep5_v08, onep5_v09, onep5_v10, onep5_v11, onep5_v31, onep5_v32, onep5_v33, onep5_v34, onep5_v35
real :: six_v04, six_v11, six_v24, six_v29, six_v34, six_v40, six_v47, six_v48
real :: twelve_v25, twelve_v30, twelve_v35
real :: p75_v08, p75_v09, p75_v10, p75_v11, p75_v31, p75_v32, p75_v33, p75_v34, p75_v35
real :: three_v10, three_v33
real :: fourp5_v11, fourp5_v34
real :: four_v19, four_v45
real :: six_v35

! polynomial coefficients in neutral density 
real :: a0n, a1n, a2n, a3n, a4n, a5n, a6n
real :: b0n, b1n, b2n, b3n, b4n, b5n, b6n, b7n, b8n, b9n

! time steps 
real :: dtts=0.0

! inverse area (1/m) of k=1 tracer cells 
real :: area_total_r  

! inverse neutralrho_interval
real :: neutralrho_interval_r

! inverse gravity constant 
real :: grav_r 

! for diagnostics manager 
logical :: used
integer :: id_eos_salinity   =-1
integer :: id_drhodtheta     =-1
integer :: id_drhodsalt      =-1
integer :: id_dpotrhodtheta  =-1
integer :: id_dpotrhodsalt   =-1
integer :: id_dpotrhodpress  =-1
integer :: id_drhodpress     =-1
integer :: id_thermal_expand =-1
integer :: id_haline_contract=-1
integer :: id_sound_speed2   =-1
integer :: id_press          =-1
integer :: id_rho            =-1
integer :: id_rhoE           =-1
integer :: id_rho0           =-1
integer :: id_neutral_rho    =-1
integer :: id_pot_rho        =-1
integer :: id_pot_rho_0      =-1
integer :: id_pot_rho_1      =-1
integer :: id_pot_rho_2      =-1
integer :: id_pot_rho_3      =-1
integer :: id_pot_rho_4      =-1
integer :: id_pot_rho_et     =-1
integer :: id_pot_rho_nt     =-1
integer :: id_pot_rho_wt     =-1
integer :: id_rho_average    =-1
integer :: id_mass_level     =-1
integer :: id_volume_level   =-1
integer :: id_drhodx_zt      =-1  
integer :: id_drhody_zt      =-1  
integer :: id_drhodz_zt      =-1  
integer :: id_drhodz_wt      =-1  
integer :: id_drhodz_diag    =-1  
integer :: id_buoyfreq2_zt   =-1  
integer :: id_buoyfreq2_wt   =-1  
integer :: id_cabbeling      =-1
integer :: id_thermobaricity =-1
integer :: id_int_rhodz      =-1

integer :: id_rhoave              =-1
integer :: id_pbot_adjust         =-1
integer :: id_eta_adjust          =-1
integer :: id_eta_adjust_approx   =-1
integer :: id_eta_adjust_cstvolume=-1

integer :: id_grad_nrho             =-1
integer :: id_grad_lrpotrho         =-1
integer :: id_grad_nrho_lrpotrho    =-1
integer :: id_watermass_factor      =-1
integer :: id_stratification_factor =-1
integer :: id_stratification_axis   =-1
integer :: id_smax_dianeutral       =-1

!for restart
integer                       :: id_restart_rho = 0
integer                       :: id_restart_rho_s = 0
type(restart_file_type), save :: Den_restart

#include <ocean_memory.h>

type(ocean_domain_type), pointer :: Dom =>NULL()
type(ocean_grid_type),   pointer :: Grd =>NULL()

character(len=128) :: version=&
       '$Id: ocean_density.F90,v 20.0 2013/12/14 00:10:40 fms Exp $'
character (len=128) :: tagname = &
       '$Name: tikal $'

public ocean_density_init
public ocean_density_end
public ocean_density_diag
public update_ocean_density
public update_ocean_density_salinity
public density
public potential_density
public neutral_density
public density_sfc
public density_derivs
public density_delta_z
public density_delta_sfc
public ocean_density_restart
public calc_cabbeling_thermobaricity
public buoyfreq2
public compute_buoyfreq

private compute_drhodxy
private ocean_density_chksum
private cabbeling_thermobaricity
private compute_diagnostic_factors
private compute_density_diagnostics 
private density_coeffs_init
private density_diagnostics_init

! interfaces for density 
interface density
   module procedure density_field
   module procedure density_level
   module procedure density_line
   module procedure density_point
end interface

! interfaces for neutral density 
interface neutral_density
   module procedure neutral_density_field
   module procedure neutral_density_point
end interface


! interfaces for density derivatives 
interface density_derivs
   module procedure density_derivs_field
   module procedure density_derivs_level
   module procedure density_derivs_point
end interface

integer :: index_temp   =-1
integer :: index_salt   =-1
integer :: index_Fdelta =-1
integer :: num_prog_tracers
integer :: salt_variable
integer :: temp_variable

! indices for diagnostic tracer density elements
integer :: ind_rho        = -1
integer :: ind_neutralrho = -1
integer :: ind_potrho_0   = -1
integer :: ind_potrho_1   = -1
integer :: ind_potrho_2   = -1
integer :: ind_potrho_3   = -1
integer :: ind_potrho_4   = -1

! nml settings 

! for linear EOS 
logical :: eos_linear=.false.    
real    :: alpha_linear_eos=0.255
real    :: beta_linear_eos =0.0

! for teos10 or preteos10 eos
logical :: eos_preteos10 = .false.
logical :: eos_teos10    = .false.

! some test settings for density 
real :: s_test=20.0
real :: t_test=20.0
real :: p_test=1000.0
real :: jmfwg_rho 
real :: jmfwg_alpha 
real :: jmfwg_beta 
real :: mbfj_rho 
real :: mbfj_alpha 
real :: mbfj_beta 

! some test settings for neutral density 
real :: sn_test=35.0
real :: tn_test=20.0
real :: mj_neutralrho 
real :: mb_neutralrho 

! for diagnostic partitioning of vertical according to 
! potential density, neutral density, or theta classes 
integer :: layer_nk = 80 ! # of classes used to compute diagnostics associated with 
                         ! potential density, potential temperature, or conservative
                         ! temperature classes. 

! for diagnostic partitioning of vertical according to potential density classes 
real :: potrho_press = 2000.0  ! sea pressure (dbars) for potential density computed for diagnostics
real :: potrho_min   = 1028.0  ! (kg/m^3)         
real :: potrho_max   = 1038.0  ! (kg/m^3)           

! for diagnostic partitioning of vertical according to 
! rational polynomial approximation to neutral density
logical :: neutral_density_omega  = .false.
logical :: neutral_density_potrho = .true.
logical :: neutral_density_theta  = .false.
real    :: neutralrho_min = 1020.0  ! (kg/m^3)         
real    :: neutralrho_max = 1030.0  ! (kg/m^3)           

real    :: nrho_press = 2000.0
logical :: diff_nrho_press = .false.

! for diagnostic partitioning of vertical according 
! to potential temperature or conservative temperature classes 
real :: theta_min = -2.0  ! (degrees C)         
real :: theta_max = 30.0  ! (degrees C)           

! standard atmospheric pressure (dbar).
! Should be set to 0.0 if assume zero pressure for the 
! overlying atmosphere.  But if have a realistic atmospheric
! pressure loading, then set press_standard=10.1325.  
real :: press_standard = 0.0 

! for smoothing the vertical density gradient 
! when diagnosing the buoyancy frequency. 
logical :: buoyfreq_smooth_vert=.true.
integer :: num_121_passes      =1
real    :: epsln_drhodz        =1.e-10

! for enforcing negative drhodz_diag
logical :: drhodz_diag_stable = .true.
real    :: epsln_drhodz_diag = 1.e-10

! for setting grad_nrho_lrpotrho=1.0 
logical :: grad_nrho_lrpotrho_compute=.false.
real    :: grad_nrho_lrpotrho_max=10.0
real    :: grad_nrho_lrpotrho_min=1.0

! for stratification factor used for diagnostics 
logical :: smooth_stratification_factor=.false.
logical :: smax_min_in_column=.false.
real    :: smax_diag=-1.0
real, dimension(:,:,:), allocatable :: smax
real, dimension(:,:),   allocatable :: dhorz_r

! to compute diagnostic factors for 
! water mass transformation diagnostics 
logical :: update_diagnostic_factors=.false. 

! for case when use domain masking, 
logical :: mask_domain_restart = .false. 

logical :: debug_this_module     = .false. 
logical :: rho0_density          = .false.
logical :: density_equal_potrho  = .false. 
logical :: module_is_initialized = .false.
logical :: write_a_restart       = .true. 
logical :: do_bitwise_exact_sum  = .false.

namelist /ocean_density_nml/ s_test, t_test, p_test, press_standard,                  &
                             sn_test, tn_test,                                        &
                             eos_linear, alpha_linear_eos, beta_linear_eos,           & 
                             eos_preteos10, eos_teos10,                               &
                             potrho_press, potrho_min, potrho_max,                    &
                             neutralrho_min, neutralrho_max,                          &
                             layer_nk, theta_min, theta_max,                          &
                             debug_this_module, write_a_restart,                      &
                             rho0_density, density_equal_potrho,                      &
                             buoyfreq_smooth_vert, num_121_passes, epsln_drhodz,      &
                             mask_domain_restart, do_bitwise_exact_sum,               &
                             drhodz_diag_stable, epsln_drhodz_diag,                   &
                             grad_nrho_lrpotrho_compute, grad_nrho_lrpotrho_max,      &
                             grad_nrho_lrpotrho_min,                                  &
                             neutral_density_omega, neutral_density_potrho,           &
                             neutral_density_theta,                                   &
                             smooth_stratification_factor, update_diagnostic_factors, &
                             smax_diag, smax_min_in_column 
contains

!#######################################################################
! <SUBROUTINE NAME="ocean_density_init">
!
! <DESCRIPTION>
! Initialize the density module
! </DESCRIPTION>
!
  subroutine ocean_density_init (Grid, Domain, Time, Time_steps, Thickness, T_prog, T_diag, &
                                 Ocean_options, Dens, ver_coordinate, use_blobs, debug)

    type(ocean_grid_type),        target,  intent(in)    :: Grid
    type(ocean_domain_type),      target,  intent(in)    :: Domain
    type(ocean_time_type),                 intent(in)    :: Time
    type(ocean_time_steps_type),           intent(in)    :: Time_steps
    type(ocean_thickness_type),            intent(in)    :: Thickness
    type(ocean_prog_tracer_type), target,  intent(in)    :: T_prog(:)
    type(ocean_diag_tracer_type),          intent(inout) :: T_diag(:)
    type(ocean_options_type),              intent(inout) :: Ocean_options
    type(ocean_density_type),     target,  intent(inout) :: Dens

    integer,   intent(in)            :: ver_coordinate
    logical,   intent(in)            :: use_blobs
    logical,   intent(in), optional  :: debug
    
    integer :: ioun, io_status, ierr
    integer :: i, j, k, n
    integer :: tau, taup1, taum1
    integer :: num_eos
    real    :: rho0_nk(nk)

    real, allocatable, dimension(:) :: rho_average
    real, allocatable, dimension(:) :: mass_level
    real, allocatable, dimension(:) :: volume_level 

    integer :: id_grid_xt, id_grid_yt
    integer :: id_grid_xu, id_grid_yu

    integer :: id_potrho_bounds,     id_potrho_axis
    integer :: id_neutralrho_bounds, id_neutralrho_axis
    integer :: id_theta_bounds,      id_theta_axis

    integer :: id_restart(5)
    integer :: neutral_rho_method=0

    real, allocatable, dimension(:) :: potrho_bounds
    real, allocatable, dimension(:) :: neutralrho_bounds
    real, allocatable, dimension(:) :: theta_bounds

    ! salinity and temperature pointers to aid readability 
    real, dimension(:,:,:), pointer :: salinity    => NULL()
    real, dimension(:,:,:), pointer :: temperature => NULL()

    real    :: potrho_interval 
    real    :: neutralrho_interval 
    real    :: theta_interval 
    character*128 filename

    integer :: stdoutunit,stdlogunit 
    stdoutunit=stdout();stdlogunit=stdlog() 


    if ( module_is_initialized ) then 
      call mpp_error(FATAL, &
       '==>Error in ocean_density_mod (ocean_density_init): module already initialized.')
    endif 

    module_is_initialized = .TRUE.

    tau             = Time%tau
    taup1           = Time%taup1
    taum1           = Time%taum1
    vert_coordinate = ver_coordinate
 
    num_prog_tracers = size(T_prog(:))
    do n=1,num_prog_tracers
       if (T_prog(n)%name == 'temp')   index_temp   = n
       if (T_prog(n)%name == 'salt')   index_salt   = n
       if (T_prog(n)%name == 'fdelta') index_Fdelta = n
       if (T_prog(n)%longname == 'Conservative temperature') temp_variable = CONSERVATIVE_TEMP
       if (T_prog(n)%longname == 'Potential temperature')    temp_variable = POTENTIAL_TEMP
       if (T_prog(n)%longname == 'Practical Salinity')       salt_variable = PRACTICAL_SALT
       if (T_prog(n)%longname == 'Preformed Salinity')       salt_variable = PREFORMED_SALT
    enddo

    call write_version_number(version, tagname)

    ! provide for namelist override of defaults
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_density_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_density_nml')
#else
    ioun = open_namelist_file()
    read (ioun,ocean_density_nml,IOSTAT=io_status)
    ierr = check_nml_error(io_status, 'ocean_density_nml')
    call close_file(ioun)
#endif
    write (stdoutunit,'(/)')
    write (stdoutunit,ocean_density_nml)
    write (stdlogunit,ocean_density_nml)

    num_eos = 0
    if(eos_linear) then 
      num_eos = num_eos+1
    elseif(eos_preteos10) then 
      num_eos = num_eos+1
    elseif(eos_teos10) then 
      num_eos = num_eos+1
    endif        
    if(num_eos == 0) then
      call mpp_error(FATAL, &
       '==>Error in ocean_density_mod: No EOS chosen. Set one to true: eos_linear, eos_preteos10, eos_teso10.')
    endif 
    if(num_eos > 1) then
      call mpp_error(FATAL, &
       '==>Error in ocean_density_mod: More than one EOS chosen. Set just one true: eos_linear, eos_preteos10, eos_teso10.')
    endif 
    Dens%use_teos10 = eos_teos10


    if (PRESENT(debug) .and. .not. debug_this_module) then
      debug_this_module = debug
    endif 
    if(debug_this_module) then 
      write(stdoutunit,'(a)') '==>Note: running ocean_density with debug_this_module=.true.'  
    endif 

    if(.not. write_a_restart) then 
      write(stdoutunit,'(a)') '==>Note: running ocean_density with write_a_restart=.false.'
      write(stdoutunit,'(a)') '   Will NOT write restart file, and so cannot restart the run.'
    endif 

    if(do_bitwise_exact_sum) then
       global_sum_flag = BITWISE_EXACT_SUM
    else
       global_sum_flag = NON_BITWISE_EXACT_SUM
    endif

    if(eos_linear) then
        write (stdoutunit,'(/1x,a)') &
        ' ==> Note: USING linear EOS designed for idealized simulations.'
        write (stdoutunit,'(7x,a)') &
        'It is a linear function of potential temperature and salinity.'
        write (stdoutunit,'(7x,a)') &
        'There is no pressure dependence.'
        Ocean_options%equation_of_state = 'Linear equation of state used for density.'
    elseif(eos_preteos10) then 
        write (stdoutunit,'(/1x,a)') &
        ' ==> Note: USING preTEOS10 EOS, as relevant for realistic ocean climate simulations.' 
        write (stdoutunit,'(1x,a,f12.6,a)') &
        ' Subtracting standard atmosphere of ',press_standard,' dbar for EOS calculation.'  
        Ocean_options%equation_of_state = 'preTEOS10 equation of state used for density.'
    elseif(eos_teos10) then 
        write (stdoutunit,'(/1x,a)') &
        ' ==> Note: USING TEOS10 EOS, as relevant for realistic ocean climate simulations.' 
        write (stdoutunit,'(1x,a,f12.6,a)') &
        ' Subtracting standard atmosphere of ',press_standard,' dbar for EOS calculation.'  
        Ocean_options%equation_of_state = 'TEOS10 equation of state used for density.'
    endif

    if(temp_variable==CONSERVATIVE_TEMP) then
        write (stdoutunit,'(/1x,a)') &
        ' ==> Note: Computing EOS assuming prognostic temp = conservative temperature.'
    elseif(temp_variable==POTENTIAL_TEMP) then
        write (stdoutunit,'(/1x,a)') &
        ' ==> Note: Computing EOS assuming prognostic temp = potential temperature.'
    else
      call mpp_error(FATAL, &
       '==>Error in ocean_density_mod: model temperature variable remains unspecified')
    endif 

    if(salt_variable==PRACTICAL_SALT) then
        if(eos_teos10) then 
            call mpp_error(FATAL, &
            '==>Error in ocean_density_mod: eos_teos10 requires preformed salinity as prognostic salinity.')
        endif
        write (stdoutunit,'(/1x,a)') &
        ' ==> Note: Computing EOS assuming prognostic salinity = practical salinity.'
    elseif(salt_variable==PREFORMED_SALT) then
        if(eos_linear .or. eos_preteos10) then 
            call mpp_error(FATAL, &
            '==>Error in ocean_density_mod: preformed salinity as prognostic salinity requires eos_teos10.')
        endif
        write (stdoutunit,'(/1x,a)') &
        ' ==> Note: Computing TEOS10 EOS assuming prognostic salinity = preformed salinity.'
    else
      call mpp_error(FATAL, &
       '==>Error in ocean_density_mod: model salinity variable remains unspecified')
    endif 

    write(stdoutunit,*) &
    '==>Note: The Boussinesq rho0 density has a value of (kg/m^3) ',rho0
    if(rho0_density) then 
        write(stdoutunit,*) &
        '==>Warning: rho0_density=.true, so rho=rho0 everywhere. Is this really what you wish to do?'
    endif

    if(neutral_density_omega) then 
        write (stdoutunit,'(/1x,a)') &
        ' ==> Note: Computing diagnostic neutral_rho according to Klocker/McDougall (not yet coded).'
        neutral_rho_method = neutral_rho_method + 1 
        call mpp_error(WARNING, &
       '==>Warning in ocean_density_mod: neutral_density_omega not coded. Will use potential density 2000dbar.')
    endif 
    if(neutral_density_potrho) then 
        write (stdoutunit,'(/1x,a)') &
        ' ==> Note: Computing diagnostic neutral_rho as potential density referenced to pressure potrho_press.'
        neutral_rho_method = neutral_rho_method + 1 
    endif 
    if(neutral_density_theta) then 
        write (stdoutunit,'(/1x,a)') &
        ' ==> Note: Computing diagnostic neutral_rho as conservative temperature.'
        neutral_rho_method = neutral_rho_method + 1 
    endif
    if(neutral_rho_method==0) then 
      call mpp_error(FATAL, &
       '==>Error in ocean_density_mod: set one of the options "neutral_density_omega" or "neutral_density_potrho" or "neutral_density_theta" true.')
    endif   
    if(neutral_rho_method > 1) then 
      call mpp_error(FATAL, &
       '==>Error in ocean_density_mod: set only **one** of the options "neutral_density_omega" or "neutral_density_potrho" or "neutral_density_theta" true.')
    endif   

    if(drhodz_diag_stable) then
        write (stdoutunit,'(/1x,a)') &
        ' ==> Note: Enforcing drhodz_diag < 0, so to use stable stratification for certain diagnostic purposes.'
    endif 

    if(update_diagnostic_factors) then 
        write (stdoutunit,'(/1x,a)') &
        ' ==> Note: Computing diagnostic factors in ocean_density.F90 for watermass diagnostics.'
    else 
        write (stdoutunit,'(/1x,a)') &
        ' ==> Note: Diagnostic factors are NOT computed. So if enable watermass diagnostics, they will be corrupted.'
    endif 

#ifndef MOM_STATIC_ARRAYS
    call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
    nk = Grid%nk
    allocate(Dens%rho(isd:ied,jsd:jed,nk,3))
    allocate(Dens%rho_fresh(isd:ied,jsd:jed,nk))
    allocate(Dens%rho_salinity(isd:ied,jsd:jed,nk,3))
    allocate(Dens%rho_dztr_tau(isd:ied,jsd:jed,nk))
    allocate(Dens%potrho(isd:ied,jsd:jed,nk))
    allocate(Dens%neutralrho(isd:ied,jsd:jed,nk))
    allocate(Dens%pressure_at_depth(isd:ied,jsd:jed,nk))
    allocate(Dens%drhodT(isd:ied,jsd:jed,nk))
    allocate(Dens%dpotrhodT(isd:ied,jsd:jed,nk))
    allocate(Dens%dpotrhodS(isd:ied,jsd:jed,nk))
    allocate(Dens%dpotrhodP(isd:ied,jsd:jed,nk))
    allocate(Dens%drhodS(isd:ied,jsd:jed,nk))
    allocate(Dens%drhodP(isd:ied,jsd:jed,nk))
    allocate(Dens%drhodz_wt(isd:ied,jsd:jed,nk))
    allocate(Dens%drhodz_zt(isd:ied,jsd:jed,nk))
    allocate(Dens%drhodx_zt(isd:ied,jsd:jed,nk))
    allocate(Dens%drhody_zt(isd:ied,jsd:jed,nk))
    allocate(Dens%drhodz_diag(isd:ied,jsd:jed,nk))
    allocate(Dens%watermass_factor(isd:ied,jsd:jed,nk))
    allocate(Dens%stratification_factor(isd:ied,jsd:jed,nk))
    allocate(Dens%dTdz_zt(isd:ied,jsd:jed,nk))
    allocate(Dens%dSdz_zt(isd:ied,jsd:jed,nk))
    allocate(Dens%mld_subduction(isd:ied,jsd:jed))
    if (use_blobs) allocate(Dens%rhoT(isd:ied,jsd:jed,nk))
#endif

    do k=1,nk 
       Dens%rho_dztr_tau(:,:,k)      = rho0r*Grid%tmask(:,:,k)
       Dens%rho_fresh(:,:,k)         = 1000.0*Grid%tmask(:,:,k)
       Dens%potrho(:,:,k)            = rho0*Grid%tmask(:,:,k)
       Dens%neutralrho(:,:,k)        = rho0*Grid%tmask(:,:,k)
       Dens%pressure_at_depth(:,:,k) = rho0*grav*Thickness%depth_zt(:,:,k)*c2dbars
    enddo
    Dens%rho(:,:,:,1)            = Grid%tmask(:,:,:)*rho0 
    Dens%rho(:,:,:,2)            = Grid%tmask(:,:,:)*rho0 
    Dens%rho(:,:,:,3)            = Grid%tmask(:,:,:)*rho0 
    Dens%rho_salinity(:,:,:,1)   = Grid%tmask(:,:,:)*35 
    Dens%rho_salinity(:,:,:,2)   = Grid%tmask(:,:,:)*35 
    Dens%rho_salinity(:,:,:,3)   = Grid%tmask(:,:,:)*35 
    Dens%drhodT(:,:,:)           = 0.0
    Dens%dpotrhodT(:,:,:)        = 0.0
    Dens%dpotrhodS(:,:,:)        = 0.0
    Dens%dpotrhodP(:,:,:)        = 0.0
    Dens%drhodS(:,:,:)           = 0.0
    Dens%drhodP(:,:,:)           = 0.0
    Dens%drhodz_wt(:,:,:)        = Grid%tmask(:,:,:)*epsln_drhodz
    Dens%drhodz_zt(:,:,:)        = Grid%tmask(:,:,:)*epsln_drhodz
    Dens%drhodx_zt(:,:,:)        = 0.0
    Dens%drhody_zt(:,:,:)        = 0.0
    Dens%drhodz_diag(:,:,:)      = Grid%tmask(:,:,:)*epsln_drhodz_diag
    Dens%dTdz_zt(:,:,:)          = 0.0
    Dens%dSdz_zt(:,:,:)          = 0.0
    Dens%watermass_factor(:,:,:) = Grid%tmask(:,:,:)
    Dens%mld_subduction(:,:)     = 0.0
    do k=1,nk   
       Dens%stratification_factor(:,:,k) = Grid%tmask(:,:,k)*Grid%dzt(k)*Grid%dat(:,:)
    enddo
    if (use_blobs) Dens%rhoT(:,:,:) = 0.0

    Dom  => Domain
    Grd  => Grid
    dtts = Time_steps%dtts

    ! for diagnostics    
    area_total_r = mpp_global_sum(Dom%domain2d,Grd%dat(:,:)*Grd%tmask(:,:,1), global_sum_flag)
    if (global_sum_flag .eq. NON_BITWISE_EXACT_SUM) area_total_r = real(area_total_r,kind=FLOAT_KIND)
    area_total_r = 1.0/(epsln+area_total_r) 

    ! for diagnostic calculation of dianeutral transport 
    allocate(smax(isd:ied,jsd:jed,nk))
    allocate(dhorz_r(isd:ied,jsd:jed))
    dhorz_r(:,:) = 0.0
    smax(:,:,:)  = 0.0
    do j=jsd,jed
       do i=isd,ied
          dhorz_r(i,j) = Grd%tmask(i,j,1)  &
          *( Grd%dxt(i,j) + Grd%dyt(i,j) ) / (epsln + 2.0*Grd%dxt(i,j)*Grd%dyt(i,j) ) 
       enddo
    enddo

    grav_r = 1.0/grav
    allocate(rhodz_tau(isd:ied,jsd:jed))
    allocate(rhodz_taup1(isd:ied,jsd:jed))
    rhodz_tau   = 0.0
    rhodz_taup1 = 0.0


   ! send as 1-dim field, due to problems with diag manager 
   id_rho0 = register_static_field('ocean_model','rho0', Grid%tracer_axes(3:3), &
             'reference density for Boussinesq approximation','kg/m^3',         &
             missing_value=missing_value, range=(/-1e0,1e10/),                  &
             standard_name='reference_sea_water_density_for_boussinesq_approximation')
   rho0_nk(:) = rho0 
   if (id_rho0 > 0) then 
      used = send_data(id_rho0, rho0_nk(:), Time%model_time)
   endif 

   allocate(denominator_r(isd:ied,jsd:jed,nk))
   denominator_r(:,:,:) = 0.0

   ! specify coefficients for the polynomical equations of state 
   ! and perform some pointwise tests.  
   call density_coeffs_init()

   filename = 'ocean_density.res.nc'    
   id_restart_rho = register_restart_field(Den_restart, filename, 'rho', Dens%rho(:,:,:,taup1), &
                   domain=Dom%domain2d )
   id_restart_rho_s = register_restart_field(Den_restart, filename, 'rho_salinity', Dens%rho_salinity(:,:,:,taup1), &
                   domain=Dom%domain2d )
   id_restart(1)  = register_restart_field(Den_restart, filename, 'pressure_at_depth', Dens%pressure_at_depth(:,:,:), &
                   domain=Dom%domain2d )
   id_restart(2)  = register_restart_field(Den_restart, filename, 'denominator_r', denominator_r(:,:,:), &
                   domain=Dom%domain2d )
   id_restart(3)  = register_restart_field(Den_restart, filename, 'drhodT', Dens%drhodT(:,:,:), &
                   domain=Dom%domain2d )
   id_restart(4)  = register_restart_field(Den_restart, filename, 'drhodS', Dens%drhodS(:,:,:), &
                   domain=Dom%domain2d )
   id_restart(5)  = register_restart_field(Den_restart, filename, 'drhodz_zt', Dens%drhodz_zt(:,:,:), &
                   domain=Dom%domain2d )

   ! pointers to relevant salinity and temperature to enhance readability    
   salinity    => Dens%rho_salinity(:,:,:,tau)
   temperature => T_prog(index_temp)%field(:,:,:,tau)

   filename = 'INPUT/ocean_density.res.nc'
   if (.NOT.file_exist(trim(filename)) )then

      write (stdoutunit,'(/a)') '  Initialising salinity for use in density calculation'
      call update_ocean_density_salinity(T_prog,taum1,Dens)
      call update_ocean_density_salinity(T_prog,tau,Dens)
      call update_ocean_density_salinity(T_prog,taup1,Dens)

      Dens%rho(:,:,:,taum1) = density(salinity, temperature, Dens%pressure_at_depth(:,:,:))
      Dens%rho(:,:,:,tau)   = Dens%rho(:,:,:,taum1)
      Dens%rho(:,:,:,taup1) = Dens%rho(:,:,:,taum1)
      if (use_blobs) Dens%rhoT(:,:,:) = Dens%rho(:,:,:,taup1)

   else

       write (stdoutunit,'(/a)') '  Reading restart for density from INPUT/ocean_density.res.nc'
       call restore_state( Den_restart, id_restart_rho )
       call mpp_update_domains(Dens%rho(:,:,:,taup1),        Dom%domain2d)
       call restore_state( Den_restart, id_restart(1) )
       call mpp_update_domains(Dens%pressure_at_depth(:,:,:),Dom%domain2d)
       call restore_state( Den_restart, id_restart(2) )

       ! initialize to epsln to eliminate NaNs when mask 
       ! out processors and then change layout upon a restart 
       if(mask_domain_restart) then 
          where (denominator_r==0.)  denominator_r=rho0r
       endif 
       call mpp_update_domains(denominator_r(:,:,:),Dom%domain2d)

       ! determine whether to read density derivs at the initial time step of integration.
       ! early versions of MOM4p1 did not contain drhodT and drhodS in the restart file, so 
       ! to allow older restart files to be used with newer releases of MOM4p1, we 
       ! provide for the possibility that the restarts do not contain drhodT and drhodS.
       if(field_exist(filename, 'drhodT')) then
           call restore_state( Den_restart, id_restart(3) )
           call restore_state( Den_restart, id_restart(4) )
           call mpp_update_domains(Dens%drhodT(:,:,:),Dom%domain2d)
           call mpp_update_domains(Dens%drhodS(:,:,:),Dom%domain2d)
       else 
           write(stdoutunit,'(a)') '==>Note: ocean_density_mod: did not read density derivatives from restart.' 
       endif 

       ! determine whether to read rho_salinity at the initial time step of
       ! integration.  Early versions of MOM4p1 did not contain the rho_salinity
       ! in the restart file.  This allows older restart files to be used with
       ! newer releases of MOM.
       if(field_exist(filename, 'rho_salinity')) then
          write (stdoutunit,'(/a)') '  Initializing salinity for use in density calculation from restart'
          call restore_state( Den_restart, id_restart_rho_s )
          Dens%rho_salinity(:,:,:,taum1) = Dens%rho_salinity(:,:,:,taup1)
          Dens%rho_salinity(:,:,:,tau) = Dens%rho_salinity(:,:,:,taup1)
          call mpp_update_domains(Dens%rho_salinity(:,:,:,taum1),Dom%domain2d)
          call mpp_update_domains(Dens%rho_salinity(:,:,:,tau),  Dom%domain2d)
          call mpp_update_domains(Dens%rho_salinity(:,:,:,taup1),Dom%domain2d)
       else
          write (stdoutunit,'(/a)') '  Initialising salinity for use in density calculation'
          call update_ocean_density_salinity(T_prog,taum1,Dens)
          call update_ocean_density_salinity(T_prog,tau,Dens)
          call update_ocean_density_salinity(T_prog,taup1,Dens)
       endif

   endif

   ! compute buoyancy frequency for diagnostic purposes 
   ! note: Dens%rhoT and the buoyancy frequency is initialised in ocean_blob_init
   ! when use_blobs=.true.
   if (.not. use_blobs) then
      call compute_buoyfreq(Time, Thickness, salinity, temperature, Dens, use_blobs) 
   endif

   ! over-write drhodz_zt from compute_buoyfreq with drhodz_zt from restart. 
   ! Note that we determine whether to read drhodz_zt at the initial time 
   ! step of integration. early versions of MOM4p1 did not contain drhodz_zt 
   ! in the restart file, so to allow older restart files to be used with 
   ! newer releases of MOM4p1, we provide for the possibility that the 
   ! restarts do not contain drhodz_zt.
   if (file_exist(trim(filename)) )then 
       if(field_exist(filename, 'drhodz_zt')) then
           call restore_state( Den_restart, id_restart(5) )
          call mpp_update_domains(Dens%drhodz_zt(:,:,:),Dom%domain2d)
       else 
          write(stdoutunit,'(a)') '==>Note: ocean_density_mod: did not read drhodz_zt from restart.' 
       endif
   endif

   ! compute neutral density for diagnostic purposes 
   Dens%neutralrho(:,:,:) = Grd%tmask(:,:,:)*neutral_density(salinity, temperature)
   ind_neutralrho = fm_get_index('/ocean_mod/diag_tracers/rho_neutral')
   if (ind_neutralrho .gt. 0) then
     T_diag(ind_neutralrho)%field(:,:,:) = Dens%neutralrho(:,:,:)
   endif

   ! compute some density related diagnostic factors
   ! initialize neutralrho_interval_r first
   neutralrho_interval  = (neutralrho_max-neutralrho_min)/(epsln+layer_nk)
   neutralrho_interval_r = 1.0/neutralrho_interval
   call compute_diagnostic_factors(Time, Thickness, Dens, salinity, temperature)

   ! compute potential density for diagnostic purposes 
   Dens%potrho(:,:,:) = Grd%tmask(:,:,:)*potential_density(salinity, temperature, potrho_press)

   ! compute various potential densities for diagnostic purposes 
   ind_potrho_0 = fm_get_index('/ocean_mod/diag_tracers/rho_pot_0')
   if (ind_potrho_0 .gt. 0) then
     T_diag(ind_potrho_0)%field(:,:,:) = Grd%tmask(:,:,:)*potential_density(salinity, temperature, 0.0)
   endif
   ind_potrho_1 = fm_get_index('/ocean_mod/diag_tracers/rho_pot_1')
   if (ind_potrho_1 .gt. 0) then
     T_diag(ind_potrho_1)%field(:,:,:) = Grd%tmask(:,:,:)*potential_density(salinity, temperature, 1000.0)
   endif
   ind_potrho_2 = fm_get_index('/ocean_mod/diag_tracers/rho_pot_2')
   if (ind_potrho_2 .gt. 0) then
     T_diag(ind_potrho_2)%field(:,:,:) = Grd%tmask(:,:,:)*potential_density(salinity, temperature, 2000.0)
   endif
   ind_potrho_3 = fm_get_index('/ocean_mod/diag_tracers/rho_pot_3')
   if (ind_potrho_3 .gt. 0) then
     T_diag(ind_potrho_3)%field(:,:,:) = Grd%tmask(:,:,:)*potential_density(salinity, temperature, 3000.0)
   endif
   ind_potrho_4 = fm_get_index('/ocean_mod/diag_tracers/rho_pot_4')
   if (ind_potrho_4 .gt. 0) then
     T_diag(ind_potrho_4)%field(:,:,:) = Grd%tmask(:,:,:)*potential_density(salinity, temperature, 4000.0)
   endif

   if(rho0_density) then 
       Dens%rho(:,:,:,taum1) = Grd%tmask(:,:,:)*rho0
       Dens%rho(:,:,:,tau)   = Grd%tmask(:,:,:)*rho0
       Dens%rho(:,:,:,taup1) = Grd%tmask(:,:,:)*rho0
   endif
   ind_rho = fm_get_index('/ocean_mod/diag_tracers/rho_in_situ')
   if (ind_rho .gt. 0) then
     T_diag(ind_rho)%field(:,:,:) = Dens%rho(:,:,:,tau)
   endif

   ! compute initial level mass, volume, and density 
   allocate(rho_average(0:nk))
   allocate(mass_level(0:nk))
   allocate(volume_level(0:nk))
   rho_average(:)  = 0.0
   mass_level(:)   = 0.0
   volume_level(:) = 0.0
   wrk1_2d(:,:)    = 0.0
   wrk2_2d(:,:)    = 0.0
   wrk3_2d(:,:)    = 0.0
   do k=1,nk
      wrk1_2d(:,:)    = Grd%dat(:,:)*Grd%tmask(:,:,k)  
      wrk2_2d(:,:)    = wrk1_2d(:,:)*Thickness%dzt(:,:,k)
      wrk3_2d(:,:)    = wrk1_2d(:,:)*Thickness%dzt(:,:,k)*Dens%rho(:,:,k,tau)
      volume_level(k) = mpp_global_sum(Dom%domain2d,wrk2_2d(:,:),global_sum_flag)
      mass_level(k)   = mpp_global_sum(Dom%domain2d,wrk3_2d(:,:),global_sum_flag)
      if (global_sum_flag == NON_BITWISE_EXACT_SUM) then
        volume_level(k) = real(volume_level(k),kind=FLOAT_KIND)
        mass_level(k)   = real(mass_level(k),kind=FLOAT_KIND)
      endif
      if(volume_level(k) > 0.0) rho_average(k) = mass_level(k)/volume_level(k)
   enddo
   do k=1,nk
      volume_level(0) = volume_level(0) + volume_level(k)
      mass_level(0)   = mass_level(0)   + mass_level(k)
   enddo
   if(volume_level(0) > 0.0) rho_average(0) = mass_level(0)/volume_level(0)

   write(stdoutunit,'(/a,e24.12)') &
   ' ==>Note: From ocean_density_mod: Boussinesq reference density rho0(kg/m3) = ',rho0
   write(stdoutunit,'(a,e24.12)')  &
   '          Initial rho_average(kg/m3) = ',rho_average(0)
   if(rho_average(0) /= rho0 .and. Time%init) then 
     write(stdoutunit,'(a)')  &
     '          Since rho0 .ne. rho_average, consider changing rho0 in' 
     write(stdoutunit,'(a/)') &
     '          ocean_parameters.F90 to be equal to rho_average for better accuracy.'
   endif 
 
   id_rho_average = register_static_field('ocean_model','rho_average', Grid%tracer_axes(3:3), &
                   'level average density at initial step of segment','kg/m^3',               &
                   missing_value=missing_value, range=(/-1e0,1e10/))
   id_mass_level  = register_static_field('ocean_model','mass_level', Grid%tracer_axes(3:3), &
                   'mass of levels at initial step of segment','kg',                         &
                   missing_value=missing_value, range=(/-1e0,1e10/))
   id_volume_level= register_static_field('ocean_model','volume_level', Grid%tracer_axes(3:3), &
                   'volume of levels at initial step of segment','m^3',                        &
                   missing_value=missing_value, range=(/-1e0,1e10/))

   if (id_rho_average > 0) then 
      used = send_data(id_rho_average, rho_average(1:nk), Time%model_time)
   endif 
   if (id_mass_level > 0) then 
      used = send_data(id_mass_level, mass_level(1:nk), Time%model_time)
   endif 
   if (id_volume_level > 0) then 
      used = send_data(id_volume_level, volume_level(1:nk), Time%model_time)
   endif 

  ! define vertical axes according to potential density classes  
  allocate ( Dens%potrho_ref(layer_nk))
  allocate ( Dens%potrho_bounds(layer_nk+1))
  allocate ( potrho_bounds(layer_nk+1))
  potrho_bounds(1) = potrho_min
  potrho_interval  = (potrho_max-potrho_min)/(epsln+layer_nk)
  do k=2,layer_nk+1
    potrho_bounds(k)=potrho_bounds(k-1)+potrho_interval
  enddo 
  do k=1,layer_nk
    Dens%potrho_ref(k)=potrho_bounds(k)+0.5*potrho_interval
  enddo 
  do k=1,layer_nk+1
    Dens%potrho_bounds(k) = potrho_bounds(k)
  enddo 

  ! define vertical axes according to neutral density classes  
  allocate ( Dens%neutralrho_ref(layer_nk))
  allocate ( Dens%neutralrho_bounds(layer_nk+1))
  allocate ( neutralrho_bounds(layer_nk+1))
  neutralrho_bounds(1) = neutralrho_min
  do k=2,layer_nk+1
    neutralrho_bounds(k)=neutralrho_bounds(k-1)+neutralrho_interval
  enddo 
  do k=1,layer_nk
    Dens%neutralrho_ref(k)=neutralrho_bounds(k)+0.5*neutralrho_interval
  enddo 
  do k=1,layer_nk+1
    Dens%neutralrho_bounds(k) = neutralrho_bounds(k)
  enddo 

  ! define vertical axes according to 
  ! potential temperature or conservative temperature classes
  allocate ( Dens%theta_ref(layer_nk))
  allocate ( Dens%theta_bounds(layer_nk+1))
  allocate ( theta_bounds(layer_nk+1))
  theta_bounds(1)  = theta_min
  theta_interval   = (theta_max-theta_min)/(epsln+layer_nk)
  do k=2,layer_nk+1
    theta_bounds(k) =theta_bounds(k-1) +theta_interval
  enddo 
  do k=1,layer_nk
    Dens%theta_ref(k) =theta_bounds(k) +0.5*theta_interval
  enddo 
  do k=1,layer_nk+1
    Dens%theta_bounds(k) = theta_bounds(k)
  enddo 

  ! assuming that if the Grd%name = 'ocean' then we will
  ! be using this diagnostic axis. Otherwise it is not used.
  ! This is done to prevent duplicate axis names for multiple
  ! grid objects.
  if (trim(Grd%name) == 'ocean') then

    id_grid_xt = diag_axis_init ('grid_xt_'//trim(Grd%name),Grd%grid_x_t,'degrees_E','x', &
                                   'tcell longitude',set_name='ocean', Domain2=Dom%domain2d)

    id_grid_yt = diag_axis_init ('grid_yt_'//trim(Grd%name),Grd%grid_y_t,'degrees_N','y', &
                                   'tcell latitude',set_name='ocean', Domain2=Dom%domain2d)

    id_grid_xu = diag_axis_init ('grid_xu_'//trim(Grd%name),Grd%grid_x_u,'degrees_E','x', &
                                   'ucell longitude',set_name='ocean', Domain2=Dom%domain2d)

    id_grid_yu = diag_axis_init ('grid_yu_'//trim(Grd%name),Grd%grid_y_u,'degrees_N','y', &
                                   'ucell latitude',set_name='ocean', Domain2=Dom%domain2d)


    id_potrho_bounds = diag_axis_init                                        &
     ( 'potrho_edges',potrho_bounds, 'kg/m^3', 'z','potential density edges',&
       direction=-1, set_name='ocean')

    id_potrho_axis   = diag_axis_init                           &
     ( 'potrho',Dens%potrho_ref,                                &
       'kg/m^3', 'z','potential density',edges=id_potrho_bounds,&
        direction=-1,set_name='ocean')

    Dens%potrho_axes        = (/ id_grid_xt, id_grid_yt, id_potrho_axis /)
    Dens%potrho_axes_flux_x = (/ id_grid_xu, id_grid_yt, id_potrho_axis /)
    Dens%potrho_axes_flux_y = (/ id_grid_xt, id_grid_yu, id_potrho_axis /)


    id_neutralrho_bounds = diag_axis_init                                          &
     ( 'neutralrho_edges',neutralrho_bounds, 'kg/m^3', 'z','neutral density edges',&
       direction=-1, set_name='ocean')

    id_neutralrho_axis   = diag_axis_init                         &
     ( 'neutral',Dens%neutralrho_ref,                             &
       'kg/m^3', 'z','neutral density',edges=id_neutralrho_bounds,&
        direction=-1,set_name='ocean')

    Dens%neutralrho_axes        = (/ id_grid_xt, id_grid_yt, id_neutralrho_axis /)
    Dens%neutralrho_axes_flux_x = (/ id_grid_xu, id_grid_yt, id_neutralrho_axis /)
    Dens%neutralrho_axes_flux_y = (/ id_grid_xt, id_grid_yu, id_neutralrho_axis /)


    id_theta_bounds = diag_axis_init                                                       &
     ( 'theta_edges',potrho_bounds, 'C', 'z','potential or conservative temperature edges',&
       direction=1, set_name='ocean')

    id_theta_axis   = diag_axis_init                                            &
     ( 'theta',Dens%theta_ref, 'C', 'z','potential or conservative temperature',&
       edges=id_theta_bounds, direction=1,set_name='ocean')

    Dens%theta_axes        = (/ id_grid_xt,  id_grid_yt,  id_theta_axis  /)
    Dens%theta_axes_flux_x = (/ id_grid_xu,  id_grid_yt,  id_theta_axis  /)
    Dens%theta_axes_flux_y = (/ id_grid_xt,  id_grid_yu,  id_theta_axis  /)

  endif

  ! register the diagnostic fields 
  call density_diagnostics_init(Time)

  write(stdoutunit,'(/a)') ' From ocean_density_mod: density chksums from ocean_density_init'
  call write_timestamp(Time%model_time)
  call ocean_density_chksum(Time, Dens, use_blobs)

  ! clean up pointers used in this subroutine 
  nullify(salinity)
  nullify(temperature)

  end subroutine ocean_density_init
! </SUBROUTINE> NAME="ocean_density_init"


!#######################################################################
! <SUBROUTINE NAME="density_diagnostics_init">
!
! <DESCRIPTION>
! Register the diagnostic fields. 
! </DESCRIPTION>
!
  subroutine density_diagnostics_init(Time)

  type(ocean_time_type),  intent(in) :: Time

  id_press = register_diag_field ('ocean_model', 'press', Grd%tracer_axes(1:3),&
             Time%model_time, 'absolute pressure', 'dbar',                     &
             missing_value=missing_value, range=(/-10.,1e6/))

  id_rho = register_diag_field ('ocean_model', 'rho', Grd%tracer_axes(1:3), &
           Time%model_time, 'in situ density', 'kg/m^3',                    &
           missing_value=missing_value, range=(/-10.0,1e5/))

  id_rhoE = register_diag_field ('ocean_model', 'rhoE', Grd%tracer_axes(1:3), &
            Time%model_time, 'E system in situ density', 'kg/m^3',            &
            missing_value=missing_value, range=(/-10.0,1e5/))

  id_pot_rho = register_diag_field ('ocean_model', 'pot_rho', Grd%tracer_axes(1:3), &
               Time%model_time, 'potential density', 'kg/m^3',                      &
               missing_value=missing_value, range=(/-10.0,1e5/))    

  id_int_rhodz = register_diag_field ('ocean_model', 'int_rhodz', Grd%tracer_axes(1:2), &
               Time%model_time, 'vertical integral of density', 'm*(kg/m^3)',           &
               missing_value=missing_value, range=(/-10.0,1e5/))    

  if(neutral_density_omega) then   
      id_neutral_rho = register_diag_field ('ocean_model', 'neutral_rho', Grd%tracer_axes(1:3), &
                       Time%model_time, 'polynomial estimate of neutral density', 'kg/m^3',     &
                       missing_value=missing_value, range=(/-10.0,1e5/))    
  elseif(neutral_density_potrho) then 
      id_neutral_rho = register_diag_field ('ocean_model', 'neutral_rho', Grd%tracer_axes(1:3),   &
                       Time%model_time, 'potential density estimate of neutral density', 'kg/m^3',&
                       missing_value=missing_value, range=(/-10.0,1e5/))    
  elseif(neutral_density_theta) then 
      id_neutral_rho = register_diag_field ('ocean_model', 'neutral_rho', Grd%tracer_axes(1:3),   &
                       Time%model_time, 'conservative temperature is neutral density', 'degC',&
                       missing_value=missing_value, range=(/-10.0,1e5/))    
  endif 

  id_eos_salinity = register_diag_field ('ocean_model', 'eos_salinity', Grd%tracer_axes(1:3),&
           Time%model_time, 'absolute salinity as used for TEOS10 equation of state', 'g/kg',&
           missing_value=missing_value, range=(/0.0,100.0/))

  id_pot_rho_0 = register_diag_field ('ocean_model', 'pot_rho_0', Grd%tracer_axes(1:3), &
                 Time%model_time, 'potential density referenced to 0 dbar', 'kg/m^3',   &
                 missing_value=missing_value, range=(/-10.0,1e5/),                      &
                 standard_name='sea_water_potential_density')    
  id_pot_rho_1 = register_diag_field ('ocean_model', 'pot_rho_1', Grd%tracer_axes(1:3), &
                 Time%model_time, 'potential density referenced to 1000 dbar', 'kg/m^3',&
                 missing_value=missing_value, range=(/-10.0,1e5/))    
  id_pot_rho_2 = register_diag_field ('ocean_model', 'pot_rho_2', Grd%tracer_axes(1:3), &
                 Time%model_time, 'potential density referenced to 2000 dbar', 'kg/m^3',&
                 missing_value=missing_value, range=(/-10.0,1e5/))    
  id_pot_rho_3 = register_diag_field ('ocean_model', 'pot_rho_3', Grd%tracer_axes(1:3), &
                 Time%model_time, 'potential density referenced to 3000 dbar', 'kg/m^3',&
                 missing_value=missing_value, range=(/-10.0,1e5/))    
  id_pot_rho_4 = register_diag_field ('ocean_model', 'pot_rho_4', Grd%tracer_axes(1:3), &
                 Time%model_time, 'potential density referenced to 4000 dbar', 'kg/m^3',&
                 missing_value=missing_value, range=(/-10.0,1e5/))    
  id_pot_rho_et = register_diag_field ('ocean_model', 'pot_rho_et', Grd%tracer_axes_flux_x(1:3), &
                  Time%model_time, 'potential density at east face of tracer cell', 'kg/m^3',    &
                  missing_value=missing_value, range=(/-10.0,1e5/))    
  id_pot_rho_nt = register_diag_field ('ocean_model', 'pot_rho_nt', Grd%tracer_axes_flux_y(1:3), &
                  Time%model_time, 'potential density at north face of tracer cell', 'kg/m^3',   &
                  missing_value=missing_value, range=(/-10.0,1e5/))    
  id_pot_rho_wt = register_diag_field ('ocean_model', 'pot_rho_wt', Grd%tracer_axes_wt(1:3), &
                  Time%model_time, 'potential density at wt points', 'kg/m^3',               &
                  missing_value=missing_value, range=(/-10.0,1e5/))    
  id_thermal_expand = register_diag_field ('ocean_model', 'thermal_expand', Grd%tracer_axes(1:3), &
                  Time%model_time, 'thermal expansion coefficient -(1/rho)d(rho)/d(theta)', '1/C',&
                  missing_value=-1e10, range=(/-1e10,1e10/))
  id_haline_contract= register_diag_field ('ocean_model', 'haline_contract', Grd%tracer_axes(1:3),        & 
                  Time%model_time, 'haline contraction coefficient (1/rho)d(rho)/d(salinity)', '1/(g/kg)',&
                  missing_value=-1e10, range=(/-1e10,1e10/))
  id_drhodtheta = register_diag_field ('ocean_model', 'drhodtheta', Grd%tracer_axes(1:3), &
                  Time%model_time, 'd(rho)/d(theta)', 'kg/m^3/C',                         &
                  missing_value=-1e10, range=(/-1e10,1e10/))
  id_drhodsalt   = register_diag_field ('ocean_model', 'drhodsalinity', Grd%tracer_axes(1:3), &
                   Time%model_time, 'd(rho)/d(salinity)', 'kg/m^3/psu',                       &
                   missing_value=missing_value, range=(/-1e9,1e9/))
  id_dpotrhodtheta = register_diag_field ('ocean_model', 'dpotrhodtheta', Grd%tracer_axes(1:3), &
                  Time%model_time, 'd(potrho)/d(theta)', 'kg/m^3/C',                            &
                  missing_value=-1e10, range=(/-1e10,1e10/))
  id_dpotrhodsalt   = register_diag_field ('ocean_model', 'dpotrhodsalt', Grd%tracer_axes(1:3), & 
                   Time%model_time, 'd(potrho)/d(salinity)', 'kg/m^3/psu',                      &
                   missing_value=missing_value, range=(/-1e9,1e9/))
  id_dpotrhodpress  = register_diag_field ('ocean_model', 'dpotrhodpress', Grd%tracer_axes(1:3), &
                   Time%model_time, 'd(potrho)/d(press)', 'kg/m^3/psu',                          &
                   missing_value=missing_value, range=(/-1e9,1e9/))
  id_drhodpress  = register_diag_field ('ocean_model', 'drhodpress', Grd%tracer_axes(1:3), &
                   Time%model_time, 'd(rho)/d(press)', '(kg/m^3)/dbar',                    &
                   missing_value=missing_value, range=(/-1e9,1e9/))
  id_sound_speed2 = register_diag_field ('ocean_model', 'sound_speed2', Grd%tracer_axes(1:3),&
                   Time%model_time, 'squared sound speed = 1/[d(rho)/d(press)]', '(m/s)^2',  &
                   missing_value=missing_value, range=(/-1e9,1e9/))
  id_cabbeling   = register_diag_field ('ocean_model', 'cabbeling', Grd%tracer_axes(1:3), &
                  Time%model_time, 'cabbeling parameter', '(1/degC)^2',                   &
                  missing_value=-1e10, range=(/-1e10,1e10/))
  id_thermobaricity = register_diag_field ('ocean_model', 'thermobaricity', Grd%tracer_axes(1:3), &
                  Time%model_time, 'thermobaricity parameter', '1/(dbar*degC)',                   &
                  missing_value=-1e10, range=(/-1e10,1e10/))

  id_buoyfreq2_zt = register_diag_field ('ocean_model','buoyfreq2_zt',  &
                    Grd%tracer_axes(1:3), Time%model_time,              &
                    'Squared buoyancy frequency at T-point', '1/s^2',   &
                    missing_value=missing_value, range=(/-1e6,1e6/))
  id_buoyfreq2_wt = register_diag_field ('ocean_model','buoyfreq2_wt',      &
                    Grd%tracer_axes_wt(1:3), Time%model_time,               &
                    'Squared buoyancy frequency at T-cell bottom', '1/s^2', &
                    missing_value=missing_value, range=(/-1e6,1e6/))
  id_drhodz_zt = register_diag_field ('ocean_model','drhodz_zt',&
                    Grd%tracer_axes(1:3), Time%model_time,      &
                    'd(neutral rho)/dz at T-point', 'kg/m^4',   &
                    missing_value=missing_value, range=(/-1e6,1e6/))
  id_drhodx_zt = register_diag_field ('ocean_model','drhodx_zt',     &
                    Grd%tracer_axes(1:3), Time%model_time,           &
                    'd(neutral rho)/dx at nominal T-point', 'kg/m^4',&
                    missing_value=missing_value, range=(/-1e6,1e6/))
  id_drhody_zt = register_diag_field ('ocean_model','drhody_zt',     &
                    Grd%tracer_axes(1:3), Time%model_time,           &
                    'd(neutral rho)/dy at nominal T-point', 'kg/m^4',&
                    missing_value=missing_value, range=(/-1e6,1e6/))
  id_drhodz_diag = register_diag_field ('ocean_model','drhodz_diag',     &
                    Grd%tracer_axes(1:3), Time%model_time,               &
                    'regularized d(neutral rho)/dz at T-point', 'kg/m^4',&
                    missing_value=missing_value, range=(/-1e6,1e6/))
  id_drhodz_wt = register_diag_field ('ocean_model','drhodz_wt',  &
                    Grd%tracer_axes_wt(1:3), Time%model_time,     &
                    'd(neutral rho)/dz at W-point', 'kg/m^4',     &
                    missing_value=missing_value, range=(/-1e6,1e6/))

  id_rhoave    = register_diag_field('ocean_model','rhoave', Time%model_time, &
                   'global mean ocean in-situ density from ocean_density_mod',&
                   'kg/m^3', missing_value=missing_value, range=(/-1e10,1e10/))
  id_pbot_adjust = register_diag_field('ocean_model','pbot_adjust',Time%model_time,         &
                   'pbot adjustment to counteract spurious mass source in Boussinesq fluid',&
                   'dbar', missing_value=missing_value, range=(/-1e10,1e10/))
  id_eta_adjust = register_diag_field('ocean_model','eta_adjust',Time%model_time,       &
                   'global eta adjustment to include steric effect in Boussinesq fluid',&
                   'm', missing_value=missing_value, range=(/-100.0,100.0/))
  id_eta_adjust_approx = register_diag_field('ocean_model','eta_adjust_approx',Time%model_time,     &
                   'approximate global eta adjustment to include steric effect in Boussinesq fluid',&
                   'm', missing_value=missing_value, range=(/-100.0,100.0/))
  id_eta_adjust_cstvolume = register_diag_field('ocean_model','eta_adjust_cstvolume',Time%model_time,              &
                   'global eta adjustment (assuming constant volume) to include steric effect in Boussinesq fluid',&
                   'm', missing_value=missing_value, range=(/-100.0,100.0/))

  id_grad_nrho     = register_diag_field ('ocean_model','grad_nrho', &
                    Grd%tracer_axes(1:3), Time%model_time,           &
                    '|grad neutral rho|', 'dimensionless',           &
                    missing_value=missing_value, range=(/-1e1,1e10/))
  id_grad_lrpotrho = register_diag_field ('ocean_model','grad_lrpotrho', &
                    Grd%tracer_axes(1:3), Time%model_time,               &
                    '|grad local ref potential rho|', 'dimensionless',   &
                    missing_value=missing_value, range=(/-1e1,1e10/))
  id_grad_nrho_lrpotrho = register_diag_field ('ocean_model','grad_nrho_lrpotrho',         &
                    Grd%tracer_axes(1:3), Time%model_time,                                 &
                    '|grad neutral rho| / |grad local ref potential rho|', 'dimensionless',&
                    missing_value=missing_value, range=(/-1e1,1e10/))
  id_watermass_factor = register_diag_field ('ocean_model','watermass_factor',                       &
                    Grd%tracer_axes(1:3), Time%model_time,                                           &
                    '(|grad neutral rho|/|grad local ref potential rho|)/(delta(gamma))', '(m^3/kg)',&
                    missing_value=missing_value, range=(/-1e1,1e15/))
  id_stratification_factor = register_diag_field ('ocean_model','stratification_factor',         &
                    Grd%tracer_axes(1:3), Time%model_time, 'abs ( rho*Area(h)/gamma_h )', 'm^3', &
                    missing_value=missing_value, range=(/-1e1,1e22/))
  id_stratification_axis = register_diag_field ('ocean_model','stratification_axis',Grd%tracer_axes(1:3), &
                    Time%model_time, 'direction of strongest stratification', 'dimensionless',            &
                    missing_value=missing_value, range=(/-1e2,1e2/))
  id_smax_dianeutral = register_diag_field ('ocean_model','smax_dianeutral',Grd%tracer_axes(1:3),      &
                    Time%model_time, 'slope factor used for computing dianeutral transport diagnostic',&
                    'dimensionless', missing_value=missing_value, range=(/-1e2,1e2/))


  return 
  end subroutine density_diagnostics_init
! </SUBROUTINE> NAME="density_diagnostics_init"


!#######################################################################
! <SUBROUTINE NAME="density_coeffs_init">
!
! <DESCRIPTION>
! Initialize the EOS coefficients, and write some test values.  
! </DESCRIPTION>
!
  subroutine density_coeffs_init()

    integer :: stdoutunit
    real    :: rho_neutralrho
    real    :: neutralrho_test, rho_test, alpha_test, beta_test, speed2_test
    real    :: drho_dtheta_test, drho_dsal_test, drho_dpress_test
    real    :: diff_test

    stdoutunit=stdout()

    ! for the TESO10 EOS 
    mbfj_rho   = 1.017775176234136d+3
    mbfj_alpha = 2.435473441547041d-4
    mbfj_beta  = 7.284367916939847d-4
    mb_neutralrho=1033.093610463980

    v01 =  9.998420897506056d+2
    v02 =  2.839940833161907
    v03 = -3.147759265588511d-2
    v04 =  1.181805545074306d-3
    v05 = -6.698001071123802
    v06 = -2.986498947203215d-2
    v07 =  2.327859407479162d-4
    v08 = -3.988822378968490d-2
    v09 =  5.095422573880500d-4
    v10 = -1.426984671633621d-5
    v11 =  1.645039373682922d-7
    v12 = -2.233269627352527d-2
    v13 = -3.436090079851880d-4
    v14 =  3.726050720345733d-6
    v15 = -1.806789763745328d-4
    v16 =  6.876837219536232d-7
    v17 = -3.087032500374211d-7
    v18 = -1.988366587925593d-8
    v19 = -1.061519070296458d-11
    v20 =  1.550932729220080d-10
    v21 =  1.0
    v22 =  2.775927747785646d-3
    v23 = -2.349607444135925d-5
    v24 =  1.119513357486743d-6
    v25 =  6.743689325042773d-10
    v26 = -7.521448093615448d-3
    v27 = -2.764306979894411d-5
    v28 =  1.262937315098546d-7
    v29 =  9.527875081696435d-10
    v30 = -1.811147201949891d-11
    v31 = -3.303308871386421d-5
    v32 =  3.801564588876298d-7
    v33 = -7.672876869259043d-9
    v34 = -4.634182341116144d-11
    v35 =  2.681097235569143d-12
    v36 =  5.419326551148740d-6
    v37 = -2.742185394906099d-5
    v38 = -3.212746477974189d-7
    v39 =  3.191413910561627d-9
    v40 = -1.931012931541776d-12
    v41 = -1.105097577149576d-7
    v42 =  6.211426728363857d-10
    v43 = -1.119011592875110d-10
    v44 = -1.941660213148725d-11
    v45 = -1.864826425365600d-14
    v46 =  1.119522344879478d-14
    v47 = -1.200507748551599d-15
    v48 =  6.057902487546866d-17

    ! Save some multiples
    two_v03 = 2.0*v03
    two_v07 = 2.0*v07
    two_v10 = 2.0*v10
    two_v14 = 2.0*v14
    two_v17 = 2.0*v17
    two_v18 = 2.0*v18
    two_v19 = 2.0*v19
    two_v20 = 2.0*v20
    two_v23 = 2.0*v23
    two_v28 = 2.0*v28
    two_v33 = 2.0*v33
    two_v36 = 2.0*v36
    two_v39 = 2.0*v39
    two_v43 = 2.0*v43
    two_v44 = 2.0*v44
    two_v45 = 2.0*v45
    two_v46 = 2.0*v46

    three_v04 = 3.0*v04
    three_v11 = 3.0*v11
    three_v24 = 3.0*v24
    three_v29 = 3.0*v29
    three_v34 = 3.0*v34
    three_v40 = 3.0*v40
    three_v47 = 3.0*v47
    three_v48 = 3.0*v48

    four_v25 = 4.0*v25
    four_v30 = 4.0*v30
    four_v35 = 4.0*v35

    onep5_v08 = 1.5*v08
    onep5_v09 = 1.5*v09
    onep5_v10 = 1.5*v10
    onep5_v11 = 1.5*v11
    onep5_v10 = 1.5*v10
    onep5_v31 = 1.5*v31
    onep5_v32 = 1.5*v32
    onep5_v33 = 1.5*v33
    onep5_v34 = 1.5*v34
    onep5_v35 = 1.5*v35

    ! Double derivs
    six_v04 = 6.0*v04
    six_v11 = 6.0*v11
    six_v24 = 6.0*v24
    six_v29 = 6.0*v29
    six_v34 = 6.0*v34
    six_v40 = 6.0*v40
    six_v47 = 6.0*v47
    six_v48 = 6.0*v48

    twelve_v25 = 12.0*v25
    twelve_v30 = 12.0*v30
    twelve_v35 = 12.0*v35

    p75_v08 = 0.75*v08
    p75_v09 = 0.75*v09
    p75_v10 = 0.75*v10
    p75_v11 = 0.75*v11
    p75_v10 = 0.75*v10
    p75_v31 = 0.75*v31
    p75_v32 = 0.75*v32
    p75_v33 = 0.75*v33
    p75_v34 = 0.75*v34
    p75_v35 = 0.75*v35

    ! Cross derivs
    three_v10 = 3.0*v10
    three_v33 = 3.0*v33

    fourp5_v11 = 4.5*v11
    fourp5_v34 = 4.5*v34

    four_v19 = 4.0*v19
    four_v45 = 4.0*v45

    six_v35 = 6.0*v35


    ! 25 coefficients in the preTEOS10 equation of state 
    if(temp_variable==CONSERVATIVE_TEMP) then

        jmfwg_rho   = 1017.842890411975d0
        jmfwg_alpha = 2.436057013634649d-4
        jmfwg_beta  = 7.314818108935248d-4

        a0  =  9.9983912878771446d+02
        a1  =  7.0687133522652896d+00
        a2  = -2.2746841916232965d-02
        a3  =  5.6569114861400121d-04
        a4  =  2.3849975952593345d+00
        a5  =  3.1761924314867009d-04
        a6  =  1.7459053010547962d-03
        a7  =  1.2192536310173776d-02
        a8  =  2.4643435731663949d-07
        a9  =  4.0525405332794888d-06
        a10 = -2.3890831309113187d-08
        a11 = -5.9016182471196891d-12

        b0  =  1.0000000000000000d+00 
        b1  =  7.0051665739672298d-03
        b2  = -1.5040804107377016d-05 
        b3  =  5.3943915288426715d-07
        b4  =  3.3811600427083414d-10
        b5  =  1.5599507046153769d-03
        b6  = -1.8137352466500517d-06
        b7  = -3.3580158763335367d-10
        b8  =  5.7149997597561099d-06
        b9  =  7.8025873978107375d-10
        b10 =  7.1038052872522844d-06
        b11 = -2.1692301739460094d-17
        b12 = -8.2564080016458560d-18

        ! Coefficients for neutral density based on McDougall/Jackett (2005).
        ! To be replaced by Klocker/McDougall approach in near future. 
        rho_neutralrho=1024.43863927763d0
        
        a0n =  1.0022048243661291d+003
        a1n =  2.0634684367767725d-001
        a2n =  8.0483030880783291d-002
        a3n = -3.6670094757260206d-004
        a4n = -1.4602011474139313d-003
        a5n = -2.5860953752447594d-003
        a6n = -3.0498135030851449d-007

        b0n =  1.0000000000000000d+000 
        b1n =  4.4946117492521496d-005
        b2n =  7.9275128750339643d-005
        b3n = -1.2358702241599250d-007
        b4n = -4.1775515358142458d-009
        b5n = -4.3024523119324234d-004
        b6n =  6.3377762448794933d-006
        b7n = -7.2640466666916413d-010
        b8n = -5.1075068249838284d-005
        b9n = -5.8104725917890170d-009


    elseif(temp_variable==POTENTIAL_TEMP) then 
    
        jmfwg_rho   =  1017.728868019642d0
        jmfwg_alpha = 2.525481286927133d-4
        jmfwg_beta  = 7.379638527217575d-4

        a0  =  9.9984085444849347d+02
        a1  =  7.3471625860981584d+00
        a2  = -5.3211231792841769d-02
        a3  =  3.6492439109814549d-04
        a4  =  2.5880571023991390d+00
        a5  = -6.7168282786692355d-03
        a6  =  1.9203202055760151d-03
        a7  =  1.1798263740430364d-02
        a8  =  9.8920219266399117d-08
        a9  =  4.6996642771754730d-06
        a10 = -2.5862187075154352d-08
        a11 = -3.2921414007960662d-12

        b0  =  1.0000000000000000d+00 
        b1  =  7.2815210113327091d-03
        b2  = -4.4787265461983921d-05 
        b3  =  3.3851002965802430d-07
        b4  =  1.3651202389758572d-10
        b5  =  1.7632126669040377d-03
        b6  = -8.8066583251206474d-06
        b7  = -1.8832689434804897d-10
        b8  =  5.7463776745432097d-06
        b9  =  1.4716275472242334d-09
        b10 =  6.7103246285651894d-06
        b11 = -2.4461698007024582d-17
        b12 = -9.1534417604289062d-18

        ! Coefficients for neutral density based on McDougall/Jackett (2005).
        ! To be replaced by Klocker/McDougall approach in near future. 
        rho_neutralrho=1024.59416751197d0

        a0n =  1.0023063688892480d+003
        a1n =  2.2280832068441331d-001
        a2n =  8.1157118782170051d-002
        a3n = -4.3159255086706703d-004
        a4n = -1.0304537539692924d-004
        a5n = -3.1710675488863952d-003
        a6n = -1.7052298331414675d-007

        b0n =  1.0000000000000000d+000 
        b1n =  4.3907692647825900d-005
        b2n =  7.8717799560577725d-005
        b3n = -1.6212552470310961d-007
        b4n = -2.3850178558212048d-009
        b5n = -5.1268124398160734d-004
        b6n =  6.0399864718597388d-006
        b7n = -2.2744455733317707d-009
        b8n = -3.6138532339703262d-005
        b9n = -1.3409379420216683d-009
       
    endif 

    ! save some multiples of the coefficients 
    two_a2   = 2.0*a2
    three_a3 = 3.0*a3
    six_a3   = 6.0*a3
    two_a6   = 2.0*a6
    two_a8   = 2.0*a8
    two_a10  = 2.0*a10
    two_a11  = 2.0*a11
    four_a11 = 4.0*a11

    two_b2    = 2.0*b2
    three_b3  = 3.0*b3
    six_b3    = 6.0*b3
    four_b4   = 4.0*b4
    twelve_b4 = 12.0*b4
    three_b7  = 3.0*b7
    six_b7    = 6.0*b7
    onep5_b8  = 1.5*b8
    onep5_b9  = 1.5*b9
    two_b9    = 2.0*b9
    three_b9  = 3.0*b9
    two_b11   = 2.0*b11
    three_b11 = 3.0*b11
    six_b11   = 6.0*b11
    three_b12 = 3.0*b12


   ! Test values for preTEOS10 EOS 
   if(eos_preteos10) then 

      write (stdoutunit,'(/,a)') 'preTEOS10 EQUATION OF STATE TEST VALUES'

      write (stdoutunit,'(a,f6.2,a,f6.2,a,f8.2)') &
      's_test(psu) = ',s_test,', t_test(C) = ',t_test,', p_test(dbar) = ',p_test  

      rho_test = density(s_test,t_test,p_test) 
      write (stdoutunit,' (a,f6.2,a,f6.2,a,f8.2,a,e22.16,a)') &
      'rho  (',s_test,',',t_test,',',p_test,') = ',rho_test,' kg/m^3'

      diff_test = rho_test-jmfwg_rho
      write (stdoutunit,' (a,e22.16,a)') 'diff from JMFWG = ',diff_test,' kg/m^3'

      call density_derivs(rho_test, s_test, t_test, p_test, &
                          drho_dtheta_test, drho_dsal_test, drho_dpress_test)

      alpha_test = -drho_dtheta_test/(epsln+rho_test)
      write (stdoutunit,' (a,f6.2,a,f6.2,a,f8.2,a,e22.16,a)') &
      'alpha(',s_test,',',t_test,',',p_test,') = ',alpha_test,' 1/C'

      diff_test = alpha_test-jmfwg_alpha
      write (stdoutunit,' (a,e22.16,a)') 'diff from JMFWG = ',diff_test,' 1/C'

      beta_test  =  drho_dsal_test  /(epsln+rho_test)
      write (stdoutunit,' (a,f6.2,a,f6.2,a,f8.2,a,e22.16,a)') &
      'beta (',s_test,',',t_test,',',p_test,') = ',beta_test,' 1/psu'

      speed2_test  =  1.0/(epsln + drho_dpress_test)
      write (stdoutunit,' (a,f6.2,a,f6.2,a,f8.2,a,e22.16,a)') &
      'squared sound speed (',s_test,',',t_test,',',p_test,') = ',speed2_test,' (m/s)^2'

      diff_test = beta_test-jmfwg_beta
      write (stdoutunit,' (a,e22.16,a)') 'diff from JMFWG = ',diff_test,' 1/psu'

      write (stdoutunit,'(/,a)') 'NEUTRAL DENSITY EQUATION TEST VALUES'

      write (stdoutunit,'(a,f6.2,a,f6.2)') &
      'sn_test(psu) = ',sn_test,', tn_test(C) = ',tn_test

      neutralrho_test = neutral_density(sn_test,tn_test) 
      write (stdoutunit,' (a,f6.2,a,f6.2,a,e22.16,a)') &
      'rho  (',sn_test,',',tn_test,') = ',neutralrho_test,' kg/m^3'

      diff_test = neutralrho_test-rho_neutralrho
      write (stdoutunit,' (a,e22.16,a)') 'diff from Klocker and McDougall test = ',diff_test,' kg/m^3'

  endif 

  ! Test values for TEOS10 EOS 
  if (eos_teos10) then

      write (stdoutunit,'(/,a)') 'TEOS10 EQUATION OF STATE TEST VALUES'

      write (stdoutunit,'(a,f6.2,a,f6.2,a,f8.2)') &
      's_test(ppt) = ',s_test,', t_test(C) = ',t_test,', p_test(dbar) = ',p_test

      rho_test = density(s_test,t_test,p_test)
      write (stdoutunit,' (a,f6.2,a,f6.2,a,f8.2,a,e22.16,a)') &
      'rho  (',s_test,',',t_test,',',p_test,') = ',rho_test,' kg/m^3'

      diff_test = rho_test-mbfj_rho
      write (stdoutunit,' (a,e22.16,a)') 'diff from MBFJ = ',diff_test,' kg/m^3'

      call density_derivs(rho_test, s_test, t_test, p_test, &
                          drho_dtheta_test, drho_dsal_test, drho_dpress_test)

      alpha_test = -drho_dtheta_test/(epsln+rho_test)
      write (stdoutunit,' (a,f6.2,a,f6.2,a,f8.2,a,e22.16,a)') &
      'alpha(',s_test,',',t_test,',',p_test,') = ',alpha_test,' 1/C'

      diff_test = alpha_test-mbfj_alpha
      write (stdoutunit,' (a,e22.16,a)') 'diff from MBFJ = ',diff_test,' 1/C'

      beta_test  =  drho_dsal_test  /(epsln+rho_test)
      write (stdoutunit,' (a,f6.2,a,f6.2,a,f8.2,a,e22.16,a)') &
      'beta (',s_test,',',t_test,',',p_test,') = ',beta_test,' 1/ppt'

      diff_test = beta_test-mbfj_beta
      write (stdoutunit,' (a,e22.16,a)') 'diff from MBFJ = ',diff_test,' 1/ppt'

      speed2_test  =  1.0/(epsln + drho_dpress_test)
      write (stdoutunit,' (a,f6.2,a,f6.2,a,f8.2,a,e22.16,a)') &
      'squared sound speed (',s_test,',',t_test,',',p_test,') = ',speed2_test,' (m/s)^2'

      write (stdoutunit,'(/,a)') 'NEUTRAL DENSITY EQUATION TEST VALUES'

      write (stdoutunit,'(a,f6.2,a,f6.2)') &
      'sn_test(ppt) = ',sn_test,', tn_test(C) = ',tn_test

      neutralrho_test = neutral_density(sn_test,tn_test)
      write (stdoutunit,' (a,f6.2,a,f6.2,a,e22.16,a)') &
      'rho  (',sn_test,',',tn_test,') = ',neutralrho_test,' kg/m^3'

      diff_test = neutralrho_test-mb_neutralrho
      write (stdoutunit,' (a,e22.16,a)') 'diff from McDougall and Barker = ',diff_test,' kg/m^3'

  endif 


  return 
  end subroutine density_coeffs_init
! </SUBROUTINE> NAME="density_coeffs_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_density_diag">
!
! <DESCRIPTION>
! Diagnostic ocean density fields: neutral density and potential density.  
! Also send some diagnostics to diagnostic manager.  
! </DESCRIPTION>
!
  subroutine ocean_density_diag(Time, Temp, Thickness, Dens, T_diag)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_prog_tracer_type),   intent(in)    :: Temp
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_density_type),       intent(inout) :: Dens
  type(ocean_diag_tracer_type),   intent(inout) :: T_diag(:)
  
  integer :: tau

  tau   = Time%tau

  if (ind_rho .gt. 0) then
    T_diag(ind_rho)%field(:,:,:) = Dens%rho(:,:,:,tau)
  endif

  ! compute neutral density for diagnostic purposes 
  Dens%neutralrho(:,:,:) = Grd%tmask(:,:,:) &
   *neutral_density(Dens%rho_salinity(:,:,:,tau), Temp%field(:,:,:,tau))
  if (ind_neutralrho .gt. 0) then
    T_diag(ind_neutralrho)%field(:,:,:) = Dens%neutralrho(:,:,:)
  endif

  ! compute potential density for diagnostic purposes 
  Dens%potrho(:,:,:) = Grd%tmask(:,:,:) &
   *potential_density(Dens%rho_salinity(:,:,:,tau), Temp%field(:,:,:,tau), potrho_press)

  ! compute some diagnostic factors 
  call compute_diagnostic_factors(Time, Thickness, Dens,       &
                                  Dens%rho_salinity(:,:,:,tau),&
                                  Temp%field(:,:,:,tau))

  ! compute potential densities for diagnostic purposes 
  if (ind_potrho_0 .gt. 0) then
    T_diag(ind_potrho_0)%field(:,:,:) = Grd%tmask(:,:,:) *                &
         potential_density(Dens%rho_salinity(:,:,:,tau), Temp%field(:,:,:,tau), 0.0)
  endif
  if (ind_potrho_1 .gt. 0) then
    T_diag(ind_potrho_1)%field(:,:,:) = Grd%tmask(:,:,:) *                &
         potential_density(Dens%rho_salinity(:,:,:,tau), Temp%field(:,:,:,tau), 1000.0)
  endif
  if (ind_potrho_2 .gt. 0) then
    T_diag(ind_potrho_2)%field(:,:,:) = Grd%tmask(:,:,:) *                &
         potential_density(Dens%rho_salinity(:,:,:,tau), Temp%field(:,:,:,tau), 2000.0)
  endif
  if (ind_potrho_3 .gt. 0) then
    T_diag(ind_potrho_3)%field(:,:,:) = Grd%tmask(:,:,:) *                &
         potential_density(Dens%rho_salinity(:,:,:,tau), Temp%field(:,:,:,tau), 3000.0)
  endif
  if (ind_potrho_4 .gt. 0) then
    T_diag(ind_potrho_4)%field(:,:,:) = Grd%tmask(:,:,:) *                &
         potential_density(Dens%rho_salinity(:,:,:,tau), Temp%field(:,:,:,tau), 4000.0)
  endif

  call diagnose_3d(Time, Grd, id_neutral_rho, Dens%neutralrho(:,:,:))
  call diagnose_3d(Time, Grd, id_pot_rho, Dens%potrho(:,:,:))


  if (id_pot_rho_0 > 0) then 
    if (ind_potrho_0 .gt. 0) then
       call diagnose_3d(Time, Grd, id_pot_rho_0, T_diag(ind_potrho_0)%field(:,:,:))
    else
      wrk1(:,:,:) = potential_density(Dens%rho_salinity(:,:,:,tau), Temp%field(:,:,:,tau), 0.0)
      call diagnose_3d(Time, Grd, id_pot_rho_0, wrk1(:,:,:))
    endif
  endif

  if (id_pot_rho_1 > 0) then 
    if (ind_potrho_1 .gt. 0) then
       call diagnose_3d(Time, Grd, id_pot_rho_1, T_diag(ind_potrho_1)%field(:,:,:))
    else
      wrk1(:,:,:) = potential_density(Dens%rho_salinity(:,:,:,tau), Temp%field(:,:,:,tau), 1000.0)
      call diagnose_3d(Time, Grd, id_pot_rho_1, wrk1(:,:,:))
    endif
  endif

  if (id_pot_rho_2 > 0) then 
    if (ind_potrho_2 .gt. 0) then
       call diagnose_3d(Time, Grd, id_pot_rho_2, T_diag(ind_potrho_2)%field(:,:,:))
    else
      wrk1(:,:,:) = potential_density(Dens%rho_salinity(:,:,:,tau), Temp%field(:,:,:,tau), 2000.0)
      call diagnose_3d(Time, Grd, id_pot_rho_2, wrk1(:,:,:))
    endif
  endif

  if (id_pot_rho_3 > 0) then 
    if (ind_potrho_3 .gt. 0) then
       call diagnose_3d(Time, Grd, id_pot_rho_3, T_diag(ind_potrho_3)%field(:,:,:))
    else
      wrk1(:,:,:) = potential_density(Dens%rho_salinity(:,:,:,tau), Temp%field(:,:,:,tau), 3000.0)
      call diagnose_3d(Time, Grd, id_pot_rho_3, wrk1(:,:,:))
    endif
  endif

  if (id_pot_rho_4 > 0) then 
    if (ind_potrho_4 .gt. 0) then
       call diagnose_3d(Time, Grd, id_pot_rho_4, T_diag(ind_potrho_4)%field(:,:,:))
    else
      wrk1(:,:,:) = potential_density(Dens%rho_salinity(:,:,:,tau), Temp%field(:,:,:,tau), 4000.0)
      call diagnose_3d(Time, Grd, id_pot_rho_4, wrk1(:,:,:))
    endif
  endif


end subroutine ocean_density_diag
! </SUBROUTINE> NAME="ocean_density_diag"


!#######################################################################
! <SUBROUTINE NAME="update_ocean_density_salinity">
!
! <DESCRIPTION>
!
! If TEOS-10 is being used then we need to multiply Preformed Salinity and the
! Salinity factor to obtain absolute salinity for use in the TEOS10 EOS. 
!
! If not using TEOS10 EOS, then copy the practical salinity into the
! density_salinity field for use in the preTEOS10 EOS or the linear EOS.  
!
! Note that halo values are not generally valid for taup1 until the halos
! for index_salt and index_Fdelta have been updated inside of ocean_model.F90.
!
! </DESCRIPTION>
  subroutine update_ocean_density_salinity(T_prog, time_level, Dens)

  type(ocean_prog_tracer_type),   intent(in)    :: T_prog(:)
  integer,                        intent(in)    :: time_level
  type(ocean_density_type),       intent(inout) :: Dens

  integer i,j,k

  if (Dens%use_teos10) then
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               Dens%rho_salinity(i,j,k,time_level) = T_prog(index_salt)%field(i,j,k,time_level)* &
                    (1.0 + T_prog(index_Fdelta)%field(i,j,k,time_level))

            enddo
         enddo
      enddo
  else
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               Dens%rho_salinity(i,j,k,time_level) = T_prog(index_salt)%field(i,j,k,time_level)
            enddo
         enddo
      enddo
  endif

  end subroutine update_ocean_density_salinity
! </SUBROUTINE> NAME="update_ocean_density_salinity"


!#######################################################################
! <SUBROUTINE NAME="update_ocean_density">
!
! <DESCRIPTION>
! Diagnose pressure_at_depth and ocean density.  
! Also send some diagnostics to diagnostic manager.  
! </DESCRIPTION>
!
  subroutine update_ocean_density(Time, Thickness, Temp, Salt, Ext_mode, Dens, L_system, use_blobs)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_prog_tracer_type),   intent(in)    :: Temp
  type(ocean_prog_tracer_type),   intent(in)    :: Salt
  type(ocean_external_mode_type), intent(in)    :: Ext_mode
  type(ocean_density_type),       intent(inout) :: Dens
  type(ocean_lagrangian_type),    intent(in)    :: L_system
  logical,                        intent(in)    :: use_blobs
  type(time_type)                               :: next_time 
  
  integer :: i, j, k
  integer :: tau, taup1

  integer :: stdoutunit 
  stdoutunit=stdout() 

  tau   = Time%tau
  taup1 = Time%taup1  

  ! compute pressure at depth (dbars).
  ! do so consistently with all fields at time tau.  
  if(vert_coordinate==GEOPOTENTIAL) then 
     if (use_blobs) then
        Dens%pressure_at_depth(:,:,:) = pressure_in_dbars_blob(Thickness, Dens%rho(:,:,:,tau), &
                                        L_system%rho_dztup(:,:,:), L_system%rho_dztlo(:,:,:),  &
                                        Ext_mode%patm_t(:,:,tau)+grav*Dens%rho(:,:,1,tau)*Ext_mode%eta_t(:,:,tau))
     else
        Dens%pressure_at_depth(:,:,:) = pressure_in_dbars(Thickness, Dens%rho(:,:,:,tau), &
                                        Ext_mode%patm_t(:,:,tau)+grav*Dens%rho(:,:,1,tau)*Ext_mode%eta_t(:,:,tau))
     endif
  elseif(vert_coordinate==ZSTAR .or. vert_coordinate==ZSIGMA) then 
     if (use_blobs) then
        Dens%pressure_at_depth(:,:,:) = pressure_in_dbars_blob(Thickness, Dens%rho(:,:,:,tau), &
                                        L_system%rho_dztup(:,:,:), L_system%rho_dztlo(:,:,:),  &
                                        Ext_mode%patm_t(:,:,tau))
     else
        Dens%pressure_at_depth(:,:,:) = pressure_in_dbars(Thickness, Dens%rho(:,:,:,tau), &
                                        Ext_mode%patm_t(:,:,tau))
     endif
  elseif(vert_coordinate==PRESSURE) then 
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               Dens%pressure_at_depth(i,j,k) = c2dbars*Thickness%depth_st(i,j,k)
            enddo
         enddo
      enddo
  elseif(vert_coordinate==PSTAR) then
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               Dens%pressure_at_depth(i,j,k) = c2dbars*(                   &
                      Ext_mode%patm_t(i,j,tau)                             &
                    + Thickness%depth_st(i,j,k)*Thickness%pbot0r(i,j)      &
                      *(Ext_mode%pbot_t(i,j,tau)-Ext_mode%patm_t(i,j,tau)) &
                    )
            enddo
         enddo
      enddo
  elseif(vert_coordinate==PSIGMA) then
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               Dens%pressure_at_depth(i,j,k) = c2dbars*(                   &
                      Ext_mode%patm_t(i,j,tau)                             &
                    + Thickness%depth_st(i,j,k)                            &
                      *(Ext_mode%pbot_t(i,j,tau)-Ext_mode%patm_t(i,j,tau)) &
                    )
            enddo
         enddo
      enddo
  endif
  
  ! diagnose in situ density 
  Dens%rho(:,:,:,taup1) = Grd%tmask(:,:,:) &
   *density(Dens%rho_salinity(:,:,:,taup1), Temp%field(:,:,:,taup1), Dens%pressure_at_depth(:,:,:))

  if(rho0_density) then 
     Dens%rho(:,:,:,taup1) = Grd%tmask(:,:,:)*rho0
  endif 

  ! compute drhodT and drhodS and drhodP
  ! do so with tau values for salinity, temperature, and pressure
  call density_derivs(Dens%rho(:,:,:,tau), Dens%rho_salinity(:,:,:,tau),    &
                      Temp%field(:,:,:,tau), Dens%pressure_at_depth(:,:,:), &
                      Time, Dens%drhodT(:,:,:), Dens%drhodS(:,:,:), Dens%drhodP(:,:,:)) 

  ! compute dpotrhodT and dpotrhodS
  ! do so with tau values for salinity, temperature, and pressure
  call density_derivs_potrho(Time, Dens%potrho(:,:,:), Dens%rho_salinity(:,:,:,tau),&
                             Temp%field(:,:,:,tau), Dens%dpotrhodT(:,:,:),          &
                             Dens%dpotrhodS(:,:,:), Dens%dpotrhodP(:,:,:))

  ! compute buoyancy frequency for diagnostic purposes 
  if (use_blobs) then
     call compute_buoyfreq(Time, Thickness, Salt%fieldT(:,:,:), Temp%fieldT(:,:,:), Dens, use_blobs) 
  else
     ! compute buoyancy frequency for diagnostic purposes 
     call compute_buoyfreq(Time, Thickness, Dens%rho_salinity(:,:,:,tau), Temp%field(:,:,:,tau), Dens, use_blobs) 
  endif

  call compute_density_diagnostics(Time, Thickness, Temp, Ext_mode, Dens, use_blobs)
  call compute_drhodxy(Time, Dens%rho_salinity(:,:,:,tau), Temp%field(:,:,:,tau), Dens)   

end subroutine update_ocean_density
! </SUBROUTINE> NAME="update_ocean_density"


!#######################################################################
! <FUNCTION NAME="density_field">
!
! <DESCRIPTION>
! Compute density for all grid points.  
!
! Note that pressure here is 
!
! sea pressure = absolute pressure - press_standard (dbars) 
!
! and salinity is in model units (psu or g/kg).  
!
! </DESCRIPTION>
!
  function density_field (salinity, theta, press)

    real, dimension(isd:,jsd:,:), intent(in) :: salinity
    real, dimension(isd:,jsd:,:), intent(in) :: theta
    real, dimension(isd:,jsd:,:), intent(in) :: press

    real, dimension(isd:ied,jsd:jed,nk) :: density_field
    real, dimension(isd:ied,jsd:jed,nk) :: pressure 

    integer :: i, j, k
    real    :: t1, t2, s1, sp5, p1, p1t1
    real    :: num, den

    if ( .not. module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_density_mod (density_field): module must be initialized')
    endif 

    if(density_equal_potrho) then 
       pressure(:,:,:) = Grd%tmask(:,:,:)*potrho_press
    else
       pressure(:,:,:) = press(:,:,:)
    endif 


    if(eos_linear) then

       do k=1,nk
          do j=jsd,jed
             do i=isd,ied
                density_field(i,j,k) = rho0 - alpha_linear_eos*theta(i,j,k) + beta_linear_eos*salinity(i,j,k)
             enddo
          enddo
       enddo

    elseif(eos_preteos10) then 

       do k=1,nk
          do j=jsd,jed
             do i=isd,ied

                t1  = theta(i,j,k)
                t2  = t1*t1

                s1  = salinity(i,j,k)
                sp5 = sqrt(s1) 

                p1   = pressure(i,j,k) - press_standard
                p1t1 = p1*t1

                num = a0 + t1*(a1 + t1*(a2+a3*t1) )  &
                     + s1*(a4 + a5*t1  + a6*s1)      &
                     + p1*(a7 + a8*t2 + a9*s1 + p1*(a10+a11*t2))

                den = b0 + t1*(b1 + t1*(b2 + t1*(b3 + t1*b4)))      &
                     + s1*(b5 + t1*(b6 + b7*t2) + sp5*(b8 + b9*t2)) &  
                     + p1*(b10 + p1t1*(b11*t2 + b12*p1))
 
                denominator_r(i,j,k) = 1.0/(epsln+den) 

                density_field(i,j,k) = num*denominator_r(i,j,k)

             enddo
          enddo
       enddo

    else   ! eos_teos10

       do k=1,nk
          do j=jsd,jed
             do i=isd,ied

                t1  = theta(i,j,k)
                t2  = t1*t1

                s1  = salinity(i,j,k)
                sp5 = sqrt(s1)

                p1   = pressure(i,j,k) - press_standard
                p1t1 = p1*t1

                num = v01 + t1*(v02 + t1*(v03 + v04*t1))                &
                      + s1*(v05 + t1*(v06 + v07*t1)                     &
                      + sp5*(v08 + t1*(v09 + t1*(v10 + v11*t1))))       &
                      + p1*(v12 + t1*(v13 + v14*t1) + s1*(v15 + v16*t1) &
                      + p1*(v17 + t1*(v18 + v19*t1) + v20*s1))

                den =  v21 + t1*(v22 + t1*(v23 + t1*(v24 + v25*t1)))                &
                       + s1*(v26 + t1*(v27 + t1*(v28 + t1*(v29 + v30*t1))) + v36*s1 &
                       + sp5*(v31 + t1*(v32 + t1*(v33 + t1*(v34 + v35*t1)))))       &
                       + p1*(v37 + t1*(v38 + t1*(v39 + v40*t1))                     &
                       + s1*(v41 + v42*t1)                                          &
                       + p1*(v43 + t1*(v44 + v45*t1 + v46*s1)                       &
                       + p1*(v47 + v48*t1)))

                denominator_r(i,j,k) = 1.0/(epsln+den)

                density_field(i,j,k) = num*denominator_r(i,j,k)

             enddo
          enddo
       enddo

    endif

  end function density_field
! </FUNCTION> NAME="density_field"


!#######################################################################
! <FUNCTION NAME="density_level">
!
! <DESCRIPTION>
! Compute density at a particular k-level. 
!
! Note that pressure here is 
!
! sea pressure = absolute pressure - press_standard (dbars)
!
! </DESCRIPTION>
!
  function density_level(salinity, theta, press)

    real, dimension(isd:,jsd:), intent(in) :: salinity
    real, dimension(isd:,jsd:), intent(in) :: theta
    real, dimension(isd:,jsd:), intent(in) :: press

    real, dimension(isd:ied,jsd:jed) :: density_level 
    real, dimension(isd:ied,jsd:jed) :: pressure 

    integer :: i, j
    real    :: t1, t2, s1, sp5, p1, p1t1
    real    :: num, den

    if ( .not. module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_density_mod (density_level): module must be initialized')
    endif 

    if(density_equal_potrho) then 
       pressure(:,:) = Grd%tmask(:,:,1)*potrho_press
    else 
       pressure(:,:) = press(:,:)
    endif 


    if(eos_linear) then

       do j=jsd,jed
          do i=isd,ied
             density_level(i,j) = rho0 - alpha_linear_eos*theta(i,j) + beta_linear_eos*salinity(i,j)
          enddo
       enddo

    elseif(eos_preteos10) then 

       do j=jsd,jed
          do i=isd,ied

             t1  = theta(i,j)
             t2  = t1*t1

             s1  = salinity(i,j)
             sp5 = sqrt(s1) 

             p1   = pressure(i,j) - press_standard
             p1t1 = p1*t1

             num = a0 + t1*(a1 + t1*(a2+a3*t1) )  &
                  + s1*(a4 + a5*t1  + a6*s1)        &
                  + p1*(a7 + a8*t2 + a9*s1 + p1*(a10+a11*t2))

             den = b0 + t1*(b1 + t1*(b2 + t1*(b3 + t1*b4)))      &
                  + s1*(b5 + t1*(b6 + b7*t2) + sp5*(b8 + b9*t2)) &  
                  + p1*(b10 + p1t1*(b11*t2 + b12*p1))

             density_level(i,j) = num/(epsln+den)

          enddo
       enddo

    else   ! eos_teos10

       do j=jsd,jed
          do i=isd,ied

             t1  = theta(i,j)
             t2  = t1*t1

             s1  = salinity(i,j)
             sp5 = sqrt(s1)

             p1   = pressure(i,j) - press_standard
             p1t1 = p1*t1

             num = v01 + t1*(v02 + t1*(v03 + v04*t1))                &
                   + s1*(v05 + t1*(v06 + v07*t1)                     &
                   + sp5*(v08 + t1*(v09 + t1*(v10 + v11*t1))))       &
                   + p1*(v12 + t1*(v13 + v14*t1) + s1*(v15 + v16*t1) &
                   + p1*(v17 + t1*(v18 + v19*t1) + v20*s1))

             den =  v21 + t1*(v22 + t1*(v23 + t1*(v24 + v25*t1)))                &
                    + s1*(v26 + t1*(v27 + t1*(v28 + t1*(v29 + v30*t1))) + v36*s1 &
                    + sp5*(v31 + t1*(v32 + t1*(v33 + t1*(v34 + v35*t1)))))       &
                    + p1*(v37 + t1*(v38 + t1*(v39 + v40*t1))                     &
                    + s1*(v41 + v42*t1)                                          &
                    + p1*(v43 + t1*(v44 + v45*t1 + v46*s1)                       &
                    + p1*(v47 + v48*t1)))


             density_level(i,j) = num/(epsln+den)

          enddo
       enddo

    endif

  end function density_level
! </FUNCTION> NAME="density_level"


!#######################################################################
! <FUNCTION NAME="density_line">
!
! <DESCRIPTION>
! Compute density at a particular k-level and j index.  This scheme
! is used in the vectorized version of the full convection scheme. 
!
! Note that pressure here is
!
! sea pressure = absolute pressure - press_standard
!
! </DESCRIPTION>
!
  function density_line(salinity, theta, press)

    real, dimension(isd:), intent(in) :: salinity
    real, dimension(isd:), intent(in) :: theta
    real, dimension(isd:), intent(in) :: press

    real, dimension(isd:ied) :: density_line 
    real, dimension(isd:ied) :: pressure

    integer :: i
    real    :: t1, t2, s1, sp5, p1, p1t1
    real    :: num, den

    if ( .not. module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_density_mod (density_line): module must be initialized')
    endif 

    if(density_equal_potrho) then 
       pressure(:) = potrho_press
    else 
       pressure(:) = press(:)
    endif 


    if(eos_linear) then

        do i=isd,ied
           density_line(i) = rho0 - alpha_linear_eos*theta(i) + beta_linear_eos*salinity(i)
        enddo

    elseif(eos_preteos10) then 

        do i=isd,ied

           t1  = theta(i)
           t2  = t1*t1

           s1  = salinity(i)
           sp5 = sqrt(s1) 

           p1   = pressure(i) - press_standard
           p1t1 = p1*t1

           num = a0 + t1*(a1 + t1*(a2+a3*t1) )  &
                + s1*(a4 + a5*t1  + a6*s1)        &
                + p1*(a7 + a8*t2 + a9*s1 + p1*(a10+a11*t2))

           den = b0 + t1*(b1 + t1*(b2 + t1*(b3 + t1*b4)))      &
                  + s1*(b5 + t1*(b6 + b7*t2) + sp5*(b8 + b9*t2)) &  
                  + p1*(b10 + p1t1*(b11*t2 + b12*p1))

           density_line(i) = num/(epsln+den)
       enddo

    else  ! eos_teos10

        do i=isd,ied

           t1  = theta(i)
           t2  = t1*t1

           s1  = salinity(i)
           sp5 = sqrt(s1)

           p1   = pressure(i) - press_standard
           p1t1 = p1*t1

           num = v01 + t1*(v02 + t1*(v03 + v04*t1))                &
                 + s1*(v05 + t1*(v06 + v07*t1)                     &
                 + sp5*(v08 + t1*(v09 + t1*(v10 + v11*t1))))       &
                 + p1*(v12 + t1*(v13 + v14*t1) + s1*(v15 + v16*t1) &
                 + p1*(v17 + t1*(v18 + v19*t1) + v20*s1))

           den =  v21 + t1*(v22 + t1*(v23 + t1*(v24 + v25*t1)))                &
                  + s1*(v26 + t1*(v27 + t1*(v28 + t1*(v29 + v30*t1))) + v36*s1 &
                  + sp5*(v31 + t1*(v32 + t1*(v33 + t1*(v34 + v35*t1)))))       &
                  + p1*(v37 + t1*(v38 + t1*(v39 + v40*t1))                     &
                  + s1*(v41 + v42*t1)                                          &
                  + p1*(v43 + t1*(v44 + v45*t1 + v46*s1)                       &
                  + p1*(v47 + v48*t1)))


           density_line(i) = num/(epsln+den)

        enddo

    endif

  end function density_line
! </FUNCTION> NAME="density_line"


!#######################################################################
! <FUNCTION NAME="neutral_density_field">
!
! <DESCRIPTION>
! Compute neutral density for use in various layer diagnostics.
!
! Two options are presently available:
!
! A/ use rational polynomial (to be done)
!
! B/ use potential density referenced to pressure potrho_press
!    McDougall recommends potential density referenced to 2000dbar,
!    since the rational polynomial is not too good.   
!
! Note that presently, the rational polynomial method defaults to 
! potential density referenced to 2000dbar.
! The polynomial approximation from McDougall and Jackett (2005)
! is not recommended (as per Trevor McDougall, 2011). A new polynomial 
! is being constructed and should be ready end of 2011.  
!
! </DESCRIPTION>
!
  function neutral_density_field (salinity, theta)

    real, dimension(isd:,jsd:,:), intent(in) :: salinity
    real, dimension(isd:,jsd:,:), intent(in) :: theta

    real, dimension(isd:ied,jsd:jed,nk) :: neutral_density_field

    integer :: i, j, k

    if ( .not. module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_density_mod (neutral_density_field): module must be initialized')
    endif 

    if(neutral_density_theta) then
        do k=1,nk
           do j=jsd,jed
              do i=isd,ied
                 neutral_density_field(i,j,k) = theta(i,j,k)
              enddo
           enddo
        enddo
    elseif(eos_linear) then
        do k=1,nk
           do j=jsd,jed
              do i=isd,ied
                 neutral_density_field(i,j,k) = rho0 - alpha_linear_eos*theta(i,j,k) + beta_linear_eos*salinity(i,j,k)
              enddo
           enddo
        enddo
    else
         if (diff_nrho_press) then
             neutral_density_field = potential_density(salinity,theta,nrho_press)
         else
             neutral_density_field = potential_density(salinity,theta,potrho_press)
         endif
    endif 

  end function neutral_density_field
! </FUNCTION> NAME="neutral_density_field"


!#######################################################################
! <FUNCTION NAME="neutral_density_point">
!
! <DESCRIPTION>
! Compute neutral density for use in various layer diagnostics.
!
! Only test here the rational polynomial 
! approximation given by McDougall and Jackett (2005).
! This test needs to be updated.  
! 
! </DESCRIPTION>
!
  function neutral_density_point (salinity, theta)

    real, intent(in) :: salinity
    real, intent(in) :: theta

    real :: neutral_density_point
    real :: t1, t2, s1, sp5
    real :: num, den

    if ( .not. module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_density_mod (neutral_density_point): module must be initialized')
    endif 

    if(neutral_density_theta) then

        neutral_density_point = theta

    elseif(eos_linear) then

        neutral_density_point = rho0 - alpha_linear_eos*theta + beta_linear_eos*salinity

    else

        t1  = theta
        t2  = t1*t1

        s1  = salinity
        sp5 = sqrt(s1) 

        num = a0n + t1*(a1n + t1*(a2n+a3n*t1) )    &
             + s1*(a4n + a5n*t1  + a6n*s1)       

        den = b0n + t1*(b1n + t1*(b2n + t1*(b3n + t1*b4n)))      &
             + s1*(b5n + t1*(b6n + b7n*t2) + sp5*(b8n + b9n*t2)) 

        neutral_density_point = num/(epsln+den)

    endif

  end function neutral_density_point
! </FUNCTION> NAME="neutral_density_point"


!#######################################################################
! <FUNCTION NAME="potential_density">
!
! <DESCRIPTION>
! Compute potential density referenced to some given sea pressure. 
!
! Note that potential density referenced to the surface (i.e., sigma_0)
! has a zero sea pressure, so pressure=0.0 should be the argument
! to the function. 
!
! Note that pressure here is 
! sea pressure = absolute pressure - press_standard  (dbars)
!
! input pressure < 0 is an error, and model is brought down.  
! 
! </DESCRIPTION>
!
  function potential_density (salinity, theta, pressure)

    real, dimension(isd:,jsd:,:), intent(in) :: salinity
    real, dimension(isd:,jsd:,:), intent(in) :: theta
    real,                         intent(in) :: pressure

    real, dimension(isd:ied,jsd:jed,nk) :: potential_density

    integer :: i, j, k
    real    :: t1, t2, s1, sp5, p1, p1t1
    real    :: num, den

    if ( .not. module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_density_mod (potential_density): module must be initialized')
    endif 

    if(pressure < 0.0) then 
       call mpp_error(FATAL, &
       '==>Error in ocean_density_mod: potential density at pressure < 0 is not defined')
    endif 


    if(eos_linear) then

        do k=1,nk
           do j=jsd,jed
              do i=isd,ied
                 potential_density(i,j,k) = rho0 - alpha_linear_eos*theta(i,j,k) + beta_linear_eos*salinity(i,j,k)
              enddo
           enddo
        enddo

    elseif(eos_preteos10) then 

        p1 = pressure
        if(p1 > 0.0) then 

            do k=1,nk
               do j=jsd,jed
                  do i=isd,ied
                     t1  = theta(i,j,k)
                     t2  = t1*t1

                     s1  = salinity(i,j,k)
                     sp5 = sqrt(s1) 

                     p1t1 = p1*t1

                     num = a0 + t1*(a1 + t1*(a2+a3*t1) )    &
                          + s1*(a4 + a5*t1  + a6*s1)        &
                          + p1*(a7 + a8*t2 + a9*s1 + p1*(a10+a11*t2))

                     den = b0 + t1*(b1 + t1*(b2 + t1*(b3 + t1*b4)))      &
                          + s1*(b5 + t1*(b6 + b7*t2) + sp5*(b8 + b9*t2)) &  
                          + p1*(b10 + p1t1*(b11*t2 + b12*p1))

                     potential_density(i,j,k) = num/(epsln+den)
                  enddo
               enddo
            enddo

        elseif(p1==0.0) then ! simplification for sigma_0

            do k=1,nk
               do j=jsd,jed
                  do i=isd,ied
                     t1  = theta(i,j,k)
                     t2  = t1*t1

                     s1  = salinity(i,j,k)
                     sp5 = sqrt(s1) 

                     num = a0 + t1*(a1 + t1*(a2+a3*t1) )  &
                          + s1*(a4 + a5*t1  + a6*s1)        

                     den = b0 + t1*(b1 + t1*(b2 + t1*(b3 + t1*b4)))      &
                          + s1*(b5 + t1*(b6 + b7*t2) + sp5*(b8 + b9*t2)) 

                     potential_density(i,j,k) = num/(epsln+den)
                  enddo
               enddo
            enddo

        endif  ! endif for value of pressure 

    else   ! eos_teos10

        p1 = pressure
        if(p1 > 0.0) then 

            do k=1,nk
               do j=jsd,jed
                  do i=isd,ied
                     t1  = theta(i,j,k)
                     t2  = t1*t1

                     s1  = salinity(i,j,k)
                     sp5 = sqrt(s1) 

                     p1t1 = p1*t1

                     num = v01 + t1*(v02 + t1*(v03 + v04*t1))               &
                          + s1*(v05 + t1*(v06 + v07*t1)                     &
                          + sp5*(v08 + t1*(v09 + t1*(v10 + v11*t1))))       &
                          + p1*(v12 + t1*(v13 + v14*t1) + s1*(v15 + v16*t1) &
                          + p1*(v17 + t1*(v18 + v19*t1) + v20*s1))

                     den =  v21 + t1*(v22 + t1*(v23 + t1*(v24 + v25*t1)))              &
                          + s1*(v26 + t1*(v27 + t1*(v28 + t1*(v29 + v30*t1))) + v36*s1 &
                          + sp5*(v31 + t1*(v32 + t1*(v33 + t1*(v34 + v35*t1)))))       &
                          + p1*(v37 + t1*(v38 + t1*(v39 + v40*t1))                     &
                          +     s1*(v41 + v42*t1)                                      &
                          +     p1*(v43 + t1*(v44 + v45*t1 + v46*s1)                   &
                          +     p1*(v47 + v48*t1)))

                     potential_density(i,j,k) = num/(epsln+den)
                  enddo
               enddo
            enddo

        elseif(p1==0.0) then ! for sigma_0

            do k=1,nk
               do j=jsd,jed
                  do i=isd,ied
                     t1  = theta(i,j,k)
                     t2  = t1*t1

                     s1  = salinity(i,j,k)
                     sp5 = sqrt(s1) 

                     num = v01 + t1*(v02 + t1*(v03 + v04*t1))         &
                          + s1*(v05 + t1*(v06 + v07*t1)               &
                          + sp5*(v08 + t1*(v09 + t1*(v10 + v11*t1)))) 

                     den =  v21 + t1*(v22 + t1*(v23 + t1*(v24 + v25*t1)))              &
                          + s1*(v26 + t1*(v27 + t1*(v28 + t1*(v29 + v30*t1))) + v36*s1 &
                          + sp5*(v31 + t1*(v32 + t1*(v33 + t1*(v34 + v35*t1)))))


                     potential_density(i,j,k) = num/(epsln+den)
                  enddo
               enddo
            enddo

        endif  ! endif for pressure 

    endif  ! endif for eos choice 


  end function potential_density
! </FUNCTION> NAME="potential_density"


!#######################################################################
! <SUBROUTINE NAME="compute_density_diagnostics">
!
! <DESCRIPTION>
! Diagnostics related to density. 
! </DESCRIPTION>
!
  subroutine compute_density_diagnostics(Time, Thickness, Temp, Ext_mode, Dens, use_blobs)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_prog_tracer_type),   intent(in)    :: Temp
  type(ocean_external_mode_type), intent(in)    :: Ext_mode
  type(ocean_density_type),       intent(in)    :: Dens
  logical,                        intent(in)    :: use_blobs
  type(time_type)                               :: next_time 
  
  logical :: used
  integer :: i, j, k
  integer :: tau, taup1
  real    :: mass, massip1, massjp1
  real    :: density_tau         =0.0
  real    :: density_taup1       =0.0
  real    :: volume_tau          =0.0
  real    :: volume_taup1        =0.0
  real    :: volume_taup12       =0.0
  real    :: mass_tau            =0.0
  real    :: mass_taup1          =0.0
  real    :: pbot_adjust         =0.0
  real    :: eta_adjust          =0.0
  real    :: eta_adjust_approx   =0.0
  real    :: eta_adjust_cstvolume=0.0

  integer :: stdoutunit 
  stdoutunit=stdout() 

  tau   = Time%tau
  taup1 = Time%taup1  

  ! compute cabbeling and thermobaricity parameters for diagnostics 
  if(id_cabbeling > 0 .or. id_thermobaricity > 0) then 
      call cabbeling_thermobaricity(Dens%rho(:,:,:,tau), Dens%rho_salinity(:,:,:,tau),    &
                                    Temp%field(:,:,:,tau), Dens%pressure_at_depth(:,:,:), &
                                    Time, Dens%drhodT(:,:,:), Dens%drhodS(:,:,:), Dens%drhodP(:,:,:))
  endif 

  call diagnose_3d(Time, Grd, id_press, Dens%pressure_at_depth(:,:,:))

  if (use_blobs) then
     call diagnose_3d(Time, Grd, id_rho, Dens%rhoT(:,:,:))
     call diagnose_3d(Time, Grd, id_rhoE, Dens%rho(:,:,:,tau))
  else
     call diagnose_3d(Time, Grd, id_rho, Dens%rho(:,:,:,tau))
  endif

  call diagnose_3d(Time, Grd, id_eos_salinity, Dens%rho_salinity(:,:,:,tau))

  if(id_int_rhodz > 0) then 
      wrk1_2d(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1_2d(i,j) = wrk1_2d(i,j) + Thickness%dzt(i,j,k)*Dens%rho(i,j,k,tau) 
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_int_rhodz, wrk1_2d(:,:))
  endif

  next_time = increment_time(Time%model_time, int(dtts), 0)

  if (need_data(id_pot_rho_wt,next_time)) then 
      wrk1(:,:,:) = 0.0
      do j=jsc,jec
         do i=isc,iec
            wrk1(i,j,nk) = Dens%potrho(i,j,nk)
         enddo
      enddo
      do k=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               if(Grd%tmask(i,j,k) > 0.0) then   
                   wrk1(i,j,k) = ( Grd%tmask(i,j,k+1)*Dens%potrho(i,j,k+1)*Thickness%rho_dzt(i,j,k+1,tau) &
                        +Dens%potrho(i,j,k)  *Thickness%rho_dzt(i,j,k,tau))                               &
                        /( epsln + Thickness%rho_dzt(i,j,k,tau) + Grd%tmask(i,j,k+1)*Thickness%rho_dzt(i,j,k+1,tau) ) 
               endif
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_pot_rho_wt, wrk1(:,:,:))
  endif

  if (need_data(id_pot_rho_et,next_time)) then 
      wrk1(:,:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               mass      = Thickness%rho_dzt(i,j,k,tau)  *Grd%dat(i,j)  *Grd%tmask(i,j,k) 
               massip1   = Thickness%rho_dzt(i+1,j,k,tau)*Grd%dat(i+1,j)*Grd%tmask(i+1,j,k) 
               wrk1(i,j,k) = ( Dens%potrho(i,j,k)*mass + Dens%potrho(i+1,j,k)*massip1 ) &
                    /( epsln + mass + massip1 ) 
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_pot_rho_et, wrk1(:,:,:))
  endif

  if (need_data(id_pot_rho_nt,next_time)) then 
      wrk1(:,:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               mass      = Thickness%rho_dzt(i,j,k,tau)  *Grd%dat(i,j)  *Grd%tmask(i,j,k) 
               massjp1   = Thickness%rho_dzt(i,j+1,k,tau)*Grd%dat(i,j+1)*Grd%tmask(i,j+1,k) 
               wrk1(i,j,k) = ( Dens%potrho(i,j,k)*mass + Dens%potrho(i,j+1,k)*massjp1 ) &
                    /( epsln + mass + massjp1 ) 
            enddo
         enddo
      enddo
      call diagnose_3d(Time, Grd, id_pot_rho_nt, wrk1(:,:,:))
  endif


  if (id_pbot_adjust>0       .or. id_eta_adjust>0           .or. &
      id_eta_adjust_approx>0 .or. id_eta_adjust_cstvolume>0 .or. id_rhoave>0) then 
    ! These diagnostics are used to adjust the bottom pressure and surface height computed
    ! from a Boussinesq model.  The adjustments correct, globally, for the spurious 
    ! mass sources appearing in the Boussinesq fluid and the missing steric effect.  
    ! The adjustments are NOT needed with non-Boussinesq models (pressure based vert coord),
    ! since the non-Boussinesq fluid correctly computes the bottom pressure and 
    ! surface height according to mass conserving kinematics.
    !
    ! In a Bouss model (depth based vert coordinates), when global mean density increases, 
    ! so does the Boussinesq mass. So the pbot_adjust is negative in this case, in 
    ! order to globally counteract effects from the spurious mass source.
    !
    ! In a non-Bouss model, when global mean density increases, global mean sea level decreases. 
    ! This global steric effect is absent from the Boussinesq fluid.  To incorporate this 
    ! this missing contribution to sea level, eta_adjust will be negative in this case. 
    !
    ! note that dzt has already been updated to its taup1 value. that is why we use  
    ! rho0r*rho_dzt = dzt (when depth-based vertical coordinates).

      mass_tau         = 0.0
      mass_taup1       = 0.0
      volume_tau       = 0.0
      volume_taup1     = 0.0
      volume_taup12    = 0.0
      rhodz_tau(:,:)   = 0.0
      rhodz_taup1(:,:) = 0.0
      wrk1_2d(:,:)     = 0.0
      wrk2_2d(:,:)     = 0.0
      wrk3_2d(:,:)     = 0.0
      wrk4_2d(:,:)     = 0.0

      ! do the vertical sum of rho*dzt 
      if(vert_coordinate==GEOPOTENTIAL .or. vert_coordinate==ZSTAR .or. vert_coordinate==ZSIGMA) then 
          do k=1,nk
             do j=jsc,jec
                do i=isc,iec
                   rhodz_tau(i,j)  = rhodz_tau(i,j)  + Grd%tmask(i,j,k)*rho0r*Thickness%rho_dzt(i,j,k,tau)   &
                                                       *Dens%rho(i,j,k,tau)
                   rhodz_taup1(i,j)= rhodz_taup1(i,j)+ Grd%tmask(i,j,k)*rho0r*Thickness%rho_dzt(i,j,k,taup1) &
                                                       *Dens%rho(i,j,k,taup1)
                enddo
             enddo
          enddo
      else 
          k=1
          do j=jsc,jec
             do i=isc,iec
                rhodz_tau(i,j)   = Grd%tmask(i,j,k)*grav_r*(Ext_mode%pbot_t(i,j,tau)  -Ext_mode%patm_t(i,j,tau))
                rhodz_taup1(i,j) = Grd%tmask(i,j,k)*grav_r*(Ext_mode%pbot_t(i,j,taup1)-Ext_mode%patm_t(i,j,taup1))
             enddo
          enddo
      endif

      ! compute the mass and volume of a seawater column
      do j=jsd,jed
         do i=isd,ied
            wrk1_2d(i,j) = Grd%tmask(i,j,1)*Grd%dat(i,j)*rhodz_tau(i,j)
            wrk2_2d(i,j) = Grd%tmask(i,j,1)*Grd%dat(i,j)*rhodz_taup1(i,j)
            wrk3_2d(i,j) = Grd%tmask(i,j,1)*Grd%dat(i,j)*(Grd%ht(i,j) + Ext_mode%eta_t(i,j,tau))
            wrk4_2d(i,j) = Grd%tmask(i,j,1)*Grd%dat(i,j)*(Grd%ht(i,j) + Ext_mode%eta_t(i,j,taup1))
         enddo
      enddo

      ! perform global sums to get global mass and volume for ocean 
      mass_tau    = mpp_global_sum(Dom%domain2d,wrk1_2d(:,:),NON_BITWISE_EXACT_SUM)
      volume_tau  = mpp_global_sum(Dom%domain2d,wrk3_2d(:,:),NON_BITWISE_EXACT_SUM)
      density_tau = mass_tau/(epsln+volume_tau)

      mass_taup1    = mpp_global_sum(Dom%domain2d,wrk2_2d(:,:),NON_BITWISE_EXACT_SUM)
      volume_taup1  = mpp_global_sum(Dom%domain2d,wrk4_2d(:,:),NON_BITWISE_EXACT_SUM)
      density_taup1 = mass_taup1/(epsln+volume_taup1)

      volume_taup12 = 0.5*(volume_taup1+volume_tau)

      if(id_pbot_adjust > 0) then 
         pbot_adjust = -grav*c2dbars*area_total_r*volume_taup1*(density_taup1-density_tau) 
         used = send_data(id_pbot_adjust, pbot_adjust, Time%model_time)
      endif 
      if(id_eta_adjust > 0) then 
         eta_adjust = area_total_r*volume_taup12*log((density_tau+epsln)/(density_taup1+epsln))
         used = send_data(id_eta_adjust, eta_adjust, Time%model_time)
      endif 
      if(id_eta_adjust_approx > 0) then 
         eta_adjust_approx = area_total_r*volume_taup1*(density_tau/(epsln+density_taup1)-1.0)
         used = send_data(id_eta_adjust_approx, eta_adjust_approx, Time%model_time)
      endif 
      if(id_eta_adjust_cstvolume > 0) then 
         eta_adjust_cstvolume = area_total_r*Grd%tcellv*(density_tau/(epsln+density_taup1)-1.0)
         used = send_data(id_eta_adjust_cstvolume, eta_adjust_cstvolume, Time%model_time)
      endif 
      if(id_rhoave > 0) then 
         used = send_data(id_rhoave, density_tau, Time%model_time)
      endif    

  endif 

  if(debug_this_module) then 
      write(stdoutunit,'(a)') ' ' 
      write(stdoutunit,*) 'From ocean_density_mod: density chksums from compute_density_diagnostics'
      call write_timestamp(Time%model_time)
      call ocean_density_chksum(Time, Dens, use_blobs)
  endif

end subroutine compute_density_diagnostics
! </SUBROUTINE> NAME="compute_density_diagnostics"



!#######################################################################
! <SUBROUTINE NAME="compute_diagnostic_factors">
!
! <DESCRIPTION>
!
! 1/ Compute ratio |grad neutral rho| / |grad local ref pot rho|
! for use in tform water mass analysis as per Iudicone et al. (2008).
!
! 2/ Compute rho*Area(h)/gamma_h, where "h" is the direction where
! gamma has the largest stratification, and where gamma is the 
! locally referenced potential density.
!
! </DESCRIPTION>
!
  subroutine compute_diagnostic_factors (Time, Thickness, Dens, salinity, theta)

    type(ocean_time_type),         intent(in)    :: Time
    type(ocean_thickness_type),    intent(in)    :: Thickness 
    type(ocean_density_type),      intent(inout) :: Dens
    real, dimension(isd:,jsd:,:),  intent(in)    :: salinity
    real, dimension(isd:,jsd:,:),  intent(in)    :: theta

    integer :: i, j, k, kp1, km1, tau
    real    :: tmp, active_cells 

    if ( .not. module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_density_mod (compute_diagnostic_factors): module must be initialized')
    endif 

    tau = Time%tau 

    if (.not. update_diagnostic_factors) then 
        do k=1,nk
            do j=jsd,jed
               do i=isd,ied                
                  Dens%watermass_factor(i,j,k)      = neutralrho_interval_r*Grd%tmask(i,j,k)
                  Dens%stratification_factor(i,j,k) = Grd%dxt(i,j)*Grd%dyt(i,j)*Thickness%dzt(i,j,k)
                  Dens%rho_dztr_tau(i,j,k)          = Thickness%rho_dztr(i,j,k)
               enddo
            enddo
        enddo
        return 
    endif 

    ! based on thinnest cell in a column, which is typically at k=1 or partial bottom 
    if(smax_min_in_column) then 
        do k=1,nk
           do j=jsd,jed
              do i=isd,ied
                 smax(i,j,k) = Grd%tmask(i,j,k)*min(Thickness%dzt(i,j,k),Thickness%dzt(i,j,1))*dhorz_r(i,j)
              enddo
           enddo
        enddo
    ! straightforward aspect ratio calculation (generally the recommended method)
    else  
        do k=1,nk
           do j=jsd,jed
              do i=isd,ied
                 smax(i,j,k) = Grd%tmask(i,j,k)*Thickness%dzt(i,j,k)*dhorz_r(i,j)
              enddo
           enddo
        enddo
    endif

    ! over-ride the above using a prescribed smax 
    if(smax_diag > 0.0) then  
        do k=1,nk
           do j=jsd,jed
              do i=isd,ied
                 smax(i,j,k) = min(1.0,smax_diag) 
              enddo
           enddo
        enddo
    endif 

    call diagnose_3d(Time, Grd, id_smax_dianeutral, smax(:,:,:))


    ! some initialization 
    do k=1,nk
       do j=jsd,jed
          do i=isd,ied                
             wrk1_v(i,j,k,1) = 0.0
             wrk1_v(i,j,k,2) = 0.0
             wrk2_v(i,j,k,1) = 0.0
             wrk2_v(i,j,k,2) = 0.0
             wrk3_v(i,j,k,1) = 0.0
             wrk3_v(i,j,k,2) = 0.0
             wrk4_v(i,j,k,1) = 0.0
             wrk4_v(i,j,k,2) = 0.0
             wrk1(i,j,k)     = 0.0
             wrk2(i,j,k)     = 0.0
             wrk3(i,j,k)     = 0.0
             Dens%watermass_factor(i,j,k) = neutralrho_interval_r*Grd%tmask(i,j,k)
             wrk4(i,j,k)                  = Grd%tmask(i,j,k)/Thickness%dzwt(i,j,k) 
             Dens%rho_dztr_tau(i,j,k)     = Thickness%rho_dztr(i,j,k)
          enddo
       enddo
    enddo

    ! spatial derivatives of locally referenced potential density  
    do k=1,nk
       kp1 = min(k+1,nk)
       wrk1_v(:,:,k,1) = FDX_T(theta(:,:,k))   *FMX(Grd%tmask(:,:,k))
       wrk1_v(:,:,k,2) = FDX_T(salinity(:,:,k))*FMX(Grd%tmask(:,:,k))
       wrk2_v(:,:,k,1) = FDY_T(theta(:,:,k))   *FMY(Grd%tmask(:,:,k))
       wrk2_v(:,:,k,2) = FDY_T(salinity(:,:,k))*FMY(Grd%tmask(:,:,k))
       do j=jsc,jec
          do i=isc,iec
             wrk3_v(i,j,k,1) = Grd%tmask(i,j,kp1)*wrk4(i,j,k)*(theta(i,j,k)-theta(i,j,kp1))
             wrk3_v(i,j,k,2) = Grd%tmask(i,j,kp1)*wrk4(i,j,k)*(salinity(i,j,k)-salinity(i,j,kp1))
             wrk1(i,j,k)     = abs( Dens%drhodT(i,j,k)*wrk1_v(i,j,k,1) + Dens%drhodS(i,j,k)*wrk1_v(i,j,k,2) )
             wrk2(i,j,k)     = abs( Dens%drhodT(i,j,k)*wrk2_v(i,j,k,1) + Dens%drhodS(i,j,k)*wrk2_v(i,j,k,2) )
             wrk3(i,j,k)     = abs( Dens%drhodT(i,j,k)*wrk3_v(i,j,k,1) + Dens%drhodS(i,j,k)*wrk3_v(i,j,k,2) )
             wrk4_v(i,j,k,2) = sqrt(wrk1(i,j,k)**2 + wrk2(i,j,k)**2 + wrk3(i,j,k)**2) + epsln_drhodz
          enddo
       enddo
    enddo

    ! compute |grad neutral density|
    wrk5(:,:,:) = 0.0 
    wrk6(:,:,:) = 0.0 
    do k=1,nk
       kp1 = min(k+1,nk)
       wrk5(:,:,k) = FDX_T(Dens%neutralrho(:,:,k))*FMX(Grd%tmask(:,:,k))
       wrk6(:,:,k) = FDY_T(Dens%neutralrho(:,:,k))*FMY(Grd%tmask(:,:,k))
       do j=jsc,jec
          do i=isc,iec
             tmp             = Grd%tmask(i,j,kp1)*wrk4(i,j,k)*(Dens%neutralrho(i,j,k)-Dens%neutralrho(i,j,kp1))
             wrk4_v(i,j,k,1) = sqrt(wrk5(i,j,k)**2 + wrk6(i,j,k)**2 + tmp**2)
          enddo
       enddo
    enddo
  
    ! compute watermass factor 
    if(.not. eos_linear .and. grad_nrho_lrpotrho_compute) then
        wrk5(:,:,:) = 0.0 
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 wrk5(i,j,k) = max(grad_nrho_lrpotrho_min, &
                      min(grad_nrho_lrpotrho_max,Grd%tmask(i,j,k)*wrk4_v(i,j,k,1)/wrk4_v(i,j,k,2)))
                 Dens%watermass_factor(i,j,k) = wrk5(i,j,k)*Dens%watermass_factor(i,j,k)
              enddo
           enddo
        enddo
    endif

    call diagnose_3d(Time, Grd, id_grad_nrho, wrk4_v(:,:,:,1))
    call diagnose_3d(Time, Grd, id_grad_lrpotrho, wrk4_v(:,:,:,2))
    call diagnose_3d(Time, Grd, id_grad_nrho_lrpotrho, wrk5(:,:,:))
    call diagnose_3d(Time, Grd, id_watermass_factor, Dens%watermass_factor(:,:,:))


    ! For stratification_factor, move derivatives to centre
    ! of a grid cell through 2-point averaging. 
    call mpp_update_domains (wrk1(:,:,:), Dom%domain2d, complete=.false.)
    call mpp_update_domains (wrk2(:,:,:), Dom%domain2d, complete=.true.)
    wrk4(:,:,:) = 0.0
    wrk5(:,:,:) = 0.0
    wrk6(:,:,:) = 0.0
    do k=1,nk
       kp1 = min(k+1,nk)
       km1 = max(k-1,1)
       do j=jsc,jec
          do i=isc,iec
             active_cells = epsln + Grd%tmask(i-1,j,k) + Grd%tmask(i+1,j,k)
             wrk4(i,j,k)  = Grd%tmask(i,j,k)*(wrk1(i-1,j,k)+wrk1(i,j,k))/active_cells 

             active_cells = epsln + Grd%tmask(i,j-1,k) + Grd%tmask(i,j+1,k)
             wrk5(i,j,k)  = Grd%tmask(i,j,k)*(wrk2(i,j-1,k)+wrk2(i,j,k))/active_cells 

             active_cells = epsln + Grd%tmask(i,j,km1) + Grd%tmask(i,j,kp1)
             wrk6(i,j,k)  = Grd%tmask(i,j,k)*(wrk3(i,j,km1)+wrk3(i,j,k))/active_cells 
          enddo
       enddo
    enddo

    ! smoothing may be useful in some cases
    if(smooth_stratification_factor) then 
       call mpp_update_domains (wrk4(:,:,:), Dom%domain2d, complete=.false.)
       call mpp_update_domains (wrk5(:,:,:), Dom%domain2d, complete=.false.)
       call mpp_update_domains (wrk6(:,:,:), Dom%domain2d, complete=.true.)
       do k=1,nk
          wrk4(:,:,k) = S2D(wrk4(:,:,k))  
          wrk5(:,:,k) = S2D(wrk5(:,:,k))  
          wrk6(:,:,k) = S2D(wrk6(:,:,k))  
       enddo 
    endif 

    ! compute stratification factor. 
    ! Vertical stratification is scaled down by smax in the if-tests 
    ! to account for grid aspect ratio, and/or specific setting for smax_diag.
    wrk1(:,:,:) = 0.0
    do k=1,nk
       do j=jsc,jec
          do i=isc,iec
             if(wrk4(i,j,k) >= wrk5(i,j,k) .and. wrk4(i,j,k) >= smax(i,j,k)*wrk6(i,j,k) .and. wrk4(i,j,k) > 0.0) then 
                Dens%stratification_factor(i,j,k) = Dens%rho(i,j,k,tau)*Grd%dyt(i,j)*Thickness%dzt(i,j,k)/wrk4(i,j,k)
                wrk1(i,j,k) = 1.0
             elseif(wrk5(i,j,k) >= smax(i,j,k)*wrk6(i,j,k) .and. wrk5(i,j,k) >= wrk4(i,j,k) .and. wrk5(i,j,k) > 0.0) then 
                Dens%stratification_factor(i,j,k) = Dens%rho(i,j,k,tau)*Grd%dxt(i,j)*Thickness%dzt(i,j,k)/wrk5(i,j,k)
                wrk1(i,j,k) = 2.0
             elseif(smax(i,j,k)*wrk6(i,j,k) >= wrk4(i,j,k) .and. smax(i,j,k)*wrk6(i,j,k) >= wrk5(i,j,k) .and. wrk6(i,j,k) > 0.0) then 
                Dens%stratification_factor(i,j,k) = Dens%rho(i,j,k,tau)*Grd%dxt(i,j)*Grd%dyt(i,j)/wrk6(i,j,k)
                wrk1(i,j,k) = 3.0
             else
                Dens%stratification_factor(i,j,k) = 0.0
                wrk1(i,j,k) = 0.0
             endif  
          enddo
       enddo
    enddo

    call diagnose_3d(Time, Grd, id_stratification_factor, Dens%stratification_factor(:,:,:))
    call diagnose_3d(TIme, Grd, id_stratification_axis, wrk1(:,:,:))


  end subroutine compute_diagnostic_factors
! </SUBROUTINE> NAME="compute_diagnostic_factors"


!#######################################################################
! <FUNCTION NAME="density_sfc">
!
! <DESCRIPTION>
! Compute density as a function of surface salinity, surface theta, 
! and in situ sea pressure. 
!
! Note that pressure here is 
! sea pressure = absolute pressure - press_standard  (dbars)
! 
! For use in KPP mixed layer scheme 
! </DESCRIPTION>
!
  function density_sfc (salinity, theta, press)

    real, intent(in), dimension(isd:,jsd:,:) :: salinity
    real, intent(in), dimension(isd:,jsd:,:) :: theta
    real, intent(in), dimension(isd:,jsd:,:) :: press

    real, dimension(isd:ied,jsd:jed,nk) :: density_sfc
    real, dimension(isd:ied,jsd:jed,nk) :: pressure 

    integer :: i, j, k
    real    :: t1, t2, s1, sp5, p1, p1t1
    real    :: num, den

    if ( .not. module_is_initialized ) then 
       call mpp_error(FATAL, &
       '==>Error in ocean_density_mod (density_sfc): module must be initialized')
    endif 

    if(density_equal_potrho) then 
       pressure(:,:,:) = Grd%tmask(:,:,:)*potrho_press
    else 
       pressure(:,:,:) = press(:,:,:)
    endif 


    if(eos_linear) then

       do k=1,nk
          do j=jsd,jed
             do i=isd,ied
                density_sfc(i,j,k) = rho0 - alpha_linear_eos*theta(i,j,1) + beta_linear_eos*salinity(i,j,1)
             enddo
          enddo
       enddo

    elseif(eos_preteos10) then 

       do k=1,nk
          do j=jsd,jed
             do i=isd,ied

                t1  = theta(i,j,1)
                t2  = t1*t1

                s1  = salinity(i,j,1)
                sp5 = sqrt(s1) 

                p1   = pressure(i,j,k) - press_standard 
                p1t1 = p1*t1

                num = a0 + t1*(a1 + t1*(a2+a3*t1) )  &
                     + s1*(a4 + a5*t1  + a6*s1)        &
                     + p1*(a7 + a8*t2 + a9*s1 + p1*(a10+a11*t2))

                den = b0 + t1*(b1 + t1*(b2 + t1*(b3 + t1*b4)))      &
                     + s1*(b5 + t1*(b6 + b7*t2) + sp5*(b8 + b9*t2)) &  
                     + p1*(b10 + p1t1*(b11*t2 + b12*p1))

                density_sfc(i,j,k) = num/(epsln + den)

             enddo
          enddo
       enddo

    else ! eos_teos10 

       do k=1,nk
          do j=jsd,jed
             do i=isd,ied

                t1  = theta(i,j,1)
                t2  = t1*t1

                s1  = salinity(i,j,1)
                sp5 = sqrt(s1)

                p1   = pressure(i,j,k) - press_standard
                p1t1 = p1*t1

                num = v01 + t1*(v02 + t1*(v03 + v04*t1))                 &
                       + s1*(v05 + t1*(v06 + v07*t1)                     &
                       + sp5*(v08 + t1*(v09 + t1*(v10 + v11*t1))))       &
                       + p1*(v12 + t1*(v13 + v14*t1) + s1*(v15 + v16*t1) &
                       + p1*(v17 + t1*(v18 + v19*t1) + v20*s1))

                 den =  v21 + t1*(v22 + t1*(v23 + t1*(v24 + v25*t1)))                &
                        + s1*(v26 + t1*(v27 + t1*(v28 + t1*(v29 + v30*t1))) + v36*s1 &
                        + sp5*(v31 + t1*(v32 + t1*(v33 + t1*(v34 + v35*t1)))))       &
                        + p1*(v37 + t1*(v38 + t1*(v39 + v40*t1))                     &
                        +     s1*(v41 + v42*t1)                                      &
                        +     p1*(v43 + t1*(v44 + v45*t1 + v46*s1)                   &
                        +     p1*(v47 + v48*t1)))
                density_sfc(i,j,k) = num/(epsln + den)

             enddo
          enddo
       enddo

    endif

  end function density_sfc
! </FUNCTION> NAME="density_sfc"


!#######################################################################
! <FUNCTION NAME="density_point">
!
! <DESCRIPTION>
! Compute density at a single model grid point. 
!
! Note that pressure here is 
!
! sea pressure = absolute pressure - press_standard  (dbars)
!
! </DESCRIPTION>
!
  function density_point (s1, t1, p1_dbars)

    real, intent(in) :: s1
    real, intent(in) :: t1
    real, intent(in) :: p1_dbars

    real :: t2, sp5, p1, p1t1
    real :: num, den
    real :: density_point
    real :: pressure 

    if ( .not. module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_density_mod (density_point): module must be initialized')
    endif 

    if(density_equal_potrho) then 
       pressure = potrho_press
    else 
       pressure = p1_dbars 
    endif 


    if(eos_linear) then

       density_point = rho0 - alpha_linear_eos*t1 + beta_linear_eos*s1

    elseif(eos_preteos10) then 

       t2  = t1*t1
       sp5 = sqrt(s1) 

       p1   = pressure - press_standard 
       p1t1 = p1*t1

       num = a0 + t1*(a1 + t1*(a2+a3*t1))                   &
            + s1*(a4 + a5*t1  + a6*s1)                      &
            + p1*(a7 + a8*t2 + a9*s1 + p1*(a10+a11*t2))

       den = b0 + t1*(b1 + t1*(b2 + t1*(b3 + t1*b4 )))      &
            + s1*(b5 + t1*(b6 + b7*t2) + sp5*(b8 + b9*t2))  &  
            + p1*(b10 + p1t1*(b11*t2 + b12*p1))

       density_point = num/(epsln+den)


    else ! eos_teos10 

       t2  = t1*t1
       sp5 = sqrt(s1) 

       p1   = pressure - press_standard
       p1t1 = p1*t1

       num = v01 + t1*(v02 + t1*(v03 + v04*t1))                &
             + s1*(v05 + t1*(v06 + v07*t1)                     &
             + sp5*(v08 + t1*(v09 + t1*(v10 + v11*t1))))       &
             + p1*(v12 + t1*(v13 + v14*t1) + s1*(v15 + v16*t1) &
             + p1*(v17 + t1*(v18 + v19*t1) + v20*s1))

       den =  v21 + t1*(v22 + t1*(v23 + t1*(v24 + v25*t1)))                &
              + s1*(v26 + t1*(v27 + t1*(v28 + t1*(v29 + v30*t1))) + v36*s1 &
              + sp5*(v31 + t1*(v32 + t1*(v33 + t1*(v34 + v35*t1)))))       &
              + p1*(v37 + t1*(v38 + t1*(v39 + v40*t1))                     &
              +     s1*(v41 + v42*t1)                                      &
              +     p1*(v43 + t1*(v44 + v45*t1 + v46*s1)                   &
              +     p1*(v47 + v48*t1)))


       density_point = num/(epsln+den)


    endif

  end function density_point
! </FUNCTION> NAME="density_point"


!#######################################################################
! <SUBROUTINE NAME="density_derivs_field">
!
! <DESCRIPTION>
! Compute partial derivative of density with respect to 
! temperature and with respect to salinity.  Hold pressure constant.  
!
! Pressure here is 
!
! sea pressure = absolute press - press_standard (dbars)
!
! </DESCRIPTION>
!
  subroutine density_derivs_field (rho, salinity, theta, press, Time, &
             density_theta, density_salinity, density_press)

    type(ocean_time_type),        intent(in)    :: Time
    real, dimension(isd:,jsd:,:), intent(in)    :: rho
    real, dimension(isd:,jsd:,:), intent(in)    :: salinity
    real, dimension(isd:,jsd:,:), intent(in)    :: theta
    real, dimension(isd:,jsd:,:), intent(in)    :: press
    real, dimension(isd:,jsd:,:), intent(inout) :: density_theta
    real, dimension(isd:,jsd:,:), intent(inout) :: density_salinity
    real, dimension(isd:,jsd:,:), intent(inout) :: density_press
    real, dimension(isd:ied,jsd:jed,nk)         :: pressure 

    integer :: i, j, k
    real :: t1, t2, s1, sp5, p1, p1t1
    real :: dnum_dtheta,    dden_dtheta 
    real :: dnum_dsalinity, dden_dsalinity
    real :: dnum_dpress, dden_dpress

    if ( .not. module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_density_mod (density_derivs_field): module must be initialized')
    endif 

    if(density_equal_potrho) then 
       pressure(:,:,:) = Grd%tmask(:,:,:)*potrho_press
    else 
       pressure(:,:,:) = press(:,:,:)
    endif 

    if(eos_linear) then

        do k=1,nk
           do j=jsd,jed
              do i=isd,ied
                 density_theta(i,j,k)    = -alpha_linear_eos
                 density_salinity(i,j,k) =  beta_linear_eos
                 density_press(i,j,k)    =  0.0
              enddo
           enddo
        enddo

    elseif(eos_preteos10) then  

        do k=1,nk
           do j=jsd,jed
              do i=isd,ied

                 t1  = theta(i,j,k)
                 t2  = t1*t1
                 s1  = salinity(i,j,k)
                 sp5 = sqrt(s1) 

                 p1   = pressure(i,j,k) - press_standard 
                 p1t1 = p1*t1

                 dnum_dtheta = a1 + t1*(two_a2 + three_a3*t1) &
                      + a5*s1                                 &
                      + p1t1*(two_a8 + two_a11*p1)    
                 dden_dtheta = b1 + t1*(two_b2 + t1*(three_b3 + four_b4*t1)) &
                      + s1*(b6 + t1*(three_b7*t1 + two_b9*sp5))              &
                      + p1*p1*(three_b11*t2 + b12*p1)

                 dnum_dsalinity = a4 + a5*t1 + two_a6*s1 + a9*p1
                 dden_dsalinity = b5 + t1*(b6 + b7*t2) + sp5*(onep5_b8 + onep5_b9*t2)

                 dnum_dpress = a7 + a9*s1 + two_a10*p1 + t2*(a8 + two_a11*p1)
                 dden_dpress = b10 + p1*t1*(two_b11*t2 + three_b12*p1) 

                 density_theta(i,j,k)    = denominator_r(i,j,k)*(dnum_dtheta    - rho(i,j,k)*dden_dtheta)
                 density_salinity(i,j,k) = denominator_r(i,j,k)*(dnum_dsalinity - rho(i,j,k)*dden_dsalinity)
                 density_press(i,j,k)    = denominator_r(i,j,k)*(dnum_dpress    - rho(i,j,k)*dden_dpress)

              enddo
           enddo
        enddo

    else  ! eos_teos10 

        do k=1,nk
           do j=jsd,jed
              do i=isd,ied

                 t1  = theta(i,j,k)
                 t2  = t1*t1
                 s1  = salinity(i,j,k)
                 sp5 = sqrt(s1)

                 p1   = pressure(i,j,k) - press_standard
                 p1t1 = p1*t1

                 dnum_dtheta = v02 + t1*(two_v03 + three_v04*t1)     &
                      + s1*((v06+two_v07*t1)                         &
                      +     sp5*(v09 + t1*(two_v10 + three_v11*t1))) &
                      + p1*((v13 + two_v14*t1) + s1*v16              &
                      +     p1*(v18+two_v19*t1))

                 dden_dtheta = v22 + t1*(two_v23 +t1*(three_v24+four_v25*t1))      &
                      + s1*(v27 + t1*(two_v28 + t1*(three_v29  + four_v30*t1))     &
                      +     sp5*(v32+t1*(two_v33 + t1*(three_v34 + four_v35*t1)))) &
                      + p1*((v38 + t1*(two_v39 + three_v40*t1))                    &
                      +     s1*v42                                                 &
                      +     p1*((v44 + two_v45*t1 + v46*s1)                        &
                      +     p1*v48))

                 dnum_dsalinity =                                    &
                      + (v05 + t1*(v06 + v07*t1)                     &
                      + 1.5*sp5*(v08 + t1*(v09 + t1*(v10 + v11*t1))))&
                      + p1*((v15 + v16*t1) &
                      +      p1*v20)

                 dden_dsalinity =                                                 &
                      (v26 + t1*(v27 + t1*(v28 + t1*(v29 + v30*t1))) + two_v36*s1 &
                      + 1.5*sp5*(v31 + t1*(v32 + t1*(v33 + t1*(v34 + v35*t1)))))  &
                      + p1*( v41 + v42*t1 + p1*t1*v46 )

                 dnum_dpress = v12 + t1*(v13 + v14*t1) + s1*(v15 + v16*t1)    &
                      + p1*(two_v17 + t1*(two_v18 + two_v19*t1) + two_v20*s1) 
                 dden_dpress = (v37 + t1*(v38 + t1*(v39 + v40*t1))            &
                      + s1*(v41 + v42*t1)                                     &
                      + p1*(two_v43 + t1*(two_v44 + two_v45*t1 + two_v46*s1)  &
                      + p1*(three_v47 + three_v48*t1)))

                 density_theta(i,j,k)    = denominator_r(i,j,k)*(dnum_dtheta    - rho(i,j,k)*dden_dtheta)
                 density_salinity(i,j,k) = denominator_r(i,j,k)*(dnum_dsalinity - rho(i,j,k)*dden_dsalinity)
                 density_press(i,j,k)    = denominator_r(i,j,k)*(dnum_dpress    - rho(i,j,k)*dden_dpress)*c2dbars

              enddo
           enddo
        enddo

    endif

    call diagnose_3d(TIme, Grd, id_drhodtheta, density_theta(:,:,:))
    call diagnose_3d(Time, Grd, id_drhodsalt, density_salinity(:,:,:))
    call diagnose_3d(Time, Grd, id_drhodpress, density_press(:,:,:))
    if (id_sound_speed2 > 0) then 
        wrk1(:,:,:) = 0.0  
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 if(density_press(i,j,k) /= 0.0) then 
                     wrk1(i,j,k) = 1.0/(c2dbars*density_press(i,j,k))
                 endif
              enddo
           enddo
        enddo
        call diagnose_3d(Time, Grd, id_sound_speed2, wrk1(:,:,:))
    endif
    if(id_thermal_expand > 0) then 
        wrk1(:,:,:) = 0.0  
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 wrk1(i,j,k) = -Grd%tmask(i,j,k)*density_theta(i,j,k)/(epsln+rho(i,j,k))
              enddo
           enddo
        enddo
        call diagnose_3d(Time, Grd, id_thermal_expand, wrk1(:,:,:))
    endif 
    if(id_haline_contract > 0) then 
        wrk1(:,:,:) = 0.0  
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 wrk1(i,j,k) = Grd%tmask(i,j,k)*density_salinity(i,j,k)/(epsln+rho(i,j,k))
              enddo
           enddo
        enddo
        call diagnose_3d(Time, Grd, id_haline_contract, wrk1(:,:,:))
    endif 


  end subroutine density_derivs_field
! </SUBROUTINE> NAME="density_derivs_field"

!#######################################################################
! <SUBROUTINE NAME="density_derivs_pothro">
!
! <DESCRIPTION>
! Compute partial derivative of density with respect to
! temperature and with respect to salinity.  Use potrho_press
! reference depth for potential density rather than neutral.
!
! These coefficients are useful for certain diagnostics, such as APE
! calculations.
!
! The algorithm is identical to density_derivs_field, only here we set
! the pressure to a constant reference pressure value, potrho_press.
!
! Pressure here is
! sea pressure = absolute press - press_standard (dbars)
!
! </DESCRIPTION>
!
  subroutine density_derivs_potrho (Time, rho, salinity, theta, &
             density_theta, density_salinity, density_press)

    type(ocean_time_type),        intent(in)    :: Time
    real, dimension(isd:,jsd:,:), intent(in)    :: rho
    real, dimension(isd:,jsd:,:), intent(in)    :: salinity
    real, dimension(isd:,jsd:,:), intent(in)    :: theta
    real, dimension(isd:,jsd:,:), intent(inout) :: density_theta
    real, dimension(isd:,jsd:,:), intent(inout) :: density_salinity
    real, dimension(isd:,jsd:,:), intent(inout) :: density_press
    real, dimension(isd:ied,jsd:jed,nk)         :: pressure

    integer :: i, j, k
    real :: t1, t2, s1, sp5, p1, p1t1
    real :: dnum_dtheta,    dden_dtheta
    real :: dnum_dsalinity, dden_dsalinity
    real :: dnum_dpress, dden_dpress

    if ( .not. module_is_initialized ) then
      call mpp_error(FATAL, &
      '==>Error in ocean_density_mod (density_derivs_field): module must be initialized')
    endif

    pressure(:,:,:) = Grd%tmask(:,:,:)*potrho_press

    if(eos_linear) then

        do k=1,nk
           do j=jsd,jed
              do i=isd,ied
                 density_theta(i,j,k)    = -alpha_linear_eos
                 density_salinity(i,j,k) =  beta_linear_eos
                 density_press(i,j,k)    =  0.0
              enddo
           enddo
        enddo

    elseif(eos_preteos10) then

        do k=1,nk
           do j=jsd,jed
              do i=isd,ied

                 t1  = theta(i,j,k)
                 t2  = t1*t1
                 s1  = salinity(i,j,k)
                 sp5 = sqrt(s1)

                 p1   = pressure(i,j,k) - press_standard
                 p1t1 = p1*t1

                 dnum_dtheta = a1 + t1*(two_a2 + three_a3*t1) &
                      + a5*s1                                 &
                      + p1t1*(two_a8 + two_a11*p1)
                 dden_dtheta = b1 + t1*(two_b2 + t1*(three_b3 + four_b4*t1)) &
                      + s1*(b6 + t1*(three_b7*t1 + two_b9*sp5))              &
                      + p1*p1*(three_b11*t2 + b12*p1)

                 dnum_dsalinity = a4 + a5*t1 + two_a6*s1 + a9*p1
                 dden_dsalinity = b5 + t1*(b6 + b7*t2) + sp5*(onep5_b8 + onep5_b9*t2)

                 dnum_dpress = a7 + a9*s1 + two_a10*p1 + t2*(a8 + two_a11*p1)
                 dden_dpress = b10 + p1*t1*(two_b11*t2 + three_b12*p1)

                 density_theta(i,j,k)    = denominator_r(i,j,k)*(dnum_dtheta    - rho(i,j,k)*dden_dtheta)
                 density_salinity(i,j,k) = denominator_r(i,j,k)*(dnum_dsalinity - rho(i,j,k)*dden_dsalinity)
                 density_press(i,j,k)    = denominator_r(i,j,k)*(dnum_dpress    - rho(i,j,k)*dden_dpress)

              enddo
           enddo
        enddo

    else  ! eos_teos10

        do k=1,nk
           do j=jsd,jed
              do i=isd,ied

                 t1  = theta(i,j,k)
                 t2  = t1*t1
                 s1  = salinity(i,j,k)
                 sp5 = sqrt(s1)

                 p1   = pressure(i,j,k) - press_standard
                 p1t1 = p1*t1

                 dnum_dtheta = v02 + t1*(two_v03 + three_v04*t1)     &
                      + s1*((v06+two_v07*t1)                         &
                      +     sp5*(v09 + t1*(two_v10 + three_v11*t1))) &
                      + p1*((v13 + two_v14*t1) + s1*v16              &
                      +     p1*(v18+two_v19*t1))

                 dden_dtheta = v22 + t1*(two_v23 +t1*(three_v24+four_v25*t1))       &
                      + s1*(v27 + t1*(two_v28 + t1*(three_v29  + four_v30*t1))      &
                      +     sp5*(v32+t1*(two_v33 + t1*(three_v34 +four_v35*t1))))   &
                      + p1*((v38 + t1*(two_v39 + three_v40*t1))                     &
                      +     s1*v42                                                  &
                      +     p1*((v44 + two_v45*t1 + v46*s1)                         &
                      +     p1*v48))

                 dnum_dsalinity =                                    &
                      + (v05 + t1*(v06 + v07*t1)                     &
                      + 1.5*sp5*(v08 + t1*(v09 + t1*(v10 + v11*t1))))&
                      + p1*((v15 + v16*t1) &
                      +      p1*v20)

                 dden_dsalinity =                                                 &
                      (v26 + t1*(v27 + t1*(v28 + t1*(v29 + v30*t1))) + two_v36*s1 &
                      + 1.5*sp5*(v31 + t1*(v32 + t1*(v33 + t1*(v34 + v35*t1)))))  &
                      + p1*( v41 + v42*t1 + p1*t1*v46 )

                 dnum_dpress = v12 + t1*(v13 + v14*t1) + s1*(v15 + v16*t1)    &
                      + p1*(two_v17 + t1*(two_v18 + two_v19*t1) + two_v20*s1)
                 dden_dpress = (v37 + t1*(v38 + t1*(v39 + v40*t1))            &
                      + s1*(v41 + v42*t1)                                     &
                      + p1*(two_v43 + t1*(two_v44 + two_v45*t1 + two_v46*s1)  &
                      + p1*(three_v47 + three_v48*t1)))

                 density_theta(i,j,k)    = denominator_r(i,j,k)*(dnum_dtheta    - rho(i,j,k)*dden_dtheta)
                 density_salinity(i,j,k) = denominator_r(i,j,k)*(dnum_dsalinity - rho(i,j,k)*dden_dsalinity)
                 density_press(i,j,k)    = denominator_r(i,j,k)*(dnum_dpress    - rho(i,j,k)*dden_dpress)*c2dbars

              enddo
           enddo
        enddo

    endif

    call diagnose_3d(Time, Grd, id_dpotrhodtheta, density_theta(:,:,:))
    call diagnose_3d(Time, Grd, id_dpotrhodsalt, density_salinity(:,:,:))
    call diagnose_3d(Time, Grd, id_dpotrhodpress, density_press(:,:,:))

  end subroutine density_derivs_potrho
! </SUBROUTINE> NAME="density_derivs_potrho"


!#######################################################################
! <SUBROUTINE NAME="density_derivs_level">
!
! <DESCRIPTION>
! Compute partial derivative of density with respect to 
! temperature and with respect to salinity.  Hold pressure constant.  
!
! Pressure here is sea pressure = absolute press - press_standard
!
! </DESCRIPTION>
!
  subroutine density_derivs_level (rho, salinity, theta, press, Time, klevel, &
                                   density_theta, density_salinity, density_press)

    type(ocean_time_type),      intent(in)    :: Time
    real, dimension(isd:,jsd:), intent(in)    :: rho
    real, dimension(isd:,jsd:), intent(in)    :: salinity
    real, dimension(isd:,jsd:), intent(in)    :: theta
    real, dimension(isd:,jsd:), intent(in)    :: press
    integer,                    intent(in)    :: klevel 
    real, dimension(isd:,jsd:), intent(inout) :: density_theta
    real, dimension(isd:,jsd:), intent(inout) :: density_salinity
    real, dimension(isd:,jsd:), intent(inout) :: density_press
    real, dimension(isd:ied,jsd:jed)          :: pressure 

    integer :: i, j
    real :: t1, t2, s1, sp5, p1, p1t1
    real :: dnum_dtheta,    dden_dtheta 
    real :: dnum_dsalinity, dden_dsalinity
    real :: dnum_dpress, dden_dpress

    if ( .not. module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_density_mod (density_derivs_level): module must be initialized')
    endif 

    if(density_equal_potrho) then 
       pressure(:,:) = Grd%tmask(:,:,1)*potrho_press
    else 
       pressure(:,:) = press(:,:)
    endif 

    if(eos_linear) then

        do j=jsd,jed
           do i=isd,ied
              density_theta(i,j)    = -alpha_linear_eos 
              density_salinity(i,j) =  beta_linear_eos
              density_press(i,j)    =  0.0
           enddo
        enddo

    elseif(eos_preteos10) then 

        do j=jsd,jed
           do i=isd,ied


              t1  = theta(i,j)
              t2  = t1*t1
              s1  = salinity(i,j)
              sp5 = sqrt(s1) 

              p1   = pressure(i,j) - press_standard 
              p1t1 = p1*t1

              dnum_dtheta = a1 + t1*(two_a2 + three_a3*t1) &
                   + a5*s1                                 &
                   + p1t1*(two_a8 + two_a11*p1)    
              dden_dtheta = b1 + t1*(two_b2 + t1*(three_b3 + four_b4*t1)) &
                   + s1*(b6 + t1*(three_b7*t1 + two_b9*sp5))              &
                   + p1*p1*(three_b11*t2 + b12*p1)

              dnum_dsalinity = a4 + a5*t1 + two_a6*s1 + a9*p1
              dden_dsalinity = b5 + t1*(b6 + b7*t2) + sp5*(onep5_b8 + onep5_b9*t2)

              dnum_dpress = a7 + a9*s1 + two_a10*p1 + t2*(a8 + two_a11*p1)
              dden_dpress = b10 + p1*t1*(two_b11*t2 + three_b12*p1) 

              density_theta(i,j)    = denominator_r(i,j,klevel)*(dnum_dtheta    - rho(i,j)*dden_dtheta)
              density_salinity(i,j) = denominator_r(i,j,klevel)*(dnum_dsalinity - rho(i,j)*dden_dsalinity)
              density_press(i,j)    = denominator_r(i,j,klevel)*(dnum_dpress    - rho(i,j)*dden_dpress)

           enddo
        enddo

    else ! eos_teos10 

        t1  = theta(i,j)
        t2  = t1*t1
        s1  = salinity(i,j)
        sp5 = sqrt(s1) 

        p1   = pressure(i,j) - press_standard 
        p1t1 = p1*t1

        dnum_dtheta = v02 + t1*(two_v03 + three_v04*t1)     &
             + s1*((v06+two_v07*t1)                         &
             +     sp5*(v09 + t1*(two_v10 + three_v11*t1))) &
             + p1*((v13 + two_v14*t1) + s1*v16              &
             +     p1*(v18+two_v19*t1))

        dden_dtheta = v22 + t1*(two_v23 +t1*(three_v24+four_v25*t1))      &
             + s1*(v27 + t1*(two_v28 + t1*(three_v29  + four_v30*t1))     &
             +     sp5*(v32+t1*(two_v33 + t1*(three_v34 + four_v35*t1)))) &
             + p1*((v38 + t1*(two_v39 + three_v40*t1))                    &
             +     s1*v42                                                 &
             +     p1*((v44 + two_v45*t1 + v46*s1)                        &
             +     p1*(v48)))

        dnum_dsalinity =                                     &
             + (v05 + t1*(v06 + v07*t1)                      &
             + 1.5*sp5*(v08 + t1*(v09 + t1*(v10 + v11*t1)))) &
             + p1*((v15 + v16*t1)                            &
             +      p1*(v20))

        dden_dsalinity =                                                 &
             (v26 + t1*(v27 + t1*(v28 + t1*(v29 + v30*t1))) + two_v36*s1 &
             + 1.5*sp5*(v31 + t1*(v32 + t1*(v33 + t1*(v34 + v35*t1)))))  &
             + p1*( v41 + v42*t1 + p1*t1*v46 )

        dnum_dpress = v12 + t1*(v13 + v14*t1) + s1*(v15 + v16*t1) &
             + 2.0*p1*(v17 + t1*(v18 + v19*t1) + v20*s1)
        dden_dpress = (v37 + t1*(v38 + t1*(v39 + v40*t1)) &
             + s1*(v41 + v42*t1)                          &
             + 2.*p1*(v43 + t1*(v44 + v45*t1 + v46*s1)    &
             + 1.5*p1*(v47 + v48*t1)))

        density_theta(i,j)    = denominator_r(i,j,klevel)*(dnum_dtheta    - rho(i,j)*dden_dtheta)
        density_salinity(i,j) = denominator_r(i,j,klevel)*(dnum_dsalinity - rho(i,j)*dden_dsalinity)
        density_press(i,j)    = denominator_r(i,j,klevel)*(dnum_dpress    - rho(i,j)*dden_dpress)


    endif   ! endif for eos choice


  end subroutine density_derivs_level
! </SUBROUTINE> NAME="density_derivs_level"


!#######################################################################
! <SUBROUTINE NAME="density_derivs_point">
!
! <DESCRIPTION>
! Compute partial derivative of density with respect to
! temperature and with respect to salinity.  Do so here for a point. 
!
! Pressure here is 
!
! sea pressure = absolute pressure - press_standard  (dbars)
!
! </DESCRIPTION>
!
  subroutine density_derivs_point (rho, salinity, theta, press,&
                                   density_theta, density_salinity, density_press)

    real, intent(in)    :: rho
    real, intent(in)    :: salinity
    real, intent(in)    :: theta
    real, intent(in)    :: press
    real, intent(out)   :: density_theta
    real, intent(out)   :: density_salinity
    real, intent(out)   :: density_press

    real :: t1, t2, s1, sp5, p1, p1t1
    real :: dnum_dtheta,    dden_dtheta 
    real :: dnum_dsalinity, dden_dsalinity
    real :: dnum_dpress, dden_dpress
    real :: denominator_point, denrecip
    real :: pressure 

    if ( .not. module_is_initialized ) then 
       call mpp_error(FATAL, &
       '==>Error in ocean_density_mod (density_derivs_point): module must be initialized')
    endif 

    if(density_equal_potrho) then 
       pressure = potrho_press
    else
       pressure = press
    endif 


    if(eos_linear) then

        density_theta    = -alpha_linear_eos 
        density_salinity =  beta_linear_eos
        density_press    =  0.0

    elseif(eos_preteos10) then 

        t1  = theta
        t2  = t1*t1
        s1  = salinity
        sp5 = sqrt(s1) 

        p1   = pressure - press_standard 
        p1t1 = p1*t1

        denominator_point = b0 + t1*(b1 + t1*(b2 + t1*(b3 + t1*b4 ))) &
             + s1*(b5 + t1*(b6 + b7*t2) + sp5*(b8 + b9*t2))           &  
             + p1*(b10 + p1t1*(b11*t2 + b12*p1))

        denrecip = 1.0/(denominator_point + epsln)

        dnum_dtheta = a1 + t1*(2.0*a2 + 3.0*a3*t1) &
             + a5*s1                               &
             + 2.0*p1t1*(a8 + a11*p1)    
        dden_dtheta = b1 + t1*(2.0*b2 + t1*(3.0*b3 + 4.0*b4*t1)) &
             + s1*(b6 + t1*(3.0*b7*t1 + 2.0*b9*sp5))             &
             + p1*p1*(3.0*b11*t2 + b12*p1)

        dnum_dsalinity = a4 + a5*t1 + two_a6*s1 + a9*p1
        dden_dsalinity = b5 + t1*(b6 + b7*t2) + sp5*(onep5_b8 + onep5_b9*t2)

        dnum_dpress = a7 + a9*s1 + two_a10*p1 + t2*(a8 + two_a11*p1)
        dden_dpress = b10 + p1*t1*(two_b11*t2 + three_b12*p1) 

        density_theta    = denrecip*(dnum_dtheta    - rho*dden_dtheta)
        density_salinity = denrecip*(dnum_dsalinity - rho*dden_dsalinity)
        density_press    = denrecip*(dnum_dpress    - rho*dden_dpress)


    else  ! eos_teos10 

        t1  = theta
        t2  = t1*t1
        s1  = salinity
        sp5 = sqrt(s1) 

        p1   = pressure - press_standard 
        p1t1 = p1*t1

        denominator_point =  v21 + t1*(v22 + t1*(v23 + t1*(v24 + v25*t1)))&
             + s1*(v26 + t1*(v27 + t1*(v28 + t1*(v29 + v30*t1))) + v36*s1 &
             + sp5*(v31 + t1*(v32 + t1*(v33 + t1*(v34 + v35*t1)))))       &
             + p1*(v37 + t1*(v38 + t1*(v39 + v40*t1))                     &
             +     s1*(v41 + v42*t1)                                      &
             +     p1*(v43 + t1*(v44 + v45*t1 + v46*s1)                   &
             +     p1*(v47 + v48*t1)))
        denrecip = 1./(denominator_point + epsln )

        dnum_dtheta = v02 + t1*(two_v03 + three_v04*t1)     &
             + s1*(v06+two_v07*t1                           &
             +     sp5*(v09 + t1*(two_v10 + three_v11*t1))) &
             + p1*((v13 + two_v14*t1) + s1*v16              &
             +     p1*(v18+two_v19*t1))

        dden_dtheta = v22 + t1*(two_v23 +t1*(three_v24+four_v25*t1))      &
             + s1*     (v27+t1*(two_v28 + t1*(three_v29 + four_v30*t1))   &
             +     sp5*(v32+t1*(two_v33 + t1*(three_v34 + four_v35*t1)))) &
             + p1*(v38 + t1*(two_v39 + three_v40*t1)+  s1*v42             &
             +     p1*(v44 + two_v45*t1 + v46*s1                          &
             +     p1*v48))

        dnum_dsalinity =                                    &
             + (v05 + t1*(v06 + v07*t1)                     &
             + 1.5*sp5*(v08 + t1*(v09 + t1*(v10 + v11*t1))))&
             + p1*((v15 + v16*t1) &
             +      p1*(v20))

        dden_dsalinity =                                                 &
             (v26 + t1*(v27 + t1*(v28 + t1*(v29 + v30*t1))) + two_v36*s1 &
             + 1.5*sp5*(v31 + t1*(v32 + t1*(v33 + t1*(v34 + v35*t1)))))  &
             + p1*( v41 + v42*t1 + p1*t1*v46 )

        dnum_dpress = v12 + t1*(v13 + v14*t1) + s1*(v15 + v16*t1) &
             + 2.0*p1*(v17 + t1*(v18 + v19*t1) + v20*s1)
        dden_dpress = (v37 + t1*(v38 + t1*(v39 + v40*t1)) &
             + s1*(v41 + v42*t1)                          &
             + 2.*p1*(v43 + t1*(v44 + v45*t1 + v46*s1)    &
             + 1.5*p1*(v47 + v48*t1)))
        density_theta    = denrecip*(dnum_dtheta    - rho*dden_dtheta)
        density_salinity = denrecip*(dnum_dsalinity - rho*dden_dsalinity)
        density_press    = denrecip*(dnum_dpress    - rho*dden_dpress)

    endif   ! endif for eos choice 


  end subroutine density_derivs_point
! </SUBROUTINE> NAME="density_derivs_point"



!#######################################################################
! <SUBROUTINE NAME="cabbeling_thermobaricity">
!
! <DESCRIPTION>
! Diagnostic sends for cabbeling and thermobaricity parameters.
!
! Pressure here is 
! sea pressure = absolute press - press_standard (dbars)
!
! </DESCRIPTION>
!
  subroutine cabbeling_thermobaricity(rho, salinity, theta, press, Time, &
             density_theta, density_salinity, density_press)

    real, dimension(isd:,jsd:,:), intent(in) :: rho
    real, dimension(isd:,jsd:,:), intent(in) :: salinity
    real, dimension(isd:,jsd:,:), intent(in) :: theta
    real, dimension(isd:,jsd:,:), intent(in) :: press
    type(ocean_time_type),        intent(in) :: Time
    real, dimension(isd:,jsd:,:), intent(in) :: density_theta
    real, dimension(isd:,jsd:,:), intent(in) :: density_salinity
    real, dimension(isd:,jsd:,:), intent(in) :: density_press

    real, dimension(isd:ied,jsd:jed,nk) :: cabbeling_param
    real, dimension(isd:ied,jsd:jed,nk) :: thermobaric_param
    real, dimension(isd:ied,jsd:jed,nk) :: pressure 


    if ( .not. module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_density_mod (cabbeling_thermobaricity): module must be initialized')
    endif 

    if(density_equal_potrho) then 
       pressure(:,:,:) = Grd%tmask(:,:,:)*potrho_press
    else 
       pressure(:,:,:) = press(:,:,:)
    endif 

    call calc_cabbeling_thermobaricity(rho, salinity, theta, pressure, &
    density_theta, density_salinity, density_press, cabbeling_param, thermobaric_param)

    call diagnose_3d(Time, Grd, id_cabbeling, cabbeling_param(:,:,:))
    call diagnose_3d(Time, Grd, id_thermobaricity, thermobaric_param(:,:,:))


  end subroutine cabbeling_thermobaricity
! </SUBROUTINE> NAME="cabbeling_thermobaricity"


!#######################################################################
! <SUBROUTINE NAME="calc_cabbeling_thermobaricity">
!
! <DESCRIPTION>
! Compute cabbeling and thermobaricity parameters, as defined in 
! McDougall (1987).
!
! Pressure here is 
! sea pressure = absolute press - press_standard (dbars)
!
! </DESCRIPTION>
!
  subroutine calc_cabbeling_thermobaricity(rho, salinity, theta, press, &
             density_theta, density_salinity, density_press, cabbeling_param, thermobaric_param)

    real, dimension(isd:,jsd:,:), intent(in)    :: rho
    real, dimension(isd:,jsd:,:), intent(in)    :: salinity
    real, dimension(isd:,jsd:,:), intent(in)    :: theta
    real, dimension(isd:,jsd:,:), intent(in)    :: press
    real, dimension(isd:,jsd:,:), intent(in)    :: density_theta
    real, dimension(isd:,jsd:,:), intent(in)    :: density_salinity
    real, dimension(isd:,jsd:,:), intent(in)    :: density_press
    real, dimension(isd:,jsd:,:), intent(inout) :: cabbeling_param
    real, dimension(isd:,jsd:,:), intent(inout) :: thermobaric_param

    integer :: i, j, k
    real :: t1, t2, s1, sp5, spm5, p1, p2, p1t1

    real :: rhotheta_rhosalinity
    real :: rho_inv
    real :: d2rho_dtheta2, d2rho_dsalin2, d2rho_dsalin_dtheta
    real :: d2rho_dsalin_dpress, d2rho_dtheta_dpress

    real :: dden_dtheta, dden_dsalinity, dden_dpress

    real :: d2num_dtheta2, d2num_dsalin2, d2num_dtheta_dsalin
    real :: d2num_dsalin_dpress, d2num_dtheta_dpress
    real :: d2den_dtheta2, d2den_dsalin2, d2den_dsalin_dtheta 
    real :: d2den_dsalin_dpress, d2den_dtheta_dpress

    if ( .not. module_is_initialized ) then 
      call mpp_error(FATAL, &
      '==>Error in ocean_density_mod (calc_cabbeling_thermobaricity): module must be initialized')
    endif 

    ! zero initialization, and values for when eos_linear is used
    cabbeling_param(:,:,:)   = 0.0   ! cabbeling parameter 
    thermobaric_param(:,:,:) = 0.0   ! thermobaricity parameter 

    if(eos_preteos10) then

       do k=1,nk
          do j=jsd,jed
             do i=isd,ied

                t1   = theta(i,j,k)
                t2   = t1*t1
                s1   = salinity(i,j,k)
                sp5  = sqrt(s1) 
                p1   = press(i,j,k) - press_standard 
                p2   = p1*p1
                p1t1 = p1*t1

                if(s1 > 0.0) then 
                   spm5 = 1.0/sp5
                else 
                   spm5 = 0.0
                endif
                rhotheta_rhosalinity = Grd%tmask(i,j,k)*density_theta(i,j,k)/(epsln+density_salinity(i,j,k))

                dden_dtheta = b1 + t1*(two_b2 + t1*(three_b3 + four_b4*t1)) &
                     + s1*(b6 + t1*(three_b7*t1 + two_b9*sp5))              &
                     + p1*p1*(three_b11*t2 + b12*p1)
                dden_dsalinity = b5 + t1*(b6 + b7*t2) + sp5*(onep5_b8 + onep5_b9*t2)
                dden_dpress = b10 + p1*t1*(two_b11*t2 + three_b12*p1) 

                d2num_dtheta2 = two_a2 + six_a3*t1 + two_a8*p1 + two_a11*p2
                d2num_dsalin2 = two_a6
                d2num_dtheta_dsalin = a5
                d2num_dsalin_dpress = a9
                d2num_dtheta_dpress = two_a8*t1 + four_a11*p1*t1

                d2den_dtheta2 = two_b2 + six_b3*t1 + twelve_b4*t2  &
                              + six_b7*s1*t1 + two_b9*s1*sp5 + six_b11*p2*t1
                d2den_dsalin2 = .75*spm5*(b8 + b9*t2)
                d2den_dsalin_dtheta = b6 + three_b7*t2 + three_b9*sp5*t1
                d2den_dsalin_dpress = 0.0
                d2den_dtheta_dpress = six_b11*p1*t2 + three_b12*p2

                d2rho_dtheta2 = denominator_r(i,j,k) &
                 *(d2num_dtheta2-2.0*density_theta(i,j,k)*dden_dtheta-rho(i,j,k)*d2den_dtheta2)

                d2rho_dsalin2 = denominator_r(i,j,k) &
                 *(d2num_dsalin2-2.0*density_salinity(i,j,k)*dden_dsalinity-rho(i,j,k)*d2den_dsalin2)

                d2rho_dsalin_dtheta = denominator_r(i,j,k)  &
                 *( d2num_dtheta_dsalin                     &
                   -density_salinity(i,j,k)*dden_dtheta     &
                   -density_theta(i,j,k)*dden_dsalinity     &
                   -rho(i,j,k)*d2den_dsalin_dtheta)

                d2rho_dsalin_dpress = denominator_r(i,j,k)  &
                 *( d2den_dsalin_dpress                     &
                   -density_press(i,j,k)*dden_dsalinity     &
                   -density_salinity(i,j,k)*dden_dpress     &
                   -rho(i,j,k)*d2den_dsalin_dpress)

                d2rho_dtheta_dpress = denominator_r(i,j,k)  &
                 *( d2den_dtheta_dpress                     &
                   -density_press(i,j,k)*dden_dtheta        &
                   -density_theta(i,j,k)*dden_dpress        &
                   -rho(i,j,k)*d2den_dtheta_dpress)
 
                rho_inv = Grd%tmask(i,j,k)/(rho(i,j,k) + epsln)

                cabbeling_param(i,j,k) = -rho_inv*               &
                  ( d2rho_dtheta2                                &
                   -2.0*d2rho_dsalin_dtheta*rhotheta_rhosalinity &
                   +d2rho_dsalin2*rhotheta_rhosalinity**2 )
                   
                thermobaric_param(i,j,k) = -rho_inv*(d2rho_dtheta_dpress-d2rho_dsalin_dpress*rhotheta_rhosalinity)

             enddo
          enddo
       enddo

    elseif(eos_teos10) then 

      do k=1,nk
          do j=jsd,jed
             do i=isd,ied

                t1   = theta(i,j,k)
                t2   = t1*t1
                s1   = salinity(i,j,k)
                sp5  = sqrt(s1)
                p1   = press(i,j,k) - press_standard
                p2   = p1*p1
                p1t1 = p1*t1

                if(s1 > 0.0) then
                   spm5 = 1.0/sp5
                else
                   spm5 = 0.0
                endif
                rhotheta_rhosalinity = Grd%tmask(i,j,k)*density_theta(i,j,k)/(epsln+density_salinity(i,j,k))

                dden_dtheta = v22 + t1*(two_v23 +t1*(three_v24+four_v25*t1))      &
                     + s1*(v27 + t1*(two_v28 + t1*(three_v29  + four_v30*t1))     &
                     +     sp5*(v32+t1*(two_v33 + t1*(three_v34 + four_v35*t1)))) &
                     + p1*((v38 + t1*(two_v39 + three_v40*t1))                    &
                     +     s1*v42                                                 &
                     +     p1*((v44 + two_v45*t1 + v46*s1)                        &
                     +     p1*(v48)))


                dden_dsalinity =                                                    &
                        (v26 + t1*(v27 + t1*(v28 + t1*(v29 + v30*t1))) + two_v36*s1 &
                       + 1.5*sp5*(v31 + t1*(v32 + t1*(v33 + t1*(v34 + v35*t1)))))   &
                       + p1*( v41 + v42*t1 + p1*t1*v46 )

               dden_dpress = (v37 + t1*(v38 + t1*(v39 + v40*t1))                    &
                       + s1*(v41 + v42*t1)                                          &
                       + 2.*p1*(v43 + t1*(v44 + v45*t1 + v46*s1)                    &
                       + 1.5*p1*(v47 + v48*t1)))

                d2num_dtheta2 = (two_v03 + six_v04*t1)    &
                     + s1*(two_v07                        &
                     +     sp5*( (two_v10 + six_v11*t1))) &
                     + p1*(two_v14                        &
                     +     p1*two_v19)
                d2num_dsalin2 = 0.75*(v08 + t1*(v09 + t1*(v10 + v11*t1)))*spm5
                d2num_dtheta_dsalin = v06 + two_v07*t1              &
                      + 1.5*sp5*(v09 + t1*(two_v10 + three_v11*t1)) &
                      + p1*v16 
                d2num_dsalin_dpress = (v15 + v16*t1) &
                      + 2.0*p1*v20
                d2num_dtheta_dpress = (v13 + two_v14*t1) + s1*v16 &
                      + 2.0*p1*(v18 + two_v19*t1 )



                d2den_dtheta2 = (two_v23 +t1*(six_v24 + twelve_v25*t1))    &
                     + s1*(two_v28 + t1*(six_v29  + twelve_v30*t1)         &
                     +     sp5*((two_v33 + t1*(six_v34 + twelve_v35*t1)))) &
                     + p1*(((two_v39 + six_v40*t1))                        &
                     +     p1*two_v45       )
                d2den_dsalin2 = two_v36  &
                       + 0.75*spm5*(v31 + t1*(v32 + t1*(v33 + t1*(v34 + v35*t1))))
                d2den_dsalin_dtheta = ((v27 + t1*(two_v28 + t1*(three_v29 + four_v30*t1))) &
                       + 1.5*sp5*((v32 + t1*(two_v33 + t1*(three_v34 + four_v35*t1)))))    &
                       + p1*( v42 + p1*v46 )
                d2den_dsalin_dpress = v41 + v42*t1 + p1*t1*two_v46 
                d2den_dtheta_dpress = (v38 + t1*(two_v39 + three_v40*t1)) &
                     +     s1*v42                                         &
                     +     2.*p1*((v44 + two_v45*t1 + v46*s1)             &
                     +             1.5*p1*(v48))


                d2rho_dtheta2 = denominator_r(i,j,k) &
                 *(d2num_dtheta2-2.0*density_theta(i,j,k)*dden_dtheta-rho(i,j,k)*d2den_dtheta2)

                d2rho_dsalin2 = denominator_r(i,j,k) &
                 *(d2num_dsalin2-2.0*density_salinity(i,j,k)*dden_dsalinity-rho(i,j,k)*d2den_dsalin2)

                d2rho_dsalin_dtheta = denominator_r(i,j,k)  &
                 *( d2num_dtheta_dsalin                     &
                   -density_salinity(i,j,k)*dden_dtheta     &
                   -density_theta(i,j,k)*dden_dsalinity     &
                   -rho(i,j,k)*d2den_dsalin_dtheta)

                d2rho_dsalin_dpress = denominator_r(i,j,k)  &
                 *( d2den_dsalin_dpress                     &
                   -density_press(i,j,k)*dden_dsalinity     &
                   -density_salinity(i,j,k)*dden_dpress     &
                   -rho(i,j,k)*d2den_dsalin_dpress)

                d2rho_dtheta_dpress = denominator_r(i,j,k)  &
                 *( d2den_dtheta_dpress                     &
                   -density_press(i,j,k)*dden_dtheta        &
                   -density_theta(i,j,k)*dden_dpress        &
                   -rho(i,j,k)*d2den_dtheta_dpress)

                rho_inv = Grd%tmask(i,j,k)/(rho(i,j,k) + epsln)

                cabbeling_param(i,j,k) = -rho_inv*               &
                  ( d2rho_dtheta2                                &
                   -2.0*d2rho_dsalin_dtheta*rhotheta_rhosalinity &
                   +d2rho_dsalin2*rhotheta_rhosalinity**2 )

                thermobaric_param(i,j,k) = -rho_inv*(d2rho_dtheta_dpress-d2rho_dsalin_dpress*rhotheta_rhosalinity)

             enddo
          enddo
       enddo

    endif ! endif for eos choice 



  end subroutine calc_cabbeling_thermobaricity
! </SUBROUTINE> NAME="calc_cabbeling_thermobaricity"



!#######################################################################
! <FUNCTION NAME="density_delta_z">
!
! <DESCRIPTION>
! rho(k)-rho(k+1) for all i,j with both temperatures referenced to the 
! deeper pressure depth.  
!
! Of use for KPP scheme. 
! </DESCRIPTION>
!
function density_delta_z (rho_initial, salinity, theta, press)

  real, intent(in), dimension(isd:,jsd:,:) :: rho_initial
  real, intent(in), dimension(isd:,jsd:,:) :: salinity
  real, intent(in), dimension(isd:,jsd:,:) :: theta
  real, intent(in), dimension(isd:,jsd:,:) :: press

  real, dimension(isd:ied,jsd:jed,nk) :: density_delta_z
  real, dimension(isd:ied,jsd:jed,nk) :: pressure 
  integer :: k

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_density_mod (density_delta_z): module must be initialized')
  endif 

  if(density_equal_potrho) then 
     pressure(:,:,:) = Grd%tmask(:,:,:)*potrho_press
  else 
     pressure(:,:,:) = press(:,:,:)
  endif 

  do k=1,nk-1
    wrk1(:,:,k) = pressure(:,:,k+1)
  enddo
  wrk1(:,:,nk) = pressure(:,:,nk)

  wrk2(:,:,:) = density(salinity(:,:,:), theta(:,:,:), wrk1(:,:,:))

  do k=1,nk-1
    density_delta_z(:,:,k) = (wrk2(:,:,k) - rho_initial(:,:,k+1))*Grd%tmask(:,:,k+1)
  enddo
  density_delta_z(:,:,nk) = (wrk2(:,:,nk) - rho_initial(:,:,nk))*Grd%tmask(:,:,nk)

end function density_delta_z
! </FUNCTION> NAME="density_delta_z"



!#######################################################################
! <FUNCTION NAME="density_delta_sfc">
!
! <DESCRIPTION>
! rho(1)-rho(k+1) for all i,j. 
!
! Of use for KPP scheme. 
! </DESCRIPTION>
!
function density_delta_sfc (rho_initial, salinity, theta, press)

  real, intent(in), dimension(isd:,jsd:,:) :: rho_initial
  real, intent(in), dimension(isd:,jsd:,:) :: salinity
  real, intent(in), dimension(isd:,jsd:,:) :: theta
  real, intent(in), dimension(isd:,jsd:,:) :: press

  real, dimension(isd:ied,jsd:jed,nk) :: density_delta_sfc
  real, dimension(isd:ied,jsd:jed,nk) :: pressure
  integer :: k

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_density_mod (density_delta_sfc): module must be initialized')
  endif 

  if(density_equal_potrho) then 
     pressure(:,:,:) = Grd%tmask(:,:,:)*potrho_press
  else 
     pressure(:,:,:) = press(:,:,:)
  endif 

  do k=1,nk-1
    wrk1(:,:,k) = pressure(:,:,k+1)
  enddo
  wrk1(:,:,nk) = pressure(:,:,nk)

  wrk2(:,:,:) = density_sfc(salinity, theta, wrk1)

  do k=1,nk-1
    density_delta_sfc(:,:,k) = (wrk2(:,:,k) - rho_initial(:,:,k+1))*Grd%tmask(:,:,k+1)
  enddo
  density_delta_sfc(:,:,nk) = (wrk2(:,:,nk) - rho_initial(:,:,nk))*Grd%tmask(:,:,nk)

end function density_delta_sfc
! </FUNCTION> NAME="density_delta_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_density_end">
!
! <DESCRIPTION>
!
! Write density and pressure_at_depth to a restart.
!
! </DESCRIPTION>
subroutine ocean_density_end(Time, Dens, use_blobs)

  type(ocean_time_type),    intent(in)  :: Time
  type(ocean_density_type), intent(in)  :: Dens
  logical,                  intent(in)  :: use_blobs
  
  integer :: stdoutunit 
  stdoutunit=stdout() 

  if ( .not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error in ocean_density_mod (ocean_density_end): module must be initialized')
  endif 

  if(.not. write_a_restart) then
    write(stdoutunit,'(/a)') '==>Warning from ocean_density_mod (ocean_density_end): NO restart written.'
    call mpp_error(WARNING,'==>Warning from ocean_density_mod (ocean_density_end): NO restart written.')
    return
  endif 

  call ocean_density_restart(Time, Dens)

  write(stdoutunit,'(/a)') ' From ocean_density_mod: ending density chksums'
  call write_timestamp(Time%model_time)
  call ocean_density_chksum(Time, Dens, use_blobs)

  module_is_initialized = .FALSE.

end subroutine ocean_density_end
! </SUBROUTINE> NAME="ocean_density_end"


!#######################################################################
! <SUBROUTINE NAME="ocean_density_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocean_density_restart(Time, Dens, time_stamp)
  type(ocean_time_type),    intent(in)           :: Time
  type(ocean_density_type), intent(in)           :: Dens
  character(len=*),         intent(in), optional :: time_stamp
   integer :: taup1

  if ( .not. module_is_initialized ) then 
     call mpp_error(FATAL, &
     '==>Error in ocean_density_mod (ocean_density_end): module must be initialized')
  endif 

  taup1  = Time%taup1

  call reset_field_pointer(Den_restart, id_restart_rho, Dens%rho(:,:,:,taup1) )
  call reset_field_pointer(Den_restart, id_restart_rho_s, Dens%rho_salinity(:,:,:,taup1) )

  call save_restart(Den_restart, time_stamp)

end subroutine ocean_density_restart
! </SUBROUTINE> NAME="ocean_density_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_density_chksum">
!
! <DESCRIPTION>
! Compute checksums for density. 
! </DESCRIPTION>
subroutine ocean_density_chksum(Time, Dens, use_blobs)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens
  logical,                  intent(in) :: use_blobs

  integer :: taup1

  if (.not. module_is_initialized) then 
    call mpp_error(FATAL,&
    '==>Error from ocean_density_mod (ocean_density_chksum): module not yet initialized ')
  endif 

  taup1 = Time%taup1 

  call write_chksum_3d('rho(taup1)', Dens%rho(COMP,:,taup1)*Grd%tmask(COMP,:))
  if (use_blobs) then
     call write_chksum_3d('rhoT(taup1)', Dens%rhoT(COMP,:)*Grd%tmask(COMP,:))
  endif
  call write_chksum_3d('pressure_at_depth', Dens%pressure_at_depth(COMP,:)*Grd%tmask(COMP,:))
  call write_chksum_3d('denominator_r', denominator_r(COMP,:)*Grd%tmask(COMP,:))
  call write_chksum_3d('drhodT', Dens%drhodT(COMP,:)*Grd%tmask(COMP,:))
  call write_chksum_3d('drhodS', Dens%drhodS(COMP,:)*Grd%tmask(COMP,:))
  call write_chksum_3d('drhodz_zt', Dens%drhodz_zt(COMP,:)*Grd%tmask(COMP,:))

end subroutine ocean_density_chksum
! </SUBROUTINE>  NAME="ocean_density_chksum"


!#######################################################################
! <SUBROUTINE NAME="compute_buoyfreq">
! <DESCRIPTION>
!
! Diagnose the buoyancy frequency, both at T-points and at 
! vertical interfaces of T-cells. 
!
! Author: Stephen.Griffies
!
! </DESCRIPTION>
!
subroutine compute_buoyfreq(Time, Thickness, salinity, theta, Dens, use_blobs)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_thickness_type),   intent(in)    :: Thickness
  real, dimension(isd:,jsd:,:), intent(in)    :: salinity
  real, dimension(isd:,jsd:,:), intent(in)    :: theta
  type(ocean_density_type),     intent(inout) :: Dens
  logical,                      intent(in)    :: use_blobs

  integer   :: i,j,k,kp1,kbot,m
  integer   :: tau, taup1
  real      :: drhodz_prev, tmpdrhodz

  if (.not. module_is_initialized) then 
      call mpp_error(FATAL, &
      '==>Error from ocean_density (compute_buoyfreq): module needs initialization')
  endif

  tau   = Time%tau
  taup1 = Time%taup1
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  if (use_blobs) then
     ! vertical derivative of temp and salt
     do k=1,nk-1
        kp1 = k+1
        do j=jsd,jed
           do i=isd,ied
              wrk1(i,j,k) = (theta(i,j,k)-theta(i,j,kp1))/Thickness%dzwtT(i,j,k)
              wrk2(i,j,k) = (salinity(i,j,k)-salinity(i,j,kp1))/Thickness%dzwtT(i,j,k)
           enddo
        enddo
     enddo
  else
     ! vertical derivative of temp and salt
     do k=1,nk-1
        kp1 = k+1
        do j=jsd,jed
           do i=isd,ied
              wrk1(i,j,k) = (theta(i,j,k)-theta(i,j,kp1))/Thickness%dzwt(i,j,k)
              wrk2(i,j,k) = (salinity(i,j,k)-salinity(i,j,kp1))/Thickness%dzwt(i,j,k)
           enddo
        enddo
     enddo
  endif

  ! vertical derivative of locally referenced potential density.
  ! vanishes at the bottom of a column.
  do k=1,nk-1
     kp1=k+1
     do j=jsd,jed
        do i=isd,ied
           wrk3(i,j,k) = Dens%drhodT(i,j,k)*wrk1(i,j,k) + Dens%drhodS(i,j,k)*wrk2(i,j,k)  
           if(abs(wrk3(i,j,k)) < epsln_drhodz) then 
              wrk3(i,j,k) = sign(1.0,wrk3(i,j,k))*epsln_drhodz
           endif 
           wrk3(i,j,k) = Grd%tmask(i,j,kp1)*wrk3(i,j,k)
        enddo
     enddo
  enddo

  ! vertically smooth drhodz; otherwise can get noisy results 
  if(buoyfreq_smooth_vert) then
      do m=1,num_121_passes
         do j=jsd,jed
            do i=isd,ied
               drhodz_prev = onefourth*wrk3(i,j,1) 
               kbot=Grd%kmt(i,j)
               if(kbot>3) then
                   do k=2,kbot-2
                      tmpdrhodz   = wrk3(i,j,k)
                      wrk3(i,j,k) = drhodz_prev + onehalf*wrk3(i,j,k) + onefourth*wrk3(i,j,k+1)
                      drhodz_prev = onefourth*tmpdrhodz
                   enddo
               endif
            enddo
         enddo
      enddo
  endif

  ! drhodz at bottom of T-cell
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           Dens%drhodz_wt(i,j,k) = wrk3(i,j,k)
        enddo
     enddo
  enddo
  if(id_buoyfreq2_wt > 0) then 
     call diagnose_3d(Time, Grd, id_buoyfreq2_wt, -grav*rho0r*wrk3(:,:,:))
  endif
  call diagnose_3d(Time, Grd, id_drhodz_wt, wrk3(:,:,:))

  ! drhodz and squared buoyancy frequency at T-cell point 
  wrk4(:,:,:) = 0.0
  k=1
  do j=jsd,jed
     do i=isd,ied
        Dens%drhodz_zt(i,j,k)   = Dens%drhodz_wt(i,j,k)
        wrk4(i,j,k)             = Dens%drhodz_wt(i,j,k)
     enddo
  enddo
  do k=2,nk
     do j=jsd,jed
        do i=isd,ied
           wrk4(i,j,k) = wrk3(i,j,k-1)*(Thickness%depth_zwt(i,j,k)-Thickness%depth_zt(i,j,k))   &
                        +wrk3(i,j,k)  *(Thickness%depth_zt(i,j,k) -Thickness%depth_zwt(i,j,k-1)) 
           wrk4(i,j,k) = wrk4(i,j,k)/(epsln+Thickness%dzt(i,j,k))
           Dens%drhodz_zt(i,j,k)   = wrk4(i,j,k)
        enddo
     enddo
  enddo

  if(drhodz_diag_stable) then

      ! enforce stable stratification 
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               if(abs(Dens%drhodz_zt(i,j,k)) < epsln_drhodz_diag .or. Dens%drhodz_zt(i,j,k) > 0.0) then 
                   Dens%drhodz_diag(i,j,k) = -epsln_drhodz_diag
               else 
                   Dens%drhodz_diag(i,j,k) = Dens%drhodz_zt(i,j,k)
               endif
            enddo
         enddo
      enddo
  else 

      ! allow for unstable stratification 
      do k=1,nk
         do j=jsd,jed
            do i=isd,ied
               if(abs(Dens%drhodz_zt(i,j,k)) < epsln_drhodz_diag) then 
                   Dens%drhodz_diag(i,j,k) = sign(1.0,Dens%drhodz_zt(i,j,k))*epsln_drhodz_diag
               else 
                   Dens%drhodz_diag(i,j,k) = Dens%drhodz_zt(i,j,k)
               endif
            enddo
         enddo
      enddo
  endif


  if(id_buoyfreq2_zt > 0) then 
     call diagnose_3d(Time, Grd, id_buoyfreq2_zt, -grav*rho0r*wrk4(:,:,:))
  endif 
  call diagnose_3d(Time, Grd, id_drhodz_zt, wrk4(:,:,:))
  call diagnose_3d(Time, Grd, id_drhodz_diag, Dens%drhodz_diag(:,:,:))

  ! dTdz and dSdz  at T-cell point 
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  k=1
  do j=jsd,jed
     do i=isd,ied
        Dens%dTdz_zt(i,j,k) = wrk1(i,j,k)
        Dens%dSdz_zt(i,j,k) = wrk2(i,j,k)
     enddo
  enddo

  do k=2,nk
     do j=jsd,jed
        do i=isd,ied
           wrk3(i,j,k) = wrk1(i,j,k-1)*(Thickness%depth_zwt(i,j,k)-Thickness%depth_zt(i,j,k))   &
                        +wrk1(i,j,k)  *(Thickness%depth_zt(i,j,k) -Thickness%depth_zwt(i,j,k-1)) 
           wrk4(i,j,k) = wrk2(i,j,k-1)*(Thickness%depth_zwt(i,j,k)-Thickness%depth_zt(i,j,k))   &
                        +wrk2(i,j,k)  *(Thickness%depth_zt(i,j,k) -Thickness%depth_zwt(i,j,k-1)) 
           wrk3(i,j,k) = wrk3(i,j,k)/(epsln+Thickness%dzt(i,j,k))
           wrk4(i,j,k) = wrk4(i,j,k)/(epsln+Thickness%dzt(i,j,k))
           Dens%dTdz_zt(i,j,k) = wrk3(i,j,k)
           Dens%dSdz_zt(i,j,k) = wrk4(i,j,k)
        enddo
     enddo
  enddo


end subroutine compute_buoyfreq
! </SUBROUTINE>  NAME="compute_buoyfreq"


!#######################################################################
! <FUNCTION NAME="buoyfreq2">
! <DESCRIPTION>
!
! Diagnose the square of the buoyancy frequency at the bottom of 
! T-cells, NOT at T-points.
! The algorithm follows that used by the private function
! compute_buoyfreq in the density module.
!
! We take the square of the buoyancy frequency as is, we do not
! smooth or force it to be positive.  This allows us to search for
! instabilities.
!
! Authors: m.bates
! </DESCRIPTION>
!
function buoyfreq2(Time, Thickness, Dens, salinity, theta, rho, use_blobs)

  type(ocean_time_type),        intent(in) :: Time
  type(ocean_thickness_type),   intent(in) :: Thickness
  type(ocean_density_type),     intent(in) :: Dens
  real, dimension(isd:,jsd:,:), intent(in) :: salinity
  real, dimension(isd:,jsd:,:), intent(in) :: theta
  real, dimension(isd:,jsd:,:), intent(in) :: rho
  logical,                      intent(in) :: use_blobs

  real, dimension(isd:ied,jsd:jed,nk) :: buoyfreq2
  real, dimension(isd:ied,jsd:jed,nk) :: drhodT
  real, dimension(isd:ied,jsd:jed,nk) :: drhodS

  integer   :: i,j,k,kp1
  integer   :: taup1
  real      :: tmp, grav_rho0r

  if (.not. module_is_initialized) then 
      call mpp_error(FATAL, &
      '==>Error from ocean_density (buoyfreq2): module needs initialization')
  endif

  taup1 = Time%taup1

  grav_rho0r = grav*rho0r

  wrk4(:,:,:)      = 0.0
  buoyfreq2(:,:,:) = 0.0

  !get the partial derivatives drho/dT and drho/dS
  call density_derivs( rho(:,:,:), salinity(:,:,:), theta(:,:,:), &
                      Dens%pressure_at_depth(:,:,:),              &
                      Time, drhodT(:,:,:), drhodS(:,:,:),         &
                      wrk4(:,:,:))

  wrk3(:,:,:) = 0.0
  ! We don't need drho/dp and so can overwrite it.
  wrk4(:,:,:) = 0.0

  ! vertical derivative of temp and salt
  if (use_blobs) then
     do k=1,nk-1
        kp1 = k+1
        do j=jsd,jed
           do i=isd,ied
              tmp = Grd%tmask(i,j,kp1)/Thickness%dzwtT(i,j,k)
              wrk3(i,j,k) = tmp*(theta(i,j,k)    - theta(i,j,kp1)   )
              wrk4(i,j,k) = tmp*(salinity(i,j,k) - salinity(i,j,kp1))
           enddo
        enddo
     enddo
  else
     do k=1,nk-1
        kp1 = k+1
        do j=jsd,jed
           do i=isd,ied
              tmp = Grd%tmask(i,j,kp1)/Thickness%dzwt(i,j,k)
              wrk3(i,j,k) = tmp*(theta(i,j,k)    - theta(i,j,kp1)   )
              wrk4(i,j,k) = tmp*(salinity(i,j,k) - salinity(i,j,kp1))
           enddo
        enddo
     enddo
  endif

  ! vertical derivative of locally referenced potential density
  ! at the bottom of a cell.
  ! N**2==0 at the bottom of a column.
  do k=1,nk-1
     do j=jsd,jed
        do i=isd,ied
           buoyfreq2(i,j,k) = -grav_rho0r*( drhodT(i,j,k)*wrk3(i,j,k) + drhodS(i,j,k)*wrk4(i,j,k) )
        enddo
     enddo
  enddo

end function buoyfreq2
! </FUNCTION>  NAME="buoyfreq2"



!#######################################################################
! <SUBROUTINE NAME="compute_drhodxy">
! <DESCRIPTION>
!
! Diagnose horiz derivatives of locally referenced potential density.
! For use in diagnosing balanced Ertel PV.  
!
! For simplicity, do no spatial averaging. Hence, the placement
! of the derivative is at the cell face, not cell center. But to 
! simplify matters, we consider the derivs to be at the cell center,
! which simplifies how we take |grad b| for the PV calculation, meaning
! there will be no averaging operations. This assumption may need to
! be revisited.  
!
! Author: Stephen.Griffies
!
! </DESCRIPTION>
!
subroutine compute_drhodxy(Time, salinity, theta, Dens)

  type(ocean_time_type),        intent(in)    :: Time
  real, dimension(isd:,jsd:,:), intent(in)    :: salinity
  real, dimension(isd:,jsd:,:), intent(in)    :: theta
  type(ocean_density_type),     intent(inout) :: Dens

  integer   :: i,j,k
  real      :: tmp1,tmp2

  if (.not. module_is_initialized) then 
      call mpp_error(FATAL, &
      '==>Error from ocean_density (compute_drhodxy): module needs initialization')
  endif

  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0

  ! x-derivative 
  do k=1,nk
     do j=jsd,jed
        do i=isd,iec
           tmp1 = (theta(i+1,j,k)   -theta(i,j,k)   )*Dens%drhodT(i,j,k)
           tmp2 = (salinity(i+1,j,k)-salinity(i,j,k))*Dens%drhodS(i,j,k)
           wrk1(i,j,k)           = Grd%tmask(i+1,j,k)*(tmp1+tmp2)*Grd%dxter(i,j)
           Dens%drhodx_zt(i,j,k) = wrk1(i,j,k)
        enddo
     enddo
  enddo
  
  ! y-derivative 
  do k=1,nk
     do j=jsd,jec
        do i=isd,ied
           tmp1 = (theta(i,j+1,k)   -theta(i,j,k)   )*Dens%drhodT(i,j,k)
           tmp2 = (salinity(i,j+1,k)-salinity(i,j,k))*Dens%drhodS(i,j,k)
           wrk2(i,j,k)           = Grd%tmask(i,j+1,k)*(tmp1+tmp2)*Grd%dytnr(i,j)
           Dens%drhody_zt(i,j,k) = wrk2(i,j,k)
        enddo
     enddo
  enddo
  
  if(id_drhodx_zt > 0) then 
     call diagnose_3d(Time, Grd, id_drhodx_zt, wrk1(:,:,:))
  endif
  if(id_drhody_zt > 0) then 
     call diagnose_3d(Time, Grd, id_drhody_zt, wrk2(:,:,:))
  endif



end subroutine compute_drhodxy
! </SUBROUTINE>  NAME="compute_drhodxy"



end module ocean_density_mod

module bgrid_masks_mod

!-----------------------------------------------------------------------
!
!    allocates memory and initializes masks and vertical indexing
!    associated with the step mountain vertical coordinate.
!
!-----------------------------------------------------------------------

use bgrid_horiz_mod, only:  horiz_grid_type
use  bgrid_halo_mod, only:  update_halo, NOPOLE, UWND
use  bgrid_vert_mod, only:  vert_grid_type
use         fms_mod, only:  write_version_number, stdlog, stdout
use         mpp_mod, only:  mpp_pe, mpp_root_pe, mpp_max

implicit none
private

!-----------------------------------------------------------------------
!    ---- public interfaces ----

   public :: grid_masks_init, grid_masks_end

!-----------------------------------------------------------------------
!    ---- public data types ----

   public ::      mask_type
   public :: grid_mask_type

   type mask_type
      real,    pointer, dimension(:,:,:) :: mask =>NULL()
      integer, pointer, dimension(:,:)   :: kbot =>NULL()
      integer                            :: kbotmin
   end type mask_type

!  mask  = step-mountain topography mask (0. or 1.)
!          mask = 0. for grid boxes that form the step-mountain
!          mask = 1. for grid boxes above ground
!  kbot  = lowest model level above ground
!  kbotmin = smallest value of kbot across all processors
!
!  NOTE:  For the sigma coordinate, mask = 1.0 everywhere, and
!         kbot = number of vertical model levels

   type grid_mask_type
      type(mask_type) :: Tmp, Vel
      logical :: sigma
   end type grid_mask_type

!  Tmp = grid masking values for the temperature/mass grid
!  Vel = grid masking values for the velocity grid
!  sigma = logical flag that specifies whether the vertical coordinate
!          is the eta/step-mountain coordinate or sigma coordinate
!
!-----------------------------------------------------------------------
!  private interfaces and data

   private :: compute_mass_mask, compute_vel_mask, compute_lowest_level

   logical :: sigma  ! local variable

!  version number info

   character(len=128) :: version='$Id: bgrid_masks.F90,v 19.0 2012/01/06 19:55:15 fms Exp $'
   character(len=128) :: tagname='$Name: tikal $'
   logical :: do_log = .true.

!-----------------------------------------------------------------------

contains

!#######################################################################

   subroutine grid_masks_init (Hgrid, Vgrid, res, Masks)

!-----------------------------------------------------------------------
! input arguments
!     Hgrid = horizontal grid constants
!     Vgrid = vertical grid constants
!     res   = 1/eta(surface); i.e., reciprical of eta at the surface
! output
!     Masks = grid box masks for the eta coordinate
!-----------------------------------------------------------------------

   type (horiz_grid_type), intent(inout) :: Hgrid
   type  (vert_grid_type), intent(in)    :: Vgrid
   real,                   intent(in)    :: res(Hgrid%ilb:,Hgrid%jlb:)
   type  (grid_mask_type), intent(inout) :: Masks

!-----------------------------------------------------------------------

   logical :: sigma   ! flag for sigma(T) or eta(F)
   integer :: k, outunit, logunit
   real    :: maxres
   real    :: aeta(Vgrid%nlev)

   if (do_log) then
      call write_version_number(version, tagname)
      do_log = .false.
   endif
   logunit = stdlog()
   outunit = stdout()

   ! allocate global storage

 allocate ( Masks%Tmp%mask (Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub, Vgrid%nlev), &
            Masks%Vel%mask (Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub, Vgrid%nlev), &
            Masks%Tmp%kbot (Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub), &
            Masks%Vel%kbot (Hgrid%ilb:Hgrid%iub, Hgrid%jlb:Hgrid%jub)  )

   ! determine if this is a sigma or eta
   ! vertical coordinate from the value of res

      maxres = maxval(res)
      call mpp_max (maxres)

      if (maxres > 1.0001) then
         Masks % sigma=.false.
         sigma=.false.
         if (mpp_pe() == mpp_root_pe()) then
            if (Vgrid%hybrid) then
               write (logunit,100) 'eta/hybrid'
            else
               write (logunit,100) 'eta'
            endif
             ! print gaudy banner to standard output for untested eta option
               write (outunit,'(4(a/))') &
                      '*******************************************************', &
                      'WARNING: The eta coordinate option has not been tested.', &
                      '         Proceed with caution.',                          &
                      '*******************************************************'
         endif
      else
         Masks % sigma=.true.
         sigma=.true.
         if (mpp_pe() == mpp_root_pe()) then
            if (Vgrid%hybrid) then
               write (logunit,100) 'sigma/hybrid'
            else
               write (logunit,100) 'sigma'
            endif
         endif
      endif

 100  format (/,'B-grid dynamical core has been initialized with the ',a,' vertical coordinate.')

!--------------topography masks ----------------------------------------

    ! average eta at model levels
      do k = 1, Vgrid%nlev
        aeta(k) = (Vgrid%eta(k)+Vgrid%eta(k+1))*0.5
      enddo

      Masks % Tmp % mask = compute_mass_mask (res, aeta)
      Masks % Vel % mask = compute_vel_mask  (res, aeta)
      call update_halo (Hgrid, UWND, Masks%Vel%mask, flags=NOPOLE)
!!!!! call update_halo (Hgrid, UWND, Masks%Vel%mask)   ! sets mask=0 at poles

!------------- compute the lowest model level --------------------------

      Masks % Tmp % kbot = compute_lowest_level (Masks % Tmp % mask)
      Masks % Vel % kbot = compute_lowest_level (Masks % Vel % mask)

!     ----- global values -----

      Masks % Tmp % kbotmin = minval(Masks % Tmp % kbot)
      Masks % Vel % kbotmin = minval(Masks % Vel % kbot)

!-----------------------------------------------------------------------

end subroutine grid_masks_init

!#######################################################################

subroutine grid_masks_end ( Masks )

type  (grid_mask_type), intent(inout) :: Masks

! release memory
  deallocate ( Masks%Tmp%mask, Masks%Vel%mask, &
               Masks%Tmp%kbot, Masks%Vel%kbot  )
  Masks%Tmp%kbotmin = 0  ! set unrealistic value
  Masks%Vel%kbotmin = 0

end subroutine grid_masks_end

!#######################################################################

   function compute_mass_mask (res, aeta) result (mask)

   real, intent(in) :: res(:,:), aeta(:)
   real, dimension(size(res,1),size(res,2),size(aeta,1)) :: mask
   integer  i, j, k

      mask = 1.0

      if (.not.sigma) then
         do j=1,size(res,2); do i=1,size(res,1)
         do k=1,size(aeta(:))
            if (aeta(k) > (1.0/res(i,j))) mask(i,j,k) = 0.0
         enddo; enddo; enddo
      endif

   end function compute_mass_mask

!#######################################################################

   function compute_vel_mask (res, aeta) result (mask)

   real, intent(in) :: res(:,:), aeta(:)
   real, dimension(size(res,1),size(res,2),size(aeta,1)) :: mask
   integer  i, j, k

      mask = 1.0

      if (.not.sigma) then
         do j=2,size(res,2); do i=2,size(res,1)
         do k=1,size(aeta(:))
            if (aeta(k) > (1.0/res(i,j))) then
                mask(i-1,j-1,k) = 0.0
                mask(i  ,j-1,k) = 0.0
                mask(i-1,j  ,k) = 0.0
                mask(i  ,j  ,k) = 0.0
            endif
         enddo; enddo; enddo
      endif

   end function compute_vel_mask

!#######################################################################

   function compute_lowest_level (mask) result (kbot)

   real, intent(in) :: mask(:,:,:)
   integer, dimension(size(mask,1),size(mask,2)) :: kbot
   integer   i, j, k, kdim

      kdim = size(mask,3)
      kbot = kdim

      if (.not.sigma) then
         do j=1,size(mask,2); do i=1,size(mask,1)
         do k=1,kdim
            if (mask(i,j,k) < 0.50) then
               kbot(i,j)=k-1; exit
            endif
         enddo; enddo; enddo
       ! must not be zero
         kbot = max(kbot,1)
      endif

   end function compute_lowest_level

!#######################################################################

end module bgrid_masks_mod

#include <fms_platform.h>

MODULE diag_data_mod
  ! <CONTACT EMAIL="seth.underwood@noaa.gov">
  !   Seth Underwood
  ! </CONTACT>

  ! <OVERVIEW>
  !   Type descriptions and global variables for the diag_manager modules.
  ! </OVERVIEW>

  ! <DESCRIPTION>
  !   Notation:
  !   <DL>
  !     <DT>input field</DT>
  !     <DD>The data structure describing the field as
  !       registered by the model code.</DD>
  !
  !     <DT>output field</DT>
  !     <DD>The data structure describing the actual
  !       diagnostic output with requested frequency and
  !       other options.</DD>
  !   </DL>
  !
  !   Input fields, output fields, and output files are gathered in arrays called
  !   "input_fields", "output_fields", and "files", respectively. Indices in these
  !   arrays are used as pointers to create associations between various data
  !   structures.
  !
  !   Each input field associated with one or several output fields via array of
  !   indices output_fields; each output field points to the single "parent" input
  !   field with the input_field index, and to the output file with the output_file
  !   index
  ! </DESCRIPTION>

  USE time_manager_mod, ONLY: time_type
  USE mpp_domains_mod,  ONLY: domain1d, domain2d
  USE mpp_io_mod,       ONLY: fieldtype
  USE fms_mod, ONLY: WARNING
#ifdef use_netCDF
  ! NF90_FILL_REAL has value of 9.9692099683868690e+36.
  USE netcdf, ONLY: NF_FILL_REAL => NF90_FILL_REAL
#endif

  IMPLICIT NONE

  PUBLIC

  ! <!-- PARAMETERS for diag_data.F90 -->
  ! <DATA NAME="MAX_FIELDS_PER_FILE" TYPE="INTEGER, PARAMETER" DEFAULT="300">
  !   Maximum number of fields per file.
  ! </DATA>
  ! <DATA NAME="DIAG_OTHER" TYPE="INTEGER, PARAMETER" DEFAULT="0" />
  ! <DATA NAME="DIAG_OCEAN" TYPE="INTEGER, PARAMETER" DEFAULT="1" />
  ! <DATA NAME="DIAG_ALL" TYPE="INTEGER, PARAMETER" DEFAULT="2" />
  ! <DATA NAME="VERY_LARGE_FILE_FREQ" TYPE="INTEGER, PARAMETER" DEFAULT="100000" />
  ! <DATA NAME="VERY_LARGE_AXIS_LENGTH" TYPE="INTEGER, PARAMETER" DEFAUTL="10000" />
  ! <DATA NAME="EVERY_TIME" TYPE="INTEGER, PARAMETER" DEFAULT="0" />
  ! <DATA NAME="END_OF_RUN" TYPE="INTEGER, PARAMETER" DEFAULT="-1" />
  ! <DATA NAME="DIAG_SECONDS" TYPE="INTEGER, PARAMETER" DEFAULT="1" />
  ! <DATA NAME="DIAG_MINUTES" TYPE="INTEGER, PARAMETER" DEFAULT="2" />
  ! <DATA NAME="DIAG_HOURS" TYPE="INTEGER, PARAMETER" DEFAULT="3" />
  ! <DATA NAME="DIAG_DAYS" TYPE="INTEGER, PARAMETER" DEFAULT="4" />
  ! <DATA NAME="DIAG_MONTHS" TYPE="INTEGER, PARAMETER" DEFAULT="5" />
  ! <DATA NAME="DIAG_YEARS" TYPE="INTEGER, PARAMETER" DEFAULT="6" />
  ! <DATA NAME="MAX_SUBAXES" TYPE="INTEGER, PARAMETER" DEFAULT="10" />
  ! <DATA NAME="CMOR_MISSING_VALUE" TYPE="REAL, PARAMETER" DEFAULT="1.0e20" />
  ! <DATA NAME="GLO_REG_VAL" TYPE="INTEGER, PARAMETER" DEFAULT="-999">
  !   Value used in the region specification of the diag_table to indicate to use the full axis instead of a sub-axis
  ! </DATA>
  ! <DATA NAME="GLO_REG_VAL_ALT" TYPE="INTEGER, PARAMETER" DEFAULT="-1">
  !   Alternate value used in the region specification of the diag_table to indicate to use the full axis instead of a sub-axis
  ! </DATA>
  ! <DATA NAME="DIAG_FIELD_NOT_FOUND" TYPE="INTEGER, PARAMETER" DEFAULT="-1">
  !   Return value for a diag_field that isn't found in the diag_table
  ! </DATA>
  ! Specify storage limits for fixed size tables used for pointers, etc.
  INTEGER, PARAMETER :: MAX_FIELDS_PER_FILE = 300 !< Maximum number of fields per file.
  INTEGER, PARAMETER :: DIAG_OTHER = 0
  INTEGER, PARAMETER :: DIAG_OCEAN = 1
  INTEGER, PARAMETER :: DIAG_ALL   = 2
  INTEGER, PARAMETER :: VERY_LARGE_FILE_FREQ = 100000
  INTEGER, PARAMETER :: VERY_LARGE_AXIS_LENGTH = 10000
  INTEGER, PARAMETER :: EVERY_TIME =  0
  INTEGER, PARAMETER :: END_OF_RUN = -1
  INTEGER, PARAMETER :: DIAG_SECONDS = 1, DIAG_MINUTES = 2, DIAG_HOURS = 3
  INTEGER, PARAMETER :: DIAG_DAYS = 4, DIAG_MONTHS = 5, DIAG_YEARS = 6
  INTEGER, PARAMETER :: MAX_SUBAXES = 10
  INTEGER, PARAMETER :: GLO_REG_VAL = -999
  INTEGER, PARAMETER :: GLO_REG_VAL_ALT = -1
  REAL, PARAMETER :: CMOR_MISSING_VALUE = 1.0e20 !< CMOR standard missing value
  INTEGER, PARAMETER :: DIAG_FIELD_NOT_FOUND = -1

  ! <TYPE NAME="diag_grid">
  !   <DESCRIPTION>
  !     Contains the coordinates of the local domain to output.
  !   </DESCRIPTION>
  !   <DATA NAME="start" TYPE="REAL, DIMENSION(3)">
  !     Start coordinates (Lat, Lon, Depth) of the local domain to output.
  !   </DATA>
  !   <DATA NAME="end" TYPE="REAL, DIMENSION(3)">
  !     End coordinates (Lat, Lon, Depth) of the local domain to output.
  !   </DATA>
  !   <DATA NAME="l_start_indx" TYPE="INTEGER, DIMENSION(3)">
  !     Start indices at each local PE.
  !   </DATA>
  !   <DATA NAME="l_end_indx" TYPE="INTEGER, DIMENSION(3)">
  !     End indices at each local PE.
  !   </DATA>
  !   <DATA NAME="subaxes" TYPE="INTEGER, DIMENSION(3)">
  !     ID returned from diag_subaxes_init of 3 subaces.
  !   </DATA>
  TYPE diag_grid
     REAL, DIMENSION(3) :: start, END ! start and end coordinates (lat,lon,depth) of local domain to output
     INTEGER, DIMENSION(3) :: l_start_indx, l_end_indx ! start and end indices at each LOCAL PE
     INTEGER, DIMENSION(3) :: subaxes ! id returned from diag_subaxes_init of 3 subaxes
  END TYPE diag_grid
  ! </TYPE>

  ! <TYPE NAME="diag_fieldtype">
  !   <DESCRIPTION>
  !     Diagnostic field type
  !   </DESCRIPTION>
  !   <DATA NAME="Field" TYPE="TYPE(fieldtype)">
  !   </DATA>
  !   <DATA NAME="Domain" TYPE="TYPE(domain2d)">
  !   </DATA>
  !   <DATA NAME="miss" TYPE="REAL">
  !   </DATA>
  !   <DATA NAME="miss_pack" TYPE="REAL">
  !   </DATA>
  !   <DATA NAME="miss_present" TYPE="LOGICAL">
  !   </DATA>
  !   <DATA NAME="miss_pack_present" TYPE="LOGICAL">
  !   </DATA>
  !   <DATA NAME="tile_count" TYPE="INTEGER">
  !   </DATA>
  TYPE diag_fieldtype
     TYPE(fieldtype) :: Field
     TYPE(domain2d) :: Domain
     REAL :: miss, miss_pack
     LOGICAL :: miss_present, miss_pack_present
     INTEGER :: tile_count
  END TYPE diag_fieldtype
  ! </TYPE>

  ! <TYPE NAME="diag_atttype">
  !   <DESCRIPTION>
  !     Attribute type for diagnostic fields
  !   </DESCRIPTION>
  !   <DATA NAME="type">
  !     Data type of attribute values (NF_INT, NF_FLOAT, NF_CHAR)
  !   </DATA>
  !   <DATA NAME="len">
  !     Number of values in attribute, or if a character string then
  !     length of the string.
  !   </DATA>
  !   <DATA NAME="name">
  !     Name of the attribute
  !   </DATA>
  !   <DATA NAME="catt">
  !     Character string to hold character value of attribute
  !   </DATA>
  !   <DATA NAME="fatt">
  !     REAL array to hold value of REAL attributes.
  !   </DATA>
  !   <DATA NAME="iatt">
  !     INTEGER array to hold value of INTEGER attributes.
  !   </DATA>
  type :: diag_atttype
     INTEGER             :: type
     INTEGER             :: len
     CHARACTER(len=128)  :: name
     CHARACTER(len=1280) :: catt
     REAL, _ALLOCATABLE, DIMENSION(:)    :: fatt _NULL
     INTEGER, _ALLOCATABLE, DIMENSION(:) :: iatt _NULL
  end type diag_atttype
  ! </TYPE>
  ! <TYPE NAME="coord_type">
  !   <DESCRIPTION>
  !     Define the region for field output.
  !   </DESCRIPTION>
  !   <DATA NAME="xbegin" TYPE="REAL">
  !   </DATA>
  !   <DATA NAME="xend" TYPE="REAL">
  !   </DATA>
  !   <DATA NAME="ybegin" TYPE="REAL">
  !   </DATA>
  !   <DATA NAME="yend" TYPE="REAL">
  !   </DATA>
  !   <DATA NAME="zbegin" TYPE="REAL">
  !   </DATA>
  !   <DATA NAME="zend" TYPE="REAL">
  !   </DATA>
  TYPE coord_type
     REAL :: xbegin
     REAL :: xend
     REAL :: ybegin
     REAL :: yend
     REAL :: zbegin
     REAL :: zend
  END TYPE coord_type
  ! </TYPE>

  ! <TYPE NAME="file_type">
  !   <DESCRIPTION>
  !     Type to define the diagnostic files that will be written as defined by the diagnostic table.
  !   </DESCRIPTION>
  !   <DATA NAME="name" TYPE="CHARACTER(len=128)">
  !     Name of the output file.
  !   </DATA>
  !   <DATA NAME="long_name" TYPE="CHARACTER(len=128)">
  !   </DATA>
  !   <DATA NAME="fields" TYPE="INTEGER, dimension(max_fields_per_file)">
  !   </DATA>
  !   <DATA NAME="num_fields" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="output_freq" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="output_units" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="format" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="time_units" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="file_unit" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="bytes_written" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="time_axis_id" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="time_bounds_id" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="new_file_freq" TYPE="INTEGER">
  !     Frequency to create a new file.
  !   </DATA>
  !   <DATA NAME="new_file_freq_units" TYPE="INTEGER">
  !     Time units of new_file_freq ( days, hours, years, ...)
  !   </DATA>
  !   <DATA NAME="duration" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="duration_units" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="tile_count" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="local" TYPE="LOGICAL">
  !   </DATA>
  !   <DATA NAME="last_flush" TYPE="TYPE(time_type)">
  !   </DATA>
  !   <DATA NAME="next_open" TYPE="TYPE(time_type)">
  !     Time to open next file.
  !   </DATA>
  !   <DATA NAME="start_time" TYPE="TYPE(time_type)">
  !     Time file opened
  !   </DATA>
  !   <DATA NAME="close_time" TYPE="TYPE(time_type)">
  !     Time file closed.  File does not allow data after close time
  !   </DATA>
  !   <DATA NAME="f_avg_start" TYPE="TYPE(diag_fieldtype)">
  !   </DATA>
  !   <DATA NAME="f_avg_end" TYPE="TYPE(diag_fieldtype)">
  !   </DATA>
  !   <DATA NAME="f_avg_nitems" TYPE="TYPE(diag_fieldtype)">
  !   </DATA>
  !   <DATA NAME="f_bounds" TYPE="TYPE(diag_fieldtype)">
  !   </DATA>
  !   <DATA NAME="attributes" TYPE="TYPE(diag_atttype), DIMENSION(:)">
  !     Array to hold user definable attributes
  !   </DATA>
  !   <DATA NAME="num_attributes" TYPE="INTEGER" >
  !     Number of defined attibutes
  !   </DATA>
  TYPE file_type
     CHARACTER(len=128) :: name !< Name of the output file.
     CHARACTER(len=128) :: long_name
     INTEGER, DIMENSION(max_fields_per_file) :: fields
     INTEGER :: num_fields
     INTEGER :: output_freq
     INTEGER :: output_units
     INTEGER :: FORMAT
     INTEGER :: time_units
     INTEGER :: file_unit
     INTEGER :: bytes_written
     INTEGER :: time_axis_id, time_bounds_id
     INTEGER :: new_file_freq !< frequency to create new file
     INTEGER :: new_file_freq_units !< time units of new_file_freq (days, hours, years, ...)
     INTEGER :: duration
     INTEGER :: duration_units
     INTEGER :: tile_count
     LOGICAL :: local !< .TRUE. if fields are output in a region instead of global.
     TYPE(time_type) :: last_flush
     TYPE(time_type) :: next_open !< Time to open a new file.
     TYPE(time_type) :: start_time !< Time file opened.
     TYPE(time_type) :: close_time !< Time file closed.  File does not allow data after close time
     TYPE(diag_fieldtype):: f_avg_start, f_avg_end, f_avg_nitems, f_bounds
     TYPE(diag_atttype), _ALLOCATABLE, dimension(:) :: attributes _NULL
     INTEGER :: num_attributes
  END TYPE file_type
  ! </TYPE>

  ! <TYPE NAME="input_field_type">
  !   <DESCRIPTION>
  !     Type to hold the input field description
  !   </DESCRIPTION>
  !   <DATA NAME="module_name" TYPE="CHARACTER(len=128)">
  !   </DATA>
  !   <DATA NAME="field_name" TYPE="CHARACTER(len=128)">
  !   </DATA>
  !   <DATA NAME="long_name" TYPE="CHARACTER(len=128)">
  !   </DATA>
  !   <DATA NAME="units" TYPE="CHARACTER(len=128)">
  !   </DATA>
  !   <DATA NAME="standard_name" TYPE="CHARACTER(len=128)">
  !   </DATA>
  !   <DATA NAME="interp_method" TYPE="CHARACTER(len=64)">
  !   </DATA>
  !   <DATA NAME="axes" TYPE="INTEGER, DIMENSION(3)">
  !   </DATA>
  !   <DATA NAME="num_axes" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="missing_value_present" TYPE="LOGICAL">
  !   </DATA>
  !   <DATA NAME="range_present" TYPE="LOGICAL">
  !   </DATA>
  !   <DATA NAME="missing_value" TYPE="REAL">
  !   </DATA>
  !   <DATA NAME="range" TYPE="REAL, DIMENSION(2)">
  !   </DATA>
  !   <DATA NAME="output_fields" TYPE="INTEGER, DIMENSION(max_out_per_in_field)">
  !   </DATA>
  !   <DATA NAME="num_output_fields" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="size" TYPE="INTEGER, DIMENSION(3)">
  !   </DATA>
  !   <DATA NAME="static" TYPE="LOGICAL">
  !   </DATA>
  !   <DATA NAME="register" TYPE="LOGICAL">
  !   </DATA>
  !   <DATA NAME="mask_variant" TYPE="LOGICAL">
  !   </DATA>
  !   <DATA NAME="local" TYPE="LOGICAL">
  !   </DATA>
  !   <DATA NAME="numthreads" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="active_omp_level" TYPE="INTEGER">
  !     The current level of OpenMP nesting
  !   </DATA>
  !   <DATA NAME="tile_count" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="local_coord" TYPE="TYPE(coord_type)">
  !   </DATA>
  !   <DATA NAME="time" TYPE="TYPE(time_type)">
  !   </DATA>
  !   <DATA NAME="issued_mask_ignore_warning" TYPE="LOGICAL">
  !     Indicates if the mask_ignore_warning has been issued for this input
  !     field.  Once .TRUE. the warning message is suppressed on all subsequent
  !     send_data calls.
  !   </DATA>
  TYPE input_field_type
     CHARACTER(len=128) :: module_name, field_name, long_name, units, standard_name
     CHARACTER(len=64) :: interp_method
     INTEGER, DIMENSION(3) :: axes
     INTEGER :: num_axes
     LOGICAL :: missing_value_present, range_present
     REAL :: missing_value
     REAL, DIMENSION(2) :: range
     INTEGER, _ALLOCATABLE, dimension(:) :: output_fields _NULL
     INTEGER :: num_output_fields
     INTEGER, DIMENSION(3) :: size
     LOGICAL :: static, register, mask_variant, local
     INTEGER :: numthreads
     INTEGER :: active_omp_level
     INTEGER :: tile_count
     TYPE(coord_type) :: local_coord
     TYPE(time_type)  :: time
     LOGICAL :: issued_mask_ignore_warning
  END TYPE input_field_type
  ! </TYPE>

  ! <TYPE NAME="output_field_type">
  !   <DESCRIPTION>
  !     Type to hold the output field description.
  !   </DESCRIPTION>
  !   <DATA NAME="input_field" TYPE="INTEGER">
  !     Index of the corresponding input field in the table
  !   </DATA>
  !   <DATA NAME="output_file" TYPE="INTEGER">
  !     Index of the output file in the table
  !   </DATA>
  !   <DATA NAME="output_name" TYPE="CHARACTER(len=128)">
  !   </DATA>
  !   <DATA NAME="static" TYPE="LOGICAL">
  !   </DATA>
  !   <DATA NAME="time_max" TYPE="LOGICAL">
  !     .TRUE. if the output field is maximum over time interval
  !   </DATA>
  !   <DATA NAME="time_min" TYPE="LOGICAL">
  !     .TRUE. if the output field is minimum over time interval
  !   </DATA>
  !   <DATA NAME="time_average" TYPE="LOGICAL">
  !     .TRUE. if the output field is averaged over time interval.
  !   </DATA>
  !   <DATA NAME="time_rms" TYPE="LOGICAL">
  !     .TRUE. if the output field is the rms.  In this case, time_average will also be true.
  !   </DATA>
  !   <DATA NAME="time_ops" TYPE="LOGICAL">
  !     .TRUE. if any of time_min, time_max, time_rms, or time_average is true
  !   </DATA>
  !   <DATA NAME="pack" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="pow_value" TYPE="INTEGER">
  !     Power to use When calculating the mean_pow(n)
  !   </DATA>
  !   <DATA NAME="time_method" TYPE="CHARACTER(len=50)">
  !     Time method field from the input file
  !   </DATA>
  !   <DATA NAME="buffer" TYPE="REAL, _ALLOCATABLE, DIMENSION(:,:,:,:)" DEFAULT="_NULL">
  !     Coordinates of buffer are (x, y, z, time-of-day)
  !   </DATA>
  !   <DATA NAME="counter" TYPE="REAL, _ALLOCATABLE, DIMENSION(:,:,:,:)" DEFAULT="_NULL">
  !     Coordinates of buffer are (x, y, z, time-of-day)
  !   </DATA>
  !   <DATA NAME="count_0d" TYPE="REAL, _ALLOCATABLE, DIMENSION(:)">
  !   </DATA>
  !   <DATA NAME="num_elements" TYPE="REAL, _ALLOCATABLE, DIMENSION(:)">
  !   </DATA>
  !   <DATA NAME="last_output" TYPE="TYPE(time_type)">
  !   </DATA>
  !   <DATA NAME="next_output" TYPE="TYPE(time_type)">
  !   </DATA>
  !   <DATA NAME="next_next_output" TYPE="TYPE(time_type)">
  !   </DATA>
  !   <DATA NAME="f_type" TYPE="TYPE(diag_fieldtype)">
  !   </DATA>
  !   <DATA NAME="axes" TYPE="INTEGER, DIMENSION(4)">
  !   </DATA>
  !   <DATA NAME="num_axes" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="total_elements" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="region_elements" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="n_diurnal_samples" TYPE="INTEGER">
  !     Number of diurnal sample intervals, 1 or more
  !   </DATA>
  !   <DATA NAME="output_grid" TYPE="TYPE(diag_grid)">
  !   </DATA>
  !   <DATA NAME="local_output" TYPE="LOGICAL">
  !     .TRUE. if this field is written out on a region and not globally.
  !   </DATA>
  !   <DATA NAME="need_compute" TYPE="LOGICAL">
  !     .TRUE. if this field is written out on a region, not global.
  !   </DATA>
  !   <DATA NAME="phys_window" TYPE="LOGICAL">
  !   </DATA>
  !   <DATA NAME="written_once" TYPE="LOGICAL">
  !   </DATA>
  !   <DATA NAME="reduced_k_range" TYPE="LOGICAL">
  !     .TRUE. if dealing with vertical sub-level output.
  !   </DATA>
  !   <DATA NAME="imin" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="imax" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="jmin" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="jmax" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="kmin" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="kmax" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="Time_of_prev_field_data" TYPE="TYPE(time_type)">
  !   </DATA>
  !   <DATA NAME="attributes" TYPE="TYPE(diag_atttype), DIMENSION(:)">
  !     Array to hold user definable attributes
  !   </DATA>
  !   <DATA NAME="num_attributes" TYPE="INTEGER" >
  !     Number of defined attibutes
  !   </DATA>
  TYPE output_field_type
     INTEGER :: input_field ! index of the corresponding input field in the table
     INTEGER :: output_file ! index of the output file in the table
     CHARACTER(len=128) :: output_name
     LOGICAL :: time_average ! true if the output field is averaged over time interval
     LOGICAL :: time_rms ! true if the output field is the rms.  If true, then time_average is also
     LOGICAL :: static
     LOGICAL :: time_max ! true if the output field is maximum over time interval
     LOGICAL :: time_min ! true if the output field is minimum over time interval
     LOGICAL :: time_ops ! true if any of time_min, time_max, time_rms or time_average is true
     INTEGER  :: pack
     INTEGER :: pow_value !< Power value to use for mean_pow(n) calculations
     CHARACTER(len=50) :: time_method ! time method field from the input file
     ! coordinates of the buffer and counter are (x, y, z, time-of-day)
     REAL, _ALLOCATABLE, DIMENSION(:,:,:,:) :: buffer _NULL
     REAL, _ALLOCATABLE, DIMENSION(:,:,:,:) :: counter _NULL
     ! the following two counters are used in time-averaging for some
     ! combination of the field options. Their size is the length of the
     ! diurnal axis; the counters must be tracked separately for each of
     ! the diurnal interval, because the number of time slices accumulated
     ! in each can be different, depending on time step and the number of
     ! diurnal samples.
     REAL, _ALLOCATABLE, DIMENSION(:)  :: count_0d
     INTEGER, _ALLOCATABLE, dimension(:) :: num_elements

     TYPE(time_type) :: last_output, next_output, next_next_output
     TYPE(diag_fieldtype) :: f_type
     INTEGER, DIMENSION(4) :: axes
     INTEGER :: num_axes, total_elements, region_elements
     INTEGER :: n_diurnal_samples ! number of diurnal sample intervals, 1 or more
     TYPE(diag_grid) :: output_grid
     LOGICAL :: local_output, need_compute, phys_window, written_once
     LOGICAL :: reduced_k_range
     INTEGER :: imin, imax, jmin, jmax, kmin, kmax
     TYPE(time_type) :: Time_of_prev_field_data
     TYPE(diag_atttype), _ALLOCATABLE, dimension(:) :: attributes _NULL
     INTEGER :: num_attributes
  END TYPE output_field_type
  ! </TYPE>

  ! <TYPE NAME="diag_axis_type">
  !   <DESCRIPTION>
  !     Type to hold the diagnostic axis description.
  !   </DESCRIPTION>
  !   <DATA NAME="name" TYPE="CHARACTER(len=128)">
  !   </DATA>
  !   <DATA NAME="units" TYPE="CHARACTER(len=256)">
  !   </DATA>
  !   <DATA NAME="long_name" TYPE="CHARACTER(len=256)">
  !   </DATA>
  !   <DATA NAME="cart_name" TYPE="CHARACTER(len=1)">
  !   </DATA>
  !   <DATA NAME="data" TYPE="REAL, DIMENSION(:), POINTER">
  !   </DATA>
  !   <DATA NAME="start" TYPE="INTEGER, DIMENSION(MAX_SUBAXES)">
  !   </DATA>
  !   <DATA NAME="end" TYPE="INTEGER, DIMENSION(MAX_SUBAXES)">
  !   </DATA>
  !   <DATA NAME="subaxis_name" TYPE="CHARACTER(len=128), DIMENSION(MAX_SUBAXES)">
  !   </DATA>
  !   <DATA NAME="length" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="direction" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="edges" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="set" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="shift" TYPE="INTEGER">
  !   </DATA>
  !   <DATA NAME="Domain" TYPE="TYPE(domain1d)">
  !   </DATA>
  !   <DATA NAME="Domain2" TYPE="TYPE(domain2d)">
  !   </DATA>
  !   <DATA NAME="subaxis_domain2" TYPE="TYPE(domain2d), dimension(MAX_SUBAXES)">
  !   </DATA>
  !   <DATA NAME="aux" TYPE="CHARACTER(len=128)">
  !   </DATA>
  !   <DATA NAME="tile_count" TYPE="INTEGER">
  !   </DATA>
  TYPE diag_axis_type
     CHARACTER(len=128) :: name
     CHARACTER(len=256) :: units, long_name
     CHARACTER(len=1) :: cart_name
     REAL, DIMENSION(:), POINTER :: data
     INTEGER, DIMENSION(MAX_SUBAXES) :: start
     INTEGER, DIMENSION(MAX_SUBAXES) :: end
     CHARACTER(len=128), DIMENSION(MAX_SUBAXES) :: subaxis_name
     INTEGER :: length, direction, edges, set, shift
     TYPE(domain1d) :: Domain
     TYPE(domain2d) :: Domain2
     TYPE(domain2d), dimension(MAX_SUBAXES) :: subaxis_domain2
     CHARACTER(len=128) :: aux
     INTEGER :: tile_count
  END TYPE diag_axis_type
  ! </TYPE>

  ! <TYPE NAME="diag_global_att_type">
  !   <DESCRIPTION>
  !   </DESCRIPTION>
  !   <DATA NAME="grid_type" TYPE="CHARACTER(len=128)" DEFAULT="regular">
  !   </DATA>
  !   <DATA NAME="tile_name" TYPE="CHARACTER(len=128)" DEFAULT="N/A">
  !   </DATA>
  TYPE diag_global_att_type
     CHARACTER(len=128)   :: grid_type='regular'
     CHARACTER(len=128)   :: tile_name='N/A'
  END TYPE diag_global_att_type
  ! </TYPE>

  ! Private CHARACTER Arrays for the CVS version and tagname.
  CHARACTER(len=128),PRIVATE  :: version =&
       & '$Id$'
  CHARACTER(len=128),PRIVATE  :: tagname =&
       & '$Name$'

  ! <!-- Other public variables -->
  ! <DATA NAME="num_files" TYPE="INTEGER" DEFAULT="0">
  !   Number of output files currenly in use by the diag_manager.
  ! </DATA>
  ! <DATA NAME="num_input_fields" TYPE="INTEGER" DEFAULT="0">
  !   Number of input fields in use.
  ! </DATA>
  ! <DATA NAME="num_output_fields" TYPE="INTEGER" DEFAULT="0">
  !   Number of output fields in use.
  ! </DATA>
  ! <DATA NAME="null_axis_id" TYPE="INTEGER" />
  INTEGER :: num_files = 0
  INTEGER :: num_input_fields = 0
  INTEGER :: num_output_fields = 0
  INTEGER :: null_axis_id

  ! <!-- Namelist variables -->
  ! <DATA NAME="append_pelist_name" TYPE="LOGICAL" DEFAULT=".FALSE." />
  ! <DATA NAME="mix_snapshot_average_fields" TYPE="LOGICAL" DEFAULT=".FALSE." />
  ! <DATA NAME="max_files" TYPE="INTEGER" DEFAULT="31">
  !   Maximum number of output files allowed.  Increase via the diag_manager_nml namelist.
  ! </DATA>
  ! <DATA NAME="max_output_fields" TYPE="INTEGER" DEFAULT="300">
  !   Maximum number of output fields.  Increase via the diag_manager_nml namelist.
  ! </DATA>
  ! <DATA NAME="max_input_fields" TYPE="INTEGER" DEFAULT="300">
  !   Maximum number of input fields.  Increase via the diag_manager_nml namelist.
  ! </DATA>
  ! <DATA NAME="max_out_per_in_field" TYPE="INTEGER" DEFAULT="150">
  !   Maximum number of output_fields per input_field.
  ! </DATA>
  ! <DATA NAME="max_axes" TYPE="INTEGER" DEFAULT="60">
  !   Maximum number of independent axes.
  ! </DATA>
  ! <DATA NAME="do_diag_field_log" TYPE="LOGICAL" DEFAULT=".FALSE." />
  ! <DATA NAME="write_bytes_in_file" TYPE="LOGICAL" DEFAULT=".FALSE." />
  ! <DATA NAME="debug_diag_manager" TYPE="LOGICAL" DEFAULT=".FALSE." />
  ! <DATA NAME="max_num_axis_sets" TYPE="INTEGER" DEFAULT="25" />
  ! <DATA NAME="use_cmor" TYPE="LOGICAL" DEFAULT=".FALSE.">
  !   Indicates if we should overwrite the MISSING_VALUE to use the CMOR missing value.
  ! </DATA>
  ! <DATA NAME="issue_oor_warnings" TYPE="LOGICAL" DEFAULT=".TRUE.">
  !   Issue warnings if the output field has values outside the given
  !   range for a variable.
  ! </DATA>
  ! <DATA NAME="oor_warnings_fatal" TYPE="LOGICAL" DEFAULT=".FALSE.">
  !   Cause a fatal error if the output field has a value outside the
  !   given range for a variable.
  ! </DATA>
  ! <DATA NAME="max_field_attributes" TYPE="INTEGER" DEFAULT="2">
  !   Maximum number of user definable attributes per field.
  ! </DATA>
  ! <DATA NAME="max_file_attributes" TYPE="INTEGER" DEFAULT="2">
  !   Maximum number of user definable global attributes per file.
  ! </DATA>
  ! <DATA NAME="prepend_date" TYPE="LOGICAL" DEFAULT=".TRUE.">
  !   Indicates if the file start date will be prepended to the file name.  <TT>.TRUE.</TT> is
  !   only supported if the diag_manager_init routine is called with the optional time_init parameter.
  !   This was usually done by FRE after the model run.
  ! </DATA>
  ! <DATA NAME="region_out_use_alt_value" TYPE="LOGICAL" DEFAULT=".TRUE.">
  !   Will determine which value to use when checking a regional output if the region is the full axis or a sub-axis.
  !   The values are defined as <TT>GLO_REG_VAL</TT> (-999) and <TT>GLO_REG_VAL_ALT</TT> (-1) in <TT>diag_data_mod</TT>.
  ! </DATA>
  LOGICAL :: append_pelist_name = .FALSE.
  LOGICAL :: mix_snapshot_average_fields =.FALSE.
  INTEGER :: max_files = 31 !< Maximum number of output files allowed.  Increase via diag_manager_nml.
  INTEGER :: max_output_fields = 300 !< Maximum number of output fields.  Increase via diag_manager_nml.
  INTEGER :: max_input_fields = 300 !< Maximum number of input fields.  Increase via diag_manager_nml.
  INTEGER :: max_out_per_in_field = 150 !< Maximum number of output_fields per input_field.  Increase via diag_manager_nml.
  INTEGER :: max_axes = 60 !< Maximum number of independent axes.
  LOGICAL :: do_diag_field_log = .FALSE.
  LOGICAL :: write_bytes_in_file = .FALSE.
  LOGICAL :: debug_diag_manager = .FALSE.
  LOGICAL :: conserve_water = .TRUE. ! Undocumented namelist to control flushing of output files.
  INTEGER :: max_num_axis_sets = 25
  LOGICAL :: use_cmor = .FALSE.
  LOGICAL :: issue_oor_warnings = .TRUE.
  LOGICAL :: oor_warnings_fatal = .FALSE.
  LOGICAL :: region_out_use_alt_value = .TRUE.

  INTEGER :: max_field_attributes = 2
  INTEGER :: max_file_attributes = 2
  LOGICAL :: prepend_date = .TRUE.
  ! <!-- netCDF variable -->
  ! <DATA NAME="FILL_VALUE" TYPE="REAL" DEFAULT="NF90_FILL_REAL">
  !   Fill value used.  Value will be <TT>NF90_FILL_REAL</TT> if using the
  !   netCDF module, otherwise will be 9.9692099683868690e+36.
  ! </DATA>
#ifdef use_netCDF
  REAL :: FILL_VALUE = NF_FILL_REAL  ! from file /usr/local/include/netcdf.inc
#else
  REAL :: FILL_VALUE = 9.9692099683868690e+36
#endif

  INTEGER :: pack_size = 1 ! 1 for double and 2 for float

  ! <!-- REAL public variables -->
  ! <DATA NAME="EMPTY" TYPE="REAL" DEFAULT="0.0" />
  ! <DATA NAME="MAX_VALUE" TYPE="REAL" />
  ! <DATA NAME="MIN_VALUE" TYPE="REAL" />
  REAL :: EMPTY = 0.0
  REAL :: MAX_VALUE, MIN_VALUE

  ! <!-- Global data for all files -->
  ! <DATA NAME="diag_init_time" TYPE="TYPE(time_type)">
  !   Time diag_manager_init called.  If init_time not included in
  !   diag_manager_init call, then same as base_time
  ! </DATA>
  ! <DATA NAME="base_time" TYPE="TYPE(time_type)" />
  ! <DATA NAME="base_year" TYPE="INTEGER" />
  ! <DATA NAME="base_month" TYPE="INTEGER" />
  ! <DATA NAME="base_day" TYPE="INTEGER" />
  ! <DATA NAME="base_hour" TYPE="INTEGER" />
  ! <DATA NAME="base_minute" TYPE="INTEGER" />
  ! <DATA NAME="base_second" TYPE="INTEGER" />
  ! <DATA NAME="global_descriptor" TYPE="CHARACTER(len=256)" />
  TYPE(time_type) :: diag_init_time
  TYPE(time_type) :: base_time
  INTEGER :: base_year, base_month, base_day, base_hour, base_minute, base_second
  CHARACTER(len = 256):: global_descriptor

  ! <!-- ALLOCATABLE variables -->
  ! <DATA NAME="files" TYPE="TYPE(file_type), DIMENSION(:), SAVE, ALLOCATABLE" />
  ! <DATA NAME="input_fields" TYPE="TYPE(input_field_type), DIMENSION(:), ALLOCATABLE" />
  ! <DATA NAME="output_fields" TYPE="TYPE(output_field_type), DIMENSION(:), ALLOCATABLE" />
  TYPE(file_type), SAVE, ALLOCATABLE :: files(:)
  TYPE(input_field_type), ALLOCATABLE :: input_fields(:)
  TYPE(output_field_type), ALLOCATABLE :: output_fields(:)

  ! <!-- Even More Variables -->
  ! <DATA NAME="time_zero" TYPE="TYPE(time_type)" />
  ! <DATA NAME="first_send_data_call" TYPE="LOGICAL" DEFAULT=".TRUE." />
  ! <DATA NAME="module_is_initialized" TYPE="LOGICAL" DEFAULT=".FALSE." />
  ! <DATA NAME="diag_log_unit" TYPE="INTEGER" />
  ! <DATA NAME="time_unit_list" TYPE="CHARACTER(len=10), DIMENSION(6)"
  !       DEFAULT="(/'seconds   ', 'minutes   ', 'hours     ', 'days      ', 'months    ', 'years     '/)" />
  ! <DATA NAME="pelist_name" TYPE="CHARACTER(len=32)" />
  TYPE(time_type) :: time_zero
  LOGICAL :: first_send_data_call = .TRUE.
  LOGICAL :: module_is_initialized = .FALSE.
  INTEGER :: diag_log_unit
  CHARACTER(len=10), DIMENSION(6) :: time_unit_list = (/'seconds   ', 'minutes   ',&
       & 'hours     ', 'days      ', 'months    ', 'years     '/)
  CHARACTER(len=32) :: pelist_name
  INTEGER :: oor_warning = WARNING

END MODULE diag_data_mod

module idealized_bc_mod 
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  ! This file is a part of MOM.                                                                 
  !                                                                      
  ! MOM is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  !!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Z. Liang  </CONTACT>
  !<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies </REVIEWER>

  !<OVERVIEW>
  ! For preparing idealized mom4 surface boundary conditions
  !</OVERVIEW>
  !
  !<DESCRIPTION>
  ! This program prepares idealized surface boundary conditions. The generated data
  ! contains some or all of the following, temperature, salinity, water flux,
  ! zonal and meridinal wind stress. The choice of output data is controlled by 
  ! namelist option.  Results are netcdf files that are then read into mom4.
  ! Various idealized options are available as selected by a namelist.
  !</DESCRIPTION>

  use fms_mod,         only : write_version_number, stdout, open_namelist_file
  use fms_mod,         only : file_exist, check_nml_error,  read_data
  use mpp_domains_mod, only : mpp_global_sum, domain2d, mpp_define_layout, mpp_global_field
  use mpp_domains_mod, only : mpp_define_domains, mpp_get_compute_domain, mpp_get_data_domain
  use mpp_domains_mod, only : mpp_update_domains, BITWISE_EXACT_SUM, CYCLIC_GLOBAL_DOMAIN
  use mpp_io_mod,      only : mpp_open, mpp_close, axistype, fieldtype, MPP_RDONLY,MPP_NETCDF
  use mpp_io_mod,      only : MPP_MULTI, MPP_SINGLE, MPP_OVERWR, mpp_get_atts,  mpp_get_axis_data
  use mpp_io_mod,      only : mpp_get_info, mpp_get_axes, mpp_write_meta, mpp_write
  use mpp_mod,         only : mpp_pe, mpp_root_pe, mpp_npes, mpp_error, FATAL, NOTE
  use mpp_mod,         only : mpp_min, mpp_max, mpp_chksum
  use constants_mod,   only : PI, RADIUS, EPSLN, RADIAN

  implicit none
  private

  !--- namelist ----------------------------------------------------------
  !<NAMELIST NAME="idealized_bc_nml">
  !  <DATA NAME="wind_type" TYPE="character(len=128)" >
  !  Control the iealized boundary wind stress condition options. 
  !  There are four options available and the default value is 
  !  "constant_tau". When temp_type is
  !  1. = "constant_tau", use space-time constant wind stress.
  !  2. = "cosine_zonal_winds", compute idealized winds using a cosine in latitude profile.  
  !        Makes sense only when running spherical coordinate model.
  !  3. = "frank_bryan_winds", compute idealized surface wind stress using zonal wind 
  !       profile originally  used by Frank Bryan. Makes sense only when running spherical coordinate model.
  !  4. = "frank_bryan_winds_compress", use the full Frank Bryan wind profiled over a 
  !        latitudinally compressed domain. Makes sense only when running spherical coordinate model. 
  !  </DATA>
  !  <DATA NAME="taux0"  TYPE="real">
  !  Constant zonal wind stress 
  !  </DATA>
  !  <DATA NAME="tauy0"  TYPE="real">
  !  Constant meridional wind stress 
  !  </DATA>
  !  <DATA NAME="qw0" UNITS="meter/sec" TYPE="real">
  !  Fresh water flux scaling parameter for idealized surface water flux 
  !  </DATA>
  !  <DATA NAME="generate_wind_bc" TYPE="logical">
  !   Control if wind stress data will be generated. When true (default value), idealized surface boundary
  !   wind stress data will be generated. If false, do not generate wind stress data. 
  !  </DATA>
  !  <DATA NAME="generate_temp_bc" TYPE="logical">
  !   Control if temperature data will be generated. When true (default value), idealized surface boundary
  !   temperature data will be generated. If false, do not generate temperature data. 
  !  </DATA>
  !  <DATA NAME="generate_salt_bc" TYPE="logical">
  !   Control if salinity data will be generated. When true (default value), idealized surface boundary
  !   salinity data will be generated. If false, do not generate salinity data. 
  !  </DATA>
  !  <DATA NAME="generate_water_bc" TYPE="logical">
  !   Control if water flux data will be generated. When true (default value), idealized surface boundary
  !   water flux data will be generated. If false, do not generate water flux data. 
  !  </DATA>
  ! </NAMELIST>
  character(len=128) :: wind_type = 'constant_tau'
  character(len=128) :: temp_type = 'idealized_temp_restore'
  character(len=128) :: salt_type = 'idealized_salt_restore'
  character(len=128) :: water_type = 'idealized_water_flux'
  logical            :: cyclic = .true.
  logical            :: generate_wind_bc = .true.
  logical            :: generate_temp_bc = .true.
  logical            :: generate_salt_bc = .true.
  logical            :: generate_water_bc = .true.
  real               :: qw0=-3.17e-8  ! 1m/year fresh water velocity (converted to m/s) for idealized
  real               :: taux0=0.0, tauy0=0.0  ! constant zonal/meridional windstress (newton/m^2) for idealized
  namelist /idealized_bc_nml/ wind_type, taux0, tauy0, qw0,  generate_wind_bc, &
       generate_temp_bc, generate_salt_bc, generate_water_bc, cyclic

  !--- output data variables -------------------------------------------
  real, dimension(:,:), allocatable :: taux, tauy, temp, salt, water
  real, dimension(:,:), allocatable :: global_taux, global_tauy, global_temp, global_salt, global_water
  !--- output file name
  character(len=128) :: temp_file  = 'temp_sfc_restore.nc'
  character(len=128) :: salt_file  = 'salt_sfc_restore.nc'
  character(len=128) :: wind_file  = 'tau.nc'
  character(len=128) :: water_file = 'water_flux.nc'

  !--- version information 
  character(len=128) :: version = '$Id: idealized_bc.f90,v 17.0 2009/07/21 03:22:49 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $' 

  !--- other module variables
  real, dimension(:,:),    allocatable :: xu, yu, xt, yt, h1t, area_t
  real, dimension(:,:),    allocatable :: umask, tmask
  integer, dimension(:,:), allocatable :: kmt, kmu
  real, dimension(:),      allocatable :: grid_x_t, grid_y_t, grid_x_c, grid_y_c
  integer                              :: isc, iec, jsc, jec, ni, nj
  real,                      parameter :: c2mks = 0.1   ! converts dynes/cm^2 to newton/m^2 
  type(domain2d),                 save :: domain
  character(len=128)                   :: grid_file = 'INPUT/grid_spec.nc'
  logical                              :: module_is_initialized = .FALSE.

  !--- public interface
  public :: idealized_bc_init, write_idealized_bc_data, idealized_bc_end

contains

  !#######################################################################
  ! <SUBROUTINE NAME="idealized_bc_init">
  !
  ! <DESCRIPTION>
  ! Initialize the module generating ideal surface boundary conditions.
  ! </DESCRIPTION>
  ! </SUBROUTINE>
  subroutine idealized_bc_init

    !--- local variables -----------------------------------------------
    integer :: unit, ierr, io_status, chksum_temp, chksum_salt
    integer :: chksum_water, chksum_taux, chksum_tauy
    !-------------------------------------------------------------------
    if ( module_is_initialized ) call mpp_error(FATAL, 'idealized_bc_mod: attempted reinitialization')
    module_is_initialized = .TRUE.

    if (file_exist('input.nml')) then
       unit = open_namelist_file ( )
       ierr=1
       do while (ierr /= 0)
          read  (unit, idealized_bc_nml,iostat=io_status, end = 10)
          ierr = check_nml_error(io_status,'idealized_bc_nml')
       enddo
10     call mpp_close (unit)
    else
       call mpp_error(NOTE,'idealized_bc_mod: file input.nml does not exist, use default namelist option')  
    endif

    !--- at least one of generate_temp_bc, generate_salt_bc, generate_water_bc and
    !--- generate_wind_bc should be true
    if(.not.generate_temp_bc .and. .not.generate_salt_bc .and. .not.generate_wind_bc .and. .not.generate_water_bc)  &
         call mpp_error(FATAL, 'idealized_bc_mod: at least one of nml generate_temp_bc, generate_salt_bc,'//  &
                         ' generate_wind_bc, generate_water_bc should be true')

    !--- write out version information and namelist option ---------------
    call write_version_number(version, tagname)
    if (mpp_pe() == mpp_root_pe()) then
       write (stdout(), nml= idealized_bc_nml)
    endif

    !--- get grid infomration
    call get_grid

    !--- allocate memory to module variables
    allocate(temp(isc:iec,jsc:jec), salt(isc:iec,jsc:jec),  &
         taux(isc:iec,jsc:jec), tauy(isc:iec,jsc:jec), water( isc:iec,jsc:jec) )
    allocate(global_temp(ni,nj), global_salt(ni,nj), global_taux(ni,nj), &
         global_tauy(ni,nj), global_water(ni,nj) )

    ! idealized wind boundary conditions 
    if(generate_wind_bc) then
       call idealized_wind_bc()
       call mpp_global_field(domain, taux, global_taux)
       call mpp_global_field(domain, tauy, global_tauy)
       chksum_taux = mpp_chksum(taux)
       chksum_tauy = mpp_chksum(tauy)
       write (stdout(),'(/(a,I20/))')' Idealized_bc condition Checksum: taux=', chksum_taux
       write (stdout(),'(/(a,I20/))')' Idealized_bc condition Checksum: tauy=', chksum_tauy
    endif

    ! idealized temperature boundary conditions
    if(generate_temp_bc) then
       call idealized_temp_bc()
       call mpp_global_field(domain, temp, global_temp)
       chksum_temp = mpp_chksum(temp) 
       write (stdout(),'(/(a,I20/))')' Boundary condition Checksum: temp=', chksum_temp
    endif
    ! idealized salinity boundary conditions
    if(generate_salt_bc) then
       call idealized_salt_bc()
       call mpp_global_field(domain, salt, global_salt)
       chksum_salt = mpp_chksum(salt)
       write (stdout(),'(/(a,I20/))')' Boundary condition Checksum: salt=', chksum_salt
    endif
    ! idealized water flux boundary conditions
    if(generate_water_bc) then
       call idealized_water_bc()
       call mpp_global_field(domain, water, global_water)
       chksum_water = mpp_chksum(water)
       write (stdout(),'(/(a,I20/))')' Boundary condition Checksum: water=', chksum_water
    endif

    return

  end subroutine idealized_bc_init

  !#######################################################################
  !--- idealized wind stress boundary condition
  subroutine idealized_wind_bc( )

    real    :: yunj, yu1, y_lat, arg_lat, frank_scale
    integer :: i, j

    select case(trim(wind_type))
    case ('constant_tau')
       write(stdout(),*)'idealized_wind_stress being used with constant_tau.'
       taux(:,:) = taux0*umask(:,:)
       tauy(:,:) = tauy0*umask(:,:)
    case ('cosine_zonal_winds')
       write(stdout(),*)'idealized_wind_stress being used with cosine_zonal_winds.'
       yunj = yu(isc,jec)
       yu1  = yu(isc,jsc)
       do j=jsc,jec
          do i=isc,iec
             yu1  = min(yu(i,j),yu1)
             yunj = max(yu(i,j),yunj)
          enddo
       enddo
       call mpp_min (yu1)
       call mpp_max (yunj)
       do j=jsc,jec
          do i=isc,iec
             arg_lat   = (yu(i,j)-yu1)/(yunj-yu1)*2.0*PI
             taux(i,j) = -c2mks*cos(arg_lat)*umask(i,j)
             tauy(i,j) = 0.0 
          enddo
       enddo
    case ('frank_bryan_winds')
       write(stdout(),*)'idealized_wind_stress being used with frank_bryan_winds.'
       do j=jsc,jec
          do i=isc,iec
             y_lat     = abs(yu(i,j))/RADIAN
             taux(i,j) = c2mks*(0.8*(-sin(6.0*y_lat)-1.0)+0.5*(tanh(5.0*PI-10.0*y_lat)+tanh(10.0*y_lat)))
             taux(i,j) = taux(i,j)*umask(i,j)
             tauy(i,j) = 0.0 
          enddo
       enddo
    case ('frank_bryan_winds_compress')
       write(stdout(),*)'idealized_wind_stress being used with frank_bryan_winds_compress.'
       do j=jsc,jec
          do i=isc,iec
             frank_scale = 90.0/yu(i,nj)
             y_lat      = frank_scale*abs(yu(i,j))/RADIAN
             taux(i,j) = c2mks*(0.8*(-sin(6.0*y_lat)-1.0)+0.5*(tanh(5.0*PI-10.0*y_lat)+tanh(10.0*y_lat)))
             taux(i,j) = taux(i,j)*umask(i,j)
             tauy(i,j) = 0.0 
          enddo
       enddo
    case default
       call mpp_error(FATAL,'idealized_bc_mod: '//trim(wind_type)//' is not a valid option of nml " wind_type" ')
    end select

  end subroutine idealized_wind_bc

  !#######################################################################
    !--- idealized temperature boundary condition
  subroutine idealized_temp_bc

    select case(trim(temp_type))
    case('idealized_temp_restore')
       write(stdout(),*)'idealized_temp_restore gives an idealized profile for restoring surface temperature.'
       temp(isc:iec,jsc:jec) = 26.93 - 0.3618*abs(yt(isc:iec,jsc:jec)) 
    case default
       call mpp_error(FATAL,'idealized_bc_mod: '//trim(temp_type)//' is not a valid option of nml "temp_type"')
    end select

  end subroutine idealized_temp_bc

  !#######################################################################
  !--- idealized profile for restoring surface salinity
  subroutine idealized_salt_bc

    !--- idealized salinity
    select case(trim(salt_type))
    case('idealized_salt_restore')
       write(stdout(),*)'idealized_salt_restore gives an idealized profile for restoring surface salinity.'
       salt(isc:iec,jsc:jec) = 24.+12.*sin(2.*abs(yt(isc:iec,jsc:jec))/RADIAN)
    case default
       call mpp_error(FATAL,'idealized_bc_mod: '//trim(salt_type)//' is not a valid option of nml salt_type')
    end select

  end subroutine idealized_salt_bc

  !#######################################################################
  !--- idealized water flux
  subroutine idealized_water_bc

    real    :: yt1, ytnj, surf_area, total_sfwf
    integer :: i, j     

    select case(trim(water_type))
    case('idealized_water_flux')
       write(stdout(),*)'idealized_water_flux gives an idealized profile for surface fresh water flux.'
       ! bounding latitudes for ideal water flux
       ytnj = yt(isc,jsc); yt1 = yt(isc,jsc)
       do j=jsc,jec
          do i=isc,iec
             yt1  = min(yt(i,j),yt1)
             ytnj = max(yt(i,j),ytnj)
          enddo
       enddo
       call mpp_min (yt1)
       call mpp_max (ytnj)

       surf_area=0.0 ; total_sfwf=0.0
       water(:,:) = tmask(:,:)*(qw0*RADIUS/h1t(:,:))*(1.0-2.0*(yt(isc:iec,jsc:jec)-yt1)/(ytnj-yt1))
       total_sfwf = mpp_global_sum (domain, area_t(:,:)*water(:,:), BITWISE_EXACT_SUM)        
       surf_area  = mpp_global_sum (domain, area_t(:,:)*tmask(:,:),  BITWISE_EXACT_SUM) 
       total_sfwf = total_sfwf/(epsln+surf_area)
       water(:,:) = tmask(:,:)*(water(:,:)-total_sfwf)
    case default
       call mpp_error(FATAL,'idealized_bc_mod: '//trim(water_type)//' is not a valid option of nml water_type')
    end select

  end subroutine idealized_water_bc

  !#######################################################################
  ! <SUBROUTINE NAME="idealized_bc_end">
  !
  ! <DESCRIPTION>
  !  Release memory.
  ! </DESCRIPTION>
  ! </SUBROUTINE>

  subroutine idealized_bc_end

    deallocate(taux, tauy, temp, salt, water, kmt, kmu, xu, yu, xt, yt, h1t)
    deallocate(area_t, umask, tmask, grid_x_t, grid_y_t, grid_x_c, grid_y_c)

    module_is_initialized = .false.
    return

  end subroutine idealized_bc_end

  !#######################################################################
  !--- read grid from grid_spec file.
  subroutine get_grid

    integer,                     dimension(2) :: layout  = (/ 1, 0 /)
    integer                                   :: unit, npes, ndim, nvar, natt, ntime, len
    integer                                   :: mi, mj, i, j, k, kb, isd, ied, jsd, jed
    type(axistype), dimension(:), allocatable :: axes
    real, dimension(:,:),         allocatable :: tmp, ht
    real, dimension(:),           allocatable :: dzt, fracdz 
    real, dimension(:,:,:),       allocatable :: dht, ztp
    character(len=128)                        :: name

    !--- get grids information -------------------------------------------
    npes = mpp_npes()
    ni = 0; nj = 0
    if(file_exist(trim(grid_file))) then
       call mpp_open(unit,trim(grid_file),MPP_RDONLY,MPP_NETCDF,threading=MPP_MULTI,fileset=MPP_SINGLE)
       call mpp_get_info(unit, ndim, nvar, natt, ntime)
       allocate(axes(ndim))
       call mpp_get_axes(unit,axes)
       do i=1, ndim
          call mpp_get_atts(axes(i),name=name,len=len)
          select case(trim(name))
          case ('grid_x_T')
             ni = len
             allocate(grid_x_t(ni))
             call mpp_get_axis_data(axes(i),data=grid_x_t)
          case ('grid_y_T')
             nj = len
             allocate(grid_y_t(nj))
             call mpp_get_axis_data(axes(i),data=grid_y_t)        
          case ('grid_x_C')
             mi = len
             allocate(grid_x_c(mi))
             call mpp_get_axis_data(axes(i),data=grid_x_c)
          case ('grid_y_C')
             mj = len
             allocate(grid_y_c(mj))
             call mpp_get_axis_data(axes(i),data=grid_y_c)        
          end select
       enddo
       call mpp_close(unit)
       if(ni == 0) call mpp_error(FATAL,'idealized_bc_mod: '//trim(grid_file)//' does not contain axis grid_x_T')
       if(nj == 0) call mpp_error(FATAL,'idealized_bc_mod: '//trim(grid_file)//' does not contain axis grid_y_T')
       if(mi .ne. ni .or. mj .ne. mj) call mpp_error(FATAL,'idealized_bc_mod: in '//trim(grid_file) &
            //' T-grid and C-grid should have the same size')

       !--- define domain ------------------------------------------------
       call mpp_define_layout((/1,ni,1,nj/),npes,layout)
       if(cyclic) then
          call mpp_define_domains((/1,ni,1,nj/),layout, domain, xflags = CYCLIC_GLOBAL_DOMAIN, xhalo=1, yhalo=1)
       else
          call mpp_define_domains((/1,ni,1,nj/),layout, domain, xhalo=1, yhalo=1)
       endif
       call mpp_get_compute_domain(domain, isc, iec, jsc, jec)
       call mpp_get_data_domain(domain, isd, ied, jsd, jed)
       allocate(xt(ni,nj), yt(ni,nj), xu(ni,nj),  &
            yu(ni,nj), kmt(isc:iec,jsc:jec), kmu(isc:iec,jsc:jec),   &
            h1t(isc:iec,jsc:jec), area_t(isc:iec,jsc:jec), tmask(isc:iec,jsc:jec), &
            umask(isc:iec,jsc:jec), tmp(isd:ied,jsd:jed) )
       tmp = 10000.0  ! dummy large number
       call read_data(trim(grid_file), 'x_T', xt)
       call read_data(trim(grid_file), 'y_T', yt)
       call read_data(trim(grid_file), 'x_C', xu)
       call read_data(trim(grid_file), 'y_C', yu )
       call read_data(trim(grid_file), 'num_levels', tmp(isc:iec,jsc:jec), domain)
       call read_data(trim(grid_file), 'area_T',area_t, domain)
       call mpp_update_domains(tmp,domain)
       kmt(isc:iec,jsc:jec) = tmp(isc:iec,jsc:jec)
       do j=jsc,jec
          do i=isc,iec
             kmu(i,j) = min(tmp(i,j), tmp(i+1,j), tmp(i,j+1), tmp(i+1,j+1))
          enddo
       enddo
       tmask = 0.0
       where(kmt .ge. 1) tmask = 1.0
       umask = 0.0
       where(kmu .ge. 1) umask = 1.0

       do j=jsc,jec
          do i=isc,iec
             if (cos(yt(i,j)/RADIAN) == 0.0) then
                h1t(i,j) = radius*abs(EPSLN)
             else
                h1t(i,j) = radius*cos(yt(i,j)/RADIAN)
             endif
          enddo
       enddo
    else
       call mpp_error(FATAL, 'idealized_bc_mod: file '//trim(grid_file)//' does not exist in your work directory')
    endif

    ! release memory
    deallocate(axes, tmp)

  end subroutine get_grid

  !#######################################################################
  ! <SUBROUTINE NAME="write_idealized_bc_data">
  !
  ! <DESCRIPTION>
  !    Write the idealized boundary condition to netcdf file.
  ! </DESCRIPTION>
  ! </SUBROUTINE>
  subroutine write_idealized_bc_data

    if(generate_temp_bc) call write_flux_data(temp_file, global_temp, 'temp', 'deg_c', 'surface restoring temp')
    if(generate_salt_bc) call write_flux_data(salt_file, global_salt, 'salt', 'g/kg', 'surface restoring salinity')
    if(generate_water_bc) call write_flux_data(water_file, global_water, 'lprec', 'm/s', 'surface liquid water flux')
    if(generate_wind_bc) call write_wind_data()

    return

  end subroutine write_idealized_bc_data

  !#######################################################################
  !--- write tracer data to output file
  subroutine write_flux_data(file, flux, fld_name, fld_unit, fld_longname)

    character(len=*), intent(in)       :: file, fld_name, fld_unit, fld_longname
    real, dimension(:,:),intent(inout) :: flux

    integer         :: unit
    type(axistype)  :: axis_x, axis_y, axis_t
    type(fieldtype) :: fld_x_t, fld_y_t, fld_flux

    call mpp_open(unit,trim(file), MPP_OVERWR, MPP_NETCDF, threading=MPP_SINGLE, fileset=MPP_SINGLE)

    !--- write out meta data ---------------------------------------------
    call mpp_write_meta(unit, axis_x,'grid_x_T','degree_east','Nominal Longitude of T-cell center', &
         cartesian ='X', data = grid_x_t )
    call mpp_write_meta(unit, axis_y,'grid_y_T','degree_north','Nominal Latitude of T-cell center', &
         cartesian ='Y', data = grid_y_t )
    call mpp_write_meta(unit,axis_t,'TIME','days since 0001-01-01 00:00:00','TIME',cartesian='T' )
    call mpp_write_meta(unit, fld_x_t, (/axis_x, axis_y/), 'x_T', 'degree_east',  &
         'Geographic longitude of T_cell centers', pack=1)
    call mpp_write_meta(unit, fld_y_t, (/axis_x, axis_y/), 'y_T', 'degree_north',  &
         'Geographic latitude of T_cell centers', pack=1)
    call mpp_write_meta(unit, fld_flux, (/axis_x, axis_y, axis_t/), trim(fld_name), &
         trim(fld_unit), trim(fld_longname), pack=1)

    !--- write out data --------------------------------------------------
    call mpp_write(unit, axis_x)
    call mpp_write(unit, axis_y)
    call mpp_write(unit, fld_x_t, xt)
    call mpp_write(unit, fld_y_t, yt)
    call mpp_write(unit, fld_flux, flux, tstamp=1.)
    call mpp_close(unit)

  end subroutine write_flux_data
  !#######################################################################
  !--- write stress wind to the output file wind_file
  subroutine write_wind_data( )

    integer         :: unit
    type(axistype)  :: axis_x, axis_y, axis_t
    type(fieldtype) :: fld_x_c, fld_y_c, fld_taux, fld_tauy

    call mpp_open(unit,trim(wind_file), MPP_OVERWR, MPP_NETCDF, threading=MPP_SINGLE, fileset=MPP_SINGLE)

    !--- write out meta data ---------------------------------------------
    call mpp_write_meta(unit, axis_x,'grid_x_C','degree_east','Nominal Longitude of C-cell center', &
         cartesian ='X', data = grid_x_c )
    call mpp_write_meta(unit, axis_y,'grid_y_C','degree_north','Nominal Latitude of C-cell center', &
         cartesian ='Y',  data = grid_y_c )
    call mpp_write_meta(unit,axis_t,'TIME','days since 0001-01-01 00:00:00','TIME', cartesian='T' )
    call mpp_write_meta(unit, fld_x_c, (/axis_x, axis_y/), 'x_C', 'degree_east',  &
         'Geographic longitude of C_cell centers', pack=1)
    call mpp_write_meta(unit, fld_y_c, (/axis_x, axis_y/), 'y_C', 'degree_north',  &
         'Geographic latitude of C_cell centers', pack=1)
    call mpp_write_meta(unit, fld_taux, (/axis_x, axis_y, axis_t/), 'taux', &
         'N/m^2', 'ZONAL WIND STRESS', pack=1)
    call mpp_write_meta(unit, fld_tauy, (/axis_x, axis_y, axis_t/), 'tauy', &
         'N/m^2', 'MERIDIONAL WIND STRESS', pack=1)
    !--- write out data --------------------------------------------------
    call mpp_write(unit, axis_x)
    call mpp_write(unit, axis_y)
    call mpp_write(unit, fld_x_c, xu)
    call mpp_write(unit, fld_y_c, yu)
    call mpp_write(unit, fld_taux,  global_taux, tstamp=1.)
    call mpp_write(unit, fld_tauy,  global_tauy, tstamp=1.)
    call mpp_close(unit)

  end subroutine write_wind_data

  !#######################################################################

end module idealized_bc_mod

      MODULE MCM_SW_DRIVER_MOD
!
!
!   TK modified from Kerr code 
!     /t90/tk/climatemodel/r30/atm_leg1/atm5a/atmlib_mods/no_ifdefs
!
!   Added interface routine (mcm_shortwave_driver) which is called by
!     fsrad and which calls mcm_swnew in this
!     module after constructing the appropriate inputs.
!
!   TK mod (6/01/01) added test to make sure CosZ is greater than
!     zero, otherwise skip sw calculation and set output to zero
!     for that point...
!!
!
!

!      USE   Constants_Mod, ONLY: grav, tfreeze

      Use       Fms_Mod, ONLY: Error_Mesg, FATAL, &
                               write_version_number, mpp_pe, mpp_root_pe

      use mcm_swnew_mod, only: mcm_swnew

implicit none
      private

      integer :: kx, kp
      character(len=128) :: version = '$Id: mcm_sw_driver.F90,v 10.0 2003/10/24 22:00:31 fms Exp $'
      character(len=128) :: tagname = '$Name: tikal $'
      logical :: module_is_initialized = .false.

      public :: mcm_shortwave_driver, mcm_sw_driver_init, &
                mcm_sw_driver_end

!     -------------------------------------------------
! TK NOTE: not ready for this yet...      implicit none




contains

      subroutine mcm_shortwave_driver(                                 &
                     Nclds, KtopSW, KbtmSW, Press, Rh2o, Qo3, CldAmt, &
                     CUVRF, CIRRF, CIRAB, Rco2, CosZ, SSolar,         &
                     Albedo, FSW, DFSW, UFSW, TdtSW, Phalf)


!     TK Original calling parameters in Kerr code:
!     &     ccosz, ttauda, rco2, solc, p, pp, qmh,
!     &     etabl, gvbrps, gqmix, grad, slwdp, rclim, dduo3n, r, 
!     &     flx, heat,
!     &     radian, radang,
!     &     zsnit, zsnitc, zsng, zsngc, zplalb, zplalbc, icf,
!
!     &     q, calb, iflg, ncv,
!
!     &     ipower, kflags,
!
!     &     tfra, alb, ts, zin, ca, oas,
!     &     snwdpt,
!     &     pkice,
!
!     &     kp, kx, ng, lx, nc, il, ix, jrow, iy, ls, ih, nhem)


      integer, intent (in), dimension(:,:)     :: Nclds
      integer, intent (in), dimension(:,:,:)      :: KtopSW, KbtmSW
      real, intent (in)   , dimension(:,:,:)      :: Press, Phalf
      real, intent (in)   , dimension(:,:,:)      :: CldAmt, CUVRF,&
                                                  &  CIRRF, CIRAB
      real, intent (in)   , dimension(:,:,:)      :: Rh2o, Qo3

      real, intent (in)                           :: Rco2
      real, intent (in)   , dimension(:,:)        :: CosZ
      real, intent (in)   , dimension(:,:)        :: SSolar
      real, intent (in)   , dimension(:,:)        :: Albedo

      REAL,   INTENT(OUT), DIMENSION(:,:,:)       :: FSW, DFSW, UFSW
      REAL,   INTENT(OUT), DIMENSION(:,:,:)       :: TdtSW


!----------------LOCAL ARRAY STORAGE------------------------------------

      INTEGER, DIMENSION(kx+2)   :: kthsw, kbhsw
      REAL,    DIMENSION(kx+2)   :: cwca, cwcb, coca, cloudy
      REAL,    DIMENSION(kx+1)   :: flx, heat, UF, DF
      REAL                       :: grdflx
      real,   dimension(0:kx)   :: pp
      real,   dimension(1:kx+1) :: pr2
      real,   dimension(size(press,1), size(press,2), kx) :: sigma_level

      integer ncv
      real pchg

      INTEGER :: ix, jx
      integer :: ipt, jrow, k

      if(.not.module_is_initialized) then
        call error_mesg('mcm_shortwave_driver', &
                        'shortwave_driver_mod is not initialized',FATAL)
      endif

      ix = SIZE(Press,1)
      jx = SIZE(Press,2)

!     Compute sigma levels, which are needed for an mcm_swnew routine input:
      do k=1,kx
        sigma_level(:,:,k) = Press(:,:,k) / Phalf(:,:,kp)
      enddo

!     Loop over all points in the horizontal array, computing
!       radiation for one column at a time in mcm_swnew...

      do jrow = 1, jx

         do ipt = 1, ix

!           Create necessary column input arrays for mcm_swnew routine:

            do k = 1, kp

               kthsw (k) = KtopSW (ipt,jrow,k)
               kbhsw (k) = KbtmSW (ipt,jrow,k)

               cwca (k) = CIRRF (ipt,jrow,k)
               cwcb (k) = CIRAB (ipt,jrow,k)
               coca (k) = CUVRF (ipt,jrow,k)
               cloudy(k) = CldAmt (ipt,jrow,k)

            end do

            ncv = Nclds(ipt,jrow) + 2

!           Load surface albedo into 2 input arrays in location ncv:
            cwca (ncv) = Albedo (ipt,jrow)           
            coca (ncv) = Albedo (ipt,jrow) 

!           Set ncv element of cloudy to 1.0 to match supersource:
            cloudy(ncv) = 1.0

!           Also initialize ncv+1 element of the cloud arrays (not
!            sure if this is actually done in SS but trying to
!            match the input arrays for the sample point -- TK):

            cwca (ncv+1) = Albedo (ipt,jrow)           
            coca (ncv+1) = Albedo (ipt,jrow) 
            cloudy(ncv+1) = 1.0
            cwcb(ncv+1) = 0.0

!          Initialize element 1 of the following arrays exactly as
!           in supersource:

            kbhsw (  1) = 1
            cwca  (  1) = 0.0
            cwcb  (  1) = 0.0
            coca  (  1) = 0.0
            cloudy(  1) = 0.0


!           Compute pp, pr2 input arrays for mcm_swnew:

            do k = 0, kx
               pp(k) = Phalf(ipt,jrow,k+1) * 10
            end do

            pchg = sqrt (Phalf(ipt,jrow,kp)/101325.0)
            do k = 1, kx
               pr2(k) = sqrt(sigma_level(ipt,jrow,k)) * pchg
            end do  

!!           TK Print diagnostics for auxilary inputs:
!            if ((ipt .eq. 49) .and. (jrow .eq. 27)) then
!               print *
!               print *, 'TK chkpt 1 in mcm_sw_mod.F.i=49,j= ', jrow
!               print *
!               print *, ' Cosz (FMS computed) = ', Cosz(ipt,jrow)
!
!               print *, ' rco2 = ', rco2
!               print *, ' rh2o = ', Rh2o(ipt,jrow,:)
!               print *, ' ro3 = ', Qo3(ipt,jrow,:)
!               print *, ' pp[0:kx] = ', pp
!               print *, ' Ssolar (calculated) = ', Ssolar(ipt,jrow)
!               print *, ' pr2[1:kx+1] = ', pr2
!               print *, ' kx = ', kx
!               print *
!               print *, ' Cloud data for shortwave: '
!               print *, '      (use only k = 2 to nc1 for clouds)'
!               print *, '      (use k = ncv for surface albedo)'
!               print *, ' ncv = ', ncv  
!               print *, ' k cloudy kthsw kbhsw      cwca ',       &
!     &             '             cwcb               coca    '
!               print *
!               do 325 k = 1, kx
!                  write(6,323) k, cloudy(k), kthsw(k), kbhsw(k),  &
!     &               cwca(k), cwcb(k), coca(k)
!323               format (i3, 2x, f4.2, 2x, i3, 2x, i3, 3(2x, e15.6))
!325            continue
!               print *
!               do k = 0, kx
!                  print *, ' k, pp(k) = ', k, pp(k)
!               end do
!               do k = 1, kx
!                  print *, ' k, pr2(k) = ', k, pr2(k)
!               end do
!               print *
!            end if

!         Only call shortwave routine if CosZ is greater than 0.0

            if (CosZ(ipt,jrow) > 0.0) then       

               call mcm_swnew (CosZ(ipt,jrow),                &
                 rco2, Rh2o(ipt,jrow,:), Qo3(ipt,jrow,:), pp, &
                 cwca, cwcb, coca, cloudy, kthsw, kbhsw,      &
                 Ssolar(ipt,jrow), pr2,                       &
                 flx, heat, grdflx, ncv, kx, UF, DF)

!              Fill the appropriate output arrays with the column output:

               do k = 1, kp
                  FSW(ipt,jrow,k) = flx(k)
                  DFSW(ipt,jrow,k) = DF(k)
                  UFSW(ipt,jrow,k) = UF(k)
               end do

               do k = 1, kx
                  TdtSw(ipt,jrow,k) = heat(k)
               end do

            else
!              CosZ is  0.0, so zero sw output arrays at that point:
                  
               do k = 1, kp
                  FSW(ipt,jrow,k) = 0.
                  DFSW(ipt,jrow,k) = 0.
                  UFSW(ipt,jrow,k) = 0.
               end do

               do k = 1, kx
                  TdtSw(ipt,jrow,k) = 0.
               end do

            end if

!!           TK Print diagnostics:
!            if ((ipt .eq. 49) .and. (jrow .eq. 27)) then
!               print *
!               print *, ' mcm_swnew output arrays, etc: '
!               print *
!               print *, ' k      flx (ergs/cm2/sec)      heat (K/day) '
!               do 328 k = 1, kx+1
!                  write(6,327) k, flx(k), heat(k)
!327               format (i3, 7x, f14.6, 3x, f15.9)
!328            continue
!               print *
!               print *, ' grdflx [ergs/cm2/sec] = ', grdflx
!               print *
!            end if

         end do
      end do

      end subroutine mcm_shortwave_driver
! ---------------------------------------------------------------------------------------
      subroutine mcm_sw_driver_init(kx_in)
      integer, intent(in) :: kx_in

      kx = kx_in
      kp = kx + 1
!------- write version number and namelist ---------

      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
      endif

      module_is_initialized = .true.

      return
      end subroutine mcm_sw_driver_init
! ---------------------------------------------------------------------------------------

      subroutine mcm_sw_driver_end

      module_is_initialized = .false.
!---------------------------------------------------------------------

      end subroutine mcm_sw_driver_end
! ---------------------------------------------------------------------------------------
      end module MCM_SW_DRIVER_MOD

module ocean_velocity_diag_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies
!</CONTACT>
!
!<OVERVIEW>
! Numerical diagnostics for velocity related quantities. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module contains some diagnostics for velocity related quantities.
! Account is taken for either Bgrid or Cgrid layout of the velocity 
! and related discrete fields.  
! </DESCRIPTION>
!
!<NAMELIST NAME="ocean_velocity_diag_nml">
!
!  <DATA NAME="diag_step" UNITS="dimensionless" TYPE="integer">
!  Number of time steps between which compute the diagnostics.
!  </DATA> 
!  <DATA NAME="energy_diag_step" TYPE="integer">
!  Perform energy analysis every n timesteps (1==every time step). 
!  This diagnostic is expensive, so should be used sparingly during
!  production runs.  
!  </DATA> 
!
!  <DATA NAME="land_cell_num_max" UNITS="dimensionless" TYPE="integer">
!  Maximum number of land cells where will printout nonzero velocity points.  
!  Default land_cell_num_max=100.
!  </DATA> 
!  <DATA NAME="max_cfl_value" UNITS="dimensionless" TYPE="real">
!  Critical value for Courant number, above which the model will be brought down.
!  </DATA> 
!  <DATA NAME="large_cfl_value" UNITS="dimensionless" TYPE="real">
!  Large value for Courant number, above which will write some diagnostics. 
!  </DATA> 
!  <DATA NAME="verbose_cfl" TYPE="logical">
!  For printing out lots of information about regions of large Courant numbers.
!  </DATA> 
!
!  <DATA NAME="do_bitwise_exact_sum" TYPE="logical">
!  Set true to do bitwise exact global sum. When it is false, the global
!  sum will be non-bitwise_exact, but will significantly increase efficiency. 
!  The default value is false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
! For some debugging purposes 
!  </DATA> 
!
!</NAMELIST>

#include <fms_platform.h>

use constants_mod,    only: epsln, c2dbars, omega 
use diag_manager_mod, only: register_diag_field, register_static_field, need_data, send_data
use fms_mod,          only: open_namelist_file, check_nml_error, close_file, write_version_number
use fms_mod,          only: FATAL, stdout, stdlog
use mpp_domains_mod,  only: mpp_global_sum, mpp_update_domains
use mpp_domains_mod,  only: BITWISE_EXACT_SUM, NON_BITWISE_EXACT_SUM, BGRID_NE
use mpp_mod,          only: input_nml_file, mpp_error, mpp_max, mpp_sum, mpp_pe 
use mpp_mod,          only: mpp_clock_id, mpp_clock_begin, mpp_clock_end, CLOCK_MODULE
use time_manager_mod, only: time_type, increment_time

use ocean_bih_friction_mod,    only: bih_friction, bih_viscosity_check, bih_reynolds_check
use ocean_coriolis_mod,        only: coriolis_force_bgrid, coriolis_force_cgrid
use ocean_domains_mod,         only: get_local_indices
use ocean_form_drag_mod,       only: form_drag_accel
use ocean_lap_friction_mod,    only: lap_friction, lap_viscosity_check, lap_reynolds_check
use ocean_momentum_source_mod, only: momentum_source
use ocean_operators_mod,       only: FAX, FAY, REMAP_BT_TO_BU, BDX_ET, BDY_NT
use ocean_parameters_mod,      only: DEPTH_BASED, PRESSURE_BASED, missing_value
use ocean_parameters_mod,      only: ENERGETIC, FINITEVOLUME
use ocean_parameters_mod,      only: MOM_BGRID, MOM_CGRID 
use ocean_parameters_mod,      only: rho0, rho0r, grav, onehalf
use ocean_pressure_mod,        only: hydrostatic_pressure, geopotential_anomaly
use ocean_pressure_mod,        only: hydrostatic_pressure_blob, geopotential_anomaly_blob
use ocean_types_mod,           only: ocean_grid_type, ocean_domain_type
use ocean_types_mod,           only: ocean_time_type, ocean_time_steps_type, ocean_thickness_type
use ocean_types_mod,           only: ocean_adv_vel_type, ocean_external_mode_type
use ocean_types_mod,           only: ocean_velocity_type, ocean_density_type
use ocean_types_mod,           only: ocean_lagrangian_type
use ocean_util_mod,            only: write_timestamp, matrix, diagnose_2d, diagnose_3d, diagnose_3d_u, diagnose_3d_en
use ocean_util_mod,            only: write_chksum_3d, write_chksum_2d
use ocean_velocity_advect_mod, only: horz_advection_of_velocity, vert_advection_of_velocity
use ocean_vert_mix_mod,        only: vert_friction_bgrid, vert_friction_cgrid
use ocean_workspace_mod,       only: wrk1, wrk2, wrk3, wrk4, wrk5, wrk6 
use ocean_workspace_mod,       only: wrk1_v2d, wrk2_v2d  
use ocean_workspace_mod,       only: wrk1_2d, wrk2_2d, wrk3_2d
use ocean_workspace_mod,       only: wrk1_v, wrk2_v, wrk3_v

implicit none

private

#include <ocean_memory.h>

! useful constants
real :: dbars2Pa
real :: p5grav
real :: p5grav_rho0r
real :: grav_rho0r

real :: dtime 
real :: dtimer 
real :: acor 

! placeholders for Adams-Bashforth Coriolis
real :: abtau_m0=0.0
real :: abtau_m1=0.0
real :: abtau_m2=0.0

! for Bgrid or Cgrid 
integer :: horz_grid 
real, dimension(:,:,:), allocatable :: grd_area
real, dimension(:,:,:), allocatable :: mass_column

! Coriolis parameter on T-point 
real, dimension(:,:), allocatable :: coriolis_t

logical :: used

integer :: id_clock_energy_analysis
integer :: id_clock_press_conversion
integer :: id_clock_press_energy
integer :: id_clock_friction_energy
integer :: id_clock_vert_dissipation

! for potential energy 
integer :: id_pe_tot    =-1
integer :: id_pe_tot_rel=-1
integer :: id_coriolis_t=-1
logical :: potential_energy_first=.true.
real :: pe_tot_0  ! gravitational potential energy (joules) at initial timestep

! for kinetic energy
integer :: id_ke_tot                    =-1
integer :: id_kinetic_energy            =-1
integer :: id_kinetic_energy_intz       =-1
integer :: id_kinetic_energy_clinic     =-1
integer :: id_kinetic_energy_clinic_intz=-1
integer :: id_kinetic_energy_tropic     =-1

! for pressure energy maps
integer :: id_u_dot_grad_pint(2)
integer :: id_u_dot_grad_pint_xy
integer :: id_ubar_dot_grad_pext(2)
integer :: id_ubar_dot_grad_pext_xy

! for friction energy maps
integer :: id_u_dot_lapfrict_horz=-1
integer :: id_v_dot_lapfrict_horz=-1
integer :: id_u_dot_bihfrict_horz=-1
integer :: id_v_dot_bihfrict_horz=-1
integer :: id_u_dot_frict_vert=-1
integer :: id_v_dot_frict_vert=-1
integer :: id_ubar_dot_frict_bt=-1
integer :: id_vbar_dot_frict_bt=-1
integer :: id_vert_lap_diss=-1

! for topostrophy
integer :: id_topostrophy=-1 

! for vorticity
integer :: id_vorticity_z =-1

! for potential vorticity
integer :: id_n2_pv     =-1
integer :: id_pg_pv     =-1
integer :: id_vert_pv   =-1
integer :: id_pg_pvf    =-1
integer :: id_vert_pvf  =-1
integer :: id_bc_pvf    =-1
integer :: id_pvf       =-1
integer :: id_ri_balance=-1
integer :: id_u_dot_grad_vert_pv   =-1
logical :: diagnose_pv = .false.

! pressure conversion diagnostics written in energy analysis subroutine
real :: press_int      ! integrated power from u_int dot grad(p) 
real :: press_ext      ! integrated power from u_ext dot grad(p)
real :: press_conv     ! integrated power converted from u dot grap(p) into other terms
real :: press_conv_err ! error in converting pressure work into other terms   
real :: ucell_mass

! for Stokes-Coriolis force
integer :: id_stokes_force_x =-1
integer :: id_stokes_force_y =-1

! for output
integer :: unit=6

type(ocean_grid_type), pointer   :: Grd =>NULL()
type(ocean_domain_type), pointer :: Dom =>NULL()

logical :: module_is_initialized = .FALSE.

character(len=128) :: version=&
     '$Id: ocean_velocity_diag.F90,v 20.0 2013/12/14 00:12:59 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

public  ocean_velocity_diag_init
public  ocean_velocity_diagnostics 

public  velocity_change
public  kinetic_energy
public  potential_energy

public  pressure_conversion
public  energy_analysis

private pressure_energy
private friction_energy
private vert_dissipation 
private velocity_land_cell_check
private cfl_check1_bgrid
private cfl_check1_cgrid
private cfl_check2_bgrid
private cfl_check2_cgrid
private compute_topostrophy
private compute_vorticity
private stokes_coriolis_force
private diagnose_kinetic_energy_maps
private diagnose_potential_vorticity 

integer :: global_sum_flag
integer :: diag_step         = -1
integer :: energy_diag_step  = -1
integer :: land_cell_num_max = 100  

! for CFL checks 
real    :: max_cfl_value   = 100.0           
real    :: large_cfl_value = 10.0 
logical :: verbose_cfl     =.false.

! internally set for diagnosing kinetic energy maps
logical :: compute_kinetic_energy_maps = .false.

logical :: do_bitwise_exact_sum = .false.
logical :: debug_this_module    = .false.


namelist /ocean_velocity_diag_nml/ diag_step, energy_diag_step, do_bitwise_exact_sum, debug_this_module, &
                                   max_cfl_value, large_cfl_value, verbose_cfl, land_cell_num_max


contains

!#######################################################################
! <SUBROUTINE NAME="ocean_velocity_diag_init">
!
! <DESCRIPTION>
! Initialize the ocean_velocity_diag module containing subroutines
! diagnosing velocity related properties of the simulation.  These are 
! not terms in the equations, but rather they are diagnosed from 
! terms. 
! </DESCRIPTION>
!
subroutine ocean_velocity_diag_init(Grid, Domain, Time, Time_steps, hor_grid)

type(ocean_grid_type),       target, intent(in) :: Grid
type(ocean_domain_type),     target, intent(in) :: Domain
type(ocean_time_type),               intent(in) :: Time
type(ocean_time_steps_type),         intent(in) :: Time_steps
integer,                             intent(in) :: hor_grid 

integer :: ioun, io_status, ierr
integer :: i,j,k

integer :: stdoutunit,stdlogunit 
stdoutunit=stdout();stdlogunit=stdlog() 

if (module_is_initialized) return

module_is_initialized = .TRUE.

call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_velocity_diag_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_velocity_diag_nml')
#else
ioun = open_namelist_file()
read(ioun, ocean_velocity_diag_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_velocity_diag_nml')
call close_file(ioun)
#endif
write (stdoutunit,'(/)')
write (stdoutunit, ocean_velocity_diag_nml)
write (stdlogunit, ocean_velocity_diag_nml)

if (diag_step == 0)        diag_step = 1
if (energy_diag_step == 0) energy_diag_step = 1

if(do_bitwise_exact_sum) then
   global_sum_flag = BITWISE_EXACT_SUM
else
   global_sum_flag = NON_BITWISE_EXACT_SUM
endif

 if(debug_this_module) then 
   write(stdoutunit,*) &
   '==>Note: running ocean_velocity_diag_mod with debug_this_module=.true.'
 endif 

#ifndef MOM_STATIC_ARRAYS
call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
nk = Grid%nk
#endif

Dom => Domain
Grd => Grid

p5grav       = 0.5*grav
grav_rho0r   = grav*rho0r
p5grav_rho0r = 0.5*grav*rho0r
dbars2Pa     = 1.0/c2dbars 

dtime        = Time_steps%dtime_u
dtimer       = 1.0/dtime
acor         = Time_steps%acor
horz_grid    = hor_grid 

! pressure energetics 
id_u_dot_grad_pint(1) = register_diag_field ('ocean_model', 'u_dot_grad_pint_x', &
     Grd%vel_axes_u(1:3), Time%model_time,                                       &
     'i-current times 3d i-pressure force', 'Watt',                              &
     missing_value=missing_value, range=(/-1e15, 1e15/))
id_u_dot_grad_pint(2) = register_diag_field ('ocean_model', 'u_dot_grad_pint_y', &
     Grd%vel_axes_v(1:3), Time%model_time,                                       &
     'j-current times 3d j-pressure force', 'Watt',                              &
     missing_value=missing_value, range=(/-1e15, 1e15/))

id_ubar_dot_grad_pext(1) = register_diag_field ('ocean_model', 'ubar_dot_grad_pext_x', &
     Grd%vel_axes_u(1:2), Time%model_time,                                             &
     '2d i-current times 2d i-pressure force', 'Watt',                                 &
     missing_value=missing_value, range=(/-1e15, 1e15/))
id_ubar_dot_grad_pext(2) = register_diag_field ('ocean_model', 'ubar_dot_grad_pext_y', &
     Grd%vel_axes_v(1:2), Time%model_time,                                             &
     '2d j-current times 2d j-pressure force', 'Watt',                                 &
     missing_value=missing_value, range=(/-1e15, 1e15/))

! friction energetics
id_u_dot_lapfrict_horz = register_diag_field ('ocean_model', 'u_dot_lapfrict_horz', &
     Grd%vel_axes_u(1:3), Time%model_time,                                          &
     'i-current times horizontal laplacian friction', 'Watt',                       &
     missing_value=missing_value, range=(/-1e15, 1e15/))
id_v_dot_lapfrict_horz = register_diag_field ('ocean_model', 'v_dot_lapfrict_horz', &
     Grd%vel_axes_v(1:3), Time%model_time,                                          &
     'j-current times horizontal laplacian friction', 'Watt',                       &
     missing_value=missing_value, range=(/-1e15, 1e15/))
id_u_dot_bihfrict_horz = register_diag_field ('ocean_model', 'u_dot_bihfrict_horz', &
     Grd%vel_axes_u(1:3), Time%model_time,                                          &
     'i-current times horizontal biharmonic friction', 'Watt',                      &
     missing_value=missing_value, range=(/-1e15, 1e15/))
id_v_dot_bihfrict_horz = register_diag_field ('ocean_model', 'v_dot_bihfrict_horz', &
     Grd%vel_axes_v(1:3), Time%model_time,                                          &
     'j-current times horizontal biharmonic friction', 'Watt',                      &
     missing_value=missing_value, range=(/-1e15, 1e15/))
id_u_dot_frict_vert = register_diag_field ('ocean_model', 'u_dot_frict_vert', &
     Grd%vel_axes_u(1:3), Time%model_time,                                    &
     'i-current times vertical friction', 'Watt',                             &
     missing_value=missing_value, range=(/-1e15, 1e15/))
id_v_dot_frict_vert = register_diag_field ('ocean_model', 'v_dot_frict_vert', &
     Grd%vel_axes_v(1:3), Time%model_time,                                    &
     'j-current times vertical friction', 'Watt',                             &
     missing_value=missing_value, range=(/-1e15, 1e15/))
id_ubar_dot_frict_bt = register_diag_field ('ocean_model', 'ubar_dot_frict_bt', &
     Grd%vel_axes_u(1:2), Time%model_time,                                      &
     'i-ubar current times horizontal friction applied just to ubar', 'Watt',   &
     missing_value=missing_value, range=(/-1e15, 1e15/))
id_vbar_dot_frict_bt = register_diag_field ('ocean_model', 'vbar_dot_frict_bt', &
     Grd%vel_axes_v(1:2), Time%model_time,                                      &
     'j-vbar current times horizontal friction applied just to vbar', 'Watt',   &
     missing_value=missing_value, range=(/-1e15, 1e15/))

id_topostrophy = register_diag_field ('ocean_model', 'topostrophy', Grd%vel_axes_uv(1:3),&
       Time%model_time, 'topostrophy = f * (zhat cross u) dot grad H', 'm/s^2',          &
       missing_value=missing_value, range=(/-1.e20,1.e20/))

id_stokes_force_x = register_diag_field ('ocean_model', 'stokes_force_x', Grd%vel_axes_u(1:3), &
     Time%model_time, 'Zonal component to Stokes Coriolis force', '(kg/m^3)*(m^2/s^2)',        &
      missing_value=missing_value, range=(/-1e9,1e9/))

id_stokes_force_y = register_diag_field ('ocean_model', 'stokes_force_y', Grd%vel_axes_v(1:3), &
      Time%model_time, 'Meridional component to Stokes Coriolis force', '(kg/m^3)*(m^2/s^2)',  &
      missing_value=missing_value, range=(/-1e9,1e9/))

! kinetic energy scalar
id_ke_tot = register_diag_field ('ocean_model', 'ke_tot', Time%model_time, &
            'Globally integrated ocean kinetic energy', '10^15 Joules',    &
            missing_value=missing_value, range=(/0.0,1e20/))

! potential energy
id_pe_tot = register_diag_field ('ocean_model', 'pe_tot', Time%model_time, &
            'Globally integrated ocean potential energy', '10^15 Joules',  &
            missing_value=missing_value, range=(/0.0,1e20/))
id_pe_tot_rel = register_diag_field ('ocean_model', 'pe_tot_rel', Time%model_time,          &
                'global potential energy - initial global potential energy', '10^15 Joules',&
                missing_value=missing_value, range=(/0.0,1e20/))

! Coriolis on T-point 
id_coriolis_t = register_static_field ('ocean_model', 'coriolis_t', Grd%tracer_axes(1:2), &
                                       'Coriolis parameter on T-cell', '1/s',             &
                                       missing_value=missing_value, range=(/-10.0,10.0/))
allocate (coriolis_t(isd:ied,jsd:jed))
do j=jsc,jec
   do i=isc,iec
      coriolis_t(i,j) = 2.0*omega*sin(Grd%phit(i,j))*Grd%tmask(i,j,1) 
   enddo
enddo
call diagnose_2d(Time, Grd, id_coriolis_t, coriolis_t(:,:))

! Ertel PV and its pieces
id_n2_pv = register_diag_field ('ocean_model', 'n2_pv', Grd%tracer_axes(1:3), Time%model_time,&
  'squared BV frequency for planetary geostrophic PV: N^2', '1/sec^2',                        &
  missing_value=missing_value, range=(/-1e6,1e6/))
id_pg_pv = register_diag_field ('ocean_model', 'pg_pv', Grd%tracer_axes(1:3), Time%model_time,&
  'planetary geostrophic PV: f*N^2', '1/sec^3', missing_value=missing_value, range=(/-1e6,1e6/))
id_vert_pv = register_diag_field ('ocean_model', 'vert_pv', Grd%tracer_axes(1:3), Time%model_time,&
  'vertical piece of Ertel PV: (f+zeta)*N^2', '1/sec^3', missing_value=missing_value, range=(/-1e6,1e6/))
id_pg_pvf = register_diag_field ('ocean_model', 'pg_pvf', Grd%tracer_axes(1:3), Time%model_time,&
  'planetary geostrophic PV times f: (f*N)^2', '1/sec^4', missing_value=missing_value, range=(/-1e6,1e6/))
id_vert_pvf = register_diag_field ('ocean_model', 'vert_pvf', Grd%tracer_axes(1:3), Time%model_time,&
  'vertical piece of Ertel PV times f: f*(f+zeta)*N^2', '1/sec^4',                                  &
  missing_value=missing_value, range=(/-1e6,1e6/))
id_bc_pvf = register_diag_field ('ocean_model', 'bc_pvf', Grd%tracer_axes(1:3), Time%model_time,&
  'baroclinic component of balanced Ertel PV times f: -|\nabla buoy|^2', '1/sec^4',             &
  missing_value=missing_value, range=(/-1e6,1e6/))
id_pvf = register_diag_field ('ocean_model', 'pvf', Grd%tracer_axes(1:3), Time%model_time,&
  'Ertel PV times f', '1/sec^4', missing_value=missing_value, range=(/-1e6,1e6/))
id_ri_balance = register_diag_field ('ocean_model', 'ri_balance', Grd%tracer_axes(1:3), Time%model_time,&
  'Balanced Richardson number', 'dimensionless', missing_value=missing_value, range=(/-1e6,1e6/))
id_u_dot_grad_vert_pv = register_diag_field ('ocean_model', 'u_dot_grad_vert_pv', Grd%tracer_axes(1:3), Time%model_time,&
'3d velocity dot product with 3d gradient of vertical piece of Ertel PV: u.grad((f+zeta)*N^2)', '1/sec^4', missing_value=missing_value, range=(/-1e6,1e6/))
if (id_pg_pv > 0)      diagnose_pv = .true.
if (id_vert_pv > 0)    diagnose_pv = .true.
if (id_pg_pvf > 0)     diagnose_pv = .true.
if (id_vert_pvf > 0)   diagnose_pv = .true.
if (id_bc_pvf > 0)     diagnose_pv = .true.
if (id_pvf > 0)        diagnose_pv = .true.
if (id_ri_balance > 0) diagnose_pv = .true.
if (id_u_dot_grad_vert_pv > 0)    diagnose_pv = .true.


if(horz_grid == MOM_BGRID) then 
   id_u_dot_grad_pint_xy = register_diag_field ('ocean_model', 'u_dot_grad_pint_xy', &
        Grd%vel_axes_uv(1:3), Time%model_time,                                       &
        'current dot 3d pressure force', 'Watt',                                     &
        missing_value=missing_value, range=(/-1e15, 1e15/))
   id_ubar_dot_grad_pext_xy = register_diag_field ('ocean_model', 'ubar_dot_grad_pext_xy',&
        Grd%vel_axes_uv(1:2), Time%model_time,                                            &
        '2d current dot 2d pressure force', 'Watt',                                       &
        missing_value=missing_value, range=(/-1e15, 1e15/))
   id_vert_lap_diss = register_diag_field ('ocean_model', 'vert_lap_diss', Grd%vel_axes_uv(1:3),&
          Time%model_time, 'Energy dissipation from vertical Laplacian friction', 'W/m^2',      &
          missing_value=missing_value, range=(/-1.e20,1.e20/),                                  &
          standard_name='ocean_kinetic_energy_dissipation_per_unit_area_due_to_vertical_friction')
   id_vorticity_z = register_diag_field ('ocean_model', 'vorticity_z', Grd%tracer_axes(1:3), Time%model_time,&
     'vertical vorticity component: v_x - u_y', '1/sec', missing_value=missing_value, range=(/-1e6,1e6/))
   id_kinetic_energy = register_diag_field ('ocean_model', 'kinetic_energy', Grd%vel_axes_uv(1:3),&
          Time%model_time, 'kinetic energy in a grid cell', '10^15 Joules',                       &
          missing_value=missing_value, range=(/0.0,1.e20/))
   if(id_kinetic_energy > 0) compute_kinetic_energy_maps = .true.

   id_kinetic_energy_intz = register_diag_field ('ocean_model', 'kinetic_energy_intz',  &
          Grd%vel_axes_uv(1:2), Time%model_time, 'Vertically integrated kinetic energy',&
          '10^15 Joules', missing_value=missing_value, range=(/0.0,1.e20/))
   if(id_kinetic_energy_intz > 0) compute_kinetic_energy_maps = .true.

   id_kinetic_energy_clinic = register_diag_field ('ocean_model', 'kinetic_energy_clinic',   &
          Grd%vel_axes_uv(1:3), Time%model_time, 'Baroclinic kinetic energy', '10^15 Joules',&
          missing_value=missing_value, range=(/0.0,1.e20/))
   if(id_kinetic_energy_clinic > 0) compute_kinetic_energy_maps = .true.

   id_kinetic_energy_clinic_intz = register_diag_field ('ocean_model', 'kinetic_energy_clinic_intz',&
          Grd%vel_axes_uv(1:2), Time%model_time, 'Vertically integrated baroclinic kinetic energy', &
          '10^15 Joules', missing_value=missing_value, range=(/0.0,1.e20/))
   if(id_kinetic_energy_clinic_intz > 0) compute_kinetic_energy_maps = .true.

   id_kinetic_energy_tropic = register_diag_field ('ocean_model', 'kinetic_energy_tropic',   &
          Grd%vel_axes_uv(1:2), Time%model_time, 'Barotropic kinetic energy', '10^15 Joules',&
          missing_value=missing_value, range=(/0.0,1.e20/))
   if(id_kinetic_energy_tropic > 0) compute_kinetic_energy_maps = .true.

else  ! Cgrid
   id_u_dot_grad_pint_xy = register_diag_field ('ocean_model', 'u_dot_grad_pint_xy',&
        Grd%tracer_axes(1:3), Time%model_time,                                      &
        'current dot 3d pressure force', 'Watt',                                    &
        missing_value=missing_value, range=(/-1e15, 1e15/))
   id_ubar_dot_grad_pext_xy = register_diag_field ('ocean_model', 'ubar_dot_grad_pext_xy',&
        Grd%tracer_axes(1:2), Time%model_time,                                            &
        '2d current dot 2d pressure force', 'Watt',                                       &
        missing_value=missing_value, range=(/-1e15, 1e15/))
   id_vert_lap_diss = register_diag_field ('ocean_model', 'vert_lap_diss', Grd%tracer_axes(1:3),&
          Time%model_time, 'Energy dissipation from vertical Laplacian friction', 'W/m^2',      &
          missing_value=missing_value, range=(/-1.e20,1.e20/),                                  &
          standard_name='ocean_kinetic_energy_dissipation_per_unit_area_due_to_vertical_friction')
   id_vorticity_z = register_diag_field ('ocean_model', 'vorticity_z', Grd%vel_axes_uv(1:3), Time%model_time, &
     'vertical vorticity component: v_x - u_y', '1/sec', missing_value=missing_value, range=(/-1e6,1e6/))


   id_kinetic_energy = register_diag_field ('ocean_model', 'kinetic_energy', Grd%tracer_axes(1:3),&
          Time%model_time, 'kinetic energy in a grid cell', '10^15 Joules',                       &
          missing_value=missing_value, range=(/0.0,1.e20/))
   if(id_kinetic_energy > 0) compute_kinetic_energy_maps = .true.

   id_kinetic_energy_intz = register_diag_field ('ocean_model', 'kinetic_energy_intz',  &
          Grd%tracer_axes(1:2), Time%model_time, 'Vertically integrated kinetic energy',&
          '10^15 Joules', missing_value=missing_value, range=(/0.0,1.e20/))
   if(id_kinetic_energy_intz > 0) compute_kinetic_energy_maps = .true.

   id_kinetic_energy_clinic = register_diag_field ('ocean_model', 'kinetic_energy_clinic',   &
          Grd%tracer_axes(1:3), Time%model_time, 'Baroclinic kinetic energy', '10^15 Joules',&
          missing_value=missing_value, range=(/0.0,1.e20/))
   if(id_kinetic_energy_clinic > 0) compute_kinetic_energy_maps = .true.

   id_kinetic_energy_clinic_intz = register_diag_field ('ocean_model', 'kinetic_energy_clinic_intz',&
          Grd%tracer_axes(1:2), Time%model_time, 'Vertically integrated baroclinic kinetic energy', &
          '10^15 Joules', missing_value=missing_value, range=(/0.0,1.e20/))
   if(id_kinetic_energy_clinic_intz > 0) compute_kinetic_energy_maps = .true.

   id_kinetic_energy_tropic = register_diag_field ('ocean_model', 'kinetic_energy_tropic',   &
          Grd%tracer_axes(1:2), Time%model_time, 'Barotropic kinetic energy', '10^15 Joules',&
          missing_value=missing_value, range=(/0.0,1.e20/))
   if(id_kinetic_energy_tropic > 0) compute_kinetic_energy_maps = .true.

endif 


allocate (grd_area(isd:ied,jsd:jed,nk))
allocate (mass_column(isd:ied,jsd:jed,2))
mass_column = 0.0
if(horz_grid == MOM_BGRID) then 
   do k=1,nk
      do j=jsd,jed
         do i=isd,ied
            grd_area(i,j,k) = Grd%umask(i,j,k)*Grd%dau(i,j)
         enddo
      enddo
   enddo
else 
   do k=1,nk
      do j=jsd,jed
         do i=isd,ied
            grd_area(i,j,k) = Grd%tmask(i,j,k)*Grd%dat(i,j)
         enddo
      enddo
   enddo
endif 

id_clock_energy_analysis   = mpp_clock_id('(Velocity diag: energy analysis)'  ,grain=CLOCK_MODULE)
id_clock_press_conversion  = mpp_clock_id('(Velocity diag: press convert)'    ,grain=CLOCK_MODULE)
id_clock_press_energy      = mpp_clock_id('(Velocity diag: press energy)'     ,grain=CLOCK_MODULE)
id_clock_friction_energy   = mpp_clock_id('(Velocity diag: friction energy)'  ,grain=CLOCK_MODULE)
id_clock_vert_dissipation  = mpp_clock_id('(Velocity diag: vert dissipation'  ,grain=CLOCK_MODULE)


end subroutine ocean_velocity_diag_init
! </SUBROUTINE>  NAME="ocean_velocity_diag_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_velocity_diagnostics">
!
! <DESCRIPTION>
! Call diagnostics related to the velocity. 
! </DESCRIPTION>
!
subroutine ocean_velocity_diagnostics(Time, Thickness, Dens, Ext_mode, Velocity, Adv_vel)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_density_type),       intent(in)    :: Dens
  type(ocean_external_mode_type), intent(in)    :: Ext_mode
  type(ocean_velocity_type),      intent(inout) :: Velocity
  type(ocean_adv_vel_type),       intent(in)    :: Adv_vel

  type(time_type) :: next_time 

  real :: pe_tot     = 0.0
  real :: pe_tot_rel = 0.0
  real :: ke_tot     = 0.0

  ! diagnostics that do not send_data to diag_manager  
  if (diag_step > 0) then 
     if(mod(Time%itt,diag_step) == 0) then
        call lap_viscosity_check
        call lap_reynolds_check(Time, Velocity)
        call bih_viscosity_check
        call bih_reynolds_check(Time, Velocity)
        call velocity_land_cell_check(Time, Velocity)
        call write_timestamp(Time%model_time)
        call kinetic_energy(Time, Thickness, Velocity, ke_tot, .false., .true.)
        call potential_energy(Time, Thickness, Dens, pe_tot, pe_tot_rel, .false., .true.)
        call cfl_check1_bgrid(Time, Thickness, Velocity)
        call cfl_check1_cgrid(Time, Thickness, Velocity)
        call cfl_check2_bgrid(Time, Thickness, Velocity)
        call cfl_check2_cgrid(Time, Thickness, Velocity)
     endif  
  endif

  ! diagnostics that send_data to diag_manager 
  next_time = increment_time(Time%model_time, int(dtime), 0)
  if (need_data(id_ke_tot,next_time)) then 
    call kinetic_energy(Time, Thickness, Velocity, ke_tot, .true., .false.)
  endif 
  if (need_data(id_pe_tot,next_time)) then 
    call potential_energy(Time, Thickness, Dens, pe_tot, pe_tot_rel, .true., .false.)
  endif 

  ! diagnose topography scalar 
  call compute_topostrophy(Time, Velocity)

  ! diagnose vorticity 
  call compute_vorticity(Time, Velocity)

  ! diagnostic Stokes-Coriolis force 
  call stokes_coriolis_force(Time, Thickness, Velocity)

  ! diagnostic kinetic energy maps
  call diagnose_kinetic_energy_maps(Time, Thickness, Velocity, Ext_mode)

  ! diagnostic potential vorticity and terms 
  call diagnose_potential_vorticity(Time, Thickness, Velocity, Adv_vel, Dens)
  
end subroutine ocean_velocity_diagnostics
! </SUBROUTINE>  NAME="ocean_velocity_diagnostics"


!#######################################################################
! <SUBROUTINE NAME="potential_energy">
!
! <DESCRIPTION>
!
! Compute gravitational potential energy (Joules) relative to z=0 
! taken with respect to the value at the initial time step. 
!
! </DESCRIPTION>
!
subroutine potential_energy (Time, Thickness, Dens, pe_tot, pe_tot_rel, diag_flag, write_flag)

  type(ocean_time_type),      intent(in)           :: Time
  type(ocean_thickness_type), intent(in)           :: Thickness
  type(ocean_density_type),   intent(in)           :: Dens
  real,                       intent(inout)        :: pe_tot
  real,                       intent(inout)        :: pe_tot_rel
  logical,                    intent(in), optional :: diag_flag 
  logical,                    intent(in), optional :: write_flag 

  integer :: i, j, k
  integer :: taup1
  integer :: stdoutunit 
  logical :: send_diagnostics
  logical :: write_diagnostics

  stdoutunit=stdout() 
  taup1 = Time%taup1

  ! assume send_diagnostics=.true., unless diag_flag says it is false.
  if (PRESENT(diag_flag)) then 
    send_diagnostics = diag_flag
  else 
    send_diagnostics = .true.
  endif 

  ! assume write_diagnostics=.true., unless write_flag says it is false.
  if (PRESENT(write_flag)) then 
    write_diagnostics = write_flag
  else 
    write_diagnostics = .true.
  endif 

  ! Calculate total potential energy
  pe_tot = 0.
  do k= 1, nk
    do j = jsc, jec
      do i = isc, iec
        pe_tot = pe_tot + Grd%dat(i, j) * Thickness%dzt(i, j, k) &
                     * Dens%rho(i, j, k, taup1) * Grd%tmask(i, j, k) &
                     * Thickness%depth_zt(i, j, k) * grav
      end do
    end do
  end do
  call mpp_sum(pe_tot)

  pe_tot_rel = 0.
  if (potential_energy_first) then
    potential_energy_first = .false.
    pe_tot_0 = pe_tot
  else
    ! computing pe_tot relative to initial time step value reduces roundoff errors
    pe_tot_rel = pe_tot_rel + (pe_tot - pe_tot_0)
  end if

  if(write_diagnostics) then 
     write(stdoutunit,'(/,1x,a,e20.12)') &
     'Gravitational potential energy relative to first time (Joules) = ', pe_tot_rel
     write(stdoutunit,'(/,1x,a,e20.12)') &
     'Gravitational potential energy                                 = ', pe_tot
  endif 

  if(send_diagnostics) then
    if (id_pe_tot_rel > 0) used = send_data (id_pe_tot_rel, pe_tot_rel*1e-15, Time%model_time)
  endif 
  if(send_diagnostics) then
    if (id_pe_tot > 0) used = send_data (id_pe_tot, pe_tot*1e-15, Time%model_time)
  endif 

end subroutine potential_energy
! </SUBROUTINE>  NAME="potential_energy"


!#######################################################################
! <SUBROUTINE NAME="kinetic_energy">
!
! <DESCRIPTION>
! Compute global integrated horizontal kinetic energy.
! </DESCRIPTION>
!
subroutine kinetic_energy (Time, Thickness, Velocity, ke_tot, diag_flag, write_flag)

  type(ocean_time_type),      intent(in)           :: Time
  type(ocean_thickness_type), intent(in)           :: Thickness
  type(ocean_velocity_type),  intent(in)           :: Velocity
  real,                       intent(inout)        :: ke_tot
  logical,                    intent(in), optional :: diag_flag 
  logical,                    intent(in), optional :: write_flag 

  logical :: send_diagnostics
  logical :: write_diagnostics
  real    :: mass_cell
  integer :: i, j, k, tau

  integer :: stdoutunit 
  stdoutunit=stdout() 

  ! assume send_diagnostics=.true., unless diag_flag says it is false.
  if (PRESENT(diag_flag)) then 
    send_diagnostics = diag_flag
  else 
    send_diagnostics = .true.
  endif 

  ! assume write_diagnostics=.true., unless write_flag says it is false.
  if (PRESENT(write_flag)) then 
    write_diagnostics = write_flag
  else 
    write_diagnostics = .true.
  endif 

  tau = Time%tau

  ! total horizontal kinetic energy(joules) at "tau"
  ke_tot = 0.0
  if(horz_grid == MOM_BGRID) then 
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              mass_cell = grd_area(i,j,k)*Thickness%rho_dzu(i,j,k,tau)
              ke_tot    = ke_tot + 0.5*mass_cell*(Velocity%u(i,j,k,1,tau)**2 + Velocity%u(i,j,k,2,tau)**2)
           enddo
        enddo
     enddo

  else  ! cgrid 

     ! ignore offset in velocity components 
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              mass_cell = Grd%dat(i,j)*Thickness%rho_dzt(i,j,k,tau)*Grd%tmask(i,j,k) 
              ke_tot    = ke_tot + 0.5*mass_cell*(Velocity%u(i,j,k,1,tau)**2 + Velocity%u(i,j,k,2,tau)**2)
           enddo
        enddo
     enddo

  endif 

  call mpp_sum (ke_tot)

  if(write_diagnostics) then 
     write(stdoutunit,'(1x,a,e20.12)') 'Kinetic energy (Joules)                          = ', ke_tot
  endif 

  if(send_diagnostics) then 
    if (id_ke_tot > 0) used = send_data (id_ke_tot, ke_tot*1e-15, Time%model_time)
  endif 

end subroutine kinetic_energy
! </SUBROUTINE> NAME="kinetic_energy"


!#######################################################################
! <SUBROUTINE NAME="diagnose_kinetic_energy_maps">
!
! <DESCRIPTION>
! Compute maps of horizontal kinetic energy, which is the kinetic
! energy appropriate for a hydrostatic fluid.
!
! Note that for Cgrid calculation we ignore the
! offset in the horizontal velocity components.
!
! </DESCRIPTION>
!
subroutine diagnose_kinetic_energy_maps (Time, Thickness, Velocity, Ext_mode)

  type(ocean_time_type),          intent(in) :: Time
  type(ocean_thickness_type),     intent(in) :: Thickness
  type(ocean_velocity_type),      intent(in) :: Velocity
  type(ocean_external_mode_type), intent(in) :: Ext_mode

  integer :: i, j, k, tau
  real    :: uprime, vprime
  real, dimension(isd:ied,jsd:jed,2)    :: ubar
  real, dimension(isd:ied,jsd:jed,2)    :: mass_per_area
  real, dimension(isd:ied,jsd:jed,nk,2) :: mass_per_cell

  if(.not. compute_kinetic_energy_maps) return

  tau                    = Time%tau
  wrk1(:,:,:)            = 0.0
  wrk2(:,:,:)            = 0.0
  wrk1_2d(:,:)           = 0.0
  wrk2_2d(:,:)           = 0.0
  wrk3_2d(:,:)           = 0.0
  mass_per_area(:,:,:)   = 0.0
  mass_per_cell(:,:,:,:) = 0.0

  ! compute masses appropriate for Bgrid or Cgrid
  if(horz_grid == MOM_BGRID) then

     do j=jsd,jed
        do i=isd,ied
           mass_per_area(i,j,1) = Thickness%mass_u(i,j,tau)
           mass_per_area(i,j,2) = Thickness%mass_u(i,j,tau)
        enddo
     enddo
     do k=1,nk
        do j=jsd,jed
           do i=isd,ied
              mass_per_cell(i,j,k,1) = grd_area(i,j,k)*Thickness%rho_dzu(i,j,k,tau)
              mass_per_cell(i,j,k,2) = mass_per_cell(i,j,k,1)
           enddo
        enddo
     enddo

  else ! Cgrid

     do j=jsd,jed
        do i=isd,ied
           mass_per_area(i,j,1) = Thickness%mass_en(i,j,1)
           mass_per_area(i,j,2) = Thickness%mass_en(i,j,2)
        enddo
     enddo
     do k=1,nk
        do j=jsd,jed
           do i=isd,ied
              mass_per_cell(i,j,k,1) = grd_area(i,j,k)*Thickness%rho_dzten(i,j,k,1)
              mass_per_cell(i,j,k,2) = grd_area(i,j,k)*Thickness%rho_dzten(i,j,k,2)
           enddo
        enddo
     enddo

  endif


  ! vertical average of horizontal velocity and kinetic energy in this vertical average
  do j=jsd,jed
     do i=isd,ied
        ubar(i,j,1)  = Grd%tmasken(i,j,1,1)*Ext_mode%udrho(i,j,1,tau)/(mass_per_area(i,j,1)+epsln)
        ubar(i,j,2)  = Grd%tmasken(i,j,1,2)*Ext_mode%udrho(i,j,2,tau)/(mass_per_area(i,j,2)+epsln)
        wrk3_2d(i,j) = onehalf*grd_area(i,j,1)*(mass_per_area(i,j,1)*ubar(i,j,1)**2 + mass_per_area(i,j,2)*ubar(i,j,2)**2)
     enddo
  enddo

  ! kinetic energy in full flow and in baroclinic flow
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           uprime      = Velocity%u(i,j,k,1,tau) - ubar(i,j,1)
           vprime      = Velocity%u(i,j,k,2,tau) - ubar(i,j,2)
           wrk1(i,j,k) = onehalf*(mass_per_cell(i,j,k,1)*Velocity%u(i,j,k,1,tau)**2 + mass_per_cell(i,j,k,2)*Velocity%u(i,j,k,2,tau)**2)
           wrk2(i,j,k) = onehalf*(mass_per_cell(i,j,k,1)*uprime**2 + mass_per_cell(i,j,k,2)*vprime**2)
        enddo
     enddo
  enddo

  ! vertical integrals
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1_2d(i,j) = wrk1_2d(i,j) + wrk1(i,j,k)
           wrk2_2d(i,j) = wrk2_2d(i,j) + wrk2(i,j,k)
        enddo
     enddo
  enddo

  if(id_kinetic_energy > 0) then
     used = send_data (id_kinetic_energy, wrk1(:,:,:)*1e-15, Time%model_time, rmask=Grd%mask(:,:,:), &
            is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
  endif
  if(id_kinetic_energy_intz > 0) then
     used = send_data (id_kinetic_energy_intz, wrk1_2d(:,:)*1e-15, Time%model_time, rmask=Grd%mask(:,:,1), &
            is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
  endif
  if(id_kinetic_energy_clinic > 0) then
     used = send_data (id_kinetic_energy_clinic, wrk2(:,:,:)*1e-15, Time%model_time, rmask=Grd%mask(:,:,:), &
            is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)
  endif
  if(id_kinetic_energy_clinic_intz > 0) then
     used = send_data (id_kinetic_energy_clinic_intz, wrk2_2d(:,:)*1e-15, Time%model_time, rmask=Grd%mask(:,:,1), &
            is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
  endif
  if(id_kinetic_energy_tropic > 0) then
     used = send_data (id_kinetic_energy_tropic, wrk3_2d(:,:)*1e-15, Time%model_time, rmask=Grd%mask(:,:,1), &
            is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)
  endif


end subroutine diagnose_kinetic_energy_maps
! </SUBROUTINE> NAME="diagnose_kinetic_energy_maps"


!#######################################################################
! <SUBROUTINE NAME="velocity_land_cell_check">
!
! <DESCRIPTION>
! See if there are any points over land with nonzero ocean velocity 
! </DESCRIPTION>
!
subroutine velocity_land_cell_check(Time, Velocity)

  implicit none
  type(ocean_time_type),     intent(in) :: Time
  type(ocean_velocity_type), intent(in) :: Velocity

  integer :: i, j, k, num, taup1

  integer :: stdoutunit 
  stdoutunit=stdout() 

  taup1 = Time%taup1

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_velocity_diag_mod(velocity_land_cell_check): module needs initialization ')
  endif 

  call write_timestamp(Time%model_time)
  write (stdoutunit,'(//60x,a/)') ' Land cell summary:'
  write (stdoutunit,'(1x,a/)')'Locations (if any) where land cell velocity is non-zero...'
  num = 0

  if(horz_grid == MOM_BGRID) then 
     kloop: do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              if (Grd%umask(i,j,k) == 0 .and. (Velocity%u(i,j,k,1,taup1) /= 0.0 .or. Velocity%u(i,j,k,2,taup1) /= 0.0)) then
                 num = num + 1
                 write (unit,9000) i, j, k, Grd%xu(i,j), Grd%yu(i,j), Grd%zt(k), Velocity%u(i,j,k,1,taup1), Velocity%u(i,j,k,2,taup1)
              endif
              if(num > land_cell_num_max) then
                 write (stdoutunit,'(1x,a/)')'More than land_cell_num_max land cells with non-zero velocity. Stop the check.'
                 exit kloop          
              endif 
           enddo
        enddo
     enddo kloop

  else  ! cgrid 

     kloop2: do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              if (Grd%tmask(i,j,k) == 0 .and. (Velocity%u(i,j,k,1,taup1) /= 0.0 .or. Velocity%u(i,j,k,2,taup1) /= 0.0)) then
                 num = num + 1
                 write (unit,9000) i, j, k, Grd%xt(i,j), Grd%yt(i,j), Grd%zt(k), Velocity%u(i,j,k,1,taup1), Velocity%u(i,j,k,2,taup1)
              endif
              if(num > land_cell_num_max) then
                 write (stdoutunit,'(1x,a/)')'More than land_cell_num_max land cells with non-zero velocity. Stop the check.'
                 exit kloop2          
              endif 
           enddo
        enddo
     enddo kloop2

  endif 

  if (num > 0)  then 
     call mpp_error(FATAL,'==>Error: found nonzero ocean velocity over land points. ')
  endif 

9000  format(/' " =>Error: Land cell at (i,j,k) = ','(',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.0,'m) has u=',e10.3, ' v=',e10.3)

end subroutine velocity_land_cell_check
! </SUBROUTINE> NAME="velocity_land_cell_check"



!#######################################################################
! <SUBROUTINE NAME="velocity_change">
!
! <DESCRIPTION>
! Determine the number of points that have large single-time step 
! changes in the absolute value of the velocity.  
! </DESCRIPTION>
!
subroutine velocity_change(Time, Velocity, velocity_change_max, velocity_change_max_num)

  implicit none
  type(ocean_time_type),     intent(in) :: Time
  type(ocean_velocity_type), intent(in) :: Velocity
  real,                      intent(in) :: velocity_change_max
  integer,                   intent(in) :: velocity_change_max_num

  real     :: abschange(2)
  integer  :: i, j, k, n, num
  integer  :: taum1, tau, taup1 

  integer :: stdoutunit 
  stdoutunit=stdout() 

  tau   = Time%tau
  taum1 = Time%taum1
  taup1 = Time%taup1

  call write_timestamp(Time%model_time)
  write (stdoutunit,'(//60x,a/)')    &
   ' Velocity change summary (test for leap-frog noise):'
  write (stdoutunit,'(1x,a,e12.6/)') &
   'Locations (if any) where abs(0.5*(u(taup1)+u(taum1))-u(tau)) (m/s) > ',velocity_change_max
  num = 0
  if(horz_grid == MOM_BGRID) then 
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              if(Grd%umask(i,j,k) > 0) then 
                 do n=1,2
                    abschange(n) = abs(0.5*(Velocity%u(i,j,k,n,taup1)+Velocity%u(i,j,k,n,taum1))-Velocity%u(i,j,k,n,tau))
                 enddo
                 if (abschange(1) > velocity_change_max .or. abschange(2) > velocity_change_max) then
                    num = num + 1
                    write (unit,9000) i, j, k, Grd%xu(i,j), Grd%yu(i,j), Grd%zt(k), abschange(1), abschange(2)
                 endif 
              endif
           enddo
        enddo
     enddo

  else 

     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              if(Grd%tmask(i,j,k) > 0) then 
                 do n=1,2
                    abschange(n) = abs(0.5*(Velocity%u(i,j,k,n,taup1)+Velocity%u(i,j,k,n,taum1))-Velocity%u(i,j,k,n,tau))
                 enddo
                 if (abschange(1) > velocity_change_max .or. abschange(2) > velocity_change_max) then
                    num = num + 1
                    write (unit,9000) i, j, k, Grd%xt(i,j), Grd%yt(i,j), Grd%zt(k), abschange(1), abschange(2)
                 endif 
              endif
           enddo
        enddo
     enddo

  endif 

  call mpp_max(num)
  if (num > velocity_change_max_num) then 
    call mpp_error(FATAL, &
    'Found too many points where velocity changed too much over single time step.')
  endif 

9000  format(/' " =>Error: Ocean at (i,j,k) = ','(',i4,',',i4,',',i4,'),',                 &
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.0,'m) has excessive change(u)=',e10.3, &
          ' or excessive change(v)=',e10.3)

end subroutine velocity_change
! </SUBROUTINE> NAME="velocity_change"


!#######################################################################
! <SUBROUTINE NAME="compute_topostrophy">
!
! <DESCRIPTION>
!
! Diagnose topostrophy as per Greg Holloway.  
! 
! Stephen.Griffies
! March 2012 
!
! </DESCRIPTION>
!
subroutine compute_topostrophy (Time, Velocity)

  type(ocean_time_type),     intent(in)  :: Time
  type(ocean_velocity_type), intent(in)  :: Velocity

  integer :: i,j,k
  integer :: tau
  real    :: ub, vb

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_velocity_diag_mod(compute_topostrophy): module needs initialization')
  endif 
  tau = Time%tau

  if(id_topostrophy > 0) then 

     wrk1(:,:,:) = 0.0
     if(horz_grid == MOM_BGRID) then 

        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                wrk1(i,j,k) = Grd%umask(i,j,k)*Grd%f(i,j) &
                              *(-Velocity%u(i,j,k,2,tau)*Grd%dht_dx(i,j)+Velocity%u(i,j,k,1,tau)*Grd%dht_dy(i,j))
              enddo
           enddo
        enddo

     else ! average c-grid velocity components to vorticity corner         

        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                ub = onehalf*(Velocity%u(i,j,k,1,tau)+Velocity%u(i,j+1,k,1,tau))
                vb = onehalf*(Velocity%u(i,j,k,2,tau)+Velocity%u(i+1,j,k,2,tau))
                wrk1(i,j,k) = Grd%umask(i,j,k)*Grd%f(i,j)*(-vb*Grd%dht_dx(i,j)+ub*Grd%dht_dy(i,j))
              enddo
           enddo
        enddo

     endif 

     call diagnose_3d_u(Time, Grd, id_topostrophy, wrk1(:,:,:))
  endif 


end subroutine compute_topostrophy
! </SUBROUTINE>  NAME="compute_topostrophy"



!#######################################################################
! <SUBROUTINE NAME="compute_vorticity">
!
! <DESCRIPTION>
! Compute z-component to vorticity.
! </DESCRIPTION>
!
subroutine compute_vorticity(Time, Velocity)

  type(ocean_time_type),      intent(in)  :: Time
  type(ocean_velocity_type),  intent(in)  :: Velocity

  integer :: i, j, k
  integer :: tau 
  tau   = Time%tau

  if(id_vorticity_z > 0) then 
     wrk1(:,:,:) = 0.0 

     if(horz_grid == MOM_BGRID) then 

        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 wrk1(i,j,k) = onehalf*((Velocity%u(i,j,k,2,tau)-Velocity%u(i-1,j,k,2,tau)    )*Grd%dxtnr(i,j)   &
                                       +(Velocity%u(i,j-1,k,2,tau)-Velocity%u(i-1,j-1,k,2,tau))*Grd%dxtnr(i,j-1) &
                                       -(Velocity%u(i,j,k,1,tau)-Velocity%u(i,j-1,k,1,tau)    )*Grd%dyter(i,j)   &
                                       -(Velocity%u(i-1,j,k,1,tau)-Velocity%u(i-1,j-1,k,1,tau))*Grd%dyter(i-1,j) &
                                              )
              enddo
           enddo
        enddo
        call diagnose_3d(Time, Grd, id_vorticity_z, wrk1(:,:,:))

     else ! cgrid 

        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 wrk1(i,j,k) = (Velocity%u(i,j,k,2,tau)-Velocity%u(i-1,j,k,2,tau))*Grd%dxur(i,j) & 
                              -(Velocity%u(i,j,k,1,tau)-Velocity%u(i,j-1,k,1,tau))*Grd%dyur(i,j)
              enddo
           enddo
        enddo
        call diagnose_3d_u(Time, Grd, id_vorticity_z, wrk1(:,:,:))

     endif 

  endif ! endif for id_vorticity_z 


end subroutine compute_vorticity
! </SUBROUTINE> NAME="compute_vorticity"


!#######################################################################
! <SUBROUTINE NAME="diagnose_potential_vorticity">
!
! <DESCRIPTION>
! Diagnose pieces to the Ertel potential vorticity, and f * PV.
!
! Motivated in part by the discussion of submeso instabilities in 
! Thomas, Taylor, Ferrari, and Joyce, DSR (2013), page 96-110.
!
! --Assume the Boussinesq form.
!
! --Compute relative vorticity from the full horizontal velocity. 
!   Differences betwen the full relative vorticity and the geostrophic
!   relative vorticity are small for much of the ocean. We prefer to use
!   the full velocity rather than geostrophic velocity, since the diagnosis
!   of the geostrophic relative vorticity requires the Laplacian of pressure,
!   which can be noisy and cumbersome. It is far simpler to just make use
!   of the prognostic u,v fields.
!
! --In contrast, we assume the baroclinic portion of the PV takes on
!   the geostrophically balanced form.  Doing so simplifies the calculation
!   and should be sufficient for many purposes. This assumption is made by 
!   Thomas et al.  But it is an assumption that may need to be revisited
!   if detailed studies are made in the boundary layers, where geostrophy
!   is not well maintained.  
!
! Note: only coded for the B-grid form of relative vorticity.
! 
!   Stephen.Griffies
!
! </DESCRIPTION>
!
subroutine diagnose_potential_vorticity(Time, Thickness, Velocity, Adv_vel, Dens)

  type(ocean_time_type),      intent(in)  :: Time
  type(ocean_thickness_type), intent(in)  :: Thickness
  type(ocean_velocity_type),  intent(in)  :: Velocity
  type(ocean_adv_vel_type),   intent(in)  :: Adv_vel
  type(ocean_density_type),   intent(in)  :: Dens

  real    :: grav_rho0r_sq
  integer :: i, j, k
  integer :: tau
  
  if(.not. diagnose_pv) return

  tau = Time%tau
  grav_rho0r_sq = grav_rho0r*grav_rho0r

  wrk1(:,:,:)  = 0.0 
  wrk2(:,:,:)  = 0.0 
  wrk3(:,:,:)  = 0.0 
  wrk4(:,:,:)  = 0.0
  wrk5(:,:,:)  = 0.0
  wrk6(:,:,:)  = 0.0


  ! planetary geostrophic PV 
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = -grav_rho0r*Dens%drhodz_zt(i,j,k) ! N^2
           wrk2(i,j,k) = wrk1(i,j,k)*coriolis_t(i,j)       ! f*N^2
           wrk3(i,j,k) = wrk2(i,j,k)*coriolis_t(i,j)       ! (f*N)^2 
        enddo
     enddo
  enddo
  if(id_n2_pv  > 0) call diagnose_3d(Time, Grd, id_n2_pv,  wrk1(:,:,:))
  if(id_pg_pv  > 0) call diagnose_3d(Time, Grd, id_pg_pv,  wrk2(:,:,:))
  if(id_pg_pvf > 0) call diagnose_3d(Time, Grd, id_pg_pvf, wrk3(:,:,:))
 

  ! contribution from absolute vorticity 
  if(id_vert_pv > 0 .or. id_vert_pvf > 0 .or. id_pvf > 0 .or. id_u_dot_grad_vert_pv > 0) then
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              wrk4(i,j,k) = onehalf*((Velocity%u(i,j,k,2,tau)-Velocity%u(i-1,j,k,2,tau)    )*Grd%dxtnr(i,j)   &
                                    +(Velocity%u(i,j-1,k,2,tau)-Velocity%u(i-1,j-1,k,2,tau))*Grd%dxtnr(i,j-1) &
                                    -(Velocity%u(i,j,k,1,tau)-Velocity%u(i,j-1,k,1,tau)    )*Grd%dyter(i,j)   &
                                    -(Velocity%u(i-1,j,k,1,tau)-Velocity%u(i-1,j-1,k,1,tau))*Grd%dyter(i-1,j) &
                                           )
              wrk5(i,j,k) = (coriolis_t(i,j) + wrk4(i,j,k))*wrk1(i,j,k)  ! (f + zeta)*N^2
              wrk6(i,j,k) = coriolis_t(i,j)*wrk5(i,j,k)                  ! f*(f + zeta)*N^2
           enddo
        enddo
     enddo
     if(id_vert_pv  > 0) call diagnose_3d(Time, Grd, id_vert_pv,  wrk5(:,:,:))
     if(id_vert_pvf > 0) call diagnose_3d(Time, Grd, id_vert_pvf, wrk6(:,:,:))
  endif        


  ! contribution from baroclinicity and total contribution 
  if(id_bc_pvf > 0 .or. id_pvf > 0 .or. id_ri_balance > 0) then
     wrk1(:,:,:) = 0.0 
     wrk2(:,:,:) = 0.0 
     wrk4(:,:,:) = 0.0 
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              wrk1(i,j,k) = grav_rho0r_sq *                                &
                            (Dens%drhodx_zt(i,j,k)*Dens%drhodx_zt(i,j,k) + &
                             Dens%drhody_zt(i,j,k)*Dens%drhody_zt(i,j,k)   &
                            )
              wrk2(i,j,k) =  wrk6(i,j,k) - wrk1(i,j,k)        ! PV*f = f*(f + zeta)*N^2 - |nabla b|^2 
              wrk4(i,j,k) =  wrk3(i,j,k)/(wrk1(i,j,k)+epsln)  ! Ri_b = (f*N)^2/|nabla b|^2 
           enddo
        enddo
     enddo
     if(id_bc_pvf     > 0) call diagnose_3d(Time, Grd, id_bc_pvf,    -wrk1(:,:,:))
     if(id_pvf        > 0) call diagnose_3d(Time, Grd, id_pvf,        wrk2(:,:,:))
     if(id_ri_balance > 0) call diagnose_3d(Time, Grd, id_ri_balance, wrk4(:,:,:))
  endif 


  ! calculate u dot grad vert_pv by centred q differences multiplied by averaged velocity
  ! NB: this method does not use conservative differencing so won't perfectly conserve advective q flux
  if(id_u_dot_grad_vert_pv > 0) then
    call mpp_update_domains(wrk5,Dom%domain2d)  ! update vert_pv
    do k=1,nk
      do j=jsc,jec
        do i=isc,iec
          wrk6(i,j,k) = (wrk5(i+1,j,k) - wrk5(i-1,j,k)) &
          /((Grd%dxu(i-1,j)+Grd%dxu(i,j) + Grd%dxu(i-1,j-1)+Grd%dxu(i,j-1))*0.5) &
           *( Velocity%u(i,j,k,1,tau) + &
              Velocity%u(i-1,j,k,1,tau) + &
              Velocity%u(i,j-1,k,1,tau) + &
              Velocity%u(i-1,j-1,k,1,tau) )*0.25 &
            + (wrk5(i,j+1,k) - wrk5(i,j-1,k)) &
            /((Grd%dyu(i,j-1)+Grd%dyu(i,j) + Grd%dyu(i-1,j-1)+Grd%dyu(i-1,j))*0.5) &
           *( Velocity%u(i,j,k,2,tau) + &
              Velocity%u(i-1,j,k,2,tau) + &
              Velocity%u(i,j-1,k,2,tau) + &
              Velocity%u(i-1,j-1,k,2,tau) )*0.25
        enddo
      enddo
      ! now do vertical advection
      if (k == 1) then ! 1st order, with vertical offset
        do j=jsc,jec
          do i=isc,iec
            wrk6(i,j,1) = wrk6(i,j,1) & 
              + (wrk5(i,j,1)-wrk5(i,j,2)) & 
              /Thickness%dzwt(i,j,1) &
              *Adv_vel%wrho_bt(i,j,1)*rho0r
          enddo
        enddo
      elseif (k == nk) then ! 1st order, with vertical offset
        do j=jsc,jec
          do i=isc,iec
            wrk6(i,j,nk) = wrk6(i,j,nk) & 
              + (wrk5(i,j,nk-1)-wrk5(i,j,nk)) & 
              /Thickness%dzwt(i,j,nk-1) &
              *Adv_vel%wrho_bt(i,j,nk-1)*rho0r
          enddo
        enddo
      else ! centred 2nd order differences, aligned vertically with other terms 
        do j=jsc,jec
          do i=isc,iec
            wrk6(i,j,k) = wrk6(i,j,k) & 
              + (wrk5(i,j,k-1) - wrk5(i,j,k+1)) &
              /(Thickness%dzwt(i,j,k-1) + Thickness%dzwt(i,j,k)) &
              *(Adv_vel%wrho_bt(i,j,k-1) + Adv_vel%wrho_bt(i,j,k))*0.5*rho0r
          enddo
        enddo
      endif
    enddo
    call diagnose_3d(Time, Grd, id_u_dot_grad_vert_pv, wrk6(:,:,:))
  endif

end subroutine diagnose_potential_vorticity
! </SUBROUTINE> NAME="diagnose_potential_vorticity"




!#######################################################################
! <SUBROUTINE NAME="pressure_conversion">
!
! <DESCRIPTION>
! Perform pressure conversion error analysis.  This analysis should be 
! computed prior to update_ucell_thickness since we need to use dzu(tau)
! and dzten(tau) here rather than dzu(taup1) or dzten(taup1).  
!
! Account taken for Bgrid and Cgrid.  However, blobs have no yet
! been updated for Cgrid.
!
! </DESCRIPTION>
!
subroutine pressure_conversion (Time, Thickness, rho, Dens, Ext_mode, &
                                Adv_vel, Velocity, L_system,          &
                                vert_coordinate_class, use_blobs)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_density_type),       intent(in)    :: Dens
  type(ocean_adv_vel_type),       intent(in)    :: Adv_vel
  type(ocean_external_mode_type), intent(in)    :: Ext_mode
  type(ocean_velocity_type),      intent(inout) :: Velocity
  type(ocean_lagrangian_type),    intent(in)    :: L_system
  real, dimension(isd:,jsd:,:),   intent(in)    :: rho
  integer,                        intent(in)    :: vert_coordinate_class 
  logical,                        intent(in)    :: use_blobs

  integer :: tau, taum1, taup1
  integer :: i, j, k, n, kb

  real, dimension(isd:ied,jsd:jed,2)  :: ubar
  real, dimension(isd:ied,jsd:jed,nk) :: rholo_anom
  real, dimension(isd:ied,jsd:jed,nk) :: rhoup_anom
  real :: rholo, rhoup
  real :: column_mass, boxarea
  real :: uint, uext, fx
  real :: term, term1, term2


  if(id_u_dot_grad_pint(1)    > 0 .or. id_u_dot_grad_pint(2)    > 0 .or. &
     id_ubar_dot_grad_pext(1) > 0 .or. id_ubar_dot_grad_pext(2) > 0 .or. &
     id_u_dot_grad_pint_xy    > 0 .or. id_ubar_dot_grad_pext_xy > 0) then 
     call pressure_energy(Time, Thickness, Ext_mode, Velocity, vert_coordinate_class)
  endif 
  
  if (.not. (energy_diag_step > 0 .and. mod(Time%itt, energy_diag_step) == 0)) return 

  call mpp_clock_begin(id_clock_press_conversion)

  tau   = Time%tau
  taum1 = Time%taum1
  taup1 = Time%taup1

  if (use_blobs) then
     ucell_mass = mpp_global_sum(Dom%domain2d, Grd%dau(:,:)*Thickness%mass_uT(:,:,tau), global_sum_flag)
  else
     ucell_mass = mpp_global_sum(Dom%domain2d, Grd%dau(:,:)*Thickness%mass_u(:,:,tau), global_sum_flag)
  endif

  if(horz_grid == MOM_BGRID) then 
     do j=jsd,jed
        do i=isd,ied
           mass_column(i,j,1) = Thickness%mass_u(i,j,tau)
           mass_column(i,j,2) = Thickness%mass_u(i,j,tau)
        enddo
     enddo
  else 
     do j=jsd,jed
        do i=isd,ied
           mass_column(i,j,1) = Thickness%mass_en(i,j,1)
           mass_column(i,j,2) = Thickness%mass_en(i,j,2)
        enddo
     enddo
  endif 


 ! truncate out the lower order bits if using non_bitwise_reproducible sums
  if (global_sum_flag .eq. NON_BITWISE_EXACT_SUM) ucell_mass = real(ucell_mass, kind=FLOAT_KIND)

  press_conv     = 0.0
  press_int      = 0.0
  press_ext      = 0.0
  press_conv_err = 0.0

  ! place density anomaly in wrk2 since it is needed frequently 
  if (use_blobs) then
     do k=1,nk
        do j=jsd,jed
           do i=isd,ied
              wrk2(i,j,k) = Grd%tmask(i,j,k)*(rho(i,j,k) - rho0) 
              rholo = (Thickness%dztlo(i,j,k)*rho(i,j,k) + L_system%rho_dztlo(i,j,k))/Thickness%dztloT(i,j,k)
              rhoup = (Thickness%dztup(i,j,k)*rho(i,j,k) + L_system%rho_dztup(i,j,k))/Thickness%dztupT(i,j,k)

              rholo_anom(i,j,k) = Grd%tmask(i,j,k)*(rholo - rho0)
              rhoup_anom(i,j,k) = Grd%tmask(i,j,k)*(rhoup - rho0)
           enddo
        enddo
     enddo
  else
     do k=1,nk
        do j=jsd,jed
           do i=isd,ied
              wrk2(i,j,k) = Grd%tmask(i,j,k)*(rho(i,j,k) - rho0) 
           enddo
        enddo
     enddo
  endif
  ! place mass tendency in wrk3 as it is needed frequently 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           wrk3(i,j,k) = Grd%tmask(i,j,k)*(Thickness%rho_dzt_tendency(i,j,k)-Thickness%mass_source(i,j,k))
        enddo
     enddo
  enddo

  ! vertically averaged horizontal velocity (meter/sec)
  do j=jsd,jed
     do i=isd,ied
        ubar(i,j,1) = Grd%tmasken(i,j,1,1)*Ext_mode%udrho(i,j,1,tau)/(mass_column(i,j,1)+epsln)
        ubar(i,j,2) = Grd%tmasken(i,j,1,2)*Ext_mode%udrho(i,j,2,tau)/(mass_column(i,j,2)+epsln)
     enddo
  enddo


  ! work done by baroclinic pressure 
  ! press_force [=] Pa [=] kg/(m*s^2)
  ! press_conv  [=] kg*m^2/s^3 = Watt
  do n=1,2
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              boxarea   = grd_area(i,j,k)
              uext      = ubar(i,j,n)
              uint      = Velocity%u(i,j,k,n,tau) - uext  
              term      = Velocity%press_force(i,j,k,n)*boxarea
              press_int = press_int + uint*term
              press_ext = press_ext + uext*term
           enddo
        enddo
     enddo
  enddo

  ! work done by depth independent pressure on depth independent flow 
  ! grad_ps [=] Pa/m =  kg/(m^2*s^2)
  ! grad_mb [=] m/s^2 
  ! press_conv [=] kg*m^2/s^3 = Watt.
  ! since this term also appears in the conversion 
  ! of u dot grad(p), we include it with press_conv.
  if(vert_coordinate_class==DEPTH_BASED) then 
      do j=jsc,jec
         do i=isc,iec
            column_mass = grd_area(i,j,1)*mass_column(i,j,1)
            term        = rho0r*Ext_mode%grad_ps(i,j,1)*ubar(i,j,1)
            press_ext   = press_ext  - term*column_mass
            press_conv  = press_conv - term*column_mass

            column_mass = grd_area(i,j,1)*mass_column(i,j,2)
            term        = rho0r*Ext_mode%grad_ps(i,j,2)*ubar(i,j,2)
            press_ext   = press_ext  - term*column_mass
            press_conv  = press_conv - term*column_mass
         enddo
      enddo
  elseif(vert_coordinate_class==PRESSURE_BASED) then 
      do j=jsc,jec
         do i=isc,iec
            column_mass = grd_area(i,j,1)*mass_column(i,j,1)
            term        = Ext_mode%grad_anompb(i,j,1)*ubar(i,j,1) 
            press_ext   = press_ext  - term*column_mass
            press_conv  = press_conv - term*column_mass

            column_mass = grd_area(i,j,1)*mass_column(i,j,2)
            term        = Ext_mode%grad_anompb(i,j,2)*ubar(i,j,2) 
            press_ext   = press_ext  - term*column_mass
            press_conv  = press_conv - term*column_mass
         enddo
      enddo
  endif


  ! compute the conversion terms 
  if(vert_coordinate_class==DEPTH_BASED) then 

      if (use_blobs) then
         wrk1(:,:,:) = hydrostatic_pressure_blob(Thickness, rhoup_anom(:,:,:), rholo_anom(:,:,:)) 
      else
         wrk1(:,:,:) = hydrostatic_pressure(Thickness, wrk2(:,:,:)) 
      endif

      if(Thickness%method==ENERGETIC) then 

          do j=jsc,jec
             do i=isc,iec
                kb = Grd%kmt(i,j)
                if (kb /= 0) then

                    k = 1
                    term = -rho0r*Grd%tmask(i,j,k)*Grd%dat(i,j)*wrk1(i,j,k)*(wrk3(i,j,k)+Adv_vel%wrho_bt(i,j,k-1))
                    press_conv  = press_conv + term

                    fx = Grd%dat(i,j)*p5grav   
                    do k=2,kb
                       term1 = -fx*Adv_vel%wrho_bt(i,j,k-1)*Thickness%dzwt(i,j,k-1)*(wrk2(i,j,k-1) + wrk2(i,j,k))
                       term2 = -Grd%dat(i,j)*wrk1(i,j,k)*wrk3(i,j,k)
                       press_conv  =  press_conv + rho0r*Grd%tmask(i,j,k)*(term1 + term2)
                    enddo

                endif
             enddo
          enddo

      else 

          do j=jsc,jec
             do i=isc,iec
                kb = Grd%kmt(i,j)
                if (kb /= 0) then

                    k = 1
                    term = -rho0r*Grd%tmask(i,j,k)*Grd%dat(i,j)*wrk1(i,j,k)*(wrk3(i,j,k)+Adv_vel%wrho_bt(i,j,k-1))
                    press_conv  = press_conv + term

                    fx = Grd%dat(i,j)*grav   
                    do k=2,kb
                       term1 = -fx*Adv_vel%wrho_bt(i,j,k-1) &
                       *(Thickness%dztlo(i,j,k-1)*wrk2(i,j,k-1) + Thickness%dztup(i,j,k)*wrk2(i,j,k)) 
                       term2 = -Grd%dat(i,j)*wrk1(i,j,k)*wrk3(i,j,k)
                       press_conv  =  press_conv + rho0r*Grd%tmask(i,j,k)*(term1 + term2)
                    enddo

                endif
             enddo
          enddo

      endif

     ! gradient of geopotential (area sum vanishes on k-level if geodepth_zt is independent of (i,j))
      do k=1,nk
         wrk1_v(:,:,k,1) = BDX_ET((Adv_vel%uhrho_et(:,:,k))*FAX(wrk2(:,:,k)))*Grd%dat(:,:)
         wrk1_v(:,:,k,2) = BDY_NT((Adv_vel%vhrho_nt(:,:,k))*FAY(wrk2(:,:,k)))*Grd%dat(:,:)
         fx = grav*rho0r
         do j=jsc,jec
            do i=isc,iec
               term = -fx*(wrk1_v(i,j,k,1) + wrk1_v(i,j,k,2))*Thickness%geodepth_zt(i,j,k)
               press_conv = press_conv + term
            enddo
         enddo
      enddo

  elseif(vert_coordinate_class==PRESSURE_BASED) then 

     
      if (use_blobs) then
         wrk1(:,:,:) = geopotential_anomaly_blob(Thickness, rhoup_anom(:,:,:), rholo_anom(:,:,:)) 
      else
         wrk1(:,:,:) = geopotential_anomaly(Thickness, wrk2(:,:,:)) 
      endif


      if(Thickness%method==ENERGETIC) then 

          do j=jsc,jec
             do i=isc,iec
                kb = Grd%kmt(i,j)
                if (kb /= 0) then

                    k = 1
                    term = -Grd%tmask(i,j,k)*Grd%dat(i,j)*wrk1(i,j,k)*(wrk3(i,j,k)+Adv_vel%wrho_bt(i,j,k-1))
                    press_conv = press_conv + term

                    fx = Grd%dat(i,j)*p5grav_rho0r    
                    do k=2,kb
                       term1 = -fx*Adv_vel%wrho_bt(i,j,k-1)*Thickness%dzwt(i,j,k-1)*(wrk2(i,j,k-1) + wrk2(i,j,k))
                       term2 = -Grd%dat(i,j)*wrk1(i,j,k)*wrk3(i,j,k)
                       press_conv  =  press_conv + Grd%tmask(i,j,k)*(term1 + term2)
                    enddo

                endif
             enddo
          enddo

      else 

          do j=jsc,jec
             do i=isc,iec
                kb = Grd%kmt(i,j)
                if (kb /= 0) then

                    k = 1
                    term = -Grd%tmask(i,j,k)*Grd%dat(i,j)*wrk1(i,j,k)*(wrk3(i,j,k)+Adv_vel%wrho_bt(i,j,k-1))
                    press_conv = press_conv + term

                    fx = Grd%dat(i,j)*grav_rho0r    
                    do k=2,kb
                       term1 = -fx*Adv_vel%wrho_bt(i,j,k-1) &
                                *(Thickness%dztlo(i,j,k-1)*wrk2(i,j,k-1) + &
                                  Thickness%dztup(i,j,k)  *wrk2(i,j,k)) 
                       term2 = -Grd%dat(i,j)*wrk1(i,j,k)*wrk3(i,j,k)
                       press_conv  =  press_conv + Grd%tmask(i,j,k)*(term1 + term2)
                    enddo

                endif
             enddo
          enddo

      endif

      ! now for the "unmanipulated" piece 
      if(horz_grid == MOM_BGRID) then 

         do k=1,nk
            do j=jsd,jed
               do i=isd,iec
                  wrk2_v(i,j,k,1) = (Dens%pressure_at_depth(i+1,j,k)-Dens%pressure_at_depth(i,j,k))*dbars2Pa
               enddo
            enddo
            do j=jsd,jec
               do i=isd,ied
                  wrk2_v(i,j,k,2) = (Dens%pressure_at_depth(i,j+1,k)-Dens%pressure_at_depth(i,j,k))*dbars2Pa
               enddo
            enddo
         enddo
         do k=1,nk
            wrk1_v(:,:,k,1) = FAY(FAX(wrk2(:,:,k))*wrk2_v(:,:,k,1))*Grd%dyu(:,:)
            wrk1_v(:,:,k,2) = FAX(FAY(wrk2(:,:,k))*wrk2_v(:,:,k,2))*Grd%dxu(:,:)
            do j=jsc,jec
               do i=isc,iec
                  term = rho0r*Thickness%dzu(i,j,k) &
                  *(Velocity%u(i,j,k,1,tau)*wrk1_v(i,j,k,1) + Velocity%u(i,j,k,2,tau)*wrk1_v(i,j,k,2))
                  press_conv = press_conv + term
               enddo
            enddo
         enddo

      else   ! Cgrid 

         do k=1,nk
            do j=jsd,jed
               do i=isd,iec
                  wrk2_v(i,j,k,1) = Grd%dxter(i,j)*(Dens%pressure_at_depth(i+1,j,k)-Dens%pressure_at_depth(i,j,k))*dbars2Pa
               enddo
            enddo
            do j=jsd,jec
               do i=isd,ied
                  wrk2_v(i,j,k,2) = Grd%dytnr(i,j)*(Dens%pressure_at_depth(i,j+1,k)-Dens%pressure_at_depth(i,j,k))*dbars2Pa
               enddo
            enddo
         enddo
         do k=1,nk
            wrk1_v(:,:,k,1) = FAX(wrk2(:,:,k))*wrk2_v(:,:,k,1)
            wrk1_v(:,:,k,2) = FAY(wrk2(:,:,k))*wrk2_v(:,:,k,2)
            do j=jsc,jec
               do i=isc,iec
                  term = rho0r*Thickness%dzten(i,j,k,1)*Grd%dat(i,j)*Velocity%u(i,j,k,1,tau)*wrk1_v(i,j,k,1) &
                        +rho0r*Thickness%dzten(i,j,k,2)*Grd%dat(i,j)*Velocity%u(i,j,k,2,tau)*wrk1_v(i,j,k,2)
                  press_conv = press_conv + term
               enddo
            enddo
         enddo

     endif ! endif for horz_grid 


  endif   ! endif for vertical coordinates  


  call mpp_sum(press_int)
  call mpp_sum(press_ext)
  call mpp_sum(press_conv)
  press_conv_err = press_int + press_ext - press_conv 


  call mpp_clock_end(id_clock_press_conversion)


end subroutine pressure_conversion
! </SUBROUTINE> NAME="pressure_conversion"


!#######################################################################
! <SUBROUTINE NAME="pressure_energy">
!
! <DESCRIPTION>
! Diagnose u dot grad(p) for diagnostic purposes. These maps 
! when summed over all grid points will result in an energy 
! that is equal to pint+pext as computed in pressure_conversion.  
!
! Account taken of either Bgrid or Cgrid. 
!
! </DESCRIPTION>
!
subroutine pressure_energy (Time, Thickness, Ext_mode, Velocity, vert_coordinate_class)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_external_mode_type), intent(in)    :: Ext_mode
  type(ocean_velocity_type),      intent(inout) :: Velocity
  integer,                        intent(in)    :: vert_coordinate_class 

  integer :: tau
  integer :: i, j, k, n

  real, dimension(isd:ied,jsd:jed,2) :: ubar
  real :: column_mass, boxarea
  real :: term

  call mpp_clock_begin(id_clock_press_energy)

  tau = Time%tau
  wrk1_v(:,:,:,:) = 0.0
  wrk1_v2d(:,:,:) = 0.0

  if(horz_grid == MOM_BGRID) then 
     do j=jsd,jed
        do i=isd,ied
           mass_column(i,j,1) = Thickness%mass_u(i,j,tau)
           mass_column(i,j,2) = Thickness%mass_u(i,j,tau)
        enddo
     enddo
  else 
     do j=jsd,jed
        do i=isd,ied
           mass_column(i,j,1) = Thickness%mass_en(i,j,1)
           mass_column(i,j,2) = Thickness%mass_en(i,j,2)
        enddo
     enddo
  endif 

  ! vertically averaged horizontal velocity 
  do j=jsd,jed
     do i=isd,ied
        ubar(i,j,1) = Grd%tmasken(i,j,1,1)*Ext_mode%udrho(i,j,1,tau)/(mass_column(i,j,1)+epsln)
        ubar(i,j,2) = Grd%tmasken(i,j,1,2)*Ext_mode%udrho(i,j,2,tau)/(mass_column(i,j,2)+epsln)
     enddo
  enddo


  ! work done by horizontal baroclinic gradients
  ! press_force [=] Pa [=] kg/(m*s^2)
  ! wrk1_v [=] wrk2_v [=] kg*m^2/s^3 = Watt
  do n=1,2
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              boxarea         =  grd_area(i,j,k)
              term            =  Velocity%press_force(i,j,k,n)*boxarea
              wrk1_v(i,j,k,n) =  Velocity%u(i,j,k,n,tau)*term
           enddo
        enddo
     enddo
  enddo

  ! work done by depth independent pressure on depth independent flow 
  ! grad_ps [=] Pa/m =  kg/(m^2*s^2)
  ! grad_mb [=] m/s^2 
  ! wrk2_v [=] kg*m^2/s^3 = Watt
  if(vert_coordinate_class==DEPTH_BASED) then 
      do j=jsc,jec
         do i=isc,iec
            column_mass     = grd_area(i,j,1)*mass_column(i,j,1)
            term            = rho0r*Ext_mode%grad_ps(i,j,1)*ubar(i,j,1) 
            wrk1_v2d(i,j,1) =  -term*column_mass
            column_mass     = grd_area(i,j,1)*mass_column(i,j,2)
            term            = rho0r*Ext_mode%grad_ps(i,j,2)*ubar(i,j,2)
            wrk1_v2d(i,j,2) =  -term*column_mass
         enddo
      enddo
  elseif(vert_coordinate_class==PRESSURE_BASED) then 
      do j=jsc,jec
         do i=isc,iec
            column_mass     = grd_area(i,j,1)*mass_column(i,j,1)
            term            = Ext_mode%grad_anompb(i,j,1)*ubar(i,j,1) 
            wrk1_v2d(i,j,1) = -term*column_mass
            column_mass     = grd_area(i,j,1)*mass_column(i,j,2)
            term            = Ext_mode%grad_anompb(i,j,2)*ubar(i,j,2)            
            wrk1_v2d(i,j,2) = -term*column_mass
         enddo
      enddo
  endif

  
  if (id_u_dot_grad_pint(1) > 0) used = send_data (id_u_dot_grad_pint(1), wrk1_v(:,:,:,1), &
                       Time%model_time, rmask=Grd%mask(:,:,:),                             &
                       is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)

  if (id_u_dot_grad_pint(2) > 0) used = send_data (id_u_dot_grad_pint(2), wrk1_v(:,:,:,2), &
                       Time%model_time, rmask=Grd%mask(:,:,:),                             &
                       is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)

  if (id_u_dot_grad_pint_xy > 0) used = send_data (id_u_dot_grad_pint_xy,             &
                       wrk1_v(:,:,:,1)+wrk1_v(:,:,:,2),                               &
                       Time%model_time, rmask=Grd%mask(:,:,:),                        &
                       is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)


  if (id_ubar_dot_grad_pext(1) > 0) used = send_data (id_ubar_dot_grad_pext(1), wrk1_v2d(:,:,1), &
                       Time%model_time, rmask=Grd%mask(:,:,1),                                   &
                       is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)

  if (id_ubar_dot_grad_pext(2) > 0) used = send_data (id_ubar_dot_grad_pext(2), wrk1_v2d(:,:,2), &
                       Time%model_time, rmask=Grd%mask(:,:,1),                                   &
                       is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)

  if (id_ubar_dot_grad_pext_xy > 0) used = send_data (id_ubar_dot_grad_pext_xy, &
                       wrk1_v2d(:,:,1)+wrk1_v2d(:,:,2),                         &
                       Time%model_time, rmask=Grd%mask(:,:,1),                  &
                       is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)


  call mpp_clock_end(id_clock_press_energy)

end subroutine pressure_energy
! </SUBROUTINE> NAME="pressure_energy"


!#######################################################################
! <SUBROUTINE NAME="friction_energy">
!
! <DESCRIPTION>
! Diagnose u dot Friction for diagnostic purposes. 
!
! Account taken for either Bgrid or Cgrid.  
!
! NOTE:
!
! A) DO NOT split into baroclinic and barotropic pieces. Just compute 
! u dot F using full velocity field u. Otherwise, the calculation emulates 
! that done in energy_analysis subroutine. 
!
! B) DO NOT remove the effects from bottom drag and from surface stress. 
! The reason is that bottom drag and surface stress are incorporated to 
! the vertical friction operator, even when doing vertical friction 
! implicitly in time.  So it is tough to remove these effects in an 
! explicit diagnostic manner.  So the u dot vertical friction piece
! includes BOTH surface (i.e., winds) and bottom stress.
!
! </DESCRIPTION>
!
subroutine friction_energy (Time, Thickness, Adv_vel, Ext_mode, Velocity, visc_cbu, visc_cbt)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_adv_vel_type),       intent(in)    :: Adv_vel
  type(ocean_external_mode_type), intent(in)    :: Ext_mode
  type(ocean_velocity_type),      intent(inout) :: Velocity
  real, dimension(isd:,jsd:,:),   intent(in)    :: visc_cbu
  real, dimension(isd:,jsd:,:),   intent(in)    :: visc_cbt

  integer :: tau
  integer :: i, j, k, n

  real, dimension(isd:ied,jsd:jed,2) :: ubar
  real :: boxarea, term

  call mpp_clock_begin(id_clock_friction_energy)

  tau = Time%tau
  wrk2_v(:,:,:,:) = 0.0   ! for holding u dot friction 
                          ! (do NOT use wrk1_v, as that is used in friction modules)
  wrk1_v2d(:,:,:) = 0.0   ! for holding ubar dot horizontal stress acting JUST on ubar 

  if(horz_grid == MOM_BGRID) then 
     do j=jsd,jed
        do i=isd,ied
           mass_column(i,j,1) = Thickness%mass_u(i,j,tau)
           mass_column(i,j,2) = Thickness%mass_u(i,j,tau)
        enddo
     enddo
  else 
     do j=jsd,jed
        do i=isd,ied
           mass_column(i,j,1) = Thickness%mass_en(i,j,1)
           mass_column(i,j,2) = Thickness%mass_en(i,j,2)
        enddo
     enddo
  endif 

  ! vertically averaged horizontal velocity 
  do j=jsd,jed
     do i=isd,ied
        ubar(i,j,1) = Grd%tmasken(i,j,1,1)*Ext_mode%udrho(i,j,1,tau)/(mass_column(i,j,1)+epsln)
        ubar(i,j,2) = Grd%tmasken(i,j,1,2)*Ext_mode%udrho(i,j,2,tau)/(mass_column(i,j,2)+epsln)
     enddo
  enddo

  ! work done by laplacian friction on horizontal velocity field.
  ! lap_friction returns thickness weighted and density weighted
  ! friction with dimensions (kg/m^3)*(m^2/s^2) = N/m^2 = Pa
  ! wrk1_v [=]  kg*m^2/s^3 = Watt
  call lap_friction(Time, Thickness, Adv_vel, Velocity, energy_analysis_step=.true.)
  do n=1,2
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              boxarea         = grd_area(i,j,k)
              term            = Velocity%wrkv(i,j,k,n)*boxarea    
              wrk2_v(i,j,k,n) = Velocity%u(i,j,k,n,tau)*term  
           enddo
        enddo
     enddo
  enddo

  if (id_u_dot_lapfrict_horz > 0) used = send_data (id_u_dot_lapfrict_horz, wrk2_v(:,:,:,1), &
                       Time%model_time, rmask=Grd%mask(:,:,:),                               &
                       is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)

  if (id_v_dot_lapfrict_horz > 0) used = send_data (id_v_dot_lapfrict_horz, wrk2_v(:,:,:,2), &
                       Time%model_time, rmask=Grd%mask(:,:,:),                               &
                       is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)

  ! work done by biharmonic friction
  ! bih_friction returns thickness weighted and density weighted
  ! friction with dimensions (kg/m^3)*(m^2/s^2) = N/m^2 = Pa.
  ! include contributions from both biharmonic friction and 
  ! side drag friction that may optionally be applied.   
  ! eng(5) [=]  kg*m^2/s^3 = Watt
  call bih_friction(Time, Thickness, Adv_vel, Velocity, energy_analysis_step=.true.)
  do n=1,2
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              boxarea         = grd_area(i,j,k)
              term            = Velocity%wrkv(i,j,k,n)*boxarea    
              wrk2_v(i,j,k,n) = Velocity%u(i,j,k,n,tau)*term  
           enddo
        enddo
     enddo
  enddo

  if (id_u_dot_bihfrict_horz > 0) used = send_data (id_u_dot_bihfrict_horz, wrk2_v(:,:,:,1), &
                       Time%model_time, rmask=Grd%mask(:,:,:),                               &
                       is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)

  if (id_v_dot_bihfrict_horz > 0) used = send_data (id_v_dot_bihfrict_horz, wrk2_v(:,:,:,2), &
                       Time%model_time, rmask=Grd%mask(:,:,:),                               &
                       is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)


  ! contribution from lap_friction acting just on barotropic. 
  ! friction with dimensions (kg/m^3)*(m^2/s^2) = N/m^2 = Pa
  ! wrk1_v2d [=]  kg*m^2/s^3 = Watt
  do n=1,2
     do j=jsc,jec
        do i=isc,iec
           boxarea         = grd_area(i,j,1)
           term            = Velocity%lap_friction_bt(i,j,n)*boxarea    
           wrk1_v2d(i,j,n) = ubar(i,j,n)*term
        enddo
     enddo
  enddo

  ! contribution from bih_friction acting just on the barotropic. 
  ! friction with dimensions (kg/m^3)*(m^2/s^2) = N/m^2 = Pa
  ! eng(5) [=]  kg*m^2/s^3 = Watt
  do n=1,2
     do j=jsc,jec
        do i=isc,iec
           boxarea         = grd_area(i,j,1)
           term            = Velocity%bih_friction_bt(i,j,n)*boxarea    
           wrk1_v2d(i,j,n) = wrk1_v2d(i,j,n) + ubar(i,j,n)*term
        enddo
     enddo
  enddo

  if (id_ubar_dot_frict_bt > 0) used = send_data (id_ubar_dot_frict_bt, wrk1_v2d(:,:,1), &
                       Time%model_time, rmask=Grd%mask(:,:,1),                           &
                       is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)

  if (id_vbar_dot_frict_bt > 0) used = send_data (id_vbar_dot_frict_bt, wrk1_v2d(:,:,2), &
                       Time%model_time, rmask=Grd%mask(:,:,1),                           &
                       is_in=isc, js_in=jsc, ie_in=iec, je_in=jec)


  ! work done by vertical friction, including wind stress and bottom stress. 
  ! implicit acceleration has been saved from previous call to ocean_implicit_accel.
  ! the implicit piece includes contributions from visc_cbu_form_drag, as well as visc_cbu, visc_cbt. 
  ! vert_frict returns thickness weighted and density weighted vertical friction (kg/m^3)*(m^2/s^2)
  ! wrk2_v [=]  kg*m^2/s^3 = Watt
  ! Note: no need to call the implicit operator again, since saved result in vfrict_impl. 
  if(horz_grid == MOM_BGRID) then 
     call vert_friction_bgrid(Time, Thickness, Velocity, visc_cbu, energy_analysis_step=.true.)
  else 
     call vert_friction_cgrid(Time, Thickness, Velocity, visc_cbt, energy_analysis_step=.true.)
  endif 
  do n=1,2
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              boxarea         = grd_area(i,j,k)
              term            = (Velocity%wrkv(i,j,k,n)+ Velocity%vfrict_impl(i,j,k,n))*boxarea 
              wrk2_v(i,j,k,n) = Velocity%u(i,j,k,n,tau)*term     
           enddo
        enddo
     enddo
  enddo
 
  if (id_u_dot_frict_vert > 0) used = send_data (id_u_dot_frict_vert, wrk2_v(:,:,:,1), &
                       Time%model_time, rmask=Grd%mask(:,:,:),                         &
                       is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)

  if (id_v_dot_frict_vert > 0) used = send_data (id_v_dot_frict_vert, wrk2_v(:,:,:,2), &
                       Time%model_time, rmask=Grd%mask(:,:,:),                         &
                       is_in=isc, js_in=jsc, ks_in=1, ie_in=iec, je_in=jec, ke_in=nk)


  call mpp_clock_end(id_clock_friction_energy)

end subroutine friction_energy
! </SUBROUTINE> NAME="friction_energy"


!#######################################################################
! <SUBROUTINE NAME="vert_dissipation">
!
! <DESCRIPTION>
! Diagnose dissipation from vertical friction due just to viscosity.
!
! Units W/m^2
!
! Assumptions:
!
! 1/ Ignore bottom drag here...just concerned with viscosity. 
!
! 2/ Assume vertical friction is handled implicitly in time. 
! 
! </DESCRIPTION>
!
subroutine vert_dissipation (Time, Thickness, Velocity, visc_cbu, visc_cbt, visc_cbu_form_drag)

  type(ocean_time_type),          intent(in) :: Time
  type(ocean_thickness_type),     intent(in) :: Thickness
  type(ocean_velocity_type),      intent(in) :: Velocity
  real, dimension(isd:,jsd:,:),   intent(in) :: visc_cbu
  real, dimension(isd:,jsd:,:),   intent(in) :: visc_cbt
  real, dimension(isd:,jsd:,:,:), intent(in) :: visc_cbu_form_drag

  integer :: itime
  integer :: i, j, k, n
  real    :: du_dz 
  type(time_type) :: next_time 

  call mpp_clock_begin(id_clock_vert_dissipation)

  itime = Time%taup1

  next_time = increment_time(Time%model_time, int(dtime), 0)
  if (need_data(id_vert_lap_diss,next_time)) then 

      if(horz_grid == MOM_BGRID) then 

         wrk1(:,:,:) = 0.0
         do n=1,2
            do k=1,nk-1
               do j=jsc,jec
                  do i=isc,iec
                     du_dz = Grd%umask(i,j,k+1) &
                     *(Velocity%u(i,j,k,n,itime)-Velocity%u(i,j,k+1,n,itime))/Thickness%dzwu(i,j,k)
                     wrk1(i,j,k) = wrk1(i,j,k) &   
                     -rho0*Thickness%dzu(i,j,k)*du_dz*du_dz &
                      *(visc_cbu(i,j,k)+visc_cbu_form_drag(i,j,k,n))  
                  enddo
               enddo
            enddo
         enddo
         call diagnose_3d_u(Time, Grd, id_vert_lap_diss, wrk1(:,:,:))
      
      else  ! Cgrid

         wrk1(:,:,:) = 0.0
         do n=1,2
            do k=1,nk-1
               do j=jsc,jec
                  do i=isc,iec
                     du_dz = Grd%tmasken(i,j,k+1,n) &
                     *(Velocity%u(i,j,k,n,itime)-Velocity%u(i,j,k+1,n,itime))/(epsln+Thickness%dzten(i,j,k,n))
                     wrk1(i,j,k) = wrk1(i,j,k) &   
                     -rho0*Thickness%dzten(i,j,k,n)*du_dz*du_dz &
                      *(visc_cbt(i,j,k)+visc_cbu_form_drag(i,j,k,n))  
                  enddo
               enddo
            enddo
         enddo
         call diagnose_3d(Time, Grd, id_vert_lap_diss, wrk1(:,:,:))

      endif 

  endif

  call mpp_clock_end(id_clock_vert_dissipation)

end subroutine vert_dissipation
! </SUBROUTINE> NAME="vert_dissipation"



!#######################################################################
! <SUBROUTINE NAME="energy_analysis">
!
! <DESCRIPTION>
! Perform energy analysis by taking scalar product of horizontal
! velocity with the velocity equations and integrating over the ocean volume.
!
! Pressure conversions have already been computed in pressure_conversion 
! subroutine.  It is necessary to perform that analysis earlier than 
! the call to update_ucell_thickness inside ocean_model_mod, whereas 
! the remaining elements in the energy analysis can be called at the 
! end of the update for velocity.  
! </DESCRIPTION>
!
subroutine energy_analysis (Time, Thickness, Ext_mode, Adv_vel, Dens,    & 
                            pme, river, upme, uriver, visc_cbu, visc_cbt,&
                            visc_cbu_form_drag, Velocity)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_adv_vel_type),       intent(in)    :: Adv_vel
  type(ocean_density_type),       intent(in)    :: Dens
  type(ocean_external_mode_type), intent(in)    :: Ext_mode
  type(ocean_velocity_type),      intent(inout) :: Velocity
  real, dimension(isd:,jsd:),     intent(in)    :: pme
  real, dimension(isd:,jsd:),     intent(in)    :: river 
  real, dimension(isd:,jsd:,:),   intent(in)    :: upme
  real, dimension(isd:,jsd:,:),   intent(in)    :: uriver
  real, dimension(isd:,jsd:,:),   intent(in)    :: visc_cbu
  real, dimension(isd:,jsd:,:),   intent(in)    :: visc_cbt
  real, dimension(isd:,jsd:,:,:), intent(in)    :: visc_cbu_form_drag

  integer :: i, j, k, n
  integer :: tau, taum1, taup1, tau_m0

  real :: boxarea
  real :: uint, uext, term, vel
  real :: rho_dz_vel_tau
  real :: ke_tot, pe_tot, pe_tot_rel, ke_per_mass
  
  real, dimension(isd:ied,jsd:jed,2) :: ubar
  real, dimension(isd:ied,jsd:jed)   :: pme_u
  real, dimension(isd:ied,jsd:jed)   :: river_u

  real, dimension(13) :: engint         ! internal mode energy integral components (Watt)
  real, dimension(13) :: engext         ! external mode energy integral components (Watt)
  real                :: compression    ! power from compression of grid cell and/or mass sources  
  real                :: enleak         ! difference between integrated advection of momentum 
                                        ! and power from compression and water forcing 
  integer :: stdoutunit 
  stdoutunit=stdout() 


  ! get 3d maps for energetics from friction 
  if(id_u_dot_lapfrict_horz  > 0 .or. id_v_dot_lapfrict_horz  > 0 .or. &
     id_u_dot_bihfrict_horz  > 0 .or. id_v_dot_bihfrict_horz  > 0 .or. &
     id_u_dot_frict_vert     > 0 .or. id_v_dot_frict_vert     > 0 .or. &
     id_ubar_dot_frict_bt    > 0 .or. id_vbar_dot_frict_bt    > 0) then 
     call friction_energy(Time, Thickness, Adv_vel, Ext_mode, Velocity, visc_cbu, visc_cbt)
  endif 

  ! get energy dissipation from vertical friction 
  call vert_dissipation(Time, Thickness, Velocity, visc_cbu, visc_cbt, visc_cbu_form_drag)

  if (.not. (energy_diag_step > 0 .and. mod(Time%itt, energy_diag_step) == 0)) return 

  call mpp_clock_begin(id_clock_energy_analysis)

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_velocity_diag_mod (energy_analysis): module must be initialized')
  endif 

  tau    = Time%tau
  taum1  = Time%taum1
  taup1  = Time%taup1
  tau_m0 = Time%tau_m0

  compression = 0.0
  engint(:)   = 0.0
  engext(:)   = 0.0

  ! place mass tendency in wrk3 as it is needed frequently 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           wrk3(i,j,k) = Grd%tmask(i,j,k)*(Thickness%rho_dzt_tendency(i,j,k)-Thickness%mass_source(i,j,k))
        enddo
     enddo
  enddo

  ! mass per horizontal area of a fluid column
  if(horz_grid == MOM_BGRID) then 
     do j=jsd,jed
        do i=isd,ied
           mass_column(i,j,1) = Thickness%mass_u(i,j,tau)
           mass_column(i,j,2) = Thickness%mass_u(i,j,tau)
        enddo
     enddo
  else 
     do j=jsd,jed
        do i=isd,ied
           mass_column(i,j,1) = Thickness%mass_en(i,j,1)
           mass_column(i,j,2) = Thickness%mass_en(i,j,2)
        enddo
     enddo
  endif 

  ! compute vertical average of horizontal velocity
  do j=jsd,jed
    do i=isd,ied
      ubar(i,j,1) = Grd%tmasken(i,j,1,1)*Ext_mode%udrho(i,j,1,tau)/(mass_column(i,j,1)+epsln)
      ubar(i,j,2) = Grd%tmasken(i,j,1,2)*Ext_mode%udrho(i,j,2,tau)/(mass_column(i,j,2)+epsln)
    enddo
  enddo

  if (debug_this_module) then
      write(stdoutunit,*) ' '
      write(stdoutunit,*) '===chksums in energy analysis===' 
      write(stdoutunit,*) 'dtime(seconds) = ',dtime, 'and dtimer = ',dtimer

      call write_chksum_3d('Thickness%rho_dzu(taum1)', Thickness%rho_dzu(COMP,:,taum1)*Grd%umask(COMP,:))
      call write_chksum_3d('Thickness%rho_dzu(tau)', Thickness%rho_dzu(COMP,:,tau)*Grd%umask(COMP,:))
      call write_chksum_3d('Thickness%rho_dzu(taup1)', Thickness%rho_dzu(COMP,:,taup1)*Grd%umask(COMP,:))
      call write_chksum_3d('Thickness%rho_dzten(1)', Thickness%rho_dzten(COMP,:,1)*Grd%tmasken(COMP,:,1))
      call write_chksum_3d('Thickness%rho_dzten(2)', Thickness%rho_dzten(COMP,:,2)*Grd%tmasken(COMP,:,2))
      call write_chksum_2d('mass_column(1)', mass_column(COMP,1)*Grd%umask(COMP,1))
      call write_chksum_2d('mass_column(2)', mass_column(COMP,2)*Grd%umask(COMP,1))
      call write_chksum_3d('Velocity%u(n=1,taum1)', Velocity%u(COMP,:,1,taum1)*Grd%tmasken(COMP,:,1))
      call write_chksum_3d('Velocity%u(n=1,tau)', Velocity%u(COMP,:,1,tau)*Grd%tmasken(COMP,:,1))
      call write_chksum_3d('Velocity%u(n=1,taup1)', Velocity%u(COMP,:,1,taup1)*Grd%tmasken(COMP,:,1))
      call write_chksum_3d('Velocity%u(n=2,taum1)', Velocity%u(COMP,:,2,taum1)*Grd%tmasken(COMP,:,2))
      call write_chksum_3d('Velocity%u(n=2,tau)', Velocity%u(COMP,:,2,tau)*Grd%tmasken(COMP,:,2))
      call write_chksum_3d('Velocity%u(n=2,taup1)', Velocity%u(COMP,:,2,taup1)*Grd%tmasken(COMP,:,2))
      call write_chksum_2d('ubar(n=1)', ubar(COMP,1)*Grd%tmasken(COMP,1,1))
      call write_chksum_2d('ubar(n=2)', ubar(COMP,2)*Grd%tmasken(COMP,1,2))

      write(stdoutunit,*)'================================='
  endif


  ! scalar product of u with the time rate of change 
  ! eng(1) [=] kg*m^2/s^3 = Watt
  if(horz_grid == MOM_BGRID) then 

     do n=1,2
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 boxarea   = grd_area(i,j,k)
                 uext      = ubar(i,j,n)
                 uint      = Velocity%u(i,j,k,n,tau) - uext
                 term      = (Thickness%rho_dzu(i,j,k,taup1)*Velocity%u(i,j,k,n,taup1)  &
                             -Thickness%rho_dzu(i,j,k,taum1)*Velocity%u(i,j,k,n,taum1)) &
                             *dtimer*boxarea
                 engint(1) = engint(1) + uint*term
                 engext(1) = engext(1) + uext*term
              enddo
           enddo
        enddo
     enddo

  else   ! Cgrid 

     do n=1,2
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 boxarea        = grd_area(i,j,k)*Grd%tmasken(i,j,k,n)
                 uext           = ubar(i,j,n)
                 uint           = Velocity%u(i,j,k,n,tau) - uext
                 rho_dz_vel_tau = (2-n)*Adv_vel%uhrho_et(i,j,k)*Grd%dxte_dxtr(i,j)*Grd%dyte_dytr(i,j) &
                                 +(n-1)*Adv_vel%vhrho_nt(i,j,k)*Grd%dxtn_dxtr(i,j)*Grd%dytn_dytr(i,j)
                 term      = (Thickness%rho_dzten(i,j,k,n)*Velocity%u(i,j,k,n,taup1) - rho_dz_vel_tau)*dtimer*boxarea
                 engint(1) = engint(1) + uint*term
                 engext(1) = engext(1) + uext*term
              enddo
           enddo
        enddo
     enddo 

  endif   ! horz_grid endif 


  ! work done by horizontal advection 
  ! horz_advection_of_velocity [=] thickness and density weighted advection 
  ! which has dimensions (kg/m^3)*(m^2/s^2) = Pa
  ! eng(2) [=] kg*m^2/s^3 = Watt
  call horz_advection_of_velocity(Time, Thickness, Adv_vel, Velocity, &
                                  energy_analysis_step=.true.)       
  do n=1,2
    do k=1,nk
      do j=jsc,jec
        do i=isc,iec
          boxarea   = Grd_area(i,j,k)
          uext      = ubar(i,j,n)
          uint      = Velocity%u(i,j,k,n,tau) - uext 
          term      = Velocity%wrkv(i,j,k,n)*boxarea  
          engint(2) = engint(2) - uint*term
          engext(2) = engext(2) - uext*term
        enddo
      enddo
    enddo
  enddo

  ! work done by vertical advection
  ! vertical_advection_of_velocity [=] thickness and density weighted advection
  ! which as dimensions (kg/m^3)*(m^2/s^2) = Pa
  ! eng(3) [=]  kg*m^2/s^3 = Watt
  call vert_advection_of_velocity(Time, Adv_vel, Velocity,  &
                                  pme, river, upme, uriver, &
                                  energy_analysis_step=.true.) 
  do n=1,2
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              boxarea   = grd_area(i,j,k)
              uext      = ubar(i,j,n)
              uint      = Velocity%u(i,j,k,n,tau) - uext   
              term      = Velocity%wrkv(i,j,k,n)*boxarea
              engint(3) = engint(3) - uint*term
              engext(3) = engext(3) - uext*term
           enddo
        enddo
     enddo
  enddo

  ! work done by laplacian friction
  ! lap_friction returns thickness weighted and density weighted
  ! friction with dimensions (kg/m^3)*(m^2/s^2) = N/m^2 = Pa
  ! eng(4) [=]  kg*m^2/s^3 = Watt
  call lap_friction(Time, Thickness, Adv_vel, Velocity, energy_analysis_step=.true.)
  do n=1,2
    do k=1,nk
      do j=jsc,jec
        do i=isc,iec
          boxarea   = grd_area(i,j,k)
          uext      = ubar(i,j,n)
          uint      = Velocity%u(i,j,k,n,tau) - uext
          term      = Velocity%wrkv(i,j,k,n)*boxarea    
          engint(4) = engint(4) + uint*term
          engext(4) = engext(4) + uext*term
        enddo
      enddo
    enddo
  enddo

  ! add contribution from lap_friction acting just on the barotropic. 
  ! friction with dimensions (kg/m^3)*(m^2/s^2) = N/m^2 = Pa
  ! eng(4) [=]  kg*m^2/s^3 = Watt
  do n=1,2
     do j=jsc,jec
        do i=isc,iec
           boxarea   = grd_area(i,j,1)
           uext      = ubar(i,j,n)
           term      = Velocity%lap_friction_bt(i,j,n)*boxarea    
           engext(4) = engext(4) + uext*term
        enddo
     enddo
  enddo

  ! work done by biharmonic friction
  ! lap_friction returns thickness weighted and density weighted
  ! friction with dimensions (kg/m^3)*(m^2/s^2) = N/m^2 = Pa
  ! eng(5) [=]  kg*m^2/s^3 = Watt
  call bih_friction(Time, Thickness, Adv_vel, Velocity, energy_analysis_step=.true.)
  do n=1,2
    do k=1,nk
      do j=jsc,jec
        do i=isc,iec
          boxarea   = grd_area(i,j,k)
          uext      = ubar(i,j,n)
          uint      = Velocity%u(i,j,k,n,tau) - uext
          term      = Velocity%wrkv(i,j,k,n)*boxarea    
          engint(5) = engint(5) + uint*term
          engext(5) = engext(5) + uext*term
        enddo
      enddo
    enddo
  enddo

  ! add contribution from bih_friction acting just on the barotropic. 
  ! friction with dimensions (kg/m^3)*(m^2/s^2) = N/m^2 = Pa
  ! eng(5) [=]  kg*m^2/s^3 = Watt
  do n=1,2
     do j=jsc,jec
        do i=isc,iec
           boxarea   = grd_area(i,j,1)
           uext      = ubar(i,j,n)
           term      = Velocity%bih_friction_bt(i,j,n)*boxarea    
           engext(5) = engext(5) + uext*term
        enddo
     enddo
  enddo

  ! work done by vertical friction (contributions from wind and bottom drag removed below)
  ! implicit acceleration has been saved from previous call to ocean_implicit_accel.
  ! Greatbatch form drag implemented through vertical viscosity is part of implict accel. 
  ! vert_frict returns thickness weighted and density weighted vertical friction (kg/m^3)*(m^2/s^2)
  ! eng(6) [=]  kg*m^2/s^3 = Watt
  if(horz_grid == MOM_BGRID) then 
     call vert_friction_bgrid(Time, Thickness, Velocity, visc_cbu, energy_analysis_step=.true.)
  else 
     call vert_friction_bgrid(Time, Thickness, Velocity, visc_cbt, energy_analysis_step=.true.)
  endif 
  do n=1,2
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              boxarea   = grd_area(i,j,k)
              uext      = ubar(i,j,n)
              uint      = Velocity%u(i,j,k,n,tau) - uext  
              term      = (Velocity%wrkv(i,j,k,n)+ Velocity%vfrict_impl(i,j,k,n))*boxarea 
              engint(6) = engint(6) + uint*term
              engext(6) = engext(6) + uext*term
           enddo
        enddo
     enddo
  enddo


  ! work done by wind stress and bottom drag 
  ! smf [=] N/m^2 = Pa 
  ! bmf [=] N/m^2 = Pa 
  ! eng(7) [=] kg*m^2/s^3 = Watt
  do n=1,2

    ! wind stress 
    k = 1
    if(horz_grid == MOM_BGRID) then 
       do j=jsc,jec
          do i=isc,iec
             uext = ubar(i,j,n)
             uint = Velocity%u(i,j,k,n,tau) - uext
             term = grd_area(i,j,k)*Velocity%smf_bgrid(i,j,n)  
             engint(7) = engint(7) + uint*term    
             engext(7) = engext(7) + uext*term
          enddo
       enddo
    else 
       do j=jsc,jec
          do i=isc,iec
             uext = ubar(i,j,n)
             uint = Velocity%u(i,j,k,n,tau) - uext
             term = grd_area(i,j,k)*Velocity%smf_cgrid(i,j,n)  
             engint(7) = engint(7) + uint*term    
             engext(7) = engext(7) + uext*term
          enddo
       enddo
    endif 

    ! bottom stress
    do j=jsc,jec
       do i=isc,iec
          k = Grd%kmu(i,j)
          if (k /= 0) then
             uext = ubar(i,j,n)
             uint = Velocity%u(i,j,k,n,tau) - uext    
             term = grd_area(i,j,k)*Velocity%bmf(i,j,n)
             engint(8) = engint(8) - uint*term    
             engext(8) = engext(8) - uext*term
          endif
       enddo
    enddo

  enddo  ! n=1,2

  ! subtract wind stress and bottom stress contributions
  ! from vertical friction to facilitate diagnostics 
   engint(6) = engint(6) - engint(7) - engint(8) 
   engext(6) = engext(6) - engext(7) - engext(8) 


  ! work due to Coriolis force (zero on B_grid only when acor=0.0)
  ! coriolis returns thickness weighted and density weighted Coriolis force (kg/m^3)*(m^2/s^2) 
  ! eng(9) [=]  kg*m^2/s^3 = Watt
  if(horz_grid == MOM_BGRID) then 
     call coriolis_force_bgrid(Time, Thickness, Velocity, energy_analysis_step=.true.)
  else 
     call coriolis_force_cgrid(Time, Adv_vel, Velocity, abtau_m0, abtau_m1, abtau_m2, &
                               energy_analysis_step=.true.)
  endif 
  do n=1,2
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              boxarea   = grd_area(i,j,k)
              uext      = ubar(i,j,n)
              uint      = Velocity%u(i,j,k,n,tau) - uext  
              term      = Velocity%wrkv(i,j,k,n)*boxarea 
              engint(9) = engint(9) + uint*term   
              engext(9) = engext(9) + uext*term   
           enddo
        enddo
     enddo
  enddo

  ! power (Watt) from surface water fluxes entering (+power) or leaving (-power) ocean 
  if(horz_grid == MOM_BGRID) then 
     pme_u(:,:)   = REMAP_BT_TO_BU(pme)
     river_u(:,:) = REMAP_BT_TO_BU(river)
  else 
     pme_u(:,:)   = pme(:,:)
     river_u(:,:) = river(:,:)
  endif 
  k = 1
  do n=1,2
     do j=jsc,jec
        do i=isc,iec
           boxarea    = grd_area(i,j,k)
           vel        = Velocity%u(i,j,k,n,tau)
           uext       = ubar(i,j,n)
           uint       = vel - uext   
           term       = pme_u(i,j)*upme(i,j,n) + river_u(i,j)*uriver(i,j,n)
           term       = term*boxarea 
           engint(10) = engint(10) + uint*term
           engext(10) = engext(10) + uext*term
        enddo
     enddo
  enddo

  ! contribution (Watt) to kinetic energy conversion from surface water fluxes 
  k = 1
  do n=1,2
     do j=jsc,jec
        do i=isc,iec
           boxarea    = grd_area(i,j,k)
           vel        = Velocity%u(i,j,k,n,tau)
           uext       = ubar(i,j,n)
           uint       = vel - uext   
           term       = pme_u(i,j)*upme(i,j,n)+river_u(i,j)*uriver(i,j,n)
           term       = 0.5*term*boxarea 
           engint(11) = engint(11) + uint*term
           engext(11) = engext(11) + uext*term
        enddo
     enddo
  enddo

  ! contribution (Watt) to kinetic energy from momentum sources 
  call momentum_source(Time, Thickness, Velocity, energy_analysis_step=.true.)
  do n=1,2
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              boxarea    = grd_area(i,j,k)
              uext       = ubar(i,j,n)
              uint       = Velocity%u(i,j,k,n,tau) - uext
              term       = Velocity%wrkv(i,j,k,n)*boxarea    
              engint(12) = engint(12) + uint*term
              engext(12) = engext(12) + uext*term
           enddo
        enddo
     enddo
  enddo

  ! contribution (Watt) to kinetic energy from parameterized form drag via Aiki scheme 
  call form_drag_accel(Time, Thickness, Velocity, energy_analysis_step=.true.)
  do n=1,2
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              boxarea    = grd_area(i,j,k)
              uext       = ubar(i,j,n)
              uint       = Velocity%u(i,j,k,n,tau) - uext
              term       = Velocity%wrkv(i,j,k,n)*boxarea    
              engint(13) = engint(13) + uint*term
              engext(13) = engext(13) + uext*term
           enddo
        enddo
     enddo
  enddo

  ! rho_dzu_tendency and mass source are converted from kinetic energy advection.
  ! these terms arise from the ability of the grid cell volume/mass to change due 
  ! to changes in its thickness or through the advent of volume/mass sources.  
  ! note that some of the surface water work is encompassed here, hence the need
  ! to compute engint(11) and engext(11).
  if(horz_grid == MOM_BGRID) then 
     do k=1,nk
        wrk1(:,:,k) = Grd%umask(:,:,k)*REMAP_BT_TO_BU(wrk3(:,:,k))
        do j=jsc,jec
           do i=isc,iec
              boxarea     = grd_area(i,j,k)
              ke_per_mass = 0.5*(Velocity%u(i,j,k,1,tau)*Velocity%u(i,j,k,1,tau)  &
                                +Velocity%u(i,j,k,2,tau)*Velocity%u(i,j,k,2,tau))
              term        = boxarea*ke_per_mass*wrk1(i,j,k)
              compression = compression + term
           enddo
        enddo
     enddo

  else ! Cgrid 

     do k=1,nk
        wrk1(:,:,k) = Grd%tmask(:,:,k)*wrk3(:,:,k)
        do j=jsc,jec
           do i=isc,iec
              boxarea     = grd_area(i,j,k)
              ke_per_mass = 0.5*(Velocity%u(i,j,k,1,tau)*Velocity%u(i,j,k,1,tau)  &
                                +Velocity%u(i,j,k,2,tau)*Velocity%u(i,j,k,2,tau))
              term        = boxarea*ke_per_mass*wrk1(i,j,k)
              compression = compression + term
           enddo
        enddo
     enddo

  endif 

  call mpp_sum(compression)
  call mpp_sum(engint, size(engint(:)))
  call mpp_sum(engext, size(engext(:)))

  enleak = engint(2) + engint(3) - engint(11) + engext(2) + engext(3) - engext(11)- compression

  call kinetic_energy(Time, Thickness, Velocity, ke_tot, .false., .false.)
  call potential_energy(Time, Thickness, Dens, pe_tot, pe_tot_rel, .false., .false.) 

  write(stdoutunit,*) ' '
  write (stdoutunit,'(//60x,a)') &
  ' Globally integrated energy analysis over model time step '
  call write_timestamp(Time%model_time)

  if(acor > 0) then 
    write (stdoutunit,'(1x,/a)') &
    ' ==> Note: acor > 0 means Coriolis force will not conserve energy.'
  endif 
  if(Grd%tripolar) then 
    write (stdoutunit,'(/1x,/a)') &
    ' ==> NOTE: Energy conversion errors are nontrivial when using the tripolar grid. '
  endif 
  write(stdoutunit,'(/,1x,a,e20.12)')  &
   'Potential energy relative to first time (Joules) = ', pe_tot_rel
  write(stdoutunit,'(1x,a,e20.12)')    &
   'Potential energy                        (Joules) = ', pe_tot
  write(stdoutunit,'(1x,a,e20.12)')    &
   'Kinetic energy  (Joules)                         = ', ke_tot
  write (stdoutunit,9100) &
   'Globally integrated U dot momentum eqns (Watt) ', ucell_mass, Grd%ucella(1)
  write (stdoutunit,9101) ' time rate of change    ', engint(1)+engext(1), engint(1), engext(1)
  write (stdoutunit,9101) ' horizontal advection   ', engint(2)+engext(2), engint(2), engext(2)
  write (stdoutunit,9101) ' vertical advection     ', engint(3)+engext(3), engint(3), engext(3)
  write (stdoutunit,9101) ' pressure force         ', press_int+press_ext, press_int, press_ext
  write (stdoutunit,9101) ' laplacian friction     ', engint(4)+engext(4), engint(4), engext(4)
  write (stdoutunit,9101) ' biharmonic friction    ', engint(5)+engext(5), engint(5), engext(5)
  write (stdoutunit,9101) ' vertical friction      ', engint(6)+engext(6), engint(6), engext(6)
  write (stdoutunit,9101) ' work by wind           ', engint(7)+engext(7), engint(7), engext(7)
  write (stdoutunit,9101) ' work by bottom drag    ', engint(8)+engext(8), engint(8), engext(8)
  write (stdoutunit,9101) ' coriolis forces        ', engint(9)+engext(9), engint(9), engext(9)
  write (stdoutunit,9101) ' work by water flux     ', engint(10)+engext(10), engint(10), engext(10)
  write (stdoutunit,9101) ' work by momentum src   ', engint(12)+engext(12), engint(12), engext(12)
  write (stdoutunit,9101) ' work by Aiki drag      ', engint(13)+engext(13), engint(13), engext(13)

  if(horz_grid==MOM_BGRID) then
     write (stdoutunit,9110) press_conv, press_int+press_ext, press_conv_err, compression, enleak
  else
     write (stdoutunit,9111) press_conv, press_int+press_ext, press_conv_err
  endif

9100 format(/1x,a,1x,/,' ocean mass         =',e16.9,' kg',/, ' ocean surface area =',e16.9,&
          ' m^2',//,35x,'total(Watt)             internal(Watt)             external(Watt)')
9101 format(a25,3(3x,es24.17))
9110 format(/ ' power contributed by pressure conversion and mass tendencies           = ',es24.17,&
            /,' power from horizontal pressure force -u dot force(p)                   = ',es24.17,&
            /,' power mismatch between -u dot grad(p) and its conversions              = ',es24.17,&
            /,' power from grid cell mass changes due to compresibility and/or sources = ',es24.17,&
            /,' power mismatch between -u dot grad (v u) and its conversions           = ',es24.17/)
9111 format(/ ' power contributed by pressure conversion and mass tendencies           = ',es24.17,&
            /,' power from horizontal pressure force -u dot force(p)                   = ',es24.17,&
            /,' power mismatch between -u dot grad(p) and its conversions              = ',es24.17)
 

  call mpp_clock_end(id_clock_energy_analysis)

end subroutine energy_analysis
! </SUBROUTINE> NAME="energy_analysis"


!#######################################################################
! <SUBROUTINE NAME="cfl_check1_bgrid">
!
! <DESCRIPTION>
! Perform the first of two CFL checks on horizontal velocity. 
!
! Assume Bgrid here.  Cgrid calculation not affected much
! for purposes of the CFL check.
!
! Vectorized version from Russell.Fiedler@csiro.au computes cfl
! values at a single latitude. The location of the maximum at this
! latitude is calculated via the maxloc() intrinsic. The maximum 
! value for this processor is then updated if necessary.
! 
! </DESCRIPTION>
subroutine cfl_check1_bgrid(Time, Thickness, Velocity)

  type(ocean_time_type),      intent(in) :: Time
  type(ocean_thickness_type), intent(in) :: Thickness
  type(ocean_velocity_type),  intent(in) :: Velocity

  real     :: cflup,cflvp        ! percent of cfl criteria reached by velocity component
  real     :: cflum,cflvm        ! velocity component which comes closest to its cfl criteria
  integer  :: icflu,jcflu,kcflu  ! "i","j","k" coordinate of "cflum"
  integer  :: icflv,jcflv,kcflv  ! "i","j","k" coordinate of "cflvm"
  real     :: dtmax
  real     :: cflup0, cflvp0
  real     :: fudge
  integer  :: i, j, k, tau

  ! work array containing cfl values 
  real , dimension(isc:iec) :: tempcfl

  ! array required for maxloc() intrinsic function
  integer, dimension(1) :: itemp

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(horz_grid == MOM_CGRID) return 

  tau = Time%tau   

  write (stdoutunit,'(/60x,a/)') ' Horizontal CFL summary I:  '
  write (stdoutunit,'(1x,a/)')'Location of largest horizontal CFL.'

  ! to distinguish processors 
  fudge = 1 + 1.e-12*mpp_pe() 

  icflu=isc; jcflu=jsc; kcflu=1; cflup=epsln; cflum=0.0
  icflv=isc; jcflv=jsc; kcflv=1; cflvp=epsln; cflvm=0.0
  dtmax = dtime  

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           tempcfl(i)=abs(Velocity%u(i,j,k,1,tau)*Grd%dxur(i,j))
        enddo
        itemp=maxloc(tempcfl)+isc-1
        if(tempcfl(itemp(1))>cflup) then
            cflup=tempcfl(itemp(1))
            icflu=itemp(1)
            jcflu=j
            kcflu=k
        endif
        do i=isc,iec
           tempcfl(i)=abs(Velocity%u(i,j,k,2,tau)*Grd%dyur(i,j))
        enddo
        itemp=maxloc(tempcfl)+isc-1
        if(tempcfl(itemp(1))>cflvp) then
            cflvp=tempcfl(itemp(1))
            icflv=itemp(1)
            jcflv=j
            kcflv=k
        endif
     enddo
  enddo

  ! multiply by 100.0 to convert to percentages 
  ! multiply by dtmax to convert to dimensionless CFL number 
  ! multipby cflwtp by rho0r for dimensional reasons as well
  cflup  = 100.0*cflup*dtmax
  cflvp  = 100.0*cflvp*dtmax

  cflum  = Velocity%u(icflu,jcflu,kcflu,1,tau)
  cflvm  = Velocity%u(icflv,jcflv,kcflv,2,tau)

  cflup   = cflup*fudge
  cflvp   = cflvp*fudge
  cflup0  = cflup
  cflvp0  = cflvp
  call mpp_max(cflup)
  call mpp_max(cflvp)

  if (cflup == cflup0) then

    write (unit,'(a,g10.3,a,f7.2,a,g10.3,a,i4,a,i4,a,i3,a,a,f12.3,a,f12.3,a,f10.3,a)')&
   ' u (',cflum,' m/s) is ',cflup/fudge,' % of CFL (',abs(100.0*cflum/(cflup/fudge)), &
   ' m/s) at (i,j,k) = (',icflu+Dom%ioff,',',jcflu+Dom%joff,',',kcflu,'),',           &
   ' (lon,lat,thk) = (',Grd%xu(icflu,jcflu),',',Grd%yu(icflu,jcflu),',',              &
   Thickness%depth_zu(icflu,jcflu,kcflu),' m)'

    write (unit,'(a,e12.3,a,e12.3,a,f10.3)')&
    ' where grid is (m) (dxu,dyu,dzu) = (', &
    Grd%dxu(icflu,jcflu),',',Grd%dyu(icflu,jcflu),',',Thickness%dzu(icflu,jcflu,kcflu)

  endif

  if (cflvp == cflvp0) then

    write (unit,'(a,g10.3,a,f7.2,a,g10.3,a,i4,a,i4,a,i3,a,a,f12.3,a,f12.3,a,f10.3,a)') &
    ' v (',cflvm,' m/s) is ',cflvp/fudge,' % of CFL (',abs(100.0*cflvm/(cflvp/fudge)), &
    ' m/s) at (i,j,k) = (',icflv+Dom%ioff,',',jcflv+Dom%joff,',',kcflv,'),',           &
    ' (lon,lat,thk) = (',Grd%xu(icflv,jcflv),',',Grd%yu(icflv,jcflv),',',              &
    Thickness%depth_zu(icflv,jcflv,kcflv),' m)'

    write (unit,'(a,e12.3,a,e12.3,a,f10.3)')          &
   ' where grid is (m) (dxu,dyu,dzu) = (',            &
    Grd%dxu(icflv,jcflv),',',Grd%dyu(icflv,jcflv),',',&
    Thickness%dzu(icflv,jcflv,kcflv)

  endif

end subroutine cfl_check1_bgrid
! </SUBROUTINE> NAME="cfl_check1_bgrid"


!#######################################################################
! <SUBROUTINE NAME="cfl_check1_cgrid">
!
! <DESCRIPTION>
! Perform the first of two CFL checks on horizontal velocity. 
!
! Assume Cgrid here.
!
! Vectorized version from Russell.Fiedler@csiro.au computes cfl
! values at a single latitude. The location of the maximum at this
! latitude is calculated via the maxloc() intrinsic. The maximum 
! value for this processor is then updated if necessary.
! 
! </DESCRIPTION>
subroutine cfl_check1_cgrid(Time, Thickness, Velocity)

  type(ocean_time_type),      intent(in) :: Time
  type(ocean_thickness_type), intent(in) :: Thickness
  type(ocean_velocity_type),  intent(in) :: Velocity

  real     :: cflup,cflvp        ! percent of cfl criteria reached by velocity component
  real     :: cflum,cflvm        ! velocity component which comes closest to its cfl criteria
  integer  :: icflu,jcflu,kcflu  ! "i","j","k" coordinate of "cflum"
  integer  :: icflv,jcflv,kcflv  ! "i","j","k" coordinate of "cflvm"
  real     :: dtmax
  real     :: cflup0, cflvp0
  real     :: fudge
  integer  :: i, j, k, tau

  ! work array containing cfl values 
  real , dimension(isc:iec) :: tempcfl

  ! array required for maxloc() intrinsic function
  integer, dimension(1) :: itemp

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(horz_grid == MOM_BGRID) return 

  tau = Time%tau   

  write (stdoutunit,'(/60x,a/)') ' Horizontal CFL summary I:  '
  write (stdoutunit,'(1x,a/)')'Location of largest horizontal CFL.'

  ! to distinguish processors 
  fudge = 1 + 1.e-12*mpp_pe() 

  icflu=isc; jcflu=jsc; kcflu=1; cflup=epsln; cflum=0.0
  icflv=isc; jcflv=jsc; kcflv=1; cflvp=epsln; cflvm=0.0
  dtmax = dtime  

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           tempcfl(i)=abs(Velocity%u(i,j,k,1,tau)*Grd%dxter(i,j))
        enddo
        itemp=maxloc(tempcfl)+isc-1
        if(tempcfl(itemp(1))>cflup) then
            cflup=tempcfl(itemp(1))
            icflu=itemp(1)
            jcflu=j
            kcflu=k
        endif
        do i=isc,iec
           tempcfl(i)=abs(Velocity%u(i,j,k,2,tau)*Grd%dytnr(i,j))
        enddo
        itemp=maxloc(tempcfl)+isc-1
        if(tempcfl(itemp(1))>cflvp) then
            cflvp=tempcfl(itemp(1))
            icflv=itemp(1)
            jcflv=j
            kcflv=k
        endif
     enddo
  enddo

  ! multiply by 100.0 to convert to percentages 
  ! multiply by dtmax to convert to dimensionless CFL number 
  ! multipby cflwtp by rho0r for dimensional reasons as well
  cflup  = 100.0*cflup*dtmax
  cflvp  = 100.0*cflvp*dtmax

  cflum  = Velocity%u(icflu,jcflu,kcflu,1,tau)
  cflvm  = Velocity%u(icflv,jcflv,kcflv,2,tau)

  cflup   = cflup*fudge
  cflvp   = cflvp*fudge
  cflup0  = cflup
  cflvp0  = cflvp
  call mpp_max(cflup)
  call mpp_max(cflvp)

  if (cflup == cflup0) then

    write (unit,'(a,g10.3,a,f7.2,a,g10.3,a,i4,a,i4,a,i3,a,a,f12.3,a,f12.3,a,f10.3,a)')&
   ' u (',cflum,' m/s) is ',cflup/fudge,' % of CFL (',abs(100.0*cflum/(cflup/fudge)), &
   ' m/s) at (i,j,k) = (',icflu+Dom%ioff,',',jcflu+Dom%joff,',',kcflu,'),',           &
   ' (lon,lat,thk) = (',Grd%xt(icflu,jcflu),',',Grd%yt(icflu,jcflu),',',              &
   Thickness%depth_zt(icflu,jcflu,kcflu),' m)'

    write (unit,'(a,e12.3,a,e12.3,a,f10.3)')&
    ' where grid is (m) (dxt,dyt,dzt) = (', &
    Grd%dxt(icflu,jcflu),',',Grd%dyt(icflu,jcflu),',',Thickness%dzt(icflu,jcflu,kcflu)

  endif

  if (cflvp == cflvp0) then

    write (unit,'(a,g10.3,a,f7.2,a,g10.3,a,i4,a,i4,a,i3,a,a,f12.3,a,f12.3,a,f10.3,a)') &
    ' v (',cflvm,' m/s) is ',cflvp/fudge,' % of CFL (',abs(100.0*cflvm/(cflvp/fudge)), &
    ' m/s) at (i,j,k) = (',icflv+Dom%ioff,',',jcflv+Dom%joff,',',kcflv,'),',           &
    ' (lon,lat,thk) = (',Grd%xt(icflv,jcflv),',',Grd%yt(icflv,jcflv),',',              &
    Thickness%depth_zt(icflv,jcflv,kcflv),' m)'

    write (unit,'(a,e12.3,a,e12.3,a,f10.3)')          &
   ' where grid is (m) (dxu,dyu,dzu) = (',            &
    Grd%dxt(icflv,jcflv),',',Grd%dyt(icflv,jcflv),',',&
    Thickness%dzt(icflv,jcflv,kcflv)

  endif

end subroutine cfl_check1_cgrid
! </SUBROUTINE> NAME="cfl_check1_cgrid"


!#######################################################################
! <SUBROUTINE NAME="cfl_check2_bgrid">
!
! <DESCRIPTION>
! Perform the second of two CFL checks on horizontal velocity.  
!
! Assume Bgrid here. 
!
! Bring the model down if too many large Courant numbers detected.  
! </DESCRIPTION>
subroutine cfl_check2_bgrid(Time, Thickness, Velocity)

 type(ocean_time_type),      intent(in) :: Time
 type(ocean_thickness_type), intent(in) :: Thickness
 type(ocean_velocity_type),  intent(in) :: Velocity

  real :: dtmax, cflu, cflv
  real :: umax, pcflu, vmax, pcflv, scl
  real, dimension(isd:ied,jsd:jed) :: u, v
  integer :: i, j, k
  integer :: is, ie, js, je
  integer :: tau

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if (horz_grid == MOM_CGRID) return 
  tau = Time%tau   

  write (stdoutunit,'(/60x,a/)') ' Horizontal CFL summary II:  '
  write (stdoutunit,'(1x,a,f5.2/)') &
  'Locations (if any) where horizontal Courant number exceeds ', large_cfl_value

  dtmax = dtime  
  do k=1,nk
    u(:,:) = Velocity%u(:,:,k,1,tau)
    v(:,:) = Velocity%u(:,:,k,2,tau)
    do j=jsc,jec
      do i=isc,iec
        cflu  = abs((dtmax/Grd%dxu(i,j))*u(i,j))    
        cflv  = abs((dtmax/Grd%dyu(i,j))*v(i,j))

        if (cflu >= large_cfl_value .or. cflv >= large_cfl_value) then

          write (unit,'(/,a,i4,a1,i3,a,i3,a,f6.3)')      &
           ' Note: CFL horizontal velocity limit exceeded at (i,j,k) = (',&
           i+Dom%ioff, ',',j+Dom%joff,',',k,') by factor =',large_cfl_value 

          umax  = Grd%dxu(i,j)/dtmax            
          pcflu = abs(100.0*u(i,j)/umax)
          vmax  = Grd%dyu(i,j)/dtmax
          pcflv = abs(100.0*v(i,j)/vmax)
          write (unit,'(a,f8.2,a,g15.8,a)') &
          ' u reached   ', pcflu,' % of the local CFL limit (',umax,' m/s)'
          write (unit,'(a,f8.2,a,g15.8,a)') & 
          ' v reached   ', pcflv,' % of the local CFL limit (',vmax,' m/s)'
          write (unit,'(a,e12.3,a,e12.3,a,f10.3)')                         &
          ' where the grid cell has dimensions (metres) (dxu,dyu,dzu) = (',&
          Grd%dxu(i,j),',',Grd%dyu(i,j),',',Thickness%dzu(i,j,k)
        endif 

        if (cflu >= max_cfl_value .or. cflv >= max_cfl_value) then

           write (unit,'(/,a,i4,a1,i3,a,i3,a,f6.3)')     &
           ' Note: CFL horizontal velocity limit exceeded at (i,j,k) = (',&
           i+Dom%ioff, ',',j+Dom%joff,',',k,') by factor =',max_cfl_value 

           write(*,'(/a)') &
           '==>Error in ocean_velocity_diag: max_cfl_value exceeded for horizontal velocity.'
           write(*,'(a)')  &
           '   The model is bringing itself down in order for the user to determine '
           write(*,'(a)')  &
           '   whether the simulation is going to produce Inf or NaN, or whether it '
           write(*,'(a)')  &
           '   will successfully run through the present phase with large Courant numbers.'
           write(*,'(a)')  &
           '   It is often the case that early spin-ups produce very large Courant'
           write(*,'(a)')  &
           '   numbers, with the model later adjusting to stable behaviour with modest'
           write(*,'(a)')  &
           '   Courant numbers. To test if the model will reach stable behaviour,'
           write(*,'(a)')  &
           '   try significally increasing "max_cfl_value" in ocean_velocity_diag_nml.'

          if(verbose_cfl) then 

              write(*,'(/a,f6.3/)')                                                      & 
              ' Information about region where horizontal Courant number is larger than',&
              max_cfl_value
              is = max(isc,i-3)
              ie = min(iec,i+3)
              js = max(jsc,j-3)
              je = min(jec,j+3)
              scl = 0.0
              write (*,9100)'u (m/s)', Time%itt, k, Thickness%depth_zu(is,js,k), &
                   Grd%xu(is,j), Grd%xu(ie,j), Grd%yu(i,js), Grd%yu(i,je), scl
              call matrix (u(is:ie,js:je), is, ie, js, je, scl)

              write (*,9100) 'v (m/s)', Time%itt, k, Thickness%depth_zu(is,js,k), &
                   Grd%xu(is,j), Grd%xu(ie,j), Grd%yu(i,js), Grd%yu(i,je), scl
              call matrix (v(is:ie,js:je), is, ie, js, je, scl)

          endif

          call mpp_error(FATAL,&
          '==>Error in ocean_velocity_diag_mod: max_cfl_value exceeded.')

        endif

      enddo
    enddo
  enddo

9100 format(1x,a12,1x,'ts=',i10,1x,',k=',i3,', z(m)=',f8.1,', lon(deg):',f6.2,' --> ',f6.2,&
            ', lat(deg):',f6.2,' --> ',f6.2,', scaling=',1pg10.3)

end subroutine cfl_check2_bgrid
! </SUBROUTINE> NAME="cfl_check2_bgrid"


!#######################################################################
! <SUBROUTINE NAME="cfl_check2_cgrid">
!
! <DESCRIPTION>
! Perform the second of two CFL checks on horizontal velocity.  
!
! Assume Cgrid here. 
!
! Bring the model down if too many large Courant numbers detected.  
! </DESCRIPTION>
subroutine cfl_check2_cgrid(Time, Thickness, Velocity)

 type(ocean_time_type),      intent(in) :: Time
 type(ocean_thickness_type), intent(in) :: Thickness
 type(ocean_velocity_type),  intent(in) :: Velocity

  real :: dtmax, cflu, cflv
  real :: umax, pcflu, vmax, pcflv, scl
  real, dimension(isd:ied,jsd:jed) :: u, v
  integer :: i, j, k
  integer :: is, ie, js, je
  integer :: tau

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if (horz_grid == MOM_BGRID) return 
  tau = Time%tau   

  write (stdoutunit,'(/60x,a/)') ' Horizontal CFL summary II:  '
  write (stdoutunit,'(1x,a,f5.2/)') &
  'Locations (if any) where horizontal Courant number exceeds ', large_cfl_value

  dtmax = dtime  
  do k=1,nk
    u(:,:) = Velocity%u(:,:,k,1,tau)
    v(:,:) = Velocity%u(:,:,k,2,tau)
    do j=jsc,jec
      do i=isc,iec
        cflu  = abs((dtmax*Grd%dxter(i,j))*u(i,j))    
        cflv  = abs((dtmax*Grd%dytnr(i,j))*v(i,j))

        if (cflu >= large_cfl_value .or. cflv >= large_cfl_value) then

          write (unit,'(/,a,i4,a1,i3,a,i3,a,f6.3)')      &
           ' Note: CFL horizontal velocity limit exceeded at (i,j,k) = (',&
           i+Dom%ioff, ',',j+Dom%joff,',',k,') by factor =',large_cfl_value 

          umax  = Grd%dxt(i,j)/dtmax            
          pcflu = abs(100.0*u(i,j)/umax)
          vmax  = Grd%dyt(i,j)/dtmax
          pcflv = abs(100.0*v(i,j)/vmax)
          write (unit,'(a,f8.2,a,g15.8,a)') &
          ' u reached   ', pcflu,' % of the local CFL limit (',umax,' m/s)'
          write (unit,'(a,f8.2,a,g15.8,a)') & 
          ' v reached   ', pcflv,' % of the local CFL limit (',vmax,' m/s)'
          write (unit,'(a,e12.3,a,e12.3,a,f10.3)')                         &
          ' where the grid cell has dimensions (metres) (dxt,dyt,dzt) = (',&
          Grd%dxt(i,j),',',Grd%dyt(i,j),',',Thickness%dzt(i,j,k)
        endif 

        if (cflu >= max_cfl_value .or. cflv >= max_cfl_value) then

           write (unit,'(/,a,i4,a1,i3,a,i3,a,f6.3)')     &
           ' Note: CFL horizontal velocity limit exceeded at (i,j,k) = (',&
           i+Dom%ioff, ',',j+Dom%joff,',',k,') by factor =',max_cfl_value 

           write(*,'(/a)') &
           '==>Error in ocean_velocity_diag: max_cfl_value exceeded for horizontal velocity.'
           write(*,'(a)')  &
           '   The model is bringing itself down in order for the user to determine '
           write(*,'(a)')  &
           '   whether the simulation is going to produce Inf or NaN, or whether it '
           write(*,'(a)')  &
           '   will successfully run through the present phase with large Courant numbers.'
           write(*,'(a)')  &
           '   It is often the case that early spin-ups produce very large Courant'
           write(*,'(a)')  &
           '   numbers, with the model later adjusting to stable behaviour with modest'
           write(*,'(a)')  &
           '   Courant numbers. To test if the model will reach stable behaviour,'
           write(*,'(a)')  &
           '   try significally increasing "max_cfl_value" in ocean_velocity_diag_nml.'

          if(verbose_cfl) then 

              write(*,'(/a,f6.3/)')                                                      & 
              ' Information about region where horizontal Courant number is larger than',&
              max_cfl_value
              is = max(isc,i-3)
              ie = min(iec,i+3)
              js = max(jsc,j-3)
              je = min(jec,j+3)
              scl = 0.0
              write (*,9100)'u (m/s)', Time%itt, k, Thickness%depth_zt(is,js,k), &
                   Grd%xt(is,j), Grd%xt(ie,j), Grd%yt(i,js), Grd%yt(i,je), scl
              call matrix (u(is:ie,js:je), is, ie, js, je, scl)

              write (*,9100) 'v (m/s)', Time%itt, k, Thickness%depth_zt(is,js,k), &
                   Grd%xt(is,j), Grd%xt(ie,j), Grd%yt(i,js), Grd%yt(i,je), scl
              call matrix (v(is:ie,js:je), is, ie, js, je, scl)

          endif

          call mpp_error(FATAL,&
          '==>Error in ocean_velocity_diag_mod: max_cfl_value exceeded.')

        endif

      enddo
    enddo
  enddo

9100 format(1x,a12,1x,'ts=',i10,1x,',k=',i3,', z(m)=',f8.1,', lon(deg):',f6.2,' --> ',f6.2,&
            ', lat(deg):',f6.2,' --> ',f6.2,', scaling=',1pg10.3)


end subroutine cfl_check2_cgrid
! </SUBROUTINE> NAME="cfl_check2_cgrid"


!#######################################################################
! <SUBROUTINE NAME="stokes_coriolis_force">
!
! <DESCRIPTION>
!
! Diagnostic to compute thickness weighted and density
! weighted acceleration from the Stokes coriolis force, where the
! Stokes drift arises from surface ocean waves.  To obtain the
! Stokes drift requires coupling MOM to a surface wave model.
!
! Note: for a hydrostatic model, we should NOT
! include the Stokes-Coriolis force as part of the
! model prognostic equations. It is computed here only
! for diagnostic purposes.
!
! Assume stokes_drift is on U-grid point
! (Stephen.Griffies: to be revisited when couple to wave model).
!
! </DESCRIPTION>
!
subroutine stokes_coriolis_force(Time, Thickness, Velocity)

  type(ocean_time_type),       intent(in)    :: Time
  type(ocean_thickness_type),  intent(in)    :: Thickness
  type(ocean_velocity_type),   intent(inout) :: Velocity

  integer :: i, j, k
  integer :: tau
  tau = Time%tau
  wrk1_v(:,:,:,:) = 0.0

  if(id_stokes_force_x > 0 .or. id_stokes_force_y > 0) then
     if(horz_grid == MOM_BGRID) then
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 wrk1_v(i,j,k,1) =  Grd%f(i,j)*Velocity%stokes_drift(i,j,k,2)*Thickness%rho_dzu(i,j,k,tau)
                 wrk1_v(i,j,k,2) = -Grd%f(i,j)*Velocity%stokes_drift(i,j,k,1)*Thickness%rho_dzu(i,j,k,tau)
              enddo
           enddo
        enddo
     else   ! Cgrid
        call mpp_update_domains(Velocity%stokes_drift(:,:,:,1),Velocity%stokes_drift(:,:,:,2),Dom%domain2d,gridtype=BGRID_NE)
        do k=1,nk
           do j=jsc,jec
              do i=isc,iec
                 wrk1_v(i,j,k,1) =  onehalf &
                       *( Grd%f(i,j)*Velocity%stokes_drift(i,j,k,2)*Thickness%rho_dzu(i,j,k,tau) &
                         +Grd%f(i,j-1)*Velocity%stokes_drift(i,j-1,k,2)*Thickness%rho_dzu(i,j-1,k,tau))
                 wrk1_v(i,j,k,2) =  -onehalf &
                       *( Grd%f(i,j)*Velocity%stokes_drift(i,j,k,1)*Thickness%rho_dzu(i,j,k,tau) &
                         +Grd%f(i-1,j)*Velocity%stokes_drift(i-1,j,k,1)*Thickness%rho_dzu(i-1,j,k,tau))
              enddo
           enddo
        enddo
     endif
  endif

  call diagnose_3d_en(Time, Grd, id_stokes_force_x, id_stokes_force_y, wrk1_v(:,:,:,:))

end subroutine stokes_coriolis_force
! </SUBROUTINE> NAME="stokes_coriolis_force"


end module ocean_velocity_diag_mod

module atmos_sulfate_mod
! <DESCRIPTION>
!   This module is an implementation of sulfate chemistry. It contains
!   tracer emissions and chemistry. The chemistry is partly based on MOZART.
!   The change of concentration of SO2, DMS, SO4, MSA and H2O2 are
!   calculated using monthly mean concentration of OH, HO2, jH2O2, NO3, O3,
!   pH. The emissions include:
!     - DMS from seawater
!     - SO2 by fossil fuel, biomass burning, non-eruptive volcanoes and aircraft
!     - SO4 by fossil fuel
! </DESCRIPTION>
! <WARNING>
!  To save space only the actual month of input files are kept in memory.
!  This implies that the "atmos_sulfate_init" should be executed at the begining
!  of each month. In other words, the script should not run more than 1 month
!  without a restart.
! </WARNING>
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   Paul Ginoux
! </CONTACT>
!-----------------------------------------------------------------------

use mpp_mod, only: input_nml_file 
use                    fms_mod, only : file_exist,              &
                                       write_version_number,    &
                                       mpp_pe,                  &
                                       mpp_root_pE,             &
                                       close_file,              &
                                       stdlog,                  &
                                       check_nml_error, error_mesg, &
                                       open_namelist_file, FATAL, NOTE, WARNING

use           time_manager_mod, only : time_type, &
                                       days_in_month, days_in_year, &
                                       set_date, set_time, get_date_julian, &
                                       print_date, get_date, &
                                       operator(>), operator(+), operator(-)
use time_interp_mod,            only:  fraction_of_year, &
                                       time_interp_init
use           diag_manager_mod, only : send_data,               &
                                       register_diag_field,     &
                                       register_static_field,   &
                                       diag_manager_init, get_base_time
use         tracer_manager_mod, only : get_tracer_index,        &
                                       set_tracer_atts
use          field_manager_mod, only : MODEL_ATMOS
use           interpolator_mod, only:  interpolate_type, interpolator_init, &
                                      obtain_interpolator_time_slices, &
                                      unset_interpolator_time_flag, &
                                       interpolator, interpolator_end,     &
                                       CONSTANT, INTERP_WEIGHTED_P
use              constants_mod, only : PI, GRAV, RDGAS, WTMAIR

implicit none

private
!-----------------------------------------------------------------------
!----- interfaces -------
!
public  atmos_sulfate_init, atmos_sulfate_end, &
        atmos_sulfate_time_vary, atmos_sulfate_endts, &
        atmos_DMS_emission, atmos_SOx_emission, atmos_SOx_chem

!-----------------------------------------------------------------------
!----------- namelist -------------------
!-----------------------------------------------------------------------

!--- Arrays to help calculate tracer sources/sinks ---

character(len=6), parameter :: module_name = 'tracer'

integer :: nSO4 = 0  ! tracer number for Sulfate               = SO4=
integer :: nDMS = 0  ! tracer number for Dimethyl sulfide      = CH3SCH3
integer :: nSO2 = 0  ! tracer number for Sulfur dioxide        = SO2
integer :: nMSA = 0  ! tracer number for Methane sulfonic acid = CH3SO3H
integer :: nH2O2= 0  ! tracer number for Hydrogen peroxyde     = H2O2

real , parameter :: WTM_S     = 32.0
real , parameter :: WTM_O3    = 48.0
real , parameter :: WTM_SO2   = 64.0
real , parameter :: WTM_SO4   = 96.0
real , parameter :: WTM_NH4_2SO4   = 132.00
real , parameter :: WTM_DMS   = 62.0
real , parameter :: WTM_MSA   = 96.0

!--- identification numbers for  diagnostic fields and axes ----
integer ::   id_OH                  = 0
integer ::   id_HO2                 = 0
integer ::   id_NO3                 = 0
integer ::   id_jH2O2               = 0
integer ::   id_O3                  = 0
integer ::   id_pH                  = 0

integer ::   id_DMSo                = 0
integer ::   id_DMS_emis            = 0
integer ::   id_DMS_emis_cmip       = 0
integer ::   id_SO2_emis            = 0
integer ::   id_SO4_emis            = 0
integer ::   id_DMS_chem            = 0
integer ::   id_SO2_chem            = 0
integer ::   id_SO4_chem            = 0
integer ::   id_SO4_oh_prod         = 0
integer ::   id_SO4_o3_prod         = 0
integer ::   id_SO4_h2o2_prod       = 0
integer ::   id_MSA_chem            = 0
integer ::   id_H2O2_chem           = 0
integer ::   id_so2_aircraft        = 0
integer ::   id_so2_cont_volc       = 0
integer ::   id_so2_expl_volc       = 0
integer ::   id_so2_biobur          = 0
integer ::   id_so2_ship            = 0
integer ::   id_so2_road            = 0
integer ::   id_so2_domestic        = 0
integer ::   id_so2_industry        = 0
integer ::   id_so2_power           = 0
integer ::   id_so2_off_road        = 0
integer ::   id_so2_ff              = 0

type(interpolate_type),save         ::  gas_conc_interp
type(interpolate_type),save         ::  aerocom_emission_interp
type(interpolate_type),save         ::  gocart_emission_interp
type(interpolate_type),save         ::  anthro_emission_interp
type(interpolate_type),save         ::  biobur_emission_interp
type(interpolate_type),save         ::  ship_emission_interp
type(interpolate_type),save         ::  aircraft_emission_interp
! type(interpolate_type),save         ::  cont_volc_emission_interp
! type(interpolate_type),save         ::  expl_volc_emission_interp
! Initial calendar time for model
type(time_type) :: model_init_time
type(time_type), save :: gas_conc_offset
type(time_type), save :: anthro_offset
type(time_type), save :: biobur_offset
type(time_type), save :: ship_offset
type(time_type), save :: aircraft_offset
! type(time_type), save :: cont_volc_offset
! type(time_type), save :: expl_volc_offset

type(time_type), save :: gas_conc_entry
type(time_type), save :: anthro_entry
type(time_type), save :: biobur_entry
type(time_type), save :: ship_entry
type(time_type), save :: aircraft_entry
! type(time_type), save :: cont_volc_entry
! type(time_type), save :: expl_volc_entry

logical, save    :: gas_conc_negative_offset
logical, save    :: anthro_negative_offset
logical, save    :: biobur_negative_offset
logical, save    :: ship_negative_offset
logical, save    :: aircraft_negative_offset
! logical, save    :: cont_volc_negative_offset
! logical, save    :: expl_volc_negative_offset

integer, save    :: gas_conc_time_serie_type
integer, save    :: anthro_time_serie_type
integer, save    :: biobur_time_serie_type
integer, save    :: ship_time_serie_type
integer, save    :: aircraft_time_serie_type
! integer, save    :: cont_volc_time_serie_type
! integer, save    :: expl_volc_time_serie_type

real             :: critical_sea_fraction = 0.5 ! DMS flux from sea occurs
                                ! in grid cells with ocn_flx_fraction .gt.
                                !  this value
                             
character(len=80)  :: runtype = 'default'

character(len=80)  :: gocart_emission_filename = 'gocart_emission.nc'
character(len=80), dimension(6) :: gocart_emission_name
data gocart_emission_name/'DMSo','SO2_GEIA1','SO2_GEIA2', &
                       'SO4_GEIA1','SO4_GEIA2','SO2_biobur'/

integer, parameter :: num_volc_levels = 12
character(len=80)  :: cont_volc_source = ' '
character(len=80)  :: expl_volc_source = ' '
real :: volc_altitude_edges(num_volc_levels+1) = 1.e3 * (/ &
  0.,0.1,0.2,0.5,1.,2.,3.,4.,5.,6.,7.,8.,20. /) ! m

character(len=80)  :: aerocom_emission_filename = 'aerocom_emission.nc'
integer, parameter :: std_aerocom_emission=18, &
                      max_aerocom_emission=std_aerocom_emission+2*num_volc_levels
character(len=80), dimension(max_aerocom_emission)  :: aerocom_emission_name = (/ &
         'SO2_RoadTransport         ', 'SO2_Off-road              ', &
         'SO2_Domestic              ', 'SO2_Industry              ', &
         'SO2_International_Shipping', 'SO2_Powerplants           ', &
         'SO2_cont_volc             ', 'alt_cont_volc_low         ', &
         'alt_cont_volc_high        ', 'SO2_expl_volc             ', &
         'alt_expl_volc_low         ', 'alt_expl_volc_high        ', &
         'GFED_SO2_l1               ', 'GFED_SO2_l2               ', &
         'GFED_SO2_l3               ', 'GFED_SO2_l4               ', &
         'GFED_SO2_l5               ', 'GFED_SO2_l6               ', &
         'SO2_cont_volc_l01         ', 'SO2_cont_volc_l02         ', &
         'SO2_cont_volc_l03         ', 'SO2_cont_volc_l04         ', &
         'SO2_cont_volc_l05         ', 'SO2_cont_volc_l06         ', &
         'SO2_cont_volc_l07         ', 'SO2_cont_volc_l08         ', &
         'SO2_cont_volc_l09         ', 'SO2_cont_volc_l10         ', &
         'SO2_cont_volc_l11         ', 'SO2_cont_volc_l12         ', &
         'SO2_expl_volc_l01         ', 'SO2_expl_volc_l02         ', &
         'SO2_expl_volc_l03         ', 'SO2_expl_volc_l04         ', &
         'SO2_expl_volc_l05         ', 'SO2_expl_volc_l06         ', &
         'SO2_expl_volc_l07         ', 'SO2_expl_volc_l08         ', &
         'SO2_expl_volc_l09         ', 'SO2_expl_volc_l10         ', &
         'SO2_expl_volc_l11         ', 'SO2_expl_volc_l12         '/)

character(len=80)  :: gas_conc_source   = ' '
character(len=80)  :: gas_conc_filename = 'gas_conc_3D.nc'
character(len=80), dimension(6) :: gas_conc_name
data gas_conc_name/'OH','HO2','NO3','O3','jH2O2','pH'/
character(len=80)     :: gas_conc_time_dependency_type
integer, dimension(6) :: gas_conc_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)

character(len=80)  :: anthro_source   = ' '
character(len=80)  :: anthro_filename = 'aero_anthro_emission_1979_2006.nc'
character(len=80), dimension(2) :: anthro_emission_name
data anthro_emission_name/'so2_anthro','so4_anthro'/
character(len=80)     :: anthro_time_dependency_type
integer, dimension(6) :: anthro_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)

character(len=80)  :: biobur_source   = ' '
character(len=80)  :: biobur_filename = 'aero_biobur_emission_1979_2006.nc'
character(len=80), dimension(2) :: biobur_emission_name
data biobur_emission_name/'so2_biobur','so4_biobur'/
character(len=80)     :: biobur_time_dependency_type
integer, dimension(6) :: biobur_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)

character(len=80)  :: ship_source   = ' '
character(len=80)  :: ship_filename = 'aero_ship_emission_1979_2006.nc'
character(len=80), dimension(2) :: ship_emission_name
data ship_emission_name/'so2_ship','so4_ship'/
character(len=80)     :: ship_time_dependency_type
integer, dimension(6) :: ship_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)

character(len=80)  :: aircraft_source = ' '
character(len=80)  :: aircraft_filename = 'aircraft_emission.nc'
character(len=80)  :: aircraft_emission_name(1)
data aircraft_emission_name/'fuel'/
character(len=80)     :: aircraft_time_dependency_type
integer, dimension(6) :: aircraft_dataset_entry  = (/ 1, 1, 1, 0, 0, 0 /)
real :: so2_aircraft_EI = 1.e-3  ! kg of SO2/kg of fuel

namelist /simple_sulfate_nml/  &
       critical_sea_fraction,     &
      runtype,                         &
      aerocom_emission_filename, aerocom_emission_name,  &
      gocart_emission_filename, gocart_emission_name,  &
      gas_conc_source, gas_conc_name, gas_conc_filename,        &
        gas_conc_time_dependency_type, gas_conc_dataset_entry, &
      anthro_source, anthro_emission_name, anthro_filename,        &
        anthro_time_dependency_type, anthro_dataset_entry, &
      biobur_source, biobur_emission_name, biobur_filename,        &
        biobur_time_dependency_type, biobur_dataset_entry, &
      ship_source, ship_emission_name, ship_filename,        &
        ship_time_dependency_type, ship_dataset_entry, &
      aircraft_source, aircraft_emission_name, aircraft_filename, &
        aircraft_time_dependency_type, aircraft_dataset_entry, so2_aircraft_EI,&
      cont_volc_source, expl_volc_source

type(time_type) :: anthro_time, biobur_time, ship_time, aircraft_time
type(time_type)        :: gas_conc_time

!trim(runtype) 
!biomass_only; fossil_fuels_only, natural_only, anthrop

logical :: module_is_initialized=.FALSE.
logical :: used

!---- version number -----
character(len=128) :: version = '$Id: atmos_sulfate.F90,v 20.0 2013/12/13 23:24:05 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
!-----------------------------------------------------------------------

contains


!#######################################################################

!<SUBROUTINE NAME="atmos_sulfate_init">
!<OVERVIEW>
! The constructor routine for the sulfate module.
!</OVERVIEW>
!<DESCRIPTION>
! A routine to initialize the sulfate module.
!</DESCRIPTION>
 subroutine atmos_sulfate_init ( lonb, latb, nlev, axes, Time, mask)

!-----------------------------------------------------------------------
real, intent(in),    dimension(:,:)                 :: lonb, latb
integer, intent(in)                                 :: nlev
type(time_type),  intent(in)                        :: Time
integer,          intent(in)                        :: axes(4)
real, intent(in), dimension(:,:,:), optional        :: mask
character(len=7), parameter :: mod_name = 'tracers'
integer :: n, m, nsulfate
!
!----------------------------------------------------------------------
!  local variables:

      integer   ::   ierr

!---------------------------------------------------------------------
!    local variables:
!
!         unit       io unit number used to read namelist file
!         ierr       error code
!         io         error status returned from io operation
!         n          do-loop index
!
!---------------------------------------------------------------------

!-----------------------------------------------------------------------
!
      integer  unit,io, logunit
      character(len=12) :: SOx_tracer(5)
!
!     1. DMS       = Dimethyl sulfide            = CH3SCH3
!     2. SO2       = Sulfur dioxide              = SO2     
!     3. SO4       = Sulfate                     = SO4=   
!     4. MSA       = Methane sulfonic acid       = CH3SO3H
!     5. H2O2      = Hydrogen peroxyde           = H2O2
!                                                                      
      data SOx_tracer/'simpleDMS', &
                      'simpleSO2', &
                      'simpleSO4', &
                      'simpleMSA', &
                      'simpleH2O2' /
      
      if (module_is_initialized) return


!---- write namelist ------------------

      call write_version_number(version, tagname)

!    read namelist.
!-----------------------------------------------------------------------
      if ( file_exist('input.nml')) then
#ifdef INTERNAL_FILE_NML
        read (input_nml_file, nml=simple_sulfate_nml, iostat=io)
        ierr = check_nml_error(io,'simple_sulfate_nml')
#else
        unit =  open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=simple_sulfate_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'simple_sulfate_nml')
        end do
10      call close_file (unit)
#endif
      endif

!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit=stdlog()
      if (mpp_pe() == mpp_root_pe() ) &
                          write (logunit, nml=simple_sulfate_nml)


!----- set initial value of sulfate ------------

     do m=1,size(SOx_tracer)

       n = get_tracer_index(MODEL_ATMOS,SOx_tracer(m))
       if (n>0) then
         nsulfate=n
        call set_tracer_atts(MODEL_ATMOS,SOx_tracer(m),SOx_tracer(m),'vmr')
         if (nsulfate > 0 .and. mpp_pe() == mpp_root_pe()) &
                 write (logunit,30) SOx_tracer(m),nsulfate
       endif
     enddo


  30   format (A,' was initialized as tracer number ',i2)

!----------------------------------------------------------------------
!    initialize namelist entries
!----------------------------------------------------------------------
        gas_conc_offset = set_time (0,0)
        anthro_offset   = set_time (0,0)
        biobur_offset   = set_time (0,0)
        ship_offset     = set_time (0,0)
        aircraft_offset = set_time (0,0)

        gas_conc_entry  = set_time (0,0)
        anthro_entry    = set_time (0,0)
        biobur_entry    = set_time (0,0)
        ship_entry      = set_time (0,0)
        aircraft_entry  = set_time (0,0)

        gas_conc_negative_offset = .false.
        anthro_negative_offset   = .false.
        biobur_negative_offset   = .false.
        ship_negative_offset     = .false.
        aircraft_negative_offset = .false.

        gas_conc_time_serie_type = 1
        anthro_time_serie_type   = 1
        biobur_time_serie_type   = 1
        ship_time_serie_type     = 1
        aircraft_time_serie_type = 1
!----------------------------------------------------------------------
!    define the model base time  (defined in diag_table)
!----------------------------------------------------------------------
        model_init_time = get_base_time()
       call interpolator_init (aerocom_emission_interp, &
                             trim(aerocom_emission_filename),  &
                             lonb, latb,&
                             data_out_of_bounds=  (/CONSTANT/), &
                             data_names = aerocom_emission_name, &
                             vert_interp=(/INTERP_WEIGHTED_P/) )
       call interpolator_init (gocart_emission_interp, &
                             trim(gocart_emission_filename),  &
                             lonb, latb,&
                             data_out_of_bounds=  (/CONSTANT/), &
                             data_names = gocart_emission_name, &
                             vert_interp=(/INTERP_WEIGHTED_P/) )
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(gas_conc_time_dependency_type) == 'constant' ) then
        gas_conc_time_serie_type = 1
        gas_conc_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'gas_conc are constant in sulfate module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for gas_conc is selected.
!---------------------------------------------------------------------
      else if (trim(gas_conc_time_dependency_type) == 'time_varying') then
        gas_conc_time_serie_type = 3
        if (gas_conc_dataset_entry(1) == 1 .and. &
            gas_conc_dataset_entry(2) == 1 .and. &
            gas_conc_dataset_entry(3) == 1 .and. &
            gas_conc_dataset_entry(4) == 0 .and. &
            gas_conc_dataset_entry(5) == 0 .and. &
            gas_conc_dataset_entry(6) == 0 ) then
          gas_conc_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to gas_conc_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          gas_conc_entry  = set_date (gas_conc_dataset_entry(1), &
                                  gas_conc_dataset_entry(2), &
                                  gas_conc_dataset_entry(3), &
                                  gas_conc_dataset_entry(4), &
                                  gas_conc_dataset_entry(5), &
                                  gas_conc_dataset_entry(6))
        endif
        call print_date (gas_conc_entry , str= &
          'Data from gas_conc timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        gas_conc_offset = gas_conc_entry - model_init_time
        if (model_init_time > gas_conc_entry) then
          gas_conc_negative_offset = .true.
        else
          gas_conc_negative_offset = .false.
        endif
      else if (trim(gas_conc_time_dependency_type) == 'fixed_year') then
        gas_conc_time_serie_type = 2
        if (gas_conc_dataset_entry(1) == 1 .and. &
            gas_conc_dataset_entry(2) == 1 .and. &
            gas_conc_dataset_entry(3) == 1 .and. &
            gas_conc_dataset_entry(4) == 0 .and. &
            gas_conc_dataset_entry(5) == 0 .and. &
            gas_conc_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_sulfate_mod', &
            'must set gas_conc_dataset_entry when using fixed_year source', FATAL)
        endif

!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to gas_conc_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        gas_conc_entry  = set_date (gas_conc_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_sulfate_mod', &
           'gas_conc is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'gas_conc correspond to year :', &
                    gas_conc_dataset_entry(1)
        endif
     endif
     call interpolator_init (gas_conc_interp, trim(gas_conc_filename),  &
                             lonb, latb,&
                             data_out_of_bounds=  (/CONSTANT/), &
                             data_names = gas_conc_name, &
                             vert_interp=(/INTERP_WEIGHTED_P/) )
      if (trim(anthro_source) .eq. 'do_anthro') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(anthro_time_dependency_type) == 'constant' ) then
        anthro_time_serie_type = 1
        anthro_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'anthro are constant in sulfate module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for anthro is selected.
!---------------------------------------------------------------------
      else if (trim(anthro_time_dependency_type) == 'time_varying') then
        anthro_time_serie_type = 3
        if (anthro_dataset_entry(1) == 1 .and. &
            anthro_dataset_entry(2) == 1 .and. &
            anthro_dataset_entry(3) == 1 .and. &
            anthro_dataset_entry(4) == 0 .and. &
            anthro_dataset_entry(5) == 0 .and. &
            anthro_dataset_entry(6) == 0 ) then
          anthro_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to anthro_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          anthro_entry  = set_date (anthro_dataset_entry(1), &
                                  anthro_dataset_entry(2), &
                                  anthro_dataset_entry(3), &
                                  anthro_dataset_entry(4), &
                                  anthro_dataset_entry(5), &
                                  anthro_dataset_entry(6))
        endif
        call print_date (anthro_entry , str= &
          'Data from anthro timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        anthro_offset = anthro_entry - model_init_time
        if (model_init_time > anthro_entry) then
          anthro_negative_offset = .true.
        else
          anthro_negative_offset = .false.
        endif
      else if (trim(anthro_time_dependency_type) == 'fixed_year') then
        anthro_time_serie_type = 2
        if (anthro_dataset_entry(1) == 1 .and. &
            anthro_dataset_entry(2) == 1 .and. &
            anthro_dataset_entry(3) == 1 .and. &
            anthro_dataset_entry(4) == 0 .and. &
            anthro_dataset_entry(5) == 0 .and. &
            anthro_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_sulfate_mod', &
            'must set anthro_dataset_entry when using fixed_year source', FATAL)
        endif

!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to anthro_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        anthro_entry  = set_date (anthro_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_sulfate_mod', &
           'anthro is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'anthro correspond to year :', &
                    anthro_dataset_entry(1)
        endif
     endif
     call interpolator_init (anthro_emission_interp,             &
                             trim(anthro_filename),           &
                             lonb, latb,                        &
                             data_out_of_bounds=  (/CONSTANT/), &
                             data_names = anthro_emission_name,        &
                             vert_interp=(/INTERP_WEIGHTED_P/)  )
     endif ! end do_anthro

    if (trim(biobur_source) .eq. 'do_biobur') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(biobur_time_dependency_type) == 'constant' ) then
        biobur_time_serie_type = 1
        biobur_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'biobur are constant in sulfate module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for biobur is selected.
!---------------------------------------------------------------------
      else if (trim(biobur_time_dependency_type) == 'time_varying') then
        biobur_time_serie_type = 3
        if (biobur_dataset_entry(1) == 1 .and. &
            biobur_dataset_entry(2) == 1 .and. &
            biobur_dataset_entry(3) == 1 .and. &
            biobur_dataset_entry(4) == 0 .and. &
            biobur_dataset_entry(5) == 0 .and. &
            biobur_dataset_entry(6) == 0 ) then
          biobur_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to biobur_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          biobur_entry  = set_date (biobur_dataset_entry(1), &
                                  biobur_dataset_entry(2), &
                                  biobur_dataset_entry(3), &
                                  biobur_dataset_entry(4), &
                                  biobur_dataset_entry(5), &
                                  biobur_dataset_entry(6))
        endif
        call print_date (biobur_entry , str= &
          'Data from biobur timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        biobur_offset = biobur_entry - model_init_time
        if (model_init_time > biobur_entry) then
          biobur_negative_offset = .true.
        else
          biobur_negative_offset = .false.
        endif
      else if (trim(biobur_time_dependency_type) == 'fixed_year') then
        biobur_time_serie_type = 2
        if (biobur_dataset_entry(1) == 1 .and. &
            biobur_dataset_entry(2) == 1 .and. &
            biobur_dataset_entry(3) == 1 .and. &
            biobur_dataset_entry(4) == 0 .and. &
            biobur_dataset_entry(5) == 0 .and. &
            biobur_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_sulfate_mod', &
            'must set biobur_dataset_entry when using fixed_year source', FATAL)
        endif

!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to biobur_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        biobur_entry  = set_date (biobur_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_sulfate_mod', &
           'biobur is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'biobur correspond to year :', &
                    biobur_dataset_entry(1)
        endif
     endif
     call interpolator_init (biobur_emission_interp,             &
                             trim(biobur_filename),           &
                             lonb, latb,                        &
                             data_out_of_bounds=  (/CONSTANT/), &
                             data_names = biobur_emission_name,        &
                             vert_interp=(/INTERP_WEIGHTED_P/)  )
     endif

     if (trim(ship_source) .eq. 'do_ship') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(ship_time_dependency_type) == 'constant' ) then
        ship_time_serie_type = 1
        ship_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'ship are constant in sulfate module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for ship is selected.
!---------------------------------------------------------------------
      else if (trim(ship_time_dependency_type) == 'time_varying') then
        ship_time_serie_type = 3
        if (ship_dataset_entry(1) == 1 .and. &
            ship_dataset_entry(2) == 1 .and. &
            ship_dataset_entry(3) == 1 .and. &
            ship_dataset_entry(4) == 0 .and. &
            ship_dataset_entry(5) == 0 .and. &
            ship_dataset_entry(6) == 0 ) then
          ship_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to ship_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          ship_entry  = set_date (ship_dataset_entry(1), &
                                  ship_dataset_entry(2), &
                                  ship_dataset_entry(3), &
                                  ship_dataset_entry(4), &
                                  ship_dataset_entry(5), &
                                  ship_dataset_entry(6))
        endif
        call print_date (ship_entry , str= &
          'Data from ship timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        ship_offset = ship_entry - model_init_time
        if (model_init_time > ship_entry) then
          ship_negative_offset = .true.
        else
          ship_negative_offset = .false.
        endif
      else if (trim(ship_time_dependency_type) == 'fixed_year') then
        ship_time_serie_type = 2
        if (ship_dataset_entry(1) == 1 .and. &
            ship_dataset_entry(2) == 1 .and. &
            ship_dataset_entry(3) == 1 .and. &
            ship_dataset_entry(4) == 0 .and. &
            ship_dataset_entry(5) == 0 .and. &
            ship_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_sulfate_mod', &
            'must set ship_dataset_entry when using fixed_year source', FATAL)
        endif

!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to ship_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        ship_entry  = set_date (ship_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_sulfate_mod', &
           'ship is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'ship correspond to year :', &
                    ship_dataset_entry(1)
        endif
     endif
     call interpolator_init (ship_emission_interp,             &
                             trim(ship_filename),           &
                             lonb, latb,                        &
                             data_out_of_bounds=  (/CONSTANT/), &
                             data_names = ship_emission_name,        &
                             vert_interp=(/INTERP_WEIGHTED_P/)  )
    endif

    if (trim(aircraft_source) .eq. 'do_aircraft') then
!---------------------------------------------------------------------
!    Set time for input file base on selected time dependency.
!---------------------------------------------------------------------
      if (trim(aircraft_time_dependency_type) == 'constant' ) then
        aircraft_time_serie_type = 1
        aircraft_offset = set_time(0, 0)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'aircraft are constant in sulfate module'
        endif
!---------------------------------------------------------------------
!    a dataset entry point must be supplied when the time dependency
!    for aircraft is selected.
!---------------------------------------------------------------------
      else if (trim(aircraft_time_dependency_type) == 'time_varying') then
        aircraft_time_serie_type = 3
        if (aircraft_dataset_entry(1) == 1 .and. &
            aircraft_dataset_entry(2) == 1 .and. &
            aircraft_dataset_entry(3) == 1 .and. &
            aircraft_dataset_entry(4) == 0 .and. &
            aircraft_dataset_entry(5) == 0 .and. &
            aircraft_dataset_entry(6) == 0 ) then
          aircraft_entry = model_init_time
        else
!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to aircraft_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
          aircraft_entry  = set_date (aircraft_dataset_entry(1), &
                                  aircraft_dataset_entry(2), &
                                  aircraft_dataset_entry(3), &
                                  aircraft_dataset_entry(4), &
                                  aircraft_dataset_entry(5), &
                                  aircraft_dataset_entry(6))
        endif
        call print_date (aircraft_entry , str= &
          'Data from aircraft timeseries at time:')
        call print_date (model_init_time , str= &
          'This data is mapped to model time:')
        aircraft_offset = aircraft_entry - model_init_time
        if (model_init_time > aircraft_entry) then
          aircraft_negative_offset = .true.
        else
          aircraft_negative_offset = .false.
        endif
      else if (trim(aircraft_time_dependency_type) == 'fixed_year') then
        aircraft_time_serie_type = 2
        if (aircraft_dataset_entry(1) == 1 .and. &
            aircraft_dataset_entry(2) == 1 .and. &
            aircraft_dataset_entry(3) == 1 .and. &
            aircraft_dataset_entry(4) == 0 .and. &
            aircraft_dataset_entry(5) == 0 .and. &
            aircraft_dataset_entry(6) == 0 ) then
           call error_mesg ('atmos_sulfate_mod', &
            'must set aircraft_dataset_entry when using fixed_year source', FATAL)
        endif

!----------------------------------------------------------------------
!    define the offset from model base time (obtained from diag_table)
!    to aircraft_dataset_entry as a time_type variable.
!----------------------------------------------------------------------
        aircraft_entry  = set_date (aircraft_dataset_entry(1), &
                                  2,1,0,0,0)
        call error_mesg ('atmos_sulfate_mod', &
           'aircraft is defined from a single annual cycle &
                &- no interannual variation', NOTE)
        if (mpp_pe() == mpp_root_pe() ) then
          print *, 'aircraft correspond to year :', &
                    aircraft_dataset_entry(1)
        endif
     endif

     call interpolator_init (aircraft_emission_interp, &
                             trim(aircraft_filename),  &
                             lonb, latb,&
                             data_out_of_bounds=  (/CONSTANT/), &
                             data_names = aircraft_emission_name, &
                             vert_interp=(/INTERP_WEIGHTED_P/) )
   endif

! Register diagnostic fields
   id_DMS_emis   = register_diag_field ( mod_name,                           &
                   'simpleDMS_emis', axes(1:2),Time,                         &
                   'simpleDMS_emis', 'kgS/m2/s',                             &
                    missing_value=-999.  )
   id_DMS_emis_cmip   = register_diag_field ( mod_name,                                   &
                   'simpleDMS_emis_cmip', axes(1:2),Time,                                 &
                   'simpleDMS_emis_cmip', 'kgDMS/m2/s',                                     &
                    missing_value=-999.  )
   id_SO2_emis   = register_diag_field ( mod_name,                           &
                   'simpleSO2_emis', axes(1:3),Time,                         &
                   'simpleSO2_emis', 'kgS/m2/s',                             &
                    missing_value=-999.  )
   id_SO4_emis   = register_diag_field ( mod_name,                           &
                   'simpleSO4_emis', axes(1:3),Time,                         &
                   'simpleSO4_emis', 'kgS/m2/s',                             &
                    missing_value=-999.  )
   id_DMSo       = register_diag_field ( mod_name,                           &
                   'DMSo',axes(1:2),Time,                                    &
                   'Dimethylsulfide seawater concentration',                 &
                   'nM/L')
   id_ph          = register_diag_field ( mod_name,                          &
                   'pH_simple_sulfate',axes(1:3),Time,                       &
                   'pH in simple-sulfate',                                   &
                   'none')
   id_O3           = register_diag_field ( mod_name,                         &
                   'O3_simple_sulfate',axes(1:3),Time,                       &
                   'O3 in simple-sulfate',                                   &
                   'none')
   id_SO2_aircraft = register_diag_field ( mod_name,                         &
                   'simpleSO2_aircraft_emis',axes(1:3),Time,                 &
                   'simpleSO2 emission by aircraft',                         &
                   'kgS/m2/s')
   id_SO2_biobur  = register_diag_field ( mod_name,                          &
                   'simpleSO2_biobur_emis',axes(1:3),Time,                   &
                   'simpleSO2 emission from biomass burning',                &
                   'kgS/m2/s')
   id_SO2_cont_volc = register_diag_field ( mod_name,                        &
                   'simpleSO2_cont_volc_emis',axes(1:3),Time,                &
                   'simpleSO2 emission from non-eruptive volcanoes',         &
                   'kgS/m2/s')
   id_SO2_expl_volc = register_diag_field ( mod_name,                        &
                   'simpleSO2_expl_volc_emis',axes(1:3),Time,                &
                   'simpleSO2 emission from eruptive volcanoes',             &
                   'kgS/m2/s')
   id_SO2_ship      = register_diag_field ( mod_name,                        &
                   'simpleSO2_ship_emis',axes(1:3),Time,                     &
                   'simpleSO2 emission from international shipping',         &
                   'kgS/m2/s')
   id_SO2_road      = register_diag_field ( mod_name,                        &
                   'simpleSO2_road_emis',axes(1:3),Time,                     &
                   'simpleSO2 emission from road transport',                 &
                   'kgS/m2/s')
   id_SO2_domestic = register_diag_field ( mod_name,                         &
                   'simpleSO2_domestic_emis',axes(1:3),Time,                 &
                   'simpleSO2 emission from domestic fossil fuel burning',   &
                   'kgS/m2/s')
   id_SO2_industry = register_diag_field ( mod_name,                         &
                   'simpleSO2_industry_emis',axes(1:3),Time,                 &
                   'simpleSO2 emission from industrial fossil fuel burning', &
                   'kgS/m2/s')
   id_SO2_power   = register_diag_field ( mod_name,                          &
                   'simpleSO2_power_emis',axes(1:3),Time,                    &
                   'simpleSO2 emission from power plants',                   &
                   'kgS/m2/s')
   id_SO2_off_road = register_diag_field ( mod_name,                         &
                   'simpleSO2_off_road_emis',axes(1:3),Time,                 &
                   'simpleSO2 emission from off-road transport',             &
                   'kgS/m2/s')
   id_SO2_ff      = register_diag_field ( mod_name,                          &
                   'simpleSO2_ff_emis',axes(1:3),Time,                       &
                   'simpleSO2 emission from fossil fuel burning',            &
                   'kgS/m2/s')
   id_NO3        = register_diag_field ( mod_name,                           &
                   'simpleNO3_diurnal',axes(1:3),Time,                       &
                   'Time varying NO3 concentration',                         &
                   'molec.cm-3')
   id_OH         = register_diag_field ( mod_name,                           &
                   'OH_simple_sulfate',axes(1:3),Time,                       &
                   'Varying Hydroxyl radical concentration',                 &
                   'molec.cm-3')
   id_jH2O2         = register_diag_field ( mod_name,                        &
                   'jH2O2_simple_sulfate',axes(1:3),Time,                    &
                   'Varying H2O2 photodissociation',                         &
                   's-1')
   id_HO2         = register_diag_field ( mod_name,                          &
                   'HO2_simple_sulfate',axes(1:3),Time,                      &
                   'Varying Hydroperoxyl radical concentration',             &
                   'molec.cm-3')
   id_DMS_chem   = register_diag_field ( mod_name,                           &
                   'simpleDMS_chem',axes(1:3),Time,                          &
                   'simpleDMS chemical production',                          &
                   'kgS/m2/s')
   id_SO2_chem   = register_diag_field ( mod_name,                           &
                   'simpleSO2_chem',axes(1:3),Time,                          &
                   'simpleSO2 chemical production',                          &
                   'kgS/m2/s')
   id_SO4_chem   = register_diag_field ( mod_name,                           &
                   'simpleSO4_chem',axes(1:3),Time,                          &
                   'simpleSO4 chemical production',                          &
                   'kgS/m2/s')
   id_SO4_oh_prod= register_diag_field ( mod_name,                           &
                   'simpleSO4_oh_prod',axes(1:3),Time,                       &
                   'simpleSO4 gas phase production',                         &
                   'kgS/m2/s')
   id_SO4_o3_prod= register_diag_field ( mod_name,                           &
                   'simpleSO4_o3_prod',axes(1:3),Time,                       &
                   'simpleSO4 aqueous phase production SO2+O3',              &
                   'kgS/m2/s')
   id_SO4_h2o2_prod= register_diag_field ( mod_name,                         &
                   'simpleSO4_h2o2_prod',axes(1:3),Time,                     &
                   'simpleSO4 aqueous phase production SO2+H2O2',            &
                   'kgS/m2/s')
   id_MSA_chem   = register_diag_field ( mod_name,                           &
                   'simpleMSA_chem',axes(1:3),Time,                          &
                   'simpleMSA chemical production',                          &
                   'kgS/m2/s')
   id_H2O2_chem   = register_diag_field ( mod_name,                          &
                   'simpleH2O2_chem',axes(1:3),Time,                         &
                   'simpleH2O2 chemical production',                         &
                   'kgH2O2/m2/s')

   call write_version_number(version, tagname)

   module_is_initialized = .TRUE.

!-----------------------------------------------------------------------
 end subroutine atmos_sulfate_init



!######################################################################

subroutine atmos_sulfate_time_vary (model_time)


type(time_type), intent(in) :: model_time

      integer :: yr,dum, mo_yr, mo, dy, hr, mn, sc, dayspmn


      call obtain_interpolator_time_slices (gocart_emission_interp, &
                                                           model_time)

      call obtain_interpolator_time_slices (aerocom_emission_interp, &
                                                           model_time)

      if (trim(anthro_source) .eq. 'do_anthro') then
!--------------------------------------------------------------------
!    define the time in the anthro data set from which data is to be 
!    taken. if anthro is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
          if(anthro_time_serie_type .eq. 3) then
            if (anthro_negative_offset) then
              anthro_time = model_time - anthro_offset
            else
              anthro_time = model_time + anthro_offset
            endif
          else
            if(anthro_time_serie_type .eq. 2 ) then
              call get_date (anthro_entry, yr, dum,dum,dum,dum,dum)
              call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
              if (mo ==2 .and. dy == 29) then
                dayspmn = days_in_month(anthro_entry)
                if (dayspmn /= 29) then
                  anthro_time = set_date (yr, mo, dy-1, hr, mn, sc)
                else
                  anthro_time = set_date (yr, mo, dy, hr, mn, sc)
                endif
              else
                anthro_time = set_date (yr, mo, dy, hr, mn, sc)
              endif
            else
              anthro_time = model_time
            endif
          endif
          call obtain_interpolator_time_slices &
                      (anthro_emission_interp, anthro_time)

      endif 

      if (trim(biobur_source) .eq. 'do_biobur') then
!--------------------------------------------------------------------
!    define the time in the biobur data set from which data is to be 
!    taken. if biobur is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
          if(biobur_time_serie_type .eq. 3) then
            if (biobur_negative_offset) then
              biobur_time = model_time - biobur_offset
            else
              biobur_time = model_time + biobur_offset
            endif
          else
            if(biobur_time_serie_type .eq. 2 ) then
              call get_date (biobur_entry, yr, dum,dum,dum,dum,dum)
              call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
              if (mo ==2 .and. dy == 29) then
                dayspmn = days_in_month(biobur_entry)
                if (dayspmn /= 29) then
                  biobur_time = set_date (yr, mo, dy-1, hr, mn, sc)
                else
                  biobur_time = set_date (yr, mo, dy, hr, mn, sc)
                endif
              else
                biobur_time = set_date (yr, mo, dy, hr, mn, sc)
              endif
            else
              biobur_time = model_time
            endif
          endif
          call obtain_interpolator_time_slices &
                            (biobur_emission_interp, biobur_time)

      endif 

      if (trim(ship_source) .eq. 'do_ship') then
!--------------------------------------------------------------------
!    define the time in the ship data set from which data is to be 
!    taken. if ship is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
          if(ship_time_serie_type .eq. 3) then
            if (ship_negative_offset) then
              ship_time = model_time - ship_offset
            else
              ship_time = model_time + ship_offset
            endif
          else
            if(ship_time_serie_type .eq. 2 ) then
              call get_date (ship_entry, yr, dum,dum,dum,dum,dum)
              call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
              if (mo ==2 .and. dy == 29) then
                dayspmn = days_in_month(ship_entry)
                if (dayspmn /= 29) then
                  ship_time = set_date (yr, mo, dy-1, hr, mn, sc)
                else
                  ship_time = set_date (yr, mo, dy, hr, mn, sc)
                endif
              else
                ship_time = set_date (yr, mo, dy, hr, mn, sc)
              endif
            else
              ship_time = model_time
            endif
          endif
          call obtain_interpolator_time_slices &
              (ship_emission_interp, ship_time)

        endif
!
! Aircraft emissions
      if (trim(aircraft_source) .eq. 'do_aircraft') then
        if(aircraft_time_serie_type .eq. 3) then
          if (aircraft_negative_offset) then
            aircraft_time = model_time - aircraft_offset
          else
            aircraft_time = model_time + aircraft_offset
          endif
        else
          if(aircraft_time_serie_type .eq. 2 ) then
            call get_date (aircraft_entry, yr, dum,dum,dum,dum,dum)
            call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
            if (mo ==2 .and. dy == 29) then
              dayspmn = days_in_month(aircraft_entry)
              if (dayspmn /= 29) then
                aircraft_time = set_date (yr, mo, dy-1, hr, mn, sc)
              else
                aircraft_time = set_date (yr, mo, dy, hr, mn, sc)
              endif
            else
              aircraft_time = set_date (yr, mo, dy, hr, mn, sc)
            endif
          else
            aircraft_time = model_time
          endif
        endif

!
          call obtain_interpolator_time_slices &
                         (aircraft_emission_interp, aircraft_time)
      endif


!--------------------------------------------------------------------
!    define the time in the gas_conc data set from which data is to be 
!    taken. if gas_conc is not time-varying, it is simply model_time.
!---------------------------------------------------------------------
     if(gas_conc_time_serie_type .eq. 3) then
       if (gas_conc_negative_offset) then
         gas_conc_time = model_time - gas_conc_offset
       else
         gas_conc_time = model_time + gas_conc_offset
       endif
     else
       if(gas_conc_time_serie_type .eq. 2 ) then
         call get_date (gas_conc_entry, yr, dum,dum,dum,dum,dum)
         call get_date (model_time, mo_yr, mo, dy, hr, mn, sc)
         if (mo ==2 .and. dy == 29) then
           dayspmn = days_in_month(gas_conc_entry)
           if (dayspmn /= 29) then
             gas_conc_time = set_date (yr, mo, dy-1, hr, mn, sc)
           else
             gas_conc_time = set_date (yr, mo, dy, hr, mn, sc)
           endif
         else
           gas_conc_time = set_date (yr, mo, dy, hr, mn, sc)
         endif
       else
         gas_conc_time = model_time
       endif
     endif

      call obtain_interpolator_time_slices &
                          (gas_conc_interp, gas_conc_time)

end subroutine atmos_sulfate_time_vary 




!######################################################################

subroutine atmos_sulfate_endts                    


      call unset_interpolator_time_flag (gocart_emission_interp)

      call unset_interpolator_time_flag (aerocom_emission_interp)

      if (trim(anthro_source) .eq. 'do_anthro') then
          call unset_interpolator_time_flag (anthro_emission_interp)
      endif 

      if (trim(biobur_source) .eq. 'do_biobur') then
          call unset_interpolator_time_flag (biobur_emission_interp)
      endif 

      if (trim(ship_source) .eq. 'do_ship') then
          call unset_interpolator_time_flag (ship_emission_interp)
      endif

      if (trim(aircraft_source) .eq. 'do_aircraft') then
          call unset_interpolator_time_flag (aircraft_emission_interp)
      endif

      call unset_interpolator_time_flag (gas_conc_interp)


end subroutine atmos_sulfate_endts         



!</SUBROUTINE>

!#######################################################################

!<SUBROUTINE NAME="atmos_sulfate_end">
!<OVERVIEW>
!  The destructor routine for the sulfate module.
!</OVERVIEW>
! <DESCRIPTION>
! This subroutine writes the version name to logfile and exits. 
! </DESCRIPTION>
!<TEMPLATE>
! call atmos_sulfate_end
!</TEMPLATE>
 subroutine atmos_sulfate_end

        call interpolator_end (aerocom_emission_interp) 
        call interpolator_end (gocart_emission_interp) 
        call interpolator_end (gas_conc_interp) 
        call interpolator_end (anthro_emission_interp) 
        call interpolator_end (biobur_emission_interp) 
        call interpolator_end (ship_emission_interp) 
        call interpolator_end (aircraft_emission_interp) 
        module_is_initialized = .FALSE.

 end subroutine atmos_sulfate_end
!</SUBROUTINE>
!#######################################################################
!</SUBROUTINE>
!<SUBROUTINE NAME="atmos_DMS_emission">
!<OVERVIEW>
! The constructor routine for the sulfate module.
!</OVERVIEW>
!<DESCRIPTION>
! A routine to calculate dimethyl sulfide emission form the ocean
!</DESCRIPTION>
!<TEMPLATE>
!call atmos_DMS_emission (r, mask, axes, Time)
!</TEMPLATE>
!   <INOUT NAME="r" TYPE="real" DIM="(:,:,:,:)">
!     Tracer fields dimensioned as (nlon,nlat,nlev,ntrace). 
!   </INOUT>
!   <IN NAME="mask" TYPE="real, optional" DIM="(:,:,:)">
!      optional mask (0. or 1.) that designates which grid points
!           are above (=1.) or below (=0.) the ground dimensioned as
!           (nlon,nlat,nlev).
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="axes" TYPE="integer" DIM="(4)">
!     The axes relating to the tracer array dimensioned as
!      (nlon, nlat, nlev, ntime)
!   </IN>
subroutine atmos_DMS_emission (lon, lat, area, ocn_flx_fraction, t_surf_rad, w10m, &
       pwt, DMS_dt, Time, Time_next, is,ie,js,je,kbot)
!
      real, intent(in),    dimension(:,:)           :: lon, lat
      real, intent(in),    dimension(:,:)           :: ocn_flx_fraction
      real, intent(in),    dimension(:,:)           :: t_surf_rad
      real, intent(in),    dimension(:,:)           :: w10m
      real, intent(in),    dimension(:,:)           :: area
      real, intent(in),    dimension(:,:,:)         :: pwt
      real, intent(out),   dimension(:,:,:)         :: DMS_dt
      type(time_type), intent(in)                   :: Time, Time_next    
      integer, intent(in)                           :: is, ie, js, je
      integer, intent(in), dimension(:,:), optional :: kbot
!-----------------------------------------------------------------------
      real, dimension(size(DMS_dt,1),size(DMS_dt,2)) :: DMSo, DMS_emis
      integer                                        :: i, j, id, jd, kd
      real                                           :: sst, Sc, conc, w10 
      real                                           :: ScCO2, Akw
      real, parameter                                :: Sc_min=1.

      id=size(dms_dt,1); jd=size(dms_dt,2); kd=size(dms_dt,3)

      dms_dt(:,:,:) =0.0

      DMSo(:,:)=0.0
      call interpolator(gocart_emission_interp, Time, DMSo, &
                       trim(gocart_emission_name(1)), is, js)
! --- Send the DMS data to the diag_manager for output.
      if (id_DMSo > 0 ) &
          used = send_data ( id_DMSo, DMSo, Time_next, is_in=is, js_in=js )

! ****************************************************************************
! *  If ocn_flx_fraction > critical_sea_fraction: DMS_emis = seawaterDMS * transfer velocity * ocn_flx_fraction
! ****************************************************************************
!

      do j = 1, jd
      do i = 1, id
       SST = t_surf_rad(i,j)-273.15     ! Sea surface temperature [Celsius]
       if (ocn_flx_fraction(i,j) .gt. critical_sea_fraction) then

!  < Schmidt number for DMS (Saltzman et al., 1993) >
        Sc = 2674.0 - 147.12*SST + 3.726*(SST**2) - 0.038*(SST**3)
        Sc = max(Sc_min, Sc)

! ****************************************************************************
! *  Calculate transfer velocity in cm/hr  (AKw)                             *
! *                                                                          *
! *  Tans et al. transfer velocity (1990) for CO2 at 25oC (Erickson, 1993)   *
! *                                                                          *
! *  Tans et al. assumed AKW=0 when W10<=3. I modified it to let             *
! *  DMS emit at low windseeds too. Chose 3.6m/s as the threshold.           *
! *                                                                          *
! *  Schmidt number for CO2:       Sc = 600  (20oC, fresh water)             *
! *                                Sc = 660  (20oC, seawater)                *
! *                                Sc = 428  (25oC, Erickson 93)             *
! ****************************************************************************
!

        CONC = DMSo(i,j)

        W10  = W10M(i,j)

! ---  Tans et al. (1990) -----------------
!       ScCO2 = 428.
!       if (W10 .le. 3.6) then
!        AKw = 1.0667 * W10
!       else
!        AKw = 6.4 * (W10 - 3.)
!       end if

! ---  Wanninkhof (1992) ------------------
!       ScCO2 = 660.
!       AKw = 0.31 * W10**2

! ---  Liss and Merlivat (1986) -----------
        ScCO2 = 600.
        if (W10 .le. 3.6) then
         AKw = 0.17 * W10
        else if (W10 .le. 13.) then
         AKw = 2.85 * W10 - 9.65
        else
         AKw = 5.90 * W10 - 49.3
        end if
!------------------------------------------

        if (W10 .le. 3.6) then
         AKw = AKw * ((ScCO2/Sc) ** 0.667)
        else
         AKw = AKw * sqrt(ScCO2/Sc)
        end if

! ****************************************************************************
! *  Calculate emission flux in kg/m2/s                                  *
! *                                                                          *
! *   AKw is in cm/hr:             AKw/100/3600    -> m/sec.                 *
! *   CONC is in nM/L (nM/dm3):    CONC*1E-12*1000 -> kmole/m3.              *
! *   WTM_DMS          : kgDMS/kmol.                                         *
! *   DMS_EMIS         : kgDMS/m2/s.                                         *
! ****************************************************************************
!
        DMS_emis(i,j) = AKw/100./3600. * CONC*1.e-12*1000.* WTM_DMS &
            * (ocn_flx_fraction(i,j))
!
       else               
        DMS_emis(i,j) = 0.

       end if           

      end do
      end do
!--------------------------------------------------------------------
! Update DMS concentration in level kd (where emission occurs)
!--------------------------------------------------------------------
      dms_dt(:,:,kd)=DMS_emis(:,:)/pwt(:,:,kd)* WTMAIR/WTM_DMS
!------------------------------------------------------------------
! DIAGNOSTICS:      DMS surface emission in kg/m2/s     
!--------------------------------------------------------------------
      if (id_DMS_emis > 0) then
        used = send_data ( id_DMS_emis, dms_emis*WTM_S/WTM_DMS, Time_next, &
              is_in=is,js_in=js )
      endif
      if (id_DMS_emis_cmip > 0) then
        used = send_data ( id_DMS_emis_cmip, dms_emis, Time_next, &
              is_in=is,js_in=js )
      endif

end subroutine atmos_DMS_emission
!#######################################################################
!</SUBROUTINE>
!<SUBROUTINE NAME="atmos_SO2_emission">
!<OVERVIEW>
! The constructor routine for the sulfate module.
!</OVERVIEW>
!<DESCRIPTION>
! A routine to calculate SO2 emission from volcanoes, biomass burning,
! anthropogenic sources, aircraft.
!</DESCRIPTION>
!<TEMPLATE>
!call atmos_SO2_emission ()
!</TEMPLATE>
!   <INOUT NAME="r" TYPE="real" DIM="(:,:,:,:)">
!     Tracer fields dimensioned as (nlon,nlat,nlev,ntrace).
!   </INOUT>
!   <IN NAME="mask" TYPE="real, optional" DIM="(:,:,:)">
!      optional mask (0. or 1.) that designates which grid points
!           are above (=1.) or below (=0.) the ground dimensioned as
!           (nlon,nlat,nlev).
!   </IN>
!   <IN NAME="Time" TYPE="type(time_type)">
!     Model time.
!   </IN>
!   <IN NAME="axes" TYPE="integer" DIM="(4)">
!     The axes relating to the tracer array dimensioned as
!      (nlon, nlat, nlev, ntime)
!   </IN>
subroutine atmos_SOx_emission (lon, lat, area, frac_land, &
       z_pbl, zhalf, phalf, pwt, SO2_dt, SO4_dt, model_time, diag_time, is,ie,js,je,kbot)
!
! This subroutine calculates the tendencies of SO2 and SO4 due to
! their emissions.
! The inventories are based from AEROCOM (cf. Dentener, ACPD, 2006)
! except the aircraft emission.
! The emission of SO4 is assumed to be fe=2.5% of all sulfur emission
! (cf. Dentener, ACPD, 2006). NB. Some authors consider 5%
!
      real, intent(in),    dimension(:,:)           :: lon, lat
      real, intent(in),    dimension(:,:)           :: frac_land
      real, intent(in),    dimension(:,:)           :: area
      real, intent(in),    dimension(:,:)           :: z_pbl
      real, intent(in),    dimension(:,:,:)         :: zhalf, phalf
      real, intent(in),    dimension(:,:,:)         :: pwt
      real, intent(out),   dimension(:,:,:)         :: SO2_dt, SO4_dt
      type(time_type), intent(in)                   :: model_time,diag_time
      integer, intent(in)                           :: is, ie, js, je
      integer, intent(in), dimension(:,:), optional :: kbot
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
      integer, parameter :: nlevel_fire = 6
      real, dimension(size(SO4_dt,1),size(SO4_dt,2),size(SO4_dt,3)) :: SO4_emis
      real, dimension(size(SO2_dt,1),size(SO2_dt,2),size(SO2_dt,3)) :: SO2_emis
      real, dimension(size(SO2_dt,1),size(SO2_dt,2),size(SO2_dt,3)) :: &
        so2_aircraft,so2_emis_cont_volc, so2_emis_expl_volc, so2_emis_biobur, &
        so2_emis_ship, so2_emis_road, so2_emis_domestic, so2_emis_industry, &
        so2_emis_power, so2_emis_off_road, so2_emis_ff
! Input emission fields
      real, dimension(size(SO2_dt,1),size(SO2_dt,2)) :: &
             SO2_ff1, SO2_ff2, SO4_ff1, SO4_ff2,&
             SO2_RoadTransport,                         &
             SO2_Off_road,                              &
             SO2_Domestic,                              &
             SO2_Industry,                              &
             SO2_Ship, SO4_ship,                        &
             SO2_Powerplants
      real, dimension(size(SO2_dt,1),size(SO2_dt,2),num_volc_levels) :: &
             SO2_cont_volc,                             &
             SO2_expl_volc
      real, dimension(size(SO2_dt,1),size(SO2_dt,2),nlevel_fire) :: &
             SO2_biobur
! Factors of vertical distribution of emissions
      real, dimension(size(SO2_dt,3)) :: fbb, fa1, fa2, fcv, fev
      real, dimension(size(SO2_dt,3),nlevel_fire) :: ff
! Lower altitude of injection of SO2 from wild fires 
! These values correspond to the AEROCOM input data (cf. Dentener, ACPD, 2006)
      real, dimension(nlevel_fire) :: &
             alt_fire_min=(/0.,100.,500.,1000.,2000.,3000./)
! Upper altitude of injection of SO2 from wild fires 
! These values correspond to the AEROCOM input data (cf. Dentener, ACPD, 2006)
      real, dimension(nlevel_fire) :: &
             alt_fire_max=(/100.,500.,1000.,2000.,3000.,6000./)
! Altitude of injection of surafce anthropogenic emissions
      real :: ze1
! Altitude of injection of SO2 from industries and power plants.   
      real :: ze2
! Emission factor for SO4
      real, parameter :: fe = 0.025

      real :: z1, z2, bltop, fbt, del
      integer  :: i, j, l, id, jd, kd, il, lf
      integer :: ivolc_lev

      id=size(SO2_dt,1); jd=size(SO2_dt,2); kd=size(SO2_dt,3)
!
! Initialize
!
      SO2_dt(:,:,:) = 0.0
      SO4_dt(:,:,:) = 0.0
      SO2_emis(:,:,:) = 0.0
      SO4_emis(:,:,:) = 0.0
! GOCART emissions
      SO2_ff1(:,:)=0.0
      SO2_ff2(:,:)=0.0
      SO4_ff1(:,:)=0.0
      SO4_ff2(:,:)=0.0
! AEROCOM emissions
      SO2_RoadTransport(:,:)=0.0
      SO2_Off_road(:,:)=0.0
      SO2_Domestic(:,:)=0.0
      SO2_Industry(:,:)=0.0
      SO2_Ship(:,:)=0.0
      SO4_Ship(:,:)=0.0
      SO2_Powerplants(:,:)=0.0
      SO2_aircraft(:,:,:)=0.0
      SO2_biobur(:,:,:)=0.0

      SO2_cont_volc(:,:,:)=0.0
      SO2_expl_volc(:,:,:)=0.0
! Arrays for output diagnostics
      so2_aircraft(:,:,:)=0.0
      so2_emis_cont_volc(:,:,:)=0.0
      so2_emis_expl_volc(:,:,:)=0.0
      so2_emis_biobur(:,:,:)=0.0
      so2_emis_ship(:,:,:)=0.0
      so2_emis_road(:,:,:)=0.0
      so2_emis_domestic(:,:,:)=0.0
      so2_emis_industry(:,:,:)=0.0
      so2_emis_power(:,:,:)=0.0
      so2_emis_off_road(:,:,:)=0.0
      so2_emis_ff(:,:,:)=0.0
!
      select case ( trim(runtype))
        case ('gocart')
          if (trim(anthro_source) .eq. 'do_anthro') then
            call interpolator(gocart_emission_interp, model_time, SO2_ff1, &
                         trim(gocart_emission_name(2)), is, js)
            call interpolator(gocart_emission_interp, model_time, SO2_ff2, &
                         trim(gocart_emission_name(3)), is, js)
            call interpolator(gocart_emission_interp, model_time, SO4_ff1, &
                         trim(gocart_emission_name(4)), is, js)
            call interpolator(gocart_emission_interp, model_time, SO4_ff2, &
                         trim(gocart_emission_name(5)), is, js)
          endif
          if (trim(biobur_source) .eq. 'do_biobur') then 
            call interpolator(gocart_emission_interp, model_time, &
                         SO2_biobur(:,:,1),trim(gocart_emission_name(6)), is, js)
          endif
        case ('aerocom')
          if (trim(anthro_source) .eq. 'do_anthro') then
            call interpolator(aerocom_emission_interp, model_time, &
                         SO2_RoadTransport,trim(aerocom_emission_name(1)),is, js)
            call interpolator(aerocom_emission_interp, model_time, SO2_Off_road, &
                         trim(aerocom_emission_name(2)), is, js)
            call interpolator(aerocom_emission_interp, model_time, SO2_Domestic, &
                         trim(aerocom_emission_name(3)), is, js)
            call interpolator(aerocom_emission_interp, model_time, SO2_Industry, &
                         trim(aerocom_emission_name(4)), is, js)
            call interpolator(aerocom_emission_interp, model_time, SO2_ship, &
                         trim(aerocom_emission_name(5)), is, js)
            call interpolator(aerocom_emission_interp, model_time, &
                         SO2_Powerplants, trim(aerocom_emission_name(6)), is, js)
          endif
          if (trim(biobur_source) .eq. 'do_biobur') then
! Wildfire emissions at 6 levels from 0 to 6 km
! (cf. AEROCOM web site or Dentener et al., ACPD, 2006)
            do il=1,nlevel_fire
              call interpolator(aerocom_emission_interp, model_time, &
                         SO2_biobur(:,:,il), &
                         trim(aerocom_emission_name(12+il)), is, js)
            enddo
          endif
        case default
          if (trim(anthro_source) .eq. 'do_anthro') then
            call interpolator(anthro_emission_interp, anthro_time, SO2_ff1(:,:), &
                     trim(anthro_emission_name(1)), is, js)
            call interpolator(anthro_emission_interp, anthro_time, SO4_ff1(:,:), &
                     trim(anthro_emission_name(2)), is, js)
          endif
          if (trim(biobur_source) .eq. 'do_biobur') then
            call interpolator(biobur_emission_interp, biobur_time, SO2_biobur(:,:,1), &
                     trim(biobur_emission_name(1)), is, js)
          endif
          if (trim(ship_source) .eq. 'do_ship') then
            call interpolator(ship_emission_interp, ship_time, SO2_ship(:,:), &
                     trim(ship_emission_name(1)), is, js)
            call interpolator(ship_emission_interp, ship_time, SO4_ship(:,:), &
                     trim(ship_emission_name(2)), is, js)
          endif

      end select
!
! Aircraft emissions
      if (trim(aircraft_source) .eq. 'do_aircraft') then
        call interpolator(aircraft_emission_interp, aircraft_time, &
                     phalf, SO2_aircraft, &
                     trim(aircraft_emission_name(1)), is, js)
      endif
!
! Continuous volcanoes
!
      if (trim(cont_volc_source) .eq. 'do_cont_volc') then
        do ivolc_lev = 1,num_volc_levels
           call interpolator( aerocom_emission_interp, model_time, SO2_cont_volc(:,:,ivolc_lev), &
                              trim(aerocom_emission_name(std_aerocom_emission+ivolc_lev)), is, js )
        end do
      endif
!
! Explosive volcanoes
!
      if (trim(expl_volc_source) .eq. 'do_expl_volc') then
        do ivolc_lev = 1,num_volc_levels
           call interpolator( aerocom_emission_interp, model_time, SO2_expl_volc(:,:,ivolc_lev), &
!                             trim(expl_volc_emission_name(ivolc_lev)), is, js )
                              trim(aerocom_emission_name(std_aerocom_emission+num_volc_levels+ivolc_lev)), is, js )
        end do
      endif

      do j = 1, jd
      do i = 1, id

! --- Assuming biomass burning emission within the PBL -------
        fbb(:) = 0.
        ze1=100.
        ze2=500.
        fbt=0.
        bltop = z_pbl(i,j)
        do l = kd,1,-1
          z1=zhalf(i,j,l+1)-zhalf(i,j,kd+1)
          z2=zhalf(i,j,l)-zhalf(i,j,kd+1)
          if (bltop.lt.z1) exit
          if (bltop.ge.z2) fbb(l)=(z2-z1)/bltop
          if (bltop.gt.z1.and.bltop.lt.z2) fbb(l) = (bltop-z1)/bltop
        enddo
! --- Assuming anthropogenic source L1 emitted below Ze1, and L2
!     emitted between Ze1 and Ze2.
        ff(:,:)=0.
        if (runtype.eq.'aerocom') then
          do l = kd,2,-1
            Z1 = zhalf(i,j,l+1)-zhalf(i,j,kd+1)
            Z2 = zhalf(i,j,l)-zhalf(i,j,kd+1)
            do lf=1,nlevel_fire
              del=alt_fire_max(lf)-alt_fire_min(lf)
              if (del.gt.0. .and. &
                  Z1.lt.alt_fire_max(lf).and.Z2.gt.alt_fire_min(lf) ) then
                if (Z1.ge.alt_fire_min(lf)) then
                  if (Z2 .lt. alt_fire_max(lf)) then
                    ff(l,lf)=(Z2-Z1)/del
                  else
                    ff(l,lf)=(alt_fire_max(lf)-z1)/del
                  endif
                else
                  if (Z2.le.alt_fire_max(lf)) then
                    ff(l,lf) = (Z2-alt_fire_min(lf))/del
                  else
                    ff(l,lf)=1.
                  endif
                endif
              endif
            enddo
          enddo
        endif
! --- Volcanic SO2 source ----
! --- For continuous and explosive volcanoes, calculate the fraction of emission
! --- for each vertical level
      if (trim(cont_volc_source) == 'do_cont_volc') then
        do ivolc_lev = 1,num_volc_levels
          fcv(:)=0.
          do l = kd,2,-1
            Z1 = zhalf(i,j,l+1)-zhalf(i,j,kd+1)
            Z2 = zhalf(i,j,l)-zhalf(i,j,kd+1)
            del=volc_altitude_edges(ivolc_lev+1)-volc_altitude_edges(ivolc_lev)
            if (del>0. .and. &
                Z1<volc_altitude_edges(ivolc_lev+1) .and. Z2>volc_altitude_edges(ivolc_lev) ) then
              if (Z1 >= volc_altitude_edges(ivolc_lev)) then
                if (Z2 < volc_altitude_edges(ivolc_lev+1)) then
                  fcv(l)=(Z2-Z1)/del
                else
                  fcv(l)=(volc_altitude_edges(ivolc_lev+1)-Z1)/del
                endif
              else
                if (Z2 <= volc_altitude_edges(ivolc_lev+1)) then
                  fcv(l)=(Z2-volc_altitude_edges(ivolc_lev))/del
                else
                  fcv(l)=1.
                endif
              endif
            endif
          enddo
          so2_emis_cont_volc(i,j,:) = so2_emis_cont_volc(i,j,:) + fcv(:) * SO2_cont_volc(i,j,ivolc_lev)
        end do
      endif
! --- For explosive volcanoes, calculate the fraction of emission for
! --- each vertical levels
      if (trim(expl_volc_source) == 'do_expl_volc') then 
        do ivolc_lev = 1,num_volc_levels
          fev(:)=0.
          do l = kd,2,-1
            Z1 = zhalf(i,j,l+1)-zhalf(i,j,kd+1)
            Z2 = zhalf(i,j,l)-zhalf(i,j,kd+1)
            del=volc_altitude_edges(ivolc_lev+1)-volc_altitude_edges(ivolc_lev)
            if (del>0. .and. &
                Z1<volc_altitude_edges(ivolc_lev+1).and.Z2>volc_altitude_edges(ivolc_lev) ) then
              if (Z1 >= volc_altitude_edges(ivolc_lev)) then
                if (Z2 < volc_altitude_edges(ivolc_lev+1)) then
                  fev(l)=(Z2-Z1)/del
                else
                  fev(l)=(volc_altitude_edges(ivolc_lev+1)-Z1)/del
                endif
              else
                if (Z2 <= volc_altitude_edges(ivolc_lev+1)) then
                  fev(l)=(Z2-volc_altitude_edges(ivolc_lev))/del
                else
                  fev(l)=1.
                endif
              endif
            endif
          enddo
          so2_emis_expl_volc(i,j,:) = so2_emis_expl_volc(i,j,:) + fev(:) * SO2_expl_volc(i,j,ivolc_lev)
        end do
      endif
! --- For fosil fuel emissions, calculate the fraction of emission for
! --- each vertical levels
        fa1(:) = 0.
        fa2(:) = 0.
        do l = kd,2,-1
          Z1 = zhalf(i,j,l+1)-zhalf(i,j,kd+1)
          Z2 = zhalf(i,j,l)-zhalf(i,j,kd+1)
          if (Z2.ge.0.and.Z1.lt.ze1) then
            if (Z1.gt.0) then
              if (Z2.lt.ze1) then
                fa1(l)=(Z2-Z1)/ze1
              else
                fa1(l)=(ze1-Z1)/ze1
              endif
            else
              if (Z2.le.ze1) then
                fa1(l)=Z2/ze1
              else
                fa1(l)=1.
              endif
            endif
          endif

          if (Z2.ge.ze1.and.z1.lt.ze2) then
            if (Z1.gt.Ze1) then
              if (Z2.lt.ze2) then
                fa2(l)=(z2-z1)/(ze2-ze1)
              else
                fa2(l)=(ze2-z1)/(ze2-ze1)
              endif
            else
              if (Z2.le.ze2) then
                fa2(l)=(z2-ze1)/(ze2-ze1)
              else
                fa2(l)=1.
              endif
            endif
          endif
          if (Z1.gt.Ze2) exit
        enddo
! SO2_emis: [kgSO2/m2/s]
!       Assuming that 1g of SO2 is emitted from 1kg of fuel: 1.e-3
        SO2_emis(i,j,:) = so2_aircraft_EI * SO2_aircraft(i,j,:) &
             + so2_emis_cont_volc(i,j,:) + so2_emis_expl_volc(i,j,:)
!
        select case (trim(runtype))
          case ('aerocom')
            do lf = 1, nlevel_fire
              so2_emis_biobur(i,j,:) = so2_emis_biobur(i,j,:) + &
                                       ff(:,lf)*SO2_biobur(i,j,lf)
            enddo
            so2_emis_road(i,j,:)     = fa1(:) * SO2_RoadTransport(i,j)
            so2_emis_off_road(i,j,:) = fa1(:) * SO2_off_Road(i,j)
            so2_emis_domestic(i,j,:) = fa1(:) * SO2_domestic(i,j)
            so2_emis_ship(i,j,:)     = fa1(:) * SO2_ship(i,j)
            so2_emis_industry(i,j,:) = fa2(:) * SO2_industry(i,j)
            so2_emis_power(i,j,:)    = fa2(:) * SO2_Powerplants(i,j)

            SO2_emis(i,j,:) = SO2_emis(i,j,:) + so2_emis_biobur(i,j,:)

            so2_emis_ff(i,j,:) =                                  &
                 + so2_emis_road(i,j,:)                           &
                 + so2_emis_off_road(i,j,:)                       &
                 + so2_emis_domestic(i,j,:)                       &
                 + so2_emis_ship(i,j,:)                           &
                 + so2_emis_industry(i,j,:)                       &
                 + so2_emis_power(i,j,:)
             SO2_emis(i,j,:) = SO2_emis(i,j,:) + so2_emis_ff(i,j,:)
          case ('gocart')
!
! GOCART assumes continent based emission index for sulfate:
!    Anthropogenic SOx emission from GEIA 1985.
!    Assuming:   Europe:      5.0% SOx emission is SO4;
!                US + Canada: 1.4% SOx emission is SO4;
!                The rest:    2.5% SOx emission is SO4.
            so2_emis_ff(i,j,:)=fa1(:) * SO2_ff1(i,j) + fa2(:) * SO2_ff2(i,j)
            so2_emis_biobur(i,j,:) = fbb(:) * SO2_biobur(i,j,1)
            SO2_emis(i,j,:) = SO2_emis(i,j,:) &
               + so2_emis_biobur(i,j,:)       &
               + so2_emis_ff(i,j,:)
            SO4_emis(i,j,:) = &
               fa1(:) * SO4_ff1(i,j) + fa2(:) * SO4_ff2(i,j)
          case default
            so2_emis_ff(i,j,:)=fa1(:) * SO2_ff1(i,j) + fa2(:) * SO2_ff2(i,j)
            so2_emis_biobur(i,j,:) = fbb(:) * SO2_biobur(i,j,1)
            so2_emis_ship(i,j,:)     = fa1(:) * SO2_ship(i,j)
            SO2_emis(i,j,:) = SO2_emis(i,j,:) &
               + so2_emis_biobur(i,j,:)       &
!++lwh
               + so2_emis_ship(i,j,:)         &
!--lwh
               + so2_emis_ff(i,j,:)
            SO4_emis(i,j,:) = fa1(:)*(SO4_ff1(i,j)+SO4_ship(i,j))
        end select

      end do   ! end i loop
      end do   ! end j loop
!
      SO2_dt(:,:,:)= SO2_emis(:,:,:)/pwt(:,:,:)*WTMAIR/WTM_SO2
      SO4_dt(:,:,:)= SO4_emis(:,:,:)/pwt(:,:,:)*WTMAIR/WTM_SO4

!------------------------------------------------------------------
! DIAGNOSTICS:      SO2 and SO4 emission in kg/timestep
!--------------------------------------------------------------------
      if (id_so2_emis > 0) then
        used = send_data ( id_so2_emis, so2_emis*WTM_S/WTM_so2, &
              diag_time, is_in=is,js_in=js,ks_in=1)
      endif
      if (id_so2_aircraft > 0) then
        used = send_data ( id_so2_aircraft, &
              so2_aircraft*so2_aircraft_EI*WTM_S/WTM_so2, &
              diag_time, is_in=is,js_in=js, ks_in=1)
      endif
      if (id_so2_cont_volc > 0) then
        used = send_data ( id_so2_cont_volc, so2_emis_cont_volc*WTM_S/WTM_so2, &
              diag_time, is_in=is,js_in=js, ks_in=1)
      endif
      if (id_so2_expl_volc > 0) then
        used = send_data ( id_so2_expl_volc, so2_emis_expl_volc*WTM_S/WTM_so2, &
              diag_time, is_in=is,js_in=js, ks_in=1)
      endif
      if (id_so2_biobur > 0) then
        used = send_data ( id_so2_biobur, so2_emis_biobur*WTM_S/WTM_so2, &
              diag_time, is_in=is,js_in=js,ks_in=1)
      endif
      if (id_so2_ship > 0) then
        used = send_data ( id_so2_ship, so2_emis_ship*WTM_S/WTM_so2, &
              diag_time, is_in=is,js_in=js, ks_in=1)
      endif
      if (id_so2_road > 0) then
        used = send_data ( id_so2_road, so2_emis_road*WTM_S/WTM_so2,  &
               diag_time, is_in=is,js_in=js, ks_in=1)
      endif
      if (id_so2_domestic > 0) then
        used = send_data ( id_so2_domestic, so2_emis_domestic*WTM_S/WTM_so2, &
              diag_time, is_in=is,js_in=js, ks_in=1)
      endif
      if (id_so2_industry > 0) then
        used = send_data ( id_so2_industry, so2_emis_industry*WTM_S/WTM_so2, &
              diag_time, is_in=is,js_in=js, ks_in=1)
      endif
      if (id_so2_power > 0) then
        used = send_data ( id_so2_power, so2_emis_power*WTM_S/WTM_so2, &
              diag_time, is_in=is,js_in=js, ks_in=1)
      endif
      if (id_so2_off_road > 0) then
        used = send_data ( id_so2_Off_road, so2_emis_off_road*WTM_S/WTM_so2, &
               diag_time, is_in=is,js_in=js, ks_in=1)
      endif
      if (id_so2_ff > 0) then
        used = send_data ( id_so2_ff, so2_emis_ff*WTM_S/WTM_so2, &
               diag_time, is_in=is,js_in=js, ks_in=1)
      endif
      if (id_so4_emis > 0) then
        used = send_data ( id_so4_emis, so4_emis*WTM_S/WTM_so4, diag_time, &
              is_in=is,js_in=js,ks_in=1)
      endif

end subroutine atmos_SOx_emission
!</SUBROUTINE>
!-----------------------------------------------------------------------
!#######################################################################
      subroutine atmos_SOx_chem(pwt,temp,pfull, phalf, dt, lwc, &
        jday,hour,minute,second,lat,lon, &
        SO2, SO4, DMS, MSA, H2O2, oh_vmr, &
        SO2_dt, SO4_dt, DMS_dt, MSA_dt, H2O2_dt, &
        model_time,diag_time,is,ie,js,je,kbot)
!
      real, intent(in)                   :: dt
      integer, intent(in)                :: jday, hour,minute,second
      real, intent(in),  dimension(:,:)  :: lat, lon  ! [radi
      real, intent(in), dimension(:,:,:) :: pwt
      real, intent(in), dimension(:,:,:) :: lwc
      real, intent(in), dimension(:,:,:) :: temp, pfull, phalf
      real, intent(in), dimension(:,:,:) :: SO2, SO4, DMS, MSA, H2O2
      real, intent(inout), dimension(:,:,:) :: oh_vmr
      real, intent(out),dimension(:,:,:) :: SO2_dt,SO4_dt,DMS_dt,MSA_dt,H2O2_dt

      type(time_type), intent(in)                    :: model_time,diag_time
      integer, intent(in),  dimension(:,:), optional :: kbot
      integer, intent(in)                            :: is,ie,js,je
! Working vectors
      integer :: i,j,k,id,jd,kd
      integer                                    :: istep, nstep
!!! Input fields from interpolator
      real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) :: pH
      real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) :: O3_mmr
      real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) :: no3_conc
      real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) :: oh_conc
      real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) :: jh2o2
      real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) :: ho2_conc
!!! Time varying fields
      real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) :: no3_diurnal
      real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) :: oh_diurnal
      real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) ::jh2o2_diurnal
      real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) :: ho2_diurnal
      real, dimension(size(pfull,1),size(pfull,2),size(pfull,3)) :: &
               SO4_oh_prod, SO4_o3_prod, SO4_h2o2_prod

      real, dimension(size(pfull,1),size(pfull,2)) :: &
               xu, dayl, h, hl, hc, hred
      real, dimension(size(pfull,1),size(pfull,2)) :: fac_NO3, fact_NO3
      real, dimension(size(pfull,1),size(pfull,2)) :: fac_OH , fact_OH 
      real, dimension(size(pfull,1),size(pfull,2)) :: fac_HO2            
      real, parameter                            :: A0 = 0.006918
      real, parameter                            :: A1 = 0.399912
      real, parameter                            :: A2 = 0.006758
      real, parameter                            :: A3 = 0.002697
      real, parameter                            :: B1 = 0.070257
      real, parameter                            :: B2 = 0.000907
      real, parameter                            :: B3 = 0.000148
      real                                       :: decl, hd, x
      real :: f, f1, tk, rho_air
      real :: SO2_0,SO4_0,MSA_0,DMS_0,H2O2_0    ! initial concentrations
      real :: xSO2,xSO4,xMSA,xDMS,xH2O2,xno3,xo3,xoh,xho2,xjh2o2 ! update conc.
      real :: rk0, rk1, rk2, rk3  ! kinetic rates
      real :: work1, xk, xe, x2, xph
      real :: heh2o2, h2o2g, rah2o2, px, heso2, so2g, heo3, o3g, rao3
      real :: pso4a, pso4b
      real :: xlwc, xhnm, ccc1, ccc2
      real :: pmsa, pso2, ph2o2    ! chemical production terms
      real :: ldms, lso2, lh2o2          ! chemical loss terms
      real :: o2
      real, parameter        :: small_value=1.e-21
      real, parameter        :: t0 = 298.
      real, parameter        :: Ra = 8314./101325.
      real, parameter        :: xkw = 1.e-14 ! water acidity
      real, parameter        :: const0 = 1.e3/6.022e23


! Local grid sizes
      id=size(pfull,1) ; jd=size(pfull,2) ; kd=size(pfull,3)

      so2_dt(:,:,:) = 0.0
      so4_dt(:,:,:) = 0.0
      dms_dt(:,:,:) = 0.0
      msa_dt(:,:,:) = 0.0
      h2o2_dt(:,:,:) = 0.0
      SO4_h2o2_prod(:,:,:)=0.0
      SO4_o3_prod(:,:,:)=0.0
      SO4_oh_prod(:,:,:)=0.0


      OH_conc(:,:,:)=1.e5  ! molec/cm3
      call interpolator(gas_conc_interp, gas_conc_time, phalf, OH_conc, &
                       trim(gas_conc_name(1)), is, js)

      HO2_conc(:,:,:)=1.e6  ! molec/cm3
      call interpolator(gas_conc_interp, gas_conc_time, phalf, HO2_conc, &
                       trim(gas_conc_name(2)), is, js)

      NO3_conc(:,:,:)=0.0  ! molec/cm3
      call interpolator(gas_conc_interp, gas_conc_time, phalf, NO3_conc, &
                       trim(gas_conc_name(3)), is, js)

      O3_mmr(:,:,:)=0  ! Ozone mass mixing ratio
      call interpolator(gas_conc_interp, gas_conc_time, phalf, O3_mmr, &
                       trim(gas_conc_name(4)), is, js)
      O3_mmr(:,:,:)=O3_mmr(:,:,:)*WTM_O3/WTMAIR

      jH2O2(:,:,:)=1.e-6 ! s-1
      call interpolator(gas_conc_interp, gas_conc_time, phalf, jH2O2, &
                       trim(gas_conc_name(5)), is, js)

      pH(:,:,:)=1.e-5
      call interpolator(gas_conc_interp, gas_conc_time, phalf, pH, &
                       trim(gas_conc_name(6)), is, js)

      x = 2. *pi *float(jday-1)/365.
      decl = A0 - A1*cos(  X) + B1*sin(  X) - A2*cos(2.*X) + B2*sin(2.*X) &
           - A3*cos(3.*X) + B3*sin(3.*X)
      xu(:,:) = -tan(lat(:,:))*tan(decl)

      where ( xu > -1 .and. xu < 1 ) dayl=acos(xu)/pi
      where ( xu <= -1 ) dayl = 1.
      where ( xu >= 1 ) dayl = 0.
!   Calculate normalization factors for OH and NO3 such that
!   the diurnal average respect the monthly input values.
      hd=0.
      fact_OH(:,:)  = 0.
      fact_NO3(:,:) = 0.
      nstep = int(24.*3600./dt)
      do istep=1,nstep
        hd=hd+dt/3600./24.
        hl(:,:) = pi*(1.-dayl(:,:))
        hc(:,:) = pi*(1.+dayl(:,:))
        h(:,:)=2.*pi*mod(hd+lon(:,:)/2./pi,1.)
        where ( h.ge.hl .and. h.lt.hc )
! Daytime
          hred=(h-hl)/(hc-hl)
          fact_OH  = fact_OH + amax1(0.,sin(pi*hred)/2.)/nstep
        elsewhere
! Nightime
          fact_NO3 = fact_NO3 + amax1(0.,amin1(1.,(1.-dayl)))/nstep
        endwhere
      enddo

      hd=amax1(0.,amin1(1.,(hour+minute/60.+second/3600.)/24.))
      hl(:,:) = pi*(1.-dayl(:,:))
      hc(:,:) = pi*(1.+dayl(:,:))
      h(:,:)=2.*pi*mod(hd+lon(:,:)/2./pi,1.)
      fac_OH(:,:)  = 0.
      fac_NO3(:,:) = 0.
      fac_HO2(:,:) = 1.
      where ( h.ge.hl .and. h.lt.hc )
! Daytime
          fac_NO3 = 0.
          hred=(h-hl)/(hc-hl)
          fac_OH  = amax1(0.,sin(pi*hred)/2.)/fact_OH
      elsewhere
! Nightime
          fac_NO3 = amax1(0.,amin1(1.,(1.-dayl)))/fact_NO3
          fac_OH  = 0.
      endwhere


! < Factor to convert AIRDEN from kgair/m3 to molecules/cm3: >
      f  = 1000. / WTMAIR * 6.022e23 * 1.e-6

      do k = 1, kd
      do j = 1, jd
      do i = 1, id
       tk    = temp(i,j,k)
       rho_air = pfull(i,j,k)/tk/RDGAS             ! Air density [kg/m3]
       xhnm  = rho_air * f
       O2    = xhnm * 0.21
       xlwc  = lwc(i,j,k)*rho_air *1.e-3
       DMS_0 = max(0.,DMS(i,j,k))
       MSA_0 = max(0.,MSA(i,j,k))
       SO4_0 = max(0.,SO4(i,j,k))
       SO2_0 = max(0.,SO2(i,j,k))
       H2O2_0= max(0.,H2O2(i,j,k))
       xSO2  = SO2_0
       xSO4  = SO4_0
       xH2O2 = H2O2_0
       xDMS  = DMS_0
       xMSA  = MSA_0
       xph   = max(1.e-7,       pH(i,j,k))
       xoh   = max(0.         , OH_conc(i,j,k)  *fac_OH(i,j))
       xho2  = max(0.         , HO2_conc(i,j,k) *fac_HO2(i,j))
       xjh2o2= max(0.         , jH2O2(i,j,k)    *fac_OH(i,j))
       xno3  = max(0.         , NO3_conc(i,j,k) *fac_NO3(i,j))
       xo3   = max(small_value, O3_mmr(i,j,k))
       oh_diurnal(i,j,k)=xoh
       oh_vmr(i,j,k)=xoh/xhnm
       no3_diurnal(i,j,k)=xno3
       ho2_diurnal(i,j,k)=xho2
       jh2o2_diurnal(i,j,k)=xjh2o2
! ****************************************************************************
! *  H2O2 production by HO2 + HO2 reactions
! ****************************************************************************
       PH2O2=(2.2e-13*exp(619./tk)+xhnm*1.9e-33*exp(980./tk))* xHO2**2 /xhnm
! ****************************************************************************
! *  H2O2 loss by OH and photodissociation
! ****************************************************************************
       LH2O2= ( 2.9e-12*exp(-160./tk)* xOH + xjH2O2 )
       if (LH2O2 .gt. 0.) then
         xH2O2= H2O2_0 * exp(-LH2O2*dt) + PH2O2*(1.-exp(-LH2O2*dt))/LH2O2
       else
         xH2O2= H2O2_0 + PH2O2 * dt
       endif
! ****************************************************************************
! *  (1) DMS + OH:  RK1 - addition channel;  RK2 - abstraction channel.      *
! ****************************************************************************
       rk1 = (1.7e-42 * exp(7810./TK) * O2) /   &
              (1. + 5.5e-31 * exp(7460./TK) * O2 ) * xoh
       rk2 = 1.2e-11*exp(-260./TK) * xoh
! ****************************************************************************
! *  (2) DMS + NO3 (only happen at night):                                   *
! ****************************************************************************
!  < XNO3 fields are in molecules/cm3.        >
        rk3 = 1.9e-13 * exp(500./TK) * xno3
! ****************************************************************************
! *  Update DMS concentration after gas phase chemistry                      *
! ****************************************************************************
       LDMS = RK1 + RK2 + RK3
       if ( LDMS .gt. 0. ) then
         xDMS = DMS_0 * exp( - LDMS*dt)
       endif
! ****************************************************************************
! *  Update MSA concentration after gas phase chemistry                      *
! ****************************************************************************
       PMSA = RK1*0.25 * xDMS
       xMSA = MSA_0 + PMSA * dt
! ****************************************************************************
! *  SO2 oxydation by OH
! ****************************************************************************
       PSO2 = ( RK1*0.75 + RK2 + RK3 ) * xDMS
       rk0 = 3.0E-31 * (300./TK)**3.3
       rk1 = rk0 * xhnm / 1.5e-12
       f1 = ( 1.+ ( log10(rk1) )**2 )**(-1)
       LSO2 = ( rk0 * xhnm / (1.+ rk1) ) * 0.6**f1 * xoh
! ****************************************************************************
! *  Update SO2 concentration after gas phase chemistry                      *
! ****************************************************************************
       xSO2 = SO2_0 + dt * ( PSO2 - LSO2 * SO2_0)
       if (xSO2 .lt. 0.) then
        xSO2 = SO2_0 * exp(-LSO2*dt) + PSO2 * (1.-exp(-LSO2*dt)) / LSO2
       end if
! ****************************************************************************
! *  Update SO4 concentration after gas phase chemistry                      *
! ****************************************************************************
       xso4 = SO4_0 + LSO2*xso2 * dt
! ****************************************************************************
! < Cloud chemistry (above 258K): >
       work1 = (t0 - tk)/(tk*t0)
!-----------------------------------------------------------------------
!         ... h2o2
!-----------------------------------------------------------------------
       xk = 7.4e4   *exp( 6621.* work1 )
       xe = 2.2e-12 *exp(-3730.* work1 )
       heh2o2  = xk*(1. + xe/xph)
       px = heh2o2 * Ra * tk * xlwc
       h2o2g = xh2o2 /(1.+px) 
!-----------------------------------------------------------------------
!         ... so2
!-----------------------------------------------------------------------
       xk = 1.23   * exp(3120. * work1 )
       xe = 1.7e-2 * exp(2090. * work1 ) 
       x2 = 6.0e-8 * exp(1120. * work1 )
       heso2 = xk*(1. + xe/xph *(1. + x2/xph) ) 
!       heso2 = 1.e2 ! xk*(1. + xe/xph *(1. + x2/xph) )
       px = heso2 * Ra * tk * xlwc
       so2g = xso2/(1.+px)
!-----------------------------------------------------------------------
!         ... o3
!-----------------------------------------------------------------------
       xk = 1.15e-2 * exp( 2560. * work1 )
       heo3 = xk
       px = heo3 * Ra * tk *xlwc
       o3g = xo3 / (1.+px) 
!-----------------------------------------------
!       ... Aqueous phase reaction rates
!           SO2 + H2O2 -> SO4
!           SO2 + O3   -> SO4
!-----------------------------------------------

!------------------------------------------------------------------------
!       ... S(IV) (HSO3) + H2O2
!------------------------------------------------------------------------
            rah2o2 = 8.e4 * EXP( -3650.*work1 )  / (.1 + xph)

!------------------------------------------------------------------------
!        ... S(IV)+ O3
!------------------------------------------------------------------------
            rao3   = 4.39e11 * EXP(-4131./tk)  &
                  + 2.56e3  * EXP(-996. /tk) /xph

!-----------------------------------------------------------------
!       ... Prediction after aqueous phase
!       so4
!       When Cloud is present
!
!       S(IV) + H2O2 = S(VI)
!       S(IV) + O3   = S(VI)
!
!       reference:
!           (1) Seinfeld
!           (2) Benkovitz
!-----------------------------------------------------------------

!-----------------------------------------------------------------
!       ... S(IV) + H2O2 = S(VI)
!-----------------------------------------------------------------
       ccc1=0.
       ccc2=0.
       if( xlwc >= 1.e-8 ) then                    ! when cloud is present
               pso4a = rah2o2 * heh2o2*h2o2g  &
                             * heso2 *so2g            ! [M/s]
               pso4a = pso4a       &                    ! [M/s] =  [mole/L(w)/s]
                    * xlwc       &                    ! [mole/L(a)/s]
                    / const0     &                    ! [/L(a)/s]
                    / xhnm                            ! [mixing ratio/s]

          ccc1 = pso4a*dt
          ccc1 = max(min(ccc1,xso2,xh2o2), 0.)
          xso4 = xso4 + ccc1
          xh2o2 = max(xh2o2 - ccc1, small_value)
          xso2 =  max(xso2  - ccc1, small_value)
!          ccc1 = max(ccc1, 0.)
!          if( xh2o2 > xso2 ) then
!              if( ccc1 > xso2 ) then
!                  xso4  = xso4 + xso2
!                  xso2  = small_value
!                  xh2o2 = xh2o2 - xso2
!              else
!                  xso4  = xso4  + ccc1
!                  xh2o2 = xh2o2 - ccc1
!                  xso2  = xso2  - ccc1
!              end if
!          else
!               if( ccc1 > xh2o2 ) then
!                   xso4  = xso4 + xh2o2
!                   xso2  = xso2 - xh2o2
!                   xh2o2 = small_value
!               else
!                   xso4  = xso4  + ccc1
!                   xh2o2 = xh2o2 - ccc1
!                   xso2  = xso2  - ccc1
!               end if
!          end if


!-----------------------------------------------
!       ... S(IV) + O3 = S(VI)
!-----------------------------------------------
           pso4b = rao3 * heo3*o3g * heso2*so2g       ! [M/s]
           pso4b = pso4b        &        ! [M/s] =  [mole/L(w)/s]
                * xlwc        &        ! [mole/L(a)/s]
                / const0      &        ! [/L(a)/s]
                / xhnm                 ! [mixing ratio/s]
 
           ccc2 = pso4b*dt
            ccc2 = max(min(ccc2, xso2), 0.)               ! mozart2
            xso4 = xso4 + ccc2                           ! mozart2
            xso2 = max(xso2 - ccc2, small_value)         ! mozart2
!          ccc2 = max(ccc2, 0.)
!          if( ccc2 > xso2 ) then
!             xso4 = xso4 + xso2
!             xso2 = small_value
!          else
!             xso4 = xso4  + ccc2
!             xso2 = xso2  - ccc2
!             xso2 = max(xso2, small_value)
!          end if
       end if
       MSA_dt(i,j,k) = (xMSA-MSA_0)/dt
       DMS_dt(i,j,k) = (xDMS-DMS_0)/dt
       SO2_dt(i,j,k) = (xso2-SO2_0)/dt
       SO4_dt(i,j,k) = (xso4-SO4_0)/dt
       H2O2_dt(i,j,k)= (xh2o2-H2O2_0)/dt
       SO4_oh_prod(i,j,k)=LSO2*xso2
       SO4_o3_prod(i,j,k)=ccc2/dt
       SO4_h2o2_prod(i,j,k)=ccc1/dt
      end do
      end do
      end do
      if ( id_NO3 > 0) then
        used = send_data ( id_NO3, NO3_diurnal, &
                           diag_time,is_in=is,js_in=js,ks_in=1)
      endif
      if ( id_OH > 0) then
        used = send_data ( id_OH, OH_diurnal, &
                           diag_time, is_in=is, js_in=js,ks_in=1 )
      endif
      if ( id_HO2 > 0) then
        used = send_data ( id_HO2, HO2_diurnal, &
                           diag_time, is_in=is, js_in=js,ks_in=1 )
      endif
      if ( id_jH2O2 > 0) then
        used = send_data ( id_jH2O2, jH2O2_diurnal, &
                           diag_time, is_in=is, js_in=js,ks_in=1 )
      endif
      if (id_ph > 0) then
        used = send_data ( id_ph, ph, &
                           diag_time,is_in=is,js_in=js,ks_in=1)
      endif
      if (id_o3 > 0) then
        used = send_data ( id_o3, o3_mmr, &
                           diag_time,is_in=is,js_in=js,ks_in=1)
      endif

      if (id_SO2_chem > 0) then
        used = send_data ( id_SO2_chem, &
              SO2_dt*pwt*WTM_S/WTMAIR, diag_time,is_in=is,js_in=js,ks_in=1)
      endif

      if (id_SO4_chem > 0) then
        used = send_data ( id_SO4_chem, &
              SO4_dt*pwt*WTM_S/WTMAIR, diag_time,is_in=is,js_in=js,ks_in=1)
      endif

      if (id_SO4_oh_prod > 0) then
        used = send_data ( id_SO4_oh_prod, &
              SO4_oh_prod*pwt*WTM_S/WTMAIR, diag_time,is_in=is,js_in=js,ks_in=1)
      endif
      if (id_SO4_o3_prod > 0) then
        used = send_data ( id_SO4_o3_prod, &
              SO4_o3_prod*pwt*WTM_S/WTMAIR, diag_time,is_in=is,js_in=js,ks_in=1)
      endif
      if (id_SO4_h2o2_prod > 0) then
        used = send_data ( id_SO4_h2o2_prod, &
              SO4_h2o2_prod*pwt*WTM_S/WTMAIR, diag_time,is_in=is,js_in=js,ks_in=1)
      endif

      if (id_DMS_chem > 0) then
        used = send_data ( id_DMS_chem, &
              DMS_dt*pwt*WTM_S/WTMAIR, diag_time,is_in=is,js_in=js,ks_in=1)
      endif

      if (id_MSA_chem > 0) then
        used = send_data ( id_MSA_chem, &
              MSA_dt*pwt*WTM_S/WTMAIR, diag_time,is_in=is,js_in=js,ks_in=1)
      endif

      if (id_H2O2_chem > 0) then
        used = send_data ( id_H2O2_chem, &
              H2O2_dt*pwt, diag_time,is_in=is,js_in=js,ks_in=1)
      endif
end subroutine atmos_SOx_chem

end module atmos_sulfate_mod

module ocean_shortwave_gfdl_mod
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> A. Rosati
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> John P. Dunne
!</CONTACT>
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S. M. Griffies 
!</CONTACT>
!
!<REVIEWER EMAIL="russell.fiedler@csiro.au"> Russell Fiedler 
!</REVIEWER>
!
!<OVERVIEW>
! This module returns thickness weighted and density weighted 
! temperature tendency [deg C *m/sec *kg/m^3] from penetrative 
! shortwave heating.
!</OVERVIEW>
!
!<DESCRIPTION>
! Compute thickness and density weighted tendency [deg C *m/sec *kg/m^3]
! of temperature associated with penetrative shortwave heating in the upper
! ocean. Generally penetration is taken as a function of monthly optical 
! properties of the upper ocean, where optical properties are read 
! in from a file of climatological data or from an ecosystem model. 
!
! Presently there is account taken only of chlorophyll-a on the optical
! properties of ocean water.  Other particulates can be added so to 
! have a more complete picture of the ocean optical properties.
!
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! Jerlov (1968): Optical Oceanography, Elsevier Press
! </REFERENCE>
!
! <REFERENCE>
! Morel and Antoine (1994), Heating rate in the upper ocean 
! in relation to its bio-optical state.
! Journal of Physical Oceanography vol 24 pages 1652-1664
! </REFERENCE>
!
! <REFERENCE>
! Manizza, M., C Le Quere, A. J. Watson, and E. T. Buitenhuis (2005)
! Bio-optical feedbacks among phytoplankton, upper ocean physics and 
! sea-ice in a global model. Geophys. Res. Let. 32, L05603, 
! doi:10.1029/2004GL020778
! </REFERENCE>
!
! <REFERENCE>
! Paulson and Simpson (1977)
! Irradiance measurements in the upper ocean
! Journal of Physical Oceanography vol 7 pages 952-956
! </REFERENCE>
!
! <REFERENCE>
! Rosati and Miyakoda (1988)
! A General Circulation Model for Upper Ocean Simulation
! Journal of Physical Oceanography vol 18 pages 1601-1626.
! </REFERENCE>
!
! <NOTE>
! Optimized for vector peformance by R. Fiedler (russell.fiedler@csiro.au)
! June 2003 on the Australian NEC computer. 
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_shortwave_gfdl_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be .true. to run with module. Default is false.
!  </DATA> 
!
!  <DATA NAME="use_sw_morel_mom4p0" TYPE="logical">
!  For backward compatibility with older simulations using 
!  MOM4.0. The new subroutine removes some confusing and unnecessary
!  logic to recompute a vertical k-index.  The differences 
!  between the old and new approach are nonzero and so will
!  result in bitwise changes to the simulation, but these changes
!  are deemed to be trivial.  Default use_sw_morel_mom4p0=.false.
!  </DATA> 
!
!  <DATA NAME="read_chl" TYPE="logical">
!  If .true. then read in climatological data of chlorophyll-a.
!  </DATA> 
!
!  <DATA NAME="optics_morel_antoine" TYPE="logical">
!  For using the Morel and Antoine optics.  This was the default in 
!  MOM4.0 for use with chlorophyll data. This scheme is NOT available
!  in MOM4p1 for use with the prognostic biology models, since it has 
!  been improved by the Manizza scheme. 
!  Default optics_morel_antoine=.false.
!  </DATA> 
!
!  <DATA NAME="optics_manizza" TYPE="logical">
!  For using the Manizza optics with chlorophyll data. Note that 
!  when running with a prognostic biology model, GFDL scientists use the 
!  Manizza optics.  
!  Default optics_manizza=.false.
!  </DATA> 
!
!  <DATA NAME="sw_frac_top" TYPE="real">
!  The fraction of shortwave radiation that should be incorporated into 
!  the sw_source array at k=1.  The generic treatment in MOM is to assume
!  that shortwave radiation is already contained inside the 
!  T_prog(index_temp)%stf field. Hence, to avoid   
!  double counting, sw_frac(k=0)=sw_frac_top should=0.0.
!  If one removes shortwave from stf, then set sw_frac_top=1.0.
!  </DATA> 
!  <DATA NAME="zmax_pen" UNITS="meter" TYPE="real">
!   Maximum depth of penetration of shortwave radiation. 
!   Below this depth, shortwave penetration is exponentially 
!   small and so is ignored.  This option formerly was useful,
!   since computation of exponentials expensive.  But with more 
!   modern computers, exponentials are cheap, so the default 
!   has been changed from 200 to 1e6, making this option irrelevant.  
!   But the option remains both for legacy purposes, and for those 
!   computers where exponentials are not cheap.  
!   Default zmax_pen=1e6.  
!  </DATA>
!  <DATA NAME="chl_default" UNITS="mg/m^3" TYPE="real">
!   Default concentration chl_default=0.08 roughly yields Jerlov Type 1A optics.
!  </DATA>
!  <DATA NAME="enforce_sw_frac" TYPE="logical">
!  To ensure the shortwave fraction is monotonically decreasing with depth. 
!  Applied only if optics_morel=.true.
!  Default enforce_sw_frac=.true. 
!  </DATA> 
!  <DATA NAME="sw_morel_fixed_depths" TYPE="logical">
!  To compute penetration assuming fixed depths via Grd%zw(k) depths.
!  This is strictly incorrect when have undulating free surface and/or 
!  generatlized vertical coordinates.  This option is here for purposes
!  of legacy, as this was done in MOM4.0 versions. The default is 
!  sw_morel_fixed_depths=.false.
!  </DATA> 
!
!  <DATA NAME="override_f_vis" TYPE="logical">
!  To fix the fraction of incoming shortwave assigned to the visible at 0.57.
!  </DATA> 
!  <DATA NAME="optics_for_uniform_chl" TYPE="logical">
!  To set the coefficients for optical model assuming the chlorophyll 
!  has a uniform distribution.  
!  Default optics_for_uniform_chl=.false.
!  </DATA> 

!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging purposes.
!  </DATA> 
!</NAMELIST>

use axis_utils_mod,           only: frac_index
use constants_mod,            only: epsln, c2dbars
use diag_manager_mod,         only: register_diag_field
use field_manager_mod,        only: fm_get_index
use fms_mod,                  only: write_version_number, open_namelist_file, close_file, check_nml_error
use fms_mod,                  only: stdout, stdlog, FATAL, NOTE
use mpp_mod,                  only: input_nml_file, mpp_error, mpp_max, mpp_min
use mpp_mod,                  only: mpp_clock_id, mpp_clock_begin, mpp_clock_end
use mpp_mod,                  only: CLOCK_ROUTINE
use time_interp_external_mod, only: time_interp_external, init_external_field

use ocean_domains_mod,        only: get_local_indices
use ocean_parameters_mod,     only: cp_ocean, rho_cp, missing_value
use ocean_parameters_mod,     only: PRESSURE, PSTAR, GEOPOTENTIAL, ZSTAR 
use ocean_types_mod,          only: ocean_time_type, ocean_domain_type, ocean_grid_type
use ocean_types_mod,          only: ocean_prog_tracer_type, ocean_diag_tracer_type
use ocean_types_mod,          only: ocean_thickness_type, ocean_options_type
use ocean_workspace_mod,      only: wrk1, wrk2, wrk3, wrk4 
use ocean_util_mod,           only: diagnose_2d

implicit none

private

! for diagnostics 
integer :: id_sat_chl  =-1
integer :: id_f_vis    =-1
logical :: used

! for vertical coordinate 
integer :: vert_coordinate 

! clock ids
integer :: id_sw_morel
integer :: id_sw_morel_mom4p0

integer :: index_chl
integer :: sbc_chl
logical :: verbose_flag=.false.

#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS
  real, dimension(isd:ied,jsd:jed)      :: sw_fk_zt    ! sw (radiation) fractional decay on t grid
  real, dimension(isd:ied,jsd:jed)      :: sw_fk_zw    ! sw (radiation) fractional decay on w grid
  real, dimension(isd:ied,jsd:jed)      :: sat_chl     ! chlorophyll concentration (mg/m^3) (a proxy for color)   
  real, dimension(isd:ied,jsd:jed,0:nk) :: sw_frac_zw  ! fractional short wave radiation on w-points     
#else  
  real, allocatable, dimension(:,:)   :: sw_fk_zt    ! sw (radiation) fractional decay on t grid
  real, allocatable, dimension(:,:)   :: sw_fk_zw    ! sw (radiation) fractional decay on w grid
  real, allocatable, dimension(:,:)   :: sat_chl     ! chlorophyll concentration (mg/m^3) (a proxy for color)   
  real, allocatable, dimension(:,:,:) :: sw_frac_zw  ! fractional short wave radiation on w-points  
#endif

! coefficients for the optical model
real, dimension(6) :: V1_coef
real, dimension(6) :: V2_coef
real, dimension(6) :: Z1_coef
real, dimension(6) :: Z2_coef

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

character(len=128)  :: version='$Id: ocean_shortwave_gfdl.F90,v 20.0 2013/12/14 00:16:18 fms Exp $'
character (len=128) :: tagname = '$Name: tikal $'
character(len=48), parameter          :: mod_name = 'ocean_shortwave_gfdl_mod'

public ocean_shortwave_gfdl_init
public sw_source_gfdl
private sw_morel
private sw_morel_mom4p0

logical :: use_this_module        = .false.
logical :: use_sw_morel_mom4p0    = .false.
logical :: read_chl               = .false.
logical :: optics_morel_antoine   = .false.
logical :: optics_manizza         = .false.
logical :: module_is_initialized  = .FALSE.
logical :: debug_this_module      = .false. 
logical :: enforce_sw_frac        = .true. 
logical :: override_f_vis         = .true. 
logical :: sw_morel_fixed_depths  = .false. 
logical :: optics_for_uniform_chl = .false. 


! (mg/m^3) default concentration 0.08 roughly yields Jerlov Type 1A optics
real :: chl_default = 0.08  

! maximum depth (m) of solar penetration. 
! below, penetration is exponentially small and so is ignored
real :: zmax_pen    = 1e6

! set to 1.0 if do not have shortwave radiation inside of T_prog(index_temp)%stf.
real :: sw_frac_top = 0.0   

namelist /ocean_shortwave_gfdl_nml/ use_this_module, read_chl, chl_default,       &
                                    zmax_pen, sw_frac_top, debug_this_module,     &
                                    enforce_sw_frac, override_f_vis,              &
                                    sw_morel_fixed_depths, optics_for_uniform_chl,&
                                    optics_morel_antoine, optics_manizza  

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_shortwave_gfdl_init">
!
! <DESCRIPTION>
! Initialization for the shorwave module
! </DESCRIPTION>
  subroutine ocean_shortwave_gfdl_init(Grid, Domain, Time, ver_coordinate, Ocean_options)

    type(ocean_grid_type),     intent(in), target :: Grid
    type(ocean_domain_type),   intent(in), target :: Domain
    type(ocean_time_type),     intent(in)         :: Time
    integer,                   intent(in)         :: ver_coordinate
    type(ocean_options_type),  intent(inout)      :: Ocean_options

    integer :: unit, io_status, ierr, i, j
#ifdef MOM_STATIC_ARRAYS    
    real, dimension(isd:ied,jsd:jed)   :: chl_data
#else
    real, allocatable, dimension(:,:)  :: chl_data
#endif
  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 


    if ( module_is_initialized ) return
    
    module_is_initialized = .TRUE.
    vert_coordinate = ver_coordinate

    call write_version_number(version, tagname)

#ifdef INTERNAL_FILE_NML
    read (input_nml_file, nml=ocean_shortwave_gfdl_nml, iostat=io_status)
    ierr = check_nml_error(io_status,'ocean_shortwave_gfdl_nml')
#else
    unit = open_namelist_file()
    read(unit, ocean_shortwave_gfdl_nml,iostat=io_status)
    ierr = check_nml_error(io_status, 'ocean_shortwave_gfdl_nml')
    call close_file(unit)
#endif
    write(stdoutunit,'(/)')
    write(stdoutunit,ocean_shortwave_gfdl_nml)    
    write(stdlogunit,ocean_shortwave_gfdl_nml)

    Dom => Domain
    Grd => Grid

#ifndef MOM_STATIC_ARRAYS    
    call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
    nk = Grid%nk
#endif 
    
    if(use_this_module) then 
        call mpp_error(NOTE, '==>Note: USING shortwave_gfdl_mod.')

        if(optics_morel_antoine) then 
            Ocean_options%shortwave = 'Used GFDL shortwave penetration module & Morel-Antoine optics.'
            write(stdoutunit,'(a)') &
            '=>Note: Using shortwave penetration with GFDL formulaton & Morel-Antoine optics.'
        endif
        if(optics_manizza) then 
            Ocean_options%shortwave = 'Used GFDL shortwave penetration module with Manizza etal optics.'
            write(stdoutunit,'(a)') &
            '=>Note: Using shortwave penetration with GFDL formulaton & Manizza etal optics.'
        endif

        if(.not. optics_morel_antoine .and. .not. optics_manizza) then 
           call mpp_error(FATAL, '==>Error: Must choose an optics scheme for shortwave penetration.')
        endif 
        if(optics_morel_antoine .and. optics_manizza) then 
           call mpp_error(FATAL, '==>Error: Must choose just one optics scheme for shortwave penetration.')
        endif 

    else 
        call mpp_error(NOTE, '==>Note: NOT using shortwave_gfdl_mod.')
        Ocean_options%shortwave = 'Did NOT use any shortwave penetration option.'
        return 
    endif

    if(use_sw_morel_mom4p0) then 
        call mpp_error(NOTE, '==>Note: Using use_sw_morel_mom4p0=.true. Recommend use_sw_morel_mom4p0=.false.')
    endif

    if(optics_morel_antoine) then 

        if(enforce_sw_frac) then  
            write(stdoutunit,'(a)') &
                 '==>Note: enforce_sw_frac=.true. enforcing monotonic decrease of sw_frac with depth.'
        else 
            write(stdoutunit,'(a)') &
                 '==>Note: enforce_sw_frac=.false. non-monotonic sw_frac w/ some penetration profiles.'
        endif

        if(sw_morel_fixed_depths) then
            write(stdoutunit,'(a)') &
                 ' ==>Warning: sw_morel_fixed_depths=.true. is unsuitable for time varying thicknesses.'
            write(stdoutunit,'(a)') &
                 '             Time varying thicknesses are the norm in MOM, so recommend'
            write(stdoutunit,'(a)') &
                 '             setting sw_morel_fixed_depths=.false.  However, to reproduce MOM4.0'
            write(stdoutunit,'(a)') &
                 '             algorithm, then set sw_morel_fixed_depths=.true.' 
        endif

    endif


#ifndef MOM_STATIC_ARRAYS    
    allocate( chl_data(isd:ied,jsd:jed))
    allocate( sat_chl(isd:ied,jsd:jed))
    allocate( sw_fk_zt(isd:ied,jsd:jed))
    allocate( sw_fk_zw(isd:ied,jsd:jed))
    allocate( sw_frac_zw(isd:ied,jsd:jed,0:nk))
#endif
    chl_data(:,:)     = 0.0 
    sat_chl(:,:)      = 0.0
    sw_fk_zt(:,:)     = 0.0 
    sw_fk_zw(:,:)     = 0.0 
    sw_frac_zw(:,:,:) = 0.0

    ! set clock ids     
    id_sw_morel        = mpp_clock_id('(Ocean shortwave morel pen) '       ,grain=CLOCK_ROUTINE)
    id_sw_morel_mom4p0 = mpp_clock_id('(Ocean shortwave morel pen-mom4p0)' ,grain=CLOCK_ROUTINE)

    sat_chl(:,:)   = chl_default*Grd%tmask(:,:,1)

    index_chl = fm_get_index('/ocean_mod/diag_tracers/chl')
    
    ! for reading chlorophyll climatology data  
    if(read_chl) then 

        call mpp_error(NOTE, &
             '==>Note: Reading in chlorophyll-a from data file for shortwave penetration.')

        ! get the unit number "sbc_chl" for reading chl data 
        sbc_chl = init_external_field('INPUT/chl','chl',domain=Domain%domain2d)
        if (sbc_chl == -1) then 
            call mpp_error(FATAL, &
                 '==>Error in ocean_shortwave_gfdl_mod: failure to find sbc_chl data file')
        endif

        ! update chl in case of restart
        chl_data = 0.0
        call time_interp_external(sbc_chl, Time%model_time, chl_data, verbose=debug_this_module)
        do j=jsc,jec
           do i=isc,iec
              sat_chl(i,j) = Grd%tmask(i,j,1)*max(0.0,chl_data(i,j))
           enddo
        enddo

        id_sat_chl = register_diag_field ('ocean_model', 'sat_chl', &
             Grid%tracer_axes(1:2), Time%model_time, 'Chlorophyll', &
             'mg/m^3',missing_value=missing_value, range=(/-10.0,10.0/))

    elseif (index_chl > 0) then
        if(optics_morel_antoine) then 
            call mpp_error(FATAL, &
            '==>Error: optics_morel_antoine in ocean_shortwave_gfdl is not coded for prognostic chlorophyll.')
        endif
        call mpp_error(NOTE, &
             '==>Note: Using prognostic chlorophyll from biology module for shortwave penetration.')
    else
        call mpp_error(NOTE, &
             '==>Note: Setting chl=chl_default in shortwave_gfdl_init.')

    endif  ! endif for read_chl 


    if(sw_frac_top==0.0) then 
        write(stdoutunit,'(a)') &
             '=>Note: computing solar shortwave penetration. Assume stf has sw-radiation field'
        write(stdoutunit,'(a)') &
             '  included.  Hence, solar shortwave penetration effects placed in sw_source will '
        write(stdoutunit,'(a)') &
             '  subtract out the effects of shortwave at k=1 to avoid double-counting.'
    elseif(sw_frac_top==1.0) then 
        write(stdoutunit,'(a)') &
             '=>Note: computing solar shortwave penetration. Assume stf does not have sw-radiation'
        write(stdoutunit,'(a)') &
             ' field included.  Shortwave penetration effects are placed completely in sw_source.'
        write(stdoutunit,'(a)') &
             ' This is not the standard approach used in MOM.'
    elseif(sw_frac_top/=1.0 .and. sw_frac_top/=0.0) then 
        write(stdoutunit,'(a)') &
             '=>Note: Computing solar shortwave penetration. Assume a portion of sw-effects are'
        write(stdoutunit,'(a)') &
             '  included in stf and a portion in sw_source.  Are you sure you wish to do this?'
    endif


    if(optics_for_uniform_chl) then 

        ! Defining coefficients for optical model taken from Morel and Antoine (1994).

        if(optics_manizza) then 
            call mpp_error(FATAL, &
            '==>Error: optics_manizza in ocean_shortwave_gfdl is not coded for optics_for_uniform_chl.')
        endif

        ! These coefficients represent a uniform distribution of chlorophyll-a 
        ! through the water column. These may be more appropriate when using
        ! chl-a from surface-viewing satellite data. 
        write(stdoutunit,'(a)') &
        ' ==>Note: Setting optical model coefficients assuming uniform chl distribution.'
        V1_coef = (/0.353,  -0.047,  0.083,  0.047, -0.011, -0.009/)
        V2_coef = (/0.647,   0.047, -0.083, -0.047,  0.011,  0.009/)
        Z1_coef = (/1.662,  -0.605,  0.128, -0.033, -0.051, -0.004/)
        Z2_coef = (/8.541,  -8.924,  4.020, -0.077, -0.536,  0.055/)

    else 

        ! These coefficients represent a non-uniform distribution of chlorophyll-a 
        ! through the depth of the water column. 
        write(stdoutunit,'(a)') &
        ' ==>Note: Setting optical model coefficients assuming nonuniform chl distribution.'
        V1_coef = (/0.321,   0.008,   0.132,   0.038, -0.017,  -0.007/)
        V2_coef = (/0.679,  -0.008,  -0.132,  -0.038,  0.017,   0.007/)
        Z1_coef = (/1.540,  -0.197,   0.166,  -0.252, -0.055,   0.042/)
        Z2_coef = (/7.925,  -6.644,   3.662,  -1.815, -0.218,   0.502/)

    endif 

    id_f_vis = register_diag_field ('ocean_model', 'f_vis',           &
               Grid%tracer_axes(1:2), Time%model_time,                &
               'Fraction of incoming shortwave in the visible range', &
               'dimensionless',missing_value=missing_value, range=(/-10.0,10.0/))

end subroutine ocean_shortwave_gfdl_init
! </SUBROUTINE> NAME="ocean_shortwave_gfdl_init"


!#######################################################################
! <SUBROUTINE NAME="sw_source_gfdl">
!
! <DESCRIPTION>
! Add short wave penetrative heating to T_prog(index_temp)%th_tendency.
!
! Note that the divergence of shortwave for the first
! level "div_sw(0)" is compensating for the effect of having
! the shortwave component already included in the total
! surface tracer flux "stf(i,j,temp)"
!
! If the shortwave penetration routine is activated but Chlorophyll
! is not being read from data, then that implies that an ecological 
! model is being used to determine chlorophyll concentration.  
! In this case, the shortwave penetration is calcualted using the
! algorithm of
!
! Manizza, M., C Le Quere, A. J. Watson, and E. T. Buitenhuis (2005)
! Bio-optical feedbacks among phytoplankton, upper ocean physics and 
! sea-ice in a global model. Geophys. Res. Let. 32, L05603, 
! doi:10.1029/2004GL020778.
!
! This algorithm assumes that all infrared light is absorbed in the 
! top level.  It separates visible light into equal portions of 
! red and blue bands, treating separately absorption by water and
! chlorophyll.
!
! If the Chlorophyll is read from data, then we generally use the 
! Morel and Antoine optics scheme. Here, we take their approach 
! for computing a vertical profile based on the surface Chlorophyll. 
! However, one may also wish to use the Manizza scheme with 
! surface Chlorophyll data. In this case, we assume the surface
! Chlorophyll concentration is the same throughout the depth.
! This assumption is not generally good, but it does provide
! for a simple means of using Manizza etal scheme with Chlorophyll
! data. Note that GFDL scientists prefer Manizza etal for use with 
! prognostic 3d models.
!
! NOTE: Determine depths to T-points and W-points.
! This code is needed in particular for GEOPOTENTIAL, since
! depth_zwt and depth_zt for this coordinate do not include
! the surface height undulations. For the shortwave calculation,
! we wish to include the depth level undulations, unless enable
! sw_morel_fixed_depths=.true. 
!
! </DESCRIPTION>
subroutine sw_source_gfdl(Time, Thickness, T_diag, swflx, swflx_vis, index_irr, Temp, sw_frac_zt, opacity)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_thickness_type),     intent(in)    :: Thickness
  type(ocean_diag_tracer_type),   intent(inout) :: T_diag(:)
  real, dimension(isd:,jsd:),     intent(in)    :: swflx
  real, dimension(isd:,jsd:),     intent(in)    :: swflx_vis
  integer,                        intent(in)    :: index_irr
  type(ocean_prog_tracer_type),   intent(inout) :: Temp
  real, dimension(isd:,jsd:,:),   intent(inout) :: sw_frac_zt
  real, dimension(isd:,jsd:,:),   intent(inout) :: opacity

  real, dimension(isd:ied,jsd:jed)  :: f_vis
  real, dimension(isd:ied,jsd:jed)  :: zt_sw
  real, dimension(isd:ied,jsd:jed)  :: zw_sw
  real, dimension(isd:ied,jsd:jed)  :: chl_data

  real    :: div_sw 
  integer :: i, j, k
  integer :: tau

  ! zero out the wrk1 array used to diagnose heating from shortwave 
  Temp%wrk1(:,:,:) = 0.0

  if (.not. use_this_module) return 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL,&
    '==>Error in ocean_shortwave_gfdl_mod (sw_source_gfdl): module must be initialized ')
  endif 

  if (Temp%name /= 'temp') then 
    call mpp_error(FATAL, &
    '==>Error in ocean_shortwave_pen_mod (sw_source): invalid tracer for sw_source')
  endif 

  tau = Time%tau 

  f_vis(:,:)         = 0.0
  zt_sw(:,:)         = 0.0
  zw_sw(:,:)         = 0.0
  chl_data(:,:)      = 0.0
  sw_frac_zw(:,:,:)  = 0.0  


  ! fill sat_chl with time interpolated chlorophyll data 
  if (read_chl) then
    chl_data=0.0
    call time_interp_external(sbc_chl, Time%model_time, chl_data, verbose=debug_this_module)
    do j=jsc,jec
      do i=isc,iec
        sat_chl(i,j) = Grd%tmask(i,j,1)*max(0.0,chl_data(i,j))
      enddo
    enddo
    call diagnose_2d(Time, Grd, id_sat_chl, sat_chl(:,:))
  endif

  ! F_vis is the amount of light in the shortwave verses the long wave. 
  ! F_vis=0.54 on sunny days and F_vis=0.60 on cloudy days. 
  ! In the GFDL atmospheric model, F_vis varies much more than 
  ! 0.54 <= F_vis <= 0.60.  So it is useful to include it explicitly
  ! in this module for those cases when using a realistic atmospheric
  ! radiation module.  Otherwise, we set f_vis=0.57
  if(override_f_vis) then
     do j=jsc,jec
       do i=isc,iec
       f_vis(i,j) = 0.57
      enddo
    enddo
  else

    !Use max() to ensure f_vis > 0
    do j=jsc,jec
      do i=isc,iec
        f_vis(i,j) = max(swflx_vis(i,j)/(epsln + swflx(i,j)),epsln) 
      enddo
    enddo

  endif
  call diagnose_2d(Time, Grd, id_f_vis, f_vis(:,:))

  ! zero out the fractional decay 
  sw_fk_zt(:,:) = 0.0
  sw_fk_zw(:,:) = 0.0

  ! only compute 3-D sw_fract for ocean regions shallower than zmax_pen 
  zw_sw=0.0
  zt_sw=0.0
  sw_frac_zw(:,:,0) = sw_frac_top


  ! for reading chlorophyll from data and using optics_morel_antoine
  if (read_chl .and. optics_morel_antoine) then

      ! determine depths to T-points and W-points
      wrk3(:,:,:) = 0.0
      wrk4(:,:,:) = 0.0
      if(vert_coordinate==GEOPOTENTIAL) then 
          do j=jsd,jed
             do i=isd,ied
                wrk3(i,j,1) = Thickness%dzwt(i,j,0)
                wrk4(i,j,1) = Thickness%dzt(i,j,1)
             enddo
          enddo
          do k=2,nk
             do j=jsd,jed
                do i=isd,ied
                   wrk3(i,j,k) = wrk3(i,j,k-1) + Thickness%dzwt(i,j,k-1)
                   wrk4(i,j,k) = wrk4(i,j,k-1) + Thickness%dzt(i,j,k)
                enddo
             enddo
          enddo
      else 
          do k=1,nk
             do j=jsd,jed
                do i=isd,ied
                   wrk3(i,j,k) = Thickness%depth_zt(i,j,k)
                   wrk4(i,j,k) = Thickness%depth_zwt(i,j,k)
                enddo
             enddo
          enddo
      endif

      ! for using the older mom4p0 sw_morel (not recommended)
      if(use_sw_morel_mom4p0) then 

          do k=1,nk-1
             if(sw_morel_fixed_depths) then 
                 if(Grd%zw(k) <= zmax_pen) then 
                     zw_sw(isc:iec,jsc:jec) = Grd%zw(k)
                     call sw_morel_mom4p0(T_diag, zw_sw, f_vis, sw_fk_zw)
                     zt_sw(isc:iec,jsc:jec) = Grd%zt(k)
                     call sw_morel_mom4p0(T_diag, zt_sw, f_vis, sw_fk_zt)
                 else
                     sw_fk_zt(:,:) = 0.0
                     sw_fk_zw(:,:) = 0.0
                 endif
             else
                 do j=jsc,jec
                    do i=isc,iec
                       zw_sw(i,j) = wrk4(i,j,k)
                       zt_sw(i,j) = wrk3(i,j,k)
                    enddo
                 enddo
                 call sw_morel_mom4p0(T_diag, zw_sw, f_vis, sw_fk_zw)
                 call sw_morel_mom4p0(T_diag, zt_sw, f_vis, sw_fk_zt)  
             endif
             sw_frac_zt(:,:,k) = sw_fk_zt(:,:)
             sw_frac_zw(:,:,k) = sw_fk_zw(:,:)
          enddo

      else 

          do k=1,nk-1
             if(sw_morel_fixed_depths) then 
                 if(Grd%zw(k) <= zmax_pen) then 
                     zw_sw(isc:iec,jsc:jec) = Grd%zw(k)
                     call sw_morel(T_diag, zw_sw, f_vis, sw_fk_zw, k)
                     zt_sw(isc:iec,jsc:jec) = Grd%zt(k)
                     call sw_morel(T_diag, zt_sw, f_vis, sw_fk_zt, k)
                 else
                     sw_fk_zt(:,:) = 0.0
                     sw_fk_zw(:,:) = 0.0
                 endif
             else
                 do j=jsc,jec
                    do i=isc,iec
                       zw_sw(i,j) = wrk4(i,j,k)
                       zt_sw(i,j) = wrk3(i,j,k)
                    enddo
                 enddo
                 call sw_morel(T_diag, zw_sw, f_vis, sw_fk_zw, k)
                 call sw_morel(T_diag, zt_sw, f_vis, sw_fk_zt, k)  
             endif
             sw_frac_zt(:,:,k) = sw_fk_zt(:,:)
             sw_frac_zw(:,:,k) = sw_fk_zw(:,:)
          enddo

      endif  ! endif for use_sw_morel_mom4p0


      if(enforce_sw_frac) then   
          do k=2,nk-1
             do j=jsc,jec
                do i=isc,iec
                   sw_frac_zt(i,j,k) = min(sw_frac_zt(i,j,k),sw_frac_zt(i,j,k-1))
                enddo
             enddo
          enddo
      endif

  endif  ! endif for (read_chl .and. optics_morel_antoine)


  ! choose the Manizza etal optics for computing shortwave penetration 
  if (optics_manizza) then


      ! for restart reproducibility, need to use time
      ! independent depth_swt array.  more accurate is to use 
      ! depth_zwt, but use of depth_zwt breaks restart 
      ! reproducibility.   
      if(vert_coordinate==PRESSURE .or. vert_coordinate==PSTAR) then 
          do k=1,nk
             do j=jsd,jed
                do i=isd,ied
                   wrk4(i,j,k) = Thickness%depth_swt(i,j,k)*c2dbars
                enddo
             enddo
          enddo
      elseif(vert_coordinate==GEOPOTENTIAL .or. vert_coordinate==ZSTAR) then 
          do k=1,nk
             do j=jsd,jed
                do i=isd,ied
                   wrk4(i,j,k) = Thickness%depth_swt(i,j,k)
                enddo
             enddo
          enddo
      else 
          do k=1,nk
             do j=jsd,jed
                do i=isd,ied
                   wrk4(i,j,k) = Thickness%depth_zwt(i,j,k)
                enddo
             enddo
          enddo
      endif


      ! wrk3 will contain the chl concentration array 
      wrk3(:,:,:) = 0.0

      ! assume chl data to be constant with depth (not always a good assumption)
      if(read_chl) then 
          do k=1,nk-1
             do j=jsc,jec
                do i=isc,iec
                   wrk3(i,j,k) = sat_chl(i,j)
                enddo
             enddo
          enddo

      ! take chl from prognostic 3d ecosystem model 
      else 
          do k=1,nk-1
             do j=jsc,jec
                do i=isc,iec
                   wrk3(i,j,k) = T_diag(index_chl)%field(i,j,k)
                enddo
             enddo
          enddo
      endif

      wrk1(:,:,:) = 0.0  ! temporary for red_frac_zw
      wrk2(:,:,:) = 0.0  ! temporary for blu_frac_zw

      ! compute shortwave penetration using Manizza etal optics 
      do j=jsc,jec
         do i=isc,iec
            if (Grd%tmask(i,j,1) > 0.0) then

                k=1
                wrk1(i,j,k) =                                  &
                     0.5*exp(-Thickness%dzt(i,j,k)*(0.225+0.037*wrk3(i,j,k)**0.629))
                wrk2(i,j,k) =                                  &
                     0.5*exp(-Thickness%dzt(i,j,k)*(0.0232+0.074*wrk3(i,j,k)**0.674))
                sw_frac_zw(i,j,k) = f_vis(i,j)*(wrk1(i,j,k) + wrk2(i,j,k))
                sw_frac_zt(i,j,k) = 0.5*(f_vis(i,j) + sw_frac_zw(i,j,1))

                do k=2,nk-1
                   if (wrk4(i,j,k) < zmax_pen) then
                       wrk1(i,j,k) = wrk1(i,j,k-1) &
                            *exp(-Thickness%dzt(i,j,k)*(0.2250+0.037*wrk3(i,j,k)**0.629))
                       wrk2(i,j,k) = wrk2(i,j,k-1) &
                            *exp(-Thickness%dzt(i,j,k)*(0.0232+0.074*wrk3(i,j,k)**0.674))
                       sw_frac_zw(i,j,k)  = f_vis(i,j)*(wrk1(i,j,k) + wrk2(i,j,k))
                       sw_frac_zt(i,j,k)  = &
                            0.5*(sw_frac_zw(i,j,k-1) + sw_frac_zw(i,j,k))
                   endif
                enddo

            endif
         enddo
      enddo

  endif  ! endif for optics_manizza

  
  ! when chlorophyll is being read through T_diag (not from climatology).
  ! note that this irradiance tracer is only used in MOM for purpose of 
  ! diagnostics, such as in in the residency time module.  It is NOT used
  ! by the ocean biogeochemistry, which actually computes its own irradiance
  ! as a function of the opacity.  
  if (index_irr > 0) then 
      do k=1,nk-1
         do j=jsc,jec
            do i=isc,iec
               T_diag(index_irr)%field(i,j,k) = swflx(i,j) * sw_frac_zt(i,j,k) 
            enddo
         enddo
      enddo
  endif

  ! compute and load heating rate, to be added to   
  ! Temp%th_tendency inside ocean_shortwave.F90. 
  do k=1,nk-1
     do j=jsc,jec
        do i=isc,iec           
           div_sw           = sw_frac_zw(i,j,k-1) - sw_frac_zw(i,j,k)*Grd%tmask(i,j,k+1)
           Temp%wrk1(i,j,k) = Grd%tmask(i,j,k)*swflx(i,j)*div_sw
        enddo
     enddo
  enddo

  ! Compute opacity, which is used by biogeochemistry. 
  ! We split off the k=1 level, since sw_frac_zw(k=0)=sw_frac_top,
  ! which is typically set to sw_frac_top=0.0 for purposes of 
  ! accounting (as swflx is also in stf(index_temp). A value 
  ! of sw_frac_zw(k=0)=0.0 to compute opacity would result in a
  ! negative opacity at k=1, which is not physical. Instead, for 
  ! purposes of opacity calculation, we need sw_frac_zw(k=0)=1.0. 
  k=1
  do j=jsc,jec
     do i=isc,iec           
        opacity(i,j,k) = -log( sw_frac_zw(i,j,k)/(f_vis(i,j)+epsln) + epsln) &
                          /(Thickness%dzt(i,j,k) + epsln)
     enddo
  enddo
  do k=2,nk-1
     do j=jsc,jec
        do i=isc,iec           
           opacity(i,j,k) = -log( sw_frac_zw(i,j,k)/(sw_frac_zw(i,j,k-1)+epsln) + epsln) &
                             /(Thickness%dzt(i,j,k) + epsln)
        enddo
     enddo
  enddo


end subroutine sw_source_gfdl
! </SUBROUTINE> NAME="sw_source_gfdl"


!#######################################################################
! <SUBROUTINE NAME="sw_morel">
!
! <DESCRIPTION>
!  Solar shortwave energy penetrates below the ocean surface and is aborbed 
!  by water and organic matter (both particulate and dissolved). This
!  routine estimates fraction of shortwave penetration using chlorophyll-a.
!  Absorbtion of shortwave radiation in the water assumes energy partitions
!  between three exponentials:
!
!  The first exponential is for wavelength > 0.75 um (microns) and assumes a
!  single attenuation of 0.267 m if the "zenith_angle" is 0.  Presently the 
!  code assumes a zero zenith angle, but this could be modified easily. 
!
!  The second and third exponentials represent a parameterization of the
!  attenuation coeficient for light between 300 um and 750 um in the following
!  form:
!
!	E(z) = E(0) * [V1 *  exp(z/efold1) + V2 * exp(z/efold2)]
!       with z < 0 the ocean depth 
!
!  Here, V1+V2=1 represent the partitioning between long (V1) and short (V2)
!  wavelengths between 300 um and 750 um. Thoughout most of the ocean V1<0.5
!  and V2>0.5. The "efold1" and "efold2" are the efolding depth of the long and short
!  visable and ultra violet light. Throughout most of the ocean efold1 should not exceed 3 m
!  while the efold2 will vary between 30 m in oligotrophic waters and 4 m in coastal
!  regions. All of these constants are based on satellite estimates of chlorophyll a and
!  taken from Morel and Antoine (JPO 1994, (24) 1652-1664).
!
!  If the thickness of the first ocean level "dzt(1)" is 50 meters,
!  then shortwave penetration does not do much. However, for higher
!  vertical resolution, such as dzt(1) = 10 meters commonly used
!  in ocean climate models, the effect of shortwave heating can
!  be significant. This can be particularly noticable in the summer
!  hemisphere.
!
! </DESCRIPTION>
!
! <INFO>
!
! <NOTE>
!  The terms contributing to sw_fk(i,j) are depth independent
!  when chl is depth independent.  However, we anticipate implementing 
!  a biological model, whereby chl will be depth dependent.  
! </NOTE> 
!
! <NOTE>
!  Simpson and Dickey (1981) and others have argued between one and 
!  two exponentials for light between 300 um and 750 um.  
!  With vertical grid resolution of 5 meters or finer
!  for the upper 20 meters, the second exponential will make a difference.
!  We anticipate using such resolutions, and so have implemented both 
!  exponentials. 
! </NOTE> 
!
! </INFO>
!
subroutine sw_morel (T_diag, z_sw, f_vis, sw_fk, ksw)

  type(ocean_diag_tracer_type), dimension(:), intent(in)    :: T_diag
  real, dimension(isd:,jsd:),                 intent(in)    :: z_sw     ! vertical depth
  real, dimension(isd:,jsd:),                 intent(in)    :: f_vis    ! fraction of incoming sw that is visible
  real, dimension(isd:,jsd:),                 intent(inout) :: sw_fk    ! sw fractional decay
  integer,                                    intent(in)    :: ksw      ! index of the k-level 

  ! parameters for optical model using C=log10(chl)
  real    :: V1, V2, efold1, efold2 
  real    :: C, C2, C3, C4, C5
  real    :: zenith_angle
  real    :: swmax, swmin, chmax, chmin

  integer :: i, j, kswp1

  integer :: stdoutunit 
  stdoutunit=stdout() 

  call mpp_clock_begin(id_sw_morel)  

  if(.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_shortwave_gfdl_mod (sw_morel): module must be initialized')
  endif 

  zenith_angle = 0.0
  kswp1 = min(ksw+1,nk)

  ! compute shortwave fraction based on triple exponential 
  ! note that 0.02 and 60.0 provide a floor and ceiling which 
  ! keep sw_fk between 0.0 and 1.0.  These values are dependent
  ! on details of the coefficients used in the exponential. 
  ! If the coefficients change, then the floor/ceiling needs 
  ! to be reevaluated. shortwave fraction set to zero for 
  ! depths greater than zmax_pen.
  do j=jsc,jec
     do i=isc,iec

        if ( z_sw(i,j) > zmax_pen .or. Grd%tmask(i,j,kswp1) == 0.0) then
            sw_fk(i,j) = 0.0

        else

            if (.not. read_chl .and. index_chl .gt. 0) then      
              ! chlorophyll-a from biology.
              C = log10(min(max(T_diag(index_chl)%field(i,j,ksw),0.02),60.0))
            else
              ! chlorophyll-a read from climatology
              C = log10(min(max(sat_chl(i,j),0.02),60.0))
            endif
            C2 = C  * C
            C3 = C2 * C
            C4 = C3 * C
            C5 = C4 * C
            V1 = V1_coef(1) + V1_coef(2) * C + V1_coef(3) * C2  &
                 + V1_coef(4) * C3 + V1_coef(5) * C4 + V1_coef(6) * C5
            V2 = V2_coef(1) + V2_coef(2) * C + V2_coef(3) * C2  &
                 + V2_coef(4) * C3 + V2_coef(5) * C4 + V2_coef(6) * C5
            efold1 = Z1_coef(1) + Z1_coef(2) * C + Z1_coef(3) * C**2  &
                 + Z1_coef(4) * C3 + Z1_coef(5) * C4 + Z1_coef(6) * C5
            efold2 = Z2_coef(1) + Z2_coef(2) * C + Z2_coef(3) * C**2  &
                 + Z2_coef(4) * C3 + Z2_coef(5) * C4 + Z2_coef(6) * C5

            sw_fk(i,j) = (1-f_vis(i,j)) * exp( -z_sw(i,j)/(0.267 * cos(zenith_angle)) )   &
                 + f_vis(i,j)  * ( V1 * exp( -z_sw(i,j)/efold1 )                 &
                 + V2 * exp( -z_sw(i,j)/efold2 ) )

        endif

     enddo  ! i-loop finish 
  enddo  ! j-loop finish

  if(debug_this_module) then 
      swmax=maxval(sw_fk(isc:iec,jsc:jec))
      call mpp_max(swmax);write(stdoutunit,*)'In ocean_shortwave_gfdl (sw_morel): max sw_fk=',swmax
      swmin=minval(sw_fk(isc:iec,jsc:jec))
      call mpp_min(swmin);write(stdoutunit,*)'In ocean_shortwave_gfdl (sw_morel): min sw_fk=',swmin
      if (index_chl .le. 0) then
        chmax=maxval(sat_chl(isc:iec,jsc:jec))
        call mpp_max(chmax);write(stdoutunit,*)'In ocean_shortwave_gfdl (sw_morel): max chl=',chmax
        chmin=minval(sat_chl(isc:iec,jsc:jec)) 
        call mpp_min(chmin);write(stdoutunit,*)'In ocean_shortwave_gfdl (sw_morel): min chl=',chmin
      endif
  endif
  call mpp_clock_end(id_sw_morel)

end subroutine sw_morel
! </SUBROUTINE> NAME="sw_morel"



!#######################################################################
! <SUBROUTINE NAME="sw_morel_mom4p0">
!
! <DESCRIPTION>
! As in sw_morel, but uses the MOM4.0 algorithm to re-compute a k-level. 
! The recomputation is not needed, it can be costly, and produces
! no physically significant differences.  This routine is 
! retained for legacy only and it is not otherwise recommended.  
! </DESCRIPTION>
!
subroutine sw_morel_mom4p0 (T_diag, z_sw, f_vis, sw_fk)

  type(ocean_diag_tracer_type), dimension(:), intent(in)    :: T_diag
  real, dimension(isd:,jsd:),                 intent(in)    :: z_sw     ! vertical depth
  real, dimension(isd:,jsd:),                 intent(in)    :: f_vis    ! fraction of incoming sw that is visible
  real, dimension(isd:,jsd:),                 intent(inout) :: sw_fk    ! sw fractional decay

  ! flag for setting k of bottom of boundary layer           
  logical :: keep_going(isc:iec)                            
  ! introducing kb as 1d vector improves vector performance  
  integer, dimension(isc:iec) :: kb   
  integer, dimension(isc:iec) :: kb_old   

  ! parameters for optical model using C=log10(chl)
  real    :: V1, V2, efold1, efold2 
  real    :: C, C2, C3, C4, C5
  real    :: zenith_angle
  real    :: swmax, swmin, chmax, chmin

  integer :: i, j, k

  integer :: stdoutunit 
  stdoutunit=stdout() 

  call mpp_clock_begin(id_sw_morel_mom4p0)  

  if(.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_shortwave_gfdl_mod (sw_morel_mom4p0): module must be initialized')
  endif 

  zenith_angle = 0.0


  ! compute shortwave fraction based on triple exponential 
  ! note that 0.02 and 60.0 provide a floor and ceiling which 
  ! keep sw_fk between 0.0 and 1.0.  These values are dependent
  ! on details of the coefficients used in the exponential. 
  ! If the coefficients change, then the floor/ceiling needs 
  ! to be reevaluated. shortwave fraction set to zero for 
  ! depths greater than zmax_pen.

  do j=jsc,jec

     ! compute kb 
     ! (this is the irrelevant part of this subroutine)
     k = 0
     kb(:)=nk                                   
     keep_going(:) = .true.
     do while (k < nk .and. any(keep_going(:))) 
        k = k+1
        do  i=isc,iec
           if (z_sw(i,j) <= Grd%zw(k) .and.  keep_going(i)) then   
               kb(i) = k
               keep_going(i) = .false.
           endif
        enddo
     enddo
     do i=isc,iec
       kb(i)=min(kb(i)+1,nk)
     enddo

     ! check with older (non-vectorized) method for kb calculation
     if(debug_this_module) then 
         do i=isc,iec 
            kb_old(i) = ceiling(frac_index(z_sw(i,j), (/0.,Grd%zw(1:nk)/)))
            kb_old(i) = min(kb_old(i),nk)
         enddo
         do i=isc,iec 
            if(kb(i) - kb_old(i) /= 0) then 
                write(stdoutunit,*) &
                'In sw_morel, kb computed two ways: kbnew(',i+Dom%ioff,',',j+Dom%joff,')= ', kb(i), &
                                  ' kbold(',i+Dom%ioff,',',j+Dom%joff,')= ',kb_old(i)
            endif
         enddo
     endif

     do i=isc,iec

        if ( z_sw(i,j) > zmax_pen .or. Grd%tmask(i,j,kb(i)) == 0) then
            sw_fk(i,j) = 0.0
        else

            if (.not. read_chl .and. index_chl .gt. 0) then      ! chlorophyll-a from biology.
              C = log10(min(max(T_diag(index_chl)%field(i,j,kb(i)),0.02),60.0))
            else                                                 ! chlorophyll-a read from climatology
              C = log10(min(max(sat_chl(i,j),0.02),60.0))
            endif
            C2 = C  * C
            C3 = C2 * C
            C4 = C3 * C
            C5 = C4 * C
            V1 = V1_coef(1) + V1_coef(2) * C + V1_coef(3) * C2  &
                 + V1_coef(4) * C3 + V1_coef(5) * C4 + V1_coef(6) * C5
            V2 = V2_coef(1) + V2_coef(2) * C + V2_coef(3) * C2  &
                 + V2_coef(4) * C3 + V2_coef(5) * C4 + V2_coef(6) * C5
            efold1 = Z1_coef(1) + Z1_coef(2) * C + Z1_coef(3) * C**2  &
                 + Z1_coef(4) * C3 + Z1_coef(5) * C4 + Z1_coef(6) * C5
            efold2 = Z2_coef(1) + Z2_coef(2) * C + Z2_coef(3) * C**2  &
                 + Z2_coef(4) * C3 + Z2_coef(5) * C4 + Z2_coef(6) * C5

            sw_fk(i,j) = (1-f_vis(i,j)) * exp( -z_sw(i,j)/(0.267 * cos(zenith_angle)) )   &
                 + f_vis(i,j)  * ( V1 * exp( -z_sw(i,j)/efold1 )                 &
                 + V2 * exp( -z_sw(i,j)/efold2 ) )
        endif

     enddo  ! i-loop finish 

  enddo  ! j-loop finish

  if(debug_this_module) then 
      swmax=maxval(sw_fk(isc:iec,jsc:jec))
      call mpp_max(swmax);write(stdoutunit,*)'In ocean_shortwave_gfdl (sw_morel): max sw_fk=',swmax
      swmin=minval(sw_fk(isc:iec,jsc:jec))
      call mpp_min(swmin);write(stdoutunit,*)'In ocean_shortwave_gfdl (sw_morel): min sw_fk=',swmin
      if (index_chl .le. 0) then
        chmax=maxval(sat_chl(isc:iec,jsc:jec))
        call mpp_max(chmax);write(stdoutunit,*)'In ocean_shortwave_gfdl (sw_morel): max chl=',chmax
        chmin=minval(sat_chl(isc:iec,jsc:jec)) 
        call mpp_min(chmin);write(stdoutunit,*)'In ocean_shortwave_gfdl (sw_morel): min chl=',chmin
      endif
  endif
  call mpp_clock_end(id_sw_morel_mom4p0)

end subroutine sw_morel_mom4p0
! </SUBROUTINE> NAME="sw_morel_mom4p0"


end module ocean_shortwave_gfdl_mod

module vegn_tile_mod

use fms_mod, only : &
     write_version_number, stdlog, error_mesg, FATAL
use constants_mod, only : &
     tfreeze, hlf

use land_constants_mod, only : NBANDS
use land_io_mod, only : &
     init_cover_field
use land_tile_selectors_mod, only : &
     tile_selector_type, SEL_VEGN

use vegn_data_mod, only : &
     NSPECIES, MSPECIES, NCMPT, C2B, &
     read_vegn_data_namelist, spdata, &
     vegn_to_use,  input_cover_types, &
     mcv_min, mcv_lai, &
     vegn_index_constant, &
     agf_bs, BSEED, LU_NTRL, LU_SCND, N_HARV_POOLS, &
     LU_SEL_TAG, SP_SEL_TAG, NG_SEL_TAG, &
     SP_C3GRASS, SP_C4GRASS, &
     scnd_biomass_bins

use vegn_cohort_mod, only : vegn_cohort_type, vegn_phys_prog_type, &
     height_from_biomass, lai_from_biomass, update_bio_living_fraction, &
     cohort_uptake_profile, cohort_root_properties, update_biomass_pools

implicit none
private

! ==== public interfaces =====================================================
public :: vegn_tile_type

public :: new_vegn_tile, delete_vegn_tile
public :: vegn_tiles_can_be_merged, merge_vegn_tiles
public :: vegn_is_selected
public :: get_vegn_tile_tag
public :: vegn_tile_stock_pe
public :: vegn_tile_carbon ! returns total carbon per tile
public :: vegn_tile_heat ! returns hate content of the vegetation

public :: read_vegn_data_namelist
public :: vegn_cover_cold_start

public :: vegn_uptake_profile
public :: vegn_root_properties
public :: vegn_data_rs_min
public :: vegn_seed_supply
public :: vegn_seed_demand

public :: vegn_tran_priority ! returns transition priority for land use 

public :: vegn_add_bliving
public :: update_derived_vegn_data  ! given state variables, calculate derived values
! =====end of public interfaces ==============================================
interface new_vegn_tile
   module procedure vegn_tile_ctor
   module procedure vegn_tile_copy_ctor
end interface


! ==== module constants ======================================================
character(len=*), parameter   :: &
     version = '$Id: vegn_tile.F90,v 20.0 2013/12/13 23:31:19 fms Exp $', & 
     tagname = '$Name: tikal $', &
     module_name = 'vegn_tile_mod'

! ==== types =================================================================
type :: vegn_tile_type
   integer :: tag ! kind of the tile
   integer :: landuse = LU_NTRL

   integer :: n_cohorts = 0
   type(vegn_cohort_type), pointer :: cohorts(:)=>NULL()

   real :: age=0.0 ! tile age

   ! fields for smoothing out the contribution of the spike-type processes (e.g. 
   ! harvesting) to the soil carbon pools over some period of time
   real :: fsc_pool=0.0, fsc_rate=0.0 ! for fast soil carbon
   real :: ssc_pool=0.0, ssc_rate=0.0 ! for slow soil carbon

   real :: csmoke_pool=0.0 ! carbon lost through fires, kg C/m2 
   real :: csmoke_rate=0.0 ! rate of release of the above to atmosphere, kg C/(m2 yr)

   real :: harv_pool(N_HARV_POOLS) = 0.0 ! pools of harvested carbon, kg C/m2
   real :: harv_rate(N_HARV_POOLS) = 0.0 ! rates of spending (release to the atmosphere), kg C/(m2 yr)

   ! values for the diagnostic of carbon budget and soil carbon acceleration
   real :: ssc_out=0.0
   real :: fsc_out=0.0
   real :: veg_in=0.0, veg_out=0.0

   real :: disturbance_rate(0:1) = 0 ! 1/year
   real :: lambda = 0.0 ! cumulative drought months per year
   real :: fuel   = 0.0 ! fuel over dry months
   real :: litter = 0.0 ! litter flux

   ! monthly accumulated/averaged values
   real :: theta_av_phen = 0.0 ! relative soil_moisture availability not soil moisture
   real :: theta_av_fire = 0.0
   real :: psist_av = 0.0 ! soil water stress index
   real :: tsoil_av = 0.0 ! bulk soil temperature
   real :: tc_av    = 0.0 ! leaf temperature
   real :: precip_av= 0.0 ! precipitation

   ! accumulation counters for long-term averages (monthly and annual). Having
   ! these counters in the tile is a bit stupid, since the values are the same for
   ! each tile, but it simplifies the current code, and they are going away when we
   ! switch to exponential averaging in any case.
   integer :: n_accum = 0 ! number of accumulated values for monthly averages
   integer :: nmn_acm = 0 ! number of accumulated values for annual averages
   ! annual-mean values
   real :: t_ann  = 0.0 ! annual mean T, degK
   real :: t_cold = 0.0 ! average temperature of the coldest month, degK
   real :: p_ann  = 0.0 ! annual mean precip
   real :: ncm    = 0.0 ! number of cold months
   ! annual accumulated values
   real :: t_ann_acm  = 0.0 ! accumulated annual temperature for t_ann
   real :: t_cold_acm = 0.0 ! temperature of the coldest month in current year
   real :: p_ann_acm  = 0.0 ! accumulated annual precipitation for p_ann
   real :: ncm_acm    = 0.0 ! accumulated number of cold months


   ! it's probably possible to get rid of the fields below
   real :: npp=0.0 ! net primary productivity
   real :: nep=0.0 ! net ecosystem productivity
   real :: rh=0.0 ! soil carbon lost to the atmosphere
   real :: total_biomass !
   real :: area_disturbed_by_treefall
   real :: area_disturbed_by_fire
   real :: total_disturbance_rate
end type vegn_tile_type

! ==== module data ===========================================================
real, public :: &
     cpw = 1952.0, & ! specific heat of water vapor at constant pressure
     clw = 4218.0, & ! specific heat of water (liquid)
     csw = 2106.0    ! specific heat of water (ice)

contains ! -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-


! ============================================================================
function vegn_tile_ctor(tag) result(ptr)
  type(vegn_tile_type), pointer :: ptr ! return value
  integer, intent(in)  :: tag ! kind of tile

  allocate(ptr)
  ptr%tag = tag
end function vegn_tile_ctor

! ============================================================================
function vegn_tile_copy_ctor(vegn) result(ptr)
  type(vegn_tile_type), pointer :: ptr ! return value
  type(vegn_tile_type), intent(in) :: vegn ! return value

  allocate(ptr)
  ! copy all non-pointer members
  ptr=vegn
  ! copy pointer members (cohorts)
  allocate(ptr%cohorts(ptr%n_cohorts))
  ptr%cohorts(:) = vegn%cohorts(1:ptr%n_cohorts)
end function vegn_tile_copy_ctor

! ============================================================================
subroutine delete_vegn_tile(vegn)
  type(vegn_tile_type), pointer :: vegn

  deallocate(vegn%cohorts)
  deallocate(vegn)
end subroutine delete_vegn_tile

! =============================================================================
function vegn_tiles_can_be_merged(vegn1,vegn2) result(response)
  logical :: response
  type(vegn_tile_type), intent(in) :: vegn1,vegn2

  real    :: b1, b2 
  integer :: i, i1, i2

  if (vegn1%landuse /= vegn2%landuse) then
     response = .false. ! different land use types can't be merged
  else if (vegn1%landuse == LU_SCND) then ! secondary vegetation tiles
     ! get tile wood biomasses
     b1 = get_vegn_tile_bwood(vegn1)
     b2 = get_vegn_tile_bwood(vegn2)
     ! find biomass bins where each the tiles belongs to
     i1 = 0 ; i2 = 0
     do i = 1, size(scnd_biomass_bins(:))
        if (b1>scnd_biomass_bins(i)) i1 = i
        if (b2>scnd_biomass_bins(i)) i2 = i
     enddo
     ! tiles can be merged only if biomasses belong to the same bin
     response = (i1 == i2)
  else
     response = .true. ! non-secondary tiles of the same land use type can always be merged
  endif
end function


! ============================================================================
subroutine merge_vegn_tiles(t1,w1,t2,w2)
  type(vegn_tile_type), intent(in) :: t1
  type(vegn_tile_type), intent(inout) :: t2
  real, intent(in) :: w1, w2 ! relative weights
  
  ! ---- local vars
  real :: x1, x2 ! normalized relative weights
  real :: HEAT1, HEAT2 ! heat stored in respective canopies
  type(vegn_cohort_type), pointer :: c1, c2
  
  ! calculate normalized weights
  x1 = w1/(w1+w2)
  x2 = 1.0 - x1

  ! the following assumes that there is one, and only one, cohort per tile 
  c1 => t1%cohorts(1)
  c2 => t2%cohorts(1)
  ! define macro for merging cohort values
#define __MERGE__(field) c2%field = x1*c1%field + x2*c2%field
  HEAT1 = (clw*c1%prog%Wl + csw*c1%prog%Ws + c1%mcv_dry)*(c1%prog%Tv-tfreeze)
  HEAT2 = (clw*c2%prog%Wl + csw*c2%prog%Ws + c2%mcv_dry)*(c2%prog%Tv-tfreeze)
  __MERGE__(prog%Wl)
  __MERGE__(prog%Ws)

  __MERGE__(bl)      ! biomass of leaves, kg C/m2
  __MERGE__(blv)     ! biomass of virtual leaves (labile store), kg C/m2
  __MERGE__(br)      ! biomass of fine roots, kg C/m2
  __MERGE__(bsw)     ! biomass of sapwood, kg C/m2
  __MERGE__(bwood)   ! biomass of heartwood, kg C/m2
  __MERGE__(bliving) ! leaves, fine roots, and sapwood biomass
  
  __MERGE__(carbon_gain) ! carbon gain during a day, kg C/m2
  __MERGE__(carbon_loss) ! carbon loss during a day, kg C/m2 [diag only]
  __MERGE__(bwood_gain)  ! heartwood gain during a day, kg C/m2

  ! should we do update_derived_vegn_data here? to get mcv_dry, etc
  call update_biomass_pools(c2)

  ! calculate the resulting dry heat capacity
  c2%mcv_dry = max(mcv_min,mcv_lai*c2%lai)
  ! update canopy temperature -- just merge it based on area weights if the heat 
  ! capacities are zero, or merge it based on the heat content if the heat contents
  ! are non-zero
  if(HEAT1==0.and.HEAT2==0) then
     __MERGE__(prog%Tv)
  else
     c2%prog%Tv = (HEAT1*x1+HEAT2*x2) / &
          (clw*c2%prog%Wl + csw*c2%prog%Ws + c2%mcv_dry) + tfreeze
  endif

#undef  __MERGE__
! re-define macro for tile values
#define __MERGE__(field) t2%field = x1*t1%field + x2*t2%field

  __MERGE__(age);
  
  __MERGE__(fsc_pool); __MERGE__(fsc_rate)
  __MERGE__(ssc_pool); __MERGE__(ssc_rate)

  __MERGE__(csmoke_pool)
  __MERGE__(csmoke_rate)

  __MERGE__(harv_pool)
  __MERGE__(harv_rate)

  ! do we need to merge these?
  __MERGE__(ssc_out)
  __MERGE__(fsc_out)
  __MERGE__(veg_in); __MERGE__(veg_out)
  
  ! or these?
  __MERGE__(disturbance_rate)
  __MERGE__(lambda)     ! cumulative drought months per year
  __MERGE__(fuel)       ! fuel over dry months
  __MERGE__(litter)     ! litter flux

  ! monthly accumulated/averaged values
  __MERGE__(theta_av_phen)   ! relative soil_moisture availability not soil moisture
  __MERGE__(theta_av_fire)
  __MERGE__(psist_av)   ! water potential divided by permanent wilting potential
  __MERGE__(tsoil_av)   ! bulk soil temperature
  __MERGE__(tc_av)      ! leaf temperature
  __MERGE__(precip_av)  ! precipitation

  ! annual-mean values
  __MERGE__(t_ann)      ! annual mean T, degK
  __MERGE__(t_cold)     ! average temperature of the coldest month, degK
  __MERGE__(p_ann)      ! annual mean precip
  __MERGE__(ncm)        ! number of cold months

  ! annual accumulated values
  __MERGE__(t_ann_acm)  ! accumulated annual temperature for t_ann
  __MERGE__(t_cold_acm) ! temperature of the coldest month in current year
  __MERGE__(p_ann_acm)  ! accumulated annual precipitation for p_ann
  __MERGE__(ncm_acm)    ! accumulated number of cold months

#undef __MERGE__

end subroutine merge_vegn_tiles


! ============================================================================
! given a vegetation tile with the state variables set up, calculate derived
! parameters to get a consistent state
! NOTE: this subroutine does not call update_biomass_pools, although some 
! of the calculations are the same. The reason is because this function may 
! be used in the situation when the biomasses are not precisely consistent, for
! example when they come from the data override or from initial conditions.
subroutine update_derived_vegn_data(vegn)
  type(vegn_tile_type), intent(inout) :: vegn
  
  ! ---- local vars 
  type(vegn_cohort_type), pointer :: cc ! pointer to the current cohort
  integer :: i  ! cohort index
  integer :: sp ! shorthand for the vegetation species
  
  ! given that the cohort state variables are initialized, fill in
  ! the intermediate variables
  do i = 1,vegn%n_cohorts
    cc=>vegn%cohorts(i)
    
    sp = cc%species
    ! set the physiology type according to species
    cc%pt     = spdata(sp)%pt
    ! calculate total biomass, calculate height
    cc%b      = cc%bliving + cc%bwood
    cc%height = height_from_biomass(cc%b);
    ! update fractions of the living biomass
    call update_bio_living_fraction(cc)
    cc%bs     = cc%bsw + cc%bwood;   
    cc%bstem  = agf_bs*cc%bs;
    cc%babove = cc%bl + agf_bs*cc%bs; 

    if(sp<NSPECIES) then ! LM3V species
       ! calculate the leaf area index based on the biomass of leaves
       cc%lai = lai_from_biomass(cc%bl, sp)
       ! calculate the root density as the total biomass below ground, in
       ! biomass (not carbon!) units
       cc%root_density = (cc%br + (cc%bsw+cc%bwood+cc%blv)*(1-agf_bs))*C2B
    else
       cc%height        = spdata(sp)%dat_height
       cc%lai           = spdata(sp)%dat_lai
       cc%root_density  = spdata(sp)%dat_root_density
    endif
    cc%sai           = 0.035*cc%height
    cc%leaf_size     = spdata(sp)%leaf_size
    cc%root_zeta     = spdata(sp)%dat_root_zeta
    cc%rs_min        = spdata(sp)%dat_rs_min
    cc%leaf_refl     = spdata(sp)%leaf_refl
    cc%leaf_tran     = spdata(sp)%leaf_tran
    cc%leaf_emis     = spdata(sp)%leaf_emis
    cc%snow_crit     = spdata(sp)%dat_snow_crit
  
    ! putting this initialization within the cohort loop is probably incorrect 
    ! in case of multiple-cohort vegetation, however for a single cohort it works
    cc%Wl_max   = spdata(sp)%cmc_lai*cc%lai
    cc%Ws_max   = spdata(sp)%csc_lai*cc%lai
    cc%mcv_dry = max(mcv_min, mcv_lai*cc%lai)
  enddo
    
end subroutine update_derived_vegn_data

! ============================================================================
! returns the profiles of uptake used in the 'LINEAR' uptake option
subroutine vegn_uptake_profile(vegn, dz, uptake_frac_max, vegn_uptake_term)
  type(vegn_tile_type), intent(in)  :: vegn
  real,                 intent(in)  :: dz(:)
  real,                 intent(out) :: uptake_frac_max(:)
  real,                 intent(out) :: vegn_uptake_term(:)

  call cohort_uptake_profile(vegn%cohorts(1), dz, uptake_frac_max, vegn_uptake_term)
end subroutine


! ============================================================================
subroutine vegn_root_properties (vegn, dz, VRL, K_r, r_r)
  type(vegn_tile_type), intent(in)  :: vegn 
  real,                 intent(in)  :: dz(:)
  real, intent(out) :: &
       vrl(:), & ! volumetric fine root length, m/m3
       K_r,    & ! root membrane permeability per unit area, kg/(m3 s)
       r_r       ! radius of fine roots, m

  call cohort_root_properties(vegn%cohorts(1), dz, VRL, K_r, r_r)
end subroutine 


! ============================================================================
function vegn_data_rs_min ( vegn )
  real :: vegn_data_rs_min
  type(vegn_tile_type), intent(in)  :: vegn
  
  vegn_data_rs_min = vegn%cohorts(1)%rs_min
end function


! ============================================================================
function vegn_seed_supply ( vegn )
  real :: vegn_seed_supply
  type(vegn_tile_type), intent(in) :: vegn

  ! ---- local vars 
  real :: vegn_bliving
  integer :: i
  
  vegn_bliving = 0
  do i = 1,vegn%n_cohorts
     vegn_bliving = vegn_bliving + vegn%cohorts(i)%bliving
  enddo
  vegn_seed_supply = MAX (vegn_bliving-BSEED, 0.0)
  
end function 

! ============================================================================
function vegn_seed_demand ( vegn )
  real :: vegn_seed_demand
  type(vegn_tile_type), intent(in) :: vegn

  integer :: i

  vegn_seed_demand = 0
  do i = 1,vegn%n_cohorts
     if(vegn%cohorts(i)%bliving<BSEED.and.vegn%t_ann>253.16.and.vegn%p_ann>1E-6) then
        vegn_seed_demand = vegn_seed_demand + BSEED
     endif
  enddo
end function 

! ============================================================================
subroutine vegn_add_bliving ( vegn, delta )
  type(vegn_tile_type), intent(inout) :: vegn
  real :: delta ! increment of bliving

  vegn%cohorts(1)%bliving = vegn%cohorts(1)%bliving + delta

  if (vegn%cohorts(1)%bliving < 0)then
     call error_mesg('vegn_add_bliving','resulting bliving is less then 0', FATAL)
  endif
  call update_biomass_pools(vegn%cohorts(1))
end subroutine 





! ============================================================================
! given a vegetation patch, destination kind of transition, and "transition 
! intensity" value, this function returns a fraction of tile that will parti-
! cipate in transition.
!
! this function must be contiguous, monotonic, its value must be within
! interval [0,1]
!
! this function is used to determine what part of each tile is to be converted
! to another land use kind; the equation is solved to get "transition intensity" 
! tau for which total area is equal to requested. Tau is, therefore, a dummy
! parameter, and only relative values of the priority functions for tiles 
! participating in transition have any meaning. For most transitions the priority 
! function is just equal to tau: therefore there is no preference, and all tiles
! contribute equally to converted area. For secondary vegetation harvesting, 
! however, priority also depends on wood biomass, and therefore tiles
! with high wood biomass are harvested first.
function vegn_tran_priority(vegn, dst_kind, tau) result(pri)
  real :: pri
  type(vegn_tile_type), intent(in) :: vegn
  integer             , intent(in) :: dst_kind
  real                , intent(in) :: tau

  real :: vegn_bwood
  integer :: i

  if (vegn%landuse==LU_SCND.and.dst_kind==LU_SCND) then ! secondary biomass harvesting
     vegn_bwood = 0
     do i = 1,vegn%n_cohorts
        vegn_bwood = vegn_bwood + vegn%cohorts(i)%bwood
     enddo
     pri = max(min(tau+vegn_bwood,1.0),0.0)
  else
     pri = max(min(tau,1.0),0.0)
  endif
end function 


! ============================================================================
function vegn_cover_cold_start(land_mask, lonb, latb) result (vegn_frac)
! creates and initializes a field of fractional vegn coverage
  logical, intent(in) :: land_mask(:,:)    ! land mask
  real,    intent(in) :: lonb(:,:), latb(:,:)! boundaries of the grid cells
  real,    pointer    :: vegn_frac (:,:,:) ! output: map of vegn fractional coverage

  allocate( vegn_frac(size(land_mask,1),size(land_mask,2),MSPECIES))

  call init_cover_field(vegn_to_use, 'INPUT/cover_type.nc', 'cover','frac', &
       lonb, latb, vegn_index_constant, input_cover_types, vegn_frac)
  
end function 

! =============================================================================
! returns true if tile fits the specified selector
function vegn_is_selected(vegn, sel)
  logical vegn_is_selected
  type(tile_selector_type),  intent(in) :: sel
  type(vegn_tile_type),      intent(in) :: vegn

  select case (sel%idata1)
  case (LU_SEL_TAG)
     vegn_is_selected = (sel%idata2 == vegn%landuse)
  case (SP_SEL_TAG)
     if (.not.associated(vegn%cohorts)) then
        vegn_is_selected = .FALSE.
     else
        vegn_is_selected = (sel%idata2 == vegn%cohorts(1)%species)
     endif
  case (NG_SEL_TAG)
     if (.not.associated(vegn%cohorts)) then
        vegn_is_selected = .FALSE.
     else
        vegn_is_selected = &
             ((vegn%cohorts(1)%species==SP_C4GRASS) .or.&
              (vegn%cohorts(1)%species==SP_C3GRASS)).and.&
             ((vegn%landuse==LU_NTRL).or. &
              (vegn%landuse==LU_SCND))
     endif
  case default
     vegn_is_selected = .FALSE.
  end select  
     
end function


! ============================================================================
! returns tag of the tile
function get_vegn_tile_tag(vegn) result(tag)
  integer :: tag
  type(vegn_tile_type), intent(in) :: vegn
  
  tag = vegn%tag
end function

! ============================================================================
! returns total wood biomass per tile 
function get_vegn_tile_bwood(vegn) result(bwood)
  real :: bwood
  type(vegn_tile_type), intent(in) :: vegn

  ! ---- local vars
  integer :: i

  bwood = 0
  do i = 1,vegn%n_cohorts
     bwood = bwood + vegn%cohorts(i)%bwood
  enddo
end function

! ============================================================================
subroutine vegn_tile_stock_pe (vegn, twd_liq, twd_sol  )
  type(vegn_tile_type),  intent(in)    :: vegn
  real,                  intent(out)   :: twd_liq, twd_sol
  integer n
  
  twd_liq = 0.
  twd_sol = 0.
  do n=1, vegn%n_cohorts
    twd_liq = twd_liq + vegn%cohorts(n)%prog%wl
    twd_sol = twd_sol + vegn%cohorts(n)%prog%ws
!      vegn_HEAT  = (mcv + clw*cohort%prog%Wl+ csw*cohort%prog%Ws)*(cohort%prog%Tv-tfreeze)

    enddo
end subroutine vegn_tile_stock_pe


! ============================================================================
! returns total carbon in the tile, kg C/m2
function vegn_tile_carbon(vegn) result(carbon) ; real carbon
  type(vegn_tile_type), intent(in)  :: vegn

  integer :: i

  carbon = 0
  do i = 1,vegn%n_cohorts
     carbon = carbon + &
          vegn%cohorts(i)%bl + vegn%cohorts(i)%blv + &
          vegn%cohorts(i)%br + vegn%cohorts(i)%bwood + &
          vegn%cohorts(i)%bsw + &
          vegn%cohorts(i)%carbon_gain + vegn%cohorts(i)%bwood_gain
  enddo
  carbon = carbon + &
       sum(vegn%harv_pool) + vegn%fsc_pool + vegn%ssc_pool + vegn%csmoke_pool
end function


! ============================================================================
! returns heat content of the vegetation, J/m2
function vegn_tile_heat (vegn) result(heat) ; real heat
  type(vegn_tile_type), intent(in)  :: vegn

  integer :: i

  heat = 0
  do i = 1, vegn%n_cohorts
     heat = heat + &
          (clw*vegn%cohorts(i)%prog%Wl + &
             csw*vegn%cohorts(i)%prog%Ws + &
             vegn%cohorts(i)%mcv_dry)*(vegn%cohorts(i)%prog%Tv-tfreeze) - &
           hlf*vegn%cohorts(i)%prog%Ws
  enddo
end function

end module vegn_tile_mod

!VERSION NUMBER:
!  $Id: donner_lscloud_k.F90,v 19.0 2012/01/06 20:07:28 fms Exp $

!module donner_lscloud_inter_mod

!#include "donner_types.h"

!end module donner_lscloud_inter_mod


!#####################################################################

subroutine don_l_lscloud_driver_k   &
         (isize, jsize, nlev_lsm, cloud_tracers_present, Param,  &
          Col_diag, pfull, temp, exit_flag,   &
          mixing_ratio, qlin, qiin, qain, phalf, Don_conv, &
          donner_humidity_factor, donner_humidity_area, dql, dqi, dqa, &
          mhalf_3d, &
          ermesg, error) 

!---------------------------------------------------------------------
!    subroutine don_l_lscloud_driver obtains variables needed by 
!    strat_cloud_mod that are dependent on the donner_deep parameter-
!    ization. specifically, the convective cell plus mesoscale anvil
!    cloud fraction (donner_humidity_area), the ratio of the large-scale 
!    specific humidity to the specific humidity in the environment out-
!    side of the convective system (donner_humidity_ratio), and the 
!    changes in cloud liquid, cloud ice and cloud area due to the con-
!    vective-system vertical mass flux and detrainment from the mesoscale
!    anvil to the large scale (dql, dqi, dqa) are passed out for use in 
!    strat_cloud_mod.
!---------------------------------------------------------------------

use donner_types_mod, only : donner_conv_type, donner_param_type, &
                             donner_column_diag_type

implicit none

!---------------------------------------------------------------------
integer,                    intent(in)    :: isize, jsize, nlev_lsm
logical,                    intent(in)    :: cloud_tracers_present
type(donner_param_type),    intent(in)    :: Param
type(donner_column_diag_type),                    &
                            intent(in)    :: Col_diag
logical, dimension(isize,jsize), intent(in) :: exit_flag
real, dimension(isize,jsize,nlev_lsm),         &
                            intent(in)    :: pfull, temp, mixing_ratio, &
                                             qlin, qiin, qain
real, dimension(isize,jsize,nlev_lsm+1),        &
                            intent(in)    :: phalf 
type(donner_conv_type),     intent(inout) :: Don_conv
real, dimension(isize,jsize,nlev_lsm),           &
                            intent(out)   :: donner_humidity_factor,  &
                                             donner_humidity_area, dql, &
                                             dqi, dqa
real, dimension(isize, jsize, nlev_lsm+1),   &
                            intent(out)   :: mhalf_3d
character(len=*),           intent(out)   :: ermesg
integer,                    intent(out)   :: error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!     pfull          pressure field on model full levels [ Pa ]
!     phalf          pressure field on model half levels [ Pa ]
!     temp           temperature field at model full levels [ deg K ]
!     mixing_ratio   water vapor specific humidity at model full 
!                    levels [ kg(h2o) / kg(air) ]
!     qlin           large-scale cloud liquid specific humidity
!                    [ kg(h2o) / kg(air) ]
!     qiin           large-scale cloud ice specific humidity
!                    [ kg(h2o) / kg(air) ]
!     qain           large-scale cloud fraction [ fraction ]
!
!   intent(inout) variables:
!
!     Don_conv
!
!
!   intent(out) variables:
!
!     donner_humidity_ratio
!                    ratio of large-scale specific humidity to the
!                    specific humidity in the environment outside
!                    of the convective system [ dimensionless ]
!     donner_humidity_area
!                    fractional area of cell plus meso circulation
!                    associated with donner_deep_mod [ fraction ]
!     dql            increment to large-scale cloud liquid field from
!                    donner_deep_mod [ kg(h2o) / kg (air) ]
!     dqi            increment to large-scale cloud ice field from
!                    donner_deep_mod [ kg(h2o) / kg (air) ]
!     dqa            increment to large-scale cloud area field from
!                    donner_deep_mod [ fraction ]
!
!---------------------------------------------------------------------

!---------------------------------------------------------------------
!   local variables:


      real, dimension   &
            (isize, jsize, nlev_lsm  ) :: dmeso_3d

!---------------------------------------------------------------------
!   local variables:
!
!     dmeso_3d       detrainment rate from convective system 
!                    [ sec**(-1) ]
!     mhalf_3d       mass flux at model half-levels 
!                    [ kg / (m**2 sec) ]
!---------------------------------------------------------------------

      ermesg = ' ' ; error = 0

!---------------------------------------------------------------------
!    call define_donner_mass_flux to define the convective system 
!    detrainment rate (dmeso_3d) and the mass flux at model interface 
!    levels (mhalf_3d) that is associated with deep convection.
!---------------------------------------------------------------------
      call don_l_define_mass_flux_k    &
           (isize, jsize, nlev_lsm, pfull, phalf, Don_conv,   &
            dmeso_3d, mhalf_3d, exit_flag, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return

 
!---------------------------------------------------------------------
!    call adjust_tiedtke_inputs to obtain the convective cloud area 
!    (donner_humidity_area) and the ratio of large-scale specific humid-
!    ity to the humidity in the environment of the convective system 
!    (donner_humidity_ratio).
!---------------------------------------------------------------------
      call don_l_adjust_tiedtke_inputs_k    &
           (isize, jsize, nlev_lsm, Param, Col_diag, pfull,temp,   &
            mixing_ratio, phalf, Don_conv, donner_humidity_factor, &
            donner_humidity_area,exit_flag,  ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
      if (error /= 0 ) return
 
!---------------------------------------------------------------------
!    when strat_cloud is active, call strat_cloud_donner_tend to
!    define increments to cloudice, cloudwater and cloud area associated
!    with deep convective vertical mass flux and detrainment from the
!    mesoscale to the large-scale. 
!---------------------------------------------------------------------
      if (cloud_tracers_present) then
        call don_l_strat_cloud_donner_tend_k   &
             (isize, jsize, nlev_lsm, Param, Col_diag, dmeso_3d,   &
              Don_conv%xliq, Don_conv%xice, qlin, qiin, qain, mhalf_3d, &
              phalf, dql, dqi, dqa, ermesg, error)
 
!----------------------------------------------------------------------
!    determine if an error message was returned from the kernel routine.
!    if so, return to calling program where it will be processed.
!----------------------------------------------------------------------
        if (error /= 0 ) return
      endif

!---------------------------------------------------------------------


end subroutine don_l_lscloud_driver_k



!#####################################################################

subroutine don_l_define_mass_flux_k   &
         (isize, jsize, nlev_lsm, pfull, phalf, Don_conv, dmeso_3d,   &
          mhalf_3d, exit_flag, ermesg, error)

!---------------------------------------------------------------------
!    subroutine define_donner_mass_flux calculates the detrainment rate
!    of the mesoscale to the large-scale and the mass flux associated 
!    with the donner deep convection parameterization.
!---------------------------------------------------------------------

use donner_types_mod, only : donner_conv_type

implicit none

!---------------------------------------------------------------------
integer,                                 intent(in)    :: isize, jsize, &
                                                          nlev_lsm
real, dimension(isize,jsize,nlev_lsm),   intent(in)    :: pfull
real, dimension(isize,jsize,nlev_lsm+1), intent(in)    :: phalf
type(donner_conv_type),                  intent(inout) :: Don_conv
real, dimension(isize,jsize,nlev_lsm),   intent(out)   :: dmeso_3d
real, dimension(isize,jsize,nlev_lsm+1), intent(out)   :: mhalf_3d
logical, dimension(isize, jsize),        intent(in)    :: exit_flag
character(len=*),                        intent(out)   :: ermesg
integer,                                 intent(out)   :: error
!----------------------------------------------------------------------
!   intent(in) variables:
!
!     pfull          pressure field on model full levels [ Pa ]
!     phalf          pressure field at half-levels 1:nlev_lsm+1  [ Pa ]
!
!   intent(inout) variables:
!     Don_conv
!
!   intent(out) variables:
!
!     dmeso_3d       detrainment rate from convective system 
!                    [ sec**(-1) ]
!     mhalf_3d       mass flux at model half-levels 
!                    [ kg / (m**2 sec) ]
!
!--------------------------------------------------------------------

!-------------------------------------------------------------------
!   local variables:

      real      :: dnna, dnnb    ! weights for averaging full-level 
                                 ! mass fluxes to half levels
                                 ! [ dimensionless ]
      integer   :: i,j,k         ! do-loop indices

!----------------------------------------------------------------------
!
!----------------------------------------------------------------------
      ermesg = ' ' ; error = 0

!----------------------------------------------------------------------
!    calculate the detrainment rate from the convective system 
!    (dmeso_3d). dmeso_3d is (1/rho) dM/dz [ sec**(-1) ], where M is 
!    the detraining mass flux of the convective system (kg/(m**2 s)).
!----------------------------------------------------------------------
      do k=1,nlev_lsm
        do j=1,jsize
          do i=1,isize
            if ( .not. exit_flag(i,j) .and. &
                 Don_conv%xice(i,j,k) >= 1.0e-10) then
              dmeso_3d(i,j,k) = Don_conv%emes(i,j,k)/ &
                                Don_conv%xice(i,j,k)
            else
              dmeso_3d(i,j,k) = 0.
            end if
          end do
        end do
      end do

!---------------------------------------------------------------------
!    define the donner parameterization mass flux at model half-levels.
!    include both mesoscale and cell scale fluxes.
!---------------------------------------------------------------------
      do k=1,nlev_lsm-1
        do j=1,jsize
          do i=1,isize
            if (((Don_conv%uceml(i,j,k) <= 1.0e-10)  .and.   &
                (Don_conv%umeml(i,j,k) <= 1.0e-10) .and. &
                (Don_conv%dmeml(i,j,k) <= 1.0e-10)) .or. &
                  exit_flag(i,j)        ) then
              mhalf_3d(i,j,k)   = 0.
              mhalf_3d(i,j,k+1) = 0.
            else
              dnna = phalf(i,j,k+1) - pfull(i,j,k)
              dnnb = pfull(i,j,k+1) - phalf(i,j,k+1)
              mhalf_3d(i,j,k+1) =  &
                                 (dnnb*Don_conv%uceml(i,j,k) + &
                                  dnna*Don_conv%uceml(i,j,k+1) +  &
                                  dnnb*Don_conv%umeml(i,j,k) +   &
                                  dnna*Don_conv%umeml(i,j,k+1) +  &
                                  dnnb*Don_conv%dmeml(i,j,k) +   &
                                  dnna*Don_conv%dmeml(i,j,k+1))/ &
                                  (dnna + dnnb)
            endif
          end do
        end do
      end do

!---------------------------------------------------------------------
!    define the donner parameterization mass fluxes at model top and
!    bottom to be 0.0.
!---------------------------------------------------------------------
      do j=1,jsize
        do i=1,isize
          mhalf_3d(i,j,nlev_lsm+1) = 0.
          mhalf_3d(i,j,1)      = 0.
        end do
      end do


!---------------------------------------------------------------------



end subroutine don_l_define_mass_flux_k 


!######################################################################

subroutine don_l_adjust_tiedtke_inputs_k   &
         (isize, jsize, nlev_lsm, Param, Col_diag, pfull, temp, &
          mixing_ratio, phalf, Don_conv, donner_humidity_factor, &
          donner_humidity_area, exit_flag, ermesg, error) 

!---------------------------------------------------------------------
!    subroutine adjust_tiedtke_inputs calculates the adjustments to 
!    the relative humidity used as a threshold for cloud formation in 
!    the Tiedtke stratiform cloud parameterization (u00), needed as a 
!    consequence of donner_deep_mod being active. see "Tiedtke u00 
!    adjustment" notes, 11/22/02.
!--------------------------------------------------------------------

use donner_types_mod, only : donner_conv_type, donner_param_type, &
                             donner_column_diag_type
use sat_vapor_pres_k_mod, only: lookup_es_k

implicit none

!--------------------------------------------------------------------
integer,                     intent(in)     :: isize, jsize, nlev_lsm
type(donner_param_type),     intent(in)     :: Param
type(donner_column_diag_type),                                      &
                             intent(in)     :: Col_diag
logical, dimension(isize,jsize), intent(in) :: exit_flag   
real, dimension(isize,jsize,nlev_lsm),                              &
                             intent(in)     :: pfull, temp, mixing_ratio
real, dimension(isize,jsize,nlev_lsm+1),                            &
                             intent(in)     :: phalf
type(donner_conv_type),      intent(inout)  :: Don_conv
real, dimension(isize,jsize,nlev_lsm),                               &
                             intent(out)    :: donner_humidity_factor, &
                                               donner_humidity_area
character(len=*),            intent(out)    :: ermesg
integer,                     intent(out)    :: error

!---------------------------------------------------------------------
!   intent(in) variables:
!
!     pfull          pressure field on model full levels [ Pa ]
!     phalf          pressure field on model half levels [ Pa ]
!     temp           temperature field at model full levels [ deg K ]
!     mixing_ratio   water vapor specific humidity at model full 
!                    levels [ kg(h2o) / kg(air) ]
!
!   intent(inout) variables:
!
!     Don_conv
!
!   intent(out) variables:
!
!     donner_humidity_ratio    
!                    ratio of large-scale specific humidity to the
!                    specific humidity in the environment outside
!                    of the convective system [ dimensionless ]
!     donner_humidity_area    
!                    fractional area of cell plus meso circulation
!                    associated with donner_deep_mod [ fraction ]
!
!--------------------------------------------------------------------

!--------------------------------------------------------------------
!   local variables:
 
     real                       :: acell, pzm, rfun
     integer                    :: i, j, k, n

!--------------------------------------------------------------------
!   local variables:
!
!     qrf           vapor specific humidity at model full levels 
!                   [ kg (h2o) /kg(air) ]
!     acell         fractional area of cells in grid box
!                   [ fraction ]
!     pzm           pressure level 200 hPa above top of mesoscale
!                   downdraft [ Pa ]
!     rfun          ratio of specific humidity to saturation specific
!                   humidity assumed in the region between the top of
!                   the mesoscale downdraft and the cloud base
!                   [ fraction ]
!     qsat          saturation specific humidity [ kg(h2o) / kg(air) ]
!     esat          saturation vapor pressure [ Pa ]
!     i,j,k,n       do-loop indices
!---------------------------------------------------------------------

      ermesg = ' ' ; error = 0

      do k=1,nlev_lsm           
        do j=1,jsize
          do i=1,isize

!---------------------------------------------------------------------
!    the output fields are given non-default values only in grid boxes
!    where donner_deep_mod has produced either cell or mesoscale cloud.
!---------------------------------------------------------------------
            if ( .not. exit_flag(i,j) .and. &
                 (Don_conv%cual(i,j,k)  > 0.0 .or. &
                  Don_conv%ampta1(i,j) > 0.0)) then

!-------------------------------------------------------------------
!    define the pressure at the base of the mesoscale updraft (pzm), 
!-------------------------------------------------------------------
              pzm = Don_conv%pzm_v(i,j) 

!--------------------------------------------------------------------
!    define the area of the convective cells in each grid box (acell).
!    if in the region of mesoscale updraft, the cell area is defined as
!    the difference between the total cloud area (Don_conv%cual) and 
!    the mesoscale area (Don_conv%ampta1). above and below this region 
!    it is defined as the total cloud area, since no mesoscale cloud is
!    present. be sure that the cell area is non-negative.
!--------------------------------------------------------------------
              if ((pfull(i,j,k) <= Don_conv%pzm_v(i,j)) .and.   &
                  (pfull(i,j,k) >= Don_conv%pztm_v(i,j))) then
                acell = Don_conv%cual(i,j,k) - Don_conv%ampta1(i,j)
              else
                acell = Don_conv%cual(i,j,k)
              endif
              acell = MAX (acell, 0.0)

!--------------------------------------------------------------------
!    define the fractional area of the grid box where the humidity
!    is affected by the deep convection in the mesoscale updraft region 
!    (donner_humidity_area). it is assumed to be the sum of the cell and
!    meso cloud areas. previously, below cloud base and above the top 
!    of the mesoscale updraft, there was no moisture-enhanced area due 
!    to deep convection.      
!      this is no longer the case after mods during AM2p9 -- in current
!      formulation there may be cell cloud above top of mesoscale
!      updraft (when cloud top exceeds plzb), and in grid box containing
!      cloud base level.
!--------------------------------------------------------------------
              donner_humidity_area(i,j,k) = Don_conv%cual(i,j,k)

!----------------------------------------------------------------------
!     between cloud base and the base of the mesoscale updraft, the
!     humidity in an area the size of the sum of the cell and meso 
!     cloud areas is assumed to be affected by the deep convection.
!----------------------------------------------------------------------
              if ((pfull(i,j,k) >  Don_conv%pzm_v(i,j)) .and.  &
                  (pfull(i,j,k) <= Don_conv%pb_v(i,j)) ) then
                donner_humidity_area(i,j,k) = Don_conv%cual(i,j,k) +   &
                                              Don_conv%ampta1(i,j)
              endif

!---------------------------------------------------------------------
!      limit the fractional area to be less than 1.0.
!---------------------------------------------------------------------
              donner_humidity_area(i,j,k) =     &
                                  MIN (donner_humidity_area(i,j,k), 1.0)

!---------------------------------------------------------------------
!    define the variable rfun, which serves as the ratio of specific
!    humidity to saturation specific humidity assumed to be present in
!    the part of the grid box with a mesoscale circulation. saturation 
!    is assumed in the cell portion and in the region from the top of 
!    the mesoscale downdraft to the top of the mesoscale updraft. from 
!    top of mesoscale downdraft to cloud base, the relative humidity 
!    goes from 100% to 70%, as a function of relative pressure distance
!    between the two end points.  
!---------------------------------------------------------------------
              if ((pfull(i,j,k) >= Don_conv%pztm_v(i,j)) .and. &
                  (pfull(i,j,k) <= Don_conv%pmd_v(i,j))) then
                rfun = 1.
              else if ((pfull(i,j,k) >= Don_conv%pmd_v(i,j)) .and.  &
                       (pfull(i,j,k) <= Don_conv%pb_v(i,j))) then
                rfun = 1. - 0.3*(Don_conv%pmd_v(i,j) - pfull(i,j,k))/ &
                                (Don_conv%pmd_v(i,j) -   &
                                                     Don_conv%pb_v(i,j))
              else if (pfull(i,j,k) < Don_conv%pztm_v(i,j)) then
                rfun = 0.
              else if (pfull(i,j,k) > Don_conv%pztm_v(i,j)) then
                rfun = 0.
              endif

              donner_humidity_factor(i,j,k) = Don_conv%ampta1(i,j)*rfun

!---------------------------------------------------------------------
!    if in diagnostics column, output the profiles of cell and mesoscale
!    cloud area, the pressure, temperature and specific humidity prof-
!    iles,  the saturation specific humidity, the large-scale and 
!    convective environment specific humidities.
!---------------------------------------------------------------------
              if (Col_diag%in_diagnostics_window) then
                do n=1, Col_diag%ncols_in_window
                  if (j == Col_diag%j_dc(n) .and.    &
                      i == Col_diag%i_dc(n)) then
                    if (pfull(i,j,k) .le. Don_conv%pb_v(i,j)) then
                      if (Don_conv%ampta1(i,j) .ne. 0.) then
                        write (Col_diag%unit_dc(n), '(a, i5, 2f20.10)') &
                           'k,cual,ampt= ', &
                            k, Don_conv%cual(i,j,k), Don_conv%ampta1(i,j)
                        write (Col_diag%unit_dc(n), '(a, i5, 4f20.10)') &
                                     'pb,prinp,trf, acell= ',  k, &
                                   Don_conv%pb_v(i,j), pfull(i,j,k),   &
                                    temp(i,j,k),acell
                        write (Col_diag%unit_dc(n), '(a, i5, f20.10)') &
                               'rfun,= ', k,  rfun
                      endif
                    endif
                  endif
                end do
              endif

!---------------------------------------------------------------------
!    if there is no cell or meso cloud in the grid box, set 
!    donner_humidity_ratio to 1.0 and donner_humidity_area to 0.0
!---------------------------------------------------------------------
            else
              donner_humidity_factor(i,j,k) = 0.0
              donner_humidity_area(i,j,k) = 0.0
            endif
          end do
        end do
      end do

!---------------------------------------------------------------------


end subroutine don_l_adjust_tiedtke_inputs_k 



!#######################################################################

 subroutine don_l_strat_cloud_donner_tend_k    &
          (isize, jsize, nlev_lsm, Param, Col_diag, dmeso_3d, qlmeso, &
           qimeso, qlin, qiin, qain, mhalf_3d, phalf, dql, dqi, dqa,  &
           ermesg, error)

!--------------------------------------------------------------------
!    subroutine strat_cloud_donner is part of the linkage between
!    the deep convection parameterization of donner_deep_mod and the 
!    tiedtke/rotstayn cloud fraction/microphysics parameterization of 
!    strat_cloud_mod.
!-----------------------------------------------------------------------

use donner_types_mod, only : donner_param_type, donner_column_diag_type

implicit none

!-----------------------------------------------------------------------
integer,                       intent(in)   :: isize, jsize, nlev_lsm
type(donner_param_type),       intent(in)   :: Param
type(donner_column_diag_type), intent(in)   :: Col_diag
real, dimension(isize,jsize,nlev_lsm),          &
                               intent(in)   :: dmeso_3d, qlmeso, qimeso,&
                                               qlin, qiin, qain
real, dimension(isize,jsize,nlev_lsm+1),         &
                               intent(in)   :: mhalf_3d, phalf
real, dimension(isize,jsize,nlev_lsm),           &
                               intent(out)  :: dql, dqi, dqa
character(len=*),              intent(out)  :: ermesg
integer,                       intent(out)  :: error
!---------------------------------------------------------------------
!   intent(in) variables:
!
!     dmeso_3d       mass detrainment rate from mesoscale region to 
!                    large-scale region [ sec**(-1) ]
!     qlmeso         mesoscale cloud liquid specific humidity   
!                    [ (kg (h2o) /kg air) ]
!     qimeso         mesoscale cloud ice specific humidity 
!                    [ (kg (h2o) /kg air) ]
!     mhalf_3d       total donner-related mass flux = 
!                    mesoscale_mass_flux + convective_mass_flux,
!                    on model interface levels [ kg / ((m**2) s) ]
!                    NOTE: mhalf_3d(:,:,1) and mhalf_3d(:,:,kdim+1) are 
!                    assumed to be 0.0 in this subroutine.
!     phalf          pressure at model half-levels [ Pa ]
!     qlin           large-scale cloud liquid specific humidity
!                    [ kg(h2o) / kg(air) ]
!     qiin           large-scale cloud ice specific humidity
!                    [ kg(h2o) / kg(air) ]
!     qain           large-scale cloud fraction [ fraction ]
!
!   intent(out) variables:
!
!     dql            increment to large-scale cloud liquid field from
!                    donner_deep_mod [ kg(h2o) / kg (air) ]
!     dqi            increment to large-scale cloud ice field from
!                    donner_deep_mod [ kg(h2o) / kg (air) ]
!     dqi            increment to large-scale cloud area field from
!                    donner_deep_mod [ fraction ]
!
!----------------------------------------------------------------------

!-----------------------------------------------------------------------
!   local variables:
      real, dimension (isize, jsize,nlev_lsm) ::  mass  
      integer     :: k, n

!---------------------------------------------------------------------
!   local variables:
!
!         mass     mass of air per square meter in the given layer
!                  [ kg / m**2 ]
!         kdim     number of model layers
!         k,n      do-loop indices
!
!---------------------------------------------------------------------

      ermesg = ' ' ; error = 0

!---------------------------------------------------------------------
!    define the number of model layers (kdim) and the mass per unit area
!    contained in each layer (mass).
!---------------------------------------------------------------------
!     kdim = nlev_lsm
      do k=1,nlev_lsm
        mass(:,:,k) = (phalf(:,:,k+1) - phalf(:,:,k))/Param%grav 
      end do

!---------------------------------------------------------------------
!    define the large scale cloud increments at level 1 to be 0.0.
!---------------------------------------------------------------------
      dql (:,:,1) = 0.
      dqi (:,:,1) = 0.
      dqa (:,:,1) = 0.
    
!---------------------------------------------------------------------
!    define the tendencies of cloud liquid, cloud ice and cloud area
!    due to the vertical mass flux associated with donner_deep con-
!    vection.
!---------------------------------------------------------------------
      do k=2,nlev_lsm

!---------------------------------------------------------------------
!    define the tendencies due to flux through the top interface of the
!    layer.
!---------------------------------------------------------------------
        dql(:,:,k) = mhalf_3d(:,:,k)*0.5*(qlin(:,:,k) + qlin(:,:,k-1))/ &
                                                           mass(:,:,k)
        dqi(:,:,k) = mhalf_3d(:,:,k)*0.5*(qiin(:,:,k) + qiin(:,:,k-1))/ &
                                                           mass(:,:,k)
        dqa(:,:,k) = mhalf_3d(:,:,k)*0.5*(qain(:,:,k) + qain(:,:,k-1))/ &
                                                           mass(:,:,k)

!---------------------------------------------------------------------
!    add the tendencies due to flux through the bottom interface of 
!    the layer.
!---------------------------------------------------------------------
        dql(:,:,k-1) = dql(:,:,k-1) - mhalf_3d(:,:,k)*0.5*     &
                            (qlin(:,:,k-1) + qlin(:,:,k))/mass(:,:,k-1)
        dqi(:,:,k-1) = dqi(:,:,k-1) - mhalf_3d(:,:,k)*0.5*      &
                            (qiin(:,:,k-1) + qiin(:,:,k))/mass(:,:,k-1)
        dqa(:,:,k-1) = dqa(:,:,k-1) - mhalf_3d(:,:,k)*0.5*       &
                            (qain(:,:,k-1) + qain(:,:,k))/mass(:,:,k-1)
      end do

!---------------------------------------------------------------------
!    add the effects of detrainment from the mesoscale region.
!---------------------------------------------------------------------
      do k=1,nlev_lsm
        dql (:,:,k) = dql (:,:,k) + dmeso_3d(:,:,k)*qlmeso(:,:,k)
        dqi (:,:,k) = dqi (:,:,k) + dmeso_3d(:,:,k)*qimeso(:,:,k)
        where (qlmeso(:,:,k) + qimeso(:,:,k) >= 1.e-10) 
          dqa (:,:,k) = dqa (:,:,k) + dmeso_3d(:,:,k)
        end where
      end do

!--------------------------------------------------------------------
!    if in diagnostics window, output values of the cloud variables and
!    the tendencies due to donner_deep convection.
!--------------------------------------------------------------------
      if (Col_diag%in_diagnostics_window) then
        do n=1,Col_diag%ncols_in_window
          do k=1, nlev_lsm     
            if (dql(Col_diag%i_dc(n),Col_diag%j_dc(n), k) /= 0.0 .or. &
                dqi(Col_diag%i_dc(n),Col_diag%j_dc(n), k) /= 0.0 ) then 
              write (Col_diag%unit_dc(n), '(a, i5, 3f20.10)') &
                  'donner_deep,strat_cloud_donner_tend', k, &
                   qlin(Col_diag%i_dc(n),Col_diag%j_dc(n), k), &
                   qiin(Col_diag%i_dc(n),Col_diag%j_dc(n), k), &
                   qain(Col_diag%i_dc(n),Col_diag%j_dc(n), k)
              write (Col_diag%unit_dc(n), '(a, i5, 3f20.10)') &
                  'donner_deep,strat_cloud_donner_tend', k, &
                   dql(Col_diag%i_dc(n),Col_diag%j_dc(n), k), &
                   dqi(Col_diag%i_dc(n),Col_diag%j_dc(n), k), &
                   dqa(Col_diag%i_dc(n),Col_diag%j_dc(n), k)
            endif
          end do
        end do
      endif 

!-----------------------------------------------------------------------


end subroutine don_l_strat_cloud_donner_tend_k


!###################################################################

      module mo_imp_sol_mod

      use chem_mods_mod,        only : clscnt4
      use constants_mod,    only : PI

      implicit none

      private
      public :: imp_slv_init, imp_sol

!     save

      integer, parameter ::  inst = 1, avrg = 2
      real, parameter    ::  rel_err      = 1.e-3
      real, parameter    ::  high_rel_err = 1.e-4
!-----------------------------------------------------------------------
!               newton-raphson iteration limits
!-----------------------------------------------------------------------
!     integer, parameter :: cut_limit    = 5
      integer, parameter :: cut_limit    = 8

      integer :: ox_ndx,o1d_ndx,h2o_ndx
      integer :: oh_ndx, ho2_ndx, ch3o2_ndx, po2_ndx, ch3co3_ndx, &
                 c2h5o2_ndx, isopo2_ndx, macro2_ndx, mco3_ndx, c3h7o2_ndx, &
                 ro2_ndx, xo2_ndx, no_ndx, no2_ndx, no3_ndx, n2o5_ndx, &
                 c2h4_ndx, c3h6_ndx, isop_ndx, mvk_ndx, c10h16_ndx
      integer :: ox_p1_ndx, ox_p2_ndx, ox_p3_ndx, ox_p4_ndx, ox_p5_ndx, &
                 ox_p6_ndx, ox_p7_ndx, ox_p8_ndx, ox_p9_ndx, ox_p10_ndx, &
                 ox_p11_ndx
      integer :: ox_l1_ndx, ox_l2_ndx, ox_l3_ndx, ox_l4_ndx, ox_l5_ndx, &
                 ox_l6_ndx, ox_l7_ndx, ox_l8_ndx, ox_l9_ndx, usr4_ndx, &
                 usr16_ndx, usr17_ndx
      logical :: do_ox_pl = .true.
      integer :: verbose
      real    :: r2d

      type hst_pl
         integer  ::  cnt(2)
         logical  ::  do_hst(2)
      end type hst_pl

      real, private                      ::   small
      real, private                      ::   epsilon(clscnt4)
      type(hst_pl), private, allocatable ::   imp_hst_prod(:)
      type(hst_pl), private, allocatable ::   imp_hst_loss(:)
      logical, private, allocatable      ::   factor(:)

character(len=128), parameter :: version     = '$Id: mo_imp_slv.F90,v 20.0 2013/12/13 23:25:05 fms Exp $'
character(len=128), parameter :: tagname     = '$Name: tikal $'
logical                       :: module_is_initialized = .false.

      contains

      subroutine imp_slv_init( verbose_in, retain_cm3_bugs )
!-----------------------------------------------------------------------
!        ... initialize the implict solver
!-----------------------------------------------------------------------

      use chem_mods_mod,  only : clscnt4, endrun, implicit
      use mo_grid_mod,    only : pcnstm1
      use mo_chem_utls_mod, only : get_spc_ndx, get_rxt_ndx

      implicit none

!-----------------------------------------------------------------------
!       ... Dummy arguments
!-----------------------------------------------------------------------
      integer,          intent(in) :: verbose_in
      logical,          intent(in) :: retain_cm3_bugs

!-----------------------------------------------------------------------
!        ... local variables
!-----------------------------------------------------------------------
      integer :: m, astat
      integer :: wrk(21)
      real    :: eps(pcnstm1)
      character(len=128) ::  msg

      allocate( factor(implicit%iter_max),stat=astat )
      if( astat /= 0 ) then
         write(msg,*) 'imp_slv_init: failed to allocate factor array; error = ',astat
         call endrun(msg)
      end if
      factor(:) = .true.
      eps(:)    = rel_err

      if (retain_cm3_bugs) then
        ox_ndx = get_spc_ndx( 'OX' )
      else
        ox_ndx = get_spc_ndx ('O3')
      endif
      o1d_ndx = get_spc_ndx('O1D')
      h2o_ndx = get_spc_ndx('H2O')
      if( ox_ndx > 0 ) then
         eps(ox_ndx) = high_rel_err
      else
         m = get_spc_ndx( 'O3' )
         if( m > 0 ) then
            eps(m) = high_rel_err
         end if
      end if
      m = get_spc_ndx( 'N' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'NO' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'NO2' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'NO3' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'HNO3' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'HO2NO2' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'N2O5' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'ClONO2' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'BrONO2' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'OH' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'HO2' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'Cl' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'ClO' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'Br' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if
      m = get_spc_ndx( 'BrO' )
      if( m > 0 ) then
         eps(m) = high_rel_err
      end if

      do m = 1,max(1,clscnt4)
         epsilon(m) = eps(implicit%clsmap(m))
      end do

      if( ox_ndx > 0 ) then
         ox_p1_ndx = get_rxt_ndx( 'ox_p1' )
         ox_p2_ndx = get_rxt_ndx( 'ox_p2' )
         ox_p3_ndx = get_rxt_ndx( 'ox_p3' )
         ox_p4_ndx = get_rxt_ndx( 'ox_p4' )
         ox_p5_ndx = get_rxt_ndx( 'ox_p5' )
         ox_p6_ndx = get_rxt_ndx( 'ox_p6' )
         ox_p7_ndx = get_rxt_ndx( 'ox_p7' )
         ox_p8_ndx = get_rxt_ndx( 'ox_p8' )
         ox_p9_ndx = get_rxt_ndx( 'ox_p9' )
         ox_p10_ndx = get_rxt_ndx( 'ox_p10' )
         ox_p11_ndx = get_rxt_ndx( 'ox_p11' )
         wrk(1:11) = (/ ox_p1_ndx, ox_p2_ndx, ox_p3_ndx, ox_p4_ndx, ox_p5_ndx, &
                        ox_p6_ndx, ox_p7_ndx, ox_p8_ndx, ox_p9_ndx, ox_p10_ndx, ox_p11_ndx /)
         if( any( wrk(1:11) < 1 ) ) then
            do_ox_pl = .false.
         end if
         if( do_ox_pl ) then
            ox_l1_ndx = get_rxt_ndx( 'ox_l1' )
            ox_l2_ndx = get_rxt_ndx( 'ox_l2' )
            ox_l3_ndx = get_rxt_ndx( 'ox_l3' )
            ox_l4_ndx = get_rxt_ndx( 'ox_l4' )
            ox_l5_ndx = get_rxt_ndx( 'ox_l5' )
            ox_l6_ndx = get_rxt_ndx( 'ox_l6' )
            ox_l7_ndx = get_rxt_ndx( 'ox_l7' )
            ox_l8_ndx = get_rxt_ndx( 'ox_l8' )
            ox_l9_ndx = get_rxt_ndx( 'ox_l9' )
            usr4_ndx = get_rxt_ndx( 'usr4' )
            usr16_ndx = get_rxt_ndx( 'usr16' )
            usr17_ndx = get_rxt_ndx( 'usr17' )
            wrk(1:12) = (/ ox_l1_ndx, ox_l2_ndx, ox_l3_ndx, ox_l4_ndx, ox_l5_ndx, &
                           ox_l6_ndx, ox_l7_ndx, ox_l8_ndx, ox_l9_ndx, usr4_ndx, &
                           usr16_ndx, usr17_ndx /)
            if( any( wrk(1:12) < 1 ) ) then
               do_ox_pl = .false.
            end if
         end if

         if( do_ox_pl ) then
            oh_ndx = get_spc_ndx( 'OH' )
            ho2_ndx = get_spc_ndx( 'HO2' )
            ch3o2_ndx = get_spc_ndx( 'CH3O2' )
            po2_ndx = get_spc_ndx( 'PO2' )
            ch3co3_ndx = get_spc_ndx( 'CH3CO3' )
            c2h5o2_ndx = get_spc_ndx( 'C2H5O2' )
            macro2_ndx = get_spc_ndx( 'MACRO2' )
            mco3_ndx = get_spc_ndx( 'MCO3' )
            c3h7o2_ndx = get_spc_ndx( 'C3H7O2' )
            ro2_ndx = get_spc_ndx( 'RO2' )
            xo2_ndx = get_spc_ndx( 'XO2' )
            no_ndx = get_spc_ndx( 'NO' )
            no2_ndx = get_spc_ndx( 'NO2' )
            no3_ndx = get_spc_ndx( 'NO3' )
            n2o5_ndx = get_spc_ndx( 'N2O5' )
            c2h4_ndx = get_spc_ndx( 'C2H4' )
            c3h6_ndx = get_spc_ndx( 'C3H6' )
            isop_ndx = get_spc_ndx( 'ISOP' )
            isopo2_ndx = get_spc_ndx( 'ISOPO2' )
            mvk_ndx = get_spc_ndx( 'MVK' )
            c10h16_ndx = get_spc_ndx( 'C10H16' )
            wrk(1:21) = (/ oh_ndx, ho2_ndx, ch3o2_ndx, po2_ndx, ch3co3_ndx, &
                           c2h5o2_ndx, macro2_ndx, mco3_ndx, c3h7o2_ndx, ro2_ndx, &
                           xo2_ndx, no_ndx, no2_ndx, no3_ndx, n2o5_ndx, &
                           c2h4_ndx, c3h6_ndx, isop_ndx, isopo2_ndx, mvk_ndx, c10h16_ndx /)
            if( any( wrk(1:21) < 1 ) ) then
               do_ox_pl = .false.
            end if
         end if
      else
         do_ox_pl = .false.
      end if

!     if( moz_file_cnt > 0 ) then
!        allocate( imp_hst_prod(moz_file_cnt),stat=astat )
!        if( astat /= 0 ) then
!             write(*,*) 'imp_slv_init: Failed to allocate imp_hst_prod array; error = ',astat
!            call endrun
!        end if
!        if( astat /= 0 ) then
!            write(*,*) 'imp_slv_init: Failed to allocate imp_hst_prod array; error = ',astat
!            call endrun
!        end if
!         do file = 1,moz_file_cnt
!            imp_hst_prod(file)%do_hst(:) = .false.
!            imp_hst_prod(file)%cnt(:)    = 0
!         end do
!        allocate( imp_hst_loss(moz_file_cnt),stat=astat )
!        if( astat /= 0 ) then
!            write(*,*) 'imp_slv_init: Failed to allocate imp_hst_loss array; error = ',astat
!            call endrun
!        end if
!         do file = 1,moz_file_cnt
!            imp_hst_loss(file)%do_hst(:) = .false.
!            imp_hst_loss(file)%cnt(:)    = 0
!         end do
!-----------------------------------------------------------------------
!        ... scan for class production to history file(s)
!-----------------------------------------------------------------------
!        do file = 1,moz_file_cnt
!            do timetype = inst,avrg
!              if( hfile(file)%histout_cnt(14,timetype) > 0 ) then
!                  il = hfile(file)%histout_ind(14,timetype)
!                  iu = il + hfile(file)%histout_cnt(14,timetype) - 1
!                  if( timetype == inst ) then
!                     if( any( hfile(file)%inst_map(il:iu)/1000 == 4 ) ) then
!                        imp_hst_prod(file)%do_hst(timetype) = .true.
!                        do m = il,iu
!                           if( hfile(file)%inst_map(m)/1000 == 4 ) then
!                              imp_hst_prod(file)%cnt(timetype) = imp_hst_prod(file)%cnt(timetype) + 1
!                           end if
!                        end do
!                        cycle
!                    end if
!                  else if( timetype == avrg ) then
!                     if( any( hfile(file)%timav_map(il:iu)/1000 == 4 ) ) then
!                        imp_hst_prod(file)%do_hst(timetype) = .true.
!                        do m = il,iu
!                           if( hfile(file)%timav_map(m)/1000 == 4 ) then
!                              imp_hst_prod(file)%cnt(timetype) = imp_hst_prod(file)%cnt(timetype) + 1
!                           end if
!                        end do
!                        exit
!                    end if
!                 end if
!              end if
!           end do
!        end do
!-----------------------------------------------------------------------
!        ... scan for class loss to history file(s)
!-----------------------------------------------------------------------
!        do file = 1,moz_file_cnt
!            do timetype = inst,avrg
!              if( hfile(file)%histout_cnt(15,timetype) > 0 ) then
!                  il = hfile(file)%histout_ind(15,timetype)
!                  iu = il + hfile(file)%histout_cnt(15,timetype) - 1
!                  if( timetype == inst ) then
!                     if( any( hfile(file)%inst_map(il:iu)/1000 == 4 ) ) then
!                        imp_hst_loss(file)%do_hst(timetype) = .true.
!                        do m = il,iu
!                           if( hfile(file)%inst_map(m)/1000 == 4 ) then
!                              imp_hst_loss(file)%cnt(timetype) = imp_hst_loss(file)%cnt(timetype) + 1
!                           end if
!                        end do
!                        cycle
!                    end if
!                  else if( timetype == avrg ) then
!                     if( any( hfile(file)%timav_map(il:iu)/1000 == 4 ) ) then
!                        imp_hst_loss(file)%do_hst(timetype) = .true.
!                        do m = il,iu
!                           if( hfile(file)%timav_map(m)/1000 == 4 ) then
!                              imp_hst_loss(file)%cnt(timetype) = imp_hst_loss(file)%cnt(timetype) + 1
!                           end if
!                        end do
!                        exit
!                    end if
!                 end if
!              end if
!           end do
!        end do
!     end if

      small = 1.e6 * tiny( small )
      r2d = 180./PI

      verbose = verbose_in

      end subroutine imp_slv_init

      subroutine imp_sol( base_sol, reaction_rates, &
                          het_rates, extfrc, &
                          nstep, delt, &
                          lat, lon, &
                          prod_out, loss_out, check_convergence, &
                          non_convergence, &
                          plonl, plnplv, &
                          prod_ox, loss_ox)
!-----------------------------------------------------------------------
!              ... imp_sol advances the volumetric mixing ratio
!           forward one time step via the fully implicit euler scheme.
!           this source is meant for small l1 cache machines such as
!           the intel pentium and itanium cpus
!-----------------------------------------------------------------------

      use chem_mods_mod,         only : clscnt4, imp_nzcnt, clsze, rxntot, hetcnt, extcnt, implicit
      use m_tracname_mod,        only : tracnam
      use mo_grid_mod,           only : pcnstm1
      use mo_indprd_mod,         only : indprd
      use mo_imp_prod_loss_mod,  only : imp_prod_loss
      use mo_imp_lin_matrix_mod, only : imp_linmat
      use mo_imp_nln_matrix_mod, only : imp_nlnmat
      use mo_imp_factor_mod,     only : imp_lu_fac
      use mo_imp_solve_mod,      only : imp_lu_slv

      implicit none

!-----------------------------------------------------------------------
!             ... dummy args
!-----------------------------------------------------------------------
      integer, intent(in)    :: nstep                     ! time step index (zero based)
      real,    intent(in)    :: lat(:)                    ! latitude
      real,    intent(in)    :: lon(:)                    ! longitude
      integer, intent(in)    :: plonl                     ! longitude tile dimension
      integer, intent(in)    :: plnplv                    ! plonl*plev
      real,    intent(in)    :: delt                      ! time step (seconds)
      real,    intent(in)    :: reaction_rates(plnplv,rxntot)
      real,    intent(in)    :: het_rates(plnplv,max(1,hetcnt)), &
                                extfrc(plnplv,max(1,extcnt))
      logical, intent(in)    :: check_convergence         ! check for convergence ?
      real,    intent(out)   :: non_convergence(plnplv)   ! flag for implicit solver non-convergence (fraction)
      real,    intent(inout) :: base_sol(plnplv,pcnstm1)
      real,    intent(inout) :: prod_out(plnplv,pcnstm1),loss_out(plnplv,pcnstm1)
      real,    intent(inout) :: prod_ox(plnplv),loss_ox(plnplv)
!-----------------------------------------------------------------------
!             ... local variables
!-----------------------------------------------------------------------
      type hst_buff
         real, pointer, dimension(:,:) :: buff
      end type hst_buff

      integer ::   nr_iter, &
                   lev, &
                   indx, &
                   i, &
                   j, &
                   k, &
                   m, &
                   cut_cnt, stp_con_cnt
      real :: interval_done, dt, dti
      real :: max_delta(max(1,clscnt4))
      real, dimension(max(1,imp_nzcnt)) :: &
                   sys_jac, &
                   lin_jac
      real, dimension(max(1,clscnt4)) :: &
                   solution, &
                   forcing, &
                   iter_invariant, &
                   prod, &
                   loss
      real :: lrxt(max(1,rxntot))
      real :: lsol(max(1,pcnstm1))
      real :: lhet(max(1,hetcnt))
      real, dimension(plnplv,max(1,clscnt4)) :: &
                   ind_prd
      logical ::   convergence
      logical ::   frc_mask
      logical ::   converged(max(1,clscnt4))
      integer :: indx_old

!-----------------------------------------------------------------------
!        ... allocate history prod, loss buffers
!-----------------------------------------------------------------------
!     if( moz_file_cnt > 0 ) then
!        allocate( prod_buff(moz_file_cnt), stat=astat )
!         if( astat /= 0 ) then
!            write(*,*) 'imp_slv_init: Failed to allocate prod_buff; error = ',astat
!            call endrun
!         end if
!         do file = 1,moz_file_cnt
!            n = SUM( imp_hst_prod(file)%cnt(:) )
!            if( n > 0 ) then
!              allocate( prod_buff(file)%buff(plnplv,n), stat=astat )
!               if( astat /= 0 ) then
!                  write(*,*) 'imp_slv_init: Failed to allocate prod buff for file = ',file,'; error = ',astat
!                  call endrun
!               end if
!            else
!               nullify( prod_buff(file)%buff )
!            end if
!         end do
!        allocate( loss_buff(moz_file_cnt), stat=astat )
!         if( astat /= 0 ) then
!            write(*,*) 'imp_slv_init: Failed to allocate loss_buff; error = ',astat
!            call endrun
!         end if
!         do file = 1,moz_file_cnt
!            n = SUM( imp_hst_loss(file)%cnt(:) )
!            if( n > 0 ) then
!              allocate( loss_buff(file)%buff(plnplv,n), stat=astat )
!               if( astat /= 0 ) then
!                  write(*,*) 'imp_slv_init: Failed to allocate loss buff for file = ',file,'; error = ',astat
!                  call endrun
!               end if
!            else
!               nullify( loss_buff(file)%buff )
!            end if
!         end do
!     end if

!     if( implicit%indprd_cnt > 0 .or. extcnt > 0 ) then
      if( implicit%indprd_cnt > 0 ) then
!-----------------------------------------------------------------------
!        ... class independent forcing
!-----------------------------------------------------------------------
         call indprd( 4, ind_prd, base_sol, extfrc, reaction_rates )
      else
         do m = 1,max(1,clscnt4)
            ind_prd(:,m) = 0.
         end do
      end if

!-----------------------------------------------------------------------
!        ... Initialize production/loss diagnostics
!-----------------------------------------------------------------------
      do k = 1,clscnt4
         j = implicit%clsmap(k)
         prod_out(:,j) = 0.
         loss_out(:,j) = 0.
      end do
!for ox budget (jmao, 1/1/2011)
      prod_ox(:) = 0.
      loss_ox(:) = 0.
      non_convergence(:) = 0.


level_loop : &
!++lwh
!     do lev = 1,plev
      do lev = 1,plnplv/plonl
!--lwh
lon_tile_loop : &
         do i = 1,plonl
            indx = (lev - 1)*plonl + i
            indx_old = 0
!-----------------------------------------------------------------------
!        ... transfer from base to local work arrays
!-----------------------------------------------------------------------
            do m = 1,rxntot
               lrxt(m) = reaction_rates(indx,m)
            end do
            if( hetcnt > 0 ) then
               do m = 1,hetcnt
                  lhet(m) = het_rates(indx,m)
                end do
            end if
!-----------------------------------------------------------------------
!        ... time step loop
!-----------------------------------------------------------------------
            dt            = delt
            cut_cnt       = 0
            stp_con_cnt   = 0
            interval_done = 0.
time_step_loop : &
            do
               dti = 1. / dt
!-----------------------------------------------------------------------
!        ... transfer from base to local work arrays
!-----------------------------------------------------------------------
               do m = 1,pcnstm1
                  lsol(m) = base_sol(indx,m)
               end do
!-----------------------------------------------------------------------
!        ... transfer from base to class array
!-----------------------------------------------------------------------
               do k = 1,clscnt4
                  j = implicit%clsmap(k)
                  m = implicit%permute(k)
                  solution(m) = lsol(j)
               end do
!-----------------------------------------------------------------------
!        ... set the iteration invariant part of the function f(y)
!        ... if there is "independent" production put it in the forcing
!-----------------------------------------------------------------------
               if( implicit%indprd_cnt > 0 .or. extcnt > 0 ) then
                  do m = 1,clscnt4
                     iter_invariant(m) = dti * solution(m) + ind_prd(indx,m)
                  end do
               else
                  do m = 1,clscnt4
                     iter_invariant(m) = dti * solution(m)
                  end do
               end if
!-----------------------------------------------------------------------
!        ... the linear component
!-----------------------------------------------------------------------
               if( implicit%lin_rxt_cnt > 0 ) then
                  call imp_linmat( lin_jac, lsol, lrxt, lhet )
               else
                  do j = 1,clscnt4
                     m = implicit%diag_map(j)
                     lin_jac(m) = -dti
                  end do
               end if

!=======================================================================
!        the newton-raphson iteration for f(y) = 0
!=======================================================================
iter_loop : &
               do nr_iter = 1,implicit%iter_max
!-----------------------------------------------------------------------
!        ... the non-linear component
!-----------------------------------------------------------------------
                  if( factor(nr_iter) ) then
                     if( implicit%nln_rxt_cnt > 0 ) then
                        call imp_nlnmat( sys_jac, lsol, lrxt, lin_jac, dti )
                     else
                        do m = 1,imp_nzcnt
                           sys_jac(m) = lin_jac(m)
                        end do
                     end if
!-----------------------------------------------------------------------
!         ... factor the "system" matrix
!-----------------------------------------------------------------------
                     call imp_lu_fac( sys_jac )
                  end if
!-----------------------------------------------------------------------
!           ... form f(y)
!-----------------------------------------------------------------------
                  call imp_prod_loss( prod, loss, lsol, lrxt, lhet )
                  do m = 1,clscnt4
                     forcing(m) = solution(m)*dti - (iter_invariant(m) + prod(m) - loss(m))
                  end do
!-----------------------------------------------------------------------
!         ... solve for the mixing ratio at t(n+1)
!-----------------------------------------------------------------------
                  call imp_lu_slv( sys_jac, forcing )
                  do m = 1,clscnt4
                     solution(m) = solution(m) + forcing(m)
                  end do
!-----------------------------------------------------------------------
!            ... convergence measures
!-----------------------------------------------------------------------
                  if( nr_iter > 1 ) then
                     do k = 1,clscnt4
                        m = implicit%permute(k)
                        if( abs(solution(m)) > 1.e-40 ) then
                           max_delta(k) = abs( forcing(m)/solution(m) )
                        else
                           max_delta(k) = 0.
                        end if
                     end do
                  end if
!-----------------------------------------------------------------------
!           ... limit iterate
!-----------------------------------------------------------------------
                  where( solution(:) < 0. )
                     solution(:) = 0.
                     endwhere
!-----------------------------------------------------------------------
!           ... transfer latest solution back to work array
!-----------------------------------------------------------------------
                  do k = 1,clscnt4
                     j = implicit%clsmap(k)
                     m = implicit%permute(k)
                     lsol(j) = solution(m)
                  end do
!-----------------------------------------------------------------------
!            ... check for convergence
!-----------------------------------------------------------------------
                  if( nr_iter > 1 ) then
                     do k = 1,clscnt4
                        m = implicit%permute(k)
                        frc_mask = abs( forcing(m) ) > small
                        if( frc_mask ) then
                           converged(k) =  abs(forcing(m)) <= epsilon(k)*abs(solution(m))
                        else
                           converged(k) =  .true.
                        end if
                     end do
                     convergence = all( converged(:) )
                     if( convergence ) then
                        exit
                     end if
                  end if
               end do iter_loop

!-----------------------------------------------------------------------
!            ... check for newton-raphson convergence
!-----------------------------------------------------------------------
               if( .not. convergence ) then
!-----------------------------------------------------------------------
!           ... non-convergence
!-----------------------------------------------------------------------
!                  if( pdiags%imp_slv ) then
!                     write(*,'('' imp_sol: Time step '',1p,e21.13,'' Failed to converge'')') dt
!                  end if
                  stp_con_cnt = 0
                  if( cut_cnt < cut_limit ) then
                     cut_cnt = cut_cnt + 1
                     dt = .5 * dt
                     cycle
                  else
!                    write(*,'('' imp_sol: failed to converge @ (lon,lat,lev,dt) = '',3i5,1p,e21.13)') indx,lat,lev,dt
                     non_convergence(indx) = non_convergence(indx) + dt/delt
                     if (indx_old /= indx) then
                        if (verbose >= 3) then
                        write(*,105) lon(i)*r2d,lat(i)*r2d,lev,dt
 105                    format('imp_sol: failed to converge @ (lon,lat,lev,dt) = ', 2f8.2,i5,1p,f12.4)
                        end if
                        if (verbose >= 4) then
                           do m = 1,clscnt4
                              if( .not. converged(m)) then
                                 write(*,'(1x,a8,1x,1pe10.3)') &
                                    tracnam(implicit%clsmap(m)), max_delta(m)
                              end if
                           end do
                        end if
                     else
                        if (verbose >= 4) then
                        write(*,105) lon(i)*r2d,lat(i)*r2d,lev,dt
                        end if
                     end if
                     indx_old = indx
                  end if
               end if
!-----------------------------------------------------------------------
!           ... check for interval done
!-----------------------------------------------------------------------
               interval_done = interval_done + dt
               if( abs( delt - interval_done ) <= .0001 ) then
                  exit
               else
!-----------------------------------------------------------------------
!           ... transfer latest solution back to base array
!-----------------------------------------------------------------------
                  if( convergence ) then
                     stp_con_cnt = stp_con_cnt + 1
                  end if
                  if ( convergence .or. .not. check_convergence ) then
                     do m = 1,pcnstm1
                        base_sol(indx,m) = lsol(m)
                     end do
!++lwh
!-----------------------------------------------------------------------
!        ... Production/loss diagnostics
!-----------------------------------------------------------------------
                     do k = 1,clscnt4
                        j = implicit%clsmap(k)
                        m = implicit%permute(k)
                        prod_out(indx,j) = prod_out(indx,j) + prod(m) * dt/delt
                        loss_out(indx,j) = loss_out(indx,j) + loss(m) * dt/delt
                     end do
!--lwh
                     if( stp_con_cnt >= 2 ) then
                        dt = 2.*dt
                        stp_con_cnt = 0
                        cut_cnt = max( 0,cut_cnt-1 )
                     end if
                  endif
                  dt = min( dt,delt-interval_done )
               end if
            end do time_step_loop
!-----------------------------------------------------------------------
!           ... transfer latest solution back to base array
!-----------------------------------------------------------------------
            if ( convergence .or. .not. check_convergence ) then
               do k = 1,clscnt4
                  j = implicit%clsmap(k)
                  m = implicit%permute(k)
                  base_sol(indx,j) = solution(m)
!++lwh
!-----------------------------------------------------------------------
!        ... Production/loss diagnostics
!-----------------------------------------------------------------------
                  prod_out(indx,j) = prod_out(indx,j) + prod(m) * dt/delt &
                                                      + ind_prd(indx,m)
                  loss_out(indx,j) = loss_out(indx,j) + loss(m) * dt/delt
!--lwh
               end do
            end if
!-----------------------------------------------------------------------
!           ... check for history prod, loss
!-----------------------------------------------------------------------
! hist_buff_loop : &
!            do file = 1,moz_file_cnt
!               do timetype = inst,avrg
!                  fill_buff = imp_hst_prod(file)%do_hst(timetype)
!                  if( timetype == inst ) then
!                     fill_buff = fill_buff .and. hfile(file)%wrhstts
!                  end if
!                 if( fill_buff ) then
!                     hndx = 0
!                     do n = 1,hfile(file)%histout_cnt(14,timetype)
!                        if( timetype == inst ) then
!                           class = hfile(file)%inst_map(hfile(file)%histout_ind(14,inst)+n-1)/1000
!                        else
!                           class = hfile(file)%timav_map(hfile(file)%histout_ind(14,avrg)+n-1)/1000
!                       end if
!                        if( class == 4 ) then
!                           if( timetype == inst ) then
!                              cls_ndx = mod( hfile(file)%inst_map(hfile(file)%histout_ind(14,inst)+n-1),1000 )
!                           else
!                              cls_ndx = mod( hfile(file)%timav_map(hfile(file)%histout_ind(14,avrg)+n-1),1000 )
!                          end if
!                           hndx = hndx + 1
!                           l = implicit%clsmap(cls_ndx)
!                           if( l == ox_ndx ) then
!-----------------------------------------------------------------------
!         ... ozone production (only valid for the troposphere!)
!-----------------------------------------------------------------------
!                          write(*,*)'do_ox_pl is ', do_ox_pl
			      if( do_ox_pl ) then
                                   prod_ox(indx) = &
                                    (reaction_rates(indx,ox_p1_ndx)*base_sol(indx,ho2_ndx) &
                                    + reaction_rates(indx,ox_p2_ndx) *base_sol(indx,ch3o2_ndx) &
                                    + reaction_rates(indx,ox_p3_ndx) *base_sol(indx,po2_ndx) &
                                    + reaction_rates(indx,ox_p4_ndx) *base_sol(indx,ch3co3_ndx) &
                                    + reaction_rates(indx,ox_p5_ndx) *base_sol(indx,c2h5o2_ndx) &
                                    + .88*reaction_rates(indx,ox_p6_ndx)*base_sol(indx,isopo2_ndx) &
                                    + .985*reaction_rates(indx,ox_p7_ndx)*base_sol(indx,macro2_ndx) &
                                    + reaction_rates(indx,ox_p8_ndx)*base_sol(indx,mco3_ndx) &
                                    + reaction_rates(indx,ox_p9_ndx)*base_sol(indx,c3h7o2_ndx) &
                                    + reaction_rates(indx,ox_p10_ndx)*base_sol(indx,ro2_ndx) &
                                    + reaction_rates(indx,ox_p11_ndx)*base_sol(indx,xo2_ndx)) * base_sol(indx,no_ndx)
!                              end if
!                          else
!                              j = implicit%permute(cls_ndx)
!                             prod_buff(file)%buff(indx,hndx) = prod(j) + ind_prd(indx,j)
!                           end if
!                        end if
!                    end do
!                 end if
!                  fill_buff = imp_hst_loss(file)%do_hst(timetype)
!                  if( timetype == inst ) then
!                     fill_buff = fill_buff .and. hfile(file)%wrhstts
!                  end if
!                 if( fill_buff ) then
!                     hndx = 0
!                     do n = 1,hfile(file)%histout_cnt(15,timetype)
!                        if( timetype == inst ) then
!                           class = hfile(file)%inst_map(hfile(file)%histout_ind(15,inst)+n-1)/1000
!                        else
!                           class = hfile(file)%timav_map(hfile(file)%histout_ind(15,avrg)+n-1)/1000
!                        end if
!                        if( class == 4 ) then
!                           if( timetype == inst ) then
!                              cls_ndx = mod( hfile(file)%inst_map(hfile(file)%histout_ind(15,inst)+n-1),1000 )
!                           else
!                              cls_ndx = mod( hfile(file)%timav_map(hfile(file)%histout_ind(15,avrg)+n-1),1000 )
!                           end if
!                           hndx = hndx + 1
!                           l = implicit%clsmap(cls_ndx)
!                           if( l == ox_ndx ) then
!                             if( do_ox_pl ) then
!-----------------------------------------------------------------------
!         ... ozone destruction (only valid for the troposphere!)
!             also include ox loss from no2+oh, n2o5+aerosol, no3+aerosol
!-----------------------------------------------------------------------
!	                         k = indx
                                   loss_ox(indx) = reaction_rates(indx,ox_l2_ndx) *base_sol(indx,oh_ndx) &
                                   + reaction_rates(indx,ox_l3_ndx) *base_sol(indx,ho2_ndx) &
                                   + reaction_rates(indx,ox_l6_ndx) *base_sol(indx,c2h4_ndx) &
                                   + reaction_rates(indx,ox_l4_ndx) *base_sol(indx,c3h6_ndx) &
                                   + .9*reaction_rates(indx,ox_l5_ndx) *base_sol(indx,isop_ndx) &
                                   + .8*(reaction_rates(indx,ox_l7_ndx)*base_sol(indx,mvk_ndx) &
                                         + reaction_rates(indx,ox_l8_ndx)*base_sol(indx,macro2_ndx)) &
                                   + .235*reaction_rates(indx,ox_l9_ndx)*base_sol(indx,c10h16_ndx) &
                                   + (reaction_rates(indx,usr4_ndx) * base_sol(indx,no2_ndx) * base_sol(indx,oh_ndx) &
                                      + 3. * reaction_rates(indx,usr16_ndx) * base_sol(indx,n2o5_ndx) &
                                      + 2. * reaction_rates(indx,usr17_ndx) * base_sol(indx,no3_ndx)) &
                                     /max( base_sol(indx,ox_ndx),1.e-20 )
! here I sperate the o1d term because we need ozone implicitly from o1d.
                                     loss_ox(indx)=loss_ox(indx)*base_sol(indx,ox_ndx)&
                                   +reaction_rates(indx,ox_l1_ndx)*base_sol(indx,o1d_ndx)*base_sol(indx,h2o_ndx)
                                   prod_ox(indx)=max(prod_ox(indx),0.0)
                                   loss_ox(indx)=max(loss_ox(indx),0.0)
                             end if
!                             write(*,*)prod_ox(k)
!                           else
!                              j = implicit%permute(cls_ndx)
!                             loss_buff(file)%buff(indx,hndx) = loss(j)
!                           end if
!                       end if
!                    end do
!                 end if
!              end do
!           end do hist_buff_loop
         end do lon_tile_loop
      end do level_loop

!-----------------------------------------------------------------------
!       ... check for implicit species production and loss output
!           first check production; instantaneous then time averaged
!           then  check loss; instantaneous then time averaged
!-----------------------------------------------------------------------
!     do file = 1,moz_file_cnt
!         do timetype = inst,avrg
!           dump_buff = imp_hst_prod(file)%do_hst(timetype)
!            if( timetype == inst ) then
!               dump_buff = dump_buff .and. hfile(file)%wrhstts
!            end if
!           if( dump_buff ) then
!               hndx = 0
!               do n = 1,hfile(file)%histout_cnt(14,timetype)
!                  if( timetype == inst ) then
!                     class = hfile(file)%inst_map(hfile(file)%histout_ind(14,timetype)+n-1)/1000
!                  else
!                     class = hfile(file)%timav_map(hfile(file)%histout_ind(14,timetype)+n-1)/1000
!                  end if
!                  if( class == 4 ) then
!                     if( timetype == inst ) then
!                        cls_ndx = mod( hfile(file)%inst_map(hfile(file)%histout_ind(14,inst)+n-1),1000 )
!                        fldname = hfile(file)%hist_inst(hfile(file)%histout_ind(14,timetype)+n-1)
!                     else
!                        cls_ndx = mod( hfile(file)%timav_map(hfile(file)%histout_ind(14,avrg)+n-1),1000 )
!                        fldname = hfile(file)%hist_timav(hfile(file)%histout_ind(14,timetype)+n-1)
!                     end if
!                     hndx        = hndx + 1
!                     wrk_buff(:) = prod_buff(file)%buff(:,hndx) * hnm(:)
!                     call outfld( fldname, wrk_buff, plonl, ip, lat, file )
!                 end if
!              end do
!           end if
!           dump_buff = imp_hst_loss(file)%do_hst(timetype)
!            if( timetype == inst ) then
!               dump_buff = dump_buff .and. hfile(file)%wrhstts
!            end if
!           if( dump_buff ) then
!               hndx = 0
!               do n = 1,hfile(file)%histout_cnt(15,timetype)
!                  if( timetype == inst ) then
!                     class = hfile(file)%inst_map(hfile(file)%histout_ind(15,timetype)+n-1)/1000
!                  else
!                     class = hfile(file)%timav_map(hfile(file)%histout_ind(15,timetype)+n-1)/1000
!                  end if
!                  if( class == 4 ) then
!                     if( timetype == inst ) then
!                        cls_ndx = mod( hfile(file)%inst_map(hfile(file)%histout_ind(15,inst)+n-1),1000 )
!                        fldname = hfile(file)%hist_inst(hfile(file)%histout_ind(15,timetype)+n-1)
!                     else
!                        cls_ndx = mod( hfile(file)%timav_map(hfile(file)%histout_ind(15,avrg)+n-1),1000 )
!                        fldname = hfile(file)%hist_timav(hfile(file)%histout_ind(15,timetype)+n-1)
!                     end if
!                     hndx        = hndx + 1
!                     l           = implicit%clsmap(cls_ndx)
!                    wrk_buff(:) = loss_buff(file)%buff(:,hndx) * hnm(:) * base_sol(:,l)
!                     call outfld( fldname, wrk_buff, plonl, ip, lat, file )
!                 end if
!              end do
!           end if
!        end do
!     end do

!     if( allocated( prod_buff ) ) then
!         do file = 1,moz_file_cnt
!            if( associated( prod_buff(file)%buff ) ) then
!               deallocate( prod_buff(file)%buff )
!            end if
!         end do
!         deallocate( prod_buff )
!     end if
!     if( allocated( loss_buff ) ) then
!         do file = 1,moz_file_cnt
!            if( associated( loss_buff(file)%buff ) ) then
!               deallocate( loss_buff(file)%buff )
!            end if
!         end do
!         deallocate( loss_buff )
!     end if

      end subroutine imp_sol

      end module mo_imp_sol_mod

module fv_physics_mod

! Note: the option "use_tendency = .true." will not be reproducible
!       this is because winds on the physics grid need to be saved
!       in the restart file. This is a to-do item since there is no
!       clear benefit at this point for doing so.

!-----------------------------------------------------------------------
!
!        interface for FV dynamics with atmospheric physics
!
!-----------------------------------------------------------------------
use      time_manager_mod, only: time_type, get_time, operator(-)
use               fms_mod, only: error_mesg, FATAL, write_version_number, &
                                 clock_flag_default, NOTE, WARNING
use    physics_driver_mod, only: physics_driver_init,   &
                                 physics_driver_end,    &
                                 physics_driver_moist_init, &
                                 physics_driver_moist_end, &
                                 physics_driver_down_time_vary, &
                                 physics_driver_up_time_vary,  &
                                 physics_driver_down_endts,  &
                                 physics_driver_up_endts, &
                                 physics_driver_down,   &
                                 physics_driver_up,     &
                                 surf_diff_type
use     field_manager_mod, only: MODEL_ATMOS
use    tracer_manager_mod, only: get_tracer_index, NO_TRACER

!use    fv_pack,       only: nlon, mlat, nlev, beglat, endlat,          &
!                            nt_phys, nt_prog, ncnst, beglon, endlon,   &
!                            u, v, pt, q, ua, va, delp, phis, pe, peln, &
!                            omga, rlat, rlon, area, rlonb, rlatb,      &
!                            u_phys, v_phys, t_phys, q_phys,            &
!                            use_tendency, get_eta_level
use    fv_pack,       only: nlon, mlat, beglat, endlat,          &
                            nt_phys, nt_prog, beglon, endlon,   &
                            rlat, rlon, area, rlonb, rlatb,      &
                            use_tendency, get_eta_level, fv_domain
use     timingModule, only: timing_on, timing_off

use    atmos_co2_mod, only: atmos_co2_rad, co2_radiation_override
use  atmos_nudge_mod, only: atmos_nudge_init, atmos_nudge_end
use    constants_mod, only: rdgas, grav, rvgas, WTMAIR, WTMCO2

use mpp_mod, only: stdout, stderr, mpp_error, mpp_clock_id, &
     mpp_clock_begin, mpp_clock_end, CLOCK_MODULE_DRIVER
use update_fv_phys_mod, only: update_fv_phys
use fv_arrays_mod, only: fv_array_limits, fv_array_sync
use    mpp_mod,       only: mpp_pe, mpp_root_pe
use   mpp_domains_mod,only: mpp_global_sum, BITWISE_EXACT_SUM

#ifdef _OPENMP
use omp_lib
#endif
!-----------------------------------------------------------------------

implicit none
private

public   fv_physics_down, fv_physics_up,  &
         fv_physics_init, fv_physics_end
public   surf_diff_type

!-----------------------------------------------------------------------
character(len=128) :: version = '$Id: fv_physics.F90,v 20.0 2013/12/13 23:08:17 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
!-----------------------------------------------------------------------

   real zvir, rrg, ginv
   logical :: do_atmos_nudge
!RSH make module variable:
   integer :: sphum

   integer :: isw, iew, jsw, jew !window start/end in global index space
   integer :: nx_win, ny_win !iew-isw+1, jew-jsw+1 (window sizes)
   integer :: nx_dom, ny_dom !ie-is+1, je-js+1 (compute domain sizes)
!MPP clocks
   integer :: id_fv_physics_down, id_fv_physics_up, id_update_fv_phys

! Auto arrays:
   real, allocatable, dimension(:,:,:) :: p_full, z_full, p_half, z_half
   integer, allocatable, dimension(:)  :: physics_window_x, physics_window_y
   integer :: numthreads, ny_per_thread, num_phys_windows
!#include "omp.h"

contains


  subroutine fv_physics_init (axes, Time, window, Surf_diff)
#include "fv_arrays.h"
!-----------------------------------------------------------------------
!
!   axes      = array of axis indices for diagnostics (x,y,pf,ph)
!   Time      = current time (time_type)
!
!-----------------------------------------------------------------------
    integer,               intent(in)    :: axes(4)
    type (time_type),      intent(in)    :: Time
    integer,               intent(in)    :: window(2)
    type (surf_diff_type), intent(inout) :: Surf_diff
!-----------------------------------------------------------------------
    real, dimension(nlev+1,2) :: pref
!-----------------------------------------------------------------------
!RSHinteger :: i, j, k, sphum
    integer :: i, j, k
    integer :: ios
    character(len=80) evalue
!-----------------------------------------------------------------------
    real p_edge(nlon,beglat:endlat,nlev+1)  ! used by atmos_tracer_driver_init
    real phalf(nlev+1)
    character(len=132) :: text
    real, allocatable :: rlonb2d(:,:), rlatb2d(:,:)
    integer :: unit
#include "fv_point.inc"

    zvir = rvgas/rdgas - 1.
    ginv = 1./ grav
    rrg = rdgas / grav        

!----- write version to logfile --------

    call write_version_number(version, tagname)

!---------- reference profile -----------

    pref(nlev+1,1) = 101325.
    pref(nlev+1,2) = 81060.

    call get_eta_level ( nlev, pref(nlev+1,1), pref(1,1), phalf )
    call get_eta_level ( nlev, pref(nlev+1,2), pref(1,2), phalf )

!------- pressure at model layer interfaces -----

    do k=1,nlev+1
       do j=beglat,endlat
          do i=beglon,endlon
             p_edge(i,j,k) = pe(i,k,j)
          enddo
       enddo
    enddo

!---------- initialize physics -------
    allocate( rlonb2d( size(rlonb), size(rlatb) ) )
    allocate( rlatb2d( size(rlonb), size(rlatb) ) )
    do j = 1, size(rlatb)
       rlonb2d(:,j) = rlonb(:)
    end do
    do i = 1, size(rlonb)
       rlatb2d(i,:) = rlatb(:)
    end do

    call physics_driver_init(Time, &
         rlonb2d(beglon:endlon+1,beglat:endlat+1), &
         rlatb2d(beglon:endlon+1,beglat:endlat+1), &
         rlonb2d(beglon:endlon+1,beglat:endlat+1), & !dummy argument needed for interface change
         rlatb2d(beglon:endlon+1,beglat:endlat+1), & !dummy argument needed for interface change
         axes, pref, q(beglon:endlon,beglat:endlat,:,1:ncnst), &
         Surf_diff, p_edge(beglon:endlon,:,:) )
!    call physics_driver_init(Time, rlonb, rlatb(beglat:endlat+1), &
!                             axes, pref, q(:,beglat:endlat,:,1:ncnst), &
!                             Surf_diff, p_edge )

! Specific humidity is assumed to be q(:,:,:,1)
    sphum = get_tracer_index (MODEL_ATMOS, 'sphum' )
    if(sphum /= 1) call error_mesg('fv_physics_init:','sphum /= 1', FATAL)

!--- initialize nudging module ---
    call atmos_nudge_init ( Time, axes(1:3), flag=do_atmos_nudge )
!physics window
    nx_win = window(1)
    ny_win = window(2)
    nx_dom = endlon - beglon + 1
    ny_dom = endlat - beglat + 1
    if( nx_win.LE.0 )nx_win = nx_dom
    if( ny_win.LE.0 )ny_win = ny_dom
    if( mod(nx_dom,nx_win).NE.0 )then
        write( text,'(a,2i4)' )'FV_PHYSICS_INIT: atmosphere_nml problem,'// &
             ' physics_window must divide domain size: ',  nx_win, nx_dom
        call mpp_error( FATAL, text )
    end if
    if( mod(ny_dom,ny_win).NE.0 )then
        write( text,'(a,2i4)' )'FV_PHYSICS_INIT: atmosphere_nml problem,'// &
             ' physics_window must divide domain size: ',  ny_win, ny_dom
        call mpp_error( FATAL, text )
    end if
    allocate( p_full(beglon:endlon,beglat:endlat,nlev) )
    allocate( z_full(beglon:endlon,beglat:endlat,nlev) )
    allocate( p_half(beglon:endlon,beglat:endlat,nlev+1) )
    allocate( z_half(beglon:endlon,beglat:endlat,nlev+1) )
!MPP clocks
    id_fv_physics_down = mpp_clock_id( 'FV_PHYSICS_DOWN', &
         flags=clock_flag_default, grain=CLOCK_MODULE_DRIVER )
    id_fv_physics_up = mpp_clock_id( 'FV_PHYSICS_UP', &
         flags=clock_flag_default, grain=CLOCK_MODULE_DRIVER )
    id_update_fv_phys = mpp_clock_id( 'UPDATE_FV_PHYS', &
         flags=clock_flag_default, grain=CLOCK_MODULE_DRIVER )

    numthreads = 1
!$OMP PARALLEL
!$OMP MASTER
!$       numthreads = omp_get_num_threads()
!$OMP END MASTER
!$OMP END PARALLEL

    if ( mpp_pe()==mpp_root_pe() ) then
      unit = stdout()
      write(unit,*) 'Starting Threads : ', numthreads
    endif
    ny_per_thread = max (1,ny_win/numthreads)


    num_phys_windows = (nx_dom/nx_win)*(ny_dom/ny_win) 
    write(text,'(a,2i4)') 'num_phys_windows, numthreads',num_phys_windows,numthreads
    call error_mesg ('fv_physics_init', trim(text), NOTE)
    write(text,'(a,4i4)') '  nx_dom, ny_dom, nx_win, ny_win', nx_dom, ny_dom, nx_win, ny_win
    call error_mesg ('fv_physics_init', trim(text), NOTE)
    allocate(physics_window_x(num_phys_windows))
    allocate(physics_window_y(num_phys_windows))
    i = 1 
    do jsw = beglat,endlat,ny_win
       do isw = beglon,endlon,nx_win
          physics_window_x(i) =isw
          physics_window_y(i) =jsw
          i = i + 1
       enddo
    enddo
    
    
      end subroutine fv_physics_init


  subroutine fv_physics_down(dt_phys,Time_prev, Time, Time_next, &
       frac_land,   albedo,        &
       albedo_vis_dir, albedo_nir_dir, &
       albedo_vis_dif, albedo_nir_dif, &
       rough_vel,   t_surf,        &
       u_star, b_star, q_star,     &
       dtau_du, dtau_dv, tau_x, tau_y, &
       flux_sw,                    &
       flux_sw_dir, flux_sw_dif,   &
       flux_sw_down_vis_dir,       &
       flux_sw_down_vis_dif,       &
       flux_sw_down_total_dir,     &
       flux_sw_down_total_dif,     &
       flux_sw_vis, flux_sw_vis_dir, &
       flux_sw_vis_dif,            &
       flux_lw, coszen,            &
       gust, Surf_diff, frac_open_sea )
#include "fv_arrays.h"

!-----------------------------------------------------------------------
!
!   Time_prev =  time at the previous time level, tau-1 (time_type)
!   Time      =  time at the current time level,  tau   (time_type)
!   Time_next =  time at the next time level,     tau+1 (time_type)
!
!   NOTE: for a two time level scheme (e.g., forward-backward scheme)
!         Time_prev = Time.
!
!-----------------------------------------------------------------------
    real,    intent(in)           :: dt_phys
    type(time_type),intent(in)    :: Time_prev, Time, Time_next

    real, intent(in),    dimension(beglon:endlon,beglat:endlat) :: &
         frac_land,  albedo,   &
         albedo_vis_dir, albedo_nir_dir, &
         albedo_vis_dif, albedo_nir_dif, &
         rough_vel,  t_surf,   &
         u_star,     b_star, &
         q_star,     dtau_du, dtau_dv, frac_open_sea

    real, intent(inout), dimension(beglon:endlon,beglat:endlat) :: &
         tau_x, tau_y
    real, intent(out),   dimension(beglon:endlon,beglat:endlat) :: &
         flux_sw,  flux_sw_dir, flux_sw_dif,&
         flux_sw_down_vis_dir,       &
         flux_sw_down_vis_dif,       &
         flux_sw_down_total_dir,     &
         flux_sw_down_total_dif,     &
         flux_sw_vis,                &
         flux_sw_vis_dir,            &
         flux_sw_vis_dif,            &
         flux_lw, coszen, gust

    type(surf_diff_type), intent(inout):: Surf_diff

!-----------------------------------------------------------------------
    integer :: i, j, k, m, idx, phys_loop
    real :: rdt, gavg_rrv(nt_prog)
    integer :: is_w, ie_w, js_w, je_w
    real    :: dt 
    integer :: sec, day

#include "fv_point.inc"

!---------------------------- do physics -------------------------------

    rdt = 1. / dt_phys

!----------------------------------------------------------------------
! obtain pressure-weighted global mean co2 dry volume mixing ratio for
! use by radiation package.
!----------------------------------------------------------------------
    gavg_rrv = 0.
! check if to override predicted global pressure-weighted rad co2
    idx = get_tracer_index(MODEL_ATMOS, 'co2')
    if(idx /= NO_TRACER .and. co2_radiation_override) then
      call atmos_co2_rad(Time, gavg_rrv(idx))
    elseif (idx /= NO_TRACER) then
      call compute_g_avg(gavg_rrv, 'co2')
    endif  
!---------------------------------------------------------------------
! compute the physics time step (from tau-1 to tau+1).
!---------------------------------------------------------------------
    call get_time (Time_next-Time_prev, sec, day)
    dt = real(sec+day*86400)
 
!---------------------------------------------------------------------
! call physics_driver_down_time_vary to do the time-dependent, spatially
! independent calculations before entering windows / threads loop. 
!--------------------------------------------------------------------- 
    call physics_driver_down_time_vary (Time, Time_next, gavg_rrv, dt)


    call mpp_clock_begin(id_fv_physics_down)

!isw,iew,jsw,jew are in global index space
    call compute_p_z( beglon, beglat, nx_dom, ny_dom )
!$OMP parallel do schedule(dynamic) default(shared) private(phys_loop, isw, iew, jsw, jew, m, k, j, i)
    do phys_loop = 1, size(physics_window_y)!num_phys_windows
       jsw = physics_window_y(phys_loop)
       jew = jsw + ny_win - 1
       isw = physics_window_x(phys_loop)
       iew = isw + nx_win - 1
          if ( use_tendency ) then
              do k=1,nlev
                 do j = jsw,jew
                    do i=isw,iew
                       u_dt(i,j,k) = (ua(i,j,k) - u_phys(i,j,k)) * rdt
                       v_dt(i,j,k) = (va(i,j,k) - v_phys(i,j,k)) * rdt
                       t_dt(i,j,k) = (pt(i,j,k) - t_phys(i,j,k)) * rdt
                    end do
                 enddo
              enddo

              do m=1,nt_prog
                 do k=1,nlev
                    do j = jsw,jew
                       do i=isw,iew
                          q_dt(i,j,k,m) = (q(i,j,k,m)-q_phys(i,j,k,m)) * rdt
                       enddo
                    end do
                 enddo
              enddo
!isw-beglon+1 are wrt domain index space
              call physics_driver_down                                       &
                   ( isw-beglon+1, iew-beglon+1, jsw-beglat+1, jew-beglat+1, &
                   Time_prev, Time, Time_next                              , &
                   rlat(isw:iew,jsw:jew) , rlon(isw:iew,jsw:jew)           , &
                   area(isw:iew,jsw:jew) , &
                   p_half(isw-is_w+1:iew-is_w+1,jsw-js_w+1:jew-js_w+1,:), &
                   p_full(isw-is_w+1:iew-is_w+1,jsw-js_w+1:jew-js_w+1,:), &
                   z_half(isw-is_w+1:iew-is_w+1,jsw-js_w+1:jew-js_w+1,:), &
                   z_full(isw-is_w+1:iew-is_w+1,jsw-js_w+1:jew-js_w+1,:), &
                   p_half(isw-is_w+1:iew-is_w+1,jsw-js_w+1:jew-js_w+1,:), &
                   u_phys(isw:iew,jsw:jew,:), v_phys(isw:iew,jsw:jew,:)    , &
                   t_phys(isw:iew,jsw:jew,:), q_phys(isw:iew,jsw:jew,:,1)  , &
                   q_phys(isw:iew,jsw:jew,:,:)                             , &
                   u_phys(isw:iew,jsw:jew,:), v_phys(isw:iew,jsw:jew,:)    , &
                   t_phys(isw:iew,jsw:jew,:), q_phys(isw:iew,jsw:jew,:,1)  , &
                   q_phys(isw:iew,jsw:jew,:,:)                             , &
                   frac_land(isw:iew,jsw:jew), rough_vel(isw:iew,jsw:jew)  , &
                   frac_open_sea(isw:iew,jsw:jew)                          , &
                   albedo   (isw:iew,jsw:jew)                              , &
                   albedo_vis_dir(isw:iew,jsw:jew)                         , &
                   albedo_nir_dir(isw:iew,jsw:jew)                         , &
                   albedo_vis_dif(isw:iew,jsw:jew)                         , &
                   albedo_nir_dif(isw:iew,jsw:jew)                         , &
                   t_surf   (isw:iew,jsw:jew), u_star   (isw:iew,jsw:jew)  , &
                   b_star   (isw:iew,jsw:jew), q_star   (isw:iew,jsw:jew)  , &
                   dtau_du  (isw:iew,jsw:jew), dtau_dv  (isw:iew,jsw:jew)  , &
                   tau_x    (isw:iew,jsw:jew), tau_y    (isw:iew,jsw:jew)  , &
                   u_dt     (isw:iew,jsw:jew,:), v_dt(isw:iew,jsw:jew,:)   , &
                   t_dt     (isw:iew,jsw:jew,:), q_dt(isw:iew,jsw:jew,:,1) , &
                   q_dt     (isw:iew,jsw:jew,:,1:nt_prog)                  , &
                   flux_sw               (isw:iew,jsw:jew)                 , &
                   flux_sw_dir           (isw:iew,jsw:jew)                 , &
                   flux_sw_dif           (isw:iew,jsw:jew)                 , &
                   flux_sw_down_vis_dir  (isw:iew,jsw:jew)                 , &
                   flux_sw_down_vis_dif  (isw:iew,jsw:jew)                 , &
                   flux_sw_down_total_dir(isw:iew,jsw:jew)                 , &
                   flux_sw_down_total_dif(isw:iew,jsw:jew)                 , &
                   flux_sw_vis           (isw:iew,jsw:jew)                 , &
                   flux_sw_vis_dir       (isw:iew,jsw:jew)                 , &
                   flux_sw_vis_dif       (isw:iew,jsw:jew)                 , &
                   flux_lw               (isw:iew,jsw:jew)                 , &
                   coszen                (isw:iew,jsw:jew)                 , &
                   gust                  (isw:iew,jsw:jew)                 , &
                   Surf_diff, gavg_rrv                                     )
          else
              do k=1,nlev
                 do j = jsw,jew
                    do i=isw,iew
                       u_dt(i,j,k) = 0.
                       v_dt(i,j,k) = 0.
                       t_dt(i,j,k) = 0.
                    enddo
                 end do
              enddo

              do m=1,nt_prog
                 do k=1,nlev
                    do j = jsw,jew
                       do i=isw,iew
                          q_dt(i,j,k,m) = 0.
                       enddo
                    end do
                 enddo
              enddo
!isw-beglon+1 are wrt domain index space
              call physics_driver_down                                       &
                   ( isw-beglon+1, iew-beglon+1, jsw-beglat+1, jew-beglat+1, &
                   Time_prev, Time, Time_next                              , &
                   rlat(isw:iew,jsw:jew), rlon(isw:iew,jsw:jew), &
                   area(isw:iew,jsw:jew) , &
                   p_half(isw:iew,jsw:jew,:),&
                   p_full(isw:iew,jsw:jew,:),&
                   z_half(isw:iew,jsw:jew,:),&
                   z_full(isw:iew,jsw:jew,:),&
                   p_half(isw:iew,jsw:jew,:),&
                   ua (isw:iew,jsw:jew,:), va (isw:iew,jsw:jew,:)          , &
                   pt (isw:iew,jsw:jew,:), q  (isw:iew,jsw:jew,:,1)        , &
                   q  (isw:iew,jsw:jew,:,:)                                , &
                   ua (isw:iew,jsw:jew,:), va (isw:iew,jsw:jew,:)          , &
                   pt (isw:iew,jsw:jew,:), q  (isw:iew,jsw:jew,:,1)        , &
                   q  (isw:iew,jsw:jew,:,:)                                , &
                   frac_land(isw:iew,jsw:jew), rough_vel(isw:iew,jsw:jew), &
                   frac_open_sea(isw:iew,jsw:jew)                          , &
                   albedo   (isw:iew,jsw:jew)     ,&
                   albedo_vis_dir(isw:iew,jsw:jew),&
                   albedo_nir_dir(isw:iew,jsw:jew),&
                   albedo_vis_dif(isw:iew,jsw:jew),&
                   albedo_nir_dif(isw:iew,jsw:jew),&
                   t_surf   (isw:iew,jsw:jew), u_star   (isw:iew,jsw:jew),&
                   b_star   (isw:iew,jsw:jew), q_star   (isw:iew,jsw:jew),&
                   dtau_du  (isw:iew,jsw:jew), dtau_dv  (isw:iew,jsw:jew),&
                   tau_x    (isw:iew,jsw:jew), tau_y    (isw:iew,jsw:jew),&
                   u_dt     (isw:iew,jsw:jew,:), v_dt(isw:iew,jsw:jew,:)   , &
                   t_dt     (isw:iew,jsw:jew,:), q_dt(isw:iew,jsw:jew,:,1) , &
                   q_dt     (isw:iew,jsw:jew,:,1:nt_prog)                  , &
                   flux_sw               (isw:iew,jsw:jew),&
                   flux_sw_dir           (isw:iew,jsw:jew),&
                   flux_sw_dif           (isw:iew,jsw:jew),&
                   flux_sw_down_vis_dir  (isw:iew,jsw:jew),&
                   flux_sw_down_vis_dif  (isw:iew,jsw:jew),&
                   flux_sw_down_total_dir(isw:iew,jsw:jew),&
                   flux_sw_down_total_dif(isw:iew,jsw:jew),&
                   flux_sw_vis           (isw:iew,jsw:jew),&
                   flux_sw_vis_dir       (isw:iew,jsw:jew),&
                   flux_sw_vis_dif       (isw:iew,jsw:jew),&
                   flux_lw               (isw:iew,jsw:jew),&
                   coszen                (isw:iew,jsw:jew),&
                   gust                  (isw:iew,jsw:jew),&
                   Surf_diff, gavg_rrv                                     )
endif
       enddo

    call physics_driver_down_endts (1, 1) !Note that these arguments are not used yet.

    call fv_array_sync
    call mpp_clock_end(id_fv_physics_down)


  end subroutine fv_physics_down


  subroutine fv_physics_up(dt_phys, Time_prev, Time, Time_next, &
       frac_land, Surf_diff, lprec, fprec, gust, u_star, b_star, q_star )
#include "fv_arrays.h"
!-----------------------------------------------------------------------
!
!   Time_prev =  time at the previous time level, tau-1 (time_type)
!   Time      =  time at the current time level,  tau   (time_type)
!   Time_next =  time at the next time level,     tau+1 (time_type)
!
!   NOTE: for a two time level scheme (e.g., forward-backward scheme)
!         Time_prev = Time.
!
!-----------------------------------------------------------------------
    real,           intent(in)    :: dt_phys
    type(time_type),intent(in)    :: Time_prev, Time, Time_next
    real, intent(in),  dimension(beglon:endlon,beglat:endlat)  :: frac_land
    real, intent(out), dimension(beglon:endlon,beglat:endlat)  :: lprec, fprec
    real, intent(inout), dimension(beglon:endlon,beglat:endlat) :: gust
    type(surf_diff_type), intent(inout)                         :: Surf_diff
    real,    intent(in),dimension(beglon:endlon,beglat:endlat)  :: u_star, b_star, q_star

    integer :: is_w, ie_w, js_w, je_w, phys_loop
    integer :: sec, day, npz
    real    :: dt

#include "fv_point.inc"

    call mpp_clock_begin(id_fv_physics_up)
    npz = size(p_full,3)
!---------------------------------------------------------------------
!    compute the physics time step (from tau-1 to tau+1).
!---------------------------------------------------------------------
    call get_time (Time_next-Time_prev, sec, day)
    dt = real(sec+day*86400)
 
    call physics_driver_up_time_vary (Time, Time_next, dt)

    call compute_p_z( beglon, beglat, nx_dom, ny_dom )
    call physics_driver_moist_init (nx_dom, ny_dom,  npz, nt_prog, ncnst) 
!$OMP parallel  do default(shared) private(phys_loop, isw, iew, jsw, jew)
    do phys_loop = 1, size(physics_window_y)!num_phys_windows
       jsw = physics_window_y(phys_loop)
       jew = jsw + ny_win - 1  
       isw = physics_window_x(phys_loop)
       iew = isw + nx_win - 1
          if ( use_tendency ) then

              call physics_driver_up (isw-beglon+1, iew-beglon+1, jsw-beglat+1, jew-beglat+1, &
                   Time_prev, Time, Time_next             , &
                   rlat     (isw:iew,jsw:jew)             , &
                   rlon     (isw:iew,jsw:jew)             , &
                   area     (isw:iew,jsw:jew)             , &
              p_half(isw:iew,jsw:jew,:), p_full(isw:iew,jsw:jew,:), &
              z_half(isw:iew,jsw:jew,:), z_full(isw:iew,jsw:jew,:), &
                   omga     (isw:iew,jsw:jew,:)           , &
                   u_phys   (isw:iew,jsw:jew,:)           , &
                   v_phys   (isw:iew,jsw:jew,:)           , &
                   t_phys   (isw:iew,jsw:jew,:)           , &
                   q_phys   (isw:iew,jsw:jew,:,1)         , &
                   q_phys   (isw:iew,jsw:jew,:,:)         , & ! cjg: pass all tracers
                   u_phys   (isw:iew,jsw:jew,:)           , &
                   v_phys   (isw:iew,jsw:jew,:)           , &
                   t_phys   (isw:iew,jsw:jew,:)           , &
                   q_phys   (isw:iew,jsw:jew,:,1)         , &
                   q_phys   (isw:iew,jsw:jew,:,:)         , & ! cjg: pass all tracers
                   frac_land(isw:iew,jsw:jew)             , &
                   u_star   (isw:iew,jsw:jew)             , &
                   b_star   (isw:iew,jsw:jew)             , &
                   q_star   (isw:iew,jsw:jew)             , &
                   u_dt     (isw:iew,jsw:jew,:)           , &
                   v_dt     (isw:iew,jsw:jew,:)           , &
                   t_dt     (isw:iew,jsw:jew,:)           , &
                   q_dt     (isw:iew,jsw:jew,:,1)         , &
                   q_dt     (isw:iew,jsw:jew,:,1:nt_prog) , &
                   Surf_diff                              , &
                   lprec    (isw:iew,jsw:jew)             , &
                   fprec    (isw:iew,jsw:jew)             , &
                   gust     (isw:iew,jsw:jew)             )
          else
              call physics_driver_up (isw-beglon+1, iew-beglon+1, jsw-beglat+1, jew-beglat+1, &
                   Time_prev, Time, Time_next             , &
                   rlat     (isw:iew,jsw:jew)             , &
                   rlon     (isw:iew,jsw:jew)             , &
                   area     (isw:iew,jsw:jew)             , &
              p_half(isw:iew,jsw:jew,:), p_full(isw:iew,jsw:jew,:), &
              z_half(isw:iew,jsw:jew,:), z_full(isw:iew,jsw:jew,:), &
                   omga     (isw:iew,jsw:jew,:)           , &
                   ua       (isw:iew,jsw:jew,:)           , &
                   va       (isw:iew,jsw:jew,:)           , &
                   pt       (isw:iew,jsw:jew,:)           , &
                   q        (isw:iew,jsw:jew,:,1)         , &
                   q        (isw:iew,jsw:jew,:,:)         , & ! cjg: pass all tracers
                   ua       (isw:iew,jsw:jew,:)           , &
                   va       (isw:iew,jsw:jew,:)           , &
                   pt       (isw:iew,jsw:jew,:)           , &
                   q        (isw:iew,jsw:jew,:,1)         , &
                   q        (isw:iew,jsw:jew,:,:)         , & ! cjg: pass all tracers
                   frac_land(isw:iew,jsw:jew)             , &
                   u_star   (isw:iew,jsw:jew)             , &
                   b_star   (isw:iew,jsw:jew)             , &
                   q_star   (isw:iew,jsw:jew)             , &
                   u_dt     (isw:iew,jsw:jew,:)           , &
                   v_dt     (isw:iew,jsw:jew,:)           , &
                   t_dt     (isw:iew,jsw:jew,:)           , &
                   q_dt     (isw:iew,jsw:jew,:,1)         , &
                   q_dt     (isw:iew,jsw:jew,:,1:nt_prog) , &
                   Surf_diff                              , &
                   lprec    (isw:iew,jsw:jew)             , &
                   fprec    (isw:iew,jsw:jew)             , &
                   gust     (isw:iew,jsw:jew)              )
          endif

    enddo
    call physics_driver_moist_end

    call physics_driver_up_endts(1, 1) !Note that these arguments are not used yet.

    call fv_array_sync()
    call mpp_clock_end(id_fv_physics_up)
!    call timing_on('update_fv')
    call mpp_clock_begin(id_update_fv_phys)
    call update_fv_phys( dt_phys, nt_prog, &
         .true., do_atmos_nudge, Time_next)
    call fv_array_sync()
    call mpp_clock_end(id_update_fv_phys)
!    call timing_off('update_fv')

  end subroutine fv_physics_up



subroutine fv_physics_end (Time)

!-----------------------------------------------------------------------
   type(time_type), intent(in) :: Time
!-----------------------------------------------------------------------
!  NOTE: this is not the dynamics time
!-----------------------------------------------------------------------


    call physics_driver_end (Time)
    call atmos_nudge_end

!-----------------------------------------------------------------------

end subroutine fv_physics_end



subroutine compute_p_z (istart, jstart, isiz, jsiz )
#include "fv_arrays.h"


  integer, intent(in):: istart, jstart, isiz, jsiz
!  real,    intent(out), dimension(isiz,jsiz,nlev)   :: p_full, z_full
!  real,    intent(out), dimension(isiz,jsiz,nlev+1) :: p_half, z_half

! local
  integer i,j,k,id,jd
  real    tvm
#include "fv_point.inc"

!----------------------------------------------------
! Compute pressure and height at full and half levels
!----------------------------------------------------

  do j = 1,jsiz
     jd = j + jstart - 1
     do i=1,isiz
        id = i + istart - 1
!        z_half(i,j,nlev+1) = phis(id,jd) * ginv
        z_half(id,jd,nlev+1) = phis(id,jd) * ginv
     enddo
  end do

  do k=1,nlev+1
     do j = 1,jsiz
        jd = j + jstart - 1
        do i=1,isiz
           id = i + istart - 1
!           p_half(i,j,k) = pe(id,k,jd)
           p_half(id,jd,k) = pe(id,k,jd)
        enddo
     enddo
  end do

  if ( use_tendency ) then
      do k=nlev,1,-1
         do j = 1,jsiz
            jd = j + jstart - 1
            do i=1,isiz
               id = i + istart - 1
               tvm = rrg*t_phys(id,jd,k)*(1.+zvir*q_phys(id,jd,k,1))
! Testing for M30_v1
!                    tvm = rrg*pt(id,jd,k)*(1.+zvir*q(id,jd,k,1))
!               p_full(i,j,k) = delp(id,jd,k)/(peln(id,k+1,jd)-peln(id,k,jd))
!               z_full(i,j,k) = z_half(i,j,k+1) + tvm*(1.-p_half(i,j,k)/p_full(i,j,k))
!               z_half(i,j,k) = z_half(i,j,k+1) + tvm*(peln(id,k+1,jd)-peln(id,k,jd))
               p_full(id,jd,k) = delp(id,jd,k)/(peln(id,k+1,jd)-peln(id,k,jd))
               z_full(id,jd,k) = z_half(id,jd,k+1) + tvm*(1.-p_half(id,jd,k)/p_full(id,jd,k))
               z_half(id,jd,k) = z_half(id,jd,k+1) + tvm*(peln(id,k+1,jd)-peln(id,k,jd))
            enddo
         end do
      enddo
  else
      do k=nlev,1,-1
         do j = 1,jsiz
            jd = j + jstart - 1
            do i=1,isiz
               id = i + istart - 1
               tvm = rrg*pt(id,jd,k)*(1.+zvir*q(id,jd,k,1))
!               p_full(i,j,k) = delp(id,jd,k)/(peln(id,k+1,jd)-peln(id,k,jd))
!               z_full(i,j,k) = z_half(i,j,k+1) + tvm*(1.-p_half(i,j,k)/p_full(i,j,k))
!               z_half(i,j,k) = z_half(i,j,k+1) + tvm*(peln(id,k+1,jd)-peln(id,k,jd))
               p_full(id,jd,k) = delp(id,jd,k)/(peln(id,k+1,jd)-peln(id,k,jd))
               z_full(id,jd,k) = z_half(id,jd,k+1) + tvm*(1.-p_half(id,jd,k)/p_full(id,jd,k))
               z_half(id,jd,k) = z_half(id,jd,k+1) + tvm*(peln(id,k+1,jd)-peln(id,k,jd))
            enddo
         end do
       enddo
     endif

end subroutine compute_p_z
subroutine compute_g_avg(rrv, tracer_name)
#include "fv_arrays.h"

  real,          intent(inout) :: rrv(nt_prog)
  character(len=*), intent(in) :: tracer_name

  real psfc_sum(beglon:endlon,beglat:endlat,1),  &
       qp_sum(beglon:endlon,beglat:endlat,1), &
       qp, s1, s2
  integer j, i, k, idx
#include "fv_point.inc"
  psfc_sum = 0.
  qp_sum = 0.
  idx = get_tracer_index(MODEL_ATMOS, trim(tracer_name))
  if(idx /= NO_TRACER) then
     
     ! Subroutine argument check      
!     if(.not. allocated(pe)) then
!        call error_mesg("compute_g_avg", "pressure array is not available", FATAL)
!     else
!        if(use_tendency) then
!           if(.not. allocated(q_phys)) call error_mesg("compute_g_avg", &
!                "q_phys is not available when use_tendency = .true.", &
!                FATAL)
!        else
!           if(.not. allocated(q)) call error_mesg("compute_g_avg", &
!                "q is not available when use_tendency = .false.", &
!                FATAL)
!        endif
!     endif
     
!---------------------------------------------------------------------
!  define pressure-weighted column mean value of dry mass mixing 
!  ratio  for tracer idx. assumption is that the tracer field q_phys
!  is a moist mass mixing ratio. convert to dry mass mixing ratio by 
!  dividing by (1 - qh2o).
!---------------------------------------------------------------------
     do j=beglat,endlat
        do i = beglon, endlon
           psfc_sum(i,j,1) = pe(i,nlev+1,j)*area(i,j)
           qp = 0.0
           do k = 2, nlev+1
              if(use_tendency) then
                 qp = qp + (q_phys(i,j,k-1,idx)/  &
                                (1.0 - q_phys(i,j,k-1,sphum))) * &
                                             (pe(i,k,j) - pe(i,k-1,j))
              else
                 qp = qp + (q(i,j,k-1, idx)/ &
                                (1.0 - q_phys(i,j,k-1,sphum))) * &
                                            (pe(i,k,j) - pe(i,k-1,j))
              endif
           enddo
           qp_sum(i,j,1) = qp * area(i, j)
        enddo
     enddo
     
!---------------------------------------------------------------------
!    compute global sum of pressure-weighted tracer dry mass mixing 
!    ratio and global pressure.
!---------------------------------------------------------------------
     s1 = mpp_global_sum(fv_domain, psfc_sum, flags=BITWISE_EXACT_SUM)
     s2 = mpp_global_sum(fv_domain, qp_sum, flags=BITWISE_EXACT_SUM)

!---------------------------------------------------------------------
!    produce global mean tracer dry mass mixing ratio.
!---------------------------------------------------------------------
     rrv(idx) = s2 / s1
     !       if(mpp_pe() == mpp_root_pe()) print *, 'Note from PE: ', mpp_pe(), tracer_name, ' dry MASS mixing ratio = ', rrv

!---------------------------------------------------------------------
!    convert the tracer dry mass mixing ratio to the dry volume 
!    mixing ratio.
!---------------------------------------------------------------------

     if (trim(tracer_name).eq.'co2') then
       rrv(idx) = rrv(idx)*WTMAIR/WTMCO2
     !       if(mpp_pe() == mpp_root_pe()) print *, 'Note from PE: ', mpp_pe(), tracer_name, ' dry VOLUME mixing ratio = ', rrv
     endif

  endif
  
end subroutine compute_g_avg

end module fv_physics_mod

MODULE aerosol_cloud_mod

use fms_mod,                   only :  error_mesg, FATAL, mpp_pe,   &
                                       mpp_root_pe, open_namelist_file, &
                                       check_nml_error, close_file,  &
                                       write_version_number, file_exist, &
                                       stdlog
use constants_mod,             ONLY :  grav, cp_air, rdgas, rvgas, tfreeze
use rad_utilities_mod,         ONLY :  aerosol_type
use mpp_mod,                   only :  mpp_clock_id, mpp_clock_begin,  &
                                       mpp_clock_end, CLOCK_LOOP,  &
                                       input_nml_file
use polysvp_mod,               ONLY :  polysvp_l, polysvp_i, polysvp_init, &
                                       polysvp_end
use aerosol_params_mod,        only :  aerosol_params_init, Nfact_du1,  &
                                       Nfact_du2, Nfact_du3, Nfact_du4, &
                                       Nfact_du5, rbar_du1, rbar_du2,   &
                                       rbar_du3, rbar_du4, rbar_du5
USE  aer_ccn_act_mod,          ONLY :  aer_ccn_act_wpdf_m, &
                                       aer_ccn_act_init,  aer_ccn_act_end
USE  ice_nucl_mod,             ONLY :  ice_nucl_wpdf, ice_nucl_wpdf_init, &
                                       ice_nucl_wpdf_end
USE strat_cloud_utilities_mod, ONLY:   strat_cloud_utilities_init, &
                                       diag_id_type, diag_pt_type, &
                                       strat_nml_type, atmos_state_type, &
                                       particles_type, strat_constants_type

implicit none 
private

!--------------------------------------------------------------------------
!---interfaces-------------------------------------------------------------

public   aerosol_cloud, aerosol_cloud_init, aerosol_cloud_end
private  aerosol_effects

!--------------------------------------------------------------------------
!---version number---------------------------------------------------------

Character(len=128) :: Version = '$Id: aerosol_cloud.F90,v 20.0 2013/12/13 23:21:48 fms Exp $'
Character(len=128) :: Tagname = '$Name: tikal $'

!--------------------------------------------------------------------------
!---namelist---------------------------------------------------------------

integer :: rh_act_opt = 2           ! option as to which rh to use for ice
                                    ! nucleation. 1 => use gridbox mean;
                                    ! 2 => use rh in non-cloudy portion of
                                    ! box when the cloudy part of grid box
                                    ! is less than cf_thresh_nucl; use grid
                                    ! box mean otherwise.
real    :: sea_salt_scale_onl = 1.  ! scaling factor to convert seasalt 
                                    ! aerosol tracer to seasalt available
                                    ! for use as condensation nuclei
logical :: reproduce_rk = .true.    ! option to force use of same entries in
                                    ! aerosol activation tables as were used
                                    ! in legacy code; new code fixes an 
                                    ! index offset error.
real    :: var_limit_ice = -999.    ! lower limit to the vertical velocity
                                    ! variance of the pdf used for ice
                                    ! nucleation; default value implies 
                                    ! that no limit is imposed.
real    :: cf_thresh_nucl = 0.98    ! threshold cloud fraction below which
                                    ! the rh of the non-cloudy portion of 
                                    ! the gribox is used in determining
                                    ! ice nucleation (when rh_act_opt is >1)

namelist / aerosol_cloud_nml / rh_act_opt, sea_salt_scale_onl, &
                               reproduce_rk, var_limit_ice, &
                               cf_thresh_nucl



!-------------------------------------------------------------------------

real, parameter    :: d622 = rdgas / rvgas
real, parameter    :: d378 = 1. - d622
integer, parameter :: n_totmass  = 4
integer, parameter :: n_imass = 12

LOGICAL            :: do_var_limit_ice
INTEGER            :: wpdf_offs

integer            :: aero_init, aero_effects, aero_dust, aero_loop1, &
                      aero_loop2, aero_loop3

logical            :: module_is_initialized = .false.
real               :: missing_value = -1.e30


CONTAINS

!#########################################################################

subroutine aerosol_cloud_init (Constants)

!------------------------------------------------------------------------
type(strat_constants_type), intent(in) :: Constants


!-----local variables

      integer :: unit, io, ierr, logunit

!-----------------------------------------------------------------------
      if (module_is_initialized) return

!-------------------------------------------------------------------------
!    process namelist.
!-------------------------------------------------------------------------
#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=aerosol_cloud_nml, iostat=io)
      ierr = check_nml_error(io,'aerosol_cloud_nml')
#else
      if ( file_exist('input.nml')) then
        unit = open_namelist_file ( )
        ierr=1; do while (ierr /= 0)
        read  (unit, nml=aerosol_cloud_nml, iostat=io, end=10)
        ierr = check_nml_error(io,'aerosol_cloud_nml')
        enddo
10      call close_file (unit)
      endif
#endif
 
!-------------------------------------------------------------------------
!    write version and namelist to standard log.
!-------------------------------------------------------------------------
      call write_version_number(version, tagname)
      logunit = stdlog()
      if (mpp_pe() == mpp_root_pe()) &
                                  write (logunit, nml=aerosol_cloud_nml)

      if (var_limit_ice .EQ. -999. ) THEN
        do_var_limit_ice = .false.
      ELSE
        do_var_limit_ice = .true.
      END IF

!-------------------------------------------------------------------------
!    define offset into aerosol activation tables.
!-------------------------------------------------------------------------
      IF (.NOT. (Constants%do_mg_microphys .OR.   & 
                                   Constants%do_mg_ncar_microphys)  & 
                                       .AND. reproduce_rk) THEN
        wpdf_offs =0
      ELSE 
        wpdf_offs = 1
      END IF

!-------------------------------------------------------------------------
!    be sure needed modules have been initialized.
!-------------------------------------------------------------------------
      call strat_cloud_utilities_init
      call polysvp_init
      call aer_ccn_act_init
      call ice_nucl_wpdf_init

!-------------------------------------------------------------------------
!    initialize clocks.
!-------------------------------------------------------------------------
      aero_init = mpp_clock_id ('aerosol_cloud:  initial',   &
                                                      grain = CLOCK_LOOP)
      aero_effects = mpp_clock_id ('aerosol_cloud:  effects',  &
                                                      grain = CLOCK_LOOP)
      aero_dust = mpp_clock_id ('aerosol_cloud:  dust   ',   &
                                                      grain = CLOCK_LOOP)
      aero_loop1 = mpp_clock_id ('aerosol_cloud:  loop1  ',   &
                                                      grain = CLOCK_LOOP)
      aero_loop2 = mpp_clock_id ('aerosol_cloud:  loop2  ',  &
                                                      grain = CLOCK_LOOP)
      aero_loop3 = mpp_clock_id ('aerosol_cloud:  loop3  ',  &
                                                      grain = CLOCK_LOOP)

!-------------------------------------------------------------------------
!    declare module initialized.
!-------------------------------------------------------------------------
      module_is_initialized = .true.


end subroutine aerosol_cloud_init


!#########################################################################

subroutine aerosol_cloud (idim, jdim, kdim, n_diag_4d, Nml, Constants, &
                          Atmos_state, Particles, qa_upd, Aerosol,   &
                          diag_4d, diag_id, diag_pt, otun)                        

!-------------------------------------------------------------------------
integer,                    intent(in)     :: idim, jdim, kdim, n_diag_4d
type(strat_nml_type),       intent(in)     :: Nml
type(strat_constants_type), intent(in)     :: Constants
type(atmos_state_type),     intent(inout)  :: Atmos_state
type(particles_type),       intent(inout)  :: Particles  
REAL, DIMENSION(:,:,:),     INTENT(IN )    :: qa_upd
TYPE(aerosol_type),         INTENT (in)    :: Aerosol  
REAL, DIMENSION( :,:,:,0:), INTENT(INOUT ) :: diag_4d
TYPE(diag_id_type),         intent(in)     :: diag_id
TYPE(diag_pt_type),         intent(in)     :: diag_pt
INTEGER,                    INTENT(IN )    :: otun


!-------------------------------------------------------------------------
!----local variables
      real, dimension(idim, jdim, kdim, n_totmass)  :: totalmass1
      real, dimension(idim, jdim, kdim, n_imass)    :: imass1      
      real, dimension(idim, jdim, kdim)             ::                 &
                                 up_strat, wp2, wp2i, wp2t, thickness, &
                                 ni_sulf, ni_dust, ni_bc, cf, u_i, u_l, &
                                 eslt, esit, qvsl, qvsi, qs_d, qvt
      INTEGER :: i, j, k

!-------------------------------------------------------------------------
!    initialize fields.
!-------------------------------------------------------------------------
      call mpp_clock_begin (aero_init)
      totalmass1 = 0.
      imass1     = 0.
      call mpp_clock_end   (aero_init)

!---------------------------------------------------------------------
!    call aerosol_effects to determine aerosol fields that will impact the 
!    cloud / ice droplet numbers and the bergeron process, if these effects
!    have been activated.
!---------------------------------------------------------------------
      call mpp_clock_begin (aero_effects)
      if (Nml%do_liq_num .or. Nml%do_dust_berg) then
        call aerosol_effects (idim, jdim, kdim, n_diag_4d,  &
                              Atmos_state%phalf, Atmos_state%airdens, &
                              Atmos_state%T_in, Particles%concen_dust_sub,&
                              totalmass1, imass1, Aerosol, Nml, diag_4d,  & 
                              diag_id, diag_pt, otun )
      endif
      call mpp_clock_end   (aero_effects)

!-------------------------------------------------------------------------
!    define the number and mean radius of dust particles present.
!-------------------------------------------------------------------------
      call mpp_clock_begin (aero_dust)
      do k = 1,kdim
        do j=1,jdim
          do i = 1,idim
            Particles%ndust(i,j,k) = Nfact_du1*imass1(i,j,k,8) +   &
                                     Nfact_du2*imass1(i,j,k,9) +   &
                                     Nfact_du3*imass1(i,j,k,10) +  &
                                     Nfact_du4*imass1(i,j,k,11) +  &
                                     Nfact_du5*imass1(i,j,k,12)

            Particles%rbar_dust(i,j,k) = (  &
                                 Nfact_du1*imass1(i,j,k,8)*rbar_du1  +  &
                                 Nfact_du2*imass1(i,j,k,9)*rbar_du2  +  &
                                 Nfact_du3*imass1(i,j,k,10)*rbar_du3  + &
                                 Nfact_du4*imass1(i,j,k,11)*rbar_du4  + &
                                 Nfact_du5*imass1(i,j,k,12)*rbar_du5 ) / &
                                       MAX (Particles%ndust(i,j,k),1.e-10)
          end do
        end do        
      end do        
      call mpp_clock_end (aero_dust)

!-------------------------------------------------------------------------
!    do the following calculations if droplet number is being predicted:
!-------------------------------------------------------------------------
      if (Nml%do_liq_num) then 

!-------------------------------------------------------------------------
!    compute the relevant upward velocity for droplet / ice activation.
!-------------------------------------------------------------------------
        call mpp_clock_begin (aero_loop1)
        do k = 1,kdim
          do j=1,jdim
            do i = 1,idim
              up_strat(i,j,k) = -1.*(((Atmos_state%omega(i,j,k) + &
                                      grav*Atmos_state%Mc(i,j,k))/ &
                                      Atmos_state%airdens(i,j,k)/grav) + &
                                      Atmos_state%radturbten2(i,j,k)* &
                                                                cp_air/grav)
            end do
          end do
        end do
        call mpp_clock_end (aero_loop1)

!-------------------------------------------------------------------------
!    define the layer thickness and variance of the vertical velocity. 
!    call aer_ccn_act_wpdf_m to determine number of activated droplets.
!    this call need not be made if the activation vertical velocity is
!    downward, the rotstayn-klein microphysics is being used, and pdf_clouds
!    are not activated; in such a case, no particles are activated. 
!-------------------------------------------------------------------------
        call mpp_clock_begin (aero_loop2)
        do k = 1,kdim
          do j=1,jdim
            do i = 1,idim
              if ( (Nml%do_pdf_clouds) .or.  &
                   (Constants%do_mg_microphys)  .or.  &
                   (Constants%do_mg_ncar_microphys)  .or.  &
                   (up_strat(i,j,k) >= 0.0) )  then
                thickness(i,j,k) = Atmos_state%deltpg(i,j,k)/  &
                                                Atmos_state%airdens(i,j,k)
                wp2t(i,j,k) = 2.0/(3.0*0.548**2)* &
                      (0.5*(Atmos_state%diff_t(i,j,k) +  &
                                 Atmos_state%diff_t(i,j,min(k+1,KDIM)))/&
                                                     thickness(i,j,k) )**2
                wp2(i,j,k) = MAX (wp2t(i,j,k), Nml%var_limit**2)
                if(diag_id%subgrid_w_variance > 0)   &
                 diag_4d(i,j,k,diag_pt%subgrid_w_variance) = wp2(i,j,k)**0.5
               
                call aer_ccn_act_wpdf_m   &
                      (Atmos_state%T_in(i,j,k), Atmos_state%pfull(i,j,k), &
                       up_strat(i,j,k), wp2(i,j,k), wpdf_offs,   &
                       totalmass1(i,j,k,:), Particles%drop1(i,j,k))

              else
                Particles%drop1(i,j,k) = 0.                
              endif
            end do
          end do
        end do
        call mpp_clock_end   (aero_loop2)

!-------------------------------------------------------------------------
!    if ice nuclei activation is being done via a vertical velocity pdf,
!    execute the following code.
!-------------------------------------------------------------------------
        call mpp_clock_begin (aero_loop3)
        if (Nml%do_ice_nucl_wpdf) THEN
          do k = 1,kdim
            do j = 1,jdim
              do i = 1,idim

!------------------------------------------------------------------------
!    ice nuclei activation may only occur at temps below -5 C.
!------------------------------------------------------------------------
                if (Atmos_state%T_in(i,j,k) .LT. tfreeze - 5.) then

!-----------------------------------------------------------------------
!    place a lower limit on the velocity pdf variance, if desired.
!-----------------------------------------------------------------------
                  IF (do_var_limit_ice) THEN
                    wp2i(i,j,k) = MAX (wp2t(i,j,k), var_limit_ice**2)
                  ELSE
                    wp2i(i,j,k) = wp2(i,j,k)
                  END IF

!------------------------------------------------------------------------
!    define the saturation specific humidities over liquid and ice.
!------------------------------------------------------------------------
                  eslt(i,j,k) = polysvp_l(Atmos_state%T_in(i,j,k))
                  qs_d(i,j,k) = Atmos_state%pfull(i,j,k) - d378*eslt(i,j,k)
                  qs_d(i,j,k) = max(qs_d(i,j,k),eslt(i,j,k))
                  qvsl(i,j,k) = 0.622 *eslt(i,j,k)/qs_d(i,j,k)

                  esit(i,j,k) = polysvp_i(Atmos_state%T_in(i,j,k))
                  qs_d(i,j,k) = Atmos_state%pfull(i,j,k) - d378*esit(i,j,k)
                  qs_d(i,j,k) = max(qs_d(i,j,k),esit(i,j,k))
                  qvsi(i,j,k) = 0.622 *esit(i,j,k)/qs_d(i,j,k)

!------------------------------------------------------------------------
!    define the relative humidities wrt ice and liquid to be used in the 
!    calculation of ice nuclei activation. it may vary based on the nml 
!    variable rh_act_opt.
!------------------------------------------------------------------------
                  IF (rh_act_opt .EQ. 1) THEN
                    qvt(i,j,k) = Atmos_state%qv_In(i,j,k)
                    cf(i,j,k) = 0.
                  ELSE
                    cf(i,j,k) = qa_upd(i,j,k)+ Atmos_state%ahuco(i,j,k)
                    IF (cf(i,j,k) .LT. cf_thresh_nucl) THEN
                      qvt(i,j,k) =  (Atmos_state%qv_in(i,j,k) -   &
                                      cf(i,j,k)*Atmos_State%qs(i,j,k))/ &
                                                           (1. - cf(i,j,k))
                    ELSE
                      qvt(i,j,k) =  Atmos_state%qv_in(i,j,k)
                    ENDIF
                  END IF

                  if (qvt(i,j,k) .LE. 0.0) then
                     qvt(i,j,k) =  MAX(Atmos_state%qv_in(i,j,k), Nml%qmin)
                  endif
                  u_i(i,j,k) =  qvt(i,j,k)/qvsi(i,j,k)
                  u_l(i,j,k) =  qvt(i,j,k)/qvsl(i,j,k)

!--------------------------------------------------------------------------
!    if debugging is active and the relative humidity exceeds 200%, output
!    relevant variables.
!--------------------------------------------------------------------------
                  if (Nml%debugo .and.   &
                                 Atmos_state%T_in(i,j,k) .lt. 260. .and.  &
                                                u_i(i,j,k) .gt. 200. ) then
                    write(otun,*) " +++++++++++++++++++++++ "
                    write(otun,*) " i,j,k ,u_i ", i,j,k,u_i(i,j,k)
                    write(otun,*) " qs, qvsi , qvt, qv ",   &
                                    Atmos_state%qs(i,j,k), qvsi(i,j,k), &
                                     qvt(i,j,k),    Atmos_state%qv_in(i,j,k)
                    write(otun,*) " cf, ahuco,qa_upd,qrat ", cf(i,j,k), &
                                    Atmos_state%ahuco(i,j,k),   &
                                    qa_upd(i,j,k), Atmos_state%qrat(i,j,k)
                    write(otun,*) " qv(i,k) - cf * qs(i,k), (1-cf) " , &
                                    Atmos_state%qv_in(i,j,k) -  &
                                        cf(i,j,k)*Atmos_state%qs(i,j,k), &
                                                               (1-cf(i,j,k))
                    write(otun,*) " +++++++++++++++++++++++ "
                  endif

!-------------------------------------------------------------------------
!    call ice_nucl_wpdf to obtain number of activated ice crystals.
!-------------------------------------------------------------------------
                  call ice_nucl_wpdf (    &
                          Atmos_state%T_in(i,j,k), u_i(i,j,k), u_l(i,j,k),&
                          up_strat(i,j,k), wp2i(i,j,k),  &
                          Atmos_state%zfull(i,j,k), totalmass1(i,j,k,:), &
                          imass1(i,j,k,:), n_totmass, n_imass,   &
                          Particles%crystal1(i,j,k), &
                          Particles%drop1(i,j,k), Particles%hom(i,j,k), &
                          Atmos_state%rh_crit(i,j,k),  &
                          Atmos_state%rh_crit_min(i,j,k), ni_sulf(i,j,k), &
                          ni_dust(i,j,k), ni_bc(i,j,k))
                else
                  ni_sulf(i,j,k) = 0.
                  ni_dust(i,j,k) = 0.
                  ni_bc  (i,j,k) = 0.
                  cf(i,j,k) = missing_value
                  u_i(i,j,k) =  missing_value            
                  u_l(i,j,k) =  missing_value
                endif

!-------------------------------------------------------------------------
!    define the critical relative humidity that was used for ice nuclei 
!    activation, averaged over all spectral intervals (rh_crit). also define
!    the minimum value from any of the spectral regions (rh_crit_min).
!-------------------------------------------------------------------------
                IF (Atmos_state%T_in(i,j,k) .LT. 250.) THEN 
                  Atmos_state%rh_crit(i,j,k) =     &
                                      MAX(Atmos_state%rh_crit(i,j,k), 1.) 
                  Atmos_state%rh_crit_min(i,j,k) =  &
                                  MAX(Atmos_state%rh_crit_min(i,j,k), 1.) 

!-------------------------------------------------------------------------
!    if debugging is active, and the minimum is over 250%, output relevant
!    information.
!-------------------------------------------------------------------------
                  IF ( Nml%debugo ) THEN
                    IF (Atmos_state%rh_crit_min(i,j,k) .GT. 2.5  ) THEN
                      write(otun,*) "MMMMMM RH", i,j,k
                      write(otun,*) " rh_crit_min_1d ",   &
                                           Atmos_state%rh_crit_min(i,j,k)
                    END IF
                  END IF
                ELSE

!-------------------------------------------------------------------------
!    if temp over 250 K, set values to 1.0.
!-------------------------------------------------------------------------
                  Atmos_state%rh_crit(i,j,k) = 1.
                  Atmos_state%rh_crit_min(i,j,k) = 1.
                END IF
              end do
            end do
          end do

!-------------------------------------------------------------------------
!    define various desired diagnostics.
!-------------------------------------------------------------------------

          if ( diag_id%imass7 > 0 )    &   
                        diag_4d(:,:,:,diag_pt%imass7) = imass1(:,:,:,7)

          if(diag_id%potential_crystals > 0)   &
                   diag_4d(:,:,:,diag_pt%potential_crystals) =  &
                                                       Particles%crystal1

          if ( diag_id%rhcrit > 0 )     &  
                    diag_4d(:,:,:,diag_pt%rhcrit) = 100.*Atmos_state%rh_crit

          if ( diag_id%rhcrit_min > 0 )     &  
            diag_4d(:,:,:,diag_pt%rhcrit_min) = 100.*Atmos_state%rh_crit_min

          if ( diag_id%ndust1 > 0 )     &  
               diag_4d(:,:,:,diag_pt%ndust1) = Nfact_du1 *  imass1(:,:,:,8)

          if ( diag_id%ndust2 > 0 )     &  
               diag_4d(:,:,:,diag_pt%ndust2) = Nfact_du2 *  imass1(:,:,:,9)

          if ( diag_id%ndust3 > 0 )     &  
               diag_4d(:,:,:,diag_pt%ndust3) = Nfact_du3 *  imass1(:,:,:,10)
         
          if ( diag_id%ndust4 > 0 )     &  
               diag_4d(:,:,:,diag_pt%ndust4) = Nfact_du4 *  imass1(:,:,:,11)
    
          if ( diag_id%ndust5 > 0 )    &
               diag_4d(:,:,:,diag_pt%ndust5) = Nfact_du5 *  imass1(:,:,:,12)

          if ( diag_id%ni_dust > 0 )   &
                                   diag_4d(:,:,:,diag_pt%ni_dust) = ni_dust

          if ( diag_id%ni_bc > 0 ) diag_4d(:,:,:,diag_pt%ni_bc) = ni_bc

          if ( diag_id%ni_sulf > 0 )      & 
                                    diag_4d(:,:,:,diag_pt%ni_sulf) = ni_sulf

          if (rh_act_opt .ne. 1) then
            if ( diag_id%cfin > 0 ) diag_4d(:,:,:,diag_pt%cfin) = cf
          end if

          if ( diag_id%rhiin > 0 ) diag_4d(:,:,:,diag_pt%rhiin) = u_i

          if ( diag_id%rhlin > 0 ) diag_4d(:,:,:,diag_pt%rhlin) = u_l

        END IF ! do_ice_nucl_wpdf

        if(diag_id%potential_droplets > 0)   &
                      diag_4d(:,:,:,diag_pt%potential_droplets) =   &
                                                        Particles%drop1

        call mpp_clock_end (aero_loop3)
      end if  ! (do_liq_num)

!-------------------------------------------------------------------------


END SUBROUTINE  aerosol_cloud


!#####################################################################

subroutine  aerosol_cloud_end

      module_is_initialized = .false.

      call polysvp_end
      call aer_ccn_act_end
      call ice_nucl_wpdf_end

end subroutine  aerosol_cloud_end

!#########################################################################

 subroutine aerosol_effects (idim,jdim,kdim,n_diag_4d, phalf, airdens, T, &
                            concen_dust_sub, totalmass1, imass1, Aerosol, &
                            Nml, diag_4d, diag_id, diag_pt, otun )

INTEGER,                                   INTENT (in)   :: idim, jdim,  &
                                                            kdim, n_diag_4d
REAL, DIMENSION(idim,jdim,kdim+1),         INTENT(in )   :: phalf
REAL, DIMENSION(idim,jdim,kdim),           INTENT(in )   :: airdens, T 
REAL, DIMENSION(idim,jdim,kdim),           INTENT(inout) :: concen_dust_sub
REAL, DIMENSION(idim,jdim,kdim,n_totmass), INTENT(inout) :: totalmass1
REAL, DIMENSION(idim,jdim,kdim,n_imass),   INTENT(inout) ::  imass1
type(strat_nml_type),                      intent(in)    :: Nml
TYPE(aerosol_type),                        INTENT (in)   :: Aerosol  
REAL, DIMENSION(idim,jdim,kdim,0:n_diag_4d),    &
                                           INTENT(INOUT) ::  diag_4d
TYPE(diag_id_type),                        intent(in)    :: diag_id
TYPE(diag_pt_type),                        intent(in)    :: diag_pt
INTEGER,                                   INTENT (in)   :: otun


      REAL, DIMENSION(idim,jdim,kdim) :: pthickness, concen_all_sub, &
                                         concen_ss_sub, concen_ss_sup
      INTEGER :: i, j, k, na, s
      LOGICAL :: used


!-------------------------------------------------------------------------
!    initialize output field (sub-micron dust content).
!-------------------------------------------------------------------------
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            concen_dust_sub(i,j,k) = 0.
          end do
        end do
      end do

!-------------------------------------------------------------------------
!    initialize local accumulation arrays. 
!-------------------------------------------------------------------------
      if (Nml%use_online_aerosol) then
        do k=1,kdim
          do j=1,jdim
            do i=1,idim
              concen_ss_sub(i,j,k) = 0.
              concen_ss_sup(i,j,k) = 0.
              concen_all_sub(i,j,k) = 0.
            end do
          end do
        end do
      endif

!------------------------------------------------------------------------
!    define layer thickness.
!------------------------------------------------------------------------
      do k=1,kdim
        do j=1,jdim
          do i=1,idim
            if (phalf(i,j,k) < 1.0) then
              pthickness(i,j,k) = (phalf(i,j,k+1) - phalf(i,j,k))/&
                                               grav/airdens(i,j,k)
            else
              pthickness(i,j,k) = log(phalf(i,j,k+1)/ &
                                  phalf(i,j,k))*8.314*T(i,j,k)/(9.8*0.02888)
            end if
          end do
        end do
      end do

!-------------------------------------------------------------------------
!    define the aerosol content in various categories that may be used for
!    droplet or ice crystal nucleation. save various diagnostics as they
!    are calculated.
!-------------------------------------------------------------------------
      if (Nml%do_liq_num) then
        if (Nml%use_online_aerosol) then
          do na = 1,size(Aerosol%aerosol,4)               
            if (trim(Aerosol%aerosol_names(na)) == 'so4' .or. &
                trim(Aerosol%aerosol_names(na)) == 'so4_anthro' .or.&
                trim(Aerosol%aerosol_names(na)) == 'so4_natural')  then
              do k=1,kdim
                do j=1,jdim
                  do i=1,idim
                    totalmass1(i,j,k,1) = totalmass1(i,j,k,1) + &
                                          Aerosol%aerosol(i,j,k,na)
                  end do
                end do
              end do

            else if(trim(Aerosol%aerosol_names(na)) == 'omphilic' .or.&
                   trim(Aerosol%aerosol_names(na)) == 'omphobic')  then
              do k=1,kdim
                do j=1,jdim
                  do i=1,idim
                    totalmass1(i,j,k,4) = totalmass1(i,j,k,4) +  &
                                          Aerosol%aerosol(i,j,k,na)

                  end do
                end do
              end do

            else if(trim(Aerosol%aerosol_names(na)) == 'seasalt1' ) then 
              do k=1,kdim
                do j=1,jdim
                  do i=1,idim
                    concen_ss_sub(i,j,k) = concen_ss_sub(i,j,k) +  &
                                           Aerosol%aerosol(i,j,k,na)
                    imass1(i,j,k,1) = Aerosol%aerosol(i,j,k,na)/  &
                                                         pthickness(i,j,k)
                  end do
                end do
              end do

            else if(trim(Aerosol%aerosol_names(na)) == 'seasalt2') then
              do k=1,kdim
                do j=1,jdim
                  do i=1,idim
                    concen_ss_sub(i,j,k) = concen_ss_sub(i,j,k) +  &
                                           Aerosol%aerosol(i,j,k,na)
                    imass1(i,j,k,2) = Aerosol%aerosol(i,j,k,na)/   &
                                                         pthickness(i,j,k)
                  end do
                end do
              end do

            else if(trim(Aerosol%aerosol_names(na)) == 'seasalt3') then 
              do k=1,kdim
                do j=1,jdim
                  do i=1,idim
                    concen_ss_sup(i,j,k) = concen_ss_sup(i,j,k) +  &
                                           Aerosol%aerosol(i,j,k,na)
                    imass1(i,j,k,3) = Aerosol%aerosol(i,j,k,na)/  &
                                                         pthickness(i,j,k)
                  end do
                end do
              end do

            else if(trim(Aerosol%aerosol_names(na)) == 'seasalt4' ) then 
              do k=1,kdim
                do j=1,jdim
                  do i=1,idim
                    concen_ss_sup(i,j,k) = concen_ss_sup(i,j,k) +  &
                                           Aerosol%aerosol(i,j,k,na)
                    imass1(i,j,k,4) = Aerosol%aerosol(i,j,k,na)/  &
                                                         pthickness(i,j,k)
                  end do
                end do
              end do

            else if(trim(Aerosol%aerosol_names(na)) == 'seasalt5' ) then
              do k=1,kdim
                do j=1,jdim
                  do i=1,idim
                    concen_ss_sup(i,j,k) = concen_ss_sup(i,j,k) +  &
                                           Aerosol%aerosol(i,j,k,na)
                    imass1(i,j,k,5) = Aerosol%aerosol(i,j,k,na)/   &
                                                         pthickness(i,j,k)
                  end do
                end do
              end do
             
            else if(trim(Aerosol%aerosol_names(na)) == 'bcphilic') then 
              do k=1,kdim
                do j=1,jdim
                  do i=1,idim
                    concen_all_sub(i,j,k) = concen_all_sub(i,j,k) +  &
                                            Aerosol%aerosol(i,j,k,na)
                    imass1(i,j,k,6) = Aerosol%aerosol(i,j,k,na)/ &
                                                         pthickness(i,j,k)
                  end do
                end do
              end do

            else if(trim(Aerosol%aerosol_names(na)) == 'bcphobic' ) then 
              do k=1,kdim
                do j=1,jdim
                  do i=1,idim
                    concen_all_sub(i,j,k) = concen_all_sub(i,j,k) +  &
                                            Aerosol%aerosol(i,j,k,na)
                  end do
                end do
              end do

            else if(trim(Aerosol%aerosol_names(na)) == 'dust1') then      
              do k=1,kdim
                do j=1,jdim
                  do i=1,idim
                    concen_all_sub(i,j,k) = concen_all_sub(i,j,k) +  &
                                            Aerosol%aerosol(i,j,k,na)
                    imass1(i,j,k,8) = Aerosol%aerosol(i,j,k,na)/  &
                                                         pthickness(i,j,k)
! according to Paul dust 1  and dust2 are sub- 2.5 micron
                    imass1(i,j,k,7) =    imass1(i,j,k,7) +   &
                                              Aerosol%aerosol(i,j,k,na)
                    if (Nml%do_dust_berg) then
                      concen_dust_sub(i,j,k) =   concen_dust_sub(i,j,k) + &
                                                 Aerosol%aerosol(i,j,k,na)
                    endif
                  end do
                end do
              end do

            else if(trim(Aerosol%aerosol_names(na)) == 'dust2' ) then   
              do k=1,kdim
                do j=1,jdim
                  do i=1,idim
                    concen_all_sub(i,j,k) = concen_all_sub(i,j,k) +  &
                                            Aerosol%aerosol(i,j,k,na)
                    imass1(i,j,k,9) = Aerosol%aerosol(i,j,k,na)/  &
                                                         pthickness(i,j,k)
! according to Paul dust 1  and dust2 are sub- 2.5 micron
                    imass1(i,j,k,7) =    imass1(i,j,k,7) +   &
                                              Aerosol%aerosol(i,j,k,na)
                    if (Nml%do_dust_berg) then
                      concen_dust_sub(i,j,k) = concen_dust_sub(i,j,k) + &
                                               Aerosol%aerosol(i,j,k,na)
                    endif
                  end do
                end do
              end do

            else if(trim(Aerosol%aerosol_names(na)) == 'dust3' ) then 
              do k=1,kdim
                do j=1,jdim
                  do i=1,idim
                    concen_all_sub(i,j,k) = concen_all_sub(i,j,k) +  &
                                            Aerosol%aerosol(i,j,k,na)
                    imass1(i,j,k,10) = Aerosol%aerosol(i,j,k,na)/   &
                                                         pthickness(i,j,k)
                    if (Nml%do_dust_berg) then
                      concen_dust_sub(i,j,k) = concen_dust_sub(i,j,k) + &
                                               Aerosol%aerosol(i,j,k,na)
                    endif
                  end do
                end do
              end do

            else if (trim(Aerosol%aerosol_names(na)) == 'dust4') then
              do k=1,kdim
                do j=1,jdim
                  do i=1,idim
                    imass1(i,j,k,11) = Aerosol%aerosol(i,j,k,na)/   &   
                                                         pthickness(i,j,k)
                  end do
                end do
              end do

            else if (trim(Aerosol%aerosol_names(na)) == 'dust5') then
              do k=1,kdim
                do j=1,jdim
                  do i=1,idim
                    imass1(i,j,k,12) = Aerosol%aerosol(i,j,k,na)/ &      
                                                         pthickness(i,j,k)
                  end do
                end do
              end do

            endif
          end do
          
          do k=1,kdim
            do j=1,jdim
              do i=1,idim
                totalmass1(i,j,k,3) = concen_ss_sub(i,j,k)
                totalmass1(i,j,k,2) = concen_all_sub(i,j,k) + &
                                      totalmass1(i,j,k,4) + &
                                      concen_ss_sub(i,j,k)
                if (Nml%use_sub_seasalt) then
                else
                  totalmass1(i,j,k,3) = concen_ss_sub(i,j,k) +  &
                                                  concen_ss_sup(i,j,k)
                endif
                if (sea_salt_scale_onl .NE. 1. ) then
                  totalmass1(i,j,k,3) =     sea_salt_scale_onl*  &
                                                       totalmass1(i,j,k,3)
                end if
                if (diag_id%sulfate > 0) then
                  diag_4d(i,j,k, diag_pt%sulfate) =   &
                                             0.7273*totalmass1(i,j,k,1)/  &
                                                    pthickness(i,j,k)*1.0e9
                endif
         
                if (diag_id%seasalt_sub > 0) then
                  diag_4d(i,j,k,diag_pt%seasalt_sub) =    &
                                                  concen_ss_sub(i,j,k)/  &
                                                    pthickness(i,j,k)*1.0e9
                endif 
                if (diag_id%seasalt_sup > 0) then
                  diag_4d(i,j,k, diag_pt%seasalt_sup) =    &
                                                 concen_ss_sup(i,j,k)/  &
                                                    pthickness(i,j,k)*1.0e9
                endif 
              end do
            end do
           end do

         else  ! (use_online_aerosol)

           if (Nml%do_dust_berg) then

!     YMice submicron dust (NO. 14 to NO. 18)
             do s = 14,18
               do k=1,kdim
                 do j=1,jdim
                   do i=1,idim
                     concen_dust_sub(i,j,k) = concen_dust_sub(i,j,k)+ &
                                              Aerosol%aerosol(i,j,k,s)
                   end do
                 end do
               end do
             end do
           endif

           if (diag_id%sulfate > 0) then
!     anthro. and natural sulfate concentration (ug so4/m3)
             do k=1,kdim
               do j=1,jdim
                 do i=1,idim
                   diag_4d(i,j,k, diag_pt%sulfate) = 0.7273*   &
                            (Aerosol%aerosol(i,j,k,1) +      &
                                            Aerosol%aerosol(i,j,k,2))/&
                                                pthickness(i,j,k)*1.0e9
                 end do
               end do
             end do
           endif

!offline
! NO. 1 natural Sulfate; NO. 2 anthro. sulfate; NO. 3 Sea Salt; NO. 4 Or        ganics
           do k=1,kdim
             do j=1,jdim
               do i=1,idim
                 totalmass1(i,j,k,1) = Aerosol%aerosol(i,j,k,2)
                 totalmass1(i,j,k,2) = Aerosol%aerosol(i,j,k,1)
                 totalmass1(i,j,k,3) = Nml%sea_salt_scale*  &
                                       Aerosol%aerosol(i,j,k,5)
                 totalmass1(i,j,k,4) = Nml%om_to_oc*  &
                                       Aerosol%aerosol(i,j,k,3)
               end do
             end do
           end do
         endif ! (use_online_aerosol)

!cms2008-10-08         do na = 1, 3
        do na = 1, 4
          do k=1,kdim
            do j=1,jdim
              do i=1,idim
                totalmass1(i,j,k,na) = totalmass1(i,j,k,na)/  &
                                       pthickness(i,j,k)*1.0e9*1.0e-12
              end do
            end do
          end do
        end do

        do k=1,kdim
          do j=1,jdim
            do i=1,idim
! submicron dust concentration (ug/m3) (NO. 2 to NO. 4)
              imass1(i,j,k,7) = imass1(i,j,k,7)/pthickness(i,j,k)*1.0e9 
            end do
          end do
        end do


        if (Nml%do_dust_berg) then
! submicron dust concentration (ug/m3) (NO. 2 to NO. 4)
          do k=1,kdim
            do j=1,jdim
              do i=1,idim
                concen_dust_sub(i,j,k) = concen_dust_sub(i,j,k)/ &
                                                   pthickness(i,j,k)*1.0e9 
              end do
            end do
          end do
        endif

        if (diag_id%om > 0) then
          do k=1,kdim
            do j=1,jdim
              do i=1,idim
!RSH the 1.0e12 factor here is to counter the  1.0e-12 factor applied 
! above to totalmass1. The 1.0e9 factor (kg -> ug) is already in totalmass1.
                diag_4d(i,j,k,diag_pt%om) = totalmass1(i,j,k,2)*1.0e12
              end do
            end do
          end do
        endif

      endif  ! (do_liq_num)

!----------------------------------------------------------------------


end subroutine aerosol_effects

!#########################################################################



END MODULE aerosol_cloud_mod

!-----------------------------------------------------------------------
! Copyright 2011 NOAA Geophysical Fluid Dynamics Lab, Princeton, NJ
! This program is distributed under the terms of the GNU General Public
! License. See the file COPYING contained in this directory
!-----------------------------------------------------------------------

module plev_constants_mod
implicit none
private

real, public, parameter :: GRAV   = 9.80
real, public, parameter :: RDGAS  = 287.04
real, public, parameter :: RVGAS  = 461.50
real, public, parameter :: TFREEZE  = 273.16

end module plev_constants_mod

module ocean_xlandmix_mod
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> M.J. Harrison 
!</REVIEWER>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> K. Dixon 
!</REVIEWER>
!
!<OVERVIEW>
! Tracer and mass source from cross-land mixing.
!</OVERVIEW>
!
!<DESCRIPTION>
! Compute thickness weighted and density weighted tendency
! [tracer*(kg/m^3)*meter/sec] of tracer and mass associated with 
! cross-land mixing of points. 
!
! In particular, this module provides interaction between bodies of
! water separated by land in coarse models (e.g., Med-Atlantic).  
! Interaction consists of mixing tracer and mass between water 
! columns found on each side of the land barrier.
!
! To conserve total tracer when using xlandmix with k=1, 
! also need to connect mass between remote bodies of water
! via xlandmix of eta.  
!
! When connecting cells with k>1, we do not mix mass. This 
! is ensured by making the time tendency only a function of the 
! difference in tracer concentration. 
!
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies, M.J. Harrison, R. C. Pacanowski, and A. Rosati
! A Technical Guide to MOM4 (2004)
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies: Elements of MOM (2012)
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
! <NOTE>
! Algorithm ensures both total tracer and total mass is conserved.
! </NOTE>
!
! <NOTE>
! 2D domain decomposition is implemented according to following
! notions.  If the two points in an xlandmix pair live within halo 
! of each other (i.e., within same local_domain), 
! then no added mpp communication required. However, more generally 
! the two points live further away.  In this case, xland_domain
! is defined so that its halos incorporate the maximum separation 
! of xlandmix points.  New tracer, eta, and grid arrays
! are defined over this extended xland_domain.  This added domain
! size will come at some computational cost, so it is advantageous
! to limit the separation between points within an xlandmix pair. 
! </NOTE>
!
! <NOTE>
! The current implementation of xlandmix has not been generalized 
! to allow for communication between points separated by the tripolar fold.  
! The problem is in the logic used to compute xland_domain.  
! There is nothing fundamental limiting a generalization of the
! logic used to generate xland_domain.
! </NOTE>
!
! <NOTE>
! Many of the user specified values given in USER INPUT are
! model dependent since unresolved straits can become resolved 
! in finer mesh models. 
! </NOTE>
!
! <NOTE>
! Algorithm originally developed by Keith Dixon (Keith.Dixon) 
! for rigid lid and full cells and one processor (i.e., MOM1).  
! Algorithm extended to free surface and partial cells and 2D 
! domain decomposition by S.M.Griffies (Stephen.Griffies).
! Further extensions to generalized vertical coordinates by 
! Stephen.Griffies
! </NOTE>
!
! <NOTE>
! BUG FIX 30 May 2011. 
! Trying to mix across the ends of the global domain results in incorrect indexing.
! Local indices need to be incremented/decremented by the global extent.
! Russell.Fiedler@csiro.au
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_xlandmix_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  Needs to be true in order to use this scheme. Default is false.
!  </DATA> 
!  <DATA NAME="xlandmix_kmt" TYPE="logical">
!  To allow xlandmixing to occur at k=kmt cell.  
!  Default is xlandmix_kmt=.false. 
!  </DATA> 
!  <DATA NAME="verbose_init" TYPE="logical">
!  For verbose initialization information.
!  </DATA> 
!</NAMELIST>

use constants_mod,     only: epsln
use diag_manager_mod,  only: register_diag_field
use field_manager_mod, only: MODEL_OCEAN, parse, find_field_index
use field_manager_mod, only: get_field_methods, method_type, get_field_info
use fms_mod,           only: stdout, stdlog, FATAL, NOTE, WARNING
use fms_mod,           only: write_version_number, open_namelist_file, check_nml_error, close_file
use mpp_domains_mod,   only: mpp_update_domains
use mpp_mod,           only: input_nml_file, mpp_error

use ocean_domains_mod,    only: get_local_indices, get_global_indices, set_ocean_domain
use ocean_parameters_mod, only: missing_value, rho0, rho0r, onehalf
use ocean_types_mod,      only: ocean_domain_type, ocean_grid_type, ocean_external_mode_type
use ocean_types_mod,      only: ocean_thickness_type, ocean_time_type, ocean_density_type
use ocean_types_mod,      only: ocean_prog_tracer_type, ocean_options_type
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3, wrk4, wrk5, wrk1_v
use ocean_util_mod,       only: diagnose_2d, diagnose_3d, diagnose_sum
use ocean_tracer_util_mod,only: diagnose_3d_rho


implicit none

private 

public ocean_xlandmix_init
public xlandmix
private xlandmix_mass
private watermass_diag_init
private watermass_diag

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()


! Variables set inside subroutine ocean_xlandmix_init
! See comments in ocean_xlandmix_init for description
integer, dimension(:,:), allocatable :: ixland     
integer, dimension(:,:), allocatable :: jxland     
integer, dimension(:,:), allocatable :: kxland     
real, dimension(:), allocatable      :: vxland     

! number of xland mixing pairs 
integer :: nxland=0 

! Variables calculated from user input
real, dimension(:,:), allocatable    :: depth_static   ! time independent depth of columns (m)
real, dimension(:,:), allocatable    :: gamma_xland    ! inverse damping time (s^-1)

integer                              :: xland_halo     ! halo size needed to perform xlandmix
integer                              :: kxland_min     ! min of the k-levels for the nxland pairs
integer                              :: kxland_max     ! max of the k-levels for the nxland pairs
type(ocean_domain_type), save        :: Xland_domain   ! domain for xlandmix 

! variables defined with halos given by xland_halo
real, dimension(:,:), allocatable    :: xland_mass      ! mass source associated with xlandmix  kg/(m^2*sec)
real, dimension(:,:), allocatable    :: xland_mass_pair ! mass source on space of xlandmix pairs kg/(m^2*sec)
real, dimension(:,:), allocatable    :: xtx             ! zonal position of tracer points (degrees)
real, dimension(:,:), allocatable    :: ytx             ! meridional position of tracer points (degrees)
real, dimension(:,:), allocatable    :: datx            ! area of tracer cell (m^2)
real, dimension(:,:,:), allocatable  :: rho_dzt_x       ! mass per area of tracer cell (kg/m^2)

integer                              :: unit=6         !processor zero writes to unit 6

logical, dimension(:), allocatable   :: error_xland    !for checking that all xland points are OK.  


! internally set for computing watermass diagnostics
logical :: compute_watermass_diag = .false. 

! for global area normalization
real    :: cellarea_r

! for diagnostics 
logical :: used
integer, dimension(:), allocatable  :: id_xland
integer :: id_xland_mass=-1

integer :: id_neut_rho_xmix          =-1
integer :: id_neut_rho_xmix_on_nrho  =-1
integer :: id_wdian_rho_xmix         =-1
integer :: id_wdian_rho_xmix_on_nrho =-1
integer :: id_tform_rho_xmix         =-1
integer :: id_tform_rho_xmix_on_nrho =-1

integer :: id_eta_tend_xmix     =-1
integer :: id_eta_tend_xmix_glob=-1

integer :: id_neut_temp_xmix          =-1
integer :: id_neut_temp_xmix_on_nrho  =-1
integer :: id_wdian_temp_xmix         =-1
integer :: id_wdian_temp_xmix_on_nrho =-1
integer :: id_tform_temp_xmix         =-1
integer :: id_tform_temp_xmix_on_nrho =-1

integer :: id_neut_salt_xmix          =-1
integer :: id_neut_salt_xmix_on_nrho  =-1
integer :: id_wdian_salt_xmix         =-1
integer :: id_wdian_salt_xmix_on_nrho =-1
integer :: id_tform_salt_xmix         =-1
integer :: id_tform_salt_xmix_on_nrho =-1

integer :: num_prog_tracers=0
integer :: index_temp=-1
integer :: index_salt=-1

character(len=128) :: version=&
       '$Id: ocean_xlandmix.F90,v 20.0 2013/12/14 00:16:30 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk
integer :: isg, ieg, jsg, jeg
integer :: ixl, jxl, ixl2, jxl2
integer :: kmt_offset=1

logical :: verbose_init          = .true.
logical :: use_this_module       = .false.
logical :: module_is_initialized = .FALSE.
logical :: xlandmix_kmt          = .false.

namelist /ocean_xlandmix_nml/ verbose_init, use_this_module, xlandmix_kmt

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_xlandmix_init">
!
! <DESCRIPTION>
!    Initial set up for crossland mixing of tracers 
!
!    (i,j,k) locations of crossland mixing points are set via 
!    field table entries.
!
!    Time invariant crossland mixing rates (in units of m**3/sec) are 
!    set via field table entries. 
!
!    Checks are performed to ensure that the crossland mixing
!    grid locations are valid according to model configuration.
!
!    A summary of the locations of crossland mixing points is written out.
!
!    User specified inputs in "USER INPUT" section:
!
!    ixland and jxland = user specified nxland pairs of i,j grid locations
!
!    kxland = user specified uppermost (ktop=kxland(n,1)) and deepest 
!             (kbot=kxland(n,2)) levels over which crossland mixing will 
!             be done for each pair of crossland mixing points.
!
!    vxland = user specified time invariant rates of crossland mixing (m3/sec)
!             Equivalent to "the flow to the east = the flow to the west"
!             Dynamic vxland is not available in MOM. 
!
!    NOTE: for ixland, jxland, and kxland pairs, values of the
!    (n,1) element should be < the corresponding (n,2) value.
! </DESCRIPTION>
!
subroutine ocean_xlandmix_init(Grid, Domain, Time, Dens, T_prog, Ocean_options, dtime)

  type(ocean_grid_type),        intent(in), target :: Grid
  type(ocean_domain_type),      intent(in), target :: Domain
  type(ocean_time_type),        intent(in)         :: Time
  type(ocean_density_type),     intent(in)         :: Dens
  type(ocean_prog_tracer_type), intent(in)         :: T_prog(:)
  type(ocean_options_type),     intent(inout)      :: Ocean_options
  real,                         intent(in)         :: dtime

  type(method_type), allocatable, dimension(:) :: xland_methods
  character(len=32) :: fld_type, fld_name
  logical           :: error_check=.false.

  integer :: i, n, nt, model, imax, imin
  integer :: nxl, lx, xland_halo_test
  integer :: parse_ok
  integer :: kmt_max
  integer :: io_status, ioun, ierr
  real    :: ztop 

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if (module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_xlandmix_mod (ocean_xlandmix_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  call get_global_indices(Domain,isg,ieg,jsg,jeg)
  nk = Grid%nk

  Dom => Domain
  Grd => Grid
  
  cellarea_r = 1.0/(epsln + Grd%tcellsurf)

  num_prog_tracers = size(T_prog(:))
  do nt=1,num_prog_tracers
     if (T_prog(nt)%name == 'temp') index_temp = nt
     if (T_prog(nt)%name == 'salt') index_salt = nt
  enddo

  n=find_field_index(MODEL_OCEAN,'xland_mix')

  if (n < 1) then 
     Ocean_options%xlandmix = 'Did NOT use xlandmix.'
     return
  endif 

  call get_field_info(n,fld_type,fld_name,model,nxland)

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_xlandmix_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_xlandmix_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_xlandmix_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_xlandmix_nml')
  call close_file (ioun)
#endif
  write (stdlogunit,ocean_xlandmix_nml)
  write (stdoutunit,'(/)') 
  write (stdoutunit,ocean_xlandmix_nml)

  if(use_this_module) then 
      if(nxland == 0) then 
          write(stdoutunit, *) &
          '==>Warning: use_this_module=.true. but no mixing points chosen. Is this what you wish?'
          call mpp_error(WARNING, &
          '==>NOTE from ocean_xlandmix_mod: No cross-land mixing points chosen')
          Ocean_options%xlandmix = 'Used xlandmix, but set zero cross-land points, so module does nothing.'
          return
      else
          call mpp_error(NOTE, &
          '==>Note from ocean_xlandmix_mod (ocean_xlandmix_init): USING this module')
          write(stdoutunit, *) &
          '==>Note: Using xlandmix to connect tracers and mass between non-local ocean cells.'
          Ocean_options%xlandmix = 'Used xlandmix to transfer tracer between inland seas and open ocean.'
      endif
  else 
      call mpp_error(NOTE, '==>Note from ocean_xlandmix_mod: NOT USING this module')
      if(nxland > 0) then 
          call mpp_error(WARNING, &
          '==>Warning: nxland > 0, but use_this_module=.false. NOT using xlandmix. Is this what you wish?')
      endif
      Ocean_options%xlandmix = 'Did NOT use xlandmix.'
      return
  endif

  write(stdoutunit,'(/a,f10.2)') &
  '==> Note from ocean_xlandmix_mod: using forward time step of (secs)', dtime 

  if(xlandmix_kmt) then 
    kmt_offset=0
    write(stdoutunit,'(/a)') &
    '==> Note from ocean_xlandmix_mod: allowing xlandmix to occur at k=kmt.'
  else 
    kmt_offset=1
  endif 

  allocate(xland_methods(nxland))
  allocate (ixland(nxland,2))
  ixland(:,:) = 0
  allocate (jxland(nxland,2))
  jxland(:,:) = 0
  allocate (kxland(nxland,2))
  kxland(:,:) = 0
  allocate (vxland(nxland))
  vxland(:)   = 0.0
  allocate (depth_static(nxland,2))
  depth_static(:,:) = 0.0
  allocate (gamma_xland(nxland,2))
  gamma_xland(:,:) = 0.0
  allocate (error_xland(nxland))
  error_xland(:) = .false.

  call get_field_methods(n,xland_methods)
  do i=1, nxland
     parse_ok = parse(xland_methods(i)%method_control,'ixland_1',ixland(i,1))
     if (parse_ok == 0) call mpp_error(FATAL,&
     '==>Error ocean_xlandmix_mod: xland table entry "ixland_1" error')
     parse_ok = parse(xland_methods(i)%method_control,'ixland_2',ixland(i,2))
     if (parse_ok == 0) call mpp_error(FATAL,&
     '==>Error ocean_xlandmix_mod: xland table entry "ixland_2" error')
     parse_ok = parse(xland_methods(i)%method_control,'jxland_1',jxland(i,1))
     if (parse_ok == 0) call mpp_error(FATAL,&
     '==>Error ocean_xlandmix_mod: xland table entry "jxland_1" error')
     parse_ok = parse(xland_methods(i)%method_control,'jxland_2',jxland(i,2))
     if (parse_ok == 0) call mpp_error(FATAL,&
     '==>Error ocean_xlandmix_mod: xland table entry "jxland_2" error')
     parse_ok = parse(xland_methods(i)%method_control,'kxland_1',kxland(i,1))
     if (parse_ok == 0) call mpp_error(FATAL,&
     '==>Error ocean_xlandmix_mod: xland table entry "kxland_1" error')
     parse_ok = parse(xland_methods(i)%method_control,'kxland_2',kxland(i,2))
     if (parse_ok == 0) call mpp_error(FATAL,&
     '==>Error ocean_xlandmix_mod: xland table entry "kxland_2" error')
     parse_ok   = parse(xland_methods(i)%method_control,'vxland',vxland(i))
     if (parse_ok == 0) call mpp_error(FATAL,&
     '==>Error ocean_xlandmix_mod: xland table entry "vxland" error')
  enddo

  if(Grid%tripolar) then 
     write(stdoutunit,'(a)') &
     '==>Warning: xlandmix has not been implemented to connect points across the tripolar fold.'
  endif

  xland_halo = min(isc-isd,ied-iec,jsc-jsd,jed-jec)
  kxland_min = nk
  kxland_max = 0

  do nxl=1,nxland

     ! check for invalid crossland mixing grid locations

     if (kxland(nxl,1) > kxland(nxl,2)) then
        write (unit,994) nxl, kxland(nxl,1), nxl, kxland(nxl,2)
        error_xland(nxl) = .true.
     endif
     if (kxland(nxl,1) < kxland_min ) kxland_min = kxland(nxl,1)  
     if (kxland(nxl,2) > kxland_max ) kxland_max = kxland(nxl,2)  

     do lx = 1,2
        if (ixland(nxl,lx) < 1 .or. ixland(nxl,lx) > Grd%ni) then
           write(unit,991) nxl, lx, ixland(nxl,lx)
           error_xland(nxl) = .true.
        endif
        if (jxland(nxl,lx) < 1 .or. jxland(nxl,lx) > Grd%nj ) then
           write(unit,992) nxl, lx, jxland(nxl,lx)
           error_xland(nxl) = .true.
        endif
        if (kxland(nxl,lx) < 1 .or. kxland(nxl,lx) > Grd%nk ) then
           write(unit,993) nxl, lx, kxland(nxl,lx)
           error_xland(nxl) = .true.
        endif
     enddo

     ! determine size for xland_halo
     if(Grd%cyclic_x) then
       imax = max(ixland(nxl,1),ixland(nxl,2))
       imin = min(ixland(nxl,1),ixland(nxl,2))
       xland_halo_test = min( abs(imax-imin), abs(imax-Grd%ni-imin))
     else
       xland_halo_test = abs(ixland(nxl,1)-ixland(nxl,2))
     endif
     if (xland_halo_test > xland_halo ) xland_halo = xland_halo_test

     xland_halo_test = abs(jxland(nxl,1)-jxland(nxl,2))
     if (xland_halo_test > xland_halo ) xland_halo = xland_halo_test

  enddo  ! end of do-loop nxl=1,nxland

  if(xland_halo == 0) then 
     call mpp_error(FATAL,&
     '==>Error in ocean_xlandmix_mod (ocean_xlandmix_init): xland_halo=0 => problems defining xlandmix points.')
  endif
 
  if(xland_halo > Dom%xhalo .or. xland_halo > Dom%yhalo) then 
    write(stdoutunit,*) &
    'Defining extra tracer arrays for xland_domain over k-levels ',kxland_min,' through ',kxland_max 
  endif 

  allocate (xland_mass_pair(nxland,2))
  xland_mass_pair(:,:)  = 0.0


  ! define arrays and xland_domain
  if(xland_halo <= Dom%xhalo .and. xland_halo <= Dom%yhalo) then 

     write(stdoutunit,*)'The model local computational domain has a x,y halo = ',Dom%xhalo,Dom%yhalo
     write(stdoutunit,*)'This is large enough for chosen points in xlandmix,'
     write(stdoutunit,*)'where we need to have a halo of size = ', xland_halo

     ! time independent arrays 
     allocate (datx(isd:ied,jsd:jed))
     allocate (xtx(isd:ied,jsd:jed))
     allocate (ytx(isd:ied,jsd:jed))
     xtx(:,:)         = Grd%xt(:,:)
     ytx(:,:)         = Grd%yt(:,:)
     datx(:,:)        = Grd%dat(:,:)

     ! time dependent arrays 
     allocate (rho_dzt_x(isd:ied,jsd:jed,nk))
     allocate (xland_mass(isd:ied,jsd:jed))
     rho_dzt_x(:,:,:) = 0.0
     xland_mass(:,:)  = 0.0
  endif 

  if(xland_halo > Dom%xhalo .or. xland_halo > Dom%yhalo) then 
     write(stdoutunit,*)'The model local computational domain has a x,y halo = ',Dom%xhalo, Dom%yhalo
     write(stdoutunit,*)'This is smaller than the halo required for xlandmix.'
     write(stdoutunit,*)'For xlandmix, will define a new domain type with halo = ', xland_halo

     if(xland_halo > (Dom%xhalo+6)) then 
       write(stdoutunit,*)'=>Warning: ocean_xlandmix_init determined xland_halo = ', xland_halo
       write(stdoutunit,*)'           Are you sure you wish to connect such distant locations?'
       write(stdoutunit,*)'           Are you instead trying to connect points across a tripolar fold?'
       write(stdoutunit,*)'           If so, then presently this has yet to be coded into xlandmix.'
       write(stdoutunit,*)'           Alternative xlandmix points must be taken, or new code implemented.'
     endif

     ! define xlandmix domain 
     call set_ocean_domain(Xland_domain,Grd,xhalo=xland_halo,yhalo=xland_halo,&
                           name='xlandmix',maskmap=Dom%maskmap)

     ! time independent arrays defined over the xland_domain region 
     allocate (datx(isc-xland_halo:iec+xland_halo,jsc-xland_halo:jec+xland_halo))
     allocate (xtx(isc-xland_halo:iec+xland_halo,jsc-xland_halo:jec+xland_halo))
     allocate (ytx(isc-xland_halo:iec+xland_halo,jsc-xland_halo:jec+xland_halo))
     datx(:,:) = 0.0
     xtx(:,:)  = 0.0
     ytx(:,:)  = 0.0

     datx(isc:iec,jsc:jec) = Grd%dat(isc:iec,jsc:jec)
     xtx(isc:iec,jsc:jec)  = Grd%xt(isc:iec,jsc:jec)
     ytx(isc:iec,jsc:jec)  = Grd%yt(isc:iec,jsc:jec)
     call mpp_update_domains (datx(:,:), Xland_domain%domain2d)
     call mpp_update_domains (xtx(:,:), Xland_domain%domain2d)
     call mpp_update_domains (ytx(:,:), Xland_domain%domain2d)

     ! time dependent arrays defined over the xland_domain region 
     allocate (rho_dzt_x(isc-xland_halo:iec+xland_halo,jsc-xland_halo:jec+xland_halo,nk))
     allocate (xland_mass(isc-xland_halo:iec+xland_halo,jsc-xland_halo:jec+xland_halo))
     rho_dzt_x(:,:,:) = 0.0
     xland_mass(:,:)  = 0.0
  endif

! Mixing across Straits of Gibraltar in CSIRO MK3.5 model resulted in 
! exceeding bounds with the Dec2009 version of MOM4p1. 
! ixl needs to be changed to reflect cyclic BCs.
! Earlier checks were made to see if ixl was negative or too 
! large wrt the global domain. However we want ixl in the current 
! expanded data domain of xtx.
  if(Grd%cyclic_x) then
     do nxl=1,nxland
        if( at_least_one_in_comp_domain(nxl) ) then
            do lx = 1,2
               if(.not. on_processor(nxl, lx)) then               ! Not in domain. This is WRONG!
                  ixl = ixland(nxl,lx)-Dom%ioff
                  if(ixl < lbound(xtx,1) ) then                   ! Gone outside lower index
                     ixl2 = ixland(nxl,lx) + ieg
                     write(unit,*) 'xlandmix init: ixland outside local domain i=',lbound(xtx,1),':',ubound(xtx,1),   &
                                   ' Changing index from ', ixland(nxl,lx) ,' to ', ixl2
                     ixland(nxl,lx) = ixl2
                  else if ( ixl > ubound(xtx,1) ) then             ! Gone outside upper index
                     ixl2 = ixland(nxl,lx) - ieg
                     write(unit,*) 'xlandmix init: ixland outside local domain i=',lbound(xtx,1),':',ubound(xtx,1),   &
                                   ' Changing index from ', ixland(nxl,lx) ,' to ', ixl2
                     ixland(nxl,lx) = ixl2
                  endif
                  if(.not. on_processor(nxl, lx)) then
                    write(unit,*) 'xlandmix init FAILED?: ixl =', ixl, ' Bounds ',isc+Dom%ioff-xland_halo,':',iec+Dom%ioff+xland_halo
                    error_xland(nxl)=.true.
                  endif
               endif
             enddo
         endif
      enddo
  endif

  do nxl=1,nxland

     ! check for attempts to mix land rather than sea.
     ! Restrict xland mixing to be above the bottom-most level in a column.      
     do lx = 1,2
        if(on_comp_domain(nxl, lx)) then
           ixl = ixland(nxl,lx)-Dom%ioff
           jxl = jxland(nxl,lx)-Dom%joff
           kmt_max = max(0,Grid%kmt(ixl,jxl)-kmt_offset)
           if (kxland(nxl,2) > kmt_max) then
              write (unit,192) nxl, kxland(nxl,2), ixland(nxl,lx),jxland(nxl,lx),Grid%kmt(ixl,jxl)
              error_xland(nxl)=.true.
           endif
        endif
     enddo

     ! write out summary information for this pair of crossland mixing points
     if (kxland(nxl,1) == 1) then
        ztop = 0.0
     else
        ztop = Grid%zw(kxland(nxl,1)-1)
     endif

     if(at_least_one_in_comp_domain(nxl)) then
         ixl = ixland(nxl,1)-Dom%ioff
         jxl = jxland(nxl,1)-Dom%joff
         ixl2 = ixland(nxl,2)-Dom%ioff
         jxl2 = jxland(nxl,2)-Dom%joff
         if(verbose_init) then 
             write(unit,191) nxl, ixland(nxl,1), jxland(nxl,1) &
              ,xtx(ixl,jxl), ytx(ixl,jxl) &
              ,ixland(nxl,2), jxland(nxl,2) &
              ,xtx(ixl2,jxl2), ytx(ixl2,jxl2) &
              ,kxland(nxl,1), kxland(nxl,2), ztop, Grid%zw(kxland(nxl,2))
         endif 
         call xland_check (nxl, dtime, error_check)
         if(error_check) then 
           error_xland(nxl) = .true.
         endif 
     endif

  enddo

  ! Bring model down here if there are problems with xlandmix points.  
  do nxl=1,nxland
    if(error_xland(nxl)) then
      call mpp_error(FATAL, &
      '==>Error detected in ocean_xlandmix_mod: Use "grep -i error" to find ALL errors.')
    endif 
  enddo 

  ! register for diag_manager 
  allocate (id_xland(num_prog_tracers))
  id_xland = -1

  do n=1,num_prog_tracers
     if(T_prog(n)%name == 'temp') then 
         id_xland(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xland', &
                       Grd%tracer_axes(1:3), Time%model_time,                              &
                       'xlandmix*cp*rho*dzt*temp', 'Watt/m^2',                             &
                       missing_value=missing_value, range=(/-1.e10,1.e10/))
     else
         id_xland(n) = register_diag_field ('ocean_model', trim(T_prog(n)%name)//'_xland', &
                       Grd%tracer_axes(1:3), Time%model_time,                              &
                       'xlandmix*rho*dzt*tracer for '//trim(T_prog(n)%name),               &
                       trim(T_prog(n)%flux_units),                                         &
                       missing_value=missing_value, range=(/-1.e10,1.e10/))
     endif
  enddo

  id_xland_mass  = register_diag_field ('ocean_model', 'mass_xland', &
                   Grd%tracer_axes(1:2), Time%model_time,            &
                   'mass source from xland', 'kg/(m^2*sec)',         &
                   missing_value=missing_value, range=(/-1.e8,1.e8/))

  call watermass_diag_init(Time, Dens)


191 format(/' ===== from ocean_xland_init ====='/                                  &
       ' for crossland sea connection pair number',i3,/                            &
       ' mix  (i,j) gridpoint (',i4,',',i4,') [long=',f8.3,' lat=',f8.3,']',/      &
       ' with (i,j) gridpoint (',i4,',',i4,') [long=',f8.3,' lat=',f8.3,']',/      & 
       ' from level',i3,' to',i3,' [depths of ',f10.3,' to ',f10.3,'m]' ) 
192 format(/'=>Error: Problem with crossland mixing: improper k-levels requested.'/&
       'kxland(',i2,',2) =',i4, ' and kmt(',i4,',',i4,') = ',i4)
991 format(/'=>Error: problem with crossland tracer mixing:',/,                    &
       ' out of bounds i grid location requested'/  &
       '      ixland(',i4,',',i1,') was set incorrectly set to = ',i8,/)
992 format(/'=>Error: problem with crossland tracer mixing:',/,                    &
       ' out of bounds j-row grid location requested'/ &
       '      jxland(',i4,',',i1,') was set incorrectly set to = ',i8,/)
993 format(/'=>Error: problem with crossland tracer mixing:',/,                    &
       ' out of bounds k-level grid location requested'/ &
       '      kxland(',i4,',',i1,') was set incorrectly set to = ',i8,/)
994 format(/'=>Error: problem with crossland tracer mixing:',/,                    &
       ' improper k-values requested'/' kxland(',i3,',1)=',i5,                     &
       ' and is not less than or equal to kxland(',i3,',2)=',i5,/)

end subroutine ocean_xlandmix_init
! </SUBROUTINE> NAME="ocean_xlandmix_init"


!#######################################################################
! <SUBROUTINE NAME="xlandmix">
!
! <DESCRIPTION>
! Compute thickness and density weighted time tendency from 
! xlandmix. Units of the tendency are tracer*(kg/m^3)*meter/sec.
!
! Logic is a bit tricky in order to allow each (i,j,k) point
! to participate in an arbitrary number of xlandmix pairs.  
!
! </DESCRIPTION>
!
subroutine xlandmix (Time, Ext_mode, Dens, Thickness, T_prog)

  type(ocean_time_type),          intent(in)    :: Time
  type(ocean_external_mode_type), intent(in)    :: Ext_mode
  type(ocean_density_type),       intent(in)    :: Dens
  type(ocean_thickness_type),     intent(inout) :: Thickness
  type(ocean_prog_tracer_type),   intent(inout) :: T_prog(:)
 
  real, dimension(isc-xland_halo:iec+xland_halo,jsc-xland_halo:jec+xland_halo,kxland_min:kxland_max,num_prog_tracers) :: &
                   tracerx    ! tracer concentration

  real, dimension(2) :: top_rho_dzt       
  real               :: temporary
  integer            :: i, j, k, nxl, lx, n
  integer            :: taum1, tau

  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_xlandmix_mod (xlandmix): module must be initialized')
  endif 

  if (nxland < 1) return
  if (.not. use_this_module) return

  taum1 = Time%taum1
  tau   = Time%tau

  xland_mass(:,:)      = 0.0
  xland_mass_pair(:,:) = 0.0
 
  if(xland_halo > Dom%xhalo .or. xland_halo > Dom%yhalo) then

         ! for surface cell, wish to have only difference be due to eta_t differences
         ! to ensure that xlandmix at surface will readily equilize eta_t across straits. 
         ! if use rho_dzt_x = rho0*Thickness%dzt, then with zstar and pstar, there would
         ! be a far smaller difference in rho_dzt_x than for the following specification,
         ! which is based on the geopotential case.  

     do k=kxland_min,kxland_max
        rho_dzt_x(isc:iec,jsc:jec,k) = Thickness%rho_dzt(isc:iec,jsc:jec,k,taum1)
     enddo
     rho_dzt_x(isc:iec,jsc:jec,1) = rho0*(Grd%dzt(1)+Ext_mode%eta_t(isc:iec,jsc:jec,taum1))
     call mpp_update_domains (rho_dzt_x(:,:,:), Xland_domain%domain2d)
     tracerx = 0.0
     do n = 1, num_prog_tracers
        do k=kxland_min,kxland_max
            tracerx(isc:iec,jsc:jec,k,n)   = T_prog(n)%field(isc:iec,jsc:jec,k,taum1)
        enddo
     enddo
     call mpp_update_domains( tracerx(:,:,:,:), Xland_domain%domain2d)
  endif  

  do n=1,num_prog_tracers

     T_prog(n)%wrk1(:,:,:) = 0.0

     if(xland_halo > Dom%xhalo .or. xland_halo > Dom%yhalo) then 
         do nxl=1,nxland 

            if(at_least_one_in_comp_domain(nxl)) then  

                do lx=1,2
                   ixl = ixland(nxl,lx)-Dom%ioff; jxl = jxland(nxl,lx)-Dom%joff
                   gamma_xland(nxl,lx) = (2.0*vxland(nxl))/  &
                        (datx(ixl,jxl)*(depth_static(nxl,1)+depth_static(nxl,2)))
                enddo

                ! tracer exchange for k>1 
                do lx=1,2 
                   if(on_comp_domain(nxl,lx)) then
                       ixl  = ixland(nxl,lx)-Dom%ioff
                       jxl  = jxland(nxl,lx)-Dom%joff
                       ixl2 = ixland(nxl,3-lx)-Dom%ioff
                       jxl2 = jxland(nxl,3-lx)-Dom%joff
                       do k=max(2,kxland(nxl,1)),kxland(nxl,2)  
                          T_prog(n)%wrk1(ixl,jxl,k) = T_prog(n)%wrk1(ixl,jxl,k) + gamma_xland(nxl,lx) &
                               *onehalf*(rho_dzt_x(ixl2,jxl2,k)+rho_dzt_x(ixl,jxl,k))                 &
                               *(tracerx(ixl2,jxl2,k,n)-tracerx(ixl,jxl,k,n))
                       enddo
                   endif
                enddo

                ! mass and tracer exchange for k=1
                if(kxland(nxl,1)==1) then 

                    k=1
                    do lx=1,2
                       ixl = ixland(nxl,lx)-Dom%ioff
                       jxl = jxland(nxl,lx)-Dom%joff                 
                       top_rho_dzt(lx) = rho_dzt_x(ixl,jxl,k)
                    enddo

                    if(n==1) then 
                        do lx=1,2
                           ixl = ixland(nxl,lx)-Dom%ioff
                           jxl = jxland(nxl,lx)-Dom%joff                   
                           xland_mass_pair(nxl,lx) = gamma_xland(nxl,lx)*( top_rho_dzt(3-lx)-top_rho_dzt(lx) )
                           xland_mass(ixl,jxl)     = xland_mass(ixl,jxl) + xland_mass_pair(nxl,lx) 
                        enddo
                    endif

                    do lx=1,2  
                       if(on_comp_domain(nxl,lx)) then
                           ixl  = ixland(nxl,lx)-Dom%ioff
                           jxl  = jxland(nxl,lx)-Dom%joff
                           ixl2 = ixland(nxl,3-lx)-Dom%ioff
                           jxl2 = jxland(nxl,3-lx)-Dom%joff
                           T_prog(n)%wrk1(ixl,jxl,k) = T_prog(n)%wrk1(ixl,jxl,k)        &
                                +gamma_xland(nxl,lx)*(top_rho_dzt(3-lx)*tracerx(ixl2,jxl2,k,n) &
                                -top_rho_dzt(lx)*tracerx(ixl,jxl,k,n)) 
                       endif
                    enddo

                endif

            endif ! end of at_least_one_in_comp_domain(nxl) if-test 

         enddo  ! end of the nxland do-loop 

     endif ! end of xland_halo > halo if-test 

     if(xland_halo <= Dom%xhalo .and. xland_halo<= Dom%yhalo) then 

         do nxl=1,nxland 

            if(at_least_one_in_comp_domain(nxl)) then  

                do lx=1,2
                   ixl = ixland(nxl,lx)-Dom%ioff
                   jxl = jxland(nxl,lx)-Dom%joff 
                   gamma_xland(nxl,lx) = (2.0*vxland(nxl))/  &
                        (Grd%dat(ixl,jxl)*(depth_static(nxl,1)+depth_static(nxl,2)))
                enddo

                ! tracer exchange for k>1 
                do lx=1,2 
                   if(on_comp_domain(nxl,lx)) then
                       ixl = ixland(nxl,lx)-Dom%ioff
                       jxl = jxland(nxl,lx)-Dom%joff
                       ixl2 = ixland(nxl,3-lx)-Dom%ioff
                       jxl2 = jxland(nxl,3-lx)-Dom%joff
                       do k=max(2,kxland(nxl,1)),kxland(nxl,2)  
                          T_prog(n)%wrk1(ixl,jxl,k) = T_prog(n)%wrk1(ixl,jxl,k) + gamma_xland(nxl,lx)       &
                               *onehalf*(Thickness%rho_dzt(ixl2,jxl2,k,taum1)+Thickness%rho_dzt(ixl,jxl,k,taum1)) &
                               *(T_prog(n)%field(ixl2,jxl2,k,taum1)-T_prog(n)%field(ixl,jxl,k,taum1))
                       enddo
                   endif
                enddo

                ! mass and tracer exchange for k=1
                if(kxland(nxl,1)==1) then 

                    k=1
                    do lx=1,2
                       ixl = ixland(nxl,lx)-Dom%ioff
                       jxl = jxland(nxl,lx)-Dom%joff
                       top_rho_dzt(lx) = rho0*(Grd%dzt(1)+Ext_mode%eta_t(ixl,jxl,taum1))
                    enddo

                    if(n==1) then  
                        do lx=1,2
                           ixl = ixland(nxl,lx)-Dom%ioff
                           jxl = jxland(nxl,lx)-Dom%joff                   
                           xland_mass_pair(nxl,lx) = gamma_xland(nxl,lx)*( top_rho_dzt(3-lx)-top_rho_dzt(lx) )
                           xland_mass(ixl,jxl)     = xland_mass(ixl,jxl) + xland_mass_pair(nxl,lx)
                        enddo
                    endif

                    do lx=1,2  
                       if(on_comp_domain(nxl,lx)) then
                           ixl  = ixland(nxl,lx)-Dom%ioff
                           jxl  = jxland(nxl,lx)-Dom%joff
                           ixl2 = ixland(nxl,3-lx)-Dom%ioff
                           jxl2 = jxland(nxl,3-lx)-Dom%joff
                           T_prog(n)%wrk1(ixl,jxl,k) = T_prog(n)%wrk1(ixl,jxl,k)                      &
                                +gamma_xland(nxl,lx)*(top_rho_dzt(3-lx)*T_prog(n)%field(ixl2,jxl2,k,taum1) &
                                -top_rho_dzt(lx)  *T_prog(n)%field(ixl,jxl,k,taum1))  
                       endif
                    enddo

                endif

            endif ! end of at_least_one_in_comp_domain(nxl) if-test 

         enddo  ! end of the nxland do-loop 

     endif ! end of xland_halo > halo if-test 


     ! fill source array 
     T_prog(n)%th_tendency(isc:iec,jsc:jec,:) = T_prog(n)%th_tendency(isc:iec,jsc:jec,:) &
          + T_prog(n)%wrk1(isc:iec,jsc:jec,:)

     ! send diagnostics 
     if(id_xland(n) > 0) then 
        call diagnose_3d(Time, Grd, id_xland(n), T_prog(n)%conversion*T_prog(n)%wrk1(:,:,:))
     endif

  enddo ! end of do loop n=1,num_prog_tracers 


  ! compute effects on mass 
  call xlandmix_mass(Time, Thickness)

  ! call some diagnostics 
  call watermass_diag(Time, Dens, &
  T_prog(index_temp)%wrk1(:,:,:), T_prog(index_salt)%wrk1(:,:,:))
  

end subroutine xlandmix
! </SUBROUTINE> NAME="xlandmix"


!#######################################################################
! <SUBROUTINE NAME="xlandmix_mass">
!
! <DESCRIPTION>
! Compute the mass source kg/(m^2*sec).
! Note that xlandmix has already been called, so xland_mass has been 
! filled.  
! </DESCRIPTION>
!
subroutine xlandmix_mass (Time, Thickness)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(inout) :: Thickness 
 
  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_xlandmix_mod (xlandmix_mass): module must be initialized')
  endif 

  Thickness%mass_source(isc:iec,jsc:jec,1) = Thickness%mass_source(isc:iec,jsc:jec,1) &
                                           + xland_mass(isc:iec,jsc:jec)

  call mpp_update_domains (Thickness%mass_source(:,:,1), Dom%domain2d)

  call diagnose_2d(Time, Grd, id_xland_mass, xland_mass(:,:))

end subroutine xlandmix_mass
! </SUBROUTINE> NAME="xlandmix_mass"


!#######################################################################
! <SUBROUTINE NAME="xland_check">
!
! <DESCRIPTION>
! Check if prescribed too much mixing
!
! In this routine the crossland mixing rate vxland(nxl) for
! the pair of points associated with index number nxl is
! converted into the fraction of the model grid boxes to be mixed
! per second, and checked.  These checks ensure that the rate of
! crossland mixing requested is valid in that it can be realized
! given the timestep length and column volumes involved.
! </DESCRIPTION>
!
! <IN NAME="nxl" TYPE="integer">
! Integer labeling the particular xlandmix pair
! </IN>
! <INOUT NAME="error" TYPE="logical">
! Error flag indicates whether initialization was performed successfully.  
! </INOUT>
!
subroutine xland_check(nxl, dtime, error)

  logical, intent(inout) :: error
  integer, intent(in)    :: nxl
  real,    intent(in)    :: dtime

  integer                   :: k, lx, ll
  real, dimension(2)        :: colvol
  real                      :: factor, tslim
  real, dimension(nxland,2) :: bxland 

  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_xlandmix_mod (xland_check): module must be initialized')
  endif 

  ! Calculate static depth range over which crossland mixing will be applied. 
  ! Note that do not include partial bottom cell in kxland range.  
  do lx=1,2
    depth_static(nxl,lx) = 0.0
    do k=max(1,kxland(nxl,1)),kxland(nxl,2)
       ixl = ixland(nxl,lx)-Dom%ioff
       jxl = jxland(nxl,lx)-Dom%joff                            
       depth_static(nxl,lx) = depth_static(nxl,lx) + Grd%dzt(k)
    enddo
  enddo

  do lx=1,2

! For each of the two (i,j) points to be mixed, convert from volume
! to be mixed per second vxland(nxl) to model box fraction to be
! mixed per second bxland(nxl,l)
     ixl = ixland(nxl,lx)-Dom%ioff
     jxl = jxland(nxl,lx)-Dom%joff                          
     colvol(lx)     = datx(ixl,jxl)*depth_static(nxl,lx)
     bxland(nxl,lx) = vxland(nxl) / (epsln + colvol(lx))

    ! check for attempts to mix at a rate so fast that it can not
    ! be stably achieved in a single forward timestep
    ! (for the two boxes to be thoroughly mixed, no more than
    ! one-half of the volume of a given grid box can be
    ! stably transported in effect into the other gridbox)
    factor = bxland(nxl,lx)*dtime
    if (factor > 0.5) then
      tslim = 0.5/bxland(nxl,lx)
      write (unit,997) nxl, factor, ixland(nxl,lx), jxland(nxl,lx), bxland(nxl,lx), tslim, &
             vxland(nxl), kxland(nxl,1), kxland(nxl,2), colvol(lx)
      error=.true.
      return
    endif

  enddo

  if(verbose_init) then 
    write (unit,197) nxl, ixland(nxl,1), jxland(nxl,1), ixland(nxl,2), jxland(nxl,2), kxland(nxl,1), &
         kxland(nxl,2), depth_static(nxl,1), (colvol(ll),ll=1,2), vxland(nxl), (bxland(nxl,ll),ll=1,2)
  endif 

197   format(/' ===== from xlandvchk ====='/                             &
     ' for crossland sea communication pair number',i3,/                 &
     ' mix I,J gridpoints (',i4,',',i4,') and (',i4,',',i4,')'/          &
     ' from level',i3,' to',i3,' (a depth range of ',e12.6,' m)'/        &
     ' column volumes =',e12.6,' and ',e12.6,' m^3'/                     & 
     ' simulated flow in = flow out = ',e12.6,' m^3/sec,',/,             &
     ' so mix ',e12.6,' fraction of 1st column with ',e12.6,             &
     ' of 2nd column per sec.'/)
997   format(/' Error => problem with crossland tracer mixing',          &
     ' pair #',i3,/,' Error => attempting to mix at too fast a rate:'/   &
     ' asking for more than half (',g12.6,') the volume of a grid box',  &
     ' at i, j, k: ',2i5,/,' to be mixed into its neighbor on',          &
     ' leapfrog timesteps'/                                              &  
     ' As specified now, fraction of column mixed per sec = ',e12.6,/,   &
     ' Potential Fixes: shorten dtime to be less than',e13.6,/           &
     t18,' reduce mixing rate vxland (now ',e12.6,' m^3/sec)'/           &
     t18,' or mix over a larger depth range (now from k=',i3,' to ',i3   &
     ,' => water column volume = ',e12.6,' m^3)'/)

end subroutine xland_check
! </SUBROUTINE> NAME="xland_check"


!#######################################################################
! <FUNCTION NAME="at_least_one_in_comp_domain">
!
! <DESCRIPTION>
! Function to see if at least one of the two points in a crossland pair
! is within the computational domain for the processor. 
! </DESCRIPTION>
!
! <IN NAME="nxl" TYPE="integer">
! Integer labeling the particular xlandmix pair
! </IN>
!
function at_least_one_in_comp_domain(nxl)

  integer, intent(in) :: nxl
  integer             :: lx
  logical             :: in_domain(2), at_least_one_in_comp_domain

  do lx=1,2
    if(isc+Dom%ioff <= ixland(nxl,lx) .and. ixland(nxl,lx) <= iec+Dom%ioff .and. &
       jsc+Dom%joff <= jxland(nxl,lx) .and. jxland(nxl,lx) <= jec+Dom%joff) then
       in_domain(lx) = .true.
    else 
       in_domain(lx) = .false.  
    endif
  enddo

  at_least_one_in_comp_domain = .false.
  if(in_domain(1) .and. in_domain(2)     ) at_least_one_in_comp_domain = .true.
  if(in_domain(1) .and. .not.in_domain(2)) at_least_one_in_comp_domain = .true.
  if(.not.in_domain(1) .and. in_domain(2)) at_least_one_in_comp_domain = .true.


end function at_least_one_in_comp_domain 
! </FUNCTION> NAME="at_least_one_in_comp_domain"


!#######################################################################
! <FUNCTION NAME="both_in_local_domain">
!
! <DESCRIPTION>
! Determine if both points in a crossland pair are within the
! local domain for the processor. 
! </DESCRIPTION>
!
! <IN NAME="nxl" TYPE="integer">
! Integer labeling the particular xlandmix pair
! </IN>
!
function both_in_local_domain(nxl)

  integer, intent(in) :: nxl
  integer             :: lx, ilo, ihi, jlo, jhi
  logical             :: in_domain(2), both_in_local_domain

  ilo = isd+Dom%ioff
  ihi = ied+Dom%ioff
  jlo = jsd+Dom%joff
  jhi = jed+Dom%joff

  do lx=1,2
    if(ilo <= ixland(nxl,lx) .and. ixland(nxl,lx) <= ihi .and. &
       jlo <= jxland(nxl,lx) .and. jxland(nxl,lx) <= jhi) then
       in_domain(lx) = .true.
    else 
       in_domain(lx) = .false.  
    endif
  enddo
  if(in_domain(1) .and. in_domain(2)) then
    both_in_local_domain = .true.
  else 
    both_in_local_domain = .false.
  endif

end function both_in_local_domain 
! </FUNCTION> NAME="both_in_local_domain"


!#######################################################################
! <FUNCTION NAME="on_comp_domain">
!
! <DESCRIPTION>
! Determine if the point is in comp-domain for the processor
! </DESCRIPTION>
!
! <IN NAME="nxl" TYPE="integer">
! Integer labeling the particular xlandmix pair
! </IN>
! <IN NAME="lx" TYPE="integer">
! lx=1,2 labels the point within an xlandmix pair
! </IN>
!
function on_comp_domain(nxl, lx)

  integer, intent(in) :: nxl, lx
  logical             :: on_comp_domain

  if(isc+Dom%ioff <= ixland(nxl,lx) .and. ixland(nxl,lx) <= iec+Dom%ioff .and. &
     jsc+Dom%joff <= jxland(nxl,lx) .and. jxland(nxl,lx) <= jec+Dom%joff) then
     on_comp_domain = .true.
  else 
     on_comp_domain = .false.  
  endif

end function on_comp_domain
! </FUNCTION> NAME="on_comp_domain"


!#######################################################################
! <FUNCTION NAME="on_processor">
!
! <DESCRIPTION>
! Determine if the point is on processor 
! </DESCRIPTION>
!
function on_processor(nxl, lx)

  integer, intent(in) :: nxl, lx
  logical             :: on_processor

  if(isc+Dom%ioff-xland_halo <= ixland(nxl,lx) .and. ixland(nxl,lx) <= iec+Dom%ioff+xland_halo .and. &
     jsd+Dom%joff-xland_halo <= jxland(nxl,lx) .and. jxland(nxl,lx) <= jed+Dom%joff+xland_halo) then
     on_processor = .true.
  else 
     on_processor = .false.  
  endif

end function on_processor
! </FUNCTION> NAME="on_processor"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag_init">
!
! <DESCRIPTION>
! Initialization of watermass diagnostic output files. 
! </DESCRIPTION>
!
subroutine watermass_diag_init(Time, Dens)

  type(ocean_time_type),    intent(in) :: Time
  type(ocean_density_type), intent(in) :: Dens

  integer :: stdoutunit
  stdoutunit=stdout()
  compute_watermass_diag = .false. 

  id_neut_rho_xmix = register_diag_field ('ocean_model', 'neut_rho_xmix',&
    Grd%tracer_axes(1:3), Time%model_time,                               &
    'update of locally ref potrho from xlandmix',                        &
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_xmix > 0) compute_watermass_diag = .true. 

  id_neut_rho_xmix_on_nrho = register_diag_field ('ocean_model',                 &
   'neut_rho_xmix_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,          &
   'update of locally ref potrho from xlandmix binned to neutral density layers',&
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_rho_xmix_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_rho_xmix = register_diag_field ('ocean_model', 'wdian_rho_xmix',&
    Grd%tracer_axes(1:3), Time%model_time,                                 &
    'dianeutral mass transport due to xlandmix',                           &
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_xmix > 0) compute_watermass_diag = .true. 

  id_wdian_rho_xmix_on_nrho = register_diag_field ('ocean_model',             &
   'wdian_rho_xmix_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,      &
   'dianeutral mass transport from xlandmix binned to neutral density layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_rho_xmix_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_rho_xmix = register_diag_field ('ocean_model',    &
     'tform_rho_xmix', Grd%tracer_axes(1:3), Time%model_time,&
     'watermass transform from xlandmix',                    &
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_xmix_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_rho_xmix_on_nrho = register_diag_field ('ocean_model',          &
     'tform_rho_xmix_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time, &
     'watermass transform from xlandmix binned to neutral density layers', &
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_rho_xmix_on_nrho > 0) compute_watermass_diag = .true. 

  id_eta_tend_xmix= -1          
  id_eta_tend_xmix= register_diag_field ('ocean_model','eta_tend_xmix',    &
       Grd%tracer_axes(1:2), Time%model_time,                              &
       'non-Bouss steric sea level tendency from xlandmix tendency', 'm/s',&
       missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_xmix > 0) compute_watermass_diag=.true.

  id_eta_tend_xmix_glob= -1          
  id_eta_tend_xmix_glob= register_diag_field ('ocean_model', 'eta_tend_xmix_glob',&
       Time%model_time,                                                           &
       'global mean non-bouss steric sea level tendency from xlandmix tendency',  &
       'm/s', missing_value=missing_value, range=(/-1e10,1.e10/))
  if(id_eta_tend_xmix_glob > 0) compute_watermass_diag=.true.


  ! temperature effects 
  id_neut_temp_xmix = register_diag_field ('ocean_model', 'neut_temp_xmix',&
    Grd%tracer_axes(1:3), Time%model_time,                                 &
    'temp related update of locally ref potrho from xlandmix',             &
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_xmix > 0) compute_watermass_diag = .true. 

  id_neut_temp_xmix_on_nrho = register_diag_field ('ocean_model',                             &
   'neut_temp_xmix_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                      &
   'temp related update of locally ref potrho from xlandmix binned to neutral density layers',&
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_temp_xmix_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_temp_xmix = register_diag_field ('ocean_model', 'wdian_temp_xmix',&
    Grd%tracer_axes(1:3), Time%model_time,                                   &
    'temp related dianeutral mass transport due to xlandmix',                &
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_xmix > 0) compute_watermass_diag = .true. 

  id_wdian_temp_xmix_on_nrho = register_diag_field ('ocean_model',                         &
   'wdian_temp_xmix_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                  &
   'temp related dianeutral mass transport from xlandmix binned to neutral density layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_temp_xmix_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_temp_xmix = register_diag_field ('ocean_model',    &
     'tform_temp_xmix', Grd%tracer_axes(1:3), Time%model_time,&
     'temp related watermass transform from xlandmix',        &
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_xmix_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_temp_xmix_on_nrho = register_diag_field ('ocean_model',                     &
     'tform_temp_xmix_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,            &
     'temp related watermass transform from xlandmix binned to neutral density layers',&
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_temp_xmix_on_nrho > 0) compute_watermass_diag = .true. 


  ! salinity effects 
  id_neut_salt_xmix = register_diag_field ('ocean_model', 'neut_salt_xmix',&
    Grd%tracer_axes(1:3), Time%model_time,                                 &
    'salt related update of locally ref potrho from xlandmix',             &
    '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_xmix > 0) compute_watermass_diag = .true. 

  id_neut_salt_xmix_on_nrho = register_diag_field ('ocean_model',                             &
   'neut_salt_xmix_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                      &
   'salt related update of locally ref potrho from xlandmix binned to neutral density layers',&
   '(kg/m^3)/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_neut_salt_xmix_on_nrho > 0) compute_watermass_diag = .true. 

  id_wdian_salt_xmix = register_diag_field ('ocean_model', 'wdian_salt_xmix',&
    Grd%tracer_axes(1:3), Time%model_time,                                   &
    'salt related dianeutral mass transport due to xlandmix',                &
    'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_xmix > 0) compute_watermass_diag = .true. 

  id_wdian_salt_xmix_on_nrho = register_diag_field ('ocean_model',                         &
   'wdian_salt_xmix_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,                  &
   'salt related dianeutral mass transport from xlandmix binned to neutral density layers',&
   'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_wdian_salt_xmix_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_salt_xmix = register_diag_field ('ocean_model',    &
     'tform_salt_xmix', Grd%tracer_axes(1:3), Time%model_time,&
     'salt related watermass transform from xlandmix',        &
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_xmix_on_nrho > 0) compute_watermass_diag = .true. 

  id_tform_salt_xmix_on_nrho = register_diag_field ('ocean_model',                     &
     'tform_salt_xmix_on_nrho', Dens%neutralrho_axes(1:3), Time%model_time,            &
     'salt related watermass transform from xlandmix binned to neutral density layers',&
     'kg/sec', missing_value=missing_value, range=(/-1.e20,1.e20/))
  if(id_tform_salt_xmix_on_nrho > 0) compute_watermass_diag = .true. 


  if(compute_watermass_diag) then 
    write(stdoutunit,'(/a/)') &
    '==>Note: running ocean_xlandmix_mod w/ compute_watermass_diag=.true.'  
  endif 


end subroutine watermass_diag_init
! </SUBROUTINE> NAME="watermass_diag_init"


!#######################################################################
! <SUBROUTINE NAME="watermass_diag">
!
! <DESCRIPTION>
! Diagnose effects from xlandmix on watermass transformation.  
! </DESCRIPTION>
!
subroutine watermass_diag(Time, Dens, theta_tend, salt_tend)

  type(ocean_time_type),          intent(in) :: Time
  type(ocean_density_type),       intent(in) :: Dens
  real, dimension(isd:,jsd:,:),   intent(in) :: theta_tend
  real, dimension(isd:,jsd:,:),   intent(in) :: salt_tend

  integer :: i,j,k,tau
  real, dimension(isd:ied,jsd:jed) :: eta_tend
  real    :: eta_tend_glob

  if (.not.module_is_initialized) then 
    call mpp_error(FATAL, &
    '==>Error from ocean_xlandmix (watermass_diag): module needs initialization ')
  endif 

  if (.not. compute_watermass_diag) return

  tau = Time%tau

  ! effects from both temperature and salinity 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0
  wrk5(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodT(i,j,k)*theta_tend(i,j,k) &
                        +Dens%drhodS(i,j,k)*salt_tend(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
           wrk5(i,j,k) =-wrk1(i,j,k)/(epsln+Dens%rho(i,j,k,tau)**2)  ! for eta_tend 
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_rho_xmix, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_rho_xmix, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_rho_xmix, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_rho_xmix_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_rho_xmix_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_rho_xmix_on_nrho, wrk4)

  if(id_eta_tend_xmix > 0 .or. id_eta_tend_xmix_glob > 0) then
      eta_tend(:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               eta_tend(i,j) = eta_tend(i,j) + wrk5(i,j,k)
            enddo
         enddo
      enddo
      call diagnose_2d(Time, Grd, id_eta_tend_xmix, eta_tend(:,:))
      call diagnose_sum(Time, Grd, Dom, id_eta_tend_xmix_glob, eta_tend, cellarea_r)
  endif

 
  ! effects from temperature
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodT(i,j,k)*theta_tend(i,j,k) 
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_temp_xmix, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_temp_xmix, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_temp_xmix, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_temp_xmix_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_temp_xmix_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_temp_xmix_on_nrho, wrk4)
 
  ! effects from salinity 
  wrk1(:,:,:) = 0.0
  wrk2(:,:,:) = 0.0
  wrk3(:,:,:) = 0.0
  wrk4(:,:,:) = 0.0

  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           wrk1(i,j,k) = Dens%drhodS(i,j,k)*salt_tend(i,j,k)
           wrk2(i,j,k) = wrk1(i,j,k)*Dens%rho_dztr_tau(i,j,k)
           wrk3(i,j,k) = wrk2(i,j,k)*Dens%stratification_factor(i,j,k)
           wrk4(i,j,k) = wrk1(i,j,k)*Grd%dat(i,j)*Dens%watermass_factor(i,j,k)
        enddo
     enddo
  enddo

  call diagnose_3d(Time, Grd, id_neut_salt_xmix, wrk2(:,:,:))
  call diagnose_3d(Time, Grd, id_wdian_salt_xmix, wrk3(:,:,:))
  call diagnose_3d(Time, Grd, id_tform_salt_xmix, wrk4(:,:,:))
  call diagnose_3d_rho(Time, Dens, id_neut_salt_xmix_on_nrho, wrk2)
  call diagnose_3d_rho(Time, Dens, id_wdian_salt_xmix_on_nrho, wrk3)
  call diagnose_3d_rho(Time, Dens, id_tform_salt_xmix_on_nrho, wrk4)

 
end subroutine watermass_diag
! </SUBROUTINE>  NAME="watermass_diag"


end module ocean_xlandmix_mod

module betts_miller_mod

!----------------------------------------------------------------------
!use      utilities_mod, only:  file_exist, error_mesg, open_file,  &
!                               check_nml_error, get_my_pe, FATAL,  &
!                               close_file

use            mpp_mod, only:  input_nml_file
use            fms_mod, only:  file_exist, error_mesg, open_namelist_file, &
                               check_nml_error, mpp_pe, mpp_root_pe, &
                               FATAL, close_file, write_version_number, stdlog

use sat_vapor_pres_mod, only:  escomp, descomp
use      constants_mod, only:  HLv,HLs,Cp_air,Grav,rdgas,rvgas, &
                               kappa, es0

implicit none
private
!---------------------------------------------------------------------
!  ---- public interfaces ----

   public  betts_miller, betts_miller_init, betts_miller_end

!-----------------------------------------------------------------------
!   ---- version number ----

 character(len=128) :: version = '$Id: betts_miller.F90,v 19.0 2012/01/06 20:01:31 fms Exp $'
 character(len=128) :: tagname = '$Name: tikal $'

!-----------------------------------------------------------------------
!   ---- local/private data ----

    real, parameter :: d622 = rdgas/rvgas
    real, parameter :: d378 = 1.-d622

    logical :: module_is_initialized=.false.

!-----------------------------------------------------------------------
!   --- namelist ----

real    :: tau_bm=7200.
real    :: rhbm = .8
logical :: do_simp = .true.
!logical :: do_enadjusttemp = .false.
logical :: do_shallower = .false.
logical :: do_changeqref = .false.
logical :: do_envsat = .false.
logical :: do_taucape = .false.
real    :: capetaubm = 900.
real    :: tau_min = 2400.

namelist /betts_miller_nml/  tau_bm, rhbm, do_simp, &
!                            do_enadjusttemp, &
                            do_shallower, do_changeqref, &
                            do_envsat, do_taucape, capetaubm, tau_min

!-----------------------------------------------------------------------
!           description of namelist variables
!
!  tau_bm    =  betts-miller relaxation timescale (seconds)
!
!  rhbm      = relative humidity that you're relaxing towards
!
!  do_simp = do the simple method where you adjust timescales to make 
!            precip continuous always
!
!  do_enadjusttemp = do the betts-miller (1986) way of conserving energy:
!                    adjust the reference temperature by a fixed amount w/ 
!                    height.  

! ***   if neither of the two above are true, then we instead adjust the 
!       humidity profile so its precipitation is increased to balance the 
!       precip_t change, and hence dries more than the 
! 
!  do_shallower = do the shallow convection scheme where it chooses a smaller
!                 depth such that precipitation is zero
! 
!  do_changeqref = do the shallow convection scheme where if changes the 
!                  profile of both q and T in order make precip zero
! 
!  do_envsat = reference profile is rhbm times saturated wrt environment 
!              (if false, it's rhbm times parcel)
!  
!  do_taucape = scheme where taubm is proportional to CAPE**-1/2
!
!  capetaubm = for the above scheme, the value of CAPE for which 
!              tau = tau_bm
!  
!  tau_min   = minimum relaxation time allowed for the above scheme
!
!  
!
!-----------------------------------------------------------------------

contains

!#######################################################################

   subroutine betts_miller (dt, tin, qin, pfull, phalf, coldT, &
                           rain, snow, tdel, qdel, q_ref, bmflag, &
                           klzbs, cape, cin, t_ref,invtau_bm_t,invtau_bm_q, &
                           mask, conv)

!-----------------------------------------------------------------------
!
!                     Betts-Miller Convection Scheme
!
!-----------------------------------------------------------------------
!
!   input:  dt       time step in seconds
!           tin      temperature at full model levels
!           qin      specific humidity of water vapor at full
!                      model levels
!           pfull    pressure at full model levels
!           phalf    pressure at half (interface) model levels
!           coldT    should precipitation be snow at this point?
!   optional:
!           mask     optional mask (0 or 1.) 
!           conv     logical flag; if true then no betts-miller
!                       adjustment is performed at that grid-point or
!                       model level
!
!  output:  rain     liquid precipitation (kg/m2)
!           snow     frozen precipitation (kg/m2)
!           tdel     temperature tendency at full model levels
!           qdel     specific humidity tendency (of water vapor) at
!                      full model levels
!           bmflag   flag for which routines you're calling
!           klzbs    stored klzb values
!           cape     convectively available potential energy 
!           cin      convective inhibition (this and the above are before the 
!                    adjustment)
!           invtau_bm_t temperature relaxation timescale
!           invtau_bm_q humidity relaxation timescale
!
!-----------------------------------------------------------------------
!--------------------- interface arguments -----------------------------

   real   , intent(in) , dimension(:,:,:) :: tin, qin, pfull, phalf
   real   , intent(in)                    :: dt
   logical   , intent(in) , dimension(:,:):: coldT
   real   , intent(out), dimension(:,:)   :: rain,snow, bmflag, klzbs, cape, &
       cin, invtau_bm_t, invtau_bm_q
   real   , intent(out), dimension(:,:,:) :: tdel, qdel, q_ref, t_ref
   real   , intent(in) , dimension(:,:,:), optional :: mask
   logical, intent(in) , dimension(:,:,:), optional :: conv
!-----------------------------------------------------------------------
!---------------------- local data -------------------------------------

   logical :: avgbl
   real,dimension(size(tin,1),size(tin,2),size(tin,3)) :: rin
   real,dimension(size(tin,1),size(tin,2))             :: precip, precip_t
   real,dimension(size(tin,3))                         :: rpc, tpc

   real                                                :: &
       cape1, cin1, tot, deltak, deltaq, qrefint, deltaqfrac, deltaqfrac2, &
       ptopfrac, es, small
integer  i, j, k, ix, jx, kx, klzb, ktop
!-----------------------------------------------------------------------
!     computation of precipitation by betts-miller scheme
!-----------------------------------------------------------------------

      if (.not. module_is_initialized) call error_mesg ('betts_miller',  &
                         'betts_miller_init has not been called.', FATAL)

      ix=size(tin,1)
      jx=size(tin,2)
      kx=size(tin,3)
      avgbl = .false.
      small = 1.e-10

! calculate r
       rin = qin/(1.0 - qin)
       do i=1,ix
          do j=1,jx
             cape1 = 0.
             cin1 = 0.
             tot = 0.
             klzb=0
! the bmflag is written out to show what aspects of the bm scheme is called
! bmflag = 0 is no cape, no convection
! bmflag = 1 is shallow conv, the predicted precip is less than zero
! bmflag = 2 is deep convection
             bmflag(i,j) = 0.
             tpc = tin(i,j,:)
             rpc = rin(i,j,:)
! calculate cape, cin, level of zero buoyancy, and parcel properties 
! new code (second order in delta ln p and exact LCL calculation)
             call capecalcnew( kx,  pfull(i,j,:),  phalf(i,j,:),&
                            cp_air, rdgas, rvgas, hlv, kappa, tin(i,j,:), &
                            rin(i,j,:), avgbl, cape1, cin1, tpc, &
                            rpc, klzb)

! set values for storage
             cape(i,j) = cape1
             cin(i,j) = cin1
             klzbs(i,j) = klzb
             if(cape1.gt.0.) then 
!             if((tot.gt.0.).and.(cape1.gt.0.)) then 
                bmflag(i,j) = 1.
! reference temperature is just that of the parcel all the way up
                t_ref(i,j,:) = tpc
                do k=klzb,kx
! sets reference spec hum to a certain relative hum (change to vapor pressure, 
! multiply by rhbm, then back to spec humid)
                   if(do_envsat) then 
!                      call establ2(es,tin(i,j,k))
                      call escomp(tin(i,j,k),es)
                      es = es*rhbm
!                      rpc(k) = d622*es/(pfull(i,j,k) - d378*es)
                      rpc(k) = rdgas/rvgas*es/pfull(i,j,k)
                      q_ref(i,j,k) = rpc(k)/(1 + rpc(k))
                   else 
                      rpc(k) = rhbm*rpc(k)
!                      eref(k) = rhbm*pfull(i,j,k)*rpc(k)/(d622 + d378*rpc(k))
!                      rpc(k) = d622*eref(k)/(pfull(i,j,k) - d378*eref(k))
                      q_ref(i,j,k) = rpc(k)/(1 + rpc(k))
                   endif 
                end do
! set the tendencies to zero where you don't adjust
! set the reference profiles to be the original profiles (for diagnostic 
! purposes only --  you can think of this as what you're relaxing to in
! areas above the actual convection
                do k=1,max(klzb-1,1)
                   qdel(i,j,k) = 0.0
                   tdel(i,j,k) = 0.0
                   q_ref(i,j,k) = qin(i,j,k)
                   t_ref(i,j,k) = tin(i,j,k)
                end do
! initialize p to zero for the loop
                precip(i,j) = 0.
                precip_t(i,j) = 0.
! makes t_bm prop to (CAPE)**-.5.  Gives a relaxation time of tau_bm when 
! CAPE = sqrt(capetaubm)
                if(do_taucape) then
                   tau_bm = sqrt(capetaubm)*tau_bm/sqrt(cape1)
                   if(tau_bm.lt.tau_min) tau_bm = tau_min
                endif 
                do k=klzb, kx
! relax to reference profiles
                   tdel(i,j,k) = - (tin(i,j,k) - t_ref(i,j,k))/tau_bm*dt
                   qdel(i,j,k) = - (qin(i,j,k) - q_ref(i,j,k))/tau_bm*dt
! Precipitation can be calculated already, based on the change in q on the 
! way up (this isn't altered in the energy conservation scheme).  
                   precip(i,j) = precip(i,j) - qdel(i,j,k)*(phalf(i,j,k+1)- &
                                 phalf(i,j,k))/grav
                   precip_t(i,j)= precip_t(i,j) + cp_air/(hlv+small)*tdel(i,j,k)* &
                                 (phalf(i,j,k+1)-phalf(i,j,k))/grav
                end do
                if ((precip(i,j).gt.0.).and.(precip_t(i,j).gt.0.)) then 
! If precip > 0, then correct energy. 
                   bmflag(i,j) = 2.
                   if(precip(i,j).gt.precip_t(i,j)) then
! if the q precip is greater, then lengthen the relaxation timescale on q to
! conserve energy.  qdel is therefore changed.
                      invtau_bm_q(i,j) = precip_t(i,j)/precip(i,j)/tau_bm
                      qdel(i,j,klzb:kx) = tau_bm*invtau_bm_q(i,j)* &
                         qdel(i,j,klzb:kx)
                      precip(i,j) = precip_t(i,j)
                      invtau_bm_t(i,j) = 1./tau_bm
                   else
                      if(do_simp) then
! simple scheme:
! if the t precip is greater, then lengthen the relaxation timescale on t to
! conserve energy.  tdel is therefore changed.
                         invtau_bm_t(i,j) = precip(i,j)/precip_t(i,j)/tau_bm
                         tdel(i,j,klzb:kx) = tau_bm*invtau_bm_t(i,j)* &
                            tdel(i,j,klzb:kx)
                         invtau_bm_q(i,j) = 1./tau_bm
!                      else if(do_enadjusttemp)
                      else
! not simple scheme: shift the reference profile of temperature
! deltak is the energy correction that you make to the temperature reference
! profile
                         deltak = 0.
                         do k=klzb, kx
! Calculate the integrated difference in energy change within each level.
                            deltak = deltak - (tdel(i,j,k) + hlv/cp_air*&
                                     qdel(i,j,k))* &
                                     (phalf(i,j,k+1) - phalf(i,j,k))
                         end do
! Divide by total pressure.
                         deltak = deltak/(phalf(i,j,kx+1) - phalf(i,j,klzb))
! Adjust the reference profile (uniformly with height), and correspondingly 
! the temperature change.
                         t_ref(i,j,klzb:kx) = t_ref(i,j,klzb:kx)+ &
                              deltak*tau_bm/dt
                         tdel(i,j,klzb:kx) = tdel(i,j,klzb:kx) + deltak
                      endif
                   endif
                else if(precip_t(i,j).gt.0.) then
! If precip < 0, then do the shallow conv routine.
! First option: do_shallower = true
! This chooses the depth of convection based on choosing the height that 
! it can make precip zero, i.e., subtract off heights until that precip 
! becomes positive.  
                   if (do_shallower) then
! ktop is the new top of convection.  set this initially to klzb.
                      ktop = klzb
! Work your way down until precip is positive again.
                      do while ((precip(i,j).lt.0.).and.(ktop.le.kx))
                         precip(i,j) = precip(i,j) - qdel(i,j,ktop)* &
                                  (phalf(i,j,ktop) - phalf(i,j,ktop+1))/grav
                         ktop = ktop + 1
                      end do
! since there will be an overshoot (precip is going to be greater than zero 
! once we finish this), the actual new top of convection is somewhere between
! the current ktop, and one level above this.  set ktop to the level above.
                      ktop = ktop - 1
! Adjust the tendencies in the places above back to zero, and the reference 
! profiles back to the original t,q.
                      if (ktop.gt.klzb) then
                         qdel(i,j,klzb:ktop-1) = 0.
                         q_ref(i,j,klzb:ktop-1) = qin(i,j,klzb:ktop-1)
                         tdel(i,j,klzb:ktop-1) = 0.
                         t_ref(i,j,klzb:ktop-1) = tin(i,j,klzb:ktop-1)
                      end if
! Then make the change only a fraction of the new top layer so the precip is 
! identically zero.
! Calculate the fractional penetration of convection through that top layer.  
! This is the amount necessary to make precip identically zero.  
                      if (precip(i,j).gt.0.) then 
                         ptopfrac = precip(i,j)/(qdel(i,j,ktop)* &
                            (phalf(i,j,ktop+1) - phalf(i,j,ktop)))*grav
! Reduce qdel in the top layer by this fraction. 
                         qdel(i,j,ktop) = ptopfrac*qdel(i,j,ktop)
! Set precip to zero
                         precip(i,j) = 0.
! Now change the reference temperature in such a way to make the net 
! heating zero.
!! Reduce tdel in the top layer
                         tdel(i,j,ktop) = ptopfrac*tdel(i,j,ktop)
                         deltak = 0.
                         if (ktop.lt.kx) then
! Integrate temperature tendency up to 1 level below top.
                            do k=ktop,kx
                               deltak = deltak + tdel(i,j,k)* &
                                   (phalf(i,j,k) - phalf(i,j,k+1))
                            end do
! Normalize by the pressure difference.
                            deltak = deltak/(phalf(i,j,kx+1) - phalf(i,j,ktop))
! Subtract this value uniformly from tdel, and make the according change to 
! t_ref.
                            do k=ktop,kx
                               tdel(i,j,k) = tdel(i,j,k) + deltak
                               t_ref(i,j,k) = t_ref(i,j,k) + deltak*tau_bm/dt
                            end do
                         end if
                      else
                         precip(i,j) = 0.
                         qdel(i,j,kx) = 0.
                         q_ref(i,j,kx) = qin(i,j,kx)
                         tdel(i,j,kx) = 0.
                         t_ref(i,j,kx) = tin(i,j,kx)
                         invtau_bm_t(i,j) = 0.
                         invtau_bm_q(i,j) = 0.
                      end if
                   else if(do_changeqref) then
! Change the reference profile of q by a certain fraction so that precip is 
! zero.  This involves calculating the total integrated q_ref dp (this is the
! quantity intqref), as well as the necessary change in q_ref (this is the 
! quantity deltaq).  Then the fractional change in q_ref at each level (the 
! quantity deltaqfrac) is 1-deltaq/intqref.  (have to multiply q_ref by 
! 1-deltaq/intqref at every level)  Then the change in qdel is 
! -deltaq/intqref*q_ref*dt/tau_bm.
! Change the reference profile of T by a uniform amount so that precip is zero.
                      deltak = 0.
                      deltaq = 0.
                      qrefint = 0.
                      do k=klzb,kx
! deltaq = a positive quantity (since int qdel is positive).  It's how 
! much q_ref must be changed by, in an integrated sense.  The requisite 
! change in qdel is this without the factors of tau_bm and dt.
                         deltaq = deltaq - qdel(i,j,k)*tau_bm/dt* &
                                   (phalf(i,j,k) - phalf(i,j,k+1))
! deltak = the amount tdel needs to be changed
                         deltak  = deltak  + tdel(i,j,k)* &
                                   (phalf(i,j,k) - phalf(i,j,k+1))
! qrefint = integrated value of qref
                         qrefint = qrefint - q_ref(i,j,k)* &
                                   (phalf(i,j,k) - phalf(i,j,k+1))
                      end do
! Normalize deltak by total pressure.
                      deltak  = deltak /(phalf(i,j,kx+1) - phalf(i,j,klzb))
! multiplying factor for q_ref is 1 + the ratio
                      deltaqfrac = 1. - deltaq/qrefint
! multiplying factor for qdel adds dt/tau_bm
                      deltaqfrac2 = - deltaq/qrefint*dt/tau_bm
                      precip(i,j) = 0.0
                      do k=klzb,kx
                         qdel(i,j,k) = qdel(i,j,k) + deltaqfrac2*q_ref(i,j,k)
                         q_ref(i,j,k) = deltaqfrac*q_ref(i,j,k)
                         tdel(i,j,k) = tdel(i,j,k) + deltak
                         t_ref(i,j,k) = t_ref(i,j,k) + deltak*tau_bm/dt
                      end do
                   else
                      precip(i,j) = 0.
                      tdel(i,j,:) = 0.
                      qdel(i,j,:) = 0.
                      invtau_bm_t(i,j) = 0.
                      invtau_bm_q(i,j) = 0.
                   end if
! for cases where virtual temp predicts CAPE but precip_t < 0.
                else
                   tdel(i,j,:) = 0.0
                   qdel(i,j,:) = 0.0
                   precip(i,j) = 0.0
                   q_ref(i,j,:) = qin(i,j,:)
                   t_ref(i,j,:) = tin(i,j,:)
                   invtau_bm_t(i,j) = 0.
                   invtau_bm_q(i,j) = 0.
                end if
! if no CAPE, set tendencies to zero.
             else 
                tdel(i,j,:) = 0.0
                qdel(i,j,:) = 0.0
                precip(i,j) = 0.0
                q_ref(i,j,:) = qin(i,j,:)
                t_ref(i,j,:) = tin(i,j,:)
                invtau_bm_t(i,j) = 0.
                invtau_bm_q(i,j) = 0.
             end if
          end do
       end do

       rain = precip
       snow = 0.
   

   end subroutine betts_miller

!#######################################################################

!all new cape calculation.

      subroutine capecalcnew(kx,p,phalf,cp_air,rdgas,rvgas,hlv,kappa,tin,rin,&
                             avgbl,cape,cin,tp,rp,klzb)

!
!    Input:
!
!    kx          number of levels
!    p           pressure (index 1 refers to TOA, index kx refers to surface)
!    phalf       pressure at half levels
!    cp_air      specific heat of dry air
!    rdgas       gas constant for dry air
!    rvgas       gas constant for water vapor (used in Clausius-Clapeyron, 
!                not for virtual temperature effects, which are not considered)
!    hlv         latent heat of vaporization
!    kappa       the constant kappa
!    tin         temperature of the environment
!    rin         specific humidity of the environment
!    avgbl       if true, the parcel is averaged in theta and r up to its LCL
!
!    Output:
!    cape        Convective available potential energy
!    cin         Convective inhibition (if there's no LFC, then this is set 
!                to zero)
!    tp          Parcel temperature (set to the environmental temperature 
!                where no adjustment)
!    rp          Parcel specific humidity (set to the environmental humidity 
!                where no adjustment, and set to the saturation humidity at 
!                the parcel temperature below the LCL)
!    klzb        Level of zero buoyancy
!
!    Algorithm: 
!    Start with surface parcel. 
!    Calculate the lifting condensation level (uses an analytic formula and a 
!       lookup table).  
!    Average under the LCL if desired, if this is done, then a new LCL must
!       be calculated.  
!    Calculate parcel ascent up to LZB.
!    Calculate CAPE and CIN.  
      implicit none
      integer, intent(in)                    :: kx
      logical, intent(in)                    :: avgbl
      real, intent(in), dimension(:)         :: p, phalf, tin, rin
      real, intent(in)                       :: rdgas, rvgas, hlv, kappa, cp_air
      integer, intent(out)                   :: klzb
      real, intent(out), dimension(:)        :: tp, rp
      real, intent(out)                      :: cape, cin

      integer            :: k, klcl, klfc, klcl2
      logical            :: nocape
      real, dimension(kx)   :: theta
      real                  :: t0, r0, es, rs, theta0, pstar, value, tlcl, &
                               a, b, dtdlnp, thetam, rm, tlcl2, &
                               plcl2, plcl, plzb, small

      pstar = 1.e5
! so we can run dry limit (one expression involves 1/hlv)
      small = 1.e-10

      nocape = .true.
      cape = 0.
      cin = 0.
      plcl = 0.
      plzb = 0.
      klfc = 0
      klcl = 0
      klzb = 0
      tp(1:kx) = tin(1:kx)
      rp(1:kx) = rin(1:kx)

! start with surface parcel
      t0 = tin(kx)
      r0 = rin(kx)
! calculate the lifting condensation level by the following:
! are you saturated to begin with?  
      call escomp(t0,es)
      rs = rdgas/rvgas*es/p(kx)
      if (r0.ge.rs) then
! if youčre already saturated, set lcl to be the surface value.
         plcl = p(kx)
! the first level where youčre completely saturated.
         klcl = kx
! saturate out to get the parcel temp and humidity at this level
! first order (in delta T) accurate expression for change in temp
         tp(kx) = t0 + (r0 - rs)/(cp_air/(hlv+small) + hlv*rs/rvgas/t0**2.)
         call escomp(tp(kx),es)
         rp(kx) = rdgas/rvgas*es/p(kx)
      else
! if not saturated to begin with, use the analytic expression to calculate the 
! exact pressure and temperature where youčre saturated.  
         theta0 = tin(kx)*(pstar/p(kx))**kappa
! the expression that we utilize is 
! log(r/theta**(1/kappa)*pstar*rvgas/rdgas/es00) = log(es/T**(1/kappa))
! (the division by es00 is necessary because the RHS values are tabulated
! for control moisture content)
! The right hand side of this is only a function of temperature, therefore 
! this is put into a lookup table to solve for temperature.  
         if (r0.gt.0.) then
            value = log(theta0**(-1/kappa)*r0*pstar*rvgas/rdgas/es0)
            call lcltabl(value,tlcl)
            plcl = pstar*(tlcl/theta0)**(1/kappa)
! just in case plcl is very high up
            if (plcl.lt.p(1)) then
               plcl = p(1)
               tlcl = theta0*(plcl/pstar)**kappa
               write (*,*) 'hi lcl'
            end if
            k = kx
         else
! if the parcel sp hum is zero or negative, set lcl to top level
            plcl = p(1)
            tlcl = theta0*(plcl/pstar)**kappa
!            write (*,*) 'zero r0', r0
            do k=1,kx
               tp(k) = theta0*(p(k)/pstar)**kappa
               rp(k) = 0.
! this definition of CIN contains everything below the LCL
               cin = cin + rdgas*(tin(k) - tp(k))*log(phalf(k+1)/phalf(k))
            end do
            go to 11
         end if
! calculate the parcel temperature (adiabatic ascent) below the LCL.  
! the mixing ratio stays the same
         do while (p(k).gt.plcl)
            tp(k) = theta0*(p(k)/pstar)**kappa
            call escomp(tp(k),es)
            rp(k) = rdgas/rvgas*es/p(k)
! this definition of CIN contains everything below the LCL
            cin = cin + rdgas*(tin(k) - tp(k))*log(phalf(k+1)/phalf(k))
            k = k-1
         end do
! first level where you're saturated at the level
         klcl = k
         if (klcl.eq.1) klcl = 2
! do a saturated ascent to get the parcel temp at the LCL.  
! use your 2nd order equation up to the pressure above.  
! moist adaibat derivatives: (use the lcl values for temp, humid, and 
! pressure)
         a = kappa*tlcl + hlv/cp_air*r0
         b = hlv**2.*r0/cp_air/rvgas/tlcl**2.
         dtdlnp = a/(1. + b)
! first order in p
!         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl)
! second order in p (RK2)
! first get temp halfway up 
         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl)/2.
         if ((tp(klcl).lt.173.16).and.nocape) go to 11
         call escomp(tp(klcl),es)
         rp(klcl) = rdgas/rvgas*es/(p(klcl) + plcl)*2.
         a = kappa*tp(klcl) + hlv/cp_air*rp(klcl)
         b = hlv**2./cp_air/rvgas*rp(klcl)/tp(klcl)**2.
         dtdlnp = a/(1. + b)
! second half of RK2
         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl)
!         d2tdlnp2 = (kappa + b - 1. - b/tlcl*(hlv/rvgas/tlcl - &
!                   2.)*dtdlnp)/ (1. + b)*dtdlnp - hlv*r0/cp_air/ &
!                   (1. + b)
! second order in p
!         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl) + .5*d2tdlnp2*(log(&
!             p(klcl)/plcl))**2.
         if ((tp(klcl).lt.173.16).and.nocape) go to 11
         call escomp(tp(klcl),es)
         rp(klcl) = rdgas/rvgas*es/p(klcl)
!         write (*,*) 'tp, rp klcl:kx, new', tp(klcl:kx), rp(klcl:kx)
! CAPE/CIN stuff
         if ((tp(klcl).lt.tin(klcl)).and.nocape) then
! if youčre not yet buoyant, then add to the CIN and continue
            cin = cin + rdgas*(tin(klcl) - &
                 tp(klcl))*log(phalf(klcl+1)/phalf(klcl))
         else
! if youčre buoyant, then add to cape
            cape = cape + rdgas*(tp(klcl) - &
                  tin(klcl))*log(phalf(klcl+1)/phalf(klcl))
! if itčs the first time buoyant, then set the level of free convection to k
            if (nocape) then
               nocape = .false.
               klfc = klcl
            endif
         end if
      end if
! then average the properties over the boundary layer if so desired.  to give 
! a new "parcel".  this may not be saturated at the LCL, so make sure you get 
! to a level where it is before moist adiabatic ascent!
!!!! take out all the below (between the exclamation points) if no avgbl !!!!
      if (avgbl) then
         theta(klcl:kx) = tin(klcl:kx)*(pstar/p(klcl:kx))**kappa
         thetam = 0.
         rm = 0.
         do k=klcl,kx
            thetam = thetam + theta(k)*(phalf(k+1) - phalf(k))
            rm = rm + rin(k)*(phalf(k+1) - phalf(k))
         end do
         thetam = thetam/(phalf(kx+1) - phalf(klcl))
         rm = rm/(phalf(kx+1) - phalf(klcl))
! check if you're saturated at the top level.  if not, then get a new LCL
         tp(klcl) = thetam*(p(klcl)/pstar)**kappa
         call escomp(tp(klcl),es)
         rs = rdgas/rvgas*es/p(klcl)
! if you're not saturated, get a new LCL
         if (rm.lt.rs) then
! reset CIN to zero.  
            cin = 0.
! again, use the analytic expression to calculate the exact pressure and 
! temperature where youčre saturated.  
! the expression that we utilize is 
! log(r/theta**(1/kappa)*pstar*rvgas/rdgas/es00)= log(es/T**(1/kappa))
! (the division by es00 is necessary because the RHS values are tabulated
! for control moisture content)
! The right hand side of this is only a function of temperature, therefore 
! this is put into a lookup table to solve for temperature.  
            value = log(thetam**(-1/kappa)*rm*pstar*rvgas/rdgas/es0)
            call lcltabl(value,tlcl2)
            plcl2 = pstar*(tlcl2/thetam)**(1/kappa)
! just in case plcl is very high up
            if (plcl2.lt.p(1)) then
               plcl2 = p(1)
            end if
            k = kx
! calculate the parcel temperature (adiabatic ascent) below the LCL.  
! the mixing ratio stays the same
            do while (p(k).gt.plcl2) 
               tp(k) = thetam*(p(k)/pstar)**kappa
               call escomp(tp(k),es)
               rp(k) = rdgas/rvgas*es/p(k)
! this definition of CIN contains everything below the LCL
               cin = cin + rdgas*(tin(k) - tp(k))*log(phalf(k+1)/phalf(k))
               k = k-1
            end do
! first level where youčre saturated at the level
            klcl2 = k
            if (klcl2.eq.1) klcl2 = 2
! do a saturated ascent to get the parcel temp at the LCL.  
! use your 2nd order equation up to the pressure above.  
! moist adaibat derivatives: (use the lcl values for temp, humid, and 
! pressure)
            a = kappa*tlcl2 + hlv/cp_air*rm
            b = hlv**2.*rm/cp_air/rvgas/tlcl2**2.
            dtdlnp = a/(1. + b)
! first order in p
!            tp(klcl2) = tlcl2 + dtdlnp*log(p(klcl2)/plcl2)
! second order in p (RK2)
! first get temp halfway up 
         tp(klcl2) = tlcl2 + dtdlnp*log(p(klcl2)/plcl2)/2.
         if ((tp(klcl2).lt.173.16).and.nocape) go to 11
         call escomp(tp(klcl2),es)
         rp(klcl2) = rdgas/rvgas*es/(p(klcl2) + plcl2)*2.
         a = kappa*tp(klcl2) + hlv/cp_air*rp(klcl2)
         b = hlv**2./cp_air/rvgas*rp(klcl2)/tp(klcl2)**2.
         dtdlnp = a/(1. + b)
! second half of RK2
         tp(klcl2) = tlcl2 + dtdlnp*log(p(klcl2)/plcl2)
!            d2tdlnp2 = (kappa + b - 1. - b/tlcl2*(hlv/rvgas/tlcl2 - &
!                          2.)*dtdlnp)/ (1. + b)*dtdlnp - hlv*rm/cp_air/ &
!                          (1. + b)
! second order in p
!            tp(klcl2) = tlcl2 + dtdlnp*log(p(klcl2)/plcl2) + &
!               .5*d2tdlnp2*(log(p(klcl2)/plcl2))**2.
            call escomp(tp(klcl2),es)
            rp(klcl2) = rdgas/rvgas*es/p(klcl2)
! CAPE/CIN stuff
            if ((tp(klcl2).lt.tin(klcl2)).and.nocape) then
! if youčre not yet buoyant, then add to the CIN and continue
               cin = cin + rdgas*(tin(klcl2) - &
                    tp(klcl2))*log(phalf(klcl2+1)/phalf(klcl2))
            else
! if youčre buoyant, then add to cape
               cape = cape + rdgas*(tp(klcl) - &
                     tin(klcl))*log(phalf(klcl+1)/phalf(klcl))
! if itčs the first time buoyant, then set the level of free convection to k
               if (nocape) then
                  nocape = .false.
                  klfc = klcl2
               endif
            end if
         end if
      end if
!!!! take out all of the above (within the exclamations) if no avgbl !!!!
! then, start at the LCL, and do moist adiabatic ascent by the first order 
! scheme -- 2nd order as well
      do k=klcl-1,1,-1
         a = kappa*tp(k+1) + hlv/cp_air*rp(k+1)
         b = hlv**2./cp_air/rvgas*rp(k+1)/tp(k+1)**2.
         dtdlnp = a/(1. + b)
! first order in p
!         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1))
! second order in p (RK2)
! first get temp halfway up 
         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1))/2.
         if ((tp(k).lt.173.16).and.nocape) go to 11
         call escomp(tp(k),es)
         rp(k) = rdgas/rvgas*es/(p(k) + p(k+1))*2.
         a = kappa*tp(k) + hlv/cp_air*rp(k)
         b = hlv**2./cp_air/rvgas*rp(k)/tp(k)**2.
         dtdlnp = a/(1. + b)
! second half of RK2
         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1))
!         d2tdlnp2 = (kappa + b - 1. - b/tp(k+1)*(hlv/rvgas/tp(k+1) - & 
!               2.)*dtdlnp)/(1. + b)*dtdlnp - hlv/cp_air*rp(k+1)/(1. + b)
! second order in p
!         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1)) + .5*d2tdlnp2*(log( &
!             p(k)/p(k+1)))**2.
! if you're below the lookup table value, just presume that there's no way 
! you could have cape and call it quits
         if ((tp(k).lt.173.16).and.nocape) go to 11
         call escomp(tp(k),es)
         rp(k) = rdgas/rvgas*es/p(k)
         if ((tp(k).lt.tin(k)).and.nocape) then
! if youčre not yet buoyant, then add to the CIN and continue
            cin = cin + rdgas*(tin(k) - tp(k))*log(phalf(k+1)/phalf(k))
         elseif((tp(k).lt.tin(k)).and.(.not.nocape)) then
! if you have CAPE, and itčs your first time being negatively buoyant, 
! then set the level of zero buoyancy to k+1, and stop the moist ascent
            klzb = k+1
            go to 11
         else
! if youčre buoyant, then add to cape
            cape = cape + rdgas*(tp(k) - tin(k))*log(phalf(k+1)/phalf(k))
! if itčs the first time buoyant, then set the level of free convection to k
            if (nocape) then
               nocape = .false.
               klfc = k
            endif
         end if
      end do
 11   if(nocape) then 
! this is if you made it through without having a LZB
! set LZB to be the top level.
         plzb = p(1)
         klzb = 0
         klfc = 0
         cin = 0.
         tp(1:kx) = tin(1:kx)
         rp(1:kx) = rin(1:kx)
      end if
!      write (*,*) 'plcl, klcl, tlcl, r0 new', plcl, klcl, tlcl, r0
!      write (*,*) 'tp, rp new', tp, rp
!       write (*,*) 'tp, new', tp
!       write (*,*) 'tin new', tin 
!       write (*,*) 'klcl, klfc, klzb new', klcl, klfc, klzb
      end subroutine capecalcnew

! lookup table for the analytic evaluation of LCL
      subroutine lcltabl(value,tlcl)
!
! Table of values used to compute the temperature of the lifting condensation
! level.  
! 
! the expression that we utilize is 
! log(r/theta**(1/kappa)*pstar*rvgas/rdgas/es00) = log(es/T**(1/kappa))
! the RHS is tabulated for control moisture content, hence the division 
! by es00 on the LHS
! 
! Gives the values of the temperature for the following range: 
!   starts with -23, is uniformly distributed up to -10.4.  There are a 
! total of 127 values, and the increment is .1.  
!
      implicit none 
      real, intent(in)     :: value
      real, intent(out)    :: tlcl

      integer              :: ival
      real, dimension(127) :: lcltable
      real                 :: v1, v2

      data lcltable/  1.7364512e+02,   1.7427449e+02,   1.7490874e+02, &
      1.7554791e+02,   1.7619208e+02,   1.7684130e+02,   1.7749563e+02, &
      1.7815514e+02,   1.7881989e+02,   1.7948995e+02,   1.8016539e+02, &
      1.8084626e+02,   1.8153265e+02,   1.8222461e+02,   1.8292223e+02, &
      1.8362557e+02,   1.8433471e+02,   1.8504972e+02,   1.8577068e+02, &
      1.8649767e+02,   1.8723077e+02,   1.8797006e+02,   1.8871561e+02, &
      1.8946752e+02,   1.9022587e+02,   1.9099074e+02,   1.9176222e+02, &
      1.9254042e+02,   1.9332540e+02,   1.9411728e+02,   1.9491614e+02, &
      1.9572209e+02,   1.9653521e+02,   1.9735562e+02,   1.9818341e+02, &
      1.9901870e+02,   1.9986158e+02,   2.0071216e+02,   2.0157057e+02, &
      2.0243690e+02,   2.0331128e+02,   2.0419383e+02,   2.0508466e+02, &
      2.0598391e+02,   2.0689168e+02,   2.0780812e+02,   2.0873335e+02, &
      2.0966751e+02,   2.1061074e+02,   2.1156316e+02,   2.1252493e+02, &
      2.1349619e+02,   2.1447709e+02,   2.1546778e+02,   2.1646842e+02, &
      2.1747916e+02,   2.1850016e+02,   2.1953160e+02,   2.2057364e+02, &
      2.2162645e+02,   2.2269022e+02,   2.2376511e+02,   2.2485133e+02, &
      2.2594905e+02,   2.2705847e+02,   2.2817979e+02,   2.2931322e+02, &
      2.3045895e+02,   2.3161721e+02,   2.3278821e+02,   2.3397218e+02, &
      2.3516935e+02,   2.3637994e+02,   2.3760420e+02,   2.3884238e+02, &
      2.4009473e+02,   2.4136150e+02,   2.4264297e+02,   2.4393941e+02, &
      2.4525110e+02,   2.4657831e+02,   2.4792136e+02,   2.4928053e+02, &
      2.5065615e+02,   2.5204853e+02,   2.5345799e+02,   2.5488487e+02, &
      2.5632953e+02,   2.5779231e+02,   2.5927358e+02,   2.6077372e+02, &
      2.6229310e+02,   2.6383214e+02,   2.6539124e+02,   2.6697081e+02, &
      2.6857130e+02,   2.7019315e+02,   2.7183682e+02,   2.7350278e+02, &
      2.7519152e+02,   2.7690354e+02,   2.7863937e+02,   2.8039954e+02, &
      2.8218459e+02,   2.8399511e+02,   2.8583167e+02,   2.8769489e+02, &
      2.8958539e+02,   2.9150383e+02,   2.9345086e+02,   2.9542719e+02, &
      2.9743353e+02,   2.9947061e+02,   3.0153922e+02,   3.0364014e+02, &
      3.0577420e+02,   3.0794224e+02,   3.1014515e+02,   3.1238386e+02, &
      3.1465930e+02,   3.1697246e+02,   3.1932437e+02,   3.2171609e+02, &
      3.2414873e+02,   3.2662343e+02,   3.2914139e+02,   3.3170385e+02 /

      v1 = value
      if (value.lt.-23.0) v1 = -23.0
      if (value.gt.-10.4) v1 = -10.4
      ival = floor(10.*(v1 + 23.0))
      v2 = -230. + ival
      v1 = 10.*v1
      tlcl = (v2 + 1.0 - v1)*lcltable(ival+1) + (v1 - v2)*lcltable(ival+2)


      end subroutine lcltabl

!#######################################################################

   subroutine betts_miller_init ()

!-----------------------------------------------------------------------
!
!        initialization for betts_miller
!
!-----------------------------------------------------------------------

  integer  unit,io,ierr, logunit

!----------- read namelist ---------------------------------------------

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=betts_miller_nml, iostat=io)
      ierr = check_nml_error(io,'betts_miller_nml')
#else   
      if (file_exist('input.nml')) then
         unit = open_namelist_file ( )
         ierr=1; do while (ierr /= 0)
            read  (unit, nml=betts_miller_nml, iostat=io, end=10)
            ierr = check_nml_error (io,'betts_miller_nml')
         enddo
  10     call close_file (unit)
      endif
#endif

!---------- output namelist --------------------------------------------

      call write_version_number(version, tagname)
      logunit = stdlog()
      if ( mpp_pe() == mpp_root_pe() ) then
           write (logunit,nml=betts_miller_nml)
      endif

      module_is_initialized =.true.

   end subroutine betts_miller_init

!#######################################################################
   subroutine betts_miller_end ()

      module_is_initialized =.false.

   end subroutine betts_miller_end

end module betts_miller_mod

module time_interp_mod

! <CONTACT EMAIL="Bruce.Wyman@noaa.gov">
!   Bruce Wyman
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!   Computes a weight and dates/indices for linearly interpolating between two dates.
! </OVERVIEW>

! <DESCRIPTION>
!     A time type is converted into two consecutive dates plus
!     a fraction representing the distance between the dates.
!     This information can be used to interpolate between the dates.
!     The dates may be expressed as years, months, or days or
!     as indices in an array.
! </DESCRIPTION>

! <PUBLIC>
!   Description summarizing public interface.
! </PUBLIC>

!-----------------------------------------------------------------------

use time_manager_mod, only: time_type, get_date, set_date, set_time, &
                            days_in_year, days_in_month, leap_year,  &
                            time_type_to_real, real_to_time_type,    &
                            get_calendar_type, JULIAN, GREGORIAN, NO_CALENDAR, &
                            operator(+), operator(-), operator(>),   &
                            operator(<), operator( // ), operator( / ),  &
                            operator(>=), operator(<=), operator( * ), &
                            operator(==), print_date, print_time

use          fms_mod, only: write_version_number, &
                            error_mesg, FATAL, stdout, stdlog, &
                            open_namelist_file, close_file, check_nml_error, &
                            fms_error_handler
use          mpp_mod, only: input_nml_file

implicit none
private

!-----------------------------------------------------------------------

public :: time_interp_init, time_interp, fraction_of_year

! <INTERFACE NAME="time_interp">

!   <OVERVIEW>
!      Returns a weight and dates or indices for interpolating between two dates. The
!      interface fraction_of_year is provided for backward compatibility with the
!      previous version. 
!   </OVERVIEW>
!   <DESCRIPTION>
!      Returns weight by interpolating Time between Time1 and Time2.
!      i.e. weight = (Time-Time1)/(Time2-Time1)
!      Time1 and Time2 may be specified by any of several different ways,
!      which is the reason for multiple interfaces.

!      If Time1 and Time2 are the begining and end of the year in which
!      Time falls, use first interface.

!      If Time1 and Time2 fall on year boundaries, use second interface.

!      If Time1 and Time2 fall on month boundaries, use third.

!      If Time1 and Time2 fall on day boundaries, use fourth.

!      If Time1 and Time2 are consecutive elements of an assending list, use fifth.
!      The fifth also returns the indices of Timelist between which Time falls.

!      The sixth interface is for cyclical data. Time_beg and Time_end specify the
!      begining and end of a repeating period. In this case:
!      weight = (Time_adjusted - Time1) / (Time2 - Time1)
!      Where:
!      Time1 = Timelist(index1)
!      Time2 = Timelist(index2)
!      Time_adjusted = Time - N*Period
!      Period = Time_end-Time_beg
!      N is between (Time-Time_end)/Period and (Time-Time_beg)/Period
!      That is, N is the integer that results in Time_adjusted that is between Time_beg and Time_end.
!      
!   </DESCRIPTION>
!   <TEMPLATE>
!     1. call time_interp( Time, weight )
!   </TEMPLATE>
!   <TEMPLATE>
!     2. call time_interp( Time, weight, year1, year2 )
!   </TEMPLATE>
!   <TEMPLATE>
!     3. call time_interp( Time, weight, year1, year2, month1, month2 )
!   </TEMPLATE>
!   <TEMPLATE>
!     4. call time_interp( Time, weight, year1, year2, month1, month2, day1, day2 )
!   </TEMPLATE>
!   <TEMPLATE>
!     5. call time_interp( Time, Timelist, weight, index1, index2 [, modtime] )
!   </TEMPLATE>
!   <TEMPLATE>
!     6. call time_interp( Time, Time_beg, Time_end, Timelist, weight, index1, index2 [,correct_leap_year_inconsistency])
!   </TEMPLATE>
!   <IN NAME="Time">
!      The time at which the the weight is computed.
!   </IN>
!   <IN NAME="Time_beg">
!      For cyclical interpolation: Time_beg specifies the begining time of a cycle.
!   </IN>
!   <IN NAME="Time_end">
!      For cyclical interpolation: Time_end specifies the ending time of a cycle.
!   </IN>
!   <IN NAME="Timelist">
!      For cyclical interpolation: Timelist is an array of times between Time_beg and Time_end.
!                                  Must be monotonically increasing.
!   </IN>
!   <IN NAME="modtime">
!   </IN>
!   <IN NAME="index1">
!      Timelist(index1) = The largest value of Timelist which is less than mod(Time,Time_end-Time_beg)
!   </IN>
!   <IN NAME="index2">
!      Timelist(index2) = The smallest value of Timelist which is greater than mod(Time,Time_end-Time_beg)
!   </IN>
!   <IN NAME="correct_leap_year_inconsistency">
!       Turns on a kluge for an inconsistency which may occur in a special case.
!       When the modulo time period (i.e. Time_end - Time_beg) is a whole number of years
!       and is not a multiple of 4, and the calendar in use has leap years, then it is
!       likely that the interpolation will involve mapping a common year onto a leap year.
!       In this case it is often desirable, but not absolutely necessary, to use data for
!       Feb 28 of the leap year when it is mapped onto a common year.
!       To turn this on, set correct_leap_year_inconsistency=.true.
!   </IN>
!   <OUT NAME="weight">
!     weight = (mod(Time,Time_end-Time_beg) - Timelist(index1)) / (Timelist(index2) - Timelist(index1))
!   </OUT>
!   <OUT NAME="year1"> </OUT>
!   <OUT NAME="year2"> </OUT>
!   <OUT NAME="month1"> </OUT>
!   <OUT NAME="month2"> </OUT>
!   <OUT NAME="day1"> </OUT>
!   <OUT NAME="day2"> </OUT>
!   <OUT NAME="index1"> </OUT>
!   <OUT NAME="index2"> </OUT>
!   <ERROR MSG="input time list not ascending order" STATUS="ERROR">
!     The list of input time types must have ascending dates.
!   </ERROR>
!   <ERROR MSG="modulo months must have same length" STATUS="ERROR">
!     The length of the current month for input Time and Time_list
!     must be the same when using the modulo month option. The
!     modulo month option is available but not supported. 
!   </ERROR>
!   <ERROR MSG="invalid value for argument modtime" STATUS="ERROR">
!     The optional argument modtime must have a value set by one
!     of the public parameters: NONE, YEAR, MONTH, DAY. The
!     MONTH and DAY options are available but not supported. 
!   </ERROR>
!   <ERROR MSG="period of list exceeds modulo period" STATUS="ERROR">
!     The difference between the last and first values in the input
!     Time list/array exceeds the length of the modulo period.
!   </ERROR>
!   <ERROR MSG="time before range of list or time after range of list" STATUS="ERROR">
!     The difference between the last and first values in the input
!     These errors occur when you are not using a modulo axis and
!     the input Time occurs before the first value in the Time
!     list/array or after the last value in the Time list/array. 
!   </ERROR>
!   <NOTE>
!     Examples: 
!     <PRE>
!       Time: Jan 01 00z    weight = 0.0 
!       Time: Jul 01        weight ~ 0.5 
!       Time: Dec 31 23z    weight ~ 1.0
!     </PRE>
!   </NOTE>

interface time_interp
    module procedure time_interp_frac,  time_interp_year, &
                     time_interp_month, time_interp_day,  &
                     time_interp_list,  time_interp_modulo
end interface
! </INTERFACE>

integer, public, parameter :: NONE=0, YEAR=1, MONTH=2, DAY=3

!-----------------------------------------------------------------------

   integer, parameter ::  secmin = 60, minhour = 60, hourday = 24,  &
                         sechour = secmin*minhour,                  &
                          secday = secmin*minhour*hourday

   integer, parameter :: monyear = 12
   integer, parameter :: halfday = secday/2

   integer :: yrmod, momod, dymod
   logical :: mod_leapyear

   character(len=128) :: version='$Id$'
   character(len=128) :: tagname='$Name$'

   logical :: module_is_initialized=.FALSE.
   logical :: perthlike_behavior=.FALSE.

   namelist / time_interp_nml / perthlike_behavior

contains


 subroutine time_interp_init()
   integer :: ierr, io, namelist_unit, logunit

   if ( module_is_initialized ) return

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, time_interp_nml, iostat=io)
      ierr = check_nml_error (io, 'time_interp_nml')
#else
   namelist_unit = open_namelist_file()
   ierr=1
   do while (ierr /= 0)
     read(namelist_unit, nml=time_interp_nml, iostat=io, end=20)
     ierr = check_nml_error (io, 'time_interp_nml')
   enddo
   20 call close_file (namelist_unit)
#endif

   call write_version_number( version, tagname )
   logunit = stdlog()
   write(logunit,time_interp_nml)

   module_is_initialized = .TRUE.

 end subroutine time_interp_init

!#######################################################################

! <SUBROUTINE NAME="time_interp_frac" INTERFACE="time_interp">
!   <IN NAME="Time" TYPE="time_type" > </IN>
!   <OUT NAME="weight" TYPE="real"> </OUT>
! </SUBROUTINE>
!  returns the fractional time into the current year

 subroutine time_interp_frac ( Time, weight )

   type(time_type), intent(in)  :: Time 
   real           , intent(out) :: weight

   integer         :: year, month, day, hour, minute, second
   type(time_type) :: Year_beg, Year_end


   if ( .not. module_is_initialized ) call time_interp_init

!  ---- compute fractional time of year -----

     call get_date (Time, year, month, day, hour, minute, second) 

     Year_beg = set_date(year  , 1, 1) 
     Year_end = set_date(year+1, 1, 1)

     weight = (Time - Year_beg) // (Year_end - Year_beg)

 end subroutine time_interp_frac

!#######################################################################
! <SUBROUTINE NAME="fraction_of_year">
! <OVERVIEW>
!  Wrapper for backward compatibility
! </OVERVIEW>
! </SUBROUTINE>

 function fraction_of_year (Time)
 type(time_type), intent(in)  :: Time
 real :: fraction_of_year

  call time_interp_frac ( Time, fraction_of_year )

 end function fraction_of_year

!#######################################################################
! <SUBROUTINE NAME="time_interp_year" INTERFACE="time_interp">
!   <IN NAME="Time" TYPE="time_type" > </IN>
!   <OUT NAME="weight" TYPE="real"> </OUT>
!   <OUT NAME="year1" TYPE="integer"> </OUT>
!   <OUT NAME="year2" TYPE="integer"> </OUT>
! </SUBROUTINE>
!  returns fractional time between mid points of consecutive years

 subroutine time_interp_year ( Time, weight, year1, year2 )

   type(time_type), intent(in)  :: Time
   real           , intent(out) :: weight
   integer        , intent(out) :: year1, year2

   integer :: year, month, day, hour, minute, second
   type (time_type) :: Mid_year, Mid_year1, Mid_year2


   if ( .not. module_is_initialized ) call time_interp_init()

      call get_date (Time, year, month, day, hour, minute, second)

    ! mid point of current year
      Mid_year = year_midpt(year)

      if ( Time >= Mid_year ) then
    ! current time is after mid point of current year
           year1  = year
           year2  = year+1
           Mid_year2 = year_midpt(year2)
           weight = (Time - Mid_year) // (Mid_year2 - Mid_year)
      else
    ! current time is before mid point of current year
           year2  = year
           year1  = year-1
           Mid_year1 = year_midpt(year1)
           weight = (Time - Mid_year1) // (Mid_year - Mid_year1)
      endif

 end subroutine time_interp_year

!#######################################################################
! <SUBROUTINE NAME="time_interp_month" INTERFACE="time_interp">
!   <IN NAME="Time" TYPE="time_type" > </IN>
!   <OUT NAME="weight" TYPE="real"> </OUT>
!   <OUT NAME="year1" TYPE="integer"> </OUT>
!   <OUT NAME="year2" TYPE="integer"> </OUT>
!   <OUT NAME="month1" TYPE="integer"> </OUT>
!   <OUT NAME="month2" TYPE="integer"> </OUT>
! </SUBROUTINE>
!  returns fractional time between mid points of consecutive months

 subroutine time_interp_month ( Time, weight, year1, year2, month1, month2 )

   type(time_type), intent(in)  :: Time
   real           , intent(out) :: weight
   integer        , intent(out) :: year1, year2, month1, month2

   integer :: year, month, day, hour, minute, second,  &
              mid_month, cur_month, mid1, mid2

   if ( .not. module_is_initialized ) call time_interp_init()

      call get_date (Time, year, month, day, hour, minute, second)

    ! mid point of current month in seconds
      mid_month = days_in_month(Time) * halfday
    ! time into current month in seconds
      cur_month = second + secmin*minute + sechour*hour + secday*(day-1)

      if ( cur_month >= mid_month ) then
    ! current time is after mid point of current month
           year1  = year;  month1 = month
           year2  = year;  month2 = month+1
           if (month2 > monyear)  year2 = year2+1
           if (month2 > monyear) month2 = 1
           mid1 = mid_month
           mid2 = days_in_month(set_date(year2,month2,2)) * halfday
           weight = real(cur_month - mid1) / real(mid1+mid2)
      else
    ! current time is before mid point of current month
           year2  = year;  month2 = month
           year1  = year;  month1 = month-1
           if (month1 < 1)  year1 = year1-1
           if (month1 < 1) month1 = monyear
           mid1 = days_in_month(set_date(year1,month1,2)) * halfday
           mid2 = mid_month
           weight = real(cur_month + mid1) / real(mid1+mid2)
      endif

 end subroutine time_interp_month

!#######################################################################
! <SUBROUTINE NAME="time_interp_day" INTERFACE="time_interp">
!   <IN NAME="Time" TYPE="time_type" > </IN>
!   <OUT NAME="weight" TYPE="real"> </OUT>
!   <OUT NAME="year1" TYPE="integer"> </OUT>
!   <OUT NAME="year2" TYPE="integer"> </OUT>
!   <OUT NAME="month1" TYPE="integer"> </OUT>
!   <OUT NAME="month2" TYPE="integer"> </OUT>
!   <OUT NAME="day1" TYPE="integer"> </OUT>
!   <OUT NAME="day2" TYPE="integer"> </OUT>
! </SUBROUTINE>
!  returns fractional time between mid points of consecutive days

 subroutine time_interp_day ( Time, weight, year1, year2, month1, month2, day1, day2 )

   type(time_type), intent(in)  :: Time
   real           , intent(out) :: weight
   integer        , intent(out) :: year1, year2, month1, month2, day1, day2

   integer :: year, month, day, hour, minute, second, sday

   if ( .not. module_is_initialized ) call time_interp_init()

      call get_date (Time, year, month, day, hour, minute, second)

    ! time into current day in seconds
      sday = second + secmin*minute + sechour*hour

      if ( sday >= halfday ) then
    ! current time is after mid point of day
           year1 = year;  month1 = month;  day1 = day
           year2 = year;  month2 = month;  day2 = day + 1
           weight  = real(sday - halfday) / real(secday)

           if (day2 > days_in_month(Time)) then
               month2 = month2 + 1
               day2 = 1
               if (month2 > monyear) then
                    month2 = 1;  year2 = year2+1
               endif
           endif
      else
    ! current time is before mid point of day
           year2 = year;  month2 = month;  day2 = day
           year1 = year;  month1 = month;  day1 = day - 1
           weight  = real(sday + halfday) / real(secday)

           if (day1 < 1) then
               month1 = month1 - 1
               if (month1 < 1) then
                   month1 = monyear;  year1 = year1-1
               endif
               day1 = days_in_month(set_date(year1,month1,2))
           endif
      endif

 end subroutine time_interp_day

!#######################################################################
! <SUBROUTINE NAME="time_interp_modulo" INTERFACE="time_interp">
!   <IN NAME="Time" TYPE="time_type" > </IN>
!   <IN NAME="Time_beg" TYPE="time_type"> </IN>
!   <IN NAME="Time_end" TYPE="time_type"> </IN>
!   <IN NAME="Timelist" TYPE="time_type" DIM="(:)"> </IN>
!   <IN NAME="correct_leap_year_inconsistency" TYPE="logical, optional" DEFAULT=".false.">
!       Turns on a kluge for an inconsistency which may occur in a special case.
!       When the modulo time period (i.e. Time_end - Time_beg) is a whole number of years
!       and is not a multiple of 4, and the calendar in use has leap years, then it is
!       likely that the interpolation will involve mapping a common year onto a leap year.
!       In this case it is often desirable, but not absolutely necessary, to use data for
!       Feb 28 of the leap year when it is mapped onto a common year.
!       To turn this on, set correct_leap_year_inconsistency=.true. </IN>
!   <OUT NAME="weight" TYPE="real"> </OUT>
!   <OUT NAME="index1" TYPE="real"> </OUT>
!   <OUT NAME="index2" TYPE="real"> </OUT>
! </SUBROUTINE>

subroutine time_interp_modulo(Time, Time_beg, Time_end, Timelist, weight, index1, index2, &
                              correct_leap_year_inconsistency, err_msg)
type(time_type), intent(in)  :: Time, Time_beg, Time_end, Timelist(:)
real           , intent(out) :: weight
integer        , intent(out) :: index1, index2
logical, intent(in), optional :: correct_leap_year_inconsistency
character(len=*), intent(out), optional :: err_msg
  
  type(time_type) :: Period, T
  integer :: is, ie,i1,i2
  integer :: ys,ms,ds,hs,mins,ss ! components of the starting date
  integer :: ye,me,de,he,mine,se ! components of the ending date
  integer :: yt,mt,dt,ht,mint,st ! components of the current date
  integer :: dt1                 ! temporary value for day 
  integer :: n                   ! size of Timelist
  integer :: stdoutunit
  logical :: correct_lyr, calendar_has_leap_years, do_the_lyr_correction

  if ( .not. module_is_initialized ) call time_interp_init
  if( present(err_msg) ) err_msg = ''

  stdoutunit = stdout()
  n = size(Timelist)
  
  if (Time_beg>=Time_end) then
     if(fms_error_handler('time_interp_modulo', &
     'end of the specified time loop interval must be later than its beginning',err_msg)) return
  endif

  calendar_has_leap_years = (get_calendar_type() == JULIAN .or. get_calendar_type() == GREGORIAN)
  
  Period = Time_end-Time_beg ! period of the time axis

  if(present(correct_leap_year_inconsistency)) then
    correct_lyr = correct_leap_year_inconsistency
  else
    correct_lyr = .false.
  endif
  
  ! bring the requested time inside the specified time period
  T = Time

  do_the_lyr_correction = .false.

  ! Determine if the leap year correction needs to be done.
  ! It never needs to be done unless 3 conditions are met:
  ! 1) We are using a calendar with leap years
  ! 2) optional argument correct_leap_year_inconsistency is present and equals .true.
  ! 3) The modulo time period is an integer number of years
  ! If all of these are true then set do_the_lyr_correction to .true.

  if(calendar_has_leap_years .and. correct_lyr) then
    call get_date(Time_beg,ys,ms,ds,hs,mins,ss)
    call get_date(Time_end,ye,me,de,he,mine,se)
    if(ms==me.and.ds==de.and.hs==he.and.mins==mine.and.ss==se) then
      ! whole number of years
      do_the_lyr_correction = .true.
    endif
  endif

  if(do_the_lyr_correction) then
     call get_date(T,yt,mt,dt,ht,mint,st)
     yt = ys+modulo(yt-ys,ye-ys)
     dt1 = dt
     ! If it is Feb 29, but we map into a common year, use Feb 28
     if(mt==2.and.dt==29.and..not.leap_year(set_date(yt,1,1))) dt1=28
     T = set_date(yt,mt,dt1,ht,mint,st)
     if (T < Time_beg) then
       ! the requested time is within the first year, 
       ! but before the starting date. So we shift it to the last year.
       if(mt==2.and.dt==29.and..not.leap_year(set_date(ye,1,1))) dt=28
       T = set_date(ye,mt,dt,ht,mint,st)
     endif
  else
     do while ( T >= Time_end )
        T = T-Period
     enddo
     do while ( T < Time_beg )
        T = T+Period
     enddo
  endif
  
  ! find indices of the first and last records in the Timelist that are within 
  ! the requested time period.
  if (Time_end<=Timelist(1).or.Time_beg>=Timelist(n)) then
     if(get_calendar_type() == NO_CALENDAR) then
       call print_time(Time_beg,    'Time_beg'    )
       call print_time(Time_end,    'Time_end'    )
       call print_time(Timelist(1), 'Timelist(1)' )
       call print_time(Timelist(n), 'Timelist(n)' )
     else
       call print_date(Time_beg,    'Time_beg'    )
       call print_date(Time_end,    'Time_end'    )
       call print_date(Timelist(1), 'Timelist(1)' )
       call print_date(Timelist(n), 'Timelist(n)' )
     endif
     write(stdoutunit,*)'where n = size(Timelist) =',n
     if(fms_error_handler('time_interp_modulo', &
     'the entire time list is outside the specified time loop interval',err_msg)) return
  endif
  
  call bisect(Timelist,Time_beg,index1=i1,index2=i2)
  if (i1 < 1) then
     is = 1 ! Time_beg before lower boundary
  else if (Time_beg == Timelist(i1)) then
     is = i1 ! Time_beg right on the lower boundary
  else
     is = i2 ! Time_beg inside the interval or on upper boundary
  endif
  call bisect(Timelist,Time_end,index1=i1,index2=i2)
  if (Time_end > Timelist(i1)) then
    ie = i1
  else if (Time_end == Timelist(i1)) then
    if(Time_beg == Timelist(is)) then
      ! Timelist includes time levels at both the lower and upper ends of the period.
      ! The endpoints of Timelist specify the same point in the cycle.
      ! This ambiguity is resolved by ignoring the last time level.
      ie = i1-1
    else
      ie = i1
    endif
  else
!   This should never happen because bisect does not return i1 such that Time_end < Timelist(i1)
  endif
  if (is>=ie) then
     if(get_calendar_type() == NO_CALENDAR) then
       call print_time(Time_beg,    'Time_beg   =')
       call print_time(Time_end,    'Time_end   =')
       call print_time(Timelist(1), 'Timelist(1)=')
       call print_time(Timelist(n), 'Timelist(n)=')
     else
       call print_date(Time_beg,    'Time_beg   =')
       call print_date(Time_end,    'Time_end   =')
       call print_date(Timelist(1), 'Timelist(1)=')
       call print_date(Timelist(n), 'Timelist(n)=')
     endif
     write(stdoutunit,*)'where n = size(Timelist) =',n
     write(stdoutunit,*)'is =',is,'ie =',ie
     if(fms_error_handler('time_interp_modulo', &
     'error in calculation of time list bounds within the specified time loop interval',err_msg)) return
  endif
  
  ! handle special cases:
  if( T>=Timelist(ie) ) then
     ! time is after the end of the portion of the time list within the requested period
     index1 = ie;   index2 = is
     weight = (T-Timelist(ie))//(Period-(Timelist(ie)-Timelist(is)))
  else if (T<Timelist(is)) then
     ! time is before the beginning of the portion of the time list within the requested period
     index1 = ie;   index2 = is
     weight = 1.0-((Timelist(is)-T)//(Period-(Timelist(ie)-Timelist(is))))
  else
     call bisect(Timelist,T,index1,index2)
     weight = (T-Timelist(index1)) // (Timelist(index2)-Timelist(index1))
  endif

end subroutine time_interp_modulo

!#######################################################################
! given an array of times in ascending order and a specific time returns
! values of index1 and index2 such that the Timelist(index1)<=Time and
! Time<=Timelist(index2), and index2=index1+1
! index1=0, index2=1 or index=n, index2=n+1 are returned to indicate that 
! the time is out of range
subroutine bisect(Timelist,Time,index1,index2)
  type(time_type)  , intent(in)  :: Timelist(:)
  type(time_type)  , intent(in)  :: Time
  integer, optional, intent(out) :: index1, index2

  integer :: i,il,iu,n,i1,i2

  n = size(Timelist(:))
  
  if (Time==Timelist(1)) then
     i1 = 1 ; i2 = 2
  else if (Time==Timelist(n)) then
     i1 = n ; i2 = n+1
  else
     il = 0; iu=n+1
     do while(iu-il > 1)
        i = (iu+il)/2
        if(Timelist(i) > Time) then
           iu = i
        else
           il = i
        endif
     enddo
     i1 = il ; i2 = il+1
  endif

  if(PRESENT(index1)) index1 = i1
  if(PRESENT(index2)) index2 = i2
end subroutine bisect


!#######################################################################
! <SUBROUTINE NAME="time_interp_list" INTERFACE="time_interp">
!   <IN NAME="Time" TYPE="time_type" > </IN>
!   <IN NAME="Timelist" TYPE="time_type" DIM="(:)"> </IN>
!   <OUT NAME="weight" TYPE="real"> </OUT>
!   <OUT NAME="index1" TYPE="real"> </OUT>
!   <OUT NAME="index2" TYPE="real"> </OUT>
!   <IN NAME="modtime" TYPE="integer" > </IN>
! </SUBROUTINE>

subroutine time_interp_list ( Time, Timelist, weight, index1, index2, modtime, err_msg )
type(time_type)  , intent(in)  :: Time, Timelist(:)
real             , intent(out) :: weight
integer          , intent(out) :: index1, index2
integer, optional, intent(in)  :: modtime
character(len=*), intent(out), optional :: err_msg

integer :: n, hr, mn, se, mtime
type(time_type) :: T, Ts, Te, Td, Period, Time_mod

  if ( .not. module_is_initialized ) call time_interp_init

  if( present(err_msg) ) err_msg = ''

  weight = 0.; index1 = 0; index2 = 0
  n = size(Timelist(:))

! setup modular time axis?
  mtime = NONE
  if (present(modtime)) then
     mtime = modtime
     Time_mod = (Timelist(1)+Timelist(n))/2
     call get_date (Time_mod, yrmod, momod, dymod, hr, mn, se)
     mod_leapyear = leap_year(Time_mod)
  endif

! set period for modulo axis
  select case (mtime)
     case (NONE)
       ! do nothing
     case (YEAR)
         Period = set_time(0,days_in_year(Time_mod))
     case (MONTH)
       ! month length must be equal
         if (days_in_month(Time_mod) /= days_in_month(Time)) then
            if(fms_error_handler ('time_interp_list','modulo months must have same length',err_msg)) return
         endif 
         Period = set_time(0,days_in_month(Time_mod))
     case (DAY)
         Period = set_time(0,1)
     case default
         if(fms_error_handler ('time_interp_list','invalid value for argument modtime',err_msg)) return
  end select

! If modulo time is in effect and Timelist spans a time interval exactly equal to 
! the modulo period, then the endpoints of Timelist specify the same point in the cycle.
! This ambiguity is resolved by ignoring the last time level.
  if (mtime /= NONE .and. Timelist(size(Timelist))-Timelist(1) == Period) then
     n = size(Timelist) - 1
  else
     n = size(Timelist)
  endif

! starting and ending times from list
  Ts = Timelist(1)
  Te = Timelist(n)
  Td = Te-Ts
  T  = set_modtime(Time,mtime)

! Check that Timelist does not span a time interval greater than the modulo period
  if (mtime /= NONE) then
     if (Td > Period) then
        if(fms_error_handler ('time_interp_list','period of list exceeds modulo period',err_msg)) return
     endif
  endif

! time falls on start or between start and end list values
  if ( T >= Ts .and. T < Te ) then
     call bisect(Timelist(1:n),T,index1,index2)
     weight = (T-Timelist(index1)) // (Timelist(index2)-Timelist(index1))

! time falls before starting list value
  else if ( T < Ts ) then
     if (mtime == NONE) then
        if(fms_error_handler ('time_interp_list','time before range of list',err_msg)) return
     endif
     Td = Te-Ts
     weight = 1. - ((Ts-T) // (Period-Td))
     index1 = n
     index2 = 1

! time falls on ending list value
  else if ( T == Te ) then
    if(perthlike_behavior) then
       weight = 1.0
       index1 = n-1
       index2 = n
    else
       weight = 0.
       index1 = n
       if (mtime == NONE) then
         index2 = n
       else
         index2 = 1
       endif
    endif

! time falls after ending list value
  else if ( T > Te ) then
     if (mtime == NONE) then
        if(fms_error_handler ('time_interp_list','time after range of list',err_msg)) return
     endif
     Td = Te-Ts
     weight = (T-Te) // (Period-Td)
     index1 = n
     index2 = 1
  endif

end subroutine time_interp_list

!#######################################################################
!  private routines
!#######################################################################

 function year_midpt (year)

   integer, intent(in) :: year
   type (time_type)    :: year_midpt, year_beg, year_end


   year_beg = set_date(year  , 1, 1)
   year_end = set_date(year+1, 1, 1)

   year_midpt = (year_beg + year_end) / 2
   
 end function year_midpt

!#######################################################################

 function month_midpt (year, month)

   integer, intent(in) :: year, month
   type (time_type)    :: month_midpt, month_beg, month_end

!  --- beginning of this month ---
   month_beg = set_date(year, month, 1)

!  --- start of next month ---
   if (month < 12) then
      month_end = set_date(year, month+1, 1)
   else
      month_end = set_date(year+1, 1, 1)
   endif

   month_midpt = (month_beg + month_end) / 2
   
 end function month_midpt

!#######################################################################

function set_modtime (Tin, modtime) result (Tout)
type(time_type), intent(in) :: Tin
integer, intent(in), optional :: modtime
type(time_type)             :: Tout
integer :: yr, mo, dy, hr, mn, se, mtime

  if(present(modtime)) then
    mtime = modtime
  else
    mtime = NONE
  endif

  select case (mtime)
    case (NONE)
       Tout = Tin
    case (YEAR)
       call get_date (Tin, yr, mo, dy, hr, mn, se)
       yr = yrmod
        ! correct leap year dates
          if (.not.mod_leapyear .and. mo == 2 .and. dy > 28) then
             mo = 3; dy = dy-28
          endif
       Tout = set_date (yr, mo, dy, hr, mn, se)
    case (MONTH)
       call get_date (Tin, yr, mo, dy, hr, mn, se)
       yr = yrmod; mo = momod
       Tout = set_date (yr, mo, dy, hr, mn, se)
    case (DAY)
       call get_date (Tin, yr, mo, dy, hr, mn, se)
       yr = yrmod; mo = momod; dy = dymod
       Tout = set_date (yr, mo, dy, hr, mn, se)
  end select

end function set_modtime

!#######################################################################

subroutine error_handler (string)
character(len=*), intent(in) :: string

  call error_mesg ('time_interp_mod', trim(string), FATAL)

! write (*,'(a)') 'ERROR in time_interp: ' // trim(string)
! stop 111

end subroutine error_handler

!#######################################################################

end module time_interp_mod

! <INFO>

!   <ERROR MSG="input time list not ascending order" STATUS="">
!     The list of input time types must have ascending dates.
!   </ERROR> *
!   <ERROR MSG="modulo months must have same length" STATUS="">
!     The length of the current month for input Time and Time_list
!     must be the same when using the modulo month option.
!     The modulo month option is available but not supported.
!   </ERROR> *
!   <ERROR MSG="invalid value for argument modtime" STATUS="">
!     The optional argument modtime must have a value set by one
!     of the public parameters: NONE, YEAR, MONTH, DAY.
!     The MONTH and DAY options are available but not supported.
!   </ERROR> *
!   <ERROR MSG="period of list exceeds modulo period" STATUS="">
!     The difference between the last and first values in the
!     input Time list/array exceeds the length of the modulo period.
!   </ERROR> *
!   <ERROR MSG="time before range of list or time after range of list" STATUS="">
!     These errors occur when you are not using a modulo axis and the
!     input Time occurs before the first value in the Time list/array
!     or after the last value in the Time list/array.
!   </ERROR> *
!   <NOTE>
!   For all routines in this module the calendar type in module
!   time_manager must be set.
!   </NOTE>
!   <NOTE>
!     The following private parameters are set by this module:
! <PRE>
!           seconds per minute = 60
!           minutes per hour   = 60
!           hours   per day    = 24
!           months  per year   = 12
! </PRE>
!   </NOTE>

! </INFO>

#ifdef test_time_interp_
 program test_time_interp
 use          fms_mod, only: fms_init, fms_end, stdout, stdlog, FATAL, mpp_error
 use time_manager_mod, only: get_date, set_time, set_date, time_manager_init, set_calendar_type, operator(+)
 use time_manager_mod, only: JULIAN, time_type, increment_time, NOLEAP, print_date
 use  time_interp_mod, only: time_interp_init, time_interp, NONE, YEAR, MONTH, DAY

 implicit none

 integer, parameter :: num_Time=6
 type(time_type) :: Time_beg, Time_end, Time(num_Time)
 type(time_type), allocatable, dimension(:) :: Timelist
 integer :: index1, index2, mo, yr, timelist_len, outunit, ntest, nline
 real :: weight

 integer :: nmin, nmax

 namelist / test_time_interp_nml / timelist_len

 call fms_init
 outunit = stdout()
 call set_calendar_type(JULIAN)
 call time_interp_init

 Time_beg = set_date(1, 1, 1)
 Time_end = set_date(2, 1, 1)
 Time(1) = Time_beg
 Time(2) = set_date(1, 1,16)
 Time(3) = set_date(1, 2, 1)
 Time(4) = set_date(1,12, 1)
 Time(5) = set_date(1,12,16)
 Time(6) = Time_end

! Tests with modulo time
 do nline=1,3
   if(nline == 1) then
     allocate(Timelist(12))
     do mo=1,12
       Timelist(mo) = set_date(1, mo, 1)
     enddo
   else if(nline == 2) then
     allocate(Timelist(13))
     do mo=1,12
       Timelist(mo) = set_date(1, mo, 1)
     enddo
     Timelist(13) = set_date(2, 1, 1)
   else if(nline == 3) then
     allocate(Timelist(12))
     do mo=2,12
       Timelist(mo-1) = set_date(1, mo, 1)
     enddo
     Timelist(12) = set_date(2, 1, 1)
   endif

   do ntest=1,num_Time
     call diagram(nline,ntest,modulo_time=.true.)
     call time_interp(Time(ntest), Time_beg, Time_end, Timelist, weight, index1, index2)
     write(outunit,*) 'time_interp_modulo:'
     write(outunit,'()')
     call print_date(Time(ntest),                'Time       =')
     call print_date(Time_beg,                   'Time_beg   =')
     call print_date(Time_end,                   'Time_end   =')
     call print_date(Timelist(1),                'Timelist(1)=')
     call print_date(Timelist(size(Timelist(:))),'Timelist(n)=')
     write(outunit,99) index1,index2,weight
     write(outunit,'()')

     call time_interp(Time(ntest), Timelist, weight, index1, index2, modtime=YEAR)
     write(outunit,*) 'time_interp_list with modtime=YEAR:'
     write(outunit,'()')
     call print_date(Time(ntest),                'Time       =')
     call print_date(Timelist(1),                'Timelist(1)=')
     call print_date(Timelist(size(Timelist(:))),'Timelist(n)=')
     write(outunit,99) index1,index2,weight
   enddo
   deallocate(Timelist)
 enddo

! Tests without modulo time
 do nline=1,3
   if(nline == 1) then
     allocate(Timelist(12))
     do mo=1,12
       Timelist(mo) = set_date(1, mo, 1)
     enddo
   else if(nline == 2) then
     allocate(Timelist(13))
     do mo=1,12
       Timelist(mo) = set_date(1, mo, 1)
     enddo
     Timelist(13) = set_date(2, 1, 1)
   else if(nline == 3) then
     allocate(Timelist(12))
     do mo=2,12
       Timelist(mo-1) = set_date(1, mo, 1)
     enddo
     Timelist(12) = set_date(2, 1, 1)
   endif

   if(nline == 1) then
     nmin = 1; nmax = 4
   else if(nline == 2) then
     nmin = 1; nmax = num_Time
   else if(nline == 3) then
     nmin = 3; nmax = num_Time
   endif
   do ntest=nmin,nmax
     call diagram(nline,ntest,modulo_time=.false.)
     call time_interp(Time(ntest), Timelist, weight, index1, index2, modtime=NONE)
     write(outunit,*) 'time_interp_list with modtime=NONE:'
     write(outunit,'()')
     call print_date(Time(ntest),                'Time       =')
     call print_date(Timelist(1),                'Timelist(1)=')
     call print_date(Timelist(size(Timelist(:))),'Timelist(n)=')
     write(outunit,99) index1,index2,weight
   enddo
   deallocate(Timelist)
 enddo

! More tests with modulo time
 Time_beg = set_date(1999, 1, 1)
 Time_end = set_date(2000, 1, 1)
 Time(1)  = set_date(1998, 1, 1)
 Time(2)  = set_date(1998, 2,28)
 Time(3)  = set_date(1998,12,16)
 Time(4)  = set_date(2000, 1, 1)
 Time(5)  = set_date(2000, 2,28)
 Time(6)  = set_date(2000, 2,29)

 allocate(Timelist(13))
 do mo=1,12
   Timelist(mo) = set_date(1999, mo, 1)
 enddo
 Timelist(13) = set_date(2000, 1, 1)

 write(outunit,'("<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>",/)')
 write(outunit,'()')
 write(outunit,*) 'time_interp_modulo with correct_leap_year_inconsistency=.true.'
 write(outunit,'()')
 write(outunit,'(" Jan 1 1999                                     Jan 1 2000")')
 write(outunit,'("    |                                               |")')
 write(outunit,'("    v                                               v")')
 write(outunit,'("    x---x---x---x---x---x---x---x---x---x---x---x---x")')
 write(outunit,'("    ^                                               ^")')
 write(outunit,'("    |                                               |")')
 write(outunit,'(" Time_beg                                        Time_end ")')
 write(outunit,'()')

 do ntest=1,num_Time
   call time_interp(Time(ntest), Time_beg, Time_end, Timelist, weight, index1, index2, correct_leap_year_inconsistency=.true.)
   call print_date(Time(ntest),' Time =')
   write(outunit,99) index1,index2,weight
   write(outunit,'()')
 enddo
 deallocate(Timelist)

! Tests of modulo time and leap year inconsistency
 Time_beg = set_date(1978, 1, 1)
 Time_end = set_date(1981, 1, 1)
 Time(1)  = set_date(1976, 2,28)
 Time(2)  = set_date(1976, 2,29)
 Time(3)  = set_date(1976, 3, 1)
 Time(4)  = set_date(1983, 2,28)
 Time(5)  = set_date(1983, 3, 1)
 Time(6)  = set_date(1981, 1, 1)
 allocate(Timelist(37))
 do yr=1978,1980
   do mo=1,12
     Timelist(12*(yr-1978)+mo) = set_date(yr, mo, 1)
   enddo
 enddo
 Timelist(37) = set_date(1981, 1, 1)

 write(outunit,'("<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>")')
 write(outunit,'()')
 write(outunit,*) 'time_interp_modulo with correct_leap_year_inconsistency=.true.'
 write(outunit,'()')
 write(outunit,'(" Jan 1 1978              Jan 1 1979              Jan 1 1980              Jan 1 1981")')
 write(outunit,'("     |                       |                       | <---- leap year ----> |")')
 write(outunit,'("     v                       v                       v                       v")')
 write(outunit,'("     x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x")')
 write(outunit,'("     ^                                                                       ^")')
 write(outunit,'("     |                                                                       |")')
 write(outunit,'("  Time_beg                                                               Time_end")')
 write(outunit,'()')

 do ntest=1,num_Time
   call time_interp(Time(ntest), Time_beg, Time_end, Timelist, weight, index1, index2, correct_leap_year_inconsistency=.true.)
   call print_date(Time(ntest),' Time=')
   write(outunit,99) index1,index2,weight
   write(outunit,'()')
 enddo
 deallocate(Timelist)

 allocate(Timelist(12))
 Timelist( 1) = set_date(1,  1, 16, hour=12) ! Jan midmonth
 Timelist( 2) = set_date(1,  2, 15, hour= 0) ! Feb midmonth (common year)
 Timelist( 3) = set_date(1,  3, 16, hour=12) ! Mar midmonth
 Timelist( 4) = set_date(1,  4, 16, hour= 0) ! Apr midmonth
 Timelist( 5) = set_date(1,  5, 16, hour=12) ! May midmonth
 Timelist( 6) = set_date(1,  6, 16, hour= 0) ! Jun midmonth
 Timelist( 7) = set_date(1,  7, 16, hour=12) ! Jul midmonth
 Timelist( 8) = set_date(1,  8, 16, hour=12) ! Aug midmonth
 Timelist( 9) = set_date(1,  9, 16, hour= 0) ! Sep midmonth
 Timelist(10) = set_date(1, 10, 16, hour=12) ! Oct midmonth
 Timelist(11) = set_date(1, 11, 16, hour= 0) ! Nov midmonth
 Timelist(12) = set_date(1, 12, 16, hour=12) ! Dec midmonth
 Time_beg = set_date(1, 1, 1)
 Time_end = set_date(2, 1, 1)
 call diagram(nline=4, ntest=0, modulo_time=.true.)
 do ntest=0,73
   Time(1) = set_date(1996, 1, 1) + set_time(seconds=0, days=5*ntest)
   call print_date(Time(1),' Time=')
   call time_interp(Time(1), Timelist, weight, index1, index2, modtime=YEAR)
   write(outunit,89) 'time_interp_list with modtime=YEAR:   ', index1,index2,weight
   call time_interp(Time(1), Time_beg, Time_end, Timelist, weight, index1, index2, correct_leap_year_inconsistency=.true.)
   write(outunit,89) 'time_interp_modulo: ', index1,index2,weight
   write(outunit,'()')
 enddo 

 99 format(' index1=',i3,'  index2=',i3,'  weight=',f18.15)
 89 format(a20,' index1=',i3,'  index2=',i3,'  weight=',f18.15)
 call fms_end

 contains

 subroutine diagram(nline,ntest,modulo_time)
 integer, intent(in) :: nline,ntest
 logical, intent(in) :: modulo_time

 write(outunit,'("<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>")')
 write(outunit,'()')
 if(modulo_time) then
   write(outunit,'(" Time_beg                                      Time_end")')
   write(outunit,'("  |                                               |")')
   write(outunit,'("  v                                               v")')
 endif

 if(nline == 1) then
   write(outunit,'("  x---x---x---x---x---x---x---x---x---x---x---x----")')
 else if(nline == 2) then
   write(outunit,'("  x---x---x---x---x---x---x---x---x---x---x---x---x")')
 else if(nline == 3) then
   write(outunit,'("  ----x---x---x---x---x---x---x---x---x---x---x---x")')
 else if(nline == 4) then
   write(outunit,'("  --x---x---x---x---x---x---x---x---x---x---x---x--")')
 endif

 if(ntest == 1) then
   write(outunit,'("  ^")  ')
   write(outunit,'("  |")  ')
   write(outunit,'(" Time")')
 else if(ntest == 2) then
   write(outunit,'("    ^")  ')
   write(outunit,'("    |")  ')
   write(outunit,'("   Time")')
 else if(ntest == 3) then
   write(outunit,'("      ^")  ')
   write(outunit,'("      |")  ')
   write(outunit,'("     Time")')
 else if(ntest == 4) then
   write(outunit,'("                                              ^")  ')
   write(outunit,'("                                              |")  ')
   write(outunit,'("                                             Time")')
 else if(ntest == 5) then
   write(outunit,'("                                                ^")  ')
   write(outunit,'("                                                |")  ')
   write(outunit,'("                                               Time")')
 else if(ntest == 6) then
   write(outunit,'("                                                  ^")  ')
   write(outunit,'("                                                  |")  ')
   write(outunit,'("                                                 Time")')
 endif
 write(outunit,'()')

 end subroutine diagram

 end program test_time_interp
#endif

module ecmfft
 contains

      subroutine fax(ifax,n,mode)
      integer ifax(13)
      nn=n
      if (iabs(mode).eq.1) go to 10
      if (iabs(mode).eq.8) go to 10
      nn=n/2
      if ((nn+nn).eq.n) go to 10
      ifax(1)=-99
      return
   10 k=1
   20 if (mod(nn,4).ne.0) go to 30
      k=k+1
      ifax(k)=4
      nn=nn/4
      if (nn.eq.1) go to 80
      go to 20
   30 if (mod(nn,2).ne.0) go to 40
      k=k+1
      ifax(k)=2
      nn=nn/2
      if (nn.eq.1) go to 80
   40 if (mod(nn,3).ne.0) go to 50
      k=k+1
      ifax(k)=3
      nn=nn/3
      if (nn.eq.1) go to 80
      go to 40
   50 l=5
      inc=2
   60 if (mod(nn,l).ne.0) go to 70
      k=k+1
      ifax(k)=l
      nn=nn/l
      if (nn.eq.1) go to 80
      go to 60
   70 l=l+inc
      inc=6-inc
      go to 60
   80 ifax(1)=k-1
      nfax=ifax(1)
      if (nfax.eq.1) go to 110
      do 100 ii=2,nfax
      istop=nfax+2-ii
      do 90 i=2,istop
      if (ifax(i+1).ge.ifax(i)) go to 90
      item=ifax(i)
      ifax(i)=ifax(i+1)
      ifax(i+1)=item
   90 continue
  100 continue
  110 continue
      end subroutine fax

      subroutine fft99a(a,work,trigs,inc,jump,n,lot)
      real a(jump*lot),work((n+1)*lot),trigs(3*n/2+1)

      nh=n/2
      nx=n+1
      ink=inc+inc
      ia=1
      ib=n*inc+1
      ja=1
      jb=2
      do 10 l=1,lot
      work(ja)=a(ia)+a(ib)
      work(jb)=a(ia)-a(ib)
      ia=ia+jump
      ib=ib+jump
      ja=ja+nx
      jb=jb+nx
   10 continue
      iabase=2*inc+1
      ibbase=(n-2)*inc+1
      jabase=3
      jbbase=n-1
      do 30 k=3,nh,2
      ia=iabase
      ib=ibbase
      ja=jabase
      jb=jbbase
      c=trigs(n+k)
      s=trigs(n+k+1)
      do 20 l=1,lot
      work(ja)=(a(ia)+a(ib))-         &
          (s*(a(ia)-a(ib))+c*(a(ia+inc)+a(ib+inc)))
      work(jb)=(a(ia)+a(ib))+        &
          (s*(a(ia)-a(ib))+c*(a(ia+inc)+a(ib+inc)))
      work(ja+1)=(c*(a(ia)-a(ib))-s*(a(ia+inc)+a(ib+inc)))+    &
          (a(ia+inc)-a(ib+inc))
      work(jb+1)=(c*(a(ia)-a(ib))-s*(a(ia+inc)+a(ib+inc)))-    &
          (a(ia+inc)-a(ib+inc))
      ia=ia+jump
      ib=ib+jump
      ja=ja+nx
      jb=jb+nx
   20 continue
      iabase=iabase+ink
      ibbase=ibbase-ink
      jabase=jabase+2
      jbbase=jbbase-2
   30 continue
      if (iabase.ne.ibbase) go to 50
      ia=iabase
      ja=jabase
      do 40 l=1,lot
      work(ja)=2.0*a(ia)
      work(ja+1)=-2.0*a(ia+inc)
      ia=ia+jump
      ja=ja+nx
   40 continue
   50 continue
      end subroutine fft99a


      subroutine fft99b(work,a,trigs,inc,jump,n,lot)

      real work((n+1)*lot),a(jump*lot),trigs(3*n/2+1)

      nh=n/2
      nx=n+1
      ink=inc+inc
      scale=1.0/float(n)
      ia=1
      ib=2
      ja=1
      jb=n*inc+1
      do 10 l=1,lot
      a(ja)=scale*(work(ia)+work(ib))
      a(jb)=scale*(work(ia)-work(ib))
      a(ja+inc)=0.0
      a(jb+inc)=0.0
      ia=ia+nx
      ib=ib+nx
      ja=ja+jump
      jb=jb+jump
   10 continue
      scale=0.5*scale
      iabase=3
      ibbase=n-1
      jabase=2*inc+1
      jbbase=(n-2)*inc+1
      do 30 k=3,nh,2
      ia=iabase
      ib=ibbase
      ja=jabase
      jb=jbbase
      c=trigs(n+k)
      s=trigs(n+k+1)
      do 20 l=1,lot
      a(ja)=scale*((work(ia)+work(ib))         &
         +(c*(work(ia+1)+work(ib+1))+s*(work(ia)-work(ib))))
      a(jb)=scale*((work(ia)+work(ib))                  &
         -(c*(work(ia+1)+work(ib+1))+s*(work(ia)-work(ib))))
      a(ja+inc)=scale*((c*(work(ia)-work(ib))-s*(work(ia+1)+work(ib+1)))     &
          +(work(ib+1)-work(ia+1)))
      a(jb+inc)=scale*((c*(work(ia)-work(ib))-s*(work(ia+1)+work(ib+1)))        &
          -(work(ib+1)-work(ia+1)))
      ia=ia+nx
      ib=ib+nx
      ja=ja+jump
      jb=jb+jump
   20 continue
      iabase=iabase+2
      ibbase=ibbase-2
      jabase=jabase+ink
      jbbase=jbbase-ink
   30 continue
      if (iabase.ne.ibbase) go to 50
      ia=iabase
      ja=jabase
      scale=2.0*scale
      do 40 l=1,lot
      a(ja)=scale*work(ia)
      a(ja+inc)=-scale*work(ia+1)
      ia=ia+nx
      ja=ja+jump
   40 continue
   50 continue
      end subroutine fft99b


      subroutine fft99(a,work,trigs,ifax,inc,jump,n,lot,isign)

      real a(jump*lot),work((n+1)*lot),trigs(3*n/2+1)
      integer ifax(13)

      nfax=ifax(1)
      nx=n+1
      nh=n/2
      ink=inc+inc
      if (isign.eq.+1) go to 30
      igo=50
      if (mod(nfax,2).eq.1) goto 40
      ibase=inc+1
      jbase=1
      do 20 l=1,lot
      i=ibase
      j=jbase
      do 10 m=1,n
      work(j)=a(i)
      i=i+inc
      j=j+1
   10 continue
      ibase=ibase+jump
      jbase=jbase+nx
   20 continue
      igo=60
      go to 40
   30 continue
      call fft99a(a,work,trigs,inc,jump,n,lot)
      igo=60
   40 continue
      ia=inc+1
      la=1
      do 80 k=1,nfax
      if (igo.eq.60) go to 60
   50 continue
      call vpassm(a(ia),a(ia+inc),work(1),work(2),trigs,       &
         ink,2,jump,nx,lot,nh,ifax(k+1),la)
      igo=60
      go to 70
   60 continue
      call vpassm(work(1),work(2),a(ia),a(ia+inc),trigs,         &
          2,ink,nx,jump,lot,nh,ifax(k+1),la)
      igo=50
   70 continue
      la=la*ifax(k+1)
   80 continue
      if (isign.eq.-1) go to 130
      if (mod(nfax,2).eq.1) go to 110
      ibase=1
      jbase=ia
      do 100 l=1,lot
      i=ibase
      j=jbase
      do 90 m=1,n
      a(j)=work(i)
      i=i+1
      j=j+inc
   90 continue
      ibase=ibase+nx
      jbase=jbase+jump
  100 continue
  110 continue
      ia=1
      ib=n*inc+1
      do 120 l=1,lot
      a(ia)=a(ib)
      a(ib+inc)=a(ia+inc)
      ia=ia+jump
      ib=ib+jump
  120 continue
      go to 140
  130 continue
      call fft99b(work,a,trigs,inc,jump,n,lot)
  140 continue
      end subroutine fft99


      subroutine fftrig(trigs,n,mode)

      real trigs(3*n/2+1)
      pi=2.0*asin(1.0)
      imode=iabs(mode)
      nn=n
      if (imode.gt.1.and.imode.lt.6) nn=n/2
      del=(pi+pi)/float(nn)
      l=nn+nn
      do 10 i=1,l,2
      angle=0.5*float(i-1)*del
      trigs(i)=cos(angle)
      trigs(i+1)=sin(angle)
   10 continue
      if (imode.eq.1) return
      if (imode.eq.8) return
      del=0.5*del
      nh=(nn+1)/2
      l=nh+nh
      la=nn+nn
      do 20 i=1,l,2
      angle=0.5*float(i-1)*del
      trigs(la+i)=cos(angle)
      trigs(la+i+1)=sin(angle)
   20 continue
      if (imode.le.3) return
      del=0.5*del
      la=la+nn
      if (mode.eq.5) go to 40
      do 30 i=2,nn
      angle=float(i-1)*del
      trigs(la+i)=2.0*sin(angle)
   30 continue
      return
   40 continue
      del=0.5*del
      do 50 i=2,n
      angle=float(i-1)*del
      trigs(la+i)=sin(angle)
   50 continue
      end subroutine fftrig

      subroutine vpassm(a,b,c,d,trigs,inc1,inc2,inc3,inc4,lot,n,ifac,la)

      real  a(*),b(*), c(*),d(*), trigs(*)
      data sin36/0.587785252292473/,cos36/0.809016994374947/,   &
           sin72/0.951056516295154/,cos72/0.309016994374947/,   &
           sin60/0.866025403784437/
      m=n/ifac
      iink=m*inc1
      jink=la*inc2
      jump=(ifac-1)*jink
      ibase=0
      jbase=0
      igo=ifac-1
      if (igo.gt.4) return
      go to (10,50,90,130),igo
   10 ia=1
      ja=1
      ib=ia+iink
      jb=ja+jink
      do 20 l=1,la
      i=ibase
      j=jbase
      do 15 ijk=1,lot
      c(ja+j)=a(ia+i)+a(ib+i)
      d(ja+j)=b(ia+i)+b(ib+i)
      c(jb+j)=a(ia+i)-a(ib+i)
      d(jb+j)=b(ia+i)-b(ib+i)
      i=i+inc3
      j=j+inc4
   15 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
   20 continue
      if (la.eq.m) return
      la1=la+1
      jbase=jbase+jump
      do 40 k=la1,m,la
      kb=k+k-2
      c1=trigs(kb+1)
      s1=trigs(kb+2)
      do 30 l=1,la
      i=ibase
      j=jbase
      do 25 ijk=1,lot
      c(ja+j)=a(ia+i)+a(ib+i)
      d(ja+j)=b(ia+i)+b(ib+i)
      c(jb+j)=c1*(a(ia+i)-a(ib+i))-s1*(b(ia+i)-b(ib+i))
      d(jb+j)=s1*(a(ia+i)-a(ib+i))+c1*(b(ia+i)-b(ib+i))
      i=i+inc3
      j=j+inc4
   25 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
   30 continue
      jbase=jbase+jump
   40 continue
      return
   50 ia=1
      ja=1
      ib=ia+iink
      jb=ja+jink
      ic=ib+iink
      jc=jb+jink
      do 60 l=1,la
      i=ibase
      j=jbase
      do 55 ijk=1,lot
      c(ja+j)=a(ia+i)+(a(ib+i)+a(ic+i))
      d(ja+j)=b(ia+i)+(b(ib+i)+b(ic+i))
      c(jb+j)=(a(ia+i)-0.5*(a(ib+i)+a(ic+i)))-(sin60*(b(ib+i)-b(ic+i)))
      c(jc+j)=(a(ia+i)-0.5*(a(ib+i)+a(ic+i)))+(sin60*(b(ib+i)-b(ic+i)))
      d(jb+j)=(b(ia+i)-0.5*(b(ib+i)+b(ic+i)))+(sin60*(a(ib+i)-a(ic+i)))
      d(jc+j)=(b(ia+i)-0.5*(b(ib+i)+b(ic+i)))-(sin60*(a(ib+i)-a(ic+i)))
      i=i+inc3
      j=j+inc4
   55 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
   60 continue
      if (la.eq.m) return
      la1=la+1
      jbase=jbase+jump
      do 80 k=la1,m,la
      kb=k+k-2
      kc=kb+kb
      c1=trigs(kb+1)
      s1=trigs(kb+2)
      c2=trigs(kc+1)
      s2=trigs(kc+2)
      do 70 l=1,la
      i=ibase
      j=jbase
      do 65 ijk=1,lot
      c(ja+j)=a(ia+i)+(a(ib+i)+a(ic+i))
      d(ja+j)=b(ia+i)+(b(ib+i)+b(ic+i))
      c(jb+j)=  &
          c1*((a(ia+i)-0.5*(a(ib+i)+a(ic+i)))-(sin60*(b(ib+i)-b(ic+i)))) &
         -s1*((b(ia+i)-0.5*(b(ib+i)+b(ic+i)))+(sin60*(a(ib+i)-a(ic+i)))) 
      d(jb+j)=     &
          s1*((a(ia+i)-0.5*(a(ib+i)+a(ic+i)))-(sin60*(b(ib+i)-b(ic+i)))) &
         +c1*((b(ia+i)-0.5*(b(ib+i)+b(ic+i)))+(sin60*(a(ib+i)-a(ic+i))))
      c(jc+j)=     &
          c2*((a(ia+i)-0.5*(a(ib+i)+a(ic+i)))+(sin60*(b(ib+i)-b(ic+i)))) &
         -s2*((b(ia+i)-0.5*(b(ib+i)+b(ic+i)))-(sin60*(a(ib+i)-a(ic+i))))
      d(jc+j)=     &
          s2*((a(ia+i)-0.5*(a(ib+i)+a(ic+i)))+(sin60*(b(ib+i)-b(ic+i)))) &
         +c2*((b(ia+i)-0.5*(b(ib+i)+b(ic+i)))-(sin60*(a(ib+i)-a(ic+i))))
      i=i+inc3
      j=j+inc4
   65 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
   70 continue
      jbase=jbase+jump
   80 continue
      return
   90 ia=1
      ja=1
      ib=ia+iink
      jb=ja+jink
      ic=ib+iink
      jc=jb+jink
      id=ic+iink
      jd=jc+jink
      do 100 l=1,la
      i=ibase
      j=jbase
      do 95 ijk=1,lot
      c(ja+j)=(a(ia+i)+a(ic+i))+(a(ib+i)+a(id+i))
      c(jc+j)=(a(ia+i)+a(ic+i))-(a(ib+i)+a(id+i))
      d(ja+j)=(b(ia+i)+b(ic+i))+(b(ib+i)+b(id+i))
      d(jc+j)=(b(ia+i)+b(ic+i))-(b(ib+i)+b(id+i))
      c(jb+j)=(a(ia+i)-a(ic+i))-(b(ib+i)-b(id+i))
      c(jd+j)=(a(ia+i)-a(ic+i))+(b(ib+i)-b(id+i))
      d(jb+j)=(b(ia+i)-b(ic+i))+(a(ib+i)-a(id+i))
      d(jd+j)=(b(ia+i)-b(ic+i))-(a(ib+i)-a(id+i))
      i=i+inc3
      j=j+inc4
   95 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
  100 continue
      if (la.eq.m) return
      la1=la+1
      jbase=jbase+jump
      do 120 k=la1,m,la
      kb=k+k-2
      kc=kb+kb
      kd=kc+kb
      c1=trigs(kb+1)
      s1=trigs(kb+2)
      c2=trigs(kc+1)
      s2=trigs(kc+2)
      c3=trigs(kd+1)
      s3=trigs(kd+2)
      do 110 l=1,la
      i=ibase
      j=jbase
      do 105 ijk=1,lot
      c(ja+j)=(a(ia+i)+a(ic+i))+(a(ib+i)+a(id+i))
      d(ja+j)=(b(ia+i)+b(ic+i))+(b(ib+i)+b(id+i))
      c(jc+j)=        &
          c2*((a(ia+i)+a(ic+i))-(a(ib+i)+a(id+i)))   &
         -s2*((b(ia+i)+b(ic+i))-(b(ib+i)+b(id+i)))
      d(jc+j)=       &
          s2*((a(ia+i)+a(ic+i))-(a(ib+i)+a(id+i)))   &
         +c2*((b(ia+i)+b(ic+i))-(b(ib+i)+b(id+i)))
      c(jb+j)=      &
          c1*((a(ia+i)-a(ic+i))-(b(ib+i)-b(id+i)))   &
         -s1*((b(ia+i)-b(ic+i))+(a(ib+i)-a(id+i)))
      d(jb+j)=       &
          s1*((a(ia+i)-a(ic+i))-(b(ib+i)-b(id+i)))   &
         +c1*((b(ia+i)-b(ic+i))+(a(ib+i)-a(id+i)))
      c(jd+j)=       &
          c3*((a(ia+i)-a(ic+i))+(b(ib+i)-b(id+i)))    &
         -s3*((b(ia+i)-b(ic+i))-(a(ib+i)-a(id+i)))
      d(jd+j)=        &
          s3*((a(ia+i)-a(ic+i))+(b(ib+i)-b(id+i)))    &
         +c3*((b(ia+i)-b(ic+i))-(a(ib+i)-a(id+i)))
      i=i+inc3
      j=j+inc4
  105 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
  110 continue
      jbase=jbase+jump
  120 continue
      return
  130 ia=1
      ja=1
      ib=ia+iink
      jb=ja+jink
      ic=ib+iink
      jc=jb+jink
      id=ic+iink
      jd=jc+jink
      ie=id+iink
      je=jd+jink
      do 140 l=1,la
      i=ibase
      j=jbase
      do 135 ijk=1,lot
      c(ja+j)=a(ia+i)+(a(ib+i)+a(ie+i))+(a(ic+i)+a(id+i))
      d(ja+j)=b(ia+i)+(b(ib+i)+b(ie+i))+(b(ic+i)+b(id+i))
      c(jb+j)=(a(ia+i)+cos72*(a(ib+i)+a(ie+i))-cos36*(a(ic+i)+a(id+i)))     &
        -(sin72*(b(ib+i)-b(ie+i))+sin36*(b(ic+i)-b(id+i)))
      c(je+j)=(a(ia+i)+cos72*(a(ib+i)+a(ie+i))-cos36*(a(ic+i)+a(id+i)))   &
        +(sin72*(b(ib+i)-b(ie+i))+sin36*(b(ic+i)-b(id+i)))
      d(jb+j)=(b(ia+i)+cos72*(b(ib+i)+b(ie+i))-cos36*(b(ic+i)+b(id+i)))  &
        +(sin72*(a(ib+i)-a(ie+i))+sin36*(a(ic+i)-a(id+i)))
      d(je+j)=(b(ia+i)+cos72*(b(ib+i)+b(ie+i))-cos36*(b(ic+i)+b(id+i))) &
        -(sin72*(a(ib+i)-a(ie+i))+sin36*(a(ic+i)-a(id+i)))
      c(jc+j)=(a(ia+i)-cos36*(a(ib+i)+a(ie+i))+cos72*(a(ic+i)+a(id+i)))      &
        -(sin36*(b(ib+i)-b(ie+i))-sin72*(b(ic+i)-b(id+i)))
      c(jd+j)=(a(ia+i)-cos36*(a(ib+i)+a(ie+i))+cos72*(a(ic+i)+a(id+i)))       &
        +(sin36*(b(ib+i)-b(ie+i))-sin72*(b(ic+i)-b(id+i)))
      d(jc+j)=(b(ia+i)-cos36*(b(ib+i)+b(ie+i))+cos72*(b(ic+i)+b(id+i)))       &
        +(sin36*(a(ib+i)-a(ie+i))-sin72*(a(ic+i)-a(id+i)))
      d(jd+j)=(b(ia+i)-cos36*(b(ib+i)+b(ie+i))+cos72*(b(ic+i)+b(id+i)))      &
        -(sin36*(a(ib+i)-a(ie+i))-sin72*(a(ic+i)-a(id+i)))
      i=i+inc3
      j=j+inc4
  135 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
  140 continue
      if (la.eq.m) return
      la1=la+1
      jbase=jbase+jump
      do 160 k=la1,m,la
      kb=k+k-2
      kc=kb+kb
      kd=kc+kb
      ke=kd+kb
      c1=trigs(kb+1)
      s1=trigs(kb+2)
      c2=trigs(kc+1)
      s2=trigs(kc+2)
      c3=trigs(kd+1)
      s3=trigs(kd+2)
      c4=trigs(ke+1)
      s4=trigs(ke+2)
      do 150 l=1,la
      i=ibase
      j=jbase
      do 145 ijk=1,lot
      c(ja+j)=a(ia+i)+(a(ib+i)+a(ie+i))+(a(ic+i)+a(id+i))
      d(ja+j)=b(ia+i)+(b(ib+i)+b(ie+i))+(b(ic+i)+b(id+i))
      c(jb+j)=     &
          c1*((a(ia+i)+cos72*(a(ib+i)+a(ie+i))-cos36*(a(ic+i)+a(id+i))) &
            -(sin72*(b(ib+i)-b(ie+i))+sin36*(b(ic+i)-b(id+i))))       &
         -s1*((b(ia+i)+cos72*(b(ib+i)+b(ie+i))-cos36*(b(ic+i)+b(id+i))) &
            +(sin72*(a(ib+i)-a(ie+i))+sin36*(a(ic+i)-a(id+i))))
      d(jb+j)=           &
          s1*((a(ia+i)+cos72*(a(ib+i)+a(ie+i))-cos36*(a(ic+i)+a(id+i)))      &
            -(sin72*(b(ib+i)-b(ie+i))+sin36*(b(ic+i)-b(id+i))))      &
         +c1*((b(ia+i)+cos72*(b(ib+i)+b(ie+i))-cos36*(b(ic+i)+b(id+i)))      &
            +(sin72*(a(ib+i)-a(ie+i))+sin36*(a(ic+i)-a(id+i))))
      c(je+j)=       &
          c4*((a(ia+i)+cos72*(a(ib+i)+a(ie+i))-cos36*(a(ic+i)+a(id+i)))      &
            +(sin72*(b(ib+i)-b(ie+i))+sin36*(b(ic+i)-b(id+i))))             &
         -s4*((b(ia+i)+cos72*(b(ib+i)+b(ie+i))-cos36*(b(ic+i)+b(id+i)))     &
            -(sin72*(a(ib+i)-a(ie+i))+sin36*(a(ic+i)-a(id+i))))
      d(je+j)=          &
          s4*((a(ia+i)+cos72*(a(ib+i)+a(ie+i))-cos36*(a(ic+i)+a(id+i)))      &
            +(sin72*(b(ib+i)-b(ie+i))+sin36*(b(ic+i)-b(id+i))))             &
         +c4*((b(ia+i)+cos72*(b(ib+i)+b(ie+i))-cos36*(b(ic+i)+b(id+i)))      &
            -(sin72*(a(ib+i)-a(ie+i))+sin36*(a(ic+i)-a(id+i))))
      c(jc+j)=      &
          c2*((a(ia+i)-cos36*(a(ib+i)+a(ie+i))+cos72*(a(ic+i)+a(id+i)))   &
            -(sin36*(b(ib+i)-b(ie+i))-sin72*(b(ic+i)-b(id+i))))          &
         -s2*((b(ia+i)-cos36*(b(ib+i)+b(ie+i))+cos72*(b(ic+i)+b(id+i)))  &
            +(sin36*(a(ib+i)-a(ie+i))-sin72*(a(ic+i)-a(id+i))))
      d(jc+j)=           &
          s2*((a(ia+i)-cos36*(a(ib+i)+a(ie+i))+cos72*(a(ic+i)+a(id+i))) &
            -(sin36*(b(ib+i)-b(ie+i))-sin72*(b(ic+i)-b(id+i))))         &
         +c2*((b(ia+i)-cos36*(b(ib+i)+b(ie+i))+cos72*(b(ic+i)+b(id+i))) &
            +(sin36*(a(ib+i)-a(ie+i))-sin72*(a(ic+i)-a(id+i))))
      c(jd+j)=         &
          c3*((a(ia+i)-cos36*(a(ib+i)+a(ie+i))+cos72*(a(ic+i)+a(id+i)))   &
            +(sin36*(b(ib+i)-b(ie+i))-sin72*(b(ic+i)-b(id+i))))            &
         -s3*((b(ia+i)-cos36*(b(ib+i)+b(ie+i))+cos72*(b(ic+i)+b(id+i)))   &
            -(sin36*(a(ib+i)-a(ie+i))-sin72*(a(ic+i)-a(id+i))))
      d(jd+j)=            &
          s3*((a(ia+i)-cos36*(a(ib+i)+a(ie+i))+cos72*(a(ic+i)+a(id+i)))   &
            +(sin36*(b(ib+i)-b(ie+i))-sin72*(b(ic+i)-b(id+i))))       &
         +c3*((b(ia+i)-cos36*(b(ib+i)+b(ie+i))+cos72*(b(ic+i)+b(id+i)))   &
            -(sin36*(a(ib+i)-a(ie+i))-sin72*(a(ic+i)-a(id+i))))
      i=i+inc3
      j=j+inc4
  145 continue
      ibase=ibase+inc1
      jbase=jbase+inc2
  150 continue
      jbase=jbase+jump
  160 continue
      end subroutine vpassm

end module ecmfft

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The dynamic kb-equation \label{sec:kbeq}
!
! !INTERFACE:
   subroutine kbeq(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)

! !DESCRIPTION:
! The transport equation for (half the) buoyancy variance,
! $k_b=\mean{b'^2}/2$,
! follows from the equation for the buoyancy fluctations (see \cite{Sander98a}).
! In the case of a Boussinesq-fluid, this equation can
! be written as
! \begin{equation}
!   \label{kbeq}
!   \dot{k_b}
!   =
!   {\cal D}_b +  P_b - \epsilon_b
!   \comma
! \end{equation}
! where $\dot{k_b}$ denotes the material derivative of $k_b$. $P_b$ is
! the production of $k_b$ be mean density gradients,  and
! $\epsilon_b$ the rate of molecular destruction. ${\cal D}_b$ represents
! the sum of the viscous and turbulent transport terms. It is presently
! evaluated with a simple down gradient model in GOTM.
!
! The production of buoyancy variance by the vertical density gradient
! is
! \begin{equation}
!   \label{Pbvertical}
!   P_b = - \mean{w'b'} \partder{B}{z} = -\mean{w'b'} N^2
!   \point
! \end{equation}
! Its computation is discussed in \sect{sec:production}.
!
! The rate of molecular destruction, $\epsilon_b$,  can be computed
! from either a transport equation or a algebraic expression, \sect{sec:updateEpsb}.

!
! !USES:
   use turbulence,   only: Pb,epsb,nuh
   use turbulence,   only: kb,kb_min
   use turbulence,   only: k_ubc, k_lbc, ubc_type, lbc_type
   use util,         only: Dirichlet,Neumann

   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer,  intent(in)                :: nlev

!  time step (s)
   REALTYPE, intent(in)                :: dt

!  surface and bottom
!  friction velocity (m/s)
   REALTYPE, intent(in)                :: u_taus,u_taub

!  surface and bottom
!  roughness length (m)
   REALTYPE, intent(in)                :: z0s,z0b

!  layer thickness (m)
   REALTYPE, intent(in)                :: h(0:nlev)

!  square of shear and buoyancy
!  frequency (1/s^2)
   REALTYPE, intent(in)                :: NN(0:nlev),SS(0:nlev)
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf

!  $Log: kbeq.F90,v $
!  Revision 20.0  2013/12/14 00:13:45  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1  2005-06-27 10:54:33  kbk
!  new files needed
!
!
!EOP
!------------------------------------------------------------------------
!
! !LOCAL VARIABLES:
   REALTYPE                  :: DiffKbup,DiffKbdw,pos_bc
   REALTYPE                  :: prod,diss
   REALTYPE                  :: prod_pos,prod_neg
   REALTYPE                  :: cnpar=_ONE_
   REALTYPE                  :: avh(0:nlev)
   REALTYPE                  :: Lsour(0:nlev),Qsour(0:nlev)

   integer                   :: i
!
!------------------------------------------------------------------------
!BOC
!
!  compute diffusivity
   avh = nuh

   do i=1,nlev-1

!     compute production terms in k-equation
      prod     = Pb(i)
      diss     = epsb(i)

!     compute positive and negative parts of RHS
      prod_pos    =  0.5*( prod   + abs(prod  ) )
      prod_neg    = prod    - prod_pos

!     compose source terms
      Qsour(i) =   prod_pos
      Lsour(i) =  (prod_neg - diss)/kb(i)

   end do



!  position for upper BC
   if (k_ubc.eq.Neumann) then
!     flux at center "nlev"
      pos_bc = 0.5*h(nlev)
   else
!     value at face "nlev-1"
      pos_bc = h(nlev)
   end if

!  obtain BC for upper boundary of type "ubc_type"
   DiffKbup  = _ZERO_


!  position for lower BC
   if (k_lbc.eq.Neumann) then
!     flux at center "1"
      pos_bc = 0.5*h(1)
   else
!     value at face "1"
      pos_bc = h(1)
   end if

!  obtain BC for lower boundary of type "lbc_type"
   DiffKbdw  = _ZERO_


!  do diffusion step
   call diff_face(nlev,dt,cnpar,h,k_ubc,k_lbc,                          &
                  DiffKbup,DiffKbdw,avh,Lsour,Qsour,kb)


!  fill top and bottom value with something nice
!  (only for output)
   kb(nlev)  = _ZERO_
   kb(0   )  = _ZERO_

!  clip at k_min
   do i=0,nlev
      kb(i) = max(kb(i),kb_min)
   enddo

   return
   end subroutine kbeq
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module ocean_momentum_source_mod
!  
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! Internal momentum sources, such as sink from Rayleigh drag.   
!</OVERVIEW>
!
!<DESCRIPTION>
! Compute thickness weighted and density weighted tendency
! [velocity*(kg/m^3)*meter/sec] for velocity associated with 
! momentun sources in the interior.  Primary application is to 
! specify Rayleigh drag (a momentum sink).  
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies, Elements of MOM (2012)
! NOAA/Geophysical Fluid Dynamics Laboratory
! </REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_momentum_source_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  Needs to be true in order to use this scheme. Default is false.
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging.
!  </DATA> 
!  <DATA NAME="verbose_init" TYPE="logical">
!  For verbose initialization information.
!  </DATA> 
!  <DATA NAME="use_rayleigh_damp_table" TYPE="logical">
!  For reading in Rayleigh damping times from a table.
!  </DATA> 
!  <DATA NAME="rayleigh_damp_exp_from_bottom" TYPE="logical">
!  For computing a Rayleigh damping time with largest at bottom and 
!  decaying towards surface.
!  </DATA> 
!  <DATA NAME="rayleigh_damp_exp_scale" TYPE="real"  UNITS="metre">
!  Exponential decay scale from bottom upwards for computing 
!  the Rayleigh damping time. 
!  </DATA> 
!  <DATA NAME="rayleigh_damp_exp_max" TYPE="real"  UNITS="sec">
!  Damping time at the bottom for rayleigh_damp_exp_from_bottom=.true.
!  </DATA> 
!</NAMELIST>

use constants_mod,     only: epsln
use diag_manager_mod,  only: register_diag_field, register_static_field
use field_manager_mod, only: MODEL_OCEAN, parse, find_field_index
use field_manager_mod, only: get_field_methods, method_type, get_field_info
use fms_mod,           only: stdout, stdlog, FATAL, NOTE, WARNING
use fms_mod,           only: write_version_number, open_namelist_file, check_nml_error, close_file
use mpp_domains_mod,   only: mpp_update_domains 
use mpp_mod,           only: input_nml_file, mpp_error

use ocean_domains_mod,    only: get_local_indices, set_ocean_domain
use ocean_parameters_mod, only: missing_value, sec_in_day_r
use ocean_types_mod,      only: ocean_domain_type, ocean_grid_type
use ocean_types_mod,      only: ocean_thickness_type, ocean_time_type
use ocean_types_mod,      only: ocean_velocity_type, ocean_options_type
use ocean_workspace_mod,  only: wrk1_v, wrk2
use ocean_util_mod,       only: diagnose_3d_u

implicit none

private 

public ocean_momentum_source_init
public momentum_source

type(ocean_domain_type), pointer :: Dom => NULL()
type(ocean_grid_type),   pointer :: Grd => NULL()

real, dimension(:,:,:), allocatable  :: rayleigh_damp   ! inverse Rayleigh damping time (1/sec)
                                                        ! set to zero for places with no damping  

! for reading in points where wish to set a static Rayleigh drag
integer, dimension(:),   allocatable :: itable
integer, dimension(:),   allocatable :: jtable     
integer, dimension(:,:), allocatable :: ktable     
real,    dimension(:),   allocatable :: rayleigh_damp_table

! for diagnostics 
logical :: used
integer :: id_rayleigh_drag_u    =-1
integer :: id_rayleigh_drag_v    =-1
integer :: id_rayleigh_damp      =-1
integer :: id_rayleigh_damp_table=-1
integer :: id_rayleigh_drag_power=-1

character(len=128) :: version=&
       '$Id: ocean_momentum_source.F90,v 20.0 2013/12/14 00:16:02 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk 

real    :: rayleigh_damp_exp_scale_r
real    :: rayleigh_damp_exp_time_r

logical :: use_rayleigh_damp_table       =.false.                     
logical :: rayleigh_damp_exp_from_bottom =.false.
real    :: rayleigh_damp_exp_scale       =100.0
real    :: rayleigh_damp_exp_time        =8.64e5

logical :: verbose_init                  = .true.
logical :: use_this_module               = .false.
logical :: debug_this_module             = .false.
logical :: module_is_initialized         = .FALSE.

namelist /ocean_momentum_source_nml/ verbose_init, use_this_module, debug_this_module,       &
                                     use_rayleigh_damp_table, rayleigh_damp_exp_from_bottom, &
                                     rayleigh_damp_exp_scale, rayleigh_damp_exp_time

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_momentum_source_init">
!
! <DESCRIPTION>
!    Initial set up for momentum source/sink 
! </DESCRIPTION>
!
subroutine ocean_momentum_source_init(Grid, Domain, Time, Ocean_options, debug)

  type(ocean_grid_type),        intent(in), target   :: Grid
  type(ocean_domain_type),      intent(in), target   :: Domain
  type(ocean_time_type),        intent(in)           :: Time
  type(ocean_options_type),     intent(inout)        :: Ocean_options
  logical,                      intent(in), optional :: debug

  integer :: io_status, ioun, ierr

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if (module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_momentum_source_mod (ocean_momentum_source_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  nk = Grid%nk

  Dom => Domain
  Grd => Grid

  ! provide for namelist over-ride of default values
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_momentum_source_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_momentum_source_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_momentum_source_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_momentum_source_nml')
  call close_file (ioun)
#endif
  write (stdlogunit,ocean_momentum_source_nml)
  write (stdoutunit,'(/)') 
  write (stdoutunit,ocean_momentum_source_nml)

  if(use_this_module) then 
      write(stdoutunit,'(a)') '==>Note from ocean_momentum_source_mod: USING this module' 
      Ocean_options%momentum_source = 'Used momentum sources.'
  else 
      call mpp_error(NOTE, '==>Note from ocean_momentum_source_mod: NOT USING this module')
      Ocean_options%momentum_source = 'Did NOT use momentum sources.'
      return
  endif

  if (PRESENT(debug) .and. .not. debug_this_module) then
      debug_this_module = debug
  endif 
  if(debug_this_module) then 
     write(stdoutunit,'(a)') '==>Note: running ocean_momentum_source_mod with debug_this_module=.true.'  
  endif 

  allocate(rayleigh_damp(isd:ied,jsd:jed,nk))
  rayleigh_damp(:,:,:) = 0.0

  rayleigh_damp_exp_scale_r = 1.0/(epsln+rayleigh_damp_exp_scale)
  rayleigh_damp_exp_time_r  = 1.0/(epsln+rayleigh_damp_exp_time)

  ! read in static rayleigh drag damping times from a table
  call rayleigh_damp_table_init(Time)


end subroutine ocean_momentum_source_init
! </SUBROUTINE> NAME="ocean_momentum_source_init"


!#######################################################################
! <SUBROUTINE NAME="momentum_source">
!
! <DESCRIPTION>
!    Compute the momentum source/sink (N/m2).
! </DESCRIPTION>
!
subroutine momentum_source(Time, Thickness, Velocity, energy_analysis_step)

  type(ocean_time_type),       intent(in)    :: Time
  type(ocean_thickness_type),  intent(in)    :: Thickness
  type(ocean_velocity_type),   intent(inout) :: Velocity
  logical,                     intent(in)    :: energy_analysis_step 

  integer :: i,j,k,n
  integer :: tau, taum1
  integer :: kmu
  real    :: argument, rayleigh_damp_scalar

  if(.not. use_this_module) then
      if(energy_analysis_step) then 
          do n=1,2
             do k=1,nk
                do j=jsc,jec
                   do i=isc,iec
                      Velocity%wrkv(i,j,k,n) = 0.0
                   enddo
                enddo
             enddo
          enddo
      endif
    return 
  endif 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_momentum_source_mod (momentum_source): module needs to be initialized')
  endif 

  taum1 = Time%taum1
  tau   = Time%tau

  wrk1_v(:,:,:,:) = 0.0

  ! Inverse Rayleigh damping times, with largest damping near the bottom. 
  if(rayleigh_damp_exp_from_bottom) then 
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               kmu = Grd%kmu(i,j)
               if(k <= kmu) then 
                   argument = -(Thickness%depth_zu(i,j,kmu)-Thickness%depth_zu(i,j,k))*rayleigh_damp_exp_scale_r 
                   rayleigh_damp_scalar = rayleigh_damp_exp_time_r*exp(argument)
                   rayleigh_damp(i,j,k) = Grd%umask(i,j,k)*max(rayleigh_damp(i,j,k), rayleigh_damp_scalar)
               endif
            enddo
         enddo
      enddo
  endif

  ! drag from Rayleigh damping 
  do n=1,2
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              wrk1_v(i,j,k,n) = -Thickness%rho_dzu(i,j,k,taum1)*Velocity%u(i,j,k,n,taum1)*rayleigh_damp(i,j,k)
           enddo
        enddo
     enddo
  enddo

  ! energetic analysis 
  if(energy_analysis_step) then 
      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%wrkv(i,j,k,n) = wrk1_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo

  ! add to acceleration 
  else 
      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%accel(i,j,k,n) = Velocity%accel(i,j,k,n) + wrk1_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo
      call diagnose_3d_u(Time, Grd, id_rayleigh_drag_u, wrk1_v(:,:,:,1))
      call diagnose_3d_u(Time, Grd, id_rayleigh_drag_v, wrk1_v(:,:,:,2))
      if (id_rayleigh_drag_power > 0) then 
          wrk2(:,:,:) = 0.0
          do n=1,2
             do k=1,nk
                do j=jsc,jec
                   do i=isc,iec
                      wrk2(i,j,k) = wrk2(i,j,k) + Velocity%u(i,j,k,n,tau)*wrk1_v(i,j,k,n)*Grd%dau(i,j)
                   enddo
                enddo
             enddo
          enddo
          call diagnose_3d_u(Time, Grd, id_rayleigh_drag_power, wrk2(:,:,:))
      endif

  endif 


end subroutine momentum_source
! </SUBROUTINE> NAME="momentum_source"


!#######################################################################
! <SUBROUTINE NAME="rayleigh_damp_table_init">
!
! <DESCRIPTION>
! Read in static Rayleigh drag dissipation times entered to the 
! table "rayleigh_damp_table".  The dissipation times should be 
! entered in units of seconds.  
! </DESCRIPTION>
!
subroutine rayleigh_damp_table_init(Time)

  type(ocean_time_type), intent(in) :: Time
  type(method_type), allocatable, dimension(:) :: rayleigh_damp_methods

  character(len=32) :: fld_type, fld_name
  integer :: ntable, ntable_points, model, parse_ok
  integer :: itbl, jtbl, ntbl
  integer :: k

  integer :: stdoutunit 
  stdoutunit=stdout() 

  ntable = find_field_index(MODEL_OCEAN,'rayleigh_damp_table')
  if (ntable < 1) then 
    call mpp_error(NOTE, &
    '==>Warning: ocean_momentum_source_init NO table for Rayleigh damp time. Nothing read.')  
  endif
  if(ntable > 1 .and. .not. use_rayleigh_damp_table) then 
    call mpp_error(NOTE, &
    '==>Warning: ocean_momentum_source_init found rayleigh_damp_table, yet use_rayleigh_damp_table=.false.')  
  endif 
  if(ntable > 1 .and. use_rayleigh_damp_table) then 
    write(stdoutunit,*) &
    '==>Note: ocean_momentum_source_init will read Rayleigh damping coefficients from rayleigh_damp_table.'  
  endif 

  ! read in Rayleigh damping times specified from "rayleigh_damp_table"
  wrk2(:,:,:) = 0.0 
  if(use_rayleigh_damp_table .and. ntable > 1) then 

      call get_field_info(ntable,fld_type,fld_name,model,ntable_points)
      allocate(rayleigh_damp_methods(ntable_points))

      allocate (itable(ntable_points))
      itable(:) = 0
      allocate (jtable(ntable_points))
      jtable(:) = 0
      allocate (ktable(ntable_points,2))
      ktable(:,:) = 0
      allocate (rayleigh_damp_table(ntable_points))
      rayleigh_damp_table(:) = 0.0

      call get_field_methods(ntable,rayleigh_damp_methods)
      do ntbl=1,ntable_points
         parse_ok = parse(rayleigh_damp_methods(ntbl)%method_control,'itable',itable(ntbl))
         if (parse_ok == 0) call mpp_error(FATAL,&
         '==>Error ocean_momentum_source_init: rayleigh_damp_table entry "itable" error')
         parse_ok = parse(rayleigh_damp_methods(ntbl)%method_control,'jtable',jtable(ntbl))
         if (parse_ok == 0) call mpp_error(FATAL,&
         '==>Error ocean_momentum_source_init: rayleigh_damp_table entry "jtable" error')
         parse_ok = parse(rayleigh_damp_methods(ntbl)%method_control,'ktable_1',ktable(ntbl,1))
         if (parse_ok == 0) call mpp_error(FATAL,&
         '==>Error ocean_momentum_source_init: rayleigh_damp_table entry "ktable_1" error')
         parse_ok = parse(rayleigh_damp_methods(ntbl)%method_control,'ktable_2',ktable(ntbl,2))
         if (parse_ok == 0) call mpp_error(FATAL,&
         '==>Error ocean_momentum_source_init: rayleigh_damp_table entry "ktable_2" error')
         parse_ok = parse(rayleigh_damp_methods(ntbl)%method_control,'rayleigh_damp_table',rayleigh_damp_table(ntbl))
         if (parse_ok == 0) call mpp_error(FATAL,&
         '==>Error ocean_momentum_source_init: rayleigh_damp_table entry "rayleigh_damp_table" error')
         if(ktable(ntbl,2) < ktable(ntbl,1) ) then 
             call mpp_error(FATAL,&
             '==>Error ocean_momentum_source_init: rayleigh_damp_table entry needs ktable_2 >= ktable_1')
         endif
      enddo

      do ntbl=1,ntable_points

         if(on_comp_domain(ntbl)) then

             itbl=itable(ntbl)-Dom%ioff
             jtbl=jtable(ntbl)-Dom%joff

             do k=ktable(ntbl,1),ktable(ntbl,2)

                if(Grd%umask(itbl,jtbl,k) == 0.0) then 
                    write(*,'(a,i4,a,i4,a,i4,a)')                                                  &
                    '==>Warning ocean_momentum_source_init: ignored nonzero rayleigh_damp_table(', &
                    itable(ntbl),',',jtable(ntbl),',',k,') set over land. Is your table correct?'
                endif

                if(rayleigh_damp_table(ntbl) > 0.0) then 
                   wrk2(itbl,jtbl,k) = Grd%umask(itbl,jtbl,k)/rayleigh_damp_table(ntbl)
                else 
                   wrk2(itbl,jtbl,k) = 0.0
                endif  
                rayleigh_damp(itbl,jtbl,k) = rayleigh_damp(itbl,jtbl,k) + wrk2(itbl,jtbl,k)

             enddo

         endif

      enddo

  endif

  id_rayleigh_damp_table = register_static_field ('ocean_model', 'rayleigh_damp_table',            &
                           Grd%vel_axes_uv(1:3), 'Inverse Rayleigh damping time from table', '1/s',&
                           missing_value=missing_value, range=(/-1.0,1e6/))

  id_rayleigh_damp = register_static_field ('ocean_model', 'rayleigh_damp',       &
                     Grd%vel_axes_uv(1:3), 'Inverse Rayleigh damping time', '1/s',&
                     missing_value=missing_value, range=(/-1.0,1e6/))

  call diagnose_3d_u(Time, Grd, id_rayleigh_damp_table, wrk2(:,:,:))
  call diagnose_3d_u(TIme, Grd, id_rayleigh_damp, rayleigh_damp(:,:,:))

  id_rayleigh_drag_u = register_diag_field ('ocean_model', 'rayleigh_drag_u',  &
                       Grd%vel_axes_uv(1:3), Time%model_time,                  &
                       'Rayleigh drag on i-component of velocity', 'N/m2',     &
                       missing_value=missing_value, range=(/-1e6,1e6/))

  id_rayleigh_drag_v = register_diag_field ('ocean_model', 'rayleigh_drag_v',  &
                       Grd%vel_axes_uv(1:3), Time%model_time,                  &
                       'Rayleigh drag on j-component of velocity', 'N/m2',     &
                       missing_value=missing_value, range=(/-1e6,1e6/))

  id_rayleigh_drag_power = register_diag_field ('ocean_model', 'rayleigh_drag_power',  &
                       Grd%vel_axes_uv(1:3), Time%model_time,                          &
                       'Energy sink from Rayleigh drag', 'Watt',                       &
                       missing_value=missing_value, range=(/-1e16,1e16/))


end subroutine rayleigh_damp_table_init
! </SUBROUTINE> NAME="rayleigh_damp_table_init"


!#######################################################################
! <FUNCTION NAME="on_comp_domain">
!
! <DESCRIPTION>
! Determine if the point is in comp-domain for the processor.
! </DESCRIPTION>
!
! <IN NAME="nxl" TYPE="integer">
! Integer labeling the particular point in a table.
! </IN>
function on_comp_domain(ntable)

  integer, intent(in) :: ntable
  logical             :: on_comp_domain

  if(isc+Dom%ioff <= itable(ntable) .and. itable(ntable) <= iec+Dom%ioff .and. &
     jsc+Dom%joff <= jtable(ntable) .and. jtable(ntable) <= jec+Dom%joff) then
     on_comp_domain = .true.
  else 
     on_comp_domain = .false.  
  endif

end function on_comp_domain
! </FUNCTION> NAME="on_comp_domain"



end module ocean_momentum_source_mod
      
      

module ocean_lapcgrid_friction_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S. M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! This module computes the thickness weighted time tendency for  
! horizontal velocity arising from horizontal Laplacian friction. 
! Friction is formulated for the C-grid here. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes the thickness weighted time tendency for
! horizontal velocity arising from horizontal Laplacian friction. 
! The viscosity used to determine the strength of the tendency 
! can be a general function of space and time as specified by 
! the Smagorinsky approach as well as a grid-scale dependent
! background viscosity.  The form of the friction operator 
! can be isotropic or anisotropic in the horizontal plane. 
!
!
! Friction is formulated for the C-grid here. 
!
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! S.M. Griffies and R.W. Hallberg, 2000: 
! Biharmonic friction with a Smagorinsky viscosity for use in large-scale
! eddy-permitting ocean models
! Monthly Weather Review, vol. 128, pages 2935-2946
! </REFERENCE>
!
! <REFERENCE>
! R. D. Smith and J. C. McWilliams, 2003:
! Anisotropic horizontal viscosity for ocean models,
! Ocean Modelling, vol. 5, pages 129-156.
! </REFERENCE>
!
! <REFERENCE>
! Maltrud and Holloway, 2008: Implementing biharmonic neptune in a
! global eddying ocean model, Ocean Modelling, vol. 21, pages 22-34.
! </REFERENCE>
!
! <REFERENCE>
! Deremble, Hogg, Berloff, and Dewar, 2011:
! On the application of no-slip lateral boundary conditions to coarsely
! resolved ocean models, Ocean Modelling. 
! </REFERENCE>
!
! <REFERENCE>
! Griffies: Elements of MOM (2012)
! </REFERENCE>
!
! <NOTE>
! The ocean model can generally run with both Laplacian and biharmonic friction
! enabled at the same time.  Such has been found useful for some eddying 
! ocean simulations. 
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_lapcgrid_friction_nml">
!
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is false.
!  </DATA>
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging by printing checksums.  
!  </DATA> 
!
!  <DATA NAME="viscosity_scale_by_rossby" TYPE="logical">
!  To scale down the laplacian viscosity according to the relative scale of the 
!  horizontal grid and the first baroclinic Rossby radius. This is a useful 
!  scheme for models that resolve the Rossby radius in the lower latitudes, and so
!  presumably do not wish to have much laplacian friction, whereas the higher latitudes
!  need more friction.  Default viscosity_scale_by_rossby=.false.
!  </DATA> 
!
!  <DATA NAME="viscosity_scale_by_rossby_power" TYPE="real">
!  The power used to determine the viscosity scaling function. 
!  Default viscosity_scale_by_rossby_power=2.0.
!  </DATA> 
!
!  <DATA NAME="divergence_damp" TYPE="logical">
!  To damp the divergence field.  
!  </DATA> 
!  <DATA NAME="divergence_damp_vel_micom" TYPE="real" UNITS="m/s">
!  Velocity scale to set the viscosity used with divergence damping. 
!  </DATA> 
!
!  <DATA NAME="k_smag_iso" UNITS="dimensionless" TYPE="real">
!  This is the dimensionless Smagorinsky coefficient used to set the scale 
!  of the Smagorinsky isotropic viscosity. 
!  </DATA> 
!  <DATA NAME="k_smag_aniso" UNITS="dimensionless" TYPE="real">
!  This is the dimensionless Smagorinsky coefficient used to set the scale 
!  of the Smagorinsky anisotropic viscosity. 
!  </DATA> 
!
!  <DATA NAME="vel_micom_iso" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM isotropic viscosity. 
!  </DATA> 
!  <DATA NAME="vel_micom_aniso" UNITS="m/sec" TYPE="real">
!  Velocity scale that is used for computing the MICOM anisotropic viscosity. 
!  </DATA> 
!
!  <DATA NAME="equatorial_zonal" TYPE="logical">
!  Orient the anisotropic friction within a latitudinal band according to zonal direction. 
!  </DATA> 
!  <DATA NAME="equatorial_zonal_lat" TYPE="real">
!  Latitudinal band to use the zonal friction orientation. 
!  </DATA> 
!  <DATA NAME="equatorial_no_smag" TYPE="logical">
!  Turn smag off within equatorial_zonal_lat region. 
!  </DATA> 
!  <DATA NAME="eq_vel_micom_iso" TYPE="real">
!  Velocity scale that is used for computing the MICOM isotropic viscosity within
!  a user specified equatorial band. 
!  </DATA> 
!  <DATA NAME="eq_vel_micom_aniso" TYPE="real">
!  Velocity scale that is used for computing the MICOM anisotropic viscosity within
!  a user specified equatorial band. 
!  </DATA> 
!  <DATA NAME="eq_lat_micom" TYPE="real">
!  Equatorial latitude band (degrees) within which the MICOM viscosity is set according 
!  to eq_vel_micom_iso and eq_vel_micom_aniso.
!  </DATA> 
!
!  <DATA NAME="restrict_polar_visc" TYPE="logical">
!  For restricting the background viscosity poleward of a 
!  latitude.  This method may be useful for coupling to an ice model
!  in which case the horizontal viscosity may need to be a bit 
!  smaller to maintain time step constraints.  This is because the 
!  effective friction is larger than that just within the ocean.  
!  </DATA> 
!  <DATA NAME="restrict_polar_visc_lat" TYPE="real">
!  Latitude poleward of which we restrict the viscosity.
!  </DATA> 
!  <DATA NAME="restrict_polar_visc_ratio" TYPE="real">
!  Ratio of the normal critical value that we limit the 
!  viscosity to be no greater than.  If restrict_polar_visc_ratio=1.0
!  then there is no special limitation of the viscosity beyond that 
!  of the one-dimensional stability constraint.  
!  </DATA> 
!
!  <DATA NAME="neptune" TYPE="logical">
!  Set to true for computing friction relative to Neptune barotropic velocity. 
!  Default neptune=.false. 
!  </DATA> 
!  <DATA NAME="neptune_length_eq" UNITS="m" TYPE="real">
!  Length scale used to compute Neptune velocity at equator.  
!  </DATA> 
!  <DATA NAME="neptune_length_pole" UNITS="m" TYPE="real">
!  Length scale used to compute Neptune velocity at pole. 
!  </DATA> 
!  <DATA NAME="neptune_depth_min" UNITS="m" TYPE="real">
!  Minimum depth scale used for computing Neptune velocity.
!  Default neptune_depth_min=100.0
!  </DATA> 
!  <DATA NAME="neptune_smooth" TYPE="logical">
!  For doing a horizontal 1-2-1 smoothing on the diagnosed  
!  neptune velocity scale. 
!  Default neptune_smooth=.true.
!  </DATA> 
!  <DATA NAME="neptune_smooth_num" TYPE="integer">
!  Number of smoothing passes for neptune velocity.
!  Default neptune_smooth_num=1.
!  </DATA> 
!
!  <DATA NAME="use_side_drag_friction" TYPE="logical">
!  For converting friction at U-cells next to walls into 
!  a drag law, as per Deremble et al. Use cdbot_array
!  from ocean_core/ocean_bbc.F90 to compute drag force. 
!  Default use_side_drag_friction=.false.
!  </DATA> 
!  <DATA NAME="side_drag_friction_scaling" TYPE="real">
!  Dimensionless scaling used for cdbot_array when setting
!  side drag friction. So the effective side dragy coefficient
!  is side_drag_friction_scaling*cdbot_array.  
!  Default side_drag_friction_scaling=1.0.
!  </DATA> 
!  <DATA NAME="side_drag_friction_uvmag_max" UNITS="m/s" TYPE="real">
!  Maximum magnitude of horizontal velocity used to compute the 
!  side drag friction. This parameter can be useful especially
!  for pressure models where the bottom cells can be quite thin 
!  and subject to sporadic large magnitudes.  We do the same thing with 
!  bottom drag calculations. 
!  Default side_drag_friction_uvmag_max=10.0.
!  </DATA> 
!  <DATA NAME="side_drag_friction_max" UNITS="N/m^2" TYPE="real">
!  Maximum magnitude of the side drag induced friction. 
!  This parameter can be useful especially for pressure models 
!  where the bottom cells can be quite thin and subject to sporadic
!  large magnitudes.  We do the same thing with bottom drag calculations
!  in ocean_bbc. Default side_drag_friction_max=1.0.
!  </DATA> 
!
!</NAMELIST>

use constants_mod,    only: pi, radius, epsln, radian
use diag_manager_mod, only: register_diag_field, register_static_field
use fms_mod,          only: open_namelist_file, check_nml_error, write_version_number, close_file
use mpp_domains_mod,  only: mpp_update_domains, CGRID_NE, mpp_global_field
use mpp_domains_mod,  only: mpp_start_update_domains, mpp_complete_update_domains
use mpp_mod,          only: input_nml_file, mpp_sum, mpp_pe, mpp_error, mpp_max
use mpp_mod,          only: FATAL, NOTE, stdout, stdlog

use ocean_domains_mod,    only: get_local_indices
use ocean_obc_mod,        only: ocean_obc_enhance_visc_back
use ocean_operators_mod,  only: BAY, BAX, BDX_EU, BDY_NU, FDX_U, FDY_U, FMX, FMY
use ocean_operators_mod,  only: FAY, FAX, FDX_NT, FDY_ET, FDX_T, FDY_T 
use ocean_parameters_mod, only: missing_value, onehalf, omega_earth, rho0
use ocean_types_mod,      only: ocean_time_type, ocean_grid_type
use ocean_types_mod,      only: ocean_domain_type, ocean_adv_vel_type 
use ocean_types_mod,      only: ocean_thickness_type, ocean_velocity_type
use ocean_types_mod,      only: ocean_options_type
use ocean_util_mod,       only: write_timestamp, diagnose_3d, diagnose_2d_u, diagnose_3d_u, diagnose_2d, write_chksum_3d
use ocean_workspace_mod,  only: wrk1, wrk2, wrk3, wrk4
use ocean_workspace_mod,  only: wrk1_2d, wrk1_v2d  
use ocean_workspace_mod,  only: wrk1_v, wrk2_v, wrk3_v

implicit none

private

public ocean_lapcgrid_friction_init
public lapcgrid_friction
public lapcgrid_viscosity_check
public lapcgrid_reynolds_check

private compute_neptune_velocity

! length of forward time step  
real :: dtime

! for diagnostics 
integer :: id_aiso                 =-1
integer :: id_aaniso               =-1
integer :: id_aiso_smag            =-1
integer :: id_aaniso_smag          =-1
integer :: id_along_back           =-1
integer :: id_across_back          =-1
integer :: id_aiso_diverge         =-1
integer :: id_sin2theta            =-1
integer :: id_cos2theta            =-1
integer :: id_neptune_lap_u        =-1
integer :: id_neptune_lap_v        =-1
integer :: id_neptune_psi          =-1
integer :: id_along                =-1
integer :: id_across               =-1
integer :: id_visc_crit_lap        =-1
integer :: id_lap_fric_u           =-1
integer :: id_lap_fric_v           =-1
integer :: id_horz_lap_diss        =-1
integer :: id_viscosity_scaling    =-1
integer :: id_tmask_next_to_land   =-1
integer :: id_stress_xx_lap        =-1
integer :: id_stress_xy_lap        =-1
integer :: id_stress_yx_lap        =-1

logical :: used

real :: k_smag_iso            = 2.0     ! smag scaling coeff for isotropic viscosity (dimensionless) 
real :: k_smag_aniso          = 0.0     ! smag scaling coeff for anisotripic viscosity (dimensionless) 
real :: vel_micom_iso         = 0.0     ! background scaling velocity for isotropic viscosity (m/sec) 
real :: vel_micom_aniso       = 0.0     ! background scaling velocity for anisotropic viscosity (m/sec) 
real :: eq_vel_micom_iso      = 0.0     ! background scaling velocity (m/sec) within equatorial band for isotropic visc
real :: eq_vel_micom_aniso    = 0.0     ! background scaling velocity (m/sec) within equatorial band for anisotropic visc
real :: eq_lat_micom          = 0.0     ! equatorial latitude band for micom (degrees)
real :: equatorial_zonal_lat  = 0.0     ! latitudinal band for orienting the friction along zonal direction
logical :: equatorial_zonal   = .false. ! zonally orient anisotropic friction w/i equatorial_zonal_lat
logical :: equatorial_no_smag = .false. ! remove smag within equatorial_zonal_lat

! for scaling the viscosity down according to the Rossby radius 
logical :: viscosity_scale_by_rossby=.false. 
real    :: viscosity_scale_by_rossby_power=2.0

! for restricting critical viscosity in high latitudes.
! this has been found of use for coupling to ice models, where 
! the effective friction is larger than just that within the ocean.   
logical :: restrict_polar_visc=.false.  
real    :: restrict_polar_visc_lat=60.0
real    :: restrict_polar_visc_ratio=0.35

! for divergence damping 
logical  :: divergence_damp           = .false.
real     :: divergence_damp_vel_micom = 0.0
                                 
! for neptune scheme  
logical :: neptune              = .false. ! for computing friction relative to barotropic Neptune velocity
logical :: neptune_smooth       = .true.  ! for smoothing diagnosed neptune velocity
integer :: neptune_smooth_num   = 1       ! number of smoothing passes for neptune smoother 
real    :: neptune_length_eq    = 1.2e3   ! (metres)
real    :: neptune_length_pole  = 3.0e3   ! (metres)
real    :: neptune_depth_min    = 100.0   ! (metres)

! for side-boundary drag law
logical :: use_side_drag_friction       = .false.
real    :: side_drag_friction_scaling   = 1.0
real    :: side_drag_friction_max       = 1.0
real    :: side_drag_friction_uvmag_max = 10.0
real, dimension(:,:,:), allocatable :: tmask_next_to_land


#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS
real, dimension(isd:ied,jsd:jed,nk)  :: aiso_back      ! minimum allowable isotropic viscosity (m^2/s)
real, dimension(isd:ied,jsd:jed,nk)  :: aaniso_back    ! minimum allowable anisotropic viscosity (m^2/s)
real, dimension(isd:ied,jsd:jed,nk)  :: aiso_xx        ! isotropic viscosity (m^2/s) for stress_xx 
real, dimension(isd:ied,jsd:jed,nk)  :: aiso_xy        ! isotropic viscosity (m^2/s) for stress_xy 
real, dimension(isd:ied,jsd:jed,nk)  :: aaniso_xx      ! anisotropic viscosity (m^2/s) for stress_xx 
real, dimension(isd:ied,jsd:jed,nk)  :: aaniso_xy      ! anisotropic viscosity (m^2/s) for stress_xy 
real, dimension(isd:ied,jsd:jed,nk)  :: horz_ten       ! horizontal rate of deformation (1/s)
real, dimension(isd:ied,jsd:jed,nk)  :: horz_str       ! horizontal rate of strain (1/s)
real, dimension(isd:ied,jsd:jed,nk)  :: stress_xx      ! stress tensor component
real, dimension(isd:ied,jsd:jed,nk)  :: stress_xy      ! stress tensor component
real, dimension(isd:ied,jsd:jed,nk)  :: stress_yx      ! stress tensor component
real, dimension(isd:ied,jsd:jed,nk)  :: dissipate      ! diagnosed lateral dissipation from friction 
#else
real, dimension(:,:,:),  allocatable  :: aiso_back      ! minimum allowable isotropic viscosity (m^2/s)
real, dimension(:,:,:),  allocatable  :: aaniso_back    ! minimum allowable anisotropic viscosity (m^2/s)
real, dimension(:,:,:),  allocatable  :: aiso_xx        ! isotropic viscosity (m^2/s) for stress_xx 
real, dimension(:,:,:),  allocatable  :: aiso_xy        ! isotropic viscosity (m^2/s) for stress_xy 
real, dimension(:,:,:),  allocatable  :: aaniso_xx      ! anisotropic viscosity (m^2/s) for stress_xx 
real, dimension(:,:,:),  allocatable  :: aaniso_xy      ! anisotropic viscosity (m^2/s) for stress_xy 
real, dimension(:,:,:),  allocatable  :: horz_ten       ! horizontal rate of tension (1/s)
real, dimension(:,:,:),  allocatable  :: horz_str       ! horizontal rate of strain (1/s)
real, dimension(:,:,:),  allocatable  :: stress_xx      ! stress tensor component
real, dimension(:,:,:),  allocatable  :: stress_xy      ! stress tensor component
real, dimension(:,:,:),  allocatable  :: stress_yx      ! stress tensor component
real, dimension(:,:,:),  allocatable  :: dissipate      ! diagnosed lateral dissipation from friction 
#endif

real, dimension(:,:),   allocatable  :: fsmag_iso    ! (m^2) combination of terms for computing isotropic smag visc
real, dimension(:,:),   allocatable  :: fsmag_aniso  ! (m^2) combination of terms for computing anisotropic smag visc
real, dimension(:,:),   allocatable  :: aiso_diverge ! (m^2/s) viscosity for divergence damping
real, dimension(:,:),   allocatable  :: visc_crit    ! critical value of the viscosity (m^2/sec) for linear stability 
real, dimension(:,:),   allocatable  :: dxu_dyur          ! (dxu/dyu)
real, dimension(:,:),   allocatable  :: dyu_dxur          ! (dyu/dxu)
real, dimension(:,:),   allocatable  :: dxt_dytr          ! (dxt/dyt)
real, dimension(:,:),   allocatable  :: dyt_dxtr          ! (dyt/dxt)
real, dimension(:,:),   allocatable  :: grid_length       ! horizontal grid length (m)
real, dimension(:,:),   allocatable  :: viscosity_scaling ! dimensionless function of grid scale and Rossby radius
real, dimension(:,:,:), allocatable  :: neptune_velocity  ! barotropic velocity (m/s) from Neptune 

type(ocean_grid_type), pointer   :: Grd => NULL()
type(ocean_domain_type), pointer :: Dom => NULL()

character(len=256) :: version=&
     '=>Using: ocean_lapcgrid_friction.F90 ($Id: ocean_lapcgrid_friction.F90,v 20.0 2013/12/14 00:14:22 fms Exp $)'
character (len=128) :: tagname = &
     '$Name: tikal $'

logical :: use_this_module       = .false.
logical :: debug_this_module     = .false.
logical :: module_is_initialized = .FALSE.
logical :: have_obc              = .FALSE.

namelist /ocean_lapcgrid_friction_nml/ use_this_module, debug_this_module,              &
    k_smag_iso, k_smag_aniso,                                                           &
    vel_micom_iso, vel_micom_aniso, eq_vel_micom_iso, eq_vel_micom_aniso, eq_lat_micom, &
    equatorial_zonal, equatorial_zonal_lat, equatorial_no_smag,                         &
    neptune, neptune_length_eq, neptune_length_pole, neptune_depth_min,                 &
    neptune_smooth, neptune_smooth_num,                                                 &
    restrict_polar_visc, restrict_polar_visc_lat, restrict_polar_visc_ratio,            &
    divergence_damp, divergence_damp_vel_micom,                                         &
    viscosity_scale_by_rossby, viscosity_scale_by_rossby_power,                         &
    use_side_drag_friction, side_drag_friction_scaling,                                 &
    side_drag_friction_uvmag_max, side_drag_friction_max 

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_lapcgrid_friction_init">

! <DESCRIPTION>
! Initialize the horizontal Laplacian friction module by 
! registering fields for diagnostic output and performing some 
! numerical checks to see that viscosity is set appropriately.
! </DESCRIPTION>
!
subroutine ocean_lapcgrid_friction_init(Grid, Domain, Time, Ocean_options, d_time, &
                                        obc, use_lapcgrid_friction, debug)
 
  type(ocean_grid_type),    target, intent(in)    :: Grid
  type(ocean_domain_type),  target, intent(in)    :: Domain
  type(ocean_time_type),            intent(in)    :: Time
  type(ocean_options_type),         intent(inout) :: Ocean_options
  real,                             intent(in)    :: d_time
  logical,                          intent(in)    :: obc
  logical,                          intent(inout) :: use_lapcgrid_friction
  logical,                optional, intent(in)    :: debug

  integer :: ioun, io_status, ierr
  integer :: i, j, k
  real :: coeff_iso, coeff_aniso, dxdy

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lapcgrid_friction_mod (ocean_lapcgrid_friction_init): already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk = Grid%nk
#endif 

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_lapcgrid_friction_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_lapcgrid_friction_nml')
#else
  ioun = open_namelist_file()
  read (ioun,ocean_lapcgrid_friction_nml,IOSTAT=io_status)
  ierr = check_nml_error(io_status,'ocean_lapcgrid_friction_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit,ocean_lapcgrid_friction_nml)  
  write (stdlogunit,ocean_lapcgrid_friction_nml)

  if(use_this_module) then 
      call mpp_error(NOTE, '==> NOTE: USING ocean_lapcgrid_friction_mod.')
      Ocean_options%horz_lap_friction = 'Used general horizontal Laplacian friction for Cgrid.'
      use_lapcgrid_friction = .true. 
  else 
      call mpp_error(NOTE, '==> NOTE: NOT using ocean_lapcgrid_friction_mod.')
      Ocean_options%horz_lap_friction = 'Did NOT use horizontal Laplacian friction for Cgrid.'
      use_lapcgrid_friction = .false. 
      return 
  endif

  if (PRESENT(debug) .and. .not. debug_this_module) then 
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') &
    '==>Note: running ocean_lapcgrid_friction with debug_this_module=.true. so will print lots of checksums.'  
  endif 

  dtime = d_time
  write(stdoutunit,'(/a,f10.2)') &
  '==> Note from ocean_lapcgrid_friction_mod: using forward time step of (secs)', dtime 

  have_obc = obc
  if (have_obc) write(stdoutunit,'(/a,f10.2)') &
   '==> Note from ocean_lapcgrid_friction_mod: considering obc' 

  if(viscosity_scale_by_rossby) then 
    write(stdoutunit,'(1x,a)') '==> Note: Scaling the laplacian viscosity according to grid scale and Rossby radius.'
  endif 

  if(neptune) then 
    write(stdoutunit,'(1x,a)') '==> Note: Computing Laplacian friction relative to Neptune'
    write(stdoutunit,'(5x,a,e10.5)') &
    'Equatorial length (m) for computing Neptune velocity is   ',neptune_length_eq 
    write(stdoutunit,'(5x,a,e10.5)') &
    'Polar length (m) for computing Neptune velocity is        ',neptune_length_pole 
    write(stdoutunit,'(5x,a,e10.5)') &
    'Minimum depth scale (m) for computing Neptune velocity is ',neptune_depth_min
  endif 

  if(k_smag_iso > 0.0) then 
     write( stdoutunit,'(1x,a)')'==> NOTE: USING horz isotropic viscosity &
          &via Smagorinsky.'
  endif 
  if(k_smag_aniso > 0.0) then 
     write( stdoutunit,'(1x,a)')'==> NOTE: USING horz anisotropic viscosity &
          &via Smagorinsky.'
  endif      
  if(k_smag_iso==0.0)    write( stdoutunit,'(1x,a)')'==> NOTE: Setting horz &
       &isotropic Smagorinsky viscosity to zero.'
  if(k_smag_aniso==0.0)  write( stdoutunit,'(1x,a)')'==> NOTE: Setting horz &
       &anisotropic Smagorinsky viscosity to zero.'

  if(vel_micom_iso > 0.0) then 
     write( stdoutunit,'(1x,a)') &
     '==> NOTE: USING background horz isotropic viscosity via MICOM.'
  endif
  if(vel_micom_aniso > 0.0) then 
     write( stdoutunit,'(1x,a)') &
     '==> NOTE: USING background horz anisotropic viscosity via MICOM.'
  endif 
  if(vel_micom_iso==0.0)  write( stdoutunit,'(1x,a)')  '==> NOTE: USING zero &
       &background horz isotropic viscosity.'
  if(vel_micom_aniso==0.0)  write( stdoutunit,'(1x,a)')'==> NOTE: USING zero &
       &background horz anisotropic viscosity.' 
  if(eq_lat_micom > 0) write( stdoutunit,'(1x,a)')'==> NOTE: USING different &
       &background horz viscosity within equatorial zone.'

  if(k_smag_aniso > 2.0*k_smag_iso) then
    write( stdoutunit,'(1x,a)')'==> ERROR: Smag horz anisotropic visc too large. &
         &Must be less than twice Smagorinsky isotropic visc.'
  endif  
  if(vel_micom_aniso > 2.0*vel_micom_iso) then
    write( stdoutunit,'(1x,a)')'==> ERROR: Background anisotropic visc too large.&
         & Must be less than twice back isotropic visc.'
  endif  

  if(equatorial_zonal) then
    write( stdoutunit,'(/a)') &
    'If using anisotropic friction, zonally orient the friction within a latitudinal band'
    write( stdoutunit,'(a,f12.5,a)') &
    ' of width ',equatorial_zonal_lat,' degrees.'
  endif 

  if(restrict_polar_visc) then
    write( stdoutunit,'(/a,f12.5)')&
    ' Using restrict_polar_visc to lower visc_crit poleward of (deg)',restrict_polar_visc_lat
    write( stdoutunit,'(a,f12.5)')&
    ' by an amount given by the fraction ',restrict_polar_visc_ratio
    write( stdoutunit,'(a/)')&
    ' This approach is useful when coupling to ice, where effective (ocn+ice) visc > ocn visc.'
  endif 

  Grd => Grid
  Dom => Domain

#ifndef MOM_STATIC_ARRAYS
  allocate (aiso_back(isd:ied,jsd:jed,nk))
  allocate (aaniso_back(isd:ied,jsd:jed,nk))
  allocate (aiso_xx(isd:ied,jsd:jed,nk))
  allocate (aiso_xy(isd:ied,jsd:jed,nk))
  allocate (aaniso_xx(isd:ied,jsd:jed,nk))
  allocate (aaniso_xy(isd:ied,jsd:jed,nk))
  allocate (horz_ten(isd:ied,jsd:jed,nk))
  allocate (horz_str(isd:ied,jsd:jed,nk))
  allocate (stress_xx(isd:ied,jsd:jed,nk))  
  allocate (stress_xy(isd:ied,jsd:jed,nk))  
  allocate (stress_yx(isd:ied,jsd:jed,nk))  
  allocate (dissipate(isd:ied,jsd:jed,nk))  
#endif
  allocate (fsmag_iso(isd:ied,jsd:jed))
  allocate (fsmag_aniso(isd:ied,jsd:jed))
  allocate (aiso_diverge(isd:ied,jsd:jed))
  allocate (visc_crit(isd:ied,jsd:jed))
  allocate (dxu_dyur(isd:ied,jsd:jed))
  allocate (dyu_dxur(isd:ied,jsd:jed))
  allocate (dxt_dytr(isd:ied,jsd:jed))
  allocate (dyt_dxtr(isd:ied,jsd:jed))
  allocate (grid_length(isd:ied,jsd:jed))
  allocate (viscosity_scaling(isd:ied,jsd:jed))

  grid_length(:,:)       = Grd%tmask(:,:,1)*2.0*Grd%dxt(:,:)*Grd%dyt(:,:)/(epsln+Grd%dxt(:,:)+Grd%dyt(:,:))
  viscosity_scaling(:,:) = Grd%tmask(:,:,1)

  aiso_back(:,:,:)   = 0.0
  aaniso_back(:,:,:) = 0.0
  aiso_xx(:,:,:)     = 0.0
  aiso_xy(:,:,:)     = 0.0
  aaniso_xx(:,:,:)   = 0.0
  aaniso_xy(:,:,:)   = 0.0
  aiso_diverge(:,:)  = 0.0
  horz_ten(:,:,:)    = 0.0
  horz_str(:,:,:)    = 0.0
  stress_xx(:,:,:)   = 0.0
  stress_xy(:,:,:)   = 0.0
  stress_yx(:,:,:)   = 0.0
  dissipate(:,:,:)   = 0.0
  
  ! dimensionless ratios used for friction operator 
  dxu_dyur(:,:) = Grd%dxu(:,:)*Grd%dyur(:,:)
  dyu_dxur(:,:) = Grd%dyu(:,:)*Grd%dxur(:,:)
  dxt_dytr(:,:) = Grd%dxt(:,:)*Grd%dytr(:,:)
  dyt_dxtr(:,:) = Grd%dyt(:,:)*Grd%dxtr(:,:)

  ! critical value of viscosity, above which 2-dim linear stability is not satisfied
  ! visc_crit taken from equation (18.17) of Griffies book.
  visc_crit(:,:) = 0.0
  do j=jsd,jed
    do i=isd,ied
      dxdy = 1.0/( 1.0/(Grd%dxt(i,j)*Grd%dxt(i,j)) + 1.0/(Grd%dyt(i,j)*Grd%dyt(i,j)) )
      visc_crit(i,j) = 0.5*dxdy/(dtime + epsln)
    enddo
  enddo
  
  ! may need a more conservative restriction in high latitudes when coupling to ice models 
  if(restrict_polar_visc) then 
     do j=jsd,jed
       do i=isd,ied
          if (abs(Grd%yt(i,j)) > restrict_polar_visc_lat) then    
            visc_crit(i,j) = restrict_polar_visc_ratio*visc_crit(i,j)
          endif
       enddo
     enddo
  endif

  id_visc_crit_lap = register_static_field ('ocean_model', 'visc_crit_lap', &
                     Grd%tracer_axes(1:2), 'critical viscosity',            &
                     'm^2/sec',missing_value=missing_value, range=(/0.0,1.e20/))
  call diagnose_2d(Time, Grd, id_visc_crit_lap, visc_crit(:,:))

  ! compute some smag fields and parameters 

  ! f_smag = (delta s * k_smag/pi)^2 where (delta s) is for velocity cell
  fsmag_iso(:,:)   = 0.0
  fsmag_aniso(:,:) = 0.0
  coeff_iso        = (k_smag_iso/pi)**2
  coeff_aniso      = (k_smag_aniso/pi)**2
  fsmag_iso(:,:)   = coeff_iso  *((2.0*Grd%dxt(:,:)*Grd%dyt(:,:))/(epsln + Grd%dxt(:,:) + Grd%dyt(:,:)))**2
  fsmag_aniso(:,:) = coeff_aniso*((2.0*Grd%dxt(:,:)*Grd%dyt(:,:))/(epsln + Grd%dxt(:,:) + Grd%dyt(:,:)))**2

  ! remove smag within equatorial_zonal_lat band 
  if(equatorial_no_smag) then
    do j=jsd,jed
      do i=isd,ied
        if(abs(Grd%yt(i,j)) < equatorial_zonal_lat) then
          fsmag_iso(i,j)   = 0.0
          fsmag_aniso(i,j) = 0.0
        endif 
      enddo
    enddo 
  endif 

  ! compute time independent background viscosities 
  aiso_back(:,:,:)   = 0.0
  aaniso_back(:,:,:) = 0.0

  ! grid scale dependent "MICOM" background viscosities
  do j=jsd,jed
     do i=isd,ied
        aiso_back(i,j,:)   = vel_micom_iso  *(2.0*Grd%dxt(i,j)*Grd%dyt(i,j)) &
                                            /(epsln + Grd%dxt(i,j) + Grd%dyt(i,j))
        aaniso_back(i,j,:) = vel_micom_aniso*(2.0*Grd%dxt(i,j)*Grd%dyt(i,j)) &
                                            /(epsln + Grd%dxt(i,j) + Grd%dyt(i,j))
        if(abs(Grd%yt(i,j)) < eq_lat_micom) then
            aiso_back(i,j,:)   = eq_vel_micom_iso  *(2.0*Grd%dxt(i,j)*Grd%dyt(i,j)) &
                                                   /(epsln + Grd%dxt(i,j) + Grd%dyt(i,j))
            aaniso_back(i,j,:) = eq_vel_micom_aniso*(2.0*Grd%dxt(i,j)*Grd%dyt(i,j)) &
                                                   /(epsln + Grd%dxt(i,j) + Grd%dyt(i,j))
        endif
     enddo
  enddo

  ! for divergence damping 
  do j=jsd,jed
     do i=isd,ied
        aiso_diverge(i,j) = divergence_damp_vel_micom*(2.0*Grd%dxt(i,j)*Grd%dyt(i,j)) &
                            /(epsln + Grd%dxt(i,j) + Grd%dyt(i,j))
     enddo
  enddo


  ! enhance background viscosity near open boundaries if needed
  if (have_obc) call ocean_obc_enhance_visc_back(aiso_back, aaniso_back)

  ! ensure background viscosities are not too large 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           if(aiso_back(i,j,k)   > visc_crit(i,j))  aiso_back(i,j,k)   = visc_crit(i,j)
           if(aaniso_back(i,j,k) > visc_crit(i,j))  aaniso_back(i,j,k) = visc_crit(i,j)
        enddo
     enddo
  enddo

  ! ensure viscosities maintain proper relative values so friction dissipates 
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
            if(aaniso_back(i,j,k) >= 2.0*aiso_back(i,j,k) .and. aaniso_back(i,j,k) > 0.0)  then 
              write(stdoutunit,'(a,i4,a,i4,a,i3,a)') &
              'Violating lap iso/aniso constraint at (',i,',',j,',',k,')'
              aaniso_back(i,j,k) = 1.9*aiso_back(i,j,k)
            endif 
         enddo
      enddo
  enddo

  ! compute static neptune viscosity 
  call compute_neptune_velocity(Time)


  if(use_side_drag_friction) then 
     write(stdoutunit,'(a)') '==> Note from ocean_lapcgrid_friction: using side drag friction for cells next to land.'
     allocate (tmask_next_to_land(isd:ied,jsd:jed,nk))
     tmask_next_to_land(:,:,:) = 0.0
     do k=1,nk
        do j=jsc,jec
           do i=isc,iec
              tmask_next_to_land(i,j,k) = (1.0-Grd%tmask(i+1,j,k)) + (1.0-Grd%tmask(i-1,j,k)) &
                                         +(1.0-Grd%tmask(i,j+1,k)) + (1.0-Grd%tmask(i,j-1,k)) 
              tmask_next_to_land(i,j,k) = Grd%tmask(i,j,k)*min(1.0,tmask_next_to_land(i,j,k))
           enddo
        enddo
     enddo 
     id_tmask_next_to_land = register_static_field('ocean_model', 'tmask_next_to_land_lap',&
            Grd%tracer_axes(1:3),'T-cell mask for cells next to land for lapcgrid module', &
            'dimensionless', missing_value=missing_value, range=(/-10.0,10.0/))
     call diagnose_3d(Time, Grd, id_tmask_next_to_land, tmask_next_to_land(:,:,:))
  endif 


  ! send static fields to diag_manager 
  id_along_back   = register_static_field('ocean_model', 'along_lap_back',      &
                    Grd%tracer_axes(1:3),'T-cell background along-stream visc', &
                    'm^2/sec', missing_value=missing_value, range=(/-10.0,1.e10/))
  id_across_back = register_static_field('ocean_model', 'across_lap_back',      &
                   Grd%tracer_axes(1:3), 'T-cell background cross-stream visc', &
                   'm^2/sec', missing_value=missing_value, range=(/-10.0,1.e10/))

  if (id_along_back > 0) then 
     call diagnose_3d(Time, Grd, id_along_back, aiso_back(:,:,:)+0.5*aaniso_back(:,:,:))
  endif 
  if (id_across_back > 0) then 
     call diagnose_3d(Time, Grd, id_across_back, aiso_back(:,:,:)-0.5*aaniso_back(:,:,:))
  endif 

  id_aiso_diverge = register_static_field('ocean_model', 'aiso_lap_diverge', &
              Grd%tracer_axes(1:2), 'T-cell visc for divergence damping',    &
              'm^2/sec', missing_value=missing_value, range=(/-10.0,1.e10/))
  call diagnose_2d(Time, Grd, id_aiso_diverge, aiso_diverge(:,:))

  ! other viscosities for diagnostic output 

  id_aiso   = register_diag_field ('ocean_model', 'aiso_lap', Grd%tracer_axes(1:3), &
              Time%model_time, 'T-cell isotropic visc', 'm^2/sec',                  &
              missing_value=missing_value, range=(/-10.0,1.e10/),                   &
              standard_name='ocean_momentum_xy_laplacian_diffusivity')
  id_aaniso = register_diag_field ('ocean_model', 'aaniso_lap', Grd%tracer_axes(1:3), &
              Time%model_time, 'T-cell anisotropic visc', 'm^2/sec',                  &
              missing_value=missing_value, range=(/-10.0,1.e10/))
  id_aiso_smag = register_diag_field ('ocean_model', 'aiso_lap_smag', Grd%tracer_axes(1:3), &
                 Time%model_time, 'T-cell isotropic lap visc from smag', 'm^2/sec',         &
                 missing_value=missing_value, range=(/-10.0,1.e10/))
  id_aaniso_smag = register_diag_field ('ocean_model', 'aaniso_lap_smag', Grd%tracer_axes(1:3), &
                   Time%model_time, 'T-cell anisotropic lap visc from smag', 'm^2/sec',         &
                   missing_value=missing_value, range=(/-10.0,1.e10/))
  id_along  = register_diag_field ('ocean_model', 'along', Grd%tracer_axes(1:3), &
              Time%model_time, 'T-cell along-stream visc', 'm^2/sec',            &
              missing_value=missing_value, range=(/-10.0,1.e10/))
  id_across = register_diag_field ('ocean_model', 'across', Grd%tracer_axes(1:3), &
              Time%model_time, 'T-cell cross-stream visc', 'm^2/sec',             &
              missing_value=missing_value, range=(/-10.0,1.e10/))
  id_sin2theta = register_diag_field ('ocean_model', 'sin2theta_lap', Grd%tracer_axes(1:3),               &
              Time%model_time, 'sin2theta for orientation angle with laplacian friction', 'dimensionless',&
              missing_value=missing_value, range=(/-10.0,10.0/))
  id_cos2theta = register_diag_field ('ocean_model', 'cos2theta_lap', Grd%tracer_axes(1:3),               &
              Time%model_time, 'cos2theta for orientation angle with laplacian friction', 'dimensionless',&
              missing_value=missing_value, range=(/-10.0,10.0/))
 
  id_lap_fric_u = register_diag_field ('ocean_model', 'lap_fric_u', Grd%tracer_axes(1:3),              &
                  Time%model_time, 'Thick & rho wghtd horz lap frict on u-zonal','(kg/m^3)*(m^2/s^2)', &
                  missing_value=missing_value, range=(/-1.e20,1.e20/))
  id_lap_fric_v = register_diag_field ('ocean_model', 'lap_fric_v', Grd%tracer_axes(1:3), &
                  Time%model_time, 'Thick & rho wghtd horz lap frict on v-merid', '(kg/m^3)*(m^2/s^2)', &
                  missing_value=missing_value, range=(/-1.e20,1.e20/))
  id_horz_lap_diss = register_diag_field ('ocean_model', 'horz_lap_diss', Grd%tracer_axes(1:3),     &
                  Time%model_time, 'Energy dissipation from horizontal Laplacian friction', 'W/m^2',&
                  missing_value=missing_value, range=(/-1.e20,1.e20/))
  id_viscosity_scaling = register_diag_field ('ocean_model', 'viscosity_scaling', Grd%tracer_axes(1:2),  &
              Time%model_time, 'Grid/Rossby radius scaling for the laplacian viscosity', 'dimensionless',&
              missing_value=missing_value, range=(/-1.0,10.0/))
  id_stress_xx_lap = register_diag_field ('ocean_model', 'stress_xx_lap', Grd%tracer_axes(1:3),  &
                  Time%model_time, 'Stress tensor xx component from Laplacian friction', 'N/m^2',&
                  missing_value=missing_value, range=(/-1.e20,1.e20/))
  id_stress_xy_lap = register_diag_field ('ocean_model', 'stress_xy_lap', Grd%vel_axes_uv(1:3),  &
                  Time%model_time, 'Stress tensor xy component from Laplacian friction', 'N/m^2',&
                  missing_value=missing_value, range=(/-1.e20,1.e20/))
  id_stress_yx_lap = register_diag_field ('ocean_model', 'stress_yx_lap', Grd%vel_axes_uv(1:3),  &
                  Time%model_time, 'Stress tensor xy component from Laplacian friction', 'N/m^2',&
                  missing_value=missing_value, range=(/-1.e20,1.e20/))


end subroutine ocean_lapcgrid_friction_init
! </SUBROUTINE>  NAME="ocean_lapcgrid_friction_init"


!#######################################################################
! <SUBROUTINE NAME="lapcgrid_friction">
!
! <DESCRIPTION>
! This routine computes thickness weighted and density weighted 
! time tendency for horizontal velocity arising from horizontal 
! Laplacian friction.  
!
! The algorithm is derived from a functional approach that ensures
! kinetic energy is consistenty dissipated for all flow configurations. 
! The stencil is far simpler than the B-grid approach. In particular, 
! there are no triads here for the C-grid.  
! 
! Fundamental to the scheme are the rates of horizontal deformation 
! horizontal tension = DT = (dy)(u/dy)_x - (dx)(v/dx)_y             
! horizontal strain  = DS = (dx)(u/dx)_y + (dy)(v/dy)_x             
! Units of the tension and strain are sec^-1.
!
! </DESCRIPTION>
!
subroutine lapcgrid_friction(Time, Thickness, Velocity, lap_viscosity, energy_analysis_step)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(in)    :: Thickness
  type(ocean_velocity_type),  intent(inout) :: Velocity
  logical,                    intent(in)    :: energy_analysis_step
  real, dimension(isd:,jsd:), intent(inout) :: lap_viscosity

  real :: deform, delta 
  real :: usqrd, vsqrd, umagr
  real :: uvmag, umag, vmag, velocity_gamma  
  real :: term1, term2 

  integer :: i, j, k, n
  integer :: taum1, tau
  integer :: stdoutunit
  stdoutunit=stdout() 

  if(.not. use_this_module) then
      if(energy_analysis_step) then 
          do n=1,2
             do k=1,nk
                do j=jsc,jec
                   do i=isc,iec
                      Velocity%wrkv(i,j,k,n) = 0.0
                   enddo
                enddo
             enddo
          enddo
      endif
    return 
  endif 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lapcgrid_friction_mod (lapcgrid_friction): module not initialized')
  endif 

  taum1 = Time%taum1
  tau   = Time%tau

  ! to scale down the viscosity if the Rossby radius is resolved by the grid 
  if(viscosity_scale_by_rossby) then 
     do j=jsc,jec
        do i=isc,iec
           wrk1_2d(i,j) = Velocity%rossby_radius(i,j)
        enddo
     enddo
     call mpp_update_domains (wrk1_2d(:,:), Dom%domain2d)    
     do j=jsd,jed
        do i=isd,ied
           viscosity_scaling(i,j) = grid_length(i,j)**viscosity_scale_by_rossby_power &
           /(grid_length(i,j)**viscosity_scale_by_rossby_power + wrk1_2d(i,j)**viscosity_scale_by_rossby_power + epsln)
        enddo
     enddo
  else 
     do j=jsd,jed
        do i=isd,ied
           viscosity_scaling(i,j) = Grd%tmask(i,j,1)
        enddo
     enddo
  endif 

  ! store velocity relative to neptune 
  wrk1_v(:,:,:,:) = 0.0
  do k=1,nk
     do j=jsd,jed
        do i=isd,ied
           wrk1_v(i,j,k,1) = Velocity%u(i,j,k,1,taum1) - neptune_velocity(i,j,1)
           wrk1_v(i,j,k,2) = Velocity%u(i,j,k,2,taum1) - neptune_velocity(i,j,2)
        enddo
     enddo
  enddo

  ! compute the horizontal deformation rates
  ! horz_ten = (dy)(u/dy)_x - (dx)(v/dx)_y 
  !          = located at tracer points 
  ! horz_str = (dx)(u/dx)_y + (dy)(v/dy)_x
  !          = located at corner vorticity points 
  !          = zero at corner points via umask 
  horz_ten(:,:,:) = 0.0
  horz_str(:,:,:) = 0.0
  do k=1,nk
     do j=jsc,jec
        do i=isc,iec
           horz_ten(i,j,k) = dyt_dxtr(i,j)*(wrk1_v(i,j,k,1)  *Grd%dyter(i,j)  -wrk1_v(i-1,j,k,1)*Grd%dyter(i-1,j)) &
                            -dxt_dytr(i,j)*(wrk1_v(i,j,k,2)  *Grd%dxtnr(i,j)  -wrk1_v(i,j-1,k,2)*Grd%dxtnr(i,j-1))
           horz_str(i,j,k) = dxu_dyur(i,j)*(wrk1_v(i,j+1,k,1)*Grd%dxter(i,j+1)-wrk1_v(i,j,k,1)  *Grd%dxter(i,j))   &
                            +dyu_dxur(i,j)*(wrk1_v(i+1,j,k,2)*Grd%dytnr(i+1,j)-wrk1_v(i,j,k,2)  *Grd%dytnr(i,j))
           horz_ten(i,j,k) = horz_ten(i,j,k)*Grd%tmask(i,j,k) 
           horz_str(i,j,k) = horz_str(i,j,k)*Grd%umask(i,j,k) 
        enddo
     enddo
  enddo
  call mpp_update_domains (horz_ten(:,:,:), Dom%domain2d)    
  call mpp_update_domains (horz_str(:,:,:), Dom%domain2d)    


  ! compute viscosities according to Smagorinsky scheme 
  wrk1 = 0.0   ! aiso_xx_smag 
  wrk2 = 0.0   ! aiso_xy_smag   
  wrk3 = 0.0   ! aaniso_xx_smag
  wrk4 = 0.0   ! aaniso_xy_smag
  if(k_smag_iso > 0.0) then 
     do k=1,nk 
        do j=jsc,jec
           do i=isc,iec
              deform      = sqrt(horz_ten(i,j,k)**2 + horz_str(i,j,k)**2)
              wrk1(i,j,k) = fsmag_iso(i,j)*deform
              wrk3(i,j,k) = fsmag_aniso(i,j)*deform

              deform      = sqrt(horz_ten(i,j,k)**2 + horz_str(i+1,j+1,k)**2)
              wrk2(i,j,k) = fsmag_iso(i,j)*deform
              wrk4(i,j,k) = fsmag_aniso(i,j)*deform
           enddo
        enddo
     enddo
  endif 
  ! write diagnostics here since use wrk arrays, some of which are reused later 
  if(.not. energy_analysis_step) then 
     if (id_aiso_smag > 0) then
        call diagnose_3d(Time, Grd, id_aiso_smag, onehalf*(wrk1(:,:,:)+wrk2(:,:,:)))
     endif 
     if (id_aaniso_smag > 0) then
        call diagnose_3d(Time, Grd, id_aaniso_smag, onehalf*(wrk3(:,:,:)+wrk4(:,:,:)))
     endif  
  endif 

  ! compute the full viscosities 
  do k=1,nk 
     do j=jsc,jec
        do i=isc,iec
           aiso_xx(i,j,k)   = viscosity_scaling(i,j)*min(visc_crit(i,j), aiso_back(i,j,k)   + wrk1(i,j,k))
           aaniso_xx(i,j,k) = viscosity_scaling(i,j)*min(visc_crit(i,j), aaniso_back(i,j,k) + wrk3(i,j,k))
           aiso_xy(i,j,k)   = viscosity_scaling(i,j)*min(visc_crit(i,j), aiso_back(i,j,k)   + wrk2(i,j,k))
           aaniso_xy(i,j,k) = viscosity_scaling(i,j)*min(visc_crit(i,j), aaniso_back(i,j,k) + wrk4(i,j,k))
        enddo
     enddo
  enddo

  ! compute orientation angle; ignore offset of u,v 
  wrk1 = 0.0    ! sin2theta
  wrk2 = 0.0    ! cos2theta
  do k=1,nk 
     do j=jsc,jec
        do i=isc,iec
           if(equatorial_zonal .and. abs(Grd%yt(i,j)) <= equatorial_zonal_lat) then
             wrk1(i,j,k) = 0.0
             wrk2(i,j,k) = 1.0
           else
             usqrd = wrk1_v(i,j,k,1)**2
             vsqrd = wrk1_v(i,j,k,2)**2
             umagr = 1.0/(epsln + usqrd + vsqrd)
             wrk1(i,j,k) = 2.0*wrk1_v(i,j,k,1)*wrk1_v(i,j,k,2)*umagr
             wrk2(i,j,k) = (usqrd-vsqrd)*umagr
           endif
        enddo
     enddo
  enddo
  if(.not. energy_analysis_step) then 
     call diagnose_3d(Time, Grd, id_sin2theta, wrk1(:,:,:))
     call diagnose_3d(Time, Grd, id_cos2theta, wrk2(:,:,:))
  endif 


  ! compute the stress tensor components (N/m2)
  ! stress_xx(i,j) = rho*
  !   [aiso_xx(i,j)*horz_ten(i,j) + aaniso_xx(i,j)*sin2theta*0.5*(horz_str(i,j)*cos2theta - horz_ten(i,j)*sin2theta)] 
  ! stress_xy(i,j) = 0.5*rho*
  !   [aiso_xy(i,j)*horz_str(i,j) - aaniso_xy(i,j)*cos2theta*0.5*(horz_str(i,j)*cos2theta - horz_ten(i+1,j+1)*sin2theta)]
  ! set rho = rho0 even for non-Boussinesq 
  ! stress_yy = -stress_xx
  ! stress_xy =  stress_yx except for possible differences next to boundaries with partial slip 
  stress_xx(:,:,:) = 0.0
  stress_xy(:,:,:) = 0.0
  stress_yx(:,:,:) = 0.0
  
  ! umask applied to stress_xy corresponds to free-slip side boundaries 
  wrk1 = 0.0
  do k=1,nk 
     do j=jsc,jec
        do i=isc,iec

           delta = onehalf*(horz_str(i,j,k)*wrk2(i,j,k)-horz_ten(i+1,j+1,k)*wrk1(i,j,k))
           stress_xy(i,j,k) = rho0*Grd%umask(i,j,k) &
                              *(aiso_xy(i,j,k)*horz_str(i,j,k) - aaniso_xy(i,j,k)*wrk2(i,j,k)*delta)
           stress_yx(i,j,k) = stress_xy(i,j,k) 

           delta = onehalf*(horz_str(i,j,k)*wrk2(i,j,k)-horz_ten(i,j,k)*wrk1(i,j,k))
           stress_xx(i,j,k) = rho0*grd%tmask(i,j,k) &
                              *(aiso_xx(i,j,k)*horz_ten(i,j,k) + aaniso_xx(i,j,k)*wrk1(i,j,k)*delta)

           ! estimate the dissipation (W/m2) based on diagonal terms 
           wrk1(i,j,k) = -Thickness%rho_dzt(i,j,k,tau) &
                        *(aiso_xx(i,j,k)*(horz_ten(i,j,k)**2 + horz_str(i,j,k)**2) - 2.0*aaniso_xx(i,j,k)*delta**2)

        enddo
     enddo
   enddo

   ! side drag law for partial slip on stress_xy and stress_yx (N/m^2)
   wrk2_v(:,:,:,:) = 0.0
   if(use_side_drag_friction) then
      do k=1,nk    
         do j=jsc,jec
            do i=isc,iec
               uvmag            = sqrt(wrk1_v(i,j,k,1)**2 + wrk1_v(i,j,k,2)**2)
               uvmag            = min(uvmag,side_drag_friction_uvmag_max)
               velocity_gamma   = rho0*side_drag_friction_scaling*Velocity%cdbot_array(i,j)*uvmag
               umag             = abs(wrk1_v(i,j,k,1))
               vmag             = abs(wrk1_v(i,j,k,2))
               wrk2_v(i,j,k,1)  = -min(side_drag_friction_max, velocity_gamma*umag)*sign(1.0,wrk1_v(i,j,k,1))
               wrk2_v(i,j,k,2)  = -min(side_drag_friction_max, velocity_gamma*vmag)*sign(1.0,wrk1_v(i,j,k,2))
               stress_xy(i,j,k) = stress_xy(i,j,k) + wrk2_v(i,j,k,1)*tmask_next_to_land(i,j,k)   
               stress_yx(i,j,k) = stress_yx(i,j,k) + wrk2_v(i,j,k,2)*tmask_next_to_land(i,j,k)   
            enddo
         enddo
      enddo
   endif 

   ! need stress components in halos 
   call mpp_update_domains (stress_xx(:,:,:), Dom%domain2d)    
   call mpp_update_domains (stress_xy(:,:,:), Dom%domain2d)    
   call mpp_update_domains (stress_yx(:,:,:), Dom%domain2d)    


   ! acceleration from lateral friction kg/(m*s^2) = N/m^2
   ! the factor of dzt ensures proper units, and scales down friction for thin cells.  
   do k=1,nk
      do j=jsc,jec
         do i=isc,iec
            term1 = Grd%dyter(i,j)*(dyt_dxtr(i+1,j)*stress_xx(i+1,j,k)-dyt_dxtr(i,j)  *stress_xx(i,j,k))  
            term2 = Grd%dxter(i,j)*(dxu_dyur(i,j)  *stress_xy(i,j,k)  -dxu_dyur(i,j-1)*stress_xy(i,j-1,k))  
            wrk3_v(i,j,k,1) = Thickness%dzt(i,j,k)*(term1 + term2)

            term1 = -Grd%dxtnr(i,j)*(dxt_dytr(i,j+1)*stress_xx(i,j+1,k) - dxt_dytr(i,j)  *stress_xx(i,j,k))  
            term2 =  Grd%dytnr(i,j)*(dyu_dxur(i,j)  *stress_yx(i,j,k)   - dyu_dxur(i-1,j)*stress_yx(i-1,j,k))  
            wrk3_v(i,j,k,2) = Thickness%dzt(i,j,k)*(term1 + term2)
         enddo
      enddo
   enddo

   if(energy_analysis_step) then 
      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%wrkv(i,j,k,n) = wrk3_v(i,j,k,n)
               enddo
            enddo
         enddo
      enddo
      return 
   endif 

   do n=1,2
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               Velocity%accel(i,j,k,n) = Velocity%accel(i,j,k,n) + wrk3_v(i,j,k,n)
            enddo
         enddo
      enddo
   enddo

   ! vertically averaged isotropic portion of the viscosity 
   lap_viscosity(:,:) = 0.0
   wrk1_2d(:,:)       = 0.0
   do k=1,nk
      do j=jsc,jec
         do i=isc,iec
            lap_viscosity(i,j) = lap_viscosity(i,j) + Grd%tmask(i,j,k)*Thickness%rho_dzt(i,j,k,tau) &
                                                      *onehalf*(aiso_xx(i,j,k) + aiso_xy(i,j,k))
            wrk1_2d(i,j)       = wrk1_2d(i,j) + Grd%tmask(i,j,k)*Thickness%rho_dzt(i,j,k,tau)
         enddo
      enddo
   enddo
   do j=jsc,jec
      do i=isc,iec
         lap_viscosity(i,j) = Grd%tmask(i,j,1)*lap_viscosity(i,j)/(epsln+wrk1_2d(i,j))
      enddo
   enddo
   call mpp_update_domains (lap_viscosity(:,:), Dom%domain2d)    


   if (id_aiso > 0) then 
      wrk1(:,:,:) = onehalf*(aiso_xx(:,:,:)+aiso_xy(:,:,:))    
      call diagnose_3d(Time, Grd, id_aiso, wrk1(:,:,:))
   endif 
   if (id_aaniso > 0) then 
      wrk1(:,:,:) = onehalf*(aaniso_xx(:,:,:)+aaniso_xy(:,:,:))      
      call diagnose_3d(Time, Grd, id_aaniso, wrk1(:,:,:))
   endif 
   if (id_along > 0) then 
      wrk1(:,:,:) = onehalf*(aiso_xx(:,:,:)+aiso_xy(:,:,:) + onehalf*(aaniso_xx(:,:,:)+aaniso_xy(:,:,:)))
      call diagnose_3d(Time, Grd, id_along,  wrk1(:,:,:))
   endif 
   if (id_across > 0) then 
      wrk1(:,:,:) = onehalf*(aiso_xx(:,:,:)+aiso_xy(:,:,:) - onehalf*(aaniso_xx(:,:,:)+aaniso_xy(:,:,:)))
      call diagnose_3d(Time, Grd, id_across,  wrk1(:,:,:))
   endif 
   call diagnose_3d_u(Time, Grd, id_lap_fric_u, wrk3_v(:,:,:,1))
   call diagnose_3d_u(Time, Grd, id_lap_fric_v, wrk3_v(:,:,:,2))
   call diagnose_2d_u(Time, Grd, id_viscosity_scaling, viscosity_scaling(:,:))
   call diagnose_3d(Time, Grd, id_horz_lap_diss, dissipate(:,:,:))
   call diagnose_3d(Time, Grd, id_stress_xx_lap, stress_xx(:,:,:))
   call diagnose_3d_u(Time, Grd, id_stress_xy_lap, stress_xy(:,:,:))
   call diagnose_3d_u(TIme, Grd, id_stress_yx_lap, stress_yx(:,:,:))

   if(debug_this_module) then
      write(stdoutunit,*) ' ' 
      write(stdoutunit,*) 'From ocean_lapcgrid_friction_mod: friction chksums'
      call write_timestamp(Time%model_time)
      call write_chksum_3d('rho_dzu(tau)', Thickness%rho_dzu(COMP,:,tau)*Grd%umask(COMP,:))
      call write_chksum_3d('lapcgrid friction(1)', wrk1_v(COMP,:,1)*Grd%umask(COMP,:))
      call write_chksum_3d('lapcgrid friction(2)', wrk1_v(COMP,:,2)*Grd%umask(COMP,:))
   endif


end subroutine lapcgrid_friction
! </SUBROUTINE> NAME="lapcgrid_friction"



!#######################################################################
! <SUBROUTINE NAME="lapcgrid_viscosity_check">
!
! <DESCRIPTION>
! Subroutine to perform linear stability check for the Laplacian 
! operator given a value for the horizontal biharmonic viscosity.
! </DESCRIPTION>
!
subroutine lapcgrid_viscosity_check

  integer       :: num, i, j, k
  integer, save :: unit=6, max_num=3
  real :: fudge

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return 

  if (.not. module_is_initialized ) then 
    call mpp_error(FATAL,&
     '==>Error in ocean_lapcgrid_friction_mod (lapcgrid_viscosity_check): needs initialization')
  endif 

  fudge=1.001  ! to eliminate roundoffs causing aiso=visc_crit+epsln

  write (stdoutunit,'(/60x,a/)') &
  ' Excessive horizontal Laplacian friction summary:'
  write (stdoutunit,'(1x,a/)') &
  'Locations (if any) where viscosity exceeds conservative linear stability constraint'
  num = 0
  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        if (Grd%tmask(i,j,k) > 0.0) then 
          if (aiso_xx(i,j,k) > fudge*visc_crit(i,j) .and. num < max_num) then
            num = num + 1
            write (unit,9600) &
            'aiso(',aiso_xx(i,j,k), visc_crit(i,j), i, j, k, &
            Grd%xu(i,j), Grd%yu(i,j), Grd%zt(k), mpp_pe()
          endif
        endif 
      enddo
    enddo
  enddo
  call mpp_sum(num)
  if (num > max_num) write (stdoutunit,*) ' (a max of ',max_num,' violations per pe are listed)'

9600  format(/' Warning: ',a,es16.8,' m^2/s) exceeds max value (',es16.8,') at (i,j,k) = ', &
            '(',i4,',',i4,',',i4,'),',' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.0,'m, pe=',i3,')')
9601  format(/' Warning: ',a,es16.8,' m^2/s) exceeds max value (',es16.8,') at (i,j,k) = ', &
            '(',i4,',',i4,',',i4,'),',' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.0,'m, pe=',i3,')')


end subroutine lapcgrid_viscosity_check
! </SUBROUTINE> NAME="lapcgrid_viscosity_check"


!#######################################################################
! <SUBROUTINE NAME="lapcgrid_reynolds_check">
!
! <DESCRIPTION>
! Subroutine to compute the LLaplacian grid Reynolds number.  Large 
! Reynolds numbers indicate regions where solution may experience 
! some grid noise due to lack of enough horizontal friction. 
! </DESCRIPTION>
!
! <IN NAME="u" TYPE="real" DIM="(isd:ied,jsd:jed,nk,2)">
! Horizontal velocity field at time tau
! </IN>
!
subroutine lapcgrid_reynolds_check(Time, Velocity)

  type(ocean_time_type),     intent(in) :: Time
  type(ocean_velocity_type), intent(in) :: Velocity

  real :: rame, ramn, reyx, reyy
  real :: reynx0, reyny0, reynx,reyny, reynu,reynv, reynmu,reynmv
  integer :: ireynx,jreynx,kreynx, ireyny,jreyny,kreyny
  integer :: i, j, k, tau
  integer, save :: unit=6

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if(.not. use_this_module) return 

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lapcgrid_friction_mod (lapcgrid_reynolds_check): needs initialization')
  endif 

  tau = Time%tau

  ! look for max grid reynolds numbers using velocities at "tau".

  ireynx=isc; jreynx=jsc; kreynx=1; reynx=0.0
  ireyny=isc; jreyny=jsc; kreyny=1; reyny=0.0
  do k=1,nk
    do j=jsc,jec
      do i=isc,iec
        rame = 1.0/(aiso_xx(i,j,k) + epsln)
        ramn = 1.0/(aiso_xx(i,j,k) + epsln)
        reyx = abs(Velocity%u(i,j,k,1,tau)*Grd%dxu(i,j))*rame
        if (reyx > reynx) then
          ireynx = i
          jreynx = j
          kreynx = k
          reynx  = reyx
          reynu  = Velocity%u(i,j,k,1,tau)
          reynmu = 1.0/rame
        endif
        reyy = abs(Velocity%u(i,j,k,2,tau)*Grd%dyu(i,j))*ramn
        if (reyy > reyny) then
          ireyny = i
          jreyny = j
          kreyny = k
          reyny  = reyy
          reynv  = Velocity%u(i,j,k,2,tau)
          reynmv = 1.0/ramn
        endif
      enddo
    enddo
  enddo
  write (stdoutunit,'(/60x,a/)') ' Horizontal Laplacian Reynolds number summary'

  reynx0 = reynx
  reyny0 = reyny
  call mpp_max(reynx)
  call mpp_max(reyny)
  
  if (reynx == reynx0 .and. reynx > 1.e-6) then
    write (unit,10300) &
    reynx, ireynx, jreynx, kreynx, Grd%xu(ireynx,jreynx), &
    Grd%yu(ireynx,jreynx), Grd%zt(kreynx), reynu, reynmu
  endif
  
  if (reyny == reyny0 .and. reyny > 1.e-6) then
    write (unit,10400) &
    reyny, ireyny, jreyny, kreyny, Grd%xu(ireyny,jreyny), &
    Grd%yu(ireyny,jreyny), Grd%zt(kreyny), reynv, reynmv
  endif

  10300 format (1x,'Maximum zonal Re =',es9.2,' at (i,j,k) = (',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.2,'), U =',es9.2, ', mix =',e9.2)
  10400 format (1x,'Maximum merid Re =',es9.2,' at (i,j,k) = (',i4,',',i4,',',i4,'),',&
          ' (lon,lat,dpt) = (',f7.2,',',f7.2,',',f7.2,'), V =',es9.2, ', mix =',e9.2)


end subroutine lapcgrid_reynolds_check
! </SUBROUTINE> NAME="lapcgrid_reynolds_check"


!#######################################################################
! <SUBROUTINE NAME="compute_neptune_velocity">
!
! <DESCRIPTION>
! Compute Neptune velocity for c-grid.  
!
! Method follows that used in MOM2 and MOM3 as implemented by 
! Greg Holloway (zounds@ios.bc.ca) and Michael Eby (eby@uvic.ca) 
! Coded in mom4 by Stephen.Griffies 
!
! Neptune is calculated as an equilibrium streamfunction given by 
! pnep = -f*snep*snep*ht and is applied through friction whereby 
! the solution is damped towards the equilibrium streamfunction 
! rather than being damped towards zero kinetic energy. 
!
! hu    = depth of B-grid velocity corner 
! snep = spnep + (senep-spnep)*(0.5 + 0.5*cos(2.0*latitude))
!
! Neptune length scale snep has a value of senep at the
! equator and smoothly changes to spnep at the poles
!
! Reference:
! Holloway, G., 1992: Representing topographic stress for large
! scale ocean models, J. Phys. Oceanogr., 22, 1033-1046
!
! Eby and Holloway, 1994: Sensitivity of a large scale ocean model
! to a parameterization of topographic stress.  JPO, vol. 24,
! pages 2577-2588
!
! March 2012
! Stephen.Griffies 
! Algorithm updated to Eby and Holloway (1994)
!
! May 2012
! Stephen.Griffies 
! upgraded to Cgrid 
!
! </DESCRIPTION>
!
subroutine compute_neptune_velocity(Time)

  type(ocean_time_type), intent(in) :: Time
  real, dimension(isd:ied,jsd:jed)  :: neptune_psi
  real                              :: neptune_length
  real                              :: active_cells_u
  real                              :: active_cells_v
  integer                           :: i,j,k
  integer                           :: num_smooth

  if ( .not. module_is_initialized ) then 
    call mpp_error(FATAL, &
    '==>Error in ocean_lapcgrid_friction_mod (compute_neptune_velocity): needs initialization')
  endif 

  allocate (neptune_velocity(isd:ied,jsd:jed,2))
  neptune_velocity = 0.0
  if(.not. neptune) return 

  ! neptune_psi defined at U-cell point 
  do j=jsd,jed
     do i=isd,ied
        neptune_length   = neptune_length_pole  &
        + onehalf*(neptune_length_eq-neptune_length_pole)*(1.0 + cos(2.0*Grd%phiu(i,j)))
        neptune_psi(i,j) = -Grd%f(i,j)*neptune_length*neptune_length*Grd%hu(i,j)
     enddo
  enddo

  ! compute neptune velocity on C-grid 
  do j=jsc,jec
    do i=isc,iec
       neptune_velocity(i,j,1) = -(neptune_psi(i,j)-neptune_psi(i,j-1))*Grd%dyunr(i,j-1)
       neptune_velocity(i,j,2) =  (neptune_psi(i,j)-neptune_psi(i-1,j))*Grd%dxuer(i-1,j)
    enddo
  enddo
  call mpp_update_domains(neptune_velocity(:,:,1), neptune_velocity(:,:,2),&
                          Dom%domain2d,gridtype=CGRID_NE)


  ! optional smoothing
  if(neptune_smooth) then 
      do num_smooth=1,neptune_smooth_num

         wrk1_v2d(:,:,:) = 0.0
         k=1
         do j=jsc,jec
            do i=isc,iec

               if(Grd%tmask(i,j,k)==1.0) then 

                   active_cells_u = 4.0         +&
                        Grd%tmasken(i-1,j,k,1)  +&
                        Grd%tmasken(i+1,j,k,1)  +&
                        Grd%tmasken(i,j-1,k,1)  +&
                        Grd%tmasken(i,j+1,k,1)

                   active_cells_v = 4.0         +&
                        Grd%tmasken(i-1,j,k,2)  +&
                        Grd%tmasken(i+1,j,k,2)  +&
                        Grd%tmasken(i,j-1,k,2)  +&
                        Grd%tmasken(i,j+1,k,2)

                   if (active_cells_u > 4.0) then
                       wrk1_v2d(i,j,1) =                  &  
                         (4.0*neptune_velocity(i,j,1)    +&
                              neptune_velocity(i-1,j,1)  +&
                              neptune_velocity(i+1,j,1)  +&
                              neptune_velocity(i,j-1,1)  +&
                              neptune_velocity(i,j+1,1)) / active_cells_u
                   else
                       wrk1_v2d(i,j,1) = neptune_velocity(i,j,1)
                   endif 

                   if (active_cells_v > 4.0) then
                       wrk1_v2d(i,j,2) =                    &  
                         (4.0*neptune_velocity(i,j,2)      +&
                              neptune_velocity(i-1,j,2)    +&
                              neptune_velocity(i+1,j,2)    +&
                              neptune_velocity(i,j-1,2)    +&
                              neptune_velocity(i,j+1,2)) / active_cells_v
                   else
                       wrk1_v2d(i,j,2) = neptune_velocity(i,j,2)
                   endif

               endif

            enddo
         enddo

         do j=jsc,jec
            do i=isc,iec
               neptune_velocity(i,j,1) = wrk1_v2d(i,j,1)*Grd%tmasken(i,j,k,1)
               neptune_velocity(i,j,2) = wrk1_v2d(i,j,2)*Grd%tmasken(i,j,k,2)
            enddo
         enddo

         call mpp_update_domains(neptune_velocity(:,:,1), neptune_velocity(:,:,2),&
                                 Dom%domain2d,gridtype=CGRID_NE)

      enddo  ! enddo for number of smoothing iterations 
  endif      ! endif for smooth



  ! diagnostics; output onto T-cell is fine  
  id_neptune_lap_u = register_static_field('ocean_model', 'neptune_lap_u',                &
                     Grd%tracer_axes(1:2), 'Zonal velocity from neptune Laplacian scheme',&
                     'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  call diagnose_2d_u(Time, Grd, id_neptune_lap_u, neptune_velocity(:,:,1))

  id_neptune_lap_v = register_static_field('ocean_model', 'neptune_lap_v',                   &
                   Grd%tracer_axes(1:2), 'Meridional velocity from neptune Laplacian scheme',&
                   'm/sec', missing_value=missing_value, range=(/-1.e10,1.e10/))
  call diagnose_2d_u(Time, Grd, id_neptune_lap_v, neptune_velocity(:,:,2))

  id_neptune_psi   = register_static_field('ocean_model', 'neptune_psi',            &
                     Grd%vel_axes_uv(1:2), 'Transport for neptune parameterization',&
                     'm^3/sec', missing_value=missing_value, range=(/-1.e12,1.e12/))
  call diagnose_2d_u(Time, Grd, id_neptune_psi, neptune_psi(:,:))


end subroutine compute_neptune_velocity
! </SUBROUTINE> NAME="compute_neptune_velocity"

end module ocean_lapcgrid_friction_mod
      
      

module ocean_velocity_advect_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</CONTACT>
!
!<OVERVIEW>
! Velocity advective transport. 
!</OVERVIEW>
!
!<DESCRIPTION>
! This module computes advection of velocity using one of the 
! following advection schemes:
! 1/ second order centered 
! 2/ first order upwind 
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! R.C. Pacanowski and S.M. Griffies
! The MOM3 Manual (1999)
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies, M.J. Harrison, R.C. Pacanowski, and A. Rosati
! A Technical Guide to MOM4 (2004)
! </REFERENCE>
!
! <REFERENCE>
! R.C. Pacanowski and S.M. Griffies
! The MOM3 Manual (1999)
! </REFERENCE>
!
! <REFERENCE>
! S.M. Griffies: Elements of MOM (2012)
! </REFERENCE>
!
!<REFERENCE>
! Hundsdorder and Trompert (1994), "Method of lines and 
! direct discretization: a comparison for linear 
! advection", Applied Numerical Mathematics,
! pages 469--490.
!</REFERENCE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_velocity_advect_nml">
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging
!  </DATA> 
!  <DATA NAME="zero_velocity_advect_horz" TYPE="logical">
!  For debugging, it is often useful to remove horizontal advection of velocity. 
!  </DATA> 
!  <DATA NAME="zero_velocity_advect_vert" TYPE="logical">
!  For debugging, it is often useful to remove vertical advection of velocity. 
!  </DATA> 
!
!  <DATA NAME="velocity_advect_centered" TYPE="logical">
!  For using the standard second order centered method for 
!  computing the advection of linear momentum. This is the 
!  default: velocity_advect_centered=.true.
!  </DATA> 
!  <DATA NAME="velocity_advect_upwind" TYPE="logical">
!  For using the first order upwind method for 
!  computing the advection of linear momentum. 
!  Default: velocity_advect_upwind=.false.
!  </DATA> 
!
!</NAMELIST>

use diag_manager_mod, only: register_diag_field
use fms_mod,          only: mpp_error, FATAL, NOTE, stdout, stdlog, write_version_number
use fms_mod,          only: read_data, open_namelist_file, check_nml_error, close_file
use mpp_mod,          only: input_nml_file

use ocean_domains_mod,    only: get_local_indices
use ocean_obc_mod,        only: ocean_obc_update_boundary, ocean_obc_zero_boundary
use ocean_operators_mod,  only: FAX, FAY, BDX_EU, BDY_NU, REMAP_BT_TO_BU
use ocean_parameters_mod, only: missing_value, onefourth
use ocean_parameters_mod, only: MOM_BGRID, MOM_CGRID
use ocean_parameters_mod, only: VEL_ADVECT_UPWIND, VEL_ADVECT_2ND_ORDER
use ocean_types_mod,      only: ocean_grid_type, ocean_domain_type
use ocean_types_mod,      only: ocean_velocity_type, ocean_adv_vel_type
use ocean_types_mod,      only: ocean_time_type, ocean_thickness_type
use ocean_workspace_mod,  only: wrk1_v, wrk1_2d, wrk2_2d   
use ocean_util_mod,       only: write_timestamp, diagnose_2d_u, diagnose_3d_u, diagnose_3d_en, write_chksum_3d

implicit none

private

! for Bgrid or Cgrid
integer :: horz_grid

public horz_advection_of_velocity
public vert_advection_of_velocity
public ocean_velocity_advect_init

private horz_advection_centered
private vert_advection_centered
private horz_advection_upwind
private vert_advection_upwind 


! for diagnostics 
logical :: used 
integer :: id_hadv_u=-1
integer :: id_hadv_v=-1
integer :: id_vadv_u=-1
integer :: id_vadv_v=-1
integer :: id_surf_accel(2)=-1
integer :: id_pme_u  =-1
integer :: id_river_u=-1

#include <ocean_memory.h>

#ifdef MOM_STATIC_ARRAYS
real, dimension(isd:ied,jsd:jed)  :: tmp, tmp1, tmp2
#else
real, dimension(:,:), allocatable :: tmp, tmp1, tmp2
#endif

real, dimension(:),   allocatable :: kmask

type(ocean_grid_type), pointer   :: Grd =>NULL()
type(ocean_domain_type), pointer :: Dom =>NULL()

character(len=128) :: version=&
  '$Id: ocean_velocity_advect.F90,v 20.0 2013/12/14 00:12:43 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

integer :: advection_scheme           = 2
logical :: module_is_initialized      = .false.
logical :: debug_this_module          = .false.
logical :: zero_velocity_advect_horz  = .false. 
logical :: zero_velocity_advect_vert  = .false. 
logical :: have_obc                   = .false.
logical :: velocity_advect_centered   = .true.
logical :: velocity_advect_upwind     = .false.

namelist /ocean_velocity_advect_nml/ debug_this_module,         &
          zero_velocity_advect_horz, zero_velocity_advect_vert, &
          velocity_advect_centered, velocity_advect_upwind 

contains

!#######################################################################
! <SUBROUTINE NAME="ocean_velocity_advect_init">
!
! <DESCRIPTION>
! Initialize the velocity advection module.
! </DESCRIPTION>
!
subroutine ocean_velocity_advect_init(Grid, Domain, Time, obc, hor_grid, debug)

  type(ocean_grid_type),   intent(in), target   :: Grid
  type(ocean_domain_type), intent(in), target   :: Domain
  type(ocean_time_type),   intent(in), target   :: Time
  logical,                 intent(in)           :: obc
  integer,                 intent(in)           :: hor_grid
  logical,                 intent(in), optional :: debug

  integer :: ioun, io_status, ierr
  integer :: num_methods=0 

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
    call mpp_error(FATAL,&
    '==>Error from ocean_velocity_advect_mod (ocean_velocity_advect_init): module already initialized')
  endif 

  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  Grd => Grid
  Dom => Domain
  horz_grid = hor_grid
  have_obc  = obc

  ! provide for namelist over-ride
#ifdef INTERNAL_FILE_NML
  read (input_nml_file, nml=ocean_velocity_advect_nml, iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_velocity_advect_nml')
#else
  ioun = open_namelist_file()
  read  (ioun, ocean_velocity_advect_nml,iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_velocity_advect_nml')
  call close_file (ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit, ocean_velocity_advect_nml)  
  write (stdlogunit, ocean_velocity_advect_nml)

  if (PRESENT(debug) .and. .not. debug_this_module) then
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') '==>Note: running ocean_velocity_advect with debug_this_module=.true.'  
  endif 
  
#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain, isd, ied, jsd, jed, isc, iec, jsc, jec)
  nk=Grid%nk
  allocate(tmp(isd:ied,jsd:jed),tmp1(isd:ied,jsd:jed),tmp2(isd:ied,jsd:jed))
#endif
  tmp =0.0
  tmp1=0.0
  tmp2=0.0

  ! for help with masking flux at ocean bottom 
  allocate(kmask(nk))
  kmask(1:nk-1) = 1.0
  kmask(nk)     = 0.0

  if(zero_velocity_advect_horz) then 
    write(stdoutunit,*) &
    '==>Warning: running MOM with zero horizontal advection of velocity. Unrealistic simulation.'
  endif 
  if(zero_velocity_advect_vert) then 
    write(stdoutunit,*) &
    '==>Warning: running MOM with zero vertical advection of velocity. Unrealistic simulation.'
  endif 

  if(velocity_advect_centered) then 
    write(stdoutunit,*) &
    '==>Note: running MOM with traditional second order centred advection of linear momentum. '
    num_methods = num_methods+1
    advection_scheme = VEL_ADVECT_2ND_ORDER
  endif 

  if(velocity_advect_upwind) then 
    if(horz_grid == MOM_CGRID) then 
       write(stdoutunit,'(/a)') &
       '==>Error from ocean_velocity_advect_mod: Cgrid has yet to code upwind velocity advection.'
       call mpp_error(FATAL,&
       '==>Error from ocean_velocity_advect_mod: Cgrid has yet to code upwind velocity advection.')
    endif 
    write(stdoutunit,'(/a)') &
    '==>Note: running MOM with first order upwind advection of linear momentum. '
    write(stdoutunit,'(a)') &
    '   This method is for testing purposes.  It is not generally recommened.'
    write(stdoutunit,'(a)') &
    '   Diagnosed energy conversion errors will be large, as energy analysis assumes 2nd order centred advection.'
    num_methods = num_methods+1
    advection_scheme = VEL_ADVECT_UPWIND
  endif 

  if(num_methods==0) then 
    call mpp_error(FATAL,&
    '==>Error from ocean_velocity_advect_mod: No momentum advection scheme chosen. Must choose a scheme.')
  endif 
  if(num_methods>1) then 
    call mpp_error(FATAL,&
    '==>Error from ocean_velocity_advect_mod: More than one momentum advect scheme chosen. Choose only one.')
  endif 


  ! register for diagnostics manager 

  id_hadv_u = register_diag_field ('ocean_model', 'hadv_u', Grd%vel_axes_u(1:3), &
              Time%model_time, 'Thickness and rho wghtd horz advection of u',    &
              '(kg/m^3)*(m^2/s^2)',missing_value=-1e10, range=(/-1e10,1e10/))
  id_hadv_v = register_diag_field ('ocean_model', 'hadv_v', Grd%vel_axes_v(1:3), &
              Time%model_time, 'Thickness and rho wghtd horz advection of v',    &
              '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1e10,1e10/))

  id_vadv_u = register_diag_field ('ocean_model', 'vadv_u', Grd%vel_axes_u(1:3), &
              Time%model_time, 'Thickness and rho  wghtd vert advection of u',   &
              '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1e10,1e10/))
  id_vadv_v = register_diag_field ('ocean_model', 'vadv_v', Grd%vel_axes_v(1:3), &
              Time%model_time, 'Thickness and rho  wghtd vert advection of v',   &
              '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1e10,1e10/))

  id_surf_accel(1) = register_diag_field ('ocean_model', 'surf_accel_u', Grd%vel_axes_u(1:2), &
                     Time%model_time, 'uh-forcing from fresh water',                          &
                     '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1e10,1e10/))
  id_surf_accel(2) = register_diag_field ('ocean_model', 'surf_accel_v', Grd%vel_axes_v(1:2), &
                     Time%model_time, 'vh-forcing from fresh water',                          &
                     '(kg/m^3)*(m^2/s^2)', missing_value=missing_value, range=(/-1e10,1e10/))

  id_pme_u         = register_diag_field ('ocean_model', 'pme_u', Grd%vel_axes_uv(1:2), &
                     Time%model_time, 'pme on u-cell', '(kg/m^3)*(m/s)',                &
                     missing_value=missing_value, range=(/-1e10,1e10/))
  id_river_u       = register_diag_field ('ocean_model', 'river_u', Grd%vel_axes_uv(1:2), &
                     Time%model_time, 'river on u-cell', '(kg/m^3)*(m/s)',                &
                     missing_value=missing_value, range=(/-1e10,1e10/))


end subroutine ocean_velocity_advect_init
! </SUBROUTINE> NAME="ocean_velocity_advect_init"


!#######################################################################
! <SUBROUTINE NAME="horz_advection_of_velocity">
!
! <DESCRIPTION>
!
! Compute thickness weighted and density weighted acceleration 
! (kg/m^3)*(m^2/s^2) due to horizontal (constant k-level)
! advection of velocity.
!
! </DESCRIPTION>
!
subroutine horz_advection_of_velocity(Time, Thickness, Adv_vel, Velocity, energy_analysis_step)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(in)    :: Thickness
  type(ocean_adv_vel_type),   intent(in)    :: Adv_vel
  type(ocean_velocity_type),  intent(inout) :: Velocity
  logical,                    intent(in)    :: energy_analysis_step
 
  if ( .not. module_is_initialized ) then 
     call mpp_error(FATAL,&
      '==>Error from ocean_velocity_advect_mod (horz_advection_of_velocity): module not yet initialized')
  endif 

  if(zero_velocity_advect_horz) then 
      Velocity%wrkv(:,:,:,:) = 0.0
      return 
  endif

  if(advection_scheme==VEL_ADVECT_2ND_ORDER) then 
    call horz_advection_centered(Time, Thickness, Adv_vel, Velocity, energy_analysis_step)  
  elseif(advection_scheme==VEL_ADVECT_UPWIND) then
    call horz_advection_upwind(Time, Thickness, Adv_vel, Velocity, energy_analysis_step)  
  endif 

end subroutine horz_advection_of_velocity
! </SUBROUTINE> NAME="horz_advection_of_velocity"


!#######################################################################
! <SUBROUTINE NAME="horz_advection_centered">
!
! <DESCRIPTION>
!
! Compute thickness weighted and density weighted acceleration 
! (kg/m^3)*(m^2/s^2) due to horizontal (constant k-level)
! advection of velocity.
!
! Use second order centered method for either Bgrid or Cgrid. 
!
! </DESCRIPTION>
!
subroutine horz_advection_centered(Time, Thickness, Adv_vel, Velocity, energy_analysis_step)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(in)    :: Thickness
  type(ocean_adv_vel_type),   intent(in)    :: Adv_vel
  type(ocean_velocity_type),  intent(inout) :: Velocity
  logical,                    intent(in)    :: energy_analysis_step

  real    :: metric_force
  integer :: i, j, k, n
  integer :: tau, tau_m0
  integer :: stdoutunit 
  stdoutunit=stdout() 

  tau    = Time%tau
  tau_m0 = Time%tau_m0
  wrk1_v = 0.0

  if(horz_grid == MOM_BGRID) then 

     do k=1,nk
        do n=1,2

           tmp1(:,:) = Adv_vel%uhrho_eu(:,:,k)*FAX(Velocity%u(:,:,k,n,tau))
           tmp2(:,:) = Adv_vel%vhrho_nu(:,:,k)*FAY(Velocity%u(:,:,k,n,tau))

           ! compute horizontal divergence of flux 
           tmp(:,:)  = BDX_EU(tmp1) + BDY_NU(tmp2) 

           ! remove advection of momentum but leave the metric term unchanged
           if(have_obc) then
             call ocean_obc_zero_boundary(tmp(:,:), 'C')
           endif
           do j=jsc,jec
             do i=isc,iec
               tmp(i,j) = tmp(i,j) &
                           + (3-2*n)*Thickness%rho_dzu(i,j,k,tau)*Velocity%u(i,j,k,3-n,tau) &
                            *(Grd%dh1dy(i,j)*Velocity%u(i,j,k,1,tau)-Grd%dh2dx(i,j)*Velocity%u(i,j,k,2,tau))
               wrk1_v(i,j,k,n) = Grd%umask(i,j,k)*tmp(i,j)
             enddo
           enddo
        enddo
     enddo

  else ! cgrid 

     do k=1,nk

        ! minus the advection metric frequency
        wrk1_2d(:,:) = Grd%dh1dy(:,:)*FAY(Velocity%u(:,:,k,1,tau)) - Grd%dh2dx(:,:)*FAX(Velocity%u(:,:,k,2,tau))

        ! zonal velocity 
        n=1
        tmp1(:,:) = FAX(Adv_vel%uhrho_et(:,:,k))*FAX(Velocity%u(:,:,k,n,tau))
        tmp2(:,:) = FAX(Adv_vel%vhrho_nt(:,:,k))*FAY(Velocity%u(:,:,k,n,tau))
          
        do j=jsc,jec
           do i=isc,iec
              metric_force = onefourth*( (Adv_vel%vhrho_nt(i,j,k)   + Adv_vel%vhrho_nt(i+1,j,k))  *wrk1_2d(i,j) &
                                        +(Adv_vel%vhrho_nt(i,j-1,k) + Adv_vel%vhrho_nt(i+1,j-1,k))*wrk1_2d(i,j-1) ) 
              tmp(i,j) = (tmp1(i,j)-tmp1(i-1,j))*Grd%dxter(i,j) + (tmp2(i,j)-tmp2(i,j-1))*Grd%dyter(i,j) &
                         + metric_force 
              wrk1_v(i,j,k,n) = Grd%tmasken(i,j,k,n)*tmp(i,j)
           enddo
        enddo  

        ! meridional velocity 
        n=2
        tmp1(:,:) = FAY(Adv_vel%uhrho_et(:,:,k))*FAX(Velocity%u(:,:,k,n,tau))
        tmp2(:,:) = FAY(Adv_vel%vhrho_nt(:,:,k))*FAY(Velocity%u(:,:,k,n,tau))
          
        do j=jsc,jec
           do i=isc,iec
              metric_force = -onefourth*((Adv_vel%uhrho_et(i-1,j,k) + Adv_vel%uhrho_et(i-1,j+1,k))*wrk1_2d(i-1,j) &
                                        +(Adv_vel%uhrho_et(i,j,k)   + Adv_vel%uhrho_et(i,j+1,k))  *wrk1_2d(i,j-1) )
              tmp(i,j) =  (tmp1(i,j)-tmp1(i-1,j))*Grd%dxtnr(i,j) + (tmp2(i,j)-tmp2(i,j-1))*Grd%dytnr(i,j) &
                          + metric_force 
              wrk1_v(i,j,k,n) = Grd%tmasken(i,j,k,n)*tmp(i,j)
           enddo
        enddo  

     enddo   ! k-loop


  endif  ! for horz_grid 


  if(energy_analysis_step) then 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%wrkv(i,j,k,n) = wrk1_v(i,j,k,n) 
               enddo
            enddo
         enddo
      enddo

  else 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%advection(i,j,k,n,tau_m0) = Velocity%advection(i,j,k,n,tau_m0) + wrk1_v(i,j,k,n) 
               enddo
            enddo
         enddo
      enddo

      call diagnose_3d_en(Time, Grd, id_hadv_u, id_hadv_v, wrk1_v(:,:,:,:))

      if(debug_this_module) then 
          write(stdoutunit,*) ' '
          write(stdoutunit,*) 'From ocean_velocity_advect_mod: horz_advection_centered chksums'
          call write_timestamp(Time%model_time)
          call write_chksum_3d('horz_advection_of_velocity(1)', wrk1_v(COMP,:,1))
          call write_chksum_3d('horz_advection_of_velocity(2)', wrk1_v(COMP,:,2))
      endif

  endif

end subroutine horz_advection_centered
! </SUBROUTINE> NAME="horz_advection_centered"


!#######################################################################
! <SUBROUTINE NAME="horz_advection_upwind">
!
! <DESCRIPTION>
!
! Compute thickness weighted and density weighted acceleration 
! (kg/m^3)*(m^2/s^2) due to horizontal (constant k-level)
! advection of velocity.
!
! Use first order upwind method. Not coded for Cgrid, since
! first order upwind method is rarely used.  
!
! </DESCRIPTION>
!
subroutine horz_advection_upwind(Time, Thickness, Adv_vel, Velocity, energy_analysis_step)

  type(ocean_time_type),      intent(in)    :: Time
  type(ocean_thickness_type), intent(in)    :: Thickness
  type(ocean_adv_vel_type),   intent(in)    :: Adv_vel
  type(ocean_velocity_type),  intent(inout) :: Velocity
  logical,                    intent(in)    :: energy_analysis_step
 
  real, dimension(isd:ied,jsd:jed) :: fe, fn 
  real                             :: vel, upos, uneg 
  integer                          :: i, j, k, n
  integer                          :: tau, taum1, tau_m0

  integer :: stdoutunit 
  stdoutunit=stdout() 

  tau    = Time%tau
  taum1  = Time%taum1
  tau_m0 = Time%tau_m0
  wrk1_v = 0.0

  do k=1,nk
     do n=1,2

        ! i-flux 
        fe = 0.0
        do j=jsd,jed
           do i=isd,iec
              vel     = 0.5*Adv_vel%uhrho_eu(i,j,k)
              upos    = vel + abs(vel)
              uneg    = vel - abs(vel)
              fe(i,j) = (upos*Velocity%u(i,j,k,n,taum1) + uneg*Velocity%u(i+1,j,k,n,taum1)) &
                         *Grd%umask(i,j,k)*Grd%umask(i+1,j,k)
           enddo
        enddo

        ! j-flux
        fn = 0.0
        do j=jsd,jec
           do i=isd,ied
              vel     = 0.5*Adv_vel%vhrho_nu(i,j,k)
              upos    = vel + abs(vel)
              uneg    = vel - abs(vel)
              fn(i,j) = (upos*Velocity%u(i,j,k,n,taum1) + uneg*Velocity%u(i,j+1,k,n,taum1)) &
                        *Grd%umask(i,j,k)*Grd%umask(i,j+1,k)
           enddo
        enddo

        ! compute horizontal divergence of flux 
        tmp(:,:) = BDX_EU(fe) + BDY_NU(fn) 


        ! remove advection of momentum but leave the metric term unchanged
        if(have_obc) then
          call ocean_obc_zero_boundary(tmp(:,:), 'C')
        endif

        do j=jsc,jec
          do i=isc,iec
            tmp(i,j) = tmp(i,j) &
                        + (3-2*n)*Thickness%rho_dzu(i,j,k,tau)*Velocity%u(i,j,k,3-n,tau) &
                         *(Grd%dh1dy(i,j)*Velocity%u(i,j,k,1,tau)-Grd%dh2dx(i,j)*Velocity%u(i,j,k,2,tau))
            wrk1_v(i,j,k,n) = Grd%umask(i,j,k)*tmp(i,j)
          enddo
        enddo


     enddo
  enddo


  if(energy_analysis_step) then 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%wrkv(i,j,k,n) = wrk1_v(i,j,k,n) 
               enddo
            enddo
         enddo
      enddo

  else 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%advection(i,j,k,n,tau_m0) = Velocity%advection(i,j,k,n,tau_m0) + wrk1_v(i,j,k,n) 
               enddo
            enddo
         enddo
      enddo

      call diagnose_3d_u(Time, Grd, id_hadv_u, wrk1_v(:,:,:,1))
      call diagnose_3d_u(Time, Grd, id_hadv_v, wrk1_v(:,:,:,2))

      if(debug_this_module) then 
          write(stdoutunit,*) ' '
          write(stdoutunit,*) 'From ocean_velocity_advect_mod: horz_advection_upwind chksums'
          call write_timestamp(Time%model_time)
          call write_chksum_3d('horz_advection_of_velocity(1)', wrk1_v(COMP,:,1))
          call write_chksum_3d('horz_advection_of_velocity(2)', wrk1_v(COMP,:,2))
      endif

  endif


end subroutine horz_advection_upwind
! </SUBROUTINE> NAME="horz_advection_upwind"



!#######################################################################
! <SUBROUTINE NAME="vert_advection_of_velocity">
!
! <DESCRIPTION>
!
! Compute thickness weighted and density weighted acceleration 
! (kg/m^3)*(m^2/s^2) due to vertical advection of velocity.  
!
! Include vertical advection due to fresh water entering surface cells.  
!
! </DESCRIPTION>
! 
subroutine vert_advection_of_velocity(Time, Adv_vel, Velocity, pme, river, &
                                      upme, uriver, energy_analysis_step)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_adv_vel_type),     intent(in)    :: Adv_vel
  type(ocean_velocity_type),    intent(inout) :: Velocity
  real, dimension(isd:,jsd:),   intent(in)    :: pme
  real, dimension(isd:,jsd:),   intent(in)    :: river
  real, dimension(isd:,jsd:,:), intent(in)    :: upme
  real, dimension(isd:,jsd:,:), intent(in)    :: uriver 
  logical,                      intent(in)    :: energy_analysis_step

  real, dimension(isd:ied,jsd:jed)   :: pme_u
  real, dimension(isd:ied,jsd:jed)   :: river_u
  real, dimension(isd:ied,jsd:jed,2) :: surf_accel 
  integer :: i, j, n


  if ( .not. module_is_initialized ) then 
     call mpp_error(FATAL,&
      '==>Error from ocean_velocity_advect_mod (vert_advection_of_velocity): module not yet initialized')
  endif 

  if(zero_velocity_advect_vert) then 
      Velocity%wrkv(:,:,:,:) = 0.0
      return 
  endif

  ! fresh water on U-cell
  pme_u    = 0.0
  river_u  = 0.0
  pme_u    = REMAP_BT_TO_BU(pme(:,:))
  river_u  = REMAP_BT_TO_BU(river(:,:))

  if(advection_scheme==VEL_ADVECT_2ND_ORDER) then 
    call vert_advection_centered(Time, Adv_vel, Velocity, pme, pme_u, river, river_u, &
                                 upme, uriver, energy_analysis_step)
  elseif(advection_scheme==VEL_ADVECT_UPWIND) then
    call vert_advection_upwind(Time, Adv_vel, Velocity, pme_u, river_u,   &
                               upme, uriver, energy_analysis_step)
  endif 
  

  ! diagnostics
  surf_accel = 0.0
  if(id_surf_accel(1) > 0 .or. id_surf_accel(2) > 0) then   
      do n=1,2
         do j=jsc,jec
            do i=isc,iec
               surf_accel(i,j,n) = Grd%umask(i,j,1)*(pme_u(i,j)*upme(i,j,n) + river_u(i,j)*uriver(i,j,n))
            enddo
         enddo
      enddo
  endif

  call diagnose_2d_u(Time, Grd, id_surf_accel(1), surf_accel(:,:,1))
  call diagnose_2d_u(Time, Grd, id_surf_accel(2), surf_accel(:,:,2))
  call diagnose_2d_u(Time, Grd, id_pme_u, pme_u(:,:))
  call diagnose_2d_u(Time, Grd, id_river_u, river_u(:,:))

end subroutine vert_advection_of_velocity
! </SUBROUTINE> NAME="vert_advection_of_velocity"


!#######################################################################
! <SUBROUTINE NAME="vert_advection_centered">
!
! <DESCRIPTION>
!
! Compute thickness weighted and density weighted acceleration 
! (kg/m^3)*(m^2/s^2) due to vertical advection of velocity.  
!
! Include vertical advection due to fresh water entering surface cells.  
! Assume upme and uriver are the most fundamental fields, passed through
! the FMS coupler on the Bgrid velocity point. So use these to average 
! onto the C-grid velocity points.  Likewise, pme and river are fundamental,
! and sit on the T-grid.  
!
! Use second order centered method here.
!
! </DESCRIPTION>
! 
subroutine vert_advection_centered(Time, Adv_vel, Velocity, pme, pme_u, river, river_u, &
                                   upme, uriver, energy_analysis_step)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_adv_vel_type),     intent(in)    :: Adv_vel
  type(ocean_velocity_type),    intent(inout) :: Velocity
  real, dimension(isd:,jsd:),   intent(in)    :: pme
  real, dimension(isd:,jsd:),   intent(in)    :: pme_u
  real, dimension(isd:,jsd:),   intent(in)    :: river
  real, dimension(isd:,jsd:),   intent(in)    :: river_u
  real, dimension(isd:,jsd:,:), intent(in)    :: upme
  real, dimension(isd:,jsd:,:), intent(in)    :: uriver 
  logical,                      intent(in)    :: energy_analysis_step

  real, dimension(isd:ied,jsd:jed) :: ft1
  real, dimension(isd:ied,jsd:jed) :: ft2

  integer :: i, j, k, kp1, n
  integer :: tau, tau_m0

  integer :: stdoutunit 
  stdoutunit=stdout() 

  tau    = Time%tau
  tau_m0 = Time%tau_m0
  wrk1_v = 0.0

  if(horz_grid == MOM_BGRID) then 

     do n=1,2

        ! fresh water contribution at the surface 
        do j=jsc,jec
           do i=isc,iec
              ft1(i,j) = -pme_u(i,j)*upme(i,j,n) -river_u(i,j)*uriver(i,j,n) 
              ft2(i,j) = 0.0
           enddo
        enddo

        do k=1,nk
           kp1 = min(k+1,nk)
           do j=jsc,jec
              do i=isc,iec
                 ft2(i,j) = Adv_vel%wrho_bu(i,j,k)*0.5*(Velocity%u(i,j,k,n,tau) + kmask(k)*Velocity%u(i,j,kp1,n,tau))
                 wrk1_v(i,j,k,n) = Grd%umask(i,j,k)*(ft1(i,j)-ft2(i,j))
                 ft1(i,j) = ft2(i,j)
              enddo
           enddo

           if(have_obc) then
             call ocean_obc_zero_boundary(wrk1_v(:,:,k,n), 'C')
           endif

        enddo
     enddo

  else  ! cgrid  

     n=1 ! zonal velocity 

     ! fresh water contribution at the surface 
     do j=jsc,jec
        do i=isc,iec
           ft1(i,j) = -onefourth*Grd%tmasken(i,j,1,n)*(pme(i,j)  +pme(i+1,j))  *(upme(i,j,n)  +upme(i,j-1,n)  ) &
                      -onefourth*Grd%tmasken(i,j,1,n)*(river(i,j)+river(i+1,j))*(uriver(i,j,n)+uriver(i,j-1,n)) 
           ft2(i,j) = 0.0
        enddo
     enddo
     do k=1,nk
        kp1 = min(k+1,nk)
        do j=jsc,jec
           do i=isc,iec
              ft2(i,j) = onefourth*(Adv_vel%wrho_bt(i,j,k)+Adv_vel%wrho_bt(i+1,j,k)) &
                                  *(Velocity%u(i,j,k,n,tau) + kmask(k)*Velocity%u(i,j,kp1,n,tau))
              wrk1_v(i,j,k,n) = Grd%tmasken(i,j,k,n)*(ft1(i,j)-ft2(i,j))
              ft1(i,j) = ft2(i,j)
           enddo
        enddo
     enddo


     n=2 ! meridional velocity 

     ! fresh water contribution at the surface 
     do j=jsc,jec
        do i=isc,iec
           ft1(i,j) = -onefourth*Grd%tmasken(i,j,1,n)*(pme(i,j)  +pme(i,j+1))  *(upme(i,j,n)  +upme(i-1,j,n)  ) &
                      -onefourth*Grd%tmasken(i,j,1,n)*(river(i,j)+river(i,j+1))*(uriver(i,j,n)+uriver(i-1,j,n)) 
           ft2(i,j) = 0.0
        enddo
     enddo
     do k=1,nk
        kp1 = min(k+1,nk)
        do j=jsc,jec
           do i=isc,iec
              ft2(i,j) = onefourth*(Adv_vel%wrho_bt(i,j,k)+Adv_vel%wrho_bt(i,j+1,k)) &
                                  *(Velocity%u(i,j,k,n,tau) + kmask(k)*Velocity%u(i,j,kp1,n,tau))
              wrk1_v(i,j,k,n) = Grd%tmasken(i,j,k,n)*(ft1(i,j)-ft2(i,j))
              ft1(i,j) = ft2(i,j)
           enddo
        enddo
     enddo


  endif  ! horz_grid if-test


  if(energy_analysis_step) then 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%wrkv(i,j,k,n) = wrk1_v(i,j,k,n) 
               enddo
            enddo
         enddo
      enddo

  else 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%advection(i,j,k,n,tau_m0) = Velocity%advection(i,j,k,n,tau_m0) + wrk1_v(i,j,k,n) 
               enddo
            enddo
         enddo
      enddo

      call diagnose_3d_u(Time, Grd, id_vadv_u, wrk1_v(:,:,:,1))
      call diagnose_3d_u(Time, Grd, id_vadv_v, wrk1_v(:,:,:,2))

      if(debug_this_module) then
          write(stdoutunit,*) ' '
          write(stdoutunit,*) 'From ocean_velocity_advect_mod: vert_advection_centered chksums'
          call write_timestamp(Time%model_time)
          call write_chksum_3d('vert_advection_of_velocity(1)', wrk1_v(COMP,:,1))
          call write_chksum_3d('vert_advection_of_velocity(2)', wrk1_v(COMP,:,2))
      endif

  endif

end subroutine vert_advection_centered
! </SUBROUTINE> NAME="vert_advection_centered"


!#######################################################################
! <SUBROUTINE NAME="vert_advection_upwind">
!
! <DESCRIPTION>
!
! Compute thickness weighted and density weighted acceleration 
! (kg/m^3)*(m^2/s^2) due to vertical advection of velocity.  
!
! Include vertical advection due to fresh water entering surface cells.  
!
! Use first order upwind method here. Not coded for Cgrid, since
! first order upwind method is rarely used. 
!
! </DESCRIPTION>
! 
subroutine vert_advection_upwind(Time, Adv_vel, Velocity, pme_u, river_u, &
                                 upme, uriver, energy_analysis_step)

  type(ocean_time_type),        intent(in)    :: Time
  type(ocean_adv_vel_type),     intent(in)    :: Adv_vel
  type(ocean_velocity_type),    intent(inout) :: Velocity
  real, dimension(isd:,jsd:),   intent(in)    :: pme_u
  real, dimension(isd:,jsd:),   intent(in)    :: river_u
  real, dimension(isd:,jsd:,:), intent(in)    :: upme
  real, dimension(isd:,jsd:,:), intent(in)    :: uriver 
  logical,                      intent(in)    :: energy_analysis_step

  real, dimension(isd:ied,jsd:jed) :: ft1
  real, dimension(isd:ied,jsd:jed) :: ft2

  integer :: i, j, k, kp1, n
  integer :: taum1, tau_m0
  real    :: vel, wpos, wneg

  integer :: stdoutunit 
  stdoutunit=stdout() 

  taum1  = Time%taum1
  tau_m0 = Time%tau_m0
  wrk1_v = 0.0

  do n=1,2

     ! fresh water contribution at the surface 
     do j=jsc,jec
        do i=isc,iec
           ft1(i,j) = -pme_u(i,j)*upme(i,j,n) -river_u(i,j)*uriver(i,j,n)
           ft2(i,j) = 0.0
        enddo
     enddo

     do k=1,nk
        kp1 = min(k+1,nk)
        do j=jsc,jec
           do i=isc,iec
              vel      = 0.5*Adv_vel%wrho_bu(i,j,k)
              wpos     = vel + abs(vel) 
              wneg     = vel - abs(vel) 
              ft2(i,j) = (wneg*Velocity%u(i,j,k,n,taum1) + kmask(k)*wpos*Velocity%u(i,j,kp1,n,taum1)) &
                         *Grd%umask(i,j,k)*Grd%umask(i,j,kp1) 
              wrk1_v(i,j,k,n) = Grd%umask(i,j,k)*(ft1(i,j)-ft2(i,j))
              ft1(i,j) = ft2(i,j)
           enddo
        enddo

        if(have_obc) then
          call ocean_obc_zero_boundary(wrk1_v(:,:,k,n), 'C')
        endif

     enddo
  enddo

  if(energy_analysis_step) then 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%wrkv(i,j,k,n) = wrk1_v(i,j,k,n) 
               enddo
            enddo
         enddo
      enddo

  else 

      do n=1,2
         do k=1,nk
            do j=jsc,jec
               do i=isc,iec
                  Velocity%advection(i,j,k,n,tau_m0) = Velocity%advection(i,j,k,n,tau_m0) + wrk1_v(i,j,k,n) 
               enddo
            enddo
         enddo
      enddo

      call diagnose_3d_u(Time, Grd, id_vadv_u, wrk1_v(:,:,:,1))
      call diagnose_3d_u(Time, Grd, id_vadv_v, wrk1_v(:,:,:,2))

      if(debug_this_module) then
          write(stdoutunit,*) ' '
          write(stdoutunit,*) 'From ocean_velocity_advect_mod: vert_advection_upwind chksums'
          call write_timestamp(Time%model_time)
          call write_chksum_3d('vert_advection_of_velocity(1)', wrk1_v(COMP,:,1))
          call write_chksum_3d('vert_advection_of_velocity(2)', wrk1_v(COMP,:,2))
      endif

  endif


end subroutine vert_advection_upwind
! </SUBROUTINE> NAME="vert_advection_upwind"





end module ocean_velocity_advect_mod

module mpp_memutils_mod

  use mpp_mod, only: mpp_min, mpp_max, mpp_sum, mpp_pe, mpp_root_pe
  use mpp_mod, only: mpp_error, FATAL, stderr, mpp_npes, get_unit

  implicit none
  private

  public :: mpp_print_memuse_stats, mpp_mem_dump
  public :: mpp_memuse_begin, mpp_memuse_end

  real    :: begin_memuse
  logical :: memuse_started = .false.

contains

  !#######################################################################
  subroutine mpp_memuse_begin
#if defined(__sgi) || defined(__aix) || defined(__SX)
    integer :: memuse
#endif

    if(memuse_started) then
       call mpp_error(FATAL, "mpp_memutils_mod: mpp_memuse_begin was already called")
    endif
    memuse_started = .true.

#if defined(__sgi) || defined(__aix) || defined(__SX)
    begin_memuse = memuse()*1e-3
#else
    call mpp_mem_dump(begin_memuse)
#endif 

  end subroutine mpp_memuse_begin

  !#######################################################################
  subroutine mpp_memuse_end( text, unit )

    character(len=*), intent(in) :: text
    integer, intent(in), optional :: unit
    real    :: m, mmin, mmax, mavg, mstd, end_memuse
    integer :: mu
#if defined(__sgi) || defined(__aix) || defined(__SX)
    integer :: memuse
#endif

    if(.NOT.memuse_started) then
       call mpp_error(FATAL, "mpp_memutils_mod: mpp_memuse_begin must be called before calling mpp_memuse_being")
    endif
    memuse_started = .false.

#if defined(__sgi) || defined(__aix) || defined(__SX)
    end_memuse = memuse()*1e-3
#else
    call mpp_mem_dump(end_memuse)
#endif 

    mu = stderr(); if( PRESENT(unit) )mu = unit
    m = end_memuse - begin_memuse
    mmin = m; call mpp_min(mmin)
    mmax = m; call mpp_max(mmax)
    mavg = m; call mpp_sum(mavg); mavg = mavg/mpp_npes()
    mstd = (m-mavg)**2; call mpp_sum(mstd); mstd = sqrt( mstd/mpp_npes() )
    if( mpp_pe().EQ.mpp_root_pe() )write( mu,'(a64,4es11.3)' ) &
         'Memory(MB) used in '//trim(text)//'=', mmin, mmax, mstd, mavg

    return    

  end subroutine mpp_memuse_end

  !#######################################################################

  subroutine mpp_print_memuse_stats( text, unit )

    character(len=*), intent(in) :: text
    integer, intent(in), optional :: unit
    real :: m, mmin, mmax, mavg, mstd
    integer :: mu
!memuse is an external function: works on SGI
!use #ifdef to generate equivalent on other platforms.
#if defined(__sgi) || defined(__aix) || defined(__SX)
    integer :: memuse !default integer OK?
#endif 

    mu = stderr(); if( PRESENT(unit) )mu = unit
#if defined(__sgi) || defined(__aix) || defined(__SX)
    m = memuse()*1e-3
#else
    call mpp_mem_dump(m)
#endif 
    mmin = m; call mpp_min(mmin)
    mmax = m; call mpp_max(mmax)
    mavg = m; call mpp_sum(mavg); mavg = mavg/mpp_npes()
    mstd = (m-mavg)**2; call mpp_sum(mstd); mstd = sqrt( mstd/mpp_npes() )
    if( mpp_pe().EQ.mpp_root_pe() )write( mu,'(a64,4es11.3)' ) &
         'Memuse(MB) at '//trim(text)//'=', mmin, mmax, mstd, mavg

    return
  end subroutine mpp_print_memuse_stats

!#######################################################################

subroutine mpp_mem_dump ( memuse )

real, intent(out) :: memuse

! This routine returns the memory usage on Linux systems.
! It does this by querying a system file (file_name below).
! It is intended for use by print_memuse_stats above.

character(len=32) :: file_name = '/proc/self/status'
character(len=32) :: string
integer :: mem_unit
real    :: multiplier

  memuse = 0.0
  multiplier = 1.0

  mem_unit = get_unit()
  open(mem_unit, file=file_name, form='FORMATTED', action='READ', access='SEQUENTIAL')
  
  do; read (mem_unit,'(a)', end=10) string
    if ( INDEX ( string, 'VmHWM:' ) == 1 ) then
      read (string(7:LEN_TRIM(string)-2),*) memuse
      exit
    endif
  enddo
  
  if (TRIM(string(LEN_TRIM(string)-1:)) == "kB" ) &
    multiplier = 1.0/1024. ! Convert from kB to MB

10 close (mem_unit)
   memuse = memuse * multiplier

  return
end subroutine mpp_mem_dump


end module mpp_memutils_mod

module ocean_tpm_util_mod  !{
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Richard D. Slater
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> John P. Dunne
!</REVIEWER>
!
!<OVERVIEW>
! Ocean tracer package module pointers module
!</OVERVIEW>
!
!<DESCRIPTION>
! This module allocates a suite of variables used in ocean_tpm
!</DESCRIPTION>
!
! <INFO>
! </INFO>
!

use field_manager_mod, only: fm_string_len, fm_path_name_len
use field_manager_mod, only: fm_get_type, fm_get_index, fm_get_length
use field_manager_mod, only: fm_get_current_list, fm_new_list, fm_change_list
use field_manager_mod, only: fm_new_value, fm_get_value
use field_manager_mod, only: fm_exists
use fms_mod,           only: FATAL, stdout
use mpp_mod,           only: mpp_error
use fm_util_mod,       only: fm_util_default_caller
use fm_util_mod,       only: fm_util_check_for_bad_fields
use fm_util_mod,       only: fm_util_set_caller, fm_util_reset_caller, fm_util_set_no_overwrite
use fm_util_mod,       only: fm_util_reset_no_overwrite, fm_util_set_good_name_list, fm_util_reset_good_name_list
use fm_util_mod,       only: fm_util_get_string_array, fm_util_set_value, fm_util_get_index_string

implicit none

private

!
!       Public routines
!

public  otpm_set_tracer_package
public  otpm_set_prog_tracer
public  otpm_set_diag_tracer

!
!       Public variables
!

!
!       Private routines
!

private  set_prog_value
private  set_prog_value_integer
private  set_prog_value_logical
private  set_prog_value_real
private  set_prog_value_string
private  check_ocean_mod

!
!       private parameters
!

character(len=48), parameter            :: mod_name = 'ocean_tpm_util_mod'

character(len=fm_string_len), parameter :: default_units = ' '
character(len=fm_string_len), parameter :: default_type  = ' '
real, parameter                         :: default_conversion = 1.0
real, parameter                         :: default_offset = 0.0
real, parameter                         :: default_min_tracer = -1.0e+20
real, parameter                         :: default_max_tracer = +1.0e+20
logical, parameter                      :: default_use_only_advection = .false.
real, parameter                         :: default_min_range = 1.0
real, parameter                         :: default_max_range = 0.0
character(len=fm_string_len), parameter :: default_restart_file = 'ocean_tracer.res.nc'
logical, parameter                      :: default_const_init_tracer = .false.
real, parameter                         :: default_const_init_value = 0.0
character(len=fm_string_len), parameter :: default_flux_units = ' '
real, parameter                         :: default_min_flux_range = 1.0
real, parameter                         :: default_max_flux_range = 0.0
real, parameter                         :: default_min_tracer_limit = -1.0e+20
real, parameter                         :: default_max_tracer_limit = +1.0e+20
character(len=fm_string_len), parameter :: default_vert_adv_scheme = 'mdfl_sweby'
character(len=fm_string_len), parameter :: default_horiz_adv_scheme = 'mdfl_sweby'
logical, parameter                      :: default_psom_limit = .false.
integer, parameter                      :: default_ppm_hlimiter = 2
integer, parameter                      :: default_ppm_vlimiter = 2
integer, parameter                      :: default_mdt_scheme = 1

!
!       Private variables
!

character(len=128) :: version = '$Id: ocean_tpm_util.F90,v 20.0 2013/12/14 00:17:18 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

!
!        Interface definitions for overloaded routines
!

interface  set_prog_value  !{
  module procedure  set_prog_value_integer
  module procedure  set_prog_value_logical
  module procedure  set_prog_value_real
  module procedure  set_prog_value_string
end interface  !}

contains


!#######################################################################
! <SUBROUTINE NAME="check_ocean_mod">
!
! <DESCRIPTION>
! Be sure that the /ocean_mod hierarchy has been initialized.
! </DESCRIPTION>
!

subroutine check_ocean_mod(caller)  !{

implicit none

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'check_ocean_mod'

!
!       arguments
!

character(len=*), intent(in), optional  :: caller

!
!       Local variables
!

character(len=256)                                      :: error_header
character(len=256)                                      :: warn_header
character(len=256)                                      :: note_header
character(len=128)                                      :: caller_str
character(len=fm_string_len), pointer, dimension(:)     :: good_list => NULL()
logical, save                                           :: ocean_mod_initialized = .false.

!
!       return if ocean_mod has been initialized
!

if (ocean_mod_initialized) then
  return
endif

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
  
!
! make sure that /ocean_mod exists, just in case there were no inputs in the field table
!

if (fm_new_list('/ocean_mod') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "ocean_mod" list')
endif  

if (fm_new_list('/ocean_mod/GOOD') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "GOOD" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'GOOD', append = .true.)

if (fm_new_list('/ocean_mod/tracer_packages') .le. 0) then 
  call mpp_error(FATAL, trim(error_header) // ' Could not set "tracer packages" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'tracer_packages', append = .true.)

if (fm_new_list('/ocean_mod/prog_tracers') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "prog_tracers" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'prog_tracers', append = .true.)

if (fm_new_list('/ocean_mod/diag_tracers') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "diag_tracers" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'diag_tracers', append = .true.)

if (fm_new_list('/ocean_mod/namelists') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "namelists" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'namelists', append = .true.)
  
if (fm_new_list('/ocean_mod/xland_mix') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "xland_mix" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'xland_mix', append = .true.)

if (fm_new_list('/ocean_mod/xland_insert') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "xland_insert" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'xland_insert', append = .true.)

if (fm_new_list('/ocean_mod/diff_cbt_enhance') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "diff_cbt_enhance" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'diff_cbt_enhance', append = .true.)

if (fm_new_list('/ocean_mod/riverspread') .le. 0) then  
   call mpp_error(FATAL, trim(error_header) // ' Could not set the "riverspread" list')
endif
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'riverspread', append = .true.)

if (fm_new_list('/ocean_mod/rayleigh_damp_table') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "rayleigh_damp_table" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'rayleigh_damp_table', append = .true.)

if (fm_new_list('/ocean_mod/overflow_ofp_info') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "overflow_ofp_info" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'overflow_ofp_info', append = .true.)

if (fm_new_list('/ocean_mod/overflow_ofp_src') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "overflow_ofp_src" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'overflow_ofp_src', append = .true.)

if (fm_new_list('/ocean_mod/overflow_ofp_int') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "overflow_ofp_int" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'overflow_ofp_int', append = .true.)

if (fm_new_list('/ocean_mod/overflow_ofp_ent') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "overflow_ofp_ent" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'overflow_ofp_ent', append = .true.)

if (fm_new_list('/ocean_mod/overflow_ofp_prd_line_01') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "overflow_ofp_prd_line_01" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'overflow_ofp_prd_line_01', append = .true.)

if (fm_new_list('/ocean_mod/overflow_ofp_prd_line_02') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "overflow_ofp_prd_line_02" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'overflow_ofp_prd_line_02', append = .true.)

if (fm_new_list('/ocean_mod/overflow_ofp_prd_line_03') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "overflow_ofp_prd_line_03" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'overflow_ofp_prd_line_03', append = .true.)

if (fm_new_list('/ocean_mod/overflow_ofp_prd_line_04') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "overflow_ofp_prd_line_04" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'overflow_ofp_prd_line_04', append = .true.)

if (fm_new_list('/ocean_mod/overflow_ofp_prd_line_05') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "overflow_ofp_prd_line_05" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'overflow_ofp_prd_line_05', append = .true.)

if (fm_new_list('/ocean_mod/overflow_ofp_prd_line_06') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "overflow_ofp_prd_line_06" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'overflow_ofp_prd_line_06', append = .true.)

if (fm_new_list('/ocean_mod/overflow_ofp_prd_line_07') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "overflow_ofp_prd_line_07" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'overflow_ofp_prd_line_07', append = .true.)

if (fm_new_list('/ocean_mod/overflow_ofp_prd_line_08') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "overflow_ofp_prd_line_08" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'overflow_ofp_prd_line_08', append = .true.)

if (fm_new_list('/ocean_mod/overflow_ofp_prd_line_09') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "overflow_ofp_prd_line_09" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'overflow_ofp_prd_line_09', append = .true.)

if (fm_new_list('/ocean_mod/overflow_ofp_prd_line_10') .le. 0) then  
  call mpp_error(FATAL, trim(error_header) // ' Could not set the "overflow_ofp_prd_line_10" list')
endif  
call fm_util_set_value('/ocean_mod/GOOD/good_ocean_mod_list', 'overflow_ofp_prd_line_10', append = .true.)


!
! Initialize the good_namelists variable as it may not be otherwise set
!

call fm_util_set_value('/ocean_mod/GOOD/good_namelists', ' ', index = 0)

!
! Check for any errors in the number of fields in the ocean_mod list
!

good_list => fm_util_get_string_array('/ocean_mod/GOOD/good_ocean_mod_list',   &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
if (associated(good_list)) then  
  call fm_util_check_for_bad_fields('/ocean_mod', good_list,       &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')
  deallocate(good_list)
else  
  call mpp_error(FATAL,trim(error_header) // ' Empty "good_ocean_mod_list" list')
endif 

ocean_mod_initialized = .true.

return

end subroutine  check_ocean_mod  !}
! </SUBROUTINE> NAME="check_ocean_mod"


!#######################################################################
! <FUNCTION NAME="otpm_set_tracer_package">
!
! <DESCRIPTION>
! Set the values for a tracer package and return its index (0 on error)
!
! </DESCRIPTION>
!

function otpm_set_tracer_package(name, caller, units, conversion, offset,       &
     min_tracer, max_tracer, use_only_advection,                                &
     min_range, max_range, restart_file,                                        &
     const_init_tracer,                                                         &
     const_init_value, flux_units,                                              &
     min_flux_range, max_flux_range,                                            &
     min_tracer_limit, max_tracer_limit,                                        &
     psom_limit, ppm_hlimiter, ppm_vlimiter, mdt_scheme,                        &
     vert_adv_scheme, horiz_adv_scheme)                                         &
         result (pack_index)  !{

implicit none

!
!       Return type
!

integer :: pack_index

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in), optional  :: caller
character(len=*), intent(in), optional  :: units
character(len=*), intent(in), optional  :: flux_units
character(len=*), intent(in), optional  :: vert_adv_scheme
character(len=*), intent(in), optional  :: horiz_adv_scheme
real, intent(in), optional              :: conversion
character(len=*), intent(in), optional  :: restart_file
logical, intent(in), optional           :: const_init_tracer
logical, intent(in), optional           :: use_only_advection
real, intent(in), optional              :: max_range
real, intent(in), optional              :: min_range
real, intent(in), optional              :: max_flux_range
real, intent(in), optional              :: min_flux_range
real, intent(in), optional              :: max_tracer
real, intent(in), optional              :: min_tracer
real, intent(in), optional              :: max_tracer_limit
real, intent(in), optional              :: min_tracer_limit
real, intent(in), optional              :: offset
real, intent(in), optional              :: const_init_value  
logical, intent(in), optional           :: psom_limit
integer, intent(in), optional           :: ppm_hlimiter
integer, intent(in), optional           :: ppm_vlimiter
integer, intent(in), optional           :: mdt_scheme

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'otpm_set_tracer_package'

!
!       Local variables
!

character(len=fm_path_name_len)                         :: current_list
character(len=256)                                      :: error_header
character(len=256)                                      :: warn_header
character(len=256)                                      :: note_header
character(len=128)                                      :: caller_str
character(len=fm_path_name_len)                         :: tracer_package_name
character(len=fm_string_len), pointer, dimension(:)     :: good_list => NULL()
logical                                                 :: add_name

  integer :: stdoutunit 
  stdoutunit=stdout() 

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

call check_ocean_mod(caller = trim(sub_name) // caller_str)

write (stdoutunit,*)
write (stdoutunit,*) trim(note_header), ' Processing tracer package ', trim(name)

!
!       Check whether the package already exists. If so, then use that package
!

tracer_package_name = '/ocean_mod/tracer_packages/' // trim(name) // '/'
pack_index = fm_get_index(tracer_package_name)

if (pack_index .le. 0) then  !{

!
!       Set a new tracer package and get its index
!

  pack_index = fm_new_list(tracer_package_name)
  if (pack_index .le. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Could not set tracer package')
  endif  !}

endif  !}

!
!       Change to the new tracer package, first saving the current list
!

current_list = fm_get_current_list()
if (current_list .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not get the current list')
endif  !}

if (.not. fm_change_list(tracer_package_name)) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not change to the new list')
endif  !}

!
!       Set the array in which to save the valid names for this list,
!       used later for a consistency check. This is used in the fm_util_set_value
!       routines to make the list of valid values
!

call fm_util_set_good_name_list('/ocean_mod/GOOD/tracer_packages/' // trim(name) // '/good_list')

!
!       Set other defaults for the fm_util_set_value routines
!

call fm_util_set_no_overwrite(.true.)
call fm_util_set_caller(caller_str)

!
!       Set the default number of instances (always zero)
!

call fm_util_set_value('names', ' ', index = 0)

!
!       Set various values to given values, or to defaults if not given
!

if (present(units)) then  !{
  call fm_util_set_value('units', units)
else  !}{
  call fm_util_set_value('units', default_units, no_create = .true.)
endif  !}

if (present(conversion)) then  !{
  call fm_util_set_value('conversion', conversion)
else  !}{
  call fm_util_set_value('conversion', default_conversion, no_create = .true.)
endif  !}

if (present(offset)) then  !{
  call fm_util_set_value('offset', offset)
else  !}{
  call fm_util_set_value('offset', default_offset, no_create = .true.)
endif  !}

if (present(min_tracer)) then  !{
  call fm_util_set_value('min_tracer', min_tracer)
else  !}{
  call fm_util_set_value('min_tracer', default_min_tracer, no_create = .true.)
endif  !}

if (present(max_tracer)) then  !{
  call fm_util_set_value('max_tracer', max_tracer)
else  !}{
  call fm_util_set_value('max_tracer', default_max_tracer, no_create = .true.)
endif  !}

if (present(min_range)) then  !{
  call fm_util_set_value('min_range', min_range)
else  !}{
  call fm_util_set_value('min_range', default_min_range, no_create = .true.)
endif  !}

if (present(max_range)) then  !{
  call fm_util_set_value('max_range', max_range)
else  !}{
  call fm_util_set_value('max_range', default_max_range, no_create = .true.)
endif  !}

if (present(use_only_advection)) then  !{
  call fm_util_set_value('use_only_advection', use_only_advection)
else  !}{
  call fm_util_set_value('use_only_advection', default_use_only_advection, no_create = .true.)
endif  !}

if (present(restart_file)) then  !{
  call fm_util_set_value('restart_file', restart_file)
else  !}{
  call fm_util_set_value('restart_file', default_restart_file, no_create = .true.)
endif  !}

if (present(const_init_tracer)) then  !{
  call fm_util_set_value('const_init_tracer', const_init_tracer)
else  !}{
  call fm_util_set_value('const_init_tracer', default_const_init_tracer, no_create = .true.)
endif  !}

if (present(const_init_value)) then  !{
  call fm_util_set_value('const_init_value', const_init_value)
else  !}{
  call fm_util_set_value('const_init_value', default_const_init_value, no_create = .true.)
endif  !}

if (present(psom_limit)) then  !{
  call fm_util_set_value('psom_limit', psom_limit)
else  !}{
  call fm_util_set_value('psom_limit', default_psom_limit, no_create = .true.)
endif  !}

if (present(ppm_hlimiter)) then  !{
  call fm_util_set_value('ppm_hlimiter', ppm_hlimiter)
else  !}{
  call fm_util_set_value('ppm_hlimiter', default_ppm_hlimiter, no_create = .true.)
endif  !}

if (present(ppm_vlimiter)) then  !{
  call fm_util_set_value('ppm_vlimiter', ppm_vlimiter)
else  !}{
  call fm_util_set_value('ppm_vlimiter', default_ppm_vlimiter, no_create = .true.)
endif  !}

if (present(mdt_scheme)) then  !{
  call fm_util_set_value('mdt_scheme', mdt_scheme)
else  !}{
  call fm_util_set_value('mdt_scheme', default_mdt_scheme, no_create = .true.)
endif  !}

if (present(flux_units)) then  !{
  call fm_util_set_value('flux_units', flux_units)
else  !}{
  call fm_util_set_value('flux_units', default_flux_units, no_create = .true.)
endif  !}

if (present(min_flux_range)) then  !{
  call fm_util_set_value('min_flux_range', min_flux_range)
else  !}{
  call fm_util_set_value('min_flux_range', default_min_flux_range, no_create = .true.)
endif  !}

if (present(max_flux_range)) then  !{
  call fm_util_set_value('max_flux_range', max_flux_range)
else  !}{
  call fm_util_set_value('max_flux_range', default_max_flux_range, no_create = .true.)
endif  !}

if (present(min_tracer_limit)) then  !{
  call fm_util_set_value('min_tracer_limit', min_tracer_limit)
else  !}{
  call fm_util_set_value('min_tracer_limit', default_min_tracer_limit, no_create = .true.)
endif  !}

if (present(max_tracer_limit)) then  !{
  call fm_util_set_value('max_tracer_limit', max_tracer_limit)
else  !}{
  call fm_util_set_value('max_tracer_limit', default_max_tracer_limit, no_create = .true.)
endif  !}

if (present(vert_adv_scheme)) then  !{
  call fm_util_set_value('vertical-advection-scheme', vert_adv_scheme)
else  !}{
  call fm_util_set_value('vertical-advection-scheme', default_vert_adv_scheme, no_create = .true.)
endif  !}

if (present(horiz_adv_scheme)) then  !{
  call fm_util_set_value('horizontal-advection-scheme', horiz_adv_scheme)
else  !}{
  call fm_util_set_value('horizontal-advection-scheme', default_horiz_adv_scheme, no_create = .true.)
endif  !}

!
!       Reset the defaults for the fm_util_set_value calls
!

call fm_util_reset_good_name_list
call fm_util_reset_no_overwrite
call fm_util_reset_caller

!
!       Change back to the saved current list
!

if (.not. fm_change_list(current_list)) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not change back to ' // trim(current_list))
endif  !}

!
!       Check for any errors in the number of fields in this list
!

if (caller_str .eq. ' ') then  !{
  caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'
endif  !}
good_list => fm_util_get_string_array('/ocean_mod/GOOD/tracer_packages/' // trim(name) // '/good_list', &
     caller = caller_str)
if (associated(good_list)) then  !{
  call fm_util_check_for_bad_fields('/ocean_mod/tracer_packages/' // trim(name), good_list, caller = caller_str)
  deallocate(good_list)
else  !}{
  call mpp_error(FATAL, trim(error_header) // ' Empty "' // trim(name) // '" list')
endif  !}

!
!       Add the package name to the list of good packages (if not already there), to be used
!       later for a consistency check
!

if (fm_exists('/ocean_mod/GOOD/good_tracer_packages')) then  !{
  add_name = fm_util_get_index_string('/ocean_mod/GOOD/good_tracer_packages', name,           &
     caller = caller_str) .le. 0                ! true if name does not exist in string array
else  !}{
  add_name = .true.                             ! always add to new list
endif  !}
if (add_name) then  !{
  if (fm_new_value('/ocean_mod/GOOD/good_tracer_packages', name, append = .true.) .le. 0) then  !{
    call mpp_error(FATAL, trim(error_header) //                                         &
         ' Could not add ' // trim(name) // ' to "good_tracer_packages" list')
  endif  !}
endif  !}

return

end function otpm_set_tracer_package  !}
! </FUNCTION> NAME="otpm_set_tracer_package"


!#######################################################################
! <SUBROUTINE NAME="set_prog_value_integer">
!
! <DESCRIPTION>
! Set an integer value for a prognostic tracer element in the Field Manager tree.
! </DESCRIPTION>
!

subroutine set_prog_value_integer(name, package_name, value, caller)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in)            :: package_name
integer, intent(in)                     :: value
character(len=*), intent(in), optional  :: caller

!
!       Local parameters
!

character(len=48), parameter    :: sub_name = 'set_prog_value_integer'

!
!       Local variables
!

integer                         :: integer_value
character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
integer                         :: length

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       check that a package name is given (fatal if not)
!

if (package_name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty package_name given')
endif  !}

!
!       The following steps are done when setting elements in the prognostic
!       tracer. Note that the subroutine fm_util_set_value should have been
!       set so as to only set the given value if there is not already a
!       value in the tracer tree (such as one specified from the field table)
!
!       The precedence of values to use is as follows:
!               1) a value set in the field table
!               2) a value present in the package defaults (either
!                       from the field table or otpm_set_tracer_package)
!               3) the value given to this subroutine
!

!       
!       First check whether there is a package default set
!

length = fm_get_length(trim(package_name) // name)
if (length .gt. 1) then  !{

  !     Error: package default is not a scalar

  call mpp_error(FATAL, trim(error_header) //                         &
       ' "' // trim(name) // '" not a scalar in: ' // trim(package_name))

elseif (length .le. 0) then  !}{

  ! Package default does not exist or is null, so use, in order:
  ! 1) value specified in field table (implicit in the fm_util_set_value call)
  ! 2) value given in argument list

  call fm_util_set_value(name, value)

else  !}{

  ! Package default exists, so use, in order:
  ! 1) value specified in field table (implicit in the fm_util_set_value call)
  ! 2) package default

  if (fm_get_value(trim(package_name) // name, integer_value)) then  !{

    call fm_util_set_value(name, integer_value)

  else  !}{

    ! This error shouldn't happen since the previous calls all
    ! show that the value exists, unless, perhaps, the type is incorrect

    call mpp_error(FATAL, trim(error_header) //                         &
         ' Could not get "' // trim(name) // '" from: ' // trim(package_name))

  endif  !}

endif  !}

return

end subroutine set_prog_value_integer  !}
! </SUBROUTINE> NAME="set_prog_value_integer"


!#######################################################################
! <SUBROUTINE NAME="set_prog_value_logical">
!
! <DESCRIPTION>
! Set a logical value for a prognostic tracer element in the Field Manager tree.
! </DESCRIPTION>
!

subroutine set_prog_value_logical(name, package_name, value, caller)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in)            :: package_name
logical, intent(in)                     :: value
character(len=*), intent(in), optional  :: caller

!
!       Local parameters
!

character(len=48), parameter    :: sub_name = 'set_prog_value_logical'

!
!       Local variables
!

logical                         :: logical_value
character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
integer                         :: length

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       check that a package name is given (fatal if not)
!

if (package_name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty package_name given')
endif  !}

!
!       The following steps are done when setting elements in the prognostic
!       tracer. Note that the subroutine fm_util_set_value should have been
!       set so as to only set the given value if there is not already a
!       value in the tracer tree (such as one specified from the field table)
!
!       The precedence of values to use is as follows:
!               1) a value set in the field table
!               2) a value present in the package defaults (either
!                       from the field table or otpm_set_tracer_package)
!               3) the value given to this subroutine
!

!       
!       First check whether there is a package default set
!

length = fm_get_length(trim(package_name) // name)
if (length .gt. 1) then  !{

  !     Error: package default is not a scalar

  call mpp_error(FATAL, trim(error_header) //                         &
       ' "' // trim(name) // '" not a scalar in: ' // trim(package_name))

elseif (length .le. 0) then  !}{

  ! Package default does not exist or is null, so use, in order:
  ! 1) value specified in field table (implicit in the fm_util_set_value call)
  ! 2) value given in argument list

  call fm_util_set_value(name, value)

else  !}{

  ! Package default exists, so use, in order:
  ! 1) value specified in field table (implicit in the fm_util_set_value call)
  ! 2) package default

  if (fm_get_value(trim(package_name) // name, logical_value)) then  !{

    call fm_util_set_value(name, logical_value)

  else  !}{

    ! This error shouldn't happen since the previous calls all
    ! show that the value exists, unless, perhaps, the type is incorrect

    call mpp_error(FATAL, trim(error_header) //                         &
         ' Could not get "' // trim(name) // '" from: ' // trim(package_name))

  endif  !}

endif  !}

return

end subroutine set_prog_value_logical  !}
! </SUBROUTINE> NAME="set_prog_value_logical"


!#######################################################################
! <SUBROUTINE NAME="set_prog_value_real">
!
! <DESCRIPTION>
! Set a real value for a prognostic tracer element in the Field Manager tree.
! </DESCRIPTION>
!

subroutine set_prog_value_real(name, package_name, value, caller)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in)            :: package_name
real, intent(in)                        :: value
character(len=*), intent(in), optional  :: caller

!
!       Local parameters
!

character(len=48), parameter    :: sub_name = 'set_prog_value_real'

!
!       Local variables
!

real                            :: real_value
character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
integer                         :: length

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       check that a package name is given (fatal if not)
!

if (package_name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty package_name given')
endif  !}

!
!       The following steps are done when setting elements in the prognostic
!       tracer. Note that the subroutine fm_util_set_value should have been
!       set so as to only set the given value if there is not already a
!       value in the tracer tree (such as one specified from the field table)
!
!       The precedence of values to use is as follows:
!               1) a value set in the field table
!               2) a value present in the package defaults (either
!                       from the field table or otpm_set_tracer_package)
!               3) the value given to this subroutine
!

!       
!       First check whether there is a package default set
!

length = fm_get_length(trim(package_name) // name)
if (length .gt. 1) then  !{

  !     Error: package default is not a scalar

  call mpp_error(FATAL, trim(error_header) //                         &
       ' "' // trim(name) // '" not a scalar in: ' // trim(package_name))

elseif (length .le. 0) then  !}{

  ! Package default does not exist or is null, so use, in order:
  ! 1) value specified in field table (implicit in the fm_util_set_value call)
  ! 2) value given in argument list

  call fm_util_set_value(name, value)

else  !}{

  ! Package default exists, so use, in order:
  ! 1) value specified in field table (implicit in the fm_util_set_value call)
  ! 2) package default

  if (fm_get_value(trim(package_name) // name, real_value)) then  !{

    call fm_util_set_value(name, real_value)

  else  !}{

    ! This error shouldn't happen since the previous calls all
    ! show that the value exists, unless, perhaps, the type is incorrect

    call mpp_error(FATAL, trim(error_header) //                         &
         ' Could not get "' // trim(name) // '" from: ' // trim(package_name))

  endif  !}

endif  !}

return

end subroutine set_prog_value_real  !}
! </SUBROUTINE> NAME="set_prog_value_real"


!#######################################################################
! <SUBROUTINE NAME="set_prog_value_string">
!
! <DESCRIPTION>
! Set a string value for a prognostic tracer element in the Field Manager tree.
! </DESCRIPTION>
!

subroutine set_prog_value_string(name, package_name, value, caller)  !{

implicit none

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in)            :: package_name
character(len=*), intent(in)            :: value
character(len=*), intent(in), optional  :: caller

!
!       Local parameters
!

character(len=48), parameter    :: sub_name = 'set_prog_value_string'

!
!       Local variables
!

character(len=fm_string_len)    :: string_value
character(len=256)              :: error_header
character(len=256)              :: warn_header
character(len=256)              :: note_header
character(len=128)              :: caller_str
integer                         :: length

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

!
!       check that a package name is given (fatal if not)
!

if (package_name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty package_name given')
endif  !}

!
!       The following steps are done when setting elements in the prognostic
!       tracer. Note that the subroutine fm_util_set_value should have been
!       set so as to only set the given value if there is not already a
!       value in the tracer tree (such as one specified from the field table)
!
!       The precedence of values to use is as follows:
!               1) a value set in the field table
!               2) a value present in the package defaults (either
!                       from the field table or otpm_set_tracer_package)
!               3) the value given to this subroutine
!

!       
!       First check whether there is a package default set
!

length = fm_get_length(trim(package_name) // name)
if (length .gt. 1) then  !{

  !     Error: package default is not a scalar

  call mpp_error(FATAL, trim(error_header) //                         &
       ' "' // trim(name) // '" not a scalar in: ' // trim(package_name))

elseif (length .le. 0) then  !}{

  ! Package default does not exist or is null, so use, in order:
  ! 1) value specified in field table (implicit in the fm_util_set_value call)
  ! 2) value given in argument list

  call fm_util_set_value(name, value)

else  !}{

  ! Package default exists, so use, in order:
  ! 1) value specified in field table (implicit in the fm_util_set_value call)
  ! 2) package default

  if (fm_get_value(trim(package_name) // name, string_value)) then  !{

    call fm_util_set_value(name, string_value)

  else  !}{

    ! This error shouldn't happen since the previous calls all
    ! show that the value exists, unless, perhaps, the type is incorrect

    call mpp_error(FATAL, trim(error_header) //                         &
         ' Could not get "' // trim(name) // '" from: ' // trim(package_name))

  endif  !}

endif  !}

return

end subroutine set_prog_value_string  !}
! </SUBROUTINE> NAME="set_prog_value_string"


!#######################################################################
! <FUNCTION NAME="otpm_set_prog_tracer">
!
! <DESCRIPTION>
! Set the values for a prog tracer and return its index (0 on error)
! </DESCRIPTION>
!
function otpm_set_prog_tracer(name, package, caller, longname, units,   &
     type, conversion, offset,                                          &
     min_tracer, max_tracer, use_only_advection,                        &
     min_range, max_range, restart_file,                                &
     const_init_tracer,                                                 &
     const_init_value, flux_units,                                      &
     min_flux_range, max_flux_range,                                    &
     min_tracer_limit, max_tracer_limit,                                &
     psom_limit, ppm_hlimiter, ppm_vlimiter, mdt_scheme,                &
     vert_adv_scheme, horiz_adv_scheme)                                 &
         result (prog_index)  !{

implicit none

!
!       Return type
!

integer :: prog_index

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in)            :: package
character(len=*), intent(in), optional  :: caller
character(len=*), intent(in), optional  :: units
character(len=*), intent(in), optional  :: type
character(len=*), intent(in), optional  :: flux_units
character(len=*), intent(in), optional  :: longname
character(len=*), intent(in), optional  :: vert_adv_scheme
character(len=*), intent(in), optional  :: horiz_adv_scheme
real, intent(in), optional              :: conversion
character(len=*), intent(in), optional  :: restart_file
logical, intent(in), optional           :: const_init_tracer
logical, intent(in), optional           :: use_only_advection
real, intent(in), optional              :: max_range
real, intent(in), optional              :: min_range
real, intent(in), optional              :: max_flux_range
real, intent(in), optional              :: min_flux_range
real, intent(in), optional              :: max_tracer
real, intent(in), optional              :: min_tracer
real, intent(in), optional              :: max_tracer_limit
real, intent(in), optional              :: min_tracer_limit
real, intent(in), optional              :: offset
real, intent(in), optional              :: const_init_value  
logical, intent(in), optional           :: psom_limit  
integer, intent(in), optional           :: ppm_hlimiter
integer, intent(in), optional           :: ppm_vlimiter
integer, intent(in), optional           :: mdt_scheme

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'otpm_set_prog_tracer'

!
!       Local variables
!

character(len=fm_path_name_len)                         :: current_list
character(len=fm_path_name_len)                         :: package_name
character(len=256)                                      :: error_header
character(len=256)                                      :: warn_header
character(len=256)                                      :: note_header
character(len=128)                                      :: caller_str
character(len=fm_path_name_len)                         :: tracer_name
character(len=fm_string_len), pointer, dimension(:)     :: good_list => NULL()
logical                                                 :: add_name

  integer :: stdoutunit 
  stdoutunit=stdout() 

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

call check_ocean_mod(caller = trim(sub_name) // caller_str)

!
!       check the package name
!

if (package .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty package given')
endif  !}
package_name = '/ocean_mod/tracer_packages/' // trim(package) // '/'
if (fm_get_type(package_name) .ne. 'list') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Package does not exist or is not a list: ' // trim(package))
endif  !}

!
!       Begin processing
!

write (stdoutunit,*)
write (stdoutunit,*) trim(note_header), ' Processing prog tracer ', trim(name)

!
!       Check whether the tracer already exists. If so, then use that tracer
!

tracer_name = '/ocean_mod/prog_tracers/' // trim(name) // '/'
prog_index = fm_get_index(tracer_name)

if (prog_index .le. 0) then  !{

!
!       Set a new prog tracer and get its index
!

  prog_index = fm_new_list(tracer_name)
  if (prog_index .le. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Could not set prog tracer ' // trim(name))
  endif  !}

endif  !}

!
!       Change to the new tracer, first saving the current list
!

current_list = fm_get_current_list()
if (current_list .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not get the current list')
endif  !}

if (.not. fm_change_list(tracer_name)) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not change to the new list')
endif  !}

!
!       Set the array in which to save the valid names for this list,
!       used later for a consistency check. This is used in the fm_util_set_value
!       routines to make the list of valid values
!

call fm_util_set_good_name_list('/ocean_mod/GOOD/prog_tracers/' // trim(name) // '/good_list')

!
!       Set other defaults for the fm_util_set_value routines
!

call fm_util_set_caller(caller_str)

!
!       When the following is set to true, fm_util_set_value will not overwrite
!       any values already set in the tracer tree If there is no
!       value present, then a new entry will be created in the tracer tree and
!       the value supplied will be set.
!

call fm_util_set_no_overwrite(.true.)

!
!       Set various values to given values, or to defaults if not given
!

!
!       The longname is distinct here in that there is no option for a package
!       default. Hence, the precedence of values is:
!               1) a value set in the field table
!               2) an optional argument given to this subroutine
!               3) the tracer name
!

if (present(longname)) then  !{
  call fm_util_set_value('longname', longname)
else  !}{
  call fm_util_set_value('longname', name)
endif  !}

!
!       The precedence of values to use in set_prog_value is as follows:
!               1) a value set in the field table
!               2) a value present in the package defaults (either
!                       from the field table or otpm_set_tracer_package)
!               3) the value passed to it in the argument list
!       This subroutine will preferentially supply the given optional
!       argument over the module-wide default value
!

if (present(units)) then  !{
  call set_prog_value('units', package_name, units)
else  !}{
  call set_prog_value('units', package_name, default_units)
endif  !}

if (present(type)) then  !{
   call set_prog_value('type', package_name, type)
else  !}{
   call set_prog_value('type', package_name, default_type)
endif  !}

if (present(conversion)) then  !}{
  call set_prog_value('conversion', package_name, conversion)
else  !}{
  call set_prog_value('conversion', package_name, default_conversion)
endif  !}

if (present(offset)) then  !}{
  call set_prog_value('offset', package_name, offset)
else  !}{
  call set_prog_value('offset', package_name, default_offset)
endif  !}

if (present(min_tracer)) then  !}{
  call set_prog_value('min_tracer', package_name, min_tracer)
else  !}{
  call set_prog_value('min_tracer', package_name, default_min_tracer)
endif  !}

if (present(max_tracer)) then  !}{
  call set_prog_value('max_tracer', package_name, max_tracer)
else  !}{
  call set_prog_value('max_tracer', package_name, default_max_tracer)
endif  !}

if (present(min_range)) then  !}{
  call set_prog_value('min_range', package_name, min_range)
else  !}{
  call set_prog_value('min_range', package_name, default_min_range)
endif  !}

if (present(max_range)) then  !}{
  call set_prog_value('max_range', package_name, max_range)
else  !}{
  call set_prog_value('max_range', package_name, default_max_range)
endif  !}

if (present(use_only_advection)) then  !}{
  call set_prog_value('use_only_advection', package_name, use_only_advection)
else  !}{
  call set_prog_value('use_only_advection', package_name, default_use_only_advection)
endif  !}

if (present(restart_file)) then  !}{
  call set_prog_value('restart_file', package_name, restart_file)
else  !}{
  call set_prog_value('restart_file', package_name, default_restart_file)
endif  !}

if (present(const_init_tracer)) then  !}{
  call set_prog_value('const_init_tracer', package_name, const_init_tracer)
else  !}{
  call set_prog_value('const_init_tracer', package_name, default_const_init_tracer)
endif  !}

if (present(const_init_value)) then  !}{
  call set_prog_value('const_init_value', package_name, const_init_value)
else  !}{
  call set_prog_value('const_init_value', package_name, default_const_init_value)
endif  !}

if (present(psom_limit)) then  !}{
  call set_prog_value('psom_limit', package_name, psom_limit)
else  !}{
  call set_prog_value('psom_limit', package_name, default_psom_limit)
endif  !}

if (present(ppm_hlimiter)) then  !}{
  call set_prog_value('ppm_hlimiter', package_name, ppm_hlimiter)
else  !}{
  call set_prog_value('ppm_hlimiter', package_name, default_ppm_hlimiter)
endif  !}

if (present(ppm_vlimiter)) then  !}{
  call set_prog_value('ppm_vlimiter', package_name, ppm_vlimiter)
else  !}{
  call set_prog_value('ppm_vlimiter', package_name, default_ppm_vlimiter)
endif  !}

if (present(mdt_scheme)) then  !}{
  call set_prog_value('mdt_scheme', package_name, mdt_scheme)
else  !}{
  call set_prog_value('mdt_scheme', package_name, default_mdt_scheme)
endif  !}

if (present(flux_units)) then  !}{
  call set_prog_value('flux_units', package_name, flux_units)
else  !}{
  call set_prog_value('flux_units', package_name, default_flux_units)
endif  !}

if (present(min_flux_range)) then  !}{
  call set_prog_value('min_flux_range', package_name, min_flux_range)
else  !}{
  call set_prog_value('min_flux_range', package_name, default_min_flux_range)
endif  !}

if (present(max_flux_range)) then  !}{
  call set_prog_value('max_flux_range', package_name, max_flux_range)
else  !}{
  call set_prog_value('max_flux_range', package_name, default_max_flux_range)
endif  !}

if (present(min_tracer_limit)) then  !}{
  call set_prog_value('min_tracer_limit', package_name, min_tracer_limit)
else  !}{
  call set_prog_value('min_tracer_limit', package_name, default_min_tracer_limit)
endif  !}

if (present(max_tracer_limit)) then  !}{
  call set_prog_value('max_tracer_limit', package_name, max_tracer_limit)
else  !}{
  call set_prog_value('max_tracer_limit', package_name, default_max_tracer_limit)
endif  !}

if (present(vert_adv_scheme)) then  !}{
  call set_prog_value('vertical-advection-scheme', package_name, vert_adv_scheme)
else  !}{
  call set_prog_value('vertical-advection-scheme', package_name, default_vert_adv_scheme)
endif  !}

if (present(horiz_adv_scheme)) then  !}{
  call set_prog_value('horizontal-advection-scheme', package_name, horiz_adv_scheme)
else  !}{
  call set_prog_value('horizontal-advection-scheme', package_name, default_horiz_adv_scheme)
endif  !}

!
!       Reset the defaults for the fm_util_set_value calls
!

call fm_util_reset_good_name_list
call fm_util_reset_no_overwrite
call fm_util_reset_caller

!
!       Change back to the saved current list
!

if (.not. fm_change_list(current_list)) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not change back to ' // trim(current_list))
endif  !}

!
!       Check for any errors in the number of fields in this list
!

if (caller_str .eq. ' ') then  !{
  caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'
endif  !}
good_list => fm_util_get_string_array('/ocean_mod/GOOD/prog_tracers/' // trim(name) // '/good_list', &
     caller = caller_str)
if (associated(good_list)) then  !{
  call fm_util_check_for_bad_fields('/ocean_mod/prog_tracers/' // trim(name), good_list, caller = caller_str)
  deallocate(good_list)
else  !}{
  call mpp_error(FATAL, trim(error_header) // ' Empty "' // trim(name) // '" list')
endif  !}

!
!       Add the tracer name to the list of good tracers (if not already there), to be used
!       later for a consistency check
!

if (fm_exists('/ocean_mod/GOOD/good_prog_tracers')) then  !{
  add_name = fm_util_get_index_string('/ocean_mod/GOOD/good_prog_tracers', name,           &
     caller = caller_str) .le. 0                ! true if name does not exist in string array
else  !}{
  add_name = .true.                             ! always add to new list
endif  !}
if (add_name) then  !{
  if (fm_new_value('/ocean_mod/GOOD/good_prog_tracers', name, append = .true.) .le. 0) then  !{
    call mpp_error(FATAL, trim(error_header) //                                         &
         ' Could not add ' // trim(name) // ' to "good_prog_tracers" list')
  endif  !}
endif  !}

return

end function otpm_set_prog_tracer  !}
! </FUNCTION> NAME="otpm_set_prog_tracer"


!#######################################################################
! <FUNCTION NAME="otpm_set_diag_tracer">
!
! <DESCRIPTION>
! Set the values for a diag tracer and return its index (0 on error)
! </DESCRIPTION>
!
function otpm_set_diag_tracer(name, caller, longname, units,    &
     type, conversion, offset, min_tracer, max_tracer,          &
     min_range, max_range, restart_file,                        &
     const_init_tracer,                                         &
     const_init_value)                                          &
         result (diag_index)  !{

implicit none

!
!       Return type
!

integer :: diag_index

!
!       arguments
!

character(len=*), intent(in)            :: name
character(len=*), intent(in), optional  :: caller
character(len=*), intent(in), optional  :: units
character(len=*), intent(in), optional  :: type
character(len=*), intent(in), optional  :: longname
real, intent(in), optional              :: conversion
character(len=*), intent(in), optional  :: restart_file
logical, intent(in), optional           :: const_init_tracer
real, intent(in), optional              :: max_range
real, intent(in), optional              :: min_range
real, intent(in), optional              :: max_tracer
real, intent(in), optional              :: min_tracer
real, intent(in), optional              :: offset
real, intent(in), optional              :: const_init_value  

!
!       Local parameters
!

character(len=48), parameter  :: sub_name = 'otpm_set_diag_tracer'

!
!       Local variables
!

character(len=fm_path_name_len)                         :: current_list
character(len=256)                                      :: error_header
character(len=256)                                      :: warn_header
character(len=256)                                      :: note_header
character(len=128)                                      :: caller_str
character(len=fm_string_len), pointer, dimension(:)     :: good_list => NULL()
character(len=fm_path_name_len)                         :: tracer_name
logical                                                 :: add_name

  integer :: stdoutunit 
  stdoutunit=stdout() 

!
!       set the caller string and headers
!

if (present(caller)) then  !{
  caller_str = '[' // trim(caller) // ']'
else  !}{
  caller_str = fm_util_default_caller
endif  !}

error_header = '==>Error from ' // trim(mod_name) //   &
               '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
warn_header = '==>Warning from ' // trim(mod_name) //  &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'
note_header = '==>Note from ' // trim(mod_name) //     &
              '(' // trim(sub_name) // ')' // trim(caller_str) // ':'

!
!       check that a name is given (fatal if not)
!

if (name .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Empty name given')
endif  !}

call check_ocean_mod(caller = trim(sub_name) // caller_str)

!
!       Check whether the tracer already exists. If so, then use that tracer
!

tracer_name = '/ocean_mod/diag_tracers/' // trim(name) // '/'
diag_index = fm_get_index(tracer_name)

if (diag_index .le. 0) then  !{

!
!       Set a new diag tracer and get its index
!

  diag_index = fm_new_list(tracer_name)
  if (diag_index .le. 0) then  !{
    call mpp_error(FATAL, trim(error_header) // ' Could not set diag tracer ' // trim(name))
  endif  !}

endif  !}

write (stdoutunit,*)
write (stdoutunit,*) trim(note_header), ' Processing diag tracer ', trim(name)

!
!       Change to the new tracer, first saving the current list
!

current_list = fm_get_current_list()
if (current_list .eq. ' ') then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not get the current list')
endif  !}

if (.not. fm_change_list(tracer_name)) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not change to the new list')
endif  !}

!
!       Set the array in which to save the valid names for this list,
!       used later for a consistency check. This is used in the fm_util_set_value
!       routines to make the list of valid values
!

call fm_util_set_good_name_list('/ocean_mod/GOOD/diag_tracers/' // trim(name) // '/good_list')

!
!       Set other defaults for the fm_util_set_value routines
!

call fm_util_set_no_overwrite(.true.)
call fm_util_set_caller(caller_str)

!
!       Set various values to given values, or to defaults if not given
!

if (present(longname)) then  !{
  call fm_util_set_value('longname', longname)
else  !}{
  call fm_util_set_value('longname', name)
endif  !}

if (present(units)) then  !{
  call fm_util_set_value('units', units)
else  !}{
  call fm_util_set_value('units', default_units)
endif  !}

if (present(type)) then  !{
   call fm_util_set_value('type', type)
else  !}{
   call fm_util_set_value('type', default_type)
endif  !}

if (present(conversion)) then  !{
  call fm_util_set_value('conversion', conversion)
else  !}{
  call fm_util_set_value('conversion', default_conversion)
endif  !}

if (present(offset)) then  !{
  call fm_util_set_value('offset', offset)
else  !}{
  call fm_util_set_value('offset', default_offset)
endif  !}

if (present(min_tracer)) then  !{
  call fm_util_set_value('min_tracer', min_tracer)
else  !}{
  call fm_util_set_value('min_tracer', default_min_tracer)
endif  !}

if (present(max_tracer)) then  !{
  call fm_util_set_value('max_tracer', max_tracer)
else  !}{
  call fm_util_set_value('max_tracer', default_max_tracer)
endif  !}

if (present(min_range)) then  !{
  call fm_util_set_value('min_range', min_range)
else  !}{
  call fm_util_set_value('min_range', default_min_range)
endif  !}

if (present(max_range)) then  !{
  call fm_util_set_value('max_range', max_range)
else  !}{
  call fm_util_set_value('max_range', default_max_range)
endif  !}

if (present(restart_file)) then  !{
  call fm_util_set_value('restart_file', restart_file)
else  !}{
  call fm_util_set_value('restart_file', ' ')
endif  !}

if (present(const_init_tracer)) then  !{
  call fm_util_set_value('const_init_tracer', const_init_tracer)
else  !}{
  call fm_util_set_value('const_init_tracer', default_const_init_tracer)
endif  !}

if (present(const_init_value)) then  !{
  call fm_util_set_value('const_init_value', const_init_value)
else  !}{
  call fm_util_set_value('const_init_value', default_const_init_value)
endif  !}

!
!       Reset the defaults for the fm_util_set_value calls
!

call fm_util_reset_good_name_list
call fm_util_reset_no_overwrite
call fm_util_reset_caller

!
!       Change back to the saved current list
!

if (.not. fm_change_list(current_list)) then  !{
  call mpp_error(FATAL, trim(error_header) // ' Could not change back to ' // trim(current_list))
endif  !}

!
!       Check for any errors in the number of fields in this list
!

if (caller_str .eq. ' ') then  !{
  caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'
endif  !}
good_list => fm_util_get_string_array('/ocean_mod/GOOD/diag_tracers/' // trim(name) // '/good_list', &
     caller = caller_str)
if (associated(good_list)) then  !{
  call fm_util_check_for_bad_fields(tracer_name, good_list, caller = caller_str)
  deallocate(good_list)
else  !}{
  call mpp_error(FATAL, trim(error_header) // ' Empty "' // trim(name) // '" list')
endif  !}

!
!       Add the tracer name to the list of good tracers (if not already there), to be used
!       later for a consistency check
!

if (fm_exists('/ocean_mod/GOOD/good_diag_tracers')) then  !{
  add_name = fm_util_get_index_string('/ocean_mod/GOOD/good_diag_tracers', name,           &
     caller = caller_str) .le. 0                ! true if name does not exist in string array
else  !}{
  add_name = .true.                             ! always add to new list
endif  !}
if (add_name) then  !{
  if (fm_new_value('/ocean_mod/GOOD/good_diag_tracers', name, append = .true.) .le. 0) then  !{
    call mpp_error(FATAL, trim(error_header) //                                         &
         ' Could not add ' // trim(name) // ' to "good_diag_tracers" list')
  endif  !}
endif  !}

return

end function otpm_set_diag_tracer  !}
! </FUNCTION> NAME="otpm_set_diag_tracer"


end module ocean_tpm_util_mod  !}

module vert_turb_driver_mod

!-----------------------------------------------------------------------
!
!       driver for compuing vertical diffusion coefficients
!
!         choose either:
!              1) mellor-yamada 2.5 (with tke)
!              2) non-local K scheme
!              3) entrainment and diagnostic turbulence (edt) from
!                 Bretherton and Grenier
!
!-----------------------------------------------------------------------
!---------------- modules ---------------------


use      my25_turb_mod, only: my25_turb_init, my25_turb_end,  &
                              my25_turb, tke_surf, get_tke,   &
                              my25_turb_restart

use    diffusivity_mod, only: diffusivity, molecular_diff

use            edt_mod, only: edt_init, edt, edt_end

use    strat_cloud_mod, only: strat_cloud_on

use   shallow_conv_mod, only: shallow_conv_init, shallow_conv

use stable_bl_turb_mod, only: stable_bl_turb_init, stable_bl_turb

use        entrain_mod, only: entrain_init, entrain, entrain_end

use   diag_manager_mod, only: register_diag_field, send_data

use   time_manager_mod, only: time_type, get_time, operator(-)

use      constants_mod, only: rdgas, rvgas, kappa
 
use            mpp_mod, only: input_nml_file
use            fms_mod, only: mpp_pe, mpp_root_pe, stdlog, &
                              error_mesg, open_namelist_file, file_exist, &
                              check_nml_error, close_file, FATAL, &
                              write_version_number
 

use  field_manager_mod, only: MODEL_ATMOS

use tracer_manager_mod, only: get_tracer_index

implicit none
private

!---------------- interfaces ---------------------

public   vert_turb_driver_init, vert_turb_driver_end, vert_turb_driver
public   vert_turb_driver_restart


!-----------------------------------------------------------------------
!--------------------- version number ----------------------------------

character(len=128) :: version = '$Id: vert_turb_driver.F90,v 20.0 2013/12/13 23:22:34 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'
logical            :: module_is_initialized = .false.

!-----------------------------------------------------------------------
 real, parameter :: p00    = 1000.0E2
 real, parameter :: p00inv = 1./p00
 real, parameter :: d622   = rdgas/rvgas
 real, parameter :: d378   = 1.-d622
 real, parameter :: d608   = d378/d622

!---------------- private data -------------------

 real :: gust_zi = 1000.   ! constant for computed gustiness (meters)

 integer :: nql, nqi, nqa    !  tracer indices for stratiform clouds

!-----------------------------------------------------------------------
!-------------------- namelist -----------------------------------------

 logical :: do_shallow_conv  = .false.
 logical :: do_mellor_yamada = .true.
 logical :: do_diffusivity         = .false.
 logical :: do_molecular_diffusion = .false.
 logical :: do_edt                 = .false.
 logical :: do_stable_bl     = .false.
 logical :: use_tau          = .true.
 logical :: do_entrain    = .false.
 logical :: do_simple = .false. 

 character(len=24) :: gust_scheme  = 'constant' ! valid schemes are:
                                                !   => 'constant'
                                                !   => 'beljaars'
 real              :: constant_gust = 1.0
 real              :: gust_factor   = 1.0

!-->h1g, 2012-07-16
 integer :: do_clubb
 integer :: nwp2
 real    :: wp2_min = 4.e-4
 real    :: diff_min = 1.e-3    ! minimum value of a diffusion 
                                ! coefficient beneath which the
                                ! coefficient is reset to zero
 
 integer :: id_clubb_on
 integer :: id_stable_on                     ! ( diff_m_stab > diff_m  or diff_t_stab > diff_t)
 
 integer :: id_stable_effective              !     ( diff_m_stab > diff_m  or diff_t_stab > diff_t) 
                                             ! and ( diff_m_stab > diff_min  or diff_t_stab > diff_min)
!<--h1g, 2012-07-16 
 
 namelist /vert_turb_driver_nml/ do_shallow_conv, do_mellor_yamada, &
                                 gust_scheme, constant_gust, use_tau, &
                                 do_molecular_diffusion, do_stable_bl, &
                                 do_diffusivity, do_edt, do_entrain, &
                                 gust_factor, do_simple, wp2_min

!-------------------- diagnostics fields -------------------------------

integer :: id_tke,    id_lscale, id_lscale_0, id_z_pbl, id_gust,  &
           id_diff_t, id_diff_m, id_diff_sc, id_z_full, id_z_half,&
           id_uwnd,   id_vwnd,   id_diff_t_stab, id_diff_m_stab,  &
           id_diff_t_entr, id_diff_m_entr    

real :: missing_value = -999.

character(len=9) :: mod_name = 'vert_turb'

!-----------------------------------------------------------------------

contains

!#######################################################################

subroutine vert_turb_driver (is, js, Time, Time_next, dt, tdtlw,     &
                             frac_land,   &
                             p_half, p_full, z_half, z_full, u_star,   &
                             b_star, q_star, rough, lat, convect,      &
                             u, v, t, q, r, um, vm, tm, qm, rm,        &
                             udt, vdt, tdt, qdt, rdt, diff_t, diff_m,  &
                             gust, z_pbl, mask, kbot                   )

!-----------------------------------------------------------------------
integer,         intent(in)         :: is, js
type(time_type), intent(in)         :: Time, Time_next
   real,         intent(in)         :: dt
   real, intent(in), dimension(:,:) :: frac_land, u_star, b_star,  &
                                       q_star, rough, lat
logical, intent(in), dimension(:,:) :: convect       
   real, intent(in), dimension(:,:,:) :: tdtlw, p_half, p_full, &
                                         z_half, z_full, &
                                         u, v, t, q, um, vm, tm, qm, &
                                         udt, vdt, tdt, qdt
   real, intent(in) ,   dimension(:,:,:,:) :: r, rm, rdt
   real, intent(out),   dimension(:,:,:) :: diff_t, diff_m
   real, intent(out),   dimension(:,:)   :: gust, z_pbl 
   real, intent(in),optional, dimension(:,:,:) :: mask
integer, intent(in),optional, dimension(:,:) :: kbot
!-----------------------------------------------------------------------
real   , dimension(size(t,1),size(t,2),size(t,3))   :: ape, thv
logical, dimension(size(t,1),size(t,2),size(t,3)+1) :: lmask
real   , dimension(size(t,1),size(t,2),size(t,3)+1) :: el, diag3
real   , dimension(size(t,1),size(t,2),size(t,3)+1) :: tke
real   , dimension(size(t,1),size(t,2))             :: stbltop
real   , dimension(size(t,1),size(t,2))             :: el0, vspblcap
real   , dimension(size(diff_t,1),size(diff_t,2), &
                                  size(diff_t,3))   :: diff_sc,     &
                                                       diff_t_stab, &
                                                       diff_m_stab, &
       diff_t_entr, &
       diff_m_entr, &
       use_entr
real   , dimension(size(t,1),size(t,2),size(t,3))   :: tt, qq, uu, vv
real   , dimension(size(t,1),size(t,2),size(t,3))   :: qlin, qiin, qain
real    :: dt_tke
integer :: ie, je, nlev, sec, day, nt
logical :: used
!-->h1g, 2012-08-07
real   , dimension(size(diff_t,1),size(diff_t,2), &
                                  size(diff_t,3))   :: clubb_on,   &
                                                       stable_on,  &
                                                       stable_effective
!<--h1g, 2012-08-07 

!-----------------------------------------------------------------------
!----------------------- vertical turbulence ---------------------------
!-----------------------------------------------------------------------

      if (.not. module_is_initialized)  call error_mesg  &
                     ('vert_turb_driver in vert_turb_driver_mod',  &
                      'initialization has not been called', FATAL)

     nlev = size(p_full,3)
     ie = is + size(p_full,1) - 1
     je = js + size(p_full,2) - 1

!-----------------------------------------------------------------------
!---- set up state variable used by this module ----

      if (use_tau) then
      !-- variables at time tau
          uu = u
          vv = v
          tt = t
          qq = q
      else
      !-- variables at time tau+1
          uu = um + dt*udt
          vv = vm + dt*vdt
          tt = tm + dt*tdt
          qq = qm + dt*qdt
      endif

      !------ setup cloud variables: ql & qi & qa -----
      if (strat_cloud_on) then
           nt=size(r,4)
           if (nt == 0 .or. nt < max(nql,nqi,nqa))                    &
        call error_mesg ('vert_turb_driver',                  & 
                     'number of tracers less than nql or nqi or nqa', &
      FATAL) 
           if (use_tau) then
                qlin (:,:,:)=r(:,:,:,nql)
                qiin (:,:,:)=r(:,:,:,nqi)
                qain (:,:,:)=r(:,:,:,nqa)
           else
                qlin (:,:,:)=rm(:,:,:,nql)+rdt(:,:,:,nql)*dt
                qiin (:,:,:)=rm(:,:,:,nqi)+rdt(:,:,:,nqi)*dt
                qain (:,:,:)=rm(:,:,:,nqa)+rdt(:,:,:,nqa)*dt
           endif
      else
           qlin = 0.0
           qiin = 0.0
           qain = 0.0
      end if

!--------------------------------------------------------------------

!--------------------------------------------------------------------
! initialize output

   diff_t = 0.0
   diff_m = 0.0
   z_pbl = -999.0
   
!-------------------------------------------------------------------
! initiallize variables   
   vspblcap = 0.0   
   
!-----------------------------------------------------------------------
if (do_mellor_yamada) then

!    ----- virtual temp ----------
     ape(:,:,:)=(p_full(:,:,:)*p00inv)**(-kappa)
     if(do_simple) then 
       thv(:,:,:)=tt(:,:,:)*ape(:,:,:)
     else
       thv(:,:,:)=tt(:,:,:)*(qq(:,:,:)*d608+1.0)*ape(:,:,:)
     endif  
     if (present(mask)) where (mask < 0.5) thv = 200.

 endif

!---------------------------
 if (do_mellor_yamada) then
!---------------------------

!    ----- time step for prognostic tke calculation -----
     call get_time (Time_next-Time, sec, day)
     dt_tke = real(sec+day*86400)

!    --------------------- update tke-----------------------------------
!    ---- compute surface tke --------
!    ---- compute tke, master length scale (el0),  -------------
!    ---- length scale (el), and vert mix coeffs (diff_t,diff_m) ----

     call tke_surf  (is, js, u_star, kbot=kbot)



     if ( id_z_pbl > 0 ) then
     !------ compute pbl depth from k_profile if diagnostic needed -----
     call my25_turb (is, js, dt_tke, frac_land, p_half, p_full, thv, uu, vv, &
                     z_half, z_full, rough,   &
                     el0, el, diff_m, diff_t, &
                     mask=mask, kbot=kbot, &
                     ustar=u_star,bstar=b_star,h=z_pbl)
     else
     call my25_turb (is, js, dt_tke, frac_land, p_half, p_full, thv, uu, vv, &
                     z_half, z_full, rough,   &
                     el0, el, diff_m, diff_t, &
                     mask=mask, kbot=kbot)
     end if

!---------------------------
 else if (do_diffusivity) then
!--------------------------------------------------------------------
!----------- compute molecular diffusion, if desired  ---------------

    if (do_molecular_diffusion) then
      call molecular_diff (tt, p_half, diff_m, diff_t)
    else
      diff_m = 0.0
      diff_t = 0.0
    endif

!---------------------------
!------------------- non-local K scheme --------------


    call diffusivity ( tt, qq, uu, vv, p_full, p_half, z_full, z_half,   &
                       u_star, b_star, z_pbl, diff_m, diff_t, &
                       kbot = kbot)

!---------------------------
else if (do_edt) then
!----------------------------

!    ----- time step for prognostic tke calculation -----
      call get_time (Time_next-Time, sec, day)
      dt_tke = real(sec+day*86400)
 

      tke = 0.0

    call edt(is,ie,js,je,dt_tke,Time_next,tdtlw, u_star,b_star,q_star, &
             tt,qq,  &
             qlin,qiin,qain,uu,vv,z_full,p_full,z_half,p_half,stbltop, &
             diff_m,diff_t,z_pbl,kbot=kbot,tke=tke)


 endif
 


 
!------------------------------------------------------------------
! --- boundary layer entrainment parameterization

   if( do_entrain ) then

       call entrain(is,ie,js,je,Time_next,tdtlw, convect,u_star,b_star,&
                    tt,qq, &
            qlin,qiin,qain,uu,vv,z_full,p_full,z_half,p_half,diff_m,   &
    diff_t,diff_m_entr,diff_t_entr,use_entr,z_pbl,vspblcap,    &
    kbot=kbot)
   
   endif

!-----------------------------------------------------------------------
! --- stable boundary layer parameterization

! --> h1g, 2012-08-08, pre-set stable_on is 0
   stable_on = 0.0
   stable_effective = 0.0
! <-- h1g, 2012-08-08

   if( do_stable_bl ) then

        if (do_entrain) then

CALL STABLE_BL_TURB( is, js, Time_next, tt, qq, qlin, qiin, uu,&
                     vv, z_half, z_full, u_star, b_star, lat,  &
     diff_m_stab, diff_t_stab,                 &
     vspblcap = vspblcap, kbot=kbot)
     
            diff_m = use_entr*diff_m_entr + (1-use_entr)*diff_m_stab
            diff_t = use_entr*diff_t_entr + (1-use_entr)*diff_t_stab
    
            !for diagnostic purposes only, save the stable_bl_turb
            !coefficient only where it was used
    
            diff_m_stab = (1-use_entr)*diff_m_stab
            diff_t_stab = (1-use_entr)*diff_t_stab    
         
else

CALL STABLE_BL_TURB( is, js, Time_next, tt, qq, qlin, qiin, uu,&
                     vv, z_half, z_full, u_star, b_star, lat,  &
     diff_m_stab, diff_t_stab,kbot=kbot)
     
! --->h1g, 2012-07-16
     if(  do_clubb > 0 ) then
        clubb_on = 1.0
        where ( r(:,:,:, nwp2) <= wp2_min )
            where( diff_m_stab > diff_m .or. diff_t_stab > diff_t )
               stable_on = 1.0
               where( diff_m_stab >= diff_min .or. diff_t_stab >= diff_min )
                   stable_effective = 1.0
               endwhere
            endwhere
            diff_m = diff_m +  MAX( diff_m_stab - diff_m, 0.0 )
            diff_t = diff_t +  MAX( diff_t_stab - diff_t, 0.0 )
            clubb_on = 0.0
         endwhere
     else
        diff_m = diff_m +  MAX( diff_m_stab - diff_m, 0.0 )
        diff_t = diff_t +  MAX( diff_t_stab - diff_t, 0.0 )
     endif
! <---h1g, 2012-07-16

end if
        
    endif
   
!-----------------------------------------------------------------------
!------------------ shallow convection ???? ----------------------------

   if (do_shallow_conv) then
        call shallow_conv (tt, qq, p_full, p_half, diff_sc, kbot)
        diff_t = diff_t + diff_sc
   endif

!-----------------------------------------------------------------------
!------------- define gustiness ------------

     if ( trim(gust_scheme) == 'constant' ) then
          gust = constant_gust
     else if ( trim(gust_scheme) == 'beljaars' ) then
!    --- from Beljaars (1994) and Beljaars and Viterbo (1999) ---
          where (b_star > 0.)
             gust = gust_factor * (u_star*b_star*gust_zi)**(1./3.)
          elsewhere
             gust = 0.
          endwhere
     endif

!-----------------------------------------------------------------------
!------------------------ diagnostics section --------------------------

if (do_mellor_yamada) then

!     --- set up local mask for fields with surface data ---
      if ( present(mask) ) then
         lmask(:,:,1)        = .true.
         lmask(:,:,2:nlev+1) = mask(:,:,1:nlev) > 0.5
      else
         lmask = .true.
      endif

!------- tke --------------------------------
      if ( id_tke > 0 ) then
         call get_tke(is,ie,js,je,tke)
         used = send_data ( id_tke, tke, Time_next, is, js, 1, &
                            mask=lmask )
      endif

!------- length scale (at half levels) ------
      if ( id_lscale > 0 ) then
         used = send_data ( id_lscale, el, Time_next, is, js, 1,  &
                            mask=lmask )
      endif

!------- master length scale -------
      if ( id_lscale_0 > 0 ) then
         used = send_data ( id_lscale_0, el0, Time_next, is, js )
      endif

end if

if (do_edt) then 
    
!     --- set up local mask for fields with surface data ---
    if ( present(mask) ) then
          lmask(:,:,1)        = .true.
          lmask(:,:,2:nlev+1) = mask(:,:,1:nlev) > 0.5
     else   
        lmask = .true.
       endif

!------- tke --------------------------------
      if ( id_tke > 0 ) then
        used = send_data ( id_tke, tke, Time_next, is, js, 1,     &
                          mask=lmask )
      endif
 
end if

!------- boundary layer depth -------
      if ( id_z_pbl > 0 ) then
         used = send_data ( id_z_pbl, z_pbl, Time_next, is, js )
      endif

!------- gustiness -------
      if ( id_gust > 0 ) then
         used = send_data ( id_gust, gust, Time_next, is, js )
      endif


!------- output diffusion coefficients ---------

  if ( id_diff_t > 0 .or. id_diff_m > 0 .or. id_diff_sc > 0 .or. &
       id_diff_t_stab > 0 .or. id_diff_m_stab > 0 .or.           &
       id_diff_t_entr > 0 .or. id_diff_m_entr > 0  ) then
!       --- set up local mask for fields without surface data ---
        if (present(mask)) then
            lmask(:,:,1:nlev) = mask(:,:,1:nlev) > 0.5
            lmask(:,:,nlev+1) = .false.
        else
            lmask(:,:,1:nlev) = .true.
            lmask(:,:,nlev+1) = .false.
        endif
!       -- dummy data at surface --
        diag3(:,:,nlev+1)=0.0
  endif

!------- diffusion coefficient for heat/moisture -------
   if ( id_diff_t > 0 ) then
      diag3(:,:,1:nlev) = diff_t(:,:,1:nlev)
      used = send_data ( id_diff_t, diag3, Time_next, is, js, 1, mask=lmask )
   endif

!------- diffusion coefficient for momentum -------
   if ( id_diff_m > 0 ) then
      diag3(:,:,1:nlev) = diff_m(:,:,1:nlev)
      used = send_data ( id_diff_m, diag3, Time_next, is, js, 1, mask=lmask )
   endif

!------- diffusion coefficient for shallow conv -------
 if (do_shallow_conv) then
   if ( id_diff_sc > 0 ) then
      diag3(:,:,1:nlev) = diff_sc(:,:,1:nlev)
      used = send_data ( id_diff_sc, diag3, Time_next, is, js, 1, mask=lmask)
   endif
 endif

!------- diffusion coefficients for stable boudary layer -------
   if (do_stable_bl) then
!------- for heat/moisture -------
    if ( id_diff_t_stab > 0 ) then
       diag3(:,:,1:nlev) = diff_t_stab(:,:,1:nlev)
      used = send_data ( id_diff_t_stab, diag3, Time_next, is, js, 1, mask=lmask )
  endif
!------- for momentum -------
    if ( id_diff_m_stab > 0 ) then
       diag3(:,:,1:nlev) = diff_m_stab(:,:,1:nlev)
     used = send_data ( id_diff_m_stab, diag3, Time_next, is, js, 1, mask=lmask )
    endif

     if ( id_stable_on > 0 ) then
        used = send_data ( id_stable_on, stable_on, Time_next, is, js, 1, mask=lmask )
     endif

     if ( id_stable_effective > 0 ) then
        used = send_data ( id_stable_effective, stable_effective, Time_next, is, js, 1, mask=lmask )
     endif

 endif

!------- diffusion coefficients for entrainment module -------
 if (do_entrain) then
      if ( id_diff_t_entr > 0 ) then
       diag3(:,:,1:nlev) = diff_t_entr(:,:,1:nlev)
      used = send_data ( id_diff_t_entr, diag3, Time_next, is, js, 1, mask=lmask )
      endif
      if ( id_diff_m_entr > 0 ) then
       diag3(:,:,1:nlev) = diff_m_entr(:,:,1:nlev)
      used = send_data ( id_diff_m_entr, diag3, Time_next, is, js, 1, mask=lmask )
      endif
 endif

!--- geopotential height relative to the surface on full and half levels ----

   if ( id_z_half > 0 ) then
      !--- set up local mask for fields with surface data ---
      if ( present(mask) ) then
         lmask(:,:,1)        = .true.
         lmask(:,:,2:nlev+1) = mask(:,:,1:nlev) > 0.5
      else
         lmask = .true.
      endif
      used = send_data ( id_z_half, z_half, Time_next, is, js, 1, mask=lmask )
   endif
   
   if ( id_z_full > 0 ) then
      used = send_data ( id_z_full, z_full, Time_next, is, js, 1, rmask=mask)
   endif
   
!--- zonal and meridional wind on mass grid -------

   if ( id_uwnd > 0 ) then
      used = send_data ( id_uwnd, uu, Time_next, is, js, 1, rmask=mask)
   endif
  
   if ( id_vwnd > 0 ) then
      used = send_data ( id_vwnd, vv, Time_next, is, js, 1, rmask=mask)
   endif
  
! --->h1g, 2012-08-07, dump whether stable-scheme is on, clubb_on
   if( do_clubb > 0) then
     if ( id_clubb_on > 0 ) then
        used = send_data ( id_clubb_on, clubb_on, Time_next, is, js, 1, mask=lmask )
     endif
   endif
! <---h1g, 2012-08-07
   
!-----------------------------------------------------------------------

end subroutine vert_turb_driver

!#######################################################################

subroutine vert_turb_driver_init (lonb, latb, id, jd, kd, axes, Time, &
                                  doing_edt, doing_entrain, do_clubb_in)

!-----------------------------------------------------------------------
   real, dimension(:,:), intent(in) :: lonb, latb
   integer,         intent(in) :: id, jd, kd, axes(4)
   type(time_type), intent(in) :: Time
   logical,         intent(out) :: doing_edt, doing_entrain

!-->h1g
 integer, optional,    intent(in)    :: do_clubb_in
!<--h1g
!-----------------------------------------------------------------------
   integer, dimension(3) :: full = (/1,2,3/), half = (/1,2,4/)
   integer :: ierr, unit, io, logunit

      if (module_is_initialized)  &
          call error_mesg  &
                   ('vert_turb_driver_init in vert_turb_driver_mod',  &
                    'attempting to call initialization twice', FATAL)

!-----------------------------------------------------------------------
!--------------- read namelist ------------------

#ifdef INTERNAL_FILE_NML
   read (input_nml_file, nml=vert_turb_driver_nml, iostat=io)
   ierr = check_nml_error(io,'vert_turb_driver_nml')
#else   
      if (file_exist('input.nml')) then
         unit = open_namelist_file (file='input.nml')
         ierr=1; do while (ierr /= 0)
            read  (unit, nml=vert_turb_driver_nml, iostat=io, end=10)
            ierr = check_nml_error (io, 'vert_turb_driver_nml')
         enddo
  10     call close_file (unit)
      endif
#endif

!---------- output namelist --------------------------------------------

      logunit = stdlog()
      if ( mpp_pe() == mpp_root_pe() ) then
           call write_version_number(version, tagname)
           write (logunit,nml=vert_turb_driver_nml)
      endif

!     --- check namelist option ---
      if ( trim(gust_scheme) /= 'constant' .and. &
           trim(gust_scheme) /= 'beljaars' ) call error_mesg &
         ('vert_turb_driver_mod', 'invalid value for namelist '//&
          'variable GUST_SCHEME', FATAL)

      if (do_molecular_diffusion .and. do_mellor_yamada)  &
         call error_mesg ( 'vert_turb_driver_mod', 'cannot activate '//&
              'molecular diffusion with mellor_yamada', FATAL)
 
       if (do_molecular_diffusion .and. do_edt)  &
         call error_mesg ( 'vert_turb_driver_mod', 'cannot activate '//&
           'molecular diffusion with EDT', FATAL)

!-----------------------------------------------------------------------
! -->h1g, 2012-07-16
    if (present(do_clubb_in)) then
         do_clubb = do_clubb_in
    else
         do_clubb = 0
    endif
    
    if( do_entrain .and. do_clubb>0 ) &
         call error_mesg ( 'vert_turb_driver_mod', 'cannot activate '//&
           'both do_entrain and CLUBB', FATAL)
    nwp2 = get_tracer_index ( MODEL_ATMOS, 'wp2' )
!<--h1g, 2012-07-16

       if (strat_cloud_on) then
! get tracer indices for stratiform cloud variables
          nql = get_tracer_index ( MODEL_ATMOS, 'liq_wat' )
          nqi = get_tracer_index ( MODEL_ATMOS, 'ice_wat' )
          nqa = get_tracer_index ( MODEL_ATMOS, 'cld_amt' )
          if (mpp_pe() == mpp_root_pe()) &
                 write (logunit,'(a,3i4)') 'Stratiform cloud tracer indices: nql,nqi,nqa =',nql,nqi,nqa
          if (min(nql,nqi,nqa) <= 0) call error_mesg ('moist_processes', &
                         'stratiform cloud tracer(s) not found', FATAL)
          if (nql == nqi .or. nqa == nqi .or. nql == nqa) call error_mesg ('moist_processes',  &
       'tracers indices cannot be the same (i.e., nql=nqi=nqa).', FATAL)
      endif

!----------------------------------------------------------------------

      if (do_mellor_yamada) call my25_turb_init (id, jd, kd)

      if (do_shallow_conv)  call shallow_conv_init (kd)

      if (do_stable_bl)     call stable_bl_turb_init ( axes, Time )

      if (do_edt)           call edt_init (lonb, latb, axes,Time,id,jd,kd)

      if (do_entrain)       call entrain_init (lonb, latb, axes,Time,id,jd,kd)
      
!-----------------------------------------------------------------------
!----- initialize diagnostic fields -----

   id_uwnd = register_diag_field ( mod_name, 'uwnd', axes(full), Time, &
        'zonal wind on mass grid', 'meters/second' ,                   &
         missing_value=missing_value    )

   id_vwnd = register_diag_field ( mod_name, 'vwnd', axes(full), Time, &
        'meridional wind on mass grid', 'meters/second' ,              &
        missing_value=missing_value    )

   id_z_full = &
   register_diag_field ( mod_name, 'z_full', axes(full), Time,    &
        'geopotential height relative to surface at full levels', &
         'meters' , missing_value=missing_value    )

   id_z_half = &
   register_diag_field ( mod_name, 'z_half', axes(half), Time,    &
        'geopotential height relative to surface at half levels', &
        'meters' , missing_value=missing_value    )

if (do_mellor_yamada) then

   id_tke = &
   register_diag_field ( mod_name, 'tke', axes(half), Time,      &
                        'turbulent kinetic energy',  'm2/s2'   , &
                        missing_value=missing_value               )

   id_lscale = &
   register_diag_field ( mod_name, 'lscale', axes(half), Time,    &
                        'turbulent length scale',  'm'   ,        &
                        missing_value=missing_value               )

   id_lscale_0 = &
   register_diag_field ( mod_name, 'lscale_0', axes(1:2), Time,   &
                        'master length scale',  'm'               )
endif

 if (do_edt) then
 
   id_tke = &
   register_diag_field ( mod_name, 'tke', axes(half), Time,      &
                         'turbulent kinetic energy',  'm2/s2'   , &
                         missing_value=missing_value               )
 
  end if

   id_z_pbl = &
   register_diag_field ( mod_name, 'z_pbl', axes(1:2), Time,       &
                        'depth of planetary boundary layer',  'm'  )

   id_gust = &
   register_diag_field ( mod_name, 'gust', axes(1:2), Time,        &
                        'wind gustiness in surface layer',  'm/s'  )

   id_diff_t = &
   register_diag_field ( mod_name, 'diff_t', axes(half), Time,    &
                        'vert diff coeff for temp',  'm2/s'   ,   &
                        missing_value=missing_value               )

   id_diff_m = &
   register_diag_field ( mod_name, 'diff_m', axes(half), Time,      &
                        'vert diff coeff for momentum',  'm2/s'   , &
                        missing_value=missing_value               )

if (do_shallow_conv) then

   id_diff_sc = &
   register_diag_field ( mod_name, 'diff_sc', axes(half), Time,      &
                        'vert diff coeff for shallow conv', 'm2/s' , &
                        missing_value=missing_value               )
endif

if (do_stable_bl) then
  id_diff_t_stab = &
    register_diag_field ( mod_name, 'diff_t_stab', axes(half), Time,       &
                       'vert diff coeff for temp',  'm2/s',                &
                        missing_value=missing_value               )

  id_diff_m_stab = &
    register_diag_field ( mod_name, 'diff_m_stab', axes(half), Time,       &
                       'vert diff coeff for momentum',  'm2/s',            &
                       missing_value=missing_value               )

  id_stable_on = &
    register_diag_field ( mod_name, 'stable_on', axes(half), Time,       &
   'frequency of stable is on (diff_m_stab > diff_m  or diff_t_stab > diff_t)',  ' ', &
                        missing_value=missing_value               )

  id_stable_effective = &
    register_diag_field ( mod_name, 'stable_effective', axes(half), Time,       &
   'frequency of stable is effective (diff_m_stab > diff_m or diff_t_stab > diff_t and diff_m_stab > diff_min or diff_t_stab > diff_min)',  ' ', &
                        missing_value=missing_value               )

 endif


if (do_entrain) then
  id_diff_m_entr = &
    register_diag_field ( mod_name, 'diff_m_entr', axes(half), Time,        &
            'momentum vert diff coeff from entrainment module',  'm2/s',    &
                        missing_value=missing_value               )

  id_diff_t_entr = &
    register_diag_field ( mod_name, 'diff_t_entr', axes(half), Time,        &
            'heat vert diff coeff from entrainment module',  'm2/s',        &
                        missing_value=missing_value               )

 endif

! --->h1g, 2012-08-07, register id_clubb_on
if( do_clubb > 0 ) then
   id_clubb_on = &
    register_diag_field ( mod_name, 'clubb_on', axes(half), Time,       &
                       'frequency of clubb is on',  ' ',                &
                        missing_value=missing_value               )
endif
! <---h1g, 2012-08-07


!-----------------------------------------------------------------------

   doing_edt = do_edt
   doing_entrain = do_entrain
   module_is_initialized =.true.

!-----------------------------------------------------------------------

end subroutine vert_turb_driver_init


!#######################################################################

subroutine vert_turb_driver_end

!-----------------------------------------------------------------------
      if (do_mellor_yamada) call my25_turb_end
      if (do_edt) call edt_end
      if (do_entrain) call entrain_end
      module_is_initialized =.false.

!-----------------------------------------------------------------------

end subroutine vert_turb_driver_end

!#######################################################################
! <SUBROUTINE NAME="vert_turb_driver_restart">
!
! <DESCRIPTION>
! write out restart file.
! Arguments: 
!   timestamp (optional, intent(in)) : A character string that represents the model time, 
!                                      used for writing restart. timestamp will append to
!                                      the any restart file name as a prefix. 
! </DESCRIPTION>
!
subroutine vert_turb_driver_restart(timestamp)
  character(len=*), intent(in), optional :: timestamp

   if (do_mellor_yamada) call my25_turb_restart(timestamp)
end subroutine vert_turb_driver_restart
! </SUBROUTINE> NAME="vert_turb_driver_restart"


end module vert_turb_driver_mod

! module within MPP for handling PSETs:
! PSET: Persistent Shared-memory Execution Thread
!
! AUTHOR: V. Balaji (v.balaji@noaa.gov)
! DATE: 2006-01-15
#include <fms_platform.h>
#ifdef test_mpp_pset
!PSET_DEBUG is always turned on in the test program
#define PSET_DEBUG
#endif

module mpp_pset_mod
  use mpp_mod, only: mpp_pe, mpp_npes, mpp_root_pe, mpp_send, mpp_recv, &
       mpp_sync, mpp_error, FATAL, WARNING, stdout, stderr, mpp_chksum, &
       mpp_declare_pelist, mpp_get_current_pelist, mpp_set_current_pelist, &
       mpp_init, COMM_TAG_1, COMM_TAG_2, COMM_TAG_3, mpp_sync_self
  implicit none
  private

!private variables
  integer :: pe
  integer :: commID !MPI communicator, copy here from pset
  logical :: verbose=.FALSE.
  logical :: module_is_initialized=.FALSE.
  character(len=256) :: text
#ifdef use_SGI_GSM
#include <mpp/shmem.fh>
  integer :: pSync(SHMEM_BARRIER_SYNC_SIZE)
  pointer( p_pSync, pSync ) !used by SHPALLOC
#endif
!generic interfaces
  interface mpp_pset_broadcast_ptr
     module procedure mpp_pset_broadcast_ptr_scalar
     module procedure mpp_pset_broadcast_ptr_array
  end interface
  interface mpp_send_ptr
     module procedure mpp_send_ptr_scalar
     module procedure mpp_send_ptr_array
  end interface
  interface mpp_recv_ptr
     module procedure mpp_recv_ptr_scalar
     module procedure mpp_recv_ptr_array
  end interface
  interface mpp_pset_print_chksum
     module procedure mpp_pset_print_chksum_1D
     module procedure mpp_pset_print_chksum_2D
     module procedure mpp_pset_print_chksum_3D
     module procedure mpp_pset_print_chksum_4D
  end interface
!public type
  type :: mpp_pset_type
     private
#ifdef IBM_FIX
     sequence
#endif
     integer :: npset !number of PSETs
     integer :: next_in_pset, prev_in_pset !next and prev PE in PSET (cyclic)
     integer :: root_in_pset !PE designated to be the root within PSET
     logical :: root !true if you are the root PSET
     integer :: pos !position of current PE within pset
!stack is allocated by root
!it is then mapped to mpp_pset_stack by mpp_pset_broadcast_ptr
     real, _ALLOCATABLE :: stack(:) _NULL
     integer, _ALLOCATABLE :: pelist(:) _NULL !base PElist
     integer, _ALLOCATABLE :: root_pelist(:) _NULL !a PElist of all the roots
     integer, _ALLOCATABLE :: pset(:) _NULL !PSET IDs
     integer(POINTER_KIND) :: p_stack
     integer :: lstack, maxstack, hiWM !current stack length, max, hiWM
     integer :: commID
     character(len=32) :: name
     logical :: initialized=.FALSE.
  end type mpp_pset_type
!public types
  public :: mpp_pset_type
!public variables
!public member functions
  public :: mpp_pset_create, mpp_pset_sync, mpp_pset_broadcast, &
       mpp_pset_broadcast_ptr, mpp_pset_check_ptr, mpp_pset_segment_array, &
       mpp_pset_stack_push, mpp_pset_stack_reset, mpp_pset_print_chksum, &
       mpp_pset_delete, mpp_pset_root, mpp_pset_numroots, mpp_pset_init, &
       mpp_pset_get_root_pelist, mpp_pset_print_stack_chksum


contains
  subroutine mpp_pset_init
#ifdef use_SGI_GSM
    integer :: err
#ifdef sgi_mipspro
    character(len=8) :: value !won't be read
    integer :: lenname, lenval!won't be read
#endif
    if( module_is_initialized )return
!this part needs to be called _all_ PEs
    call SHMEM_BARRIER_ALL()
    call SHPALLOC( p_pSync, SHMEM_BARRIER_SYNC_SIZE, err, -1 )
    call SHMEM_BARRIER_ALL()
#ifdef sgi_mipspro
    call PXFGETENV( 'SMA_GLOBAL_ALLOC', 0, value, lenval, err )
    if( err.NE.0 )call mpp_error( FATAL, &
         'The environment variable SMA_GLOBAL_ALLOC must be set on Irix.' )
#endif
#endif
    module_is_initialized = .TRUE.
  end subroutine mpp_pset_init
  
  subroutine mpp_pset_create(npset,pset,stacksize,pelist, commID)
!create PSETs
!  called by all PEs in parent pelist
!  mpset must be exact divisor of npes
    integer, intent(in) :: npset !number of PSETs per set
    type(mpp_pset_type), intent(inout) :: pset
    integer, intent(in), optional :: stacksize
    integer, intent(in), optional :: pelist(:)
    integer, intent(in), optional :: commID

    integer :: npes, my_commID
    integer :: i, j, k, out_unit, errunit
    integer, allocatable :: my_pelist(:), root_pelist(:)

    call mpp_init()
    call mpp_pset_init()

#ifdef PSET_DEBUG
    verbose=.TRUE.
#endif
    out_unit = stdout()
    errunit  = stderr()
    pe = mpp_pe()
    if(present(pelist)) then
       npes = size(pelist(:))
    else
       npes = mpp_npes()
    endif
    if( mod(npes,npset).NE.0 )then
        write( text,'(a,2i6)' ) &
             'MPP_PSET_CREATE: PSET size (npset) must divide npes exactly:'// &
             ' npset, npes=', npset, npes
        call mpp_error( FATAL, text )
    end if

    !configure out root_pelist
    allocate(my_pelist(0:npes-1) )
    allocate(root_pelist(0:npes/npset-1) )
    if(present(pelist)) then
       if(.not. present(commID)) call mpp_error(FATAL, &
         'MPP_PSET_CREATE: when pelist is present, commID should also be present')
       my_pelist = pelist
       my_commID = commID
    else
       call mpp_get_current_pelist(my_pelist, commID = my_commID)
    endif
    do i = 0,npes/npset-1
       root_pelist(i) = my_pelist(npset*i)
    enddo
    write( out_unit,'(a,i6)' )'MPP_PSET_CREATE creating PSETs... npset=', npset
    if(ANY(my_pelist == pe) ) then
    if( pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_CREATE: PSET already initialized!' )     
    pset%npset = npset
    allocate( pset%pelist(0:npes-1) )
    allocate( pset%root_pelist(0:npes/npset-1) )
    pset%commID = my_commID
    pset%pelist = my_pelist
!create the root PElist
    pset%root_pelist = root_pelist
    allocate( pset%pset(0:npset-1) )
    do i = 0,npes/npset-1
       k = npset*i
!designate the root PE, next PE, prev PE
       do j = 0,npset-1
          if( pe.EQ.pset%pelist(k+j) )then
              pset%pset(:) =  pset%pelist(k:k+npset-1)
              pset%pos = j
              pset%root_in_pset = pset%root_pelist(i)
              if( j.EQ.0 )then
                  pset%prev_in_pset = pset%pelist(k+npset-1)
              else
                  pset%prev_in_pset = pset%pelist(k+j-1)
              end if
              if( j.EQ.npset-1 )then
                  pset%next_in_pset = pset%pelist(k)
              else
                  pset%next_in_pset = pset%pelist(k+j+1)
              end if
          end if
       end do
    end do

    pset%root = pe.EQ.pset%root_in_pset

!stack
    pset%hiWM = 0 !initialize hi-water-mark
    pset%maxstack = 1000000 !default
    if( PRESENT(stacksize) )pset%maxstack = stacksize
    write( out_unit,'(a,i8)' ) &
         'MPP_PSET_CREATE: setting stacksize=', pset%maxstack
    if( pset%root )then
        allocate( pset%stack(pset%maxstack) )
#ifdef use_CRI_pointers
        pset%p_stack = LOC(pset%stack)
#endif
    end if
    pset%initialized = .TRUE. !must be called before using pset
    call mpp_pset_broadcast_ptr(pset,pset%p_stack)
    endif

    call mpp_declare_pelist(root_pelist)

    if( verbose )then
        write( errunit,'(a,4i6)' )'MPP_PSET_CREATE: pe, root, next, prev=', &
             pe, pset%root_in_pset, pset%next_in_pset, pset%prev_in_pset
        write( errunit,* )'PE ', pe, ' pset=', pset%pset(:)
        write( out_unit,* )'root pelist=', pset%root_pelist(:)
    end if
  end subroutine mpp_pset_create

  subroutine mpp_pset_delete(pset)
    type(mpp_pset_type), intent(inout) :: pset
    integer :: out_unit

    out_unit = stdout()
    if( .NOT.pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_DELETE: called with uninitialized PSET.' )
!deallocate arrays...
    deallocate( pset%pelist )
    deallocate( pset%root_pelist )
    deallocate( pset%pset )
    if( pset%root )deallocate( pset%stack )
    write( out_unit, '(a,i10)' ) &
         'Deleting PSETs... stack high-water-mark=', pset%hiWM
!... and set status flag
    pset%initialized = .FALSE.
  end subroutine mpp_pset_delete

  subroutine mpp_send_ptr_scalar( ptr, pe )
    integer(POINTER_KIND), intent(in) :: ptr
    integer, intent(in) :: pe

!currently only wraps mpp_send
!on some architectures, mangling might occur
    call mpp_send( ptr, pe, tag=COMM_TAG_1 )
  end subroutine mpp_send_ptr_scalar

  subroutine mpp_send_ptr_array( ptr, pe )
    integer(POINTER_KIND), intent(in) :: ptr(:)
    integer, intent(in) :: pe

!currently only wraps mpp_send
!on some architectures, mangling might occur
    call mpp_send( ptr, size(ptr), pe, tag=COMM_TAG_2 )
  end subroutine mpp_send_ptr_array

  subroutine mpp_recv_ptr_scalar( ptr, pe )
    integer(POINTER_KIND), intent(inout) :: ptr
    integer, intent(in) :: pe

    call mpp_recv( ptr, pe, tag=COMM_TAG_1  )
    call mpp_translate_remote_ptr( ptr, pe )
    return
  end subroutine mpp_recv_ptr_scalar

  subroutine mpp_recv_ptr_array( ptr, pe )
    integer(POINTER_KIND), intent(inout) :: ptr(:)
    integer, intent(in) :: pe
    integer :: i

    call mpp_recv( ptr, size(ptr), pe, tag=COMM_TAG_2 )
    do i = 1, size(ptr)
       call mpp_translate_remote_ptr( ptr(i), pe )
    end do
    return
  end subroutine mpp_recv_ptr_array

  subroutine mpp_translate_remote_ptr( ptr, pe )
!modifies the received pointer to correct numerical address
    integer(POINTER_KIND), intent(inout) :: ptr
    integer, intent(in) :: pe
#ifdef use_SGI_GSM
!from the MPI_SGI_GLOBALPTR manpage
!            POINTER(global_ptr, global_addr)
!            INTEGER rem_rank, comm, ierror
!            INTEGER(KIND=MPI_ADDRESS_KIND) rem_addr, size, global_addr
!
!            CALL MPI_SGI_GLOBALPTR(rem_addr, size, rem_rank, comm, global_ptr, ierror)
    real :: dummy
    pointer( p, dummy )
    integer :: ierror
!length goes in the second argument to MPI_SGI_GLOBALPTR
!    according to Kim Mcmahon, this is only used to ensure the requested array
!    length is within the valid memory-mapped region. We do not have access to
!    the actual array length, so we are only going to set it to 1. This might
!    unexpectedly fail on some large model.
    integer(POINTER_KIND) :: length=1
#ifdef sgi_mipspro
    return !no translation needed on sgi_mipspro if SMA_GLOBAL_ALLOC is set
#endif
#ifdef use_libMPI
!the MPI communicator was stored in pset%commID
!since this routine doesn't take a pset argument, we let the caller store
!it in the module global variable commID (see broadcast_ptr and check_ptr)
    p = ptr
    call MPI_SGI_GLOBALPTR( dummy, length, pe, commID, ptr, ierror )
    if( ierror.EQ.-1 )call mpp_error( FATAL, &
         'MPP_TRANSLATE_REMOTE_PTR: unknown MPI_SGI_GLOBALPTR error.' )
#else
    call mpp_error( FATAL, &
         'MPP_TRANSLATE_REMOTE_PTR now only works under -Duse_libMPI' )
#endif
#endif
    return
  end subroutine mpp_translate_remote_ptr

  subroutine mpp_pset_sync(pset)
!this is a replacement for mpp_sync, doing syncs across
!shared arrays without calling mpp_sync
    type(mpp_pset_type), intent(in) :: pset

    if( .NOT.pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_SYNC: called with uninitialized PSET.' )
#ifdef use_SGI_GSM
!assumes npset contiguous PEs starting with root_in_pset
    call SHMEM_BARRIER( pset%root_in_pset, 0, pset%npset, pSync )
#else
!currently does mpp_sync!!! slow!!!
!try and make a lightweight pset sync
    call mpp_sync
#endif
  end subroutine mpp_pset_sync

  subroutine mpp_pset_broadcast(pset,a)
!broadcast value on the root to its sub-threads
    type(mpp_pset_type), intent(in) :: pset
    real, intent(inout) :: a
    integer :: i

    if( .NOT.pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_BROADCAST: called with uninitialized PSET.' )
    if( pset%root )then
        do i = 1,pset%npset-1
           call mpp_send( a, pset%pset(i), tag=COMM_TAG_3 )
        end do
    else
        call mpp_recv( a, pset%root_in_pset, tag=COMM_TAG_3 )
    end if
    call mpp_pset_sync(pset)
  end subroutine mpp_pset_broadcast

  subroutine mpp_pset_broadcast_ptr_scalar(pset,ptr)
!create a shared array by broadcasting pointer
!root allocates memory and passes pointer in
!on return all other PSETs will have the pointer to a shared object
    type(mpp_pset_type), intent(in) :: pset
    integer(POINTER_KIND), intent(inout) :: ptr
    integer :: i

    if( .NOT.pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_BROADCAST_PTR: called with uninitialized PSET.' )
    commID = pset%commID !pass to mpp_translate_remote_ptr
    if( pset%root )then
        do i = 1,pset%npset-1
           call mpp_send_ptr( ptr, pset%pset(i) )
        end do
    else
        call mpp_recv_ptr( ptr, pset%root_in_pset )
    end if
    call mpp_sync_self()
  end subroutine mpp_pset_broadcast_ptr_scalar

  subroutine mpp_pset_broadcast_ptr_array(pset,ptr)
!create a shared array by broadcasting pointer
!root allocates memory and passes pointer in
!on return all other PSETs will have the pointer to a shared object
    type(mpp_pset_type), intent(in) :: pset
    integer(POINTER_KIND), intent(inout) :: ptr(:)
    integer :: i

    if( .NOT.pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_BROADCAST_PTR: called with uninitialized PSET.' )
    commID = pset%commID !pass to mpp_translate_remote_ptr
    if( pset%root )then
        do i = 1,pset%npset-1
           call mpp_send_ptr( ptr, pset%pset(i) )
        end do
    else
        call mpp_recv_ptr( ptr, pset%root_in_pset )
    end if
    call mpp_sync_self()

  end subroutine mpp_pset_broadcast_ptr_array

  subroutine mpp_pset_check_ptr(pset,ptr)
!checks if the supplied pointer is indeed shared
    type(mpp_pset_type), intent(in) :: pset
#ifdef use_CRI_pointers
    real :: dummy
    pointer( ptr, dummy )
#else
    integer(POINTER_KIND), intent(in) :: ptr
#endif
#ifdef PSET_DEBUG
    integer(POINTER_KIND) :: p
    integer :: i
    if( .NOT.pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_CHECK_PTR: called with uninitialized PSET.' )
    commID = pset%commID !pass to mpp_translate_remote_ptr
!check if this is a shared pointer
    p = ptr
    if( pset%root )then
        do i = 1,pset%npset-1
           call mpp_send_ptr( p, pset%pset(i) )
        end do
    else
        call mpp_recv_ptr( p, pset%root_in_pset )
    end if
    call mpp_pset_sync(pset)
    if( p.NE.ptr )call mpp_error( FATAL, &
         'MPP_PSET_CHECK_PTR: pointers do not match!' )
#else
!do nothing if the debug CPP flag isn't on
#endif
  end subroutine mpp_pset_check_ptr

  subroutine mpp_pset_segment_array( pset, ls, le, lsp, lep )
!given input indices ls, le, returns indices lsp, lep
!so that segments span the range ls:le with no overlaps.
!attempts load balance: also some PSETs might get lsp>lep
!so that do-loops will be null
    type(mpp_pset_type), intent(in) :: pset
    integer, intent(in) :: ls, le
    integer, intent(out) :: lsp, lep
    integer :: i

    if( .NOT.pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_SEGMENT_ARRAY: called with uninitialized PSET.' )
#ifdef PSET_DEBUG
    if( le-ls+1.LT.pset%npset )then
        write( text,'(3(a,i6))' ) &
             'MPP_PSET_ARRAY_SEGMENT: parallel range (', ls, ',', le, &
             ') is smaller than the number of threads:', pset%npset
        call mpp_error( WARNING, text )
    end if
#endif
    lep = ls-1 !initialize so that lsp is correct on first pass
    do i = 0,pset%pos
       lsp = lep + 1
       lep = lsp + CEILING( REAL(le-lsp+1)/(pset%npset-i) ) - 1
    end do
  end subroutine mpp_pset_segment_array

  subroutine mpp_pset_stack_push( pset, ptr, len )
!mpp_malloc specialized for shared arrays
!len is the length of the required array
!lstack is the stack already in play
!user should zero lstack (call mpp_pset_stack_reset) when the stack is to be cleared
    type(mpp_pset_type), intent(inout) :: pset
    integer, intent(in) :: len
#ifdef use_CRI_pointers
    real :: dummy
    pointer( ptr, dummy )
    real :: stack(pset%maxstack)
    pointer( p, stack )

    if( .NOT.pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_STACK_PUSH: called with uninitialized PSET.' )
    if( pset%lstack+len.GT.pset%maxstack )then
        write( text, '(a,3i12)' ) &
             'MPP_PSET_STACK_PUSH: mpp_pset_stack overflow: '// &
             'len+lstack.GT.maxstack.  len, lstack, maxstack=', &
             len, pset%lstack, pset%maxstack
        call mpp_error( FATAL, text )
    end if
    p = pset%p_stack !point stack to shared stack pointer
    ptr = LOC( stack(pset%lstack+1) )
    call mpp_pset_check_ptr(pset,ptr) !make sure ptr is the same across PSETs
    pset%lstack = pset%lstack + len
    pset%hiWM = max( pset%hiWM, pset%lstack )
#else
    integer(POINTER_KIND), intent(out) :: ptr
    call mpp_error( FATAL, &
         'MPP_PSET_STACK_PUSH only works with Cray pointers.' )
#endif
  end subroutine mpp_pset_stack_push

  subroutine mpp_pset_stack_reset(pset)
    type(mpp_pset_type), intent(inout) :: pset
!reset stack... will reuse any temporary arrays! USE WITH CARE
!next few lines are to zero stack contents...
!but it's better noone tries to use uninitialized stack variables!
!    integer :: l1, l2
!    real :: mpp_pset_stack(maxstack)
!    pointer( p_mpp_pset_stack, mpp_pset_stack )
!    p_mpp_pset_stack = ptr_mpp_pset_stack
!    call mpp_pset_array_segment( 1, lstack, l1, l2 )
!    mpp_pset_stack(l1:l2) = 0.
    if( .NOT.pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_STACK_RESET: called with uninitialized PSET.' )
    pset%lstack = 0
  end subroutine mpp_pset_stack_reset

  subroutine mpp_pset_print_chksum_1D(pset, caller, array)
!print a checksum of an array
!pass the whole domain seen by root PSET
!add lines to check on shared array?
    type(mpp_pset_type), intent(in) :: pset
    character(len=*), intent(in) :: caller
    real, intent(in) :: array(:)
    integer          :: errunit

#ifdef PSET_DEBUG
    logical :: do_print
    integer(LONG_KIND) :: chksum

    if( .NOT.pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_PRINT_CHKSUM: called with uninitialized PSET.' )
    errunit = stderr()

    if( pset%root )then
        do_print = pe.EQ.mpp_root_pe() !set to T to print from all PEs
        call mpp_set_current_pelist(pset%root_pelist)
        chksum = mpp_chksum( array )
        if( do_print ) &
             write( errunit, '(a,z18)' )trim(caller)//' chksum=', chksum
    end if
    call mpp_set_current_pelist(pset%pelist)
#endif
    return
  end subroutine mpp_pset_print_chksum_1D

  subroutine mpp_pset_print_chksum_2D(pset, caller, array)
    type(mpp_pset_type), intent(in) :: pset
    character(len=*), intent(in) :: caller
    real, intent(in) :: array(:,:)
    real :: array1D( size(array) )
#ifdef use_CRI_pointers
    pointer( p, array1D )
    p = LOC(array)
#else
    array1D = TRANSFER( array, array1D )
#endif
    call mpp_pset_print_chksum(pset, caller, array1D)
  end subroutine mpp_pset_print_chksum_2D

  subroutine mpp_pset_print_chksum_3D(pset, caller, array)
    type(mpp_pset_type), intent(in) :: pset
    character(len=*), intent(in) :: caller
    real, intent(in) :: array(:,:,:) !overload for other ranks
    real :: array1D( size(array) )
#ifdef use_CRI_pointers
    pointer( p, array1D )
    p = LOC(array)
#else
    array1D = TRANSFER( array, array1D )
#endif
    call mpp_pset_print_chksum(pset, caller, array1D)
  end subroutine mpp_pset_print_chksum_3D

  subroutine mpp_pset_print_chksum_4D(pset, caller, array)
    type(mpp_pset_type), intent(in) :: pset
    character(len=*), intent(in) :: caller
    real, intent(in) :: array(:,:,:,:)
    real :: array1D( size(array) )
#ifdef use_CRI_pointers
    pointer( p, array1D )
    p = LOC(array)
#else
    array1D = TRANSFER( array, array1D )
#endif
    call mpp_pset_print_chksum(pset, caller, array1D)
  end subroutine mpp_pset_print_chksum_4D

  subroutine mpp_pset_print_stack_chksum( pset, caller )
    type(mpp_pset_type), intent(in) :: pset
    character(len=*), intent(in) :: caller

    if( .NOT.pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_PRINT_STACK_CHKSUM: called with uninitialized PSET.' )
    call mpp_pset_print_chksum( pset, trim(caller)//' stack', &
         pset%stack(1:pset%lstack) )
  end subroutine mpp_pset_print_stack_chksum

!accessor functions
  function mpp_pset_root(pset)
    logical :: mpp_pset_root
    type(mpp_pset_type), intent(in) :: pset

    if( .NOT.pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_ROOT: called with uninitialized PSET.' )
    mpp_pset_root = pset%root
  end function mpp_pset_root
  
  function mpp_pset_numroots(pset)
!necessary to export root_pelist: caller needs to pre-allocate
    integer :: mpp_pset_numroots
    type(mpp_pset_type), intent(in) :: pset

    if( .NOT.pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_NUMROOTS: called with uninitialized PSET.' )
    mpp_pset_numroots = size(pset%root_pelist)
  end function mpp_pset_numroots

  subroutine mpp_pset_get_root_pelist(pset,pelist,commID)
    type(mpp_pset_type), intent(in) :: pset
    integer, intent(out) :: pelist(:)
    integer, intent(out), optional :: commID

    if( .NOT.pset%initialized )call mpp_error( FATAL, &
         'MPP_PSET_GET_ROOT_PELIST: called with uninitialized PSET.' )
    if( size(pelist).NE.size(pset%root_pelist) )then
        write( text,'(a,2i6)' ) &
             'pelist argument has wrong size: requested, actual=', &
             size(pelist), size(pset%root_pelist)
        call mpp_error( FATAL, 'MPP_PSET_GET_ROOT_PELIST: '//text )
    end if
    pelist(:) = pset%root_pelist(:)
    if( PRESENT(commID) )then
#ifdef use_libMPI
        commID = pset%commID
#else
        call mpp_error( WARNING, &
             'MPP_PSET_GET_ROOT_PELIST: commID is only defined under -Duse_libMPI.' )
#endif
    end if
  end subroutine mpp_pset_get_root_pelist
  
end module mpp_pset_mod

!FDOC_TAG_GFDL
      module lhsw_driver_mod
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov">
!   fil
! </CONTACT>
! <REVIEWER EMAIL="">
!   
! </REVIEWER>
! <OVERVIEW>
!            lacis-hansen shortwave parameterization
!   
! </OVERVIEW>
! <DESCRIPTION>
!   
! </DESCRIPTION>
!

use rad_utilities_mod,     only: astronomy_type, &
                                 Sw_control, &
                                 atmos_input_type, &
                                 surface_type, &
                                 sw_output_type, &
                                 cld_space_properties_type, &
                                 radiative_gases_type, &
                                 cld_specification_type, &
                                 cldrad_properties_type
use  constants_mod,        only: GRAV, diffac, radcon, alogmin, wtmair
use        mpp_mod,        only: input_nml_file
use        fms_mod,        only: fms_init, open_namelist_file, file_exist, &
                                 check_nml_error, error_mesg, &  
                                 FATAL, close_file, mpp_pe, mpp_root_pe, &
                                 write_version_number, stdlog

!--------------------------------------------------------------------

implicit none
private


!--------------------------------------------------------------------
!            lacis-hansen shortwave parameterization
!
!------------------------------------------------------------------


!--------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------

    character(len=128)  :: version =  '$Id: lhsw_driver.F90,v 19.0 2012/01/06 20:17:29 fms Exp $'
    character(len=128)  :: tagname =  '$Name: tikal $'
    logical             :: module_is_initialized = .false.



!---------------------------------------------------------------------
!-------  interfaces --------
 
public  lhsw_driver_init, lhsw_driver_end, swrad

private convert_to_cloud_space


!-------------------------------------------------------------------
!-------- namelist ----------


real     :: dummy = 0.0
integer  :: nbands_to_use = 9
logical  :: calculate_o2_absorption = .false.

namelist /lhsw_driver_nml /         &
                            nbands_to_use, &
                            calculate_o2_absorption, &
                            dummy


!--------------------------------------------------------------------
!------ public data -------





!--------------------------------------------------------------------
!------ private data -------


!---------------------------------------------------------------------
!       abcff   = absorption coefficients for bands in k-distribution
!                 that were originally given by lacis and hansen and
!                 revised by ramaswamy.
!       pwts    = the corresponding weights assigned to the 
!                 shortwave radiation k-distribution.
!---------------------------------------------------------------------

!-------------------------------------------------------------------
!   absorption coefficients and weights for bands as revised by 
!   ramaswamy.
!-------------------------------------------------------------------

real, dimension(12)   :: abcff_12, pwts_12

data abcff_12 /4.0000E-05, 4.0000E-05, 0.0020E+00, 0.0350E+00,   &
               0.3770E+00, 1.9500E+00, 9.4000E+00, 4.4600E+01,   &
               1.9000E+02, 9.8900E+02, 2.7060E+03, 3.9011E+04/
  
data pwts_12 /0.50000E+00, 0.121416E+00, 0.06980E+00, 0.15580E+00, &
              0.06310E+00, 0.036200E+00, 0.02430E+00, 0.01580E+00,&
              0.00870E+00, 0.001467E+00, 0.23420E-02, 0.10750E-02/

!---------------------------------------------------------------------
!     the original 9-band lacis-hansen coefficients and weights.
!---------------------------------------------------------------------
 
real, dimension(9)    :: abcff_9, pwts_9

data abcff_9 /4.000E-05, 4.000E-05, 0.002E+00, 0.035E+00,  &
              0.377E-00, 1.950E+00, 9.400E+00, 4.460E+01,  &
              1.900E+02/

data pwts_9 /0.5000E+00, 0.1470E+00, 0.0698E+00, 0.1443E+00,  &
             0.0584E+00, 0.0335E+00, 0.0225E+00, 0.0158E+00, &
             0.0087E+00/

 
!--------------------------------------------------------------------
!   cfco2, cfo3 = conversion factors from gm/cm**2 to cm-atm (standard
!                 temperature and pressure).
!reflo3, rrayav = reflection coefficients given by lacis and hansen to 
!                 account for effects of rayleigh scattering in the 
!                 visible band one frequencies.         
!         prko2 = pressure (mb) below which o2 absorption affects short-
!                 wave transmissivities. 
!       efmago3 = ??????????
!--------------------------------------------------------------------
real           :: cfco2=5.0896E+02
real           :: cfo3=4.6664E+02
real           :: reflo3=1.9000E+00
real           :: rrayav=1.4400E-01
real           :: prko2=2.8
real           :: efmago3=1.900
!---------------------------------------------------------------------
 
integer        :: NB
integer        :: ixprko2


real, dimension(:), allocatable   :: abcff, pwts

real  :: wtmco2 = 44.00995
real  :: rco2air







!------------------------------------------------------------------
!------------------------------------------------------------------




contains


! <SUBROUTINE NAME="lhsw_driver_init">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call lhsw_driver_init ( pref )
!
!  </TEMPLATE>
!  <IN NAME="pref" TYPE="">
! 
!  </IN>
! </SUBROUTINE>
!
subroutine lhsw_driver_init ( pref )

real, dimension(:,:), intent(in) :: pref

      integer :: unit, ierr, io, logunit
      integer :: k, KSL, KEL, kmin, kmax

      real, dimension(size(pref,1) )  :: plm
      
      call fms_init

!---------------------------------------------------------------------
!-----  read namelist  ------

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, nml=lhsw_driver_nml, iostat=io)
      ierr = check_nml_error(io,'lhsw_driver_nml')
#else   
      if (file_exist('input.nml')) then
        unit =  open_namelist_file ()
        ierr=1; do while (ierr /= 0)
        read (unit, nml=lhsw_driver_nml, iostat=io, end=10)
        ierr = check_nml_error (io, 'lhsw_driver_nml')
        enddo
10      call close_file (unit)
      endif
#endif

      if ( mpp_pe() == mpp_root_pe() ) then
        call write_version_number(version, tagname)
        logunit = stdlog()
        write (logunit,nml=lhsw_driver_nml)
      endif

!---------------------------------------------------------------------
      KSL = 1
      KEL = size(pref, 1) - 1
      kmin = ksl
      kmax = kel
 
!     if (Environment%using_fms_periphs) then
      if (nbands_to_use == 9) then
         NB = 9
         allocate (abcff (9) )
         allocate (pwts  (9) )
        abcff(:) = abcff_9(:)
         pwts(:)  = pwts_9(:)
!     else if (Environment%using_sky_periphs) then
      else if (nbands_to_use == 12) then           
        NB = 12
        allocate (abcff (12) )
        allocate (pwts  (12) )
        abcff(:) = abcff_12(:)
        pwts(:)  = pwts_12(:)
      else
        call error_mesg ('lhsw_driver_mod', &
           ' nbands_to_use has improper value', FATAL)
      endif

!-------------------------------------------------------------------
!   convert pressure specification for bottom (flux) pressure level
!   for o2 calculation into an index (ixprko2)
!------------------------------------------------------------------- 

      plm (kmin) = 0.
     do k=kmin+1,kmax
         plm (k) = 0.5*(pref (k-1,1) + pref (k,1))
     enddo
      plm (kmax+1) = pref (kmax+1,1)
      ixprko2 = KSL 
      do k=KSL+1,KEL
        if ((plm(k)*1.0E-02 - prko2) .LT. 0.0) then
          ixprko2 = k + KSL - 1
        else
          exit
        endif
      enddo


      rco2air = wtmco2/wtmair

!------------------------------------------------------------------- 
      module_is_initialized = .true.
!------------------------------------------------------------------- 


end subroutine lhsw_driver_init


!######################################################################
! <SUBROUTINE NAME="lhsw_driver_end">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call lhsw_driver_end
!  </TEMPLATE>
! </SUBROUTINE>
!
subroutine lhsw_driver_end

!------------------------------------------------------------------- 
      module_is_initialized = .true.
!---------------------------------------------------------------------

end subroutine lhsw_driver_end




!######################################################################
 
! <SUBROUTINE NAME="swrad">
!  <OVERVIEW>
!     Swrad solves for shortwave radiation.
!
!     references:
!
!     (1)  lacis, a. a. and j. e. hansen, "a parameterization for the
!          absorption of solar radiation in the earth's atmosphere,"
!          journal of the atmospheric sciences, 31 (1974), 118-133.
!
!     author: m. d. schwarzkopf
!
!     revised: 1/1/93
!
!     certified:  radiation version 1.0
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call swrad ( is, ie, js, je,   &
!                Astro,                with_clouds,    Atmos_input,   &
!                Surface,  &
!                Rad_gases,                                   &
!                Cldrad_props, Cld_spec, Sw_output, Cldspace_rad, gwt)
!
!  </TEMPLATE>
!  <IN NAME=" is" TYPE="integer">
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <IN NAME="Astro" TYPE="astronomy_type">
! 
!  </IN>
!  <IN NAME="with_clouds" TYPE="logical">
! 
!  </IN>
!  <IN NAME="Atmos_input" TYPE="atmos_input_type">
! 
!  </IN>
!  <IN NAME="Surface" TYPE="surface_type">
! 
!  </IN>
!  <IN NAME="Rad_gases" TYPE="radiative_gases_type">
! 
!  </IN>
!  <IN NAME="Cldrad_props" TYPE="cldrad_properties_type">
! 
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
! 
!  </IN>
!  <INOUT NAME="Sw_output" TYPE="sw_output_type">
! 
!  </INOUT>
!  <INOUT NAME="Cldspace_rad" TYPE="cld_space_properties_type">
! 
!  </INOUT>
!  <IN NAME="gwt" TYPE="real">
! 
!  </IN>
! </SUBROUTINE>
!
subroutine swrad ( is, ie, js, je,   &
            Astro,                with_clouds,    Atmos_input,   &
             Surface,  &
            Rad_gases,                                   &
   Cldrad_props, Cld_spec, Sw_output, Cldspace_rad, gwt)
       
!-----------------------------------------------------------------------
!
!     Swrad solves for shortwave radiation.
!
!     references:
!
!     (1)  lacis, a. a. and j. e. hansen, "a parameterization for the
!          absorption of solar radiation in the earth's atmosphere," 
!          journal of the atmospheric sciences, 31 (1974), 118-133.
!
!     author: m. d. schwarzkopf
!
!     revised: 1/1/93
!
!     certified:  radiation version 1.0
!
!-----------------------------------------------------------------------
!     intent in:
!
!     fracday =  fraction of day (or timestep) that sun is above 
!                horizon.
! 
!     press   =  pressure at data levels of model.
!
!     qo3     =  mass mixing ratio of o3 at model data levels.
!
!     rh2o    =  mass mixing ratio of h2o at model data levels.
!
!     ssolar  =  solar constant (may vary over one year). units: Wm-2.
!
! cosangsolar =  zenith angle at grid point.
!-----------------------------------------------------------------------

integer,                  intent(in)     :: is, ie, js, je
logical,                  intent(in)     :: with_clouds
type(cldrad_properties_type), intent(in) :: Cldrad_props
type(cld_specification_type), intent(in) :: Cld_spec       
real, dimension(:), optional, intent(in) :: gwt
type(astronomy_type), intent(in) :: Astro
type(atmos_input_type), intent(in) :: Atmos_input
type(surface_type), intent(in) :: Surface
type(radiative_gases_type), intent(in) :: Rad_gases  

type(sw_output_type), intent(inout) :: Sw_output
type(cld_space_properties_type), intent(inout) :: Cldspace_rad

!-----------------------------------------------------------------------
!     intent out:
!
!     dfsw    =  downward radiation at all pressure levels.
!
!     fsw     =  net radiation (up-down) at all pressure levels.
!
!     hsw     =  radiation heating rates at all pressure layers.
!
!     ufsw    =  upward radiation at all pressure levels.
!-----------------------------------------------------------------------


!-----------------------------------------------------------------------
!     intent local:
!
!     absdo3  =  absorption of o3 down the atmosphere.
!
!     absuo3  =  absorption of o3 up the atmosphere.
!
!     alfa    =  effective reflective coefficient of a cloud and all
!                clouds below it.
! 
!     alfau   =  effective reflective coefficient excluding current
!                cloud.
!
!     cr      =  coefficient of reflection of a cloud.
!
!     ct      =  coefficient of transmission of a cloud.
!
!     dfn     =  downwards flux for current band n.
!
!     dfnclb  =  down flux at cloud bottom.
!
!     dfnclt  =  down flux at cloud top.
!
!     dfntop  =  down flux at atmosphere top. (in cgs units)
!
!     dfntrn  =  down flux partial product at cloud.
!
!     dp      =  derivative of pressure.
!
!     dpcldi  =  inverse of pressure difference between cloud top and
!                bottom.
!
!     du      =  delta optical path.
!
!     duco2   =  delta optical path for co2.
!
!     duo3    =  delta optical path for o3.
!
!     ff      =  angular optical factor.
!
!     ffco2   =  angular optical for co2.
!
!     ffo3    =  angular optical for o3.
!
!     pp      =  pressure.
!
!     ppbtm   =  pressure at bottom of cloud.
!
!     pptop   =  pressure at top of cloud.
!
!     pr2     =  normalized pressure.
!
!     refl    =  ground coefficent of reflection.
!
!     rray    =  parameterization for rayleigh scrattering.
!
!     secz    =  average secant of solar angle.
!
!     tdclbt  =  transmission down from cloud top to next cloud top
!
!     tdcltt  =  transmission down from cloud top to to next cloud top.
!
!     tdcltop =  transmission down at cloud top.
!
!     tdcltopi=  inverse of tdcltop.
!
!     tdclbtm =  transmission down at cloud bottom.
!
!     tdco2   =  transmission down co2.
!
!     ttd     =  transmission down h2o.
!
!     ttdb1   =  band one transmission quantity.
!
!     ttu     =  transmission up h2o.
!
!     ttub1   =  band one transmission quantity.
!
!     tuclbtm =  transmission up at cloud bottom.
!
!     tucltop =  transmission up at cloud top.
!
!     tucltop =  inverse of tucltop.
!
!     tuco2   =  transmission up co2.
!
!     ud      =  optical path down h2o.
!
!     udco2   =  optical path down co2.
!
!     udo3    =  optical path down o3.
!
!     ufn     =  upward flux for current band n.
!
!     ufnclb  =  upward flux at cloud bottom.
!
!     ufnclt  =  upward flux cloud top.
!
!     ufntrn  =  up flux partial product at cloud.
!
!     uu      =  optical path up h2o.
!
!     uuco2   =  optical path up co2.
!
!     uuo3    =  optical path up o3.
!
!     absdo2  =  absorption down o2.
!     udo2    =  optical path o2 (up-down).
!     uo2     =  optical path o2 (up-down).
!-----------------------------------------------------------------------
      real, dimension(:,:),   allocatable :: refl, rray, seczen
      real, dimension(:,:,:), allocatable ::   &
  absdo3,        absuo3,          alfa,   &
  alfau,         alogtt,          cr,       &
  ct,            dfn,             dfncltop, &
  dfnlbc,        dfntop,          dp,       &
  dpcldi,        du,              duco2,    &
  duo3,          ff,              ffco2,    &
  ffo3,          pp,              pptop,    &
  pr2,           tdcltt,          tdclbt,   &
  tdcltop,       tdclbtm,         tdco2,    &
  ttd,           ttdb1,           ttu,      &
  ttub1,         tucltop,         tuco2,    &
  ud,            udco2,           udo3,     &
  ufn,           ufncltop,        ufnlbc,   &
  uu,            uuco2,           uuo3,     &
  absdo2,        uo2,             dfswg,    &
  fswg,          hswg,            ufswg
     integer :: k,j,i,kc, kc1, nband, ko, ngp, kcldsw
     real    :: tempu, tempd
     real, dimension(:,:,:  ),  allocatable   :: cirabsw, cirrfsw, &
                  cvisrfsw
     real, dimension(:,:,:),    allocatable   :: camtsw
     integer, dimension(:,:),   allocatable   :: ncldsw            
     integer, dimension(:,:,:), allocatable   :: ktopsw, kbtmsw    

     integer :: israd, ierad, jsrad, jerad, ks, ke
     real    :: rrco2
     real :: rrvco2
     integer :: nsolwg=1
     real, dimension(size(Atmos_input%press,1),  &
                   size(Atmos_input%press,2),1) :: cosangsolar
     real, dimension(size(Atmos_input%press,1),  &
                   size(Atmos_input%press,2)  ) :: fracday, &
                               cirabgd, cvisrfgd_dir, cirrfgd_dir, &
                                  cvisrfgd_dif, cirrfgd_dif

     real, dimension(size(Atmos_input%press,1),   &
                size(Atmos_input%press,2), &
                      size(Atmos_input%press,3)) :: press     

     real, dimension(size(Atmos_input%press,1),   &
                size(Atmos_input%press,2), &
                      size(Atmos_input%press,3)-1) :: qo3, rh2o 

     real :: ssolar


     cosangsolar(:,:, 1) = Astro%cosz(:,:)
     fracday(:,:) = Astro%fracday(:,:)
!    cvisrfgd(:,:) = Surface%asfc(:,:)
!    cirrfgd(:,:) = Surface%asfc(:,:)
     cvisrfgd_dir(:,:) = Surface%asfc_vis_dir(:,:)
     cirrfgd_dir(:,:) = Surface%asfc_nir_dir(:,:)
     cvisrfgd_dif(:,:) = Surface%asfc_vis_dif(:,:)
     cirrfgd_dif(:,:) = Surface%asfc_nir_dif(:,:)    


! convert press to cgs.
      press(:,:,:) = 10.0*Atmos_input%press(:,:,:)
      rh2o (:,:,:) = Atmos_input%rh2o (:,:,:)
      qo3(:,:,:) = Rad_gases%qo3(:,:,:)
      rrvco2 = Rad_gases%rrvco2

      ssolar = Sw_control%solar_constant*Astro%rrsun

     israd = 1
     ierad = size(Atmos_input%press, 1)
     jsrad = 1
     jerad = size(Atmos_input%press,2)
     ks    = 1
     ke    = size(Atmos_input%press,3) - 1
    

!--------------------------------------------------------------------
!     allocate space for and then retrieve the number of clouds in 
!     in each model column.
!------------------------------------------------------------------
      allocate( ncldsw (ISRAD:IERAD, JSRAD:JERAD) )
      ncldsw(:,:) = Cld_spec%ncldsw(:,:)

!---------------------------------------------------------------------
!     define the maximum number of clouds in any column of the chunk
!     and the distribution of clouds with grid column to be used in 
!     this execution of the shortwave radiation code.
!---------------------------------------------------------------------
      if (with_clouds) then
        kcldsw = MAXVAL(ncldsw)
      else
        kcldsw = 0
        ncldsw(:,:) = 0
      endif

!--------------------------------------------------------------------
!     allocate space for and then retrieve the shortwave radiative 
!     cloud properties in each model column.
!------------------------------------------------------------------
      if (kcldsw /= 0) then
        allocate( camtsw (ISRAD:IERAD, JSRAD:JERAD, 1:kcldsw) )
        allocate( ktopsw (ISRAD:IERAD, JSRAD:JERAD, 1:kcldsw) )
        allocate( kbtmsw (ISRAD:IERAD, JSRAD:JERAD, 1:kcldsw+1) )
        allocate( cirabsw(ISRAD:IERAD, JSRAD:JERAD, 1:kcldsw        ) )
        allocate( cirrfsw(ISRAD:IERAD, JSRAD:JERAD, 1:kcldsw        ) )
        allocate( cvisrfsw(ISRAD:IERAD, JSRAD:JERAD,1:kcldsw        ) )
        camtsw   = 0.0
        ktopsw   = 0.0
        kbtmsw   = 0.0
        cirabsw  = 0.0
        cirrfsw  = 0.0
        cvisrfsw = 0.0
        call convert_to_cloud_space (is, ie, js, je,   Cldrad_props, &
           Cld_spec,      cirabsw, cirrfsw, cvisrfsw,  &
   ktopsw, kbtmsw, camtsw, Cldspace_rad)

!!! IS THIS NEEDED ???
!!! 1-13-03  : YES, YES, YES !!!!
      else if (with_clouds) then
!!!!! needed for radiation_diag_mod
       allocate ( Cldspace_rad%camtswkc(ie-is+1, je-js+1, 1 ))
       allocate ( Cldspace_rad%cirabswkc(ie-is+1, je-js+1, 1 ))
       allocate ( Cldspace_rad%cirrfswkc(ie-is+1, je-js+1, 1 ))
       allocate ( Cldspace_rad%cvisrfswkc(ie-is+1, je-js+1, 1 ))
       allocate ( Cldspace_rad%ktopswkc(ie-is+1, je-js+1,  1 ))
       allocate ( Cldspace_rad%kbtmswkc(ie-is+1, je-js+1,  1 ))
       Cldspace_rad%camtswkc = -99.0       
       Cldspace_rad%cirabswkc = -99.0       
       Cldspace_rad%cirrfswkc = -99.0       
       Cldspace_rad%cvisrfswkc = -99.0        
       Cldspace_rad%ktopswkc = -99.0      
       Cldspace_rad%kbtmswkc = -99.0         
      endif
  
!--------------------------------------------------------------------
!    allocate local arrays
!--------------------------------------------------------------------

      allocate( absdo3  (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( absuo3  (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( alfa    (ISRAD:IERAD, JSRAD:JERAD, kcldsw+1) )
      allocate( alfau   (ISRAD:IERAD, JSRAD:JERAD, kcldsw+1) )
      allocate( alogtt  (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( cr      (ISRAD:IERAD, JSRAD:JERAD, kcldsw+1) )
      allocate( ct      (ISRAD:IERAD, JSRAD:JERAD, kcldsw+1) )
      allocate( dfn     (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( dfncltop(ISRAD:IERAD, JSRAD:JERAD, kcldsw+1) )
      allocate( dfnlbc  (ISRAD:IERAD, JSRAD:JERAD, kcldsw+1) )
      allocate( dfntop  (ISRAD:IERAD, JSRAD:JERAD, NB) )
      allocate( dp      (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( dpcldi  (ISRAD:IERAD, JSRAD:JERAD, kcldsw) )
      allocate( du      (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( duco2   (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( duo3    (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( ff      (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( ffco2   (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( ffo3    (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( pp      (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( pptop   (ISRAD:IERAD, JSRAD:JERAD, kcldsw) )
      allocate( pr2     (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( refl    (ISRAD:IERAD, JSRAD:JERAD) )
      allocate( rray    (ISRAD:IERAD, JSRAD:JERAD) )
      allocate( seczen  (ISRAD:IERAD, JSRAD:JERAD) )
      allocate( tdcltt  (ISRAD:IERAD, JSRAD:JERAD, kcldsw  ))
      allocate( tdclbt  (ISRAD:IERAD, JSRAD:JERAD, kcldsw  ) ) 
      allocate( tdcltop (ISRAD:IERAD, JSRAD:JERAD, kcldsw+1) )
      allocate( tdclbtm (ISRAD:IERAD, JSRAD:JERAD, kcldsw+1) )
      allocate( tdco2   (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( ttd     (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( ttdb1   (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( ttu     (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( ttub1   (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( tucltop (ISRAD:IERAD, JSRAD:JERAD, kcldsw+1) )
      allocate( tuco2   (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( ud      (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( udco2   (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( udo3    (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( ufn     (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( ufncltop(ISRAD:IERAD, JSRAD:JERAD, kcldsw+1) )
      allocate( ufnlbc  (ISRAD:IERAD, JSRAD:JERAD, kcldsw+1) )
      allocate( uu      (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( uuco2   (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) ) 
      allocate( uuo3    (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )

      allocate( absdo2  (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      allocate( uo2     (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
      absdo3 = 0.0 ; absuo3   = 0.0 ; alfa     = 0.0 ; alfau    = 0.0
      alogtt   = 0.0 ; cr       = 0.0 ; ct       = 0.0 ; dfn      = 0.0
      dfncltop = 0.0 ; dfnlbc   = 0.0 ; dfntop   = 0.0 ; dp       = 0.0
      dpcldi   = 0.0 ; du       = 0.0 ; duco2    = 0.0 ; duo3     = 0.0
      ff       = 0.0 ; ffco2    = 0.0 ; ffo3     = 0.0 ; pp       = 0.0
      pptop    = 0.0 ; pr2      = 0.0 ; refl     = 0.0 ; rray     = 0.0
      seczen   = 0.0 ; tdcltt   = 0.0 ; tdclbt   = 0.0 ; tdcltop  = 0.0
      tdclbtm  = 0.0 ; tdco2    = 0.0 ; ttd      = 0.0 ; ttdb1    = 0.0
      ttu      = 0.0 ; ttub1    = 0.0 ; tucltop  = 0.0 ; tuco2    = 0.0
      ud       = 0.0 ; udco2    = 0.0 ; udo3     = 0.0 ; ufn      = 0.0
      ufncltop = 0.0 ; ufnlbc   = 0.0 ; uu       = 0.0 ; uuco2    = 0.0
      uuo3     = 0.0 ; absdo2   = 0.0 ; uo2      = 0.0

      if (present(gwt)) then
        allocate( dfswg   (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
        allocate( fswg    (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
        allocate( hswg    (ISRAD:IERAD, JSRAD:JERAD, KS:KE  ) )
        allocate( ufswg   (ISRAD:IERAD, JSRAD:JERAD, KS:KE+1) )
        dfswg = 0.0 ; fswg = 0.0 ; hswg =0.0  ; ufswg =0.0
      endif
!----------------------------------------------------------------------

    rrco2 = rrvco2*rco2air

    do ngp=1,nsolwg

!-----------------------------------------------------------------------
!     calculate secant of zenith angle seczen, flux pressures pp, layer
!     width dp, and pressure scaling factor pr2.  see reference (1).
!-----------------------------------------------------------------------

      seczen(:,:        ) = 3.5E+01/SQRT(1.224E+03*  &
    cosangsolar(:,:,ngp)*  &
                            cosangsolar(:,:,ngp) + 1.0E+00)
      pp    (:,:,KS     ) = 0.0E+00
      pp    (:,:,KE+1   ) = press(:,:,KE+1)
      pp    (:,:,KS+1:KE) = (press(:,:,KS+1:KE) + press(:,:,KS:KE-1))* &
                             0.5E+00
      dp    (:,:,KS:KE  ) = (pp(:,:,KS+1:KE+1) - pp(:,:,KS:KE  ))
      pr2   (:,:,KS:KE  ) = (pp(:,:,KS:KE  )+ pp(:,:,KS+1:KE+1))*0.5E+00
      do k=KS,KE
        pr2(:,:,k) = pr2(:,:,k)/press(:,:,KE+1)
      end do

!-----------------------------------------------------------------------
!     set up angular factor to be multiplied by the optical factor.
!     above the highest cloud, this is the secant of the zenith angle 
!     seczen (modified slightly for refractive effects).  below the 
!     highest cloud, this is diffac (efmago3 for ozone, in accordance 
!     with lacis-hansen parameterization).  this factor is used 
!     regardless of cloud amount and for direct and diffuse radiation 
!     (this is not a 2-1/2 stream model).
!-----------------------------------------------------------------------

      ff   (:,:,KS:KE+1) = diffac
      ffco2(:,:,KS:KE+1) = diffac
      ffo3 (:,:,KS:KE+1) = efmago3
      do j=JSRAD,JERAD
        do i=ISRAD,IERAD
  if (ncldsw(i,j) .NE. 0) then
            kc1=ktopsw(i,j,ncldsw(i,j))
  else
    kc1 = KE+1
  endif
          do kc=KS,kc1 
            ffo3 (i,j,kc) = seczen(i,j) 
            ffco2(i,j,kc) = seczen(i,j)
            ff   (i,j,kc) = seczen(i,j) 
          end do
        end do
      end do

!-----------------------------------------------------------------------
!     calculate pressure-weighted optical paths for each layer.
!     pressure weighting uses pr2.  du equals value for h2o; duco2 for
!     co2; duo3 for o3.
!-----------------------------------------------------------------------
      duo3 (:,:,KS:KE) = (cfo3/(1.0E+02*GRAV))*qo3(:,:,KS:KE)*dp(:,:,KS:KE)
      duco2(:,:,KS:KE) = (rrco2/(1.0E+02*GRAV)*cfco2)*dp(:,:,KS:KE)*  &
                          pr2(:,:,KS:KE)
      du   (:,:,KS:KE) = rh2o(:,:,KS:KE)*dp(:,:,KS:KE)* &
                          pr2(:,:,KS:KE)/(1.0E+02*GRAV)

!-----------------------------------------------------------------------
!     obtain the optical path from the top of the atmosphere to the
!     flux pressure.  angular factors are now included.  ud equals 
!     downward path for h2o, with uu the upward path for h2o. 
!     corresponding quantities for co2 and o3 are udco2/uuco2 and 
!     udo3/uuo3 respectively.
!-----------------------------------------------------------------------
      ud   (:,:,KS) = 0.0E+00 
      udco2(:,:,KS) = 0.0E+00
      udo3 (:,:,KS) = 0.0E+00
      do k=KS+1,KE+1
        ud   (:,:,k) = ud   (:,:,k-1) + du   (:,:,k-1)*ff   (:,:,k) 
        udco2(:,:,k) = udco2(:,:,k-1) + duco2(:,:,k-1)*ffco2(:,:,k)
        udo3 (:,:,k) = udo3 (:,:,k-1) + duo3 (:,:,k-1)*ffo3 (:,:,k) 
      end do
      uu   (:,:,KE+1) = ud   (:,:,KE+1) 
      uuco2(:,:,KE+1) = udco2(:,:,KE+1) 
      uuo3 (:,:,KE+1) = udo3 (:,:,KE+1)
      do k=KE,KS,-1
        uu   (:,:,k) = uu   (:,:,k+1) + du   (:,:,k)*diffac
        uuco2(:,:,k) = uuco2(:,:,k+1) + duco2(:,:,k)*diffac
        uuo3 (:,:,k) = uuo3 (:,:,k+1) + duo3 (:,:,k)*reflo3 
      end do

!-----------------------------------------------------------------------
!     for the skyhi model only, obtain the oxygen optical path, using
!     the o3 angular integration.
!-----------------------------------------------------------------------
      uo2(:,:,KS+1:ixprKO2) = pp(:,:,KS+1:ixprKO2)*    &
                              ffo3(:,:,KS+1:ixprKO2)

!-----------------------------------------------------------------------
!     calculate co2 absorptions.  they will be used in near infrared
!     bands.  since the absorption amount is given (in the formula used
!     below, derived from sasamori) in terms of the total solar flux,
!     and the absorption is only included in the near infrared 
!     (50 percent of the solar spectrum), the absorptions are multiplied
!     by two.
!-----------------------------------------------------------------------
      tdco2(:,:,KS:KE+1) =    &
!                     1.0E+00 - 2.0E+00*(2.35E-03* EXP(0.26E+00*ALOG( &
!                      (udco2(:,:,Ks   :Ke   +1) + &
!                     1.29E-02))) - 7.58265E-04)
                     1.0E+00 - 2.0E+00*(2.35E-03*(udco2(:,:,KS:KE+1) + &
                     1.29E-02)**2.6E-01 - 7.58265E-04)
      tuco2(:,:,KS:KE+1) =    &
!          1.0E+00 - 2.0E+00*(2.35E-03* EXP(0.26E+00*ALOG(  &
!                     (uuco2(:,:,Ks   :Ke   +1) +  &
!                     1.29E-02))) - 7.58265E-04)
                     1.0E+00 - 2.0E+00*(2.35E-03*(uuco2(:,:,KS:KE+1) + &
                     1.29E-02)**2.6E-01 - 7.58265E-04)

!-----------------------------------------------------------------------
!     now calculate ozone absorptions.  these will be used in the
!     visible band one.  just as in the co2 case, since this band is
!     50 percent of the solar spectrum, the absorptions are multiplied
!     by two.  see reference (1).
!-----------------------------------------------------------------------
       absdo3(:,:,KS:KE+1) =   &
!     &   2.0E+00*udo3(:,:,Ks :Ke   +1)*(1.082E+00*EXP(-.805E+00*ALOG( &
!     &    (1.0E+00 + 1.386E+02*udo3(:,:,Ks   :Ke   +1)))) + &
!     &    6.58E-02/(1.0E+00 + (1.036E+02)**3* &
!     &    udo3(:,:,Ks   :Ke   +1)**3) +  &
!     &    2.118E-02/(1.0E+00 + udo3(:,:,Ks   :Ke   +1)*(4.2E-02 + &
!     &    3.23E-04*   &
!     &    udo3(:,:,KS   :Ke   +1))))
          2.0E+00*udo3(:,:,KS:KE+1)*(1.082E+00*    &
          (1.0E+00 + 1.386E+02*udo3(:,:,KS:KE+1))**(-8.05E-01) +   &
          6.58E-02/(1.0E+00 + (1.036E+02)**3*udo3(:,:,KS:KE+1)**3) + &
          2.118E-02/(1.0E+00 + udo3(:,:,KS:KE+1)*(4.2E-02 + 3.23E-04* &
          udo3(:,:,KS:KE+1))))
       absuo3(:,:,KS:KE+1) =   &

!         2.0E+00*uuo3(:,:,Ks :Ke   +1)*(1.082E+00*EXP(-.805E+00*ALOG( &
!         (1.0E+00 + 1.386E+02*uuo3(:,:,Ks   :Ke   +1)))) +  &
!         6.58E-02/(1.0E+00 + (1.036E+02)**3*  &
!         uuo3(:,:,Ks   :Ke   +1)**3) +  &
!         2.118E-02/(1.0E+00 + uuo3(:,:,Ks   :Ke   +1)*(4.2E-02 + &
!         3.23E-04*   &
!         uuo3(:,:,Ks   :Ke   +1)))) 
          2.0E+00*uuo3(:,:,KS:KE+1)*(1.082E+00*  &
          (1.0E+00 + 1.386E+02*uuo3(:,:,KS:KE+1))**(-8.05E-01) + &
          6.58E-02/(1.0E+00 + (1.036E+02)**3*uuo3(:,:,KS:KE+1)**3) + &
          2.118E-02/(1.0E+00 + uuo3(:,:,KS:KE+1)*(4.2E-02 + 3.23E-04* &
          uuo3(:,:,KS:KE+1))))

!---------------------------------------------------------------------
!     calculate o2 absorptions (in visible band one).
!
!     formula is: abs=1.02E-05*uo2(k)**0.3795 for uo2 < 673.9057
!
!                 abs=4.51E-06*uo2(k)**0.5048 for uo2 > 673.9057
!
!     the absorption is constant below 35 km (level ixprKO2).
!---------------------------------------------------------------------
!   if (Environment%using_sky_periphs) then
    if (calculate_o2_absorption) then
      absdo2(:,:,KS) = 0.0E+00
      do ko=KS+1,ixprKO2
        do j=JSRAD,JERAD
          do i=ISRAD,IERAD
            if(uo2(i,j,ko) .LE. 6.739057E+02) then
!    absdo2(i,j,ko) = 1.02E-05*EXP(.3795E+00*ALOG(uo2(i,j,ko)))
               absdo2(i,j,ko) = 1.02E-05*uo2(i,j,ko)**0.3795E+00
            else
!    absdo2(i,j,ko) = 4.51E-06*EXP(.5048E+00*ALOG(uo2(i,j,ko)))
               absdo2(i,j,ko) = 4.51E-06*uo2(i,j,ko)**0.5048E+00
            endif
          end do
        end do
      end do

!-----------------------------------------------------------------------
!     add o2 absorption to o3 absorption.
!-----------------------------------------------------------------------
      do k=KS,KE+1
        if(k .LE. ixprKO2) then
          absdo3(:,:,k) = absdo3(:,:,k) + absdo2(:,:,k  )
        else
          absdo3(:,:,k) = absdo3(:,:,k) + absdo2(:,:,ixprKO2)
        endif
        absuo3(:,:,k) = absuo3(:,:,k) + absdo2(:,:,ixprKO2)
      end do
    endif

!-----------------------------------------------------------------------
!     computations for bands have been divided into: band one, band two,
!     and band three through NB.  begin by calculating flux entering
!     at the top for each band.
!-----------------------------------------------------------------------
      do nband=1,NB
        dfntop(:,:,nband) = ssolar*1.0E+03*cosangsolar(:,:,ngp)*   &
                                fracday(:,:)*pwts(nband)
      end do

!-----------------------------------------------------------------------
!     initialize dfsw and ufsw for the bands.
!-----------------------------------------------------------------------
      if (present(gwt)) then
        dfswg(:,:,KS:KE+1) = 0.0E+00
        ufswg(:,:,KS:KE+1) = 0.0E+00
      endif

!-----------------------------------------------------------------------
!     execute the reflectivity parameterization for the visible band 
!     one.  see reference (1)
!-----------------------------------------------------------------------
      rray(:,:) = 2.19E-01/(1.0E+00 + 8.16E-01*cosangsolar(:,:,ngp))
!! WHAT TO DO HERE ?
!!  USING ONLY DIR ALBEDOES IN THIS SCHEME - the totals will be assigned
!!  to _dir and the _dif fluxes will remain zero, pending a better
!! assignment ??     
      refl(:,:) = rray(:,:) + (1.0E+00 - rray(:,:))*(1.0E+00 -    &
!                 rrayav)*cvisrfgd(:,:)/(1.0E+00 - cvisrfgd(:,:  )* &
             rrayav)*cvisrfgd_dir(:,:)/(1.0E+00 - cvisrfgd_dir(:,:)* &
                  rrayav)

!-----------------------------------------------------------------------
!     where clouds exist.
!-----------------------------------------------------------------------
      if(kcldsw .NE. 0) then
!-----------------------------------------------------------------------
!     the first cloud is the ground; its properties are given by refl. 
!     the transmission ct(:,:,1) is irrelevant for now.
!-----------------------------------------------------------------------
        cr(:,:,1) = refl(:,:)
!-----------------------------------------------------------------------
!     obtain cloud reflection and transmission coefficients for
!     remaining clouds in the visible band one.  the maximum number of 
!     clouds kcldsw is used.  this creates extra work and may be removed
!     in a subsequent update.
!-----------------------------------------------------------------------
        cr(:,:,2:kcldsw+1) = cvisrfsw(:,:,1:kcldsw    )*   &
      camtsw(:,:,1:kcldsw)
        ct(:,:,2:kcldsw+1) = 1.0E+00 - cr(:,:,2:kcldsw+1)
      end if

!-----------------------------------------------------------------------
!     begin computations for visible band one, near infrared band two,
!     and near infrared bands three thru NB.
!-----------------------------------------------------------------------
      do nband=1,NB
!-----------------------------------------------------------------------
!     calculations for visible band one which includes o3, o2, and 
!     (negligible) h2o absorption.
!-----------------------------------------------------------------------
        if(nband .EQ. 1) then
          alogtt(:,:,KS:KE+1) = -abcff(1)*ud(:,:,KS:KE+1)
          ttdb1 (:,:,KS:KE+1) = EXP(MAX(alogmin, alogtt(:,:,KS:KE+1)))
          ttd   (:,:,KS:KE+1) = ttdb1 (:,:,KS:KE+1)*(1.0E+00 -   &
                                absdo3(:,:,KS:KE+1))
          alogtt(:,:,KS:KE+1) = -abcff(1)*uu(:,:,KS:KE+1)
          ttub1 (:,:,KS:KE+1) = EXP(MAX(alogmin, alogtt(:,:,KS:KE+1)))
          ttu   (:,:,KS:KE+1) = ttub1 (:,:,KS:KE+1)*(1.0E+00 -   &
                                absuo3(:,:,KS:KE+1))

!-----------------------------------------------------------------------
!     calculations for the near infrared band two where the water vapor
!     transmission function ttdb1 and ttub1 for band two is equal to
!     that of band one.
!-----------------------------------------------------------------------
else if(nband .EQ. 2) then
          alogtt(:,:,KS:KE+1) = -abcff(1)*ud(:,:,KS:KE+1)
          ttdb1 (:,:,KS:KE+1) = EXP(MAX(alogmin,alogtt(:,:,KS:KE+1)))
          ttd   (:,:,KS:KE+1) = ttdb1(:,:,KS:KE+1)*tdco2(:,:,KS:KE+1)
          alogtt(:,:,KS:KE+1) = -abcff(1)*uu(:,:,KS:KE+1)
          ttub1 (:,:,KS:KE+1) = EXP(MAX(alogmin,alogtt(:,:,KS:KE+1)))
          ttu   (:,:,KS:KE+1) = ttub1(:,:,KS:KE+1)*tuco2(:,:,KS:KE+1)

!-----------------------------------------------------------------------
!     calculate water vapor transmission functions for near infrared
!     bands.  include co2 transmission tdco2/tuco2, which is the
!     same for all infrared bands.
!-----------------------------------------------------------------------
else if(nband .GE. 3) then
          alogtt(:,:,KS:KE+1) = -abcff(nband)*ud(:,:,KS:KE+1)
          ttd   (:,:,KS:KE+1) = EXP(MAX(alogmin,alogtt(:,:,KS:KE+1)))* &
                                tdco2(:,:,KS:KE+1)
          alogtt(:,:,KS:KE+1) = -abcff(nband)*uu(:,:,KS:KE+1)
          ttu   (:,:,KS:KE+1) = EXP(MAX(alogmin,alogtt(:,:,KS:KE+1)))* &
                                tuco2(:,:,KS:KE+1)
        endif

!-----------------------------------------------------------------------
!     at this point, include ttd(KS), ttu(KE+1), noting that ttd(KS)=1 
!     for all bands, and that ttu(KE+1)=ttd(KE+1) for all bands.
!-----------------------------------------------------------------------
        ttd(:,:,KS  ) = 1.0E+00
        ttu(:,:,KE+1) = ttd(:,:,KE+1)
!-----------------------------------------------------------------------
!     where no clouds exist.
!-----------------------------------------------------------------------
        if (kcldsw .EQ. 0) then
          if(nband .EQ. 1) then
            do k=KS,KE+1
              ufn(:,:,k) = refl(:,:)*ttu(:,:,k)
              dfn(:,:,k) = ttd(:,:,k)
            end do
          else
            do k=KS,KE+1
!             ufn(:,:,k) = cirrfgd(:,:)*ttu(:,:,k)
!! WHAT TO DO HERE ?
!!  USING ONLY DIR ALBEDOES IN THIS SCHEME - the totals will be assigned
!!  to _dir and the _dif fluxes will remain zero, pending a better
!! assignment ??
              ufn(:,:,k) = cirrfgd_dir(:,:)*ttu(:,:,k)
              dfn(:,:,k) = ttd(:,:,k)
            end do      
          endif
!-----------------------------------------------------------------------
!     where clouds exist.
!-----------------------------------------------------------------------
        else
!-----------------------------------------------------------------------
!     for execution of the cloud loop, it is necessary to separate the
!     transmission functions at the top and bottom of the clouds, for
!     each band.  the required quantities are:
!
!       ttd(:,:,ktopsw(:,:,kc),nband) kc=1,ncldsw(:,:)+1 
!       ttd(:,:,kbtmsw(:,:,kc),nband) kc=1,ncldsw(:,:)+1 
!       ttu(:,:,ktopsw(:,:,kc),nband) kc=1,ncldsw(:,:)+1.
!
!     the above quantities are stored in tdcltop, tdclbtm, and tucltop 
!     respectively, as they have multiple use in the program.
!-----------------------------------------------------------------------
 
!-----------------------------------------------------------------------
!     for first cloud layer (i.e. the ground) tdcltop and tucltop are
!     known.
!-----------------------------------------------------------------------
          tdcltop (:,:,1) = ttd    (:,:,KE+1)
          tucltop (:,:,1) = ttu    (:,:,KE+1)
          tdclbtm (:,:,1) = tdcltop(:,:,1 )

!-----------------------------------------------------------------------
!     use gathers for remaining ones.
!-----------------------------------------------------------------------
              do kc=1,kcldsw
          do j=JSRAD,JERAD
            do i=ISRAD,IERAD
                tdcltop(i,j,kc+1) = ttd(i,j,ktopsw(i,j,kc))
                tucltop(i,j,kc+1) = ttu(i,j,ktopsw(i,j,kc))
                tdclbtm(i,j,kc+1) = ttd(i,j,kbtmsw(i,j,kc))
              end do
            end do
          end do
!-----------------------------------------------------------------------
!     compute the transmissivity from the top of cloud kc+1 to the top
!     of cloud kc.  the cloud transmission ct is included.  this
!     quantity is called tdclbt(kc)-transmission down cloud bottom-top.
!     also, obtain the transmissivity from the bottom of cloud kc+1
!     to the top of cloud kc (a path entirely outside clouds).  this
!     quantity is called tdcltt(kc)-transmission down cloud top-top.
!-----------------------------------------------------------------------
          tdclbt(:,:,1:kcldsw) = tdcltop(:,:,1:kcldsw)/  &
                              tdcltop(:,:,2:kcldsw+1)*ct(:,:,2:kcldsw+1)
          tdcltt(:,:,1:kcldsw) = tdcltop(:,:,1:kcldsw)/   &
                              tdclbtm(:,:,2:kcldsw+1)

!-----------------------------------------------------------------------
!     the following is the recursion relation for alfa. the reflection
!     coefficient for a system including the cloud in question and the
!     flux coming out of the cloud system including all clouds below
!     the cloud in question.
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!     alfau is alfa without the reflection of the cloud in question.
!----------------------------------------------------------------------!
          alfa (:,:,1) = cr(:,:,1)
          alfau(:,:,1) = 0.0E+00
          do kc=1,kcldsw
!-----------------------------------------------------------------------
!     excessive calculations.
!-----------------------------------------------------------------------
            alfau(:,:,kc+1) = (tdclbt(:,:,kc)**2)*alfa(:,:,kc)/ &
                            (1.0E+00 - (tdcltt(:,:,kc)**2)* &
                            alfa(:,:,kc)*cr(:,:,kc+1))
            alfa (:,:,kc+1) = alfau(:,:,kc+1) + cr(:,:,kc+1)
          end do
!-----------------------------------------------------------------------
!     the following calculation is done for visible band one case only.
!     obtain the pressure at the top, bottom and the thickness of thick 
!     clouds (those at least 2 layers thick).  this is used later is 
!     obtaining fluxes inside the thick clouds, for all frequency bands.
!-----------------------------------------------------------------------
          if(nband .EQ. 1) then
            do kc=1,kcldsw
              do j=JSRAD,JERAD
                do i=ISRAD,IERAD
                  if(ktopsw(i,j,kc  ) .NE. KS) then 
                  if((kbtmsw(i,j,kc  ) - ktopsw(i,j,kc  )) .GT. 1) then
                      pptop (i,j,kc) = pp(i,j,ktopsw(i,j,kc  )) 
                      dpcldi(i,j,kc) = 1.0E+00/(pptop(i,j,kc) -  &
                                       pp(i,j,kbtmsw(i,j,kc  )))
                    endif
                  endif
                end do
              end do
            end do
!! define this as zero -- could at some point be an input ??
            cirabgd(:,:) = 0.0
!! WHAT TO DO HERE ?
!!  USING ONLY DIR ALBEDOES IN THIS SCHEME - the totals will be assigned
!!  to _dir and the _dif fluxes will remain zero, pending a better
!! assignment ??
!           cr(:,:,1) = cirrfgd(:,:)
!           ct(:,:,1) = 1.0E+00 - (cirrfgd(:,:) + cirabgd(:,:))
            cr(:,:,1) = cirrfgd_dir(:,:)
            ct(:,:,1) = 1.0E+00 - (cirrfgd_dir(:,:) + cirabgd(:,:))
            cr(:,:,2:kcldsw+1) = cirrfsw(:,:,1:kcldsw    )*  &
                                 camtsw(:,:,1:kcldsw)
            ct(:,:,2:kcldsw+1) = 1.0E+00 - camtsw(:,:,1:kcldsw  )*  &
                                 (cirrfsw(:,:,1:kcldsw      ) +    &
                                  cirabsw(:,:,1:kcldsw      ))
          endif

!-----------------------------------------------------------------------
!     calculate ufn at cloud tops and dfn at cloud bottoms note that 
!     ufncltop(:,:,kcldsw+1) gives the upward flux at the top of the 
!     highest real cloud (if ncldsw(:,:)=kcldsw).  it gives the flux at 
!     the top of the atmosphere if ncldsw(:,:) < kcldsw.  it the first 
!     case, tdcltop equals the transmission function to the top of the 
!     highest cloud, as we want.  in the second case, tdcltop=1, so
!     ufncltop equals alfa. this is also correct.
!-----------------------------------------------------------------------
          ufncltop(:,:,kcldsw+1) = alfa(:,:,kcldsw+1)*   &
                                   tdcltop(:,:,kcldsw+1)
          dfncltop(:,:,kcldsw+1) = tdcltop(:,:,kcldsw+1)
!-----------------------------------------------------------------------
!     this calculation is the reverse of the recursion relation used
!     above.
!-----------------------------------------------------------------------
          do kc=kcldsw,1,-1
            ufncltop(:,:,kc) = ((ufncltop(:,:,kc+1)*alfau(:,:,kc+1))/ &
                               alfa(:,:,kc+1))/tdclbt(:,:,kc)
            dfncltop(:,:,kc) = ufncltop(:,:,kc)/alfa (:,:,kc)
          end do

!-----------------------------------------------------------------------
!     now obtain dfn and ufn for levels between the clouds.
!-----------------------------------------------------------------------
          ufnlbc(:,:,1:kcldsw+1) = ufncltop(:,:,1:kcldsw+1)/  &
                                   tucltop (:,:,1:kcldsw+1)
          dfnlbc(:,:,1:kcldsw+1) = dfncltop(:,:,1:kcldsw+1)/  &
                                   tdcltop (:,:,1:kcldsw+1)
!-----------------------------------------------------------------------
!     case of kc=1 (from the ground to the bottom of the lowest cloud).
!-----------------------------------------------------------------------
          do j=JSRAD,JERAD
            do i=ISRAD,IERAD
              do k=kbtmsw(i,j,1),KE+1
                ufn(i,j,k) = ufnlbc(i,j,1)*ttu(i,j,k)
                dfn(i,j,k) = dfnlbc(i,j,1)*ttd(i,j,k)
              end do
            end do
          end do
!-----------------------------------------------------------------------
!     remaining levels.
!-----------------------------------------------------------------------
            do j=JSRAD,JERAD
              do i=ISRAD,IERAD
do kc=1,ncldsw(i,j)
                  do k=kbtmsw(i,j,kc+1),ktopsw(i,j,kc  )
                    ufn(i,j,k) = ufnlbc(i,j,kc+1)*ttu(i,j,k) 
                    dfn(i,j,k) = dfnlbc(i,j,kc+1)*ttd(i,j,k)
                  end do
!-----------------------------------------------------------------------
!     for the thick clouds, the flux divergence through the cloud layer
!     is assumed to be constant.  the flux derivative is given by
!     tempu (for the upward flux) and tempd (for the downward flux).
!-----------------------------------------------------------------------
                  if((kbtmsw(i,j,kc  ) - ktopsw(i,j,kc  )) .GT. 1) then
               tempu=(ufncltop(i,j,kc+1) - ufn(i,j,kbtmsw(i,j,kc  )))*&
                           dpcldi(i,j,kc  )
                tempd=(dfncltop(i,j,kc+1) - dfn(i,j,kbtmsw(i,j,kc  )))*&
                           dpcldi(i,j,kc  )
                    do k=ktopsw(i,j,kc  )+1,kbtmsw(i,j,kc  )-1
                      ufn(i,j,k) = ufncltop(i,j,kc+1) +   &
                                   tempu*(pp(i,j,k) - pptop(i,j,kc  ))
                      dfn(i,j,k) = dfncltop(i,j,kc+1) +   &
                                   tempd*(pp(i,j,k) - pptop(i,j,kc  ))
                    end do
                  endif
              end do
            end do
          end do
        endif  ! (end of kcldsw loop)

!-----------------------------------------------------------------------
!     scale the previously computed fluxes by the flux at the top of the
!     atmosphere.
!-----------------------------------------------------------------------
        do k=KS,KE+1
          dfn(:,:,k) = dfn(:,:,k)*dfntop(:,:,nband)
          ufn(:,:,k) = ufn(:,:,k)*dfntop(:,:,nband)
        end do

!-----------------------------------------------------------------------
!     sum over bands.
!-----------------------------------------------------------------------
        if (present(gwt)) then
          dfswg(:,:,KS:KE+1) = dfswg(:,:,KS:KE+1) + dfn(:,:,KS:KE+1)
          ufswg(:,:,KS:KE+1) = ufswg(:,:,KS:KE+1) + ufn(:,:,KS:KE+1)
        else
           if (with_clouds) then
          Sw_output%dfsw (:,:,KS:KE+1,1) = Sw_output%dfsw (:,:,KS:KE+1,1) + dfn(:,:,KS:KE+1)
          Sw_output%ufsw (:,:,KS:KE+1,1) = Sw_output%ufsw (:,:,KS:KE+1,1) + ufn(:,:,KS:KE+1)
  else
          Sw_output%dfswcf (:,:,KS:KE+1,1) = Sw_output%dfswcf (:,:,KS:KE+1,1) + dfn(:,:,KS:KE+1)
          Sw_output%ufswcf (:,:,KS:KE+1,1) = Sw_output%ufswcf (:,:,KS:KE+1,1) + ufn(:,:,KS:KE+1)
  endif
        endif
      end do

!-----------------------------------------------------------------------
!     obtain the net flux and the shortwave heating rate for all bands.
!-----------------------------------------------------------------------
      if (present(gwt)) then
        fswg(:,:,KS:KE+1) = ufswg(:,:,KS:KE+1) - dfswg(:,:,KS:KE+1)
        hswg(:,:,KS:KE  ) = radcon*(fswg(:,:,KS+1:KE+1) -    &
      fswg(:,:,KS:KE))/dp(:,:,KS:KE)
      else
if (with_clouds) then
        Sw_output%fsw (:,:,KS:KE+1,1) = Sw_output%ufsw (:,:,KS:KE+1,1) - &
                  Sw_output%dfsw (:,:,KS:KE+1,1)
        Sw_output%hsw (:,:,KS:KE,1  ) = radcon*   &
         (Sw_output%fsw (:,:,KS+1:KE+1,1) -    &
      Sw_output%fsw (:,:,KS:KE,1))/dp(:,:,KS:KE)
else
        Sw_output%fswcf (:,:,KS:KE+1,1) = Sw_output%ufswcf (:,:,KS:KE+1,1) -   &
              Sw_output%dfswcf (:,:,KS:KE+1,1)
        Sw_output%hswcf (:,:,KS:KE,1  ) = radcon*  &
 (Sw_output%fswcf (:,:,KS+1:KE+1,1) -    &
     Sw_output% fswcf (:,:,KS:KE,1))/dp(:,:,KS:KE)
      endif

      endif
    end do ! (ngp loop)

!--------------------------------------------------------------------
!   deallocate local arrays
!-------------------------------------------------------------------
      if (present(gwt)) then
        deallocate (ufswg      )
        deallocate (hswg       )
        deallocate (fswg       )
        deallocate (dfswg      )
      endif
      deallocate ( absdo3    )
      deallocate ( absuo3    )
      deallocate ( alfa      )
      deallocate ( alfau     )
      deallocate ( alogtt    )
      deallocate ( cr        )
      deallocate ( ct        )
      deallocate ( dfn       )
      deallocate ( dfncltop  )
      deallocate ( dfnlbc    )
      deallocate ( dfntop    )
      deallocate ( dp        )
      deallocate ( dpcldi    )
      deallocate ( du        )
      deallocate ( duco2     )
      deallocate ( duo3      )
      deallocate ( ff        )
      deallocate ( ffco2     )
      deallocate ( ffo3      )
      deallocate ( pp        )
      deallocate ( pptop     )
      deallocate ( pr2       )
      deallocate ( refl      )
      deallocate ( rray      )
      deallocate ( seczen    )
      deallocate ( tdcltt    )
      deallocate ( tdclbt    )
      deallocate ( tdcltop   )
      deallocate ( tdclbtm   )
      deallocate ( tdco2     )
      deallocate ( ttd       )
      deallocate ( ttdb1     )
      deallocate ( ttu       )
      deallocate ( ttub1     )
      deallocate ( tucltop   )
      deallocate ( tuco2     )
      deallocate ( ud        )
      deallocate ( udco2     )
      deallocate ( udo3      )
      deallocate ( ufn       )
      deallocate ( ufncltop  )
      deallocate ( ufnlbc    )
      deallocate ( uu        )
      deallocate ( uuco2     )
      deallocate ( uuo3      )
      deallocate ( absdo2    )
      deallocate ( uo2       )
  
      if (kcldsw /= 0) then
        deallocate ( camtsw )
        deallocate ( cirabsw    )
        deallocate ( cirrfsw    )
        deallocate ( cvisrfsw     )
        deallocate ( ktopsw )
        deallocate ( kbtmsw )
      endif

      deallocate ( ncldsw )

!--------------------------------------------------------------------
!   convert sw fluxes to mks units.
!---------------------------------------------------------------------
      if (with_clouds) then
      Sw_output%fsw(:,:,:,:) = 1.0E-03*Sw_output%fsw(:,:,:,:)
      Sw_output%dfsw(:,:,:,:) = 1.0E-03*Sw_output%dfsw(:,:,:,:)
      Sw_output%ufsw(:,:,:,:) = 1.0E-03*Sw_output%ufsw(:,:,:,:)
      else
        Sw_output%fswcf(:,:,:,:) = 1.0E-03*Sw_output%fswcf(:,:,:,:)
       Sw_output%dfswcf(:,:,:,:) = 1.0E-03*Sw_output%dfswcf(:,:,:,:)
      Sw_output%ufswcf(:,:,:,:) = 1.0E-03*Sw_output%ufswcf(:,:,:,:)
     endif
!-------------------------------------------------------------------

      end subroutine swrad 



!##################################################################
!####################################################################

! <SUBROUTINE NAME="convert_to_cloud_space">
!  <OVERVIEW>
!   
!  </OVERVIEW>
!  <DESCRIPTION>
!   
!  </DESCRIPTION>
!  <TEMPLATE>
!   call convert_to_cloud_space (is, ie, js, je,  Cldrad_props, &
!                Cld_spec,  &
!                cirabswkc, cirrfswkc,  &
!                cvisrfswkc, ktopswkc, kbtmswkc,  &
!                camtswkc, Cldspace_rad)
!
!  </TEMPLATE>
!  <IN NAME="is" TYPE="integer">
! 
!  </IN>
!  <IN NAME="ie" TYPE="integer">
! 
!  </IN>
!  <IN NAME="js" TYPE="integer">
! 
!  </IN>
!  <IN NAME="je" TYPE="integer">
! 
!  </IN>
!  <IN NAME="Cldrad_props" TYPE="cldrad_properties_type">
! 
!  </IN>
!  <IN NAME="Cld_spec" TYPE="cld_specification_type">
! 
!  </IN>
!  <OUT NAME="cirabswkc" TYPE="real">
! 
!  </OUT>
!  <OUT NAME="cirrfswkc" TYPE="real">
! 
!  </OUT>
!  <OUT NAME="cvisrfswkc" TYPE="real">
! 
!  </OUT>
!  <OUT NAME="ktopswkc" TYPE="integer">
! 
!  </OUT>
!  <OUT NAME="kbtmswkc" TYPE="integer">
! 
!  </OUT>
!  <OUT NAME="camtswkc" TYPE="real">
! 
!  </OUT>
!  <INOUT NAME="Cldspace_rad" TYPE="cld_space_properties_type">
! 
!  </INOUT>
! </SUBROUTINE>
!
subroutine convert_to_cloud_space (is, ie, js, je,  Cldrad_props, &
                               Cld_spec,  &
                               cirabswkc, cirrfswkc,  &
cvisrfswkc, ktopswkc, kbtmswkc,  &
camtswkc, Cldspace_rad)
      
integer, intent(in) :: is, ie, js, je
type(cldrad_properties_type), intent(in) :: Cldrad_props
type(cld_specification_type), intent(in) :: Cld_spec       
real, dimension(:,:,:),   intent(out) :: camtswkc
real, dimension(:,:,:  ), intent(out) :: cirabswkc, cirrfswkc,  &
 cvisrfswkc
integer, dimension(:,:,:),intent(out) :: ktopswkc, kbtmswkc
type(cld_space_properties_type), intent(inout) :: Cldspace_rad
!-------------------------------------------------------------------


      integer :: i,j,k, index_kbot, index_ktop
      integer :: kcldsmx
      integer :: ix, jx, kx

       ix = size(Cld_spec%camtsw,1)
       jx = size(Cld_spec%camtsw,2)
       kx = size(Cld_spec%camtsw,3)

!---------------------------------------------------------------------
!     obtain arrays for shortwave cloud properties in "cloud space".
!     "bottom up" counting is used in conformity with the lhsw
!     radiative algorithm. (ie, index = 1 = lowest cloud (if any), etc.)
!---------------------------------------------------------------------
      
      kcldsmx = MAXVAL(Cld_spec%ncldsw)
      if (kcldsmx /= 0.0) then
      camtswkc(:,:,:) = 0.0E+00
      cirabswkc(:,:,:  ) = 0.0E+00
      cirrfswkc(:,:,:  ) = 0.0E+00
      cvisrfswkc(:,:,:) = 0.0E+00
      ktopswkc(:,:,:) = 1        
      kbtmswkc(:,:,:) = 1        

      do j=1,jx         
        do i=1,ix         
 index_kbot = 0
  index_ktop = 0
!---------------------------------------------------------------------
!     in the kx   'th layer, the presence of cloud (camtsw) implies a
!     shortwave cloud bottom at level (kx   +1) but nothing about
!     cloud tops.
!---------------------------------------------------------------------
          if (Cld_spec%camtsw(i,j,kx   ) .GT. 0.0E+00) then
            index_kbot = index_kbot + 1
    kbtmswkc(i,j,index_kbot) = kx   +1
    camtswkc(i,j,index_kbot) = Cld_spec%camtsw(i,j,kx   )
      cirabswkc(i,j,index_kbot    ) = Cldrad_props%cirabsw(i,j,kx )
              cirrfswkc(i,j,index_kbot    ) = Cldrad_props%cirrfsw(i,j,kx )
      cvisrfswkc(i,j,index_kbot    ) = Cldrad_props%cvisrfsw(i,j,kx )
          endif
!---------------------------------------------------------------------
!   in other layers, cloud bottoms and tops are determined according
!   to changes in shortwave cloud (and special case).
!---------------------------------------------------------------------
          do k=kx-1,1    ,-1
!---------------------------------------------------------------------
!     cloud bottoms.
!--------------------------------------------------------------------
    if (Cld_spec%camtsw(i,j,k) .NE. Cld_spec%camtsw(i,j,k+1) .AND.    &
      Cld_spec%camtsw(i,j,k) .GT. 0.0E+00              .OR.  &
!---------------------------------------------------------------------
!     special case where shortwave cloud amounts for adjacent
!     layers are equal, but a randomly overlapped cloud exists
!     in at least one of these layers
!---------------------------------------------------------------------
                Cld_spec%camtsw(i,j,k) .EQ. Cld_spec%camtsw(i,j,k+1) .AND.   &
               (Cld_spec%crndlw(i,j,k) .NE. 0.0E+00 .OR.      &
                Cld_spec%crndlw(i,j,k+1) .NE. 0.0E+00)                ) then
              index_kbot = index_kbot + 1
      kbtmswkc(i,j,index_kbot) = k+1
      camtswkc(i,j,index_kbot) = Cld_spec%camtsw(i,j,k)
      cirabswkc(i,j,index_kbot    ) = Cldrad_props%cirabsw(i,j,k)
      cirrfswkc(i,j,index_kbot    ) = Cldrad_props%cirrfsw(i,j,k)
      cvisrfswkc(i,j,index_kbot    ) = Cldrad_props%cvisrfsw(i,j,k)
            endif
!---------------------------------------------------------------------
!     cloud tops.
!---------------------------------------------------------------------
            if (Cld_spec%camtsw(i,j,k) .NE. Cld_spec%camtsw(i,j,k+1) .AND.      &
                Cld_spec%camtsw(i,j,k+1) .GT. 0.0E+00            .OR.  &
!---------------------------------------------------------------------
!     special case where shortwave cloud amounts for adjacent
!     layers are equal, but a randomly overlapped cloud exists
!     in at least one of these layers
!---------------------------------------------------------------------
                Cld_spec%camtsw(i,j,k) .EQ. Cld_spec%camtsw(i,j,k+1) .AND.    &
               (Cld_spec%crndlw(i,j,k) .NE. 0.0E+00 .OR.        &
                Cld_spec%crndlw(i,j,k+1) .NE. 0.0E+00)                ) then
      index_ktop = index_ktop + 1
      ktopswkc(i,j,index_ktop) = k+1
            endif
          enddo
        enddo
      enddo


!---------------------------------------------------------------------
      allocate ( Cldspace_rad%camtswkc(ie-is+1, je-js+1,  &
                                 size(camtswkc,3) ) )
      allocate ( Cldspace_rad%cirabswkc(ie-is+1, je-js+1,  &
                                 size(camtswkc,3)   ) )
      allocate ( Cldspace_rad%cirrfswkc(ie-is+1, je-js+1,  &
                                 size(camtswkc,3)   ) )
      allocate ( Cldspace_rad%cvisrfswkc(ie-is+1, je-js+1,  &
                                 size(camtswkc,3)   ) )
      allocate ( Cldspace_rad%ktopswkc(ie-is+1, je-js+1,  &
                                 size(camtswkc,3) ) )
      allocate ( Cldspace_rad%kbtmswkc(ie-is+1, je-js+1,  &
                                 size(camtswkc,3)+1 ) )
      Cldspace_rad%camtswkc = camtswkc
      Cldspace_rad%cirabswkc = cirabswkc
      Cldspace_rad%cirrfswkc = cirrfswkc
      Cldspace_rad%cvisrfswkc = cvisrfswkc
      Cldspace_rad%ktopswkc = ktopswkc
      Cldspace_rad%kbtmswkc = kbtmswkc
      else
      endif



end subroutine convert_to_cloud_space



!####################################################################


             end module lhsw_driver_mod

MODULE CONV_CLOSURES_MOD

! use Sat_Vapor_Pres_Mod, ONLY: ESCOMP, DESCOMP
! use      Constants_Mod, ONLY: tfreeze,HLv,HLf,HLs,CP_AIR,GRAV,Kappa,rdgas,rvgas
  use fms_mod,              only: write_version_number
  use  conv_utilities_k_mod,only: sd_copy_k, adi_cloud_k, extend_sd_k,&
                                  adicloud, sounding, uw_params
  use  conv_plumes_k_mod,   only: cumulus_plume_k, cumulus_tend_k, &
                                  cplume, ctend, cpnlist

!---------------------------------------------------------------------
  implicit none
  private

!---------------------------------------------------------------------
!----------- ****** VERSION NUMBER ******* ---------------------------

  character(len=128) :: version = '$Id: conv_closures.F90,v 19.0 2012/01/06 20:25:26 fms Exp $'
  character(len=128) :: tagname = '$Name: tikal $'
  logical            :: module_is_initialized=.false.  ! module initialized ?

!---------------------------------------------------------------------
!-------  interfaces --------

  public  :: cclosure_bretherton, cclosure_relaxcbmf, cclosure_emanuel, &
             cclosure_implicit, cclosure_relaxwfn, &
             conv_closures_init, conv_closures_end

  character(len=11) :: mod_name = 'conv_closures'

  public cclosure
  type cclosure
     real    :: cbmf, wrel, ufrc, scaleh, dcin, dcape, dwfn, wfn
     integer :: igauss
     real    :: rkfre, rmaxfrac, rbuoy, tau_sh, tau_dp, wcrit_min
     real    :: maxcldfrac
  end type cclosure
 
contains

!#####################################################################
!#####################################################################

  function erfccc(x)
    !--------------------------------------------------------------
    ! This numerical recipes routine calculates the complementary
    ! error function.
    !--------------------------------------------------------------
   
    real :: erfccc
    real, intent(in) :: x 
    real :: t,z
   
    z=abs(x)      
    t=1./(1.+0.5*z)
   
    erfccc=t*exp(-z*z-1.26551223+t*(1.00002368+t*(.37409196+t*      &
         (.09678418+t*(-.18628806+t*(.27886807+t*(-1.13520398+t*    &
         (1.48851587+t*(-.82215223+t*.17087277)))))))))
    
    if (x.lt.0.) erfccc=2.-erfccc
    
  end function erfccc

!#####################################################################
!#####################################################################

  subroutine solvecbmf(alpha, beta, x)
    !Newton iteration solving Eq. x = beta * exp (-alpha * x)
    implicit none
    real,    intent(in)    :: alpha, beta
    real,    intent(inout) :: x
    
    integer :: iteration, niteration=5, id_check
    real    :: dydx, x0, y0

    x0=1.
    do iteration = 1,niteration
       y0   = x0 - beta * exp(-alpha * x0)
       dydx = 1. + beta * alpha * exp(-alpha * x0)
       x0   = x0 - y0 / dydx
       if (abs(y0) < 0.0001) then
          x=x0; id_check=0
       else
          id_check=1
       end if
    end do
    if (id_check==1) then
      x=1.
      print*, 'ID_CHECK=1, in solvecbmfffffffffffff'
    endif
    
  end subroutine solvecbmf

!#####################################################################
!#####################################################################

  subroutine cclosure_bretherton(tkeavg, cpn, sd, Uw_p,  ac, cc, &
                                 cbmf_unmod)
  
    implicit none
    real,           intent(in)    :: tkeavg
    type(cpnlist),  intent(in)    :: cpn
    type(sounding), intent(in)    :: sd
    type(uw_params), intent(inout)    :: Uw_p
    type(adicloud), intent(in)    :: ac
    type(cclosure), intent(inout) :: cc
    real,   intent(out), optional :: cbmf_unmod
    
    real    :: sigmaw, wcrit, erfarg, cbmf, wexp, ufrc, wtw
    real    :: rmfk1=0.3, rmfk2=5.0, rmfk3=3.0

    cc%cbmf=0.; cc%wrel=0.; cc%ufrc=0.;
    if(cc%igauss.eq.0)then     !Use cin and pbl tke
       cbmf = rmfk1* ac % rho0lcl * sqrt(tkeavg) * exp(-rmfk2* ac % cin/tkeavg)
       wexp = rmfk3* sqrt(tkeavg) !Updraft vertical velocity at release height depends on tke

    elseif(cc%igauss.eq.1)then !Use cin and gaussian distribution of w
       wcrit  = sqrt(2. * ac % cin * cc%rbuoy)
       sigmaw = sqrt(cc%rkfre * tkeavg)
       wcrit = max(wcrit, cc%wcrit_min*sigmaw)
       cbmf   = ac % rho0lcl * sigmaw / 2.5066 * exp(-0.5*((wcrit/sigmaw)**2.))

      if (present (cbmf_unmod)) then
        cbmf_unmod = MAX(0.0, cbmf)
      endif
  
       !Diagnose updraft fraction sqrt(2.) = 1.4142
       erfarg=wcrit / (1.4142 * sigmaw)
       if(erfarg.lt.20.)then
          ufrc = min(cc%maxcldfrac, cc%rmaxfrac, 0.5*erfccc(erfarg))
       else
          ufrc = 0.
       endif

       if(ufrc.gt.0.0) then !Diagnose expected value of cloud base vertical velocity
           wexp = cbmf / ac % rho0lcl / ufrc
       else
          wexp = 0.
          cbmf = 0.
       endif
    endif

    wtw = wexp * wexp - 2 * ac % cin * cc%rbuoy !used for the runs of xx-hv1_amip and tropical storm 
    if(wtw.le.0.) then
       cc%wrel=0.; 
    else
       cc%wrel=sqrt(wtw)
    end if

    cc%cbmf=cbmf
    cc%wrel=min(cc%wrel, 50.)!cc%ufrc=min(cc%rmaxfrac, cc%ufrc)
    cbmf = (sd%ps(0) - ac%plcl ) * 0.25 / sd%delt / Uw_p%GRAV
    if (cc%cbmf .gt. cbmf) cc%cbmf = cbmf
    if (cc%wrel .gt. 0.) then
      cc%ufrc=cc%cbmf / cc%wrel /ac % rho0lcl
    else
      cc%ufrc=0.
    end if
    if (cc%ufrc > cc%maxcldfrac) then
       cc%ufrc = cc%maxcldfrac
       cc%cbmf = cc%wrel*ac%rho0lcl*cc%ufrc
    end if   

!    cc%cbmf=cbmf
!    cc%ufrc=ufrc
!
!    cbmf = (sd%ps(0) - ac%plcl ) * 0.25 / sd%delt / Uw_p%GRAV
!    if (cc%cbmf .gt. cbmf .and. cc%wrel .gt. 0) then
!       cc%cbmf = cbmf
!       cc%ufrc = cc%cbmf / wexp /ac % rho0lcl
!    end if
!    cc%wrel=min(cc%wrel, 50.)
!    cc%ufrc=min(cc%rmaxfrac, cc%ufrc)

    return

  end subroutine cclosure_bretherton

!#####################################################################
!#####################################################################

  subroutine cclosure_implicit(tkeavg, cpn, sd, Uw_p, ac, cc, delt, rkm, &
       do_coldT, sd1, ac1, cc1, cp1, ct1, ier, ermesg)
    implicit none
    real,           intent(in)    :: tkeavg, delt, rkm
    type(cpnlist),  intent(in)    :: cpn
    type(sounding), intent(in)    :: sd
    type(uw_params), intent(inout)    :: Uw_p
    type(adicloud), intent(in)    :: ac
    type(cclosure), intent(inout) :: cc, cc1
    type(sounding), intent(inout) :: sd1
    type(adicloud), intent(inout) :: ac1
    type(cplume),   intent(inout) :: cp1
    type(ctend),    intent(inout) :: ct1
    logical,        intent(in)    :: do_coldT
    integer,        intent(out)     :: ier
    character(len=256), intent(out) :: ermesg

    logical :: dofast=.false., doice=.true.

    real :: cbmf0=0.001, alpha, beta, phi

    call cclosure_bretherton(tkeavg, cpn, sd, Uw_p, ac, cc)
    if(cc%cbmf.eq.0.) then
      cc % dcin=0.
      return
    end if

    call cumulus_plume_k(cpn, sd, ac, cp1, rkm, cbmf0, cc%wrel, cc%scaleh, Uw_p, ier, ermesg)
    if (ier /= 0) then
      ermesg = 'Called from cclosure_implicit : '// trim(ermesg)
      return
    endif
    if(cp1%ltop.lt.cp1%krel+2 .or. cp1%let.le.cp1%krel+1) then
       cc % dcin=0.
       return
    else
       call cumulus_tend_k(cpn, sd, Uw_p, cp1, ct1, do_coldT)
       call sd_copy_k(sd, sd1)
       sd1 % t  = sd1 % t  + ct1%tten  * delt
       sd1 % qv = sd1 % qv + ct1%qvten * delt
       sd1 % ql = sd1 % ql + ct1%qlten * delt
       sd1 % qi = sd1 % qi + ct1%qiten * delt
       sd1 % qa = sd1 % qa + ct1%qaten * delt
       sd1 % qn = sd1 % qn + ct1%qnten * delt
       sd1 % u  = sd1 % u  + ct1%uten  * delt
       sd1 % v  = sd1 % v  + ct1%vten  * delt

       call extend_sd_k(sd1, sd%pblht, doice, Uw_p)

       call adi_cloud_k(sd1%zs(1), sd1%ps(1), sd1%hl(1), sd1%thc(1), sd1%qct(1), sd1, Uw_p, dofast, doice, ac1)

       cc % dcin=(ac1%cin-ac%cin)/cbmf0

       alpha  = (2. * cc%rbuoy) / (2. * cc%rkfre * tkeavg) * cc % cbmf * cc % dcin
       beta   = 1.  ! ac % rho0lcl * sqrt(cc%rkfre * tkeavg) / 2.5066
       phi    = 1.
       if (alpha .gt. 0.) then
          call solvecbmf(alpha, beta, phi)
          cc % cbmf = phi * cc % cbmf
       end if
    end if

  end subroutine cclosure_implicit

!#####################################################################
!#####################################################################

  subroutine cclosure_relaxcbmf(tkeavg, cpn, sd, Uw_p, ac, cc, delt)
  
    implicit none
    real,           intent(in)    :: tkeavg, delt
    type(cpnlist),  intent(in)    :: cpn
    type(sounding), intent(in)    :: sd
    type(uw_params), intent(in)    :: Uw_p
    type(adicloud), intent(in)    :: ac
    type(cclosure), intent(inout) :: cc
    
    real    :: sigmaw, wcrit, erfarg, wexp, wtw
    real    :: cbmfs, tmp
    
    cc%wrel=0.; cc%ufrc=0.;   

    wcrit  = sqrt(2. * ac % cin * cc%rbuoy)
    sigmaw = sqrt(cc%rkfre * tkeavg)
    cbmfs  = ac % rho0lcl * sigmaw / 2.5066 * exp(-0.5*((wcrit/sigmaw)**2.))

    tmp    = delt/cc%tau_sh
    cc%cbmf= max((cc%cbmf+tmp*cbmfs)/(1.+tmp),0.0)

    !Diagnose updraft fraction
    erfarg=wcrit / (1.4142 * sigmaw)
    if(erfarg.lt.20.)then
       cc%ufrc = min(cc%maxcldfrac, cc%rmaxfrac, 0.5*erfccc(erfarg))
    else
       cc%ufrc = 0.
    endif

    if(cc%ufrc.gt.0.001)then !Diagnose expected value of cloud base vertical velocity
       wexp = cc%cbmf / ac % rho0lcl / cc%ufrc
    else
       wexp = 0.
       cc%cbmf = 0.
    endif

    wexp=min(wexp, 50.)
    wtw = wexp * wexp - 2 * ac % cin * cc%rbuoy
    if(wtw.le.0.) then
       cc%wrel=0.; 
    else
       cc%wrel=sqrt(wtw)
    end if

    return

  end subroutine cclosure_relaxcbmf

!#####################################################################
!#####################################################################

  subroutine cclosure_emanuel(tkeavg, cpn, sd, Uw_p, ac, cc, delt)
  
    implicit none
    real,           intent(in)    :: tkeavg, delt
    type(cpnlist),  intent(in)    :: cpn
    type(uw_params),  intent(inout)    :: Uw_p
    type(sounding), intent(in)    :: sd
    type(adicloud), intent(in)    :: ac
    type(cclosure), intent(inout) :: cc
    
    integer :: k
    real    :: ufrc=0.01
    real    :: dtmin, dpsum, dtpbl, damps
    real    :: cbmf
    real    :: dtmax    = 0.9    ! MAXIMUM NEGATIVE TEMPERATURE PERTURBATION
                                 ! A LIFTED PARCEL IS ALLOWED TO HAVE BELOW ITS LFC
    real    :: damp     = 0.1    ! ALPHA AND DAMP ARE PARAMETERS THAT CONTROL THE RATE OF
    real    :: alpha    = 0.1    ! APPROACH TO QUASI-EQUILIBRIUM

    cbmf=cc%cbmf; cc%cbmf=0.; cc%wrel=0.; cc%ufrc=0.;

    dpsum=0.; dtpbl=0.
    do k=1, ac%klcl-1
       dtpbl=dtpbl+(ac%thv(k)-sd%thv(k))*sd%exner(k)*sd%dp(k)
       dpsum=dpsum+sd%dp(k);
    end do
    dtpbl=dtpbl/dpsum
    dtmin=(ac%thvlcl-ac%thv0lcl)+dtpbl+dtmax

    damps=damp*delt/300.
    cbmf =(1.-damps)*cbmf+0.1*alpha*dtmin
    cc%cbmf=max(cbmf,0.0)
    cc%wrel=cbmf / ac % rho0lcl / ufrc
    cc%ufrc=ufrc

    return

  end subroutine cclosure_emanuel

!#####################################################################
!#####################################################################

  subroutine cclosure_relaxwfn(tkeavg, cpn, sd, Uw_p, ac, cc, cp, ct, delt, rkm, &
       do_coldT, sd1, ac1, cc1, cp1, ct1, ier, ermesg)
    implicit none
    real,           intent(in)    :: tkeavg, delt, rkm
    type(cpnlist),  intent(in)    :: cpn
    type(uw_params),  intent(inout)    :: Uw_p
    type(sounding), intent(in)    :: sd
    type(adicloud), intent(in)    :: ac
    type(cclosure), intent(inout) :: cc, cc1
    type(sounding), intent(inout) :: sd1
    type(adicloud), intent(inout) :: ac1
    type(cplume),   intent(inout) :: cp, cp1
    type(ctend),    intent(inout) :: ct, ct1
    logical,        intent(in)    :: do_coldT
    integer,        intent(out)   :: ier
    character(len=256), intent(out) :: ermesg
    logical :: dofast=.false., doice=.true.


    integer :: k
    real    :: cbmf0=0.0001, delp, cbmf_old, tmp, cbmfs

    cbmf_old= cc%cbmf
    call cclosure_bretherton(tkeavg, cpn, sd, Uw_p, ac, cc)

    call cumulus_plume_k(cpn, sd,  ac, cp, rkm, cbmf0, cc%wrel, cc%scaleh, Uw_p, ier, ermesg)
    if (ier /= 0) then
      ermesg = 'Called from cclosure_relaxwfn : '//trim(ermesg)
      return
    endif
    if(cp%ltop.lt.cp%krel+2 .or. cp%let.le.cp%krel+1) then
       cc % dcin=0.
       return
    else
       call cumulus_tend_k(cpn, sd, Uw_p, cp, ct, do_coldT)
       call sd_copy_k(sd, sd1)
       sd1 % t  = sd1 % t  + ct%tten  * delt
       sd1 % qv = sd1 % qv + ct%qvten * delt
       sd1 % ql = sd1 % ql + ct%qlten * delt
       sd1 % qi = sd1 % qi + ct%qiten * delt
       sd1 % qa = sd1 % qa + ct%qaten * delt
       sd1 % qn = sd1 % qn + ct%qnten * delt
       sd1 % u  = sd1 % u  + ct%uten  * delt
       sd1 % v  = sd1 % v  + ct%vten  * delt

       call extend_sd_k(sd1, sd%pblht, doice, Uw_p)

       call adi_cloud_k(sd1%zs(1), sd1%ps(1), sd1%hl(1), sd1%thc(1), sd1%qct(1), sd1, Uw_p, dofast, doice, ac1)
       cc % dcin=(ac1%cin-ac%cin)/cbmf0
       cc % dcape=(ac1%cape-ac%cape)/cbmf0

       call cumulus_plume_k(cpn, sd1, ac1, cp1, rkm, cbmf0, cc%wrel, cc%scaleh, Uw_p, ier, ermesg)
       if (ier /= 0) then
         ermesg = 'Called from cclosure_relaxwfn 2nd call : '//trim(ermesg)
       endif

       cc%dwfn=0.; cc%wfn=0.; delp=0.;
       do k=cp1%krel, cp1%let
          cc % wfn  = cc % wfn  + 0.5*(cp %wu(k)*cp %wu(k)) * cp%dp(k)
          cc % dwfn = cc % dwfn + 0.5*(cp1%wu(k)*cp1%wu(k) - cp%wu(k)*cp%wu(k)) * cp%dp(k)
          delp      = delp + cp%dp(k)
       end do
       cc % wfn  = cc % wfn  / delp 
       cc % dwfn = cc % dwfn / delp / cbmf0

       cbmfs = - cc%wfn  / cc % dwfn

       tmp    = delt/cc%tau_sh
       cc%cbmf= (cbmf_old+tmp*cbmfs)/(1.+tmp)

       cc % cbmf = max(cc%cbmf,0.)


    end if

  end subroutine cclosure_relaxwfn

!#####################################################################
!#####################################################################
subroutine conv_closures_init

!---------------------------------------------------------------------
!    write version number and namelist to logfile.
!---------------------------------------------------------------------
      call write_version_number(version, tagname)
!---------------------------------------------------------------------
!    mark the module as initialized.
!---------------------------------------------------------------------
      module_is_initialized = .true.
    


end subroutine conv_closures_init
!#####################################################################
!#####################################################################
subroutine conv_closures_end

      module_is_initialized = .false.


end subroutine conv_closures_end

!#####################################################################
!#####################################################################

end MODULE CONV_CLOSURES_MOD

#include  <fms_platform.h>

module time_interp_external_mod
!
!<CONTACT EMAIL="Matthew.Harrison@noaa.gov">M.J. Harrison</CONTACT>
!
!<REVIEWER EMAIL="hsimmons@iarc.uaf.edu">Harper Simmons</REVIEWER>
!
!<OVERVIEW>
! Perform I/O and time interpolation of external fields (contained in a file).
!</OVERVIEW>

!<DESCRIPTION>
! Perform I/O and time interpolation for external fields.
! Uses udunits library to calculate calendar dates and
! convert units.  Allows for reading data decomposed across
! model horizontal grid using optional domain2d argument
!
! data are defined over data domain for domain2d data
! (halo values are NOT updated by this module)
! 
!</DESCRIPTION>
!
!<NAMELIST NAME="time_interp_external_nml">
! <DATA NAME="num_io_buffers" TYPE="integer">
! size of record dimension for internal buffer.  This is useful for tuning i/o performance
! particularly for large datasets (e.g. daily flux fields)
! </DATA>
!</NAMELIST>

  use mpp_mod, only : mpp_error,FATAL,WARNING,mpp_pe, stdout, stdlog, NOTE
  use mpp_mod, only : input_nml_file
  use mpp_io_mod, only : mpp_open, mpp_get_atts, mpp_get_info, MPP_NETCDF, MPP_MULTI, MPP_SINGLE,&
       mpp_get_times, MPP_RDONLY, MPP_ASCII, default_axis,axistype,fieldtype,atttype, &
       mpp_get_axes, mpp_get_fields, mpp_read, default_field, mpp_close, &
       mpp_get_tavg_info, validtype, mpp_is_valid, mpp_get_file_name
  use time_manager_mod, only : time_type, get_date, set_date, operator ( >= ) , operator ( + ) , days_in_month, &
                            operator( - ), operator ( / ) , days_in_year, increment_time, &
                            set_time, get_time, operator( > ), get_calendar_type, NO_CALENDAR
  use get_cal_time_mod, only : get_cal_time
  use mpp_domains_mod, only : domain2d, mpp_get_compute_domain, mpp_get_data_domain, &
       mpp_get_global_domain, NULL_DOMAIN2D
  use time_interp_mod, only : time_interp, time_interp_init
  use axis_utils_mod, only : get_axis_cart, get_axis_modulo, get_axis_modulo_times
  use fms_mod, only : lowercase, open_namelist_file, check_nml_error, close_file
  use platform_mod, only: r8_kind
  use horiz_interp_mod, only : horiz_interp, horiz_interp_type

  implicit none
  private

  character(len=128), private :: version= &
   'CVS $Id$'
  character(len=128), private :: tagname='Tag $Name$'

  integer, parameter, public  :: NO_REGION=0, INSIDE_REGION=1, OUTSIDE_REGION=2
  integer, parameter, private :: modulo_year= 0001
  integer, parameter, private :: LINEAR_TIME_INTERP = 1 ! not used currently
  integer, parameter, public  :: SUCCESS = 0, ERR_FIELD_NOT_FOUND = 1
  integer,            private :: max_fields = 100, max_files= 40
  integer, private :: num_fields = 0, num_files=0
  ! denotes time intervals in file (interpreted from metadata)
  integer, private :: num_io_buffers = 2 ! set -1 to read all records from disk into memory 
  logical, private :: module_initialized = .false.
  logical, private :: debug_this_module = .false.

  public init_external_field, time_interp_external, time_interp_external_init, &
       time_interp_external_exit, get_external_field_size, get_time_axis
  public set_override_region, reset_src_data_region

  private find_buf_index,&
         set_time_modulo

  type, private :: ext_fieldtype
     integer :: unit ! keep unit open when not reading all records
     character(len=128) :: name, units
     integer :: siz(4), ndim
     type(domain2d) :: domain
     type(axistype) :: axes(4)
     type(time_type), dimension(:), pointer :: time =>NULL() ! midpoint of time interval
     type(time_type), dimension(:), pointer :: start_time =>NULL(), end_time =>NULL()
     type(fieldtype) :: field ! mpp_io type
     type(time_type), dimension(:), pointer :: period =>NULL() 
     logical :: modulo_time ! denote climatological time axis
     real, dimension(:,:,:,:), pointer :: data =>NULL() ! defined over data domain or global domain
     logical, dimension(:,:,:,:), pointer :: mask =>NULL() ! defined over data domain or global domain
     integer, dimension(:), pointer :: ibuf  =>NULL() ! record numbers associated with buffers
     real, dimension(:,:,:,:), pointer :: src_data  =>NULL() ! input data buffer
     type(validtype) :: valid ! data validator
     integer :: nbuf
     logical :: domain_present
     real(DOUBLE_KIND) :: slope, intercept
     integer :: isc,iec,jsc,jec
     type(time_type) :: modulo_time_beg, modulo_time_end
     logical :: have_modulo_times, correct_leap_year_inconsistency
     integer :: region_type
     integer :: is_region, ie_region, js_region, je_region
     integer :: is_src, ie_src, js_src, je_src
     integer :: tdim
     integer :: numwindows
     logical, dimension(:,:), pointer :: need_compute=>NULL()
  end type ext_fieldtype

  type, private :: filetype
     character(len=128) :: filename = ''
     integer :: unit = -1
  end type filetype

  interface time_interp_external
     module procedure time_interp_external_0d
     module procedure time_interp_external_2d
     module procedure time_interp_external_3d
  end interface

  type(ext_fieldtype), save, private, pointer :: field(:) => NULL()
  type(filetype),      save, private, pointer :: opened_files(:) => NULL()
!Balaji: really should use field%missing
  real(DOUBLE_KIND), private, parameter :: time_interp_missing=-1e99
  contains

! <SUBROUTINE NAME="time_interp_external_init">
!
! <DESCRIPTION>
! Initialize the time_interp_external module
! </DESCRIPTION>
!
    subroutine time_interp_external_init()

      integer :: ioun, io_status, logunit, ierr

      namelist /time_interp_external_nml/ num_io_buffers, debug_this_module, &
                                          max_fields, max_files

      ! open and read namelist

      if(module_initialized) return
      
      logunit = stdlog()
      write(logunit,'(/a/)') version
      write(logunit,'(/a/)') tagname

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, time_interp_external_nml, iostat=io_status)
      ierr = check_nml_error(io_status, 'time_interp_external_nml')
#else
      ioun = open_namelist_file ()
      ierr=1; do while (ierr /= 0)
      read  (ioun, nml=time_interp_external_nml, iostat=io_status, end=10)
      ierr = check_nml_error(io_status, 'time_interp_external_nml')
      enddo
10    call close_file (ioun)
#endif

      write(logunit,time_interp_external_nml)
      call realloc_fields(max_fields)
      call realloc_files(max_files)

      module_initialized = .true.

      call time_interp_init()

      return
      
    end  subroutine time_interp_external_init
! </SUBROUTINE> NAME="time_interp_external_init"


!<FUNCTION NAME="init_external_field" TYPE="integer">
!
!<DESCRIPTION>
! initialize an external field.  Buffer "num_io_buffers" (default=2) in memory to reduce memory allocations. 
! distributed reads are supported using the optional "domain" flag.  
! Units conversion via the optional "desired_units" flag using udunits_mod.
!
! Return integer id of field for future calls to time_interp_external.
!
! </DESCRIPTION>
!
!<IN  NAME="file" TYPE="character(len=*)">
! filename
!</IN>
!<IN  NAME="fieldname" TYPE="character(len=*)">
! fieldname (in file)
!</IN>
!<IN NAME="format" TYPE="integer">
! mpp_io flag for format of file (optional). Currently only "MPP_NETCDF" supported
!</IN>
!<IN NAME="threading" TYPE="integer">
! mpp_io flag for threading (optional).  "MPP_SINGLE" means root pe reads global field and distributes to other PEs
! "MPP_MULTI" means all PEs read data
!</IN>
!<IN NAME="domain" TYPE="mpp_domains_mod:domain2d">
! domain flag (optional)
!</IN>
!<IN NAME="desired_units" TYPE="character(len=*)">
! Target units for data (optional), e.g. convert from deg_K to deg_C.  
! Failure to convert using udunits will result in failure of this module.
!</IN>
!<IN NAME="verbose" TYPE="logical">
! verbose flag for debugging (optional).
!</IN>
!<INOUT NAME="axis_centers" TYPE="axistype" DIM="(4)">
! MPP_IO axistype array for grid centers ordered X-Y-Z-T (optional).
!</INOUT>
!<INOUT NAME="axis_sizes" TYPE="integer" DIM="(4)">
!  array of axis lengths ordered X-Y-Z-T (optional).
!</INOUT>


    function init_external_field(file,fieldname,format,threading,domain,desired_units,&
         verbose,axis_centers,axis_sizes,override,correct_leap_year_inconsistency,&
         permit_calendar_conversion,use_comp_domain,ierr, nwindows )
      
      character(len=*), intent(in)            :: file,fieldname
      integer, intent(in), optional           :: format, threading
      logical, intent(in), optional           :: verbose 
      character(len=*), intent(in), optional  :: desired_units
      type(domain2d), intent(in), optional    :: domain
      type(axistype), intent(inout), optional :: axis_centers(4)
      integer, intent(inout), optional        :: axis_sizes(4)
      logical, intent(in), optional           :: override, correct_leap_year_inconsistency,&
                                                 permit_calendar_conversion,use_comp_domain
      integer,          intent(out), optional :: ierr
      integer,          intent(in),  optional :: nwindows

      integer :: init_external_field
      
      type(fieldtype), dimension(:), allocatable :: flds
      type(axistype), dimension(:), allocatable :: axes, fld_axes
      type(axistype) :: time_axis
      type(atttype), allocatable, dimension(:) :: global_atts

      real(DOUBLE_KIND) :: slope, intercept
      integer :: form, thread, fset, unit,ndim,nvar,natt,ntime,i,j, outunit
      integer :: iscomp,iecomp,jscomp,jecomp,isglobal,ieglobal,jsglobal,jeglobal
      integer :: isdata,iedata,jsdata,jedata, dxsize, dysize,dxsize_max,dysize_max
      logical :: verb, transpose_xy,use_comp_domain1
      real, dimension(:), allocatable :: tstamp, tstart, tend, tavg
      character(len=1) :: cart
      character(len=128) :: units, fld_units
      character(len=128) :: name, msg, calendar_type, timebeg, timeend
      integer :: siz(4), siz_in(4), gxsize, gysize,gxsize_max, gysize_max
      type(time_type) :: tdiff
      integer :: yr, mon, day, hr, minu, sec
      integer :: len, nfile, nfields_orig, nbuf, nx,ny
      integer :: numwindows

      if (.not. module_initialized) call mpp_error(FATAL,'Must call time_interp_external_init first')
      if(present(ierr)) ierr = SUCCESS
      use_comp_domain1 = .false.
      if(PRESENT(use_comp_domain)) use_comp_domain1 = use_comp_domain
      form=MPP_NETCDF
      if (PRESENT(format)) form = format
      thread = MPP_MULTI
      if (PRESENT(threading)) thread = threading
      fset = MPP_SINGLE
      verb=.false.
      if (PRESENT(verbose)) verb=verbose
      if (debug_this_module) verb = .true.
      numwindows = 1
      if(present(nwindows)) numwindows = nwindows

      units = 'same'
      if (PRESENT(desired_units)) then
          units = desired_units
          call mpp_error(FATAL,'==> Unit conversion via time_interp_external &
               &has been temporarily deprecated.  Previous versions of&
               &this module used udunits_mod to perform unit conversion.&
               &  Udunits_mod is in the process of being replaced since &
               &there were portability issues associated with this code.&
               & Please remove the desired_units argument from calls to &
               &this routine.')
      endif
      nfile = 0
      do i=1,num_files
         if(trim(opened_files(i)%filename) == trim(file)) then
            nfile = i
            exit  ! file is already opened
         endif
      enddo
      if(nfile == 0) then      
         call mpp_open(unit,trim(file),MPP_RDONLY,form,threading=thread,&
              fileset=fset)
         num_files = num_files + 1
         if(num_files > max_files) then ! not enough space in the file table, reallocate it
            !--- z1l: For the case of multiple thread, realoc_files will cause memory leak. 
            !---      If multiple threads are working on file A. One of the thread finished first and 
            !---      begin to work on file B, the realloc_files will cause problem for 
            !---      other threads are working on the file A.
            !  call realloc_files(2*size(opened_files))
            call mpp_error(FATAL, "time_interp_external: num_files is greater than max_files, "// &
                                      "increase time_interp_external_nml max_files")
         endif
         opened_files(num_files)%filename = trim(file)
         opened_files(num_files)%unit = unit
      else
         unit = opened_files(nfile)%unit
      endif

      call mpp_get_info(unit,ndim,nvar,natt,ntime)
      
      if (ntime < 1) then
          write(msg,'(a15,a,a58)') 'external field ',trim(fieldname),&
           ' does not have an associated record dimension (REQUIRED) '
          call mpp_error(FATAL,trim(msg))
      endif       
      allocate(global_atts(natt))
      call mpp_get_atts(unit, global_atts)
      allocate(axes(ndim))
      call mpp_get_axes(unit, axes, time_axis)
      allocate(flds(nvar))
      call mpp_get_fields(unit,flds)
      allocate(tstamp(ntime),tstart(ntime),tend(ntime),tavg(ntime))
      call mpp_get_times(unit,tstamp)
      transpose_xy = .false.     
      isdata=1; iedata=1; jsdata=1; jedata=1
      gxsize=1; gysize=1
      siz_in = 1

      if (PRESENT(domain)) then
         call mpp_get_compute_domain(domain,iscomp,iecomp,jscomp,jecomp)
         nx = iecomp-iscomp+1; ny = jecomp-jscomp+1
         call mpp_get_data_domain(domain,isdata,iedata,jsdata,jedata,dxsize,dxsize_max,dysize,dysize_max)
         call mpp_get_global_domain(domain,isglobal,ieglobal,jsglobal,jeglobal,gxsize,gxsize_max,gysize,gysize_max)
      elseif(use_comp_domain1) then
         call mpp_error(FATAL,"init_external_field:"//&
              " use_comp_domain=true but domain is not present") 
      endif
      
      init_external_field = -1
      nfields_orig = num_fields

      outunit = stdout()
      do i=1,nvar
         call mpp_get_atts(flds(i),name=name,units=fld_units,ndim=ndim,siz=siz_in)
         call mpp_get_tavg_info(unit,flds(i),flds,tstamp,tstart,tend,tavg)

         ! why does it convert case of the field name?
         if (trim(lowercase(name)) /= trim(lowercase(fieldname))) cycle

         if (verb) write(outunit,*) 'found field ',trim(fieldname), ' in file !!'
         num_fields = num_fields + 1
         if(num_fields > max_fields) then
            !--- z1l: For the case of multiple thread, realoc_fields will cause memory leak. 
            !---      If multiple threads are working on field A. One of the thread finished first and 
            !---      begin to work on field B, the realloc_files will cause problem for 
            !---      other threads are working on the field A.
            !call realloc_fields(size(field)*2) 
            call mpp_error(FATAL, "time_interp_external: num_fields is greater than max_fields, "// &
                                      "increase time_interp_external_nml max_fields")
         endif

         init_external_field = num_fields
         field(num_fields)%unit = unit
         field(num_fields)%name = trim(name)
         field(num_fields)%units = trim(fld_units)
         field(num_fields)%field = flds(i)
         field(num_fields)%isc = 1
         field(num_fields)%iec = 1
         field(num_fields)%jsc = 1
         field(num_fields)%jec = 1
         field(num_fields)%region_type = NO_REGION
         field(num_fields)%is_region   = 0
         field(num_fields)%ie_region   = -1
         field(num_fields)%js_region   = 0
         field(num_fields)%je_region   = -1
         if (PRESENT(domain)) then
            field(num_fields)%domain_present = .true.
            field(num_fields)%domain = domain
            field(num_fields)%isc=iscomp;field(num_fields)%iec = iecomp
            field(num_fields)%jsc=jscomp;field(num_fields)%jec = jecomp
         else
            field(num_fields)%domain_present = .false.
         endif

         call mpp_get_atts(flds(i),valid=field(num_fields)%valid )
         allocate(fld_axes(ndim))
         call mpp_get_atts(flds(i),axes=fld_axes)
         if (ndim > 4) call mpp_error(FATAL, &
              'invalid array rank <=4d fields supported')
         field(num_fields)%siz = 1
         field(num_fields)%ndim = ndim
         field(num_fields)%tdim = 4
         do j=1,field(num_fields)%ndim
            cart = 'N'
            call get_axis_cart(fld_axes(j), cart)
            call mpp_get_atts(fld_axes(j),len=len)
            if (cart == 'N') then
               write(msg,'(a,"/",a)')  trim(file),trim(fieldname)
               call mpp_error(FATAL,'file/field '//trim(msg)// &
                    ' couldnt recognize axis atts in time_interp_external')
            endif
            select case (cart)
            case ('X')
               if (j.eq.2) transpose_xy = .true.
               if (.not.PRESENT(domain) .and. .not.PRESENT(override)) then
                  isdata=1;iedata=len
                  iscomp=1;iecomp=len
                  gxsize = len
                  dxsize = len
                  field(num_fields)%isc=iscomp;field(num_fields)%iec=iecomp
               elseif (PRESENT(override)) then
                  gxsize = len
                  if (PRESENT(axis_sizes)) axis_sizes(1) = len
               endif
               field(num_fields)%axes(1) = fld_axes(j)
               if(use_comp_domain1) then
                  field(num_fields)%siz(1) = nx
               else
                  field(num_fields)%siz(1) = dxsize
               endif
               if (len /= gxsize) then
                  write(msg,'(a,"/",a)')  trim(file),trim(fieldname)
                  call mpp_error(FATAL,'time_interp_ext, file/field '//trim(msg)//' x dim doesnt match model')
               endif
            case ('Y')
               field(num_fields)%axes(2) = fld_axes(j)
               if (.not.PRESENT(domain) .and. .not.PRESENT(override)) then
                  jsdata=1;jedata=len
                  jscomp=1;jecomp=len
                  gysize = len
                  dysize = len
                  field(num_fields)%jsc=jscomp;field(num_fields)%jec=jecomp
               elseif (PRESENT(override)) then
                  gysize = len 
                  if (PRESENT(axis_sizes)) axis_sizes(2) = len
               endif
               if(use_comp_domain1) then
                  field(num_fields)%siz(2) = ny
               else
                  field(num_fields)%siz(2) = dysize
               endif
               if (len /= gysize) then
                  write(msg,'(a,"/",a)')  trim(file),trim(fieldname)
                  call mpp_error(FATAL,'time_interp_ext, file/field '//trim(msg)//' y dim doesnt match model')
               endif
            case ('Z')
               field(num_fields)%axes(3) = fld_axes(j)
               field(num_fields)%siz(3) = siz_in(3)
            case ('T')
               field(num_fields)%axes(4) = fld_axes(j)
               field(num_fields)%siz(4) = ntime
               field(num_fields)%tdim   = j 
            end select
         enddo
         siz = field(num_fields)%siz
         
         if (PRESENT(axis_centers)) then
            axis_centers = field(num_fields)%axes
         endif
         
         if (PRESENT(axis_sizes) .and. .not.PRESENT(override)) then
            axis_sizes = field(num_fields)%siz
         endif
         
         deallocate(fld_axes)
         if (verb) write(outunit,'(a,4i6)') 'field x,y,z,t local size= ',siz
         if (verb) write(outunit,*) 'field contains data in units = ',trim(field(num_fields)%units)
         if (transpose_xy) call mpp_error(FATAL,'axis ordering not supported')
         if (num_io_buffers .le. 1) call mpp_error(FATAL,'time_interp_ext:num_io_buffers should be at least 2')
         nbuf = min(num_io_buffers,siz(4))

         field(num_fields)%numwindows = numwindows
         allocate(field(num_fields)%need_compute(nbuf, numwindows))
         field(num_fields)%need_compute = .true.

         allocate(field(num_fields)%data(isdata:iedata,jsdata:jedata,siz(3),nbuf),&
              field(num_fields)%mask(isdata:iedata,jsdata:jedata,siz(3),nbuf) )
            field(num_fields)%mask = .false.
            field(num_fields)%data = 0.0
         slope=1.0;intercept=0.0
!             if (units /= 'same') call convert_units(trim(field(num_fields)%units),trim(units),slope,intercept)
!             if (verb.and.units /= 'same') then
!                 write(outunit,*) 'attempting to convert data to units = ',trim(units)
!                 write(outunit,'(a,f8.3,a,f8.3)') 'factor = ',slope,' offset= ',intercept
!             endif
         field(num_fields)%slope = slope
         field(num_fields)%intercept = intercept
         allocate(field(num_fields)%ibuf(nbuf))
         field(num_fields)%ibuf = -1
         field(num_fields)%nbuf =  0 ! initialize buffer number so that first reading fills data(:,:,:,1)
         if(PRESENT(override)) then
            field(num_fields)%is_src = 1
            field(num_fields)%ie_src = gxsize
            field(num_fields)%js_src = 1
            field(num_fields)%je_src = gysize
            allocate(field(num_fields)%src_data(gxsize,gysize,siz(3),nbuf))
         else
            field(num_fields)%is_src = isdata
            field(num_fields)%ie_src = iedata
            field(num_fields)%js_src = jsdata
            field(num_fields)%je_src = jedata
            allocate(field(num_fields)%src_data(isdata:iedata,jsdata:jedata,siz(3),nbuf))
         endif
         
         allocate(field(num_fields)%time(ntime))
         allocate(field(num_fields)%period(ntime))
         allocate(field(num_fields)%start_time(ntime))
         allocate(field(num_fields)%end_time(ntime))
         
         call mpp_get_atts(time_axis,units=units,calendar=calendar_type)
         do j=1,ntime
            field(num_fields)%time(j)       = get_cal_time(tstamp(j),trim(units),trim(calendar_type),permit_calendar_conversion)
            field(num_fields)%start_time(j) = get_cal_time(tstart(j),trim(units),trim(calendar_type),permit_calendar_conversion)
            field(num_fields)%end_time(j)   = get_cal_time(  tend(j),trim(units),trim(calendar_type),permit_calendar_conversion)
         enddo
             
         if (field(num_fields)%modulo_time) then
            call set_time_modulo(field(num_fields)%Time)
            call set_time_modulo(field(num_fields)%start_time)
            call set_time_modulo(field(num_fields)%end_time)
         endif

         if(present(correct_leap_year_inconsistency)) then
           field(num_fields)%correct_leap_year_inconsistency = correct_leap_year_inconsistency
         else
           field(num_fields)%correct_leap_year_inconsistency = .false.
         endif
             
         if(get_axis_modulo_times(time_axis, timebeg, timeend)) then
           if(get_calendar_type() == NO_CALENDAR) then
             field(num_fields)%modulo_time_beg = set_time(timebeg)
             field(num_fields)%modulo_time_end = set_time(timeend)
           else
             field(num_fields)%modulo_time_beg = set_date(timebeg)
             field(num_fields)%modulo_time_end = set_date(timeend)
           endif
           field(num_fields)%have_modulo_times = .true.
         else
           field(num_fields)%have_modulo_times = .false.
         endif
         if(ntime == 1) then
            call mpp_error(NOTE, 'time_interp_external_mod: file '//trim(file)//'  has only one time level')
         else                
            do j= 1, ntime
               field(num_fields)%period(j) = field(num_fields)%end_time(j)-field(num_fields)%start_time(j)
               if (field(num_fields)%period(j) > set_time(0,0)) then
                  call get_time(field(num_fields)%period(j), sec, day)
                  sec = sec/2+mod(day,2)*43200
                  day = day/2
                  field(num_fields)%time(j) = field(num_fields)%start_time(j)+&
                       set_time(sec,day)
               else
                  if (j > 1 .and. j < ntime) then
                     tdiff = field(num_fields)%time(j+1) -  field(num_fields)%time(j-1)
                     call get_time(tdiff, sec, day)
                     sec = sec/2+mod(day,2)*43200
                     day = day/2
                     field(num_fields)%period(j) = set_time(sec,day)
                     sec = sec/2+mod(day,2)*43200
                     day = day/2
                     field(num_fields)%start_time(j) = field(num_fields)%time(j) - set_time(sec,day)
                     field(num_fields)%end_time(j) = field(num_fields)%time(j) + set_time(sec,day)
                  elseif ( j == 1) then
                     tdiff = field(num_fields)%time(2) -  field(num_fields)%time(1)
                     call get_time(tdiff, sec, day)
                     field(num_fields)%period(j) = set_time(sec,day)
                     sec = sec/2+mod(day,2)*43200
                     day = day/2
                     field(num_fields)%start_time(j) = field(num_fields)%time(j) - set_time(sec,day)
                     field(num_fields)%end_time(j) = field(num_fields)%time(j) + set_time(sec,day)
                  else
                     tdiff = field(num_fields)%time(ntime) -  field(num_fields)%time(ntime-1)
                     call get_time(tdiff, sec, day)
                     field(num_fields)%period(j) = set_time(sec,day)
                     sec = sec/2+mod(day,2)*43200
                     day = day/2
                     field(num_fields)%start_time(j) = field(num_fields)%time(j) - set_time(sec,day)
                     field(num_fields)%end_time(j) = field(num_fields)%time(j) + set_time(sec,day)
                  endif
               endif
            enddo
         endif
             
         do j=1,ntime-1
            if (field(num_fields)%time(j) >= field(num_fields)%time(j+1)) then
               write(msg,'(A,i20)') "times not monotonically increasing. Filename: " &
                    //TRIM(file)//"  field:  "//TRIM(fieldname)//" timeslice: ", j
               call mpp_error(FATAL, TRIM(msg))
            endif
         enddo
             
         field(num_fields)%modulo_time = get_axis_modulo(time_axis)
             
         if (verb) then
            if (field(num_fields)%modulo_time) write(outunit,*) 'data are being treated as modulo in time'
            do j= 1, ntime
               write(outunit,*) 'time index,  ', j
               call get_date(field(num_fields)%start_time(j),yr,mon,day,hr,minu,sec)
               write(outunit,'(a,i4,a,i2,a,i2,1x,i2,a,i2,a,i2)') &
                    'start time: yyyy/mm/dd hh:mm:ss= ',yr,'/',mon,'/',day,hr,':',minu,':',sec
               call get_date(field(num_fields)%time(j),yr,mon,day,hr,minu,sec)
               write(outunit,'(a,i4,a,i2,a,i2,1x,i2,a,i2,a,i2)') &
                    'mid time: yyyy/mm/dd hh:mm:ss= ',yr,'/',mon,'/',day,hr,':',minu,':',sec
               call get_date(field(num_fields)%end_time(j),yr,mon,day,hr,minu,sec)
               write(outunit,'(a,i4,a,i2,a,i2,1x,i2,a,i2,a,i2)') &
                    'end time: yyyy/mm/dd hh:mm:ss= ',yr,'/',mon,'/',day,hr,':',minu,':',sec                  
            enddo
         end if

      enddo
    
      if (num_fields == nfields_orig) then
        if (present(ierr)) then
           ierr = ERR_FIELD_NOT_FOUND
        else
           call mpp_error(FATAL,'external field "'//trim(fieldname)//'" not found in file "'//trim(file)//'"')
        endif
      endif

      deallocate(global_atts)
      deallocate(axes)
      deallocate(flds)
      deallocate(tstamp, tstart, tend, tavg)

      return
      
    end function init_external_field
    
!</FUNCTION> NAME="init_external_field"


    subroutine time_interp_external_2d(index, time, data_in, interp, verbose,horz_interp, mask_out, &
               is_in, ie_in, js_in, je_in, window_id)

      integer, intent(in) :: index
      type(time_type), intent(in) :: time
      real, dimension(:,:), intent(inout) :: data_in
      integer, intent(in), optional :: interp
      logical, intent(in), optional :: verbose
      type(horiz_interp_type),intent(in), optional :: horz_interp
      logical, dimension(:,:), intent(out), optional :: mask_out ! set to true where output data is valid 
      integer,                  intent(in), optional :: is_in, ie_in, js_in, je_in
      integer,                  intent(in), optional :: window_id

      real   , dimension(size(data_in,1), size(data_in,2), 1) :: data_out
      logical, dimension(size(data_in,1), size(data_in,2), 1) :: mask3d

      data_out(:,:,1) = data_in(:,:) ! fill initial values for the portions of array that are not touched by 3d routine
      call time_interp_external_3d(index, time, data_out, interp, verbose, horz_interp, mask3d, &
                                   is_in=is_in,ie_in=ie_in,js_in=js_in,je_in=je_in,window_id=window_id)
      data_in(:,:) = data_out(:,:,1)
      if (PRESENT(mask_out)) mask_out(:,:) = mask3d(:,:,1)

      return
    end subroutine time_interp_external_2d

!<SUBROUTINE NAME="time_interp_external" >
!
!<DESCRIPTION>
! Provide data from external file interpolated to current model time.
! Data may be local to current processor or global, depending on 
! "init_external_field" flags.
!</DESCRIPTION>
!
!<IN NAME="index" TYPE="integer">
! index of external field from previous call to init_external_field
!</IN>
!<IN NAME="time" TYPE="time_manager_mod:time_type">
! target time for data
!</IN>
!<INOUT NAME="data" TYPE="real" DIM="(:,:),(:,:,:)">
! global or local data array 
!</INOUT>
!<IN NAME="interp" TYPE="integer">
! time_interp_external defined interpolation method (optional).  Currently this module only supports
! LINEAR_TIME_INTERP. 
!</IN>
!<IN NAME="verbose" TYPE="logical">
! verbose flag for debugging (optional).
!</IN>

    subroutine time_interp_external_3d(index, time, data, interp,verbose,horz_interp, mask_out, is_in, ie_in, js_in, je_in, window_id)

      integer,                    intent(in)           :: index
      type(time_type),            intent(in)           :: time
      real, dimension(:,:,:),  intent(inout)           :: data
      integer,                    intent(in), optional :: interp
      logical,                    intent(in), optional :: verbose
      type(horiz_interp_type),    intent(in), optional :: horz_interp
      logical, dimension(:,:,:), intent(out), optional :: mask_out ! set to true where output data is valid 
      integer,                    intent(in), optional :: is_in, ie_in, js_in, je_in
      integer,                    intent(in), optional :: window_id

      integer :: nx, ny, nz, interp_method, t1, t2
      integer :: i1, i2, isc, iec, jsc, jec, mod_time, outunit
      integer :: yy, mm, dd, hh, min, ss
      character(len=256) :: err_msg, filename

      integer :: isw, iew, jsw, jew, nxw, nyw
          ! these are boundaries of the updated portion of the "data" argument
          ! they are calculated using sizes of the "data" and isc,iec,jsc,jsc
          ! fileds from respective input field, to center the updated portion
          ! in the output array
 
      real :: w1,w2
      logical :: verb
      character(len=16) :: message1, message2

      nx = size(data,1)
      ny = size(data,2)
      nz = size(data,3)
      outunit = stdout()

      interp_method = LINEAR_TIME_INTERP
      if (PRESENT(interp)) interp_method = interp
      verb=.false.
      if (PRESENT(verbose)) verb=verbose
      if (debug_this_module) verb = .true.
      
      if (index < 1.or.index > num_fields) &
           call mpp_error(FATAL,'invalid index in call to time_interp_ext -- field was not initialized or failed to initialize')

      isc=field(index)%isc;iec=field(index)%iec
      jsc=field(index)%jsc;jec=field(index)%jec

      if( field(index)%numwindows == 1 ) then
         nxw = iec-isc+1
         nyw = jec-jsc+1 
      else
         if( .not. present(is_in) .or. .not. present(ie_in) .or. .not. present(js_in) .or. .not. present(je_in) ) then
            call mpp_error(FATAL, 'time_interp_external: is_in, ie_in, js_in and je_in must be present ' // &
                                  'when numwindows > 1, field='//trim(field(index)%name))
         endif
         nxw = ie_in - is_in + 1
         nyw = je_in - js_in + 1
         isc = isc + is_in - 1
         iec = isc + ie_in - is_in
         jsc = jsc + js_in - 1
         jec = jsc + je_in - js_in
      endif
      
      isw = (nx-nxw)/2+1; iew = isw+nxw-1
      jsw = (ny-nyw)/2+1; jew = jsw+nyw-1

      if (nx < nxw .or. ny < nyw .or. nz < field(index)%siz(3)) then
         write(message1,'(i6,2i5)') nx,ny,nz
         call mpp_error(FATAL,'field '//trim(field(index)%name)//' Array size mismatch in time_interp_external.'// &
         ' Array "data" is too small. shape(data)='//message1)
      endif
      if(PRESENT(mask_out)) then
        if (size(mask_out,1) /= nx .or. size(mask_out,2) /= ny .or. size(mask_out,3) /= nz) then
          write(message1,'(i6,2i5)') nx,ny,nz
          write(message2,'(i6,2i5)') size(mask_out,1),size(mask_out,2),size(mask_out,3)
          call mpp_error(FATAL,'field '//trim(field(index)%name)//' array size mismatch in time_interp_external.'// &
          ' Shape of array "mask_out" does not match that of array "data".'// &
          ' shape(data)='//message1//' shape(mask_out)='//message2)
        endif
      endif

      if (field(index)%siz(4) == 1) then
         ! only one record in the file => time-independent field
         call load_record(field(index),1,horz_interp, is_in, ie_in ,js_in, je_in,window_id)
         i1 = find_buf_index(1,field(index)%ibuf)
         if( field(index)%region_type == NO_REGION ) then
            where(field(index)%mask(isc:iec,jsc:jec,:,i1))
               data(isw:iew,jsw:jew,:) = field(index)%data(isc:iec,jsc:jec,:,i1)
            elsewhere
               data(isw:iew,jsw:jew,:) = time_interp_missing !field(index)%missing? Balaji
            end where
         else
            where(field(index)%mask(isc:iec,jsc:jec,:,i1))
               data(isw:iew,jsw:jew,:) = field(index)%data(isc:iec,jsc:jec,:,i1)
            end where
         endif
         if(PRESENT(mask_out)) &
              mask_out(isw:iew,jsw:jew,:) = field(index)%mask(isc:iec,jsc:jec,:,i1)
      else
        if(field(index)%have_modulo_times) then
          call time_interp(time,field(index)%modulo_time_beg, field(index)%modulo_time_end, field(index)%time(:), &
                          w2, t1, t2, field(index)%correct_leap_year_inconsistency, err_msg=err_msg)
          if(err_msg .NE. '') then
             filename = mpp_get_file_name(field(index)%unit)
             call mpp_error(FATAL,"time_interp_external 1: "//trim(err_msg)//&
                    ",file="//trim(filename)//",field="//trim(field(index)%name) )
          endif      
        else
          if(field(index)%modulo_time) then
            mod_time=1
          else
            mod_time=0
          endif
          call time_interp(time,field(index)%time(:),w2,t1,t2,modtime=mod_time, err_msg=err_msg)
          if(err_msg .NE. '') then
             filename = mpp_get_file_name(field(index)%unit)
             call mpp_error(FATAL,"time_interp_external 2: "//trim(err_msg)//&
                    ",file="//trim(filename)//",field="//trim(field(index)%name) )
          endif     
        endif
         w1 = 1.0-w2
         if (verb) then
            call get_date(time,yy,mm,dd,hh,min,ss)
            write(outunit,'(a,i4,a,i2,a,i2,1x,i2,a,i2,a,i2)') &
                 'target time yyyy/mm/dd hh:mm:ss= ',yy,'/',mm,'/',dd,hh,':',min,':',ss
            write(outunit,*) 't1, t2, w1, w2= ', t1, t2, w1, w2
         endif

         call load_record(field(index),t1,horz_interp, is_in, ie_in ,js_in, je_in, window_id)
         call load_record(field(index),t2,horz_interp, is_in, ie_in ,js_in, je_in, window_id)
         i1 = find_buf_index(t1,field(index)%ibuf)
         i2 = find_buf_index(t2,field(index)%ibuf)
         if(i1<0.or.i2<0) &
              call mpp_error(FATAL,'time_interp_external : records were not loaded correctly in memory')

         if (verb) then
            write(outunit,*) 'ibuf= ',field(index)%ibuf
            write(outunit,*) 'i1,i2= ',i1, i2
         endif

         if( field(index)%region_type == NO_REGION ) then
            where(field(index)%mask(isc:iec,jsc:jec,:,i1).and.field(index)%mask(isc:iec,jsc:jec,:,i2))
               data(isw:iew,jsw:jew,:) = field(index)%data(isc:iec,jsc:jec,:,i1)*w1 + &
                    field(index)%data(isc:iec,jsc:jec,:,i2)*w2
            elsewhere
               data(isw:iew,jsw:jew,:) = time_interp_missing !field(index)%missing? Balaji
            end where
         else
            where(field(index)%mask(isc:iec,jsc:jec,:,i1).and.field(index)%mask(isc:iec,jsc:jec,:,i2))
               data(isw:iew,jsw:jew,:) = field(index)%data(isc:iec,jsc:jec,:,i1)*w1 + &
                    field(index)%data(isc:iec,jsc:jec,:,i2)*w2
            end where
         endif
         if(PRESENT(mask_out)) &
              mask_out(isw:iew,jsw:jew,:) = &
                                        field(index)%mask(isc:iec,jsc:jec,:,i1).and.&
                                        field(index)%mask(isc:iec,jsc:jec,:,i2)
      endif

    end subroutine time_interp_external_3d
!</SUBROUTINE> NAME="time_interp_external"
    
    subroutine time_interp_external_0d(index, time, data, verbose)

      integer, intent(in) :: index
      type(time_type), intent(in) :: time
      real, intent(inout) :: data
      logical, intent(in), optional :: verbose
      
      integer :: t1, t2, outunit
      integer :: i1, i2, mod_time
      integer :: yy, mm, dd, hh, min, ss
      character(len=256) :: err_msg, filename

      real :: w1,w2
      logical :: verb

      outunit = stdout()
      verb=.false.
      if (PRESENT(verbose)) verb=verbose
      if (debug_this_module) verb = .true.
      
      if (index < 1.or.index > num_fields) &
           call mpp_error(FATAL,'invalid index in call to time_interp_ext -- field was not initialized or failed to initialize')
     
      if (field(index)%siz(4) == 1) then
         ! only one record in the file => time-independent field
         call load_record_0d(field(index),1)
         i1 = find_buf_index(1,field(index)%ibuf)
         data = field(index)%data(1,1,1,i1)
      else
        if(field(index)%have_modulo_times) then
          call time_interp(time,field(index)%modulo_time_beg, field(index)%modulo_time_end, field(index)%time(:), &
                          w2, t1, t2, field(index)%correct_leap_year_inconsistency, err_msg=err_msg)
          if(err_msg .NE. '') then
             filename = mpp_get_file_name(field(index)%unit)
             call mpp_error(FATAL,"time_interp_external 3:"//trim(err_msg)//&
                    ",file="//trim(filename)//",field="//trim(field(index)%name) )
          endif    
        else
          if(field(index)%modulo_time) then
            mod_time=1
          else
            mod_time=0
          endif
          call time_interp(time,field(index)%time(:),w2,t1,t2,modtime=mod_time, err_msg=err_msg)
          if(err_msg .NE. '') then
             filename = mpp_get_file_name(field(index)%unit)
             call mpp_error(FATAL,"time_interp_external 4:"//trim(err_msg)// &
                    ",file="//trim(filename)//",field="//trim(field(index)%name) )
          endif     
        endif
         w1 = 1.0-w2
         if (verb) then
            call get_date(time,yy,mm,dd,hh,min,ss)
            write(outunit,'(a,i4,a,i2,a,i2,1x,i2,a,i2,a,i2)') &
                 'target time yyyy/mm/dd hh:mm:ss= ',yy,'/',mm,'/',dd,hh,':',min,':',ss
            write(outunit,*) 't1, t2, w1, w2= ', t1, t2, w1, w2
         endif
         call load_record_0d(field(index),t1)
         call load_record_0d(field(index),t2)
         i1 = find_buf_index(t1,field(index)%ibuf)
         i2 = find_buf_index(t2,field(index)%ibuf)

         if(i1<0.or.i2<0) &
              call mpp_error(FATAL,'time_interp_external : records were not loaded correctly in memory')
         data = field(index)%data(1,1,1,i1)*w1 + field(index)%data(1,1,1,i2)*w2
         if (verb) then
            write(outunit,*) 'ibuf= ',field(index)%ibuf
            write(outunit,*) 'i1,i2= ',i1, i2
         endif
      endif

    end subroutine time_interp_external_0d

    subroutine set_time_modulo(Time)

      type(time_type), intent(inout), dimension(:) :: Time

      integer :: ntime, n
      integer :: yr, mon, dy, hr, minu, sec
      
      ntime = size(Time(:))

      do n = 1, ntime
         call get_date(Time(n), yr, mon, dy, hr, minu, sec)
         yr = modulo_year
         Time(n) = set_date(yr, mon, dy, hr, minu, sec)
      enddo


    end subroutine set_time_modulo

! ============================================================================
! load specified record from file  
subroutine load_record(field, rec, interp, is_in, ie_in, js_in, je_in, window_id_in)
  type(ext_fieldtype),     intent(inout)        :: field
  integer            ,     intent(in)           :: rec    ! record number
  type(horiz_interp_type), intent(in), optional :: interp
  integer,                 intent(in), optional :: is_in, ie_in, js_in, je_in
  integer,                 intent(in), optional :: window_id_in

  ! ---- local vars 
  integer :: ib ! index in the array of input buffers
  integer :: isw,iew,jsw,jew ! boundaries of the domain on each window
  integer :: outunit
  integer :: is_region, ie_region, js_region, je_region, i, j, n
  integer :: start(4), nread(4)
  logical :: need_compute
  real    :: mask_in(size(field%src_data,1),size(field%src_data,2),size(field%src_data,3))
  real, allocatable :: mask_out(:,:,:)
  integer :: window_id

  window_id = 1
  if( PRESENT(window_id_in) ) window_id = window_id_in
  outunit = stdout()
  need_compute = .true.  

!$OMP CRITICAL
  ib = find_buf_index(rec,field%ibuf)

  if(ib>0) then
     !--- do nothing   
     need_compute = .false.  
  else
     ! calculate current buffer number in round-robin fasion
     field%nbuf = field%nbuf + 1
     if(field%nbuf > size(field%data,4).or.field%nbuf <= 0) field%nbuf = 1
     ib = field%nbuf
     field%ibuf(ib) = rec
     field%need_compute(ib,:) = .true.
 
     if (field%domain_present .and. .not.PRESENT(interp)) then
        if (debug_this_module) write(outunit,*) 'reading record with domain for field ',trim(field%name)
        call mpp_read(field%unit,field%field,field%domain,field%src_data(:,:,:,ib),rec)
     else
        if (debug_this_module) write(outunit,*) 'reading record without domain for field ',trim(field%name)
        start = 1; nread = 1
        start(1) = field%is_src; nread(1) = field%ie_src - field%is_src + 1
        start(2) = field%js_src; nread(2) = field%je_src - field%js_src + 1
        start(3) = 1;            nread(3) = size(field%src_data,3)
        start(field%tdim) = rec; nread(field%tdim) = 1
        call mpp_read(field%unit,field%field,field%src_data(:,:,:,ib),start,nread)
     endif
  endif
!$OMP END CRITICAL  
  isw=field%isc;iew=field%iec
  jsw=field%jsc;jew=field%jec

  if( field%numwindows > 1) then
     if( .NOT. PRESENT(is_in) .OR. .NOT. PRESENT(ie_in) .OR. .NOT. PRESENT(js_in) .OR. .NOT. PRESENT(je_in) ) then
        call mpp_error(FATAL, 'time_interp_external(load_record): is_in, ie_in, js_in, je_in must be present when numwindows>1') 
     endif
     isw = isw + is_in - 1
     iew = isw + ie_in - is_in
     jsw = jsw + js_in - 1
     jew = jsw + je_in - js_in
  endif

  ! interpolate to target grid 

  need_compute = field%need_compute(ib, window_id)
  if(need_compute) then
     if(PRESENT(interp)) then
        is_region = field%is_region; ie_region = field%ie_region
        js_region = field%js_region; je_region = field%je_region
        mask_in = 0.0
        where (mpp_is_valid(field%src_data(:,:,:,ib), field%valid)) mask_in = 1.0
        if ( field%region_type .NE. NO_REGION ) then
           if( ANY(mask_in == 0.0) ) then
              call mpp_error(FATAL, "time_interp_external: mask_in should be all 1 when region_type is not NO_REGION")
           endif
           if( field%region_type == OUTSIDE_REGION) then
              do j = js_region, je_region
                 do i = is_region, ie_region
                    mask_in(i,j,:) = 0.0
                 enddo
              enddo
           else  ! field%region_choice == INSIDE_REGION
              do j = 1, size(mask_in,2)
                 do i = 1, size(mask_in,1)
                    if( j<js_region .OR. j>je_region .OR. i<is_region .OR. i>ie_region ) mask_in(i,j,:) = 0.0
                 enddo
              enddo
           endif
        endif
        allocate(mask_out(isw:iew,jsw:jew, size(field%src_data,3)))
        call horiz_interp(interp,field%src_data(:,:,:,ib),field%data(isw:iew,jsw:jew,:,ib), &
             mask_in=mask_in, &
             mask_out=mask_out)

        field%mask(isw:iew,jsw:jew,:,ib) = mask_out(isw:iew,jsw:jew,:) > 0
        deallocate(mask_out)
        field%need_compute(ib, window_id) = .false.
     else
        if ( field%region_type .NE. NO_REGION ) then
           call mpp_error(FATAL, "time_interp_external: region_type should be NO_REGION when interp is not present") 
        endif
        field%data(isw:iew,jsw:jew,:,ib) = field%src_data(isw:iew,jsw:jew,:,ib)
        field%mask(isw:iew,jsw:jew,:,ib) = mpp_is_valid(field%data(isw:iew,jsw:jew,:,ib),field%valid)
     endif
     ! convert units
     where(field%mask(isw:iew,jsw:jew,:,ib)) field%data(isw:iew,jsw:jew,:,ib) = &
          field%data(isw:iew,jsw:jew,:,ib)*field%slope + field%intercept
  endif

end subroutine load_record


subroutine load_record_0d(field, rec)
  type(ext_fieldtype),     intent(inout)        :: field
  integer            ,     intent(in)           :: rec    ! record number
  ! ---- local vars 
  integer :: ib ! index in the array of input buffers
  integer :: outunit
  integer :: start(4), nread(4)

  outunit = stdout()
  ib = find_buf_index(rec,field%ibuf)

  if(ib>0) then
     return
  else
     ! calculate current buffer number in round-robin fasion
     field%nbuf = field%nbuf + 1
     if(field%nbuf > size(field%data,4).or.field%nbuf <= 0) field%nbuf = 1
     ib = field%nbuf
     field%ibuf(ib) = rec
 
     if (debug_this_module) write(outunit,*) 'reading record without domain for field ',trim(field%name)
     start = 1; nread = 1
     start(3) = 1;            nread(3) = size(field%src_data,3)
     start(field%tdim) = rec; nread(field%tdim) = 1
     call mpp_read(field%unit,field%field,field%src_data(:,:,:,ib),start,nread)
     if ( field%region_type .NE. NO_REGION ) then
        call mpp_error(FATAL, "time_interp_external: region_type should be NO_REGION when field is scalar")
     endif
     field%data(1,1,:,ib) = field%src_data(1,1,:,ib)
     field%mask(1,1,:,ib) = mpp_is_valid(field%data(1,1,:,ib),field%valid)
     ! convert units
     where(field%mask(1,1,:,ib)) field%data(1,1,:,ib) = &
          field%data(1,1,:,ib)*field%slope + field%intercept
  endif  

end subroutine load_record_0d

! ============================================================================
subroutine reset_src_data_region(index, is, ie, js, je)
   integer, intent(in) :: index
   integer, intent(in) :: is, ie, js, je
   integer             :: nk, nbuf

   if( is == field(index)%is_src .AND. ie == field(index)%ie_src .AND. &
       js == field(index)%js_src .AND. ie == field(index)%je_src ) return

   if( .NOT. ASSOCIATED(field(index)%src_data) ) call mpp_error(FATAL, &
       "time_interp_external: field(index)%src_data is not associated")
   nk = size(field(index)%src_data,3)
   nbuf = size(field(index)%src_data,4)
   deallocate(field(index)%src_data)
   allocate(field(index)%src_data(is:ie,js:je,nk,nbuf))
   field(index)%is_src = is
   field(index)%ie_src = ie
   field(index)%js_src = js
   field(index)%je_src = je
   

end subroutine reset_src_data_region

! ============================================================================
subroutine set_override_region(index, region_type, is_region, ie_region, js_region, je_region)
   integer, intent(in) :: index, region_type
   integer, intent(in) :: is_region, ie_region, js_region, je_region

   field(index)%region_type = region_type
   field(index)%is_region   = is_region
   field(index)%ie_region   = ie_region
   field(index)%js_region   = js_region   
   field(index)%je_region   = je_region

   return

end subroutine set_override_region

! ============================================================================
! reallocates array of fields, increasing its size
subroutine realloc_files(n)
  integer, intent(in) :: n ! new size

  type(filetype), pointer :: ptr(:)
  integer :: i

  if (associated(opened_files)) then
     if (n <= size(opened_files)) return ! do nothing, if requested size no more than current
  endif

  allocate(ptr(n))
  do i = 1, size(ptr)
     ptr(i)%filename = ''
     ptr(i)%unit = -1
  enddo
  
  if (associated(opened_files))then
     ptr(1:size(opened_files)) = opened_files(:)
     deallocate(opened_files)
  endif
  opened_files => ptr

end subroutine realloc_files

! ============================================================================
! reallocates array of fields,increasing its size
subroutine realloc_fields(n)
  integer, intent(in) :: n ! new size

  type(ext_fieldtype), pointer :: ptr(:)
  integer :: i, ier

  if (associated(field)) then
     if (n <= size(field)) return ! do nothing if requested size no more then current
  endif

  allocate(ptr(n))
  do i=1,size(ptr)
     ptr(i)%unit=-1
     ptr(i)%name=''
     ptr(i)%units=''
     ptr(i)%siz=-1
     ptr(i)%ndim=-1
     ptr(i)%domain = NULL_DOMAIN2D
     ptr(i)%axes(:) = default_axis
     if (ASSOCIATED(ptr(i)%time))       DEALLOCATE(ptr(i)%time, stat=ier)
     if (ASSOCIATED(ptr(i)%start_time)) DEALLOCATE(ptr(i)%start_time, stat=ier)
     if (ASSOCIATED(ptr(i)%end_time))   DEALLOCATE(ptr(i)%end_time, stat=ier)
     ptr(i)%field = default_field
     if (ASSOCIATED(ptr(i)%period)) DEALLOCATE(ptr(i)%period, stat=ier)
     ptr(i)%modulo_time=.false.
     if (ASSOCIATED(ptr(i)%data)) DEALLOCATE(ptr(i)%data, stat=ier)
     if (ASSOCIATED(ptr(i)%ibuf)) DEALLOCATE(ptr(i)%ibuf, stat=ier)
     if (ASSOCIATED(ptr(i)%src_data)) DEALLOCATE(ptr(i)%src_data, stat=ier)
     ptr(i)%nbuf=-1
     ptr(i)%domain_present=.false.
     ptr(i)%slope=1.0
     ptr(i)%intercept=0.0
     ptr(i)%isc=-1;ptr(i)%iec=-1
     ptr(i)%jsc=-1;ptr(i)%jec=-1
  enddo
  if (associated(field)) then
     ptr(1:size(field)) = field(:)
     deallocate(field)
  endif
  field=>ptr

end subroutine realloc_fields


    function find_buf_index(indx,buf)
      integer :: indx
      integer, dimension(:) :: buf
      integer :: find_buf_index

      integer :: nbuf, i
      
      nbuf = size(buf(:))

      find_buf_index = -1

      do i=1,nbuf
         if (buf(i) == indx) then
            find_buf_index = i
            exit
         endif
      enddo

    end function find_buf_index

!<FUNCTION NAME="get_external_field_size" TYPE="integer" DIM="(4)">
!
!<DESCRIPTION>
! return size of field after call to init_external_field.
! Ordering is X/Y/Z/T.
! This call only makes sense for non-distributed reads.
!</DESCRIPTION>
!
!<IN NAME="index" TYPE="integer">
! returned from previous call to init_external_field.
!</IN>

    function get_external_field_size(index)

      integer :: index
      integer :: get_external_field_size(4)
      
      if (index .lt. 1 .or. index .gt. num_fields) &
           call mpp_error(FATAL,'invalid index in call to get_external_field_size')


      get_external_field_size(1) = field(index)%siz(1)
      get_external_field_size(2) = field(index)%siz(2)
      get_external_field_size(3) = field(index)%siz(3)
      get_external_field_size(4) = field(index)%siz(4)

    end function get_external_field_size
!</FUNCTION> NAME="get_external_field"

! ===========================================================================
subroutine get_time_axis(index, time)
  integer        , intent(in)  :: index   ! field id
  type(time_type), intent(out) :: time(:) ! array of time values to be filled

  integer :: n ! size of the data to be assigned
    
  if (index < 1.or.index > num_fields) &
       call mpp_error(FATAL,'invalid index in call to get_time_axis')

  n = min(size(time),size(field(index)%time))
  
  time(1:n) = field(index)%time(1:n)  
end subroutine

!<SUBROUTINE NAME="time_interp_external_exit">
!
!<DESCRIPTION>
! exit time_interp_external_mod.  Close all open files and
! release storage
!</DESCRIPTION>

    subroutine time_interp_external_exit()

      integer :: i,j
!
! release storage arrays
!
      do i=1,num_fields
         deallocate(field(i)%time,field(i)%start_time,field(i)%end_time,&
              field(i)%period,field(i)%data,field(i)%mask,field(i)%ibuf)
         if (ASSOCIATED(field(i)%src_data)) deallocate(field(i)%src_data)
         do j=1,4
            field(i)%axes(j) = default_axis
         enddo
         field(i)%domain = NULL_DOMAIN2D
         field(i)%field = default_field
         field(i)%nbuf = 0
         field(i)%slope = 0.
         field(i)%intercept = 0.
      enddo
      
      deallocate(field)
      deallocate(opened_files)

      num_fields = 0

      module_initialized = .false.

    end subroutine time_interp_external_exit
!</SUBROUTINE> NAME="time_interp_external_exit"

end module time_interp_external_mod

#ifdef test_time_interp_external

program test_time_interp_ext
use constants_mod, only: constants_init
use fms_mod,       only: open_namelist_file, check_nml_error
use mpp_mod, only : mpp_init, mpp_exit, mpp_npes, stdout, stdlog, FATAL, mpp_error
use mpp_mod, only : input_nml_file
use mpp_io_mod, only : mpp_io_init, mpp_io_exit, mpp_open, MPP_RDONLY, MPP_ASCII, mpp_close, &
                       axistype, mpp_get_axis_data
use mpp_domains_mod, only : mpp_domains_init, domain2d, mpp_define_layout, mpp_define_domains,&
     mpp_global_sum, mpp_global_max, mpp_global_min, BITWISE_EXACT_SUM, mpp_get_compute_domain, &
     mpp_domains_set_stack_size
use time_interp_external_mod, only : time_interp_external, time_interp_external_init,&
     time_interp_external_exit, time_interp_external, init_external_field, get_external_field_size
use time_manager_mod, only : get_date, set_date, time_manager_init, set_calendar_type, JULIAN, time_type, increment_time,&
                             NOLEAP
use horiz_interp_mod, only: horiz_interp, horiz_interp_init, horiz_interp_new, horiz_interp_del, horiz_interp_type
use axis_utils_mod, only: get_axis_bounds
implicit none



integer :: id, i, io_status, unit, ierr
character(len=128) :: filename, fieldname
type(time_type) :: time
real, allocatable, dimension(:,:,:) :: data_d, data_g
logical, allocatable, dimension(:,:,:) :: mask_d
type(domain2d) :: domain, domain_out
integer :: layout(2), fld_size(4)
integer :: isc, iec, jsc, jec, isd, ied, jsd, jed
integer :: yy, mm, dd, hh, ss
real :: sm,mx,mn
character(len=12) :: cal_type
integer :: ntime=12,year0=1991,month0=1,day0=1,days_inc=31
type(horiz_interp_type) :: Hinterp
type(axistype) :: Axis_centers(4), Axis_bounds(4)
real :: lon_out(180,89), lat_out(180,89)
real, allocatable, dimension(:,:) :: lon_local_out, lat_local_out
real, allocatable, dimension(:) :: lon_in, lat_in
integer :: isc_o, iec_o, jsc_o, jec_o, outunit

namelist /test_time_interp_ext_nml/ filename, fieldname,ntime,year0,month0,&
     day0,days_inc, cal_type

call constants_init
call mpp_init
call mpp_io_init
call mpp_domains_init
call time_interp_external_init
call time_manager_init
call horiz_interp_init

#ifdef INTERNAL_FILE_NML
      read (input_nml_file, test_time_interp_ext_nml, iostat=io_status)
      ierr = check_nml_error(io_status, 'test_time_interp_ext_nml')
#else
      unit = open_namelist_file ()
      ierr=1; do while (ierr /= 0)
      read  (unit, nml=test_time_interp_ext_nml, iostat=io_status, end=10)
      ierr = check_nml_error(io_status, 'test_time_interp_ext_nml')
      enddo
10    call close_file (unit)
#endif

outunit = stdlog()
write(outunit,test_time_interp_ext_nml)

select case (trim(cal_type))
case ('julian')
   call set_calendar_type(JULIAN)
case ('no_leap')
   call set_calendar_type(NOLEAP)
case default
   call mpp_error(FATAL,'invalid calendar type')
end select

outunit = stdout()
write(outunit,*) 'INTERPOLATING NON DECOMPOSED FIELDS'
write(outunit,*) '======================================'

call time_interp_external_init

id = init_external_field(filename,fieldname,verbose=.true.)

fld_size = get_external_field_size(id)

allocate(data_g(fld_size(1),fld_size(2),fld_size(3)))
data_g = 0

time = set_date(year0,month0,day0,0,0,0)

do i=1,ntime
   call time_interp_external(id,time,data_g,verbose=.true.)
   sm = sum(data_g)
   mn = minval(data_g)
   mx = maxval(data_g)
   write(outunit,*) 'sum= ', sm
   write(outunit,*) 'max= ', mx
   write(outunit,*) 'min= ', mn
   time = increment_time(time,0,days_inc)
enddo

call mpp_define_layout((/1,fld_size(1),1,fld_size(2)/),mpp_npes(),layout)
call mpp_define_domains((/1,fld_size(1),1,fld_size(2)/),layout,domain)
call mpp_get_compute_domain(domain,isc,iec,jsc,jec)
call mpp_get_compute_domain(domain,isd,ied,jsd,jed)

call mpp_domains_set_stack_size(fld_size(1)*fld_size(2)*min(fld_size(3),1)*2)
allocate(data_d(isd:ied,jsd:jed,fld_size(3)))
data_d = 0

write(outunit,*) 'INTERPOLATING DOMAIN DECOMPOSED FIELDS'
write(outunit,*) '======================================'

id = init_external_field(filename,fieldname,domain=domain, verbose=.true.)

time = set_date(year0,month0,day0)

do i=1,ntime
   call time_interp_external(id,time,data_d,verbose=.true.)
   sm = mpp_global_sum(domain,data_d,flags=BITWISE_EXACT_SUM)
   mx = mpp_global_max(domain,data_d)
   mn = mpp_global_min(domain,data_d)
   write(outunit,*) 'global sum= ', sm
   write(outunit,*) 'global max= ', mx
   write(outunit,*) 'global min= ', mn
   time = increment_time(time,0,days_inc)
enddo

write(outunit,*) 'INTERPOLATING DOMAIN DECOMPOSED FIELDS USING HORIZ INTERP'
write(outunit,*) '======================================'


! define a global 2 degree output grid

do i=1,180
   lon_out(i,:) = 2.0*i*atan(1.0)/45.0
enddo

do i=1,89
   lat_out(:,i) = (i-45)*2.0*atan(1.0)/45.0
enddo

call mpp_define_layout((/1,180,1,89/),mpp_npes(),layout)
call mpp_define_domains((/1,180,1,89/),layout,domain_out)
call mpp_get_compute_domain(domain_out,isc_o,iec_o,jsc_o,jec_o)

id = init_external_field(filename,fieldname,domain=domain_out,axis_centers=axis_centers,&
      verbose=.true., override=.true.)

allocate (lon_local_out(isc_o:iec_o,jsc_o:jec_o))
allocate (lat_local_out(isc_o:iec_o,jsc_o:jec_o))

lon_local_out(isc_o:iec_o,jsc_o:jec_o) = lon_out(isc_o:iec_o,jsc_o:jec_o)
lat_local_out(isc_o:iec_o,jsc_o:jec_o) = lat_out(isc_o:iec_o,jsc_o:jec_o)

call get_axis_bounds(axis_centers(1), axis_bounds(1), axis_centers)
call get_axis_bounds(axis_centers(2), axis_bounds(2), axis_centers)

allocate(lon_in(fld_size(1)+1))
allocate(lat_in(fld_size(2)+1))

call mpp_get_axis_data(axis_bounds(1), lon_in) ; lon_in = lon_in*atan(1.0)/45
call mpp_get_axis_data(axis_bounds(2), lat_in) ; lat_in = lat_in*atan(1.0)/45

call horiz_interp_new(Hinterp,lon_in,lat_in, lon_local_out, lat_local_out, &
     interp_method='bilinear')

time = set_date(year0,month0,day0)

deallocate(data_d)
allocate(data_d(isc_o:iec_o,jsc_o:jec_o,fld_size(3)))
allocate(mask_d(isc_o:iec_o,jsc_o:jec_o,fld_size(3)))
do i=1,ntime
   data_d = 0
   call time_interp_external(id,time,data_d,verbose=.true.,horz_interp=Hinterp, mask_out=mask_d)
   sm = mpp_global_sum(domain_out,data_d,flags=BITWISE_EXACT_SUM)
   mx = mpp_global_max(domain_out,data_d)
   mn = mpp_global_min(domain_out,data_d)
   write(outunit,*) 'global sum= ', sm
   write(outunit,*) 'global max= ', mx
   write(outunit,*) 'global min= ', mn
   
   where(mask_d) 
      data_d = 1.0
   elsewhere
      data_d = 0.0
   endwhere
   sm = mpp_global_sum(domain_out,data_d,flags=BITWISE_EXACT_SUM)
   write(outunit,*) 'n valid points= ', sm
   
   time = increment_time(time,0,days_inc)
enddo

call horiz_interp_del(Hinterp)


call time_interp_external_exit


call mpp_io_exit
call mpp_exit
stop

end program test_time_interp_ext
#endif
    
  

      

module gauss_and_legendre_mod

use       fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, &
                         write_version_number

use constants_mod, only: pi

!-----------------------------------------------------------------------
!   computes Gaussian latitudes and associated Legendre polynomials
!
!-----------------------------------------------------------------------

implicit none
private

character(len=128), parameter :: version = '$Id: gauss_and_legendre.F90,v 10.0 2003/10/24 22:01:02 fms Exp $'
character(len=128), parameter :: tagname ='$Name: tikal $'

logical :: entry_to_logfile_done=.false.

public :: compute_legendre, compute_gaussian

contains

!-----------------------------------------------------------------------
subroutine compute_legendre(legendre, num_fourier, fourier_inc,  &
                num_spherical, sin_lat, n_lat)
!-----------------------------------------------------------------------

integer, intent (in) :: num_fourier, fourier_inc, num_spherical, n_lat
real,    intent (in), dimension(n_lat) :: sin_lat

real, intent (out), dimension(0:num_fourier, 0:num_spherical, n_lat)  :: legendre

integer :: j, m, n , fourier_max
real, dimension(0:num_fourier*fourier_inc, 0:num_spherical) :: poly, eps, m2, l2
real, dimension(0:num_fourier*fourier_inc) :: b
real, dimension(n_lat) :: cos_lat

if(.not.entry_to_logfile_done) then
  call write_version_number(version, tagname)
  entry_to_logfile_done=.true.
endif

fourier_max = num_fourier*fourier_inc

do j=1,n_lat
  cos_lat(j)=sqrt(1-sin_lat(j)*sin_lat(j))
end do

do n=0,num_spherical
  do m=0,fourier_max
    m2(m,n)   = m**2
    l2(m,n)   = (m+n)**2
  end do
end do

eps= sqrt((l2 -m2)/(4.0*l2 - 1.0))

do m=1,fourier_max
  b(m) = SQRT(0.5*(2.0*float(m) + 1.0)/float(m))
end do

poly(0,0) = sqrt(0.5)
do j=1,n_lat     
  do m=1,fourier_max
    poly(m,0) = b(m)*cos_lat(j)*poly(m-1,0)
  end do
  do m=0,fourier_max
     poly(m,1) =  sin_lat(j)*poly(m,0)/eps(m,1)
  end do

  do n=2,num_spherical
    do m=0,fourier_max
      poly(m,n) = (sin_lat(j)*poly(m,n-1) - eps(m,n-1)*poly(m,n-2))/eps(m,n)
    end do
  end do

  do n = 0, num_spherical
    do m = 0,num_fourier
      legendre(m,n,j) = poly(m*fourier_inc,n)
    end do
  end do
end do

return
end subroutine compute_legendre

!----------------------------------------------------------------------
subroutine compute_gaussian(sin_hem, wts_hem, n_hem)
!----------------------------------------------------------------------
!
!     reference:
!       press, h. william, et. al., numerical recipes (fortran version),
!       cambridge, england: cambridge university press (1990)
! 
!------------------------------------------------------------------------

integer, intent (in) :: n_hem
real, intent (out), dimension(n_hem) :: sin_hem, wts_hem

real :: converg
integer :: itermax
integer :: i, iter, j, n, nprec
real :: pp, p1, p2, p3, z, z1

if(.not.entry_to_logfile_done) then
  call write_version_number(version, tagname)
  entry_to_logfile_done=.true.
endif

! must use a more relaxed convergence criteria on the
! workstations than that for the cray T90
! fez code is commented out

!if(kind(converg).eq.8) then
!  converg = 1.0E-15
!else if(kind(converg).eq.4) then
!  converg = 1.0E-7
!else
!  call error_mesg('compute_gaussian','dont know what value to use for converg', FATAL)
!end if

! The 2 lines of code below will yeild a different result than the fez code
! when kind(converg)=4. converg is 1.0E-6 instead of 1.0E-7
! This should be investigated further, but it's OK for now because it yeilds
! the same result on the HPCS. -- pjp
nprec = precision(converg)
converg = .1**nprec


itermax = 10

n=2*n_hem
do i=1,n_hem
  z = cos(pi*(i - 0.25)/(n + 0.5))
  do iter=1,itermax
     p1 = 1.0
     p2 = 0.0

     do j=1,n
        p3 = p2
        p2 = p1
        p1 = ((2.0*j - 1.0)*z*p2 - (j - 1.0)*p3)/j
     end do

     pp = n*(z*p1 - p2)/(z*z - 1.0E+00)
     z1 = z
     z  = z1 - p1/pp
     if(ABS(z - z1) .LT. converg) go to 10
  end do
  call error_mesg('compute_gaussian','abscissas failed to converge in itermax iterations', FATAL)

  10  continue

  sin_hem (i)     = z
  wts_hem (i)     = 2.0/((1.0 - z*z)*pp*pp)

end do

return
end subroutine compute_gaussian
!----------------------------------------------------------------------

end module gauss_and_legendre_mod

      subroutine upper(string,length)

!***********************************************************************
!
!     upper.f - change lower case letter to upper case letter          *
!                                                                      *
!     George Lai Tue Jun 28 16:37:00 1994                              *
!                                                                      *
!***********************************************************************

      implicit         none

!      character string(length)
!      character*20 string
!      character, dimension(length) :: string
!      character (len=*), intent(inout) ::  string
!      character (len=*) ::  string
!      character (len=1), intent(inout) ::  string(20)
!ok      character (len=20), intent(inout) ::  string
      character (len=*), intent(inout) ::  string
      character char1
      integer,   intent(in)    ::  length
      integer i
      integer a, z, dist
      a = ichar('a')
      z = ichar('z')
      dist = ichar('A') - a

      do i = 1,length
        char1=string(i:i)
        if (ichar(char1) .ge. a .and.       &
            ichar(char1) .le. z) then
          string(i:i) = char(ichar(char1)+dist)
        endif
      end do

      return
      end

program runoff_regrid
  !-----------------------------------------------------------------------
  !                   GNU General Public License                        
  !                                                                      
  ! This program is free software; you can redistribute it and/or modify it and  
  ! are expected to follow the terms of the GNU General Public License  
  ! as published by the Free Software Foundation; either version 2 of   
  ! the License, or (at your option) any later version.                 
  !                                                                      
  ! MOM is distributed in the hope that it will be useful, but WITHOUT    
  ! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
  ! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
  ! License for more details.                                           
  !                                                                      
  ! For the full text of the GNU General Public License,                
  ! write to: Free Software Foundation, Inc.,                           
  !           675 Mass Ave, Cambridge, MA 02139, USA.                   
  ! or see:   http://www.gnu.org/licenses/gpl.html                      
  !-----------------------------------------------------------------------
  !
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Sergey Malyshev </CONTACT>
  ! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Zhi Liang </CONTACT>
  !
  ! <OVERVIEW>
  !   This program works together with program make_xgrids, create_grid to 
  !   remap runoff data from a spherical grid onto any grid (spherical or tripolar) 
  !   using conservative scheme.
  ! </OVERVIEW>

  !<DESCRIPTION>
  ! This program expects to read runoff data from a netcdf file, which is specfied
  ! by the namelist variable "src_data". The name of the runoff field in input file is specified 
  ! by the namelist variable "src_fld_name". The output file is a netcdf file specified
  ! by the namelist variable "dst_data". The name of the runoff field in output file is specified 
  ! by the namelist variable "src_fld_name". Both the source grid and  destination grid 
  ! are read from netcdf file "grid_spec.nc". The grid_spec.nc is expected contains
  ! field 'x_T' and 'y_T', which is the new name convention used as a prototype for ESMF.
  ! The source grid read from variable "xta" and "yta" of "grid_spec.nc" should match 
  ! the grid in "src_data". "grid_spec.nc" is generated by 
  ! " make_xgrid -a atmos_grid.nc -l atmos_grid.nc -o dst_grid.nc ",
  ! where dst_grid is the grid which you want remap runoff data on and atmos_grid.nc 
  ! is generated through program "create_grid", which is located at the same directory
  ! as this program. make_xgrid is a c program that generates exchange grid between 
  ! atmos, ocean and land grid. make_xgrid source code is located at 
  ! "../generate_grids/make_xgrids". If there is any land point has runoff data 
  ! after remapping runoff data onto destination grid, the runoff value of that land point
  ! will be moved to the nearest ocean point.
  !
  !</DESCRIPTION>
  !

  implicit none

#include "netcdf.inc"

  !--- namelist interface ----------------------------------------------
  !<NAMELIST NAME="runoff_regrid_nml">
  ! <DATA NAME="src_data" TYPE="character(len=128)" >
  !  Name of input file containing runoff data.
  ! </DATA>
  ! <DATA NAME="src_fld_name" TYPE="character(len=128)" >
  !  Name of runoff field in input file.
  ! </DATA>
  ! <DATA NAME="dst_fld_name" TYPE="character(len=128)" >
  !  Name of runoff field in output file.
  ! </DATA>
  ! <DATA NAME="dst_data" TYPE="character(len=128)" >
  !  Name of output file containing runoff data.
  ! </DATA>
  !</NAMELIST>

  character(len=128) :: src_fld_name = 'runoff'      ! name of the input runoff field
  character(len=128) :: dst_fld_name = 'runoff'      ! name of the output runoff field
  character(len=128) :: src_data     = 'src_data.nc' ! name of the runoff source data file
  character(len=128) :: dst_data     = 'dst_data.nc' ! name of the runoff output file

  namelist /runoff_regrid_nml/ src_fld_name, dst_fld_name, src_data, dst_data


  !--- version information ---------------------------------------------
  character(len=128)   :: version= '$ID$'
  character(len=128)   :: tagname= '$Name: tikal $'
  !--- other variables -------------------------------------------------
  real,    allocatable :: time_value(:)
  real,    allocatable :: runoff(:,:,:), runoff_src(:,:,:)
  logical, allocatable :: mask(:,:)
  real,    allocatable :: lon(:), lat(:), x_t_dst(:,:), y_t_dst(:,:), grid_x_t(:), grid_y_t(:)
  integer, allocatable :: i_atm_atmxocn(:), j_atm_atmxocn(:), i_ocn_atmxocn(:), j_ocn_atmxocn(:)
  integer, allocatable :: i_atm_atmxlnd(:), j_atm_atmxlnd(:), i_lnd_atmxlnd(:), j_lnd_atmxlnd(:)
  real,    allocatable :: area_atmxocn(:), area_atmxlnd(:)
  integer              :: ni_src, nj_src, ni_dst, nj_dst, ntime
  real,      parameter :: PI = 3.141592658979
  integer              :: stdout = 6 

  !--- initialize routine 
  call runoff_regrid_init()

  !--- read source data file -------------------------------------------
  call read_src_data()

  !--- read exchange grid information ----------------------------------
  call read_xgrid()

  !--- read the runoff data and remap onto destination grid.
  call remap_data()

  !--- write runoff data to destination file
  call write_dst_data()

  !--- release memory
  call runoff_regrid_end


contains

  !#######################################################################
  !--- initialization routine: read namelist, write namelist and version information
  subroutine runoff_regrid_init
    integer :: unit=7, iostat 
    logical :: opened

    !--- read namelist 
    do 
       inquire( unit, opened = opened )
       if( .not. opened ) exit
       unit = unit + 1
       if( unit.EQ.100 )call error_handler( 'Error: unable to locate unit number.' )
    enddo

    open (unit, file='input.nml', iostat = iostat )
    if(iostat .ne. 0) call error_handler('error in open input.nml file')

    read (unit, runoff_regrid_nml, iostat=iostat)
    if(iostat .ne. 0) call error_handler('error in while reading runoff_regrid_nml ')

    close(unit)

    !--- write out namelist and version information
    write( stdout,'(/a)' )'runoff_regrid '//trim(version)//trim(tagname)
    write( stdout, runoff_regrid_nml)

  end subroutine runoff_regrid_init

  !#######################################################################
  ! read runoff data from src_data
  subroutine read_src_data

  integer :: dims(4), start(4), nread(4)
  integer :: rcode, ncid, ndims, nvar, id_time, id_runoff, i
  real    :: missing_value

  rcode = nf_open(trim(src_data), NF_NOWRITE, ncid)

  rcode = nf_inq_varid(ncid, trim(src_fld_name), id_runoff )

  rcode = nf_inq_varndims(ncid, id_runoff, ndims)

  rcode = nf_inq_vardimid(ncid, id_runoff, dims)

  rcode = nf_inq_dimlen(ncid, dims(1), ni_src)
  rcode = nf_inq_dimlen(ncid, dims(2), nj_src)

  ntime = 1
  if(ndims .gt. 2) then
     rcode = nf_inq_dimlen(ncid, dims(3), ntime)
  endif

  !--- get the time values if there are more than one time level
  if(ndims .gt. 2) then
    allocate(time_value(ntime) )
    rcode = nf_inq_varid(ncid, 'Time', id_time)
    rcode = nf_get_var_double(ncid, id_time, time_value)
  endif

  allocate(runoff_src(ni_src, nj_src, ntime) )

  !--- read the source runoff data
  start = 1; nread = 1
  nread(1) = ni_src; nread(2) = nj_src; nread(3) = ntime
  rcode = nf_get_vara_double(ncid, id_runoff, start, nread, runoff_src)

  !--- get the missing value -------------------------------------------
  missing_value = -1.0e20
  rcode = nf_get_att_double(ncid, id_runoff, 'missing_value', missing_value)
  if(rcode == 0) then
    where(runoff_src == missing_value) runoff_src = 0.0
  endif

  rcode = nf_close(ncid)

  end subroutine read_src_data

  !#######################################################################
  ! read component grid and exchange grid from grid_spec.nc
  subroutine read_xgrid
    integer              :: rcode, ncid, ncells, ni_lon, nj_lat, i, j
    real,    allocatable :: wet(:,:)
    logical, allocatable :: mask0(:,:)

  !--- read xgrid from the grid_spec.nc file --------------------------
  rcode = nf_open('grid_spec.nc', NF_NOWRITE, ncid)
  call error_handler('error in open file grid_spec.nc', rcode)

  ni_dst = get_dimlen(ncid, 'grid_x_T')
  nj_dst = get_dimlen(ncid, 'grid_y_T')

  allocate(grid_x_t(ni_dst), grid_y_t(nj_dst) )
  allocate(wet(ni_dst,nj_dst), x_t_dst(ni_dst,nj_dst), y_t_dst(ni_dst,nj_dst) )
  allocate(mask0(ni_dst,nj_dst),mask(ni_dst,nj_dst)) 

  !--- get grid axis data ----------------------------------------------
  call get_var_real_1d(ncid,'grid_x_T', grid_x_t)
  call get_var_real_1d(ncid,'grid_y_T', grid_y_t)

  call get_var_real_2d(ncid, 'wet', wet)
  
  ! calculate coastal mask, on ocn grid
  mask0 = (wet > 0.5)
  do j = 1, nj_dst
     do i = 1, ni_dst
        mask(i,j) = coastal(mask0,i,j)
     enddo
  enddo

  deallocate(mask0)

  call get_var_real_2d(ncid, 'x_T',  x_t_dst)
  call get_var_real_2d(ncid, 'y_T',  y_t_dst)

  !--- get exchange grid information
  ncells = get_dimlen(ncid, 'I_ATM_ATMxOCN')
  allocate(i_atm_atmxocn(ncells), j_atm_atmxocn(ncells), &
           i_ocn_atmxocn(ncells), j_ocn_atmxocn(ncells), &
           area_atmxocn(ncells) )

  call get_var_int_1d(ncid, 'I_ATM_ATMxOCN', i_atm_atmxocn)
  call get_var_int_1d(ncid, 'J_ATM_ATMxOCN',j_atm_atmxocn )
  call get_var_int_1d(ncid, 'I_OCN_ATMxOCN',i_ocn_atmxocn )
  call get_var_int_1d(ncid, 'J_OCN_ATMxOCN',j_ocn_atmxocn )
  call get_var_real_1d(ncid, 'AREA_ATMxOCN',area_atmxocn )

  ncells = get_dimlen(ncid, 'I_ATM_ATMxLND')
  allocate(i_atm_atmxlnd(ncells), j_atm_atmxlnd(ncells), &
           i_lnd_atmxlnd(ncells), j_lnd_atmxlnd(ncells), &
           area_atmxlnd(ncells) )

  call get_var_int_1d(ncid, 'I_ATM_ATMxLND', i_atm_atmxlnd)
  call get_var_int_1d(ncid, 'J_ATM_ATMxLND',j_atm_atmxlnd )
  call get_var_int_1d(ncid, 'I_LND_ATMxLND',i_lnd_atmxlnd )
  call get_var_int_1d(ncid, 'J_LND_ATMxLND',j_lnd_atmxlnd )
  call get_var_real_1d(ncid, 'AREA_ATMxLND',area_atmxlnd )

  !--- get the longitude and latitude of simple lon lat grid
  !--- it should has the same size as the runoff data ni_src, nj_src
  ni_lon = get_dimlen(ncid, 'xta')
  nj_lat = get_dimlen(ncid, 'yta')

  if(ni_lon .ne. ni_src .or. nj_lat .ne. nj_src)  &
      call error_handler('Error: size mismatch between file grid_spec.nc and file '//trim(src_data) )

  allocate(lon(ni_src), lat(nj_src))

  call get_var_real_1d(ncid, 'xta', lon)
  call get_var_real_1d(ncid, 'yta', lat)  

  rcode = nf_close(ncid)

  end subroutine read_xgrid

  !#######################################################################
  ! remapping runoff data onto destination grid
  subroutine remap_data
     integer              :: i, j, k, ncells_axo, ncells_axl
     real,    allocatable :: area_ocn(:,:), area_lnd(:,:), runoff_lnd(:,:), x(:), xl(:)
     integer, allocatable :: imap(:,:), jmap(:,:)
     real                 :: D2R

     D2R = PI/180.
     ncells_axo = size(i_atm_atmxocn(:))
     ncells_axl = size(i_atm_atmxlnd(:))

     allocate(area_ocn(ni_dst, nj_dst), area_lnd(ni_src, nj_src))
     allocate(runoff_lnd(ni_src, nj_src), runoff(ni_dst, nj_dst, ntime) )
     allocate(x(ncells_axo), xl(ncells_axl) )
     allocate(imap(ni_src, nj_src), jmap(ni_src, nj_src) )

     imap = 0
     jmap = 0
     runoff = 0
     do k = 1, ntime

        ! put input runoff to ocean grid
        do i = 1, ncells_axo
           x(i) = runoff_src(i_atm_atmxocn(i),j_atm_atmxocn(i),k)
        enddo

        area_ocn = 0
        do i = 1, ncells_axo
           runoff(i_ocn_atmxocn(i),j_ocn_atmxocn(i), k) = &
                runoff(i_ocn_atmxocn(i),j_ocn_atmxocn(i), k)+area_atmxocn(i)*x(i)
           area_ocn(i_ocn_atmxocn(i),j_ocn_atmxocn(i)) = &
                area_ocn(i_ocn_atmxocn(i),j_ocn_atmxocn(i))+area_atmxocn(i)
        enddo

        where (area_ocn(:,:) > 0) runoff(:,:,k) = runoff(:,:,k)/area_ocn(:,:)

        ! put input runoff to land grid -- it will be mostly zero, but in places where
        ! the input data grid and model ocean grid do not coincide
        do i = 1, ncells_axl
           xl(i) = runoff_src(i_atm_atmxlnd(i),j_atm_atmxlnd(i),k)
        enddo
        runoff_lnd = 0
        area_lnd = 0
        do i = 1, ncells_axl
           runoff_lnd(i_lnd_atmxlnd(i),j_lnd_atmxlnd(i)) = &
                runoff_lnd(i_lnd_atmxlnd(i),j_lnd_atmxlnd(i))+area_atmxlnd(i)*xl(i)
           area_lnd(i_lnd_atmxlnd(i),j_lnd_atmxlnd(i)) = &
                area_lnd(i_lnd_atmxlnd(i),j_lnd_atmxlnd(i))+area_atmxlnd(i)
        enddo
        where (area_lnd > 0) runoff_lnd = runoff_lnd/area_lnd
        write (stdout,*) 'At time level ', k,' There are ',count(runoff_lnd/=0), 'land points that has runoff value'

        ! calculate remapping
        do j = 1,nj_src
        do i = 1,ni_src
           if(runoff_lnd(i,j)>0) then
              if(imap(i,j)==0) &
                   call nearest(mask,x_t_dst*D2R,y_t_dst*D2R,lon(i)*D2R,lat(j)*D2R,imap(i,j),jmap(i,j))
              runoff(imap(i,j),jmap(i,j),k) = runoff(imap(i,j),jmap(i,j),k) + &
                   runoff_lnd(i,j)*area_lnd(i,j)/area_ocn(imap(i,j),jmap(i,j))
           endif
        enddo
        enddo

     enddo


  end subroutine remap_data

  !#####################################################################
  ! write out output
  subroutine write_dst_data
    integer           :: id_lon, id_lat, id_time, id_time_src, id_runoff_src, id_runoff
    integer           :: type, ndims, natts, rcode, ncid, ncid_src, i, natts_time
    integer           :: dims(4), start(4), nwrite(4)
    character(len=64) :: name
    integer           ::fsize = 65536, inital = 0


    rcode = nf_open(trim(src_data), NF_NOWRITE, ncid_src)
    call error_handler('error in opening file '//trim(src_data) , rcode)  
    rcode = nf_inq_varid(ncid_src, trim(src_fld_name), id_runoff_src )
    call error_handler('error in inquring varible id of variable'//trim(src_fld_name) , rcode) 
    rcode = nf_inq_varndims(ncid_src, id_runoff_src, ndims ) 
    call error_handler('error in inquring ndims of variable'//trim(src_fld_name) , rcode) 
    rcode = nf_inq_varnatts(ncid_src, id_runoff_src, natts )
    call error_handler('error in inquring natts of variable'//trim(src_fld_name) , rcode) 


#ifdef use_netCDF3
    rcode = NF__CREATE(dst_data, NF_CLOBBER, inital, fsize, ncid)
#else  
    rcode = NF__CREATE(dst_data, IOR(NF_NETCDF4,NF_CLASSIC_MODEL), inital, fsize, ncid )
#endif
    call error_handler('error in creating file '//trim(dst_data), rcode)    

    rcode = nf_def_dim(ncid, 'grid_x_T', ni_dst, dims(1))
    call error_handler('error in defining x dimension' , rcode)    
    rcode = nf_def_dim(ncid, 'grid_y_T', nj_dst, dims(2))
    call error_handler('error in defining y dimension' , rcode) 
    if(ndims > 2) then
       rcode = nf_def_dim(ncid, 'Time', NF_UNLIMITED, dims(3))
       call error_handler('error in defining time dimension' , rcode) 
    endif

    rcode = nf_def_var(ncid, 'grid_x_T', NF_DOUBLE, 1, dims(1), id_lon)
    call error_handler('error in defining variable grid_x_T' , rcode)  
    rcode = nf_put_att_text(ncid,id_lon, 'long_name', 34,'Nominal Longitude of T-cell center')
    call error_handler('error in putting longnmae of variable grid_x_T' , rcode)  
    rcode = nf_put_att_text(ncid,id_lon, 'cartesian_axis', 1,'X')
    call error_handler('error in putting  cartesian_axis of variable grid_x_T' , rcode)  
    rcode = nf_put_att_text(ncid,id_lon, 'units', 11,'degree_east')
    call error_handler('error in putting units of variable grid_x_T' , rcode)  

    rcode = nf_def_var(ncid, 'grid_y_T', NF_DOUBLE, 1, dims(2), id_lat)
    call error_handler('error in defining variable grid_y_T' , rcode)  
    rcode = nf_put_att_text(ncid,id_lat, 'long_name', 33,'Nominal latitude of T-cell center')
    call error_handler('error in putting longnmae of variable grid_x_T' , rcode)  
    rcode = nf_put_att_text(ncid,id_lat, 'cartesian_axis', 1,'Y')
    call error_handler('error in putting  cartesian_axis of variable grid_x_T' , rcode)  
    rcode = nf_put_att_text(ncid,id_lat, 'units', 12,'degree_north')
    call error_handler('error in putting units of variable grid_x_T' , rcode)  

    if(ndims > 2) then
       rcode = nf_def_var(ncid, 'Time', NF_DOUBLE, 1, dims(3), id_time)
       call error_handler('error in defining variable Time' , rcode)  
       rcode = nf_inq_varid(ncid_src,'Time',id_time_src)
       call error_handler('error in inquiring variable id of Time of file'//trim(src_data) , rcode)  
       rcode = nf_inq_varnatts(ncid_src, id_time_src, natts_time )
       call error_handler('error in inquring natts of variable Time', rcode) 
       do i = 1, natts_time
          rcode = nf_inq_attname(ncid_src, id_time_src, i, name)
          call error_handler('error in inquring attribute '//trim(name), rcode)  
          rcode = nf_copy_att(ncid_src,id_time_src, trim(name), ncid, id_time)
          call error_handler('error in copy attribute '//trim(name)//' of Time', rcode)  
       enddo
    endif

    if(ndims .le. 2) then
       rcode = nf_def_var(ncid, trim(dst_fld_name), NF_DOUBLE, 2, dims(1:2), id_runoff)
    else
       rcode = nf_def_var(ncid, trim(dst_fld_name), NF_DOUBLE, 3, dims(1:3), id_runoff)
    endif
    call error_handler('error in defining variable '//trim(dst_fld_name) , rcode)  

    !--- write the field attribute ---------------------------------------
    do i = 1, natts
       rcode = nf_inq_attname(ncid_src, id_runoff_src, i, name)
       call error_handler('error in inquring attribute '//trim(name), rcode)  
       if(trim(name) .ne. '_FillValue') then
          rcode = nf_copy_att(ncid_src,id_runoff_src, trim(name), ncid, id_runoff)
          call error_handler('error in copy attribute '//trim(name)//' of variable '//trim(src_fld_name), rcode)  
       endif
    enddo

    rcode = nf_enddef(ncid)

    !--- write out data --------------------------------------------------
    start = 1; nwrite = 1;
    nwrite(1) = ni_dst
    rcode = nf_put_vara_double(ncid, id_lon, start, nwrite, grid_x_t)
    call error_handler('error in putting grid_x_T data', rcode)
    nwrite(1) = nj_dst
    rcode = nf_put_vara_double(ncid, id_lat, start, nwrite, grid_y_t)
    call error_handler('error in putting grid_y_T data', rcode)

    do i =1, ntime
       if(ndims>2) then
          rcode = nf_put_var1_double(ncid, id_time, i, time_value(i))
          call error_handler('error in putting time data', rcode)
       endif
       nwrite(1) = ni_dst; nwrite(2) = nj_dst
       start(3)  = i
       rcode = nf_put_vara_double(ncid, id_runoff, start, nwrite, runoff(:,:,i))  
       call error_handler('error in putting data of '//trim(dst_fld_name), rcode)
    enddo

    rcode = nf_close(ncid_src)
    rcode = nf_close(ncid)

  end subroutine write_dst_data

  !#####################################################################
  ! get the dimension length of any one dimensional variable
  function get_dimlen(ncid, name)
    integer,          intent(in) :: ncid
    character(len=*), intent(in) :: name
    integer                      :: get_dimlen
    integer                      :: varid, rcode, dims(1)

    rcode = nf_inq_varid(ncid, trim(name), varid)
    call error_handler('error in inquiring variable id of '//trim(name), rcode)

    rcode = nf_inq_vardimid(ncid, varid, dims)
    call error_handler('error in inquiring dimension id of '//trim(name), rcode)

    rcode = nf_inq_dimlen(ncid, dims(1), get_dimlen)
    call error_handler('error in inquiring dimension length of '//trim(name), rcode)

  end function get_dimlen

  !#####################################################################
  ! read the 1d real data from netcdf file.
  subroutine get_var_real_1d(ncid, name, data)
    integer,             intent(in) :: ncid
    character(len=*),    intent(in) :: name
    real, dimension(:), intent(out) :: data
    integer                         :: rcode, varid

    rcode = nf_inq_varid(ncid, name, varid)
    call error_handler('error in inquiring variable id of '//trim(name), rcode)

    rcode = nf_get_var_double(ncid, varid, data)
    call error_handler('error in reading data of '//trim(name), rcode)


  end subroutine get_var_real_1d

  !#####################################################################
  ! read the 2d real data from netcdf file.
  subroutine get_var_real_2d(ncid, name, data)
    integer,               intent(in) :: ncid
    character(len=*),      intent(in) :: name
    real, dimension(:,:), intent(out) :: data
    integer                           :: rcode, varid


    rcode = nf_inq_varid(ncid, name, varid)
    call error_handler('error in inquiring variable id of '//trim(name), rcode)

    rcode = nf_get_var_double(ncid, varid, data)
    call error_handler('error in reading data of '//trim(name), rcode)

  end subroutine get_var_real_2d

  !#####################################################################
  ! read the 1d integer data from netcdf file.
  subroutine get_var_int_1d(ncid, name, data)
    integer,                intent(in) :: ncid
    character(len=*),       intent(in) :: name
    integer, dimension(:), intent(out) :: data
    integer                            :: rcode, varid

    rcode = nf_inq_varid(ncid, name, varid)
    call error_handler('error in inquiring variable id of '//trim(name), rcode)
    rcode = nf_get_var_int(ncid, varid, data)
    call error_handler('error in reading data of '//trim(name), rcode)

  end subroutine get_var_int_1d

  !#####################################################################
  ! find the nearest ocean point of a given land point.
  subroutine nearest(mask, lon, lat, plon, plat, iout, jout)
    ! finde nearest point that is not masked out; brute force approach 
    logical, intent(in) :: mask(:,:)  ! mask of valid input points
    real,    intent(in) :: lon(:,:)   ! longitudes of input grd central points
    real,    intent(in) :: lat(:,:)   ! latitudes of input grd central points
    real,    intent(in) :: plon, plat ! coordinates of destination point
    integer, intent(out):: iout, jout ! output map values

    integer :: i,j
    real    :: r, r1

    r = distance(0.0,PI/2,0.0,-PI/2)  ! some big value

    do j = 1, size(mask,2)
       do i = 1, size(mask,1)
          if (.not.mask(i,j)) cycle
          r1 = distance(plon,plat,lon(i,j),lat(i,j))
          if ( r1 < r ) then
             iout = i
             jout = j
             r = r1
          endif
       enddo
    enddo

  end subroutine nearest

  !#####################################################################
  ! returns true if (i,j) is a coastal point of ocean
  function coastal(wet, i,j)
    logical, intent(in) :: wet(:,:)
    integer, intent(in) :: i,j
    logical             :: coastal

    type delta
       integer :: i,j
    end type delta

    integer :: i0,j0,k
    type(delta):: stencil(4)
    data stencil/delta(-1,0),delta(1,0),delta(0,-1),delta(0,1)/

    coastal = .false.
    if(.not.wet(i,j)) return

    do k = 1, size(stencil(:))
       i0 = lbound(wet,1)+modulo(i+stencil(k)%i-lbound(wet,1),size(wet,1)); 
       j0 = min( max(j+stencil(k)%j,lbound(wet,2)), ubound(wet,2) )

       coastal = coastal.or..not.wet(i0,j0)
    enddo
  end function coastal

!#####################################################################
  ! calculate a distance in 3-d between points on unit square
  function distance(lon1, lat1, lon2, lat2)
    real, intent(in) :: lon1,lat1,lon2,lat2 
    real             :: distance
    real             :: x1,y1,z1, x2,y2,z2

    z1 = sin(lat1)           ;  z2 = sin(lat2)
    x1 = cos(lat1)*cos(lon1) ;  x2 = cos(lat2)*cos(lon2)
    y1 = cos(lat1)*sin(lon1) ;  y2 = cos(lat2)*sin(lon2)

    distance = sqrt((z1-z2)**2+(x1-x2)**2+(y1-y2)**2)
  end function distance

  !#####################################################################
  ! error handling routine.
  subroutine error_handler(mesg, status)
    character(len=*),  intent(in) :: mesg
    integer, optional, intent(in) :: status
    character(len=256) :: msg

    if(present(status)) then
       if(status == 0) return
       msg = nf_strerror(status)
       msg = trim(mesg)//': '// trim(msg)
    else
       msg = trim(mesg)
    endif

    write(stdout,*) msg

    call ABORT()

  end subroutine error_handler

  !#######################################################################
  ! destructor: release memory.
  subroutine runoff_regrid_end

    deallocate(runoff, runoff_src, mask, lon, lat, x_t_dst, y_t_dst)
    deallocate(i_atm_atmxocn, j_atm_atmxocn, i_ocn_atmxocn, j_ocn_atmxocn)
    deallocate(i_atm_atmxlnd, j_atm_atmxlnd, i_lnd_atmxlnd, j_lnd_atmxlnd)
    deallocate(area_atmxocn, area_atmxlnd)

  end subroutine runoff_regrid_end

  !#######################################################################

end program runoff_regrid

 
!VERSION NUMBER:
!  $Name: tikal $
!  $Id: wet_deposition_0D.F90,v 19.0 2012/01/06 20:09:12 fms Exp $

!<SUBROUTINE NAME = "wet_deposition_0D">
!<TEMPLATE>
!CALL wet_deposition_0D( Henry_constant, Henry_variable, &
!                        frac_in_cloud, alpha_r, alpha_s, &
!                        T, p0, p1, rho_air, &
!                        cloud, precip, &
!                        tracer, Lgas, Laerosol, Lice, &
!                        delta_tracer )
!</TEMPLATE>
subroutine wet_deposition_0D( Henry_constant, Henry_variable, &
                              frac_in_cloud, alpha_r, alpha_s, &
                              T, p0, p1, rho_air, &
                              cloud, rain, snow, &
                              tracer, Lgas, Laerosol, Lice, &
                              delta_tracer )
implicit none
!      
!<OVERVIEW>
! Routine to calculate the fraction of tracer removed by wet deposition
!</OVERVIEW>
!
!<IN NAME="T" TYPE="real">
!   Temperature (K)
!</IN>
!<IN NAME="p0" TYPE="real">
!   Pressure (Pa) at layer closer to surface
!</IN>
!<IN NAME="p1" TYPE="real">
!   Pressure (Pa) at layer farther from surface
!</IN>
!<IN NAME="rho_air" TYPE="real">
!   Air density (kg/m3)
!</IN>
!<IN NAME="cloud" TYPE="real">
!   Cloud amount (liquid+ice) (kg/kg)
!</IN>
!<IN NAME="rain" TYPE="real">
!   Precipitation increment (rain) (kg/m3)
!</IN>
!<IN NAME="snow" TYPE="real">
!   Precipitation increment (snow) (kg/m3)
!</IN>
!<IN NAME="tracer" TYPE="real">
!   The tracer field (tracer units)
!</IN>
!<IN NAME="Lgas" TYPE="logical">
!   Is tracer a gas?
!</IN>
!<IN NAME="Laerosol" TYPE="logical">
!   Is tracer an aerosol?
!</IN>
!<IN NAME="Lice" TYPE="logical">
!   Is tracer removed by snow (or only by rain)?
!</IN>
!<OUT NAME="delta_tracer" TYPE="real">
!   The change (increment) of the tracer field due to wet deposition (tracer units)
!/OUT>
!<DESCRIPTION>
! Schemes allowed here are:
!
! 1) Removal according to Henry's Law. This law states that the ratio of the concentation in 
!    cloud water and the partial pressure in the interstitial air is a constant. In this 
!    instance, the units for Henry's constant are kg/L/Pa (normally it is M/L/Pa)
!    Parameters for a large number of species can be found at
!    http://www.mpch-mainz.mpg.de/~sander/res/henry.html
!
! 2) Aerosol removal, using specified in-cloud tracer fraction

! To utilize this section of code add one of the following lines as 
! a method for the tracer of interest in the field table.
!<PRE>
! "wet_deposition","henry","henry=XXX, dependence=YYY"
! "wet_deposition","henry_below","henry=XXX, dependence=YYY"
!     where XXX is the Henry's constant for the tracer in question
!       and YYY is the temperature dependence of the Henry's Law constant.
!
! "wet_deposition","aerosol","frac_incloud=XXX"
! "wet_deposition","aerosol_below","frac_incloud=XXX"
!     where XXX is the in-cloud fraction of the aerosol tracer
!</PRE>

!</DESCRIPTION>

!-----------------------------------------------------------------------
!     ... dummy arguments
!-----------------------------------------------------------------------
real,             intent(in)                     :: Henry_constant, Henry_variable, &
                                                    frac_in_cloud, alpha_r, alpha_s
real,             intent(in)                     :: T, p0, p1, rho_air
real,             intent(in)                     :: cloud, rain, snow
real,             intent(in)                     :: tracer
logical,          intent(in)                     :: Lgas, Laerosol, Lice
real,             intent(out)                    :: delta_tracer

!-----------------------------------------------------------------------
!     ... local variables
!-----------------------------------------------------------------------
real :: &
      Htemp, xliq, n_air, pwt, pmid, precip
real :: &
      temp_factor, scav_factor, &
      w_h2o, beta, f_a, in_temp
real, parameter :: &
      GRAV = 9.80,              &  ! acceleration due to gravity [m/s2]
      RDGAS = 287.04,           &  ! gas constant for dry air [J/kg/deg]
      AVOGNO = 6.023000E+23,    &  ! Avogadro's number
      inv298p15 = 1./298.15,    &  ! 1/K
      cm3_2_m3 = 1.e-6             ! m3/cm3
real, parameter :: mw_air = 28.96440E-03 ! molar mass of air (kg/mole)
real, parameter :: mw_h2o = 18.0E-03  ! molar mass of H2O (kg/mole)

!-----------------------------------------------------------------------

delta_tracer = 0.

pmid = 0.5 * (p0+p1)         ! Pa
pwt     = ( p0 - p1 )/GRAV   ! kg/m2

if( Lgas .or. Laerosol ) then
!++lwh
! units = VMR
!
! Henry_constant (mole/L/Pa) = [X](aq) / Px(g) 
! where [X](aq) is the concentration of tracer X in precipitation (mole/L)
!       Px(g) is the partial pressure of the tracer in the air (Pa)
!
! VMR (total) = VMR (gas) + VMR (aq)
!             = VMR (gas) + [X] * L
!
! where L = cloud liquid amount (kg H2O/mole air)
!
! Using Henry's Law, [X] = H * Px = H * VMR(gas) * Pfull
!
! So, VMR (total) =  VMR(gas) * [ 1 + H * Pfull * L ]
! 
! VMR(gas) = VMR(total) / [1 + H * Pfull * L]
!
! [X] = H * Pfull * VMR(total) / [ 1 + H * Pfull * L]
!
! Following Giorgi and Chameides, JGR, 90(D5), 1985, the first-order loss
! rate constant (s^-1) of X due to wet deposition equals:
!
! k = W_X / n_X
!
! where W_x = the loss rate (molec/cm3/s), and n_X = the number density (molec/cm3)
! 
! W_X = [X] * W_H2O / (55 mole/L)
! n_x = VMR(total) * n_air (molec/cm3) = VMR(total) * P/(kT) * 1E-6 m3/cm3
! 
! where P = atmospheric pressure (Pa)
!       k = Boltzmann's constant = 1.38E-23 J/K
!       T = temperature (K)
!       W_H2O = removal increment of water (molec/cm3)
! 
!             [X] * W_H2O / 55         
! So, k = ------------------------------
!         VMR(total) * P/(kT) * 1E-6
! 
!         W_H2O    H * VMR(total) * P / [ 1 + H * P *L ]
!       = ----- * ---------------------------------------
!          55          VMR(total) * P/(kT) * 1E-6
! 
!         W_H2O     H * kT * 1E6
!       = ----- *  -------------    
!          55      1 + H * P * L 
!
!         W_H2O     1     1     H * P * L
!       = ----- * ----- * - * -------------
!          55     n_air   L   1 + H * P * L
!
! where W_H2O = precip (kg/m3) * (AVOGNO/mw_h2o) (molec/kg) * 1E-6 m3/cm3
!
   if( (Lgas .and. Henry_constant > 0.) .or. Laerosol ) then
      if (Lice) then
         precip = rain+snow
      else
         precip = rain
      end if
      in_temp = 0.

      scav_factor = 0.0
      xliq = MAX( cloud * mw_air, 0. ) ! (kg H2O)/(mole air)
      n_air = rho_air * (AVOGNO/mw_air) * cm3_2_m3 ! molec/cm3
      if (Lgas) then
! Calculate the temperature dependent Henry's Law constant
         temp_factor = 1/T-inv298p15
         Htemp = Henry_constant * exp( Henry_variable*temp_factor )
         f_a = Htemp * pmid * xliq
         scav_factor = f_a / ( 1.+f_a )
      else if (Laerosol) then
         scav_factor = frac_in_cloud
      end if
      if (precip > 0. .and. xliq > 0.) then
         w_h2o = precip * (AVOGNO/mw_h2o) * cm3_2_m3 ! molec/cm3
         beta = w_h2o * mw_h2o  / (n_air * xliq)   ! fraction of condensed water removed
         beta = MAX(MIN(beta,1.),0.)
         in_temp = beta * scav_factor              ! fraction of tracer removed
      end if

!     wdep_in = - in_temp*tracer*pwt
!     dt_temp = 1. - exp( -in_temp*dt ) ! fractional loss/timestep
!     tracer_dt = dt_temp / dt !+ve loss frequency (1/sec)
      delta_tracer = in_temp ! fraction of tracer removed
!--lwh
   endif 

end if

! Now multiply by the tracer mixing ratio to get the actual tendency.
! tracer_dt = MIN( MAX(tracer_dt, 0.0E+00), 0.5/dt)
if (tracer > 0.) then
   delta_tracer = delta_tracer*tracer
else
   delta_tracer = 0.
end if

! Output diagnostics in kg/m2/s (if MMR) or mole/m2/s (if VMR)
! if(trim(units) .eq. 'mmr') then
!    diag_scale = 1.
! else if(trim(units) .eq. 'vmr') then
!    diag_scale = mw_air ! kg/mole
! else
!    write(*,*) ' Tracer number =',n,' tracer_name=',tracer_name
!    write(*,*) ' scheme=',text_in_scheme
!    write(*,*) ' control=',control
!    write(*,*) ' scheme=',scheme
!    write(*,*) 'Please check field table'
!    write(*,*) 'tracers units =',trim(units),'it should be either  mmr or vmr!'
!  <ERROR MSG="Unsupported tracer units" STATUS="FATAL">
!     Tracer units must be either VMR or MMR
!  </ERROR>
!    call error_mesg('wet_deposition', 'Unsupported tracer units.', FATAL )
! end if

! if(trim(cloud_param) == 'donner') then
!    if (id_tracer_wdep_donin(n) > 0 ) then
!        used = send_data ( id_tracer_wdep_donin(n), wdep_in/diag_scale, Time, is_in=is, js_in=js)
!    endif
!    if(id_tracer_wdep_donin_dt(n) > 0) then
!       used = send_data ( id_tracer_wdep_donin_dt(n), in_temp, Time, is_in=is, js_in=js, ks_in=1)
!    endif
!    if(id_tracer_wdep_don_dt(n) > 0) then
!       used = send_data ( id_tracer_wdep_don_dt(n), dt_temp/dt, Time, is_in=is, js_in=js, ks_in=1)
!    endif
! endif

end subroutine wet_deposition_0D
!</SUBROUTINE>

module grid_mod

use mpp_mod, only : mpp_root_pe
use constants_mod, only : PI, radius
use fms_mod, only : uppercase, lowercase, field_exist, field_size, read_data, &
     error_mesg, string, FATAL, NOTE
use fms_io_mod, only : get_great_circle_algorithm, get_global_att_value
use mosaic_mod, only : get_mosaic_ntiles, get_mosaic_xgrid_size, get_mosaic_grid_sizes, &
     get_mosaic_xgrid, calc_mosaic_grid_area, calc_mosaic_grid_great_circle_area

! the following two use statement are only needed for define_cube_mosaic
use mpp_domains_mod, only : domain2d, mpp_define_mosaic, mpp_get_compute_domain, &
                            mpp_get_global_domain
use mosaic_mod, only : get_mosaic_ncontacts, get_mosaic_contact

implicit none;private

! ==== public interfaces =====================================================
! grid dimension inquiry subroutines
public :: get_grid_ntiles ! returns number of tiles
public :: get_grid_size   ! returns horizontal sizes of the grid
! grid geometry inquiry subroutines
public :: get_grid_cell_centers 
public :: get_grid_cell_vertices
! grid area inquiry subroutines
public :: get_grid_cell_area
public :: get_grid_comp_area
! decompose cubed sphere domains -- probably does not belong here, but it should 
! be in some place available for component models
public :: define_cube_mosaic
! ==== end of public interfaces ==============================================

interface get_grid_size
   module procedure get_grid_size_for_all_tiles
   module procedure get_grid_size_for_one_tile
end interface

interface get_grid_cell_vertices
   module procedure get_grid_cell_vertices_1D
   module procedure get_grid_cell_vertices_2D
end interface

interface get_grid_cell_centers
   module procedure get_grid_cell_centers_1D
   module procedure get_grid_cell_centers_2D
end interface

! ==== module constants ======================================================
character(len=*), parameter :: &
     module_name = 'grid_mod', &
     version     = '$Id$', &
     tagname     = '$Name$'

character(len=*), parameter :: &
     grid_dir  = 'INPUT/',     &      ! root directory for all grid files
     grid_file = 'INPUT/grid_spec.nc' ! name of the grid spec file

integer, parameter :: &
     MAX_NAME = 256,  & ! max length of the variable names
     MAX_FILE = 1024, & ! max length of the file names
     VERSION_0 = 0,   &
     VERSION_1 = 1,   &
     VERSION_2 = 2

integer, parameter :: BUFSIZE = 1048576  ! This is used to control memory usage in get_grid_comp_area
                                         ! We may change this to a namelist variable is needed.

! ==== module variables ======================================================
integer :: grid_version = -1
logical :: great_circle_algorithm = .FALSE.
logical :: first_call = .TRUE.


contains 

function get_grid_version()
  integer :: get_grid_version

  if(first_call) then
     great_circle_algorithm = get_great_circle_algorithm()
     first_call = .FALSE.
  endif

  if(grid_version<0) then
    if(field_exist(grid_file, 'geolon_t')) then
       grid_version = VERSION_0 
    else if(field_exist(grid_file, 'x_T')) then
       grid_version = VERSION_1
    else if(field_exist(grid_file, 'ocn_mosaic_file') ) then
       grid_version = VERSION_2
    else
       call error_mesg(module_name//'/get_grid_version',&
            'Can''t determine the version of the grid spec: none of "x_T", "geolon_t", or "ocn_mosaic_file" exist in file "'//trim(grid_file)//'"', &
            FATAL )
    endif
  endif
  get_grid_version = grid_version
end function get_grid_version


! ============================================================================
! returns number of tiles for a given component
! ============================================================================
subroutine get_grid_ntiles(component,ntiles)
  character(len=*)     :: component
  integer, intent(out) :: ntiles

  ! local vars
  character(len=MAX_FILE) :: component_mosaic

  select case (get_grid_version())
  case(VERSION_0,VERSION_1)
     ntiles = 1
  case(VERSION_2)
     call read_data(grid_file,trim(lowercase(component))//'_mosaic_file',component_mosaic)
     ntiles = get_mosaic_ntiles(grid_dir//trim(component_mosaic))
  end select
end subroutine get_grid_ntiles


! ============================================================================
! returns size of the grid for each of the tiles
! ============================================================================
subroutine get_grid_size_for_all_tiles(component,nx,ny)
  character(len=*)     :: component
  integer, intent(inout) :: nx(:),ny(:)

  ! local vars
  integer :: siz(4) ! for the size of external fields
  character(len=MAX_NAME) :: varname1, varname2
  character(len=MAX_FILE) :: component_mosaic
  
  varname1 = 'AREA_'//trim(uppercase(component))
  varname2 = trim(lowercase(component))//'_mosaic_file'

  select case (get_grid_version())
  case(VERSION_0,VERSION_1)
     call field_size(grid_file, varname1, siz)
     nx(1) = siz(1); ny(1)=siz(2)
  case(VERSION_2) ! mosaic file
     call read_data(grid_file,varname2, component_mosaic)
     call get_mosaic_grid_sizes(grid_dir//trim(component_mosaic),nx,ny)
  end select
end subroutine get_grid_size_for_all_tiles


! ============================================================================
! returns size of the grid for one of the tiles
! ============================================================================
subroutine get_grid_size_for_one_tile(component,tile,nx,ny)
  character(len=*)       :: component
  integer, intent(in)    :: tile
  integer, intent(inout) :: nx,ny
  
  ! local vars
  integer, allocatable :: nnx(:), nny(:)
  integer :: ntiles

  call get_grid_ntiles(component, ntiles)
  if(tile>0.and.tile<=ntiles) then
     allocate(nnx(ntiles),nny(ntiles))
     call get_grid_size_for_all_tiles(component,nnx,nny)
     nx = nnx(tile); ny = nny(tile)
     deallocate(nnx,nny)
  else
     call error_mesg('get_grid_size',&
          'requested tile index '//trim(string(tile))//' is out of bounds (1:'//trim(string(ntiles))//')',&
          FATAL)
  endif
end subroutine get_grid_size_for_one_tile

! ============================================================================
! return grid cell area for the specified model component and tile
! ============================================================================
subroutine get_grid_cell_area(component, tile, cellarea, domain)
  character(len=*), intent(in)    :: component
  integer         , intent(in)    :: tile
  real            , intent(inout) :: cellarea(:,:)
  type(domain2d)  , intent(in), optional :: domain

  ! local vars
  integer :: nlon, nlat
  real, allocatable :: glonb(:,:), glatb(:,:)

  select case(get_grid_version())
  case(VERSION_0,VERSION_1)
     select case(trim(component))
     case('LND')
        call read_data(grid_file, 'AREA_LND_CELL', cellarea, &
            no_domain=.not.present(domain), domain=domain)
     case('ATM','OCN')
        call read_data(grid_file, 'AREA_'//trim(uppercase(component)),cellarea,&
            no_domain=.not.present(domain),domain=domain)
     case default
        call error_mesg(module_name//'/get_grid_cell_area',&
             'Illegal component name "'//trim(component)//'": must be one of ATM, LND, or OCN',&
             FATAL)
     end select
     ! convert area to m2
     cellarea = cellarea*4.*PI*radius**2
  case(VERSION_2)
     if (present(domain)) then
        call mpp_get_compute_domain(domain,xsize=nlon,ysize=nlat)
     else
        call get_grid_size(component,tile,nlon,nlat)
     endif
     allocate(glonb(nlon+1,nlat+1),glatb(nlon+1,nlat+1))
     call get_grid_cell_vertices(component, tile, glonb, glatb, domain)
     if (great_circle_algorithm) then
        call calc_mosaic_grid_great_circle_area(glonb*pi/180.0, glatb*pi/180.0, cellarea)
     else
        call calc_mosaic_grid_area(glonb*pi/180.0, glatb*pi/180.0, cellarea)
     end if
     deallocate(glonb,glatb)
  end select

end subroutine get_grid_cell_area


! ============================================================================
! get the area of the component per grid cell
! ============================================================================
subroutine get_grid_comp_area(component,tile,area,domain)
  character(len=*) :: component
  integer, intent(in) :: tile
  real, intent(inout) :: area(:,:)
  type(domain2d), intent(in), optional :: domain
  ! local vars
  integer :: n_xgrid_files ! number of exchange grid files in the mosaic
  integer :: siz(4), nxgrid
  integer :: i,j,m,n
  integer, allocatable :: i1(:), j1(:), i2(:), j2(:)
  real, allocatable :: xgrid_area(:)
  real, allocatable :: rmask(:,:)
  character(len=MAX_NAME) :: &
     xgrid_name, & ! name of the variable holding xgrid names
     tile_name,  & ! name of the tile
     xgrid_file, & ! name of the current xgrid file
     mosaic_name,& ! name of the mosaic
     mosaic_file,&
     tilefile 
  character(len=4096)     :: attvalue
  character(len=MAX_NAME), allocatable :: nest_tile_name(:)
  character(len=MAX_NAME) :: varname1, varname2
  integer :: is,ie,js,je ! boundaries of our domain
  integer :: i0, j0 ! offsets for x and y, respectively
  integer :: num_nest_tile, ntiles
  logical :: is_nest
  integer :: found_xgrid_files ! how many xgrid files we actually found in the grid spec
  integer :: ibegin, iend, bsize, l

  select case (get_grid_version())
  case(VERSION_0,VERSION_1)
     select case(component)
     case('ATM')
        call read_data(grid_file,'AREA_ATM',area, no_domain=.not.present(domain),domain=domain)
     case('OCN')
        allocate(rmask(size(area,1),size(area,2)))
        call read_data(grid_file,'AREA_OCN',area, no_domain=.not.present(domain),domain=domain)
        call read_data(grid_file,'wet',     rmask,no_domain=.not.present(domain),domain=domain)
        area = area*rmask
        deallocate(rmask)
     case('LND')
        call read_data(grid_file,'AREA_LND',area,no_domain=.not.present(domain),domain=domain)
     case default
        call error_mesg(module_name//'/get_grid_comp_area',&
             'Illegal component name "'//trim(component)//'": must be one of ATM, LND, or OCN',&
             FATAL)
     end select
  case(VERSION_2) ! mosaic gridspec
     select case (component)
     case ('ATM')
        ! just read the grid cell area and return
        call get_grid_cell_area(component,tile,area)
        return
     case ('LND')
        xgrid_name = 'aXl_file'
        call read_data(grid_file, 'lnd_mosaic', mosaic_name)
        tile_name  = trim(mosaic_name)//'_tile'//char(tile+ichar('0'))
     case ('OCN')
        xgrid_name = 'aXo_file'
        call read_data(grid_file, 'ocn_mosaic', mosaic_name)
        tile_name  = trim(mosaic_name)//'_tile'//char(tile+ichar('0'))
     case default
        call error_mesg(module_name//'/get_grid_comp_area',&
             'Illegal component name "'//trim(component)//'": must be one of ATM, LND, or OCN',&
             FATAL)
     end select
     ! get the boundaries of the requested domain
     if(present(domain)) then
        call mpp_get_compute_domain(domain,is,ie,js,je)
        i0 = 1-is ; j0=1-js
     else
        call get_grid_size(component,tile,ie,je)
        is = 1 ; i0 = 0
        js = 1 ; j0 = 0
     endif
     if (size(area,1)/=ie-is+1.or.size(area,2)/=je-js+1) &
        call error_mesg(module_name//'/get_grid_comp_area',&
        'size of the output argument "area" is not consistent with the domain',FATAL) 

     ! find the nest tile 
     call read_data(grid_file, 'atm_mosaic', mosaic_name)
     call read_data(grid_file,'atm_mosaic_file',mosaic_file)
     mosaic_file = grid_dir//trim(mosaic_file)
     ntiles = get_mosaic_ntiles(trim(mosaic_file))   
     allocate(nest_tile_name(ntiles))  
     num_nest_tile = 0
     do n = 1, ntiles
        call read_data(mosaic_file, 'gridfiles', tilefile, level=n)        
        tilefile = grid_dir//trim(tilefile)
        if( get_global_att_value(tilefile, "nest_grid", attvalue) ) then
           if(trim(attvalue) == "TRUE") then
              num_nest_tile = num_nest_tile + 1
              nest_tile_name(num_nest_tile) = trim(mosaic_name)//'_tile'//char(n+ichar('0'))
           else if(trim(attvalue) .NE. "FALSE") then
              call error_mesg(module_name//'/get_grid_comp_area', 'value of global attribute nest_grid in file'// &
                   trim(tilefile)//' should be TRUE of FALSE', FATAL)
           endif
        end if
     end do
     area(:,:) = 0.
     if(field_exist(grid_file,xgrid_name)) then
        ! get the number of the exchange-grid files
        call field_size(grid_file,xgrid_name,siz)
        n_xgrid_files = siz(2)
        found_xgrid_files = 0
        ! loop through all exchange grid files
        do n = 1, n_xgrid_files
           ! get the name of the current exchange grid file
           call read_data(grid_file,xgrid_name,xgrid_file,level=n)
           ! skip the rest of the loop if the name of the current tile isn't found 
           ! in the file name, but check this only if there is more than 1 tile
           if(n_xgrid_files>1) then
              if(index(xgrid_file,trim(tile_name))==0) cycle
           endif
           found_xgrid_files = found_xgrid_files + 1
           !---make sure the atmosphere grid is not a nested grid
           is_nest = .false. 
           do m = 1, num_nest_tile
              if(index(xgrid_file, trim(nest_tile_name(m))) .NE. 0) then
                 is_nest = .true.
                 exit
              end if
           end do
           if(is_nest) cycle 

           ! finally read the exchange grid
           nxgrid = get_mosaic_xgrid_size(grid_dir//xgrid_file)
           if(nxgrid < BUFSIZE) then
              allocate(i1(nxgrid), j1(nxgrid), i2(nxgrid), j2(nxgrid), xgrid_area(nxgrid))
           else
              allocate(i1(BUFSIZE), j1(BUFSIZE), i2(BUFSIZE), j2(BUFSIZE), xgrid_area(BUFSIZE))
           endif
           ibegin = 1
           do l = 1,nxgrid,BUFSIZE
              bsize = min(BUFSIZE, nxgrid-l+1)
              iend = ibegin + bsize - 1
              call get_mosaic_xgrid(grid_dir//xgrid_file, i1(1:bsize), j1(1:bsize), i2(1:bsize), j2(1:bsize), &
                                    xgrid_area(1:bsize), ibegin, iend)
              ! and sum the exchange grid areas
              do m = 1, bsize
                 i = i2(m); j = j2(m)
                 if (i<is.or.i>ie) cycle
                 if (j<js.or.j>je) cycle
                 area(i+i0,j+j0) = area(i+i0,j+j0) + xgrid_area(m)
              end do
              ibegin = iend + 1
           enddo
           deallocate(i1, j1, i2, j2, xgrid_area)
        enddo
        if (found_xgrid_files == 0) &
           call error_mesg('get_grid_comp_area', 'no xgrid files were found for component '& 
                 //trim(component)//' (mosaic name is '//trim(mosaic_name)//')', FATAL)

     endif
     deallocate(nest_tile_name)
  end select ! version
  ! convert area to m2
  area = area*4.*PI*radius**2
end subroutine

! ============================================================================
! returns arrays of global grid cell boundaries for given model component and 
! mosaic tile number.
! NOTE that in case of non-lat-lon grid the returned coordinates may have be not so 
! meaningful, by the very nature of such grids. But presumably these 1D coordinate 
! arrays are good enough for diag axis and such.
! ============================================================================
subroutine get_grid_cell_vertices_1D(component, tile, glonb, glatb)
  character(len=*), intent(in) :: component
  integer,          intent(in) :: tile
  real,          intent(inout) :: glonb(:),glatb(:)

  integer                      :: nlon, nlat
  integer                      :: start(4), nread(4)
  real, allocatable            :: tmp(:,:), x_vert_t(:,:,:), y_vert_t(:,:,:)
  character(len=MAX_FILE)      :: filename1, filename2

  call get_grid_size_for_one_tile(component, tile, nlon, nlat)
  if (size(glonb(:))/=nlon+1) &
       call error_mesg ( module_name//'/get_grid_cell_vertices_1D',&
       'Size of argument "glonb" is not consistent with the grid size',FATAL)
  if (size(glatb(:))/=nlat+1) &
       call error_mesg ( module_name//'/get_grid_cell_vertices_1D',&
       'Size of argument "glatb" is not consistent with the grid size',FATAL)
  if(trim(component) .NE. 'ATM' .AND. component .NE. 'LND' .AND. component .NE. 'OCN') then
     call error_mesg(module_name//'/get_grid_cell_vertices_1D',&
          'Illegal component name "'//trim(component)//'": must be one of ATM, LND, or OCN',&
          FATAL)     
  endif

  select case(get_grid_version())
  case(VERSION_0)
     select case(trim(component))
     case('ATM','LND')
        call read_data(grid_file, 'xb'//lowercase(component(1:1)), glonb, no_domain=.true.)
        call read_data(grid_file, 'yb'//lowercase(component(1:1)), glatb, no_domain=.true.)
     case('OCN')
        call read_data(grid_file, "gridlon_vert_t", glonb, no_domain=.true.) 
        call read_data(grid_file, "gridlat_vert_t", glatb, no_domain=.true.) 
     end select
  case(VERSION_1)
     select case(trim(component))
     case('ATM','LND')
        call read_data(grid_file, 'xb'//lowercase(component(1:1)), glonb, no_domain=.true.)
        call read_data(grid_file, 'yb'//lowercase(component(1:1)), glatb, no_domain=.true.)
     case('OCN')
        allocate (x_vert_t(nlon,1,2), y_vert_t(1,nlat,2) ) 
        start = 1; nread = 1
        nread(1) = nlon; nread(2) = 1; start(3) = 1
        call read_data(grid_file, "x_vert_T", x_vert_t(:,:,1), start, nread, no_domain=.TRUE.)
        nread(1) = nlon; nread(2) = 1; start(3) = 2
        call read_data(grid_file, "x_vert_T", x_vert_t(:,:,2), start, nread, no_domain=.TRUE.)

        nread(1) = 1; nread(2) = nlat; start(3) = 1
        call read_data(grid_file, "y_vert_T", y_vert_t(:,:,1), start, nread, no_domain=.TRUE.)
        nread(1) = 1; nread(2) = nlat; start(3) = 4
        call read_data(grid_file, "y_vert_T", y_vert_t(:,:,2), start, nread, no_domain=.TRUE.)
        glonb(1:nlon) = x_vert_t(1:nlon,1,1)
        glonb(nlon+1) = x_vert_t(nlon,1,2)
        glatb(1:nlat) = y_vert_t(1,1:nlat,1)
        glatb(nlat+1) = y_vert_t(1,nlat,2)
        deallocate(x_vert_t, y_vert_t)
     end select
  case(VERSION_2)
     ! get the name of the mosaic file for the component
     call read_data(grid_file, trim(lowercase(component))//'_mosaic_file', filename1)
     filename1=grid_dir//trim(filename1)
     ! get the name of the grid file for the component and tile
     call read_data(filename1, 'gridfiles', filename2, level=tile)
     filename2 = grid_dir//trim(filename2)

     start = 1; nread = 1
     nread(1) = 2*nlon+1
     allocate( tmp(2*nlon+1,1) )
     call read_data(filename2, "x", tmp, start, nread, no_domain=.TRUE.)
     glonb(1:nlon+1) = tmp(1:2*nlon+1:2,1)
     deallocate(tmp)
     allocate(tmp(1,2*nlat+1))

     start = 1; nread = 1
     nread(2) = 2*nlat+1
     call read_data(filename2, "y", tmp, start, nread, no_domain=.TRUE.)
     glatb(1:nlat+1) = tmp(1,1:2*nlat+1:2)
     deallocate(tmp)
  end select

end subroutine get_grid_cell_vertices_1D

! ============================================================================
! returns cell vertices for the specified model component and mosaic tile number
! ============================================================================
subroutine get_grid_cell_vertices_2D(component, tile, lonb, latb, domain)
  character(len=*),         intent(in) :: component
  integer,                  intent(in) :: tile
  real,                  intent(inout) :: lonb(:,:),latb(:,:)
  type(domain2d), optional, intent(in) :: domain

  ! local vars
  character(len=MAX_FILE) :: filename1, filename2
  integer :: nlon, nlat
  integer :: i,j
  real, allocatable :: buffer(:), tmp(:,:), x_vert_t(:,:,:), y_vert_t(:,:,:)
  integer :: is,ie,js,je ! boundaries of our domain
  integer :: i0,j0 ! offsets for coordinates
  integer :: isg, jsg
  integer :: start(4), nread(4)

  call get_grid_size_for_one_tile(component, tile, nlon, nlat)
  if (present(domain)) then
    call mpp_get_compute_domain(domain,is,ie,js,je)
  else
    is = 1 ; ie = nlon
    js = 1 ; je = nlat
    !--- domain normally should be present
    call error_mesg ( module_name//'/get_grid_cell_vertices',&
       'domain is not present, global data will be read', NOTE)
  endif
  i0 = -is+1; j0 = -js+1
  
  ! verify that lonb and latb sizes are consistent with the size of domain
  if (size(lonb,1)/=ie-is+2.or.size(lonb,2)/=je-js+2) &
       call error_mesg ( module_name//'/get_grid_cell_vertices',&
       'Size of argument "lonb" is not consistent with the domain size',FATAL)
  if (size(latb,1)/=ie-is+2.or.size(latb,2)/=je-js+2) &
       call error_mesg ( module_name//'/get_grid_cell_vertices',&
       'Size of argument "latb" is not consistent with the domain size',FATAL)
  if(trim(component) .NE. 'ATM' .AND. component .NE. 'LND' .AND. component .NE. 'OCN') then
     call error_mesg(module_name//'/get_grid_cell_vertices',&
          'Illegal component name "'//trim(component)//'": must be one of ATM, LND, or OCN',&
          FATAL)  
  endif

  select case(get_grid_version())
  case(VERSION_0)
     select case(component)
     case('ATM','LND')
        allocate(buffer(max(nlon,nlat)+1))
        ! read coordinates of grid cell vertices
        call read_data(grid_file, 'xb'//lowercase(component(1:1)), buffer(1:nlon+1), no_domain=.true.)
        do j = js, je+1
           do i = is, ie+1
              lonb(i+i0,j+j0) = buffer(i)
           enddo
        enddo
        call read_data(grid_file, 'yb'//lowercase(component(1:1)), buffer(1:nlat+1), no_domain=.true.)
        do j = js, je+1
           do i = is, ie+1
              latb(i+i0,j+j0) = buffer(j)
           enddo
        enddo
        deallocate(buffer)
     case('OCN')
        if (present(domain)) then
           start = 1; nread = 1
           start(1) = is; start(2) = js
           nread(1) = ie-is+2; nread(2) = je-js+2
           call read_data(grid_file, 'geolon_vert_t', lonb, start, nread, no_domain=.true. )
           call read_data(grid_file, 'geolat_vert_t', latb, start, nread, no_domain=.true. )
         else
           call read_data(grid_file, 'geolon_vert_t', lonb, no_domain=.TRUE. )
           call read_data(grid_file, 'geolat_vert_t', latb, no_domain=.TRUE. )
         endif
     end select
  case(VERSION_1)
     select case(component)
     case('ATM','LND')
        allocate(buffer(max(nlon,nlat)+1))
        ! read coordinates of grid cell vertices
        call read_data(grid_file, 'xb'//lowercase(component(1:1)), buffer(1:nlon+1), no_domain=.true.)
        do j = js, je+1
           do i = is, ie+1
              lonb(i+i0,j+j0) = buffer(i)
           enddo
        enddo
        call read_data(grid_file, 'yb'//lowercase(component(1:1)), buffer(1:nlat+1), no_domain=.true.)
        do j = js, je+1
           do i = is, ie+1
              latb(i+i0,j+j0) = buffer(j)
           enddo
        enddo
        deallocate(buffer)
     case('OCN')
        nlon=ie-is+1; nlat=je-js+1
        allocate (x_vert_t(nlon,nlat,4), y_vert_t(nlon,nlat,4) ) 
        call read_data(grid_file, 'x_vert_T', x_vert_t, no_domain=.not.present(domain), domain=domain )
        call read_data(grid_file, 'y_vert_T', y_vert_t, no_domain=.not.present(domain), domain=domain )
        lonb(1:nlon,1:nlat) = x_vert_t(1:nlon,1:nlat,1)
        lonb(nlon+1,1:nlat) = x_vert_t(nlon,1:nlat,2)
        lonb(1:nlon,nlat+1) = x_vert_t(1:nlon,nlat,4)
        lonb(nlon+1,nlat+1) = x_vert_t(nlon,nlat,3)
        latb(1:nlon,1:nlat) = y_vert_t(1:nlon,1:nlat,1)
        latb(nlon+1,1:nlat) = y_vert_t(nlon,1:nlat,2)
        latb(1:nlon,nlat+1) = y_vert_t(1:nlon,nlat,4)
        latb(nlon+1,nlat+1) = y_vert_t(nlon,nlat,3)
        deallocate(x_vert_t, y_vert_t)
     end select
  case(VERSION_2)
     ! get the name of the mosaic file for the component
     call read_data(grid_file, trim(lowercase(component))//'_mosaic_file', filename1)
     filename1=grid_dir//trim(filename1)
     ! get the name of the grid file for the component and tile
     call read_data(filename1, 'gridfiles', filename2, level=tile)
     filename2 = grid_dir//trim(filename2)
     if(PRESENT(domain)) then
        call mpp_get_global_domain(domain, xbegin=isg, ybegin=jsg)
        start = 1; nread = 1
        start(1) = 2*(is-isg+1) - 1; nread(1) = 2*(ie-is)+3
        start(2) = 2*(js-jsg+1) - 1; nread(2) = 2*(je-js)+3
        allocate(tmp(nread(1), nread(2)) )
        call read_data(filename2, 'x', tmp, start, nread, no_domain=.TRUE.)
        do j = 1, je-js+2
           do i = 1, ie-is+2
              lonb(i,j) = tmp(2*i-1,2*j-1)
           enddo
        enddo
        call read_data(filename2, 'y', tmp, start, nread, no_domain=.TRUE.)
        do j = 1, je-js+2
           do i = 1, ie-is+2
              latb(i,j) = tmp(2*i-1,2*j-1)
           enddo
        enddo        
     else
        allocate(tmp(2*nlon+1,2*nlat+1))
        call read_data(filename2, 'x', tmp, no_domain=.TRUE.)
        do j = js, je+1
           do i = is, ie+1
              lonb(i+i0,j+j0) = tmp(2*i-1,2*j-1)
           end do
        end do
        call read_data(filename2, 'y', tmp, no_domain=.TRUE.)
        do j = js, je+1
           do i = is, ie+1
              latb(i+i0,j+j0) = tmp(2*i-1,2*j-1)
           end do
        end do
     endif
     deallocate(tmp)
  end select

end subroutine get_grid_cell_vertices_2D

! ============================================================================
! returns global coordinate arrays fro given model component and mosaic tile number
! NOTE that in case of non-lat-lon grid those coordinates may have be not so 
! meaningful, by the very nature of such grids. But presumably these 1D coordinate 
! arrays are good enough for diag axis and such.
! ============================================================================
subroutine get_grid_cell_centers_1D(component, tile, glon, glat)
  character(len=*), intent(in) :: component
  integer, intent(in) :: tile
  real, intent(inout) :: glon(:),glat(:)
  integer                      :: nlon, nlat
  integer                      :: start(4), nread(4)
  real, allocatable            :: tmp(:,:)
  character(len=MAX_FILE)      :: filename1, filename2

  call get_grid_size_for_one_tile(component, tile, nlon, nlat)
  if (size(glon(:))/=nlon) &
       call error_mesg ( module_name//'/get_grid_cell_centers_1D',&
       'Size of argument "glon" is not consistent with the grid size',FATAL)
  if (size(glat(:))/=nlat) &
       call error_mesg ( module_name//'/get_grid_cell_centers_1D',&
       'Size of argument "glat" is not consistent with the grid size',FATAL)
  if(trim(component) .NE. 'ATM' .AND. component .NE. 'LND' .AND. component .NE. 'OCN') then
     call error_mesg(module_name//'/get_grid_cell_centers_1D',&
          'Illegal component name "'//trim(component)//'": must be one of ATM, LND, or OCN',&
          FATAL)     
  endif

  select case(get_grid_version())
  case(VERSION_0)
     select case(trim(component))
     case('ATM','LND')
        call read_data(grid_file, 'xt'//lowercase(component(1:1)), glon, no_domain=.true.)
        call read_data(grid_file, 'yt'//lowercase(component(1:1)), glat, no_domain=.true.)
     case('OCN')
        call read_data(grid_file, "gridlon_t", glon, no_domain=.true.) 
        call read_data(grid_file, "gridlat_t", glat, no_domain=.true.)
     end select 
  case(VERSION_1)
     select case(trim(component))
     case('ATM','LND')
        call read_data(grid_file, 'xt'//lowercase(component(1:1)), glon, no_domain=.true.)
        call read_data(grid_file, 'yt'//lowercase(component(1:1)), glat, no_domain=.true.)
     case('OCN')
        call read_data(grid_file, "grid_x_T", glon, no_domain=.true.) 
        call read_data(grid_file, "grid_y_T", glat, no_domain=.true.) 
     end select
  case(VERSION_2)
     ! get the name of the mosaic file for the component
     call read_data(grid_file, trim(lowercase(component))//'_mosaic_file', filename1)
     filename1=grid_dir//trim(filename1)
     ! get the name of the grid file for the component and tile
     call read_data(filename1, 'gridfiles', filename2, level=tile)
     filename2 = grid_dir//trim(filename2)

     start = 1; nread = 1
     nread(1) = 2*nlon+1; start(2) = 2
     allocate( tmp(2*nlon+1,1) )
     call read_data(filename2, "x", tmp, start, nread, no_domain=.TRUE.)
     glon(1:nlon) = tmp(2:2*nlon:2,1)
     deallocate(tmp)
     allocate(tmp(1, 2*nlat+1))

     start = 1; nread = 1
     nread(2) = 2*nlat+1; start(1) = 2
     call read_data(filename2, "y", tmp, start, nread, no_domain=.TRUE.)
     glat(1:nlat) = tmp(1,2:2*nlat:2)
     deallocate(tmp)
  end select

  
end subroutine get_grid_cell_centers_1D

! ============================================================================
! returns grid cell centers for specified model component and mosaic tile number
! ============================================================================
subroutine get_grid_cell_centers_2D(component, tile, lon, lat, domain)
  character(len=*), intent(in) :: component
  integer, intent(in) :: tile
  real, intent(inout) :: lon(:,:),lat(:,:)
  type(domain2d), intent(in), optional :: domain
  ! local vars
  character(len=MAX_NAME) :: varname
  character(len=MAX_FILE) :: filename1, filename2
  integer :: nlon, nlat
  integer :: i,j
  real, allocatable :: buffer(:),tmp(:,:)
  integer :: is,ie,js,je ! boundaries of our domain
  integer :: i0,j0 ! offsets for coordinates
  integer :: isg, jsg
  integer :: start(4), nread(4) 

  call get_grid_size_for_one_tile(component, tile, nlon, nlat)
  if (present(domain)) then
    call mpp_get_compute_domain(domain,is,ie,js,je)
  else
    is = 1 ; ie = nlon
    js = 1 ; je = nlat
    !--- domain normally should be present
    call error_mesg ( module_name//'/get_grid_cell_centers',&
       'domain is not present, global data will be read', NOTE)
  endif
  i0 = -is+1; j0 = -js+1

  ! verify that lon and lat sizes are consistent with the size of domain
  if (size(lon,1)/=ie-is+1.or.size(lon,2)/=je-js+1) &
       call error_mesg ( module_name//'/get_grid_cell_centers',&
       'Size of array "lon" is not consistent with the domain size',&
       FATAL )
  if (size(lat,1)/=ie-is+1.or.size(lat,2)/=je-js+1) &
       call error_mesg ( module_name//'/get_grid_cell_centers',&
       'Size of array "lat" is not consistent with the domain size',&
       FATAL )
  if(trim(component) .NE. 'ATM' .AND. component .NE. 'LND' .AND. component .NE. 'OCN') then
     call error_mesg(module_name//'/get_grid_cell_vertices',&
          'Illegal component name "'//trim(component)//'": must be one of ATM, LND, or OCN',&
          FATAL)  
  endif

  select case(get_grid_version())
  case(VERSION_0)
     select case (trim(component))
     case('ATM','LND')
        allocate(buffer(max(nlon,nlat)))
        ! read coordinates of grid cell vertices
        call read_data(grid_file, 'xt'//lowercase(component(1:1)), buffer(1:nlon), no_domain=.true.)
        do j = js,je
        do i = is,ie
           lon(i+i0,j+j0) = buffer(i)
        enddo
        enddo
        call read_data(grid_file, 'yt'//lowercase(component(1:1)), buffer(1:nlat), no_domain=.true.)
        do j = js,je
        do i = is,ie
           lat(i+i0,j+j0) = buffer(j)
        enddo
        enddo
        deallocate(buffer)
     case('OCN')
        call read_data(grid_file, 'geolon_t', lon, no_domain=.not.present(domain), domain=domain )
        call read_data(grid_file, 'geolat_t', lat, no_domain=.not.present(domain), domain=domain )
     end select
  case(VERSION_1)
     select case(trim(component))
     case('ATM','LND')
        allocate(buffer(max(nlon,nlat)))
        ! read coordinates of grid cell vertices
        call read_data(grid_file, 'xt'//lowercase(component(1:1)), buffer(1:nlon), no_domain=.true.)
        do j = js,je
        do i = is,ie
           lon(i+i0,j+j0) = buffer(i)
        enddo
        enddo
        call read_data(grid_file, 'yt'//lowercase(component(1:1)), buffer(1:nlat), no_domain=.true.)
        do j = js,je
        do i = is,ie
           lat(i+i0,j+j0) = buffer(j)
        enddo
        enddo
        deallocate(buffer)
     case('OCN')
        call read_data(grid_file, 'x_T', lon, no_domain=.not.present(domain), domain=domain )
        call read_data(grid_file, 'y_T', lat, no_domain=.not.present(domain), domain=domain )
     end select
  case(VERSION_2) ! mosaic grid file
     ! get the name of the mosaic file for the component
     call read_data(grid_file, trim(lowercase(component))//'_mosaic_file', filename1)
     filename1=grid_dir//trim(filename1)
     ! get the name of the grid file for the component and tile
     call read_data(filename1, 'gridfiles', filename2, level=tile)
     filename2 = grid_dir//trim(filename2)
     if(PRESENT(domain)) then
        call mpp_get_global_domain(domain, xbegin=isg, ybegin=jsg)
        start = 1; nread = 1
        start(1) = 2*(is-isg+1) - 1; nread(1) = 2*(ie-is)+3
        start(2) = 2*(js-jsg+1) - 1; nread(2) = 2*(je-js)+3
        allocate(tmp(nread(1), nread(2)))
        call read_data(filename2, 'x', tmp, start, nread, no_domain=.TRUE.)
        do j = 1, je-js+1
           do i = 1, ie-is+1
              lon(i,j) = tmp(2*i,2*j)
           enddo
        enddo
        call read_data(filename2, 'y', tmp, start, nread, no_domain=.TRUE.)
        do j = 1, je-js+1
           do i = 1, ie-is+1
              lat(i,j) = tmp(2*i,2*j)
           enddo
        enddo        
     else
        allocate(tmp(2*nlon+1,2*nlat+1))
        call read_data(filename2, 'x', tmp, no_domain=.TRUE.)
        do j = js,je
           do i = is,ie
              lon(i+i0,j+j0) = tmp(2*i,2*j)
           end do
        end do
        call read_data(filename2, 'y', tmp, no_domain=.TRUE.)
        do j = js,je
           do i = is,ie
              lat(i+i0,j+j0) = tmp(2*i,2*j)
           end do
        end do
        deallocate(tmp)
     endif
  end select

end subroutine get_grid_cell_centers_2D


! ============================================================================
! given a model component, a layout, and (optionally) a halo size, returns a 
! domain for current processor
! ============================================================================
! this subroutine probably does not belong in the grid_mod 
subroutine define_cube_mosaic ( component, domain, layout, halo, maskmap )
  character(len=*) , intent(in)    :: component
  type(domain2d)   , intent(inout) :: domain
  integer          , intent(in)    :: layout(2)
  integer, optional, intent(in)    :: halo 
  logical, optional, intent(in)    :: maskmap(:,:,:)

  ! ---- local constants
  
  ! ---- local vars
  character(len=MAX_NAME) :: varname
  character(len=MAX_FILE) :: mosaic_file
  integer :: ntiles     ! number of tiles
  integer :: ncontacts  ! number of contacts between mosaic tiles
  integer :: n
  integer :: ng, pe_pos, npes         ! halo size
  integer, allocatable :: nlon(:), nlat(:), global_indices(:,:)
  integer, allocatable :: pe_start(:), pe_end(:), layout_2d(:,:)
  integer, allocatable :: tile1(:),tile2(:)
  integer, allocatable :: is1(:),ie1(:),js1(:),je1(:)
  integer, allocatable :: is2(:),ie2(:),js2(:),je2(:)

  call get_grid_ntiles(component,ntiles)
  allocate(nlon(ntiles), nlat(ntiles))
  allocate(global_indices(4,ntiles))
  allocate(pe_start(ntiles),pe_end(ntiles))
  allocate(layout_2d(2,ntiles))
  call get_grid_size(component,nlon,nlat)

  pe_pos = mpp_root_pe()
  do n = 1, ntiles
     global_indices(:,n) = (/ 1, nlon(n), 1, nlat(n) /)
     layout_2d     (:,n) = layout
     if(present(maskmap)) then
        npes = count(maskmap(:,:,n))
     else
        npes = layout(1)*layout(2)
     endif
     pe_start(n) = pe_pos
     pe_end  (n) = pe_pos + npes - 1
     pe_pos      = pe_end(n) + 1
  enddo

  varname=trim(lowercase(component))//'_mosaic_file'
  call read_data(grid_file,varname,mosaic_file)
  mosaic_file = grid_dir//mosaic_file

  ! get the contact information from mosaic file
  ncontacts = get_mosaic_ncontacts(mosaic_file)
  allocate(tile1(ncontacts),tile2(ncontacts))
  allocate(is1(ncontacts),ie1(ncontacts),js1(ncontacts),je1(ncontacts))
  allocate(is2(ncontacts),ie2(ncontacts),js2(ncontacts),je2(ncontacts))
  call get_mosaic_contact(mosaic_file, tile1, tile2, &
       is1, ie1, js1, je1, is2, ie2, js2, je2)

  ng = 0
  if(present(halo)) ng = halo
  ! create the domain2d variable
  call mpp_define_mosaic ( global_indices, layout_2d, domain, &
       ntiles, ncontacts, tile1, tile2,                  &
       is1, ie1, js1, je1, &
       is2, ie2, js2, je2, &
       pe_start=pe_start, pe_end=pe_end, symmetry=.true.,  &
       shalo = ng, nhalo = ng, whalo = ng, ehalo = ng,     &
       maskmap = maskmap,                                  &
       name = trim(component)//'Cubic-Sphere Grid' )

  deallocate(nlon,nlat,global_indices,pe_start,pe_end,layout_2d)
  deallocate(tile1,tile2)
  deallocate(is1,ie1,js1,je1)
  deallocate(is2,ie2,js2,je2)

end subroutine define_cube_mosaic

end module grid_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The non-local, approximate weak-equilibrium stability function\label{sec:cmueB}
!
! !INTERFACE:
   subroutine cmue_b(nlev)
!
! !DESCRIPTION:
!  This subroutine is used to update the quantities
!  $c_\mu$, $c'_\mu$ and $\Gamma$, defined in \eq{b13}, from which all turbulent
!  fluxes can be computed. This done exactly as described in \sect{sec:cmueA}, with
!  the exception that equilibrium $P+G=\epsilon$ and $P_b = \epsilon_b$ is assumed
!  in computing the non-linear terms in \eq{NandNb}, leading to the particularly
!  simple expressions
!  \begin{equation}
!    \label{NandNbEq}
!      {\cal N} = \dfrac{c_1}{2} \comma
!      {\cal N}_b =  c_{b1}
!      \point
!  \end{equation}


! !USES:
   use turbulence, only: an,as,at
   use turbulence, only: cmue1,cmue2,gam
   use turbulence, only: cm0
   use turbulence, only: cc1
   use turbulence, only: ct1,ctt
   use turbulence, only: a1,a2,a3,a4,a5
   use turbulence, only: at1,at2,at3,at4,at5

   IMPLICIT NONE
!
! !INPUT PARAMETERS:
!
!  number of vertical layers
   integer, intent(in)       :: nlev
!
! !BUGS:
! Test stage. Do not yet use.
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!
!  $Log: cmue_b.F90,v $
!  Revision 20.0  2013/12/14 00:13:29  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1  2005-06-27 10:54:33  kbk
!  new files needed
!
!
!EOP
!-----------------------------------------------------------------------
! !LOCAL VARIABLES:

     integer                 ::   i
     REALTYPE                ::   N,Nt
     REALTYPE                ::   d0,d1,d2,d3,d4,d5
     REALTYPE                ::   n0,n1,n2,n3,nt0,nt1,nt2
     REALTYPE                ::   gam0,gam1,gam2
     REALTYPE                ::   dCm,nCm,nCmp,nGam,cm3_inv

!-----------------------------------------------------------------------
!BOC

     N     =   0.5*cc1
     Nt    =   ct1

     d0    =   36.* N**3. * Nt**2.
     d1    =   84.*a5*at3 * N**2. * Nt
     d2    =   9.*(at2**2.-at1**2.) * N**3. - 12.*(a2**2.-3.*a3**2.) * N * Nt**2.
     d3    =   12.*a5*at3*(a2*at1-3.*a3*at2) * N + 12.*a5*at3*(a3**2.-a2**2.) * Nt
     d4    =   48.*a5**2.*at3**2. * N
     d5    =   3.*(a2**2.-3.*a3**2.)*(at1**2.-at2**2.) * N


     n0    =   36.*a1 * N**2. * Nt**2.
     n1    = - 12.*a5*at3*(at1+at2) * N**2. + 8.*a5*at3*(6.*a1-a2-3.*a3) * N * Nt
     n2    =   9.*a1*(at2**2.-at1**2.) * N**2.
     n3    =   12.*a5*at4*(3.*(at1+at2) * N**2. + 2.*(a2+3.*a3) * N * Nt)

     nt0   =   12.*at3 * N**3. * Nt
     nt1   =   12.*a5*at3**2.  * N**2.
     nt2   =   9.*a1*at3*(at1-at2) * N**2. + (  6.*a1*(a2-3.*a3)                         &
             - 4.*(a2**2.-3.*a3**2.) )*at3 * N * Nt

     gam0  =   36.*at4 * N**3. * Nt
     gam1  =   36.*a5*at3*at4 * N**2.
     gam2  =  -12.*at4*(a2**2.-3.*a3**2.) * N * Nt

     cm3_inv = 1./cm0**3.

     do i=0,nlev

        dCm  =  d0  +  d1*an(i) +  d2*as(i) + d3*an(i)*as(i) + d4*an(i)*an(i) + d5*as(i)*as(i)
        nCm  =  n0  +  n1*an(i) +  n2*as(i) + n3*at(i)
        nCmp =  nt0 + nt1*an(i) + nt2*as(i)

        nGam = ( gam0 + gam1*an(i) + gam2*as(i) )*at(i)

        cmue1(i) =  cm3_inv*nCm /dCm
        cmue2(i) =  cm3_inv*nCmp/dCm
        gam(i)   =          nGam/dCm

     end do


     return
     end subroutine cmue_b
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

module strat_chem_utilities_mod

use       mpp_io_mod, only : mpp_open, mpp_close, MPP_RDONLY
use          mpp_mod, only : mpp_pe, mpp_root_pe, stdout
use          fms_mod, only : file_exist, open_namelist_file, close_file, &
                             error_mesg, FATAL
use    constants_mod, only : PI, DEG_TO_RAD, AVOGNO, PSTD_MKS, SECONDS_PER_DAY
use time_manager_mod, only : time_type, get_date, days_in_month, days_in_year, &
                             set_date, increment_time, set_time, &
                             operator(>), operator(<), operator(-), operator(+)
!++lwh
use interpolator_mod, only : interpolate_type, interpolator_init, &
                             obtain_interpolator_time_slices, &
                             unset_interpolator_time_flag, &
                             interpolator, interpolator_end, &
                             CONSTANT, INTERP_WEIGHTED_P
use time_interp_mod, only  : time_interp_init, time_interp
use diag_manager_mod, only : get_base_time

!--lwh

implicit none
private

integer, parameter :: nlon_input=144, nlat_input=90, nlev_input=48, &
                      nspecies_age=8, nspecies_lbc=15, &
                      ntime_tropc=151, year_start_tropc=1950, nspecies_tropc=9
! real, parameter :: agefact1 = 1.5, &
!                    agefact2 = 1.25
real, parameter :: clweight(7) = (/ 3., 2., 3., 4., 1., 3., 1. /)

real :: tropc(ntime_tropc,nspecies_tropc)
!++lwh
type(time_type) :: tropc_Time(ntime_tropc), cfc_entry, cfc_offset
logical :: time_varying_cfc_lbc, negative_offset_cfc

! real :: dfdage(nlat_input,nlev_input,nspecies_age)
! real :: lat_input(nlat_input)
real, parameter :: days_per_year = 365.25, &
                   tfact = 1./(days_per_year*SECONDS_PER_DAY)
! integer :: jstart
real :: age_factor, dclydt_factor
!--lwh

type psc_type
   private
   real, dimension(:,:), pointer :: &
      tice=>NULL(), wh2so4=>NULL(), am=>NULL(), aw=>NULL(), &
      aliq=>NULL(), rmean=>NULL(), asat=>NULL(), rnat=>NULL(), rice=>NULL()
   real, dimension(:,:,:), pointer :: &
      cond=>NULL()
   real :: adrop, anat, aice
end type psc_type

!++lwh
type(interpolate_type), save  :: dfdage_interp
character(len=32), save  :: dfdage_filename = "dfdage3.dat.nc"
character(len=32), dimension(nspecies_age), save :: dfdage_name = &      ! kerr
      (/ "dfdage_cfc11  ", "dfdage_cfc12  ", "dfdage_cfc113 ", "dfdage_ccl4   ", &
         "dfdage_ch3cl  ", "dfdage_ch3ccl3", "dfdage_hcfc22 ", "dfdage_bry    " /)
!--lwh

! For extra H2O calculation
real, dimension(:), allocatable :: ch4_value
type(time_type), dimension(:), allocatable :: ch4_time
logical :: fixed_ch4_lbc_time = .false.
type(time_type) :: ch4_entry

!-----------------------------------------------------------------------
!     ... interfaces
!-----------------------------------------------------------------------
public strat_chem_utilities_init, strat_chem_dcly_dt, strat_chem_get_aerosol, &
       strat_chem_dcly_dt_time_vary, strat_chem_dcly_dt_endts, &
       strat_chem_get_h2so4, strat_chem_get_psc, strat_chem_destroy_psc, &
       strat_chem_get_gamma, strat_chem_get_hetrates, strat_chem_psc_sediment, &
       strat_chem_get_extra_h2o, &
       psc_type


!---- version number -----
character(len=128), parameter :: version     = ''
character(len=128), parameter :: tagname     = ''

logical :: module_is_initialized=.false.

CONTAINS

subroutine strat_chem_utilities_init( lonb, latb, age_factor_in, dclydt_factor_in, &
                                      set_min_h2o_strat, ch4_filename, ch4_scale_factor, &
                                      fixed_ch4_lbc_time_in, ch4_entry_in, &
                                      cfc_lbc_filename, time_varying_cfc_lbc_in, cfc_lbc_dataset_entry )

   implicit none
! dummy arguments
   real,             intent(in), dimension(:,:) :: lonb,latb
   real,             intent(in)                 :: age_factor_in, dclydt_factor_in
   logical,          intent(in)                 :: set_min_h2o_strat
   character(len=*), intent(in)                 :: ch4_filename
   real,             intent(in)                 :: ch4_scale_factor
   logical,          intent(in)                 :: fixed_ch4_lbc_time_in
   type(time_type),  intent(in)                 :: ch4_entry_in
   character(len=*), intent(in)                 :: cfc_lbc_filename
   logical,          intent(in)                 :: time_varying_cfc_lbc_in
   integer,          intent(in), dimension(:)   :: cfc_lbc_dataset_entry
   
! local variables
   real :: chlb_dummy(nlat_input,nspecies_lbc), &
           ozb_dummy(nlon_input, nlat_input, 12)
   integer :: unit, nc, n, year, outunit
   type(time_type) :: Model_init_time
   
   if (module_is_initialized) return

!-----------------------------------------------------------------------
!     ... initialize time_interp
!-----------------------------------------------------------------------
   call time_interp_init

!-----------------------------------------------------------------------
!     ... set scale factors for age of air and dcly/dt
!-----------------------------------------------------------------------
   age_factor = age_factor_in
   dclydt_factor = dclydt_factor_in

!-----------------------------------------------------------------------
!     ... read in chemical lower boundary 
!-----------------------------------------------------------------------
   call mpp_open( unit, 'INPUT/' // TRIM(cfc_lbc_filename),action=MPP_RDONLY )
   outunit= stdout()
   if (mpp_pe() == mpp_root_pe()) WRITE(outunit,*) 'reading INPUT/' // TRIM(cfc_lbc_filename)
   do nc = 1,15                                           
     read(unit,'(6E13.6)') chlb_dummy(:,nc)
   end do
   read(unit,'(6E13.6)') ozb_dummy
   read(unit,'(6e13.6)') tropc
   call mpp_close(unit)

!++lwh
!---------------------------------------------------------------------
!    convert the time stamps of the tropc series to time_type variables.     
!---------------------------------------------------------------------
   time_varying_cfc_lbc = time_varying_cfc_lbc_in
   Model_init_time = get_base_time()
   if ( cfc_lbc_dataset_entry(1) == 1 .and. &
        cfc_lbc_dataset_entry(2) == 1 .and. &
        cfc_lbc_dataset_entry(3) == 1 .and. &
        cfc_lbc_dataset_entry(4) == 0 .and. &
        cfc_lbc_dataset_entry(5) == 0 .and. &
        cfc_lbc_dataset_entry(6) == 0 ) then
      cfc_entry = Model_init_time
   else
      cfc_entry = set_date( cfc_lbc_dataset_entry(1), &
                            cfc_lbc_dataset_entry(2), &
                            cfc_lbc_dataset_entry(3), &
                            cfc_lbc_dataset_entry(4), &
                            cfc_lbc_dataset_entry(5), &
                            cfc_lbc_dataset_entry(6) )
   end if         
   if (time_varying_cfc_lbc) then
      cfc_offset = cfc_entry - Model_init_time
      if (Model_init_time > cfc_entry) then
         negative_offset_cfc = .true.
      else
         negative_offset_cfc = .false.
      end if
   end if

   do n = 1,ntime_tropc
      year = year_start_tropc + (n-1)
      tropc_Time(n) = set_date(year,1,1,0,0,0)
   end do
!--lwh


!++lwh -- replace dfdage ASCII file with NetCDF via interpolator

!  read in data for Cly and Bry computation
!  call mpp_open( unit, 'INPUT/ageair_fms_90.dat', action=MPP_RDONLY )
!  if (mpp_pe() == mpp_root_pe()) &
!     write(stdout(),*) 'strat_chem_utilities_init: Reading from INPUT/ageair_fms_90.dat'
!  read(unit,'(6e13.6)') age_dummy
!  read(unit,'(6e13.6)') dfdage
!  call mpp_close(unit)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!  THIS CODE WILL NOT WORK CORRECTLY FOR CUBED SPHERE  !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  jstart = 0   
!  do j = 1,nlat_input
!     lat_input(j) = ( -90. + (180./(nlat_input-1))*(j-1) ) * DEG_TO_RAD
!     if (lat_input(j) >= latb(1,1) .and. lat_input(j) <= latb(1,2)) jstart = j
!  end do
!  if (mpp_pe() == mpp_root_pe()) &
!     write(stdout(),*) 'strat_chem_utilities_init: jstart=',jstart,' on PE ',mpp_pe()
!

   call interpolator_init (dfdage_interp,  &
                           dfdage_filename, lonb, latb,  &
                           data_names=dfdage_name(:),   &
                           data_out_of_bounds=(/CONSTANT/), &
                           vert_interp=(/INTERP_WEIGHTED_P/) )  

   if (set_min_h2o_strat) then
      call strat_chem_extra_h2o_init( ch4_filename, ch4_scale_factor, &
                                      fixed_ch4_lbc_time_in, ch4_entry_in )
   end if

   module_is_initialized = .true.


end subroutine strat_chem_utilities_init



!#####################################################################

subroutine strat_chem_dcly_dt_time_vary(Time)


type(time_type), intent(in) :: Time

      call obtain_interpolator_time_slices (dfdage_interp, Time)

end subroutine strat_chem_dcly_dt_time_vary



!#####################################################################

subroutine strat_chem_dcly_dt_endts              

      call unset_interpolator_time_flag (dfdage_interp)

end subroutine strat_chem_dcly_dt_endts



!#####################################################################

!++lwh
subroutine strat_chem_dcly_dt(Time, phalf, is, js, age, cly, bry, dclydt, dbrydt)
!--lwh

implicit none

! dummy arguments

type(time_type),        intent(in)  :: Time
!++lwh
integer,                intent(in)  :: is, js
real, dimension(:,:,:), intent(in)  :: phalf, age, cly, bry
!--lwh
real, dimension(:,:,:), intent(out) :: dclydt, dbrydt

! local variables

integer :: iyear, imon, iday, ihour, imin, isec
real :: dt1, factor, extra_seconds
integer :: it1,it2
integer :: ic, i, j, k, il, jl, kl
real :: clytot, brytot
!++lwh
! real, dimension(size(age,1),size(age,2),nspecies_age) :: dfdtau
real, dimension(size(age,1),size(age,2),size(age,3),nspecies_age) :: dfdage
type(time_type) :: cfc_Time, cfc_base_Time
!--lwh
real, dimension(size(age,1),size(age,2),nspecies_tropc) :: cfc
character(len=256) :: err_msg

call get_date( Time, iyear, imon, iday, ihour, imin, isec )

il = size(age,1)
jl = size(age,2)
kl = size(age,3)

!-----------------------------------------------------------------------
!     ... Compute multiplying factor for missing CFCs, and include factor
!         for conversion of rates to a per second rate. 
!-----------------------------------------------------------------------

! time0 = iyear + REAL(imon-1)/12.
! it1 = INT(time0-year_start_tropc) + 1
! it1 = min(max(it1,1),ntime_tropc-1)
! it2 = it1+1
! dt1 = time0 - (year_start_tropc-1) - it1

! sum1 = 0.
! sum2 = 0.
! do ic = 1,7
!    sum1 = sum1 + clweight(ic) * tropc(it1,ic)
!    sum2 = sum2 + clweight(ic) * tropc(it2,ic)
! end do
! factor = ((1-dt1)*tropc(it1,8) + dt1*tropc(it2,8))*tfact / (sum1*(1-dt1) + sum2*dt1)

! monthfrac = REAL(iday)/REAL(days_in_month(Time))
! imon2 = MOD(imon,12) + 1


!++lwh -- Read in dfdage from NetCDF file via interpolator
call interpolator (dfdage_interp, Time, phalf, dfdage, dfdage_name(1), is, js)
!--lwh

if (time_varying_cfc_lbc) then
   if (negative_offset_cfc) then
      cfc_base_Time = Time - cfc_offset
   else
      cfc_base_Time = Time + cfc_offset
   end  if
else
   cfc_base_Time = cfc_entry
end if

level_loop: &
do k = 1,kl


!++lwh -- Switch to reading from NetCDF file via interpolator (above)
! Copy dfdage to locally indexed variable
!  do j = 1,jl
!  do ic = 1,8
!     dfdtau(:,j,ic) = dfdage(j+jstart-1+js-1,k,ic)
!  end do
!  end do
!--lwh

!-----------------------------------------------------------------------
!     ... Compute CFCs at time t - age
!-----------------------------------------------------------------------

   do j = 1,jl
   do i = 1,il
!++lwh
! Time-interpolate tropospheric CFC concentrations
!     time0 = iyear + (imon+monthfrac-1)/12. - age(i,j,k)*age_factor
!     it1 = INT(time0-year_start_tropc) + 1
!     it1 = min(max(it1,1),ntime_tropc-1)
!     it2 = it1 + 1
!     dt1 = time0 - (year_start_tropc-1) - it1
!     cfc(i,j,:) = tropc(it1,:)*(1-dt1) + tropc(it2,:)*dt1

      extra_seconds = age(i,j,k)*age_factor / tfact
      
      cfc_Time = increment_time( cfc_base_Time, -NINT(extra_seconds), 0)
      if (cfc_Time < tropc_Time(1)) then
         cfc_Time = tropc_Time(1)
      else if (cfc_Time > tropc_Time(ntime_tropc)) then
         cfc_Time = tropc_Time(ntime_tropc)
      end if
      call time_interp( cfc_Time, tropc_Time(:), dt1, it1, it2, err_msg=err_msg )
      if(err_msg /= '') then
         call error_mesg('strat_chem_dcly_dt', trim(err_msg) , FATAL)
      endif

      cfc(i,j,:) = tropc(it1,:)*(1-dt1) + tropc(it2,:)*dt1
!--lwh

      factor = cfc(i,j,8) / SUM(cfc(i,j,1:7)*clweight(1:7))
      dclydt(i,j,k) = 0.
      do ic = 1,7
         dclydt(i,j,k) = dclydt(i,j,k) &
                       + factor * 1.e-12 * tfact * dclydt_factor &
!++lwh
!                      * dfdtau(i,j,ic) * clweight(ic) * cfc(i,j,ic)
                       * dfdage(i,j,k,ic) * clweight(ic) * cfc(i,j,ic)
!--lwh
      end do
      clytot = 1.e-12*cfc(i,j,8)
      if (cly(i,j,k) >= clytot) dclydt(i,j,k) = 0.
!++lwh
!     dbrydt(i,j,k) = 1.e-12 * tfact * dfdtau(i,j,8)*cfc(i,j,9)
      dbrydt(i,j,k) = 1.e-12 * tfact * dfdage(i,j,k,8)*cfc(i,j,9)
!--lwh
      brytot = 1.e-12*cfc(i,j,9)
      if (bry(i,j,k) >= brytot) dbrydt(i,j,k) = 0.
   end do
   end do
   
end do level_loop


end subroutine strat_chem_dcly_dt


! <SUBROUTINE NAME="strat_chem_get_aerosol">
!   <OVERVIEW>
!     Estimate stratospheric aerosol surface area based on aerosol extinction.
!   </OVERVIEW>
!   <DESCRIPTION>
!     Estimate stratospheric aerosol surface area based on aerosol extinction.
!     This subroutine is called from tropchem_driver. Aerosol extinction in
!     band 4 (centered at 1um) is saved as a diagnostic tracer in swresf.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call strat_chem_get_aerosol (extinct, aerosol)
!   </TEMPLATE>
!   <IN NAME="extinct" TYPE="real" DIM="(:,:,:)">
!     Aerosol extinction for band 4 centered at 1 um (in units of 1/m)
!   </IN>
!   <OUT NAME="aerosol" TYPE="real" DIM="(:,:,:)">
!     Volcanic aerosol surface area (cm2/cm3)
!   </OUT>


subroutine strat_chem_get_aerosol( extinct, aerosol )

implicit none

! dummy arguments

real, dimension(:,:,:), intent(in)  :: extinct
real, dimension(:,:,:), intent(out) :: aerosol

! local variables

real, dimension(size(extinct,1),size(extinct,2)) :: extinct_local
integer :: k

do k = 1,size(extinct,3)

   extinct_local(:,:) = extinct(:,:,k) * 1.e3 ! convert to 1/km
   where( extinct_local(:,:) <= 0. )
      aerosol(:,:,k) = 0.
   elsewhere( extinct_local(:,:) <= 4.e-3 )
      aerosol(:,:,k) = 4.25e-6 * extinct_local(:,:)**0.68
   elsewhere( extinct_local(:,:) <= 2.e-2 )
      aerosol(:,:,k) = 1.223e-5 * extinct_local(:,:)**0.875
   elsewhere
      aerosol(:,:,k) = 2.e-5 * extinct_local(:,:)
   end where

end do

end subroutine strat_chem_get_aerosol


! <SUBROUTINE NAME="strat_chem_get_h2so4">
!   <OVERVIEW>
!     Set stratospheric H2SO4
!   </OVERVIEW>
!   <DESCRIPTION>
!     Set stratospheric H2SO4 as an analytical function of age, peaking at 0.5 ppbv
!   </DESCRIPTION>
!   <TEMPLATE>
!     call strat_chem_get_h2so4( press, age, h2so4 )
!   </TEMPLATE>
!   <IN NAME="press" TYPE="real" DIM="(:,:)">
!     Pressure on model full levels (Pa)
!   </IN>
!   <IN NAME="age" TYPE="real" DIM="(:,:)">
!     Age-of-air tracer (yrs)
!   </IN>
!   <OUT NAME="h2so4" TYPE="real" DIM="(:,:)">
!     Sulfuric acid (H2SO4) VMR (mol/mol)
!   </OUT>
subroutine strat_chem_get_h2so4(press, age, h2so4)

implicit none

! Dummy arguments

real, dimension(:,:), intent(in)  :: press, age
real, dimension(:,:), intent(out) :: h2so4

! Local variables

integer :: i, k, il, kl
real :: x1, x2


il = size(press,1)
kl = size(press,2)

do k = 1,kl
   do i=1,il

        x1 = 3.*(log10(press(i,k)) - 3.5)**2
        x2 = 3./(10.*age(i,k) + 1.) * (age(i,k) - 1.)**2
        h2so4(i,k) = (0.01 + 0.49*exp(-x1-x2))*1.e-9

   end do
end do

end subroutine strat_chem_get_h2so4



! <SUBROUTINE NAME="strat_chem_get_psc">
!   <OVERVIEW>
!     Set up stratospheric PSCs
!   </OVERVIEW>
!   <DESCRIPTION>
!     Set up stratospheric PSCs
!   </DESCRIPTION>
!   <TEMPLATE>
!     call strat_chem_get_psc( temp, press, hno3, h2o, h2so4, strat_aerosol, psc, psv_vmr_out )
!   </TEMPLATE>
!   <IN NAME="temp" TYPE="real" DIM="(:,:)">
!     Temperature (K)
!   </IN>
!   <IN NAME="press" TYPE="real" DIM="(:,:)">
!     Pressure on model full levels (Pa)
!   </IN>
!   <INOUT NAME="hno3" TYPE="real" DIM="(:,:)">
!     Nitric acid (HNO3) VMR (mol/mol)
!   </INOUT>
!   <INOUT NAME="h2o" TYPE="real" DIM="(:,:)">
!     Water (H2O) VMR (mol/mol)
!   </INOUT>
!   <IN NAME="h2so4" TYPE="real" DIM="(:,:)">
!     Sulfuric acid (H2SO4) VMR (mol/mol)
!   </IN>
!   <IN NAME="strat_aerosol" TYPE="real" DIM="(:,:)">
!     Stratospheric aerosol (liquid)
!   </IN>
!   <OUT NAME="psc" TYPE="psc_type">
!     PSC properties
!   </OUT>
!   <OUT NAME="psc_vmr_out" TYPE="real" DIM="(:,:)" OPTIONAL>
!     PSC VMR (mol/mol)
!   </OUT>

subroutine strat_chem_get_psc( temp, press, hno3, h2o, h2so4, strat_aerosol, psc, psc_vmr_out )

implicit none

! Dummy arguments

real, dimension(:,:), intent(in)    :: temp, press, h2so4, strat_aerosol
real, dimension(:,:), intent(inout) :: hno3, h2o
type(psc_type),       intent(out)   :: psc
real, dimension(:,:,:), intent(out), optional :: psc_vmr_out

! Local variables
integer :: il, kl, i, k
real :: rho(size(temp,1)), &
        DENS(size(temp,1)), &
        VHET(size(temp,1),4), &
        WF(size(temp,1),2)
real :: PH2O, &                    ! H2O partial pressure (atm)
        TSAT,ABT,AMT,BMT,PX,C2, &
        A1,A2,A3,A4,C3,P0H2O,Y1,Y2,T1,RMODE,RMODESAT,SANAT
!----------------------------------------------------------------------------
!
! AVGDR IS THE RECIPROCAL OF THE AVOGADRO CONSTANT
! RR IS THE GAS CONSTANT
!
!----------------------------------------------------------------------------
real, parameter :: AVGDR = 1/AVOGNO, &
                   RR = 8.3144
!----------------------------------------------------------------------------
!
!   ADROP, ANAT AND AICE ARE THE (FIXED) NUMBER OF DROPS OR PARTICLES PER CC
!   IN THE POLAR STRATOSPHERC CLOUDS. A LOG NORMAL SIZE DISTRIBUTION IS ASSUMED
!   WITH SIGMA = 1.8 GIVING LOG(SIGMA)**2 = 0.3455
!
!----------------------------------------------------------------------------
real, parameter :: SIGMAL=0.34549316


real, parameter ::  boltz = 1.38044e-16      ! erg/K


il = size(temp,1)
kl = size(temp,2)

allocate( psc%cond(il,kl,3), &
          psc%tice(il,kl), psc%wh2so4(il,kl), psc%am(il,kl), &
          psc%aw(il,kl), psc%aliq(il,kl), psc%rmean(il,kl), &
          psc%asat(il,kl), psc%rnat(il,kl), psc%rice(il,kl) )

!
!----------------------------------------------------------------------------
!
! COMPUTE SOLID CONDENSED MATTER: COND(IL,1:3) -- SAT, NAT, ICE
!
!----------------------------------------------------------------------------
psc%cond(:,:,1:3) = 0.
psc%adrop = 10.
psc%anat  = 10.
psc%aice  = 10.

do k = 1,kl
   do i=1,il
      rho(i) = 10. * press(i,k) / (boltz * temp(i,k))  ! molec/cm3
      PH2O = h2o(i,k)*press(i,k)/PSTD_MKS
      TSAT = 3236.0 / (11.502 - LOG10(PH2O*760.0))
      IF(temp(i,k) < TSAT) psc%cond(i,k,1) = h2so4(i,k)

      ABT = 39.1104 - 11397.0/temp(i,k) + 9.179E-3*temp(i,k)
      AMT = -2.7836 - 8.8E-4*temp(i,k)
      BMT = -2.1249 + LOG10(PH2O*PSTD_MKS)
      PX = AMT*BMT + ABT
      C2 = hno3(i,k) - 100./press(i,k) * 10.**PX
      IF(C2 > 0.) psc%cond(i,k,2) = C2

      psc%tice(i,k) = 2668.70/(10.4310 - LOG10(760.0*PH2O))
      A1 = 7.5502 - 2668.7/temp(i,k)
      C3 = h2o(i,k) - PSTD_MKS/press(i,k) * 10.**A1
!     C4 = PSTD_MKS/press(i,k) * 10.**A1
      IF(C3 > 0.) psc%cond(i,k,3) = C3

      hno3(i,k) = hno3(i,k) - psc%cond(i,k,2)
!     DYY(i,k,15) = DYY(i,k,15) - psc%cond(i,k,2)
!     CLIMIT = rho(i)*1. E-15
!     DYY(i,k,15) = MAX(DYY(i,k,15),CLIMIT)
      h2o(i,k) = h2o(i,k) - psc%cond(i,k,3)
   end do
!-------------------------------------------------------------------------
!
!  COMPUTE WEIGHT % H2SO4. FROM TABAZADEH ET AL., GRL, 24, 1931-1934, 1997.
!  TABLE A1 OF SHIA ET AL. JGR, 106, 24,529-24,274, 2001
!
!-------------------------------------------------------------------------
   do i = 1,IL
! Saturation water vapor pressure (in mbar)
      P0H2O = EXP(18.452406985 - 3505.1578807/temp(i,k) - &
         330918.55082/temp(i,k)**2 + 12725068.262/temp(i,k)**3)
! Water activity
      psc%aw(i,k) = h2o(i,k)*press(i,k)*0.01/P0H2O
!++lwh
      psc%aw(i,k) = MAX( MIN(psc%aw(i,k), 1.), 0.01 )
!--lwh
      IF (psc%aw(i,k) <= 0.05) THEN
         Y1 = 12.37208932*psc%aw(i,k)**(-0.16125516114) - 30.490657554*psc%aw(i,k) - 2.1133114241
         Y2 = 13.455394705*psc%aw(i,k)**(-0.1921312255) - 34.285174607*psc%aw(i,k) - 1.7620073078
      ELSEIF(psc%aw(i,k) < 0.85) THEN
         Y1 = 11.820654354*psc%aw(i,k)**(-0.20786404244) - 4.807306373*psc%aw(i,k) -  5.1727540348
         Y2 = 12.891938068*psc%aw(i,k)**(-0.23233847708) - 6.4261237757*psc%aw(i,k) - 4.9005471319
      ELSE
         Y1 = -180.06541028*psc%aw(i,k)**(-0.38601102592) - 93.317846778*psc%aw(i,k) + 273.88132245
         Y2 = -176.95814097*psc%aw(i,k)**(-0.36257048154) - 90.469744201*psc%aw(i,k) + 267.45509988
      ENDIF
! Sulfuric acid molality
!++lwh
!     psc%am(i,k) = Y1 + (temp(i,k) - 190.)*(Y2 - Y1)/70.
      psc%am(i,k) = (temp(i,k) - 190.)/70.
      psc%am(i,k) = MAX( MIN(psc%am(i,k), 1.), 0. )
      psc%am(i,k) = Y1 + psc%am(i,k)*(Y2 - Y1)
!--lwh
! Sulfuric acid weight percent
      psc%wh2so4(i,k) = 9800.*psc%am(i,k)/(98.*psc%am(i,k) + 1000.)
      WF(i,1) = 0.01*psc%wh2so4(i,k)
      WF(i,2) = 0.0
   end do
!---------------------------------------------------------------------------
!
!  COMPUTE DENSITY OF BINARY AEROSOL
!
!---------------------------------------------------------------------------
   CALL DENSITY(WF,temp(:,k),DENS)
!---------------------------------------------------------------------------
!
!  COMPUTE VOLUME OF BINARY AEROSOL/SAT/NAT/ICE
!  1.6, 1.35 and 0.928  are the densities of SAT, NAT and ICE
!
!---------------------------------------------------------------------------
   do i=1,IL
     T1 = h2so4(i,k)*press(i,k)/(rho(i)*temp(i,k)*RR)
     VHET(i,1) = T1*98.076E-6/(WF(i,1)*DENS(I))
     VHET(i,2) = psc%cond(i,k,1)*rho(i)*170.1*AVGDR/1.6
     VHET(i,3) = psc%cond(i,k,2)*rho(i)*117.1*AVGDR/1.35
     VHET(i,4) = psc%cond(i,k,3)*rho(i)*18.02*AVGDR/0.928
   end do
!---------------------------------------------------------------------------
!
!  COMPUTE PARTICLE PARAMETERS FROM WHICH THE HETEROGENEOUS REACTION RATES
!  ARE DETERMINED; ASSUME SURFACE AREA FROM SAT IS LIMITED BY NAT AMOUNT
!
!---------------------------------------------------------------------------
   A1 = EXP(-4.5*SIGMAL)
   A2 = EXP(0.5*SIGMAL)
   A3 = EXP(2.0*SIGMAL)
   A4 = 1.33333333*PI*psc%adrop
   do i=1,IL
     RMODE = (VHET(i,1)*A1/A4)**0.33333333
     psc%rmean(i,k) = MAX(RMODE*A2, 1.e-12)
!    psc%aliq(i,k) = 3.0*A4*(RMODE**2)*A3
     psc%aliq(i,k) = strat_aerosol(i,k)
     RMODESAT = (VHET(i,2)*A1/A4)**0.33333333
     psc%asat(i,k) = 3.0*A4*(RMODESAT**2)*A3
     psc%rnat(i,k) = (VHET(i,3)/(1.33333333*PI*psc%anat))**0.33333333
     psc%rice(i,k) = (VHET(i,4)/(1.33333333*PI*psc%aice))**0.33333333
     SANAT = 4.*PI * psc%anat * psc%rnat(i,k)**2
     psc%asat(i,k) = MAX(psc%asat(i,k) - SANAT, 0.)
!    psc%aliq(i,k) = MAX(psc%aliq(i,k) - SANAT, 0.)
   end do
end do

if (present(psc_vmr_out)) then
   psc_vmr_out(:,:,:) = psc%cond(:,:,:)
end if

end subroutine strat_chem_get_psc


subroutine strat_chem_destroy_psc( psc )

implicit none

! Dummy arguments

type(psc_type),   intent(inout)   :: psc


deallocate( psc%cond, psc%tice, psc%wh2so4, psc%am, &
            psc%aw, psc%aliq, psc%rmean, &
            psc%asat, psc%rnat, psc%rice )

end subroutine strat_chem_destroy_psc


subroutine strat_chem_get_gamma(temp, press, rho, hcl, clono2, psc, k, gamma)
!-------------------------------------------------------------------------
!
! SUBROUTINE TO CALCULATE REACTION PROBABILITIES ON SULPHATE AEROSOL
! BASED ON JPL'03 RECOMMENDATION
!
!-------------------------------------------------------------------------
IMPLICIT NONE


! dummy arguments
REAL, dimension(:),   intent(in)  :: temp, press, rho, hcl, clono2
type(psc_type),       intent(in)  :: psc
integer,              intent(in)  :: k
REAL, dimension(:,:), intent(out) :: gamma

! local variables

integer :: i,il
REAL, dimension(size(temp,1)) :: AMH2SO4, XH2SO4, VISC, AACID, TEMP2, RTT
REAL :: T2,Z1,Z2,Z3,RHOX,AA,X,T1,T3,AKH,AKH2O,AKHYDR,DIFF,SCLONO2, &
        CCLONO2,GAMMAB1,HHCL,AKHCL,Q1,RQ,A1,FCLONO2,GAMMARXN,      &
        GAMMABHCL,GAMMAS,FHCL,GAMMASP,GAMMABHCLP,GAMMAB,GCLONO2,   &
        SHOCL,HHOCL,FHOCL,WT,AK0,AK1,AK2,T0,HCLONO2,   &
        AMHCL,AKHOCL,CHOCL

!  The parameterisations used here break down below about 185K, so the
!  temperature is here limited to 185K and above (TEMP2).

   il = size(temp,1)

!-------------------------------------------------------------------------
!
! CALCULATE H2SO4 MOLARITY (AMH2SO4), MOLE FRACTION (XH2SO4),
!  VISCOSITY (VISC) AND ACID ACTIVITY (AACID)
!  TABLE A2 OF SHIA ET AL. JGR, 106, 24,529-24,274, 2001.
!
!-------------------------------------------------------------------------
   TEMP2(:) = MAX(temp(:),185.)
   RTT(:) = SQRT(temp(:))

long_loop: &
   do i = 1,il
      T2 = TEMP2(I)**2
      Z1 = 0.12364 - 5.6E-7*T2
      Z2 = -0.02954 + 1.814E-7*T2
      Z3 = 2.343E-3 - 1.487E-6*TEMP2(I) - 1.324E-8*T2
      RHOX = 1.0 + Z1*psc%am(i,k) + Z2*psc%am(i,k)**1.5 + Z3*psc%am(i,k)**2
      AMH2SO4(I) = RHOX*psc%wh2so4(i,k)/9.8
      XH2SO4(I) = psc%wh2so4(i,k)/(psc%wh2so4(i,k) + (100.0 - psc%wh2so4(i,k))*98.0/18.0)
      AA = 169.5 + 5.18*psc%wh2so4(i,k) - 0.0825*psc%wh2so4(i,k)**2 + 3.27E-3*psc%wh2so4(i,k)**3
      T0 = 144.11 + 0.166*psc%wh2so4(i,k) - 0.015*psc%wh2so4(i,k)**2 + 2.18E-4*psc%wh2so4(i,k)**3
      X = TEMP2(I)**(-1.43)
      VISC(I) = AA*X*EXP(448.0/(TEMP2(I) - T0))
      T1 = 60.51 - 0.095*psc%wh2so4(i,k) + 0.0077*psc%wh2so4(i,k)**2 - 1.61E-5*psc%wh2so4(i,k)**3
      T2 =  (-805.89 + 253.05*psc%wh2so4(i,k)**0.076)/RTT(I)
      T3 =   (1.76 + 2.52E-4*psc%wh2so4(i,k)**2)*RTT(I)
      AACID(I) = EXP(T1 + T2 - T3)
!-------------------------------------------------------------------------
!
!  CALCULATE REACTION PROBABILITES FOR CLONO2 + H2O AND CLONO2 + HCL AND
!  HENRY'S LAW COEFFICIENTS.
!  TABLE A3 OF SHIA ET AL. JGR, 106, 24,529-24,274, 2001.
!
!  The following formulation for the water activity is from Shi et al.,
!  but the differences between their parameterisation and that calculated
!  using the actual model H2O is not large.
!
!      awx = exp((-69.775*xh2so4(il) - 18253.7*xh2so4(il)**2 +   &
!           31072.2*xh2so4(il)**3 - 25668.8*xh2so4(il)**4)*      &
!           (1.0/temp(il) - 26.9033/(temp(il)**2)))
!      AKHYDR = AWx*(AKH2O + AKH*AACID(IL))
!
!-------------------------------------------------------------------------
      AKH = 1.22E12*EXP(-6200.0/TEMP2(I))
      AKH2O = 1.95E10*EXP(-2800.0/TEMP2(I))
      AKHYDR = psc%aw(i,k)*(AKH2O + AKH*AACID(I))
      DIFF = 5.0E-8*TEMP2(I)/VISC(I)
      SCLONO2 = 0.306 + 24.0/TEMP2(I)
      HCLONO2 = 1.6E-6*EXP(4710.0/TEMP2(I) - SCLONO2*AMH2SO4(I))
      CCLONO2 = 1474.*TEMP2(I)**0.5
      GAMMAB1 = (4.0*HCLONO2*0.082*TEMP2(I)/CCLONO2) * (DIFF*AKHYDR)**0.5

      HHCL = (0.094 - 0.61*XH2SO4(I) + 1.2*XH2SO4(I)**2)* &
         EXP(-8.68 + (8515. - 10718.*XH2SO4(I)**0.7)/TEMP2(I))
      AMHCL = HHCL*hcl(i)*press(I)/PSTD_MKS
      AKHCL = 7.9E11*AACID(I)*DIFF*AMHCL
      Q1 = (DIFF/(AKHYDR + AKHCL))**0.5
      RQ = psc%rmean(i,k)/Q1
      A1 = RQ + 0.312*RQ**2
      FCLONO2 = A1/(3.0 + A1)
      GAMMARXN = FCLONO2*GAMMAB1*(1.0 + AKHCL/AKHYDR)**0.5
      GAMMABHCL = GAMMARXN*AKHCL/(AKHCL + AKHYDR)
      GAMMAS = 66.12* EXP(-1374./TEMP2(I))*HCLONO2*AMHCL
      IF( hcl(i) /= 0. ) THEN
       FHCL = 1.0/(1.0 + 0.612*(GAMMAS + GAMMABHCL)*clono2(i)/hcl(i))
      ELSE
       FHCL = 0.0
      ENDIF
      GAMMASP = FHCL*GAMMAS
      GAMMABHCLP = FHCL*GAMMABHCL
      GAMMAB = GAMMABHCLP + GAMMARXN*AKHYDR/(AKHCL + AKHYDR)
      GCLONO2 = 1.0/(1.0 + 1.0/(GAMMASP + GAMMAB))
      gamma(i,5) = GCLONO2*(GAMMASP + GAMMABHCLP) / (GAMMASP + GAMMAB)
      gamma(i,4) = GCLONO2 - gamma(i,5)

!-------------------------------------------------------------------------
!
!  CALCULATE REACTION PROBABILITES FOR HOCL + HCL AND HENRY'S LAW COEFFICIENTS.
!  TABLE A4 OF SHIA ET AL. JGR, 106, 24,529-24,274, 2001.
!
!-------------------------------------------------------------------------
      SHOCL = 0.0776 + 59.18/TEMP2(I)
      HHOCL = 1.91E-6*EXP(5862.4/TEMP2(I) - SHOCL*AMH2SO4(I))
      DIFF = 6.4E-8 *TEMP2(I)/VISC(I)
      AKHOCL = 1.25E9*AACID(I)*DIFF*AMHCL
      CHOCL = 2009.*RTT(I)
      Q1 = (DIFF/AKHOCL)**0.5
      RQ = psc%rmean(i,k)/Q1
      A1 = RQ + 0.312*RQ**2
      FHOCL = A1/(3.0 + A1)
      GAMMARXN = (FHOCL*4.0*HHOCL*0.082*TEMP2(I)/CHOCL) * (DIFF*AKHOCL)**0.5
      gamma(i,1) = 1.0/(1.0 + 1.0/(GAMMARXN*FHCL))

!-------------------------------------------------------------------------
!
!  CALCULATE REACTION PROBABILITES FOR N2O5 + H2O
!  ROBINSON ET AL. JGR, 102, 3583-3601, 1997.
!
!-------------------------------------------------------------------------
      WT = MIN( psc%wh2so4(i,k), 80. )
      AK0 = -25.5265 - 0.133188*WT + 0.00930846*WT**2 - 9.0194E-5*WT**3
      AK1 = 9283.76 + 115.345*WT - 5.19258*WT**2 + 0.0483464*WT**3
      AK2 = -851801. - 22191.2*WT + 766.916*WT**2 - 6.85427*WT**3
      gamma(i,3) = EXP(AK0 + AK1/TEMP2(I) + AK2/(TEMP2(I)**2))
   end do long_loop

!-------------------------------------------------------------------------
!
!  REACTION PROBABILITES FOR
!       N2O5 + HCL
!       HOBR + HCL
!       HOCL + HBR
!  NO RECOMMENDATION IN JPL '03, ASSUMED ZERO
!
!-------------------------------------------------------------------------
   gamma(:,2) = 0.
   gamma(:,6) = 0.
   gamma(:,7) = 0.

!-------------------------------------------------------------------------
!
!  REACTION PROBABILITES FOR HOBR + HBR
!  ABBATT, JGR, 100, 14009-14017, 1995.
!
!-------------------------------------------------------------------------
   gamma(:,8) = 0.25

!-------------------------------------------------------------------------
!
!  REACTION PROBABILITES FOR BRONO2 + H2O
!  USE JPL '03 RECOMMENDATION (HANSON PERS. COMM.)
!
!-------------------------------------------------------------------------
   gamma(:,9) = 1.0/(1.2422 + 1.0/(0.114 + EXP(29.24 - 0.396*psc%wh2so4(:,k))))

end subroutine strat_chem_get_gamma

subroutine strat_chem_get_hetrates( temp, hcl, hbr, h2o, rho, psc, gamma, k, tstep, rates )

implicit none
!------------------------------------------------------------------------
!
!  This subroutine computes the equivalent 2nd order reaction rates for
!  the heterogeneous reactions on aerosol, nat and ice.
!
!------------------------------------------------------------------------


! dummy arguments

INTEGER,              intent(in)  :: k
REAL, dimension(:),   intent(in)  :: temp, &   ! temperature (K)
                                     hcl, &    ! HCl volume mixing ratio (VMR)
                                     hbr, &    ! HBr VMR
                                     h2o, &    ! water vapor VMR
                                     rho       ! atmospheric density (molec/cm3)
REAL, dimension(:,:), intent(in)  :: gamma     ! reaction probabilities
type(psc_type),       intent(in)  :: psc       ! polar stratospheric clouds (PSCs)
real,                 intent(in) ::  tstep     ! timestep (sec)
REAL, dimension(:,:), intent(out) :: rates     ! heterogeneous reaction rate constants (molec^-1 cm^3 s^-1)

! local variables

integer, parameter :: nhet_data = 9
INTEGER :: i, ic, IL, NHET
REAL, dimension(size(temp)) :: CHEMC, &        ! chemical species number density (molec/cm3)
                               G2NAT, &        ! reaction probabilities on NAT
                               DELT, &         ! temperature excess over ice saturation (K)
                               SICE, &         ! 
                               RTT, &
                               VEL1, &
                               VEL2
REAL :: VCONST, ANUM, ADEN, MW2, area, afac1, adsorb_frac

real, dimension(nhet_data), parameter :: &
         AMW = (/ 52.45, 108.00, 108.00, 97.45, 97.45, 96.91, 52.45, 96.91, 141.91 /), &
!------------------------------------------------------------------------
!  AMW = MOLECULAR WEIGHT OF GAS PHASE SPECIES
!------------------------------------------------------------------------
         GNAT = (/0.1, 3.0E-3, 4.0E-4, 4.0E-3, 0.2, 0.0, 0.0, 0.0, 0.0 /), &
         GICE = (/0.2, 0.03, 0.02, 0.3, 0.3, 0.3, 0.03, 0.1, 0.3 /)
integer, parameter :: &
         HET_H2O=0, HET_HCL=1, HET_HBR=2
integer, dimension(nhet_data), parameter :: &
         INN = (/ HET_HCL,HET_HCL,HET_H2O,HET_H2O,HET_HCL,HET_HCL,HET_HBR,HET_HBR,HET_H2O /)
real, parameter :: small_conc = 1.e-20, &
                   mw_hcl = 36.46, &
                   mw_hbr = 80.91, &
                   mw_h2o = 18.01, &
                   adsorb_sites = 1.e15 ! adsorption sites per cm^2
!------------------------------------------------------------------------
!  INN = INDEX NUMBER OF LIQUID/SOLID PHASE SPECIES (0= H2O)
!-------------------------------------------------------------------------
!     REACTION 70 HOCL + HCL --> H2O + CL2 (HETEROGENEOUS)
!     REACTION 71 N2O5 + HCL --> HNO3 + CLNO2 (HETEROGENEOUS)
!     REACTION 72 N2O5+H2O --> 2HNO3 (HETEROGENEOUS)
!     REACTION 73 CLONO2+H2O --> HOCL+HNO3 (HETEROGENEOUS)
!     REACTION 74 CLONO2+HCL --> CL2+HNO3 (HETEROGENEOUS)
!     REACTION 75 HOBR + HCL --> BRCL + H2O (HETEROGENEOUS)
!     REACTION 76 HOCL + HBR --> BRCL + H2O (HETEROGENEOUS)
!     REACTION 77 HOBR + HBR --> 2BR + H2O (HETEROGENEOUS)
!     REACTION 78 BRONO2 + H2O --> HOBR + HNO3 (HETEROGENEOUS)
!     (THE FIRST MOLECULE ON THE LEFT HAND SIDE IS IN THE GAS PHASE,
!     THE SECOND MOLECULE IS IN THE LIQUID/SOLID PHASE)
!-------------------------------------------------------------------------
   IL = size(temp)
   NHET = size(gamma,2)

   RTT(:) = sqrt(temp(:))
   DELT(:) = temp(:) - psc%tice(:,k)
   SICE(:) = 10**(2668.70*(1.0/temp(:) - 1.0/psc%tice(:,k)))
   SICE(:) = MIN( SICE(:), 3. )

   do ic = 1,NHET
      VCONST = sqrt(8.0*8.3144E7/(PI*AMW(ic)))
      select case (ic)
         case(4)
            G2NAT(:) = EXP(-9.03 + 2.81*SICE(:))
         case(5)
            G2NAT(:) = 1.0/(4.3478 + 1.4241*EXP(0.518*DELT(:)))
         case default
            G2NAT(:) = GNAT(ic)
      end select
      select case (INN(ic))
         case(HET_H2O)
            CHEMC(:) = h2o(:)*rho(:)
            mw2 = mw_h2o
         case(HET_HCL)
            CHEMC(:) = hcl(:)*rho(:)
            mw2 = mw_hcl
         case(HET_HBR)
            CHEMC(:) = hbr(:)*rho(:)
            mw2 = mw_hbr
      end select
      VEL1(:) = VCONST * RTT(:)
      VEL2(:) = sqrt(8.*8.3144E7/(pi*mw2)) * RTT(:)
      rates(:,ic) =  0.

      select case (INN(ic))
         case(HET_H2O)

            do i=1,IL
               ADEN = CHEMC(i)
               if (ADEN > small_conc) then
!-------------------------------------------------------------------------
!    Reactions on NAT
!-------------------------------------------------------------------------
                  area = 4.*PI * psc%anat * psc%rnat(i,k)**2
                  ANUM = 0.25*VEL1(i)*G2NAT(i) * area
                  IF(ANUM > 0.) rates(i,ic) =  ANUM/ADEN
!-------------------------------------------------------------------------
!    Reactions on ICE
!------------------------------------------------------------------------
                  area = 4.*PI * psc%aice * psc%rice(i,k)**2
                  ANUM = 0.25*VEL1(i)*GICE(ic) * area
                  IF(ANUM > 0.) rates(i,ic) = rates(i,ic) + ANUM/ADEN
!-------------------------------------------------------------------------
!    Reactions on LIQUID AEROSOL
!    aliq is the liquid surface area. const is sqrt(8R/(pi*mw)) for the
!    gaseous phase species, with the mean molecular speed equal to
!        const*sqrt(temp)
!-------------------------------------------------------------------------
                  ANUM = 0.25*VEL1(i)*gamma(i,ic) * psc%aliq(i,k)
                  if (ANUM > 0.) rates(i,ic) = rates(i,ic) + ANUM / ADEN
               end if
            end do

         case(HET_HCL,HET_HBR)

            do i=1,IL
!-------------------------------------------------------------------------
!    Reactions on NAT
!-------------------------------------------------------------------------
               area = 4.*PI * psc%anat * psc%rnat(i,k)**2
               ANUM = 0.25*VEL1(i)*G2NAT(i)
               if (ANUM>0. .and. area>0.) then
                  afac1 = 0.25*VEL2(i)*tstep*area
!                 adsorb_frac = MIN(0.5*afac1, 1.)
                  adsorb_frac = 1. - (1./afac1)*(1.-exp(-afac1))
                  rates(i,ic) =  ANUM*adsorb_frac/adsorb_sites
               end if
!-------------------------------------------------------------------------
!    Reactions on ICE
!------------------------------------------------------------------------
               area = 4.*PI * psc%aice * psc%rice(i,k)**2
               ANUM = 0.25*VEL1(i)*GICE(ic)
               if(ANUM>0. .and. area>0.) then
                  afac1 = 0.25*VEL2(i)*tstep*area
!                 adsorb_frac = MIN(0.5*afac1, 1.)
                  adsorb_frac = 1. - (1./afac1)*(1.-exp(-afac1))
                  rates(i,ic) = rates(i,ic) + ANUM*adsorb_frac/adsorb_sites
               end if
!-------------------------------------------------------------------------
!    Reactions on LIQUID AEROSOL
!    aliq is the liquid surface area. const is sqrt(8R/(pi*mw)) for the
!    gaseous phase species, with the mean molecular speed equal to
!        const*sqrt(temp)
!-------------------------------------------------------------------------
               area = psc%aliq(i,k)
               ANUM = 0.25*VEL1(i)*gamma(i,ic)
               if(ANUM>0. .and. area>0.) then
                  afac1 = 0.25*VEL2(i)*tstep*area
!                 adsorb_frac = MIN(0.5*afac1, 1.)
                  adsorb_frac = 1. - (1./afac1)*(1.-exp(-afac1))
                  rates(i,ic) = rates(i,ic) + ANUM*adsorb_frac/adsorb_sites
               end if
            end do

      end select

   end do

end subroutine strat_chem_get_hetrates


subroutine DENSITY(WF,T,DENS)
implicit none
!
!    Density of ternary solution in g cm-3
!

! dummy arguments
REAL, intent(in)  :: WF(:,:),T(:)
REAL, intent(out) :: DENS(:)

! local variables
INTEGER :: I
REAL :: W,WH,T2,V1,A1,A2,VS,VN,VMCAL

real, parameter :: &
       X(22) = (/ 2.393284E-02,-4.359335E-05,7.961181E-08,0.0,-0.198716351, &
                  1.39564574E-03,-2.020633E-06,0.51684706,-3.0539E-03,      &
                  4.505475E-06,-0.30119511,1.840408E-03,-2.7221253742E-06,  &
                 -0.11331674116,8.47763E-04,-1.22336185E-06,0.3455282,      &
                 -2.2111E-03,3.503768245E-06,-0.2315332,1.60074E-03,        &
                 -2.5827835E-06 /), &
       AMR(3) = (/ 0.05550622,0.01019576,0.01586899 /)

   DO I = 1,SIZE(T)
      W = WF(I,1) + WF(I,2)
      WH = 1.0 - W
      T2 = T(I)**2
      V1 = X(1) + X(2)*T(I) + X(3)*T2 + X(4)*T2*T(I)
      A1 = X(8) + X(9)*T(I) + X(10)*T2
      A2 = X(11) + X(12)*T(I) + X(13)*T2
      VS = X(5) + X(6)*T(I) + X(7)*T2 + A1*W + A2*W**2
      A1 = X(17) + X(18)*T(I) + X(19)*T2
      A2 = X(20) + X(21)*T(I) + X(22)*T2
      VN = X(14) + X(15)*T(I) + X(16)*T2 + A1*W + A2*W**2
      VMCAL = WH*V1*AMR(1) + VS*WF(I,1)*AMR(2) + VN*WF(I,2)*AMR(3)
      DENS(I) = 1.0E-3/VMCAL
   END DO

end subroutine DENSITY


subroutine strat_chem_psc_sediment( psc, pfull, dt, dpsc )      

implicit none
!------------------------------------------------------------------------
!
!  This subroutine calculates sedimentation rates of Type I and Type II
!  particles and vertically advects model NAT and ice
!
!------------------------------------------------------------------------


! dummy arguments
!
!  CALCULATES SEDIMENTATION RATES OF TYPE I AND TYPE 2 PARTICLES               
!  AND VERTICALLY ADVECTS MODEL NAT AND ICE                                    
!
REAL, dimension(:,:,:),   intent(in)  :: pfull
REAL, dimension(:,:,:,:), intent(in)  :: psc
REAL,                     intent(in)  :: dt
REAL, dimension(:,:,:,:), intent(out) :: dpsc

! local variables

real, dimension(SIZE(pfull,3)) :: ANAT, AICE, SNATS, SICES, F1, F2, ANAT2, AICE2
real :: PNAT,PICE,PNAT2,PICE2
real :: ANATMAX,AICEMAX
integer :: i, j, k, il, jl, kl
real :: temp, pfrac, dz, const, d1, d2, FIXNAT, FIXICE
!                                                                              
!  V1 = SEDIMENTATION VELOCITY (M/S) OF ICE PARTICLES
!  V2 = SEDIMENTATION VELOCITY OF NAT PARTICLES
!  R1, R2 = ASSUMED RADII
!  AM1, AM2 = MOLECULAR WEIGHTS
!  RHO1, RHO2 = DENSITIES OF THE PSCs (G/CM3)
!                                                                              
real, parameter :: V1=1.27E-2, V2=1.39E-4
real, parameter :: R1=7.0E-6, R2=0.5E-6
real, parameter :: AM1=18.0, AM2=117.0
real, parameter :: RHO1=0.928, RHO2=1.35
real, parameter :: RATIO = AM1*RHO2/(AM2*RHO1)*(R2/R1)**3

il = SIZE(pfull,1)
jl = SIZE(pfull,2)
kl = SIZE(pfull,3)

!                                                                              
!  CALCULATE FRACTION OF NAT PARTICLES USED AS TYPE 2 CORES (F1)               
!  AND FRACTION OF NAT PARTICLES THAT REMAIN AS TYPE 1 CORES (F2)              
!  DETERMINE MAXIMUM NAT AND ICE TO APPLY LIMITERS TO ADVECTED AMOUNTS
!                                                                              
Lat_loop : &
   DO j = 1,jl 
Lon_loop : &
   DO i = 1,il 
      ANAT(:) = psc(i,j,:,2)
      AICE(:) = psc(i,j,:,3)
      where(AICE(:) < 1.0E-18)
         AICE(:) = 0.
      end where
      where(ANAT(:) < 1.0E-18)
         ANAT(:) = 0.
         F1(:) = 0.
         F2(:) = 0.
      elsewhere
         F1(:) = AICE(:)*RATIO/ANAT(:)
         F1(:) = MIN(1.,F1(:))
         F2(:) = 1.0 - F1(:)
      end where
      ANATMAX = maxval(ANAT(:))
      AICEMAX = maxval(AICE(:))
!
! VERTICALLY ADVECT NAT AND ICE. NOTE THAT PART OF NAT IS ADVECTED
! AT TYPE 2 RATE AND THE REMAINDER AT TYPE 1 RATE. CALCULATE DESCENT IN
!  1 TIMESTEP; USE APPROXIMATE VERTICAL DISPLACEMENT BETWEEN LAYERS
!
      TEMP = 195.
      PNAT = 0.
      PICE = 0.
      DO k = 2,kl
         PFRAC = pfull(i,j,k)/pfull(i,j,k-1)
         DZ = 29.26*TEMP*LOG(PFRAC)
         CONST = dt/DZ                                              
         D1 = ANAT(k) - ANAT(k-1)
         D2 = AICE(k) - AICE(k-1)         
         SNATS(k) = -CONST*D1*(V1*F1(k) + V2*F2(k))
         SICES(k) = -CONST*D2*V1
         PNAT = PNAT + pfull(i,j,k)*ANAT(k)
         PICE = PICE + pfull(i,j,k)*AICE(k)
      END DO
!
!  set sedimented nat and ice to zero at top and bottom
!
      SNATS(1) = 0.0
      SICES(1) = 0.0 
      SNATS(kl) = 0.0
      SICES(kl) = 0.0
      ANAT2(:) = ANAT(:) + SNATS(:)
      AICE2(:) = AICE(:) + SICES(:)
!
!  APPLY LIMITERS TO NEW NAT AND ICE
!
      ANAT2(:) = MAX( MIN(ANAT2(:),ANATMAX), 0. )
      AICE2(:) = MAX( MIN(AICE2(:),AICEMAX), 0. )
!
! APPLY MASS FIXER
!
      PNAT2 = 0.0
      PICE2 = 0.0
      DO k = 1,kl
         PNAT2 = PNAT2 + pfull(i,j,k)*ANAT2(k)
         PICE2 = PICE2 + pfull(i,j,k)*AICE2(k)
      END DO
      IF(PNAT2 == 0.) THEN 
         FIXNAT = 1.0
      ELSE 
         FIXNAT = PNAT/PNAT2
      ENDIF
      IF(PICE2 == 0.) THEN
         FIXICE = 1.0
      ELSE
         FIXICE = PICE/PICE2
      ENDIF
      ANAT2(:) = ANAT2(:)*FIXNAT 
      AICE2(:) = AICE2(:)*FIXICE 
!
!  ADJUST NOY AND H2O TENDENCY FIELDS
!
!     ANOY(j,:) = ANOY(j,:) + (ANAT2(:) - ANAT(:))/dt 
!     AHNO3(j,:) = AHNO3(j,:) + (ANAT2(:) - ANAT(:))/dt 
!     AH2O(j,:) = AH2O(j,:) + (AICE2(:) - AICE(:))/dt 

!  ADJUST PSC FIELDS
      dpsc(i,j,:,1) = 0.
      dpsc(i,j,:,2) = ANAT2(:) - ANAT(:)
      dpsc(i,j,:,3) = AICE2(:) - AICE(:)


   end do Lon_loop
   end do Lat_loop

end subroutine strat_chem_psc_sediment


! <SUBROUTINE NAME="strat_chem_get_extra_h2o">
!   <OVERVIEW>
!     Set minimum allowed stratospheric water
!   </OVERVIEW>
!   <DESCRIPTION>
!     Constrain stratospheric H2O to be greater than or equal to 2*CH4
!   </DESCRIPTION>
!   <TEMPLATE>
!     call strat_chem_get_extra_h2o( h2o, age, ch4, Time, extra_h2o )
!   </TEMPLATE>
!   <IN NAME="h2o" TYPE="real" DIM="(:,:)">
!     Total H2O volume mixing ratio (mol/mol)
!   </IN>
!   <IN NAME="age" TYPE="real" DIM="(:,:)">
!     Age-of-air tracer (yrs)
!   </IN>
!   <IN NAME="ch4" TYPE="real" DIM="(:,:)">
!     Methane volume mixing ratio (mol/mol)
!   </IN>
!   <IN NAME="age" TYPE="time_type">
!     Current model time
!   </IN>
!   <OUT NAME="extra_h2o" TYPE="real" DIM="(:,:)">
!     Additional stratospheric H2O VMR (mol/mol)
!   </OUT>
subroutine strat_chem_get_extra_h2o( h2o, age, ch4, Time, extra_h2o )

implicit none

! Dummy arguments

real, dimension(:,:), intent(in)  :: h2o, age, ch4
type(time_type),      intent(in)  :: Time
real, dimension(:,:), intent(out) :: extra_h2o

! Local variables

integer :: i, k, il, kl, index1, index2
real :: frac, ch4_trop, min_h2o
type(time_type) :: time_trop
character(len=256) :: err_msg

il = size(h2o,1)
kl = size(h2o,2)

do k = 1,kl
do i=1,il

   if (fixed_ch4_lbc_time) then
      time_trop = ch4_entry
   else
      time_trop = increment_time( Time, -NINT(age(i,k)/tfact), 0)
   end if
   call time_interp( time_trop, ch4_time(:), frac, index1, index2, err_msg=err_msg )
   if(err_msg /= '') then
      call error_mesg('strat_chem_get_extra_h2o', trim(err_msg) , FATAL)
   endif 
   ch4_trop = ch4_value(index1) + frac*(ch4_value(index2)-ch4_value(index1))
   min_h2o = 2. * MAX( 0., ch4_trop - ch4(i,k) )
   if (age(i,k) > 0.1) then
      extra_h2o(i,k) = MAX( 0., min_h2o - h2o(i,k) )
   else
      extra_h2o(i,k) = 0.
   end if

end do
end do

end subroutine strat_chem_get_extra_h2o



! <SUBROUTINE NAME="strat_chem_extra_h2o_init">
!   <OVERVIEW>
!     Initialize minimum stratospheric water calculation
!   </OVERVIEW>
!   <DESCRIPTION>
!     Initialize constraint of stratospheric H2O to be greater than or equal to 2*CH4
!   </DESCRIPTION>
!   <TEMPLATE>
!     call strat_chem_extra_h2o_init()
!   </TEMPLATE>
!   <IN NAME="ch4_filename" TYPE="character">
!     Methane timeseries filename
!   </IN>
!   <IN NAME="ch4_scale_factor" TYPE="real">
!     Methane timeseries scale factor to convert to VMR (mol/mol)
!   </IN>
subroutine strat_chem_extra_h2o_init( ch4_filename, ch4_scale_factor, &
                                      fixed_ch4_lbc_time_in, ch4_entry_in )

implicit none

! Dummy arguments

character(len=*), intent(in) :: ch4_filename
real, intent(in)             :: ch4_scale_factor
logical, intent(in)          :: fixed_ch4_lbc_time_in
type(time_type), intent(in)  :: ch4_entry_in

! Local variables
character(len=64) :: filename
integer :: flb, series_length, n, year, diy
real :: extra_seconds
real, dimension(:), allocatable :: input_time
type(time_type) :: Year_t

fixed_ch4_lbc_time = fixed_ch4_lbc_time_in
ch4_entry = ch4_entry_in


filename = 'INPUT/' // trim(ch4_filename)
if( file_exist(filename) ) then
   flb = open_namelist_file( filename )
   read(flb, FMT='(i12)') series_length
   allocate( ch4_value(series_length), &
             input_time(series_length), &
             ch4_time(series_length) )
   do n = 1,series_length
      read (flb, FMT = '(2f12.4)') input_time(n), ch4_value(n)
   end do
   ch4_value(:) = ch4_value(:) * ch4_scale_factor
   call close_file( flb )
!---------------------------------------------------------------------
!    convert the time stamps of the series to time_type variables.     
!---------------------------------------------------------------------
   do n=1,series_length
      year = INT(input_time(n))
      Year_t = set_date(year,1,1,0,0,0)
      diy = days_in_year(Year_t)
      extra_seconds = (input_time(n) - year)*diy*SECONDS_PER_DAY 
      ch4_time(n) = Year_t + set_time(NINT(extra_seconds), 0)
   end do
   deallocate(input_time)
else
   call error_mesg ('strat_chem_extra_h2o_init', &
                    'Failed to find input file '//trim(filename), FATAL)
end if

end subroutine strat_chem_extra_h2o_init


end module strat_chem_utilities_mod

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The dynamic psi-equation  \label{sec:genericeq}
!
! !INTERFACE:
   subroutine genericeq(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)

! !DESCRIPTION:
! This model has been formulated by \cite{UmlaufBurchard2003},
! who introduced a `generic' variable,
! \begin{equation}
!   \label{psi_l}
!   \psi = (c_\mu^0)^p k^m l^n
!   \comma
! \end{equation}
! where $k$ is the turbulent kinetic energy computed from \eq{tkeA} and
! $l$ is the dissipative length-scale defined in \eq{epsilon}.
! For appropriate choices of the exponents $p$, $m$, and $n$, the variable
! $\psi$ can be directly identified with the classic length-scale determining
! variables like the rate of dissipation, $\epsilon$, or the product
! $kl$ used by \cite{MellorYamada82} (see \sect{sec:lengthscaleeq}
! and \sect{sec:dissipationeq}).
!  Some examples are compiled in \tab{tab:psi}.
! \begin{table}[ht]
!   \begin{center}
!     \begin{tabular}{clccc}
!       $\psi$     & two-equation model by:      &  $p$   & $m$           & $n$    \\[2mm]  \hline
!       $\omega$   & \cite{Wilcox88}             &  $-1$ & $\frac{1}{2}$  & $-1$   \\[1mm]
!       $k l$      & \cite{MellorYamada82}       &  $0$  & $1$            & $1$    \\[1mm]
!       $\epsilon$ & \cite{Rodi87}               &  $3$  & $\frac{3}{2}$  & $-1$   \\[1mm]
!       $k \tau$   & \cite{ZeiermanWolfshtein86} &  $-3$ & $\frac{1}{2}$  & $1$    \\
!     \end{tabular}
!    \caption{\label{tab:psi}Exponents $p$, $n$, $m$ defined in  \eq{psi_l}, and
!     their relation to the variable of the second equation in some well-known
!     two-equation models.}
!  \end{center}
!\end{table}
!
! The transport equation for $\psi$ can written as
! \begin{equation}
!   \label{generic}
!   \dot{\psi} = {\cal D}_\psi
!   + \frac{\psi}{k} (  c_{\psi_1} P + c_{\psi_3} G
!    - c_{\psi 2} \epsilon )
!   \comma
! \end{equation}
! where $\dot{\psi}$ denotes the material derivative of $\psi$,
! see \cite{UmlaufBurchard2003}.
! The production terms $P$ and $G$ follow from \eq{PandG}.
! ${\cal D}_\psi$ represents the sum of the viscous and turbulent
! transport terms. The rate of dissipation can computed by solving
! \eq{psi_l} for $l$ and inserting the result into \eq{epsilon}.
!
! For horizontally homogeneous flows, the transport terms ${\cal D}_\psi$
! appearing in \eq{generic} are expressed by a simple
! gradient formulation,
! \begin{equation}
!   \label{diffusionGeneric}
!   {\cal D}_\psi = \frstder{z}
!   \left( \dfrac{\nu_t}{\sigma_\psi} \partder{\psi}{z} \right)
!  \point
! \end{equation}
!
! For appropriate choices of the parameters, most of the classic transport
! equations can be directly recovered from the generic equation \eq{generic}.
! An example is the transport equation for the inverse turbulent time scale,
! $\omega \propto \epsilon / k$, which has been formulated by \cite{Wilcox88}
! and extended to buoyancy affected flows by \cite{Umlaufetal2003}. The precise
! definition of $\omega$ follows from \tab{tab:psi}, and its transport
! equation can be written as
! \begin{equation}
!   \label{KW}
!   \dot{\omega}
!   =
!   {\cal D}_\omega
!   + \frac{\omega}{k} (  c_{\omega_1} P + c_{\omega_3} G
!   - c_{\omega 2} \epsilon )
!   \comma
! \end{equation}
! which is clearly a special case of \eq{generic}. Model constants for this
! and other traditional models are given in \tab{tab:constants}.
! \begin{table}[ht]
!   \begin{center}
!     \begin{tabular}{lccccccc}
!       & $c_\mu^0$
!       & $\sigma_k^\psi$
!       & $\sigma_\psi$
!       & $c_{\psi 1}$
!       & $c_{\psi 2}$
!       & $c_{\psi 3}$  \\[2mm] \hline
!       $k$-$\epsilon$,  \cite{Rodi87}             :
!       & $0.5477$ & $1.0$  &  $1.3$  & $1.44$  & $1.92$  & (see eq.\ (\ref{Ri_st})) \\[1mm]
!       $k$-$kl$,       \cite{MellorYamada82}      :
!       & $0.5544$ & $1.96$ &  $1.96$ & $0.9$   & $0.5$   & $0.9$ &    \\[1mm]
!       $k$-$\omega$,   \cite{Wilcox88}            :
!       & $0.5477$ & $2$    &  $2$    & $0.555$ & $0.833$ & (see eq.\ (\ref{Ri_st})) \\[1mm]
!       $k$-$\tau$     \cite{ZeiermanWolfshtein86}:
!        & $0.5477$ & $1.46$ &  $10.8$ & $0.173$ & $0.225$ & (---)      \\
!     \end{tabular}
!     \caption{\label{tab:constants} Model constants of some standard models,
! converted to the notation used here. The Schmidt-numbers for the model of
!    \cite{MellorYamada82} are valid only in the logarithmic boundary-layer,
!    because the diffusion models \eq{diffusionMYTKE} and \eq{diffusionMYlength}
!    are slightly different from \eq{diffusionTKE} and \eq{diffusionGeneric}.
!    There is no indication that one class of  diffusion models is superior.}
!   \end{center}
! \end{table}
! Apart from having to code only one equation to recover all of the
! traditional models, the main advantage of the generic equation is its
! flexibility. After choosing meaningful values for physically relevant
! parameters like  the von K{\'a}rm{\'a}n constant, $\kappa$, the temporal
! decay rate for homogeneous turbulence, $d$, some parameters related to
! breaking surface waves, etc, a two-equation model can be generated,
! which has exactly the required properties. This is discussed in
! great detail in  \cite{UmlaufBurchard2003}. All algorithms have been
! implemented in GOTM and are described in \sect{sec:generate}.
!
! !USES:
   use turbulence, only: P,B,num
   use turbulence, only: tke,tkeo,k_min,eps,eps_min,L
   use turbulence, only: cpsi1,cpsi2,cpsi3plus,cpsi3minus,sig_psi
   use turbulence, only: gen_m,gen_n,gen_p
   use turbulence, only: cm0,cde,galp,length_lim
   use turbulence, only: psi_bc, psi_ubc, psi_lbc, ubc_type, lbc_type
   use util,       only: Dirichlet,Neumann

   IMPLICIT NONE

! !INPUT PARAMETERS:

!  number of vertical layers
   integer,  intent(in)                :: nlev

!  time step (s)
   REALTYPE, intent(in)                :: dt

!  surface and bottom
!  friction velocity (m/s)
   REALTYPE, intent(in)                :: u_taus,u_taub

!  surface and bottom
!  roughness length (m)
   REALTYPE, intent(in)                :: z0s,z0b

!  layer thickness (m)
   REALTYPE, intent(in)                :: h(0:nlev)

!  square of shear and buoyancy
!  frequency (1/s^2)
   REALTYPE, intent(in)                :: NN(0:nlev),SS(0:nlev)
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf and Hans Burchard

!  $Log: genericeq.F90,v $
!  Revision 20.0  2013/12/14 00:13:40  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:53  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.9  2005-12-28 08:51:10  hb
!  Bug fix: Now tkeo is used for reconstruction of psi
!
!  Revision 1.8  2005-11-15 11:35:02  lars
!  documentation finish for print
!
!  Revision 1.7  2005/11/03 20:53:37  hb
!  Patankar trick reverted to older versions for
!  stabilising 3D computations
!
!  Revision 1.6  2005/08/11 13:11:50  lars
!  Added explicit loops for diffusivities for 3-D z-level support.
!  Thanks to Vicente Fernandez.
!
!  Revision 1.5  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.4  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.3  2003/03/10 09:02:05  gotm
!  Added new Generic Turbulence Model +
!  improved documentation and cleaned up code
!
!
!EOP
!------------------------------------------------------------------------
!
! !LOCAL VARIABLES:
   REALTYPE                  :: DiffPsiup,DiffPsidw,pos_bc
   REALTYPE                  :: prod,buoyan,diss
   REALTYPE                  :: prod_pos,prod_neg,buoyan_pos,buoyan_neg
   REALTYPE                  :: ki,epslim,PsiOverTke,NN_pos
   REALTYPE                  :: cnpar=_ONE_
   REALTYPE                  :: exp1,exp2,exp3
   REALTYPE                  :: psi(0:nlev)
   REALTYPE                  :: avh(0:nlev)
   REALTYPE                  :: Lsour(0:nlev),Qsour(0:nlev)
   REALTYPE                  :: cpsi3

   integer                   :: i
!
!------------------------------------------------------------------------
!BOC

!  compute some parameters
   exp1 = 3.0 + gen_p/gen_n
   exp2 = 1.5 + gen_m/gen_n
   exp3 =       - 1.0/gen_n

!  re-construct psi at "old" timestep
   do i=0,nlev
      psi(i) = cm0**gen_p * tkeo(i)**gen_m * L(i)**gen_n
   end do

!  compute RHS
   do i=1,nlev-1

!     compute psi diffusivity
      avh(i) = num(i)/sig_psi

!     compute production terms in psi-equation
      if (B(i).gt.0) then
         cpsi3=cpsi3plus
      else
         cpsi3=cpsi3minus
      end if

!     compute production terms in psi-equation
      PsiOverTke  = psi(i)/tkeo(i)
      prod        = cpsi1*PsiOverTke*P(i)
      buoyan      = cpsi3*PsiOverTke*B(i)
      diss        = cpsi2*PsiOverTke*eps(i)

      if (prod+buoyan.gt.0) then
         Qsour(i)  = prod+buoyan
         Lsour(i) = -diss/psi(i)
      else
         Qsour(i)  = prod
         Lsour(i) = -(diss-buoyan)/psi(i)
      end if

   end do

!  TKE and position for upper BC
   if (psi_ubc.eq.Neumann) then
!     tke at center "nlev"
      ki = tke(nlev-1)

!     flux at center "nlev"
      pos_bc = 0.5*h(nlev)
   else
!     tke at face "nlev-1"
      ki = tke(nlev-1)

!     value at face "nlev-1"
      pos_bc = h(nlev)
   end if

!  obtain BC for upper boundary of type "ubc_type"
   DiffPsiup  = psi_bc(psi_ubc,ubc_type,pos_bc,ki,z0s,u_taus)


!  TKE and position for lower BC
   if (psi_lbc.eq.Neumann) then
!     tke at center "1"
      ki = tke(1)

!     flux at center "1"
      pos_bc = 0.5*h(1)
   else
!     tke at face "1"
      ki = tke(1)

!     value at face "1"
      pos_bc = h(1)
   end if

!  obtain BC for lower boundary of type "lbc_type"
   DiffPsidw  = psi_bc(psi_lbc,lbc_type,pos_bc,ki,z0b,u_taub)


!  do diffusion step
   call diff_face(nlev,dt,cnpar,h,psi_ubc,psi_lbc,                          &
                  DiffPsiup,DiffPsidw,avh,Lsour,Qsour,psi)


!  fill top and bottom value with something nice
!  (only for output)
   psi(nlev)  = psi_bc(Dirichlet,ubc_type,z0s,tke(nlev),z0s,u_taus)
   psi(0   )  = psi_bc(Dirichlet,lbc_type,z0b,tke(0   ),z0b,u_taub)

   do i=0,nlev
!     recover dissipation rate from k and psi
      eps(i)=cm0**exp1 * tke(i)**exp2 * psi(i)**exp3

!     clip at eps_min
      eps(i) = max(eps(i),eps_min)

!     compute dissipative scale
      L(i)=cde*sqrt(tke(i)*tke(i)*tke(i))/eps(i)
   enddo

!  limit dissipation rate under stable stratification,
!  see Galperin et al. (1988)
   if (length_lim) then
      do i=0,nlev

 !       look for N^2 > 0
         NN_pos = 0.5*( NN(i) + abs( NN(i) ) )

!        compute limit
         epslim = cde/sqrt(2.)/galp*tke(i)*sqrt(NN_pos)

!        clip at limit
         eps(i) = max(eps(i),epslim)

!        re-compute dissipative scale
         L(i) = cde*sqrt(tke(i)*tke(i)*tke(i))/eps(i)

      end do
   endif

   return
   end subroutine genericeq
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

!----------------------------------------------------------------
! <CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Niki Zadeh 
! </CONTACT>
! 
! <REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> William Cooke
! </REVIEWER>
!
! <OVERVIEW>
! g_tracer_utils module consists of core utility subroutines 
! to be used by all generic tracer modules.
! These include the lowest level functions for adding, 
! allocating memory, and record keeping of individual 
! generic tracers irrespective of their physical/chemical nature.
! </OVERVIEW>
!----------------------------------------------------------------


#include <fms_platform.h>
module g_tracer_utils

  use coupler_types_mod, only: coupler_2d_bc_type, ind_flux, ind_deltap, ind_kw
  use coupler_types_mod, only: ind_alpha, ind_csurf, ind_sc_no
  use FMS_coupler_util,  only: extract_coupler_values, set_coupler_values
  use atmos_ocean_fluxes_mod, only: aof_set_coupler_flux
  use mpp_mod,           only: mpp_error, NOTE, WARNING, FATAL
  use mpp_mod,           only: mpp_pe, mpp_root_pe
  use time_manager_mod,  only: time_type
  use diag_manager_mod,  only: register_diag_field, send_data 


  use field_manager_mod, only: fm_string_len, fm_path_name_len, fm_new_list, fm_change_list, fm_get_value

  use fms_mod,           only: stdout


  implicit none ; private
!-----------------------------------------------------------------------
  character(len=128) :: version = '$Id: generic_tracer_utils.F90,v 20.0 2013/12/14 00:18:12 fms Exp $'
  character(len=128) :: tag = '$Name: tikal $'
!-----------------------------------------------------------------------

  character(len=48), parameter :: mod_name = 'g_tracer_utils'

  ! <DESCRIPTION>
  ! Public types:
  !
  ! Each generic tracer node is an instant of a FORTRAN type with the following member variables.
  ! These member fields are supposed to uniquely define an individual tracer.
  ! One such type shall be instantiated for EACH individual tracer.
  ! <PRE>
  !type g_tracer_type
  !   !A pointer to the next node in the list for the current "linked-list implementation".
  !   type(g_tracer_type), pointer :: next => NULL()  
  !         
  !   !A unique index (for the possible future "array implementation")
  !   integer :: index              
  !
  !   ! Tracer name, descriptive name, package that instantiates it 
  !   character(len=64) :: name, longname, package_name
  ! 
  !   ! Units of measurement for its field and its flux
  !   character(len=64) :: units, flux_units
  !
  !   ! Tracer concentration field in space (and time)
  !   ! MOM keeps the field at 3 time levels, hence 4D.
  !   real, _ALLOCATABLE, dimension(:,:,:,:):: field  _NULL
  !
  !   ! Surface flux, surface gas flux, deltap and kw
  !   real, _ALLOCATABLE, dimension(:,:)    :: stf    _NULL
  ! 
  !   real, _ALLOCATABLE, dimension(:,:)    :: deltap    _NULL
  ! 
  !   real, _ALLOCATABLE, dimension(:,:)    :: kw    _NULL
  ! 
  !   ! Bottom  flux
  !   real, _ALLOCATABLE, dimension(:,:)    :: btf    _NULL
  ! 
  !   ! Bottom  reservoir flux
  !   real, _ALLOCATABLE, dimension(:,:)    :: btm_reservoir    _NULL 
  !
  !   ! Tracer concentration in river runoff
  !   real, _ALLOCATABLE, dimension(:,:)    :: trunoff _NULL 
  !
  !   ! Runoff flux of tracer
  !   real, _ALLOCATABLE, dimension(:,:)    :: runoff_tracer_flux _NULL 
  !
  !   ! Wet deposition flux of tracer
  !   real, _ALLOCATABLE, dimension(:,:)    :: wetdep _NULL 
  !
  !   ! Dry deposition flux of tracer
  !   real, _ALLOCATABLE, dimension(:,:)    :: drydep _NULL 
  !
  !   ! Tracer saturation, alpha, and schmidt number 
  !   real, _ALLOCATABLE, dimension(:,:)    :: csurf  _NULL 
  !
  !   real, _ALLOCATABLE, dimension(:,:)    :: alpha  _NULL 
  !
  !   real, _ALLOCATABLE, dimension(:,:)    :: sc_no  _NULL 
  !
  !   ! An 3D field for vertical movement, esp. for zooplankton, ... 
  !   real, _ALLOCATABLE, dimension(:,:,:)  :: vmove  _NULL
  !   ! An 3D field for random vertical movement, esp. for zooplankton, ... 
  !   real, _ALLOCATABLE, dimension(:,:,:)  :: vdiff  _NULL

  !   ! An 3D field for implicit vertical diffusion
  !   real, _ALLOCATABLE, dimension(:,:,:)  :: vdiffuse_impl  _NULL

  !   ! An auxiliary 3D field for keeping model dependent change tendencies, ... 
  !   real, _ALLOCATABLE, dimension(:,:,:)  :: tendency  _NULL
  !
  !   ! IDs for using diag_manager tools
  !   integer :: diag_id_field=-1, diag_id_stf=-1, diag_id_stf_gas=-1, diag_id_deltap=-1, diag_id_kw=-1, diag_id_trunoff=-1
  !   integer :: diag_id_alpha=-1, diag_id_csurf=-1, diag_id_sc_no=-1, diag_id_aux=-1
  !
  !  ! Tracer Initial concentration if constant everywhere
  !   real    :: const_init_value = 0.0
  !
  !   ! Tracer Sinking rate
  !   real    :: sink_rate   = 0.0
  !
  !   ! Logical switches
  !   logical :: prog        = .false. !Is this a prognostic (.true.) or diagnostic (.false.) tracer?
  !   logical :: move_vertical = .false. ! Enable allocation of fields for active vertical movement
  !   logical :: diff_vertical = .false. ! Enable allocation of fields for random active vertical movement
  !   logical :: flux_gas    = .false. !Is there a gas flux to atmosphere?
  !   logical :: flux_runoff = .false. !Is there a river flux?
  !   logical :: flux_wetdep = .false. !Is there a wet deposition?
  !   logical :: flux_drydep = .false. !Is there a dry deposition?
  !   logical :: flux_bottom = .false. !Is there a flux through bottom?
  !
  !   ! Flux identifiers to be set by aof_set_coupler_flux()
  !   integer :: flux_gas_ind    = -1  
  !   integer :: flux_runoff_ind = -1
  !   integer :: flux_wetdep_ind = -1
  !   integer :: flux_drydep_ind = -1
  !
  !end type g_tracer_type
  !
  ! </PRE>
  ! 
  !
  ! </DESCRIPTION>

  type g_tracer_type
     !A pointer to the next node in the list for the current "linked-list implementation".
     type(g_tracer_type), pointer :: next => NULL()  

     !A unique index (for the possible future "array implementation")
     integer :: index              

     ! Tracer name, descriptive name, package that instantiates it 
     character(len=fm_string_len) :: name, longname, alias, package_name

     ! Tracer molecular wt
     real :: flux_gas_molwt

     ! Tracer flux names recognized by component models (OCN, LND, ICE, ATM) 
     character(len=fm_string_len) :: flux_gas_name, flux_gas_type, flux_runoff_name, flux_wetdep_name, flux_drydep_name
     real, _ALLOCATABLE, dimension(:) :: flux_param, flux_gas_param

     ! IN and OUT (restart) files
     character(len=fm_string_len) :: ice_restart_file, ocean_restart_file
     character(len=fm_string_len) :: flux_gas_restart_file 
     ! Units of measurement for its field and its flux
     character(len=fm_string_len) :: units, flux_units

     ! Tracer concentration field in space (and time)
     ! MOM keeps the prognostic tracer fields at 3 time levels, hence 4D.
     real, pointer, dimension(:,:,:,:):: field  => NULL()
     !The following pointer is intended to point to prognostic tracer field in MOM. Do not allocate!
     real, pointer,      dimension(:,:,:,:):: field4d_ptr => NULL()
     !The following pointer is intended to point to diagnostic tracer field in MOM. Do not allocate!
     real, pointer,      dimension(:,:,:)  :: field3d_ptr => NULL() 
     ! Define a 3-d field pointer so as to retain the lower
     ! and upper bounds for the 3-d version of g_tracer_get_pointer
     ! for the field option
     real, pointer,      dimension(:,:,:)  :: field_3d => NULL()

     ! Surface flux, surface flux of gas, deltap and kw
     real, _ALLOCATABLE, dimension(:,:)    :: stf    _NULL

     real, _ALLOCATABLE, dimension(:,:)    :: stf_gas    _NULL

     real, _ALLOCATABLE, dimension(:,:)    :: deltap    _NULL

     real, _ALLOCATABLE, dimension(:,:)    :: kw    _NULL

     ! Bottom  flux
     real, _ALLOCATABLE, dimension(:,:)    :: btf    _NULL

     ! Bottom  reservoir flux
     real, _ALLOCATABLE, dimension(:,:)    :: btm_reservoir    _NULL 

     ! Tracer concentration in river runoff
     real, _ALLOCATABLE, dimension(:,:)    :: trunoff _NULL 

     ! Runoff flux of tracer
     real, _ALLOCATABLE, dimension(:,:)    :: runoff_tracer_flux _NULL 

     ! Wet deposition flux of tracer
     real, _ALLOCATABLE, dimension(:,:)    :: wetdep _NULL 

     ! Dry deposition flux of tracer
     real, _ALLOCATABLE, dimension(:,:)    :: drydep _NULL 

     ! Tracer saturation, alpha and schmidt number 
     real, _ALLOCATABLE, dimension(:,:)    :: csurf  _NULL 

     real, _ALLOCATABLE, dimension(:,:)    :: alpha  _NULL 

     real, _ALLOCATABLE, dimension(:,:)    :: sc_no  _NULL 

     ! An 3D field for vertical movement, esp. for zooplankton, ... 
     real, _ALLOCATABLE, dimension(:,:,:)  :: vmove  _NULL

     ! An 3D field for random vertical movement, esp. for zooplankton, ... 
     real, _ALLOCATABLE, dimension(:,:,:)  :: vdiff  _NULL

     ! An 3D field for implicit vertical diffusion
     real, _ALLOCATABLE, dimension(:,:,:)  :: vdiffuse_impl  _NULL

     ! An auxiliary 3D field for keeping model dependent change tendencies, ... 
     real, pointer, dimension(:,:,:)  :: tendency  => NULL()

     ! IDs for using diag_manager tools
     integer :: diag_id_field=-1, diag_id_stf=-1, diag_id_stf_gas=-1, diag_id_deltap=-1, diag_id_kw=-1, diag_id_trunoff=-1
     integer :: diag_id_alpha=-1, diag_id_csurf=-1, diag_id_sc_no=-1, diag_id_aux=-1
     integer :: diag_id_btf=-1,diag_id_btm=-1, diag_id_vmove=-1, diag_id_vdiff=-1
     integer :: diag_id_vdiffuse_impl = -1, diag_id_tendency = -1, diag_id_field_taup1 = -1

     ! Tracer Initial concentration if constant everywhere
     real    :: const_init_value = 0.0
     real    :: initial_value = 0.0
     ! Tracer Sinking rate
     real    :: sink_rate   = 0.0

     ! Logical switches
     logical :: prog        = .false. !Is this a prognostic (.true.) or diagnostic (.false.) tracer?
     logical :: move_vertical = .false. ! Enable allocation of fields for active vertical movement
     logical :: diff_vertical = .false. ! Enable allocation of fields for random active vertical movement
     logical :: flux_gas    = .false. !Is there a gas flux to atmosphere?
     logical :: flux_runoff = .false. !Is there a river flux?
     logical :: flux_wetdep = .false. !Is there a wet deposition?
     logical :: flux_drydep = .false. !Is there a dry deposition?
     logical :: flux_bottom = .false. !Is there a flux through bottom?
     logical :: has_btm_reservoir = .false. !Is there a flux bottom reservoir?

     ! Flux identifiers to be set by aof_set_coupler_flux()
     integer :: flux_gas_ind    = -1  
     integer :: flux_runoff_ind = -1
     integer :: flux_wetdep_ind = -1
     integer :: flux_drydep_ind = -1

  end type g_tracer_type


  type g_diag_type
     !A pointer to the next node in the list for the current "linked-list implementation".
     type(g_diag_type), pointer :: next => NULL()
  
     integer :: diag_id = -1
     character(len=fm_string_len) :: name, longname, package_name, units
     !Diagnostic axes 
     integer :: axes(3)
     type(time_type) :: init_time
     real :: missing_value = -1.0e+10
     integer :: Z_diag = 0
     real, pointer, dimension(:,:,:) :: field_ptr 
  end type g_diag_type

  ! <DESCRIPTION>
  ! Public types:
  !
  ! The following type fields are common to ALL generic tracers and hence has to be instantiated only once:
  ! </DESCRIPTION>
  type g_tracer_common
     !Domain extents
     integer :: isc,iec,jsc,jec,isd,ied,jsd,jed,nk

     !Number of time levels 
     integer :: ntau

     !Diagnostic axes 
     integer :: axes(3)

     !Initial time used for diagnostics (all tracers are instantiated at the same time).
     type(time_type)        :: init_time

     !Grid mask
     real, _ALLOCATABLE, dimension(:,:,:) :: grid_tmask  _NULL !nnz: Make this a pointer, needs to be "target" in models

     !Grid bottom index
     integer, _ALLOCATABLE, dimension(:,:):: grid_kmt    _NULL

     !coast mask
     integer, _ALLOCATABLE, dimension(:,:):: grid_mask_coast    _NULL

     ! IN and OUT (restart) files
     character(len=fm_string_len) :: ice_restart_file, ocean_restart_file
  end type g_tracer_common

  !Keep the state of this common type for ALL tracers
  type(g_tracer_common), target, save :: g_tracer_com



  ! <DESCRIPTION>
  ! Public interfaces:
  ! </DESCRIPTION>
  public :: g_tracer_type
  public :: g_tracer_find
  public :: g_tracer_add
  public :: g_tracer_init
  public :: g_tracer_flux_init
  public :: g_tracer_column_int
  public :: g_tracer_flux_at_depth
  public :: g_tracer_add_param
  public :: g_tracer_set_values
  public :: g_tracer_get_values
  public :: g_tracer_get_pointer
  public :: g_tracer_get_common
  public :: g_tracer_set_common
  public :: g_tracer_set_files
  public :: g_tracer_coupler_set
  public :: g_tracer_coupler_get
  public :: g_tracer_send_diag
  public :: g_tracer_diag
  public :: g_tracer_get_name
  public :: g_tracer_get_alias
  public :: g_tracer_get_next
  public :: g_tracer_register_diag
  public :: g_tracer_is_prog
  public :: g_tracer_vertdiff_G
  public :: g_tracer_vertdiff_M
  public :: g_tracer_start_param_list
  public :: g_tracer_end_param_list
  public :: g_diag_type
  public :: g_diag_field_add
  public :: g_tracer_set_pointer

  ! <INTERFACE NAME="g_tracer_add_param">
  !  <OVERVIEW>
  !   Add a new parameter for the generic tracer package
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   This subroutine is used to add a new parameter by the calling tracer package.
  !   It provides a mechanism for parameter overwrite through the field_table.
  !For each tracer package there is a field called namelists and there
  !the parameters can be modified from their value set by this method. 
  !E.g., we may have the following in the field_table
  !
  !   "namelists","ocean_mod","generic_topaz"
  !   init = t
  !    /
  !This will overwrite the parameter topaz%init to be .true. at the run time 
  !even though generic_topaz package had in the code 
  !<TT>call g_tracer_add_param('init', topaz%init, .false. )</TT>
  ! 
  !   For the parameters overwrite mechanism to work all calls
  !   for adding new parameters (refer to description for subroutine g_tracer_add_param)
  !   should happen between a <TT>call g_tracer_start_param_list(package_name)</TT>
  !   and a <TT>call g_tracer_end_param_list(package_name)</TT> 
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_add_param(param_name, param_variable, param_value )
  !  </TEMPLATE>
  !  <IN NAME="param_name" TYPE="character(len=fm_string_len)">
  !   Name of the  parameter (e.g., "init")
  !  </IN>
  !  <IN NAME="param_variable" TYPE="integer or logical or real">
  !   Variable to contain the  parameter (e.g., "topaz%init")
  !  </IN>
  !  <IN NAME="param_value" TYPE="integer or logical or real">
  !   Value of the  parameter (e.g., ".true.")
  !  </IN>
  ! </INTERFACE>
  interface g_tracer_add_param
     module procedure g_tracer_add_param_real
     module procedure g_tracer_add_param_logical
     module procedure g_tracer_add_param_integer
     module procedure g_tracer_add_param_string      
  end interface

  interface g_tracer_set_pointer
    module procedure g_tracer_set_pointer_3d
    module procedure g_tracer_set_pointer_4d
  end interface g_tracer_set_pointer

  ! <INTERFACE NAME="g_tracer_set_values">
  !  <OVERVIEW>
  !   Set the values of various (array) memebers of the tracer node g_tracer_type
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   This function is overloaded to set the values of the following member variables
  !4D arrays:   'field'
  !3D arrays:   'field' , 'tendency'
  !2D arrays:   'alpha','csurf','sc_no','stf','stf_gas','deltap','kw','btf','btm_reservoir','trunoff','runoff_tracer_flux','drydep','wetdep'
  !1D values:   'field','tendency','stf','stf_gas','deltap','kw','btf','btm_reservoir','trunoff','runoff_tracer_flux','drydep','wetdep','btm_reservoir','sink_rate'
  !
  !In case of 1D values all element arrays are set to the particular value.
  !
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_set_values(tracer_list,tracer_name,field_name, array_in ,isd,jsd)
  !  </TEMPLATE>
  !  <IN NAME="tracer_list" TYPE="type(g_tracer_type),    pointer">
  !   Pointer to the head of the generic tracer list.
  !  </IN>
  !  <IN NAME="tracer_name" TYPE="character(len=*)">
  !   Name of the particular tracer.
  !  </IN>
  !  <IN NAME="field_name" TYPE="character(len=*)">
  !   String associated with the member array, one of the following:
  !   'field','tendency','stf','stf_gas','deltap','kw','btf','btm_reservoir','trunoff','runoff_tracer_flux','drydep','wetdep','btm_reservoir','sink_rate'
  !   So the result of this call is tracer%field_name = array_in for the tracer called tracer_name
  !  </IN>
  !  <IN NAME="value" TYPE="real OR real(isd:,jsd:) OR real(isd:,jsd:,:) OR real(isd:,jsd:,:,:)">
  !   Overloaded based on the dimension of argument array_in. 
  !  </IN>
  !  <IN NAME="isd,jsd" TYPE="integer">
  !   Lower bound of the domain for argument array_in
  !  </IN>
  ! </INTERFACE>
  interface g_tracer_set_values
     module procedure g_tracer_set_real
     module procedure g_tracer_set_2D
     module procedure g_tracer_set_3D
     module procedure g_tracer_set_4D
  end interface

  ! <INTERFACE NAME="g_tracer_get_values">
  !  <OVERVIEW>
  !   Reverse of interface g_tracer_set_values for getting the tracer member arrays  in the argument value.
  !  </OVERVIEW>
  !  <TEMPLATE>
  !   call g_tracer_get_values(tracer_list,tracer_name,field_name, array_out ,isd,jsd)
  !  </TEMPLATE>
  !  <DESCRIPTION>
  !   This means "get the values of array  %field_name for tracer tracer_name and put them in argument array_out".
  !  </DESCRIPTION>
  ! </INTERFACE>
  !
  interface g_tracer_get_values
     module procedure g_tracer_get_4D_val
     module procedure g_tracer_get_3D_val
     module procedure g_tracer_get_2D_val
     module procedure g_tracer_get_real
     module procedure g_tracer_get_string
  end interface

  ! <INTERFACE NAME="g_tracer_get_pointer">
  !  <OVERVIEW>
  !   Return the pointer to the requested field of a particular tracer
  !  </OVERVIEW>
  !  <TEMPLATE>
  !       call g_tracer_get_pointer(tracer_list,tracer_name,field_name, array_ptr)
  !  </TEMPLATE>
  !  <DESCRIPTION>
  !   This means "get the pointer of array  %field_name for tracer tracer_name  in argument array_ptr".
  !  </DESCRIPTION>
  ! </INTERFACE>

  interface g_tracer_get_pointer
     module procedure g_tracer_get_4D
     module procedure g_tracer_get_3D
     module procedure g_tracer_get_2D
  end interface

contains

  ! <SUBROUTINE NAME="g_tracer_start_param_list">
  !  <OVERVIEW>
  !   Mark the start of adding new parameters for a package
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   For the parameters override mechanism to work all calls
  !   for adding new parameters (refer to description for subroutine g_tracer_add_param)
  !   should happen between a <TT>call g_tracer_start_param_list(package_name)</TT>
  !   and a <TT>call g_tracer_end_param_list(package_name)</TT> 
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_start_param_list(package_name)
  !  </TEMPLATE>
  !  <IN NAME="package_name" TYPE="character(len=fm_string_len)">
  !   Name of the generic tracer package that is adding the parameters (e.g., "generic_cfc")
  !  </IN>
  ! </SUBROUTINE>

  subroutine g_tracer_start_param_list(package_name)
    character(len=fm_string_len), intent(in) :: package_name
    character(len=fm_string_len), parameter  :: sub_name = 'g_tracer_start_param_list'
    character(len=fm_string_len) :: list_path
    integer                      :: list_index

    list_path = '/ocean_mod/namelists/' // trim(package_name) // '/'

    list_index = fm_new_list(list_path)
    if (list_index .le. 0) then  !{
       call mpp_error(FATAL, trim(sub_name) // ' Could not make  the new list' // list_path)
    endif  !}
    
    if (.not. fm_change_list(list_path)) then  !{
       call mpp_error(FATAL, trim(sub_name) // ' Could not change to the new list' // list_path)
    endif  !}

  end subroutine g_tracer_start_param_list

  ! <SUBROUTINE NAME="g_tracer_end_param_list">
  !  <OVERVIEW>
  !   Mark the start of adding new parameters for a package
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   For the parameters override mechanism to work all calls
  !   for adding new parameters (refer to description for subroutine g_tracer_add_param)
  !   should happen between a <TT>call g_tracer_start_param_list(package_name)</TT>
  !   and a <TT>call g_tracer_end_param_list(package_name)</TT> 
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_end_param_list(package_name)
  !  </TEMPLATE>
  !  <IN NAME="package_name" TYPE="character(len=fm_string_len)">
  !   Name of the generic tracer package that is adding the parameters (e.g., "generic_cfc")
  !  </IN>
  ! </SUBROUTINE>

  subroutine g_tracer_end_param_list(package_name)
    character(len=fm_string_len) :: package_name

  end subroutine g_tracer_end_param_list

  !Overload interface g_tracer_add_param for real parameter
  subroutine g_tracer_add_param_real(name, var,  value)
    character(len=*), intent(in)  :: name
    real,             intent(in)  :: value
    real,             intent(out) :: var

    real :: x

    ! Need to save "value" since if "var" and "value" are the same
    ! variable, and "name" does not exist, then "var/value" will be
    ! set to 0 in the fm_get_value routine, and "var" cannot then be
    ! set to the supplied default value

    x = value

    if(.NOT. fm_get_value(name, var))  var = x

  end subroutine g_tracer_add_param_real

  !Overload interface g_tracer_add_param for logical parameter
  subroutine g_tracer_add_param_logical(name, var,  value)
    character(len=*), intent(in)  :: name
    logical,          intent(in)  :: value
    logical,          intent(out) :: var

    logical :: x

    ! Need to save "value" since if "var" and "value" are the same
    ! variable, and "name" does not exist, then "var/value" will be
    ! set to false in the fm_get_value routine, and "var" cannot then be
    ! set to the supplied default value

    x = value

    if(.NOT. fm_get_value(name, var))  var = x

  end subroutine g_tracer_add_param_logical

  !Overload interface g_tracer_add_param for integer parameter
  subroutine g_tracer_add_param_integer(name, var,  value)
    character(len=*), intent(in)  :: name
    integer,          intent(in)  :: value
    integer,          intent(out) :: var

    real :: x

    ! Need to save "value" since if "var" and "value" are the same
    ! variable, and "name" does not exist, then "var/value" will be
    ! set to 0 in the fm_get_value routine, and "var" cannot then be
    ! set to the supplied default value

    x = value

    if(.NOT. fm_get_value(name, var))  var = x

  end subroutine g_tracer_add_param_integer

  !Overload interface g_tracer_add_param for string parameter
  subroutine g_tracer_add_param_string(name, var,  value)
    character(len=*), intent(in)  :: name
    character(len=*), intent(in)  :: value
    character(len=*), intent(out) :: var

    character(len=fm_string_len) :: x

    ! Need to save "value" since if "var" and "value" are the same
    ! variable, and "name" does not exist, then "var/value" will be
    ! set to '' in the fm_get_value routine, and "var" cannot then be
    ! set to the supplied default value

    x = value

    if(.NOT. fm_get_value(name, var))  var = x

  end subroutine g_tracer_add_param_string


  ! <SUBROUTINE NAME="g_tracer_add">
  !  <OVERVIEW>
  !   Add a new tracer (node) at the top of the list of generic tracers
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !    This subroutine call adds an individual new tracer to the growing list of generic tracers.
  !    It then allocates all the necessary arrays for using this tracer in the Ocean model that requested it.
  !    The information passed into this subroutine should be enough to fully describe the individual tracer
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !  call g_tracer_add(tracer_list,&
  !       package    = 'generic_topaz',&
  !       name       = 'g_dic',               &
  !       longname   = 'g Dissolved Inorganic Carbon', &
  !       units      = 'mol/kg',            &
  !       prog       = .true.,              &
  !       flux_gas       = .true.,                      &
  !       flux_gas_name  = 'co2_flux',                  &
  !       flux_gas_molwt = WTMCO2,                      &
  !       flux_gas_param = (/ 9.36e-07, 9.7561e-06 /),  &
  !       flux_runoff    = .true.,          &
  !       flux_param     = (/12.011e-03  /),  &
  !       flux_bottom    = .true.,          &
  !       ice_restart_file = topaz%ice_restart_file)
  !
  !  </TEMPLATE>
  !  <IN NAME="node_ptr" TYPE="type(g_tracer_type), pointer">
  !   Pointer to the head node of the tracer list. This is also going to be the pointer to the node being added after the call.
  !  </IN>
  !  <IN NAME="package" TYPE="character(len=*)">
  !   Name of tracer package adding this node.
  !  </IN>
  !  <IN NAME="name" TYPE="character(len=*)">
  !   Name of this tracer.
  !  </IN>
  !  <IN NAME="longname" TYPE="character(len=*)">
  !   Descriptive name of this tracer..
  !  </IN>
  !  <IN NAME="units" TYPE="character(len=*)">
  !   Concentration units (units of array %field).
  !  </IN>
  !  <IN NAME="prog" TYPE="logical">
  !   .true. for prognastic , .false. for diagnostic tracer.
  !  </IN>
  !
  !  OPTIONAL arguments begin:
  !
  !  <IN NAME="const_init_value" TYPE="real">
  !   Initial value of concenteration if constant.
  !  </IN>
  !  <IN NAME="flux_gas" TYPE="logical">
  !   .true. if there is gas flux exchange with atmos.
  !  </IN>
  !  <IN NAME="flux_gas_name" TYPE="character(len=*)">
  !   Name of the atmospheric tracer to exchange flux with (if flux_gas=.true.).
  !  </IN>
  !  <IN NAME="flux_runoff" TYPE="logical">
  !   .true. if there is runoff flux.
  !  </IN>
  !  <IN NAME="flux_wetdep" TYPE="logical">
  !   .true. if there is wetdep flux.
  !  </IN>
  !  <IN NAME="flux_drydep" TYPE="logical">
  !   .true. if there is drydep flux.
  !  </IN>
  !  <IN NAME="flux_bottom" TYPE="logical">
  !   .true. if there is bottom flux.
  !  </IN>
  !  <IN NAME="btm_reservoir" TYPE="logical">
  !   .true. if there is bottom reservoir.
  !  </IN>
  !  <IN NAME="move_vertical" TYPE="logical">
  !   .true. if there is active vertical movement
  !  </IN>
  !  <IN NAME="diff_vertical" TYPE="logical">
  !   .true. if there is random active vertical movement
  !  </IN>
  !  <IN NAME="flux_gas_molwt" TYPE="real">
  !   Molecular wt of gas defined in constants.F90 (g/mol)
  !  </IN>
  !  <IN NAME="flux_gas_param" TYPE="real, dimension(:)">
  !   Aray of parameters for gas flux (refer to documentation for subroutine aof_set_coupler_flux() ).
  !  </IN>
  !  <IN NAME="flux_param" TYPE="real, dimension(:)">
  !   Aray of parameters for non-gas flux (refer to documentation for subroutine aof_set_coupler_flux() ).
  !  </IN>
  !  <IN NAME="sink_rate" TYPE="real">
  !   Sinking rate if non-zero.
  !  </IN>
  !  <IN NAME="ice_restart_file" TYPE="character(len=*)">
  !   refer to documentation for subroutine aof_set_coupler_flux().
  !  </IN>
  !  <IN NAME="ocean_restart_file" TYPE="character(len=*)">
  !   refer to documentation for subroutine aof_set_coupler_flux().
  !  </IN>
  !  
  ! </SUBROUTINE>

  subroutine g_tracer_add(node_ptr, package, name, longname, units,  prog, const_init_value,init_value,&
       flux_gas, flux_gas_name, flux_runoff, flux_wetdep, flux_drydep, flux_gas_molwt, flux_gas_param, &
       flux_param, flux_bottom, btm_reservoir, move_vertical, diff_vertical, sink_rate, flux_gas_restart_file, flux_gas_type) 

    type(g_tracer_type), pointer :: node_ptr 
    character(len=*),   intent(in) :: package,name,longname,units
    logical,            intent(in) :: prog
    real,               intent(in), optional :: const_init_value
    real,               intent(in), optional :: init_value
    real,               intent(in), optional :: sink_rate
    logical,            intent(in), optional :: flux_gas
    logical,            intent(in), optional :: flux_runoff
    logical,            intent(in), optional :: flux_wetdep
    logical,            intent(in), optional :: flux_drydep
    logical,            intent(in), optional :: flux_bottom
    logical,            intent(in), optional :: btm_reservoir
    logical,            intent(in), optional :: move_vertical
    logical,            intent(in), optional :: diff_vertical
    real,               intent(in), optional :: flux_gas_molwt
    real, dimension(:), intent(in), optional :: flux_gas_param
    real, dimension(:), intent(in), optional :: flux_param
    character(len=*),   intent(in), optional :: flux_gas_name
    character(len=*),   intent(in), optional :: flux_gas_type
    character(len=*),   intent(in), optional :: flux_gas_restart_file

    !
    !       Local parameters
    !

    character(len=fm_string_len), parameter  :: sub_name = 'g_tracer_add'
    character(len=fm_string_len) :: flux_name
    !
    !       Local variables
    !
    type(g_tracer_type), pointer :: g_tracer => NULL()
    integer, save :: index = 0

    !===================================================================
    !Initialize the node
    !===================================================================
    allocate(g_tracer)

    !Specific properties
    index = index + 1
    g_tracer%index        = index
    g_tracer%name         = trim(name)
    g_tracer%longname     = trim(longname)
    g_tracer%package_name = trim(package)
    g_tracer%units        = trim(units)
    g_tracer%prog         = prog 

    !Restart files for tracers 
    g_tracer%ocean_restart_file = trim(g_tracer_com%ocean_restart_file)
    !Restart files for ice fluxes
    g_tracer%ice_restart_file   = trim(g_tracer_com%ice_restart_file)

    !Restart files for csurf, alpha and sc_no for tracers with gas flux default values
    g_tracer%flux_gas_restart_file = trim("ocean_airsea_flux.res.nc")    

    g_tracer%alias        = trim(name)
    !%alias is the global name for this tracer 
    !i.e., the name this tracer is known outside generic modules e.g., to model componenets.
    !Normally, %alias = %name as set above.
    !Sometimes, for debugging purposes the user may want to change the global name of a tracer
    !e.g., to clone a tracer and rrun it under a different name. 
    !This can be done for all tracers by:
    !g_tracer%alias        = trim("g_") // trim(name)


    !===================================================================
    !Allocate and initialize member field arrays
    !===================================================================
    !Note that const_init_value unlike init_value has special meaning in MOM 
    ! and if present the field is not restarted from a file!!
    if(present(const_init_value)) then
       g_tracer%const_init_value = const_init_value
       g_tracer%initial_value = const_init_value
    endif

    if(present(init_value))  g_tracer%initial_value = init_value

    !
    !Determine the fluxes 
    !

    if(present(flux_gas_molwt)) then
       g_tracer%flux_gas_molwt=flux_gas_molwt
    else
       g_tracer%flux_gas_molwt = 0.0
    endif
    if(present(flux_gas_param)) then
       allocate(g_tracer%flux_gas_param(size(flux_gas_param)))
       g_tracer%flux_gas_param=flux_gas_param
    endif
    if(present(flux_param)) then
       allocate(g_tracer%flux_param(size(flux_param)))
       g_tracer%flux_param=flux_param
    endif

    if(present(flux_gas))  g_tracer%flux_gas = flux_gas
    if(g_tracer%flux_gas) then
       g_tracer%flux_gas_name=trim(g_tracer%alias) // trim("_flux")
       if(present(flux_gas_name)) g_tracer%flux_gas_name=flux_gas_name
       if(present(flux_gas_restart_file))  g_tracer%flux_gas_restart_file  = flux_gas_restart_file
       g_tracer%flux_gas_type=trim("air_sea_gas_flux_generic")
       if(present(flux_gas_type)) g_tracer%flux_gas_type=flux_gas_type
    endif

    if(present(flux_runoff))  g_tracer%flux_runoff = flux_runoff
    if(g_tracer%flux_runoff) then
       g_tracer%flux_runoff_name=trim("runoff_") // trim(g_tracer%alias) 
    endif

    if(present(flux_wetdep))  g_tracer%flux_wetdep = flux_wetdep
    if(g_tracer%flux_wetdep) then
       g_tracer%flux_wetdep_name=trim("wet_dep_") // trim(g_tracer%alias)
    endif

    if(present(flux_drydep))  g_tracer%flux_drydep = flux_drydep
    if(g_tracer%flux_drydep) then
       g_tracer%flux_drydep_name=trim("dry_dep_") // trim(g_tracer%alias)
    endif

    if(present(flux_bottom))  g_tracer%flux_bottom = flux_bottom

    if(present(btm_reservoir)) g_tracer%has_btm_reservoir = btm_reservoir

    if(present(move_vertical)) g_tracer%move_vertical = move_vertical

    if(present(diff_vertical)) g_tracer%diff_vertical = diff_vertical

    if(present(sink_rate)) g_tracer%sink_rate = sink_rate

    !===================================================================
    !Reversed Linked List implementation! Make this new node to be the head of the list.
    !===================================================================    

    g_tracer%next => node_ptr 
    node_ptr => g_tracer 


  end subroutine g_tracer_add

  !
  !     Local functiion to remap the bounds of an array
  !     (Thanks to wikipedia for the suggestion)
  !

  function remap_bounds(ilb, jlb, klb, array) result(ptr)

  real, dimension(:,:,:),          pointer              :: ptr

  integer,                                 intent(in)   :: ilb
  integer,                                 intent(in)   :: jlb
  integer,                                 intent(in)   :: klb
  real, dimension(ilb:,jlb:,klb:), target, intent(in)   :: array

  ptr => array

  return
  end function remap_bounds

  subroutine g_tracer_init(g_tracer)
    type(g_tracer_type), pointer :: g_tracer
    integer :: isc,iec,jsc,jec,isd,ied,jsd,jed, nk,ntau,axes(3)

    !Get the common values for all tracers
    call g_tracer_get_common(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,axes) 

    allocate(g_tracer%field(isd:ied,jsd:jed,nk,ntau));  g_tracer%field(:,:,:,:) = g_tracer%initial_value
    g_tracer%field_3d => remap_bounds(isd, jsd, 1, g_tracer%field(:,:,:,1))

    if(g_tracer%prog) then
       allocate(g_tracer%tendency(isd:ied,jsd:jed,nk)); g_tracer%tendency(:,:,:) = 0.0
       allocate(g_tracer%vdiffuse_impl(isd:ied,jsd:jed,nk))
       g_tracer%vdiffuse_impl(:,:,:) = 0.0
    endif

    if(g_tracer%flux_gas) then
       allocate(g_tracer%alpha(isd:ied,jsd:jed));g_tracer%alpha=0.0
       allocate(g_tracer%csurf(isd:ied,jsd:jed));g_tracer%csurf=0.0
       allocate(g_tracer%stf_gas(isd:ied,jsd:jed)); g_tracer%stf_gas(:,:) = 0.0 
       if(g_tracer%flux_gas_type .eq. 'air_sea_gas_flux_generic') then
          allocate(g_tracer%sc_no(isd:ied,jsd:jed));g_tracer%sc_no=0.0
          allocate(g_tracer%deltap(isd:ied,jsd:jed)); g_tracer%deltap(:,:) = 0.0 
          allocate(g_tracer%kw(isd:ied,jsd:jed)); g_tracer%kw(:,:) = 0.0 
       endif
    endif
    if(g_tracer%flux_runoff) then
       allocate(g_tracer%trunoff(isd:ied,jsd:jed));g_tracer%trunoff(:,:) = 0.0 
       allocate(g_tracer%runoff_tracer_flux(isd:ied,jsd:jed));g_tracer%runoff_tracer_flux(:,:) = 0.0 
    endif

    if(g_tracer%flux_wetdep) then
       allocate(g_tracer%wetdep(isd:ied,jsd:jed));g_tracer%wetdep(:,:) = 0.0 
    endif

    if(g_tracer%flux_drydep) then
       allocate(g_tracer%drydep(isd:ied,jsd:jed));g_tracer%drydep(:,:) = 0.0 
    endif

    if(g_tracer%flux_bottom) then
       allocate(g_tracer%btf(isd:ied,jsd:jed));g_tracer%btf(:,:) = 0.0 
    endif

    if(g_tracer%has_btm_reservoir) then
       allocate(g_tracer%btm_reservoir(isd:ied,jsd:jed));g_tracer%btm_reservoir(:,:) = 0.0 
    endif

    if(g_tracer%move_vertical) then
       allocate(g_tracer%vmove(isd:ied,jsd:jed, nk));g_tracer%vmove(:,:,:) = 0. 
    endif

    if(g_tracer%diff_vertical) then
       allocate(g_tracer%vdiff(isd:ied,jsd:jed, nk));g_tracer%vdiff(:,:,:) = 0. 
    endif
    !Surface flux %stf exists if one of the following fluxes were requested:

    if(g_tracer%flux_gas .or. g_tracer%flux_runoff .or. g_tracer%flux_wetdep .or. g_tracer%flux_drydep) then
       allocate(g_tracer%stf(isd:ied,jsd:jed)); g_tracer%stf(:,:) = 0.0 
    endif
    
  end subroutine g_tracer_init

  subroutine g_tracer_flux_init(g_tracer)
    type(g_tracer_type), pointer :: g_tracer


    !===================================================================
    !Get coupler flux indices
    !===================================================================
    !
    !For each kind of flux allocate the appropriate arrays only if that flux 
    !indicated to exist for the tracer.

    if(g_tracer%flux_gas) then
       g_tracer%flux_gas_ind  = aof_set_coupler_flux(g_tracer%flux_gas_name,                  &
            flux_type         = g_tracer%flux_gas_type,                                       &
            implementation    = 'ocmip2',                                                     &
            mol_wt            = g_tracer%flux_gas_molwt,                                      &
            param             = g_tracer%flux_gas_param,                                      &
            ice_restart_file  = g_tracer%ice_restart_file,                                    &
            ocean_restart_file= g_tracer%flux_gas_restart_file                                &
            )
    endif

    if(g_tracer%flux_runoff) then
       g_tracer%flux_runoff_ind  = aof_set_coupler_flux(g_tracer%flux_runoff_name,            &
            flux_type            = 'land_sea_runoff',                                         &
            implementation       = 'river',                                                   &
            param                = g_tracer%flux_param,                                       &
            ice_restart_file     = g_tracer%ice_restart_file                                  &
            )
    endif

    if(g_tracer%flux_wetdep) then
       g_tracer%flux_wetdep_ind  = aof_set_coupler_flux(g_tracer%flux_wetdep_name,            &
            flux_type            = 'air_sea_deposition',                                      &
            implementation       = 'wet',                                                     &
            param                = g_tracer%flux_param,                                       &
            ice_restart_file       = g_tracer%ice_restart_file                                &
            )
    endif

    if(g_tracer%flux_drydep) then
       g_tracer%flux_drydep_ind  = aof_set_coupler_flux(g_tracer%flux_drydep_name,            &
            flux_type            = 'air_sea_deposition',                                      &
            implementation       = 'dry',                                                     &
            param                = g_tracer%flux_param,                                       &
            ice_restart_file     = g_tracer%ice_restart_file                                  &
            )
    endif
    
    

  end subroutine g_tracer_flux_init


  ! <SUBROUTINE NAME="g_tracer_register_diag">
  !  <OVERVIEW>
  !   Diag-register all the internal fields that were _ALLOCATED for a tracer.
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Use diag_manager register_diag_field for each of the field arrays that were _ALLOCATED for a tracer node.
  !   These include %field,  %tendency, %stf, %stf_gas, %deltap, %kw, %btf, %trunoff, %alpha, %csurf, %sc_no, %btm_reservoir. 
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call  g_tracer_register_diag(g_tracer)
  !  </TEMPLATE>
  !  <IN NAME="g_tracer" TYPE="type(g_tracer_type), pointer">
  !   Pointer to this tracer node. 
  !  </IN>
  ! </SUBROUTINE>

  subroutine g_tracer_register_diag(g_tracer)
    type(g_tracer_type), pointer :: g_tracer

    character(len=fm_string_len) :: string

    g_tracer%diag_id_field = register_diag_field(g_tracer%package_name, &
         trim(g_tracer%alias),         &
         g_tracer_com%axes(1:3),       &
         g_tracer_com%init_time,       &
         trim(g_tracer%longname),      &
         trim(g_tracer%units),         &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_taup1")
    g_tracer%diag_id_field_taup1 = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:3),       &
         g_tracer_com%init_time,       &
         trim(g_tracer%longname) // ' at taup1',      &
         trim(g_tracer%units),         &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_aux")
    g_tracer%diag_id_aux = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:3),       &
         g_tracer_com%init_time,       &
         trim(string),                 &
         trim(g_tracer%units),         &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_vmove")
    g_tracer%diag_id_vmove = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:3),       &
         g_tracer_com%init_time,       &
         trim('vertical movement'),    &
         trim('m/s'),                  &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_vdiffuse_impl")
    g_tracer%diag_id_vdiffuse_impl = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:3),       &
         g_tracer_com%init_time,       &
         'Implicit vertical diffusion of ' // trim(g_tracer%alias),      &
         trim('mole/m^2/s'),                  &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_tendency")
    g_tracer%diag_id_tendency = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:3),       &
         g_tracer_com%init_time,       &
         'Generic tracer tendency of ' // trim(g_tracer%alias),      &
         trim('mole/m^2/s'),                  &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_vdiff")
    g_tracer%diag_id_vdiff = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:3),       &
         g_tracer_com%init_time,       &
         trim('random movement'),      &
         trim('m/s'),                  &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_stf")
    g_tracer%diag_id_stf = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:2),       &
         g_tracer_com%init_time,       &
         trim('Total flux of ') // trim(g_tracer%alias) // trim(' into Ocean Surface'), &
         trim('mole/m^2/sec'),         &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_stf_gas")
    g_tracer%diag_id_stf_gas = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:2),       &
         g_tracer_com%init_time,       &
         trim('Gas exchange flux of ') // trim(g_tracer%alias) // trim(' into Ocean Surface'), &
         trim('mole/m^2/sec'),         &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_deltap")
    g_tracer%diag_id_deltap = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:2),       &
         g_tracer_com%init_time,       &
         trim('Ocn minus Atm pressure of ') // trim(g_tracer%alias), &
         trim('uatm'),                 &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_kw")
    g_tracer%diag_id_kw = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:2),       &
         g_tracer_com%init_time,       &
         trim('Gas Exchange piston velocity for ') // trim(g_tracer%alias), &
         trim('m/sec'),                &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_btf")
    g_tracer%diag_id_btf = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:2),       &
         g_tracer_com%init_time,       &
         trim('Total flux of ') // trim(g_tracer%alias) // trim(' into Ocean Bottom'), &
         trim('mole/m^2/sec'),         &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_btm_reservoir")
    g_tracer%diag_id_btm = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:2),       &
         g_tracer_com%init_time,       &
         trim('Bottom reservoir of ') // trim(g_tracer%alias), &
         trim(g_tracer%units),         &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_trunoff")
    g_tracer%diag_id_trunoff = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:2),       &
         g_tracer_com%init_time,       &
         trim('River concentration of ') // trim(g_tracer%alias), &
         trim(g_tracer%units),         &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_alpha")
    g_tracer%diag_id_alpha = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:2),       &
         g_tracer_com%init_time,       &
         trim('Atmospheric saturation for ') // trim(g_tracer%alias), &
         trim(g_tracer%units),         &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_csurf")
    g_tracer%diag_id_csurf = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:2),       &
         g_tracer_com%init_time,       &
         trim('Ocean surface gas concentration of ') // trim(g_tracer%alias), &
         trim(g_tracer%units),         &
         missing_value = -1.0e+20)

    string=trim(g_tracer%alias) // trim("_sc_no")
    g_tracer%diag_id_sc_no = register_diag_field(g_tracer%package_name, &
         trim(string),                 &
         g_tracer_com%axes(1:2),       &
         g_tracer_com%init_time,       &
         trim('Ocean surface Schmidt Number for ') // trim(g_tracer%alias), &
         trim(g_tracer%units),         &
         missing_value = -1.0e+20)

  end subroutine g_tracer_register_diag

  ! <SUBROUTINE NAME="g_tracer_coupler_set">
  !  <OVERVIEW>
  !   Set coupler values only for tracers that have _ALLOCATED %alpha, %csurf and %sc_no
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Use coupler_util subroutine set_coupler_values() to set the coupler values
  !   for fluxes to be exchanged with Ice for the requested fluxes.
  !   NOTE:
  !   This is a collective subroutine and will traverese the list of generic tracers and 
  !   set the coupler values for each tracer node accordingly.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_coupler_set(g_tracer_list,IOB_struc,value)
  !  </TEMPLATE>
  !  <IN NAME="g_tracer_list" TYPE="type(g_tracer_type), pointer">
  !   Pointer to the head of the generic tracer list.
  !  </IN>
  !  <IN NAME="IOB_struc" TYPE="type(coupler_2d_bc_type)">
  !   The coupler flux IOB structure. 
  !  </IN>
  !  OPTIONAL ARGS:
  !  <IN NAME="value" TYPE="real">
  !   Set the coupler values to a constant (particularly 0) is desired.
  !  </IN>
  ! </SUBROUTINE>

  subroutine g_tracer_coupler_set(g_tracer_list,IOB_struc,value)
    type(g_tracer_type), pointer :: g_tracer_list,g_tracer 
    type(coupler_2d_bc_type), intent(inout) :: IOB_struc
    real, optional :: value

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_coupler_set'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list
    !Go through the list of tracers 
    do  
       !
       !Set coupler values only for tracers that have _ALLOCATED %alpha, %csurf and %sc_no
       !

       if(_ALLOCATED(g_tracer%alpha)) then

          if(present(value)) g_tracer%alpha=value 

          call set_coupler_values(g_tracer%alpha,   &
               BC_struc   = IOB_struc,              &
               BC_index   = g_tracer%flux_gas_ind,  &
               BC_element = ind_alpha,              &
               ilb=g_tracer_com%isd, jlb=g_tracer_com%jsd ,&
               is=g_tracer_com%isc, ie=g_tracer_com%iec,&
               js=g_tracer_com%jsc, je=g_tracer_com%jec &
               )
       endif

       if(_ALLOCATED(g_tracer%csurf)) then

          if(present(value)) g_tracer%csurf=value 

          call set_coupler_values(g_tracer%csurf,   &
               BC_struc   = IOB_struc,              &
               BC_index   = g_tracer%flux_gas_ind,  &
               BC_element = ind_csurf,              &
               ilb=g_tracer_com%isd, jlb=g_tracer_com%jsd ,&
               is=g_tracer_com%isc, ie=g_tracer_com%iec,&
               js=g_tracer_com%jsc, je=g_tracer_com%jec &
               )
       endif

       if(_ALLOCATED(g_tracer%sc_no)) then

          if(present(value)) g_tracer%sc_no=value 

          call set_coupler_values(g_tracer%sc_no,   &
               BC_struc   = IOB_struc,              &
               BC_index   = g_tracer%flux_gas_ind,  &
               BC_element = ind_sc_no,              &
               ilb=g_tracer_com%isd, jlb=g_tracer_com%jsd ,&
               is=g_tracer_com%isc, ie=g_tracer_com%iec,&
               js=g_tracer_com%jsc, je=g_tracer_com%jec &
               )
       endif

       !traverse the linked list till hit NULL
       if(.NOT. associated(g_tracer%next)) exit
       g_tracer => g_tracer%next
    enddo

  end subroutine g_tracer_coupler_set

  ! <SUBROUTINE NAME="g_tracer_coupler_get">
  !  <OVERVIEW>
  !   Get coupler values only for tracers that have _ALLOCATED arrays for the fluxes
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Use coupler_util subroutine extract_coupler_values() to get the coupler values
  !   for fluxes to be exchanged with Ice for the requested fluxes only.
  !   NOTE:
  !   This is a collective subroutine and will traverese the list of generic tracers and 
  !   get the coupler values for each tracer node accordingly.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_coupler_get(g_tracer_list,IOB_struc)
  !  </TEMPLATE>
  !  <IN NAME="g_tracer_list" TYPE="type(g_tracer_type), pointer">
  !   Pointer to the head of the generic tracer list.
  !  </IN>
  !  <IN NAME="IOB_struc" TYPE="type(coupler_2d_bc_type)">
  !   The coupler flux IOB structure. 
  !  </IN>
  ! </SUBROUTINE>

  subroutine g_tracer_coupler_get(g_tracer_list,IOB_struc)
    type(g_tracer_type),          pointer :: g_tracer_list, g_tracer 
    type(coupler_2d_bc_type),    intent(in) :: IOB_struc

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_coupler_get'
    real, dimension(:,:), allocatable :: temp_array,stf_array,stf_gas_array,deltap_array, kw_array

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list
    allocate(temp_array(g_tracer_com%isd:g_tracer_com%ied,g_tracer_com%jsd:g_tracer_com%jed));temp_array=0.0
    allocate(stf_array(g_tracer_com%isd:g_tracer_com%ied,g_tracer_com%jsd:g_tracer_com%jed))
    allocate(stf_gas_array(g_tracer_com%isd:g_tracer_com%ied,g_tracer_com%jsd:g_tracer_com%jed))
    allocate(deltap_array(g_tracer_com%isd:g_tracer_com%ied,g_tracer_com%jsd:g_tracer_com%jed))
    allocate(kw_array(g_tracer_com%isd:g_tracer_com%ied,g_tracer_com%jsd:g_tracer_com%jed))


    !Go through the list of tracers 
    do  
       stf_array=0.0

       if(g_tracer%flux_gas) then
          temp_array=0.0
          call extract_coupler_values(BC_struc  =IOB_struc, &
               BC_index  =g_tracer%flux_gas_ind,    & 
               BC_element=ind_flux,                 &
               array_out =temp_array,               &
               conversion=-1.0,                     &
               ilb=g_tracer_com%isd,jlb=g_tracer_com%jsd,& !lower bounds of array_out 
               is=g_tracer_com%isc, ie=g_tracer_com%iec,&
               js=g_tracer_com%jsc, je=g_tracer_com%jec)
          !This does temp_array=conv *BC_struc%bc(flux_gas_ind)%field(ind_flux)%values

          stf_array = stf_array+temp_array !flux_gas contributes to %stf
          stf_gas_array=stf_array


          if(g_tracer%flux_gas_type .eq. 'air_sea_gas_flux_generic') then
             temp_array=0.0
             deltap_array=0.0
             call extract_coupler_values(BC_struc  =IOB_struc, &
                  BC_index  =g_tracer%flux_gas_ind,    & 
                  BC_element=ind_deltap,               &
                  array_out =temp_array,               &
                  conversion=1.0,                      &
                  ilb=g_tracer_com%isd,jlb=g_tracer_com%jsd,& !lower bounds of array_out 
                  is=g_tracer_com%isc, ie=g_tracer_com%iec,&
                  js=g_tracer_com%jsc, je=g_tracer_com%jec)
             !This does temp_array=conv *BC_struc%bc(flux_gas_ind)%field(ind_flux)%values
             
             deltap_array = deltap_array+temp_array
             temp_array=0.0
             kw_array=0.0
             call extract_coupler_values(BC_struc  =IOB_struc, &
                  BC_index  =g_tracer%flux_gas_ind,    & 
                  BC_element=ind_kw,                   &
                  array_out =temp_array,               &
                  conversion=1.0,                      &
                  ilb=g_tracer_com%isd,jlb=g_tracer_com%jsd,& !lower bounds of array_out
                  is=g_tracer_com%isc, ie=g_tracer_com%iec,&
                  js=g_tracer_com%jsc, je=g_tracer_com%jec)
             !This does temp_array=conv *BC_struc%bc(flux_gas_ind)%field(ind_flux)%values
             
             kw_array = kw_array+temp_array
          endif
          
       endif

       if(g_tracer%flux_drydep) then
          temp_array=0.0
          call extract_coupler_values(BC_struc  =IOB_struc, &
               BC_index  =g_tracer%flux_drydep_ind,  &
               BC_element=ind_flux,                  &
               array_out =temp_array,                &
               conversion=-1.0,                      &
               ilb=g_tracer_com%isd,jlb=g_tracer_com%jsd,&
               is=g_tracer_com%isc, ie=g_tracer_com%iec, &
               js=g_tracer_com%jsc, je=g_tracer_com%jec)

          stf_array = stf_array+temp_array !flux_drydep contributes to %stf

          call g_tracer_set_values(g_tracer,g_tracer%name,'drydep',temp_array,&
               g_tracer_com%isd,g_tracer_com%jsd)
       endif

       if(g_tracer%flux_wetdep) then
          temp_array=0.0
          call extract_coupler_values(BC_struc  =IOB_struc, &
               BC_index  =g_tracer%flux_wetdep_ind,  &
               BC_element=ind_flux,                  &
               array_out =temp_array,                &
               conversion=-1.0,                      &
               ilb=g_tracer_com%isd,jlb=g_tracer_com%jsd,&
               is=g_tracer_com%isc, ie=g_tracer_com%iec, &
               js=g_tracer_com%jsc, je=g_tracer_com%jec)

          stf_array = stf_array+temp_array  !flux_wetdep contributes to %stf

          call g_tracer_set_values(g_tracer,g_tracer%name,'wetdep',temp_array,&
               g_tracer_com%isd,g_tracer_com%jsd)
       endif

       if(g_tracer%flux_runoff) then
          temp_array=0.0
          call extract_coupler_values(BC_struc  =IOB_struc, &
               BC_index  =g_tracer%flux_runoff_ind, &
               BC_element=ind_flux,                 &
               array_out =temp_array,               &
               conversion=1.0,                      &
               ilb=g_tracer_com%isd,jlb=g_tracer_com%jsd,&
               is=g_tracer_com%isc, ie=g_tracer_com%iec, &
               js=g_tracer_com%jsc, je=g_tracer_com%jec)

          call g_tracer_set_values(g_tracer,g_tracer%name,'trunoff',temp_array,&
               g_tracer_com%isd,g_tracer_com%jsd)
       endif

       !Any of the following fluxes contribute to %stf
       !gas, wetdep and drydep contribute explicitly here.
       !runoff contributes to %stf in GOLD but not in MOM, 
       !so it will be added later in the model-dependent driver code (GOLD_generic_tracer.F90)

       if(g_tracer%flux_gas .or. g_tracer%flux_drydep .or. g_tracer%flux_wetdep .or. g_tracer%flux_runoff ) then
          call g_tracer_set_values(g_tracer,g_tracer%name,'stf',stf_array,&
               g_tracer_com%isd,g_tracer_com%jsd)
       endif

       if(g_tracer%flux_gas) then
          call g_tracer_set_values(g_tracer,g_tracer%name,'stf_gas',stf_gas_array,&
               g_tracer_com%isd,g_tracer_com%jsd)
          if(g_tracer%flux_gas_type .eq. 'air_sea_gas_flux_generic') then
             call g_tracer_set_values(g_tracer,g_tracer%name,'deltap',deltap_array,&
                  g_tracer_com%isd,g_tracer_com%jsd)
             call g_tracer_set_values(g_tracer,g_tracer%name,'kw',kw_array,&
                  g_tracer_com%isd,g_tracer_com%jsd)
          endif
       endif

       !traverse the linked list till hit NULL
       if(.NOT. associated(g_tracer%next)) exit
       g_tracer => g_tracer%next
    enddo

    deallocate(temp_array, stf_array, stf_gas_array, deltap_array, kw_array)

  end subroutine g_tracer_coupler_get

  ! <SUBROUTINE NAME="g_tracer_set_common">
  !  <OVERVIEW>
  !   Set common values and arrays for ALL generic tracers to share
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   ALL generic tracers share the same properties such as 2D Domain, # of depth levels, # of time steps retained
  !   grid_mask array and initial time.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_set_common(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,axes,grid_tmask,grid_kmt,init_time)
  !  </TEMPLATE>
  !  <IN NAME="" TYPE="">
  !   
  !  </IN>
  ! </SUBROUTINE>

  subroutine g_tracer_set_common(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,axes,grid_tmask,grid_kmt,init_time)
    integer,                     intent(in) :: isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,axes(3)
    real, dimension(isd:,jsd:,:),intent(in) :: grid_tmask
    integer,dimension(isd:,jsd:),intent(in) :: grid_kmt
    type(time_type),             intent(in) :: init_time 

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_set_common'
    integer :: i,j

    !Here we assume that all the tracers in the list have the same following properties

    g_tracer_com%isd=isd
    g_tracer_com%ied=ied
    g_tracer_com%jsd=jsd
    g_tracer_com%jed=jed
    g_tracer_com%isc=isc
    g_tracer_com%iec=iec
    g_tracer_com%jsc=jsc
    g_tracer_com%jec=jec
    g_tracer_com%nk =nk
    g_tracer_com%ntau=ntau
    g_tracer_com%axes=axes
    g_tracer_com%init_time=init_time

    if(.NOT. _ALLOCATED(g_tracer_com%grid_tmask)) allocate(g_tracer_com%grid_tmask(isd:ied,jsd:jed,nk))
    g_tracer_com%grid_tmask=grid_tmask 


    if(.NOT. _ALLOCATED(g_tracer_com%grid_kmt)) allocate(g_tracer_com%grid_kmt(isd:ied,jsd:jed))    
    g_tracer_com%grid_kmt = grid_kmt

    if(.NOT. _ALLOCATED(g_tracer_com%grid_mask_coast)) allocate(g_tracer_com%grid_mask_coast(isd:ied,jsd:jed))

    !Determine the coast line.
    !In order to that grid_tmask must have the proper value on the data domain boundaries isd,ied,jsd,jed
    !so that we can decide if the coast line coinsides with a point on the compute domain boundary

    g_tracer_com%grid_mask_coast(:,:) = 0
    do j =jsc, jec ; do i = isc, iec  
       if (g_tracer_com%grid_tmask(i,j,1) .gt. 0) then 
          if (g_tracer_com%grid_tmask(i-1,j,1) .lt. 1 .or. g_tracer_com%grid_tmask(i,j-1,1) .lt. 1 .or. &
              g_tracer_com%grid_tmask(i+1,j,1) .lt. 1 .or. g_tracer_com%grid_tmask(i,j+1,1) .lt. 1) then !{
             g_tracer_com%grid_mask_coast(i,j) = 1
          endif
       endif
    enddo; enddo     


  end subroutine g_tracer_set_common

  ! <SUBROUTINE NAME="g_tracer_get_common">
  !  <OVERVIEW>
  !   Get common values and arrays for ALL generic tracers to share
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_get_common(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,&
  !     axes,grid_tmask,grid_mask_coast,grid_kmt,init_time)
  !  </TEMPLATE>
  !  <IN NAME="" TYPE="">
  !   
  !  </IN>
  ! </SUBROUTINE>

  subroutine g_tracer_get_common(isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau,&
       axes,grid_tmask,grid_mask_coast,grid_kmt,init_time)

    integer,               intent(out) :: isc,iec,jsc,jec,isd,ied,jsd,jed,nk,ntau
    integer,optional,      intent(out) :: axes(3)
    type(time_type), optional,      intent(out) :: init_time 
    real, optional, dimension(:,:,:),pointer    :: grid_tmask
    integer, optional, dimension(:,:),  pointer :: grid_mask_coast
    integer, optional, dimension(:,:),  pointer :: grid_kmt

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_get_common'

    !Here we assume that all the tracers in the list have the same following properties

    isd=g_tracer_com%isd
    ied=g_tracer_com%ied
    jsd=g_tracer_com%jsd
    jed=g_tracer_com%jed
    isc=g_tracer_com%isc
    iec=g_tracer_com%iec
    jsc=g_tracer_com%jsc
    jec=g_tracer_com%jec
    nk =g_tracer_com%nk
    ntau=g_tracer_com%ntau
    if(present(axes))             axes = g_tracer_com%axes 
    if(present(init_time))        init_time=g_tracer_com%init_time
    if(present(grid_tmask))       grid_tmask => g_tracer_com%grid_tmask
    if(present(grid_mask_coast))  grid_mask_coast=> g_tracer_com%grid_mask_coast
    if(present(grid_kmt))         grid_kmt => g_tracer_com%grid_kmt
!    if(present(ice_restart_file)) ice_restart_file    = g_tracer_com%ice_restart_file
!    if(present(ocean_restart_file)) ocean_restart_file  = g_tracer_com%ocean_restart_file

  end subroutine g_tracer_get_common

  subroutine g_tracer_set_files(ice_restart_file,ocean_restart_file)
    character(len=*),   intent(in) :: ice_restart_file
    character(len=*),   intent(in) :: ocean_restart_file

    g_tracer_com%ice_restart_file    = ice_restart_file
    g_tracer_com%ocean_restart_file  = ocean_restart_file

  end subroutine g_tracer_set_files
    
  !Overload interface g_tracer_get_pointer for 4D fields

  subroutine g_tracer_get_4D(g_tracer_list,name,member,array_ptr)
    character(len=*),         intent(in) :: name
    character(len=*),         intent(in) :: member
    type(g_tracer_type),    pointer    :: g_tracer_list, g_tracer
    real, dimension(:,:,:,:), pointer    :: array_ptr

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_get_4D'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!
    !Find the node which has name=name
    call g_tracer_find(g_tracer,name)
    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list with name="//trim(name))

    select case(member)
    case ('field')
       if(associated(g_tracer%field)) then 
          array_ptr => g_tracer%field
       else
          call mpp_error(FATAL, trim(sub_name)//": Cannot get member variable: "//trim(name)//" % "//trim(member))
       endif
    case default 
       call mpp_error(FATAL, trim(sub_name)//": Not a known member variable: "//trim(name)//" % "//trim(member))   
    end select

  end subroutine g_tracer_get_4D

  !Overload interface g_tracer_get_pointer for 3D fields

  subroutine g_tracer_get_3D(g_tracer_list,name,member,array_ptr)
    character(len=*),         intent(in) :: name
    character(len=*),         intent(in) :: member
    type(g_tracer_type),    pointer    :: g_tracer_list, g_tracer
    real, dimension(:,:,:), pointer    :: array_ptr

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_get_3D'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!
    !Find the node which has name=name
    call g_tracer_find(g_tracer,name)
    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list with name="//trim(name))

    select case(member)
    case ('field') 
       if(associated(g_tracer%field3d_ptr)) then 
          array_ptr => g_tracer%field3d_ptr
       elseif(associated(g_tracer%field_3d)) then
          array_ptr => g_tracer%field_3d
       else
          call mpp_error(FATAL, trim(sub_name)//": Cannot get member variable: "//trim(name)//" % "//trim(member))
       endif
    case ('vmove') 
       array_ptr => g_tracer%vmove
    case ('vdiff') 
       array_ptr => g_tracer%vdiff
    case ('vdiffuse_impl') 
       array_ptr => g_tracer%vdiffuse_impl
    case default 
       call mpp_error(FATAL, trim(sub_name)//": Not a known member variable: "//trim(member))   
    end select

  end subroutine g_tracer_get_3D  

  !Overload interface g_tracer_get_pointer for 2D fields

  subroutine g_tracer_get_2D(g_tracer_list,name,member,array_ptr)
    character(len=*),         intent(in) :: name
    character(len=*),         intent(in) :: member
    type(g_tracer_type),    pointer    :: g_tracer_list, g_tracer
    real, dimension(:,:), pointer    :: array_ptr

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_get_4D'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!
    !Find the node which has name=name
    call g_tracer_find(g_tracer,name)
    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list with name="//trim(name))

    select case(member)
    case ('alpha') 
       array_ptr => g_tracer%alpha
    case ('csurf') 
       array_ptr => g_tracer%csurf
    case ('sc_no') 
       array_ptr => g_tracer%sc_no
    case ('stf') 
       array_ptr => g_tracer%stf
    case ('stf_gas') 
       array_ptr => g_tracer%stf_gas
    case ('deltap') 
       array_ptr => g_tracer%deltap
    case ('kw') 
       array_ptr => g_tracer%kw
    case ('btf') 
       array_ptr => g_tracer%btf
    case ('btm_reservoir') 
       array_ptr => g_tracer%btm_reservoir
    case ('trunoff') 
       array_ptr => g_tracer%trunoff
    case ('runoff_tracer_flux') 
       array_ptr => g_tracer%runoff_tracer_flux
    case ('drydep') 
       array_ptr => g_tracer%drydep
    case ('wetdep') 
       array_ptr => g_tracer%wetdep
    case default 
       call mpp_error(FATAL, trim(sub_name)//": Not a known member variable: "//trim(member))   
    end select

  end subroutine g_tracer_get_2D

  !Overload interface g_tracer_get_values for 4D fields

  subroutine g_tracer_get_4D_val(g_tracer_list,name,member,array,isd,jsd)
    character(len=*),         intent(in) :: name
    character(len=*),         intent(in) :: member
    type(g_tracer_type),    pointer    :: g_tracer_list, g_tracer 
    integer,                  intent(in) :: isd,jsd
    real, dimension(isd:,jsd:,:,:), intent(out):: array

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_get_4D_val'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!
    !Find the node which has name=name
    call g_tracer_find(g_tracer,name)
    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list with name="//trim(name))

    select case(member)
    case ('field') 
       if(associated(g_tracer%field)) then 
          array = g_tracer%field
       else
          call mpp_error(FATAL, trim(sub_name)//": Cannot get member variable: "//trim(name)//" % "//trim(member))
       endif
    case default 
       call mpp_error(FATAL, trim(sub_name)//": Not a known member variable: "//trim(name)//" % "//trim(member))   
    end select

  end subroutine g_tracer_get_4D_val

  !Overload interface g_tracer_get_values for 3D fields

  subroutine g_tracer_get_3D_val(g_tracer_list,name,member,array,isd,jsd,ntau,positive)
    character(len=*),         intent(in) :: name
    character(len=*),         intent(in) :: member
    type(g_tracer_type),    pointer    :: g_tracer_list, g_tracer 
    integer,                  intent(in) :: isd,jsd
    integer, optional,        intent(in) :: ntau
    logical, optional,        intent(in) :: positive
    real, dimension(isd:,jsd:,:), intent(out):: array
    integer :: tau
    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_get_3D_val'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!
    !Find the node which has name=name
    call g_tracer_find(g_tracer,name)
    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list with name="//trim(name))

    tau = 1
    if(present(ntau)) tau = ntau

    select case(member)
    case ('field') 
       if(associated(g_tracer%field)) then 
          array(:,:,:) = g_tracer%field(:,:,:,tau)
       elseif(associated(g_tracer%field3d_ptr)) then 
          array(:,:,:) = g_tracer%field3d_ptr(:,:,:)
       else
          call mpp_error(FATAL, trim(sub_name)//": Cannot get member variable: "//trim(name)//" % "//trim(member))
       endif
          
       if(present(positive)) array = max(0.0,array)
    case ('tendency') 
       array(:,:,:) = g_tracer%tendency(:,:,:)
    case ('vmove') 
       array(:,:,:) = g_tracer%vmove(:,:,:)
    case ('vdiff') 
       array(:,:,:) = g_tracer%vdiff(:,:,:)
    case ('vdiffuse_impl') 
       array(:,:,:) = g_tracer%vdiffuse_impl(:,:,:)
    case default 
       call mpp_error(FATAL, trim(sub_name)//": Not a known member variable: "//trim(member))   
    end select

  end subroutine g_tracer_get_3D_val

  !Overload interface g_tracer_get_values for 2D fields

  subroutine g_tracer_get_2D_val(g_tracer_list,name,member,array,isd,jsd)
    character(len=*),         intent(in) :: name
    character(len=*),         intent(in) :: member
    type(g_tracer_type),    pointer    :: g_tracer_list, g_tracer 
    integer,                  intent(in) :: isd,jsd
    real, dimension(isd:,jsd:), intent(out):: array

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_get_2D_val'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!
    !Find the node which has name=name
    call g_tracer_find(g_tracer,name)
    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list with name="//trim(name))

    select case(member)
    case ('alpha') 
       array = g_tracer%alpha
    case ('csurf') 
       array = g_tracer%csurf
    case ('sc_no') 
       array = g_tracer%sc_no
    case ('stf') 
       array = g_tracer%stf
    case ('stf_gas') 
       array = g_tracer%stf_gas
    case ('deltap') 
       array = g_tracer%deltap
    case ('kw') 
       array = g_tracer%kw
    case ('btf') 
       array = g_tracer%btf
    case ('btm_reservoir') 
       array = g_tracer%btm_reservoir
    case ('trunoff') 
       array = g_tracer%trunoff
    case ('runoff_tracer_flux') 
       array = g_tracer%runoff_tracer_flux
    case ('drydep') 
       array = g_tracer%drydep
    case ('wetdep') 
       array = g_tracer%wetdep
    case default 
       call mpp_error(FATAL, trim(sub_name)//": Not a known member variable: "//trim(member))   
    end select

  end subroutine g_tracer_get_2D_val

  !Overload interface g_tracer_get_values for 1D fields

  subroutine g_tracer_get_real(g_tracer_list,name,member,value)
    character(len=*),         intent(in) :: name
    character(len=*),         intent(in) :: member
    type(g_tracer_type),    pointer    :: g_tracer_list, g_tracer 
    real,                     intent(out):: value

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_get_real'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!
    !Find the node which has name=name
    call g_tracer_find(g_tracer,name)
    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list with name="//trim(name))

    select case(member)
    case ('sink_rate') 
       value = g_tracer%sink_rate
    case ('const_init_value') 
       value = g_tracer%const_init_value
    case default 
       call mpp_error(FATAL, trim(sub_name)//": Not a known member variable: "//trim(member))   
    end select

  end subroutine g_tracer_get_real

  !Overload interface g_tracer_get_values for string members

  subroutine g_tracer_get_string(g_tracer_list,name,member,string)
    character(len=*),         intent(in) :: name
    character(len=*),         intent(in) :: member
    type(g_tracer_type),    pointer    :: g_tracer_list, g_tracer 
    character(len=fm_string_len), intent(out) :: string
    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_get_string'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!

    !If queried for 'name' return the %name of the head 
    if(member .eq. 'name') then
       string=g_tracer%name
       return
    endif

    !Find the node which has name=name
    call g_tracer_find(g_tracer,name)
    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list with name="//trim(name))

    select case(member)
    case ('longname') 
       string = g_tracer%longname
    case ('alias') 
       string = g_tracer%alias
    case ('units') 
       string = g_tracer%units
    case ('package') 
       string = g_tracer%package_name
    case ('ocean_restart_file') 
       string = g_tracer%ocean_restart_file
    case default 
       call mpp_error(FATAL, trim(sub_name)//": Not a known member variable: "//trim(member))   
    end select

  end subroutine g_tracer_get_string

  !Overload interface g_tracer_set_values for 2D fields

  subroutine g_tracer_set_2D(g_tracer_list,name,member,array,isd,jsd)
    character(len=*),         intent(in) :: name
    character(len=*),         intent(in) :: member
    type(g_tracer_type),    pointer    :: g_tracer_list, g_tracer
    integer,                  intent(in) :: isd,jsd
    real, dimension(isd:,jsd:),intent(in) :: array

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_set_2D'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!

    !Find the node which has name=name
    call g_tracer_find(g_tracer,name)
    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list with name="//trim(name))

    select case(member)
    case ('alpha') 
       g_tracer%alpha  = array 
    case ('csurf')
       g_tracer%csurf  = array
    case ('sc_no')
       g_tracer%sc_no  = array
    case ('stf') 
       g_tracer%stf    = array
    case ('stf_gas') 
       g_tracer%stf_gas= array
    case ('deltap') 
       g_tracer%deltap = array
    case ('kw') 
       g_tracer%kw     = array
    case ('btf') 
       g_tracer%btf    = array
    case ('btm_reservoir') 
       g_tracer%btm_reservoir = array
    case ('trunoff')
       g_tracer%trunoff = array
    case ('runoff_tracer_flux')
       g_tracer%runoff_tracer_flux = array
    case ('drydep')
       g_tracer%drydep = array
    case ('wetdep')
       g_tracer%wetdep = array
    case default 
       call mpp_error(FATAL, trim(sub_name)//": Not a known member variable: "//trim(member))   
    end select

  end subroutine g_tracer_set_2D

  !Overload interface g_tracer_set_values for 3D fields

  subroutine g_tracer_set_3D(g_tracer_list,name,member,array,isd,jsd,ntau)
    character(len=*),         intent(in) :: name
    character(len=*),         intent(in) :: member
    type(g_tracer_type),    pointer    :: g_tracer_list, g_tracer
    integer,                  intent(in) :: isd,jsd
    integer, optional,        intent(in) :: ntau
    real, dimension(isd:,jsd:,:), intent(in)       :: array
    integer :: tau

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_set_3D'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!

    !Find the node which has name=name
    call g_tracer_find(g_tracer,name)
    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list with name="//trim(name))

    tau = 1
    if(present(ntau)) tau = ntau

    select case(member)
    case ('tendency') 
       g_tracer%tendency  = array 
    case ('field') 
       if(associated(g_tracer%field)) then 
          g_tracer%field(:,:,:,tau) = array(:,:,:) 
       elseif(associated(g_tracer%field3d_ptr)) then 
          g_tracer%field3d_ptr(:,:,:) = array(:,:,:) 
       else
          call mpp_error(FATAL, trim(sub_name)//": Cannot set member variable: "//trim(name)//" % "//trim(member))
       endif      
    case ('vmove') 
       g_tracer%vmove  = array 
    case ('vdiff') 
       g_tracer%vdiff  = array 
    case ('vdiffuse_impl') 
       g_tracer%vdiffuse_impl  = array 
    case default 
       call mpp_error(FATAL, trim(sub_name)//": Not a known member variable: "//trim(member))   
    end select

  end subroutine g_tracer_set_3D

  !Overload interface g_tracer_set_values for 4D fields

  subroutine g_tracer_set_4D(g_tracer_list,name,member,array,isd,jsd)
    character(len=*),         intent(in) :: name
    character(len=*),         intent(in) :: member
    type(g_tracer_type),    pointer    :: g_tracer_list, g_tracer
    integer,                  intent(in) :: isd,jsd
    real, dimension(isd:,jsd:,:,:), intent(in)       :: array

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_set_4D'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!

    !Find the node which has name=name
    call g_tracer_find(g_tracer,name)
    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list with name="//trim(name))

    select case(member)
    case ('field')
       if(associated(g_tracer%field)) then
          g_tracer%field = array
       else
          call mpp_error(FATAL, trim(sub_name)//": Cannot set member variable: "//trim(name)//" % "//trim(member))
       endif
    case default 
       call mpp_error(FATAL, trim(sub_name)//": Not a known member variable: "//trim(member))   
    end select

  end subroutine g_tracer_set_4D

  !Overload interface g_tracer_set_values for 1D fields

  subroutine g_tracer_set_real(g_tracer_list,name,member,value)
    character(len=*),         intent(in) :: name
    character(len=*),         intent(in) :: member
    type(g_tracer_type),    pointer    :: g_tracer_list, g_tracer
    real,                     intent(in) :: value

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_set_real'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!

    !Find the node which has name=name
    call g_tracer_find(g_tracer,name)
    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list with name="//trim(name))

    select case(member)
    case ('field') 
       if(associated(g_tracer%field)) then
          g_tracer%field = value !Set all elements to value
       else
          call mpp_error(FATAL, trim(sub_name)//": Cannot set member variable: "//trim(name)//" % "//trim(member))
       endif
    case ('tendency') 
       g_tracer%tendency  = value 
    case ('alpha') 
       g_tracer%alpha     = value 
    case ('csurf') 
       g_tracer%csurf     = value 
    case ('sc_no') 
       g_tracer%sc_no     = value 
    case ('stf') 
       g_tracer%stf       = value 
    case ('stf_gas') 
       g_tracer%stf_gas   = value 
    case ('deltap') 
       g_tracer%deltap    = value 
    case ('kw') 
       g_tracer%kw        = value 
    case ('btf') 
       g_tracer%btf       = value 
    case ('trunoff') 
       g_tracer%trunoff   = value 
    case ('runoff_tracer_flux') 
       g_tracer%runoff_tracer_flux = value 
    case ('btm_reservoir') 
       g_tracer%btm_reservoir = value 
    case ('sink_rate') 
       g_tracer%sink_rate = value 
    case default 
       call mpp_error(FATAL, trim(sub_name)//": Not a known member variable: "//trim(member))   
    end select

  end subroutine g_tracer_set_real

  subroutine g_tracer_set_pointer_4D(g_tracer_list,name,member,array,ilb,jlb)
    character(len=*),               intent(in) :: name
    character(len=*),               intent(in) :: member
    type(g_tracer_type),            pointer    :: g_tracer_list, g_tracer
    integer,                        intent(in) :: ilb,jlb
    real, dimension(ilb:,jlb:,:,:), target, intent(in) :: array

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_set_pointer_4D'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!

    !Find the node which has name=name
    call g_tracer_find(g_tracer,name)
    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list with name="//trim(name))

    select case(member)
    case ('field') 
       if (associated(g_tracer%field )) then
          call mpp_error(NOTE, trim(sub_name) // ": Deallocating generic tracer "//trim(name)//" % "//trim(member))
          deallocate( g_tracer%field )
       endif
       g_tracer%field  => array 
    case default 
       call mpp_error(FATAL, trim(sub_name)//": Not a supported operation for member variable: "//trim(name)//" % "//trim(member))
    end select

  end subroutine g_tracer_set_pointer_4D

  subroutine g_tracer_set_pointer_3D(g_tracer_list,name,member,array,ilb,jlb)
    character(len=*),               intent(in) :: name
    character(len=*),               intent(in) :: member
    type(g_tracer_type),            pointer    :: g_tracer_list, g_tracer
    integer,                        intent(in) :: ilb,jlb
    real, dimension(ilb:,jlb:,:), target, intent(in) :: array
    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_set_pointer_3D'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!

    !Find the node which has name=name
    call g_tracer_find(g_tracer,name)
    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list with name="//trim(name))

    select case(member)
    case ('tendency') 
       if (associated( g_tracer%tendency )) then
          call mpp_error(NOTE, trim(sub_name) // ": Deallocating generic tracer "//trim(name)//" % "//trim(member))
          deallocate( g_tracer%tendency )
       endif
       g_tracer%tendency  => array 
    case ('field') 
       if (associated( g_tracer%field )) then
          call mpp_error(NOTE, trim(sub_name) // ": Deallocating generic tracer "//trim(name)//" % "//trim(member))
          deallocate( g_tracer%field )
       endif
       g_tracer%field3d_ptr  => array 
!       call set_cray_pointer_field(g_tracer%field,array,ilb,jlb)

    case default 
       call mpp_error(FATAL, trim(sub_name)//": Not a supported operation for member variable: "//trim(name)//" % "//trim(member))   
    end select

  end subroutine g_tracer_set_pointer_3D

  !The following does not compile:
  !error #6406: Conflicting attributes or multiple declaration of name.   [FIELD]
  !  pointer(ptr,field)
  !----------------^

!  subroutine set_cray_pointer_field(field,array,ilb,jlb)
!    real, dimension(:,:,:,:), intent(inout)     ::  field
!    integer,                        intent(in) :: ilb,jlb
!    real, dimension(ilb:,jlb:,:), target, intent(in) :: array
!
!    pointer(ptr,field)
!
!    ptr = LOC(array)
!
!  end subroutine set_cray_pointer_field


  ! <SUBROUTINE NAME="g_tracer_find">
  !  <OVERVIEW>
  !   Get the pointer for the named tracer node
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_find(g_tracer,name)
  !  </TEMPLATE>
  !  <IN/OUT NAME="g_tracer" TYPE="type(g_tracer_type),    pointer">
  !   Head of the generic tracer list.
  !   Upon return this will be a pointer to the tracer node called name or NULL if not found 
  !  </IN/OUT>
  !  <IN NAME="name" TYPE="character(len=*)">
  !   Name of a tracer node
  !  </IN>
  ! </SUBROUTINE>


  subroutine g_tracer_find(g_tracer,name)
    character(len=*),         intent(in) :: name
    type(g_tracer_type),    pointer    :: g_tracer

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_find'

    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    !Go through the list of tracers 
    do  
       if(g_tracer%name == name .or. g_tracer%alias == name) exit

       !traverse the linked list till hit NULL
       if(.NOT. associated(g_tracer%next)) then
          g_tracer => NULL() ! name Not found.
          exit
       endif

       g_tracer => g_tracer%next
    enddo
  end subroutine g_tracer_find
  

!#######################################################################
  ! <SUBROUTINE NAME="g_tracer_column_int">
  !  <OVERVIEW>
  !   Calculate the column interval for a given variable
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Calculate the column interval for a given variable
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_column_int(depth, ilb, jlb, var, dzt, rho_dzt, rd, k_level, integral, caller)
  !  </TEMPLATE>
  !  <IN NAME="depth" TYPE="real">
  !   Depth over which to integrate
  !  </IN>
  !  <IN NAME="ilb" TYPE="integer">
  !   Lower bound of 1st dimension of arrays
  !  </IN>
  !  <IN NAME="jlb" TYPE="integer">
  !   Lower bound of 2nd dimension of arrays
  !  </IN>
  !  <IN NAME="var" TYPE="real(:,:,:)">
  !   Variable to integrate
  !  </IN>
  !  <IN NAME="dzt" TYPE="real(:,:,:)">
  !   Layer thicknesses
  !  </IN>
  !  <IN NAME="rho_dzt" TYPE="real(:,:,:)">
  !   Density times layer thicknesses
  !  </IN>
  !  <INOUT NAME="rd" TYPE="real(:,:,:)">
  !   Work array: rho_dzt to be multiplied by var to do the integral (may be used in subsequent calls)
  !  </INOUT>
  !  <INOUT NAME="k_level" TYPE="integer">
  !   K level for maximum depth to perform the integral, if 0 then calculate rd array (may be used in subsequent calls)
  !   If set greater than 0, then the work array can be used in subsequent calls for the same depth to save some
  !   computation. Care should be taken that if k_level is set > 0 that the same depth range is used.
  !  </INOUT>
  !  <OUT NAME="integral" TYPE="real(:,:,:)">
  !   Integral of var over depth
  !  </OUT>
  !  <IN NAME="caller" TYPE="character(len=*), optional">
  !   string indicating caller of this routine, for traceback
  !  </IN>
  ! </SUBROUTINE>

  subroutine g_tracer_column_int(depth, ilb, jlb, var, dzt, rho_dzt, rd, k_level, integral, caller)

    real,                         intent(in)            :: depth
    integer,                      intent(in)            :: ilb
    integer,                      intent(in)            :: jlb
    real, dimension(ilb:,jlb:,:), intent(in)            :: var
    real, dimension(ilb:,jlb:,:), intent(in)            :: dzt
    real, dimension(ilb:,jlb:,:), intent(in)            :: rho_dzt
    real, dimension(ilb:,jlb:,:), intent(inout)         :: rd
    integer,                      intent(inout)         :: k_level
    real, dimension(ilb:,jlb:),   intent(out)           :: integral
    character(len=*),             intent(in), optional  :: caller

!-----------------------------------------------------------------------
!     local parameters

    character(len=fm_string_len), parameter     :: sub_name = 'g_tracer_column_int'

    character(len=256)                          :: caller_str
    character(len=256)                          :: error_header
    character(len=256)                          :: warn_header
    character(len=256)                          :: note_header
    integer                                     :: isc
    integer                                     :: iec
    integer                                     :: jsc
    integer                                     :: jec
    integer                                     :: isd
    integer                                     :: ied
    integer                                     :: jsd
    integer                                     :: jed
    integer                                     :: nk
    integer                                     :: ntau
    real,    dimension(:,:,:), pointer          :: grid_tmask
    integer                                     :: i
    integer                                     :: j
    integer                                     :: k 
    logical                                     :: continue_calc
    real, dimension(:,:), allocatable           :: depth_x
    
    !  Set up the headers for stdout messages.

    if (present(caller)) then
      caller_str = trim(mod_name) // '(' // trim(sub_name) // ')[' // trim(caller) // ']'
    else
      caller_str = trim(mod_name) // '(' // trim(sub_name) // ')[]'
    endif
    error_header = '==> Error from '   // trim(caller_str) // ':'
    warn_header =  '==> Warning from ' // trim(caller_str) // ':'
    note_header =  '==> Note from '    // trim(caller_str) // ':'

    !
    ! Check the depth
    !

    if (depth .le. 0.0) then
      call mpp_error(FATAL, trim(error_header) // ' Depth <= 0,0')
    endif

    !  Set up the module if not already done

    call g_tracer_get_common(isc, iec, jsc, jec, isd, ied, jsd, jed, nk, ntau,  &
         grid_tmask = grid_tmask)

    !
    ! Check the k_level
    !

    if (k_level .gt. nk) then
      call mpp_error(FATAL, trim(error_header) // ' k_level > nk')
    endif

    !
    !   Calculate the integral
    !

    if (k_level .le. 0) then  !{
      allocate (depth_x(isd:ied,jsd:jed))
      depth_x(:,:) = depth
      rd(:,:,:) = 0.0
      do k = 1, nk  !}
        continue_calc = .false.
        do j = jsc, jec  !{
          do i = isc, iec  !{
            if (grid_tmask(i,j,k) .gt. 0.5 .and. depth_x(i,j) .gt. 0.0) then  !{
              k_level = k
              if (depth_x(i,j) .gt. dzt(i,j,k)) then  !{
                continue_calc = .true.
                rd(i,j,k) = rho_dzt(i,j,k)
                depth_x(i,j) = depth_x(i,j) - dzt(i,j,k)
              else  !}{
                rd(i,j,k) = depth_x(i,j) / dzt(i,j,k) * rho_dzt(i,j,k)
                depth_x(i,j) = 0.0
              endif  !}
            endif  !}
          enddo  !} i
        enddo  !} j
        if (.not. continue_calc) then
          exit
        endif
      enddo  !} k
      deallocate (depth_x)
    endif  !}

    integral(:,:) = 0.0
    do k = 1, k_level  !}
      do j = jsc, jec  !{
        do i = isc, iec  !{
          integral(i,j) = integral(i,j) + var(i,j,k) * rd(i,j,k)
        enddo  !} i
      enddo  !} j
    enddo  !} k
            
    return

  end subroutine g_tracer_column_int
  

!#######################################################################
  ! <SUBROUTINE NAME="g_tracer_flux_at_depth">
  !  <OVERVIEW>
  !   Calculate the column interval for a given variable
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Calculate the column interval for a given variable
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_flux_at_depth(depth, ilb, jlb, var, dzt, k_level, frac, initialized, flux, caller)
  !  </TEMPLATE>
  !  <IN NAME="depth" TYPE="real">
  !   Depth over which to integrate
  !  </IN>
  !  <IN NAME="ilb" TYPE="integer">
  !   Lower bound of 1st dimension of arrays
  !  </IN>
  !  <IN NAME="jlb" TYPE="integer">
  !   Lower bound of 2nd dimension of arrays
  !  </IN>
  !  <IN NAME="var" TYPE="real(:,:,:)">
  !   Variable to integrate
  !  </IN>
  !  <IN NAME="dzt" TYPE="real(:,:,:)">
  !   Layer thicknesses
  !  </IN>
  !  <INOUT NAME="k_level" TYPE="real(:,:)">
  !   Work array: array of k level for each grid point at which depth occurs (may be used in future calls)
  !  </INOUT>
  !  <INOUT NAME="frac" TYPE="real(:,:)">
  !   Work array: fraction of level at which depth occurs (may be used in future calls)
  !  </INOUT>
  !  <INOUT NAME="initialized" TYPE="logical">
  !   True if the arrays have been initialized from a previous call, set to true in subroutine.
  !   If true, then the work arrays can be used in subsequent calls for the same depth to save some
  !   computation. Care should be taken that if iniitialized is set to true that the same depth range is used.
  !  </INOUT>
  !  <OUT NAME="flux" TYPE="real(:,:)">
  !   Flux at specified depth
  !  </OUT>
  !  <IN NAME="caller" TYPE="character(len=*), optional">
  !   string indicating caller of this routine, for traceback
  !  </IN>
  ! </SUBROUTINE>

  subroutine g_tracer_flux_at_depth(depth, ilb, jlb, var, dzt, k_level, frac, initialized, flux, caller)

    real,                            intent(in)                 :: depth
    integer,                         intent(in)                 :: ilb
    integer,                         intent(in)                 :: jlb
    real,    dimension(ilb:,jlb:,:), intent(in)                 :: var
    real,    dimension(ilb:,jlb:,:), intent(in)                 :: dzt
    integer, dimension(ilb:,jlb:),   intent(inout)              :: k_level
    real,    dimension(ilb:,jlb:),   intent(inout)              :: frac
    logical,                         intent(inout)              :: initialized
    real,    dimension(ilb:,jlb:),   intent(out)                :: flux
    character(len=*),                intent(in),    optional    :: caller

!-----------------------------------------------------------------------
!     local parameters

    character(len=fm_string_len), parameter     :: sub_name = 'g_tracer_flux_at_depth'

    character(len=256)                          :: caller_str
    character(len=256)                          :: error_header
    character(len=256)                          :: warn_header
    character(len=256)                          :: note_header
    integer                                     :: isc
    integer                                     :: iec
    integer                                     :: jsc
    integer                                     :: jec
    integer                                     :: isd
    integer                                     :: ied
    integer                                     :: jsd
    integer                                     :: jed
    integer                                     :: nk
    integer                                     :: ntau
    real,    dimension(:,:,:), pointer          :: grid_tmask
    integer                                     :: i
    integer                                     :: j
    integer                                     :: k 
    real, dimension(:,:), allocatable           :: depth_x
    logical                                     :: continue_calc
    
    !  Set up the headers for stdout messages.

    if (present(caller)) then
      caller_str = trim(mod_name) // '(' // trim(sub_name) // ')[' // trim(caller) // ']'
    else
      caller_str = trim(mod_name) // '(' // trim(sub_name) // ')[]'
    endif
    error_header = '==> Error from '   // trim(caller_str) // ':'
    warn_header =  '==> Warning from ' // trim(caller_str) // ':'
    note_header =  '==> Note from '    // trim(caller_str) // ':'

    !
    ! Check the depth
    !

    if (depth .le. 0.0) then
      call mpp_error(FATAL, trim(error_header) // ' Depth <= 0,0')
    endif

    !  Set up the module if not already done

    call g_tracer_get_common(isc, iec, jsc, jec, isd, ied, jsd, jed, nk, ntau,  &
         grid_tmask = grid_tmask)

    !
    !   Calculate the flux
    !

    if (.not. initialized) then  !{
      allocate (depth_x(isd:ied,jsd:jed))
      depth_x(:,:) = depth
      frac(:,:) = 0.0
      k_level(:,:) = 0
      do k = 1, nk  !{
        continue_calc = .false.
        do j = jsc, jec  !{
          do i = isc, iec  !{
            if (grid_tmask(i,j,k) .gt. 0.5 .and. depth_x(i,j) .gt. 0.0) then  !{
              if (depth_x(i,j) .gt. dzt(i,j,k)) then  !{
                continue_calc = .true.
                depth_x(i,j) = depth_x(i,j) - dzt(i,j,k)
              else  !}{
                frac(i,j) = depth_x(i,j) / dzt(i,j,k)
                k_level(i,j) = k
                depth_x(i,j) = 0.0
              endif  !}
            endif  !}
          enddo  !} i
        enddo  !} j
        if (.not. continue_calc) then
          exit
        endif
      enddo  !} k
      deallocate (depth_x)
    endif  !}
    initialized = .true.

    flux(:,:) = 0.0
    do j = jsc, jec  !{
      do i = isc, iec  !{
        if (k_level(i,j) .gt. 0) then  !{
          k = k_level(i,j)
          if (k .eq. 1) then
            flux(i,j) = frac(i,j) * var(i,j,k)
          else
            flux(i,j) = (1.0 - frac(i,j)) * var(i,j,k-1) + frac(i,j) * var(i,j,k)
          endif
        endif  !}
      enddo  !} i
    enddo  !} j
            
    return

  end subroutine g_tracer_flux_at_depth


  ! <SUBROUTINE NAME="g_tracer_send_diag">
  !  <OVERVIEW>
  !   Send diagnostics for all registered fields (if in diag_table)
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Collectively sends out the diagnostics for all registered fields of all generic tracers
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_send_diag(g_tracer_list,model_time , tau)
  !  </TEMPLATE>
  !  <IN NAME="g_tracer_list" TYPE="type(g_tracer_type),    pointer">
  !   pointer to the head of the generic tracer list
  !  </IN>
  !  <IN NAME="model_time" TYPE="type(time_type)">
  !   Time that the diagnostics is sent
  !  </IN>
  !  <IN NAME="tau" TYPE="integer">
  !   The time step for the %field 4D field to be reported
  !  </IN>
  ! </SUBROUTINE>

  subroutine g_tracer_send_diag(g_tracer_list,model_time,tau)
    type(g_tracer_type),    pointer    :: g_tracer_list, g_tracer
    type(time_type),          intent(in) :: model_time
    integer,                  intent(in) :: tau
    integer :: tau_1
    logical :: used

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_send_diag'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!

    !Go through the list of tracers 
    do  
       tau_1=tau
       if (g_tracer%diag_id_field .gt. 0) then
          if(.NOT. g_tracer_is_prog(g_tracer)) tau_1=1

       if(associated(g_tracer%field)) then 
          used = send_data(g_tracer%diag_id_field, g_tracer%field(:,:,:,tau_1), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,:),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc, ks_in=1,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec, ke_in=g_tracer_com%nk)
       elseif(associated(g_tracer%field3d_ptr)) then 
          used = send_data(g_tracer%diag_id_field, g_tracer%field3d_ptr(:,:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,:),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc, ks_in=1,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec, ke_in=g_tracer_com%nk)

       else
          call mpp_error(FATAL, trim(sub_name)//": Cannot send_diag field variable for "//trim(g_tracer%name) )
       endif      


       endif

       if (g_tracer%diag_id_vmove .gt. 0 .and. _ALLOCATED(g_tracer%vmove)) then
          used = send_data(g_tracer%diag_id_vmove, g_tracer%vmove(:,:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,:),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc, ks_in=1,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec, ke_in=g_tracer_com%nk)
       endif

       if (g_tracer%diag_id_vdiff .gt. 0 .and. _ALLOCATED(g_tracer%vdiff)) then
          used = send_data(g_tracer%diag_id_vdiff, g_tracer%vdiff(:,:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,:),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc, ks_in=1,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec, ke_in=g_tracer_com%nk)
       endif

       if (g_tracer%diag_id_aux .gt. 0) then
          used = send_data(g_tracer%diag_id_aux, g_tracer%tendency(:,:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,:),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc, ks_in=1,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec, ke_in=g_tracer_com%nk)
       endif

       if (g_tracer%diag_id_stf .gt. 0 .and. _ALLOCATED(g_tracer%stf)) then
          used = send_data(g_tracer%diag_id_stf, g_tracer%stf(:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,1),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec )
       endif

       if (g_tracer%diag_id_stf_gas .gt. 0 .and. _ALLOCATED(g_tracer%stf_gas)) then
          used = send_data(g_tracer%diag_id_stf_gas, g_tracer%stf_gas(:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,1),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec )
       endif

       if (g_tracer%diag_id_deltap .gt. 0 .and. _ALLOCATED(g_tracer%deltap)) then
          used = send_data(g_tracer%diag_id_deltap, g_tracer%deltap(:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,1),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec )
       endif

       if (g_tracer%diag_id_kw .gt. 0 .and. _ALLOCATED(g_tracer%kw)) then
          used = send_data(g_tracer%diag_id_kw, g_tracer%kw(:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,1),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec )
       endif

       if (g_tracer%diag_id_btf .gt. 0 .and. _ALLOCATED(g_tracer%btf)) then
          used = send_data(g_tracer%diag_id_btf, g_tracer%btf(:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,1),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec )
       endif

       if (g_tracer%diag_id_btm .gt. 0 .and. _ALLOCATED(g_tracer%btm_reservoir)) then
          used = send_data(g_tracer%diag_id_btm, g_tracer%btm_reservoir(:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,1),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec )
       endif

       if (g_tracer%diag_id_trunoff .gt. 0 .and. _ALLOCATED(g_tracer%trunoff)) then
          used = send_data(g_tracer%diag_id_trunoff, g_tracer%trunoff(:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,1),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec )
       endif

       if (g_tracer%diag_id_alpha .gt. 0 .and. _ALLOCATED(g_tracer%alpha)) then
          used = send_data(g_tracer%diag_id_alpha, g_tracer%alpha(:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,1),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec )
       endif

       if (g_tracer%diag_id_csurf .gt. 0 .and. _ALLOCATED(g_tracer%csurf)) then
          used = send_data(g_tracer%diag_id_csurf, g_tracer%csurf(:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,1),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec )
       endif

       if (g_tracer%diag_id_sc_no .gt. 0 .and. _ALLOCATED(g_tracer%sc_no)) then
          used = send_data(g_tracer%diag_id_sc_no, g_tracer%sc_no(:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,1),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec )
       endif

       !traverse the linked list till hit NULL
       if(.NOT. associated(g_tracer%next)) exit
       g_tracer => g_tracer%next
    enddo

  end subroutine g_tracer_send_diag


  ! <SUBROUTINE NAME="g_tracer_diag">
  !  <OVERVIEW>
  !   Send diagnostics for all registered fields at finish (if in diag_table)
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   Collectively sends out the diagnostics for all registered fields of all generic tracers
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_diag(g_tracer_list,model_time , tau)
  !  </TEMPLATE>
  !  <IN NAME="g_tracer_list" TYPE="type(g_tracer_type),    pointer">
  !   pointer to the head of the generic tracer list
  !  </IN>
  !  <IN NAME="model_time" TYPE="type(time_type)">
  !   Time that the diagnostics is sent
  !  </IN>
  !  <IN NAME="tau" TYPE="integer">
  !   The time step for the %field 4D field to be reported
  !  </IN>
  ! </SUBROUTINE>

  subroutine g_tracer_diag(g_tracer_list, ilb, jlb, rho_dzt_tau, rho_dzt_taup1, model_time, tau, taup1, dtts)
    type(g_tracer_type),    pointer    :: g_tracer_list
    integer,                  intent(in) :: ilb
    integer,                  intent(in) :: jlb
    real, dimension(ilb:,jlb:,:),   intent(in) :: rho_dzt_tau
    real, dimension(ilb:,jlb:,:),   intent(in) :: rho_dzt_taup1
    type(time_type),          intent(in) :: model_time
    integer,                  intent(in) :: tau
    integer,                  intent(in) :: taup1
    real,                     intent(in) :: dtts

    type(g_tracer_type),    pointer    :: g_tracer
    integer :: tau_1
    logical :: used

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_diag'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!

    !Go through the list of tracers 
    do  
       tau_1=taup1
       if (g_tracer%diag_id_field_taup1 .gt. 0) then
          if(.NOT. g_tracer_is_prog(g_tracer)) tau_1=1
          used = send_data(g_tracer%diag_id_field_taup1, g_tracer%field(:,:,:,tau_1), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,:),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc, ks_in=1,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec, ke_in=g_tracer_com%nk)
       endif

       if (g_tracer%diag_id_tendency .gt. 0  .and. g_tracer%prog) then
          used = send_data(g_tracer%diag_id_tendency,&
               (g_tracer%field(:,:,:,taup1)*rho_dzt_taup1(:,:,:) - g_tracer%field(:,:,:,tau)*rho_dzt_tau(:,:,:))/dtts, model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,:),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc, ks_in=1,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec, ke_in=g_tracer_com%nk)
       endif

       if (g_tracer%diag_id_vdiffuse_impl .gt. 0 .and. _ALLOCATED(g_tracer%vdiffuse_impl)) then
          used = send_data(g_tracer%diag_id_vdiffuse_impl, g_tracer%vdiffuse_impl(:,:,:), model_time,&
               rmask = g_tracer_com%grid_tmask(:,:,:),& 
               is_in=g_tracer_com%isc, js_in=g_tracer_com%jsc, ks_in=1,&
               ie_in=g_tracer_com%iec, je_in=g_tracer_com%jec, ke_in=g_tracer_com%nk)
       endif

       !traverse the linked list till hit NULL
       if(.NOT. associated(g_tracer%next)) exit
       g_tracer => g_tracer%next
    enddo

  end subroutine g_tracer_diag


  subroutine g_tracer_traverse(g_tracer_list)
    type(g_tracer_type),    pointer    :: g_tracer_list, g_tracer 

    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_traverse'

    if(.NOT. associated(g_tracer_list)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer => g_tracer_list !Local pointer. Do not change the input pointer!

    !Go through the list of tracers 
    do  
       !do nothing
       !traverse the linked list till hit NULL
       if(.NOT. associated(g_tracer%next)) exit
       g_tracer => g_tracer%next
    enddo

  end subroutine g_tracer_traverse

  !
  !The following subroutines work with individual tracer nodes
  !
  ! <SUBROUTINE NAME="g_tracer_get_name">
  !  <OVERVIEW>
  !   Get the name of a particular tracer Node
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_get_name(g_tracer,string)
  !  </TEMPLATE>
  !  <IN NAME="g_tracer" TYPE="type(g_tracer_type),    pointer">
  !   Pointer to tracer node
  !  </IN>
  !  <IN NAME="string" TYPE="character(len=*)">
  !   Name of the tracer upon return
  !  </IN>
  ! </SUBROUTINE>

  subroutine g_tracer_get_name(g_tracer,string)
    type(g_tracer_type),    pointer    :: g_tracer 
    character(len=*),        intent(out) :: string
    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_get_name'

    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    string=g_tracer%name
  end subroutine g_tracer_get_name

  subroutine g_tracer_get_alias(g_tracer,string)
    type(g_tracer_type),    pointer    :: g_tracer 
    character(len=*),        intent(out) :: string
    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_get_alias'

    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    string=g_tracer%alias
  end subroutine g_tracer_get_alias

  ! <SUBROUTINE NAME="g_tracer_is_prog">
  !  <OVERVIEW>
  !   Is the tracer prognostic?
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   flag = g_tracer_is_prog(g_tracer)  
  !  </TEMPLATE>
  !  <IN NAME="g_tracer" TYPE="type(g_tracer_type),    pointer">
  !   Pointer to tracer node
  !  </IN>
  !  RETURNS .true. for prognostic tracer, .false. for diagnostic
  ! </SUBROUTINE>
  function g_tracer_is_prog(g_tracer) 
    logical :: g_tracer_is_prog
    type(g_tracer_type),    pointer    :: g_tracer 
    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_is_prog'

    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer_is_prog=g_tracer%prog
  end function g_tracer_is_prog

  ! <SUBROUTINE NAME="g_tracer_get_next">
  !  <OVERVIEW>
  !   get the next tracer in the list
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call g_tracer_get_next(g_tracer,g_tracer_next)
  !  </TEMPLATE>
  !  <IN NAME="g_tracer" TYPE="type(g_tracer_type),    pointer">
  !   Pointer to tracer node
  !  </IN>
  !  <IN NAME="g_tracer_next" TYPE="type(g_tracer_type),    pointer">
  !   Pointer to the next tracer node in the list
  !  </IN>
  ! </SUBROUTINE>
  subroutine g_tracer_get_next(g_tracer,g_tracer_next)
    type(g_tracer_type),    pointer    :: g_tracer,g_tracer_next 
    character(len=fm_string_len), parameter :: sub_name = 'g_tracer_get_next'

    if(.NOT. associated(g_tracer)) call mpp_error(FATAL, trim(sub_name)//&
         ": No tracer in the list.")

    g_tracer_next => g_tracer%next
  end subroutine g_tracer_get_next

  ! <SUBROUTINE NAME="g_tracer_vertdiff_G">
  !  <OVERVIEW>
  !   Vertical Diffusion of a tracer node
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   This subroutine solves a tridiagonal equation to find and set values of vertically diffused field for a tracer node.
  !   This is ported from GOLD (vertdiff) and simplified
  !   Since the surface flux from the atmosphere (%stf) has the units of mol/m^2/sec the resulting tracer concentration
  !   has units of mol/Kg
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call 
  !  </TEMPLATE>
  !  <IN NAME="" TYPE="">
  !   
  !  </IN>
  ! </SUBROUTINE>

  subroutine g_tracer_vertdiff_G(g_tracer, h_old, ea, eb, dt, kg_m2_to_H, m_to_H, tau, mom)
    type(g_tracer_type),    pointer  :: g_tracer
    real, dimension(g_tracer_com%isd:,g_tracer_com%jsd:,:), intent(in) :: h_old, ea, eb
    real,                   intent(in) :: dt, kg_m2_to_H, m_to_H
    integer,                intent(in) :: tau
    logical,                                                intent(in), optional :: mom

    ! Arguments: h_old -  Layer thickness before entrainment, in m or kg m-2.
    !                     In all the following comments the units of h_old are
    !                     denoted as H.
    !  (in)      ea - The amount of fluid entrained from the layer above, in H.
    !  (in)      eb - The amount of fluid entrained from the layer below, in H.
    !  (in)      dt - The amount of time covered by this call, in s.
    !  (in)      kg_m2_to_H - A conversion factor that translates kg m-2 into
    !                         the units of h_old (H).
    !  (in)      m_to_H - A conversion factor that translates m into the units
    !                     of h_old (H).
    !  (in,opt)  mom - If true, then called from MOM and don't do diagnostic,
    !                  if false or not present, then not from MOM and do diagnostics.

    !   This subroutine solves a tridiagonal equation for the final tracer
    ! concentrations after the dual-entrainments, and possibly sinking or surface
    ! and bottom sources, are applied.  The sinking is implemented with an
    ! fully implicit upwind advection scheme.

    real :: sink_dist(1:g_tracer_com%nk+1)    ! The distance the tracer sinks in a time step, in H.
    real :: sfc_src      ! The time-integrated surface source of the tracer, in
    ! units of H times a concentration.
    real :: btm_src      ! The time-integrated bottom source of the tracer, in
    ! units of H times a concentration.
    real :: b1           ! b1 is used by the tridiagonal solver, in H-1.
    real :: d1           ! d1=1-c1 is used by the tridiagonal solver, nondimensional.
    real :: c1(1:g_tracer_com%nk)     ! c1 is used by the tridiagonal solver, ND.
    real :: h_minus_dsink(1:g_tracer_com%nk)  ! The layer thickness minus the
    ! difference in sinking rates across the layer, in H.
    ! By construction, 0 <= h_minus_dsink < h_old.
    real :: sink(1:g_tracer_com%nk+1) ! The tracer's sinking distances at the
    ! interfaces, limited to prevent characteristics from
    ! crossing within a single timestep, in H.
    real :: b_denom_1    ! The first term in the denominator of b1, in H.
    real :: H_to_kg_m2   ! 1 / kg_m2_to_H.
    integer :: i, j, k, nz
    logical :: do_diagnostic

    !
    !   Save the current state for calculation of the implicit vertical diffusion term
    !

    if (g_tracer%diag_id_vdiffuse_impl .gt. 0) then
      if (present(mom)) then
        do_diagnostic = .not. mom
      else
        do_diagnostic = .false.
      endif
    else
      do_diagnostic = .false.
    endif
    if (do_diagnostic) then
      do j = g_tracer_com%jsc, g_tracer_com%jec
         do i = g_tracer_com%isc, g_tracer_com%iec
            do k = 1, g_tracer_com%nk
               g_tracer%vdiffuse_impl(i,j,k) = g_tracer%field(i,j,k,tau) 
            enddo
         enddo
      enddo
    endif

    d1 = 0.0
    H_to_kg_m2 = 1.0 / kg_m2_to_H

    sink_dist = (dt*g_tracer%sink_rate) * m_to_H

    do j=g_tracer_com%jsc,g_tracer_com%jec ; do i=g_tracer_com%isc,g_tracer_com%iec 

       if (g_tracer_com%grid_tmask(i,j,1) > 0.5) then

          nz=g_tracer_com%grid_kmt(i,j)

          if (g_tracer%move_vertical) then
	    do k=2,nz; sink_dist(k) = (dt*g_tracer%vmove(i,j,k)) * m_to_H; enddo
	  endif
          sfc_src = 0.0 ; btm_src = 0.0 

          ! Find the sinking rates at all interfaces, limiting them if necesary
          ! so that the characteristics do not cross within a timestep.
          !   If a non-constant sinking rate were used, that would be incorprated
          ! here.
          if (_ALLOCATED(g_tracer%btm_reservoir)) then
             do k=2,nz 
                sink(k) = sink_dist(k) ; h_minus_dsink(k) = h_old(i,j,k)
             enddo
             sink(nz+1) = sink_dist(nz+1) 
          else
             sink(nz+1) = 0.0 
             ! Find the limited sinking distance at the interfaces.
             do k=nz,2,-1
                if (sink(k+1) >= sink_dist(k)) then
                   sink(k) = sink_dist(k)
                   h_minus_dsink(k) = h_old(i,j,k) + (sink(k+1) - sink(k))
                elseif (sink(k+1) + h_old(i,j,k) < sink_dist(k)) then
                   sink(k) = sink(k+1) + h_old(i,j,k)
                   h_minus_dsink(k) = 0.0
                else
                   sink(k) = sink_dist(k)
                   h_minus_dsink(k) = (h_old(i,j,k) + sink(k+1)) - sink(k)
                endif
             enddo
          endif

          sink(1) = 0.0 ; h_minus_dsink(1) = (h_old(i,j,1) + sink(2))

          !Avoid sinking tracers with negative concentrations
          do k=2,nz+1
             if(g_tracer%field(i,j,k-1,tau) <= 0.0) sink(k) = 0.0
          enddo

          ! Now solve the tridiagonal equation for the tracer concentrations.

          b_denom_1 = h_minus_dsink(1) + ea(i,j,1)
          b1 = 1.0 / (b_denom_1 + eb(i,j,1))
          d1 = b_denom_1 * b1

          if (_ALLOCATED(g_tracer%stf)) sfc_src = (g_tracer%stf(i,j)*dt)*kg_m2_to_H

          g_tracer%field(i,j,1,tau) = b1*(h_old(i,j,1)*g_tracer%field(i,j,1,tau) + sfc_src)

          do k=2,nz-1 
             c1(k) = eb(i,j,k-1) * b1
             b_denom_1 = h_minus_dsink(k) + d1 * (ea(i,j,k) + sink(k))
             b1 = 1.0 / (b_denom_1 + eb(i,j,k))
             d1 = b_denom_1 * b1

             g_tracer%field(i,j,k,tau) = b1 * (h_old(i,j,k) * g_tracer%field(i,j,k,tau) + &
                  (ea(i,j,k) + sink(k)) * g_tracer%field(i,j,k-1,tau))
          enddo


          c1(nz) = eb(i,j,nz-1) * b1
          b_denom_1 = h_minus_dsink(nz) + d1 * (ea(i,j,nz) + sink(nz))
          b1 = 1.0 / (b_denom_1 + eb(i,j,nz))

          if (_ALLOCATED(g_tracer%btf)) btm_src = (-g_tracer%btf(i,j)*dt)*kg_m2_to_H

          g_tracer%field(i,j,nz,tau) = b1 * ((h_old(i,j,nz) * g_tracer%field(i,j,nz,tau) + btm_src) + &
               (ea(i,j,nz) + sink(nz)) * g_tracer%field(i,j,nz-1,tau))

          if (_ALLOCATED(g_tracer%btm_reservoir)) then 
             g_tracer%btm_reservoir(i,j) = g_tracer%btm_reservoir(i,j) + &
                 (sink(nz+1)*g_tracer%field(i,j,nz,tau))*H_to_kg_m2
          endif

          do k=nz-1,1,-1
             g_tracer%field(i,j,k,tau) = g_tracer%field(i,j,k,tau) + c1(k+1)*g_tracer%field(i,j,k+1,tau)
          enddo

        endif !(g_tracer_com%grid_tmask(i,j,1) > 0.5)

    enddo; enddo ! i,j

    !
    !   Calculate the implicit vertical diffusion term
    !   (Note: not sure if this needs any unit conversion)
    !

    if (do_diagnostic) then
      do j = g_tracer_com%jsc, g_tracer_com%jec
         do i = g_tracer_com%isc, g_tracer_com%iec
            do k = 1, g_tracer_com%nk
               g_tracer%vdiffuse_impl(i,j,k) = g_tracer_com%grid_tmask(i,j,k) *   &
                    (g_tracer%field(i,j,k,tau) - g_tracer%vdiffuse_impl(i,j,k)) / dt
            enddo
         enddo
      enddo
    endif

  end subroutine g_tracer_vertdiff_G

  ! <SUBROUTINE NAME="g_tracer_vertdiff_M">
  !  <OVERVIEW>
  !   Vertical Diffusion of a tracer node
  !  </OVERVIEW>
  !  <DESCRIPTION>
  !   This subroutine solves a tridiagonal equation to find and set values of vertically diffused field for a tracer node.
  !   This is designed to calculate entrainments for MOM tracers and then call the g_tracer_vertdiff_G() above.
  !  </DESCRIPTION>
  !  <TEMPLATE>
  !   call 
  !  </TEMPLATE>
  !  <IN NAME="" TYPE="">
  !   
  !  </IN>
  ! </SUBROUTINE>

  subroutine g_tracer_vertdiff_M(g_tracer,dh, dhw, diff_cbt, dt, rho0,tau)
    type(g_tracer_type),    pointer  :: g_tracer
    real, dimension(g_tracer_com%isd:,g_tracer_com%jsd:,:), intent(in) :: dh, diff_cbt
    real, dimension(g_tracer_com%isd:,g_tracer_com%jsd:,0:), intent(in) :: dhw
    real,                   intent(in) :: dt,rho0
    integer,                intent(in) :: tau

    real, dimension(g_tracer_com%isd:g_tracer_com%ied,0:g_tracer_com%nk) ::  a,b,c, e, f, a1, c1
    real, dimension(g_tracer_com%isd:g_tracer_com%ied,0:g_tracer_com%nk) ::  wposu, wnegu, wposl, wnegl
    real, dimension(g_tracer_com%isd:g_tracer_com%ied,g_tracer_com%jsd:g_tracer_com%jed,0:g_tracer_com%nk) ::  dcb
    real, dimension(g_tracer_com%isd:g_tracer_com%ied) :: bet

    real, dimension(:,:,:), allocatable    :: ea, eb
    integer :: i, j, k, km1, kp1
    real :: eps, factu, factl, wabsu, wabsl, fact1, fact2
    logical :: GOLDtridiag = .true.
    logical :: IOWtridiag  = .false.
    
    GOLDtridiag = .true.
    IOWtridiag  = .false.
    if (g_tracer%move_vertical) then
       GOLDtridiag = .false.
       IOWtridiag  = .true.
    endif
    
    eps = 1.e-30

    !
    !   Save the current state for calculation of the implicit vertical diffusion term
    !

    if (g_tracer%diag_id_vdiffuse_impl .gt. 0) then
      do j = g_tracer_com%jsc, g_tracer_com%jec
         do i = g_tracer_com%isc, g_tracer_com%iec
            do k = 1, g_tracer_com%nk
               g_tracer%vdiffuse_impl(i,j,k) = g_tracer%field(i,j,k,tau) 
            enddo
         enddo
      enddo
    endif

    !
    !Add the contribution of K33_implicit to the diffusivity
    !
    !g_tracer%tendency should contain T_prog(n)%K33_implicit or be zero
    !!nnz: This is not really "tendency". Change name to something else like aux_array!
    do j=g_tracer_com%jsc,g_tracer_com%jec
       do i=g_tracer_com%isc,g_tracer_com%iec
          do k=1,g_tracer_com%nk
             dcb(i,j,k) = rho0*diff_cbt(i,j,k) + g_tracer%tendency(i,j,k) 
          enddo
       enddo
    enddo
    if (g_tracer%diff_vertical) then
      do j=g_tracer_com%jsc,g_tracer_com%jec
        do i=g_tracer_com%isc,g_tracer_com%iec
           do k=1,g_tracer_com%nk
             dcb(i,j,k) = dcb(i,j,k) + rho0*g_tracer%vdiff(i,j,k) 
           enddo
        enddo
      enddo
    endif
    !
    !The following two alternatives for solving the tridiagonal equation produce exact same results.
    !The choice between them should come from performance testing. I have not done this yet.
    !

    if(GOLDtridiag) then

       !===== 1 ===================
       !Via GOLD's vertdiff routine
       !===========================
       !            
       !h_old(i,j,k) = dh(i,j,k) (in kg m-2)

       allocate(   ea(g_tracer_com%isd:g_tracer_com%ied,g_tracer_com%jsd:g_tracer_com%jed,1:g_tracer_com%nk))
       allocate(   eb(g_tracer_com%isd:g_tracer_com%ied,g_tracer_com%jsd:g_tracer_com%jed,1:g_tracer_com%nk))

       do j=g_tracer_com%jsc,g_tracer_com%jec 
          do i=g_tracer_com%isc,g_tracer_com%iec

             ea(i,j,1) = 0.0 
             do k=2,g_tracer_com%nk
                ea(i,j,k) = dt * g_tracer_com%grid_tmask(i,j,k)  *dcb(i,j,k-1) /dhw(i,j,k-1)
             enddo

             do k=1,g_tracer_com%nk-1
                eb(i,j,k) = dt * g_tracer_com%grid_tmask(i,j,k+1)*dcb(i,j,k)   /dhw(i,j,k)
             enddo
             eb(i,j,g_tracer_com%nk) = 0.0 
          enddo
       enddo
       !Note: dh, ea, and eb have units here of kg m-2.
       call g_tracer_vertdiff_G(g_tracer, dh, ea, eb, dt, 1.0, rho0, tau, mom = .true.)

       !Mask out the field over "land" (land under Ocean)
       g_tracer%field(:,:,:,tau) = g_tracer%field(:,:,:,tau) * g_tracer_com%grid_tmask(:,:,:)

       deallocate(ea, eb)

    elseif(IOWtridiag) then

       !
       !OR 
       !
       !===== 2 ===================
       !Via MOM's invtri routine with vertical movement added
       !===========================
       !
       !This is borrowed from MOM invtri
       !     call invtri (T_prog(n)%field(:,:,:,taup1), T_prog(n)%stf, &
       !                  T_prog(n)%btf, wrk2(:,:,:), dtime_t, Grd%kmt,&
       !                  Grd%tmask, Thickness%rho_dzt(:,:,:,taup1), Thickness%dzwt, aidif, nk) 
       !
       do j=g_tracer_com%jsc,g_tracer_com%jec
          do k=1,g_tracer_com%nk
             km1   = max(1,k-1)
             kp1   = min(k+1,g_tracer_com%nk)
             do i=g_tracer_com%isc,g_tracer_com%iec
                fact1  = dt/dh(i,j,k)
		fact2  = rho0*fact1*0.5
		factu  = fact1/dhw(i,j,km1)
                factl  = fact1/dhw(i,j,k)
		wabsu       = abs(g_tracer%vmove(i,j,km1))
		wposu(i,k)  = fact2*(g_tracer%vmove(i,j,km1) + wabsu)*g_tracer_com%grid_tmask(i,j,k)
		wnegu(i,k)  = fact2*(g_tracer%vmove(i,j,km1) - wabsu)*g_tracer_com%grid_tmask(i,j,k)
		wabsl       = abs(g_tracer%vmove(i,j,k))
		wposl(i,k)  = fact2*(g_tracer%vmove(i,j,k  ) + wabsl)*g_tracer_com%grid_tmask(i,j,kp1)
		wnegl(i,k)  = fact2*(g_tracer%vmove(i,j,k  ) - wabsl)*g_tracer_com%grid_tmask(i,j,kp1)
                a1(i,k) = dcb(i,j,km1)*factu*g_tracer_com%grid_tmask(i,j,k)  
                c1(i,k) = dcb(i,j,k)  *factl*g_tracer_com%grid_tmask(i,j,kp1)
                a(i,k) = -(a1(i,k) - wnegu(i,k))
                c(i,k) = -(c1(i,k) + wposl(i,k))
                f(i,k) = g_tracer%field(i,j,k,tau)*g_tracer_com%grid_tmask(i,j,k) 
                b(i,k) = 1.0 + a1(i,k) + c1(i,k) - wnegl(i,k) + wposu(i,k)
             enddo
          enddo

          do i=g_tracer_com%isc,g_tracer_com%iec
             a1(i,1)  = 0.0
	     wnegu(i,1) = 0.0; wposu(i,1) = 0.0
	     a(i,1)  = 0.0
             c1(i,g_tracer_com%nk) = 0.0
	     wposl(i,g_tracer_com%nk) = 0.0; wnegl(i,g_tracer_com%nk) = 0.0 
             c(i,g_tracer_com%nk) = 0.0
             b(i,1)  = 1.0 + a1(i,1) + c1(i,1) - wnegl(i,1) + wposu(i,1)
             b(i,g_tracer_com%nk) = 1.0 + a1(i,g_tracer_com%nk) + c1(i,g_tracer_com%nk) &
	                                - wnegl(i,g_tracer_com%nk) + wposu(i,g_tracer_com%nk)

             ! top and bottom b.c.
             if (_ALLOCATED(g_tracer%stf)) &
                  f(i,1) = g_tracer%field(i,j,1,tau) + g_tracer%stf(i,j)*dt*g_tracer_com%grid_tmask(i,j,1)/dh(i,j,1)
             if (_ALLOCATED(g_tracer%btf)) then
                k = max(2,g_tracer_com%grid_kmt(i,j))
                f(i,k) = g_tracer%field(i,j,k,tau) - g_tracer%btf(i,j)*dt*g_tracer_com%grid_tmask(i,j,k)/dh(i,j,k)
             endif
          enddo

          ! decomposition and forward substitution
          do i=g_tracer_com%isc,g_tracer_com%iec
             bet(i) = g_tracer_com%grid_tmask(i,j,1)/(b(i,1) + eps)
             g_tracer%field(i,j,1,tau) = f(i,1)*bet(i)
          enddo
          do k=2,g_tracer_com%nk
             do i=g_tracer_com%isc,g_tracer_com%iec
                e(i,k) = c(i,k-1)*bet(i)
                bet(i) = g_tracer_com%grid_tmask(i,j,k)/(b(i,k) - a(i,k)*e(i,k) + eps)
                g_tracer%field(i,j,k,tau) = (f(i,k) - a(i,k)*g_tracer%field(i,j,k-1,tau))*bet(i)
             enddo
          enddo

          ! back substitution
          do k=g_tracer_com%nk-1,1,-1
             do i=g_tracer_com%isc,g_tracer_com%iec
                g_tracer%field(i,j,k,tau) = g_tracer%field(i,j,k,tau) - e(i,k+1)*g_tracer%field(i,j,k+1,tau)
             enddo
          enddo
       enddo
    else

       !
       !OR 
       !
       !===== 2 ===================
       !Via MOM's invtri routine. Works only for sink_rate=0
       !===========================
       !
       !This is borrowed from MOM invtri
       !     call invtri (T_prog(n)%field(:,:,:,taup1), T_prog(n)%stf, &
       !                  T_prog(n)%btf, wrk2(:,:,:), dtime_t, Grd%kmt,&
       !                  Grd%tmask, Thickness%rho_dzt(:,:,:,taup1), Thickness%dzwt, aidif, nk) 
       !
       do j=g_tracer_com%jsc,g_tracer_com%jec
          do k=1,g_tracer_com%nk
             km1   = max(1,k-1)
             kp1   = min(k+1,g_tracer_com%nk)
             do i=g_tracer_com%isc,g_tracer_com%iec
                factu  = dt/(dhw(i,j,k-1)*dh(i,j,k))
                factl  = dt/(dhw(i,j,k)*dh(i,j,k))
                a(i,k) = -dcb(i,j,km1)*factu*g_tracer_com%grid_tmask(i,j,k)
                c(i,k) = -dcb(i,j,k)  *factl*g_tracer_com%grid_tmask(i,j,kp1)
                f(i,k) = g_tracer%field(i,j,k,tau)*g_tracer_com%grid_tmask(i,j,k) 
                b(i,k) = 1.0 - a(i,k) - c(i,k)
             enddo
          enddo

          do i=g_tracer_com%isc,g_tracer_com%iec
             a(i,1)  = 0.0
             c(i,g_tracer_com%nk) = 0.0
             b(i,1)  = 1.0 - a(i,1) - c(i,1)
             b(i,g_tracer_com%nk) = 1.0 - a(i,g_tracer_com%nk) - c(i,g_tracer_com%nk)

             ! top and bottom b.c.
             if (_ALLOCATED(g_tracer%stf)) &
                  f(i,1) = g_tracer%field(i,j,1,tau) + g_tracer%stf(i,j)*dt*g_tracer_com%grid_tmask(i,j,1)/dh(i,j,1)
             if (_ALLOCATED(g_tracer%btf)) then
                k = max(2,g_tracer_com%grid_kmt(i,j))
                f(i,k) = g_tracer%field(i,j,k,tau) - g_tracer%btf(i,j)*dt*g_tracer_com%grid_tmask(i,j,k)/dh(i,j,k)
             endif
          enddo

          ! decomposition and forward substitution
          do i=g_tracer_com%isc,g_tracer_com%iec
             bet(i) = g_tracer_com%grid_tmask(i,j,1)/(b(i,1) + eps)
             g_tracer%field(i,j,1,tau) = f(i,1)*bet(i)
          enddo
          do k=2,g_tracer_com%nk
             do i=g_tracer_com%isc,g_tracer_com%iec
                e(i,k) = c(i,k-1)*bet(i)
                bet(i) = g_tracer_com%grid_tmask(i,j,k)/(b(i,k) - a(i,k)*e(i,k) + eps)
                g_tracer%field(i,j,k,tau) = (f(i,k) - a(i,k)*g_tracer%field(i,j,k-1,tau))*bet(i)
             enddo
          enddo

          ! back substitution
          do k=g_tracer_com%nk-1,1,-1
             do i=g_tracer_com%isc,g_tracer_com%iec
                g_tracer%field(i,j,k,tau) = g_tracer%field(i,j,k,tau) - e(i,k+1)*g_tracer%field(i,j,k+1,tau)
             enddo
          enddo
       enddo

    endif

    !
    !   Calculate the implicit vertical diffusion term
    !   (Note: dh = rho_dzt(taup1)
    !

    if (g_tracer%diag_id_vdiffuse_impl .gt. 0) then
      do j = g_tracer_com%jsc, g_tracer_com%jec
         do i = g_tracer_com%isc, g_tracer_com%iec
            do k = 1, g_tracer_com%nk
               g_tracer%vdiffuse_impl(i,j,k) = dh(i,j,k) * g_tracer_com%grid_tmask(i,j,k) *   &
                    (g_tracer%field(i,j,k,tau) - g_tracer%vdiffuse_impl(i,j,k)) / dt
            enddo
         enddo
      enddo
    endif

    return

  end subroutine g_tracer_vertdiff_M


  subroutine g_diag_field_add(node_ptr, diag_id, package_name, name, axes, init_time, longname, units, &
                            missing_value, Z_diag, field_ptr, Zname, Zlongname, Zunits)
    type(g_diag_type), pointer :: node_ptr
    integer, intent(inout) :: diag_id
    CHARACTER(len=*), INTENT(in) :: package_name, name
    INTEGER, INTENT(in) :: axes(:)
    TYPE(time_type), INTENT(in) :: init_time
    CHARACTER(len=*), INTENT(in) :: longname, units
    REAL, OPTIONAL, INTENT(in) :: missing_value
    integer, optional, intent(in) :: Z_diag
    CHARACTER(len=*), optional, INTENT(in) :: Zname, Zlongname, Zunits
    real, optional, pointer :: field_ptr(:,:,:)
    

    type(g_diag_type), pointer :: g_diag => NULL()
    
    !diag register with the original name
    diag_id = register_diag_field(package_name, name, axes, init_time, longname,units, missing_value = missing_value)

    !===================================================================
    !Add this diagnostics to the list that is going to be used later (by GOLD) 
    !===================================================================
    allocate(g_diag)
    
    g_diag%diag_id = diag_id
    g_diag%name         = trim(name)
    g_diag%longname     = trim(longname)
    g_diag%units        = trim(units)
    g_diag%package_name = trim(package_name)
    g_diag%axes         = axes
    g_diag%init_time    = init_time
    g_diag%missing_value= missing_value
    !Is this a Z diag?
    if(present(Z_diag))    g_diag%Z_diag       = Z_diag
    if(present(field_ptr)) g_diag%field_ptr    => field_ptr
    if(present(Zname))     g_diag%name         = trim(Zname)
    if(present(Zlongname)) g_diag%longname     = trim(Zlongname)
    if(present(Zunits))    g_diag%units        = trim(Zunits)


    !===================================================================
    !Reversed Linked List implementation! Make this new node to be the head of the list.
    !===================================================================    

    g_diag%next => node_ptr 
    node_ptr => g_diag 
  end subroutine g_diag_field_add


end module g_tracer_utils

#include"cppdefs.h"
!-----------------------------------------------------------------------
!BOP
!
! !ROUTINE: The dynamic k-equation \label{sec:tkeeq}
!
! !INTERFACE:
   subroutine tkeeq(nlev,dt,u_taus,u_taub,z0s,z0b,h,NN,SS)

! !DESCRIPTION:
! The transport equation for the turbulent kinetic energy, $k$,
! follows immediately from the contraction of the Reynolds-stress
! tensor. In the case of a Boussinesq-fluid, this equation can
! be written as
! \begin{equation}
!   \label{tkeA}
!   \dot{k}
!   =
!   {\cal D}_k +  P + G  - \epsilon
!   \comma
! \end{equation}
! where $\dot{k}$ denotes the material derivative of $k$. $P$ and $G$ are
! the production of $k$ by mean shear and buoyancy, respectively, and
! $\epsilon$ the rate of dissipation. ${\cal D}_k$ represents the sum of
! the viscous and turbulent transport terms.
! For horizontally homogeneous flows, the transport term ${\cal D}_k$
! appearing in \eq{tkeA} is presently expressed by a simple
! gradient formulation,
! \begin{equation}
!   \label{diffusionTKE}
!   {\cal D}_k = \frstder{z} \left( \dfrac{\nu_t}{\sigma_k} \partder{k}{z} \right)
!  \comma
! \end{equation}
! where $\sigma_k$ is the constant Schmidt-number for $k$.
!
! In horizontally homogeneous flows, the shear and the buoyancy
! production, $P$ and $G$, can be written as
! \begin{equation}
!   \label{PandG}
!   \begin{array}{rcl}
!   P &=& - \mean{u'w'} \partder{U}{z} - \mean{v'w'} \partder{V}{z}  \comma \\[3mm]
!   G &=&  \mean{w'b'}                                               \comma
!   \end{array}
! \end{equation}
! see \eq{PG}. Their computation is discussed in \sect{sec:production}.
!
! The rate of dissipation, $\epsilon$, can be either obtained directly
! from its parameterised transport equation as discussed in
! \sect{sec:dissipationeq}, or from any other model yielding
! an appropriate description of the dissipative length-scale, $l$.
! Then, $\epsilon$ follows from the well-known cascading relation
! of turbulence,
! \begin{equation}
!   \label{epsilon}
!   \epsilon = (c_\mu^0)^3 \frac{k^{\frac{3}{2}}}{l}
!   \comma
! \end{equation}
! where $c_\mu^0$ is a constant of the model.
!
! !USES:
   use turbulence,   only: P,B,num
   use turbulence,   only: tke,tkeo,k_min,eps
   use turbulence,   only: k_bc, k_ubc, k_lbc, ubc_type, lbc_type
   use turbulence,   only: sig_k
   use util,         only: Dirichlet,Neumann

   IMPLICIT NONE
!
! !INPUT PARAMETERS:

!  number of vertical layers
   integer,  intent(in)                :: nlev

!  time step (s)
   REALTYPE, intent(in)                :: dt

!  surface and bottom
!  friction velocity (m/s)
   REALTYPE, intent(in)                :: u_taus,u_taub

!  surface and bottom
!  roughness length (m)
   REALTYPE, intent(in)                :: z0s,z0b

!  layer thickness (m)
   REALTYPE, intent(in)                :: h(0:nlev)

!  square of shear and buoyancy
!  frequency (1/s^2)
   REALTYPE, intent(in)                :: NN(0:nlev),SS(0:nlev)
!
! !REVISION HISTORY:
!  Original author(s): Lars Umlauf
!                     (re-write after first version of
!                      H. Burchard and K. Bolding)
!
!  $Log: tkeeq.F90,v $
!  Revision 20.0  2013/12/14 00:13:53  fms
!  Merged revision 1.1.2.1 onto trunk
!
!  Revision 1.1.2.1  2012/05/15 16:00:54  smg
!  initial cvs ci for these modules to mom5.
!  AUTHOR:Griffies
!  REVIEWERS:
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.1.2.1.390.1  2012/04/23 20:30:29  smg
!  updated to the gotm-2012.03.09 CVS tag.
!  AUTHOR:Martin Schmidt
!  REVIEWERS:Griffies
!  TEST STATUS:
!  CHANGES PUBLIC INTERFACES?
!  CHANGES ANSWERS?
!
!  Revision 1.9  2005-11-15 11:35:02  lars
!  documentation finish for print
!
!  Revision 1.8  2005/11/03 20:53:37  hb
!  Patankar trick reverted to older versions for
!  stabilising 3D computations
!
!  Revision 1.7  2005/08/11 13:11:50  lars
!  Added explicit loops for diffusivities for 3-D z-level support.
!  Thanks to Vicente Fernandez.
!
!  Revision 1.6  2005/06/27 13:44:07  kbk
!  modified + removed traling blanks
!
!  Revision 1.5  2003/03/28 09:20:35  kbk
!  added new copyright to files
!
!  Revision 1.4  2003/03/10 09:02:06  gotm
!  Added new Generic Turbulence Model + improved documentation and cleaned up code
!
!
!EOP
!------------------------------------------------------------------------
!
! !LOCAL VARIABLES:
   REALTYPE                  :: DiffKup,DiffKdw,pos_bc
   REALTYPE                  :: prod,buoyan,diss
   REALTYPE                  :: prod_pos,prod_neg,buoyan_pos,buoyan_neg
   REALTYPE                  :: cnpar=_ONE_
   REALTYPE                  :: avh(0:nlev)
   REALTYPE                  :: Lsour(0:nlev),Qsour(0:nlev)

   integer                   :: i
!
!------------------------------------------------------------------------
!BOC
!

   tkeo=tke

   do i=1,nlev-1

!     compute diffusivity
      avh(i) = num(i)/sig_k

!     compute production terms in k-equation
      prod     = P(i)
      buoyan   = B(i)
      diss     = eps(i)


      if (prod+buoyan.gt.0) then
         Qsour(i)  = prod+buoyan
         Lsour(i) = -diss/tke(i)
      else
         Qsour(i)  = prod
         Lsour(i) = -(diss-buoyan)/tke(i)
      end if

   end do


!  position for upper BC
   if (k_ubc.eq.Neumann) then
!     flux at center "nlev"
      pos_bc = 0.5*h(nlev)
   else
!     value at face "nlev-1"
      pos_bc = h(nlev)
   end if

!  obtain BC for upper boundary of type "ubc_type"
   DiffKup  = k_bc(k_ubc,ubc_type,pos_bc,z0s,u_taus)


!  position for lower BC
   if (k_lbc.eq.Neumann) then
!     flux at center "1"
      pos_bc = 0.5*h(1)
   else
!     value at face "1"
      pos_bc = h(1)
   end if

!  obtain BC for lower boundary of type "lbc_type"
   DiffKdw  = k_bc(k_lbc,lbc_type,pos_bc,z0b,u_taub)


!  do diffusion step
   call diff_face(nlev,dt,cnpar,h,k_ubc,k_lbc,                          &
                  DiffKup,DiffKdw,avh,Lsour,Qsour,tke)


!  fill top and bottom value with something nice
!  (only for output)
   tke(nlev)  = k_bc(Dirichlet,ubc_type,z0s,z0s,u_taus)
   tke(0   )  = k_bc(Dirichlet,lbc_type,z0b,z0b,u_taub)

!  clip at k_min
   do i=0,nlev
      tke(i) = max(tke(i),k_min)
   enddo

   return
   end subroutine tkeeq
!EOC

!-----------------------------------------------------------------------
! Copyright by the GOTM-team under the GNU Public License - www.gnu.org
!-----------------------------------------------------------------------

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------
 
! $Id: cosp_misr_simulator.F90,v 20.0 2013/12/13 23:15:46 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

!
! History:
! Nov 2008 - A. Bodas-Salcedo - Initial version
!
!

MODULE MOD_COSP_MISR_SIMULATOR
  USE MOD_COSP_CONSTANTS
  USE MOD_COSP_TYPES
  IMPLICIT NONE

CONTAINS


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!-------------- SUBROUTINE COSP_MISR_SIMULATOR -----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_MISR_SIMULATOR(gbx,sgx,y)
  
  ! Arguments
  type(cosp_gridbox),intent(in) :: gbx  ! Gridbox info
  type(cosp_subgrid),intent(in) :: sgx  ! Subgridbox info
  type(cosp_misr),intent(inout) :: y    ! MISR simulator output
  
  ! Local variables 
  integer :: Nlevels,Npoints
  real :: dtau_s(gbx%Npoints, gbx%Nlevels)
  real :: dtau_c(gbx%Npoints, gbx%Nlevels)
  real :: at(gbx%Npoints, gbx%Nlevels)
  real :: frac_out(gbx%Npoints, gbx%Ncolumns, gbx%Nlevels)
  integer :: sunlit(gbx%Npoints)
  
  real :: zfull(gbx%Npoints, gbx%Nlevels) !  height (in meters) of full model levels (i.e. midpoints)
                                          !  zfull(npoints,1)    is    top level of model
                                          !  zfull(npoints,nlev) is bottom level of model
     
    
  Nlevels = gbx%Nlevels
  Npoints = gbx%Npoints
  ! Levels from TOA to surface
  zfull  = gbx%zlev(:,Nlevels:1:-1)
  at     = gbx%T(:,Nlevels:1:-1) 
  dtau_s = gbx%dtau_s(:,Nlevels:1:-1) 
  dtau_c = gbx%dtau_c(:,Nlevels:1:-1) 
  frac_out(1:Npoints,:,1:Nlevels) = sgx%frac_out(1:Npoints,:,Nlevels:1:-1)
  sunlit = int(gbx%sunlit)
 
#ifdef COSP_GFDL
 if (sgx%cols_input_from_model) then
  call MISR_simulator(gbx%npoints,gbx%nlevels,gbx%ncolumns,&
                     sunlit,zfull,at,dtau_s,dtau_c,frac_out, &
                     R_UNDEF, &
                     y%fq_MISR,y%MISR_dist_model_layertops,  &
                     y%MISR_meanztop,y%MISR_cldarea,   &
                     sgx%dtau_col)
 else
#endif
  call MISR_simulator(gbx%npoints,gbx%nlevels,gbx%ncolumns,&
                     sunlit,zfull,at,dtau_s,dtau_c,frac_out, R_UNDEF, &
                     y%fq_MISR,y%MISR_dist_model_layertops,y%MISR_meanztop,y%MISR_cldarea)
#ifdef COSP_GFDL
 endif
#endif
            
END SUBROUTINE COSP_MISR_SIMULATOR

END MODULE MOD_COSP_MISR_SIMULATOR

module ocean_vert_chen_mod
#define COMP isc:iec,jsc:jec
!
!<CONTACT EMAIL="Russell.Fiedler@csiro.au"> Russell Fiedler 
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> S.M. Griffies 
!</REVIEWER>
!
!<OVERVIEW>
! Vertical viscosity and diffusivity according Chen scheme 
!</OVERVIEW>
!
!<DESCRIPTION>
! This scheme was originally developed by researchers 
! at the CSIRO Marine and Atmospheric Research and 
! Bureau of Meteorology, both in Australia.
!</DESCRIPTION>
!
! <INFO>
!
! <REFERENCE>
! Chen, D., L.M. Rothstein and A.J. Busalacchi, 1994:
! A hybrid vertical mixing scheme and its application 
! to tropical ocean models, 
! J. Phys. Oceanogr., 24, 2156-2179
! </REFERENCE>
!
! <NOTE>
! Surface fresh water contributes to surface buoyancy via conversion to 
! a locally implied salt flux. 
! </NOTE>
!
! <NOTE>
! This module typically runs with the ocean_shortwave_csiro scheme.
! </NOTE>
!
! <NOTE>
! Use smf_bgrid since this array contains the primary smf array read in from 
! from the coupler in ocean_core/ocean_sbc.F90, when using the FMS coupler.
! </NOTE>
!
! </INFO>
!
!<NAMELIST NAME="ocean_vert_chen_nml">
!  <DATA NAME="use_this_module" TYPE="logical">
!  Must be true to use this module. Default is false. 
!  </DATA> 
!  <DATA NAME="debug_this_module" TYPE="logical">
!  For debugging.  Default debug_this_module=.false. 
!  </DATA> 
!
!  <DATA NAME="diff_cbt_iw" UNITS="m^2/sec" TYPE="real">
!  Background vertical diffusivity.  Note that if using Bryan-Lewis as a 
!  background diffusivity, then should set diff_cbt_iw=0.0. 
!  </DATA> 
!  <DATA NAME="visc_cbu_iw" UNITS="m^2/sec" TYPE="real">
!  Background vertical viscosity
!  </DATA> 
!  <DATA NAME="visc_cbu_limit" UNITS="m^2/sec" TYPE="real">
!  Enhanced vertical viscosity due to shear instability 
!  </DATA> 
!  <DATA NAME="diff_cbt_limit" UNITS="m^2/sec" TYPE="real">
!  Enhanced vertical diffusivity due to shear instability 
!  </DATA> 
!  <DATA NAME="bulk_tn" UNITS="" TYPE="real">
!  Bulk turblence parameter n_0
!  </DATA> 
!  <DATA NAME="bulk_tm" UNITS="" TYPE="real">
!  Bulk turblence parameter m_0
!  </DATA> 
!  <DATA NAME="hbl_growth_max" UNITS="m/sec" TYPE="real">
!  Maximum growth rate of kraus mixed layer 
!  </DATA> 
!</NAMELIST>

use constants_mod,    only: epsln
use diag_manager_mod, only: register_diag_field, register_static_field
use fms_mod,          only: FATAL, NOTE, WARNING, stdout, stdlog, file_exist
use fms_mod,          only: write_version_number, open_namelist_file, check_nml_error, close_file
use fms_io_mod,       only: register_restart_field, save_restart, restore_state
use fms_io_mod,       only: restart_file_type
use mpp_domains_mod,  only: mpp_update_domains, NUPDATE, EUPDATE
use mpp_mod,          only: input_nml_file, mpp_error

use ocean_density_mod,         only: density, density_delta_z, density_delta_sfc
use ocean_domains_mod,         only: get_local_indices
use ocean_parameters_mod,      only: missing_value, rho0r, rho_cp, cp_ocean, grav
use ocean_parameters_mod,      only: MOM_BGRID, MOM_CGRID
use ocean_shortwave_csiro_mod, only: F_vis, ssw_atten_depth
use ocean_types_mod,           only: ocean_grid_type, ocean_domain_type
use ocean_types_mod,           only: ocean_prog_tracer_type, ocean_diag_tracer_type
use ocean_types_mod,           only: ocean_velocity_type, ocean_density_type
use ocean_types_mod,           only: ocean_time_type, ocean_time_steps_type, ocean_thickness_type
use ocean_util_mod,            only: write_timestamp, diagnose_2d, write_chksum_2d
use ocean_vert_util_mod,       only: ri_for_cgrid
use ocean_workspace_mod,       only: wrk1, wrk1_v

implicit none

private

public ocean_vert_chen_init
public ocean_vert_chen_end
public vert_mix_chen
public ocean_vert_chen_restart

private kraus_turner
private ri_for_chen
private nr_for_chen

#ifdef MOM_STATIC_ARRAYS

integer, parameter :: isc = 1, iec = NI_LOCAL_ , jsc = 1, jec = NJ_LOCAL_
integer, parameter :: isd = 0, ied = NI_LOCAL_ + 1 , jsd = 0, jed = NJ_LOCAL_ + 1
integer, parameter :: isg = 1, ieg = NI_ , jsg = 1, jeg = NJ_
integer, parameter :: nk = NK_


real                :: BoT        ! thermal turb buoy. forcing  (m^2/s^3)
real, dimension(isd:ied,jsd:jed)                :: Bosol      ! radiative buoy forcing      (m^2/s^3)
real                :: BoS        ! salinity buoy forcing      (m^2/s^3)
real                :: BoTot      ! total buoy forcing      (m^2/s^3)
real, dimension(isd:ied,jsd:jed)             :: dbloc      ! local delta buoy at interfaces(m/s^2)

integer, dimension(isd:ied,jsd:jed)             :: kbl        ! index of first grid level below hbl

real, private, dimension(isd:ied,jsd:jed,nk)   :: riu      ! Richardson number at base of U-cells
real, private, dimension(isd:ied,jsd:jed,nk)   :: rit      ! Richardson number at base of T-cells
real, private, dimension(isd:ied,jsd:jed)      :: hbl      ! boundary layer depth

#else

integer :: isd, ied, jsd, jed, isc, iec, jsc, jec, nk


real, dimension(:,:), allocatable        :: rhosfc     ! potential density of sfc layer(kg/m^3)
real        :: BoT        ! 
real, dimension(:,:), allocatable        :: Bosol      ! 
real        :: BoS        !
real        :: BoTot      !
real, dimension(:,:), allocatable      :: dbloc      ! local delta buoy at interfaces(m/s^2)
integer, dimension(:,:), allocatable     :: kbl        ! index of first grid level below hbl

real, private, dimension(:,:,:), allocatable   :: riu      ! Richardson number at base of U-cells
real, private, dimension(:,:,:), allocatable   :: rit      ! Richardson number at base of T-cells
real, private, dimension(:,:),   allocatable   :: hbl      ! boundary layer depth

#endif

real, parameter :: epsilon = 0.1

! for diagnostics 
integer :: id_diff_cbt_chen_t, id_diff_cbt_chen_s,id_hbl
integer :: id_wmix,id_bte,id_dbloc,id_tke
logical :: used

! for restart
type(restart_file_type), save :: Che_restart

real :: tracer_timestep=0.0
real :: aidif 

integer :: num_prog_tracers=0, index_temp, index_salt


! Namelist 

real :: visc_cbu_limit     = 50.0e-4 ! max visc due to shear instability
real :: diff_cbt_limit     = 50.0e-4 ! max diff due to shear instability
real :: visc_con_limit     = 0.1     ! m^2/s. visc due to convective instability
real :: diff_con_limit     = 0.1     ! m^2/s. diff due to convective instability
real :: visc_cbu_iw        = 1.0e-4  ! m^2/s. visc background due to internal waves
real :: diff_cbt_iw        = 0.1e-4  ! m^2/s. diffusivity background due to internal waves
 

! bulk turbulence parameters
real :: bulk_tm        = 0.4
real :: bulk_tn        = 0.18
real :: hbl_growth_max = 100.    ! (m/s) set large by default

! for Bgrid or Cgrid
integer :: horz_grid

type(ocean_domain_type), pointer :: Dom =>NULL()
type(ocean_grid_type), pointer :: Grd =>NULL()

character(len=256) :: version=&
     '$Id: ocean_vert_chen.F90,v 20.0 2013/12/14 00:16:36 fms Exp $'
character (len=128) :: tagname = &
     '$Name: tikal $'

logical :: module_is_initialized = .FALSE.
logical :: use_this_module       = .false.
logical :: debug_this_module     = .false. 

namelist /ocean_vert_chen_nml/ use_this_module, debug_this_module, &
                               diff_cbt_iw, visc_cbu_iw,           &
                               visc_cbu_limit, diff_cbt_limit,     &
                               bulk_tn, bulk_tm, hbl_growth_max,   &
                               visc_con_limit, diff_con_limit

contains


!#######################################################################
! <SUBROUTINE NAME="ocean_vert_chen_init">
!
! <DESCRIPTION>
! Initialization for the Chen vertical mixing scheme
!
!     input:
!       dzt    = thickness of vertical levels (m)                        
!       km     = number of vertical levels                               
!       yt     = latitude of grid points (deg)                           
!       dtts   = density time step (sec)                                 
!       dtuv   = internal mode time step (sec)                           
!       error  = logical to signal problems                              
!       vmixset= logical to determine if a vertical mixing scheme was    
!                chosen
!
!     output:
!       visc_cbu_limit = visc max due to shear instability  (m**2/sec)   
!       diff_cbt_limit = diffusivity ..                     (m**2/sec)   
!       visc_cbu_iw  = visc background due to internal waves(m**2/sec)   
!       diff_cbt_iw  = diffusivity ..                       (m**2/sec)   
!       error  = true if some inconsistancy was found                    
!
! </DESCRIPTION>
!
subroutine ocean_vert_chen_init (Grid, Domain, Time, Time_steps, T_prog, hor_grid, debug)
  
  type(ocean_grid_type),        intent(in), target   :: Grid
  type(ocean_domain_type),      intent(in), target   :: Domain
  type(ocean_time_type),        intent(in)           :: Time
  type(ocean_time_steps_type),  intent(in)           :: Time_steps
  type(ocean_prog_tracer_type), intent(in)           :: T_prog(:)
  integer,                      intent(in)           :: hor_grid 
  logical,                      intent(in), optional :: debug 

  integer :: i, j, k, ioun, io_status, ierr, n
  integer :: id_restart
  real    :: hbl_init=25.0

  integer :: stdoutunit,stdlogunit 
  stdoutunit=stdout();stdlogunit=stdlog() 

  if ( module_is_initialized ) then 
       call mpp_error(FATAL,  '==>Error: ocean_vert_chen_init attempted reinitialization')
  endif 
  module_is_initialized = .TRUE.

  call write_version_number(version, tagname)

  ! provide for namelist over-ride of defaults 
#ifdef INTERNAL_FILE_NML
read (input_nml_file, nml=ocean_vert_chen_nml, iostat=io_status)
ierr = check_nml_error(io_status,'ocean_vert_chen_nml')
#else
  ioun =  open_namelist_file ()
  read  (ioun, ocean_vert_chen_nml,iostat=io_status)
  ierr = check_nml_error(io_status,'ocean_vert_chen_nml')
  call close_file(ioun)
#endif
  write (stdoutunit,'(/)')
  write (stdoutunit, ocean_vert_chen_nml)  
  write (stdlogunit, ocean_vert_chen_nml)

  if(use_this_module) then
      write(stdoutunit,'(/1x,a)')'==> NOTE: USING Chen vertical mixing scheme.'
      write(stdoutunit,'(1x,a/)')'==> NOTE: Chen is to be run with shortwave flux from ocean_shortwave_csiro_mod'
  else
      write(stdoutunit,'(/1x,a)')'==> NOTE: NOT USING Chen vertical mixing scheme.'
      return
  endif

  if (PRESENT(debug) .and. .not. debug_this_module) then 
    debug_this_module = debug
  endif 
  if(debug_this_module) then 
    write(stdoutunit,'(a)') '==>Note: running ocean_vert_chen_mod with debug_this_module=.true.'  
  endif 

  tracer_timestep = Time_steps%dtts
  aidif           = Time_steps%aidif 
  horz_grid       = hor_grid
  
  index_temp=-1;index_salt=-1
  num_prog_tracers = size(T_prog)
  do n= 1, num_prog_tracers
     if (T_prog(n)%name == 'temp') index_temp = n
     if (T_prog(n)%name == 'salt') index_salt = n
  enddo

  if (index_temp < 1 .or. index_salt < 1) then 
    call mpp_error(FATAL,&
    '==>Error: ocean_vert_chen_mod: temp and/or salt not present in tracer array')
  endif 
  Dom => Domain
  Grd => Grid

#ifndef MOM_STATIC_ARRAYS
  call get_local_indices(Domain,isd,ied,jsd,jed,isc,iec,jsc,jec)
  nk = Grid%nk

  allocate (riu(isd:ied,jsd:jed,nk))
  allocate (rit(isd:ied,jsd:jed,nk))
  allocate (hbl(isd:ied,jsd:jed))

  allocate (dbloc(isd:ied,jsd:jed))     ! local delta buoy at interfaces(m/s^2)
  allocate (kbl(isd:ied,jsd:jed))       ! index of first grid level below hbl
  allocate(Bosol(isd:ied,jsd:jed))
#endif

  riu(:,:,:)    = 0.0
  rit(:,:,:)    = 0.0
#ifdef defined(ACCESS_CM)
  kbl(:,:)      = 1
  hbl(:,:)      = 5.0
#endif
  id_restart = register_restart_field(Che_restart, 'kraus.res.nc', 'kbl',kbl, &
               domain=Dom%domain2d)
  id_restart = register_restart_field(Che_restart, 'kraus.res.nc', 'hbl',hbl, &
               domain=Dom%domain2d)
  if(file_exist('INPUT/kraus.res.nc')) then
      call restore_state(Che_restart)
#ifdef defined(ACCESS_CM)
      call mpp_update_domains(kbl,Dom%domain2d)
      call mpp_update_domains(hbl,Dom%domain2d)
#endif
      write(stdoutunit,*)' ' 
      write(stdoutunit,*) 'From ocean_vert_chen: reading hbl from kraus.res.nc'
      call write_timestamp(Time%model_time)
      call write_chksum_2d('hbl', hbl(COMP)*Grd%tmask(COMP,1))
#ifdef defined(ACCESS_CM)
      write(stdoutunit,*) 'From ocean_vert_chen: reading kbl from kraus.res.nc'
      call write_timestamp(Time%model_time)
      call write_chksum_2d('kbl', kbl(COMP)*Grd%tmask(COMP,1))
#endif
  else
      hbl(:,:) = hbl_init*Grd%tmask(:,:,1)
      kbl(:,:)=1
      do k=nk,1,-1
         do j=jsc,jec
            do i=isc,iec
               if(Grd%zt(k) > hbl(i,j)) then
                  kbl(i,j)=k
               endif
            enddo
         enddo
      enddo
  endif

  call mpp_update_domains(kbl, Dom%domain2d)
  call mpp_update_domains(hbl, Dom%domain2d)

!-----------------------------------------------------------------------
! error checks and diagnostics setup 
!-----------------------------------------------------------------------

  id_wmix = register_diag_field('ocean_model','wmix',Grd%tracer_axes_wt(1:2),&
       Time%model_time, 'wind mixing', 'm^3/s^3',                            &
       missing_value = missing_value, range=(/-1.e5,1.e5/))
  id_bte = register_diag_field('ocean_model','bte',Grd%tracer_axes_wt(1:2),&
       Time%model_time, 'bulk_Tke term', 'm^2/s^3',                        &
       missing_value = missing_value, range=(/-1.e5,1.e5/))
  id_dbloc = register_diag_field('ocean_model','dbloc',Grd%tracer_axes_wt(1:2),&
       Time%model_time, 'delta density ', 'm/s^2',                             &
       missing_value = missing_value, range=(/-1.e5,1.e5/))
  id_tke = register_diag_field('ocean_model','tke',Grd%tracer_axes_wt(1:2),&
       Time%model_time, 'Rhs of tke', 'm^3/s^3',                           &
       missing_value = missing_value, range=(/-1.e5,1.e5/))
  id_hbl = register_diag_field('ocean_model','hbl',Grd%tracer_axes_wt(1:2),&
       Time%model_time, 'Kraus mixed layer depth', 'm',                    &
       missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_diff_cbt_chen_t = register_diag_field('ocean_model','diff_cbt_chen_t',            &
       Grd%tracer_axes_wt(1:3), Time%model_time, 'vert diffusivity from chen for temp',&
       'm^2/sec', missing_value = missing_value, range=(/-1.e5,1.e5/))

  id_diff_cbt_chen_s = register_diag_field('ocean_model','diff_cbt_chen_s',                 &
       Grd%tracer_axes_wt(1:3), Time%model_time, 'vert diffusivity from chen for salinity', &
       'm^2/sec', missing_value = missing_value, range=(/-1.e5,1.e5/))

end subroutine ocean_vert_chen_init
! </SUBROUTINE> NAME="ocean_vert_mix_coeff_init">


!#######################################################################
! <SUBROUTINE NAME="vert_mix_chen">
!
! <DESCRIPTION>
!
! --Compute interior mixing everywhere:                               
!   interior mixing gets computed at all cell interfaces due to constant
!   internal wave background activity ("visc_cbu_iw" and "diff_cbt_iw").
!   Additionally, mixing can be enhanced by contribution from shear 
!   instability which is a function of the local Ri.
!
! --Boundary layer:
!
!   (A) Boundary layer depth:
!       at every gridpoint the depth of the Kraus boundary layer 
!       ("hbl") gets computed.
!
!   (B) Boundary layer mixing:
!       within the boundary layer, above hbl, vertical mixing is 
!       set to a maximum
!
! inputs
!
! outputs
!
!  hbl      = boundary layer depth (meters)
!  visc_cbu = viscosity coefficient at bottom of U cells (m^2/s) <BR/> 
!  diff_cbt = diffusion coefficient at bottom of T cells (m^2/s) <BR/>
! </DESCRIPTION>
!
  subroutine vert_mix_chen(Time, Thickness, Velocity, T_prog, Dens, &
                           swflx,  pme, visc_cbu, visc_cbt, diff_cbt)

  type(ocean_time_type),                 intent(in)    :: Time
  type(ocean_thickness_type),            intent(in)    :: Thickness
  type(ocean_velocity_type),             intent(in)    :: Velocity
  type(ocean_prog_tracer_type),          intent(in)    :: T_prog(:)
  type(ocean_density_type),              intent(in)    :: Dens
  real, dimension(isd:,jsd:),            intent(in)    :: swflx
  real, dimension(isd:,jsd:),            intent(in)    :: pme
  real, dimension(isd:ied,jsd:jed,nk),   intent(inout) :: visc_cbu
  real, dimension(isd:ied,jsd:jed,nk),   intent(inout) :: visc_cbt
  real, dimension(isd:ied,jsd:jed,nk,2), intent(inout) :: diff_cbt

!
! Coefficients for richardson no. mixing.
!
  real, parameter  :: a_pt_8=6.7490227E-8
  real, parameter  :: b_pt_2=8.6118424E-4
  real, parameter  :: d_pt_10=2.0269152E-9
  real, parameter  :: e_pt_3=8.4795331E-4    
  real :: t1, t2, t3, rriu_8, rrit_10, rrit_8

  real, dimension(isd:ied,jsd:jed,nk)  :: mixmask
  integer :: i, j, k
  integer :: tau, taum1

  integer :: stdoutunit 
  stdoutunit=stdout() 

  if ( .not. module_is_initialized ) call &
       mpp_error(FATAL, '==>Error: Module ocean_vert_mix_coeff_mod must be initialized')

  tau   = Time%tau
  taum1 = Time%taum1

  visc_cbu(:,:,:) = 0.0
  visc_cbt(:,:,:) = 0.0

  ! compute mixed layer according to Kraus-Turner algorithm
  call kraus_turner(Time, Velocity, T_prog, Dens, swflx, pme, mixmask)

!-----------------------------------------------------------------------
!     compute gradient Ri 
!-----------------------------------------------------------------------

  if(horz_grid == MOM_BGRID) then 
     call ri_for_chen(Time, Thickness, Velocity, T_prog, Dens%pressure_at_depth, &
                      Dens%rho(:,:,:,tau), Dens%rho(:,:,:,taum1), Dens%rho_salinity)
  else
      ! average horizontal C-grid velocity onto T-cell center
      wrk1_v(:,:,:,:) = 0.0
      do k=1,nk
         do j=jsc,jec
            do i=isc,iec
               wrk1_v(i,j,k,1) = Grd%tmask(i,j,k)                                                  &
                    *(Velocity%u(i,j,k,tau,1)*Grd%dtw(i,j)+Velocity%u(i-1,j,k,tau,1)*Grd%dte(i,j)) &
                    /(epsln+Grd%dxt(i,j))
               wrk1_v(i,j,k,2) = Grd%tmask(i,j,k)                                                  &
                    *(Velocity%u(i,j,k,tau,2)*Grd%dts(i,j)+Velocity%u(i,j-1,k,tau,2)*Grd%dtn(i,j)) &
                    /(epsln+Grd%dyt(i,j))
            enddo
         enddo
      enddo
      call ri_for_cgrid(Time, Thickness%dzwt, Dens%drhodT, Dens%drhodS,          &
           T_prog(index_temp)%field(:,:,:,taum1), Dens%rho_salinity(:,:,:,taum1),&
           wrk1_v(:,:,:,1), wrk1_v(:,:,:,2), rit, riu)
  endif 

! Do Richardson number mixing according to whatever law you like.
! Perhaps should make this a distinct user supplied/customisable routine.
!
! Law used here is
! visc= a/Ri^8  + b/(1+5Ri)^2
! diff= d/Ri^10 + e/(1+Ri)^3
!
! compute C-grid viscosity on T-points and 
! assume east value same as north value.
!
  do k=1,nk-1
    do j=jsc,jec
      do i=isc,iec
        t1                   = 1.0/(1.0 + 5.0*riu(i,j,k))
        t3                   = 1.0/(1.0 + 5.0*rit(i,j,k))
        rriu_8               = 1.0/(riu(i,j,k)**8+epsln)
        visc_cbu(i,j,k)      = mixmask(i,j,k)*visc_cbu_limit + &
                               (a_pt_8*rriu_8+b_pt_2*t1**2)+visc_cbu_iw
        rrit_8               = 1.0/(rit(i,j,k)**8+epsln)
        visc_cbt(i,j,k)      = mixmask(i,j,k)*visc_cbu_limit + &
                              (a_pt_8*rrit_8+b_pt_2*t3**2)+visc_cbu_iw
        t2                   = 1.0/(1.0 + 5.0*rit(i,j,k))
        rrit_10              = 1.0/(rit(i,j,k)**10+epsln)
        diff_cbt(i,j,k,1)    = mixmask(i,j,k)*diff_cbt_limit + &
                               (d_pt_10*rrit_10+e_pt_3*t2**3)+diff_cbt_iw
      enddo
    enddo
  enddo

! Limit
  
  do k=1,nk-1
     do j=jsc,jec
        do i=isc,iec
           diff_cbt(i,j,k,1)   = min(diff_cbt(i,j,k,1),  diff_cbt_limit)*Grd%tmask(i,j,k+1)
           visc_cbt(i,j,k)     = min(visc_cbt(i,j,k),    visc_cbu_limit)*Grd%tmask(i,j,k+1)
           visc_cbu(i,j,k)     = min(visc_cbu(i,j,k),    visc_cbu_limit)*Grd%umask(i,j,k+1)
        enddo
     enddo
  enddo

  ! Convection
  if(aidif == 1.0) then
     do k=1,nk-1
        do j=jsc,jec
           do i=isc,iec
              if(rit(i,j,k) < 0.0) then
                 diff_cbt(i,j,k,1) = diff_con_limit*Grd%tmask(i,j,k+1)
                 visc_cbu(i,j,k)   = visc_con_limit*Grd%umask(i,j,k+1)  
                 visc_cbt(i,j,k)   = visc_con_limit*Grd%tmask(i,j,k+1)  
              endif
           enddo
        enddo
     enddo
  endif


  ! default salinity coefficient equal to thermal (assume no double diffusion) 
  diff_cbt(:,:,:,2) = diff_cbt(:,:,:,1)

  if(debug_this_module) then 
      write(stdoutunit,*)' ' 
      write(stdoutunit,*) 'From ocean_vert_chen: intermediate chksum'
      call write_timestamp(Time%model_time)
      call write_chksum_2d('hbl', hbl(COMP)*Grd%tmask(COMP,1))
      call write_chksum_2d('diff_cbt', diff_cbt(COMP,:,1)*Grd%tmask(COMP,:))
  endif
  
end subroutine vert_mix_chen
! </SUBROUTINE> NAME="vert_mix_chen"


!#######################################################################
! <SUBROUTINE NAME="kraus_turner">
!
! <DESCRIPTION>
!
! Calculate the Kraus mixed layer depth
!
! Note: This formulation assumes a single exponential decay in the solar
! shortwave penetration.
!
! Use smf_bgrid since this array contains the primary smf array read in from 
! from the coupler in ocean_core/ocean_sbc.F90, when using the FMS coupler.
!
!      real dbloc(ij_bounds)  = local delta buoyancy         (m/s^2)        
!      real Bo(ij_bounds)     = surface turbulent buoyancy forcing(m^2/s^3)
!      real Bosol(ij_bounds)  = radiative buoyancy forcing (m^2/s^3)       
!
!  output
!      real hbl(ij_bounds)        ! boundary layer depth              (m)      
!      real mixmask(ij_bounds,nk) ! fraction of cell which resides in mixed layer
!      integer kbl(ij_bounds)     ! index of first grid level below hbl        
!
! </DESCRIPTION>
subroutine kraus_turner(Time, Velocity, T_prog, Dens, swflx, pme, mixmask)

  type(ocean_time_type),        intent(in)  :: Time
  type(ocean_velocity_type),    intent(in)  :: Velocity
  type(ocean_prog_tracer_type), intent(in)  :: T_prog(:)
  type(ocean_density_type),     intent(in)  :: Dens
  real, dimension(isd:,jsd:),   intent(in)  :: swflx
  real, dimension(isd:,jsd:),   intent(in)  :: pme
  real, dimension(isd:,jsd:,:), intent(out) :: mixmask

  real, dimension(isd:ied,jsd:jed) :: talpha !-d(rho)/ d(pot.temperature)  (kg/m^3/C)
  real, dimension(isd:ied,jsd:jed) :: sbeta  !d(rho)/ d(salinity)          (kg/m^3/PSU)
  real, dimension(isd:ied,jsd:jed) :: tempbl,saltbl,pressbl  ! Values across boundary layer 
  real, dimension(isd:ied,jsd:jed) :: density_mixed, density_mixed_1
  real, dimension(isd:ied,jsd:jed) :: wind_mixing,tke,bulk_tke

  integer, dimension(isd:ied,jsd:jed) :: kblm1  ! level immediately above  mixed layer
  integer, dimension(isd:ied,jsd:jed) :: kblp1  ! next level immediately below  mixed layer

  integer :: i,j,k, kbl_m1
  integer :: tau, taum1
  real    :: shallow
  real    :: smftu, smftv, active_cells
  real    :: pen_ke,exdepth,hbltemp  

  tau   = Time%tau
  taum1 = Time%taum1   
!
! Layers above and below mixed layer interface
!
  kblm1=max(kbl-1,1)
  kblp1=max(min(kbl+1,Grd%kmt),1)

! result from density_derivs is d(rho)/d(theta), yet need minus for this routine. 
  do j=jsd,jed
     do i=isd,ied
        talpha(i,j) = -Dens%drhodT(i,j,1)
        sbeta(i,j)  =  Dens%drhodS(i,j,1)
     enddo
  enddo


! Surface Buoyancy fluxes
! Note stf is now ( heat_flux/cp_ocean)
! swflux is proper flux.
! Heat flux term : -(alpha*g/rho_cp)*(Heat flux into ocean)
! SSW term       : -(alpha*g/rho_cp)*(penetrating component of SSW)
! Salt term      : (beta*g)*salinty(surface)*(freshwater flux into ocean)
!

  do j=jsc,jec
    do i=isc,iec
!
! Calculate buoyancy fluxes in mixed layer
!
      BoT=-(grav*rho0r)*(talpha(i,j)/ (Dens%rho(i,j,1,tau)+epsln)) * T_prog(index_temp)%stf(i,j)
      Bosol(i,j) =-(grav*rho0r)* (talpha(i,j)/(Dens%rho(i,j,1,tau)+epsln)) * F_vis * swflx(i,j)/cp_ocean
      BoS=-(grav*rho0r) * Dens%rho_salinity(i,j,1,tau) *pme(i,j) * sbeta(i,j) / (Dens%rho(i,j,1,tau)+epsln)
!
      BoTot = BoT + BoS - Bosol(i,j)

! Penetrative SSW contribution
      exdepth=exp(-hbl(i,j)/ssw_atten_depth(i,j))
      pen_ke= Bosol(i,j)*(hbl(i,j)*(1+exdepth)-2.0*ssw_atten_depth(i,j)*(1.0-exdepth))

      wind_mixing(i,j)= 2.0 * bulk_tm * Velocity%ustar(i,j)**3
      bulk_tke(i,j)=((1+bulk_tn)*BoTot-(1.0-bulk_tn)*abs(BoTot))/2.0
      tke(i,j)=Grd%tmask(i,j,1)*(wind_mixing(i,j)+hbl(i,j)*bulk_tke(i,j)+pen_ke)
    enddo
  enddo
  do j=jsd,jed
    do i=isd,ied
      if(kbl(i,j) > 0) then
         saltbl(i,j) = Dens%rho_salinity(i,j,kbl(i,j),taum1)
         tempbl(i,j) = T_prog(index_temp)%field(i,j,kbl(i,j),taum1)
         pressbl(i,j)= Dens%pressure_at_depth(i,j,kbl(i,j))
      end if
    enddo
  enddo
!
! Calculate densities across mixed layer
!
  density_mixed=density(saltbl,tempbl,pressbl)

  do j=jsd,jed
    do i=isd,ied
      saltbl(i,j) = Dens%rho_salinity(i,j,kblm1(i,j),taum1)
      tempbl(i,j) = T_prog(index_temp)%field(i,j,kblm1(i,j),taum1)
    enddo
  enddo
  density_mixed_1=density(saltbl,tempbl,pressbl)
!
! Calculate and limit buoyancy differential
!
  dbloc=max(2.5e-4,grav*(density_mixed-density_mixed_1)*rho0r)


!
! Entrain mixed layer where necessary and limit by depth of next layer
! and maximum growth rate
!
  do j=jsc,jec
    do i=isc,iec
      hbltemp=hbl(i,j)+tracer_timestep*min(max(tke(i,j),0.0)/(dbloc(i,j)*hbl(i,j)+epsln),hbl_growth_max)
!
! Alternate update which will be better when winds dominate
!
! hbltemp=min(sqrt(hbl(i,j)**2+2.0*tracer_timestep*(max(tke(i,j),0.0)/dbloc(i,j)), &
!              hbl(1,j)+tracer_timestep*hbl_growth_max)
      hbl(i,j)=min(hbltemp,Grd%zt(kblp1(i,j)))*Grd%tmask(i,j,1)
    enddo
  enddo


  kbl(:,:)=1
  do j=jsc,jec
!
! Newton Raphson scheme for detrainment.
!
! Convergence is checked on a row by row basis in order to vectorise.
!
    call nr_for_chen(wind_mixing(isc:iec,j),bulk_tke(isc:iec,j),Bosol(isc:iec,j),ssw_atten_depth(isc:iec,j), &
                tke(isc:iec,j),hbl(isc:iec,j))
    mixmask(:,j,:)=0.0
    do k=1,nk
      do i=isc,iec
        if(hbl(i,j) >= Grd%zt(k)) then 
          kbl(i,j)=min(Grd%kmt(i,j),kbl(i,j)+1)
          mixmask(i,j,k)=1.0
        endif
      enddo
    enddo
    kbl=max(kbl,1)
    do i=isc,iec
      kbl_m1=max(1,kbl(i,j)-1)
      shallow=max(hbl(i,j),Grd%zt(1))-Grd%zt(kbl_m1)
#ifdef defined(ACCESS_CM)
      !dhb599: try to avoid "floating invalid" here:
      mixmask(i,j,kbl(i,j))=shallow/(Grd%zt(kbl(i,j))-Grd%zt(kbl_m1)+ 1.0e-10)
#else
      mixmask(i,j,kbl(i,j))=shallow/(Grd%zt(kbl(i,j))-Grd%zt(kbl_m1)+ epsln)
#endif
    enddo
  enddo

  call diagnose_2d(Time, Grd, id_wmix, wind_mixing(:,:))
  call diagnose_2d(Time, Grd, id_bte, bulk_tke(:,:))
  call diagnose_2d(Time, Grd, id_dbloc, dbloc(:,:))
  call diagnose_2d(Time, Grd, id_tke, tke(:,:))
  call diagnose_2d(Time, Grd, id_hbl, hbl(:,:))

end subroutine kraus_turner
! </SUBROUTINE> NAME="kraus_turner"


subroutine nr_for_chen(a,b,c,h,tkeinit,z)
!
! Hybrid Newton Raphson, half interval search
!
! Equation is of the form
!
! f(z)=a+b*z+c*(z*(1+exp(z/h)-2*h*(1-exp(z/h))
!
! Where a,b,c,h are constant for each point.
!
! We wish to solve f(z)=0 for those points where detrainment takes place. That
! is when f(z_init)=tkinit < 0
!
! Note that a>=0 so we must have a solution in the interval [0,z_init)
!
! A global convergence criteria of 0.01m is used
! No changes are made if the local change is less than crit. This should enable reproduciblity.
! 

  real, dimension(isc:iec),intent(in)    :: a,b,c,h,tkeinit
  real, dimension(isc:iec),intent(inout) :: z


  real, dimension(isc:iec)   :: z_left,z_half
  real, dimension(isc:iec)   :: dz_old,dz
  real,dimension(isc:iec)    :: f,df
  real                       :: texp
  logical:: converge
  integer i,its
  real :: crit
  crit = 0.01

  do i=isc,iec
    z_half(i)=0.0
    z_left(i)=z(i)
    if(tkeinit(i) < 0) then
      dz_old(i)=z_left(i)
      dz(i)=z_left(i)
    else
      dz_old(i)=0.0
      dz(i)=0.0
    endif
    z(i)=z_left(i)
    f(i)=tkeinit(i)
    df(i)=b(i)+c(i)*(1.0-exp(-z(i)/h(i)))*(1.0+z(i)/h(i))
  enddo
  converge=.false.
  its=0
  do while(its .lt. 20 .and. (.not. converge))
    its=its+1
    do i=isc,iec
      if(tkeinit(i) < 0.0 .and. abs(dz(i)) > crit) then
        if(((z(i)-z_half(i))*df(i)-f(i))*((z(i)-z_left(i))*df(i)-f(i)) >= 0.0 .or. &
           abs(2.0*f(i)) > abs(dz_old(i)*df(i))) then

! If proposed solution is outside range or slow convergence use half interval
! search
           
          dz_old(i)=dz(i)
          dz(i)=0.5*(z_half(i)-z_left(i))
          z(i)=z_left(i)+dz(i)
        else
          dz_old(i)=dz(i)
          dz(i)=f(i)/df(i)
          z(i)=z(i)-dz(i)
        endif
        texp=exp(-z(i)/h(i))
        f(i)=a(i)+z(i)*b(i)+c(i)*(z(i)*(1+texp)-2.0*h(i)*(1.0-texp))
        df(i)=b(i)+c(i)*(1-texp*(1.0+z(i)/h(i)))
        if(f(i) < 0.0) then
          z_left(i)=z(i)
        else
          z_half(i)=z(i)
        endif
      endif
    enddo
    converge=maxval(abs(dz)) <= crit
  enddo
  end subroutine nr_for_chen


!#######################################################################
! <SUBROUTINE NAME="ri_for_chen">
!
! <DESCRIPTION>
! Compute Richardson number on tracer and velocity cell bottoms. 
!  rit = richardson number at bottom of T cells <BR/>
!  riu = richardson number at bottom of U cells
! </DESCRIPTION>
!
subroutine ri_for_chen (Time, Thickness, Velocity, T_prog, pressure_at_depth, rho, rho_taum1, rho_salinity)

  type(ocean_time_type),          intent(in) :: Time
  type(ocean_thickness_type),     intent(in) :: Thickness
  type(ocean_velocity_type),      intent(in) :: Velocity
  type(ocean_prog_tracer_type),   intent(in) :: T_prog(:)
  real, dimension(isd:,jsd:,:),   intent(in) :: pressure_at_depth
  real, dimension(isd:,jsd:,:),   intent(in) :: rho
  real, dimension(isd:,jsd:,:),   intent(in) :: rho_taum1
  real, dimension(isd:,jsd:,:,:), intent(in) :: rho_salinity

  integer :: i, j, k, tlev,  mr, tau, taum1
  real :: active_cells, fx, t1 

  real  :: ri_temp1(isd:ied),ri_temp2(isd:ied)

  logical :: smooth_richardson_number = .true.
  integer :: num_smoothings = 1 ! for vertical smoothing of Richardson number

  real,parameter :: epsln_chen=1.e-10


  fx   = -0.25*grav*rho0r

  tau = Time%tau
  taum1 = Time%taum1

  ! compute density difference across bottom of T cells at tau-1

  if (aidif == 1.0) then
    tlev = tau
    wrk1(:,:,:) = density_delta_z(rho(:,:,:), rho_salinity(:,:,:,tau),             &
                                              T_prog(index_temp)%field(:,:,:,tau), & 
                                              pressure_at_depth(:,:,:))
  else
    tlev = taum1
    wrk1(:,:,:) = density_delta_z(rho_taum1(:,:,:), rho_salinity(:,:,:,taum1), &
                                 T_prog(index_temp)%field(:,:,:,taum1), pressure_at_depth(:,:,:))
  endif

  ! compute richardson numbers on bottom of U cells
  do k=1,nk-1
    do j=jsd,jed-1
      do i=isd,ied-1
        t1 = fx*Thickness%dzwt(i,j,k)
        riu(i,j,k) = t1*Grd%umask(i,j,k+1)*(wrk1(i,j+1,k) + wrk1(i+1,j+1,k) + wrk1(i,j,k)   + wrk1(i+1,j,k)) /&
                      ((Velocity%u(i,j,k,1,tlev) - Velocity%u(i,j,k+1,1,tlev))**2 + &
                       (Velocity%u(i,j,k,2,tlev) - Velocity%u(i,j,k+1,2,tlev))**2 + epsln_chen)
      enddo
    enddo
  enddo

  if (smooth_richardson_number) then

    ! smooth Richardson number in the vertical using a 1-2-1 filter:

    do mr = 1,num_smoothings
      do j=jsd,jed-1
         do i=isd,ied-1
            ri_temp2(i)    =  riu(i,j,1)
         enddo
         do k=2,nk-2
!CDIR NODEP
            do i=isd,ied-1
              if(k < Grd%kmu(i,j) -1) then
              ri_temp1(i)        =  ri_temp2(i)
              ri_temp2(i)        =  riu(i,j,k)
              riu(i,j,k) = 0.25*ri_temp1(i) + 0.5 * riu(i,j,k) + 0.25 * riu(i,j,k+1)
              endif
            enddo
         enddo
      enddo
    enddo
  endif

  riu=max(min(riu,10.0),-10.0)
  ! compute richardson numbers on bottom of T cells as average
  ! of four nearest richardson numbers on bottom of U cells.
  ! (do not consider land cells in the average... only active ones)

  do k=1,nk-1
    do j=jsc,jec
      do i=isc,iec
        active_cells = Grd%umask(i,j,k+1) + Grd%umask(i-1,j,k+1) + Grd%umask(i,j-1,k+1) + Grd%umask(i-1,j-1,k+1) + epsln_chen
        rit(i,j,k)   = (riu(i,j,k) + riu(i-1,j,k) + riu(i,j-1,k) + riu(i-1,j-1,k))/active_cells

        ! make sure no static instability exists (one that is not seen
        ! by the Richardson number).  This may happen due to
        ! horizontal averaging used in calculating the Richardson
        ! number.

        if (rit(i,j,k) > 0.0 .and. wrk1(i,j,k) > 0.0) then
          rit(i,j,k) = -0.01
        endif
      enddo
    enddo
  enddo
  rit=max(min(rit,10.0),-10.0)

end subroutine ri_for_chen
! </SUBROUTINE> NAME="ri_for_chen"


!#######################################################################
! <SUBROUTINE NAME="ocean_vert_chen_restart">
! <DESCRIPTION>
!  Write out restart files registered through register_restart_file
! </DESCRIPTION>
subroutine ocean_vert_chen_restart(time_stamp)
  character(len=*), intent(in), optional :: time_stamp

  call save_restart(Che_restart, time_stamp)

end subroutine ocean_vert_chen_restart
! </SUBROUTINE> NAME="ocean_vert_chen_restart"


!#######################################################################
! <SUBROUTINE NAME="ocean_vert_chen_end">
!
! <DESCRIPTION>
! Save the Kraus boundary layer depth to start next time step. 
! </DESCRIPTION>
!
subroutine ocean_vert_chen_end(Time)

  type(ocean_time_type), intent(in) :: Time

  integer :: stdoutunit 
  stdoutunit=stdout() 

  write(stdoutunit,*)' ' 
  write(stdoutunit,*) 'From ocean_vert_chen: ending hbl checksum for kraus.res.nc'
  call write_timestamp(Time%model_time)
  call write_chksum_2d('hbl', hbl(COMP)*Grd%tmask(COMP,1))

  return 

end subroutine ocean_vert_chen_end  
! </SUBROUTINE> NAME="ocean_vert_chen_end"


end module ocean_vert_chen_mod

module topog_regularization_mod

!  produces regularized topography according to Lindberg and Broccoli,
!  J. of Climate vol 9, no 11 pg. 2641-2659 (1996)

!  Originally coded by Charles Jackson
!  Modified for FMS by Peter Phillipps

use             fms_mod, only: mpp_pe, mpp_root_pe, error_mesg, FATAL, &
                               write_version_number

use             mpp_mod, only: mpp_chksum

use       constants_mod, only: pi

use      transforms_mod, only: compute_gaussian, compute_legendre, &
                               trans_grid_to_spherical, trans_spherical_to_grid,          &
                               get_sin_lat, get_wts_lat, transforms_are_initialized,      &
                               get_lon_max, get_lat_max, get_num_fourier, get_fourier_inc,&
                               get_num_spherical, get_grid_domain, get_spec_domain,       &
                               grid_domain, spectral_domain, area_weighted_global_mean

use     mpp_domains_mod, only: mpp_global_field

implicit none
private

character(len=128), parameter :: version = &
'$Id: topog_regularization.F90,v 13.0 2006/03/28 21:17:37 fms Exp $'

character(len=128), parameter :: tagname = &
'$Name: tikal $'

public :: compute_lambda, regularize

integer, parameter :: itmax=1000
real,    parameter :: tolerance = 1.e-5

integer :: is, ie, js, je, ms, me, ns, ne
integer :: lon_max, lat_max, num_fourier, num_spherical, fourier_inc, nmax

real,    allocatable, dimension(:,:  ) :: smoothed_field_tmp, rough, cost_field
real,    allocatable, dimension(:    ) :: wts_lat_global, sin_lat_global, facm, sin_facm
complex, allocatable, dimension(:,:  ) :: Dnm, anm, bnm, Hnm, DR2, DelAnm, DelBnm

logical :: module_is_initialized=.false.

character(len=8) :: chtmp1, chtmp2

contains

!============================================================================================

subroutine compute_lambda(ocean_topog_smoothing, ocean_mask, unsmoothed_field, lambda, actual_fraction_smoothed)

real,    intent(in) :: ocean_topog_smoothing
logical, intent(in), dimension(:,:) :: ocean_mask
real,    intent(in), dimension(:,:) :: unsmoothed_field
real,    intent(out) :: lambda, actual_fraction_smoothed

real :: lambda_1, lambda_2, fraction_smoothed_1, fraction_smoothed_2
real :: tol_lambda = .001
integer :: it_lambda, itmax_lambda=20

if(.not.module_is_initialized) then
  call topog_regularization_init(ocean_mask)
endif

if(any(shape(unsmoothed_field) /= (/ie-is+1,je-js+1/))) then
  write(chtmp1,'(2i4)') shape(unsmoothed_field)
  write(chtmp2,'(2i4)')  (/ie-is+1,je-js+1/)
  call error_mesg('compute_lambda', &
    'Input argument unsmoothed_field has incorrect dimensions. shape(unsmoothed_field)='//chtmp1//'  Should be '//chtmp2,FATAL)
endif

lambda_1 = 1.e-7
lambda_2 = 2.e-7
call regularize(lambda_1, ocean_mask, unsmoothed_field, smoothed_field_tmp, fraction_smoothed_1)
if(abs(ocean_topog_smoothing-fraction_smoothed_1) < tol_lambda) then
  lambda = lambda_1
  actual_fraction_smoothed = fraction_smoothed_1
  goto 20
endif
call regularize(lambda_2, ocean_mask, unsmoothed_field, smoothed_field_tmp, fraction_smoothed_2)
if(abs(ocean_topog_smoothing-fraction_smoothed_2) < tol_lambda) then
  lambda = lambda_2
  actual_fraction_smoothed = fraction_smoothed_2
  goto 20
endif
if(fraction_smoothed_1 > ocean_topog_smoothing .or. fraction_smoothed_2 > ocean_topog_smoothing) then
  call error_mesg('compute_lambda', &
     'Iterative scheme for computing lambda may not work unless initial values of lambda_1 and lambda_2 are reduced.', FATAL)
endif
lambda_1 = ((fraction_smoothed_2-ocean_topog_smoothing)*lambda_1 + &
            (ocean_topog_smoothing-fraction_smoothed_1)*lambda_2)/(fraction_smoothed_2-fraction_smoothed_1)
if(lambda_1 < 0.) then
  call error_mesg('compute_lambda', &
    'Iterative scheme for finding lambda will not work unless initial values of lambda_1 and lambda_2 are reduced.', FATAL)
endif
call regularize(lambda_1, ocean_mask, unsmoothed_field, smoothed_field_tmp, fraction_smoothed_1)
do it_lambda=1,itmax_lambda
  if(abs(ocean_topog_smoothing-fraction_smoothed_1) < tol_lambda) then
    lambda = lambda_1
    actual_fraction_smoothed = fraction_smoothed_1
    goto 20
  endif
  lambda_2 = ((fraction_smoothed_2-ocean_topog_smoothing)*lambda_1 + &
              (ocean_topog_smoothing-fraction_smoothed_1)*lambda_2)/(fraction_smoothed_2-fraction_smoothed_1)
  if(lambda_2 < 0.) then
    write(chtmp1,'(i8)') it_lambda
    call error_mesg('compute_lambda', &
        'Iterative scheme for finding lambda failed. lambda went negative on iteration number'//chtmp1, FATAL)
  endif
  call regularize(lambda_2, ocean_mask, unsmoothed_field, smoothed_field_tmp, fraction_smoothed_2)
  if(abs(ocean_topog_smoothing-fraction_smoothed_2) < tol_lambda) then
    lambda = lambda_2
    actual_fraction_smoothed = fraction_smoothed_2
    goto 20
  endif
  lambda_1 = ((fraction_smoothed_2-ocean_topog_smoothing)*lambda_1 + &
              (ocean_topog_smoothing-fraction_smoothed_1)*lambda_2)/(fraction_smoothed_2-fraction_smoothed_1)

  call regularize(lambda_1, ocean_mask, unsmoothed_field, smoothed_field_tmp, fraction_smoothed_1)
enddo
call error_mesg('compute_lambda','Cannot converge on a value of lambda. Perhaps more interations are needed.', FATAL)
20 continue

return
end subroutine compute_lambda
!============================================================================================

subroutine regularize(lambda, ocean_mask, unsmoothed_field, smoothed_field, fraction_smoothed)

real,    intent(in) :: lambda
logical, intent(in),  dimension(:,:) :: ocean_mask
real,    intent(in),  dimension(:,:) :: unsmoothed_field
real,    intent(out), dimension(size(ocean_mask,1), size(ocean_mask,2)) :: smoothed_field
real,    intent(out) :: fraction_smoothed

real :: converg, cost, oldcost, lamcost, lamcosti
integer :: m, n, it

if(.not.module_is_initialized) then
  call topog_regularization_init(ocean_mask)
endif

if(any(shape(unsmoothed_field) /= (/ie-is+1,je-js+1/))) then
  write(chtmp1,'(2i4)') shape(unsmoothed_field)
  write(chtmp2,'(2i4)')  (/ie-is+1,je-js+1/)
  call error_mesg('regularize', &
   'Input argument unsmoothed_field has incorrect dimensions. shape(unsmoothed_field)='//chtmp1//'  Should be '//chtmp2,FATAL)
endif

if(is /= 1 .or. ie /= lon_max) then
  call error_mesg('regularize', &
    'subroutine regularize is not yet coded for 2-d decomposition. It was assumed that it will never be needed.',FATAL)
endif

Hnm=cmplx(0.,0.)
do n=ns,nmax
  do m=ms,me
    Hnm(m,n)=1./(1.+lambda*Dnm(m,n)*((n+m)*(n+m+1))**2)
  enddo
enddo

bnm=cmplx(0.,0.)
call trans_grid_to_spherical(unsmoothed_field,bnm)

!    anm (equation 6.3)

anm = cmplx(0.,0.)
do n=ns,nmax
  do m=ms,me
    anm(m,n)=bnm(m,n)/(1.+lambda*((n+m)*(n+m+1))**2)
  enddo
enddo

DelAnm = cmplx(0.,0.)
do n=ns,nmax
  do m=ms,me
    DelAnm(m,n)=(n+m)*(n+m+1)*anm(m,n)
  enddo
enddo

call trans_spherical_to_grid(DelAnm,rough)

converg=1.
cost=0.

DelBnm = cmplx(0.,0.)
do it=1,itmax
  if (abs(converg) < tolerance) goto 60

! rough is zeroed out over land
  where(.not.ocean_mask)
    rough = 0.
  end where

! Do an iteration of smoothing
  call trans_grid_to_spherical(rough,DR2)
  do n=ns,nmax
    do m=ms,me
      DR2(m,n)=(n+m)*(n+m+1)*DR2(m,n)
    enddo
  enddo

  do n=ns,nmax
    do m=max(ms,1),me
      anm(m,n)=(anm(m,n)+Hnm(m,n)*(bnm(m,n)-anm(m,n))-lambda*Hnm(m,n)*DR2(m,n))*sin_facm(m)/facm(m)
    enddo
  enddo
  if(ms == 0) then
    do n=ns,nmax
      anm(0,n)=anm(0,n)+Hnm(0,n)*(bnm(0,n)-anm(0,n))-lambda*Hnm(0,n)*DR2(0,n)
    enddo
  endif

! transform the smoothed field to grid
  call trans_spherical_to_grid(anm,smoothed_field)

! compute cost function (eq. 6.4)
  do n=ns,nmax
    do m=ms,me
      DelAnm(m,n)=(n+m)*(n+m+1)*anm(m,n)
    enddo
  enddo
  call trans_spherical_to_grid(DelAnm,rough)
  where(ocean_mask)
    cost_field = (unsmoothed_field-smoothed_field)**2 + lambda*rough**2
  else where
    cost_field = 0.
  end where
  oldcost=cost
  cost = area_weighted_global_mean(cost_field)

  if (it > 1) then
    converg=(oldcost-cost)/oldcost
  endif
enddo
call error_mesg('regularize','Failure to converge',FATAL)
60 continue

do n=ns,nmax
  do m=ms,me
    DelBnm(m,n)=(n+m)*(n+m+1)*bnm(m,n)
  enddo
enddo
call trans_spherical_to_grid(DelBnm,rough)
where(ocean_mask)
  cost_field = rough**2
else where
  cost_field = 0.
end where
lamcosti = area_weighted_global_mean(cost_field)
call trans_spherical_to_grid(DelAnm,rough)
where(ocean_mask)
  cost_field = rough**2
else where
  cost_field = 0.
end where
lamcost = area_weighted_global_mean(cost_field)
fraction_smoothed = 1. - lamcost/lamcosti

if(mpp_pe() == mpp_root_pe()) then
  print '("Message from subroutine regularize: lambda=",1pe16.8,"  fraction_smoothed=",1pe16.8)',lambda,fraction_smoothed
endif

return
end subroutine regularize
!===================================================================================
subroutine topog_regularization_init(ocean_mask)

logical, intent(in), dimension(:,:) :: ocean_mask
integer :: m, i, j
real,    allocatable, dimension(:,:,:) :: legendre_global, legendre
logical, allocatable, dimension(:,:) :: ocean_mask_global

call write_version_number(version, tagname)

if(.not.transforms_are_initialized()) then
  call error_mesg('topog_regularization_init','Transforms are not initialized',FATAL)
endif

call get_grid_domain(is, ie, js, je)
call get_spec_domain(ms, me, ns, ne)

if(any(shape(ocean_mask) /= (/ie-is+1,je-js+1/))) then
  write(chtmp1,'(2i4)') shape(ocean_mask)
  write(chtmp2,'(2i4)')  (/ie-is+1,je-js+1/)
  call error_mesg('topog_regularization_init', &
     'Input argument ocean_mask has incorrect dimensions. shape(ocean_mask)='//chtmp1//'  Should be '//chtmp2,FATAL)
endif

call get_lon_max(lon_max)
call get_lat_max(lat_max)
call get_num_fourier(num_fourier)
call get_num_spherical(num_spherical)
call get_fourier_inc(fourier_inc)

nmax = min(num_fourier,ne)

allocate(sin_lat_global(lat_max))
allocate(wts_lat_global(lat_max))
call get_sin_lat(sin_lat_global)
call get_wts_lat(wts_lat_global)

allocate(facm    (ms:me))
allocate(sin_facm(ms:me))
do m=ms,me
  facm(m) = pi*m/(2.*num_fourier)
  sin_facm(m) = sin(facm(m))
enddo

allocate(Dnm(ms:me,ns:ne),    Hnm(ms:me,ns:ne),    bnm(ms:me,ns:ne), anm(ms:me,ns:ne))
allocate(DR2(ms:me,ns:ne), DelAnm(ms:me,ns:ne), DelBnm(ms:me,ns:ne))
allocate(smoothed_field_tmp(is:ie,js:je), rough(is:ie,js:je), cost_field(is:ie,js:je))

allocate(legendre_global(0:num_fourier,0:num_spherical,lat_max/2))
allocate(legendre(ms:me, ns:ne, lat_max/2))
call compute_legendre(legendre_global, num_fourier, fourier_inc, num_spherical, -sin_lat_global(1:lat_max/2), lat_max/2)
legendre = legendre_global(ms:me,ns:ne,:)

allocate(ocean_mask_global(lon_max,lat_max))
call mpp_global_field(grid_domain, ocean_mask, ocean_mask_global)
Dnm=cmplx(0.,0.)
do i=1,lon_max
  do j=1,lat_max/2
    if(ocean_mask_global(i,j)) then
      Dnm = Dnm + wts_lat_global(j)*legendre(:,:,j)**2
    endif
  enddo
  do j=lat_max/2+1,lat_max
    if(ocean_mask_global(i,j)) then
      Dnm = Dnm + wts_lat_global(j)*legendre(:,:,lat_max+1-j)**2
    endif
  enddo
enddo
deallocate(legendre_global, legendre, ocean_mask_global)
Dnm = Dnm/lon_max

module_is_initialized = .true.
return

end subroutine topog_regularization_init
!===================================================================================

end module topog_regularization_mod

#include <fms_platform.h>

! ----------------------------------------------------------------
!                   GNU General Public License                        
! This file is a part of MOM.                                                                 
!                                                                      
! MOM is free software; you can redistribute it and/or modify it and  
! are expected to follow the terms of the GNU General Public License  
! as published by the Free Software Foundation; either version 2 of   
! the License, or (at your option) any later version.                 
!                                                                      
! MOM is distributed in the hope that it will be useful, but WITHOUT    
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public    
! License for more details.                                           
!                                                                      
! For the full text of the GNU General Public License,                
! write to: Free Software Foundation, Inc.,                           
!           675 Mass Ave, Cambridge, MA 02139, USA.                   
! or see:   http://www.gnu.org/licenses/gpl.html                      
!-----------------------------------------------------------------------
! 
!<CONTACT EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Jennifer Simeon
!</CONTACT>
!
!<REVIEWER EMAIL="GFDL.Climate.Model.Info@noaa.gov"> Eric Galbraith
!</REVIEWER>
!
!<OVERVIEW>
! Add-on ocean biogeochemistry module
!</OVERVIEW>
!
!<DESCRIPTION>
! This module has simple implementation of preformed phosphate.
! Where,
!    po4_pre=po4, if z <= mld
!
! It is an optional package that requires TOPAZ, ocmip2_biotic, or ocean_bgc_restore to be running.
!
! Various mixed layer depth options are available and can be
! set via namelist
!
!         1 = kpp mixed layer (default)
!         2 = buoyancy criteria defined mixed layer, where this buoyancy
!              references in situ density
!         3 = buoyancy criteria defined mixed layer, where this buoyancy 
!              references potential density
!
!</DESCRIPTION>
!
! <INFO>
! <REFERENCE>
! No reference yet.
! </REFERENCE>
!
! </INFO>
!

module  ocean_po4_pre_mod

use diag_manager_mod, only: register_diag_field, diag_axis_init
use field_manager_mod, only: fm_get_index
use field_manager_mod,        only: fm_field_name_len, fm_path_name_len, fm_string_len
use field_manager_mod,        only: fm_get_length, fm_get_value, fm_new_value
use mpp_mod,                  only: stdout, stdlog, mpp_error, mpp_sum, FATAL
use fms_mod,                  only: field_exist
use time_manager_mod,         only: get_date, time_type
use mpp_domains_mod,          only: domain2d

use ocean_tpm_util_mod, only: otpm_set_tracer_package, otpm_set_prog_tracer
use fm_util_mod,        only: fm_util_check_for_bad_fields, fm_util_set_value
use fm_util_mod,        only: fm_util_get_string, fm_util_get_logical, fm_util_get_integer, fm_util_get_real
use fm_util_mod,        only: fm_util_get_logical_array, fm_util_get_real_array, fm_util_get_string_array
use fm_util_mod,        only: fm_util_start_namelist, fm_util_end_namelist
use ocean_types_mod,    only: ocean_prog_tracer_type, ocean_diag_tracer_type
use ocean_types_mod,    only: ocean_thickness_type, ocean_time_type, ocean_density_type
use ocean_tracer_diag_mod, only: calc_mixed_layer_depth, calc_potrho_mixed_layer

implicit none

private

public  :: ocean_po4_pre_bbc
public  :: ocean_po4_pre_end
public  :: ocean_po4_pre_init
public  :: ocean_po4_pre_flux_init
public  :: ocean_po4_pre_sbc
public  :: ocean_po4_pre_source
public  :: ocean_po4_pre_start
public  :: ocean_po4_pre_tracer
public  :: ocean_po4_pre_init_sfc
public  :: ocean_po4_pre_avg_sfc
public  :: ocean_po4_pre_sum_sfc
public  :: ocean_po4_pre_zero_sfc
public  :: ocean_po4_pre_sfc_end

private :: allocate_arrays
private :: set_array

character(len=32), parameter              :: package_name = 'ocean_po4_pre'
character(len=48), parameter              :: mod_name = 'ocean_po4_pre_mod'
character(len=fm_string_len), parameter   :: default_restart_file =   'ocean_po4_pre.res.nc'
character(len=fm_string_len), parameter   :: default_phosphate_name = 'po4'

type mask_region_type
  real, dimension(:,:,:), pointer       :: mask => NULL()
  real, dimension(:), pointer           :: elon => NULL()
  real, dimension(:), pointer           :: nlat => NULL()
  real, dimension(:), pointer           :: slat => NULL()
  real, dimension(:), pointer           :: wlon => NULL()
  logical                               :: coastal_only
  real                                  :: factor
  logical, dimension(:), pointer        :: t_mask => NULL()
end type mask_region_type


type po4_pre_type

  integer                               :: ind_po4_pre = -1
  character(len=fm_string_len)          :: restart_file
  character(len=fm_field_name_len)      :: name
  integer                               :: mld_option 
  type(mask_region_type)                :: po4_pre_mask
  real, _ALLOCATABLE, dimension(:,:)    :: ml_depth  _NULL
  character(len=fm_string_len)          :: phosphate_name

end type po4_pre_type

logical, public :: do_ocean_po4_pre

integer                                 :: package_index
logical                                 :: module_initialized = .false.

character(len=128) :: version = '$Id: ocean_po4_pre.F90,v 20.0 2013/12/14 00:09:36 fms Exp $'
character(len=128) :: tagname = '$Name: tikal $'

type(po4_pre_type), allocatable, dimension(:)    :: po4_pre
integer                                          :: instances
integer                                          :: indtemp, indsal, indpo4

contains

!#######################################################################
! <SUBROUTINE NAME="allocate_arrays">
!
! <DESCRIPTION>
!     Dynamically allocate arrays
! </DESCRIPTION>
!

subroutine allocate_arrays(isd, ied, jsd, jed)

integer, intent(in)     :: isd
integer, intent(in)     :: ied
integer, intent(in)     :: jsd
integer, intent(in)     :: jed

integer :: n

do n = 1, instances
       allocate( po4_pre(n)%ml_depth(isd:ied,jsd:jed) )
       po4_pre(n)%ml_depth(:,:) = 0.0
enddo

return
end subroutine  allocate_arrays
! </SUBROUTINE> NAME="allocate_arrays"


!#######################################################################
! <SUBROUTINE NAME="ocean_po4_pre_bbc">
!
! <DESCRIPTION>
!     calculate the surface boundary conditions
! </DESCRIPTION>
!

subroutine ocean_po4_pre_bbc

end subroutine  ocean_po4_pre_bbc
! </SUBROUTINE> NAME="ocean_po4_pre_bbc"


!#######################################################################
! <SUBROUTINE NAME="ocean_po4_pre_end">
!
! <DESCRIPTION>
!     Clean up various PO4_PRE quantities for this run.
! </DESCRIPTION>

subroutine ocean_po4_pre_end(isc, iec, jsc, jec, nk, isd, jsd,  &
                             t_prog, grid_dat, grid_tmask, rho_dzt, taup1)

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: nk
type(ocean_prog_tracer_type), intent(in), dimension(:)  :: t_prog
integer, intent(in)                                     :: taup1
real, dimension(isd:,jsd:), intent(in)                  :: grid_dat
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho_dzt

integer :: i, j, k, n
real    :: total_po4_pre

  integer :: stdoutunit 
  stdoutunit=stdout() 

!       integrate the total concentrations of some tracers
!       for the end of the run

!       Use taup1 time index for the end of a run, and taup1 time
!       index for the end of a run so that we are integrating the
!       same time level and should therefore get identical results
do n = 1, instances
  total_po4_pre = 0.0
  do k = 1,nk
    do j = jsc, jec
      do i = isc, iec
        total_po4_pre = total_po4_pre +                                   &
             t_prog(po4_pre(n)%ind_po4_pre)%field(i,j,k,taup1) *      &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)
      enddo
    enddo
  enddo

  call mpp_sum(total_po4_pre)

  write (stdoutunit,*) '  Instance ', trim(po4_pre(n)%name)
  write (stdoutunit,                                              &
         '(/'' Total preformed phosphate  = '',es19.12,'' Gmol-PO4'')')        &
              total_po4_pre * 1.0e-09
enddo

end subroutine  ocean_po4_pre_end
! </SUBROUTINE> NAME="ocean_po4_pre_end"


!#######################################################################
! <SUBROUTINE NAME="ocean_po4_pre_sbc">
!
! <DESCRIPTION>
!     Calculate the surface boundary conditions
! </DESCRIPTION>

subroutine ocean_po4_pre_sbc

end subroutine  ocean_po4_pre_sbc
! </SUBROUTINE> NAME="ocean_po4_pre_sbc"


!#######################################################################
! <SUBROUTINE NAME="ocean_po4_pre_flux_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the ocean-atmosphere gas fluxes
! </DESCRIPTION>

subroutine ocean_po4_pre_flux_init

end subroutine  ocean_po4_pre_flux_init
! </SUBROUTINE> NAME="ocean_po4_pre_flux_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_po4_pre_init">
!
! <DESCRIPTION>
!       Set up any extra fields needed by the tracer packages
!
!       Save pointers to various "types", such as Grid and Domains.
! </DESCRIPTION>
subroutine ocean_po4_pre_init

character(len=64), parameter    :: sub_name = 'ocean_po4_pre_init'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '): '
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '): '

integer                                                 :: n
character(len=fm_field_name_len)                        :: name
character(len=fm_path_name_len)                         :: path_to_names
character(len=fm_field_name_len+1)                      :: suffix
character(len=fm_field_name_len+3)                      :: long_suffix
logical, dimension(12)                                  :: t_mask
character(len=256)                                      :: caller_str
character(len=fm_string_len), pointer, dimension(:)     :: good_list

  integer :: stdoutunit 
  stdoutunit=stdout() 

  ! Initialize the package
package_index = otpm_set_tracer_package(package_name,                 &
     restart_file = default_restart_file,   &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')

! Check whether to use this package
path_to_names = '/ocean_mod/tracer_packages/' // trim(package_name) // '/names'
instances = fm_get_length(path_to_names)
if (instances .lt. 0) then
  call mpp_error(FATAL, trim(error_header) // 'Could not get number of instances')
endif

! Check some things
write (stdoutunit,*)
if (instances .eq. 0) then
  write (stdoutunit,*) trim(note_header), ' No instances'
  do_ocean_po4_pre = .false.
else
  if (instances .eq. 1) then
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instance'
  else
    write (stdoutunit,*) trim(note_header), ' ', instances, ' instances'
  endif

    do_ocean_po4_pre = .true.
endif

module_initialized = .true.

!       Return if we don't want to use this package,
!       after changing the list back
if (.not. do_ocean_po4_pre) then
  return
endif

! allocate storage for po4_pre array
allocate ( po4_pre(instances) )

! loop over the names, saving them into the po4_pre array
do n = 1, instances

  if (fm_get_value(path_to_names, name, index = n)) then
    po4_pre(n)%name = name
  else
    write (name,*) n
    call mpp_error(FATAL, trim(error_header) //        &
         'Bad field name for index ' // trim(name))
  endif

enddo

! Set up the field input
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances

  name = po4_pre(n)%name
  if (name(1:1) .eq. '_') then
    suffix = ' '
    long_suffix = ' '
  else
    suffix = '_' // name
    long_suffix = ' (' // trim(name) // ')'
  endif

  ! PO4_pre
  po4_pre(n)%ind_po4_pre = otpm_set_prog_tracer('po4_pre' // suffix, package_name,   &
       longname = 'Preformed Phosphate' // trim(long_suffix),                      &
       units = 'mol/kg', flux_units = 'mol/m-2/s',             &
       caller = caller_str)
enddo

!       Process the namelists

! Add the package name to the list of good namelists, to be used
! later for a consistency check
if (fm_new_value('/ocean_mod/GOOD/good_namelists', package_name, append = .true.) .le. 0) then
  call mpp_error(FATAL, trim(error_header) //                           &
       ' Could not add ' // trim(package_name) // ' to "good_namelists" list')
endif

!       Set up the instance namelists
t_mask(:) = .true.

do n = 1, instances
   ! create the instance namelist
  call fm_util_start_namelist(package_name, po4_pre(n)%name, caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('restart_file', default_restart_file)
  call fm_util_set_value('mld_option', 1)
  call fm_util_set_value('phosphate_name', default_phosphate_name)

  call fm_util_end_namelist(package_name, po4_pre(n)%name, check = .true., caller = caller_str)

  ! create some sub-namelists
  call fm_util_start_namelist(trim(package_name), trim(po4_pre(n)%name) // '+po4_pre_mask',     &
       caller = caller_str, no_overwrite = .true., &
       check = .true.)

  call fm_util_set_value('factor', 0.0)
  call fm_util_set_value('coastal_only', .false.)
  call fm_util_set_value('t_mask', t_mask, size(t_mask))
  call fm_util_set_value('wlon', 0.0, index = 0)
  call fm_util_set_value('elon', 0.0, index = 0)
  call fm_util_set_value('slat', 0.0, index = 0)
  call fm_util_set_value('nlat', 0.0, index = 0)

  call fm_util_end_namelist(trim(package_name), trim(po4_pre(n)%name) // '+po4_pre_mask', caller = caller_str)
enddo

! Check for any errors in the number of fields in the namelists for this package
good_list => fm_util_get_string_array('/ocean_mod/GOOD/namelists/' // trim(package_name) // '/good_values',   &
     caller = trim(mod_name) // '(' // trim(sub_name) // ')')
if (associated(good_list)) then
  call fm_util_check_for_bad_fields('/ocean_mod/namelists/' // trim(package_name), good_list,       &
       caller = trim(mod_name) // '(' // trim(sub_name) // ')')
  deallocate(good_list)
else
  call mpp_error(FATAL,trim(error_header) // ' Empty "' // trim(package_name) // '" list')
endif

return

end subroutine ocean_po4_pre_init
! </SUBROUTINE> NAME="ocean_po4_pre_init"


!#######################################################################
! <SUBROUTINE NAME="ocean_po4_pre_init_sfc">
!
! <DESCRIPTION>
!       Initialize surface fields for flux calculations
!
!       Note: this subroutine should be merged into ocean_po4_pre_start
! </DESCRIPTION>

subroutine ocean_po4_pre_init_sfc

end subroutine ocean_po4_pre_init_sfc
! </SUBROUTINE> NAME="ocean_po4_pre_init_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_po4_pre_sum_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>

subroutine ocean_po4_pre_sum_sfc

end subroutine ocean_po4_pre_sum_sfc
! </SUBROUTINE> NAME="ocean_po4_pre_sum_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_po4_pre_zero_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>

subroutine ocean_po4_pre_zero_sfc

end subroutine ocean_po4_pre_zero_sfc
! </SUBROUTINE> NAME="ocean_po4_pre_zero_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_po4_pre_avg_sfc">
!
! <DESCRIPTION>
!       Sum surface fields for flux calculations
! </DESCRIPTION>

subroutine ocean_po4_pre_avg_sfc

end subroutine ocean_po4_pre_avg_sfc
! </SUBROUTINE> NAME="ocean_po4_pre_avg_sfc"


!#######################################################################
! <SUBROUTINE NAME="ocean_po4_pre_sfc_end">
!
! <DESCRIPTION>
!       Finish up stuff for surface fields for flux calculations
! </DESCRIPTION>

subroutine ocean_po4_pre_sfc_end

end subroutine ocean_po4_pre_sfc_end
! </SUBROUTINE> NAME="ocean_po4_pre_sfc_end"


!#######################################################################
! <SUBROUTINE NAME="ocean_po4_pre_source">
!
! <DESCRIPTION>
!     compute the source terms for the PO4_PREs, including boundary
!     conditions (not done in setvbc, to minimize number
!     of hooks required in MOM base code)
! </DESCRIPTION>

subroutine ocean_po4_pre_source

end subroutine  ocean_po4_pre_source
! </SUBROUTINE> NAME="ocean_po4_pre_source"


!#######################################################################
! <SUBROUTINE NAME="ocean_po4_pre_start">
!
! <DESCRIPTION>
! Initialize variables, read in namelists, calculate constants for a given run
! and allocate diagnostic arrays
! </DESCRIPTION>

subroutine ocean_po4_pre_start(isc, iec, jsc, jec, nk, isd, ied, jsd, jed,      &
     T_prog, taup1, grid_dat, grid_tmask, grid_kmt,                 &
     grid_xt, grid_yt, rho_dzt)

character(len=64), parameter    :: sub_name = 'ocean_po4_pre_start'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '): '
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '): '

integer, intent(in)                                     :: isc
integer, intent(in)                                     :: iec
integer, intent(in)                                     :: jsc
integer, intent(in)                                     :: jec
integer, intent(in)                                     :: nk
integer, intent(in)                                     :: isd
integer, intent(in)                                     :: ied
integer, intent(in)                                     :: jsd
integer, intent(in)                                     :: jed
type(ocean_prog_tracer_type), dimension(:), intent(in)  :: T_prog
integer, intent(in)                                     :: taup1
real, dimension(isd:,jsd:), intent(in)                  :: grid_dat
real, dimension(isd:,jsd:,:), intent(in)                :: grid_tmask
integer, dimension(isd:,jsd:), intent(in)               :: grid_kmt
real, dimension(isd:,jsd:), intent(in)                  :: grid_xt
real, dimension(isd:,jsd:), intent(in)                  :: grid_yt
real, dimension(isd:,jsd:,:,:), intent(in)              :: rho_dzt

!       Global values to apply the following inhibitions
!       and depletions
!
!  coastal_only : if true, then only apply the changes in
!                 coastal boxes
!  t_mask_len   : parameter giving the number of elements in
!                 the time mask per year (eg., 12 would
!                 imply monthly)
!  t_mask_array : logical array controlling whether to apply
!                 the following inhibitions and depletions to
!                 each time-period (true means set the masks,
!                 false means use the defaults everywhere)
!  num_reg      : number of regions
!  factor       : factor by which to scale the field
!               : in the selected regions
!  wlon : western longitude of region
!  elon : eastern longitude of region
!  slat : southern latitude of region
!  nlat : northern latitude of region
!  mask(imt,jmt)  : mask array (0.0 - alternate, 1.0 - normal)
!
!       Set up a mask array using wlon,elon,nlat,slat
!       (any box with its lon,lat inside the box bounded by
!       wlon,elon,nlat,slat value in mask set to factor).

integer                                 :: i, j, k, l, n
integer                                 :: done
character(len=256)                      :: caller_str
integer                                 :: len_w
integer                                 :: len_e
integer                                 :: len_s
integer                                 :: len_n
real                                    :: total_po4_pre
character(len=25)                       :: po4_tree_path

  integer :: stdoutunit 
  stdoutunit=stdout() 

write(stdoutunit,*) 
write(stdoutunit,*) trim(note_header),                     &
                  'Starting ', trim(package_name), ' module'

!     dynamically allocate the global PO4_PRE arrays
call allocate_arrays(isd, ied, jsd, jed)

!       read in the namelists for each instance
caller_str = trim(mod_name) // '(' // trim(sub_name) // ')'

do n = 1, instances
  call fm_util_start_namelist(package_name, po4_pre(n)%name, caller = caller_str)

  po4_pre(n)%restart_file           = fm_util_get_string ('restart_file', scalar = .true.)
  po4_pre(n)%mld_option             = fm_util_get_integer ('mld_option', scalar = .true.)
  po4_pre(n)%phosphate_name         = fm_util_get_string ('phosphate_name', scalar = .true.)


  call fm_util_end_namelist(package_name, po4_pre(n)%name, caller = caller_str)

  call fm_util_start_namelist(trim(package_name), trim(po4_pre(n)%name) // '+po4_pre_mask', caller = caller_str)

  po4_pre(n)%po4_pre_mask%factor        =  fm_util_get_real          ('factor', scalar = .true.)
  po4_pre(n)%po4_pre_mask%coastal_only  =  fm_util_get_logical       ('coastal_only', scalar = .true.)
  po4_pre(n)%po4_pre_mask%wlon          => fm_util_get_real_array    ('wlon')
  po4_pre(n)%po4_pre_mask%elon          => fm_util_get_real_array    ('elon')
  po4_pre(n)%po4_pre_mask%slat          => fm_util_get_real_array    ('slat')
  po4_pre(n)%po4_pre_mask%nlat          => fm_util_get_real_array    ('nlat')
  po4_pre(n)%po4_pre_mask%t_mask        => fm_util_get_logical_array ('t_mask')

  call fm_util_end_namelist(trim(package_name), trim(po4_pre(n)%name) // '+po4_pre_mask', caller = caller_str)
enddo

!       read in the po4_pre_mask namelist data
do n = 1, instances
  if (associated(po4_pre(n)%po4_pre_mask%wlon)) then
    len_w = size(po4_pre(n)%po4_pre_mask%wlon)
  else
    len_w = 0
  endif
  if (associated(po4_pre(n)%po4_pre_mask%elon)) then
    len_e = size(po4_pre(n)%po4_pre_mask%elon)
  else
    len_e = 0
  endif
  if (associated(po4_pre(n)%po4_pre_mask%slat)) then
    len_s = size(po4_pre(n)%po4_pre_mask%slat)
  else
    len_s = 0
  endif
  if (associated(po4_pre(n)%po4_pre_mask%nlat)) then
    len_n = size(po4_pre(n)%po4_pre_mask%nlat)
  else
    len_n = 0
  endif

  if (len_e .ne. len_w .or. len_w .ne. len_s .or. len_s .ne. len_n) then
    call mpp_error(FATAL, trim(error_header) // ' Region sizes are not equal')
  endif

  if (size(po4_pre(n)%po4_pre_mask%t_mask) .ne. 12) then
    call mpp_error(FATAL, trim(error_header) // ' t_mask size is not 12')
  endif

  ! set all of the values to the default
  po4_pre(n)%po4_pre_mask%mask(:,:,:) = 1.0

  if (len_w .gt. 0) then

    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header), 'Process po4_pre_mask array for ', trim(po4_pre(n)%name)
    write (stdoutunit,*)

    ! set values for this time-level
  done = 0
  do l = 1, 12
    if (po4_pre(n)%po4_pre_mask%t_mask(l)) then
      if (done .eq. 0) then
         ! set the values via the input values, saving this time index
         ! afterwards
        write (stdoutunit,*) trim(note_header), ' Assigning month ', l
        call set_array(po4_pre(n)%po4_pre_mask%mask(:,:,l), isd, ied, jsd, jed,                                   &
                grid_xt, grid_yt, grid_kmt,                                        &
                len_w, po4_pre(n)%po4_pre_mask%wlon, po4_pre(n)%po4_pre_mask%elon, &
                po4_pre(n)%po4_pre_mask%slat, po4_pre(n)%po4_pre_mask%nlat,        &
                po4_pre(n)%po4_pre_mask%factor, 1.0,                                                          &
                T_prog(po4_pre(n)%ind_po4_pre)%name, po4_pre(n)%po4_pre_mask%coastal_only)
        done = l
      else
         ! Duplicate the values for a previous time-level
          write (stdoutunit,*) 'Duplicating month ', done, ' as ', l
          po4_pre(n)%po4_pre_mask%mask(:,:,l) = po4_pre(n)%po4_pre_mask%mask(:,:,done)
        endif
      endif
    enddo
  endif

enddo

!       integrate the total concentrations of some tracers
!       for the start of the run
indtemp = fm_get_index('/ocean_mod/prog_tracers/temp')
if (indtemp .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the temperature index')
endif
                                                                                                                          
indsal = fm_get_index('/ocean_mod/prog_tracers/salt')
if (indsal .le. 0) then
  call mpp_error(FATAL,trim(error_header) // ' Could not get the salinity index')
endif
      
do n = 1,instances

  po4_tree_path = '/ocean_mod/prog_tracers/' // trim(po4_pre(n)%phosphate_name) 
  write(stdoutunit,*)  po4_tree_path

  indpo4 = fm_get_index('/ocean_mod/prog_tracers/' //                 &
  trim(po4_pre(n)%phosphate_name))

  if (indpo4 .le. 0) then
   call mpp_error(FATAL,trim(error_header) // ' Could not get the phosphate index check if running with an ocean biology model')

 endif

enddo

!       Use taup1 time index for the start of a run, and taup1 time
!       index for the end of a run so that we are integrating the
!       same time level and should therefore get identical results
write (stdoutunit,*) trim(note_header),                           &
     'Global integrals at start of run'

do n = 1, instances
  total_po4_pre = 0.0
  do k = 1,nk
    do j = jsc, jec
      do i = isc, iec
        total_po4_pre = total_po4_pre +                         &
             T_prog(po4_pre(n)%ind_po4_pre)%field(i,j,k,taup1) *  &
             grid_dat(i,j) * grid_tmask(i,j,k) * rho_dzt(i,j,k,taup1)

      enddo
    enddo
  enddo

  call mpp_sum(total_po4_pre)
  write (stdoutunit,*) '  Instance ', trim(po4_pre(n)%name)
  write (stdoutunit,                                              &
         '(/'' Total Preformed Phosphate  = '',es19.12,'' (mol/kg)*Gmol-PO4_pre'')')       &
              total_po4_pre * 1.0e-09
enddo

write(stdoutunit,*)
write(stdoutunit,*) trim(note_header), 'Tracer runs initialized'
write(stdoutunit,*)

return

end subroutine  ocean_po4_pre_start
! </SUBROUTINE> NAME="ocean_po4_pre_start"


!#######################################################################
! <SUBROUTINE NAME="ocean_po4_pre_tracer">
!
! <DESCRIPTION>
!     Perform things that should be done in tracer, but are done here
! in order to minimize the number of hooks necessary in the MOM4 basecode
! </DESCRIPTION>
!
subroutine ocean_po4_pre_tracer(isc, iec, jsc, jec, isd, ied, jsd, jed, nk,     &
                                t_prog, Time, Thickness, Dens, grid_zt, hblt_depth)

integer, intent(in)                                             :: isc
integer, intent(in)                                             :: iec
integer, intent(in)                                             :: jsc
integer, intent(in)                                             :: jec
integer, intent(in)                                             :: isd
integer, intent(in)                                             :: ied
integer, intent(in)                                             :: jsd
integer, intent(in)                                             :: jed
integer, intent(in)                                             :: nk
type(ocean_prog_tracer_type), intent(inout), dimension(:)       :: t_prog
type(ocean_time_type), intent(in)                               :: Time
type(ocean_thickness_type), intent(in)                          :: Thickness
type(ocean_density_type), intent(in)                            :: Dens
real, dimension(:), intent(in)                                  :: grid_zt
real, dimension(isd:,jsd:), intent(in)                          :: hblt_depth

integer :: i, j, k, n

! set Preformed phosphate
do n = 1, instances

   if (po4_pre(n)%mld_option == 1) then
      po4_pre(n)%ml_depth = hblt_depth
   elseif (po4_pre(n)%mld_option == 2) then
      call calc_mixed_layer_depth(Thickness,                            &
           t_prog(indsal)%field(isd:ied,jsd:jed,:,Time%tau),            &
           t_prog(indtemp)%field(isd:ied,jsd:jed,:,Time%tau),           &
           Dens%rho(isd:ied,jsd:jed,:,Time%tau),                        &
           Dens%pressure_at_depth(isd:ied,jsd:jed,:), &
           po4_pre(n)%ml_depth)
   else
      call calc_potrho_mixed_layer(Thickness, Dens,               &
            potrho_mix_depth= po4_pre(n)%ml_depth)
   endif

  do j = jsc, jec
    do i = isc, iec
      do k = 1,nk
         if (grid_zt(k) <= po4_pre(n)%ml_depth(i,j)) then
           t_prog(po4_pre(n)%ind_po4_pre)%field(i,j,k,Time%taup1) = t_prog(indpo4)%field(i,j,k,Time%taup1) 
         endif
      enddo
    enddo
  enddo

enddo

return

end subroutine  ocean_po4_pre_tracer
! </SUBROUTINE> NAME="ocean_po4_pre_tracer"

!#######################################################################
! <SUBROUTINE NAME="set_array">
!
! <DESCRIPTION>
!       Set up an array covering the model domain with a user-specified
!       value, in user-specified regions. There are a given number of
!       2-d regions specified by the values slat, nlat, wlon and elon.
!       The longitudes are for a cyclic domain, and if wlon and elon
!       are on opposite sides of the cut, the correct thing will
!       be done. Elon is considered to be east of wlon, so if elon is
!       less than wlon, then the region east of elon to the cut will be
!       filled, and the region from the cut to wlon will be filled.
!
!       After setting up the array in this routine, it may prove useful
!       to allow fine-tuning the settings via an array in a namelist.
!
!       Arguments:
!         Input:
!      num_regions = number of user-specified regions which will be
!                    filled
!
!             wlon = 1-d array of western (starting) longitudes for the
!                    rectangular regions
!
!             elon = 1-d array of eastern (ending) longitudes for the
!                    rectangular regions
!
!             slat = 1-d array of southern (starting) latitudes for the
!                    rectangular regions
!
!             nlat = 1-d array of northern (ending) latitudes for the
!                    rectangular regions
!
!                       Note: if slat >= nlat, then nothing is done
!                             for that region
!
!        set_value = the value to assign to array in the user-specified
!                    regions
!
!      unset_value = the value to assign to array outside of the
!                    user-specified regions
!
!             name = character variable used in informative messages
!
!     coastal_only = true to limit changes only to coastal points
!                    (i.e., at least one bordering point is land)
!
!         Output:
!
!            array = 2-d array which will contain the set- and unset-
!                    values. The array is assumed to have a border
!                    one unit wide on all edges, ala MOM. A cyclic
!                    boundary condition will be set if requested.
! </DESCRIPTION>
!
subroutine set_array(array, isd, ied, jsd, jed,                 &
                     xt, yt, kmt,                               &
                     num_regions, wlon_in, elon_in, slat, nlat, &
                     set_value, unset_value, name,              &
                     coastal_only)

integer, intent(in)                             :: isd
integer, intent(in)                             :: ied
integer, intent(in)                             :: jsd
integer, intent(in)                             :: jed
integer, intent(in)                             :: num_regions
real, dimension(isd:ied,jsd:jed), intent(out)   :: array
logical, intent(in)                             :: coastal_only
real, dimension(num_regions), intent(in)        :: elon_in
integer, dimension(isd:ied,jsd:jed), intent(in) :: kmt
character(len=*), intent(in)                    :: name
real, dimension(num_regions), intent(in)        :: nlat
real, intent(in)                                :: set_value
real, dimension(num_regions), intent(in)        :: slat
real, intent(in)                                :: unset_value
real, dimension(num_regions), intent(in)        :: wlon_in
real, dimension(isd:ied,jsd:jed), intent(in)    :: xt
real, dimension(isd:ied,jsd:jed), intent(in)    :: yt

character(len=64), parameter    :: sub_name = 'set_array'
character(len=256), parameter   :: error_header =                               &
     '==>Error from ' // trim(mod_name) // '(' // trim(sub_name) // '):'
character(len=256), parameter   :: note_header =                                &
     '==>Note from ' // trim(mod_name) // '(' // trim(sub_name) // '):'

integer :: i, j, n
real, dimension(:), allocatable :: wlon
real, dimension(:), allocatable :: elon

  integer :: stdoutunit 
  stdoutunit=stdout() 

  ! save the longitudes in case they need to be modified
allocate(wlon(num_regions))
allocate(elon(num_regions))

wlon(:) = wlon_in(:)
elon(:) = elon_in(:)

! loop over the regions, applying changes as necessary
do n = 1, num_regions

  if (nlat(n) .ge. slat(n)) then
    write (stdoutunit,*)
    write (stdoutunit,*) trim(note_header),                          &
                       trim(name), ' region: ', n

    ! make sure that all longitudes are in the range [0,360]
    do while (wlon(n) .gt. 360.0)
      wlon(n) = wlon(n) - 360.0
    enddo
    do while (wlon(n) .lt. 0.0)
      wlon(n) = wlon(n) + 360.0
    enddo
    do while (elon(n) .gt. 360.0)
      elon(n) = elon(n) - 360.0
    enddo
    do while (elon(n) .lt. 0.0)
      elon(n) = elon(n) + 360.0
    enddo
    ! if the southern and northern latitudes are the same, then
    ! find the grid box which encompasses them ...
    if (slat(n) .eq. nlat(n)) then

     call mpp_error(FATAL, trim(error_header) //                &
                    'Equal latitudes not supported')

    elseif (wlon(n) .eq. elon(n)) then

     call mpp_error(FATAL, trim(error_header) //                &
                    'Equal longitudes not supported')
    else
       ! ... else find all boxes where the center lies in the
       ! rectangular region
      do j = jsd, jed
        do i = isd, ied
          if (nlat(n) .ge. yt(i,j) .and.                        &
              slat(n) .le. yt(i,j) .and.                        &
              lon_between(xt(i,j), wlon(n), elon(n))) then
            array(i,j) = set_value
          endif
        enddo
      enddo

    endif

  endif

enddo

!       if desired only apply mask to coastal regions
if (coastal_only) then
  do j = jsd, jed
    do i = isd, ied
      if (kmt(i,j) .ne. 0 .and.                         &
          array(i,j) .eq. set_value) then
!       if all the surrounding points are ocean, then this is not
!       a coastal point, therefore reset the mask
        if (kmt(i-1,j) .ne. 0 .and.                     &
            kmt(i+1,j) .ne. 0 .and.                     &
            kmt(i,j-1) .ne. 0 .and.                     &
            kmt(i,j+1) .ne. 0) then
          array(i,j) = unset_value
        endif
      endif
    enddo
  enddo
endif

!       clean up
deallocate(wlon)
deallocate(elon)

return

contains

!       Return true if w <= x_in <= e, taking into account the
!       periodicity of longitude.
!
!       x_in    = value to test
!
!       w       = west longitude of boundary
!
!       e       = east longitude of boundary
function lon_between(x_in, w, e)

implicit none

logical :: lon_between

real, intent(in)                :: x_in
real, intent(in)                :: w
real, intent(in)                :: e

real                    :: x

! Save input values so we may modify them safely
x = x_in

! make sure that all longitudes are in the range [0,360]
do while (x .gt. 360.0)
  x = x - 360.0
enddo
do while (x .lt. 0.0)
  x = x + 360.0
enddo
 
if (w .gt. e) then
  lon_between = w .le. x .or. x .le. e
else
  lon_between = w .le. x .and. x .le. e
endif

return

end function  lon_between

end subroutine  set_array
! </SUBROUTINE> NAME="set_array"


end module  ocean_po4_pre_mod

#include "cosp_defs.H"
#ifdef COSP_GFDL

!---------------------------------------------------------------------
!------------ FMS version number and tagname for this file -----------

! $Id: math_lib.F90,v 20.0 2013/12/13 23:16:48 fms Exp $
! $Name: tikal $
! cosp_version = 1.3.2

#endif

! MATH_LIB: Mathematics procedures for F90
! Compiled/Modified:
!   07/01/06  John Haynes (haynes@atmos.colostate.edu)
! 
! gamma (function)
! path_integral (function)
! avint (subroutine)
  
  module math_lib
  implicit none

  contains

! ----------------------------------------------------------------------------
! function GAMMA
! ----------------------------------------------------------------------------
  function gamma(x)
  implicit none
!
! Purpose:
!   Returns the gamma function
!
! Input:
!   [x]   value to compute gamma function of
!
! Returns:
!   gamma(x)
!
! Coded:
!   02/02/06  John Haynes (haynes@atmos.colostate.edu)
!   (original code of unknown origin)

! ----- INPUTS -----
  real*8, intent(in) :: x
  
! ----- OUTPUTS -----
  real*8 :: gamma

! ----- INTERNAL -----  
  real*8 :: pi,ga,z,r,gr
  real*8 :: g(26)
  integer :: k,m1,m
       
  pi = acos(-1.)    
  if (x ==int(x)) then
    if (x > 0.0) then
      ga=1.0
      m1=x-1
      do k=2,m1
        ga=ga*k
      enddo
    else
      ga=1.0+300
    endif
  else
    if (abs(x) > 1.0) then
      z=abs(x)
      m=int(z)
      r=1.0
      do k=1,m
        r=r*(z-k)
      enddo
      z=z-m
    else
      z=x
    endif
    data g/1.0,0.5772156649015329, &
           -0.6558780715202538, -0.420026350340952d-1, &
           0.1665386113822915,-.421977345555443d-1, &
           -.96219715278770d-2, .72189432466630d-2, &
           -.11651675918591d-2, -.2152416741149d-3, &
           .1280502823882d-3, -.201348547807d-4, &
           -.12504934821d-5, .11330272320d-5, &
           -.2056338417d-6, .61160950d-8, &
           .50020075d-8, -.11812746d-8, &
           .1043427d-9, .77823d-11, &
          -.36968d-11, .51d-12, &
          -.206d-13, -.54d-14, .14d-14, .1d-15/
    gr=g(26)
    do k=25,1,-1
      gr=gr*z+g(k)
    enddo 
    ga=1.0/(gr*z)
    if (abs(x) > 1.0) then
      ga=ga*r
      if (x < 0.0) ga=-pi/(x*ga*sin(pi*x))
    endif
  endif
  gamma = ga
  return
  end function gamma
  
! ----------------------------------------------------------------------------
! function PATH_INTEGRAL 
! ----------------------------------------------------------------------------
  function path_integral(f,s,i1,i2)
  use m_mrgrnk
  use array_lib
  implicit none
!
! Purpose:
!   evalues the integral (f ds) between f(index=i1) and f(index=i2)
!   using the AVINT procedure
!
! Inputs:
!   [f]    functional values
!   [s]    abscissa values
!   [i1]   index of lower limit
!   [i2]   index of upper limit
!
! Returns:
!   result of path integral
!
! Notes:
!   [s] may be in forward or reverse numerical order
!
! Requires:
!   mrgrnk package
!
! Created:
!   02/02/06  John Haynes (haynes@atmos.colostate.edu)

! ----- INPUTS -----  
  real*8, intent(in), dimension(:) :: f,s  
  integer, intent(in) :: i1, i2

! ---- OUTPUTS -----
  real*8 :: path_integral  
  
! ----- INTERNAL -----    
  real*8 :: sumo, deltah, val
  integer*4 :: nelm, j
  integer*4, dimension(i2-i1+1) :: idx
  real*8, dimension(i2-i1+1) :: f_rev, s_rev

  nelm = i2-i1+1
  if (nelm > 3) then
    call mrgrnk(s(i1:i2),idx)
    s_rev = s(idx)
    f_rev = f(idx)
    call avint(f_rev(i1:i2),s_rev(i1:i2),(i2-i1+1), &
      s_rev(i1),s_rev(i2), val)
    path_integral = val
  else
     sumo = 0.
     do j=i1,i2
       deltah = abs(s(i1+1)-s(i1))
       sumo = sumo + f(j)*deltah
    enddo
    path_integral = sumo
  endif 
  ! print *, sumo

  return
  end function path_integral
  
! ----------------------------------------------------------------------------
! subroutine AVINT
! ----------------------------------------------------------------------------
  subroutine avint ( ftab, xtab, ntab, a_in, b_in, result )
  implicit none
!
! Purpose:
!   estimate the integral of unevenly spaced data
!
! Inputs:
!   [ftab]     functional values
!   [xtab]     abscissa values
!   [ntab]     number of elements of [ftab] and [xtab]
!   [a]        lower limit of integration
!   [b]        upper limit of integration
!
! Outputs:
!   [result]   approximate value of integral
!
! Reference:
!   From SLATEC libraries, in public domain
!
!***********************************************************************
!
!  AVINT estimates the integral of unevenly spaced data.
!
!  Discussion:
!
!    The method uses overlapping parabolas and smoothing.
!
!  Modified:
!
!    30 October 2000
!    4 January 2008, A. Bodas-Salcedo. Error control for XTAB taken out of
!                    loop to allow vectorization.
!
!  Reference:
!
!    Philip Davis and Philip Rabinowitz,
!    Methods of Numerical Integration,
!    Blaisdell Publishing, 1967.
!
!    P E Hennion,
!    Algorithm 77,
!    Interpolation, Differentiation and Integration,
!    Communications of the Association for Computing Machinery,
!    Volume 5, page 96, 1962.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) FTAB(NTAB), the function values,
!    FTAB(I) = F(XTAB(I)).
!
!    Input, real ( kind = 8 ) XTAB(NTAB), the abscissas at which the
!    function values are given.  The XTAB's must be distinct
!    and in ascending order.
!
!    Input, integer NTAB, the number of entries in FTAB and
!    XTAB.  NTAB must be at least 3.
!
!    Input, real ( kind = 8 ) A, the lower limit of integration.  A should
!    be, but need not be, near one endpoint of the interval
!    (X(1), X(NTAB)).
!
!    Input, real ( kind = 8 ) B, the upper limit of integration.  B should
!    be, but need not be, near one endpoint of the interval
!    (X(1), X(NTAB)).
!
!    Output, real ( kind = 8 ) RESULT, the approximate value of the integral.

  integer, intent(in) :: ntab

  integer,parameter :: KR8 = selected_real_kind(15,300)
  real ( kind = KR8 ), intent(in) :: a_in
  real ( kind = KR8 ) a
  real ( kind = KR8 ) atemp
  real ( kind = KR8 ), intent(in) :: b_in
  real ( kind = KR8 ) b
  real ( kind = KR8 ) btemp
  real ( kind = KR8 ) ca
  real ( kind = KR8 ) cb
  real ( kind = KR8 ) cc
  real ( kind = KR8 ) ctemp
  real ( kind = KR8 ), intent(in) :: ftab(ntab)
  integer i
  integer ihi
  integer ilo
  integer ind
  real ( kind = KR8 ), intent(out) :: result
  real ( kind = KR8 ) sum1
  real ( kind = KR8 ) syl
  real ( kind = KR8 ) term1
  real ( kind = KR8 ) term2
  real ( kind = KR8 ) term3
  real ( kind = KR8 ) x1
  real ( kind = KR8 ) x2
  real ( kind = KR8 ) x3
  real ( kind = KR8 ), intent(in) :: xtab(ntab)
  logical lerror
  
  lerror = .false.
  a = a_in
  b = b_in  
  
  if ( ntab < 3 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'AVINT - Fatal error!'
    write ( *, '(a,i6)' ) '  NTAB is less than 3.  NTAB = ', ntab
    stop
  end if
 
  do i = 2, ntab
    if ( xtab(i) <= xtab(i-1) ) then
       lerror = .true.
       exit
    end if
  end do
  
  if (lerror) then
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'AVINT - Fatal error!'
      write ( *, '(a)' ) '  XTAB(I) is not greater than XTAB(I-1).'
      write ( *, '(a,i6)' ) '  Here, I = ', i
      write ( *, '(a,g14.6)' ) '  XTAB(I-1) = ', xtab(i-1)
      write ( *, '(a,g14.6)' ) '  XTAB(I) =   ', xtab(i)
      stop  
  end if
 
  result = 0.0D+00
 
  if ( a == b ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'AVINT - Warning!'
    write ( *, '(a)' ) '  A = B, integral=0.'
    return
  end if
!
!  If B < A, temporarily switch A and B, and store sign.
!
  if ( b < a ) then
    syl = b
    b = a
    a = syl
    ind = -1
  else
    syl = a
    ind = 1
  end if
!
!  Bracket A and B between XTAB(ILO) and XTAB(IHI).
!
  ilo = 1
  ihi = ntab

  do i = 1, ntab
    if ( a <= xtab(i) ) then
      exit
    end if
    ilo = ilo + 1
  end do

  ilo = max ( 2, ilo )
  ilo = min ( ilo, ntab - 1 )

  do i = 1, ntab
    if ( xtab(i) <= b ) then
      exit
    end if
    ihi = ihi - 1
  end do
  
  ihi = min ( ihi, ntab - 1 )
  ihi = max ( ilo, ihi - 1 )
!
!  Carry out approximate integration from XTAB(ILO) to XTAB(IHI).
!
  sum1 = 0.0D+00
 
  do i = ilo, ihi
 
    x1 = xtab(i-1)
    x2 = xtab(i)
    x3 = xtab(i+1)
    
    term1 = ftab(i-1) / ( ( x1 - x2 ) * ( x1 - x3 ) )
    term2 = ftab(i)   / ( ( x2 - x1 ) * ( x2 - x3 ) )
    term3 = ftab(i+1) / ( ( x3 - x1 ) * ( x3 - x2 ) )
 
    atemp = term1 + term2 + term3

    btemp = - ( x2 + x3 ) * term1 &
            - ( x1 + x3 ) * term2 &
            - ( x1 + x2 ) * term3

    ctemp = x2 * x3 * term1 + x1 * x3 * term2 + x1 * x2 * term3
 
    if ( i <= ilo ) then
      ca = atemp
      cb = btemp
      cc = ctemp
    else
      ca = 0.5D+00 * ( atemp + ca )
      cb = 0.5D+00 * ( btemp + cb )
      cc = 0.5D+00 * ( ctemp + cc )
    end if
 
    sum1 = sum1 &
          + ca * ( x2**3 - syl**3 ) / 3.0D+00 &
          + cb * 0.5D+00 * ( x2**2 - syl**2 ) &
          + cc * ( x2 - syl )
 
    ca = atemp
    cb = btemp
    cc = ctemp
 
    syl = x2
 
  end do
 
  result = sum1 &
        + ca * ( b**3 - syl**3 ) / 3.0D+00 &
        + cb * 0.5D+00 * ( b**2 - syl**2 ) &
        + cc * ( b - syl )
!
!  Restore original values of A and B, reverse sign of integral
!  because of earlier switch.
!
  if ( ind /= 1 ) then
    ind = 1
    syl = b
    b = a
    a = syl
    result = -result
  end if
 
  return
  end subroutine avint
  
  end module math_lib

module gradient_mod
! <CONTACT EMAIL="Zhi.Liang@noaa.gov">
!   Zhi Liang
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!    <TT>gradient_mod</TT> implements some utility routines to calculate gradient.
! </OVERVIEW>

! <DESCRIPTION>
!    <TT>gradient_mod</TT> implements some utility routines to calculate gradient.
!    Currently only gradient on cubic grid is implemented. Also a public interface 
!    is provided to calculate grid information needed to calculate gradient.

use mpp_mod,       only : mpp_error, FATAL
use constants_mod, only : RADIUS

implicit none
private


public :: gradient_cubic
public :: calc_cubic_grid_info

character(len=128) :: version = '$Id$'
character(len=128) :: tagname = '$Name$'

contains


!#####################################################################
!  NOTe: pin has halo size = 1.
!  the size of pin    will be (nx+2,ny+2), T-cell center, with halo = 1
!  the size of dx     will be (nx, ny+1),  N-cell center
!  the size of dy     will be (nx+1, ny),  E-cell center
!  the size of area   will be (nx, ny),    T-cell center.
!  The size of edge_w will be (ny+1),      C-cell center
!  The size of edge_e will be (ny+1),      C-cell center
!  The size of edge_s will be (nx+1),      C-cell center
!  The size of edge_n will be (nx+1),      C-cell center
!  The size of en_n   will be (3,nx,ny+1), N-cell center
!  The size of en_e   will be (3,nx+1,ny), E-cell center
!  The size of vlon   will be (3,nx, ny)   T-cell center
!  The size of vlat   will be (3,nx, ny),  T-cell center

subroutine gradient_cubic(pin, dx, dy, area, edge_w, edge_e, edge_s, edge_n,    &
                          en_n, en_e, vlon, vlat, grad_x, grad_y, on_west_edge, &
                          on_east_edge, on_south_edge, on_north_edge)

  real,    dimension(:,:  ), intent(in ) :: pin, dx, dy, area
  real,    dimension(:    ), intent(in ) :: edge_w, edge_e, edge_s, edge_n
  real,    dimension(:,:,:), intent(in ) :: en_n, en_e
  real,    dimension(:,:,:), intent(in ) :: vlon, vlat
  real,    dimension(:,:  ), intent(out) :: grad_x, grad_y
  logical,                   intent(in ) :: on_west_edge, on_east_edge, on_south_edge, on_north_edge
  integer :: nx, ny


  nx = size(grad_x,1)
  ny = size(grad_x,2)

  if(size(pin,1) .NE. nx+2 .OR. size(pin,2) .NE. ny+2)call mpp_error(FATAL, "gradient_mod:size of pin should be (nx+2, ny+2)")
  if(size(dx,1) .NE. nx .OR. size(dx,2) .NE. ny+1 ) call mpp_error(FATAL, "gradient_mod: size of dx should be (nx,ny+1)")
  if(size(dy,1) .NE. nx+1 .OR. size(dy,2) .NE. ny ) call mpp_error(FATAL, "gradient_mod: size of dy should be (nx+1,ny)")
  if(size(area,1) .NE. nx .OR. size(area,2) .NE. ny ) call mpp_error(FATAL, "gradient_mod: size of area should be (nx,ny)")
  if(size(vlon,1) .NE. 3 .OR. size(vlon,2) .NE. nx .OR. size(vlon,3) .NE. ny) &
          call mpp_error(FATAL, "gradient_mod: size of vlon should be (3,nx,ny)")
  if(size(vlat,1) .NE. 3 .OR. size(vlat,2) .NE. nx .OR. size(vlat,3) .NE. ny) &
          call mpp_error(FATAL, "gradient_mod: size of vlat should be (3,nx,ny)")
  if(size(edge_w) .NE. ny+1) call mpp_error(FATAL, "gradient_mod: size of edge_w should be (ny+1)")
  if(size(edge_e) .NE. ny+1) call mpp_error(FATAL, "gradient_mod: size of edge_e should be (ny+1)")
  if(size(edge_s) .NE. nx+1) call mpp_error(FATAL, "gradient_mod: size of edge_s should be (nx+1)")
  if(size(edge_n) .NE. nx+1) call mpp_error(FATAL, "gradient_mod: size of edge_n should be (nx+1)")
  if(size(en_n,1) .NE. 3 .OR. size(en_n,2) .NE. nx .OR.  size(en_n,3) .NE. ny+1 ) &
       call mpp_error(FATAL, "gradient_mod:size of en_n should be (3, nx, ny+1)")
  if(size(en_e,1) .NE. 3 .OR. size(en_e,2) .NE. nx+1 .OR.  size(en_e,3) .NE. ny ) &
       call mpp_error(FATAL, "gradient_mod:size of en_e should be (3, nx+1, ny)")

  call grad_c2l(nx, ny, pin, dx, dy, area, edge_w, edge_e, edge_s, edge_n, en_n, en_e, vlon, vlat, &
                grad_x, grad_y, on_west_edge, on_east_edge, on_south_edge, on_north_edge)

  return

end subroutine gradient_cubic


subroutine calc_cubic_grid_info(xt, yt, xc, yc, dx, dy, area, edge_w, edge_e, edge_s, edge_n, &
                           en_n, en_e, vlon, vlat, on_west_edge, on_east_edge, on_south_edge, on_north_edge )
  real,    dimension(:,:  ), intent(in ) :: xt, yt, xc, yc
  real,    dimension(:,:  ), intent(out) :: dx, dy, area
  real,    dimension(:    ), intent(out) :: edge_w, edge_e, edge_s, edge_n
  real,    dimension(:,:,:), intent(out) :: en_n, en_e
  real,    dimension(:,:,:), intent(out) :: vlon, vlat
  logical,                   intent(in ) :: on_west_edge, on_east_edge, on_south_edge, on_north_edge
  integer :: nx, ny, nxp, nyp


  nx  = size(area,1)
  ny  = size(area,2)
  nxp = nx+1
  nyp = ny+1

  if(size(xt,1) .NE. nx+2 .OR. size(xt,2) .NE. ny+2 ) call mpp_error(FATAL, "gradient_mod: size of xt should be (nx+2,ny+2)")
  if(size(yt,1) .NE. nx+2 .OR. size(yt,2) .NE. ny+2 ) call mpp_error(FATAL, "gradient_mod: size of yt should be (nx+2,ny+2)")
  if(size(xc,1) .NE. nxp .OR. size(xc,2) .NE. nyp ) call mpp_error(FATAL, "gradient_mod: size of xc should be (nx+1,ny+1)")
  if(size(yc,1) .NE. nxp .OR. size(yc,2) .NE. nyp ) call mpp_error(FATAL, "gradient_mod: size of yc should be (nx+1,ny+1)")
  if(size(dx,1) .NE. nx .OR. size(dx,2) .NE. nyp ) call mpp_error(FATAL, "gradient_mod: size of dx should be (nx,ny+1)")
  if(size(dy,1) .NE. nxp .OR. size(dy,2) .NE. ny ) call mpp_error(FATAL, "gradient_mod: size of dy should be (nx+1,ny)")
  if(size(area,1) .NE. nx .OR. size(area,2) .NE. ny ) call mpp_error(FATAL, "gradient_mod: size of area should be (nx,ny)")
  if(size(vlon,1) .NE. 3 .OR. size(vlon,2) .NE. nx .OR. size(vlon,3) .NE. ny) &
          call mpp_error(FATAL, "gradient_mod: size of vlon should be (3,nx,ny)")
  if(size(vlat,1) .NE. 3 .OR. size(vlat,2) .NE. nx .OR. size(vlat,3) .NE. ny) &
          call mpp_error(FATAL, "gradient_mod: size of vlat should be (3,nx,ny)")
  if(size(edge_w) .NE. ny+1) call mpp_error(FATAL, "gradient_mod: size of edge_w should be (ny-1)")
  if(size(edge_e) .NE. ny+1) call mpp_error(FATAL, "gradient_mod: size of edge_e should be (ny-1)")
  if(size(edge_s) .NE. nx+1) call mpp_error(FATAL, "gradient_mod: size of edge_s should be (nx-1)")
  if(size(edge_n) .NE. nx+1) call mpp_error(FATAL, "gradient_mod: size of edge_n should be (nx-1)")
  if(size(en_n,1) .NE. 3 .OR. size(en_n,2) .NE. nx .OR.  size(en_n,3) .NE. nyp ) &
       call mpp_error(FATAL, "gradient_mod:size of en_n should be (3, nx, ny+1)")
  if(size(en_e,1) .NE. 3 .OR. size(en_e,2) .NE. nxp .OR.  size(en_e,3) .NE. ny ) &
       call mpp_error(FATAL, "gradient_mod:size of en_e should be (3, nx+1, ny)")


  call calc_c2l_grid_info(nx, ny, xt, yt, xc, yc, dx, dy, area, edge_w, edge_e, edge_s, edge_n, &
                          en_n, en_e, vlon, vlat, on_west_edge, on_east_edge, on_south_edge, on_north_edge )


  return

end subroutine calc_cubic_grid_info

end module gradient_mod

#!/bin/csh -f
# Minimal compile script for fully coupled model CM2M experiments

#set echo
set platform      = gfortran   # A unique identifier for your platfo
                                  # This corresponds to the mkmf templates in $root/bin dir.
if ( `hostname` =~ login0? ) then
  set platform      = pik-iplex-ifort11
  if ( -d /p ) then ### argl. what a hack. from hostname nor domain we can distinguish iplex and hpc2015 clusters
    set platform      = pik-hlrs2015-ifort
  endif
endif
if ( `hostname` =~ viss0?* ) then
  set platform      = pik-vis-ifort11
endif
if ( `hostname` =~ pc89 ) then
  set platform      = pik-pc89-gfortran
endif
if ( `hostname` =~ zuse ) then
  set platform      = ifi-zuse-ifort11
endif



set type          = "" # MOM_solo      # Type of the experiment
set help = 1 # if invoked without --type then print help
set unit_testing = 0
set debug = ""
set vec = "" # -vec or -omp
set repro = 0
set use_netcdf4 = 1
set environ = 1

set argv = (`getopt -u -o hd -l type: -l platform: -l help -l unit_testing -l debug -l repro -l vec -l omp -l use_netcdf4 -l no_environ --  $*`)
if ($status != 0) then
  # Die if there are incorrect options
  set help = 1
  goto help
endif

while ("$argv[1]" != "--")
    switch ($argv[1])
        case --type:
                set type = $argv[2]; set help = 0; shift argv; breaksw
        case --platform:
                set platform = $argv[2]; shift argv; breaksw
        case --unit_testing:
                set unit_testing = 1; breaksw
        case --repro:
                set repro = 1; breaksw
        case --use_netcdf4:
                set use_netcdf4 = 1; breaksw
        case --no_environ:
                set environ = 0; breaksw
        case --help:
        case -h:
                set help = 1;  breaksw
        case --debug:
        case -d:
                set debug = "-debug"; breaksw
	case --vec:
                set vec = "-vec"; breaksw
	case --omp:
		set vec = "-omp"; breaksw
    endsw
    shift argv
end

if ("" == "$type") echo "Option --type is required!"

shift argv
help:
if ( $help ) then
    echo "The optional arguments are:"
    echo "--type       followed by the type of the experiment, currently one of the following:"
    echo "             MOM_solo : solo ocean model"
    echo "             MOM_SIS  : ocean-seaice model"
    echo "             SLAB_SIS : slab -seaice model"
    echo "             CM2M     : ocean-seaice-land-atmosphere coupled climate model"
    echo "             SLAB_CM2M: slab -seaice-land-atmosphere coupled climate model"
    echo "             ESM2M    : ocean-seaice-land-atmosphere coupled climate model with biogeochemistry, EarthSystemModel"
    echo "             ICCM     : ocean-seaice-land-atmosphere coupled model"
    echo "             EBM      : ocean-seaice-land-atmosphere coupled model with energy balance atmosphere"
    echo "             ACCESS-CM : ocean component of ACCESS-CM model."
    echo "             ACCESS-OM : ocean component of ACCESS-OM model."
    echo "             ACCESS-ESM : ocean component of ACCESS-ESM model with CSIRO BGC  (Wombat)."
    echo "             ACCESS-OM-BGC: ocean component of ACCESS-OM model with CSIRO BGC  (Wombat)."
    echo
    echo "--platform   followed by the platform name that has a corresponding environ file in the ../bin dir, default is $platform"
    echo "--debug | -d to append -debug to the platform name, so that mkmf template with debug options is used,"
    echo "             and the executable is built in a directory with -debug appended to its name."
    echo "--vec        Compile with highest optimization and vectorisation (default is without vectorisation)"
    echo "--omp        Compile with highest optimization and OpenMP"
    echo
    echo "--use_netcdf4  use NetCDF4, the default is NetCDF3. Warning: many of the standard experiments don't work with NetCDF4."
    echo
    echo "--no_environ  do not source platform specific environment. Allows customising/overriding default environment"
    echo
    exit 1
endif

set echo
#
# User does not need to change anything below!
#
set root          = $cwd:h                            # The directory you created when you checkout
set code_dir      = $root/src                         # source code directory
set executable    = $root/exec/$platform$vec$debug/$type/fms_$type.x      # executable created after compilation
set mppnccombine  = $root/bin/mppnccombine.$platform  # path to executable mppnccombine
set mkmfTemplate  = $root/bin/mkmf.template.$platform$vec$debug # path to template for your platform
set mkmf          = $root/bin/mkmf                    # path to executable mkmf
set cppDefs  = ( "-Duse_netCDF -Duse_netCDF3 -Duse_libMPI -DUSE_OCEAN_BGC -DENABLE_ODA -DSPMD -DLAND_BND_TRACERS" )
#On Altrix systems you may include "-Duse_shared_pointers -Duse_SGI_GSM" in cppDefs for perfomance.
#These are included in the GFDL configuration of the model.

set static        = 0              # 1 if you want static memory allocation, 0 for dynamic
if($static) then
  set executable = $root/exec/$platform/${type}_static/fms_$type.x
  set cppDefs = "$cppDefs -DMOM_STATIC_ARRAYS -DNI_=360 -DNJ_=200 -DNK_=50 -DNI_LOCAL_=60 -DNJ_LOCAL_=50"
endif

if ( $type == EBM ) then
    set cppDefs  = ( "-Duse_netCDF -Duse_netCDF3 -Duse_libMPI -DLAND_BND_TRACERS -DOVERLOAD_C8 -DOVERLOAD_C4 -DOVERLOAD_R4" )
else if( $type == ACCESS-OM ) then
    set cppDefs  = ( "-Duse_netCDF -Duse_libMPI -DACCESS -DACCESS_OM" )
else if( $type == ACCESS-OM-BGC ) then
    set cppDefs  = ( "-Duse_netCDF -Duse_libMPI -DACCESS -DACCESS_OM -DCSIRO_BGC" )
else if( $type == ACCESS-CM ) then
    set cppDefs  = ( "-Duse_netCDF -Duse_libMPI -DACCESS -DACCESS_CM" )
else if( $type == ACCESS-ESM ) then
    set cppDefs  = ( "-Duse_netCDF -Duse_libMPI -DACCESS -DACCESS_CM -DCSIRO_BGC" )
endif

if ( $unit_testing ) then
    set cppDefs = ( "$cppDefs -DUNIT_TESTING" )
    setenv DEBUG true
endif

if ( "$debug" != "" ) then
    setenv DEBUG true
endif

if ( $repro ) then
    setenv REPRO true
endif

if ( $use_netcdf4 ) then
    set cppDefs = `echo $cppDefs | sed -e 's/-Duse_netCDF3//g'`
    set cppDefs = "$cppDefs -Duse_netCDF4"
endif

#
# Users must ensure the correct environment file exists for their platform.
#
if ( $environ ) then
  source $root/bin/environs.$platform  # environment variables and loadable modules
endif
if ( $status ) exit $status

env | grep NETCDF

#
# compile mppnccombine.c, needed only if $npes > 1
  if ( ! -f $mppnccombine ) then
    $CC -O -g -o $mppnccombine $NETCDFINCLUDE $code_dir/postprocessing/mppnccombine/mppnccombine.c $NETCDFLIBPATH
    if ( $status ) exit $status
  endif

set mkmf_lib = "$mkmf -f -m Makefile -a $code_dir -t $mkmfTemplate"
set lib_include_dirs = "$root/include $code_dir/shared/include $code_dir/shared/mpp/include"

# Build version
source ./version_compile.csh
if ( $status ) exit $status

# Build FMS.
source ./FMS_compile.csh
if ( $status ) exit $status
set includes = "-I$code_dir/shared/include -I$executable:h:h/lib_FMS -I$executable:h:h/lib_ocean -I$executable:h:h/lib_version/"

# Build the core ocean.
cd $root/exp
if ( $type == SLAB_SIS | $type == SLAB_CM2M) then
    source ./slab_compile.csh
else
    source ./ocean_compile.csh
endif
if ( $status ) exit $status

if( $type != MOM_solo && $type != ACCESS-OM  && $type != ACCESS-CM && $type != ACCESS-OM-BGC  && $type != ACCESS-ESM) then
    cd $root/exp
    source ./ice_compile.csh
    if ( $status ) exit $status
endif
if( $type == MOM_SIS | $type == SLAB_SIS) then
    cd $root/exp
    source ./land_null_compile.csh
    if ( $status ) exit $status

    cd $root/exp
    source ./atmos_null_compile.csh
    if ( $status ) exit $status
endif
if( $type == EBM) then
    cd $root/exp
    source ./atmos_ebm_compile.csh
    if ( $status ) exit $status
endif
if( $type == CM2M | $type == ESM2M | $type == ICCM | $type == SLAB_CM2M) then
    cd $root/exp
    source ./atmos_phys_compile.csh
    if ( $status ) exit $status
endif
if( $type == CM2M | $type == ESM2M | $type == SLAB_CM2M ) then
    cd $root/exp
    source ./atmos_fv_compile.csh
    if ( $status ) exit $status
endif
if( $type == CM2M | $type == ICCM | $type == EBM | $type == SLAB_CM2M) then
    cd $root/exp
    source ./land_lad_compile.csh
    if ( $status ) exit $status
endif
if( $type == ESM2M ) then
    cd $root/exp
    source ./land_lad2_compile.csh
    if ( $status ) exit $status
endif
if( $type == ICCM ) then
    cd $root/exp
    source ./atmos_bg_compile.csh
    if ( $status ) exit $status
endif

# Build the executable
set mkmf_exec = "$mkmf -f -m Makefile -a $code_dir -t $mkmfTemplate -p $executable:t"
mkdir -p $executable:h
cd $executable:h
if( $type == MOM_solo ) then
    set srcList = ( mom5/drivers )
    set libs = "$executable:h:h/lib_ocean/lib_ocean.a"
else if( $type == ACCESS-CM || $type == ACCESS-ESM) then
    set srcList = ( accesscm_coupler )
    set includes = "-I$executable:h:h/lib_FMS -I$executable:h:h/$type/lib_ocean"
    set libs = "$executable:h:h/$type/lib_ocean/lib_ocean.a"
    setenv OASIS true
else if( $type == ACCESS-OM || $type == ACCESS-OM-BGC) then
    set srcList = ( accessom_coupler )
    set includes = "-I$executable:h:h/lib_FMS -I$executable:h:h/$type/lib_ocean"
    set libs = "$executable:h:h/$type/lib_ocean/lib_ocean.a"
else if( $type == MOM_SIS ) then
    set srcList = ( coupler )
    set includes = "$includes -I$executable:h:h/lib_ice -I$executable:h:h/lib_atmos_null -I$executable:h:h/lib_land_null"
    set libs = "$executable:h:h/lib_ocean/lib_ocean.a $executable:h:h/lib_ice/lib_ice.a $executable:h:h/lib_atmos_null/lib_atmos_null.a $executable:h:h/lib_land_null/lib_land_null.a"
else if( $type == SLAB_SIS ) then
    set srcList = ( coupler )
    set includes = "-I$executable:h:h/lib_FMS -I$executable:h:h/lib_slab -I$executable:h:h/lib_ice -I$executable:h:h/lib_atmos_null -I$executable:h:h/lib_land_null"
    set libs = "$executable:h:h/lib_slab/lib_slab.a $executable:h:h/lib_ice/lib_ice.a $executable:h:h/lib_atmos_null/lib_atmos_null.a $executable:h:h/lib_land_null/lib_land_null.a"
else if( $type == EBM ) then
    set srcList = ( coupler )
    set includes = "$includes -I$executable:h:h/lib_ice -I$executable:h:h/lib_atmos_ebm  -I$executable:h:h/lib_land_lad"
    set libs = "$executable:h:h/lib_ocean/lib_ocean.a $executable:h:h/lib_ice/lib_ice.a $executable:h:h/lib_atmos_ebm/lib_atmos_ebm.a $executable:h:h/lib_land_lad/lib_land_lad.a"
else if( $type == CM2M ) then
    set srcList = ( coupler )
    set includes = "$includes -I$executable:h:h/lib_ice -I$executable:h:h/lib_atmos_fv -I$executable:h:h/lib_atmos_phys -I$executable:h:h/lib_land_lad"
    set libs = "$executable:h:h/lib_ocean/lib_ocean.a $executable:h:h/lib_ice/lib_ice.a $executable:h:h/lib_atmos_fv/lib_atmos_fv.a $executable:h:h/lib_atmos_phys/lib_atmos_phys.a $executable:h:h/lib_land_lad/lib_land_lad.a"
else if( $type == SLAB_CM2M ) then
    set srcList = ( coupler )
    set includes = "-I$executable:h:h/lib_FMS -I$executable:h:h/lib_slab -I$executable:h:h/lib_ice -I$executable:h:h/lib_atmos_fv -I$executable:h:h/lib_atmos_phys -I$executable:h:h/lib_land_lad"
    set libs = "$executable:h:h/lib_slab/lib_slab.a $executable:h:h/lib_ice/lib_ice.a $executable:h:h/lib_atmos_fv/lib_atmos_fv.a $executable:h:h/lib_atmos_phys/lib_atmos_phys.a $executable:h:h/lib_land_lad/lib_land_lad.a"
else if( $type == ESM2M ) then
    set srcList = ( coupler )
    set includes = "$includes -I$executable:h:h/lib_ice -I$executable:h:h/lib_atmos_fv -I$executable:h:h/lib_atmos_phys -I$executable:h:h/lib_land_lad2"
    set libs = "$executable:h:h/lib_ocean/lib_ocean.a $executable:h:h/lib_ice/lib_ice.a $executable:h:h/lib_atmos_fv/lib_atmos_fv.a $executable:h:h/lib_atmos_phys/lib_atmos_phys.a $executable:h:h/lib_land_lad2/lib_land_lad2.a"
else if( $type == ICCM ) then
    set srcList = ( coupler )
    set includes = "$includes -I$executable:h:h/lib_ice -I$executable:h:h/lib_atmos_bg -I$executable:h:h/lib_atmos_phys -I$executable:h:h/lib_land_lad" 
    set libs = "$executable:h:h/lib_ocean/lib_ocean.a $executable:h:h/lib_ice/lib_ice.a $executable:h:h/lib_atmos_bg/lib_atmos_bg.a $executable:h:h/lib_atmos_phys/lib_atmos_phys.a $executable:h:h/lib_land_lad/lib_land_lad.a"
else
    echo "Error: unsupported model type, please see model types in ./MOM_compile.sh --help"
    exit 1
endif

# Always include FMS and version
set libs = "$libs $executable:h:h/lib_version/lib_version.a $executable:h:h/lib_FMS/lib_FMS.a"

$mkmf_exec -o "$includes" -c "$cppDefs" -l "$libs"  $srcList
make
if( $status ) then
    echo "Make failed to create the $type executable"
    exit 1
endif

exit

#!/bin/csh 
#=======================================================================
#      preprocessing : make_xgrids.csh
#         Contact : Zhi Liang   email : Zhi.Liang
#
#  This runscritp can be used to generate exchange grids between ocean, atmosphere and land grid.
#  The user need to create atmos_grid.nc, land_grid.nc and ocean_grid.nc before using make_xgrids.
#  Normally land_grid.nc is the same as atmos_grid.nc. 
#=======================================================================
#  This preprocessing program was tested with Intel Fortran compiler on ia64 at GFDL.
#  In order to run on other system, some changes may be needed.
#######################################################################
# Users need to modify the following variables according to their need. 
# These particular values are here for testing purposes in GFDL only.  
#######################################################################
  set echo
  set name         = "grid_spec"                                  # name of the grid file will be generated
  set platform     = "ncrc.intel"                                    # A unique identifier for your platform
  set npes         = 1                                      # number of processors
#
  set root         = $cwd:h:h:h:h                       # The directory that contains src/ and bin/
  set tooldir      = $cwd                                         # directory of the tool 
  set workdir      = $tooldir/workdir                             # where the tool is run and output is produced
  set executable   = $tooldir/exec/make_xgrids                    # executable created after compilation
  set xgrids_code  = $tooldir/make_xgrids.c                       # source code of make_xgrids
#
# Users must ensure the following  files exist for their platform.
#
  source $root/bin/environs.$platform                   # environment variables and compiler options

# model grid data
  set atmos_grid   = $tooldir:h/atmos/workdir/atmos_grid.nc       # atmos grid
  set land_grid    = $tooldir:h/atmos/workdir/atmos_grid.nc       # land grid
  set ocean_grid   = $tooldir:h/ocean/workdir/ocean_grid.nc       # ocean grid

#--create the executable -----------------------------------------------------------
  if( ! -d $executable:h ) mkdir $executable:h
  cd $executable:h
  cc -O -o $executable:t $xgrids_code -I$netcdf3_inc_dir -L$netcdf3_lib_dir -lnetcdf -lm

#--------------------------------------------------------------------------------------------------------
# setup directory structure
  if ( ! -d $workdir )         mkdir $workdir

  cd $workdir

# get executable  
  cp $executable $executable:t

#  run the executable
  ./$executable:t -o $ocean_grid -a $atmos_grid -l $land_grid >>fms.out   
  cat fms.out
  
# renmae output file
  mv fms.out $name.fms.out
  mv grid_spec.nc $name.nc

  unset echo 

#PBS -P v45
#PBS -l ncpus=960
#PBS -l mem=1920Gb
#PBS -l walltime=5:00:00 
#PBS -l wd
#PBS -l storage=gdata/hh5+scratch/v45
#PBS -W block=true

module purge

module use /g/data3/hh5/public/modules
module load conda/analysis3-unstable
module load pbs

nosetests --with-xunit test_run.py -s

# Build the null atmos library

set srcList = ( atmos_null atmos_param/diag_integral atmos_param/monin_obukhov )

set lib_name = "lib_atmos_null"

mkdir -p $executable:h:h/$lib_name
cd $executable:h:h/$lib_name
$mkmf_lib -p $lib_name.a -c "$cppDefs" -o "-I$executable:h:h/lib_FMS" $srcList $lib_include_dirs
make

if( $status ) then
    echo "Make failed to create $lib_name.a"
    exit 1
endif

#!/bin/tcsh

switch (`uname -m`)
case 'ia64':
   source /opt/modules/default/init/tcsh
   module purge
   module load ifort.9.1.041
   module load netcdf-3.6.2
   breaksw
case 'i686':
   breaksw
default:
   echo Unsupported architecture `uname -m` 
endsw

module list

make

#!/bin/tcsh -f
#
# $Id: timavg.csh,v 20.0 2013/12/14 00:30:18 fms Exp $
# ------------------------------------------------------------------------------
# FMS/FRE Project: Script to Call Time-Averaging Executables
# ------------------------------------------------------------------------------
# afy    Ver   1.00  Copied from ~fms/local/ia64/netcdf4.fix        June 10
# afy    Ver   2.00  Don't source the 'init.csh' script             June 10
# afy    Ver   2.01  Use 'which' to locate executables              June 10
# ------------------------------------------------------------------------------
# Copyright (C) NOAA Geophysical Fluid Dynamics Laboratory, 2000-2010
# Designed and written by V. Balaji, Amy Langenhorst and Aleksey Yakovlev
#

#-----------------------------------------------------------------------
#
#  This script takes multiple netcdf files that all contain the same
#  dimensions and variables but may have a different number of time
#  records and writes a new netcdf file that has a time record 
#  averaged from each input file.
#
#-----------------------------------------------------------------------

set ofile
set ifiles
set etime = .true.
set do_verbose = .false.
set do_bounds  = .false.
set do_errors  = .false.
set no_warning = .false.
set vers = v08
set precision = 8

#  ----- parse input argument list ------

set argv = (`getopt abdmWo:v:w:r: $*`)

while ("$argv[1]" != "--")
    switch ($argv[1])
        case -a:
            set do_errors = .true.; breaksw
        case -b:
            set do_bounds = .true.; breaksw
        case -d:
            set debug; set do_verbose = .true.; breaksw
        case -m:
            set etime = .false.; breaksw
        case -r:
            set precision = $argv[2]; shift argv; breaksw
        case -W:
            set no_warning = .true.; breaksw
        case -w:
            set weight = $argv[2]; shift argv; breaksw
        case -o:
            set ofile = $argv[2]; shift argv; breaksw
        case -v:
            set vers = $argv[2]; shift argv; breaksw
    endsw
    shift argv
end
shift argv
if ($?debug) set echo
set ifiles = ( $argv )

##################################################################
#  ----- help message -----

if ($ofile == "" || $#ifiles == 0) then
set name = `basename $0`
cat << EOF

Time averaging script

Usage:  $name [-a] [-b] [-d] [-m] [-r prec] [-v vers] -o ofile  files.....

        -a       = skips "average information does not agree" errors
        -b       = adds time axis bounds and cell methods (CF convention)
        -d       = turns on command echo (for debugging)
        -m       = average time (instead of end time) for t-axis values
        -r prec  = precision used for time averaging, either -r4 or -r8 (default)
        -W       = suppress warning messages (use with caution)
        -w wght  = minimum fraction of missing data needed for valid data
        -o ofile = name of the output file

        files... = list netcdf files, each file will be a time record
                   in the output file (the files should be in 
                   chronological order)
                  
EOF
exit 1
endif

#        -v vers  = executable version (TAVG.$vers.exe)
##################################################################

# executable name depends on precision 
if ($precision == 4) then
    set executable = `which TAVG.r4.exe`
else if ($precision == 8) then
    set executable = `which TAVG.exe`
else
    echo "ERROR: use -r4 or -r8"; exit 1
endif

set error_flag = 0

#-- check existence of executable --
if (! -e $executable) then
   echo Executable does not exist
   set error_flag = 1
endif

#-- check existence of files --
foreach file ($ifiles)
   if (! -e $file) then
       echo File $file does not exist
       set error_flag = 1
   endif
end
if ($error_flag != 0) then
   echo ERROR: input files do not exist
   exit 1
endif

#-- namelist (create unique name) --
set nml_name = nml`date '+%j%H%M%S'`
    echo " &input" > $nml_name
set i = 1
foreach file ($ifiles)
    echo "    file_names("$i") = " \'$file\' , >> $nml_name
    @ i++
end
    echo "    file_name_out = " \'$ofile\' ,     >> $nml_name
    echo "    use_end_time  = " $etime ,         >> $nml_name
    echo "    verbose  = " $do_verbose ,         >> $nml_name
    echo "    add_cell_methods = " $do_bounds ,  >> $nml_name
    echo "    skip_tavg_errors = " $do_errors ,  >> $nml_name
    echo "    suppress_warnings = " $no_warning, >> $nml_name

    if ($?weight) then
       echo "    frac_valid_data = " $weight ,   >> $nml_name
    endif

    echo " &end"                                 >> $nml_name

#-- run averaging program --
    $executable < $nml_name
    set exit_status = $status

#-- clean up --
rm -f $nml_name

exit $exit_status

#!/bin/csh -f
unalias *

set argv = (`getopt Hbehmsf:t: $*`)

#-----------------------------------------------------------------------

 set sep =  
 set format = standard

 set rec = tail
 set help = 0

 set hours   = 0
 set minutes = 0
 set seconds = 0

#-----------------------------------------------------------------------

while ("$argv[1]" != "--")
    switch ($argv[1])
        case -H:
            set help = 1; breaksw
        case -b:
            set rec = 2; breaksw
        case -e:
            set rec = 1; breaksw
        case -h:
            set hours = 1; breaksw
        case -m:
            set hours = 1; set minutes = 1; breaksw
        case -s:
            set hours = 1; set minutes = 1; set seconds = 1; breaksw
        case -f:
            set format = $argv[2]; shift argv; breaksw
        case -t:
            set sep = $argv[2]; shift argv; breaksw
    endsw
    shift argv
end
shift argv

#  --- help output ---

 if ( $help ) then
   cat << END
   time_stamp.csh [ -behms -f format -t separator ]

      -H help (no execution)
      -b beginning date
      -e ending date (default)
      -h hours
      -m hours,minutes
      -s hours,minutes,seconds
      -f format=standard(default),european,digital
      -t separator (default=blank)

END
   exit
 endif

#  --- check format ---

 if ( $format != "standard" &&  \
      $format != "european" && $format != "digital" ) then
    echo ERROR invalid format
    exit (4)
 endif
 
 set hsep = $sep
 if ( $format == "standard" || $format == "european" ) set hsep = h

#-----------------------------------------------------------------------

 if ( -e time_stamp.out ) then
     set time_stamp = `tail -$rec time_stamp.out`

     set month_name = `echo $time_stamp[7] | tr "[A-Z]" "[a-z]"`
     set  month_num = `printf "%.2d" $time_stamp[2]`

#    ---- day can have more than 2 digits ----

     set day_num = `printf "%.2d" $time_stamp[3]`
     if ( $month_name == "day"  && $format == "standard" ) \
        set day_num = `printf "%.4d" $time_stamp[3]`

#    ---- hours,min,sec can have only 2 digits ----

     set  hour_num = `printf "%.2d" $time_stamp[4]`
     set  min_num = `printf "%.2d" $time_stamp[5]`
     set  sec_num = `printf "%.2d" $time_stamp[6]`

#    ---- pad ISO years to 4 digits ----
     if ( $format == "digital" ) then
         set year = `printf %.4d $time_stamp[1]` # will work even if year>9999
     endif

#    ---- create date label ----

     set date_name

     if ( $format == "standard" ) then
        if ( $month_name != "day" ) set date_name = $time_stamp[1]
        set date_name = $date_name$month_name$day_num
     else if ( $format == "european" ) then
        set date_name = $day_num$month_name$time_stamp[1]
     else if ( $format == "digital" ) then
        set date_name = $year$sep$month_num$sep$day_num
     endif

        if ( $hours   ) set date_name = $date_name$hsep$hour_num
        if ( $minutes ) set date_name = $date_name$sep$min_num
        if ( $seconds ) set date_name = $date_name$sep$sec_num

 else
#    --- dummy values ---
     set month_name = "xxx"
     set date_name  = "no_time_stamp"
 endif

     echo $date_name

#!/bin/tcsh 
#=======================================================================
#      regrid_2d : interp 2-D data
#         Contact : Zhi Liang   email : Zhi.Liang
#
#  This runscritp can be used to regrid 2-d lat-lon gridded data to logically
#  rectangular grid described by grid descriptor file $dest_grid.  If two
#  fields are specified for regridding, it is assumed that they represent
#  vector components. Rotation to the local grid direction on the target
#  grid will be performed.
#
#  This preprocessing program was tested with Intel Fortran compiler on ia64 at GFDL.
#  In order to run on other system, some changes may be needed.
#######################################################################
# Users need to modify the following variables according to their need. 
# These particular values are here for testing purposes in GFDL only.  
#######################################################################

  set echo
  set platform     = "ncrc.intel"                                    # A unique identifier for your platform
  set npes         = 1                                      # number of processors

#
  set root         = $cwd:h:h:h                         # The directory that contains src/ and bin/
#
# Users must ensure the following  files exist for their platform.
#
  source $root/bin/environs.$platform                   # environment variables and compiler options

  set mkmfTemplate = $root/bin/mkmf.template.$platform  # path to mkmf template 
#
# input data file and destination grid
# NOTE: Users must change the following according to their need. These particular values are here for testing purposes only.
#
  set src_file        = $FMS_ARCHIVE/mom4/input_data/hellerman.nc   # source data file
  set dest_grid       = $cwd:h/generate_grids/ocean/workdir/ocean_grid.nc  # destination grid



#############################################################################
# Users need not change anything below this line except the namelists values.
#############################################################################
  set name         = "regrid_2d"                            # name of the data file will be generated
  set tooldir      = $cwd                                   # directory of the tool
  set sharedir     = $root/src/shared                       # directory of the shared code.
  set includedir   = $sharedir/include                      # fms include directory
  set workdir      = $tooldir/workdir                       # where the tool is run and output is produced
  set executable   = $tooldir/exec/regrid_2d.exe            # executable created after compilation
  if ( $?DEBUG ) then
    set executable    = $tooldir/debug/regrid_2d.exe 
    set mkmfTemplate  = $root/bin/mkmf.debugtemplate.$platform         
  endif
  set mkmf         = $root/bin/mkmf                         # path to executable mkmf
  set cppDefs      = ( "-Duse_netCDF -Duse_netCDF3 -Duse_libMPI" )        # list of cpp #defines to be passed to the source files

# list the source code
  set CORE      = "$tooldir/{regrid_2d.f90}"
  set UTILITIES = "$sharedir/{axis_utils,constants,fms,mpp,horiz_interp,platform,memutils,mosaic}"
  set UTILITIES    = " $UTILITIES $sharedir/mpp/include $includedir " 
  set srclist   = ( $CORE $UTILITIES )

# compile the code and create executable
  if( ! -d $executable:h ) mkdir $executable:h
  cd $executable:h
  $mkmf -t $mkmfTemplate -p $executable:t -c "$cppDefs" $srclist /usr/local/include

  make $executable:t

#--------------------------------------------------------------------------------------------------------
# setup directory structure
  if ( ! -d $workdir )         mkdir $workdir

  cd $workdir

# get executable  
  cp $executable $executable:t

# --- set up namelist

    cat >input.nml <<!
    &regrid_2d_nml
       src_file = '$src_file'
       numfields = 2
       src_field_name = 'TAUX', 'TAUY'
       dest_grid = '$dest_grid'
       dest_file = '$name.nc'
       dest_grid_type = 'C'
       vector_field = .TRUE.
       /
!

#  run the executable
  $mpirunCommand $npes ./$executable:t >fms.out
  
  cat fms.out
       
#---------------------------------------------------------------------
# rename the ascii output file
  mv fms.out $name.fms.out
  mv logfile*.out $name.logfile.out

  unset echo

# Build the shared FMS component library
# The list of source files that should be compiled for this component.

set pathnames_shared  = $code_dir/path_names_shared        # path to file containing list of source paths

$root/bin/list_paths $root/src/shared
mv path_names $pathnames_shared

#set srcList = ( shared/tridiagonal shared/tracer_manager shared/topography shared/time_manager shared/time_interp shared/station_data shared/sat_vapor_pres shared/random_numbers shared/platform shared/oda_tools shared/diag_manager shared/data_override shared/constants shared/column_diagnostics shared/axis_utils shared/astronomy shared/amip_interp shared/fft shared/field_manager shared/horiz_interp shared/include shared/memutils shared/mosaic shared/coupler shared/test )
set srcList = ( shared/tridiagonal shared/tracer_manager shared/topography shared/time_manager shared/time_interp shared/station_data shared/sat_vapor_pres shared/random_numbers shared/platform shared/oda_tools shared/diag_manager shared/data_override shared/constants shared/column_diagnostics shared/axis_utils                  shared/amip_interp shared/fft shared/field_manager shared/horiz_interp shared/include shared/memutils shared/mosaic shared/coupler shared/test )

set lib_name = "lib_FMS"

mkdir -p $executable:h:h/$lib_name

# astronomy.F90 must be compiled with stricter floating point semantics to prevent buggy vectorization
set pathnames_astro = $executable:h:h/$lib_name/astronomy_command-$$
if ( `ifort --version | head -1` =~ "*17.0.4*" & "$vec" == "-vec" ) then
    echo 'compiling astronomy.F90 with fp-model consistent to prevent buggy vectorization'
    echo '$(FC) -fp-model consistent $(CPPDEFS) $(CPPFLAGS) $(FPPFLAGS) $(FFLAGS) $(OTHERFLAGS) -fp-model consistent -c	/p/projects/climber3/petri/POEM/src/shared/astronomy/astronomy.F90' > $pathnames_astro
else
    echo >  $pathnames_astro
    set srcList = ( $srcList shared/astronomy )
endif

cd $executable:h:h/$lib_name
$mkmf_lib -p $lib_name.a -c "$cppDefs" $srcList $pathnames_astro $pathnames_shared $lib_include_dirs
make

if( $status ) then
    echo "Make failed to create $lib_name.a"
    exit 1
endif

#!/bin/tcsh 
#=======================================================================
#      river_regrid : remap river network data.
#         Contact : Zhi Liang   email : Zhi.Liang
#  This program can remap river network data from spherical grid onto another
#  spherical grid. 
#
#  This preprocessing program was tested with Intel Fortran compiler on ia64 at GFDL.
#  In order to run on other system, some changes may be needed.
#######################################################################
# Users need to modify the following variables according to their need. 
# These particular values are here for testing purposes in GFDL only.  
#######################################################################

  set echo
  set platform     = "ncrc.intel"                                    # A unique identifier for your platform
  set npes         = 1
#
  set root         = $cwd:h:h:h                         # The directory that contains src/ and bin/
#
# Users must ensure the following  files exist for their platform.
#
  source $root/bin/environs.$platform                   # environment variables and compiler options

  set mkmfTemplate = $root/bin/mkmf.template.$platform  # path to mkmf template 
# needed data set and field name of the runoff data
# NOTE: Users must change the following according to their need. These particular values are here for testing purposes only.
#
 set river_input_file = $FMS_ARCHIVE/home/z1l/fms/src/preprocessing/river_regrid/input/orig_runoff.rivers_init.nc
 set land_grid_file   = $FMS_ARCHIVE/mom4/mom4p1/riga/preprocess_tools/grid_spec.partial_areas.1deg.nc

#############################################################################
# Users need not change anything below this line except the namelists values.
##############################################################################
  set name         = "river_regrid"                         # name of the data file will be generated
  set tooldir      = $cwd                                   # directory of the tool
  set sharedir     = $root/src/shared                       # directory of the shared code.
  set includedir   = $sharedir/include                          # fms include directory
  set workdir      = $tooldir/workdir                       # where the tool is run and output is produced
  set executable   = $tooldir/exec/river_regrid.exe            # executable created after compilation
  set mkmf         = $root/bin/mkmf                         # path to executable mkmf
  set cppDefs      = ( "-Duse_netCDF -Duse_netCDF3 -Duse_libMPI" )                     # list of cpp #defines to be passed to the source files

# list the source code
  set CORE      = "$tooldir/{river_regrid.f90}"
  set UTILITIES = "$sharedir/{axis_utils,constants,fms,mpp,platform,memutils,horiz_interp,mosaic}"
  set UTILITIES    = " $UTILITIES $sharedir/mpp/include $includedir "
  set srclist   = ( $CORE $UTILITIES )

# compile the code and create executable
  if( ! -d $executable:h ) mkdir $executable:h
  cd $executable:h
  $mkmf -t $mkmfTemplate -p $executable:t -c "$cppDefs" $srclist /usr/local/include

  make $executable:t

#--------------------------------------------------------------------------------------------------------
# setup directory structure
  if ( ! -d $workdir )         mkdir $workdir

  cd $workdir

# get executable  
  cp $executable $executable:t

# --- set up namelist

  cat >input.nml <<!
     &river_regrid_nml
       river_input_file = '$river_input_file'
       land_grid_file   = '$land_grid_file' /
!


#  run the executable
     $mpirunCommand $npes ./$executable:t >fms.out

     cat fms.out
  
#---------------------------------------------------------------------
# rename the ascii output file
  mv fms.out $name.fms.out
  mv logfile*.out $name.logfile.out

  unset echo

# Build the land_lad2 library

set srcList = ( land_lad2/vegetation land_lad2/transitions land_lad2/topo_rough land_lad2/soil land_lad2/snow land_lad2/shared land_lad2/shared/nf_utils land_lad2/river land_lad2/lake land_lad2/glacier land_lad2/canopy_air land_lad2 )

set lib_name = "lib_land_lad2"

# TODO: compiler version check.
# land_lad2 is fixed to ifort version 15.0.3.
# gfortran and all other tested ifort versions produce wrong code for
# writing and reading restart information.

# land_lad2 must be compiled without OpenMP , at least with ifort 15.0.3

mkdir -p $executable:h:h/$lib_name
cd $executable:h:h/$lib_name
$mkmf_lib -p $lib_name.a -c "-DUSE_LOG_DIAG_FIELD_INFO -qno-openmp $cppDefs"  -o "-I$executable:h:h/lib_FMS -qno-openmp" $srcList $lib_include_dirs
make

if( $status ) then
    echo "Make failed to create $lib_name.a"
    exit 1
endif

#!/bin/tcsh 
#=======================================================================
#      compare_grid : compare topography of two grid files.
#         Contact : Zhi Liang   email : Zhi.Liang
#
#  This runscritp compares two grid descriptor files (generated via ocean_grid_generator) 
#  and creates a text file output listing line-by-line differences between the
#  two files. Output file format is the same as the grid_edits file used by
#  edit_grid.F90. These two compared files should have same grid size and same grid
#  resolution.
#=======================================================================
#  This preprocessing program was tested with Intel Fortran compiler on ia64 at GFDL.
#  In order to run on other system, some changes may be needed.
#######################################################################
# Users need to modify the following variables according to their need. 
# These particular values are here for testing purposes in GFDL only.  
#######################################################################

  set echo
  set platform     = "ncrc.intel"                              # A unique identifier for your platform
#
  set root         = $cwd:h:h:h:h                       # The directory that contains src/ and bin/
#
# Users must ensure the following  files exist for their platform.
#
  source $root/bin/environs.$platform                   # environment variables and compiler options

  set mkmfTemplate = $root/bin/mkmf.template.$platform  # path to mkmf template 
  # grid data will be compared
  set grid_file  = $FMS_ARCHIVE/mom4/mom4p0/mom4p0c/mom4_test5/preprocessing/grid_spec_v7.nc
#
#############################################################################
# Users need not change anything below this line except the namelists values.
#############################################################################
  set name         = "check_mask"                      # name of tool and name of the output
  set tooldir      = $cwd                              # directory of the tool
  set sharedir     = $root/src/shared                  # directory of the shared code.   
  set includedir   = $sharedir/include
  set workdir      = $tooldir/workdir                  # where the tool is run and output is produced
  set executable   = $tooldir/exec/check_mask.exe      # executable created after compilation
  if ( $?DEBUG ) then
    set executable    = $tooldir/debug/check_mask.exe 
    set mkmfTemplate  = $root/bin/mkmf.debugtemplate.$platform         
  endif
  set mkmf         = $root/bin/mkmf                    # path to executable mkmf
  set cppDefs      = ( "-Duse_netCDF -Duse_netCDF3 -Duse_libMPI -Dcheck_mask" )                # list of cpp #defines to be passed to the source files

# list the source code
  
  set CORE      = "$tooldir/check_mask.F90"
  set UTILITIES    = "$sharedir/{constants,fms,mpp,platform,memutils}"
  set UTILITIES    = " $UTILITIES $sharedir/mpp/include $includedir" 
  set srclist   = "$CORE $UTILITIES"

#---------------------------------------------------------------------
# compile the model code and create executable
  if( ! -d $executable:h ) mkdir $executable:h
  cd $executable:h
  $mkmf -t $mkmfTemplate -p $executable:t -c "$cppDefs" $srclist 

  make $executable:t

#--------------------------------------------------------------------------------------------------------
# setup directory structure
  if ( ! -d $workdir )         mkdir $workdir

  cd $workdir

# get executable  
  cp $executable $executable:t

# --- set up namelist

    cat >input.nml <<!
    &check_mask_driver_nml
       grid_file   = '$grid_file' 
       /
!

  $executable:t >fms.out
  cat fms.out
#   --- rename ascii output file
  mv fms.out $name.fms.out
  mv logfile*.out $name.logfile.out
  
  unset echo  

# Build the land_lad library

set lib_name = "lib_land_lad"

# land_model.F90 must be compiled without vectorization!
# ifort 15.0.3.187 apparently has a bug.
# With ifort 17.0.1.132 land_model.F90 can be compiled with vectorization.
set pathnames = $executable:h:h/$lib_name/land_model_command-$$

set srcList = ( land_param land_lad/vegetation land_lad/soil land_lad/numerics.F90 land_lad/land_types.F90 $pathnames )

mkdir -p $executable:h:h/$lib_name

if ( `$(FC) --version` =~ 15.0.3 ) then
    echo compiling land_model.F90 without vectorization because of compiler bug (ifort 15.0.3)
#	$(FC) $(CPPDEFS) $(CPPFLAGS) $(FPPFLAGS) $(FFLAGS) $(OTHERFLAGS) -c -I/p/projects/climber3/petri/POEM/src/shared/include	/p/projects/climber3/petri/POEM/src/land_lad/land_model.F90
    echo '$(FC) -no-vec $(CPPDEFS) $(CPPFLAGS) $(FPPFLAGS) $(FFLAGS) $(OTHERFLAGS) -no-vec -c land_lad/land_model.F90' > $pathnames
else
    echo land_lad/land_model.F90 > $pathnames
endif

cd $executable:h:h/$lib_name
$mkmf_lib -p $lib_name.a -c "$cppDefs"  -o "-I$executable:h:h/lib_FMS" $srcList $lib_include_dirs
rm -f $pathnames
make

if( $status ) then
    echo "Make failed to create $lib_name.a"
    exit 1
endif

#!/bin/sh
#
# $Id: plevel.sh,v 20.0 2013/12/14 00:29:52 fms Exp $
# ------------------------------------------------------------------------------
# FMS/FRE Project: Script to Call Converters to Pressure Levels
# ------------------------------------------------------------------------------
# afy    Ver   1.00  Copied from ~fms/local/ia64/netcdf4.fix        June 10
# afy    Ver   1.00  Don't source the 'init.sh' script              June 10
# afy    Ver   1.01  Use 'which' to locate executables              June 10
# ------------------------------------------------------------------------------
# Copyright (C) NOAA Geophysical Fluid Dynamics Laboratory, 2000-2010
# Designed and written by V. Balaji, Amy Langenhorst and Aleksey Yakovlev
#

fields=
more_output=1
ofile=plevel.nc
ifiles=
do_all_3d_fields=.false.
do_all_fields=.false.
allow_zero=.false.
default_missval=.false.
mask_extrap=.true.
tlist=

# default is ncep reanalysis levels
plevs="100000 92500 85000 70000 60000 50000 40000 30000 25000 \
        20000 15000 10000  7000  5000  3000  2000  1000"

#-----------------------------------------------------------------------

while getopts 03amxi:o:d:p:t: arg
do
    case $arg in
       0) allow_zero=.true.;;
       3) do_all_3d_fields=.true.;;
       a) do_all_fields=.true.;;
       m) default_missval=.true.;;
       x) mask_extrap=.false.;;
       i) ifiles=$OPTARG;;
       o) ofile=$OPTARG;;
       d) more_output=$OPTARG;;
       p) plevs=$OPTARG;;
       t) tlist=$OPTARG;;
       *) exit 1;;
    esac
done
shift `expr $OPTIND - 1`
fields=$@

#-----------------------------------------------------------------------

if [ "${ifiles:-NULL}" = "NULL" ]; then
name=`basename $0`
cat << EOF

Interpolates data from model levels to pressure levels.
The input model grid is a hybrid sigma-pressure coordinate
and the output pressure levels may be specified.
The minimum required input fields are "bk", "pk", and "ps".

Usage:  $name [-a] [-3] [-0] [-f] [-d #] -i file [-o ofile] [-m] [fields.....]

        -a        = Output all fields converting 3d fields to pressure levels.
        -3        = Output and convert all 3d fields to pressure levels.
        -0        = When fields sphum or zsurf do not exist use zero, otherwise fail.
        -m        = Default missing value is used for all fields (the _FillValue).
        -x        = DO NOT set data extrapolated beneath the surface to missing values.
        -i file   = Input netcdf file, the file must contain the required variables 
                    (pk,bk,ps,...).
                    If the -i files option is omitted a usage message is printed.
        -o ofile  = The output file name. (Default: plevel.nc)
        -p plevs  = A list of output pressure levels in pascals (with no decimal point).
                    The default is the 17 NCEP reananalysis levels (bottom to top).
                    The list must be in quotes and values must be separated by a space.
        -d value    The verbosity level, use an integer number where value >= 0.
                    (Default: value=1)
        -t #,#,#    The starting, ending, and increment index for time axis processing
                    where # is a positive number.
                    (The default is to process all time indices.)

        fields    = A list of (additional) output fields. If this list is not supplied,
                    then the "-a" or "-3" option must be specified.  Possible list entries
                    included any fields in the input files, and additional fields: slp, hght.
                    Additional input fields may be required for these output fields.

Example:  $name -a -i atmos.nc slp hght

EOF
exit 1
fi

# location of executable
executable=`which PLEV.exe`

if [ ! -x "$executable" ]; then
   echo "ERROR: executable does not exist"
   echo "       executable=$executable"
   exit 1
fi

#  make sure input files are present

list=
for file in $ifiles;
do
   if [ ! -e $file ]; then
       list="$list $file"
   fi
done
if [ ${#list} -gt 0 ]; then
    echo ERROR: the following input files do not exist
    for file in $list;
    do
      echo $file
    done
    exit 1
fi

# process time loop limits (create array of length 3)

tlist=`echo ${tlist} | sed -e "s/,,,/,,0,/"`
tlist=`echo ${tlist} | sed -e "s/^,/0,/"`
tlist=`echo ${tlist} | sed -e "s/,,/,0,/"`
tloop=`echo ${tlist} | sed -e "s/,/ /g"`

#-----------------------------------------------------------------------
#   ---- namelist for pressure interp program ----
    
    namelist="plev.input.nml"

    echo " &input" > $namelist

# input file names
    echo "     in_file_name =  '$file' ," >> $namelist
    echo "     out_file_name =   '$ofile' ,"  >> $namelist

# input field names
i=0
for field in $fields;
do
    let "i=$i+1"
    echo "    field_names($i) =  '$field' ," >> $namelist
done

# pressure level values
i=0
for prs in $plevs;
do
    let "i=$i+1"
    echo "    pout($i) =  $prs.," >> $namelist
done

# more namelist values
cat >> $namelist << EOF
    do_all_3d_fields = $do_all_3d_fields,
    do_all_fields = $do_all_fields,
    allow_zero_sphum = $allow_zero,
    allow_zero_topog = $allow_zero,
    mask_extrap = $mask_extrap,
    use_default_missing_value = $default_missval,
    verbose = $more_output,
EOF

#--- time loop limits ---
i=0
for index in $tloop;
do
    let "i=$i+1"
    if [ $index -gt 0 ]; then 
       case $i in
          1) echo "    time_beg = $index" >> $namelist;;
          2) echo "    time_end = $index" >> $namelist;;
          3) echo "    time_inc = $index" >> $namelist;;
       esac    
    fi
done

   echo " /" >> $namelist

$executable

#rm -f $namelist

# Build the am3 library

set srcList = ( atmos_param/diag_integral atmos_param/monin_obukhov atmos_shared/vert_advection atmos_shared/tracer_driver/tropchem atmos_shared/tracer_driver/stratchem atmos_shared/tracer_driver atmos_shared/tracer_driver/aer_ccn_act atmos_shared/interpolator atmos_shared/atmos_nudge atmos_param/vert_turb_driver atmos_param/vert_diff_driver atmos_param/vert_diff atmos_param/topo_drag atmos_param/strat_cloud atmos_param/stable_bl_turb atmos_param/shallow_physics atmos_param/shallow_cu atmos_param/shallow_conv atmos_param/rh_clouds atmos_param/ras atmos_param/radiation_driver atmos_param/physics_driver atmos_param/my25_turb atmos_param/moist_processes atmos_param/moist_conv atmos_param/mg_drag atmos_param/lscale_cond atmos_param/lin_cloud_microphys atmos_param/grey_radiation atmos_param/fsrad atmos_param/entrain atmos_param/edt atmos_param/dry_adj atmos_param/donner_deep atmos_param/diffusivity atmos_param/diag_cloud_rad atmos_param/diag_cloud atmos_param/damping_driver atmos_param/cu_mo_trans atmos_param/cosp/quickbeam atmos_param/cosp/llnl atmos_param/cosp/icarus-scops-3.7 atmos_param/cosp/actsim atmos_param/cosp/MODIS_simulator atmos_param/cosp/MISR_simulator atmos_param/cosp atmos_param/clouds atmos_param/cloud_zonal atmos_param/cloud_rad atmos_param/cloud_obs atmos_param/cloud_generator atmos_param/cg_drag atmos_param/betts_miller atmos_param/clubb )

set sea_esf_rad_files = ( `(cd $root/src ; find atmos_param/sea_esf_rad -name '*.F90' -print | grep -v longwave_tables)` )

set lib_name = "lib_atmos_phys"

mkdir -p $executable:h:h/$lib_name

# ifort 17.0.1.132 and 19.x produce buggy code when compiling
# src/atmos_param/sea_esf_rad/longwave_tables.F90
# with full optimization: -O3 -xHOST -qopenmp -parallel
# It works when compiled without -O3 -xHOST .
# That file contains only an init routine, so no-optimization should not matter for run time.
set pathnames = $executable:h:h/$lib_name/longwave_tables_command-$$
set srcList = ( $pathnames $sea_esf_rad_files $srcList )
if ( X"$debug$vec" =~ '*omp*' ) then
    echo compiling longwave_tables.F90 without optimization to avoid compiler bug with combination of optimization and openmp
#	$(FC) $(CPPDEFS) $(CPPFLAGS) $(FPPFLAGS) $(FFLAGS) $(OTHERFLAGS) -c	/p/projects/climber3/petri/POEM/src/atmos_param/sea_esf_rad/longwave_tables.F90
    echo '$(FC) -O0 $(CPPDEFS) $(CPPFLAGS) $(FPPFLAGS) $(FFLAGS) $(OTHERFLAGS) -O0 -c atmos_param/sea_esf_rad/longwave_tables.F90' > $pathnames
else
    echo atmos_param/sea_esf_rad/longwave_tables.F90 > $pathnames
endif

cd $executable:h:h/$lib_name
$mkmf_lib -p $lib_name.a -c "$cppDefs" -o "-I$executable:h:h/lib_FMS" $srcList $lib_include_dirs
rm -f $pathnames
make

if( $status ) then
    echo "Make failed to create $lib_name.a"
    exit 1
endif

#!/bin/tcsh 
#=======================================================================
#      idealized_ic : generate idealized initial condition
#         Contact : Zhi Liang   email : Zhi.Liang
#
#  This runscript can be used to generate tracer initial conditions for mom4.
#  It creates Makefile, compiles if necessary and  saves output.The generated
#  data sets are saved in the directory $output_dir/data. A grid_spec file
#  is needed for this program. 
#  ******Important notice: to obtain desired initial condition, you need to
#  specify initial_nml which is listed in this runscript.
#=======================================================================
#  This preprocessing program was tested with Intel Fortran compiler on ia64 at GFDL.
#  In order to run on other system, some changes may be needed.
#######################################################################
# Users need to modify the following variables according to their need. 
# These particular values are here for testing purposes in GFDL only.  
#######################################################################

  set echo
  set platform     = "ncrc.intel"                           # A unique identifier for your platform
  set npes         = 1                                      # number of processors
#
# input data file and destination grid
#
  set grid_spec_file  = $cwd:h:h/generate_grids/ocean/workdir/ocean_grid.nc  # destination grid
#
  set root         = $cwd:h:h:h:h                         # The directory that contains src/ and bin/
#
# Users must ensure the following  files exist for their platform.
#
  source $root/bin/environs.$platform                   # environment variables and compiler options

  set mkmfTemplate = $root/bin/mkmf.template.$platform  # path to mkmf template 

#############################################################################
# Users need not change anything below this line except the namelists values.
#############################################################################
  set name         = "idealized_ic"                         # name of the tool
  set tooldir      = $cwd                                   # directory of the tool
  set sharedir     = $root/src/shared                       # directory of the shared code.
  set includedir   = $sharedir/include                      # fms include directory
  set workdir      = $tooldir/workdir                       # where the tool is run and output is produced
  set executable   = $tooldir/exec/idealized_ic.exe            # executable created after compilation
  if ( $?DEBUG ) then
    set executable    = $tooldir/debug/idealized_ic.exe 
    set mkmfTemplate  = $root/bin/mkmf.debugtemplate.$platform         
  endif
  set mkmf         = $root/bin/mkmf                         # path to executable mkmf
  set cppDefs      = ( "-Duse_netCDF -Duse_netCDF3 -Duse_libMPI" )        # list of cpp #defines to be passed to the source files

# list the source code
  set CORE      = $tooldir/{idealized_ic.f90,idealized_ic_driver.f90}
  set UTILITIES = "$sharedir/{fms,mpp,platform,constants,memutils}"
  set UTILITIES    = " $UTILITIES $sharedir/mpp/include $includedir " 
  set srclist   = ( $CORE $UTILITIES )

# compile the code and create executable
  if( ! -d $executable:h ) mkdir $executable:h
  cd $executable:h
  $mkmf -t $mkmfTemplate -p $executable:t -c "$cppDefs" $srclist /usr/local/include

  make $executable:t

#--------------------------------------------------------------------------------------------------------
# setup directory structure
  if ( ! -d $workdir )         mkdir $workdir

  cd $workdir

# get executable  
  cp $executable $executable:t

# --- set up namelist

    cat >input.nml <<!
    &idealized_ic_nml
       temp_type = 'zonal_levitus_temp_ic',
       salt_type = 'salinity_profile_ic'
       constant_temp_value = 15.1 ,
       constant_salt_value = 32. 
       passive_tracer_file = 'ocean_age.res.nc'
       grid_file           = '$grid_spec_file' /
    &fms_nml
       domains_stack_size = 395850 /       
!

#  run the executable
  $mpirunCommand $npes $executable:t >fms.out
  
  cat fms.out
       
#---------------------------------------------------------------------
# rename the ascii output file
  mv fms.out $name.fms.out
  mv logfile*.out $name.logfile.out

  unset echo

#!/bin/tcsh 
#=======================================================================
#      regrid_2d : interp 2-D data
#         Contact : Zhi Liang   email : z1l
#
#  This runscritp can be used to regrid data $src_data on any grid $src_grid to logically
#  rectangular grid described by grid descriptor file $dst_grid. 
#
#  This preprocessing program was tested with Intel Fortran compiler on ia64 at GFDL.
#  In order to run on other system, some changes may be needed.
#######################################################################
# Users need to modify the following variables according to their need. 
# These particular values are here for testing purposes in GFDL only.  
#######################################################################

  set echo
  set platform     = "ncrc.intel"                               # A unique identifier for your platform
  set npes         = 1                                  # number of processors
#
  set root         = $cwd:h:h:h                         # The directory that contains src/ and bin/
#
# Users must ensure the following  files exist for their platform.
#
  source $root/bin/environs.$platform                   # environment variables and compiler options

  set mkmfTemplate = $root/bin/mkmf.template.$platform  # path to mkmf template 
# input data file and destination grid
  set src_data       = $FMS_ARCHIVE/z1l/CM2Q-d2_1PctTo4x_j1/ocean.000101-000512.eta_t.nc
  set grid_spec_file = $FMS_ARCHIVE/z1l/postprocessing/regrid/input/om3ocn_1degatm.nc

#############################################################################
# Users need not change anything below this line except the namelists values.
#############################################################################
  set name         = "regrid_eta_t"                         # name of the data file will be generated
  set tooldir      = $cwd                                   # directory of the tool
  set sharedir     = $root/src/shared                       # directory of the shared code.
  set includedir   = $sharedir/include
  set workdir      = $tooldir/workdir                       # where the tool is run and output is produced
  set executable   = $tooldir/exec/regrid.exe               # executable created after compilation
  set mkmf         = $root/bin/mkmf                     # path to executable mkmf
  set cppDefs      = ( "-Duse_netCDF -Duse_netCDF3 -Duse_libMPI" )        # list of cpp #defines to be passed to the source files

# list the source code
  set CORE      = "$tooldir/{regrid.F90}"
  set UTILITIES = "$sharedir/{axis_utils,constants,fms,mpp,horiz_interp,platform,memutils,mosaic}"
  set UTILITIES    = " $UTILITIES $sharedir/mpp/include $includedir " 
  set srclist   = ( $CORE $UTILITIES )

# compile the code and create executable
  if( ! -d $executable:h ) mkdir $executable:h
  cd $executable:h
  $mkmf -t $mkmfTemplate -p $executable:t -c "$cppDefs" $srclist /usr/local/include 

  make $executable:t

  if($status != 0) then
     unset echo
     echo " Error in compilation "
     exit 1
  endif

#--------------------------------------------------------------------------------------------------------
# setup directory structure
  if ( ! -d $workdir )         mkdir $workdir

  cd $workdir

# get executable  
  cp $executable $executable:t

# --- set up namelist

    cat >input.nml <<!
    &regrid_nml
       src_data       = '$src_data',
       grid_spec_file = '$grid_spec_file',
       dst_data       = '$name.nc',
       num_flds       = 1
       fld_name       = 'eta_t'
       fld_pos        =  'T'
       vector_fld     = .false.
       debug          = .false. /
!

#  run the executable
  $mpirunCommand $npes ./$executable:t >fms.out 
  cat fms.out
       
#---------------------------------------------------------------------
# rename the ascii output file
  mv fms.out $name.fms.out

  unset echo

#!/bin/tcsh 
#=======================================================================
#      grid_transer 
#         Contact : Zhi Liang   email : Zhi.Liang
#
#  This runscritp can be used to convert the old name convention grid specification
#  netcdf file to new name convention grid netcdf file. The user need to provide the
#  input grid file $old_grid and the program will generate the output grid file
#  $new_grid. The output file $new_grid contains both the new name convention grid
#  infofmation and all the fields in $old_grid.
#
#=======================================================================
#  This preprocessing program was tested with Intel Fortran compiler on ia64 at GFDL.
#  In order to run on other system, some changes may be needed.
#######################################################################
# Users need to modify the following variables according to their need. 
# These particular values are here for testing purposes in GFDL only.  
#######################################################################

  set echo
  set platform     = "ncrc.intel"                                # A unique identifier for your platform
  set npes         = 1                                      # number of processors

#
  set root         = $cwd:h:h:h:h                       # The directory that contains src/ and bin/
#
# Users must ensure the following  files exist for their platform.
#
  source $root/bin/environs.$platform                   # environment variables and compiler options
# grid file to be converted
  set old_grid     = "$FMS_ARCHIVE/mom4/mom4p1/nalanda/mom4_om3_core/preprocessing/grid_spec_v7.nc"
                    # grid file you want to transfer to new format.

#############################################################################
# Users need not change anything below this line except the namelists values.
#############################################################################
  set mkmfTemplate = $root/bin/mkmf.template.$platform  # path to mkmf template 
  set name         = "grid_transfer"                    # name of the grid file will be generated
  set tooldir      = $cwd                               # directory of the tool
  set sharedir     = $root/src/shared                   # directory of the shared code.
  set includedir   = $sharedir/include                      # fms include directory
  set workdir      = $tooldir/workdir                   # where the tool is run and output is produced
  set mkmf         = $root/bin/mkmf                     # path to executable mkmf
  set cppDefs      = ( "-Duse_netCDF -Duse_netCDF3 -Duse_libMPI" )   # list of cpp #defines to be passed to the source files
  set executable   = $tooldir/exec/grid_transfer.exe    # executable created after compilation


# list the source code
  
  set CORE         = "$tooldir/{grid_transfer.F90}"
  set UTILITIES    = "$sharedir/{axis_utils,constants,fms,mpp,platform,memutils}"
  set UTILITIES    = " $UTILITIES $sharedir/mpp/include $includedir " 
  set srclist      =  ( $CORE $UTILITIES )                       # list of the source code


# compile the code and create executable
  if( ! -d $executable:h ) mkdir $executable:h
  cd $executable:h
  $mkmf -t $mkmfTemplate -p $executable:t -c "$cppDefs" $srclist 

  make $executable:t

#--------------------------------------------------------------------------------------------------------
# setup directory structure
  if ( ! -d $workdir )         mkdir $workdir

  cd $workdir

# get executable  
  cp $executable $executable:t

# --- set up namelist
    cat >input.nml <<!
    &grid_transfer_nml
      old_grid = '$old_grid'
      new_grid = '$name.nc'
       /
!

#  run the executable
  $mpirunCommand $npes ./$executable:t >fms.out
  
  cat fms.out
       
#---------------------------------------------------------------------
# rename the ascii output file
  mv fms.out $name.fms.out
  mv logfile*.out $name.logfile.out

  unset echo

#!/bin/csh -f
#
#Modify the namelists in input.nml to comply with the changes in this release
#
  sed "s/barotropic_time_stepping_mom4p0/barotropic_time_stepping_A/g" -i input.nml
  sed "s/barotropic_time_stepping_mom4p1/barotropic_time_stepping_B/g" -i input.nml
  sed "/.*robert_asselin_bt.*/d" -i input.nml
  sed "/.*barotropic_leap_frog.*/d" -i input.nml
  sed "/.*barotropic_pred_corr.*/d" -i input.nml
  sed "s/linear_eos/eos_linear/g" -i input.nml
  sed "s/alpha_eos_linear/alpha_linear_eos/g" -i input.nml
  sed "s/beta_eos_linear/beta_linear_eos/g" -i input.nml
  sed "s/eos_linear=.false./eos_linear=.false. \n eos_preteos10=.true./g" -i input.nml
  sed "/.*freezing_temp_accurate.*/d" -i input.nml
#
#Correct field_table enteries for ppm_hlimiter=3 and ppm_vlimiter=3 to be 2 instead of 3
#
  sed "s/ppm_hlimiter=3/ppm_hlimiter=2/g" -i field_table
  sed "s/ppm_vlimiter=3/ppm_vlimiter=2/g" -i field_table
# 
#Avoid am3 physics
#
#  sed "s/do_lsc          =.true./do_lsc          =.false./g" -i input.nml
#  sed "s/do_strat        =.false./do_strat        =.true./g" -i input.nml
#  sed "s/do_diffusivity   = .true./do_diffusivity   = .false./g" -i input.nml
#
#MOM5 required changes
#
  sed s/\'kpp\'/\'kpp_mom4p1\'/g -i input.nml 
  sed "s/ocean_vert_kpp_nml/ocean_vert_kpp_mom4p1_nml/g" -i input.nml 
#
#Do not specify the layout so that the model could run on any npes
#  sed "/.*layout.*/d" -i input.nml

# Build the Mixed-Layer Slab Ocean library

set srcList = ( ocean_mixed_layer mom5/ocean_core/ocean_parameters.F90 )

set lib_name = "lib_slab"

mkdir -p $executable:h:h/$lib_name
cd $executable:h:h/$lib_name
$mkmf_lib -p $lib_name.a -c "$cppDefs" -o "-I$executable:h:h/lib_FMS" $srcList $lib_include_dirs
make

if( $status ) then
    echo "Make failed to create $lib_name.a"
    exit 1
endif

#!/bin/csh -f
# Minimal compile script for mom4p1 solo experiments

set echo
set platform      = ncrc2.intel     # A unique identifier for your platform
                                   # This corresponds to the mkmf templates in $root/bin dir.
#
# User does not need to change anything below!
#
set type          = EBM                               # Name of the experiment
set root          = $cwd:h                            # The directory you created when you checkout
set code_dir      = $root/src                         # source code directory
set executable    = $root/exec/$platform/$type/fms_$type.x      # executable created after compilation
set pathnames     = $code_dir/path_names_$type        # path to file containing list of source paths
set mppnccombine  = $root/bin/mppnccombine.$platform  # path to executable mppnccombine
set mkmfTemplate  = $root/bin/mkmf.template.$platform # path to template for your platform
set mkmf          = $root/bin/mkmf                    # path to executable mkmf
set cppDefs  = ( "-Duse_netCDF  -Duse_netCDF3 -Duse_libMPI -DLAND_BND_TRACERS -DOVERLOAD_C8 -DOVERLOAD_C4 -DOVERLOAD_R4" )

#
# Users must ensure the correct environment file exists for their platform.
#
source $root/bin/environs.$platform  # environment variables and loadable modules

# setup directory structure
  if ( ! -d $executable:h )    mkdir -p $executable:h

#
# compile mppnccombine.c, needed only if $npes > 1
#NOTE: On some platforms you may need to specify the location for netcdf.h and libnetcdf.a
#      by modifying the following -I and -L
  if (  ! -f $mppnccombine ) then
    cc -O -o $mppnccombine -I/usr/local/include -L/usr/local/lib $code_dir/postprocessing/mppnccombine/mppnccombine.c -lnetcdf
  endif



# The list of source files that should be compiled for this experiment.
cat > $pathnames <<EOF
atmos_coupled/atmos_model.F90
atmos_ebm/atmosphere.F90
atmos_ebm/ebm_diagnostics.F90
atmos_param/betts_miller/betts_miller.F90                                                                
atmos_param/betts_miller/bm_massflux.F90                                                                      
atmos_param/betts_miller/bm_omp.F90                                   
atmos_param/cg_drag/cg_drag.F90                                  
atmos_param/cloud_generator/betaDistribution.F90                 
atmos_param/cloud_generator/cloud_generator.F90                   
atmos_param/cloud_obs/cloud_obs.F90                              
atmos_param/cloud_rad/cloud_rad.F90                              
atmos_param/cloud_zonal/cloud_zonal.F90                          
atmos_param/clouds/clouds.F90                                     
atmos_param/clubb/CLUBB_driver_SCM.F90
atmos_param/clubb/MG_microp_3D.F90
atmos_param/cosp/null/cosp_driver.F90                                
atmos_param/cu_mo_trans/cu_mo_trans.F90                          
atmos_param/damping_driver/damping_driver.F90                       
atmos_param/diag_cloud/diag_cloud.F90                            
atmos_param/diag_cloud_rad/diag_cloud_rad.F90                                            
atmos_param/diffusivity/diffusivity.F90                           
atmos_param/donner_deep/cumulus_closure_k.F90                     
atmos_param/donner_deep/donner_cape_k.F90                        
atmos_param/donner_deep/donner_cloud_model_k.F90                 
atmos_param/donner_deep/donner_deep.F90                           
atmos_param/donner_deep/donner_deep_k.F90                         
atmos_param/donner_deep/donner_deep_miz.F90                       
atmos_param/donner_deep/donner_lite_k.F90                        
atmos_param/donner_deep/donner_lscloud_k.F90                     
atmos_param/donner_deep/donner_meso_k.F90                         
atmos_param/donner_deep/donner_nml.h                             
atmos_param/donner_deep/donner_rad_k.F90                         
atmos_param/donner_deep/donner_types.F90                     
atmos_param/donner_deep/donner_types.h                           
atmos_param/donner_deep/donner_utilities_k.F90                    
atmos_param/donner_deep/fms_donner.F90                         
atmos_param/donner_deep/nonfms_donner.F90                        
atmos_param/donner_deep/wet_deposition_0D.F90                    
atmos_param/dry_adj/dry_adj.F90                                  
atmos_param/edt/edt.F90                                          
atmos_param/entrain/entrain.F90                                   
atmos_param/fsrad/co2_data.F90                                    
atmos_param/fsrad/co2int.F90                                                                                             
atmos_param/fsrad/fs_profile.F90                                 
atmos_param/fsrad/fsrad.F90                                      
atmos_param/fsrad/hconst.F90                                     
atmos_param/fsrad/longwave.F90                                   
atmos_param/fsrad/mcm_lw.F90                                     
atmos_param/fsrad/mcm_sw_driver.F90                              
atmos_param/fsrad/mcm_swnew.F90                                   
atmos_param/fsrad/mcm_swtbls.F90                                 
atmos_param/fsrad/rad_diag.F90                                   
atmos_param/fsrad/rdparm.F90
atmos_param/fsrad/shortwave.F90
atmos_param/grey_radiation/grey_radiation.F90
atmos_param/lin_cloud_microphys/lin_cloud_microphys.F90
atmos_param/lscale_cond/lscale_cond.F90
atmos_param/mg_drag/mg_drag.F90
atmos_param/moist_conv/moist_conv.F90
atmos_param/moist_processes/detr_ice_num.F90
atmos_param/moist_processes/moist_processes.F90
atmos_param/moist_processes/moist_processes_utils.F90
atmos_param/moist_processes/moistproc_kernels.F90
atmos_param/my25_turb/my25_turb.F90
atmos_param/physics_driver/physics_driver.F90
atmos_param/radiation_driver/radiation_driver.F90
atmos_param/ras/ras.F90
atmos_param/rh_clouds/rh_clouds.F90
atmos_param/sea_esf_rad/aerosol.F90
atmos_param/sea_esf_rad/aerosolrad_package.F90
atmos_param/sea_esf_rad/bulkphys_rad.F90
atmos_param/sea_esf_rad/cloud_spec.F90
atmos_param/sea_esf_rad/cloudrad_diagnostics.F90
atmos_param/sea_esf_rad/cloudrad_package.F90
atmos_param/sea_esf_rad/diag_clouds_W.F90
atmos_param/sea_esf_rad/donner_deep_clouds_W.F90
atmos_param/sea_esf_rad/esfsw_driver.F90
atmos_param/sea_esf_rad/esfsw_parameters.F90
atmos_param/sea_esf_rad/gas_tf.F90
atmos_param/sea_esf_rad/isccp_clouds.F90
atmos_param/sea_esf_rad/lhsw_driver.F90
atmos_param/sea_esf_rad/longwave_clouds.F90
atmos_param/sea_esf_rad/longwave_driver.F90
atmos_param/sea_esf_rad/longwave_fluxes.F90
atmos_param/sea_esf_rad/longwave_params.F90
atmos_param/sea_esf_rad/longwave_tables.F90
atmos_param/sea_esf_rad/lw_gases_stdtf.F90
atmos_param/sea_esf_rad/mgrp_prscr_clds.F90
atmos_param/sea_esf_rad/microphys_cloud.F90
atmos_param/sea_esf_rad/microphys_rad.F90
atmos_param/sea_esf_rad/optical_path.F90
atmos_param/sea_esf_rad/original_fms_rad.F90
atmos_param/sea_esf_rad/ozone.F90
atmos_param/sea_esf_rad/rad_output_file.F90
atmos_param/sea_esf_rad/rad_utilities.F90
atmos_param/sea_esf_rad/radiation_diag.F90
atmos_param/sea_esf_rad/radiative_gases.F90
atmos_param/sea_esf_rad/rh_based_clouds.F90
atmos_param/sea_esf_rad/sea_esf_rad.F90
atmos_param/sea_esf_rad/sealw99.F90
atmos_param/sea_esf_rad/shortwave_driver.F90
atmos_param/sea_esf_rad/specified_clouds_W.F90
atmos_param/sea_esf_rad/standalone_clouds.F90
atmos_param/sea_esf_rad/strat_clouds_W.F90
atmos_param/sea_esf_rad/uw_clouds_W.F90
atmos_param/sea_esf_rad/zetac_clouds_W.F90
atmos_param/shallow_conv/shallow_conv.F90
atmos_param/shallow_cu/conv_closures.F90
atmos_param/shallow_cu/conv_plumes.F90
atmos_param/shallow_cu/conv_plumes_k.F90
atmos_param/shallow_cu/conv_utilities.F90
atmos_param/shallow_cu/conv_utilities_k.F90
atmos_param/shallow_cu/deep_conv.F90
atmos_param/shallow_cu/uw_conv.F90
atmos_param/stable_bl_turb/stable_bl_turb.F90
atmos_param/strat_cloud/aerosol_cloud.F90
atmos_param/strat_cloud/check_nan.F90
atmos_param/strat_cloud/cldwat2m_micro.F90
atmos_param/strat_cloud/gamma_mg.F90
atmos_param/strat_cloud/mg_const.F90
atmos_param/strat_cloud/microphysics.F90
atmos_param/strat_cloud/morrison_gettelman_microp.F90
atmos_param/strat_cloud/nc_cond.F90
atmos_param/strat_cloud/polysvp.F90
atmos_param/strat_cloud/rotstayn_klein_mp.F90
atmos_param/strat_cloud/simple_pdf.F90
atmos_param/strat_cloud/strat_cloud.F90
atmos_param/strat_cloud/strat_cloud_legacy.F90
atmos_param/strat_cloud/strat_cloud_utilities.F90
atmos_param/strat_cloud/strat_netcdf.F90
atmos_param/strat_cloud/strat_nml.h
atmos_param/topo_drag/topo_drag.F90
atmos_param/vert_diff/vert_diff.F90
atmos_param/vert_diff_driver/vert_diff_driver.F90
atmos_param/vert_turb_driver/vert_turb_driver.F90
atmos_shared/atmos_nudge/atmos_nudge.F90
atmos_shared/interpolator/interpolator.F90
atmos_shared/tracer_driver/aer_ccn_act/aer_ccn_act.F90
atmos_shared/tracer_driver/aer_ccn_act/aer_ccn_act_k.F90
atmos_shared/tracer_driver/aer_ccn_act/aer_in_act.F90
atmos_shared/tracer_driver/aer_ccn_act/aerosol_params.F90
atmos_shared/tracer_driver/aer_ccn_act/ice_nucl.F90
atmos_shared/tracer_driver/atmos_age_tracer.F90
atmos_shared/tracer_driver/atmos_carbon_aerosol.F90
atmos_shared/tracer_driver/atmos_ch3i.F90
atmos_shared/tracer_driver/atmos_co2.F90
atmos_shared/tracer_driver/atmos_convection_tracer.F90
atmos_shared/tracer_driver/atmos_dust.F90
atmos_shared/tracer_driver/atmos_radon.F90
atmos_shared/tracer_driver/atmos_sea_salt.F90
atmos_shared/tracer_driver/atmos_soa.F90
atmos_shared/tracer_driver/atmos_sulfate.F90
atmos_shared/tracer_driver/atmos_sulfur_hex.F90
atmos_shared/tracer_driver/atmos_tracer_driver.F90
atmos_shared/tracer_driver/atmos_tracer_utilities.F90
atmos_shared/tracer_driver/stratchem/strat_chem_driver.F90
atmos_shared/tracer_driver/stratchem/strat_chem_model.F90
atmos_shared/tracer_driver/tropchem/m_tracname.F90
atmos_shared/tracer_driver/tropchem/mo_chem_utls.F90
atmos_shared/tracer_driver/tropchem/mo_chemdr.F90
atmos_shared/tracer_driver/tropchem/mo_chemini.F90
atmos_shared/tracer_driver/tropchem/mo_exp_slv.F90
atmos_shared/tracer_driver/tropchem/mo_fastjx.F90
atmos_shared/tracer_driver/tropchem/mo_fphoto.F90
atmos_shared/tracer_driver/tropchem/mo_hook.F90
atmos_shared/tracer_driver/tropchem/mo_imp_slv.F90
atmos_shared/tracer_driver/tropchem/mo_jpl.F90
atmos_shared/tracer_driver/tropchem/mo_photo.F90
atmos_shared/tracer_driver/tropchem/mo_read_sim_chm.F90
atmos_shared/tracer_driver/tropchem/mo_rodas_slv.F90
atmos_shared/tracer_driver/tropchem/mo_setinv.F90
atmos_shared/tracer_driver/tropchem/mo_setsox.F90
atmos_shared/tracer_driver/tropchem/mo_usrrxt.F90
atmos_shared/tracer_driver/tropchem/moz.mat.F90
atmos_shared/tracer_driver/tropchem/moz.mods.F90
atmos_shared/tracer_driver/tropchem/moz.subs.F90
atmos_shared/tracer_driver/tropchem/strat_chem_utilities.F90
atmos_shared/tracer_driver/tropchem/tropchem_driver.F90
atmos_shared/vert_advection/vert_advection.F90
atmos_param/diag_integral/diag_integral.F90
atmos_param/monin_obukhov/monin_obukhov.F90
atmos_param/monin_obukhov/monin_obukhov_interfaces.h
atmos_param/monin_obukhov/monin_obukhov_kernel.F90
atmos_spectral/tools/gauss_and_legendre.F90
atmos_spectral/tools/grid_fourier.F90
atmos_spectral/tools/spec_mpp.F90
atmos_spectral/tools/spherical.F90
atmos_spectral/tools/spherical_fourier.F90
atmos_spectral/tools/transforms.F90
coupler/coupler_main.F90
coupler/flux_exchange.F90
coupler/surface_flux.F90
ice_param/ice_albedo.F90
ice_param/ocean_albedo.F90
ice_param/ocean_rough.F90
ice_sis/ice_bergs.F90
ice_sis/ice_dyn.F90
ice_sis/ice_grid.F90
ice_sis/ice_model.F90
ice_sis/ice_spec.F90
ice_sis/ice_thm.F90
ice_sis/ice_type.F90
ice_sis/mask.F90
ice_sis/rot.F90
land_lad/land_model.F90
land_lad/land_types.F90
land_lad/numerics.F90
land_lad/soil/land_properties.F90
land_lad/soil/rivers.F90
land_lad/soil/soil.F90
land_lad/vegetation/vegetation.F90
land_param/climap_albedo.F90
ocean_shared/generic_tracers/FMS_coupler_util.F90
ocean_shared/generic_tracers/FMS_ocmip2_co2calc.F90
ocean_shared/generic_tracers/generic_CFC.F90
ocean_shared/generic_tracers/generic_COBALT.F90
ocean_shared/generic_tracers/generic_TOPAZ.F90
ocean_shared/generic_tracers/generic_BLING.F90
ocean_shared/generic_tracers/generic_miniBLING.F90
ocean_shared/generic_tracers/generic_ERGOM.F90
ocean_shared/generic_tracers/generic_tracer.F90
ocean_shared/generic_tracers/generic_tracer_utils.F90
shared/astronomy/astronomy.F90
shared/axis_utils/axis_utils.F90
shared/column_diagnostics/column_diagnostics.F90
shared/constants/constants.F90
shared/coupler/atmos_ocean_fluxes.F90
shared/coupler/coupler_types.F90
shared/coupler/ensemble_manager.F90
shared/data_override/data_override.F90
shared/diag_manager/diag_axis.F90
shared/diag_manager/diag_data.F90
shared/diag_manager/diag_grid.F90
shared/diag_manager/diag_manager.F90
shared/diag_manager/diag_output.F90
shared/diag_manager/diag_util.F90
shared/diag_manager/diag_table.F90
shared/drifters/cloud_interpolator.F90
shared/drifters/drifters_comm.F90
shared/drifters/drifters_compute_k.h
shared/drifters/drifters_core.F90
shared/drifters/drifters.F90
shared/drifters/drifters_input.F90
shared/drifters/drifters_io.F90
shared/drifters/drifters_push.h
shared/drifters/drifters_set_field.h
shared/drifters/fms_switches.h
shared/drifters/quicksort.F90
shared/exchange/stock_constants.F90
shared/exchange/xgrid.F90
shared/fft/fft99.F90
shared/fft/fft.F90
shared/field_manager/field_manager.F90
shared/field_manager/fm_util.F90
shared/field_manager/parse.inc
shared/fms/fms.F90
shared/fms/fms_io.F90
shared/fms/read_data_2d.inc
shared/fms/read_data_3d.inc
shared/fms/read_data_4d.inc
shared/fms/test_fms_io.F90
shared/fms/write_data.inc
shared/horiz_interp/horiz_interp_bicubic.F90
shared/horiz_interp/horiz_interp_bilinear.F90
shared/horiz_interp/horiz_interp_conserve.F90
shared/horiz_interp/horiz_interp.F90
shared/horiz_interp/horiz_interp_spherical.F90
shared/horiz_interp/horiz_interp_type.F90
shared/include/fms_platform.h
shared/memutils/memuse.c
shared/memutils/memutils.F90
shared/mosaic/constant.h
shared/mosaic/create_xgrid.c
shared/mosaic/create_xgrid.h
shared/mosaic/gradient_c2l.c
shared/mosaic/gradient_c2l.h
shared/mosaic/gradient.F90
shared/mosaic/grid.F90
shared/mosaic/interp.c
shared/mosaic/interp.h
shared/mosaic/mosaic.F90
shared/mosaic/mosaic_util.c
shared/mosaic/mosaic_util.h
shared/mosaic/read_mosaic.c
shared/mosaic/read_mosaic.h
shared/mpp/include/mpp_chksum.h
shared/mpp/include/mpp_chksum_int.h
shared/mpp/include/mpp_chksum_scalar.h
shared/mpp/include/mpp_comm.inc
shared/mpp/include/mpp_comm_mpi.inc
shared/mpp/include/mpp_comm_nocomm.inc
shared/mpp/include/mpp_comm_sma.inc
shared/mpp/include/mpp_data_mpi.inc
shared/mpp/include/mpp_data_nocomm.inc
shared/mpp/include/mpp_data_sma.inc
shared/mpp/include/mpp_do_get_boundary.h
shared/mpp/include/mpp_do_global_field.h
shared/mpp/include/mpp_domains_comm.inc
shared/mpp/include/mpp_domains_define.inc
shared/mpp/include/mpp_domains_misc.inc
shared/mpp/include/mpp_domains_reduce.inc
shared/mpp/include/mpp_domains_util.inc
shared/mpp/include/mpp_do_redistribute.h
shared/mpp/include/mpp_do_update_ad.h
shared/mpp/include/mpp_do_update.h
shared/mpp/include/mpp_do_updateV_ad.h
shared/mpp/include/mpp_do_updateV.h
shared/mpp/include/mpp_error_a_a.h
shared/mpp/include/mpp_error_a_s.h
shared/mpp/include/mpp_error_s_a.h
shared/mpp/include/mpp_error_s_s.h
shared/mpp/include/mpp_get_boundary.h
shared/mpp/include/mpp_global_field.h
shared/mpp/include/mpp_global_reduce.h
shared/mpp/include/mpp_global_sum_ad.h
shared/mpp/include/mpp_global_sum.h
shared/mpp/include/mpp_global_sum_tl.h
shared/mpp/include/mpp_io_connect.inc
shared/mpp/include/mpp_io_misc.inc
shared/mpp/include/mpp_io_read.inc
shared/mpp/include/mpp_io_util.inc
shared/mpp/include/mpp_io_write.inc
shared/mpp/include/mpp_read_2Ddecomp.h
shared/mpp/include/mpp_reduce_mpi.h
shared/mpp/include/mpp_reduce_nocomm.h
shared/mpp/include/mpp_reduce_sma.h
shared/mpp/include/mpp_sum.inc
shared/mpp/include/mpp_sum_mpi.h
shared/mpp/include/mpp_sum_nocomm.h
shared/mpp/include/mpp_sum_sma.h
shared/mpp/include/mpp_transmit.inc
shared/mpp/include/mpp_transmit_mpi.h
shared/mpp/include/mpp_transmit_nocomm.h
shared/mpp/include/mpp_transmit_sma.h
shared/mpp/include/mpp_update_domains2D_ad.h
shared/mpp/include/mpp_update_domains2D.h
shared/mpp/include/mpp_util.inc
shared/mpp/include/mpp_util_mpi.inc
shared/mpp/include/mpp_util_nocomm.inc
shared/mpp/include/mpp_util_sma.inc
shared/mpp/include/mpp_write_2Ddecomp.h
shared/mpp/include/mpp_write.h
shared/mpp/include/system_clock.h
shared/mpp/mpp_data.F90
shared/mpp/mpp_domains.F90
shared/mpp/mpp.F90
shared/mpp/mpp_io.F90
shared/mpp/mpp_memutils.F90
shared/mpp/mpp_parameter.F90
shared/mpp/mpp_pset.F90
shared/mpp/mpp_utilities.F90
shared/mpp/nsclock.c
shared/mpp/test_mpp_domains.F90
shared/mpp/test_mpp.F90
shared/mpp/test_mpp_io.F90
shared/mpp/test_mpp_pset.F90
shared/mpp/threadloc.c
shared/platform/platform.F90
shared/random_numbers/MersenneTwister.F90
shared/random_numbers/random_numbers.F90
shared/sat_vapor_pres/sat_vapor_pres.F90
shared/sat_vapor_pres/sat_vapor_pres_k.F90
shared/time_interp/time_interp_external.F90
shared/time_interp/time_interp.F90
shared/time_manager/get_cal_time.F90
shared/time_manager/time_manager.F90
shared/topography/gaussian_topog.F90
shared/topography/topography.F90
shared/tracer_manager/tracer_manager.F90
shared/tridiagonal/tridiagonal.F90

EOF

set srcList = (  mom5/ocean_bgc mom5/ocean_core mom5/ocean_diag mom5/ocean_blobs mom5/ocean_param/neutral mom5/ocean_param/sources mom5/ocean_param/lateral mom5/ocean_param/vertical mom5/ocean_param/gotm-4.0/include mom5/ocean_param/gotm-4.0/turbulence mom5/ocean_param/gotm-4.0/util mom5/ocean_tracers mom5/ocean_wave        )


# compile the model code and create executable
  set makeFile      = Make_$type
  cd $executable:h
  $mkmf -f -m $makeFile -a $code_dir -t $mkmfTemplate -p $executable:t -c "$cppDefs" $srcList $pathnames $root/include $code_dir/shared/include $code_dir/shared/mpp/include 
#/usr/local/include

  make -f $makeFile

#!/bin/csh
#
#These are the notes on how to make the MOM4p1 public release.
#The notes are intended only for the GFDL people responsible for making the MOM4p1 public release.
#
set FMS_RELEASE=tikal
set MOM_RELEASE=tikal
set PUB_RELEASE=mom5_pubrel_December2013
mkdir src
cd src

#check outs
cvs co -r $MOM_RELEASE mom5
cvs co -r $FMS_RELEASE shared ocean_shared
cvs co -r $FMS_RELEASE ice_sis ice_param
cvs co -r $FMS_RELEASE land_lad land_null land_param land_lad2
cvs co -r $FMS_RELEASE atmos_param_am3
cvs co -r $FMS_RELEASE atmos_bgrid atmos_coupled atmos_ebm atmos_fv_dynamics
cvs co -r $FMS_RELEASE atmos_null atmos_shared atmos_spectral
cvs co -r $FMS_RELEASE coupler

cvs co -r $FMS_RELEASE postprocessing preprocessing  tools

#cut and nullify some stuff
\rm -rf atmos_param/qe_moist_convection atmos_param/two_stream_gray_rad atmos_param/shallow_physics 
\rm -rf atmos_param/lin_cloud_microphys/* atmos_param/clubb/*
cvs co -r nullify_rab_nnz atmos_param/lin_cloud_microphys/lin_cloud_microphys.F90 atmos_param/clubb/CLUBB_driver_SCM.F90 atmos_param/clubb/MG_microp_3D.F90

#The following file is not needed
\rm -rf mom5/drivers/coupler_types.*

\rm -rf tools/xmlDoc tools/fremetar tools/fbrowser


cvs up -r mom5_pubrel_dec2013_nnz mom5/doc
mv mom5/doc ../

#No pdf,ps,html
find . -name '*.pdf' -exec rm -f {} \;
find . -name '*.ps' -exec rm -f {} \;
find . -name '*.html' -exec rm -f {} \;

#bin/ and exp/

cvs co -r mom5_pubrel_dec2013_nnz mom5/utils/
mv mom5/utils/bin ../
mv mom5/utils/exp ../
\rm -rf mom5/utils

#Date tag (sticky) the whole thing
#cvs tag $(PUB_RELEASE)_nnz *

exit 
#The following cleanups is done after tagging.
#No www.gfdl.noaa.gov
foreach file ( `grep -l -r noaa.gov .` )
foreach? sed '/.*www.*.noaa.gov.*/d' -i $file
foreach? end

#No work emails
foreach file ( `grep -l -r @noaa.gov .`)
foreach? sed 's/@noaa.gov/@no.gov/g' -i $file
foreach? end

foreach file ( `grep -l -r @gfdl.noaa.gov .`)
foreach? sed 's/@gfdl.noaa.gov/@no.gov/g' -i $file
foreach? end

foreach file ( `grep -l -r EMAIL .`)
sed 's/EMAIL=.*.gov/EMAIL="GFDL.Climate.Model.Info@noaa.gov/g' -i  $file
end

foreach file ( `grep -l -r @no.gov .` )
foreach? sed 's/@.*no.gov//g' -i $file
foreach? end

exit

#update the htmls for some major files
#The following is too big to be included
cvs co -r xmlDoc_clean_sdu tools/xmlDoc


setenv XMLDOC_ROOT ${PWD}/tools/xmlDoc

foreach file ( coupler shared/diag_manager shared/mpp shared/time_manager shared/data_override preprocessing shared/field_manager mom5 )
${PWD}/tools/xmlDoc/bin/xmlDoc --dir $file
end

#GNUize all F90 and c files
#Some files are checked in without write permission
#chmod -R +w .
#/home/nnz/bin/GNULicense.pl -f --dir=. --recursive
#This will touch ALL code, so you have to test, test, test!
# cvs ci or not ci ,  I wouldn't do it GNU!!

#
#tar up
#
cd ../


tar cvf $PUB_RELEASE.tar $PUB_RELEASE/src
tar rvf $PUB_RELEASE.tar $PUB_RELEASE/bin
tar rvf $PUB_RELEASE.tar $PUB_RELEASE/exp
gzip $PUB_RELEASE.tar

#Documentation
#cvs co -r $MOM_RELEASE mom5/doc
#cd mom5/doc
##Work on the doc/README check it in and move it up
##Work on the doc/quickstart_guide.xml and MOM_practice.xml
##Generate the html and pdf from xml
#/home/nnz/bin/mkdocbk quickstart_guide.xml
#/home/nnz/bin/mkdocbk MOM_practice.xml
#Run Seth's tool to produce .html files for time_manager.html field_manager.html diag_manager.html mpp.html mpp_io.html coupler_main.html
#and move them in doc/  
#cvs ci README quickstart_guide.xml quickstart_guide.html MOM_practice.xml MOM_practice.html  time_manager.html field_manager.html diag_manager.html mpp.html mpp_io.html coupler_main.html
#mv README ../

#!/bin/tcsh -f
#=======================================================================
#      preprocessing : ocean_grid_generator
#         Contact : Zhi Liang   email : Zhi.Liang
#
#  This runscritp can be used to generate horizontal grid and/or vertical grid
#  and/or topography. It creates Makefile, compile if necessary and  saves output.
#  The generated data sets are grid_spec.nc (default value of namelist varible
#  output_file of grid_generator_nml) and are saved in the directory $work_dir.
#  When you want to generate topography (not idealized or special topography), a
#  topography source data file is needed, which is specified by the namelist
#  variable topog_file of topog_nml.
#  *******Important notice: You need to configure hgrid_nml, vgrid_nml, topog_nml
#  and grid_generator_nml, which are listed in this runscripts, to obtain desired grid.
#=======================================================================
#  This preprocessing program was tested with Intel Fortran compiler on ia64 at GFDL.
#  In order to run on other system, some changes may be needed.
#######################################################################
# Users need to modify the following variables according to their need. 
# These particular values are here for testing purposes in GFDL only.  
#######################################################################

  set echo
  set platform     = "ncrc.intel"                                    # A unique identifier for your platform
  set npes         = 1                                      # number of processors
#
# input data file and destination grid
#
  set type         = "tripolar"                             # type of grid "tripolar" or "simple"
#
  set root         = $cwd:h:h:h:h                       # The directory that contains src/ and bin/
#
# Users must ensure the following  files exist for their platform.
#
  source $root/bin/environs.$platform                   # environment variables and compiler options

  set mkmfTemplate = $root/bin/mkmf.template.$platform  # path to mkmf template 

  set topog_file   = $FMS_ARCHIVE/mom4/input_data/OCCAM_p5degree.nc

#############################################################################
# Users need not change anything below this line except the namelists values.
#############################################################################

  set name         = "ocean_grid"                           # name of the grid file will be generated
  set tooldir      = $cwd                                   # directory of the tool
  set sharedir     = $root/src/shared                       # directory of the shared code.
  set includedir   = $sharedir/include                          # fms include directory  
  set workdir      = $tooldir/workdir                       # where the tool is run and output is produced
  set executable   = $tooldir/exec/ocean_grid_generator.exe # executable created after compilation
  if ( $?DEBUG ) then
    set executable    = $tooldir/debug/ocean_grid_generator.exe 
    set mkmfTemplate  = $root/bin/mkmf.debugtemplate.$platform         
  endif
  set mkmf         = $root/bin/mkmf                         # path to executable mkmf
  set cppDefs      = ( "-Duse_netCDF -Duse_netCDF3 -Duse_libMPI" )        # list of cpp #defines to be passed to the source files

# list the source code
  
  set CORE         = "$tooldir/{grids_type.f90,grids_util.f90,ocean_grid_generator.f90}"
  set CORE         = "$CORE $tooldir/{hgrid.f90,vgrid.f90,topog.f90,check_mask.F90}"
  set UTILITIES    = "$sharedir/{axis_utils,constants,fms,mpp,horiz_interp,platform,memutils,mosaic}"
  set UTILITIES    = " $UTILITIES $sharedir/mpp/include $includedir " 
  set srclist      =  ( $CORE $UTILITIES )                       # list of the source code

# compile the code and create executable
  if( ! -d $executable:h ) mkdir $executable:h
  cd $executable:h
  $mkmf -t $mkmfTemplate -p $executable:t -c "$cppDefs" $srclist 

  make $executable:t

#--------------------------------------------------------------------------------------------------------
# setup directory structure
  if ( ! -d $workdir )         mkdir $workdir

  cd $workdir

# get executable  
  cp $executable $executable:t

# --- set up namelist
  if($type == "simple") then
    cat >input.nml <<EOF
     &ocean_grid_generator_nml
       grid_type   = 'hgrid_vgrid_topog'
       output_file = '$name.nc'  /    
    &hgrid_nml
       nxlons=2,x_lon=0.,360.,dx_lon=2.5,2.5,
       nylats=2,y_lat=-90.,90.,dy_lat=2.0,2.0,
       tripolar_grid=.false.,lat_join=65, 
       debug = .true. /
    &vgrid_nml
       nzdepths=3,z_depth=0.0,100.0,5600.0,dz_depth=25.0,25.0,975.0
       debug = .true. /
    &topog_nml
       topography = 'rectangular_basin' 
       topog_depend_on_vgrid = .TRUE.
       fill_first_row = .true.
       kmt_min=2,
       filter_topog=.false.,
       num_filter_pass=5,
       scale_factor=-1,
       interp_method = "conservative"
       debug = .true. /
    &fms_nml
       domains_stack_size = 105560 /

EOF

  else if($type == "tripolar") then
    cat >input.nml <<EOF
     &ocean_grid_generator_nml
       grid_type   = 'hgrid_vgrid_topog'
       output_file = '$name.nc'  /    
    &hgrid_nml
       nxlons=2,x_lon=-280.,80.,dx_lon=1.0,1.0,
       nylats=7,y_lat=-82.0,-30,-10.,0.,10.,30.0,90.
       dy_lat= 1.0,1.0,0.6666667,0.3333333,0.6666667,1.0,1.0,
       tripolar_grid=.true.,lat_join=65, 
       debug = .true. /
    &vgrid_nml
       nzdepths=3,z_depth=0.,220.,5500.,dz_depth=10.,10.,367.14286
       debug = .true. /
    &topog_nml
       topography = 'from_file' 
       topog_depend_on_vgrid = .TRUE.
       topog_file='$topog_file',
       topog_field='topo',
       lon_field = 'geolon_t'
       lat_field = 'geolat_t'
       fill_first_row = .true.
       num_nbrs = 4
       kmt_min=4,
       max_dist = 0.05,
       filter_topog=.false.,
       adjust_topo = .true.,
       num_filter_pass=5,
       scale_factor= -1,
       src_is_spherical = .true.
       interp_method = "bilinear"
       debug = .true. /
    &fms_nml
       domains_stack_size = 576000 /

EOF

  else
	echo Unknown grid type $type
	exit 1
  endif


#  run the executable
  $mpirunCommand $npes ./$executable:t >fms.out
  
  cat fms.out     

#---------------------------------------------------------------------
# rename the ascii output file
  mv fms.out $name.fms.out
  mv logfile*.out $name.logfile.out

  unset echo

#!/bin/tcsh 
#=======================================================================
#      regrid_2d : interp 2-D data
#         Contact : Zhi Liang   email : z1l
#
#  This runscritp can be remap runoff data from spherical grid onto any grid
#  ( spherical or tripolar ) using conservative scheme. The runscript will
#  run executable $create_grid to generate atmos_grid based on the $src_data.
#  Then generate exchange grid grid_spec.nc by running $make_xgrids.
#  $make_xgrids need file atmos_grid.nc and file $dst_grid as command line
#  input. Finally remap the runoff data onto $dst_grid and write out output
#  file by executing $runoff_regrid.
#
#  This preprocessing program was tested with Intel Fortran compiler on ia64 at GFDL.
#  In order to run on other system, some changes may be needed.
#######################################################################
# Users need to modify the following variables according to their need. 
# These particular values are here for testing purposes in GFDL only.  
#######################################################################

  set echo
  set platform      = "ncrc.intel"                                # A unique identifier for your platform

#  set ocean_only_dst_grid                  # comment this if the $dst_grid contains exchange grid information
                                            # uncomment this if the $dst_grid only contains ocean grid information.
			                    # $make_xgrids only accept ocean only grid as the -o option.
 
#
  set root         = $cwd:h:h:h                         # The directory that contains src/ and bin/
#
# Users must ensure the following  files exist for their platform.
#
  source $root/bin/environs.$platform                   # environment variables and compiler options

  set mkmfTemplate = $root/bin/mkmf.template.$platform  # path to mkmf template 
  set make_xgrids  = $root/bin/make_xgrids_$platform
# needed data set and field name of the runoff data
# NOTE: Users must change the following according to their need. These particular values are here for testing purposes only.
#
  set dst_grid      = $FMS_ARCHIVE/mom4/mom4p1/memphis/mom4_om1p5/preprocessing/om1p5_grid_spec.nc
  set src_data      = $FMS_ARCHIVE/mom4/mom4p1/omsk/om3_core1/INPUT/RUNOFF.nc
  set src_fld_name  = 'RUNOFF'

#############################################################################
# Users need not change anything below this line except the namelists values.
#############################################################################
  set name          = "runoff_regrid"                    # name of the data file will be generated
  set tooldir       = $cwd                               # directory of the tool
  set workdir       = $tooldir/workdir                   # where the tool is run and output is produced
  set create_grid   = $tooldir/exec/create_grid.exe      # executable created after compilation create_grid.F90
  set runoff_regrid = $tooldir/exec/runoff_regrid.exe    # executable created after compilation runoff_regrid.F90
  if ( $?DEBUG ) then
    set create_grid   = $tooldir/debug/debug_create_grid.exe 
    set runoff_regrid = $tooldir/debug/debug_runoff_regrid.exe 
    set mkmfTemplate  = $root/bin/mkmf.debugtemplate.$platform         
  endif
  set mkmf         = $root/bin/mkmf                         # path to executable mkmf
  set cppDefs      = ( "-Duse_netCDF -Duse_netCDF3 -Duse_libMPI" )                     # list of cpp #defines to be passed to the source files
 
# compile create_grid.F90 to create the executable.
  if( ! -d $create_grid:h ) mkdir $create_grid:h
  cd $create_grid:h
  $mkmf -t $mkmfTemplate -p $create_grid:t -c "$cppDefs"  $tooldir/create_grid.F90 /usr/local/include
  make $create_grid:t

# if make_xgrids does not exist, compare the source code
  if ( ! -f $make_xgrids ) then
     cc -O2 -o $make_xgrids $tooldir:h/generate_grids/make_xgrids/make_xgrids.c -L/usr/local/lib -lnetcdf -lm
  endif

# compile runoff_field.F90 to create the executable.
  if( ! -d $runoff_regrid:h ) mkdir $runoff_regrid:h
  cd $runoff_regrid:h
  $mkmf -t $mkmfTemplate -p $runoff_regrid:t -c "$cppDefs"  $tooldir/runoff_regrid.F90 /usr/local/include
  make $runoff_regrid:t

# compile runoff_regrid.F90 to create the executable.

#--------------------------------------------------------------------------------------------------------
# setup directory structure
  if ( ! -d $workdir )         mkdir $workdir

  cd $workdir

# get executable  
  cp $create_grid $create_grid:t
  cp $runoff_regrid $runoff_regrid:t
  cp $make_xgrids make_xgrids

# --- set up namelist

    cat >input.nml <<!
    &create_grid_nml
      src_data     = '$src_data',
      src_fld_name = '$src_fld_name'
      /
    &runoff_regrid_nml
      src_fld_name = '$src_fld_name',
      src_data     = '$src_data',
      dst_data     = '$name.nc'
       /
!

# first generate the atmosphere grid to be used to generate exchange grid

  if ( $?DEBUG ) then
     totalview $create_grid:t >fms.out
  else
     $create_grid:t >fms.out
  endif

  if ( $status != 0 ) then
    unset echo
    echo "ERROR: create_grid failed"
    exit 1
  endif

# then generate the exchange grid between dst_grid and the atmos_grid just generated
  if( $?ocean_only_dst_grid ) then
     make_xgrids -a atmos_grid.nc -l atmos_grid.nc -o $dst_grid >> fms.out
  else

# if $dst_grid contains exchange grid and atmos, land grid information, extract
# ocean grid from $dst_grid.
     ncea -x -v AREA_ATMxOCN,DI_ATMxOCN,DJ_ATMxOCN,I_ATM_ATMxOCN,J_ATM_ATMxOCN,I_OCN_ATMxOCN,J_OCN_ATMxOCN,AREA_ATMxLND,DI_ATMxLND,DJ_ATMxLND,I_ATM_ATMxLND,J_ATM_ATMxLND,I_LND_ATMxLND,J_LND_ATMxLND,AREA_LNDxOCN,DI_LNDxOCN,DJ_LNDxOCN,I_LND_LNDxOCN,J_LND_LNDxOCN,I_OCN_LNDxOCN,J_OCN_LNDxOCN,xba,yba,xta,yta,AREA_ATM,xbl,ybl,xtl,ytl,AREA_LND,AREA_LND_CELL,xto,yto,AREA_OCN $dst_grid $dst_grid:t
     make_xgrids -a atmos_grid.nc -l atmos_grid.nc -o $dst_grid:t >> fms.out
     rm -f $dst_grid:t
  endif

  if ( $status != 0 ) then
    unset echo
    echo "ERROR: make_xgrids failed"
    exit 1
  endif

# remove atm_grid.nc
  rm -f atmos_grid.nc

# Finally remap the runoff data onto destination grid
     $runoff_regrid:t >> fms.out

  if ( $status != 0 ) then
    unset echo
    echo "ERROR: runoff_regrid failed"
    exit 1
  endif

  cat fms.out

# remove the exchange grid
  rm -f grid_spec.nc
  
#---------------------------------------------------------------------
# rename the ascii output file
  mv fms.out $name.fms.out

  unset echo

#!/bin/csh
#contact: Zhi Liang (Zhi.Liang)
#PBS -N test_tools
#PBS -l nodes=1:ppn=6
#PBS -l walltime=3:00:00
#PBS -o $HOME/tools/tikal/tools/scripts
#PBS -j oe
#PBS -m abe
#PBS -r y
#PBS -q batch

#set echo
set release  = tikal
set platform = `perl -T -e "use Net::Domain(hostdomain); print hostdomain"`
if( $platform == "princeton.rdhpcs.noaa.gov" ) then
   set indir    = /archive/fms/tools/input
   set outdir   = /work/$USER/tools/test_$release
   set basedir  = $TMPDIR/tools
   module load mpich2/1.2.1p1
   alias aprun mpirun
else if( $platform == "ncrc.gov" ) then
   set indir    = /lustre/f1/pdata/fms/tools/input
   set outdir   = /lustre/f1/unswept/$USER/tools/test_$release
   set basedir  = /lustre/f1/$USER/work/tools/test_$release
   alias aprun aprun
endif

set npes = 4
set npes2 = 6

set dome_grid         = dome_grid
set bowl_grid         = bowl_grid
set channel_grid      = channel_grid
set torus_grid        = torus_grid
set gyre_grid         = gyre_grid
set coupled_grid      = coupled_grid
set coupled_nest_grid = coupled_nest_grid
set C48_to_N45        = C48_to_N45
set cmip5_regrid      = cmip5_regrid
set regrid_extrap     = regrid_extrap
set runoff_regrid     = runoff_regrid
set river_regrid      = river_regrid
set checkmask_baltic1 = checkmask_baltic1
set checkmask_MOM6    = checkmask_MOM6
set remap_land        = remap_land
set regional_regrid   = regional_regrid
set make_quick_mosaic = make_quick_mosaic
set mppncscatter      = mppncscatter
set transfer_mosaic   = transfer_to_mosaic_grid
set CM21_to_CM25      = CM2.1_to_CM2.5

module load fre-nctools/$release
module load nccmp

    
#***********************************************************************************
#
#    Test 1: ocean_grid for dome experiment
#
#**********************************************************************************
set workdir = $basedir/$dome_grid
set output  = $outdir/$dome_grid
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

#create hgrid
make_hgrid --grid_type regular_lonlat_grid --nxbnd 2 --nybnd 2 --xbnd 0,25 --ybnd 63,70 --dlon 0.5,0.5 --dlat 0.5,0.5 --grid_name ocean_hgrid 
if( $status != 0 ) then
   echo "ERROR: failed at make_hgrid for dome_grid"
   exit 1
endif

#create vgrid
make_vgrid --nbnds 3 --bnds 0.,220.,5500. --dbnds 10.,10.,367.14286 --center c_cell --grid_name ocean_vgrid 
if( $status != 0 ) then
   echo "ERROR: failed at make_vgrid for dome_grid"
   exit 1
endif

#create solo mosaic
make_solo_mosaic --num_tiles 1 --dir ./ --mosaic_name ocean_mosaic --tile_file ocean_hgrid.nc
if( $status != 0 ) then
   echo "ERROR: failed at make_solo_mosaic for dome_grid"
   exit 1
endif

#create topography data
make_topog --mosaic ocean_mosaic.nc --topog_type dome --dome_slope 0.01 --dome_embayment_south 69 --dome_embayment_west 19.25 --dome_embayment_east 21.25 --dome_bottom 5500
if( $status != 0 ) then
   echo "ERROR: failed at make_topog for dome_grid"
   exit 1
endif

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 1: ocean_grid for dome experiment                       *"
echo "*                                                                         *"
echo "***************************************************************************"

#copy data to the output directory
mv *.nc $output 

#***********************************************************************************
#
#    Test 2: ocean_grid for bowl experiment
#
#**********************************************************************************
set workdir = $basedir/$bowl_grid
set output  = $outdir/$bowl_grid
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

#create hgrid
make_hgrid --grid_type regular_lonlat_grid --nxbnd 2 --nybnd 2 --xbnd 0,20 --ybnd 60,72 --dlon 0.5,0.5 --dlat 0.5,0.5 --grid_name ocean_hgrid
if( $status != 0 ) then
   echo "ERROR: failed at make_hgrid for bowl_grid"
   exit 1
endif

#create vgrid
make_vgrid --nbnds 3 --bnds 0.,220.,5500. --dbnds 10.,10.,367.14286 --center c_cell --grid_name ocean_vgrid 
if( $status != 0 ) then
   echo "ERROR: failed at make_vgrid for bowl_grid"
   exit 1
endif

#create solo mosaic
make_solo_mosaic --num_tiles 1 --dir ./ --mosaic_name ocean_mosaic --tile_file ocean_hgrid.nc
if( $status != 0 ) then
   echo "ERROR: failed at make_solo_mosaic for bowl_grid"
   exit 1
endif

#create topography data
make_topog --mosaic ocean_mosaic.nc --topog_type bowl --bottom_depth 5500
if( $status != 0 ) then
   echo "ERROR: failed at make_topog for bowl_grid"
   exit 1
endif

#copy data to the output directory
mv *.nc $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 2: ocean_grid for bowl experiment                       *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 3: ocean_grid for box channel experiment  
#
#**********************************************************************************
set workdir = $basedir/$channel_grid
set output  = $outdir/$channel_grid
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

#create hgrid
make_hgrid --grid_type regular_lonlat_grid --nxbnd 2 --nybnd 2 --xbnd 0,10 --ybnd -40,-10 --dlon 0.5,0.5 --dlat 0.5,0.5 --grid_name ocean_hgrid
if( $status != 0 ) then
   echo "ERROR: failed at make_hgrid for channel_grid"
   exit 1
endif

#create vgrid
make_vgrid --nbnds 2 --bnds 0,1200 --dbnds 40,40 --grid_name ocean_vgrid 
if( $status != 0 ) then
   echo "ERROR: failed at make_vgrid for channel_grid"
   exit 1
endif

#create solo mosaic
make_solo_mosaic --num_tiles 1 --dir ./ --mosaic_name ocean_mosaic --tile_file ocean_hgrid.nc
if( $status != 0 ) then
   echo "ERROR: failed at make_solo_mosaic for channel_grid"
   exit 1
endif

#create topography data
make_topog --mosaic ocean_mosaic.nc --topog_type box_channel --jwest_south 5 --jwest_north 15 --jeast_south 30 --jeast_north 45 --bottom_depth 1200
if( $status != 0 ) then
   echo "ERROR: failed at make_topog for channel_grid"
   exit 1
endif

#copy data to the output directory
mv *.nc $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 3: ocean_grid for box channel experiment                *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 4: ocean_grid for torus experiment  
#
#**********************************************************************************
set workdir = $basedir/$torus_grid
set output  = $outdir/$torus_grid
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

#create hgrid
make_hgrid --grid_type regular_lonlat_grid --nxbnd 2 --nybnd 2 --xbnd 0,20 --ybnd 10,30 --dlon 1,1 --dlat 1,1 --grid_name ocean_hgrid
if( $status != 0 ) then
   echo "ERROR: failed at make_hgrid for torus_grid"
   exit 1
endif

#create vgrid
make_vgrid --nbnds 2 --bnds 0.,200 --dbnds 10,10 --grid_name ocean_vgrid 
if( $status != 0 ) then
   echo "ERROR: failed at make_vgrid for torus_grid"
   exit 1
endif

#create solo mosaic
make_solo_mosaic --num_tiles 1 --dir ./ --mosaic_name ocean_mosaic --tile_file ocean_hgrid.nc --periodx 20 --periody 20
if( $status != 0 ) then
   echo "ERROR: failed at make_solo_mosaic for torus_grid"
   exit 1
endif

#create topography data
make_topog --mosaic ocean_mosaic.nc --topog_type rectangular_basin --bottom_depth 200
if( $status != 0 ) then
   echo "ERROR: failed at make_topog for torus_grid"
   exit 1
endif

#copy data to the output directory
mv *.nc $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 4: ocean_grid for torus experiment                      *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 5: ocean_grid for gyre experiment   
#
#**********************************************************************************
set workdir = $basedir/$gyre_grid
set output  = $outdir/$gyre_grid
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

#create hgrid
make_hgrid --grid_type regular_lonlat_grid --nxbnd 2 --nybnd 2 --xbnd 0,10 --ybnd 15,35 --dlon 2,2 --dlat 2,2 --grid_name ocean_hgrid
if( $status != 0 ) then
   echo "ERROR: failed at make_hgrid for gyre_grid"
   exit 1
endif

#create vgrid
make_vgrid --nbnds 3 --bnds 0.,220.,5500. --dbnds 10.,10.,367.14286 --center c_cell --grid_name ocean_vgrid 
if( $status != 0 ) then
   echo "ERROR: failed at make_vgrid for gyre_grid"
   exit 1
endif

#create solo mosaic
make_solo_mosaic --num_tiles 1 --dir ./ --mosaic_name ocean_mosaic --tile_file ocean_hgrid.nc
if( $status != 0 ) then
   echo "ERROR: failed at make_solo_mosaic for gyre_grid"
   exit 1
endif

#create topography data
make_topog --mosaic ocean_mosaic.nc --topog_type rectangular_basin --bottom_depth 5500
if( $status != 0 ) then
   echo "ERROR: failed at make_topog for gyre_grid"
   exit 1
endif

#copy data to the output directory
mv *.nc $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 5: ocean_grid for gyre experiment                       *"
echo "*                                                                         *"
echo "***************************************************************************"


#***********************************************************************************
#
#    Test 6: grid for coupled model (land and atmosphere are C48 and ocean is 1 degree tripolar grid.
#
#**********************************************************************************
set workdir = $basedir/$coupled_grid
set output  = $outdir/$coupled_grid
set input   = $indir
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

#create ocean_hgrid 
make_hgrid --grid_type tripolar_grid --nxbnd 2 --nybnd 7 --xbnd -280,80 --ybnd -82,-30,-10,0,10,30,90 --dlon 1.0,1.0 --dlat 1.0,1.0,0.6666667,0.3333333,0.6666667,1.0,1.0 --grid_name ocean_hgrid --center c_cell
if( $status != 0 ) then
   echo "ERROR: failed at make_hgrid for coupled_grid ocean"
   exit 1
endif

#create ocean_vgrid
make_vgrid --nbnds 3 --bnds 0.,220.,5500. --dbnds 10.,10.,367.14286 --center c_cell --grid_name ocean_vgrid 
if( $status != 0 ) then
   echo "ERROR: failed at make_vgrid for coupled_grid ocean"
   exit 1
endif

#create ocean solo mosaic
make_solo_mosaic --num_tiles 1 --dir ./ --mosaic_name ocean_mosaic --tile_file ocean_hgrid.nc --periodx 360
if( $status != 0 ) then
   echo "ERROR: failed at make_solo_mosaic for coupled_grid ocean"
   exit 1
endif

#create ocean topography data
make_topog --mosaic ocean_mosaic.nc --topog_type realistic --topog_file $input/OCCAM_p5degree.nc --topog_field TOPO --scale_factor -1 --vgrid ocean_vgrid.nc --output topog.nc
if( $status != 0 ) then
   echo "ERROR: failed at make_topog for coupled_grid ocean"
   exit 1
endif

if( ! -d parallel ) mkdir parallel
cd parallel

aprun -n $npes make_topog_parallel --mosaic ../ocean_mosaic.nc --topog_type realistic --topog_file $input/OCCAM_p5degree.nc --topog_field TOPO --scale_factor -1 --vgrid ../ocean_vgrid.nc --output topog.nc
if( $status != 0 ) then
   echo "ERROR: failed at make_topog_parallel for coupled_grid ocean"
   exit 1
endif

nccmp -md topog.nc ../topog.nc
if( $status != 0 ) then
   echo "ERROR: make_topog did not reproduce from processor count for coupled_grid"
   exit 1
endif

cd ..

#Create C48 grid for atmos/land
make_hgrid --grid_type gnomonic_ed --nlon 96 --grid_name C48_grid
if( $status != 0 ) then
    echo "ERROR:  failed at make_hgrid for C48_grid"
    exit 1
endif
#create C48 solo mosaic for atmos/land
make_solo_mosaic --num_tiles 6 --dir ./ --mosaic C48_mosaic --tile_file C48_grid.tile1.nc,C48_grid.tile2.nc,C48_grid.tile3.nc,C48_grid.tile4.nc,C48_grid.tile5.nc,C48_grid.tile6.nc
if( $status != 0 ) then
    echo "ERROR: failed at make_solo_mosaic for C48_grid"
    exit 1
endif

#make the coupler_mosaic
make_coupler_mosaic --atmos_mosaic C48_mosaic.nc --ocean_mosaic ocean_mosaic.nc --ocean_topog  topog.nc --mosaic_name grid_spec --check --area_ratio_thresh 1.e-10 --check 
if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at make_coupler_mosaic for coupled_grid"
    exit 1
endif

#check reproducing ability between processor count for make_coupler_mosaic
cd parallel
aprun -n $npes make_coupler_mosaic_parallel --atmos_mosaic ../C48_mosaic.nc --ocean_mosaic ../ocean_mosaic.nc --ocean_topog  ../topog.nc --mosaic_name grid_spec  --area_ratio_thresh 1.e-10 
  
if( $status != 0 ) then
    echo "ERROR: failed at make_coupler_mosaic_parallel for coupled_grid"
    exit 1
endif
foreach file ( `ls -1 *.nc` )
   nccmp -md $file ../$file
   if( $status != 0 ) then
      echo "ERROR: make_coupler_mosaic could not reproduce for $file for different processor count"
      exit 1
   endif
endif

cd ..
#copy data to the output directory
mv *.nc $output 


echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 6: grid for coupled model                               *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 7: grid for coupled nest model (land are C48 and ocean is 1 degree tripolar grid, atmosphere is C48 with nested region
#
#**********************************************************************************
set workdir = $basedir/$coupled_nest_grid
set output  = $outdir/$coupled_nest_grid
set input   = $indir
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

#create ocean_hgrid 
make_hgrid --grid_type tripolar_grid --nxbnd 2 --nybnd 7 --xbnd -280,80 --ybnd -82,-30,-10,0,10,30,90 --dlon 1.0,1.0 --dlat 1.0,1.0,0.6666667,0.3333333,0.6666667,1.0,1.0 --grid_name ocean_hgrid --center c_cell
if( $status != 0 ) then
   echo "ERROR: failed at make_hgrid for coupled_nest_grid ocean"
   exit 1
endif

#create ocean_vgrid
make_vgrid --nbnds 3 --bnds 0.,220.,5500. --dbnds 10.,10.,367.14286 --center c_cell --grid_name ocean_vgrid 
if( $status != 0 ) then
   echo "ERROR: failed at make_vgrid for coupled_nest_grid ocean"
   exit 1
endif

#create ocean solo mosaic
make_solo_mosaic --num_tiles 1 --dir ./ --mosaic_name ocean_mosaic --tile_file ocean_hgrid.nc --periodx 360
if( $status != 0 ) then
   echo "ERROR: failed at make_solo_mosaic for coupled_nest_grid ocean"
   exit 1
endif

#create ocean topography data
make_topog --mosaic ocean_mosaic.nc --topog_type realistic --topog_file $input/OCCAM_p5degree.nc \
           --topog_field TOPO --scale_factor -1 --vgrid ocean_vgrid.nc --output topog.nc
if( $status != 0 ) then
   echo "ERROR: failed at make_topog for coupled_nest_grid ocean"
   exit 1
endif

#Create C48 grid with atmos nested grid.
make_hgrid --grid_type gnomonic_ed --nlon 96 --grid_name atmos_grid --do_schmidt \
           --target_lat 48.15 --target_lon -100.15 --halo 3 --stretch_factor 3 \
	   --great_circle_algorithm --nest_grid --refine_ratio 3 --parent_tile 4 \
	   --istart_nest 21 --iend_nest 60 --jstart_nest 11 --jend 70
if( $status != 0 ) then
    echo "ERROR:  failed at make_hgrid for nested atmos_grid"
    exit 1
endif
#create C48 solo mosaic for atmos
make_solo_mosaic --num_tiles 7 --dir ./ --mosaic atmos_mosaic --tile_file atmos_grid.tile1.nc,atmos_grid.tile2.nc,atmos_grid.tile3.nc,atmos_grid.tile4.nc,atmos_grid.tile5.nc,atmos_grid.tile6.nc,atmos_grid.tile7.nc
if( $status != 0 ) then
    echo "ERROR: failed at make_solo_mosaic for nested atmosphere grid"
    exit 1
endif

#Create C144 grid for land
make_hgrid --grid_type gnomonic_ed --nlon 288 --grid_name land_grid --do_schmidt \
           --target_lat 48.15 --target_lon -100.15 --halo 3 --stretch_factor 3   \
	   --great_circle_algorithm --nest_grid --refine_ratio 3 --parent_tile 0
if( $status != 0 ) then
    echo "ERROR:  failed at make_hgrid for nested C48_grid"
    exit 1
endif
#create C144 solo mosaic for land
make_solo_mosaic --num_tiles 6 --dir ./ --mosaic land_mosaic \
  --tile_file land_grid.tile1.nc,land_grid.tile2.nc,land_grid.tile3.nc,land_grid.tile4.nc,land_grid.tile5.nc,land_grid.tile6.nc

if( $status != 0 ) then
    echo "ERROR: failed at make_solo_mosaic for land"
    exit 1
endif

#make the coupler_mosaic
aprun -n $npes2 make_coupler_mosaic_parallel --atmos_mosaic atmos_mosaic.nc --land_mosaic land_mosaic.nc \
          --ocean_mosaic ocean_mosaic.nc --ocean_topog  topog.nc --interp_order 1 --mosaic_name grid_spec --check
if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at make_coupler_mosaic for coupled_nest_grid"
    exit 1
endif

#check reproducing ability between processor count for make_coupler_mosaic
if( ! -d parallel ) mkdir parallel
cd parallel
aprun -n $npes make_coupler_mosaic_parallel --atmos_mosaic ../atmos_mosaic.nc --land_mosaic ../land_mosaic.nc \
         --ocean_mosaic ../ocean_mosaic.nc --ocean_topog  ../topog.nc --interp_order 1 --mosaic_name grid_spec

if( $status != 0 ) then
    echo "ERROR: failed at make_coupler_mosaic on 10 pe for coupled_nest_grid"
    exit 1
endif
foreach file ( `ls -1 *.nc` )
   nccmp -md $file ../$file
   if( $status != 0 ) then
      echo "ERROR: make_coupler_mosaic could not reproduce for $file from processor count for nested grid"
      exit 1
   endif
endif

cd ..

#copy data to the output directory
mv *.nc $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 7: grid for coupled model with nested grid              *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 8: remap data from C48 to regular lat-lon grid
#
#**********************************************************************************
set workdir = $basedir/$C48_to_N45
set output  = $outdir/$C48_to_N45
set input   = $indir/$C48_to_N45
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

fregrid --input_mosaic $input/C48_mosaic.nc --input_dir $input --input_file 19800101.atmos_daily \
        --scalar_field zsurf,temp,t_surf --nlon 144 --nlat 90 --interp_method conserve_order2 \
	--output_file 19800101.atmos_daily.nc --check_conserve --remap_file C48_to_N45_remap.nc

if( $status != 0 ) then
    unset echo
    echo "ERROR: run failed for fregrid from C48 to N45 using conservative_order2"
    exit 1
endif

if( ! -d parallel ) mkdir parallel
cd parallel

#running on multiple processors
aprun -n $npes fregrid_parallel --input_mosaic $input/C48_mosaic.nc --input_dir $input --input_file 19800101.atmos_daily \
                                --scalar_field zsurf,temp,t_surf --nlon 144 --nlat 90 --interp_method conserve_order2    \
				--output_file 19800101.atmos_daily.nc --check_conserve

if( $status != 0 ) then
    unset echo
    echo "ERROR: failed for fregrid from C48 to N45 using conservative_order2 on $npes pe"
    exit 1
endif

nccmp -md 19800101.atmos_daily.nc ../19800101.atmos_daily.nc
if( $status != 0 ) then
    unset echo
    echo "ERROR: fregrid could not reproduce between 1 and $npes processors"
    exit 1
endif

#test reading from remap file
aprun -n $npes fregrid_parallel --input_mosaic $input/C48_mosaic.nc --input_dir $input --input_file 19800101.atmos_daily \
                                --scalar_field zsurf,temp,t_surf --nlon 144 --nlat 90 --interp_method conserve_order2 \
				--output_file 19800101.atmos_daily.read.nc --check_conserve --remap_file ../C48_to_N45_remap.nc

if( $status != 0 ) then
    unset echo
    echo "ERROR: failed for fregrid from C48 to N45 using conservative_order2 on $npes pe and read remap file"
    exit 1
endif

nccmp -md 19800101.atmos_daily.read.nc ../19800101.atmos_daily.nc
if( $status != 0 ) then
    unset echo
    echo "ERROR: fregrid could not reproduce when reading from remap file"
    exit 1
endif

cd ..
#copy data to the output directory
mv *.nc $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 8: remap data from C48 to lat-lon                       *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 9: remap cmip5 ocean data onto regular lat-lon grid (use GFDL-CM3 data as example)
#
#**********************************************************************************
set workdir = $basedir/$cmip5_regrid
set output  = $outdir/$cmip5_regrid
set input   = $indir/$cmip5_regrid
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

# create GFDL-CM3_grid.nc
make_hgrid --grid_type from_file --my_grid_file $input/GFDL-CM3_sic_OImon.nc --grid_name GFDL-CM3_grid
if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at make_hgrid for GFDL-CM3 cmip5 ocean data"
    exit 1
endif

#. create GFDL-CM3_mosaic.nc
make_solo_mosaic --num_tiles 1 --dir ./ --mosaic_name GFDL-CM3_mosaic --tile_file GFDL-CM3_grid.nc
if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at make_solo_mosaic for GFDL-CM3 cmip5 ocean data"
    exit 1
endif

#. create remap file 
fregrid --input_mosaic GFDL-CM3_mosaic.nc --nlon 180 --nlat 90 --remap_file remap_file.GFDL-CM3.nc
if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at creating remap_file for GFDL-CM3 cmip5 ocean data"
    exit 1
endif

#. remap data
fregrid --input_mosaic GFDL-CM3_mosaic.nc --nlon 180 --nlat 90 --remap_file remap_file.GFDL-CM3.nc --input_dir $input \
        --input_file GFDL-CM3_sic_OImon.nc --output_file GFDL-sic_OImon.out.nc --scalar_field sic --check_conserve
if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at regrid for GFDL-CM3 cmip5 ocean data"
    exit 1
endif

#Create MPI-ESM-LR_grid.nc
make_hgrid --grid_type from_file --my_grid_file $input/MIROC-ESM_sic_OImon.nc --grid_name MIROC-ESM_grid
if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at make_hgrid for MIROC-ESM  cmip5 ocean data"
    exit 1
endif


#create MPI-ESM-LR_mosaic.nc
make_solo_mosaic --num_tiles 1 --dir ./ --mosaic_name MIROC-ESM_mosaic --tile_file MIROC-ESM_grid.nc
if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at make_solo_mosaic for MIROC-ESM cmip5 ocean data"
    exit 1
endif

#create remap file
fregrid --input_mosaic MIROC-ESM_mosaic.nc --nlon 180 --nlat 90 --remap_file remap_file.MIROC-ESM.nc
if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at make_solo_mosaic for MIROC-ESM cmip5 ocean data"
    exit 1
endif

#remap data
fregrid --input_mosaic MIROC-ESM_mosaic.nc --nlon 180 --nlat 90 --remap_file remap_file.MIROC-ESM.nc --input_dir $input \
        --input_file MIROC-ESM_sic_OImon.nc --output_file MIROC-ESM-sic_OImon.out.nc --scalar_field sic --check_conserve
if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at make_solo_mosaic for MIROC-ESM cmip5 ocean data"
    exit 1
endif

#copy data to the output directory
mv *.nc $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 9: remap cmip5 ocean data                               *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 10: remap data onto cm2m ocean grid with extrapolation and vertical interpolation.
#
#**********************************************************************************
set workdir = $basedir/$regrid_extrap
set output  = $outdir/$regrid_extrap
set input   = $indir/$regrid_extrap
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

make_hgrid --grid_type regular_lonlat_grid --nxbnd 2 --nybnd 2 --xbnd 0,360 --ybnd -90,90 --nlon 720 --nlat 360 --grid_name levitus_grid
if( $status != 0 ) then
    echo "ERROR: failed at make_hgrid for levitus grid"
    exit 1 
endif 
make_solo_mosaic --num_tiles 1 --dir . --mosaic_name levitus_mosaic --tile_file levitus_grid.nc --periodx 360
if( $status != 0 ) then
    echo "ERROR: failed at make_solo_mosaic for levitus grid"
    exit 1 
endif 

fregrid --input_mosaic levitus_mosaic.nc --input_dir $input --input_file WOA09_ann_theta.nc \
        --scalar_field POTENTIAL_TEMP --output_file WOA09_ann_theta_cm2g_extrap.nc --output_mosaic \
	 $input/ocean_mosaic.nc --extrapolate --dst_vgrid $input/ocean_vgrid.nc --check_conserve
if( $status != 0 ) then
    echo "ERROR: failed at regrid data onto cm2m ocean grid with extrapolation and vertical interpolation."
    exit 1 
endif 

#copy data to the output directory
mv *.nc $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 10: remap data onto cm2m grid with                      *"
echo "*   extrpolation and vertical interpolation                               *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 11: remap runoff data from regular lat-lon grid onto cm2m grid
#
#**********************************************************************************
set workdir = $basedir/$runoff_regrid
set output  = $outdir/$runoff_regrid
set input   = $indir/$runoff_regrid
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

runoff_regrid --input_file $input/runoff.daitren.iaf.nc --input_fld_name runoff --output_mosaic $input/ocean_mosaic.nc \
              --output_topog $input/topog.nc --output_file runoff.cm2m.nc
if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at runoff_regrid from lat-lon grid onto cm2m ocean grid"
    exit 1
endif

#copy data to the output directory
mv *.nc $output

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 11: remap runoff data onto cm2m grid                    *"
echo "*                                                                         *"
echo "***************************************************************************"


#***********************************************************************************
#
#    Test 12: river_regrid: remap data from lat-lon onto C48 grid.
#
#**********************************************************************************
set workdir = $basedir/$river_regrid
set output  = $outdir/$river_regrid
set input   = $indir/$river_regrid
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

river_regrid --mosaic $input/grid_spec.nc --river_src $input/z1l_river_output_M45_tripolar_aug24.nc \
             --output river_data_C48 --land_thresh 0.000001
if( $status != 0 ) then 
    unset echo 
    echo "ERROR: failed for river_regrid to regrid river data onto C48 mosaic grid."
    exit 1 
endif

#copy data to the output directory
mv *.nc $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 12: remap river_regrid onto C48 grid                    *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 13: check_mask: create mask_table to mask out some all-land domain
#                         to save processor usage
# 
#             for a sea-ice model, baltic1 experiment
#**********************************************************************************
set workdir = $basedir/$checkmask_baltic1
set output  = $outdir/$checkmask_baltic1
set input   = $indir/$checkmask_baltic1
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

check_mask --grid_file $input/baltic1_grid_spec.nc --min_pe 60 --max_pe 80 

if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at check_mask for baltic1 experiment"
    exit 1
endif

#copy data to the output directory
mv mask_table* $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 13:  check_mask for baltic1 experiment                  *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 14: check_mask: create mask_table to mask out some all-land domain
#                         to save processor usage
# 
#             for a coupled model with cm2m grid.
#**********************************************************************************
set workdir = $basedir/$checkmask_MOM6
set output  = $outdir/$checkmask_MOM6
set input   = $indir/$checkmask_MOM6
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

check_mask --grid_file $input/ocean_mosaic.nc --ocean_topog $input/topog.nc --layout 45,72
if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at check_mask for a coupled model grid"
    exit 1
endif

mv mask_table* $output

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 14: check_mask for MOM6 grid                            *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 15: remap_land: remap land restart file.
#
#**********************************************************************************
set workdir = $basedir/$remap_land
set output  = $outdir/$remap_land
set input   = $indir/$remap_land
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

# Create remapping file and remap land.res file.
remap_land --file_type land --src_mosaic $input/C48_mosaic/C48_mosaic.nc \
           --dst_mosaic $input/C192_mosaic/C192_mosaic.nc                \
	   --src_restart $input/src_restart/land.res  \
	   --dst_restart land.res    \
	   --dst_cold_restart $input/dst_cold_restart/land.res  \
	   --remap_file remap_file_C48_to_C192 --print_memory

if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at remap_land for land"
    exit 1
endif


# Remap soil, snow, cana, glac, lake, vegn1, vegn2
foreach type ( soil snow cana glac lake vegn1 vegn2 )
 if( $type == "vegn1" || $type == "vegn2" ) then
   set filetype = vegn
 else
   set filetype = $type
 endif
 remap_land --file_type $filetype --src_mosaic $input/C48_mosaic/C48_mosaic.nc \
            --dst_mosaic $input/C192_mosaic/C192_mosaic.nc \
	    --src_restart $input/src_restart/$type.res \
	    --dst_restart $type.res  \
	    --dst_cold_restart $input/dst_cold_restart/$type.res \
	    --land_src_restart $input/src_restart/land.res \
	    --land_cold_restart $input/dst_cold_restart/land.res \
	    --remap_file remap_file_C48_to_C192 --print_memory
   if( $status != 0 ) then
      unset echo
      echo "ERROR: failed at remap_land for $type"
      exit 1
   endif
end

#Remap static_vegn will added in the future.
if( ! -d parallel ) mkdir parallel
cd parallel
aprun -n $npes remap_land_parallel --file_type land --src_mosaic $input/C48_mosaic/C48_mosaic.nc \
                                   --dst_mosaic $input/C192_mosaic/C192_mosaic.nc \
				   --src_restart $input/src_restart/land.res \
				   --dst_restart land.res \
				   --dst_cold_restart $input/dst_cold_restart/land.res \
				   --remap_file remap_file_C48_to_C192 --print_memory

if( $status != 0 ) then
    unset echo
    echo "ERROR: failed at remap_land_parallel for land"
    exit 1
endif

foreach file (`ls -1 *.nc`)
   nccmp -md $file ../$file
   if( $status != 0 ) then
      echo "ERROR: remap_land could not reproduce  between processor count for $file"
      exit 1
   endif
end
cd ..

#copy data to the output directory
mv *.nc $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 15: remap land restart from C48 to C192                 *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 16: make_regional_mosaic: create mosaic file for regional output and do remapping
#             for regional output.
#
#**********************************************************************************
set workdir = $basedir/$regional_regrid
set output  = $outdir/$regional_regrid
set input   = $indir/$regional_regrid
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

#Create tile grids for four regions.
make_regional_mosaic --global_mosaic $input/C192-rot-120.-0.-r1_mosaic.nc --regional_file $input/rregionatmos_4xdaily_eq_avg.tile2.nc
make_regional_mosaic --global_mosaic $input/C192-rot-120.-0.-r1_mosaic.nc --regional_file $input/rregionatmos_4xdaily_eq_avg.tile3.nc
make_regional_mosaic --global_mosaic $input/C192-rot-120.-0.-r1_mosaic.nc --regional_file $input/rregionatmos_4xdaily_eq_avg.tile5.nc
make_regional_mosaic --global_mosaic $input/C192-rot-120.-0.-r1_mosaic.nc --regional_file $input/rregionatmos_4xdaily_eq_avg.tile6.nc

#Create regional mosaic
make_solo_mosaic --num_tiles 4 --dir ./ --mosaic regional_mosaic --tile_file regional_grid.tile2.nc,regional_grid.tile3.nc,regional_grid.tile5.nc,regional_grid.tile6.nc

#Create regular lat-lon grid (100:160, -15:15, size is 360x180)
make_hgrid --grid_type regular_lonlat_grid --nxbnd 2 --nybnd 2 --xbnd 0,360 --ybnd -2,2 --nlon 720 --nlat 10 --grid_name latlon_grid

#Create lat-lon mosaic
make_solo_mosaic --num_tiles 1 --dir ./ --mosaic_name latlon_mosaic --tile_file latlon_grid.nc

#Remap data
fregrid --input_mosaic regional_mosaic.nc --output_mosaic latlon_mosaic.nc --input_dir $input \
        --input_file rregionatmos_4xdaily_eq_avg --output_file atmos_4xdaily_latlon.nc --scalar_field ps --check_conserve


#copy data to the output directory
mv *.nc $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 16: using fregrid for regional output                   *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 17: mppncscatter first use mppncscatter to split the file
#             and then use mppnccombine to combine the file. The output should reproduce
#             original file
#
#**********************************************************************************
set workdir = $basedir/$mppncscatter
set output  = $outdir/$mppncscatter
set input   = $indir/$mppncscatter
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

foreach tile ( 1 2 3 4 5 6 )
   set file = fv_core.res.tile$tile.nc
   mppncscatter -i 2 -j 3 -x 2 -y 12  $input/$file
   mppnccombine -64 $file $file.???? 
   nccmp -md $file $input/$file
end

set file = ocean_temp_salt.res.nc
mppncscatter  -i 7 -j 7 -x 21 -y 14  $input/$file
mppnccombine -64 $file $file.???? 
nccmp -md $file $input/$file

set file = ice_model.res.nc
mppncscatter  -i 7 -j 7 -x 21 -y 14  $input/$file
mppnccombine -64 $file $file.???? 
nccmp -md $file $input/$file

#copy data to the output directory
mv *.nc $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 17: mppncscatter                                        *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 18: make_quick_mosaic
#
#***********************************************************************************
set workdir = $basedir/$make_quick_mosaic
set output  = $outdir/$make_quick_mosaic
set input   = $indir/$make_quick_mosaic
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

make_quick_mosaic --input_mosaic $input/ocean_mosaic.nc --ocean_topog $input/ocean_topog.nc

#copy data to the output directory
mv *.nc $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 18: make_quick_mosaic                                   *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 19: transfer to mosaic
#
#**********************************************************************************
set workdir = $basedir/$transfer_mosaic
set output  = $outdir/$transfer_mosaic
set input   = $indir/$transfer_mosaic
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

transfer_to_mosaic_grid --input_file  $input/grid_spec_v7_transfer.nc

#copy data to the output directory
mv *.nc $output 

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 19: transfer_to_mosaic_grid                             *"
echo "*                                                                         *"
echo "***************************************************************************"

#***********************************************************************************
#
#    Test 20: remap ocean restart file from CM2.1 to CM2.5
#
#**********************************************************************************
set workdir = $basedir/$CM21_to_CM25
set output  = $outdir/$CM21_to_CM25
set input   = $indir/$CM21_to_CM25
if( ! -d $workdir ) mkdir -p $workdir
if( ! -d $output  ) mkdir -p $output
cd $workdir

#Create a OM3-like regular lat-lon grid.
make_hgrid --grid_type regular_lonlat_grid --nxbnd 2 --nybnd 7 --xbnd -280,80 --ybnd -82,-30,-10,0,10,30,90 \
           --dlon 1.0,1.0 --dlat 1.0,1.0,0.6666667,0.3333333,0.6666667,1.0,1.0 --grid_name latlon_grid --center c_cell

#Create the lat-lon solo mosaic
make_solo_mosaic --num_tiles 1 --dir ./ --mosaic_name latlon_mosaic --tile_file latlon_grid.nc --periodx 360

#Remap data from CM2.1 ocean grid onto regular lat-lon grid.
aprun -n $npes fregrid_parallel --input_mosaic $input/CM2.1_mosaic.nc --input_dir $input \
                                --input_file ocean_temp_salt.res.nc --scalar_field temp,salt \
				--output_file ocean_temp_salt.res.latlon.nc --output_mosaic latlon_mosaic.nc --check_conserve

#Remap data from regular lat-lon grid onto CM2.5 ocean grid with extrapolation.
aprun -n $npes fregrid_parallel --input_mosaic latlon_mosaic.nc --input_dir ./ \
                                --input_file ocean_temp_salt.res.latlon.nc --scalar_field temp,salt \
				--output_file ocean_temp_salt.res.CM2.5.nc --output_mosaic $input/CM2.5_mosaic.nc --extrapolate  --check_conserve

#copy data to the output directory
mv *.nc $output

echo "***************************************************************************"
echo "*                                                                         *"
echo "*   complete Test 20: remap restart file from CM2.1 grid to CM2.5 grid    *"
echo "*                                                                         *"
echo "***************************************************************************"

#!/bin/tcsh 
#=======================================================================
#      preprocessing : atmos_grid_generator
#         Contact : Zhi Liang   email : Zhi.Liang
#
#  This runscritp can be used to generate bgrid or spectral horizontal grid
#  for atmosphere model or land model. It creates Makefile, compile if necessary
#  and saves output. The generated data sets are atmos_grid.nc (default value of
#  namelist varible output_file of atmos_grid_generator_nml) and are saved in
#  the directory $output_dir/data. The standard output is stored at
#  $output_dir/ascii/.
#=======================================================================
#  This preprocessing program was tested with Intel Fortran compiler on ia64 at GFDL.
#  In order to run on other system, some changes may be needed.
#######################################################################
# Users need to modify the following variables according to their need. 
# These particular values are here for testing purposes in GFDL only.  
#######################################################################

  set echo
#  set platform     = "ncrc.intel"                       # A unique identifier for your platform
if ( `hostname` =~ login0? ) then
  set platform      = pik-iplex-ifort11
endif
if ( `hostname` =~ viss0? ) then
  set platform      = pik-vis-ifort11
endif
#
  set root         = $cwd:h:h:h:h                       # The directory that contains src/ and bin/
  set npes         = 1
#
# Users must ensure the following  files exist for their platform.
#
  source $root/bin/environs.$platform                   # environment variables and compiler options

  set mkmfTemplate = $root/bin/mkmf.template.$platform  # path to mkmf template 

#############################################################################
# Users need not change anything below this line except the namelists values.
#############################################################################
  set name         = "atmos_grid"                           # name of the grid file will be generated
  set tooldir      = $cwd                                   # directory of the tool
  set sharedir     = $root/src/shared                       # directory of the shared code.
  set includedir   = $sharedir/include                      # fms include directory  
  set atmtool      = $root/src/atmos_spectral/tools         # directory contains atmos_spectral tool code.
  set workdir      = $tooldir/workdir                       # where the tool is run and output is produced
  set executable   = $tooldir/exec/atmos_grid_generator.exe # executable created after compilation
  if ( $?DEBUG ) then
    set executable    = $tooldir/debug/atmos_grid_generator.exe 
    set mkmfTemplate  = $root/bin/mkmf.debugtemplate.$platform         
  endif
  set mkmf         = $root/bin/mkmf                         # path to executable mkmf
  set cppDefs      = ( "-Duse_netCDF -Duse_netCDF3 -DOVERLOAD_C8 -Duse_libMPI -DOVERLOAD_C4 -DOVERLOAD_R4")        # list of cpp #defines to be passed to the source files

# list the source code
  set CORE         = " $tooldir/{atmos_grid.f90,atmos_grid_generator.f90} "
  set CORE         = " $CORE $atmtool"
  set UTILITIES    = "$root/src/shared/{axis_utils,constants,fms,mpp,fft,platform,memutils,mosaic}"
  set UTILITIES    = " $UTILITIES $sharedir/mpp/include $includedir "
  set srclist      =  ( $CORE $UTILITIES )

   
# compile the model code and create executable
  if( ! -d $executable:h ) mkdir $executable:h
  cd $executable:h
  $mkmf -t $mkmfTemplate -p $executable:t -c "$cppDefs" $srclist 

  make $executable:t

#--------------------------------------------------------------------------------------------------------
# setup directory structure
  if ( ! -d $workdir )         mkdir $workdir

  cd $workdir

# get executable  
  cp $executable $executable:t

# --- set up namelist
    cat >input.nml <<!
     &atmos_grid_generator_nml
       output_file = '$name.nc'  /    
    &atmos_grid_nml
       grid_type = 'bgrid'
       num_lon=144, num_lat=90   /
!

#  run the executable
  $mpirunCommand $npes ./$executable:t >fms.out
  cat fms.out
       
#---------------------------------------------------------------------
# rename the ascii output file
  mv fms.out $name.fms.out
  mv logfile*.out $name.logfile.out

  unset echo

# Build the atmos_BG library

set srcList = ( atmos_bgrid/tools atmos_bgrid/model atmos_bgrid/driver/coupled atmos_coupled )

set lib_name = "lib_atmos_bg"

mkdir -p $executable:h:h/$lib_name
cd $executable:h:h/$lib_name
$mkmf_lib -p $lib_name.a -c "$cppDefs" -o "-I$executable:h:h/lib_FMS -I$executable:h:h/lib_atmos_phys" $srcList $lib_include_dirs
make

if( $status ) then
    echo "Make failed to create $lib_name.a"
    exit 1
endif

# Build the Ocean library

set srcList = ( mom5/ocean_core mom5/ocean_diag mom5/ocean_wave mom5/ocean_blobs mom5/ocean_param/neutral mom5/ocean_param/sources mom5/ocean_param/lateral mom5/ocean_param/vertical mom5/ocean_param/gotm-4.0/include mom5/ocean_param/gotm-4.0/turbulence mom5/ocean_param/gotm-4.0/util mom5/ocean_tracers )

set lib_name = "lib_ocean"

if( $type == ACCESS-OM || $type == ACCESS-CM || $type == ACCESS-OM-BGC || $type == ACCESS-ESM) then
    set srcList = ( $srcList mom5/ocean_access )
    if( $type ==  ACCESS-OM-BGC || $type == ACCESS-ESM) then
        set srcList = ( $srcList mom5/ocean_csiro_bgc )
    endif
    mkdir -p $executable:h:h/$type/$lib_name
    cd $executable:h:h/$type/$lib_name
else
    set srcList = ( $srcList mom5/ocean_bgc ocean_shared/generic_tracers )
    mkdir -p $executable:h:h/$lib_name
    cd $executable:h:h/$lib_name
endif

$mkmf_lib -p $lib_name.a -c "$cppDefs" -o "$includes" $srcList $lib_include_dirs
make

if( $status ) then
    echo "Make failed to create $lib_name.a"
    exit 1
endif

#!/bin/tcsh 
#=======================================================================
#      regrid : interp 2-D/3-D logical rectangular grid to logical rectangular grid.
#         Contact : Zhi Liang   email : z1l
#
#  This runscritp can be used to regrid data $src_data on any grid $src_grid to logically
#  rectangular grid described by grid descriptor file $dst_grid. 
#
#  This preprocessing program was tested with Intel Fortran compiler on ia64 at GFDL.
#  In order to run on other system, some changes may be needed.
#######################################################################
# Users need to modify the following variables according to their need. 
# These particular values are here for testing purposes in GFDL only.  
#######################################################################

  set echo
  set platform     = "ncrc.intel"      # A unique identifier for your platform
  set npes         = 1        # number of processors
#
  set root         = $cwd:h:h:h                         # The directory that contains src/ and bin/
#
# Users must ensure the following  files exist for their platform.
#
  source $root/bin/environs.$platform                   # environment variables and compiler options

  set mkmfTemplate = $root/bin/mkmf.template.$platform  # path to mkmf template 
#
# input data file and destination grid
#
  set src_data     = $FMS_ARCHIVE/mom4/mom4p1/riga/preprocess_tools/ocean.000101-000512.uv.nc
  set src_grid     = $FMS_ARCHIVE/mom4/mom4p1/riga/preprocess_tools/grid_spec_v5.nc
  set dst_grid     = $FMS_ARCHIVE/mom4/mom4p1/riga/preprocess_tools/grid_spec_v7.nc

#############################################################################
# Users need not change anything below this line except the namelists values.
#############################################################################

  set name         = "regrid"                               # name of the data file will be generated
  set tooldir      = $cwd                                   # directory of the tool
  set sharedir     = $root/src/shared                       # directory of the shared code.
  set includedir   = $sharedir/include
  set workdir      = $tooldir/workdir                       # where the tool is run and output is produced
  set executable   = $tooldir/exec/regrid.exe               # executable created after compilation
  if ( $?DEBUG ) then
    set executable    = $tooldir/debug/regrid.exe 
    set mkmfTemplate  = $root/bin/mkmf.debugtemplate.$platform         
  endif
  set mkmf         = $root/bin/mkmf                         # path to executable mkmf
  set cppDefs      = ( "-Duse_netCDF -Duse_netCDF3 -Duse_libMPI" )        # list of cpp #defines to be passed to the source files

# list the source code
  set CORE      = "$tooldir/{regrid.F90}"
  set UTILITIES = "$sharedir/{axis_utils,constants,fms,mpp,horiz_interp,platform,memutils,mosaic}"
  set UTILITIES    = " $UTILITIES $sharedir/mpp/include $includedir " 
  set srclist   = ( $CORE $UTILITIES )


# compile the code and create executable
  if( ! -d $executable:h ) mkdir $executable:h
  cd $executable:h
  $mkmf -t $mkmfTemplate -p $executable:t -c "$cppDefs" $srclist /usr/local/include 

  make $executable:t

  if($status != 0) then
     unset echo
     echo " Error in compilation "
     exit 1
  endif

#--------------------------------------------------------------------------------------------------------
# setup directory structure
  if ( ! -d $workdir )         mkdir $workdir

  cd $workdir
# get executable  
  cp $executable $executable:t

# --- set up namelist

   cat >input.nml <<!
   &regrid_nml
      src_data = '$src_data',
      src_grid = '$src_grid',
      dst_grid = '$dst_grid',
      dst_data = '$name.nc',
      num_flds = 2
      fld_name = 'u','v'
      fld_pos  =  'C','C'
      vector_fld = .true., .true.
      use_source_vertical_grid = .false.
      apply_mask = .true.
      debug      = .false. /
!

#  run the executable
  $mpirunCommand $npes ./$executable:t >fms.out
  
  cat fms.out
       
#---------------------------------------------------------------------
# rename the ascii output file
  mv fms.out $name.fms.out
  mv logfile*.out $name.logfile.out

  unset echo

# Build the version component library

set srcList = ( version )

set lib_name = "lib_version"

# Set up the version string

# The version string is the git hash of the commit used to build the code.
# The version of an executable can be found with the following command:
# strings <executable> | grep 'MOM_COMMIT_HASH='
setenv GIT_CONFIG_NOGLOBAL 'yes'

set old_hash=`grep 'public :: MOM_COMMIT_HASH' ../src/version/version.F90 | cut -d '"' -f 2 | cut -d '=' -f 2`
set new_hash=`git rev-parse HEAD`

if ( $old_hash != $new_hash ) then
    sed -e "s/{MOM_COMMIT_HASH}/$new_hash/g" $code_dir/version/version.F90.template > $code_dir/version/version.F90
endif

set curdir=$PWD
mkdir -p $executable:h:h/$lib_name
cd $executable:h:h/$lib_name
$mkmf_lib -p $lib_name.a -c "$cppDefs" $srcList
make

if( $status ) then
    echo "Make failed to create $lib_name.a"
    exit 1
endif

cd $curdir

#!/bin/csh -f
# Minimal runscript for MOM experiments

set type          = MOM_solo       # type of the experiment
set name          = box1
set platform      = gfortran     # A unique identifier for your platform
set npes          = 8            # number of processor
                                 # Note: If you change npes you may need to change
                                 # the layout in the corresponding namelist
set valid_npes = 0
set help = 0
set download = 0
set debug = 0
set valgrind = 0
set argv = (`getopt -u -o h -l type: -l platform: -l npes: -l experiment: -l debug -l valgrind -l help -l download_input_data --  $*`)
while ("$argv[1]" != "--")
    switch ($argv[1])
        case --type:
                set type = $argv[2]; shift argv; breaksw
        case --platform:
                set platform = $argv[2]; shift argv; breaksw
        case --npes:
                set npes = $argv[2]; shift argv; breaksw
        case --experiment:
                set name = $argv[2]; shift argv; breaksw
        case --debug:
                set debug = 1; breaksw
        case --valgrind:
                set valgrind = 1; breaksw
        case --help:
                set help = 1;  breaksw
        case -h:
                set help = 1;  breaksw
        case --download_input_data:
                set download = 1;  breaksw
    endsw
    shift argv
end
shift argv

if ( $help ) then
    echo "The optional arguments are:"
    echo "--type       followed by the type of the experiment, currently one of the following:"
    echo "             MOM_solo : solo ocean model"
    echo "             MOM_SIS  : ocean-seaice model"
    echo "             CM2M     : ocean-seaice-land-atmosphere coupled climate model"
    echo "             ESM2M    : ocean-seaice-land-atmosphere coupled climate model with biogeochemistry, EarthSystemModel"
    echo "             ICCM     : ocean-seaice-land-atmosphere coupled model"
    echo 
    echo "--experiment followed by the name of the experiment of the specified type"
    echo "             To see the list of available experiments for each type use  -h --type type_name"
    if ( $type == MOM_solo ) then
    echo "             Available experiments for MOM_solo:"
    echo "             box1, box_channel1, bowl1, dome1, gyre1, iom1, mk3p51, symmetric_box1, torus1, dome_bates_blobs1"
    endif
    if ( $type == MOM_SIS ) then
    echo "             Available experiments for MOM_SIS:"
    echo "             om3_core1, om3_core3, MOM_SIS_TOPAZ, MOM_SIS_BLING, atlantic1, global_0.25_degree_NYF"
    endif
    if ( $type == CM2M ) then
    echo "             Available experiments for CM2M:"
    echo "             CM2.1p1, CM2M_coarse_BLING"
    endif
    if ( $type == ESM2M ) then
    echo "             Available experiments for ESM2M:"
    echo "             ESM2M_pi-control_C2"
    endif
    if ( $type == ICCM ) then
    echo "             Available experiments for ICCM:"
    echo "             ICCMp1"
    endif
    if ( $type == EBM ) then
    echo "             Available experiments for EBM:"
    echo "             mom4p1_ebm1"
    endif
    echo 
    echo 
    echo "--platform   followed by the platform name that has a corresponfing environ file in the ../bin dir, default is gfortran"
    echo 
    echo "--npes       followed by the number of pes to be used for this experiment"
    echo
    echo "--download_input_data  download the input data for the test case"
    echo 
    echo "Note that the executable for the run should have been built before calling this script. See MOM_compile.csh"
    echo 
    exit 1
endif

set root          = $cwd:h         # The directory in which you checked out src
set code_dir      = $root/src                         # source code directory
set workdir       = $root/work     # where the model is run and model output is produced
                                   # This is recommended to be a link to the $WORKDIR of the platform.
set expdir        = $workdir/$name
set inputDataDir  = $expdir/INPUT   # This is path to the directory that contains the input data for this experiment.
                                     # You should have downloaded and untared this directory from MOM4p1 FTP site.
set diagtable     = $inputDataDir/diag_table  # path to diagnositics table
set datatable     = $inputDataDir/data_table  # path to the data override table.
set fieldtable    = $inputDataDir/field_table # path to the field table
set namelist      = $inputDataDir/input.nml   # path to namelist file

set executable    = $root/exec/$platform/$type/fms_$type.x      # executable created after compilation

#set archive       = $ARCHIVE/$type #Large directory to host the input and output data.


#===========================================================================
# The user need not change any of the following
#===========================================================================

if ( $debug || $valgrind ) then
    setenv DEBUG true
endif

#
# Users must ensure the correct environment file exists for their platform.
#
source $root/bin/environs.$platform  # environment variables and loadable modules

set mppnccombine  = $root/bin/mppnccombine.$platform  # path to executable mppnccombine
set time_stamp    = $root/bin/time_stamp.csh          # path to cshell to generate the date

# Check if the user has extracted the input data
if( $download ) then
    cd $root/data
    ./get_exp_data.py $name.input.tar.gz
    mkdir -p $workdir
    cp archives/$name.input.tar.gz $workdir
    cd $workdir
    tar zxvf $name.input.tar.gz
endif

if ( ! -d $inputDataDir ) then
        echo "ERROR: the experiment directory '$inputDataDir' does not exist or does not contain input and preprocessing data directories!"
        echo "Either use the --download_input_data option or copy the input data from the MOM data directory manually."
        echo "To manually dowload the data execute the following:"
        echo "cd $root/data"
        echo "./get_exp_data.py $name.input.tar.gz"
        echo "mkdir -p $workdir"
        echo "cp archives/$name.input.tar.gz $workdir"
        echo "cd $workdir"
        echo "tar zxvf $name.input.tar.gz"
        exit 1
endif

# setup directory structure
if ( ! -d $expdir )         mkdir -p $expdir
if ( ! -d $expdir/RESTART ) mkdir -p $expdir/RESTART
if ( ! -d $expdir/INPUT ) mkdir -p $expdir/INPUT

if ( ! -e $namelist ) then
    echo "ERROR: required input file does not exist $namelist."
    echo "Need to download input data? See ./MOM_run.csh -h"
    exit 1
endif
if ( ! -e $datatable ) then
    echo "ERROR: required input file does not exist $datatable."
    echo "Need to download input data? See ./MOM_run.csh -h"
    exit 1
endif
if ( ! -e $diagtable ) then
    echo "ERROR: required input file does not exist $diagtable."
    echo "Need to download input data? See ./MOM_run.csh -h"
    exit 1
endif
if ( ! -e $fieldtable ) then
    echo "ERROR: required input file does not exist $fieldtable."
    echo "Need to download input data? See ./MOM_run.csh -h"
    exit 1
endif

# Change to expdir
cd $expdir

cp $namelist   input.nml
cp $datatable  data_table
cp $diagtable  diag_table
cp $fieldtable field_table

# Preprocessings
$root/exp/preprocessing.csh

if ( $type == CM2M & $npes != 45 ) then
    set valid_npes = 45
endif

if ( $type == ESM2M & $npes != 90 ) then
    set valid_npes = 90
endif
if ( $type == ICCM & $npes != 54 ) then
    set valid_npes = 54
endif

if ( $name  == atlantic1 & $npes != 24) then
    set valid_npes = 24
endif

if ( $name  == mom4p1_ebm1 & $npes != 17) then
    set valid_npes = 17
endif

if ( $name  == global_0.25_degree_NYF & $npes != 960) then
    set valid_npes = 960
endif


set runCommand = "$mpirunCommand $npes $executable >fms.out"
if ( $valgrind ) then
    set runCommand = "$mpirunCommand $npes -x LD_PRELOAD=$VALGRIND_MPI_WRAPPERS valgrind --gen-suppressions=all --suppressions=../../test/valgrind_suppressions.txt --main-stacksize=2000000000 --max-stackframe=2000000000 --error-limit=no $executable >fms.out"
endif

if ( $debug ) then
    set runCommand = "$mpirunCommand --debug $npes $executable >fms.out"
endif

echo "About to run experiment $name with model $type at `date`. The command is: $runCommand"

if ( $valid_npes ) then
    echo "ERROR: This experiment is designed to run on $valid_npes pes. Please specify --npes  $valid_npes "
    echo "Note:  In order to change the default npes for an expeiment the user may need to edit the values of layouts and atmos_npes and ocean_npes in the input.nml and run the mpi command manually in the working dir"
    exit 1
endif

# Run the model
$runCommand
set model_status = $status
if ( $model_status != 0) then
    echo "ERROR: Model failed to run to completion"
    exit 1
endif

# generate date for file names ---
set begindate = `$time_stamp -bf digital`
if ( $begindate == "" ) then
    set begindate = tmp`date '+%j%H%M%S'`
endif
set enddate = `$time_stamp -ef digital`
if ( $enddate == "" ) then
    set enddate = tmp`date '+%j%H%M%S'`
endif
if ( -f time_stamp.out ) then
    rm -f time_stamp.out
endif

# combine output files
if ( $npes > 1 ) then
    set file_previous = ""
    set multioutput = (`ls *.nc.????`)
    foreach file ( $multioutput )
        if ( $file:r != $file_previous:r ) then
            set input_files = ( `ls $file:r.????` )
            if ( $#input_files > 0 ) then
                $mppnccombine -n4 -r $file:r $input_files
                if ( $status != 0 ) then
                    echo "ERROR: in execution of mppnccombine -n4 -r on outputs"
                    echo "Command was: $mppnccombine $file:r $input_files"
                    break
                endif
            endif
        else
            continue
        endif
        set file_previous = $file
    end
endif

# get a tar restart file
cd RESTART
cp $expdir/input.nml .
cp $expdir/*_table .

# combine netcdf files
if ( $npes > 1 ) then
    # Concatenate blobs restart files. mppnccombine would not work on them.
    if ( -f ocean_blobs.res.nc.0000 ) then
        ncecat ocean_blobs.res.nc.???? ocean_blobs.res.nc
        rm ocean_blobs.res.nc.????
    endif

    # Concatenate iceberg restarts
    if ( -f icebergs.res.nc.0000 ) then
        ncrcat icebergs.res.nc.???? icebergs.res.nc
        rm icebergs.res.nc.????
    endif

    # Land restarts need to be combined with  combine-ncc
    # More simply just tar them up in this version
    set land_files = ( cana glac lake land snow soil vegn1 vegn2 )
    foreach file ( $land_files )
       set input_files = `/bin/ls ${file}.res.nc.????`
       if ( $#input_files > 0 ) then
          tar czf ${file}.res.nc.tar $input_files
          if ( $status != 0 ) then
             echo "ERROR: in creating land restarts tarfile"
             exit 1
          endif
          rm $input_files
       endif
    end

    set file_previous = ""
    set multires = (`ls *.nc.????`)
    foreach file ( $multires )
        if ( $file:r != $file_previous:r ) then
            set input_files = ( `ls $file:r.????` )
            if ( $#input_files > 0 ) then
                $mppnccombine -n4 -r $file:r $input_files
                if ( $status != 0 ) then
                    echo "ERROR: in execution of mppnccombine -n4 -r on restarts"
                    echo "Command was: $mppnccombine $file:r $input_files"
                endif
            endif
        else
            continue
        endif
        set file_previous = $file
    end
endif

# rename ascii files with the date
foreach out (`ls *.out`)
   mv $out ascii/$begindate.$out
end

unset echo

echo end_of_run
echo "NOTE: Natural end-of-script for experiment $name with model $type at `date`"

exit 0

#!/bin/tcsh -f
#
# This is a TCSH program to test files used by time_interp_external_mod
# and/or data_override_mod.  This is intended to help debug runtime errors
# in FMS based codes where the above modules fail reading an INPUT file. 
# This is a quick way to make sure the file works without having to run the
# entire model.
#
# USER INPUT:
# filename = name of file to be tested
# fieldname = name of field in file
# year0 = initial year to use (typically start time of model)
# month0 = initial month to use
# day0 = initial day to use
# days_inc = increment in days
# ntime = number of time steps
# cal_type = calendar ('julian' , 'no_leap' or '360_day')
#
#
#  This preprocessing program was tested with Intel Fortran compiler on ia64 at GFDL.
#  In order to run on other system, some changes may be needed.
#######################################################################
# Users need to modify the following variables according to their need. 
# These particular values are here for testing purposes in GFDL only.  
#######################################################################
  set echo
  set platform     = "ncrc.intel"                                    
  set npes = 1
#
  set root         = $cwd:h:h:h                         # The directory that contains src/ and bin/
#
# Users must ensure the following  files exist for their platform.
#
  source $root/bin/environs.$platform                   # environment variables and compiler options

  set mkmfTemplate = $root/bin/mkmf.template.$platform  # path to mkmf template 

#############################################################################
# Users need not change anything below this line except the namelists values.
#############################################################################
  set mkmf         = $root/bin/mkmf                         
  set cppDefs      = ( "-Duse_netCDF -Duse_netCDF3 -Duse_libMPI" )        # list of cpp #defines to be passed to the source files
  set sharedir     = $root/src/shared                       # directory of the shared code.
  set includedir   = $sharedir/include
  set UTILITIES    = "$sharedir/{time_manager,fms,mpp,clocks,time_interp,axis_utils,platform,horiz_interp,constants,memutils,mosaic}"
  set srclist    = " $UTILITIES $sharedir/mpp/include $includedir "   
#
# Set the compiler options and environment variables. User must ensure the file exists for the platform.
#
  source $root/bin/environs.$platform

# compile the code and create executable
$mkmf -p test_time_interp_ext.exe -t $mkmfTemplate -c "$cppDefs -Dtest_time_interp_external" $srclist 
make  test_time_interp_ext.exe


cat > input.nml <<EOF
 &test_time_interp_ext_nml
 filename='foo.nc'
 fieldname='foo'
 year0=1900
 month0=1
 day0=1
 days_inc=1
 ntime=1
 cal_type='julian'
 /
EOF

$mpirunCommand $npes `./test_time_interp_ext.exe
unset echo

#!/bin/tcsh 
#=======================================================================
#         Contact : Zhi Liang   email : Zhi.Liang
#
#  This runscritp can can edit the topography of input grid_spec file "orig_grid" 
#  according to the ascii input file "grid_edits". Then it will output the 
#  new grid_spec file "mod_grid". 
#=======================================================================
#  This preprocessing program was tested with Intel Fortran compiler on ia64 at GFDL.
#  In order to run on other system, some changes may be needed.
#######################################################################
# Users need to modify the following variables according to their need. 
# These particular values are here for testing purposes in GFDL only.  
#######################################################################
  set echo
  set platform     = "ncrc.intel"                      # A unique identifier for your platform
#
  set root         = $cwd:h:h:h:h                       # The directory that contains src/ and bin/
  set npes         = 1
#
# Users must ensure the following  files exist for their platform.
#
  source $root/bin/environs.$platform                   # environment variables and compiler options

  set mkmfTemplate = $root/bin/mkmf.template.$platform  # path to mkmf template 

#############################################################################
# Users need not change anything below this line except the namelists values.
#############################################################################
  set name         = "edit_grid"                       # name of the grid file will be generated
  set tooldir      = $cwd                              # directory of the tool
  set sharedir     = $root/src/shared                  # directory of the shared code.
  set includedir   = $sharedir/include                 # fms include directory   
  set workdir      = $tooldir/workdir                  # where the tool is run and output is produced
  set executable   = $tooldir/exec/edit_grid.exe       # executable created after compilation
  if ( $?DEBUG ) then
    set executable    = $tooldir/debug/edit_grid.exe 
    set mkmfTemplate  = $root/bin/mkmf.debugtemplate.$platform         
  endif
  set mkmf         = $root/bin/mkmf                    # path to executable mkmf
  set cppDefs      = ( "-Duse_netCDF -Duse_netCDF3 -Duse_libMPI" )                # list of cpp #defines to be passed to the source files

# grid to be edited and grid_edits test file
  set grid_edits = grid_edits.txt                      # text file to specify the edit region and new depth.
  set orig_grid  = $workdir/ocean_grid.nc         

# list the source code
  
  set CORE      = " $tooldir/{edit_grid.F90,topog.f90,grids_type.f90,grids_util.f90,check_mask.F90} "
  set UTILITIES    = "$sharedir/{axis_utils,constants,fms,mpp,horiz_interp,platform,memutils,mosaic}"
  set UTILITIES    = " $UTILITIES $sharedir/mpp/include $includedir " 
  set srclist   = ( $CORE $UTILITIES )


# compile the model code and create executable
  if( ! -d $executable:h ) mkdir $executable:h
  cd $executable:h
  $mkmf -t $mkmfTemplate -p $executable:t -c "$cppDefs" $srclist

  make $executable:t

#--------------------------------------------------------------------------------------------------------
# setup directory structure
  if ( ! -d $workdir )         mkdir $workdir

  cd $workdir

# get executable  
  cp $executable $executable:t

# if the grid_edits file does not exist, create one here.
  if( ! -f $grid_edits) then
     cat >$grid_edits <<EOF
     100:105, 50:65, 1000   #lon_start:lon_end, lat_start:lat_end, new height.
     65, 75, 200
     5,16, 0
EOF
  endif

# --- set up namelist  

  cat >input.nml <<!
    &edit_grid_nml
       orig_grid   = '$orig_grid' 
       mod_grid    = '$name.nc'
       grid_edits  = '$grid_edits'
       /
!

  $mpirunCommand $npes ./$executable:t >fms.out

  cat fms.out

# rename ascii output file
  mv fms.out $name.fms.out
  mv logfile*.out $name.logfile.out

  unset echo

#!/bin/tcsh -f
#
# $Id: list_ncvars.csh,v 20.0 2013/12/14 00:29:09 fms Exp $
# ------------------------------------------------------------------------------
# FMS/FRE Project: Script to Call the "list_ncvars" Program
# ------------------------------------------------------------------------------
# afy    Ver   1.00  Initial version (copied from 1.1.2.1)          June 10
# afy    Ver   2.00  Don't source the "init.csh" script             June 10
# afy    Ver   2.01  Use "which" to locate the "list_ncvars"        June 10
# afy    Ver   3.00  Return to the original executable name         June 10
# ------------------------------------------------------------------------------
# Copyright (C) NOAA Geophysical Fluid Dynamics Laboratory, 2000-2010
# Designed and written by V. Balaji, Amy Langenhorst and Aleksey Yakovlev
#

set static    = .false.
set nonstatic = .false.
set var0d  = .false.
set var1d  = .false.
set var2d  = .false.
set var3d  = .false.
set var4d  = .false.

##################################################################
#  ----- parse input argument list ------

set argv = (`getopt st01234 $*`)

while ("$argv[1]" != "--")
    switch ($argv[1])
        case -s:
            set static = .true.; breaksw
        case -t:
            set nonstatic = .true.; breaksw
        case -0:
            set var0d = .true.; breaksw
        case -1:
            set var1d = .true.; breaksw
        case -2:
            set var2d = .true.; breaksw
        case -3:
            set var3d = .true.; breaksw
        case -4:
            set var4d = .true.; breaksw
    endsw
    shift argv
end
shift argv
set list = ( $argv )

# usage message?
if ($#list == 0) set help
if ($static == ".false." && $nonstatic == ".false.") set help
if ($var0d == ".false." && $var1d == ".false." && \
    $var2d == ".false." && $var3d == ".false." && $var4d == ".false.") set help

##################################################################
#----- help message -----

if ($?help) then
set name = `basename $0`
cat << EOF

Usage:  $name -s | -t [-0123] files...

        -s   list names of static fields (no time dimension)
        -t   list names of non-static fields (with time dimension)
        -0   list names of scalar fields
        -1   list names of 1-d fields
        -2   list names of 2-d fields
        -3   list names of 3-d fields
        -4   list names of 4-d fields
        files... list of netcdf files

   Options -0,1,2,3,4 exclude the time dimension.
   Must specify either "-s" or "-t".
   Also must specify one (or more) of the following: -0, -1, -2, -3, -4.
   A file name must be supplied.
   Variables that are also dimensions are skipped.
   Variables that end in "_T1", "_T2", and "_DT" are skipped.

Example:  $name -st -0123 myfile.nc
          
          This will list all variables (static and non-static) that
          have a rank of 0, 1, 2, or 3.

EOF
exit 1
endif

##################################################################

alias list_ncvars `which list_ncvars.exe`

# unique namelist name
set nml_name = nml`date '+%j%H%M%S'`

#-------------------------
# loop thru netcdf files
foreach file ($list)

cat > $nml_name << EOF
 &input
   filename = '$file',
   list_static = $static,
   list_nonstatic = $nonstatic,
   var0d = $var0d,
   var1d = $var1d,
   var2d = $var2d,
   var3d = $var3d,
   var4d = $var4d,
 &end
EOF

list_ncvars < $nml_name

end
#-------------------------

# clean up
rm -f $nml_name

# MOM Quickstart Guide

Brief instructions for running MOM5 experiments
   
Author: Niki Zadeh (Niki.Zadeh@@noaa.gov)
   

##  Where to start?
   
A good place to start is the online [User Guide](http://www.mom-ocean.org/web/docs/project/user_guide), which gives full details on all the steps involved in running a complete experiment.

This document gives a short outline of how to get a very basic example experiment running.
   
## How to get the source code and scripts

You can access the source code by following these [download instructions](http://www.mom-ocean.org/web/downloads)
      
In the sections below, `TEST_CASE` is a generic name referring to the name of a specific experiment you are working on. After you clone the repository from github you will have a directory called `mom/` in your working directory, which will be referred to as `$root_dir` in this guide.
   
## How to compile and run the MOM tests
   
MOM requires that NetCDF and MPI libraries be installed on users' platform.
    
Ensure that you have the right environment variable for your platform in the file `bin/environs.PLATFORM_ID`. `PLATFORM_ID` could be any string that identifies your platform. The file `bin/environs.PLATFORM_ID` gets sourced at the beginning of all compile and run scripts and is there to make sure all compile and run time library paths are found.
    
There are a few types of test models provided for this release  all using the GFDL shared infrastructure (FMS) but have different FMS component models for atmosphere and/or land. 
We refer to these types as `MODEL_TYPE` in this guide: 
     
       
* `MOM_solo`: stand alone MOM ocean model.
* `MOM_SIS`: MOM coupled with GFDL ice model (SIS) besides null versions of atmosphere and land models.
* `EBM`: `MOM_SIS` coupled with `land_lad` and energy balanced atmosphere model 
* `ICCM`: `MOM_SIS` coupled with `land_lad` and `bgrid` atmosphere model in low resolution setup.  
* `CM2M`: GFDL CM2.1 model which is `MOM_SIS` coupled with `land_lad` and finite volume atmosphere model (with `am2` physics).
* `ESM2M`: GFDL Earth System Model which is `MOM_SIS` coupled with `land_lad2` and finite volume atmosphere model (with `am2` physics).
      
### To compile the models:
      
Find out what `MODEL_TYPE` you want to work on and what is `PLATFORM_ID` then
        
    $ cd $root_dir/exp    
    $ ./MOM_compile.csh --platform PLATFORM_ID --type MODEL_TYPE
      
NOTE: The Energy Balanced Model (`EBM`) cannot be compiled by the above procedure and a separate compile script is provided for it. 

### To run an experiment

Make sure you have a large enough working directory (`WORKDIR`) and made a symbolic link to it called `work` in your top directory, i.e.,    

    $ cd $root_dir
    $ ln -s WORKDIR work
            
Find out what test cases are available for a particular `MODEL_TYPE`

    $ cd $root_dir/exp
    $ ./MOM_run.csh --platform PLATFORM_ID --type MODEL_TYPE -h      

To run a `TEST_CASE`
                
    $ ./MOM_run.csh --platform PLATFORM_ID --type MODEL_TYPE  --experiment TEST_CASE --download_input_data

You may need to specify the number of processor for the `TEST_CASE`, in that case the above command errors out with the right info. Note: The script `exp/preprocessing.csh` is called by the `MOM_run.csh` to modify the mom4p1 namelists of these old test cases to make them compatible with MOM5. The results go into `WORKDIR`.

### Notes

* The scripts have been tested fully only with Intel Fortran and PGI compilers on ia64 platform. They are partially tested  with pathscale compiler on x86\_64 and also gfortran4.3 compiler on Core2Duo processor. 
* Some of these test cases  require a large disk space to save the input data. Choose a partition with enough space (1-2 G) to untar the code and data bundels.
* IBM platform users might want to add the following line to the top of the run scripts 


        setenv LDR_CNTRL MAXDATA=0xD0000000@DSA 


* The compile script provides the basic capability with dynamic memory allocation. To use static memory allocation which might be faster on some platforms  you need to adjust the values of domain bounds properly according to the number of processors and layout. 
* The compile script use netcdf3 by default. If you want to use netcdf4 libraries instead you can do so by deleting the `-Duse_netCDF3` from the CPPs in compile script and then recompile.   

## How to prepare input data

The input data needed to run the selected experiments (tests) that are included in this release are available in the `data/` directory. The data should be downloaded automatically when you run the MOM_run.csh script with the --download_input_data option. Alternatively the data can be downloaded manually with the command:

    $ ./data/get_exp_data.py <filename>

For example, to download the data for the box_channel1 experiment one would execute:

    $ ./data/get_exp_data.py box_channel1.input.tar.gz
    $ ./data/get_exp_data.py box_channel1.output.tar.gz

## Examine the output
   
To keep the runscript simple all output files of a model run will be in the work directory. There are three types of output files:
     
* ascii file with `.fms.out` extension: the description of the setup of the run and verbose comments printed out during the run.
* restart files in `RESTART` directory: the model fields necessary to initialize future runs of the model.
* history files with `.nc` or `.nc.tar` extension: output of the model, both averaged over specified time intervals and snapshots.
   
The ascii file contains everything written to the screen during model execution. The total time for model execution as well as the times of separate modules are reported here. All `.tar` files should be decompressed for viewing. The decompress command is:
     
    tar -xvf filename.tar
     
Users will see result files in NetCDF format. Postprocessing tools such as Ferret, ncview, grads or matlab can be used to view data in these files.
The outputs of the selected experiments can be downloaded into the `data/` directory for the purpose of comparing your results with results produced at GFDL.

# The MOM User Guide

Authors:

* Stephen Griffies - Stephen.Griffies@noaa.gov
* Niki Zadeh - Niki.Zadeh@noaa.gov

## Introduction

The purpose of this section is to provide an overview of MOM and the contents of this web page.
   
### What is MOM?
   
The Modular Ocean Model (MOM) is a numerical representation of the ocean's hydrostatic primitive equations. It is designed primarily as a tool for studying the global ocean climate system, as well as capabilities for regional and coastal applications. The latest release of MOM occurred in 2012, and is named MOM5. This code has origins that date back to the pioneering work of Kirk Bryan and Mike Cox in the 1960s-1980s. It is developed and supported by researchers at NOAA's [Geophysical Fluid Dynamics Laboratory](http://gfdl.noaa.gov/) (GFDL), with critical contributions also provided by researchers worldwide who comprise the MOM community. The purpose of this web guide is to provide general information about MOM, and particular information for how to download and run the code. Here is a table summarizing the algorithmic history of MOM.
   
### MOM Releases

MOM has had the following releases (note that MOM4p1 releases are distinguished by release dates).

* MOM4p0a: January 2004
* MOM4p0b: March 2004
* MOM4p0c: August 2004
* MOM4p0d: May 2005
* MOM4p1: 28 September 2007
* MOM4p1: 28 December 2007
* MOM4p1: Dec 2009
* MOM5: 2012
         
For each release, we aim to update MOM by enhancing features and documentation, and correcting bugs.  Each version is generally compatible with the previous versions.  However, as updates are made, we cannot guarantee that all features will bitwise agree across releases.  Nonetheless, we do maintain a small selection of "bitwise-legacy" code to allow for certain modules to bitwise agreement across versions.  As the maintenance of bitwise-legacy features represents an onerous task (e.g., bits change when A+B is altered to B+A), we recommend that researchers beginning new projects start with the most recent version, and that researchers with mature projects carefully test the new code prior to moving forward.

### MOM email list
   
Email concerning MOM should be directed to the [MOM mailing list](https://groups.google.com/forum/#!forum/mom-users). All questions, comments, and suggestions are to be referred to this list.

### The MOM community
      
There is a sizable user community for MOM. This community has proven to be a great resource, especially for new users, and those with portability questions, some of which are beyond the abilities of GFDL scientists to answer.

### Efficiency and Portability

The MOM team aims to provide code that is efficient, flexible, and transparent for use across a broad range of computer platforms. Balancing these aims is not always simple. For example, some of the most efficient code is also the least transparent. The MOM developers are scientists whose main concern is to support MOM as a tool for science research. This focus then leads us to weight transparency and portability over efficiency. However, we readily make efficiency modifications that are of a general nature, so please do feel free to volunteer any such changes.

Given the above aims, we have continued to support one avenue for code efficiency involving the allocation of arrays. MOM can be compiled in two ways: with static allocation of arrays or dynamic allocation. Static allocation is enabled at compile time via the cpp-preprocessor option `MOM_STATIC_ARRAYS`.  At GFDL, we have generally found that static allocation executables are faster than dynamic, since compilers like to know before-hand the size of the model arrays. Work on the SGI machines at GFDL has reduced the difference in efficiency between these two compilations. However, details of the model configuration strongly impact the differences in model speed. Additionally, we understand that on some platforms, the dynamic allocation results in faster code than static. Consequently, we have decided to maintain both the static and dynamic options, given the ambiguous results across platforms, compilers, model configurations, etc.

## An Outline of MOM

The purpose of this section is to outline certain features of MOM.  

### Documentation

In addition to this online user guide, documentation for MOM is provided by the following LaTeX generated PDF documents:
       
* [A Technical Guide to MOM4](http://www.mom-ocean.org/web/docs/project/MOM4_guide.pdf) by Stephen.Griffies@noaa.gov, Matthew.Harrison@noaa.gov, Ronald.Pacanowski@noaa.gov, and Tony.Rosati@noaa.gov. This is the primary reference for MOM4p0. It contains details about some of the numerical algorithms and diagnostics. Reference to MOM4p0 in the literature should refer to this document:

       
        A Technical Guide to MOM4
        GFDL Ocean Group Technical Report No. 5
        S.M. Griffies, M.J. Harrison, R.C. Pacanowski, and A. Rosati
        NOAA/Geophysical Fluid Dynamics Laboratory
        August 2004
        Available on-line at http://www.mom-ocean.org/web/docs

       
* [Elements of MOM](http://www.mom-ocean.org/web/docs/project/MOM5_elements.pdf) by Stephen.Griffies@noaa.gov is the primary reference for MOM4p1 and MOM5. It contains details about some of the numerical algorithms and diagnostics. Reference to MOM in the literature should refer to this document:

       
        Elements of the Modular Ocean Model (MOM)
        GFDL Ocean Group Technical Report No. 7
        Stephen M. Griffies
        NOAA/Geophysical Fluid Dynamics Laboratory
        June 2012
        620 + xiii pages 
        Available on-line at http://www.mom-ocean.org/web/docs
       
       
A theoretical rationalization of ocean climate models is provided by [Fundamentals of Ocean Climate Models](http://www.amazon.com/Fundamentals-Climate-Models-Stephen-Griffies/dp/0691118922). This book by Stephen.Griffies@noaa.gov was published by Princeton University Press in August 2004.

### Embedded Documentation
   
The documentation of most Fortran modules in FMS is inserted right in the source code to enable consistency between the code and documentation. A Perl software tool is used to extract documentation from the source code to create a corresponding html module.  For example, documentation for `shared/diag_manager/diag_manager.F90 module` is `shared/diag_manager/diag_manager.html`. In general, the embedded documentation is a good starting point to understand the Fortran module, though ultimately the Fortran code is the final source for information.
   
### MOM5 Characteristics
   
Although MOM5 shares much in common with earlier versions of MOM, it possesses a number of computational, numerical, and physical characteristics that are noteworthy. The main characteristics of MOM5 can be found in the introduction to [Elements of MOM](http://www.mom-ocean.org/web/docs/project/MOM5_elements.pdf).

### MOM and FMS
   
MOM has been coded within GFDL's [Flexible Modeling System](http://gfdl.noaa.gov/fms) (FMS). Doing so allows for MOM developers to use numerous FMS infrastructure and superstructure modules that are shared amongst various atmospheric, ocean, sea ice, land, vegetative, etc. models. Common standards and shared software tools facilitate the development of high-end earth system models, which necessarily involves a wide variety of researchers working on different computational platforms.  Such standards also foster efficient input from computational scientists and engineers as they can more readily focus on common computational issues.

The following list represents a sample of the FMS shared modules used by MOM.
     
* time manager: keeps model time and sets time dependent flags
* coupler: used to couple MOM to other component models
* I/O: to read and write data in either NetCDF, ASCII, or native formats 
* parallelization tools: for passing messages across parallel processors
* diagnostic manager: to register and send fields to be written to a file for later analysis
* field manager: for integrating multiple tracers and organizing their names, boundary conditions, and advection schemes

The FMS infrastructure (the "Siena" version) forms the basis for the 2012 release of MOM. 
      
The Flexible Modeling System (FMS), including MOM, is free software; you can redistribute it and/or modify it and are expected to follow the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

FMS is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
    
You should have received a copy of the GNU General Public License along with MOM; if not, write to:
   
     Free Software Foundation, Inc.
     59 Temple Place, Suite 330
     Boston, MA 02111-1307  
     USA
   
### MOM test cases
   
MOM is distributed with a suite of test cases, with these tests detailed in [Elements of MOM](http://www.mom-ocean.org/web/docs/project/MOM5_elements.pdf).

Many of the test cases are NOT sanctioned for their physical relevance. They are instead provided for the user to learn how to run MOM, and to verify the numerical and/or computational integrity of the code. PLEASE do not assume that the experiments will run for more than the short time selected in the sample runscripts.
   
## Contributing to MOM
   
MOM developers aim to provide the international climate research community with a repository for robust and well documented methods to simulate the ocean climate system.  Consequently, we encourage interested researchers to contribute to MOM by commenting on code features, and providing new modules that enhance simulation integrity (e.g., a new physical parameterization or new advection scheme) or increase the model's functionality.

The [Model Development Lab](http://www.mom-ocean.org) (MDL) provides infrastructure to facilitate contributions from the MOM community.
   
## Source code and data sets

The purpose of this section is to outline methods required to obtain the source code and associated datasets.  

### Obtaining source code and data sets
   
The source code and test case data sets for MOM are hosted on [github](https://github.com/BreakawayLabs/mom). Follow [these instructions](http://www.mom-ocean.org/web/downloads) to download the code and (optionally) the test case data sets.

### Description of the data sets

There are many datasets provided with the various MOM test cases. All datasets released with MOM are in [NetCDF](http://www.unidata.ucar.edu/software/netcdf/) format, since this format is widely used in the community. A number of useful tools are available as part of the [NCO](http://nco.sourceforge.net/) suite that allow the user to perform some necessary operations (editting attributes, merging, etc.) on a NetCDF file.
     
## Setting up an experiment with MOM
     
MOM is distributed with code used to generate model grids, initial conditions, and boundary conditions.  Each step must be performed prior to running the ocean model.  The steps used during this experimental setup stage are generally termed "preprocessing", and the code used for these purposes is under the `preprocessing/` directory in the MOM distribution.  The purpose of this section of the User Guide is to outline this code and its usage.  Further details of usage and algorithms can be found in the internal documentation within the various preprocessing code modules.

### General comments
   
We start this section with some general comments regarding the setup of a model experiment.
 
* Setting up an experiment is critical part to the success of a research or development project with MOM.  It is important that the user take some time to understand each of the many steps, and scrutinize the output from this code. We have endeavored over the years to provide tools facilitating the ready setup of a new experiment.  However, we remain unable to provide code that does everything possible under the sun.  Additionally, all features that are provided here may not be fully tested. For these reasons, the preprocessing code continues to evolve as use and functionality evolve.  We sincerely appreciate ALL comments about code and documentation, especially comments regarding clarity, completeness, and correctness.  Your input is essential for the improvement of the code and documentation.
 
* Many steps in idealized experiments that were formerly performed while running earlier MOM versions have been extracted from MOM and placed into preprocessing.  Hence, even if you are running an idealized experiment, it is likely that you will need to perform some if not all of the preprocessing steps discussed here.
 
* If you have a problem that is not addressed here, then please feel free to query the [MOM mailing list](https://groups.google.com/forum/#!forum/mom-users).  No question is too silly, so please ask!
 
* All code used to setup an experiment with MOM is written in Fortran 90/95 except `make_xgrids`, which is written in C.  Most code is dependent on FMS shared code for the purpose of parallization and interpolation.  In addition to the documentation provided here, there are comments within the code to help users debug and to make modifications to suit their purpose.
 
* Some users make nontrivial changes of general use.  With your support, assistance, and maintenance, we will endeavour to include your changes in future releases.
 
### Creation of the ocean/ice grid (mosaics)
  
Mosaics is the name given to a general framework to define structured grids at GFDL.  The details of this scheme are being incorporated by others outside of GFDL as well.  Most of the recent global models developed at GFDL employ the conventions of Mosaic.  However, MOM is backwards compatible, so that it still supports grids generated with older software.

### Creation of the ocean/ice grid (pre-mosaics)
  
Within GFDL FMS, ocean and ice are assumed to share the same grid. This means that the two models read in the same grid specification file.  Even so, the domain decomposition on parallel systems may be different, and indeed they generally are due to different load balance issues between the two models.

Even though the ocean and ice models read the same grid specification file, they use the information from the grid file in a slightly different manner when setting up the respective model's tracer grid. In particular, the ocean model reads the tracer location directly from the arrays (`x_T/geolon_t`, `y_T/geolat_t`) written in the grid specification file.  In contrast, the GFDL ice model reads (`x_vert_T/geolon_vert_t`, `y_vert_T/geolat_vert_t`) from the grid specification file and then averages these four vertex locations to get the tracer location used in the ice model.  The result is that diagnostics output from the two models have ocean and ice fields at slightly different locations for cases such as the tripolar grid when the grid is not spherical.

The ocean/ice grid specification file is generated by executing the `ocean_grid_generator` utility. The `ocean_grid_generator` utility generates the horizontal grid, vertical grid, and topography. A C-shell script is provided to compile relevant code to generate and run the executable to produce the grid file. To create the desired grid and topography, setting namelist options within the runscript is needed.  

The horizontal grid can be conventional lon-lat spherical grid or a reprojected rotated tripolar grid (R. Murray, [Explicit generation of orthogonal grids for ocean models](http://www.sciencedirect.com/science/article/pii/S0021999196901369), 1996, J.Comp.Phys., v. 126, p. 251-273.).  The choice is controlled by the namelist option `tripolar grid` (true for tripolar grid and false for lon-lat spherical grid).  Note that Cartesian beta-plane and f-plane geometries are set up within MOM, not within the grid generation preprocessing steps discussed here (see `ocean_core/ocean_grids.F90` for beta-plane and f-plane namelist options).

The `grid_spec` file contains the following horizontal grid information: geographic location of T, E, C and N-cell (Tracer, East, Corner, and North cells), half and full cell lengths (in meters), rotation information between logical (i.e., grid oriented) and geographic east of cell. The complete description of the horizontal grid and namelist option is available in hgrid 

The vertical grid information includes depth of tracer points and tracer boundaries.  The complete description of namelist option is available in vgrid 

The topography can be idealized (various examples are provided and others can be easily added through emulating those provided) or remapped from a source topography dataset.  The type of topography is specified by the namelist variable `topography`.  Namelist `topog_depend_on_vgrid` specifies if the topography will depend on the vertical grid or not. To generate a grid for MOM, `topog_depend_on_vgrid` should always be true.  A useful option for those upgrading older models to MOM is `adjust_topo`.  If this option is set to false, there will be no adjustments made to the topography.  See topog for further details about topography namelist options.
    
### The exchange grid for coupled models
     
"Exchange grid" information is required for coupled models  (i.e., ocean/ice coupled to land and/or atmosphere) that employ the GFDL coupler technology.  The exchange grid is defined by taking the union of the ocean/ice grid with the atmosphere and land grids.  This union is then used to compute area integrals to allow for conservative mapping of fluxes between the component models.

### The Sutherland-Hodgman polygon clipping algorithm for model cell interaction calculation

The exchange grid information is generated by executing the `make_xgrids` utility. The execution of the `make_xgrids` utility will generate a netcdf file with the name `grid_spec.nc`. The `grid_spec.nc` contains the component model grids as well as the exchange grid information.  In particular, the utility `make_xgrids` generates two exchange grids used by the FMS coupler: one grid for surface fluxes and another for runoff. `make_xgrids` is created by compiling its C source:

    cc -O -o make_xgrids make_xgrids.c -I/usr/local/include -L/usr/local/lib -lnetcdf -lm
      
creates the `make_xgrids` executable from C source and the netCDF and standard math libraries.  It is executed with the command

    make_xgrids -o ocean_grid.nc -a atmos_grid.nc -l land_grid.nc

This execution produces a `grid_spec.nc` file (input files containing grid information for the ocean/sea-ice, atmosphere and land component models are indicated by the `-o`, `-a` and `-l` flags, respectively).  The grid files `ocean_grid.nc`, `atmosphere_grid.nc`, and `land_grid.nc` all can be generated separately through the `ocean_grid_generator` utility. Normally at GFDL we select the same atmosphere and land model grid, but such is not necessary. When the land and atmosphere grids are the same, then we can reduce the execute command to 

    make_xgrids -o ocean_grid.nc -a atmos_grid.nc

If you further decide to choose same ocean, atmosphere and land grid, the execute command will be

    make_xgrids -o ocean_grid.nc -a ocean_grid.nc

`make_xgrids` expects a netCDF format input specification for each of the component model grid files.  For the ice/ocean grid (`ocean_grid.nc`), the following three fields are required:

* `wet` - a 2D array of double precision numbers set to 1.0 where the ice and ocean models are active and 0.0 elsewhere. `wet` has `im` indices in the `i`-direction (pseudo east-west) and `jm` indices in the `j`-direction (pseudo north-south). These correspond to the size of the global arrays of temperature, salinity and ice thickness in the coupled climate model.
* `x_vert_T` and `y_vert_T` - 3D double precision arrays (dimensioned `im * jm * 4`) that contain the longitudes and latitudes (respectively) of the four corners of T- cells.  The numbers are in degrees.

For the netCDF format input specification for the atmosphere and land grid (`atmos_grid.nc` and/or `land_grid.nc`), `x_vert_T` and `y_vert_T` are required.

`make_xgrids` copies all fields of the ice/ocean grid specification file to its output file, `grid_spec.nc`, and then appends fields that specify the atmosphere and land model grids and then the surface and runoff exchange grids.

Using the Sutherland-Hodgman polygon clipping algorithm (reference in next paragraph) for model cell interaction calculation, `make_xgrids` takes care that the land and ocean grids perfectly tile the sphere. The land model's domain is defined as that part of the sphere not covered by ocean (where `wet=0` on the ocean grid). To accomplish this, the land cells must be modified to remove the ocean parts. This is done in `make_xgrids` by first taking the intersections of atmosphere and land cells. The overlap area between these cells and active ocean cells are then subtracted. Finally, the modified atmosphere/land intersections are aggregated into land cell areas and atmosphere/land exchange cell areas.

Model cell intersections are calculated using the Sutherland-Hodgman polygon clipping algorithm (Sutherland, I. E. and G. W. Hodgman, 1974: [Reentrant polygon clipping](http://dl.acm.org/citation.cfm?id=360767.360802), CACM, 17(1), 32-42.).  This algorithm finds the intersection of a convex and arbitrary polygon by successively removing the portion of the latter that is "outside" each boundary of the former. It can be found in many computer graphics text books (e.g., Foley, J. D., A. van Dam, S. K. Feiner, and J. F. Hughes, 1990: [Computer graphics: principles and practice](http://books.google.com.au/books/about/Computer_Graphics.html?id=-4ngT05gmAQC&redir_esc=y), second edition. Addison Wesley, 1174 pp.).  The implementation in `make_xgrids` is particularly simple because the clipping polygon is always a rectangle in longitude/latitude space. For the purpose of finding the line intersections in the clipping operations, the cell boundaries are assumed to be straight lines in longitude/latitude space. This treatment is only perfectly accurate for cells bounded by lines of longitude and latitude.

Spherical areas are calculated by taking the integral of the negative sine of latitude around the boundary of a polygon (Jones, P. W., 1999: [First- and second-order conservative remapping schemes for grids in spherical coordinates](http://journals.ametsoc.org/doi/pdf/10.1175/1520-0493(1999)127%3C2204%3AFASOCR%3E2.0.CO%3B2). Monthly Weather Review, 127, 2204-2210.). The integration pathways are again straight lines in longitude/latitude space. `make_xgrids` checks that the sphere and the individual cells of the atmosphere and ocean grids are tiled by the surface exchange cells. The fractional tiling errors are reported.

### Initial and Boundary Conditions
     
After generating the model grid, it is time to generate the initial and boundary conditions (ICs and BCs).  These conditions are specific to the details of the model grid, so it is necessary to have the grid specificiation file in hand before moving to the IC and BC generation.

There are two options for ICs and BCs.

* Idealized Conditions.  These conditions are based on subroutines that design idealized setups for either initial conditions (e.g., exponential temperature profile) or boundary conditions (e.g., cosine zonal wind stress).  Code for these purposes is found in the `src/preprocessing/mom4_prep/idealized_ic` and `src/preprocessing/mom4_prep/idealized_bc` directories in the MOM distribution. Details of available namelist choices are in the documentation file `idealized_ic.html` as well as the comments within the source code itself.  Users can readily incorporate their favorite idealized IC or BC into the MOM idealized preprocessing step by emulating the code provided.
* Realistic Conditions.  These ICs and BCs generally result from a regridding routine to bring, say, the Levitus analysis onto the model grid for initializing a model, or for mapping surface fluxes onto the grid for boundary conditions.  Code enabling the regridding functions is found in the `preprocessing/regrid_2d`, `preprocessing/regrid_3d` and `preprocessing/regrid` directories in the MOM distribution.

In the remainder of this section, we detail code to generate the ICs and BCs of use for MOM.
    
### 2d Regridding: the common approach
      
It is typical for air-sea fluxes of momentum, heat, and mosture to live on a grid distinct from the ocean model grid.  In particular, most analysis are placed on a spherical latitude-longitude grid, whereas most global ocean models configured from MOM are run with tripolar grids.

When running an ocean or ocean-ice model, it is useful to map the boundary fluxes onto the ocean model grid prior to the experiment. This preprocessing step saves computational time that would otherwise be needed if the fluxes were mapped each time step of a running experiment.  To enable this regridding, one should access code in the `preprocessing/regrid_2d` directory.  The original data must be on a latitude-longitude grid to use `regrid_2d`.  The target/destination grid can be either latitude-longitude with arbitrary resolution, or tripolar with arbitrary resolution.
      
### 2d Regridding: the less common approach

In some cases, one may wish to take a set of forcing fields from one tripolar MOM experiment and regrid them onto another tripolar MOM experiment with different grid resolution.  In this case, it is necessary to regrid before running the experiment.

As of the MOM4p0d distribution, there is a regridding tool within the `preprocessing/regrid` directory that enables one to regrid fields on one tripolar grid to another tripolar grid. Indeed, one can regrid source data from any logically rectangular grid (e.g., latitude-longitude grid or tripolar grid) to a target/destination grid that is any logically rectangular grid.

Note that this is new code, and so has been tested only for particular cases.  So the user should be extra careful to scrutinize the results.

### Setting the `on_grid` logical in the `data_table`

The `on_grid` logical in the `data_table` indicates whether an input file is on the grid of the model or not.

`on_grid=.true.` means that the input file is on the same grid as the ocean model.  This is the recommended setting for models running with specified atmospheric forcing from data or an analysis product.

`on_grid=.false.` means the input file has data on a grid differing from the ocean model.  This feature is allowed ONLY if the input data lives on a spherical grid.  This is a relevant setting if one wishes to keep the input data on their native spherical grid. If the input data is non-spherical, then `on_grid=.false.` is NOT supported.  Instead, it is necessary to preprocess the data onto the ocean model grid.

### Regridding river runoff data

The tool `preprocessing/runoff_regrid` is of use to grid river runoff data onto the ocean model grid.  In this case, runoff is moved to a nearest ocean/land boundary point on the new grid.  Note that the source runoff dataset must be on a spherical latitude-longitude grid, whereas the target/destination grid can be spherical or tripolar.  The regridding algorithm is conservative.

The conservative regridding scheme used in `runoff_regrid` is an area average scheme, which is similiar to the algorithm used in coupler flux exchange.  If any land point has runoff data, after remapping runoff data onto destination grid, the runoff value of that land point will be moved to the nearest ocean point. Before using this tool, you must use `make_xgrids` to generate exchange grid information between the source grid and destination grid. The complete description can be found in `runoff_regrid.html`.

### Two ways to specify surface boundary fluxes

There are two ways to specify surface boundary fluxes when using the coupler feature of FMS. One is through flux exchange, and this employs a conservative algorithm as appropriate for running a coupled ocean-atmosphere model.  It is assumed that the atmospheric model grid is spherical with arbitrary resolution.  The other method is through data override, and this uses a non-conservative scheme.  Data override is of use to selectively remove, say, one of the fluxes coming from an atmospheric model and replace this flux with that from data.  GFDL modelers have found this feature to be very useful in diagnosing problems with a coupled model.

### 3d Regridding for initial conditions or sponges

When generating realistic initial conditions for an ocean experiment, one generally requires the gridding of temperature and salinity, such as from the Levitus analysis product, onto the model's grid.  For this purpose, we are in need of vertical grid information in addition to horizontal 2d information required for the surface boundary conditions.  Hence, we use the `preprocessing/regrid_3d`. A similar procedure is required to develop sponge data.

The original data must be on a spherical grid in order to use `regrid_3d`.  If the original data is on a tripolar grid, we should use `preprocessing/regrid`, which can map data from any logical rectangular grid onto any logical rectangular grid.

###  Comments on the regridding algorithms

For `preprocessing/regrid_3d`, `preprocessing/regrid_2d` and `preprocessing/regrid`, regridding is accomplished non-conservatively using a nearest neighbor distance weighting algorithm, or bilinear interpolation.  The interpolation algorithm is controlled through the namelist option `interp_method`.

Bilinear interpolation is recommanded for most cases since it provides a smooth interpolation when regridding from coarse grid to fine grid (the usual situation with model destination grids typically having resolution more refined than source data products), and it is more efficient.  Efficiency can become a particularly important issue when developing initial and boundary conditions for a refined resolution model.

If the original data is on a tripolar grid, nearest neighbor distance weighting interpolation found in `preprocessing/regrid` must be used, since bilinear interpolation assumes the original data is on a latitude-longitude grid.  For `preprocessing/regrid_2d`, `preprocessing/regrid_3d` and `preprocessing/regrid` using the nearest neighbor distance weighting algorithm, a maximum distance (in radians) can be selected using the namelist value `max_dist`. Namelist option `num_nbrs` can be adjusted for speed, although for most applications this refinement is not necessary.

The complete namelist description for these algorithms can be found in `regrid_2d.html`, `regrid_3d.html` and `regrid.html`.

### Acceptable data formats

When the input data is on a latitude-longitude grid, `preprocessing/regrid_2d` and `preprocessing/regrid_3d` can be used.

When the input data is on a tripolar grid or a latitude-longitude grid, `postprocessing/regrid` can be used.

For sponge generation, acceptable input data sets must have NetCDF format with [COARDS](http://ferret.wrc.noaa.gov/noaa_coop/coop_cdf_profile.html)-compliance.

### Time-related issues in forcing files

There are many ways that data can be formatted in time.  The FMS tools used to read in time information, and to time interpolate, are quite sophisticated and flexible.  Nonetheless, these tools cannot do everything, nor can they know a priori what the modeler intends.  It is therefore necessary to maintain certain conventions when preparing the time information for datasets. This section aims to outline some of the common issues involved with time, and to provide a guide for resolving possible problems.        
      
### How it works and what to do if it fails 

Previous versions of MOM used IEEE binary formats and MOM-specific headers to process forcing data. As of MOM4, data are stored in portable formats (NetCDF currently), and contain standardized metadata per the CF1.0 convention. Understading the functions of Fortran modules that handle metadata and time-related problems will be very helpful in identifying some user's problems. Some of the most frequently used modules are listed below:

* `mpp_io_mod`: Low level I/O (open, close file, write, read,...)
* `axis_utils_mod`: process metadata: identify cartesian axis information (X/Y/Z/T)
* `time_manager_mod`: basic time operations, calendar, increment/decrement time
* `time_interp_mod`: Computes a weight for linearly interpolating between two dates
* `time_interp_external_mod`: top level routines for requesting data
* `data_override_mod`: top level routines for requesting data

### Test your forcing files before use 

It is likely that you will encounter an error using "off-the-shelf" NetCDF files to force your ocean model. This could be due to inadequate metadata in the forcing files, mis-specification of the DataTable, or errors in the parsing of the axis information by `axis_utils` or `get_cal_time`. You'll need some tools to help you diagnose problems and apply the required fix. 

The first thing you should do to setup a new forcing file is use the test program: `time_interp_external_mod:test_time_interp_external`. This test program calls `time_interp_external` at user-specified model times and returns information on how the times were decoded and the resulting interpolation indices and weights. It is STRONGLY suggested that you pass your forcing files through this program before including them in your model configuration. As you gain familiarity with the metadata requirements, you will more easily be able to identify errors and save a lot of time debugging.

The forcing test program is located in `src/preprocessing/test_time_interp_ext`. There is a csh version and a Perl version. Compilation

    mkmf -m Makefile -p test_time_interp_ext.exe -t $TEMPLATE -c -Dtest_time_interp_external -x shared/{time_manager,fms,mpp,clocks,time_interp,axis_utils,platform,horiz_interp,constants,memutils} 

running csh version

namelist options: 

    filename='foo.nc'                      ! name of forcing file
    fieldname='foo'                        ! name of variable in file
    year0=[integer]                        ! initial year to start model calendar
    month0=[integer]                       ! initial month to start model calendar
    day0=[integer]                         ! initial day to start model calendar
    days_inc=[integer]                     ! increment interval for model calendar
    ntime=[integer]                        ! number of model "timesteps"
    cal_type=['julian','noleap','360day']  ! model calendar

running perl version

    test_time_interp_ext.pl -f 'foo.nc' -v 'foo' [--nt [int] --year0 [int] --month0 [int] --day0 [int] --inc_days [int] --cal_type [char]] 

Modifying the file metadata should hopefully prove straightforward. The NCO operators  need to be installed on your platform. The utility `ncatted` is most useful for modifying or adding metadata. If for some reason, you are unable to install the NCO operators, you can use the NetCDF utilities `ncgen` and `ncdump` which come with the NetCDF package.

### Common metadata problems 

Can't identify cartesian axis information: axis_utils_mod:get_axis_cart should return the cartesian information. If this fails, you will get a somewhat cryptic error message: `file/fieldname could not recognize axis atts in time_interp_external`. The best solution is to add the `cartesian_axis` attribute to the axes, e.g. `ncatted -a cartesian_axis,axis_name,c,c,"X" foo.nc`.

Calendar attribute does not exist: This is a required attribute. `time_manager_mod:get_cal_time` converts time units appropriate to the specified calendar to the model time representation. If the `calendar` attribute does not exist, an error message appears "get_cal_time: calendar attribute required. Check your dataset to make sure calendar attribute exists " Use a ncatted command such as:

    ncatted -a calendar,time_axis_name,c,c,"julian" foo.nc

Currently, the FMS time_manager does not support the Gregorian calendar. So, for instance if you have forcing data that are encoded using the Gregorian calendar which has an average year length of 365.2425 days compared with the Julian calendar with an average year length of 365.25 days, assuming Julian calendar encoding will result in a drift of 0.75 days/100 years. If your forcing times are referenced to an early date such as "0001-01-01" your times will drift by 15 days by the year 2000. Until the Gregorian calendar is implemented in the FMS code, the recommended solution is to change the reference date in the forcing dataset using an application such as [Ferret](http://ferret.pmel.noaa.gov/Ferret/home).
 
## Scalability of MOM code 
   
Scalability of a complex model like MOM is the correlation between the number of processing elements (PE) and the run time. One would expect that run time decreases as the number of PEs increases. It is important, however, to note that there are a number of important factors that can affect scalability considerably. The reader is referred to the paper "[A benchmark for the parallel code used in FMS and MOM4](http://www.sciencedirect.com/science/article/pii/S1463500306001107)" Ocean Modelling, Volume 17, Issue 1, 2007, Pages 49-67, Martin Schmidt.

MOM test cases are designed for testing the code integrity, they are not set for scalability study or "production" purpose. Changes should be made if one wants to study scalability of the code.

`diag_step` set the time steps at which numerical diagnostics (e.g., energy, tracer budgets) are computed. The user needs to set this value to be equal to the time step at the end of the experiment, so that only a single instance of the diagnostics is evaluated. For example, if time step is 1 hour and run length is 4 days, `diag_step` (or `diag_freq` in MOM4p0) should be set to 96.

`diag_table` contains all fields that will be saved in history files. The frequency of saving and number of fields can afect the total run time greatly.  So when testing performance, it is recommended that the researcher reduce the output of history files.

Scalability is also dependent on the configuration of the computing platform: Ethernet card, interconnect between PEs, implementation of MPI, memory hierarchy, version of compiler, ...


In examining the total run time the overheads due to initialization and termination should be extracted from total runtime for scalability study since they contain a lot of I/O activities.


### Minimizing idle processors 
 

When running an ocean-ice model with atmospheric data forcing, it may happen that some ocean-ice tasks contain only land points, in which case these processors stand idle. FMS provides a feature to mask land-only tasks and to thus run the model without allocating a processor for these land-only domains. For example, if a processor domain layout 30x50 is specified, but say 500 subdomains are land only, you may run the model with 1500-500=1000 MPI tasks only. Note that you do not get your results faster when eliminating land-only processors, but compute costs may be reduced.
 
In the following example, an "x" represents a land-only subdomain, whereas a dot indicates a domain with a nonzero number of "wet" ocean points:


    x . x 
    x . .
    . . .


In this example, three idle processors could be left out (two in the northern-most row, and one in the second row) since there are no wet ocean points on these "x" domains.  The ocean-ice model may thus be run with only 6 MPI tasks rather than nine.  To enable this feature of FMS, the following variables in the namelist `coupler_nml` must be specified.


    coupler_nml
    ...
    do_atmos = .false.
    ....
    n_mask = 3
    layout_mask = 3, 3
    mask_list = 1,2, 1,3, 3,3

If a mask list is specified, the domain layout of the ocean and the ice model is automatically the same, as specified with `layout_mask`. Running the model, only 6 MPI tasks need to be started.

For large and complex model topography, it is very tedious to specify the mask list by hand.  To simplify this task, the preprocessing tool `check_mask` can be used after the model grid and topography are specified, i.e., when `grid_spec.nc` is generated. To do so requires adding the following to `topog_nml` during the preprocessing stage


    topog_nml
    ...
    check_mask=.true.
      

The preprocessing code prints out a number of proposals for possible domain layouts, number of land-only subdomains, and templates for setting the `mask_list`. You may copy these layouts to `coupler_nml`, but note that you must replace spaces by a comma in `mask_list`.

You may configure `check_mask` from the namelist `check_mask_nml`. There are two variables `max_pe` and `halo` required to perform the mask checking. The default settings are

    max_pe = 128
    halo = 1

If you intend to employ more processors, then increase `max_pe`. If you want to use higher order advection schemes, then increase `halo` to `halo=2` or even `halo=3`. Otherwise, the halo information of masked domains may leak into ocean domains, in which case the model will fail, with errors reporting land values at ocean points.
      
In the postprocessing step, the single netCDF-output files from the MPI tasks can be combined into one file using the tool `mppnccombine`. The latest version adds "missing" values at the location of land-only domains. Hence, the only remaining trace of masking out land-only processors is in your account files, where some compute time is saved.

## Postprocessing regrid tool

### Introduction to postprocessing 

For many analysis applications, it is sufficient, and often preferable, to have output on the model's native grid (i.e., the grid used to run the simulation).  Accurate computation of budgets, for example, must be done on the model's native grid, preferably online during integration. MOM provides numerous online diagnostics for this purpose. 

Many applications, such as model comparison projects, require results on a common latitude-longitude spherical grid.  Such facilitates the development of difference maps.  For this purpose, we have developed a tool to regrid scalar and vector fields from a tripolar grid to a spherical grid.  In principle, this tool can be used to regrid any logically rectangular gridded field onto a spherical grid.  However, applications at GFDL have been limited to the tripolar to spherical regrid case. 

In general, regridding is a difficult task to perform accurately and without producing noise or spurious results.  The user should carefully examine regridding results for their physical integrity. Problems occur, in particular, with fields near MOM's partial bottom step topography in the presence of realistic topography and land/sea geometry.  Indeed, we were unable to find a simple algorithm to handle regridding in the vertical that did not produce egregious levels of noise. Hence, the regridding tool provided with MOM only handles horizontal regridding. The regridded data will thus be on the source vertical grid. 

Model comparisons should ideally be performed only after regridding output using the same regridding algorithm.  Unfortunately, such is not generally the case since there is no standard regridding algorithm used in the modeling community. 
         

### How to use the regridding tool 
       
The regridding algorithm provided with the MOM distribution is located in the directory `postprocessing/regrid`.
 
The algorithm accepts data from any logically rectangular grid (e.g., tripolar or latitude-longitude) and regrids to a spherical latitude-longitude grid. When the data is on the tracer cell (T-cell), the regridding interpolation is conservative. Thus, total heat, salt, and passive tracer remain the same on the two grids.  However, when data is located at another position:  
  
* corner or C-cell as for a B-grid horizontal velocity component
* east or E-cell as for an eastward tracer flux
* north or N-cell as for a northward tracer flux
		 
then regridding is accomplished non-conservatively using a nearest neighbor distance weighting algorithm.  It is for this reason that computationally accurate results are only available when working on the model's native grids. The regridding tool reads grids information from a netcdf file, specified by the namelist `grid_spec_file`. `grid_spec_file` contains source grid, destination grid and exchange grid information.
 
* source grid: `src_grid.nc`. This is the model's native grid. It results from running preprocessing grid generation code.
* destination grid: `dst_grid.nc`. This is the spherical latitude-lontitude grid.  This grid can also be obtained from running preprocessing grid generation code.  Be sure that the tripolar option is set to false to ensure that `dst_grid.nc` is spherical.
* exchange grid: `grid_spec.nc`.  This is the union of the source grid and destination grid.  The exchange grid is needed for conservative regridding.  The same conservative regridding algorithm is used for coupled models with FMS.  The tool to construct the exchange grid is know as `make_xgrids`. It is located in the `preprocessing/` directory. After `grid_spec.nc` is generated, it should be passed to the `regrid` tool through namelist `grid_spec_file` (No need to pass `src_grid.nc` and `dst_grid.nc` to the `regrid` tool).

To create the exchange grid, execute the command 

    make_xgrids -o src_grid.nc -a dst_grid.nc
 
The exchange grid creates a file `grid_spec.nc`.  It has new fields with names: 

    AREA_ATMxOCN, DI_ATMxOCN, DJ_ATMxOCN, I_ATM_ATMxOCN, J_ATM_ATMxOCN,
    I_OCN_ATMxOCN, J_OCN_ATMxOCN, AREA_ATMxLND, DI_ATMxLND, DJ_ATMxLND,
    I_ATM_ATMxLND, J_ATM_ATMxLND, I_LND_ATMxLND, J_LND_ATMxLND,
    AREA_LNDxOCN, DI_LNDxOCN, DJ_LNDxOCN, I_LND_LNDxOCN, J_LND_LNDxOCN,
    I_OCN_LNDxOCN, J_OCN_LNDxOCN, xba, yba, xta, yta, AREA_ATM, xbl, ybl,
    xtl, ytl, AREA_LND, AREA_LND_CELL, xto, yto, AREA_OCN  

It is critical that `src_grid.nc` DO NOT already have any of the above new exchange grid fields.  If they do, then these fields should be removed using netcdf tools such as `ncks`. After the `grid_spec.nc` file is generated, it is passed into the `regrid` program through the nml option `grid_spec_file`.
 
The `regrid` program reads model data from a netcdf file, which is specfied by the namelist variable `src_data`. Again, `src_data` fields are gridded according to `src_grid.nc`.  The number of fields to be regridded is specified by `num_flds`. The name of the fields (e.g., `temp`, `salt`) to be regridded is specified by the namelist variable `fld_name`.  Each field can be a scalar or vector.  If a vector, then specify by `vector_fld`. Vector fields should always be paired together (e.g., u,v components to the horizontal current).  The output file is a netcdf file specified by the namelist variable `dst_data`.
 
The complete namelist option description is available in `regrid.html` or the code itself. 

## Preparing the runscript

### The runscript
   
A runscript is provided in each test case directory (`exp/$test_case`) for each test case. Details can be found in [quickstart guide](http://www.mom-ocean.org/web/docs/project/quickstart).
       
Incorporated in the FMS infrastructure is MPP (Massively Parallel Processing), which provides a uniform message-passing API interface to the different message-passing libraries. If MPICH is installed, the user can compile the MOM source code with MPI. If the user does not have MPICH or the communications library, the MOM source code can be compiled without MPI by omitting the `CPPFLAGS` value `-Duse_libMPI` in the example runscript.

### The diagnostics table
   
The diagnostics table allows users to specify the sampling rates and choose the output fields prior to executing the MOM source code. It is included in the input directory for each test case (`exp/$test_case/input`). A portion of a sample MOM diagnostic table is displayed below. Reference `diag_manager.html` for detailed information on the use of `diag_manager`.
   
   
    "Diagnostics for MOM test case"
    1980 1 1 0 0 0
    #output files
    "ocean_month",1,"months",1,"hours","Time"
    "ocean_snap",1,"days",1,"hours","Time"
    #####diagnostic field entries####
    #===============================================================
    # ocean model grid quantities (static fields and so not time averaged))
    "ocean_model","geolon_t","geolon_t","ocean_month" "all",.false.,"none",2
    "ocean_model","geolat_t","geolat_t","ocean_month","all",.false.,"none",2
    #================================================================
    # prognostic fields 
    "ocean_model","temp","temp","ocean_month","all", "max", "none",2
    "ocean_model","age_global","age_global","ocean_month","all","min","none",2
    #================================================================
    # diagnosing tracer transport 
    "ocean_model","temp_xflux_sigma","temp_xflux_sigma","ocean_month","all",.true.,"none",2
    "ocean_model","temp_yflux_sigma","temp_yflux_sigma","ocean_month","all",.true.,"none",2
    #================================================================ 
    # surface forcing
    "ocean_model","sfc_hflux","sfc_hflux","ocean_month","all",.true.,"none",2
    "ocean_model","sfc_hflux_adj","sfc_hflux_adj","ocean_month","all",.true.,"none",2
    #================================================================
    # ice model fields 
    "ice_model", "FRAZIL",   "FRAZIL",     "ice_month", "all", .true., "none", 2,
    "ice_model", "HI",    "HI",   "ice_month", "all", .true., "none", 2
    #-----------------------------------------------------------------
   
   
The diagnostics manager module, `diag_manager_mod`, is a set of simple calls for parallel diagnostics on distributed systems. It provides a convenient set of interfaces for writing data to disk in NetCDF format. The diagnostics manager is packaged with the MOM source code. The FMS diagnostic manager can handle scalar fields as well as arrays. For more information on the diagnostics manager, reference `diag_manager.html`.
   

### The field table
 
The MOM field table is used to specify tracers and their advection schemes, cross-land tracer mixing, cross-land insertion, and other options. The field table is included in the runscript as a namelist and is written to an output file upon execution of the runscript. 
   
    "prog_tracers","ocean_mod","temp"
    
    horizontal-advection-scheme = quicker
    vertical-advection-scheme = quicker
    restart_file  = ocean_temp_salt.res.nc
    /
         
    "prog_tracers","ocean_mod","salt"
    
    horizontal-advection-scheme = mdfl_sweby
    vertical-advection-scheme = mdfl_sweby
    restart_file  = ocean_temp_salt.res.nc
    / 
        
    "tracer_packages","ocean_mod","ocean_age_tracer"
    
    names = global
    horizontal-advection-scheme = mdfl_sweby
    vertical-advection-scheme = mdfl_sweby
    restart_file  = ocean_age.res.nc
    min_tracer_limit=0.0
    /
        
    "namelists","ocean_mod","ocean_age_tracer/global"
    
    slat = -90.0
    nlat =  90.0
    wlon =   0.0
    elon = 360.0
    /
    
    "xland_mix","ocean_mod","xland_mix"
    "xland","Gibraltar","ixland_1=274,ixland_2=276,jxland_1=146,jxland_2=146,kxland_1=1,kxland_2=28,vxland=0.55e6"
    "xland","Gibraltar","ixland_1=274,ixland_2=276,jxland_1=147,jxland_2=147,kxland_1=1,kxland_2=28,vxland=0.55e6"
    "xland","Black-Med","ixland_1=305,ixland_2=309,jxland_1=151,jxland_2=152,kxland_1=1,kxland_2=6,vxland=0.01e6"
    "xland","Black-Med","ixland_1=306,ixland_2=309,jxland_1=151,jxland_2=153,kxland_1=1,kxland_2=6,vxland=0.01e6"/
    
    "xland_insert","ocean_mod","xland_insert"
    "xland","Gibraltar","ixland_1=274,ixland_2=276,jxland_1=146,jxland_2=146,kxland_1=1,kxland_2=18,tauxland=86400.0"
    "xland","Gibraltar","ixland_1=274,ixland_2=276,jxland_1=147,jxland_2=147,kxland_1=1,kxland_2=18,tauxland=86400.0"
    "xland","Black-Med","ixland_1=305,ixland_2=309,jxland_1=151,jxland_2=152,kxland_1=1,kxland_2=6,tauxland=86400.0"
    "xland","Black-Med","ixland_1=306,ixland_2=309,jxland_1=151,jxland_2=153,kxland_1=1,kxland_2=6,tauxland=86400.0"/
    
    "diff_cbt_enhance","ocean_mod","diff_cbt_enhance"
    "diffcbt","Gibraltar","itable=274,jtable=146,ktable_1=1,ktable_2=18,diff_cbt_table=0.01"
    "diffcbt","Gibraltar","itable=276,jtable=146,ktable_1=1,ktable_2=18,diff_cbt_table=0.01"
    "diffcbt","Gibraltar","itable=274,jtable=147,ktable_1=1,ktable_2=18,diff_cbt_table=0.01"
    "diffcbt","Gibraltar","itable=276,jtable=147,ktable_1=1,ktable_2=18,diff_cbt_table=0.01"
    "diffcbt","Black-Med","itable=305,jtable=151,ktable_1=1,ktable_2=6,diff_cbt_table=0.01"
    "diffcbt","Black-Med","itable=309,jtable=152,ktable_1=1,ktable_2=6,diff_cbt_table=0.01"
    "diffcbt","Black-Med","itable=306,jtable=151,ktable_1=1,ktable_2=6,diff_cbt_table=0.01"
    "diffcbt","Black-Med","itable=309,jtable=153,ktable_1=1,ktable_2=6,diff_cbt_table=0.01"/
   
In the first section of the field table, the user can specify tracers to be used in the simulation. Although there is no limit to the number of tracers specified, temperature (temp) and salinity (salt) must be included. The user may also define the horizontal and vertical tracer advection schemes. For more information on the field manager, reference `field_manager.html`.
      
In climate modeling, it is often necessary to allow water masses that are separated by land to exchange tracer and surface height properties. This situation arises in models when the grid mesh is too coarse to resolve narrow passageways that in reality provide crucial connections between water masses. The cross-land mixing and cross-land insertion establishes communication between bodies of water separated by land. The communication consists of mixing tracers and volume between non-adjacent water columns. Momentum is not mixed. The scheme conserves total tracer content, total volume, and maintains compatibility between the tracer and volume budgets. The grid points where this exchange takes place, and the rates of the exchange, are specified in the field table. 

For some cases, it is necessary to set a large vertical tracer diffusivity at a specified point in the model, say next to a river mouth to ensure fresh water is mixed vertically. These diffusivities are specified in the field table.
   
For a technical description of cross-land tracer mixing and insertion, please reference [A Technical Guide to MOM4](http://www.mom-ocean.org/web/docs/project/MOM4_guide.pdf).

### `mppnccombine`
   
Running MOM in a parallel processing environment will produce one output NetCDF diagnostic file per processor. `mppnccombine` joins together an arbitrary number of data files containing chunks of a decomposed domain into a unified NetCDF file. If the user is running the model on one processor, the domain is not decomposed and there is only one data file. `mppnccombine` will still copy the full contents of the data file, but this is inefficient and `mppnccombine` should not be used in this case. Executing `mppnccombine` is automated through the runscripts. The data files are NetCDF format for now, but IEEE binary may be supported in the future.
   
`mppnccombine` requires decomposed dimensions in each file to have a `domain_decomposition` attribute. This attribute contains four integer values:

* starting value of the entire non-decomposed dimension range (usually 1)
* ending value of the entire non-decomposed dimension range
* starting value of the current chunk's dimension range
* ending value of the current chunk's dimension range.

`mppnccombine` also requires that each file have a `NumFilesInSet` global attribute which contains a single integer value representing the total number of chunks (i.e., files) to combine. 

The syntax of `mppnccombine` is:
     
    mppnccombine [-v] [-a] [-r] output.nc [input ...] 
          
         -v  print some progress information
       
         -a  append to an existing NetCDF file
    
         -r  remove the '.####' decomposed files after a successful run
       
An output file must be specified and it is assumed to be the first filename argument. If the output file already exists, then it will not be modified unless the option is chosen to append to it. If no input files are specified, their names will be based on the name of the output file plus the extensions '.0000', '.0001', etc. If input files are specified, they are assumed to be absolute filenames. A value of 0 is returned if execution is completed successfully and a value of 1 indicates otherwise.
   
The source of `mppnccombine` is packaged with the MOM module in the postprocessing directory. `mppnccombine.c` should be compiled on the platform where the user intends to run the FMS MOM source code so the runscript can call it. A C compiler and NetCDF library are required for compiling `mppnccombine.c`:

    cc -O -o mppnccombine -I/usr/local/include -L/usr/local/lib mppnccombine.c -lnetcdf
     
## Examining the output

### Sample model output

Sample MOM model output data files are available in the `data/` directory. Output files are classified into three subdirectories:

* `ascii/`: the description of the setup of the run and verbose comments printed out during the run.
* `restart/`: the model fields necessary to initialize future runs of the model.
* `history/`: output of the model, both averaged over specified time intervals and snapshots.

Note that these output files are compressed using `tar`. All `.tar` files should be decompressed for viewing. The decompress command is:
     
    tar -xvf filename.tar
         
### Analysis tools
   
There are several graphical packages available to display the model output. These packages vary widely depending on factors, such as the number of dimensions, the amount and complexity of options available and the output data format. The data will first have to be put into a common format that all the packages can read. FMS requires the data to be stored in NetCDF format since it is so widely supported for scientific visualization. The graphical package is also dependent upon the computing environment. For ocean modeling, [ncview](http://meteora.ucsd.edu/~pierce/ncview_home_page.html), [Ferret](http://ferret.pmel.noaa.gov/Ferret/home) and [GrADS](http://www.iges.org/grads/) are most commonly used. 
